(************** Content-type: application/mathematica **************

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[  16132238,     255597]*)
(*NotebookOutlinePosition[  16133463,     255636]*)
(*  CellTagsIndexPosition[  16133384,     255630]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["\<\
J/Link Programming:
JavaSwing Example\
\>", "Title"],

Cell["Junzo SATO", "Subtitle"],

Cell[TextData[StyleBox["J/Link enables us to handle Java objects within \
MATHEMATICA. The MATHEMATICA package \"JavaSwing.m\" was designed as \
collection of wrapper functions for the Java Swing classes. All basic aspects \
of these functions are shown in this Notebook.", "Subtitle",
  FontSize->16]], "Text",
  FontSlant->"Italic"],

Cell["Copyright \[Copyright] 2000-2002, Junzo SATO. All rights reserved.", \
"Text",
  TextAlignment->Right],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Loading the JavaSwing ",
    FontColor->RGBColor[1, 0, 0]],
  StyleBox["MATHEMATICA",
    FontSlant->"Italic",
    FontColor->RGBColor[1, 0, 0]],
  StyleBox[" package",
    FontColor->RGBColor[1, 0, 0]]
}], "Section"],

Cell[BoxData[
    \(Off[General::spell, General::spell1]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Needs["\<JLinkProgramming`JavaSwing`JavaSwing`\>"]\)], "Input"],

Cell[BoxData[
    \("Loading JavaSwing..."\)], "Print"],

Cell[BoxData[
    \("Finished loading JavaSwing"\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> com.wolfram.jlink.MathJFrame <<< ",
  FontColor->RGBColor[1, 0, 0]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058T8P10000
000018S0^<SPf8S0^8S0^1H0080300600P02P00400:100>100>100>10`04
P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<1
2X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0@008000i^WlC=3YC=3Y@09<d>U1P00P0<0
0H0200:000@00X400h400h400h4300B10P05P@0400F200J200J200J20P07
PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f4
0`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8F
Q`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<3
7HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd3
1BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6
;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHc
TP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9
BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd2
2e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;
FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<
H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]
47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<A
QJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d
4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLD
VkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[
_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00
P007VjOaooooSWZfYY_4/jWBZ9g8/jWB00:VVl@01KbhgNk^m>[YlOoooc=3
Y@0500200`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X80
1X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@0
0`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<3
6hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=
12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5
:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9
AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YA
W@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]G
W`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW
3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mc
Z@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@
OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hA
Q:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H0
11BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ
_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P03
5k6n5k6o5k6o00<G/[l35k>o0QRd`20000026;C04000008H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P004VjOaooooK5ZU[jG:0[bhg@0:
oogo/jWBoooooooo_;SMUhZlZ9g8i^K/oooo<d>U1000P0<00H0200:000@0
0X400h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R2
0@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD3
0Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN8
0aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@O
R`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd5
9hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_
T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`Ld
TPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD3
23bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3
V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;
VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@03
2eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aK
X08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R
00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@3
3FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W
00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mg
ZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<A
P:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7
/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb
0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@3
4iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg
0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS
^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G
[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc
_`8H]<000lSPf4R@R4R@R00<B92800<00038h=Q8T8P03DR@R00400006;C0
6;C0b>3H3TR@R00300006;C06;C000:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000^KYo7ooonXWLSoooncZM9PC9Z>N[IhIJjXWLSooooooOl0
0oooo`03<d>U0020002000<0080300600P02P00400:100>100>100>10`04
P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<1
2X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50P8@Q@?oool20Q660`8B
QP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR8
00<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/3
12:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>
0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946
<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087
=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10Pn
UP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH
0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/3
2TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h0
0`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ
35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeR
XP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZ
Y@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0ma
Z0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/3
47Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^
4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK00
11:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8C
Sk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF
]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPE
W[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX3
5ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^
_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3H
R<2hR<2h00^8`;P00dR@R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P0
3HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^08008003Y^WlOooooooom_Lk61<VY>5^[>Yd[bhgF1<VYV?_ZJKa<S3gooo
oc=3Y@H00803oooo0P02P00300:1oooooooo00;oool200B100<01H7oool0
1H800`06PPCoool00`48PP48Poooo`03oooo0`4:P`06oooo0@^40@^40@b4
oooo0@b40P4=Q004oooo0@j5oooo0@j50P8?Q@04oooo0Q25oooo0Q250P8A
QP03oooo0Q660Q:600824XH20Q>600@24hL258L258L258L30QF70P8FQ`04
0aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX3
11j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=
00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I03
1Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86
=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`Lj
U0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88
@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX3
2DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M
0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl3
35ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<
H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eV
Y0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>
KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT3
3gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]
0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl4
4HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb
4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d
00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLD
VkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT3
5J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[
_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`03
5k:o0aNc_`8H]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P00038h=P0
0XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008003Y^WlOoookbh
gIV?__ooomKAgM_Lk??nojJKa>k^m8Ef/9>5^_oooc=3Y@@008001oooo`01
P001P001P?ooo`02P?ooo`0300>100Koool0184018401H7oool01H8200J2
00Soool01h801h811h;oool128;oool128<30@V300Coool12X<12X?oool2
0@^400<138Coool138@00P4=Q004oooo0@j5oooo0@j50P8?Q@03oooo0Q25
oooo00?oool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<4
7XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd0
0`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6
;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHd
TP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD
0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3
U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9
BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd3
2e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<
FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaP
XP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT
0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_
Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?
MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd2
4Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@A
QZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8B
SK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@0
0a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK
]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<E
X[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m
5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P00dR@R0000<SPf002
R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<001<SP
f8S0^8S0^8S0^0800004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3002000nKYo7ooonISkjGR[cDdnS_
[;?oMW_^Wj]KF:FVVlBFWm9PC9Zl^=gooolc@jD00`00P007oooo00600060
0060oooo00:0oooo00<00h401_ooo`04P@04POooo`05POooo`801X802?oo
o`07PP07PP47P_ooo`48P_ooo`48P`<12H<02Oooo`4:Poooo`4;Poooo`4;
Q?ooo`4<Q?ooo`020@f400Coool13XGoool13XD20Pn500Coool248Goool2
48D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP3
5hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;
0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DW
SPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@
00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB
1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8
?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H
2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J
0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;
E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P
0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ80
0`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=
J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L0
10m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ
0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60
[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`
0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK82
4Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<C
U;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L2
59fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j
0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/
_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o
0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8
`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^002R<2h
0P0000:8`;P200000hS0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008002Y^WlOoooiN:_7Y/Z[?7j:U^X<S3gi>5^U]6
TiV?_P9hIJh0148WQJnUb_oooc=3Y@@00803006000?oool00X000X401?oo
o`8018400oooo`05POooo`0300J21?ooo`030@R20@R30@R300<12H<02Ooo
o`4:Poooo`4;Poooo`4;Q?ooo`4<Q?ooo`020@f400Coool13XGoool13XD2
0Pn500?oool248Goool00oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<K
R@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d4
9Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[
S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO
00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y
00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n
[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64
[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P04
59Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl
00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G
/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000
b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd
`003b>3HR<2hR<2h00>8`;P4000018S0^004B92800006;C06;C00XS0^058
T8P10000000018S0^<SPf8S0^8S0^08008000i^WlOooooooo`02oooo00[o
[K3oMW_icMCmkNkooonVVlB5M[2l^=gooolc@jD500200`01P003oooo00:0
00:100<00h400oooo`04POooo`0200F100@01H;oool01X801X8200N200<1
1h;oool128800P48P`?oool20@Z300Ooool12h?oool12hCoool138Coool0
0P4=Q004oooo0@j5oooooooo0P8?Q@06oooo0Q25oooo0Q250Q66oooo0P8A
QP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN8
0`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3
126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh0
0`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA
1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLe
TP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`Pm
U@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4
V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/3
2TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN
2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:00
10aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=
HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iY
Y@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?
LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X3
47V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61
[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;02
4XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P03
4hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E
]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`04
5Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X3
5ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm
00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<00
0lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8
`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P018S0^0800005
R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0`00P00:XJcbnLgDhRHlm;FohRHlm6emo>?YoooooNg^ojf`0_ooo`03<d>U
0020002000@00803006000?oool00X000X400oooo`8018401Oooo`05P@05
P@05P_ooo`0200J20oooo`8128800`48Poooo`49P`020@V30P4:P`04oooo
0@^30@^4oooo0P4<Q007oooo0@f40@f4oooo0@j5oooo0@j500;oool00`8?
Q@8@Q@8@Q@04oooo00@24HH24XH24XH24XH20Q>600@24hL258L258L258L3
0QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^9
0`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@U
S@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?
10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHc
TPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0Lh
U0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G
246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI
0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:
DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil0
0`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<
Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=
IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^
Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT0
10mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/
47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_
4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:<
/@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`03
4i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@D
V[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i
5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`0
11J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa
_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038
h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C0
00?8h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P00=VjOaoNg^hRHlo_GhmhVGm69^
lj2^m69^oogoojf`o>?Yoooo<d>U00L00803006000?oool00X000X400`03
P@<0184200F100@01H801X801X801X8200N200D11h81288128;oool128<0
0`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH3
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8
h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h
00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8`;P200000XS0
^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0P00P003VjOam/S<hRHl00;o[K001mlT;_nTW_JlaOn]/>ikS?oo
oc=3Y@0800200`01P003oooo00:000:100<00h4300B10P05P@0400F200J2
00J200J20P07PP050@N20@R20@R2oooo0@R300<12H<01?ooo`4:P`4:P`4;
P`812h@30@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@04
0aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`4
98d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5
:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A
00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7
>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9
AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN
2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ
0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X
3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@
OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh0
0a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@
/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf
0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<F
ZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003
B9280000b>3H00:8`;P900000XS0^005B92800006;C06;C0b>3H00>8`;P2
000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0P00P003VjOanLgDmhVG00;oool01on]/>4F=?mfNonT
W^8V??n9Oc=3Y@0800200`01P003oooo00:000:100<00h4300B10P05P@04
00F200J200J200J20P07PP040@N20@R20@R20@R31?ooo`<12X<00`4;P`4;
Q04;Q0030@b40P4=Q004oooo0@j50@j50@j50`8?Q@<248D40Q660`8BQP82
4hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<3
6HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<
10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DY
SP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946
<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<3
1cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8
?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5
V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK
0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]E
WP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ
35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP02
3F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>
JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0ma
Z0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[
0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^
00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9
/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8C
Sk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<D
UkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PE
W[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk
0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^
_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2h
R<2h00^8`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd
`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0P00P007VjOaoooolj2^m69^oooomhVGnLgD00;oool00o>P[_oo
oc=3Y@0800200`01P0800X001002P@03P@03P@03P@<0184200F100@01H80
1X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@1
2h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8D
Q`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<J
R@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=
12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?
00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@04
1S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC
1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8
@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI
00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YA
W0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]G
W`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<
Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<0
0`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP04
3VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mc
Z@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/
00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<A
Q:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<B
Rk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<3
4i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8D
V[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<E
X;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl
11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`
_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@
R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008002i^WlOoooon9
Oooooo>P[_6CXOooooomoo>P[_oko3=3Y@0800200`01P0800X001002P@03
P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h8128812880
0P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D4
0Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP3
5hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@P
R`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDW
SP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6
;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB
1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D3
23fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH
2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<
V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;
E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaL
X00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQ
XPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D3
3VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`
Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1h
ZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@03
4H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8
/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb
00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@3
4iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg
00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT
^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G
[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd
`0o8h=P00`000<SPf<SPf00=b>3H00<0000H]<0H]<003lSPf00300006;C0
6;C000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P400200i^Wl@06oooo
lj2^m;Fom[c5nmWJ<d>U2@00P0<00H0200:000@00X400h400h400h4300B1
0P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V30`4:
P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>6
00@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV8
0aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@4
8h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh0
0`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A
0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`Lf
T`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF
0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP0
0`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:
Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh3
2eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aM
X@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeR
X`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V
0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP3
3g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@
Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P03
4H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4B
R[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb
008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne
11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh
5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<F
Yk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG
[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h5P00P0<00H0200:000@00X400h400h400h43
00B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V3
0`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR003
0aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A
1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC
0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH3
23nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9
AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>
V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aM
X@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ80
0PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD4
3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?
LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1j
Z`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61
[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@B
RK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb
4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D3
59Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh
5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@
R04000000003R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058T8P1000000000hS0
^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8h=S8h=P0olSP
f?o8h=Qmb>3H0DR@R04000000?n8`;SoR<2hPHS0^04000000001\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l00000o`00003o00?ok^k^
ooooooo^k^h00oo^k^h00oooooook^k^onk^kP0Eonk^kP03ooooooo^k^kok^k^00Wok^k^00Cooooo
onk^k_o^k^kooooo1oo^k^h01Oooooook^k^onk^k_o^k^kooooo00Gok^k^00?oooooonk^k_o^k^h0
0oo^k^h00oooooook^k^onk^kP03onk^kP03ooooooo^k^kok^k^00Gok^k^00Goooooonk^k_o^k^ko
k^k^ooooo`04onk^kP03ooooooo^k^kok^k^00Cok^k^00?oooooonk^k_o^k^h04?o^k^h01Ooooooo
k^k^onk^k_o^k^kooooo00?ok^k^00?oooooonk^k_o^k^h00_o^k^h00oooooook^k^onk^kP03onk^
kP03ooooooo^k^kok^k^00;ok^k^00?oooooonk^k_o^k^h01oo^k^h00oooooook^k^onk^kP04onk^
kP05ooooooo^k^kok^k^onk^k_ooool02_o^k^h00oooooook^k^onk^kP08onk^kP03ooooooo^k^ko
k^k^00;ok^k^00?oooooonk^k_o^k^h03?o^k^h01Oooooook^k^onk^k_o^k^kooooo00Ook^k^00?o
ooooonk^k_o^k^h00oo^k^h00oooooook^k^onk^kP07onk^kP05ooooooo^k^kok^k^onk^k_ooool0
3oo^k^h01?ooooook^k^onk^k_oooolConk^kP05ooooooo^k^kok^k^onk^k_ooool02_o^k^h00ooo
ooook^k^onk^kP03onk^kP04ooooooo^k^kok^k^ooooo`ook^k^00Coooooonk^k_o^k^kooooo0oo^
k^h00oooooook^k^onk^kP06onk^kP03ooooooo^k^kok^k^00Kok^k^00?oooooonk^k_o^k^h01Oo^
k^h00oooooook^k^onk^kP0Ionk^kP03ooooooo^k^kok^k^00;ok^k^00?oooooonk^k_o^k^h00oo^
k^h01?ooooook^k^onk^k_ooool>onk^kP03ooooooo^k^kok^k^00Wok^k^00Goooooonk^k_o^k^ko
k^k^ooooo`0:onk^kP04ooooooo^k^kok^k^ooooo`Cok^k^00?oooooonk^k_o^k^h01_o^k^h00ooo
ooook^k^onk^kP06onk^kP03ooooooo^k^kok^k^00?ok^k^00?oooooonk^k_o^k^h01oo^k^h01Ooo
ooook^k^onk^k_o^k^kooooo00Ook^k^00?oooooonk^k_o^k^h07_o^k^h01Oooooook^k^onk^k_o^
k^kooooo01?ok^k^00?oooooonk^k_o^k^h02?o^k^h01?ooooook^k^onk^k_ooool4onk^kP03oooo
ooo^k^kok^k^00Wok^k^00?oooooonk^k_o^k^h01_o^k^h00oooooook^k^onk^kP05onk^kP03oooo
ooo^k^kok^k^00cok^k^00Goooooonk^k_o^k^kok^k^ooooo`06onk^kP03ooooooo^k^kok^k^00Co
k^k^00?ogMgMooooooooool03?ooool000Sok^k^00Coooooonk^k_o^k^kooooo0oo^k^h00ooooooo
k^k^onk^kP05onk^kP05ooooooo^k^kok^k^onk^k_ooool01?o^k^h01Oooooook^k^onk^k_o^k^ko
oooo00[ok^k^00?oooooonk^k_o^k^h02Oo^k^h00oooooook^k^onk^kP04onk^kP03ooooooo^k^ko
k^k^00;ok^k^00?oooooonk^k_o^k^h01Oo^k^h00oooooook^k^onk^kP0Eonk^kP03ooooooo^k^ko
k^k^00?ok^k^00?oooooonk^k_o^k^h05_o^k^h00oooooook^k^onk^kP0Lonk^kP03ooooooo^k^ko
k^k^00;ok^k^00?oooooonk^k_o^k^h01Oo^k^h01Oooooook^k^onk^k_o^k^kooooo00_ok^k^00Co
ooooonk^k_o^k^kooooo3Oo^k^h01?ooooook^k^onk^k_ooool;onk^kP03ooooooo^k^kok^k^013o
k^k^00?oooooonk^k_o^k^h00_o^k^h00oooooook^k^onk^kP09onk^kP05ooooooo^k^kok^k^onk^
k_ooool01?o^k^h00oooooook^k^onk^kP08onk^kP04ooooooo^k^kok^k^oooooa7ok^k^00Gooooo
onk^k_o^k^kok^k^ooooo`03onk^kP03ooooooo^k^kok^k^00Ook^k^00?oooooonk^k_o^k^h00_o^
k^h00oooooook^k^onk^kP07onk^kP03ooooooo^k^kok^k^00Cok^k^00?oooooonk^k_o^k^h02?o^
k^h01Oooooook^k^onk^k_o^k^kooooo00?ok^k^00Goooooonk^k_o^k^kok^k^ooooo`03onk^kP03
ooooooo^k^kok^k^00cok^k^00?oooooonk^k_o^k^h01oo^k^h01Oooooook^k^onk^k_o^k^kooooo
00cok^k^00?oooooonk^k_o^k^h03Oo^k^h00oooooook^k^onk^kP08onk^kP05ooooooo^k^kok^k^
onk^k_ooool01?o^k^h00oooooook^k^onk^kP03onk^kP03ooooooo^k^kok^k^00_ok^k^00?ooooo
onk^k_o^k^h03Oo^k^h00oooooook^k^onk^kP03onk^kP05ooooooo^k^kok^k^onk^k_ooool01?o^
k^h01Oooooook^k^onk^k_o^k^kooooo00?ok^k^00Coooooonk^k_o^k^kooooo3oo^k^h01Ooooooo
k^k^onk^k_o^k^kooooo00Kok^k^00Coooooonk^k_o^k^kooooo1_o^k^h00oooooook^k^onk^kP02
onk^kP03ooooooo^k^kok^k^013ok^k^00?oooooonk^k_o^k^h01?o^k^h00oooooook^k^onk^kP06
onk^kP03ooooooo^k^kok^k^00Kok^k^00Coooooonk^k_o^k^kooooo3_o^k^h00oooooook^k^onk^
kP03onk^kP03ooooooo^k^kok^k^00;ok^k^00CogMgMooooooooooook^k^0oooool01OoMgMgooooo
oooooooooooogMgM00?ooooo0004onk^kP03ooooooo^k^kok^k^00kok^k^00?oooooonk^k_o^k^h0
3_o^k^h00oooooook^k^onk^kP08onk^kP03ooooooo^k^kok^k^00?ok^k^00?oooooonk^k_o^k^h0
0oo^k^h00oooooook^k^onk^kP0=onk^kP03ooooooo^k^kok^k^00;ok^k^00Goooooonk^k_o^k^ko
k^k^ooooo`03onk^kP05ooooooo^k^kok^k^onk^k_ooool00_o^k^h01Oooooook^k^onk^k_o^k^ko
oooo00Cok^k^00?oooooonk^k_o^k^h01_o^k^h00oooooook^k^onk^kP06onk^kP03ooooooo^k^ko
k^k^00;ok^k^00?oooooonk^k_o^k^h02?o^k^h00oooooook^k^onk^kP02onk^kP03ooooooo^k^ko
k^k^00;ok^k^00Goooooonk^k_o^k^kok^k^ooooo`02onk^kP03ooooooo^k^kok^k^00;ok^k^00?o
ooooonk^k_o^k^h02oo^k^h00oooooook^k^onk^kP08onk^kP03ooooooo^k^kok^k^00;ok^k^00?o
ooooonk^k_o^k^h01_o^k^h00oooooook^k^onk^kP03onk^kP03ooooooo^k^kok^k^00Wok^k^00?o
ooooonk^k_o^k^h02?o^k^h00oooooook^k^onk^kP02onk^kP03ooooooo^k^kok^k^00;ok^k^00Co
ooooonk^k_o^k^kooooo3_o^k^h00oooooook^k^onk^kP08onk^kP03ooooooo^k^kok^k^00;ok^k^
00Goooooonk^k_o^k^kok^k^ooooo`0:onk^kP05ooooooo^k^kok^k^onk^k_ooool00_o^k^h00ooo
ooook^k^onk^kP0?onk^kP03ooooooo^k^kok^k^00cok^k^00?oooooonk^k_o^k^h00_o^k^h00ooo
ooook^k^onk^kP0:onk^kP05ooooooo^k^kok^k^onk^k_ooool05oo^k^h01Oooooook^k^onk^k_o^
k^kooooo00gok^k^00?oooooonk^k_o^k^h01_o^k^h00oooooook^k^onk^kP03onk^kP03ooooooo^
k^kok^k^00Cok^k^00?oooooonk^k_o^k^h00_o^k^h01Oooooook^k^onk^k_o^k^kooooo00[ok^k^
00?oooooonk^k_o^k^h03_o^k^h00oooooook^k^onk^kP07onk^kP03ooooooo^k^kok^k^00Sok^k^
00?oooooonk^k_o^k^h01Oo^k^h00oooooook^k^onk^kP0<onk^kP03ooooooo^k^kok^k^017ok^k^
00Coooooonk^k_o^k^kooooo0oo^k^h00oooooook^k^onk^kP07onk^kP03ooooooo^k^kok^k^01So
k^k^00?oooooonk^k_o^k^h00_o^k^h01?ooooook^k^onk^k_ooool4onk^kP03ooooooo^k^kok^k^
00Gok^k^00?oooooonk^k_o^k^h01oo^k^h01?ooooook^k^onk^k_ooool8onk^kP03ooooooo^k^ko
k^k^00Cok^k^00?oooooonk^k_o^k^h02oo^k^h03_ooooooc<c<oooooooMgMgoR8R8omgMgOoooooo
gMgMohR8R?o^k^koooooomgMgOn8R8Sok^k^0_ooool00003onk^k_ooooook^k^00?ok^k^00?ooooo
onk^k_o^k^h01?o^k^h00oooooook^k^onk^kP02onk^kP03ooooooo^k^kok^k^00?ok^k^00?ooooo
onk^k_o^k^h00_o^k^h00oooooook^k^onk^kP08onk^kP04ooooooo^k^kok^k^ooooo`Sok^k^00?o
ooooonk^k_o^k^h02Oo^k^h00oooooook^k^onk^kP02onk^kP05ooooooo^k^kok^k^onk^k_ooool0
9Oo^k^h00oooooook^k^onk^kP05onk^kP03ooooooo^k^kok^k^00Gok^k^00?oooooonk^k_o^k^h0
0_o^k^h00oooooook^k^onk^kP08onk^kP03ooooooo^k^kok^k^00;ok^k^00?oooooonk^k_o^k^h0
4?o^k^h00oooooook^k^onk^kP02onk^kP03ooooooo^k^kok^k^00Cok^k^00?oooooonk^k_o^k^h0
4Oo^k^h01Oooooook^k^onk^k_o^k^kooooo00Gok^k^00?oooooonk^k_o^k^h02oo^k^h00ooooooo
k^k^onk^kP0<onk^kP03ooooooo^k^kok^k^00Kok^k^00Goooooonk^k_o^k^kok^k^ooooo`03onk^
kP03ooooooo^k^kok^k^00;ok^k^00Goooooonk^k_o^k^kok^k^ooooo`0?onk^kP03ooooooo^k^ko
k^k^017ok^k^00?oooooonk^k_o^k^h01Oo^k^h00oooooook^k^onk^kP06onk^kP03ooooooo^k^ko
k^k^00Cok^k^00?oooooonk^k_o^k^h01?o^k^h00oooooook^k^onk^kP06onk^kP03ooooooo^k^ko
k^k^00cok^k^00Goooooonk^k_o^k^kok^k^ooooo`03onk^kP05ooooooo^k^kok^k^onk^k_ooool0
1?o^k^h00oooooook^k^onk^kP08onk^kP05ooooooo^k^kok^k^onk^k_ooool00_o^k^h00ooooooo
k^k^onk^kP04onk^kP03ooooooo^k^kok^k^00Gok^k^00?oooooonk^k_o^k^h00_o^k^h00ooooooo
k^k^onk^kP0=onk^kP03ooooooo^k^kok^k^00;ok^k^00?oooooonk^k_o^k^h00oo^k^h00ooooooo
k^k^onk^kP04onk^kP03ooooooo^k^kok^k^00[ok^k^00?oooooonk^k_o^k^h01_o^k^h01Ooooooo
k^k^onk^k_o^k^kooooo00Gok^k^00?oooooonk^k_o^k^h01_o^k^h01?ooooook^k^onk^k_ooool;
onk^kP03ooooooo^k^kok^k^00;ok^k^00?oooooonk^k_o^k^h01?o^k^h00oooooook^k^onk^kP0<
onk^kP03ooooooo^k^kok^k^00Gok^k^00?oooooonk^k_o^k^h00oo^k^h01Oooooook^k^onk^k_o^
k^kooooo00?ok^k^00Goooooonk^k_o^k^kok^k^ooooo`03onk^kP03ooooooo^k^kok^k^013ok^k^
00?oooooonk^k_o^k^h01_o^k^h00oooooook^k^onk^kP0=onk^kP05ooooooo^k^kok^k^onk^k_oo
ool01_o^k^h01?ooooook^k^onk^k_ooool9onk^kP0>omgMgOooooooooooomgMgOn8R8SogMgMoooo
oooMgMgoR8R8onk^k_oooooogMgMohR8R?oMgMd1ooooo`002_o^k^h00oooooook^k^onk^kP03onk^
kP03ooooooo^k^kok^k^013ok^k^00?oooooonk^k_o^k^h02?o^k^h00oooooook^k^onk^kP09onk^
kP03ooooooo^k^kok^k^01;ok^k^00?oooooonk^k_o^k^h00oo^k^h01Oooooook^k^onk^k_o^k^ko
oooo00?ok^k^00?oooooonk^k_o^k^h01?o^k^h01Oooooook^k^onk^k_o^k^kooooo00?ok^k^00?o
ooooonk^k_o^k^h00_o^k^h01Oooooook^k^onk^k_o^k^kooooo00Cok^k^00?oooooonk^k_o^k^h0
2oo^k^h01?ooooook^k^onk^k_ooool=onk^kP03ooooooo^k^kok^k^00Cok^k^00Goooooonk^k_o^
k^kok^k^ooooo`04onk^kP03ooooooo^k^kok^k^00[ok^k^00Goooooonk^k_o^k^kok^k^ooooo`03
onk^kP03ooooooo^k^kok^k^00;ok^k^00?oooooonk^k_o^k^h03oo^k^h01Oooooook^k^onk^k_o^
k^kooooo00?ok^k^00Goooooonk^k_o^k^kok^k^ooooo`03onk^kP05ooooooo^k^kok^k^onk^k_oo
ool02oo^k^h00oooooook^k^onk^kP0Fonk^kP03ooooooo^k^kok^k^00?ok^k^00?oooooonk^k_o^
k^h01oo^k^h00oooooook^k^onk^kP02onk^kP03ooooooo^k^kok^k^00Cok^k^00Goooooonk^k_o^
k^kok^k^ooooo`03onk^kP03ooooooo^k^kok^k^00Cok^k^00?oooooonk^k_o^k^h01?o^k^h00ooo
ooook^k^onk^kP0>onk^kP03ooooooo^k^kok^k^00;ok^k^00Coooooonk^k_o^k^kooooo0oo^k^h0
1Oooooook^k^onk^k_o^k^kooooo01Ook^k^00Goooooonk^k_o^k^kok^k^ooooo`0=onk^kP03oooo
ooo^k^kok^k^01;ok^k^00Coooooonk^k_o^k^kooooo0oo^k^h00oooooook^k^onk^kP0?onk^kP03
ooooooo^k^kok^k^00?ok^k^00?oooooonk^k_o^k^h01?o^k^h00oooooook^k^onk^kP03onk^kP05
ooooooo^k^kok^k^onk^k_ooool03_o^k^h01Oooooook^k^onk^k_o^k^kooooo00Wok^k^00Gooooo
onk^k_o^k^kok^k^ooooo`04onk^kP03ooooooo^k^kok^k^00Cok^k^00?oooooonk^k_o^k^h00_o^
k^h00oooooook^k^onk^kP05onk^kP04ooooooo^k^kok^k^ooooo`Kok^k^00?oooooonk^k_o^k^h0
0oo^k^h00oooooook^k^onk^kP0Fonk^kP05ooooooo^k^kok^k^onk^k_ooool00_o^k^h00ooooooo
k^k^onk^kP0:onk^kP03ooooooo^k^kok^k^00;ok^k^00?oooooonk^k_o^k^h01_o^k^h00ooooooo
k^k^onk^kP09onk^kP03ooooooo^k^kok^k^00Ook^k^00Coooooonk^k_o^k^kooooo0_o^k^h03OoM
gMgooooooooooooooooogMgMohR8R?o^k^koooooomgMgOn8R8SogMgMoooooooMgMd00_ooool00005
ooooooo^k^kok^k^onk^k_ooool04Oo^k^h01Oooooook^k^onk^k_o^k^kooooo00?ok^k^00?ooooo
onk^k_o^k^h01Oo^k^h00oooooook^k^onk^kP09onk^kP03ooooooo^k^kok^k^00?ok^k^00?ooooo
onk^k_o^k^h00oo^k^h01Oooooook^k^onk^k_o^k^kooooo00Sok^k^00?oooooonk^k_o^k^h00oo^
k^h00oooooook^k^onk^kP0<onk^kP03ooooooo^k^kok^k^01[ok^k^00?oooooonk^k_o^k^h00_o^
k^h00oooooook^k^onk^kP08onk^kP03ooooooo^k^kok^k^00;ok^k^00?oooooonk^k_o^k^h01oo^
k^h00oooooook^k^onk^kP0>onk^kP05ooooooo^k^kok^k^onk^k_ooool03oo^k^h01Oooooook^k^
onk^k_o^k^kooooo00Ook^k^00?oooooonk^k_o^k^h07?o^k^h00oooooook^k^onk^kP03onk^kP03
ooooooo^k^kok^k^00?ok^k^00Goooooonk^k_o^k^kok^k^ooooo`04onk^kP05ooooooo^k^kok^k^
onk^k_ooool01?o^k^h00oooooook^k^onk^kP03onk^kP03ooooooo^k^kok^k^00?ok^k^00Gooooo
onk^k_o^k^kok^k^ooooo`0;onk^kP03ooooooo^k^kok^k^00Ook^k^00?oooooonk^k_o^k^h00oo^
k^h00oooooook^k^onk^kP02onk^kP03ooooooo^k^kok^k^00Cok^k^00Goooooonk^k_o^k^kok^k^
ooooo`02onk^kP03ooooooo^k^kok^k^00?ok^k^00?oooooonk^k_o^k^h04_o^k^h00oooooook^k^
onk^kP02onk^kP05ooooooo^k^kok^k^onk^k_ooool00oo^k^h00oooooook^k^onk^kP0<onk^kP03
ooooooo^k^kok^k^00cok^k^00Goooooonk^k_o^k^kok^k^ooooo`03onk^kP05ooooooo^k^kok^k^
onk^k_ooool04?o^k^h00oooooook^k^onk^kP04onk^kP03ooooooo^k^kok^k^00cok^k^00?ooooo
onk^k_o^k^h03_o^k^h01Oooooook^k^onk^k_o^k^kooooo00;ok^k^00?oooooonk^k_o^k^h03?o^
k^h00oooooook^k^onk^kP0Ionk^kP03ooooooo^k^kok^k^01Kok^k^00Goooooonk^k_o^k^kok^k^
ooooo`03onk^kP05ooooooo^k^kok^k^onk^k_ooool01_o^k^h00oooooook^k^onk^kP0:onk^kP05
ooooooo^k^kok^k^onk^k_ooool03?o^k^h01Oooooook^k^onk^k_o^k^kooooo00?ok^k^00?ooooo
onk^k_o^k^h03oo^k^h00oooooook^k^onk^kP05onk^kP03omgMgOoooooooooo00;ooooo00OogMgM
ohR8R?oMgMgoooooomgMgOn8R8Sok^k^00?ooooo0008onk^kP05ooooooo^k^kok^k^onk^k_ooool0
1oo^k^h00oooooook^k^onk^kP0:onk^kP03ooooooo^k^kok^k^00Wok^k^00Coooooonk^k_o^k^ko
oooo1?o^k^h00oooooook^k^onk^kP04onk^kP03ooooooo^k^kok^k^00Gok^k^00Goooooonk^k_o^
k^kok^k^ooooo`0>onk^kP05ooooooo^k^kok^k^onk^k_ooool02_o^k^h01Oooooook^k^onk^k_o^
k^kooooo00?ok^k^00?oooooonk^k_o^k^h00oo^k^h01Oooooook^k^onk^k_o^k^kooooo00kok^k^
00?oooooonk^k_o^k^h03Oo^k^h00oooooook^k^onk^kP05onk^kP04ooooooo^k^kok^k^ooooo`?o
k^k^00?oooooonk^k_o^k^h00_o^k^h00oooooook^k^onk^kP0:onk^kP03ooooooo^k^kok^k^00;o
k^k^00?oooooonk^k_o^k^h02_o^k^h00oooooook^k^onk^kP03onk^kP05ooooooo^k^kok^k^onk^
k_ooool00oo^k^h01Oooooook^k^onk^k_o^k^kooooo00Kok^k^00?oooooonk^k_o^k^h00_o^k^h0
0oooooook^k^onk^kP04onk^kP03ooooooo^k^kok^k^02_ok^k^00Goooooonk^k_o^k^kok^k^oooo
o`0Monk^kP03ooooooo^k^kok^k^017ok^k^00?oooooonk^k_o^k^h01Oo^k^h00oooooook^k^onk^
kP02onk^kP03ooooooo^k^kok^k^013ok^k^00Goooooonk^k_o^k^kok^k^ooooo`03onk^kP03oooo
ooo^k^kok^k^00Sok^k^00?oooooonk^k_o^k^h01?o^k^h00oooooook^k^onk^kP0Eonk^kP05oooo
ooo^k^kok^k^onk^k_ooool01?o^k^h01?ooooook^k^onk^k_ooool5onk^kP05ooooooo^k^kok^k^
onk^k_ooool00_o^k^h00oooooook^k^onk^kP07onk^kP04ooooooo^k^kok^k^ooooo`?ok^k^00?o
ooooonk^k_o^k^h03?o^k^h00oooooook^k^onk^kP05onk^kP03ooooooo^k^kok^k^00?ok^k^00?o
ooooonk^k_o^k^h01?o^k^h00oooooook^k^onk^kP02onk^kP04ooooooo^k^kok^k^ooooo`?ok^k^
00?oooooonk^k_o^k^h01_o^k^h00oooooook^k^onk^kP04onk^kP04ooooooo^k^kok^k^ooooo`?o
k^k^00?oooooonk^k_o^k^h00oo^k^h00oooooook^k^onk^kP0?onk^kP03ooooooo^k^kok^k^00_o
k^k^00?oooooonk^k_o^k^h01oo^k^h01Oooooook^k^onk^k_o^k^kooooo017ok^k^00Coooooonk^
k_o^k^kooooo1?o^k^h00oooooook^k^onk^kP0:onk^kP03omgMgOoooooooooo00?ooooo00OogMgM
ohR8R?o^k^koooooomgMgOn8R8Sok^k^00;ooooo0002onk^kP03ooooooo^k^kok^k^00Wok^k^00Co
ooooonk^k_o^k^kooooo1Oo^k^h01Oooooook^k^onk^k_o^k^kooooo00Sok^k^00Goooooonk^k_o^
k^kok^k^ooooo`0Fonk^kP03ooooooo^k^kok^k^00[ok^k^00?oooooonk^k_o^k^h01Oo^k^h00ooo
ooook^k^onk^kP07onk^kP05ooooooo^k^kok^k^onk^k_ooool03_o^k^h00oooooook^k^onk^kP07
onk^kP05ooooooo^k^kok^k^onk^k_ooool01?o^k^h00oooooook^k^onk^kP03onk^kP03ooooooo^
k^kok^k^00;ok^k^00?oooooonk^k_o^k^h00_o^k^h00oooooook^k^onk^kP03onk^kP03ooooooo^
k^kok^k^017ok^k^00Goooooonk^k_o^k^kok^k^ooooo`0<onk^kP03ooooooo^k^kok^k^00Gok^k^
00?oooooonk^k_o^k^h05Oo^k^h00oooooook^k^onk^kP08onk^kP03ooooooo^k^kok^k^00Wok^k^
00Coooooonk^k_o^k^kooooo1?o^k^h01Oooooook^k^onk^k_o^k^kooooo00Gok^k^00?oooooonk^
k_o^k^h00oo^k^h00oooooook^k^onk^kP03onk^kP03ooooooo^k^kok^k^00gok^k^00Goooooonk^
k_o^k^kok^k^ooooo`02onk^kP03ooooooo^k^kok^k^00Gok^k^00?oooooonk^k_o^k^h00oo^k^h0
0oooooook^k^onk^kP07onk^kP03ooooooo^k^kok^k^00Kok^k^00?oooooonk^k_o^k^h02?o^k^h0
0oooooook^k^onk^kP08onk^kP05ooooooo^k^kok^k^onk^k_ooool01?o^k^h00oooooook^k^onk^
kP0@onk^kP05ooooooo^k^kok^k^onk^k_ooool01Oo^k^h00oooooook^k^onk^kP05onk^kP05oooo
ooo^k^kok^k^onk^k_ooool00oo^k^h00oooooook^k^onk^kP03onk^kP04ooooooo^k^kok^k^oooo
oakok^k^00Goooooonk^k_o^k^kok^k^ooooo`0<onk^kP04ooooooo^k^kok^k^ooooo`gok^k^00?o
ooooonk^k_o^k^h02_o^k^h00oooooook^k^onk^kP0@onk^kP03ooooooo^k^kok^k^00Kok^k^00?o
ooooonk^k_o^k^h02oo^k^h00oooooook^k^onk^kP03onk^kP05ooooooo^k^kok^k^onk^k_ooool0
0oo^k^h00oooooook^k^onk^kP0:onk^kP03ooooooo^k^kok^k^00;ok^k^00?oooooonk^k_o^k^h0
0oo^k^h00oooooook^k^onk^kP0;onk^kP05ooooooo^k^kok^k^onk^k_ooool01oo^k^h00ooooooo
k^k^onk^kP06onk^kP05ooooooo^k^kok^k^onk^k_ooool01oo^k^h01?ooooook^k^onk^k_oMgMd6
ooooo`07omgMgOn8R8SogMgMoooooooMgMgoR8R8onk^kP01ooooo`002_o^k^h00oooooook^k^onk^
kP0Conk^kP03ooooooo^k^kok^k^00Ook^k^00?oooooonk^k_o^k^h01_o^k^h00oooooook^k^onk^
kP02onk^kP03ooooooo^k^kok^k^00_ok^k^00Goooooonk^k_o^k^kok^k^ooooo`05onk^kP03oooo
ooo^k^kok^k^00Ook^k^00?oooooonk^k_o^k^h02oo^k^h00oooooook^k^onk^kP02onk^kP03oooo
ooo^k^kok^k^00Ook^k^00?oooooonk^k_o^k^h01oo^k^h00oooooook^k^onk^kP08onk^kP03oooo
ooo^k^kok^k^00;ok^k^00?oooooonk^k_o^k^h04?o^k^h00oooooook^k^onk^kP02onk^kP03oooo
ooo^k^kok^k^00[ok^k^00?oooooonk^k_o^k^h00_o^k^h00oooooook^k^onk^kP06onk^kP03oooo
ooo^k^kok^k^00Gok^k^00Coooooonk^k_o^k^kooooo0oo^k^h01?ooooook^k^onk^k_ooool4onk^
kP03ooooooo^k^kok^k^00Sok^k^00?oooooonk^k_o^k^h01?o^k^h00oooooook^k^onk^kP02onk^
kP03ooooooo^k^kok^k^017ok^k^00?oooooonk^k_o^k^h00oo^k^h00oooooook^k^onk^kP03onk^
kP03ooooooo^k^kok^k^00?ok^k^00Coooooonk^k_o^k^kooooo1?o^k^h00oooooook^k^onk^kP0<
onk^kP03ooooooo^k^kok^k^00?ok^k^00?oooooonk^k_o^k^h02Oo^k^h00oooooook^k^onk^kP03
onk^kP04ooooooo^k^kok^k^ooooo`?ok^k^00?oooooonk^k_o^k^h01?o^k^h00oooooook^k^onk^
kP06onk^kP03ooooooo^k^kok^k^00Ook^k^00?oooooonk^k_o^k^h01?o^k^h00oooooook^k^onk^
kP03onk^kP03ooooooo^k^kok^k^00;ok^k^00?oooooonk^k_o^k^h01oo^k^h00oooooook^k^onk^
kP03onk^kP03ooooooo^k^kok^k^00ook^k^00?oooooonk^k_o^k^h02Oo^k^h01?ooooook^k^onk^
k_ooool7onk^kP04ooooooo^k^kok^k^ooooo`?ok^k^00?oooooonk^k_o^k^h04?o^k^h00ooooooo
k^k^onk^kP08onk^kP05ooooooo^k^kok^k^onk^k_ooool00oo^k^h01Oooooook^k^onk^k_o^k^ko
oooo00?ok^k^00?oooooonk^k_o^k^h02_o^k^h00oooooook^k^onk^kP06onk^kP03ooooooo^k^ko
k^k^00?ok^k^00?oooooonk^k_o^k^h02_o^k^h01Oooooook^k^onk^k_o^k^kooooo01Kok^k^00?o
ooooonk^k_o^k^h00_o^k^h00oooooook^k^onk^kP03onk^kP03ooooooo^k^kok^k^00[ok^k^00?o
ooooonk^k_o^k^h00_o^k^h00oooooook^k^onk^kP0:onk^kP03ooooooo^k^kok^k^00Gok^k^00?o
ooooonk^k_o^k^h02Oo^k^h00oooooook^k^onk^kP04onk^kP03olc<c?oooooooooo00Gooooo00Go
gMgMohR8R?o^k^koooooomgMg@02ooooo`0000Goooooonk^k_o^k^kok^k^ooooo`02onk^kP03oooo
ooo^k^kok^k^00;ok^k^00?oooooonk^k_o^k^h00oo^k^h01?ooooook^k^onk^k_ooool3onk^kP04
ooooooo^k^kok^k^ooooo`Gok^k^00Coooooonk^k_o^k^kooooo1_o^k^h00oooooook^k^onk^kP07
onk^kP05ooooooo^k^kok^k^onk^k_ooool00_o^k^h01Oooooook^k^onk^k_o^k^kooooo00cok^k^
00Goooooonk^k_o^k^kok^k^ooooo`09onk^kP04ooooooo^k^kok^k^ooooo`Cok^k^00?oooooonk^
k_o^k^h02?o^k^h00oooooook^k^onk^kP07onk^kP04ooooooo^k^kok^k^ooooo`Wok^k^00?ooooo
onk^k_o^k^h03Oo^k^h00oooooook^k^onk^kP02onk^kP04ooooooo^k^kok^k^ooooo`Sok^k^00?o
ooooonk^k_o^k^h00_o^k^h01Oooooook^k^onk^k_o^k^kooooo00?ok^k^00?oooooonk^k_o^k^h0
0_o^k^h01Oooooook^k^onk^k_o^k^kooooo00Cok^k^00?oooooonk^k_o^k^h01?o^k^h00ooooooo
k^k^onk^kP0Aonk^kP04ooooooo^k^kok^k^ooooo`?ok^k^00Goooooonk^k_o^k^kok^k^ooooo`07
onk^kP05ooooooo^k^kok^k^onk^k_ooool01oo^k^h01?ooooook^k^onk^k_oooolRonk^kP04oooo
ooo^k^kok^k^ooooo`?ok^k^00Goooooonk^k_o^k^kok^k^ooooo`03onk^kP03ooooooo^k^kok^k^
00?ok^k^00Goooooonk^k_o^k^kok^k^ooooo`0Donk^kP03ooooooo^k^kok^k^00Gok^k^00Gooooo
onk^k_o^k^kok^k^ooooo`03onk^kP05ooooooo^k^kok^k^onk^k_ooool03?o^k^h00oooooook^k^
onk^kP08onk^kP04ooooooo^k^kok^k^ooooo`kok^k^00Goooooonk^k_o^k^kok^k^ooooo`02onk^
kP05ooooooo^k^kok^k^onk^k_ooool02Oo^k^h00oooooook^k^onk^kP09onk^kP03ooooooo^k^ko
k^k^00_ok^k^00?oooooonk^k_o^k^h00_o^k^h01?ooooook^k^onk^k_ooool3onk^kP03ooooooo^
k^kok^k^00?ok^k^00?oooooonk^k_o^k^h00oo^k^h00oooooook^k^onk^kP0Bonk^kP04ooooooo^
k^kok^k^ooooo`?ok^k^00?oooooonk^k_o^k^h00oo^k^h01?ooooook^k^onk^k_ooool5onk^kP03
ooooooo^k^kok^k^00?ok^k^00Coooooonk^k_o^k^kooooo0oo^k^h00oooooook^k^onk^kP07onk^
kP03ooooooo^k^kok^k^00?ok^k^00Coooooonk^k_o^k^kooooo1?o^k^h01Oooooook^k^onk^k_o^
k^kooooo00Gok^k^00?oooooonk^k_o^k^h02oo^k^h01Oooooook^k^onk^k_o^k^kooooo00Wok^k^
00Coooooonk^k_o^k^kooooo1?o^k^h00oooooook^k^onk^kP0:onk^kP03ooooooo^k^kok^k^00Go
k^k^00Goooooonk^k_o^k^kok^k^ooooo`04onk^kP03omgMgOoooooooooo00Kooooo00?ogMgMohR8
R?oMgMd00oooool000ook^k^00?oooooonk^k_o^k^h07Oo^k^h01?ooooook^k^onk^k_oooolAonk^
kP03ooooooo^k^kok^k^00;ok^k^00?oooooonk^k_o^k^h02oo^k^h00oooooook^k^onk^kP0?onk^
kP04ooooooo^k^kok^k^ooooo`Kok^k^00Coooooonk^k_o^k^kooooo3?o^k^h00oooooook^k^onk^
kP03onk^kP03ooooooo^k^kok^k^00;ok^k^00?oooooonk^k_o^k^h00_o^k^h00oooooook^k^onk^
kP03onk^kP03ooooooo^k^kok^k^00Gok^k^00?oooooonk^k_o^k^h08_o^k^h00oooooook^k^onk^
kP08onk^kP03ooooooo^k^kok^k^00Cok^k^00?oooooonk^k_o^k^h07?o^k^h01?ooooook^k^onk^
k_ooool9onk^kP03ooooooo^k^kok^k^00?ok^k^00?oooooonk^k_o^k^h00oo^k^h00oooooook^k^
onk^kP03onk^kP03ooooooo^k^kok^k^00Cok^k^00?oooooonk^k_o^k^h07oo^k^h00oooooook^k^
onk^kP03onk^kP03ooooooo^k^kok^k^00_ok^k^00?oooooonk^k_o^k^h05?o^k^h01?ooooook^k^
onk^k_ooool9onk^kP03ooooooo^k^kok^k^00gok^k^00?oooooonk^k_o^k^h00_o^k^h00ooooooo
k^k^onk^kP0Aonk^kP03ooooooo^k^kok^k^00?ok^k^00?oooooonk^k_o^k^h01?o^k^h00ooooooo
k^k^onk^kP08onk^kP03ooooooo^k^kok^k^00Cok^k^00?oooooonk^k_o^k^h06?o^k^h01Ooooooo
k^k^onk^k_o^k^kooooo00Sok^k^00?oooooonk^k_o^k^h02_o^k^h00oooooook^k^onk^kP0Monk^
kP03ooooooo^k^kok^k^00Cok^k^00?oooooonk^k_o^k^h05oo^k^h00oooooook^k^onk^kP03onk^
kP03ooooooo^k^kok^k^00Sok^k^00?oooooonk^k_o^k^h03oo^k^h01?ooooook^k^onk^k_ooool9
onk^kP03ooooooo^k^kok^k^00Wok^k^00?ogMgMooooooooool01oooool00ooMgMgoR8R8onk^kP02
ooooo`0000?ok^k^ooooooo^k^h01oo^k^h00oooooook^k^onk^kP09onk^kP03ooooooo^k^kok^k^
00Kok^k^00?oooooonk^k_o^k^h01Oo^k^h00oooooook^k^onk^kP0;onk^kP03ooooooo^k^kok^k^
00Kok^k^00?oooooonk^k_o^k^h02_o^k^h00oooooook^k^onk^kP05onk^kP03ooooooo^k^kok^k^
00?ok^k^00?oooooonk^k_o^k^h01Oo^k^h00oooooook^k^onk^kP0Ionk^kP03ooooooo^k^kok^k^
02Cok^k^00?oooooonk^k_o^k^h00oo^k^h01Oooooook^k^onk^k_o^k^kooooo00Sok^k^00?ooooo
onk^k_o^k^h01_o^k^h00oooooook^k^onk^kP0:onk^kP03ooooooo^k^kok^k^00Cok^k^00?ooooo
onk^k_o^k^h00oo^k^h00oooooook^k^onk^kP05onk^kP03ooooooo^k^kok^k^00Kok^k^00Cooooo
onk^k_o^k^kooooo4_o^k^h00oooooook^k^onk^kP03onk^kP03ooooooo^k^kok^k^00?ok^k^00?o
ooooonk^k_o^k^h00oo^k^h00oooooook^k^onk^kP03onk^kP03ooooooo^k^kok^k^00?ok^k^00?o
ooooonk^k_o^k^h01Oo^k^h00oooooook^k^onk^kP0:onk^kP03ooooooo^k^kok^k^00Gok^k^00?o
ooooonk^k_o^k^h00oo^k^h00oooooook^k^onk^kP03onk^kP04ooooooo^k^kok^k^ooooo`[ok^k^
00Goooooonk^k_o^k^kok^k^ooooo`08onk^kP03ooooooo^k^kok^k^00[ok^k^00?oooooonk^k_o^
k^h01_o^k^h00oooooook^k^onk^kP05onk^kP05ooooooo^k^kok^k^onk^k_ooool02Oo^k^h00ooo
ooook^k^onk^kP0;onk^kP03ooooooo^k^kok^k^00Wok^k^00?oooooonk^k_o^k^h01?o^k^h01Ooo
ooook^k^onk^k_o^k^kooooo00Kok^k^00?oooooonk^k_o^k^h02?o^k^h01Oooooook^k^onk^k_o^
k^kooooo00Ook^k^00?oooooonk^k_o^k^h03?o^k^h00oooooook^k^onk^kP0:onk^kP03ooooooo^
k^kok^k^00[ok^k^00?oooooonk^k_o^k^h01Oo^k^h00oooooook^k^onk^kP05onk^kP03ooooooo^
k^kok^k^01Cok^k^00?oooooonk^k_o^k^h01Oo^k^h00oooooook^k^onk^kP05onk^kP03ooooooo^
k^kok^k^00?ok^k^00?oooooonk^k_o^k^h00oo^k^h00oooooook^k^onk^kP07onk^kP03ooooooo^
k^kok^k^00Gok^k^00?oooooonk^k_o^k^h02oo^k^h01Oooooook^k^onk^k_o^k^kooooo00_ok^k^
00Coooooonk^k_o^k^kogMgM2_ooool00ooMgMgoR8R8omgMg@01ooooo`001_o^k^h00oooooook^k^
onk^kP09onk^kP03ooooooo^k^kok^k^00Kok^k^00?oooooonk^k_o^k^h01Oo^k^h00oooooook^k^
onk^kP05onk^kP03ooooooo^k^kok^k^00?ok^k^00?oooooonk^k_o^k^h01_o^k^h00oooooook^k^
onk^kP0:onk^kP03ooooooo^k^kok^k^00Gok^k^00?oooooonk^k_o^k^h02oo^k^h00oooooook^k^
onk^kP05onk^kP03ooooooo^k^kok^k^00Ook^k^00?oooooonk^k_o^k^h01oo^k^h00oooooook^k^
onk^kP04onk^kP03ooooooo^k^kok^k^00;ok^k^00Coooooonk^k_o^k^kooooo1?o^k^h01?oooooo
k^k^onk^k_ooool4onk^kP04ooooooo^k^kok^k^ooooo`Cok^k^00Coooooonk^k_o^k^kooooo1Oo^
k^h00oooooook^k^onk^kP0:onk^kP03ooooooo^k^kok^k^00Kok^k^00?oooooonk^k_o^k^h02_o^
k^h00oooooook^k^onk^kP0Bonk^kP03ooooooo^k^kok^k^00Kok^k^00?oooooonk^k_o^k^h02Oo^
k^h00oooooook^k^onk^kP07onk^kP03ooooooo^k^kok^k^02?ok^k^00?oooooonk^k_o^k^h01_o^
k^h01Oooooook^k^onk^k_o^k^kooooo00Ook^k^00?oooooonk^k_o^k^h05?o^k^h01?ooooook^k^
onk^k_ooool<onk^kP03ooooooo^k^kok^k^00Cok^k^00?oooooonk^k_o^k^h00oo^k^h00ooooooo
k^k^onk^kP06onk^kP03ooooooo^k^kok^k^00Gok^k^00?oooooonk^k_o^k^h02oo^k^h00ooooooo
k^k^onk^kP04onk^kP04ooooooo^k^kok^k^ooooo`?ok^k^00?oooooonk^k_o^k^h01_o^k^h01?oo
ooook^k^onk^k_ooool6onk^kP03ooooooo^k^kok^k^01?ok^k^00?oooooonk^k_o^k^h02Oo^k^h0
0oooooook^k^onk^kP03onk^kP04ooooooo^k^kok^k^ooooo`Gok^k^00?oooooonk^k_o^k^h01Oo^
k^h00oooooook^k^onk^kP02onk^kP03ooooooo^k^kok^k^00[ok^k^00?oooooonk^k_o^k^h01Oo^
k^h00oooooook^k^onk^kP05onk^kP03ooooooo^k^kok^k^00Cok^k^00Goooooonk^k_o^k^kok^k^
ooooo`04onk^kP03ooooooo^k^kok^k^00Cok^k^00?oooooonk^k_o^k^h01Oo^k^h00oooooook^k^
onk^kP05onk^kP03ooooooo^k^kok^k^01?ok^k^00?oooooonk^k_o^k^h01Oo^k^h00oooooook^k^
onk^kP05onk^kP03ooooooo^k^kok^k^00?ok^k^00?oooooonk^k_o^k^h02Oo^k^h01Oooooook^k^
onk^k_o^k^kooooo00Gok^k^00?oooooolc<c?ooool02_ooool1omgMg@7ooooo0Oooool00005oooo
ooo^k^kok^k^onk^k_ooool00oo^k^h00oooooook^k^onk^kP02onk^kP04ooooooo^k^kok^k^oooo
o`?ok^k^00Goooooonk^k_o^k^kok^k^ooooo`04onk^kP05ooooooo^k^kok^k^onk^k_ooool00oo^
k^h01Oooooook^k^onk^k_o^k^kooooo00?ok^k^00?oooooonk^k_o^k^h00oo^k^h00oooooook^k^
onk^kP02onk^kP05ooooooo^k^kok^k^onk^k_ooool00_o^k^h01?ooooook^k^onk^k_ooool2onk^
kP05ooooooo^k^kok^k^onk^k_ooool00oo^k^h01Oooooook^k^onk^k_o^k^kooooo00;ok^k^00Co
ooooonk^k_o^k^kooooo0oo^k^h01Oooooook^k^onk^k_o^k^kooooo00?ok^k^00Goooooonk^k_o^
k^kok^k^ooooo`02onk^kP04ooooooo^k^kok^k^ooooo`?ok^k^00Coooooonk^k_o^k^kooooo0_o^
k^h01Oooooook^k^onk^k_o^k^kooooo00Kok^k^00?oooooonk^k_o^k^h01Oo^k^h00oooooook^k^
onk^kP05onk^kP03ooooooo^k^kok^k^00Gok^k^00?oooooonk^k_o^k^h01Oo^k^h00oooooook^k^
onk^kP03onk^kP05ooooooo^k^kok^k^onk^k_ooool00oo^k^h00oooooook^k^onk^kP02onk^kP05
ooooooo^k^kok^k^onk^k_ooool01?o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^ko
k^k^ooooo`?ok^k^00Goooooonk^k_o^k^kok^k^ooooo`02onk^kP04ooooooo^k^kok^k^ooooo`;o
k^k^00Goooooonk^k_o^k^kok^k^ooooo`03onk^kP03ooooooo^k^kok^k^00;ok^k^00Goooooonk^
k_o^k^kok^k^ooooo`02onk^kP05ooooooo^k^kok^k^onk^k_ooool01?o^k^h01?ooooook^k^onk^
k_ooool2onk^kP05ooooooo^k^kok^k^onk^k_ooool00_o^k^h01?ooooook^k^onk^k_ooool2onk^
kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^
k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`?ok^k^00Goooooonk^k_o^k^kok^k^ooooo`03onk^
kP03ooooooo^k^kok^k^00;ok^k^00Goooooonk^k_o^k^kok^k^ooooo`03onk^kP05ooooooo^k^ko
k^k^onk^k_ooool00_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;o
k^k^00Goooooonk^k_o^k^kok^k^ooooo`06onk^kP05ooooooo^k^kok^k^onk^k_ooool01?o^k^h0
1Oooooook^k^onk^k_o^k^kooooo00Kok^k^00?oooooonk^k_o^k^h00oo^k^h00oooooook^k^onk^
kP02onk^kP05ooooooo^k^kok^k^onk^k_ooool00oo^k^h01Oooooook^k^onk^k_o^k^kooooo00?o
k^k^00?oooooonk^k_o^k^h00_o^k^h00oooooook^k^onk^kP02onk^kP03ooooooo^k^kok^k^00Oo
k^k^00Goooooonk^k_o^k^kok^k^ooooo`02onk^kP03ooooooo^k^kok^k^00Kok^k^00?oooooonk^
k_o^k^h01?o^k^h01Oooooook^k^onk^k_o^k^kooooo00?ok^k^00Coooooonk^k_o^k^kooooo0_o^
k^h01Oooooook^k^onk^k_o^k^kooooo00?ok^k^00Goooooonk^k_o^k^kok^k^ooooo`03onk^kP05
ooooooo^k^kok^k^onk^k_ooool02?o^k^h00oooooook^k^onk^kP03onk^kP05ooooooo^k^kok^k^
onk^k_ooool01?o^k^h01Oooooook^k^onk^k_o^k^kooooo00;ok^k^00Coooooonk^k_o^k^kooooo
0_o^k^h01Oooooook^k^onk^k_o^k^kooooo00?ok^k^00Goooooonk^k_o^k^kok^k^ooooo`03onk^
kP05ooooooo^k^kok^k^onk^k_ooool01_o^k^h00oooooook^k^onk^kP02onk^kP05ooooooo^k^ko
k^k^onk^k_ooool00_o^k^h01Oooooook^k^onk^k_o^k^kooooo00?ok^k^00Goooooonk^k_o^k^ko
k^k^ooooo`03onk^kP05ooooooo^k^kok^k^onk^k_ooool00_o^k^h01?ooooook^k^onk^k_ooool2
onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0oo^k^h01Oooooook^k^
onk^k_o^k^kooooo00?ok^k^00Goooooonk^k_o^k^kok^k^ooooo`03onk^kP03ooooooo^k^kok^k^
00?ok^k^00Goooooonk^k_o^k^kok^k^ooooo`07onk^kP05ooooooo^k^kok^k^onk^k_ooool01?o^
k^h00ooMgMgoooooooooo`0<ooooo`00ooo^k^koonk^kW?ok^k^1_oMgMd00oo<c<cogMgMomgMg@06
omgMg@00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0000:onk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h06OoMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h0PooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h05OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0=omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP1momgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h07ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h03_oMgMgok^k^onk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h02?oMgMgok^k^onk^k_oMgMgok^k^
omgMgOo^k^kogMgM0_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^037ogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^02_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^01GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0=ooMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h06_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM0Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h000;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03ooMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0AomgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h00ooMgMgok^k^omgMg@02onk^kP0LomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@;ok^k^01GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h05ooMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgM
g@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^ko
gMgM0_o^k^h02?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^
k_oMgMgok^k^omgMg@;ok^k^02GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^03oogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h03OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^
kP08omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^
k^kogMgM0_o^k^h05_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^
omgMgOo^k^kogMgM0_o^k^h0=_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^
00?ogMgMonk^k_oMgMd00_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgM
g@;ok^k^02?ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^01SogMgM
onk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0SomgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^ko
k^k^omgMgOo^k^kogMgM0_o^k^h05ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
00?ogMgMonk^k_oMgMd00_o^k^h1omgMg@7ok^k^0Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h0000@onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00oogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h08?oMgMgok^k^onk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^
k^h04?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^013ogMgMonk^k_o^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h02?oMgMgok^k^onk^k_oM
gMgok^k^omgMgOo^k^kogMgM0_o^k^h0AooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0?omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00oogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
0ooMgMgok^k^omgMg@02onk^kP0MomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h05ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^02;ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0;OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0/omgMgOo^k^kok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP0;omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h03OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h0;ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h06OoMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h09_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM0_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0MomgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h03_oM
gMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0000:onk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00oogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h07OoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01CogMgMonk^
k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@;ok^k^07gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0BomgMgOo^k^kok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
0_o^k^h04OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^
k^kok^k^omgMgOo^k^kogMgM0_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP03omgMgOo^k^kogMgM00;ok^k^023ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP0`omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h06ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h05OoMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP0comgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^
k_oMgMd2onk^kP0PomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0EomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?o
gMgMonk^k_oMgMd00_o^k^h02?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0:_oM
gMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01?ogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^0OoMgMd00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h000;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03ooMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP1;omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01CogMgM
onk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h06ooMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0:omgMgOo^k^kok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@;ok^k^00SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMg@;o
k^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02GogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^02gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h04OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01WogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0KOoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h03OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00OogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h0=OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01CogMgMonk^k_o^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP7ogMgM0Oo^k^h00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0000@onk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01OogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^
k^h06?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00_ogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^017o
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP0>omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd2onk^kP0BomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgM
g@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0eomgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h02_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2
onk^kP0oomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h06OoMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h03ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^
k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^01KogMgMonk^k_o^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0PomgMgOo^k^kok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^
k^kok^k^omgMgOo^k^kogMgM0_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^
k_oMgMd00_o^k^h0=ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
1_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0S
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h02?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM
0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^01GogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h03OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0
000:onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00oogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooM
gMgok^k^omgMg@02onk^kP0LomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03_oMgMgok^k^onk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h05OoMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP1?omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP0?omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^01GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h05ooMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03?oMgMgok^k^
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00WogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0CooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgo
k^k^omgMg@02onk^kP0DomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0<omgMgOo^k^kok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0AomgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h0?OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01[ogMgMonk^
k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01WogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^
omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^03OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_o^k^h00OoMgMd00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h000;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03ooM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP0QomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^02WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP1;omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h05OoMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP0VomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgM
gOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h05?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h02OoMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0ComgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP1FomgMgOo^
k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP1=omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
0ooMgMgok^k^omgMg@02onk^kP0lomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0<_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgo
k^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00[ogMgMonk^k_o^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM0_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@01
onk^kP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00013o
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM0_o^k^h0>OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP0UomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^
00cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgM
gOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP05omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03
omgMgOo^k^kogMgM00;ok^k^01cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM0_o^k^h05OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^ko
k^k^omgMgOo^k^kogMgM0_o^k^h01ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0?OoM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h06ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0JOoMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgM
gOo^k^kogMgM0_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^
k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP0[omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP10omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0SomgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h1omgMg@00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP0000[ok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM0_o^k^h07OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0>omgMgOo^k^kok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM
00;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^
omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h03OoMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h04OoMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01go
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP0MomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h06?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^04oogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^02gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^
k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00Ko
gMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP08omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oM
gMd2onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01ooMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^
k_o^k^kogMgMonk^k_oMgMd2onk^kP0oomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^
k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^
k^h03ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h08?oMgMgok^k^onk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooM
gMgok^k^omgMg@02onk^kP0TomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01ooMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM007ok^k^003oonk^k_oo
k^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^0002onk^kP03omgMgOo^k^ko
gMgM00;ok^k^00oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oM
gMd00_o^k^h05ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02GogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0BOoMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02
onk^kP0IomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0[omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^
k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;o
k^k^00?ogMgMonk^k_oMgMd00_o^k^h02?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^
k^h05_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0oomgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^03go
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^03GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0momgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0/omgMgOo^
k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0AomgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h1omgMg@00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00013ok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM0_o^k^h0JOoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0ComgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^
k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0IomgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^
01OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP08omgMgOo^k^kok^k^omgMgOo^
k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0
<ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0<omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00Go
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^06oogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0IomgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0?OoM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h0:ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
6OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00Oo^k^h00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0000:onk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^02_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^01CogMgMonk^k_o^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
01_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0;ooM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0B_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0;OoMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;o
k^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^05GogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06
omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0<OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgo
k^k^onk^k_oMgMgok^k^omgMg@;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^
k^kogMgM00;ok^k^02WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP0NomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM0_o^k^h02?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^
omgMg@02onk^kP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP000_o^k^h00ooMgMgok^k^omgMg@02onk^kP0SomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooM
gMgok^k^omgMg@02onk^kP0>omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd2onk^kP0AomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0@omgM
gOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@;ok^k^03?ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h03ooMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP0eomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgo
k^k^omgMg@02onk^kP1KomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01OoM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oM
gMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^
omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^
k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^
onk^k_oMgMgok^k^omgMg@;ok^k^03OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0homgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^03KogMgMonk^k_o^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool0
0?ook^k^ooo^k^j2onk^kP00013ok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^ko
gMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP10omgMgOo^k^kok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;o
k^k^02oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP0<omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM0_o^k^h0:OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^02OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0=omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^ko
gMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0BomgMgOo^k^kok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0
3?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgM
onk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^0=OogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP0ZomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM0_o^k^h03?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;o
k^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^0OoMgMd1onk^kP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP0000[ok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0KOoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgo
k^k^onk^k_oMgMgok^k^omgMg@;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h07?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd2onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0ComgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^
k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^03cogMgMonk^k_o^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0@omgMgOo^k^ko
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^
01OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP05omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^05OogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgM
g@;ok^k^01WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgM
onk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0jomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@;ok^k^02WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h04?oM
gMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd2onk^kP0?omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM007ok^k^003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^0002onk^kP03omgMgOo^k^kogMgM00;ok^k^02_ogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h02?oMgMgo
k^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;o
k^k^013ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM0_o^k^h03_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0DomgMgOo^k^kok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2
onk^kP0eomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02
onk^kP0IomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP2AomgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^
00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0komgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h04OoMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^
k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^01SogMgMonk^k_o^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^
k^kogMgM0_o^k^h0;?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM0_o^k^h0:OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00013ok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h04ooMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h00ooMgMgok^k^omgMg@02onk^kP0VomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^
kP0BomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM0_o^k^h0<ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^
k^kok^k^omgMgOo^k^kogMgM0_o^k^h04ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h05OoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP0domgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgM
onk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00GogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP11omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h05ooMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgo
k^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgM
gOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^ko
gMgMonk^k_oMgMd2onk^kP2<omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;o
k^k^02cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h1omgMg@00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP0000[ok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0H_oMgMgok^k^
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h03ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0FomgMgOo^k^kok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0EomgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^023ogMgMonk^k_o^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^013o
gMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
0ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^
k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h02ooMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^0<7ogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h00ooMgMgo
k^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h08ooMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;o
k^k^017ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@01onk^kP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP000_o^k^h00ooMgMgok^k^omgMg@02onk^kP1]omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP03omgMgOo^k^kogMgM00;ok^k^00kogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@;ok^k^03SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@;ok^k^01_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h03OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h0>ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^02oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP1NomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00KogMgM
onk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0@omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP08omgM
gOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP1HomgMgOo^k^kok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP0PomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@7ok^k^003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^00004?o^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0OomgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06
omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP08omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^
k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h02?oMgMgok^k^
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
02oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^01?ogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
05KogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^
k_o^k^kogMgMonk^k_oMgMd2onk^kP0;omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h0AooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^03So
gMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01GogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h0;_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^
k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0E?oMgMgok^k^onk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00Oo^
k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0000:onk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01OogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^073ogMgMonk^k_o^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM0_o^k^h04ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^
kP0ComgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oM
gMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^01WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h04ooMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h0;OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^017ogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0N
omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oM
gMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^
k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP1comgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP08omgMgOo^k^kok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd2onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0VomgMgOo^k^kok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd2onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP000_o^k^h00ooMgMgok^k^omgMg@02onk^kP0?omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^
k^kogMgMonk^k_oMgMd2onk^kP1OomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^
k_oMgMgok^k^omgMg@;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h05_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0GomgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h06ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00SogMgMonk^k_o^k^kogMgMonk^k_oMgMgo
k^k^omgMg@;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^03?ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oM
gMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^
omgMgOo^k^kogMgM0_o^k^h05OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP1comgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0:omgMgOo^k^kok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@;ok^k^07WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oM
gMd2onk^kP0FomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^00004?o^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0QomgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0AomgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^
omgMg@02onk^kP0:omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?o
gMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^01CogMgMonk^k_o^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^
01OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP1aomgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0;omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0;_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0lomgMgOo^k^kok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h07ooMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP0MomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
1_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^01gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^02gogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^027ogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h1omgMg@7o
k^k^0Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0
00;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0<ooMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0DooMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01CogMgMonk^k_o^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^
00?ogMgMonk^k_oMgMd00_o^k^h06_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM0_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02GogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^
k_oMgMd00_o^k^h04_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^04WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^
kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h03?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h02ooMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0
3OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
6OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0<_oMgMgok^k^onk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM
0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^037ogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
02OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h02_oMgMgok^k^onk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd1onk^kP00ooo^k^koonk^kX;ok^k^003ooooooooooooo
P_ooool00?ook^k^ooo^k^j2onk^kP0000Kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0IomgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgM
gOo^k^kogMgM0_o^k^h0@_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^02?ogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^01GogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h04OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgo
k^k^omgMg@;ok^k^01GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02
onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oM
gMgok^k^omgMg@;ok^k^04gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^
k^h04OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^023ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^027ogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0;_oMgMgo
k^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0@ooMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02
onk^kP0QomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03ooMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP00ooo^k^ko
onk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP000_o^k^h04OoMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h06?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0komgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02
onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0MomgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
GOoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP0WomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgM
onk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0AomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0?ooMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP0]omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP1;omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^03OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00Ko
gMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0EomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
00?ogMgMonk^k_oMgMd00Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h0000>onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd2onk^kP0momgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
1_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^
kP0:omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01_ogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h03OoMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02
onk^kP0_omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h02?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0
8_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd2onk^kP0ComgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^
omgMgOo^k^kogMgM0_o^k^h02ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^037ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02kogMgMonk^k_o^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02
onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oM
gMd00_o^k^h04OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oM
gMgok^k^omgMg@;ok^k^00_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP0IomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgM
gOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00Ko
gMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0<_oM
gMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0PomgMgOo^k^kok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP07
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP7ogMgM003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^0002onk^kP0momgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^ko
k^k^omgMgOo^k^kogMgM0_o^k^h0CooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h04ooMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
3?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgM
onk^k_oMgMd00_o^k^h06ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP0QomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01CogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^04Co
gMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oM
gMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0Z
omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01OoMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^02gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0QomgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h09ooMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00Go
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP0OomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00oo
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00006
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h05_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2
onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0<omgM
gOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0<OoMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h09OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h04ooMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h06OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h07ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06
omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h03_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0?OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0]omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^03kogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0AooMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^
kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0;_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0GomgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h1omgMg@00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP000_o^k^h03ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM
0_o^k^h06OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0:ooMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgo
k^k^omgMg@02onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oM
gMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP1comgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0IomgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h07OoMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oM
gMd00_o^k^h0:ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP08omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oM
gMd2onk^kP0:omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01gogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03
omgMgOo^k^kogMgM00;ok^k^02OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h07OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0=ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0FomgMgOo^k^kok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP7ogMgM0Oo^k^h00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0000lonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01ooMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP08omgMgOo^k^kok^k^
omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h04OoM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^02WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h04ooMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
5ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0
1_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00[ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM0_o^k^h09OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgo
k^k^omgMg@02onk^kP0@omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@;ok^k^08gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oM
gMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^023ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00OogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0<omgMgOo^k^ko
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h02?oMgMgok^k^onk^k_oM
gMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;o
k^k^02_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^00SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP0[omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@01onk^kP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP000_o^k^h0IooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h0:OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^017ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0
2OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0:omgMgOo^k^kok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^02SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00go
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01Go
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0BOoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^
k^h0:OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01GogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0IOoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM
00;ok^k^02_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP0000Kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^
kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
1_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^
kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^04gogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP1ComgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01ooMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h04ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^
kP0EomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00oogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oM
gMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP05
omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h08OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^
omgMgOo^k^kogMgM0_o^k^h04ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0:?oMgMgok^k^onk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00cogMgMonk^k_o^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0AomgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
8OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0
0ooMgMgok^k^omgMg@02onk^kP0aomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;o
k^k^01_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h000;ok^k^03Oo
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^027ogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0>omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^
k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0;_oMgMgok^k^
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^
kP1IomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^07oogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0YomgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h04OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00_ogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^
017ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00[ogMgMonk^k_o^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM0_o^k^h0>ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h06ooMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgM
gOo^k^kogMgM0_o^k^h1omgMg@7ok^k^003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^0000A?o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oM
gMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0F
omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^02WogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oM
gMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgM
g@02onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP08omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM
00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00Wo
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h08ooMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^01OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP08omgMgOo^k^ko
k^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01ooM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h08OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0QomgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^02_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;o
k^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0comgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^03kogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgo
k^k^omgMg@;ok^k^01kogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00oogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00Oo^k^h00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0000nonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP1AomgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h09OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h03OoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^
k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP05omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h0AOoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;o
k^k^013ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0AomgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^04OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP0SomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP03
omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^
omgMgOo^k^kogMgM0_o^k^h0;_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0GomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h1omgMg@00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP000_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^
k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oM
gMgok^k^omgMg@;ok^k^00SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^02OogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP07
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP0AomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h09ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP0comgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02_ogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^
k^h0:?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0<omgMgOo^k^ko
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h04?oMgMgok^k^onk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0QomgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^017ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^02_ogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^
k_o^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^
k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^07GogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h06ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP7ogMgM0Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h0001Honk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h07ooMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
0ooMgMgok^k^omgMg@02onk^kP1PomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h06ooMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0;omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0D?oMgMgok^k^onk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
0_o^k^h08OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP0AomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0;ooMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02?o
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP0DomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^
k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^03[ogMgM
onk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgo
k^k^onk^k_oMgMgok^k^omgMg@;ok^k^00cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd2onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP05omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h02?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0Oo^
k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h000;ok^k^
047ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^
k^kogMgMonk^k_oMgMd2onk^kP10omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgo
k^k^onk^k_oMgMgok^k^omgMg@;ok^k^01;ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgM
gOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^ko
gMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h05OoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00_ogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06
omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
01cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0
4OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^03?ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^
k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0eomgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0@_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^
00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0fomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM0_o^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h0000Lonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@;ok^k^01gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP0ZomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
0_o^k^h02?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oM
gMgok^k^omgMg@;ok^k^017ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0WomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0<OoMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
0ooMgMgok^k^omgMg@02onk^kP0SomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01ooMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h0:OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0EomgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h05?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0>omgMgOo^k^ko
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^
k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP15omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0>?oMgMgok^k^onk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h02ooMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^0OoMgMd1onk^kP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP0000Cok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgo
k^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0<omgM
gOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^
onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0XomgMgOo^
k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0
8ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^07gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0;omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0<OoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h04OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP0OomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0ComgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0_omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h02?oMgMgok^k^onk^k_oM
gMgok^k^omgMgOo^k^kogMgM0_o^k^h09ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP13omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP08omgMgOo^k^kok^k^omgM
gOo^k^kogMgMonk^k_oMgMd2onk^kP0>omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@01onk^
kP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP000_o^k^h0
AooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^
k_oMgMd00_o^k^h01ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h09OoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h0A?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^
k^h06ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03
omgMgOo^k^kogMgM00;ok^k^013ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0>omgMgOo^k^ko
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0SomgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0WomgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^057ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooM
gMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^
k^kogMgM00;ok^k^03WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
?_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0XomgMgOo^k^kok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@;ok^k^0OoMgMd00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h0000Lonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@;ok^k^027ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0Q
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP05
omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h06OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM
0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oM
gMd2onk^kP0:omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00cogMgM
onk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP08omgMgOo^k^ko
k^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
5OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0SomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
2?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^
omgMg@;ok^k^013ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM0_o^k^h0;_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^
k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00[ogMgMonk^k_o^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?o
gMgMonk^k_oMgMd00_o^k^h0HOoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0<?oMgMgo
k^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@;ok^k^017ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
9_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h03ooMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@01onk^kP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP0001Kok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM0_o^k^h03OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h04ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h05OoMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP0?omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^02OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h0_?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgo
k^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0;omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0=ooMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgM
gOo^k^kogMgM0_o^k^h0@_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^02KogMgMonk^k_o^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oM
gMgok^k^omgMg@;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
0ooMgMgok^k^omgMg@02onk^kP0XomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@;ok^k^00SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00WogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^ko
gMgM00;ok^k^003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^
0002onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0@
omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgo
k^k^onk^k_oMgMgok^k^omgMg@;ok^k^02CogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgM
gOo^k^kogMgM00;ok^k^027ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP17omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h06ooMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0:omgMgOo^k^kok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h02?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM
0_o^k^h0<_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h06ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0[omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0;omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h07OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP03omgM
gOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgM
gOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM
00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0:_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@;ok^k^03oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^
kP0SomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;o
oooo003oonk^k_ook^k^P_o^k^h0000Jonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd2onk^kP0UomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^ko
gMgM00;ok^k^06cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0:omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0ComgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^03KogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h02?oMgMgo
k^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0AOoMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP0>omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd2onk^kP0MomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h0?ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^
k_oMgMd2onk^kP0nomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^02gogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00?ook^k^
ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h000;ok^k^01?ogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^02GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^017ogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^
k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0@omgMgOo^k^ko
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^
00?ogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^
00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^
k_oMgMd00_o^k^h0:?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0R
omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@;ok^k^02WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^02OogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h05ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00Ko
gMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
<?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@;ok^k^03oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0<OoMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01OoMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^ko
k^k^omgMgOo^k^kogMgM0_o^k^h09OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h02?oM
gMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgM
gOo^k^kogMgM007ok^k^003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^00008_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0jomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^027ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0=ooMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h04ooMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h07ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h0A_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^
kP0;omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgo
k^k^omgMg@02onk^kP0<omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0
=OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^
k_oMgMd2onk^kP0homgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^
kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03ooMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0IomgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^04;o
gMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^01[ogMgMonk^k_o^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^00001?o^k^kogMgMonk^k_oMgMd2onk^kP06omgM
gOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h03_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h03OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
00cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0=omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0[omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0komgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^01WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^
k_oMgMd00_o^k^h04ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgM
g@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^ko
gMgM0_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01?ogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
00_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP15omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h02?oM
gMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h05ooMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^
k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgo
k^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0IomgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP1KomgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgM
gOo^k^kogMgM00;ok^k^02KogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^0OoMgMd0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h000;ok^k^01Go
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h08ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00Wo
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h06?oMgMgok^k^onk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@;ok^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
02?ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0QomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00[ogMgMonk^k_o^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h07OoMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01[ogMgMonk^k_o^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^02WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h09?oMgMgok^k^
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@;ok^k^01WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^07oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00oogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgo
k^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0comgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0<_oMgMgok^k^onk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM0_o^k^h1omgMg@7ok^k^003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^0000L?o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^
k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00OogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^ko
gMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h08OoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP03omgMgOo^k^kogMgM00;ok^k^01kogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0SomgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h0:OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00GogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP0IomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgM
onk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h07OoM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
00?ogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP13omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0IomgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h00ooM
gMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^
k_oMgMgok^k^omgMg@;ok^k^02;ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01OoMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
00[ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0Oo^k^h00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0000Nonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgM
g@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h05OoMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h02OoMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP1ComgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h03ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP0OomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP0LomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02
onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01OogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
5OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^
k^h0=_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd0
0_o^k^h0?ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0K_oM
gMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0SomgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^
k^h000;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgM
g@;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^017ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^02?ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0SomgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h03OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h07?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^
kP03omgMgOo^k^kogMgM00;ok^k^01GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgo
k^k^omgMg@02onk^kP0RomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP03omgMgOo^k^kogMgM00;ok^k^01gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0GomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h06ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h07_oMgMgok^k^onk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00_ogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM
0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oM
gMd2onk^kP0JomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0T
omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0=ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h04OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01_ogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;o
oooo003oonk^k_ook^k^P_o^k^h0000Jonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd2onk^kP0YomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h0>OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h08ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
00gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
01gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP1YomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0<ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP0QomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h02ooMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^04?ogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;o
k^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0AomgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^
omgMg@02onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h04OoMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgM
onk^k_oMgMd00_o^k^h08_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0;omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP7ogMgM0Oo^k^h0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0000fonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01ooMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h08OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0;omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^01[ogMgM
onk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd0
0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oM
gMd2onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP0EomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^
k_oMgMd2onk^kP0ComgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgM
onk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0QomgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^01_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0;omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^02CogMgMonk^
k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd2onk^kP15omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0;ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01SogMgMonk^k_o^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h06ooM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP09omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h03_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM0Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h000;ok^k^01oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h06OoMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgM
onk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0;omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h08ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^027ogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h05OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0ComgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0OomgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^ko
gMgM00;ok^k^01KogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h03?oMgMgok^k^onk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0
6_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^
omgMg@02onk^kP0?omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^01GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h04ooMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h0<_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^
kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^01Co
gMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@;ok^k^023ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^03_ogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0<omgMgOo^k^kok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h07OoMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^00001_o^k^kogMgMonk^k_oMgMgok^k^omgM
g@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^ko
gMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0YomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h0@OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^027ogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h04OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^03kogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^02cogMgMonk^k_o^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01oogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^03OogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP0GomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgo
k^k^omgMg@02onk^kP08omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP08omgMgOo^
k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0jomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^02OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^01_ogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h07OoMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00gogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00CogMgMonk^k_o^k^ko
gMgM0Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0
00;ok^k^067ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00WogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00GogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0<ooMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^027ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h07OoMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd0
0_o^k^h08OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^01kogMgMonk^k_o^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0iomgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^033ogMgMonk^k_o^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd2onk^kP0ComgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0LomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^
kP08omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP07omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0MomgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h06OoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h0000`onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgM
g@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h07_oMgMgok^k^onk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00WogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h08OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oM
gMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00kogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01?ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgM
onk^k_oMgMd00_o^k^h03?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00Ko
gMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0LomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03OoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgM
g@02onk^kP0_omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0>omgMgOo^k^kok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^
omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^01_ogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0<OoMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h03OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0>ooM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
01[ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^
k_oMgMd00_o^k^h02?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h03ooMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0<
omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00?ook^k^
ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0000Nonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgo
k^k^onk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h06ooMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^
k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^05GogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01?ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^03GogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^02GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0FomgMgOo^k^kok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@;ok^k^033ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00WogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h09?oMgMgok^k^onk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP0SomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0<?oMgMgok^k^onk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01_o
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h07OoMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00go
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00Co
gMgMonk^k_o^k^kogMgM0Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h000;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^
omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP1:omgMgOo^k^kok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0[omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0[omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0HomgMgOo^k^kok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0DooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^01WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgM
onk^k_oMgMd00_o^k^h06OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h09OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h06OoMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^01;o
gMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd2onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP0AomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0KomgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00WogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP08omgMgOo^
k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^
k^h0>OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0I
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@01onk^kP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP0006Sok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^
k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0;_oMgMgok^k^onk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0ComgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00_ogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^01oogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^01go
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP0MomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h0?OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h06?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^
01?ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^017ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0?omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oM
gMd00_o^k^h05OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0[omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^
k^kogMgM0_o^k^h05_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM
00;ok^k^01gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00033ok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgo
k^k^onk^k_oMgMgok^k^omgMg@;ok^k^00SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMg@;o
k^k^00?ogMgMonk^k_oMgMd00_o^k^h01ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
??oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^ko
gMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^01?ogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^01oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^01;ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0@omgMgOo^k^kok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01SogMgM
onk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0]omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd0
0_o^k^h03ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oM
gMgok^k^omgMg@;ok^k^01KogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^
omgMg@02onk^kP0UomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP0aomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP05omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h0;OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP0JomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h05OoMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oM
gMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^0002onk^kP0MomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
03SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^02gogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
@OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0:OoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02[ogMgMonk^k_o^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM
0_o^k^h05?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h05_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd2onk^kP0MomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h02?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0AOoMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0DomgMgOo^k^kok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^
kP0KomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^027o
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h0DOoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP0000Kok^k^omgMgOo^k^kogMgM
onk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oM
gMgok^k^omgMg@;ok^k^06CogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^
k^h00ooMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0]
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h03ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0momgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP09omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01WogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^01[ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@;ok^k^047ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^
00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^
k^h05OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00cogMgM
onk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0OomgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;o
k^k^01;ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd2onk^kP0SomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^
omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h04ooMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h1omgMg@00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP000_o^k^h0CooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;o
k^k^00_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgM
gOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^02oo
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP0;omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h04ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h08OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^ko
gMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0EomgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^01_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h0<ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP09omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02;ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h02?oMgMgok^k^
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0:ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^ko
k^k^omgMgOo^k^kogMgM0_o^k^h01ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0;ooM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgM
gOo^k^kogMgM0_o^k^h01ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h09ooMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@01onk^kP00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00033ok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^
omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^
k^kogMgMonk^k_oMgMd2onk^kP0FomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^02oogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^
kP0<omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h09?oM
gMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h02ooMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01SogMgMonk^k_o^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd2onk^kP0;omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h0:ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h06ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP0?omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^
omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^
00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0<omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM0_o^k^h0UooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0@?oMgMgok^k^onk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06
omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP00ooo^k^ko
onk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP0001[ok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oM
gMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^0:CogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h08ooMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^02KogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^ko
gMgMonk^k_oMgMd2onk^kP0ComgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^
01;ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd2onk^kP1[omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgM
gOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00GogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h05OoMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP0GomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^037ogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01?o
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM007ok^k^003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^0002onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^
k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0@ooMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h07OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^
k^kok^k^omgMgOo^k^kogMgM0_o^k^h0;?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00Ko
gMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP1=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02
onk^kP08omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0GomgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0GomgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h0@ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
0ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^
onk^k_oMgMgok^k^omgMg@;ok^k^00cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^02oogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0EomgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0domgM
gOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^
omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0JomgMgOo^k^kok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP7ogMgM003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^0000C?o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^
013ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP0MomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP03omgMgOo^k^kogMgM00;ok^k^00SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^
00?ogMgMonk^k_oMgMd00_o^k^h0=OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^
k_o^k^kogMgMonk^k_oMgMd2onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^04?ogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^03GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP08
omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^027o
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h0<ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP09omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00[ogMgMonk^k_o^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM0_o^k^h07ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0;omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oM
gMgok^k^omgMg@;ok^k^033ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd00Oo^
k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0000Ponk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd2onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^
kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0D_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd2onk^kP0eomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgM
g@02onk^kP08omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM
00;ok^k^027ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0;ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01SogMgMonk^k_o^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0?omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgo
k^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgM
gOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^09Wo
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0?omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^037ogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@;ok^k^003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^0002onk^kP0EomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00kogMgM
onk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^03;o
gMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@;ok^k^033ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0WomgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^04WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h01ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h03OoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgM
g@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h04OoMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgM
onk^k_oMgMd00_o^k^h04_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^067ogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd0
0_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oM
gMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0<
omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h02ooMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01GogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h0AooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^01GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h1omgMg@00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP0000Kok^k^omgMgOo^k^kogMgMonk^
k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0@?oMgMgok^k^onk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2
onk^kP03omgMgOo^k^kogMgM00;ok^k^00oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h03OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;o
k^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0<omgMgOo^k^kok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h05ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP0[omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP03omgMgOo^k^kogMgM00;ok^k^01oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^03[ogMgMonk^k_o^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0;ooMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00OogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h02_oMgMgok^k^onk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM
0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oM
gMd2onk^kP0gomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0;omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h03OoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^
k_oMgMgok^k^omgMg@;ok^k^02?ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM
00;ok^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^
k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP0MomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0
00;ok^k^03OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^037ogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^02kogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
02SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgM
g@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h02_oMgMgok^k^onk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM
0_o^k^h07OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^027ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h05?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h09OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^08GogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01oogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^037ogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
1?oMgMgok^k^onk^k_oMgMd2onk^kP7ogMgM0Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooo
oh;ooooo003oonk^k_ook^k^P_o^k^h0000Honk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
1OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03_oMgMgok^k^onk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^
onk^k_oMgMgok^k^omgMg@;ok^k^04;ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP07omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0MomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0BooMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^
k^kogMgM0_o^k^h02ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^01GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h07OoMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00oogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgM
g@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^
omgMg@;ok^k^01WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^06Wo
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0MomgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0@?oMgMgo
k^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd2onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
00gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM007ok^k^
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^0002onk^kP0A
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h0?ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgM
onk^k_o^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^01_ogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^
kP0UomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0IomgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP0YomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02?ogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00kogMgMonk^k_o^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01;ogMgMonk^k_o^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0momgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP05omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h03OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgM
gOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^ko
gMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^
k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^ko
gMgM00;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h06OoMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0:?oMgMgok^k^onk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
3OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
0ooMgMgok^k^omgMg@02onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^0OoMgMd00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00006onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oM
gMgok^k^omgMg@;ok^k^01OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP17omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgM
g@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h04OoMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01OogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0?omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP0>omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd2onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^02_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^027ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h04ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0;ooM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd2onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^00?ogMgMonk^k_oMgMd00_o^k^h0EOoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0XomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@;ok^k^01KogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0:_oMgMgo
k^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@7ok^k^003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^0002onk^kP0_omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h00ooMgMgok^k^omgMg@02onk^kP0@omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^027ogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0:ooMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgo
k^k^onk^k_oMgMgok^k^omgMg@;ok^k^01;ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0QomgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM
0_o^k^h03_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM0_o^k^h05OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^
k^kogMgM0_o^k^h08OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0ComgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0WomgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^
k_oMgMd2onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP0EomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^05?ogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP0;omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h08OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM
0_o^k^h0>?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooM
gMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgM
g@02onk^kP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00
01Kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgM
g@;ok^k^00cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^
kP0AomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h03?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@;ok^k^063ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP1?omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h08OoMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06
omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h03ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^017o
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP08omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^
k^kok^k^omgMgOo^k^kogMgM0_o^k^h0;?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h03_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h06OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP03omgMgOo^k^kogMgM00;ok^k^00_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP0MomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h0>_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd2onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h06?oMgMgok^k^onk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^0002onk^kP0UomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP0]omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
01SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;o
k^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM
0_o^k^h05OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0IomgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^ko
gMgMonk^k_oMgMd2onk^kP0WomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
027ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0bomgMgOo^k^kok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd2onk^kP0[omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP03omgMgOo^k^kogMgM00;ok^k^02_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgM
g@;ok^k^01;ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oM
gMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^03?ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
:_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00KogMgM
onk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0:omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@;ok^k^02?ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP7ogMgM003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^00001_o^k^kogMgMonk^k_oMgMgok^k^
omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP1PomgMgOo^k^kok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^03gogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgM
onk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0[omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0AooM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^03[ogMgMonk^k_o^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgM
g@02onk^kP0?omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03_oMgMgok^k^onk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP1IomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^02Oo
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0@_oMgMgok^k^onk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@7ok^k^003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;o
k^k^0002onk^kP0GomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h04ooMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd0
0_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h05ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^02gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00kogMgMonk^
k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^02?ogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP0TomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h06_oMgMgok^k^onk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0?omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgM
onk^k_oMgMd00_o^k^h02?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h06ooMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0YomgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h02OoMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP19omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd0
0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00Ko
gMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0`omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgM
g@02onk^kP08omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^
omgMgOo^k^kogMgM0_o^k^h1omgMg@7ok^k^0Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooo
oh;ooooo003oonk^k_ook^k^P_o^k^h0000Nonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^
k^kogMgM00;ok^k^06WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h05ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
02?ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0YomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0PomgMgOo^k^kok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgM
gOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0;ooMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^
k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0AooMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00[ogMgMonk^k_o^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;o
k^k^01KogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP06
omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h09OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0]omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h02_oMgMgo
k^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0PomgMgOo^k^kok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP000_o^k^h01OoMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^ko
gMgM00;ok^k^03GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0;omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgo
k^k^omgMg@;ok^k^01[ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;o
k^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM
0_o^k^h0<_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^
k^kok^k^omgMgOo^k^kogMgM0_o^k^h0:OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^02GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01oogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^00?ogMgMonk^k_oMgMd00_o^k^h0>ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h07?oMgMgok^k^onk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP07omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP0WomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP15omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^01OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP03omgMgOo^k^kogMgM00;ok^k^03SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@;ok^k^0OoMgMd00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h0000Jonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^
kP0eomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h05OoMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP0komgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0PomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;o
k^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^
k_oMgMgok^k^omgMg@;ok^k^02GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01_ogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^
omgMg@02onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^01_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h00ooMgMgok^k^omgMg@02onk^kP0DomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^ko
k^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^017ogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP11omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgM
gOo^k^kogMgM00;ok^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^
k_o^k^kogMgMonk^k_oMgMd2onk^kP0>omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0GomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h0A?oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^0OoMgMd00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h000;ok^k^027ogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^
k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP1BomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0
1_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^
omgMg@;ok^k^02GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00gogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02GogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0>?oMgMgok^k^onk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0<omgMgOo^
k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h04OoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^04WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^013ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM0_o^k^h07OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0:OoMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^
omgMg@;ok^k^02gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^
k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h1omgMg@7ok^k^
0Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00006
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP0[omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP21omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02gogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooM
gMgok^k^omgMg@02onk^kP0DomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP07omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^
k_oMgMd2onk^kP0DomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0??oMgMgo
k^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^
00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0EomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^00cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0;
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^
omgMg@02onk^kP0NomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM0_o^k^h08OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;o
k^k^02;ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h000;ok^k^05?ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgM
g@;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^
omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0/omgMgOo^k^ko
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP08omgMgOo^
k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0BomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^
omgMg@02onk^kP0?omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0B?oMgMgok^k^onk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01GogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h08OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^ko
gMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01ooM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0ComgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP0QomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02;ogMgMonk^k_o^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0
9?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^03gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^0OoMgMd00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00014onk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd2onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^027ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h08ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01GogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0PomgMgOo^k^kok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0A
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h08?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0:ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h06?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h04OoM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0@ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0_omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02
onk^kP0ComgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
2?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h05ooMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^04WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM007ok^k^003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^00008_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgM
onk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oM
gMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h06OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
=ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^
k_oMgMgok^k^omgMg@;ok^k^02SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
0_o^k^h0;OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h02?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h02?oM
gMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;o
k^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP0JomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03
omgMgOo^k^kogMgM00;ok^k^05_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^
kP0IomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0GomgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h09OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0comgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00Ko
gMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
1_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^0OoMgMd1onk^kP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP000_o^k^h00ooMgMgok^k^omgMg@02onk^kP06
omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0komgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0;omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0GOoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP0ComgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0@omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00GogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP1UomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^
k^h08ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^00cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h02ooMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h06_oMgMgok^k^onk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h08OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM
00;ok^k^01OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM
00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^ko
gMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^02;ogMgMonk^k_o^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0Oo^
k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0001@onk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^01_ogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP06
omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^
00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^
k^h05OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^
omgMg@;ok^k^00oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h05?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h06ooMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0gomgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0=omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
6ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgM
gOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h06OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h07ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h05ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^01cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0?omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0GomgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0oomgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00?ogMgMonk^k_o^k^h00OoMgMd00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;o
oooo003oonk^k_ook^k^P_o^k^h000;ok^k^03oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h02?oMgMgok^k^onk^
k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0DOoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP09
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00WogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h06ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP0EomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00WogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h02ooMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0:OoMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^
k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01WogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP1NomgMgOo^k^ko
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@;ok^k^01gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP0ComgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0[omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP13omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM007ok^k^
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^00007?o^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^
k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;o
k^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^02?ogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP0eomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0EOoMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h04ooMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oM
gMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0>?oMgMgok^k^onk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0>ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02GogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^03CogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0:OoMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^03kogMgMonk^k_o^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^
k_oMgMd00_o^k^h04?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd2onk^kP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP0000Cok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^
omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP10omgMgOo^k^kok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;o
k^k^00?ogMgMonk^k_oMgMd00_o^k^h06OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0oomgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03?oMgMgok^k^onk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00;ok^k^02[ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^
kP0gomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^ko
gMgM00;ok^k^03OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00Ko
gMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
1_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM
0_o^k^h00ooMgMgok^k^omgMg@02onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h05_oMgMgo
k^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^
k^kogMgMonk^k_oMgMd2onk^kP0>omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00oogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^
onk^k_oMgMgok^k^omgMg@;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP05omgMgOo^k^ko
gMgMonk^k_oMgMd00_o^k^h05_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^
k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;o
k^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00SogMgM
onk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01[ogMgMonk^k_o^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@;ok^k^0OoMgMd1onk^kP7ok^k^003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^0002onk^kP1?omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP0MomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP09omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2
onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgM
g@;ok^k^00_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP08
omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^ko
gMgM0_o^k^h04OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^01GogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooM
gMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h02ooMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^04gogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP06omgM
gOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h05?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgo
k^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0DooMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^01_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h04ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0;OoMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP13omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@01
onk^kP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP0003co
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2
onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP1JomgM
gOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^
k^h0<OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h08OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP09omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h09_oMgMgo
k^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP3oomgMgOo^
k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^000GomgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h0000Jonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^
k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgo
k^k^omgMg@;ok^k^02OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oM
gMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^01KogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^
k^h0;OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@02onk^kP0IomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0E
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^02gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^
omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^
k^kogMgM0_o^k^h06?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00KogMgM
onk^k_o^k^kogMgMonk^k_oMgMd2onk^kP1;omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h05?oMgMgo
k^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP0;omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0FomgMgOo^
k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h03OoMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgM
g@02onk^kP0FomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^
k^h02ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgM
onk^k_oMgMd00_o^k^h05_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^ko
gMgM00;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^ko
gMgM00;ok^k^00SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00[ogMgMonk^k_o^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@01onk^kP00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP000_o^k^h00ooMgMgo
k^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oM
gMgok^k^omgMg@;ok^k^03_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^01[ogMgMonk^k_o^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^
kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00WogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP07omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00cogMgMonk^k_o^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP09omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^
k^kogMgM00;ok^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00WogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0LOoMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;o
k^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0AomgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^
omgMg@02onk^kP0@omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@;ok^k^01KogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oM
gMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h04ooMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0@omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01KogMgMonk^k_o^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00gogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oM
gMd00_o^k^h0:ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h1omgMg@00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP0003cok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP03omgMgOo^k^kogMgM00;ok^k^03gogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01OogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP0EomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01OogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP0EomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^01Oo
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP1;omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^ko
gMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01ooMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgM
gOo^k^kogMgM0_o^k^h0oooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@001_o^k^kogMgMonk^k_oMgMgok^k^omgMg@7ok^k^003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^0000ooo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^kP00;ooMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^
k^h0oooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@00:_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^
00?ogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP08omgMgOo^k^kok^k^omgMgOo^
k^kogMgMonk^k_oMgMd2onk^kP7ogMgM003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^0002onk^kP0EomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgM
onk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP0:omgMgOo^k^kok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0TomgMgOo^
k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM0_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgM
gOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd0
0_o^k^h01ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgo
k^k^omgMg@;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01OoMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^
k_o^k^kogMgMonk^k_oMgMd2onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01ooMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00Go
gMgMonk^k_oMgMgok^k^omgMg@02onk^kP07omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oM
gMd2onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01ooMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00SogMgMonk^k_o^k^kogMgM
onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0IomgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^
01cogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0
5ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h0
3OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h0
0ooMgMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h02ooMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^
k^h04?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h04?oMgMgok^k^onk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgM
gOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h02ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^
omgMg@;ok^k^00_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^
kP03omgMgOo^k^kogMgM00;ok^k^013ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;o
k^k^013ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00_ogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00Ko
gMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0JomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd2onk^kP7ogMgM0Oo^k^h00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;o
oooo003oonk^k_ook^k^P_o^k^h00006onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgo
k^k^onk^k_oMgMgok^k^omgMg@;ok^k^033ogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgM
gOo^k^kogMgM0_o^k^h01ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^
omgMg@02onk^kP3iomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgM
onk^k_oMgMd00_o^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP09
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^
k^h01ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h03ooMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0HomgMgOo^k^kok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h05?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h06?oM
gMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^01CogMgMonk^k_o^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@;ok^k^01SogMgMonk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP0DomgMgOo^k^ko
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd2onk^kP0HomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0
5?oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h0<_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0Oo^k^h00?ook^k^
ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h000;ok^k^0?oogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd005[ok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^
kP3oomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM000Jonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP05omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h1omgMg@00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP0001[ok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
00?ogMgMonk^k_oMgMd00_o^k^h07OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM00;ok^k^0<oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP05omgMgOo^k^kogMgMonk^k_oM
gMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oM
gMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^02GogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM00;ok^k^0?oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00cogMgM
onk^k_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP7ogMgM0Oo^k^h0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h000;ok^k^00?o
gMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgo
k^k^omgMg@02onk^kP0KomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0:omgMgOo^k^kok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^017ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;o
k^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP03omgMgOo^k^kogMgM00;ok^k^00?ogMgM
onk^k_oMgMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^ko
gMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^
k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^ko
k^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^
k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgo
k^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgM
gOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00Ko
gMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h0
1_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^
kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;o
k^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM
0_o^k^h0:ooMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd0
0_o^k^h00ooMgMgok^k^omgMg@02onk^kP08omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMd2
onk^kP03omgMgOo^k^kogMgM00;ok^k^00OogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^
00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h01OoMgMgok^k^omgMgOo^
k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00_o^k^h00ooMgMgok^k^omgMg@02onk^kP06omgMgOo^
k^kok^k^omgMgOo^k^kogMgM0_o^k^h02_oMgMgok^k^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgo
k^k^omgMg@;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^
00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0:omgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^ko
k^k^omgMgOo^k^kogMgM0_o^k^h01OoMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00?ogMgMonk^k_oM
gMd00_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00[ogMgMonk^k_o^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgM0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00Ko
gMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd00_o^k^h00ooM
gMgok^k^omgMg@02onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h02_oMgMgok^k^onk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM
0_o^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgMg@;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP03omgMgOo^k^kogMgM00;ok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd2onk^kP0:omgM
gOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@;ok^k^00KogMgMonk^k_o^k^kogMgM
onk^k_oMgMd2onk^kP06omgMgOo^k^kok^k^omgMgOo^k^kogMgM0_o^k^h07OoMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM007ok^k^003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^00008_o^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd2
onk^kP0[omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02
onk^kP3oomgMgOo^k^kok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^003oomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgM000^onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@;ok^k^0OoMgMd00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h0000Lonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMg@;ok^k^02_ogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00;ok^k^0?oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd001[ok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMg@;ok^k^0?oogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMd001[ok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^
k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@7ok^k^003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^0000
3_o^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM0_o^
k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP0OomgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@02onk^kP3N
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^0_oMgMd06Oo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^h00_oMgMd02Oo^k^kogMgMonk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^kP02omgMg@03onk^k_oMgMgok^k^00;ogMgM00Wok^k^omgMgOo^k^ko
gMgMonk^k_oMgMgok^k^omgMgOo^k^h00_oMgMd00oo^k^kogMgMonk^kP02omgMg@0Donk^k_oMgMgo
k^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^ko
gMgMonk^k_oMgMd2onk^kP3oomgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^
k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oM
gMgok^k^omgMgOo^k^kogMgM000:onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgM
g@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h1omgMg@7ok^k^003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^0005onk^kP03omgMgOo^k^kok^k^00Cok^k^00Co
gMgMonk^k_o^k^kogMgM0_o^k^h00ooMgMgok^k^onk^kP03onk^kP05omgMgOo^k^kogMgMonk^k_oM
gMd00oo^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP03omgMgOo^k^kok^k^00Gok^k^00GogMgMonk^
k_o^k^kok^k^omgMg@05onk^kP05omgMgOo^k^kogMgMonk^k_oMgMd01?o^k^h01OoMgMgok^k^onk^
k_o^k^kogMgM00;ok^k^00?ogMgMonk^k_oMgMd00oo^k^h01_oMgMgok^k^onk^k_oMgMgok^k^omgM
g@?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^omgMg@03onk^kP03omgMgOo^k^kok^k^
00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kogMgM
00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^omgMg@03onk^kP03omgMgOo^k^kok^k^
00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kogMgM
00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^omgMg@03onk^kP03omgMgOo^k^kok^k^
00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kogMgM
00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^omgMg@03onk^kP03omgMgOo^k^kok^k^
00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kogMgM
00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^omgMg@03onk^kP03omgMgOo^k^kok^k^
00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kogMgM
00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^omgMg@03onk^kP03omgMgOo^k^kok^k^
00Wok^k^00?ogMgMonk^k_o^k^h01oo^k^h00ooMgMgok^k^onk^kP0=onk^kP03omgMgOo^k^kok^k^
00cok^k^00?ogMgMonk^k_o^k^h02_o^k^h00ooMgMgok^k^onk^kP04onk^kP03omgMgOo^k^kogMgM
00Gok^k^00KogMgMonk^k_o^k^kogMgMonk^k_oMgMd3onk^kP03omgMgOo^k^kok^k^00;ok^k^00?o
gMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgMg@04onk^kP03omgMgOo^k^kogMgM00?ok^k^00?o
gMgMonk^k_o^k^h00_o^k^h00ooMgMgok^k^omgMg@03onk^kP03omgMgOo^k^kogMgM00Cok^k^00?o
gMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^onk^kP02onk^kP03omgMgOo^k^kogMgM00?ok^k^00?o
gMgMonk^k_oMgMd01?o^k^h00ooMgMgok^k^omgMg@03onk^kP03omgMgOo^k^kok^k^00;ok^k^00?o
gMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgMg@04onk^kP03omgMgOo^k^kogMgM00?ok^k^00?o
gMgMonk^k_o^k^h00_o^k^h00ooMgMgok^k^omgMg@03onk^kP03omgMgOo^k^kogMgM00Cok^k^00?o
gMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^onk^kP02onk^kP03omgMgOo^k^kogMgM00?ok^k^00?o
gMgMonk^k_oMgMd01?o^k^h00ooMgMgok^k^omgMg@03onk^kP03omgMgOo^k^kok^k^00;ok^k^00?o
gMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgMg@04onk^kP03omgMgOo^k^kogMgM00?ok^k^00?o
gMgMonk^k_o^k^h00_o^k^h00ooMgMgok^k^omgMg@03onk^kP03omgMgOo^k^kogMgM00Cok^k^00?o
gMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^onk^kP02onk^kP03omgMgOo^k^kogMgM00?ok^k^00?o
gMgMonk^k_oMgMd01?o^k^h00ooMgMgok^k^omgMg@03onk^kP03omgMgOo^k^kok^k^00;ok^k^00?o
gMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgMg@04onk^kP03omgMgOo^k^kogMgM00?ok^k^00?o
gMgMonk^k_o^k^h00_o^k^h00ooMgMgok^k^omgMg@07onk^kP03omgMgOo^k^kok^k^00;ok^k^00?o
gMgMonk^k_oMgMd00_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP0000?oR8R8ogMgMomgMgL00_mg
MgL00on8R8SoMgMgogMgM`04ogMgM`04ohR8R?mgMgOoMgMgohR8R0;oMgMg00?oR8R8ogMgMomgMgL0
0omgMgL01On8R8SoMgMgohR8R?mgMgOoR8R800?oMgMg00CoR8R8ogMgMomgMgOoR8R80_mgMgL00on8
R8SoMgMgohR8R005ogMgM`05ohR8R?mgMgOoMgMgogMgMon8R8P01OmgMgL01on8R8SoMgMgohR8R?mg
MgOoR8R8ogMgMon8R8P00_mgMgL01On8R8SoMgMgogMgMomgMgOoR8R800;oMgMg00OoR8R8ogMgMon8
R8SoMgMgohR8R?mgMgOoR8R800;oMgMg00?oR8R8ogMgMon8R8P00omgMgL01?n8R8SoMgMgogMgMon8
R8P2ogMgM`03ohR8R?mgMgOoR8R800?oMgMg00CoR8R8ogMgMomgMgOoR8R80_mgMgL00on8R8SoMgMg
ohR8R003ogMgM`04ohR8R?mgMgOoMgMgohR8R0;oMgMg00?oR8R8ogMgMon8R8P00omgMgL01?n8R8So
MgMgogMgMon8R8P2ogMgM`03ohR8R?mgMgOoR8R800?oMgMg00CoR8R8ogMgMomgMgOoR8R80_mgMgL0
0on8R8SoMgMgohR8R003ogMgM`04ohR8R?mgMgOoMgMgohR8R0;oMgMg00?oR8R8ogMgMon8R8P00omg
MgL01?n8R8SoMgMgogMgMon8R8P2ogMgM`03ohR8R?mgMgOoR8R800?oMgMg00CoR8R8ogMgMomgMgOo
R8R80_mgMgL00on8R8SoMgMgohR8R003ogMgM`04ohR8R?mgMgOoMgMgohR8R0;oMgMg00?oR8R8ogMg
Mon8R8P00omgMgL01?n8R8SoMgMgogMgMon8R8P2ogMgM`03ohR8R?mgMgOoR8R800?oMgMg00CoR8R8
ogMgMomgMgOoR8R80_mgMgL00on8R8SoMgMgohR8R003ogMgM`04ohR8R?mgMgOoMgMgohR8R0;oMgMg
00?oR8R8ogMgMon8R8P00omgMgL01?n8R8SoMgMgogMgMon8R8P2ogMgM`03ohR8R?mgMgOoR8R800?o
MgMg00CoR8R8ogMgMomgMgOoR8R80_mgMgL00on8R8SoMgMgohR8R003ogMgM`04ohR8R?mgMgOoMgMg
ohR8R0;oMgMg00?oR8R8ogMgMon8R8P00omgMgL01?n8R8SoMgMgogMgMon8R8P2ogMgM`03ohR8R?mg
MgOoR8R800?oMgMg00CoR8R8ogMgMomgMgOoR8R82?mgMgL00on8R8SoMgMgogMgM`07ogMgM`03ohR8
R?mgMgOoMgMg00koMgMg00?oR8R8ogMgMomgMgL02omgMgL00on8R8SoMgMgogMgM`0;ogMgM`03ohR8
R?mgMgOoMgMg00?oMgMg00?oR8R8ogMgMon8R8P01OmgMgL03?n8R8SoMgMgogMgMon8R8SoMgMgohR8
R?mgMgOoR8R8ogMgMon8R8SoMgMgohR8R0;oMgMg00_oR8R8ogMgMon8R8SoMgMgohR8R?mgMgOoR8R8
ogMgMon8R8SoMgMgohR8R002ogMgM`09ohR8R?mgMgOoR8R8ogMgMon8R8SoMgMgohR8R?mgMgOoR8R8
00;oMgMg00_oR8R8ogMgMon8R8SoMgMgohR8R?mgMgOoR8R8ogMgMon8R8SoMgMgohR8R002ogMgM`09
ohR8R?mgMgOoR8R8ogMgMon8R8SoMgMgohR8R?mgMgOoR8R800;oMgMg00_oR8R8ogMgMon8R8SoMgMg
ohR8R?mgMgOoR8R8ogMgMon8R8SoMgMgohR8R002ogMgM`09ohR8R?mgMgOoR8R8ogMgMon8R8SoMgMg
ohR8R?mgMgOoR8R800;oMgMg00_oR8R8ogMgMon8R8SoMgMgohR8R?mgMgOoR8R8ogMgMon8R8SoMgMg
ohR8R002ogMgM`09ohR8R?mgMgOoR8R8ogMgMon8R8SoMgMgohR8R?mgMgOoR8R800;oMgMg00_oR8R8
ogMgMon8R8SoMgMgohR8R?mgMgOoR8R8ogMgMon8R8SoMgMgohR8R002ogMgM`09ohR8R?mgMgOoR8R8
ogMgMon8R8SoMgMgohR8R?mgMgOoR8R800;oMgMg00_oR8R8ogMgMon8R8SoMgMgohR8R?mgMgOoR8R8
ogMgMon8R8SoMgMgohR8R002ogMgM`09ohR8R?mgMgOoR8R8ogMgMon8R8SoMgMgohR8R?mgMgOoR8R8
00;oMgMg00_oR8R8ogMgMon8R8SoMgMgohR8R?mgMgOoR8R8ogMgMon8R8SoMgMgohR8R002ogMgM`09
ohR8R?mgMgOoR8R8ogMgMon8R8SoMgMgohR8R?mgMgOoR8R800;oMgMg00_oR8R8ogMgMon8R8SoMgMg
ohR8R?mgMgOoR8R8ogMgMon8R8SoMgMgohR8R002ogMgM`09ohR8R?mgMgOoR8R8ogMgMon8R8SoMgMg
ohR8R?mgMgOoR8R800;oMgMg00_oR8R8ogMgMon8R8SoMgMgohR8R?mgMgOoR8R8ogMgMon8R8SoMgMg
ohR8R002ogMgM`09ohR8R?mgMgOoR8R8ogMgMon8R8SoMgMgohR8R?mgMgOoR8R800;oMgMg00_oR8R8
ogMgMon8R8SoMgMgohR8R?mgMgOoR8R8ogMgMon8R8SoMgMgohR8R002ogMgM`09ohR8R?mgMgOoR8R8
ogMgMon8R8SoMgMgohR8R?mgMgOoR8R800;oMgMg00?oR8R8ogMgMon8R8P01omgMgL00on8R8SoMgMg
ohR8R002ogMgM`03ohR8R?mgMgOoR8R800;oMgMg00CoR8R8ogMgMomgMgOoR8R80_mgMgL000;ok^k^
oooMgMeIomgMg@03olc<c?oMgMgogMgM0?oogMgM8_oMgMd2onk^kP0000Gok^k^omgMgOo^k^kogMgM
olc<c007omgMg@;oc<c<00?ogMgMolc<c?o<c<`00_o<c<`5omgMg@04olc<c?oMgMgogMgMolc<c0Co
gMgM00?oc<c<omgMgOoMgMd01_o<c<`5omgMg@03olc<c?oMgMgogMgM00OogMgM1oo<c<`6omgMg@04
olc<c?oMgMgogMgMolc<c0;ogMgM00Coc<c<omgMgOoMgMgoc<c<0ooMgMd00oo<c<cogMgMomgMg@02
omgMg@04olc<c?oMgMgogMgMolc<c0?ogMgM00?oc<c<omgMgOoMgMd00_oMgMd01?o<c<cogMgMomgM
gOo<c<`3omgMg@03olc<c?oMgMgogMgM00;ogMgM00Coc<c<omgMgOoMgMgoc<c<0ooMgMd00oo<c<co
gMgMomgMg@02omgMg@04olc<c?oMgMgogMgMolc<c0?ogMgM00?oc<c<omgMgOoMgMd00_oMgMd01?o<
c<cogMgMomgMgOo<c<`3omgMg@03olc<c?oMgMgogMgM00;ogMgM00Coc<c<omgMgOoMgMgoc<c<0ooM
gMd00oo<c<cogMgMomgMg@02omgMg@04olc<c?oMgMgogMgMolc<c0?ogMgM00?oc<c<omgMgOoMgMd0
0_oMgMd01?o<c<cogMgMomgMgOo<c<`3omgMg@03olc<c?oMgMgogMgM00;ogMgM00Coc<c<omgMgOoM
gMgoc<c<0ooMgMd00oo<c<cogMgMomgMg@02omgMg@04olc<c?oMgMgogMgMolc<c0?ogMgM00?oc<c<
omgMgOoMgMd00_oMgMd01?o<c<cogMgMomgMgOo<c<`3omgMg@03olc<c?oMgMgogMgM00;ogMgM00Co
c<c<omgMgOoMgMgoc<c<0ooMgMd00oo<c<cogMgMomgMg@02omgMg@04olc<c?oMgMgogMgMolc<c0?o
gMgM00?oc<c<omgMgOoMgMd00_oMgMd01?o<c<cogMgMomgMgOo<c<`3omgMg@03olc<c?oMgMgogMgM
00;ogMgM00Coc<c<omgMgOoMgMgoc<c<0ooMgMd00oo<c<cogMgMomgMg@02omgMg@04olc<c?oMgMgo
gMgMolc<c0?ogMgM00?oc<c<omgMgOoMgMd00_oMgMd01?o<c<cogMgMomgMgOo<c<`4omgMg@05olc<
c?oMgMgoc<c<omgMgOo<c<`06_oMgMd00oo<c<cogMgMomgMg@0;omgMg@03olc<c?oMgMgogMgM00So
gMgM1Oo<c<`00ooMgMgoc<c<omgMg@02omgMg@03olc<c?oMgMgogMgM00?ogMgM00Goc<c<omgMgOoM
gMgogMgMolc<c002omgMg@03olc<c?oMgMgoc<c<00;ogMgM00Goc<c<omgMgOoMgMgogMgMolc<c002
omgMg@03olc<c?oMgMgoc<c<00;ogMgM00Goc<c<omgMgOoMgMgogMgMolc<c002omgMg@03olc<c?oM
gMgoc<c<00;ogMgM00Goc<c<omgMgOoMgMgogMgMolc<c002omgMg@03olc<c?oMgMgoc<c<00;ogMgM
00Goc<c<omgMgOoMgMgogMgMolc<c002omgMg@03olc<c?oMgMgoc<c<00;ogMgM00Goc<c<omgMgOoM
gMgogMgMolc<c002omgMg@03olc<c?oMgMgoc<c<00;ogMgM00Goc<c<omgMgOoMgMgogMgMolc<c002
omgMg@03olc<c?oMgMgoc<c<00;ogMgM00Goc<c<omgMgOoMgMgogMgMolc<c002omgMg@03olc<c?oM
gMgoc<c<00;ogMgM00Goc<c<omgMgOoMgMgogMgMolc<c002omgMg@03olc<c?oMgMgoc<c<00;ogMgM
00Goc<c<omgMgOoMgMgogMgMolc<c002omgMg@03olc<c?oMgMgoc<c<00;ogMgM00Goc<c<omgMgOoM
gMgogMgMolc<c002omgMg@03olc<c?oMgMgoc<c<00;ogMgM00Goc<c<omgMgOoMgMgogMgMolc<c002
omgMg@03olc<c?oMgMgoc<c<00;ogMgM00Goc<c<omgMgOoMgMgogMgMolc<c002omgMg@03olc<c?oM
gMgoc<c<00;ogMgM00Goc<c<omgMgOoMgMgogMgMolc<c002omgMg@03olc<c?oMgMgoc<c<00;ogMgM
00Goc<c<omgMgOoMgMgogMgMolc<c002omgMg@03olc<c?oMgMgoc<c<00;ogMgM00Goc<c<omgMgOoM
gMgogMgMolc<c002omgMg@03olc<c?oMgMgoc<c<00;ogMgM00Goc<c<omgMgOoMgMgogMgMolc<c002
omgMg@03olc<c?oMgMgoc<c<00;ogMgM00Goc<c<omgMgOoMgMgogMgMolc<c002omgMg@03olc<c?oM
gMgoc<c<00;ogMgM00Goc<c<omgMgOoMgMgogMgMolc<c002omgMg@03olc<c?oMgMgoc<c<00;ogMgM
00Goc<c<omgMgOoMgMgogMgMolc<c002omgMg@03olc<c?oMgMgoc<c<00;ogMgM00Goc<c<omgMgOoM
gMgogMgMolc<c002omgMg@03olc<c?oMgMgoc<c<00;ogMgM00Goc<c<omgMgOoMgMgogMgMolc<c008
omgMg@03olc<c?oMgMgoc<c<00?ogMgM00?oc<c<omgMgOoMgMd00ooMgMd00oo<c<cogMgMonk^kP01
onk^kP000_o^k^h2omgMg@03onk^k_oMgMgogMgM00CogMgM0_o<c<`00onk^k_oZZZZok^k^`02ok^k
^`;oc<c<1?oMgMd01?o^k^kogMgMomgMgOo^k^h5omgMg@;oc<c<1Onk^k/2olc<c0?ogMgM00?ok^k^
omgMgOoMgMd02?oMgMd01?o<c<co^k^kok^k^onZZZX2ok^k^`;oc<c<1OoMgMd01?o^k^kogMgMomgM
gOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kP?ogMgM00Kok^k^omgMgOoMgMgok^k^omgMgOo^k^h2
omgMg@05onk^k_oMgMgogMgMomgMgOo^k^h00_oMgMd00oo^k^kogMgMonk^kP02omgMg@05onk^k_oM
gMgogMgMomgMgOo^k^h00_oMgMd00oo^k^kogMgMonk^kP02omgMg@05onk^k_oMgMgogMgMomgMgOo^
k^h00_oMgMd00oo^k^kogMgMonk^kP02omgMg@05onk^k_oMgMgogMgMomgMgOo^k^h00_oMgMd00oo^
k^kogMgMonk^kP02omgMg@05onk^k_oMgMgogMgMomgMgOo^k^h00_oMgMd00oo^k^kogMgMonk^kP02
omgMg@05onk^k_oMgMgogMgMomgMgOo^k^h00_oMgMd00oo^k^kogMgMonk^kP02omgMg@05onk^k_oM
gMgogMgMomgMgOo^k^h00_oMgMd00oo^k^kogMgMonk^kP02omgMg@05onk^k_oMgMgogMgMomgMgOo^
k^h00_oMgMd00oo^k^kogMgMonk^kP02omgMg@05onk^k_oMgMgogMgMomgMgOo^k^h00_oMgMd00oo^
k^kogMgMonk^kP02omgMg@05onk^k_oMgMgogMgMomgMgOo^k^h00_oMgMd00oo^k^kogMgMonk^kP02
omgMg@05onk^k_oMgMgogMgMomgMgOo^k^h00_oMgMd00oo^k^kogMgMonk^kP02omgMg@05onk^k_oM
gMgogMgMomgMgOo^k^h00_oMgMd00oo^k^kogMgMonk^kP02omgMg@05onk^k_oMgMgogMgMomgMgOo^
k^h00_oMgMd00oo^k^kogMgMonk^kP02omgMg@05onk^k_oMgMgogMgMomgMgOo^k^h00_oMgMd00oo^
k^kogMgMonk^kP02omgMg@05onk^k_oMgMgogMgMomgMgOo^k^h00_oMgMd00oo^k^kogMgMonk^kP02
omgMg@05onk^k_oMgMgogMgMomgMgOo^k^h00_oMgMd00oo^k^kogMgMonk^kP02omgMg@03onk^k_oM
gMgogMgM00?ogMgM00?oc<c<omgMgOoMgMd0=OoMgMd01?o<c<cogMgMomgMgOo<c<`5omgMg@04onk^
k_oMgMgogMgMonk^kP;ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP02omgMg@03onk^k_oMgMgok^k^
00;ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP02omgMg@03onk^k_oMgMgok^k^00;ogMgM00Gok^k^
omgMgOoMgMgogMgMonk^kP02omgMg@03onk^k_oMgMgok^k^00;ogMgM00Gok^k^omgMgOoMgMgogMgM
onk^kP02omgMg@03onk^k_oMgMgok^k^00;ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP02omgMg@03
onk^k_oMgMgok^k^00;ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP02omgMg@03onk^k_oMgMgok^k^
00;ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP02omgMg@03onk^k_oMgMgok^k^00;ogMgM00Gok^k^
omgMgOoMgMgogMgMonk^kP02omgMg@03onk^k_oMgMgok^k^00;ogMgM00Gok^k^omgMgOoMgMgogMgM
onk^kP02omgMg@03onk^k_oMgMgok^k^00;ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP02omgMg@03
onk^k_oMgMgok^k^00;ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP02omgMg@03onk^k_oMgMgok^k^
00;ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP02omgMg@03onk^k_oMgMgok^k^00;ogMgM00Gok^k^
omgMgOoMgMgogMgMonk^kP02omgMg@03onk^k_oMgMgok^k^00;ogMgM00Gok^k^omgMgOoMgMgogMgM
onk^kP02omgMg@03onk^k_oMgMgok^k^00;ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP02omgMg@03
onk^k_oMgMgok^k^00;ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP02omgMg@03onk^k_oMgMgok^k^
00;ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP02omgMg@03onk^k_oMgMgok^k^00;ogMgM00Gok^k^
omgMgOoMgMgogMgMonk^kP02omgMg@03onk^k_oMgMgok^k^00;ogMgM00Gok^k^omgMgOoMgMgogMgM
onk^kP02omgMg@03onk^k_oMgMgok^k^00;ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP02omgMg@03
onk^k_oMgMgok^k^00;ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP02omgMg@03onk^k_oMgMgok^k^
00;ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP05omgMg@06onk^k_oMgMgogMgMonk^k_oMgMgok^k^
0ooMgMd00oo^k^kogMgMomgMg@03omgMg@03onk^k_oMgMgok^k^007ok^k^000:onk^kP03omgMgOo<
c<coZZZZ00;oR8R800KoVFIVogMgMon8R8SoZZZZok^k^ooMgMd;onk^kP05omgMgOo<c<coVIVIoiVI
VOmVIYT00_mgMgL01?n8R8SoZZZZolc<c?o<c<`4onk^kP03ooooooo^k^kok^k^00Cok^k^00[ogMgM
ok^k^onZZZ[oR8R8ogMgMon8R8SoMgMgohR8R?nZZZ[oc<c<0_oMgMd00oo^k^koooooonk^kP3Konk^
kP?ogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd5onk^kP03omgMgOo^k^kok^k^00?ok^k^00CogMgM
onk^k_o^k^kogMgM0oo^k^h00ooMgMgok^k^onk^kP0Ionk^kP06ojZZZ_mgMgOoIVIVofIVI_nk^k_o
gMgMooo^k^h?onk^kP03ooooooo^k^kok^k^00cok^k^00?oooooonk^k_o^k^h00oo^k^h00004oooo
ooo^k^kogMgMonk^kP;ogMgM00Ook^k^omgMgOo^k^koc<c<ojZZZ_n8R8SoIVIV00;oA4A400Ko<c=V
odA4A?mEEEGoIVIVohR8R?nZZZX2omgMg@03onk^k_oMgMgok^k^00;ogMgM0_o^k^h01OoMgMgoc<c<
ok^k^on8R8SoIVIV00GoA4A400CoIVIVohR8R?nk^k_oc<c<0_oMgMd00oo^k^kogMgMomgMg@02onk^
kP?ogMgM00?oZZZZoiVIVOmEEED00_mEEED01_lc<c?oA4A4oeEEEOmVIVKoVIVIojZZZP?ogMgM00Ko
k^k^omgMgOo^k^kok^k^omgMgOo^k^h2omgMg@;ok^k^0_oMgMd2onk^kP04omgMgOo^k^kogMgMonk^
kP;ogMgM0_o^k^h2omgMg@;ok^k^00CogMgMonk^k_oMgMgok^k^0_oMgMd2onk^kP;ogMgM0_o^k^h0
1?oMgMgok^k^omgMgOo^k^h2omgMg@;ok^k^0_oMgMd2onk^kP04omgMgOo^k^kogMgMonk^kP;ogMgM
0_o^k^h2omgMg@;ok^k^00CogMgMonk^k_oMgMgok^k^0_oMgMd2onk^kP;ogMgM0_o^k^h01?oMgMgo
k^k^omgMgOo^k^h2omgMg@;ok^k^0_oMgMd2onk^kP04omgMgOo^k^kogMgMonk^kP;ogMgM0_o^k^h2
omgMg@;ok^k^00CogMgMonk^k_oMgMgok^k^0_oMgMd2onk^kP;ogMgM0_o^k^h01?oMgMgok^k^omgM
gOo^k^h2omgMg@;ok^k^0_oMgMd2onk^kP04omgMgOo^k^kogMgMonk^kP;ogMgM0_o^k^h2omgMg@;o
k^k^00CogMgMonk^k_oMgMgok^k^0_oMgMd2onk^kP;ogMgM0_o^k^h01?oMgMgok^k^omgMgOo^k^h2
omgMg@;ok^k^0_oMgMd2onk^kP04omgMgOo^k^kogMgMonk^kP;ogMgM0_o^k^h2omgMg@;ok^k^00Co
gMgMonk^k_oMgMgok^k^0_oMgMd2onk^kP;ogMgM0_o^k^h01?oMgMgok^k^omgMgOo^k^h2omgMg@;o
k^k^0_oMgMd2onk^kP04omgMgOo^k^kogMgMonk^kP;ogMgM0_o^k^h2omgMg@;ok^k^00CogMgMonk^
k_oMgMgok^k^0_oMgMd2onk^kP08omgMgOo^k^kogMgMonk^k_nk^k_o8R8RodA4A?nIVIT4omgMg@;o
c<c<00?ogMgMolc<c?oMgMd02OoMgMd02Oo<c<cogMgMolc<c?oMgMgoc<c<omgMgOo<c<cogMgMolc<
c005omgMg@05olc<c?oMgMgogMgMomgMgOo<c<`04?oMgMd02omgMgOoIVIVohR8R?mEEEGo0000ojZZ
Z_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgM
gOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;o
k^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgM
gOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;o
k^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgM
gOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;o
k^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgM
gOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;o
k^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^
k_oMgMgok^k^omgMg@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgM
g@02onk^kP03omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP03omgM
gOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgMg@02onk^kP04omgMgOo^k^kogMgMonk^
kP;ogMgM00gok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
00;ogMgM1?o^k^h000?ok^k^0_oMgMd04_o^k^kogMgMomgMgOo<c<co^k^koiVIVOmEEEGoIS<coiUV
<oo<IVKoc9UVolaVI_nIIS?oIS<coeEEEOn8R8So^k^kolc<c0CogMgM00Wok^k^omgMgOoMgMgoc<c<
ok^k^on8R8SoEEEEofIV<onIVC<00oo<c3<01OnIVC?oIVHcoeEEEOn8R8So^k^k00CogMgM01?ok^k^
omgMgOoMgMgogMgMolc<c?nk^k_oR8R8oeEEEOlcIS?oIYTcofK<<oo<c6KoVL`cofJI<olcIS?oA4A4
oiVII_nk^k_oc<c<00SogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP07omgMg@05onk^k_oMgMgogMgM
omgMgOo^k^h01ooMgMd01Oo^k^kogMgMomgMgOoMgMgok^k^00OogMgM00Gok^k^omgMgOoMgMgogMgM
onk^kP07omgMg@05onk^k_oMgMgogMgMomgMgOo^k^h01ooMgMd01Oo^k^kogMgMomgMgOoMgMgok^k^
00OogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP07omgMg@05onk^k_oMgMgogMgMomgMgOo^k^h01ooM
gMd01Oo^k^kogMgMomgMgOoMgMgok^k^00OogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP07omgMg@05
onk^k_oMgMgogMgMomgMgOo^k^h01ooMgMd01Oo^k^kogMgMomgMgOoMgMgok^k^00OogMgM00Gok^k^
omgMgOoMgMgogMgMonk^kP07omgMg@05onk^k_oMgMgogMgMomgMgOo^k^h01ooMgMd01Oo^k^kogMgM
omgMgOoMgMgok^k^00OogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP07omgMg@05onk^k_oMgMgogMgM
omgMgOo^k^h01ooMgMd00oo^k^kogMgMomgMg@04omgMg@07olc<c?nIVIWoVIVIoa4A4On8R8Soc<c<
omgMg@02olc<c004omgMgOo<c<coc<c<olc<c0;ogMgM0oo<c<`2omgMg@04olc<c?oMgMgoc<c<omgM
g@?oc<c<0_oMgMd02?o<c<co^k^kolc<c?oMgMgoc<c<omgMgOo<c<cogMgM0_o<c<`2omgMg@;oc<c<
0_oMgMd01_o<c<cogMgMomgMgOo<c<cogMgMolc<c0?ogMgM00?oc<c<omgMgOoMgMd00oo<c<`00ooM
gMgoA4A4oc<c<`3oomgMgA3ogMgM00Gok^k^omgMgOoMgMgogMgMonk^kP0:omgMg@04onk^k_oMgMgo
gMgMonk^kP7ooooo00000oooooook^k^omgMg@02onk^kP0OomgMgOo^k^kogMgMolc<c?nIVIWoEEEE
oiTc<oooIVKooiVIooo<VOooVIWoolbIoonIVOooIVKoVC<coeEEEOnZZZ[oc<c<omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo<c<coVIVIofIVI_nIIS?ool`cooooIP03ooooV@0CooooI_o<c3?oVFHc
ofIVI_nIVIWoc<c<onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_o<c<coVIVIofIVI_mVIS?oVOmV
olcoIP03olcoV@07olcoI_nIc6KoIYTcoc=VI_nZZZ[oc<c<omgMg@03onk^kP0;omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00oo^k^h02OoMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@03onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
00?ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00oo^k^h02OoMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@03onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgM00?ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00oo^
k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@03onk^kP09omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgM00?ok^k^00WogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMd00oo^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMg@03onk^kP09
omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00?ok^k^00WogMgMonk^k_oMgMgok^k^
omgMgOo^k^kogMgMonk^k_oMgMd00oo^k^h02OoMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMgok^k^
omgMg@03onk^kP09omgMgOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00?ok^k^00WogMgM
onk^k_oMgMgok^k^omgMgOo^k^kogMgMonk^k_oMgMd00oo^k^h02OoMgMgok^k^omgMgOo^k^kogMgM
onk^k_oMgMgok^k^omgMg@03onk^kP03omgMgOo^k^kogMgM00;ok^k^00CogMgMonk^k_oMgMgogMgM
0_o^k^h00ooMgMgoEEEEoeEEE@02omgMg@06odA4A?l0003o4A4AohR8R?lA4A7oA4A40_oMgMd00onI
VIWo0000oiVIV@03omgMg@07oc<c<ol0003o4A4AohR8R?lA4A7oEEEEok^k^`02o`0000;o8R8R00[o
MgMgomgMgOoMgMgoc<c<o`000?mVIVKogMgMolc<c?mEEEGo4A4A0ooMgMd01_mEEEGoA4A4onk^k_oM
gMgo8R8RohR8R0;ogMgM00[oMgMgoc<c<ooMgMgogMgMolc<c?mEEEGo<c<cofIVI_n8R8So8R8R0_oM
gMd3onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgM
g@03onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgM
g@03onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgM
g@03onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgM
g@03onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgM
g@03onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgM
g@03onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgM
g@03onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgM
g@03onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgM
g@03onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgM
g@03onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgM
g@03onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgM
g@03onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgM
g@03onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h00ooMgMgok^k^omgM
g@03onk^kP03omgMgOo^k^kogMgM00?ok^k^00?ogMgMonk^k_oMgMd00oo^k^h02ooMgMgok^k^omgM
gOo^k^kogMgMonk^k_oMgMgok^k^omgMgOo^k^kogMgM00;ok^k^00GogMgMonk^k_oMgMgok^k^omgM
g@04onk^kP0000Kok^k^ooooooooooooooooonk^k_ooool2onk^kP05olc<c?nIVIWoIS<coomVI_oo
VFH00_ooVIT02?ooc<coolbIoonIVOooVIWoc6IVoiTc<onIVIWoc<c<0_o^k^h00oooooook^k^oooo
o`02onk^kP07olc<c?n8R8SoVFHcolc<<oooc6KooonIooooIP03ooooV@0Cooo<I_ooc3?oVFHcohR8
R?o<c<cok^k^ooooooo^k^koooooonk^k_ooooook^k^olc<c?n8R8So<iTcofK<<onIc6Koc?nIolco
IP03olcoV@07olcoI_mVc3?oIVHcohR8R?o<c<cok^k^ooooo`02onk^kP3Aooooooo^k^koooooonk^
k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^oooo
ooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^
k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^oooo
ooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^
k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^oooo
ooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^
k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^oooo
ooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^
k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^oooo
ooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^
k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^oooo
ooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^
k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^oooo
ooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooool00_o^k^h5ooooo`;ok^k^00Wo
R8R8oa4A4Oo^k^koc<c<o`000?nk^k_ogMgMoeEEEOl000000oo^k^h00omEEEGo4A4Aoc<c<`02onk^
kP09ok^k^ol0003oc<c<olc<c?mEEEGo4A4Aonk^k_oMgMgoZZZZ00;ok^k^00Go^k^ko`000?nk^k_o
k^k^ok^k^`02oa4A4@;ok^k^00?o<c<co`000?nZZZX00_o^k^h0oomVIVKoEEEEonk^k_o^k^ko8R8R
ohR8R?o^k^koooooohR8R?lR8R;ok^k^oooooom4A4Co8R8RoiVIVOmgMgOo8R8Roa4A4Oo^k^kooooo
onk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^
ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^kooooo
onk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^
ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^kooooo
onk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^
ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^kooooo
onk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^
ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^kooooo
onk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^
ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^kooooo
onk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^
ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^kooooo
onk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^
ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^kooooo
onk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^
ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^kP00:?ooooook^k^ooooooo^k^ko
ooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_oooooo
k^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^koooooonk^k_ooooook^k^ooooooo^k^ko
ooooonk^k_ooooook^k^ooooooo^k^h4ooooo`09onk^k_ooooook^k^ooooooo^k^koooooonk^k_oo
ooook^k^007ooooo00000oooooook^k^onk^kP04onk^kP05omgMgOnk^k_oIVHcol`c<oo<IVH01_oo
VIT01_ooIVKooiUVol`c<omEEEGoc<c<omgMg@Gok^k^00OogMgMok^k^onIIVKooiT0oonII_ooc6Ko
oomV00;ooonI0_ooofH2ooo<IP04oonI0?mVIVKo^k^komgMg@Gok^k^00OogMgMok^k^olcIVKoIYT0
oiW<I_nIofKoc?mV00;oc?nI00SoVOmVolcoVOnIofKoVLaVoc?<0?mVIVKo^k^komgMgMKok^k^00?o
gMgMonk^k_o^k^h01?o^k^h02_mgMgOo8R8Ronk^k_o<c<co0000ojZZZ_oMgMgoVIVIoa4A4Oo^k^h2
omgMg@0>o`000?nZZZ[o0000olc<c?oMgMgo^k^ko`000?nk^k_ok^k^ogMgMolR8R;ok^k^omgMgOo^
k^h2omgMg@0<olc<c?l0003oR8R8omgMgOmVIVKoA4A4oc<c<onZZZ[o^k^ko`000?mgMgOoEEEE0_oM
gMd2oeEEE@04onk^k_oMgMgo8R8RohR8R0;ogMgM00[oMgMgoc<c<ooMgMgoc<c<o`000?nZZZ[ogMgM
onk^k_mgMgOo4A4Aooo^k^hFonk^kP03omgMgOo^k^kok^k^00[ok^k^0Oooool00005ooooooo^k^ko
k^k^omgMgOo^k^h00ooMgMd02?nk^k_oIS<col`c<oooIVKoc6IVoonII_ooVIWooiUV0_ooVIT01Ooo
VFKoc6IVol`c<omV<c?oZZZZ00?ogMgM00cok^k^omgMgOoMgMgogMgMok^k^onIIS?oc9Tcooo<<ooo
c6KooomVooo<I_ooofH3ooo<IP04ooo<<oo<VC?oVFHcok^k^`?ogMgM01?ok^k^omgMgOoMgMgogMgM
ok^k^olcIS?oIYTcoiW<<onIofKoVLaVoiWoVOo<ofKoc<bIoiWoI_nIc3?oVLaVofJI<olcIS?oZZZZ
00;ogMgM00?ok^k^omgMgOo^k^h00_oMgMd00oo^k^kogMgMonk^kP02omgMg@04onk^k_oMgMgogMgM
onk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgMomgMgOo^k^h2omgMg@04onk^
k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgMomgMgOo^k^h2
omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgM
omgMgOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd0
1?o^k^kogMgMomgMgOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgo
k^k^0_oMgMd01?o^k^kogMgMomgMgOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^
omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgMomgMgOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kP;o
gMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgMomgMgOo^k^h2omgMg@04onk^k_oMgMgo
gMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgMomgMgOo^k^h2omgMg@04
onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgMomgMgOo^
k^h2omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^ko
gMgMomgMgOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oM
gMd01?o^k^kogMgMomgMgOo^k^h2omgMg@06onk^k_oMgMgogMgMonk^k_oMgMgok^k^1?oMgMd02oo^
k^kogMgMogMgMolA4A7oc<c<onk^k_nIVIWo<c<cob8R8_lc<c?o4A4A00;ogMgM00GoR8R8oa4A4OoM
gMgoEEEEofIVIP02omgMg@05oiVIVOlR8R;o8R8Roc<c<olR8R800ooMgMd2olc<c00<ofIVI_l0003o
^k^komgMgOlR8R;oR8R8ogMgMomVIVKoR8R8oc<c<oo<c<co00000_oMgMd03_mEEEGoA4A4omgMgOoM
gMgo8R8RohR8R?o<c<cogMgMogMgMolR8R;ogMgMojZZZ_l0003oc<c<0_oMgMd00on8R8So4A4AomgM
g@03omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^ko
gMgMomgMgOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oM
gMd01?o^k^kogMgMomgMgOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoM
gMgok^k^0_oMgMd01?o^k^kogMgMomgMgOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Co
k^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgMomgMgOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^
kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgMomgMgOo^k^h2omgMg@04onk^k_oM
gMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgMomgMgOo^k^h2omgM
g@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgMomgM
gOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^
k^kogMgMomgMgOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^
0_oMgMd01?o^k^kogMgMomgMgOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgM
gOoMgMgok^k^0_oMgMd01?o^k^kogMgMomgMgOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM
00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgMomgMgOo^k^h2omgMg@04onk^k_oMgMgogMgM
onk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgMomgMgOo^k^h2omgMg@04onk^
k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgMomgMgOo^k^h2
omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd01?o^k^kogMgM
omgMgOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kP;ogMgM00Cok^k^omgMgOoMgMgok^k^0_oMgMd0
1?o^k^kogMgMomgMgOo^k^h2omgMg@04onk^k_oMgMgogMgMonk^kPCogMgM00Cok^k^omgMgOoMgMgo
k^k^0_oMgMd1onk^kP7ooooo0Oooool000;ooooo1Oo^k^h01OoMgMgo^k^kogL00?o<<c?oc6IV00;o
ofIV00?ooiUVoonIVOo<VFH00_ooIVH01Oo<IS?oc3<cogL00?o<c<cogMgM00Gok^k^00KogMgMok^k
^onI<`3ooiTcolbI<oooc3<3ooo<IP03ooooI_ooc6Kool`c00;ooiTc00?oVC<0ok^k^ooMgMd01Oo^
k^h04OoMgMgo^k^koc=V0?mVVC?oI/`coiW<<onIc6KoVOmVoiW<I_o<ofKoI/aVoiW<I_mVVC?oI/`c
o`140?o<c<cogMgM0=_ok^k^00OogMgMonk^k_mgMgOo8R8Ronk^k_oMgMgok^k^00;ogMgM00_oR8R8
oa4A4Oo^k^kogMgMoc<c<omgMgOok^k^ojZZZ_lA4A7ogMgMonk^kP03omgMg@0<ogMgMolR8R;ok^k^
onk^k_oMgMgo^k^kob8R8_l0003oVIVIonk^k_o<c<co00000_o<c<`01olR8R;oEEEEogMgMoo^k^ko
8R8RojZZZ_o^k^h00_mEEED03?oMgMgok^k^ob8R8_mVIVKok^k^omgMgOmgMgOo<c<conk^k_nk^k_o
0000ojZZZP;ogMgM00?oVIVIoa4A4Oo^k^h0ooo^k^hRonk^kP7ooooo0007ooooo`03onk^k_oMgMgo
E@0000;oc3<c00Ooc6HcolaVI_o<IVKoc6IVoomVI_o<IVKoc6Hc00;oc3<c00?oIP00olc<c?o^k^h0
1Oooool01?o^k^kogMgMoiTc0?o<VC<3oonI<`04ooo<<oo<c3?ooiUVooo<<`;ooiTc00Coc9TcoiTc
0?oMgMgok^k^1Oooool01?o^k^kogMgMo`140?lcVC<2ofJI<`0;oiW<<omVc3?oVLaVofK<I_nIc3?o
I/`cofK<0?mVVC?o05D0olc<c?o^k^h0gOooool03On8R8So4A4Aonk^k_oooooo^k^kolc<c?oooooo
IVIVodA4A?o^k^kogMgMo`000?oMgMd00_ooool01_lR8R;oZZZZoooooonZZZ[ogMgMooooo`;oEEEE
00Kok^k^oooooonIVIWo0000oc<c<oo<c<`2ooooo`0=oiVIVOlR8R;ooooooooooolR8R;o0000ok^k
^oooooooR8R8oeEEEOooooooIVIVoeEEE@02ooooo`06ob8R8_lA4A7oR8R8omgMgOm4A4CoEEEE0_oo
ool01_lc<c?oA4A4omgMgOo^k^koEEEEoa4A4Ooooooo9?ooool000;ooooo1_o^k^h02Oo<c<coIS<c
oiTc<oo<<`3oc3<colaV<oo<<c?oc6IVolaV<`03ol`c<`03oiTc<omV<c?oc<c<00Ook^k^00Koc<c<
oiT0<oo<VC?oc9T0oonI0?o<VC<2oonI<`07ooo<<oooV@3ooiTcolbI0?o<IS?oVC<colc<c007onk^
kP0;olc<c?lR8R;o<iTcoc>I0?mVVC?oI/`coiVI<omVc3?oVITcofK<<omVV@000_lcVC<00olR8R;o
gMgMonk^kP3Lonk^kP03omgMgOmgMgOo8R8R00;ok^k^00SoMgMgoc<c<ol0003o<c<cojZZZ_oooooo
MgMgodA4A0?ok^k^01;oR8R8oeEEEOo^k^koIVIVob8R8_l0003oA4A4ok^k^oo^k^kogMgMoa4A4OmV
IVKogMgMonk^k_oMgMgok^k^oeEEEOmgMgL2onk^kP09ofIVI_lR8R;ok^k^onk^k_o<c<co8R8Ronk^
k_mVIVKoEEEE00;ok^k^00Ko<c<cohR8R?mEEEGo0000oc<c<oo<c<`2onk^kP06olc<c?lc<c?o0000
ob8R8_mVIVKo8R8Rooo^k^hRonk^kP;ooooo00000oooooook^k^onk^kP04onk^kP04omgMgOo^k^ko
IS<cofHc<`;oVC<c00Goc3<colaVI_o<IS?oc3=VolaV<`03oiTc<`04odA4A?oMgMgok^k^omgMg@Co
k^k^0_oMgMd01onIIS?oVC<colaV<oo<VC?ooiTcolbI<oooVC<00_o<VC<01?o<IS?oc9TcoiTc<onI
<c<2omgMg@?ok^k^00OogMgMonk^k_o^k^kogMgModA4A?lcIS?o<iTc00;oIYTc00?oI/`cofJI<omV
c3<00_mVVC<00olcVC?o<fHcodA4A002omgMg@;ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgo
k^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgo
k^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgo
k^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgo
k^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgo
k^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgo
k^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgo
k^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgo
k^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgo
k^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgo
k^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgo
k^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?ok^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgo
k^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00Kok^k^00?oR8R8oa4A4OoMgMd00oo^k^h01?oMgMgo
k^k^onk^k_oMgMd5onk^kP03omgMgOo^k^kok^k^00?ok^k^00KogMgMonk^k_o^k^kogMgMo`000?nk
^k/2omgMg@05onk^k_oMgMgok^k^onk^k_oMgMd01oo^k^h01OoMgMgok^k^onk^k_o^k^kogMgM00Go
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00?o
k^k^00?ogMgMonk^k_o^k^h00oo^k^h00ooMgMgok^k^onk^kP03onk^kP03omgMgOo^k^kok^k^00go
k^k^0_ooool000;ooooo1oo^k^h01?n8R8SoIS<coiUVI_o<IVH2olbIV@07oonIVOo<VIWoc9VIolaV
I_nIIVKoA000oiVIV@09onk^kP07ohR8R?nI<c?oc6IVolbII_o<c9WoolbIolc<V@02ooo<V@04olbI
I_nIIVKoVC<0oiVIV@Wok^k^00CoR8R8ob8R8_mVVFKoIYUV0_nIc9T01oo<c9WoVLbIoiW<VOmVVFKo
EEEEob8R8_n8R8P0goo^k^h00omgMgOo8R8Ronk^kP0Fonk^kP05oeEEEOlR8R;oR8R8ofIVI_lc<c<0
3?o^k^h2ofIVI_ook^k^<_o^k^h2ooooo`002_ooool00omVIVKoIS<coiVIV@02ooo<c006onk^k_oM
gMgoolc<olbIVOmV<c?oIVIV2oooool02onIIVKoIS<colbIVOooc<cogMgMooooooooc<coc<c<olbI
VOnI<c?oIVIV00[ooooo00Gok^k^ogMgMolc<c?oVIVIolc<c002onk^kP05olcoc?o<c<coVIVIodA4
A?mVIVH0h?ooool00oo<c<coVIVIooooo`0Gooooo`04olc<c?mVIVKoMgMgojZZZPcooooo0_nk^k_o
ooooocCooooo0003ooooo`?ok^k^00ooooooonk^k_o^k^kok^k^omgMgOmVIVKo<c<coiVIVOnk^k_o
gMgMok^k^on8R8So<c<cofIVI_oMgMd00_o^k^h01?ooooook^k^onk^k_ooool2onk^kP0>ooooooo^
k^kok^k^omgMgOnIIVKoIS<colbIVOooc<coc<c<ooo<c?o<VIWoIS<coiUVI_oMgMd3onk^kP04oooo
ooo^k^kok^k^ooooo`;ok^k^00goooooonk^k_o<c<coIVIVoc<c<onIVIWo^k^komgMgOnk^k_oR8R8
oc<c<omVIVKogMgM00;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2
onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^
onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h0
1?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^ko
oooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Cooooo
onk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;o
k^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^ko
k^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04
ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_oo
ool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?oooooo
k^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^
k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^
k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Co
ooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^oooo
o`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^
k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^
kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^
k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?oo
ooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo
0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^
k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^
00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^
ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04oooo
ooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2
onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^
onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h0
1?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^ko
oooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Cooooo
onk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;o
k^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^ko
k^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04
ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_oo
ool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?oooooo
k^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^
k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^
k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Co
ooooonk^k_o^k^kooooo2?o^k^h2ooooo`7ok^k^00000oo^k^koooooooooo`03onk^kP04omgMgOo^
k^kok^k^omgMg@;ok^k^00WoVIVIoeEEEOlR8R;o0000ob8R8_mEEEGoVIVIonk^k_oMgMd00_o^k^h0
1?oMgMgok^k^onk^k_oMgMd2onk^kP0<omgMgOo^k^kok^k^omgMgOo^k^koVIVIoeEEEOlR8R;oA000
ob8R8_mEEEGoR8R80_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@?o
k^k^00WoVIVIoeEEEOlR8R;o0000ob8R8_mEEEGoVIVIonk^k_oMgMd00_o^k^h01?oMgMgok^k^onk^
k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oM
gMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM
0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^
k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^
00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^
omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgM
gOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2
onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^
onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h0
1?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^ko
gMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgM
onk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;o
k^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^ko
k^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04
omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oM
gMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgo
k^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^
k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^
k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00Co
gMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgM
g@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^
k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^
kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^
k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oM
gMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM
0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^
k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^
00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^
omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgM
gOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2
onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^
onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h0
1?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgMonk^k_o^k^ko
gMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;ok^k^00CogMgM
onk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP04omgMgOo^k^kok^k^omgMg@;o
k^k^00CogMgMonk^k_o^k^kogMgM0_o^k^h01?oMgMgok^k^onk^k_oMgMd2onk^kP03omgMgOo^k^ko
k^k^00?ok^k^0_ooool1omgMg@0000?oc<c<ooooooooool00oo^k^h01?ooooook^k^onk^k_ooool2
onk^kP03ooooooo^k^kok^k^00;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^
k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00?oooooonk^k_o^k^h00_o^k^h01?oooooo
k^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo1Oo^
k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^
k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Co
ooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^oooo
o`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^
k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^
kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^
k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?oo
ooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo
0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^
k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^
00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^
ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04oooo
ooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2
onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^
onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h0
1?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^ko
oooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Cooooo
onk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;o
k^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^ko
k^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04
ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_oo
ool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?oooooo
k^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^
k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^
k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Co
ooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^oooo
o`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^
k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^
kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^
k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?oo
ooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo
0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Coooooonk^
k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^
00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04ooooooo^k^kok^k^
ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2onk^kP04oooo
ooo^k^kok^k^ooooo`;ok^k^00Coooooonk^k_o^k^kooooo0_o^k^h01?ooooook^k^onk^k_ooool2
onk^kP04ooooooo^k^kok^k^ooooo`;ok^k^00Soooooonk^k_o^k^kok^k^ooooooo^k^koooooonk^
kP7oVIVI0002olc<c?oooooooooooommooooo`7ok^k^0OnZZZX1ojZZZP0000?oooooolc<c?o<c<`0
ooooooooooooog[ooooo00Cok^k^omgMgOnZZZ[oZZZZ0Oo<c<`00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 1}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell["A MathJFrame is created.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(frame = NewMathJFrame["\<JavaSwing\>", 640, 480, 360, 0]\), "\n", 
    \(If[frame === $Failed, Abort[]]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "com.wolfram.jlink.MathJFrame"] \[RightGuillemet]\),
      JLink`Objects`JavaObject49780801667073]], "Output"]
}, Open  ]],

Cell["\<\
A frame has four panes in its JRootPane. The content pane is one of \
the most important object among these. Glass pane, layered pane, and menu bar \
are the rest of these. The menu bar is null by default.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(pane = frame@getContentPane[]\), "\n", 
    \(glass = frame@getGlassPane[]\), "\n", 
    \(layer = frame@getLayeredPane[]\), "\n", 
    \(menubar = frame@getJMenuBar[]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JPanel"] \[RightGuillemet]\),
      JLink`Objects`JavaObject122481645977601]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JPanel"] \[RightGuillemet]\),
      JLink`Objects`JavaObject122773552758785]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JLayeredPane"] \[RightGuillemet]\),
      JLink`Objects`JavaObject102833848320001]], "Output"]
}, Open  ]],

Cell[TextData[{
  "The ",
  StyleBox["frame",
    FontWeight->"Bold"],
  " is located to the center of the main screen and is shown."
}], "Text"],

Cell[BoxData[{
    \(CenterizeFrameOnScreen[frame]\), "\[IndentingNewLine]", 
    \(JavaShow[frame]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["<<< SimpleMathJFrame >>>",
  FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40001`0000=AP00`40o`00
0?l0003oL000000000>8`;Q8T8Q8T8P0K4R@R04000000003R<2hb>3HR<2h
06^8`;P1B9280@00000000>8`;S8h=R8`;P0JhS0^058T8P1000000001HS0
^<SPf8S0^8S0^<c<c00coooo00?<c<coooooool0<Oooo`:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVK<c<`aIVIV00?ooomVIVK<c<`0<FIVIP04
ooooR<2hR<2hB9280@00000000J8`;S8h=R8`;R8`;QVIVKoool`c<c<00=V
IVKooomVIVH0<Oooo`05IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo<<c<c003IVIVooooIVIV037oool01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oooa3<c<`@VIW<4<c<c003
IVIVooooIVIV037oool01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_oooa3<c<`00iVIc<c<c<c<c00<c<c<00>IVLc<c<c<c<`0
3/c<c003IVIVooooIVIV037oool01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_oooa3<c<`00iVIc<c<c<c<c00<c<c<00>IVLc<
c<c<c<`03/c<c003IVIVooooIVIV037oool01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_oooa3<c<`00iVIc<c<c<c<c00<c<c<
00>IVLc<c<c<c<`03/c<c003IVIVooooIVIV037oool01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oooa3<c<`00iVIc<c<c<c<
c00<c<c<00>IVLc<c<c<c<`03/c<c003IVIVooooIVIV00?oool30000:ooo
o`05IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
4<c<c003VIW<c<c<c<c<00800005c<c<0P0000?<c<`00iVIc<c<c<c<c00>
c<c<00=VIVKooomVIVH00_ooo`050000oooooooooooo000002[oool01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oooa3<c<`0
0iVIc<c<c<c<c00200001Lc<c0800003c<c<00>IVLc<c<c<c<`03/c<c003
IVIVooooIVIV00Koool00`000?ooooooo`0Xoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool@c<c<00>IVL`000000000
10000003c<c<0000000000@000000lc<c9VIc<c<c00?c<c<00=VIVKooomV
IVH01_ooo`030000oooooooo02Soool01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_oooa3<c<`00iVIc<c<c<c<c00200001Lc<
c0800003c<c<00>IVLc<c<c<c<`03/c<c003IVIVooooIVIV00;oool01@00
0?ooooooooooo`00000Zoooo00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoool@c<c<00>IVLc<c<c<c<`00P0000G<c<`20000
0lc<c003VIW<c<c<c<c<00k<c<`00fIVI_ooofIVIP02oooo100002_oool0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oooa3<
c<`00iVIc<c<c<c<c00<c<c<00>IVLc<c<c<c<`03/c<c003IVIVooooIVIV
00;oool00`000?ooooooo`0/oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoool@c<c<00>IVLc<c<c<c<`03<c<c003VIW<
c<c<c<c<00k<c<`00fIVI_ooofIVIP03oooo00<0003oooooool0:oooo`05
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo4<c<
c003VIW<c<c<c<c<00c<c<`00iVIc<c<c<c<c00>c<c<00=VIVKooomVIVH0
0oooo`@0000Zoooo00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoool@c<c<00>IVLc<c<c<c<`03<c<c003VIW<c<c<c<c<00k<
c<`00fIVI_ooofIVIP0aoooo00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoool@c<c<00>IVLc<c<c<c<`03<c<c003VIW<c<c<
c<c<00k<c<`00fIVI_ooofIVIP0aoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoool@c<c<00>IVLc<c<c<c<`03<c<c003
VIW<c<c<c<c<00k<c<`00fIVI_ooofIVIP0aoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool@c<c<00>IVLc<c<c<c<`0
3<c<c003VIW<c<c<c<c<00k<c<`00fIVI_ooofIVIP0aoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool@c<c<49VIc13<
c<`00fIVI_ooofIVIP0aoooo00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoool`c<c<00=VIVKooomVIVH0<Oooo`05IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo<<c<c003IVIV
ooooIVIV037oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP0aoooo00?<c<cooomVIVH0<Oooo`05c<c<ooooR<2hR<2hB928
004000000004R<2hb>3HR<2hR<2h<fIVIP03c<c<IVIVIVIV035VIVH01<c<
c8S0^8S0^4R@R04000000003R<2hb>3HR<2h06^8`;P1B9280@00000000B8
`;S8h=R8`;R8`;PC002001l01H812h@248H35XP378X48H`59hh6;I06<Y87
>9@8?IH9@iP9BIX:CY`;E9h<FZ0<Gj8=IJ@>JZH?L:P?MZX@Nj`APJhBQk0B
S;8CT[@DUkHEWKPEXkXFZ;`G[[h0=QRd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P4002000>KYo4c@jDc@jD02C=3Y@<008007`05PP4;Q08@QP<F
R0<LRP@QS0DWSPH]T0HbTPLhU0PmUPU3V0U9VPY>W0]DWPaJX0aOXPeUY0iZ
YPm`Z0mfZQ1k[161[Q:7/1:</Q>B]1BG]QFM^1FS^QJX_1N^_P0f6;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0<008001i^WlOooohij]ZJKa;>Y
dZRMb;>YdP02YY_400Fl^=g^k_CZjO7ooolc@jD00P00P00O00F20@^40Q26
0aJ80ab:126<1BN>1Rf@1S:B1cRD23fF2D>H2DVJ2TjL2eBN35ZP35nR3FFT
3VZV3g2X3gJZ47^/4H6^4XN`4Xbb4i:d59Nf5Ifh5J>j5ZRl5jjn008H]<0P
00000QRd`10000026;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
080019^WlOooofaJYJnUbP:l^=d0:_omok>Yd_oooooookbhgIN:_:RMb>KV
k?oooc=3Y@00P005PP4;Q08@QP<FR0<LRP@QS0DWSPH]T0HbTPLhU0PmUPU3
V0U9VPY>W0]DWPaJX0aOXPeUY0iZYPm`Z0mfZQ1k[161[Q:7/1:</Q>B]1BG
]QFM^1FS^QJX_1N^_P8H]<000lSPf4R@R4R@R00<B92800<00038h=Q8T8P0
3DR@R00400006;C06;C0b>3H3TR@R00300006;C06;C000:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000^KYo7ooonXWLSoooncZM9PC9Z>N[Ih
IJjXWLSooooooOl00oooo`0R<d>U0020002000F20@^40Q260aJ80ab:126<
1BN>1Rf@1S:B1cRD23fF2D>H2DVJ2TjL2eBN35ZP35nR3FFT3VZV3g2X3gJZ
47^/4H6^4XN`4Xbb4i:d59Nf5Ifh5J>j5ZRl5jjn0QRd`003b>3HR<2hR<2h
00^8`;P00dR@R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004
B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0800800
3Y^WlOooooooom_Lk61<VY>5^[>Yd[bhgF1<VYV?_ZJKa<S3gooooc=3Y@<0
08007`05PP4;Q08@QP<FR0<LRP@QS0DWSPH]T0HbTPLhU0PmUPU3V0U9VPY>
W0]DWPaJX0aOXPeUY0iZYPm`Z0mfZQ1k[161[Q:7/1:</Q>B]1BG]QFM^1FS
^QJX_1N^_P026;C000C8h=R8`;R8`;R8`;P6000018S0^003B9280000b>3H
00:8`;P900000XS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd
`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000jKYo7ooonl
^=fISkkooooFdMgKg>cco_nVVlC^k_B5M[2CQK[ooolc@jD2002001l01H81
2h@248H35XP378X48H`59hh6;I06<Y87>9@8?IH9@iP9BIX:CY`;E9h<FZ0<
Gj8=IJ@>JZH?L:P?MZX@Nj`APJhBQk0BS;8CT[@DUkHEWKPEXkXFZ;`G[[h0
0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P00dR@R0000<SPf002R<2h00<0
0028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<001<SPf8S0^8S0
^8S0^0800004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P3002002nKYo7ooonISkjGR[cDdnS_[;?oMW_^
Wj]KF:FVVlBFWm9PC9Zl^=gooolc@jD008001H812h@248H35XP378X48H`5
9hh6;I06<Y87>9@8?IH9@iP9BIX:CY`;E9h<FZ0<Gj8=IJ@>JZH?L:P?MZX@
Nj`APJhBQk0BS;8CT[@DUkHEWKPEXkXFZ;`G[[h00QRd`003b>3HR<2hR<2h
00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2h
R<2hB9280000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08002Y^WlOoooiN:_7Y/Z[?7j:U^X<S3gi>5^U]6TiV?_P9hIJh0948WQJnU
b_oooc=3Y@00P005PP4;Q08@QP<FR0<LRP@QS0DWSPH]T0HbTPLhU0PmUPU3
V0U9VPY>W0]DWPaJX0aOXPeUY0iZYPm`Z0mfZQ1k[161[Q:7/1:</Q>B]1BG
]QFM^1FS^QJX_1N^_P8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P0
0XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8
h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0P00P003VjOaoooooooo00;oool02_n]/?mf
NoW=e?g]k_ooojJKa8Ef/;bhgOoooc=3Y@8008007`05PP4;Q08@QP<FR0<L
RP@QS0DWSPH]T0HbTPLhU0PmUPU3V0U9VPY>W0]DWPaJX0aOXPeUY0iZYPm`
Z0mfZQ1k[161[Q:7/1:</Q>B]1BG]QFM^1FS^QJX_1N^_P026;C000?8h=R8
`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D0
0028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00B8`;P200001HS0^004
B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<00800
2Z6/l_W=e>8V??Be_n8V??A]OOcSjOoooog]k_n]/0;oool08c=3Y@00P000
P000P005PP4;Q08@QP<FR0<LRP@QS0DWSPH]T0HbTPLhU0PmUPU3V0U9VPY>
W0]DWPaJX0aOXPeUY0iZYPm`Z0mfZQ1k[161[Q:7/1:</Q>B]1BG]QFM^1FS
^QJX_1N^_P026;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P0
0`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2h
R<2h00>8`;P4000018S0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_ARK_om
oon]/?cSjOoooc=3Y@04002001l01H812h@248H35XP378X48H`59hh6;I06
<Y87>9@8?IH9@iP9BIX:CY`;E9h<FZ0<Gj8=IJ@>JZH?L:P?MZX@Nj`APJhB
Qk0BS;8CT[@DUkHEWKPEXkXFZ;`G[[h00QRd`003b>3HR<2hR<2h00^8`;P0
0dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB928
0000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008000i^W
lOK8c>8V?002ojf`00OO92koY9kf_<Go[K3^Nhcooolc@jD01@00P00O00F2
0@^40Q260aJ80ab:126<1BN>1Rf@1S:B1cRD23fF2D>H2DVJ2TjL2eBN35ZP
35nR3FFT3VZV3g2X3gJZ47^/4H6^4XN`4Xbb4i:d59Nf5Ifh5J>j5ZRl5jjn
008H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0T00002R<2h
00E8T8P0000H]<0H]<38h=P00hS0^0800004R<2h0P0000:8`;P014R@R000
01Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7i
cMCgRIL00_ooo`07ojf`hAHdogIkojBNhRHlohUo<d>U00D008007`05PP4;
Q08@QP<FR0<LRP@QS0DWSPH]T0HbTPLhU0PmUPU3V0U9VPY>W0]DWPaJX0aO
XPeUY0iZYPm`Z0mfZQ1k[161[Q:7/1:</Q>B]1BG]QFM^1FS^QJX_1N^_P02
6;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P900000XS0^005
B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000NKYo7oooocX:kdHVkoooogRIOicM@0
0_ooo`03lj2^oooo<d>U00D008007`05PP4;Q08@QP<FR0<LRP@QS0DWSPH]
T0HbTPLhU0PmUPU3V0U9VPY>W0]DWPaJX0aOXPeUY0iZYPm`Z0mfZQ1k[161
[Q:7/1:</Q>B]1BG]QFM^1FS^QJX_1N^_P026;C000?8h=R8`;R8`;P02hS0
^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0
000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00;VjOa
ooooohUooooolj2^lI>Qoooooogolj2^oo_l<d>U00D008007`05PP4;Q08@
QP<FR0<LRP@QS0DWSPH]T0HbTPLhU0PmUPU3V0U9VPY>W0]DWPaJX0aOXPeU
Y0iZYPm`Z0mfZQ1k[161[Q:7/1:</Q>B]1BG]QFM^1FS^QJX_1N^_P026;C0
3lSPf0030000b>3Hb>3H00g8h=P00`0001Rd`1Rd`00?b>3H00<0000H]<0H
]<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0@00803VjOa00Kooooc
X:kd]Kof_<GkfMXc@jD6002001l01H812h@248H35XP378X48H`59hh6;I06
<Y87>9@8?IH9@iP9BIX:CY`;E9h<FZ0<Gj8=IJ@>JZH?L:P?MZX@Nj`APJhB
Qk0BS;8CT[@DUkHEWKPEXkXFZ;`G[[h0=QRd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;PC002001l01H812h@248H35XP378X48H`59hh6;I06<Y87
>9@8?IH9@iP9BIX:CY`;E9h<FZ0<Gj8=IJ@>JZH?L:P?MZX@Nj`APJhBQk0B
S;8CT[@DUkHEWKPEXkXFZ;`G[[h0=QRd`0:8`;P1B9280@00000000>8`;S8
h=R8`;P0JhS0^058T8P1000000000hS0^<SPf8S0^01[R<2h0DR@R0400000
0003R<2hb>3Hb>3H06_8h=P1B9280@000000KhS0^04000000001\
\>"], "Graphics",
  ImageSize->{112, 53},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002X0000?b000`400?l0
0000o`00003oZ?o`l?000:Sol?3`002Xoo3`l000Z?o`l?000:Sol?3`002X
oo3`l000Z?o`l?000:Sol?3`002Xoo3`l000Z?o`l?000:Sol?3`002Xoo3`
l000Z?o`l?000:Sol?3`002Xoo3`l00000goooooookno_ono_koo?clooWi
nOoemOGol?3`on[Zj_oMg]koc/o@ok^m_on`/kKoZJfa00;oZ:f`00?oYjb_
okFg^On//;<01?nW[:l01?n//;?o]KNiokFg^On//;<4ojN/[`04ojb`/one
]kWo]KNiojb`/`CoYjb_00Co[;2cokFg^One]kWo[;2c1?nW[:l01?n//;?o
]KNiokFg^On//;<4ojN/[`04ojb`/one]kWo]KNiojb`/`CoYjb_00Co[;2c
okFg^One]kWo[;2c0_nW[:l2ojR]/00:ojV]/On`/kKo^kfoolk?d?oMg]ko
j^[Zoo3`l?oemOGonOWiooclo0;oo_kn0_ooool00ond];Coclo?olo?c`1?
olo?c`7oaLG50Ond];@000;okNg]00coj^[ZonOWiooQhN7odm?Col;3`on[
[JooVIfQohZAU_moR93oN8>=ogF2SOmePHd2ogF1S003ogf5SOmfPH_oM82;
00?oM82;00CoMX6;ogf5SOmmQHgoMX6;1?mdP8/01?mfPH_oOHF=ogf5SOmf
PH/4ogB0R`04ogJ1RommQHgoOHF=ogJ1R`CoM82;00CoMX6;ogf5SOmmQHgo
MX6;1?mdP8/01?mfPH_oOHF=ogf5SOmfPH/4ogB0R`05ogJ1RommQHgoOHF=
ogJ1RomdP8/00_mePH`03?mePHgoMH:=ogR3SOmoR93oRY6FoiVMXOn[[Joo
`/?3om?CdooQhN7oinOWon[ZjP;okNg]00?ok^k^okVi^OoMgMd01Oo/k>a6
onk^kPGok>c/0OoMgMd1okVi^@0000coiNGUon;Rh_oNg]kof=SHolW9b_n^
[k3oTiNKogj6S_m_O8OoIWJ3of1bPOmML842oe]^P0;oFFio00?oG6ekoeU^
OomIKWl01?mIKWl2oea]N`KoFFio0_mLKG/6oeU^O`;oG6ek1_mIKWl2oea]
N`KoFFio0_mLKG/6oeU^O`;oG6ek1?mIKWl2oe]^P00;oee`POmPLX7oIWJ3
ofmlQomnQXkoTiNKojj_/?o9bL[of=SHomkNg_oRh^800_oUiND00oni^KWo
hn?SooGem@04ooOgmdKon_[j1OogmoL1on?Sh`7o^KVi00003?o[jn_oinOW
on3Ph?o>cloo/[>dohnDVOmdOhWoHgB3oea]O?mHJ7CoF6E_oeUSK0;oFF9Z
0_mGHFT00omAGV[oE61ZoeMQJ@03oeMQJ@04oeAPJ_mAGV[oDEiZoeAPJPCo
Ef5Y00CoE61Zoe5NJ_mAGV[oE61Z1?mGHFT01?mDH6[oDEiZoe5NJ_mDH6X4
oeMQJ@04oeAPJ_mAGV[oDEiZoeAPJPCoEf5Y00CoE61Zoe5NJ_mAGV[oE61Z
1?mGHFT01?mDH6[oDEiZoe5NJ_mDH6X3oeMQJ@;oFF9Z013oFF=/oeQUKomH
J7CoG6elof=dPomdOhWoSiBIok:c]?o>clooh>3PonOWioo[jn_okNg]okVi
^OoShn?omOGeC_ooool1ooOgm`7ohn?S0Oni^KT0000DooWinOobl_;ogmoP
okjo`?nFVj3oN8>;ofMdOomZMGkoQhfCoj^^/?o;c<goj>SYooKfm_ogmoOo
nOWiooShn?oinOWon_[jooWinOogmoL3ooShn0;onOWi00?on_[jooWinOog
moL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[o
nOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03
oo[jn_oinOWomoOg00?on?Sh0_oinOT05_ojn_[onOWiooShn?oinOWon?Sh
ooOgmooZj^_oc<g>ojb^/On7SI?oJWEnofMdOomhPh_oUY^Pokjo`?oOgn3o
l_;booWinOomoOgo^KVion?ShooemOE>ooooo`7omoOg0OoShn<1okVi^@00
00coi>CTom?Cdond]KKoSiFIog9mQOmSKgWoPhV>ok^m_oo^k^kom_Kfoocl
o?ono_hkooooo`0@ookno_olo?comoOgono_konl_/3oQ8Z?of=_NOmbOHGo
SiFIokBe]_oCdm?oi>CTon[Zj_ni^KWohn?SooGemDkooooo0OogmoL1on?S
h`7o^KVi00002_oBd];o]KJgoi2EV_mcOXKoIg=mohjDUooNg]kojn_[ooCd
m?okno/oooooo`0>oo_knooclo?ok>c/on7QhOnAUY[oIg=mog=nQ_n@UI[o
]KJgom;Bd_oOgmoo^KVion?ShooemOE>ooooo`7omoOg0OoShn<1okVi^@00
00[obLW:oijRY_mhQ8koJ7J1ohbAUOoDe=Coh>3Ponc/k?oemOGooOgm?ooo
ool03_ono_kom_Kfonc/k?oRh^;ofMWIohnDVOmXMX7oN8B>oijRY_o9bL[o
i>CTokVi^OoShn?on_[jC_ooool1oo[jnP7ohn?S0Oni^KT0000;okbo`On?
V:7oKh2?ogn8Soo6a/Koe=CDon3Ph?o/k>col_;booclo?ono_h0?_ooool0
3_ojn_[om?Cdon[Zj_oShn?oemOGolg=cOn2RY7oKh2?ohnHXOnl_l7ojn_[
okVi^OoShn?on_[j0oooool00oofm_Koe]KFono_k`18ooooo`7on_[j0OoS
hn<1okVi^@0000ooW::WogJ6TomYNXOoVifPolK6a_oBd];og=cLonKVi_o/
k>comOGeooShn?ojn_[ooOgmooooooolo?`02?ooool00oomoOgooooooooo
o`05ooooo`06oogmoOoooooooooooooooonb/[;oGEeM0_ooool00oomoOgo
ooooooooo`03ooooo`03ok:b/_mMGEgooOgm00Oooooo00?ooOgmoooooooo
ool01Oooool00oomoOgoooooooooo`02ooooo`0CoogmoOoooooooOgmoo_k
noohn?Som?Cdong]kOoVi^KogmoOomKFe_o<c<coXJ>VofYkR?mfQY?oW::W
olo@d?ni^KWohn?Soo[jnP03ooooo`05ogemOOli>CWo=SHfod51@Onl_;`0
A_ooool1oo[jnP7ohn?S0Oni^KT0000CohVCVom[P9;oMGn8okJf]_o3`l?o
clo?omKFe_oOgmooi^KVon[Zj_o_knoolo?cooCdm?oemOGomoOgooKfm_og
moOom_KfooShn002ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?n/[:coFUYJ0_ofm_H2ooOgm`06ooKfm_oh
n?SomoOgooOgmon[Zj_oFEUI0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`0FooKfm_ohn?So
m_KfooOgmoofm_Kom?Cdoo;bl_o`l?3ojn_[onKVi_oQhN7of][Jom?Cdoo9
bLWo_knoogV4S?m[P9;oRI>KokFg^?ni^KWohn?Soo[jnPKooooo00?oRHV9
oa8B4_olo?`0AOooool1oo[jnP7ohn?S0Oni^KT0000;ohFBW?mZPIGoQ8Z?
ok>c/oo0`<3obLW9om?CdooIfMWogMgMon;Rh_oUiND00_oZj^X00oo/k>co
kNg]ong]k@07onk^kP03oo3`l?o^k^kok^k^00Gok^k^00Kol?3`onk^k_o^
k^kok^k^ojJVY_mFEUH2onk^kP03oo3`l?o^k^kok^k^00?ok^k^00?oYZJV
oeIFE_o`l?001oo^k^h00oo`l?3ok^k^onk^kP05onk^kP04oo3`l?o^k^ko
k^k^onk^kP;okNg]0_o/k>`04?oYjNWoi^KVon?ShooPh>3ofm_KomGEeOo=
cLgoaLG5ok^k^on:T9GoJX6EohFBW?na];Oo^KVion?Shoojn_X6ooooo`03
omGEeOl0003oh^;R04Gooooo0Oojn_X1on?Sh`7o^KVi00003On;V:CoJhBI
ohjAU?n/[:co^k^kolK6a_o=cLgodm?ComOGeooKfm_ogmoOon7QhOoRh^80
0_oShn<7onGUi@;oi^KV1_oUiND2onKViP05ohB4Q?m1@D7o@D51obd];OlG
5aL00_m1@D401?m>CTkoiNGUonGUiOn4Q8@2od51@@05obd];OlG5aOo@D51
od51@Om>CTh01?oUiND2onKViPKoiNGU0_oVi^H3onGUi@;oi>CT0_oShn<0
4?oRh^;oh>3PomcLg?oIfMWoe]KFom3@d?o9bLWo`L71okFe]OnGVIcoJhBI
oh^HY?ni_<3o^KVion?Shoojn_X6ooooo`03oginO_lA4A7ooOgm04Gooooo
0Oojn_X1on?Sh`7o^KVi00003On4TYkoJX>Hohn?T?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`2omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@0;omkNg_oMgMgogMgMol30`?n[Zj_o
ZZZZogIfM_lm?CgoZj^[ojZZZ_n_[jl00_oNg]h02?no_kooZZZZojZZZ_mg
MgOo?CdmojZZZ_n[Zj_o[jn_0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h2omgMg@;og=cL017ofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^KW?mZPiSoQ9:Nojfa
]Oni^KWohn?Soo[jnP03ooooo`05ol[:b_m/K6co<C4aobl_;one]KD0A_oo
ool1oo[jnP7ohn?S0Oni^KT0000=oh:?Vom[Q9[oQhR9oijNW_n][Jgo^KVi
ol;2`_o7alOoc<c<om3@d?oBd];oeMGEomKFeP02omOGe`03omSHf?oIfMWo
fMWI017ofMWI00?oUiNGodm?CooIfMT01ooIfMT00onGUiOoCdm?omWIf@0C
omWIf@;of=SH0_oGemL04?oEeMGodm?Com3@d?o>c/kob/[:olG5aOno_koo
]KFeojVYZOnCU9GoJhBJoh:?VonY[:oo^KVion?Shoojn_X3ooooo`03oi^K
Vom2@T;oh>3P04Sooooo0Oojn_X1on?Sh`7o^KVi00003On7UJ7oKhVPogUm
P?nCTi?oXZ:Rojn_[onj^[[o`L71olO7aoo;bl_oc/k>om3@d?oAdM400_oC
dm<3omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD00KoeMGEoiBDU?m>CTkoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFoiBDU?m>CTkoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE01?oe=CDom?CdooCdm?odM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jf
oj^[ZonMWIgoPXF8ofn9X?n7UJ7o[k>fokVi^OoShn?on_[j00?ooooo00?o
Vi^Kof5QHOooool0B?ooool1oo[jnP7ohn?S0Oni^KT0000BoiBQZomgTJKo
M7Z1ohV9ROnGUiOoYJFUok:b/_no_koobl_;om7AdOoEeMGoemOGomWIfOoJ
f][ofm_Kom[Jf_oKfm_og=cL1ooKfm/00ooLg=cofm_Kom_Kf`05om_Kf`04
omcLg?oKfm_o^KVioi:BTPCofm_K00Kog=cLom_KfooKfm_ofm_KokVi^OnB
TY82om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoK
fm/05_oLg=cofm_Kom_KfooKfm_of][JomWIfOoHf=Soe]KFom?Cdoo=cLgo
`/;2okJf]_n/[:coWinOoi2@T?mjP8KoMi6VoiBQZoo3a/Wo^KVion?Shooj
n_X3ooooo`03oi^KVom0@43oZZZZ00;oZZZZA_ooool1oo[jnP7ohn?S0Oni
^KT0000;oiVQZOmjT:;oKgZ4ogYjN_n8R8SoUYJFojZZZ_o4a<CoeMGEom_K
fooNg]h00_oPh>03on;RhP03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?S
hooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?S
h`04onCTi?oShn?ohn?Son?Sh`;oh^;R017ohN7Qon3Ph?oOgmoog=cLomOG
eoo5aLGo[:b/oijNW_n@T93oPX:2og9mQomjT:;oVJ6Yol;4aOni^KWohn?S
oo[jnP03ooooo`05okbl_?mCDe?oDe=Coe=CDomEEED0A_ooool1oo[jnP7o
hn?S0Oni^KT0000>ojZ^/On7U:3oM8FCofM[L?mhN7SoQXJ6oinOWoo5aLGo
f=SHomgMgOoOgmoohN7Qon;Rh_oShn<3onCTi0CoiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi004onGUiOoTi>CoiNGUonGU
i@?oi>CT017ohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83o
L7=hogF6U?n7U:3oZZjaolo@d?ni^KWohn?Soo[jnP1>ooooo`7on_[j0OoS
hn<1okVi^@0000_ocLk>oj2W[On6UJ;oJgV4ofEUIOmcLg?oSHf=ok^k^ooD
e=Cof][JomgMg@02omoOg`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Q
h@03on;Rh_oQhN7ohN7Q00KohN7Q017oh>3PomoOgooMgMgog=cLomGEeOni
^KWoSXj>og]kNom^KVkoKW^7ohJEX_nPYjgocLk>onGUiOni^KWohn?SooGe
m@1>ooooo`7omoOg0OoShn<1okVi^@0000comOGeol[=conOZK7oPiNXofQb
NomRHV;oMWIfojBTY?o7alOod];BomGEeOoHf=P2om[JfP?ofm_K1ooLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL01Oofm_KomcLg?oLg=cofm_KomcLg?oKfm_of][JomWIfOoH
f=Sodm?ColG5aOnLW9coMGEeofMWIom[MGgoPiNXoinY/Oo:cLoomOGeookn
o_ni^KWohn?SooGem@1>ooooo`7omoOg0OoShn<1okVi^@0000kokNg]omKG
eonb]KWoSi^Vogb>WOmSKGGoFUYJog]kNonSXj?o_;blolK6a_o;bl_ocLg=
olo?c`;odM7A1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];o
dM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05
om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM400ooBd]82
om7Ad@0=om3@d?o?clooc<c<olS8b?nk^k_oW9bLog9bL_mKFe_oIVmhogb>
WOn?VjKo/[FiomKGe`02ong]k@03okVi^OoShn?omOGe04kooooo0OogmoL1
on?Sh`7o^KVi00004?oUiNGog]kNolS8bOnW[;3oRiRSogfBXomSLWooF5eQ
ofQXJ?n3Ph?oUiNGoj>SXon/[:co[jn_ok6a/Onb/[82okBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]00IokFe]Onf][Co];BdokBd]?nf][Ko/k>cok:b/_nc/k?o[jn_
ojZZZ_nLW9coPX:2of9RH_mIGV;oIWB2ogfBXon;V:?oYjb`olS8bOoNg]ko
iNGUonKVi_ni^KWohn?SooGem@04ooooodKon_[j1?ooool1ooOgm`7ohn?S
0Oni^KT0000Bonk^k_o]kNgoi^KVom3@dOnc][WoUj6ZohJGY_mfRYcoIGF2
oe]TK?mJGV;oGUmPofUYJOmbLW;oM7AdogUiNOmlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@07ogalO?mkNg_oO7alogemO?mlO7coNg]kogem
O@02ogYjNP0=ogMgMomdM7CoJ6UZoemTIomLIVkoIGF2ogJ;WOn6UjKoUj6Z
ok>f^Oo@d=7oi^KVong]k@02onk^kP03okVi^OoMgMgoj^[Z00Coj^[ZA_o`
l?05on[ZjP7ogMgM0Oni^KT000;ooooo00_oo_knooOgmooXjNWoc<k@okFj
_onLYk7oSYj]oh>K[omoVk;oO9ZcogbI/`03og^I/P03oh6I[OmkVK;oNiVb
00CoNiVb0_n1VJd6og^I/P;oPIV]1_mkVK82oh6I[@KoNiVb0_n1VJd6og^I
/P;oPIV]1_mkVK82oh6I[@GoNiVb00_oO9VcogbJ/omoVk;oPi^_ohjN[OnL
Yk7o]KZoolc>d?oXjNWomoOgooknoP03ooooo`03oiZJV_ni^KWo`/;200Co
`/;2A_o3`l<5ol;2`P7o^KVi0OnJVYX000Cok^k^00OokNg]onKVi_oHfMWo
_/32ojZ`]?nIXj_oTIjX00;oSifY0on>W:P00onLY:_oT9fXohjLZ003ohjL
Z004oi2MZ?nLY:_oW:B[oi2MZ0CoSYbX00CoT9fXoibTZonLY:_oT9fX1?n>
W:P01?n@WJSoW:B[oibTZon@WJP4ohjLZ004oi2MZ?nLY:_oW:B[oi2MZ0Co
SYbX00CoT9fXoibTZonLY:_oT9fX1?n>W:P01?n@WJSoW:B[oibTZon@WJP4
ohjLZ0;oSifY00OoTIjXoiVSZonZ/;Co_/32omSIfOoVi^KokNg]00Gok^k^
00?oJFUYogMgMomkNg/01?mkNg]6ogalO0GoNg]k0OmgMgL1ofUYJ@00Z?mo
Ogl00004on_[jooVi^Koh^;RomkNgPCogMgM0ooNg]h00ooLg=cog]kNomgM
g@02omgMg@2<omkNg_oLg=cog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMh3omkNgP03omgMgOoNg]ko
g]kN00?ogMgM0OoQhN41onOWi`7oj^[Z00000oo/k>coi^KVon3Ph007omWI
f@04omSHf?oFe]Kodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooI
fMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_o
fMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=QK
omWIf@03omSHf?oIfMWofMWI00KofMWI0OoNg]h1onKViP7ok>c/00001oo^
k^kojNWYonCTi?oPh>3ohN7Qon3Ph?oRh^800_oQhN403OoNg]kofm_Kom?C
doo7alOo^k^kok:b/_n][Jgo/[:bok^k^oo7alOodm?Com_KfooOgml02OoQ
hN403OoOgmoofm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOo
dm?Com_KfooOgml02OoQhN403OoOgmoofm_Kom?Cdoo7alOo^k^kok:b/_n^
[Zko/[:bok^k^oo7alOodm?Com_KfooOgml0G?oQhN400ooRh^;ohN7Qon;R
hP04on7Qh@7oi>CT0OoYjNT1ong]k@0000?ol?3`ono_kooalO400oo`l?00
W_o_knool?3`onk^k_oYjNWofm_Kol71`OnTY:CoS8b<ogYjN_mgMgOoNg]k
ohb<S?nTY:Co`/;1om[Jf_oZj^[okNg]oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<RomkNg_oMgMgog]kNon<
S8coY:BTol;2`_oJf][oj^[Xong]kOoalO7okno_oo7alOo_knoolO7aono_
kooalNookNg]on[Zj_oJf][o`/;2ojBTY?n<S8coNg]kogMgM_mkNg_oS8b<
ojBTY?o2`/;of][Jon[Zj_o]kNgolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo`l?3okno_oo3`l?o_knool?3`ono_koo`l?3o
kno_1?o`l?000003oo;bl_o^k^koinOW00CoiNGU013oi>CTomoOgooAdM7o
/K6aohZ:R_mUIFGoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoA
dM7og]kN0_oTi>@00ooUiNGoi>CTonGUi002onCTi00?omkNg_oAdM7o/K6a
ohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM3o
g]kN00;oi>CT06koiNGUonCTi?oUiNGoi>CTonCThooNg]kodM7Aok6a/On:
RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7AomkN
g_oTi>?oi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i0CoiNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o]kNd1oo;blP0000?om?Cd
ong]kOoWinL00_oPh>004ooQhN7ogmoOomkNg_oBd];o];BdohN7QomLG5co
KC/eoii>@_o=KUkojH=_ole_GonMCD?oKC/foeaLG?n7QhOo];Bdom;Bd_oN
g]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLofeP;?nNURkocLdoonWY
COo=cCooWYX_ofeS;OmLG5coQhN7okBd]?oBd];og]kN00Goh>3P017og]kN
om;Bd_nd];CoQhN7oeaLG?m7IbkoJ9hcoi7=AonZjEGoTLe7ofZN=?m9JRoo
G5aLohN7Qond];Cod];BomkNgP1Hon3Ph003omoOgooPh>3ogmoO00;ogmoO
0ooPh>000ooQhN7oinOWonc/k001ooCdm00000?om_Kfoo;bl_o[jn/00ooX
j>P04ooWinOoh^;Rolg=cOnOWiooJUiNohlf;_o/L67onIf@oofaYOom_:oo
oKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;Rh_oWinL00ooXj>P04ooW
inOoh^;Rolg=cOnOWiooKVIOoi=b8_o]dDConO=doogmSOomoIGooOf>ooWh
M_o]edOoTg<RofiWGonOWioocLg=on;Rh_oWinL00ooXj>P04ooWinOoh^;R
olg=cOnOWiooH6QOod]l8onBhD_o_OUkom3mT_oHoI_oe?fEol3iO_nHj4go
CH0Tof1YGonOWioocLg=on;Rh_oWinL0H?oXj>P1onc/k07ol_;b0Oofm_H0
0003ooOgmoohn?Son?Sh00?on?Sh01?omoOgonk^k_o>c/koT92@ohD_:ooY
I5Koni:7oojVVoon/JGookNZoojcY_onZ9conYB9oniXFOn9<B_oT92@olk>
c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@oiUY:oo`_Cgonn1^
ookdP_onoX[ooonBooknS?onn8?onnE`oo32?_nIJR_oT92@olk>c_o^k^ko
moOg00?on?Sh01?omoOgonk^k_o>c/koT92@od9c:on4cT?o[Nmcol;nR?o>
oY3oe_nGom3nT_o6oXWo/_EdohSC@om4MB_oT92@olk>c_o^k^komoOg05Wo
n?Sh00?omoOgooShn?ohn?P00_ohn?P01?ogmoOonOWiooOgmoogmoL1ooSh
n00000?on_[jooGemOo^k^h00_o/k>`0Uoo[jn_ojNWYomoOgonj^[[oN59B
oklb9?oVLfSooHUnoonGRoonXYKoojRLoojTV?ooVXgooXYoonifJ_o3<bCo
NE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/on[Zj_oOgmoo^[ZjohQUD_oR
TAconL=@oogJHooojW;oo_=nooojP_onmWooonacookNI?ojae7ohY8LohUV
Donj^[[ogmoOon[Zj_o[jn_ok>c/on_[jooZj^[ogmoOokZj^_mBKE;oDJ<L
oi7BEOnVif[o^?Ujol3nP_o7ohWo`oj4okWmNonWk6coU=IGoe:V7?mBKE;o
^[ZjomoOgooZj^[ojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jn`0
1_o[jn/01Oo/k>cojn_[on_[joo^k^kom_Kf007onOWi00000ookno_olo?c
ong]k@02onGUi@2GonKVi_oTi>CofMWIok:b/_mi;Rkob48con=ZG?odNVgo
oHQloojGR_onVhkooYR;ooj:O_odNfgoif]MolY2=?mk;Rko/[:bomSHf?oT
i>CoiNGUonKVi_oUiNKoi>CTomSHf?nb/[;oUUD^onZL:ook_4Coo/aCoogH
H_onhg;oo^UeookVLoonffGooLaCoo_1AOo^WR_oVEH^ok:b/_oHf=Soi>CT
onGUiOoVi^KoiNGUonCTi?oHf=Wo/[:bobiR;_mS[B_oQlY8oiOLFOnUiFWo
/_=gokSfNondmGWoYnY[oiSLFOn9cd_oHjh[obiS;_nb/[;of=SIonCTi?oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUiP02onKViP03onGUiOoV
i^Koi^KV00?oi^KV00?oiNGUong]kOodm?@00Oojn_X00003ooclo?ohn?So
lO7a00?ok^k^01?ojn_[on7QhOnl_;coNQLGol<o<_oCETWoi6QJonmgK?od
PgWomhMlooF4N_ocNFgoiFUKomUHB_o4?c;oO1LGokbl_?oQhN7ok>c/00?o
k^k^01?ok>c/on7QhOnl_;coYDLGonJG<_oe[33ooKa1oog9Doomd63onm=U
oogBH?oncECooKe2ooZ_<_oYVc;oYDHGokbl_?oQhN7ok>c/00?ok^k^01?o
k>c/on7QhOnl_;co5eTGoenX<_mf_COoQ/e7oiKFF_nRh6GoXn1Yoj?QIonG
fUcoQ/i7ogNo=omOZc;o5eTGokbl_?oQhN7ok>c/05ook^k^00?okNg]oo;b
l_ohn?P00Oolo?`000?ooOgm01Koo?cloogmoOomoOgoo?cloo?clooAdM7o
J0L7okPd=?o7?c?odU13omYREOoSKV;oi79TonA_H_oLI5Oode53ola1=?ni
=3CoJ`L7om;Bd_oclo?oo?cl0oomoOd04oolo?colo?com;Bd_nN:`OofXXd
on^K6OoeZ2Won;@oooVmB_oh_dgon[m:ooVh?oofZR[okihIom^;=?nR;@Oo
d];Boo?cloolo?`00oomoOd04oolo?colo?com;Bd_l7@0OoCIXdoen[8?m`
^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^BooHZhPodjK=?l7@POod];Boo?c
loolo?`0GOomoOd00oolo?cooOgmooclo003oogmo@0003[ooOgmoo[jn_oc
lo?ok^k^oo3`l?o_knook^k^onWYjOoCdm?oFQ`Loj8d=?nd:1go`CT/olM9
??o?ET[od5M;om1GB_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^
oo3`l?o_knool?3_onk^k_oZj^[odm?Coh`U7Oo8LCCofH@MonBD5OoWWBCo
kZPcoo2Z=?o_ZS?ok:0UonNG5OoLR1gob74doh`U7OoCdm?oj^[Zonk^k_o`
l?3okno_oo3`l?o^k^koj^[Yom?CdolM>1go=88dodNE7OmJYA_oJJdZ0_md
^3P0HOme^CSoJk4[oe^W7?m8VQgo=88doadh7OoCdm?oj^[Yonk^k_o`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knl00_o`l?06ono_k`7o
lo?c0OoinOT1ooknoP0000?oo_knooOgmoo`l?001?oYjNT04OoWinOofm_K
of=;Bon1<S;oYSDeokHd;Oo2CD7o`eA9olAEB_o3E4Wo`Te1okHd;OnU=CGo
PC8bof=;BooKfm_oinOW00GojNWY017oinOWom_Kfon9Bd_o[d/boleg=OoF
Rbgoh9`^on2P<_oQX3Coh:0bomnJ;_oFRbgobWDeojm;<_n9Bd_ofm_KonOW
i`05onWYj@0AonOWiooKfm_oBd];oc9P<_ljRCGoDi/]of^[;om`[CSoKjhj
og2]>?mZZRooDi/]ocV8=OlbH3;oBd];om_KfooWinL0F_oYjNT00ooXj>So
jNWYonWYj@04onWYj@7ol?3`0OogmoL1ooknoP0000Goo_knoo[jn_odm?Co
kno_oo7al@02oo3`l00Aono_koo[jn_oUIBDodlS8onEE5Co^g=com>EUOoJ
W9cofYjLomVLW?oDUIGo^g=coiEDE?m?8b?oUIBDon[Zj_o_knl01Oo`l?00
4Oo_knooj^[ZojVDU?n18b?o^VYDomBJLooT_9Goj/NLonW7W?oZaicoiKbE
omBJLonkJUCoPB<SojZDU?oZj^[okno_00Gol?3`017okno_on[Zj_nDU9Co
8bXSoeAjE?mcYG?oW/JEojc>W?n]cYco[<jLoik6UOmcYG?oE7YDob<Z8onD
U9Coj^[Zono_k`1Ooo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn00001?o/
k_3oooooooooooono_h2ooooo`;oo_kn09OooOgmooShn?m^KVkoFSlook6@
T?oNbLWol>CToo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?cooooo
ookno_ooooooo_knooooo_ono_koooooooclo?ohn?SoSFe]ohXo?oo9TI3o
jM39ooCYi?ofjnKom>WTonW@bOo9TI3oRCloohe]KOohn?Ooo?clooooooon
o_koooooookno_ooooooo_knooooo_olo?con?Shofe]KOlo?cooT9f@olWE
bOoTk>Coi^kVonC/i?o9eLWoT9f@oclo?om]KFgon?Shooclo?ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
00;ooooo00?oo_knooooooooool00oooool1onc^l00000Co`LS>ookno_oj
n_[om?Cd1OoalO403Oo_knooe]KFof][Jom3?CgoVhb<olJj^_oFc<coakZj
oi^<S?m3?CgoJf][omKFe_o_knl02OoalO403Oo_knooemKFoh=[Jomd?Cgo
]Hb<omFj^_oQc<coe[ZjokJ<S?mb?CgoPF][omOFe_o_knl02OoalO403Oo_
knooe]KFof][Jolm?CgoS8b<okZj^_o<cLco^[Zjohb<S?lm?CgoJf][omKF
e_o_knl0F_oalO401?o`l?3olO7aoo7alOo`l?04oo7al@03ooCdm?ojn_[o
o_kn007o_lG;00001On4SiWooOgmooShn?o`l?3ojn_[00?oj^[Z00gojNWY
on[Zj_oYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>So
jNWY00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo@RHVofUIFOnP
Vi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV
9_mIFEWoVi^KonSXj?oYjNT0H_oZj^X01?o[jn_ol?3`ooOgmoomoOd1ogn9
U00000Co=TIAokS0aOoinOWom?Cd2?oalO42oo3`l0?okno_0_o`l?0?oo7a
l@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`H?oalO400oo`
l?3olO7aoo7al@02oo7al@03ooGemOojn_[o]Kc3007o;ci<00000olM;coo
C5USokVoa@2Rooooo`7o][c10Om7Del1oaHX=`0000Ko72hmoaXY=Olb?4Ko
OXR@okg3b?o[k>jLooooo`05on[[kOnk`<GoNH>;obdh@olE8bl00OlH:CL0
0001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{168, 63},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleMathJFrame",
        ButtonData:>{"SimpleMathJFrame.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SimpleMathJFrame[]\)], "Input"],

Cell[BoxData[
    \("Final value was 5."\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JLayeredPane, JInternalFrame <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Qnc<c<aVIVVOo<c<`ec<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^7g<c<`?IVJI[9VIc0eVIYWoc<c<=<c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Qmc<c<3VIVVJ`0000>IVJIolc<c3C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hOLc<c<QVIYWoc<c<=<c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Qmc<c<b6IVVOo<c<`dc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^7g<c<`5IVJI_/c<c0EVIYWoc<c<=<c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Qmc<c<1FIVVKk<c<`5IVJIolc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hOLc<c0EVIYVnc<c<1FIVVOo<
c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^7g<c<`5IVJI_/c<
c0EVIYWoc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qmc<c<
1FIVVKk<c<`5IVJIolc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hOLc<c0EVIYVnc<c<1FIVVOo<c<`dc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^7g<c<`5IVJI_/c<c0EVIYWoc<c<=<c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Qmc<c<1FIVVKk<c<`5IVJIolc<c3C<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hOLc<c0=VIYT00iVIc6IVVLc<c02m
c<c<0fIVV@03VIW<IVJIc<c<0?o<c<`cc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^7g<c<`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VI
c6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qmc<c<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hOLc<c09VIYT00`0009VIc6IV
V@2nc<c<0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^7g<c<`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`00
09VIc6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qm
c<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hOLc<c09VIYT00`0009VI
c6IVV@2nc<c<0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^7g<c<`2IVJI00<0002IVLaVIYT0_/c<c09VIYT0
0`0009VIc6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Qmc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<
c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hOLc<c09VIYT00`00
09VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^7g<c<`2IVJI00<0002IVLaVIYT0_/c<c09V
IYT00`0009VIc6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Qmc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hILc<c1YVIYT0
0`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^6C<c<`?IVJI2YVIc09VIYT00`0009VI
c6IVV@2nc<c<0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^6C<c<`>IVJI2`00009VIYT00`0009VIc6IVV@2n
c<c<0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^6C<c<`KIVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VI
c6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QTc<c<
6fIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI<c<c0EVIYTDc<c<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hI<c<c0EVIYTDc<c<0VIVV@030000VIW<
IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hI<c<c0EVIYTDc<c<0VIVV@030000VIW<IVJI0;k<
c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hI<c<c0EVIYTDc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI
00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hI<c<c0EVIYTDc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002I
VLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI<c<
c0EVIYTDc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI<c<c0EVIYTD
c<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI<c<c0EVIYTDc<c<0VIV
V@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hI<c<c0=VIYT00iVIc6IVVLc<c00C
c<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI<c<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002I
VLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI<c<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI
00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hI<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<
c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hI<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hI<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hI<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI<c<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<
c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaV
IYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI<c<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
I<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2
IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2hC<c<c1YVIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hBlc<c0mVIYT:VIW<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@3oc<c<=<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Q;c<c<3VIVV@/00002IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<
IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^4_<c<`K
IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@03
0000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^4_<c<`KIVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2nc<c<
0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^4_<c<`5IVJI5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hBlc<c0EVIYTDc<c<0VIVV@030000VIW<
IVJI01C<c<`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@3o
c<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Q;c<c<1FIVVAC<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2nc<c<0VIV
V@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^4_<c<`5IVJI5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hBlc<c0EVIYTDc<c<0VIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@3oc<c<
=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Q;c<c<1FIVVAC<c<`2
IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@03
0000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^4_<c<`5IVJI5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hBlc<c0EVIYTDc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@3oc<c<=<c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Q;c<c<0fIVV@03VIW<IVJI
c<c<01?<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2n
c<c<0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^4_<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hBlc<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT0_/c<c09VIYT00`0009VIc6IVV@3oc<c<=<c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Q;c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000
VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^4_<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hBlc<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0_/c<c09V
IYT00`0009VIc6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Q;c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI0?o<c<`d
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^4_<c<`2IVJI00<0002I
VLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hBlc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IV
V@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Q;c<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^4_<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
Blc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@3oc<c<=<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<6VIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2nc<c<
0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^3;<c<`?IVJI2YVIc09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VI
c6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pbc<c<
3VIVV@/00002IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h</c<c1]VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0
_/c<c09VIYT00`0009VIc6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Pbc<c<6fIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT05<c<c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI
0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3;<c<`5IVJI
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@3oc<c<=<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Pbc<c<1FIVVAC<c<`2IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h</c<c0EVIYTDc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2nc<c<0VIV
V@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^3;<c<`5IVJI5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IV
V@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pbc<c<1FIV
VAC<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h</c<c0EVIYTDc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@2nc<c<0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^3;<c<`5IVJI5<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0_/c<c09V
IYT00`0009VIc6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Pbc<c<1FIVVAC<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaV
IYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h</c<c0=V
IYT00iVIc6IVVLc<c00Cc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<
IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3;<c<`2
IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VI
c6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pbc<c<
0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002I
VLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h</c<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000
VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3;<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`00
09VIc6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pb
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
</c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@03
0000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^3;<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0_/c<c09VIYT0
0`0009VIc6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Pbc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI
00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h</c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2nc<c<0VIV
V@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^3;<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0_/c<c09V
IYT00`0009VIc6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Pbc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2
IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6/c<c1YVIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2nc<c<
0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^1W<c<`?IVJI2YVIc09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@2nc<c<0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^1W<c<`>IVJI2`00009VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^1W<c<`KIVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@3oc<c<=<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<6fIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c0EVIYTDc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c0EVIYTD
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6Lc<c0EVIYTDc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaV
IYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<
c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6Lc<c0EVIYTDc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6Lc<c0EVIYTDc<c<0VIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c0EVIYTDc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c0EVIYTD
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6Lc<c0EVIYTDc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaV
IYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<
c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6Lc<c0=VIYT00iVIc6IVVLc<c00Cc<c<0VIVV@030000VIW<
IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2
IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI
00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002I
VLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaV
IYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<
c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaV
IYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<
c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2
IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI
00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002I
VLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaV
IYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<
c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaV
IYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<
c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2
IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI
00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002I
VLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaV
IYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<
c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaV
IYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<
c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2
IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI
00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002I
VLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaV
IYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<
c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaV
IYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<
c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2
IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI
00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002I
VLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaV
IYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<
c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaV
IYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<
c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2
IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI
00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002I
VLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaV
IYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<
c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaV
IYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<
c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2
IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI
00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002I
VLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaV
IYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<
c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaV
IYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<
c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2
IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0olc<c3C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI0;k<c<`2IVJI
00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI0<1VIYT00`0009VIc6IVV@3oc<c<=<c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0_/c<o`9VIYT00`0009VI
c6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<
0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT0_/c<o`9VIYT00`0009VIc6IVV@3oc<c<=<c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0_/c<o`9VIYT00`0009VIc6IV
V@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaV
IYT01Lc<o`03ooooR8R8A4A400I4A4@00c<c<dA4A4A4A003A4A400>IVIW<
c?o<c?l0BLc<o`05IVJIc<coc<coc<coIVJI00?<c?l01FIVVLc<olc<olc<
ofIVV@03c<co00EVIYW<c?o<c?o<c?mVIYT00lc<o`03IVJIc<coc<co04?<
c?l2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI00G<c?l00oooodA4A6IVIP03MgMg00=VIVIg
MgMgMgL01GMgM`03<c<cc<c<c<co01W<c?l400004/c<o`<0000Gc<co00Go
ooo<c?o<c?o<c?ooool00lc<o`05ooooc<coc<coc<cooooo00?<c?l01Ooo
olc<olc<olc<ooooo`03c<co00?oooo<c?o<c?l01/c<o`Ooool;c<co2_oo
oa3<c?l>oooo1<c<o`9VIYT00`0009VIc6IVV@3oc<c<=<c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT01Lc<o`0<oooo<c<ck^k^
k^k^^k^kMgMgZZZZooook^k^gMgMMgMggMgM0^k^kP03MgMgc<c<c<co01S<
c?l010000<c<olc<olc<o`80000Cc<co0P0001G<c?l01FIVVLc<olc<olc<
ofIVV@03c<co00EVIYW<c?o<c?o<c?mVIYT00lc<o`05IVJIc<coc<coc<co
IVJI00?<c?l00fIVVLc<olc<o`06c<co00<0001VIYUVIYT016IVV@03oooo
c<coc<co00S<c?l00`0006IVVFIVV@07IVJI00?oooo<c?o<c?l03Lc<o`03
0000IVJIIVJI00]VIYT00oooolc<olc<o`02c<co0VIVV@030000VIW<IVJI
0?o<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1W<c<`2IVJI
00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IV
V@05c<co00Kooolc<c?oooo^k^igMgL0<l`2<c<000Q4A4@c03<0029V06Ig
MgOooomgMgNk^k/5c<co1@0000?<c?l200001<c<o`D00002c<co0P000003
c<co0000000000C<c?l600000/c<o`D00002c<co0`0000?<c?l400000/c<
o`800008c<co00Goooo<c?o<c?o<c?ooool00lc<o`05ooooc<coc<coc<co
oooo00?<c?l01Oooolc<olc<olc<ooooo`03c<co00?oooo<c?o<c?l01lc<
o`030000IVJIIVJI00<000000fIVVOooolc<o`09c<co00<0001VIYUVIYT0
0VIVV@@000000fIVVOooolc<o`0>c<co00<0001VIYUVIYT02P000003IVJI
ooooc<co00?<c?l2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI00G<c?l04?ooogMgMnk^k^k^
kVIVIP1Vo`1Vc4A4A3<0<c<c<gMgMc<0<hR8R>k^kVIVI/c<c0G<c?l20000
0/c<o`800002c<co0P0000?<c?l200000/c<o`8000001<c<o`0000000<c<
o`<00004c<co0P0000G<c?l200000/c<o`800002c<co0`0000;<c?l20000
0/c<o`8000000lc<o`000000000;c<co00EVIYW<c?o<c?o<c?mVIYT00lc<
o`05IVJIc<coc<coc<coIVJI00?<c?l01FIVVLc<olc<olc<ofIVV@03c<co
00=VIYW<c?o<c?l01<c<o`030000IVJIoooo00;<c?l00`0006IVVOooo`0:
c<co00D0001VIYUVIYUVIYWoool00lc<o`030000IVJIoooo00o<c?l00`00
06IVVLc<o`07c<co00Goooo<c?l0001VIYWoool01<c<o`9VIYT00`0009VI
c6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<
0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT01Lc<o`05oooo<c<ck^k^gMgM4A4A0080I_l02C=Vc28R8XR8R9VI
VB8R8]gMgNk^kWMgMlc<c005c<co0P0000?<c?l2000000?<c?l000000000
0lc<o`800002c<co0P000003c<co0000000000;<c?l200001<c<o`800005
c<co0P0000;<c?l2000000C<c?l00000003<c?l2000000?<c?l000000000
1Lc<o`80000:c<co00Goooo<c?o<c?o<c?ooool00lc<o`05ooooc<coc<co
c<cooooo00?<c?l01Oooolc<olc<olc<ooooo`03c<co00?oooo<c?o<c?l0
1Lc<o`030000IVJIoooo00;<c?l00`0006IVVOooo`0:c<co00<0001VIYT0
00000VIVV@06ooooc<coc<co0000IVJIoooo3lc<o`060000IVJIc<coc<co
IVJIoooo0lc<o`06IVJIoooooooo0000IVJIoooo1<c<o`9VIYT00`0009VI
c6IVV@3oc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<
0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT01Lc<o`06oooo<c<ck^k^<c<c<`0c000A0R8R8P0803<c<`0c4@00
0000<c<c^k^kMgMg^k^k1Lc<o`800003c<co0P000003c<co0000000000C<
c?l2000000C<c?l00000003<c?l200000/c<o`800004c<co0P0000K<c?l2
000000C<c?l00000003<c?l2000000C<c?l00000003<c?l6000000?<c?l0
000000002Lc<o`05IVJIc<coc<coc<coIVJI00?<c?l01FIVVLc<olc<olc<
ofIVV@03c<co00EVIYW<c?o<c?o<c?mVIYT00lc<o`03IVJIc<coc<co00K<
c?l00`0006IVVOooo`02oooo0VIVV@03ooooc<coc<co00S<c?l0100006IV
VOooo`00009VIYT01Oooolc<o`0006IVVOooo`0?c<co00@0001VIYW<c?l0
0002IVJI0_ooo`=VIYT01<c<o`0006IVVOooo`C<c?l2IVJI00<0002IVLaV
IYT0olc<c3C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI00G<c?l04?ooogMgMfHcIVHcIWMgMhR8R6IVIS<c000cc01Vc3<0IP00
06HcIS<c<gMgMlc<c0G<c?l200000lc<o`8000000lc<o`0000000005c<co
10000003c<co0000000000;<c?l200001<c<o`800007c<co10000004c<co
00000000c<co0P000003c<co0000000000;<c?l2000000?<c?l000000000
2<c<o`05ooooc<coc<coc<cooooo00?<c?l01Oooolc<olc<olc<ooooo`03
c<co00Goooo<c?o<c?o<c?ooool00lc<o`03ooooc<coc<co00O<c?l00`00
06IVVFIVV@04IVJI2lc<o`050000IVJIooooc<co0000009VIYT01?ooofIV
VFIVVOooo`o<c?l01@0006IVVLc<olc<o`000005IVJI0/c<o`030000IVJI
oooo00C<c?l2IVJI00<0002IVLaVIYT0olc<c3C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI00G<c?l02OooodA4A3<0<l`0c6Hc
IVIVIQ4009UV0<bI000206K<0YT0V@03^k^kMgMgc<c<00G<c?l200000lc<
o`8000000lc<o`0000000003c<co00@0003<c?o<c?o<c?l2000000C<c?l0
0000003<c?l300001<c<o`800005c<co00@0003<c?o<c?o<c?l400000lc<
o`@00002c<co0P000003c<co0000000000_<c?l01FIVVLc<olc<olc<ofIV
V@03c<co00EVIYW<c?o<c?o<c?mVIYT00lc<o`05IVJIc<coc<coc<coIVJI
00?<c?l00fIVVLc<olc<o`04c<co1`000003c<cooooooooo00Coool4c<co
00<0001VIYWoool00/c<o`030000IVJIIVJI009VIYT00oooolc<olc<o`0=
c<co00<0001VIYW<c?l00/c<o`050000IVJIIVJIIVJIoooo00;<c?l00`00
06IVVOooo`04c<co0VIVV@030000VIW<IVJI0?o<c<`dc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0006IVVFIVV@05c<co00Cooolc<c?<c<a4
A4@2000000Xc03=VIP3oc02IIP1V06K<0?mV06IV<fIgMgNk^k/5c<co0P00
00?<c?l2000000?<c?l0000000000P0000;<c?l400000lc<o`8000000lc<
o`0000000004c<co0P0000K<c?l4000000?<c?l0000000000lc<o`800000
0lc<o`000000000200000/c<o`@00008c<co00Goooo<c?o<c?o<c?ooool0
0lc<o`05ooooc<coc<coc<cooooo00?<c?l01Oooolc<olc<olc<ooooo`03
c<co00?oooo<c?o<c?l03<c<o`030000IVJIIVJI00=VIYT00oooolc<olc<
o`02c<co00<0001VIYWoool00oooo`050000IVJIIVJIIVJIoooo00;<c?l2
oooo2lc<o`030000IVJIc<co00;<c?l4IVJI00Koooo<c?o<c?l0001VIYWo
ool4c<co0VIVV@030000IVJIIVJI0?o<c<`dc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaV
IYT05<c<c0EVIYT5c<co00OooomgMgO^k^k^k^hR8R:I09UV<fH00VH0IP07
<`0cVFH04A4Ac<c<k^k^MgMgc<c<00G<c?l200000/c<o`80000Hc<co0P00
02C<c?l01FIVVLc<olc<olc<ofIVV@03c<co00EVIYW<c?o<c?o<c?mVIYT0
0lc<o`05IVJIc<coc<coc<coIVJI00?<c?l00fIVVLc<olc<o`0=c<co00@0
001VIYUVIYUVIYT200001Lc<o`030000IVJIIVJI00MVIYT2oooo0VIVV@03
ooooc<coc<co00W<c?l0100006IVVLc<olc<o`=VIYT0200006IVVFIVVOoo
olc<o`0006IVVOooo`C<c?l5IVJIolc<c3C<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IV
V@0Dc<c<1FIVV@G<c?l01_ooodA4A>k^kYVIVA4A4DA4A0;<0<`019T0V@0c
I/bI07MgM`;^k^h00gMgMlc<c<c<o`04c<co1@0001W<c?l200008lc<o`05
ooooc<coc<coc<cooooo00?<c?l01Oooolc<olc<olc<ooooo`03c<co00Go
ooo<c?o<c?o<c?ooool00lc<o`03ooooc<coc<co00k<c?l01@0006IVVFIV
VFIVVOooo`06c<co2@00009VIYT01?ooofIVVFIVVOooo`_<c?l0100006IV
VLc<o`00009VIYT2c<co00L0001VIYUVIYW<c?l0001VIYWoool01<c<o`EV
IYWoc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`5IVJI1Lc<o`09oooo
<c<ck^k^MgMg<c<cIVIV<c<cc03<A4A40080<fH01GMgMnk^k^k^kWMgMk^k
^`1;c<co00EVIYW<c?o<c?o<c?mVIYT00lc<o`05IVJIc<coc<coc<coIVJI
00?<c?l01FIVVLc<olc<olc<ofIVV@03c<co00=VIYW<c?o<c?l02lc<o`03
0000IVJI0000009VIYT00oooolc<olc<o`0<c<co00<0001VIYUVIYT00VIV
V@03ooooc<coc<co00W<c?l01@0006IVVLc<olc<o`000004c<co00H0003<
c?o<c?l0001VIYWoool4c<co1FIVVOo<c<`dc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaV
IYT05<c<c0EVIYT5c<co00?ooomgMgO^k^h00nk^kP06^k^kIS=Vooook^k^
VIVIR8R80^k^kP03MgMgc<c<c<co04W<c?l01Oooolc<olc<olc<ooooo`03
c<co00Goooo<c?o<c?o<c?ooool00lc<o`05ooooc<coc<coc<cooooo00?<
c?l00oooolc<olc<o`0<c<co00@0001VIYWoool00002IVJI00?oooo<c?o<
c?l02lc<o`03oooo0000IVJI009VIYT00oooolc<olc<o`09c<co00<0001V
IYW<c?l02Lc<o`9VIYT00oooolc<olc<o`02c<co1FIVVOo<c<`dc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0002IVLaVIYT05<c<c0EVIYT5c<co00?ooolc<c?oool02nk^kP03
MgMgc<c<c<co04S<c?l01FIVVLc<olc<olc<ofIVV@03c<co00EVIYW<c?o<
c?o<c?mVIYT00lc<o`05IVJIc<coc<coc<coIVJI00?<c?l00fIVVLc<olc<
o`0=c<co0P0000;<c?l00`0006IVVFIVV@0<c<co00<0001VIYUVIYT00fIV
V@03ooooc<coc<co00W<c?l00`0006IVVFIVV@0;IVJI00?oooo<c?o<c?l0
0/c<o`EVIYWoc<c<=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PI
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`5IVJI1Lc<
o`03oooo<c<cMgMg00agMgL00oooolc<olc<o`16c<co00Goooo<c?o<c?o<
c?ooool00lc<o`05ooooc<coc<coc<cooooo00?<c?l01Oooolc<olc<olc<
ooooo`03c<co00?oooo<c?o<c?l04lc<o`030000c<coc<co00_<c?l60000
3<c<o`h00005c<co1FIVVOo<c<`dc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<
c0EVIYVnc<co1FIVVOo<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c0EV
IYVnc<co1FIVVOo<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c0IVIYVl
c<co1VIVVOo<c<`dc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1W<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c<QVIYWoc<c<
=<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000
VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`?IVJI[9VIc0eVIYWoc<c<=<c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<
IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI029VIYV/00003VIVVOo<c<`dc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT05<c<olQVIYWoc<c<=<c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI
01C<c?l00lc<c6IVVFIVV@34IVJIolc<c3G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000
VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IV
V@2nc<co0VIVV@030000VIW<IVJI0?o<c<a=c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaV
IYT01Lc<o`03ooooR8R8A4A400I4A4@00c<c<dA4A4A4A003A4A400>IVIW<
c?o<c?l0D/c<o`05IVJIc<coc<coc<coIVJI00?<c?l01FIVVLc<olc<olc<
ofIVV@18c<co0VIVV@030000VIW<IVJI0?o<c<a=c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT01Lc<o`03ooooA4A4IVIV00=gMgL00fIVIWMgMgMgM`05MgMg00<c
<c?<c<c<c?l04lc<o`80000<c<co0P0001G<c?l300005lc<o`05ooooc<co
c<coc<cooooo00?<c?l01Oooolc<olc<olc<ooooo`0;c<co1oooo`_<c?l:
oooo4<c<o`koool4c<co0VIVV@030000VIW<IVJI0?o<c<a=c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT01Lc<o`0<oooo<c<ck^k^k^k^^k^kMgMgZZZZooook^k^
gMgMMgMggMgM0^k^kP03MgMgc<c<c<co01?<c?l200003<c<o`80000Gc<co
0P0001G<c?l01FIVVLc<olc<olc<ofIVV@03c<co00EVIYW<c?o<c?o<c?mV
IYT00lc<o`03IVJIc<coc<co00G<c?l00`0006IVVFIVV@04IVJI00?oooo<
c?o<c?l02<c<o`030000IVJIIVJI00MVIYT00oooolc<olc<o`0=c<co00<0
001VIYUVIYT02fIVV@03ooooc<coc<co00;<c?l2IVJI00<0002IVLaVIYT0
olc<c4g<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002I
VLaVIYT05<c<c09VIYT00`0009VIc6IVV@05c<co00Kooolc<c?oooo^k^ig
MgL0<l`2<c<000Q4A4@c03<0029V06IgMgOooomgMgNk^k/5c<co0P0000O<
c?l400000/c<o`8000000lc<o`0000000003c<co0P000004c<co00000000
c<co0P000003c<co0000000000G<c?l600000/c<o`D00002c<co0`0000?<
c?l400000/c<o`800008c<co00Goooo<c?o<c?o<c?ooool00lc<o`05oooo
c<coc<coc<cooooo00?<c?l00oooolc<olc<o`06c<co00<0001VIYUVIYT0
0`000003IVJIooooc<co00W<c?l00`0006IVVFIVV@02IVJI10000003IVJI
ooooc<co00k<c?l00`0006IVVFIVV@0:000000=VIYWoooo<c?l00lc<o`9V
IYT00`0009VIc6IVV@3oc<c<CLc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI00G<c?l0
4?ooogMgMnk^k^k^kVIVIP1Vo`1Vc4A4A3<0<c<c<gMgMc<0<hR8R>k^kVIV
I/c<c0G<c?l200001/c<o`800002c<co0P000005c<co000000000000c<co
008000001<c<o`0000000<c<o`<000001Lc<o`00000000000<c<o`020000
1<c<o`800005c<co0P0000;<c?l200000/c<o`<00002c<co0P0000;<c?l2
000000?<c?l0000000002lc<o`05IVJIc<coc<coc<coIVJI00?<c?l01FIV
VLc<olc<olc<ofIVV@09c<co00<0001VIYWoool00/c<o`030000IVJIoooo
00[<c?l01@0006IVVFIVVFIVVOooo`03c<co00<0001VIYWoool03lc<o`03
0000IVJIc<co00O<c?l01Oooolc<o`0006IVVOooo`04c<co0VIVV@030000
VIW<IVJI0?o<c<a=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1W<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT01Lc<o`05oooo<c<c
k^k^gMgM4A4A0080I_l02C=Vc28R8XR8R9VIVB8R8]gMgNk^kWMgMlc<c005
c<co0P0000K<c?l200000/c<o`8000000lc<o`0000000002c<co0P000003
c<co0000000000;<c?l2000000?<c?l0000000000/c<o`800004c<co0P00
00G<c?l200000/c<o`8000001<c<o`0000000<c<o`8000000lc<o`000000
0005c<co0P0000[<c?l01Oooolc<olc<olc<ooooo`03c<co00Goooo<c?o<
c?o<c?ooool02/c<o`030000IVJIoooo00;<c?l00`0006IVVOooo`0:c<co
00<0001VIYT000000VIVV@06ooooc<coc<co0000IVJIoooo3lc<o`060000
IVJIc<coc<coIVJIoooo0lc<o`06IVJIoooooooo0000IVJIoooo1<c<o`9V
IYT00`0009VIc6IVV@3oc<c<CLc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI00G<c?l0
1_oooc<c<nk^kS<c<c<0<`004@8R8R80200c<c<0<a40000003<c<k^k^gMg
Mk^k^`G<c?l600000/c<o`800002c<co0P000003c<co0000000000;<c?l2
000000?<c?l0000000000/c<o`8000000lc<o`0000000002c<co0P0000C<
c?l200001/c<o`8000001<c<o`0000000<c<o`8000001<c<o`0000000<c<
o`H000000lc<o`0000000009c<co00EVIYW<c?o<c?o<c?mVIYT00lc<o`05
IVJIc<coc<coc<coIVJI00?<c?l00fIVVLc<olc<o`05c<co00<0001VIYWo
ool00_ooo`9VIYT00oooolc<olc<o`08c<co00@0001VIYWoool00002IVJI
00Goooo<c?l0001VIYWoool03lc<o`040000IVJIc<co00000VIVV@;oool3
IVJI00C<c?l0001VIYWoool4c<co0VIVV@030000VIW<IVJI0?o<c<a=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaV
IYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT01Lc<o`0@ooooMgMgIS=VIS=VMgMgR8R8IVIV
<c<003?<06K<<`1V0000IS=V<c<cMgMgc<c<1Lc<o`800003c<co0P000003
c<co0000000000;<c?l2000000?<c?l0000000000/c<o`8000000lc<o`00
00000002c<co0P000003c<co0000000000;<c?l200001<c<o`800007c<co
10000004c<co00000000c<co0P000003c<co0000000000;<c?l2000000?<
c?l0000000002<c<o`05ooooc<coc<coc<cooooo00?<c?l01Oooolc<olc<
olc<ooooo`03c<co00?oooo<c?o<c?l01/c<o`030000IVJIIVJI00AVIYT;
c<co00D0001VIYWoooo<c?l000000VIVV@04ooooIVJIIVJIoooo3lc<o`05
0000IVJIc<coc<co000000EVIYT2c<co00<0001VIYWoool01<c<o`9VIYT0
0`0009VIc6IVV@3oc<c<CLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PIc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI00G<c?l02Ooo
odA4A3<0<l`0c6HcIVIVIQ4009UV0<bI000206K<0YT0V@03^k^kMgMgc<c<
00G<c?l200000lc<o`800002c<co00<0003<c?o<c?l00P000005c<co0000
00000000c<co008000000lc<o`0000000002c<co0P000005c<co00000000
0000c<co00800004c<co0P0000G<c?l010000<c<olc<olc<o`@00003c<co
100000;<c?l2000000?<c?l0000000002lc<o`05IVJIc<coc<coc<coIVJI
00?<c?l01FIVVLc<olc<olc<ofIVV@09c<co1`000003c<cooooooooo00Co
ool4c<co00<0001VIYWoool00/c<o`030000IVJIIVJI009VIYT00oooolc<
olc<o`0=c<co00<0001VIYW<c?l00/c<o`050000IVJIIVJIIVJIoooo00;<
c?l00`0006IVVOooo`04c<co0VIVV@030000VIW<IVJI0?o<c<a=c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2
IVJI00<0001VIYUVIYT01Lc<o`04oooo<c<cc<c<A4A40P00000:<`0cIVH0
ol`0VFH0IP1Vc03oIP1VIS=VMgMg^k^k1Lc<o`800003c<co0P0000;<c?l4
00000/c<o`8000000lc<o`0000000002c<co0P0000;<c?l2000000C<c?l0
0000003<c?l200001Lc<o`800006c<co10000003c<co0000000000?<c?l2
000000?<c?l0000000000P0000;<c?l400002<c<o`05ooooc<coc<coc<co
oooo00?<c?l01Oooolc<olc<olc<ooooo`0Ac<co00<0001VIYUVIYT00fIV
V@03ooooc<coc<co00;<c?l00`0006IVVOooo`03oooo00D0001VIYUVIYUV
IYWoool00/c<o`;oool;c<co00<0001VIYW<c?l00/c<o`AVIYT01_ooolc<
olc<o`0006IVVOooo`C<c?l2IVJI00<0001VIYUVIYT0olc<c4g<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c0EV
IYT5c<co00OooomgMgO^k^k^k^hR8R:I09UV<fH00VH0IP07<`0cVFH04A4A
c<c<k^k^MgMgc<c<00G<c?l200000lc<o`80000Pc<co0P0002C<c?l01FIV
VLc<olc<olc<ofIVV@03c<co00EVIYW<c?o<c?o<c?mVIYT00lc<o`03IVJI
c<coc<co00c<c?l0100006IVVFIVVFIVV@800005c<co00<0001VIYUVIYT0
1fIVV@;oool2IVJI00?oooo<c?o<c?l02Lc<o`040000IVJIc<coc<co0fIV
V@080000IVJIIVJIooooc<co0000IVJIoooo1<c<o`EVIYWoc<c<CLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
1FIVV@G<c?l01_ooodA4A>k^kYVIVA4A4DA4A0;<0<`019T0V@0cI/bI07Mg
M`;^k^h00gMgMlc<c<c<o`04c<co1P00027<c?l200008lc<o`05ooooc<co
c<coc<cooooo00?<c?l01Oooolc<olc<olc<ooooo`03c<co00?oooo<c?o<
c?l03Lc<o`050000IVJIIVJIIVJIoooo00K<c?l900000VIVV@04ooooIVJI
IVJIoooo2lc<o`040000IVJIc<co00000VIVV@;<c?l01`0006IVVFIVVLc<
o`0006IVVOooo`04c<co1FIVVOo<c<a=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`5IVJI1Lc<o`09oooo<c<c
k^k^MgMg<c<cIVIV<c<cc03<A4A40080<fH01GMgMnk^k^k^kWMgMk^k^`1D
c<co00EVIYW<c?o<c?o<c?mVIYT00lc<o`05IVJIc<coc<coc<coIVJI013<
c?l00`0006IVV@000002IVJI00?oooo<c?o<c?l03<c<o`030000IVJIIVJI
009VIYT00oooolc<olc<o`09c<co00D0001VIYW<c?o<c?l000001<c<o`06
0000c<coc<co0000IVJIoooo1<c<o`EVIYWoc<c<CLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<1FIVV@G<c?l0
0oooogMgMnk^kP03k^k^00Jk^k]V<fKoooo^k^jIVIV8R8P2k^k^00=gMgO<
c<c<c?l0D/c<o`05ooooc<coc<coc<cooooo00?<c?l01Oooolc<olc<olc<
ooooo`0Ac<co00@0001VIYWoool00002IVJI00?oooo<c?o<c?l02lc<o`03
oooo0000IVJI009VIYT00oooolc<olc<o`09c<co00<0001VIYW<c?l02Lc<
o`9VIYT00oooolc<olc<o`02c<co1FIVVOo<c<a=c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`5IVJI1Lc<o`03
oooo<c<coooo00_^k^h00gMgMlc<c<c<o`1Ac<co00EVIYW<c?o<c?o<c?mV
IYT00lc<o`05IVJIc<coc<coc<coIVJI00?<c?l00fIVVLc<olc<o`0<c<co
0P0000;<c?l00`0006IVVFIVV@0<c<co00<0001VIYUVIYT00fIVV@03oooo
c<coc<co00W<c?l00`0006IVVFIVV@0;IVJI00?oooo<c?o<c?l00/c<o`EV
IYWoc<c<CLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@0Dc<c<1FIVV@G<c?l00ooooc<c<gMgM`0<MgMg00?oooo<c?o<
c?l0Clc<o`05ooooc<coc<coc<cooooo00?<c?l01Oooolc<olc<olc<oooo
o`03c<co00?oooo<c?o<c?l04/c<o`030000c<coc<co00_<c?l600003<c<
o`h00005c<co1FIVVOo<c<a=c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0D
c<c<0VIVV@030000VIW<IVJI01C<c<`5IVJI_/c<o`EVIYWoc<c<CLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI
01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
1FIVVKk<c?l5IVJIolc<c4g<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT05<c<c0IVIYVlc<co1VIVVOo<c<a=c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<c8
IVJIolc<c4g<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0
002IVLaVIYT05<c<c0mVIYV/VIW<3FIVVOo<c<a=c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT0
0`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI029VIYV/00003VIVVOo<
c<a=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI01C<c?o8IVJIolc<c4g<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT05<c<o`03c<c<IVJIIVJI0<AVIYWoc<c<C/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<
IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@2n
c<co0VIVV@030000VIW<IVJI0?o<c<aVc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI00G<c?l00oooohR8R4A4A006A4A4
00<c<c=4A4A4A4@00dA4A003VIVIc<coc<co053<c?l01FIVVLc<olc<olc<
ofIVV@03c<co00EVIYW<c?o<c?o<c?mVIYT00lc<o`03IVJIc<coc<co04C<
c?l2IVJI00<0002IVLaVIYT0olc<c6K<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<
IVJI01C<c<`2IVJI00<0002IVLaVIYT01Lc<o`03ooooA4A4IVIV00=gMgL0
0fIVIWMgMgMgM`05MgMg00<c<c?<c<c<c?l0=/c<o`<0000Gc<co00Goooo<
c?o<c?o<c?ooool00lc<o`05ooooc<coc<coc<cooooo00?<c?l00oooolc<
olc<o`07c<co1oooo`_<c?l:oooo4<c<o`koool4c<co0VIVV@030000VIW<
IVJI0?o<c<aVc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1W<c<`2
IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI00G<c?l03?oooc<c<nk^k^k^k[^k^gMgMjZZZ_ooonk^k]gM
gGMgMmgMg@;^k^h00gMgMlc<c<c<o`0hc<co0P0001G<c?l01FIVVLc<olc<
olc<ofIVV@03c<co00EVIYW<c?o<c?o<c?mVIYT00lc<o`03IVJIc<coc<co
00O<c?l00`0006IVVFIVV@04IVJI00?oooo<c?o<c?l02<c<o`030000IVJI
IVJI00MVIYT00oooolc<olc<o`0=c<co00<0001VIYUVIYT02fIVV@03oooo
c<coc<co00;<c?l2IVJI00<0002IVLaVIYT0olc<c6K<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT01Lc<o`06oooo<c<c
ooook^k^MgMg03?<0S<c0008A4A4<`0c000RIP1VMgMgooooMgMg^k^k1Lc<
o`800002c<co00<0003<c?o<c?l00P0000;<c?l400000lc<o`8000000lc<
o`0000000002c<co1@000003c<co0000000000C<c?l600000/c<o`D00002
c<co0`0000?<c?l400000/c<o`800008c<co00Goooo<c?o<c?o<c?ooool0
0lc<o`05ooooc<coc<coc<cooooo00?<c?l00oooolc<olc<o`08c<co00<0
001VIYUVIYT00`000003IVJIooooc<co00W<c?l00`0006IVVFIVV@02IVJI
10000003IVJIooooc<co00k<c?l00`0006IVVFIVV@0:000000=VIYWoooo<
c?l00lc<o`9VIYT00`0009VIc6IVV@3oc<c<I/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@05c<co013ooomgMgO^k^k^
k^iVIVH0I_l0I/a4A4@c03<c<c=gMgLc03>8R8S^k^iVIVK<c<`5c<co0P00
0005c<co000000000000c<co008000000lc<o`0000000002c<co0P000004
c<co00000000c<co0`000003c<co0000000000;<c?l2000000?<c?l00000
00001<c<o`800005c<co0P0000;<c?l200000/c<o`<00002c<co0P0000;<
c?l2000000?<c?l0000000002lc<o`05IVJIc<coc<coc<coIVJI00?<c?l0
1FIVVLc<olc<olc<ofIVV@03c<co00=VIYW<c?o<c?l01Lc<o`030000IVJI
oooo00;<c?l00`0006IVVOooo`0:c<co00D0001VIYUVIYUVIYWoool00lc<
o`030000IVJIoooo00o<c?l00`0006IVVLc<o`07c<co00Goooo<c?l0001V
IYWoool01<c<o`9VIYT00`0009VIc6IVV@3oc<c<I/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI
00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@05c<co00Gooolc<c?^
k^kMgMdA4A400P1Vo`09<fK<8R8RR8R8VIVI8R8RgMgMk^k^MgMgc<c<00G<
c?l2000000G<c?l000000000003<c?l00P000003c<co0000000000;<c?l2
000000?<c?l0000000000/c<o`8000000lc<o`0000000002c<co0P000003
c<co0000000000C<c?l200001Lc<o`800002c<co0P000004c<co00000000
c<co0P000003c<co0000000000G<c?l200002/c<o`05ooooc<coc<coc<co
oooo00?<c?l01Oooolc<olc<olc<ooooo`03c<co00?oooo<c?o<c?l01/c<
o`030000IVJIoooo00;<c?l00`0006IVVOooo`0:c<co00<0001VIYT00000
0VIVV@06ooooc<coc<co0000IVJIoooo3lc<o`060000IVJIc<coc<coIVJI
oooo0lc<o`06IVJIoooooooo0000IVJIoooo1<c<o`9VIYT00`0009VIc6IV
V@3oc<c<I/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIV
V@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`00
09VIc6IVV@05c<co00Kooolc<c?^k^hc<c<c03<001428R8R00P0<c<c03<A
0000000c<c>k^k]gMgNk^k/5c<co0P000005c<co0000c<co0000c<co0080
00000lc<o`0000000002c<co0P000003c<co0000000000;<c?l200000/c<
o`8000001<c<o`0000000<c<o`800004c<co0P0000K<c?l2000000C<c?l0
0000003<c?l2000000C<c?l00000003<c?l6000000?<c?l0000000002Lc<
o`05IVJIc<coc<coc<coIVJI00?<c?l01FIVVLc<olc<olc<ofIVV@03c<co
00=VIYW<c?o<c?l01lc<o`030000IVJIoooo00;oool2IVJI00?oooo<c?o<
c?l02<c<o`040000IVJIoooo00000VIVV@05ooooc<co0000IVJIoooo00o<
c?l0100006IVVLc<o`00009VIYT2oooo0fIVV@04c<co0000IVJIoooo1<c<
o`9VIYT00`0009VIc6IVV@3oc<c<I/c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaV
IYT05<c<c09VIYT00`0009VIc6IVV@05c<co013ooomgMgMV<fIV<fIgMgN8
R8QVIVHc<`00<l`0I/`c06H0001V<fHc<c=gMgO<c<`5c<co0P000005c<co
0000c<co0000c<co008000000lc<o`0000000002c<co0P000003c<co0000
000000;<c?l200000lc<o`@000000lc<o`0000000004c<co0P0000O<c?l4
000000C<c?l00000003<c?l2000000?<c?l0000000000/c<o`8000000lc<
o`0000000008c<co00Goooo<c?o<c?o<c?ooool00lc<o`05ooooc<coc<co
c<cooooo00?<c?l00oooolc<olc<o`08c<co00<0001VIYUVIYT016IVV@_<
c?l01@0006IVVOooolc<o`000002IVJI00CooomVIYUVIYWoool?c<co00D0
001VIYW<c?o<c?l000001FIVV@;<c?l00`0006IVVOooo`04c<co0VIVV@03
0000VIW<IVJI0?o<c<aVc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI00G<c?l02OooodA4A3<0<l`0c6HcIVIVIQ4009UV
0<bI000206K<0YT0V@03^k^kMgMgc<c<00G<c?l4000000?<c?l000000000
0P0000;<c?l00`000<c<olc<o`02000000C<c?l00000003<c?l3000000?<
c?l0003<c?l00/c<o`8000000lc<o`0000000004c<co0P0000G<c?l01000
0<c<olc<olc<o`@00003c<co100000;<c?l2000000?<c?l0000000002lc<
o`05IVJIc<coc<coc<coIVJI00?<c?l01FIVVLc<olc<olc<ofIVV@03c<co
00=VIYW<c?o<c?l01Lc<o`L000000lc<ooooooooo`04oooo1<c<o`030000
IVJIoooo00;<c?l00`0006IVVFIVV@02IVJI00?oooo<c?o<c?l03Lc<o`03
0000IVJIc<co00;<c?l01@0006IVVFIVVFIVVOooo`02c<co00<0001VIYWo
ool01<c<o`9VIYT00`0009VIc6IVV@3oc<c<I/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0
002IVLaVIYT05<c<c09VIYT00`0006IVVFIVV@05c<co00Cooolc<c?<c<a4
A4@2000000Xc03=VIP3oc02IIP1V06K<0?mV06IV<fIgMgNk^k/5c<co1000
0003c<co0000000000800002c<co100000?<c?l2000000?<c?l000000000
0/c<o`@00002c<co0P0000C<c?l200001/c<o`@000000lc<o`0000000003
c<co0P000003c<co0000000000800002c<co100000S<c?l01Oooolc<olc<
olc<ooooo`03c<co00Goooo<c?o<c?o<c?ooool00lc<o`03ooooc<coc<co
00g<c?l00`0006IVVFIVV@03IVJI00?oooo<c?o<c?l00/c<o`030000IVJI
oooo00?oool01@0006IVVFIVVFIVVOooo`02c<co0_ooo`_<c?l00`0006IV
VLc<o`02c<co16IVV@06ooooc<coc<co0000IVJIoooo1<c<o`9VIYT00`00
06IVVFIVV@3oc<c<I/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PI
c<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT05<c<c0EV
IYT5c<co00OooomgMgO^k^k^k^hR8R:I09UV<fH00VH0IP07<`0cVFH04A4A
c<c<k^k^MgMgc<c<00G<c?l300000lc<o`<0000<c<co0P0000S<c?l20000
1<c<o`80000Tc<co00EVIYW<c?o<c?o<c?mVIYT00lc<o`05IVJIc<coc<co
c<coIVJI00?<c?l00fIVVLc<olc<o`0>c<co00@0001VIYUVIYUVIYT20000
1Lc<o`030000IVJIIVJI00MVIYT2oooo0VIVV@03ooooc<coc<co00W<c?l0
100006IVVLc<olc<o`=VIYT0200006IVVFIVVOooolc<o`0006IVVOooo`C<
c?l5IVJIolc<c6K<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<
c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`5IVJI
1Lc<o`06ooooA4A4k^k^VIVI4A4AA4A40/`0c004V@2I03=Vc9T0MgMg0^k^
kP03MgMgc<c<c<co00C<c?l300000lc<o`<0000<c<co0P0000S<c?l20000
1<c<o`80000Sc<co00Goooo<c?o<c?o<c?ooool00lc<o`05ooooc<coc<co
c<cooooo00?<c?l00oooolc<olc<o`0?c<co00D0001VIYUVIYUVIYWoool0
1/c<o`T00002IVJI00CooomVIYUVIYWoool;c<co00@0001VIYW<c?l00002
IVJI0/c<o`070000IVJIIVJIc<co0000IVJIoooo00C<c?l5IVJIolc<c6K<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`5IVJI1Lc<o`09oooo<c<c
k^k^MgMg<c<cIVIV<c<cc03<A4A40080<fH01GMgMnk^k^k^kWMgMk^k^`1B
c<co00EVIYW<c?o<c?o<c?mVIYT00lc<o`05IVJIc<coc<coc<coIVJI00?<
c?l00fIVVLc<olc<o`0<c<co00<0001VIYT000000VIVV@03ooooc<coc<co
00c<c?l00`0006IVVFIVV@02IVJI00?oooo<c?o<c?l02Lc<o`050000IVJI
c<coc<co000000C<c?l01P000<c<olc<o`0006IVVOooo`C<c?l5IVJIolc<
c6K<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`00
09VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`5IVJI1Lc<o`03oooo
MgMgk^k^00?^k^h01[^k^fHcI_ooonk^kYVIVHR8R0;^k^h00gMgMlc<c<c<
o`1@c<co00Goooo<c?o<c?o<c?ooool00lc<o`05ooooc<coc<coc<cooooo
00?<c?l00oooolc<olc<o`0=c<co00@0001VIYWoool00002IVJI00?oooo<
c?o<c?l02lc<o`03oooo0000IVJI009VIYT00oooolc<olc<o`09c<co00<0
001VIYW<c?l02Lc<o`9VIYT00oooolc<olc<o`02c<co1FIVVOo<c<aVc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaV
IYT05<c<c09VIYT00`0009VIc6IVV@0Dc<c<1FIVV@G<c?l00ooooc<c<ooo
o`0;k^k^00=gMgO<c<c<c?l0Clc<o`05IVJIc<coc<coc<coIVJI00?<c?l0
1FIVVLc<olc<olc<ofIVV@03c<co00=VIYW<c?o<c?l03/c<o`800002c<co
00<0001VIYUVIYT03<c<o`030000IVJIIVJI00=VIYT00oooolc<olc<o`09
c<co00<0001VIYUVIYT02fIVV@03ooooc<coc<co00;<c?l5IVJIolc<c6K<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VI
c6IVV@0Dc<c<0VIVV@030000VIW<IVJI01C<c<`5IVJI1Lc<o`03oooo<c<c
MgMg00agMgL00oooolc<olc<o`1=c<co00Goooo<c?o<c?o<c?ooool00lc<
o`05ooooc<coc<coc<cooooo00?<c?l00oooolc<olc<o`0Dc<co00<0003<
c?o<c?l02lc<o`H0000<c<co3P0000G<c?l5IVJIolc<c6K<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI01C<c<`5IVJI_/c<o`EVIYWoc<c<I/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT05<c<c0EVIYVnc<co1FIVVOo<c<aVc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@0Dc<c<1VIVVKc<c?l6IVJIolc<c6K<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI01C<c<c8IVJIolc<c6K<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI01C<c<`?IVJI[9VIc0eVIYWoc<c<I/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT08VIVVJ`0000>IVJIolc<c6K<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI01C<c?o8IVJIolc<c6K<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIVV@03
0000VIW<IVJI01C<c?l00lc<c6IVVFIVV@34IVJIolc<c6O<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<
0VIVV@030000VIW<IVJI0;k<c?l2IVJI00<0002IVLaVIYT0olc<c7o<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IV
V@0Dc<c<0VIVV@030000VIW<IVJI00G<c?l00oooohR8R4A4A006A4A400<c
<c=4A4A4A4@00dA4A003VIVIc<coc<co05K<c?l01FIVVLc<olc<olc<ofIV
V@03c<co00=VIYW<c?o<c?l0A/c<o`9VIYT00`0009VIc6IVV@3oc<c<Olc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<
IVJI01C<c<`2IVJI00<0002IVLaVIYT01Lc<o`03ooooA4A4IVIV00=gMgL0
0fIVIWMgMgMgM`05MgMg00<c<c?<c<c<c?l0?<c<o`<0000Gc<co00Goooo<
c?o<c?o<c?ooool00lc<o`03ooooc<coc<co00W<c?l7oooo2lc<o`[oool@
c<co3_ooo`C<c?l2IVJI00<0002IVLaVIYT0olc<c7o<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<0VIV
V@030000VIW<IVJI00G<c?l03?oooc<c<nk^k^k^k[^k^gMgMjZZZ_ooonk^
k]gMgGMgMmgMg@;^k^h00gMgMlc<c<c<o`0nc<co0P0001G<c?l01FIVVLc<
olc<olc<ofIVV@03c<co00EVIYW<c?o<c?o<c?mVIYT01lc<o`030000IVJI
IVJI00AVIYT00oooolc<olc<o`08c<co00<0001VIYUVIYT01fIVV@03oooo
c<coc<co00g<c?l00`0006IVVFIVV@0;IVJI00?oooo<c?o<c?l00/c<o`9V
IYT00`0009VIc6IVV@3oc<c<Olc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<c<`2IVJI00<0002IVLaVIYT0
1Lc<o`06oooo<c<cooook^k^MgMg03?<0S<c0008A4A4<`0c000RIP1VMgMg
ooooMgMg^k^k1Lc<o`800007c<co1@000003c<co0000000000;<c?l40000
0lc<o`800002c<co0P0000;<c?l400001Lc<o`H00002c<co1@0000;<c?l3
00000lc<o`@00002c<co0P0000S<c?l01Oooolc<olc<olc<ooooo`03c<co
00Goooo<c?o<c?o<c?ooool02<c<o`030000IVJIIVJI00<000000fIVVOoo
olc<o`09c<co00<0001VIYUVIYT00VIVV@@000000fIVVOooolc<o`0>c<co
00<0001VIYUVIYT02P000003IVJIooooc<co00?<c?l2IVJI00<0002IVLaV
IYT0olc<c7o<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09V
IYT00`0009VIc6IVV@0Dc<c<0VIVV@030000VIW<IVJI00G<c?l04?ooogMg
Mnk^k^k^kVIVIP1Vo`1Vc4A4A3<0<c<c<gMgMc<0<hR8R>k^kVIVI/c<c0G<
c?l200001/c<o`800002c<co0P000004c<co00000000c<co0P0000;<c?l2
000000?<c?l0000000000/c<o`800002c<co0P0000;<c?l200001<c<o`80
0005c<co0P0000;<c?l200000/c<o`<00002c<co0P0000;<c?l2000000?<
c?l0000000002lc<o`05IVJIc<coc<coc<coIVJI00?<c?l00fIVVLc<olc<
o`07c<co00<0001VIYWoool00/c<o`030000IVJIoooo00[<c?l01@0006IV
VFIVVFIVVOooo`03c<co00<0001VIYWoool03lc<o`030000IVJIc<co00O<
c?l01Oooolc<o`0006IVVOooo`04c<co0VIVV@030000VIW<IVJI0?o<c<ao
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002I
VLaVIYT05<c<c09VIYT00`0009VIc6IVV@05c<co00Gooolc<c?^k^kMgMdA
4A400P1Vo`09<fK<8R8RR8R8VIVI8R8RgMgMk^k^MgMgc<c<00G<c?l20000
1/c<o`800002c<co0P000004c<co00000000c<co0P0000G<c?l200000/c<
o`800002c<co0P0000S<c?l200001Lc<o`800002c<co0P000004c<co0000
0000c<co0P000003c<co0000000000G<c?l200002/c<o`05ooooc<coc<co
c<cooooo00?<c?l00oooolc<olc<o`08c<co00<0001VIYWoool00/c<o`03
0000IVJIoooo00[<c?l00`0006IVV@000002IVJI00Koooo<c?o<c?l0001V
IYWoool?c<co00H0001VIYW<c?o<c?mVIYWoool3c<co00IVIYWoooooool0
001VIYWoool4c<co0VIVV@030000VIW<IVJI0?o<c<aoc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IYT00`0009VIc6IVV@05c<co00Kooolc<c?^k^hc<c<c03<001428R8R00P0
<c<c03<A0000000c<c>k^k]gMgNk^k/5c<co1P0000?<c?l2000000C<c?l0
0000003<c?l2000000?<c?l00000000010000003c<co0000000000;<c?l2
00000/c<o`H00004c<co0P0000K<c?l2000000C<c?l00000003<c?l20000
00C<c?l00000003<c?l6000000?<c?l0000000002Lc<o`05IVJIc<coc<co
c<coIVJI00?<c?l01FIVVLc<olc<olc<ofIVV@07c<co00<0001VIYWoool0
0_ooo`9VIYT00oooolc<olc<o`08c<co00@0001VIYWoool00002IVJI00Go
ooo<c?l0001VIYWoool03lc<o`040000IVJIc<co00000VIVV@;oool3IVJI
00C<c?l0001VIYWoool4c<co0VIVV@030000VIW<IVJI0?o<c<aoc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT0
5<c<c09VIYT00`0009VIc6IVV@05c<co013ooomgMgMV<fIV<fIgMgN8R8QV
IVHc<`00<l`0I/`c06H0001V<fHc<c=gMgO<c<`5c<co0P0000?<c?l20000
0lc<o`@000001<c<o`0000000<c<o`800002c<co0P000003c<co00000000
00;<c?l200000/c<o`800002c<co0P0000C<c?l200001lc<o`@000001<c<
o`0000000<c<o`8000000lc<o`0000000002c<co0P000003c<co00000000
00S<c?l01Oooolc<olc<olc<ooooo`03c<co00Goooo<c?o<c?o<c?ooool0
2<c<o`030000IVJIIVJI00AVIYT;c<co00D0001VIYWoooo<c?l000000VIV
V@04ooooIVJIIVJIoooo3lc<o`050000IVJIc<coc<co000000EVIYT2c<co
00<0001VIYWoool01<c<o`9VIYT00`0009VIc6IVV@3oc<c<Olc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI01C<
c<`2IVJI00<0002IVLaVIYT01Lc<o`09ooooA4A4<`0cc03<IS=VIVIV4@00
VFH0c9T00080I/`2V@2I00>k^k]gMgO<c<`01Lc<o`800003c<co0P000003
c<co0000c<co00;<c?l2000000C<c?l00000003<c?l200000/c<o`800000
0lc<o`0000000002c<co0P0000;<c?l200000/c<o`800004c<co0P0000G<
c?l010000<c<olc<olc<o`@00003c<co100000;<c?l2000000?<c?l00000
00002lc<o`05IVJIc<coc<coc<coIVJI00?<c?l00fIVVLc<olc<o`07c<co
1`000003c<cooooooooo00Coool4c<co00<0001VIYWoool00/c<o`030000
IVJIIVJI009VIYT00oooolc<olc<o`0=c<co00<0001VIYW<c?l00/c<o`05
0000IVJIIVJIIVJIoooo00;<c?l00`0006IVVOooo`04c<co0VIVV@030000
VIW<IVJI0?o<c<aoc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1W<
c<`2IVJI00<0002IVLaVIYT05<c<c09VIYT00`0006IVVFIVV@05c<co00Co
oolc<c?<c<a4A4@2000000Xc03=VIP3oc02IIP1V06K<0?mV06IV<fIgMgNk
^k/5c<co0P0000?<c?l200000/c<o`@00002c<co0P0000;<c?l4000000?<
c?l0000000001P0000;<c?l400001Lc<o`800006c<co10000003c<co0000
000000?<c?l2000000?<c?l0000000000P0000;<c?l400002<c<o`05oooo
c<coc<coc<cooooo00?<c?l00oooolc<olc<o`0?c<co00<0001VIYUVIYT0
0fIVV@03ooooc<coc<co00;<c?l00`0006IVVOooo`03oooo00D0001VIYUV
IYUVIYWoool00/c<o`;oool;c<co00<0001VIYW<c?l00/c<o`AVIYT01_oo
olc<olc<o`0006IVVOooo`C<c?l2IVJI00<0001VIYUVIYT0olc<c7o<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IV
V@0Dc<c<1FIVV@G<c?l01oooogMgMnk^k^k^kR8R8YT0VFHcIP02IP1V00Lc
03>IIP0A4A7<c<c^k^igMgO<c<`01Lc<o`800003c<co0P0000S<c?l20000
2<c<o`800002c<co0P0000c<c?l200009<c<o`05IVJIc<coc<coc<coIVJI
00?<c?l01FIVVLc<olc<olc<ofIVV@0>c<co00@0001VIYUVIYUVIYT20000
1Lc<o`030000IVJIIVJI00MVIYT2oooo0VIVV@03ooooc<coc<co00W<c?l0
100006IVVLc<olc<o`=VIYT0200006IVVFIVVOooolc<o`0006IVVOooo`C<
c?l5IVJIolc<c7o<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<
c09VIYT00`0009VIc6IVV@0Dc<c<1FIVV@G<c?l01_ooodA4A>k^kYVIVA4A
4DA4A0;<0<`019T0V@0cI/bI07MgM`;^k^h00gMgMlc<c<c<o`04c<co1P00
00W<c?l200002Lc<o`050000c<coc<coc<co000000c<c?l200008lc<o`05
ooooc<coc<coc<cooooo00?<c?l01Oooolc<olc<olc<ooooo`0?c<co00D0
001VIYUVIYUVIYWoool01/c<o`T00002IVJI00CooomVIYUVIYWoool;c<co
00@0001VIYW<c?l00002IVJI0/c<o`070000IVJIIVJIc<co0000IVJIoooo
00C<c?l5IVJIolc<c7o<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<1FIVV@G<c?l02Ooooc<c<nk^kWMg
Mc<c<fIVIS<c<l`0c4A4A00203=V00EgMgO^k^k^k^igMgNk^k/0F<c<o`05
IVJIc<coc<coc<coIVJI00?<c?l00fIVVLc<olc<o`0>c<co00<0001VIYT0
00000VIVV@03ooooc<coc<co00c<c?l00`0006IVVFIVV@02IVJI00?oooo<
c?o<c?l02Lc<o`050000IVJIc<coc<co000000C<c?l01P000<c<olc<o`00
06IVVOooo`C<c?l5IVJIolc<c7o<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<1FIVV@G<c?l00oooogMg
Mnk^kP03k^k^00Jk^k]V<fKoooo^k^jIVIV8R8P2k^k^00=gMgO<c<c<c?l0
E/c<o`05ooooc<coc<coc<cooooo00?<c?l00oooolc<olc<o`0?c<co00@0
001VIYWoool00002IVJI00?oooo<c?o<c?l02lc<o`03oooo0000IVJI009V
IYT00oooolc<olc<o`09c<co00<0001VIYW<c?l02Lc<o`9VIYT00oooolc<
olc<o`02c<co1FIVVOo<c<aoc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<c0EVIYT5c<co00?ooolc<c?o
ool02nk^kP03MgMgc<c<c<co05G<c?l01FIVVLc<olc<olc<ofIVV@03c<co
00EVIYW<c?o<c?o<c?mVIYT03/c<o`800002c<co00<0001VIYUVIYT03<c<
o`030000IVJIIVJI00=VIYT00oooolc<olc<o`09c<co00<0001VIYUVIYT0
2fIVV@03ooooc<coc<co00;<c?l5IVJIolc<c7o<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<1FIVV@G<
c?l00ooooc<c<gMgM`0<MgMg00?oooo<c?o<c?l0Dlc<o`05ooooc<coc<co
c<cooooo00?<c?l01Oooolc<olc<olc<ooooo`0Dc<co00<0003<c?o<c?l0
2lc<o`H0000<c<co3P0000G<c?l5IVJIolc<c7o<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<1FIVVKk<
c?l5IVJIolc<c7o<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<
c09VIYT00`0009VIc6IVV@0Dc<c<1FIVVKk<c?l5IVJIolc<c7o<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0D
c<c<1VIVVKc<c?l6IVJIolc<c7o<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@0Dc<c<b6IVVOo<c<aoc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT0
5<c<c0mVIYV/VIW<3FIVVOo<c<aoc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT08VIVVJ`0000>IVJIolc<c7o<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VI
c6IVV@0Dc<cob6IVVOo<c<aoc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^1W<c<`2IVJI00<0002IVLaVIYT05<c<o`03c<c<IVJIIVJI0<AVIYWo
c<c<P<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@03
0000VIW<IVJI0;k<c?l2IVJI00<0002IVLaVIYT0olc<c9S<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IVV@05c<co
00?ooon8R8Q4A4@01TA4A003<c<cA4A4A4A400=4A4@00iVIVLc<olc<o`1F
c<co00EVIYW<c?o<c?o<c?mVIYT00lc<o`03IVJIc<coc<co04K<c?l2IVJI
00<0002IVLaVIYT0olc<c9S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6Lc<c09VIYT00`0009VIc6IVV@05c<co00?ooom4A4AVIVH00gMgM`03
IVIVMgMgMgMg00EgMgL00c<c<lc<c<c<o`0lc<co0`0001O<c?l01Oooolc<
olc<olc<ooooo`03c<co00?oooo<c?o<c?l02Lc<o`Ooool;c<co2_oooa3<
c?l>oooo1<c<o`9VIYT00`0009VIc6IVV@3oc<c<V<c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI00G<c?l03?oo
oc<c<nk^k^k^k[^k^gMgMjZZZ_ooonk^k]gMgGMgMmgMg@;^k^h00gMgMlc<
c<c<o`0nc<co0P0001G<c?l01FIVVLc<olc<olc<ofIVV@03c<co00EVIYW<
c?o<c?o<c?mVIYT01lc<o`030000IVJIIVJI00AVIYT00oooolc<olc<o`08
c<co00<0001VIYUVIYT01fIVV@03ooooc<coc<co00g<c?l00`0006IVVFIV
V@0;IVJI00?oooo<c?o<c?l00/c<o`9VIYT00`0009VIc6IVV@3oc<c<V<c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<
IVJI00G<c?l01_oooc<c<oooonk^kWMgM`0cc08c<`0024A4A3<0<`008VH0
IWMgMoooogMgMk^k^`G<c?l500001<c<o`@00002c<co0P0000?<c?l50000
0/c<o`8000001<c<o`0000000<c<o`800002c<co0P0000C<c?l600000/c<
o`D00002c<co0`0000?<c?l400000/c<o`800008c<co00Goooo<c?o<c?o<
c?ooool00lc<o`05ooooc<coc<coc<cooooo00S<c?l00`0006IVVFIVV@03
000000=VIYWoooo<c?l02Lc<o`030000IVJIIVJI009VIYT4000000=VIYWo
ooo<c?l03/c<o`030000IVJIIVJI00X000000fIVVOooolc<o`03c<co0VIV
V@030000VIW<IVJI0?o<c<bHc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^1W<c<`2IVJI00<0002IVLaVIYT01Lc<o`0@ooooMgMgk^k^k^k^IVIV
06Ko06K<A4A4<`0c<c<cMgMg<`0cR8R8k^k^IVIVc<c<1Lc<o`800002c<co
0P0000;<c?l200000/c<o`8000000lc<o`0000000002c<co0P0000;<c?l2
000000C<c?l00000003<c?l3000000C<c?l00000003<c?l200001Lc<o`80
0005c<co0P0000;<c?l200000/c<o`<00002c<co0P0000;<c?l2000000?<
c?l0000000002lc<o`05IVJIc<coc<coc<coIVJI00?<c?l00fIVVLc<olc<
o`07c<co00<0001VIYWoool00/c<o`030000IVJIoooo00[<c?l01@0006IV
VFIVVFIVVOooo`03c<co00<0001VIYWoool03lc<o`030000IVJIc<co00O<
c?l01Oooolc<o`0006IVVOooo`04c<co0VIVV@030000VIW<IVJI0?o<c<bH
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002I
VLaVIYT01Lc<o`05oooo<c<ck^k^gMgM4A4A0080I_l02C=Vc28R8XR8R9VI
VB8R8]gMgNk^kWMgMlc<c005c<co0P0000?<c?l2000000?<c?l000000000
1Lc<o`800002c<co0P0000;<c?l2000000?<c?l0000000000/c<o`800000
1<c<o`0000000<c<o`800005c<co0P0000G<c?l200000/c<o`8000001<c<
o`0000000<c<o`8000000lc<o`0000000005c<co0P0000[<c?l01Oooolc<
olc<olc<ooooo`03c<co00?oooo<c?o<c?l02<c<o`030000IVJIoooo00;<
c?l00`0006IVVOooo`0:c<co00<0001VIYT000000VIVV@06ooooc<coc<co
0000IVJIoooo3lc<o`060000IVJIc<coc<coIVJIoooo0lc<o`06IVJIoooo
oooo0000IVJIoooo1<c<o`9VIYT00`0009VIc6IVV@3oc<c<V<c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000VIW<IVJI00G<
c?l01_oooc<c<nk^kS<c<c<0<`004@8R8R80200c<c<0<a40000003<c<k^k
^gMgMk^k^`G<c?l200000lc<o`8000000lc<o`0000000004000000?<c?l0
000000000lc<o`8000001<c<o`0000000<c<o`800002c<co0P000004c<co
00000000c<co0P0000G<c?l200001/c<o`8000001<c<o`0000000<c<o`80
00001<c<o`0000000<c<o`H000000lc<o`0000000009c<co00EVIYW<c?o<
c?o<c?mVIYT00lc<o`05IVJIc<coc<coc<coIVJI00O<c?l00`0006IVVOoo
o`02oooo0VIVV@03ooooc<coc<co00S<c?l0100006IVVOooo`00009VIYT0
1Oooolc<o`0006IVVOooo`0?c<co00@0001VIYW<c?l00002IVJI0_ooo`=V
IYT01<c<o`0006IVVOooo`C<c?l2IVJI00<0002IVLaVIYT0olc<c9S<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c09VIYT00`0009VIc6IV
V@05c<co013ooomgMgMV<fIV<fIgMgN8R8QVIVHc<`00<l`0I/`c06H0001V
<fHc<c=gMgO<c<`5c<co0P0000?<c?l2000000?<c?l0000000000/c<o`80
00000lc<o`0000000004c<co10000003c<co0000000000;<c?l2000000C<
c?l00000003<c?l200001Lc<o`800007c<co10000004c<co00000000c<co
0P000003c<co0000000000;<c?l2000000?<c?l0000000002<c<o`05oooo
c<coc<coc<cooooo00?<c?l01Oooolc<olc<olc<ooooo`08c<co00<0001V
IYUVIYT016IVV@_<c?l01@0006IVVOooolc<o`000002IVJI00CooomVIYUV
IYWoool?c<co00D0001VIYW<c?o<c?l000001FIVV@;<c?l00`0006IVVOoo
o`04c<co0VIVV@030000VIW<IVJI0?o<c<bHc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^1W<c<`2IVJI00<0002IVLaVIYT01Lc<o`09ooooA4A4
<`0cc03<IS=VIVIV4@00VFH0c9T00080I/`2V@2I00>k^k]gMgO<c<`01Lc<
o`800003c<co0P000003c<co0000000000;<c?l2000000?<c?l000000000
0/c<o`040000c<coc<coc<co0P000003c<co0000000000;<c?l2000000C<
c?l00000003<c?l200001Lc<o`800005c<co00@0003<c?o<c?o<c?l40000
0lc<o`@00002c<co0P000003c<co0000000000_<c?l01FIVVLc<olc<olc<
ofIVV@03c<co00=VIYW<c?o<c?l01lc<o`L000000lc<ooooooooo`04oooo
1<c<o`030000IVJIoooo00;<c?l00`0006IVVFIVV@02IVJI00?oooo<c?o<
c?l03Lc<o`030000IVJIc<co00;<c?l01@0006IVVFIVVFIVVOooo`02c<co
00<0001VIYWoool01<c<o`9VIYT00`0009VIc6IVV@3oc<c<V<c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;PIc<c<0VIVV@030000IVJIIVJI00G<
c?l01?oooc<c<lc<c4A4A08000002S<0<fIV0?o<09UV06H0I/`0ofH0IVHc
IWMgMk^k^`G<c?l200000lc<o`800002c<co10000003c<co000000000080
0002c<co100000;<c?l200000/c<o`8000000lc<o`000000000400001<c<
o`800006c<co10000003c<co0000000000?<c?l2000000?<c?l000000000
0P0000;<c?l400002<c<o`05ooooc<coc<coc<cooooo00?<c?l00oooolc<
olc<o`0?c<co00<0001VIYUVIYT00fIVV@03ooooc<coc<co00;<c?l00`00
06IVVOooo`03oooo00D0001VIYUVIYUVIYWoool00/c<o`;oool;c<co00<0
001VIYW<c?l00/c<o`AVIYT01_ooolc<olc<o`0006IVVOooo`C<c?l2IVJI
00<0001VIYUVIYT0olc<c9S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6Lc<c0EVIYT5c<co00OooomgMgO^k^k^k^hR8R:I09UV<fH00VH0IP07
<`0cVFH04A4Ac<c<k^k^MgMgc<c<00G<c?l200000/c<o`800009c<co0P00
013<c?l2000000?<c?l0000000001Lc<o`80000Tc<co00EVIYW<c?o<c?o<
c?mVIYT00lc<o`05IVJIc<coc<coc<coIVJI00k<c?l0100006IVVFIVVFIV
V@800005c<co00<0001VIYUVIYT01fIVV@;oool2IVJI00?oooo<c?o<c?l0
2Lc<o`040000IVJIc<coc<co0fIVV@080000IVJIIVJIooooc<co0000IVJI
oooo1<c<o`EVIYWoc<c<V<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PIc<c<1FIVV@G<c?l01_ooodA4A>k^kYVIVA4A4DA4A0;<0<`019T0V@0c
I/bI07MgM`;^k^h00gMgMlc<c<c<o`04c<co1@0000_<c?l300003/c<o`80
0002c<co00<0003<c?o<c?l00lc<o`80000Sc<co00Goooo<c?o<c?o<c?oo
ool00lc<o`05ooooc<coc<coc<cooooo00o<c?l01@0006IVVFIVVFIVVOoo
o`06c<co2@00009VIYT01?ooofIVVFIVVOooo`_<c?l0100006IVVLc<o`00
009VIYT2c<co00L0001VIYUVIYW<c?l0001VIYWoool01<c<o`EVIYWoc<c<
V<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<1FIVV@G<c?l0
2Ooooc<c<nk^kWMgMc<c<fIVIS<c<l`0c4A4A00203=V00EgMgO^k^k^k^ig
MgNk^k/0F<c<o`05IVJIc<coc<coc<coIVJI00?<c?l00fIVVLc<olc<o`0>
c<co00<0001VIYT000000VIVV@03ooooc<coc<co00c<c?l00`0006IVVFIV
V@02IVJI00?oooo<c?o<c?l02Lc<o`050000IVJIc<coc<co000000C<c?l0
1P000<c<olc<o`0006IVVOooo`C<c?l5IVJIolc<c9S<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6Lc<c0EVIYT5c<co00?ooomgMgO^k^h00nk^
kP06^k^kIS=Vooook^k^VIVIR8R80^k^kP03MgMgc<c<c<co05K<c?l01Ooo
olc<olc<olc<ooooo`03c<co00?oooo<c?o<c?l03lc<o`040000IVJIoooo
00000VIVV@03ooooc<coc<co00_<c?l00oooo`0006IVV@02IVJI00?oooo<
c?o<c?l02Lc<o`030000IVJIc<co00W<c?l2IVJI00?oooo<c?o<c?l00/c<
o`EVIYWoc<c<V<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<
1FIVV@G<c?l00ooooc<c<oooo`0;k^k^00=gMgO<c<c<c?l0ELc<o`05IVJI
c<coc<coc<coIVJI00?<c?l01FIVVLc<olc<olc<ofIVV@0>c<co0P0000;<
c?l00`0006IVVFIVV@0<c<co00<0001VIYUVIYT00fIVV@03ooooc<coc<co
00W<c?l00`0006IVVFIVV@0;IVJI00?oooo<c?o<c?l00/c<o`EVIYWoc<c<
V<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<1FIVV@G<c?l0
0ooooc<c<gMgM`0<MgMg00?oooo<c?o<c?l0Dlc<o`05ooooc<coc<coc<co
oooo00?<c?l01Oooolc<olc<olc<ooooo`0Dc<co00<0003<c?o<c?l02lc<
o`H0000<c<co3P0000G<c?l5IVJIolc<c9S<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6Lc<c0EVIYVnc<co1FIVVOo<c<bHc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^1W<c<`5IVJI_/c<o`EVIYWoc<c<V<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<1VIVVKc<c?l6IVJIolc<
c9S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c<QVIYWoc<c<
V<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIc<c<3fIVVJbIVL`=
IVJIolc<c9S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6Lc<c0iV
IYV/00003VIVVOo<c<bHc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^1W<c<c8IVJIolc<c9S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6/c<c<IVIYWoc<c<VLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000B8`;S8
h=R8`;R8`;PF00200`01P0800X001002P@03P@03P@03P@<0184200F100@0
1H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<1
2h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8D
Q`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT0
10<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<
12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?
1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHb
T@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`03
1cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8
@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI
2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`0
10YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]G
WP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aN
X@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=
I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]
YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mc
Z0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`4
47f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^
00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::
/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<C
T;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI
]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh
00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/3
5ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn
0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P4002000>KYo4c@jDc@jD02C=3Y@H0080300600P02P004
00:100>100>100>10`04P@801H401005PP06PP06PP06PP801h800`47PP48
PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn5
0`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<4
7h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=
1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086
;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7
=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9
@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:
BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<
Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`
Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?
MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd3
4H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<B
Qk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d
0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL
]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d2
5jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G
/klf6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008001i^WlOoo
ohij]ZJKa;>YdZRMb;>YdP02YY_400Fl^=g^k_CZjO7ooolc@jD01@00P0<0
0H0200:000@00X400h400h400h4300B10P05P@0400F200J200J200J20P07
PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f4
0`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8F
Q`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<3
7HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd3
1BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6
;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHc
TP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9
BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd2
2e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;
FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<
H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]
47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<A
QJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d
4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLD
VkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[
_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_`8H]<0P00000QRd`10000026;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^080080019^WlOooofaJYJnUbP:l^=d02_omok>Yd_oo
oooookbhgIN:_:RMb>KVk?oooc=3Y@@0080300600P02P00400:100>100>1
00>10`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R3
0`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH3
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8
h=Q8T8Q8T8P034R@R0030000b>3HB92800e8T8P0100001Rd`1Rd`<SPf0i8
T8P00`0001Rd`1Rd`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00
P00;VjOaooooZ9g8oooo/jWBH4bJSWZfN6F^Z9g8oooooogo00?oool00c=3
Y@00P000P00300200`01P0800X001002P@03P@03P@03P@<0184200F100@0
1H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<1
2h@12h@00`4<Q0<13H@30@j50`8?Q@8248D3oooo0P8AQP<24XH20Q>600@2
4hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV9
0aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`0
10@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZ
SPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`Ha
T@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7
=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0
UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6
V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`4
2U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN
00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aM
X@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=
Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/
YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X
00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/3
47b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^
0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4B
R[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008C
Sk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH
]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh
0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/3
5ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;
R<2h00=8T8P00038h=P03HS0^005B92800006;C06;C0b>3H00f8`;P014R@
R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000jK
Yo7ooooooooKg>aPC9ZCQKZcZM:l^=ePC9ZISkjVVlC8`moooolc@jD60020
0oooo`800X000`02POooooooo`02oooo0P04P@0300F1oooo00F200<01X84
oooo00<1288128?oool00oooo`<12X<01_ooo`4;Q04;Q04<Q?ooo`4<Q081
3H@01?ooo`4>QOooo`4>Q@823hD01?ooo`8@QOooo`8@Q@824HH00oooo`8A
QP8BQP020Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<G
R0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3
122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>
1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i00
10H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987
=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`Pl
U@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9
A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX3
2TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]D
W@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj02
35bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP03
3F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eX
Y@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`04
3g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX3
47RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]
00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk03
4XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8B
S[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D
]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8D
WKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX3
5JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm
0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl2
6;C000C8h=R8`;R8`;R8`;P6000018S0^003B9280000b>3H00:8`;P90000
0XS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3002000jKYo7ooonl^=fISkkooooF
dMgKg>cco_nVVlC^k_B5M[2CQK[ooolc@jD4002000Ooool00H000H000H3o
ool00X3oool00`03P@06oooo00B100B100F1oooo00F20P06PP08oooo00N2
00N20@N2oooo0@R2oooo0@R30`49P`04oooo0@Z30@Z3oooo0P4;Q0030@b4
oooo0@b400813H@01?ooo`4>QOooo`4>Q@823hD00oooo`8@QOooo`03oooo
0P8AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN8
0aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<4
88/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh5
9hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T004
1RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLe
TPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE
0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4
V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:
C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM
2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<
G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=
HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU
0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?
L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@
N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d0
0a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<B
R;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>
/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd
0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM
]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<E
Y;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d3
5jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H
]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P00038h=P00XS0^0030000
R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000C8h=R8`;R8`;R8
`;P2000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0`00P00?VjOaooooVHnnUhZle=?XkjbcogIkkYn[
FeRUYY_4UYoBH4bJ_;SMoooo<d>U00<008001oooo`01P001P001P?ooo`02
P?ooo`0300>100Koool01840187oool01H7oool200J200Soool01h801h81
1h;oool128;oool128<30@V300Woool12X?oool12h?oool12hCoool138Co
ool00P4=Q004oooo0@j5oooo0@j50P8?Q@04oooo0Q25oooo0Q25108AQP<2
4XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<H
R0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;
0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DX
SP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A
1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP02
1cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8
?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4
V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK
0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN
00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aL
X@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=
HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>
JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?
LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[
0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61
[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`
00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb
4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<D
U[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh
5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj
0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G
[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSP
f8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P0
1@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h
0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000ZKYo7ooonGR[ajK:ZcanRYKZ38`mnCQKYKAY>ISkh2N6F^
00A29hF_YL[ooolc@jD400200`01P003oooo00:000:100Coool200B100?o
ool01H7oool00`06PPCoool00`48PP48P`48P`030@V300Woool12X?oool1
2h?oool12hCoool138Coool00P4=Q004oooo0@j5oooo0@j50P8?Q@03oooo
0Q25oooo00?oool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ7
00@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<M
RP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<5
9Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]
T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B
0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@3
1cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G
0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9
VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;
DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]I
W`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaP
XPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY003
3FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW
0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`me
Z@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@
Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65
[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8B
SK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@C
T[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK
]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ
^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m
5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o
00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h
00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0
^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2002000>KYo7oooooool00_ooo`0:ojf`ogIknLgD
oNg^ooooYY_4QGJ`_;SMoooo<d>U1@00P0<00H000oooo`02P002P@0300>1
00?oool0187oool00P05P@0400F2oooo00J200J20P07PP030@N2oooo0@R2
008128<3oooo0P4:P`07oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?oo
o`4>QOooooooo`823hD01_ooo`8@QOooo`8@Q@8AQ_ooo`824HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028
`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00B8`;P200001HS0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008002Z6/
l_W=e>8V??Be_n8V??A]OOcSjOoooog]k_n]/0;oool00c=3Y@00P000P004
00200`01P003oooo00:000:100?oool200B100Goool01H401H401H;oool0
0P06PP?oool20@R200<128?oool12H<00P49P`812X<01?ooo`4;P`4;Q?oo
o`8138@01oooo`4=Q04=Q?ooo`4>QOooo`4>Q@02oooo00<23hD248D248D0
1?ooo`040Q660Q:60Q:60Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:
0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DV
S@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@
0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i82
1SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7
>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL2
24>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ
0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]B
W@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO
0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R
362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=
IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL3
3VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o
[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_
1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=
/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B
]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g
59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i
0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdF
ZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl0
0aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P0
0`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2h
R<2h00>8`;P4000018S0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_ARK_om
oon]/?cSjOoooc=3Y@0700200`01P003oooo00:000:100<00h4300B10P05
P@0400F200J200J200J20P07PP050@N20@R20@R2oooo0@R300<12H<30@Z3
00<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0
108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP3
6HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@S
S00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP03
1BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<943
1S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC
0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2
242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V003
2DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?
W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;
EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ
35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S
0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH3
3VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?
LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1k
Z`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<A
PZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::
/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk80
0Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD4
59Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PE
W[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW
^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^
_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h
00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2h
R<2hB9280000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08000i^WlOK8c>8V?002ojf`00OO92koY9kf_<Go[K3^Nhcooolc@jD02000
P0<00H000oooo`02P002P@0300>10`04P@801H401005PP06PP06PP06PP80
1h801@47PP48PP48P_ooo`48P`030@V300Coool12X<12X<12h<20@^40`4<
Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<2
5HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT3
0ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=
0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl4
1Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B
1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD
00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8
@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT3
2DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YA
W@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`03
2eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aO
XPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eU
Y0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW
3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@04
3gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@
OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lA
Q:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba
00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<C
T[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ
]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TE
X;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_004
5Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n
5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SP
f002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf003R<2h0P0000B8`;P2
00000XS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0
^8S0^08008000i^WlOW=e?N9U`02oooo00Oo[K3Q5SCoMW_oY9kR9ScoRGlc
@jD02000P0<00H000oooo`02P002P@0300>10`04P@801H401005PP06PP06
PP06PP801h801047PP48PP48PP48P`Coool30@Z300<12h<12h@12h@00`4<
Q0813H@01?ooo`4>Q@4>Q@4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL2
58L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV9
00@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@T
S0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZ
S`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86
<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<0
0`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04
242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6
V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L
00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;
Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<
GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<3
3FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>
KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?
LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/
111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63
[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4B
R[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<3
4i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<D
VKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO
^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk
0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN_
_P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h
00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08001i^WlOoooo>P[_ARK_ooooN9UoW=e002oooo00?cX:kooolc@jD02000
P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J200J200J2
0P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@3
0@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF7
0P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<L
RP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@85
9Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/
S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHc
TPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU003
1cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G
0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8
V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:
DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]H
W`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<
H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=
IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^
Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010md
Z@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]
47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_
00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@04
4Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c
4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LD
VkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i
00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[
_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa
_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P0
3HS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3002000^KYo7oooooRGooooocX:ka
Tj7ooooooOocX:kono`c@jD02000P0<00H0200:000@00X400h400h400h43
00B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V3
0`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR003
0aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A
1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC
0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH3
23nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9
AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>
V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aM
X@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ80
0PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD4
3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?
LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1j
Z`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61
[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@B
RK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb
4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D3
59Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh
5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<0?b>3H00<0
0038h=S8h=P03LSPf00300006;C06;C000o8h=P00`0001Rd`1Rd`002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1000P0>KYo401_oooo>P[_Be_oJl
aO_IfS=3Y@T0080300600P02P00400:100>100>100>10`04P@801H401005
PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;
Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@04
0aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`4
98d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5
:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A
00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7
>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9
AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN
2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ
0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X
3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@
OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh0
0a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@
/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf
0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<F
ZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P10000000018S0
^<SPf8S0^8S0^1H0080300600P02P00400:100>100>100>10`04P@801H40
1005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;
P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>7
0QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<I
R@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@4
98`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5
:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I42
1S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC
00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H0
10Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9
AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@
W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP03
2eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ43
35jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S
0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H2
3VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ003
3g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l
[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<A
Pjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa
4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc
0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H3
59Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<E
WkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX
^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G
[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P100000000
0hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8h=R8`;P0
ohS0^?n8`;QmR<2h0DR@R04000000003R<2hb>3Hb>3H0?o8h=Sob>3HOLSP
f058T8P10000003oR<2hohS0^868`;P100000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l00000o`00003oooo`l?3o
oo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`
003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?00
0?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`
l?22oo3`l000oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003o
onKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2
ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^
k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV001monk^k/SoRXZ:ooo^k^hlonk^kP00OOooooo8ogmoOooooooo??oo
ool007gok^k^00?oOgmoooooooooool0]Oooool00ooIfMWoooooooooo`0<ooooo`03ogmoOoo^k^ko
k^k^0?ook^k^>_o^k^h007goi^KV00?oOgmoooooooooool0]Oooool01?oIfMWooooooooooooUiND3
ooooo`05onGUiOoooooooooooooooooUiND00oooool00omoOgooi^KVonKViP3oonKViS[oi^KV001m
onk^kP03ogmoOooooooooooo0;Gooooo00gofMWIoooooooJf][oSHf=onGUiOoooooof][Johf=SOoU
iNGoooooom[Jf_n=SHgoiNGU00;ooooo00?oOgmoonk^k_o^k^h0ooo^k^hjonk^kP00OOooool00omo
Ogooooooooooo`2eooooo`0@omWIfOooooooooooom[Jf_n=SHgoiNGUoooooooJf][oSHf=onGUiOoo
oooof][Johf=SOoUiNGoooooogmoOooooooo??ooool007gok^k^00?oOgmoooooooooool0]Oooool0
3OoIfMWooooooooooooooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGUoooooooJf]X00_ooool0
0omoOgook^k^onk^kP3oonk^kS[ok^k^001monKViP03ogmoOooooooooooo0;Gooooo00?ofMWIoooo
ooooool00_ooool01ooJf][oSHf=onGUiOoooooof][Johf=SOoUiND00oooool00omoOgooi^KVonKV
iP3oonKViS[oi^KV001monk^kP03ogmoOooooooooooo0;Gooooo00?ofMWIooooooooool00oooool0
1ooJf][oSHf=onGUiOoooooof][Johf=SOoUiND00_ooool00omoOgook^k^onk^kP3oonk^kS[ok^k^
001mooooo`03ogmoOooooooooooo0;Gooooo00?ofMWIooooooooool01?ooool02OoJf][oSHf=onGU
iOoooooog=cLohf=SOoUiNGoooooogmoO`3ooooooccooooo001monk^kP03ogmoOooooooooooo0;Go
oooo00?ofMWIooooooooool01Oooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo00?oOgmoonk^
k_o^k^h0ooo^k^hjonk^kP00OOoVi^H00omoOgooooooooooo`2eooooo`03omWIfOoooooooooo00Ko
oooo00?og=cLohf=SOoUiND00oooool00omoOgooi^KVonKViP3oonKViS[oi^KV001monk^kP03ogmo
Oooooooooooo0;Gooooo00?ofMWIooooooooool01oooool00ooLg=coSHf=onGUi@02ooooo`03ogmo
Ooo^k^kok^k^0?ook^k^>_o^k^h007gooooo00?oOgmoooooooooool0]Oooool00ooIfMWooooooooo
o`08ooooo`05omcLg?n=SHgoiNGUoooooomoOgl0oooooollooooo`00OOo^k^h00omoOgoooooooooo
o`2eooooo`03omWIfOoooooooooo00Wooooo00Cog=cLooooooooooooOgmoooo^k^hlonk^kP00OOoV
i^H00omoOgooooooooooo`2eooooo`03omWIfOoooooooooo00cooooo00?oOgmoonKVi_oVi^H0oooV
i^HjonKViP00OOo^k^h00omoOgooooooooooo`2eooooo`oofMWI00?oOgmoonk^k_o^k^h0ooo^k^hj
onk^kP00OOooool00omoOgooooooooooo`34ooooo`03ogmoOooooooooooo0?oooooo>_ooool007go
k^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^001monKViP03ogmo
OooVi^Koi^KV0<Coi^KV00?oOgmoonKVi_oVi^H0oooVi^HjonKViP00OOo^k^h00omoOgook^k^onk^
kP34onk^kP03ogmoOoo^k^kok^k^0?ook^k^>_o^k^h007gooooo00?oOgmoooooooooool0a?ooool0
0omoOgooooooooooo`3ooooooc[ooooo001monk^kP03ogmoOoo^k^kok^k^0<Cok^k^00?oOgmoonk^
k_o^k^h0ooo^k^hjonk^kP00OOoVi^H00omoOgooi^KVonKViP34onKViP03ogmoOooVi^Koi^KV0?oo
i^KV>_oVi^H007gok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^
001ToooooaWoRXZ:00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo001T
onk^kQ[oOgmoa_o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^001TonKViP03ogmoOooooooooooo
01Kooooo00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV001Tonk^kP03
ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[o
k^k^001Tooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgoooooo
ooooo`3ooooooc[ooooo001Tonk^kP03ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^k^h0a?o^
k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^001TonKViP03ogmoOooooooooooo01Kooooo00?oOgmo
onKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV001Tonk^kP03ogmoOooooooooooo
01Kooooo00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^001Tooooo`03
ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[o
oooo001Tonk^kP03ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^
onk^kP3oonk^kS[ok^k^001TonKViP03ogmoOooooooooooo01Kooooo00?oOgmoonKVi_oVi^H0a?oV
i^H00omoOgooi^KVonKViP3oonKViS[oi^KV001Tonk^kP03ogmoOooooooooooo01Kooooo00?oOgmo
onk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^001Tooooo`03ogmoOooooooooooo
01Kooooo00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo001Tonk^kP03
ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[o
k^k^001TonKViP03ogmoOooooooooooo01Kooooo00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KV
onKViP3oonKViS[oi^KV001Tonk^kP03ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^k^h0a?o^
k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^001Tooooo`03ogmoOooooooooooo01Kooooo00?oOgmo
ooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo001Tonk^kP03ogmoOoo^k^kok^k^
01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^001TonKViP03
ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[o
i^KV001Tonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^
onk^kP3oonk^kS[ok^k^001Tooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?oo
ool00omoOgooooooooooo`3ooooooc[ooooo001Tonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmo
onk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^001TonKViP03ogmoOooVi^Koi^KV
01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV001Tonk^kP03
ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[o
k^k^001Tooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgoooooo
ooooo`3ooooooc[ooooo001;onk^kQWoRXZ:00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^
kP34onk^kP03ogmoOoo^k^kok^k^0?ook^k^>_o^k^h004_oi^KV6_moOglHonKViP03ogmoOooVi^Ko
i^KV0<Coi^KV00?oOgmoonKVi_oVi^H0oooVi^HjonKViP00Boo^k^h00omoOgooooooooooo`0Foooo
o`03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^
kS[ok^k^001;ooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgoo
ooooooooo`34ooooo`03ogmoOooooooooooo0?oooooo>_ooool004_ok^k^00?oOgmoooooooooool0
5_ooool00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^0<Cok^k^00?oOgmoonk^k_o^k^h0
ooo^k^hjonk^kP00BooVi^H00omoOgooooooooooo`0Fooooo`03ogmoOooVi^Koi^KV01Koi^KV00?o
OgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV001;onk^kP03ogmoOooooooo
oooo01Kooooo00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP34onk^kP03ogmoOoo^k^ko
k^k^0?ook^k^>_o^k^h004_ooooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Foooo
o`03ogmoOooooooooooo0<Cooooo00?oOgmoooooooooool0ooooooljooooo`00Boo^k^h00omoOgoo
ooooooooo`0Fooooo`03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoo
k^k^onk^kP3oonk^kS[ok^k^001;onKViP03ogmoOooooooooooo01Kooooo00?oOgmoonKVi_oVi^H0
5_oVi^H00omoOgooi^KVonKViP34onKViP03ogmoOooVi^Koi^KV0?ooi^KV>_oVi^H004_ok^k^00?o
Ogmoooooooooool05_ooool00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^0<Cok^k^00?o
Ogmoonk^k_o^k^h0ooo^k^hjonk^kP00Boooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooo
oooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo001;onk^
kP03ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP34onk^
kP03ogmoOoo^k^kok^k^0?ook^k^>_o^k^h004_oi^KV00?oOgmoooooooooool05_ooool00omoOgoo
i^KVonKViP0FonKViP03ogmoOooVi^Koi^KV0<Coi^KV00?oOgmoonKVi_oVi^H0oooVi^HjonKViP00
Boo^k^h00omoOgooooooooooo`0Fooooo`03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0
a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^001;ooooo`03ogmoOooooooooooo01Kooooo00?o
Ogmoooooooooool05_ooool00omoOgooooooooooo`34ooooo`03ogmoOooooooooooo0?oooooo>_oo
ool004_ok^k^00?oOgmoooooooooool05_ooool00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^ko
k^k^0<Cok^k^00?oOgmoonk^k_o^k^h0ooo^k^hjonk^kP00BooVi^H00omoOgooi^KVonKViP0FonKV
iP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKV
iS[oi^KV001;onk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgoo
k^k^onk^kP34onk^kP03ogmoOoo^k^kok^k^0?ook^k^>_o^k^h004_ooooo00?oOgmoooooooooool0
5_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo0<Cooooo00?oOgmoooooooooool0
ooooooljooooo`00Boo^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^001;onKViP03ogmoOooVi^Ko
i^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP34onKViP03ogmoOooVi^Ko
i^KV0?ooi^KV>_oVi^H004_ok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^
kP03ogmoOoo^k^kok^k^0<Cok^k^00?oOgmoonk^k_o^k^h0ooo^k^hjonk^kP00Boooool00omoOgoo
ooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgoo
ooooooooo`3ooooooc[ooooo001;onk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0
5_o^k^h00omoOgook^k^onk^kP34onk^kP03ogmoOoo^k^kok^k^0?ook^k^>_o^k^h003;oi^KV6On:
RXX00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oV
i^H00omoOgooi^KVonKViP3oonKViS[oi^KV000bonk^kQ[oOgmo6?o^k^h00omoOgook^k^onk^kP0F
onk^kP03ogmoOoo^k^kok^k^0<Cok^k^00?oOgmoonk^k_o^k^h0ooo^k^hjonk^kP00<_ooool00omo
Ogooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omo
Ogooooooooooo`34ooooo`03ogmoOooooooooooo0?oooooo>_ooool003;ok^k^00?oOgmooooooooo
ool05_ooool00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^
k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000bonKViP03ogmoOooooooooooo01Kooooo
00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV0<Coi^KV
00?oOgmoonKVi_oVi^H0oooVi^HjonKViP00<_o^k^h00omoOgooooooooooo`0Fooooo`03ogmoOoo^
k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP34onk^kP03ogmoOoo^
k^kok^k^0?ook^k^>_o^k^h003;ooooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0F
ooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3o
oooooc[ooooo000bonk^kP03ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^k^h05_o^k^h00omo
Ogook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^0<Cok^k^00?oOgmoonk^k_o^k^h0ooo^k^hjonk^
kP00<_oVi^H00omoOgooooooooooo`0Fooooo`03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oV
i^H05_oVi^H00omoOgooi^KVonKViP34onKViP03ogmoOooVi^Koi^KV0?ooi^KV>_oVi^H003;ok^k^
00?oOgmoooooooooool05_ooool00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^
00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000booooo`03ogmoOooo
oooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooo
oooooooo0<Cooooo00?oOgmoooooooooool0ooooooljooooo`00<_o^k^h00omoOgooooooooooo`0F
ooooo`03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP34
onk^kP03ogmoOoo^k^kok^k^0?ook^k^>_o^k^h003;oi^KV00?oOgmoooooooooool05_ooool00omo
Ogooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omo
Ogooi^KVonKViP3oonKViS[oi^KV000bonk^kP03ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^
k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^0<Cok^k^00?oOgmoonk^k_o^
k^h0ooo^k^hjonk^kP00<_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo
00?oOgmoooooooooool05_ooool00omoOgooooooooooo`34ooooo`03ogmoOooooooooooo0?oooooo
>_ooool003;ok^k^00?oOgmoooooooooool05_ooool00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^
k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000b
onKViP03ogmoOooooooooooo01Kooooo00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0F
onKViP03ogmoOooVi^Koi^KV0<Coi^KV00?oOgmoonKVi_oVi^H0oooVi^HjonKViP00<_o^k^h00omo
Ogook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omo
Ogook^k^onk^kP34onk^kP03ogmoOoo^k^kok^k^0?ook^k^>_o^k^h003;ooooo00?oOgmooooooooo
ool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmooooooooo
ool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo000bonk^kP03ogmoOoo^k^kok^k^01Kok^k^
00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^0<Cok^k^
00?oOgmoonk^k_o^k^h0ooo^k^hjonk^kP00<_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooV
i^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP34onKViP03ogmoOooV
i^Koi^KV0?ooi^KV>_oVi^H003;ok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0F
onk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3o
onk^kS[ok^k^000booooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omo
Ogooooooooooo`0Fooooo`03ogmoOooooooooooo0<Cooooo00?oOgmoooooooooool0ooooooljoooo
o`00<_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^
k^h05_o^k^h00omoOgook^k^onk^kP34onk^kP03ogmoOoo^k^kok^k^0?ook^k^>_o^k^h003;oi^KV
00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV
00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kQWoRXZ:00?o
Ogmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000Ioooooa[oOgmo6?ooool0
0omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool0
0omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmoOooooooooooo01Kooooo00?oOgmoonk^
k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmoOooooooooooo01Ko
oooo00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmo
Oooooooooooo01Kooooo00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^
000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgoooooooooo
o`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgoooooooooo
o`3ooooooc[ooooo000Ionk^kP03ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmoOooooooooooo01Kooooo00?oOgmoonKV
i_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKV
i_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmoOooooooooooo01Ko
oooo00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmo
Oooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmo
Oooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo
000Ionk^kP03ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^
kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^
kP3oonk^kS[ok^k^000IonKViP03ogmoOooooooooooo01Kooooo00?oOgmoonKVi_oVi^H05_oVi^H0
0omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H0
0omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmoOooooooooooo01Kooooo00?oOgmoonk^
k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Ko
oooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Ko
oooo00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmo
Oooooooooooo01Kooooo00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^
000IonKViP03ogmoOooooooooooo01Kooooo00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKV
iP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKV
iP3oonKViS[oi^KV000Ionk^kP03ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmooooo
ooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmooooo
ooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmo
OooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmo
OooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV
000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^
kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^
kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool0
0omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool0
0omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^
000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgoooooooooo
o`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgoooooooooo
o`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKV
i_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKV
i_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmo
Oooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmo
Oooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo
000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^
kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^
kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H0
0omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H0
0omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Ko
oooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Ko
oooo00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^
000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKV
iP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKV
iP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmooooo
ooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmooooo
ooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmo
OooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmo
OooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV
000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^
kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^
kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool0
0omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool0
0omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^
000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgoooooooooo
o`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgoooooooooo
o`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKV
i_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKV
i_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmo
Oooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmo
Oooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo
000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^
kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^
kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H0
0omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H0
0omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Ko
oooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Ko
oooo00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^
000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKV
iP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKV
iP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmooooo
ooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmooooo
ooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmo
OooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmo
OooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV
000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^
kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^
kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool0
0omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool0
0omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^
000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgoooooooooo
o`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgoooooooooo
o`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKV
i_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKV
i_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmo
Oooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmo
Oooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo
000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^
kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^
kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H0
0omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H0
0omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Ko
oooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Ko
oooo00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^
000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKV
iP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKV
iP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmooooo
ooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmooooo
ooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmo
OooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmo
OooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV
000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^
kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^
kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool0
0omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool0
0omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^
000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgoooooooooo
o`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgoooooooooo
o`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKV
i_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKV
i_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmo
Oooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmo
Oooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo
000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^
kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^
kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H0
0omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H0
0omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Ko
oooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Ko
oooo00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^
000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKV
iP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKV
iP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmooooo
ooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmooooo
ooooool0a?ooool00omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmo
OooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmo
OooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV
000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^
kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^
kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool0
0omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool0
0omoOgooooooooooo`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h0a?o^k^h00omoOgook^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oPH61onk^k_o^k^h0a?o^k^h00on1PH7ok^k^onk^kP3oonk^kS[ok^k^
000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgoooooooooo
o`0Fooooo`03ogmoOooooooooooo01Kooooo00?oQ8B4ooooooooool0a?ooool00on4Q8Cooooooooo
o`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oQXJ6onk^k_o^k^h0a?o^k^h0
0on6QXKok^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKV
i_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oRHV9onKV
i_oVi^H0a?oVi^H00on9RHWoi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oRh^;onk^k_o^k^h0a?o^k^h00on;Rh_ok^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmo
Oooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmo
Oooooooooooo01Kooooo00?oSXj>ooooooooool0a?ooool00on>SXkoooooooooo`3ooooooc[ooooo
000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^
kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oT92@onk^k_o^k^h0a?o^k^h00on@T93ok^k^onk^
kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H0
0omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oTi>ConKVi_oVi^H0a?oVi^H0
0onCTi?oi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oUIFEonk^
k_o^k^h0a?o^k^h00onEUIGok^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Ko
oooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Ko
oooo00?oV9RHooooooooool0a?ooool00onHV9Soooooooooo`3ooooooc[ooooo000Ionk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oVYZJonk^k_o^k^h0a?o^k^h00onJVY[ok^k^onk^kP3oonk^kS[ok^k^
000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKV
iP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oWIfMonKVi_oVi^H0a?oVi^H00onMWIgoi^KVonKV
iP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oWinOonk^k_o^k^h0a?o^k^h0
0onOWiook^k^onk^kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmooooo
ooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oXZ:Roooo
ooooool0a?ooool00onRXZ;oooooooooo`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oY:BTonk^k_o^k^h0a?o^k^h00onTY:Cok^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmo
OooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmo
OooVi^Koi^KV01Koi^KV00?oYjNWonKVi_oVi^H0a?oVi^H00onWYjOoi^KVonKViP3oonKViS[oi^KV
000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^
kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oZJVYonk^k_o^k^h0a?o^k^h00onYZJWok^k^onk^
kP3oonk^kS[ok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool0
0omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?o[:b/ooooooooool0a?ooool0
0on/[:coooooooooo`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?o[Zj^onk^
k_o^k^h0a?o^k^h00on^[Zkok^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?o/K6aonKVi_oVi^H0a?oVi^H00ona/K7oi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?o/k>conk^k_o^k^h0a?o^k^h00onc/k?ok^k^onk^kP3oonk^kS[ok^k^
000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgoooooooooo
o`0Fooooo`03ogmoOooooooooooo01Kooooo00?o][Jfooooooooool0a?ooool00onf][Kooooooooo
o`3ooooooc[ooooo000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?o^;Rhonk^k_o^k^h0a?o^k^h0
0onh^;Sok^k^onk^kP3oonk^kS[ok^k^000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKV
i_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?o^k^kogmo
OomoOgl0a?moOgl00onk^k_oi^KVonKViP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00Go_Kfmon_[jooVi^Koh^;RomkNgP04omgMg@?og]kN0:oogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMojNWYomaLG;oE5ADofQXJ?nc/k?ogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMko`l?3ofe]KOoGemOogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgM00?og]kN00?ogMgMomkNg_oNg]h00ooMgMd01?oQhN7oinOWon[Zj_nm
_Kgoonk^kScok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool0
0omoOgooooooooooo`0Fooooo`03oh61POoooooooooo01Kooooo00Co`<30onc/k?oVi^Koh>3P1ooI
fMT01?oHf=Soe]KFom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooC
dm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Co
d=3@om?CdooGemOof=SH<OoIfMT01_mdM7CoI6ATohb<S?mDE5Co2@T9oinOWaCofMWI00?oeMGEoaPH
6?n<S8`0:ooIfMT00ooHf=SofMWIomWIf@06omWIf@04omkNg_oVi^Kok>c/ol30`?oooooo??ooool0
01Wok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^
01Kok^k^00?oQ8B4onk^k_o^k^h05_o^k^h02?o2`/;ok^k^onWYjOoTi>Coh>3Pon7QhOoPh>3oh^;R
0_oQhN403OoNg]kog=cLom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml0
2OoQhN403OoOgmoofm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml0
2OoQhN403OoOgmoofm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml0
:_oQhN400oo@d=3ogmoOon7Qh@02omOGe`GohN7Q00?oCdm?ochn?_oQhN403OoQhN400oo@d=3ogmoO
on7Qh@02omOGe`;ohN7Q00?oNWYjocHf=_oQhN401OoQhN400ooGemOoc<c<on7Qh@0Ton7Qh@03on;R
h_oQhN7oh^;R00CohN7Q00Coi>CTonWYjOo]kNgo`/;2ooo^k^hlonk^kP006OoVi^H00omoOgooi^KV
onKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00on6QXKoi^KV
onKViP0FonKViP04olG5aOo`l?3okno_oo7al@?ol?3`05Ookno_oo3`l?o^k^kojNWYom_Kfoo1`L7o
Y:BTohb<S?mkNg_oMgMgog]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_oNg]kogMgMomkNg_oS8b<ojBTY?o2`/;o
f][Jon[Zj?o]kNgolO7aono_kooalO7okno_oo7alOo_knoolO7_ong]kOoZj^[of][Jol;2`_nTY:Co
S8b<og]kNomgMgKoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akolb<S800_l000008?l71`Oo;2`/ofa/K?oShn?olO7_ono_kooalO7o
>c/kogQhN?o_knoolO7aono_kom<C4_o1`L7oaPH6?nBTY;o4A4Aoe5ADOoalO7of=SHoeMGEole=CGo
Lg=coi>CTolL71cokno_oo7alOo_knoolO7_ono_kooalO7o<S8b1?l00000?olf=SKokno_oda<C?l7
1`Oo61PHoi:BT_lA4A7oDE5Aoo7akoo_knooRHV9o`000?o;bl_okno_oo7alOo_knoof][HodE5AOl2
0P;o820PoaDE5Ond];ColO7aoc/k>omhN7Ookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7ol?3`ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`04
oo3`l003olG5aOoVi^Koi^KV0?ooi^KV>_oVi^H001Wok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omo
Ogook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oRHV9onk^k_o^k^h05_o^k^h01?o7
alOol_;bonk^k_oWinL4onGUi@0@onCTi?oOgmoodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5
AOmADE7oIVIVohZ:ROna/K7odM7AomkNgP;oi>CT00?oiNGUonCTi?oUiN@00_oTi>@03ooNg]kodM7A
ok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7@omkNgP02onCTi02<
onGUiOoTi>CoiNGUonCTi?oTi>?og]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5A
ofIVI_n:RX[o/K6aom7AdOoNg]koi>CSonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
oc0`<?mXJ6Soi>CTomcLg?nf][Ko?CdmoadM7OoGemKoi>CTonGUiOli>CWoLW9bonCTi?oUiNGo/K6a
o`<30oo5aLGoc/k>oe5ADOl?3`ooi>CTonGUiOm4A4Co:BTYoi2@T?m_Kfoo:2PXoa4A4OoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOl`<33oJ6QXonCTi?oUiNGoi>CTonGUi?na/K7o0`<3olG5aOo>c/koDE5A
o`l?3ooTi>CoiNGTonCTi?lZ:R[o20P8ofEUIOoTi>CoiNGUonCTi?lm?Cco>CTiolS8b?oTi>Cof][J
omSHf?oUiNGo>CTiog9bLOoTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>@4onGUi@08onCTi?oUiNGoiNGUonGUiOoXj>SokNg]oo;bl_o7alOo
onk^kScok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omo
Ogooooooooooo`0Fooooo`03oh^;Rooooooooooo01Kooooo00Cob/[:ooCdm?o]kNgoinOW0_oPh>00
4ooQhN7ogmoOomkNg_oBd];o];BdohN7QomLG5coKC/eoii>@_o=KeoojH=_ole_GonNCT?oKC/foeaL
G?n7QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLofeP;?nNURkocLdoonWY
COo=cCooWYX_ofeS;OmLG5coQhN7okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaL
G?m7IbkoJ9hcoi7=AonZjEGoTLe7ofZN=?m9JRooG5aLohN7Qond];Cod];BomkNgP07on3Ph003oooo
oon8R8SoA4A400KoA4A400?o<c<codA4A?m4A4@00om4A4@01?nIVIWoh>3Pobl_;omUIFD3on3Ph003
om_KfolK6a_oHf=S00;oh>3P00ko>3Phofm_KooPh>3oh>3Pokjn__l20P;oYZJVon3Ph?n;Rh_o71`L
on3Ph?oHf=So1`L7oj:RXP;oh>3P00?oPh>3o`h>3_oPh>001OoPh>000ol_;booIFEUon3Ph003on3P
h006okjn__l20P;oYZJVon3Ph?n;Rh_o71`L0_oPh>002Onc/k?o0000oh^;Rol@413ofMWIon3Ph?o2
`/;o0000oj6QX@05on3Ph003ocPh>?m_Kfooh>3P01goh>3P00?ogmoOon3Ph?oOgml00_oOgml3on3P
h005on7QhOoWinOok>c/ooCdm?o:b/X0oooooollooooo`006Oo^k^h00omoOgook^k^onk^kP0Fonk^
kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00on>SXkok^k^onk^kP0Fonk^
kP04olc<c?ofm_Kol_;bon_[j`?oj>SX01?oinOWon;Rh_o=cLgoWinOof]OGon?=RkokG5QooVMT?om
/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=cOoRh^;oinOW00?oj>SX01?oinOWon;Rh_o=
cLgoWinOofiVGonCLR;okM54ooWcM?omoHgooOfEoogmS_oin7KokMM7oi=c8_m^IeooWinOolg=cOoR
h^;oinOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOof1XGom;O2?oT^5;okgiNoo@oI;of?fKomCmUOo0
nGkoV>Q=odf09?mPJEooWinOolg=cOoRh^;oinOW00Koj>SX00?oooooodA4A?mVIVH00omgMgL00omV
IVKoMgMgogMgM`05ogMgM`05oc<c<oo<c<coj>SXoc4a<OmYJFT01?oXj>P01_m`L73o7QhNonSXj?oX
j>So>SXjog=cL`?oj>SX00WoWIfMobd];Ol^;Rko<C4aoadM7OoXj>So/;2`o`000?oAdM400_oXj>P0
0onLW9co3`l?onSXj005onSXj003oc4a<OmYJFWoj>SX00Coj>SX00GoWIfMobd];Ol^;Rko<C4aoadM
7@02onSXj009oemOGolk>c_oj>SXob@T9?nEUIGoj>SXojb/[?l0003o=cLg00?o>CTi00Co/[:bonSX
j?lj>S[oLg=c9ooXj>P01?o/k>col_;booKfm_o<c<coonk^kScok^k^000IonKViP03ogmoOooVi^Ko
i^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03oi2@T?oVi^Ko
i^KV01Koi^KV00?oclo?ooOgmoohn?P01?ohn?P04oogmoOok^k^olk>c_n@T93oQBl[onUTE_okTXOo
oZJKoojaYOoo^:_oo[>VoojXW?okU8WokVQIohTa:on@T93oc/k>onk^k_ogmoL00oohn?P04oogmoOo
k^k^olk>c_n@T93oVFT[oo2m?Ookh6koo_B2ooknR_oooi;oo_j<ookhPookiG3ol<8noiUZ:on@T93o
c/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93o@W<[ohC>@on]kg?o`_j8olknT?oFoiOo
d?jBolKnROnbmGCoR==3odAe:on@T93oc/k>onk^k_ogmoL01_ohn?P03?oooooo<c<conk^k_o^k^ko
^k^kogMgMonZZZ[oooooonk^k_oMgMgoMgMgomgMg@;ok^k^00GoMgMgolc<c?ohn?So=3@dog1`L004
ooShn006oiVIVOl20P;ol_;booShn?ln?SkoIVIV1Oohn?P01oofm_KoShn?ob0P8?ohn?Soe=CDo`00
0?n`/;000_ohn?P00onWYjOo410@ooShn005ooShn003oc@d=?m`L73on?Sh00Kon?Sh01Gom_Kfohn?
SolP823on?Shono_kol>3PkoWIfMooShn?n<S8co?3`looShn?oDe=Co0000ojJVY_o9bLWo`L71o`82
0_oNg]kon?Shochn?_mVIVH08?ohn?P00oogmoOon?ShooShn002ooShn006ooOgmooinOWomoOgooOg
moohn?Soclo?oooVi^HlonKViP006Oo^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^
01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00onCTi?ok^k^onk^kP0Fonk^kP04om7AdOojn_[omOGe
onk^kP;ok>c/04cojn_[onWYjOoOgmoo^[ZjogUBD_no<RCoigAYoof9O_ooV8cooZ:FoonXW?onY9So
oiZ=ooj:Ooo^MV[o`c<TogUBD_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[k?oZj^[ogmoOokZj^_n8IE;o
hY4LooW3D?omfV?oonYbookcO_oonX;oo_Ioooo/LoongVCon/MAon:B7?n9IU?o^[ZjomoOgooZj^[o
jn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S7?nAdUGoY^MZokSiN_o0oX;oaon9ol?nQ?nioG_o
Yna/oiCFEomBYQcoDVeBokZj^_oOgmooj^[Zon_[joo/k>cojn_[onc/k?o[jn_ok>c/oooooolc<c?o
ooooonk^k_mgMgOo03?<0_lc<`00I_m4A4Co<`0co`008_mV06KoMgMgoooooomgMgOo^k^kon_[k?la
<C7oJVYZonc/k?o[jn_ok>c/on_[jon5QHGo10@4onSXj?o[jn_o>c/koa4A4On6QXKod];Bon[Zj_nU
YJKobLW9onSXj?mIFEWoCDe=onc/k?o[jn_o=SHfod10@?oAdM7og]kNodm?Col?3`ook>c/on_[joo/
k>cojn_/onc/k?o[jn_o<C4aofYZJ_o/k>cojn_[onc/k?o[jncok>c/ojFUYOo9bLWoj>SXoeUIFOm=
CDgok>c/oiJFU_l<30cohN7Qonc/k?oKfm_o20P8olK6a_o/k>co>SXjof=SHooShn?oTY:BobLW9oo/
k>cojn_[oc/k>olA4A7oQXJ6om;Bd_o/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k0Oojn_[00Ook>c/on_[joo[jn_ok^k^ooKfm_oinOWodM7A0?ook^k^??o^k^h001Wo
oooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Ko
oooo00?oUIFEooooooooool05_ooool01?oDe=Cono_koo?cloo]kNd2onGUi@18onKVi_oTi>CofMWI
ok:b/_mi;Rkob48don=ZG?odNVgooHQloojGR_onVhkooYR;ooj:O_odNfgoif]MolY2=?mk;Rko/[:b
omSHf?oTi>CoiNGUonKVi_oUiNKoi>CTomSHf?nb/[;oUUD^onZL:ook_4Coo/aCoogHH_onhg;oo^Ue
ookVLoonffGooLaCoo_1AOo^WR_oVEH^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGUonCTi?oHf=Wo/[:b
obiR;_mS[B_oQlY8oiOLFOnUiFWo/_=gokSfNondmGWoYnY[oiSLFOn9cd_oHjh[obiS;_nb/[;of=SI
onCTi?oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_ooooooMgMg0_o^k^h0JomVIVKo06Koo`1Vc?m4A4Co
<`0coc<c<omgMgOo<`0cohR8R?o^k^koIVIVolc<c?oUiNKo<30`ofQXJ?oVi^KoiNGUonKVi_oUiNGo
BDU9obLW9ooVi^KoiNGUod];BomkNg_oDe=Co`P82?oHf=SoNg]lobd];Ol>3Pko<c<cok2`/?oVi^Ko
iNGUolc<c?lm?Cgo2@T9ob@T9?mZJV[o9BDUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUoc0`<?mXJ6So
i^KVonGUiOoVi^KoiNGVonKVi_mkNg_o;Bd]o`h>3_lc<c?o/;2`onKVi_m@D57oIFEUonGUiOoVi^Ko
iNGUof5QHOmgMgOoi^KVolk>com0@43o2`/;oaTI6OnTY:Coi^KVonGUiOm;Bd_oNg]koe=CDol820So
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU00;oi^KV00?o
iNGUonKVi_oVi^H00ooVi^H01OoUiNGokNg]ooCdm?okno_oe=CD0?oooooo??ooool001Wok^k^00?o
Ogmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?o
V9RHonk^k_o^k^h05_o^k^h01?oFe]Koo?clooShn?oalO43onk^kP0Con_[jooQhN7o_;blogXG5oo3
?c;odeI9onAXF_o_Mfcom8=iooR7O?oeQ7[olgU]onEYFooIF4[oa3lbog`G5onl_;cohN7Qonc/k003
onk^kP0Conc/k?oQhN7o_;blojE75ooVUc;omJ``oofl@OombE?ooM1Poo_CIOomdV3oo/eDoofm@_oj
[c;ojI/bojE65onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;bloaMI5omOZ3;oM[dgohK=AonF
eU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg_cOoGj/boaMI5onl_;cohN7Qonc/k006onk^kP05oooooolc
<c?ok^k^omgMgOlA4A400_l0I_l03?lcI/co8R8RohR8R?nIVIWo8R8RomgMgOo^k^koMgMgolc<c?o^
k^ko<S8bofa/K0?ok^k^00?oU9BDo`000?nFUYH01Oo^k^h01Oo[jn_ok^k^onk^k_o^k^kok>c/00Ko
k^k^00?ok>c/onk^k_o^k^h01oo^k^h00olb<S;oK6a/onk^kP06onk^kP03onc/k?o^k^kok^k^00_o
k^k^00?ojn_[onk^k_o^k^h01Oo^k^h00oo[jn_ok^k^onk^kP0Ronk^kP05ong]kOobl_;on?Shoocl
o?oFe]H0ooo^k^hlonk^kP006OoVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?oOgmoonKVi_oVi^H05_oVi^H00onJVY[oi^KVonKViP0FonKViP05omWIfOomoOgooOgmoogm
oOolo?`00_omoOd04oolo?colo?com7AdOmX1`Oo^3@dolLo<ooBD4?ofV9Eon=^H_oTLVCoi6mRomaT
EooCDD?oc44dokTd=?m[1`Ood];Boo?cloolo?`00oomoOd04oolo?colo?com;Bd_nN:`OofXXdon^K
6OoeZ2Won;@oooVmB_oh_dgon[m:ooVh?oofZR[okihIom^;=?nR;@Ood];Boo?cloolo?`00oomoOd0
4oolo?colo?com;Bd_l7@0OoCIXdoen[8?m`^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^BooHZhPodjK
=?l7@POod];Boo?cloolo?`01_omoOd01_oooooo<c<conk^k_lc<c?o<`0co`004@;o8R8R017o03<c
oc<0<olA003o0000oc<c<onk^k_oMgMgok^k^oomoOgo=CDeobd];OmSHf?oCTi>ob`/;?l61PKoSHf=
ooclo00Joogmo@03ocDe=OmcLg?ooOgm03oooOgm00?oo?cloogmoOolo?`00oomoOd00ooIfMWoi^KV
onKViP3oonKViS[oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^
k^h00omoOgook^k^onk^kP0Fonk^kP03oifMWOo^k^kok^k^01Kok^k^03_ofm_KoogmoOojn_[olo?c
onk^k_o`l?3okno_onk^k_oYjNWodm?Coe/M7OnR=3Co]2PMol4j;Oo7BCcoceI:om1GBoo@Ed[obTXn
ol<k;_nf:1goXS@doe`M7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`koo^k^koj^[Zom?Cdon<9Agob74d
omV47OoTU1GoiidTonjX<oo`ZSCokjXconbP9OoWUaGog8PMolQa=?n<9Agodm?Con[Zj_o^k^kol?3`
ono_koo`l?3ok^k^on[ZjOoCdm?o7CPMocB2=?m7UAgoFZDKofV]:P02ogBh>00AogFi>?m[/B_oFjLL
odRJ7OldPSCo7CPMom?CdooZj^Wok^k^oo3`l?o_knool?3`ono_koo`l?3okno_oooooomgMgL00_mV
<fH03_mgMgOoR8R8ofIVI_lc<`3o03?<o`1Vc?lc06Ko0000ofHcI_lc<c?oMgMgolc<c?o`l>ooY:BT
0_n@T900G?nHV9So]kNgomgMgOo_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3oY:BTokbl_?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_0_o`l?06ono_k`04oo?clooinOWoo_knom_Kfoook^k^??o^k^h001Wooooo
00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo
00?oWinOooooooooool05_ooool01?oNg]koo_knooOgmoo`l?04onWYj@0AonOWiooKfm_oHd];oh4b
<_nV=CGo]S@]ol9=@Oo3E4Woa5E:ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooWinL01OoYjNT0
4OoWinOofm_KohU;Bon_Bc;ocGLeomJ;;OoPW2koh:0bon6P=?oPX3;ogiX^omJ;;Oo:MCGo[d/bohU;
BooKfm_oinOW00GojNWY017oinOWom_Kfom;Bd_o<V0bocZ9=OmCVbgoJj/_og2]>?m_[S[oL:dhofZZ
;omCVbgo>HPeoc9P<_m;Bd_ofm_KonOWi`07onWYj@09oooooom4A4Co<`0col`0c?mV<fKoIVIVoa40
0?nIIP3oc9T000;o06K<0_nI09T00onk^k_oMgMgolc<c01QonWYj@03onSXj?oYjNWojNWY00CojNWY
00Col?3`ooOgmoono_kog]kNoooooollooooo`006Oo^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00onRXZ;ok^k^onk^kP0Fonk^kP06on3P
h?ono_kon_[jooCdm?o_knoolO7a0_o`l?004Oo_knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbL
omZNW?oIW9coe9FEok]cLonEE5CoCb<SoiFDU?oZj^[okno_00Gol?3`017okno_on[Zj_nYU9CoPB<S
okYZE?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S8onZU9Coj^[Zono_k`05oo3`l00A
ono_kooZj^[oU9BDob<Z8omDNUCoLjEcoik6UOn/cYco[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BD
on[Zj_o_knl01oo`l?001?oooooo<c<colc<c?m4A4@2o`00000:oc<0<omVIP3ool`0oiUV0?mV06Ko
c03oofH0I_mV<fKoMgMgok^k^fKol?3`00KolO7aoo3`l?odm?Con_[jookno_oPh>3oonk^kScok^k^
000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKV
iP0FonKViP03ojBTY?oVi^Koi^KV01Koi^KV00Gohn?Sooclo?ooooooooooooknoP02ooooo`;oo_kn
04GooOgmooShn?m^KVkoFSlook6@T?oNbLWol>CToo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?ol
o?coooooookno_ooooooo_knooooo_ono_koooooooclo?ohn?SoSFe]ohXo?oo9TI3ojM39ooCYi?of
jnKom>WTonW@bOo9TI3oRCloohe]KOohn?Ooo?clooooooono_koooooookno_ooooooo_knooooo_ol
o?con?Shofe]KOlo?cooT9f@olWEbOoTk>Coi^kVonC/i?o9eLWoT9f@oclo?om]KFgon?Shooclo?oo
ookoo_knooooooono_koooooookno_ooooooo_knoooooomgMgL00_o^k^h00olR8R;oV@2IofHcIP02
ofH0IP1Yoc<0<onIIP3o4A4Aolc<c?o^k^koMgMgolc<c?ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ooooo_kn00;ooooo00?oo_knooooooooool00oooool00oolo?cohn?SonKViP3oonKViS_oi^KV000I
onk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0F
onk^kP03ojNWYoo^k^kok^k^01Ook^k^00Com_Kfookno_ojn_[om?Cd1OoalO403Oo_knooe]KFof][
Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?CgoJf][omKFe_o_knl02OoalO403Oo_knooemKFoh=[
Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<S?mb?CgoPF][omOFe_o_knl02OoalO403Oo_knooe]KFof][
Jolm?CgoS8b<okZj^_o<cLco^[Zjohb<S?lm?CgoJf][omKFe_o_knl02OoalO401_ooooooA4A4onk^
k_nIVIWo4A4AodA4A0;oc03<00CoV@2Io`0cI_o<V@3oMgMg0_o^k^h00omgMgOoc<c<oo7al@1Noo7a
l@04oo3`l?oalO7olO7aoo3`l0ColO7a00Com?Cdoo[jn_ono_kom_Kfooo^k^hmonk^kP006Oooool0
0omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool0
0onYZJWoooooooooo`0Gooooo`05onk^k_omoOgon?Shoo3`l?o[jn/00ooZj^X03OoYjNWoj^[ZonWY
jOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT02ooZj^X02ooYjNWoj>SXoj2K
VomZFEWo@bHVobd92Om29RKoJEUIoj2KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nKVi_oFEUIobHV
9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0:on[ZjP09oooooolc<c?ok^k^ogMgMolc<c?oIVIVoc<c
<oo<0<coA4A400;o03=V00GoMgMgonk^k_o^k^koMgMgok^k^`1Von[ZjP05on_[joo`l?3on?Shoogm
oOo^k^h0oooooolmooooo`006Oo^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h05_o^k^h00on/[:cok^k^onk^kP0Gonk^kP04ono_koodm?Con_[jooCd
m0SolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`
l0colO7a00?oooooogMgMoo^k^h00oo^k^h01_nk^k_oIS=Vooooooo^k^koVIVIohR8R0;ok^k^00?o
MgMgolc<c?oalO40HOoalO400oo`l?3olO7aoo7al@02oo7al@04ooGemOojn_[om?Cdono_koook^k^
?Oo^k^h001Woi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooV
i^Koi^KV01Koi^KV00?o[Zj^onKVi_oVi^H06?oVi^H00oo[jn_omOGeooooo`18ooooo`03oc<c<ooo
ooook^k^00[ok^k^00?oMgMgolc<c?ooool0Ioooool00ooemOGojn_[onKViP3oonKViSgoi^KV000I
onk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0F
onk^kP03ok6a/Oo^k^kok^k^01Wok^k^00Cokno_onk^k_ofm_KooOgmA_ooool00olc<c?oMgMgogMg
M`0;ogMgMfKooooo00CooOgmooKfm_o^k^kokno_ooo^k^hoonk^kP006Oooool00omoOgoooooooooo
o`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00onc/k?ooooooooo
o`0Loooookcohn?Soooooom2ooooo`006Oo^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^ko
k^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00onf][Kok^k^onk^kP34onk^kP03okJf]_o^k^ko
k^k^0?ook^k^Doo^k^h001Woi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKV
iP03ogmoOooVi^Koi^KV01Koi^KV00?o^;RhonKVi_oVi^H0a?oVi^H00onh^;Soi^KVonKViP3oonKV
iU?oi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgoo
k^k^onk^kP0Fonk^kP03ok^k^omoOgooOgmo0<CoOgmo00?o^k^konk^k_o^k^h0ooo^k^iConk^kP00
6Oooool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0
5_ooool01Onm_Kgol?3`onc/k?oYjNWoi^KV00CoiNGU0ooVi^H01OoUiNGoi^KVonGUiOoUiNGoi>CT
00;oiNGU01Coi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoiNGUonCTi0;oiNGU017oi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKViP02onGUi@1oonCTiOoUiNGo
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVokjn__o;bl_oiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_nn_[kobl_;onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVomWIfOna/K7o
h^;RonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVolC4a?oVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi@03onKViP03onGUiOoVi^Koi^KV00?oiNGU00Coj>SXong]kOo_knoo
_KfmoooooomEooooo`006Oo^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^
00?oPH61onk^k_o^k^h05_o^k^h01?o0`<3ojn_[onOWiooRh^88omgMg@;ofm_K00OofMWIomSHf?oH
f=Sof=SHomWIfOoKfm_og=cL00gogMgM00?og=cLom_KfooIfMT00ooHf=P00ooIfMWofm_KomcLg00=
omgMg@03omcLg?oKfm_ofMWI00?of=SH00?ofMWIom_KfooLg=`0:ooMgMd00onFUYKo[Jf]omgMg@0=
omgMg@03oiJFU_n][JgogMgM01OogMgM00?ofm_KohV9ROnk^k/05OoMgMd00oo2`/;ogMgMomgMg@0:
omgMg@03omcLg?oMgMgogMgM00KogMgM00CohN7QonOWioo[jn_o`<30ooo^k^iEonk^kP006OoVi^H0
0omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oQ8B4onKVi_oVi^H05_oVi^H0
2?o2`/;ojn_[onOWiooShn?oh>3Pon7QhOoPh>3oh^;R0_oQhN403OoOgmooh>3Pom_KfooGemOodm?C
om3@d?o?clood=3@om?CdooGemOofm_KomoOgooPh>002OoQhN403OoPh>3ogmoOom_KfooGemOodm?C
om3@d?o?clood=3@om?CdooGemOofm_KomoOgooPh>002OoQhN403OoPh>3ogmoOom_KfooGemOodm?C
om3@d?o?clood=3@om?CdooGemOofm_KomoOgooPh>008ooQhN400ooIfMWof][Jon7Qh@03on7Qh@05
oiNGUon_[jooh>3PomOGeooPh>001?oQhN400ooOgmoof][Jon7Qh@04on7Qh@05oiNGUon_[jooh>3P
omOGeooPh>003ooQhN400ooIfMWoh>3Pon7Qh@02omcLg0;ohN7Q00?o];BdoiJFU_oQhN401OoQhN40
0ooLg=cof=SHon7Qh@0<on7Qh@03olW9bOoQhN7ohN7Q00cohN7Q00?oh^;Ron7QhOoRh^801?oQhN40
1?oShn?oinOWon[Zj_o2`/;oonKViUGoi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmo
onk^k_o^k^h05_o^k^h00on6QXKok^k^onk^kP0Fonk^kP04olG5aOo^k^kok^k^ono_k`Gok^k^083o
kNg]on_[jooVi^Kog]kNom?Cdoo;bl_oa<C4ol?3`oo4a<Cobl_;om?CdooOgmkoi^KVonc/k?o]kNgo
kno_onk^k_o_knook^k^ono_k_o^k^kokno_ong]kOo/k>coi^KVomoOgooCdm?obl_:olC4a?o3`l?o
a<C4ol_;booCdm?ogmoOonKVi_o/k>_okNg]ono_koo^k^kokno_onk^k_o_knook^k^ono_k_o]kNgo
k>c/onKVi_oOgmoodm?Col_;boo4a<Co`l?3olC4a?o;bl_odm?ComoOgooVi^Kok>c/ong]kOo_knko
k^k^ono_koo^k^kokno_onk^k_o_knook^k^ono_k_o^k^kokno_onk^k_o_knook^k^ono_koo^k^ko
kno^onk^k_o_knook^k^ono_koo^k^kokno_onk^k_o_knkoUYJFok>c/oo^k^kokno_onk^k_o_knoo
k^k^omoOg_nFUYKoQHF5ohB4Q?nHV9Sog]kNono_koo^k^koVi^JoinOWon?ShooRXZ:ohR8R?o@d=3o
kno_onk^k_oBd];oRXZ:oh:2P_nRXZ;o^KVioi>CToo_knook^k^oi^KV_nOWiooShn?ohZ:R_n8R8So
d=3@ono_koo^k^kokno^onk^k_o_knook^k^oiJFUPCoOgmo02koV9RHono_konRXZ;oPX:2ohZ:R_o3
`l?oQhN7ojFUY?o^k^kokno_okjn__moOgoog=cLono_koo^k^kokno^on?ShonOWiooP820ohj>S_n9
RHWodm?Conk^k_nKVi[o][Jfono_koo^k^kokno_onk^k_o_knook^k^ono_k_o^k^koeMGEonk^k_o_
knook^k^ono_koo^k^kokno^onk^k_o_knook^k^ono_koo^k^kokno_3?o^k^h00oo5aLGok^k^onk^
kP3oonk^kU?ok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool0
0on9RHWoooooooooo`0Fooooo`04olO7aooemOGol_;bong]k@Gojn_[067ojNWYon?ShooHf=SobLW9
okbl_?ne]KGo/;2`ojn_[on`/;3o]KFeokbl_?o9bLSoemOGon?ShooXj>Sojn_[on[Zj_o[jn_oj^[Z
on_[j_oZj^[ojn_[onSXj?oShn?oemOGolW9bOnl_;co]KFdok2`/?n_[joo/;2`okFe]Onl_;cobLW9
omOGeooShn;oj>SXon_[jooZj^[ojn_[on[Zj_o[jn_oj^[Zon_[j_oXj>Sohn?SomOGeoo9bLWo_;bl
okFe]On`/;3o[jn^ok2`/?ne]KGo_;blolW9bOoGemOohn?SonSXj?o[jn[oj^[Zon_[jooZj^[ojn_[
on[Zj_o[jn_oj^[Zon_[j_oZj^[ojn_[on[Zj_o[jn_oj^[Zon_[jooZj^[ojn_Zon[Zj_o[jn_oj^[Z
on_[jooZj^[ojn_[on[Zj_o[jn[oUIFEok6a/OoZj^[ojn_[on[Zj_o[jn_ojNWYoiFEU?nQXJ7ohn?S
on;Rh_nSXj?oUIFE00;oj^[Z053oVYZIoi^KVooTi>Coj>SXok>c/on6QXKoiNGUon[Zj_nRXZ;oY:BT
onOWioo1`L7oQHF5oi>CToo[jn_oj^[ZoiZJVOnKVi_oi>CTonSXj?nc/k?oQXJ6onGUiOoZj^[ojn_Z
on[Zj_o[jn_oj^[ZoiFEUOn_[joojn_[on[Zj_o[jn[oj^[Zom;Bd_n0P83og=cLomoOgonUYJGoQXJ6
on_[j_oZj^[ojn_[oi:BT_n2PX;o[Zj^on_[jooZj^[ojn_Zoi^KVonJVY[og=cLon_[jooTi>CoiNGU
on[Zj_nJVYWo];Bdon_[jooZj^[ojn_[on[Zj_o[jn_oj^[Zon_[j_oZj^[ocLg=on[Zj_o[jn_oj^[Z
on_[jooZj^[ojn_Zon[Zj_o[jn_oj^[Zon_[jooZj^[ojn_[on[ZjPCojn_[00Soj^[Zon_[joo[jn_o
jn_[ong]kOoalO7omOGeolO7aoooooooEOooool001Wok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omo
Ogook^k^onk^kP0Fonk^kP03oh^;Roo^k^kok^k^01Kok^k^00Cob/[:oo7alOo/k>coj>SX0_oRh^80
4ooShn?oh^;Ron7QhOoLg=cod];Bol;2`_nc/k?o]kNgol[:b_oLg=coiNGUomcLg?o:b/[o^;Rhok>c
/oo2`/;od];BomcLg?oQhN401OoRh^804OoQhN7og=cLom;Bd_o2`/;o/k>cokNg]oo:b/[og=cLonGU
iOoLg=cob/[:okRh^?nc/k?o`/;2om;Bd_oLg=cohN7Q00Goh^;R017ohN7QomcLg?oBd];o`/;2ok>c
/ong]kOob/[:omcLg?oUiNGog=cLol[:b_nh^;So/k>col;2`_oBd];og=cLon7Qh@07on;RhP03oooo
oon8R8SoA4A400KoA4A400?o<c<codA4A?m4A4@00om4A4@01?nIVIWoh^;Roi>CTon][Jd4on;RhP03
om;Bd_moOgooa/K600;oh^;R00Koa/K6ogmoOooDe=Coh^;RoiNGUon`/;02on;RhP06omSHf?moOgoo
`/;2on;Rh_n@T93o][Jf0_oRh^801_n^[ZkoTI6Aon;Rh_oRh^;oUiNGok2`/0;oh^;R00?of=SHogmo
Ooo2`/801OoRh^800onCTi?o[:b/on;RhP03on;RhP06om?Cdon0P83ob<S8on;Rh_nl_;coRh^;0_oR
h^802Oo>c/koOgmookbl_?n6QXKogmoOon;Rh_oDe=CoOgmoolK6aP05on;RhP03oiNGUon`/;3oh^;R
00Ooh^;R00?obLW9on;Rh_oRh^804_oRh^801OoShn?oj>SXon_[jooalO7ob/[:0?ook^k^EOo^k^h0
01Woi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ohj>S_oVi^Koi^KV
01Koi^KV00Coc<c<oo7alOo^k^kojNWY1?oVi^H01ooTi>Cog=cLolc<c?ni^KWo`/;2onGUiOo/k>`0
0oo]kNd01oo/k>coinOWol?3`onj^[[oc<c<omcLg?oTi>@01OoVi^H01ooTi>Cog=cLolc<c?ni^KWo
`/;2onGUiOo/k>`00oo]kNd01oo/k>coinOWol?3`onj^[[oc<c<omcLg?oTi>@01OoVi^H01ooTi>Co
g=cLolc<c?ni^KWo`/;2onGUiOo/k>`00oo]kNd01oo/k>coinOWol?3`onj^[[oc<c<omcLg?oTi>@0
1ooVi^H00oooooooA4A4ofIVIP03ogMgM`03ofIVI_mgMgOoMgMg00GoMgMg00Oo<c<colc<c?oVi^Ko
U9BDoj:RX_o?cloog]kN00;oi^KV00?obl_;ogmoOooKfm/00_oVi^H01_oKfm_oOgmoolc<c?oVi^Ko
V9RHok:b/P?oi^KV00GoQhN7okVi^OoVi^KoT92@okZj^P02onKViP06okRh^?nBTY;oi^KVonKVi_nH
V9So/[:b0ooVi^H00on7QhOo^KVionKViP04onKViP03oiBDU?n][Jgoi^KV00Coi^KV00Goa<C4oi>C
TonCTi?oU9BDoh^;R`02onKViP09ojVYZOnIVIWoi^KVohn?Soo1`L7oi^KVol_;bomoOgooUiNG00?o
V9RH00Coc/k>onKVi_nHV9So/[:b2?oVi^H00oo@d=3oi^KVonKViP0ConKViP04onWYjOo^k^kolO7a
olc<c?ooi^KVEOoVi^H001Wok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^
kP03oi2@T?o^k^kok^k^01Kok^k^00?oclo?ooCdm?odm?@01Oodm?@01_o`l?3oiNGUolo?coo9bLWo
j>SXoo;blP;om_Kf00WomoOgooKfm_ofm_Kom?Cdon[Zj_o9bLWoclo?onGUiOo`l?001Oodm?@01_o`
l?3oiNGUolo?coo9bLWoj>SXoo;blP;om_Kf00WomoOgooKfm_ofm_Kom?Cdon[Zj_o9bLWoclo?onGU
iOo`l?001Oodm?@01_o`l?3oiNGUolo?coo9bLWoj>SXoo;blP;om_Kf00WomoOgooKfm_ofm_Kom?Cd
on[Zj_o9bLWoclo?onGUiOo`l?001oodm?@03?oooooo<c<conk^k_o^k^ko^k^kogMgMonZZZ[ooooo
onk^k_oMgMgoMgMgomgMg@;ok^k^00coMgMgolc<c?odm?CoUiNGohb<S?n>SXkoOgmoojRXZ?o^k^ko
hn?SogmoOooAdM42ooCdm006om3@d?moOgooiNGUooCdm?nLW9co][Jf0_odm?@01_o[jn_oOgmoomSH
f?odm?CoTi>Col;2`P;om?Cd00Ko`<30oiFEUOodm?Com?CdoibLW?nf][H2ooCdm003on_[jomoOgoo
f=SH00Gom?Cd00?oUiNGokBd]?odm?@01_odm?@05Ooclo?o`/;2ohj>S_odm?Cokno_ohF5QOo9bLWo
m?Cdol71`OnKVi_om?Cdon?ShomoOgoocLg=omgMgOoJf][oP820onSXj?odm?CoW9bLojn_[`08ooCd
m003omgMgOodm?Com?Cd01;om?Cd00GomOGeooCdm?odm?Com?Cdolo?c`3oonk^kUGok^k^000Ioooo
o`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00onCTi?oooooooooo`0Foooo
o`04om7AdOokno_omoOgoo;blP?ol?3`00[okno_on_[jooNg]koa<C4omWIfOoWinOok^k^oo?clood
m?ComOGe0_odm?@01oo_knoojNWYom[Jf_o4a<Cog]kNon_[joo_knl00oo`l?002_o_knoojn_[omkN
g_o4a<CofMWIonOWioo^k^kolo?cooCdm?oemOD2ooCdm007ono_kooYjNWof][JolC4a?oNg]kojn_[
ono_k`03oo3`l00:ono_koo[jn_og]kNolC4a?oIfMWoinOWonk^k_oclo?om?CdooGem@;om?Cd00Oo
kno_onWYjOoJf][oa<C4omkNg_o[jn_okno_00Kol?3`00Kooooooc<c<oooooook^k^ogMgMol0<l`2
oc<c000FodA4A?lc03?o000RofH0I_mgMgOoooooogMgMonk^k_ol?3`oiJFU_nc/k?ol?3`omcLg?n4
Q8Co[Jf]oo3`l?nKVi_oWYjNon7QhOoPh>3oWYjNoifMW@;ol?3`00[oVi^KohZ:R_o1`L7oh>3Pojf]
[On6QXKok^k^oo3`l?nBTY;o`<300_o`l?002onn_[koU9BDoo3`l?o`l?3oVi^KohZ:R_o1`L7oh>3P
ojf][On6QXKok^k^00Gol?3`00?oUYJFok:b/_o`l?001?o`l?004oo>c/kogmoOonk^k_nYZJWoY:BT
oo3`l?o7alOoQHF5on_[joo`l?3oj>SXoh:2P_oNg]kol?3`oiZJV_n^[Zkok>c/olG5aOnBTY800_o`
l?001?nKVi_oQhN7okno_ooTi>@6oo3`l003omCDe?o`l?3ol?3`01?ol?3`00Col_;booShn?ojn_[o
dM7AoooooomEooooo`006Oo^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^
00?oUIFEonk^k_o^k^h05_o^k^h01?oDe=ComoOgoo7alOo/k>`2onKViP09onOWiooVi^Koh^;RomCD
e?nk^k_oe]KFomoOgooUiNGoi^KV00;ojn_[00Sok>c/onOWiooUiNGoh>3QomOGeonk^k_oe=CDon7Q
h@;oi^KV00[oinOWonKViooVi^KohN7QomCDe?nk^k_oe]KFomkNg_oUiNGoi^KW0_o[jn/02?o/k>co
inOWonGUiOoPh>3oemOGok^k^ooDe=CohN7Q0_oVi^H05?oWinOoi^KVonKVi_oQhN;oe=CDok^k^ooF
e]Kog]kNonGUiOoVi^Kojn_[on_[k?o/k>coinOWonGUiOoPh>3oemOGok^k^ooDe=CohN7R0_oVi^H0
1ooWinOoi^KVonOWiooVi^KoinOWoooooomgMgL00_o^k^h05_mVIVKo06Koo`1Vc?m4A4Co<`0coc<c
<omgMgOo<`0cohR8R?o^k^koIVIVolc<c?oVi^OoUIFEojn_[ooWinOoi^KVojVYZOn;Rh_oinOWomcL
gOnPX:02ohF5Q@1Coj2PX?oNg]koi^KVonOWionPX:7o]kNgojNWYon4Q8CoRHV9ol?3`ooVi^KoinOW
oiZJV_no_kooi^KVonOWionm_KgoVi^KonKVi_oWinOoX:2QokNg]onWYjOoQ8B4ohV9ROo3`l?oi^KV
onOWiooVi^OoinOWonKVi_oWinOoU9BDojj^[_oVi^KoinOWonKViooWinOoi^KVokNg]onCTi?oQHF5
oiJFU_o>c/koi^KWoj>SXon/[:coinOWonKVi_oWinOoZZZZokFe]OoVi^Oog=cLoi^KVon4Q8CoRXZ:
olW9bOoVi^KoinOWoj2PXOnf][KoY:BToh:2P_oVi^KoinOWonKVi_oWinOoi^KWonOWioo@d=3oinOW
onKVi_oWinOoi^KVonOWiooVi^OoinOWonKVi_oWinOoi^KVonOWiooVi^H00_oWinL00ooVi^KoinOW
onOWi`03onOWi`05onKVi_o/k>colO7aooOgmooDe=@0ooo^k^iEonk^kP006OoVi^H00omoOgooi^KV
onKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oV9RHonKVi_oVi^H05_oVi^H01?oFe]KomOGe
oo;bl_o]kNd3on_[j`08onWYjOoVi^KofMWIokfm_OoHf=SogMgMon?ShooVi^H3onWYj@08onOWiooS
hn?ogmoOomWIfOnm_KgofMWIonKVi_oZj^X3on_[j`08on[Zj_oVi^KofMWIokfm_OoHf=Sog]kNon?S
hooVi^H3onWYj@08onOWiooShn?ogmoOomWIfOnm_KgofMWIonKVi_oZj^X3on_[j`08on[Zj_oVi^Ko
fMWIokfm_OoHf=Sog]kNon?ShooVi^H3onWYj@08onOWiooShn?ogmoOomWIfOnm_KgofMWIonKVi_oZ
j^X6on_[j`05oooooolc<c?ok^k^omgMgOlA4A400_l0I_l03?lcI/co8R8RohR8R?nIVIWo8R8RomgM
gOo^k^koMgMgolc<c?o[jn_oUIFEok6a/@;ojn_[00?oW9bLoi^KVoo[jn/00_o[jn/2on[ZjPOojn_[
00?oj^[Zon_[joo[jn/03Oo[jn/00ooZj^[ojn_[on_[j`06on_[j`03oiFEUOn`/;3ojn_[00Kojn_[
00?oj^[Zon_[joo[jn/02oo[jn/00ooYjNWojn_[on_[j`05on_[j`03onWYjOo[jn_ojn_[00Cojn_[
00?of=SHon_[joo[jn/04_o[jn/01OoZj^[ok^k^oo;bl_oemOGoe]KF0?ooi^KVEOoVi^H001Wok^k^
00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03oiZJV_o^k^kok^k^01Kok^k^
00GofMWIooShn?ohn?Son?ShooOgm`03ooShn007ooCdm?oXj>So_Kfmom_KfooQhN7oi>CTonSXj003
on_[j`07onWYjOoUiNGoh^;RomcLg?nn_[kojNWYooCdm005ooShn007ooCdm?oYjNWo_Kfmom_KfooQ
hN7oi>CTonSXj003on_[j`07onWYjOoUiNGoh^;RomcLg?nn_[kojNWYooCdm005ooShn007ooCdm?oY
jNWo_Kfmom_KfooQhN7oi>CTonSXj003on_[j`07onWYjOoUiNGoh^;RomcLg?nn_[kojNWYooCdm007
ooShn006oooooolc<c?ok^k^oc<c<olc03?o000A0_lR8R803ol0<c?o<`0coa400?l0003o<c<cok^k
^omgMgOo^k^kooShn?nHV9SoUIFEojVYZOnATI7oOgmoom7Ad@0UooShn003oiRHV?nf][Kon?Sh02?o
n?Sh00?ohn?SooShn?ohn?P04?ohn?P00oogmoOon?ShooOgm`03ooShn003omWIfOo^k^kok^k^0?oo
k^k^Doo^k^h001Wooooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03oifM
WOoooooooooo01Kooooo00Gofm_KoogmoOokno_om_Kfoo;blP03oo?cl`07oo7alOoXj>So];Bdom7A
dOoGemOog=cLomkNgP02on7Qh@08on;Rh_oOgmoog=cLomSHf?oAdM7o];BdonSXj?oalO45oo?cl`07
oo7alOoXj>So];Bdom7AdOoGemOog=cLomkNgP02on7Qh@08on;Rh_oOgmoog=cLomSHf?oAdM7o];Bd
onSXj?oalO45oo?cl`07oo7alOoXj>So];Bdom7AdOoGemOog=cLomkNgP02on7Qh@08on;Rh_oOgmoo
g=cLomSHf?oAdM7o];BdonSXj?oalO47oo?cl`0BoooooomgMgOoIS=VofHcI_mgMgOoR8R8ofIVI_lc
<`3o03?<o`1Vc?lc06Ko0000ofHcI_lc<c?oMgMgolc<c?oclo?oclo?0_o5aLD00oo=cLgohn?Soo?c
l`0Uoo?cl`03olo?cooIfMWolo?c02?olo?c00?of][Joo?clooclo<04ooclo<01?ofm_Kon_[jookn
o_oKfm_ooooooeGooooo000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^
k^h00onOWiook^k^onk^kP0Fonk^kP04omkNg_oinOWom?Cdonk^kPCojNWY00Koj>SXon?Shonb/[;o
_knoolc<c?oBd]82omOGe`09omSHf?oGemOoe]KFom;Bd_o;bl_o_[jnok6a/OoShn?oj>SX00GojNWY
00Koj>SXon?Shona/K7o_[jnolc<c?oBd]82omOGe`09omSHf?oGemOoe]KFom;Bd_o;bl_o_[jnok6a
/OoShn?oj>SX00GojNWY00Koj>SXon?Shona/K7o_[jnolc<c?oBd]82omOGe`09omSHf?oGemOoe]KF
om;Bd_o;bl_o_[jnok6a/OoShn?oj>SX00OojNWY00WoooooodA4A?lc03?oc03<ofHcI_mVIVKo4@00
oiUV0?o<V@000_l0I/`2oiT0V@03ok^k^omgMgOoc<c<05;ojNWY00?oeMGEonWYjOoYjNT03?oYjNT0
0ooXj>SojNWYonWYj@04onWYj@04onk^k_odm?ConOWiomkNg_ook^k^EOo^k^h001Woi^KV00?oOgmo
onKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03oj:RX_oVi^Koi^KV01Koi^KV00Koh>3P
ooOgmoodm?Cokno_onc/k?o]kNd3onc/k006on_[joo;bl_o[Jf]olW9bOoGemOohN7Q0ooShn<01_oQ
hN7oemOGolW9bOn][Jgobl_;on[ZjPOok>c/00Koj^[Zol_;bon][JgobLW9omOGeooQhN43on?Sh`06
on7QhOoGemOobLW9ojf][Oo;bl_oj^[Z1oo/k>`01_oZj^[obl_;ojf][Oo9bLWoemOGon7Qh@?ohn?S
00KohN7QomOGeoo9bLWo[Jf]ol_;booZj^X8onc/k004oooooolc<c?oc<c<odA4A0;o000000[o<`0c
ofIV0?ooc03oVFH0ofH0I_o<0?ooIP1VofHcI_mgMgOo^k^kD_o/k>`00ooKfm_ok>c/onc/k00Aonc/
k006ong]kOo/k>cokno_ooCdm?ogmoOoh>3PoooVi^IEonKViP006Oo^k^h00omoOgook^k^onk^kP0F
onk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oY:BTonk^k_o^k^h05_o^k^h01OoShn?onOWioo[jn_oj
n_[onOWi00;on_[j0ooinOT0A?ogmoOobLW9okfm_OoMgMgok^k^ooGemOofm_KomOGeonk^k_oMgMgo
_KfmolS8b?ogmoOon?Shoo[jn_oinOWon_[jooWinOojn_WonOWioo[jn_ohn?SomoOgolS8b?nm_Kgo
gMgMonk^k_oemOGom_KfooGemOo^k^kogMgMokfm_Oo8b<SomoOfooShn?ojn_[onOWioo[jn_oinOWo
n_[jooWinOojn_Won?ShooOgmoo8b<So_KfmomgMgOo^k^komOGeooKfm_oemOGok^k^omgMgOnm_Kgo
b<S8ooOgmoohn?Son_[iooWinOojn_[onOWioo[jn_oinOWon_[jooWinOooooooMgMg0_o^k^h00olR
8R;oV@2IofHcIP02ofH0IP1Yoc<0<onIIP3o4A4Aolc<c?o^k^koMgMgolc<c?ojn_WonOWioo[jn_oi
nOWon_[jooWinOojn_[onOWioo[jnOoinOWon_[jooWinOojn_[onOWioo[jn_oinOWon_[iooWinOoj
n_[onOWioo[jn_oinOWon_[jooWinOojn_WonOWioo[jn_oinOWon_[jooWinOojn_[onOWioo[jnOoi
nOWon_[jooWinOojn_[onOWioo[jn_oinOWon_[iooWinOojn_[onOWioo[jn_oinOWon_[jooWinOoj
n_WonOWioo[jn_oinOWon_[jooWinOojn_[onOWioo[jnOoinOWon_[jooWinOojn_[onOWioo[jn_oi
nOWon_[iooWinOojn_[onOWioo[jn_oinOWon_[jooWinOojn_WonOWioo[jn_oinOWon_[jooWinOoj
n_[onOWioo[jnOoinOWoj>SXooWinOojn_[onOWioo[jn_oinOWon_[iooWinOojn_[onOWioo[jn_oi
nOWon_[jooWinOojn_[onOWi00;on_[j00?onOWioo[jn_ojn_X00oojn_X00ooinOWohn?Sonk^kP3o
onk^kUCok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00onW
YjOoooooooooo`0Gooooo`04oo7alOono_kono_kooKfmPGom?Cd00golo?con[Zj_o5aLGo^KViomCD
e?oRh^;oj>SXon;Rh_oDe=Co^KViolG5aOoZj^[olo?c00Wom?Cd00golo?con[Zj_o5aLGo^KViomCD
e?oRh^;oj>SXon;Rh_oDe=Co^KViolG5aOoZj^[olo?c00Wom?Cd00golo?con[Zj_o5aLGo^KViomCD
e?oRh^;oj>SXon;Rh_oDe=Co^KViolG5aOoZj^[olo?c00Wom?Cd00KoooooodA4A?o^k^koVIVIoa4A
4Om4A4@2ol`0c004oiT0VOl0<fKoc9T0ogMgM`;ok^k^00?oMgMgolc<c?odm?@0DOodm?@00ooMgMgo
m?CdooCdm00:ooCdm004oo?cloodm?Com?Cdoo?cl`Com?Cd00Com_Kfoo_knoono_kolO7aoooooomF
ooooo`006Oo^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oZJVYonk^
k_o^k^h05oo^k^h01Oo/k>con?ShooCdm?o^k^kojn_[00?oj^[Z00cojNWYon[Zj_oZj^[ojNWYolg=
cOng]kOoYJFUoibLW?nUYJGo]kNgolg=cOoYjNT=on[ZjP09onWYjOo=cLgo]kNgojFUYOnLW9coYJFU
okNg]oo=cLgojNWY00goj^[Z00WojNWYolg=cOng]kOoYJFUoibLW?nUYJGo]kNgolg=cOoYjNT02ooZ
j^X02Ooooooo<c<conk^k_mgMgOo<c<cofIVI_lc<c?oc03<odA4A002o`0cIP05ogMgMoo^k^kok^k^
ogMgMonk^k/0D_oZj^X00ooIfMWoj^[Zon[ZjP0Aon[ZjP05on_[joo^k^kom?CdooShn?o/k>`0ooo^
k^iFonk^kP006OoVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?o[:b/
onKVi_oVi^H05ooVi^H01?oXj>Sol?3`ooCdm?o_knl:ong]k@?ok>c/4oo]kNd3onc/k1?okNg]0oo/
k>`>ong]k@03oooooomgMgOok^k^00?ok^k^00Ko^k^kofHcI_ooooook^k^oiVIVOn8R8P2onk^kP03
ogMgMoo<c<cokNg]057okNg]00?ogmoOong]kOo]kNd03Oo]kNd00oo/k>cokNg]ong]k@02ong]k@04
oo3`l?odm?Col?3`onSXj?ooi^KVE_oVi^H001Wok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgoo
k^k^onk^kP0Fonk^kP03ojj^[_o^k^kok^k^01Sok^k^00?ol?3`oo7alOojn_X0Aoojn_X00ooooooo
<c<cooooo`0;onk^kP03ogMgMoo<c<con_[j057on_[j00?oj^[Zoo[jn_ojn_X04oojn_X00ooalO7o
l?3`onk^kP3oonk^kUKok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0
5_ooool00ona/K7oooooooooo`0Jooooo`03onc/k?oalO7ooooo04Kooooo00?o<c<cogMgMomgMgL0
2omgMgMCooooo`03on_[jooooooooooo017ooooo00?olO7aonc/k?ooool0oooooomHooooo`006Oo^
k^h00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?o/k>conk^k_o^k^h07?o^
k^jlon?Shoook^k^Foo^k^h001Woi^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0F
onKViP03okJf]_oVi^Koi^KV0<Coi^KV00?o][JfonKVi_oVi^H0oooVi^I/onKViP006Oo^k^h00omo
Ogook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?o^;Rhonk^k_o^k^h0a?o^k^h00onh
^;Sok^k^onk^kP3oonk^kVcok^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?oOgmooooooooo
ool05_ooool00onk^k_oOgmoogmoO`34ogmoO`03ok^k^ooooooooooo0?ooooooK?ooool001Wok^k^
00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP05okfm_Oo[jn_oinOWonCTi?oQ
hN401?oPh>03on7Qh@05on3Ph?oQhN7oh>3Pon3Ph?oOgml00_oPh>005?oQhN7oh>3Qon7QhOoPh>3o
hN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>3ohN7Qon3PhOoPh>3o
gmoO0_oPh>004OoQhN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>3ohN7Qon3PhOoQ
hN7oh>3Pon7QhOoPh>3ohN7Q00;oh>3P07oogmoPon3Ph?oPh>3ohN7Qon3Ph?oQhN7oh>3Pon7QhOoP
h>7ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>3ohN7Qon3PhOoQhN7oh>3Pon7QhOoPh>3ohN7Qon3Ph?oQ
hN7oh>3Qon7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7oh>3Pon7QhOoP
h>3ohN7Qon3PhOoQhN7oh>3Pon7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3Qon7QhOoPh>3ohN7Qon3Ph?oQ
hN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>3ohN7Qon3PhOoQhN7oh>3Pon7QhOoP
h>3ohN7Qon3Ph?oQhN7oh>3Qon7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQ
hN7oh>3Pon7QhOoPh>3ohN7Qon3PhOoEeMGo[Zj^omkNg_oPh>3ohN7Qon3Ph?oQhN7oh>3Qon7QhOoP
h>3ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>3ohN7Qon3PhOoQ
hN7oa<C4on7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3Qon7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3P00?ohN7Q
00?oh>3Pon7QhOoQhN400ooPh>001?oShn?oj>SXon[Zj_nm_Kgoonk^kVkok^k^000IonKViP03ogmo
OooVi^Koi^KV01Koi^KV00?oPH61onKVi_oVi^H05_oVi^H01?o0`<3ojNWYonGUiOoPh>08om_Kf`;o
fMWI00OoemOGomKFe_oFe]Koe]KFomOGeooIfMWof][J00gofm_K00?of][JomWIfOoGemL00ooFe]H0
0ooGemOofMWIom[JfP0=om_Kf`03om[Jf_oIfMWoemOG00?oe]KF00?oemOGomWIfOoJf]X0E?oKfm/0
0ooIfMWoRHV9okZj^P0Fom_Kf`03ol;2`_oKfm_ofm_K00[ofm_K00?of][Jom_KfooKfm/01_oKfm/0
1?oOgmooiNGUonWYjOo0`<3oonKViVkoi^KV000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oQ8B4
onk^k_o^k^h05_o^k^h02?o2`/;okNg]onWYjOoUiNGoh^;Ron?ShooRh^;oi>CT0_oShn<03OoQhN7o
h^;RomgMgOoIfMWoeMGEom;Bd_oAdM7od];BomGEeOoIfMWogMgMon7QhOoRh^802OoShn<03OoRh^;o
hN7QomgMgOoIfMWoeMGEom;Bd_oAdM7od];BomGEeOoIfMWogMgMon7QhOoRh^802OoShn<03OoRh^;o
hN7QomgMgOoIfMWoeMGEom;Bd_oAdM7od];BomGEeOoIfMWogMgMon7QhOoRh^809ooShn<00ooKfm_o
g=cLon?Sh`04on?Sh`03on7QhOoIfMWohn?S00Gohn?S00?ofm_Kon;Rh_oShn<00_oNg]hAon?Sh`03
om_KfooRh^;ohn?S00;og]kN0_oShn<00one]KGoUiNGon?Sh`05on?Sh`03omkNg_oIfMWohn?S00go
hn?S00?obLW9on?ShooShn<03?oShn<00ooTi>Cohn?SonCTi004on?Sh`04onGUiOoYjNWok>c/ol;2
`_ook^k^K_o^k^h001Wooooo00?oOgmoooooooooool05_ooool00on6QXKoooooooooo`0Fooooo`04
olG5aOoclo?olo?cooCdm0Golo?c07ool_;boo3`l?o[jn_oh^;RomSHf?o?cloobLW9olO7aoo9bLWo
clo?omSHf?oShn;ojn_[oo7alOobl_;om?Cdoo?cloodm?Colo?cooCdlooclo?om?Cdoo;bl_oalO7o
jn_[on?ShooHf=Soclo>olW9bOo7alOobLW9olo?cooHf=Sohn?Son_[jooalO3ol_;booCdm?oclo?o
m?Cdoo?cloodm?Colo?cooCdloobl_;olO7aon_[jooShn?of=SHolo?coo9bLWoalO7olW9bOo?cloo
f=SHon?Shoo[jn_olO7aoo;bl_odm??olo?cooCdm?oclo?om?Cdoo?cloodm?Colo?cooCdlooclo?o
m?Cdoo?cloodm?Colo?cooCdm?oclo?om?Ccoo?cloodm?Colo?cooCdm?oclo?om?Cdoo?cloodm??o
UiNGol[:b_oclo?ojn_[olO7aooZj^[olo?comKFeOmoOgoom?Cdoo?clooShn?oUiNGohF5QOn4Q8Co
VIVHon?Shoodm?Colo?com;Bd_n5QHGoOgmooi>CToo2`/7oQXJ6ooCdm?oclo?oY:BToh:2P_n:RX[o
aLG5ohN7QonVYZKom?CdoibLW?ni^KWolo?cooCdm?oclo?om?Ccoo?cloodm?CoUiNG00CoOgmo02oo
VIVIoo?clonTY:CoPX:2ohZ:R_o5aLGoQhN7ojJVY_odm??olo?col71`OmoOgoohN7Qoo?cloodm?Co
lo?conSXj?nPX:3oP820ohj>S_n9RHWoe]KFooCdm?nLW9co^KVhoo?cloodm?Colo?cooCdm?oclo?o
m?Cdoo?cloodm??olo?comGEeOoclo?om?Cdoo?cloodm?Colo?cooCdlooclo?om?Cdoo?cloodm?Co
lo?cooCdm00<oo?cl`03olG5aOoooooooooo0?ooooooK?ooool001Wok^k^00?oOgmoonk^k_o^k^h0
5_o^k^h00on9RHWok^k^onk^kP0Fonk^kP04olO7aoo`l?3okNg]onSXj0Goi^KV06Goi>CTomkNg_oC
dm?oaLG5okRh^?na/K7o[:b/oj^[Zon/[:co/K6aokRh^?o5aLCodm?ComkNg_oShn?oi^KVonGUiOoV
i^KoiNGUonKViOoUiNGoi^KVon?ShooNg]kodm?ColG5aOnh^;So/K6`ojb/[?n[Zj_o[:b/ok6a/Onh
^;SoaLG5om?CdooNg]gohn?SonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKViOoShn?og]kNom?Cdoo5
aLGo^;Rhok6a/On/[:coZj^Zojb/[?na/K7o^;RholG5aOoCdm?og]kNon?ShooVi^GoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKViOoUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KUonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^GoU9BDol71`OoUiNGo^;RhogmoOond];CoiNGUolc<bomo
Ogooi^KVonCTi?nDU9CoWinOomoOgooNg]koXJ6QoiBDU002onGUi@1<oi>CTonSXj?og]kNolo?conA
TI7oQHF5onKVi_o>c/koP820omOGeooKfm_oXj>SohF5QOoUiNGoi^KVoiRHV?nb/[;oiNGUonKVi_oU
iNGoi^KUonGUiOoVi^KoU9BDojf][OoUiNGoi^KVonGUiOoVi^Goc/k>oh20P?oGemOofm_Koj>SXon5
QHGoiNGUonKViOoUiNGoTI6Aoh:2P_n/[:coiNGUonKVi_oUiNGoVYZJoiRHV?oIfMWoiNGUon7QhOoO
gmooi^KVoiRHV?nb/[7oiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKViOoUiNGocLg=onGUiOoV
i^KoiNGUonKVi_oUiNGoi^KUonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi@Coi^KV00SoiNGUonKV
i_oVi^Koi^KVonSXj?o/k>col?3`olO7aoook^k^K_o^k^h001Woi^KV00?oOgmoonKVi_oVi^H05_oV
i^H00on;Rh_oi^KVonKViP0FonKViP04ol[:b_o_knooj^[ZonKViP;oh>3P01?ohN7Qon3Ph?oOgmoo
f][Jom7AdOo1`L7o/K6aokFe]Oo9bLWof][JonCTi?oJf][obLW9okJf]_na/K7o`<30om7AdOoJf][o
gmoO00Goh>3P017ogmoOom[Jf_oAdM7o`<30ok6a/One]KGobLW9om[Jf_oTi>Cof][JolW9bOnf][Ko
/K6aol30`?oAdM7of][JomoOg`05on3Ph00AomoOgooJf][odM7Aol30`?na/K7o]KFeolW9bOoJf][o
i>CTom[Jf_o9bLWo][Jfok6a/Oo0`<3odM7Aom[Jf_oOgml01ooPh>000oooooooR8R8odA4A006odA4
A003oc<c<om4A4CoA4A400?oA4A400ooVIVIon3Ph?nCTi?o_Kfmon3Ph?nBTY;oVYZJohf=SOoPh>3o
alO7ogmoOooPh>3odM7AogmoOoo4a<@00_oPh>001_o4a<CoOgmoom;Bd_oGemOoOgmoolW9b@;oh>3P
00Wo`<30ohF5QOoPh>3odM7Aoh20P?o6a/Koh>3Pok^k^on;Rh/00_oPh>000onGUiOo[jn_on3Ph005
on3Ph003oi>CTon[Zj_oh>3P00?oh>3P00KodM7Aoh20P?o6a/Koh>3Pok^k^on;Rh/2on3Ph009olc<
c?moOgoo^k^kohJ6Q_oMgMgoh>3Pom?CdomoOgooa<C400Goh>3P00?oUiNGojn_[ooPh>002?oPh>00
0oo9bLWoh>3Pon3Ph00Bon3Ph005on7QhOoVi^KojNWYono_koo:b/X0oooVi^I^onKViP006Oo^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ohj>S_o^k^kok^k^01Kok^k^00Coc<c<oo?cloo`l?3ojn_[1?oX
j>P01ooVi^KogMgMolk>c_nj^[[oa<C4onOWioo^k^h00oo_knl01oo^k^kojNWYolG5aOnk^k_oc/k>
omgMgOoVi^H01OoXj>P01ooVi^KogMgMolk>c_nj^[[oa<C4onOWioo^k^h00oo_knl01oo^k^kojNWY
olG5aOnk^k_oc/k>omgMgOoVi^H01OoXj>P01ooVi^KogMgMolk>c_nj^[[oa<C4onOWioo^k^h00oo_
knl01oo^k^kojNWYolG5aOnk^k_oc/k>omgMgOoVi^H01ooXj>P00oooooooA4A4ofIVIP03ogMgM`03
ofIVI_mgMgOoMgMg00GoMgMg013o<c<colc<c?oXj>SoUIFEol;2`_oGemOoOgmoomKFe_n@T93odM7A
olg=cOmoOgooj>SXolg=cOmoOgoogMgM0_oXj>P01_oLg=coOgmoolk>c_o>c/koOgmoomgMg@;oj>SX
00WoaLG5ohJ6Q_oXj>Soj>SXolK6a_nCTi?oU9BDoiFEUOn<S8`00_oXj>P00onIVIWo/k>conSXj005
onSXj003oiFEUOn^[Zkoj>SX00Coj>SX00Goa/K6oi>CTonDU9CoUIFEohb<S002onSXj008ojZZZ_nI
VIWoj>SXohn?Soo2`/;oj>SXolg=cOmoOgl4oiRHV004olo?cooXj>SoVIVIok>c/`Woj>SX00?od=3@
onSXj?oXj>P04ooXj>P01?o[jn_ol?3`oo?cloo<c<coonk^kVkok^k^000Iooooo`03ogmoOooooooo
oooo01Kooooo00?oT92@ooooooooool05_ooool00oo?cloonOWiooWin@05ooWin@06ooGemOoZj^[o
dm?Colc<c?o/k>com_Kf0_ojn_X02Ookno_on_[joo[jn_ohn?Sok^k^olc<c?oCdm?oj^[ZooGem@05
ooWin@06ooGemOoZj^[odm?Colc<c?o/k>com_Kf0_ojn_X02Ookno_on_[joo[jn_ohn?Sok^k^olc<
c?oCdm?oj^[ZooGem@05ooWin@06ooGemOoZj^[odm?Colc<c?o/k>com_Kf0_ojn_X02Ookno_on_[j
oo[jn_ohn?Sok^k^olc<c?oCdm?oj^[ZooGem@07ooWin@0<oooooolc<c?ok^k^onk^k_nk^k_oMgMg
ojZZZ_ooooook^k^omgMgOmgMgOogMgM0_o^k^h04?mgMgOoc<c<ooWinOnHV9SocLg=okZj^_nEUIGo
nOWiol30`?na/K7of][JogmoOooinOWoj>SXogmoOooEeMD2ooWin@06omCDe?moOgooj^[Zon[Zj_mo
Ogooe=CD0_oinOT00ooAdM7oQhN7ooWin@03ooWin@03ooShn?o5aLGoSXj>00;onOWi00?oWIfMok^k
^ooinOT01OoinOT00onHV9So][JfooWin@06ooWin@0EooShn?o5aLGoSXj>ooWinOodm?CoQXJ6olc<
c?oinOWo`l?3oibLW?oinOWoinOWogmoOoo@d=3oh^;RomkNg_n0P83ok>c/ooWinOnMWIgo/K6a00Wo
nOWi00?ogMgMooWinOoinOT04_oinOT01Oojn_[onOWiooWinOoinOWoclo?0?ooooooK_ooool001Wo
k^k^00?oOgmoonk^k_o^k^h05_o^k^h00onCTi?ok^k^onk^kP0Fonk^kP04om7AdOofm_Kol_;bong]
k@?ojn_[00[oj^[ZonKVi_oIfMWo`<30omKFe_oTi>Cojn_[oo3`l?oalO7ol_;b0_oalO401oo/k>co
i^KVomOGeoo0`<3ofMWIonKVi_oZj^X00oo[jn/02_oZj^[oi^KVomWIfOo0`<3oe]KFonCTi?o[jn_o
l?3`oo7alOobl_82oo7al@07onc/k?oVi^KoemOGol30`?oIfMWoi^KVon[ZjP03on_[j`0:on[Zj_oV
i^KofMWIol30`?oFe]Koi>CTon_[joo`l?3olO7aoo;blP;olO7a00Ook>c/onKVi_oGemOo`<30omWI
fOoVi^Koj^[Z00Kojn_[00Kooooooc<c<oooooook^k^ogMgMol0<l`2oc<c000BodA4A?lc03?o000R
ofH0I_mgMgOoooooogMgMonk^k_ojn_[oiFEUOo4a<CoS8b<okVi^Oo[jn_ogmoOohN7Qoo<c<coOgmo
0_o[jn/01_nJVY[oWIfMomgMgOoLg=coWIfMoi^KV`;ojn_[00KoVi^KoibLW?oOgmooh^;Roj6QXOn6
QXH2on_[j`05ol_;booKfm_ojNWYojRXZ?nRXZ800_o[jn/00onJVY[o];Bdon_[j`05on_[j`03oiFE
UOn`/;3ojn_[00Cojn_[01?obl_;om_KfooYjNWoZ:RXoj:RX_o[jn_oa<C4ohB4Q?oVi^Kojn_[on?S
hon2PX;of][Jon_[jonIVIWo[:b/onOWioo1`L7oTI6A00;ojn_[00CoVYZJohN7Qonl_;cogmoO1oo[
jn/00ooDe=Cojn_[on_[j`0Con_[j`04ong]kOoclo?omOGeom7AdOook^k^K_o^k^h001Woi^KV00?o
OgmoonKVi_oVi^H05_oVi^H00onEUIGoi^KVonKViP0FonKViP04omCDe?oemOGokno_on[ZjP;oi>CT
00WoiNGUonCTi?oPh>3odm?CokZj^_oEeMGog]kNonCTi?oUiND00_oZj^X02?o[jn_oi^KVonCTi?oO
gn3oe]KFokVi^OoCdm?ogmoO0_oTi>@02_oUiNGoi>CUonCTi?oOgmoodm?CokVi^OoEeMGogMgMonCT
i?oUiNH2on[ZjP08on_[jooVi^Koi>CTomoOgooFe]Ko^KVjom?CdooOgml2onCTi00DonGUiOoTi>Co
i>CTomoOh?oCdm?o^KViomGEeOoMgMgoi>CTonGUiOoZj^[oj^[[on_[jooVi^Koi>CTomoOgooFe]Ko
^KViom?CdooOgn02onCTi007onGUiOoTi>CoiNGUonCTi?oUiNGoooooogMgM`02onk^kP1[ofIVI_l0
I_oo06K<odA4A?lc03?o<c<cogMgMolc03?oR8R8onk^k_mVIVKoc<c<onCTiOnDU9CoZ:RXogmoOooI
fMWoiNGUonCTi?nKVi_oZJVZogmoOooTi>CoiNGUom[Jf_nOWiooQ8B4ohF5QOnPX:3og=cLonCTi?oU
iNGof][JoiZJV_n3Ph?oShn?ojZZZ_n5QHGoi>CTonGUiOne]KGoTi>CohF5QOnEUIGoc<c=onGUiOoT
i>CoV9RHok6a/OoUiNGoi>CTonGUiOoTi>GoiNGUonCTi?nDU9Co[:b/onGUiOoTi>CoiNGUonCTiOoU
iNGo]KFeoi>CTon5QHGoUIFEolc<c?oUiNGoXZ:Sojb/[?oTi>CoiNGUonCTi?nZZZ[o/k>conGUiOoJ
f]_oVi^KohB4Q?n:RX[oalO7onGUiOoTi>CoX:2PokFe]OnTY:CoPX:2onGUiOoTi>CoiNGUonCTi?oU
iNGoi>CUonGUiOo@d=3oiNGUonCTi?oUiNGoi>CTonGUiOoTi>GoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>@00_oUiND00ooTi>CoiNGUonGUi@03onGUi@05onCTi?oZj^[okno_ooGemOoDe=@0oooVi^I^onKV
iP006Oo^k^h00omoOgook^k^onk^kP0Fonk^kP03oiRHV?o^k^kok^k^01Kok^k^00Coe]KFooOgmood
m?Cokno_0oo]kNd02?o[jn_oj>SXom_Kfonn_[kof][JomkNg_oTi>CoinOW0ooZj^X02?oXj>Soi>CT
on3Ph?oJf][o_[jnom_KfooXj>Sok>c/0oo]kNd02?o/k>coj>SXom_Kfonn_[kofMWIomoOgooTi>Co
inOW0ooZj^X02?oXj>Soi>CTon3Ph?oJf][o_[jnom_KfooXj>Sok>c/0oo]kNd02?o/k>coj>SXom_K
fonn_[kofMWIomoOgooTi>CoinOW0ooZj^X02?oXj>Soi>CTon3Ph?oJf][o_[jnom_KfooXj>Sok>c/
1_o]kNd01Ooooooo<c<conk^k_oMgMgo4A4A00;o06Ko00go<fK<ob8R8_n8R8SoVIVIob8R8_oMgMgo
k^k^ogMgMoo<c<cokNg]oiJFU_n7QhOoVi^K00?okNg]00?oaLG5ohN7QomoOgl01?o]kNd2onc/k0Ko
kNg]00Cok>c/ong]kOo9bLWoQXJ61?o]kNd00oo/k>cokNg]ong]k@02ong]k@03oiZJV_ne]KGokNg]
00GokNg]00?oUYJFok6a/Oo]kNd01_o]kNd00oo/k>cokNg]ong]k@0;ong]k@03on_[joo]kNgokNg]
00GokNg]00?ojn_[ong]kOo]kNd01Oo]kNd00ooHf=SokNg]ong]k@0Bong]k@05onc/k?o`l?3om?Cd
ooOgmooFe]H0ooo^k^i^onk^kP006Oooool00omoOgooooooooooo`0Fooooo`03oiZJV_oooooooooo
01Kooooo00GofMWIoogmoOomoOgooOgmooclo003oogmo@07ooWinOo]kNgo`<30omkNg_oTi>CoinOW
on_[j`03onk^kP07onc/k?oXj>SoiNGUomoOgoo1`L7ok^k^ooWin@05oogmo@07ooWinOo^k^ko`<30
omkNg_oTi>CoinOWon_[j`03onk^kP07onc/k?oXj>SoiNGUomoOgoo1`L7ok^k^ooWin@05oogmo@07
ooWinOo^k^ko`<30omkNg_oTi>CoinOWon_[j`03onk^kP07onc/k?oXj>SoiNGUomoOgoo1`L7ok^k^
ooWin@07oogmo@06oooooolc<c?ok^k^oc<c<olc03?o000A0_lR8R803?l0<c?o<`0coa400?l0003o
<c<cok^k^omgMgOo^k^koogmoOnIVIWoOgmoolg=c@?ooOgm00?on?ShohB4Q?moOgl03_omoOd00ooC
dm?oQhN7oogmo@08oogmo@03oijNW_nm_KgooOgm00GooOgm00?oVIVIokRh^?omoOd09?omoOd00ooS
hn?ooOgmoogmo@0@oogmo@03ooclo?omoOgoo?cl00?ooOgm00?ofMWIooooooooool0oooooom/oooo
o`006Oo^k^h00omoOgook^k^onk^kP0Fonk^kP03oifMWOo^k^kok^k^01Kok^k^00Gofm_KooShn?of
m_KolO7aong]k@03onk^kP07onc/k?oShn?o/K6aolk>c_oDe=CofMWIom_Kf`02omkNgP08omoOgooL
g=cofMWIomGEeOo>c/ko/K6aon?Shoo/k>`5onk^kP07onc/k?oShn?o/K6aolk>c_oDe=CofMWIom_K
f`02omkNgP08omoOgooLg=cofMWIomGEeOo>c/ko/K6aon?Shoo/k>`5onk^kP07onc/k?oShn?o/K6a
olk>c_oDe=CofMWIom_Kf`02omkNgP08omoOgooLg=cofMWIomGEeOo>c/ko/K6aon?Shoo/k>`7onk^
kP0DoooooomgMgOoIS=VofHcI_mgMgOoR8R8ofIVI_lc<`3o03?<o`1Vc?lc06Ko0000ofHcI_lc<c?o
MgMgolc<c?o^k^kobl_;ol;2`_oXj>P4onk^kP03olk>c_o2`/;ok^k^00gok^k^00?obLW9ohJ6Q_o^
k^h02?o^k^h00onJVY[o][Jfonk^kP05onk^kP03ol_;booFe]Kok^k^02Cok^k^00?of][Jonk^k_o^
k^h04oo^k^h01?oalO7omOGeooWinOoKfm_oonk^kVkok^k^000IonKViP03ogmoOooVi^Koi^KV01Ko
i^KV00?oWinOonKVi_oVi^H05_oVi^H01?oNg]komoOgoo;bl_o/k>`4onOWi`06onKVi_oQhN7o/;2`
okjn__o;bl_odM7A0_oFe]H02OoGemOoe]KFomGEeOoAdM7ob/[:okfm_On_[joohN7QonKViP05onOW
i`06onKVi_oQhN7o[jn_okfm_Oo;bl_odM7A0_oFe]H02OoGemOoe]KFomGEeOoAdM7ob/[:okfm_On_
[joohN7QonKViP05onOWi`06onKVi_oQhN7o[jn_okfm_Oo;bl_odM7A0_oFe]H02OoGemOoe]KFomGE
eOoAdM7ob/[:okfm_On_[joohN7QonKViP07onOWi`09oooooom4A4Co<`0col`0c?mV<fKoIVIVoa40
0?nIIP3oc9T000;o06K<0_nI09T00onk^k_oMgMgolc<c00HonOWi`03onKVi_oTi>CoinOW00SoinOW
00?oiNGUonKVi_oWinL0;?oWinL00ooEeMGoinOWonOWi`0<onOWi`03onKVi_oWinOoinOW00CoinOW
00Cok>c/oo;bl_ogmoOog]kNoooVi^I^onKViP006Oo^k^h00omoOgook^k^onk^kP0Fonk^kP03oj:R
X_o^k^kok^k^01Kok^k^00Koh>3PooWinOofm_KolO7aonk^k_o_knl3onk^kP06ong]kOo=cLgo[jn_
ol_;booIfMWohn?S0ooUiND01_oShn?ofMWIol_;bon_[joocLg=onc/k0Ook^k^00Kok>c/olg=cOn_
[joobl_;omWIfOoShn<3onGUi@06on?ShooIfMWobl_;ojn_[oo=cLgok>c/1oo^k^h01_o/k>cocLg=
ojn_[oo;bl_ofMWIon?Sh`?oiNGU00Kohn?SomWIfOo;bl_o[jn_olg=cOo/k>`8onk^kP04oooooolc
<c?oc<c<odA4A0;o000000[o<`0cofIV0?ooc03oVFH0ofH0I_o<0?ooIP1VofHcI_mgMgOo^k^kD_o^
k^h00ooKfm_ok^k^onk^kP0Aonk^kP06ono_koo^k^kolO7aooKfm_oinOWoh>3Pooo^k^i^onk^kP00
6Oooool00omoOgooooooooooo`0Fooooo`03ojBTY?oooooooooo01Kooooo00Gohn?Soooooooooooo
ooooooknoP02ooooo`?oo_kn04Coo?clolg=cOo0`<3oh>3Poo;bl_ohn?Son_[jooShn?obl_;oh>3P
ol71`?o<c<coo?cloogmoOooooooo_knooooooono_koooonookno_oooooooOgmooclo?o<c<co`L71
on3Ph?obl_7on?Shoo[jn_ohn?Sol_;bon3Ph?o1`L7oc<c<ooclnoomoOgoooooookno_ooooooo_kn
ooooooono_koooonoogmoOolo?coc<c<ol71`OoPh>3ol_;booShn?ojn_Won?Shoo;bl_oPh>3o`L71
olc<c?olo?cooOgmooooo_ono_koooooookno_ooooooo_knooooooono_koooooogMgM`;ok^k^00?o
8R8RoiT0VOmV<fH00_mV06H0JOlc03?oVFH0oa4A4Oo<c<cok^k^ogMgMoo<c<coooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knonSXj?ono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooooooknoP02ooooo`03ookno_oooooooooo00Cooooo00?ohn?Sooooooooool0
oooooom/ooooo`006Oo^k^h00omoOgook^k^onk^kP0Fonk^kP03ojNWYoo^k^kok^k^01Ook^k^00Co
lO7aooWinOofm_KolO7a1Oo_knl03Oo^k^koiNGUol71`Onf][KodM7AomoOgooUiNGogmoOom7AdOnf
][Ko`L71onGUiOo^k^h02Oo_knl03Oo^k^koiNGUol71`Onf][KodM7AomoOgooUiNGogmoOom7AdOnf
][Ko`L71onGUiOo^k^h02Oo_knl03Oo^k^koiNGUol71`Onf][KodM7AomoOgooUiNGogmoOom7AdOnf
][Ko`L71onGUiOo^k^h02Oo_knl01_ooooooA4A4onk^k_nIVIWo4A4AodA4A0;oc03<00CoV@2Io`0c
I_o<V@3oMgMg0_o^k^h00omgMgOoc<c<ono_k`1Aono_k`03omgMgOo_knookno_00[okno_00Cok^k^
ono_koo_knook^k^1?o_knl01?oalO7om_KfooWinOoalO7oonk^kVook^k^000IonKViP03ogmoOooV
i^Koi^KV01Koi^KV00?oZJVYonKVi_oVi^H05ooVi^H01Oo/k>com_Kfoo;bl_o/k>cojNWY00?oj>SX
00coinOWonSXj?oXj>SoinOWol_;bonf][KoY:BToi^KVonTY:Co][Jfol_;booWinL=onSXj009onOW
ioo;bl_o][JfojBTY?nKVi_oY:BTokJf]_o;bl_oinOW00goj>SX00WoinOWol_;bonf][KoY:BToi^K
VonTY:Co][Jfol_;booWinL02ooXj>P02Ooooooo<c<conk^k_mgMgOo<c<cofIVI_lc<c?oc03<odA4
A002o`0cIP05ogMgMoo^k^kok^k^ogMgMonk^k/0D_oXj>P00ooIfMWoj>SXonSXj00AonSXj005onWY
jOo/k>col_;booKfm_o/k>`0oooVi^I_onKViP006Oo^k^h00omoOgook^k^onk^kP0Fonk^kP03ojb/
[?o^k^kok^k^01Ook^k^00Cokno_oo3`l?ofm_KolO7a2_o_knl3onk^kQ?okno_0oo^k^hCono_k`?o
k^k^3_o_knl00oooooooMgMgonk^kP03onk^kP06ok^k^omV<fKoooooonk^k_nIVIWoR8R80_o^k^h0
0omgMgOoc<c<ono_k`1Aono_k`03omoOgoo_knookno_00gokno_00?ok^k^ono_koo_knl00_o_knl0
1?obl_;om_Kfoo3`l?o_knooonk^kVook^k^000Iooooo`03ogmoOooooooooooo01Kooooo00?o[Zj^
ooooooooool06Oooool00ooalO7oooooooooo`17ooooo`03oc<c<oooooook^k^00[ok^k^00?oMgMg
olc<c?ooool0DOooool00ooZj^[oooooooooo`0Cooooo`03oo7alOoooooooooo0?ooooooKoooool0
01Wok^k^00?oOgmoonk^k_o^k^h05_o^k^h00ona/K7ok^k^onk^kP0Ionk^kP04ono_koo/k>colO7a
ooWinDGon_[j00?ooooooc<c<omgMgL03?mgMgL00ooooooon_[joo[jnP1@oo[jnP03on_[joojn_[o
n_[j013on_[j00ConOWioo7alOo/k>cokno_ooo^k^iaonk^kP006OoVi^H00omoOgooi^KVonKViP0F
onKViP03ok>c/ooVi^Koi^KV01coi^KV_?oShn?oonKViWCoi^KV000Ionk^kP03ogmoOoo^k^kok^k^
01Kok^k^00?o][Jfonk^k_o^k^h0a?o^k^h00onf][Kok^k^onk^kP3oonk^kXGok^k^000Iooooo`03
ogmoOooooooooooo01Kooooo00?o^;Rhooooooooool0a?ooool00onh^;Soooooooooo`3oooooohGo
oooo000Ionk^kP03ogmoOoo^k^kok^k^01Kok^k^00?o^k^kogmoOomoOgl0a?moOgl00onk^k_ok^k^
onk^kP3oonk^kXGok^k^000IonKViP03ogmoOooVi^Koi^KV01Koi^KV00Go_KfmonWYjOoUiNGoh^;R
omoOg`04omkNgP?ogmoO00Gog]kNomoOgooNg]kog]kNomgMg@02omkNgP0DomoOgooNg]oogmoOomkN
g_oOgmoog]kNomoOgooNg]kogmoOomkNgooOgmoog]kNomoOgooNg]kogmoOomkNg_oOgmoog]kOomkN
g_oMgMd2omkNgP0AomoOgooNg]kogmoOomkNgooOgmoog]kNomoOgooNg]kogmoOomkNg_oOgmoog]kO
omoOgooNg]kogmoOomkNg_oOgml00_oNg]h0OooMgMkog]kNomkNg_oOgmoog]kNomoOgooNg]kogmoO
omkNgooOgmoog]kNomoOgooNg]kogmoOomkNg_oOgmoog]kOomoOgooNg]kogmoOomkNg_oOgmoog]kN
omoOgooNg]oogmoOomkNg_oOgmoog]kNomoOgooNg]kogmoOomkNgooOgmoog]kNomoOgooNg]kogmoO
omkNg_oOgmoog]kOomoOgooNg]kogmoOomkNg_oOgmoog]kNomoOgooNg]oogmoOomkNg_oOgmoog]kN
omoOgooNg]kogmoOomkNgooOgmoog]kNomoOgooNg]kogmoOomkNg_oOgmoog]kOomoOgooNg]kogmoO
omkNg_oOgmoog]kNomoOgooNg]oogmoOomkNg_oOgmoog]kNomoOgooNg]kogmoOomkNgooOgmoog]kN
omoOgooNg]kogmoOomkNg_oOgmoog]kOomoOgooNg]kogmoOomkNg_oCdm?o[Jf]omcLg?oNg]oogmoO
omkNg_oOgmoog]kNomoOgooNg]kogmoOomkNgooOgmoog]kNomoOgooNg]kogmoOomkNg_oOgmoog]kO
omoOgoo4a<CogmoOomkNg_oOgmoog]kNomoOgooNg]oogmoOomkNg_oOgmoog]kNomoOgooNg]h00ooO
gml00ooNg]kogmoOomoOg`03omkNgP04on7QhOoVi^Koj>SXokfm_Oooi^KVQooVi^H001Wok^k^00?o
PH61onk^k_o^k^h05_o^k^h01?o0`<3ojn_[onOWiooRh^88omgMg@;ofm_K00OofMWIomSHf?oHf=So
f=SHomWIfOoKfm_og=cL00gogMgM00?og=cLom_KfooIfMT00ooHf=P00ooIfMWofm_KomcLg00=omgM
g@03omcLg?oKfm_ofMWI00?of=SH00?ofMWIom_KfooLg=`0F?oMgMd00ooKfm_oRHV9ok^k^`0BomgM
g@03ol;2`_oMgMgogMgM00[ogMgM00?og=cLomgMgOoMgMd01_oMgMd01?oQhN7oinOWon_[joo0`<3o
onk^kXOok^k^000Iooooo`03ohB4Q?oooooooooo01Kooooo00So`/;2oo;bl_o^k^koj^[ZonOWiooX
j>SoinOWonWYj@;oj>SX00goi^KVonOWiooRh^;ogMgMom[Jf_oFe]KoeMGEomKFe_oJf][ogMgMon;R
h_oVi^KoinOW00Woj>SX00goinOWonKVi_oRh^;ogMgMom[Jf_oFe]KoeMGEomKFe_oJf][ogMgMon;R
h_oVi^KoinOW00Woj>SX00goinOWonKVi_oRh^;ogMgMom[Jf_oFe]KoeMGEomKFe_oJf][ogMgMon;R
h_oVi^KoinOW02;oj>SX00?oh>3PonOWiooXj>P00_oShn<7onSXj003on?ShooNg]koj>SX00Coj>SX
00?ogMgMonOWiooXj>P00_oXj>P00ooMgMgoinOWonSXj002onSXj003on?ShooNg]koj>SX00koj>SX
00?oh>3PonOWiooXj>P00_oShn<2onSXj003okRh^?nHV9Soj>SX00Goj>SX00?ohn?SomkNg_oXj>P0
2OoXj>P00oo9bLWoj>SXonSXj00<onSXj003onWYjOoXj>SojNWY00Coj>SX00Coj^[Zonk^k_oalO7o
`/;2oooooon7ooooo`006Oo^k^h00on6QXKok^k^onk^kP0Fonk^kP04olG5aOo^k^kok^k^ono_k`Go
k^k^08?okNg]on_[jooVi^Kog]kNom?Cdoo;bl_oa<C4ol?3`oo4a<Cobl_;om?CdooOgmkoi^KVonc/
k?o]kNgokno_onk^k_o_knook^k^ono_k_o^k^kokno_ong]kOo/k>coi^KVomoOgooCdm?obl_:olC4
a?o3`l?oa<C4ol_;booCdm?ogmoOonKVi_o/k>_okNg]ono_koo^k^kokno_onk^k_o_knook^k^ono_
k_o]kNgok>c/onKVi_oOgmoodm?Col_;boo4a<Co`l?3olC4a?o;bl_odm?ComoOgooVi^Kok>c/ong]
kOo_knkok^k^ono_koo^k^kokno_onk^k_o_knook^k^ono_k_o^k^kokno_onk^k_o_knook^k^ono_
koo^k^kokno^onk^k_o_knook^k^ono_koo^k^kokno_onk^k_o_knkoUYJFok>c/oo^k^kokno_onk^
k_o_knook^k^oj:RX_n2PX;oRXZ:ol;2`_n7QhOoY:BTono_konJVY[o][Jfonk^k_o_knoohn?SoinO
Won0P83oSXj>ohV9ROoCdm?ok^k^om_Kfon?ShooS8b<olo?coo_knoof][John?Son<S8cod=3@onk^
k_oTi>CoWinOoh20P?n>SXkoRHV9om?Cdoo_knook^k^ono_koo^k^kokno_oiJFUP04ogmoO`0[oiRH
V?o^k^koXZ:Roh:2P_n:RX[o`/;2ohN7QonTY:Cokno_onk^k_no_kooOgmoomgMg?o^k^kokno_onk^
k_oTi>CoWinOoh20P?n>SXkoRHV9om?Cdoo_knooVYZJono_koo^k^kokno_onk^k_o_knkok^k^omGE
eOo^k^kokno_onk^k_o_knook^k^ono_k_o^k^kokno_onk^k_o_knook^k^ono_k`0<onk^kP03olG5
aOo^k^kok^k^0?ook^k^QOo^k^h001Woi^KV00?oRHV9onKVi_oVi^H05_oVi^H01?o7alOok^k^on_[
jooVi^H5onCTi01_on;Rh_oLg=cod];Bol?3`onf][Ko/;2`ojZZZ_nYZJWoZZZZok2`/?nf][Ko`l?2
om7AdOoLg=cohN7QonCTi?oShn?oi>CTon?ShooTi>?ohn?SonCTi?oQhN7og=cLom7AdOo3`l?o][Jf
ok2`[onZZZ[oZJVYojZZZ_n`/;3o][Jfol?3`ooAdM7og=cKon7QhOoTi>Cohn?SonCTi?oShn?oi>CT
on?ShooTi>?ohN7QomcLg?oAdM7o`l?3okJf]_n`/;3oZZZZojVYZOnZZZ[o/;2`okJf]_o3`l?odM7A
omcLg?oQhN7oi>CSon?ShooTi>Cohn?SonCTi?oShn?oi>CTon?ShooTi>?ohn?SonCTi?oShn?oi>CT
on?ShooTi>Cohn?SonCThooShn?oi>CTon?ShooTi>Cohn?SonCTi?oShn?oi>CSoiBDU?n^[Zkohn?S
onCTi?oShn?oi>CTolc<c?n0P83oeMGEom[Jf_nRXZ;oQHF5on?ShooTi>CoV9RHok6a/?oShn?oi>CT
oiVIVOnHV9Soe]KFonCTi?oNg]kog]kMon?Shon[Zj_oV9RH00;ohn?S04;oi>CToj^[ZonHV9Soh^;R
onCTi?oShn?oVIVIoiRHV?oGemOohn?SomoOg_oMgMgoi>CTon?ShooTi>Cohn?SonCTi?nDU9Co[:b/
on?ShooTi>Cohn?SonCTi?o<c<coP820omGEeOoJf]WoXZ:RohF5QOoShn?oi>CTon?ShonATI7oPX:2
oj^[ZooShn?oi>CTon?ShonIVIWoV9RHomOGeooShn?ogmoNomgMgOoTi>CoV9RHonCTi?oShn?oi>CT
on?ShooTi>?ohn?Solg=cOoShn?oi>CTon?ShooTi>Cohn?SonCThooShn?oi>CTon?ShooTi>Cohn?S
onCTi?oShn<4onCTi008on?ShooTi>Coi>CTonCTi?oVi^Koj^[Zonk^k_o7alOoonKViXOoi^KV000I
onk^kP03oh^;Roo^k^kok^k^01Kok^k^00Cob/[:oo7alOo/k>coj>SX0_oRh^804ooShn?oh^;Ron7Q
hOoLg=cod];Bol;2`_nc/k?o]kNgol[:b_oLg=coiNGUomcLg?o:b/[o^;Rhok>c/oo2`/;od];BomcL
g?oQhN401OoRh^804OoQhN7og=cLom;Bd_o2`/;o/k>cokNg]oo:b/[og=cLonGUiOoLg=cob/[:okRh
^?nc/k?o`/;2om;Bd_oLg=cohN7Q00Goh^;R017ohN7QomcLg?oBd];o`/;2ok>c/ong]kOob/[:omcL
g?oUiNGog=cLol[:b_nh^;So/k>col;2`_oBd];og=cLon7Qh@07on;RhP03oooooon8R8SoA4A400Ko
A4A400?o<c<codA4A?m4A4@00om4A4@01?nIVIWoh^;Roi>CTon][Jd4on;RhP06om?Cdon0P83ob<S8
on;Rh_nl_;coRh^;0_oRh^801_nGUiOo/;2`on;Rh_oDe=CoOgmoolK6aPGoh^;R00?oW9bLoj^[ZooR
h^800_oRh^801onLW9coZj^[on;Rh_oRh^;oe=CDogmoOoo6a/H02OoRh^800onCTi?o[:b/on;RhP03
on;RhP06om?Cdon0P83ob<S8on;Rh_nl_;coRh^;0_oRh^802Oo>c/koOgmookbl_?n6QXKogmoOon;R
h_oDe=CoOgmoolK6aP05on;RhP03oiNGUooRh^;oh^;R00Coh^;R00?obLW9on;Rh_oRh^804_oRh^80
1OoShn?oj>SXon_[jooalO7ob/[:0?ook^k^Qoo^k^h001Wooooo00?oSXj>ooooooooool05_ooool0
1?o<c<con?ShooGemOo`l?04ong]k@07on_[jooRh^;od];Bokjn__o7alOoj^[Zoo7al@03oo;blP07
oo7alOo/k>cob<S8okno_ooBd];oh^;Ron_[j`05ong]k@07on_[jooRh^;od];Bokjn__o7alOoj^[Z
oo7al@03oo;blP07oo7alOo/k>cob<S8okno_ooBd];oh^;Ron_[j`05ong]k@07on_[jooRh^;od];B
okjn__o7alOoj^[Zoo7al@03oo;blP07oo7alOo/k>cob<S8okno_ooBd];oh^;Ron_[j`07ong]k@03
oooooom4A4CoIVIV00?oMgMg00?oIVIVogMgMomgMgL01OmgMgL01olc<c?oc<c<ong]kOnFUYKoY:BT
omGEeOoTi>@00oo]kNd01Oo9bLWoU9BDoiFEUOnFUYKoS8b<00;okNg]00KoVYZJokFe]Oo]kNgod=3@
ogmoOonIVIT3oiZJVP04om?Cdoo]kNgoX:2Pok2`/0?okNg]00OoX:2Pok2`/?o]kNgokNg]om3@d?mo
OgooVIVI00?oVYZJ00?odm?Cong]kOo]kNd00oo]kNd00onFUYKo/K6aong]k@04ong]k@05olW9bOnD
U9CoUIFEoiJFU_n<S8`00_o]kNd02On/[:coVi^Kong]kOn@T93oaLG5ong]kOo@d=3oOgmooiVIV@03
oiZJVP03om?Cdoo]kNgoVYZJ00KokNg]00?od=3@ong]kOo]kNd04oo]kNd01?o`l?3omOGeooShn?o<
c<coooooohOooooo000Ionk^kP03oi2@T?o^k^kok^k^01Kok^k^00?oclo?ooCdm?odm?@01Oodm?@0
1_o`l?3oiNGUolo?coo9bLWoj>SXoo;blP;om_Kf00WomoOgooKfm_ofm_Kom?Cdon[Zj_o9bLWoclo?
onGUiOo`l?001Oodm?@01_o`l?3oiNGUolo?coo9bLWoj>SXoo;blP;om_Kf00WomoOgooKfm_ofm_Ko
m?Cdon[Zj_o9bLWoclo?onGUiOo`l?001Oodm?@01_o`l?3oiNGUolo?coo9bLWoj>SXoo;blP;om_Kf
00WomoOgooKfm_ofm_Kom?Cdon[Zj_o9bLWoclo?onGUiOo`l?001oodm?@03?oooooo<c<conk^k_o^
k^ko^k^kogMgMonZZZ[oooooonk^k_oMgMgoMgMgomgMg@;ok^k^00WoMgMgolc<c?odm?CoUiNGohb<
S?n>SXkoOgmoojRXZ?o^k^h00oodm?@00ooclo?o`/;2ohj>SP02ooCdm00=oibLW?ni^KWom?Cdon?S
homoOgoocLg=omgMgOoJf][oP820onSXj?odm?CoXZ:Rok>c/`03ooCdm00;oj:RX_nc/k?om?CdooCd
m?oShn?oOgmoolg=cOoMgMgof][Joh20P?oXj>P01Oodm?@00onGUiOo];BdooCdm006ooCdm00Doo?c
loo2`/;oSXj>ooCdm?o_knooQHF5olW9bOodm?Co`L71oi^KVoodm?Cohn?SogmoOoo=cLgogMgMom[J
f_n0P83oj>SXooCdm?nLW9`6ooCdm003omgMgOodm?Com?Cd01;om?Cd00GomOGeooCdm?odm?Com?Cd
olo?c`3oonk^kXOok^k^000IonKViP03oi>CTooVi^Koi^KV01Koi^KV00CodM7AooCdm?o`l?3ojn_[
0ooYjNT02_oXj>Soi>CTomOGeono_kooe=CDon;Rh_oYjNWok^k^ono_koo`l?02ono_k`07on[Zj_oT
i>CoeMGEokno_ooGemOoi>CTonSXj003onWYj@0:onSXj?oTi>CoemOGokno_ooDe=Coh^;RonWYjOo^
k^kokno_oo3`l0;okno_00Ooj^[ZonCTi?oEeMGo_knoomOGeooTi>Coj>SX00?ojNWY00[oj>SXonCT
i?oGemOo_knoomCDe?oRh^;ojNWYonk^k_o_knool?3`0_o_knl01ooZj^[oi>CTomGEeOno_kooemOG
onCTi?oXj>P01_oYjNT01_oooooo<c<cooooooo^k^koMgMgo`0cc0;o<c<001GoA4A4oc<0<ol002;o
IP1VogMgMoooooooMgMgok^k^ooYjNWoUIFEok2`/?oYjNWoe]KFoh>3Pon[Zj_ojNWYolW9bOoIfMWo
inOWojNWYonQXJ400_oYjNT06_nIVIWo/k>conWYjOoYjNWoVIVIoj^[ZooUiNGo`<30oi2@T?oYjNWo
i^KVoifMWOn/[:coi>CTonOWiooVi^KoWIfMojb/[?oTi>CoinOWonWYjOnIVIWoZj^[onGUiOo0`<3o
T92@1_oYjNT00onEUIGo[jn_onWYj@04onWYj@0ColW9bOoIfMWoinOWojNWYonQXJ7ojNWYol;2`_n4
Q8Coi>CTonWYjOoQhN7oPX:2omSHf?oYjNWoVIVIoj^[ZooUiNGo`<30oi2@T002onWYj@03oiVIVOoY
jNWojNWY00CojNWY00?oe=CDonWYjOoYjNT04ooYjNT01?o[jn_olO7aoo?clooAdM7oonKViXOoi^KV
000Ionk^kP03oiFEUOo^k^kok^k^01Kok^k^00Coe=CDooOgmooalO7ok>c/0_oVi^H02OoWinOoi^KV
on;Rh_oDe=Co^k^komKFe_oOgmooiNGUonKViP02on_[j`08onc/k?oWinOoiNGUon3PhOoGemOo^k^k
omCDe?oQhN42onKViP0:onOWiooVi^Ooi^KVon7QhOoDe=Co^k^komKFe_oNg]koiNGUonKVi`;ojn_[
00Sok>c/onOWiooUiNGoh>3PomOGeonk^k_oe=CDon7Qh@;oi^KV01CoinOWonKVi_oVi^KohN7RomCD
e?nk^k_oe]KFomkNg_oUiNGoi^KVon_[joo[jncok>c/onOWiooUiNGoh>3PomOGeonk^k_oe=CDon7Q
hP;oi^KV00OoinOWonKVi_oWinOoi^KVonOWioooooooMgMg00;ok^k^06_oIVIVo`1Vool0I/coA4A4
oc<0<olc<c?oMgMgoc<0<on8R8Sok^k^ofIVI_o<c<coi^KWoiFEUOn_[jooinOWonKVi_nYZJWoRh^;
onOWionf][OoTi>CohF5QOnFUYKoc/k>onOWiooVi^KoVIVIok:b/_oWinOoi^KVomcLg?nKVi_oQ8B4
ohZ:R_o9bLWoi^KWok:b/_n2PX;oPh>3ohV9ROo5aLGo/[:boh:2P_n3Ph?oRXZ:olG5aOoWinOofm_K
oi^KVon4Q8CoRXZ:olS8bOoWinOoi^KVonOWiooVi^KoinOWonKVi_nEUIGo[Jf^onOWiooVi^KoinOW
onKVi_oWinOo][Jfoi>CTon5QHGoUYJFolk>c_oWinOoXj>Sojf][OoVi^KoinOWonKVion[Zj_o];Bd
onOWiooKfm_oVi^KohB4Q?n:RX[ob<S9onOWiooVi^KoXJ6QonKVi_oWinOoi^KVonOWiooVi^OoinOW
om3@d?oWinOoi^KVonOWiooVi^KoinOWonKViooWinOoi^KVonOWiooVi^KoinOWonKViP02onOWi`03
onKVi_oWinOoinOW00?oinOW00Goi^KVonc/k?oalO7omoOgomCDe03oonk^kXOok^k^000Iooooo`03
oiRHV?oooooooooo01Kooooo00Coe]KFooclo?oinOWom?Cd0oobl_802?o`l?3okNg]omoOgoo2`/;o
gMgMon7QhOoWinOoj^[Z0oo]kNd02?o[jn_oinOWon?ShooMgMgo`/;2omoOgoo]kNgolO7a0oobl_80
2?oalO7okNg]omoOgoo2`/;og=cLon;Rh_oWinOoj^[Z0oo]kNd02?o[jn_oinOWon?ShooMgMgo`/;2
omoOgoo]kNgolO7a0oobl_802?oalO7okNg]omoOgoo2`/;og=cLon;Rh_oWinOoj^[Z0oo]kNd02?o[
jn_oinOWon?ShooMgMgo`/;2omoOgoo]kNgolO7a1_obl_801Ooooooo<c<conk^k_oMgMgo4A4A00;o
06Ko00co<fK<ob8R8_n8R8SoVIVIob8R8_oMgMgok^k^ogMgMoo<c<col_;boiNGUond];@2oo;blP03
oijNW_nMWIgol_;b00;ol_;b00?olO7aoo;bl_obl_800_obl_800onKVi_o^;Rhoo;blP03oo;blP03
oo3`l?obl_;ol_;b00;ol_;b00?oXJ6Qok:b/_obl_800_obl_800onQXJ7o/[:boo;blP04oo;blP03
oo3`l?obl_;ol_;b00Kol_;b00?oUiNGok>c/oobl_801_obl_800ooalO7ol_;boo;blP0;oo;blP03
oo3`l?obl_;ol_;b00Wol_;b00?of=SHoo;bl_obl_804_obl_801OoalO7omOGeooWinOolo?coe]KF
0?ooooooQoooool001Wok^k^00?oVYZJonk^k_o^k^h05_o^k^h01OoIfMWon?ShooShn?ohn?SomoOg
00?on?Sh00Oom?CdonSXj?nm_Kgofm_Kon7QhOoTi>Coj>SX00?ojn_[00OojNWYonGUiOoRh^;og=cL
okjn__oYjNWom?Cd00Gon?Sh00Oom?CdonWYjOnm_Kgofm_Kon7QhOoTi>Coj>SX00?ojn_[00OojNWY
onGUiOoRh^;og=cLokjn__oYjNWom?Cd00Gon?Sh00Oom?CdonWYjOnm_Kgofm_Kon7QhOoTi>Coj>SX
00?ojn_[00OojNWYonGUiOoRh^;og=cLokjn__oYjNWom?Cd00Oon?Sh00Kooooooc<c<oo^k^ko<c<c
oc<0<ol00142ob8R8P0?o`0c<olc03?o4@00o`000?lc<c?o^k^kogMgMonk^k_on?ShoiRHV?nEUIGo
ZJVYoi6ATOmoOgoodM7A00Son?Sh00?oWIfMok^k^oohn?P02?ohn?P00ooYjNWoj>SXooShn002ooSh
n003onWYjOoXj>Son?Sh00gon?Sh00?oV9RHokJf]_ohn?P08?ohn?P00ooShn?on?ShooShn00@ooSh
n003ooOgmoohn?SomoOg00?on?Sh00?ofMWIonk^k_o^k^h0ooo^k^j5onk^kP006OoVi^H00onMWIgo
i^KVonKViP0FonKViP05om_Kfoofm_Kom?Cdono_koo[jn/00oo/k>`01ooZj^[ohN7Qok2`/?o<c<co
d];BomOGeooIfMT00_oLg=`02?oMgMgof][JomOGeooCdm?oc<c<ok2`/?oQhN7oj^[Z1Oo/k>`01ooZ
j^[ohN7Qok2`/?o<c<cod];BomOGeooIfMT00_oLg=`02?oMgMgof][JomOGeooCdm?oc<c<ok2`/?oQ
hN7oj^[Z1Oo/k>`01ooZj^[ohN7Qok2`/?o<c<cod];BomOGeooIfMT00_oLg=`02?oMgMgof][JomOG
eooCdm?oc<c<ok2`/?oQhN7oj^[Z1oo/k>`05_ooooooMgMgofHcI_mV<fKoMgMgohR8R?mVIVKo<c<0
o`0cc?l0I/co<`1Vo`000?mV<fKo<c<cogMgMoo<c<cok>c/ol[:b_o0`<3o`L71olS8b?oMgMd9onc/
k003oiZJV_ne]KGok>c/01gok>c/00?ob/[:omCDe?o/k>`08?o/k>`00ooJf][ok>c/onc/k00Conc/
k004ono_kooclo?omoOgom_Kfoooi^KVQooVi^H001Wok^k^00?oWinOonk^k_o^k^h05_o^k^h01?oN
g]konOWiooCdm?o^k^h4onWYj@06onSXj?oShn?o/[:bokno_oo<c<cod];B0_oGemL02OoHf=SoemOG
omKFe_oBd];obl_;okjn__na/K7ohn?SonSXj005onWYj@06onSXj?oShn?o/K6aokjn__o<c<cod];B
0_oGemL02OoHf=SoemOGomKFe_oBd];obl_;okjn__na/K7ohn?SonSXj005onWYj@06onSXj?oShn?o
/K6aokjn__o<c<cod];B0_oGemL02OoHf=SoemOGomKFe_oBd];obl_;okjn__na/K7ohn?SonSXj007
onWYj@09oooooom4A4Co<`0col`0c?mV<fKoIVIVoa400?nIIP3oc9T000;o06K<0_nI09T00onk^k_o
MgMgolc<c00?onWYj@03onOWiooXj>SojNWY043ojNWY00?oeMGEonWYjOoYjNT03?oYjNT00ooXj>So
jNWYonWYj@04onWYj@04onk^k_odm?ConOWiomkNg_ook^k^Qoo^k^h001Wooooo00?oXZ:Roooooooo
ool05_ooool01_oPh>3oo_knoo_knoofm_Kolo?cooCdm0?olo?c00Kol_;bom7AdOnb/[;oc/k>omcL
g?oVi^H3onSXj006onKVi_oLg=coc/k>ok:b/_oAdM7olO7a1ooclo<01_oalO7odM7Aok:b/_o>c/ko
g=cLonKViP?oj>SX00Koi^KVomcLg?o>c/ko/[:bom7AdOoalO47oo?cl`06oo7alOoAdM7o/[:bolk>
c_oLg=coi^KV0ooXj>P01_oVi^Kog=cLolk>c_nb/[;odM7Aoo7al@Solo?c00Cooooooc<c<oo<c<co
A4A40_l000002_lc03?oIVH0ooo<0?nIIP3oIP1Vol`0oomV06KoIS=VogMgMonk^k]Boo?cl`03om_K
fooclo?olo?c017olo?c00Kom?Cdoo?cloofm_Kono_kookno_oPh>3oooooohOooooo000Ionk^kP03
ojBTY?o^k^kok^k^01Kok^k^00Gohn?SooWinOojn_[on_[jooWin@02oo[jnP?onOWi04ComoOgolW9
bOnm_KgogMgMonk^k_oemOGom_KfooGemOo^k^kogMgMokfm_Oo8b<SomoOgooShn?ojn_[onOWioo[j
n_oinOWon_[iooWinOojn_[on?ShooOgmoo8b<So_KfmomgMgOo^k^komOGeooKfm_oemOGok^k^omgM
gOnm_Kgob<S8ooOgm_ohn?Son_[jooWinOojn_[onOWioo[jn_oinOWon_[iooShn?ogmoOob<S8okfm
_OoMgMgok^k^ooGemOofm_KomOGeonk^k_oMgMgo_KfmolS8b?ogmoOon?Shoo[jnOoinOWon_[jooWi
nOojn_[onOWioo[jn_oinOWoooooogMgM`;ok^k^00?o8R8RoiT0VOmV<fH00_mV06H0JOlc03?oVFH0
oa4A4Oo<c<cok^k^ogMgMoo<c<con_[iooWinOojn_[onOWioo[jn_oinOWon_[jooWinOojn_WonOWi
oo[jn_oinOWon_[jooWinOojn_[onOWioo[jnOoinOWon_[jooWinOojn_[onOWioo[jn_oinOWon_[i
ooWinOojn_[onOWioo[jn_oinOWon_[jooWinOojn_WonOWioo[jn_oinOWon_[jooWinOojn_[onOWi
oo[jnOoinOWon_[jooWinOojn_[onOWioo[jn_oinOWon_[iooWinOojn_[onOWioo[jn_oinOWon_[j
ooWinOojn_WonOWioo[jn_oinOWon_[jooWinOojn_[onOWioo[jnOoinOWon_[jooWinOojn_[onOWi
oo[jn_oinOWon_[iooWinOojn_[onOWioo[jn_oinOWon_[jooWinOojn_WonOWionSXj?oinOWon_[j
ooWinOojn_[onOWioo[jnOoinOWon_[jooWinOojn_[onOWioo[jn_oinOWon_[jooWin@02oo[jnP03
ooWinOojn_[on_[j00?on_[j00?onOWion?Shoo^k^h0ooo^k^j6onk^kP006OoVi^H00onWYjOoi^KV
onKViP0GonKViP04oo7alOogmoOom?Cdono_k`GokNg]00gok>c/on?Shono_koo]KFeom3@d?oNg]ko
i>CTomkNg_o@d=3o]KFeokno_ooShn?ok>c/00WokNg]00gok>c/on?Shono_koo]KFeom3@d?oNg]ko
i>CTomkNg_o@d=3o]KFeokno_ooShn?ok>c/00WokNg]00gok>c/on?Shono_koo]KFeom3@d?oNg]ko
i>CTomkNg_o@d=3o]KFeokno_ooShn?ok>c/00WokNg]00KoooooodA4A?o^k^koVIVIoa4A4Om4A4@2
ol`0c004oiT0VOl0<fKoc9T0ogMgM`;ok^k^00?oMgMgolc<c?o]kNd0DOo]kNd00ooMgMgokNg]ong]
k@0:ong]k@04onc/k?o]kNgokNg]onc/k0CokNg]00Cokno_ooCdm?ogmoOolO7aoooVi^J8onKViP00
6Oo^k^h00onYZJWok^k^onk^kP0Gonk^kP05onc/k?ohn?Som?Cdonk^k_o[jn/00ooZj^X03?oYjNWo
j^[Zon[Zj_oYjNWocLg=okNg]onUYJGoW9bLojFUYOng]kOocLg=onWYj@goj^[Z00WojNWYolg=cOng
]kOoYJFUoibLW?nUYJGo]kNgolg=cOoYjNT03OoZj^X02OoYjNWocLg=okNg]onUYJGoW9bLojFUYOng
]kOocLg=onWYj@0;on[ZjP09oooooolc<c?ok^k^ogMgMolc<c?oIVIVoc<c<oo<0<coA4A400;o03=V
00GoMgMgonk^k_o^k^koMgMgok^k^`1Bon[ZjP03omWIfOoZj^[oj^[Z017oj^[Z00Gojn_[onk^k_od
m?Con?Shonc/k03oonk^kXSok^k^000Iooooo`03ojb/[?oooooooooo01Sooooo00?ol?3`oo_knoof
m_H02_odm?@3oo?cla?om?Cd0ooclo<CooCdm0?olo?c3_odm?@00oooooooMgMgonk^kP03onk^kP06
ok^k^omV<fKoooooonk^k_nIVIWoR8R80_o^k^h00omgMgOoc<c<ooCdm01AooCdm003omoOgoodm?Co
m?Cd00gom?Cd00?olo?cooCdm?odm?@00_odm?@00oogmoOono_koo3`l03oooooohWooooo000Ionk^
kP03ojj^[_o^k^kok^k^01Sok^k^00?ol?3`oo7alOojn_X0Aoojn_X00ooooooo<c<cooooo`0;onk^
kP03ogMgMoo<c<con_[j057on_[j00?oj^[Zoo[jn_ojn_X04oojn_X00ooalO7ol?3`onk^kP3oonk^
kXSok^k^000IonKViP03ok6a/OoVi^Koi^KV01Woi^KV00Coj>SXonc/k?oalO7omoOgAOohn?P00ooo
oooo<c<cogMgM`0<ogMgM`03ooooooohn?Son?Sh053on?Sh00?ojn_[ooShn?ohn?P04?ohn?P01?og
moOolO7aonc/k?oXj>SoonKViX[oi^KV000Ionk^kP03ok>c/oo^k^kok^k^01cok^k^_?oShn?oonk^
kXgok^k^000Iooooo`03okJf]_oooooooooo0<Cooooo00?o][Jfooooooooool0oooooonNooooo`00
6Oo^k^h00onh^;Sok^k^onk^kP34onk^kP03okRh^?o^k^kok^k^0?ook^k^W_o^k^h001Woi^KV00?o
^k^kogmoOomoOgl0a?moOgl00onk^k_oi^KVonKViP3oonKViYkoi^KV000Ionk^kP05okfm_Oo[jn_o
inOWonCTi?oQhN401?oPh>03on7Qh@05on3Ph?oQhN7oh>3Pon3Ph?oOgml00_oPh>005?oQhN7oh>3Q
on7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>3ohN7Q
on3PhOoPh>3ogmoO0_oPh>004OoQhN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>3o
hN7Qon3PhOoQhN7oh>3Pon7QhOoPh>3ohN7Q00;oh>3P07oogmoPon3Ph?oPh>3ohN7Qon3Ph?oQhN7o
h>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>3ohN7Qon3PhOoQhN7oh>3Pon7QhOoPh>3o
hN7Qon3Ph?oQhN7oh>3Qon7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7o
h>3Pon7QhOoPh>3ohN7Qon3PhOoQhN7oh>3Pon7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3Qon7QhOoPh>3o
hN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>3ohN7Qon3PhOoQhN7o
h>3Pon7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3Qon7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>7o
hN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>3ohN7Qon3PhOoQhN7oh>3Pon7QhOoPh>3ohN7Qon3Ph?oQhN7o
h>3QomGEeOn^[Zkog]kNon3Ph?oQhN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>3o
hN7Qon3PhOoQhN7oh>3Pon7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3Qon7QhOoPh>3ohN7Qon3Ph?oQhN7o
h>3P00?ohN7Q00?oh>3Pon7QhOoQhN400ooPh>001?oShn?oj>SXon[Zj_nm_Kgoonk^kZ3ok^k^000I
ooooo`04ol30`?o`l?3ok>c/onOWi`Soh^;R0_oPh>001ooNg]kogMgMomgMgOoMgMgog]kNon3Ph?oQ
hN403OoRh^800ooQhN7oh>3PomkNgP03omgMg@03omkNg_oPh>3ohN7Q00goh^;R00?ohN7Qon3Ph?oN
g]h00ooMgMd00ooNg]koh>3Pon7Qh@1Lon;RhP03on3Ph?n:RX[o_kno01_oh^;R00?ohN7Qon;Rh_oR
h^801_oRh^801?oVi^Kok>c/oo3`l?o0`<3ooooooj3ooooo000Ionk^kP08ol;2`_o]kNgojNWYonGU
iOoRh^;ohn?Son;Rh_oTi>@2on?Sh`0=on7QhOoRh^;ogMgMomWIfOoEeMGod];Bom7AdOoBd];oeMGE
omWIfOoMgMgohN7Qon;RhP09on?Sh`0=on;Rh_oQhN7ogMgMomWIfOoEeMGod];Bom7AdOoBd];oeMGE
omWIfOoMgMgohN7Qon;RhP09on?Sh`0=on;Rh_oQhN7ogMgMomWIfOoEeMGod];Bom7AdOoBd];oeMGE
omWIfOoMgMgohN7Qon;RhP0Von?Sh`03omkNg_oIfMWohn?S00Sohn?S00?ofm_Kon;Rh_oShn<00_oN
g]h2on?Sh`03on7QhOoLg=cohn?S00[ohn?S00?of=SHon;Rh_oShn<03?oShn<00ooKfm_oh^;Ron?S
h`02omkNgP;ohn?S00?o]KFeoiNGUooShn<01OoShn<00ooNg]kofMWIon?Sh`0Don?Sh`03onCTi?oS
hn?oi>CT00Cohn?S00CoiNGUonWYjOo/k>co`/;2ooo^k^jPonk^kP006OoVi^H01?o5aLGok>c/onc/
k?o]kNd5onc/k01Eon_[jooYjNWoi>CTomcLg?oBd];obLW9ol?3`oo2`/;o`l?3olW9bOoBd];ogMgL
onCTi?oZj^[ojn_[ong]kOo/k>cokNg]onc/k?o]kNcok>c/ong]kOo[jn_oj^[ZonCTi?oMgMgod];B
olW9b?o3`l?o`/;2ol?3`oo9bLWod];BomgMgOoTi>Coj^[Yon_[joo]kNgok>c/ong]kOo/k>cokNg]
onc/k?o]kNcojn_[on[Zj_oTi>CogMgMom;Bd_o9bLWo`l?3ol;2`Oo3`l?obLW9om;Bd_oMgMgoi>CT
on[Zj_o[jn_okNg/onc/k?o]kNgok>c/ong]kOo/k>cokNg]onc/k?o]kNcok>c/ong]kOo/k>cokNg]
onc/k?o]kNgok>c/ong]k?o/k>cokNg]onc/k?o]kNgok>c/ong]kOo/k>cokNg/oiJFUP02ogmoO`0`
oh:2P_nCTi?o/;2`onKVi_o]kNcok>c/ong]kOoQhN7oWYjNoh20P?n>SXkoR8R8om;BdOo/k>co];Bd
oi^KVoo]kNgok>c/ong]kOnQXJ7oPX:2ohZ:R_o2`/;oQhN7ojBTY?o/k>codM7AohZ:R_n2PX7oXZ:R
okRh^?nCTi?okNg]onc/k?nJVY[o]KFeong]k?o/k>cof][Johj>S_n;Rh_oc/k>ong]kOo/k>cokNg/
onc/k?o]kNgoUYJF1?moOgl09onHV9Ook>c/oj6QXOn2PX;oRXZ:ol71`On7QhOoY:BTong]k?o/k>co
_KfmogmoOooKfm_ok>c/ong]kOo/k>coh^;QoijNW_n0P83oSHf=ong]kOo/k>cokNg]onc/k?o]kNco
k>c/ong]kOo/k>cokNg]onc/k?o]kNgok>c/ong]k?o/k>cokNg]onc/k?o]kNgok>c/ong]k@0<onc/
k003olG5aOoVi^Koi^KV0?ooi^KVW_oVi^H001Wok^k^00CoalO7oo3`l?o]kNgoj>SX1OoVi^H0OooT
i>Cog]kNom?Cdoo5aLGo^;Rhok6a/On/[:coZj^[ojb/[?na/K7o^;RholG5a?oCdm?og]kNon?ShooV
i^KoiNGUonKVi_oUiNGoi^KUonGUiOoVi^Kohn?SomkNg_oCdm?oaLG5okRh^?na/K3o[:b/oj^[Zon/
[:co/K6aokRh^?o5aLGodm?ComkNgOoShn?oi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KUon?ShooN
g]kodm?ColG5aOnh^;So/K6aojb/[?n[Zj[o[:b/ok6a/Onh^;SoaLG5om?CdooNg]kohn?SonKViOoU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KUonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^GoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKViOnDU9Co[Jf]onGUiOoQhN7od=3@oiZJV_n<
S8cogmoOonGUiOoVi^KoVYZJoiRHV?oHf=Soi^KVon3Ph?oPh=ooiNGUok6a/OnIVIWoi^KVonGUiOo>
c/koP820omSHeooKfm_oXj>SohF5QOoVi^KoiNGUoj2PX?nRXZ;oh^;Qokjn__n5QHGoTY:BonKVi_oU
iNGoV9RHok6a/OoVi^GoiNGUojb/[?nIVIT00_oUiND0<_oVi^KoiNGUonKViOoUiNGoi^KVoiBDU?n]
[JgoiNGUonKVi_oUiNGoi^KUolk>c_n0P83oemOGom_KfonSXj?oQHF5onGUiOoVi^GoiNGUoi6ATOn2
PX;o[:b/onGUiOoVi^KoiNGUoiZJV_nHV9SofMWIonGUiOoVi^KoiNGUonKVi_oUiNGoi^KUonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^GoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU1?oVi^H0
2?oUiNGoi^KVonKVi_oVi^Koj>SXonc/k?o`l?3oalO7ooo^k^jPonk^kP006Oooool01?o:b/[om_Kf
oo7alOo]kNd2onOWi`0ConSXj?oWinOoi^KVon7QhOoGemOoalO7okJf]_nj^[[ocLg=omoOgooXj>So
gmoOolg=cOnk^k_o][JfolK6a_oGemOohN7QonKViP05onOWi`0AonKVi_oQhN7oemOGolK6a_nf][Ko
^[Zjolg=cOoOgmooj>SXomoOgoo=cLgo^k^kokJf]_o6a/KoemOGon7QhOoVi^H01OoWinL04OoVi^Ko
hN7QomOGeoo6a/Ko][JfokZj^_o=cLgogmoOonSXj?oOgmoocLg=ok^k^onf][Koa/K6omOGeooQhN7o
i^KV00OoinOW00?oooooohR8R?m4A4@01_m4A4@00olc<c?oA4A4odA4A003odA4A004oiVIVOoWinOo
UIFEojj^[P?oinOW00Ooi>CToh^;Ron][JgoinOWomWIfOmoOgoob/[:00GoinOW00[o/K6aoiVIVOoW
inOoinOWomOGeon0P83oc<c<onOWiono_kooS8b<0_oWinL01_n@T93o^KVionOWiooWinOo/;2`oi:B
TP;oinOW00KoVIVIok:b/_oWinOoinOWoijNW_n][Jd7onOWi`03oiFEUOn^[ZkoinOW00?oinOW00Ko
emOGoh20P?o<c<coinOWokno_on<S8`2onOWi`09om;Bd_moOgoo_knoohJ6Q_oTi>CoinOWomWIfOmo
Ogoob/[:01goinOW00Goj>SXong]kOo`l?3om_Kfol[:bP3ooooooj3ooooo000Ionk^kP04olc<c?oc
lo?ol?3`on_[j`Coj>SX00Ooi^KVomgMgOo>c/ko^[ZjolC4a?oWinOok^k^00?okno_00Ook^k^onWY
jOo5aLGo^k^kolk>c_oMgMgoi^KV00Goj>SX00Ooi^KVomgMgOo>c/ko^[ZjolC4a?oWinOok^k^00?o
kno_00Ook^k^onWYjOo5aLGo^k^kolk>c_oMgMgoi^KV00Goj>SX00Ooi^KVomgMgOo>c/ko^[ZjolC4
a?oWinOok^k^00?okno_00Ook^k^onWYjOo5aLGo^k^kolk>c_oMgMgoi^KV00Ooj>SX00?oooooodA4
A?mVIVH00omgMgL00omVIVKoMgMgogMgM`05ogMgM`05oc<c<oo<c<coj>SXoiFEUOn^[Zh01?oXj>P0
1Onb/[;oSHf=onSXj?o=cLgoOgmo00CoV9RH00Coclo?onSXj?nb/[;oVYZJ0ooXj>P01Oo6a/KoTi>C
oiBDU?nEUIGoS8b<00;oj>SX00KoTI6Aok^k^ooXj>Soj>SXokVi^OnBTY82onSXj006oiVIVOnc/k?o
j>SXonSXj?nNWYko[Jf]1ooXj>P00onEUIGo[Zj^onSXj004onSXj005olK6a_nCTi?oU9BDoiFEUOn<
S8`00_oXj>P02?nZZZ[oVIVIonSXj?n?Shoo`/;2onSXj?o=cLgoOgmo0onHV9PLonSXj004on_[joo`
l?3olo?colc<c?ook^k^X?o^k^h001Woi^KV00?oclo?oo;bl_obl_801Oobl_801_o^k^kohn?Solg=
cOo7alOoinOWoo7al@;omOGe00Wom_KfooGemOoemOGolo?conWYjOo7alOocLg=on?Shoo^k^h01Oob
l_801_o^k^kohn?Solg=cOo7alOoinOWoo7al@;omOGe00Wom_KfooGemOoemOGolo?conWYjOo7alOo
cLg=on?Shoo^k^h01Oobl_801_o^k^kohn?Solg=cOo7alOoinOWoo7al@;omOGe00Wom_KfooGemOoe
mOGolo?conWYjOo7alOocLg=on?Shoo^k^h01oobl_803?oooooo<c<conk^k_o^k^ko^k^kogMgMonZ
ZZ[oooooonk^k_oMgMgoMgMgomgMg@;ok^k^00GoMgMgolc<c?obl_;oUiNGok>c/`04oo;blP0=olK6
a_n0P83okno_on7QhOmoOgooc<c<omcLg?oHf=SoP820onKVi_obl_;o][JfoibLW005oo;blP03oo7a
lOo1`L7oSHf=00;ol_;b00KoTY:Bol71`Oobl_;ol_;bokno_onDU9@2oo;blP06oi^KVonh^;Sol_;b
oo;bl_nQXJ7o/[:b1oobl_800onGUiOo/k>coo;blP06oo;blP0@oo7alOo1`L7oSHf=oo;bl_o]kNgo
QHF5olS8b?obl_;o_knooiZJV_obl_;ohN7QogmoOoo<c<cog=cLomSHf1_ol_;b00Golo?coo;bl_ob
l_;ol_;bolo?c`3oonKViZ3oi^KV000Ionk^kP04om7AdOofm_Kol_;bong]k@?ojn_[00[oj^[ZonKV
i_oIfMWo`<30omKFe_oTi>Cojn_[oo3`l?oalO7ol_;b0_oalO401oo/k>coi^KVomOGeoo0`<3ofMWI
onKVi_oZj^X00oo[jn/02_oZj^[oi^KVomWIfOo0`<3oe]KFonCTi?o[jn_ol?3`oo7alOobl_82oo7a
l@07onc/k?oVi^KoemOGol30`?oIfMWoi^KVon[ZjP03on_[j`0:on[Zj_oVi^KofMWIol30`?oFe]Ko
i>CTon_[joo`l?3olO7aoo;blP;olO7a00Ook>c/onKVi_oGemOo`<30omWIfOoVi^Koj^[Z00Kojn_[
00Kooooooc<c<oooooook^k^ogMgMol0<l`2oc<c000;odA4A?lc03?o000RofH0I_mgMgOoooooogMg
Monk^k_ojn_[oiFEUOn`/;001?o[jn/05Onk^k_oPH61onWYjOo[jn_oVIVIojb/[?oWinOo`L71oi6A
TOo[jn_oj>SXok2`/?nIVIWoi^KVonSXj?o[jn_obl_;om_KfooYjNWoZ:RXoj:RXP02on_[j`06oi6A
TOnm_Kgojn_[on_[jonk^k_oTi>C0_o[jn/02?nJVY[o];Bdon_[jooXj>SoWIfMojf][OoVi^KojNWY
1Oo[jn/00onEUIGo/;2`on_[j`04on_[j`0Bol_;booKfm_ojNWYojRXZ?nRXZ;ojn_[olC4a?n4Q8Co
i^KVon_[jooShn?oPX:2om[Jf_o[jn_oVIVIojb/[?oWinOo`L717?o[jn/01?o]kNgolo?cooGemOoA
dM7oonk^kZ3ok^k^000Iooooo`04omCDe?olo?com_Kfoo7al@;ojn_[00[ok>c/on_[jooWinOofMWI
okno_ooIfMWoh^;RonSXj?oZj^[ok^k^0_o_knl01oo[jn_oj>SXonCTi?oJf][o_[jnomWIfOoVi^H0
0_o[jn/02oo/k>cojn_/on_[jooVi^KofMWIokjn__oIfMWoh^;RonSXj?oZj^[ok^k^00;okno_00Oo
jn_[onSXj?oTi>Cof][Jokjn_ooIfMWoi^KV00;ojn_[00_ok>c/on_[joo[jn_oi^KWomWIfOnn_[ko
fMWIon;Rh_oXj>Soj^[Zonk^kP02ono_k`07on_[jooXj>Soi>CTom[Jf_nn_[kofMWIonKVi`02on_[
j`07onc/k?o[jn_ok>c/on_[joo/k>coooooogMgM`02onk^kP1[ofIVI_l0I_oo06K<odA4A?lc03?o
<c<cogMgMolc03?oR8R8onk^k_mVIVKoc<c<on_[k?nFUYKo/;2`onc/k?o[jn_ok>c/on_[jonRXZ;o
TI6Aonc/k?o[jn_ohN7QoifMWOn4Q8CoRXZ:olg=cOo[jnco_;blohB4Q?n1PH7oRXZ:okno_oo[jn_o
^KVioiBDU?n5QHGoUiNGom;Bd_o[jn_ok>c/oi^KVoo2`/;ojn_/onc/k?o0`<3oW9bLon_[joo/k>co
VYZJokFe]Oo[jnco]KFeoh:2P_n4Q8CoRXZ:olW9bOo[jn_ok>c/on_[k?o/k>cojn_[oiJFU_n`/;3o
k>c/on_[joo/k>cojn_/onc/k?ni^KWoU9BDohF5QOnGUiOod];Bonc/k?nUYJGo[jn_on_[joo/k>co
jn_[ojf][Ong]kOok>c/on3PhOnMWIgoQ8B4ohZ:R_o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn/00_o/k>`00oo[jn_o
k>c/onc/k003onc/k005on_[jooalO7om_Kfooclo?oDe=@0oooooonPooooo`006Oo^k^h01?oFe]Ko
moOgooCdm?o_knl3ong]k@08on_[jooXj>Sofm_Kokjn__oJf][og]kNonCTi?oWinL3on[ZjP08onSX
j?oTi>Coh>3Pom[Jf_nn_[kofm_KonSXj?o/k>`3ong]k@08onc/k?oXj>Sofm_Kokjn__oIfMWogmoO
onCTi?oWinL3on[ZjP08onSXj?oTi>Coh>3Pom[Jf_nn_[kofm_KonSXj?o/k>`3ong]k@08onc/k?oX
j>Sofm_Kokjn__oIfMWogmoOonCTi?oWinL3on[ZjP08onSXj?oTi>Coh>3Pom[Jf_nn_[kofm_KonSX
j?o/k>`6ong]k@05oooooolc<c?ok^k^omgMgOlA4A400_l0I_l03?lcI/co8R8RohR8R?nIVIWo8R8R
omgMgOo^k^koMgMgolc<c?o]kNgoUYJFok6a/@?okNg]00?o`l?3ogmoOoo4a<@01?o]kNd00oo[jn_o
kNg]ong]k@02ong]k@03okFe]OnKVi_okNg]00CokNg]00?ok>c/ong]kOo]kNd02_o]kNd01_nJVY[o
]KFeong]kOo]kNgoX:2Pok2`/0OokNg]00?oUYJFok6a/Oo]kNd01_o]kNd00oo/k>cokNg]ong]k@0;
ong]k@03on_[joo]kNgokNg]01[okNg]00Gok>c/oo3`l?odm?ComoOgomKFeP3oonk^kZ3ok^k^000I
onKViP05omWIfOofm_Kom_KfooKfm_oemOD00oofm_H01oobl_;oi^KVokbl_?oJf][oh>3Pon?ShooW
inL00ooZj^X01ooXj>Soi>CTon7QhOoKfm_o_KfmonOWioobl_801Oofm_H01oobl_;oinOWokbl_?oJ
f][oh>3Pon?ShooWinL00ooZj^X01ooXj>Soi>CTon7QhOoKfm_o_KfmonOWioobl_801Oofm_H01oob
l_;oinOWokbl_?oJf][oh>3Pon?ShooWinL00ooZj^X01ooXj>Soi>CTon7QhOoKfm_o_KfmonOWioob
l_801oofm_H01_oooooo<c<conk^k_lc<c?o<`0co`004@;o8R8R017o03<coc<0<olA003o0000oc<c
<onk^k_oMgMgok^k^oofm_KoV9RHoiBDU?n][JgoXj>SoiBDU?n2PX;o`L71ooGem@09ooKfmP03omGE
eOn=SHgom_Kf017om_Kf00KoW9bLokZj^_ofm_Kom_KfonOWiooVi^H7ooKfmP03oiRHV?ne]KGom_Kf
02oom_Kf00?omOGeooKfm_oemOD00oofm_H00ooIfMWoi^KVonKViP3oonKViYkoi^KV000Ionk^kP05
om_Kfoohn?Som_Kfoo7alOo]kNd00oo^k^h01oo/k>cohn?Sok6a/Oo>c/koe=CDomWIfOoKfm/00_oN
g]h02?oOgmoog=cLomWIfOoEeMGoc/k>ok6a/OoShn?ok>c/1Oo^k^h01oo/k>cohn?Sok6a/Oo>c/ko
e=CDomWIfOoKfm/00_oNg]h02?oOgmoog=cLomWIfOoEeMGoc/k>ok6a/OoShn?ok>c/1Oo^k^h01oo/
k>cohn?Sok6a/Oo>c/koe=CDomWIfOoKfm/00_oNg]h02?oOgmoog=cLomWIfOoEeMGoc/k>ok6a/OoS
hn?ok>c/1oo^k^h04_ooooooMgMgofHcI_mV<fKoMgMgohR8R?mVIVKo<c<0o`0cc?l0I/co<`1Vo`00
0?mV<fKo<c<cogMgMoo<c<cok^k^ol_;b`;o`/;200?oaLG5omCDe?oUiND02oo^k^h01Oo[jn_oWIfM
ohj>S_n;Rh_og=cL00ook^k^00?oVYZJokJf]_o^k^h02_o^k^h00oo;bl_oe]KFonk^kP0bonk^kP04
oo7alOoemOGonOWiom_Kfoook^k^X?o^k^h001Wooooo00Cog]kNookno_oinOWolo?c1?o^k^h01_o]
kNgoj>SXokFe]Oo2`/;od=3@omKFeP;ofm_K00Wog=cLom_KfooJf][oe]KFolo?coo2`/;o]KFeonSX
j?o]kNd01Oo^k^h01_o]kNgoj>SXokFe]Oo2`/;od=3@omKFeP;ofm_K00Wog=cLom_KfooJf][oe]KF
olo?coo2`/;o]KFeonSXj?o]kNd01Oo^k^h01_o]kNgoj>SXokFe]Oo2`/;od=3@omKFeP;ofm_K00Wo
g=cLom_KfooJf][oe]KFolo?coo2`/;o]KFeonSXj?o]kNd01oo^k^h02OooooooA4A4oc<0<oo<0<co
IS=VofIVI_lA003oVFH0olbI0002o`1Vc0;oV@2I00?o^k^kogMgMoo<c<`05?o^k^h00ooTi>Coi^KV
onk^kP0?onk^kP03onc/k?o]kNgok^k^03Sok^k^00?okNg]onk^k_o^k^h01?o^k^h01?oclo?onOWi
ookno_oNg]kooooooj3ooooo000Ionk^kP06on3Ph?oinOWom_Kfoo7alOo^k^kokno_0oo^k^h01_o]
kNgocLg=ojn_[oo;bl_ofMWIon?Sh`?oiNGU00Kohn?SomWIfOo;bl_o[jn_olg=cOo/k>`7onk^kP06
onc/k?o=cLgo[jn_ol_;booIfMWohn?S0ooUiND01_oShn?ofMWIol_;bon_[joocLg=onc/k0Ook^k^
00Kok>c/olg=cOn_[joobl_;omWIfOoShn<3onGUi@06on?ShooIfMWobl_;ojn_[oo=cLgok>c/2?o^
k^h01?oooooo<c<colc<c?m4A4@2o`00000:oc<0<omVIP3ool`0oiUV0?mV06Koc03oofH0I_mV<fKo
MgMgok^k^fKok^k^00Kokno_onk^k_oalO7om_KfooWinOoPh>3oonk^kZ3ok^k^000IonKViP05on?S
hoogmoOon?ShooShn?ogmoL00_ohn?P3ooOgm`14ooGemOo7alOo^k^kom_Kfoo]kNgolo?cooGemOoc
lo?okNg]om_Kfonl_;_oa/K6ooGemOofm_Kon?ShooOgmoohn?SomoOgooShmoogmoOon?ShooKfm_oe
mOGoa/K6okbl_?oKfm_okNg/oo?clooemOGolo?cong]kOoKfm_o_;blolK6a_oemOCom_KfooShn?og
moOon?ShooOgmoohn?SomoOgooShmoofm_KomOGeolK6a_nl_;cofm_Kong]kOoclo?omOGdoo?cloo]
kNgofm_Kokbl_?o6a/KomOGeooKfm_ohn?OomoOgooShn?ogmoOon?ShooOgmoohn?SomoOgoooooomg
MgL2onk^kP03ob8R8_nI09WoIS=V00;oIP1V06Wo<`0coiUV0?lA4A7oc<c<onk^k_mgMgOoc<c<ooSh
moogmoOon?ShooOgmoohn?SomoOgooShn?ogmoOon?SgooOgmoohn?SomoOgooShn?ogmoOon?ShooOg
moohn?OomoOgooShn?ogmoOon?ShooOgmoohn?SomoOgooShmoogmoOon?ShooOgmoohn?SomoOgooSh
n?ogmoOon?SgooOgmoohn?SomoOgooShn?ogmoOon?ShooOgmoohn?OomoOgooShn?ogmoOon?ShooOg
moohn?SomoOgooShmoogmoOon?ShooOgmoohn?SomoOgooShn?ogmoOon?SgooOgmoohn?SomoOgooSh
n?ogmoOon?ShooOgmoohn?OomoOgooShn?ogmoOon?ShooOgmoohn?SomoOgooShmoogmoOon?ShooOg
moohn?SomoOgooShn?ogmoOon?SgooOgmoohn?SomoOgooShn?ogmoOon?ShooOgmoohn?OomoOgooSh
n?ogmoOon?ShooOgmoohn?SomoOgooShn?ogmoL00_ohn?P00oogmoOon?ShooShn003ooShn003ooOg
mooShn?oi^KV0?ooi^KVWooVi^H001[ok^k^00ColO7aooWinOofm_KolO7a1Oo_knl03Oo^k^koiNGU
ol71`Onf][KodM7AomoOgooUiNGogmoOom7AdOnf][Ko`L71onGUiOo^k^h02Oo_knl03Oo^k^koiNGU
ol71`Onf][KodM7AomoOgooUiNGogmoOom7AdOnf][Ko`L71onGUiOo^k^h02Oo_knl03Oo^k^koiNGU
ol71`Onf][KodM7AomoOgooUiNGogmoOom7AdOnf][Ko`L71onGUiOo^k^h02Oo_knl01_ooooooA4A4
onk^k_nIVIWo4A4AodA4A0;oc03<00CoV@2Io`0cI_o<V@3oMgMg0_o^k^h00omgMgOoc<c<ono_k`1N
ono_k`04onk^k_o_knookno_onk^kPCokno_00ColO7aooKfm_oinOWolO7aooo^k^jQonk^kP006_oo
ool01Oo/k>cooOgmooWinOoclo?ol?3`00?okno_00cok^k^ono_koo_knook^k^om7AdOnk^k_oZ:RX
oinOWonXZ:So^k^kom7AdOo^k^h=ono_k`09onk^k_oAdM7o^k^kojRXZ?nOWiooZ:RXok^k^ooAdM7o
k^k^00gokno_00Wok^k^om7AdOnk^k_oZ:RXoinOWonXZ:So^k^kom7AdOo^k^h02oo_knl02Ooooooo
<c<conk^k_mgMgOo<c<cofIVI_lc<c?oc03<odA4A002o`0cIP05ogMgMoo^k^kok^k^ogMgMonk^k/0
I_o_knl01Oo`l?3olo?cooWinOomoOgok>c/0?ooooooXOooool001[ok^k^00Cokno_oo3`l?ofm_Ko
lO7a2_o_knl3onk^kQ?okno_0oo^k^hCono_k`?ok^k^3_o_knl00oooooooMgMgonk^kP03onk^kP06
ok^k^omV<fKoooooonk^k_nIVIWoR8R80_o^k^h00omgMgOoc<c<ono_k`1Qono_k`03onk^k_o_knoo
kno_00;okno_00Col_;booKfm_o`l?3okno_ooo^k^jQonk^kP006ooVi^H00ooZj^[olO7aooShn017
ooShn003oooooolc<c?ooooo00_ok^k^00?oMgMgolc<c?ohn?P0Ioohn?P00ooalO7oj^[ZonKViP3o
onKViZ7oi^KV000Lonk^kP04ono_koo/k>colO7aooWinDGon_[j00?ooooooc<c<omgMgL03?mgMgL0
0ooooooon_[joo[jnP1Soo[jnP04ooWinOoalO7ok>c/ono_koook^k^Xoo^k^h001oooooo_?oShn?o
ooooojKooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_oo
k^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00
oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooooooo
P_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^
k^h00?ooi^KVoooVi^J2onKViP00oomoOgmGogmoO`OoOWinoomoOglTogmoO`0000Cojn_[onKVi_oR
h^;og]kN1?oMgMd3omkNgP3oomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgM000FomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oLg=cogMgMom_Kf`;og=cL03?ogMgM
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]h00_oLg=`01OoIfMWof=SHomOGeooHf=SofMWJ00;og=cL0?oog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]h001Oo
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMgP03omkNgP03omgMgOoNg]kog]kN00?ogMgM0OoQ
hN41onOWi`7oj^[Z00000oo/k>coi^KVon3Ph007omWIf@04omSHf?oFe]Kodm?Colo?c`?ocLg=00Co
d=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSH
f0;ofMWI00?of=SHomWIfOoIfMT01_oIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@06om3@d?oCdm?o
emOGomSHf?oIfMWof=SHfOoIfMT2omSHf006omKFe_oCdm?odm?ComCDe?oGemOof=SH0_oIfMT00ooH
f=SofMWIomWIf@02omSHf0WofMWI00?of=SHomWIfOoIfMT00_oHf=P00ooIfMWof=SHomSHf002omSH
f1OofMWI00Cof=SHomKFe_oBd];oclo?0_o=cLd01?o?cloodm?ComOGeooHf=Q_omWIf@03omSHf?oI
fMWofMWI0:?ofMWI00?of=SHomWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWo
i>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=codm?ColO7aonk^k_o/[:bojj^[_na/K7o
^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o
^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o
^k^kolO7aooCdm?ofm_KomoOg`3Jon7Qh@09on3Ph?oOgmoofm_KomKFe_oDe=Coe]KFom[Jf_oNg]ko
h>3P00KogmoO0ooPh>000ooOgmooh>3Pon3Ph002on3Ph0SogmoO0_oNg]h2omoOg`?oh>3P0_oOgml2
on3Ph0;ogmoO3OoPh>001OoOgmoogMgMomWIfOoEeMGodm?C00;od];B00?oe]KFomcLg?oPh>00oooQ
hN4Hon7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoTi>@1onWYj@7okNg]00000oo`l?3okno_oo7al@03
oo3`l03oono_koo`l?3ok^k^onSXj?oKfm_o`L71oj>SXon<S8coNg]kogIfM_mkNg_oS8b<ojBTY?o2
`/7of][Jon[Zj_o]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2`_nT
Y:CoS8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^Sok>c/oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJ
f][oj^[Zong]kOoalNook^k^oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_000Koo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNook^k^ono_kooZj^[oinOW00;o
h>3P00Oohn?Son_[jOo[jn_oj^[ZonKVi_oXj>SoinOW00;ojNWY01;ok^k/onc/k?o/k>coj>SXonc/
k?o]kNgol?3`onc/k?oZj^Soi^KVonSXj?oWinOojNWYonSXj?o[jn_oinOWonOWiOoUiND2onWYj@0?
onk^k_o]kNgokNg]onSXj?o[jnWok>c/onk^k_oYjNWoj^[Zon_[joo_knook>c/onc/j_oZj^[ok^k^
00;ok>c/0?ooj^[Zono_koo/k>cok>cZon[Zj_o^k^kok>c/ojn_[omfMWKoFEUIofi^K_ng]kKoh>3P
onWYjOo]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_koo`l>kokno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knl002golO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`l?o_knl01?o`l?000003oo;bl_o^k^koinOW00CoiNGU013oi>CTomoOgooAdM7o/;2`ohZ:
R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@00ooUiNGoi>CT
onGUi002onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:
ok6a/OoAdM3og]kN00;oi>CT0>goiNGUonCTi?oUiNGoi>CTonCThooNg]kodM7Aok6a/On:RX[oIVIV
oe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7AomkNg_oShn;oi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiN@00_oTi>@0ooo5aLGo:2PXodA4A?n@T93odM7AomcLfooKfm_oemOGomCDe?oFe]Koe=CD
omGEeOoIfMWoh>3OomkNg_oJf][oe=CDomWIfOoNg]koh^;RomcLg?oGemKoe=CDomKFe_oDe=CoeMGE
omSHf?oKfm_oemOGomKFeOoEeMGoemOGomSHf?oNg]kogmoOomcLg?oEeMGoemOFomcLg?oMgMgoemOG
omKFe_oKfm_ohN7QomkNg_oKfm[of][JomkNg_oLg=cof][Jom_KfooPh>3ogmoOomcLfooIfMWog]kN
omoOgomdM7CoIfMWohf=SOmDE5Co20P8oj:RX_oLg=coh^;RonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi000F?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>@4onGUi@06onCTi?oUiNGoiNGUonGUiOoXj>SokNg]0Oobl_800003ooCdm?o]kNgo
inOW00;oh>3P01?ohN7QomoOgooNg]kod];BokBd]?n7QhOoG5aLofdk=OnNCT;ocFmOonV3Koo=KUko
WTi3ofdk=_mLG5coQhN7okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m]H2co
WYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomkNg_oBd];o
];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=AomZWSCoBFX_oeaLG?n7QhOo];Bdom;Bd_oNg]h0
fOoPh>001_oOgmooclo?oiVIVOnBTY;o6ATIohb<S0;oeMGE01ooclo?ol;2`_o>c/koc/k>olG5aOo:
b/[of][JomSHf?o@d=3obl_;olo?cooHf=Sof][JomGEeOo?cloo`L71om3@d?o>c/koa<C4ol_;booH
f=SoemOGokjn__nk^k_odM7Aom3@d?oEeMGof=SHom?Cdoo<c<coc/k>00;oeMGE00Goc/k>olc<c?oC
dm?of][JomSHf002om;BdP04omSHf?oGemOodM7Aom?Cd`;ofMWI00Kodm?Com7AdOoGemOof=SHom7A
dOo@d=02om7Ad@04odI6A_m1@D7oemOGomkNgVgoh>3P00?ogmoOon3Ph?oPh>001OoPh>000ooOgmoo
h>3Pon3Ph00bon3Ph003omoOgooPh>3oh>3P06Soh>3P00?ogmoOon3Ph?oOgml00_oOgml3on3Ph003
on7QhOoWinOok>c/007om?Cd00000oofm_Kol_;bon_[j`03onSXj00ConOWiooRh^;ocLg=oinOWom[
GeooScH^ona`H?oiWI3ooK6Uoofl[oom]:OonInConedHonB=booJemOoinOWoo=cLgoh^;RonOWi`03
onSXj00ConOWiooRh^;ocLg=oinOWom^IUooTg8RongAA?oilgCooOf=oogmUOomoHkonOQfongGAonC
Lb;oKVMOoinOWoo<c<coh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWomPJ5ooBg`Soi;QBonm
nG_od?fBomSmVooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=cLgohN7QonOWi`3JonSXj004onKVi_oQ
hN7oGEeMode=C@;ogMgM01ooD51@o`L71olE5AGoQ8B4oaHF5_m3@d?oh^;RomgMgOnLW9co0000ohn?
SooMgMgohN7Qom_Kfom0@43o20P8oaTI6On8R8So2`/;oeQHF?ng]kOo30`<o`L71olS8b?o9bLWogem
OOoJf][ogMgMomCDe?l;2`_oFEUI00;ofMWI00?oGEeMo`/;2ooCdm<00_oOgml01_mJFU[oCTi>omkN
g_oNg]ko8b<SohB4Q0;ohN7Q00coNWYjobh^;_oMgMgogMgMol;2`_m@D53o<c<cofi^K_n3Ph?o8B4Q
omkNg_oVi^KoonSXj1ooj>SX0Oo/k>`1oo;blP7om_Kf00000oogmoOon?ShooShn003ooShn00CooOg
moo^k^koc/k>oi2@T?n5;R[ojFAFoo^BQoonYY_oo[6UoonhZoon/ZKooZRLoo^DROo^J5WoRC4[oi2@
T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_PK_onm8;oo_j:oooo
T_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^ooKfmP03ooShn00CooOgmoo^k^koc/k>oi2@
T?m2Lb_oQ<i3ojg_Loo2oXSoc_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^ooOg
m`3JooShn00UooKfm_oalO7oPH61oalO7oo]kNgoa/K6o`000?o3`l?odm?CoeaLG?l820Soj^[Zoo3`
l?oZj^[oDU9Boa@D5?lm?CgojNWYoo3`l?n_[joo1`L7om;Bd_o=cLgoCTi>oa/K6oo^k^kofm_Kojj^
[_oXj>Sok>c/ojj^[_l0003o];Bdonc/k?n`/;3o2`/;oaXJ6P02onCTi00;ob<S8ol>3PkoY:BTong]
kOo^k^koH61PoeADE?o^k^kokNg]obHV9_n=SHd00_o`l?003?n2PX;o<C4aonc/k?oZj^[o@d=3obl_
;onLW9coLg=cobXZ:_lJ6Q[ok^k^ooKfmPoon?Sh00?omoOgooShn?ohn?P0Foohn?P00oogmoOon?Sh
ooShn005ooShn003ooOgmoohn?Son?Sh03Oon?Sh00?omoOgooShn?ohn?P0IOohn?P00oogmoOon?Sh
ooShn002ooShn004ooOgmooinOWomoOgooOgm`7on?Sh00000oojn_[omOGeonk^kP02onc/k03oon_[
jooYjNWogmoOokZj^_miDU;o_c8TonMdJOomRGkooiR<oojRU_ooYi_ooZBHoonJSOonRWookWIZol<c
9?miDU;o^[ZjomoOgooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3ooMYSoooZ
L_onlgkoooZ2ookfOoook7?oo]iToo[7DOoRTQcoRFICokVi^OoOgmooj^[Zon_[joo/k>cojn_[on[Z
j_oOgmoo^[Zjoe9]D_mAXacoTM9EojKWJ_nhnG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]
D_ni^KWogmoOon[Zj_o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/0019
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/onWYjOoUiNGoNWYj
oa`L7?oQhN;oc<c<o`<30onPX:3og]kNoiBDU?lC4a?ohN7Qon3PhOo@d=3o1PH6oj6QXOl92@Wo_kno
on7QhOnj^[[o0P82ok:b/_oMgMgoP820obPX:?oShn?oinOWonGUiOoOgmoofm_Kom?Cdol820SoQHF5
omoOgomYJFWoBTY:ocDe=On][Jgo_Kfmo`L71omhN7SoEEEEomoOgooPh>3oFe]Koe1@D002on7Qh@0:
ob@T9?n5QHGogmoOon7QhOmkNg_o;bl_on3Ph?oDe=Co1@D5ojRXZ0;ohn?S07;oOWiooaHF5_oQhN7o
j^[Zon_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>`3on_[j`2Tonc/k?o[jn_ok>c/on[Zjoo/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jn`6on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT0
0003oo_knooclo?okNg]00;oiNGU0?ooi^KVonCTi?oIfMWo/K6aogT^;_o8@S?ohfYLooAjKOomR7co
oYN:oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;of=SHonCTi?oUiNGoi^KVonGUi_oTi>Co
f=SHok:b/_nFEBkojY`[oo^lA?onc5?ooMQRookSL_onjGGoo^IcookKIOomc5?onl55onjN:onIERko
/[:bomSHf?oTi>CoiNGUonKVi_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on7bTSoUmaIojGUJOnblgOo
^?IkokCeNOnWjV_oV=aIohW?BomS[R_o;V<^ok:b/_oHf=Wohn?SonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNH003Coi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^Kohn?SomoOgomgMgOo6a/KomcLg?oQhN7oWYjNobl_;ol[:b_o<S8boa8B4_oL
g=cof][KohB4Q?lP823oh>3Poe9BD_mXJ6Sof][JomkNg_n@T93o:RXZobh^;_l/;2co9bLW0_oNg]h0
4ooIfMWodm?Dom3@d?mKFe_o0000okfm_OoJf][o:2PXohN7QomgMgSoJ6QXoh:2P_ll?3co`/;2o`l?
3ooDe=Cof][JoeUIFOm>CTh00_oLg=`0oolS8b?oPH61omGEeOoGemOoMgMgobh^;_oLg=coXj>So`00
0?o7alOof=SHomWIfOn=SHko5ADEomcLg?oTi>CoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUi@009_oVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
0_oVi^H00ooUiNGoi^KVonKViP03onKViP03onGUiOo]kNgom?Cd007ono_k00000oolo?con?Shoo7a
l@03onk^kP0Con_[jooQhN7o_;blogXG5oo3?c;odeI9onAXF_o^MV_om8=iooR7O?odQ7WolgU]onEY
FooIF4[oa3lbog`G5onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;blojE75ooVUc;omJ``oofl
@OombE?ooM1Poo_CIOomdV3oo/eDoofm@_oj[c;ojI/bojE65onl_;coh>3Ponc/k003onk^kP0Conc/
k?oQhN7o_;bloaMI5omOZ3;oM[dgohK=AonFeU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg_cOoGj/boaMI
5onl_;cohN7Qonc/k03Jonk^kP0^onc/k?oWinOoNg]koa`L7?oTi>CojNWYonKVi_oQhN7og]kNohf=
SOlD51Coi^KVonCTi?le=CGoNGUion_[jonb/[;o5ADEomoOgooVi^Koi>CTon7QhOoMgMgoNWYjobTY
:OoXj>SoiNGUomgMgOna/K7o9RHVo`/;2onKVi_ojNWYolc<c?l0003oc/k>ol?3`olU9BGoBd];ogal
O?oXj>So<C4aojFUYOoTi>CoGEeMoe5AD@;oinOW00[o9BDUofUYJOoOgmoogmoOogMgMola<C7ojNWY
ol71`Ol0003oYjNW0_oOgml01?nCTi?o5QHFonOWioo/k>a]onk^kP03ong]kOo^k^kok^k^00Gok^k^
00?okNg]onk^k_o^k^h0YOo^k^h00oo]kNgol_;booShn001ooclo0000oomoOd05_olo?cooOgmoogm
oOolo?colo?com7AdOmW1`Oo^3@dolHo<_oBD4?ofV9Eon=^H_oTLFCoi6mRomaTEooCDD?oc44dokTd
=?m[1`Ood];Boo?cloolo?`3oogmo@0Cooclo?oclo?od];Boih[1ooJRSCoji/IooFX:Ooh]3oonKe:
ooRoCOoj_d[onKPoooJZ:_o_WQWofh/doj8]1ooBd];olo?cooclo003oogmo@0Cooclo?oclo?od];B
o`M01om=VSCoGj/Pog2h;omo`d?oR/e@ohg=D_n:cU3oPLM4og6i;omR[R3oCY/do`M21ooBd];olo?c
ooclo03Joogmo@0Soo_knoogmoOoQ8B4oahN7_oclo?onOWiok>c/oo@d=3olo?cofQXJ?m7AdOon_[j
omCDe?l0003ogMgMooclo?okno_o9bLWojRXZ?oinOWoZj^[omGEeOoalO7oE5ADoeiNG_oinOWom?Cd
oiBDU?l51@Go@410om7AdOogmoOon?ShoiNGUol[:b/00_ojn_X06olT92Co1`L7olS8b?okno_oQHF5
of=SHoogmoOoHf=SoeMGEoohn?SonOWiobLW9olE5AGoPh>3omOGeom2@T;oHf=Soo_knoojn_[o=3@d
odU9BOoKfm_oiNGUodm?ColG5aOon_[jooclo03ooogmoAcooOgm00?oo?cloogmoOolo?`00oomoOd0
000joogmoOojn_[olo?conk^k_o`l?3okno_onk^k_oYjNWod];Boe/M7OnR=3Co]2PMol4j;Oo7BCco
ceI:om1GBoo@Ed[obTXnol<k;_nf:1goXS@doe`M7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`koo^k^ko
j^[Zom?Cdon<9Agob74domV47OoTU1GoiidTonjX<oo`ZSCokjXconbP9OoWUaGog8PMolQa=?n<9Ago
dm?Con[Zj_o^k^kol?3`ono_koo`l?3ok^k^on[ZjOoCdm?o7CPMocB2=?m7UAgoFZDKofV]:P;oM;Ph
0>;oMKThof^a:omKYacoB9XMocB2=?lM>1godm?Con[ZjOo^k^kol?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`0_o_knl0?OoZj^[oOWinoa`L7?oXj>OokNg]ohR8R?l`<33o3`l?oc4a<Ona/K7ok^k^ohF5
Q?m=CDgokno_onk^k_o_knooRXZ:oeUIFOo^k^koN7Qhob/[:ol?3`oo>3Phokno_oo]kNgoi>CTo`h>
3_mYJFWogmoOon?ShooUiNGojn_[of5QHOmgMgOok^k^ono_k_mfMWKo9RHVong]kOo_knooc<c<ob`/
;?oZj^[oKFe/of9RH_o/k>cokNg]oc/k>onCTi?oHV9Ro`h>3_ld=3Coa<C4ono_koo^k^kodM7Aoc`l
??l:2P[o9bLWofa/K?l/;2`00_o^k^h0KOo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>l00_o_knl0Yoo^k^kol?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_00;o
l?3`1_o_knl1oo?cl`7onOWi0Oono_h00003ookno_ogmoOol?3`00CojNWY017oinOWom_KfomSBd_o
PC8bojHe=Onf=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mSBd_of][JonOWi`05onWY
j@0BonOWiooKfm_oRD];ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;o
RD];om_KfooVi^Koj>SX1?oYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[ZbooL:dhofn^>_m`
[CSoJZX_oe>K;OliR3Go<V0bod];BooKfm_oinOW0=_ojNWY00Koj>SXonKVi_mkNg_o71`LonCTi?oX
j>P2onWYj@03onOWiooYjNWojNWY00_ojNWY00coinOWonWYjOoYjNWoj>SXomSHf?l:2P[o[Zj^omgM
gOoNg]koh>3PonGUiOoXj>P8onWYj@06onSXj?oVi^Kohn?Son?ShooVi^Koj>SX0ooYjNT00ooXj>So
jNWYonWYj@04onWYj@03onOWiooYjNWojNWY0:gojNWY00?oj>SXonWYjOoYjNT0J_oYjNT00ooXj>So
jNWYonWYj@04onWYj@7ol?3`0OogmoL1ooknoP0000Goo_knoo[jn_odm?Cokno_oo7al@02oo3`l00A
onk^k_o[jn_oUIBDodlS8onEE5Co^g=com>EUOoJW9cofYjLomVLW?oDUIGo^g=coiEDE?m?8b?oUIBD
on[Zj_o^k^h01Oo`l?004Oo_knooj^[ZojVDU?n18b?o^VYDomBJLooT_9Goj/NLonW7W?oZaicoiKbE
omBJLonkJUCoPB<SojZDU?oZj^[okno_00Gol?3`017okno_on[Zj_nDU9Co8bXSoeAjE?mcYG?oW/JE
ojc>W?n]cYco[<jLoik6UOmcYG?oE7YDob<Z8onDU9CojNWYono_k`3Koo3`l0;okno_00CoP820oadM
7Oo^k^kokno_4oo`l?02ono_k`07ofATI?lY:BWoPH61of=SHolk>c_ok^k^ono_k`08oo3`l006ono_
koo^k^koLg=cofUYJOo^k^kokno_3?o`l?000oo_knool?3`oo3`l00Aoo3`l003ono_koo`l?3ol?3`
09gol?3`00?okno_oo3`l?o`l?00JOo`l?001?oalO7ol?3`ooCdm?ojn_X1ooknoP0000CokO3boooo
ooooooooo_kn0_ooool2ooknoP3ooogmoOohn?SoKFe]oeXo?onaT93og/W9oo3Ti?oci^Kol>CTomk9
bOnaT93oFSloofe]KOohn?Soo?clooooooono_koooooookno_ooookoo_knooooooolo?con?Shohe]
KOn:?coobI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo?on=KFgon?Sgooclo?ooooooo_knoooo
ooono_koooooookno_ooookoo?clooShn?m]KFgo?clooi2MT?o9eLWoi>cTonK^i_oTk>CobMG9oi2M
T?lo?cooKFe]ooShn?olo?coooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_kn000hooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooomoOgod=3@ojFUYOono_goo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooooogmoOo1`L3oLG5a
oh61POn_[jl2ooknoP0<ooooooono_koooonookno_ooooooo_knooooooono_kooooooogmoOo2`/7o
_;bl0_ono_h0ooooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooo`00:Oono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn00;o
oooo00?oo_knooooooooool00oooool1oo[jn`0000Coa<_Bookno_ojn_[om?Cd0ooalO403oo`l?3o
lO7aono_kooFe]KoJf][od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7a
l@0>ono_kooGe]KoPf][og@m?OneS8coeKZjon7<c?oF^[[o]Xb<og8m?On1Jf_oemKFono_koo`l?08
oo7al@0=ono_kooFe]KoJf][ocdm?On<S8co^[Zjolc=c?nj^[[oS8b<ocdm?Om[Jf_oe]KFono_k`3o
oo7alOoolO7a=?oalO401?o`l?3olO7aoo7alOo`l?04oo7al@03ooCdm?oinOWoo_kn007ol?;c0000
1On7U:7ooOgmooOgmoo`l?3ojn_[00?oj^[Z00gojNWYon[Zj_oYjNWoj>SXoi^KVomIFEWo9RHVo`T9
2OlV9RKoFEUIoi^KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo@RHVofUI
FOnPVi_oj>SXonWYj@02on[ZjP03onWYjOoZj^[oj^[Z00Koj^[Z00oojNWYonSXj?nKVi_oFEUIobHV
9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYjOoZj^[ojNWYon[Zj_oYjNT0oooZj^XHon[ZjP03onWYjOoZ
j^[oj^[Z0?ooj^[Z7OoZj^X01?o[jn_ol?3`ooShn?omoOd1omkQh`0000Co>4UIok[2b_ojn_[om?Cd
2?oalO42oo3`l0?okno_0_o`l?03oo7al@03oo3`l?oalO7olO7a00WolO7a0_o`l?03ono_k`;ol?3`
3ooalO42oo3`l0?okno_0_o`l?3ooo7alOoolO7a>_oalO400oo`l?3olO7aoo7al@02oo7al@03ooCd
m?ojn_[ojng_007oWjBW00000olR=TWoCEiZok[3b@3oooooooooooooO?ooool1onW[k@7oYJZ/0OnK
XJD00006obLnD?lP=TKo=DQDoh:?V?o1alcok>g_ooooooooooooogKooooo00GonOWjon_^kooBe]So
VYnRoijSYP01ok>i_P00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell["Some constants for layers are listed.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(layerConstants = \
{\[IndentingNewLine]javax`swing`JLayeredPane`DEFAULTULAYER, \
\[IndentingNewLine]javax`swing`JLayeredPane`PALETTEULAYER, \
\[IndentingNewLine]javax`swing`JLayeredPane`MODALULAYER, \
\[IndentingNewLine]javax`swing`JLayeredPane`POPUPULAYER, \
\[IndentingNewLine]javax`swing`JLayeredPane`DRAGULAYER\[IndentingNewLine]}\)],\
 "Input"],

Cell[BoxData[
    \({0, 100, 200, 300, 400}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(javax`swing`JLayeredPane`FRAMEUCONTENTULAYER\)], "Input"],

Cell[BoxData[
    \(\(-30000\)\)], "Output"]
}, Open  ]],

Cell["We also list names of layers.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(layerNames = {\[IndentingNewLine]"\<Default Layer\>", \
\[IndentingNewLine]"\<Palette Layer\>", \[IndentingNewLine]"\<Modal Layer\>", \
\[IndentingNewLine]"\<Popup Layer\>", \[IndentingNewLine]"\<Drag Layer\>"\
\[IndentingNewLine]}\)], "Input"],

Cell[BoxData[
    \({"Default Layer", "Palette Layer", "Modal Layer", "Popup Layer", 
      "Drag Layer"}\)], "Output"]
}, Open  ]],

Cell["\<\
An ImageIcon which will be shown on a title bar of the internal \
frame is loaded.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(icon = 
      NewImageIcon[
        StringJoin[$JavaSwingMaterial, "\<NB(S).GIF\>"]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject29217873985537]], "Output"]
}, Open  ]],

Cell[TextData[{
  "JInternalFrame objects are added to the ",
  StyleBox["layer",
    FontWeight->"Bold"],
  " which is actually the layered pane of the frame.\nA close box of an \
internal frame is not handled at now."
}], "Text"],

Cell[BoxData[{
    \(\(internalFrames = {};\)\), "\n", 
    \(Do[\[IndentingNewLine]internalFrames = 
        AppendTo[\[IndentingNewLine]internalFrames, 
          NewJInternalFrame[\[IndentingNewLine]layer, 
            layerConstants[\([i]\)], \[IndentingNewLine]layerNames[\([i]\)], \
\[IndentingNewLine]Round[25  i], Round[25 \((i + 1)\)], 200, 
            250, \[IndentingNewLine]True, True, True, 
            True, \[IndentingNewLine]icon\[IndentingNewLine]]\
\[IndentingNewLine]]; \[IndentingNewLine]layer@
        repaint[];, \[IndentingNewLine]{i, 1, 
        5}\[IndentingNewLine]]\), "\n", 
    \(JavaShow[frame]\), "\[IndentingNewLine]", 
    \(frame@repaint[]\), "\[IndentingNewLine]", 
    \(internalFrames[\([1]\)]@setSelected[True]\)}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[TextData[{
  "JInternalFrame objects which is kept in the ",
  StyleBox["internalFrames",
    FontWeight->"Bold"],
  " are removed."
}], "Text"],

Cell[BoxData[
    \(Do[\[IndentingNewLine]internalFrames[\([i]\)]@
        dispose[]; \[IndentingNewLine]ReleaseObject[
        internalFrames[\([i]\)]];, \[IndentingNewLine]{i, 1, 
        5}\[IndentingNewLine]]\)], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JDesktopPane, JInternalFrame <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVI
c?nIVLajVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<
NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVI
c?nIVLajVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<
NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVI
c?nIVLajVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<
NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVI
c?nIVLajVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<
NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVI
c?nIVLajVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<
NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVI
c?nIVLajVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<
NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;QmVIW<00?<c<aVIVIVIVH0a6IVIP03c<c<VIW<VIW<0?nIVL`bVIW<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^7fIVL`?IVIV[9VIV@eVIVKoVIW<
=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QmVIW<3VIVIZ`0000>
IVIVoiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hOIVIc<QV
IVKoVIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QmVIW<b6IV
I_nIVL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^7fIVL`5IVIV
_/c<c0EVIVKoVIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qm
VIW<1FIVI[k<c<`5IVIVoiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2hOIVIc0EVIVJnc<c<1FIVI_nIVL`dVIW<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^7fIVL`5IVIV_/c<c0EVIVKoVIW<=9VIc0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;QmVIW<1FIVI[k<c<`5IVIVoiVIc3BIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hOIVIc0EVIVJnc<c<1FIVI_nI
VL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^7fIVL`5IVIV_/c<
c0EVIVKoVIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QmVIW<
1FIVI[k<c<`5IVIVoiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hOIVIc0=VIVH00iVIVFIVI/c<c02mc<c<0fIVIP03VIVIIVIVVIW<0?nI
VL`cVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^7fIVL`2IVIV00<0
002IVIUVIVH0_/c<c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;QmVIW<0VIVIP030000VIVIIVIV0;k<c<`2
IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2hOIVIc09VIVH00`0009VIVFIVIP2nc<c<0VIVIP030000VIVIIVIV
0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^7fIVL`2IVIV
00<0002IVIUVIVH0_/c<c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;QmVIW<0VIVIP030000VIVIIVIV0;k<
c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hOIVIc09VIVH00`0009VIVFIVIP2nc<c<0VIVIP030000VIVI
IVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^7fIVL`2
IVIV00<0002IVIUVIVH0_/c<c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;QmVIW<0VIVIP030000VIVIIVIV
0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hOIVIc09VIVH00`0009VIVFIVIP2nc<c<0VIVIP030000
VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^7fI
VL`2IVIV00<0002IVIUVIVH0_/c<c09VIVH00`0009VIVFIVIP3oVIW<=9VI
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QmVIW<0VIVIP030000VIVI
IVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hI9VIc003c<c<IVIVIVIV01QVIVH00`0009VIVFIV
IP2nc<c<0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^6BIVL`?IVIV2YVIV@9VIVH00`0009VIVFIVIP2nc<c<
0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^6BIVL`>IVIV2`00009VIVH00`0009VIVFIVIP2nc<c<0VIVIP03
0000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^6BIVL`KIVIV00<0002IVIUVIVH0_/c<c09VIVH00`0009VIVFIVIP3oVIW<
=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QTVIW<6fIVIP030000
VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hI9VIc0EVIVHDc<c<0VIVIP030000VIVIIVIV
0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hI9VIc0EVIVHDc<c<0VIVIP030000VIVIIVIV0;k<c<`2
IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2hI9VIc0EVIVHDc<c<0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0
002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
I9VIc0EVIVHDc<c<0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0002IVIUV
IVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI9VIc0EV
IVHDc<c<0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVI
c3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI9VIc0EVIVHDc<c<
0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI9VIc0EVIVHDc<c<0VIVIP03
0000VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hI9VIc0EVIVHDc<c<0VIVIP030000VIVI
IVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hI9VIc0=VIVH00iVIVFIVI/c<c00Cc<c<0VIVIP03
0000VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hI9VIc09VIVH00`0009VIVFIVIP0Dc<c<
0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI9VIc09VIVH00`0009VIVFIV
IP0Dc<c<0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVI
c3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI9VIc09VIVH00`00
09VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0002IVIUV
IVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI9VIc09V
IVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0
002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
I9VIc09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV0;k<c<`2
IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2hI9VIc09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV
0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hI9VIc09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP030000
VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hI9VIc09VIVH00`0009VIVFIVIP0Dc<c<0VIV
IP030000VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hI9VIc09VIVH00`0009VIVFIVIP0D
c<c<0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BI
VL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI9VIc09VIVH00`0009VI
VFIVIP0Dc<c<0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0
oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hI9VIc09VIVH0
0`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0002I
VIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hBiVI
c003c<c<IVIVIVIV01QVIVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVI
IVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hBiVIc0mVIVH:VIVI0VIVIP030000VIVIIVIV01C<
c<`2IVIV00<0002IVIUVIVH0_/c<c09VIVH00`0009VIVFIVIP3oVIW<=9VI
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Q;VIW<3VIVIP/00002IVIV
00<0002IVIUVIVH05<c<c09VIVH00`0009VIVFIVIP2nc<c<0VIVIP030000
VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^4^I
VL`KIVIV00<0002IVIUVIVH05<c<c09VIVH00`0009VIVFIVIP2nc<c<0VIV
IP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^4^IVL`KIVIV00<0002IVIUVIVH05<c<c09VIVH00`0009VIVFIVIP2n
c<c<0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^4^IVL`5IVIV5<c<c09VIVH00`0009VIVFIVIP0Dc<c<0VIV
IP030000VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hBiVIc0EVIVHDc<c<0VIVIP030000
VIVIIVIV01C<c<`2IVIV00<0002IVIUVIVH0_/c<c09VIVH00`0009VIVFIV
IP3oVIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Q;VIW<1FIV
IQC<c<`2IVIV00<0002IVIUVIVH05<c<c09VIVH00`0009VIVFIVIP2nc<c<
0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^4^IVL`5IVIV5<c<c09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP03
0000VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hBiVIc0EVIVHDc<c<0VIVIP030000VIVI
IVIV01C<c<`2IVIV00<0002IVIUVIVH0_/c<c09VIVH00`0009VIVFIVIP3o
VIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Q;VIW<1FIVIQC<
c<`2IVIV00<0002IVIUVIVH05<c<c09VIVH00`0009VIVFIVIP2nc<c<0VIV
IP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^4^IVL`5IVIV5<c<c09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP030000
VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hBiVIc0EVIVHDc<c<0VIVIP030000VIVIIVIV
01C<c<`2IVIV00<0002IVIUVIVH0_/c<c09VIVH00`0009VIVFIVIP3oVIW<
=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Q;VIW<0fIVIP03VIVI
IVIVc<c<01?<c<`2IVIV00<0002IVIUVIVH05<c<c09VIVH00`0009VIVFIV
IP2nc<c<0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^4^IVL`2IVIV00<0002IVIUVIVH05<c<c09VIVH00`00
09VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0002IVIUV
IVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hBiVIc09V
IVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV01C<c<`2IVIV00<0
002IVIUVIVH0_/c<c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Q;VIW<0VIVIP030000VIVIIVIV01C<c<`2
IVIV00<0002IVIUVIVH05<c<c09VIVH00`0009VIVFIVIP2nc<c<0VIVIP03
0000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^4^IVL`2IVIV00<0002IVIUVIVH05<c<c09VIVH00`0009VIVFIVIP0Dc<c<
0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hBiVIc09VIVH00`0009VIVFIV
IP0Dc<c<0VIVIP030000VIVIIVIV01C<c<`2IVIV00<0002IVIUVIVH0_/c<
c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Q;VIW<0VIVIP030000VIVIIVIV01C<c<`2IVIV00<0002IVIUV
IVH05<c<c09VIVH00`0009VIVFIVIP2nc<c<0VIVIP030000VIVIIVIV0?nI
VL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^4^IVL`2IVIV00<0
002IVIUVIVH05<c<c09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVI
IVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hBiVIc09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP03
0000VIVIIVIV01C<c<`2IVIV00<0002IVIUVIVH0_/c<c09VIVH00`0009VI
VFIVIP3oVIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Q;VIW<
0VIVIP030000VIVIIVIV01C<c<`2IVIV00<0002IVIUVIVH05<c<c09VIVH0
0`0009VIVFIVIP2nc<c<0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^4^IVL`2IVIV00<0002IVIUVIVH05<c<
c09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV0;k<c<`2IVIV
00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hBiVIc09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV01C<
c<`2IVIV00<0002IVIUVIVH0_/c<c09VIVH00`0009VIVFIVIP3oVIW<=9VI
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PbVIW<00?<c<aVIVIVIVH0
66IVIP030000VIVIIVIV01C<c<`2IVIV00<0002IVIUVIVH05<c<c09VIVH0
0`0009VIVFIVIP2nc<c<0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^3:IVL`?IVIV2YVIV@9VIVH00`0009VI
VFIVIP0Dc<c<0VIVIP030000VIVIIVIV01C<c<`2IVIV00<0002IVIUVIVH0
_/c<c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;PbVIW<3VIVIP/00002IVIV00<0002IVIUVIVH05<c<c09V
IVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0
002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
<YVIc1]VIVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV01C<c<`2
IVIV00<0002IVIUVIVH0_/c<c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;PbVIW<6fIVIP030000VIVIIVIV
01C<c<`2IVIV00<0002IVIUVIVH05<c<c09VIVH00`0009VIVFIVIP2nc<c<
0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^3:IVL`5IVIV5<c<c09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP03
0000VIVIIVIV01C<c<`2IVIV00<0002IVIUVIVH0_/c<c09VIVH00`0009VI
VFIVIP3oVIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PbVIW<
1FIVIQC<c<`2IVIV00<0002IVIUVIVH05<c<c09VIVH00`0009VIVFIVIP0D
c<c<0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BI
VL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<YVIc0EVIVHDc<c<0VIV
IP030000VIVIIVIV01C<c<`2IVIV00<0002IVIUVIVH05<c<c09VIVH00`00
09VIVFIVIP2nc<c<0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^3:IVL`5IVIV5<c<c09VIVH00`0009VIVFIV
IP0Dc<c<0VIVIP030000VIVIIVIV01C<c<`2IVIV00<0002IVIUVIVH0_/c<
c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;PbVIW<1FIVIQC<c<`2IVIV00<0002IVIUVIVH05<c<c09VIVH0
0`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV0;k<c<`2IVIV00<0002I
VIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<YVI
c0EVIVHDc<c<0VIVIP030000VIVIIVIV01C<c<`2IVIV00<0002IVIUVIVH0
5<c<c09VIVH00`0009VIVFIVIP2nc<c<0VIVIP030000VIVIIVIV0?nIVL`d
VIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3:IVL`5IVIV5<c<c09V
IVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV01C<c<`2IVIV00<0
002IVIUVIVH0_/c<c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;PbVIW<1FIVIQC<c<`2IVIV00<0002IVIUV
IVH05<c<c09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV0;k<
c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h<YVIc0=VIVH00iVIVFIVI/c<c00Cc<c<0VIVIP030000VIVI
IVIV01C<c<`2IVIV00<0002IVIUVIVH05<c<c09VIVH00`0009VIVFIVIP2n
c<c<0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^3:IVL`2IVIV00<0002IVIUVIVH05<c<c09VIVH00`0009VI
VFIVIP0Dc<c<0VIVIP030000VIVIIVIV01C<c<`2IVIV00<0002IVIUVIVH0
_/c<c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;PbVIW<0VIVIP030000VIVIIVIV01C<c<`2IVIV00<0002I
VIUVIVH05<c<c09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV
0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h<YVIc09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP030000
VIVIIVIV01C<c<`2IVIV00<0002IVIUVIVH05<c<c09VIVH00`0009VIVFIV
IP2nc<c<0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^3:IVL`2IVIV00<0002IVIUVIVH05<c<c09VIVH00`00
09VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV01C<c<`2IVIV00<0002IVIUV
IVH0_/c<c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;PbVIW<0VIVIP030000VIVIIVIV01C<c<`2IVIV00<0
002IVIUVIVH05<c<c09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVI
IVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h<YVIc09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP03
0000VIVIIVIV01C<c<`2IVIV00<0002IVIUVIVH05<c<c09VIVH00`0009VI
VFIVIP2nc<c<0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^3:IVL`2IVIV00<0002IVIUVIVH05<c<c09VIVH0
0`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV01C<c<`2IVIV00<0002I
VIUVIVH0_/c<c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;PbVIW<0VIVIP030000VIVIIVIV01C<c<`2IVIV
00<0002IVIUVIVH05<c<c09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP030000
VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h<YVIc09VIVH00`0009VIVFIVIP0Dc<c<0VIV
IP030000VIVIIVIV01C<c<`2IVIV00<0002IVIUVIVH05<c<c09VIVH00`00
09VIVFIVIP2nc<c<0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^3:IVL`2IVIV00<0002IVIUVIVH05<c<c09V
IVH00`0009VIVFIVIP0Dc<c<0VIVIP030000VIVIIVIV01C<c<`2IVIV00<0
002IVIUVIVH0_/c<c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;PbVIW<0VIVIP030000VIVIIVIV01C<c<`2
IVIV00<0002IVIUVIVH05<c<c09VIVH00`0009VIVFIVIP0Dc<c<0VIVIP03
0000VIVIIVIV0;k<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6IVIc003c<c<IVJIIVJI0<AVIYUPc<c<
0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^1VIVL`?IVJI[9VIc0eVIYUOc<c<0VIVIP030000VIVIIVIV0?nI
VL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`>IVJI[000
00iVIYUOc<c<0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^1VIVLc8IVJIGlc<c09VIVH00`0009VIVFIVIP3o
VIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<b6IVVEo<
c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6IVIc0EVIYVnc<c<1FIVVEo<c<`2IVIV00<0002IVIUVIVH0
oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc0EVIYVn
c<c<1FIVVEo<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6IVIc0EVIYVnc<c<1FIVVEo<c<`2IVIV00<0
002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6IVIc0EVIYVnc<c<1FIVVEo<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc0EVIYVnc<c<1FIVVEo<
c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6IVIc0EVIYVnc<c<1FIVVEo<c<`2IVIV00<0002IVIUVIVH0
oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc0EVIYVn
c<c<1FIVVEo<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6IVIc0EVIYVnc<c<1FIVVEo<c<`2IVIV00<0
002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6IVIc0=VIYT00iVIc6IVVLc<c02mc<c<0fIVV@03VIW<IVJIc<c<05k<c<`2
IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI
05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000
VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIV
V@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2n
c<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BI
VL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VI
c6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0
oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT0
0`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002I
VIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVI
c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV
00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<
c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<
IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@03
0000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<
0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IV
V@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVI
c3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`00
09VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUV
IVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09V
IYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0
002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2
IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI
05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000
VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIV
V@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2n
c<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BI
VL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VI
c6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0
oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT0
0`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002I
VIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVI
c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV
00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<
c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<
IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@03
0000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<
0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IV
V@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVI
c3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`00
09VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUV
IVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09V
IYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0
002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2
IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI
05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000
VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIV
V@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2n
c<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BI
VL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VI
c6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0
oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT0
0`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002I
VIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVI
c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV
00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<
c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<
IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@03
0000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<
0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IV
V@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVI
c3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`00
09VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUV
IVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09V
IYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0
002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2
IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI
05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000
VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIV
V@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2n
c<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BI
VL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VI
c6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0
oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT0
0`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002I
VIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVI
c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV
00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<
c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<
IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@03
0000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<
0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IV
V@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVI
c3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`00
09VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUV
IVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09V
IYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0
002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2
IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI
05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000
VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIV
V@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2n
c<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BI
VL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VI
c6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0
oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT0
0`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002I
VIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVI
c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV
00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<
c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<
IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@03
0000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<
0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IV
V@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVI
c3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`00
09VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUV
IVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09V
IYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0
002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2
IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI
05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000
VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIV
V@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2n
c<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BI
VL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VI
c6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0
oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT0
0`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002I
VIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVI
c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV
00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<
c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<
IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@03
0000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<
0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IV
V@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVI
c3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`00
09VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUV
IVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09V
IYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0
002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2
IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI
05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000
VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIV
V@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2n
c<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BI
VL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VI
c6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0
oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT0
0`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002I
VIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVI
c09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV
00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<
c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<
IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@03
0000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<
0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IV
V@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVI
c3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`00
09VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUV
IVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09V
IYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2IVIV00<0
002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI05o<c<`2
IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI
05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000
VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIV
V@030000VIW<IVJI05o<c<`2IVIV00<0002IVIUVIVH0oiVIc3BIVL`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2n
c<c<0VIVV@030000VIW<IVJI065VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI
0;k<c<`2IVJI00<0002IVLaVIYT0Glc<c09VIVH00`0009VIVFIVIP3oVIW<
=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000
VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0Glc<c09VIVH00`0009VIVFIV
IP3oVIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIV
V@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0Glc<c09VIVH00`00
09VIVFIVIP3oVIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PI
VIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0Glc<c09V
IVH00`0009VIVFIVIP3oVIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
8Lc<c0Ooool;c<c<2_oooa3<c<`>oooo1<c<c09VIVH00`0009VIVFIVIP3o
VIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT08<c<c0030000IVIVIVIV
00AVIVH00oooolc<c<c<c008c<c<00<0001VIVIVIVH01fIVIP03ooooc<c<
c<c<00g<c<`00`0006IVIVIVIP0;IVIV00?oooo<c<c<c<`00/c<c09VIVH0
0`0009VIVFIVIP3oVIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00@0002IVLaVIYT00002
c<c<0P0000;<c<`400001Lc<c08000001<c<c00000000<c<c0800008c<c<
00<0001VIVIVIVH00`000003IVIVooooc<c<00W<c<`00`0006IVIVIVIP02
IVIV10000003IVIVooooc<c<00k<c<`00`0006IVIVIVIP0:000000=VIVKo
ooo<c<`00lc<c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI
00@0002IVLaVIYT00002c<c<0P000003c<c<0000000000;<c<`200001<c<
c08000001<c<c00000000<c<c0800008c<c<00<0001VIVKoool00/c<c003
0000IVIVoooo00[<c<`01@0006IVIVIVIVIVI_ooo`03c<c<00<0001VIVKo
ool03lc<c0030000IVIVc<c<00O<c<`01Oooolc<c00006IVI_ooo`04c<c<
0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<c09VIYT0100009VIc6IV
V@0000;<c<`2000000?<c<`0000000006<c<c0030000IVIVoooo00;<c<`0
0`0006IVI_ooo`0:c<c<00<0001VIVH000000VIVIP06ooooc<c<c<c<0000
IVIVoooo3lc<c0060000IVIVc<c<c<c<IVIVoooo0lc<c006IVIVoooooooo
0000IVIVoooo1<c<c09VIVH00`0009VIVFIVIP3oVIW<=9VIc0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2
IVJI00@0002IVLaVIYT00002c<c<0P000003c<c<0000000000@0000Dc<c<
00<0001VIVKoool00_ooo`9VIVH00oooolc<c<c<c008c<c<00@0001VIVKo
ool00002IVIV00Goooo<c<`0001VIVKoool03lc<c0040000IVIVc<c<0000
0VIVIP;oool3IVIV00C<c<`0001VIVKoool4c<c<0VIVIP030000VIVIIVIV
0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI
00<0002IVLaVIYT0_/c<c09VIYT0100009VIc6IVV@0000;<c<`2000000?<
c<`0000000000/c<c080000Dc<c<00<0001VIVIVIVH016IVIP_<c<`01@00
06IVI_ooolc<c0000002IVIV00CooomVIVIVIVKoool?c<c<00D0001VIVK<
c<c<c<`000001FIVIP;<c<`00`0006IVI_ooo`04c<c<0VIVIP030000VIVI
IVIV0?nIVL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2
IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@02000000C<c<`0
0000003<c<`200000/c<c080000Dc<c<1`000003c<c<oooooooo00Coool4
c<c<00<0001VIVKoool00/c<c0030000IVIVIVIV009VIVH00oooolc<c<c<
c00=c<c<00<0001VIVK<c<`00/c<c0050000IVIVIVIVIVIVoooo00;<c<`0
0`0006IVI_ooo`04c<c<0VIVIP030000VIVIIVIV0?nIVL`dVIW<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<
c09VIYT00`0009VIc6IVV@02c<c<0P0000?<c<`400007<c<c0030000IVIV
IVIV00=VIVH00oooolc<c<c<c002c<c<00<0001VIVKoool00oooo`050000
IVIVIVIVIVIVoooo00;<c<`2oooo2lc<c0030000IVIVc<c<00;<c<`4IVIV
00Koooo<c<c<c<`0001VIVKoool4c<c<0VIVIP030000IVIVIVIV0?nIVL`d
VIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002I
VLaVIYT0_/c<c09VIYT00`0009VIc6IVV@0Wc<c<00@0001VIVIVIVIVIVH2
00001Lc<c0030000IVIVIVIV00MVIVH2oooo0VIVIP03ooooc<c<c<c<00W<
c<`0100006IVI/c<c<c<c0=VIVH0200006IVIVIVI_ooolc<c00006IVI_oo
o`C<c<`5IVIVoiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI02O<c<`0
1@0006IVIVIVIVIVI_ooo`06c<c<2@00009VIVH01?ooofIVIVIVI_ooo`_<
c<`0100006IVI/c<c000009VIVH2c<c<00L0001VIVIVIVK<c<`0001VIVKo
ool01<c<c0EVIVKoVIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT09lc<
c0030000IVIV0000009VIVH00oooolc<c<c<c00<c<c<00<0001VIVIVIVH0
0VIVIP03ooooc<c<c<c<00W<c<`01@0006IVI/c<c<c<c0000004c<c<00H0
003<c<c<c<`0001VIVKoool4c<c<1FIVI_nIVL`dVIW<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<c09VIYT0
0`0009VIc6IVV@0Wc<c<00@0001VIVKoool00002IVIV00?oooo<c<c<c<`0
2lc<c003oooo0000IVIV009VIVH00oooolc<c<c<c009c<c<00<0001VIVK<
c<`02Lc<c09VIVH00oooolc<c<c<c002c<c<1FIVI_nIVL`dVIW<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<
c09VIYT00`0009VIc6IVV@0Wc<c<0P0000;<c<`00`0006IVIVIVIP0<c<c<
00<0001VIVIVIVH00fIVIP03ooooc<c<c<c<00W<c<`00`0006IVIVIVIP0;
IVIV00?oooo<c<c<c<`00/c<c0EVIVKoVIW<=9VIc0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT0;<c<c0030000c<c<c<c<00_<c<`600003<c<c0h00005c<c<
1FIVI_nIVL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2
IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@1Oc<c<1FIVI_nI
VL`dVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0
002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@1Oc<c<1FIVI_nIVL`dVIW<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002IVLaV
IYT0_/c<c09VIYT00`0009VIc6IVV@1Nc<c<1VIVI_nIVL`dVIW<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<
c09VIYT00`0009VIc6IVV@1TIVIVoiVIc3BIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000
VIW<IVJI05NIVIT=IVIVoiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI
05H0000>IVIVoiVIc3BIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI06AVIVKo
VIW<=9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0HfIVIP03c<c<VIW<VIW<
0?nIVL`bVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI
00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@16c<c<0VIVIP030000
VIVIIVIV0?nIVLa=VIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VI
VL`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@16c<c<0VIV
IP030000VIVIIVIV0?nIVLa=VIW<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@08
c<c<1oooo`_<c<`:oooo4<c<c0koool4c<c<0VIVIP030000VIVIIVIV0?nI
VLa=VIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0
002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@07c<c<00<0001VIVIVIVH0
16IVIP03ooooc<c<c<c<00S<c<`00`0006IVIVIVIP07IVIV00?oooo<c<c<
c<`03Lc<c0030000IVIVIVIV00]VIVH00oooolc<c<c<c002c<c<0VIVIP03
0000VIVIIVIV0?nIVLa=VIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^1VIVL`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@07c<c<
00<0001VIVIVIVH00`000003IVIVooooc<c<00W<c<`00`0006IVIVIVIP02
IVIV10000003IVIVooooc<c<00k<c<`00`0006IVIVIVIP0:000000=VIVKo
ooo<c<`00lc<c09VIVH00`0009VIVFIVIP3oVIW<CIVIc0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI
00<0002IVLaVIYT01lc<c0030000IVIVoooo00;<c<`00`0006IVI_ooo`0:
c<c<00D0001VIVIVIVIVIVKoool00lc<c0030000IVIVoooo00o<c<`00`00
06IVI/c<c007c<c<00Goooo<c<`0001VIVKoool01<c<c09VIVH00`0009VI
VFIVIP3oVIW<CIVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT01lc<c0030000
IVIVoooo00;<c<`00`0006IVI_ooo`0:c<c<00<0001VIVH000000VIVIP06
ooooc<c<c<c<0000IVIVoooo3lc<c0060000IVIVc<c<c<c<IVIVoooo0lc<
c006IVIVoooooooo0000IVIVoooo1<c<c09VIVH00`0009VIVFIVIP3oVIW<
CIVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000
VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT01lc<c0030000IVIVoooo00;o
ool2IVIV00?oooo<c<c<c<`02<c<c0040000IVIVoooo00000VIVIP05oooo
c<c<0000IVIVoooo00o<c<`0100006IVI/c<c000009VIVH2oooo0fIVIP04
c<c<0000IVIVoooo1<c<c09VIVH00`0009VIVFIVIP3oVIW<CIVIc0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<
c<`2IVJI00<0002IVLaVIYT01lc<c0030000IVIVIVIV00AVIVH;c<c<00D0
001VIVKoooo<c<`000000VIVIP04ooooIVIVIVIVoooo3lc<c0050000IVIV
c<c<c<c<000000EVIVH2c<c<00<0001VIVKoool01<c<c09VIVH00`0009VI
VFIVIP3oVIW<CIVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT01lc<c0L00000
0lc<c?ooooooo`04oooo1<c<c0030000IVIVoooo00;<c<`00`0006IVIVIV
IP02IVIV00?oooo<c<c<c<`03Lc<c0030000IVIVc<c<00;<c<`01@0006IV
IVIVIVIVI_ooo`02c<c<00<0001VIVKoool01<c<c09VIVH00`0009VIVFIV
IP3oVIW<CIVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIV
V@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT03/c<c0030000IVIV
IVIV00=VIVH00oooolc<c<c<c002c<c<00<0001VIVKoool00oooo`050000
IVIVIVIVIVIVoooo00;<c<`2oooo2lc<c0030000IVIVc<c<00;<c<`4IVIV
00Koooo<c<c<c<`0001VIVKoool4c<c<0VIVIP030000IVIVIVIV0?nIVLa=
VIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002I
VLaVIYT0_/c<c09VIYT00`0009VIc6IVV@0>c<c<00@0001VIVIVIVIVIVH2
00001Lc<c0030000IVIVIVIV00MVIVH2oooo0VIVIP03ooooc<c<c<c<00W<
c<`0100006IVI/c<c<c<c0=VIVH0200006IVIVIVI_ooolc<c00006IVI_oo
o`C<c<`5IVIVoiVIc4fIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI00k<c<`0
1@0006IVIVIVIVIVI_ooo`06c<c<2@00009VIVH01?ooofIVIVIVI_ooo`_<
c<`0100006IVI/c<c000009VIVH2c<c<00L0001VIVIVIVK<c<`0001VIVKo
ool01<c<c0EVIVKoVIW<CIVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT03/c<
c0030000IVIV0000009VIVH00oooolc<c<c<c00<c<c<00<0001VIVIVIVH0
0VIVIP03ooooc<c<c<c<00W<c<`01@0006IVI/c<c<c<c0000004c<c<00H0
003<c<c<c<`0001VIVKoool4c<c<1FIVI_nIVLa=VIW<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<c09VIYT0
0`0009VIc6IVV@0>c<c<00@0001VIVKoool00002IVIV00?oooo<c<c<c<`0
2lc<c003oooo0000IVIV009VIVH00oooolc<c<c<c009c<c<00<0001VIVK<
c<`02Lc<c09VIVH00oooolc<c<c<c002c<c<1FIVI_nIVLa=VIW<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<
c09VIYT00`0009VIc6IVV@0>c<c<0P0000;<c<`00`0006IVIVIVIP0<c<c<
00<0001VIVIVIVH00fIVIP03ooooc<c<c<c<00W<c<`00`0006IVIVIVIP0;
IVIV00?oooo<c<c<c<`00/c<c0EVIVKoVIW<CIVIc0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT04lc<c0030000c<c<c<c<00_<c<`600003<c<c0h00005c<c<
1FIVI_nIVLa=VIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2
IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@16c<c<1FIVI_nI
VLa=VIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0
002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@16c<c<1FIVI_nIVLa=VIW<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002IVLaV
IYT0_/c<c09VIYT00`0009VIc6IVV@15c<c<1VIVI_nIVLa=VIW<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<
c09VIYT00`0009VIc6IVV@1;IVIVoiVIc4fIVL`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000
VIW<IVJI03jIVIT=IVIVoiVIc4fIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI
03d0000>IVIVoiVIc4fIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI04]VIVKo
VIW<CIVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0BVIVIP03c<c<VIW<VIW<
0?nIVLa;VIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI
00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@0]c<c<0VIVIP030000
VIVIIVIV0?nIVLaVVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VI
VL`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@0]c<c<0VIV
IP030000VIVIIVIV0?nIVLaVVIW<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<c09VIYT0100009VIc6IVVLc<
c0[oool@c<c<3_ooo`C<c<`2IVIV00<0002IVIUVIVH0oiVIc6JIVL`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2n
c<c<0VIVV@040000VIW<IVJI00002FIVIP03ooooc<c<c<c<00g<c<`00`00
06IVIVIVIP0;IVIV00?oooo<c<c<c<`00/c<c09VIVH00`0009VIVFIVIP3o
VIW<IYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00@0002IVLaVIYT00004IVIV10000003IVIV
ooooc<c<00k<c<`00`0006IVIVIVIP0:000000=VIVKoooo<c<`00lc<c09V
IVH00`0009VIVFIVIP3oVIW<IYVIc0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00@0002IVLaVIYT0
0003IVIV00Ooooo<c<c<c<c<c<`0001VIVKoool03lc<c0030000IVIVc<c<
00O<c<`01Oooolc<c00006IVI_ooo`04c<c<0VIVIP030000VIVIIVIV0?nI
VLaVVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0
002IVLaVIYT0_/c<c09VIYT01P0009VIc6IVV@0006IVIP00009VIVH01_oo
olc<c<c<c00006IVI_ooo`o<c<`01P0006IVI/c<c<c<c6IVI_ooo`?<c<`0
1VIVI_ooooooo`0006IVI_ooo`C<c<`2IVIV00<0002IVIUVIVH0oiVIc6JI
VL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VI
c6IVV@2nc<c<0VIVV@070000VIW<IVJI0000IVIVoooo0000009VIVH01Ooo
olc<c00006IVI_ooo`0?c<c<00@0001VIVK<c<`00002IVIV0_ooo`=VIVH0
1<c<c00006IVI_ooo`C<c<`2IVIV00<0002IVIUVIVH0oiVIc6JIVL`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2n
c<c<0VIVV@080000VIW<IVJI0000IVIVooooc<c<00000VIVIP04ooooIVIV
IVIVoooo3lc<c0050000IVIVc<c<c<c<000000EVIVH2c<c<00<0001VIVKo
ool01<c<c09VIVH00`0009VIVFIVIP3oVIW<IYVIc0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00H0
002IVLaVIYT0001VIVKoool2c<c<00<0001VIVIVIVH00VIVIP03ooooc<c<
c<c<00g<c<`00`0006IVI/c<c002c<c<00D0001VIVIVIVIVIVKoool00/c<
c0030000IVIVoooo00C<c<`2IVIV00<0002IVIUVIVH0oiVIc6JIVL`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2n
c<c<0VIVV@050000VIW<IVJI0000IVIV00Coool01@0006IVIVIVIVIVI_oo
o`02c<c<0_ooo`_<c<`00`0006IVI/c<c002c<c<16IVIP06ooooc<c<c<c<
0000IVIVoooo1<c<c09VIVH00`0006IVIVIVIP3oVIW<IYVIc0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2
IVJI00@0002IVLaVIYT00009IVIV0_ooo`9VIVH00oooolc<c<c<c009c<c<
00@0001VIVK<c<c<c<`3IVIV00P0001VIVIVIVKoooo<c<`0001VIVKoool4
c<c<1FIVI_nIVLaVVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VI
VL`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@0900000VIV
IP04ooooIVIVIVIVoooo2lc<c0040000IVIVc<c<00000VIVIP;<c<`01`00
06IVIVIVI/c<c00006IVI_ooo`04c<c<1FIVI_nIVLaVVIW<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<c09V
IYT00`0009VIc6IVV@09c<c<00<0001VIVIVIVH00VIVIP03ooooc<c<c<c<
00W<c<`01@0006IVI/c<c<c<c0000004c<c<00H0003<c<c<c<`0001VIVKo
ool4c<c<1FIVI_nIVLaVVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^1VIVL`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@09c<c<
00?oool0001VIVH00VIVIP03ooooc<c<c<c<00W<c<`00`0006IVI/c<c009
c<c<0VIVIP03ooooc<c<c<c<00;<c<`5IVIVoiVIc6JIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<c<0VIV
V@030000VIW<IVJI00S<c<`00`0006IVIVIVIP03IVIV00?oooo<c<c<c<`0
2Lc<c0030000IVIVIVIV00]VIVH00oooolc<c<c<c002c<c<1FIVI_nIVLaV
VIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002I
VLaVIYT0_/c<c09VIYT00`0009VIc6IVV@08c<c<1P0000c<c<`>00001Lc<
c0EVIVKoVIW<IYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<
0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0;Lc<c0EVIVKo
VIW<IYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0;Lc<c0EVIVKoVIW<IYVI
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<
IVJI0;k<c<`2IVJI00<0002IVLaVIYT0;<c<c0IVIVKoVIW<IYVIc0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<
c<`2IVJI00<0002IVLaVIYT0<VIVI_nIVLaVVIW<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`00
09VIc6IVV@0UVIVI3FIVI_nIVLaVVIW<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IV
V@0T00003VIVI_nIVLaVVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^1VIVL`2IVJI00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@0bIVIV
oiVIc6JIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT0
0`0009VIc6IVV@2nc<c<0VIVV@030000VIW<IVJI035VIVH00lc<c9VIc9VI
c03oVIW<I9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIV
V@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT05<c<c09VIVH00`00
09VIVFIVIP3oVIW<OiVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PI
VIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT05<c<c09V
IVH00`0009VIVFIVIP3oVIW<OiVIc0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT0
0/c<c0koool4c<c<0VIVIP030000VIVIIVIV0?nIVLaoVIW<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<c09V
IYT01@0009VIc6IVVLc<c000000=IVIV00?oooo<c<c<c<`00/c<c09VIVH0
0`0009VIVFIVIP3oVIW<OiVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00D0002IVLaVIYW<c<`0
00000VIVIPX000000fIVI_ooolc<c003c<c<0VIVIP030000VIVIIVIV0?nI
VLaoVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0
002IVLaVIYT0_/c<c09VIYT01P0009VIc6IVVLc<c00006IVIPS<c<`01Ooo
olc<c00006IVI_ooo`04c<c<0VIVIP030000VIVIIVIV0?nIVLaoVIW<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002IVLaVIYT0
_/c<c09VIYT01P0009VIc6IVVLc<c00006IVIP;<c<`00fIVI_ooolc<c002
c<c<00IVIVKoooooool0001VIVKoool4c<c<0VIVIP030000VIVIIVIV0?nI
VLaoVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0
002IVLaVIYT0_/c<c09VIYT0200009VIc6IVVLc<c00006IVI/c<c000009V
IVH2oooo0fIVIP04c<c<0000IVIVoooo1<c<c09VIVH00`0009VIVFIVIP3o
VIW<OiVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00H0002IVLaVIYW<c<`0001VIVH2c<c<00<0
001VIVIVIVH00fIVIP;<c<`00`0006IVI_ooo`04c<c<0VIVIP030000VIVI
IVIV0?nIVLaoVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2
IVJI00<0002IVLaVIYT0_/c<c09VIYT01P0009VIc6IVVLc<c00006IVIP?<
c<`01@0006IVIVIVIVIVI_ooo`02c<c<00<0001VIVKoool01<c<c09VIVH0
0`0009VIVFIVIP3oVIW<OiVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00H0002IVLaVIYW<c<`0
001VIVH3c<c<16IVIP06ooooc<c<c<c<0000IVIVoooo1<c<c09VIVH00`00
06IVIVIVIP3oVIW<OiVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PI
VIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00H0002IVLaVIYW<c<`0001V
IVH2c<c<0fIVIP080000IVIVIVIVooooc<c<0000IVIVoooo1<c<c0EVIVKo
VIW<OiVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@03
0000VIW<IVJI0;k<c<`2IVJI00P0002IVLaVIYW<c<`0001VIVK<c<`00002
IVIV0/c<c0070000IVIVIVIVc<c<0000IVIVoooo00C<c<`5IVIVoiVIc7nI
VL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VI
c6IVV@2nc<c<0VIVV@060000VIW<IVJIc<c<0000IVIV0/c<c0030000c<c<
c<c<00;<c<`01P000<c<c<c<c00006IVI_ooo`C<c<`5IVIVoiVIc7nIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IV
V@2nc<c<0VIVV@060000VIW<IVJIc<c<0000IVIV2/c<c09VIVH00oooolc<
c<c<c002c<c<1FIVI_nIVLaoVIW<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<c09VIYT01@0009VIc6IVVLc<
c000000=IVIV00?oooo<c<c<c<`00/c<c0EVIVKoVIW<OiVIc0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2
IVJI00@0002IVLaVIYW<c<`>00001Lc<c0EVIVKoVIW<OiVIc0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2
IVJI00<0002IVLaVIYT05<c<c0EVIVKoVIW<OiVIc0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0
002IVLaVIYT05<c<c0EVIVKoVIW<OiVIc0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaV
IYT04lc<c0IVIVKoVIW<OiVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PIVIW<0VIVV@030000VIW<IVJI0;k<c<`2IVJI00<0002IVLaVIYT06FIV
I_nIVLaoVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI
00<0002IVLaVIYT0_/c<c09VIYT00`0009VIc6IVV@0<VIVI3FIVI_nIVLao
VIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002I
VLaVIYT0`6IVV@030000VIW<IVJI00/0000>IVIVoiVIc7nIVL`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@2nc<co
0VIVV@030000VIW<IVJI01UVIVKoVIW<OiVIc0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI0;k<c?l2IVJI00<0002I
VLaVIYT066IVIP03c<c<VIW<VIW<0?nIVLamVIW<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^1VIVL`2IVJI00<0002IVLaVIYT0_/c<o`9VIYT00`00
09VIc6IVV@3oVIW<V9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PI
VIW<0VIVV@030000VIW<IVJI00G<c?l00oooohR8R4A4A006A4A400<c<c=4
A4A4A4@00dA4A003VIVIc<coc<co0:O<c?l2IVJI00<0002IVLaVIYT0oiVI
c9RIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`00
09VIc6IVV@05c<co00?ooom4A4AVIVH00gMgM`03IVIVMgMgMgMg00EgMgL0
0c<c<lc<c<c<o`1Zc<co1oooo`_<c?l:oooo4<c<o`koool4c<co0VIVV@03
0000VIW<IVJI0?nIVLbHVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^1VIVL`2IVJI00<0002IVLaVIYT01Lc<o`0<oooo<c<ck^k^k^k^^k^kMgMg
ZZZZooook^k^gMgMMgMggMgM0^k^kP03MgMgc<c<c<co06W<c?l00`0006IV
VFIVV@04IVJI00?oooo<c?o<c?l02<c<o`030000IVJIIVJI00MVIYT00ooo
olc<olc<o`0=c<co00<0001VIYUVIYT02fIVV@03ooooc<coc<co00;<c?l2
IVJI00<0002IVLaVIYT0oiVIc9RIVL`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h6IVIc09VIYT00`0009VIc6IVV@05c<co00Kooolc<c?oooo^k^ig
MgL0<l`2<c<000Q4A4@c03<0029V06IgMgOooomgMgNk^k/5c<co0P000003
c<co0000000000;<c?l200000/c<o`800002c<co100000;<c?l200000lc<
o`800002c<co0P0000;<c?l5000000?<c?l0000000001<c<o`800004c<co
0P0000C<c?l5000000?<c?l0000000000/c<o`800002c<co0P0000;<c?l4
00001Lc<o`8000001<c<o`0000000<c<o`800008c<co00<0001VIYUVIYT0
0`000003IVJIooooc<co00W<c?l00`0006IVVFIVV@02IVJI10000003IVJI
ooooc<co00k<c?l00`0006IVVFIVV@0:000000=VIYWoooo<c?l00lc<o`9V
IYT00`0009VIc6IVV@3oVIW<V9VIc0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;PIVIW<0VIVV@030000VIW<IVJI00G<c?l04?ooogMgMnk^k^k^kVIV
IP1Vo`1Vc4A4A3<0<c<c<gMgMc<0<hR8R>k^kVIVI/c<c0G<c?l2000000?<
c?l0000000000/c<o`8000000lc<o`0000000002c<co0P0000;<c?l20000
00?<c?l0000000000lc<o`800002c<co0P000003c<co0000000000;<c?l2
000000?<c?l0000000001<c<o`800004c<co0P0000?<c?l200000/c<o`80
00000lc<o`0000000002c<co0P0000;<c?l2000000?<c?l0000000000/c<
o`800004c<co0P000004c<co00000000c<co0P0000S<c?l00`0006IVVOoo
o`02c<co00<0001VIYWoool02/c<o`050000IVJIIVJIIVJIoooo00?<c?l0
0`0006IVVOooo`0?c<co00<0001VIYW<c?l01lc<o`05ooooc<co0000IVJI
oooo00C<c?l2IVJI00<0002IVLaVIYT0oiVIc9RIVL`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@05c<co00Gooolc
<c?^k^kMgMdA4A400P1Vo`09<fK<8R8RR8R8VIVI8R8RgMgMk^k^MgMgc<c<
00G<c?l2000000?<c?l0000000000/c<o`8000000lc<o`0000000002c<co
0P0000G<c?l200000lc<o`800002c<co0P000003c<co0000000000;<c?l2
000000?<c?l0000000001<c<o`800004c<co0P0000?<c?l200000/c<o`80
00000lc<o`0000000002c<co0P0000;<c?l2000000?<c?l0000000006<c<
o`030000IVJIoooo00;<c?l00`0006IVVOooo`0:c<co00<0001VIYT00000
0VIVV@06ooooc<coc<co0000IVJIoooo3lc<o`060000IVJIc<coc<coIVJI
oooo0lc<o`06IVJIoooooooo0000IVJIoooo1<c<o`9VIYT00`0009VIc6IV
V@3oVIW<V9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIV
V@030000VIW<IVJI00G<c?l01_oooc<c<nk^kS<c<c<0<`004@8R8R80200c
<c<0<a40000003<c<k^k^gMgMk^k^`G<c?l2000000?<c?l0000000000/c<
o`8000000lc<o`0000000002c<co1P000003c<co0000000000?<c?l20000
0/c<o`800002c<co0P000004c<co00000000c<co0P0000C<c?l200001<c<
o`800004c<co0P000004c<co00000000c<co0P0000;<c?l200000/c<o`80
00000lc<o`000000000400005<c<o`030000IVJIoooo00;oool2IVJI00?o
ooo<c?o<c?l02<c<o`040000IVJIoooo00000VIVV@05ooooc<co0000IVJI
oooo00o<c?l0100006IVVLc<o`00009VIYT2oooo0fIVV@04c<co0000IVJI
oooo1<c<o`9VIYT00`0009VIc6IVV@3oVIW<V9VIc0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000VIW<IVJI00G<c?l04?ooogMg
MfHcIVHcIWMgMhR8R6IVIS<c000cc01Vc3<0IP0006HcIS<c<gMgMlc<c0G<
c?l2000000?<c?l0000000000/c<o`8000000lc<o`0000000002c<co0P00
00;<c?l2000000?<c?l0000000000lc<o`800002c<co0P0000?<c?l40000
00?<c?l0000000001<c<o`D000000lc<o`0000000005c<co10000003c<co
0000000000;<c?l200000/c<o`8000000lc<o`0000000002c<co0P0001C<
c?l00`0006IVVFIVV@04IVJI2lc<o`050000IVJIooooc<co0000009VIYT0
1?ooofIVVFIVVOooo`o<c?l01@0006IVVLc<olc<o`000005IVJI0/c<o`03
0000IVJIoooo00C<c?l2IVJI00<0002IVLaVIYT0oiVIc9RIVL`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h6IVIc09VIYT00`0009VIc6IVV@05c<co
00Wooom4A4@c03?<0<aV<fIVIVHA002IIP3<V@000P1Vc0:I09T00k^k^gMg
Mlc<c005c<co0P000005c<co000000000000c<co008000000lc<o`000000
0002c<co0P0000;<c?l2000000?<c?l0000000000lc<o`<000001Lc<o`00
00000<c<o`000003c<co0P000003c<co0000000000C<c?l200001<c<o`80
0003c<co00@0003<c?o<c?o<c?l2000000G<c?l000000000003<c?l00`00
0004c<co00000000c<co0P0000;<c?l200005<c<o`L000000lc<oooooooo
o`04oooo1<c<o`030000IVJIoooo00;<c?l00`0006IVVFIVV@02IVJI00?o
ooo<c?o<c?l03Lc<o`030000IVJIc<co00;<c?l01@0006IVVFIVVFIVVOoo
o`02c<co00<0001VIYWoool01<c<o`9VIYT00`0009VIc6IVV@3oVIW<V9VI
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<0VIVV@030000IVJI
IVJI00G<c?l01?oooc<c<lc<c4A4A08000002S<0<fIV0?o<09UV06H0I/`0
ofH0IVHcIWMgMk^k^`G<c?l2000000C<c?l00000003<c?l2000000?<c?l0
000000000P0000;<c?l400000/c<o`@000001<c<o`0000000<c<o`800003
c<co100000;<c?l200001<c<o`800004c<co100000;<c?l400000/c<o`80
00000lc<o`0000000002c<co0P0000?<c?l400007<c<o`030000IVJIIVJI
00=VIYT00oooolc<olc<o`02c<co00<0001VIYWoool00oooo`050000IVJI
IVJIIVJIoooo00;<c?l2oooo2lc<o`030000IVJIc<co00;<c?l4IVJI00Ko
ooo<c?o<c?l0001VIYWoool4c<co0VIVV@030000IVJIIVJI0?nIVLbHVIW<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`5IVJI1Lc<o`07oooo
MgMgk^k^k^k^8R8RV@2IIS=V009V06H01c<0<iUV014A4Lc<c>k^kWMgMlc<
c005c<co0P0000S<c?l200007<c<o`800004c<co0P0003c<c?l0100006IV
VFIVVFIVV@800005c<co00<0001VIYUVIYT01fIVV@;oool2IVJI00?oooo<
c?o<c?l02Lc<o`040000IVJIc<coc<co0fIVV@080000IVJIIVJIooooc<co
0000IVJIoooo1<c<o`EVIYWoVIW<V9VIc0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;PIVIW<1FIVV@G<c?l01_ooodA4A>k^kYVIVA4A4DA4A0;<0<`0
19T0V@0cI/bI07MgM`;^k^h00gMgMlc<c<c<o`04c<co0P0000W<c?l00`00
0<c<olc<o`0Jc<co0P0000C<c?l50000>Lc<o`050000IVJIIVJIIVJIoooo
00K<c?l900000VIVV@04ooooIVJIIVJIoooo2lc<o`040000IVJIc<co0000
0VIVV@;<c?l01`0006IVVFIVVLc<o`0006IVVOooo`04c<co1FIVVOnIVLbH
VIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`5IVJI1Lc<o`09
oooo<c<ck^k^MgMg<c<cIVIV<c<cc03<A4A40080<fH01GMgMnk^k^k^kWMg
Mk^k^`1ac<co00<0001VIYT000000VIVV@03ooooc<coc<co00c<c?l00`00
06IVVFIVV@02IVJI00?oooo<c?o<c?l02Lc<o`050000IVJIc<coc<co0000
00C<c?l01P000<c<olc<o`0006IVVOooo`C<c?l5IVJIoiVIc9RIVL`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc0EVIYT5c<co00?ooomgMgO^
k^h00nk^kP06^k^kIS=Vooook^k^VIVIR8R80^k^kP03MgMgc<c<c<co073<
c?l0100006IVVOooo`00009VIYT00oooolc<olc<o`0;c<co00?oool0001V
IYT00VIVV@03ooooc<coc<co00W<c?l00`0006IVVLc<o`09c<co0VIVV@03
ooooc<coc<co00;<c?l5IVJIoiVIc9RIVL`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6IVIc0EVIYT5c<co00?ooolc<c?oool02nk^kP03MgMgc<c<
c<co073<c?l200000/c<o`030000IVJIIVJI00c<c?l00`0006IVVFIVV@03
IVJI00?oooo<c?o<c?l02Lc<o`030000IVJIIVJI00]VIYT00oooolc<olc<
o`02c<co1FIVVOnIVLbHVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^1VIVL`5IVJI1Lc<o`03oooo<c<cMgMg00agMgL00oooolc<olc<o`1dc<co
00<0003<c?o<c?l02lc<o`H0000<c<co3P0000G<c?l5IVJIoiVIc9RIVL`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h6IVIc0EVIYVnc<co1FIVVOnI
VLbHVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1VIVL`5IVJI_/c<
o`EVIYWoVIW<V9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PIVIW<
1VIVVKc<c?l6IVJIoiVIc9RIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h6IVIc<QVIYWoVIW<V9VIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PIVIW<3fIVVJbIVL`=IVJIoiVIc9RIVL`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h6IVIc0iVIYV/00003VIVVOnIVLbHVIW<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^1VIVLc8IVJIoiVIc9RIVL`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h6IVIc003c<c<IVJIIVJI0<AVIYT00lc<c9VIc9VI
c03oVIW<UYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVI
c7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hoiVIc?nIVLajVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nI
VLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVI
c7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hoiVIc?nIVLajVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nI
VLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVI
c7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hoiVIc?nIVLajVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nI
VLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVI
c7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hoiVIc?nIVLajVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nI
VLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVI
c7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hoiVIc?nIVLajVIW<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nI
VLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVI
c7ZIVL`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;SoVIW<oiVIc7ZIVL`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hoiVIc?nIVLajVIW<0XS0^058T8P100000000
0hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PF00200`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X80
1X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@0
0`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<3
6hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=
12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5
:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9
AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YA
W@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]G
W`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW
3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mc
Z@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@
OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hA
Q:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H0
11BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ
_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P03
5k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P4002000>KYo4c@jDc@jD02C=3Y@H0080300600P02P00400:100>1
00>100>10`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP02
0@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@2
4HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<G
R0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;
0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>
00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_
T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87
=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8
?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9
A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK
0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]D
WP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP
00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R
3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>
JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X
3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ
0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<A
PJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`
0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[80
0a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<C
UKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL0
11FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj
0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]
_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008001i^WlOooohij]ZJK
a;>YdZRMb;>YdP02YY_400Fl^=g^k_CZjO7ooolc@jD01@00P0<00H0200:0
00@00X400h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N2
0@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<2
3hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ8
0aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:
0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<5
9hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@
0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=980
0`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7
>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL0
10U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ
0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]C
W@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP
0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82
366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=
Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL2
3W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ
0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o
[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_
0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb
4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<C
Tk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL3
59bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i
0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/
_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o
0aNc_`8H]<0P00000QRd`10000026;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^080080019^WlOooofaJYJnUbP:l^=d02_omok>Yd_oooooookbh
gIN:_:RMb>KVk?oooc=3Y@@0080300600P02P00400:100>100>100>10`04
P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<1
2X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=Q8T8Q8
T8P034R@R0030000b>3HB92800e8T8P0100001Rd`1Rd`<SPf0i8T8P00`00
01Rd`1Rd`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00;VjOa
ooooZ9g8oooo/jWBH4bJSWZfN6F^Z9g8oooooogo00?oool00c=3Y@00P000
P00300200`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X80
1X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@0
0`4<Q0<13H@30@j50`8?Q@8248D3oooo0P8AQP<24XH20Q>600@24hL258L2
58L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@3
6XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@T
S@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZ
S`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y40
10HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`Lh
T`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G
246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6
V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:
DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;
Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ42
35nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS
00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH0
10i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?
LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m
[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P03
4HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[43
4X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c
0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH2
59Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^003
5J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY
_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G
/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8
T8P00038h=P03HS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd
`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000jKYo7ooooo
oooKg>aPC9ZCQKZcZM:l^=ePC9ZISkjVVlC8`moooolc@jD600200oooo`80
0X000`02POooooooo`02oooo0P04P@0300F1oooo00F200<01X84oooo00<1
288128?oool00oooo`<12X<01_ooo`4;Q04;Q04<Q?ooo`4<Q0813H@01?oo
o`4>QOooo`4>Q@823hD01?ooo`8@QOooo`8@Q@824HH00oooo`8AQP8BQP02
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000C8
h=R8`;R8`;R8`;P6000018S0^003B9280000b>3H00:8`;P900000XS0^005
B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P3002000jKYo7ooonl^=fISkkooooFdMgKg>cc
o_nVVlC^k_B5M[2CQK[ooolc@jD4002000Ooool00H000H000H3oool00X3o
ool00`03P@06oooo00B100B100F1oooo00F20P06PP08oooo00N200N20@N2
oooo0@R2oooo0@R30`49P`04oooo0@Z30@Z3oooo0P4;Q0030@b4oooo0@b4
00813H@01?ooo`4>QOooo`4>Q@823hD00oooo`8@QOooo`03oooo0P8AQP<2
4XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<H
R0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;
0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DX
SP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A
1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP02
1cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8
?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4
V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK
0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN
00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aL
X@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=
HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>
JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?
LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[
0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61
[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`
00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb
4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<D
U[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh
5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj
0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G
[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<001<SP
f8S0^8S0^8S0^0H00004R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h
00F8`;P01@0008S0^8S0^4R@R00000026;C000C8h=R8`;R8`;R8`;P20000
18S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0`00P00?VjOaooooVHnnUhZle=?XkjbcogIkkYn[FeRUYY_4
UYoBH4bJ_;SMoooo<d>U00<008001oooo`01P001P001P?ooo`02P?ooo`03
00>100Koool01840187oool01H7oool200J200Soool01h801h811h;oool1
28;oool128<30@V300Woool12X?oool12h?oool12hCoool138Coool00P4=
Q004oooo0@j5oooo0@j50P8?Q@04oooo0Q25oooo0Q25108AQP<24XH20Q>6
00@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV8
0aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@4
8h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh0
0`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A
0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`Lf
T`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF
0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP0
0`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:
Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh3
2eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aM
X@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeR
X`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V
0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP3
3g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@
Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P03
4H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4B
R[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb
008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne
11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh
5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<F
Yk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG
[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0
^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0
^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h0P0000>8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
002000ZKYo7ooonGR[ajK:ZcanRYKZ38`mnCQKYKAY>ISkh2N6F^00A29hF_
YL[ooolc@jD400200`01P003oooo00:000:100Coool200B100?oool01H7o
ool00`06PPCoool00`48PP48P`48P`030@V300Woool12X?oool12h?oool1
2hCoool138Coool00P4=Q004oooo0@j5oooo0@j50P8?Q@03oooo0Q25oooo
00?oool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP3
5hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX3
11n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DW
S@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y02
1Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP03
1cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`Lk
U@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`04
2D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX3
2T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M
00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ03
35^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<
HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eW
Y0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>
L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX3
3gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]
0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl3
4XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8B
SK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C
]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<D
W;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T3
5J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm
0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l3
5k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028
`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^003
R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2002000>KYo7oooooool00_ooo`0:ojf`ogIknLgDoNg^oooo
YY_4QGJ`_;SMoooo<d>U1@00P0<00H000oooo`02P002P@0300>100?oool0
187oool00P05P@0400F2oooo00J200J20P07PP030@N2oooo0@R2008128<3
oooo0P4:P`07oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?ooo`4>QOoo
ooooo`823hD01_ooo`8@QOooo`8@Q@8AQ_ooo`824HH30Q:60P8CQP040Q>7
0QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<I
R@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@4
98`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5
:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I42
1S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC
00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H0
10Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9
AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@
W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP03
2eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ43
35jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S
0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H2
3VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ003
3g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l
[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<A
Pjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa
4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc
0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H3
59Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<E
WkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX
^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G
[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0
^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8
T8P000000QRd`003b>3HR<2hR<2h00B8`;P200001HS0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008002Z6/l_W=e>8V
??Be_n8V??A]OOcSjOoooog]k_n]/0;oool00c=3Y@00P000P00400200`01
P003oooo00:000:100?oool200B100Goool01H401H401H;oool00P06PP?o
ool20@R200<128?oool12H<00P49P`812X<01?ooo`4;P`4;Q?ooo`8138@0
1oooo`4=Q04=Q?ooo`4>QOooo`4>Q@02oooo00<23hD248D248D01?ooo`04
0Q660Q:60Q:60Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<4
7h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=
1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086
;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7
=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9
@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:
BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<
Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`
Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?
MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd3
4H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<B
Qk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d
0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL
]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d2
5jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G
/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0
^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8
`;P4000018S0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_ARK_omoon]/?cS
jOoooc=3Y@0700200`01P003oooo00:000:100<00h4300B10P05P@0400F2
00J200J200J20P07PP050@N20@R20@R2oooo0@R300<12H<30@Z300<12h<1
2h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8D
Q`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT0
10<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<
12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?
1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHb
T@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`03
1cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8
@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI
2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`0
10YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]G
WP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aN
X@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=
I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]
YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mc
Z0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`4
47f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^
00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::
/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<C
T;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI
]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh
00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/3
5ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn
0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P0
0dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB928
0000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008000i^W
lOK8c>8V?002ojf`00OO92koY9kf_<Go[K3^Nhcooolc@jD02000P0<00H00
0oooo`02P002P@0300>10`04P@801H401005PP06PP06PP06PP801h801@47
PP48PP48P_ooo`48P`030@V300Coool12X<12X<12h<20@^40`4<Q0<13H@3
0@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ7
00@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<M
RP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<5
9Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]
T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B
0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@3
1cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G
0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9
VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;
DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]I
W`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaP
XPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY003
3FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW
0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`me
Z@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@
Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65
[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8B
SK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@C
T[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK
]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ
^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m
5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o
00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h
2@0000:8`;P01DR@R00001Rd`1Rd`<SPf003R<2h0P0000B8`;P200000XS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08000i^WlOW=e?N9U`02oooo00Oo[K3Q5SCoMW_oY9kR9ScoRGlc@jD02000
P0<00H000oooo`02P002P@0300>10`04P@801H401005PP06PP06PP06PP80
1h801047PP48PP48PP48P`Coool30@Z300<12h<12h@12h@00`4<Q0813H@0
1?ooo`4>Q@4>Q@4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L2
58L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT3
0a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@T
S@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`03
1B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010Hb
TPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`Lh
U0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G
246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@04
2DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:
DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;
Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ
00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=
IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]
Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?
LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[004
47j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^
4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a
0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A
/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf
00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h
5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@F
Z[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h0
0aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P0
0038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008001i^W
lOoooo>P[_ARK_ooooN9UoW=e002oooo00?cX:kooolc@jD02000P0<00H02
00:000@00X400h400h400h4300B10P05P@0400F200J200J200J20P07PP03
0@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>
Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`04
0aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX3
11j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=
00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I03
1Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86
=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`Lj
U0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88
@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX3
2DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M
0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl3
35ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<
H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eV
Y0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>
KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT3
3gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]
0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl4
4HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb
4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d
00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLD
VkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT3
5J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[
_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`03
5k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P03HS0^005
B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P3002000^KYo7oooooRGooooocX:kaTj7ooooo
oOocX:kono`c@jD02000P0<00H0200:000@00X400h400h400h4300B10P05
P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V30`4:P`03
0@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@2
4hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV9
0aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`0
10@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZ
SPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`Ha
T@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7
=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0
UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6
V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`4
2U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN
00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aM
X@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=
Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/
YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X
00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/3
47b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^
0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4B
R[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008C
Sk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH
]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh
0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/3
5ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<0?b>3H00<00038h=S8
h=P03LSPf00300006;C06;C000o8h=P00`0001Rd`1Rd`002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h1000P0>KYo401_oooo>P[_Be_oJlaO_IfS=3
Y@T0080300600P02P00400:100>100>100>10`04P@801H401005PP06PP06
PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q003
0@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<K
R@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d4
9Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[
S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO
00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y
00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n
[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64
[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P04
59Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl
00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G
/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P10000000018S0^<SPf8S0
^8S0^1H0080300600P02P00400:100>100>100>10`04P@801H401005PP06
PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;
Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB7
0QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ9
0`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d4
98d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl0
0`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6
<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7
>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1
U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT0
10U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L
2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO
2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaO
X@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`03
3FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>
KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y
3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0
111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64
[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;
/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<C
TK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ
]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP
^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`4
5ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n
00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P1000000000hS0^<SP
f8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8
`;QmR<2h0DR@R04000000003R<2hb>3Hb>3H0?o8h=Sob>3HOLSPf058T8P1
0000003oR<2hohS0^868`;P100000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?oo
l?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`
l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003o
oo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;o
l?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000oolXG;Oo
obQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2obQL]`00
oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2
obQL]`00oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bg
oolXG;N2obQL]`00oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L0
0?oo:5bgoolXG;N2obQL]`00oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bg
P_lXG;L00?oo:5bgoolXG;N2obQL]`00oolXG;OoobQL]h;o:5bg003oobQL
]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2obQL]`00oolXG;OoobQL]h;o:5bg
003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2obQL]`00oolXG;OoobQL
]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2obQL]`00oolX
G;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2obQL
]`00oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolX
G;N2obQL]`00oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo
:5bgoolXG;N2obQL]`00oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lX
G;L00?oo:5bgoolXG;N2obQL]`00oolXG;OoobQL]h;o:5bg003oobQL]ooo
:5bgP_lXG;L00?oo:5bgoolXG;N2obQL]`00oolXG;OoobQL]h;o:5bg003o
obQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2obQL]`00oolXG;OoobQL]h;o
:5bg001mobQL]lSoRXZ:oolXG;LlobQL]`00OOlXG;O8ogmoOooo:5bg??lX
G;L007go:5bg00?oOgmoooooooooool0]Oooool00ooIfMWoooooooooo`0<
ooooo`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L007go:5bg00?oOgmooooo
ooooool0]Oooool01?oIfMWooooooooooooUiND3ooooo`05onGUiOoooooo
oooooooooooUiND00oooool00omoOgoo:5bgobQL]`3oobQL]c[o:5bg001m
obQL]`03ogmoOooooooooooo0;Gooooo00gofMWIoooooooJf][oSHf=onGU
iOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo00?oOgmo
obQL]olXG;L0oolXG;LjobQL]`00OOlXG;L00omoOgooooooooooo`2eoooo
o`0@omWIfOooooooooooom[Jf_n=SHgoiNGUoooooooJf][oSHf=onGUiOoo
oooof][Johf=SOoUiNGoooooogmoOooo:5bg??lXG;L007go:5bg00?oOgmo
ooooooooool0]Oooool03OoIfMWooooooooooooooooof][Johf=SOoUiNGo
ooooom[Jf_n=SHgoiNGUoooooooJf]X00_ooool00omoOgoo:5bgobQL]`3o
obQL]c[o:5bg001mobQL]`03ogmoOooooooooooo0;Gooooo00?ofMWIoooo
ooooool00_ooool01ooJf][oSHf=onGUiOoooooof][Johf=SOoUiND00ooo
ool00omoOgoo:5bgobQL]`3oobQL]c[o:5bg001mobQL]`03ogmoOooooooo
oooo0;Gooooo00?ofMWIooooooooool00oooool01ooJf][oSHf=onGUiOoo
oooof][Johf=SOoUiND00_ooool00omoOgoo:5bgobQL]`3oobQL]c[o:5bg
001mobQL]`03ogmoOooooooooooo0;Gooooo00?ofMWIooooooooool01?oo
ool02OoJf][oSHf=onGUiOoooooog=cLohf=SOoUiNGoooooogmoO`3oobQL
]cco:5bg001mobQL]`03ogmoOooooooooooo0;Gooooo00?ofMWIoooooooo
ool01Oooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo00?oOgmoobQL
]olXG;L0oolXG;LjobQL]`00OOlXG;L00omoOgooooooooooo`2eooooo`03
omWIfOoooooooooo00Kooooo00?og=cLohf=SOoUiND00oooool00omoOgoo
:5bgobQL]`3oobQL]c[o:5bg001mobQL]`03ogmoOooooooooooo0;Gooooo
00?ofMWIooooooooool01oooool00ooLg=coSHf=onGUi@02ooooo`03ogmo
OolXG;Oo:5bg0?oo:5bg>_lXG;L007go:5bg00?oOgmoooooooooool0]Ooo
ool00ooIfMWoooooooooo`08ooooo`05omcLg?n=SHgoiNGUoooooomoOgl0
oolXG;LlobQL]`00OOlXG;L00omoOgooooooooooo`2eooooo`03omWIfOoo
oooooooo00Wooooo00Cog=cLooooooooooooOgmooolXG;LlobQL]`00OOlX
G;L00omoOgooooooooooo`2eooooo`03omWIfOoooooooooo00cooooo00?o
OgmoobQL]olXG;L0oolXG;LjobQL]`00OOlXG;L00omoOgooooooooooo`2e
ooooo`oofMWI00?oOgmoobQL]olXG;L0oolXG;LjobQL]`00OOlXG;L00omo
Ogooooooooooo`34ooooo`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L007go
:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoo:5bgobQL]`3oobQL]c[o
:5bg001mobQL]`03ogmoOooVi^Koi^KV0<Coi^KV00?oOgmoobQL]olXG;L0
oolXG;LjobQL]`00OOlXG;L00omoOgook^k^onk^kP34onk^kP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L007go:5bg00?oOgmoooooooooool0a?ooool0
0omoOgoo:5bgobQL]`3oobQL]c[o:5bg001mobQL]`03ogmoOoo^k^kok^k^
0<Cok^k^00?oOgmoobQL]olXG;L0oolXG;LjobQL]`00OOlXG;L00omoOgoo
i^KVonKViP34onKViP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L007go:5bg
00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoo:5bgobQL]`3oobQL]c[o:5bg
001TobQL]aWoRXZ:00?oOgmoooooooooool0a?ooool00omoOgoo:5bgobQL
]`3oobQL]c[o:5bg001TobQL]a[oOgmoa_o^k^h00omoOgoo:5bgobQL]`3o
obQL]c[o:5bg001TobQL]`03ogmoOooooooooooo01Kooooo00?oOgmoonKV
i_oVi^H0a?oVi^H00omoOgoo:5bgobQL]`3oobQL]c[o:5bg001TobQL]`03
ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoo
:5bgobQL]`3oobQL]c[o:5bg001TobQL]`03ogmoOooooooooooo01Kooooo
00?oOgmoooooooooool0a?ooool00omoOgoo:5bgobQL]`3oobQL]c[o:5bg
001TobQL]`03ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^k^h0a?o^
k^h00omoOgoo:5bgobQL]`3oobQL]c[o:5bg001TobQL]`03ogmoOooooooo
oooo01Kooooo00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgoo:5bgobQL]`3o
obQL]c[o:5bg001TobQL]`03ogmoOooooooooooo01Kooooo00?oOgmoonk^
k_o^k^h0a?o^k^h00omoOgoo:5bgobQL]`3oobQL]c[o:5bg001TobQL]`03
ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgoo
:5bgobQL]`3oobQL]c[o:5bg001TobQL]`03ogmoOooooooooooo01Kooooo
00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoo:5bgobQL]`3oobQL]c[o:5bg
001TobQL]`03ogmoOooooooooooo01Kooooo00?oOgmoonKVi_oVi^H0a?oV
i^H00omoOgoo:5bgobQL]`3oobQL]c[o:5bg001TobQL]`03ogmoOooooooo
oooo01Kooooo00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoo:5bgobQL]`3o
obQL]c[o:5bg001TobQL]`03ogmoOooooooooooo01Kooooo00?oOgmooooo
ooooool0a?ooool00omoOgoo:5bgobQL]`3oobQL]c[o:5bg001TobQL]`03
ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoo
:5bgobQL]`3oobQL]c[o:5bg001TobQL]`03ogmoOooooooooooo01Kooooo
00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgoo:5bgobQL]`3oobQL]c[o:5bg
001TobQL]`03ogmoOooooooooooo01Kooooo00?oOgmoonk^k_o^k^h0a?o^
k^h00omoOgoo:5bgobQL]`3oobQL]c[o:5bg001TobQL]`03ogmoOooooooo
oooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgoo:5bgobQL]`3o
obQL]c[o:5bg001TobQL]`03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^
k_o^k^h0a?o^k^h00omoOgoo:5bgobQL]`3oobQL]c[o:5bg001TobQL]`03
ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgoo
:5bgobQL]`3oobQL]c[o:5bg001TobQL]`03ogmoOoo^k^kok^k^01Kok^k^
00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoo:5bgobQL]`3oobQL]c[o:5bg
001TobQL]`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?oo
ool00omoOgoo:5bgobQL]`3oobQL]c[o:5bg001TobQL]`03ogmoOoo^k^ko
k^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoo:5bgobQL]`3o
obQL]c[o:5bg001TobQL]`03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKV
i_oVi^H0a?oVi^H00omoOgoo:5bgobQL]`3oobQL]c[o:5bg001TobQL]`03
ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoo
:5bgobQL]`3oobQL]c[o:5bg001TobQL]`03ogmoOooooooooooo01Kooooo
00?oOgmoooooooooool0a?ooool00omoOgoo:5bgobQL]`3oobQL]c[o:5bg
001;obQL]aWoRXZ:00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^
kP34onk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L004_o:5bg6_moOglH
onKViP03ogmoOooVi^Koi^KV0<Coi^KV00?oOgmoobQL]olXG;L0oolXG;Lj
obQL]`00BolXG;L00omoOgooooooooooo`0Fooooo`03ogmoOoo^k^kok^k^
01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoo:5bgobQL]`3oobQL
]c[o:5bg001;obQL]`03ogmoOooooooooooo01Kooooo00?oOgmooooooooo
ool05_ooool00omoOgooooooooooo`34ooooo`03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L004_o:5bg00?oOgmoooooooooool05_ooool00omoOgook^k^
onk^kP0Fonk^kP03ogmoOoo^k^kok^k^0<Cok^k^00?oOgmoobQL]olXG;L0
oolXG;LjobQL]`00BolXG;L00omoOgooooooooooo`0Fooooo`03ogmoOooV
i^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgoo:5bgobQL
]`3oobQL]c[o:5bg001;obQL]`03ogmoOooooooooooo01Kooooo00?oOgmo
onk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP34onk^kP03ogmoOolXG;Oo
:5bg0?oo:5bg>_lXG;L004_o:5bg00?oOgmoooooooooool05_ooool00omo
Ogooooooooooo`0Fooooo`03ogmoOooooooooooo0<Cooooo00?oOgmoobQL
]olXG;L0oolXG;LjobQL]`00BolXG;L00omoOgooooooooooo`0Fooooo`03
ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoo
:5bgobQL]`3oobQL]c[o:5bg001;obQL]`03ogmoOooooooooooo01Kooooo
00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP34onKViP03ogmo
OolXG;Oo:5bg0?oo:5bg>_lXG;L004_o:5bg00?oOgmoooooooooool05_oo
ool00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^0<Cok^k^00?o
OgmoobQL]olXG;L0oolXG;LjobQL]`00BolXG;L00omoOgooooooooooo`0F
ooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool0
0omoOgoo:5bgobQL]`3oobQL]c[o:5bg001;obQL]`03ogmoOooooooooooo
01Kooooo00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP34onk^
kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L004_o:5bg00?oOgmooooooooo
ool05_ooool00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV0<Co
i^KV00?oOgmoobQL]olXG;L0oolXG;LjobQL]`00BolXG;L00omoOgoooooo
ooooo`0Fooooo`03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0
a?o^k^h00omoOgoo:5bgobQL]`3oobQL]c[o:5bg001;obQL]`03ogmoOooo
oooooooo01Kooooo00?oOgmoooooooooool05_ooool00omoOgoooooooooo
o`34ooooo`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L004_o:5bg00?oOgmo
ooooooooool05_ooool00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^ko
k^k^0<Cok^k^00?oOgmoobQL]olXG;L0oolXG;LjobQL]`00BolXG;L00omo
Ogooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKV
i_oVi^H0a?oVi^H00omoOgoo:5bgobQL]`3oobQL]c[o:5bg001;obQL]`03
ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgoo
k^k^onk^kP34onk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L004_o:5bg
00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03ogmo
Oooooooooooo0<Cooooo00?oOgmoobQL]olXG;L0oolXG;LjobQL]`00BolX
G;L00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgoo:5bgobQL]`3oobQL]c[o:5bg001;
obQL]`03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H05_oVi^H0
0omoOgooi^KVonKViP34onKViP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
04_o:5bg00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^
kP03ogmoOoo^k^kok^k^0<Cok^k^00?oOgmoobQL]olXG;L0oolXG;LjobQL
]`00BolXG;L00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Ko
oooo00?oOgmoooooooooool0a?ooool00omoOgoo:5bgobQL]`3oobQL]c[o
:5bg001;obQL]`03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h0
5_o^k^h00omoOgook^k^onk^kP34onk^kP03ogmoOolXG;Oo:5bg0?oo:5bg
>_lXG;L003;o:5bg6On:RXX00omoOgooi^KVonKViP0FonKViP03ogmoOooV
i^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgoo:5bgobQL
]`3oobQL]c[o:5bg000bobQL]a[oOgmo6?o^k^h00omoOgook^k^onk^kP0F
onk^kP03ogmoOoo^k^kok^k^0<Cok^k^00?oOgmoobQL]olXG;L0oolXG;Lj
obQL]`00<_lXG;L00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo
01Kooooo00?oOgmoooooooooool05_ooool00omoOgooooooooooo`34oooo
o`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L003;o:5bg00?oOgmooooooooo
ool05_ooool00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Ko
k^k^00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoo:5bgobQL]`3oobQL]c[o
:5bg000bobQL]`03ogmoOooooooooooo01Kooooo00?oOgmoonKVi_oVi^H0
5_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV0<Coi^KV
00?oOgmoobQL]olXG;L0oolXG;LjobQL]`00<_lXG;L00omoOgoooooooooo
o`0Fooooo`03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^
k^h00omoOgook^k^onk^kP34onk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lX
G;L003;o:5bg00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0F
ooooo`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool0
0omoOgoo:5bgobQL]`3oobQL]c[o:5bg000bobQL]`03ogmoOooooooooooo
01Kooooo00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^
kP03ogmoOoo^k^kok^k^0<Cok^k^00?oOgmoobQL]olXG;L0oolXG;LjobQL
]`00<_lXG;L00omoOgooooooooooo`0Fooooo`03ogmoOooVi^Koi^KV01Ko
i^KV00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP34onKViP03
ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L003;o:5bg00?oOgmoooooooooool0
5_ooool00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^
00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoo:5bgobQL]`3oobQL]c[o:5bg
000bobQL]`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_oo
ool00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo0<Cooooo00?o
OgmoobQL]olXG;L0oolXG;LjobQL]`00<_lXG;L00omoOgooooooooooo`0F
ooooo`03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP34onk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
03;o:5bg00?oOgmoooooooooool05_ooool00omoOgooi^KVonKViP0FonKV
iP03ogmoOooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omo
Ogoo:5bgobQL]`3oobQL]c[o:5bg000bobQL]`03ogmoOooooooooooo01Ko
oooo00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03
ogmoOoo^k^kok^k^0<Cok^k^00?oOgmoobQL]olXG;L0oolXG;LjobQL]`00
<_lXG;L00omoOgooooooooooo`0Fooooo`03ogmoOooooooooooo01Kooooo
00?oOgmoooooooooool05_ooool00omoOgooooooooooo`34ooooo`03ogmo
OolXG;Oo:5bg0?oo:5bg>_lXG;L003;o:5bg00?oOgmoooooooooool05_oo
ool00omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgoo:5bgobQL]`3oobQL]c[o:5bg000b
obQL]`03ogmoOooooooooooo01Kooooo00?oOgmoonKVi_oVi^H05_oVi^H0
0omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV0<Coi^KV00?oOgmo
obQL]olXG;L0oolXG;LjobQL]`00<_lXG;L00omoOgook^k^onk^kP0Fonk^
kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omo
Ogook^k^onk^kP34onk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L003;o
:5bg00?oOgmoooooooooool05_ooool00omoOgooooooooooo`0Fooooo`03
ogmoOooooooooooo01Kooooo00?oOgmoooooooooool0a?ooool00omoOgoo
:5bgobQL]`3oobQL]c[o:5bg000bobQL]`03ogmoOoo^k^kok^k^01Kok^k^
00?oOgmoonk^k_o^k^h05_o^k^h00omoOgook^k^onk^kP0Fonk^kP03ogmo
Ooo^k^kok^k^0<Cok^k^00?oOgmoobQL]olXG;L0oolXG;LjobQL]`00<_lX
G;L00omoOgooi^KVonKViP0FonKViP03ogmoOooVi^Koi^KV01Koi^KV00?o
OgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP34onKViP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L003;o:5bg00?oOgmoonk^k_o^k^h05_o^k^h0
0omoOgook^k^onk^kP0Fonk^kP03ogmoOoo^k^kok^k^01Kok^k^00?oOgmo
onk^k_o^k^h0a?o^k^h00omoOgoo:5bgobQL]`3oobQL]c[o:5bg000bobQL
]`03ogmoOooooooooooo01Kooooo00?oOgmoooooooooool05_ooool00omo
Ogooooooooooo`0Fooooo`03ogmoOooooooooooo0<Cooooo00?oOgmoobQL
]olXG;L0oolXG;LjobQL]`00<_lXG;L00omoOgook^k^onk^kP0Fonk^kP03
ogmoOoo^k^kok^k^01Kok^k^00?oOgmoonk^k_o^k^h05_o^k^h00omoOgoo
k^k^onk^kP34onk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L003;o:5bg
00?oOgmoonKVi_oVi^H05_oVi^H00omoOgooi^KVonKViP0FonKViP03ogmo
OooVi^Koi^KV01Koi^KV00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgoo:5bg
obQL]`3oobQL]c[o:5bg000IobQL]lSoRXZ:Hoo^k^h00omoOgoo:5bgobQL
]`3oobQL]c[o:5bg000IobQL]lSoOgmoHoooool00omoOgoo:5bgobQL]`3o
obQL]c[o:5bg000IobQL]`03ogmoOooooooooooo0;Gooooo00?ofMWIoooo
ooooool03?ooool00omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg
0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoooooooooool0]Oooool01?oIfMWo
oooooooooooUiND3ooooo`05onGUiOoooooooooooooooooUiND00oooool0
0omoOgooi^KVonKViP1QonKViP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoooooooooool0]Oooool03OoIfMWoooooom[Jf_n=SHgo
iNGUoooooooJf][oSHf=onGUiOoooooof][Johf=SOoUiND00_ooool00omo
Ogook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo
:5bg00?oOgmoooooooooool0]Oooool04?oIfMWooooooooooooJf][oSHf=
onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGUoooooomoOgmS
ooooo`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmooooo
ooooool0]Oooool03OoIfMWooooooooooooooooof][Johf=SOoUiNGooooo
om[Jf_n=SHgoiNGUoooooooJf]X00_ooool00omoOgook^k^onk^kP1Qonk^
kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmooooooooo
ool0]Oooool00ooIfMWoooooooooo`02ooooo`07om[Jf_n=SHgoiNGUoooo
oooJf][oSHf=onGUi@03ooooo`03ogmoOooVi^Koi^KV067oi^KV00?oOgmo
obQL]olXG;L0oolXG;LjobQL]`006OlXG;L00omoOgooooooooooo`2eoooo
o`03omWIfOoooooooooo00?ooooo00Oof][Johf=SOoUiNGoooooom[Jf_n=
SHgoiNGU00;ooooo00?oOgmoonk^k_o^k^h0HOo^k^h00omoOgoo:5bgobQL
]`3oobQL]c[o:5bg000IobQL]`03ogmoOooooooooooo0;Gooooo00?ofMWI
ooooooooool01?ooool02OoJf][oSHf=onGUiOoooooog=cLohf=SOoUiNGo
ooooogmoO`1Sooooo`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg
00?oOgmoooooooooool0]Oooool00ooIfMWoooooooooo`05ooooo`05om[J
f_n=SHgoiNGUoooooooLg=`00_ooool00omoOgook^k^onk^kP1Qonk^kP03
ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoooooooooool0
]Oooool00ooIfMWoooooooooo`06ooooo`03omcLg?n=SHgoiNGU00?ooooo
00?oOgmoonKVi_oVi^H0HOoVi^H00omoOgoo:5bgobQL]`3oobQL]c[o:5bg
000IobQL]`03ogmoOooooooooooo0;Gooooo00?ofMWIooooooooool01ooo
ool00ooLg=coSHf=onGUi@02ooooo`03ogmoOoo^k^kok^k^067ok^k^00?o
OgmoobQL]olXG;L0oolXG;LjobQL]`006OlXG;L00omoOgooooooooooo`2e
ooooo`03omWIfOoooooooooo00Sooooo00Gog=cLohf=SOoUiNGoooooogmo
O`1Sooooo`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmo
ooooooooool0]Oooool00ooIfMWoooooooooo`09ooooo`04omcLg?oooooo
ooooogmoOf?ok^k^00?oOgmoobQL]olXG;L0oolXG;LjobQL]`006OlXG;L0
0omoOgooooooooooo`2eooooo`03omWIfOoooooooooo00cooooo00?oOgmo
onKVi_oVi^H0HOoVi^H00omoOgoo:5bgobQL]`3oobQL]c[o:5bg000IobQL
]`03ogmoOooooooooooo0;Gooooo3ooIfMT00omoOgook^k^onk^kP1Qonk^
kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmooooooooo
ool0a?ooool00omoOgooooooooooo`1Qooooo`03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^
onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
OgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP1QonKViP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`1Qoooo
o`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^
k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KV
onKViP1QonKViP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoooooooooool0a?ooool0
0omoOgooooooooooo`1Qooooo`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^
kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oV
i^H0a?oVi^H00omoOgooi^KVonKViP1QonKViP03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^
onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoooooooooool0a?ooool00omoOgooooooooooo`1Qooooo`03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP1QonKV
iP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^
k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoooooooooool0a?ooool00omoOgoooooo
ooooo`1Qooooo`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H0
0omoOgooi^KVonKViP1QonKViP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^
kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmooooooooo
ool0a?ooool00omoOgooooooooooo`1Qooooo`03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^
onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
OgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP1QonKViP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`1Qoooo
o`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^
k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KV
onKViP1QonKViP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoooooooooool0a?ooool0
0omoOgooooooooooo`1Qooooo`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^
kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oV
i^H0a?oVi^H00omoOgooi^KVonKViP1QonKViP03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^
onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoooooooooool0a?ooool00omoOgooooooooooo`1Qooooo`03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP1QonKV
iP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^
k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoooooooooool0a?ooool00omoOgoooooo
ooooo`1Qooooo`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H0
0omoOgooi^KVonKViP1QonKViP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^
kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmooooooooo
ool0a?ooool00omoOgooooooooooo`1Qooooo`03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^
onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
OgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP1QonKViP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`1Qoooo
o`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^
k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KV
onKViP1QonKViP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoooooooooool0a?ooool0
0omoOgooooooooooo`1Qooooo`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^
kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oV
i^H0a?oVi^H00omoOgooi^KVonKViP1QonKViP03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^
onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoooooooooool0a?ooool00omoOgooooooooooo`1Qooooo`03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP1QonKV
iP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^
k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoooooooooool0a?ooool00omoOgoooooo
ooooo`1Qooooo`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H0
0omoOgooi^KVonKViP1QonKViP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^
kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmooooooooo
ool0a?ooool00omoOgooooooooooo`1Qooooo`03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^
onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
OgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP1QonKViP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`1Qoooo
o`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^
k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KV
onKViP1QonKViP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoooooooooool0a?ooool0
0omoOgooooooooooo`1Qooooo`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^
kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oV
i^H0a?oVi^H00omoOgooi^KVonKViP1QonKViP03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^
onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoooooooooool0a?ooool00omoOgooooooooooo`1Qooooo`03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP1QonKV
iP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^
k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoooooooooool0a?ooool00omoOgoooooo
ooooo`1Qooooo`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H0
0omoOgooi^KVonKViP1QonKViP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^
kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmooooooooo
ool0a?ooool00omoOgooooooooooo`1Qooooo`03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^
onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
OgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP1QonKViP03ogmoOolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`1Qoooo
o`03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^
k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ogmoOolXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KV
onKViP1QonKViP03ogmoOolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03oh61POlX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoooooooooool0a?ooool0
0omoOgooooooooooo`1Qooooo`03ohB4Q?lXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^
kP03ohJ6Q_lXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oV
i^H0a?oVi^H00omoOgooi^KVonKViP1QonKViP03ohV9ROlXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^
onk^kP1Qonk^kP03oh^;RolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoooooooooool0a?ooool00omoOgooooooooooo`1Qooooo`03ohj>S_lX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP1Qonk^kP03oi2@T?lXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP1QonKV
iP03oi>CTolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^
k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03oiFEUOlXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoooooooooool0a?ooool00omoOgoooooo
ooooo`1Qooooo`03oiRHV?lXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03oiZJV_lX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H0
0omoOgooi^KVonKViP1QonKViP03oifMWOlXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^
kP03oinOWolXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmooooooooo
ool0a?ooool00omoOgooooooooooo`1Qooooo`03oj:RX_lXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^
onk^kP1Qonk^kP03ojBTY?lXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
OgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP1QonKViP03ojNWYolX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h0
0omoOgook^k^onk^kP1Qonk^kP03ojVYZOlXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`1Qoooo
o`03ojb/[?lXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonk^k_o^
k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ojj^[_lXG;Oo:5bg0?oo
:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KV
onKViP1QonKViP03ok6a/OlXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^kP03ok>c/olX
G;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoooooooooool0a?ooool0
0omoOgooooooooooo`1Qooooo`03okJf]_lXG;Oo:5bg0?oo:5bg>_lXG;L0
01Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP1Qonk^
kP03okRh^?lXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg00?oOgmoonKVi_oV
i^H0a?oVi^ITogmoO`03ok^k^olXG;Oo:5bg0?oo:5bg>_lXG;L001Wo:5bg
00?oOgmoonk^k_o^k^h0a?o^k^h0F?moOgooh>3Qon7QhOoPh>3ohN7Qon3P
h?oQhN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>3ohN7Q
on3PhOoQhN7oh>3Pon7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3Qon7QhOoPh>3o
hN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7oh>3Pon7QhOoP
h>3ohN7Qon3PhOoQhN7oh>3Pon7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3Qon7Q
hOoPh>3ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7oh>3P
on7QhOoPh>3ohN7Qon3PhOoQhN7oh>3Pon7QhOoPh>3ohN7Qon3Ph?oQhN7o
h>3Qon7QhOo4a<Co/;gCojnld_n`_M?o[kcBok2mdon__=?o/;gCojnld_n`
_M?o[kcBok2mdon__=83ok2md`03ojnld_n`_M?o/;gC00?o[kcB00Co/[oE
okO4f_nia]co_KfmoolXG;LlobQL]`006OlXG;L00omoOgooooooooooo`34
ooooo`03ogmoOooRh^;oh^;R04Soh^;R00?o`/;2ojbicon/^Ll02_n/^Ll0
0on[^<ko[;W?ojbic`06ojbic`04ok2mdonf`mWo^/OMol30`?oo:5bg??lX
G;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoohn?Son?Sh`05
on?Sh`03omSHf?oRh^;ohn?S00;ohn?S00?og]kNomWIfOoShn<04?oShn<0
0ooKfm_oh^;Ron?Sh`02omkNgQKohn?S00?ofm_Kon;Rh_oShn<00_oNg]h;
on?Sh`03olW9bOnb_mGo/[oE00co/[oE00?o/l3Fok:oeOnc`=H01?nb_mD0
1?nd`MOo^<GKok_8g_o2`/;oobQL]cco:5bg000IobQL]`03ogmoOooVi^Ko
i^KV0<Coi^KV05SoOgmoong]k?o4a<CoRh^;onc/k?o]kNgofMWIohj>S_n;
Rh_oclo>onc/k?oRh^;oWYjNoh20P?n=SHgoR8R8om7AdOo]kNcoVYZJokFe
]Oo/k>cokNg]onc/k?nJVY[o]KFeong]k?o/k>coaLG5ohZ:R_o]kNgok>c/
oj6QXOn2PX;oRXZ:ol71`On7QhOoY:BTong]kOnJVY[o]KFeonc/k?o]kNco
k>c/ong]kOo/k>cokNg]oiJFU_na/K7ok>c/ong]k?o/k>cokNg]onc/k?nJ
VY[o]KFeong]kOo/k>cokNg/oj6QXOn2PX;oRXZ:ol;2`_n7QhOoY:BTonc/
k?nJVY[o]KFeong]kOo/k>cokNg]onc/k?o]kNgok>c/ong]k?o/k>coeMGE
okg:h?nnbn7o_L[Pokk;hOnmb^3o_/_Pokg:h?nnbn7o_L[Pokk;hOnmb^3o
_/_Q3?nmb^000oo5aLGo:5bgobQL]`3oobQL]c[o:5bg000IobQL]`03ogmo
Ooo^k^kok^k^0<Cok^k^05WoOgmoonKViOo0`<3oRXZ:onGUiOoVi^Ko[:b/
oiVIVOoTi>Coi^KUonGUiOnJVY[oV9RHomWIfOoUiNGohN7QomoOgooVi^Go
V9RHok:b/_oUiNGoi^KVonGUiOnHV9So/K6aonKViOoUiNGo`<30ohZ:R_oV
i^Koc/k>oh20P?oGemOofm_Koj>SXon5QHGoiNGUonKVi_nHV9So/[:bonGU
iOoVi^GoiNGUonKVi_oUiNGoi^KVoiBDU?n][JgoiNGUonKViOoUiNGoi^KV
onGUiOnHV9So/K6aonKVi_oUiNGoc/k>oh20P?oHf=Sofm_Koj>SXon5QHGo
i^KVonGUiOnHV9So/K6aonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKViOoU
iNGocLg=okC1eone`]So]<7GokG2f?nd`MOo]L;GokC1eone`]So]<7GokG2
f?nd`MOo]L;HokC1e`04okG2f008okC1eone`]So]L;HokG2f?nga=[o^lSN
oko<h_o7alOoobQL]cco:5bg000IobQL]`03ogmoOooooooooooo0<Cooooo
00CoOgmoonOWioo1`L7oRXZ:0_oWinL01onNWYko[Jf]onOWiooWinOofMWI
ogmoOoo:b/X01OoWinL00onIVIWo/[:bonOWi`02onOWi`0=oiVIVOnb/[;o
inOWonOWioo1`L7oRXZ:onOWiooGemOoP820olc<c?oWinOo_knoohb<S002
onOWi`03oiVIVOnb/[;oinOW00GoinOW00?oUIFEojj^[_oWinL01?oWinL0
2_nIVIWo/[:bonOWiooWinOoemOGoh20P?o<c<coinOWokno_on<S8`2onOW
i`03oiVIVOnb/[;oinOW00OoinOW00?obLW9ok6ne?na_]@04_na_]@01Onb
_mGo]lCJok[7gOo0cN?ob/[:0?oo:5bg??lXG;L001Wo:5bg00?oOgmoonk^
k_o^k^h0a?o^k^h01?moOgooj>SXol;2`_n:RXX2onSXj006oijNW_n][Jgo
j>SXonSXj?o=cLgoOgmo1?nHV9P01?o?clooj>SXoiVIVOnc/k<3onSXj006
oiVIVOnc/k?oj>SXonSXj?o2`/;oRXZ:0_oXj>P01Oo6a/KoTi>CoiBDU?nE
UIGoS8b<00;oj>SX00?oVIVIok>c/ooXj>P01OoXj>P00onEUIGo[Zj^onSX
j004onSXj003oiVIVOnc/k?oj>SX00;oj>SX00Goa/K6oi>CTonDU9CoUIFE
ohb<S002onSXj003oiVIVOnc/k?oj>SX00Ooj>SX00?od=3@okO4f_nga=X0
4onga=X01?njamgo_lcRol;?iOo<c<coobQL]cco:5bg000IobQL]`03ogmo
OooVi^Koi^KV0<Coi^KV00CoOgmooo;bl_o5aLGoS8b<0_obl_803_nQXJ7o
/[:boo;bl_obl_;ohN7QogmoOoo<c<cog=cLomSHf?n0P83oi^KVoo;bl_nK
Vi_o[Zj^0oobl_801_nKVi_oZ:RXoo;bl_obl_;oaLG5ohb<S0Col_;b00?o
lO7aol71`On=SHd00_obl_800onKVi_o^;Rhoo;blP05oo;blP05oiNGUon<
S8coWIfMoifMWOn[Zj/00_obl_800onKVi_o[Zj^oo;blP04oo;blP03oo7a
lOo1`L7oSHf=00;ol_;b00?oVi^Kok2`/?obl_801oobl_800ooMgMgo`m3V
ol?@iP0Bol?@iP05olCAioo3d>Ko`m3Vol?@i_o?cll0oolXG;LlobQL]`00
6OlXG;L00omoOgook^k^onk^kP34onk^kP0@ogmoOooMgMgoXj>SoinOWoo[
jn_oj>SXoifMWOn][Jgoi^KVonWYjOo[jn_oVIVIojb/[?oWinOo`L71oi6A
T@;ojn_[00_oVYZJohN7Qonl_;cogmoOon[Zj_nJVY[oQhN7ok2`/?oMgMgo
Xj>SoinOW`02on_[j`05ol_;booKfm_ojNWYojRXZ?nRXZ800_o[jn/00onJ
VY[o];Bdon_[j`05on_[j`05oiFEUOnSXj?od=3@om3@d?oDe=@00_o[jn/0
2_nJVY[oQhN7okbl_?oOgmooj^[Zol_;booKfm_ojNWYojRXZ?nRXZ82on_[
j`04oiZJV_n7QhOo^[Zjon7Qh@Kojn_[00?oe=CDok[7gOnjamd04onjamd0
1?nlbMoo`/oUolCAiooAdM7oobQL]cco:5bg000IobQL]`03ogmoOooooooo
oooo0<Cooooo05SoOgmoohN7QonBTY;od];Bonc/k?nd];CoPX:2ohB4Q?n:
RX[ob<S9onc/k?oPh>3oWIfMohB4Q?n:RX[oc<c<onc/k?o[jncoXZ:RokVi
^OnVYZKoPX:2onGUiOnRXZ;o^[Zjok:b/_n7QhOoTY:Bom;Bd_o[jn_ok>c/
okVi^OnDU9CoQHF5oiNGUooBd];ok>c/on_[jonJVY[o];Bdonc/k?o[jnco
k>c/on_[joo/k>cojn_[oiJFU_n`/;3ok>c/on_[k?o/k>cojn_[onc/k?nR
XZ;o^KViojJVY_n2PX;oi>CUokVi^OnDU9CoQHF5oiNGUooBd];ojn_[onc/
k?nRXZ;o^[Zjojj^[_n5QHGojn_[onc/k?o[jn_ok>c/on_[k?o/k>cod=3@
okK3fOne`]So]/?IokG2f?nf`mWo]L;IokK3fOne`]So]/?IokG2f?nf`mWo
]L;H0_nf`mT00one`]So]/?IokK3f@03okK3f@05okG2f?nkb=ko`<gSolKC
jOoDe=@0oolXG;LlobQL]`006OlXG;L00omoOgook^k^onk^kP34onk^kP03
ogmoOoo/k>cokNg]00?okNg]00?oX:2Pok2`/?o]kNd01?o]kNd00oo[jn_o
kNg]ong]k@05ong]k@03on_[joo]kNgokNg]00;okNg]00?ok>c/ong]kOo]
kNd01?o]kNd00oo/k>cokNg]ong]k@02ong]k@03oiZJV_ne]KGokNg]00Go
kNg]00?oUYJFok6a/Oo]kNd01oo]kNd01Oo[jn_okNg]ong]kOo]kNgok>c/
00OokNg]00?ok>c/ong]kOo]kNd01?o]kNd00ooHf=So_<WOokc9g`0Bokc9
g`05ok_8g_noc>;o`m3VolKCjOoFe]H0oolXG;LlobQL]`006OlXG;L00omo
Ogooi^KVonKViP34onKViP03ogmoOoofm_Kom_Kf00?om_Kf00?oinOWonKV
i_ofm_H07Oofm_H00onLW9co^[ZjooKfmP05ooKfmP03oiRHV?nDU9Co[Zj^
00;o[Zj^00?oe=CDooKfm_ofm_H05Oofm_H00ooShn?oamCZolODjP0@olOD
jP03olKCjOo7e>[oa]?Y00?oamCZ00?ofMWIobQL]olXG;L0oolXG;LjobQL
]`006OlXG;L00omoOgook^k^onk^kP34onk^kP03ogmoOoo^k^kok^k^02?o
k^k^00?oVYZJokJf]_o^k^h01Oo^k^h00oo;bl_o`/;2ol;2`P02ol;2`P03
omWIfOo^k^kok^k^01Gok^k^00?of][Jokg:h?nmb^004onmb^001?o0cN?o
a=7WolSEjooKfm_oobQL]cco:5bg000IobQL]`03ogmoOooooooooooo0<Co
oooo00?oOgmoonk^k_o^k^h08oo^k^h00oo/k>cokNg]onk^kP0Ronk^kP03
omGEeOnhaM_o^<GK00co^<GK00?o]lCJokS5fonhaM/01?nhaM/01?nmb^3o
`m3VolSEjooNg]koobQL]cco:5bg000IobQL]`03ogmoOoo^k^kok^k^0<Co
k^k^00?oOgmoonk^k_o^k^h0B?o^k^h00ooKfm_o_L[Pokg:h00Aokg:h006
okk;hOnmb^3o`<gSolGBj?o8eN_oh>3PoolXG;LlobQL]`006OlXG;L00omo
Ogooi^KVonKViP34onKViP1KogmoOoohn?OomoOgooShn?ogmoOon?ShooOg
moohn?SomoOgooShmoogmoOon?ShooOgmoohn?SomoOgooShn?ogmoOon?Sg
ooOgmoohn?SomoOgooShn?ogmoOon?ShooOgmoohn?OomoOgooShn?ogmoOo
n?ShooOgmoohn?SomoOgooShmoogmoOon?ShooOgmoohn?SomoOgooShn?og
moOon?SgooOgmoohn?SomoOgooShn?ogmoOon?ShooOgmoohn?OomoOgooSh
n?ogmoOon?ShooOgmoohn?SomoOgooShmoogmoOon?ShooOgmoohn?SomoOg
ooShn?ogmoOon?SgooOgmoohn?SomoOgooShn?ogmoOon?ShooOgmoohn?Oo
moOgonSXj?o8eN_obMK/olSEjoo9e^cob=G[olWFjoo8eN_obMK/olSEjoo9
e^cob=G[olWFk?o8eN_obMK/olSEj`02olWFk003olSEjoo9e^cobMK/00?o
bMK/00?o^/_Xon?SholXG;L0oolXG;LkobQL]`006OlXG;L00omoOgook^k^
onk^kP34onk^kP03ogmoOoo_knookno_04Sokno_00?ogMgMokk;hOnnbn40
2_nnbn401?nmb^3o_/_Qokk;hOnmb^04okk;h@04ol3=hoo5d^Sob=G[oo7a
lOoo:5bg?OlXG;L001Wo:5bg00?oOgmoooooooooool0a?ooool00omoOgoo
kno_ono_k`18ono_k`03omWIfOnia]co^LKL017o^LKL00Go^/OMokg:h?o3
d>KoamCZonc/k03oobQL]cgo:5bg000IobQL]`03ogmoOoo^k^kok^k^0<Co
k^k^00?oOgmoono_koo_knl0B?o_knl00ooOgmoo_/_Qokk;h@0=okk;h@03
okg:h?nnbn7o_/_Q00;o_/_Q00Co`LkTolGBj?o`l?3o>FVloolXG;LmobQL
]`006OlXG;L00omoOgooi^KVonKViP34onKViP03ogmoOoohn?Son?Sh04So
n?Sh00?oj^[ZolWFk?o9e^`04oo9e^`00ooalO7oBWK2obQL]`3oobQL]cgo
:5bg000IobQL]`03ogmoOoo^k^kok^k^0<Cok^k^00?oOgmooo[jn_ojn_X0
B?ojn_X00oo[jn_obMK/olWFk00@olWFk004ok[;j?oalO7ok>c/ocUY_?oo
:5bg?olXG;L001Wo:5bg00?oOgmoooooooooool0a?ooool00omoOgoohn?S
on?Sh`1Lon?Shooo:5bg@_lXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^
k^h00omoOgook^k^onk^kP18onk^kP03okJf]_lXG;Oo:5bg0?oo:5bgDolX
G;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KVonKViP18
onKViP03okRh^?lXG;Oo:5bg0?oo:5bgDolXG;L001Wo:5bg00?oOgmoonk^
k_o^k^h0a?o^k^i;ogmoO`03ok^k^olXG;Oo:5bg0?oo:5bgDolXG;L001Wo
:5bg00?oOgmoooooooooool0a?ooool0?omoOgooi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
olC4a?n`_M?o[kcBok2mdon__=;o/;gCojnldon`_M?o[kcBok2mdon__=;o
/;gCojnldP03ok2md`03ojnld_n`_M?o/;gC00?o[kcB00Co/[oEokO4f_ni
a]co_KfmoolXG;MEobQL]`006OlXG;L00omoOgook^k^onk^kP34onk^kP03
ogmoOooMgMgogMgM02oogMgM00?o`/;2ojbicon/^Ll02_n/^Ll00on[^<ko
[;W?ojbic`06ojbic`04ok2mdonf`mWo^/OMol30`?oo:5bgEOlXG;L001Wo
:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgoohN7Qon7Qh@04on7Qh@03
omWIfOoPh>3ohN7Q00;og=cL5_oQhN400ooIfMWoh>3Pon7Qh@02omcLg0_o
hN7Q00?obLW9ok:oeOnb_mD03?nb_mD00onc`=Ko/[oEok?0eP04ok:oe@04
okC1eonhaM_o^lSNol;2`_oo:5bgEOlXG;L001Wo:5bg00?oOgmoonk^k_o^
k^h0a?o^k^h0?omoOgook^k^olK6a_n;Rh_okno_onk^k_nRXZ;oPX:2ohZ:
R_o2`/;oQhN7ojBTY?o_knooVYZJokJf]_o^k^kokno^onk^k_o_knook^k^
ono_konFUYKo/K6aonk^k_o_knkok^k^ono_koo^k^koVi^KokJf]_o_knoo
k^k^ono_k_nRXZ;oPX:2ohZ:R_o3`l?oQhN7ojFUYOo^k^koVi^JokJf]_o_
knook^k^ono_koo^k^kokno_onk^k_o_knkok^k^omGEeOnmb^3o_/_Qokg:
h?nnbn7o_L[Pokk;h?nmb^3o_/_Qokg:h?nnbn7o_L[Pokk;h@0<okg:h003
olG5aOlXG;Oo:5bg0?oo:5bgDolXG;L001Wo:5bg00?oOgmoooooooooool0
a?ooool0@?moOgooj^[ZolC4a?n:RX[ojn_[om;Bd_n0P83ofm_Kon3PgonU
YJGoQXJ6on[Zj_o[jn_oVIVIokBd]?oZj^[ojn_Zon[Zj_o[jn_oj^[Zon_[
jonEUIGo/;2`on[Zj_o[jn[oj^[Zon_[jooZj^[oVYZJokBd]?o[jn_oj^[Z
om;Bd_n0P83og=cLomoOgonUYJGoQXJ6on_[jooZj^[oVYZIokBd]?o[jn_o
j^[Zon_[jooZj^[ojn_[on[Zj_o[jn[oj^[Zolg=cOnd`MOo]L;HokC1eone
`]So]<7GokG2eond`MOo]L;HokC1eone`]So]<7GokG2f?nd`ML4okG2f008
okC1eone`]So]L;HokG2f?nga=[o^lSNoko<h_o7alOoobQL]eGo:5bg000I
obQL]`03ogmoOoo^k^kok^k^0<Cok^k^00_oOgmoon;Rh_nn_[koRHV9on;R
h_oCdm?oP820olS8b?oRh^;o_;bloh^;R`02on;RhP03oiNGUon`/;3oh^;R
00Goh^;R00?oTi>Cojb/[?oRh^801?oRh^802_nGUiOo/;2`on;Rh_oRh^;o
dm?Coh20P?o8b<Soh^;Rokbl_?n;Rh/2on;RhP03oiNGUon`/;3oh^;R00Oo
h^;R00?obLW9ok6ne?na_]@04_na_]@01Onb_mGo]lCJok[7gOo0cN?ob/[:
0?oo:5bgEOlXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H01?moOgoo
i^KVol30`?n:RXX2onKViP05olC4a?nCTi?oTi>CoiBDU?n;Rh/00_oVi^H0
0onHV9So/[:bonKViP05onKViP03oiBDU?n][Jgoi^KV00Coi^KV00?oV9RH
ok:b/_oVi^H00_oVi^H01Oo4a<CoTi>Coi>CTonDU9CoRh^;00;oi^KV00?o
V9RHok:b/_oVi^H01ooVi^H00oo@d=3o]lCJokO4fP0CokO4fP04ok[7gOno
c>;o`/oUolc<c?oo:5bgEOlXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^
k^h01?moOgoom?CdolO7aon<S8`4ooCdm003oo?cloo2`/;oSXj>00;om?Cd
00?oW9bLokVi^Oodm?@01Oodm?@01OnGUiOoS8b<oijNW_nNWYko[:b/00;o
m?Cd00?oW9bLojn_[oodm?@01?odm?@00ooclo?o`/;2ohj>SP02ooCdm003
oibLW?na/K7om?Cd00Oom?Cd00?ogMgMol?@i_o3d>H04_o3d>H01Oo4dNOo
`m3Vol?@i_o3d>Koclo?0?oo:5bgEOlXG;L001Wo:5bg00?oOgmooooooooo
ool0a?ooool01?moOgoohN7QojFUYOnQXJ42oo3`l005olk>c_oOgmook^k^
ojVYZOnTY:@00_o`l?000onKVi_o]kNgoo3`l005oo3`l005oiJFU_nUYJGo
e=CDomCDe?oHf=P00_o`l?002_nKVi_oQhN7okno_ooTi>Cokno_olk>c_oO
gmook^k^ojVYZOnTY:@2oo3`l004oi^KVon8R8So_KfmonGUi@Kol?3`00?o
e=CDok[7gOnjamd04onjamd01?nlbMoo`/oUolCAiooAdM7oobQL]eGo:5bg
000IobQL]`03ogmoOoo^k^kok^k^0<Cok^k^03ooOgmoohN7QonATI7oc/k>
onKVi_oWinOo][Jfoi>CTon5QHGoUYJFolk>c_oWinOoi^KVoiVIVOnb/[;o
inOWonKViooWinOoi^KVonOWiooVi^KoUIFEojf][OoWinOoi^KWonOWiooV
i^KoinOWoj2PX?nf][KoY:BToh:2P_oOgn3o]kNgoi>CTon5QHGoUYJFolk>
c_oVi^KoinOWoj2PXOng]kOo[:b/ohF5QOoVi^KoinOWonKVi_oWinOoi^KW
onOWioo@d=3o]/?IokG2f?nf`mWo]L;HokK3fOne`]Wo]/?IokG2f?nf`mWo
]L;HokK3fOne`]P00_nf`mT00one`]So]/?IokK3f@03okK3f@05okG2f?nk
b=ko`<gSolKCjOoDe=@0oolXG;MEobQL]`006OlXG;L00omoOgooi^KVonKV
iP34onKViP03ogmoOooZj^[ojn_[00Gojn_[00?oj^[Zon_[joo[jn/00_o[
jn/00onJVY[o];Bdon_[j`05on_[j`03oiFEUOn`/;3ojn_[00Oojn_[00Go
jNWYon_[joo[jn_ojn_[on[ZjP07on_[j`03on[Zj_o[jn_ojn_[00Cojn_[
00?of=SHokc9gonlbMl04_nlbMl01Onkb=ko_lcRol?@i_o6dnWoe]KF0?oo
:5bgEOlXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoon?Sh
ooShn00:ooShn003oifMWOnk^k_on?Sh00Gon?Sh00?oV9RHoiBDU?n^[Zh0
0_n^[Zh00ooFe]Kon?ShooShn00EooShn003on?Shoo7e>[oamCZ013oamCZ
00?oa]?YolODj_o6dnT00oo7e>X00ooIfMWo:5bgobQL]`3oobQL]e?o:5bg
000IobQL]`03ogmoOooooooooooo0<Cooooo00?oOgmooo?clooclo<02_oc
lo<00onLW9co^;Rhoo?cl`05oo?cl`03olo?coo5aLGoaLG500;oaLG500?o
g]kNoo?clooclo<05Ooclo<00ooJf][o_L[Pokg:h00Cokg:h004ol3=hoo4
dNOob=G[om_Kfooo:5bgEOlXG;L001Wo:5bg00?oOgmoonk^k_o^k^h0a?o^
k^h00omoOgoojNWYonWYj@0:onWYj@03onOWiooXj>SojNWY02;ojNWY00?o
eMGEokS5fonhaM/03?nhaM/00onga=[o^<GKokS5f`04okS5f`04okg:h?o3
d>Kob=G[omkNg_oo:5bgEOlXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oV
i^H00omoOgook>c/onc/k00_onc/k003om_Kfonmb^3o_L[P017o_L[P00Ko
_/_Qokg:h?o0cN?oaM;XolSEjooPh>3oobQL]eGo:5bg000IobQL]`03ogmo
Ooo^k^kok^k^0<Cok^k^04;oOgmoooWinOojn_[onOWioo[jn_oinOWon_[j
ooWinOojn_WonOWioo[jn_oinOWon_[jooWinOojn_[onOWioo[jnOoinOWo
n_[jooWinOojn_[onOWioo[jn_oinOWon_[iooWinOojn_[onOWioo[jn_oi
nOWon_[jooWinOojn_WonOWioo[jn_oinOWon_[jooWinOojn_[onOWioo[j
nOoinOWon_[jooWinOojn_[onOWioo[jn_oinOWon_[iooWinOoXj>Sob=G[
olWFk?o8eN_obMK/olSEjoo9e^_ob=G[olWFk?o8eN_obMK/olSEjoo9e^co
b=G[olWFk?o8eN/2olWFk003olSEjoo9e^cobMK/00?obMK/00?o^/_Xon?S
holXG;L0oolXG;MDobQL]`006OlXG;L00omoOgooooooooooo`34ooooo`03
ogmoOoodm?Com?Cd02oom?Cd00?ogMgMokk;hOnnbn402_nnbn401?nmb^3o
_/_Qokk;hOnmb^04okk;h@04ol3=hoo5d^Sob=G[oo7alOoo:5bgE_lXG;L0
01Wo:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgooj^[Zon[ZjP0_on[Z
jP03omWIfOnia]co^LKL017o^LKL00Go^/OMokg:h?o3d>KoamCZonc/k03o
obQL]eKo:5bg000IobQL]`03ogmoOooVi^Koi^KV0<Coi^KV00?oOgmoong]
kOo]kNd0;oo]kNd00ooOgmoo_/_Qokk;h@0=okk;h@03okg:h?nnbn7o_/_Q
00;o_/_Q00Co`LkTolGBj?o`l?3o>FVloolXG;MFobQL]`006OlXG;L00omo
Ogook^k^onk^kP34onk^kP03ogmoOoojn_[on_[j02oon_[j00?oj^[ZolWF
k?o9e^`04oo9e^`00ooalO7oBWK2obQL]`3oobQL]eKo:5bg000IobQL]`03
ogmoOooooooooooo0<Cooooo00?oOgmoooooooooool0;oooool00oo[jn_o
bMK/olWFk00@olWFk004ok[;j?oalO7ok>c/ocUY_?oo:5bgF?lXG;L001Wo
:5bg00?oOgmoonk^k_o^k^h0a?o^k^h00omoOgoohn?Son?Sh`13on?Shooo
:5bgFolXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgooi^KV
onKViP0_onKViP03okJf]_lXG;Oo:5bg0?oo:5bgK?lXG;L001Wo:5bg00?o
Ogmoonk^k_o^k^h0a?o^k^h00omoOgook^k^onk^kP0_onk^kP03okRh^?lX
G;Oo:5bg0?oo:5bgK?lXG;L001Wo:5bg00?oOgmoooooooooool0a?oooolb
ogmoO`03ok^k^olXG;Oo:5bg0?oo:5bgK?lXG;L001Wo:5bg00?oOgmoonk^
k_o^k^h0a?o^k^h09_moOgooh>3Pon7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3Q
on7QhOoPh>3ohN7Qon3Ph?oQhN7oh>3Pon7QhOoPh>7ohN7Qon3Ph?oQhN7o
h>3Pon7QhOoPh>3ohN7Qon3PhOoQhN7oa<C4ok2mdon__=;o/;gCojnld_n`
_M?o[kcCok2mdon__=;o/;gCojnld_n`_M?o[kcB0on`_M<00on__=;o/;gC
ok2md`03ojnldP04ok:oeOnga=[o^LKLokfm_Ooo:5bgK_lXG;L001Wo:5bg
00?oOgmoonKVi_oVi^H0a?oVi^H00omoOgoofm_Kom_Kf`0Fom_Kf`03ol;2
`_n/^Loo[;W?00[o[;W?00?oZkS>ojbicon/^Ll01_n/^Ll01?n`_M?o]/?I
ok[7gOo0`<3oobQL]fko:5bg000IobQL]`03ogmoOoo^k^kok^k^0<Cok^k^
00?oOgmoon?ShooShn<01_oShn<00ooKfm_oh^;Ron?Sh`02omkNgP_ohn?S
00?obLW9ok:oeOnb_mD03?nb_mD00onc`=Ko/[oEok?0eP04ok:oe@04okC1
eonhaM_o^lSNol;2`_oo:5bgK_lXG;L001Wo:5bg00?oOgmoooooooooool0
a?ooool09_moOgoom?Cdoo?clonLW9co^;RhooCdm?oclo?om?Ccoj>SXon2
PX;oRXZ:olK6a_n7QhOoYZJVoo?clonLW9co^;RhooCdm?oclo?om?Cdoo?c
loodm?Colo?cooCdlooclo?oeMGEokg:h?nnbn7o_L[Pokk;hOnmb^3o_/_P
okg:h?nnbn7o_L[Pokk;hOnmb^3o_/_Q3?nmb^000oo5aLGo:5bgobQL]`3o
obQL]fco:5bg000IobQL]`03ogmoOoo^k^kok^k^0<Cok^k^02OoOgmoonKV
i_oUiNGoV9RHok6a/OoVi^KoiNGUolk>c_n0P83of=SHom_KfonSXj?oQHF5
onKVi_oUiNGoV9RHok6a/OoVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Go
iNGUolg=cOnd`MOo]L;HokC1eone`]So]<7GokG2eond`MOo]L;HokC1eone
`]So]<7GokG2f?nd`ML01?ne`]P02?nd`MOo]L;HokG2f?ne`]So]lCJok_8
g_noc>;oalO7oolXG;M^obQL]`006OlXG;L00omoOgooi^KVonKViP34onKV
iP05ogmoOooPh>3oh>3PoiNGUon_[jl00_oPh>001_oAdM7oP820olK6a_oP
h>3o^k^koh^;R`;oh>3P00?oUiNGojn_[ooPh>001ooPh>000oo9bLWo/KkD
ok6ne00Bok6ne005ok:oeOnga=[o^/OMol3=hoo:b/X0oolXG;M^obQL]`00
6OlXG;L00omoOgook^k^onk^kP34onk^kP05ogmoOooXj>Soj>SXoiVIVOnc
/k<00ooXj>P01Oo6a/KoTi>CoiBDU?nEUIGoS8b<00;oj>SX00?oVIVIok>c
/ooXj>P01ooXj>P00oo@d=3o]lCJokO4fP0CokO4fP04ok[7gOnoc>;o`/oU
olc<c?oo:5bgK_lXG;L001Wo:5bg00?oOgmoooooooooool0a?ooool01Omo
OgoonOWiooWinOnMWIgo/K6a00GonOWi00?on?SholG5aOn>SXh00_oinOT0
0onMWIgo/k>cooWin@07ooWin@03omgMgOo3d>Ko`m3V01;o`m3V00Goa=7W
ol?@i_o3d>Ko`m3Volo?c`3oobQL]fko:5bg000IobQL]`03ogmoOoo^k^ko
k^k^0<Cok^k^00goOgmoon_[joo[jn_oVYZJohN7Qonl_;cogmoOon[Zj_o;
bl_ofm_KonWYjOnXZ:SoXZ:R00;ojn_[00CoVYZJohN7Qonj^[[ohN7Q1_o[
jn/00ooDe=Co^/OMok[7g@0Cok[7g@04okc9goo2cnGoa=7Wom7AdOoo:5bg
K_lXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H09_moOgooi>CTonGU
iOnPX:3o]KFeoj>SXon2PX;og]kOokJf]_nBTY;oQHF5oiFEUOo=cLgoi>CT
onGUiOnPX:3o][Jfoj^[Zon5QHGoi>CTonGUiOoTi>CoiNGUonCTiOoUiNGo
d=3@okK3fOne`]So]/?IokG2f?nf`mWo]L;IokK3fOne`]So]/?IokG2f?nf
`mWo]L;H0_nf`mT00one`]So]/?IokK3f@03okK3f@05okG2f?nkb=ko`<gS
olKCjOoDe=@0oolXG;M^obQL]`006OlXG;L00omoOgook^k^onk^kP34onk^
kP03ogmoOoo]kNgokNg]00?okNg]00Gojn_[ong]kOo]kNgokNg]onc/k007
ong]k@03onc/k?o]kNgokNg]00CokNg]00?of=SHokc9gonlbMl04_nlbMl0
1Onkb=ko_lcRol?@i_o6dnWoe]KF0?oo:5bgK_lXG;L001Wo:5bg00?oOgmo
ooooooooool0a?ooool00omoOgoofMWIoogmo@0Foogmo@03on?Shoo7e>[o
amCZ013oamCZ00?oa]?YolODj_o6dnT00oo7e>X00ooIfMWo:5bgobQL]`3o
obQL]fco:5bg000IobQL]`03ogmoOoo^k^kok^k^0<Cok^k^00?oOgmoomWI
fOo^k^h05_o^k^h00ooJf][o_L[Pokg:h00Cokg:h004ol3=hoo4dNOob=G[
om_Kfooo:5bgK_lXG;L001Wo:5bg00?oOgmoonKVi_oVi^H0a?oVi^H00omo
OgooinOWonOWi`0FonOWi`03omGEeOnhaM_o^<GK00co^<GK00?o]lCJokS5
fonhaM/01?nhaM/01?nmb^3o`m3VolSEjooNg]koobQL]fko:5bg000IobQL
]`03ogmoOoo^k^kok^k^0<Cok^k^00?oOgmoonk^k_o^k^h05_o^k^h00ooK
fm_o_L[Pokg:h00Aokg:h006okk;hOnmb^3o`<gSolGBj?o8eN_oh>3PoolX
G;M^obQL]`006OlXG;L00omoOgooooooooooo`34ooooo`0YogmoOooooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_oXj>Sob=G[olWFk?o8eN_obMK/olSEjoo9e^_ob=G[olWFk?o8eN_obMK/
olSEjoo9e^cob=G[olWFk?o8eN/00_o9e^`00oo8eN_obMK/olWFk003olWF
k003ok[;j?oShn?o:5bg0?oo:5bgKOlXG;L001Wo:5bg00?oOgmoonk^k_o^
k^h0a?o^k^h00omoOgookno_ono_k`0Fono_k`03omgMgOnnbn7o_/_Q00[o
_/_Q00Co_L[Pokk;hOnnbn7o_L[P1?nnbn401?o0cN?oaM;XolSEjooalO7o
obQL]foo:5bg000IobQL]`03ogmoOooVi^Koi^KV0<Coi^KV00?oOgmoonSX
j?oXj>P05_oXj>P00ooIfMWo^LKLokW6g00AokW6g005ok[7gOnmb^3o`m3V
olODj_o/k>`0oolXG;M_obQL]`006OlXG;L00omoOgook^k^onk^kP34onk^
kP03ogmoOoo_knookno_01Kokno_00?ogmoOokk;hOnnbn403Onnbn400onm
b^3o_/_Qokk;h@02okk;h@04ol7>i?o5d^Sol?3`ocUY_?oo:5bgKolXG;L0
01Wo:5bg00?oOgmoooooooooool0a?ooool00omoOgooooooooooo`0Foooo
o`03on[Zj_o9e^cobMK/01?obMK/00?olO7aodYf`_lXG;L0oolXG;M_obQL
]`006OlXG;L00omoOgook^k^onk^kP34onk^kP03ogmoOoojn_[on_[j01Ko
n_[j00?ojn_[olWFk?o9e^`04?o9e^`01?njbnSolO7aonc/k?liJKcoobQL
]g7o:5bg000IobQL]`03ogmoOooVi^Koi^KV0<Coi^KV00?oOgmoon?ShooS
hn<0:_oShn?oobQL]gCo:5bg000IobQL]`03ogmoOoo^k^kok^k^0<Cok^k^
00?oOgmoonk^k_o^k^h05_o^k^h00onf][Ko:5bgobQL]`3oobQL]hGo:5bg
000IobQL]`03ogmoOooooooooooo0<Cooooo00?oOgmoooooooooool05_oo
ool00onh^;So:5bgobQL]`3oobQL]hGo:5bg000IobQL]`03ogmoOoo^k^ko
k^k^0<Cok^k^6OmoOgl00onk^k_o:5bgobQL]`3oobQL]hGo:5bg000IobQL
]`03ogmoOooVi^Koi^KV0<Coi^KV00goOgmook2mdon__=;o/;gCojnld_n`
_M?o[kcCok2mdon__=;o/;gCojnld_n`_M?o[kcB00?o/;gC00?o[kcBok2m
don`_M<00on__=801?nb_mGo]lCJokW6g?nm_KgoobQL]hOo:5bg000IobQL
]`03oh61POo^k^kok^k^0<Cok^k^00?oPH61ojbicon/^Ll02_n/^Ll00on[
^<ko[;W?ojbic`06ojbic`04ok2mdonf`mWo^/OMol30`?oo:5bgQolXG;L0
01Wo:5bg00?oQ8B4ooooooooool0a?ooool00on4Q8Co/[oEok:oe@0<ok:o
e@03ok?0e_nb_mGo/l3F00Co/[oE00Co]<7GokS5fonkb=ko`/;2oolXG;N7
obQL]`006OlXG;L00on6QXKok^k^onk^kP34onk^kP0=ohJ6Q_nmb^3o_/_Q
okg:h?nnbn7o_L[Pokk;h?nmb^3o_/_Qokg:h?nnbn7o_L[Pokk;h@0<okg:
h003olG5aOlXG;Oo:5bg0?oo:5bgQOlXG;L001Wo:5bg00?oRHV9onKVi_oV
i^H0a?oVi^H03_n9RHWo]<7GokG2f?nd`MOo]L;HokC1eone`]Oo]<7GokG2
f?nd`MOo]L;HokC1eone`]So]<7G1?ne`]P02?nd`MOo]L;HokG2f?ne`]So
]lCJok_8g_noc>;oalO7oolXG;N7obQL]`006OlXG;L00on;Rh_ok^k^onk^
kP34onk^kP03oh^;Rona_]Co/KkD01;o/KkD00Go/[oEokO4f_njamgo`<gS
ol[:bP3oobQL]hOo:5bg000IobQL]`03ohj>S_oooooooooo0<Cooooo00?o
SXj>okO4f_nga=X04onga=X01?njamgo_lcRol;?iOo<c<coobQL]hOo:5bg
000IobQL]`03oi2@T?o^k^kok^k^0<Cok^k^00?oT92@ol?@i_o3d>H04_o3
d>H01Oo4dNOo`m3Vol?@i_o3d>Koclo?0?oo:5bgQolXG;L001Wo:5bg00?o
Ti>ConKVi_oVi^H0a?oVi^H00onCTi?o^/OMok[7g@0Cok[7g@04okc9goo2
cnGoa=7Wom7AdOoo:5bgQolXG;L001Wo:5bg00?oUIFEonk^k_o^k^h0a?o^
k^h03OnEUIGo]/?IokG2f?nf`mWo]L;HokK3fOne`]Wo]/?IokG2f?nf`mWo
]L;HokK3fOne`]P00_nf`mT00one`]So]/?IokK3f@03okK3f@05okG2f?nk
b=ko`<gSolKCjOoDe=@0oolXG;N7obQL]`006OlXG;L00onHV9Sooooooooo
o`34ooooo`03oiRHV?nlbMoo_<WO01;o_<WO00Go^lSNoko<h_o3d>Koa]?Y
omKFeP3oobQL]hOo:5bg000IobQL]`03oiZJV_o^k^kok^k^0<Cok^k^00?o
VYZJolODj_o7e>X04?o7e>X00oo6dnWoamCZolKCj@03olODjP03omWIfOlX
G;Oo:5bg0?oo:5bgQOlXG;L001Wo:5bg00?oWIfMonKVi_oVi^H0a?oVi^H0
0onMWIgo_L[Pokg:h00Cokg:h004ol3=hoo4dNOob=G[om_Kfooo:5bgQolX
G;L001Wo:5bg00?oWinOonk^k_o^k^h0a?o^k^h00onOWioo^<GKokS5f`0<
okS5f`03okO4f_nhaM_o^<GK00Co^<GK00Co_L[Pol?@i_o8eN_og]kNoolX
G;N7obQL]`006OlXG;L00onRXZ;oooooooooo`34ooooo`03oj:RX_nmb^3o
_L[P017o_L[P00Ko_/_Qokg:h?o0cN?oaM;XolSEjooPh>3oobQL]hOo:5bg
000IobQL]`03ojBTY?o^k^kok^k^0<Cok^k^013oY:BTolSEjoo9e^cob=G[
olWFk?o8eN_obMK[olSEjoo9e^cob=G[olWFk?o8eN_obMK/olSEjoo9e^co
b=G[0_o9e^`00oo8eN_obMK/olWFk003olWFk003ok[;j?oShn?o:5bg0?oo
:5bgQ_lXG;L001Wo:5bg00?oYjNWonKVi_oVi^H0a?oVi^H00onWYjOo_/_Q
okk;h@0:okk;h@04okg:h?nnbn7o_/_Qokg:h0Co_/_Q00Co`<gSolGBj?o8
eN_olO7aoolXG;N8obQL]`006OlXG;L00onYZJWok^k^onk^kP34onk^kP03
ojVYZOnia]co^LKL017o^LKL00Go^/OMokg:h?o3d>KoamCZonc/k03oobQL
]hSo:5bg000IobQL]`03ojb/[?oooooooooo0<Cooooo00?o[:b/okk;hOnn
bn403Onnbn400onmb^3o_/_Qokk;h@02okk;h@04ol7>i?o5d^Sol?3`ocUY
_?oo:5bgR?lXG;L001Wo:5bg00?o[Zj^onk^k_o^k^h0a?o^k^h00on^[Zko
bMK/olWFk00ColWFk003oo7alOm:M/;o:5bg0?oo:5bgR?lXG;L001Wo:5bg
00?o/K6aonKVi_oVi^H0a?oVi^H00ona/K7obMK/olWFk00@olWFk004ok[;
j?oalO7ok>c/ocUY_?oo:5bgR_lXG;L001Wo:5bg00?o/k>conk^k_o^k^h0
a?o^k^h00onc/k?ohn?Son?Sh`0Aon?Shooo:5bgSOlXG;L001Wo:5bg00?o
][Jfooooooooool0a?ooool00onf][Ko:5bgobQL]`3oobQL]iko:5bg000I
obQL]`03okRh^?o^k^kok^k^0<Cok^k^00?o^;RhobQL]olXG;L0oolXG;NN
obQL]`006OlXG;L00onk^k_oOgmoogmoO`34ogmoO`03ok^k^olXG;Oo:5bg
0?oo:5bgW_lXG;L001Wo:5bg00Go_Kfmon_[jooVi^Koh^;RomkNgP04omgM
g@?og]kN0:oogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM00?og]kN00?ogMgM
omkNg_oNg]h00ooMgMd01?oQhN7oinOWon[Zj_nm_KgoobQL]j3o:5bg000I
obQL]`04ol30`?o/k>coi^KVon3Ph0OofMWI00Cof=SHomKFe_oCdm?od=3@
0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?Com3@
d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@
d=03olg=c@04om3@d?oCdm?oemOGomSHf7WofMWI00?of=SHomWIfOoIfMT0
1_oIfMT01?oNg]koi^KVonc/k?o0`<3oobQL]j3o:5bg000IobQL]`08ol;2
`_o^k^kojNWYonCTi?oPh>3ohN7Qon3Ph?oRh^82on7Qh@0=omkNg_oLg=co
dm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09
on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7
aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:b
ojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`0Xon7Qh@03ol[:b_oOgmoo
hN7Q00;ohN7Q00?oemOGolc<c?oQhN404?oQhN400oo@d=3ogmoOon7Qh@02
omOGeaKohN7Q00?od=3@omoOgooQhN400_oGemLJon7Qh@03on;Rh_oQhN7o
h^;R00CohN7Q00Coi>CTonWYjOo]kNgo`/;2oolXG;NPobQL]`006OlXG;L0
1?o5aLGol?3`ono_kooalO43oo3`l02lono_koo`l?3ok^k^onWYjOoKfm_o
`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]
kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2
`_nTY:CoS8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;o
Y:BTohb<S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]kOoa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNoo<30`ofm_Koo_knoolO7aoc/k>omhN7Sokno_oo7akonHV9So
6QXJono_kooalO7oaLG5ob8R8_lL71co[jn^ono_kooJf][oADE5o`820_lP
823o5ADEokBd]?oalNoo>c/kogQhN?o_knoolO7aono_koll?3coMgMgoo7a
koo_knooVYZJoaXJ6_oalO7okno_oda<C?l71`Oo61PHoi:BT_lA4A7oDE5A
oo7alOlk>c_oN7Qhono_kooalNookno_oo7alOo_knoolO7aoc8b<_m]KFgo
kno_oo7akoo_knoolO7aono_koll?3coMgMgoo7alOo_knoolO7_od];Bol7
1`Oo61PHoi>CTolA4A7oDU9Bono_koll?3_oMgMgoo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aoo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`l?o_knl4oo3`l003olG5aOlXG;Oo:5bg0?oo:5bgW_lXG;L001Wo
:5bg00CoalO7oo;bl_o^k^koinOW1?oUiND04?oTi>CogmoOom7AdOna/K7o
RXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RXWo/K6aom7AdOoN
g]h2onCTi003onGUiOoTi>CoiNGT00;oi>CT00oog]kNom7AdOna/K7oRXZ:
ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6aom7Ad?oNg]h0
0_oTi>@0S?oUiNGoi>CTonGUiOoTi>Coi>CSomkNg_oAdM7o/K6aohZ:R_mV
IVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM7og]kNonCT
hooTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?l^;RkoJFUYonCTi?oUiNGo>CTiog9bL_oTi>CoiNGToi6ATOlI
6AWoi>CTonGUiOmUIFGo>SXjon?ShooUiNCoi>CTocdm?Oli>CWob<S8onCT
i?oJf][of=SHonGUi?li>CWoLW9bonCTi?oUiNGoi>CTocTi>OmaLG7oiNGT
onCTi?nBTY;o6ATIonGUiOna/K7o0`<3olG5aOo>c/goDE5Ao`l?3ooTi>Co
iNGUocTi>OmbLW;oi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo<30`ofQXJ?oT
i>CoiNGTonCTi?oUiNGoi>CTocTi>OmaLG7oiNGUonCTi?na/K7o0`<3olK6
a_o=cLgoDE5Ao`l?3ooUiNGoi>CTocTi>OmaLG7oiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT1?oUiND02?oTi>CoiNGUonGU
iOoUiNGoj>SXong]kOobl_;oalO7oolXG;NPobQL]`006OlXG;L01?o:b/[o
m?Cdong]kOoWinL2on3Ph00Con7QhOoOgmoog]kNom;Bd_nd];CoQhN7oeaL
G?m]>cGoWTi2ole_GooYPfoocFmOoii>@om]>cKoG5aLohN7Qond];Cod];B
omkNgP05on3Ph00AomkNg_oBd];o];BdohN7QomLG5coKF0/oijF;_o=cCoo
jNU=olg=?onNVRooKF<]oeaLG?n7QhOo];Bdom;Bd_oNg]h01OoPh>004OoN
g]kod];BokBd]?n7QhOoG5aLodMW;_mXWS?oTLe7oj[YEOnAcDOoJYhdodUZ
;omLG5coQhN7okBd]?oBd];og]kN00Ooh>3P00?oooooohR8R?m4A4@01_m4
A4@00olc<c?oA4A4odA4A003odA4A004oiVIVOoPh>3o;Bd]ofMWI`;oh>3P
00Ko>3Phofm_KooPh>3oh>3Pohn?SolH61P2on3Ph007od=3@omTI6Coh>3P
on3Ph?o2`/;o0000oj6QX@05on3Ph003ocPh>?m_Kfooh>3P00;oh>3P00go
>3Phofm_KooPh>3oh>3Pohn?SolH61Soh>3Pokjn__l20P;oYZJVon3Ph?n;
Rh_o71`L00;oh>3P00?o>3Phofm_KooPh>001OoPh>000ol_;booIFEUon3P
h004on3Ph00:ocPh>?m_Kfooh>3Pon3Ph?nn_[ko0P82ojJVY_oPh>3oRh^;
oa`L70;oh>3P00?o>3Phofm_KooPh>005?oPh>000ooOgmooh>3PomoOg`02
omoOg`?oh>3P00GohN7QonOWioo/k>com?Cdol[:bP3oobQL]j3o:5bg000I
obQL]`04olc<c?ofm_Kol_;bon_[j`?oj>SX01?oinOWon;Rh_o=cLgoWinO
of]OGon?=RkokG5QooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[Geoo
WinOolg=cOoRh^;oinOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOofiVGonC
LR;okM54ooWcM?omoHgooOfEoogmS_oin7KokMM7oi=c8_m^IeooWinOolg=
cOoRh^;oinOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOof1XGom;O2?oT^5;
okgiNoo@oI;of?fKomCmUOo0nGkoV>Q=odf09?mPJEooWinOolg=cOoRh^;o
inOW00Koj>SX00?oooooodA4A?mVIVH00omgMgL00omVIVKoMgMgogMgM`05
ogMgM`05oc<c<oo<c<coj>SXobl_;om[Jf/00_oXj>P01_lj>S[oLg=conSX
j?oXj>SoU9BDoaTI6@;oj>SX00OoATI6ofMWIooXj>Soj>SXojb/[?l0003o
=cLg00?o>CTi00Co/[:bonSXj?lj>S[oLg=c0ooXj>P01_lj>S[oLg=conSX
j?oXj>SoU9BDoaTI6@;oj>SX00GoWIfMobd];Ol^;Rko<C4aoadM7@02onSX
j003ocXj>_mcLg?oj>SX00Goj>SX00?o<C4aofUYJOoXj>P01?oXj>P00olj
>S[oLg=conSXj002onSXj005oifMWOl];Bgo;Rh^oc4a<OlM7Ad00_oXj>P0
0olj>S[oLg=conSXj00MonSXj004onc/k?obl_;om_Kfolc<c?oo:5bgX?lX
G;L001Wo:5bg00?oclo?ooOgmoohn?P01?ohn?P04oogmoOok^k^olk>c_n@
T93oQBl[onUTE_okTXOooZJKoojaYOoo^:_oo[>VoojXW?okU8WokVQIohTa
:on@T93oc/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93oVFT[
oo2m?Ookh6koo_B2ooknR_oooi;oo_j<ookhPookiG3ol<8noiUZ:on@T93o
c/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93o@W<[ohC>@on]
kg?o`_j8olknT?oFoiOod?jBolKnROnbmGCoR==3odAe:on@T93oc/k>onk^
k_ogmoL01_ohn?P03?oooooo<c<conk^k_o^k^ko^k^kogMgMonZZZ[ooooo
onk^k_oMgMgoMgMgomgMg@;ok^k^00GoMgMgolc<c?ohn?So<S8bog9bLP02
ooShn006ochn?_mJFU[on?ShooShn?nHV9So71`L0_ohn?P03_m:BT[oKVi^
ooShn?ohn?Soe=CDo`000?nVYZKobLW9ol71`Ol20P;og]kNooShn?ln?Sko
IVIV0oohn?P01_ln?SkoFUYJooShn?ohn?SoV9RHoa`L70Con?Sh00?om_Kf
ohn?SolP82000_ohn?P00oln?SkoNg]kooShn005ooShn005oc@d=?lM7Ago
@T92od92@_mPH6000_ohn?P00oln?SkoIVIVooShn004ooShn003ooKfm_n?
Shoo820P00;on?Sh00?o?ShnofYZJ_ohn?P05_ohn?P00oogmoOon?ShooSh
n002ooShn006ooOgmooinOWomoOgooOgmoohn?Soclo?oolXG;NPobQL]`00
6OlXG;L01?oAdM7on_[jooGemOo^k^h2onc/k01<on_[jooYjNWogmoOokZj
^_miDU;o_c8TonMdJOomRGkooiR<oojRU_ooZ9cooZBHoonJSOonRWookWIZ
ol<c9?miDU;o^[ZjomoOgooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[o
R6EBon:A7?oi`e3ooMYSoooZL_onlgkoooZ2ookfOoook7?oo]iToo[7DOoR
TQcoRFICokZj^_oOgmooj^[Zon_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]
D_mAXacoTM9EojKWJ_nhnG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHL
oe9]D_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[joo/k>cojn_[onc/k?oooooo
<c<cooooooo^k^koMgMgo`0cc0;o<c<006KoA4A4oc<0<ol002;oIP1VogMg
MoooooooMgMgok^k^oo[jnco<30`ofa/K?o/k>cojn_[oc/k>olB4Q;oKFe]
olc<cOm@D53oATI6onc/k?oUiNGo@d=3ofATI?oQhN7oinOXonc/k?lj>S[o
Hf=Son?ShonBTY;o9bLWonc/k?o[jnco>c/koa4A4On6QXKod];Bon[Zj_lj
>S[o4Q8Bofa/KOo=cLgoD51@odM7Aoo[jn_ok>c/ojFUYOo9bLWoj>SYoeUI
FOm=CDgok>c/on_[jolk>c_oMGEeonc/k?o[jncok>c/on_[joo/k>cojn_[
oc4a<Om@D53o/K6aok2`/Onj^[[ojn_[onc/k?lj>S[o4A4AohF5QOoCdm?o
jNWZojJVY_o8b<SojNWYoeUIFOm=CDgojn_[onc/k?lj>S_o4a<Coh61POoF
e]Kojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>`7on_[j`07onc/k?o[jn_o
jn_[onk^k_ofm_KonOWiom7Ad@3oobQL]j3o:5bg000IobQL]`04omCDe?ok
no_olo?cong]k@;oiNGU04Soi^KVonCTi?oIfMWo/[:bogT^;_o8@SCohfYL
ooAjKOomR7cooYN:oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;o
f=SHonCTi?oUiNGoi^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^lA?on
c5?ooMQRookSL_onjGGoo^IcookKIOomc5?onl55onjN:onIERko/[:bomSH
f?oTi>CoiNGUonKVi_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on7bTSoUmaI
ojGUJOnblgOo^?IkokCeNOnWjV_oV=aIohW?BomS[R_o;V<^ok:b/_oHf=Wo
i>CTonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVoooooomgMgL2onk^kP1[ofIV
I_l0I_oo06K<odA4A?lc03?o<c<cogMgMolc03?oR8R8onk^k_mVIVKoc<c<
onGUi_l^;RkoJFUYonKVi_oUiNGoBd];ogemOOm]KFgo4A4BobTY:On`/;3o
i^KVog9bL_l71`Oo2PX:oaPH6?nLW9coi^KVolk>c_m0@43o2`/;oaTI6OnT
Y:Coi^KVonGUi_m;Bd_oNg]koe=CDol820Sof=SHod];BomnOWkoK6a]oa8B
4_lY:BWo/;2`onGUiOoVi^KoNg]kobd];Ol>3Pko<c<cok2`/?oVi^KoiNGU
ocTi>OmbLW;oi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo<30`ofQXJ?oVi^Ko
iNGVonKVi_oUiNGoi^KVod];BomkNg_oDe=Co`P82?oGemSoO7alob`/;?l>
3Pko<c<cok2`/?oUiNGoi^KVod];BommOGgoIFEUo`h>3_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiND00_oVi^H00ooUiNGoi^KVonKViP03onKV
iP05onGUiOo]kNgom?Cdoo_knooDe=@0oolXG;NPobQL]`006OlXG;L01?oF
e]Koo?clooShn?oalO43onk^kP0Con_[jooQhN7o_;blogXG5oo3?c;odeI9
onAXF_o_Mfcom8=iooR7O?oeQ7[olgU]onEYFooIF4[oa3lbog`G5onl_;co
hN7Qonc/k003onk^kP0Conc/k?oQhN7o_;blojE75ooVUc;omJ``oofl@Oom
bE?ooM1Poo_CIOomdV3oo/eDoofm@_oj[c;ojI/bojE65onl_;cohN7Qonc/
k003onk^kP0Conc/k?oQhN7o_;bloaMI5omOZ3;oM[dgohK=AonFeU[oX^1U
oj?PJOnShFOoUmYLohK>Aomg_cOoGj/boaMI5onl_;cohN7Qonc/k006onk^
kP05oooooolc<c?ok^k^omgMgOlA4A400_l0I_l03?lcI/co8R8RohR8R?nI
VIWo8R8RomgMgOo^k^koMgMgolc<c?o^k^ko<30`ofi^KPGok^k^00?okNg]
onk^k_o^k^h00_o^k^h00om7AdOoJVYZonk^kP04onk^kP03on_[joo^k^ko
k^k^00Gok^k^00?ojn_[onk^k_o^k^h00_o^k^h00oo]kNgok^k^onk^kP04
onk^kP03onc/k?o^k^kok^k^00;ok^k^00?o>c/kogIfM_o^k^h01Oo^k^h0
0olb<S;oK6a/onk^kP07onk^kP05on_[joo^k^kok^k^onk^k_o/k>`01oo^
k^h00oo]kNgok^k^onk^kP0Ionk^kP05ong]kOobl_;on?Shooclo?oFe]H0
oolXG;NPobQL]`006OlXG;L01OoIfMWooOgmoogmoOomoOgoo?cl00;ooOgm
01?oo?cloo?clooAdM7oJ0L7okPd=?o7?c?odU13omYREOoSKV;oi79TonA_
H_oLI5Oode53ola1=?ni=3CoJ`L7om;Bd_oclo?oo?cl00?ooOgm01?oo?cl
oo?clooBd];oWR/7omZ:=?o[VaWomJPYooRd?ooi_D[on;m=ooZoB_oi^3oo
mZXZonnN6OoKRcCoXRd7om;Bd_oclo?oo?cl00?ooOgm01?oo?cloo?clooB
d];o1d07odfJ=?mOZb3oL;P_ogo3@on:cE3oSLeBoh[>D?n1adCoLKT_of:^
8?m>VcCo1d87om;Bd_oclo?oo?cl00KooOgm00Kooooooc<c<oo^k^ko<c<c
oc<0<ol00142ob8R8P0;o`0c<olc03?o4@00o`000?lc<c?o^k^kogMgMonk
^k_ooOgmoc<c<omeMGD02_omoOd00ooNg]kog=cLoogmo@0Moogmo@03oclo
?omnOWkooOgm00GooOgm00?o=CDeobd];OmTI6@00_mTI6@00onf][KooOgm
oogmo@0Xoogmo@03ooclo?omoOgoo?cl00?ooOgm00?ofMWIobQL]olXG;L0
oolXG;NNobQL]`006OlXG;L0>ooKfm_ooOgmoo[jn_oclo?ok^k^oo3`l?o_
knook^k^onWYjOoCdm?oFadMoj8d=?nd:1go`CX]olM9??o?ET[od5M;om1G
B_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_
onk^k_oZj^[odm?Coh`U7Oo8LCCofH@MonBD5OoWWBCokZPcoo2Z=?o_ZS?o
k:0UonNG5OoLR1gob74doh`U7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`l?o^
k^koj^[Yom?CdolM>1go=88dodNE7OmJYA_oJJdZ00;oM;Ph017oMKThof^a
:omKYacoB9XMocB2=?lM>1godm?Con[ZjOo^k^kol?3`ono_koo`l?3okno_
oo3`l?o_knooooooogMgM`02ofHcIP12ogMgMon8R8SoIVIVoc<c0?l0<lco
06K<oc<0I_l0003oIS=Voc<c<omgMgOoc<c<oo3`konTY:Co_Kfmono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`oc/k>omgMgOokno_oo3`koo_
knool?3`ono_koo`l?3oY:BT1?n@T9009_o4a<Cokno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_0_o`
l?06ono_k`04oo?clooinOWoo_knom_Kfooo:5bgX?lXG;L001Wo:5bg00Co
g]kNookno_ogmoOol?3`1?oYjNT04OoWinOofm_Kof=;Bon1<S;oYSDeokHd
;Oo2CD7o`eA9olAEB_o3E4Wo`Te1okHd;OnU=CGoPC8bof=;BooKfm_oinOW
00GojNWY017oinOWom_Kfon9Bd_o[d/boleg=OoFRbgoh9`^on2P<_oQX3Co
h:0bomnJ;_oFRbgobWDeojm;<_n9Bd_ofm_KonOWi`05onWYj@0AonOWiooK
fm_oBd];oc9P<_ljRCGoDi/]of^[;om`[CSoKjhjog2]>?mZZRooDi/]ocV8
=OlbH3;oBd];om_KfooWinL01ooYjNT02OooooooA4A4oc<0<oo<0<coIS=V
ofIVI_lA003oVFH0olbI0002o`1Vc0;oV@2I00?o^k^kogMgMoo<c<`0;OoY
jNT00ooUiNGoinOWonWYj@0aonWYj@03onSXj?oYjNWojNWY00CojNWY00Co
l?3`ooOgmoono_kog]kNoolXG;NPobQL]`006OlXG;L01_oPh>3oo_knoo[j
n_odm?Cokno_oo7al@;ol?3`017okno_on_[jonEU9CoCb<SoiEDE?nkLg?o
diFEomZLW?oJWYcofIbLomBEUOnkLg?oUEADodlS8onEU9Coj^[Zono_k`05
oo3`l00Aono_kooZj^[oZIBDoh4S8onjJUCoe9YconBlUOoZaicojLNLon[7
W?oU_9Goe9Ycok]ZE?n18b?oZYBDon[Zj_o_knl01Oo`l?004Oo_knooj^[Z
oiBDU?lS:R?oE7YDog>ULonNaYGo[<jLojg>W?n/cYcoW/JEog>ULomDNUCo
8bXSoiBDU?oZj^[okno_00Ool?3`00Cooooooc<c<oo<c<coA4A40_l00000
2_lc03?oIVH0ooo<0?nIIP3oIP1Vol`0oomV06KoIS=VogMgMonk^k]Voo3`
l006oo7alOo`l?3om?Cdoo[jn_ono_koh>3PoolXG;NPobQL]`006OlXG;L0
1OoShn?ojo3hooooooooooooo_kn00;ooooo0_ono_h0AOomoOgon?Shofi^
K_mJ?coo/I2@omk9bOo`i>ColnKVoo3Ti?oNbLWo/I2@oeXo?om]KFgon?Sh
ooclo?ooooooo_knooooooono_koooonookno_ooooooo?clooShn?n=KFgo
RSloolVAT?oYd<Wom>WTooK[i_odjNCojM39olVAT?n9?cooSFe]ooShmool
o?coooooookno_ooooooo_knooooooono_koooonooclo?ohn?SoKFe]oclo
?on@WI3obMG9onC/i?oVk^Koi>cTolWEbOn@WI3o?cloofe]KOohn?Soo?cl
ooooo_ono_koooooookno_ooooooo_knooooooono_koooooogMgM`02onk^
kP03ob8R8_nI09WoIS=V00;oIP1V06Wo<`0coiUV0?lA4A7oc<c<onk^k_mg
MgOoc<c<ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooooono_h00_ooool0
0oono_koooooooooo`03ooooo`03on_`n?oShn?o:5bg0?oo:5bgWolXG;L0
01[o:5bg00Com_Kfookno_ojn_[om?Cd1OoalO403Oo_knooe]KFof][Jom3
?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?CgoJf][omKFe_o_knl02OoalO40
3Oo_knooemKFoh=[Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<S?mb?CgoPF][
omOFe_o_knl02OoalO403Oo_knooe]KFof][Jolm?CgoS8b<okZj^_o<cLco
^[Zjohb<S?lm?CgoJf][omKFe_o_knl02OoalO401_ooooooA4A4onk^k_nI
VIWo4A4AodA4A0;oc03<00CoV@2Io`0cI_o<V@3oMgMg0_o^k^h00omgMgOo
c<c<oo7al@1Noo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00Com?Cdoo[j
n_ono_kom_KfoolXG;NQobQL]`006_lXG;L01Oo^k^kooOgmooShn?o`l?3o
jn_[00?oj^[Z00gojNWYon[Zj_oYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV
9RKoFEUIoi^KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V
9_l]2@Wo@RHVofUIFOnPVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^K
oeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT02_oZj^X02Ooooooo
<c<conk^k_mgMgOo<c<cofIVI_lc<c?oc03<odA4A002o`0cIP05ogMgMoo^
k^kok^k^ogMgMonk^k/0I_oZj^X01Oo[jn_ol?3`ooShn?omoOgok^k^0?oo
:5bgXOlXG;L001[o:5bg00Co?ffnooCdm?ojn_[om?Cd2?oalO42oo3`l0?o
kno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;o
l?3`3?oalO400oooooooMgMgonk^kP03onk^kP06ok^k^omV<fKoooooonk^
k_nIVIWoR8R80_o^k^h00omgMgOoc<c<oo7al@1Qoo7al@03oo3`l?oalO7o
lO7a00;olO7a00ComOGeoo[jn_odm?Co?ffnoolXG;NQobQL]`006olXG;L0
0omFOlKomOGeooooo`18ooooo`03oc<c<oooooook^k^00[ok^k^00?oMgMg
olc<c?ooool0Ioooool00ooemOGoEWo6obQL]`3oobQL]j7o:5bg000LobQL
]`04ocm]__o^k^kom_Kfon_`n4Kooooo00?o<c<cogMgMomgMgL02omgMgMV
ooooo`04on_`n?ofm_Kok^k^ocm]__oo:5bgXolXG;L001oo:5bg_?oShn?o
obQL]jKo:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2obQL]`00
oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2
obQL]`00oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bg
oolXG;N2obQL]`00oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L0
0?oo:5bgoolXG;N2obQL]`00oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bg
P_lXG;L00?oo:5bgoolXG;N2obQL]`00oolXG;OoobQL]h;o:5bg003oobQL
]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2obQL]`00oolXG;OoobQL]h;o:5bg
003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2obQL]`00oolXG;OoobQL
]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2obQL]`00oolX
G;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2obQL
]`00oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolX
G;N2obQL]`00oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo
:5bgoolXG;N2obQL]`00oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lX
G;L00?oo:5bgoolXG;N2obQL]`00oolXG;OoobQL]h;o:5bg003oobQL]ooo
:5bgP_lXG;L00?oo:5bgoolXG;N2obQL]`00oolXG;OoobQL]h;o:5bg003o
obQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2obQL]`00oolXG;OoobQL]h;o
:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2obQL]`00oolXG;Oo
obQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2obQL]`00
oolXG;OoobQL]h;o:5bg003oobQL]ooo:5bgP_lXG;L00?oo:5bgoolXG;N2
obQL]`00oomoOgmGogmoO`OoOWinoomoOglTogmoO`0000Cojn_[onKVi_oR
h^;og]kN0ooMgMd0oooLg=cog]kNomkNg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMg@00
6_oNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomcLg?oMgMgofm_K0_oLg=`0<ooMgMgogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
gP02omcLg005omWIfOoHf=SoemOGomSHf?oIfMX00_oLg=`0oooNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
g=cMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNgP005ooMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN00?og]kN00?ogMgMomkNg_oN
g]h00ooMgMd1on7Qh@7oinOW0OoZj^X00003onc/k?oVi^Koh>3P00?ofMWI
00Sof=SHomWIfOoIfMWofMWIomSHf?oFe]Kodm?Com3@d0?ocLg=00Cod=3@
om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@
d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@
d=3odm?ComOGeooHf=SKomWIf@;of=SH00Koe]KFom?CdooCdm?oe=CDomOG
eooHf=P2omWIf@03omSHf?oIfMWofMWI00;of=SH2OoIfMT00ooHf=SofMWI
omWIf@02omSHf003omWIfOoHf=Sof=SH00;of=SH5ooIfMT01?oHf=Soe]KF
om;Bd_o?cll2olg=c@04olo?cooCdm?oemOGomSHf0_ofMWI00?of=SHomWI
fOoIfMT0oooIfMT8omWIf@03omSHf?oIfMWofMWI00KofMWI0OoNg]h1onKV
iP7ok>c/00001oo^k^kojNWYonCTi?oPh>3ohN7Qon3Ph?oRh^800_oQhN40
3OoNg]kog=cLom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?C
om_KfooOgml02OoQhN403OoOgmoofm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko
/[:bok^k^oo7alOodm?Com_KfooOgml02OoQhN403OoOgmoofm_Kom?Cdoo7
alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml0f_oQhN40
2OoPh>3ogmoOom_KfooFe]Koe=CDomKFe_oJf][og]kNon3Ph006omoOg`?o
h>3P00?ogmoOon3Ph?oPh>000_oPh>08omoOg`;og]kN0_oOgml3on3Ph0;o
gmoO0_oPh>02omoOg`goh>3P00GogmoOomgMgOoIfMWoeMGEom?Cd`02om;B
dP03omKFe_oLg=coh>3P0?oohN7Q6?oQhN400ooRh^;ohN7Qon;RhP04on7Q
h@7oi>CT0OoYjNT1ong]k@0000?ol?3`ono_kooalO400_o`l?02ono_k`3o
oo3`l?o^k^koj>SXom_Kfoo1`L7oY:BTohb<S?mkNg_oMgMgog]kNon<S8co
Y:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_oNg]kogMgMomkNg_oS8b<ojBT
Y?o2`/;of][Jon[Zj?o]kNgolO7aono_kooalO7okno_oo7alOo_knoolO7_
ong]kOoZj^[of][Jol;2`_nTY:CoS8b<og]kNomgMgKoNg]kohb<S?nTY:Co
`/;2om[Jf_oZj^[okNg]oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7a000Jono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo^k^kokno_on[Zj_oW
inL2on3Ph007on?Shoo[jnWojn_[on[Zj_oVi^Koj>SXonOWi`02onWYj@0B
onk^k?o/k>cok>c/onSXj?o/k>cokNg]oo3`l?o/k>coj^[XonKVi_oXj>So
inOWonWYjOoXj>Sojn_[onOWiooWinGoiNGU0_oYjNT03oo^k^kokNg]ong]
kOoXj>Sojn_Yonc/k?o^k^kojNWYon[Zj_o[jn_okno_onc/k?o/k>[oj^[Z
onk^kP02onc/k03oon[Zj_o_knook>c/onc/j_oZj^[ok^k^onc/k?n_[joo
MWIfoeUIFOm^KVko]kNfon3Ph?oYjNWokNg]oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7ok^k^oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_000]
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo`l?3okno_oo3`l?o_knool?3`ono_koo`l?3okno_
00Col?3`00000oobl_;ok^k^onOWi`04onGUi@0@onCTi?oOgmoodM7Aok6a
/On:RX[oIFEUoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:ROna/K7odM7A
omkNgP;oi>CT00?oiNGUonCTi?oUiN@00_oTi>@03ooNg]kodM7Aok6a/On:
RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7@omkN
gP02onCTi03]onGUiOoTi>CoiNGUonCTi?oTi>?og]kNom7AdOna/K7oRXZ:
ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6aom7AdOoNg]ko
i>CSonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGT00;oi>CT0?ooaLG5obPX:?m4A4CoT92@om7AdOoLg=_o
fm_KomOGeooDe=Coe]KFomCDe?oEeMGofMWIon3PgooNg]kof][JomCDe?oI
fMWog]kNon;Rh_oLg=coemOFomCDe?oFe]Koe=CDomGEeOoHf=Sofm_KomOG
eooFe]GoeMGEomOGeooHf=Sog]kNomoOgooLg=coeMGEomOGe_oLg=cogMgM
omOGeooFe]Kofm_Kon7QhOoNg]kofm_Jom[Jf_oNg]kog=cLom[Jf_oKfm_o
h>3PomoOgooLg=_ofMWIomkNg_oOgmooM7AdofMWIon=SHgoE5ADo`P82?nR
XZ;og=cLon;Rh_oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoShn?oiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUon?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>@005SoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
1?oUiND01_oTi>CoiNGUonGUiOoUiNGoj>SXong]k@7ol_;b00000oodm?Co
kNg]onOWi`03on3Ph00BomoOgooNg]kod];BokBd]?n7QhOoFe]Kofdk=OnN
CT;ocFmOonV3Koo=KeooWTi3ofdk=_mLG5coQhN7okBd]?oBd];og]kN1OoP
h>004OoNg]kod];BokBd]?n7QhOoG5aLofeP;?nNURkocLdoonWYCOo=cCoo
WYX_ofeS;OmLG5coQhN7okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd
];CoQhN7oeaLG?m7IbkoJ9hcoi7=AonZjEGoTLe7ofZN=?m9JRooG5aLohN7
Qond];Cod];BomkNgP3Ion3Ph006omoOgoo?clooVIVIoi:BT_lI6AWoS8b<
0_oEeMD07oo?cloo`/;2olk>c_o>c/koaLG5ol[:b_oJf][of=SHom3@d?o;
bl_oclo?omSHf?oJf][oeMGEolo?coo1`L7od=3@olk>c_o4a<Cobl_;omSH
f?oGemOo_[jnok^k^ooAdM7od=3@omGEeOoHf=Sodm?Colc<c?o>c/h00_oE
eMD01Oo>c/koc<c<om?CdooJf][of=SH00;od];B00Cof=SHomOGeooAdM7o
dm?C0_oIfMT01_oCdm?odM7AomOGeooHf=SodM7Aom3@d0;odM7A00CoATI6
od51@OoGemOog]kNL?oPh>000ooOgmooh>3Pon3Ph02Ron3Ph003omoOgooP
h>3ogmoO00;ogmoO0ooPh>000ooQhN7oinOWonc/k001ooCdm00000?om_Kf
oo;bl_o[jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWiooJemOohlf;_o]LF7o
nIf@oofaYOom_:oooKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;Rh_oW
inL00ooXj>P04ooWinOoh^;Rolg=cOnOWiooKVIOoi=b8_o]dDConO=doogm
SOomoIGooOf>ooWhM_o]edOoTg<RofiWGonOWioocLg=on;Rh_oWinL00ooX
j>P04ooWinOoh^;Rolg=cOnOWiooH6QOod]l8onBhD_o_OUkom3mT_oHoI_o
e?fEol3iO_nHj4goCH0Tof1YGonOWioocLg=on;Rh_oWinL0f_oXj>P01?oV
i^KohN7QoeeMGOm=CDd2omgMg@0Ooe1@D?l71`Oo5ADEohB4Q?lF5QKo@d=3
on;Rh_oMgMgoW9bLo`000?n?ShoogMgMon7QhOoKfm_o@410o`P82?lI6AWo
R8R8o`/;2omHF5So]kNgo``<3?l71`Oo8b<SobLW9ommOGgof][JomgMgOoD
e=Co2`/;oeUIF@02omWIf@03oeeMGOl;2`_odm?C00;ogmoO00KoFUYJodi>
C_oNg]kog]kNob<S8on4Q8@2on7Qh@0<ogYjN_l^;RkogMgMomgMgOo2`/;o
D51@oc<c<om^KVkoPh>3ob4Q8OoNg]koi^KVoooXj>POonSXj07ok>c/0Oob
l_81ooKfmP0001WomoOgooShn?ohn?Son?ShooOgmoohn?SomoOgonk^k_o>
c/koT92@ohD_:ooYI5KonY:7oojVVoon/JGookR[oojcY_onZ9coniB9oniX
FOn9<B_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@
oiUY:oo`_Cgonn1^ookdP_onoX[ooonBooknS?onn8?onnE`oo32?_nIJR_o
T92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@od9c:on4
cT?o[Nmcol;nR?o>oY3oe_nGom3nT_o6oXWo/_EdohSC@om4MB_oT92@olk>
c_o^k^komoOg0=[on?Sh02Gom_Kfoo7alOn1PH7o7alOong]kOo6a/Ko0000
ol?3`ooCdm?oG5aLo`P82?oZj^[ol?3`on[Zj_mBDU;o51@Docdm?OoYjNWo
l?3`ojn_[ol71`Ood];Bolg=cOm>CTko6a/Konk^k_oKfm_o[Zj^onSXj?o/
k>co[Zj^o`000?nd];Cok>c/ok2`/?l;2`_o6QXJ00;oi>CT00_o8b<So`h>
3_nTY:CokNg]onk^k_mPH63oE5ADonk^k_o]kNgo9RHVohf=S@02oo3`l00<
oh:2P_la<C7ok>c/on[Zj_m3@d?o;bl_oibLW?mcLg?o:RXZoaXJ6_o^k^ko
m_KfJOohn?P00oogmoOon?ShooShn005ooShn003ooOgmoohn?Son?Sh03;o
n?Sh00?omoOgooShn?ohn?P0K_ohn?P00oogmoOon?ShooShn002ooShn004
ooOgmooinOWomoOgooOgm`7on?Sh00000oojn_[omOGeonk^kP02onc/k03o
on_[jooYjNWogmoOokVi^OmiDU;o_c8TonMdJOomRGkooiR<oojRU_ooZ9co
oZBHoonJSOonRWookWIZol<c9?miDU;o^[ZjomoOgooZj^[ojn_[onc/k?o[
jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3ooMYSoooZL_onlgkoooZ2ookf
Ooook7?oo]iToo[7DOoRTQcoRFICokZj^_oOgmooj^[Zon_[joo/k>cojn_[
on[Zj_oOgmoo^[Zjoe9]D_mAXacoTM9EojKWJ_nhnG[o`?j2olOoROo3oXCo
^OekojO/K?nDeUOoDZHLoe9]D_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/0019onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/onWYjOoUiNGoNWYjoa`L7?oQhN;oc<c<o`<30onPX:3og]kNoiBD
U?lC4a?ohN7Qon3PhOo@d=3o1PH6oj6QXOl92@Wo_knoon7QhOnj^[[o0P82
ok:b/_oMgMgoP820obPX:?oShn?oinOWonGUiOoOgmoofm_Kom?Cdol820So
QHF5omoOgomYJFWoBTY:ocDe=On][Jgo_Kfmo`L71omhN7SoEEEEomoOgooP
h>3oFe]Koe1@D002on7Qh@0:ob@T9?n5QHGogmoOon7QhOmkNg_o;bl_on3P
h?oDe=Co1@D5ojRXZ0;ohn?S0?ooOWiooaHF5_oQhN7oj^[Zon_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn/001[ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k0Kojn_[00Gok>c/on_[joo[jn_ok^k^
ooKfmP01ooWin@0000?ono_koo?cloo]kNd00_oUiND0oooVi^Kohn?SomWI
fOnb/[;oNBh^olQ2=?oSJUcolgU/oof8O?onUh[ooY^>oojHRoonRWkom7]]
onM[GOo:@SCoNbh^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGVonCTi?oHf=So
/[:boiIE;_oZW2_onka4ook<Doomf6;oo^=bookYMOoniW?oo]]Uoog<Dook
`DGokYh[oiUF;_nb/[;of=SHonCTi?oUiNGoi^KVonGUiOoTi>Cof=SIok:b
/_l^HRkoHjd[ohO:B?nGg5WoYNEYok;cMonhmW_o]?EiojOZJonHg5WoRLm;
of>^:ol^Hbko/[:bomSHfOoTi>CoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiP00=?oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oShn?o
gmoOogMgMolK6a_og=cLon7QhOnNWYko;bl_ob/[:olb<S;o4Q8BomcLg?oJ
f]_oQ8B4ob0P8?oPh>3oDU9BofQXJ?oJf][og]kNoi2@T?lZ:R[o;Rh^ob`/
;?lW9bL2omkNgP0ComWIfOoCdmCod=3@oe]KFol0003o_Kfmom[Jf_lX:2So
QhN7ogMgN?mXJ6SoPX:2oc`l??o2`/;o3`l?omCDe?oJf][oFEUIodi>CP02
omcLg00Job<S8on1PH7oeMGEomOGeomgMgOo;Rh^omcLg?nSXj?o0000olO7
aooHf=SofMWIohf=S_lE5AGog=cLonCTi?oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^H2onGUi@2NonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^H2onGUi@1YonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGV00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGokNg]ooCd
m001oo_kn`0000?oo?clooShn?oalO400oo^k^h04oo[jn_ohN7Qokbl_?mj
5aOo`clbom9EB?oTJ5[okgM/ooB3NOohQgcomHAjoo=iKOoUJE_ofEQ:ol@o
<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?nUAaOoiYLb
ooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlbonVK<_nUAQOo
_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOoGjPbogJm=on6
cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lGFAOo_;blon7Q
hOo/k>`0f_o^k^h0;_o/k>coinOWog]kNolL71coi>CTonWYjOoVi^KohN7Q
omkNg_n=SHgo51@DonKVi_oTi>Co=CDeogUiNOo[jn_o/[:boaDE5OoOgmoo
i^KVonCTi?oQhN7ogMgMogYjN_lY:BWoj>SXonGUiOoMgMgo/K6aobHV9_l;
2`_oVi^KonWYjOo<c<co0000olk>c_o3`l?o9BDUod];BomlO7coj>SXoc4a
<OnUYJGoi>CToeeMGOmADE42onOWi`0:obDU9OmYJFWogmoOomoOgomgMgOo
<C4aonWYjOo1`L7o0000ojNWY`;ogmoO00CoTi>CoaHF5_oWinOok>c/Joo^
k^h00oo]kNgok^k^onk^kP02onk^kP03ong]kOo^k^kok^k^0:[ok^k^00?o
kNg]oo;bl_ohn?P00Oolo?`000?ooOgm01Koo?cloogmoOomoOgoo?cloo?c
looAdM7oJ0L7okPd=?o7?c?odU13omYREOoSKV;oi79TonA_H_oLI5Oode53
ola1=?ni=3CoJ`L7om;Bd_oclo?oo?cl0oomoOd04oolo?colo?com;Bd_nN
:`OofXXdon^K6OoeZ2Won;@oooVmB_oh_dgon[m:ooVh?oofZR[okihIom^;
=?nR;@Ood];Boo?cloolo?`00oomoOd04oolo?colo?com;Bd_l7@0OoCIXd
oen[8?m`^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^BooHZhPodjK=?l7@POo
d];Boo?cloolo?`0f_omoOd08ookno_omoOgohB4Q?lN7Qkolo?cooWinOnc
/k?od=3@oo?clomXJ6SoAdM7oo[jn_oDe=Co0000omgMgOolo?cono_kobLW
9onXZ:SonOWioj^[ZooEeMGolO7aoeADE?mNGUkonOWiooCdm?nDU9Co1@D5
od10@?oAdM7omoOgooShn?nGUiOo:b/[00;on_[j01_o92@To`L71oo8b<So
no_kohF5QOmSHf?omoOgof=SHomGEeOon?ShooWinOlW9bOo5ADEoh>3PooG
emOo@T92of=SHookno_on_[joc@d=?m9BDWofm_KonGUiOm?Cdoo5aLGoo[j
n_olo?`0ooomoOdLoogmo@03ooclo?omoOgoo?cl00?ooOgm0000>_omoOgo
n_[joo?cloo^k^kol?3`ono_koo^k^kojNWYom?CdomJ71coXS@dok@X7Oo1
>BcoadTlolmFB_o@Ed_od5M:olY:?_o3>bko]RPMoj8d=?mL7Agodm?Con[Z
j_o^k^kol?3`ono_koo`l>ook^k^on[Zj_oCdm?oS2DMolQa=?oIQ1goi9@E
onNM9?o^Z3?ol:XdonnZ<oo/X2GoiiLEomb87Oo8LCCoS2DMom?CdooZj^[o
k^k^oo3`l?o_knool?3`onk^k_oZj^Wodm?Coadh7OldPSCoAiDMoeZU6omY
[BX2ogBh>03RogFi>?m[/B_oFjLLodRJ7OldPSCo7CPMom?CdooZj^Wok^k^
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l0;okno_0?ooj^[ZoginO_lL71coj>SWong]kOn8R8So
<30`o`l?3ola<C7o/K6aonk^k_n5QHCoCDe=ono_koo^k^kokno_ohZ:R_mI
FEWok^k^ogQhN?l[:b_o3`l?ocPh>?no_kookNg]onCTi?l>3PkoJFUYomoO
gooShn?oiNGUon_[jomQHF7oMgMgonk^k_o_knkoMWIfobHV9_o]kNgokno_
olc<c?l/;2coj^[Zofe]K?mRHV;ok>c/ong]kOlk>c_oTi>Cof9RH_l>3Pko
=3@dolC4a?o_knook^k^om7AdOll?3co2PX:obLW9om/K6co;2`/ono_koo^
k^kol?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3ok^k^oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o^k^kol?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knl005Kol?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_k`;ol?3`1_o_
knl1oo?cl`7onOWi0Oono_h00003ookno_ogmoOol?3`00;ojNWY01?oj>SX
onWYjOoVi^Kofm_Kof=;Bon1<S;oYS@dokHd;Oo2CD7o`eA9olAEB_o3E4Wo
`Te1okHd;OnU=CGoPC8bof=;BooKfm_oinOW00GojNWY017oinOWom_Kfon9
Bd_o[d/boleg=OoFRbgoh9`^on2P<_oQX3Coh:0bomnJ;_oFRbgobWDeojm;
<_n9Bd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oBd];oc9P<_ljRCGoDi/]
of^[;om`[CSoKjhjog2]>?mZZRooDi/]ocV8=OlbH3;oBd];om_KfooWinL0
fooYjNT01_oXj>Soi^KVog]kNolL71coi>CTonSXj0;ojNWY00?oinOWonWY
jOoYjNT02ooYjNT03?oWinOojNWYonWYjOoXj>Sof=SHo`X:2_n^[ZkogMgM
omkNg_oPh>3oiNGUonSXj0SojNWY00Koj>SXonKVi_oShn?ohn?SonKVi_oX
j>P3onWYj@03onSXj?oYjNWojNWY00CojNWY00?oinOWonWYjOoYjNT03ooY
jNT00ooXj>SojNWYonWYj@2GonWYj@03onSXj?oYjNWojNWY00?ojNWY00?o
j>SXonWYjOoYjNT0J?oYjNT00ooXj>SojNWYonWYj@04onWYj@7ol?3`0Oog
moL1ooknoP0000Coo_knoo[jn_odm?Cokno_0oo`l?004Oo_knoojn_[oiFD
U?m?8b?oUEADok]cLooCUIGofYbLomZNW?oIW9coe9FEok]cLonEE5CoCb<S
oiFDU?oZj^[okno_00Gol?3`017okno_on[Zj_nYU9CoPB<SokYZE?oDVW?o
i;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S8onZU9Coj^[Zono_k`05
oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCoLjEcoik6UOn/cYco[LjLojc>
W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Zj_o_knl0foo`l?02ono_k`04oh20
P?lM7Agok^k^ono_ka?ol?3`0_o_knl01omTI6Co:BTYoh61POmSHf?o>c/k
onk^k_o_knl02?o`l?001_o_knook^k^og=cLomYJFWok^k^ono_k`[ol?3`
00?okno_oo3`l?o`l?00KOo`l?02ono_kk3ol?3`00ColO7aoo3`l?odm?Co
n_[j0Oono_h00004ong_l_ooooooooooooknoP;ooooo0_ono_h0ooomoOgo
moOgofi^K_mJ?coo/I2@omk9bOo`i>ColnKVoo3Ti?oNbLWo/I2@oeXo?om]
KFgon?Shooclo?ooooooo_knooooooono_koooonookno_ooooooo?clooSh
n?n=KFgoRSloolVAT?oYd<Wom>WTooK[i_odjNCojM39olVAT?n9?cooSFe]
ooShmoolo?coooooookno_ooooooo_knooooooono_koooonooclo?ohn?So
KFe]oclo?on@WI3obMG9onC/i?oVk^Koi>cTolWEbOn@WI3o?cloofe]KOoh
n?Soo?clooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooooknoP00>?ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooooOgmom3@
d?nUYJGoo_kmookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooomoOgo`L70og5aLOn1PH7o[jn_0_ono_h03?ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooomoOgo`/;1okbl_0;oo_kn0?oo
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooool002Woo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooooknoP02ooooo`03ookno_oooooooooo00?ooooo0Ook
o?`00004olC<doono_kon_[joo?cl`GolO7a00gokno_omKFe_m[Jf_o@cdm
oi^<S?o6^[[oe/c<olNj^_nKS8co@cdmof][JooFe]Kokno_00WolO7a00go
kno_omOFe_n3Jf_oM3dmokF<S?oE^[[ohLc<omJj^_nfS8coLSdmoh5[JooG
e]Kokno_00WolO7a00gokno_omKFe_m[Jf_o?Cdmohb<S?nj^[[oc<g<okZj
^_n<S8co?Cdmof][JooFe]Kokno_0?oolO7a5_oalO400oo`l?3olO7aoo7a
l@0Aoo7al@03oo3`l?oalO7olO7a09golO7a00?ol?3`oo7alOoalO40I_oa
lO401?o`l?3olO7aoo7alOo`l?04oo7al@03ooCdm?ojn_[oo_kn007olO;d
00005On:V:?ooOgmooShn?o`l?3ojn_[on[Zj_oYjNWoj^[ZonWYjOoZj^[o
jNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0;
on[ZjP0;onWYjOoXj>SoX9^KofYIFOm39RKo;@T9od8V9_mYFEWoX9^KonSX
j?oYjNT02ooZj^X02ooYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUI
oi^KVooXj>SojNWY0?ooj^[Z:_oZj^X00ooYjNWoj^[Zon[ZjP2Lon[ZjP03
onWYjOoZj^[oj^[Z06ooj^[Z00Cojn_[oo3`l?ohn?SooOgm0OoFf]/00004
od5@G_nla/gon_[joo?cl`SolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`
l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l?oolO7aoooalO4joo7a
l@03oo3`l?oalO7olO7a00;olO7a00?omOGeooWinOo]ko000OnTYjX00003
obDlC_mAHg3o^lG<0?oooooooooooomlooooo`7ol??d0Ona][P1ojbb]@00
00Ko:D1Gob8iC?lhBUWoQY6Mol78c_o/k_3oooooooooooooM_ooool01Ooi
n__ok_3aomGIfonMXjKoWjJZ007o][g20000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell["\<\
A desktop is created. Internal frames are added to this desktop. \
The close box of the internal frame is handled correctly.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(desktop = NewJDesktopPane[pane]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JDesktopPane"] \[RightGuillemet]\),
      JLink`Objects`JavaObject36689556799489]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(icon = 
        NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<NB(S).GIF\>"]];\)\)], "Input"],

Cell[BoxData[{
    \(\(internalFrames = {};\)\), "\n", 
    \(Do[\[IndentingNewLine]internalFrames = 
        AppendTo[\[IndentingNewLine]internalFrames, 
          NewJInternalFrame[\[IndentingNewLine]desktop, 
            Null, \[IndentingNewLine]StringJoin["\<Internal Frame - \>", 
              ToString[i]], \[IndentingNewLine]Round[25  i], 
            Round[25 \((i + 1)\)], 200, 250, \[IndentingNewLine]True, True, 
            True, True, \[IndentingNewLine]icon\[IndentingNewLine]]\
\[IndentingNewLine]]; \[IndentingNewLine]layer@
        repaint[];, \[IndentingNewLine]{i, 1, 
        5}\[IndentingNewLine]]\), "\n", 
    \(frame@repaint[]\), "\n", 
    \(JavaShow[frame]\), "\[IndentingNewLine]", 
    \(internalFrames[\([1]\)]@setSelected[True]\)}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(Do[\[IndentingNewLine]internalFrames[\([i]\)]@
        dispose[]; \[IndentingNewLine]ReleaseObject[
        internalFrames[\([i]\)]];, \[IndentingNewLine]{i, 1, 
        5}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(DeleteJObject[pane, desktop]\)], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JSplitPane <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP3oSXj>
ohj>SWR>SXh01?ooohS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hIVIV
0?ooooooooooMoooo`05SXj>ooooR<2hR<2hB928004000000007R<2hb>3H
R<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1
B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<
00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_oo
ohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007
R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo
00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<
c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0
^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R040
00000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003oooo
SXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0
olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SP
f8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h
0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<
c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKo
oon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P100000000
1hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_oo
o`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<co
c<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8
`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1
000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00ooo
ohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>
0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8
h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0
^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<
c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIV
ooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@000000
00N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXko
ool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<
olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2h
R<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B928
0@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?o
oon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>
SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2h
b>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8
`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<ad
c<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IV
I_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R0400000
0007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>
oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<
c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0
^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@
R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003
ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>
SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0
^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02
R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<
M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QV
IVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P10000
00001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>
S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<
c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8
`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058
T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`0
0oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVoooo
SXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8
`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool0
0XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<
c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2h
IVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00
000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>
SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3o
c<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3H
R<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1
B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<
00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_oo
ohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007
R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo
00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<
c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0
^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R040
00000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003oooo
SXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0
olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SP
f8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h
0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<
c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKo
oon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P100000000
1hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_oo
o`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<co
c<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8
`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1
000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00ooo
ohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>
0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8
h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0
^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<
c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIV
ooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@000000
00N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXko
ool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<
olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2h
R<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B928
0@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?o
oon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>
SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2h
b>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8
`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<ad
c<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IV
I_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R0400000
0007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>
oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<
c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0
^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@
R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003
ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>
SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0
^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02
R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<
M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QV
IVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P10000
00001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>
S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<
c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8
`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058
T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`0
0oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVoooo
SXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8
`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool0
0XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<
c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2h
IVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00
000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>
SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3o
c<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3H
R<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1
B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<
00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_oo
ohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007
R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo
00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<
c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0
^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R040
00000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003oooo
SXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0
olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SP
f8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h
0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<
c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKo
oon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P100000000
1hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_oo
o`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<co
c<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8
`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1
000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00ooo
ohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>
0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8
h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0
^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<
c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIV
ooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@000000
00N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXko
ool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<
olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2h
R<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B928
0@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?o
oon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>
SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2h
b>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8
`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<ad
c<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IV
I_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R0400000
0007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>
oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<
c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0
^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@
R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003
ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>
SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0
^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02
R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<
M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QV
IVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P10000
00001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>
S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<
c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8
`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058
T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`0
0oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVoooo
SXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8
`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool0
0XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<
c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2h
IVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00
000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>
SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3o
c<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3H
R<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1
B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<
00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_oo
ohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007
R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo
00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<
c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0
^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R040
00000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003oooo
SXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0
olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SP
f8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h
0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<
c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKo
oon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P100000000
1hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_oo
o`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<co
c<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8
`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1
000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00ooo
ohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>
0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8
h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0
^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<
c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIV
ooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@000000
00N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXko
ool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<
olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2h
R<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B928
0@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?o
oon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>
SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2h
b>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8
`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<ad
c<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IV
I_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R0400000
0007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>
oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<
c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0
^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@
R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003
ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>
SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0
^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02
R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<
M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QV
IVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P10000
00001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>
S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<
c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8
`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058
T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`0
0oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVoooo
SXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8
`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool0
0XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<
c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2h
IVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00
000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>
SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3o
c<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3H
R<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1
B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<
00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_oo
ohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007
R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo
00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<
c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0
^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R040
00000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003oooo
SXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0
olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SP
f8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h
0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<
c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKo
oon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P100000000
1hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_oo
o`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<co
c<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8
`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1
000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00ooo
ohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>
0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8
h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0
^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<
c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIV
ooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@000000
00N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXko
ool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<
olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2h
R<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B928
0@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?o
oon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>
SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2h
b>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8
`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<ad
c<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IV
I_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R0400000
0007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>
oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<
c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0
^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@
R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003
ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>
SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0
^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02
R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<
M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QV
IVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P10000
00001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>
S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<
c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8
`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058
T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`0
0oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVoooo
SXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8
`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool0
0XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<
c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2h
IVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00
000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>
SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3o
c<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3H
R<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1
B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<
00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_oo
ohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007
R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo
00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<
c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0
^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R040
00000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003oooo
SXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0
olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SP
f8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h
0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<
c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKo
oon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P100000000
1hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_oo
o`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<co
c<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8
`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1
000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00ooo
ohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>
0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8
h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0
^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<
c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIV
ooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@000000
00N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXko
ool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<
olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2h
R<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B928
0@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?o
oon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>
SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2h
b>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8
`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<ad
c<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IV
I_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R0400000
0007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>
oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<
c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0
^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@
R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003
ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>
SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0
^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02
R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<
M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QV
IVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P10000
00001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>
S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<
c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8
`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058
T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`0
0oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVoooo
SXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8
`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool0
0XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<
c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2h
IVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00
000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>
SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3o
c<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3H
R<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1
B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<
00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_oo
ohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007
R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo
00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<
c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0
^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R040
00000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003oooo
SXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0
olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SP
f8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h
0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<
c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKo
oon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P100000000
1hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_oo
o`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<co
c<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8
`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1
000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00ooo
ohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>
0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8
h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0
^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<
c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIV
ooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@000000
00N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXko
ool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<
olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2h
R<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B928
0@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?o
oon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>
SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2h
b>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8
`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<ad
c<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IV
I_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R0400000
0007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>
oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<
c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0
^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@
R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003
ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>
SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001hS0
^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02
R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<
M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QV
IVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058T8P10000
00001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`00oooohj>
S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<
c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8`;S8h=R8
`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool00XS0^058
T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<c7C<c<`0
0oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2hIVIVoooo
SXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00000000N8
`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>SXkoool0
0XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3oc<c<olc<
c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3HR<2hR<2h
IVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1B9280@00
000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<00?ooon>
SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooohj>SP3o
c<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007R<2hb>3H
R<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo00:8`;P1
B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<c<adc<c<
00?ooon>SXkoool00XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_oo
ohj>SP3oc<c<olc<c7C<c<`00oooohj>S_ooo`02R<2h0DR@R04000000007
R<2hb>3HR<2hR<2hIVIVooooSXj>0?o<c<coc<c<M<c<c003ooooSXj>oooo
00:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKooon>SXh0olc<c?o<
c<adc<c<00?ooon>SXkoool00XS0^058T8P1000000001XS0^<SPf8S0^8S0
^6IVI_oooon>SXkoSXj>MHj>SP03ooooSXj>oooo00:8`;P1B9280@000000
00F8`;S8h=R8`;R8`;QVIVH0oooooooooomgoooo00F>SXkooon8`;R8`;Q8
T8P00@00000000B8`;S8h=R8`;R8`;SoIVIVofIVIWYVIVH2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h1Lc<c0Soool7c<c<00?oooo<c<c<c<`0olc<
c?o<c<aSc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0C<c<`00`00
06IVVFIVV@05IVJI1lc<c09VIYT00oooolc<c<c<c03oc<c<olc<c6;<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c0030000IVJIIVJI00=V
IYT7c<c<16IVV@03ooooc<c<c<c<00?<c<`01FIVI/c<c<c<c<c<c6IVIP03
c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c005IVIVc<c<c<c<c<c<IVIV00?<
c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<
c005IVIVc<c<c<c<c<c<IVIV00?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<
00EVIVK<c<c<c<c<c<aVIVH00lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`0
1FIVI/c<c<c<c<c<c6IVIP03c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c005
IVIVc<c<c<c<c<c<IVIV00?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00EV
IVK<c<c<c<c<c<aVIVH00lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`01FIV
I/c<c<c<c<c<c6IVIP03c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c005IVIV
c<c<c<c<c<c<IVIV00?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00EVIVK<
c<c<c<c<c<aVIVH00lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`01FIVI/c<
c<c<c<c<c6IVIP03c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c005IVIVc<c<
c<c<c<c<IVIV00?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00EVIVK<c<c<
c<c<c<aVIVH00lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`01FIVI/c<c<c<
c<c<c6IVIP03c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c005IVIVc<c<c<c<
c<c<IVIV00?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00EVIVK<c<c<c<c<
c<aVIVH00lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`01FIVI/c<c<c<c<c<
c6IVIP03c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c005IVIVc<c<c<c<c<c<
IVIV00?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00EVIVK<c<c<c<c<c<aV
IVH00lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`01FIVI/c<c<c<c<c<c6IV
IP03c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c005IVIVc<c<c<c<c<c<IVIV
00?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00EVIVK<c<c<c<c<c<aVIVH0
0lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`01FIVI/c<c<c<c<c<c6IVIP03
c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c005IVIVc<c<c<c<c<c<IVIV00?<
c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<
c005IVIVc<c<c<c<c<c<IVIV00?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<
00EVIVK<c<c<c<c<c<aVIVH00lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`0
1FIVI/c<c<c<c<c<c6IVIP03c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c005
IVIVc<c<c<c<c<c<IVIV00?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00EV
IVK<c<c<c<c<c<aVIVH00lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`01FIV
I/c<c<c<c<c<c6IVIP03c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c005IVIV
c<c<c<c<c<c<IVIV00?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00EVIVK<
c<c<c<c<c<aVIVH00lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`01FIVI/c<
c<c<c<c<c6IVIP03c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c005IVIVc<c<
c<c<c<c<IVIV00?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00EVIVK<c<c<
c<c<c<aVIVH00lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`01FIVI/c<c<c<
c<c<c6IVIP03c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c005IVIVc<c<c<c<
c<c<IVIV00?<c<`016IVI/c<c<c<c<c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P6c<c<00@0001VIYUVIYUVIYT7c<c<1VIVV@05ooooc<c<c<c<
c<c<oooo00?<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00Goooo<c<c<c<c<
c<coool00lc<c005ooooc<c<c<c<c<c<oooo00?<c<`01Oooolc<c<c<c<c<
c?ooo`03c<c<00Goooo<c<c<c<c<c<coool00lc<c005ooooc<c<c<c<c<c<
oooo00?<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00Goooo<c<c<c<c<c<co
ool00lc<c005ooooc<c<c<c<c<c<oooo00?<c<`01Oooolc<c<c<c<c<c?oo
o`03c<c<00Goooo<c<c<c<c<c<coool00lc<c005ooooc<c<c<c<c<c<oooo
00?<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00Goooo<c<c<c<c<c<coool0
0lc<c005ooooc<c<c<c<c<c<oooo00?<c<`01Oooolc<c<c<c<c<c?ooo`03
c<c<00Goooo<c<c<c<c<c<coool00lc<c005ooooc<c<c<c<c<c<oooo00?<
c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00Goooo<c<c<c<c<c<coool00lc<
c005ooooc<c<c<c<c<c<oooo00?<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<
00Goooo<c<c<c<c<c<coool00lc<c005ooooc<c<c<c<c<c<oooo00?<c<`0
1Oooolc<c<c<c<c<c?ooo`03c<c<00Goooo<c<c<c<c<c<coool00lc<c005
ooooc<c<c<c<c<c<oooo00?<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00Go
ooo<c<c<c<c<c<coool00lc<c005ooooc<c<c<c<c<c<oooo00?<c<`01Ooo
olc<c<c<c<c<c?ooo`03c<c<00Goooo<c<c<c<c<c<coool00lc<c005oooo
c<c<c<c<c<c<oooo00?<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00Goooo<
c<c<c<c<c<coool00lc<c005ooooc<c<c<c<c<c<oooo00?<c<`01Oooolc<
c<c<c<c<c?ooo`03c<c<00Goooo<c<c<c<c<c<coool00lc<c005ooooc<c<
c<c<c<c<oooo00?<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00Goooo<c<c<
c<c<c<coool00lc<c005ooooc<c<c<c<c<c<oooo00?<c<`01Oooolc<c<c<
c<c<c?ooo`03c<c<00Goooo<c<c<c<c<c<coool00lc<c005ooooc<c<c<c<
c<c<oooo00?<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00Goooo<c<c<c<c<
c<coool00lc<c005ooooc<c<c<c<c<c<oooo00?<c<`01Oooolc<c<c<c<c<
c?ooo`03c<c<00Goooo<c<c<c<c<c<coool00lc<c005ooooc<c<c<c<c<c<
oooo00?<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00Goooo<c<c<c<c<c<co
ool00lc<c005ooooc<c<c<c<c<c<oooo00?<c<`01Oooolc<c<c<c<c<c?oo
o`03c<c<00Goooo<c<c<c<c<c<coool00lc<c005ooooc<c<c<c<c<c<oooo
00?<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00Goooo<c<c<c<c<c<coool0
0lc<c005ooooc<c<c<c<c<c<oooo00?<c<`01Oooolc<c<c<c<c<c?ooo`03
c<c<00Goooo<c<c<c<c<c<coool00lc<c005ooooc<c<c<c<c<c<oooo00?<
c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00Goooo<c<c<c<c<c<coool00lc<
c005ooooc<c<c<c<c<c<oooo00?<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<
00Goooo<c<c<c<c<c<coool00lc<c005ooooc<c<c<c<c<c<oooo00?<c<`0
1Oooolc<c<c<c<c<c?ooo`03c<c<00Goooo<c<c<c<c<c<coool00lc<c005
ooooc<c<c<c<c<c<oooo00?<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00Go
ooo<c<c<c<c<c<coool00lc<c005ooooc<c<c<c<c<c<oooo00C<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1lc<c0800007c<c<20000?o<c<co
c<c<H/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0
^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP3oc<c<olc<c7S<c<`01?oo
ohS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hIVIV0?o<c<coc<c<N<c<
c004ooooR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c?nI
VIWoVIVIM9VIV@;<c<`01?ooohS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<
c?ooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVI
c<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P10000
00001HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`
c<c<00BIVIW<c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2h
IVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?oo
o`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<
c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P100000000
1HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<
00BIVIW<c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV
00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8
`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<
0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0
^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BI
VIW<c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<
c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1
B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<
c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0^<SP
f8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<
c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`0
0iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B928
0@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<c<co
c<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0^<SPf8S0
^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<
c<coool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVI
VLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B9280@00
000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<c<coc<c<
L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0
^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<c<co
ool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<
c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B9280@000000
00F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<c<coc<c<L<c<
c004VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IV
IP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<c<coool2
R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<c<c<
c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B9280@00000000F8
`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<c<coc<c<L<c<c004
VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP02
c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<c<coool2R<2h
0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<c<c<c03o
c<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B9280@00000000F8`;S8
h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<c<coc<c<L<c<c004VIVI
c<c<c<c<oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP02c<c<
00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<c<coool2R<2h0DR@
R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<
olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B9280@00000000F8`;S8h=R8
`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<
c<c<oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP02c<c<00>I
VIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<c<coool2R<2h0DR@R040
00000005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<
c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8
`;QVIVH00/c<c003VIVIc<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<
oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<
c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<c<coool2R<2h0DR@R0400000
0005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<
c<`019VIVLc<c<c<c?ooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QV
IVH00/c<c003VIVIc<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo
0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<
c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<c<coool2R<2h0DR@R04000000005
R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`0
19VIVLc<c<c<c?ooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH0
0/c<c003VIVIc<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0
^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0
olc<c?o<c<a`c<c<00BIVIW<c<c<c<coool2R<2h0DR@R04000000005R<2h
b>3HR<2hR<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VI
VLc<c<c<c?ooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<
c003VIVIc<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058
T8P1000000001HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<
c?o<c<a`c<c<00BIVIW<c<c<c<coool2R<2h0DR@R04000000005R<2hb>3H
R<2hR<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<
c<c<c?ooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003
VIVIc<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P1
000000001HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<
c<a`c<c<00BIVIW<c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2h
R<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<
c?ooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVI
c<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P10000
00001HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`
c<c<00BIVIW<c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2h
IVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?oo
o`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<
c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P100000000
1HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<
00BIVIW<c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV
00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8
`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<
0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0
^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BI
VIW<c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<
c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1
B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<
c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0^<SP
f8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<
c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`0
0iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B928
0@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<c<co
c<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0^<SPf8S0
^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<
c<coool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVI
VLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B9280@00
000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<c<coc<c<
L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0
^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<c<co
ool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<
c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B9280@000000
00F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<c<coc<c<L<c<
c004VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IV
IP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<c<coool2
R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<c<c<
c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B9280@00000000F8
`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<c<coc<c<L<c<c004
VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP02
c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<c<coool2R<2h
0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<c<c<c03o
c<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B9280@00000000F8`;S8
h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<c<coc<c<L<c<c004VIVI
c<c<c<c<oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP02c<c<
00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<c<coool2R<2h0DR@
R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<
olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B9280@00000000F8`;S8h=R8
`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<
c<c<oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP02c<c<00>I
VIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<c<coool2R<2h0DR@R040
00000005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<
c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8
`;QVIVH00/c<c003VIVIc<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<
oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<
c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<c<coool2R<2h0DR@R0400000
0005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<
c<`019VIVLc<c<c<c?ooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QV
IVH00/c<c003VIVIc<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo
0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<
c<`0olc<c?o<c<a`c<c<00BIVIW<c<c<c<coool2R<2h0DR@R04000000005
R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`0
19VIVLc<c<c<c?ooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH0
0/c<c003VIVIc<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0
^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0
olc<c?o<c<a`c<c<00BIVIW<c<c<c<coool2R<2h0DR@R04000000005R<2h
b>3HR<2hR<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VI
VLc<c<c<c?ooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<
c003VIVIc<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058
T8P1000000001HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<
c?o<c<a`c<c<00BIVIW<c<c<c<coool2R<2h0DR@R04000000005R<2hb>3H
R<2hR<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<
c<c<c?ooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003
VIVIc<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P1
000000001HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<
c<a`c<c<00BIVIW<c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2h
R<2hIVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<
c?ooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVI
c<c<c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P10000
00001HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`
c<c<00BIVIW<c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2h
IVIV00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?oo
o`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<
c<c<0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P100000000
1HS0^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<
00BIVIW<c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV
00;<c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8
`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<
0?o<c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0
^<SPf8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BI
VIW<c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<
c<`00iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1
B9280@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<0?o<
c<coc<c<L<c<c004VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0^<SP
f8S0^8S0^6IVIP02c<c<00>IVIW<c<c<c<`0olc<c?o<c<a`c<c<00BIVIW<
c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`0
0iVIVLc<c<c<c03oc<c<olc<c73<c<`019VIVLc<c<c<c?ooo`:8`;P1B928
0@00000000F8`;S8h=R8`;R8`;QVIVH00/c<c003VIVIc<c<c<c<00G<c<`2
00000lc<c0800002c<c<0P000003c<c<0000000000;<c<`40000olc<c?o<
c<aGc<c<00BIVIW<c<c<c<coool2R<2h0DR@R04000000005R<2hb>3HR<2h
R<2hIVIV00;<c<`00iVIVLc<c<c<c005c<c<0P0000?<c<`2000000?<c<`0
000000000/c<c08000000lc<c00000000002c<c<0P000?o<c<coc<c<E/c<
c004VIVIc<c<c<c<oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IV
IP02c<c<00>IVIW<c<c<c<`01Lc<c0800003c<c<0P000003c<c<00000000
00;<c<`2000000?<c<`000000000olc<c?o<c<aJc<c<00BIVIW<c<c<c<co
ool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`00iVIVLc<
c<c<c005c<c<0P0000?<c<`2000000?<c<`0000000000/c<c08000000lc<
c000000000040000olc<c?o<c<aFc<c<00BIVIW<c<c<c<coool2R<2h0DR@
R04000000005R<2hb>3HR<2hR<2hIVIV00;<c<`5VIVI0lc<c0800003c<c<
0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c0800002
c<c<oiVIVOnIVIUEVIVI0/c<c004ooooR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;QVIVH02/c<c0800003c<c<0P000003c<c<0000000000;<c<`2
000000?<c<`0000000000/c<c080003oc<c<olc<c5W<c<`01?ooohS0^8S0
^4R@R04000000005R<2hb>3HR<2hR<2hIVIV00[<c<`200000lc<c0H00000
0lc<c00000000002c<c<10000?o<c<coc<c<F/c<c004ooooR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;QVIVH02/c<c0800006c<c<0P0000;<c<`2
0000olc<c?o<c<aPc<c<00Cooon8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^6IVIP08c<c<1P000003c<c<0000000000;<c<`00`000<c<c<c<c002
0000olc<c?o<c<aPc<c<00Cooon8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^6IVIP3oc<c<olc<c7S<c<`01?ooohS0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hIVIV0?o<c<coc<c<N<c<c004ooooR<2hR<2hB9280@000000
00F8`;S8h=R8`;R8`;QVIVH0olc<c?o<c<ahc<c<00Cooon8`;R8`;Q8T8P1
000000001HS0^<SPf8S0^8S0^6IVIP3oc<c<olc<c7S<c<`01?ooohS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2hofIVI_mVIVIiIVIV00Cooon8`;R8
`;Q8T8P1000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@000000
00B8`;S8h=R8`;R8`;PF00200`01P0800X001002P@03P@03P@03P@<01842
00F100@01H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z3
00<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0
108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP3
6HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@S
S00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP03
1BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<943
1S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC
0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2
242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V003
2DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?
W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;
EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ
35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S
0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH3
3VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?
LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1k
Z`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<A
PZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::
/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk80
0Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD4
59Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PE
W[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW
^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^
_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P4002000>KYo4c@jDc@jD02C=3Y@H008030060
0P02P00400:100>100>100>10`04P@801H401005PP06PP06PP06PP801h80
0`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<1
3XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:
0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DV
S@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@
0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i82
1SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7
>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL2
24>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ
0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]B
W@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO
0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R
362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=
IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL3
3VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o
[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_
1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=
/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B
]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g
59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i
0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdF
ZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl0
0aNb_`<G/klf6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<00800
1i^WlOooohij]ZJKa;>YdZRMb;>YdP02YY_400Fl^=g^k_CZjO7ooolc@jD0
1@00P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J200J2
00J20P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<1
38@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L3
0QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^9
0`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@U
S@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?
10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHc
TPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0Lh
U0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G
246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI
0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:
DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil0
0`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<
Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=
IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^
Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT0
10mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/
47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_
4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:<
/@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`03
4i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@D
V[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i
5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`0
11J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa
_QNa_aNa_`035k:o0aNc_`8H]<0P00000QRd`10000026;C00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^080080019^WlOooofaJYJnUbP:l^=d02_om
ok>Yd_oooooookbhgIN:_:RMb>KVk?oooc=3Y@@0080300600P02P00400:1
00>100>100>10`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48
PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@
Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<G
R0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3
122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>
1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i00
10H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987
=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`Pl
U@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9
A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX3
2TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]D
W@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj02
35bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP03
3F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eX
Y@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`04
3g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX3
47RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]
00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk03
4XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8B
S[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D
]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8D
WKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX3
5JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm
0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl2
6;C000?8h=Q8T8Q8T8P034R@R0030000b>3HB92800e8T8P0100001Rd`1Rd
`<SPf0i8T8P00`0001Rd`1Rd`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0P00P00;VjOaooooZ9g8oooo/jWBH4bJSWZfN6F^Z9g8oooooogo00?o
ool00c=3Y@00P000P00300200`01P0800X001002P@03P@03P@03P@<01842
00F100@01H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z3
00<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@8248D3oooo0P8AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR003
0aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A
1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC
0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH3
23nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9
AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>
V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aM
X@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ80
0PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD4
3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?
LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1j
Z`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61
[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@B
RK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb
4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D3
59Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh
5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0
^8S0^00;R<2h00=8T8P00038h=P03HS0^005B92800006;C06;C0b>3H00f8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
002000jKYo7ooooooooKg>aPC9ZCQKZcZM:l^=ePC9ZISkjVVlC8`moooolc
@jD600200oooo`800X000`02POooooooo`02oooo0P04P@0300F1oooo00F2
00<01X84oooo00<1288128?oool00oooo`<12X<01_ooo`4;Q04;Q04<Q?oo
o`4<Q0813H@01?ooo`4>QOooo`4>Q@823hD01?ooo`8@QOooo`8@Q@824HH0
0oooo`8AQP8BQP020Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<F
R0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@N
RP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@03
1BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^
T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB
00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@3
1c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G
00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:
VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;
Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJ
X0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R
0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@3
3FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW
0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mf
ZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8A
Ojd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166
[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=
/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]003
4i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g
0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR
^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF
[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb
_`<G/kl26;C000C8h=R8`;R8`;R8`;P6000018S0^003B9280000b>3H00:8
`;P900000XS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000jKYo7ooonl^=fI
SkkooooFdMgKg>cco_nVVlC^k_B5M[2CQK[ooolc@jD4002000Ooool00H00
0H000H3oool00X3oool00`03P@06oooo00B100B100F1oooo00F20P06PP08
oooo00N200N20@N2oooo0@R2oooo0@R30`49P`04oooo0@Z30@Z3oooo0P4;
Q0030@b4oooo0@b400813H@01?ooo`4>QOooo`4>Q@823hD00oooo`8@QOoo
o`03oooo0P8AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ8
0aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:
0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<5
9hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@
0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=980
0`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7
>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL0
10U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ
0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]C
W@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP
0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82
366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=
Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL2
3W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ
0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o
[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_
0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb
4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<C
Tk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL3
59bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i
0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/
_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o
0aNc_`8H]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P00038h=P00XS0
^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000C8h=R8
`;R8`;R8`;P2000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0`00P00?VjOaooooVHnnUhZle=?Xkjbc
ogIkkYn[FeRUYY_4UYoBH4bJ_;SMoooo<d>U00<008001oooo`01P001P001
P?ooo`02P?ooo`0300>100Koool01840187oool01H7oool200J200Soool0
1h801h811h;oool128;oool128<30@V300Woool12X?oool12h?oool12hCo
ool138Coool00P4=Q004oooo0@j5oooo0@j50P8?Q@04oooo0Q25oooo0Q25
108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN8
0aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<4
88/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh5
9hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T004
1RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLe
TPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE
0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4
V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:
C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM
2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<
G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=
HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU
0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?
L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@
N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d0
0a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<B
R;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>
/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd
0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM
]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<E
Y;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d3
5jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H
]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h
00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^080
0002R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2002000ZKYo7ooonGR[ajK:ZcanRYKZ38`mnCQKYKAY>I
Skh2N6F^00A29hF_YL[ooolc@jD400200`01P003oooo00:000:100Coool2
00B100?oool01H7oool00`06PPCoool00`48PP48P`48P`030@V300Woool1
2X?oool12h?oool12hCoool138Coool00P4=Q004oooo0@j5oooo0@j50P8?
Q@03oooo0Q25oooo00?oool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<2
5HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT3
0ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=
0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl4
1Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B
1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD
00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8
@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT3
2DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YA
W@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`03
2eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aO
XPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eU
Y0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW
3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@04
3gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@
OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lA
Q:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba
00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<C
T[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ
]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TE
X;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_004
5Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n
5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SP
f002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<00
0lSPf8S0^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2002000>KYo7oooooool00_ooo`0:ojf`
ogIknLgDoNg^ooooYY_4QGJ`_;SMoooo<d>U1@00P0<00H000oooo`02P002
P@0300>100?oool0187oool00P05P@0400F2oooo00J200J20P07PP030@N2
oooo0@R2008128<3oooo0P4:P`07oooo0@^3oooo0@^4oooo0@b4oooo0081
3H@01?ooo`4>QOooooooo`823hD01_ooo`8@QOooo`8@Q@8AQ_ooo`824HH3
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8
h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h
00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00B8`;P200001HS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<0
08002Z6/l_W=e>8V??Be_n8V??A]OOcSjOoooog]k_n]/0;oool00c=3Y@00
P000P00400200`01P003oooo00:000:100?oool200B100Goool01H401H40
1H;oool00P06PP?oool20@R200<128?oool12H<00P49P`812X<01?ooo`4;
P`4;Q?ooo`8138@01oooo`4=Q04=Q?ooo`4>QOooo`4>Q@02oooo00<23hD2
48D248D01?ooo`040Q660Q:60Q:60Q:60P8CQP040Q>70QB70QB70QB70`8E
Q`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<3
78X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd2
1BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5
;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86
<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@0
0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1
U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9
B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M
2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;
F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR
362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT
3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>
KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?
M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n
[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64
[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;40
11:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B
/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg
59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP
^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@F
Zk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG
/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H
00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003
b>3HR<2hR<2h00>8`;P4000018S0^004B92800006;C06;C00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P
[_ARK_omoon]/?cSjOoooc=3Y@0700200`01P003oooo00:000:100<00h43
00B10P05P@0400F200J200J200J20P07PP050@N20@R20@R2oooo0@R300<1
2H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8B
QP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR8
00<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/3
12:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>
0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946
<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087
=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10Pn
UP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH
0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/3
2TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h0
0`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ
35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeR
XP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZ
Y@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0ma
Z0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/3
47Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^
4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK00
11:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8C
Sk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF
]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPE
W[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX3
5ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^
_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3H
R<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^005
0000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P2
00000hS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0
^8S0^08008000i^WlOK8c>8V?002ojf`00OO92koY9kf_<Go[K3^Nhcooolc
@jD02000P0<00H000oooo`02P002P@0300>10`04P@801H401005PP06PP06
PP06PP801h801@47PP48PP48P_ooo`48P`030@V300Coool12X<12X<12h<2
0@^40`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8D
Q`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<J
R@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=
12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?
00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@04
1S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC
1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8
@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI
00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YA
W0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]G
W`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<
Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<0
0`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP04
3VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mc
Z@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/
00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<A
Q:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<B
Rk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<3
4i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8D
V[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<E
X;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl
11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`
_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@
R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf003R<2h0P00
00B8`;P200000XS0^004B92800006;C06;C00XS0^058T8P10000000018S0
^<SPf8S0^8S0^08008000i^WlOW=e?N9U`02oooo00Oo[K3Q5SCoMW_oY9kR
9ScoRGlc@jD02000P0<00H000oooo`02P002P@0300>10`04P@801H401005
PP06PP06PP06PP801h801047PP48PP48PP48P`Coool30@Z300<12h<12h@1
2h@00`4<Q0813H@01?ooo`4>Q@4>Q@4>Q@<23hD30Q25108AQP<24XH20Q>6
00@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV8
0aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@4
8h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh0
0`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A
0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`Lf
T`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF
0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP0
0`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:
Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh3
2eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aM
X@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeR
X`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V
0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP3
3g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@
Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P03
4H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4B
R[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb
008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne
11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh
5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<F
Yk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG
[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0
^00;R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38
h=P03HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0
^8S0^08008001i^WlOoooo>P[_ARK_ooooN9UoW=e002oooo00?cX:kooolc
@jD02000P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J2
00J200J20P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^4
00<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L2
58L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT3
0a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@T
S@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`03
1B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010Hb
TPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`Lh
U0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G
246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@04
2DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:
DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;
Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ
00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=
IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]
Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?
LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[004
47j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^
4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a
0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A
/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf
00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h
5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@F
Z[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h0
0aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P0
0038h=P03HS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000^KYo7oooooRGoo
ooocX:kaTj7ooooooOocX:kono`c@jD02000P0<00H0200:000@00X400h40
0h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R20081
28<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108A
QP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN8
0`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3
126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh0
0`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA
1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLe
TP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`Pm
U@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4
V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/3
2TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN
2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:00
10aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=
HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iY
Y@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?
LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X3
47V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61
[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;02
4XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P03
4hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E
]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`04
5Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X3
5ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm
00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<0?
b>3H00<00038h=S8h=P03LSPf00300006;C06;C000o8h=P00`0001Rd`1Rd
`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1000P0>KYo401_oooo>P
[_Be_oJlaO_IfS=3Y@T0080300600P02P00400:100>100>100>10`04P@80
1H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<0
0`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP04
0Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<I
R@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><
00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5
:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6
<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<3
1cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88
@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9
AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL
10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]F
WP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<
GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<3
3F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>
K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mb
Z0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[
0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62
[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa
4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P02
4hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@D
V;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN
^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk
0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn
00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^1H0080300600P02P00400:100>100>100>10`04
P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<1
2X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000003R<2hb>3Hb>3H0?o8h=So
b>3HOLSPf058T8P10000003oR<2hohS0^868`;P100000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?oo
l?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`
l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003o
oo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;o
l?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h000?oi^KVooo?clooolo?cggo
clo?0_oVi^H000?ok^k^00?o^KVionk^k_o^k^h0ooo^k^koonk^kWWok^k^
0Oni^KT1onk^kP7ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooo
oomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?o
/[:b0?oo/[:boonb/[9gok:b/P03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomfooooo`04ok:b/_oVi^Kohn?S
okVi^@;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^id
onk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVi
on?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi
0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^
00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?S
oooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi
00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^
kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?S
hooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_oo
ool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Go
oooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooo
oonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;o
i^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05
oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooo
oooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool0
00?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooo
ok:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb
/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV
0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooo
oonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo
/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?o
k^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b
/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;o
onKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003
onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb
/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:b
ooooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^
00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^
k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKV
i_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^
kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;o
k^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooo
ooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co
^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^ko
hn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_oo
i^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04
okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^
on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooooooo
ooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVi
on?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?S
okVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KV
M?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi
^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?S
honi^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooooooooooo
ogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?S
hooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi
^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oV
i^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoS
hn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni
^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGo
oooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooo
oooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02
onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H0
1Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?o
oooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT0
0_o^k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo
00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo
/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^
kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooo
oooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooo
ok:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^
k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co
/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:b
ooo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP00
0ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo
/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b
/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h0
00?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:b
oooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^
k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooV
i^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:b
onKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_oo
k^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?o
oooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooo
oooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^ko
onk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H0
1?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKV
i_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^
ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo
00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooS
hn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^
kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni
^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oS
hn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^
k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co
^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o
^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCo
k^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWo
hn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o
^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^id
onk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVi
on?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi
0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^
00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?S
oooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi
00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^
kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?S
hooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_oo
ool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Go
oooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooo
oonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;o
i^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05
oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooo
oooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool0
00?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooo
ok:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb
/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV
0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooo
oonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo
/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?o
k^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b
/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;o
onKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003
onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb
/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:b
ooooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^
00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^
k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKV
i_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^
kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;o
k^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooo
ooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co
^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^ko
hn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_oo
i^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04
okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^
on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooooooo
ooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVi
on?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?S
okVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KV
M?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi
^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?S
honi^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooooooooooo
ogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?S
hooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi
^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oV
i^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoS
hn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni
^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGo
oooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooo
oooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02
onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H0
1Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?o
oooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT0
0_o^k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo
00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo
/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^
kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooo
oooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooo
ok:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^
k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co
/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:b
ooo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP00
0ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo
/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b
/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h0
00?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:b
oooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^
k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooV
i^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:b
onKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_oo
k^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?o
oooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooo
oooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^ko
onk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H0
1?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKV
i_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^
ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo
00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooS
hn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^
kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni
^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oS
hn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^
k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co
^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o
^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCo
k^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWo
hn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o
^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^id
onk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVi
on?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi
0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^
00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?S
oooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi
00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^
kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?S
hooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_oo
ool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Go
oooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooo
oonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;o
i^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05
oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooo
oooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool0
00?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooo
ok:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb
/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV
0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooo
oonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo
/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?o
k^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b
/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;o
onKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003
onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb
/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:b
ooooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^
00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^
k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKV
i_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^
kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;o
k^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooo
ooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co
^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^ko
hn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_oo
i^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04
okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^
on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooooooo
ooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVi
on?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?S
okVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KV
M?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi
^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?S
honi^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooooooooooo
ogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?S
hooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi
^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oV
i^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoS
hn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni
^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGo
oooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooo
oooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02
onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H0
1Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?o
oooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT0
0_o^k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo
00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo
/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^
kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooo
oooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooo
ok:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^
k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co
/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:b
ooo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP00
0ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo
/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b
/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h0
00?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:b
oooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^
k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooV
i^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:b
onKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_oo
k^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?o
oooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooo
oooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^ko
onk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H0
1?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKV
i_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^
ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo
00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooS
hn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^
kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni
^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oS
hn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^
k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co
^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o
^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCo
k^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWo
hn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o
^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^id
onk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVi
on?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi
0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^
00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?S
oooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi
00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^
kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?S
hooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_oo
ool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Go
oooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooo
oonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;o
i^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05
oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooo
oooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool0
00?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooo
ok:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb
/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV
0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooo
oonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo
/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?o
k^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b
/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;o
onKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003
onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb
/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:b
ooooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^
00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^
k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKV
i_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^
kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;o
k^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooo
ooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co
^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^ko
hn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_oo
i^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04
okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^
on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooooooo
ooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVi
on?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?S
okVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KV
M?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi
^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?S
honi^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooooooooooo
ogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?S
hooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi
^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oV
i^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoS
hn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni
^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGo
oooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooo
oooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02
onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H0
1Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?o
oooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT0
0_o^k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo
00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo
/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^
kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooo
oooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooo
ok:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^
k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co
/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:b
ooo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP00
0ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo
/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b
/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h0
00?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:b
oooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^
k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooV
i^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:b
onKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_oo
k^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?o
oooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooo
oooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^ko
onk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H0
1?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKV
i_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^
ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo
00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooS
hn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^
kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni
^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oS
hn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^
k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co
^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o
^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCo
k^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWo
hn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o
^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^id
onk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVi
on?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi
0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^
00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?S
oooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi
00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^
kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?S
hooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_oo
ool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Go
oooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooo
oonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;o
i^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05
oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooo
oooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool0
00?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooo
ok:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb
/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV
0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooo
oonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo
/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?o
k^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b
/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;o
onKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003
onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb
/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:b
ooooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^
00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^
k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKV
i_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^
kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;o
k^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooo
ooooooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co
^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^ko
hn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_oo
i^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04
okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^
on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooooooo
ooooogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVi
on?Shooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?S
okVi^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KV
M?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi
^OoShn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?S
honi^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:boooooooooooo
ogGooooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?S
hooooooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi
^@02onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oV
i^H01Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoS
hn?ooooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni
^KT00_o^k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGo
oooo00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooo
oooo/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02
onk^kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H0
1Ooooooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?o
oooook:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT0
0_o^k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo
00Co/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo
/[:booo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^
kP000ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooo
oooo/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooo
ok:b/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^
k^h000?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co
/[:boooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:b
ooo^k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP00
0ooVi^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo
/[:bonKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b
/_ook^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h0
00?ooooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:b
oooooooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^
k^koonk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooV
i^H01?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:b
onKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_oo
k^k^ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?o
oooo00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooo
oooShn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^ko
onk^kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H0
1?ni^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKV
i_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^
ooo^k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo
00Co^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooS
hn?o^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^
kWCok^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni
^KWohn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oS
hn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^
k^idonk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co
^KVion?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o
^KVi0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCo
k^k^00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWo
hn?Soooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o
^KVi00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^id
onk^kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVi
on?Shooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi
0_ooool000?ok^k^00Co^KVion?Shooooooo/[:booo^k^koonk^kWCok^k^
00Gooooook:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?S
oooooonb/[;oonKVi_ooi^KVM?oVi^H01Ooooooo/[:bonKVi_oShn?o^KVi
00;oi^KV0003onk^kP04okVi^OoShn?ooooook:b/_ook^k^ooo^k^idonk^
kP05oooooonb/[;ok^k^on?Shoni^KT00_o^k^h000?ooooo00Co^KVion?S
hooooooo/[:booooooooooooogGooooo00Co/[:boooooooShn?o^KVi0_oo
ool000?ok^k^00?o^KVion?Shoooool0oonb/[;ook:b/WGo/[:b00Gooooo
ok:b/_o^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`3o
ooooooooooooM_ooool01?nb/[;oi^KVon?Shoni^KT2onKViP000oo^k^h0
1_ni^KWohn?SooooooooooooR8R8ob8R8P?o000000?o8R8RohR8R?ooool0
1?ooool00onRXZ;oooooooooo`3oooooooooooooIoooool00oo^k^kohn?S
okVi^@02onk^kP000oooool00oni^KWohn?SooknoP02ooknoP05oiRHV?lW
9bOo0000obLW9onHV9P01Oono_h00oo5aLGo>SXjolG5a@3oooknoROoo_kn
2onKVi_oooknoSKoo_kn00?oooooon?Shoni^KT00_ooool000?ok^k^00?o
^KVion?Shoobl_800_obl_801OoJf][o=SHfo`000?lf=SKof][J00Col_;b
00Gof][JocHf=_l0003o=SHfom[JfP3ooo;bl_ool_;bIoobl_800oo^k^ko
hn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Son3Ph003on3Ph003ojf]
[Olc<c?o[Jf]00Goh>3P00GoQXJ6ob<S8ol0003o8b<SohJ6QP3oon3Ph2Ko
h>3P2on9RHWoon3Ph3Koh>3P00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^
00?o^KVion?ShooEeMD01?oEeMD00on7QhOoeMGEomGEe@03omGEe@03og5a
LOlL71co000000;o000000?o71`Log5aLOoEeMD0oooEeMGoomGEeFGoeMGE
00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?ShooMgMd0oooM
gMdfomgMg@_oQhN7oooMgMdfomgMg@03oooooooShn?o^KVi00;ooooo0003
onk^kP03okVi^OoShn?od];B0?ood];BoooBd]9gom;BdP03onk^k_oShn?o
^KVi00;ok^k^0003onKViP03okVi^OoShn?o/;2`0?oo/;2`oon`/;1gok2`
/003onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ok^k^0?oo
k^k^ooo^k^ihonk^kP03on?Shoni^KWok^k^007ok^k^0003ooooo`04okVi
^OoShn?oooooooooooooU9BDoonDU9AeoiBDU0;ooooo00?ohn?SokVi^Ooo
ool00Oooool000?ok^k^00Go^KVion?Shoo^k^kok^k^oiBDU03oonk^k_oo
k^k^Loo^k^h01OnDU9Cok^k^onk^k_oShn?o^KVi00;ok^k^0003onKViP05
okVi^OoShn?oi^KVonKVi_nDU9@0oooVi^KoonKViW?oi^KV00GoU9BDonKV
i_oVi^Kohn?SokVi^@02onKViP000oo^k^h01Oni^KWohn?Sonk^k_o^k^ko
U9BD0?ook^k^ooo^k^iconk^kP05oiBDU?o^k^kok^k^on?Shoni^KT00_o^
k^h000?ooooo00Go^KVion?ShooooooooooooiBDU03oooooooooooooLooo
ool01OnDU9CooooooooooooShn?o^KVi00;ooooo0003onk^kP05okVi^OoS
hn?ok^k^onk^k_nDU9@0ooo^k^koonk^kW?ok^k^00GoU9BDonk^k_o^k^ko
hn?SokVi^@02onk^kP000ooVi^H01Oni^KWohn?SonKVi_oVi^KoU9BD0?oo
i^KVoooVi^IconKViP05oiBDU?oVi^Koi^KVon?Shoni^KT00_oVi^H000?o
k^k^00Go^KVion?Shoo^k^kok^k^oiBDU03oonk^k_ook^k^Loo^k^h01OnD
U9Cok^k^onk^k_oShn?o^KVi00;ok^k^0003ooooo`05okVi^OoShn?ooooo
oooooonDU9@0ooooooooooooog?ooooo00GoU9BDoooooooooooohn?SokVi
^@02ooooo`000oo^k^h01Oni^KWohn?Sonk^k_o^k^koU9BD0?ook^k^ooo^
k^iconk^kP05oiBDU?o^k^kok^k^on?Shoni^KT00_o^k^h000?oi^KV00Go
^KVion?ShooVi^Koi^KVoiBDU03oonKVi_ooi^KVLooVi^H01OnDU9Coi^KV
onKVi_oShn?o^KVi00;oi^KV0003onk^kP05okVi^OoShn?ok^k^onk^k_nD
U9@0ooo^k^koonk^kW?ok^k^00GoU9BDonk^k_o^k^kohn?SokVi^@02onk^
kP000oooool01Oni^KWohn?SooooooooooooU9BD0?oooooooooooomcoooo
o`05oiBDU?ooooooooooon?Shoni^KT00_ooool000?ok^k^00Go^KVion?S
hoo^k^kok^k^oiBDU03oonk^k_ook^k^Loo^k^h01OnDU9Cok^k^onk^k_oS
hn?o^KVi00;ok^k^0003onKViP05okVi^OoShn?oi^KVonKVi_nDU9@0oooV
i^KoonKViW?oi^KV00GoU9BDonKVi_oVi^Kohn?SokVi^@02onKViP000oo^
k^h01Oni^KWohn?Sonk^k_o^k^koU9BD0?ook^k^ooo^k^iconk^kP05oiBD
U?o^k^kok^k^on?Shoni^KT00_o^k^h000?ooooo00Go^KVion?Shooooooo
oooooiBDU03oooooooooooooLoooool01OnDU9CooooooooooooShn?o^KVi
00;ooooo0003onk^kP05okVi^OoShn?ok^k^onk^k_nDU9@0ooo^k^koonk^
kW?ok^k^00GoU9BDonk^k_o^k^kohn?SokVi^@02onk^kP000ooVi^H01Oni
^KWohn?SonKVi_oVi^KoU9BD0?ooi^KVoooVi^IconKViP05oiBDU?oVi^Ko
i^KVon?Shoni^KT00_oVi^H000?ok^k^00Go^KVion?Shoo^k^kok^k^oiBD
U03oonk^k_ook^k^Loo^k^h01OnDU9Cok^k^onk^k_oShn?o^KVi00;ok^k^
0003ooooo`05okVi^OoShn?ooooooooooonDU9@0ooooooooooooog?ooooo
00GoU9BDoooooooooooohn?SokVi^@02ooooo`000oo^k^h01Oni^KWohn?S
onk^k_o^k^koU9BD0?ook^k^ooo^k^iconk^kP05oiBDU?o^k^kok^k^on?S
honi^KT00_o^k^h000?oi^KV00Go^KVion?ShooVi^Koi^KVoiBDU03oonKV
i_ooi^KVLooVi^H01OnDU9Coi^KVonKVi_oShn?o^KVi00;oi^KV0003onk^
kP05okVi^OoShn?ok^k^onk^k_nDU9@0ooo^k^koonk^kW?ok^k^00GoU9BD
onk^k_o^k^kohn?SokVi^@02onk^kP000oooool01Oni^KWohn?Soooooooo
ooooU9BD0?oooooooooooomcooooo`05oiBDU?ooooooooooon?Shoni^KT0
0_ooool000?ok^k^00Go^KVion?Shoo^k^kok^k^oiBDU03oonk^k_ook^k^
Loo^k^h01OnDU9Cok^k^onk^k_oShn?o^KVi00;ok^k^0003onKViP05okVi
^OoShn?oi^KVonKVi_nDU9@0oooVi^KoonKViW?oi^KV00GoU9BDonKVi_oV
i^Kohn?SokVi^@02onKViP000oo^k^h01Oni^KWohn?Sonk^k_o^k^koU9BD
0?ook^k^ooo^k^iconk^kP05oiBDU?o^k^kok^k^on?Shoni^KT00_o^k^h0
00?ooooo00Go^KVion?ShooooooooooooiBDU03oooooooooooooLoooool0
1OnDU9CooooooooooooShn?o^KVi00;ooooo0003onk^kP05okVi^OoShn?o
k^k^onk^k_nDU9@0ooo^k^koonk^kW?ok^k^00GoU9BDonk^k_o^k^kohn?S
okVi^@02onk^kP000ooVi^H01Oni^KWohn?SonKVi_oVi^KoU9BD0?ooi^KV
oooVi^IconKViP05oiBDU?oVi^Koi^KVon?Shoni^KT00_oVi^H000?ok^k^
00Go^KVion?Shoo^k^kok^k^oiBDU03oonk^k_ook^k^Loo^k^h01OnDU9Co
k^k^onk^k_oShn?o^KVi00;ok^k^0003ooooo`05okVi^OoShn?ooooooooo
oonDU9@0ooooooooooooog?ooooo00GoU9BDoooooooooooohn?SokVi^@02
ooooo`000oo^k^h01Oni^KWohn?Sonk^k_o^k^koU9BD0?ook^k^ooo^k^ic
onk^kP05oiBDU?o^k^kok^k^on?Shoni^KT00_o^k^h000?oi^KV00Go^KVi
on?ShooVi^Koi^KVoiBDU03oonKVi_ooi^KVLooVi^H01OnDU9Coi^KVonKV
i_oShn?o^KVi00;oi^KV0003onk^kP05okVi^OoShn?ok^k^onk^k_nDU9@0
ooo^k^koonk^kW?ok^k^00GoU9BDonk^k_o^k^kohn?SokVi^@02onk^kP00
0oooool01Oni^KWohn?SooooooooooooU9BD0?oooooooooooomcooooo`05
oiBDU?ooooooooooon?Shoni^KT00_ooool000?ok^k^00Go^KVion?Shoo^
k^kok^k^oiBDU03oonk^k_ook^k^Loo^k^h01OnDU9Cok^k^onk^k_oShn?o
^KVi00;ok^k^0003onKViP05okVi^OoShn?oi^KVonKVi_nDU9@0oooVi^Ko
onKViW?oi^KV00GoU9BDonKVi_oVi^Kohn?SokVi^@02onKViP000oo^k^h0
1Oni^KWohn?Sonk^k_o^k^koU9BD0?ook^k^ooo^k^iconk^kP05oiBDU?o^
k^kok^k^on?Shoni^KT00_o^k^h000?ooooo00Go^KVion?Shooooooooooo
oiBDU03oooooooooooooLoooool01OnDU9CooooooooooooShn?o^KVi00;o
oooo0003onk^kP05okVi^OoShn?ok^k^onk^k_nDU9@0ooo^k^koonk^kW?o
k^k^00GoU9BDonk^k_o^k^kohn?SokVi^@02onk^kP000ooVi^H01Oni^KWo
hn?SonKVi_oVi^KoU9BD0?ooi^KVoooVi^IconKViP05oiBDU?oVi^Koi^KV
on?Shoni^KT00_oVi^H000?ok^k^00Go^KVion?Shoo^k^kok^k^oiBDU03o
onk^k_ook^k^Loo^k^h01OnDU9Cok^k^onk^k_oShn?o^KVi00;ok^k^0003
ooooo`05okVi^OoShn?ooooooooooonDU9@0ooooooooooooog?ooooo00Go
U9BDoooooooooooohn?SokVi^@02ooooo`000oo^k^h01Oni^KWohn?Sonk^
k_o^k^koU9BD0?ook^k^ooo^k^iconk^kP05oiBDU?o^k^kok^k^on?Shoni
^KT00_o^k^h000?oi^KV00Go^KVion?ShooVi^Koi^KVoiBDU03oonKVi_oo
i^KVLooVi^H01OnDU9Coi^KVonKVi_oShn?o^KVi00;oi^KV0003onk^kP05
okVi^OoShn?ok^k^onk^k_nDU9@0ooo^k^koonk^kW?ok^k^00GoU9BDonk^
k_o^k^kohn?SokVi^@02onk^kP000oooool01Oni^KWohn?Soooooooooooo
U9BD0?oooooooooooomcooooo`05oiBDU?ooooooooooon?Shoni^KT00_oo
ool000?ok^k^00Go^KVion?Shoo^k^kok^k^oiBDU03oonk^k_ook^k^Loo^
k^h01OnDU9Cok^k^onk^k_oShn?o^KVi00;ok^k^0003onKViP05okVi^OoS
hn?oi^KVonKVi_nDU9@0oooVi^KoonKViW?oi^KV00GoU9BDonKVi_oVi^Ko
hn?SokVi^@02onKViP000oo^k^h01Oni^KWohn?Sonk^k_o^k^koU9BD0?oo
k^k^ooo^k^iconk^kP05oiBDU?o^k^kok^k^on?Shoni^KT00_o^k^h000?o
oooo00Go^KVion?ShooooooooooooiBDU03oooooooooooooLoooool01OnD
U9CooooooooooooShn?o^KVi00;ooooo0003onk^kP05okVi^OoShn?ok^k^
onk^k_nDU9@0ooo^k^koonk^kW?ok^k^00GoU9BDonk^k_o^k^kohn?SokVi
^@02onk^kP000ooVi^H01Oni^KWohn?SonKVi_oVi^KoU9BD0?ooi^KVoooV
i^IconKViP05oiBDU?oVi^Koi^KVon?Shoni^KT00_oVi^H000?ok^k^00Go
^KVion?Shoo^k^kok^k^oiBDU03oonk^k_ook^k^Loo^k^h01OnDU9Cok^k^
onk^k_oShn?o^KVi00;ok^k^0003ooooo`05okVi^OoShn?ooooooooooonD
U9@0ooooooooooooog?ooooo00GoU9BDoooooooooooohn?SokVi^@02oooo
o`000oo^k^h01Oni^KWohn?Sonk^k_o^k^koU9BD0?ook^k^ooo^k^iconk^
kP05oiBDU?o^k^kok^k^on?Shoni^KT00_o^k^h000?oi^KV00Go^KVion?S
hooVi^Koi^KVoiBDU03oonKVi_ooi^KVLooVi^H01OnDU9Coi^KVonKVi_oS
hn?o^KVi00;oi^KV0003onk^kP05okVi^OoShn?ok^k^onk^k_nDU9@0ooo^
k^koonk^kW?ok^k^00GoU9BDonk^k_o^k^kohn?SokVi^@02onk^kP000ooo
ool01Oni^KWohn?SooooooooooooU9BD0?oooooooooooomcooooo`05oiBD
U?ooooooooooon?Shoni^KT00_ooool000?ok^k^00Go^KVion?Shoo^k^ko
k^k^oiBDU03oonk^k_ook^k^Loo^k^h01OnDU9Cok^k^onk^k_oShn?o^KVi
00;ok^k^0003onKViP05okVi^OoShn?oi^KVonKVi_nDU9@0oooVi^KoonKV
iW?oi^KV00GoU9BDonKVi_oVi^Kohn?SokVi^@02onKViP000oo^k^h01Oni
^KWohn?Sonk^k_o^k^koU9BD0?ook^k^ooo^k^iconk^kP05oiBDU?o^k^ko
k^k^on?Shoni^KT00_o^k^h000?ooooo00Go^KVion?ShooooooooooooiBD
U03oooooooooooooLoooool01OnDU9CooooooooooooShn?o^KVi00;ooooo
0003onk^kP05okVi^OoShn?ok^k^onk^k_nDU9@0ooo^k^koonk^kW?ok^k^
00GoU9BDonk^k_o^k^kohn?SokVi^@02onk^kP000ooVi^H01Oni^KWohn?S
onKVi_oVi^KoU9BD0?ooi^KVoooVi^IconKViP05oiBDU?oVi^Koi^KVon?S
honi^KT00_oVi^H000?ok^k^00Go^KVion?Shoo^k^kok^k^oiBDU03oonk^
k_ook^k^Loo^k^h01OnDU9Cok^k^onk^k_oShn?o^KVi00;ok^k^0003oooo
o`05okVi^OoShn?ooooooooooonDU9@0ooooooooooooog?ooooo00GoU9BD
oooooooooooohn?SokVi^@02ooooo`000oo^k^h01Oni^KWohn?Sonk^k_o^
k^koU9BD0?ook^k^ooo^k^iconk^kP05oiBDU?o^k^kok^k^on?Shoni^KT0
0_o^k^h000?oi^KV00Go^KVion?ShooVi^Koi^KVoiBDU03oonKVi_ooi^KV
LooVi^H01OnDU9Coi^KVonKVi_oShn?o^KVi00;oi^KV0003onk^kP05okVi
^OoShn?ok^k^onk^k_nDU9@0ooo^k^koonk^kW?ok^k^00GoU9BDonk^k_o^
k^kohn?SokVi^@02onk^kP000oooool01Oni^KWohn?SooooooooooooU9BD
0?oooooooooooomcooooo`05oiBDU?ooooooooooon?Shoni^KT00_ooool0
00?ok^k^00Go^KVion?Shoo^k^kok^k^oiBDU03oonk^k_ook^k^Loo^k^h0
1OnDU9Cok^k^onk^k_oShn?o^KVi00;ok^k^0003onKViP05okVi^OoShn?o
i^KVonKVi_nDU9@0oooVi^KoonKViW?oi^KV00GoU9BDonKVi_oVi^Kohn?S
okVi^@02onKViP000oo^k^h01Oni^KWohn?Sonk^k_o^k^koU9BD0?ook^k^
ooo^k^iconk^kP05oiBDU?o^k^kok^k^on?Shoni^KT00_o^k^h000?ooooo
00Go^KVion?ShooooooooooooiBDU03oooooooooooooLoooool01OnDU9Co
oooooooooooShn?o^KVi00;ooooo0003onk^kP05okVi^OoShn?ok^k^onk^
k_nDU9@0ooo^k^koonk^kW?ok^k^00GoU9BDonk^k_o^k^kohn?SokVi^@02
onk^kP000ooVi^H01Oni^KWohn?SonKVi_oVi^KoU9BD0?ooi^KVoooVi^Ic
onKViP05oiBDU?oVi^Koi^KVon?Shoni^KT00_oVi^H000?ok^k^00Go^KVi
on?Shoo^k^kok^k^oiBDU03oonk^k_ook^k^Loo^k^h01OnDU9Cok^k^onk^
k_oShn?o^KVi00;ok^k^0003ooooo`05okVi^OoShn?ooooooooooonDU9@0
ooooooooooooog?ooooo00GoU9BDoooooooooooohn?SokVi^@02ooooo`00
0oo^k^h01Oni^KWohn?Sonk^k_o^k^koU9BD0?ook^k^ooo^k^iconk^kP05
oiBDU?o^k^kok^k^on?Shoni^KT00_o^k^h000?oi^KV00Go^KVion?ShooV
i^Koi^KVoiBDU03oonKVi_ooi^KVLooVi^H01OnDU9Coi^KVonKVi_oShn?o
^KVi00;oi^KV0003onk^kP05okVi^OoShn?ok^k^onk^k_nDU9@0ooo^k^ko
onk^kW?ok^k^00GoU9BDonk^k_o^k^kohn?SokVi^@02onk^kP000oooool0
1Oni^KWohn?SooooooooooooU9BD0?oooooooooooomcooooo`05oiBDU?oo
ooooooooon?Shoni^KT00_ooool000?ok^k^00Go^KVion?Shoo^k^kok^k^
oiBDU03oonk^k_ook^k^Loo^k^h01OnDU9Cok^k^onk^k_oShn?o^KVi00;o
k^k^0003onKViP05okVi^OoShn?oi^KVonKVi_nDU9@0oooVi^KoonKViW?o
i^KV00GoU9BDonKVi_oVi^Kohn?SokVi^@02onKViP000oo^k^h01Oni^KWo
hn?Sonk^k_o^k^koU9BD0?ook^k^ooo^k^iconk^kP05oiBDU?o^k^kok^k^
on?Shoni^KT00_o^k^h000?ooooo00Go^KVion?ShooooooooooooiBDU03o
ooooooooooooLoooool01OnDU9CooooooooooooShn?o^KVi00;ooooo0003
onk^kP05okVi^OoShn?ok^k^onk^k_nDU9@0ooo^k^koonk^kW?ok^k^00Go
U9BDonk^k_o^k^kohn?SokVi^@02onk^kP000ooVi^H01Oni^KWohn?SonKV
i_oVi^KoU9BD0?ooi^KVoooVi^IconKViP05oiBDU?oVi^Koi^KVon?Shoni
^KT00_oVi^H000?ok^k^00Go^KVion?Shoo^k^kok^k^oiBDU03oonk^k_oo
k^k^Loo^k^h01OnDU9Cok^k^onk^k_oShn?o^KVi00;ok^k^0003ooooo`05
okVi^OoShn?ooooooooooonDU9@0ooooooooooooog?ooooo00GoU9BDoooo
oooooooohn?SokVi^@02ooooo`000oo^k^h01Oni^KWohn?Sonk^k_o^k^ko
U9BD0?ook^k^ooo^k^iconk^kP05oiBDU?o^k^kok^k^on?Shoni^KT00_o^
k^h000?oi^KV00Go^KVion?ShooVi^Koi^KVoiBDU03oonKVi_ooi^KVLooV
i^H01OnDU9Coi^KVonKVi_oShn?o^KVi00;oi^KV0003onk^kP05okVi^OoS
hn?ok^k^onk^k_nDU9@0ooo^k^koonk^kW?ok^k^00GoU9BDonk^k_o^k^ko
hn?SokVi^@02onk^kP000oooool01Oni^KWohn?SooooooooooooU9BD0?oo
oooooooooomcooooo`05oiBDU?ooooooooooon?Shoni^KT00_ooool000?o
k^k^00Go^KVion?Shoo^k^kok^k^oiBDU03oonk^k_ook^k^Loo^k^h01OnD
U9Cok^k^onk^k_oShn?o^KVi00;ok^k^0003onKViP05okVi^OoShn?oi^KV
onKVi_nDU9@0oooVi^KoonKViW?oi^KV00GoU9BDonKVi_oVi^Kohn?SokVi
^@02onKViP000oo^k^h01Oni^KWohn?Sonk^k_o^k^koU9BD01Gok^k^00?o
eMGEonc/k?o^k^h01_o^k^h00ooShn?of=SHonk^kP3oonk^k_ook^k^D_o^
k^h01OnDU9Cok^k^onk^k_oShn?o^KVi00;ok^k^0003ooooo`05okVi^OoS
hn?ooooooooooonDU9@02Oooool00ombLW;o>3Phooooo`03ooooo`0;od10
@?moOgoooooooooooooCdm?o9BDUoahN7_nj^[[ooooood10@?moOgl00_oo
ool01_oWinOoBTY:o`<30olS8b?o5aLGol71`OoooooooooooomAooooo`05
oiBDU?ooooooooooon?Shoni^KT00_ooool000?ok^k^00Go^KVion?Shoo^
k^kok^k^oiBDU009onk^kP03ofYZJ_ld=3Cok^k^00?ok^k^00Oo>c/kogIf
M_o^k^kok^k^ofUYJOll?3cokNg]00;ok^k^00[o>c/kogIfM_o^k^kok^k^
oclo?olk>c_od=3@onk^k_oRh^;ohN7Qooo^k^koonk^kU7ok^k^00GoU9BD
onk^k_o^k^kohn?SokVi^@02onk^kP000ooVi^H01Oni^KWohn?SonKVi_oV
i^KoU9BD00Woi^KV00?oIVIVoc8b<_oVi^H00ooVi^H01_li>CWoLW9bonKV
i_oVi^KoADE5ofIVIP?oi^KV00Ko>CTiog9bL_oVi^KoalO7o`000?nUYJGo
onKVi_ooi^KVEOoVi^H01OnDU9Coi^KVonKVi_oShn?o^KVi00;oi^KV0003
onk^kP05okVi^OoShn?ok^k^onk^k_nDU9@02Oo^k^h00omZJV[o=3@donk^
kP03onk^kP06oc/k>omfMWKok^k^onk^k_m7AdOoJVYZ0oo^k^h01_lk>c_o
MWIfonk^k_na/K7o0000ocPh>0?o>SXj00?o][Jfonk^k_o^k^h0ooo^k^ko
onk^kTook^k^00GoU9BDonk^k_o^k^kohn?SokVi^@02onk^kP000oooool0
1Oni^KWohn?SooooooooooooU9BD00Wooooo00?oLW9bocPh>?ooool00ooo
ool01_m0@43oOgmoooooooooooooCDe=og9bLP?ooooo00[o@410ogmoOooo
oooofm_Ko`000?n[Zj_oclo?olO7aol30`?oiNGUoooooooooooooe7ooooo
00GoU9BDoooooooooooohn?SokVi^@02ooooo`000oo^k^h01?ni^KWohn?S
onk^k_o^k^h7oiBDU0?ok^k^00?oJVYZoc@d=?o^k^h00oo^k^h02olk>c_o
MWIfonk^k_oXj>SoA4A4ofEUIOoShn?oj^[Zonk^k_lk>c_oMWIf00;ok^k^
00Ko>SXjof=SHooVi^KoTi>CobPX:?o^k^kooiBDU?ooU9BDD_nDU9@2onk^
kP03on?Shoni^KWok^k^007ok^k^0003onKViP03okVi^OoShn?oi^KV00_o
i^KV00?oIVIVoc8b<_oVi^H00ooVi^H02om;Bd_oOgmoonKVi_mbLW;o1`L7
o`X:2_lH61SoW9bLonKVi_li>CWoLW9b00;oi^KV00Goclo?od10@?l;2`_o
6ATIojFUY@3oonKVi_ooi^KVEOoVi^H00ooShn?o^KVionKViP01onKViP00
0oo^k^h00oni^KWohn?Sonk^kP0;onk^kP03ofYZJ_ld=3Cok^k^00Ook^k^
00?oAdM7ofYZJ_o^k^h00_o^k^h00olk>c_oMWIfonk^kP03onk^kP03on_[
joo^k^kok^k^0?ook^k^ooo^k^iEonk^kP03on?Shoni^KWok^k^007ok^k^
0003ooooo`03okVi^OoShn?ooooo00Sooooo00GoMgMgofEUIOmUIFGo;Bd]
oaHF5P03ofEUI@03onk^k_mKFe_oTY:B00;ooooo00?oh>3PomkNg_ooool0
0_ooool00om0@43oOgmoooooo`3oooooooooooooFoooool00ooShn?o^KVi
ooooo`01ooooo`000oo^k^h00oni^KWohn?Sonk^kP08onk^kP03oiZJV_n?
ShooShn?00GoShn?00?ohn?SojRXZ?no_kl01oo^k^h00olk>c_oMWIfonk^
kP3oonk^k_ook^k^Foo^k^h00ooShn?o^KVionk^kP01onk^kP000ooVi^H0
0oni^KWohn?SonKViP0JonKViP03on;Rh_oTi>Coi^KV0?ooi^KVoooVi^IK
onKViP03on?Shoni^KWoi^KV007oi^KV0003onk^kP03okVi^OoShn?ok^k^
0?ook^k^ooo^k^ihonk^kP03on?Shoni^KWok^k^007ok^k^0003ooooo`03
okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007o
oooo0003onk^kP03okVi^OoShn?ok^k^0?ook^k^ooo^k^ihonk^kP03on?S
honi^KWok^k^007ok^k^0003onKViP03okVi^Oo3`l?o`l?30?oo`l?3ooo3
`l=iol?3``7o^KVi0OoVi^H1onKViP000oo^k^koogalO?ooO7alOOmlO7`2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00oomoOgmGogmoO`OoOWinoomoOglTogmoO`0000Cojn_[
onKVi_oRh^;og]kN0ooMgMd0oooLg=cog]kNomkNg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMg@006_oNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomcLg?oMgMgofm_K0_oLg=`0<ooMgMgogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNgP02omcLg005omWIfOoHf=SoemOGomSHf?oIfMX00_oLg=`0oooN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kog=cMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNgP005ooMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN00?og]kN00?ogMgM
omkNg_oNg]h00ooMgMd1on7Qh@7oinOW0OoZj^X00003onc/k?oVi^Koh>3P
00?ofMWI00Sof=SHomWIfOoIfMWofMWIomSHf?oFe]Kodm?Com3@d0?ocLg=
00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=
c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=
cLd01?o@d=3odm?ComOGeooHf=SKomWIf@;of=SH00Koe]KFom?CdooCdm?o
e=CDomOGeooHf=P2omWIf@03omSHf?oIfMWofMWI00;of=SH2OoIfMT00ooH
f=SofMWIomWIf@02omSHf003omWIfOoHf=Sof=SH00;of=SH5ooIfMT01?oH
f=Soe]KFom;Bd_o?cll2olg=c@04olo?cooCdm?oemOGomSHf0_ofMWI00?o
f=SHomWIfOoIfMT0oooIfMT8omWIf@03omSHf?oIfMWofMWI00KofMWI0OoN
g]h1onKViP7ok>c/00001oo^k^kojNWYonCTi?oPh>3ohN7Qon3Ph?oRh^80
0_oQhN403OoNg]kog=cLom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7
alOodm?Com_KfooOgml02OoQhN403OoOgmoofm_Kom?Cdoo7alOo^k^kok:b
/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml02OoQhN403OoOgmoofm_K
om?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml0
f_oQhN402OoPh>3ogmoOom_KfooFe]Koe=CDomKFe_oJf][og]kNon3Ph006
omoOg`?oh>3P00?ogmoOon3Ph?oPh>000_oPh>08omoOg`;og]kN0_oOgml3
on3Ph0;ogmoO0_oPh>02omoOg`goh>3P00GogmoOomgMgOoIfMWoeMGEom?C
d`02om;BdP03omKFe_oLg=coh>3P0?oohN7Q6?oQhN400ooRh^;ohN7Qon;R
hP04on7Qh@7oi>CT0OoYjNT1ong]k@0000?ol?3`ono_kooalO400_o`l?02
ono_k`3ooo3`l?o^k^koj>SXom_Kfoo1`L7oY:BTohb<S?mkNg_oMgMgog]k
Non<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7alOo_knoolO7_
ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_oNg]kogMgMomkNg_o
S8b<ojBTY?o2`/;of][Jon[Zj?o]kNgolO7aono_kooalO7okno_oo7alOo_
knoolO7_ong]kOoZj^[of][Jol;2`_nTY:CoS8b<og]kNomgMgKoNg]kohb<
S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a000Jono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo^k^kokno_
on[Zj_oWinL2on3Ph007on?Shoo[jnWojn_[on[Zj_oVi^Koj>SXonOWi`02
onWYj@0Bonk^k?o/k>cok>c/onSXj?o/k>cokNg]oo3`l?o/k>coj^[XonKV
i_oXj>SoinOWonWYjOoXj>Sojn_[onOWiooWinGoiNGU0_oYjNT03oo^k^ko
kNg]ong]kOoXj>Sojn_Yonc/k?o^k^kojNWYon[Zj_o[jn_okno_onc/k?o/
k>[oj^[Zonk^kP02onc/k03oon[Zj_o_knook>c/onc/j_oZj^[ok^k^onc/
k?n_[jooMWIfoeUIFOm^KVko]kNfon3Ph?oYjNWokNg]oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7ok^k^oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_000]oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo`l?3okno_oo3`l?o_knool?3`ono_koo`
l?3okno_00Col?3`00000oobl_;ok^k^onOWi`04onGUi@0@onCTi?oOgmoo
dM7Aok6a/On:RX[oIFEUoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:ROna
/K7odM7AomkNgP;oi>CT00?oiNGUonCTi?oUiN@00_oTi>@03ooNg]kodM7A
ok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7o
dM7@omkNgP02onCTi03]onGUiOoTi>CoiNGUonCTi?oTi>?og]kNom7AdOna
/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6aom7A
dOoNg]koi>CSonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGT00;oi>CT0?ooaLG5obPX:?m4A4CoT92@om7A
dOoLg=_ofm_KomOGeooDe=Coe]KFomCDe?oEeMGofMWIon3PgooNg]kof][J
omCDe?oIfMWog]kNon;Rh_oLg=coemOFomCDe?oFe]Koe=CDomGEeOoHf=So
fm_KomOGeooFe]GoeMGEomOGeooHf=Sog]kNomoOgooLg=coeMGEomOGe_oL
g=cogMgMomOGeooFe]Kofm_Kon7QhOoNg]kofm_Jom[Jf_oNg]kog=cLom[J
f_oKfm_oh>3PomoOgooLg=_ofMWIomkNg_oOgmooM7AdofMWIon=SHgoE5AD
o`P82?nRXZ;og=cLon;Rh_oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoShn?oiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUon?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>@005SoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CT1?oUiND01_oTi>CoiNGUonGUiOoUiNGoj>SXong]k@7ol_;b0000
0oodm?CokNg]onOWi`03on3Ph00BomoOgooNg]kod];BokBd]?n7QhOoFe]K
ofdk=OnNCT;ocFmOonV3Koo=KeooWTi3ofdk=_mLG5coQhN7okBd]?oBd];o
g]kN1OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLofeP;?nNURkocLdoonWY
COo=cCooWYX_ofeS;OmLG5coQhN7okBd]?oBd];og]kN00Goh>3P017og]kN
om;Bd_nd];CoQhN7oeaLG?m7IbkoJ9hcoi7=AonZjEGoTLe7ofZN=?m9JRoo
G5aLohN7Qond];Cod];BomkNgP3Ion3Ph006omoOgoo?clooVIVIoi:BT_lI
6AWoS8b<0_oEeMD07oo?cloo`/;2olk>c_o>c/koaLG5ol[:b_oJf][of=SH
om3@d?o;bl_oclo?omSHf?oJf][oeMGEolo?coo1`L7od=3@olk>c_o4a<Co
bl_;omSHf?oGemOo_[jnok^k^ooAdM7od=3@omGEeOoHf=Sodm?Colc<c?o>
c/h00_oEeMD01Oo>c/koc<c<om?CdooJf][of=SH00;od];B00Cof=SHomOG
eooAdM7odm?C0_oIfMT01_oCdm?odM7AomOGeooHf=SodM7Aom3@d0;odM7A
00CoATI6od51@OoGemOog]kNL?oPh>000ooOgmooh>3Pon3Ph02Ron3Ph003
omoOgooPh>3ogmoO00;ogmoO0ooPh>000ooQhN7oinOWonc/k001ooCdm000
00?om_Kfoo;bl_o[jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWiooJemOohlf
;_o]LF7onIf@oofaYOom_:oooKBWooVOToo]M6?oTSL_of]OGonOWioocLg=
on;Rh_oWinL00ooXj>P04ooWinOoh^;Rolg=cOnOWiooKVIOoi=b8_o]dDCo
nO=doogmSOomoIGooOf>ooWhM_o]edOoTg<RofiWGonOWioocLg=on;Rh_oW
inL00ooXj>P04ooWinOoh^;Rolg=cOnOWiooH6QOod]l8onBhD_o_OUkom3m
T_oHoI_oe?fEol3iO_nHj4goCH0Tof1YGonOWioocLg=on;Rh_oWinL0f_oX
j>P01?oVi^KohN7QoeeMGOm=CDd2omgMg@0Ooe1@D?l71`Oo5ADEohB4Q?lF
5QKo@d=3on;Rh_oMgMgoW9bLo`000?n?ShoogMgMon7QhOoKfm_o@410o`P8
2?lI6AWoR8R8o`/;2omHF5So]kNgo``<3?l71`Oo8b<SobLW9ommOGgof][J
omgMgOoDe=Co2`/;oeUIF@02omWIf@03oeeMGOl;2`_odm?C00;ogmoO00Ko
FUYJodi>C_oNg]kog]kNob<S8on4Q8@2on7Qh@0<ogYjN_l^;RkogMgMomgM
gOo2`/;oD51@oc<c<om^KVkoPh>3ob4Q8OoNg]koi^KVoooXj>POonSXj07o
k>c/0Oobl_81ooKfmP0001WomoOgooShn?ohn?Son?ShooOgmoohn?SomoOg
onk^k_o>c/koT92@ohD_:ooYI5KonY:7oojVVoon/JGookR[oojcY_onZ9co
niB9oniXFOn9<B_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>
c/koT92@oiUY:oo`_Cgonn1^ookdP_onoX[ooonBooknS?onn8?onnE`oo32
?_nIJR_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@
od9c:on4cT?o[Nmcol;nR?o>oY3oe_nGom3nT_o6oXWo/_EdohSC@om4MB_o
T92@olk>c_o^k^komoOg0=[on?Sh02Gom_Kfoo7alOn1PH7o7alOong]kOo6
a/Ko0000ol?3`ooCdm?oG5aLo`P82?oZj^[ol?3`on[Zj_mBDU;o51@Docdm
?OoYjNWol?3`ojn_[ol71`Ood];Bolg=cOm>CTko6a/Konk^k_oKfm_o[Zj^
onSXj?o/k>co[Zj^o`000?nd];Cok>c/ok2`/?l;2`_o6QXJ00;oi>CT00_o
8b<So`h>3_nTY:CokNg]onk^k_mPH63oE5ADonk^k_o]kNgo9RHVohf=S@02
oo3`l00<oh:2P_la<C7ok>c/on[Zj_m3@d?o;bl_oibLW?mcLg?o:RXZoaXJ
6_o^k^kom_KfJOohn?P00oogmoOon?ShooShn005ooShn003ooOgmoohn?So
n?Sh03;on?Sh00?omoOgooShn?ohn?P0K_ohn?P00oogmoOon?ShooShn002
ooShn004ooOgmooinOWomoOgooOgm`7on?Sh00000oojn_[omOGeonk^kP02
onc/k03oon_[jooYjNWogmoOokVi^OmiDU;o_c8TonMdJOomRGkooiR<oojR
U_ooZ9cooZBHoonJSOonRWookWIZol<c9?miDU;o^[ZjomoOgooZj^[ojn_[
onc/k?o[jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3ooMYSoooZL_onlgko
ooZ2ookfOoook7?oo]iToo[7DOoRTQcoRFICokZj^_oOgmooj^[Zon_[joo/
k>cojn_[on[Zj_oOgmoo^[Zjoe9]D_mAXacoTM9EojKWJ_nhnG[o`?j2olOo
ROo3oXCo^OekojO/K?nDeUOoDZHLoe9]D_nj^[[ogmoOon[Zj_o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/0019onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/onWYjOoUiNGoNWYjoa`L7?oQhN;oc<c<o`<30onPX:3o
g]kNoiBDU?lC4a?ohN7Qon3PhOo@d=3o1PH6oj6QXOl92@Wo_knoon7QhOnj
^[[o0P82ok:b/_oMgMgoP820obPX:?oShn?oinOWonGUiOoOgmoofm_Kom?C
dol820SoQHF5omoOgomYJFWoBTY:ocDe=On][Jgo_Kfmo`L71omhN7SoEEEE
omoOgooPh>3oFe]Koe1@D002on7Qh@0:ob@T9?n5QHGogmoOon7QhOmkNg_o
;bl_on3Ph?oDe=Co1@D5ojRXZ0;ohn?S0?ooOWiooaHF5_oQhN7oj^[Zon_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn/001[ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k0Kojn_[00Gok>c/on_[joo[
jn_ok^k^ooKfmP01ooWin@0000?ono_koo?cloo]kNd00_oUiND0oooVi^Ko
hn?SomWIfOnb/[;oNBh^olQ2=?oSJUcolgU/oof8O?onUh[ooY^>oojHRoon
RWkom7]]onM[GOo:@SCoNbh^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGVonCT
i?oHf=So/[:boiIE;_oZW2_onka4ook<Doomf6;oo^=bookYMOoniW?oo]]U
oog<Dook`DGokYh[oiUF;_nb/[;of=SHonCTi?oUiNGoi^KVonGUiOoTi>Co
f=SIok:b/_l^HRkoHjd[ohO:B?nGg5WoYNEYok;cMonhmW_o]?EiojOZJonH
g5WoRLm;of>^:ol^Hbko/[:bomSHfOoTi>CoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUiP00=?oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oShn?ogmoOogMgMolK6a_og=cLon7QhOnNWYko;bl_ob/[:olb<S;o4Q8B
omcLg?oJf]_oQ8B4ob0P8?oPh>3oDU9BofQXJ?oJf][og]kNoi2@T?lZ:R[o
;Rh^ob`/;?lW9bL2omkNgP0ComWIfOoCdmCod=3@oe]KFol0003o_Kfmom[J
f_lX:2SoQhN7ogMgN?mXJ6SoPX:2oc`l??o2`/;o3`l?omCDe?oJf][oFEUI
odi>CP02omcLg00Job<S8on1PH7oeMGEomOGeomgMgOo;Rh^omcLg?nSXj?o
0000olO7aooHf=SofMWIohf=S_lE5AGog=cLonCTi?oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^H2onGUi@2NonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^H2onGUi@1YonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGV00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGo
kNg]ooCdm001oo_kn`0000?oo?clooShn?oalO400oo^k^h04oo[jn_ohN7Q
okbl_?mj5aOo`clbom9EB?oTJ5[okgM/ooB3NOohQgcomHAjoo=iKOoUJE_o
fEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?nU
AaOoiYLbooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlbonVK
<_nUAQOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOoGjPb
ogJm=on6cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lGFAOo
_;blon7QhOo/k>`0f_o^k^h0;_o/k>coinOWog]kNolL71coi>CTonWYjOoV
i^KohN7QomkNg_n=SHgo51@DonKVi_oTi>Co=CDeogUiNOo[jn_o/[:boaDE
5OoOgmooi^KVonCTi?oQhN7ogMgMogYjN_lY:BWoj>SXonGUiOoMgMgo/K6a
obHV9_l;2`_oVi^KonWYjOo<c<co0000olk>c_o3`l?o9BDUod];BomlO7co
j>SXoc4a<OnUYJGoi>CToeeMGOmADE42onOWi`0:obDU9OmYJFWogmoOomoO
gomgMgOo<C4aonWYjOo1`L7o0000ojNWY`;ogmoO00CoTi>CoaHF5_oWinOo
k>c/Joo^k^h00oo]kNgok^k^onk^kP02onk^kP03ong]kOo^k^kok^k^0:[o
k^k^00?okNg]oo;bl_ohn?P00Oolo?`000?ooOgm01Koo?cloogmoOomoOgo
o?cloo?clooAdM7oJ0L7okPd=?o7?c?odU13omYREOoSKV;oi79TonA_H_oL
I5Oode53ola1=?ni=3CoJ`L7om;Bd_oclo?oo?cl0oomoOd04oolo?colo?c
om;Bd_nN:`OofXXdon^K6OoeZ2Won;@oooVmB_oh_dgon[m:ooVh?oofZR[o
kihIom^;=?nR;@Ood];Boo?cloolo?`00oomoOd04oolo?colo?com;Bd_l7
@0OoCIXdoen[8?m`^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^BooHZhPodjK
=?l7@POod];Boo?cloolo?`0f_omoOd08ookno_omoOgohB4Q?lN7Qkolo?c
ooWinOnc/k?od=3@oo?clomXJ6SoAdM7oo[jn_oDe=Co0000omgMgOolo?co
no_kobLW9onXZ:SonOWioj^[ZooEeMGolO7aoeADE?mNGUkonOWiooCdm?nD
U9Co1@D5od10@?oAdM7omoOgooShn?nGUiOo:b/[00;on_[j01_o92@To`L7
1oo8b<Sono_kohF5QOmSHf?omoOgof=SHomGEeOon?ShooWinOlW9bOo5ADE
oh>3PooGemOo@T92of=SHookno_on_[joc@d=?m9BDWofm_KonGUiOm?Cdoo
5aLGoo[jn_olo?`0ooomoOdLoogmo@03ooclo?omoOgoo?cl00?ooOgm0000
>_omoOgon_[joo?cloo^k^kol?3`ono_koo^k^kojNWYom?CdomJ71coXS@d
ok@X7Oo1>BcoadTlolmFB_o@Ed_od5M:olY:?_o3>bko]RPMoj8d=?mL7Ago
dm?Con[Zj_o^k^kol?3`ono_koo`l>ook^k^on[Zj_oCdm?oS2DMolQa=?oI
Q1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/X2GoiiLEomb87Oo8LCCoS2DMom?C
dooZj^[ok^k^oo3`l?o_knool?3`onk^k_oZj^Wodm?Coadh7OldPSCoAiDM
oeZU6omY[BX2ogBh>03RogFi>?m[/B_oFjLLodRJ7OldPSCo7CPMom?CdooZ
j^Wok^k^oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l0;okno_0?ooj^[ZoginO_lL71coj>SWong]
kOn8R8So<30`o`l?3ola<C7o/K6aonk^k_n5QHCoCDe=ono_koo^k^kokno_
ohZ:R_mIFEWok^k^ogQhN?l[:b_o3`l?ocPh>?no_kookNg]onCTi?l>3Pko
JFUYomoOgooShn?oiNGUon_[jomQHF7oMgMgonk^k_o_knkoMWIfobHV9_o]
kNgokno_olc<c?l/;2coj^[Zofe]K?mRHV;ok>c/ong]kOlk>c_oTi>Cof9R
H_l>3Pko=3@dolC4a?o_knook^k^om7AdOll?3co2PX:obLW9om/K6co;2`/
ono_koo^k^kol?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3ok^k^oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o^k^kol?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knl005Kol?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_k`;o
l?3`1_o_knl1oo?cl`7onOWi0Oono_h00003ookno_ogmoOol?3`00;ojNWY
01?oj>SXonWYjOoVi^Kofm_Kof=;Bon1<S;oYS@dokHd;Oo2CD7o`eA9olAE
B_o3E4Wo`Te1okHd;OnU=CGoPC8bof=;BooKfm_oinOW00GojNWY017oinOW
om_Kfon9Bd_o[d/boleg=OoFRbgoh9`^on2P<_oQX3Coh:0bomnJ;_oFRbgo
bWDeojm;<_n9Bd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oBd];oc9P<_lj
RCGoDi/]of^[;om`[CSoKjhjog2]>?mZZRooDi/]ocV8=OlbH3;oBd];om_K
fooWinL0fooYjNT01_oXj>Soi^KVog]kNolL71coi>CTonSXj0;ojNWY00?o
inOWonWYjOoYjNT02ooYjNT03?oWinOojNWYonWYjOoXj>Sof=SHo`X:2_n^
[ZkogMgMomkNg_oPh>3oiNGUonSXj0SojNWY00Koj>SXonKVi_oShn?ohn?S
onKVi_oXj>P3onWYj@03onSXj?oYjNWojNWY00CojNWY00?oinOWonWYjOoY
jNT03ooYjNT00ooXj>SojNWYonWYj@2GonWYj@03onSXj?oYjNWojNWY00?o
jNWY00?oj>SXonWYjOoYjNT0J?oYjNT00ooXj>SojNWYonWYj@04onWYj@7o
l?3`0OogmoL1ooknoP0000Coo_knoo[jn_odm?Cokno_0oo`l?004Oo_knoo
jn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZNW?oIW9coe9FEok]cLonE
E5CoCb<SoiFDU?oZj^[okno_00Gol?3`017okno_on[Zj_nYU9CoPB<SokYZ
E?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S8onZU9Coj^[Z
ono_k`05oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCoLjEcoik6UOn/cYco
[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Zj_o_knl0foo`l?02ono_
k`04oh20P?lM7Agok^k^ono_ka?ol?3`0_o_knl01omTI6Co:BTYoh61POmS
Hf?o>c/konk^k_o_knl02?o`l?001_o_knook^k^og=cLomYJFWok^k^ono_
k`[ol?3`00?okno_oo3`l?o`l?00KOo`l?02ono_kk3ol?3`00ColO7aoo3`
l?odm?Con_[j0Oono_h00004ong_l_ooooooooooooknoP;ooooo0_ono_h0
ooomoOgomoOgofi^K_mJ?coo/I2@omk9bOo`i>ColnKVoo3Ti?oNbLWo/I2@
oeXo?om]KFgon?Shooclo?ooooooo_knooooooono_koooonookno_oooooo
o?clooShn?n=KFgoRSloolVAT?oYd<Wom>WTooK[i_odjNCojM39olVAT?n9
?cooSFe]ooShmoolo?coooooookno_ooooooo_knooooooono_koooonoocl
o?ohn?SoKFe]oclo?on@WI3obMG9onC/i?oVk^Koi>cTolWEbOn@WI3o?clo
ofe]KOohn?Soo?clooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooooknoP00>?ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
oOgmom3@d?nUYJGoo_kmookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooomoOgo`L70og5aLOn1PH7o[jn_0_ono_h03?oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooomoOgo`/;1okbl_0;o
o_kn0?ooooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooool002Woo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooooknoP02ooooo`03ookno_oooooooooo00?o
oooo0Ooko?`00004olC<doono_kon_[joo?cl`GolO7a00gokno_omKFe_m[
Jf_o@cdmoi^<S?o6^[[oe/c<olNj^_nKS8co@cdmof][JooFe]Kokno_00Wo
lO7a00gokno_omOFe_n3Jf_oM3dmokF<S?oE^[[ohLc<omJj^_nfS8coLSdm
oh5[JooGe]Kokno_00WolO7a00gokno_omKFe_m[Jf_o?Cdmohb<S?nj^[[o
c<g<okZj^_n<S8co?Cdmof][JooFe]Kokno_0?oolO7a5_oalO400oo`l?3o
lO7aoo7al@0Aoo7al@03oo3`l?oalO7olO7a09golO7a00?ol?3`oo7alOoa
lO40I_oalO401?o`l?3olO7aoo7alOo`l?04oo7al@03ooCdm?ojn_[oo_kn
007olO;d00005On:V:?ooOgmooShn?o`l?3ojn_[on[Zj_oYjNWoj^[ZonWY
jOoZj^[ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SX
onWYj@0;on[ZjP0;onWYjOoXj>SoX9^KofYIFOm39RKo;@T9od8V9_mYFEWo
X9^KonSXj?oYjNT02ooZj^X02ooYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV
9RKoFEUIoi^KVooXj>SojNWY0?ooj^[Z:_oZj^X00ooYjNWoj^[Zon[ZjP2L
on[ZjP03onWYjOoZj^[oj^[Z06ooj^[Z00Cojn_[oo3`l?ohn?SooOgm0OoF
f]/00004od5@G_nla/gon_[joo?cl`SolO7a0_o`l?03ono_k`;ol?3`3ooa
lO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l?oolO7aoooa
lO4joo7al@03oo3`l?oalO7olO7a00;olO7a00?omOGeooWinOo]ko000OnT
YjX00003obDlC_mAHg3o^lG<0?oooooooooooomlooooo`7ol??d0Ona][P1
ojbb]@0000Ko:D1Gob8iC?lhBUWoQY6Mol78c_o/k_3oooooooooooooM_oo
ool01Ooin__ok_3aomGIfonMXjKoWjJZ007o][g20000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(split = NewJSplitPane[pane]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JSplitPane"] \[RightGuillemet]\),
      JLink`Objects`JavaObject57170343231489]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(split@setOneTouchExpandable[True]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(p1 = NewJPanelTitledBorder[split]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JPanel"] \[RightGuillemet]\),
      JLink`Objects`JavaObject47426303950849]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p2 = NewJPanelEtchedBorder[split]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JPanel"] \[RightGuillemet]\),
      JLink`Objects`JavaObject119540230914049]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(split@setDividerLocation[120]\)], "Input"],

Cell[BoxData[{
    \(\(frame@repaint[];\)\), "\[IndentingNewLine]", 
    \(JavaShow[frame]\)}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(DeleteJObject[pane, split]\), "\[IndentingNewLine]", 
    \(ReleaseObject[p1]\), "\[IndentingNewLine]", 
    \(ReleaseObject[p2]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JTabbedPane <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;K0001VAP00`40o`00
0?l0003oo`000?l0003M000000000hS0^4R@R4R@R03oB928odR@R=U8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^=R8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;SHR<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c1[<c<coIVIV^fIVIP:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<
6/c<c003ooooc<c<c<c<0?o<c<bgc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0olc<c;O<c<`016IV
IXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<
c<c<c03oc<c<]lc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;Soc<c<6/c<c003ooooc<c<c<c<0?o<c<a2c<c<00<0003<c<c<c<`0L/c<
c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003
ooooc<c<c<c<0?o<c<a2c<c<0P0007?<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01]c<c<0P0000?<
c<`200000/c<c0D000000lc<c00000000002c<c<0P0000;<c<`200000/c<
c0D00005c<c<100000K<c<`400000/c<c0800002c<c<0P0000;<c<`20000
00C<c<`00000003<c<`200000/c<c0@00005c<c<0P0000C<c<`400000/c<
c0800002c<c<0P0000;<c<`2000000C<c<`00000003<c<`200000/c<c080
0002c<c<0P000003c<c<0000000000;<c<`400001/c<c08000000lc<c000
00000002c<c<100000G<c<`200000/c<c0030000c<c<c<c<00800002c<c<
100000;<c<`200000/c<c0800002c<c<1@0000C<c<`6000000?<c<`00000
00000/c<c0@00003c<c<1@000003c<c<0000000000K<c<`00`000<c<c<c<
c01ac<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`J
c<c<00?oooo<c<c<c<`0KLc<c0800003c<c<0P000003c<c<0000000000;<
c<`2000000?<c<`0000000000/c<c0800002c<c<0P000003c<c<00000000
00;<c<`200001<c<c0800002c<c<0P0000C<c<`200000/c<c08000000lc<
c00000000002c<c<0P0000;<c<`2000000C<c<`00000003<c<`2000000?<
c<`0000000000/c<c0800004c<c<0P0000?<c<`200000/c<c08000000lc<
c00000000002c<c<0P0000;<c<`2000000C<c<`00000003<c<`200000/c<
c08000001<c<c00000000<c<c0<000000lc<c00000000002c<c<0P0000C<
c<`2000000G<c<`000000000003<c<`00P0000;<c<`200001<c<c0800000
1Lc<c000000000000<c<c002000000?<c<`0000000000/c<c08000000lc<
c00000000002c<c<0P000003c<c<0000000000;<c<`200001<c<c0800005
c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c080
00000lc<c00000000006c<c<0P0007;<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01]c<c<0P0000;<
c<`200000/c<c0800002c<c<0P000003c<c<0000000000;<c<`200000/c<
c08000000lc<c00000000002c<c<0P0000O<c<`300001lc<c0<000000lc<
c00000000002c<c<0P0000;<c<`2000000C<c<`00000003<c<`2000000?<
c<`0000000002<c<c0800003c<c<0P0000G<c<`200000/c<c0800002c<c<
0P000004c<c<00000000c<c<0P0000;<c<`2000000?<c<`0000000000/c<
c0800004c<c<0`0000C<c<`200000/c<c0800004c<c<0`0000C<c<`20000
00G<c<`000000000003<c<`00P000003c<c<0000000000;<c<`2000000?<
c<`0000000000/c<c08000000lc<c00000000002c<c<0P0000C<c<`20000
1Lc<c0800004c<c<0`000003c<c<0000000000;<c<`200001<c<c0<00002
c<c<0P0007;<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
olc<c1[<c<`00oooolc<c<c<c01]c<c<0P0000;<c<`200000lc<c0800000
1<c<c00000000<c<c0800002c<c<0P0000;<c<`200000/c<c08000000lc<
c00000000005c<c<100000K<c<`400000/c<c0800002c<c<0P0000;<c<`2
000000C<c<`00000003<c<`2000000?<c<`000000000100000C<c<`20000
0lc<c0H000000lc<c00000000002c<c<0P0000;<c<`2000000C<c<`00000
003<c<`200000/c<c08000000lc<c00000000002c<c<0P0000;<c<`40000
1Lc<c0800002c<c<0P0000;<c<`400001Lc<c08000001Lc<c0000<c<c000
0<c<c002000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<
0P0000;<c<`2000000?<c<`0000000001<c<c0800005c<c<0P0000;<c<`4
00000lc<c08000000lc<c00000000009c<c<0P0007;<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01]
c<c<1P0000C<c<`4000000?<c<`0000000000/c<c0800002c<c<0P0000?<
c<`400001<c<c0<00007c<c<0`0000C<c<`200000/c<c0800002c<c<0P00
0004c<c<00000000c<c<0P000003c<c<0000000000;<c<`200001<c<c080
0003c<c<0P0000;<c<`2000000?<c<`0000000000/c<c0800002c<c<0P00
0004c<c<00000000c<c<0P0000;<c<`2000000?<c<`0000000000/c<c080
00001<c<c0000000000000O<c<`200000/c<c08000001<c<c00000000000
00O<c<`2000000G<c<`0003<c<`0003<c<`00P000003c<c<0000000000;<
c<`2000000?<c<`0000000000/c<c0800003c<c<100000C<c<`200001Lc<
c08000001<c<c0000000000000K<c<`400002Lc<c080001bc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<
c<`0KLc<c0D00003c<c<00@0003<c<c<c<c<c<`2000000G<c<`000000000
003<c<`00`000005c<c<00000000c<c<000000?<c<`200001<c<c0800002
c<c<0P0000C<c<`200000/c<c08000001Lc<c000000000000<c<c0030000
00C<c<`00000003<c<`2000000C<c<`00000003<c<`200000/c<c0800004
c<c<0P0000?<c<`200000/c<c08000001Lc<c000000000000<c<c0030000
00C<c<`00000003<c<`2000000G<c<`000000000003<c<`00P000004c<c<
00000000c<c<0`000003c<c<0000000000;<c<`200001<c<c0800002c<c<
0P000003c<c<0000000000;<c<`200001<c<c0@000000lc<c00000000002
00000/c<c0030000c<c<c<c<008000001Lc<c000000000000<c<c0020000
00?<c<`0003<c<`00/c<c0800004c<c<0P0000G<c<`2000000?<c<`00000
00000/c<c08000000lc<c0000<c<c002c<c<0P000003c<c<0000000000K<
c<`20000L/c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;So
c<c<6/c<c003ooooc<c<c<c<06g<c<`2000000?<c<`0000000001<c<c0@0
0002c<c<0P000003c<c<0000000000;<c<`200000lc<c0@00002c<c<0P00
00;<c<`400001/c<c0@00002c<c<0P000003c<c<0000000000;<c<`20000
0/c<c08000000lc<c00000000002c<c<100000G<c<`400000/c<c0@00002
c<c<0P000003c<c<0000000000;<c<`200000/c<c08000001<c<c0000000
0<c<c0800003c<c<0P000003c<c<0000000000;<c<`400001Lc<c0800002
c<c<0P0000;<c<`400001Lc<c0@000000lc<c0000000000200000/c<c0@0
0002c<c<0P000003c<c<0000000000?<c<`400001Lc<c0800005c<c<0P00
00;<c<`400000lc<c0@00002c<c<0P0000K<c<`00`000<c<c<c<c01ac<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?o
ooo<c<c<c<`0KLc<c0800002c<c<0P0001_<c<`200008<c<c080000`c<c<
0P0001c<c<`300000lc<c0<0000Ic<c<0P0001g<c<`20000Llc<c004IVIV
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<
c<c<06g<c<`200000lc<c080000Jc<c<0P0001g<c<`2000000?<c<`00000
00008/c<c080000<c<c<0P0001c<c<`300000lc<c0<0000Ic<c<0P0000G<
c<`200005/c<c0030000c<c<c<c<07;<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c03oc<c<]lc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003oooo
c<c<c<c<0?o<c<bgc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0olc<c;O<c<`016IVIXS0^8S0^4R@
R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c03oc<c<
]lc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<
c003ooooc<c<c<c<0?o<c<bgc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0olc<c;O<c<`016IVIXS0
^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<
c03oc<c<]lc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;So
c<c<6/c<c003ooooc<c<c<c<0?o<c<bgc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c00>4BHD
2@TD6Q`N2A8:2@T:2@TD2A8:2A`N2@T:2@TD00002@TD00002@T:0P000009
2@T:2A8:000000002@T:2@TD00002@TD2@T:00<000001`TB2P0000T92PT9
2P0000T92P0000022@T:00<92A@000092@X00PT92P0500002@T:00002@T:
000000892@X00`0000T92PT92P03000000<92@X92A@00000100000062@T:
0000000000002@T:00000PT92P0500002@T:000000002@TD00H000022@T:
0P0000032@T:0000000000@000000`T92P0000000002000000<92@X00000
0000600000032@T:0000000000H000000aXB50000000000M000000<A9Qh0
000000007@0000032@T:0000000002h000000b`h:DIED/c<c01Pc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<
c<c<c<`0GLc<c0062A8:6Q8D2A`D2@TD2A`N6PT:0QXB50074BHD2@TD4A`:
6Q8D2A`D2@TD4BHD00892A@02@TL51XB50T950T9514V50TL51XB50T92QXB
50022@TD00D92@X92A@94PX92A@J4Q@00PT92P094A`:2@T:4A`:2A8:2@T:
2@TD2@T:6Q8D2@T:00<94PX010TL50T950TB2PT9508J4Q@01@T951XB50TB
2PTB2PT950022A8:0`T950042A8:2A`D2@TD2@TD0PTB2P0;2@TD2A8:2@T:
2A8:2@T:2@TD2A8:6Q8D2A8:2@T:2@TD00<94PX22@T:0PTB2P056Q8D2@TD
2@TD2A8:6Q8D00<94PX22@TD00<94PX92A@J4Q@00PT950052A8:4BHD2A8:
2@TD6Q8D00892A@010TB2PT950T950TB2P@92A@02PTB2PT951XB50T950TL
7QXB50T950TB2PT951XB50892A@00`TL7QXB51XB50032@TD00l94PX92A@J
4Q@971@92A@971@92A@971@J4Q@92A@J4Q@92A@A9Q@971@92A@00aXB5089
2A@010TB2QXB51XB51XB50892A@011XB50T951XB50TL50892A@01PTL51XB
50T950T92QXB514V50@92A@010TL50T950TB2QXB50892A@00a4V50T951XB
50022@TD00HA9Q@92A@971@J4Q@92A@A9Qh22@TD00DA9Q@92@X971@J4Q@9
71@00PT950062A8:2A`D2@TD2@TD2A8:6Q8D0PT950074BHD2A8:2@TD2@TD
2@T:2A`N6Q8D00892A@01@TB2QXL7PT951XB50TB2P052@TD018J4Q@92A@9
2@XA9Qh92@XJ4Q@971h94PX92A@A70X92A@A9QhA9Q@92A@A70X92@Xd;c=b
LW]Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`J
c<c<00?oooo<c<c<c<`0GLc<c00:6Q8D4BHD2A8:6Q8D4BHD4BHN2@TD4A`:
4BHD2A8:0`T9500A4BHD2A8:6Q8D4A`:2@TD6Q8D2@TD6Q8D6PT:2A8:2@T:
4A`:2@TD4A`:2@TD2A8:4A`:00892@X00`T950T92PT92P022A8:00T92@X9
4PX94PX94PXA70X92@XA70X92A@J4Q@00`TB2P032@T:2@TD2@TD00894PX3
2@TD0PTB2P042@TD2A8:2@TD2A8:0`T9500:2@T:2A8:2A8:2@TD2@T:2A8:
2@T:2A8:2@TD2A8:1PT92P032A8:4A`:2@T:00<94PX010T950TB2PTB2PTB
2P892@X32A8:0`T950032A8:2@T:2@TD00892A@010TB2PT950T92PT950@9
4PX01@T950TB2PTB2PTB2PT92P026Q8D00<94PX92A@94PX00PTB2P892A@2
2A8:0PT950032A8:2A`D2A8:00894PX00`T951XB50T950022@TD00<92@XJ
4Q@92A@00PT950036Q8D2@TD2@TD00894PX010T951XB50T9514L2P892A@0
1Q4L2PT950TB2Q4L2QXB50T950892@X01A4L2QXB50T950TB2QXB50032@TD
00DJ4Q@92A@J4Q@J4Q@92A@00QXB50032@TD6Q8D6Q8D00892A@02QXB50T9
50T950T92QXB50T950TB2QXB50T951XL7P892A@01AXB50T950T950T951XB
50022@TD00<J4Q@971@J4Q@00PT9500=2A8:2@TD2@TD2@TD6Q8D2A8:6Q8D
2A8:2@TD6Q8D2@TD2A`D6Q8D00892A@36Q8D00`A70XJ4Q@971@A70XJ4Q@9
2A@A70X92A@A9QhA70X92A@A9Q@22@TD00LA70X92A@92A@92A@94PXm;ce?
GVH0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<
6/c<c003ooooc<c<c<c<05g<c<`01aXB50TB2PT9514V50T950TB2Q4V5002
2@TD00<A70X92@X92@X00PTB2P032@TD2A8:2A8:00894PX01`T92Q4L2PTB
2Q4V50T9514L2PTB2P042@T:00<A70X92@X94PX00Q4L2P892@X22A8:0`T9
2P092A8:4A`:2@T:2@T:00002A8:2@T:2A8:2@T:00D94PX010T950TB2PT9
2PTB2P<92@X00`T950TB2PTB2P052A8:00@92@X94PX94PX92@X22A8:0`T9
2P032A8:2@T:000000<94PX01@0000TB2P0000TB2PT92P042A8:00<J4Q@9
4PX92@X00PTB2P892@X01`TB2PT92PT92PT950TB2PT92PT950022A8:00H9
2A@92@X94PX92A@94PX92@X32A8:00<92A@94PX92@X00`T92P032A8:2@T:
2A8:00<92@X013d_?@T92PTB2PT92PD94PX00a4L2PT92PTB2P022@T:00HA
70X92@X94PX94PX92A@94PX22@T:00L94PX99RT92@X92@X92A@92@X92A@0
0PTB2P0=2@T:2A8:2A8:2A8:2@T:2A8:2@T:4A`:2@TD6Q8D2@T:2A8:2@T:
00894PX01Q4L2PT950TB2PT950TB2PT92P<94PX00`T92Q4L2PT950022@T:
00D92A@94PX94PXA70X92@X00PTB2P034A`:2@T:2@T:008J4Q@02@T951XB
50TB2QXB50T950T92PTB2PTL50T950022A8:01@92A@94PXJ4Q@J4Q@92A@J
4Q@92A@A70X94PX92A@92@X94PX92A@94PX92A@94PX92A@94PX92A@J4Q@2
2@TD00<J4Q@94PX92A@00PT950062A`D4A`:4BHN0000=2lcCeiVHLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003oooo
c<c<c<c<05g<c<`0314L2QXB50TL514L2PT951XB50T9514L2Q4V50T950T9
2Q4L2P892@X011XB50TB2Q4L2PT92P<94PX22@T:00<J4Q@92A@94PX020TB
2P892@X010TB2PT92PTB2PT92P894PX00a4L2PT92QXB50042@T:00@94PX9
2@X94PX92@X22A8:00H000092A@92@X94PX92@X000022A8:00<92@X00009
4PX00PT92P0:2@TD2A8:2A8:2@T:00002A8:2@T:00002A8:2@T:0PTB2P07
00002A8:2@TD2A8:00002@TD000000894PX22@T:00D000094PX94PX92@X9
4PX00PT92P062@TD2A8:2A8:2A8:00002A8:10T92P@94PX32@T:0PTB2P04
2@T:2A8:2@TD2A8:0`T92P894PX00`T92Q4L2PT92P042A8:0`T92P056Q8D
2A8:00002@T:2A8:00<92@X01`TB2Q4L2PT92PT92PTB2PT92PTB2P022@T:
00@A70X94PX94PX92@X72A8:00@92@XJ4Q@J4Q@92@X22A8:00DJ4Q@A70X9
2@X94PX92@X00PTB2P892@X00`T950TB2PTB2P022A8:00@A70X92@X94PX9
2@X32A8:00D92A@m;cd0000A70X92@X00QXB50<94PX00a4L2PTB2PT92P03
2A8:00@92@X92A@A70X92@X22@TD00@971@A70X92@X94PX22@T:00<92A@9
4PX92A@00PT92P892A@03`TB2PT950T950TB2PT951XB50TB2PTL50TB2Q4L
2QXB50TB2PT92PT9514L2P032@TD00@J4Q@94PXd;bUZNhAQc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<
c<`0GLc<c0032A`D2@TD6Q8D008971@00`T92Q4V50T950032A8:00<92A@A
9Q@94PX00PTB2P064A`:2A8:2A8:2A8:2@T:4BHD0PTB2P054A`:2@TD4A`:
2@TD2@T:00894PX22@T:00<94PX92@XA70X00PTB2P892@X010TB2PT92PTB
2PTB2P892@X32A8:00<000092@X94PX00`TB2P892@X32A8:00<92A@94PX9
4PX00PT92P<94PX00`T950T92PTB2P022A8:00<92A@94PX92@X00PT92P03
2A8:2@T:2A8:00894PX01P0000T92PT92PT950TB2P0000894PX22@T:00<9
4PX92@X94PX02PTB2P032@T:2A8:2@T:00D94PX00`T92PTB2PTB2P032A8:
0`T92P072A8:2@T:2A8:2A8:2@T:2A8:2@T:00894PX22@T:0`TB2P032@T:
2A8:2A8:00894PX22@T:0PTB2P062@T:2A8:2A8:2A8:6Q8D4A`:0PT92P07
2A8:2@T:4A`:2@T:2A8:2@T:2@TD00@94PX22@TD00DA70X94PX92@X92A@A
70X00PTB2P892@X00`T9514L2PTB2P022A8:00@J4Q@94PX92A@J4Q@22A8:
00D92@X94PX92A@J4Q@94PX00PT950062@T:2A8:2A8:2@TD2A8:2@T:0PTB
2P072@TD2@T:6Q8D6Q8D2@T:4A`:2@TD00@94PX00`T951XB51XB50022A8:
00PA70X94PX94PX94PXA70X92A@92@X94PX36Q8D0PTB2P@92A@00`TB2PT9
50T950022@TD00P971@J4Q@94PXA9Q@971@94PXd;bUZLUaQc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<
c<`0GLc<c0076Q8D4BHD2A8:6Q8D2@TD4A`:2@TD00894PX01aXB50T9514V
50T950TB2QXB50T950022A8:0PT92P032A8:2@T:2A8:00892@X00`TB2PT9
2PTB2P022A8:0PT950<94PX010T92PTB2PTB2PTB2P892@X01`TB2P0000T9
2PT92PTB2P0000TB2P022@T:00@94PX92A@000092A@22A8:00<92A@92@X9
2A@00P0000032@T:2A8:2@T:00@94PX03`T950T92PTB2P0000T92PTB2PT9
2PTB2P0000T92PTB2PT92PT950T92PTB2P022@T:00<94PX000092@X00PT9
2P032A8:2@T:2@T:00@92@X00`TB2PT92PTB2P032@T:00<94PX000094PX0
0PT92P042A8:00002@T:2A8:0PT92P<94PX42@T:00@94PX92@X94PX92@X2
2A8:00<92@X94PX94PX00PT92P062A8:2@T:2A8:2@T:2A8:00002PT92P09
2A8:2@T:2@TD2A8:2@T:2@TD2@T:2A8:2@T:00<94PX02`T950TB2PT92PT9
2PTB2PT92PTB2PTL51XB50T92PT950022@T:0PTB2P892@X01`TB2PT950T9
2PTB2PT950TB2PT92P022A8:00<92@X94PX94PX00`T92P042A8:4A`:2A8:
2@T:0PTB2P042@T:4A`:2@TD2A8:10T950892@X32A8:0PT950062@T:2A8:
2@TD2@TD2A8:2@T:0PTB2P892@X01a4L2PT92PTB2PT950T92PT950TB2P02
2@T:0PTB2P892A@42A8:00<92A@94PXJ4Q@00PT950032@T:=2lcJW]_067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`0
0oooolc<c<c<c01Mc<c<00XA9Q@J4Q@971@92@XJ4Q@94PXJ4Q@94PX92@X9
4PX42@T:00@92A@A70X92@X92@X22A8:0PT92P042A8:2@T:2@T:2A8:0PT9
2P894PX01@T92PTB2PT9500000TB2P022@T:00<000094PX92@X00PT92P89
4PX32@T:0PTB2P892@X00`TB2PT92PTB2P032A8:00<92@XJ4Q@92@X00PTB
2P@92@X00`T950TB2PTB2P042@T:00<94PX92@X000000PTB2P032@T:2A8:
6Q`N00892@X22A8:2PT92P032A`N2@T:2@T:00<92@X010TB2PT92PT92PT9
2P894PX32@T:0PTB2P032@T:2A8:2@T:00@92@X00`TB2PT92PT92P022A8:
0PT92P032@TD2@T:2A8:00<92@X010T950T92PT950T92P894PX22@T:00H9
4PX92@X92@X94PX92@X94PX22@T:0PTB2P892@X00`T950T92PT92P092@T:
00@94PX92@X92@X94PX32@T:00<94PX92@X94PX00PT92P052A8:2@T:2@T:
4A`:2A8:00892@X020TB2PT950T950TB2QXB50TB2PT92Q4L2P<92@X01QXB
50T92PT950T950TB2PT950<92@X011XB50T92PTB2PT92P<94PX01PT92PT9
50T950TB2Q4L2PT950892@X02a4L2PTB2PT92PT92PTB2PT92Q4L2PT92PTB
2PT951XB50032@T:1@T950<94PX020T950TB2PT951XB50TB2PT92S@_:EMN
Kf7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<
c<`00oooolc<c<c<c01Mc<c<00D94PXJ4Q@J4Q@971@92@X020TB2P074A`:
4BHD2@T:2A8:2@T:2A8:2@T:00894PX01AXB50TB2PT92PTB2PT92P022A8:
0PT92P052A8:2@T:2@T:2@T:2A8:00892@X00`T950TB2PTB2P022@T:00<9
4PX92@X92@X00PT92P0300002@T:2A8:00894PX00`T92P0000TB2P032A8:
00@92@X92A@94PX92@X42A8:00D92@X000094PX92@X94PX00PT92P070000
2A8:2@T:00002@T:2@TD;1`D00892@X01PTB2P0000TB2PT92PTB2PT92P89
4PX22@T:0PTB2P@92@X00`TB2PT950TB2P022@T:00/94PX92@X92A@94PX9
2@X94PX92@X94PX92@X000092@X00`TB2PH92@X02@TB2PT92PT92PTB2PT9
2PTB2PT92PTB2PT950022@T:0PTB2P042@T:2A8:2@T:00000PTB2P032@T:
4A`:2@T:00894PX010T92PTB2PTB2PT950894PX00`T92PTB2PT92P032@T:
0PTB2P892@X01@TB2PT92Q4L2PT950T92P052A8:00<92@X94PX92@X00`TB
2P092@T:2A8:2@T:2@T:2@TD2A8:2@T:2@TD2A8:00<92@X00a4L2PTB2PTB
2P022@T:00@J4Q@92@X92A@94PX22@T:00HJ4Q@92@X92@X92A@94PX92A@2
2@T:00<94PX92@X92A@00PT92P034A`:2@T:2@T:00892@X22A8:0PT92P03
2A8:2@TD2@T:00894PX22@T:00<A70X92@X92@X00PT92P072A8:2@TD2A8:
2A8:2@TD2A8:6Q8D00892A@00c@_:Cd_?Lc<c01Pc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<
c0074BHD6Q8D2A8:4A`:2A8:4A`:6Q8D00892@X010TB2PT92PTB2PTB2P89
2@X01PTB2PT92Q4L2PT92PTB2PT92P894PX00`T92PTB2PTB2P032@T:00@J
4Q@92@X92@X94PX42@T:00<A70X94PX000000`TB2PH92@X22A8:00<00009
2@X92@X00PT92P092A8:2@T:2@T:2@T:4A`:2A8:2@T:2A8:000000T92@X0
3@TB2P00000000T92Q4L2PTB2PT950T92PTB2P0000T950T92P0000052@T:
00<94PX0000000000`T92P072A8:00002A8:00002@T:2A8:000000D92@X0
0`TB2P0000T92P022@T:00<000092A@0000020T92P072A8:00002@T:2A8:
2@T:2A8:2@T:00<94PX00`T92PTB2PT92P052@T:00T92A@000092@X94PX9
2@XJ4Q@92@X94PX92@X00PTB2PL92@X00`0000T92PTB2P032@T:00<94PX0
00092@X00PT92P044A`:2@T:2@T:2A8:1PT92P042A8:2@T:2@T:2A8:0PT9
2P052@TD2@T:2A8:2@T:2A8:00892@X22A8:2@T92P894PX01@T92PTB2PT9
2PTB2PT92P032A8:1@T92P052A8:2@T:2A8:2A8:2@T:00894PX22@T:10TB
2P082@TD2@T:2@T:2A8:2@TD2@T:6Q8D2A8:0PT950032@T:=2lYAT`m067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`0
0oooolc<c<c<c01Mc<c<00@J4Q@A9PX92A@J71h22A8:00<J4Q@92A@94PX0
1`TB2P032@T:2A8:2@T:00894PX01@T92PTB2PTB2PT92PTB2P022@T:00@S
;bT94PX94PX92@X36Q8D0PTB2P052@T:2A8:00002@TD000000H92@X01a4V
7P0000TB2PT9500000T92PTB2P022@T:00@S;bT92@X94PX94PX52@T:00P9
4PX92@X92@X94PX92A@000094PX000022@T:00D94PX92@X92@X92@XJ71h0
10T92P0500002@T:2@T:2@T:2A8:00892@X010TB2PT92PT92PTB2P`92@X0
10TB2PT92PT92PTB2PL92@X01@TB2PT92PT92PT92PTB2P062@T:00@J71h9
2@X92@X000022@T:00D94PX92@X92@X92@X94PX00PT92P032A8:00002@T:
00@92@X020TB2P0000TB2P0000T92PTB2PT92PTB2PD92@X011XB50T92PT9
2PTB2PX92@X00`TB2PT92PT92P022A8:00<92@X94PX94PX01@T92P032A8:
2@T:2@T:00892@X02@TB2PT92PTB2PT92Q4L2PTB2PT92Q4L2PTB2P022@T:
00<94PX92A@94PX00PT92P052A8:2@T:2A8:2@TD2A8:00892@X32@TD00<9
4PX92A@92@X00PT92PD94PX00`T950T92QXB50032A8:00<92A@92@X92A@0
10T950044BHN2@T:=2lYCeiVHLc<c004IVIVR<2hR<2hB9280@00000000B8
`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`010T9514L2PT9
50TB2P892A@52A8:00@92A@94PX92@X94PX22@T:0PTB2P072@T:2A8:2@T:
2A8:2@T:00002A8:00892@X00`0003d_?@T92P042A8:1@T92P072A8:2@T:
2A8:2A8:2@T:4A`:2A8:00892@X010TB2P0000T92PTB2P892@X011XB50TB
2PTB2Q4L2P@92@X00`TB2PT92PTB2P022@T:00<94PX92@X92@X01@T92P07
00002A8:2@T:2A8:8blY2@T:2A8:00H92@X01P0000TB2PT92PTB2PT950TB
2PD92@X010TB2PT92PT92PT92P894PX52@T:00<94PX92@X94PX00PT92P04
2A8:2@T:2A8:2A8:0`T92P<94PX01PT92Q4L2PT92PTB2PT92PTB2P892@X0
1@TB2PT92P0000TB2PT92P022A8:0`T92P894PX22@T:00<94PX92A@94PX0
1PT92P0300002A8:2@T:00D92@X00`TB2QXL7PT92P062@T:00<94PXA70X9
4PX00PT92P082A8:2@T:2A8:2A8:2@T:2A8:2@TD2A8:1@T92P032A8:2@T:
2@T:00@92@X01PTB2PT92PTB2PTB2PT950TB2P892@X01PT950T92Q4L2PTB
2Q4L2PT92P@94PX01PT9514L2Q4L2PTB2Q4L2PTB2PD92@X01@TB2PT92PT9
2PT950TB2P022@T:00d92A@J4Q@94PX92A@94PX92@XJ4Q@92A@J4Q@92A@9
2@Xd;aibLW/0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`01aXB50T950TL50T9514L2PT9
2QXB50022@TD0PTB2P<92@X011X92PT92PT92PT92P<94PX72@T:0PTB2P<9
2@X22A8:0PT92P032A8:2@T:2A8:00<92@X06@00014L2PT92P00014L2PT9
2P00014L2P0000T92PTB2PT92PT950T92PTB2P0002`h:@T950T92PTB2PT9
2PTB2P0000T92Q4L2P042@T:00L000092@X92@X000092@X000094PX00P00
00032@T:00002A8:00<92@X0100000T92PTB2P0000892@X2000000L94PX9
2@X92@X94PX000092@X000000`T92P0300002A8:2@T:008000001@T92PTB
2PT92PT92P0000022@T:00D000092@X92A@0000A70X00`T92P0800002@T:
00002A8:2@T:00002A8:00000PTB2P892@X0100000T92PT92P0000@92@X0
0`00014L2PT92P032@T:00<0000A70X94PX01@T92P0400002A8:2@T:4A`:
0PT92P8000000a4L2PT92PT92P042@T:00<94PX92@X92@X01@T92P030000
2@T:2A8:00L92@X010TB2PT92PT92P0000892@X22A8:1@T92P032A8:2@T:
2A8:00H92@X22A8:00<92@X94PX92@X02@T92P072A8:2@T:2@T:2@T:2@TD
2@T:4A`:00@92@X00a4L2PT92QXB50032@T:00<92A@d;bUbLW/0HLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003oooo
c<c<c<c<05g<c<`01`T92PTL50TL50T9514L2PT92Q4L2P022A8:00<92A@9
2@X94PX01@TB2P0700002A8:2@T:2@T:2A8:2@T:2A8:00892@X00`TB2P00
00T92P042@T:00L0000A70X92@X92@X000094PX92@X00PTB2P892@X010TB
2PT92PT92PTB2P@92@X0300000T92PT92R`L50TB2PT92PTB2PT92PTB2Q4L
2PTB2PT92P<94PX32@T:00<94PX92@X92@X00P0000042A8:00002A8:0000
0PT92P082A8:2@T:2A8:2@T:2A8:00004A`:00000PT92P032A8:2@T:0000
00<92@X01@TB2P0000T92PTB2P0000022@T:00X94PX92@X92@X92@X94PX9
2@X94PX000092@X000032@T:0PTB2P8000000`T92PTB2PTB2P052@T:0189
4PX000092@X92A@0000J2@X000092@XA70X000094PX000092@X94PX92@X0
00094PX000052@T:00<000092@X92@X00PT92P0800002@T:2@T:2@T:4A`:
6Q8D00002@T:0PTB2P032@T:2A8:2@T:00<92@X00`TB2P0000T92P052@T:
00<94PX92@X94PX01PT92P032A8:2@T:2@T:00D92@X00`0000TB2PT92P09
2@T:00@A70X94PX92@X94PX22@T:00D92A@92@X92@X92@X94PX00`T92P89
4PX52@T:00<94PX92@X92@X00`T92P032A8:2@TD2A8:00<92A@22A8:00<0
000d;aiPLW/0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`00`TL50TB2QXB50042A8:00H9
2A@94PX92A@A70X94PXJ4Q@32@T:00<94PXA70X94PX00PTB2P072@T:2A8:
00002A`D6PT:2A8:4A`:00<92@X22A8:0`T92P894PX0100000TB2PT92P00
00894PX01P0000TB2PT92PTB2PT92PTB2P892@X22A8:00@A70X94PX00009
2@X22A8:00L92@X94PX94PXA70X000094PX92@X00PTB2P0600002@T:2@T:
2A8:2@T:2A8:0P0000032A8:00002A8:008000022A8:00@000094PX92@X0
00032@T:00/000092@X92@X94PX92@X000094PX000094PX000094PX00PT9
2P0400002@T:2A8:00001@T92P052A8:2@T:2A8:2@T:000000<92@X01PTB
2P0000T92PTB2PT92PTB2P892@X02P0000T92Q4V50T92P0001XL7PTB2P00
00T92PTB2P/92@X0214L2PT92PT92Q4L2PT92PTB2PT92PTB2PD92@X00`TB
2P0001X92P032@T:00<94PX92@X94PX00PT92P<94PX22@T:0PTB2P032@T:
2A8:2A8:00892@X0114L2PT92PTB2PTB2P<92@X01PTB2PT92PT92PTB2PT9
2Q4L2P892@X01`TB2Q4L2PT92PT92PTB2PT92PTB2P032@T:1@TB2P892@X0
0a4L2PT92PTB2P032@T:00T94PXA70X92@X92@XA70X94PX92@X94PXA70X0
0`T92P032A8:4A`:2A8:00894PX01a4L2PTB2PT950T9500003@_7W9bN`1Q
c<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<
00?oooo<c<c<c<`0GLc<c0036Q8D2A8:2A8:00<94PX00a4L2PT92PTB2P02
2@T:0`TB2P034A`:2@T:2@T:00894PX01@T92P0000TB2PT92PTB2P020000
00X92@X94PX92@X92@X94PX92@X94PX92@X94PX000032@T:014000094PX9
2@X92@X000092A@92@X94PX92@XA70X92@X94PX92@X94PX000092A@94PX0
0PT92P032A8:2@T:2@T:00D92@X01@0000T92PT92PT92P0000022A8:1PT9
2P894PX01Q4L2PT92P0000TB2P0000TB2P<92@X01PTB2PT92PT92PT92P00
00TB2PD92@X0100000T92PT92PTB2P<92@X02@TB2PT92PTB2PT92PTB2P00
00TB2P0000TB2P072@T:00@000094PX000094PX22@T:00D94PX000094PXA
70X000000`T92P0400002@T:00002A8:10T92P052A8:2@T:2@T:2@T:2A8:
00892@X010TB2PT92PTB2PT92P894PX92@T:00D94PX92@X92@X0000A70X0
1`T92P062A8:2@T:2@T:2@T:00002A8:0`T92P032A8:2@T:2@T:00L92@X0
10TB2PT92PT92PTB2P<92@X01@00014L2PT92PT92Q4L2P022@T:00<94PX9
2@X92@X010T92P034A`:2A8:2@T:00X92@X00`TB2PT92PT92P032@T:00T9
4PX92@X94PX92@XA70X94PX92A@/4P1bLW/0HLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`0
10T950TB2PTB2PT92P894PX32@T:0PTB2P892@X00`TB2PT92PTB2P042@T:
00<94PX92@X92@X00P0000082A8:2@T:2@T:00002A8:00002A8:2@T:0P00
00052A8:2@T:2@T:2@T:2A8:00892@X0200000T92P0000TB2PT92P0000TB
2PT92P<0000010TB2P0000T92P0000894PX00`0000TB2PT92P022A8:00@0
00092@X92@X94PX2000000L92@X94PX000092@X0000A70X000000PTB2P@0
00000`TB2P0000T92P022@T:00<000092@X92@X00P0000032@T:00002@T:
0080000040T92PTB2P0000T92P0000T92P0000TB2P0000T92P0000T92P00
00TB2P0000TB2P8000004PTB2PT92P0000T92P0000TB2PT92P0000TB2P00
00T92P0000TB2P0000T92P0000T92P0000<92@X00`0000T92PT92P022@T:
00<000094PX92@X00`T92P032A8:2@T:000000894PX01P0000TB2P0000TB
2P0000TB2PH92@X02@TB2PT92PT92PT92P0000TB2PT92P0000TB2P042@T:
00<94PX92@X92@X00PT92P074A`:2@T:2@T:2@T:00002@T:4A`:00@92@X0
2`TB2PT92Q4L2PTB2R`L50T92PTB2PT92Q4L2PT92PTB2P052@T:0PTB2P03
4A`:2@T:2A8:00`92@X0114L2PT92PT92PTB2P892@X22A8:00D92@XA70X9
4PX92@X92A@00PT92P062A8:2@T:2A8:0000=2lNLW9kHLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<
05g<c<`24A`:00@92@XA70X94PXJ4Q@32A8:00@J2@X000094PX92@X22A8:
00<92@X94PX92@X010TB2P<92@X00`TB2PT92Q4L2P032@T:0PTB2PD92@X0
0`TB2P0000T92P082@T:00<94PX92@X92@X01PT92P894PX00`T92PTB2P00
00022@T:0PTB2P096PT:2A8:00002A8:00002@TD2@T:2A8:000000<92@X0
0`TB2PT92PT92P042@T:00<94PX000092@X010T92P034A`:00002@T:0089
2@X01PTB2P0000TB2P00014L2P0000H92@X00`0000T92PT92P022@T:00<9
2A@000092@X01`T92P0400002@T:4A`:00000`T92P082A8:00004A`:0000
2A8:00002@TD2A8:1@T92P032A8:2@T:2@T:00894PX00`0000T92PT92P06
2@T:00@A70X0000A70X94PX82@T:0PTB2P0600002@T:2@T:2@T:2A8:0000
0PT92P032A8:2@T:2A8:00D92@X01@TB2PT92PT92PT92Q4L2P032@T:00DJ
4Q@92A@A70X92@X94PX00`T92P044A`:2@T:2@T:2@T:0PTB2P056Q8D2@TD
2@T:2@T:4A`:00@92@X00a4L2PT92Q4L2P022@T:00@94PX92@X92@XA70X3
2A8:00<92@X94PX92@X00`T92P0:2A8:4A`:2A8:2@T:4A`:2A8:2@TD2@T:
;180PhB>HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;So
c<c<6/c<c003ooooc<c<c<c<05g<c<`01PT9514L2PT9514L2PTB2PT950<9
4PX010T92PTB2PTB2PT92P894PX52@T:00D94PX92@XJ4Q@92@X92A@01PT9
2P032A8:2@T:2@T:00894PX72@T:00<94PX92@X92@X02`T92P032A8:2@TD
2@T:00@92@X02`TB2PT92PT92PTB2PT950TB2QXB50T92P0000T92PTB2P03
2@T:00<94PX92@X92@X020T92P052A8:2@T:2@T:2@TD2@T:00894PX00`T9
2PTB2PT92P052@T:00@94PX92@X92@X94PX32@T:00@94PX92@X92@X94PX2
2@T:00<94PX92@X92@X020T92P044A`:00002A8:6PT:1PT92P0300004A`:
000001492@X01@TB2P0000T92PT92PT950052@T:00<94PX92@XA70X01@T9
2P032A8:2@T:2@T:00D92@X00`T950T92PT92P032@T:00<A70X92@X92@X0
0PT92P0300002@T:2@T:00<92@X00`TB2Q4L2PT92P072@T:00<92A@A9Qh9
2@X030T92P034A`:2A8:2@T:00H92@X00`T950T92Q4L2P032@TD0PT92P05
6Q8D2@T:2@T:6Q8DPhAk067<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<0PTB2P062@TD6Q8D
6Q8D6Q8D2@T:2A8:0PT92P032A8:2@T:2A8:00D92@X01@TB2PT92PTB2PTB
2PT950022A8:00<92@X0000A9Qh00`T92P042@TD2@T:2@T:2@T:0P000008
2@T:2A8:2@TD2@T:00004A`:2@T:00000PTB2PH92@X32A8:00@000092@X9
2A@J4Q@72@T:00`J71h92@X0000J71h92@X94PX92@X000092A@000092@X9
4PX22@T:0PTB2P892@X00`TB2P0000T95002000000@94PX0000000092@X2
000000<J71h000094PX01@T92P0500002@T:2@T:00002A8:00892@X01000
00T950TB2P0000894PX01@0000TB2PT92PT92P0000052@T:00H94PX92@X9
2@X000092@X94PX62@T:00<000092@X94PX01@T92P052A8:2@T:2@T:2@T:
2A8:00P92@X22A8:00<000094PX92@X00PT92P0700006PT:2@T:6Q8D2@T:
2A8:2@T:00894PX52@T:00<A70X92@X92@X00PT92P032A8:2@T:2A8:0089
2@X011X92PT92PT92Q4L2P`92@X01a4L2PT92PT92PT92PT951XB514L2P03
2@T:00X94PX92@X92@X92@X94PX92@XA70X92@X94PX92A@22@T:00/92A@9
2@X94PX92@X92A@J4Q@971@J4Q@92A@92@X94PX00PT92P066Q8D2@TD6Q8D
2@T:6PT:PhB>HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`22@TD00@A70X92@X92@X94PX2
2@T:00LA70X94PX94PX94PX92@X92A@92@X00PTB2P082@T:2A8:2A8:0000
2@T:00002A8:00000PTB2P054A`:00002A8:2@T:2A8:00<92@X02@T950T9
2PTB2PT92P0000TB2PT92P0000TB2P032@T:00@94PX92@X94PX94PX32@T:
0P0000052@TD2A8:4BHD6Q8D000000894PX22@T:0PTB2P0:00002A8:2@T:
00002A8:2@T:00002@T:00002A8:0`T92P0;2A8:00002@TD00002@T:0000
2A8:00002A8:2@T:000000894PX22@T:00L94PX92@X94PX000094PX92@Xd
;ah00PT92P894PX32@T:0P0000034A`:0000000000892@X0100000TB2PTB
2PTB2P892@X020TB2PT92PT92PT92PTB2P0000TB2PT92P<94PX02P0000TB
2P0000T92P0000T950TB2PT92P0000TB2P<92@X020TB2PT92PT92Q4L2PT9
2PTB2P0000TB2P892@X01`TB2PT92PT92PT92PTB2P0000TB2P052@T:0`TB
2P892@X01P0000T92P0000TB2PT92PTB2P<92@X02P0000T92PT92QX92PTB
2PT92Q4L2PTB2PT92P0000<94PX0100000TB2PT92PT92PH94PX01@T92PTB
2PTB2PT92PTB2P032@T:00D94PX92@X92@X92@X94PX00PT92P894PX010T9
50TB2PT92PT92P<94PX00aXB514L2PT92P022@T:00TS70X92A@94PX92@X9
4PX92A@94PX92@X92A@00PT92P032A8:8a`:SIR>067<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01M
c<c<00@J4Q@94PX92@XA70X22@T:00<94PX92@X94PX00`T92P062A8:2@T:
2A8:00002A8:00000PT92P0<00002A8:00002@T:00002A8:00002A8:0000
2A8:0000=2lc0P0000092A8:00002A8:00002A8:00002A8:00002A8:0089
2@X01@TB2P0000T92P0000TB2P022@T:0PTB2P032@T:2A8:000000894PX2
000000D94PX92@X92@X94PX000000PT92P8000000`TB2P00000000022A8:
00@000092@X94PX92@X2000000<92@X000092@X00`T92P072A8:2@T:2A8:
2@T:00002@T:000000894PX0200000T92PTB2PT92P0002=1DP0000T92P80
00000`T92P0000T92P022@T:00P000092@X92@X000094PX000094PX00002
2@T:00D94PX000092@X92@X94PX00P00000:2@T:2A8:000000002A8:0000
2@T:2A8:2@T:2A8:0P0000034A`:00002@T:00@92@X00`TB2PT92P000005
2@T:00P94PX000092@X92@X94PX000092@X94PX22@T:00L000094PX92@X9
4PX000092@X000002@T92P072A8:2@T:4A`:2@T:00002@T:2A8:00<92@X0
0`TB2P0000T92P022@T:00X000092@X92@X92@X94PX000094PX92@X94PX0
00062@T:00<94PX000094PX00PT92P<94PX32@T:00<94PX92@X92@X00`T9
2P046Q8D2@T:2A8:2@T:1@TB2P042@T:2A8:2A8:2@T:0Q4L2P894PX00aX9
2UMNKlc<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0
^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0052@TD2@T:4A`:00004A`:00<9
4PX011XB50TB2PTB2PTB2PH92@X02A4L2PTB2P0000TB2QXB500000T92PTB
2PT950022@T:0PTB2P0=00006Q`N000000002A8:00002@TD00002@T:0000
2A8:00002A8:00892@X0314L2P00014L2P0000T92Q4L2P0000T92P0000TB
2P0000TB2P892@X01@TB2P0000TB2P0000T92P042A8:00D000092@X92@X9
2A@000000PT92P0300002@T:2@T:00892@X01PTB2P0000TB2PTB2P0000TB
2P<000001@TB2P0000TB2PT92P0000022@T:00L94PX000092@X94PX00009
2@X0000010T92P052A8:00002A8:2@T:000000<92@X00`TB2P0000T92P04
2@T:00P94PX000092@X92@X94PX000092@X94PX32@T:00@000092@X94PX0
00042@T:00LA70X92@XA70X92A@S70X92@XA9Qh010T92P042A8:2@T:2@T:
2A8:20T92P032A8:00002@T:00<92@X00a4L2PT92PT92P022@T:00H00009
2@X92@X94PX92@X94PX32@T:00@94PX000092@X94PX32@T:00@94PX92@X9
2@X92@X22A8:10T92P032@TD2@T:2@T:00892@X010TB2PT92PTB2PTB2P89
2@X00`TB2PT92PT92P022@T:00@94PX000094PX92@X22A8:0PT92P894PX0
1PT92PTB2PTB2Q4L2PT92PTB2PD92@X00`TB2PT92PTB2P022A8:00@92A@0
000/4P23Q8iQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0
^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0032@TD2A8:2A8:00894PX22@T:
00<J4Q@92A@94PX00PTB2P@92@X01@TB2PT92P00000000TB2P03000000@9
4PX0000000094PX22@T:018000094PX000092@X94PX000094PX000092@X0
000J71h94PX92@X000094PX92@X000092A@22@T:0PTB2P892@X2000000<9
4PX000094PX00PT92P082A8:2@T:2@T:4A`:00002A8:2@T:00000PTB2P03
2@T:00002@T:00D92@X0100001XB500000TB2P8000000`TB2PT92PT92P02
2@T:00L000094PX000094PX92@X94PX92A@010T92P0400002A8:4A`:0000
0`T92P0300002A8:000000892@X03PTB2P0000T92PT92P0000TB2PT92P00
00TB2PT92PTB2PT92P0000TB2P<92@X00`0000TB2P0000022@T:00<00009
2@X92@X00PT92P092A8:2@T:6PT:6PT:;1806PT:;1808a`:;180008A70X0
1PT92QX92PT950TB2PT92P0000@92@X01@0000T92PT92PTB2P0000022@T:
00<94PX92@X92@X020T92P0300002@T:2@T:00892@X020TB2PT92PT92PT9
2P0000TB2PT92PTB2P<92@X00`0000TB2Q4L2P042@T:00<A70X92@X92@X0
0`T92P032A8:2@T:2@T:00H92@X010TB2PT950TB2PTB2P892@X22A8:0`T9
2P092A8:2@T:2@T:2@T:00002@T:2A8:2@T:2A8:00@92@X00`TB2PT92PTB
2P022A8:00<A70Z3Q8k<c<`0H<c<c004IVIVR<2hR<2hB9280@00000000B8
`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`22A8:00P92@X9
4PX92A@A70XA9Q@92A@J4Q@94PX;2@T:00L0000A70X92@X000094PX92@X9
4PX00P0000892@X020TB2PT92P0000TB2PT92P0000TB2P0000892@X01P00
00T92P0000TB2PT92PTB2PP92@X02P0000TB2PT92PT92P0000T92P0000TB
2P0000TB2P<92@X2000000L94PX92@X94PX92@X0000A70X000000PTB2P89
2@X2000000L94PX92@X000092A@92@X000092A@00PT92P<000001AXL7QXB
50T92PTB2P0000032@T:00<000094PX000000PT92P0600002A8:2@T:2@T:
2A8:000010T92P0300002A8:000000892@X00`0000TB2PT92P032@T:00<9
4PX92@X92@X020T92P8J2@X02b`B02<L2R<L2QX92R<L2QX92Q4L2QX92PT9
2R<L2R`B000?2@T:00/000092@X92@X92@X0000A70X000094PX92@X0000A
70X00PT92P894PX010T92P0000TB2PTB2P<92@X00`0000T92PT92P032@T:
00<000094PX92@X01@T92P032A8:2@T:2@T:00H92@X01@TB2PT92PT92PTB
2P0000022@T:00D92A@92@X92@X000094PX00PT92P032A8:2@T:4A`:00<9
2@X03QXB50T92PTB2Q4L2PTB2PT950T92PTB2PT92PTB2QXB50T92R`B09F4
SV7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<
c<`00oooolc<c<c<c01Mc<c<00<J4Q@J2@X94PX00PTB2P066Q8D6Q`N2@TD
2A8:2@T:2A8:0PT92P042A8:2@T:2@T:2A8:0PT92P894PX020T92P0000T9
2PT92PTB2P0000T92PTB2P<92@X00`0000T92PT92P032@T:00H000094PX9
2A@000092@X94PX22@T:00L0000A9Q@J4Q@92@X94PX92@X000000`T92P04
00002@T:2A8:00001`T92P062@TD00002@T:2@T:2A8:000010T92P072A8:
000000002A8:00002@T:000000892@X32A8:00/92@X000094PX92@XA70X9
4PX92@X000099RTJ2@X000000PTB2P032@T:00002@T:00<92@X00a4L2P00
00T92P042@T:0PTB2P0400002A8:2@T:00000`T92P032A8:2@T:2@T:00P9
2@X02AX92P0002<L2SdB2QX92PT92QX92R<L2QX92P028a`:00<J2@XS70XS
70X00QX92P036Q8D;1806PT:00<92@X00`TB2PT92PT92P062@T:00T94PX9
2@X92@XA70X94PX92@X94PX92@X000001PT92P894PX52@T:00<94PX92@X9
2@X00PT92P034A`:2@T:2@T:00D92@X00`TB2PT92PT92P022@T:00@J2@X9
2@X92@X94PX22@T:0PTB2PD92@X00a4L2PT92PT92P032@T:00<94PX92@X9
2@X010TB2P032@T:2A8:2A8:00892@X00`T950T92Q4L2P022A8:00H92A@9
2@X94PX94PX00023Q8iQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0036Q8D2A`D6Q8D0089
4PX00`T92R<_7QXL7P032A8:00D92@X94PX94PX92@XJ4Q@00PTB2P082@T:
00002@T:2A8:2@T:2A8:00002@T:0PTB2P0;00002A8:2A8:2A8:2@T:2A8:
2@T:2A8:00002A8:000000<92@X01@TB2P0000TB2PT92Q4L2P022@T:00<9
4PX92@XA70X01@TB2P892@X00a4L2PT92PTB2P042@T:00D94PX92@X94PX9
4PX000000`T92P032A8:2@T:000000@92@X030TB2PT92PTB2PTB2P0001X9
2PTB2P0000T92PTB2P0000T92P8000022@T:0`TB2P0500002@T:2@T:2A8:
2@T:00<94PX02P0000TB2PT92PTB2P0000T92PTB2P0000TB2P0000892@X0
10TB2P00014L2P0000892@X00a4L2P0000TB2P022@T:00@0000A70X92@XJ
2@X28a`:0R`B0005Ea`0;1806PT:;1808a`:008J4Q@24A`:00H/71@A70XS
70X92@XS70XA70X22@T:00<000094PX92@X00PT92P894PX52@T:00<94PX0
00092@X00PT92P032A8:2@T:2@T:00892@X22A8:10T92P894PX22@T:00D9
4PX92@X92@X92@XA70X00PT92P894PX02@T92PTB2PTB2PT92P0000TB2Q4L
2PTB2PT92P022A8:00DS;bT92@X92@X94PX0000010T92P042A8:2@T:2@T:
2A8:0PT92P042A8:2@T:2A8:2A8:0PT92P052A8:2@T:2A8:2@T:000000<9
2@X02a4L2PTB2PT92PTB2QXB50T950TB2PT9500001X92X>4SP1Qc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<
c<c<c<`0GLc<c0034BHD4A`:2@TD00894PX32@T:00<94PX92A@94PX00`TB
2P042@T:2@TD2@TD00000`TB2P0300002A8:2A8:00<92@X00`0000TB2PTB
2P022A8:00H92@XJ2@X94PX0000A70X000032@T:00L000092@X92@X92@X0
00094PX92@X00PTB2P892@X02P0000T9500000T9500000TB2PT92P0000TB
2Q4L2P892@X01@TB2PT92PTB2P0000T92P022A8:10T92P0400004A`:2@T:
2A8:0PT92P0500002A8:2@T:2@T:000000@94PX22@T:00D94PX92@X0000A
70X92@X00`0000042@T:00004A`:00000PTB2P0600002@T:2@T:00002@T:
00000`TB2P<92@X00`00014L2P0000032@T:00@000094PX000094PX42@T:
00HJ2@XA70XJ2@X/4P0m4PY69PX2?A8:018/4P0/71@S70XS70X/9Q@/71@J
2@X/71@J9Q@S70X/71@A70X/71@A9Q@92@X94PX92@X000022A8:0PT92P05
00002A8:2@T:2@T:2A8:00<92@X010TB2PT92PT92P0000T92@X00`TB2PT9
2PT92P022@T:0PTB2P092@T:4A`:2@T:2A8:4A`:2A8:2@T:4A`:2@T:00<9
4PX42@T:00`94PX92@X000094PX92@X94PX92@X94PX92@X94PX92@X94PX2
2@T:00<94PXJ2@X94PX00PT92P062A8:2@T:2@T:2@T:2A8:2@T:1@TB2P<9
2@X01Q4L2PT92QXB50T950T92PTB2P892@X00hfHS/c<c<c<c01Oc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<
c<c<c<`0GLc<c00<6Q8D2@TD6Q8D2@TD2A8:4A`:2@T:2A8:2@T:2A8:2BHY
6Q8D1PTB2P042@T:000000002A8:0PT92P0300002A8:2@T:00892@X02@TB
2PT92PTB2PT92P0000TB2P0000TB2P0000022A8:00<92@X94PX92@X00PTB
2P032@T:2A8:2@T:00894PX00`T92Q4L2PT92P022A8:0`T92P0500002@T:
2@T:2@T:2A8:00892@X01P0000TB2PT92PT950TB2P0000D92@X0100000TB
2PT92P0000<92@X010TB2PT92PTB2PT92P<000001`TB2P0000T950TB2PT9
2P0000TB2P032@T:00PA70X92@X000094PX92@X94PX000094PX32@T:00D0
00094PX92@X000094PX00`T92P0600002@TD2A8:00002@T:2A8:0PT92P05
2A8:00002@T:2@T:4A`:008J2@X00b`B03dB2SdB2P02?A8:01569PX/4P0m
4PXJ4Q@/71@J71hJ2@XA70XJ9Q@J71hA70XJ71hJ2@XA9PX94PX92@X94PX0
0`T92P0400002A8:2@T:2A8:0PT92P072A8:2@T:4A`:2@T:2A8:2@T:2A8:
00`92@X01`TB2PT92Q4L2PT92P0000TB2PT92P032A8:00<000094PX92@X0
10T92P034A`:2@T:2@T:00@92@X010TB2PT92PTB2PTB2P<92@X22A8:3@T9
2P034BHD2@T:2@T:00H92@X22A8:00LA70X92@X94PX94PXJ4Q@92@Z3Q8h0
HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<
c003ooooc<c<c<c<05g<c<`00`TB2QXB50T950032A8:00DJ4Q@92@X92@X/
71@94PX010T92P8J4Q@00`T950T92PT92P062@T:00H94PX000094PX00009
2@X000022@T:00X000092@X92@X94PX92A@000094PX000094PX000032@T:
00@A70X92@X92@XA70X22@T:00<94PX000092@X00PT92P034A`:00002@T:
00894PX22@T:00@000092@X92@X94PX22@T:00/94PX92@X92@X000094PX0
00092@XA70X000092@X94PX00P0000042@T:00002@T:2@T:0PTB2P040000
2A8:00002@T:0PTB2P0400002@T:2A8:2@T:0P0000892@X00`0000T92PT9
2P042@T:00H000092@X000094PX000092@X2000000DA70X000092@X94PX0
00000`T92P0600002@T:2@T:4A`:;1802@T:1AX92P<m4PX03AX92R<L2R<V
2R<_7QXB52`L51XL7R`L51XB52`L51XB514L2P0000062@T:00<94PX00009
2@X00`T92P0400002@T:2@TD00000`T92P032A8:2@T:2@T:00D92@X0114L
2PT92PT92QX92PL92@X01@TB2PT92PTB2PT92PTB2P072@T:00D94PX92@X9
2A@94PX000000`T92P044A`:2@T:2A8:2A8:10T92P052A8:2@T:2@T:2@T:
4A`:00@92@X00a4L2PT92PT92P022@T:00<94PX92@X92@X00PT92P032A8:
2@T:2@T:00892@X010TB2P0001X92X>4SV7<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00<J
4Q@J71hA70X00PT92P086Q8D2A8:2A8:2@T:4A`:2@TD4A`:2A8:1`T92P@9
4PX32@T:00<94PX92@X94PX00PTB2P0500002A8:2@T:2@T:2A8:00800002
2@T:00<94PX000092@X01PT92P894PX00`T92PTB2PTB2P022@T:00@00009
2@X000094PX2000000T92@X94PX92@X92@X94PX000094PX92@X000000PT9
2P0500002@T:2@T:2A8:000000D92@X00`TB2PT92PT92P02000000@94PX9
2A@92@X92@X200000PT92P8000022@T:00P000092@X94PX92@X000094PX0
00094PX52@T:00L000092@X92@X92@XA70X000094PX02PT92P<J2@X010T9
2QX92R<L2Q4L2P8S70X033dB2QXV51XB51XL7R`L50T951XB52`V51X92R`L
52<_7QXB50<92@X00`0000T92PTB2P072@T:00@94PX92@X92@X94PX52@T:
00<000092@X92@X00`T92P0400002@T:2@T:4A`:2@T92P0300002@T:2@T:
00H92@X00`TB2PT92PT92P022@T:00<J4Q@92@X92@X00`T92P032A8:0000
2@T:00892@X00`TB2PT92PT92P022@T:00@92A@94PX94PX94PX22@T:00<A
70X92@X92@X00PT92P032A8:2@T:2A8:00D92@X01PTB2QXB50T950T92P00
08>4SV7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<
c1[<c<`00oooolc<c<c<c01Mc<c<00P92A@971@94PX94PXA70X92@X92A@9
2@X22A8:00<000094PX94PX010T92P032A8:2@T:2@T:008000022@T:00L0
00092@X000092@X000092@X000000PTB2P0300002@TD2A8:00D92@X01P00
00TB2P0000TB2PT92PTB2P892@X22A8:00<92@X94PX92@X00`TB2P032@T:
2A8:2@T:00<92@X010TB2PT92P0000TB2P892@X22A8:00<92@X000092@X0
0PT92P0=00002@T:2@T:2@T:00002A8:2@T:00002@T:00002A8:2@T:2A8:
008000000`T92P00014L2P052@T:00@000092@X92@X92@X2000000@A70X0
00094PX000032@T:00<000094PX92@X00PT92P042A8:00002A`D000010T9
2P054A`:2@T:00002A8:2@T:008A70X22@T:00<J2@XA70X92A@00aX92P0?
4A`:6Q8D;1`D6Q`N8blY;1`D8blc8blN6Q`N=2lY;2HD4BHD2@T:00002A8:
00892@X01AXB50T92PT92PT92PTB2P022@T:00HJ71h000094PX92@X00009
2@X22A8:3`T92P894PX32@T:00D94PX92@X92@X92@X94PX00PT92P072A8:
2@T:2A8:2A8:2@T:2A8:2@T:00894PX0100000TB2PTB2PTB2P@92@X010TB
2PT950T92PT92P894PX00aX92PTB2PT92P022A8:0`T92P<94PX32@T:00@9
2A@92@X94PXJ2@X22@T:00HA70X94PX92@XA70XJ2@ZEQ7]Qc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<
c<`0GLc<c00:2A8:6Q8D2A8:2@T:2A8:2@T:8blY2@T:2A8:2@T:0PTB2P89
2@X01PTB2PT92PT92PTB2Q4V7PT92P<94PX00`T92PTB2PTB2P032@T:00`9
4PX92@X92@X000094PX000094PX000092@X94PX92@X94PX22@T:00D94PX9
2@X92@X000094PX00`T92P034A`:00002A8:00892@X03P0000T92PT92P00
00TB2PT92PTB2P0000T92PTB2P0000TB2PT92PTB2P892@X01@TB2P0000TB
2P00014L2P02000000/94PX92@X000094PX000094PX000094PX92@X00009
4PX00`T92P042A8:00004A`:00000PT92P032A8:2@T:2@T:00892@X010TB
2PT92PT92P0000892@X01@TB2PT92PT92PT92P0000022@T:00D000092@XJ
2@X94PXA70X00`T92P0300002@T:000000<92@X26PT:00XA70X92@XJ4Q@9
71@A70X/71@A9Q@J2@XJ4Q@S;ah38blY00D/>2TS;bTS;bT/>2TS;ah01@T9
2P0300002A`D4A`:00<92@X010T950TB2PT92PTB2P<92@X00`TB2PT92PT9
2P062@T:00D94PX92@X92@X92@X94PX01@T92P032A8:2@T:2A8:00892@X0
2@0000TB2PT92PT92PTB2PT92PTB2PT92PTB2P022@T:00<94PX92@X92@X0
0`T92P042A8:2@T:2@T:2A8:0PT92P032@TD0000;1`D00892@X01@TB2PT9
2X<_0;UW000000062@T:01092A@92@X92@X94PX92@X000092@X000094PX9
2@X94PX92@X94PXJ4Q@92@Z3Q8iQc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0046Q8D4BH:
2A8:2@T:0`TB2P052BHY6Q8D2@T:2@T:2A8:00<92@X01@TB2PT92PTB2PTL
50TV:@02000000@92@XA70X0000000042A8:00D92@X94PX000092@X94PX0
0PT92P074A`:00002A8:00002@T:2A8:000000894PX01PT92PTB2PT92Q4L
2P0000T92P894PX00`T92PTB2PTB2P032A8:00H92@X94PX000092@X94PX0
00032@T:0PTB2P082@T:00002A8:00002A8:00002@T:2@TD1PT92P032A8:
00002@T:00<94PX02P0000TB2P0000T92PTB2PT950T92PTB2P0000T92P89
4PX52@T:00@A70X92@X94PX94PX32@T:00HA70X94PXA70X94PX0000A70X8
2A8:00H92@XA70X92@XA70X92@XA70X26PT:00HJ71hS;bTA9PX94PXJ4Q@S
;c<2;3PY00Hd;bT/>2Td;bTm;cd/>2TJ9Q@32A8:00@92@X94PXA70X00002
2A8:0PT92P03=2lY00004A`:00894PX01Q4L2PT92PT92PTB2PT92PTB2P@9
2@X01@TB2Q4L2PT92PT92PTB2P052@T:00H94PX000094PX94PX92@X94PX3
2@T:1@TB2P032@T:2A8:2@T:00H92@X00a4L2PTB2PT950022A8:00H92A@0
002V@@3omP23;`1G7002Pbl000WTZP3od00m4PX92@X0000A70X92@XA70X9
4PX010T92P038blY2A8:2A8:00894PX01`T92QXB50TB2PT92Q4V51XB58>4
SP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`J
c<c<00?oooo<c<c<c<`0GLc<c0036Q8D2@T:2A8:00@94PX01PT92Q4L2Q4L
2PT92PTB2PT92P894PX03P0000TB2PTB2P0001X92PTB2PT92Q4L2P0000T9
2PTB2PT92PTB2P0000892@X22A8:0PT92P894PX00`0000T92PT92P022@T:
00@94PX92@X92@X92@X22A8:00<92@XA70XA70X00PTB2P892@X00`TB2P00
000000032@T:00DA70X92@X92@X92@X94PX00PT92P032A8:00002A8:00<9
4PX01a4L2P0000T92Q4L2P0000T92PTB2P082@T:00<000092@X92@X00`T9
2P894PX01P0000T92PTB2P0000T9500000@94PX00`0000T92PT92P052A8:
1@T92P044A`:2@T:2@T:4A`:10T92P0?2A8:00004A`:4A`:2@T:6PT:4BHD
6Q8D4A`:8blN8bH:4A`:6Q`N8blN;3PY00Ld;bT01`TB2PT92PT92PTB2PT9
2PTB2P0000022@T:00@94PX92@X92@X94PX22@T:00<94PX92@X92@X00PT9
2P052A8:2@T:2@T:2@T:2A8:00892@X00`TB2PT92PT92P032@T:00P94PX9
2@X92@X94PX92@XA70X92@X94PX52@T:00H94PX92@X92@X94PX92@XA70X2
2@T:00<A70X92@X92@X010T92P894PX01`T92Q4L2P000;1<0?oI0?o@0?oI
0002ooH000Kof@3fa`[f/`169PX92@XA70X42@T:00/A70X94PXA70X92@X9
4PXJ4Q@94PX92@XA70X94PXJ4Q@00PTB2P032@TD0000PhB>067<c<`016IV
IXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<
c<c<c01Mc<c<0PTB2P032@T:2A8:2@T:00@92@X010TB2PT92PTB2Q4L2P@9
2@X04@0000T9500000TB2PT92P0000TB2PT92P0000T92P0000T92P0000TB
2PT92P0000TB2P022@T:00@000094PX94PX000022A8:00P000094PX94PX9
2@X000094PX92@XA70X22@T:00<94PX92@X000000`TB2P0=2@T:2A8:2@T:
00002A8:2@T:00002A8:2@T:00002A8:00002@TD00@000002`TB2PT92P00
00TB2PT92P0000TB2PT92P0000T92PTB2P022@T:00T000092@X92@X92@X9
4PX92@X000092@X000000PTB2P0600002@T:00002@T:2A8:2@T:0P000003
2@T:2A8:000000892@X01P0000TB2P0000TB2PT92PTB2PP92@X02P0000T9
2P0000T92P0001X92Q4L2P0001XB514L2P@J4Q@012`L52`h:B`h:C@_:@8d
;c<3=2lY00PS;ah92@X92@X92@X000094PX000094PX22@T:00<000094PX9
2@X00`T92P0300002A8:2@T:00H92@X01@0000TB2PT92P0000TB2P042@T:
00H000094PX94PX000092@X000022@T:00<A70X92@X92@X00PT92P030000
2@T:2@T:00H92@X01`00014L2PT92P0000TB2PT92P0000032@T:00`94PXm
4P[1Q02VLP23@@1b>00m4PX/4P3CQ03od00m4PX94PX32@T:00<92A@/>2T0
00000`T92P054A`:2@T:2A8:2@T:000000892@X01@TB2PT92PTB2P0009F4
SP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`J
c<c<00?oooo<c<c<c<`0GLc<c0032@TD2A8:6Q8D00@94PX32@T:0PTB2PH9
2@X04@TB2PT92PTB2P0000TB2P0000TB2PT92Q4L2PT92P0000TB2PT92P00
00TB2P0000TB2P032@T:00D000094PX0000000094PX00P0000<94PX32@T:
00<A70X92@X94PX00PT92P8000000`TB2P0000TB2P072@T:00@000094PX9
2@X000022A8:00D92@X000094PX000094PX00`T92P0300002A8:2@T:0080
000010TB2PT92PTB2P0000892@X0100000TB2P0000TB2P892@X01@TB2P00
014L2PT92PTB2P042@T:00<000094PX92@X010T92P0600002A8:00002A8:
2@T:2A8:1`T92P032A8:2@T:4A`:00892@X0214L2PT92QXB51XB51X92Q4V
2R<_7R<_<`<d;bT00c@_<dI<?C@_:@028blc00</71@92@X92@X00PT92P04
2A8:2@T:2@T:00000`T92P0300002A8:2@T:00892@X00`TB2PT92PT92P03
2@T:00<94PX92@X92@X01@T92P034A`:2@T:2@T:00D92@X00a4L2PT92PT9
2P052@T:00@A70X92@X92@X94PX82@T:00XA70X92@X92@XA70X92@X94PXA
70X92@X94PX92A@2000000L92A@92@X92A@92@XJ2@X94PX92@X00`TB2P03
6Q8D2@TD2@T:00<92@X01@TB2PT92PT92PTB2P0000022A8:00D92@XJ4Q@A
70X0002EV:<0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`00`TB2PT92PT950022@TD0PT9
2P082@TD2@T:2@T:2@T:2A8:2@T:2@TD2A8:0`T92P0500002@T:2@T:2A8:
000000H92@X00`0000T92PT92P022@T:00<000092@X92@X010T92P092A8:
00002@T:2A8:00002@T:2A8:2@T:2A8:00892@X00a4L2PT92PT92P022@T:
00<94PX000092@X01PT92P0400002@T:2@T:00000PT92P0300002@T:0000
00D92@X0100000T92PT92P0000894PX22@T:0P0000892@X01`0000T92P00
00T9500000T92P0000022@T:0P0000<92@X00`0000TB2P0000042@T:00<A
70X000092@X010T92P034A`:2@T:000000T92@X00a4L2QX92PT92P024A`:
0QXB500<;2HD8blN=2lY=2lc=2lY=2lc;3PY=2lY;3PY8blY4BHD00001@T9
2P0300002@T:2@T:00h92@X01A4L2PT92P0000T92Q4L2P032@T:00<94PX9
2@X92@X010T92P0300002@T:000000<92@X00`0000T92PT92P022@T:00@A
70X000092@XA70X52@T:00<000092@X92@X01`T92P062A8:2@T:2A8:2@T:
00002A8:0`T92P044A`:2@T:2@T:4A`:1`T92P042A8:2@T:2@T:2@T:0PTB
2P892@X00`0009FHXlc<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0894PX03@T950TB
2PTB2PTB2PT92PTB2PT92PTB2PT92PTB2PT950T92PTB2P022@T:0`TB2P03
00002@T:2@T:00<92@X010T950T92PT92PTB2P<92@X00`TB2PT950T92P02
2@T:0PTB2PX92@X020TB2PT92PT92PTB2PT950T92PTB2P0000<92@X0114L
2P0000T92PTB2P<92@X01@TB2PT92P0000T92PTB2P052@T:00X94PX92@X9
2@X92@XA70X94PX000094PX92@X94PX62@T:00D94PX92@X94PX000094PX0
0PT92P072A8:2@T:2A8:00002A8:00002A8:00H92@X01`0000T92PT92PT9
50T92PTB2Q4L2P062@T:00<94PX92@X92@X00PT92P8J4Q@02Q4L2QX92QX9
2QXB51XL7R`L52`h:DI17Sd_?DI17P8d;c<01cd_?B`h:B<_7PT92PTB2PT9
2PTB2P032@T:00<94PX92@X92@X00PT92P0400002@T:2@T:2A8:2PT92P03
2A8:00002@T:00<92@X00a4L2PTB2PT92P072@T:00<94PX92@XA70X03`T9
2P894PX52@T:00/A70X92A@92@XA70X92A@92@XA70X92A@94PXA70X92@X0
0PTB2P892A@00`TB2PT92PT92P032@T:00<94PXA70X94PX00`T92P054A`:
2@TD2@TD0000UHB>067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<0PTB2P034A`:2@T:2@T:
00<94PX22@T:0PTB2P036Q8D2@T:2A8:00892@X00`0000T92PT92P032@T:
00T000092@X92@X92@X0000A70X92@X000094PX00PT92P0600002A8:2@T:
2@T:00002A8:0`T92P0900002@T:2A8:2@T:2A8:00004A`:2A8:4A`:0089
2@X00`TB2P0000T92P042@T:00d94PXA70X92@X92@XA70X000094PX92@X0
00094PX92@X000094PX01@T92P0300002A8:2@T:008000001A4L2P0000TB
2P0000TB2P022@T:00P000092A@000092@X000092A@92@X000022@T:0P00
00072@T:00002@T:2@T:00002A8:000000@92@X01A4L2PT92P0000T92Q4L
2P042@T:00L94PX92@XA70X92@XJ2@XA70X92@X00Q4L2P892@X02AXB514L
2Q4L2QX92QXB52<_<c@_7S@_<cd_?@03=2lc0R`h:@036Q8D2A8:00000089
2@X02000014L2PT92P0000T92PTB2PT92PT950<92@X00`TB2PT92PT92P04
2@T:00<A70X92@X94PX00PT92P046PT:2@T:2@T:4A`:10T92P044A`:2A8:
2@T:4A`:0`T92P036Q8D=2lY6Q8D00@92@X00`TB2PT92PT92P052@T:00@A
70X92@X92@XJ2@X22@T:00HA70X92@X92@XA70X92A@000042@TD00<94PXm
4PZ3;`000PTB2P042@T:2@TD2@TD4A`:0PT92P042A8:2@TD2A8:2A8:0PT9
2P092A8:2@T:4A`:2@T:6Q8D4A`:4BHN0000UIRS067<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01M
c<c<00<92A@A70X92A@00PTB2P032@T:2A8:2A8:00@92@X00aXL7Q4L2PT9
2P032@T:00D94PX92@X92A@92@XA70X00PT92P894PX32@T:00<94PX92@X9
2@X00`T92P894PX52@T:00D94PX92@X92@X94PX92@X00Q4L2P032@T:6PT:
4A`:00T92@X00`TB2Q4L2PT92P0:2@T:00@0000A70XJ4Q@94PX22@T:00<0
00092@X94PX00PT92P052A8:00002@T:2@T:2A8:00<92@X22A8:0`T92P04
2A8:2@TD2@T:2A8:0`T92P034A`:2@T:2@T:00P92@X04Q4L2PT92PT92PT9
2PTB2Q4L2QX92R`B01X92R`B04HV2SdB2QXB51X92PT92QX92Q4L2QXB50<J
2@X01R<_:B`L53@_:Cd_?C@_<dI<?@8d;c<2;3PY00<92A@94PX94PX010T9
2P032@TD2@T:2A8:00<J4Q@010TB2PT92PT92PT92P8A70X=2@T:00<92A@A
70X92@X020T92P048blc2@T:2@T:4A`:1`T92P032A8:2@T:2A8:00H92@X0
4a4L2PT951XB514L2PT92PT958<_0?nc078h500003@_7R`B0=>40?oI03dB
2PT92Q4L2PT951XB50022@T:00@A70X94PX92@XJ4Q@32@T:00TA70X92@X9
2A@92@XJ2@XA70X92A@0002EQ8h0HLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`00`T950TB
2PTB2P022A8:0`T92P032A8:2@T:2A8:00892@X32A8:00/92@X94PX00009
4PX000094PX000094PX000094PX000000PTB2P0B00002A8:00002A`D0000
2@T:2A8:00002@T:2A8:00002A8:00002A8:00002@T:2A8:00000PTB2P<9
2@X01A4L2PTB2PT92P0000T92P022A8:00H0000A70X92@XA70X92@XA70X3
2@T:00@94PX000094PX94PX22@T:00D94PX000094PX971h000000PTB2P<9
2@X02P0000TB2P0000T9500000TB2P0000TB2P0000TB2P8000001PT92PTB
2P00000000T92P0000892@X22A8:00<000092@X92@X010T92P0@2A8:2@T:
2@T:4A`:6PT:2@T:4A`:2A8:;1806PT:ARHDARH:;1`D?A8:H2l:Ea`00R`B
00034A`:6PT:4A`:008J2@X01a4L2R`L51XL7R`V53@_<cAE:Cd_?@02=2lc
00P/>2TS;bTJ9Q@A70X94PX000092@X94PX22@T:00T92A@94PX971@92A@9
2@XJ4Q@000094PX92@X00PTB2PP92@X00`TB2PT92PT92P022A8:0PT92P0<
2A8:4A`:2A8:2A8:4A`:2@T:4A`:2A8:2@T:0000?Blm2A8:0`T92P044A`:
2A8:2@T:2A8:10T92P032A8:2@T:2@T:00<92@X22A8:00hJ4Q@92@X94PX9
2AAb9P3TZP3od03TZP3f/`3od03of@3f/`3fa`Xm4PX32A8:00@92@XA70X9
2@X92@X22A8:00<92@XA70X92@X01@T92P054A`:2@T:4A`:2@T:PhB>067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`0
0oooolc<c<c<c01Mc<c<00D971@J4Q@94PX94PX92@X00PTB2P032@T:2A8:
2A8:00892@X02@TB2PT92PTB2P0000T92PTB2PT92PTB2P0000052@T:00d9
2A@000094PX94PX000094PX92@X000094PX92@X000092@X000000PT92P0=
2@TD00002A8:2@T:2A8:00002@T:4A`:2@T:4A`:6PT:2@T:2A8:00<92@X0
2@00014L2PT92PT92Q4L2PT92Q4L2PT92PTB2P042@T:00<94PX92@X94PX0
0PT92P034A`:00002@T:008000042@T:00<94PX000092@X00PTB2P050000
2@T:2@T:2@T:000000D92@X01@0000TB2P0000TB2P0000022@T:00<94PX9
2@X94PX00`T92P0@2A8:00002A8:4A`:6PT:?A8:;1808a`:?A8:;1`DH2lD
Pbl0Ea`0?A`:Ea`0H2l:0THV500D6PT:4A`:6PT:6PT:2A8:8a`:6PT:8a`:
8blY;1`D;3PY?BlmAT`m?Blm=2lc=2lY8blN6Q8D2@T:00000PT92P040000
2A8:4A`:2A8:0P0000052A8:0000;1`D2@T:000000892@X01@TB2Q4L2Q4L
2PT92PTB2P052@T:00@0000A70X92@X000092@T:00H94PX92@XA70XA70X9
2@XA70X62@T:00<A70X0000A70X010T92P0;2A8:2@T:4A`:2@T:4BHD2@TD
4A`:2A8:2@TDPcP0om0000;TZP001l640:Ib09EE0>BZ0?o@05LL00T92P02
2A8:00<A70X92@X94PX00PT92P032A8:2@T:2@T:00@92@X01`TB2PT92Q4L
2PT92PTB2P0009FHX`1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0056Q8D2A8:2@TD2A8:
2@T:00894PX00`0000TB2PTB2P072A8:010000092A@000094PX92@X00009
2@X0000A70X92@X94PX92@X000094PX000094PX22@T:00<000094PX94PX0
0`T92P0400002@T:0000000010T92P044A`:2@T:2@T:2A8:0`T92P044A`:
00002@T:2@T:0Q4L2P072@T:4A`:2@T:00002A8:00002@T:00<94PX01000
00T92PT92P0000892@X0114L2PT9500000TB2P<92@X01@0000TB2P000000
00TB2P042@T:00h94PX92@X000092@X0000A70X000092@X0000A70X92@X0
00092@X000032A8:0`T92P0300006PT:?A8:00A69PX07ULL078h060_2V0_
2SdL2VY12V0_2ULL04HV52`L53dB2QX92QXB52`B02<L2Q4L2QXB51XL7R`h
:Cd_?CAE:B=1DSAE:C@_:B<_:AXV514V500000TB2P0000894PX2000000<9
2A@92@X92@X00PT92P032A`D00002@T:00P92@X00`TB2PT92PT92P022@T:
00L000094PX92@X92@X94PXA70X000000PTB2P@92@X01@TB2PT92PT92Q4L
2PTB2P0;2@T:00@000092@XA70X94PX22@T:00<92A@94PX92@X00PT92P03
2BHY00002@TD008000001@T9500003dB2W8h00T950042@T:0PTB2P042@TD
2@T:2A8:2A8:1`T92P<94PX00`000:JQV<c<c01Pc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<
c00F8blN2A8:2A8:2@T:2A8:2@T:2A8:2@T:4A`:2@T:00002A8:2@T:2A8:
2@T:00002A8:2@T:00002A8:00002@T:0`TB2P032@T:00002A8:00<92@X0
1@0000TB2P0000TB2PT92P02000000H94PX92@X92@X92@X94PX92@X22A8:
00P92@X94PXA70X0000A70X92@XJ2@XA70X32@T:0PTB2P892@X24A`:0PT9
2P044A`:00004A`:2A8:0P00000=2A8:2@T:00002A8:2@T:2A8:00002@T:
00002@T:00004A`:000000892@X0100000TB2PT92P0000L92@X01P0000TB
2P0000TB2P0000T92P8000000a4L2PT92PT92P052@T:0PTB2P04Ea`0H2lD
Ea`0ARH:0eLL000:H2l:Nd40ARH:Ea`0ARH:Nd40H2l:Ea`0H2l:LRH00ULL
0003;1`D6PT:4A`:008S;ah04B`h:C@_:Cd_?Cd_?C@_<b<_:B`L514L2QX9
2PT92PTB2P0000TB2P0000TB2Q4L2P0000032@T:00@94PXS;ah92@X94PX2
2@T:00@A70X92@X92@X92@X22A8:0P0000034A`:2@T:2A8:00892@X00`TB
2PT92PTB2P022@T:00<A70X94PX92@X010T92P032A8:4A`:2@T:00P92@X0
10TB2PT92PTB2Q4L2PH92@X00a4L2QXB514L2P042@T:00@A70X92@X92@X9
4PX22@T:00<92A@000094PX010T92P042A8:2@T:2@T:2A8:0PT92P8A70X3
2@T:00<A70X92@XJ4Q@00PT92P03UIRSc<c<c<c<05o<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01M
c<c<00TJ4Q@94PX92@X92@X94PX000094PX0000J71h010T92P052A8:2@T:
2@T:2@T:2A8:00892@X22A8:00d92@X94PX000094PX000094PX92@XA70X0
00092@X94PX000092A@00`T92P062A8:00002A8:00002@TD2A8:0`000006
2@T:2A8:2A8:2A8:4A`:000010T92P062A8:00002@T:2A8:2@T:4A`:0PT9
2P032A8:00002@T:00894PX01@0000T92PT92P0000TB2P0200001@T92P07
00002@T:2A8:2@TD2A8:2@T:000000<92@X01P0000T92PT92PTB2P0000TB
2P8000000`T92PTB2P0000032@T:00<000092@X92@X010T92P032@TD;180
H2lD00=G70002f0_2SdL2ULL060_2W8V02<L2THV2V0_2THV2THV55LL0003
LRH000=P;`Y69PX/71@00R`L500E8blY;1`D=2lc=5Dm=2lc;3PY=2lY8blN
6PT:4A`:2@T:2A8:00002A8:00002@T:00002@T:2A8:00002A8:00800000
0aX92Q4L2PT92P042@T:0PTB2P0600002@T:2@T:00002@T:00000PT92P03
2A8:2@T:2@T:00892@X00`TB2P0000T92P032@T:00<A70X92@X92@X00`T9
2P894PX22@T:00<000092@XA70X00`T92P064A`:2@T:2A8:00002@T:4BHN
0PT92P032A8:00002@T:00892@X22A8:00<92@X94PX92@X030T92P054A`:
2@T:2@T:2@T:6Q8D00@92@X010TB2Q4L2QXB59F4SV7<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01M
c<c<0PTB2P032@T:2@TD2@T:00892@X01PTB2PT92PTB2PT92PTB2PT95089
2@X010TB2P0000T92PT92P8000022@T:0P0000892@X00`0000T92P000004
2@T:00T94PX000092@X92@X000092@X000094PX000000PT92P052A8:0000
2@T:2@T:2A8:00892@X24A`:0`T92P<94PX22@T:0`TB2P086PT:2@T:2@T:
2@T:2A8:00002A8:00000PT92P0900002@T:2@T:00002A8:00002A8:0000
4A`:008000022@T:0PTB2P0700002@T:2@T:2@T:00002@T:2A8:00800008
2@T:00@000092@X92@XA70X22@T:00PA70Xm4PXm70Y69PXm70YP;`YG700m
70X2ARH:00Lm70X/4P0m70Xm70Y69PX/71AP;`X00W8V000?H2l:LRH0H2lD
ARHD;1`D8a`:6Q`N8blYAT4N?Blm=2lc;2HD6Q`N6Q8D8a`:00892@X01@00
00T92P0000T92PTB2P022@T:00<000092@X92@X00`T92P0300002@T:2@T:
00@92@X00`0000T92P0000022@T:00D94PX92@X92@X94PX000000`T92P03
2A8:2@T:4A`:00H92@X00`0000T92PT92P0B2@T:00<94PX92@X92@X06PT9
2P074A`:2@T:2A8:2A8:2@T:0000UHB>067<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00<9
2@X94PX92A@00PTB2P<92@X01`TB2P0000TB2PT92P0000T92PTB2P022@T:
00<94PX92@X94PX02@T92P0300002@T:000000892@X02@0000TB2PT92P00
00T92P0000T92P0000TB2P0300000PT92P032A8:2@T:4A`:00@92@X00a4L
2PT92PT92P0200000PT92P0400004A`:2@T:00000`T92P0300002A8:0000
00892@X03P0000T92PTB2P0000T92P0000T92P0000T92P0000T92PTB2PT9
2PT95080000020T92PTB2P0000T92P0000T92P0000TB2P892@X0100000T9
2PT92P0000<92@X00`TB2P0000TB2P022@T:01<A70X/4P0S70XS70Xm4PXm
70YG70169PXS70Xm4PY69QA6;`XJ2@XS70X/71A69Q@S;ah/4P0m4PX00THV
2P0=AT`mAT4N?Blm=2lc8a`:;3PY;1`D=2lc8blc=2lY;2HD8blN;1`D0089
2@X00`0000TB2P0000022@T:0P0000052@T:2A8:000000002A8:00P92@X0
2Q4L2P00014L2P00014L2PT92P0000TB2PT92P0000892@X00a4L2PT92PT9
2P082@T:00<A70X92@X92@X00PTB2Pl92@X01@TB2PT92PTB2P0000TB2P06
2@T:00<000092@X92@X03PT92P092A8:2@T:2@T:2@T:4A`:2@T:4A`:0000
PhB>067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<
c1[<c<`00oooolc<c<c<c01Mc<c<0PTB2P036Q8D2A8:2A8:00P92@X01PTB
2PT92PT92PTB2PT92P0000D92@X01@TB2P0000T92P0000TB2P022@T:00<9
4PX000092@X01PT92P074A`:2@T:00004A`:2@T:2A8:000000892@X01Q4L
2PT92Q4L2P0000T92PTB2P@92@X22A8:1@T92P038a`:2@T:2@T:00892@X0
100000TB2PT92PTB2P8000032@T:00H0000A70X0000A70X000092@X30000
0`T92P0300002A8:2@T:00@92@X22A8:0PT92P0500002@T:00002A8:0000
00892@X01@TB2PT92SdB2QX92R`B00028a`:01Xm70Y69PY69PXS70XS9PXm
70XS9PX/4P0m70X/71@d;ahd;c<92@XS70X/71@/>2TS;ahd;bTm;cdd;bTS
;ahd;ahS;bT/>2U69Q@/>2T2;1`D0Q4L2P892@X0100000T92P0000TB2P89
2@X01PTB2P0000T950T92PTB2P0000D92@X00`TB2Q4L2PTB2P072@T:00<9
4PX92@XA70X00PT92P044A`:2@T:4A`:4A`:20T92P044A`:2@T:00002A8:
10T92P032A8:2@T:2@T:00P92@X22A8:1PT92P032A8:2@T:2@T:00@92@X0
0`TB2QXB50TB2P032@T:00<A70X92A@92@X00`T92P094A`:2@T:2A8:4A`:
2@T:6Q8D4A`:0000UHAk067<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00<94PXJ9Q@J4Q@0
0PT92P032A8:2@T:2A8:00892@X00`TB2PT92PT92P022@T:00@94PX92@X9
2@X92@X22A8:00@92@X000094PX000022@T:00PA70X000094PX92@X00009
2@X94PX000022@T:00<000094PX000000PT92P072A8:00002A8:00002A8:
2@T:2A8:00892@X03a4L2PTB2Q4L2PT92Q4L2PT92PTB2PT92P0000T92Q4L
2P00014L2PT92PTB2P052@T:00@94PX000092@X000022A8:00@92@X00000
00092A@22A8:00T000092@X000094PX92@X000094PX000094PX00PT92P06
00004A`:000000002A8:00000`T92P0400004A`:2@T:00000PT92P082A8:
00002@T:;1808a`:4A`:8a`:4A`:0THV2P0:8a`:;180?A`:ARHD;2HD4A`:
;1`D8blN=2lY=2lc0PT92P086PT:4BHD6Q8D8blYAT4N8blN?Blm;2HD0R<_
<`0>;3PY;2HD8a`:6Q8D00002@T:00002@T:00002A8:00002@T:00002A8:
0P0000032@T:2A8:000000H92@X010TB2P0000TB2PTB2P/92@X01A4L2PT9
2PT92PT92P0000052@T:00H94PX92@X94PX92@X94PX000032@T:00<94PX0
00092@X00PT92P0@2A8:2@T:2A8:2@T:2A8:2@T:2A8:2@TD2A8:2@T:2A8:
2@T:2A8:2@T:4A`:00000PT92P072A8:2@T:2@T:2A8:2@T:2A8:2@TD00H9
2@X00a4L2PT92PT92P022@T:00<A70X92@X92@X00PT92P030000YZ6Hc<c<
063<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<
c<`00oooolc<c<c<c01Mc<c<00LJ4Q@92@X94PX92@X94PX92@X94PX010T9
2P062A8:2@T:2@T:2@T:6PT:2@T:0PTB2P0800002A8:2@T:2A8:00002@T:
2A8:00000`T92P894PX2000010T92P0400002@T:2@T:2A8:0PT92P042A8:
00002@T:2A8:0PT92P044A`:2A8:2@T:2A8:0PT92P0900002@T:2@T:0000
2@T:00002@T:6PT:2@T:008A70X020T92PTB2PTB2PT92P0000T92P0000TB
2P8000000`TB2PT92PTB2P02000000<94PX0000A70X00`0000042@T:0000
2@T:00000`T92P0300002@T:000000<92@X0100000TB2PT92P0000892@X3
000000@92@X94PX/4P0S70X2;18000<m70XS9PXm70X00SdL2P094BH:ARHD
?A`:?A`:6Q8D?A`:AT`m4BHD2@T:008A70X012`L51XL7S@_:C@_<`8/9Q@0
12`L52`V52`V52<_7P8J9Q@02A4L2PT92PTB2PT92P00014L2P0000TB2PT9
2P02000000H94PX0000A70X000094PX000042@T:00D94PX92@X/4P092@X9
4PX010T92P0300002@T:2@T:00H92@X00a4L2PT92PT92P0>2@T:00<94PX9
2@X92@X00PT92P894PX0100000T92Q4L2P0000l92@X01`TB2P0000T92QXB
50TB2PT92P0000072@T:00P94PX92@XA70X92@XA70X92@X0002=V8iQc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?o
ooo<c<c<c<`0GLc<c0034BHD4A`:6Q8D00894PX01Q4L2PT92PTB2PTB2PT9
2PTB2P892@X020TB2PT92PTB2PTB2P0000T951X92P0000894PX010T92PTB
2PT92PT92P894PX01@T92P0000T950TB2P0000022@T:01094PX92@X94PX0
00092@X000094PX000092@X94PXA70X0000J2@X94PX0000J2@X22@T:00H9
4PX92@XA70XA70X000094PX22@T:00XA70X92@XA70X0000J2@XA70X94PX9
2@X000094PX22@T:00P000094PX92@X000094PX000092A@94PX2000000H9
4PX000092@X92@X0000A70X22@T:00@000094PX0000A70X32@T:00P00009
4PX94PX92@X000094PX92@X000022A8:0`T92P068a`:4A`:6PT:8bH:?A`:
8a`:0THV2P09?A`:8a`:ARHD;2HDARHD;2HD=2lcEeEB2@T:008A70X01aX9
2QXV52`h:DI<?C@_<aXB52<V2P02=2lY00DJ71h/9Q@/71@A70X94PX00PT9
2P0500002@T:2@T:2@T:000000<94PX22@T:00P000094PX92@X0000A70X9
2@XA70X92@X22A8:00<92@XA70X92@X00PT92P032A8:2@T:2@T:00D92@X0
0a4L2PT92Q4L2P022@T:00@A70X92@X92@XA70X22@T:00@A70X92@X94PX9
4PX52@T:00D94PX92@X92@XA70X94PX00PT92P032A8:2@T:2@T:00/92@X0
1Q4L2PT92PT92PT92PTB2PT92P894PX00`T92QXB50TB2P032@T:00<A70X9
2@XA70X00`TB2P892@X01A4L2PT92Q4L2P0009FHX`1Qc<c<00AVIVJ8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0
GLc<c0032A8:2@TD6Q8D00D94PX00`T92PTB2PT92P032@T:00H94PX92@X9
4PXA70X000094PX52@T:00T000094PX92@X000094PX92@X94PX92@X00000
0`T92P072A8:2@T:2@T:2A8:2@T:00002@T:00894PX01@0000TB2PT92PT9
2Q4L2P022@T:00@A70X92@X94PXA70X42@T:00@94PX92@XA70XA70X22@T:
00<94PX92@X92@X00`T92P0400002@T:2@T:00000`T92P0400002A8:2A8:
2@T:0PTB2P032@T:00002A8:00894PX42@T:00@000094PX92@X94PX22@T:
00<000094PX92@X00PT92P0300002@T:000000892@X0114L2R<L2R`B02`B
00<S70X012<V2R<L2R<V2R<V2P8/9Q@05b<L2R<_7R`h:B=1DR<L2QXB51X9
2QXB52`h:C@_:EMEDS@_7R<V2R`L54I17R`V51XL7R<L2QX92Q4L2PTB2PT9
2PTB2P032@T:00@A70X0000A70X000052@T:00@J2@X92@X92@X94PX22@T:
00HA70X92@X94PXJ2@XA70X94PX32@T:00L94PX92@X92@X94PXA70X0000A
70X00PT92P034A`:2@T:2@T:00H92@X01@TB2PT92PT92PT92Q4L2P032@T:
00<94PX92@X92@X00PT92P032A8:2@T:2@T:00@92@X00`TB2PT92PT92P03
2@T:00<94PX92@X92@X010T92P032A8:2@T:2@T:00892@X01`TB2PT92PT9
2PTB2PT92PTB2Q4L2P022@T:00<94PX92@X94PX00PT92P044A`:2@T:0000
SIR>HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<
6/c<c003ooooc<c<c<c<05g<c<`32@TD00l94PXJ4Q@94PX92A@92@X971h9
4PX92@X94PX92@X94PX0000971h94PX000000PT92P894PX01@T92PTB2PT9
50TB2P0000022@T:00<J4Q@000092@X00PT92P052A8:2@T:2A8:2A8:2@T:
00<94PX01@T92PTB2P00000000T92P052A8:00PA70X92@X92@X94PX92@X9
4PX92@XA70X22@T:00HA70X92@X92@XA70X92@XA70X32@T:00<A70X92@X9
2@X00`T92P0@2A8:2@T:2A8:2@T:00002@T:00002A8:00002A8:00002A8:
00002@T:00002A8:0PT92P072A8:2@T:2A8:2@TD2@T:2A8:000000D92@X0
2`TB2PT92PT92PT92R`B01X92R<L2QX92QXB52`B02`L50058a`:018J9Q@/
71@d;bTd;bTdEBTA70X92@X971@/71@d;bTd;c=?Ie`J71hJ4Q@/71@/9Q@/
>2TS70X24A`:0PT92P0700002@T:2A8:00002A8:00002A8:00<92@X22A8:
00<92@X94PX92@X00PT92P084A`:2@T:4A`:2A8:4A`:2@T:4A`:2@T:0`TB
2P892@X02@0000TB2Q4L2PT92PTB2PT92Q4L2PT92Q4L2P082@T:00LA70X9
2@XA70X92@X94PX92@X94PX010T92P042A8:2@T:2@T:2A8:0PT92P894PX0
0`T92PTB2PTB2P022A8:00D92@X94PX92@X92@X94PX00PT92P032A8:2@T:
2@T:00892@X00`TB2PT92PTB2P022@T:00<A70X94PX94PX01@T92P072A8:
2@T:4A`:2@T:2A8:0000UHB>067<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00XJ4Q@94PX9
2A@92@X94PX92@X94PX971@/9Q@92A@32@T:00<94PX92@X92@X010T92P0:
2A8:2@T:2@T:2@T:00002@T:2A8:00002@T:00000`T92P032A8:00002A8:
008000001PT92P0000T92P0000TB2P0000892@X00`0000T92P0000022@T:
00TJ2@X000092@XA70X94PX92@X94PX92@X000000PT92P084A`:2A8:4A`:
2@T:4A`:00004A`:2A8:0P0000082@T:00002A8:00002@T:00002A8:0000
0PT92P032A8:2@T:2@T:00T92@X00`0000T92PT92P03000000D94PX92@X0
00092@X000000PT92P0C00004A`:2@T:2@T:8a`:2@T:8a`:4A`:;1808a`:
;1808a`:8bH:6PT:;1`D;2HD;1`D;2HD=2lN0096@Ah04c@_:B<_7R<_:B<_
7Sd_?DmNITI<?B`B02`L51X92R`L52<L2QXB50TB2PT92P0000T92Q4L2P00
00052@T:00<94PX92@X94PX00P0000062A8:6Q8D2A8:2A8:2@T:2A8:0PT9
2P0700002@T:4A`:2@T:4A`:2@T:000000D92@X32A8:00<A70X92@XA70X0
0PT92P034A`:2@T:4A`:00892@X00a4L2PT92PT92P032@T:00<94PX00009
2@X010T92P0600002@T:2@T:2@T:4A`:00000PTB2P0500002A8:2@T:0000
2A8:00<92@X010TB2PT92Q4L2PTB2P@92@X01@TB2P0000T92PTB2P000007
2@T:00T94PX92@X92@X94PX92@XA70X94PX00023Q7/0HLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<
05g<c<`22A8:00L92@XA70X92@XA70X92@X94PX92@X00Q4L2P892@X00`TB
2PT92PT92P052A8:00X92@XA70X92@X92@XA70X92@X000094PX92@XA70X7
2@T:00<A70X0000A70X00PT92P062A8:2@T:00004A`:2@T:4A`:0`T92P09
4A`:2A8:00002A8:2@T:4A`:00002@T:2A8:00892@X01A4L2QX92Q4L2PT9
2Q4L2P042@T:00<0000A70X92@X01`T92P8000022@T:00<000092@X94PX0
0`T92P0300002A8:2@T:00D92@X00`0000TB2P0000032A8:00hA70XJ4Q@0
00094PXA70XA9PX/4P0J2@X/4P0J4Q@J2@XA70XS70XJ2@X38a`:0b`V5009
=2lN=2lc=2lY;3PY8blc=2lcAUEBEei_;3PY008A70X00b`L514L2PT92P02
2@T:00<A70X92@X92@X00PT92P032A8:2@T:2A8:00894PX01PT92P0000T9
2PT92P0000TB2P@92@X0200000TB2PT92Q4L2PT92PTB2Q4L2PT92P894PX0
1a4L2P00014L2P00014L2PT92PTB2P022@T:00</71@J4Q@A70X05`T92P03
2A8:2@T:6PT:00892@X22A8:00<92@XJ2@X94PX010T92P032A8:2@T:2@T:
00892@X020TB2PT92PT92PT92PTB2PT92Q4L2PT92P8A70X32@T:00TA70X9
2@X92@X92@XA70X92@XA70X0002EQ7/0HLc<c004IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`01Q4L
2PT92Q4L2PT92PT950TB2P892@X01PTB2Q4L2PT92PT92PTB2PT950894PX0
0`T92P0000T92P022@T:00<A70X000092@X00PT92P064A`:6Q`N00002A8:
2@T:2A8:1@T92P0;2A8:00002@T:00002A8:2@T:00002@T:4A`:00002A8:
00892@X01Q4L2PT92Q4L2QX92PTB2Q4L2P892@X00a4L2P0000T92P024A`:
00<92@XA70XA70X010T92P0900002@T:2@T:2@T:00002A8:00004A`:0000
00<92@X01@00014L2PT92PT92P0000022A8:00<92@X000092@X01PT92P03
00002@T:2@T:00<92@X2000000<92@X000092A@00PT92P056PT:8a`:8a`:
4A`:;18000@S70X00b`B014L2R`L5002;1`D00@d;ahd;c=6@Ai6C3d2?Blm
00Q6C3d/EEa?Ie`J2@XA70XJ2@X/4P0A70X92@T:00@94PX92@X000092A@2
2@T:00<94PX92@X92@X01@T92P032A8:2@T:2@T:00892@X00a4L2QX92Q4L
2P022@T:00T94PX92@X92@X92@X94PX92@XJ2@XA70X92@X00QXB50032@T:
4A`:4A`:01@92@X00`TB2PT92PTB2P022@T:00<A70X92@X92@X01PT92P03
2A8:2@T:2@T:00@92@X01@TB2PT92PT92PT92PTB2P022@T:00<94PX92@X9
2@X01@T92P064A`:00006Q8D2A8:0000Phf4HLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`0
1Q4V50T950TB2PTB2QXV51XB50<94PX01PT950T92Q4V50T92PT950TB2P89
2@X32A8:0PT92P034BHN2A8:2A8:00892@X020TB2PT92PT92PTB2PT92PTB
2PT92PTB2P<92@X010TB2PT92PT92PT92P894PX00a4L2P0000T92P022@T:
00PA70X92@XA70XJ2@XA9Q@J2@X92@XA70X22A8:00H92@XA70X92@X92@XA
70XJ2@X24A`:00<94PXA70X92@X00`T92P072A8:2@T:2@T:2@T:00002A8:
000000D92@X22A8:00D000092@X92@X92@XA70X01`T92P062A8:00002A8:
2A8:00002@T:0PTB2P0300002A8:2@T:00<A70X00a4V2QX92Q4L2P026PT:
0b<L2P8/71@01B`V53dL2S@_:DI17S@_<`02AUEB00Lm;ce6GTMGGVm6C3d0
000/4P0J2@X02PT92P0<2A8:00002@T:2@T:4A`:00002A8:00002@T:2@TD
2@T:2A8:0PT92P032A8:00002@T:00892@X01a4L2PT92PT92Q4L2PT92PTB
2P0000022A8:00H92@XA70X92@X92@X94PXJ4Q@22@T:0Q4L2P<92@X010TB
2PT92Q4L2PT92P894PX52@T:00<94PX92@X94PX00`T92P044A`:2@T:2@T:
2@T:0`TB2P032@T:2A8:2@T:00892@X01PTB2PT92Q4L2PTB2PT950TB2PL9
2@X01@T9500000TB2PTB2Q4L2P042@T:0PTB2P892@X01@TB2PT950TB2PT9
58=kG01Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<
c<`Jc<c<00?oooo<c<c<c<`0GLc<c0042@T:6Q8D2@TD2A8:0`T92P894PX0
10T950T92PTB2P0000L94PX01@T92PTB2PT92PT92P0000042@T:00@00009
2@X92@X92@X22A8:00@92@X000094PX000022@T:00<94PX000092@X00PT9
2P0400002A8:2@T:2@T:0a4L2P<92@X00`TB2PT92PTB2P0200000Q4L2P0:
6PT:4A`:8a`:6PT:2@T:4A`:2A8:2@T:2A8:00000`T92P894PX22@T:00/0
00094PX92@X92@X94PX000092@X000092@X94PX000000PT92P894PX01PT9
2P0000T92PTB2P0000T92P8000000`TB2P00000000052@T:00D/4P0J2@X/
4P094PXJ4Q@00R`B00<S70X032`L52<L2R`L53@_7S@_:C@_<dI<?EMEDTI<
?DIEDUMNKdmWA`8A70X011X92Q4L2Q4L2PTB2P@92@X00`TB2P0000TB2P02
2A8:1PT92P042@TD00004A`:00001PT92P034A`:2@T:2@T:00@A70X01@T9
2Q4L2PT92PTB2P0000032@T:00@94PX92@X92@XA70X22@T:00<A70X92@X9
2@X00`T92P032A8:00002@T:00D92@X00a4L2P0000T92P052@T:00<94PX0
00092@X00PT92P0>2A8:00002@T:2@T:4A`:2@T:2A8:2@TD6PT:00002@TD
00002@T:4A`:20T92P034A`:2@T:2@T:00L92@X011XB50TB2QX92W9EDV7<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`0
0oooolc<c<c<c01Mc<c<00HA70X92@XA9Q@92A@A70X94PX42@T:00HA70X9
2A@92@X94PX92@X94PX22@T:00L000094PX92@X92@X000092@X94PX00`T9
2P0300002@TD2@T:00<92@X01@0000TB2PT92PT92P0000022@T:00/00009
4PX0000000094PX000092@X000094PX92@XA70X00PTB2P8A70X01@TB2PT9
2PT92P00014L2P042@T:00H0000A70XJ2@X94PX92@X000042@T:0`000004
2A8:2@T:2@T:2@T:0P0000042@T:00002A8:2@T:0P0000052@T:2A8:6Q8D
6Q8D000000<92@X00`0000T92P0000062@T:014000092@X92@X94PXJ2@X/
4P0J2@XA70X/4P0J4Q@J2@XS70X/4P0S70XS9PX/4P0J4Q@00S@_:@07=2lc
EeEBCfMLCeiVEeEBEfMB4BHN00D92@X01`0000TB2P0000T92PTB2P0000TB
2P02000000X94PX000092@X92@X000092@X94PX0000A70X000022@T:00<0
000A70X92@X00PTB2P892@X01AX92PTB2Q4L2QX92PT950082@T:00D00009
2@X94PX92@XA70X00PT92P044A`:2@T:2@T:2A8:0PT92P032A8:2@T:2@T:
00<92@X00`0000T92PT92P062@T:00<94PX92@X92@X010T92P0<2A8:2@T:
2@T:2@T:2@TD00002@TD?A8:Ea`0ARHD2@T:2A8:0`T92P044A`:2@T:0000
2@TD0`T92P052A8:2@T:2@T:4A`:0000008A70X01@T92PTB2P0001XB55MW
DP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`J
c<c<00?oooo<c<c<c<`0GLc<c0062@TD4A`:2@TD4A`:2@TD2@T:0Q4L2P08
2A8:2@T:2A8:4A`:2@T:2A8:2@T:2A8:1@T92P042A8:2@TD2@T:2A8:1PT9
2P032A8:2@T:2@T:00H92@X00a4L2PT92PT92P022A8:00d000094PX00009
4PXA70XJ4Q@92A@J2@XA70X94PX92@XJ2@XA70X010T92P@A70X01B`V50T9
2Q4L2PT92Q4L2P022@T:00<A70X92@X94PX020T92P032A8:2@T:2@T:00<9
2@X01PTB2P0000TB2QXB50T92PTB2P892@X010TB2PT950T92PTB2PP92@X0
1a4L2QX92R<L2Q4L2QX92Q4L2QX92P048a`:00d/71@/9Q@d;ahm70Xd;c=P
@BU?IeaGEE9GGVmZLUa?GVH000094PX02@T92P0600002@T:2@T:2A8:2@T:
2A8:1`T92P0400002A8:2@T:2A8:10T92P054A`:2@T:2@T:2@TD6PT:008A
70X22@T:00@94PX92@X92@X94PX32@T:00@A70X92@XA70X92@X24A`:00<9
2@XA70XA70X010T92P034A`:2@T:2@T:00`92@X010TB2PT92PT92PTB2P89
2@X01PTB2Q4L2PT92PT950000?nc00;of@003?of0?oI00T92PT92PTB2Q4L
2QX92PT92QX92PTB2PT92PTB2P892@X01PTB2PT92PT92PT92Q4L2PTB2P89
2@X010TB2QXB500009F4SV7<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00X92@X92A@A9Q@9
2@XA70X94PX92@X/9Q@92A@A70X22A8:00PJ4Q@94PX94PX92A@92@X94PX9
2@X94PX22@T:00<94PX92@X000000PT92P052A8:2@T:2A8:2A8:00000089
2@X010TB2QXB50T92PTB2P892@X02PTB2PT92P0000TB2P0000TB2P0000T9
2PTB2PT92P8A70X00`T92Q4L2R`B00024A`:00D94PXA70X000094PXA70X0
0aX92P054A`:6PT:8bH:4A`:2@T:00894PX00`0000T92P0000052@T:00<0
00092@X92@X00PT92P032A8:2@T:2@T:00`92@X00`TB2P0000T92P022@T:
00<000094PX000000`T92P036PT:8a`:;180008S70X03A4L2QX92QX92R<L
2R`L52<L2R`L53@_:DHV54I<?DIEDUMEDTmNIP02H79k00<971@92@X94PX0
0PT92P894PX62@T:00<94PX92@X000000PT92P032A8:2@T:2@T:00892@X0
0`TB2PT92PT92P022@T:0PTB2P036Q8D2@T:2@T:00892@X34A`:00/J2@X9
2@X94PX000092@X94PX92@X000092@X94PXJ2@X00`T92P034A`:2@T:2@T:
00892@X00`0000TB2QXB500D2@T:00@94PX92@X94PX94PX22@T:00/m4P[C
Q02`LP3f/`2EE@1b9P2iI`3of@1G70092@XA70X010T92P042@TD2@T:2A8:
2@T:0PTB2P0:2@T:4A`:2@T:2@T:4A`:2@T:6Q8D2@TD0000`LO<HLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003oooo
c<c<c<c<05g<c<`0114V50TB2PT9514L2P892@X00a4L2PTB2PTB2P022A8:
0PT950032A8:2@T:4A`:00@94PX01PT92PTB2PTB2PTB2PT92QXB50894PX0
0aX92PT950TB2P022A8:00<92@X94PX94PX01PT92P044A`:00002A8:0000
0PT92P894PX24A`:00HS70XJ2@XA70XA70XA9PXJ2@X24A`:00D92@X94PXA
70X92@XJ2@X00Q4L2P032@T:6PT:4A`:00@92@X01PTB2PT92PTB2PT92PT9
50TB2P892@X00`TB2PT92P0000022@T:00<94PX92@X92@X010T92P032A8:
2@T:2@T:00D92@X00`TB2PT92PTB2P022A8:0`T92P062A8:4A`:8a`:8a`:
4BH:6Q8D0R`B00048bH:8a`:8a`:;1`D0R`V5003=2lY=2lcAT`m009?GVH0
2EMNKdINA`0000TB2P0000T950TB2P0000TB2P022@T:00X94PX92@X92@X0
00092@X94PX92@XA70X000094PX22@T:00@94PX92@X92@X94PX22@T:00`A
9PX94PX92@X92@X94PXA70X92@X94PX92@XA70XJ2@XA9Q@22A8:00@92@X9
4PX92@X94PX42@T:00@A70X92@X94PX92@X24A`:00<94PX92@X94PX010T9
2P032A8:2@T:2@T:00894PX01PT92Q4L2PT92PT92PTB2PT92P894PX00`T9
2Q4L2PTB2P032A8:00<92@X94PX92@X00PT92P09Pbl0om00LRH0ok<0Ea`0
2@TD/4`0om00Ea`000892@X0114L2PT92PT92PTB2P892@X03PTB2PT950TB
2PT92PTB2PT92PTB2PT92PTB2PT92PT950T92P000<77c67<c<`016IVIXS0
^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<
c01Mc<c<0PTB2P046Q8D2A8:2A8:4A`:10T92P082A8:6Q8D6Q8D2@TD2A8:
6Q8D2@T:2A8:0PT92P0300002A8:2A8:00892@X01AXB50T92PT92PT92PTB
2P022@T:00D94PX92@X92@X000094PX01@T92P0500002A8:2@T:00002A8:
00<92@X01aX92PTB2PT92Q4L2PT92QX92R`B00032@T:00<000092@X94PX0
0Q4L2P892@X0214L2PT92PT92Q4L2PT92PTB2PT92PTB2P892@X22A8:1@T9
2P032A8:2@T:2@T:00894PX00`T92PTB2PT92P032@T:00@94PX000092@X0
00032@T:00<000092@X92@X00PT92P0500004A`:00004A`:6PT:008S70X0
1B`B02<L2R<L2R<L2QX92P038a`:00</9Q@d;ahd;c<00UMEDP04CeiVLW9k
CfML4BH:0PT92P0400004A`:00002A8:0`T92P0300002A8:2@T:00894PX0
2@0000TB2PT92PT92P0000TB2PT92P0000TB2P032@T:0PTB2P0400002@T:
2@T:2A8:0PT92P0:4A`:2@T:4A`:4A`:6PT:4A`:2@T:2A8:2@T:000010T9
2P062A8:2@T:4A`:2@T:8a`:4A`:0PTB2P892@X01@TB2Q4L2PT92PT92Q4L
2P072@T:00D94PX92@X92@X92@X94PX00PT92P0B2A8:2@T:2@T:2@T:2A8:
2@T:2A8:2@T:Pbl0ooH0LRH02@TDok<0H2l:0000^FL0om00Ea`010T92P03
4A`:2@T:2@T:00<92@X010TB2PT92PT92PTB2P892@X01Q4L2PT92PT92Q4L
2P000:Jc`F7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
olc<c1[<c<`00oooolc<c<c<c01Mc<c<00<92A@A70X92A@01PTB2P072@T:
2A8:2@T:4BHD2@T:2A8:2@T:00D94PX020T92PTB2PT92Q4L2PT92Q4L2PTB
2PT950894PX32@T:00L94PX92@X92@X94PX92@X94PX92@X00PTB2P062@T:
00002A8:00002A8:00000Q4L2P036PT:4A`:;18000<A70X00`T92Q4L2PT9
2P022@T:00@A70XJ2@XJ2@X92@X24A`:00D92@X94PXA70X92@X000000`TB
2P892@X00`0000TB2Q4L2P022@T:00PA70X92@X92@X92@X94PX000094PX9
2@X22A8:0`T92P0300002@TD4A`:00892@X00`TB2PT92PTB2P032@T:00L9
4PX000094PX92@XJ2@XS70X/4P000R<L2P03;1804A`:;180008S70X02B`L
53@_7S@_:DI17UMEDTmNIW9EDX>4SR<_<`022A8:0PT92P052A8:2@T:2@T:
2@T:2A8:00892@X01`0000TB2P0000TB2PT92P0000TB2P032@T:00<00009
4PX92@X010T92P894PX00a4L2PT92PT92P022A8:00<92@XA70X92@X00Q4L
2P894PX00`0000TB2PT92P022A8:00X92@X94PX94PX92@XA70X0000A9Q@9
2@XJ2@X94PX22@T:00DA70X92@X92@X92@X94PX00`T92P032A8:2@T:2@T:
00892@X00a4L2PTB2PTB2P022@T:00<A70X92@X92@X00`T92P0=2A8:2@T:
2@T:LRH0omT0Pbl00000omT0Ea`0?A8:/4`0om00Ea`000892@X01A4L2PTB
2PT92PT950TB2P022@T:00@94PX92@X94PX92@X22A8:0PT92P054A`:6Q8D
4A`:0000/;k1067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2h
R<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<0aXB50044A`:2A`D2A8:2@TD
0PTB2P@92@X22A8:00D92@X94PX000094PX92@X00PTB2P082@T:4A`:2@T:
2A8:6Q`N6Q8D2@TD2@T:0PTB2P0;2@TD2A8:2A8:2@T:2A8:2@T:2A8:2@T:
2A8:00002@T:00894PX01`0000TB2P0000T92PTB2PT92PTB2P024A`:00DA
9Q@94PXJ2@XA70X94PX00PT92P034A`:2@T:2@T:008A70X020T92QX92Q4L
2PT92PTB2P0000T92PTB2P892@X020TB2PT92PTB2PT92PTB2PT92PTB2P00
00H92@X00`TB2P0000TB2P022@T:0PTB2P0;00002@T:2A8:2A8:00002A8:
00002A8:2@T:2A8:000000892@X01`TB2QX92R<L2R<L2SdL2R<L2R`L5004
8a`:00@/71@d;ahd;c=6C3d3CeiV00EZNh@971@A9Q@92@X94PX00`T92P05
2A8:2@T:000000002A8:00`92@X22A8:0`T92P062A8:000000002@TD2@T:
4A`:0PT92P064A`:2@T:4A`:2A8:4A`:2A8:0`T92P0600002A8:6PT:2A8:
2@T:4A`:0PT92P034A`:2@T:2A8:00894PX00`T92PTB2PT92P022@T:00@9
4PXA70X92@XA70X32@T:00<94PX92@X94PX00PT92P044A`:2@T:2@T:4A`:
1`T92P05?A8:i:X08a`:0000H2l:00?of@001@T92PTB2PT92PT92Q4L2P04
2@T:00HA70X94PX92@XA70X92@XA70X32A8:00HA70X92A@92@X92A@0002`
_/5Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`J
c<c<00?oooo<c<c<c<`0GLc<c0064A`:2A8:2A8:2@TD2A8:2@T:0PTB2P03
00002A8:2A8:00<92@X010TB2PT92PT92PT92P894PX01@T92PTB2PTB2PT9
2PTB2P022@TD00L94PX92@X94PX94PX92@X94PX0000020T92P062A8:0000
2@T:2@T:00002@T:0PTB2P084A`:6PT:6PT:4A`:;1804A`:2@T:2A8:0PT9
2P0500002@T:2@T:2@T:6PT:008A70X00`T92Q4L2PT92P032@T:00@00009
2@X94PX000072@T:00<000092@X000001PT92P062A8:000000002A8:0000
2@T:0P0000062A8:2@T:2@T:00002@T:00001@T92P05;1806PT:4A`:;1`D
;18000@S70X022`V53@_:DI17TIEDUMEDTmNIV1bNfYkQ0<000042@T:00P0
00094PX92@X92@X000092@X000094PX22@T:00X94PX92@X92@X94PX92@X0
00094PX000092@X94PX52@T:00<S;bT92@X92@X01@T92P03;1806PT:2A8:
00`92@X00a4L2PT92PTB2P032@T:00<94PX92@X92@X01@T92P032A8:0000
2@T:0080000010T92PTB2PT92P0000X92@X2000000H92A@00031Q02VI`2=
E@X000082@T:00<000092@X92@X020T92P044A`:00000000UJ6gHLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003oooo
c<c<c<c<05g<c<`00a4V50T92PTB2P022@T:00<94PX92@X000001PT92P03
00002A8:2@T:00<92@X0100000T92PT92P0000892@X010TB2PT92PT92PTB
2PH92@X00`0000T92P0000032@T:00<000092@X000000PT92P<000001`TB
2PT92Q4L2Q4L2PT92QX92PT92P02000000P94PX000092@X94PXA70X94PXJ
2@XA70X22@T:00@94PXA70X0000000022@T:00@000092@X92@X94PX22@T:
00@000092@X92@X000042@T:00@000092@X000094PX32@T:00<000092@X0
00000PT92P0600002@T:2@T:2@T:00002@T:0P0000072A8:00004A`:6PT:
8a`:;180?A`:008/4P028a`:00T/71@d;ahd;bTd;ai6C3e?GVIGGVmbLW]6
GTL00P0000062@T:00002@T:2@T:00002@TD0`0000032@T:00002A8:0080
00001PT92P0000TB2P0000T92P0000D92@X00`0000TB2PT92P022@T:00<9
4PXA70X0000010T92P034A`:2@T:4BHN00892@X00`00014L2PT92P072@T:
00@A70X92@XA70X/71@52@T:00<000092@X92@X02PT92P0300002A8:0000
00<92@X00`0000T92PT92P022@T:00<94PX92@X92@X00PT92P0400002@TD
00002@TD50T92P034A`:0000YZZ]067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<0PTB2P07
4A`:2A8:2@T:2@T:4A`:2A8:4A`:00@92@X010TB2QX92PT92PT92P<94PX0
1@T92PTB2PTB2PTB2PT92P062A8:0PT92P062A8:2@T:2@T:2A8:2@T:2A8:
1PT92P084A`:00002@T:2A8:2@T:4A`:;1804A`:0R<L2P046PT:2A8:2@T:
2@T:0PTB2P032@T:4A`:6PT:008J2@X01A4L2QX92PT92PTB2QX92P062@T:
00<94PX000094PX00PT92P032A8:4A`:2@T:00P92@X00`0000TB2PTB2P02
2@T:00D94PX92@X92@X000094PX00PT92P032A8:2@T:2@T:00<92@X26PT:
12<L2P098bH:;1`D?A`:;2HD=2lN=2lYAT`mLUEBEei_009PLW/00b<_<`00
00TB2P052@T:00H94PX92@X92@X92@X000094PX72@T:00<94PX92@X92@X0
10T92P0@2A8:2@T:2@T:00002@TD2@T:00002@TD2@T:4A`:6PT:4A`:2@T:
4A`:6PT:4A`:10T92P0;6PT:2@T:2@T:2@T:2A8:4A`:2@T:6Q8D2@T:4A`:
2A8:00/92@X011XB50TB2R<L2PTB2Q092@X0114L2PT92QX92PTB2P8A70X5
2@T:00HA70X0000A70X92@XA70X92A@22A8:10T92P0700004A`:2@T:6Q8D
2A8:2@T:UJ6g067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2h
R<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00PJ4Q@92A@92A@94PX92A@A
70X92A@92@X42A8:0PT92P062A8:2@T:2A8:6Q8D2@T:4A`:0`T92P032A8:
2@T:2A8:00892@X00`T950TB2PTB2P022A8:10T92P034A`:2A8:2@T:0089
2@X030TB2PT92PTB2P0000T92PTB2P0000TB2QX92Q4V7Q4L2R`B008A70X0
4@TB2PT92QXB500000T92PTB2Q4L2QX92R<L2QX92Q4L2QX92PT92Q4L2QX9
2PT92PTB2P032@T:00LJ4Q@000092@X92@X94PX92@X94PX00PT92P044A`:
2A8:2@T:2A8:1@T92P032A8:2@T:2@T:00H92@X00`TB2P0000T92P052@T:
014A70XJ2@XS70X/71@S70Xm70XS9PX/71@d;ahS;ahd;c=P@BTd;c=?GVIb
EE9bIe9?GVH00PTB2PH92@X01@0000T92PT92PT92PTB2P032@T:00<A70X9
2@X94PX00`T92P062A8:2@T:2@T:2@T:2A8:00000PT92P032A8:2@T:2@T:
00D92@X24A`:00@94PXA70XA70X92A@72@T:00PJ4Q@92@X92A@94PX92@X9
4PXA70X92A@F2@T:00L94PX92@X94PX94PX92@X94PXJ4Q@01@T92P032A8:
2@T:2@T:00892@X00a4L2PT92PT92P042@T:00LA70X92A@J4Q@92@X94PXA
70X94PX00a4L2P052@T:2A8:2@T:0000UJ6g067<c<`016IVIXS0^8S0^4R@
R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<
00P92A@92@X92@XA70X92@XA70X92@XA70X22@T:0PTB2P892@X020TB2PT9
2PT92PT92PTB2Q4L2PTB2Q4L2P892@X01A4L2PT92PT92PTB2PT92P022A8:
00@92@X94PX92@X94PX22@T:00D94PX92@X92@X92@X94PX01PT92P032A8:
00002@T:008A70X00a4V2QX92Q4L2P022A8:00@000092@X92@X92@X24A`:
00@92@XA70XJ2@XA70X22@T:00<J2@XA70X92@X00PT92P034A`:00002@T:
00P92@X01PTB2P0000T92PT92PTB2P0000D92@X020TB2P0000T92PT95000
00TB2PT92PTB2PP92@X01b<L2R`B02`B02<L2R`L52`V53@_:@02ARHD00Hd
;c=6C3eGGVmbLW]GGVm6GTL22@T:00@000092A@92@X94PX22@T:00<94PX9
2@X92@X00P0000892@X00`0000T92P0000032@T:0PTB2P892@X00`TB2PT9
2PT92P082@T:00@J2@X92@X92@X92@X26Q8D0Q4L2P052A8:2@T:2@T:2@T:
4A`:00892@X02@TB2PT92Q4L2PT9514L2QXB50TB2Q4L2PTB2P072@T:00<A
70X94PX92@X02PT92P032A8:00002@T:00<92@X01@TB2QXB50T92PT92Q4L
2P022@T:00<A70X92@X92@X00PT92P032A8:2@T:2@T:00<92@X00`TB2PT9
2Q4L2P082@T:00DA70X92@X92A@0002EZZd0HLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`0
1A4V50TB2Q4L2PT950T92P032A8:0PT92P052A8:2@T:2A8:2@T:2A8:00T9
2@X01`TB2PT92Q4L2PT92PTB2P0000TB2P032@T:00<92A@94PX94PX00PT9
2P0300002@T:2@T:00892@X010TB2PT92PT92PTB2P892@X02QX92Q4L2R`B
014L2QX92R`B00T92QXB500000TB2P<92@X02AX92Q4L2QX92Q4L2QX92Q4L
2P0000TB2Q4L2P032@T:00<000094PX94PX02@T92P062A8:2@T:2@T:0000
2@TD2@T:0`TB2P0500002A8:2A8:2A8:000000<92@X00`0000TB2PT92P03
2@T:00@94PX92@XA70XA70X38a`:00@/71@d;aiP@BU6@Ah3AT`m00]bEE9P
LW]GGVld;c<000092A@A70X000092@X000092A@00PT92P0300002A8:2@T:
00D92@X00`TB2PT92PTB2P022@T:00D000094PX92@X000094PX00PT92P05
2A8:2@T:2@T:00002A8:00H92@X01AX92Q4L2QX92QX92PTB2P072@T:00LA
70X92@X92@XA70X92@XA70XJ2@X00PT92P072A8:2@T:2@T:2@T:4A`:2@T:
000000892@X00`TB2PT92PT92P022A8:2PT92P052@TD2@T:2A8:2@T:4A`:
00892@X00a4L2PT92PT92P042@T:00<J2@X94PX94PX010T92P034A`:2@T:
2@T:00892@X00a4L2PT92PT92P022@T:00@A70X92@X0002EXKMQc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<
c<c<c<`0GLc<c0062@T:2@TD2@TD4A`:2@T:2A8:0PT92P042A8:2@TD4A`:
2A8:1PT92P894PX42@T:00@92A@94PXA70X94PX22@T:0PTB2P062@T:4A`:
2@T:2@T:00002A8:1`T92P0500002A8:00002@T:0000008A70X00b<L2Q4L
2R`B00024A`:00/000092@X94PX000094PXA70X/9Q@92@XA70XJ2@XA70X0
0PTB2P032@T:6PT:4A`:00L92@X00`0000T92PT92P052@T:00<000094PX9
2@X00`T92P0900002@TD00002A8:2@T:00002A8:2@T:2@TD00<92@X010TB
2Q4L2QXB50TB2P<92@X041X92R<L2R<L2R<L2R`L54I17S@_:C@_<dI<?F11
:EMNKg9EDV1bNdmWG14V2PTB2P80000=2@T:00<A70X92@XA70X03`T92P03
2A8:2@T:2@T:00<92@X0314L2PT92PTB2Q4L2PT92PTB2Q4L2PTB2PT92Q4L
2PT92P0000<92@X01PTB2Q4L2Q4L2QXB50T92PTB2P<92@X01@TB2PT92PT9
2PT92PTB2P082@T:00<000092@X94PX010T92P032A8:2@T:4A`:00D92@X0
1A4L2PT92PT92PT92Q4L2P082@T:00<94PX92@X92@X00`T92P092A8:2A`D
4A`:2@T:4A`:2@T:4A`:0000Y[?1067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00<J4Q@A
70X94PX00`TB2P0:4A`:2@T:2@T:2@TD2A8:2@T:2A8:2@T:2A8:2@T:0PTB
2P<92@X22A8:00<92@X94PX92@X00PT92P032A8:2@T:2@T:00L92@X01000
00T92PT92PTB2PH92@X02PTB2PT92Q4L2QX92Q4L2QX92Q4V2QX92PTB2Q4L
2P8000000`TB2PT92PT92P024A`:00<S70XJ2@XA70X00`T92P034A`:6PT:
2@T:00<92@X01PTB2PT92PT92Q4L2PT92PTB2PL92@X01P0000T92PT92PT9
2Q4L2P0000892@X020TB2PT92PT9500002`V51XB50T92PTB2P892@X00`TB
2PT92PT92P032@T:00lS70X/4P0S70X/9Q@d;bTd;c=6@Ai6EE9GEE9bEE9P
LW]GGVm?Ie`000094PX01`T92P032A8:2@T:2@T:00D92@X00b<L2PT92Q4L
2P032@T:00<92A@94PX92@X01`T92P032A8:00002@T:00D92@X00aXB514L
2QX92P024A`:10T92P032A8:00002@T:00892@X00`TB2Q4L2QX92P034A`:
00P94PX92@X92@X92@X94PX0000A70X000022@T:00@92A@000092@XA70X5
2@T:00<000092@XA70X00PT92P044A`:2@T:4A`:2@T:0Q4L2P042A8:2@T:
2@TD4A`:1`T92P034A`:2@T:2@T:00<92@X03AXB50T92PT92PT92PTB2PT9
2Q4L2PT92PT9514L2PT950000:JZ[@1Qc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0054BHD
2@TD2A8:6Q8D2A8:00892@X01@TB2PT950T92PT92QX92P072@T:00D94PX9
2@X92@X94PX000003`T92P032A8:00002@T:00D92@X00`0000T92P000002
4A`:00HJ2@XA70X/4P0A70XJ2@XA70X32@T:00P000092@XA70XJ2@X92@XA
70X/4P0A70X22@T:00L0000J2@X92@XA70X000094PX000000PT92P030000
2@T:2@T:00<92@X01PT9500000TB2P0000T92P0000H92@X01@0000T92PTB
2PT92P0000022@T:00D000094PX000092@X000000PT92P0A00004A`:6PT:
6PT:8a`:8blN=2lYAT4N=2lcH44YEeEBCeiVEei_AUi78blc00002@T:0080
00001A4L2PT92PT92PTB2P0000022@T:00<94PX92@X92@X010T92P094A`:
2@T:2@T:2@T:2A8:00002@T:00002A8:00@92@X01@TB2P0000T92PT92P00
00042@T:00H94PX92@XA70XJ2@XA70XJ2@X22@T:00<000092@X92@X00PT9
2P062A8:2@T:2@T:2@T:2A8:6PT:2PT92P0300002@T:000001<92@X22@TD
00<000092@X92@X020T92P032A8:2@T:2@T:00<92@X00`TB2PT92PT92P05
2@T:00<A70X0002VZZd0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`02`T9514V51XB50T9
2PTB2PT92Q4L2PT9514L2PT92PTB2P022@T:00@94PX92@X92@X94PX52@T:
00<94PX92@X92@X00PTB2P042@T:6Q8D2@T:2A8:1@T92P032A8:2@T:2@T:
00<92@X22A8:0PT92P034A`:2@T:2@T:00<92@X01A4L2QX92Q4L2Q4L2QX9
2P052@T:0Q4L2P076PT:4A`:8bH:;1802A8:4A`:2@T:008A70X00aX92Q4L
2P0000022@T:00<94PX92@X92@X00`T92P894PX01`0000T92PT92P0000TB
2P0000T92P022A8:0PT92P042A8:2@T:2@T:00000`T92P034A`:2@T:6PT:
00894PX42@T:00h94PXJ2@XA70XS70XS;ahd;c<d;bU6@Ah/EEaGEE9GGVmb
EE8S;bT971@22A8:0PT92P0500002A8:2@T:2@T:2A8:00892@X00`0000TB
2PTB2P032@T:00@94PX92@X92@X94PX42@T:00@94PX92A@000094PX22@T:
00D94PX92@X92@X92@X94PX010T92P066PT:2@T:6PT:4A`:;1802A8:1`T9
2P0700002A8:2@T:6PT:6Q8D6PT:4A`:00L92@X00a4L2PT92PT92P032@T:
00<94PX92@X94PX01@T92P032A8:2@T:2@T:00892@X00`TB2Q4L2PT92P02
2@T:00X000092ACo/`23;`092@X94PX92@XA70X92@X94PX32@T:00<94PX9
2@X92@X00PT92P054A`:2@T:2A8:2A8:2@T:00894PX22@T:00<94PXJ2@ZE
XKL0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<
6/c<c003ooooc<c<c<c<05g<c<`020TB2QXB50T9514L2PT92Q4L2PT92Q4L
2P892@X0100000TB2PTB2PTB2PD92@X00`TB2PT92PTB2P032A8:10T92P03
4A`:2@T:2@T:00892@X02PTB2PT92PT92P00014L2P0000TB2PT92PTB2P00
00894PX02P0000T92PTB2PTB2PT92Q4L2QX92Q4L2PT92QX92P8A70X00`00
00TB2PT92P022A8:00DA70XJ2@X/4P0J2@XS70X00PT92P0800002A8:2@T:
4A`:6PT:4A`:2@T:2A8:0PT92P042A8:2@T:2@T:2A8:0`T92P034A`:2@T:
2@T:00@92@X01`00014L2PT92PT92P0000TB2PT92P022A8:00H92@X94PX9
4PX94PX92@X94PX22@T:00H94PX92@X92@X92@XA70XJ4Q@2;2HD00<S;ai6
@Ai6C3d00TI<?@08=5Dm4A`:2@T:00002@TD2A8:2@T:2A8:1@T92P0:0000
2@T:2@T:00002A8:2@T:2A8:2@T:00002A8:0PT92P062A8:2@T:2@T:0000
2@T:4A`:1`T92P062A8:2@T:2@T:00002@T:00000Q4L2P052@T:2A8:2@T:
2@T:2A8:00892@X00a4L2PT92PTB2P062@T:0Q4L2PL92@X0100000T92PT9
2Q4L2PP92@X01`TB2P0000TB2PTB2PT92QX92Q4L2P032@T:00N`C02iI`31
Q03TZP0/71@92@XJ2@X00`T92P054A`:2@T:2@T:2@T:4A`:00@92@X0114L
2PT92PT92QX92P892@X22A8:00@A70X92@X0002VZZeQc<c<00AVIVJ8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0
GLc<c0032@TD8blN2A8:00H94PX22@T:00<94PX000092@X00`T92P032A8:
2@T:2A8:00@92@X0100000T92PT92PT92P894PX01@T92PTB2PTB2P0000TB
2P052@T:00P000092@X92@X92@X94PX000092@X94PX200000PT92P054A`:
2@T:4A`:6PT:4A`:00892@X02`0000T92P0000T92QX92Q4L2QX92Q4L2PT9
2Q4L2P0000052@T:00<A70X92@X94PX01@T92P0;00002A8:2@T:00004A`:
2@T:00002@T:00002@T:2A8:00<000032@T:00<94PX000092@X00P00000;
2@T:2A8:00002@T:00002A8:00002@T:2A8:00002A8:008A70X011X92QXV
51XL7TI17P8d;bT00b`L500000TB2P02000000@94PX000092@X000022@T:
00<000092@X94PX010T92P800000314L2PT92P0000T92PTB2P0000T92PTB
2P0000TB2P0000TB2P892@X01@TB2PT92PT92PT92P0000022@T:00@0000A
70X92@X000022@T:00DA70X94PX94PX000094PX01`T92P054A`:2@T:4A`:
6PT:4A`:00L92@X00a4L2PTB2PT92P024A`:2@T92P042A8:4A`:2@T:2A8:
0PT92P072@TDPbl0omT0m[<0m/L:`H@0000000@92@X22A8:1`T92P034A`:
2@T:2@T:00D92@X22A8:00<A70X0002EXKL0HLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`0
1PTB2Q4V50T951XB50TB2PT950<94PX00`T92PTB2PT92P032A8:00D92@X9
4PX94PX92@XJ4Q@01@TB2P042@T:2A8:4A`:2@T:0`TB2P<92@X01@TB2PT9
2PTB2P0000TB2P062@T:0PTB2P@92@X01A4L2QX92Q4L2PTB2QX92P022@T:
00X94PX92@X92@X92@XA70XJ2@XA70X92@X94PXA70X:2@T:00<A70X92@X9
4PX00PT92P0500002@T:2A8:2@T:4BHN00L92@X01@T950TB2P0000T92PTB
2P042@T:00<94PX000092@X010T92P0>2A8:2@T:2A8:2@TD2@T:2A8:6Q8D
6RHD;1`D;3PY8blc6RHD2@T:2A8:10T92P032A8:2@T:2@T:00892@X010TB
2P0000T92PT92P894PX00`T92Q4L2P0000022@T:00D94PX92@X92@XJ4Q@9
4PX010T92P<94PX01@T92Q4L2PT92PT92Q4V7P022@T:00d000092@X92@X9
2@X94PXA70X92@XJ2@X94PX92@X94PXA70X92@X00PTB2P046PT:2A8:2@TD
6PT:0a4L2P056PT:2A8:2@T:2@T:2A8:00892@X010TB2PT92PT92PTB2P@9
2@X00a4L2PT92PT92P022A8:1@T92P0;4A`:2@T:4A`:0000Pbl0ooH0omT0
`H@000002@T:4A`:00892@X010TB2PT92PT92Q4L2P<92@X0414L2PTB2PT9
2PT92Q4L2PTB2PT92Q4L2PT92PTB2Q4L2PTB2QXB50T9500009FQ]f7<c<`0
16IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00ooo
olc<c<c<c01Mc<c<00HJ4Q@92A@92@XJ4Q@A70X92@X22A8:00D92@X94PXA
70X94PX92@X00`TB2P032@T:2A8:2A8:00D92@X52A8:00@92@X94PX92@X9
2@X22A8:0`T92P052A8:00004A`:2@T:2A8:00@92@X00`0000T92PTB2P02
4A`:00</4P0A70X92@X00QX92P8A70X01@TB2PT92Q4L2PTB2QX92P034A`:
00D/4P094PXA70X92@X94PX010T92P<A70X010T92Q4L2PTB2PT92P894PX0
1@T92P0000TB2PT92PTB2P022@T:00DA70X92@X92@X92@X000000`T92P03
00002A8:000000<92@X00`TB2PT92PTB2P022@T:00L94PX92@X92@X92@X0
00094PX92@X00QXB508S70X011X92Q4L2PTB2PTB2P<92@X00aXB500000TB
2P022@T:00P94PX92@X92@X92@X94PX92@X000094PX22@T:00H94PX00009
2@X0000J4Q@A9Q@22@T:00/94PX92@X92@X92@X94PXJ4Q@A9Q@92A@92@XA
70X92@X00`TB2P892@X00`TB2PT92PT92P032@T:00`J2@X92@X94PXA70X9
2A@92@X94PX92@XJ4Q@A70X92@XJ2@X24A`:00<94PX92@X92@X03PT92P03
00002A8:2@T:00892@X04PTB2Q4L2PT92PT92PT9514L2PT959EE078V00T9
2PTB2Q4L2PT92Q4L2PT92Q4L2PT92Q4L2P@92@X00a4L2PT92PT92P022@T:
00D94PX92@X94PX92@X94PX00PT92P042@TD4A`:0000UJ6gHLc<c004IVIV
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<
c<c<05g<c<`00a4V50TB2Q4L2P022@T:00DA70X92@X92@X92@X94PX00PT9
2P052A8:2@T:2@T:2A8:2@T:00894PX42@T:00<94PX92@X92@X010T92P03
2A8:2@T:2A8:00892@X01P0000TB2PT92PTB2PT92P0000894PX32@T:00D0
000A70X92@X000094PX00PT92P042A8:4A`:6PT:4A`:1@T92P0800004A`:
8a`:6PT:;1804A`:6PT:4A`:30T92P046PT:00002A8:00000PT92P032A8:
00002A8:00892@X01A4L2PT92PTB2PT92PTB2P022@T:00<000092A@94PX0
10T92P0<2A8:2@T:00002A8:00002@T:2A8:00002@T:00002@T:2A8:0a4L
2P092@T:2A8:2@T:00002A8:00002A8:2@TD2A8:00<92@X00`0000TB2PTB
2P022@T:00<000092@X92@X00PT92P0400002@TD2@T:2@T:0P0000032A8:
2@T:2@T:00894PX22@T:0PT950082@T:4A`:2@T:2A8:00002@TD00002A8:
0PT92P044A`:2@T:4A`:4A`:0`T92P086PT:6Q8D=2lY4A`:2@T:4A`:2@T:
;1800Q4L2P8J2@X01`TB2PT92PTB2PT92P0000T92P0000042@T:00<94PX9
2@X92@X02`T92P074A`:2@T:2@T:2A8:00002@TD000000892@X01a4L2PT9
2PT950T92PTB2PT92Q4L2P042@T:0PTB2P032@T:2A8:2@T:00D92@X24A`:
00<92@X0002`_/40HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8
`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`01@T950T92PT92PT92Q4L
2P052@T:00<94PX000092@X01@T92P042A8:2@T:2@T:2A8:0PT92P032A8:
2@T:4A`:00892@X01AX92P0000TB2P0000TB2P042@T:00@J2@X94PX94PX0
00032@T:00h94PX000092@X0000A70X000092@XA70XJ2@XA70X92@XA70XJ
2@XA70X26PT:00/A70X94PXA70XA70XJ2@XA9PXS70XA70XJ2@X92@XJ2@X0
0`T92P032A8:2@T:2@T:00892@X00a4L2PT92PT92P042@T:00h94PX00009
2@X92@X94PX92@X94PX92@X000094PX000092@X000094PX300000PT92P03
2A8:00002A8:00894PX0100000TB2P0000T92P894PX0100000T92PTB2P00
00892@X010TB2P0000T92PTB2P892@X00aXB50T951XB50022A8:1PT92P06
4A`:00002A8:2@T:2A8:00001@T92P042A8:00002@T:2@T:0`TB2P036Q8D
2A8:2A8:00<94PX00`0000T92PT92P082@T:00<A70X92@XA70X00PT92P07
2A8:2@T:2@T:4A`:2A8:00004A`:00894PX00`0000T92PTB2P022A8:10T9
2P042A8:00002@T:2A8:0`T92P074A`:2@T:2@T:2@T:4A`:2@T:4A`:00<9
4PX01PT95000060_2^BZ0?nc0<6400892@X011X92X<_00T92PTB2PP92@X0
0`TB2PT92Q4L2P022@T:00<94PX92@X94PX00PT92P034A`:0000Y[?1067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`0
0oooolc<c<c<c01Mc<c<0a4L2P032A8:2@T:4A`:00<94PX32@T:0PTB2P<9
2@X22A8:00H92@X000092@X92@X94PX000022@T:00<94PX92@X92@X00`T9
2P0<2A8:2@T:2@T:00002A8:00002@T:00002@T:2A8:2@T:2A8:0`T92P04
2A8:2@T:2A8:00000Q4L2P052A8:2A`D2@T:4A`:6PT:008A70X02`T92PTB
2PT92PTB2R<L2R`B014L2P00014L2PT92Q4L2P022A8:0PT92P0300002@T:
2@T:00H92@X22A8:00@000092@X94PX000022@T:00@S70X94PX92@X00002
2@T:00D94PX000092@X92@X94PX00`0000042A8:0000000000000PT92P03
2A8:0000000000@92@X00`TB2PT950T92P022@T:00D000092@X92@X92@X9
2A@00PTB2P042@T:2A8:2A8:00000PT92P0:2A8:00002@T:00002@T:0000
2A8:2@T:2A8:2@T:0PTB2P<92@X010TB2PT92PT92PT950H94PX92@T:00@A
70X92@X94PXA70X22@T:00<A70X94PX92@X00`T92P054A`:6PT:4A`:6PT:
2A8:00892@X010TB2P0000T92PT92P894PX0100000T92PTB2P0000H92@X0
0`TB2PT92PT92P052@T:0180000m4P[CV0[CV0[1Q03o/`23;`092AB`C03o
mP23;`092@XJ2@X92@XA70X92@XA70X94PX32@T:00@A70X92@XA70X94PX2
2@T:00HA70X92@XJ4Q@92A@0002EXKMQc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0062A8:
2@TD4A`:2@T:4A`:2@T:1@TB2PD92@X02PTB2PT92PTB2PTB2PT92PTB2PT9
2PTB2PT92Q4V7PD92@X22A8:00<000094PX92@X00`T92P894PX010T92PTB
2PT92P0000892@X01`TB2PT92PT92P0000TB2Q4L2QX92P03;18000<94PXA
70X94PX00`T92P064A`:6PT:6PT:8a`:;1806PT:1@T92P032A8:2@T:2@T:
00<92@X0100000T92PT92PT92P894PX01`0000TB2PT92P0000TB2P0000T9
5002000000d94PX92@X94PX92@X000092A@92@X000094PX0000A70X92@X0
00000`T92P0300002A8:2@T:00892@X010TB2PT92PT92PT92P8000000`TB
2PT92P0000022@T:00L000092@X92@X000092@X971@94PX00PT92P072A8:
00002@T:2@TD2A8:2@T:2A8:00<92@X00`0000T92PT92P032@T:00<94PX9
2@X92A@010T92P042A8:2@T:2@T:00003PT92P032A8:2@T:2A8:00892@X0
0a4L2PT92Q4L2P022@T:00<J2@X92@XA70X01@T92P032A8:2@T:2@T:00L9
2@X00`TB2P0000TB2P052@T:0Q4L2P0@2@T:LRH0ooH0YT402@TDok<0YT40
;180/4`0ooH0PcP02@T:6PT:4A`:2@T:2A8:0`T92P892A@32@T:00<J2@X9
2@X92@X00`T92P034A`:0000YZZ]067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00TA70X9
2@X94PX92@X94PX0000A70X92@X94PX00PT92P<94PX00`T92Q4L2PT92P03
2@T:0PTB2P042@T:00002A8:00000PT92P0:2A8:2@T:2A8:2@T:00002A8:
00002A8:2@T:2A8:0PT92P0?00002A8:2@T:00002A8:00002A8:00002A8:
00002@T:2A8:6PT:4A`:;180008A70X42@T:00P94PX92@X/4P092@XA70X9
2@XA70X/4P026PT:00DA70X92@X94PX0000J2@X020T92P032A8:00002@T:
008000022@T:00<000094PX92@X010T92P0300004A`:000000<92@X01@00
00TB2P0000T92PTB2P042@T:00L94PX92@X000094PX000092@X000000`T9
2P894PX22@T:00<94PX92@X92@X00PT92P892A@32@T:00@000094PX00000
00022@T:00D000092@X92@X92@X94PX01@T92P0300002A8:2A8:00X92@X0
0a4L2PT92PT92P042@T:00<94PX92@X92@X01PT92P064A`:2@T:2@T:2@T:
4A`:4BHD0PT92P0=00002A8:2@T:00002@T:00002A8:00002@T:2@TD2A8:
2@T:2A8:00D92@X00`TB2PT92PT92P022@T:01094PX92@X92AAb9P3omP2E
E@092ACf/`23>02`C03omP1G70092@XJ2@X92@XA70X22@T:00H94PX92@X9
2@X94PX92A@A70X32@T:00P94PX92@X92@X92@XA70X92@X0002`/kMQc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?o
ooo<c<c<c<`0GLc<c0894PX22@T:00D94PXA70X92@X000094PX00PT92P06
2A8:2@T:2@T:2A8:2@T:2A8:0`T92P0<2@TD00002A8:2A8:2@T:4A`:0000
2A8:00002A8:00002A8:0P0000<92@X01`TB2PT92PTB2PTB2P0000T92PTB
2P022@T:00<000092@X94PX00`T92P036PT:4A`:2A8:008/4P024A`:00<9
4PX000092@X00a4L2P052@T:4A`:2@T:4A`:2A8:008A70X02@TB2R`B014L
2PT92Q4L2PT92R`B00T92Q4L2P022@T:00@94PX000092@X000022A8:00H9
2@X94PX94PX000092@X94PX22@T:00L000092@X000094PX000094PX00000
10T92P0800002A8:2@T:2@T:2A8:00002A8:00000`T92P0:2A8:00002@T:
2A8:00002@T:2A8:00002@T:2A8:0PT92P042A8:2@TD2@TD2A8:1@T92P08
2A8:00002@T:2@T:2A8:2@T:2A8:00001PT92P042A8:2@TD2@T:2@T:0PTB
2PD92@X01Q4L2PT92Q4L2Q4L2PT92PTB2P892@X00a4L2PT92PT92P052@T:
00L94PX92A@92@X92@XA70XJ2@X/4P001PT92P062A8:00002@T:2@T:2A8:
00000PT92P0500002@T:2A8:2@T:2A8:00<92@X070TB2Q4L2PT92PTB2Q4L
2P0003dB2_K72_Jc0?nc0?o@0?oI0?o@078V00T950TB2Q4L2QX92PT92Q4L
2PT92Q4L2PT92Q4L2PT92Q4L2PT92Q4L2P892@X00`TB2PT92PTB2P032@T:
00<0002EV:?<c<`0H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8
`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`010T951XB514L2PT95089
2@X00aXB50T92QX92P052@T:00D94PX92@X92@X92@X92A@00P0000892@X0
2@0000T92P0000TB2P0000T92P0000T92P0000022@T:00@000094PX00009
2@X300000`T92P032A8:00002@T:00892@X02`00014L2PT92Q4L2QX92R<V
2R<L2R`B02<V2QX92PTB2P032@T:0QX92P8A70X01B`B01X92QX92QX92PT9
2P026PT:00DA70X92@XS70X92@XA70X00PT92P8A70X0100000TB2P0000T9
50<000000a4L2P0000TB2P0200000`T92P0300002@T:000000892@X01000
00T92PTB2P0000892@X020TB2PT92PT92P0000T92P0000T92P0000T92@X0
20TB2PT92PT92PTB2PT950T92QXB500000892@X02@TB2P000000000000TB
2PT9500000TB2P00000<2@T:00<94PX000092@X01@T92P0;4A`:2@T:2@T:
2@T:2A8:2@T:4A`:00002A8:2@T:000000P92@X0214L2PT92Q4L2PT92Q4L
2PTB2PT92P0000D92@X00`0000T92P0000032@T:00<94PX000094PX01PT9
2P062A8:2@T:2@T:4A`:2@TD6PT:0/640006YW80Nd40Nd`:00006PT:0000
0PT92P052A8:2@T:2A8:2@T:2@TD00<92@X01A4L2PT92PT92PT92PTB2P03
2@T:0Q4L2P030000/;>gc<c<063<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00L94PXA9Q@9
2A@A70X94PX92@X94PX00PT92P032A8:4A`:2A8:00<92@X22A8:00<0000A
70X92@X00PT92P092A8:2@T:2A8:00002A8:00002A8:2@T:2A8:00@92@X0
0`0000T92P0000032@T:00<000094PX92@X00`T92P0400002@T:2A8:0000
0PTB2P064A`:8a`:6PT:4BH:8a`:4A`:0`T92P062A8:2@T:4A`:6PT:2@T:
4A`:0PT92P034A`:2@T:4A`:00892@X22A8:0PT92P034A`:2@T:2A8:0089
2@X010TB2PT92P0000TB2P892@X011XB50T92P0000TB2P892@X010TB2P00
00T92P0000@92@X00`0000TB2PT92P032@T:00H000094PX92@X000092@X0
00022A8:0`T92P<94PX62@T:00<94PX92@X92@X00`T92P0500002@T:2A8:
2@T:000000X92@X01@TB2PT92PT92PTB2PT950052@T:00@000092@X92@X9
2@X24A`:00L92@X94PX94PXA70X92@X94PXA70X02PT92P034A`:2@T:6PT:
008A70X42@T:00<000094PX92@X010T92P0300004A`:2@T:00<92@X00`00
014L2PT92P042@T:00P94PX92@X94PX92@X000092A@000092A@2000000PJ
4Q@92@XA70X92@XA70X92@XJ2@X92@X24A`:0PT92P032A8:2@T:2A8:00<9
2@X24A`:0PT92P032@TD0000UJ6g067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00HJ4Q@9
4PX92A@94PX92A@J4Q@=2@T:00H000092@X000092@X000094PX32@T:00/0
00094PX92@X92@X94PX92@X94PX92@X000092@X94PX00`T92P0600002@T:
4A`:2@T:00004A`:0PTB2P8000026PT:00HA70XS70X/4P0A70XJ2@XA70X5
2@T:00d94PXA70X92@XA70X92@XA70X000094PX92@X000094PX000094PX0
0`T92P0=00002A8:2@T:2@T:00002A8:2@T:00006Q`N6Q8D00002@T:6Q8D
008000000`T950T92PT92P022@T:00<000094PX000000PT92P032A8:2@T:
2@TD00@92@X00a4L2PT92PT92P032@T:00PA70XJ4Q@J4Q@J2@X94PX92@X9
4PX92A@42@T:00X94PX92@X92@X92@X94PX92@X000092@X000094PX32@T:
00<94PX92@X000001PT92P032A8:2@T:2@T:00L92@X0100000T92PTB2Q4L
2P<92@X0114L2PT92Q4L2PTB2P<92@X01P0000T92PT92PTB2PT92P000089
2@X0114L2PT92Q4L2PTB2PH92@X0200000TB2PT92P0000T92PTB2P0000TB
2P@92@X00`0000T92PT92P072@T:00Tm4P[TZP3o/`3CQ00000092@X0000m
4PX94PX00PT92P044A`:2@T:2@T:2A8:10T92P034A`:2@T:2@T:00D92@X2
4A`:00<0002V/l7<c<`0H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`00`TB2QXB514L2P02
2A8:00<92@X94PX94PX00PT92P042A8:2@T:2A8:2A8:0PT92P034A`:2@T:
2@T:00892@X22A8:0`T92P0400002@T:4A`:00000PT92P894PX2000000<A
70X000092@X00PT92P094A`:2@T:2A8:2A8:2@T:2A8:2@T:6PT:00000089
2@X34A`:00DJ2@XA9PX/4P0S;ahA70X00PTB2P<92@X00a4L2PT92Q4L2P02
2@T:00@94PX92@X92@X94PX:2@T:00@94PX000092@X94PX2000000@92@X9
4PX0000000022A8:00H000092@X94PX92@X94PX000032@T:00<0000971h9
4PX00`T92P894PX00`0000TB2PT92P042@T:00@A70X94PXA;c<94PX32@T:
0PTB2P892@X22A8:00<000094PX000001PT92P034A`:00002@T:00<92@X3
2A8:00<92@XJ71h92@X02PT92P032A8:00002@T:00894PX00`T92R<L2PTB
2P092@T:00<A70X92@X92@X00PT92P044A`:6PT:2@T:4A`:1PT92P040000
2@T:4A`:000020T92P0K2A8:2@T:2@T:2@T:4A`:2@T:4A`:2@T:6Q8D^FL0
diP:`H@0ok<0Pbl02@TD/4`0ooH0PcP02@T:6PT:2@T:4A`:6PT:2@T:6PT:
2@T:2A8:00892@X01a4L2PT92PT92Q4L2PT92Q4L2PTB2P022@T:00<0002V
/l7<c<`0H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;So
c<c<6/c<c003ooooc<c<c<c<05g<c<`010TL51XB50T92PTB2P@92@X00`TB
2PT92Q4L2P032@T:00@94PXA70X000092@X22A8:00<000092@X92@X01@T9
2P0500002@T:2@T:2@T:000000L92@X010TB2PT92PTB2P0000892@X01@TB
2PT92PT92PT92PTB2P022@T:00<A70X92@X/4P000QX92P054A`:6PT:0000
00004A`:00<92@X02@TB2Q4L2Q4L2PTB2PT92PTB2P0000T92PTB2P042@T:
0P0000034A`:00002@T:00892@X01P0000T92P0000TB2PT92P0000892@X2
000000L92@X0000000094PX000092@X000001PT92P032A8:000000000089
2@X02@0000TB2P00000000T92Q4L2PTB2R`B00TL50022@T:0PTB2P030000
2@T:2@T:00<92@X01@0001XB500000T92P0000022@T:00<000092@X00000
0`T92P042A8:2@T:2A8:00001PT92P894PX42@T:00L000094PX92@X92@X0
00092@X/4P0010T92P082A8:00002@T:00002@T:00004A`:00002PT92P04
00002@T:4A`:00000PT92P0500002@T:2@T:2@T:000000H92@X00`0000T9
2PT92P022@T:00l92A@A70X0001G703omP2EE@00003CQ02EE@000023;`3o
mP23>000000A70X01PT92P034A`:2@T:2@T:00892@X02A4L2PT92Q4L2PTB
2PT92Q4V7PT92P000:Jc`@1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0042@TD6Q8D4A`:
2@T:0PTB2P084A`:2@T:2@TD4A`:2@T:2A8:2@T:4A`:0PT92P032A8:2@T:
4A`:00<92@X01@TB2PT92PT92PT92PTB2P022@T:00<A70X000092@X01@T9
2P072A8:2@T:000000002A8:2@T:2A8:00L92@X02@00014L2QX92Q4L2QX9
2Q4L2R`B01X92Q4L2P022@T:00<000094PX92@X020T92P036PT:2@T:0000
00892@X00`TB2PT92PTB2P022@T:0PTB2P@92@X00`0000T92PT92P042@T:
00<000092A@94PX00PT92P032A8:2@T:2@T:00H92@X22A8:00D92@X94PX9
2@X000094PX00PT92P032A8:2@T:2A8:00<92@X22@TD00@94PX92@X92@X9
4PX22@T:00<94PX92@X94PX00PT92P0600002@T:2@T:00002@T:00000PT9
2P0300002@T:2@T:00@92@X01@TB2PT92PT92P0000T950022@T:00L94PX9
2@X92@X92A@000092@X94PX00`T92P032A8:2@T:000000D92@X01P0000T9
2PT92PT92P0000TB2P892@X00a4L2PT92Q4L2P042@T:00@000092@X00009
4PX32@T:00@94PX92@X92@X92@X22A8:0PT92P034A`:2@T:2@T:00892@X0
6A4L2PT92PTL7SdB2_oI09EE00T95>BZ08=103dB2[1<0>BZ05LL00T92PTB
2QX92Q4L2PT92Q4L2PT92PTB2PT92QX92PT9514L2P022@T:00PA70X92A@J
2@X94PXJ2@XA70X0002`_/5Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0054A`:6Q8D2@TD
4A`:2A8:00892@X00`TB2QXB50TB2P032@T:00DA70X92@X92@X94PX92A@0
0PTB2P@92@X22A8:00`000092@X94PX000094PXA70X92@X94PX92@XA70X9
2@X92A@62@T:00H000094PX94PX94PX92@X94PX22@T:00<94PXA70X92@X0
0R<V2P03;1804BH:6PT:00892@X01PTB2PT92PTB2PTB2PT92PTB2P892@X0
1Q4L2PT92PTB2PT92PTB2PT92P894PX01PT92PTB2PTB2PT92PTB2PT92P80
000020TB2PT92P00014L2P0000TB2P0000T92P894PX01P0000T92P0000TB
2PT92P0000<92@X00`TB2PT92PT92P042@T:00<000092@X000000PT92P05
00002A8:2@T:2@T:000000892@X32A8:0PT92P894PX01aXB50TB2PT92P00
00TB2P0000TB2P022@T:00<94PXA70X92@X00PTB2P892@X01`TB2PT92PTB
2PT92PTB2PT92PTB2P072@T:00L000094PX000094PX92@X000094PX00`T9
2P0300002A8:2@T:00<92@X01@TB2PT92PTB2PTB2P0000032@T:00<00009
2@X94PX00PTB2PD92@X00`TB2PT92PT92P022A8:00<000094PX92@X01`T9
2P0?4A`:2@T:2@T:4A`:2@T:0000?A8:ooH0YT400000dh@0Pd40Pbl0ooH0
000000892@X011X92PT92QX92Q4L2P892@X01A4L2PT92PT92PT92Q4L2P05
2@T:00DJ2@X94PXA70X0002`_/40HLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`010TL50T9
514L2PTB2P<92@X02@TB2QXB50TB2PT92PTB2Q4L2PT92PTB2P0000022A8:
1@T92P894PX010T92PTB2PTB2P0000@92@X0214L2PT92Q4L2P0000T92PTB
2PT92PTB2P892@X00`0000T92PTB2P02000000<94PX000092@X00PT92P8/
4P028a`:00PS9PXJ2@XA70X000094PX000094PX000022@T:00P000092@XA
70XJ2@XA70X000094PX000022@T:00H000094PX0000000092@X000032@T:
00<94PX0000000000`T92P0600002A8:6PT:00002@T:2A8:0PT92P060000
2A8:2@T:2@T:2A8:2@T:0`TB2P0<00002@T:2@T:2@T:2A8:00002@TD0000
2A8:00002A8:00000PTB2PD92@X02PTB2P0000TB2PT9500000TB2P0000T9
2PTB2P0000894PX2000000T94PX92@X000092@X94PX000092@X94PX00000
10T92P062@TD2@T:2A8:2@TD2@T:2A8:10T92P034A`:00002A8:00894PX0
2P0000T92PT92P0000T92PTB2P0000T92PTB2P0000H92@X00a4L2P0000T9
2P032@T:00H94PX92@X92@X000092@X94PX2000000<94PX000092@X020T9
2P0?2A8:2@T:2@T:2@T:4A`:0000diP:dh@0i:X0m[<0ok<0omT06PT:0000
2@T:008A70X00`T92QXB50TB2P032@T:00<94PXA70X92@X010T92P032A8:
4A`:2@T:00892@X00`0009FQ]lc<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0046Q8D
2@TD4A`:2@TD0PTB2P032@T:4A`:2A8:00892@X01PTB2PT92PT92PTB2QXB
50T92P894PX22@T:00H94PX0000000092@X94PX000032@T:00X94PX92@X9
4PX000094PX000092@X94PX971h000022A8:00<92@X94PX92@X00PT92P05
2A8:00002A8:00002@T:008A70X01QX92R<V2R`B02<L2R`B014L2P892@X0
0`TB2P0000T92P052@T:00HA70XJ2@X92@X92@X94PX000022@T:00X94PX9
2@X94PX94PX92@X94PX92@X000094PX000052@T:00@000092@X92@X94PX2
000000H94PX92@X000092A@94PX000022@T:00H94PX92@X92@X971h00009
2@X22A8:0PT92P0500002@T:00002A8:000000D92@X01@TB2P0000T95000
00TL7P02000000D94PX000092@X92@X0000010T92P0300002A8:00000089
2@X01`T950TB2PT92PT92PTB2PT92PTB2P042@T:00T94PX000092@X00009
2@X94PX000092@X92A@00P0000L92@X00`0000T92PT92P022@T:00H00009
2@X92@X000092@X92A@22@T:00@94PX000092@X94PX62@T:00<000092@X9
2@X01`T92P0>2A8:2@T:2@T:2@T:2A8:2@T:2@TD6PT:diP:i:X0`H@0YVL0
UED02@TD0PTB2P032@T:2@TD2@T:00892@X00a4L2PT92PT92P032@T:00/A
70X92@XA70X92@X94PX92A@92@XA70X92@X0002`_/40HLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<
05g<c<`02A4L2QXB50T951XB50TB2PT9514L2PT950TB2P022@T:00H92A@9
2@X92@X92@XJ4Q@J71h42@T:00<94PX92@X92@X00PTB2P032@T:2A8:2@T:
00D92@X00`0000T92PTB2P042@T:00D000094PX000092A@94PX00`T92P0;
00002A8:00004A`:6PT:4BH:;1808a`:4A`:2@T:6PT:00<92@X00`0000TB
2PTB2P032@T:00@92A@A70XJ2@XA70X22@T:00@0000A70X94PX000022@T:
00D000094PX92@X92@X94PX00PT92P032A8:2@T:2@T:00<92@X01`TB2PT9
2PT92PTB2PT92P0000TB2P022@T:00H94PX92@X92@X94PX92A@94PX22@T:
00@94PX92@X92@X000022A8:00D92@X94PX92A@000092A@00PT92P042@TD
2A8:2@T:2@T:0PTB2P892@X040T950T92P0001XB50T92P0000TB2PT92PTB
2PT92PT950TB2P0000TB2PT92PTB2P<92@X00`TB2PT950T92P042@T:00D9
4PX92@X92@X92@X92A@01@T92P0600002@T:2A8:2@T:00002A8:0`T92P04
2A8:2@TD2@T:2A8:1`T92P032A8:2@T:2A8:00H92@X01@TB2PT92PT92PT9
2P0000052@T:00<000092@X92@X00PT92P0;4A`:2@T:2A8:4A`:2@T:0000
2@TD00002@TD00002@TD00<92@X00aX92PT9514L2P032@T:00DJ4Q@92@X9
4PXA70X94PX00`T92P084A`:6Q8D6Q8D2@T:2@TD4BHD0000/;k1HLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003oooo
c<c<c<c<05g<c<`02`TL50T950TB2PT950TB2PT92PT9514L2PT92PTB2Q4L
2P032A8:00DA70X92@XJ4Q@94PXA70X00PT92P052A8:2@T:2@T:2@T:2A8:
00<92@X00`TB2PT92Q4L2P052@T:00<000094PX94PX00`T92P052A8:2@T:
2@T:00002A8:00D92@X00b<L2R`B01X92P038a`:00<A70X94PX94PX00PTB
2P092@T:00002A8:2@T:2A8:6Q8D2A8:4A`:2@TD008A70X42@T:00/94PX9
2@X92@X92@X000094PX92@X000092@X000094PX00PT92P032A8:00000000
008000001`T92P0000TB2P00014L2P00014L2P032@T:00D92A@94PX92@X9
4PX0000010T92P0>00002A8:00002A8:2@T:00002@T:4A`:2@T:2A8:2@T:
2A8:2@T:2A8:0`T92P0?00002@T:00002A8:2@T:00002A8:2@T:00002A8:
00002@TD2@T:2A8:000000<94PX01@T9514V50T92PTB2PT92P022@TD10T9
2P0300002@T:2@T:00L92@X00`TB2PT92PT92P022@T:00<000092@X92@X0
1@T92P052A8:2@T:4A`:2@T:2@TD00892@X22A8:10T92P0300002A8:2@T:
00H92@X00`TB2PT92PT92P072@T:00HA70X92@X92A@A70X92@XA70X52@T:
00DA70X92@X92@XA70X92@X00Q4L2P032@T:6PT:2A8:008A70X020TB2PT9
514L2PT92PTB2PT92P000:JZ[F7<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00DJ4Q@A9Q@J
4Q@92A@A70X00PTB2P032@T:6Q8D2@T:00892@X010TB2PT92PT92PTB2P89
2@X010TB2PT92PT92PTB2P<92@X01a4L2PTB2PT92PTB2P0000TB2PT92P02
2A8:1@T92P894PX22@T:0PTB2PH92@X02@TB2PT92PT92Q4L2PT92R<L2QX9
2R`B01X92P032@T:00<94PX000092@X00PT92P032A8:00002@T:00892@X0
4`TB2PT92PT92PTB2PT92PTB2P0000T92PTB2PT92PTB2P0000T92PTB2P00
00T92P00014L2P0000062@T:00H000092@X92@X92@X94PX000042@T:00<9
4PX92@X92@X00PTB2P<92@X02PT9500000T92PTB2PT92P0000TB2P0000T9
2PTB2P<92@X32A8:00L92@X94PX000094PX000092@X000000`T92P070000
2@T:2@T:2A8:00002@T:2A8:00<92A@00`TL7PT950TB2P042A8:0PT92P03
2A8:2@T:2@T:00D92@X0100000T92PTB2P0000892@X42A8:00P92@XA70XA
70XA70X92A@92@XA70X94PX32@T:0PTB2P@92@X00`TB2PT92PT92P062@T:
00@94PX000092@X94PX92@T:00@A70X94PX92@X94PX22@T:00PJ2@X92@X9
2@XA70X92@XA70X92@XA70X32@TD00d94PX92@XA70X92@XJ2@X92@XA70X9
2@XA70XJ4Q@94PX0002V/l40HLc<c004IVIVR<2hR<2hB9280@00000000B8
`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`02A4V50T951XB
50T92Q4L2PT92Q4L2PTB2PT92P024A`:00L92@XA70XJ4Q@92A@92@XA70X9
4PX00`T92P064A`:2@T:4A`:2@T:2A8:2@T:0PTB2P052@T:2A8:2A8:2@T:
2A8:00892@X02PTB2PT92PT92PTB2P0000TB2QX92PT92PTB2Q4L2P892@X0
0a4L2PTB2P0000022@T:00TJ2@XA70X/4P0S70X/4P0J2@XA70X94PX92@X0
0PTB2P892@X010TB2PT92PTB2PTB2P892@X00`TB2PT92PT92P072@T:00@9
4PX92@X92@X000022@T:00<000092@X92@X00PT92P0400002A8:2@T:2A8:
0PT92P0400002A8:00002A8:0`T92P062A8:2@T:2@TD2@T:2@TD00000`T9
2P032A8:00002@T:00<92@X00`TB2PT92PTL50052@T:00<94PX92@X94PX0
0PT92P042A8:2@T:2A8:000010T92P032A8:00002@T:00894PX021XB5000
014V514V52`L514V50T951XB50@94PX00`T950T92PT92P032@T:00<A70X9
2@XA70X00PT92P0:2A8:2@T:6Q8D2@T:4A`:2@T:6Q8D4A`:6Q8D4BHN0QXV
50034BHD8blN6RHD00<J9Q@24BHD00PA70XJ4Q@94PX92@XJ4Q@94PX92A@A
70X22A8:0PT92P032A8:2@T:2@T:00T92@X00a4L2PT92PT92P032@T:00<A
70X92@XA70X01PT92P072A8:4A`:6PT:2@T:4A`:2@T:4A`:00<92@X02@TB
2PT92PT92Q4L2PTB2QXB50T950000<77c01Qc<c<00AVIVJ8`;R8`;Q8T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c006
4BHD6Q8D2A8:2@T:4BHD2@T:0PTB2P<92@X00a4L2PT92PTB2P024A`:0PT9
2P042A8:2@T:2A8:2A8:10T92P064A`:2A8:2@T:2@T:2A8:00000PTB2P89
2@X00`0000TB2PT92P082@T:0PTB2P052@T:4A`:2@T:2@T:4A`:008J2@X0
1B`B02<L2R`B014L2PTB2P052@T:00H000092@X92@X000094PX92@X22A8:
0PT92P042A8:2@T:2@T:2A8:0`T92P032A8:2@T:4A`:00892@X32A8:0PT9
2P054A`:00002@T:00002A8:00D92@X01@0000TB2PTB2PT950TB2P022@T:
00@000092@X92@X94PX72@T:00<000094PX92A@00PT92P042A8:2@T:2@T:
2@T:0`TB2P042@T:00002A8:00002@T92P0900006Q8D4Blc8blY2BHY8d4m
2@T:2@TD2A8:00892A@04PTB2R<_:@TL7PTB2PT92PTB2P0000T950T92PTB
2PT92Q4V514L2QXB514V50TL514V51XB50@A9Q@00b<V2QXL7R`h:@028blN
0R<_:@036RHD4BHN8blY008S;ah011XV52<_7R`h:AXV508S;ah01@TL51XB
514L2PT9514L2P022A8:10T92P052A8:2@T:2@T:2@T:2A8:00<92@X01AXB
50T92Q4L2PT92Q4L2P032@T:00<A70X94PX92@X00`T92P036Q8D2@T:4A`:
00892@X00a4L2PT92Q4L2P022A8:00P92@XS70X92@XJ2@X92A@S9PX92ABV
ZZeQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`J
c<c<00?oooo<c<c<c<`0GLc<c00:2A8:2@TD2@T:2A8:6Q`N2@TD4A`:2@TD
2@T:4A`:0PT950036Q8D2A8:2@T:00892@X00`TB2PT92PTB2P082@T:00@9
4PX92@X92@X94PX22@T:00<94PX92@X94PX04PT92P03;1808a`:;180008J
2@X00`TB2P0000T92P0;2@T:0P0000042@T:00002A8:00000`T92P030000
2@TD000000892@X3000000L92@X0000000094PX000092@X92A@00PTB2P09
00002A8:2@T:2@T:2A8:2@TD2A8:2@TD2A8:00<92@X010TB2P0000T92P00
00<92@X01PTB2P0000T92PT92PT950TB2P892@X02@0000TB2PT92QXB50T9
2P0000TB2PT92P0000022@T:00H000092@X000094PX92@X000032@T:00D0
000S@Cdd;c=6EE8971h00PT950052A`D6Q8D2@TD0000?Blm00892A@01PTB
2PT92PT92P0000TB2QXB50<A9Q@010TB2QXB514L2PT9508A70X04PTB2QXB
51XB50TL7QXV50TL7Q4L2QXB52`h:B<_:AXV51XL7R<_7R`V514V7R<_7QXL
7QXV508S;ah02QXV52`V51XL7QXV52<_7Q4L2QXB51XV50T9514L2P892@X0
0a4L2PT92PT92P022@T:00D94PX92@X92@X92@XA70X01`T92P046PT:2@T:
2@T:4A`:10T92P8A70X01@T92Q4L2PT92PT92QX92P042@T:0QXB50030000
/;>gc<c<063<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
olc<c1[<c<`00oooolc<c<c<c01Mc<c<00<J4Q@J9Q@94PX010TB2P082@T:
4A`:2@T:2@T:2@TD2@T:2@TD4A`:0PTB2P036PT:4A`:000000894PX02@T9
2PTB2PT92PT92PTB2PT92PTB2PT92PTB2P032@T:00<94PX000092@X00PT9
2P094A`:00002A8:2A8:2@T:6PT:2@T:4BHN4A`:00<92@X01`TB2PT92PT9
2Q4L2QX92PT92Q4L2P042@T:00HA70X92@XA70X94PX92@XA70X22@T:0Q4L
2PD92@X00`0000T92PT92P022@T:00D000092@X000092@X94PX00`T92P03
2A8:00002@T:00892@X01P0000TB2P00000000TB2P0000<92@X02PTB2PTL
7PTB2PT950TB2PT92PTB2P0000T92PT950894PX010T92PTB2PTB2P0000L9
2@X00`TB2PT92PT92P032@T:00X000094PX92@X94PX0000A70X000094PX9
2@X94PX22@T:00H94PX92@X92@XS;ahS;bT/EE`22@T:0PT950892@X00`T9
53AE?@TB2P052@T:0PTB2PH92@X00`TB2P0000TB2P022@T:0PTB2P074BHD
4A`:4A`:6RHD4BH:6Q`N4BHD00<J9Q@022`h:AXV51XL7QXL7QXV52`L52<_
7QXV50<S;ah02QXL7QXV51XV51XV51XB52<L2Q4L2PT92PTB2Q4L2PT92@X0
0`TB2PT92PTB2P0:2@T:00<J2@X92@XJ2@X00`T92P0900002A8:2@T:4A`:
2@T:4A`:2@T:0000/;>g067<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00@A9Q@94PX94PX9
2A@32A8:00T92@XA70X94PXA70X92@X94PX92@X94PXA70X00P0000894PX0
1@0000TB2PT92Q4L2PTB2P0200000PT92P0600002@T:2A8:2A8:2@T:0000
0PTB2P0:2@T:2A8:2A8:2A8:00002@T:2A8:4A`:2@T:00001@TB2P892@X0
1A4L2P000000014L2PTB2P032@T:0Q4L2P066PT:;1802@T:4A`:6PT:4A`:
0QX92P084A`:2@T:2A8:00002A8:00002@T:2A8:0P0000042A8:00002A8:
00000PT92P072A`D00002A8:00002@T:2A8:000000892@X01`TB2P0000TB
2P0000T92PTB2PT950022A`D00D92A@92@X000094PXA70X00PT92P052A8:
000000002A8:000000892@X010TB2PT92PT92PTB2PH92@X22A8:0P00000>
2@T:00002@T:2@T:00002A8:00002@T:00002@T:2A8:00002@T:2A8:0PT9
50042A`D2A8:2A8:2@TD0`TB2P032@TD8d4m2A8:00@92@X01@TB2PT92PT9
2Q4V2Q4L2P042@T:00<A70X94PXJ2@X00PT92P032A8:2@T:2A8:00892@X2
4A`:00H94PXA9Q@J9Q@A9Q@J9Q@A9Qh36RHD00<S;ahS9PXJ9Q@00b<_7P03
8blY4BHN6Q`N00<J9Q@01AXB514L2Q4L2QXB514L2P022@T:00<A70X92@X9
2@X00PT92P032A8:4A`:2@T:00892@X00a4L2PT92PT92P052@T:00<94PX9
2@X92@X00PT92P0<4A`:2A8:2@T:4A`:2@T:4A`:2@T:4A`:2@T:4A`:0000
`LO<HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<
6/c<c003ooooc<c<c<c<05g<c<`01QXB50TB2QXB51XB50T950TB2P892@X0
1PTB2PT950T92Q4L2PT9514L2P@92@X00`0000TB2PT92P052@T:00<A70X9
4PX94PX010T92P0700004A`:2@T:2@T:00002A8:2@T:008000001@TB2QX9
2PTB2P00014L2P032@T:00@000092@X92@XA70X22@T:00<000094PX94PX0
10T92P8J2@X02@T92R`B00TB2QX92R`B02<V2Q4L2PT92Q4L2P042@T:00T0
00094PX92@X94PX000092@X000094PX92@X00P00000;2@T:00002@T:2A8:
00002@T:2A8:2@T:00002@T:000000892@X01PTB2QXB54mNIPTL7PT950TB
2P892@X00`TB2PT92PT92P062@T:00<94PX92@XA9Q@00`T92P0400002A8:
2@T:2A8:1@T92P042A8:2@T:4A`:00000`T92P052A8:00002A8:2@T:0000
00892@X00`0000TB2PT92P022@T:00D92A@92@X92@X92A@92@X00PT9500?
2A8:2@TD2@TD2@T:00002A8:4BHD4A`:2@T:4A`:4BHN2@T:4A`:2@T:4A`:
00892@X02A4L2PT92Q4L2QX92PT92Q4L2P0000T92QX92P024A`:00HJ4Q@A
70XJ2@X92A@A70XJ4Q@26RHD00<J4Q@J9Q@S;ah00R<_7P0:;2HD8blN8blN
6Q`N;1`D6Q`N4BH:8bH:6RHD4BHD0Q4L2P032@TD2@T:2@T:00`92@X0114L
2PT92PT92Q4L2PH92@X00`TB2PT92PT92P032@T:00@A70X92@X0002VZZeQ
c<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<
00?oooo<c<c<c<`0GLc<c0066Q8D2A`D4BHD2@T:6Q8D2A8:0Q4L2P082@TD
4A`:2@TD4A`:2@T:2A8:2@T:2A8:2`T92P0400002A8:00002A8:0`T92P03
00002A8:2@T:00<92@X00`0000TB2PT92P022@T:00PA70X92@XA70XA70X0
00092@X94PXA70X22@T:00<A70X92@X92@X01@T92P084A`:;1804A`:8a`:
2A8:4A`:6PT:4A`:0`T92P0500002A8:00002A8:2@T:00<000022@T:00<0
00092@X000000PTB2P0500002@T:000000002@T:00<000001@T92PTB2P00
00T92P0000026Q8D00=?Ie`92A@94PX00PTB2P0300002@T:2@T:00<92@X2
2A8:0PT92P0300002@T:=2lN00892@X02`TB2PT92PT92PTB2P0000TB2PT9
2P0000T950TB2PT92P0200000PT92P044A`:00002@T:2@T:0P0000032A8:
00002@T:00D92@X010TB2PT92PTB2PT950894PX010T92PT951XB514V5089
2@X01@TB2R<_7PT92PTB2Q4L2P022A8:00L92@X94PXA9PXA70X92@X94PXA
70X00`T92P064A`:2@T:4A`:00002@T:2A8:0`T92P0<4A`:2@T:2A8:4A`:
2@T:2A8:2@TD6RHD6Q8D8blY6RHD8blY0Q4V2P8S;ah01AXB51XV51XL7QXB
52<L2P024A`:00<000092@X92@X060T92P074A`:2A8:4A`:2@T:4A`:0000
SHe_067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<
c1[<c<`00oooolc<c<c<c01Mc<c<00DA9Q@J71hJ4Q@A70X92A@00`T92P04
6Q8D2A8:2@T:2A8:0PT92P034A`:2A8:2A8:00<94PX22@T:00<A70X92@X9
4PX010T92P042A8:00002@T:2A8:0`T92P042A8:2@T:2@T:2A8:10T92P05
4A`:2@T:2A8:2@T:6PT:00<92@X010T950T92PT92PT92P894PX32@T:00<9
4PX92@XJ2@X00`T92P036PT:2@T:2@T:00894PX22@T:00<000092@X94PX0
0P0000032@T:2A8:000000892@X010TB2P0000T92P0000H92@X01`0000TB
2PT92PTB2P0000T92P0000022A8:00DJ2@Xd;c<92@X94PX000000PTB2P<9
2@X01@TB2PT92PTB2PT9514L2P022@T:00@94PXJ71h94PX000052@T:00LJ
4Q@94PX94PX000092@X94PX92@X00PTB2P042@T:00002A8:00000PT92P05
6Q8D00002@T:2@T:2A8:00892@X01@TB2PT950TB2PT950TB2P042@T:00/J
71hJ4Q@J4Q@94PX92@XA9Q@S;ahA9Q@J2@X0000A70X00`T92P056PT:2A8:
2A8:2@T:6PT:008A70X01AX92Q4L2PT92Q4L2PTB2P042@T:00<A70X92@X9
2@X01@T92P062A8:4A`:6RHD6RHD8bH:6PT:0R<_7P<J9Q@28bH:00<A70XS
70XA70X00PT92P0300004A`:000000H92@X00`TB2PT92PT92P0;2@T:00</
4P092@X92@X00`T92P034A`:0000UJ6>067<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00<J
4Q@92A@92@X00QXB50094A`:2@T:4A`:2@T:4A`:6Q8D2@T:4A`:2A8:00L9
2@X00`00014L2P0000022@T:00@000092@X92@X92@X22A8:00T92@X00009
2@X94PX92@X94PXJ4Q@92@X94PX00PT92P032@TD4A`:2@TD008A70X01AX9
2PT92Q4L2P00014L2P022@T:00H94PX92@X92@XA70X92@X000022@T:0Q4L
2P032@T:4A`:2A8:00894PX00`0000T92PTB2P022@T:0P0000032A8:2@T:
000000892@X0500000T92P0000T92PTB2PT9500000T92PTB2P0000TB2P00
00T92P0000T92PT9500000T92PTB2P00008J4Q@00`T92S@_<`0000022@TD
0`T92P076Q8D4BHD2@T:8d4m8blN6Q8D2A8:00<92@X00`0000T92PT92P02
2A8:0PT92P042@TD00002A8:00000PT92P0=2A8:00002@T:2@T:2A8:0000
2@TD2@T:2A8:00002A8:2@TD4A`:00@92@X22@TD00PJ4Q@92@X94PX94PX9
2A@94PXA9QhA9Q@26Q8D00@94PXJ9Q@/9Q@A70X22A8:0PT92P032A8:2@T:
4A`:00892@X24A`:00<92@XA70XA70X00Q4L2P082@T:4A`:6Q8D2@T:2A8:
2@T:4A`:2@T:0PTB2PD92@X00`TB2PT92Q4L2P024A`:00`J9Q@S;ahJ9Q@J
4Q@A9PXS;ahJ4Q@J71hJ9Q@J2@X0000A70X32@T:00@94PX92@X92@XJ2@X2
2@T:00<A70X92@X92@X00PT92P044A`:2@T:2@T:4A`:1`T92P032@TD2@T:
4A`:00892A@00`000:JHQ<c<c01Pc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0042A`D6Q8D
2@T:4BHD0`TB2P892@X01@TB2PT92Q4L2PT950TB2P032@T:0PTB2P892@X0
2QXB50T92P00000000TB2PT92P0000T92PTB2PT92P894PX22@T:00d00009
4PX92@X92@X000094PX000092@XA70X92@XA70X92A@J4Q@00Q4L2P046PT:
4A`:2@T:2@T:0P0000052A8:2@T:2@T:2A8:2@T:008000001`TB2PT92PTB
2P0000T92P0000TB2P022@T:00<000094PX92@X00PT92P0700002A8:0000
2A8:00002A8:000000892@X3000001<A70XJ2@X92@X000092@X94PX00009
2@X000094PX92@X000094PX92@X92A@A70XS@Cd94PX92A@010T92P062A8:
00006Q8DAUi76Q`N;2HD0PTB2P0500002@TD2A8:2@T:2A8:008000022A8:
00H92@X94PX92@X000094PXA70X22@T:00H000094PX92@X92@X000094PX3
2@T:00H000094PX92A@94PX92@X94PX22@TD00@94PX92A@92@X92@X22@TD
0QXB50092@TD2A8:2A8:6RHD4BH:4A`:2A8:00002A8:00892@X01`0000TB
2PTB2PT92Q4L2QX92Q4V2P024A`:00hA9PX/4P0A70X92@XJ2@XA70X92@XA
70X92@XA70X92@X94PX92@XA70X22@T:01494PX92@XA70XA70XJ2@X94PXJ
4Q@J2@XA9Q@A70X/9Q@J9Q@J4Q@J9Q@A9PX92A@A70X010T92P042A8:2@T:
2@T:2A8:2@T92P056PT:2@T:2@T:2@T:4A`:00D92@X01Q4L2PT92PTB2Q4L
2P000:J4Q67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
olc<c1[<c<`00oooolc<c<c<c01Mc<c<00<A9Q@94PXA9Q@00PT950052A8:
2@TD4A`:4A`:2@TD00<92@X32A8:0PT92P042A8:2@T:2A8:000010T92P07
00002A8:2@T:2@T:00002A8:000000@92@X00a4V2PTB2PTB2P032@T:0PTB
2P054A`:6Q8D4A`:4A`:2A8:008A70X0200000TB2PT92PT92P00014L2P00
014L2PD92@X01`TB2P0000TB2PT92P0000T92P0000042@T:00<000092@X0
00000`T92P042A8:0000000000000PTB2P<92@X03P0000T92PTB2PTB2P00
00T92P0000T92P0000TB2P0000T92PTB2PT92P<92A@03PTB2PT92PT92PTB
2P0000T9514V7TIEDQXL7QXV50T92P0000T92P0000892@X0300000TB2PT9
2P0000T92Q4L2P0000TB2PT92PTB2PT92P0000894PX92@T:00L000092@X0
00094PX92A@94PX92A@00PTB2P892@X22@TD0Q4L2P052@T:2A8:2A8:4BHD
8blN008000000`TB2PT92P0000032@T:00`A70XJ2@XA70XJ4Q@A70XJ4Q@A
70XJ2@XA70XA9PXA70XA9Q@34A`:00L92@XA70XA70XJ4Q@A70X92@XA70X0
0PT92P054A`:6PT:2A`D4A`:8a`:008A70X26PT:00HA70XJ4Q@J9Q@J4Q@J
9Q@A70XD2@T:00<J2@X92@X92@X01PT92P054A`:6PT:2A8:0000UJ6>067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`0
0oooolc<c<c<c01Mc<c<00<A9Qh92@X92A@00QXB50052A8:2@TD6Q8D2@TD
6Q8D00892@X00`TB2PT92PT92P022A8:00H92@X94PX92@XA70X92@X94PX5
2@T:00`94PX92@X92@X0000A70X92@X94PX92@X000092@X94PX000032@T:
1@TB2P06;1804A`:6PT:2A8:4A`:6PT:0PT92P0500002@T:2@T:00002A8:
00<92@X02@TB2P0000T92PT92Q4L2P0000TB2P0000TB2P02000000/94PX0
00094PX000094PX000094PX000092@X000092@X00P0000<92@X010TB2P00
00T92P0000892@X010TB2P0000T92P0000892@X03`0000T92PTB2PT950TB
2PT92PTB2P0000T92PTB2P00014V52<_:B<_<`0000022@T:00<000094PX9
2@X01@T92P062A`D00002@T:00002A8:00000PT92P80000010TB2P0000T9
2PTB2P892@X01@TB2PT92PTB2PT92PTB2P022@T:00DA9Qh92A@92A@94PX9
2A@00PTB2P036Q8D2@TD2@T:00892@X010TB2PT92Q4V51X92P@92@X06@TB
2PT92QX92PT92PTB2Q4L2Q4V514V2R<_7QXV52`L514V2QXB514L2QXB51XV
51X92Q4L2QX92Q4V514L2QX92Q4L2Q4V2QX92P034A`:00<92@XJ9Q@S;ah0
0QXV5005;1`D8a`:4A`:4A`:2A8:008A70X26RHD00@94PX92@X92@X94PX2
2@T:00L94PXS70X92A@J4Q@94PX92@XJ2@X01PT92P042@TD2@T:2A8:4A`:
10T92P082A8:2@T:4A`:2@T:6Q8D6PT:0000YZ6HHLc<c004IVIVR<2hR<2h
B9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<
c<`05AXB514L2PTB2PTB2QXB50T92Q4L2PT92PTB2QXB50TB2PT92PTB2QXB
50TB2P0000TB2P0000T92PTB2P0000032@T:00L94PX92@X92@X000094PX9
2@X94PX00PT92P0300002@T:2A8:00<92@X01@TB2PT92PTB2PTB2P000003
2@T:00DA70X92@XA70X92@X/4P000PT92P034A`:2@T:2@T:00892@X01000
00T92PTB2PTB2P892@X2000000h92@X94PX000092@X000092@X94PX92A@0
00092@X000092@X000092@X2000000H92A@92@X000092@X000092@X20000
00H94PX000094PX000094PX000042@T:00D000092@X000094PX000000PT9
2P042A8:2@T:2@TD00000`T92P894PX0100000T92PT92P0000H92@X00`TB
2PT950T92P022@T:00D000092@X000092@X94PX00`T92P0400002@T:2@T:
2A8:0P0000D92@X01AXB50T950T950TB2PT950022@T:00<A70X94PX94PX0
0P0000042@T:2A8:4A`:2A8:0PT92P032A8:00002@T:00<92@X01Q4L2R<L
2R`V52<_7QXV52<V2P8S;ah26RHD00<S9PXJ4Q@A70X00Q4L2P05;1`D8bH:
4A`:6Q8D4BH:008A70X02QX92Q4L2Q4V2R`V52<_:B`B02<V2QXV514L2R<L
2P8J2@X24A`:00<J9Q@A9PX0000010T92P032A8:6Q8D2@T:00892@X00aXB
50T92PT92P052@T:00<94PX92@X92@X010T92P8A70X22@T:00HA70X92@XJ
2@XA70X92@ZEQ8iQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0054A`:2@TD2A8:2A8:2@T:
00@94PX02@T92PTB2Q4L2PT92Q4L2PT92PTB2PT92PTB2P022@T:00D94PX9
2@X92@X92@X000000PTB2P<92@X01`0000TB2P0000TB2P0000T92P000002
2A8:0`T92P894PX010T92PTB2PT92PT92P8A70X01b`B014L2Q4L2Q4L2QX9
2PT92Q4L2P042@T:00@000094PX92@X94PX22@T:0P0000032@T:00000000
0080000070TB2PT92P0000TB2P0000TB2P0000TB2PT92P0000T92P0000TB
2PT92P0000T92PTB2P0000T92P0000T92P0000T92P0000TB2P0000T92P00
00892@X01`0000T92PT950T92PTB2PT92P0000022@T:00<94PX92A@94PX0
0PT92P072A8:2@T:2@T:2A8:2@TD4A`:2@T:00@92A@01@T92P0000TB2P00
00TB2P032@T:00<000092@X000000PTB2P892@X010TB2PT92PT92PT92P89
4PX010T950TL7PT950TB2P892A@22A8:00<971@92@X92@X00`T92P034BHD
2@T:2@T:00L92@X01A4L2QXV52<_7R`h:AXV50028blN00/J9Q@S9PXS;ahS
9PXS;ahS9PXJ4Q@S9PXJ9Q@S;ahA9PX00QXV508J4Q@02A4V2Q4L2QXB52<_
7SAE:@T9514L2Ra<:AXV50024A`:00HJ9Q@A9PXA9Q@J9Q@d;bTA70X52@T:
00@J2@XJ4Q@92@XA70X92@T:00<J2@X92@XA70X00`T92P0;00002@T:2@T:
00002@T:2@TD2@T:4A`:2@T:0000YYR4067<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00@9
2A@92@XJ4Q@92@X22A8:00<92@X94PX94PX010TB2P892@X01`TB2PT951X9
2PTB2Q4L2PT92PTB2P032@T:00<A70X000094PX01PT92P032A8:2@T:2@T:
00892@X02000014L2PT92PTB2P0000TB2PT92PTB2P892@X01AX92Q4L2QX9
2Q4V2R`B00034A`:1@T92P0800002A8:2A8:2A8:00002A8:2@T:2A8:0PT9
2P0300002A8:2@T:00892@X0100000T92P0000T92P8000022A8:00h92@X0
00092@X0000A70X000092@X94PX000094PX000094PX92@X000022@T:00P9
4PX92@X94PX92@X94PX000092@X94PX42@T:00L94PX92@X94PX94PX92@X0
00094PX00PT92P892A@0214L2PT9514V50T9514_?@0000T92P0000@92@X0
0`TB2PT92PT92P032@T:00DJ2@X94PX92@X000094PX00PT92P062@TD6Q8D
2A`D2@TD6Q8D2A`D1@T950052A8:2@T:2@T:2@T:4BHD00@92@X00`TB2PT9
2PT92P024A`:00DJ4Q@J9Q@/>2T/>2TS;bT01R<_7P038bH:6Q`N8blN00<S
;ah00b<_:B<V2R<_7P026RHD00/A70XJ9Q@/>2U6C3d000094PX92A@d;ahS
;ahJ2@XS;bT00b<_7P05;4`Y6Q8D2A8:2@T:4A`:00892@X00aX92QXB50T9
2P052@T:00H94PX92@X92@XJ2@X92@XA70X52@T:00PA70X92@X92@X92@XA
70XJ2@XA70X92@X26Q8D00<0002VV6o<c<`0H<c<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`0
114V514L2PTB2QXB50892@X0214L2PT92QXB51XB50T92PTB2PT92Q4L2P89
2@X00`TB2PT92PT92P062@T:00D000092@XA70X92@X94PX00PT92P072A8:
2@T:2A8:2@T:2A8:;1`D4BHD00894PX32@T:0PTB2P892@X01A4L2PT92Q4L
2Q4L2PT92P024A`:00T94PX92@XA70X92@XA70X92@X94PX000092@X00PTB
2P046PT:2A8:2A8:00000PT92P042A8:00002@T:2@T:0PTB2P0700002A8:
00004A`:2@T:2A8:000000892@X01P0000TB2P0000T92PTB2P0000<92@X0
2P0000T92PT92P0000TB2P0000T92P0000TB2P0000892@X22A8:0`T92P<9
4PX62@T:00XA9QhS;c<92A@A;c<S;c<J71hA9QhA70X92@X94PX42@T:00<9
4PX92@X94PX00`T92P032@TD6Q8D2@TD00<92@X02QXB50TB2PTB2PTL7PTB
2PT950TB2PT9514L2PT950894PX01@0000T92PT92PT951XB50052@T:00DA
70XJ4Q@A70XJ2@XA70X00b`h:@03;4`Y6Q`N6RHD00<S;ah012`V51XV52<_
7SAE:@<S;ah00b<V2R<_7R<_7P028blN00PJ4Q@J9Q@dEBTdEBT0000J4Q@9
2A@d;bT2;3PY00Ld;ai6@AhdEBTS;ahS;bT0000A70X00PT92P044A`:2@TD
6Q`N4A`:0`T92P034A`:2@T:;18000@92@X00a4L2P0000TB2P034A`:0`T9
2P046PT:2@T:2A8:6PT:0PT92P044A`:6PT:0000CeiVHLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<
05g<c<`00`TL50T950TB2P032@T:00L94PXA70X92@XA9Q@971@J4Q@94PX0
0PT92P034A`:2@T:2@T:00H92@X01Q4L2PT92PT92PT92PTB2P0000<92@X0
1PTB2P0000T92P0000TB2P0000<92@X22A8:00L0000J2@XA70X0000A70X9
2@XA70X00PT92P052A8:00002@T:2@T:6PT:008A70X00`00014L2PT92P03
2@T:0PTB2P036PT:2@T:2@T:00<92@X2000000X92@X000092@X000092@X0
00094PX000092@X000022A8:0PT92P0=2A8:00002@T:2@T:00002A8:2@T:
00002A8:2@T:00002@T:2A8:00<92@X22A8:00T000092@X94PX92A@94PX9
2A@000092@X94PX00PT92P0;2A8:00002@T:=5Dm6Q`N6PT:CeiVJW^4;6ML
00002@T:0080000020T92P0000TB2P0000T92P0000T92P0000892@X00a4L
2PT92QXB50032@T:00@A70X94PX92A@92A@22@T:00H94PX92A@92@X971h9
2A@94PX22@T:00@94PX92@X92A@94PX22@T:00@A70XS70XA70X94PX32@T:
0R`h:@04AT`m=2lY8blN6Q8D0R<_7P07;2HD6RHD8blN=5DY;4`Y;2HD8bH:
008/>2T00b<V2R<_7R<_7P028blN00P/71@/>2TdEBT92A@A70X94PY6@Ai6
GTL2=5DY00@/C2TS;c</9Q@A70X22@T:00<94PX92@X92@X00Q4L2P@92@X0
200000T92PT92QX92PT92Q4L2PT92Q4L2P892@X00aX92PT92PT92P092@T:
00@J4Q@92@X92AAP@BUQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c00>4A`:6Q8D2@T:2A8:
6Q8D4A`:2@T:6Q8D4A`:2@T:;1`D6Q8D2@T:4A`:0PT950034A`:2@T:2A8:
008A70X00`T92Q4L2PTB2P022@T:00@94PX92@X0000A70X52@T:00P94PX9
2@X000094PX92@X94PX000092@X3000000<92@X94PXA70X00PT92P034A`:
2@T:2@T:00892@X01A4L2P00014L2PT92Q4L2P052@T:00<000094PX94PX0
10T92P0400002A8:2@T:2A8:0P00000A2@T:00002A8:00002@T:00002@T:
00002@T:00002@T:00002A8:00002A8:2@T:000000894PX0100000TB2P00
00T92P8000003PTB2PT92P0000TB2P0000TB2P00014L2P0000TB2PT950T9
2P0000TB2P892@X03`TB2PT92Q4L2PT92R`L514_?Cd_?BaEK`TB2P0000T9
2PTB2P0000TB2P0000022A8:0PT92P894PX01`T92Q4L2PT952`h:@T92PTB
2PT92P022@TD00DJ4Q@94PX92@X94PX92@X00`T950052@T:00002A8:2@T:
000000894PX22@T:0PTB2P0<2@T:00002A8:2@T:2A8:00008bH:=5DY=2lc
=5DY;3PY4A`:0R<_7P066RHD8blN8blN=2lY;4`Y8blY0R<_7P048bH:;3PY
8blN=2lN0R<_7P08;3PYAUDY=5DY00002A8:8blN?Ehm8blN0aXV50036Q8D
4A`:000000D92@X00aX92PT92PT92P052@T:00H000092@X92@X94PX92@XJ
2@X22@T:00@S70X92@X92@X94PX82@T:00@A70X92@X0002`NfIQc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<
c<c<c<`0GLc<c00@2@TD6Q8D2A8:4A`:2@TD2A8:4A`:2@TD4A`:2@T:8blc
2@T:4A`:2@T:2A8:4A`:0PT92P034A`:2A8:2@T:00<92@X22A8:00@92@X0
00094PX94PX22@T:0`TB2P0400002A8:2@T:2@T:0P00000:2A8:2@T:2@T:
2@T:6Q8D2@T:4A`:2@T:2A8:4A`:0`T92P042A8:2@T:2A8:2A8:0`T92P04
4A`:2@T:2@T:4A`:0PT92P8000001PTB2PT92PTB2PT92PTB2PT92P800002
2@T:00D000094PX000092@X000000`T92P0A00006Q8D00002@T:00002A8:
00002@T:2A8:2@T:00002@T:00002A8:2@T:00002A8:00@92@X020T950T9
2PT9500000T950T92P0000T92P894PX02@0000TB2PT92PT92PTL50T92Sd_
?H>=Q6YkQ0022@TD00H94PX92@X000092@X000094PX2000010T92P070000
4A`:6Q8D2A`D2@T:00002A8:00892A@00`TL50T92PTB2P032@TD00<94PX9
2A@94PX01@T92P042@TD4A`:4A`:2@T:0P0000064A`:00002A8:00002@T:
8a`:0TI<?@04=5DY;3PY4BHD6Q`N0b<_7P056Q8D;3PY=2lY6RHD8blN00@/
>2T38blY00Y6EBU6C3dA9Qh92@XJ4Q@/9Q@971@92@XJ9Q@92@X24A`:10T9
2P034A`:2@T:2@T:00`92@X00a4L2PT92PT92P032@T:00<J2@X92@X92@X0
1PT92P056PT:2@TD4A`:0000b]31067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c?mVIVHFIVIV00?oooo<c<c<c<`0GLc<c004
6Q8D4A`:2@T:2@TD0`T92P074A`:2@T:2@TD2@T:2A8:2@T:6Q8D00@92@X0
0`TB2PT92PT92P022@T:00<94PX92@X92@X010T92P894PX00`0000T92PTB
2P022@T:00H94PXJ2@X94PX000092@XA70X32@T:00<94PX92@X92@X00`T9
2P0300002@T:2A8:00892@X01@TB2PT92PT92Q4L2QX92P042@T:00@00009
2@X92@X000082@T:00<000092@X000000`T92P0400006PT:2@T:00000PT9
2P0500002@T:2@T:00002@T:008000000`T92PT9500000022@T:00<94PX0
00092@X01`T92P0500002@T:2@T:2A8:000000D92@X01@T9500000TV:BaW
G0TL7P022A8:00<000092@X92@X01PT92P0300002@T:2@T:00H92@X02@TB
2PT950T950T950T92PTB2PTL51XB50TB2P022@TD00<92@X94PX92@X00PT9
2P052A8:2@TD2@T:2A8:000000H92@X00`0002<_7TI17P02?Ehm00<d;bTS
9PXA9Qh012<_7P96EBT01R<V2R<_7R`h:B`V52`h:CAE:@8J9Q@01C@_:DIN
AcAE:@TL50T92P024BHD00<92@XA70X92@X00Q4L2P032A8:2@T:2@T:00X9
2@X00`TB2PT92PT92P072@T:00<J2@X94PX92@X02PT92P044A`:2@TD0000
`K>]HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<
00=VIVK<c<bIVIT01iVIV@Soool00okno_ooooknoP02m_Kf00?^k^kQhN7N
g]h00m[JfP?IfMU2f=SH2=WIf@06e]KFfm_Ki>CTk>c/lo?cnOWi0_ooo`?n
o_h6ooooVYVIV@03ooooc<c<c<c<05g<c<`01@T92Q4L2PTB2QXB50T95002
2A8:00D000092@X94PX94PXJ4Q@00PTB2P034A`:2@T:2A8:00894PX01a4L
2PT92PT92PT92QX92PT92PTB2P032@T:00H94PX000092@X92@X94PX00003
2@T:00@94PX92@X92@X94PX52@T:00DS;bT94PX92@X92@X94PX01@T92P05
2A8:2@T:4A`:0000=2lY00P92@X00a4L2PT92PT92P092@T:00<000092@X9
2@X00PTB2P@92@X00`0000T92P0000042@T:00@000094PX94PX000032@T:
00<94PX92@X92@X010T92P032A8:2@T:2@T:00D92@X00`0000T92PTB2P02
2@TD00L000094PX971@000092A@92@X000001`T92P0500002@T:2@T:2@T:
2A8:00<92@X02aXB50TB2QXB50T950T92QXB50TL51XB50T950TL50T95002
2@T:00D94PX92@X92@X92A@A70X00`0000<92@X02@TB2PT92PT92PTB2QXV
53AE:DIE:DIEDSAE:@038blN00D/>2TJ9Q@/>2Td;bTdEBT00R`h:@0?=5DY
;3PY;4`YAT`m=2lY;3PYJW9LH5hc8blN00004BH:2@TD2A`D2@T:6PT:008A
70X42@T:00DA70X92@X92@X92@XA70X00`T92P054A`:6PT:2@T:2@T:4A`:
00@92@X01AX92PT92PT92PT92QX92P032@T:00<A70X92@X92@X00PT92P07
6PT:2@T:4A`:2@T:4A`:0000UHB>067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT8oooo00[lo?cn
o_kbl_;Shn?OgmoHf=S=cLg:b/[0`<2o_kl2_[jn00Bm_Kfl_;bk^k^k^k]8
_[jn00S0`<37alO?cloEeMGKfm_UiNGclo?moOd3o_kn1_oooiZIVIT00ooo
olc<c<c<c01Mc<c<00<A70X92@X94PX00PTB2P042@T:2A8:2A8:4A`:1@T9
2P072A8:2@T:4A`:00002A8:2@T:0000008A70X00`0000T92PT92P032@T:
00<94PX92@X92@X00`T92P0A2A8:2@T:2@T:00002A8:2@T:4A`:2@T:2A8:
2@T:2A8:2@T:2A8:2@T:2A8:2@T:2A8:00@92@X26Q8D00DA70X92A@92@XJ
71h0000010T92P0=4A`:2@T:00002@T:00002@T:00004A`:00002A8:2@T:
2A8:4A`:008000000`TB2P0001XL7P0200000PT92P042A8:00002A8:0000
0PTB2P052@T:00002A8:2@T:000000894PX0200000T92PT92PTB2PT92PTB
2PT92PTB2P<92@X00`0000TB2PTB2P032@T:00<94PX92@X92@X00PT92P06
2@TD2@T:2@TD2A`D2A8:00000`T92P0500002@T:00002@T:000000H92@X0
0`TB2PT92PTB2P022@TD00@971@94PX92@X94PX22@T:0`T950032A8:2@T:
000000894PX00`T9500000T92P092@T:00`S;ah/>2U6C3e6EBU?IdLd;bTS
;ahJ9Q@S9PX/>2TS;ah/>2T2;4`Y00<d;bT/>2T/C2T00TI17P04=2lYAUDY
LVMBEfMB0PTB2P074A`:8blY4BHD8blN6RHD4A`:2A8:00892@X00`0000T9
2PT92P072@T:00<000092@X92@X00`T92P036PT:4A`:2@T:00892@X01@TB
2PT92PT92PT92QX92P042@T:00TA70X92@X92@XA70X92@XA70X94PX0002V
V8@0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<
00=VIVK<c<bIVIT01iVIV@Soool02OCdm?;bl]kNg/S8b<30`;Rh^:j^[Z^[
Zj2PX002WinO00FMWIfLW9bKVi^JVYZIVIT0@9ZJVPRKVi/02:>SXj^[Zk:b
/[Fe]K^k^l[:b]oOgng]k@?no_h6ooooVYVIV@03ooooc<c<c<c<05g<c<`0
0`T9514L2PT92P022@T:0PTB2P<92@X22A8:00L92@XA70X92@XA70X92@X9
2A@J2@X00`T92P0300004A`:2@T:00892@X01@TB2PT92PTB2P00014L2P02
000000l92@X000094PX92@X94PX000094PX000094PX92@X000094PX92@X9
4PXA70X00PT92P034A`:2@T:2@T:00892@X0214L2PTB2PT92R`V51XB514L
2PT92Q4L2P894PX00a4L2P0000T92P032@T:00@94PX92@X92@X000032@T:
0P0000892@X2000000<A70X92@X000000PT92P0800002@T:2@T:2@T:0000
2@T:00002@T:0P0000062A8:000000002A8:2@T:2A8:0PT92P0300002@T:
2A8:00892@X020TB2PT92Q4V2PTB2P0000T950T92P0000892@X01PTB2QXB
50TL50TL7PT92P0000D92@X00`0000T92P0000022@T:00T000094PX00009
2@X94PX92@X000092@X94PX010T950032A8:2@T:2A8:00892A@00`T92PTB
2PT92P022@T:00@000094PX94PX94PX22@T:00/000092@X94PX92@X94PX9
2@XA70X/71@/>2U6C3dmGSd00TI<?@038blY8blN;3PY008/>2T01CAE:DI1
7S@_<ba<:DI17P02;3PY00//GSdS;bUGEE9ZNfldEBT000092A@0000S;ai6
EBT/C2T01@T92P032A8:2@T:2@T:00X92@X00`0000T92PT92P022@T:00DA
70X92@XJ2@X92@X/4P000`T92P042A8:2@T:2@T:4A`:10T92P052A8:6PT:
6PT:0000UJ6>067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2h
R<2h1<c<c003IVIVc<c<VIVI00NIVIT00ooooogmoOooo`04oooo00gemOGN
g]k?clno_kna/K6UYJFGUiN<S8b7QhN9RHV8R8R5QHF1PH400WemO@03Ogmo
PH61Ogmo03moOgl3P82000mnOWimOGeoOgn4Q8B9RHV7QhN:RXZ>SXjEUIFP
X:2`/;33`l?AdM7Ti>Cbl_800_knoP03o?cloooooooo00;ooonJVIVI00?o
ooo<c<c<c<`0GLc<c0056Q8D4A`:2A8:6Q8D2A8:00<92@X01Q4L2PT92PTB
2PTB2PT92QXB50<92@X00a4L2PT950T92P022@T:00<A70XJ4Q@92@X00PT9
2P0300002@T:2@T:00892@X01@TB2PT92P00014L2P0000072@T:00/94PX9
2@X92@XA70X0000A70X94PX92@X0000A70X000000PT92P0600002@T:2@T:
2@T:2A8:000010T92P8A70X42@T:00L94PX92@X000092@X94PX92@XA70X0
10T92P0400002@TD00002A8:10T92P0600002@T:00002A8:2@T:000010T9
2P032@TD00002@T:00@92@X00`TB2PT92PTB2P022A8:0PT950032A8:2@T:
2A8:00<92@X00`TB2PT950TL50022@TD00T92@X92A@0000A70X92@X00009
4PX000094PX00PT92P052A8:2@T:2@T:2A8:000000892@X32A8:00<92@X9
4PX92A@00PT950054BHN2@TD2A8:2A`N2@TD00892@X01PTB2PT92PT92PT9
2PTB2P0000<92@X020TB2PT92PTB2PT92Q4L2PTB2R<_7R`h:@96C3d00dIE
DTIE:B`h:@028blN01TdEBTd;bTd;c<dEBTd;c=6C3ddEBT/>2TdEBT/C2UG
EE9GSEaPGS<S;ah92A@00016@AibSCd/C2T000094PX92@X000092@X94PX0
4@T92P036PT:2@T:2@T:00@92@X01`TB2PT92PT92PT92QX92PT92PTB2P02
2@T:00HS70X92@XJ2@X92@X0002VXIQQc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI01Soooono_ko
oooooookno_jn_[bl_;Rh^;Fe]K7alNc/k>OWin<S8akNg]cLg=bLW9aLG5b
LW9cLg=bLW9`L71_Kfm`L71aLG4hL71`275aL@0CKVi^L71`LG5aLG5aKfm_
L71`LW9bMGEeO7alL71`KVi^OGemT92@WYjN/;2``<30clo?hn?Sn?Sh00;o
ool01?kno_gmoOclo?oooiZIVIT00oooolc<c<c<c01Mc<c<00<92A@92@X9
2@X00PT92P032A8:2@T:2@T:00894PX01`T92P0000T92PTB2PT92QXB50T9
2P032A8:00@J4Q@A70X94PXA9Q@22@T:00L94PX92@X94PX92@X94PX00009
2@X00PTB2P0400002@T:2A8:00000PTB2P0500004A`:00002@T:00000089
2@X22A8:00@92@XA70X94PX000062@T:00@000092@X000094PX22@T:00L9
4PX92@X92@X92@X94PX92@X000000`T92P042A8:00002A8:000010T92P0;
2A8:00002A8:00002@T:00002A8:00002@T:00002@T:008000032@T:00@0
00092@X000094PX22@T:0PTB2P0300002@T:2@T:00892A@00`TB2PT950TB
2P022@T:00H000092@X94PX92@X92A@94PX32@TD00H94PX92@X000092@X9
4PX000032@T:00<94PX0000000000PT92P0700002A8:00002A8:00002@TD
2@T:00894PX020TL7PT952`L52=1?@T950TL7PTL50T950894PX01@0000T9
2PTB2PTB2P0000032@T:02D94PX000094PX94PXA70XJ2@XA70XS;ah/C2Tm
;ce6@AhdECdmGSdS;ah/C2Td;bU6C3ddEBU6C3e?IdM?Ie`dEBU6C3dd;c</
>2TS;aiPGS=?IdLmGSd/C2T0001ZEAj3Ne`971@000092@X94PX00PT92P03
00006PT:2@T:00<92@X00`TB2P0000T92P0;2@T:00<94PXA70X92@X00PT9
2P032A8:2@T:2@T:00@92@X22A8:00L92@X94PXJ2@X92@XA70X0002VV8@0
HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT01iVIV@0Coooono_kooooooooo_knn_[jk>c/emOG^[ZjYJFU
Shn?QhN7SHf=Vi^KZJVY];Bde=CDemOGg=cL00;Ogml00mgMgMcLg=cLg00h
g=cL2=kNgP05f][Jg=cLg]kNg]kNgMgM00;Kfm/03=cLg<g=cKRh^:BTY9RH
V8R8R861PIFEUKBd];bl_=?Cdno_k`Coool00ogmoOoooiVIV@2IVIVI00?o
ooo<c<c<c<`0GLc<c0054A`:2@T:4A`:4BHN2@T:00894PX00a4L2PT92Q4L
2P032@T:0PTB2P046Q8D4A`:2@T:2A8:0`T92P072A8:00002@T:2@T:0000
2A8:000000894PX22@T:00P000094PX92@X92@X0000A70X000092@X22A8:
1PT92P894PX01@0000T92PTB2PTB2P0000022A8:10T92P0:4A`:2@T:0000
4A`:2@T:00002A8:2@T:00002A8:0`T92P0500002A8:00002A8:000000@9
2@X04@0000T92PT92P0000T92P0000T92P0000TB2P0000T92P0000T92P00
00TB2P0000T950022@T:00@000094PX92@X92@X22A8:00H92@X94PX92@X9
4PXA9Qh92A@32A8:00D92@X94PX92@X94PX971@00PT950072A8:2A`N2@TD
2A8:00002A8:000000894PX22@T:00P000092@X92@X92@X000092@X00009
4PX22@T:018000092@X92A@92@XA9Qh/71@J71hm;cd92A@971@971h94PXA
70X92@X94PX92A@A9Q@92A@22A8:00@92@X000094PX92@X22A8:02<A70XA
9Q@J9Q@d;bU6EBTdEBU?Ieb3Q7]6C3ddEBTS;bU6C3e6@AhdECeGEE9?Ie`m
GSe6C3e6GTM6EE9?IdLS;aiPGS=?IdMZLU`00016EBV=SFl/GSd000092@X9
4PX92@X000094PX00PT92P056PT:2@T:4A`:2A8:4A`:00L92@X00a4L2PT9
2PT92P022@T:00D94PX92@X94PX92@XJ2@X010T92P032A8:2@T:2@T:00D9
2@X01A4L2PT92QX92P0009FQSP1Qc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI00?no_kkno_oool0
0_ooo`0>m_Kfh^;RalO7/K6aVYZJR8R8TI6A[Zj^bl_;fm_KhN7QgMgMh^;R
inOW0^_[j`03j^[ZjNWYjNWY03SZj^X8jn_[00KYjNWZj^[[jn_Zj^[YjNWX
j>P2inOW00gQhN7OgmoMgMgAdM6c/k>CTi>:RXZCTi>/[:c3`l?Ph>3dm?Cm
oOd01?oooiZIVIT00oooolc<c<c<c01Mc<c<00H92@XA9Q@92@X94PX92@X9
4PX62@T:00TA70X92@X92@XJ4Q@92@X94PX92@X94PXA70X00PT92P030000
2A8:2@T:00D92@X01@0000TB2PT92P00014L2P022@T:00H000094PX94PX9
2@X000092@X62A8:00P000092@X94PX92@X000094PX92@X000042A8:0P00
00072@T:00002@T:2A8:00004A`:000000<92@X01a4L2PT92PT92PT92P00
00T92PTB2P032@T:00<A70X92A@94PX00`T92P072A8:2@T:00002A8:0000
2@T:000000<92@X01`0000TB2P0000TB2PT92P0000TB2P022@T:00D92A@9
2@X92A@92A@971@00PT950032A8:00002A8:00@92@X01@TB2PT950TL7Q4V
51XB500200000PT92P80000020TB2P0000TB2P0000T92P0000T92PTB2P<9
2@X22A8:014971h92A@971hS@Cd/EE`J2@XA;c<971h92A@A9Qh92A@92@X0
000A70X94PXJ4Q@971@00P0000032A8:2@T:2@T:00892@X01A4L2QXB52<_
7Q4V2R<_7P02;4`Y01PS;ai6GTMGIe96C3e6@Ai6EBU6C3ePGS=?IeaPGS=6
EE9?IdM6C3ePGS<dEBTd;aiPGS=bLW//GSdJ2@Z=SFl/GSd000092@X22A8:
00<000094PX92@X030T92P0300002@T:2@T:00@92@X031X92PT92PT92Q4L
2P0000T92Q4L2P0001XB500001X92PTB2P@92@X01Q4L2P00014L2PT92P00
0:JHQ67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<
c003IVIVc<c<VIVI00NIVIT4oooo017gmoOWinO;bl^/[:bJVYZFUYJMWIfd
];C>c/kKfm_MgMgJf][Vi^KYjNW]kNg_kno`l?000^o_k`03l?3`lO7alO7a
03kalO401??clo;bl_3`l>o_k`;^k^h2kNg]0]oOg`0=gMgMemOGc/k>^[Zj
WYjNQXJ6VYZJ[Zj^c<c<inOWm_Kfno_ko_kn00;ooom:VIVI0`0004fIVIT0
0oooolc<c<c<c01Mc<c<00@A70X92A@94PX92@X32A8:0PT92P082A8:2@T:
00002@T:2A8:2@T:2A8:00000PTB2P0300002A8:2A8:00@94PX22@T:00D9
4PX92@X92@XA70X000000PT92P0400002@T:2@T:2A8:0P0000<92@X20000
0`T92P894PX22@T:00X94PX92@X92@X000092@X000094PX000092@X94PX2
2@T:00H94PX92@X000094PX92@X94PX22@T:00<000092@X92@X00PT92P0G
2A8:00002@T:2A8:2@T:2A8:2@T:H44Y2A8:2@T:4A`:00002@T:00002A8:
00002A8:00002A8:00002@TD00002A8:008000000`T92P0000T92P032@T:
00P92A@971@94PX92A@A9Qh94PX92@X94PX22@T:00T94PX92@X92@X94PX9
2A@94PX971@94PX000000PT92P032A8:00002@T:008000001PTB2PT92P00
00T92PTB2P0000<92@X00`TB2P0000T92P022@TD00mZNh@A;ceGEE899RTA
;c<971hA9QhA;cd92@X94PX92@XS;ai6C3dS;bT92A@00PT92P062A8:0000
2@T:2@T:4A`:6RHD0R<_7P0<4A`:8blY=2lY=5DY;4`Y=2lcAT`m=5DYAT`m
?EhmAUEBAT`m1DmWA`0;?Ehm8blNAT`mLXeLNheV0000LXeL;4`Y00002@T:
2A8:008000042@T:00<000092@X92@X04`T92P044A`:2@T:2@T:4A`:10T9
2P032A8:2@T:2@T:00<92@X0114L2PT92P00079bNf7<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT4
oooo00_alO7MgMg0`<2QXJ65QHFEUIF^[Zk5aLGAdM7GemONg]h00^KViP03
jNWYjn_[k>c/00?/k>`00nk^k^o_kno_k`0fkno_2>g]k@04l_;bkno_kNg]
jn_[0^c/k00@jn_[j^[Zl?3`kNg]h>3Pclo?alO7`L71/K6aWYjNT92@XJ6Q
_knoh>3PmOGeo?cl0_gmo@03ooooVIVIVIVI04ZIVIT20000C9VIV@03oooo
c<c<c<c<05g<c<`02A4L2PT953@_<`TB2PT92PTB2PT92PTB2PT92P042A8:
00D92@X94PX94PX92@X94PX00`T92P092A8:000000002@T:2A8:2@T:4A`:
00002A8:00892@X00`TB2PT92PT92P052@T:00<94PX92@X94PX01PT92P05
2A8:2@T:4A`:2@T:2A8:00L92@X01P0000T92PTB2P0000T92P0000892@X0
100000T92PT92PTB2P892@X01`TB2PT92PTB2P0000T92PTB2P0000032A8:
00<S9PX92@X94PX00PT92P894PX0300000TB2P0000T92P0000TB2P0000TB
2P0000T92PT9500000892@X00`TB2PT92PTB2P032@TD00<94PX971@94PX0
0`T92P@94PX01PT950TL7PT950T950T92PTB2P<92@X00`TB2P0000TB2P02
000000D92@X94PX000094PX92A@00`T92P894PX030T950T92QXV58>H[DmN
IUN=SPTB2PTL7PTL50TL7PTL50T92P8A70X01`T954I<?B<_:@TB2P0000TB
2P0000022@T:00HA70XA9PX/>2T/C2TS;ahJ4Q@3;3PY00<S;bU6C3dmGSd0
0TINA`03AVMLCfM7AUEB009?IdL2EfMB00TmGSd/9QA6C3eZIc=kSFH94PYZ
Ic>3Q7/000002@T92P052A8:2@T:4A`:2A8:000000<92@X00`TB2PT92PT9
2P022@T:00<0000A70X92@X010T92P074A`:2@T:2@T:2@T:6PT:2@T:4A`:
00@92@X0114L2PT92PT92R<L2P892@X00a4L2P0008>4N`1Qc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07
VIVI01Coooono_koooono_k/k>cFe]Jj^[ZLW9bHV9RTY:Be]KG3`l?8b<S=
cLgJf][Xj>SUiNGWinOZj^[/k>`4jn_[>>g]k@S/k>`01>k^k^c/k>_[jn_[
j`;/k>`04>WYjNKVi]CDe=[Jf]kNg]SHf<c<c;jn_Zj^[Z>SXi:BTYbLW;Bd
]=GEeO3`l?clo0?oool4VIVI0P0000BIVIT2000019VIV@@00002VIVI0P00
00:IVIT200000YVIV@800006VIVI0P0000>IVIT200000YVIV@800002VIVI
100000JIVIT500000YVIV@800002VIVI0P0000:IVIT300000YVIV@800002
VIVI100000:IVIT200000YVIV@800006VIVI0P0000BIVIT400000iVIV@<0
0002VIVI0P0000>IVIT400000YVIV@80000DVIVI00?oooo<c<c<c<`0GLc<
c0032@T:4BHD2@T:00894PX32@T:00HA70X94PX94PX94PX0000A70X22@T:
00<94PX92@X94PX010TB2P032@T:2A8:2A8:00894PX01`T92PTB2PTB2P00
014L2P00014L2P022@T:00X94PXA9PX92@X000092@X000094PX92@XA70X0
00032A8:00<92@XA70X92@X00PTB2P034A`:6PT:2A8:00892@X01a4L2PT9
2PTB2P0000TB2Q4L2P0000022@T:00@94PX92@X92@X000022A8:00<00009
4PX94PX010T92P056PT:2A8:2@T:2@T:2A8:00<92@X2000000PA70X00009
4PX94PX000094PX000092A@32@T:00@000094PX94PX94PX22@T:00H92A@9
71h94PX971h971@92A@32A8:00d92A@94PX92@X92A@971h971@971h92A@9
2@X000094PX000094PX01`T92P032A8:2@T:2@T:00894PX00a4L2PT950T9
50022A`D00LJ71i6Iea?LW/S@Cd94PX92A@99RT00PTL50082A8:4A`:6PT:
6Q`NEeEB8blY2@TD2A8:0PT92P0A4A`:2A8:2@T:8blN6RHD8blN6Q8D;3PY
AUDYAT`mAUDYAT`mCfM7CfMLCfM7=5DmEfMB008mGSd2AUEB0SAE:@08=2lY
4BHD=2lN/:Z42A8:AT`mNheV000010T92P894PX52@T:00DA70X92@X92@X9
2@XA70X00PT92P044A`:2A8:2@T:2A8:0a4L2P<92@X01R<L2Q4L2PT92Q4L
2PTB2Q4L2P<92@X01a4L2PT92QX92PT92Q4L2PT92Q4L2P022@T:00@A70X9
2@X0002EV:=Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0
^0C<c<`00fIVI/c<c9VIV@07VIVI0oooo`0<nOWih^;Rb<S8Zj^[SXj>Vi^K
WinOZj^[_Kfmb/[:d];BemOG0]cLg004gmoOi>CTi^KVi^KV0^CTi003hn?S
iNGUiNGU03kUiND05nCTi>?ShnCTi>KVi^OWinKVi^7QhMgMgNGUiMOGelg=
cLk>c/_;bkbl_:VYZInOWiJFUYRHV:RXZ<O7anCTi?Kfm_knoP02oooo19VI
V@800004VIVI0P0000>IVIT200000YVIV@8000000iVIV@0000000002VIVI
0P0000:IVIT200001YVIV@800003VIVI0P0000:IVIT2000000>IVIT00000
00000YVIV@800004VIVI0P0000>IVIT2000000>IVIT0000000000YVIV@80
0002VIVI0`0000:IVIT2000000>IVIT0000000000YVIV@8000000iVIV@00
00000002VIVI0P0000JIVIT200000iVIV@800002VIVI0P0000:IVIT30000
00BIVIT0000000000002VIVI0P0000:IVIT2000000>IVIT00000000059VI
V@03ooooc<c<c<c<05g<c<`32A8:00<92@X92A@94PX00PTB2P892@X01P00
00TB2PT92PTB2PT92Q4L2P<92@X00aX92PT92PT92P032@T:00H000094PX9
2@XA70X000094PX:2@T:00D94PX92@X92@X000094PX00PT92P0400004A`:
2@T:4A`:0`T92P032A8:2@T:2@T:00<92@X020TB2PT92PT92PT92P00014L
2P00014L2P8000001PTB2PT92PT92QXB500000TB2P@92@X0100000T92PTB
2P0000892@X01a4L2P0000TB2PT92PTB2P0000T92P0200000PT92P042A8:
000000004A`:0`T92P052A8:2@TD2A8:2@TD2BHY00<92A@22A8:00H92@X9
4PX94PX94PX92@X94PX32@TD00<A9Qh000092@X020T92P052A8:00002@T:
2@T:000000894PX42@T:00T94PX971hA9Qh94PX971@92@X971h92A@971h0
0PT950082@T:2A8:4A`:8blc=2lc2A`D2@T:00000PTB2P892@X00a4L2R<_
7R<_7P028blN01TdEBTmGSe6C3eGSEaGIe9ZSEa?Iea?IdMGEE9PGS</C2U6
EBTdEBTA9QhJ2@X/>2T0000S;aibIe8A9Qj=SDN3SHA6C3d000092@X00PTB
2P892@X00`0000T92PT92P072@T:00<A70X92@X92@X020T92P032A8:2@T:
4A`:00@92@X01AX92PT92PT92Q4L2P0000092@T:00<A70X0002VXIP0HLc<
c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<
c<bIVIT01iVIV@0Ao_knooooo?cln_[jgMgMalO7XZ:RPX:2TI6AWinO[Jf]
]kNg_[jnb<S8d=3@dm?Cf=SH00;GemL01MWIfMgMgMkNg]gMgM[JfP0hg]kN
2=gMg@?Ph>005]oOgmkNg]gMgM_Kfm[Jf]GEeM?Cdlg=cLG5aKjn_[Ng]j^[
Zj6QXIBDU8:2PZFUYL71`MkNg_Shn?oooogmoOooo`BIVIT2000019VIV@80
0003VIVI0P0000:IVIT2000000>IVIT0000000000YVIV@800002VIVI0P00
00JIVIT200000iVIV@800002VIVI0P000003VIVI0000000000fIVIT20000
00BIVIT00000002IVIT200000YVIV@80000019VIV@00000009VIV@800000
0iVIV@0000000002VIVI0P000003VIVI0000000000:IVIT200001YVIV@80
0003VIVI0P0000:IVIT200000YVIV@<0000019VIV@000000000000:IVIT2
00001IVIV@80000DVIVI00?oooo<c<c<c<`0GLc<c0066Q8D0000=2lc2A8:
2@T:4A`:0PT92P894PX42@T:0P0000@92@X00`TB2PT92PTB2P042@T:00<0
00092@XJ2@X010T92P0800002@T:2@T:4A`:2A8:2@T:2A8:000010T92P0;
00002@T:2@T:2@T:4A`:2@T:4A`:2@T:00002@T:2A8:00892@X00`0000T9
2PTB2P052@T:00@94PX000092@X94PX42@T:00@A70X000094PX000022A8:
00<92@XA70X000000`T92P0300002A8:00000080000040TB2P0000T92PT9
2P0000T92P0000TB2PT92P0000T92PTB2PT92PTB2PT9514L2P8971@01PTB
2Q4V50T950T92PTL50TB2P892@X01`T950TB2Q4L2PT92Q4_?@TL7Q4_<`02
2@T:00@000092@X92@X000042@T:00<000094PX000000PT92P042A8:2@T:
2@T:2A8:0PT92P032A8:2A`D2A`D00892@X02aXB50TL514_<`T950TV:A4V
50T92PTB2PT92Q4V50TL50022A8:10T92P034A`:6Q8D8blN00<S;ah01cd_
?CeN?EMWDUMWDVYbG4mWAeMWDP02=5DY01HA9Qh/9Q@d;ah94PXd;ahJ9Q@9
4PXd;ajVV6m6IeabIe:EV6IbSCePGS<A9Q@92@X000094PX92@X94PX92@XA
70X62@T:00<A70X92@X92@X00`T92P034A`:2@T:2@T:00<92@X011X92PT9
2PTB2QX92P892@X00aX92PT92PT92P022@T:00@A70X94PX92@XJ2@X22@T:
00<A70X92@XA70X00Q4L2P036PT:0000b]31067<c<`016IVIXS0^8S0^4R@
R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT04Okn
o_ooooclo?[jn]_KflS8b96ATHB4Q96ATIfMWJ^[Zk:b/[Rh^<30`<K6a/W9
bM3@d002clo?00CBd];Fe]KHf=SHf=Pie]KF2=OGe`GFe]H05=GEeMCDe=?C
dlk>c/c<c<O7akno_kVi^K:b/ZNWYifMWI6ATH>3PiFEULC4a=gMgOShn?oo
oo_knoooo`BIVIT2000019VIV@800003VIVI0P0000:IVIT2000000>IVIT0
000000000YVIV@800002VIVI0P0000JIVIT200000iVIV@800002VIVI0P00
0003VIVI0000000000@00007VIVI10000003VIVI0000000000<00002VIVI
0P000004VIVI00000000VIVI0P000003VIVI0000000000:IVIT2000000>I
VIT0000000000YVIV@800006VIVI0P0000>IVIT200000YVIV@80000029VI
V@00000009VIV@0009VIV@0009VIV@8000000iVIV@0000000004000000>I
VIT00000000059VIV@03ooooc<c<c<c<05g<c<`01Q4L2QXB50T92Q4L2PT9
2PTB2P@92@X01@TB2PT92PT92PT92Q4L2P032@T:00@94PX92@XA70X92@X2
2A8:2`T92P054A`:2@T:2A8:2@T:2A8:00<92@X00a4L2PT92PTB2P032@T:
00TA70X94PX92@XA70X0000A70X000092@X94PX010T92P064A`:2@T:2@T:
00002@T:00001PT92P072A8:00002@T:2@T:00002@T:4A`:00892@X020TB
2PT92PT92PT92P0000T92P0000TB2P<92@X01PTB2P0000TB2P0000T92P00
00892@X02`TB2P0000T92QXB52<_<a4_<dINA`TB2PTL7PTL50T950022A8:
00@92@X94PX92@X94PX32@TD00</71@99RT92A@00`TB2P<92@X01@TB2PT9
2PT92P0000TB2P022@T:00@A70X92@X000094PX22@T:0PTB2P032@T:2@TD
2A8:00894PX22A`N00<A9Q@971hJ4Q@00PT92P894PX0114V7PT950T950T9
2P894PX22@T:01XA70XJ9Q@S;ah/>2TS;bU6C3ePGS=ZLUakSFI6EE96EBTd
;bTS9PXA70X0001P;a@A9PX92A@92@YbSCd94PXA9PYbIe9GSE`d;ajEV6H2
2A8:00BEV6I6@Ah94PX000022@T:00<94PX000092@X00`T92P036PT:2@T:
2@T:00<92@X00a4L2QX92PT92P032@T:00LJ2@X92@X92@X92@XJ2@X92@X0
00000`T92P058a`:00004A`:2A8:6PT:00@92@X02B<L2PT92PTB2QX92PT9
2Q4L2PTB2P0008fHSP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI013moOgoooomoOgjn_[IfMW:
b/YgMgN5QHF=SHfIVIVUYJF/[:b`/;2g]kNm_Kfo_kl3aLG500?7alO;bl_>
c/h00/o?ccS=cLd8c/k>0lc<c00Fbl_;b/[:b<S8alO7a/K6a<C4`/;2_[jn
]kNg/[:b[Jf]Xj>SVIVISHf=Ph>3OGemalO7g=cLn?ShoooonOWioooo19VI
V@D000000iVIV@0000000003VIVI0P0000:IVIT2000000>IVIT000000000
0YVIV@800002VIVI0P0000JIVIT200000iVIV@800002VIVI0P000003VIVI
0000000000:IVIT200001IVIV@D00002VIVI100000>IVIT2000000BIVIT0
0000002IVIT2000000>IVIT0000000000YVIV@8000000iVIV@0000000002
VIVI0P0000JIVIT200000iVIV@800002VIVI0P000004VIVI00000000VIVI
0`000004VIVI00000000VIVI0P0000:IVIT2000000>IVIT00000000059VI
V@03ooooc<c<c<c<05g<c<`01@TB2Q4L2PTB2PT92Q4L2P042A8:00<A70X9
2@X92@X00PT92P082A8:2@T:2A8:2@T:2A8:00002A8:2@T:0PTB2P030000
4A`:2@T:00/92@X22A8:0`T92P0400002@T:000000001@TB2P032@T:4A`:
2A8:00892@X0200000TB2PT92PTB2PT92PTB2P00014L2P@92@X00`0000T9
2PT92P052@T:00<0000A70X94PX00`T92P032A8:00004A`:00892@X02`00
00TB2P0000TB2P0000TB2P0000T92P0000T92P0000022@T:00D94PX92@X9
4PX0001?Ie`00PT92P05AUEB2A`D2A`D2@TD000000<92@X03@0000TB2PT9
514V50T952<_:Cd_?B<_<`TB2PTL50T92P0000TB2P022@T:00<000094PX9
4PX00PT92P0700002@T:2A8:2A8:2@T:00002A8:00892@X00`0000TB2QXB
50022@TD00<971@92A@A9Qh00PTL500:2@TD2A8:2@T:2@T:2A8:2A`D2@TD
2A`D2A8:00000PT92P0E4A`:4BH:6Q8D4BH:;4`Y=5DYAT`mCfM7AUDY=5DY
8a`:2A`D4A`:2@T:6Q8D2@T:=5DY2@T:4A`:JVLc=2lN0096@Ah02FZ=G3@_
7[2ZQ00000T92QX92Ra<:JJQIP0000022A8:2@T92P044A`:2A8:2@T:4A`:
1@T92P044A`:2@T:2@T:2A8:0`T92P8A70X01PT92PTB2PT92Q4L2PT92QX9
2P<92@X02a4L2PT92PT92PT92QX92Q4L2QX92Q4L2QX92P000:JQV01Qc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<
c9VIV@07VIVI013lo?coooono_kkno_Jf][=cLePH622PX:6QXJBTY:OWinV
YZJ[Zj^b/[:h^;Rk^k/3_Kfm00Fo_ko2`/;4a<C6a/K7alL0><K6aP[5aLD0
1LC4a<?3`l30`;jn_[bl_003^k^k00ng]kNa/K6][JfXZ:ROWinFUYJ8R8R1
PH5VIVK:b/[Lg=chn?Soooojn_[oool019VIV@800004VIVI0P0000BIVIT0
0`0009VIVIVIV@02000000FIVIT000000000002IVIT00`000003VIVI0000
000000JIVIT200000iVIV@<0000019VIV@00000009VIV@800002VIVI0P00
00BIVIT4000019VIV@80000019VIV@00000009VIV@800003VIVI100000:I
VIT00`0009VIVIVIV@02000000FIVIT000000000002IVIT00P0000JIVIT2
000019VIV@030000VIVIVIVI0080000019VIV@00000009VIV@<0000019VI
V@00000009VIV@800002VIVI0P000003VIVI0000000001BIVIT00oooolc<
c<c<c01Mc<c<00@J4Q@94PX92A@A70X22@T:00<94PXJ4Q@92@X00PT92P08
4A`:2A8:4A`:2A8:2@T:4A`:2A8:4A`:0`T92P042A8:00004A`:000030T9
2P0400002@T:2@T:00000PT92P042A8:4A`:2@T:2@T:0P0000032A8:2@T:
2A8:00@92@X010TB2PT92PT92P0000894PX0100000TB2P0000TB2PH92@X0
0`0000T92PT92P022@T:00<000094PX92@X00PTB2P<92@X200000PT92P05
2A8:00002@T:00002A8:00<92@X010T950T92P00000000892@X01P0002=1
?C@_:AXB52`V51XB50892A@32A8:0PT92P032@TD00002BHY008J71h014IE
DRaEG0TB2PTB2P892@X00`0000TB2P0000022@T:00D000094PX000092@X0
000020T92P042A8:2@TD2A`D2A8:0PT950054BHN2A`N2A`D2@T:000000<9
2@X01@TL7QXB50T9500000TB2P022@T:00@A70XJ4Q@J9Q@/>2T2CfM700@m
GSdA9PX0000A70X32@T:0Q4L2P0>;1808a`:AUDYJVLc8blYEeEBUJ6>NheV
0000/:Z44BH:00002@T:00000TI17P05LXdm00002A8:2@TD000000892@X0
0`0000T92PT92P0C2@T:00<J2@X92@XA70X00PT92P036PT:2@T:2@T:0089
2@X26PT:00T94PX92@X92@X92@XJ2@X92@XJ2@X0002VXIP0HLc<c004IVIV
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT0
1iVIV@0HoOgmoooooooono_khN7QdM7AEEEENGUiPH61SXj>VYZJXJ6QYZJV
[Jf]/k>c]KFe]kNg^;Rh^KVi^[Zj^k^k_;bl_[jn_kno>;fm_@Rl_;`3_Kfm
01Jl_;bk^k^i^KVh^;Rg]kNe]KFd];Ba/K6[Zj^XZ:RTY:BJVYZATI62PX9i
NGUIFEW=cLgOgmohn?SoooomoOgoool4VIVI0P0000BIVIT400000YVIV@@0
0002VIVI0P000003VIVI0000000000:IVIT200001iVIV@800003VIVI0P00
0003VIVI0000000000>IVIT400001IVIV@800006VIVI0P0000:IVIT40000
0iVIV@@00002VIVI100000:IVIT2000000>IVIT0000000001iVIV@800004
VIVI100000:IVIT200000YVIV@030000VIVIVIVI00800002VIVI100000:I
VIT400004YVIV@03ooooc<c<c<c<05g<c<`32A8:00H92@XA70X94PX92@XA
70X92@X22A8:10T92P032A8:00002@T:00<92@X00`TB2P0000T92P032@T:
00LA70X92@X92@X92@X94PX92@XA70X00`T92P042A8:2@T:4A`:00000PTB
2P0300002@T:2@T:00892@X01@TB2PT92PTB2P0000TB2P022@T:00D94PX0
00092@X000094PX01@T92P072A8:00002@T:00002@T:00002A8:00892@X0
1P0000T92P0000T92PTB2P0000892@X01`0000T92PT92P00014L2PTB2PT9
2P02000010T92P80000010T92P00000000TB2P892@X02P0000T92PTB2R<_
7QXL7P0004IEDPT950TB2PT92P894PX22@T:00d92AA6EE9?GVIbLW/m;cd9
@DL99RT92@X94PX92@X000094PX000000`T92P032A8:2@T:2A8:00892@X0
0`0000T92PT92P062@T:0PTB2P892A@010T92Q4_<`T92PTB2P<92@X01@TB
2PT950T9514V50TB2P032@T:0Q4L2P0I6RHD;3PYH5hc=5DY6RHD00002@TD
2@T:2A8:2@T:4A`:6PT:6Q8D;2HD=2lNH5hcPg]LEfMBLXdm`K>>;5hm0000
`K>>2A`N000000892@X2000000N3Nc=6@Aj=SDL0000A70X92@X000002`T9
2P036PT:2@T:2@T:00892@X01A4L2PT92QX92PT92QX92P052@T:00@J2@X9
2@X92@XA70X82@T:00HJ2@X0000A70XJ2@X0002EV:=Qc<c<00AVIVJ8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI
01?no_kmoOgoooolo?c/k>cFe]IIFEU[Jf]lO7b7QhNDU9BJVYZNWYjTY:BY
ZJV/[:b`/;2b/[:d];@00kFe]@03][Jf]kNg];Bd03Nd];@8]KFe00>d];Be
]KFe]KD01;Jf]P0?]KFe[Zj^[Jf]ZJVYXj>SWinOVi^KTY:BR8R8NGUiKFe]
F5QHe=CDj>SXnOWi00?oool4VIVI0P00022IVIT200000iVIV@80000?VIVI
0P0000>IVIT2000000>IVIT0000000002iVIV@80000DVIVI0P00036IVIT0
0oooolc<c<c<c01Mc<c<0PT950894PX22@T:00@A70X92@X92@XA70X52@T:
00@94PX92@X92@X94PX32@T:00<J2@X92@X92@X00PT92P894PX72@T:00<9
4PXJ2@X000000`T92P0300002@T:2@T:00H92@X0114L2P00014L2P000089
2@X00`TB2P0000T92P022A8:0`T92P0300002A8:2@T:00892@X00`0000T9
2PT92P022@T:00<A70X000092@X00`T92P032A8:4A`:000000892@X01`00
00T92PT92PT92PTB2P0000TB2P052@T:00@94PX92@X0000000022@T:00X9
4PX92A@J4Q@92@XS;bTS@CdJ4Q@92A@92@X92A@22@T:00H94PX0001bSH@9
2AB3Q8h/EFl32A`N0PT92P062A8:00002@T:2@T:2A8:00000PT92P042@TD
00002A8:2A8:1PT92P032A8:2@T:2A8:00892A@00a4L2PTL7PTL7P022@TD
01<94PX92@X92@X94PX92A@94PXA;c<971@000092@X94PX92A@J4QA6EBTm
GSd000094PXJ4Q@J2@X00Q4L2P0B2A8:4A`:2@T:4A`:AT4NAT`mJVLcSHe_
CfM7H5hcYZ6HAVML0000Pg]LUJ6>LXdm00002A8:0`T92P050000YYQ_AUDY
=2lN4BHD00<92@X00aXB50T92Q4L2P052@T:00<J2@X92@X92@X00PT92P03
4A`:6PT:2@T:00D92@X00a4L2QX92PT92P052@T:0Q4L2P0<2@T:4A`:6PT:
2@T:4A`:6PT:2@T:4A`:6Q8D2A8:0000YZ6HHLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT01iVIV@0Doooo
o?cloooooOgmmoOgfMWII6ATGUiNKfm_O7alR8R8Shn?U9BDVi^KXJ6QXj>S
YZJVZZZZ[Zj^/K6a0k2`/003/K6a[jn_[jn_03J_[jl8/;2`0jn_[`0C/;2`
[jn_[jn_[Zj^[Jf]YJFUY:BTWinOVIVIUIFET92@QXJ6O7alKFe]GemOH61P
g=cLm?Cdo?cl00?oool4VIVI1@0001^IVIT6000000>IVIT00000000049VI
V@D00002VIVI0P0000^IVIT200004YVIV@H0000_VIVI00?oooo<c<c<c<`0
GLc<c08J4Q@32A8:00<A70X94PX92@X00PT92P034A`:2@T:2@T:00L92@X0
0`0000T92PTB2P052@T:00@000094PX92@X94PX92@T:00P94PX92@X92@X9
2@X000094PX92@X94PX22@T:00<000094PX94PX00PT92P0300002@T:2@T:
00<92@X01P0000TB2PTB2PTB2QX92P0000892@X01PTB2PT92PT92P0000T9
2P0000894PX42@T:00<94PX92@X94PX010T92P082A8:00002@T:2@T:0000
2@T:2A8:00000PT92P0500002A8:2@T:2@T:000000892@X00aXB50T951XB
50022A`N00@92A@J4Q@94PX92@X22A8:00P0001bLW/m;cfEV:<92A@A9PX9
2A@J4Q@22@T:00d94PX92@X000092@X000092@X000092@X000092@X00009
2A@94PX010T92P0;2A8:2@T:2@T:2A8:2@TD2A8:2@TD4Blc2@TD4BHN2A8:
00<92@X08`T9514V7PTB2PTV:@TB2PT92PTB2Q4L2QX92TI17Ra<:@0000T9
2S@_7QXV514L2PT92PT951XB50T953@_7TIE:G9WDW:=?G9WDW:=G7^=IZJQ
V5N=G00009F=DVYW<iF4DXf=Ka4V50022@T:00H94PX92@X92@XS9PZiV5a?
IdL32A8:0PT92P034BHD2@T:6Q8D00892@X00aX92PT92PT92P0=2@T:00@A
70X92@X92@XA70X32@T:00DJ2@XS70XA70X92@XJ4Q@00PT92P076PT:4A`:
2@T:8a`:6PT:2@T:YZ6H067<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT04ooooo_knooooogmoOkn
o]cLg6e]KEEEEF=SHg1`L7inOXJ6QXf=SIJFUYfMWJ2PX9jNWZBTY:ZZZP02
[Jf]00>/[:b][Jf][Jd0>:f][@R/[:`2[Zj^01F][Jf/[:bYZJVWYjNUYJFS
Xj>NWYjMWIfHV9RBTY:=SHf7QhMmOGecLg=UIFEFEUIXJ6SRh^;moOgno_kk
no/00_oooiZIVIT00oooolc<c<c<c01Mc<c<0PTB2P0<2@T:2A8:2@T:2A8:
2@T:2A8:2@T:4A`:2@T:2A8:2@T:4A`:0`T92P032A8:2@T:4A`:00<92@X0
1`TB2PT92PT92Q4L2P0000T92PTB2P032@T:00<A70X92@X94PX01PT92P0:
00002A8:2@T:2@T:2A8:00002A8:00004A`:2@T:0`TB2P@92@X00`0000T9
2PT92P032@T:00@000094PX92@X92@X22A8:0PT92P0400002A8:2@T:2A8:
0P00000=2A8:2@T:2@T:2A8:2@T:00002A8:4A`:00002A8:00002A8:2@T:
008000001Q4L2P0000TB2PT92P0000T92P8000000`T92PTB2PT92P052A8:
00<971h971@92@X00PTB2P892@X010TB2RaEG8>HSRaWG08971h00`TB2PTL
7PTB2P022@T:00<000094PX000000PTB2P0300002A8:2@T:00892@X20000
00@94PX92@X94PX94PX22@TD00T94PX92@X971@92A@A9Q@A;cdA9Q@971@9
2A@00PTB2P892@X00`TL50TL7PTL50032@T:01hA70X/>2TA9Q@000092A@J
2@XS;ahS9PX/9Q@94PXJ9Q@J71iZEAikSFJ=SE9ZNfmGIe9?IdNVXIREXHj=
SFl0002ESE9?IdMZEAj=SDN=SFl/C2T000094PX22@T:00L00016EBU6EBVE
SE8d;bT92@X92A@010T92P034A`:2@T:2@T:00892@X0114L2PT92PT92Q4L
2PH92@X00a4L2PT92PT92P024A`:1@T92P074A`:2@T:2@T:6Q8D;3PY6PT:
4A`:00@92@X011XB50T950000:JZ[F7<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT04ogmoOoooooo
ooCdm?ooooCdm92@T4i>CV9RHUIFEVYZJX^;Ri6ATJ2PX:RXZ:n_[jj^[[>c
/kFe]@02];Bd00>f][Jg]kNf][H04;Jf]QRg]kLI][Jf0[Vi^@0F][Jf]KFe
][Jf][Jf];BdZ:RX^[ZjVIVIW9bLVi^KMWIfKVi^GemOC4a<CTi>R8R8oooo
o?clkno_oooomOGeooooVYVIV@03ooooc<c<c<c<05g<c<`01aXB50T92Q4L
2P00014L2PT92PTB2P022@T:00<94PX000092@X00`T92P054A`:2@T:4A`:
2@T:4A`:00892@X01A4L2PT92PT92Q4L2P0000022@T:00<A70X92@X92@X0
0`T92P052A8:2@T:2@T:2A8:000000<92@X00`0000T92PT92P042@T:00H9
4PX000092@X000092@XA70X22@T:00<94PX92@X92@X01PT92P894PX01P00
00T92P0000T92PTB2P0000D92@X00`TB2P0000T92P022@T:00<94PX00009
4PX00`T92P092A8:2@T:2@T:00002@T:00002A8:00002A8:00<92@X01@00
00T92PTB2P0000T92P032@TD00<94PX92A@94PX00PT92P062A8:2@TD0000
8d4m2D574Blc0PT950046Q`N00002A8:00000`T92P8000001@T92P000000
00TB2P0000022@T:00D94PXJ4Q@94PX92@XJ4Q@00`TB2P892A@03@TL7R=1
?@TL50T950TB2PT92Q4L2PTB2Q4_<`TL50TL7PTB2P0000022@T:00d94PX9
2@X92@X94PX92@XA70XS9PXJ9Q@S9PXJ9QA6@Aj=SDN=V8h00VYkK`0>H5hc
SHe_YZ6HPg]L4BH:0000JVLcEheL8a`:JUDNYZ5VYZ6HLXeL00000PT92P0;
00002@T:0000H44YNheVLXdmAUDY2@T:2A8:2@T:4A`:00892@X01Q4L2PT9
2PT92Q4L2PT92QX92P@92@X010TB2R`B00T92Q4L2PH92@X04a4L2PT92PT9
2R`B0000014L2PT92PTB2PT92Q4L2PT950T92Q4L2PT92Q4L2QX92PT92P00
0:JQV01Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@07VIVI01SooooinOWoooooooogmoOno_k2`/8l?3a2
@T99BDUZJVYfMWJLW9be]KFl_;bd];Bo_ko4a<C6a/K5aLG4a<C6a/K7alO5
aLD@bLW96<O7aaS9bLT01lG5aLS8b<S8b<G5aLC4a<K6a/G5a@02`l?300^e
]KFh^;Rk^k^7QhMZJVYbLW98B4QFEUI0@432`/;emOD00_ooo`03m_Kfoooo
oooo09ZIVIT00oooolc<c<c<c01Mc<c<00<94PX92@X94PX00`T92P044A`:
2@T:2@T:2A8:0`T92P034A`:2A8:2A8:00892@X0114L2P0000TB2Q4L2P<9
2@X22A8:10T92P064A`:2@T:2@T:2@T:2A8:2@T:10TB2P892@X00`TB2PT9
2PT92P022@T:00<94PX000094PX00PT92P034A`:2@T:2@T:00892@X010TB
2P0000TB2PTB2P<92@X020TB2PT92PTB2PT92QX92PT92Q4L2PT950D92@X0
0`TB2PT92PT92P022@T:00@94PX92@XJ2@X000032@T:00<94PX92@X00000
0PT92P052A8:00002@T:2@T:000000@92@X00`TB2PT92PT92P022A8:00<9
2A@94PX94PX00PTL500<2A8:2@T:2A8:2@T:2@TD4BHD2A8:2BHY2@T:2A`D
4Blc00000`T92P894PX32@T:00DA70X94PX92@X92@X000000PT92P046RHD
6Q8D6Q`N6Q8D0PTL500@2A8:2@TD6Q8D4BHN4Blc2A8:6Q8D2A8:2@T:2A8:
2@TD2BHY2A`D6RHD00004A`:1PT92P0>4A`:4BH:6RHD8bH:;3PYAT4NPhAk
Phf4JW]_LXeLSHe_LXdm=5DY4BH:0P0000062A8:SHe_00008bH:AT4NPehD
0ZJHK`0<00002@T:2@T:2@T:2A8:4A`:0000Pehc/:Z4Pg/c00004A`:1@T9
2P064A`:2@T:4A`:4A`:00008a`:0PT92P0N4A`:2@T:2@T:2@T:4A`:2@T:
6PT:2@T:6PT:;1806PT:2@T:4A`:6PT:2@T:8a`:2@T:6PT:2@T:00006Q8D
4A`:6Q8D2@T:6PT:4A`:6PT:4A`:0000YZZSHLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT01iVIV@0Eoooo
n_[jo_knoooolO7aoooooOgmPh>3A4A4@d=3CTi>MWIfYjNW_Kfm^;RhalO7
`/;2alO7b/[:bLW9b<S800;9bLT00lO7al[:b/[:bP0nb/[:01G9bLW;bl_;
bl_9bLW8b<S9bLW8b<S5aLG7alNo_kne]KFi^KVXZ:Q^KVi3@d=1@D4e=CF:
RX[clo?hn?Sno_h00_ooo`03o?clooooVIVI09VIVIT00oooolc<c<c<c01M
c<c<00@J4Q@92A@92@X92@X24A`:00<92@XA70X92@X02PT92P034A`:2@T:
2@T:00<92@X00`TB2PT92PT92P052@T:00XA70X92@X0000A70X92@X00009
4PX000094PX92@X200000PTB2P0300002@T:2@T:00892@X00`TB2P0000TB
2P052@T:00D0000A70X000092@X000000PT92P0;00002@T:2@T:2@T:0000
2@T:00002A8:2@T:00002@T:008000001PTB2PT92PT92PT92P00014L2P@9
2@X02AX92Q4L2PT92PT92PTB2PT92P0000TB2P0000022@T:00<000094PX9
2@X01@T92P052@TD2A8:2@TD2@TD2A`N00892@X22A8:0PT950064BHN2A`N
2A`D2A`N2BHY00000PT92P0300002@T:000000<92@X2000000/94PX92@X9
4PX92@X94PX92A@J2@X/71@99RT971h971@00PT9500:4BHN4Blc2A`D2@TD
2A8:2@T:6Q8D2@TD6Q8D4BHN0PTL7P032@T:00002A8:00892@X031XB50TB
2Q4L2QXB514V51XV53@_7TmWAk2ZQ7:=?DIE:B<V2P@000003@T95000061N
<mc7X`00014L2R`L56YE7Xf=Ahf=DYFHIP0000TB2P042@T:00L00016EBV3
Nc>=SFm6EBT92@X94PX00`T92P062A8:2@T:2@T:00006PT:4A`:1@T92P03
4A`:2@T:6PT:00`92@X0100000T92Q4L2P0000892@X01b<L2PTB2QX92PT9
2QX92P000:JZX`1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI0_ooo`03n?Sho?cloooo00;oool0
3_7alEQHF2/[:cXj>UmOGg]kNl71`Kjn_/71`L;2`/O7al[:b/W9bLS8b0;9
bLT00lO7alS8b<S8b00>b<S86<W9bAS8b<P00lW9bLc<c<_;b`02bLW901;:
b/[8b<S3`l?3`l?5aLG<c<b][JemOGePH612@T8[:b]KFe_ooooinOWgmoOo
oookno_inOT2ooooVYVIV@03ooooc<c<c<c<05g<c<`010T9514L2PTB2Q4L
2P892@X01@TB2PT92Q4L2PT92PTB2P022@T:00@A70X94PXA70XA70X82@T:
00<94PX92@X92@X01@T92P044A`:2@T:2@T:00000PTB2P072@T:00002A8:
00002A8:2@T:6PT:008000001@TB2PT92PTB2PTB2Q4L2P062@T:00@00009
2@X0000A70X42@T:00<94PX000092@X00PT92P0<00002@T:2@T:00004A`:
2@T:00004A`:00002A8:2@T:00001PT92P082A8:2@T:2@T:00002@T:0000
2@T:000010T92P0300002A8:2@T:00<94PX32@TD0PTB2P032@TD2A8:2@T:
00894PX00`T950TV:A4_?@022@TD00<971@92A@000000PT92P042@TD2@T:
2@T:2@T:0PTB2P@92@X0200000TB2PT92R<_<b<_7QXB54IEDPTL7P892A@0
3@TL50TV:@TV:A4V500000T92P0000TL50T92Q4_?A4L2Q4V7PT950022@T:
01l94PX92@X94PXJ9Q@92@XS9PXJ9QAP@BUbIe:=SDMZLUc1/hhA9PX/C2TA
9PX92A@94PXA70X94PX00023GS?1al4971h0000A70XJ4QAP@ABVV6n`ZXBi
ZVl000000PTB2P<92@X01PTB2PT92TmWAh=k<hf=DP0000894PX00`T92QX9
2PT92P022@T:00<A70X92@X92@X01@T92P046PT:2@T:2@T:2@T:0Q4L2P08
2@T:6PT:4A`:2@T:6PT:2@T:4A`:6PT:0Q4L2P042@TD2@T:4A`:4A`:0PT9
2P066PT:2@T:6PT:4A`:0000YZZ]HLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P4c<c<0VIVIP03c<c<VIVIVIVI00FIVIT01o_knooo
ooooooclo?ooooclo>_[j`02oooo00Tf=SI0@41?Cdn1PH6MWIf/[:ba/K6h
^;Rn_[h00l;2`P;3`l<00l71`L?3`l?3``0>`l?36<;2`QS3`l<00l71`L?3
`l;2`P02`L7100g2`/:o_kni^KVm_Kfh^;R^[ZjBTY9ZJVXj>SXZ:RY>CTkj
n_[^k^h00_ooo`05jNWYooooooooo?cloooo09ZIVIT00oooolc<c<c<c01M
c<c<00TJ4Q@94PX92@X92@XA70X92@XA9Q@92@X94PX03PT92P032A8:2@T:
2@T:01892@X021X92PTB2P0000T92PTB2P0002<V2QX92P892@X22A8:0PT9
2P072A8:2@T:2@T:2@T:00002@T:2A8:00892@X00a4L2PT92PT92P032@T:
00<000092@X92@X00PT92P0300002A8:2@T:00T92@X22A8:10T92P030000
4A`:2@T:00892@X0100000T92PTB2PTB2P892@X00`TB2PT950TL50032@TD
00d94PX92@X92@X94PX92@X92A@A9Qh99RT92A@92@XA;c<92A@94PX00P00
00<92@X01P0000T92PT92P0000T92P0000@92@X01b`h:AXB50T92X>4Na4_
<`TL7QXB50024BHN00<A;c<971h92A@00PTB2P032A`N2A`D2BHY00899RT0
4@T950T92PT92PTB2PT950TB2Q4L2R<_7TI17UMEDYF4DXfHSW^=Q:JHQ8f=
A`0001X92P026Q8D00D92A@0000d;ajESFKLhn000P0000892@X01aXV54H_
2VYW<iF=DYik<a4V2P0000052@T:00L00016@AikSFJESE9PGS<000094PX0
0PT92P8A70X00`T92Q4L2PT92P022@T:00<A70X92@XA70X00PT92P056PT:
2@T:2@T:6PT:2@T:008J2@X22@T:00TA70X92@XA70XJ2@X92@XJ2@XA70XS
70XJ2@X00`T92P<A70X00aX92P000:JZX`1Qc<c<00AVIVJ8`;R8`;Q8T8P1
0000000018S0^<SPf8S0^8S0^0C<c<`016IVI/c<c6IVI/c<c0JIVIT00ooo
oo[jn_ooo`02o?cl013oooodm?Coooo[jn_ooom6ATHb<S97AdM/K6bGUiNW
YjNTY:B[Zj^`/;2b/[:c/k<2][Jf00>d];Be]KFe]KD0?[Fe]@0D/[:b/k>c
/[:b/K6a/[:b/k>c[Zj^YjNWVIVI/;2`RXZ:H61PAdM792@TIVIVo_knoooo
nOWiooool_;b0_ooo`03mOGeoooooooo09ZIVIT00oooolc<c<c<c01Mc<c<
00<J4Q@A70X92@X00`T92P032A8:00002@T:00<92@X00`TB2Q4L2PT92P04
2@T:00<94PXA70X92@X00PT92P0300004A`:2@T:00<92@X00`0000T92PT9
2P042@T:00D000092@X92@X000094PX020T92P0300004A`:2@T:00892@X0
1PTB2PT92PTB2P0000T92PTB2P@92@X00`T9514V51XB50022@T:00T00009
2@X92@X94PX000092@X000094PX000000`T92P032A8:2@T:2@T:00<92@X0
0`TB2PT92PT92P022A8:00@92@X94PX000092@X3000000@94PX92@X94PX9
2@X42A8:00D92A@971hJ4Q@92A@000000`TB2P0500002@T:2@TD2@TD4Blc
00894PX00`TV:@T92P0000022@T:00@0000A70XA70X94PX42@T:00<A70X0
000000000`T92P084BHN;1`D;5hm2A8:4BHD2A`N2A`D2BHY0Q4V7P0R2A8:
6Q8D2@TD4BHN2BHY2A8:4Blc;5hm2@T:2A8:2@T:2@TD4A`:2A8:ARHDAT4N
SHeBNheVUIRSNheVCfM7SHe700006PT:4A`:2@TD2A`D0000Pg]L`K>]g>?F
;5hm00004A`:0PT92P068a`:ARHDWW/cUIQVYZ5V=5DY10T92P092A8:2@T:
2A8:0000JUDNUHeBPg]L=5DY000000P92@X00aX92P0000T92P022@T:00P0
000A70X92@X92@XJ2@X92@XA70XJ2@X52@T:00HJ2@XA70X92@X92@X00009
2@X34A`:0aX92P032@T:0000YZ6H067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c005IVIVc<c<VIVIIVIVc<c<00FIVIT01Ooo
ookno_oooo_knoShn004oooo00kjn_[ooomgMgM2@T8_;bm9BDUGEeMeMGEl
O7b3Ph>6QXJ9RHV<S8b=SHdARh^;68f=SAV;Rh/048b<S8^;RhZ:RXb<S8f=
SHN7QgmoOgIfMUADE34a<Bl_;chn?Xb<S?3`l?_knnk^kP;oool01_WinOoo
oo[jn_ooooOgmooooiZIVIT00oooolc<c<c<c01Mc<c<0PT92P044A`:2@T:
4A`:2@T:0PTB2PT92@X00`TB2Q4L2PT92P072@T:00<A70X0000A70X01@T9
2P0:2A8:2@T:2@T:2@T:00002A8:2@T:00002@T:4A`:2PT92P0700002A8:
00004A`:2@T:00002A8:00892@X00`TB2Q4V50T92P052@T:00<94PX00009
4PX01@T92P894PX00`T92PTB2PT92P032@T:00H000092@X92@X92@X00009
4PX22@T:0PTB2P892@X00`0000TB2PT92P032@TD0PTB2P8971@22A8:00<9
2@X94PX94PX00PT92P0:2A8:4BHN4Blc2BHY2@T:2A`N2@TD2A8:2@T:2A8:
0`T92P0:8a`:00002A8:00002A8:2@T:00002A8:2@T:2A8:0PT92P894PX0
1@00014V7Q4V2PTL7QXL7P024BHN00X971@92A@92A@A9Q@A9Qh971@A9QhS
;c=?GVH000022A8:01LJ4Q@A9QAP@BUbIe9kSFJVXIRVZZ=kSFH/C2TA9PX0
000J4Q@A70XA9Q@000169QBEV6K1al7:d=IZNflA9PXA70X92@X00PTB2P08
4A`:;1`DPg/c^JY_/:Z4JVLc00002A8:0PT92P0800002@T:2@T:2A8:6Q8D
SHe7Pg]LPg/c0PTB2P062@T:4A`:2@T:4A`:2@T:6PT:0PT92P<A70X03PT9
2Q4L2QX92QX92PT92P0001X92PT92QX92PTB2PT92Q4L2PT92Q4L2P892@X0
11X92PT92Q4L2QX92P<92@X01QX92PT92QX92Q4L2P000:JZ[F7<c<`016IV
IXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c006IVIVc<c<VIVI
VIVIIVIVc<c<19VIV@03n?Shoooon_[j00;oool01O[jn_oooogmoOoooogm
o@03oooo00_OgmmPH60o?cl[:b/b<S8j>SXn?Si2@T96ATI8B4Q6ATH044Y:
BQQ9BDTHBTY:0T];B`0<BTY:BDU9Bd];C4a<ATI6?Shn<C4a>3PhK6a/gmoO
ooool_;b1?ooo`03no_koooomoOg00CooonJVIVI00?oooo<c<c<c<`0GLc<
c08A70X020T92Q4L2P0001X92PTB2PT92PTB2PT92P894PX02@T92PTB2PTB
2PTB2PT92Q4L2PT92P0000T92P022A8:0PT92P044A`:2@T:4A`:2@T:0Q4L
2P892@X02a4L2PT92Q4L2PTB2PT92Q4L2PT92PTB2P0000T92Q4L2P072@T:
0PTB2P<92@X020TB2PT92PT92PT92P0000T92PTB2PT92P894PX22@T:00<9
4PX92@X92@X00PT92P032A8:2@T:000000894PX01@0000TB2PTB2PTB2P00
00022@T:00D94PX92@X92@X92@X94PX00PT92P0400002A8:00002A8:0P00
000=2A8:2@T:000000002A8:6Q8D2A`D4BHD2@TD2A8:6Q8D2A`N2@TD00<9
4PX01`0000T92Q4L2PT950TB2Q4_DPTV:@022A8:00D971h92@X92@X00009
4PX00`0000032A8:2@T:2@T:00894PX32@T:0P0000894PX010T92QXB50TL
50T9508A9Qh22BHY010971h971@A9Q@A9Q@99RT971hJ71h/EE`/Ie`00009
4PX0000d;ai6@Aj=SDMkSFH2YZ6H011GSE`000092@X92@X94PXA9PX971@9
2@YZIc?1/jg1al7Lhn0mGSd0001ZEAh/9Q@32A8:00LA70Y6;`YZEAjVQ5:V
XFJNSC<000000PTB2P032@T:4A`:2A8:00892@X0200004IE:JJHKk2ZQ4HV
500000T92Q4L2P892@X020TB2PT92PT92PT92Q4L2PT92QX92PTB2P8J2@X4
4A`:0PT92P036PT:;1802@T:008A70X01AX92Q4L2Q4L2Q4L2PT92P044A`:
00H92@XJ2@XA70XS70X00031/jeQc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@02VIVI00=VIVK<c<c<c<`0
olc<c0k<c<`00oooolc<c<c<c01Mc<c<00D92A@92@X92@XA70X94PX00Q4L
2P042A8:2@T:4A`:000010T92P034A`:2@T:2@T:00892@X02PTB2PT92PTB
2Q4L2PT92PTB2PT92Q4V2PT92PTB2P892@X24A`:0PT92P032A8:2@T:4A`:
00892@X01@TB2Q4L2PT92Q4L2PT92P022A8:00H92@X94PX94PX94PX00009
4PX52@T:0`TB2P0300002@T:2@T:00<92@X01@0000T92PT92PTB2P000002
2@T:00H94PX92@X92@X94PX0000J2@X42@T:00D94PX92@X94PX000092@X0
0PTB2P0500002@T:2A8:00002@TD00892@X020TB2PT92PT92PT92Q4V50T9
2PTL50T9508971h01PTL50T950T950TB2PT950T92P894PX04PT950TL7Q4_
<a4V7PT950TB2PTV:@TB2P0000T92P0000T92Q4L2P0000TB2PT92PTB2P00
00<92@X22A8:00<92@X000092@X00PTB2P892A@0114V514_<a4V7Q4V7P89
71@08@TB2PTL7R=1?@TL7R=1?B=1DQ4_<`0000T953@_7VYW<g9WDYFHXjJZ
Xhf=Ka4V2P00014L2QXV52`V54I17PT9500008=N<l6c[L77c>g]jTINA`TB
2S@_7QXB57:=?A4V2P022A8:00P/4P0/71B3GQBVXFJiV5bVXFH0000A70X7
2@T:00T/9QBESFJVV6mbSCd92@X94PX92@XA70X92@X00Q4L2P032@T:6PT:
2@T:00D92@X011X92PT92QX92PT92P8J2@X02B<L2PT92Q4L2PT92QX92PT9
2QX92PT92PTB2P022@T:00TJ2@X92@X92@XA70XJ2@XA70XJ2@X00031/jd0
HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT00iVIVOmVIVH@IVIV00?oooo<c<c<c<`0GLc<c0046Q8D4A`:
2A8:2A8:1@T92P032A8:2@T:2@T:00894PX32@T:00<0000A70X92@X010T9
2P894PX22@T:00<A70XJ2@X000001@T92P036PT:2@T:2@T:00@92@X020TB
2PT92PTB2P0000T92PTB2P0000TB2P892@X00a4L2PTB2PT92P042@T:00<0
00092@X000000PTB2P<92@X00a4L2PT92Q4L2P032@T:00HA70X92@X92@X9
4PX92@X94PX32@T:00@A70X92@X92@X94PX22@T:00D94PX000092@X92@X0
00000PT92P0300002A8:000000<92@X0114V53AE?@T950TV:@8971@00a4V
50T950TB2P022A8:01892A@94PX94PX92A@94PXS;c<99RT94PX92@XA;cd9
71@000092@X94PX92@X94PX92@X000022@T:00<000092@X92@X00PT92P06
00002@T:2@T:2@T:2A8:4A`:0PT950032A`D2A`N4BHN008A9Qh0:`TB2PTL
50TL52<_<a4_<`T957:=Q2a<:A4V50T92R`L54IE:IFHIYFQS[2ZQ5N=G000
00T92Q4V2V11:H=k<cAE:@TB2P000<6cS[2c]l77`McSh6YkK`0002<V2R<L
2R<V2QXB58=k<`T950TB2Q4L2QX92VYE7[V=<l6cSZJQIP022@T:00DA70X9
2@X92@X92@XA70X00PT92P060000SHeBNheV`K>>4BHD4A`:1@T92P044A`:
2@T:4A`:2@T:0Q4L2P032@T:4A`:4A`:00892@X01aX92PT92QX92QXB514L
2QX92Q4L2P036PT:00dA70X92@XA70XA70XJ2@X92@XA70XJ2@XA70XJ2@XA
70X92@ZVZZd0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;P4c<c<00=VIVK<c<bIVIT0oiVIVA>IVIT00oooolc<c<c<c01Mc<c<00@J
4Q@94PX92@X94PX32@T:00<A70X92@X92@X00`T92P054A`:2@T:4A`:2@T:
4A`:00<92@X01a4L2PT92PT92PT92QX92PT92PTB2P032@T:00<A70X92@X9
2@X02@T92P044A`:2@T:2@T:4A`:10T92P034A`:2@T:2@T:00@92@X02@00
00T92PT92PT92Q4L2P0000T92PTB2Q4L2P032@T:00@0000A70X92@X92@X2
000000<92@X000092@X03@T92P0300002@T:2@T:00892@X02`0000T92PT9
2QXB500001XV54I<?@TV:@T92PT950TB2P032@TD0`TB2P0C2@T:6Q8D2@T:
2BHY4DaB2BHY2A8:2@TD2BHY2@TD2A8:2@T:00002@T:00002A8:2@T:0000
4A`:00/92@X05AXB50TB2PTL7Q4V7PTL7PTV:AXL7PTB2Sd_?A4_?B=1DR=1
?DmbNh>4SPTV:B<_:@TB2QXV56YW<l[@`G:=G002000001dS9PZ3Nc>ESE:E
V6H971h94PX0002NQ6J`/kO1/jg]kNX971h000092A@A70XS70X/71@dEBU6
;`XJ9Q@94PXJ2@XA9PYkC0ZESE:=SDO:ZVH000094PX01`T92P060000AT4N
SHeB/;>gARl:2A8:10T92P046PT:4A`:2@T:4A`:0PT92P036PT:2@T:2@T:
008J2@X020T92Q4L2PT92QX92R`B01X92Q4L2QX92P892@X00a4L2PT92QX9
2P026PT:00@92@XJ2@XJ2@XJ2@X24A`:00<J2@X0002VZZd0HLc<c004IVIV
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT0
1iVIV@;lool2oooo0_ono`1Hooooo_ooo?oonooonoolnO[en??`m^c[l^;R
j][Jgm?Cg]CCgm?Cg]CCgm?Cg]CCgm?Cg]CCgm?Cg]CCgm?Cg]CCgm?Cg]CC
gm?Cg]CCgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?C
g]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CB
gm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?C
g]CBgm?Cg]CBgm?Cg]CCgm?Cg]CCgm?Cg]CCgm?Cg]CCgm?Cg]CCgm?Cg]CC
gm?Cg]CCgm?Cg]CC0]oCd`09glo?j][Jk^3PlnOWoOCeoOWhoO_looooo_oo
00?lool4o_oo00?ooonIVIVIVIT0V9VIV@03ooooc<c<c<c<05g<c<`01`T9
50T92Q4L2PT92Q4L2PT92Q4L2P022@T:00<A70X92@X92@X02`T92P056PT:
2@T:2@T:2@T:4A`:00<92@X00a4L2PT92PT92P052@T:00XS;bT000092@XA
70X92@XA70X92@X000092@X000042@T:00<000092@X92@X00`T92P042A8:
00002@T:00002PT92P0300004A`:2@T:00h92@X00`0000T92PT92P020000
0PT92P0300002A8:0000008000000`TB2R`h:@TV:@032@TD00/A9Q@J4Q@9
71@94PX92@X92A@92@X92A@971@A9QhA;c<00PT950052A8:4Blc2A8:2@T:
000000892@X0200000T92PT92PT92P0000TB2P0000TB2PP92@X06PT950TB
2QXB50T950TV:AXL7PTV:@T92YFQ]dmNIPU1AdmbNl77`CAWNb<_:@TL7P00
09EbAk2c]a4V500004HV58=k<k2ZQ9FHIW:=?@<000005l6QQ;2c]mcSe^gf
mBa<:@00014L2PT92QX92R<L2R<_7THV561N<h=k<`00014L2R<L2W]<2/ZQ
D]c7XjJQIP00014V50092@T:00=PGS>=SDN3Nc<00PTB2P052@T:00006PT:
2@T:6PT:00@92@X00aX92PT92R`B00032@T:00<J2@X92@XJ2@X00aX92P05
2A8:6PT:4A`:2@T:2A8:00892@X011X92PT92QX92PT92P@J2@X00`000<6c
[Lc<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@07VIVI1Oooo`1To_ooo?ooo?ooo?oon?ckl_;`in?P
h]SGh];BglW;f<;4bKNgakNgbKNgakNgbKNgakNgbKNgakNgbkVibKVibkVi
bKVibkVibKVibkVibKVibkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZg
bkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVi
bKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZg
bkVibKZgbkVibKZgbkVibKZgbkVibKVibkVibKVibkVibKVibkVibKVibkVi
bKVibKNgakNgbKNgakNgbKNgakNgbKNgb[JgckJif/74g<S9g/k>im_KkNCU
lno`o_kno_oo0_coo`03noooo?ooo?oo00;nool00ooooiVIVIVIV@2HVIVI
00?oooo<c<c<c<`0GLc<c08A70X01@T92Q4L2P0000T92PTB2P052@T:00`0
00092@X92@X92@X0000A70X92@X000092@XJ2@X0000A70X62@T:00<00009
2@X000000PT92P046PT:2@T:2@T:2@T:0Q4L2P892@X00b`B01X92PT92P02
2@T:00`A70X000092@X92@X000094PX92@X000092@X000092@X000022@T:
00<000092@X92@X00PT92P0500002@T:2@T:2@T:000000<92@X01@0000T9
2PT92PT92P0000042@T:00<000092@X92@X00PT92P0500002@T:2A8:0000
2@T:008000003`T9500000T92PT92P0000T92PTB2P00014_?@TL50TB2PT9
50TV:@T92PT950042@T:00P92A@J4Q@971hA;c<92@X92A@971@A9Qh42@T:
00<000092@X000000PT92P0600002@T:000000002A8:00000PT92P0L0000
2@T:2@T:2A8:6Q8D2@TD2@T:4BHN2@TD2D574BlmPbmLUIRS8d5B2D57=6Mk
`LO<4Blm8blN0000H44DYZZS/:Z42@T:UHeB/:Z4UIQV4BH:0`000008ARHD
`J64/;>g`LO1b]3FEheL00002A8:0`T92P0<4A`:8a`:=2lN?A`:H5hc=2lN
00004A`:JUDN/8eB/:Z4kM2H0P0000H92@X03@TB2PT92PTB2R`B08=kG9F=
DV1N<`0001X92PT92P0000T92QX92P022@T:00</4P092@X92@X00PT92P0?
4A`:2@T:6PT:6PT:2@T:6PT:2@T:6PT:2@T:6PT:2@T:;1802@T:4A`:6PT:
00@92@X01a4L2QX92PT92QX92PT92P000;2c]`1Qc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI00Go
oOooo_ooo_ooooonool00ocoo`09mOOfl>o]h]gJdLK4b;JfaJna`jJZ_9nS
[iFH00N^UIP8[IBG<:fEU@R]U9L7[YFH00^_UIRgUic2XZO4Yj_5[:o=^k_C
alOQf=Wbk^ooooonool01?coo`;nool00ooooiVIVIVIV@2HVIVI00?oooo<
c<c<c<`0GLc<c0052A8:6Q8D2A8:2@T:4A`:00892@X0114L2PT92PT92Q4L
2Pd92@X00`TB2PT92PT92P0@2@T:00DA70X94PX92@X94PX000002@T92P03
2A8:2@T:2@T:00P92@X00a4L2PT92PT92P072@T:00<000094PX92@X010T9
2P0500002@T:2@T:2@T:2A8:00@92@X010TB2PT92P0000TB2PD92@X020T9
50TB2PT951XB50T9514V7PTL7PTB2P892A@020TB2PT92PTL52<_:A4_?@TV
:@T92QXB508A;c<01PTB2P0000T92PTB2PT92PTB2P<92@X01`TB2PT92Q4L
2PT92PTB2PT92P0000042@T:02<94PX92A@J4Q@92A@A;cdS;c=PLW^EV:>3
Q8h/Ie`/EE`S@Cd/EE`/Ie`S;bTA;c=69QBVZZ>EXHhA9P[]d9QbSE`A9PX0
00092@XJ4Q@92@YP;aC:d<71/jg:d<7foolA9PX000092A@00PT92P042A8:
2@T:2@T:;1800R<_7P0:UG97SHe72A8:6Q8DNd`:/8dc/:Z4dkj>=5DY2A8:
0PT92P032A8:2@T:2@T:00@92@X01@0009EbAhf=Aij=<`0000022@T:00@J
2@X92@X92@XJ2@X22@T:00XA70XJ2@XA70XJ2@X/4P092@XJ2@XA70X94PXS
70X26PT:00/A70X92@XJ2@XJ2@X94PXJ2@XA70X92@XJ2@XA70XJ2@X00PT9
2P8J2@X00a4L2P000:JZ[@1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI00Gonoooo?ooo_oooool
o_d00_coo`0Ao?cjiN7NeL_9c;jm_JVX]9ZK/92CX7f1XGf1WGYnVGUlUgMj
Tg=fTG5dTW9eUGEhV7Qk03REMGP:Tg=f016BLWF@L7>?Kg:ALGBEMGRKN7bO
N7fNMgbSOh>_Si:gWIjmZJ[;_KcJd<oXh^;eloCoool01Okoo`03ooooVIVI
VIVI09RIVIT00oooolc<c<c<c01Mc<c<00@J4Q@94PX0000A70X22@T:00<A
70X92A@A70X01PT92P074A`:2@T:2A8:2A8:4A`:2A8:4A`:00892@X00a4L
2PT92PT92P022@T:00<94PX92@X92@X010T92P096PT:2A8:4A`:2@T:2A8:
2@TD2@T:4A`:;18000H92@X00`TB2PT92P0000022@T:00<94PX000092@X0
1`T92P894PX00`T92PTB2PT92P032@T:00<94PX92@X92@X00PT92P030000
2@T:2@T:00<92@X00a4L2PT92PT92P022@T:00P000094PX000094PX92@X0
000A70X000042@T:00T94PX92A@92@XA9Qh92A@J4Q@92A@971@971h00PT9
500:6Q8D2@TD4BHN2BHY4Blc2BHY2A8:2@T:2BHY4BHN0PT92P052A8:0000
2@T:00002A8:00892@X01`0000TB2PT92P0000T92P0000TB2P042@T:02D9
4PX92A@92A@A9Qh99RW:d=JEV:>V/l5GSHhS@E8AC58/EE`/EFlS@E8A;c<d
;aj`ZXCLaj<0002VQ59bSCd000092@XJ2@XA70X0001P;aCLhn2`/kO1al7L
hn2EZZd000092A@A70X92@XA70X00`T92P0>4A`:8a`:;2HD;2HD^IQLAUDY
4BHDJT4:/8dcb[j]`K>>=5DY00002A8:0PT92P032A8:2@T:2@T:00<92@X0
1`000611:JJHKjJQIP00014L2PTB2P022@T:00/J2@X92@X92@XJ2@X92@XJ
2@X92@XJ2@X92@XJ2@X92@X01AX92P042@T:;1804A`:2@T:0aX92P0;4A`:
6PT:6PT:2@T:6PT:4A`:8a`:;1806PT:0000`K>]067<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT0
KOolooomooonoooooo[lnoWkn??clNOSh>3Edm;0_/Z`/K>CU:1lP9I]LHYO
IY1UK8MNI8MPIHUPIXMPIHMNI8IOI8UPIXURIhQOIHMPIHQOIHMPIHQOIHMP
IHQOIHMPIHQOIHMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQO
IhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMP
IHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQO
IhMPIHQOIhMPIHQOIhMPIHMNI8IOI8MNI8IOI8MNI8IOI8MNI8IOI8MNI8MP
IHUPIXMPIHMNI8IOI8UPIX]RJ9AUKH]LHXYMI9M^LZN4R;>FV;nZZLbj^]c@
d>gTiOchmoonoogmo@03o?go00?ooonIVIVIVIT0V9VIV@03ooooc<c<c<c<
05g<c<`02PT92P00014L2PTB2PT92PTB2PT92Q4L2PT92PTB2PL92@X010TB
2PT92P0000TB2PT92@X01@00014L2PT92PT92PTB2P052@T:00DA70XJ4Q@A
70XA70X000000PT92P0400002A8:2A8:2A8:0P0000052@T:000000002A8:
2@T:00<94PX01@T92P0000TB2PT92PTB2P032@T:00H000094PX94PX94PX9
2@X94PX2000000@92@XA70X92@X94PX42@T:01L000092@X92@X92@X94PX9
2@X000094PX000094PX92@X94PX000092@X000092@X000092@X92A@971h9
@DL0000A9Q@00PTL7P092A8:2A`N4BHN4BHD2@TD4BHD2A8:4Blc4BHN0089
2A@01`U1A`TL7Q4V7PT92P0000T92PTB2P022@T:0PTB2P032@T:00004A`:
00H92@X32A8:00D92A@A9Q@92@XS@E;CfMH00/77c00L2D578d5B8d4m8d5B
8d4m8d5B4BlmUHAB`K>]4BH:^JY_YZ5V00004A`:2A8:2A`D0000/8Akb]31
`K>]b]3FdmWFg>?P00002@T:2A8:2@T:2A8:0`T92P0?4A`:2@T:6PT:8a`:
=5DYARH:YZ5V8bH:JT4:YXAB`K>>g<NS=5DY00002A8:00892@X22A8:0PT9
2P894PX01@T92R`V5:JQI[VHG00000032@T:00@A70XJ2@X92@XA70X22@T:
00@J2@X92@XJ2@X92@X24A`:0PT92P036PT:4A`:2@T:008J2@X02`T92QX9
2Q4L2QX92PT92Q4L2PT92Q4L2PT92QX92Q4L2P036PT:00<0002VZZ?<c<`0
H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT01iVIV@1^oocooo_oo_coooooooomoOchl>_Wg=7=b;>`]iVI
[hR;XgIiYgIl^8F:`i2GeZ>Zk;g5k/3:llC>mLOAm/OAm<K@m<G?m<K@llC>
l/C>llC>l/C>llC>l/C>llC>l/C>llC>l/C>ll??l/C>ll??l/C>ll??l/C>
ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??
l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>
ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>m<G?llG?m<G?llG?m<G?
llG?m<G?llG?l/?=llG?m/OAmLOAm<G?l/C>l/?=llC<iK2hej:Xa96H/H24
X7=hWGIi[hf>`jNVd;^jhM7Am^c[oo_kookoo_oo0_coo`03o_ooVIVIVIVI
09RIVIT00oooolc<c<c<c01Mc<c<00@A70X94PX92@X92@X22A8:00HA70X9
2@X92@X0000A70XS9PX32@T:0PTB2P0300002@T:;18000T92@X00a4L2PT9
2PT92P072@T:00<94PXA70XJ4Q@00Q4L2P052@T:4A`:00002@T:2A8:0080
00022A8:00<000094PX94PX00PT92P094A`:00002@T:2A8:00002@T:2A8:
00002A8:00892@X32A8:00<000092@X92@X00`T92P0600002@T:2@T:2A8:
2@T:2A8:10T92P032A8:00002A8:0080000010TB2P0000TB2P0000@92@X2
2A8:01092A@A9QhA;c<92@X99RTA9QhA9PX971@92A@99RT971hA9Q@92A@9
71hS@E894PX22@TD00@/EFl971@A9Q@92@X22A8:00<000092@X94PX00P00
00032@T:2A8:000000@92@X00`TB2P0000T92P022A8:00L971@99RTA;c<m
;cg1albVan09@DL00b=1DP0C4BmB;5hm4BlcH5hcg<NS;4`YWXdc?Ehm0000
;4`Y2@TD2A8:0000`J64b]31`LO1b]3Fg>?Fdn?e009PGS<01@0000TB2PTB
2PT92PTB2P052@T:00`A70XJ4QB3Nc=6;`XA9QikC1BNSBV`ZXC:_Ze?IdL0
00094PX32@T:00<000094PXA70X00PT92P0600008bH:UIQV`K>>00004A`:
0PT92P0I4A`:2A8:2@T:6PT:2@T:4A`:2@T:4A`:6PT:2@T:;1802@T:6PT:
2@T:4A`:;1802@T:4A`:6PT:;1804A`:6PT:2@T:;1802@T:008J2@X020TB
2QX92QX92R<L2QX92PT92P000:JZXf7<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT04oolookioOom
o_oooOoonocgln[OfmBo_<JWYK:8RJekO[=jP<nDV^jc^ORm`oo:d?K3c?W7
d_k<e`02oloJ00?oc]WocMSocMP01oo>f@?oc]X0;Oo=g?o>f_o=g?o>f_o=
g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>
f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=
g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g002olkJ1oo>f@0Fo/cG
olgHolgHolgHo/cGo<[EnlWDo<WBnl;9olC:o/?9kKBjcIVM/X64Z7amZH:3
`J6Re;blk]cLoO?booglo_oo0__oo`03o_ooVIVIVIVI09RIVIT00oooolc<
c<c<c01Mc<c<00X92A@A70X92@XA70X92@XJ2@X92@XA70X92@X94PX52@T:
00<J2@X92@X94PX010T92P072A8:2@T:4A`:2@T:4A`:2@T:6PT:00L92@X0
1A4L2PT92PTB2PT92PTB2P024A`:00<94PX92@X92@X01@T92P8000000`T9
2P0000T92P072@T:00D94PX92@X94PX92@XA70X010T92P052A8:2@T:2@T:
2@T:4A`:00D92@X00a4L2PT92PT92P024A`:00d94PXA70X000092@X94PX0
00094PX000094PX000094PX0000A70X00P0000072@T:2@TD4Blc2BHY2@T:
4BHD2A`D00892A@03Q4_DPTL7Q4L2PT950TL7Q4V515<DPT95000079EDQ4_
DPT92PTL7PTB2P892@X00`TB2PT92PTB2P042@T:0PTB2P042@T:4A`:2A8:
2@T:0`TB2P052@T:6Q8D8blY4Blc8d5B00<99RT013ebQ2=1?BaEG4mbN`8A
;cd04ng@V3AE:A4L2R<_7P0008=k<`TB2PTL7V0_2/6c[L77`M?Ie/[@`McS
e[2n`G9WDW:=?FYW<`T92P022A8:00@92@XA70X92@XA70X22A8:00lA70X9
2@XS9PXS70Z3GQ@A9QAP;`ZNSBVVV6oC_Xi?IdL000094PXA70X92A@00PT9
2P036PT:2@TD;1`D00969Q@01Iik<iF=I[2ZQ000014L2P022@T:00<J2@X9
2@X92@X00PT92P046PT:2@T:6PT:4A`:0QX92P032@T:6PT:2@T:008J2@X0
0`TB2QX92Q4L2P036PT:00<92@XJ2@X92@X00Q4L2P086PT:2@T:6PT:6PT:
4A`:8a`:0000/;>gHLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8
`;R8`;P4c<c<00=VIVK<c<bIVIT01iVIV@;ooOl04OoooooooO[gl^kUh=[7
`L:UXKR<RkEnPLF7S=ZGW_J`^?o3b_bk`ORla?o:e?o<fOo?g002om3M00?o
cmcod=godMh02?oCh0;od^80;_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oB
i?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oB
h_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oB
i?oBh_oBi?oBh_oBi?oBh_oBi?oBhPSod]l00ooCh?oAg_o@g@02olkK0_o=
fP0BolgGol;:o[g3o;_1n[c1l[BifYnS_8F8YgEf]8Z;aJ>Rg/K6l^CSo?Kf
noglnOoon_ooo_ooVYVIV@03ooooc<c<c<c<05g<c<`00aXB514L2PT92P05
2@T:00@A70XJ2@X92@X000022@T:00@A70X000092@XA70X52@T:00D94PX9
2@X92@X92@X94PX00PT92P036PT:2@T:2@T:00<92@X00aX92PT92Q4L2P02
2@T:00DJ4Q@/9Q@94PX92@X000000`T92P0500002@T:2@T:2@T:2A8:0089
2@X01@0000T92PT92PT92P0000022@T:00<000092@X92@X010T92P032A8:
4A`:2@T:00<92@X00`0000TB2PTB2P092@T:00<000092@X92@X00PT92P03
00002A8:2@T:00892@X00`0000TB2PT92P022@T:00<94PX99RT99RT00Q4V
7P0D00004BHN2A8:2BHY2A`N2A`D2@TD0000;5EL4Blc4BH:?BlmLW9k4Blm
2A`N2@TD00002A8:2@T:000020T92P0400002A8:00002@T:0`TB2P044BHD
2@T:6Q`N4Blm0Q4V7P0L6Q`N;5EL;5EL;5ELCg9k?G:48d5BPg]LLXdm0000
2A8:0000PehcYZ5V0000H2l:b]31b]3FdmWF`LO1g>?F/;k14A`:AT4NJUDN
LXdm=2lc00000PTB2PH92@X04P0002<V2R`V54IE:B`V57]<2[2=D/6cS]c7
XdIE:A4L2QX92PT954HV2R<L2XeE2V0_58=N50:NLQ@01Hf=Al6cS[2ZQ<6c
SP0000022@T:00<J2@XA70XJ2@X00Q4L2P<92@X26PT:00TA70XJ2@XA70XJ
2@XA70XJ2@X92@XJ2@X92@X00QX92P052@T:6PT:4A`:6PT:2@T:00@J2@X0
1QXB514L2PT92QX92P0009FZ[F7<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT04_onoogmoOoooOoo
noKakNGJe=:k]KfGU:QeM;QhNMV@UnnRZ_jc^_nnaOnk`oo4c?o9e_o<f@;o
cMX2olcI00?ocM[ocmcodMh01_oAgP0bom3Pom3Rom3Rom3Tom3Rom3Tom3R
om3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3T
om3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3R
om3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3RolkN1oo?g003
om?Pom7NolkK00;ocMX2olkK01;oc=Woe=cobLko_L;i];Wb[K;VXJCDTiO4
RH^cPH:mTiCB];CZf=KilNolo?[hookiooonoonJVIVI00?oooo<c<c<c<`0
GLc<c0092@TD2@T:2A8:2@T:4A`:2@T:2A8:4A`:000000@92@X01@TB2PT9
2Q4L2QX92PTB2P042@T:00PA70X94PX92@XA70X92@XJ2@X92@XJ2@X72@T:
00@A70X94PX92@XA70X26RHD00@000094PX000092A@22@T:00<0000A70X9
2@X00`0000034A`:00002@T:00H92@X00`TB2PT92PT92P022@T:00<0000A
70X000002@T92P042A8:2@T:2@T:4A`:0`T92P072A8:2@T:2@T:00002A8:
6PT:2A8:00T92@X04a4_?BaN?A4_<`00061bNh>H[IFQ]`TL50TL7PTL514V
50T92RaWG0TB2PTL58<_G3AWN`TV:A4V7P022A8:0PT92P052@TD2A8:2A8:
2@T:2A8:00H92@X22A8:00<92@X92A@94PX00PT9500K2BHY8blY8blc8blY
4BlmCeiV;5E_Ehf>=6Mk2D57UG97LXdm00004A`:0000=2lN^JY_;4`YLSPD
b]3Fb]31b]3F/;>gkNgZUJZ]0000;1`D0096@Ah01VYW<fYE7R<_7PTB2QX9
2Q4L2PH92@X06AX92S@_7TH_2QXL7W]<2ZJ4D[VZKlZn[JJQIXeE2YF=0;1k
2Yj=<iik<k2=7Xf=Ah=k<jJ4DZJQI[2ZQ:JZXk2ZQ:JQIPTB2QX92P024A`:
00<J2@X92@X92@X00QX92P044A`:2@T:8a`:4A`:1AX92P074A`:;1806Q8D
6PT:2@T:6PT:8a`:00<92@X0114L2QX92Q4L2PT92P8J2@X01B`B01XB51X9
2P0009FQSP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0
^0C<c<`00fIVI/c<c9VIV@07VIVI01Coooolo?cooognoOSak>KSe<g=/Z^h
S8VlPX7:Q8KXUikbWjOhYjkn/KOn]Kcob=3ob=Gnbm[ocMcoc]d2olgL00?o
c]gocmkocmh01oo?gP;ocn80;_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>
i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?
h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>
i?o?h_o>i?o?h_o>i?o?h_o>i?o?hPSoc]d01?o@goo>gOo=g?o>g@;ocmh0
4?o=g?o9e_Nf__nj`?nnaOnl`?^`]NZOXmN@U<R8RKInOkV;RlZXYnC?c_O]
k?gmn`;iool00okooiVIVIVIV@03VIVI1@0000>IVIT2000000BIVIT00000
002IVIT200000YVIV@800002VIVI100000>IVIT400000iVIV@800006VIVI
100000>IVIT200001IVIV@800003VIVI0P0000:IVIT500000YVIV@@00003
VIVI1@0000:IVIT2000000>IVIT0000000000YVIV@@00005VIVI0P0000:I
VIT400000YVIV@800002VIVI1@000003VIVI0000000000:IVIT200000YVI
V@8000000iVIV@000000000<VIVI00?oooo<c<c<c<`0GLc<c00;6Q8D4A`:
2@TD4A`:2A8:2@T:6Q8D2@T:4A`:2A8:4A`:00892@X02A4L2PT950T92Q4L
2PT92Q4L2PT92Q4L2QX92P032@T:00PA70X92@X92@X92@XA70X92@XA70XJ
2@X22@T:00T/4P092@X94PX92@X94PX971@/>2TA70X000000PT92P040000
2A8:00002A8:0P0000892@X010TB2PT92PTB2P0000<94PX42@T:00<94PX9
2@X94PX00PT92P894PX00a4L2PTB2PT92P032@T:00<000092@X94PX00PT9
2P062A8:2@T:2@T:2A8:2@T:00000PT92P032A8:00002@T:00@92@X00`TB
2PT92PT92P022@T:01HA9Q@A;c<A;cdJ71ibLW]PLW/m;cfEV:<971hA9PX9
71@92A@J4Q@A;e892AAGGVoChoD/EFl971@A;c<A9Qh000042@T:00<92A@9
2@X94PX00PT92P074A`:2@T:2A8:2A8:2@TD6Q8D2A8:00<92A@0114V50TV
:A4_<a4_DP8S@Cd0=dmbNa5<DUN=SR=1DQXV52a<:@00014L2PT92R`L5<6c
SPTB2THV5=cSh>g]jZJZXjJQV>g]jRa<:@0000T951XB52<L2TIE:FYE7YFH
ITI17PTB2PT92Q4L2PT92PTB2Q4L2PT92Q4L2PT92PTB2R<V2R<_7Q4V2W]<
59j=<k2ZQ<Zn[FYE7/6cS/ZQD/ZZIZJQI[2ZQ=c7Xl6cSZJZXlZn[JJQV002
/:Z40ZJQV0042A8:4A`:6PT:2@T:0Q4L2P052@T:6PT:2@T:2@T:8a`:00@J
2@X01@T92Q4L2QXB52`B01X92P022@T:00//4P0J2@X92@XA70X92@XJ2@XA
70XJ2@XS70XJ2@X92@X00aX92P032@T:6PT:UJZ]067<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT0
4oonooono?Wnn?Cil^SUg][9`/FMVjidLlMmO/ekON>>TNjLW_RY[?ne^Ofb
]onla?^mb?_1coo5d`02olOE0oo7e0Gna]<2olGC00?oaMCnaMKnaMP0;Ok5
f00Ro/GFo/GDo/KCo/GDo/KCo/GDo/KCo/GDo/KCo<?Bnl?@oL?BolKDolSG
olKDo<;Ankg:ol;9ok^no;BgnZncnJZ]l:2Sg8b?ag]m^gUk]hB3`ifLf/G0
lNSSn_Wdn_oinoolo_oo19VIV@800003VIVI0P000004VIVI00000000VIVI
0`000003VIVI0000000000:IVIT2000000>IVIT0000000000YVIV@800000
0iVIV@0000000002VIVI0P000003VIVI0000000000JIVIT200000YVIV@80
0002VIVI0P0000FIVIT200000iVIV@8000000iVIV@0000000002VIVI0P00
0003VIVI0000000000:IVIT2000000>IVIT0000000000YVIV@80000019VI
V@00000009VIV@<000000iVIV@0000000002VIVI0P0000BIVIT2000000>I
VIT0000000000YVIV@80000019VIV@00000009VIV@800002VIVI0P000003
VIVI0000000000:IVIT2000000BIVIT00000002IVIT3000039VIV@03oooo
c<c<c<c<05g<c<`00a4L2PT92Q4L2P022@T:00<A70X92@X92@X00`T92P04
2A8:2@T:2@T:2@T:0PTB2PP92@X01QX92PT92Q4L2P00014L2QX92P892@X0
30TB2PT92PT92PT92PTB2P0000T92R`L52a<:@T92PTB2PT92P894PX00`00
00TB2PT92P022@T:00<000094PX000000PT92P032A8:0000000000894PX2
2@T:00H94PX000092@X92@X94PX000032@T:00<A70X94PX94PX01PT92P03
4A`:2@T:2@T:00892@X00a4L2PT92PT92P022@T:00H94PX92@X94PX92@X9
4PX000022@T:01T94PX000092@X92@XA;cdA;c<A;cf3V:f3Q8ibEE:3SH@9
2A@94PX92A@92@X99RTA;e9ZNfn3;ebEXKM?LW//GSdA9QhS;bT000000PT9
2P<94PX22@TD00@94PX92A@92@XA70X22@TD01d94PXJ4Q@92A@A70X971hA
9Qh971hJ71h99RTS;c</EE`/Ie`S@E9GSHhS;bT971@J2@X92@X92A@0002E
LTNVXFH0002VXIS:d<7Lhn2VXISCfMKChoD00P0000<92@X02b<L2S@_7VYW
<h=k<jJQIQ4V2PTB2Q4L2PTB2PT92P0000042@T:00HJ2@XS70Xd;aiZEAjV
XFK1/hh2/:Z400O1/hk:_Zg:_ZfVXISC_Xk1/jfiZVl00k2ZQ00;YYQ_`K>]
YYQ_/:Z400002A8:6PT:4A`:6PT:4A`:6PT:008A70X56PT:00H/4P0J2@XJ
2@XJ2@X92@X/4P024A`:00D92@XA70XJ2@XJ2@XA70X00PT92P056Q8D2@T:
4A`:6PT:4A`:00<J2@X00`0009FHXlc<c01Pc<c<00AVIVJ8`;R8`;Q8T8P1
0000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI017onogo
noSgoo[booGXjN7>^KC5RXbbH6C>JfkIMgKOS8KUW9?WYig][:Kk/K3o];Wo
]l400_nf``05okW6okg9ol3;okk9okc700Go_LP3okc82?nmbbSo_<X08Onm
b_nmb?nmb_nmb?nlb_nmb?nlb_nmb?njb?nka_nkbOnkaonjb?niaOngaOjf
`Ong^_jg]ORa[o>YY_6PWnjEUnJ7RmQnP<5bMJAXIkjITM:n]NONeOWfkOon
n?onnoooo@09VIVI0P000003VIVI0000000000:IVIT2000000>IVIT00000
00000YVIV@800004VIVI0`000003VIVI0000000000FIVIT200001IVIV@80
0004VIVI0P000003VIVI0000000000FIVIT200000YVIV@800002VIVI0P00
00:IVIT2000019VIV@<000000iVIV@0000000002VIVI0P000003VIVI0000
000000:IVIT2000000>IVIT0000000000YVIV@800004VIVI0P0000BIVIT3
000000BIVIT00000002IVIT200000YVIV@8000000iVIV@0000000002VIVI
0P000003VIVI0000000000:IVIT2000039VIV@03ooooc<c<c<c<05g<c<`0
11X92Q4L2PT92Q4L2P892@X01A4L2PT92Q4L2PT92PTB2P022@T:0Q4L2P04
2@T:;18000004A`:10T92P064A`:2@T:2@T:2@T:00004A`:0PT92P034A`:
2@T:4A`:00892@X01Q4L2PT92PT92PTB2SeN?CAE:@8000001`TB2P000000
00TB2P0001XB500000022@T:00<94PX92@X92@X01@T92P0300002A8:2@T:
00<92@X01@TB2PT92PT92PTB2Q4L2P022@T:00@94PX92@X92@X92@X22A8:
00<A70X94PX92@X00`T92P042A8:2@T:2@T:2A8:0`T92P0400002@T:2@T:
00001PT92P064A`:4Blc4BHN2BHY;5ELUIRS0Sd_?@0ICfML00002@TD2A8:
8d4m4Blm8blc/;>g?G:4PiR]=5Dm2A`N4Blc4BHD4A`:6Q8D4A`:2@TD4BHD
2A`D2@TD4BHN4BHD2A`N4Blc00<J71h01TIEDR`h:EMEDR=1DR=1?A4_<`8S
@Cd2;5EL01HAC59?LW//GSd000092A@A70X92A@S9PYZIc<dEBTJ2@[:_Zg:
d=KTd<bVXISLhn1kSHAZ@@XdEBT000094PXA70X22@T:00H/9QA6;`Z3Nc=6
C3f=SE8000032A8:00D92@X94PX92@XA70X92@X00Q4L2P0K=2lNWW8:^IQL
`K>]b]31`K>]`K>>g<NSb]31Pg/c`K>>/;>gdkj>YZZS/:Z4UJZ]Pg]Lb]3F
Nhf4YYQ_00006PT:4A`:;2HD2A8:6PT:4A`:008J2@X01PT92Q4L2R<L2QX9
2R`B01XB508A70X00`T92R`B02<L2P046PT:00<A70XJ2@XJ2@X00Q4L2P04
2@T:6PT:;1806PT:0Q4L2P8S70X00`000:JZ[Lc<c01Pc<c<00AVIVJ8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI
01Son_gonoSfoo[aooOUi]kE^KJlMGVnGFCFJ6_NMG;MRgoNVh[MY9?UYice
YjGnZJko[[Ko[[On[[On/KWo]Kgo^;oo]kko][d2o[Nm1?nf_@03okFmokJm
okJo02oo][l4okW11?nh`@;o]l42okS201Go]l7o]/3o];ko/k_k[k7i[jcb
ZjO]Y9k/ViS[TI3VPXCJMg[:LG>XHV2ZOGOC^k7[hMGoooCoo_SomoCoood0
1iVIV@@000000iVIV@0000000002VIVI0P000003VIVI0000000000:IVIT2
00000YVIV@@00002VIVI1P000003VIVI0000000000FIVIT2000019VIV@80
00000iVIV@0000000005VIVI0P0000:IVIT200000iVIV@8000000iVIV@00
00000002VIVI100000>IVIT2000000BIVIT00000002IVIT200000YVIV@80
00000iVIV@0000000002VIVI0P0000BIVIT200000YVIV@@00002VIVI0P00
00:IVIT2000000BIVIT00000002IVIT200000YVIV@8000000iVIV@000000
0002VIVI0P0000bIVIT00oooolc<c<c<c01Mc<c<00PJ4Q@971@92A@92@X9
4PXA70X92@XA70X22@T:00<J2@X92@XA70X010T92P054A`:2@T:2@T:2@T:
4A`:00D92@X01B`B00TB2PT92PT92QX92P032@T:00T/4P094PX92@X92@XJ
2@Y?Ie`J9Q@92@X94PX01@T92P0300002A8:2@T:00@92@X00`TB2PT92PTB
2P042@T:00/94PX92@X92@X94PX000092@X94PX92@X94PX92@XA70X01@T9
2P0300002A8:2@T:00@92@X00`TB2PT92PT92P032@T:00<000092@X92@X0
10T92P0J2A8:2@T:00002@T:2@TD4Blc2BHY4Blc2A8:CeiVARHDPhB>2BHY
2A`D6Q8D2BHY4Blm2@TDJW]_Y/OP4BmBdn?e2A8:4DaB4Blc2A8:0PT95009
2@T:2@TD2@TD2A8:2@TD6Q8D2A`D4BHN6Q`N00899RT03a4_<baEG2=1DW9b
NbaEG2aN?B=1DUMNKdIWG4mbNb=1DUN=SRaWG00000T92P034BHD00`S;bT0
002VV8C:d<71alc:d<71al7CfMHA9PX/4P1ZEAj3Nc<32A8:00/A70X92@X9
2@Y6@Aj3Nc=bSCfELTL/C2T92@X92A@94PX00`T92P894PX06`T9514L2R`L
58=N5;VHG;2ZQ=bn[L6cS[2ZQ<6cS]cSh8=N<nC@c9F=I/[@`G9bNl6cSX>4
NiEbAmc7XjJHQ:JHK`00014L2PT92QX92PT92P036PT:00<A70X92@XJ2@X0
11X92P032@T:6PT:6Q8D00@J2@X020T92QX92QX92Q4L2QX92PT92R`B01X9
2P8A70X00aX92Q4L2QX92P028a`:00<0003]kN[<c<`0H<c<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT01iVI
V@0Hoo_no_gkmoolmOohi]oIgKZhYEUM`UeSe6=UfG1/f8Ihf9F4fI^<h9fD
l9^Nn9jWmjJ/ljN[lZN[lJV/m:b_mJnamK6bm;2a0_>a/P03mK6bm;2amJna
00?e[k4=m:nb0oF`/a3d[k83mK2c3OB_/PKc/K<2mK2c0_B_/P;e[[805OB]
/O>//?>[[oBY[OBTYo>SY>^QW^>LU^>FT>:=R>5mOMUbLl]YJZmNGIUOFmbj
/NcNeOoom_oon_Sim?ooo@05VIVI1@0000:IVIT200000YVIV@8000000iVI
V@0000000002VIVI0P000004VIVI00000000000019VIV@800002VIVI0P00
0003VIVI0000000000FIVIT2000019VIV@8000000iVIV@0000000005VIVI
1P0000BIVIT4000000BIVIT0000000000006VIVI10000003VIVI00000000
00:IVIT2000000>IVIT0000000000YVIV@800004VIVI0P000004VIVI0000
0000000019VIV@800003VIVI10000003VIVI0000000000:IVIT2000000>I
VIT0000000000YVIV@80000<VIVI00?oooo<c<c<c<`0GLc<c0064A`:2@TD
4A`:4A`:2@T:6Q8D1@T92P038a`:2@T:2@T:00@92@X01Q4L2PT92P00014L
2P00014L2P892@X01Q4L2P0000T92PT92Q4L2PT92P8A70X22@T:00d94PX0
00092@XA70Y?IdL94PXA70X0000A70X94PX92@X94PX92@X00`TB2P892@X0
10TB2PT92P0000T92P894PX01PT92PTB2PTB2PT92PTB2P0000892@X01@TB
2P0000T92PTB2P0000062@T:00<94PX000092@X00PT92P054A`:00000000
2@T:6Q8D00<92@X01PTB2PT92Q4L2P0000T92PTB2P8000002`T92PTB2P00
00T92PTV:A4_<`TL50TB2TIWG0TV:@TL7P022BHY00<971hA9Qh99RT00PTV
:@092D57CeiVY[?12@TD8d4m4BHD2@T:2A`D6Q8D00894PX02PT950TB2Q4L
2PT951XB514V7PTV:A4V7PTV:AXL7P8S@Cd05Q5<DR=1?A4_DTmbNcebQ4mb
NcAWNg:=[EN=G00000T92PTL500000T950T92V11:L6c[K2n`L[@`L77`L6c
[McSh080000011XB52`B07:=?F1N<`894PX030T92Q4L2PTB2R`B04I17Yik
<h=k<iF=DS@_:@T950T92Q4L2P<92@X06PTB2QXB52<V2R`V58=k<kVZKmbc
Xl[@`H=kG<Zn[H=N<mcSh9EbAl[@`IF4Nl6c[FYW<l6cSYFHIYF4Nl77`JJH
Q8f=A`0001X92PT92P8A70X020T92QX92PT9514L2PT92R<L2QX92R`B00<J
2@X02Q4L2QX92Q4L2QX92R`B014L2PT92Q4L2QX92Q4L2P8J2@X01@T92QX9
2QX92QX92Q4L2P036PT:00<S70X0003Lhn00HLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT01iVIV@0Foo_o
o_knmoolnOoijMcFikjlTD54`UUMceeMeFYTeGm`eHileiF7gIJ@kiJLm9VR
kinRk:2PjZ2OjJ:PjZBRk:JT0^fYYP;[ZZH2kJVV00C^Z:K]YjG]YjG]YjD;
k:RW6^fYZ0_/Z:L6jZVW0^bXY`;YYJ@01^ZTY>VSXnVSXnRRX^RPXN^OX@;_
VYl03nBJVMfFT=bBRMf8PMmiMMU]JlMJGKUIFY9<B^Zm^>_Gd?Sek_cono[o
o?koo`04VIVI100000BIVIT200000YVIV@8000001IVIV@000000000009VI
V@02000000>IVIT0000000000YVIV@8000000iVIV@0000000002VIVI0P00
0003VIVI0000000000FIVIT2000019VIV@8000000iVIV@0000000005VIVI
1@0000>IVIT0100009VIVIVIVIVIV@8000000iVIV@0000000002VIVI0P00
0003VIVI0000VIVI00:IVIT2000000BIVIT00000002IVIT300000YVIV@03
0000VIVIVIVI00800004VIVI0P000003VIVI0000000000:IVIT2000000FI
VIT00000002IVIT000000iVIV@8000001IVIV@000000000009VIV@020000
00BIVIT00000002IVIT3000039VIV@03ooooc<c<c<c<05g<c<`02a4V50TB
2PT92Q4L2PTB2PT9514L2PT92Q4L2PT92Q4L2P032@T:00hA70X92@XA70X9
2@X94PX92@XA70X92@XA70X92@X94PX92@X94PXA70X22@T:00<94PXJ2@X9
2@X01PT92P07AUi7AUDYARHD4BH:8a`:6PT:;180008A70X011X92Q4L2R`B
00T92P<94PX0214L2PTB2PTB2Q4L2P0000T92P0001XB50<94PX01PT92PTB
2PT92PTB2P0000TB2PD92@X00`TB2P0000T92P082@T:0QXB50042A8:6Q`N
000000000PTB2P0600002@T:2A8:2@T:2A8:00000PT92P042BHY4BHN2A8:
2A`D0PT950082A`N2A`D2A`N2A8:2BHY4Blc2A8:2@TD0R=1DP0300002BHY
2A`N00@94PX00`T92PTB2PTB2P022A8:01<92A@971@971A6C3dm;ce?GVH/
EE`S@E8S;ahA;c<S@E9GGVm?LW]GSHh/EFl/GSd971@000094PX00PT92P0P
0000H44Yb[j]/;k1`LO1YZZS/;>gg>?Fb]3FYZZS00006Q`N;1`D4A`:JUDN
PehcPg/c00006Q8D2@T:2A8:2@T:AUDY=2lNUHeBLXdmUHeB00002A8:0000
2@T:4A`:0`T92P0H6RHD;2HDWW8DYZ5Vdkj>b]31LUEBdmWFPg]Li=3<YYR4
b]31YYR4`LO1PhAkb]31SHe_`K>]/;>g`K>>LXdm00002@T:4A`:0QX92P09
4A`:6PT:6PT:;1806Q8D2@T:4A`:6PT:8a`:00DJ2@X00b`B01X92R`B0002
4A`:00@J2@XA70X92@XS70X24A`:00TJ2@XA70XJ2@XJ2@X92@Y6;`XS70X0
003:d=H0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4
c<c<00=VIVK<c<bIVIT01iVIV@0Ioo_oo_komoomoOojkmgIl<?0QcDg^e5C
cEMEdfAKe7QYeHIgeXb1g8j:jXnHl9>MjiJIj9RGj9ZHiibIiifJj9jKj:6M
j:>NjJBO00?XXih2j:6M00?ZX9gYWicXXIl01nRQW`04ij2Nj:6Oj:6Oj:6O
0nVRX003jZ>QjJ:PjJ:P00kYXZ001>ZSXNVRX>VRX>VRX0?XXIl00nNPW^RQ
WnRQW`06j:6O00?WXIoVXYoWXIl01NNQW`;XXIl00nNPW^JOWNRNW@02iifL
01;ZW9c/TY_ZTi_PU9CGT8[FS8?JPg[LLfoIIV?:DeFmD5>>?Ccd_k_`em?g
m>ohooggooolool4VIVI0P0000JIVIT200000YVIV@80000019VIV@000000
09VIV@800003VIVI100000>IVIT4000000>IVIT0000000000P0000BIVIT2
000019VIV@H00004VIVI0P000003VIVI0000000000BIVIT400000iVIV@@0
0003VIVI100000>IVIT2000000>IVIT0000000000YVIV@@00005VIVI0P00
00:IVIT400000YVIV@800002VIVI100000:IVIT2000000>IVIT000000000
0iVIV@8000000iVIV@000000000<VIVI00?oooo<c<c<c<`0GLc<c08J4Q@0
0`TB2QXB50T92P026Q8D00HA70X92@X92@X92@X94PXA70X62@T:00LA70X0
00092@XA70X000092@XS70X00PT92P044A`:2@T:2@T:2@T:0QX92P034A`:
2@T:2@T:00892@X02TIE:C@_:DIE:DHV514L2R<_7QXV514L2R<L2Q4V2P<A
70X030T92PTB2QXB514L2PT92QXV51XB50T92P0000T92P0000T950<92@X0
0`TB2PT92PT92P022@T:00<000094PX92@X02PT92P0500002@T:2@TD2@T:
000000892@X010T950T92P0000TB2P892@X06P0000T92PT950TB2QX92P00
014_?@TV:@T951XB50TB2PTL7Q4V7PT950TL7Q4V7Q4_<`TV:@TB2SebQ14_
DQ5<DQ4V7PTV:@T92Q4V7P8J4Q@0:PT9514L2QXB50TL50TB2PT9514L2PTB
2PT92PTL7Q4V7R<_<b=1?A4_?A4_D[2n`JJZ[Ng]jUN=SQ4V2Q4V5000014L
2PT92QXB50T92V11:H>4Nk2c]h>HS[2ZQ;2c]m?Ie]cSeXfHS/6c[M?IeP00
00T92QX92PT92R`B00:3Nc<00`TL50TB2Q4L2P022@T:00</9QAZIc=ZEAh0
0Xf=DP05AT4N2@T:2A8:4A`:2@T:008A70X03PT952<_7TH_2Yik<k2ZQ<Zn
[IFQS/6QQ<6c[K2ZQ<[@`K2c]l[@`JJZX`;:d<405jJHQ<[@`H=kG<6c[K2Z
Q14V50T951XB50T92QX92Q4L2QX92R`B014L2PT92QX92R`B00T952`B01X9
2R<L2QX92R<L2P036PT:00</71@92@XJ2@X00QX92P08;1804A`:6PT:6PT:
4A`:6Q8D4A`:6PT:0R<L2P046Q8D;1800000g>?PHLc<c004IVIVR<2hR<2h
B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT01iVIV@0C
oo_oookonOomoookm^GNm/_5RCTh[TA4ae1<d5]BdVeQe7Y_dh1heh>3h8F>
iHRCiXfAiI6?iYFB00;VUi<01>FGTnBIU>BKUNJMU`;UW9H2iIZE0^JHU003
iINCiiVGiIZG00KUVYL00n>HUNBIU^BIUP02iIZG0^JKV003iibIiIZGiIZG
00kUVYL00nNLVNJKV>JKV002iIZG0^BIUP03hiREiIZGiIZG00KUVYL6iYbI
0nNLV@03iY^HiiVGiYRF00;UUiD04nJFUNNEUnF;U>><U=R<S=68P]63NMAj
LMQYH]EKF<eADK=3@XXd<oS1__kUhOolnOSooo3oo?coo`04VIVI0P0000>I
VIT200007IVIV@800006VIVI0P0000:IVIT200000YVIV@800005VIVI0P00
00:IVIT200006iVIV@80000;VIVI0P0000RIVIT200004iVIV@80000<VIVI
00?oooo<c<c<c<`0GLc<c0076RHD4BHD2A8:6Q8D4A`:2@T:4A`:00892@X0
0a4L2PTB2PT92P0;2@T:00</4P092@X92@X00`T92P034A`:00004A`:00D9
2@X060TB2P0005MWDTmWAcAE:CeN?C@_:CeN?B`V51XB53eN?AXV50TB2R<_
7PTB2Q4L2PT92R<_:A4V2QXB514V51XV500000TB2P892@X00`TB2PT92PTB
2P042@T:00<A70X92@X94PX020T92P894PX32@T:00<J4Q@92A@92@X00P00
00034BHN2A8:000000892@X0800000T92PT92PTB2PT92P0000TB2PT9514_
<`TL7PT92PTB2PT9514V514V7PT92QXB52=1DRaEG0TV:A4L2RaEKa4_DQ4_
?@TL7Q4_<a4L2Q4V7PTB2PT950T92R<_:@892A@08QXB50TL53@_<g9EDQXB
514L2PT950T92Q4V7R<_:B=1?H>HSTmNIRa<:@0000T950T92Q4L2PT95000
00T92TI17ZJZXiFQSYF=IXf=Kl77`NC@c<[@`H>4Nh=kG=cSh<6c[B<V2P89
4PX040T92Q4L2ULL08=k<ij=:@00014L2P0000T92R<L2R`V56YW<fYE7Xf=
Ahf=DP0000894PX42@T:00M69QAZ@@Z3Nc>iZVo1/hk1/jg:d<400/77`@0B
b]31/:Z4i=3<SHe_b]31YZ6HYYQ_`LO1SHe_YZZSAUDY00002@T:4A`:6Q8D
2@T:6PT:4A`:0QX92P044A`:6PT:2@T:8a`:0QX92P03;1802@T:6PT:008J
2@X00b<L2R`B00T92P046PT:00<A70XJ2@XA70X00QX92P08;1804A`:6PT:
6Q8D6PT:8a`:6PT:`LO<HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT01iVIV@0Eoo[oooconocnoookn_3W
mm;:T4I3WSPd^T<oada5cUiCdFYQcG9]cGMheG^5fX2:gX>8hHR:iXf?iY2A
i92@00;QT8l01>6AT>>CT^>CT^:BT@;RTI000n>?Sn:>S^2?SP08hY2B0^2>
T004hHnAhY2BhY2Bhi6C0^BBU13RT982i9:D00CSTI?RT9;RT9;QSi42h8j@
1n>AT`03hY:Ci9BEi9BE00CTU9D2iI>E00?STI?RT9;SSY400n6<S`0ChXb?
hHbAfhB=ehB<dH>3bgagc7E/d6]SdEYDcDe:`TE3Y3HeSchko/_7oo;^ookk
nOoomOooo?oo00FIVIT500007iVIV@030000VIVIVIVI00FIVIT4000019VI
V@<00003VIVI0P0000>IVIT200006YVIV@80000;VIVI0P0000RIVIT20000
4iVIV@80000<VIVI00?oooo<c<c<c<`0GLc<c0052@TD6Q8D6PT:2@T:2A8:
00892@X00a4L2PT92PT92P022@T:00<A70X92@X92@X00PT92P0>4A`:2@T:
2@T:4A`:2@T:4A`:2@T:6PT:2@T:4A`:2@T:4A`:2@T:;1800PT92P894PX0
60T92Q4L2PT92Q4V2SAE:F1N<b<_7SeN?B<_:DIE:AXV51X92SAE:AXB514V
51XV52<L2Q4V50T92Q4L2QXB50T92Q4V2QXV50892@X010TB2P0000T92PT9
2P<94PX01@T92PTB2PT92PTB2P0000022@T:00@A70X92@X92@X92@X22A8:
00L92@X94PX92@X94PX92@XA70X94PX00PT92P894PX00`0000T92PT92P02
2A8:00<000094PX000000PT92P894PX09Q4_<a4V7PTB2QXB50T951XB50T9
514V514_<a4_?BaWG14L2Q4_?BaEKcAWN`TL52aEG2=1?@TV:@TL52<_:@00
02a<:CAE:A4L2PTB2Q4V7P000:JZXiF4SSdB2YFQSPTV:@TB2PTL51XB52<_
7PT92P80000020T92PTB2PT92PT92V1N<hf=DYFQS/77`@;1/jd01:JZXm?I
e]cSeYFZ[@96@Ah0<L6cS]cSh<[@eYF=DP0000TB2Q4L2PT92S@_7THV58=k
<dI<?@T950TB2PT950T92R<V2TI17X=N<fYW<hf=DR<_:@0001XB50T92Q4L
2PT92Q4V54HV56YE7Yik<l6cS/[@`G:=Q>BZV=cSe[2ZQ>C@c:JHQ=?IeYF=
I]cSh:JZXjJHQ<6c[K2c]h=kG14L2PTB2P026PT:00l92@XA70XJ2@XA70XJ
2@X92@XJ2@XA70XS70X92@XJ2@XS70XJ2@XJ4Q@/4P000QX92P04;1806PT:
4A`:4BHD0QX92P03;1804A`:6PT:00@J2@X01`T92R<L2R`B01X92R<L2P00
0;2c]`1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@07VIVI01Kon?oon_olo?knoo_ln>gcf<f@E4b><bj/
=SBn?S_9Cd[?GUS<J6K:LG?;N83@OhKFOhGLPhOPRXgRSI3QS8oMRhd2g8b=
0]f?S`;MSHh01=f;SMb:S=^9Rm^9R`SMSI02fXZ=00CKRhkLS8oMSI3MSI02
gXjA4=b<S`;NSY42gHf@00CLS8oKRhkJRXgJRXd8gXjA1=f>T@CNSY401=n=
TMj<T=f;Sm^9S@?MR8d04]b:S]1oQ/ioQLYlO<MdL<UZI<aOF/a?Bl=3@:lh
=9H`;9IAB_oHd_ojm_okn_[koocoookooiZIVIT00oooolc<c<c<c01Mc<c<
00LJ4Q@A70X92@XA70X92@XA70X94PX00PT92P034A`:6Q8D2@T:00892@X0
1`TB2PT92Q4L2PTB2Q4L2PT92Q4L2P052@T:00<94PX92@X92@X00PT92P0=
4A`:2@T:2A8:2@T:00002@T:2A8:6RHDCfML=2lN4BH:AUDY8blN008/>2T0
1b<L2SAE:A4L2R<_:B`V50TB2Q4V50022A8:0Q4L2P074BHD6RHD2@T:0000
2@T:2A8:000000892@X22A8:00<92@X000094PX00PT92P072A8:2@T:2@T:
2@T:2A8:2@T:2A8:00<92@X02@TB2PT92Q4L2PT92QXB50TB2PT92PTB2P00
00032@T:00@000092A@94PX000032@T:00@92A@J4Q@99RTA9Qh22@TD0PTL
7P0J4BHD2A`N2BHY2BHY4BmB4Blm2D57?G:4;5EL2A`N8blcLUEBPehcLUEB
UHAkPg]LCfML2A`N4BHN6RHD=2lN=2lcYUEVYXB4UHAkSHe_0Ra<:@0U6PT:
6RHD2@T:2@TD;1`DAT4N8blNARHDH5hcLXdmH5hcCfM7Phf4b]31dmWFb]31
dmWFYZZS;4`YARH:`K>]b[j]b]31kNgZg>?PLXdmSHe700002@TD4A`:2@T:
6Q8DWXdYPg/cAUDY2@T:4A`:00892@X084I17TIE:FYE7Xf=DYF=DQ4V2PT9
514L2PTB2Q4L2QX92TI17VYE7ZJQI/6cS/[@`FYW<l6cS^C@c:JQV>C@c<Zn
[Ng]j[2c]jJZXl6cSVYW<k2ZQ9FQS/6cSP0000T950<A70X01R`B00T92QX9
2Q4L2R`B00T92P8J2@X01b<L2QX92R<L2R`B01X92Q4L2PT92P026PT:00D/
4P0J2@XJ2@XJ2@XA70X011X92P034A`:6Q8D4A`:008J2@X01B`B02<L2R`B
00000;2c]`1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0
^0C<c<`00fIVI/c<c9VIV@07VIVI01?ok_con?oooooiooWlooKon>Z^OgF4
=BjR=C:W:RS1@D3DFUW?IfSEO7kJSiCJTiONTYKSTiKUUYT00^BHVP03hiVJ
hYZKhi^L00;SWId00nBLWN>KW>FKW003i9ZK2>>KWP;PV9/01>6IW>:JWN>K
W^>KWP?TW9l01n>KW^6IW>2HVn2HVn6IW>>KW^BLW`08hYZM0nBLW`;SVih3
hYZM2>>KWPCRW9h4hi^N01WTVIgWW:3WW:3SV9cQUIWRUY[QUIWMTYKESY;T
W9oAQHG?MgGJLVniAT?7AdJ^<BnC9R>?>S>OJf3on>ooo?Sln?Woo?oonOoo
o_l0VYVIV@03ooooc<c<c<c<05g<c<`01AXB514L2PT92PT92Q4L2P022@T:
00D94PX92@X92@XA70X000000`T92P044A`:2@T:2@T:2A8:0PT92P0=2A8:
6PT:2@T:6PT:2@T:;1804A`:2@T:6PT:4A`:6PT:4A`:2A8:00892@X04aX9
2PT92Ra<:IFQSP0002<_7TmWA`0002`h:DI<?@0003AE:@0002a<:@T9514L
2QXV50T92Q4L2P024BHD00<J4Q@S;ah000000PT92P0300002A8:000000@9
2@X32A8:10T92P032A8:2@T:2@T:00<92@X32A8:00DJ2@X94PXJ4Q@00009
4PX00`T92P894PX32@T:00<92A@92@X92@X00PTB2P0C2@TD8d4m2BHY2A8:
4BHD2@TD4BHN6Q`N4Blm4Blc6Q`N;6ML6Q`N8d5B;5E_4DaBEei_g;jgkMW<
00;fkNX05OKfmOKomIEbA`0004HV2[VHG>BZV=bn]ngIc?K]jYF4SQ4V2R<_
7R<L2R`L54I17YF4DYFHIZJHKiFHIYF4N`02YZZS0iFQSP07g<NSb]3FNheV
JW9L4BH:0000H2lD00;1/jd01^C@c=?Ie]cSh=cSh4I<?Hf=A`<94PX00a4L
2QX92R<L2P02Pg/c00X000094PXA70X92@XJ9QA6;`Y6@Aj3Nc>=SE96EBT2
2A8:00lJ4Q@0000d;bU6@Aj3Nc>iV5c:_ZgL_[NEZZgL_[OfooFVXIS:_Zf`
/kO:d<400ZJQV007`LO1JW9L`K>]`K>>NheV00004A`:00@J2@X02Q4L2R<L
2PT92QX92R<L2PT92QX92PT92QX92R<L2P<J2@X012<L2R`B01XB52<L2PLJ
2@X00a4L2QX92R<L2P026PT:00<S70XJ4Q@S70X00QX92P03/;>gc<c<c<c<
05o<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003
IVIVc<c<VIVI00NIVIT06?odoooco?onooWooNgikOklkmbl/Fh]9hhZ:9`T
9KHh>LY?DMU`M>N>T=^EUmJHVNZUZ>fWZNn[[>j/[Nf[[>b/[>Z][>^^[@;^
/[400nnb/Nja/?2`/003kjn_2>j`/@04jjf^k:j_k:j_kJn`0^j`/@?_/K80
1nj`/Nb^[n^][^^][^b^[nj`/Nna/P08kJn`0nna/P;^/;43kJn`2>j`/@C]
/K44k[2a00G_[k3b/[?b/[?^[Zo^[:h00^n][`0Bjj^/m[JggYZKeh^;ojNV
aE]K_DI8_D53UR0PVS/gIb<Jgkfaoo[^o?WdookoooSoooWooogoVYVIV@03
ooooc<c<c<c<05g<c<`00aXB50T92Q4L2P024A`:00<94PXJ4Q@92@X00PT9
2P032A8:4A`:2@T:00<92@X0114L2PT92PT92Q4L2P892@X0114L2PTB2PT9
2Q4L2P<92@X00a4L2P0001X92P032@T:018A70X000094PXS@Cf=SFl0000S
;ai6EE80000S@CddEBT94PXdEBT0000dEBT92@XA9Q@S9PX24A`:00LA9PXA
70XJ9Q@J9Q@94PX000094PX010T92P064A`:2@T:2A8:2@T:2A8:2@T:0PTB
2P052@T:2A8:2A8:2@T:4A`:00<92@X00a4L2PT92PTB2P022@T:00<J4Q@9
2@X92@X010T92P0300002A8:2@T:00<92@X02@TB2PT92PTB2PT9514V50TL
7QXB50T950TL50022BHY018A;c<A;cdA;c<A;cdS@CdA;e8/EE`9@DOL/jg]
fLcTal7fkN[Lhn3LhmKTd<bELTNNLS?1Ng/2i<O1017fkN[LhmKfooF3Nc<0
000A70X/71A69QB=SE;:d<6`/kO1/hj`/kO1al7:d<7LhmK:d<400]cSeP03
YZZS4BH:000000892@X01FYW<k2ZQ=cSe/6c[L[@`@03kNgZ00_1/hi6EBUP
GS<94PXA9Q@92@X94PXS70Xm70Z3Nc?:XCd00`T92P074A`:;2HDARHDJUDN
LXdmYYQ_000000894PX021XB54HV56YW<iik<k2ZQ<[@`L6c[H=kG0;:d<40
7jJQV<Zn[JJQV<6cSZJZXiF=IZJQV9FHIYFQSZJZXaXV50T950T92Q4L2QX9
2PTB2PT92R<L2PT92QX92R<L2PT92Q4L2QX92PTB2R<L2R`B01X92R`B01X9
2R`B00026PT:00H/4P094PXJ2@X92@XJ2@XJ4Q@36PT:00@92@XJ2@X/4P09
2@X26PT:00@/4P0/71@00031alaQc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI01SomOool?Kooooh
oog_ooGnooKon_6TLFef8R2>92JM:Bbb?d;PO7knZZ[`[jgY[jgX[ZgZ/:o[
/k;[]K?Z];;W];7V]K7U]K44ikNc0^Nf/P;X]K88ikFd00?U/k;V];?V];<0
0^Ne]0;X][D2jKNf00OX][GV];?U/k;U/k;V];?X][GY]kH02>Ne]0CX][D<
ikFd1^Jf]0;W]K@00nJd/nRf]NZg]P02ikBc01CY][GX]KCW/JoSZJO/ZjWb
YZK]UICQN7bgATZI9RV471e]7a^[Ng7onN[gnNcloo_gmOSon?oomooooOnJ
VIVI00?oooo<c<c<c<`0GLc<c08A70X22@T:00<A70X92@XA70X00PT92P03
6PT:2@T:2@T:00@92@X01@T9514L2QX92PT92Q4L2P042@T:00DA70X92@XJ
2@XA70X92@X00Q4L2P0O2@T:2A8:2@T:2@T:2A8:2@T:AT4NJXeL0000=5DY
LXeL2A8:H5hcAUDY;180CfM70000AUDY2@T:8bH:;3PY0000;1804A`:4BHD
;2HD6RHD2@T:00002A8:000000<92@X00`0000TB2PT92P032A8:0`T92P06
6Q8D2@T:4A`:2A8:2@T:4A`:10T92P054A`:2@T:2@T:2@T:000000<92@X0
0`TB2PT92P0000032@T:00P94PX92A@94PX94PX92@XJ4Q@A9Q@92@X24BHN
00dS@CdA;c<A;cdS@E8S;c<A;c<S@CdS@E8/EFnVEFKLhmK:d<7]fL`00]cS
eP05i<O1g;jgb[j]g;>Si=3<00;]fL`03oK]j_o]c?oooa4V2QXV514L2P00
06YW<jJ4DW^=IXf=Kg^=Q8>4NjJQV=cSeP02g>?P00VVXIQ6EBT000092@XA
70X92@YZEAkLaj?L_[L00]cSh009`LO<kOKeg>?FkNgZb]31`LO<LXdm8blN
4BHD008A70X0:`T92R<V2V1157]<2W:=?@00014L2PT92R<L2R<V2V1158f=
AjJQIV1N<`T92PTB2THV54I17X=k<k2=D/ZZI/[@`Hf=KnC@c:JQV>C@c<6c
[LZn[FYkKl6c[JJZXjJHQ;2c]jJQV8f=KjJHK`00014L2PT92QX92Q4L2QX9
2Q4L2P026PT:00@J4Q@J2@X/4P0J4Q@2;1800QX92P038a`:6Q8D6PT:008J
2@X00b<L2R`B01X92P026PT:00XS70XJ2@XJ2@X/4P0S70X92@X/71@J2@X/
4P0J4Q@2;18000<J2@X/4P2`_/40HLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT01iVIV@0FooGgoo_moOgm
n?onmoomo?okoocfon3MWE]LJ18CPAdOYCi1`VMViiJChIfJiJZViZn/ik:^
jkJbj[Ncj;Nbi[Na1^Bg/@CV]k40;nJf/^Bg/^Jf/^Bg/^Jf/^Bg/^Jf/^Bg
/^Fe/N>f/NFe/N>f/NJf/^Bg/^Ng/nFh/nNg/nBg/^Fe/N>f/NFe/N>f/NJf
/^Fh/nJf/^Bg/^Jf/^Bg/^Jf/^Bg/^Jf/^Bg/^Jf/^Bg/^Jf/^Bg/^Jf/^Bg
/^Jf/^Bg/^Jf/^Bg/^Jf/^Bg/^Jf/^Bg/^Jf/P02i;Nb00?S^;;T]k;S^;80
1>Bg/P0Ii;B`ikNcikNciKFai[FaikJbiKB`i:n[jJjZgi^HokFbj9BBa6AV
SBP/QR4UM1hOUUUFon[Qooc`n?ofn?omn?SjooSooo7noogo09ZIVIT00ooo
olc<c<c<c01Mc<c<00P94PXJ2@XA70XA70X92@X94PX92@XA70X72@T:00dJ
4Q@A70X92@XA70XJ4Q@000094PXJ2@X94PX92@XA70X92@XJ2@X01@T92P0E
4A`:6PT:2@T:4A`:6Q8D;2HDAUDY8bH:8blNJW]_2@TD=5DYAUi74A`:;4`Y
8blN6RHD4BHN6Q8D6RHD4A`:00894PX00b`V51XL7Q4L2P052@T:00<94PX9
2@X000000PTB2P0600002@T:2A8:4A`:2@T:4A`:0`T92P062@TD4A`:2@TD
4A`:2A8:6Q8D0PT92P044A`:2@T:2A8:2@T:0PTB2P0300002@T:2@T:00<9
2@X05Q4L2QXB51XB51XB50T950T92PTV:@TL7Q4V7QXV50TV:@TL7R=1?@TV
:B=1?BaEG14_?BaEG3ebQ4mbNnC@c=bn]`?Td<`01>gIc=bn[NgIc>C7`@;]
fL`09mcSe_K]j_KomNg]j/Zn[G8h014L2Q4V2Q4L2PT92S@_:JJQIX=k<dI1
7TH_2^g@V<6c[Hf=Ka4V2P0000T92QXB514V51XB56YE7/6c[NC7`McSe^g]
j^gfmL6c[OKomMcSh=cSe/[@`McSeZJQV61N<`0000026Q8D00L92@XS70XA
70YZEAjNNc<92A@94PX00Q4L2P0O=2lNAT4NPehcSHe7^JY_00002A8:=2lN
ARHDJUDNWXdcb[j]YZZSAT`mkMW</:Z4g;jgb]31`LO1`LO</:Z4YZ6HNheV
Pg]L/:Z4UHB>JXeL00002A8:2@T:6PT:008A70X00aX92PT92QX92P036PT:
00DA70XJ2@XJ2@X92@XJ4Q@00R`B00@J2@X04b<L2QXB51X92R<L2QX92R<L
2R`B014L2QX92Q4L2R`B01X92R<L2QX92R<L2QXB52`B00000;2n`@1Qc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`2IVIV00?<
c<bIVIVIVIT01IVIV@0Eoogiookko?cjnOglnoooo_kol^SYooOhonk_KC4a
L2HURc`hXe9?jI^GhY^Eh9fGh:6Lh:FQiJZViZbXi:fX00;R[JL00n2^Yn:`
ZN:`Z@02h[2Y1>F`ZP0_iK2/hk2/iK2/hk2/iK2/hk2/iK2/hk2/i:n[hZn[
i:n[hk2/iK2/hk2/iK2/hk2/iK2/hk2/i:n[hZn[i:n[hZn[iK2/hk2/iK2/
hk2/iK2/hk2/iK2/hk2/iK2/hk2/i:n[hZn[i:n[hZn[iK2/hk2/iK2/hk2/
iK2/hk2/iK2/hk2/iK2/hk2/iK2/00;S/:`00n:a[>>`[>:a[004hk2/01WT
[j_U/:cU/:cS[Z[T[J[U[Z_QZZONXioPVYSZX9gES8K0MG2@@3n6=3I[6aie
<C;oj^OonO;goO7doo[_o?Gnoooologon?oooOl0VYVIV@03ooooc<c<c<c<
05g<c<`02AXB514L2QX92QX92Q4L2PT92QX92Q4L2PT92P032A8:0`T92P0A
6Q8D2@T:2A8:6PT:4A`:2@T:6PT:4A`:2@T:2A8:2@T:;1804A`:2@T:;180
2@T:4A`:00<92@X01QX92PT92Q4L2R`h:DmWAaXL7P8dEBT02DI<?@TB2SeN
?B<V2PT92SAE:@0004I17Q4L2P024BH:00HJ2@XJ4Q@A9Q@A9PX92@X94PX4
2@T:00<000094PX92@X00PT92P082A8:2@T:2@T:2@T:2A8:6Q8D4A`:2@T:
0a4L2P082A8:6Q8D2A8:6Q8D2A8:4A`:6PT:4A`:0`T92P032@TD2A8:2@T:
00<92@X32A8:00h92A@S;ah94PX99RTA9Q@A70XS;ahA;c<A;ce6Ie`A;cdS
@Cd/EE`S@E82;5EL00</EFoL/jgTal400nC@c003i<O1g;j]i<O100;]fL`0
6oK]j^g]j_KfmOKomNg]jYEE5;1E0=c7Xa4V2R<_7Q4L2Q4V50T92PTB2S@_
7X=k<k2ZQ<6c[Ba<:@TB2Q4L2Q4V51XB514L2PT92ZJQI[2ZQ002g>?F00oL
hn3]kN[]m_FVZZ?foooLhn3LhmKTd<cLhn31albEXHh0000A70X92A@A70X0
0PT9500TARHDH5hcJVLc2A8:6PT:2A8:2@T:AT4NJT4:LXdmYZ5V;3PY2@T:
=2lN=2lYPg/cWW8ci=3<SHe_YYQ_kNgZYZZSYZ6Hg>?FYZZ]b[j]SHe_`K>]
UJ6>SHe_`K>]/:Z44BH:2@TD2@T:4A`:11X92P046Q8D6PT:6PT:;1801AX9
2P0<8a`:6PT:6Q8D;1806Q`N;1808a`:;1808a`:6PT:8a`:6Q8D0QX92P06
;1808a`:6PT:;1`D2@T:6PT:0R<L2P04?A8:8a`:;180/;k1HLc<c004IVIV
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00AVIVK<c<aVIVK<
c<`6VIVI01GkooSjooWnoogoooogm?_oo?ohkOGon_gomOKom?=lBdIE61>9
A3f1=S33MW3APgoAQhCCS8SITXkLUi;LVI<00]ZIT`GJVi@4g9^E02oLViOK
W9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OL
ViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOK
W9OKVYKJViKKVYKJViKLViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OL
ViL00]^LU`?IW9L4fibG01WKVYKLViOKVYKJVIGLV9GMVIKHU97CS8SBPgoG
R8>]I5jFDDai=C9>3Pj?DE;ol?7om_ConOGioo[_ooScooglooohjo;onOoo
oOl0VYVIV@03ooooc<c<c<c<05g<c<`01PT9514L2PT92Q4L2PT92Q4L2P89
2@X00a4L2PT92PT92P052@T:00<A70X92@XA70X010T92P05;1802@T:2@T:
2@T:4A`:00@92@X00a4L2PT92Q4L2P032@T:00U6@Ah/>2U6EBT/C2T/>2U?
IdL0000d;ah/9Q@00PTL50034A`:8bH:2A8:008J2@X24A`:00@J2@XS;ah9
2@X94PX52@T:00<92A@94PX92@X00PTB2P892@X0214L2PT92PT92PT92Q4L
2PTB2PT92QXL7P894PX010TL514L2PT9514L2P894PX42@T:00@94PXA70X9
2@X94PX32@T:00D94PX92A@S;ahA9Q@/>2T00Q4V500=6Q`N4Blc8blY4Blm
4BHN8blc4Blm8d5B4DaB=6MkPhf4i<O1b]3100;Td<`01NgIc>C@c>C7`NgI
c=cSh004m^gZ00K1/jeb9P2iLS?T_XCokLaP;`X28bH:00PJ4Q@92@XA70X9
2A@d;ajiZVmZEAhA9Q@26Q8D00@A9Q@92A@A70ZNQ6H2b]3100O]kN[]m_G]
kN[]m_GCfMJVXISfool00]cSeP0^kNgZg>?PkNgZ`LO100004BH:6Q8D2@T:
6PT:2A8:4A`:ARHDJVLcAUDY00004A`:2@T:;180=2lNJUDNSHe7SHeBAUDY
=2lNLSPD/8dNYYQ_dmWFUHAkYYQ_i=3<`K>]YZ6Hi=3<Pg]L`LO<UHAk`K>]
`LO1/:Z4YZ6H;4`Y6Q`N00006Q8D2A8:0Q4L2P092@T:6PT:2@T:;1806Q8D
6PT:6Q8D6PT:4A`:00<J2@X2;18000LJ2@X/4P0J2@XJ2@XS70X/4P092@X0
0QX92P8S70X01aXB52`B00T92QX92R`B02<L2QX92P028a`:00</71@0003]
kNX0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<
00EVIVK<c<bIVIUVIVK<c<`01IVIV@0HlOofl_oeo?omoogoooKoooSoooWo
ooGmooCfoo[fooG]WW=ZEadBLbdUPRl[UC/j[eED]5YJ^f5Q_fMV`6YY`6aZ
_fi[`6m/0ke/J@03_VeZ`6aZ`6aZ00;1KF/0<<1/J[i]J/1/J[i]J/1/J[i]
J/1/J[i]J/5]Jkm^Jl5]Jkm^Jl5]Jkm^Jl5]Jki]J/1/J[m^Jl5]Jkm^Jl5]
Jkm^Jl5]Jki]J/5]Jkm^Jl5]Jkm^Jl5]Jkm^Jl5]Jkm^Jkm[JKe/JKm[JKi]
J/1/J[i]J/5]Jkm^Jl1/J[i]J/1/J[i]J/1/J[i]J/1/J[i]JPBmKVX4_VeZ
01VoJfW0K6ZoJfVnJVS1Jf[3KFbmIfJhH5j]DTn=>3=g;RME5PmS;RRTM73o
k^ooko7fhN3oo__hoog[o_SeooocnOWonooon_ooo_l0VYVIV@03ooooc<c<
c<c<05g<c<`01aXB514L2PT92PT92Q4L2PT92QXB50022@T:00@A70X92@X9
4PX94PX22@T:00@J2@X000092@X94PX92@T:00P94PX92@X92@X92@X94PXJ
2@X92@XJ2@X24A`:00`S;ah/>2U?IdLJ71hS;ahmGSdS;bT94PX/>2TJ9Q@A
70X92@X24A`:00L92@XA70X000094PX92@XA70XA9PX00PTB2P0400002@T:
00002A8:0P0000892@X04P00014L2P00000000TB2PT92PTB2PT92PT950TB
2Q4V7R=1?Ba<:A4L2PTB2Q4L2P0001XB50<A70X00`T92PTB2PT92P022@T:
0PTB2P072@T:2A8:2@T:2@T:2@TD6Q8D4A`:00<92A@24BHN00`A;c<S@CdS
;c<S@CdA;cddIg^VZZ?Td<cTal7Td<cTal7Td<`4kMW<0_K]jP0;m_Keoooo
`J64bZYVi<O1g>?FkMW<m_oeAUDY4BH:6Q8D008A70X00`T92Q4L2PT95003
4A`:00T/71@A9Q@92A@J4QAZIc?Laj?:_ZgCfMK]kNX00^gfm@0;m_oedmWF
Phf4m_ookNgZg>?PkOKekNgZkOKe/;>g4BH:008A70X0<QXB514L2QXB50TB
2Q4L2TI17VYE7R<_7PT92Q4L2PT952`V51XV54HV58f=AfYE7TI17X=N5=>n
S/Zn[L6c[Mbn]l77`LZn[L[@`JJHQ>g]jZJHQ9FQS/6c[H=kG:JZXk2c]iFH
IP00014L2PT92QXB51X92PT92R`B00T92Q4L2R<L2PT92R`B01X92R<L2QX9
2PT92P8/4P003AX92QXB51X92R`B02`L51X92R`B03dB2QX92Q4L2QX92PT9
2R`B00036PT:00@A70XS70XJ2@XJ2@X28a`:0b`B0003dmWFc<c<c<c<05o<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c006IVIV
c<c<VIVIVIVIIVIVc<c<19VIV@0IjOo`lOofnooloo[nooSooncoooWooo_o
ookooo[doo_aoo?Voo7Vol[2Y4m:QBHTL0h?Ma<EOA/LPR8SQBDVQ2TXQR/Z
QR`[Q2XY00>5:bX2Qb`[0XX/;0R7;2/4R2d/1XL/:`B8;B`2Qb`[28P];004
QBXYQR/ZQR/ZQR/Z0XL/:`:8;B`7Qb`[0XH/:`03QBd[QR`[QR`[00:6;2/2
Qb`[01V5:RV6:bZ8:RZ8:RZ;;Bf=;bn7:BV08R1l6QUi81bNEDkof];ol^co
jNCom?Com_Son_[glo3eoocbooo]o?WgoooooOojlOKoo_l0VYVIV@03oooo
c<c<c<c<05g<c<`031XB51X92Q4L2Q4L2PT92Q4L2PT952<L2PT92Q4L2PT9
2P0000@92@X02A4L2PT92QX92PT92PTB2Q4L2QX92PT92QX92P022@T:00@/
4P0J2@X92@X94PX62@T:00XA70Y6@AhJ9QA6@Ai?IdL0000dEBU6EBT0000/
>2T24A`:00D92@XA70XA70X92@XA70X00PT92P054BHD6RHD2A8:2A8:0000
00@92@X01PTB2PT92PT92PTB2PT92PTB2P@92@X01P0000TB2PT92PTB2P00
00TL7P9bSJd02DIWG2<_:@T92PTL51X92Q4L2Q4_<a4V7PT92P032A8:00<J
4Q@94PX92@X00`TB2P032@T:2A`D2@TD008A9Q@011XL7PTV:A4_?B<_<`8A
;c<01Q4_DQ4_?IF4S^gIc=bn]nC@c0G]fL`2g>?F0_K]jP06m_KekOKeong<
m^gZkNgZong<0_Kom@054BH:2A`D4A`:4A`:2@TD00<94PX020T9514V514V
514V7PT95611:JJHKlZn[@;LhmH5kNgZ00?Lhn1bIe;fool01^g]jP066RHD
2A`D4BHD6PT:2@TD6Q8D0Q4L2P8/9Q@0261150T9514L2PTB2QX92QXV52`V
5611:@96@Ah02[2=<l6cS^C@c9F4NmcSe/6c[JJZXm?IeYFQS/77`@:VXIP0
2<77`K2ZQ<6c[L6cSP0000T950T92Q4L2P<92@X01B<L2PTB2QX92PT92R`B
00066PT:00<J4Q@/4P0/4P000R<L2P0>;1808a`:?A8:6PT:4A`:6PT:4A`:
;1806PT:;1806Q8D;1806PT:;1800R<L2P06;1806Q8D8a`:;1`D0000dmWF
HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT00YVIV@03IVIVc<c<c<c<0?o<c<`>c<c<00?oooo<c<c<c<`0
GLc<c0084A`:2@T:2@T:6PT:4A`:2@T:6PT:4A`:1@T92P042A8:2@T:6PT:
4A`:0`T92P032A8:2@T:6PT:00<92@X00a4L2P0000T92P032@T:00<A70X9
2@XA70X00PT92P0;8a`:AT4N4A`:6RHD=5DY4A`:2A8:8bH:8a`:00004BH:
00892@X02@TB2PT92PT92PTB2Q4L2Q4V2S@_:AXV514L2P042@T:00@94PX9
2@X92@X000032A8:00D000094PX92@X94PX92@X010TB2P052@TD4BH:6Q8D
8d5B=5Dm008S@Cd34A`:00HJ71hS@Cd/C2T94PX971@92A@22A8:00T92@X9
4PX94PX94PXA70X92A@92@X92A@A70X00PTV:@088blY4Blm8d5B8d5B?G:4
YZ6HkMW<i<O10^C@c00:g>?Fong<kMW<kMW<kNgZg>?Fm_Kem^gZm_oem_Ke
0oK]jP08m_oem^gZm_oeg<NS00002A`D2@TD2@T:0Q4L2P0<6Q8D2A8:6Q8D
6Q8D6Q`N2A8:H2lDg>?Fi=3<g>?Fg>?PkOKe0ng]jP07kOKekNgZkNgZ`LO<
kNgZg>?PkNgZ00;Lhn002/[@`McSe/6cSP00014V514L2QX92PTB2QX92PT9
2P8J2@X05dH_2TIE:@00014L2PT92QXB53@_7VYE7S@_7Yik<l6cS/6c[H>=
Q:JHKl6c[L[@`JJHQ<[@`K2c]l6c[L77`JJQV:JZX`02UIQV00<000092A@9
4PX00`T92P8A70X01PT92QX92QX92Q4L2QX92R<L2P8J2@X03B`B02<L2QX9
2QX92R<L2QX92R<L2R`B02<L2QX92R`B02<L2R`B00036PT:00<S70XJ2@X/
4P000aX92P088a`:;1806PT:;1808a`:;1`D;180`LO<HLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT00iVI
VOmVIVH@IVIV00?oooo<c<c<c<`0GLc<c0044A`:6Q8D4A`:4A`:0PT92P0>
6Q`N2A8:2@T:6PT:4A`:2@T:4A`:2@T:4A`:6PT:2@T:4A`:6PT:4A`:0`T9
2P054A`:2@T:4A`:6PT:2@T:008A70X010T92PTB2Q4L2QX92P892@X0214L
2R<L2QXV52a<:A4V51XB52a<:@00008A70X03@TB2Q4L2PT92Q4L2PT92QXB
51X92Q4L2QXB52a<:B<_:AXV50T92P032A8:0PT92P036Q8D2@T:2@T:00D9
2@X00`TB2PT92Q4L2P022@T:014J4Q@92A@A9Q@S;bT/>2U?IeaZNhA?LW^3
V:ebSH@mGSd0000J71h92ABEXKLS;c<000000PTL500F6Q8D2A8:2@TD2@TD
6Q8D2@TD4A`:6Q8D4BHD2A`D2BHY8blc2D574Blc4BmBEei_2BHYYZ6Hong<
g>?FkMW<i=3<0mcSeP05ong<kMW<kNgZong<kNgZ00?fm_D01oK]j_KfmOo]
c?ooooo]c14V2PTB2P026Q8D00<A9Q@J4Q@A9Q@00QXB50044BHD2@TD6Q8D
JUDN0]cSeP04i=3<g>?PkNgZkNgZ1Ngfm@03m_oeg>?FkNgZ00CLhmH01]?I
e/77`McSh14L2Q4V2QX92P<A70X02QXB514L2R<L2Q4L2THV54I17PT92S@_
7VYE7TI17P9P@BT06LZZI]c7XjJZXmbn]k2ZQ<Zn[L77`JJQI/77c8>=Q<6c
[IF=IZJHQ<Zn[IFQSP0000T92PT951XB50T950T92Q4L2PT92QX92Q4L2P03
6PT:00`/4P0J2@XS70X/4P0J4Q@J2@X/71@/4P0J2@Xm70X/4P0J2@X2;180
00HJ2@Xm70XJ2@XJ2@XS70XJ2@X28a`:00<J2@Xm4PXA70X00R<L2P07;1`D
8a`:;1`D8a`:;1`D;180/;>g067<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI0?nIVITCVIVI00?oooo<c<c<
c<`0GLc<c00:4A`:2@T:4A`:6Q8D4A`:6Q8D4A`:6PT:2@T:2A8:0PT92P0=
2A8:2@T:4A`:2@T:;1802@T:2A8:2@T:4A`:2@T:4A`:6PT:2A8:00892@X0
2Q4L2PT92PT92P0002`B00TB2Q4L2PT92PTB2PT92P8S9PX02DH_2Q4V2PTB
2R`B00TB2PT92PTB2PT92P0000052@T:00DA9Q@/9QA?IdLd;ahA70X00`TB
2P892@X01A4L2PT92PT92PT92PTB2P052@T:00<A70X92@XA70X00PTB2P0@
6Q8D6RHD8blY4BlmLXf4JW^4H79kY[?1PiR]UJ6gPhf4;5hm;4`Y8d4mdn?e
UIRS0P00000C2A8:2A`N4BHN2A`D6Q8D2@T:4BHN2BHY2A`N2@TD8blc8d4m
Eei_LUEBYYR4i<O1WW8c0000?Ehm00?]fL`01nC@c>gIc=cSh=cSh?o]c?K]
j^g]jP02m^gZ0_Kfm@0<m^gZm_oem_oePg]L00002A8:4A`:2@TD4A`:2@T:
2@TD2@T:0Q4V50042@T:=2lN/:Z4`K>]0/[@`@03g>?Fg>?PkNgZ00?]m_D0
1OKoooKomMcSh=cSe]cSh003kNgZ0lZn[@08g;jgg>?P`K>]4BH:2A8:4A`:
6PT:2@T:0a4L2P0?6PT:6Q8DH44D=2lNNd`DPehcAUDYLSPDWW/cb[j]`LO1
^JY_dmWFPg]Li=3<00:VZZ<02l[@`JJHKl6c[L6cS/77`IFQSP0000T92PTB
2PT92Q4L2P022A8:00@A70X92@XA70XS70X36PT:00DJ4Q@/4P0J4Q@J2@X/
4P000QX92P098a`:?A8:6PT:;180;1`D;1806PT:;1`D?A`:008S70X011X9
2R`B01X92R<L2P8/4P000aX92R`B02<L2P02;1800R<L2P03?A`:;180/;k1
067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003
IVIVc<c<VIVI00jIVIT2ooom1_ooo`;oo_l01_kmnockmoWel_3_j^[Wh^GR
gA3Jem8_f=OC00?Hem;Jem;Jem803M[GdP08fmK@f]K;in7Ej^KKl>cSo?Oc
o_[goo_j1Oono`Cnool00ooooiVIVIVIV@2AVIVI00?oooo<c<c<c<`0GLc<
c0076Q8D4A`:2@TD?Blm2@TD4A`:6PT:00892@X00a4L2PT92PT92P032@T:
00<94PX92@XA70X010T92P094A`:6PT:2@T:2@T:;1802@T:4A`:2@T:2A8:
008J2@X32@T:00DA70XS9PX94PXA70X94PX01@T92P894PX010T950T92PTB
2PT92P8dEBT013d_?DIE:A4V2PTB2P<92@X01A4L2PT92Q4L2Q4L2PTB2P06
2@T:01894PX92@X94PX94PX92@XA70X92A@S;c</C2Td;c>3Q8j3V8j`/kNE
V:>3V8jEV:>`_/5GIe824BHN00ddIg^E/lc:d=J3Q8hm;cdS;c</71@99RTA
9Qh/>2UGEE9ZIc=GGVl00jJQV009`K>]g;>Sb[j]i<O1kMW<g>?FPehc0000
JW9L00?fkNX04NgIc=cSh>g]j^g]j_K]j^gIc>gfmOo]c?Kool[@`L6cSQ4V
2P0000TB2PT9514L2PTB2P034A`:018A9Q@J2@XS;ahd;aibSCf`ZXBVXIS:
_ZgLhmKLhn3]kN[]m_Gfooo]m_GfooG]kN[Lhn3:_Zd3kNgZ00CLhn3]kN[]
kN[Lhn02g>?F0]cSh008SHe_2A8:4A`:4A`:6Q8D2@T:4A`:2@T:0Q4L2P0F
;1`DPehcAUDYJVLcJUDNbZYVdkj>`K>>YZ6H`K>>b]3F/:Z4b]31YZZS`K>>
/;>gUJ6>`LO1dmWF=5Dm00002@TD0PT92P<94PX52@T:00HA70X/4P0J4Q@/
4P0S70X/4P026PT:00`J4Q@/4P0J2@XS70X/4P0S70X/4P0m4PX/71@/4P0m
4PX/4P026PT:00DJ4Q@/4P0J2@X/71@J2@X00R<L2P056PT:6Q8D8a`:;180
;1`D008/4P000k2n`Lc<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0>VIVI1?ooo`0=ookoooom
ookoooomookmoOWfm?7/j^OPhmkHg=WBem;<d/k5b<6i00k9`;L00lS1]lK2
^LK2^@0^a/:i00?8`KW9`;O9`;L03<W0]`09bL6fb/>ce<fkfM74gMG:i]oG
kNGRm>k^oogn00Coo_l2o_oo00?looonooooool0TiVIV@03ooooc<c<c<c<
05g<c<`01A4L2PT952<_7R`B01XB50032@T:00HA70X92@X92@X92@X/4P0A
70X22@T:0Q4L2P086PT:4A`:2@T:2A8:4A`:2A8:2@T:4A`:10T92P044A`:
2@T:6PT:4A`:10T92P032A8:2@T:2A8:00@92@X00`0001X92PTB2P022A8:
00L92@X94PY6@Ai6EBUbSCdA9PX92@X00a4L2P064BHD;2HD6RHD6PT:4A`:
2@T:0PTB2P892@X00`TB2PT92PTB2P022@T:0PTB2P076Q8D4A`:;3PY;4`Y
EfMBYZZ]CeiV00:3V8h08G^=Q9FQSZJc`L77`C@_7W:=?C@_7R<_:JK7h=?S
mNgfmM?SmOKooiF=IZJHKij4IZJ4DYj4I[24Nl6QQ:J4Q<6QQ;24Nl6QQ;VZ
Kl6c[MbcXmbn]nC7`L6QQ8=N<a4_?IF4SP02kMW<0_K]jP09kNgZm^gZkNgZ
kNgZg;jg^JY_;18000002A8:00892A@020TL51XB50T950T92QXB50T951XV
53@_7P96EBT01X=kG:JZXk2c]l77`L[@`McSeP;]kNX2kOKe00K]kN[Lhn3T
d<cLhmK]kN[]m_D3kNgZ0^gfm@08kNgZg>?Pg>?Fg>?Pm_Ke4BH:4A`:6PT:
0Q4L2P096Q8D4A`:2@TDH44YPg/cJUDNH44YNd`DbZYV00;1/hh04/[@`JJQ
V<Zn[L6c[IFQS/Zn[L77`JJQV<6c[K2c]l6c[H>HSP0000T92QXB50T92PTB
2QXB50D92@X24A`:00<J2@XJ4Q@J2@X00aX92P0D8a`:6PT:8a`:;1806PT:
8a`:;1`D?A8:?A`:8a`:6PT:;180?A8:;1808a`:6PT:;1806Q8D6PT:;180
0R<L2P056PT:;180?A`:;1808a`:008m70X00b`B0<77c<c<c01Pc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VI
V@0>VIVI1?ooo`;oood02ooonoonnoWflO7/i^CMeM;;`LJo]Knh[[ZcZKN_
Y;2TV00>/J>H0[2TV00_[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ
[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH
[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ
[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH00naXiP02K6TU;>VTkbaVkndX/6eYl[0
]]?:aN7Ieo;/k003ooko00?oooonooonool00_coo@03ooooVIVIVIVI096I
VIT00oooolc<c<c<c01Mc<c<0QXB50034A`:2@TD4A`:008A70X00aX92PT9
2Q4L2P024A`:0`T92P034A`:2@T:;180008J2@X02a4L2PT92QX92QX92Q4L
2PT92R`B00TB2PT92PTB2PT92P026PT:00D92@X94PXA70X92@XA70X00PT9
2P0400002A8:2@T:2A8:0PT92P0900002A8:4A`:2@T:2A8:;1`DH5hcAUDY
8bH:00894PX02aX92PTB2QX92R<V2R`h:B`V514V2R<L2Q4L2PT92Q4L2P02
2@T:00@94PXA70X92@X000042A8:00H92@XJ9Q@d;bUZNfnEZZeZNfl2SIR>
01B3V8j=V8jEZZg1albVXIREZZdS;ahJ9Q@A9PYZNhBV/l6`/kNVXIR`Q6JN
LS>`Q6J`Q7^VQ8BVV8BVXIP2YXB400J`NfJVQ8BVQ8B`Q7^`ZXBVXIP2b[j]
00STal6iV5aPLW/mLXB3SHBVZZ?Lhn3fkNX2kMW<00GL_ZgT_XC]ahBiLS=k
C1@00QXB500<2@TD6Q8D2A8:4BHD4A`:6Q8D8bH:=2lN=5DYEeEBPg/c/:Z4
0ZJHQ003/;>gg>?PkNgZ00?]m_D01?Koong]j]cSe^C@c0?]kNX00mcSh?Ko
mNg]jP02kNgZ00kLhn3]kN[LhmKLhmKfooEbSE`0000971@A70XJ2@X94PXA
9QA6@AiZEAh2H44Y01JVQ5;:ZVKLaj>`/kNEXHkTal6`/kNVXIS:d<6VZZ?1
al6`/kN=SFo1/jg1al5ZSE`000092@XA70X92@XA70X94PX72@T:00h/4P0J
2@XJ2@X/4P0J2@XS70XJ2@X/4P0J2@XS70XJ2@Xm4PX/4P0m70X2;18000<m
4PXm70XJ2@X00SdB2P0:6PT:;1806Q8D8a`:;1806Q8D?A8:;1806Q8D;180
0R<L2P05;180;1`D;1`D;180/;k1067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00jIVIT05_onooooookn
o_gmoOoooOoonoomn?_fl?;[hm_Db/No];neZKJ/X:VMSj2DQZ2CPin<OZ2:
O9f7NIZ4MYR2M9N1L`:FP787VH=e0YN4M@0_UXEeUXAfUXEeUXAfUXEeUXAf
UXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEe
UXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAf
UXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEe00RIPgD2V89d0YV3
M@:JQ7H049^5Mi^6MJ6?NIf=M:>BOZnPSKR[VknbZLo4_^3Fe>oWiOWcloon
ookno__mo?gooP;lood00ooooiVIVIVIV@2AVIVI00?oooo<c<c<c<`0GLc<
c0892@X020TB2QXB50TB2Q4L2QX92PT92Q4L2QX92P<92@X01a4L2PT92Q4L
2P00014L2PT92Q4L2P032@T:00TA70X92@X92@X92@XA70X94PX92@X94PXJ
2@X00Q4L2P892@X0114L2PT92PT92PT92P894PX05@0000TB2PTB2PT92PTB
2P00014L2PT92Q4L2TIE:FYbG0TB2P0000TB2Q4L2PTB2QXB52<V2R`h:C@_
7R`h:@028blN00@A70X94PXA70X94PX22@T:00h94PX92@X94PX92@X94PXJ
4Q@92A@94PX92A@99RU6GTMZNfn3Q8j=V8h2UJZ]02R=V8j3V8j`_/71alb3
Q7]kSFHdEBT/>2Td;bV=V8j`Q7^iZVnVV8C1XHBVV8C1XHCL/j>VZZ?L/jfV
ZZ?1XHBVZZ?1XHB`Q7^VXIRVV8BVQ8B`Q7^VQ8BVV8C1XHCL/hBVV8B3V:dm
LXBVQ8C1/jg]fLcfooGokL`2kMW<01ViSC=P@A@971@92A@A70X92A@J2@XA
70X/9Q@/71@J9Q@d;ai6@Aj3Nc=PGS=6@AjVV8BVZZ?:_Zg]m_Gfooo]m_G]
kN[]m_Gfool00mcSeP07kNgZg>?PkNgZg>?PkNgZkOKem_oe00;]kNX2g>?F
00gTd<cooom6Ie`A70XJ2@XA70X92A@/9QAP@A@d;aiP@BUZEAj`SE800]c7
X`0>SHe_g;jgb]3F`K>>`K>]SIR>YZ6H/;>gYYR4/;k1/:Z4b]31EheL0000
0Q4L2P032@T:2@TD2A8:00<92@X04@TB2PT92PT92PT92Q4L2QX92PT92QX9
2R<L2QX92R<L2QX92QXB52`B01X92R<L2QX92P02;18000Xm4PXS70XJ2@X/
4P0S70YG70169Q@/4P0J4Q@/4P026PT:00`/4P0S70XJ2@XS70XS9PX/71@/
4P0S9PXm4PX/71@/4P31alaQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0>VIVI0_ono`0No_kooOgmoook
ooojnoK`lncRdLVnd<Nh`kNW[9n>WXinUXEcRGQVNfUESG=RSW=RSg9RSG9Q
SW5QSW=RSg9RSgASSW5QSG9QSW5QSG9QSW5QSG9QSW5QSG9Q0XabH@0^S79S
S79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79Q
S79SS79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79QS79S
S79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79Q
0XebH@0KSW5QSG9QSW5QSG9QSW5QSG9QT7=SSgAST7=ST7ETTGATT7ETTGAT
T7ERUWiVS7MLS7INV8=^Y99n[Yj>^jfRa[bcfm;;kNGRoOWfooomoooo00;n
ool00ocnoOoooiVIV@2BVIVI00?oooo<c<c<c<`0GLc<c08A70X010TB2QX9
2QX92QXB50<A70X01@T9514L2PT92Q4L2PT92P026PT:00PA70XJ2@X92@X/
4P0A70X92@X/4P0J2@X24A`:0PT92P0400004A`:6PT:6PT:0PT92P034A`:
2@T:2@T:00<92@X00`TB2PT92PT92P042@T:01<J2@X92@XA70XS9PYZIc=6
9Q@92@XA70XJ2@XA70XJ2@XS9PXS;ah/>2U6EBUP@BTJ9Q@A70XJ2@X00Q4L
2P<94PX040T92PTB2PTB2PT9500002<_7Q4V2PT950TB2Q4L2Q4V54mWAiFH
XiFZ[K2n`JJZX`:=V8h01;2n`L[@eW^=Q6YbG096C3d034mWAfYbG:JQV<6Q
Q:JQV>BZV<6cS]bn]mbcXnC7`Mbn[Mbc[@;L/j<2b[j]00>VZZ?L/j>VXIP0
0ZJ4Q0:EQ7/03;VHG>g@V<ZZIP0002aEKeN=SYF4DX>4Nl6cS_o]c=bcG000
00<94PX01A4V52`L52`L51XV52<L2P026Q8D014dEBU6@AhS;ahA9QiZIc>V
V6n`ZXC]kN[fooo]m_G]kN[Lhn3]m_GfooGLhn3]kN[]m_D00ng]jP;]m_D0
1?KomNg]j^g]j^C@c0;LhmH04?K]j_oooa4V2Q4L2Q4V50T951X92VYE7VYW
<c@_7VYE7Yik<kVZKk2ZQ:JZXjJHK`;:d<4028f=KnC@c8=kG<Zn[JJZXl6c
S/[@`K2c]`8000001A4L2PTB2PT92PTB2QXB50022A8:00<92@X94PX92@X0
0Q4L2P0=2@T:6Q8D6PT:4A`:2A8:;1806PT:;1806PT:;1806PT:2@TD;180
008S70X013dB2SdL2SdL2R`B008J2@X044HV2SdB2R`B02<L2R`B01XB52<L
2R`B02`V52`B02<L2R`B03dB2R`L52`B04HV508m4PX00k2n`Lc<c<c<c01O
c<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIV
I/c<c9VIV@0>VIVI01ono_onooono_ono_kooo_nnoCaj^3Rf/g=`K71]:>Y
VXFGQg2QSGFnZ93D_ZKM`jcce<3ddl;he<Cge/GkelOif<Olf<SjfLSieLGg
e/GieLGge/GieLGge/GieLD00oOFa@0]mmK7mmK5mmK7mmK5mmK7mmK5mmK7
mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5
mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7
mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK700?ge/D07oWEaOOFaOWEaOOFaOWE
aOOFaO[Fa_SGa_WEaOOFaOWEaOOFaOWEaOKF`NW;/Mc1Y<bbUkNOQJ:<M9b7
LZ^JR;nbX/Vm/McCb_?_i_onnOoooOooookooo_mo?ooo`2CVIVI00?oooo<
c<c<c<`0GLc<c0064A`:6PT:6Q8D4A`:;3PY2@TD0PT92P036PT:6Q8D4A`:
00892@X0114L2PT92PT92QX92P8A70X03@T92QX92Q4L2Q4L2PT92P0001X9
2Q4L2P00014L2PT92Q4L2PT92P024A`:00<94PX92@X94PX00PT92P894PX4
2@T:00@94PX92@X92@XA70X22@T:00e6EBT/4P0J2@XA9PXJ2@XA70XJ9Q@d
;bTS9PXd;c=6EBU6C3dS70X00a4L2P076PT:4A`:2@T:6Q8D2A8:2@T:2A8:
00892A@03FYbG5MWDPTB2PTL50TB2P0002=1?H>=Q8>4S/77`IFZ[JJQV:JZ
[@02b]3F00>3Q7]ZNfnEXHh00W^=IP09;3PYLXf4`J64g;>SYZ6H`K>>g;j]
g;>Sg;jg00C:_Zd02]c7XlZn[Mc7XjJQV:JZXl6cSZJZXjJQV:JHKb`h:@80
000010T92P00000000T92P8000002S@_7P0000T950T92QXB52`L51XB52`L
51XV52`L508A70X022`V51XB51XV52<_7S@_7V1N<jJQV>C7`@;]m_D00ng]
j]cSh=cSh002kNgZ0^gfm@06kNgZkOKekNgZg>?Fm_oekOKe0ng]jP0=g>?F
kNgZg>?FooooY/OP00002A`D4BHD4A`:JUDNAT4NH2lDPg/c00:iZVl02:JQ
V;2ZQ=bn]jJQV<Zn[L77c9F=I/[@`@:`/kL02<6c[IFQS]c7Xa4V2P0001XB
514L2PT950894PX01@0000T950TB2PT92PTB2P042@T:01DJ2@X/4P0J4Q@J
2@X/4P0J2@X/71@/4P0J2@X/4P0S70XJ2@X/71@J2@X/4P169PXm4PXS70X/
4P0S70Xm4PX00R<L2P0@6PT:8a`:8a`:;1806PT:?A8:8a`:6PT:?A`:8a`:
?A`:;180?A`:;2HD;180b]3FHLc<c004IVIVR<2hR<2hB9280@00000000B8
`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT03YVIV@;no_l07?kmooooooom
n_Ocj^?Kd<o6]L2cX:jNQjRDNkZUR]RnXncA]?SM`?oTbo[E`__Fa?kGb?kI
aooHbOgHa_gFao_Fa?kGb?gHa_kGb?gHa_kGb?gHaPCnelP0;OkFb_kGb?kF
b_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kG
b?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kF
b_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFbP02o]O801gm
f<KnelSmf<KnelSmf<KnelSmf<Kme/OlelGme/Oke/CleLKjeL?ke<Gie<7l
f;kogl?ohlKff;cI_Z6kXhN/V7n[VhBo/9g?`k?WgmCgln[nn_OooOh00ooo
oi>IVIT00oooolc<c<c<c01Mc<c<0Q4L2P046PT:4A`:6PT:6PT:0Q4L2P08
2@T:4A`:2@T:4A`:;1802A8:2@T:4A`:0PT92P04;1806PT:4A`:4A`:0QX9
2P8A70X01PT92Q4L2PT92Q4L2P00014V2P<92@X012`B00T92PTB2Q4L2P89
2@X24A`:00H92@X94PX92@X92@XA70X94PX22@T:0Q4L2P8S9PX02a4L2QXV
52`V52`V52<_7TIE:F1N<dI17Q4L2R<L2PTB2P024A`:00@92@X94PX92@X/
71@22A8:014A70X94PYkSFJEXHi6C3d0000971@94PXA9PYGSEaZNfmPLW^V
ZZf`/kN3V8jEZZf`/kL00XfHSP08YZ6HCfM7CfM7LXeLEfMB`K>]`K>>g;>S
0/6c[@05/:Z4Phf4AUDY;3PY4BH:00<000009B`h:G:=G:JQV79bNjJHKiFQ
SP0000TB2PT950TL51XB514V7PTB2QXB50T950TB2PT92PT952`V52<L2QXV
52<L2R`L52`V52`L51XV52<_7R`V514V2QXV52`V54I17S@_:F11:LZn[McS
e_Koo`02kNgZ00?LhmKLhn3]kNX00^gfm@06m_oekOKekNgZg>?FkMW<m_oo
0ng]jP07kOKeg>?FkNgZkNgZm_oo;6ML0000008J4Q@01fYE7X=k<dHV58=k
<l6QQ<6cSZJHQ002`K>>00c1al71/jf`ZXB`/kNVV8C1al71/jfVXIS:d<71
/hhJ9Q@000024A`:00P92@XJ2@X94PX92@XA70X94PX92@X94PX32@T:00L9
4PXA70X92@XJ2@XA70XJ2@XS70X00R`B008J4Q@00b<L2QX92R`B0002;180
00<m70Xm4PXS9PX00QX92P06?A8:Ea`0?A`:;1806PT:6Q8D0R`B00058a`:
8bH:;1806PT:?A8:008m70X01DHV53dL2SdL2R`B0<[@eP1Qc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0>
VIVI01klo_olooonooono_kmnOK`jN7FcKk0/j2[VhB^VWo2ZhcRajWifkWk
f[Oedk3cc[7le/?leLKoeLWnelSoe/[leLKmdlOjdlCoeLWme/OoeLWme/Oo
eLWme/L4omG902goe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_o
eLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWo
e<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_o
eLWoe<_oeLWoe</00_oEb@0MoMK7omG9oMK7omG9oMK7omG9oMK7omO;omS9
omO;o]O8omG9oMK7omG9o]C4nM2jm<ndmM:do=^ln]^lhlVX`JZ:YY=c/Z:8
`;BNeljmk^OMnoKboogn00;oo_l00ooooiVIVIVIV@2AVIVI00?oooo<c<c<
c<`0GLc<c0<A70X040T9514L2PT92Q4L2QX92PTB2QX92Q4L2QX92PT92S@_
7PTB2R`B014L2R`B014L2P8J2@X01PTB2QX92PT92R`B00T92PTB2P892@X0
0`TB2PT92QX92P042@T:00DA70X92@X92@X92@X94PX010T92P034A`:2@T:
2@T:008A70X22A8:00<A70XA9PXJ2@X00R<V2P064BH:8blN6Q8DH5hcAUDY
;2HD0a4L2P058a`:4A`:4A`:2@T:4A`:00892@X020TB2PT92QXV57^=IVYk
KiFQSTIE:@TB2P80000064IWG61N<a4V2W9bNiFHXfYbG;2c]jJZXl[@eW9b
NfYkKhfHSW^=Q6YkKdINAjJZXl6cSTIE:JJQIR<_:B<_7TIE:C@_<cAE:@89
2A@03PTB2PT92R<_7UN=G4mbNg:=Q8>H[EN=G00001XB50T951XB50T92PTB
2P892A@01AXB50T952<_7PT952<L2P026PT:0a4L2P038blN;2HD;2HD008J
4Q@01b`L51XV52<_7R<V2X=kG=cSe^gfm@02kNgZ00CLhn3]kN[]kN[]kNX2
kOKe00?fooo]kN[LhmH00]cSeP03m_ookNgZkNgZ00C]kNX08NgfmOKoodmW
G000014V7THV56YW<fYE7ZJ4D[VHG<6cSXf=Kk24I/[@`L6c[JJHKm?IeZJH
Q;2ZQ=cSh;2ZQ<[@e/6c[H=k<`0000T92PTB2QX92PT950T92Q4L2PT92Q4L
2P022@T:01hJ4Q@94PX92@X92@X94PX92@X94PXA70XJ2@X94PXS70XJ2@XS
70XJ2@X/4P0m4PXJ2@X/4P0J2@Xm4PXJ2@X/4P169PX/4P0/71@/4P0S70Xm
4PX/71@S70X2;18000//71@m4PX/71@/4P0/71@/4P0S9PX/4P0S70Xm70X/
9Q@00SdB2P03`LO1c<c<c<c<05o<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00jIVIT04__moocoookooocl
o_Kck^KOeL[1/;JWTZBCNL:[S=c2XN_:Yo?A[?oL]_oO^?oJ^__A`OcAb0;m
d/T<o]?:<?oBc0_ndlX4oM;900omdlGohlgof[kid[?fd[3fe:o[cJOE_9C1
[HRXV7JdYX_<`JgXh=?km_;oo_l00_omo`03ooooVIVIVIVI096IVIT00ooo
olc<c<c<c01Mc<c<00XJ4Q@94PXJ4Q@A9Q@J2@XA70XJ4Q@94PXJ2@XA70X3
2@T:00T94PXJ2@X92@XJ2@X92@XJ2@XA70X/4P0J2@X00Q4L2P056PT:2@T:
4A`:2A8:000000H92@X01PTB2PT92QXB514L2PT92Q4L2P<92@X011X92PT9
2PT92R`B00<92@X00aX92PT92Q4L2P024A`:00Pd;ahJ4Q@J9Q@J71i6GTMP
GS</9Q@94PX34A`:00HJ2@XA70X92@X94PX92@X94PX22@T:034S;aikSHAP
LW^`/kNEXHi6EBT0000971@A9PY6Ie`d;bU?LW^EZZfVZZf`_/6V/l7:d=JV
ZZ>EXHibLW^EXHj=V8iZLUaZNfoLhmH0002EV6HS;ai?Ie`mGSdS;aiZLU`J
9Q@92A@A70X00016C3eZNhAbSHB3V8hA9PX000092A@A70X94PX92@XA70X9
2A@A9Qh00PTB2P096Q8D2@TD2A8:2@TD4A`:8a`:4BHD6Q8D4A`:008J4Q@0
0`TL52`L52<_7P026RHD00HJ4Q@S;ajVV8C]kN[]m_GLhn03kNgZ0^gfm@05
kNgZooookNgZg>?Pi=3<00;]kNX01OKoongfmNg]j^gfmOK]jP02kOKe0_Ko
o`0IPiR>4BH:LSPDJVLcH5hcPehDdkj>/:Z4^IQLb]31g>?PYYQ_g>?P`LO1
YYQ_g>?PYZZSi=3<`K>]g<NSLXeL00002@TD2@T:4A`:00892@X0114L2PT9
2PT92PTB2P892@X00`TB2PT92PT92P022@T:010A70X92@XJ2@XJ2@X/4P0J
2@X/4P0J2@X/4P0J2@X/4P0m4PXJ4Q@S70X/4P0/71@2?A8:01L/4P0J2@XJ
2@Xm4PY69PX/4P0J2@XJ4Q@J2@X/4P0J2@X/4P0m4PXm70XS70Xm70Xm4PXm
70X/71@m70Y69PXm70[1al`0HLc<c004IVIVR<2hR<2hB9280@00000000B8
`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT03YVIV@0Cn_koo?koo_kon_[l
l>gXgMO;`kRV[in8[IYlbk:CilVUlLnYmm6ZoMJ]omF[n/n]omK8o]G?oMC>
00;neLl00ooFd?oGdOoHdP08omK@<?oEdPSoe]02o=?=1OgDcP0BomK:m/Vd
om6gomblomnknmRbjl^Rf[nDc;N</Imi]:F6a;RPgmK7m^oYoo[noo_oooco
oooo19VIV@800003VIVI0P0000:IVIT2000000BIVIT00000002IVIT20000
0YVIV@800002VIVI0P0000:IVIT5000000>IVIT0000000000YVIV@800002
VIVI0P0000:IVIT400000iVIV@800002VIVI100000NIVIT400000iVIV@D0
0002VIVI100000>IVIT2000000>IVIT0000000000YVIV@@0000/VIVI00?o
ooo<c<c<c<`0GLc<c00C4A`:6PT:6PT:6Q8D2@TD6Q8D2@T:6PT:4A`:2@T:
4A`:6PT:2@T:6PT:2@T:6PT:2@T:6PT:4A`:00<92@X26PT:00@A70X92@XJ
2@X94PX32@T:00@S70XA70X92@XA70X22@T:00<A70X92@X92@X010T92P04
2A8:2@T:2A8:2@T:0Q4L2P<92@X02aXB514L2Q4L2R<V2QXB514V52`L561N
<dIE:B`h:B<L2P044A`:0PT92P<94PX00a4L2PT9514L2P02JW]_02Z3V8jV
XIREZZf=SFl0000971@/C2U6IeaZNfnEZZf`_/6EV:>`/kO1albEZZf`/kNV
ZZ=kSFH/>2UGIe894PX971@92@ZEQ58m;ceGIe9PGS<S;aj=SE8dEBT00009
4PXJ4QA6Iea?LW]ZNhA6GTL94PX971@A70X92A@971@22@TD00H94PX92A@J
4Q@92A@A70X94PX22@TD00<J4Q@92A@A70X00QXB500<2@T:6PT:4A`:6RHD
;1`D6RHD;1`D6Q`N8a`:g;>SkNgZkOKe0^g]jP03g>?Pm_oekOKe00;]m_D0
2OKomMcSh=bn]mcSe^g]j]cSh?KomOKoong]jP03kOKe01KfooG]m_Gfoon`
/kLS9PZ3Nc=PGS>EEACC_XjVV6niV5c:d<7C_Xk:d<7:_ZgTal7]kN[:d<7]
kN[:_ZgCfMIkSFH2000000DJ2@X92A@A70X92A@94PX00PT92P034A`:2@TD
2@T:00@92@X00`TB2PT92PT92P022@T:0aX92P06;1806Q8D;180;1`D6PT:
;1`D0QX92P07;1808bH:8a`:?A8:ARH:?A8:4A`:008J2@X2?A8:0R`B0007
;1`D;1808a`:;1`D?A8:ARH:6PT:008m70X01R`L53dL2THV53dL2SdB2/[@
`F7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003
IVIVc<c<VIVI00jIVIT06?clookoooonooWgn>gXi=WAa/6bWjnKP<bfTLba
Q]NfRNk:V_cFZOoF[?oI/OoO_ooF`_cEa__DaO[Ba_WAaO[Ba__CaocDb0Sk
dlL`oM;9027kdlOje<OkdlOje<OkdlOje<OkdlOje<OkdlOje<OkdlOkeLSl
e<Sle/WmeLWoe/CoekkoekSoekGmeK7gdJ[/bIoM_Y3?]8G3[X>mZhG1/iKG
c;S^iMkiloGnn?ooo?ooo_l019VIV@800003VIVI0P000004VIVI00000000
VIVI0`000003VIVI0000000000:IVIT200000YVIV@8000000iVIV@000000
0002VIVI0P000003VIVI0000000000:IVIT200000YVIV@8000000iVIV@00
00000002VIVI0P000003VIVI0000000000:IVIT200000YVIV@800005VIVI
0P0000:IVIT2000000>IVIT0000000000YVIV@8000000iVIV@0000000002
VIVI0P000003VIVI0000000000:IVIT2000000>IVIT0000000000YVIV@80
000[VIVI00?oooo<c<c<c<`0GLc<c00=6PT:4A`:2@T:6Q8D4A`:6Q8D4A`:
2@T:4A`:2A8:6PT:4A`:2@T:008A70X030T92QX92PTB2QX92Q4L2QX92Q4L
2PT92QX92PTB2R`B014L2P892@X010TB2PT92PTB2PTB2P892@X011X92PTB
2PTB2Q4L2P892@X0314L2PTB2Q4L2PT92Q4L2PT92Q4L2QX92PT92Q4L2PT9
2Q4L2P892@X24A`:00/92A@S;ahd;bUGIe8mGSdS;bTJ9Q@A70XJ4Q@A9Q@A
70X00`TB2P892@X0;@TB2PT92PTB2S@_<g^=Q:JZXk2c]jJZ[L77`A4V2PTB
2Q4V2TmWAdmNIX>H]h>HSYFZ[L[@eVYkKl[@e/77c7^=IP0000T92W:=G000
00T92Q4V57^=IS@_<g9WDTmWAaXB59FQSV1N<`T92PTB2P0005MWDUN=G4mb
NceN?A4V2PT950TB2P042@TD00@92@X92A@92@XJ4Q@22@TD00PJ4Q@92A@A
70XJ4Q@94PXA70X92A@J9Q@24BHD00PJ4Q@J9Q@A9PXJ9Q@S;ah/9QC:d<7f
m_D2kOKe00?]kN[Lhn3]kNX00^gfm@04ooookNgZb]31g>?F1>g]jP04kOKe
kNgZkNgZkNgZ0ngfm@05oooob]3F4BH:JUDNPehD00;C_Xh02lZn[NgIc>gf
mL6cS]cSeXf=Khf=AdINAhf=DSeN?DI17P02000000T92A@94PXA70XA70X9
2@XA70X92@XA70X92@X00PTB2P082@T:2A8:2@T:2A8:2@T:2A8:2@T:2A8:
0PT92P054A`:2@T:6Q8D?A`:;180008J2@X3;18000XS70XJ2@Xm4PXm4PX/
4P0/71@/4P0J2@XS70X/4P02ARHD00@m4PX/71@S70XJ2@X2;18000E69PXm
4PXJ2@XS70Xm70X00R`L5004ARH:ARHD?A`:/;>gHLc<c004IVIVR<2hR<2h
B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT03YVIV@0H
oo_hookkoognoo_ki]cJe<Nn]ZB>/iehaZYhdkEghKmojLF7l<^Fn=>Wo=Rf
oMZlomfmo]bio=Zgo=Viombnomfoomc0o]^o0o_H_003o=Vmo=VkoMZl00;m
f[`00ocI_OcH__cH_P05o=Rn0ogI_`;lf;h3nmNm4?cH_P?kf;`2o=Vm0ogJ
_PSkf;`07__H^_[I^?_H^?[I^?_H^?[I^?_H^?[I^?_H^?[I^?_H^?[I^?_H
^?[I^?_H^?_I]_oK]_oK]?kG/?SAZ_?<YNc5W=njSM:bPLR/O;>MK[j/Q=;4
YncSe?okn0;ooOl00oonoiVIVIVIV@02VIVI0P0000:IVIT200000YVIV@80
0002VIVI0P000003VIVI0000000000:IVIT200000YVIV@8000000iVIV@00
00000002VIVI0P000003VIVI0000000000:IVIT200000YVIV@8000000iVI
V@0000000002VIVI0P000003VIVI0000000000:IVIT200000YVIV@800004
VIVI0P0000JIVIT200000YVIV@800004VIVI0`000003VIVI0000000000:I
VIT2000000>IVIT000000000;iVIV@03ooooc<c<c<c<05g<c<`22@T:0Q4L
2P052A8:8a`:2@T:4A`:;18000892@X010TB2Q4L2QX92PT92P8A70X03AX9
2PT92QX92Q4L2P00014L2R`B00T92QX92PT92Q4L2PTB2PT92P022A8:00<9
2@XA70XA70X00`T92P034A`:2@T:4A`:00<92@X010TB2PT92Q4L2PT92P8A
70X03@TB2Q4L2PT92Q4L2PTB2Q4L2QXB514L2R<L2R`h:FYbG5MWDTI17P02
4BHD00dA70X94PX94PX94PX92@X94PX92@XA70X94PX0001kSHAGIe8A9Q@0
0[2c]`0ZUJZ]`LO<YZZS00002A8:8blYAUi7Cg9kSIR>dmWFUJZ]Y[?1`LO1
b]31JXeL00006RHDLXeL00002A8:6Q`NJW]_CfM7LXeLCfM76Q`NYYQ_AUi7
00002A8:4A`:CfML;6MLAUDY00002@TD6Q8D2A8:2@TD2A8:2@T:4A`:0`TB
2P066Q8D4BHD2@T:2A8:6PT:4BHD0QXB50034A`:6PT:2A`D008J2@X03Q4L
2QXV51XB52`L51XV5611:JJZ[OKfmNg]j^gfmNg]j^gfmOKoongfm@;]kNX2
g>?F00[Td<c]kN[]kN[Lhn3]kN[fooG]kN[fkN[]m_Gfool2kOKe00WooooL
hn16;`[:ZVKL_ZgLhmKokLakSFJESE801`0000892@X00`T951XB51X92P02
2A8:00<92A@A70X92@X00PT92P034A`:2@T:2@T:00L92@X02`TB2PT92Q4L
2PT92PT952`B03dB2R`B01X92R`B03dB2P036PT:00</71@J2@Xm70X00R`B
00048a`:?A8:8a`:?A`:0ULL0006ARH:;180;1808a`:6PT:8a`:0SdL2P03
6PT:?A8:?A8:008m70X014HV2ULL03dB2/[@eV7<c<`016IVIXS0^8S0^4R@
R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00jIVIT2ookk
01SooO[oo?WYg]SEaKJdWh:gW779ZW7G]7;S_WSX`go[ahg_cIobdJkcd[?k
fK?jejgieZkjejolf;CmfKGlf;KkekGnf[[ofk/2om^i0ooL^003omfho]bi
o]^k00Knfk/4ombl0okK^`03oMZjo]^ko]^k00knfk/01?gK^?kL^OkL^OkL
^@CogKX7o]bi0_kL]`Ong;H4oM^e0okL]P0Bo]fdn]N]nmJZn=6Xm<ZRl<JN
j/2Fh;N9e:mkbZUd]9UT^jIgdlFRkNGBoo_googooO_oooko19VIV@800002
VIVI0P0000:IVIT200000YVIV@8000000iVIV@0000000002VIVI0P0000:I
VIT200000YVIV@80000019VIV@00000009VIV@800002VIVI0P0000:IVIT2
000000>IVIT0000000000YVIV@8000000iVIV@0000000002VIVI0P0000:I
VIT2000019VIV@800007VIVI0P000003VIVI0000000000:IVIT400000YVI
V@800002VIVI0P000003VIVI0000000000@0000[VIVI00?oooo<c<c<c<`0
GLc<c00=4A`:6Q8D6PT:2A8:6PT:4A`:6PT:2@T:6PT:4A`:6PT:2@T:4A`:
008J2@X00`TB2PT92Q4L2P024A`:00@J2@XA70XJ2@XJ2@X24A`:00/J2@X9
2@X92@XA70X92@XA70X94PXJ2@XA70X92@XA70X010T92P0=4A`:2@T:2@T:
2@T:4A`:2@T:4A`:6PT:4A`:6Q8D2@T:4A`:6PT:00@A70X02PTB2R<_7VYk
Kh=kG3eN?B<_:A4V2QXV52`L51X92P<94PX22@T:02`J4Q@0002EZZfEQ7/0
000971BV/l6VZZf`_/7CfMH0000A9PXA70XS;bTS@CfEZZf`_/6VZZg:d=J`
_/7ChoE6EBT0000/>2UGSE`92@X00016@Aj3NeaGGVmZNfldEBTmGSfVV8Ab
SCd0000A70X92A@S;bT/C2TA;c<000094PX92A@42@T:00X94PX92@X92@X9
2@X92A@A70X92A@A70XJ71hJ4Q@24A`:01894PXJ4Q@A70XA9Q@J2@X971@J
2@XA70XA9Q@d;bUZIc>VXIS]m_G]kN[]m_GLhn3]kN[]m_D4kNgZ0]cSeP09
kNgZm_oekNgZg>?Pm_ookNgZm_oekOKem_oo00;]m_D01oKoomcSh=>nS]bn
[L[@`G:=?B`V5002000000</4P092A@J4Q@00Q4L2P0;6Q8D2@T:2A8:6Q8D
2@TD4A`:6Q8D2A8:6PT:2A8:2@T:008A70X22@T:00@A70X94PX92@X94PX2
2@T:00DA70X92@X94PX92@XA70X00PT92P076Q8D;1806PT:;1`D?A`:6PT:
;1`D008/4P002aX92R`B02`L53dB2R<L2QXB52`B02<L2SdB2ULL04HV2P02
H2l:0SdL2P0>8a`:;180?A8:?A8:ARH:4A`:ARHDARH:;1`DARH:ARHDARH:
?A`:dmWFHLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4
c<c<00=VIVK<c<bIVIT03YVIV@0Hoogooocooo_kookfk>?Be<BZ[9I_]i][
bJI/eZi`hKQjiKf0j<6:j/JFjl^Rjl^TnMJ`n]B_nM>_n]B`o=FfoMJgo=Fh
nmBg0_S@]P;id[D2nM:c0_[C]003nM:emm:emm:e00Ggd[D2n=>f1?OB]@;f
dK@@mm:e0_KA]0Cgd[D2n=>f1oOB]@;gdk<7mm>a1oKB/00Bm]:^l/nUm<nS
l<VNk<:Hj[nDi[^>gKB0djaebJI^/YAN/I]Ze<BPknCBoo[foogon_[oooko
19VIV@H00002VIVI0P0000:IVIT2000000>IVIT0000000000YVIV@800002
VIVI0P0000>IVIT4000000>IVIT0000000000YVIV@800002VIVI0P000003
VIVI0000000000:IVIT2000000>IVIT0000000000YVIV@800002VIVI0P00
00BIVIT2000029VIV@@0000019VIV@000000000000BIVIT200000YVIV@80
00000iVIV@0000000002VIVI0P0002^IVIT00oooolc<c<c<c01Mc<c<02D9
2@XJ2@X94PXJ2@XA70X92@XJ2@XA70X92@XA70XJ2@XA70XJ2@XA70X92@XJ
2@X/4P0J4Q@94PXJ2@XA70X92@X/4P094PXJ2@XA70X/4P092@XA70X92@XA
70X0000/4P092@XJ2@XA70X94PX00Q4L2P0<2@T:6PT:4A`:2@T:6PT:4A`:
6PT:4A`:6PT:4A`:2@T:6PT:0a4L2P0?6PT:4A`:2@T:2@T:4A`:8blNPhf4
NheVAUDY8blN6Q`N6RHD2A`D4BHD2@T:00<94PX24A`:01@0002EZZekSFH0
00094PY6IebEZZf`/kOLhn1ZLU`0000971@J9Q@A9Qj3V:g:d=J`_/71al6`
/kO]m_D24BH:019PGS=6Ie`A70X94PYbIe9ZNfmbSEb3Ne`A9PYGIe:VZZ<d
EBT0000A70X971@A70XJ4Q@92A@22A8:0PT92P042A8:2@T:2@T:2@T:0`TB
2P0H6Q8D2@TD2A8:2@TDAT4N6RHD4A`:6Q8D6PT:4A`:6PT:2A8:4A`:4BHD
2@TD;1`D4A`:=2lNH5hc`K>]kNgZkOKem_oog>?F1ng]jP05i=3<m_oekNgZ
g>?FkMW<00;]kNX3m_oo00GfooG]m_Gfm_G]m_E6;`X00R`B000:6PT:;180
2@T:8a`:6PT:2A8:4A`:6PT:2A8:6Q8D0Q4L2P032@T:6PT:4A`:00892@X0
11X92Q4L2QXB50T950892@X00a4L2PT92PT92P042@T:00HA70X92@X94PX9
2@X94PX92@X24A`:00<J2@X/71@J2@X00R`B000>?A8:6Q8D;1806PT:?A`:
;180?A`:;180?A8:?A`:?A8:LRH0ARHD?A8:0ULL0009ARH:?A8:8bH:?A8:
?A`:8a`:?A`:;180?A`:00969PX01B`L54HV2THV2SdL2ZJc`@1Qc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VI
V@0>VIVI01[ooOolnOooo?_oo_;ailkDa:2RS5^dUEk5WVGCYV_N[gOS]WoT
^hOW`hoXb9OWb9[[aIk/a:3]aJ;^aZ?_aZK_aZS_aZ[^aJW^a:__aJ`2klJZ
1>o6Z003klJZk/NZk/NZ00c^ajX00ng6ZNk7Z^k7ZP0>k/NZ00?]aZW^aj[^
ajX03>k7ZP03k/NXk/NVk/NV00K^ajH6kLJU01?/aJC/aZ;/bIo]b9cY`iKW
_97U^H[T]XCM/7WCZFo8XFJ_SeJXSUgGaIo_i=3nnO?noOoknoooo_l019VI
V@D00003VIVI0P0000:IVIT2000000FIVIT000000000002IVIT00`000005
VIVI00000000VIVI000000>IVIT2000000FIVIT000000000002IVIT00`00
0003VIVI0000000000:IVIT00`0009VIVIVIV@02000000>IVIT000000000
0iVIV@030000VIVIVIVI00800004VIVI0P0000JIVIT0100009VIVIVIVIVI
V@8000000iVIV@0000000002VIVI0P000003VIVI0000000000:IVIT20000
00>IVIT0000000000YVIV@80000[VIVI00?oooo<c<c<c<`0GLc<c00<4A`:
4BHD6PT:2A8:4A`:6PT:2A`N2@T:;1802A8:2@T:4A`:0`T92P056PT:4A`:
0000;1804A`:00892@X00a4L2PT92R`B00036PT:00D/4P0S70XA70XJ2@X9
2@X00Q4L2P082@T:;1802@T:2@T:6PT:4A`:2@T:4A`:0PT92P044A`:2@T:
4A`:2@T:0a4L2P0I6PT:4A`:4BH:4A`:2@T:4A`:2@T:8blNUIRSPg]LJW9L
8blc;4`Y6RHD6Q8D4A`:2A8:2@T:2A8:2@T:2A8:2@TD0000UJZ]SHe_0080
00003a4L2SeN?IFZ[L[@e/77c6Z=G000014V2P0008>H[L[@eYFZ[JJc`L77
`McSh002000000aZSEa6C3dS;ahJ9QBEV6I6C3f3NeaZLU`A9PZ3Q7_1/hhA
9PX22A8:00@J4Q@92A@94PX92A@82A8:00<92@X92A@94PX00PT9500:2@T:
=2lNAUDY8blN6PT:4BH:4A`:;2HD4A`:6PT:0QXB50064A`:4BH:6Q8D8blY
JVLcb]310ng]jP03i=3<kOKem_oe00C]kNX00mcSe^g]j^g]jP02g>?P00?]
kN[fkN[fooD01?Koo`;]m_D02Oooob`B04HV52`V53dL2R`L514L2QX92PT9
2P026PT:00<94PXJ4Q@A70X00PT92P056PT:4A`:2@TD4A`:2@TD00892@X0
0b<_7P0001XB50022@T:00<94PX92@X94PX00`T92P052A8:2@T:2@T:2@T:
2A8:00892@X02QX92PT92R`B02`B02`L52`B03dL2R`B02`L51X92P8/4P00
1THV2R<L2SdB2V0_2ULL060_509G70001V0_2THV2SdL2THV2QX92R<L2P8m
70X00eLL014L2THV2P05ARH:00=G703:d=K<c<`0H<c<c004IVIVR<2hR<2h
B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT03YVIV@0F
o_con?OooO_loog^mNc;fL^LW8=;[he@`IMMd9mWg:UdhJmlhKJ1iKj7h/>:
hlB>il6Djl6IkL>Mk/BNk/>Pk/>Q0^k3X`;_a:@2k/>S0^k3X@03k/>Pk<BP
k<BQ00g/a:42kLFR4>c4X@;]aJ8>k<BQ2>c4X004kLFQk<BPk<BPk<BP0^_3
W`0Cj/:NjL>Li/>IiL>Ei;j?hKN7h[B2h[5ifjY_dj=Ua9]M[HU?WX9@flNR
l^GBoOSbookooOgoooko00BIVIT2000000>IVIT0000000000iVIV@800002
VIVI0P000004VIVI00000000VIVI0P0000:IVIT200000iVIV@@00002VIVI
0P000003VIVI0000000000:IVIT200000iVIV@@000000iVIV@0000000002
00000YVIV@@00005VIVI0P0000NIVIT400000iVIV@@000000iVIV@000000
0002000000>IVIT0000000000YVIV@@0000/VIVI00?oooo<c<c<c<`0GLc<
c00G4A`:6PT:4BHD6Q8D6PT:4A`:6PT:4A`:6PT:2@T:4A`:6PT:4A`:6PT:
4A`:6PT:4A`:2@T:6PT:2@T:;1802A8:;180008J2@X00a4V2QX92Q4L2P02
2@T:01DA70XJ2@XA70X/4P092@X/4P092@XA70XJ2@XA70XS70XA70XJ2@X9
2@XA70XJ2@XA70X92@XA70XA9PXJ2@X00Q4L2P0V8a`:6PT:4A`:4A`:2A8:
;1808blNNheVSIR>LW9kAUDY8blY2A8:4BHD2A`D6Q8D2A8:2@T:4A`:6PT:
6Q8D0000LXf4YZZS2A8:2A`D4BHD0000LXf4/;k1`LO<`LO100004BH:0000
?G:4/;>gYZZS0/77c00B`LO100002@T:SHe_4BHD4BH:H5hcUHAk?EhmSHe_
JVLc8blNJW9LH5hc00002@T:2A8:4A`:0PTB2P054A`:2A8:2A8:2A8:2@T:
00<94PX040T92Q4L2PT9514L2QXB500003@_7X=kG8f=AdI17PTL52<L2QXV
52<_7QXV514V508A70X03AXB52`V514L2QXL7X=kG<[@`McSh>gfmMcSe]cS
h>g]j_KomMcSh006kNgZ00GfkN[Lhn3LhmKfooG]m_D01?Koo`04kOKem_oo
ooooARl:0THV50048bH:ARHD8a`:8a`:114L2P036PT:2@T:4A`:00892@X0
214L2PT92PT92Q4L2PT92Q4L2R`L514L2P892@X0114L2PT92PTB2PT92P89
4PX02aXB50T92PTB2Q4L2PT92Q4L2PTB2QX92QXB52`B02<L2P05;18000<S
70XJ4Q@S70X00SdL2P8m4PX04THV2ULL078V03dB2ULL060_2ULL03dB2THV
2QXB52`B04HV54HV2SdB2Q4L2THV2SdL2THV50=69PX00cdB2/[@e/c<c01P
c<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIV
I/c<c9VIV@0>VIVI01?lo?ognOono_knnn[klloTe:>HOTFWPdFnT5C<V5oG
XVcLZGCM[WSM]WgJ^WoI^X7U`HgY`iC[aIP00^g6V`03k<FLk<FNkLJO00?[
a9d2j/>L0^[3VP03jL:Ij/>JjLBJ00KYa9X00nS3VNW4V^W4VP02jLBJ0n[5
Va3Ya9X2j/FK00gZa9gYa9[Y`icYa9[Y`icX`iWZa9gZaI_Za9gZaI_Za9gZ
aI_Za9d00^[5V`0Pj/FIj/FKj/FIj/FKj/FIj/FKj/FIj/FKj/FIjLBJjLBH
j<>Iil:Fil:Hil:FgkjAgkf?g[R7g;=ogJifg:Y_eJ9QbiYH_8m>ZH97VG]9
i=2[nNgGoo_bookoo?ooo_oo19VIV@800002VIVI0P0002fIVIT200003IVI
V@800002VIVI0P0000nIVIT200000YVIV@80000bVIVI00?oooo<c<c<c<`0
GLc<c0086Q8D4A`:6PT:2@T:4A`:6Q8D4A`:2@T:0QX92P0>2@T:4A`:2@T:
4A`:2@T:4A`:6PT:4A`:2@T:4A`:6PT:2@T:6PT:4A`:0QX92P082@T:;180
4A`:;1802@T:4A`:6PT:4A`:0PT92P8J2@X020TB2QX92PT92PT92Q4L2PT9
2Q4L2PT92P<A70X00aX92Q4L2Q4L2P034A`:00hS;ahJ4Q@92@X94PXA9QAZ
Nfn3SHB3Q8i6EBT/C2TS;ahJ9Q@A9Q@92@X32A8:0Q4L2P0R2A8:NheVYZZ]
;3PY00004BH:2A8:?EhmPiR>/;k1b]3F00002A`D4A`:2A`NUJZ]YZZ]b]3F
SIR>4BH:2@TD4BHNUIQV2A`D2A8:AT4NPhB>EfMB=5DY00002@T:00002@TD
2@T:0PTB2P044A`:2A8:2A8:2A8:0`T92P894PX01@T950TB2PT92PTB2PT9
50022@T:01Ld;bVELTN=SFmkSFJ3Nc<94PXJ9Q@/C2T/9Q@J9Q@J4Q@A70XA
9Q@J2@XA9Q@92AAZEAjVXIS:d<7Lhn3]kN[LhmK]kNX00^gfm@08g>?FkNgZ
kNgZkNgZg>?Fi=3<kNgZkOKe0ng]jP03m_Kem_oom_oe00;]kNX2m_oo00Co
oon3NeaG701P;a@2?A`:01XS70XJ2@X/4P0A70XJ2@X92@XA70XJ4Q@92@XA
70X92@XA70X92@XA70X92@XA70X92A@J71hJ4Q@A70X94PX92@XA70X94PX9
2@X94PX22@T:00<94PX92@X94PX00`T92P092A8:;1806Q8D;1808a`:;180
8a`:;180?A8:00</4P03?A8:00=69PY69QAP;a@00V0_2P0CARHDLRH0H2l:
8bH:8a`:6Q8D;180ARH:ARHDARH:6PT:ARH:?A`:ARHDARH:H2l:ARH:Ea`0
g>?P067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<
c003IVIVc<c<VIVI00jIVIT06?_mooSlookooocjjoohfO3O/iQmAZ9l?[:4
A/6>ClnIGMBPI]FWK=J^LmJcNM>eNMBdNmZgPMfjQ=nkQmjjR=fiRMjjR]nj
S@?S_Y401N>oSn:nS^:nS^:nS]nnR`08h;n<00CO_X_P_hcP_hcP_h`4hL2=
4>2oS0;Q_hl03N6oTN6oSn2nT>2nS^2nT=nmSN6oTN6oSn6oTN6oSn6oTN6o
Sn6oT@02hKn?00oQ`8gQ_hoQ`8gQ_hoQ`8gQ_hoQ`8gQ_hoQ`8gQ_hoP_hcO
_HgN_H[N_8cM_H`00]NgR00?f;:1eZegeZQ]e:9SbiQF`Hi</X92Y7a1UgQ9
l]bgooKPookeo_ooo?ooo_oo00BIVIT200000iVIV@80000]VIVI00<0002I
VIVIVIT039VIV@@0000AVIVI00<0002IVIVIVIT00P0003:IVIT00oooolc<
c<c<c01Mc<c<00TJ4Q@J2@XA70XA70XJ2@XA70X92@XA70XJ2@X00Q4L2P05
6PT:;1808a`:2@T:6PT:00892@X012`B014L2PT92PT92P8J2@X01B`B02<L
2Q4L2QX92PT92P026PT:00lA70X92@XJ2@X92@X/4P0A70X92@XJ2@X/4P09
2@X/4P092@XA70X92@XA70X00PT92P0G6PT:4A`:4A`:6RHD4A`:;2HD6RHD
;2HD2A8:4A`:2@T:2A8:SHe_Nhf4Phf4JW9LEeEB8blY8blN2A8:4A`:2@T:
4A`:00892@X24A`:01m?GVJEZZfEXHh971@0000A9QhA9PX0002EZZg1/jd0
00094PX92A@00023V:g1al56GTL000092@XA9Q@S;aj=SFl000094PX/9QA?
IdNEQ7/000094PX/71@92@X00`TB2P036Q8D6RHD4BHD00L94PX060T92PT9
514L2PT92Q4V51XV58f=Ahf=DW^=IVYbG9F4Nh=kG3AE:DI17S@_:B<_7R`V
51XV514L2QXB514V514L2PT92Xf=DP;1/jd2kNgZ00?Lhn3]kN[]kNX01>g]
jP03g>?PkNgZi=3<00;]kNX04=cSe^g]j_KomOKoooKomNg]j_K]j^g]j^gf
mOKooooooiF4NdH_2V0_2THV2SdL2P8S70X36PT:00DA70XJ2@XJ4Q@J2@XA
70X00PT92P054A`:2@T:4A`:2@T:4A`:008J4Q@01A4V51XB514L2QXB50T9
2P022A8:0Q4L2P072@T:4A`:2@T:2@T:4A`:2A8:4A`:008J2@X00b<L2SdL
2SdL2P02?A8:00Pm70Xm4PXS70X/71@m4PY69PXS70Xm4PX2Ea`000U69PYP
;aAG701b9P1P;a@m70XS70X/4P0/71@00SdL2P06ARH:4A`:ARH:H2l:ARHD
?A`:0THV5003Ea`0dmWFc<c<063<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00jIVIT06OWooo[nookooocj
k_omhoSV`YUmCIei?jMi>kN4@lJAClfJFM2RI]>[L=>`N=6bNmFfOmVjPmfn
R=joRMfmR]blRmfmS]jnSmbkSP02g;b=0]^kRP;J^XT00mVkQmZlR=ZlR006
f[b80mVkQ`;J_8P3fkf94=ZlR003fkf;fkb=fkb=00;J^h`3fKZ;1m^lS@_K
_H/2f[b:01GI^hWH^XSG^HOG^HOA/X?B/X?C[W[AZ73AXfO>WE_4TDnhQdBW
NC^ON46GN4[ki<Coo>WoooKnoookooonool0TiVIV@03ooooc<c<c<c<05g<
c<`01A4V514L2PTB2QX92PTB2P024A`:00<J2@XA70X92@X00QX92P032@T:
6PT:2@T:00<A70X26PT:0Q4L2P032@T:6PT:6PT:008J2@X02B`B014L2Q4L
2Q4L2R`B014L2QX92Q4L2P0000026PT:00LA70XJ2@X92@XJ2@XA70X94PX9
2@X01A4L2P034BHD;1`D6RHD00<S;ah07QXB514L2Q4V500004mNIW^=IW9b
Nh>=Q8=kG3AE:B<_7Q4V2PT951XB50T92QXB514L2PT951X92TINAg^=Q9FQ
S[2ZQ0TB2P0000TL500007^=Q9FQSP0000894PX05a4L2RaEG14V7P0000T9
2PT95000079WDX>4NeMEDQ4L2S@_7THV2/77`G8V00T92/77`ELL00T951XB
50TB2PT92PT950042A8:00<92A@94PX94PX00PTB2P0A4A`:2A8:2A8:;1`D
8blYAUDYH5hcPhAkLXeLSHeBH5hcCfM7UG97LXdm=2lNH5hc=2lY008J9Q@0
1a4V51XB514V56YW<jJZXl77`McSeP02g>?P1Ng]jP03g>?FkNgZi=3<00;]
kNX04]cSh>g]j^g]j_KomOooomcSh?KomMcSe^g]j_KomOKoooooog9WDW8V
078h55LL04HV2SdL2P8S70X26Q8D00hA70XJ2@X92A@92A@A70X92@XS70X9
2@XA70X92A@92@XA70X92A@A70X22@T:00<J4Q@/9Q@92A@01`T92P034A`:
2@T:2@T:008J2@X01B`B02<L2R`B02`L52`B0002?A`:0SdB2P04;180?A8:
ARH:?A8:0THV2P0>Ea`0ARHDEa`0Ea`0H2lDEa`0ARH:?A`:4A`:ARH:Ea`0
4A`:ARH:4A`:0dHV2P05Ea`0H2lDH2lDEa`0b]3F067<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00jIVIT0
6?Wooo7fnOcooooon_onlOo`ekfSOXm^>j9i>jAe;k20=]6QFLBHEmV`N>W5
TmRhRM^oSmNmR]RnSMo4UN;7V^76VN;7W>G:W`?QaId2hLJK0^76V@;QaYL7
glNG0]k6UP04glNGh<RHh<RHhLVI0^;:VPoPb9P00n38V]o7Vmo7V`0?glNK
1mo7V@;Tc9h2hl^M01GQbI_MaIOG_i7D^HcR`iGP_Y3F/WkV_hK9WF30Te:g
QdFVNCR?IB^FL3nlWgOonMcom>;kn>onooofn__nool0TiVIV@03ooooc<c<
c<c<05g<c<`011X92PT951X92Q4L2P8J2@X22@T:0Q4L2P062@T:6PT:6Q`N
4A`:2@T:;1800QX92P0:2@T:4A`:6PT:2@T:4A`:6PT:4A`:6PT:00004A`:
11X92P066Q8D00008a`:2@T:6PT:2@T:0QX92P04;1806PT:6PT:2@T:0a4L
2P076PT:8a`:8a`:4BH:8blN8a`:6RHD00<S;ah031XB514V50T92S@_:DmW
G8fHSX>HSX>4SUN=G3@_:B<_7PT9508A70X01@T950TB2PT92Q4V52<_:@02
JW]_00NEV:=kSFHA9Q@92A@dECdA9Qi?Ie`00`T92P0Q=5DY2A`N4Blc4A`:
6Q8D2@TD0000AUDYCfML`LO<00008bH:;180`LO<`J64?A8:UIRSong<0000
4BH:4A`:2A8:4A`:2@T:2@TD6Q8D2@T:6Q8D2@T:2@TD2A8:6Q8D2@TD008A
70X072`B02<_:A4L2V1N<g^=IX=k<eMEDV1N<hf=DXfHSZJHQ8f=AfYW<dIE
:C@_:A4V7PTL51XL7PT954I17ZJQV<6c[McSh>gfmMcSe^g]j]cSh=cSePC]
kNX00mcSh>C@c>g]jP03kNgZ00?fooofooG]kNX00ng]jP?fool2PcP00123
;`1b>1AG700m70Y69PXS70XJ2@XS70X92@XJ2@XA70XJ4Q@92@XA70X92A@J
4Q@62@T:00<A70X92@X92@X00PT92P032A8:2@T:2@T:00D92@X02@TB2Q4L
2PT92Q4L2QX92SdB2R<L2R`B02<L2P03?A8:00Hm70X/4P169PXm70Xm4PY6
9PX4Ea`000M69PZ3;`1P;`Xm70X/71@/4P0/71@00SdL2P03ARHD6Q8DARHD
00=69PX014HV560_578V0<[@eV7<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00jIVIT02__ooO[oo?coooon
o?ohmOoik]_6ZgmR>91/<YM_:@:eRCh03>_2P=ffOmNbQ^g=Y^S<Y>?:XNC;
XnS?Yn[@ZnO=Z^O=[>W?[P;[d;82jm6`0^_A[P;[dJ`8j]:/0^K>Z0;WcjT0
1>S@Z^WAZnWAZn[B[13Xd:X00n[B[^[B/>[B/00=j]:`2>[B[P03i/jZiLfY
i<bX00;UcJT05>C<Z>;:Y^37Wn_;X^W7VN[6T]fiOm>[KJb3@jV0@99Z;I9]
>HMV>mc2XOohh?onkooom_Wkn?Okn_kooi>IVIT00oooolc<c<c<c01Mc<c<
00<J4Q@A70XA70X00QX92P074A`:6PT:4A`:2@T:6PT:4A`:6PT:008A70X0
1AX92PT92QX92Q4L2QX92P024A`:00L/4P0J2@XJ2@X/4P0J2@XA70X/4P00
0QX92P0;4A`:2A8:;1802@T:4A`:6PT:4A`:;1806PT:2@T:;180008J2@X3
2@T:0a4L2P064BH:8blN8blN8blN6RHD4BH:0R<_7P0K6RHD4BH:;1`D8blN
AVMLPhB>SIR>Phf4JW]_CfM7=5DY4BH:2A8:2@T:4A`:2@TD4BHD8blNAT`m
AUEBCfMLNheVCfML;3PY=5Dm4BHD0000008S;ah010T92Q4V51XV50T92P89
9RT040TB2Q4L2QXL7TI<?EMED/[@eZIbDP0003dL2[1kI^C@c;1k:DHV5>gI
c7]<500000894PX02`T92Q4L2PTV:@TL50T92Q4L2PT950T92QXB50TL50T9
50022A8:00HJ4Q@A70X92AA6EBTd;bUZIc<2Pg]L0ZJHQ00</:Z4SHe_LXdm
H5hcJUDNH5hcAT4N4BH:4A`:6Q8DPhAkb]310^g]jP?Lhn04g>?F00CLhn3L
hmK]kN[LhmH2kNgZ00?]m_Gfooo]kNX01>g]jP08m_oooooo`LO<Pd40Pbl0
UED0Pbl0H2l:0THV2P0;;1808a`:6PT:4BHD4A`:6PT:6Q8D4A`:2@T:4A`:
2@T:008A70X22@T:00DA70X92@XA70X0000A70X00PT92P<94PX010T92PTB
2PT92PTB2P892@X01@TB2PT92R<L2QXB52`B0002?A`:00L/4P0m4PY69PY6
9PXS9PXm4PXS70X00SdL2P969PX02SdB2V0_55LL04HV2V0_2X<_04HV2SdL
2R<L2THV2P8m70X015LL02<L2SdL2ULL00969PX2H2lD00=G703CfMK<c<`0
H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT03YVIV@0Hnoogo?ojnogloooonoKjoocjooOYZ95aRF/gME<C
TFdS^I=:a9iOom^Vi/>Kk<^Zj/f]i/f^ilj`jLndjLnfilfdi/bej<jg1>S=
^0;Xc[L:j<je0^O=]0;Xc[D01>W?]^[@]n[@]n[@]a3YckHHj<jg01W]dkc[
dK[Zd;WZd;W/d[_]dkc/d[_]d[G[bjCU`iGW`hoXaHgQ_H6ROT:AKSB9J3>1
HSJ]Tg;olm_onNWoo?7oooSooo_mookoool0TiVIV@03ooooc<c<c<c<05g<
c<`0214L2QXB51X92PTB2Q4L2QX92Q4L2QX92P8A70X00aX92Q4L2PT92P02
6PT:00<A70XJ2@XS70X00aX92P0B2@T:4A`:6PT:8a`:6PT:;1806PT:;180
4A`:6PT:;1806PT:;1802@T:;1802@T:6PT:2@T:0b<L2P066Q8D2@T:2@T:
4A`:2A8:4A`:0R<_7P0J8blY;3PY;3PY4BHD4A`:6RHD4BHD8blN;3PY=5DY
6RHD;3PYJW]_SIR>Nhf4LW9kNhf4AUEB6RHD00004BHD2@T:4A`:6RHD6Q8D
AVML0TINA`06AVML4BHN8blY4BHD00002@T:0Q4V50036Q8D4BHD4A`:0089
2@X0>B=1DQXL7Q4L2[2ZQ2`B0611:McSh>C7`@0004H_2ZIbD]bn]mbn[ELL
0<6QQ=cSeSdL2Q4V2PT9514L2P0002aN?@00014L2PT92PTB2Q4L2Q4V53@_
7S@_:@TB2PT92PT950TL514V51XV51XB53AE:IFQSW:=?G9WDVYW<g9WDTmW
Ah=kG9j4IZJZXjJHKhf=DQ4V2PT9514V7V11:McSh>C@c>g]j]cSh007g>?F
00?Td<cLhmK]kNX00^g]jP0<m_ookOKekOKem_oem_ookOKem_ooooookOKe
UG97YT`0UED00X<h0007LRH0H2l:?A8:;1`D;1808a`:6PT:008A70X01`T9
2QX92Q4L2QX92Q4L2PT92PT950024A`:00@92@X94PX92@XA70X62@T:00/A
70X92@XA70X92@Xd;bT92A@94PXA70X92@XS70X/4P000SdB2P05?A`:?A8:
?A8:Ea`0ARH:008m4PX02TH_2SdL2SdL2R`L560_2ULL060_2ULL08<_060_
2P969PX03SdB2SdL2THV2SdL2THV2R<L2THV560_2THV54HV2W8h56Y12V0_
2/[@`F7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<
c003IVIVc<c<VIVI00jIVIT06?oom_cmmocnoOkooo_jooonooomm??Sc::=
HWAI8XMX:9Ug=l:OIMbhQ]fjT^?2XNS;[NO<[n[?]>c@^>c@^^_?^N_?^^gA
_0G[c[`2jlnj00?[ckW[ck[[ckX02>_?^P?/d;/3kM6l4>c@^aW[ckX06>[>
^NW=^>W=^>[>^NW=^>O;]^O9[mfkUOcJ[>K5T]RgPKNGGZ62Bh5V<GEJ;JVA
KoWUcOolkOomm?K_jOkkm_oonokooOoooi>IVIT00oooolc<c<c<c01Mc<c<
00<J2@XA70XA70X00QXB50036PT:2A8:4A`:008J2@X02`TB2QX92R`B014L
2PT92QX92Q4L2QX92PT92Q4L2QX92P024A`:00X/4P0J2@XJ2@XJ2@XS70X/
4P0J2@XA70XJ2@XA70X36PT:00<A70XJ2@XA70X00aX92P03;1802A8:2@T:
00<92@X01R<V2R<_7SAE:C@_7SAE:B`h:@8S;ah00b<_:DIEDS@_<`028blY
01DJ71h/>2V3Q8iZNfn=V8j3SHAPLW]6EBT92A@94PX971@J2@XJ71hS;bTd
ECeZNfm6Ie`A9Q@S;ah94PX92@X00Q4L2P104BHD6Q`N4BHD4BHD4A`:2A8:
4A`:2@TD8d5B6PT:YXAB;180PbmL`LO1ong<2@T:4BH:WW8c`K>>i<O1Ea`0
/8AVm^gZi:ZH00004BH:00004BHD2A8:2@TD2@T:4A`:2@T:6Q8D2@T:=2lc
LXdm8blN8bH:2@TD6Q8D6PT:2A8:2@TD8blNH5hcLUEBCfM7SHe_NheVUHAk
YZ6HUJ6>YZ6HUIQVH5hc6Q8DPg/cH5hc2@T:b]31g>?Pm_oog>?P0mcSeP03
g>?Pg>?Fg>?F00;Td<`01mcSe]cSh?K]j^gfmOKoong]j_K]jP02m_oo00G]
m_GLhn3foonVZZfEE@000jI<0008Pd40PcP0H2l:Ea`0ARH:?A`:6Q8D8a`:
0QX92P0:4A`:2A8:2@T:2@T:4A`:2@T:4A`:00006PT:4A`:0`T92P064A`:
2@T:4A`:4A`:2@T:4A`:0PT92P0B2A8:2@T:6Q`N6Q8D2@TD6Q8D;1808a`:
6PT:?A`:ARHD6PT:;180ARH:H2lD?A8:?A`:?A8:0SdL2P0=6Q8D?A8:Ea`0
H2lDEa`0H2l:LSPD;1`DLRH0ARHD8a`:?A`:;1`D00969PX01B<V2THV2V0_
2THV2ULL0002H2lD00=G703CfMK<c<`0H<c<c004IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P4c<c<0VIVIP03c<c<VIVIVIVI00bIVIT05_oo
n_onn_oooo_loo[moo[koOOdkoookOodehQeBg1F9IQjA[6AG/ZXN_7@YMNg
T=nnVn73XNG6YnK7Z>K7Z^K7Z`;Wajh3ilN`0^O7[P?Wb:`8i/R^1>C6[0CU
ajd@i<J/6>K8[P?SaJ/2i<J/01CRa:[N`:KK_9gC/8SWaIOE]87@/G^LPDY`
FBEVDBB3LDgol]WooNgnlngooO_oo_glnoWloOSooo_ooofCVIVI00?oooo<
c<c<c<`0GLc<c0074A`:6PT:2A8:6Q8D8a`:2@T:;18000892@X24A`:00HJ
2@X92@XA70XJ2@XA70XJ2@X24A`:01DJ2@X/4P0J2@X94PXJ2@X92@X/4P0J
2@X/4P0S70Xm70XS70X/4P0S70XA70XJ2@XA70XJ2@X/4P092A@/4P000R<L
2P044A`:2@T:2@T:4A`:0PT92P0P2@TD6RHD;2HDAT`mEeEB?Ehm=5DY6Q`N
;3PY=5Dm;4`YAT`m;4`Y8bH:2@T:CfMLPhB>Nhf4JW^4JXeLEeEB;3PY2A8:
4A`:2A8:8blN;4`YAT`mAUi74BH:2A8:8blY0PTB2P0U2@T:2@TD4BHN;2HD
2@TD6Q8D4A`:00002A8:2@T:4BHN6Q`NLSPDH44YH2lD`G]km_ooJVLc4BH:
PcP0YW9Bg;>]YW9BUEhcg;jgong<6PT:4BH:2A8:4BHN2@TD4BHD2A8:4A`:
2@T:4A`:2@T:008J9Q@064I17TmWAa4V50TB2PT92Q4L2QXB5000061N<g:=
?F1N<g9WDW:=G8f=KiF4NiFQS/6cSVYbG1XV514L2[2ZQ8=kG6YW<l6c[@;]
m_D00mcSh>C@c=cSeP03g>?F00STd<cLhmKLhmKLhmK]kN[]m_Gfooo]kNX2
m_oo013CfMK1al6VXIQbIe;foonNGQBVI`2VC02`E@2VC02V@@23>01b>1Ab
9P169PXm70X2;18000<J2@XA70X/4P000PT92P034A`:6PT:4A`:00<92@X0
114L2PT92Q4L2Q4L2PH92@X03PTB2PT92PT92PT92PTB2QXB51XL7PTB2QX9
2R`B02`L52`B05LL02`B008m4PX01ULL04HV2R`L52`B03dL2R`L509G7000
260_2THV2V0_2V0_2X<_078V05LL060_2P@m70X00eLL03dL2SdL2P03H2l:
00AP;aAb>01G703:d=IQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^0C<c<`016IVI/c<c6IVI/c<c0fIVIT01?olooonoooooo3dm`;k
ool04^k`jooom?ook?oaehigEg5E;XIV?JZ9G:j=H=FeQ/n_P=JeR=ZiS=Zi
S]RgS]VgTMZhT]VgTPGH]Y43f;J@00?G]i7G]Y?G]Y<07=NfT`;G]i40:mNg
T=NgTMNgT=NgTMNgT=NgTMNgT=NgTMNgT=NgTMNgT=NgTMNgT=NgTMNgT=Ng
TMNgT=NgTMNgT=NgTMNgT=NgTMNgT=ZjU=ZjTmblU]jnUmnoVMfmU]RhT]Jd
S]^fS<ZUN;NGIYn1CHE^>VMC8JjOM_[_dOonkOoilOomoOObmP02ooko00?g
n??ooo_oood0TiVIV@03ooooc<c<c<c<05g<c<`00a4L2PTB2QX92P034A`:
01<92A@A70XJ2@XJ2@XA70XJ2@XA70X/4P0J2@X/4P0A70XJ2@X/4P0A70X9
2@XJ2@X92@X/4P0J2@X00R`B00088a`:;1808bH:8a`:;1806PT:;1802@T:
0QX92P034A`:;1806PT:008J2@X07B`B014L2PT92Q4L2PT92PTB2PT950T9
2QXB52<_7UMWDVYbG4mWG4I<?CAE?C@_<dIWG3AE:@TB2QXL7TmWAdI<?BaW
G7^=Q8>4SVYkQ7^=ITmWAb`h:@022A8:00LJ71h/C2U?LW/000092@X94PXS
;ah00PTB2P042@T:6Q8D6RHD6RHD0Q4V50044A`:2A8:2@T:2@T:0Q4L2P0C
6RHDH2lDLSPD/7]Vm_KeYYR40000LSPDYW9Bg;jgi<O1LRH0g;jgm^gZg;>S
4BH:4BHD4BHN2A`N00<92@X03`TB2PT92Q4L2QXB514V2S@_:G:=?F1N<`00
00T950TB2Q4L2PT92R`h:C@_7P02AUDY00mPGS>3SHBVXIRVV8BEXHj=SDL/
>2T/9QB3NebVXIRVZZg:d<7]m_GfoooLhn002=cSeP0Ai=3<kNgZkOKem_oe
m_oo`LO1YZ6HJW9LLVMBWXAVg;>SkNgZYT`0/5D0YT`0/5D0/78000:VC000
1H<h08<_05LL04HV2SdL2P028a`:0QX92P074A`:2@T:4A`:2@T:2A8:2@T:
4A`:00<92@X00`0000T92Q4L2P022A8:00<92@X94PX92@X010T92P056PT:
2@T:6Q8D2A8:6PT:008/4P0023dB2S@_:CdB2R`B03dB2THV55LL02<L2P<m
70X01CdB2THV578V02`B05LL0002H2l:015b9P0m70YG70169PXm4PY69PXm
4PYP;`Xm70Y69QAb9P169PYP;aAZEAiP;a@m70[1al`0HLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00EVIVK<c<bIVIUVIVK<
c<`039VIV@0HooSooocoo_gomo_lnOoon?omnOojo?oho?S]oogaooKUWhE/
R6]9NUXaS6`kUgPo[he@^9IG_YaM_I]N_9UO_iaT`IiV`9eW1KfJI0>mVV88
^iYU6;fLI`0a^iYT^i]R^iYT^i]R^iYT^i]R^iYT^i]R^iYT^i]R^iYT^i]R
^iYT^i]R^iYT^i]R^iYT^i]R^iYT^i]R^iYT^i]R^iYT^i]R^YUS^YYQ^YUS
_9aS_IaV_9aS^IQR^9APW7I9WgY=SFdlITXHL5XXWi5To?;>oooXn_K[m_Gc
ookolO3hn?Oloooooookooojooom09>IVIT00oooolc<c<c<c01Mc<c<00DA
70XJ2@XA70XJ2@XA70X00PT92P07;1804A`:2@T:6PT:4A`:2@T:;180008A
70X03AX92Q4L2PT92QX92R`B00T92Q4L2QX92R`B014L2R<L2R`B02<L2P02
4A`:00h92@XA70X92@XJ2@X/4P092A@J2@X/4P0S70X/4P092@XS70XA70X9
2@X34A`:01`92@X94PX92@X94PX/C2UZLUaZNfmZSEa?IdM6GTM6@AhS;ahS
;bT/C2U?Ie`mGSdd;c=?GVJ3V8j3Q8iZNhAGSEa6GTLA9Qh94PXS;bTdECdS
;bT2000000<94PXJ9Q@J4Q@00PTB2P0O4A`:6RHD;3PY2A8:4A`:2@T:2A8:
2@T:2A8:8a`:2@TD6Q8D0000UD`YUG97kMW<i=3<4A`:SED:YXB4g;jgm_Ke
Ea`0kNgZm^gZm_oo00002A`D4BHD2@T:4BHD008A70X02@T92PTB2PT92Q4L
2PT951X92VYW<g^=IX=k<`022@T:01L94PXA70XJ4Q@/>2TS;aiP@BU6C3f=
SE:3NebEV6JEXHk1/hiPGS<d;aj=SFo1/jg:d<7CfMK]m_GfoooCfMKLhmKC
fMH00mcSeP05i=3<g>?Fi=3<g>?Pm_oe00;oool02W:=Q6YE7VYW<iF=I/6Q
Q=cSe_ooojJZXkUW0;1<00B`E@002JI<08=108<_060_2W8V04HV2SdL2R`B
014V2P026PT:0PT92P094A`:2@T:2@T:2A8:4A`:2@T:4A`:2@T:4A`:00<9
2@X01Q4L2PT92PT92PT92PTB2Q4L2P892@X01Q4V50T92QXB51X92R<L2QX9
2P8m70X00b`B03dL2ULL0002Ea`000<S70YG700m70X00SdL2P07ARHDLRH0
H2l:H2l:LRH0H2l:Pbl000A69PX033dL2THV2W8V04HV2SdL2THV2ULL060_
2THV54H_2ULL0<77c67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c006IVIVc<c<VIVIVIVIIVIVc<c<2iVIV@0Foo[ooo_onOOl
o?oomooljoS_n?ojnOohno[eooSaoo_aoo[XooKHo^6gX81=Q6@WLU4<OU`D
QV@MQfDNR6DSS6TW0Xm/;0:>JR`4SV/[00>>JbV>Jb^=Jb`02Xe[;QB<JRd0
0haZ:he[;8e[:`0FSF/[01VAKbn?KBf=Jb^<JRZ=Jb^<JRZ;JBV9IbZ0EbV1
FbjUQEKoj[WoolgoomCoo]gonnGoooSoooo`l?Sno_ooo_okno_ooo_ooo[o
ood0TiVIV@03ooooc<c<c<c<05g<c<`02A4L2PT92R`V514L2QX92R`B014L
2R<L2PT92P024A`:0QX92P034A`:6PT:4A`:008J2@X03b`B014L2PT92Q4L
2PT92Q4L2PT92QX92R`B02<L2R`B00T92QX92R`B00TB2P022@T:00DA70X/
4P0/4P0J2@XS70X00QX92P074A`:2@T:6PT:2@T:4A`:6Q8D4A`:00894PX0
6@T92P0002`h:CeN?H>=Q7^=IVYkKdmWAdI<?B<_7R`h:B<_<g:=Q6YkKdIW
G6Z=G7:=Q6YkQ6YkKeMWDRa<:A4V7R`h:B<_:@0000042A8:00@A70X94PX9
2@XJ4Q@26RHD0a4L2P042@T:2A8:4A`:6PT:0Q4L2P072@T:H44YYW9Bg;jg
m_ooYXB4LSP000;1XH@01_KfmIE<:Mbn]nC@c?KoojJ4Q08A9PX01@T9514L
2PT9514L2PTB2P044A`:00P/9Q@/>2UPGS?1/hj=SDL94PXA70X94PX24A`:
00hJ4Q@d;ai6EBUbIe9kSFJEXHk1/jfEXHhdEBV3Nc?1/jg1al7:d<7Lhn02
kOKe01kCfMK:d<7:d<7Td<cLhmKTd<cCfMK:d<7Td<c]kN[ooooChoEGSHi6
@AjELTNNQ6KTal7]fLcfoooooonVQ8BiI`2`E@2iI`2`E@2`C02iI`2`E@2V
@@2EE@02Pbl000IP;`YG700m70X/4P0S70XJ2@X34A`:00H92@XA70X92@X9
4PX92@XA70X22@T:00<A70X92@XA70X00`T92P0<4A`:2@T:2A8:2@T:4A`:
2@T:;1`D2@TD;1808a`:;1808a`:0THV2P038a`:H2l:H2l:008m4PX01DHV
2SdL2SdL2SdB2ULL0003LRH000Ab>1Ab9P23;`1P;`X2ARH:00Lm70Y69PYG
70169PY6@Ahm4PYP;`X00dHV2P03ARHDEa`0/;k1067<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00:IVIT0
0fIVI/c<c<c<c03oc<c<3/c<c003ooooc<c<c<c<05g<c<`06Q4L2QX92QXB
514L2QX92PT92Q4L2PT92QX92PTB2QX92Q4L2QX92Q4L2QX92PT92QX92Q4L
2QX92Q4L2R`B01X92PT92R`B01X92QXB508J2@X02B`B014L2PT92PT92P00
00TB2QX92QXB51X92P028a`:0QX92P03;1804BHD2@T:008A70X01@T92Q4L
2R<_7QXB514L2P022@T:00D000092A@dEBUbSHB3Q8h00VYkK`8dECd03VYk
KcAE?DIWG4mWG4mNIVYkKh>4SVYkKdmbNdIWG2a<:A4V2PT950T92P894PX0
21XB50TB2QXB50T92PTB2Q4L2QXB51XV50@94PX22@T:00dA70X92A@A70X0
00169PZ3GS?L_[Ofm_G]fL`m4P[1XHCL/j?L_[L00/6QQ008i<O1m^gZkMW<
LVMB4BH:2A8:4BHDAT4N0QXB50052@TD4A`:2@TD2A`D6Q8D008S70X01X=k
G9FQSSAE:@TB2PT92QXB50<A70X02b`V5<6c[H=kG9FQS[2c]k2ZQ14V2ZJ4
Q<77`L77c>C@c002kOKe00?Lhn3LhmKTd<`00/[@`@0AdmWFb]31b]31b]31
g>?FooooY/OPAT4NJUDNWXAVYYR4b[j]g>?Pm_ookOKeoooo`J6400:iI`00
2k1E0;UW0;UW0;1E0;UW0:I<0:I109EE08<h060_2ULL0002ARH:00@S70XA
70X92@XJ2@X22@T:00PA70XJ2@X92@XA70X94PX92A@94PXA70X22@T:0PTB
2PL92@X00`00014L2QXB5002;18000<m4PY69Q@m70X00SdB2P0DEa`0H2l:
;1`D?A`:?A8:ARH:?A8:H2l:LSPDEa`0H2lDLRH0LSPDNd`:H2l:LRH0ARH:
?A`:H2l:ARHD0ULL00038a`:ARH:ARH:00969PX00dH_2SdB2/77c01Qc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<
c9VIV@03VIVIofIVIQ1VIVH00oooolc<c<c<c01Mc<c<00LJ2@X92@XJ4Q@9
2@XJ2@XA70XJ2@X00Q4L2P046PT:2A8:6PT:4A`:0QX92P0=4A`:;1804A`:
6PT:4A`:6PT:4A`:2A8:6Q8D;1802@T:8a`:6PT:008/71@22@T:00/92A@0
000J2@XS70XJ2@X/4P0J2@XS70X/4P0S70XJ2@X00PTB2P096Q8D2A8:2@T:
6Q`N6RHD8blN4BHD4A`:2@TD008000003@TB2SAE?H>4SX>=Q6YkKeN=G5MN
Kg^=IUN=G5MWDTmNIW9bNfYkQ002LXf400@94PX000092@X92A@22@T:00HJ
4Q@92A@92A@S;ah000092A@24BHD01<A70XJ4Q@92@X94PX92@XA70X92@XJ
4Q@A9Q@94PXJ4QA69QBEC2WTal7foooooolS70[:ZVJ`Q7/00^C@c00GYW9B
b[j]i<O1kMW<b]3100004BHD2A`D=2lNJVLcJUDN4BHD2A8:6Q8D2@TD6Q8D
4BHD6Q`N6RHDg<NSSHe72A8:2A`D008J4Q@03a4L2Q4V51XV5:JHKiFQS[2Z
Q:JZXiF4NdHV5<[@e/77`McSe]cSh=?SmNg]jP02g>?F0]?IePC:d<404=cS
e^gfmMcSh5MEDYF4DZJHQ<6cS^C7`McSe_KoongfmOK]j_Kool77c;UW0=>4
00:iI`002;1E0;1<0;UW0;1E0:I<0:I108=108<_009P;`X01ELL014L2QXB
514L2QX92P024A`:0PT92P044A`:2@T:2@TD2A8:0PT92P034A`:2@T:2A8:
00892@X00`TB2PT92PT92P022@T:00<A70X92@X92@X00QX92P05;1`D?A`:
?A`:Ea`0?A8:009P;`X02eLL03dL2THV2SdB2THV55LL060_578V060_578V
060_2P02Pbl000=69PYP;`Y69PX01DHV2P08ARHDEa`0ARH:?A`:ARHDEa`0
?A8:b]3FHLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4
c<c<00=VIVK<c<bIVIT0oiVIVA>IVIT00oooolc<c<c<c01Mc<c<1A4L2P0I
8a`:4A`:6PT:4A`:6PT:4A`:8a`:6PT:4A`:8a`:6PT:4A`:6PT:4A`:6PT:
2A8:;1802@TD;1806PT:4A`:2@T:6Q`N=2lY4A`:00892@X01PTB2Q4L2R<L
2R`B01XB52`B008S70X00aX92R<L2Q4L2P022@T:00H94PXA70X92@XA9Q@A
70XA9Q@2;3PY00Td;ahS;ahA9Q@/>2Td;bTS@CeGGVmZNfmbLW/00VYkQ009
LXf4H79kAVMLCg9kPiR>AUi700004BHD000000892A@24A`:00/94PXJ71h9
2@XJ71hJ4Q@A70X94PXJ4Q@92A@A70X971@00PTB2P0=2@T:4BHD6Q8D4A`:
6Q8D2@TDARH:UG97i<O1m_KeooooARl:^IQL00;1XH@03^C@c7]<5<6QQ>C7
`Ng]j_Koof0_2Q4V2R`L514V7W:=?DI<?DIE:AXV508A70X06AXB52`B014V
53@_:L6c[IFQSQ4V2PT9514V514L2QXB52<_7PT95:JHQ;2c]jJZXiFQSVYb
G:JQV<6c[L[@`NgfmM?SmOKoomcSh002dmWF01OLhmKCfMKLhmK1alc1/jg1
al7Lhn3]kNYPLW^EV6K1/hk1/jg:d<7LhmKfm_Gfooo]m_Gfm_GooooLhn3C
Q02iI`31Q0000[1E0004`H@0^FL0/5D0^FL00ZI<0006PcP0LSPDLRH0ARH:
;1802@T:0Q4L2P8J2@X01a4L2PT92QX92Q4L2PTB2PT9514L2P022@T:00<A
70X92@X92@X00`TB2P034A`:2@T:4A`:00892@X0414L2R<L2R<L2R`B03dB
2THV2SdL2R`B060_560_2ULL03dL2SdB2THV54HV2V0_2P9b9P001dHV578V
078h58<_07]<578V060_5002ARH:00M69QA69PY69PY69PYG70169QA69PX0
0THV5003ARH:Ea`0`LO<067<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01nIVIT4oooo0_ono`?oood01ooo
nocnnOGjlo7fkngbjnC[hmcTf@04emoB1=KNdCSGgm88f=kD1mWOe@09f>3C
e]o<f^?>hn[Jjo7SmOSan_ciooooooko00?ooOl00oonooooooooo`02ooom
00?ooonIVIVIVIT0P9VIV@03ooooc<c<c<c<05g<c<`00a4V51XB514L2P02
6Q8D00TA70XJ4Q@A9Q@J2@XA70XS70X92@XJ2@X94PX011X92P06;1806PT:
6Q8D;1802@T:8a`:0QX92P05;1`D8blY6Q8D4A`:6PT:008A70X01cdB2Q4L
2R<L2R`B01XB52`B01X92P028a`:00<J2@X94PXA9Q@00PT92P0I4A`:2@T:
2@TD6Q8D4A`:6RHD;4`Y?EhmJW]_PhAkJXeLPhB>JW]_JW^4LXf]LXf4JW]_
Eei_JW^4Cg9kCeiVAUEB8blN00004BHD00894PX03PT92Q4L2QXB50T951XV
514V7QXB50TB2PT9514L2PT92PTB2QXB50T950894PX06Q4L2PT952<_:AXB
51X92PTL53dL2W9ED/Zn[Ng]j_oooiF4SYib<mbcXjIEI_KfmK24NiE<:NC@
c>gfmOKoongIc;24I/6cSZIb514V509PGS<06c@_:AXB50TL514L2QXB514L
2TI17[2c]l6cSQXV514V2PTL51XV51XB51XL7R`V5;2ZQ<6c[JJQV8>=Q<77
`K2n`K2c]mcSe^gfmNg]j_Koo`02dmWF00?Lhn3CfMK:d<400/77`@0:g<NS
b]31kOKeUIRSUHAk`K>>`K>]b]31g>?Fm_Ke0oKoo`08kOKeoooog>?P/5D0
dh@0^FL0`H@0dh@00[UW0005/4`0^FL0/5D0YT`0UED000:3;`001THV51XL
7Q4L2Q4L2QX92Q4V508A70X01@T92PT951X92QXB514L2P022@T:00DA70X9
2@X94PX92@X94PX00PT92P0H4A`:2@T:2@T:4A`:2@T:6Q8D?Blm6PT:?A8:
ARH:?A`:?A8:;180H2l:LRH0=2lN?A`:ARH:Ea`0ARHDEa`0H2l:LSPDEa`0
0V0_2P:3;`0024HV560_2THV2SdL2THV560_2THV2V0_509P;`X01THV2ULL
04HV54HV2SdB2/77c67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c003IVIVc<c<VIVI01nIVIT6ooko0_ooo@09oooko?ggl_G^
i>[Pg>;HemoDdMW<b];3_LRg00:mbKD3_<Rd0[_7/cNmbKD00kg8]ko7^;o7
^006_lNh1kk6]`09_/Nd`lfda]>gcmW1eMk;gN?Gj>[UloGdno[o00Koo_l2
ooom00?ooonIVIVIVIT0P9VIV@03ooooc<c<c<c<05g<c<`02aX92PT92QXB
51X92R<L2QX92Q4L2QX92PT92QXB52`B00036PT:00h/4P0A70XS70XJ2@XS
70XA70X/4P0J2@XA70XJ2@X/4P0J2@XA70XJ2@X42@T:01<A70XJ2@XJ2@XS
70XJ2@X/4P0J2@XS70XJ2@X/4P0J2@XA70X94PX92@XA70X92@XA70X92@XA
70X00PT92P0=6Q8D0000AUEBUIRSNhf4SIR>H79k`LO</;>gJW]_H79kJW^4
H79k009?LW/01DmNIR<_7PT92R`h:@T92P032A8:00HA70X92A@J4Q@J4Q@9
4PX92@X24A`:00@92@X94PX94PX94PX32@TD00TJ4Q@A9Q@J4Q@A70X92A@m
70ZELTO1XHCTd<`00_Kfm@03UEDD^G8c/7]V00;]kNX05YE<:Mbn]oKoongf
mOKoongIc=bn]nC7`FYW<a4V2X=kG8=k<`TB2QXB514L2R`L514V2QXV5<6c
SZJQV6YE7QXV508J4Q@04AXV52`V56YW<h>=Q:JZXjJZ[L[@eZJZXk2ZQ;2c
]ngfmM?SmNg]j^gfmM?Ie]cSh<[@`@02`LO100^`/kO1/jgTd<cLhmKCfMJV
V6nVXIS1/jg1alcLhmK]m_D00oKoo`04m_Kem_oooooodmWF1=>40004`H@0
dh@0`H@0/4`00[UW0003/5D0YT40UED000:3>002?A`:00<A70XJ2@XJ2@X0
0QX92P044A`:6PT:2@T:6PT:0PT92P054A`:2@T:2@T:2A8:4A`:00D92@X0
0`TB2PT92PT92P024A`:00//4P0J2@Xm70YG700m4PXJ4QAb9P1G701P;`Xm
70YG7000160_2P03Pbl0LSPDLRH0009b>1@00h<_060_2V0_2P04ARH:00YP
;`YG70169PY69PYG70169PX/71A69PXm4P[:d=IQc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0OVIVI1Oon
o`;oood02_oonoSilo3cj]oUfL[B`kk6]kW2/KBm[:^gXJ:`U`>Q[iD2X:jD
0Yn]TcRMZi400ijZTZ2YU:2YU005X:VD1j:[UP09X:fCYkFB[;ZF/[nQ^<:Y
_lRgbm?8gN;LjNg^00;nool4ooko0_ooo@03ooooVIVIVIVI082IVIT00ooo
olc<c<c<c01Mc<c<00@J4Q@/71@A70XJ2@X22@T:01LJ2@XA70XJ2@XA70X9
2@XA70XJ2@X92@XS70XJ2@X/9Q@92@X94PX/4P0J2@XA70X94PX/4P0J2@XA
70X/4P0J2@X92@X00a4L2P0=6PT:8a`:8a`:;1808a`:8bH:8a`:;1806PT:
8a`:6PT:4A`:2@T:00<94PX03`T92PTB2PT92Q4L2PTB2QXB50T92Q4_<fYk
KiFHXg9bNjJc`FYkKg:=Q6YkQ002LXf400QPLW]ZNfmkSHAGSE`000094PX/
GSd000022A8:00<92A@A9Q@J4Q@00PT92P032A8:2@TD2@T:00894PX010T9
2PTB2QXB50T92P894PX05AXB514V7Q4V51XB514L2QXB56YE7ZJ4Q>C@c>gf
mOooog9ED[2=<l5kNngIc?KoolZn[K24I_KfmNgfmOKoo`03kNgZ01[Tal56
;`ZEV6J3Ne`dEBT94PXJ4Q@A70XS70XA70ZEXHk1/je6EBT/>2TS9PXJ4Q@A
9PXd;aiZLUbEXHkCfMK:d<71al6EZZf=V8k:d<42kNgZ00?fooo:d=K1al40
0/77`@B`/kL02=cSh>gfmJJZXjJZXl6cSZJQV=cSe^g]jPKfool00oooombc
[M>40004dh@000>iI`3CQ02iI`000[UW000</5D0YVL0YT40UED0Pd40ARH:
?A`:8a`:;1806PT:2@T:4A`:0PT92P064A`:2@T:4A`:2A8:6PT:4A`:0PT9
2P0>4A`:2@T:2@T:4A`:2A8:2@T:4A`:2A8:2@T:2A8:2@T:;1`D;180Ea`0
0THV500<?A8:H2l:H2lDLRH0?A8:H2lDEa`0ARH:ARHDPbl0LSP0H2lD0W8V
0005Nd`:Pbl0H2l:ARHDEa`000969PX01ELL060_55LL04HV55LL0002ARH:
0SdL2P03;180dn?ec<c<063<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01nIVIT2oogo01Koo_oooOoooooo
oogmo_SdmnkWkN7DgLc0bKJb_ZRY]IfO[9:FXhV@WH6?WWf<W7R8V7B5UG63
Tfn4U727Ug>8V7@hQIEa38JDL`0>QiEdRIMfRYQgS9YgTJ1gTZ=gUZJ1W:Z9
YK6I];n^alo4dm[Ci>SWlOGf0_gno`05o?cnoOgmooomookloooo08:IVIT0
0oooolc<c<c<c01Mc<c<00<A70XJ9Q@92@X00a4L2P062@T:4A`:4A`:4A`:
2@T:;1800Q4L2P0<2@T:8a`:8a`:;1806PT:;1804A`:6PT:00008a`:2A8:
;180114L2P042@T:6PT:4A`:;1800QX92P078a`:;1804A`:8a`:;1806PT:
8a`:008A70X01`T92P0000TB2PTB2Q4L2QXB50T92P022A8:00@92@X0002E
V:=kSH@2UJZ]00E6EE9bLW]bSHAbSHAPLW/00W:=Q006PiR>AVML00002A8:
CfM700000`TB2P038blY2A`D2A8:00<94PX0114L2PT92PTL50T92P894PX0
6A4L2PT9514V51XB50TL52`V50T92Q4V514L2V0_5>BZV:JZ[Mbn]oooombn
]iEN<k1kI/77c?KfmNC@c;1kI_K]j^g]j_KfmNgfm@02kNgZ00GLhn2iZVmP
GS>VXIQ6EBT00PTL500B2@T:6RHD4A`:H5hcUIQVAUDYH5hc4A`:6RHD2A`N
JVLcYZ6HdmWFb]31`LO</;>g/:Z4PhAk0^g]jP;]m_D00k2c]l77`L6c[@02
UJ6>00N`/kO1/jg]kN[Lhn23V:fVXIR`/kL00/6c[@03kNgZkOKem_oo00Kf
ool01KUW0=>40=>40=>40>BZ0004dh@00kUW0007/4`0/5D0YT`0UED0Pbl0
LRH0ARH:008S70X01A4L2QX92Q4L2Q4L2PT92P032A8:0`T92P894PX010T9
2PTB2PT92PTB2P<92@X01A4L2PT92Q4L2QX92R`B0002ARH:00=G700m4PYb
9P000W8V0003ARHDLRH0LRH0008m70X00g8V08<_078V0003LRH000YP;`YG
701P;`YG70169PYG70169PYb9P169PYG7003ARH:00@m70X/71@/4P3CfMIQ
c<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIV
I/c<c9VIV@0OVIVI0_omo`1<ookoooooooomo_okmOS_jNoQbmC1_/Zd/;fS
X[6BTj60P91/M89OKWiIM8EKLhAHLhAJLX=GLX=ILX=GLhAJLhAHMHILMHIJ
MHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHIL
MHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJ
MHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHIL
MHIJMHILMHIJMHILMHIJMHILMHIJ0WF6G09fQE`06GJ5GWJ5G7J5GWJ5G7J5
GWJ5G7N6GgN6GGJ5GWJ5G7N6GgR7GWV8HGZ9GWb>GW65E764EgnAJHjOOIVY
SZZgXk[6^=3JdN?ZhoKkm`02o_oo00Coooooo_oooOkooon2VIVI00?oooo<
c<c<c<`0GLc<c0066Q8D6PT:4BHD6PT:4A`:6PT:0Q4L2P8J2@X01@TB2Q4L
2QX92QX92R`B00024A`:00LJ2@XA70XA70XJ2@X/4P0A70X/4P000aX92P06
;1806PT:6PT:6PT:4A`:6PT:0b<L2P09;180;1`D6PT:;1806Q8D;1808a`:
6PT:6Q8D00894PX01@T92PTB2QXB50T9514V50026Q8D00<92@XdECekSH@0
0YFHX`04CeiVLXf4Cg9kPhf40TIWG00@PiR]UJZ]PiR]00002A8:6Q`NAUEB
00002A`D2@TD2@T:;4`Y6Q`N2A8:2@T:2@TD0`TB2P036Q8D2A8:2A8:008J
4Q@050T9514L2Q4V7R<_<b`h:A4L2QXB50TB2R`B0<6c[L5kNmbn]ngfmOKo
ok1kIZIbD]bc[NgfmNg]j^BZV0;]kNX05_KfmNgfmOKfmNg]j_K]j]cSeQ4V
2ZJZXg:=?B<_7PTB2Q4V50T952`L52<_7TI<?IEbAhf=DQ4V7Q4L2VYW<l[@
`@?1al`01l77`JJZXjJZXk2c]oKoom?SmOKoo`03`LO<00VEXKN=V8jEZZg:
_Zg]kNZVan0J9QA6C3g1/hh00/[@`@03g;jgoooom_oo00Gfool01NgfmNBZ
V=>40=>40>BZ0003dh@000?TZP3CQ02iI`000k1E0004^FL0/4`0/5D0/5D0
0X=10003LSPDARH:;180008J2@X01a4L2QX92PT92Q4L2PT9514L2PT92P02
4A`:0PT92P042A8:2@T:2A8:2A8:0PT92P074A`:2@T:2A8:6PT:;180;1`D
?A8:009G70003SdB2W8V078h560_2THV2ULL078V03dL2THV2X<_07]<2W8h
578V04HV2P=P;`X025LL060_2ULL060_55LL04HV55LL04HV50=69PX013dL
2R`L53dB2]?SmF7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2h
R<2h1<c<c003IVIVc<c<VIVI01nIVIT2oogo04coo_ooooonoo_ho_CWkn3E
hLg2d;N[^Y^CXgn9Vg>BXgNU^8Zmcio<gZkSmLGVm/GYnL[[nl[/o<g/o<_Z
n/_YnLS[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[
nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[
nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[
nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nlX2jo_<0^gjc00LkO[>
kO[<kO[>kO[<kO[>kO[<kO[>kO[<k?W=k?W;k?W=k?W;kO[>k?c;gO:jb=nW
]/fIYkf>TJIkPiMbUZN7]<BZ_LZfdMk=jO?Xn?oho_omo_oo0ooooh:IVIT0
0oooolc<c<c<c01Mc<c<00/A70XS70XJ4Q@S70XJ71hA9Q@J4Q@92@XJ4Q@9
2@XS70X00QX92P064A`:6Q8D;1806PT:;1806PT:0R`B00056PT:2@T:;180
4A`:;18000<J2@X01PT92Q4L2Q4L2QX92R`B02<L2P8J2@X030T92R<L2QX9
2Q4L2QX92R<L2Q4L2Q4V2PTB2PT92Q4L2PT92P894PX04@T951XB514V2QXV
56YkKiFZ[G:=Q4IWG6YkQ7:=Q4IWG3eN?B=1?FYkQ:K7h8>HSPTL50022A8:
00a6Iea?Ie`0000S;ahA9Q@0000/>2TJ9Q@92@X94PX92A@94PX22@T:0149
4PX92@X92A@92@X92A@A9Q@J71hA9QhS@E9GIe8A70XS70XJ4Q@92ABEC2W1
/jgL_[L00_Koo`0Ni=3<UEhc`J64kMW<g>?Pg;jgkNgZm_KekNgZm_Kem_oo
kOKekNgZooooARl:YZ6HPg]LAUDY2A`D6Q8D4A`:4BHD;2HD8a`:EfMBLXdm
H44YSHe_`LO1/;k10/77c0;1al400k2c]l77`JJZ[@02kOKe013:d=JEV:>`
_/71al71albV/l7Td<bEZZeGSHh/GSe6C3dJ9Q@94PZEXHk:d<7Lhn04m_oo
0_ooo`03m_oobZ4mdh@000;CQ003i:X00]>40005i:X0dh@0dh@0dh@0^FL0
00>`E@001/640:I<08=109EE04HV2R<L2P8A70X01aX92PT92Q4L2Q4L2QX9
2PT92Q4L2P022@T:01T94PX92@X92A@A70X92@X94PX92@XA70X92@XA70X9
2@XA70XJ4Q@/4P169PYb9P1P;aA69QAP;`Yb9P23;`1P;aAP;`Yb9P1G7000
0V0_2P05Pbl0ARH:Ea`0ARH:H2lD00=P;`X03ULL060_54HV2ULL04HV2ULL
04H_2SdB2SdL2R`V53dL2TI17X=N5<[@eV7<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01nIVIT0C_omooon
ooooookooocono7ik=OScl7?]ZbmWIZ_R9:XNZ6gQ[kEWmS`]^Kn`^kob>[k
aNcmbO;ocO?od?KodO?od??oc_3ocO7oc>ooc?7oc>ooc?7oc>ooc?7oc>oo
c?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7o
c>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>oo
c?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7o
c>ooc0Caol`07O7oc_7oc?7oc_7oc?7oc_7oc?;oco;ocO7oc_7oc?3ncO3n
bo3ncNkobNSoa>Co`n?oa=Sd^[WDWiF_OhZQMHjTOZ^nW/3@]]WVe>cfjoOl
m_goo?koo`02ooooPYVIV@03ooooc<c<c<c<05g<c<`38a`:00LA70XJ4Q@J
71h92@XA70X92@XA70X00QX92P062A8:?Blm;180;1804A`:;1800QX92P06
8a`:4A`:2@T:;1806PT:2@T:0R`B00064A`:;1806PT:6PT:;1806PT:0R`B
00034A`:;180;180008/4P00:QX92Q4L2QXB52`B00T92PTB2PT92Q4L2PTB
2Q4L2PTB2Q4L2S@_<fYkKg:=Q3@_<dIWG5MWDTIWG4I<?@TL514V59FHXl77
c8>HSQ4V2P0000TB2Sd_?IFZ[DmWG00002<_7Q4V2PT952a<:B<_:@T92PTB
2PT92PT9514L2P894PX05PT92Q4L2PT92QXV514_<b<_<a4_<dIWG8>H[@T9
2R<_7PTL50TB2ULL0<6QQ<Zn[NgfmOKooooook1kI/6QQ<77c0;Td<`01>gI
c>gfmOK]j^gfm@?fm_D01Ooook24Ng^=IXf=KdmWA`022A8:00HA70XA9Q@J
4Q@J9Q@A70YPGS<2/;>g01Z`_/71alc:d<71al6`/kNVZZfVV8B`/kO:d=K]
kN[oooo1al6`_/7CfMJ3V:ekSHA?Iec1al71alabEE:VXIREZZfEXHi6@Ah0
0016C3d2m_oo00O]m_GfoooooooooooChoGT/bWTZP000m>400;TZP001=>4
0>BZ0;UW0>BZ00;CQ0001[UW0=>40;UW0<640;1<0;UW00;1Q0001YEE078V
03dL2R`B01X92PTB2P<A70X22@T:00LA70X94PX92@X92@XA70X92@X94PX0
10T92P0<2A8:2@T:2@T:00008a`:;180;1`DEa`0H2l:Ea`0LRH0H2l:0W8V
009P;`X01X<_060_2THV2V0_578V02`L509G70001THV2V0_2ULL060_2ULL
060_2P=69PX01B<L2THV53dL2SdB2Yik<`02WXdc00>Van3<c<c<c<`0Glc<
c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<
c<bIVIT07iVIV@1>oogoookooooooOolmokfi_7Qb=O0[/6QTZR1Ujj0ZL6=
aMjTgONfiOnmhObeg_BckOk7l?k;l_k<loo>m?o>loo>loo=l_o=mOo?m?o?
mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?
m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?
mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?
m?o?mOo?m?o?mOo?m?o?mOo?m?o?0oGoc`0@mOo=mOo?mOo=mOo?mOo=mOo?
mOo=mOo?mOo=mOo?mOo=m?o>loo;loo=koo9i?jo0^7o_@0;h_o0h?k0cnfa
[lbDTZikV;:5Zl6KbMVoh^oMm?_cnool00;nool00ooooiVIVIVIV@20VIVI
00?oooo<c<c<c<`0GLc<c00H6RHD4A`:4A`:6Q8D2@TD6PT:4A`:6PT:4A`:
6PT:2@T:4A`:8a`:6PT:;1806Q8D8a`:6PT:;1804A`:2@T:;1802@T:8a`:
0R`B00094A`:2@T:;1802@T:4A`:2@T:6PT:;1808a`:008J2@X01aXB51X9
2PT92QX92R<L2R`B00T92P024A`:00`94PXA70X94PX92@XJ9Q@S;bUZNfm?
IdLmGSdS;ah/C2U6C3d28blN00D94PX/71BEXHjV/l6=V8h00P00000=2A8:
4BHDUJZ]Y[?1JW]_0000;4`Y8blN0000AT`m4BHD2A8:2@T:00H94PX05@T9
514V51XL7SAE?B<_:DINAh>4SUN=SS@_7R<V2QXV51XB52`L59j4I/6c[Mbn
]ngfmOKoombn]jJZXnC7`@02i=3<01W]m_Gfooo]kN[fm_G]m_Gfm_G]m_Gf
oooL_[N3Neb=V8i?IdL/>2TA70XJ4Q@92A@J2@XA9Q@A70Y6C3g:d<71alc1
al71alb`/kL00ZJZ[@0>YZ6HYZZ]`LO1kNgZkOKedn?eb]31`K>]g>?P`LO1
UJ6>YZZ]/;>gdn?e0^gfm@05kNgZg>?Pg>?P`K>]YZZ]00C]m_D00mcSh9Fc
c>BZV004i:X000?CQ03TZP3TZP000^BZ0003g:Xci:X0dh@000;CQ003^FL0
00V`E@31Q02iI`2`LP2EE@1P;`YG700S9PXA70X00QX92P032A8:6PT:4A`:
00892@X01b`B00T950T92PT92Q4L2PT92Q4L2P022@T:00<A70X92@X94PX0
0PTB2P076PT:?A`:?A8:LRH0H2l:Ea`0LSPD009b9P001F0_2W8V08<_078V
03dB2P02LRH000Lm4PY69PXm4PYb9P1P;`YG701P;`X01DHV2P05?A`:ARHD
;180H44YYZ5V00:=SDL00fYW<l[@e/c<c01Pc<c<00AVIVJ8`;R8`;Q8T8P1
0000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0OVIVI04oooOoo
o_onoooio_[`n>gKj=Jkc[:Q]i>AZgjP_HNjeY_@kJ[Jn;3Oo[;YokKbol?c
olWdolkgom7eologom7eologom7eolojomChom;jomChom;jomChom;jomCh
om;jomChom;jomChom;jomChom;jomChom;jomChom;jomChom;jomChom;j
omChom;jomChom;jomChom;jomChom;jomChom;jomChom;jomChom;jomCh
om;jomChom;jomChom;jomChom;jomChom;jomChom;jomChom;jomChom;j
omChom;jom@00_SodPchom005?OocoKoc_;oc>oob>Oo`m_l]M3aZ/o`ZL[^
Z;SHUj2oPhbYLi^eR;[=[M_Zdo;llO_ooOcooognoooooh:IVIT00oooolc<
c<c<c01Mc<c<00TJ4Q@J2@Y69Q@/71@J4Q@A70X92@XA70XJ2@X00Q4L2P05
;1804A`:;1806PT:8a`:008J2@X01B<L2QX92R`B01X92PTB2P02;18000`A
70X/4P0m4PXJ2@X/4P0A70X/4P0A70XJ2@XS70XJ2@XS70X2;18000<J4Q@S
70XJ2@X00Q4L2P0<2@T:6PT:4A`:2A8:2@T:AT`mJW9L=5Dm4BH:2@T:4BHD
;4`Y0R`h:@0D6RHD2@T:PhB>UJ6>Y[?1CfM74BH:4BHD2@TD8blNPiR>Y[?1
/;k1NheV0000;4`Y8blN4BHNJXeL000010TB2P064A`:2@TD6Q8D2@TD2A8:
=5DY0R=1?@0?AUEBH79k/;>g;5EL/;>g00008blN6RHD4A`:PehcYXB4g;jg
kOKekNgZi=3<00;L_[L7kOKe0_Kfm@0?m_ooi=3<=5DYPhf4UJ6>AUDY4BH:
4BHD2A8:4BHD2@TD2A8:H5hc`LO<`LO100:VZZd04ZJZXl77`JJZ[K2n`JJQ
V>g]j_KoongfmOKool[@`LZn[Ng]j_Kook2n`L77`L[@e/[@`M?IeP;]kNX0
2m?SmNg]j]?SmNgfmM?SmNgfmOKoong7G9EN<h>4Nonc0002i:X000Wf/`3T
ZP3TZP3TZP3f/`3TZP3f/`3CQ03TZP001=>40005^FL0dh@0`H@0^FL0dh@0
00:EE@000g8V04HV2SdL2P02;18000<A70XJ2@XA70X00PT92P064A`:6PT:
2@T:4A`:2@T:2A8:10T92P0:2A8:2@T:4A`:2A8:2@T:8a`:?A`:ARHDH2l:
H2lD0g8V000:LSPDEa`0LRH0LRH0H2lDLSPDLRH0H2lDH2l:LRH00dHV2P03
H2l:ARH:?A`:00969PX02b`V54HV2THV2V1159ib<hf=DX=k<fYW<f1N<dH_
2/[@eP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@0OVIVI0_ono`1>o_oom_chj?;WdN3;//NXVK::VkN6
Z/V>`^6Ndo>Zf?VZe_RTf_^Ti?nbkok5l__<mOc@m?g>m_gAmOk?mOc@m?g>
mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@
m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>
mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@
m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>2?Cnc003log;m?k<
mOo=00;eold05?Cnc??mbngnamol^^?o_nWo`nGo_MWn/LW_X[[NU:kBS9Fd
N9^gQ;36WlkPa^[fj?Snn__ooognooooo`FIVIT500000iVIV@@00003VIVI
0P000004VIVI00000000VIVI0P000003VIVI0000000000FIVIT400000YVI
V@D0001CVIVI00?oooo<c<c<c<`0GLc<c08S70X2;1`D00LA70X94PX94PX9
4PX/71@A70XJ2@X00R<L2P0A6PT:8a`:8a`:4A`:;1804A`:;1806PT:4A`:
;1804A`:8a`:6PT:8a`:2@T:4A`:2@T:00<J2@X022`B02<L2QX92Q4L2R<L
2QX92R`B01X92P8/4P034A`:00@J4Q@0001?IdMGSE`2000000@A70XJ2@XA
9Q@J4Q@2;4`Y01<94PZEV:?1al6VZZeZNflA9PXS;ah/9QAbIe:3V8jEXKNE
ZZfVan1ZSE`0000dEBTA9QiZLUaGSE`00PTB2P0300002A8:4A`:00894PX0
6`TL50T92TmWAa4_<b<_:CAE?EMNKh>H[H>4SV1bNjJc`DIE:A4V2R<_7QXB
54I17ZIbD/77`NgIc>g]j^C@c=bn]nC@c>gfmNg]j^gfmOK]jP03kNgZ0^gf
m@08oooob[j]AUDY`LO1YZZS=5DY2A8:4BHD0QXB50034BHD6Q8D4A`:00:V
ZZd2/;>g00J`_/71alb`/kO1al6`/kOChoD3kNgZ00_]m_GLhmJVZZgfooo]
m_FVXIS:d=K:d<7Lhn3ChoG]kNX01^gfm@05kMW<bZY7YZZSg;j]m[<000CT
ZP001=>40?Jc0?Jc0=>H2PGTZP001=>40;UW0=>40;UW00:`C0002KUW07]<
58eE2ZI<08<_05LL03dL2Q4L2QX92P024A`:00@92@X92A@94PXS70X32@T:
00d94PX92@XA70X92@XA70X92@XA70X92A@92@XA70XJ4Q@/4P169PX00g8V
0003H2l:LRH0LRH0009P;`X02W8h578V078V078V078h560_578V060_2THV
55LL00969PX01SdL2THV2SdL2ULL061158=N<`:3Nc<01VYW<f1N<dI17R`h
:@000=?IeV7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
1<c<c003IVIVc<c<VIVI01nIVIT06?kno?koookoooCio>C]j<cKb:g3WIFb
O:oBSZgCR;7JS<7XVLofYmWn[^3o[nKo]nSj_>cjaO3mb?7ob_?obo;ob_7n
bO3lbP?aoL/elOk92?3ob003k_g6kok7l?o800;aolT05?3ob>onan_o`n?o
_]Sn/mGk[]On[m3jZ<7[UkCMS[7GS:G8Q:;1R:[3VL;G^=o/f_3jl_Woooco
ookoo`BIVIT200000iVIV@8000000iVIV@0000000002VIVI0P000004VIVI
00000000VIVI0`000004VIVI00000000VIVI0P0000BIVIT200000YVIV@80
00000iVIV@0000000002VIVI0P0005:IVIT00oooolc<c<c<c01Mc<c<00T/
71@S70XA70XS70X92@X94PXA70X92@XA70X00QX92P08;1804A`:8a`:6PT:
;1806PT:2A8:6PT:0R<L2P0:;1802@T:;1806PT:;1808a`:2@T:4A`:;180
4A`:0R`B00084A`:;1808a`:6PT:;1802@T:6PT:2@T:0R<L2P0:4A`:;180
2A`D4A`:LUEB?Ehm2A8:2@T:2A8:2@TD0Q4L2P0F2A8:6Q`N;1`D;5hm`LO<
UJ6>JW]_AT4N=2lNAT`mPhf4UJZ]UJ6g/;>g/;k1g>?PCfM70000AUDY?Ehm
PhAk?Ehm0PTB2P0L4A`:2@TD2A8:4A`:2@TD0000;4`YAUEB;4`Y4BHDCeiV
Nhf4Y[?1CfMLY[?1UJ6gNheV4BHD;2HD6Q`N=2lYH44YUHAkkMW<i=3<kOKe
kMW<g>?P0ng]jP03dn?ekNgZkNgZ00;]kNX02OKfmOKoog9WDVYkKk2n`HfH
SUMWDQ4V2PTL50034BHD01TJ4Q@92@YkSHBVZZ?1al6`/kN`_/7:d<71alc:
d<7]kN[Lhn3CfMKfooo]kN[]m_GfoooLhmJVZZ?fooFVZZg1al7:d=KCfMKL
hn000ngfm@0Cm_ookOKeoooom_oei;=7UJZ]kM2Hi:X0m/L:i:X0m[<0i:X0
m[<0dh@0m/L:i:X0m/Lmi;<Ym[<000;TZP06dh@001>iI`2`C023GQB3;`2`
C023@@1b9P169PX/71@92@XJ2@XJ4Q@A70X92@XJ2@XS70X92@XA70X92@X0
0PTB2P@92@X32A8:00P92@XS70Xm70Y69QAb9P1P;`YP;aAb9P02H2l:00Ib
9P1b>1B3;`1b9P1P;`Z3;`02H2l:00Ab9P1G701G701P;`X2ARH:00Dm70Y6
9QAb>1B3Nc>=SDL00X=k<`07JVLcH5hc=2lN4BHNARH:UED0b]3F067<c<`0
16IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<
VIVI01nIVIT05OkokOkom?cloocnomkRjl7?`9fhQIVnKYk=IjCIKjcRQ;CX
UL3^Y/cg/]Kn]M_o/mom/n;m]^Go^>Go^nOo_002j?no00CXol3VokkVokkX
o[hej?jm3>Ko^`0EiOjji?fihobhgofgfonhe_nbd?f/b?FP`_2H_N^A]>2;
Z]F5Y<b5UkUlWKV9_MFae^G>n?ofmooin_ono_oo00VIVIT2000000>IVIT0
000000001IVIV@800002VIVI0P000004VIVI00000000VIVI0P0000RIVIT2
000000>IVIT0000000000iVIV@80001AVIVI00?oooo<c<c<c<`0GLc<c00G
;1`D8a`:8a`:6Q8D2@T:4A`:2@T:6Q8D2@T:8bH:;1806PT:8a`:6PT:8a`:
6PT:;1804A`:6PT:;1806PT:8a`:2@T:008S70X02AX92R<L2R`B01X92R<L
2R`B00T92R<L2R`B00026PT:00</71@/4P0J2@X00R`B008J2@X00b<L2Q4L
2R`L5002CfM700T0000A70XA70XA70XJ4Q@A70X971@A9PXJ4Q@00R<_7P08
PhB>Phf4JW]_PhAkPhB>UJZ]UJ6gUJZ]0[2c]`04/;k1dn?e4BH:4BH:0TmW
G004SIR>;4`Y00004A`:0PT92P0@4A`:2@T:2@T:6Q`NYZ6H?Blm;4`Y2A8:
Phf4UIRSUJZ]H79k`LO<b]3F2A`N;2HD0TI17P09LSPD=2lYH2lDg>?Fm^gZ
m_ookNgZkMW<i=3<00;Lhn003^C@c=cSh>C@c>C@c>gIc=cSh?Kfm@0008>=
Q;2n`IFZ[CAE?A4L2PTL508J4Q@021XV514L2PT92Xf=Kk2n`IFHXk2n`McS
h0;:d=H02m?SmL[@e/[@e/[@`M?SmOKoongfmM?SmOoool[@`JJZX`02/;>g
00?:d<7]kN[]kNX00^gfm@Cfool01^C7`L[@`NC7`OJc0>BZ0?K72P;f/`03
i:X000KT/bWfaakTZP3f/`3TZP3CQ002i:X01=>4000<^FL0`H@0/4`0PcP0
^FL0/5D0YT`0Pd40LRH08bH:;1804A`:0PT92P8A70X011X92Q4L2PTB2Q4L
2P892@X00`TB2PT92PTB2P022@T:00HJ2@XJ4Q@92@XJ2@X/4P169PX4LRH0
00Y69PYb9P1b9P23;`1b>1Ab9P1b>1Ab9P1G701P;a@2H2l:00I69QA69PXm
70XS70YP@AAZEAh2WW/c0X=k<`08AUDYH44D2A`D?A8:WUhDUED02A8:dn?e
HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT07iVIV@0Do_oZo_odo?coo?gog>?]`]2oV[QhU/9QW==LX]eW
Z>B2/>NF]nZW`_2_boJ^c_NYeob^fOb/f_b_g?ja0]go]@;Oo[P2h?nk0n7o
^C?QokL8h?ng01WQokSRokWRokWRokWQokSPokOOokKMokGCo:k?o:_8n:C1
lI^lkIBgj8f_h8NXeH2PbgbC^gFK^X70fJoEj<cfoo;goo_kooonool01iVI
V@@000000iVIV@0000000005VIVI0P0000:IVIT2000000BIVIT00000002I
VIT2000029VIV@8000000iVIV@0000000003VIVI0P00056IVIT00oooolc<
c<c<c01Mc<c<00</71@S70XS70X00R<L2P<A70X00b<L2R`B02<L2P028a`:
0R`B00056PT:8a`:6PT:;1806PT:008/4P0030T92R<L2R<L2R<L2R`B01X9
2Q4L2R`B01X92R`B02<L2QX92P8/4P001B`V51X92R`B02`B01X92P028a`:
00`/4P0A70XS;ahdEBT0000J2@XA70X92A@A70XA9Q@A70XJ2@X22A8:02TJ
9Q@dECdS@CfEZZg1albE/lbVZZ>`/kNEXKNEZZf`/kN`_/71alcChoD0000A
9PYkSHAZLUbVZZ<0000971@94PXA70XA9Q@A70X92@XJ9QBEZZddECdmGSdA
70Xm;cfEV:>V/l63V8k1albV/l6EXHh0002EV:>VZZd00ZJQV0:EQ7/02LZn
[McSh?K]j^C@c=cSe/77c=cSh=?Ie/[@eP03`LO<00b`_/5ZNflA9PY6C3g:
d=JV/l6EXKLS;bTA9Q@J71hA70XJ9Q@28blN00dA9QA6GTLmGSfEXHk]m_G:
d=KCfMK]m_G:d=JEZZgCfMK:d<7]kNX00ngfm@06dn?ekOKekNgZYZ6HYYR4
UJZ]1>gfm@Cfool01l77c=cSe_K77_Jc0>BZ0?Jc0>BZ0002m[<00^BZ0003
m[<0m/LNi:X000;TZP000m>40>BZ0=>40006dh@000>iI`2VC02iI`000[1E
0005YT`0PcP0?A`:8a`:6PT:008A70X00`T92QX92R<L2P022@T:00<94PX9
2@XA70X00PTB2P0=2@T:2A8:4A`:2@TD2A8:4A`:6Q8D8a`:Ea`0H2l:Ea`0
H2l:H2lD009b9P00778h578V078h58<_060_578V060_2ULL060_54HV2ULL
04HV2THV59ib5:J4DXf=DX=k<g:=?FYE7TIE:@TL51XB58eE2Yib2Q4V50TB
2P000=?SmF7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
1<c<c003IVIVc<c<VIVI01nIVIT06?oolooon_knoo_momgVhl3C]I:dJY?2
FYOAFIoKJJKQPj[SU[7TXK[YYL?^W/K`W<ofYloeZ<oeZ]3fZm;f/=?g/MCg
/mGh]0?Fm[D00mKf/mOf/mOf/`02eoJb<=Kg/P[Dn;805mGi/mCh/]Ch/]?g
/M7e[m3fZl_eXlOdWl3`V[WYUKGWT[;TSJ[LPj;ENI_<LhnjJ9BhL/7LYmOZ
b_?olO[ooocoookoo`05VIVI1@0000:IVIT200001IVIV@800002VIVI0P00
0004VIVI00000000VIVI0P0000RIVIT2000000>IVIT0000000000iVIV@80
001AVIVI00?oooo<c<c<c<`0GLc<c08S70X02QX92Q4L2QX92R<_:@T92R`L
52<L2R`B03@_<b`B008S70X031X92R`B01X92R`B02<L2R`B01X92R<L2PTB
2R`B02<L2R`B008J2@X00b`B014L2QX92P026PT:00@/4P0S70XJ2@X/4P02
6PT:00@S70XJ2@X/4P092@X24A`:00<J2@XJ9Q@A70X00Q4L2P0@6Q8D6RHD
6Q8D4A`:4BHD4A`:4BHN8blYEfMBAUi78d4m;4`YH79kY[?1UJ6gUJZ]0VYk
Q00:UJ6g`LO<kOKe00008blNUHB>JW]_UJZ]00004BH:0PTB2P0C2@TD2A8:
0000SIR>LXf4SHe_6RHD0000JW^4Y[?1dmWFPhB>/;k1`LO<;5hm6Q8D`LO<
/;k1Y/OP00;1al`00l[@eW^=Q79bN`02JW^400=PLW^3V;OChoD00ZK7h008
UK?<PiRgUK?<LXf]PiRgPiR]`LO<Y/OP0]?Sm@04H79k4BH:8blY4A`:0R`h
:@0GAUDY=2lY8a`:2@T:LW9kkOKedn?edmWFkOKe;5hmJW9L`LO1`LO<g>?P
kNgZkOKem_ookNgZdmWFkOKeg>?FUHAkUJ6>00?]m_D2m_oo0_ooo`05dn?e
kMW<kLMLm/LNm/L:00?f/`000nBZ0?Jc0?Jc0002i:X00_Jc00;TZP000oJc
0=>40>BZ0007dh@001:iI`31Q031Q031Q02`LP2VC01G700S9PXJ2@XA70XJ
2@XA70X92@X/4P0A70X94PX92@X94PX32@T:00PA70X92@X92@X92@X94PX9
2@XJ2@X/4P02ARH:00=P;`Yb>1Ab9P000g8V0004Pbl0H2l:LRH0LRH00V0_
2P0EARH:Ea`0?A`:ARHDLSPDWXdcPg/cJVLcWW8DJVLcAT4N;2HD6Q`NPcP0
WW8:H44D2A8:6Q8D6PT:0000kOKe067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01nIVIT06?oonokno_om
ooSkomgYfl3GZhF]EhRlCY7<E9SGIJ7MPjKNTjgPWKKTW;kZTL7/T<G_WLC_
X<C^X/C^Y<K^YlS`ZLWaZl[b[0C:kj`2bnjZ0l__ZC3:kjT7b?2Y1LK^Y`0D
a>bU`n^T`nbPa>jJ`NfD^nRC/n>?[N6>Zn6;Y=]nWMEdUl]WQkIFQjiK_]bL
g>g9logbo?ooo_goooko19VIV@@00004VIVI0P0000:IVIT2000000>IVIT0
000000000YVIV@80000019VIV@00000009VIV@800006VIVI0`0000:IVIT2
00000iVIV@80001AVIVI00?oooo<c<c<c<`0GLc<c0<S70X00aX92R`B02`B
00058a`:0QX92P8S70X00b`B01X92R<L2P028a`:00<A70X/4P0A70X00R`B
00038a`:;1806PT:008/4P001QX92R<L2R`B01XB52`B01XB508J2@X01b<L
2QX92R`B02<L2PTB2R`B01X92P024A`:01lJ71h92@XA70XJ4Q@J9Q@A9PXA
9Q@/71@S;bUPGS<dECdS;bTS;ah0000971C:d=J3Q8i6EE8/C2T/>2U6GTNV
/l7:d=K:d<400016C3fEV:>3V:fEXHh000094PX00PT9500B4A`:2@T:6Q8D
/;>gCfMLAUi78blN6Q`NLW9kY/OPb]3F/;k1UIRSg>?P0000UIRS/;k1Y[?1
0/[@eP0:`LO<kOKe4Blm4Blc2BHY6Q`N;5E_Cg9kdn?em_oo0ZK7h0:E/l`0
0iFQ]iFcc:K7h002UK?<0ZK7h005dn?ePhB>?Ehm;2HD=2lN008/>2T03TIE
DZJQV:JQV9FHXjK7h<[@e]cSh5N=SQ4V2Q4L2[2c]k2n`McSh=?Sm@?]m_D0
4]cSh=?SmOoool[@`IF4Nl[@e_KoongfmM?SmOKool[@e/77c?KoooJc0?o@
0>fn?OK72^BZ00;f/`001NBZ0?Jc0>BZ0>BZ0=>40002i:X000Of/`3TZP3C
Q03TZP3CQ03TZP3CQ0000^BZ00;CQ0002^BZ0=>40=>40=>40<640;1E0:I<
06Y12SdL2R<L2P8J2@X02PT92Q4L2QX92QXB50T92Q4L2PTB2QX92PT92Q4L
2P892@X01a4L2PTB2PT92PT92Q4L2QX92SdB2P02Pbl0178V000:Pbl0LSPD
Pbl0H2l:LRH0ARH:H2l:?A8:;180LSP00Yj=<`0@Pg/cWXdYJVLcAUDY8blY
6Q8DPbl0YVL0H44D6RHD2A8:2@TD4A`:2@T:0000dn?eHLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT07iVI
V@0Hoogooocooogom_[khNoF`MbUN:=7O;90R<Q>T==RVmZ1XM^?Z=bD/N2B
^^J7_^R6_NVB_>VH_>RI_NVJ_nVM`>ZN`N^Q`^bT1<C/Y@;6k:<00lK/XLC]
XLC/X`0^a>bS2L?]X`;1jj405l;/X/7[XL7[XL3ZX;kXW[kYV[oWTKcWS[OS
SZkMS:WMRZKNQIgIMiGCJ93:FWbaAGNSA;cLTn7cboGml_oloookooono`04
VIVI0P0000NIVIT400000YVIV@800002VIVI0P000004VIVI00000000VIVI
0P0000RIVIT2000000>IVIT0000000000iVIV@80001AVIVI00?oooo<c<c<
c<`0GLc<c0058a`:;1`D8a`:8a`:4A`:008S70X2;1`D0b<L2P0_;1806PT:
4A`:8a`:;1806PT:8a`:;1806PT:;1806PT:4A`:6PT:;1808bH:;1806PT:
4A`:8a`:;2HD2@T:6PT:8a`:;1806PT:;1802@T:6PT:8a`:6PT:8a`:6PT:
4A`:6PT:4A`:;1804A`:2@T:8blY=5DY2@T:6Q8D=5DY?Ehm6Q`N4BH:6Q`N
008S;bT08S@_<h>HS/77c8=kG14V2TIEDX>4S/77c=?SmG^=Q14V2TmWG:JZ
Xk2n`FZ=G000014V2PTL51XB50TB2P0009FQSR<_:H>=Q4IE:DI<?B`h:L77
c<[@eX>4SZJc`L77c8fHSP0000?1al`03<[@eZK7h=cSh=?IePU1Ab=1?A4_
<b<_<dIEDSAWNjK7h?Koo`>Van001YFcc:K7h9Fcc:Jc`JK7h9FQ]`:Van03
dn?e010dIg]ZLUb3Q8ibLW]PGS=bSHBEZZfVZZ?1alc:d=K1al6=V8i6EBT0
002=V8j`_/44g>?P0ngfm@?]kNX028>4NoKoooKoongfmOKooiFHXjJZ[NBc
A`;f/`000oK7?OJc0?Jc0006m[<000?TZP3fa`[f/`002>BZ000Cm[<0diP:
i:X0dh@0i:X0dh@0diP:dh@0`H@0/5D0LSP0ARl:8a`:4A`:6PT:4A`:2A8:
4A`:6PT:00892@X01@TB2P0000T92QXL7PTB2P022@T:00T94PXA70X94PX9
2@YP;aB3;`1b9P1b>1AP;`X00W8V000<LSPDLRH0LRH0LRH0LSPDARHDH2l:
ARHDNd`:/8@YbZ4mSHe70X=k<`0?H44Y;4`Y6Q8DPbl0/7/DUEDD2A`D2@TD
2@T:2A8:6PT:2A8:8a`:0000kOKe067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01nIVIT06?olooojooom
ooKkmnSgf/SVZW2M?W>/>H31BHW=G9GFNYcGQj7ERZ_HQkCNO;KPN[KSR;CT
S[GUSkOWTk[WU;[WU[[VUk[VV@>liYX00kcWV;gVV;gVU`03_NJG03nliiNl
iiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRl
iiNliiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRliiNl
iiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRl
iiNliiRkj9NkiiRkj9NkiiRkj9NkiiRkj9NkiiRljIRlj9VljIRkiiRjiiJi
iIJii9800[SPRP0?/Mb:Z]Z6XmV1WMUiUMA[S<aJPl=;LZ/hKidj`N>IjO_C
m__doo_oooSooogo00BIVIT200000iVIV@80000?VIVI0P000003VIVI0000
000000BIVIT200000YVIV@8000000iVIV@0000000002VIVI0P0005:IVIT0
0oooolc<c<c<c01Mc<c<00<J9Q@/71@m70X00R<L2P096PT:8a`:8a`:;180
8a`:?A8:8a`:;1808a`:008/4P0011X92R<L2R`B014L2P8/4P001PT92R`B
02`B02<L2R`B02<L2P8/4P001aX92R<L2R<L2R`B01X92R`B014L2P026PT:
01dA70X/4P0J2@XS70X/4P0J2@XA70XJ2@XA70XJ2@X94PXJ71hJ9Q@J4Q@A
9Q@J4Q@J9Q@92A@971@A9PX/>2TS;ahA9Q@971C1al5kSFHS;aj3SHBEV:<0
0/[@eP8A9PX018>4S[2n`L77c1XV50894PX04`T951X92PT92R=1?HfHSTmN
IVZ=G2=1?DI<?FYkQ>gfmH>4S[2n`IFZ[JJZXaXV56YkKl[@e/77c002b]3F
00g1alcLhn2EXKLAC58/C2TS;c<S;bTS@E8m;cfVan3foooChoFE/l`00ZK7
h006UK?<Y/OPY/OPUJ6gPiRgUK?<0jK7h009dn?e4DaBLXf]`LO<Y/OPEhf>
;5hmJW9L/;k100;CfMH04/[@e[2c]g^=Q14V2R<_7ZJQV<[@e]cSe]cSh>g]
j]?SmNgfmOKool[@e^g]j]?SmMcSh:J4Q0;oool01?Kooh>=Q=cSh?nc00;f
/`001?o@?OK72^Bc:NBZ00;f/`001OK72^BZ0>BZ0=>40?K72P02i:X00_Jc
00;TZP001OJc0>BZ0>BZ0>BZ0?Jc0004i:X00]>40005`H@0/780Pd40Ea`0
8bH:00<J2@X01Q4L2QX92QX92Q4L2PT92PTB2P8A70X22@T:00T92A@A70X9
2@X92A@m4PZ3;`1b9P23;`1b9P000W8h509b9P000f0_2X<_060_2P02H2l:
00EG701P;`ZEEAB`SE:ESE800X=k<`0=PehD;2HD6RHDPbl0/5D0PehD4BH:
2@T:2A8:6Q8D4A`:6PT:6Q8D008S70X00aX92^gfmLc<c01Pc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0O
VIVI01SonooonOoooOohoOO`onGBkkE^Vd1_ZCUb]Sem`dn;cF^CcgVIcWbS
d7^^eWJbfWN_g7f`gh>chXJehhVfi8bfhhjfhXfdghd3]Mn=0[GOR`03]Mn9
]mn9]Mn900:eghT0?[GORkGORKGORkGORKGORkGORKGORkGORKGORkGORKGO
RkGORKGORkGORKGORkGORKGORkGORKGORkGORKGORkGORKGORkGORKGORkGO
RKGORkGORKGORkGORKGORkGORKGORkGORKGORkGORKGORkGORKGORkGORKGO
RkGORKGORkGORKGORkCPRKCPRkCPRKCPRkCPRKCPRkCPRKCPRkCPRKGQS;KR
RkKRSKKRRkGQS;CPRK?OR[?MR@:behL03j_FQ:CDOYgDMYKCJhW<FGo3BWBd
>V^U=76N?lg^ZO?oh?Oim?ojoooiooomo`05VIVI1@00012IVIT2000000>I
VIT0000000001IVIV@@00002VIVI1@0005>IVIT00oooolc<c<c<c01Mc<c<
00Dm70XS9PXS9PXm70XS70X00R`B00036PT:?A`:6PT:008/4P006R<L2R`B
02<L2QX92R<L2QX92R<L2R`B01X92R<L2PTB2R`B02<L2R`B02<L2R`B02<L
2QX92R`B01X92R`B01X92R`B01X92R`B01X92P8/4P0022<L2QX92QX92QX9
2R`B014L2PTB2PT92P8A70X01A4V2Q4L2PTB2Q4V50TB2P024A`:010J2@XA
9QhJ71hA70X92@X/>2V=V8hA70X/GSfVZZfEXKOfool/C2TA9PY6C3f=V8h2
`LO<01@A9PX971@A70XA9Q@92@X971BVV8APLW^3V8i6GTL/9QA?GVIZNhC]
m_FVZZf3V:g1al4S;ah00031al`3b]3F00jVan3:d=Kfm_EGSHhA;c<S@CdA
;cdm;cdS@E8/EEb3V;OChoGfoonE/l`5Y/OP01NE/labSJfE/lbE/lbVan3C
hoFVan0J71jE/lcChoFE/l`971@99RTd;c>`_/71alc:d=K1alcCfMK1al56
EBT94PXS;ah00/[@eP03g>?Pdn?ekNgZ00?]m_D2dmWF013]m_GLhmJ`/kOf
oonVan2=V8iZNfood3fEQ5:EQ7^=SFnEQ7_:d=Kf/`3fa`[TZP03m[<000CC
Q03faakf/`3TZP04m[<000Ofa`[TZP3f/`3TZP3f/`3TZP3f/`000nBZ00;C
Q0001;UW08<_04HV2R`B008A70X010T92Q4L2QX92R`B008A70X42@T:00D9
4PXA70X92@X92@Xm4PX00g8V0005Pbl0LRH0LRH0LRH0H2l:00=b9P006dHV
560_2THV59iN59j=<iF4DX=k<fYE7X=N56YE7R<_7THV2[1E08=N52`V5000
00T92QX92PT9514L2QX92QXB52`B02<L2SdL2P000=?Sm@1Qc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0O
VIVI01Soo?onnOoooOoio_[gonoImLA`Vd]`YcmXZCEd^DB3aUf<bFZDbW:P
cWJ]e7Vaf7^/eg^^fh2agHBehHRfhXfdh8^cgH^afhT2]]f>0[KMS0:fgHX0
0kOMR[KMR[KMRP0^]]f:2kCNRP0G]Mn;]=j:]=j:/mf9/M^7/M^9[=26[M67
Ym:2X=5fV=5ZSlmMP/I=Mk]0JZTdJJ4fMJ5<f?Jjn?oZmoWdoo[oooWooogo
08:IVIT00oooolc<c<c<c01Mc<c<01<S9PX/71@S70X/71@/4P0S70XA70Xm
4PX/4P0S9PXS70X/71@S70XA70X/4P0J9Q@S70X/4P0J2@X00R<L2P03;180
6PT:8bH:008/4P028a`:00L/4P0S70X/4P0J2@X/4P0S70X/4P000R<L2P04
4A`:6PT:6Q8D6PT:0R`B00046PT:6Q8D;1802A8:0Q4L2P8J2@X06A4L2QXB
50T951XB514V50T951XV50TL51XV50T9500004mNIW9EDR`V58>4S[2c]l77
c<[@eP0001XV54mNIYFZ[L77c:JZX`0000022A`D01X0000S;c>VZZ=?IdNV
ZZe6GTLS;ah/C2VEV:>`_/71alb3V8j=V8j=SFl00016C3gChoG1alcLhn3:
d=K1al7CfMKfooldIg/S@Cd99RT28blc00LS@CdS@E9bSJgChoGfoooChoFE
/l`00jK7h00Tb]3FUK?<LXf]PiRgUK?<dn?eY/OP=6Mk;5ELY/OPm_ooY/OP
4DaB8d4m2A8:LW9k`LO</;k1g>?P`LO<g>?PUJ6>2A`N0000YZZ]b]3FdmWF
g>?Pdn?ekOKem_ookNgZg>?PdmWFb]31oooo0ZJZX`0=AVMLH5hcH44YUHAk
SHe_UJ6>WXAVJVLc`LO<ok<0m/Lmi:X0m/L:00;f/`02i:X00_Jc0003i;<N
m/L:m/L:00?f/`001oK72_Jc0?Jc0>BZ0?Jc0>BZ0?Jc0002i:X000gCQ031
Q02EE@16;`Xm70X/4P0A70XJ2@X92@XA9PXJ2@XS9PX94PX00`T92P064A`:
00002A8:2@T:6PT:H2lD0W8V0003LSPDLRH0LRH000=b9P001H<_060_2THV
2W8h07]<2P02WXdc012NNc>3Nc>3GQAZEAh/C2TJ4QAG702NGQ@A9PX92@X9
2A@J2@X92@XA9QhS70XJ2@X2;18000DS9PX/71@S70X/4P3]m_D0HLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bI
VIT07iVIV@0Fookkm_;aookoo?oon?ohg_KDYl^;FH``Hj4dJZdiNKa;SlaT
Rl5SX<id_>B>]=Z7^N2?]=j<]]n@_^NH`nVN_nFJ0[_QV0;0i9h2`>BL1L;T
VS30i9X7_nFJ00?0iY^oiI[0iY/00/3VV`0D_N>H^=jC]=VC^MbL`>FRXlin
YmUhW=IVO[i4O/12HJ<XEI0THiHjU;]hl_oOlooYn__foo_oooKoookoPYVI
V@03ooooc<c<c<c<05g<c<`48a`:01</4P0S70XS70X/4P0/9Q@/4P0S70X/
4P0S70X/4P0S70X/4P0S70XJ2@X/4P0S70XJ2@X/4P094PX00b<L2P0:?A8:
;1808bH:;1808a`:;1808a`:;1808a`:;1800QX92P088a`:;180;1808a`:
6PT:8a`:;1808a`:0PT92P046PT:4A`:2@T:6PT:0Q4L2P0g6Q8D4BHD6Q8D
2A8:6Q8D2A`D4BHD2@T:;4`YAT`mAUEBUIRS`LO<dn?e?Ehm4BH:8blNJW]_
/;k1`LO<LXdm00002A`D6Q8D2A8:JW9LNheVEfMBUJZ]NheVAUDYJW9Lb]3F
`LO<YZZ]Nhf4YZZS4BH:2BHY/;>g`LO<b]3FdmWF/;>gb]3Fg>?Pdn?e;6ML
8d4m?Blm4Blc8blc8d4m?BlmCg9k00;ChoD00oKooiFcc:K7h003Y/OP016E
/labSJf3V;NV/l7ChoEbSJdA9QiGGVnVan3ChoFVan0dIg/mLX@A9QhdEBV`
/kO:d=H00/77c0;:d=H01F1N<a4V2UMWD/[@e]?IeP02g>?P0^gfm@0<kNgZ
`LO<g>?Pg>?PdmWFm_oei=3<SHe7H5hcJVLcWXAVUIQV0[2ZQ005JW9LdmWF
m[<0m/LNm/L:00?f/`001m>H2_K77_Jc0>Bc7_K72_K77_K7?@03m/L:00?f
/`3fa`[f/`000oJc00?TZP02dh@000>EE@1G700m70X00Q4L2P076Q8D2A8:
6PT:;180;2HD6Q8D4A`:00<92@X01Q4L2PT92PT92R`B060_2X<_00=b9P00
278h578V078V078h560_2V0_58<_0;2=<`:NSC<2Pg/c00eZ@@Y6@AhJ4Q@m
70Z3@@1Z@@X0000J4Q@94PXA70X92@XS70X/4P0012<L2P05;1`DARHD8a`:
;180dn?e067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
1<c<c003IVIVc<c<VIVI01nIVIT06?oom_oon_onoo_loo?lmo?okkWFYUEo
=Df38eVD:6VW>7NbA[G[RKk/U;?JRm;f[<W]YLCYXl?XXlS]Z<c_[lW/[<SZ
[LW[[P;:jJh2b^V]00?;jJg;jJ_;jJ/00/_YZc3:jZ/7b>^[00?9k:c8jj_9
k:`00/[][@0DbNb/aNRX`nFX]]NNb^j^`NbL]nV6ULiKLJlbKjldI:<`HILi
FhHn]MFTjooSnoofo_gkoo_noocoookoPYVIV@03ooooc<c<c<c<05g<c<`0
12<L2R<V2SdL2SdL2P<S70X010T92R`B02<L2SdL2P<S70X01R`B02<L2QXL
7R<L2R`B02<V2P8S70X01`T92R`B02<L2R`B02<V2QX92R`B00028a`:00l/
4P092@XS70X/4P0S70XJ2@XS70X/4P0J2@X/71@A70X/4P0J2@X/4P0S70X0
0Q4L2P042@T:4A`:4A`:6PT:0Q4L2P042A8:6Q8D2A8:4A`:0PTB2P0>6Q8D
2@T:?EhmAT`mNhf4UJ6gb]3FPiR>4BH:4BHN=5DYJW^4b]3F/;>g0Q4V2P89
4PX07b`h:FYkKc@_<k2c]g^=Q4INAeN=G9FZ[L[@e/77`H>4SYFZ[Ba<:@00
0;2c]jJZ[L77c<[@e[2n`JJc`M?Ie]?SmL[@eQ4_?B=1?A4_<b<_:A4_<b=1
DRaEG5MNK`02dn?e00?foonVan2Van001:K7h00HLXf]PiRg/;k1dn?e;5E_
;3PYLXf]dn?em_ooUK?<LXf]PiRg2A`N4BHDLW9k/;>gg>?PdmWFY[?1g>?P
UJZ]CfM70000`LO10]?IeP0;g>?PkOKem_ookNgZ/;k1g>?Fm_Keb]3Fg>?P
m_oo`K>]00:ESE8029FQS/6cS/77`G:=?H=N<nC@c?Jc0?K72P?f/`000oo@
0>BZ0?K72P02m/L:00CofBWfaakfacgfa`X2m/Lm0_K72P06om00m/L:m/LN
m[<0i;<Nm[<00^BZ000<dh@0UED0H2l:ARH:6PT:8a`:2A8:4A`:6PT:;1`D
ARH:8bH:0Q4L2P072A8:4A`:2@T:2A8:4A`:;180LSPD00Eb9P00260_560_
2V0_2W8V09ib5;2=<iF4DX=k<`9ZEAh024I17R<_7R<L2V0_2VY12PTB2PT9
2PTB2P<J2@X022<L2QX92R`B02`L52<L2SdL2R<L2R`V508m70X00b`B0>gf
mLc<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@0OVIVI01CnonooooKoooogn?cho?ohoo[PmMJ>[gQP
SCa:OQa[XSYk/TZGbfW2l9Rcg92kh9_<k[78jK35iZo7j;42b^Rf00?;j;S=
j[c;i[T00/_V^@04bnNgc>Jgc>Jgc>Jf<<_W]PW:j;H3bNNe01K:j;K<j[S<
j[S:j;K6i[CCm/2khZ>_fXZijhR`iWB4_TIMURE:PAa?Nc23Z7CXon?eooCk
oo[ooogooO_onoWooof2VIVI00?oooo<c<c<c<`0GLc<c004ARHD;1`D8a`:
=2lN0R`B00038a`:4A`:8a`:008S70X2?A8:00`S9PX/71@/4P0J4Q@/4P0S
70XJ2@XS70XJ2@X/4P0S70Xm70X38a`:00L/4P0J4Q@/4P0S70X/71@/4P0/
71@00R`B008J2@X012`B01X92R<L2R`B00<S70X011X92Q4L2PT9514L2P89
2@X05A4L2QX92Q4L2QX92QXB50T92QXB50TB2Q4L2PTB2UMWDX>4SZJc`L[@
eVYbG4mWAdIE:DI17TIE:K2c]ng]jP024BH:00P94PX971@0002`/kLJ2@YZ
Nfo1alakSH@2LW9k00W1alb`/kNV/l6EZZd/C2T0001?GVKCfMJV/l400/[@
eP0@UJ6g`LO<g>?Pdn?eY[?1;5hm8d4m?Blm8blc?Blm;5EL?BlmH79kY/OP
dn?em_oo0jK7h005`LO<Y/OPY[?1LXf]PiRg00:Van028d4m00]bLW_ChoGf
oonE/lbVan0dIg/S;bTJ4QA6C3ePLW_Lhn001<[@eP06UJ6>0000JW]_`LO<
b]3Fg>?P0^gfm@09m_oo/;>g`LO1oooo/;k1b[j]kNgZooooAT4N00;1/hh0
1iFQS[2ZQ61N<h=kG?K]j_Jc0?oI:@02m[<000kfa`[faakTZP3faakfacg]
_SgffFKfaakffFKofBWofCgffFKofBWofCd3m/L:00?f/`3fa`[fa`X00^BZ
0006dh@0/780H2l:ARl:8a`:4A`:0QX92P074A`:?A8:JT4:8blN6RHD6PT:
6Q8D00894PX011XB51X92R`L58<_00Ab9P001W8h55LL060_5:Ib5;2=<kV=
<`:3Nc<03fYE7V1152<V2QXB54HV560_2R<V2PT92QXB50T92QX92Q4L2QX9
2R<L2SdL2P058a`:00I69Q@m4PY69PY69PX/4P3]m_EQc<c<00AVIVJ8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0OVIVI
01Skoo3joO;ooogoo_oloOolooohooCSnM=TQTU5L21<OB5_Xd6:^enfiY2c
gI7?m[?9k;;7j[C6jK?6j;G7ikK8j;W8ik_9j;`2bnRl00?;ikk;j;c<ik`0
0/cW^P1Bc>Rhc>NjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRh
bnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRj
bnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRh
bnRjbnRhbnRjbnRhbnRjbnRhbnRjbNVhbNVjbNVhbNVjbNVhbNVjbNVhbNVj
b>RganNhb>Rgb^Zkb^Zib^ZkanVf]]bS`NZVaO:QY]EgP[E<K:0dDH4N@VdK
NiiTeO7;m?ofnOomm?Keo_gkookjoo[dooomPYVIV@03ooooc<c<c<c<05g<
c<`022`L52`V52`B02<V2R`L52<L2QX92R`B008m70X01B<V2R<L2R<L2R`B
02<L2P02;180014S70X/4P0J2@XS70XS9PX92@XJ4Q@S70X/4P0m4PX/4P0S
70X/4P0S70XJ2@X/4P0S70X00R`B00048a`:;1808a`:;1800b<L2P076PT:
;1808a`:;1806PT:4A`:2@T:00<A70X00`TB2QXB50T92P024A`:02492@XJ
2@XA70X971A?GVJ`/kO:d<5bSH@/>2UZLUa6EBUZNfm?IdNVan31al`0000A
9PX971@J4QAGIe9?IeakSHBVZZ=PLW]?LW^`/kN`_/7:d=JVZZf=V8j=SFl9
4PX000000/[@eP;1al`02;2n`L77c<77c=?Ie^gfmH>H]cebQ2=1DP8S@Cd0
13d_?B=1?BaEG6YkQ0:Van02m_oo01JE/lbVan2Van2Van2E/labSJf3V;NV
/l6E/l`S;c<m;cf3V;OChoGfoon3V;OfooldIg//EFlA9Q@d;c=6C3f`_/42
dmWF00F`/kO]m_G:d=HA9PXJ71h00/77c00Mg>?PkOKekOKem_oob]3FLW9k
kNgZg>?F/;k1YZZ]g>?Pb]31`LO1NheVJVLcAT`mH2lDi<O1ong<m[<0m/LN
om00m[<0m/L:m[<0i:X0m]UVon>>onf>00;ohh@3m]UV00WofCgffFKofCgf
a`[]_Sgfa`[f/`3faakf/`000nBZ000=`H@0LRH0ARH:8a`:6PT:4A`:6PT:
4A`:;180Nd`:ARl:=2lN8bH:00892A@01@TB2QXB50T92R`B078h5002LRH0
019P;`YP;aAP;aB3@@2`Q2VNSC>NSBV3Nc>3GQAZ@@YZEAhA9QA69QAP;`XS
9PX92@XJ4Q@92@X24A`:00DS70X/4P0S70X/71@S70X00SdL2P04ARHD?A`:
?A`:;2HD0THV2P03?A`:?A8:kOKe067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c09VIVH00lc<c9VIVIVIV@0MVIVI01SkooSh
oOKnoogooooln_ogmOSloo[honoaomiVR4a<M2]OS3^B`VjFaGC2lJ>ScXJh
hInkhJBmhjJni:W0hj_0hjfohZbnh:d2`^:`00?2h[72h[34h[000/CR[P1?
`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/
`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^
`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/
`^>^`^>/`^>^`NB/`NB^`NB/`NB^`NB/`NB^`NB/`NB^`NB/`^F_`>>[_n:/
_n:Z`>>]`>>[_^6[^n6V]N2K[]bA]>B@YM=kO:U>EH0WCG<XIXQ;iooIm?oa
k_WanooooooooOcj00;oo_X00ooooIVIVIVIV@20VIVI00?oooo<c<c<c<`0
GLc<c0048bH:?A`:?A`:8a`:0R`B00048a`:;1808a`:;1800SdL2P038bH:
?A8:;180008S70X01QX92R<L2R<L2QX92R`B01XB508/4P004cdL2R<V2R<L
2R<V2R`B02<L2R`B02`L52`B01X92R<L2R`B02<L2R`B01XV51X92R`B01XB
52`B00028a`:00L/4P0S70XA70XA70X0000A70X92@X00PTB2P044A`:2@T:
2@T:4A`:0Q4V500F=2lYUIRSb]3FEhf>0000UJ6>NheVAUEBPiR>PhB>kNgZ
4BH:00002A`D0000=2lNUJ6>4BHDSIR>b]3FSIR>2A`D0[2n`@07`LO<UJZ]
SIR>;4`Y0000PhB>b]3F00?1al`02[2n`L77c<77c>gfmH>H]baEKbaEG3d_
?BaEG3d_?@8S@E8012=1?CAWNk2n`JK7h0;fool03JK7h9Fcc:K7h<77c9Fc
c8>H]iFQ]jK7h8>4SR<_<f1bNh>H]oKoo`02dn?e01jVan1bSJebSJdA;c<A
9QhdECf3Q8kCfMK:d=KCfMK1alcfoomZNfl0002VXIS1alcCfMKChoG]m_Gf
ooo]kNYZLUc1alc]kN[:d<6`/kOTd<c]m_G1al56;`X22A`D00EP@BWfooo]
aeco/`3facd01?K72P03m[<0on>>onf>00CokHh00ooSQ?oI?OKIIP02omTm
00?ofBWofCgfa`X00oK72P?TZP003l6406Y12ULL02<V2Q4L2Q4V2PT92QX9
2R<L2W]<2V11:DHV54H_2PTB2Q4L2P032@T:01Hm4PYb9P1P;`YP;`Xm4PYb
>02NLPZiQ2VNSC>NNc>3Nc>NSBV3GQ@J4Q@S70Y69PXS70XA70X92@XA70XJ
2@XA70X36PT:0R<L2P03;180?A`:ARHD00Hm70X2ARH:00</4P3ChoG<c<`0
H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00AV
IVK<c<aVIVK<c<`NVIVI00CioogkoognoogooOh2oocn01;noOWioo?hong[
omaPPDY=MS9DPSN4]FAhZEN/fh^Sch:YeHZ^fXn_fY:afYBbfiNafYJ^eiD2
/MRG00>af9Vaf9NceiL00[?HU@1B/mRC/MRE/MVC/MRE/MVC/MRE/MVC/MRE
/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC
/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE
/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/=VC/=VE/=VC
/=VE/=VC/=VE/=VC/MZF/=VC[mRD[mRB[mRD[]NA[=FAZ=>;XM:1U/QcSKeY
NjQEBW<U=U/EPZ5XiOkDmOo]looanoomm?Ggooooookoo?SeookkooomPYVI
V@03ooooc<c<c<c<05g<c<`00b<L2SdL2R`L50038a`:00H/4P0/71@/4P0S
70XS9PXm70X2;18000LS70X/4P0S70Xd;ah/4P0S70X/4P000Q4L2P0>;180
;1`D;1808bH:8a`:;1808bH:6PT:;1808a`:6PT:8a`:;1808a`:0QX92P8/
4P000b<L2R`B02<L2P02;18000<S70Xm4PXJ2@X00a4L2P042@TD6PT:2@TD
4BHD0Q4L2P0E6PT:2@T:AT`mYZZS`LO<2A`DAT4N;3PYUIRSNhf4JW]_PhB>
UJZ]UJ6>00004BHD2@TD2@T:UJ6>8blNAT`m00;:d=H03dIWG0TL5<77c;2c
]l77c8>4SYFQSP0004I<?K2n`M?IeZJc`L77c;2n`L77c003b]3F00b3Q8jV
ZZfVZZ>EQ8jNQ6JVLU:ELTM?GVHS@E9GGVnVan3ChoD2m_oo00cChoFE/lbV
an2Van2E/lb3V;NE/lbV/l5?LW/m;cebLW^3V;L3dn?e00N3V;NE/lbE/l`A
;c<dECdS;c=6@Ah00/[@eP08dmWF`LO<b]3F`LO<8blN=5DYYZ6H`LO<0ngf
m@0?m_ooPiR>SHe_kOKe/;>gb]3F/;>gg>?PkOKe`LO<ARl:UG97`LO1onf>
m]UV00;fa`X02_K7?OJc0?K72_K72_Jc0?oSS_o]c?KomOo]S_oSQ0;okHh0
2ooSQ?KII_KII_oI?OKII_oI?OoI:OK77_K72^Bc7_K72P02i:X000G1Q023
;`1P;a@S9PXJ2@X00Q4L2P0C6PT:8a`:Nd`D/8@YPehDH44D2A8:2@TD6PT:
6Q8D4A`:;180H2l:ARH:LRH0WUhDdj4YbZYVYZ5V00>NSBT01dH_2QX92R<V
2R<V2QX92Q4L2PTB2P046PT:00DS70X/4P0S70Y69Q@m4PX01SdL2P07ARH:
?A`:ARH:?A`:ARH:;180kOKe067<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c005IVIVc<c<VIVIIVIVc<c<01fIVIT06?GoooWo
ookooOkmnOonnoomnoomoOgln?7gkOOolO3oiW>HHUn<Ace^7EJ;<fbQAG^^
Ch>fEh^lH8bmHXfnHi31J971JhjnJ0:A_VT00i6nJi6nJI:nJ@02T[iW04fB
_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB
_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB
_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB
_VNB_VFB_VNA_fFA_fNA_fFA_fNA_fFA_fNA_fFA_fNA_fFB`6RA_fFA_fNB
`6JC`FVA_fF=^f>8^Eim/e=i[e5?PBXoJaiCNSVB/7cUo]Oeonc[m^K_m^kn
ooggmoT00oono`03oognooooVIVI086IVIT00oooolc<c<c<c01Mc<c<00Lm
70X/71@/4P0/71@m70XS70Xm70X00R<L2P03?A`:8bH:;180008m70X02b<L
2R`B02<L2R`B02<L2QX92R<V2R`B01X92R`V52`B0002?A`:00X/4P0S70X/
4P0/4P0S9PY69PXS9PX/4P0S70X/4P028a`:00`J2@XS70X/4P0d;ah/4P0J
2@XS70XJ2@XS70XS9PXJ2@X94PX34A`:00<J2@XA9Q@J2@X00Q4L2P0=0000
SIR>YZZ]0000EfMBYZZSJW]_YZZSJW]_UIRSUJ6>dn?e0000008971@05000
0:JHQ2<_:A4L2X>4S/77c=cSh14V2UN=G9FHXk2c]iFZ[JJZXceN?@000;2n
`IFHXmcSh9FQ]l77c0:`_/403L[@e]cSh:JZXjJZXjJHQ:J4Q9F4Nij4IX=k
G9EbAg9EDRaEG8>H]`02Y/OP0]?Sm@0Gm_ooY/OPY/OPY/OPUK?<PiRgUJ6g
Y[?1AUEBCfMLLW9kUJ6gdn?em_ooUK?<PiRgdn?eY/OP4BlcCg9k8d4m6RHD
LW9k00;:d=H01McSh;2c]ooooiFQ]a4V2P02UIRS01O]m_GChoGfooofooo1
alaZLUcCfMK:d<7:d=K]m_F`_/6V/l71alc]kN[fooookHkfd8CffFKf/`3]
_SgofCgfa`[ofBT00_K72P03on>>onf>onf>00;okHh3on>400WffFKohhCo
fCgffFKofCgfaakfacgfa`[facd00nBZ0003diP:Nd40LSP0008S70X02AX9
2PT92Q4L2R<L2V0_2[24:Iik<heE2Q4V50024A`:00l92@XA70XS70Xm70YG
702iSABNSBViZVn=SDNNLQB3Nc=6@Ah/71@J2@XS9PX00PT92P034A`:6PT:
4A`:008J2@X022<L2R`B01X92Q4L2SdL2R<V2THV2THV50<m70X00dHV2R`L
54HV2P04ARH:00</4P3ChoG<c<`0H<c<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P4c<c<00IVIVK<c<bIVIVIVIUVIVK<c<`LVIVI01Se
ooohooolo__ooo[oo_SomoGnmOKoo_onoogeooG_on[[omoXom;>ok9TVCm<
Q24mM0i6OQ=?Pai@Q1mAQB5FRRIHRbaFRBX4FH//0U^::S9KRbP8FH/X00=H
RRMIRbQJS2T00Ub>:`0AFX`YEXPUDXHR>g8<AgdKIiU2boN/kOoFi_oGm?oZ
mooanooho?okl?3^oooooogonoWl00;oo_l00ooooiVIVIVIV@20VIVI00?o
ooo<c<c<c<`0GLc<c00A;2HD;1`D;1804A`:?A`:;1`D8a`:;180?A`:?A8:
8bH:?A`:8a`:?A`:?A8:;1808a`:008/4P003B<L2QX92R`B01X92R`B02<L
2R`B03dL2R<L2SdL2R<V2R`B02<L2P02;18000</71@/4P0/4P000b`B0004
?A8:8a`:;1808a`:0b`B00048a`:;1804A`:6Q`N0PT92P0W4A`:2A8:6PT:
4A`:6Q8D4A`:0000`LO1AT4N4A`:`LO1SIR>Phf4SIR>LW9kUJZ]`LO1SIR>
00006Q8D2@TD8blNEheLEfMBJW]_UJ6gb]3F/;>g2A`DPiR>SIR>/;k1Nhf4
SIR>0000LUEBJW^4UJ6gb]3F00:`_/401JJc`L77c<[@e[2n`Mbn]`02b[j]
00R`ZXB`Q7^NQ6J`NfJNQ6JELTM6C3eZNh@2Y/OP013ChoGfooofoooChoF3
V;NVan2V/l63V;NEXKNE/la?GVIPLW^EV:>`_/7ChoGfool2PiRg01?ChoG:
d=H9@DN3Q8j3V;L94PYGEE9ZNhC1alcCfMKLhn3:d=K]m_DdEBU6EBW1alb`
_/7:d=K]m_D00_Koo`03UIRSdmWFdn?e00;]m_D01]cSe^gIc>g@V?oSS^fn
?OK7?@;ffFH01Oo@0?Jc0?K7?OK72^fn?@02m/L:00CohhkokLcokHkohh@2
onf>0_oSQ007m]UVon>4omTmomTmm]UVomTmm/LN00;fa`X02oJc0>BZ0=>4
0=>H2X<h06Y12R<V2R`L51X92QXB50T95002;18000k:ZTNNSC>`Q2T94PXJ
2@X92@XA70XJ2@X92@Z=E@ZVXFJNSBV3Nc=ZEAh2AT4N00@A9QhJ2@XA9PXJ
2@X22@T:00@A70X92@XS70XJ2@X28a`:00@/4P0/71@/4P0S70X4?A`:00=6
9PXm70Xm70X00SdL2P03ARH:?A8:?A`:00969PX00b`B0>gfmLc<c01Pc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<
c9VIV@02VIVI00=VIVK<c<c<c<`0olc<c0k<c<`00oooolc<c<c<c01Mc<c<
02A69Q@/71@m70X/4P0/71@/9Q@/4P0S70X/4P0S70Xm70X/4P0m70XS70X/
71@/4P0S70XJ2@X/4P0m4PX/4P0S70XA70XS70X/4P0/9Q@m70X/4P0S70X/
4P0S70X/4P0A9PX/4P0m70X/4P038a`:00PJ2@XS70Xm70XS70X/4P0S70XJ
2@XS70X26PT:00LS70XA70XA70X92@XA70XJ2@X94PX00PT950062A8:;3PY
=5DY4BHDYZZS`LO<0W^=Q00KCeiVYZ6H/;>gEheL00004BHD00008blNPhAk
AT4N8blNPiR>/;k1b]3FNhf44BHD=5DmYZZSUJ6>`LO14BH:0000/;>gAUEB
g>?P/;k1`LO<00:`_/402<77c<77`Mbc[L77c>C7`Mbn]l[@`JJ4Q0:`Q7/0
1ZJ4Q:JQV;24NcAWNiFcc:K7h0;ChoD2m_oo00[ChoFE/lbE/lb3V:fEXKNV
/l5?LW]bEE:3V:fVan02m_oo00EbSJfE/lcChoFVan0/EE`00ZK7h00?0000
UIRSLW9kUJ6gdn?ekNgZUIRSooooYZZ]=5DY/;>g`LO<Y[?1dn?ekOKe00Cf
ool03^gfmNg@V?K72_K7?OKII_K77_oI:OK7?OK@Q?oSQ?K72_K77_KII_o@
00;ofBT01Oo@0?KII_o]c?o]c?oSQ003onf>00GohhCffFKffFKofCgffFH0
0_oI?@04m/Lmm/LNm/L:i;<N0nBZ0003SED:LRH0ARl:008A70X021X92Q4L
2R<L2QX92[1k:LZQD[2=<b<_7P8A70X030T92PTB2QX92Yj=<fYW<dI17S@_
7Q4V50TB2P00014L2QXB50<94PX02a4L2PT92R<L2QXB52`B02<L2R`B02<L
2R<V2SdL2R<L2P04?A`:00@S9PXm70Xm70Xm70X6ARH:00<m4P[ChoG<c<`0
H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT00iVIVOmVIVH@IVIV00?oooo<c<c<c<`0GLc<c0@S70X01b`B
04I<?CdL2SdL2R<L2R`B04HV2P028a`:00@m70X/4P0S9PX/4P038a`:00LS
9PXJ2@XS70XS70Xm4PX/4P0S9PX012<L2P05;1808a`:?A8:8bH:8a`:008/
4P000b<L2R`B02<V2P02?A`:03HJ2@XS9PX/4P0S70X/4P0A70XJ2@Xd;ahJ
4Q@A70XA9Q@92@XJ4Q@A9Q@J4Q@0002`ZX@94PXmGSfEZZebLW/mGSf=SFn3
V:fV/l6EXHh0000A9Q@94PXS;c=ZNfl00031al4J71iZLUc1alc:d=I6EBT0
001ZLUbVZZebSHBVXIP00016C3e6EBW1alc:d=IkSHC:d=J`_/71alc1/jgL
_[L2i=3<0]cSeP03g;jg`J64YZ6H00:VV8@2`J6400BVQ8BE/lbVan3ChoD2
m_oo0m?Sm@:3V;L06iFQ]jJc`G9EDW9bNiFQ]m?SmOKoom?SmG:=[H>H]m?S
mIFQ]eMNKm?SmIFcc0TL7R=1?L77`G9ED/77c<[@e^gfmIFQ]oKooiF4SVYb
G=?IeP02b]3F01C]m_GChoG]m_Gfm_G]d9SffFKfa`[ofBWfacgofBWfa`[f
/`3]_SgokHkohhCfa`[ofBWfacgfa`[]_Sd2m/LN00?]aecokLcokHh01?o]
SP03on>4m]UVonf>00CffFH01?K72_oI:OK7?OK72P;TZP002=>408=107]<
2SdL2R<L2QX92Q4L2R<L2P8J2@X01LZH:MbcQ<ZZAfY12PTL50024A`:0R`B
000BbZ4mPehDPehDARl:;3PY6PT:8a`:6Q8D2A8:2@T:6Q8D2@T:6PT:2@T:
6PT:;1808a`:6PT:0SdL2P05ARH:?A`:?A8:?A`:ARHD008m70X013dB2THV
2SdL2THV2P8m70X2ARH:00A69QA69PXm4P[CfMIQc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@3oVIVI4iVI
V@03ooooc<c<c<c<05g<c<`01SdL2R<L2R`B03dL2R<V2R`B008S70X02SdB
2QX92R<L2SdB2R<L2SdL2R<L2R`B03dL2R`B00<S70X02B`B01X92R<L2SdL
2R<L2THV2R`B03dL2R`B00036PT:00//4P0S70YG700S70X/4P0m70X/4P0m
4PXS9PX/4P0m4PX00R<L2P0i4A`:8a`:6PT:4A`:2A8:8bH:4A`:6PT:4A`:
;1802@TDAUDY4A`:CfM76Q`N=5DY?Blm?EhmEfMB;4`Y/;k1/;>g00002A8:
2A`D2@T:JXeLAT`mJW9L/;>gNhf4JW9L`LO<Phf44BH:?EhmLW9kNhf4`LO1
4BHD2A8:SHe_CeiVg>?P/;>gUJZ]/;>g/;k1YYR4g;>]i<O1kMW<m^gZg>?P
kMW<i=3<b[j]00?L/j<3g;jg00?:_Zf`/kO:d=H00]?Sm@0:m_oodn?edn?e
Y/OPLW9kPhB>YZZ]LW9kPhB>UIRS0]?Sm@0Cm_ooLXf]PiRgY/OPPhB>PiRg
m_ooUK?<4DaB?BlmCeiVkNgZPhB>`LO<kOKe`LO<b]3Fdn?eEeEB00;CfMH0
2<77c>gfmOooongIc>fn?OoI:OK7?OK77P?facd04oK77_Jc0?oI?OK@Q?oS
Q?o@0?K72_KII_K72_oI:OJc0?oI?OJc0?o]c?o]S_KII_o]S_KII_o]SP02
on>400WokHkofCgohhCohhCofCgfacgod03]aecfaah00nBZ000?UED0LSP0
ARH:4A`:8a`:4A`:2@T:8a`:6PT:WW8:kM2HbZYVWW8D2A`D4A`:008J2@X0
1`000>BcAij=<h=k<h=N54H_2R<V2P024A`:00@92A@A70X92@X92@X24A`:
0b<L2P03Ea`0?A`:?A`:00<m70X00b`L53dL2SdL2P02ARH:00=69Q@m70Xm
70X00cdL2P05Ea`0;2HDARHD;180kOKe067<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01BIVIT2ooom1?ko
o@;oo_l05_olo_omoookooKfn?;hn>Kel]K[i]?XhloNfM7MfM;MfM7MfM;M
fM7MfM;MfM7MfM;MfM7MfM;MfM7MfM;MfM7Mf@;BgMT`d]cK01SBgMWAgMWB
gMWAgMWBgMWAgMWBgMWAgMWBgMWAgMWBgMWAgMWBgMWAgMWBgMW?g]W;h=_<
h]oGj^KWlo7cnOOino[noO_ooOd2oocm00OooOooo_ooo_ooooonoooloooo
ool0SIVIV@03ooooc<c<c<c<05g<c<`00b`L52<L2R`L5002;18000TS70Xm
70Xm4PX/4P0/71@m70XS70Xm70X/4P000SdL2P03;180?A`:6PT:008/4P03
8a`:00@m4PX/4P0m70Xm70X38a`:00L/4P0S70X/71@S9PX/4P0S70X/4P00
0R<L2P0a;180Ea`08bH:;1808a`:;180?A8:?A`:6PT:2A8:6Q8D2@T:8a`:
6PT:2@T:4A`:AUDYNheV;3PY4BHD2A8:4A`:4BHDAUDY;2HDPhAkYZZS6RHD
2A8:4BHD2@TD;3PYAUDY;3PYPhAk/;k1`LO1UIRSb]3F4BHD4BH:;4`Y`LO1
UJ6>SIR>0000NheV4BHN/;>g00;1al402iFHXk2n`JJQV<6QQ=bn[NC@c=cS
e^gIc?K]j]cSe]cSh002g;j]00?:_ZgL_[OLhmH00ngIc007g;jg`J64YXB4
`G]kdn?em_oodn?e00:Van005EMNKg9bNiF4SYF4SYFQ]m?SmOKoom?SmIFQ
]h>4SX>H[G:=[L77c=?SmIFcc7:=[B=1?DmNI/77c<77`IFZ[@02kOKe00ZV
ZZg:d=JEXKN`/kOChoGfooofkN[L_Zgfacgf/`03m/Lm00?faakfacgffFH0
0_K72P0=m/Lmonf>m]UVm/LNm/L:m]UVm/LmomTYm[<0omTmi:X0m_oeonf>
00Gohh@01_KII_oSQ?oSQ?KII_oI?OKIIP;ofBT00oK7?OK77^BZ0002i:X0
00>EE@1kC0Y6;`X00R<L2P0?6PT:4A`:;1802@T:^H@Dg<NSdkj>^HdY;1`D
6Q8D2@T:4A`:;180g;=L/8eB00:NNc<01TIE:C@_7QXV51X92QXB50T92P8A
70X01aX92PT952`B02`L52`B01XB52`V5002?A`:00@m4PY69PXS9PY69Q@2
?A`:00<S9PXm70Xm70X00SdL2P07ARHD?A`:AT4NARHDARH:YW8Ddn?e067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIV
c<c<VIVI01BIVIT4o_om01[oooooo_ooo_ooo_ooo?oooOocloGPi^KIiNG>
hMo0fMFnem6cb<6dal6fal6dal6fal6dal6fal6dal6hbL>fbL>hbL>fbL>h
bL>fbL<2^<W300>hb<Fhb<Nhb<L0;;S8a`0L^<S5^<W3]/W3^<W3]/W3^<W3
]/W3^<W3]/W3^<W3]/W3^<W3]/W3^<W3]/W3^<W3]L[3/]38]M?;`=WCcN3L
fNGQi>[Xl_;boo_loogooocooogo0_ono`04ooooo_ooo?ooooooSIVIV@03
ooooc<c<c<c<05g<c<`012`V53dL2R<L2R<L2P8m70X38a`:00@m70XS9PX/
4P0S9PX2?A`:01d/4P0S9PXm70XS9PX/71@S70X/4P0J2@XS9PY69PXm70XS
9PX/4P0S70X/4P0/71@/4P0S70X/4P0m4PY6;`XJ2@Xm70X/4P0m70XS70Xm
70XS70X/4P0012<L2P0;;1802A8:2@T:2@T:2A8:=2lN;1`D2@T:AT`m4BHD
H5hc008A70X26Q8D02E6C3e?GVJEXHhA9PXJ9Q@A9Q@92@XA70YPGS<S;aj3
Q7^3SHBEZZf`/kN`_/7:d<40000dEBV3SHAbLW^VZZeGSE`0001ZSEabEE:V
ZZ>V/l6`/kNEXHj=SFmbIe:`Q7_1/jgTd<cTal7Td<cLhmH00^C@c008g;jg
b]31g;jgi<O1kMW<m^gZm_KekOKe0_K]jP0Ai<O1g;jg`G]kdn?em_oo`LO<
Y/OPUJ6gEei_Phf4UHB>/;k1dn?em_oodn?ePiRgLW9k00:3V:d02]?SmJK7
h:K7h9Fcc3AWNdmbNdIED_oool77c=?IeP;]m_D00k2n`M?SmNgfm@02m_oo
00?Laj?f/`3faah00oK7?@0<i;<NomTYm/L:m/LmomTYm/L:m/LNon>>m]UV
m/Lmom00omTm0ooI:@03m/Lmm[<0ong<00;okHh2on>400CokHkffFKokHko
hh@2m]UV00CohhCffFKofBWofCd2m/Lm0^BZ000?diP:UED0UED0ARH:6RHD
8a`:2@T:6PT:4A`:6Q8Ddj4YkMW<m]UVg;=LARl:008A70X03QX92R`B0>g7
G<ZZIYj=<kV=<fYE7S@_7R<V2Q4L2PTB2Q4L2PT92QX92P892@X01aX92R`B
02<L2SdB2SdL2R`V54H_2P02ARH:00@m70Y69PXm70Y69Q@2?A`:0THV2P08
ARHD?A`:ARHDEa`0`G]kg;jgoooodmWFHLc<c004IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT059VIV@;lood00oko
oOoooOono`03ooko00Whm_WdmOONi>C4d<jgb/R/aL6P_KRN^kJE/:T01iJ`
Y`RE[jH00iN^Z9N]ZYN]ZP0/UjfZ00>G[ZRE[jJE[jH03IF_YP09T[2VU;R^
Uk^aX;ng[<Fo]l[4am;>fmoNkNg]00?ooOl2ooko00Coooonooonoooooon=
VIVI00?oooo<c<c<c<`0GLc<c004;1`D8a`:?A`:8a`:0R<V2P03?A`:;1`D
=2lN008m70X01R`L52<V2THV2SdL2R<L2SdL2P@/4P002SdB2R`B02<L2R`B
04HV2SdL2R`B03dL2R<L2SdL2P@S70X022`B03dL2R`B02<V2R<L2SdB2SdL
2R`B008m70X01R`B02`L52`B02<L2SdB2R`B008A70X03DI<?EN=G9FHXk2c
]dHV53AE:A4L2QXB514V2R<_7TIE:FYkK`TB2P024A`:00L92A@A9PXJ4Q@A
9QA6C3f3V8jEZZd00YFHX`0I/;k1SIR>=5DY8blNYZ6HLW9kSIR>4BH:EfMB
?BlmNhf4LXf4?Ehm8blY=2lcH44YPehcWXAVYXB4`J64`K>]g;jg`LO<i=3<
b]3100;1/jd01L6QQ=bc[NgIc>gIc?Koo`02m_Ke00_fkN[]kN[fkN[]fLc1
Ng^VZZ?ChoFVan2`_/6V/l5GEE800[2c]`?ChoD03W:=[H>4NiFHXjJc`OKo
ojK7h=?SmJK7h7:=[FYkQ3d_?IFHXngfmL77c0;]m_D01]?SmMcSh?KoooKo
ooooong7G0;faah01>Bc7_KII_K7?OK77P;facd02OKII_K7?OK77_K77_oS
Q?KII_K7?OJc0?KIIP02m/Lm00?faakofCgTZP000oo]SP04m]UVon>4onf>
on>>0oo]SP07on>4onf>m]UVm]UVomTYm]UVm/Lm00;TZP004=>H2YEE07]<
2TH_2R`B01XB514L2QXB52<L2QX92]bZ<ng@V>gIc?KIISAE:A4V2P8A70X0
25LL0<ZQDYik<h=N59j=<jJ4DR`V54I17P8J4Q@0114L2QXB50TB2Q4L2P<S
70X02B`L54HV2SdL2SdB2ULL04HV2THV54HV2THV5002ARH:00Q69Q@m70Y6
9PXm70Xd;aiG702`NfKfkNX3oooo00?:d=K<c<c<c<`0Glc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT059VI
V@04noooo?ooo_oooooo0_ono`0>o_com_KhiNWZdM_J^LO7YKVgVKB_Sk2Y
Q:NQOZ6JP:6HOIjCMiR=LiB90W6BQ`03LiB9MIJ;LY>800MbThP`Li::276B
Q`9dUHX2LiB900idUHYfUhahVHigVhmgXIEjY9R2Z9f;[:>I]:f]`;c4d<kD
f][XjNggmOP2ooko00Gno?oooOooooono_ooool0SIVIV@03ooooc<c<c<c<
05g<c<`022`V53dL2R<L2SdL2R<L2SdL2R`B03dL2P8/4P0012<L2R<V2R`B
05LL008m70X012`B02<L2R<L2R`B008S9PX01B<L2R`B03dL2R<L2SdL2P02
8bH:00<m70X/4P0m70X00R`B0005?A`:ARl:;180?A`:;180008m70X04B<V
2SdL2R<L2SdL2TH_2R`B03dL2R<V2R<L2Q4L2PT92R`L54mWAfYbG9FHXm?I
e_Koo`024BH:0Q4L2P0RAT`m=2lN00004BHD2A8:2@TD6Q`NAT`m;3PY2@TD
AT`mAUEBPhB>/;>gCeiVg>?P;4`Y2A`NLUEBJW]_UJZ];4`Y2@T:SHeBUHAk
Phf4SHeBARHD6Q8D;1`DH44YJVLcUG97YW9B0YF4N`0;YXB4LVMBLUEBPg]L
LVMBLUEBUHAkYXB4b]31g;jgkMW<00Cfm_D01_K]j_KfmMcSh=bc[M?Ie]?S
m@:Van000fYkQ8>4S[2n`@03dn?e00n3V:ebLW^EV:?1alcChoFVan3foonV
an23V:fEXKMZNhA6C3fEV:?ooooChoD00ngfm@;fool01OooonBcAnBZ0?K7
?OJc0002m/Lm01?fa`[faakfacg]aecofBWfacgfaak]d9SohhCod3gfa`[f
acgofBWfaakfa`[facgTZP3okLcokHh00_oSQ003m]UVon>4onf>00?okHh0
1?KII_oSQ?KII_KIIP;ofCd07_K7?NBc7^BZ0=>40:Ib07]<2V0_2Q4V2R<L
2Q4L2QX92R<L2PT92]>Q:OKomNg@V=c7Xh=N52<V2PTL7R`B05LL09ib<kUb
<c@_<fYW<lZH:AXV52<_7R<L2P8A70X01@T92PTB2QX92R<L2SdL2P028a`:
00H/71@m70Y69PY69PY69QAG7003ARH:00U69Q@S9PXm4PXd;aj3;`31XHCo
kLcoooofool00oooo`03b]3Fc<c<c<c<05o<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01BIVIT2noon01cn
o_kno?goo_ono?gcm?KUjn_5dLngb/JS_[V>[jQkX9QZU8YNQgmGPGMORG]N
RGQNQgULQgIMQWQMR7MPRG]ORWUPRG]ORWUPRG]ORWUPRG]ORWT4H8Uk04UR
R7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]P
RG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]R
R7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]P
RG]QRWaPRgYQRWaPRgYQRWaPRgYQRWaPRgYNQgULQgIMQWQLQgIMQWQNRGQP
RG]ORgaUUHEIS7eJR7][UHUmXIN;ZJ6O]K:c`l;>f=WSj>_gn?`00_ooo`04
ookooogooO_nooooSIVIV@03ooooc<c<c<c<05g<c<`012`L54H_2R<L2R<L
2P8m70X01B<L2SdL2R`L53dL2R<V2P02?A`:00A69PXS70X/4P0S70X2;180
00`S70X/4P0/4P0J2@XS70X/4P0m70XS9PXm70XS70Xm70X/4P028a`:03//
4P0S9PX/4P0m70XS9PXm70Y69PXS9PXm70XS70X/4P0S9PX/4P0S9PXm70Y6
9PXS9PXJ2@XS70XJ2@YGEE9ZLUbEXKO:d=KChoEPGS<A9PXS9PX/>2TA9PX9
71@A70X94PX92A@J2@YbSE`92@YbSEa?IeaPGS=GEE9ZLUa6Ie`/C2V`/kL0
000/71AZIc=ZLUbVZZ<0002VV6ld;bV3Q7]bSEa6C3dA9Q@A70XA9Q@00V11
:@0ALVMBLUEBPg]LLUEBJVLcUG97LUEBJVLcUEhc/7]V`J64g;>Sg;jgi<O1
i=3<kNgZm_Ke00?fool01?KomOK]j_KfmG9EDP;ChoD01;2n`L[@eX>4SYFQ
]`;1al`01jK7h9FHXhf=KiFQ]m?SmIFcc:K7h002dn?e01F3V;OChoFE/l`d
EBUGIe;:d=K]m_GChoGoooo]m_G]fLcfooooooo]_SgTZP3fa`[T/akfaakf
a`[T/bWfaah01?K7?@06m/L:m]UVm]UVm/LNomTYm]UV0_K7?@03m/L:m/LN
i:X000;okHh2m]UV00?ohhkokHkokHh00oo]SP?ohh@01?KII_oI?Ng7G?K7
?@;TZP001M>H2ZIb08=1060_2R`V50024A`:01/J4Q@S70X92ABVLP3okLc]
fLcokHik@@0S9PX94PXS70Xm4P[:XE;T/dNiLS>3GS>`SC=kC1@S9PXJ9Q@J
4Q@92@XA70XJ4Q@J2@XA70X/4P000SdL2P0:?A8:ARH:ARH:Ea`0ARH:H2l:
ARH:ARHD;2HD=2lN0THV5005/7/Yong<oooooooom_oo00Coool00l[@`Lc<
c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@0DVIVI0_koo`0Looooookoookon__mi^c/d=oL^<k;
W[fgOZJMKYbAMJBJR;Z_XM36[moCaOGUa_ORb_WWbocWcOcZc?gXc?_YbocW
b?OUaoSSb?OUaoSSb?OUaoSS1<Sgi@1;b_KUb?OUb_KUb?OUb_KUb?OUb_KU
b?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OU
b_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KU
b?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUbOSVb?WTbOSVb?WTbOSVb?WT
bOSVb?WTc?_Yb__Vbo[XbO[Ub_WWb__Vbo[XbOcY_OCQZ>7>VLnoSL2aO:ZO
Li^BRZZU[<K3]l_:cmgMjO?dnOkoo_oo00Coo_n=VIVI00?oooo<c<c<c<`0
GLc<c00;8a`:;1`D8a`:;1`D;180;1`D8bH:8a`:;1808a`:ARH:008m70X0
32<V2SdL2SdL2SdL2R<L2R`B02<V2SdL2R<L2R`B014V2THV2PDm70X02R<L
2R<V2SdL2R<L2SdL2THV52`B04HV2SdL2THV2P8m70X00b<L2SdL2SdL2P03
?A`:0TH_2P8S70X01AXL7TmWAg^=IYFZ[L77c002dmWF01@0000A9Q@A9PX9
2@XJ4Q@92@XJ4QA6EBT/C2TJ4Q@J71j3Q7/S;aj3V8jEXHjEV:=bSCd/>2TJ
9Q@S;ah2LXeL00]ZSE`/>2UkSFJEXHh971@dEBU6EBTJ71h94PXJ4QA69Q@0
0V11:@04LUEBPehcJVLcH44Y0W9EDP07JVLcUD`Y/7]V/8AV`G]ki:ZHi=3<
00;]fL`01OK]j_KfmOKoooooooKoo`02m_Ke00GfkN[1XHB`_/7ChoG1al`0
0ZK7h00QUK?<UJ6gdn?eY/OPUIRSEei_`LO<m_ooY/OPPiRgdn?em_ooY/OP
dn?eY/OPLXf]8blYm_oodn?ekOKem_ooUIRSg>?Fm_oooooodiP:m[<0m/LN
m[<0m/LNkLMLm/Lmm/LN00;facd03oKII_K7?OK72_oSS_K@Q?oI?OK77_o@
?OoI?OK7?OK77_KII_Jc0?KII_oSQ002m]UV0oo]SP03on>4onf>onf>00;o
hh@01_o]S_oSQ?oI:OKII_K72^BZ00;CV0X00k1b08eE2TH_2P02;1`D0Q4L
2P0K6PT:6Q8D^H@Dong<kMW<ong<LXdm4BH:2A8:4A`:Ea`0bZ5Bi;=7i;<c
dj4YUEhc^HdYH2lD;1`D6RHD6Q8D2A8:4A`:6PT:?A8:6Q8D;1`D008m70X0
3V0_55LL060_560_2THV2THV54I17THV55LL0:IbD_K]j_KfmOooongfm@Ko
ool00l[@e/c<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^0C<c<`00fIVI/c<c9VIV@0DVIVI0_ooo`;oo_l07?oooo;fmmGQ
gkW@bYfn]hRcZGV]X86jZicFb;S`hlSnlLcollKii/Oki<Wmil_oj<_ojL[n
ilSli/Oki<coj/cojLcoj/cojLcoj/cojLcoj/cojC3>onT2c?oY01c<on[<
onW<on[<onW<on[<onW;onW;onS:o^S9oNK9oNO9oNK9oNO7o^O2oNO0o^W1
o^bjmN>Pe/R1/jMgYI^1ZJ6Q`Kbid/oGinO]moSioOkoo_l2oogo00?oo_nI
VIVIVIT0RiVIV@03ooooc<c<c<c<05g<c<`01CdL2THV51XB5611:B`L5002
?A`:00<S70Y69PY69PX00R`B0003ARH:ARl:?A`:00969PX2?A`:01`S70X/
4P169PXm70XJ2@Y69PYG70169PXS70XS9PXS70Xm70X/4P0/71@d;ahm70XS
9PY69Q@/4P0m70XS9PY69PXS9PXm70Y6;`Xm70Y6;`Xm70X2ARH:014m70XS
9PXJ2@XS9PYGIe9ZNfnEV:?CfMK]kN[fooo1XH@0000A9PXm70XA9Q@J9Q@m
GSd00b<_7P0@2A8:;3PY0000JW9LSIR>YZZS0000UJ6>UIQV=5DY4BHD8blN
;3PY0000CfM74BH:0Q4L2P0G6Q8D00006Q8D8blNAT4NH44YNd`DPehcLUEB
PehcJVLcPehcH44YUD`YYYQ_/8AVUG97`J64g;>]i=3<i<O1kMW<m_oo00;f
m_D3m_oo0_Kfm@0?kMW<WXAVdn?e`LO<Y/OPm_oodn?eUK?<Y[?1/;k1Y[?1
Pg]Ldn?em_oodn?e00:3V;L03>gfmOKoom?SmOKoojJZ[H=N<jJZ[OKoomcS
h:JQV<6cS]cSh0;oool01LZH5?K77^Bc<oK72_K7?@02m/LN1OK7?@05i:X0
on>>m]24omTmm/LN00;ffFH03?K72_K7?OK7?OK77_oSS_o]c?oSQ?KII_oS
Q?o]S_o]c?oSQ0;okHh00ooSQ?o]S_oSQ002on>400ofacgffFKTZP3CV0[T
ZP2`LP23@@1Z@@Xd;ahJ9Q@/71@A70X/71@92@Z`Na@00oo]c00HWXdcAT4N
4A`:2A8:;180m]UVm]24kLMLi;=7^G8cbZ4m/4`0;1`D8blN4A`:6Q8D2A8:
6PT:8a`:;1`D?A`:?A8:H2lDEa`0160_5004ARH:YT`0g;>]ong<1?ooo`03
kOKem_oooooo00Coool00l77c<c<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P1
0000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0DVIVI023no?oo
oOoonoomnokgn?[Sk>^odm6N_kQlZYml]ZN8b;RNhm6fnNS1oo6mn^^hlN39
onS9onG9onO9onG9onO8o^C8o^K7oN?<on[<onS<on[<onS<on[<onS<on[=
onP`cooX027<onO;onO;onW;onO;onW;onO;onW;onO;onW;onO;onW:onK9
onO9onG8o^K7onK0onRnonVnon_0onfno^f^k=f@b[ihZj:6/JZL_kVnemCN
k>ccnOWmnokonokoo?ooo_l04IVIV@<0000NVIVI0`0005RIVIT00oooolc<
c<c<c01Mc<c<00@/9Q@/71@m70XA70X2?A`:00U69PXm70XS9PX/4P0m70XS
9PXm70YkC0YG70000TH_2P04?A`:ARH:ARH:?A`:0R<V2P0:8a`:?A`:8bH:
8bH:?A`:8a`:?A`:;180?A`:8bH:0R`B0003?A`:ARl:8a`:008m70X01THV
2SdL2SdL2SdL2R`B03dB2P969PX05DH_2THV2TH_2SdL2QXV55MWDX>4NiFZ
[K2n`L[@e_KoojJQIVY12Q4V51XV514V2QXB500005MWDXf=K`0000032A8:
01Q?Ieb=V8i?IdL0002EXHi?IdLS;bUPGS<dEBT92@XA70XJ4Q@92A@J4Q@9
4PXA70X92A@/>2U69QAZEAj3GS=P@BV3GS=ZEAh2JVLc00UZEAj3GS>`Q7_1
XHBVV6n`NfK1Ng_L_[OTal400^gIc003m^gZm_Keoooo00;fool04?KfmOKo
ooKoongfmH=N<m?SmL[@eYFQ]m?SmOKoom?SmL77c;2n`L77c9FHXm?Sm@?f
ool03=cSh>gfmNgfmNgfmOKoooKomOooooK]j_KfmNg]j_K]j/[@`@;fool0
2OooolZH5>BZ0?K7?OJc0?KII_K77^Bc:OK72P02m/Lm00Ofaakfacgfaakf
d8CohhCffFKfaah00_KIIP03omTYm/LmomTm00;facd01ooSS_oSQ?oSQ?o]
S_K@Q?o]S_oSQ002onf>0ooSQ00>onf>m]UVm/Lmm/LNi;<ci:X0`H@0/780
UED0JT4:;1`D8bH:4A`:6PT:0Q4L2P0>Nd`Dm_oem_oeong<WXdY=5DY2@T:
4A`:;180om0mm]24kLN4m]UVdjY70]>Q:@05Nd`D=2lN4A`:6PT:2A8:00<S
70X00dHV2SdB2V0_2P04H2lD00=b9P3]d9Soool01Oooo`03m_ookOKem_oo
00Goool00l[@`Lc<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0DVIVI017oo?oooOooo?oln_ga
l_CHi>:`blJ>^:id[Iioa;6Dgl^TlMf`nnNgo^c3oo?<ooG;on/00l_oi`;<
onP00lgojLkoj/[oiP06b_oV03;;onC=onC=on;>on;=on;>on;=on;>on;=
on;>on;=on;>on;=on;>on;=on;>on;=on;>on;=on;>on;=on;>on;=on;>
on;=on;>on;=on;>on;=on;>on;=on;>on;=on;>on;=on;>on;=on;>on;=
on;>on;=on;>on;=on;>on;=on;>on;=on;>on;=onC:on<7bOoU1Lgoj@0D
c?oXbooWaooXaoo``?o^]O[UZ?3JZ>oMYNcJUMO9P;jaMJZPR[F^[/g8e>SV
l_[lookooocooo[nooko4iVIV@80000OVIVI0P0005NIVIT00oooolc<c<c<
c01Mc<c<00=69QA69PXS70X00cdL2P068bH:ARH:?A`:;1`DARH:;1800SdL
2P06ARl:Ea`0ARH:?A`:8bH:ARl:0SdL2P08;1802@T:Ea`0ARH:;180?A`:
ARl:;1800R<L2P08?A`:;180?A`:8bH:?A`:;180?A`:8bH:13dL2P969PX0
4DH_2SdL2SdL2THV2SdL2R<L2QXL7W^=IX>4Ng^=Q<6c[McSh?ooocAE:B<V
2TH_2R<_:@022@T:014A9QA6EBU6EBTA9PX/9Q@94PX92@X/>2UkSFH92@X9
4PY?IdM6@Ah000094PX92A@A70X00PT92P076Q8D4BHD6Q8D2@TD6RHDH2lD
H44Y00:3GS<2UG9700bNQ6JELTN3GS>3GS>VQ5:VXIRVQ8BVLU;1Ng_1XHCL
/j?Tal42kMW<00CfkN[fm_Gfm_Gfm_D2m_oo00C:d=K1ala6EE8m4PX2kOKe
00?]kN[]m_Gfool00oKoo`;Lhn001OKoongfmNg]j_KomNgfm@02g>?P00?L
hmK]m_G]m_D00^gfm@0;ooookNgZkNgZg>?Poooom_oooooodiP:i:X0i;<c
m[<000;facd00nBZ0?K77_K7?@03m/Lm00Gfaakfd8CohhkohhCfa`X00_KI
IP;ofCd3m/Lm0ooSQ005onf>on>>onf>on>4on>>00Gohh@01?o]S_K7?OK7
?NBc:@;TZP002[1b09ib2VY12SdL2QXV51X92QXB51XL7PTB2X<h00?okL`0
4IF=DV1150TL514L2QX92^BcAoo]c?KII_oSS^g7G<ZQ?LZH5:Ib54HV50TB
2Q4L2PTB2P028a`:00TJ71i69QA69QAP;aAP@BUP;aAP;`Z`SE;Laj<01ooo
o`03m_ookNgZoooo00Goool00m?Ie/c<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0DVIVI017o
o?oooOoooOoknOc[ko3?g]^Wa/25]JUj^:V4ck^GjM>UnN:YnnF^nNFdm^Rk
n>S5oN@00/Smh@03bOkRb_oSb_oS00;;on@8c?oU0/oohP0^dOoRcooRdOoR
cooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooR
dOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoR
cooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooR2<coi@03
b?gQbOkRb_oS00;:on<04LWnh/SmhL?nh[Ohh;_ojl7om;kol[;ojjCagIOQ
d93Dag^g[HRj/J?8`LWRg^cfmokno`02oo_o00?oo_nIVIVIVIT019VIV@80
0004VIVI100000>IVIT300001YVIV@D00003VIVI0P0000:IVIT400000YVI
V@800004VIVI0`0000NIVIT400000iVIV@@00002VIVI0P0000:IVIT20000
0iVIV@@00003VIVI100002jIVIT00oooolc<c<c<c01Mc<c<00Dm70Y69PXS
70Xm70X/4P000SdL2P0S8bH:?A`:;180ARl:6PT:8a`:8bH:8a`:Ea`0ARl:
Ea`0ARl:?A`:;1808bH:Ea`02A8:8bH:ARH:;180ARl:;1808a`:?A`:8a`:
;1808bH:?A`:;180ARH:?A`:8a`:Ea`0;180ARl:00A69PX0;TH_2ULL060_
2TH_2SdL2TH_2QXV54I17VYbG5MWD[2c]m?Ie^gfmIib2W]<2VYE7VY12X=N
50TB2Q4V54IE:B`V52<_7QXV50T952<_7QXL7Ra<:@TB2Q4L2QXB50TB2PT9
2P0000TB2PT9514L2PTB2Q4L2PT92PTB2Q4L2S@_:G8h57]<56YE7P:ELTL0
1:JHQ=bcXiF=DX=N<`BELTL01;1kIZJQV=bn]mbn]`?]fL`3m^gZ0_Koo`0:
kMW<8bH:2A`N6PT:kOKedmWF/;k1g;jg`LO<i=3<0]bn]`09i<O1g;>SkMW<
kM2HkMW<kLN4g>?FkMW<on>>00;]fL`05Ng@V>BnQ=>nS/5kNjK7h8>HS[2n
`Ng]j_KfmOKomOoookUb<m>40?K77^Bc<oK7?OK77_K7?OK77_K7?OK77P02
m/Lm017fa`[]aecohhkfacgfa`[ffFKohhCfaakffFKfacgofBWod3gfd8Co
hhCohhkokHkffFH00_oSSP?okHh01ooSQ?KII_oSQ?KII_K7?OKII^Bc7P02
diP:00G1Q02EE@1Z@@X/9Q@S9PX00Q4L2P0=8a`:4BHDEa`0m_oeong<m_oe
YZ5VARl:4BH:2@T:0000i;<Yonf>00;ohhh02>g7G<ZZI^Bc:IiN57]<51XB
514L2PT92P8S70X01aXL7ULL04HV560_5:IW0;VZKoK]jP02oooo00?fooGo
ooooool01Oooo`03kOKem_oooooo00Coool00m?Ie/c<c<c<c01Oc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VI
V@0DVIVI01?moOgoo_ooo?kjm?SVinW6e]FJ`[Yg/jN8d/64el>:glZGj]JW
m^>do^fhoo2kong1onK4onC5onD00/OoiP03a_oUa?oS`okR00O3o^80</Gm
h/Kmg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Ol
g/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Km
g/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Ol
g/Kmg/Olg/Kmg/Knh`O4on<00l?nh/CohlGoi002a_oU01C5onC4on?2o^C4
onbio^VcoNJ`onVVnnBEkMN7g/^6elJ3bkf6`[JGaK^heM7KjNWem_Son_oo
o?ooo_l6VIVI0P0000>IVIT200000YVIV@800002VIVI0`0000FIVIT20000
0iVIV@8000000iVIV@0000000002VIVI0P0000:IVIT2000000>IVIT00000
000019VIV@<00006VIVI0P0000:IVIT2000000>IVIT0000000000YVIV@80
00000iVIV@0000000002VIVI0P0000:IVIT200000YVIV@8000000iVIV@00
00000002VIVI0P0002fIVIT00oooolc<c<c<c01Mc<c<00=69QA69PXS70X0
0b<L2P8m70X2ARH:00@m70XS70XJ2@X94PX26PT:00a69PX/4P0/4P0m70X/
9Q@/4P0S9PXJ2@X/4P0S9PXm70X/4P028a`:0R`B0004;2HD;180?A`:ARl:
0SdL2P088bH:8a`:?A`:?A`:ARH:?A`:ARl:ARH:0ULL000NLSP0ARHD?A`:
;180=2lYNheVPhAkUHAkb]31dmWFAT`mYYQ_/:Z4SHeBYZ6Hb]318bH:4BH:
2A`D00004BHD;2HD4A`:8bH:=2lN2@T:4A`:2A8:4A`:2@T:0PTB2P094A`:
2@T:2A8:4A`:2@TD4A`:6Q8D8bH:H44D009P@BT01iE<:Iik<k24I]bcXl[@
`JIbDX=k<`02Pehc00QZIc>3GS>VLU:`Q7_1XHCL_[OTd<c]fL`2m_Ke0_K]
jP;fool03Ooool5kNk2=<lZn[M>nS]>40<ZH5=>40>BZ0=>H2^Bc:NBcAoK7
?@03kLML013ffFKfd8CohhkffFK]ahCffFK]_SgfacgfaakCV0[f/`0m4PYZ
EAjELTOTd<cfool2oooo00W:V2WTZP3f/`3]_SgfacgT/bWfa`[T/akod3d0
0_K7?@;faah02oK7?OK@Q?o@?OK7?OoSQ?K@Q?oI:OKII_K7?OKII^BcA`03
on>400?okHkohhCokHh01?o]SP;ohh@06_KII_oSQ?K7?Ng7G>Bc<lZH5=>H
2/6408eE2VY12S@_7R`V514L2QX92Q4L2QXV52`B0?o]c?KomOo]c;VZKcAE
:AXB51XV50T92]>Q:@;okL`03oo]S^g7Q>g7G>fn?M>Q:G]<52`V514L2Q4V
51XB52`V52`L58<_0;1k2]bc[@05oooo00?fooooooooool01Oooo`03kNgZ
kOKeoooo00Coool00m?Ie/c<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0DVIVI01Sboo[hoo_o
n_[onooQgnBjc<j2]k5a_k9ddKmhe/B9flfJi=NWjn2]m>J[o^Z]on^conNe
onBcoN:fonBkonNmonVnonVlonL4^ooV0k[oiP0b^_oT^ooT^ooS_OoS^ooS
_OoS^ooS_OoS^ooS_OoS^ooS_OoS^ooS_OoS^ooS_OoS^ooS__oT_?oT__oT
_?oT__oT_?oT__oT_?oT__oT_?oT__oT_?oT__oT_?oT__oT_?oT_OoS^ooS
_OoS^ooS_OoS^ooS_OoS^ooS_OoS^ooS_OoS^ooS_OoS^ooS_OoS^ooT_?oU
1Kcoi`BkonL3^?oV0[Ooi@0?^_kU`OcZ___[/o_WYOWRUoOLRo;GO^K=M][2
NM6kM;f/QK^^/MK?d>CRnOoo00;ooOl00oonoiVIVIVIV@04VIVI0P0000>I
VIT200000YVIV@80000019VIV@00000009VIV@800009VIVI0P000003VIVI
0000000000:IVIT200000YVIV@8000000iVIV@0000000003VIVI0P000003
VIVI0000000000BIVIT200001YVIV@800002VIVI0P000003VIVI00000000
00:IVIT200000YVIV@800005VIVI0P00036IVIT00oooolc<c<c<c01Mc<c<
00Dm70XS9PXm70XS70Xm4PX00SdL2PE69PX24A`:00L92@X/4P0m70Xm4PY6
9PY6;`X/4P000SdL2P044A`:;180ARH:;1800SdL2P078bH:?A`:;1808bH:
8a`:?A`:;18000<m70X012<V2SdL2SdL2TH_2P9G7003ARl:01A69QAG7016
9PX/4P16C3ebSEabSHB`_/7Lhn3CfMK]kNZ`/kO:d=KCfMK]m_G1al4A70XA
9PX92@XA9Q@24A`:00LJ4Q@A70X94PZ`ZXA69Q@92@X94PX00Q4L2P032@TD
6Q8D4A`:00892@X02Q4L2PT92R<_7S@_7V11:G8h59E<:IEN<k2=D/6QQ0;T
al402YEbAh=N58=N<g]<5611:H=N<ij4I/5kNmbcXnC7`@;]fL`01?K]j_Kf
mOK]j_K]jP;fool05?ooongIc;1b0=>H2[V45=>40=>Q:LZH5>BZ0<ZH5>Bc
<nBcAnfn?NBcAooSS_K7?Ng7G?KII_oSS_K@Q0;ffFH02OoI?Ng7G?K77^Bc
7^BZ0611561N<jJ4D^g]jP03m_oo00C]_SgCQ03od3gT/dL2m/Lm00?T/akf
a`[T/c<00_K77P0=i;<Ym[<0m[<0m/LmkLMLm/L:m/Lmm]UVm/Lmm]UVi;=7
m]UVm/LN00;ffFH3on>400CokLcokHkohhCohhh3on>401gffFKohhkfacgf
d8CT/akCXBWCV0ZiQ1BNLPYkC0Y69Q@/9Q@S70XA70XJ2@XA70X/4P3okLcf
ooG]fLc1/hiZ@@XA9Q@92A@92@[CQ03fooGokHk]d9P00_K@Q00:m/Lmdh@0
UEDDH2lD4BHD6Q8D;1`D2@T:bZ4mong<1oooo`03m_oooooooooo00Coool2
m_oo00?fkN[oooooool00oooo`03dmWFc<c<c<c<05o<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01BIVIT0
6?3on?Oon_oknOokon7Pi[K>d7Vh/6S3]6_D`g?Hb8WKciWOeJGTg:K/hJ3g
i9omhjcoj:kniJkli;3ni[Goj;Ooj[Soj[Ooj@:jonX2^?oZ1;OojQ2honP@
^OoY4;Soj0Jion/4^?o[0kKojP:eonT04[OojKWfi[SgiZcehYkcg93bfHC_
dgSTbVoJ`73?^FbmZWfk[ZcJd<gXhoGooogmooomooono`JIVIT200000iVI
V@800002VIVI0P000004VIVI00000000VIVI0P0000NIVIT4000000>IVIT0
000000000YVIV@800002VIVI0P000003VIVI0000000000>IVIT2000000>I
VIT00000000019VIV@800006VIVI0P0000:IVIT2000000>IVIT000000000
0YVIV@800002VIVI1P000003VIVI0000000000@0000]VIVI00?oooo<c<c<
c<`0GLc<c00?H2lD8bH:8a`:;1808a`:;1808a`:ARH:;180H2l:ARH:;180
8a`:6PT:4A`:008S70X01b<V2R`B03dL2SdL2R<V2R`B01X92P028bH:00DS
70X/4P0S70Xm70XS9PX00R<L2P96;`X01b`B04H_2SdL2R<V2SdL2TH_2SdL
2P02ARH:00Dm70YG70169PY6;`YG70000TH_2P058bH:8blNJW]_PhAkY[?1
00;:d=H00ngfmK2c]l[@eP02b]3F00[ChoG:d<5kSFJEV6H92@XA9PXA70X9
4PX92AAP@BT2Pg/c00=6;`XS70XA70X01A4L2P894PX03@T954HV560_560_
5611:G]<59EN<k24Nl6QQ>gIc>C7`Iik<fYE7P03H44Y00Eb>1BVEFJ`NfKL
/j?L_[L00^gIc0?fm_D00oK]j_KoooKoo`02m_oo00C1XHB`LP3:V2W:XCd2
bYPD00[CXBWCV0[:V1CT/c?T/ak]aecTZP3]aecffFKohhh3m]UV00_facg]
ahCfacg]aec]_SgTZP1P@AAbIe:`ZXCfkN[fm_D00_ooo`0:g;>4i;<Ni;<c
m]UVm/Lmm/LNi;<Ym[<0i;<Nm/Lm0oK77P0?i:X0om0mkLMLm[<0m/Lmon>>
m/L:m]UVm/Lmom0mi;=7kLMLon>>m]UVong<00?okHh08?oSS_o]S_KII_oS
Q?o]S_oSQ?KII_K7?OKII^fn?LZH5=>40<6409ib2W]<2THV2QXV52<L2QX9
2QXV51XB50000>g@V?KomOo]c<6cSV11514V50TL50T95;UW0?o]c0;ohhh2
m]2400WffFKT/bV=E@YP@A@J71h971@/71@J2@[:ZVH02?ooo`03m_oooooo
oooo00Goool00ngfmOKfmOooo`04oooo00?CfMK<c<c<c<`0Glc<c004IVIV
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT0
59VIV@0Hm?ogn_oioocjoo[mg^?W/];AKKFYH<>aI]?0KMK5QMW<U=cAWN3G
WNOJUO7LUoGMY_SRZ_GQZoCQ[?GR/_OU/oSV]?OV/oKU0[Cdi0:bmN@4/OKT
4;;eha2cm^@@/_GS1[?fi@BbmnD3[oKT0jkeh`0AZ_7OYo;NX>oLU^_FSNWD
QnK@Nmk9L]JnK<^eI[^VLKRXZMgAb^_Tkogmo?gooogoooko00JIVIT20000
0iVIV@800002VIVI0P000004VIVI00000000VIVI0P0000FIVIT500000YVI
V@800002VIVI0P0000:IVIT2000000>IVIT0000000000iVIV@8000000iVI
V@0000000004VIVI0P0000JIVIT200000YVIV@8000000iVIV@0000000002
VIVI0P0000:IVIT200000YVIV@8000000iVIV@0000000002VIVI0P0002fI
VIT00oooolc<c<c<c01Mc<c<00IP@AAG700J9Q@A70XS70XA70X2?A`:0THV
2P06Ea`0ARH:;1808bH:Ea`0;2HD0R`B0006ARl:?A`:;1808bH:;1802A8:
0R`B0007?A`:ARl:8bH:8bH:?A`:8bH:?A`:008/4P000dH_2SdL2R`B0002
ARl:00L/4P169PY69PY69PY6;`Y69PYG70000TH_2P07ARH:Ea`0ARl:8blN
UIRSUJ6>YZZ]00;:d=H01^g]jXfHSZJHQ7:=G6YW<g:=?@:3Nc<049EE07]<
2PT954HV2V11578h07]1078h060_2ULL03dL2Q4L2QX92Q4L2QX92Q4L2P89
4PX01A4L2R`L54H_2THV560_2P02LSPD016EC2W1Ng_L/jg]fLc:d<6EGS>3
GS=kC1AP@BUG701b>1BEC2V`@C?1Ng_TZYSokLcfkNX01_Kfm@04m_oooooo
m^gZ/7800/ZH500BbYPYdj4YdiP:bYPDi:X0i;<ci;<YkKhmi;<YkKhmkLML
kM2Hon>4kLMLm]UVkKhmm]UVkLML0_K7?@05i:X0WW8DH5hcYZ6HkNgZ00;f
ool03?oookV=<nfn?OK77^fn?OKII_K7?Nfn?OJc0?K77_Jc0>BcA`;T/bT0
3onc0?K7?Ng7G?K72_oI:OKII_o@?OoSQ?K7?Ng7G>BZ0?KII_oSS_oSQ?oS
SP05onf>00GffFKohhCokHk]aecohh@00_K7?@08i;<ci;<NdiP:diP:YW80
Nd`:ARl:;2HD0Q4L2P0>2@TD8a`:0000g;>4m_oeong<`K>>JVLc4BHD6Q8D
2A8:Pbl0ong<onf>0_oSSP;ffFH02>Bc7YiN57]<52<_7Q4L2QXV51X92[Ub
<a3oool00oKoomcSh?ooo`04oooo00?CfMK<c<c<c<`0Glc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT059VI
V@0Fn_ogoOoioocmo_[kfnKX[MKBG:fNE;jXF/jgI=?0NmK7S=W?UMgBUn?F
T>gHU?7LVncKXN_LXn_MY>cNZ>cOZNgP0Z[/h0:ZjMh3Z>[N0ZO[gP03Yn_L
Z>[LZ>[L00jXj]`@ZN_M4:SZg0JYjml2Z>cO0ZO[gP:Uk=h3Y>_M01:Rk=^L
kMZIk]VEj]F?i=6:hLj6glelfLIcd[i[b[IM]Z9Q[YjQgM7:knS[o_cnoooo
oOooo_l6VIVI0P0000BIVIT00`0009VIVIVIV@0400000iVIV@800003VIVI
100000BIVIT200000iVIV@030000VIVIVIVI008000000iVIV@0000000002
VIVI0P0000>IVIT200000iVIV@800007VIVI00<0002IVIVIVIT00P000003
VIVI0000000000:IVIT200000YVIV@800002VIVI0P000003VIVI00000000
00:IVIT20000;IVIV@03ooooc<c<c<c<05g<c<`0360_54H_2X<h02`V52<V
2SdL2THV2ULL060_2W8V04HV2W8V00969PX00a4L2R`B02<V2P02?A`:00E6
9PX/4P169PX/4P092@X00SdL2P088bH:?A`:;180ARl:8bH:;2HD?A`:8bH:
0SdL2P03ARH:ARl:?A`:008m70X084HV2SdL2TH_2ULL04H_2THV2TH_2W8V
04H_2V0_2SdL2PTL7W^=IX>HS[2n`L[@e^gfmK2ZQ5LL08=N578h07]1078V
078h07]109EE0:Ib08=N58=107]<2VY12V0_2P96;`X012<V2R<L2Q4L2QXB
508A70X04Q4V514L2PTB2PTB2TI17S@_<f11:C@_<g8h56YE7YE<:L6QQ=bn
]nC7`L6c[Hf=AfYW<b<L2P9P;a@02F11:IEbAiE<:JIEIX<_0=bn]oo]c?oo
ooKoo`02m_Ke0_K]jP0:m_Kem_oooooo/780^HdYbYPDbYPYi:X0dh@0g:Xc
0^Bc<`09i;<NkKhmkKhmi;<Ym/LNon>>m]UVkLMLom0m00;]ae`02?K77^g7
G?K7?NBc:H=N56YW<l[@`McSeP?oool01:Ib5?K@Q>Bc<oKIIP;facd01nBc
<oJc0?K7?NBc<ooI:NBc:OJc0002i:X001;]aecf/`3]aecffFKod3gffFKo
d3gffFKT/akffFKohhkfd8CffFKohhkfd8CokHkfd8CokHh2on>400kfd8Cf
fFKffFKfacg]_SgT/c?CXBW:V1BiQ1B`N`YkC0Y69Q@/9Q@S9PX26Q8D01TA
9PX0002iV5cokLc]fLcC_XiZEAh971@A9Q@971Ab9P3okLcohhCfd8CffFKf
d8CffFKT/bV`N`ZVC00d;ahA9Q@/71@J4QBV@@002Oooo`03m_oooooooooo
00Coool00oKoong]j_ooo`04oooo00?LhmK<c<c<c<`0Glc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT059VI
V@0Dooojo_ghoocmn_Skf^g[Z]cCC:FCA;JMCl^aFm6iLmK4Q=S;SM_>S]o@
RnSCS^_FTnKFUnGGV^KIW>SK0YoWf`03X>KKXNOLY>SM00:Tj=d3X^SM0Z7Y
g@03X^SMX^WKX^WK02fRjM/6XnWN0Z;ZgP:QjMd05j3ZgIoYg9oYg9oYg9kX
fiWZfho[eXgZeHcUdHSOcXOKbhGIbWWD`g3=^VG6/U:_VU6TTYcNd<gfk^_o
oOonooomooono`06VIVI0P0000BIVIT4000000>IVIT0000000000iVIV@80
0003VIVI0P0000FIVIT400000YVIV@@00002VIVI1P0000>IVIT200000iVI
V@800007VIVI10000003VIVI0000000000H00002VIVI100000>IVIT40000
;YVIV@03ooooc<c<c<c<05g<c<`00g]<59EE514L2P02;18014HV2P03H2l:
JT4:H2l:009P;`X2?A`:00QP;`Y6;`YG70169PXm70XS70Y69PX94PX2ARH:
00=6;`YG700m70X00SdL2P0=;180ARl:ARH:?A`:ARl:Ea`0?A`:8bH:Ea`0
?A`:ARH:ARl:Ea`0009P;`X06ULL04H_2THV55LL04H_2SdL2THV53eN?F1N
<jJQV>C@c=cSh9ib57]<2YiN58=N59ib2X=N58=108=N57]109ib58=N58eE
2W8h08eE2P96;`X24A`:028S70XJ2@XA70XA70X94PXS70X/4P094PXS9PXm
70YG7016;`Y6@AiP@BUb>1BEC2WC_XkTal71XHBELTN3GS=b>1A69QAP@ABN
LQBiV5c:_Zg1/hkooooL_ZfVLU:VEFKfkN[oool2m_oo00[Tal7]fLcfm_Gf
oooooonNLPZNNc>`Q2V`SE:`Q2T2PehD0[VHG007YXABWW/cWW/cbZ4mUHAB
WW/cSHe700:EV6H06[VHG:J4DYFHIX=k<fYW<l6c[Ng]jYF4D/77`McSe_Ko
ooooooKookV4:OoSS_K7?OKII_K7?Nfn?OK7?NBc:OK77^Bc<oJc0?K77^Bc
:@;f/`001OK7?OJc0?oI:Ng7G?K72P02kLML00?od3gTZP3ffFH00_oSSP05
on>4onf>on>>on>>m]UV00;ohh@01?oSS_oSQ?oSS^g7G0;facd01^BcAmbZ
<m>H2]>H2[V=57]<2P96;`X072<L2QX92Q4L2QX92PT959ib<oKomNgIc=>n
SX=k<`TL514L2PT955LL0?o]c?o]S_K@Q?KII_K@Q?KII^fn?KUb<kV4560_
514V7QXV51XB58<_013oool00oKoomcSe_ooo`04oooo00?CfMK<c<c<c<`0
Glc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT059VIV@0EooojoOchoocmnOWkh?Cb/N?JAIj<>ZnEA/N[Cm2d
ImBoN=K6PMG6QMO9QMk<Q^7?SN7AT>;DTnGGU^KIUnGH00:Hi=P6VnCI0YWU
f@>IiMP0<i_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_U
f9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WU
f9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_U
f9WUf9_Uf9WUf9cUfY[VfYcUfY[VfYcUfP02V^KJ01ZIimZIiMVHi]VHi]VE
iMRGiMREiMRFi=NBi]J8hm66iM64glf1f/Qoe/Ikdl=`cK]TaK9K_ZY:ZIE:
WH^Ri=KFooW]ooooo_ooo?ooo_l6VIVI0P0001>IVIT200000iVIV@800000
0iVIV@000000000HVIVI0P0000:IVIT2000029VIV@800002VIVI0P0003bI
VIT00oooolc<c<c<c01Mc<c<00EZEAiP;a@S9PXJ4Q@S9PX00ULL009P;`X0
1W8V07]<560_56Y12V0_2TH_2P=G7002ARl:00AG70169PXS9PX94PX4ARl:
010m70Y6;`Y6;`X/4P169PXS9PY6;`Xm70Y69PXS9PY6;`X/4P16;`Xm70YP
;`Y69PX2ARl:011Z@@YP;aAb>01P;`Y6;`Y69PX/>2UbSEb`ZXBVV6o:d<7L
hmJES@1ZEAjNLPZ=E@X3WW8:01FVI`2=E@ZEEABNLPZ3GQAkC0YZ@@Y6;`XJ
2@Y6;`YG700S9PXJ4Q@92@X971@J2@XS70Xm70XS70XS9PXd;ah00THV500:
Ea`0LSPDH2lDUD`Y/8AVg;j]/8AVUEDDLSPDH44Y0iE<:@0XUEDD/8eBYW9B
g>?Pi<O1ooooi=3<YUEVm^gZm_oom_Keg;>4i<O1m_Kem_ooooooWW/cWXdY
^IQLUHeBH5hcPg/c`K>>g>?PUIQVSHeB^JY_UHeVH44D^IQL/:Z4g;j]i=3<
^JY_/:Z4YYR4WXAVUHeBdkj>i<O10/[@`@03YZ6HkOKem_oo00;fool02>g7
Q?K@Q?KII^BcAoKII_K7?Nfn?OK77P;T/bT02^Bc<oK77^Bc<m>H2_Jc0>Bc
<oJc0>Bc:NBcAoK77P;od3d00oK@Q>Bc<ooSQ004on>>00OohhCokHkfd8Co
hhkfd8CffFKohh@00_KIIP0:i;<Nm]UVi;=7i;<cbYPD`H@0^HdDNd`:H2l:
8bH:0a4L2P0;6Q8D2@T:PehDkM2HkMW<^JY_WXdY8blN2@TD8a`:6PT:00;o
kL`03?o]S_o]c?o]S_K@Q?KII/ZH5=>H2W]<514V51XB52`L578V00Woool0
0oKomOooooooo`04oooo00?foooLhmKoool01?ooo`03dmWFc<c<c<c<05o<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIV
c<c<VIVI01BIVIT06?kono_lmoomoO_io>gknl3[i4NLRCV[TCRmWSo9Z5G?
]VKC_W?@_Wc@`H;EaHGIbHCKbXOPcX[SdHgTdhkRdXkQdHoRdY3QdP>?h=46
S^7A03B>hLn?h<n>hLn?h<n>hLn?h<n>hLn?h<n>hLn?h<n>hLn?h<n>hLn?
h<n>hLn>glj=h<j>glj=h<j>glj=h<j>glj=h<j>glj=h<j>glj=h<j>glj=
h<j>glj=h<j?h<n>hLn?h<n>hLn?h<n>hLn?h<n>hLn?h<n>hLn?h<n>hLn?
h<n>hLn?h<n>hLn@hM:?h]:@hM:?h]:@hM82Sn;B01Z>h]:=h=2<h=2<h=2:
hM2;gln9h<n;gln9h<n6f/Z4fl^0f<Qie<=cdL5/ckeOa[=D_ZQ9/9]3XXi<
WHbakN7Rooo_oOkooOoonooooOl4VIVI1P0001:IVIT500000iVIV@030000
VIVIVIVI01NIVIT400002YVIV@<0000019VIV@000000000003ZIVIT00ooo
olc<c<c<c01Mc<c<00QP;`XS70XS9PX/4P169QAP;aAP;`YP;a@2H2l:011b
>01Z@@Yb>1AP;`YG70169PYP;`Y6;`YG701P;`Y6;`Y69PXm70X94PYkC0YG
7002H2l:00=69PY6;`Xm70X00R<V2P04ARH:?A`:?A`:ARl:0SdL2P0S;180
ARH:Ea`0H44DH2l:JT4:LSP0JT4:Ea`0LSP0ARl:Ea`08bH:AT4NH5hcJVLc
YYR4b]31bZYVPehDNd40PehDNd`:PehDSED:Pd40LSP0JVLcARH:Nd`DJUDN
Nd`:ARl:2@T:;1`D00969Q@01Q4L2R`B00TB2QX92R<L2PT92P8S70X032`V
54HV54H_2TI17V0_578h078h59E<:JIbD/5kNmbcXk2=DP9b>1@04f0_5611
:F11:JIEI[1kI/5kNnBZV=bn]oKoooooonC7`K24NoKfmNC@c;2=D^gIc?Kf
mOK]j_ooo`02`K>>00JEV6J3Nc>NLS?Tal7C_Xk1al42`K>]00S1/hjESE;C
_Xj`ZXC:_Zg:d<6`ZXCLaj<2`K>>00R3Nc?:d<7CfMK:d<71/hk:d<6EXHkf
kNX2m_oo00GfooGffFK]d9SohhkffFH00^g7G005m[<0m/LNkLMLi;<Ym[<0
00;T/bT03?Jc0>BZ0>Bc:OJc0>Bc7^BcAoK77^g7G?o@?Ng7G>BZ0>g@V0;o
hhh01^g@V?o]S_oSS_oSS_KII_oSQ0;ohhh05oKII_o@?OK7?OK7?OKII^g7
G=bZ<lZH5<640;V=57]<2VY12R`V514L2R<V2Q4L2QX92Q4L2W8h5>C7`Mc7
Xl6cS[V=:@024BHD00<92A@0003]d9P01?o]c009on>4m]UVi;<NbYPDPehD
;2HD4BHN6Q8DEa`000Woool00oKomOooooooo`04oooo00?foooLhn3fool0
1?ooo`03g>?Fc<c<c<c<05o<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01BIVIT06?WonoOln?omookioOSo
olg`jU2HRSjXTBfbTc?0WTK;[US@]fS>^GK=_H??`XWEb87EaH7JaXKMbXSO
c8WNbhSKbH[KbX_Lb`:?gLd2SMk=18cOc@03SMk=SMk;SMk;00f=g//@S=g:
48gNb`J>glh2SN3>0X_Nc0>9g//2R=g:01:9g<b7d<F8dLInd/=cd;iVd;aM
cKM?`ja7^J8kYHm1W8YEWI70ln[[ooo`n_coo?oonoooo_n=VIVI00?oooo<
c<c<c<`0GLc<c08S9PX01CdB2R<V2V0_2THV58eE2P02LSP000Qb>1Ab>01b
9P1P@AAZ@@YP;`YZ@@YP;`X2Ea`000IP;`YG7016;`Y6;`X94PYk@@02H2l:
01:3Nea6;`Y6;`X/4P0m70YG700S9PXm70Xd;ai69PXm70X/4P0/9Q@S9PY6
9QAb>01G701ZEAh2H2l:0dH_2P0:?A`:8bH:AT4NJVLcPg/cSHe7WXdcUHd0
Ea`0JT4:0W]<2P0AWW8:2@TD4BH:?A`:LXdmPg/cPehcARl:H44D8a`:;1`D
Pg/cJUDNARl:8bH:4A`:6Q8D008A70X00b<L2PTB2R<L2P03ARHD00aP@AA6
9QAP;aAP;`Z`@C>`SE;1XHCL/jfVLU9kC1AZEAiP;`X2H2lD00BELTO1XHCT
al7L/j<2kMW<00_fkN[]fLab9P2VQ8CL_[NiLS?Tal7okLcfm_GfoooL/jd0
0ZJHK`03YXAB/:Z4kNgZ00;1/hh05=>nS/6c[KVZKl6cS^C@c:JQI]cSe/ZZ
I]>nSZJQI[2ZQ7]<2ZJHKoK]j]c7Xl6cS]>nS]cSe/6c[McSh0;fool02ngI
c>g7Q?oSQ?oSS^fn?OK7?OK@Q>fn?OK7?NBc:OK77P03i:X000CCV0[faakT
/bWT/bT3m[<000KT/c?faak]aec:XCgffFK]d9P3on>>01KffFKohhkohhkf
d8CohhCffFKfd8Cfacg]aecfacg]aecT/dOCZTO:V1CCV0Z`N`Z=E@YP@AA6
9Q@S70XJ2@XJ4Q@24A`:00eP;aCC_Xk:_Zf`ZXBESE8A9PXA9Q@J4Q@92@[]
ahCfooGokLcfooD00_o]SP08m]UVdj4Yi;<NWW8D;2HD6RHD8blNEa`02Ooo
o`03m_oeoooooooo00Goool00mcSh?K]j_ooo`03oooo00?CfMK<c<c<c<`0
Glc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT059VIV@0Hm?ommOojoognoocoookog?3_Ql2g<i1k9jB69;6>
<kjMDM:dGLNaOMC4X>?JU=K<U^?CSn3=T^7>UnKCVnSFV^CCVnCCWnSG19cU
e0:KiM@00iWVe9WVdY_VdP0_VnKB19cUe0BKiM@06IcYei_XeY_XeY[WeIWX
eIOVdi?RciCLcZ7Je:GPg7c9_gOHafGI`TC3Z472YRJPQbZDOT6EQGbh/>?o
onWhnoOhoOokoooiooono`2=VIVI00?oooo<c<c<c<`0GLc<c003ARHD?A`:
ARHD00969PX2Nd`:01B3>01b>1Ak@@1kC0YP;`YkC1Ab>01P;`Yb9P1b>016
;`YP;`YG7016;`YG70169PX94PYZ@@Yb>01Z@@X2ARl:00=G700S9PXS9PX0
0R<V2P8/4P000b<V2R`B02<L2P02;18000Tm70Y69PY6;`YP;`Y6;`YP;`YG
700m70Y6;`X00R`B000:;2HDAUDY=5DYJT4:Nd40H2l:?A`:ARl:?A`:H2l:
0R<L2P054A`:AUDYJVLcNheVAT4N0096;`X08B<L2VYE7Yj=<fYE7TI17Q4L
2PTB2R`B01XB51X92R<L2R`B02`L52`V54HV54HV2SdL2THV2V0_578h59E<
:KUb<l5kNnBZV=>nSYEE59E<:F0_54HV2S@_:F0_59EN<jJ4Q002kMW<027f
m_Gfooofm_Gfm_GfkN[TZYREC2WL/j?]fLcfm_GooooL_[NNSC>VV6oLhmK1
/jfVV8C1/hk]d9SC_XjNSC>`ZXC:_Zg:d<7Laj>iZVoL_Zg:_ZfNSC?1/hk:
d<6iZVoLhn000[VZK`04`K>>kMW<m^gZi=3<0_ooo`04ong<onf>kM2Hon>>
1?K7?@05i;<cm/Lmi;<Yi;<Nm[<000?CV0X03/ZH5?Jc0=>H2^Bc<nBc7_K7
?NBc:Ng7G>Bc7^g7G?o]S_oSS_oSQ?oSSP;okHh2m]UV00?ohhCffFKfacd0
0_K7?@04kLMLm/LmkLMLg:Xc0/ZH500C^HdDSED:H44DARHD6RHD4A`:2A8:
4BHD2@TDARl:^JY_dkj>YYQ_WXdc4BH:2A`N6Q8D0000g:Xc00;okL`03?Ko
mOo]c?o]S^g7G>Bc<mbZ<l6403@_7QXL7QXV53dB2_o]c0Soool00oK]j_oo
ooooo`04oooo00?fooo]m_GLhn001?ooo`03dmWFc<c<c<c<05o<c<`016IV
IXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI
01BIVIT06?7ooOGonoonoooioogcnoGooj_FccB1LAj>MBFXR3>mW3joXGgY
dX_Od8c;`k;[i:S/gJ;[f:?Zf:[_gJc_gZ[]g:g[g;3^g`B]jm`2[>cL00>Z
kMbZkM^/k=/0;jc/f`B]jm`4[>cL01V[k]fZkMbZkMbZkMbZkmfYk]bVjmVX
i]VTd<neinJPjN28jMQIdKP]/YD//I@YY8PaU80jQ7NWe<oZoookooooo?oo
n?gon?_oo_l0SIVIV@03ooooc<c<c<c<05g<c<`01DHV2SdL2THV2SdL2X<h
0002Nd`:0163@@1k@@1kC0Yk@@1P;`Yb>1Ab>01P;`YkC0Yb9P1P;`Yb>01P
;`YG7016;`YG70094PX00VY12P05H2l:Ea`0ARH:ARl:8bH:00</4P003b<L
2QX92SdL2R`B01X92R<L2SdL2Q4L2TH_2R`B060_2R<V2TH_2SdL2R`B0002
8a`:00LJ2@XS9PXS;ahS;ahdEBTJ4Q@94PX00R<L2P0B?A`:ARH:2A8:6Q8D
2A8:AT`mPehcJVLcSHe7=2lNPg/c0000JUDNPg/c2A`D2@T:4A`:6Q8D0R`B
00044A`:2@T:4A`:ARH:14HV50969PX0460_57]<5;Ub<kUb<l6QQ>BZV;1k
:G8h560_54HV578h560_578h59EE5?o]c?K]jP;fm_D03OKoooKfmOKoom>n
SZI10>BZV>gIc?o]c?Koong@V<6QQ;VZKng]jP03dkj>00G1/hj=SE:`ZXCC
_XkCfMH00m>nSP0A`K>>^JY_YYQ_`K>]kOKe`K>>bZ5Bg;>4g<NSkMW<m_oe
ooooUHAk`LO<m_oom_oekM2H00;ohhh2kLML01OffFK]aecT/akfacgT/c?T
/bWT/akf/`3CV0[TZP3CQ03TZP3CV0[TZP3faakT/c?facg]aecT/dOT/c?o
kHkohhk]d9P00_oSSP04kM2Hon>>m]UVkM2H0_KIIP0KkLMLkLN4m/LmkLML
g;=Lg:Xc^H@DbYPD`H@0PehDJT4:ARHD;2HD6PT:6Q8D4A`:6Q8D?A`:/8eB
g<NSUHeBWXdcAT4N2@T:4BHD6PT:^G8c00?okL`00oo]S_oSQ?K@Q002i;<Y
00J`SAi6@AhA9Q@J4Q@/4P3okL`8oooo00?]kN[oooooool01?ooo`03m_oo
kOKekMW<00Coool00m?Ie/c<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0DVIVI01S`ooo_o_Wo
o_oon_okk_Ooo_oOo?Yb[:0ZQg88NV0VXXHm]IYXckbSmnZTh]f_i^2_jMf[
j=R_jMZck=fejmfcjM^di]Zfj=`4]NOK0[CXf`:cjM/00kCXfkCYfKCYf@0]
]>WI0[GWf`Jdj=/2/NOI01>_j=Vaj]^ck=fbjmb`jMZaiMW5k>^/f]RBfM6<
kMabj]4o`JDKW7hEQFd/P75^Yj3PoO_do_omnol00_omo`03oocmookoVIVI
08bIVIT00oooolc<c<c<c01Mc<c<00A69PYP;`Y69QAk@@02Nd`D00B3>01Z
@@YZ@@YZ@@X2Nd`:00Ub>01kC0Yb>01b>01P;`Yb9P1P;`Yb>016;`X00ULL
000<2@T:LSP0LRH0Ea`0ARl:ARH:;1808bH:8a`:4A`:6PT:8a`:0R`B000:
6Q8D;1804A`:6PT:8a`:;180;1`D;1808bH:;18012<L2P086PT:8bH:;4`Y
;2HD;4`Y4A`:00006PT:0b<L2P0J2A8:4A`:6Q8DJVLcWXdcWXdYH44DNd`:
PehD2@T:H44D;1802A8:2@T:6PT:;1808a`:6PT:4A`:2A8:4A`:?A`:ARHD
8bH:ARH:;2HD0THV500:Ea`0PcP0/44c/8eBg;>4g;>SYW9BPcP0;2HDARH:
0V0_5004UD`Y`G]km^gZm_oo0_K]jP0:m_Kem^gZkMW<YW9B^G8ci:ZHkMW<
m^gZm_Keg>?F0[VZK`09i=3<`K>>`K>>`K>>UIQVWW/c`LO1b]31i=3<00;C
_Xh02=c7Xng@V:JHKk2ZQ=c7XmcSh=c7Xng@V0;:d<401<77`Mbn]oKooiEb
A`;oool02^g@V?o]c?o]S_KII^g7G?KII^g7G?K7?NBcAoK7?@;]_Sd01>Bc
<nBZ0=>H2^BZ00?CQ0001m>H2^BZ0>Bc7^Bc7_K@Q>g7G<ZQ?@04on>>00?f
fFKohhkohhh00oKIIP03kLMLm/Lmm/Lm00;]ae`02Nfn?MbcG=>H2/ZH:KV4
59ib56Y12TH_2QXV50034A`:01TJ2@XA70ZNNc?C_Xj=SDNNSC=6;`X971@A
9Q@92@ZNGQCokLcokHkokLcohhCokHkfd8CT/dOT/c>iSBUP@A@92A@J9Q@/
4P3L/j<02?ooo`03i=3<oooooooo00Coool00oKoongfmM?IeP04oooo00?C
fMK<c<c<c<`0Glc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;P4c<c<00=VIVK<c<bIVIT059VIV@0Hl_ool?choooooocooo?loogom?oo
c?G_Eij@981[7HA_>jF?GK^[T>;FSM39Z>?M[NOK[nOJ/NWL]>[M]NWM]>KK
]^GK]nKL1KSWg@:fj=d3]^SL02bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bh
j=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bf
j=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bh
j=bfj=bhj=bfj=bhj=bfj=`2^>SL0kSWg@Ffj=d06KCVfk?Wfk?WfkCZgKK/
gkG[g[?Yg;;Ug:SEd[3Th:Saj7_IbDZlYC2XSAV9LAMfHV>UVlWbk_Coooon
ooC^l_khn_onoOoooOooo`2=VIVI00?oooo<c<c<c<`0GLc<c005ARH:ARl:
Nd`DSED:Nd4000:3@@001g]<2W8V08=107]<2W8h06Y12W]10002JT4:00Eb
>01P;`Yb9P1b9P1G70000TH_2P0;4BH:ARl:H2l:ARl:ARH:8bH:;1808a`:
;1808a`:;180008J2@X01A4L2QX92Q4L2QX92Q4L2P026PT:00@S70XJ2@XA
70X/4P028a`:00@J2@X94PXA70XS9PX3;2HD00@94PXA70XA70XS70X26PT:
00<A70XJ4Q@000000VYE7P0BPg/cARH:bZ5BJT4:4BH:8a`:6PT:2@T:4A`:
;1806Q8D;1804BHN6PT:2A8:8a`:?A`:8bH:0R`L500=?A8:?A`:?A`:ARH:
LSPD/44cYW9Bi:ZHg;>S`J64/7/Y8bH:8blN008/71@03IE<:L6QQ>gIc?Ko
ongIc?K]j^gIc:JHQ9EN<kUb<nBZV>gIc?o]c002m_Ke00?oooniZVo1XH@0
0]>nSP0>g<NSdkj>PehD`K>>b[j]b]31b[j]g<NSb]31dkj>b[j]YYQ_i=3<
b]310^C7`@07g>?FkMW<SHeBg;jgg>?Fm_ooWXAV00;fool02?o]c?o]S^gI
c?KII_K@Q?K7?OoSS^g7G0;ffFH01>g7G?K7?Ng7G>Bc7P;CV0X3dh@00[UW
0008/5D0dh@0kKhmdjY7^Hdconf>ong<m]240_KIIP06kM2Hm]UVm]24kM2H
m]24m]UV1>fn?@;T/dL3bYPD022NLPYZ@@YZ@@X/71@A70XJ2@XA9Q@A70X9
2@Z3GS?C_XjESE:=SDLdEBTA70XA9Q@A70Z3;`3okLcokHkokLcfd8C]d9Sf
d8CT/dOT/aj`SAiZ@@X971@S9PXJ2@[]ah@8oooo00?]kN[fooGoool01_oo
o`03`K>]oooooooo00;oool00mcSe/c<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0C<c<`2IVIV00?<c<bIVIVIVIT04YVI
V@0EnOoonooooooooogooocomoGjl_[mk_ooeoomBHMl;WM/>heoJ[jaL<:f
Yo;[T]S@VmgAX^3CYN?FYn?GZ>;F00:YhMH01:_PeZcQejcQejcQe`:Zh]L3
ZN?G02jZh]NZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZ
h]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/
h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZ
h]F/h]FZh]D2[>;E0jcQe`BZh]L05:WSejSReZSReZSReZOSejSTf:OSejCP
e:7Oe9gJdY?FcHoOdWWD`df`W2N8MBIjJdN;P=?mnO3ooo?fn`;ooOl01?ol
nocnnO_on_kooHfIVIT00oooolc<c<c<c01Mc<c<01969PXm4PZ3GQB=E@Yk
C0YZ@@YkC0Yb>1B3@@1k@@1kC0Z3>01kC0Yk@@1b>01kC1Ab9P1b>002H2l:
00EG701P;`YG700J2@YP;`X00ULL000=ARl:ARHD;1808a`:4A`:6PT:4BHD
6PT:2@T:8a`:4A`:6PT:2@T:008A70X00aX92Q4L2R`B00028a`:00TA70XJ
2@X94PX/4P0A70XS;ahd;ahS;ahJ9Q@00PTB2P044A`:6PT:8a`:6PT:0Q4L
2P036Q8DWXdcARl:00:3Nc<00k2ZQ6YE7R<V2P024A`:00PS70XA9PX94PX/
4P0A70XJ2@XJ4Q@92A@38a`:01d/71A6C3e69Q@m70YP;aA69QB3;`2EC2V`
NbWC_XkL/j?1XHB`NbUG700J9Q@/71@d;ajEGS?TZYSfkN[fooookLcTd<b`
NfJ`@C>iLS?TZYSTal7]fL`00_K]jP04m_Kem_oe^JY_^IQL0m>nSP0I^JY_
`K>]dkj>dmWFdkj>dmWFb[j]g<NSb[j]i=3<b]31i=3<b]31`K>]dmWF`K>]
UIQVWXAVYYQ_LVMBYYR4g;jgoooom_ookM2H00;okHh01?K@Q?KII_K@Q?K@
Q0;ffFH01OK@Q?KII^g7Q?oSS^g7G002i;<Y00G:V1CCV0[CQ02iI`3TZP00
0^Bc:@03m]UVkKhm^H@D00?okHh02Ng7Q?oSS_KII^g7Q?KII_oSS_K@Q?K7
?Ng7G002kKhm00?]aec]_SgL/e`00/ZH5006/8dNWW8DNd`:ARl:;2HD4A`:
0QXB508A70X02h=N<kVZKhf=Ah=k<c@_7Q4V2QXB514V578V0?o]c>g@V002
m]240_KIIP;CXBT01[V=<f1150T951XL7PT95=>ZA`Soool00ng]j_KomOoo
o`04oooo00?fooooooo1/jd01?ooo`03g>?Fc<c<c<c<05o<c<`016IVIXS0
^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c004IVIVc<c<IVIVc<c<
4iVIV@0HnoWlookoo_komoOiookoo_ooloKkmoool?ooh_ooD85m=W=/=Gie
H;2UE:NMRMg@P<k1R]C7T=[=TMW=TMO<UMW>U][?UmW?0iCFc0:Cel`3TMO<
0Y?GbP0aU=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:
TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:
U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:
TmO:U=K:TmO:U=K<TmO<U=K<00BCel`0197Gc9?IcY;HcI;Hc@:AfLd0593H
c8gEbHOCaWk>`Fk2/f6hZ52WUb=gJ1IPDfJRV]7kmo3oooKkooomoo_bmoom
oooono?jl_WonokooHfIVIT00oooolc<c<c<c01Mc<c<0W8h500BPehDPd40
JT4:JT4:Pd40PcP0JT4:SED:Nd40Nd`:Pd40LSPDNd`:LRH0Nd`:H2l:LSP0
LRH00V0_2P0:Ea`04A`:H2l:H2l:Ea`0H2l:;180ARHD;1808a`:0R`B0007
6PT:4A`:4A`:6PT:;2HD4A`:6PT:008A70X041X92Q4L2R`B00T92R<L2R`B
00T92R`B014L2S@_7R`V51XV514L2PTB2Q4L2QX92P8S70X05a4V2QX92QXV
514L2YF=DW]<2VYW<l6cS[VHG8=k<b<V2Q4L2PTB2R<L2PT952<L2R`B00TB
2Q4L2PTB2Q4L2R<L2R<V2P028a`:00DA70Y69QA69QA69PYP;a@00W8h500?
WUhD`J64i:ZH`J64/8eBARl:;2HD?A`:Ea`0YW9Bi<O1ong<m_Kei:ZH`G]k
00:iLS<06>BnQ=bc[NgIc?o]c?K]j_KfmOKoonC@c<6QQ;2=<l6cS/6c[JJH
Kl6cS_Koom?Ie/77c=cSh<[@`NC@c<Zn[L[@`McSe^gfm@;:d<404<Zn[McS
e[2ZQ;24I[2ZQ=c7Xl[@`McSh?ooooKomOKoong@V?o]c>gIc?KII^g@V0;f
fFH03?K@Q>g7G?KII_K@Q?oSS^g@V?K@Q?KII^BcAoK7?Ng@V?K7?@;]ae`0
2^BcAng7G=>Q:KV4:Iib2_oSQ>gIc?o]S_oSQ>g@V0;ohhh02?K@Q?oSQ?K@
Q?KII_K7?Ng7G?K7?Nfn?@;T/dL01lZH:KV=5<ZH59ib57]<2V1152<L2P02
4A`:01XA9Q@J4Q@94PYZEAjiZVnVXFJESE96;`XJ9Q@971@J4QAb9P3ohhkf
fFKfd8Cohhk]aecT/c?CXBW:V2V`SAiP@A@92A@A9PX92ABiLS<8oooo00?]
m_G]fLcoool01?ooo`05m_ooooooYZZSm^gZm_oo00;oool00m?Ie/c<c<c<
c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
1FIVI/c<c9VIVFIVI/c<c00BVIVI01SomOcoo?ono_oho_khoooiooolooon
ooogn_ogoooZoomVT8m>S8LSLfPaSH0mWi1A[imK]jQR_ZmS_ZmU_JmZ`;=/
`[E^`[D3Jknb0VVo/P9X`;80=6Vo/VW0/6W0/6^o/6W0/6^o/6W0/6^o/6W0
/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o
/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0
/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/VVo/V^o/PAY_k80
16S0/V[2]6W1/fS0/P9W`[<04FK1/V>n[ejl[52fXD^aVbF2KaU/G3IjKg^`
Z]Oin_;oooCgo_[cnookooS_l_[imocon`02n?oj00?loofIVIVIVIT0RiVI
V@03ooooc<c<c<c<05g<c<`056Y12W8h08=N58eE2THV2W8h08=1078V08<h
08=108eE2X=107]<58=107]<2W8h07]<2W8V07]<2W8V00=P;`X0314L2VY1
2W]1078h04HV55LL02`B02<L2R`B01X92R<L2Q4L2P8J2@X02a4L2PT92PT9
2QX92PT92R`B014L2QX92Q4L2R<L2PT92P028a`:0Q4L2P03;2HD4BH:4A`:
00892@X00`TB2QX92Q4L2P02;18001<971@S70X0001ZIc>3Nc=PGS?:d<6`
ZXBEV6IkC0X94PXS70XS9PX/4P0A70X/4P092A@92@XA70X00R`B00<S70X0
0aX92R<V2V0_5002H2lD01BEC2VEGS>EC2V`SE;1XHB`SE:EC2Tm70X/9Q@J
9QAP;`[1Ng_okLcfm_Gfooo1Ng_:ZVKL/hCTZYSL/jd2ong<00[fkN[fm_Gf
m_GfooG]fLcC_XjiSC?:ZVKTd<c1/hh2kNgZ00OLaj?1/hkLaj?Td<b`ZXC:
d<7fooD00]cSeP05`K>>b[j]b[j]i<O1/:Z400;:_Zd02JJZXmbn]ngfmOKo
ooK]j_KoonBcAoo]c?o]SP04m]UV00?]_Sg]aecfd8@00oK@Q004kLN4kKhm
kKhmm]240^g7G00Em]UVi;=7kLMLi;<Y^H@DYT40UEDDong<kMW<onf>kM2H
ong<kMW<ong<kLMLm]24kLN4m]UVi;=7kLMLi;<c00;T/dL05]bcG<ZH:KV=
5;V4:JIb06YE7VY12R<_7Q4L2QX92Q4L2PTB2QXB54H_2/ZZIXf=DXf=Ab<_
7QXV50TL51XB53dB2P;ohhh03OKII^g7G?K7?NBcAmbZ<jIb58eE2X=N50TL
51XB514V59iN5?Koo`07oooo00GfooGTd<coooooooofool00_ooo`08m_oo
oooo`K>]g>?Poooom_oooooog>?PHLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P4c<c<00IVIVK<c<bIVIVIVIUVIVK<c<`AVIVI01So
n?oomOcooooioooboooaoOgloooooOonn?okn_oeoooYoooEoon^o_<lW8hR
SG/>MF@HOfhQQWHRQgLUQGLZRW`_SGl^S7h2<8ao0Rn=O`@]SGl`;hem1Rn=
O`@]SGl05b^=ORb>Obf?P2b>ObN<O2:<N0UiHAZ8Kd6RSZcmk]GoomKnoNoo
oo_ooookooojoo[]m_oloooooOKmmOOon_KonOcoo@2=VIVI00?oooo<c<c<
c<`0GLc<c006Pd40SED:Nd40Nd`DPd40Nd400g]<2P03PcP0Nd`:Pd4000:=
E@X01G]<2X=107]<2W8V078h0002H2l:00Mb9P23;`0J4QAkC0Z3@@1b>1AZ
@@X00THV2P03;1808bH:8a`:008/4P002AX92PT92QX92Q4L2QXB514L2QX9
2Q4L2QX92P022@T:0R`B00044A`:2@T:6PT:6PT:0Q4L2P0E2A8:4A`:2@T:
2@T:6PT:;1806Q8D2A8:2@T:4A`:6PT:H44Y/8@Y^IQLYYQ_YZ5V/8eBWXdY
2A8:8a`:;180008J2@X01R<L2Q4L2Q4L2Q4L2QX92R<L2P8/71@01B<L2R`L
514L2THV56YE7P02H44Y00nEGS>3GS>EC2VVQ5:NNc=P@BTS9PXS;ah/71Ab
>1CL_[Ofm_Gfooofm_GL/jd00nBZV003g;jgong<m_Ke00?fm_D03_KoooK]
j/Zn[KVZKkVHG>g]j/6c[OKook2c]lZn[Mbn]ngIc:JQV;2ZQ0;]m_D05/77
`L[@`L[@`NC7`K2ZQ=cSe]bn]l[@`L77`NC@c=cSe_KfmOooooKoooooonBc
:Oo]S^g@V?KII^g7Q?K7?Ng7Q0?]_Sd3kLML0nfn?@0;m]UVkKhmkLMLm]UV
kLMLkKhmdh@0/4`0/5D0SED:ong<00?ohhh01Ng@V?oSS_oSS_oSS^g7Q002
on>>0^g7G00XkKhmi;=7i;=7g;=LbZY7^H@DbYPDWXdYLSP0H44D;1`D4BHD
6Q8D2@TD4A`:2@T:8bH:`K>>SHeBPg/c8blN6RHD6PT:4BHD;180m]UVm]24
m]UVi;=7m/LmbZ4mdj4Y^H@DWW8cNd`D2@TD6RHD4BHDLRH0m^gZ1oooo`03
m_oob]31m_oo00Coool01?Kooooool77`McSeP;fool00oooomcSe/c<c01P
c<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIV
I/c<c9VIV@02VIVI00=VIVK<c<c<c<`0olc<c0k<c<`00oooolc<c<c<c01M
c<c<00UkC0YkC1B3@@1kC1B3@@1k@@23>01kC0Z3>0000h=1000>SED:PehD
Pd40Pd40PcP0Nd`:Pd40Nd40LRH0H2l:Pbl08a`:JT4:SED:0VY12P06H2l:
ARl:;180?A`:;1808a`:0aX92P034A`:6PT:2@T:00892@X02aX92Q4L2PT9
2Q4L2PTB2QX92QXB50T92Q4L2QX92R`V50034A`:0PTB2P044A`:2@TD2A8:
2A8:0Q4L2P0:2@T:;3PYPg/cPg]LYZZSUIQVUHABPg/c2A8:4A`:0R<L2P05
4A`:6PT:2@T:2@T:4A`:008J2@X042<L2R`V53dL2THV2TH_2PT92Q4V52<L
2VYE7Yik<k24I[1kIYEN<g8h53@_7QXV508/71@02h<_0>gIc?KfmOKfmOoo
ombn]mbc[NBnQ=bc[NC7`NgIc002m_Ke01kfooofm_Gfm_G]fLc1/hjiV5c:
XE;]m_GL_[O:_Zg1/hkTd<c:d<7LhmIbIe;:d<7:d=K:d<7:_ZgCfMK:d<71
/jfESFK]m_G]kN[LhmJVXFIbIe:VV8BVZZ<2m_oo00C]m_GT/bWokLcohhh2
m]2403c]_Sgfacg]aec]_Sgfacg]aec]_SgT/c?]aecfacg]aecffFKfacgT
/c?T/dOT/c?T/dOT/aj`N`ZV@@23;`3okHkohhk]d9Sfd8CokLc]aecohhk]
d9Sohhk]d9S]ahCffFK]aecT/bWT/akLZS?L/ec:V1BiQ1C:V1BNLQAb>1Ak
C0XS9PXS70X92A@/4P0J4Q@J2@XS70ZVV6n3Nc>ELTM6@AhJ9Q@A70XS70XJ
2@[od3d2m]UV00ST/c?]aecT/akCXBViQ1BNLPZ3GQ@92A@26Q8D00<m4P[]
d9Soool01oooo`03b[j]m^gZm_oo00;fool00oooooKoooooo`02b]3100C]
m_GfoooooooCfMIQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^0C<c<`00fIVI/c<c9VIV@03VIVIofIVIQ1VIVH00oooolc<c<c<c01M
c<c<00V3@@2=E@Z3@@23@@23>01b>1B3@@23>023;`000W]10005SED:LSPD
UED0Pd40Nd`:00:3@@02Nd4000Qb>01b9P1P;`X/4P1kC0Z3@@1k@@1b>002
H2l:00<S9PY6;`XS9PX00R`B00046PT:2@T:8a`:2@T:0Q4L2P036PT:4A`:
2@T:00<92@X0314L2R`B014L2R`B014L2R`V52<V2R`L514L2PTB2PT92QXB
508J2@X02A4L2QX92R<L2R`B03@_7Xf=KjJQV<6cSZJHK`02`K>>00</4P0S
9PXA9PX00b<L2P044A`:2@T:4A`:4A`:0b<L2P0K8bH:H44DH2lDARHD4A`:
6Q8D;1`DH44YPehc`J64YZZSH44D6RHD6Q8D;1`D;180YUEVkMW<kNgZm_Ke
i=3<i:ZH`G]kg;>4i:ZHg;jgkMW<00;fm_D02?KoooKfmOKfmOKfmJJQI/6Q
Q=>nS^g]jP:`ZX@2b[j]00FVZZ?]m_FVQ8C:_Zg1/hh00/Zn[@;1/jd08NC@
c:JZ[NgfmK2c]iFQSYF4D[2ZQ=bn[Ng]j_KoooooooKomM>Q:Oo]c>g@V>g7
G?KII^fn?Ng7G?K7?NBcAnfn?OK@Q>g7G?KII^g7Q>g@V?K@Q?oSS^g@V>Bc
<ng7G<ZH5002kKhm00?ffFKCQ02EE@000_oSSP06m]24kLN4on>>on>>kM2H
m]240_oSSP0[m/LmkLN4kKhmkKhmg:Xcg;=LdjY7bZ4m/7/DbZ4mWXdYPehD
JT4:;2HD8a`:6Q8D2BHY4A`:2A8:;180UIQVPg/cJVLcAT4N4BHD6PT:2@T:
;180i;<YkLMLm/LmkLMLi;<c^HdcbYPY/8dNPehDNd`D4BHD2@TD8a`:6Q8D
i;j400Soool01L77`McSe_KoooKoooooo`02m_oo00?oooo:d=K:_Zd00_Ko
o`03oooodmWFc<c<063<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c003IVIVc<c<VIVI0?nIVITCVIVI00?oooo<c<c<c<`0GLc<
c00CNd`DLSPDPcP0Nd`:Pd40Nd`:PcP0Nd`DPcP0Nd`:SED:Pd40UED0SED:
Nd`:Pd40UED0Pd40UED000=k@@001H<_02<V2VY12YEE08=10002Nd`:0ULL
0006?A`:;180?A`:4BH:8a`:;1800QX92P03;1806PT:4A`:00892@X00`TB
2Q4L2Q4L2P026PT:00@A70XJ2@XJ2@X/9Q@36RHD00<J4Q@971@A70X00R<L
2P078bH:8a`:8bH:8a`:AUDY/:Z4YYQ_00:`ZX@00iF=IZJZXb`B00038bH:
0R<L2P052@TD4A`:2@T:6PT:4A`:008S70X01aXB54HV560_560_51XL7R`V
52<_7P02000000SLhn2`Q7^3GS</9Q@J4Q@/9QAG703C_Xh2m^gZ00O]fLcT
al7C_XkC_XkL/hCL/jgL_[L00_o]c006m_Kem_oom_Kem_ooong<YYR40/6c
SP0Xg;>Sg;jgi<O1b[j]`K>]g>?FkOKeb]3FYZZSb]31g>?F`K>]JW9Lg>?F
kNgZ`LO1/;>gUIQVYYQ_JVLcm^gZYZ6Hi=3<m_oem_ooi=3<i;<cong<m]UV
on>>kLMLkKhmm]24kLMLm]UVkLMLkLN4m]24kLMLkLN40oK@Q003on>>kKhm
m/Lm00;T/bT02nBZ0?K7?Nfn?M>Q:NgIc?K@Q?oSS^g@V?oSS]bcG?oSSP02
kLN400C]d9SffFK]ahC]ae`2i;<c00_LZS?:XCg:V2V`NaBiQ2V`SAib>1AZ
@@Y6;`XS70X92A@00a4L2P0:6PT:SHe7Pg/cPg/cAUDY4A`:4BHD4A`:6PT:
diP:0^Bc<`09i;=7m/LmbYPY^H@Y/7/:UEDDLSPD2A`D4BHD008J4Q@00lZQ
D_KomOooo`06oooo00?1/jgCfMK]m_D00_Koo`09oooom_oooooob]3F`K>]
m^gZkNgZoooob]3F067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c003IVIVc<c<VIVI01VIVIT2oooo1Oooo@0:ooooo_kno_oo
o_kom_Gjm_Gkk^gehN3XgMgUem[Q0]KKg`?Ef]h2e=WM2MGJgRoEf]d?eM[N
00WEf^3BfN?DgNKNiNgZkoGbmO[fn_gmo_ooool00_ooo@;oo_l5ooooR9VI
V@03ooooc<c<c<c<05g<c<`01G]<57]<2W]<2XeE2YEE0002Nd4000YkC0Z=
E@Z=E@Z3@@1kC1B=E@ZEE@2=E@Z3@@2EE@02Pd4000N=E@Z3@@1b>01P;`YG
701Z@@Z=E@X00X=10004LSP0H2l:ARl:ARH:0SdL2P05;180ARl:8a`:;180
2@T:00<J2@X34A`:0QX92P8A70X071X92Q4L2R<V2S@_:A4V7R<_7R<_:A4V
2PT92TI17TH_2R`V54HV2R<V2QXV52`L514L2Xf=Kl6c[McSh:JHKjJZ[Hf=
AdH_2R<_7Q4L2R<L2PTB2P8A70X00`T92PTB2Q4L2P026PT:01DS70XA70Y6
9QAP;aA6@Aj3;`169Q@m4PYP;a@/4P3foon3Nea6;`Xd;ah971AG702EC2WL
_[Ofm_G]fLcTd<`00l6QQ004g;>4g;>]i:ZHi<O10_Kfm@08m_oom_Kem_oo
ong<WW8c`K>>YZ5Vdkj>0/Zn[@03YZZSg>?Pb]3100;:d<400nC@c<[@`M?I
eP02YZ6H00kCfMK1alb`/kO1/jg:d<6VZZ=PGS?oooo1alc]kN[]m_Gfooo]
fLcTZP02kM2H00Wfd8C]aec]ahC]aecfd8C]aec]_SgffFK]ah@00^g7G009
m]24kLN4m]24kM2HkLMLm]UVi:X0i;<YbYPD00:iI`000k1k2^g@V?oSSP02
kM2H01oohhk]ahC]d9S]ahCffFKohhk]ahC]aec]_SgT/dOLZS?:V1CCXBVi
SC>`Q2ViQ1B`SAikC1AZ@@Y6;`XA70XJ2@XA70X92A@J4Q@0002=SDN3Nc=Z
Ic=6@AhJ9Q@00aXB500@bYPDi;<NkLMLi;<ci;<Y^H@Y^H@D/7/DPehDNd`D
2@TD4A`:6Q8D4BHDWW8cm_oe1Oooo`06m_oooooo`LO1g;jgkNgZm_oe0oKo
o`07ooookNgZYZZSm^gZkNgZoooodmWF067<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01VIVIT4oooo1?ko
o`0:nocnnooolO;gh>?Zg=oVeMSQb/gFa/[E^/7;^<7:0[O0b@04][o8]Kk7
];g6];g61kO0bC6g`<L?]l3900Zg_lZj`m:namK7cmc@fN;Gg^CQi^[`m?Gl
ooonood2ooom00?oooooo_ooo_l00_ono`03ooooVIVIVIVI08JIVIT00ooo
olc<c<c<c01Mc<c<00IkC0Z3@@2=E@Yb>02=E@Z3@@02SED:00>3@@2=E@ZE
E@0019EE0004Pd40UED0Pd40Nd`:0X=1000@PcP0Pd40ARH:JT4:UED0Pd40
Nd40Nd`:LSP0Ea`0ARl:?A`:ARH:?A`:;1808bH:1B<L2P<J2@X01@T92Q4L
2QX92R<L2R`B00028a`:00]?IdM6;`XS9PXS9PY6C3fEXHi6;`YP;`Y6;`Xm
70XS9PX00R`V500:4BH:`K>>UJ6>UJ6>b]31`LO1PehDARl:6RHD8bH:0R<L
2P0U2A8:4A`:4A`:2A8:6PT:8a`:4BH:4A`:8a`:6RHDARHDJUDNPehcWUhD
UHAB/7]V/8AVYYQ_YW9BNd`D;2HD?A8:UD`Y`G]kkMW<kNgZm^gZYZ6HWW8c
`G]k`J64kMW<i<O1g;>]g;jgkMW<ong<00;fm_D02oKoong@V:J4D]bcXjJ4
D/6cSZJHQ=cSe/6c[L77`L6c[@02b]3100B`/kO1alc:d<7:d<43`LO<00gT
d<bEZZfEZZfVQ8BVV8CLhn3]kN[fooo]m_Goooo]d9S:V1C]ah@00_K@Q009
m]UVkLMLm]24kLN4kLMLi;=7kLMLm]24kLN400?]ae`02_KII]c7Xng7G>g7
Q>Bc:Nfn?Ng7G>fn?Ng7G=bZ<`;]d9P02?oSS^g@V?oSS^g7G?oSS^g@V>g7
G>g@V0;]ah@01nBcAnBc<mbZ<m>Q:MbZ<lZQ?K1k2P02/8dN00AZEAikC0Xd
;ahS9PX44A`:00X94PYZEAj=SDMZIc=6@AhA9PXA70X971@J2@ZiLS<2i;<Y
00o:XCgLZS?:V1BNLS>NGQAb>1AP@A@A9QhA70XA9Q@92AB=E@[okLcfooGo
ool00_Koo`?oool00l77`L6c[Ng]jP05m_oo00K]m_FVXISLhn3]kN[foooL
hn1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
0fIVI/c<c9VIV@0IVIVI1?ooo`?nool02_cooo7dnNkcnM[Nil;9dK[1bk:i
`jR^^ZB/]iJR[P:DXZd01I:PZi6OZY2NZHnMZ8jLY`09SifX02f?WJJ?WJR?
WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?
WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?
WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJH02XnMZ0N@
WZT02Y2NZi^X^In/_JNc`jjja[K0bL;;d=SPh^cbl_coo`;nool01?ooooon
ooonooomo`;oo_n8VIVI00?oooo<c<c<c<`0GLc<c004Nd`:UEDDPd40Nd`:
0XeE2P:3@@001heE2YEE09ib2YEE09iN58eE2Yib2P05UED000b3@@1kC0Z3
@@1P;`YZEAjNLPZEE@23@@1kC0Yk@@1P;`YG7002ARl:0THV2P078bH:8a`:
;1806Q8D;1808a`:8bH:008S70X00`TB2Q4L2SdL2P028a`:00<m70XS9PXd
EBT00UMEDP0DUHB>YZZ]g>?P00002A`D2@T:2A8:4A`:2A8:2@TD=2lNYYR4
SHe_ARl:`LO<UHAkWXdcARl:8bH:8a`:0Q4L2P036PT:4A`:6PT:00892@X2
6PT:0R<L2P0I6Q8D4A`:?A`:Pehc/8eB/8Ak`J64g;>S`J64`K>>Pehc;2HD
SED:`J64g;>]m^gZkOKei=3</8AkJUDNH44YPg]Lb[j]m^gZm_Ke00;]fL`0
2?K]j_KfmOKfmOKoombcXiib<iik<kUb<`;:d<44`LO1016VZZg1al7Lhn3]
kN[:_ZgL/j?C_Xk:ZVKCXBW:ZVK:XE;]aecfd8AGSHjEXHkTd<c]kNX00_Ko
o`05kLN4diP:kLN4kLN4m]2400;]ae`01_K@Q?KII^g7G>g7G=bcG?K@Q0C]
ae`04nfn?OKII^g7Q?KII^BcAoK7?NBc<oKII^g7Q>fn?NBnQ?oSS^g@V?oS
S^g7Q?oSS^g@V?oSS_KIIP02m]240^g7G00=i;<NbYPDbYPYbYPYbZY7/8@Y
/8dN/8dcNd40Nd`DARl:6PT:4A`:008J2@X01aXB50T92X=N<hf=DX=k<dI1
7R<_7P026Q8D01D92ABVC03T/bWT/ak:V1CCXBW:V1B`NaBVLQAb>1Ak@@0A
9Q@J4Q@A9Q@A9Qib9P3fooG]kN[fooooooofool00oooo`04`LO1`K>]g>?F
kOKe0oKoo`07oooom_ooYZ6Hg>?FkNgZoooodmWF067<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01VIVIT0
1?oooOgln_ooooooo`;nool03_cooo;goMWPj<WBfkNobZRb_9bV/XbHYX:>
W7^;V7^>W7N=VgF;VG67U@9]Pi400fn5Tg67UFn5T`08KhFC02e_QI9_QI=_
QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_
QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_
QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI802fn5T`0F
L8JDKhFCKXBBK8:@KXBBLhVGMhbMNHVPO8bSP96UR9RXUJ>`Y[>l^lK:b]CF
h>SZlOOgo_oooooooO_no_cooogo0_onohRIVIT00oooolc<c<c<c01Mc<c<
0XeE2P05Pd40LSPDUED0SED:WUhD00:EE@0018eE2YEE09EE09iN50>EE@00
19EE59EE08eE2YEE00>3@@001f0_2W]<2ZIW09ib2YEE58=1078h0003H2l:
00AG7016;`Y6;`Xm70X28bH:0R<L2P0?;180ARHD?A`:;1808a`:Ea`0?A`:
ARH:?A`:ARH:6Q8DAT`mH5hcNheV/;k100;CfMH00dH_2VYE7R`B0002=2lN
01092A@A70XS;aj3Nc=ZLUb`ZXBEQ7^`ZXAP@AA69Q@S9PXJ2@Y6;`X94PXA
70XJ2@X44A`:01dS70XJ2@XS70X/71@J9Q@/9Q@J9QA6@Aj3GS>=SDNEQ5:V
V6n3GS=kC1BEC2V`Q7_L_[OTd<c]fLcfoooL_[NiSC>3GS<92A@S;c?Lhn3C
fMKLhn3]kNX00_K]jP;fm_D03?oool6QQ;VHG<ZZAl6cS[2c]nC@c<6c[JJZ
Xk2n`McSh<77c0;:d=H2kOKe013fooooooofoooLhmK]d9STZP3T/c?od3d9
2@ZEQ5;Lhn3fkN[fooo]kN[L/ecT/bT3kLN400[]_Sg]ahC]aec]d9S]_Sg]
aecT/dO]d9S]ahCT/c<2kLML00ST/c?]aec]aec]ahC]_SgT/c?facg]ah@2
kKhm00C:ZVKohhk]d9S]d9P2m]2401c]ahC]d9Sfd8C]ahCfd8CffFK]_SgL
ZS?CXBW:V1CCXBViSC>iSAB`NaBNSC>NSBUP@AA69Q@S9PXJ2@X/>2T92A@A
70X92@YZIc>=SDMZIc=6EBT34A`:00TA9QB3;`3T/c?:V1CT/akCQ03CXBV`
LP2NGQ@00W]<50056Q8D4BHD4A`:;1`D?A8:00;okL`00oooooKoooKoo`03
oooo00K:d<6VZZ?Lhn3]m_Gfooooool2m_oo00KooonEV:?]fLcfkN[foooL
hn1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
0fIVI/c<c9VIV@0IVIVI01SooognoO_oooooooojnoogn_o_m?[Mi>k@f>>n
b]RX]/>AXK1mSYi]OY1TMhQRMhQNN8UNNHYONX]NNHYLMhQKMXMLMhQMN8T9
FgJ702eKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEK
MXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMK
MhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEK
MXMKMhD00U]fQ`QLMhP015YeQUagR5ehREagR09JMHH04eagR5mjSFZ0V5mc
S5eaRFb1U86DXi2R[Z>d_;K3bLKAeMgUj??hnokoooooooonoooloogko_on
o`28VIVI00?oooo<c<c<c<`0GLc<c007SED:YVL0Nd`DLSPDWW8:Pd40SED:
00:EE@001heE2Yib2XeE2XeE2ZIb09EE08eE2P07UED001=Z@@YkC0Z`NaB`
N`ZNLPZEE@1kC0Z3@@1b>01Z@@YP;`Y69PYG70169QA6;`X/4P0S9PXm70XS
9PX00SdL2P0;ARH:8a`:ARH:H2l:ARH:H2l:ARH:;2HDEfMBJW9LJW^400;:
d<404G9WDVYW<l6c[K2ZQ9FHIZJHKfY12P0008=k<jJZXl6cS/6c[K2ZQ:JQ
V6YE7TH_2R<V2P028a`:00PA70XJ2@XA70X92@XA70X94PX92@XA70X38a`:
01</9QA69Q@m70XS9PY69QAP;aAb>1BEGS>NLS>VV6o1/hkL/j?L_[OTd<cT
al7fkN[]fLc1XHB`NbT00W8h5007Y/OPg;jg`G]ki<O1kMW<m^gZm_Ke00;f
ool08k1k:Ij4I[24I[VHG9iN5;V=59ib57]109E<:H=N561158=N<f1156YW
<g8h59F4DZJHQ<77c>gfmOooooK]j]>H2_K7?B<V2ZJHQ>g]j_KfmOKoooK]
j]bcG>Bc<ng7Q>g7G?KII^BcA`02kKhm00Cfd8C]aec]_SgT/dL2kLML0nBc
A`06kKhmi;=7m]24kLMLm]24kKhm0^g7G007kKhmkLMLdjY7kM2Hon>>kLN4
m]2400;]ah@01ooSS^g7Q?KII^g7Q>g7G=bcG>BcA`02bYPD023:V2W:XCf`
Q2V`N`Z`SC>3GQAkC0Y6;`XA9PXA70XJ2@XA9Q@J2@X92@YZEAjiV5aZIc=6
@AhJ71hA9Q@J4Q@A70Yb>1CT/bWT/akCV0ZiSC?CQ02`NaBVI`1P@AAZ@@X2
4A`:00DJ4Q@A70XJ2@[okLc]fL`01OKoo`05oooob]3FUJ6>kNgZkOKe00?f
ool2oooo00FVXISLhmKLhn3fooGLhmH0HLc<c004IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT06IVIV@0Coogjno[f
o_kloooooOkomocoinkhd=[V/Kg=VJViOi6UMHZONY2UQYneUK35W[[?_=__
_n3aa>Gf00;7j?T00lGVmlCUm/CUmP09a>Gf02g4iOC4iOK4iOC4iOK4iOC4
iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4
iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4
iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iO@02/CUmP05`^?da>GfaNKg
aNKga>Gf00;2ho@03/?Rm[SBjj>meXnY`8BM/gJ<XG25V8JIZ:Jha;2nbL_E
g^W`n?coookoo`;oo_l00oomo_onoiVIV@27VIVI00?oooo<c<c<c<`0GLc<
c0:=E@X019EE58eE2YEE0:I<00:EE@000jI<09EE09EE0002YVL000>NLPZE
E@2EE@000YEE0005WUhDUED0UED0Pd40UED0009Z@@X02/640;1k2ZIb09ib
2X=107]<2W]107]<2W8V06Y12P9G7002?A`:0R<V2P06?A8:ARl:?A`:ARl:
?A`:H2l:0VY12P9P;`X042<V2TIE:H>4NiFQS/[@e]?SmNgfmFYkKm?SmL[@
e[2c]l77c<77`IF=I[2c]l77`@:VZZ<2YZ6H00>VV6n3Nc<A70X00Q4L2P0:
;1802@T:4A`:6PT:4A`:2@T:4A`:6PT:4A`:;1`D0R<L2P06;2HDH2lDJUDN
UD`YYW9BYXAB0/6QQ0;L/j<04<Zn[Mbn]mbn]nC7`McSe^g]j]bc[NBZV<6Q
Q=bcQ>C7`OK]j_KfmMcSe_K]j_Kfm@;fool01?KomIib<iEbAk1k:@>`Na@0
<9EE0:I<08<h09EE58<_08eE2W]<2W8h57]<2Yib2[1k2[UW0;2=D[2c]oKo
ongIc?oI:DH_2[2ZQ>g]j^gfmOooong]j^g7G=bZ<ng7G?K@Q>g7Q>Bc<ng7
Q>fn?Ng@V>fn?NBcAmbcG>BcAng7G>Bc:Ng7G>BcAnBZ0:K7h<6QQ>g7G>Bc
AoK7?NBcAng7G0;]_Sd02LZQ?OoSS^g7Q?K@Q>g7Q>g@V?KII^g@V?K@Q002
kLN40^g7G00<i;<cdj4YbYPY^Hdc/8dc/8dNWW8:^HdDPg/cJT4:H2lD8a`:
0Q4L2P0?2@T:4A`:0000JVLcWXdYJVLcAT4N8bH:6RHD4BHD4A`:Ea`0bYPD
i;<Ndh@000;:V1@03;V45;1k578h56Y12QXV51XB514V51XB50T92_o]S]bn
[Oooo`Cfool01Oooom?IeYFZ[NC@c>gfm@04m_oo00KooonVXISCfMKLhn3f
oooCfMIQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@0IVIVI05kooOSmnOKooogoooolooocmooKho2nb]ZT
/lJ;WK=fS:AlUZnF]<bbd^_0h__7j_o3i_[6jo_=l?o@mOoAm?o?m?o?l_o>
looAm?o@mOoAm?o@mOoAm?o@mOoAm?o@mOoAmOo@m_oAmOo@m_oAmOo@m_oA
mOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@
m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oA
mOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@mOo@m?o?m?o@loo?
m?o@loo?m?o@loo?m?o?l_o?m?o@loo>loo>lOo;l?l2bnko00k8j?o7iOo5
hofiennM^M5nV:mfSjF2UjZQ//BjamOIhng_m_kko?ono_h2ooom00?ooonI
VIVIVIT0QYVIV@03ooooc<c<c<c<05g<c<`019iN58eE2XeE2YEE00:=E@X4
UED000FNGQB=E@ZEEABVI`2NGQ@00ZIW00BEE@003heE2YEE07]106Y12[2=
7[1b0;1k2ZIb09EE08=107]<2X=107]<2VY12ULL0002H2l:00E6;`Xm70XS
9PXm70Y6;`X00ULL000QARH:LSP0LSPDPd40PcP0Nd`:=2lNLVMBPhf4UJ6>
`LO<g>?PkOKeUJZ]g>?PYZZSYZ6HUHAkSHeBYYQ_UHeBARl:=2lNg>?P`LO1
/;k1`LO1UIQV4A`:4BH:4A`:6PT:8a`:008A70X01AX92Q4L2PTB2Q4L2R`L
50028a`:01<S9PX/9QA69QAP@BV3GS>NNc>VQ8CTZYS1/jg:_ZgL/jgL_[OT
al7L_[OTal7L_[OC_XkL/j?L_[L00ngIc004m^gZkMW<kNgZm^gZ0oKoo`0<
kNgZPg/cWW/c^HdY/7/:/7/DYVL0WUhDWW8:PcP0SED:WUhD0W]<2P0GJT4:
LSPDSED:WW8:/8dN^HdY`H@0YYR4oooob[j]ARl:YZ6HkMW<m_Kem_ookMW<
g;=Li:X0kLMLkLN4kLMLi;<ci;=700;]ae`07Nfn?NBcAnBc7_KII]bcG>Bc
7]bcG>g7G>Bc<jK7h<ZZI^BcAnBc:Ng7G>fn?NBc:Ng7Q?K7?KV45?o]c?KI
I^g@V?KII^g@V>g7Q?o]S^g7Q?KII^g7Q002kLML01gLZS?T/akCV0[:V1C:
XCf`Q2V`N`Z`SC=k@@1kC0Y6@Ah/71@A70X94PXJ4Q@94PX92@Z3GS>EV6J3
Nc=6@AhJ9Q@J4Q@92@XJ2@Y69QCCQ03T/c?T/ah00]>40004^H@DWW8:PehD
H2l:0a4L2P064BHD0000on>>g;>Sm_ookOKe0oKoo`04ooookNgZYZ6Hb]3F
0^gfm@;fool2oooo00F`/kOTd<cLhn3fooGCfMH0HLc<c004IVIVR<2hR<2h
B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT06IVIV@1a
ookhookiooomoooom?OnhNSba<gLX:o2RYbbPYZbR:>nW;_G/]Ga_>?o_NKo
^n?lb_3ocOGod_Oodo_oe?Wodo_oe?Woe?cof?goeooof?goeooof?goeooo
f?goeooof?koeooof?koeooof?koeooof?koeooof?koeooof?koeooof?ko
eooof?koeooof?koeooof?koeooof?koeooof?koeooof?koeooof?koeooo
f?koeooof?koeooof?koeooof?koeooof?koeooof?koeooof?koeooof?ko
eooof?koeooof?koeoooeO_oe?coeO[oe?coeO[oe?coeO[oe?cof?goeOgo
e?Wod_[od_Ood?SodOKod?Go`nOm`nOo`^Co_=ki]MC`X/3LR:?0LXZVS:2h
X[?7`loOh>Wbl_GjnO_joOcho_giooom08RIVIT00oooolc<c<c<c01Mc<c<
00B=E@ZEEAB=E@Z=E@X2UED000n=E@ZEE@2EEAB=E@ZEE@2VI`2NLPZVI`2N
LPZ=E@ZEE@2VI`2EE@2VI`2NGQ@00YEE0004Nd`:JT4:`H@0YW8D0ZIb000C
SED:UED0Nd40Nd`:Pd40Nd40H2l:LSP0ARH:Ea`0?A`:ARl:8bH:Ea`0JT4:
ARl:H2l:Nd`:Nd4000>=E@X064I17VYkKhfHSZJZ[L[@e]?SmOKooiib5:Ib
5:Ib0;UW0:I<060_2W8h58f=Kk24NfYkKngfmL77c;2c]iF=IW]<50TB2Q4L
2P8J2@X24A`:00HJ2@XA70XA70X92@XJ2@X/4P028a`:00P/9QA69QA69QAP
;aAZEAjVLU:`SE;L/jd2g;>S00W1/jgL_[OL_[OL_[OTal7L_[OL/j>`SE:V
V8@00^gIc00Fm_Kem^gZm_Kem_Kem^gZm_Kem_oom^gZ`K>]YXAB/7/Y^H@Y
^FL0^H@D^FL0/7/DYT`0WUhDUEDDWW8:Nd`:LSPD0VY12P04JUDNUEDDWW8D
/7/D0/64000AY/OPkNgZ4A`:/:Z4m_KekOKem_oog;>4kLMLg:Xcg;=LkM2H
kKhmg;=Li;=7i;<Ym]UV00;T/dL00nBc<lZQ?MbcG002i;=703K]_SgT/dOC
ZTOL/ecT/dO:XCgT/akT/dOfacgT/dOfacf`SAkohhk]d9Sfd8C]d9SokLc]
d9Sohhk]ahCffFK]d9S]_Sg]aecT/c?LZS?:V1C:V2ViSBV`Q2VVLQB`SAj3
GQAkC1A6;`XS9PX92A@/4P094PXA70X92@Y6@AjEQ5:3Nc=6EBT/9Q@S9PXJ
4Q@A70X/71B`N`[faak:V1CLZS<3/7/:00YkC1A69Q@/9Q@J4Q@A70XJ4Q@9
2@[]d9SL/hCfool2kOKe0_Koo`06ooookOKeYZZSi=3<kNgZkOKe0oKoo`06
oooo/;>gb]31g>?Fm_Keg>?PHLc<c004IVIVR<2hR<2hB9280@00000000B8
`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT06IVIV@0Cookhoogiookmoooo
ko;if=kZ]l?CU:FiLXRPOYVdUKCAZLk[/]_k]>7o^^So`o7ob?;oc?CncoOo
00;@n?l00logom3hom7io`0he?co2=;jo`04e_kodo_od?SocoOo0/kfo`0C
cOGoc?CodoWod?Go`nSo/]OdZlk^Y/OXVKKHR:;3Ni:aTJ>k]<7Df>3]lOKj
o?kmoOkho_ghooom08RIVIT00oooolc<c<c<c01Mc<c<00R=E@ZNGQB=E@Z3
@@2=E@ZEE@2=E@ZEEA@3UED000BNGQBNLPZNLPZNGQ@2WW8:00>NGQBEE@2E
E@000YEE000;YVL0Pd40JT4:/7/D/7/:/780/8dNWW8:UED0SED:UED000:3
@@00;7]<2W8V04HV2V0_2THV2SdL2R<V2SdL2V0_2THV2ULL07]<2XeE2YEE
09EE5:I<04I17W^=IYFHXk2c]mcSh?Koong]jZIb0;V=5;UW08=106YbG<[@
`McSh<[@eXf=Kiib58=N<h=10;2=7ZIW07]1014L2PTB2PT92Q4L2PT92Q4L
2P892@X34A`:00DS70XJ2@XS9PXm70Xd;bT00V11:@07UD`YWW8c/7]VYXB4
`J64g;>Sb[j]00CL_[L04NC7`NgIc=bcXk24I[24NlZn[NgIc>gfmMcSh>gI
c>g]j_KfmOKoongIc8f=DYF4DYib<`02bYPD00BiQ2W1Q02VI`2`N`X2YVL0
00fNGQB3@@1kC0Y69QAP;aAkC1B3GQBEEABVLQB`SAkCV0YZLUb`/kL00/Zn
[@03kOKem_Kem_oo00;L/e`03nBc<ng7Q>g7G>g7G>Bc<nBcAnBc<ng7Q>g7
G>BcAlZH5>Bc<nBZ0=>40=bcG003i;=700KT/akT/c?T/akfacgT/dOT/bT2
kLML00>iQ1C]d9Sohhh00^g7Q003onf>kLN4on>>00;]ah@04?K@Q>g7Q>g7
G>fn?MbZ<m>Q:LZH:KV=:K24:JIb59j=<h=N57]<2TH_2R<V2QX92P894PX2
2@TD00A69QBVXFJ3Nc=PGS<26RHD00DA70XJ4Q@J4QB`E@3T/ah00/ZH5007
dh@0/7/:/7/DPehDH2lD4BH:;1`D008J4Q@010000=bcG<ZZI^g]jP;]m_D3
m_oo00G]m_F`/kO:d<7Lhn3]m_D00oKoo`06oooo/;k1`LO1g>?Fm_oodmWF
HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT06IVIV@0Foogeoocfookko_kojNcccmOR[kc=SZ2fPi^eRjS6
V[gMYLc]Y];eYmSi/nGo`O?oao7oc??jcoKmdOSod?OncoKm0]3goPSBnOl`
d_Wn2=3goP0Fdo[odOSocoKmcoKmd?OncoKmc??jbO7k]Mk`^n?l_nOo^N3o
[m?eXLGYTk?JRjO<O9BfRYfkYkK;cMKUj_7gn_ok0_oon003ooomVIVIVIVI
00:IVIT2000019VIV@8000000iVIV@000000000300000YVIV@@00003VIVI
100000FIVIT200000iVIV@800002VIVI0P0000BIVIT6000000BIVIT00000
002IVIT200000YVIV@8000000iVIV@00000000030000?iVIV@03ooooc<c<
c<c<05g<c<`2WUhD00N=E@Z3>02=E@ZVC02=E@ZEE@2NGQ@00XeE2P09YW80
YW8D/780SED:/7/:YT`0YW80WUhDYVL000BEE@001fY12[V=5<640;1k2ZIb
09ib59EE0002Pd4000UkC0Z=E@Yb>01kC0YP;`YZ@@YP;`Y6;`Xm70X00TH_
2P04ARH:ARl:JT4:UEDD0XeE2P0HYVL0AT4NSIR>YZ6H/;k1g>?Pm_ookOKe
YW80`H@0LUEBYZZSkOKeYZ6H/8dc/780UED0LRH0UED0/7/:^Hdc/8dNNd`:
2A8:0Q4L2P072@T:4A`:6PT:4A`:6Q8D4A`:;18000@S70X022<V2THV54HV
56115611:IEN<iEbAk1kIP;1XH@01=bcXmbn]mbc[Mbn]`;Tal407NC@c>gI
c?o]c<6QQ;24Nl6QQ=>nS]bn]nC7`OK]j_KfmOoook2ZQ6Y12W9WD[1k:LZH
5;2=7/640;1k5;1b0;1E08eE2YiN5;1E09iN57]<2V11560_5002H44D01b3
GQBNGQC1Q023GQAkSFK1/jg1al7CfMKfkN[foooooooLZS?]aecT/dO]aecf
d8CT/dOT/bWT/dOT/bWT/dO]aecT/dOLZS?:XCgL/ec:V1CT/ah2kKhm01CT
/bWT/c?T/c?T/ak]aecT/dOT/bWT/dO]_Sg1Q03okLcohhk]ahCohhk]d9Sf
fFK]ahCfd8C]aecfd8@2kLN400k]aec1Q02`Q2W:ZTO:V2V`Q2ViSABNLQB3
GQAkC0Y69Q@S9PXA70XJ4Q@24A`:01/92@XS70ZEV6J=SDMZEAhA9PXJ4Q@A
9Q@J2@X/71BVC03faakTZP3:V1BiSC>iI`2=E@ZNLPYP;`X/71@J9Q@J4Q@A
9Q@0003:XE;:ZVKTd<`00ngfm@?fool01JJc`L[@`NgfmNg]j^gfm@02m_oo
00Koooo1alc1/jgLhmK]kN[Lhn1Qc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0IVIVI0_onn`0Aooomn?Wk
g^?Y`L_EWZo1OI:]PifnQ:C;SK;LW<K`ZMGl[]co/N;o]^Go_NKha>[gbNkn
00;;lOh00lW_o<S^nlS^n`07b>kk<LS^n@S8k_/06LW_o<S^nlS^nl[`oL_a
o/W_o<CZmkoVmlK^okSOo:gFm:kGmj_Cmig3jXb_fHBTcH2La8JL`IZ[akc9
g=gVko;fmOcmmOoom_oon`04VIVI0P0000>IVIT2000000>IVIT000000000
0YVIV@8000000iVIV@0000000002VIVI0P000003VIVI0000000000:IVIT2
000019VIV@800003VIVI0P000003VIVI0000000000FIVIT200001IVIV@80
00000iVIV@0000000002VIVI0P000003VIVI0000000004:IVIT00oooolc<
c<c<c01Mc<c<00NNGQBVI`1kC1B3@@2=E@ZNLPZ3>0000iEE0006YVL0YW8D
YVL0/780/7/:WW8:1:IW000?WW8:YVL0UED0UED0JT4:bYPD^H@D/8dNYW8D
YW80YVL0UED0YW80Pd40UED000:3@@02H2l:00Eb>00m70Xd;ahm70Y69PX0
0TH_2P9kC0X0:JIb08eE2ZIW03@_7VYbG:JQV:JZ[McSh>g]j]cSh<6406Y1
2]?SmL[@`JIb09EE0:Ib0;1b0:Ib09ib2YEE0;V=5;24:LZH:IEE00TB2R`B
014L2PT951X92Q4L2PT92PTB2QX92R<L2R<V2Q4L2R<L2R<V2QXV54HV5002
H2lD00NEC2VEGS>ELTO1XHBVQ8CL/j?1XH@00mbc[@04g;jgi=3<kMW<kMW<
0_K]jP04ong<i<O1i<O1kMW<0oKoo`0Bm^gZJVLcJUDNUEDDbZYV^HdD/7/D
bYPD/780/7/:YW8DYVL0UED0WUhDSED:Nd`DLSPD=2lN0THV5008LSPDWUhD
^H@D6Q8D`K>>b[j]i=3<g>?F0_ooo`0D`K>]i;=7g;=LkLMLg;=Li;j4kLN4
i;<ci;=7i;<Yi;=7kKhmkLMLi:X0bZ4mg;=Lm]24bYPDg;=Li;=70nBc<`03
i;<YbZ4mi;<Y00?T/c<02[V=<ooSS^g@V>g7G>g7Q?oSS^g@V?KII^g7Q>g7
G0;]ah@0;>g7G>fn?K2=7[1E0<640;2=7[24:K2=7ZIb08=N<fY12V0_2R<V
2Q4L2QX92PT92Q4L2PT92R`B0:JHKg:=?FYE7R<V2QXV51X92Q4V2QXB58<_
0>Bc:LZH5=>40<ZH5;V45:IW08=N560_2QXV52<L2Q4L2QXB50000;VHG>g7
Q=cSeP?]m_D2m_oo00GfooF`_/71/jgLhn3]kNX00_Koo`;oool01M?IeZJZ
XnC@c>gfmM?IeP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^0C<c<`00fIVI/c<c9VIV@0IVIVI0_ono`0Fo?kmmogmen7S_L_DTZNl
KHNXN9S7OZ?JR[;]U[ogW/KgYloc/=Sb]]kg^n3m^]kn^]ko_>3o`>Co`NGo
`>Co_N7o@<;Wo`?3j?l05/;Wol7VokoTokkSokgQokWLokOJojoEnZK>lYg7
kIK0j8Zcgh>WegVIbVV5]96Wd;?4h]OPlOGjoOkon?kolooon`BIVIT20000
0iVIV@8000000iVIV@0000000002VIVI0P000003VIVI0000000000FIVIT2
000029VIV@L000000iVIV@0000000005VIVI0P0000FIVIT2000000>IVIT0
000000000YVIV@800002VIVI0P00046IVIT00oooolc<c<c<c01Mc<c<00b=
E@ZNLPZEE@23>023@@2=E@ZEE@2=E@ZEE@2NGQBVLP2NLQ@4WW8:00B`LP2V
LP2VLP2VLP03YVL000J=E@YZ@@[:V2V`SAk:V1BiSA@2YW8000B3@@2VI`2E
E@2VI`02Pd4001Qb>01P;aAP;`Y69PYG7016;`XS9PXm70XS70YZ@@YkC0ZE
EABNLQB`Na@A70YbSCfEZZf`_/7Lhn3foooLhmIb>02Van3:ZTL2`H@000>`
LP2`N`Z`N`X00[1k2P07UED0/7/:^HdDbZ4mYW8D4A`:8a`:00<A70X01PT9
2Q4L2Q4L2R<L2Q4L2TH_2P8S70X02B<V2R`V54HV54H_2V11:H=N<iEN<iib
<k24IP02`J640]bcX`07b[j]g;jgi<O1kMW<i<O1kMW<m^gZ00;]m_D0:mcS
h?K]j_KfmOKfmNgfmOK]j/Zn[F11560_5;2=D_KoonC7`KVHG<ZH58eE2[1k
2X=N5:I<07]<58=108eE2W]<54I17R`V54HV52`V560_578h52<_7V115;2Z
Q;2c]mcSh>g]j_Kooooooiib2^g7G>g7Q>BcAnBnQ?KII^g7G002i;=700WT
/bW]aecT/dO]aecCXBW:XCgCXBWfd8CL/e`00^BcA`0:i;<ci:X0i;<ci:X0
i;<Ni;<ckKhmi;<Ni;=7diP:0^g@V008m]24kLN4kM2HkLN4m]24kLN4i;=7
kLN40^g7G00Ng:Xc`H@0YW80SED:UED0WW8D/8dcWW8DPehDNd`:ARHD;2HD
2@T:6Q8D4A`:2@T:6PT:8a`:WXAVUG97H5hc;2HD6RHD2A8:6PT:6Q8DLRH0
i;<ci;<Y^Hdc0[1k2P0;YVL0PehDH2l:;2HD6Q8D2@TD6Q8D2@T:/7/YkLN4
g;jg00C]m_D01_Kooooool[@e[2c]mcSe^g]jP?fool01_ooom?Ie/6c[L[@
`OK]j]cSh67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
1<c<c003IVIVc<c<VIVI01VIVIT0LOkmookooo[nooGmom?Nh[_=fGjF/6V9
[g>Hc7VSghB`khjkmYO1lj36kJ[>j:oCkK?Gnk3FoK;EoK?IokWLokWOok_N
okOMok[NokSNok[NokSNok[NokSOok[NokSOok[No[SOo[[No[SOo[[No[SO
o[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[N
o[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SO
o[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOok[NokSNok[N
okSNok[NokSNok[NokSNokWMokOMok[NokSNokWMokKLokOKokKIok?Dok3B
ojW>n9k8kYO3jXnliHB`gg^Ueg:Gc6N7^X2Ha[?6imCOlo?ko_kon?cnlOoo
n`04VIVI0P0000:IVIT200000iVIV@80000019VIV@00000009VIV@800005
VIVI1P0000FIVIT2000000>IVIT0000000000YVIV@800005VIVI0P0000FI
VIT2000000>IVIT0000000000YVIV@800002VIVI0P00046IVIT00oooolc<
c<c<c01Mc<c<00BNLPZEE@2=E@Yk@@03UED000Z=E@ZEE@2VI`2`N`ZVLQBV
I`2`NaBVLP2`N`Z`LP02YW8000RVI`2`N`ZEE@2EE@2NLPYZEAk:V1BiQ1@2
/8dN00B`N`ZVLP2VLP2NLPX4UED000UkC0Yb9P169PYP;`Y69PXm70XS9PX/
9Q@S70X00VY12P0<SED:UEDD/7/:ARHDUJZ]YZZS`LO1i=3<m_ooYZZSCfM7
m_oo0/64000?/8dN^H@D/780`H@0/7/:/780UEDD^H@D/780bYPY`H@02A8:
4BH:8a`:2@T:00894PX01Q4L2PT952<L2R<L2R`V514L2P<S70X014HV560_
56YE7W]<50:ELTL01k24I/6QQ<6QQ=bc[Mbn]mbcXmbn]`02i<O100O]fLcf
kN[]kN[fkN[fm_GfkN[fm_D00_Koo`0Jm^gZkMW<UHeBH44DWW8DbZYVb]31
m_oooooog>?P`J64/8@YEa`0?A`:ARl:H2l:LSPDH2l:?A`:4BHD2A`N4BHN
;1`D4A`:WW8DYZ6H0/6c[@0:g>?FkOKem_oog>?P/7/:m]24i;j4i;=7kLML
kM2H0^BcA`05i;<cbZ4mm]UVi;=7kLML00;:V1@03kUW0>BcAooSS]bcG>Bc
AnBc:LZH5>BZ0<ZQ?NBc:OK7?NBcAnBc<oK7?LZH5002kM2H0^g7Q003kM2H
kLN4kLN400C]ae`06MbcG=bZ<kV=578h58<h08=N59EE5;2=7Yib2X=N56Y1
2TH_2S@_7PTB2QXB514L2PT92Q4L2PT92Xf=Ah=k<fYE7Q4V2QXV50TB2P02
4A`:01=G703f/`3T/akCQ03:V1B`E@2`N`ZVC01Z@@X/9Q@S9PXJ4Q@A9Q@9
2@YkC1CohhjVXIS]m_G]kNX00ngfm@05m_oo`LO<YZ6Hg>?Fg>?P00?fool0
1_ooong]jYFQS/77c?K]j/[@eV7<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01VIVIT0LOonnOoono_oo_Gl
oloKjKc>iV9lWFZ;]VbFb76PeWb]iHNfjXnkjYNnij73iZG8j:K=kZG=l:K<
l:O?lZcCm:kGmk3Gn:oHn:oFmJkGmJoFmJkGmJoFljkGljoFljkGljoFljkG
ljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoF
ljkGljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoFljkG
ljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoF
ljkGljoFmJkGmJoFmJkGmJoFmJkGmJoFmJkGmJkEm:gFm:kEm:cEljcClZ[C
lJW@kjS>lZO:m:K8mJ35kiK0j8nliHRghgf]gGBReV^DbVF9_FF2[[K:jm;O
l_?ko_kon?_kkooon`04VIVI1P0000BIVIT4000000>IVIT0000000001IVI
V@800002VIVI0P0000FIVIT2000000>IVIT0000000000YVIV@800005VIVI
0P0000FIVIT2000000>IVIT0000000000YVIV@800003VIVI0P00042IVIT0
0oooolc<c<c<c01Mc<c<0Yib2PF=E@X019EE09ib2YEE09ib2P:VLQ@2WW8:
0ZIb500OYW80YW8DYW80YVL0WW8:YW80SED:JT4:i;=7^HdD^HdY^HdD/7/D
/7/:YVL0/7/:SED:YW80UED0YVL0Pd40JT4:H2l:Nd`:H2l:ARl:8bH:8a`:
4BH:ARHDARl:00:3GQ@069iN54I17X>4NjJZXl77`NgfmOKoof1N<h>4NoKf
mL640;V=5;2=7[V=5;1k5;1k2[V=5;1b09EE0;1k5:Ib5;V=5=>H2QXB50<A
70X00`T92QXB50TB2P026Q8D00H/71@J9Q@A70XJ2@X/71@J4Q@2ARHD00IP
;aB3GS>3GS>VLU:VV6nVQ8@2`J6400CTZYSL_[OL_[OTal42kMW<0oK]jP?f
m_D03?KoooKomL[@`LZn[H=N<iEN<k1k:JJQIYj=<jJHQ;2c]oKoo`;oool0
7nC@c:JHKiF=IZJHKiik<h=k<fYW<fY12VYE7X=N58=k<jJHKkVZKl77`L[@
`Mbn]ng]j_KoongIc>g7G;2=7^g7Q>g7G>fn?NBnQ>g7Q>g7G>Bc<ng7G>Bc
Ang@V002kLML00OT/bViQ1B`NaB`N`[LZS?]_Sg:ZVH00nBc:@03i;<cbZ5B
kLML00;T/bT01ng7G<ZH5>g7Q>g@V=bcG>g7Q>g7G003kLN400gL/ec]aec]
_SgT/dOCXBW:V1B3;`2NGQB3@@2NLQBNLS>NLQB3GQ@00VY12P0A;2HD8a`:
2A`D2A8:2A`D6PT:0000SHe7Pg/cH5hc=2lN6RHD6Q8D4BHD6PT:?A8:i;<Y
00;:V1@03kV45;1k2Yib2W]<560_52`V52<L2PT9514L2PT92W9ED_K@Q:JH
Q?Koong]jP02kOKe0_Koo`0=dn?eUJ6>g>?Pg>?Pm_oedn?ekOKeoooom_oo
YZ6Hb]31kMW<dmWF067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c003IVIVc<c<VIVI01VIVIT04Oonkooom?kooOOkom7Ll[g@
l4UTSfB8^6:@`VRLcWFYfGjbhHNfhY2ji9^niZ73jIk4j002WLGX00FOanZR
bn^TcNfVcnnWd?001:K?kCBVcn/8Y/o]0ZO@kP0GY/o]Y<g[X/_YX<WWW/OU
W/GVWl;ZW/3]VKkZSk[TR;OSP;?RMZ[LKIoDHi39H8RlC6^I]lk`d]obmO[n
oooho?c`oook00BIVIT200000iVIV@8000000iVIV@0009VIV@02VIVI0P00
0003VIVI0000000000:IVIT2000000>IVIT0000000000YVIV@800005VIVI
0P000003VIVI0000000000:IVIT200001IVIV@800005VIVI0P000005VIVI
000000000000VIVI00800004VIVI0P0003nIVIT00oooolc<c<c<c01Mc<c<
0YiN50>=E@X02jI<09EE09iN59iN59ib59ib2ZIW09ib2[1k2ZIW09ib2P02
/78000bVLQB`LP2NLPZVLP2VI`2NLPYZ@@[LZS?:XCg:V2WCV0Z`SAh2/7/:
00FVLP2NLPZ`LP2=E@ZVLP000W]1000NNd`:JT4:LSPDARl:?A`:8bH:8a`:
;1`D6RHDJT4:H44DPehD8bH:JW9LUIRSb]3FkNgZPhB>/;>gkNgZg>?F`H@0
g:Xc`H@0/8dN^HdD/7/:^H@D/7/:SED:0Yib2P04LSPDbYPDARH:2A8:114L
2P0A2A8:2@T:4A`:ARl:;1`D4A`:8a`:;1`D;180=2lNAT4NH44YLSPDUG97
YW9B/8AV/8Ak00?1XH@00mbc[Mbn]nC@c002kMW<1OK]jP;]kNX05^C@c<6Q
Q;VZKh=k<iik<jJ4D/ZQ?FYW<h=N56Y12THV561bNg:=[M?SmL[@e/77c?K]
j^g]j]cSe]bn]mcSe]c7X`C:d<403l6c[McSe]cSh?ooongfmM>ZAng7G;V4
5?K@Q=bcG>BnQ>g7G>g7Q>g7G>BcA`02kLN400K]d9ST_XC]ahC]aebVI`2V
C002/5D000>iI`3T/c?T/c<01nBc<`06i;=7i;<Ni;j4m]UVkLN4kLML0^g7
Q00;kLMLkLN4i;=7kKhmi;=7kKhm`H@0PehDUEDDYW8D^H@D00:`SAh07iib
58=N561154H_2R<V2PTB2R<L2PTB2QXB50T950TB2X=N<h=k<fYE7TI17R<L
2PTL51XB52`L51XB5?nc0<ZH5=>40;UW0;V45:I<08eE2V0_52`V52<L2Q4V
50024A`:00@J2@[]aeb`Q6Kfool2kNgZ1>gfm@03YYR4`LO<g>?P00;]m_D0
1oKoooooooooohf=Kmbn]mcSe]?IeP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0IVIVI01SoonOoonoo
oo_ho?oHhOk0dodkFXUHP;AJS;mPV<M]Y]=h[]Z1/]f:]N:F^>JJ_>VG_^NF
`>JG`NNH`^RIa>NJaNRLanZMb>/4W<OY19c7icRLanT3WLSZ01JLanVKa^RI
a>JH`nFI`NFJ^nBI^^NB^NB9]>60/n9i[^1^YMeWVmEJRlEGP;HmGHbjdO?E
h_Gen_koooSooo?ooo/4VIVI0P0000>IVIT200000YVIV@@00003VIVI1000
00>IVIT400001YVIV@80000019VIV@00000009VIV@@00004VIVI0P0000FI
VIT2000000BIVIT00000002IVIT200000YVIV@D0000oVIVI00?oooo<c<c<
c<`0GLc<c005YVL0WUhDPd40SED:PcP000:=E@X2WUhD00RVI`2VLQB`NbVN
LQB`N`ZNGQBNLPZ`LP02WW8:00b`LP2NLPZ`LP2NLPZNGQAZ@@[L/ecCZTO:
XCg:V2ViSBV`LP02/7/:0jIb0005/7/:UED0UED0SED:Pd40009kC0X01TH_
2R`V514L2R<V2R`L51XV50969Q@03DH_2W:=?IFHXk2c]k2n`McSe^g]j]?S
mNgfmK1b0;2=7[V=5;2=7P02/7/:00FES@2`N`Z=E@ZNLPZVI`000[V=500M
WW8D4A`:2A8:4A`:6PT:2A8:4A`:6PT:2A8:8bH:8a`:;1`D4A`:8bH:;2HD
ARHDAT4NH2lDPehcWW8cUEhcWXAVYYR4`J64^JY_g;>Sg;>]g;jgi<O100;]
fL`01?K]j_KfmOK]j_Kfm@;fkNX01^C@c=>nS[VZKk2=D[VHG>BZV0;1/hh0
0l6QQ;2=D[2ZQ002dkj>00jiZVn3GQ@0002`/kO]m_GLhmK]kN[:d=K]kN[L
hmKTd<cLhn3LhmKCfMH2g>?F00WLhn3fm_GL/ecT/c?]aebiSACfd8C]aecT
/dL00^g7Q0;]ae`03>fn?Ng7Q>g@V>g7Q>g@V=bcG9EE08<_0:I<09iN5:I1
0<ZH50;T/dL2i;<c1>Bc:@04i;<Ng:XcdjY7kM2H0^g7Q00:kLMLkM2HkLML
kLN4i;=7kLMLg;=Li;=7bYPD^FL00[1k5003bZ4m/8dcYW8D00:NLQ@097]<
560_52<V2QXB51X92PTB2PT950TB2P0006YW<h=N<fYE7TI17R<_7Q4V51XB
52<L2QX92_K77[V=<m>40;V45;1k2YiN58=N56Y12R`V52`L514L2QX92QXB
51X92_KIIZIbD_KoomcSh0?]m_D00oKoongfmHfHSP02g>?F00Wfm_Gfooof
ooofoooooon=V8k1al7LhmKCfMH0HLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT06IVIV@0CoooVooo/oook
n_cohncoaMSo?UjAB7>XE8RjFI?3Hj3<KZWCMj[GP:cKRZkPTK?STKKST[WT
U;[W00:E_>L01YFliIJmj9NniiFliIFlhiFli@:E_><019FmhIFlhiFlhiFl
hc2E_>D03iFlhiFliIFlhiFliIFlhiFliIFlhiFliIJmi9NniiNniIRoj9Nn
iINniiRmi`02T[?N00n:/=f0[=]gZMY_Y]aUWMILT/i?PKa:MJ`lGX^oeoWN
jocfnoooooSoooCooo/019VIV@800003VIVI0P0001^IVIT300000iVIV@80
0005VIVI0P0005>IVIT00oooolc<c<c<c01Mc<c<00VNLPZNNc>3@@2NLPZ3
>02=E@ZEE@2VLP2NGQ@00Yib2P07YVL0WUhD/7/:WW8:YVL0WW8:/78000:`
N`X01ZIb09ib2ZIb0:Ib56YE7]bZ<`;CZTL00lZH:KV=:KV=5003/7/:0jIb
00>EE@02SED:00BNLPYP;aA69PXA70X26PT:0Q4L2P0=6RHD4A`:LVMBUJ6>
YZZ]`LO1dn?eg>?Fg>?Pm_ooYW8D/7/:YW8D00:NLQ@02[1k2YEE0:Ib08eE
2YEE09ib2X=N58eE2VY12THV50<A70X00aX92Q4L2Q4L2P024A`:00PS9PXA
70XS9PX/71A6;`Y6@Aj3GS=P;`X2Pehc00BEQ5:`NfJNQ6J`Q7/2`J6400GL
/jgL_[OTal7Tal7]fL`00_K]jP04m_Kem^gZg>?Fi<O10/6cSP03^IQLYYQ_
bZYV00:iZVl01=bn[NC@c<[@`Ng]jP;Lhn001=cSe^C@c8=k<jJQV0;Td<`0
5>g]j]?Ie^g]j]cSh=?Ie]cSe]cSh>g]j]?Ie^g]j^gfmLZQD^fn?NBc<nBc
AkV=5>g@V=bcG>fn?Ng@V0;]ah@01nBcAmbcXng7G>g7G=bcG>g7Q<ZH5002
Pbl000B`C03CQ02`N`ZEE@02g:Xc00GTZP3T/dOT/c?T/c?T/dL00^Bc:@03
g:XcbZ5BkLN400;]ah@01>BnQ>g@V>fn?Ng7G0;T/dL02>g7G>BcAnBZ0=>Q
:L640;1k5<ZQ?K2=7P>NLQ@0161154H_2S@_7PT92P8A70X26Q8D01d0001Z
Ic>3Nc=ZIc=6@AhS;ah94PX971@S70X92ACT/akCQ02`N`ZiQ1B`N`Z`E@1k
C1Ab>1@/71@S9PXA9Q@A70X/71@92@[ohhBVLU;foooChoGLhn000^gfm@05
m_ookOKePhB>`LO<g>?F00;]m_D2m_oo00Gooon3Q7_1/jgTd<cCfMH0HLc<
c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<
c<bIVIT06IVIV@0KoooXoog]ooojn_gok_Sob=_oBFVH>fJIAgb`BhNkF9C6
Hig=KJ3?Mj?BPJGGR:WLRJ[MRjoQSk?WT[KXTKGWTKGUTKGWT[KVTKGUTKKS
TKGU00:A]^<00i6fhY6fhi6fh`0aTKGU022A]^>A]NFA]^>A]NFA]^>A]NFA
]^>@]>B@]N:A]NFA]^>A]NF@]N:?/n>A/n6:ZmJ9Z]F0Y]=dXm5/WmATVm=G
T/a?QlA3Mk4jJ9a4Ii78hOoZmoojoOoooo[oooKooo/4VIVI1P0001bIVIT3
000019VIV@030000VIVIVIVI00>IVIT200001IVIV@80001<VIVI00?oooo<
c<c<c<`0GLc<c00>WW8:YW8DSED:Pbl0SED:UED0SED:WUhDYVL0YW80YW8D
/7/DYW80/7/:0ZIb5006YW80/7/:/7/:/780WW8:/7800Yib2P0;JT4:g;=L
djY7bZ5BbZY7^HdY/8@Y^H@D/7/:/780/7/:00:`LP001Yib2YEE09iN58eE
2Yib59EE509b>1@012<L2Q4L2R<L2Q4L2P8J4Q@03@T92V1N<jJQV:JZXk2n
`M?Ie]?SmL[@`NgfmM?SmIF=IYj=:G8h0002PehD019P;`YkC0YP;`YZ@@YG
701Z@@Z3SHCLhn2`ZX@0000A9PXJ2@XA70XJ2@XA70X971@94PY6;`X24A`:
00DS70Xd;aib>1AbSCfELTL00X=N<`0:WW8cYXAB/8AV/8Ak`J64i:ZHb[j]
i<O1g;jgi<O10^gIc0;fkNX00mcSe^gIc=c7X`02`J6400V=SFo1XHBVV6oL
/j?L_[O:d<7ChoGLhn3]kNX00mcSeP0;dmWFi=3<YZ6Hb]31`K>]kOKeg>?P
kNgZg>?PkNgZg>?P00;:d<404>gfmNg@V<ZZI^Bc7]bcG>fn?NBcAm>Q:NBn
Q>g7G=bcG>g7G>BnQ>g7G>BcAng7G0?T/dL02M>ZAm>Q:JI<09iN58<_0;1E
0;1k2[1<0=>Q:@02i;<c0^Bc:@03i;<NbZ4mg:Xc00;T/bT01[V=<oK@Q>g@
V>g7Q>g7G>g@V0;]ae`04=bcG>g7G=bcG>g7G>Bc:M>Q:LZH5;V45<ZH:K1k
:Iib59ib2X=N57]<2TH_2THV508J2@X080T92QXB50T92PT954I17Xf=AdIE
:C@_7R<_7Q4L2PT9514L2PT95=>40=bZ<m>40;V45;1E0;1k:H=107]<2R`L
52<L2QX92Q4V51XB50000>g7G;V=<ngfmMcSh>g]jP?]m_D01?KoohfHS/[@
`L[@`@;]m_D2m_oo00GooonEXHj`/kOLhmKCfMH0HLc<c004IVIVR<2hR<2h
B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT06IVIV@0F
ook_oo_`ooojoOkomOoob]olDW>L<Uj=>fjS@WZcCXW1FiC;IYS;LIg<OJ?@
QJOEPZ;CR:SKSZkQTK7TTK7RT;3Q0Y6ahPBB/^43T[?P00>B/^6B/^>B/^<0
;Y:bh`ZB/^405i6ah8n_gXf]g8^[fXRXehNXeH>Tch6TcWNPc6bJbfBGcU^B
be28aDIn^Ca_Z3=OT4a^U<oWooCooocooookmoonn?ooo@28VIVI00?oooo<
c<c<c<`0GLc<c003WW8:WUhDSED:00:=E@X01H=10:I<08eE2YEE09iN5002
WW8:00BNGQB`LP2VI`2`N`X2/78000RVLP2`N`Z`LP2NGQB`N`ZNGQAZ@@[L
/e`3bZY700G:V2V`LP2iSAB`LP2VLP000k1b0004YVL0WW8:/7/:WW8:0YiN
5004Nd`:SED:H2l:8a`:0Q4L2P0M4BHD2A8:2@T:4A`:UJZ]LW9k/;k1g>?P
b]3FkNgZb]31m_oo/;>gkNgZSHe_Pg]LJUDNARHDJVLcSHeBYXB4YYR4b]31
/;>gAUDYJT4:;2HD4A`:2A8:008A70X05AX92QXB51XB53@_7Q4L2QX92Q4V
2PTB2QXB5611:FYE7YF4DYEbAij4IYF4DYj4IZJ4Q<6QQ=bcXmbn[LZn[@02
g;jg00oTal7]fLcLhmKTal7L_ZgTal6iZVn`SE:VV6n`SC>`SE;C_Xk:_ZgL
hmK:_Zd00^C@c00Cg>?PdmWFb]31`LO<dmWFkNgZ`K>]/;k1b]31kNgZdmWF
kNgZdmWFg>?Pb]31dmWFg;>4djY7i;<c00;T/bT02nBc<nBc:MbZ<lZZAnBc
AmbcG>Bc<ng7Q>BcAng7G<ZQ?@04i;<c01GLZS>iQ1B3;`1P;aB3;`2V@@2`
C02NGQCCQ03T/dO:XCgT/bWLZS?T/c?T/dOT/c?LZS?T/bViQ2W]aec]ah@0
0^g7G007kM2Hg;=Lm]UVi;=7kKhmkLMLg;=L00;LZS<01LZH5<640<ZH:Ij=
<k1k2P02SED:00AkC1A6;`X/9Q@94PX24A`:00P92@XA70X00016@AibSCeZ
EAi6C3dA9Q@26Q8D00DS70XA9QkCQ03CQ02iI`000[1k2P0?YT`0Nd`DNd`D
8bH:;1`D;2HD6Q8D4BHD0000bZYV^Hdcdn?eg>?Fg>?Pdn?e00;]m_D01ooo
ohfHS/77`NC@c>g]j^gfmOKoo`02oooo00BEXHjVZZ?Td<cCfMIQc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VI
V@0IVIVI01?oo?Son??oo__in_ceoooQm_moW[/XDWXmK:8[HIdmM;AOUM=Y
V]9lZ=N8[mJC]M^D/mnK]nJM^^H00Ybii@03W[_WWkcVW[_U00:N^nD6W[_S
00>N^nFN^nNN^nL0;9jki`03W[_UW[_SW[_S00JN^n<01IfjhZ6niZ6niYjk
hifjhP02W[_S01:J^^6>[mRM`^aiX]1iYMIcY=a;OkU1Mk<dJ:4PCh<eGhU^
Sk3]ooogoooal_Koo__lm?7ooof8VIVI00?oooo<c<c<c<`0GLc<c006WW8:
WUhDSED:UED0Pd40SED:0iEE0007YVL0YW8DWW8:YVL0/8dNWW8:/7/D00>`
N`X01k1b0;1k5:Ib0;1k2Yib2VY12_KIIP02bZY700K:XCg:ZTNiSABiSABi
Q1B`N`X2/78000fiSAB`LP2VLP2`LP2VLQB`SAjNNc>EE@2=E@YkC0Z3;`16
9PXA70X00QXB500@4BHD0000SHe_YZZ]`LO1/;>gdmWFb]31dmWFb]3FJW]_
m_oei=3<g>?Pi=3<b]3F0/77`@08kNgZ`K>]UHeVPehcYZ5V`K>>WW8D2A8:
0Q4V2P892@X03A4L2QXB52<L2Q4L2QX92PT950T92QX92R`V54I17Yik<ij4
IYEbA`02YW9B02^`Q6K1XHCL_[O:_ZgL/jg:_ZgL_ZgL_[O]fLcTal7L/j?1
XHC]fLbVV6nESE:NQ6JiZVo1XHCCfMK1al7Tal71alc:d<71alcLhmK:d<71
alb`/kO1alcLhmK:d<6VZZg1al71alc:d=J`/kOL/j?C_XkT_XCT/dOT/c?L
ZS?L/e`00^BcA`08g;=Li;=7i;=7g:Xcg;=Li;j4i;<Ng;=L0]bZ<`05bYPD
g:XcbYPDdj4YdiP:00;:V1@02G8h58<_0;1<0:I108<_0;V45<ZH5=>ZAmbc
G002i;<c00gCZTOT/dOCZTOT/c?CZTNNGQCffFK]ahCL/ec]aec]d9S]aec]
ah@00^BcA`09kLMLi;=7g:Xci;<YdiP:`H@0bYPD/8@YWW8:00:=E@X00g]<
2THV2TH_2P026PT:00T94PXA70X92@X92@X/71B3Nc=ZEAhd;ahS9PX00QXB
50036PT:0000WUhD00;:V1@02k1k2ZI<09EE57]<560_52<V2R`L51XV50T9
51XB50000002bZ5B0]cSh00:dn?ekNgZkOKekOKeooooSIR>`LO1b]31g>?P
kOKe0_Koo`05ooooUIRSYZ6Hi=3<g>?P067<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01VIVIT04oognool
oOonnooooOKooo7oojG0db=7JB5:OR9BT45b]Den`7JUgI>njig3iiRkfjO5
jJg9k[3=k`02[/_]00>`cNn`cNf_c>`00[;?k`Jbcnd00k;?kk;?lK;?l@05
//oa6:o<kPnbco400k;?kk;?kK;?k@06//o]01V^bnVac^bac^b^bnV]b^R_
c>Z^bnVZb>ZYbo6G_>JG`>jH`oIQT<Q2Lje9N[8QD8@cGX/TB6b^bNCVnOoe
o_onooommoOooO_oood0R9VIV@03ooooc<c<c<c<05g<c<`019ib59iN58=1
09iN50:3@@002HeE2YEE08eE2YiN5:Ib5:IW0:Ib5;1b0:Ib0002/7/:01>N
LPZ`N`Z`N`ZEE@2`N`ZVLP2`LP1Z@@[T/dO:XE;CZTOLZS?:XCf`SAjiSABi
SBViSABiI`2iQ1@00k1b000</7/:/7/D/7/D/8@YUEDDWW8:UED0Nd`DPd40
ARHD4A`:4BHD0QX92P0J4BHDSIR>YZZSb]31`LO1/;k1kNgZJW]_`K>]g>?P
`LO<g>?F`LO<b]31`K>]`LO1b[j]`K>]`LO1g;jg/;>g`K>]YZZSNd`:0000
2A`D0Q4L2P046PT:4A`:4A`:6PT:114L2P0=6Q8D;1`DAT4NPehcPg/cJUDN
PehcUHABYW9B`K>>`K>]g;>Sg;>]00?L_[L03M>nS[VHG;VZKmbn[IF4DYEb
Aiik<l6QQ=>nS/Zn[L6c[L77`L[@`@02`K>]0/77c009b[j]`J64UHAk`K>]
YYR4`K>>dkj>`J64bZYV00GL/e`2i;=7023]aecT/dOL/ec]aecT/c?T/dO:
V1C:XE;T/dOLZS?T_XCT/dOT/c?CXBW:V1CCQ031Q03CQ031Q03LZS=G701b
9P1P;`YP;aAb>1B`E@3T/c?L/ecT/dO:XCgCXBWT/bT3i;<c00c:V1BVI`3]
ahCL/ec]ahCT/dO]ahCL/ec]ahC]_SgT/dOT_X@2i;=700?LZS?:V1C:V1@0
0[V=:@0AWW8cNd`:SED:PehDAT4N;2HD6PT:4A`:6PT:6Q8D4A`:6Q8D;2HD
UHABH5hc=2lN8bH:008A70X26Q8D01BVI`3:V1CCQ02iQ1BNGQBEEAAkC1A6
9Q@/9Q@/71@J4Q@A70XA9Q@971j`SC?L/ecLhmKChoGLhn3]kNX2kOKe00Kf
ooFEZZfVXISTd<cLhn3]m_D2m_oo00GooonVZZ>VZZ?Td<cCfMH0HLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bI
VIT06IVIV@0Eoo_ooocooockooojlo[bmOooi?[oL8jX:4Yh8TZ5:UJGDGfl
Q:oVVlC`V/7RZloY[<[T/loW]];X]=3V/loU00:edNL00k??iKGAi[GAiP06
]M;T2;GAiQRdd>D@]M7V2;GBi00I]=7S]]?U]]?U]=7S/m3R]=7S/m3R[LgT
ZlocX<ObU;g[Ul7cQK3WBgJ]8T]o8DYh7D1VJXVVi?[om?ool?Ooookooogo
no;cooko08RIVIT00oooolc<c<c<c01Mc<c<00f`N`ZNGQB=E@Z=E@ZEEABE
E@2=E@ZVC02EE@2VI`2NLPZ`N`ZVI`000[1k2P03/780/7/:YW8000>`N`X0
1ZIb0;1k2ZIb060_2^g7G=>ZA`;:XE801<ZH5;V=:KV=5;1b00>iQ1@04KV=
5;UW0;1k2[1k2[V45;1k5;V=5:IW09ib2YiN59ib2ZI<08eE2X<_02<V2Q4L
2Q4V50022A8:00OCfMK1al6=V8kCfMK1alaZLUc:_Zd00/[@eP07g>?F`LO1
`LO<`K>]`LO<b]31g>?F00;:d<405=?Ie/6cSZJHKk2ZQ8=k<`00014V2PT9
2Q4L2QX92Q4L2R<L2Q4L2PTB2QX92Q4L2Q4V2QX92R<L2TIE:@:3GS<2UG97
01MZIc>NNc>`SE:VV6o1XHC1/jg1/hj`ZXBNQ6JiV5cC_XjiZVnNQ6JELTN`
SC?T_XCL/hCLaj>iZVo:XE;L/ecT/dOL/e`00/ZH5006diP:bYPDbYPDdh@0
i;<cg;=L0nBcA`05g;=Lg<NSg;=Li;=7kLML00?L/e`00m>ZAmbcG=bcG002
i;=700_L/ebiSC?T/dOCZTOT/c?CZTOT/c?CXBWCQ03:V1C1Q0000]>40008
^H@DLSPDARHDARHDH2l:H2lDYT`0i;=70]bcG004djY7dj4Ydj4YbYPD0m>Q
:@03/7/DkLMLkLML00;L/e`02>g7Q=bcG>g7G=>ZAnBcAmbcG>BcAmbZ<`;C
XBT03;V45;V4:K2=7Yib57]<2XeE2W]<2TH_2R<V2QX92Q4L2QXB50892@X0
4QXB52<L2W:=G6YE7S@_7R<_7Q4L2QXB514L2QX92W8h5=>40;V45;V=5:I<
0:IW07]<2V0_508S9PX36Q8D00L0002NLS?L/ec1alc]m_GLhmKChoD00^gf
m@0=m_oo/;>gYZZ]b]31g>?PkOKem_oem_oooooo/;>gUJ6>`LO<g>?P067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIV
c<c<VIVI01VIVIT04oolookioochmooon_OjlOSoo?Coomcaod5MPQ0bHQ/o
NCiUX5Z2]Z;9m9o6ijK:i:W9h:o>h[?BiP02/M3T0[;Ai@03[lkP/<oQ/=3O
00j`d=lH/M7P6;3@g`03/];Q]=CS]=CS00:bd^405;?Ch[7Ah:W<h:C:kZ?=
mj[Coh^ciUb4^49WVbM9Ma8bFDISPN_oonknoo?noocooo_io?okooolooon
ohRIVIT00oooolc<c<c<c01Mc<c<00VNLPZVI`2EE@2=E@Yk@@2=E@ZEE@2=
E@ZVI`000Yib2P0;/780WW8:/7/:/7/:/7/D/780/7/:YW80/780WW8:YW80
00:`N`X02fY12]>ZAlZQ?M>ZAlZZAlZH:M>H2[2=7[1k2[V=5;1k5002^HdD
00b`N`[1Q02iQ1BiQ1BiSAC:V1B`N`Z`Q2VVLP2`NaB`N`Z`LP02SED:00b3
;`1P;a@d;ahA70XdECf3SHCCfMJEXHk1al6VV8C:d<71/jd2b]310/77`@09
/;>g`LO1`K>]b]3Fb]31`K>]`LO<YZ6HYYR400:`ZX@00`0000TB2Q4L2P02
4A`:01LS70XA70XS70XA70X92A@J4Q@J2@XA70XJ9QA69QA6@AjVXFJVV6mb
Ie9ZIc=P;aBNNc>NLS>iV5bVV6nVQ5:`SE:VQ5800/6cSP03WXAVYXABbZ5B
00;]d9P02ngIc?o]S]bcG;V=<ng7G=bcG>g7G=bZ<m>Q:NBZ0=>H2P03dj4Y
00CT/dOCZTOL/hCL/e`2i;j400G]aecL/ecL/hCLZS?CZTL00^BcA`0CdjY7
g;=Li;=7i;=7g;=L^HdckLMLi;=7i;j4i;<ci;=7i;<Ydj4Yi:X0bYPDi:X0
diP:^FL0YT40009b>1@01F0_58<_0;1b0<ZZI]bcG003i;<c01;T/bWCV0[C
V0[CZTOCXBVNLP[]ahCT_XCT/dOL/ec]aecT/dOT_XCT/dOLZS?T_XCT/dOT
ZP02dj4Y0[V4500Q/8dNWW8DNd`DWW8:H44DH2lD8bH:8a`:6PT:2@T:4A`:
6PT:2@T:4A`:SHeBPehcAT4N;2HD4A`:2A8:6PT:2@T:LSPDbYPD^G8c`H@0
WUhDUEDDSED:ARHD8a`:6RHD8a`:008J4Q@05PT959EE5=bcG;2c]m?SmMcS
h>g]j]?SmNgfmOKomL77c:JQV<[@`McSe^g]j_KfmOKooooool77`IFQS/[@
`McSh67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<
c09VIVH00lc<c9VIVIVIV@0GVIVI01;ooOojn?goo_ooo__ooo_jo?W]m?[d
ooo^oolQ>f0UA78bE8ASR;EoY=2@/mVE^M^L_]ZRa=d3Y/SQ00>Xb^>WbN:U
b=h00jW<hPfYc>0HYl[N6:W<h003Yl[NZLcPZ<_O00:Wb]h05:S;gjG8g9k2
g9c4j9FnjXbehg>IbTi_XR0oKQ@_FS]CMNOkonOgooOooo_oong^l?onoool
oookooonohRIVIT00oooolc<c<c<c01Mc<c<00>NLPZNGQB=E@X00XeE2P0<
Pd40UED0WUhDWW8:WUhDWW8:/7/:/7/D/7/:YW80/7/:/7800[1k2P03/780
YW80/78000:`N`X05G8h0>g7G=bZ<lZQD/ZZAlZQ?K2=7/ZH5;1k5;2=7/64
0=>H2[1k2[V=5=>H2[1k2[V=5<ZH5=bZ<kV=5;V=:@02^H@D01>`LP2iQ1B`
N`ZVI`2NLPZ`LP2=E@ZVC0092@Y69QAZLUbEZZebLW_LhmJVZZ>VZZf`_/71
/jg:d=H00/77c00@/;>gUIRS`LO1b]31`LO1b]3F/;>gUJ6>YZZ]dn?eUEDD
2@TD4BH:2A`D4A`:8a`:0a4L2P046Q8D4A`:4A`:6PT:0R`L500CAT4NPg]L
UHeVUG97Pg/c;2HDJVLcLXdmUHAB^JY_/8AkYYQ_`J64dkj>/:Z4PehcbZ4m
g;>4i;j400?]d9P01]>nS[V=:Ng7G=bcG>BnQ=>ZA`;CXBT2bYPD00O:ZVKT
/dOT/bWCZTOLZS?T/dO:ZVH00]bcG006bZYVi;=7g;=LbZ4mi;=7bZ4m0^Bc
A`0=g;=LbZYVkM2HWW/cm/LmkLMLkLN4g;=LkLN4g;=Li;<ckKhmdj4Y00;C
V0X00m>Q:K1E0;1E0003Pbl000NNGQCT/dOT_XCL/ecT/bW:XE;:V1@00m>Q
:@05dh@0WW8:kLMLg;=Li;j400;L/e`00nBnQ>g7G>fn?@03i;=700OT/c?:
V1CCXBW:V1B`N`Z`SC>NLPX00g]<5004ARl:?A`:4A`:6PT:0Q4L2P0C2@T:
8blc2@T:AT4NPg/c=5DY6RHD6Q8D6PT:4A`:6PT:?A8:i:X0/7/D/7/:WUhD
YT`0LSPDH2lD008/71@04Q4V2QXB514V50T92W]<5>g7Q<6QQ>gfmL[@e]?S
mNg]j^gfmOKoojK7h:JHQ<77`McSe^g]jP;fool01Ooool[@`IFQS/[@`Ng]
jP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
16IVI/c<c6IVI/c<c1RIVIT01?koooooooonooSdl`;ooOl03nc[lOWoon3]
onkooc5<JQXhG2a=MU5dWW^MbX^^f8NZd8faeI>fg9Bhg9Jig`02V;cP00JF
^]bI_MnI_MnI_MnI_MfI_Ml2VKgM2IVnfaRH_MX?VKkK0iVmg@0OVKgOVKgM
VKgOVKgMVKgOVKgMU[[LUk_KU[[LUKWIU[[LUk_KT[KHRJoCMj79SKSSJi70
@FFE;D]m3BQEDfV@l?oom?oon?oonooojngZooomookoknS`oocoooko08RI
VIT00oooolc<c<c<c01Mc<c<00RNLPZNGQB=E@ZVC01b>1B3>02EEAB`N`X2
YVL00ZIb5004WW8:/7/:/7/:/7/Y0k1b000C/7/:YW8D/780/780/7/:JT4:
g;=LdjY7bZY7djY7g:Xc/7/:^Hdc^H@DbYPD/7/DbYPD/7/:diP:00;1Q000
1]>H2/ZH5<ZQD[V=5<ZH:KV=50:iSC<2^H@D00niSAB`N`ZiQ1B`N`[:V1A6
9QBiSABVC02EE@2EEABEXHjVXIREXHj`/kN`_/400l77c00=UJ6>YZ6H`K>]
`K>]YZ6HbZYV^JY_/8eB^HdY/8dcbYPD/5D0ARHD00894PX01A4L2R<L2QX9
2Q4V2PTB2P026Q8D01hJ2@XJ9Q@d;aiP@BVELTN3Neb3GS=P@BU6@AiZEAj3
GS=bEE:ESE:VV6niV5c1/hj3NebESFKT_XCL/ec]d9ST_XC]d9ST_XCLaj?L
/hB`SAkL/ecT/dOT_X@2g:Xc02OCXBWCV0[CXBW:V1CCZTO:XCgT/dOLZS?C
ZTOLZS?CZTOL/ecLZS?L/ecT/dOCXBWT/dOT/c?T/akCZTOT/dOLZS?]aebN
LQCfd8CL/ec]ahCT/dOT_XC]_SgT/c?]aecCXBWCV0[T/ak1Q03:V1B`N`Z`
C0000]>40008bZYVi;j4i;j4kLN4i;<cbZ4mbYPDg:Xc0]>Q:@05bYPDYVL0
on>>kLN4djY700;L/e`04^BnQ=bcG=bcG=bZ<m>ZAnBcAm>ZAm>Q:LZH5;2=
7[V45;2=<iib58=N57]<2W]<54HV53@_7P8A70X07aXB50T9514L2QX92Q4V
54I17W9EDTI17R<_7Q4L2PTB2QXB514L2QX92]>H2[1k2YiN5:IW09j4IX<_
060_514L2R`V51X92Q4L2Q4V50TL560_5>BcAl6QQ=?Sm@02g>?P00o]kN[C
hoG]m_G:d=J=V8k1/jgLhmK]m_GfooGfoooooooCfMJ=V8k:d<7Lhn00HLc<
c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00EVIVK<
c<bIVIUVIVK<c<`05iVIV@0Go?omo_ooookonO?goo[ooo_ooocoo_kon?oo
kOgokOooHWjF:TQZ5CIQ;dn0?5fBEgZ`GH:gI8W0Ihc1JXo6KI;7KY?800A/
TLD016bB`fbAaFbB`fbB``U/T/4HKI?246bB`@9/T/<07fbAaFbB`fbAaFbB
`fbAaFbB`fbAaFfCa6bAaF^A`VfBaVfCa6R=`Ej6]eAoZS=NRA8hIa<eIBI2
LGR=^>7aoo7monWao?_oookono_jmOonnoggnOoloocgo_ono`28VIVI00?o
ooo<c<c<c<`0GLc<c007WW8:WUhDUED0UED0SED:PcP0WUhD00:EE@001JIb
09ib2[1k2[1k5;1k2P02/7/D00J`LP2`N`Z`N`Z`N`Z`LP2VLP02/78000=b
>03L/ecCZTL00]>ZA`07bYPY/8@YbYPD^H@D/8dN`H@0g:Xc00;1Q0003KV=
5<640;V45<ZH5=>ZAkV=5<ZQ?KV45<ZQ?KV45=>Q:KV=5;V45002bYPD00_1
Q03CXBUP;`[LZS?L/ecLZS?:V2W1Q02iSAB`SAjiQ1@00[V=<`0=/8dc/7/D
/8dNdj4Y`H@0bYPD`H@0i;<cg;=LbYPYdj4Y`H@0diP:00;:V1@01THV50TL
51XB514L2R<L2QX92P8A70X02AXB51X92R`V54I17V1158=kG9j4IX=kG4IE
:@02AT4N00aP@BVELTNEQ7^VV6o1/hjVV8BiSC?L/hC]ahCL/hC]d9SL/h@2
kM2H02;ohhkL/hBNSBW]ahCL/ecT/dOL/ecLZS?CXBWLZS?:V1C:XE;CZTOL
ZS?T/dOLZS?T/dOLZS?T/dOL/ecT/c?T/dOCZTOT/bWL/ecCZTOT/dOL/ecT
_XCT/dOT/c>EEAC]aec]ah@2kLML00[]ahCL/ecT/bW]aecT/bW:V1CT/aj`
E@3CQ03T/c<2bZ4m01FiSC?L/hCT_XCL/ecT/dOT/c?T/dO:V1CT/dOLZS?:
XCg:V1B`LP3]d9ST_XCLZS?L/ecLZS?T_XCLZS?T_X@00^BcA`09djY7g:Xc
bYPD/8dN`H@0/7/D/8dNYW8DPehD009kC0X2ARl:018J2@XA70XA70X92@XA
70X92@XJ4Q@d;aj3Nc=6@Ah/9Q@A70XJ4Q@92@XJ4Q@J2@[faak1Q002WUhD
00JVI`1kC1AZ@@XJ4Q@/71@94PX26PT:00P92A@m4P[T/dNVV6o]m_GLhn3]
kN[Lhn02kOKe00cCfMIkSHC1/jgCfMK]kN[]m_Gfm_GooooLhn2EV:?1al7L
hn1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
1VIVI/c<c9VIVIVIVFIVI/c<c1JIVIT06?Son?cooOgko?oloookookdoook
oo[gooWooo;oonkoon[oonKoolGUodIUVbA4O`daKa<iN1]1P1m5Q2=9R2M=
S2Q>S2M=R`HYD8/2:E2922U@QaPWCXD@:E272BU@R`0H:U6<:E2;:4n::U6<
:e:=9Db76dAj43YZ5d9]CWBSa>Coioooh??olOoomOoonooon?[gnocfoooh
m_7]oocnoocoooWoookoR9VIV@03ooooc<c<c<c<05g<c<`01:Ib09iN59EE
59ib50:=E@X2WUhD00FVI`2VLQB`NbV`LP2VLQ@01[1k2P0OWW8:/7/:/780
WW8:/7/:JT4:i;=7bZYVg:Xcdkj>bZ4m^HdDbZ4m^HdDbZ4m`H@0bZY7/8dN
bYPDbYPY^H@DbYPD/8dNbZ4m^H@DbYPD/7/:bYPD/8dNbYPDdiP:00:`SAh2
bYPD00?CXBUZ@@[]ae`00]bcG004dkj>bZ4mg:XcbYPY0[V=:@04g:XcbYPD
^HdYbZ4m0/ZH:@03^HdDbZ4mg:Xc00;CZTL02M>H2[1k2]>H2/640<ZH5=bZ
<eLL00TB2Q4V50028a`:00X94PX/4P0A70XS70XJ9QA69QAP@BVESE:=SE96
@Ah2ARHD00f3GS=ZEAjNQ6K1/jgL/j>`ZXB3GS?T_XCL/hC]d9SL/ec]d9SL
/e`00^g@V004kMW<kM2HYW80kM2H0]bcG003g:Xcdj4Yi;<Y00;CXBT01mbZ
<m>ZAnBcAm>ZAmbcG>BcAlZQ?@02g;=L00CCZTOT/dOLZS?LZS<3i;=700GC
ZTOT/c?LZS?]aebEE@000^g7Q00Kg;=Li;j4kLMLg;=Li;=7i;<Ni;<cbYPD
dj4YbYPD^FL0^H@DbZ4mg;=LdjY7g;>4g;=Li;=7bZ4mi;<ckLMLbZ4mdj4Y
g:Xci;<cdj4Y^H@D00?L/e`08^BnQ<ZQ?NBnQ>BcAmbcG<ZQ?M>Q:MbcG=bZ
<m>Q:LZH5;V45;UW0;24:Iib58=N578h07]<2VY12R<V2R`B01X92PT92Q4L
2PT92Q4L2PT92SdL2W:=?DH_2S@_7PTB2PT92QXB50892@X02<ZH5;Ub<iiN
59iN5;1E08eE2V0_52`B008S70X02PT9514V50T952<L2]bZ<k1kI_Kool[@
e]cSh=?Sm@;]kNX03>gfmH>4Nl6c[M?Ie^g]j^gfmOKoooooongfmIFQS[2c
]mcSh67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<
c003IVIVc<c<VIVI00:IVIT00fIVI/c<c<c<c03oc<c<3/c<c003ooooc<c<
c<c<05g<c<`01Yib59ib2X=N59iN59EE57]100:NGQ@02jIW09ib2ZIb5;1k
2ZIb0:IbD[1b0;1k2[1b0;1k2[1b0002/7/:00n`LP2`N`ZVLP1k@@3T/dO:
XCg:ZTO:ZVKLZS>`SC?:V2ViSAC:V2V`SAkCXBT00/ZH50:iQ1@02kV=5<ZH
5<ZZAk2=7/ZH5;V=:LZH:KV=:M>Q:LZH5;V=5002bYPD01C:XCgCZTN3GQC]
aecCZTOL/ecT/dOLZS?:XCg:V1CCV0[:V1C:V2ViSBViQ2W:V1CCXBWCZTO:
V1CCV0X2djY701KCXBW:V1CCV0[CV0[1Q03:V1CLZS?:V1AP;a@J9Q@A70X9
4PX/4P094PXA9PXS70X/71A69PYZIc=6@Ai6;`Xd;ah2H44Y00QZIc>EQ5:i
ZVo1/hjESE:3GS>iSC?]ah@2i;j400[L/ecL_Zg]d9ST_XC]d9SLaj?]d9RN
LQC]aecCZTL2g;=L0]>ZA`09bZ4mdiP:bYPDg:XcbZ4mi;<cg;=Li;=7i;<Y
00?T/dL01MbcG>Bc<nBc7]bcG>Bc<`02g:Xc0^Bc<`09kKhmUED0i;=7kLML
i;<ckLN4kKhmi;=7g;=L00;T/dL01m>H2]>Q:M>H2[1E0;V45=bZ<nBnQ003
g;=L0^BcA`05i;<Ni;j4bZ4mi;<Yi;=700?CXBT2i;=70]bcG006djY7kLML
djY7i;=7g:Xci;=70]bZ<`0Hdj4Y`H@0`H@0^H@D/7/DYW8DPehDLSP0LSPD
JT4:?A`:4A`:2A8:4A`:2@TD4A`:2@T:6PT:8bH:Pg/cAT4N8bH:4A`:2@TD
0Q4L2P092@TDdh@0bYPY^H@DUEDDWUhDPd40ARHD;2HD008S70X0214L2QXB
51X92PT92]bcG<ZZAngfmM?Sm@;Lhn002Ng]j]?SmNgfmG^=Q:JZXnC@c=cS
h>gfmOKfm@02m_oo00>VZZ>VXIS]kNX0HLc<c004IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT00iVIVOmVIVH@IVIV
00?oooo<c<c<c<`0GLc<c003WW8:UEDDSED:00:=E@X01H<h09EE5:IW0:I<
0:Ib5002/7/D00j`LP2`NaB`N`Z`SAj`N`Z`LP2iI`2`N`ZVLP2`N`ZVLP2`
N`Yb>03T/dL2bZ4m01KCZTOLZS?:V2W:V1B`SAk:V2ViSAC:V2W:V1CCXBVN
LPZiQ1BiSAC:V1C:XCfiQ1C:V2W1Q03:V2V`SAkCXBV`SAh2bYPD00G:V2W:
V1CLZS=ZEAkL/e`00]>ZA`06bYPDdj4Yg:XcbYPDbYPYdiP:0/ZH:@0U/7/:
^Hdcdj4YbYPD^H@DbZ4mg:XcbYPYdj4YbYPDdj4Ydh@0bYPDdiP:bZ4mdj4Y
/8dNUEDDH2lD;1806Q8D6Q`N6PT:6Q8D6Q`NH5hc8blNAT4N;1`DAT4NJUDN
Pg/cYXABYYQ_/:Z4YW9B/8dc00;:XE801^BnQ>C7`NBnQ=bcG>g@V>g7G0?]
d9P01OoSSW]<2^BcAmbZ<mbcG002djY700?L/ecLZS?CXBT00]>Q:@06g:Xc
i;=7i;j4g;=Ldj4Yg;=L0^BcA`03i;<Ni;<cdjY700;L/e`08>Bc<mbZ<nBc
<mbZ<nBc<heE2]bcG>BnQ>Bc<oKII]bcG>g7Q>Bc<nBc7^BcAlZH5>Bc:NBc
<lZH5;1E0=>H2/ZZI^BcAlZZI]bcG>BcAmbcG>Bc<nBcAm>Q:LZH5>Bc<`;C
XBT03lZH5>g7Q=>ZAmbcG>BnQ>BcAmbcQ=>ZAlZZI^Bc<lZQ?NBc<m>Q:LZH
5;2=7P02/7/:00b`NbVVLP23GQAkC0Yk@@1Z@@XS9PXS70XA70X94PX92@XA
9Q@24A`:01dJ4QB3Nc=6@Ahd;ahA9PXA70X92@XA70X92@[CQ03:V1BiI`2V
C02`E@2=E@Yb>1@m70XS70XA70XJ9Q@J4Q@A9Q@92@ZiSC>`SE;fooo:d=K]
kN[ChoD00^g]jP07m_ooNheVYZZ]b]31g>?PkNgZm_Ke00;fool00k2c]jJQ
V=cSh01Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@3oVIVI4iVIV@03ooooc<c<c<c<05g<c<`01Yib5:IW
09E<:H=108eE2YEE00:=E@X00jIb5;1k59ib2P02/7/:00VVLQB`NaB`NaB`
LP2`N`ZVLP2`LP2VLP2`N`X00[1b0006Pd40kLMLdjY7bZ4mbZ5BbZY70/ZQ
?@0@^H@DbYPD^H@DbYPY`H@0^HdY/7/:`H@0diP:bYPDdiP:^H@DbZY7^H@D
bZ4m/8dN0/ZH50:iSA@2bYPD00S:V2UkC0[CZTOT/dOCZTOL/ecCZTO:ZVH2
g:Xc00?:V1BiSBW:V2T00[2=7P;:V1@01]>H2/ZH5=bZ<lZH:MbcG=>Q:@;:
V1@03m>H2/ZH5<ZH5<ZQ?LZZAlZH:KV=5:Ib5:IW07]<52`V53@_7TI17V11
:DI17P02H44Y00IZEAibEE:EQ5:`Q7^VQ5:iSC<3bYPY0]>ZA`?L/e`00mbc
Q?KII^g@V003kM2H00JNLQC]_SgL/ecCZTOL/ecCZTL3dj4Y00?LZS?:V1CT
/dL00mbcG003g:Xcg;=Lg;=L00?L/e`02]bZ<nBcAmbZ<mbZ<m>Q:NBc<nBc
7^fn?Iib2]>ZA`;L/e`01^g7G=bcG>g7Q>Bc<mbZ<nBcA`;CXBT03^Bc:MbZ
<m>H2[1k2]bcG=bZ<nBcAnBnQ>Bc<nBcAlZQ?NBc<m>Q:Nfn?@;CXBT01>Bc
7/ZH5=bcG>BcA`;L/e`04=>ZAmbcG=>ZAmbcG=>ZAlZQ?MbcG=bZ<m>H2/ZH
:KV45<640;1k2[1k58=N578h009Z@@X06SdL2Q4L2QX92PT92Q4L2PT92PTB
2PT92QXB56YE7SAE:B`V50T953@_7Q4L2QX92Q4L2YiN5<ZH5;V45;1k:K1E
09EE58<_02`V52<V2P8J2@X00`T9514L2PT92P02^Hdc00c]m_GLhn3CfMK]
kN[Lhn3]kN[]m_F3V8jEXHk:d<7]kN[]m_D3m_oo00?1albEXHk]kNX0HLc<
c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<
c<bIVIT05YVIV@Cnood4o_oo00?mo_onoooloOl00_CenP05kNkch>7VgMgU
f=SRf=ST00CGen<9e]KR<MKFh0SFe^87emOS00OGen7De=kIfN7Sh^[[k?7c
l_OinO/00oooo`?oood5ooooRiVIV@03ooooc<c<c<c<05g<c<`01;1k2YiN
5:IW08eE2P:3@@0028eE2ZIW09EE0:Ib09ib2[1k5;1k2[1k50:`N`X2/780
02>`N`ZVLP2`NaB`N`Z`LP2VLP23@@3L/ec:XE;LZS?:XCf`SAk:XCg:V2Vi
SABiSC>iSAC:V1C1Q02iQ1B3GQCCXBV`SAk:XCg:V2W1Q03:V1BiSBW:V1Bi
SC?1Q02iSC?:V1C:V2W:V1@00/ZH:@0CWW8DbZ5BdjY7djY7g;>4i;=7djY7
dj4YdjY7bYPDdjY7bZY7bYPY^HdcdiP:dj4YbYPDdj4Yg:Xc00;CZTL00m>Q
:LZH5<ZH5002bYPD01CCXBW:V2W:XCg:XCg:ZVJiSAC1Q02iSC=b>1A6@Ahd
;bUP@BU6@AiZIc>3GS>NLS>VQ5;:ZVJiZVn`NbT2bZ4m0]>ZA`07i;=7i;j4
g<NSkM2Hg;=LkM2Hg;>400;]d9P03NgIc>g@V;V=<nfn?NBcAnBc<m>ZAmbc
G=>ZAnBcAm>ZAnBnQ<ZQDP02g;=L00GT_XCL/ecT/dOT_XCL/e`00nBcA`05
g:Xci;=7i;=7i;<NbYPD00;LZS<02nfn?K1k2[V=<nfn?MbcG>BcAnfn?NBn
Q>BcAnBc<nBcA`02dj4Y00GT/akCXBWCV0ZiI`3:V1@00]bcG00GbZYVdjY7
dj4Yg:Xci;=7i;<cJUDNi;<YbZ4mi:X0bYPDbZYVi;=7kLN4bZY7YXABm]UV
djY7i;=7djY7g:XcdjY7g:Xc00;:V1@01[V45;1b0;1k59ib2W]<57]<2P9P
@A@03TH_2Q4L2Q4L2Q4L2PT92Q4L2QXB514L2PTB2V1N<f1153@_7Q4L2QXV
50<92@X01JIW0<ZH5;UW09iN5:Ib5002SED:01@m70XA9PXA70XA70X94PXJ
4Q@A9QAZEAk:XCg]m_GCfMKChoGLhn3ChoG]kN[fooF3V:fVV8C1al7LhmH2
kOKe00Gfooooooo1albVV8C]kNX0HLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT05YVIV@Cnoo/03?kooOko
ookoookooo[noo_oonkam]kQj=[Mi=CGg/W<eLO9e@:i^lP3^;[70kNiaPVi
^lP_^K_72;Vkb0Rj_<T02;^mb/;4d<c<f=7DgMWIhNCUj_;cn?gno`Cnool4
ooom00?ooonIVIVIVIT0RIVIV@03ooooc<c<c<c<05g<c<`01YiN59ib59EE
08eE2X<h09E<:@:EE@002IiN5:Ib09ib2[1k2ZIb5;1b0:Ib5;1k2Yib2P02
/78000>`N`ZVLQB`LP000[1k2P0EPehDg;=Ldj4YbZ4mbZY7g:XcbYPD^HdY
^H@DbYPD^HdD`H@0^HdDYW80Nd40i;<NbYPDbYPY`H@0^HdDbZY700;:V2T0
3;V45;V=:M>H2/ZH5<640;2=7[V=:LZH:H=k<lZQ?MbZ<lZQ?@;L/e`01^Bn
Q>BcAm>ZAnBcAlZQ?LZH:@;:V1@01M>Q:M>ZAlZH5<ZH5<ZH:@02g:Xc00?L
/ecCXBWCV0X00lZH500>i;<NbYPYg:XcbZY7^H@YbYPYbYPD/7/YNd`DJUDN
PehcPg/cYXAB/8eB0lZQDP04bZ4mWW8cbYPYbZ5B0mbcG00<kLN4g;>4kM2H
kLMLkLN4i;j4kM2Hon>>g;j]onf>^IQLg:Xc0mbcG009i;<NbYPDdj4Ydh@0
dj4YbYPDdjY7g;=Li;=700;L/e`07^BcAmbcG>BcAmbcQ=bZ<nBZ0>BcAmbc
G>BZ0=>ZAm>Q:MbZ<nBc:K24:K2=7^BcAmbZ<lZQ?K2=<oK@Q>BcAmbcG>Bc
AnBc<mbZ<nBc:M>Q:NBc:K1k2]>Q:@;LZS<05ng7G>BcAnBcAmbZ<mbcG<ZH
:H=N5>Bc:M>Q:NBc<lZH5=bcG>g7G=c7Xiib2YEbAng7G<ZQ?NBcAmbcG<ZQ
?MbZ<m>Q:@02bYPD00g1Q02iQ1B`NaBNLPZ3GQAk@@1kC0YZ@@Xm70XA70X/
4P094PXJ4Q@00PT92P0D6Q8D0000JVLcAUDY8bH:4BHD4A`:2@T:2A8:4A`:
Pbl0/7/:bYPYWUhD/5D0UEDDNd`D;2HD;1`D8a`:0QXB500A4A`:2@TDLSPD
bZ4mg>?Fg>?PdmWFkNgZg>?FkNgZm_ooUJZ]SHe_`K>]dn?ekNgZkOKe00;f
ool00mcSh8>=Q>g]jP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^0C<c<`00fIVI/c<c9VIV@0FVIVI0_konP;noo/0I?kooOkoooko
ookooo7en>obmm[Mi<C7d;^mbK>g`ZZ/^JJY^9RJZINJZIRIZiJIZ9NHZYFH
YiJGZIFHYiFFZ9BGYYFFZ9BGYYFFZ9BGYYFFZ9BGYYFGYYBHY9FGYYBHY9FG
YYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBH
Y9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FG
YYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBGYYFGYYBG
YYFFZ9BGYYFFZ9BGYYFFZ9BGYYJGZIFHYiJGZIFHYiJGZIFHYiJGZIFHYinQ
/:BW]Zf__;:d`KRja/K9d]_NiNg^l`Cnool2ooom0_oon`03ooooVIVIVIVI
08VIVIT00oooolc<c<c<c01Mc<c<012NLQBNGQB=E@Z=E@ZNGQBEE@2VC02N
GQBEE@2NGQB`N`Z`SAj`NaB`N`Z`NaBVLQ@2/7/:00RVLQBVLP2`N`Z`N`ZV
LP2`N`Z3@@3L/e`2bZY700G:XE;:V2W:XCfiSAC:V1@00[2=7P04bYPD^HdD
/780Nd`:0/ZH500;bZY7bYPYdiP:djY7/8dNbYPY^H@DbYPD^HdD^H@D/8dN
00;:V1@02LZH:HeE2]>ZAmbcG=bZ<m>Q:M>ZAlZZI]>ZA`02bZ4m0]bZ<`07
diP:bYPDbYPDdiP:bYPD^H@DbZ4m00;CZTL01=bZ<m>Q:LZH5;V=50;:V1@0
5m>Q:LZH5<ZQ?LZZI[V45<ZQ?M>ZAkV=:KV=<k2=D[VHG<ZQD/6QQ<ZQ?LZZ
Am>Q:LZQD]bcG9EE5<ZH:MbcG=>ZAmbcG002i;j40^g@V003g;>4dkj>kM2H
00C]d9P07k2=D]bcG>BnQ>BcAng7G6YE7]>Q:LZH5<640=>Q:LZH5<ZQD^Bc
<nBcAmbcG>Bc<m>ZAnBcAmbcG>BcAnBc7]>ZAnBc<ng7G9ib2Yj=<nfn?NBc
:NBc<l6408eE2P02kLML00V`SAj`Q7_]aec]aecT/dO]aecT/c?CXBWT/c<0
0]bZ<`0B^G8cdj4Yi;<ci;=7bZYVi;=7bZ5Bi;=7g;=Li;<Ni;<Ydj4Yi;<Y
dj4YbYPDdjY7bZYVkLML0^BcA`07g;=LbYPDg;=Ldj4YbZ4mi;=7g:Xc00;:
V1@2/7/:00b`NaBNLQBEE@1k@@23@@1Z@@Xm70XA70XJ2@X94PXA70X92@X2
4A`:00H92AAbIe96;`XS;ahA70XJ2@X24A`:00T94PYb>1BiLS>`N`ZVI`2N
GQB3>01kC1@m70X00R<L2P0:6PT:6Q8D4A`:6Q8D?A8:djY7`LO<dn?edmWF
g>?P0]?Sm@07kOKeUJZ]NheV/;k1g>?FkNgZkOKe00;fool00ngfmH>=Q=cS
h01Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
0fIVI/c<c9VIV@0FVIVI06[ooo[loOOmo_Wooo_moocnooolooodn?_Phn[<
cmRn`/fY[KVKWZf@UZJ0PiIoQ9MoPYElPY9lOi9fO8aeN8]cNHUhNhihOXii
O8mgOHeiO8mgOHeiO8mgOHeiO8mgOHeiO8egOH]iO8egOH]iO8egOH]iO8eg
OH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]i
O8egOH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]iO8eg
OH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]iO8egOHehNhafO8ahNhifO8ah
NhifO8ahNhifO8aiO8mhOXijOI1fO8agNXegOHenPIB0QIQnPIB0QIR8Rij@
TjBKWZf[[k^m`Lc;c]OSi^gbmOX2o_oo00GkoO[lo__ooo_ooo_oool0RiVI
V@03ooooc<c<c<c<05g<c<`01:Ib59ib59EE58eE2P:3>0002heE2ZI<09EE
5:IW0:Ib5;1k:KV45:Ib0;1k2[1b0;1k2P02/78000ZNLPZ`LP2`NaB`LP2`
N`Z=E@[T/bWLZS?:XCgLZS<2bZ4m00RiSBV`SAk:V1BiSC?:V1C:V2ViI`2N
LQ@2bYPD00O:V2ViSBV`SAj`SAjiSC?:V2V`SAh00/ZH:@0?`H@0bYPY^HdY
^HdD/8dNPg/c^HdYdjY7dj4YdjY7g:Xcdj4Yg:Xci;<NbYPY00;CZTL02M>Q
:LZH:M>H2]bZ<m>Q:LZH:M>Q:M>ZAlZQ?@03bYPY00_:V1CLZS?CV0[CXBW:
V2W:XCgLZS>iQ1C:V1CL/ecLZS<00]>ZA`04bZ4mbZ5Bdj4YbZ4m0]>Q:@05
i;j4dkj>bZYVdjY7bYPY00;LZS<02=bcG>BnQ>g@V>BnQ>g7G4H_2]bcQ>gI
c0?]d9P01/ZZAng7G=bcG=bcG>g7G8=N<`GCXBT01MbcG>BnQ=bcG=bcG=>Z
A`02i;<c013T/dOCZTOT/dOT/akT/dO]_SfEEABiQ1CCZTO:V1CL/ec:V2VE
EACfd8CT/dOLZS<2kLML01WT/dO]aecT/dO]aecCXBWT/dOTZP3:V1CCQ02i
Q1CCXBW:XCgT/c?L/ecCZTOT/c?CZTOCV0[CXBWT/c?:V1CT/ak:V1BiSC?]
ae`01=bcG006^Hdci;<cbZ4mdj4YbZ4mg:Xc0]>Q:@0>`H@0^H@D/8dNWW8:
SED:JT4:PehDJT4:ARH:;1804A`:;1802@T:4A`:0QX92P040000H44YAT4N
;2HD0Q4L2P076PT:4A`:2@TDEa`0bYPD/7/:/7/D00:=E@X00g]<2R`L52`V
50044A`:00@A9Q@J2@[T/dO1/jd3g>?P0^g]jP07kOKe/;k1Nhf4/;>gb]3F
kNgZkOKe00;fool00ng]jX>4Nng]jP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0FVIVI06_ooo[nooWn
oo[no_cino[in_c`m?OOh^W@dmbk_l^]/;nBUjZ0QIUgO91[L8I`MH]UJWiV
KGmXKH1VKGmUJWeTJgeUJWeUK7iXKH1WKX1XKH1WKX1XKH1WKX1XKH1WKX1X
KH1WKWiXKWiWKWiXKWiWKWiXKWiWKWiXKWiWKWiXKWiWKWiXKWiWKWiXKWiW
KWiXKWiWKWiXKWiWKWiXKWiWKWiXKWiWKWiXKWiWKWiXKWiWKWiXKWiWKWiX
KWiWKWiXKWiWKWiXKWiWKWiXKWiWKWiXKWiWKWiXKWiWKWiXKWiWKWiXKWiW
KWiXKWiWKWiUJWeTJgeUJWeTJgeUJWeTJgeUJWeTJgeTJGaUK7iWK7mVKGmU
JWeUK7iXKH1ZLHA`MH]TJX1TJGmdNHn7S:2HVjjY[;fi_LW;cMWPhn[gn?d0
0_koo`04oOoloOkio?ghooooRiVIV@03ooooc<c<c<c<05g<c<`00jIb59ib
59iN5002SED:00B3@@1kC1BEE@2=E@X2YW8D00>`NaBNLPZ`NbT00[1k2P03
YW80/7/:YVL000:`LP004ZIW0;1k2[1k2X=10=>nS]bZ<lZH:LZZAlZH5<ZQ
?LZH5;V=<lZH:LZH5;V=<m>ZAk1k5;1k2P;:V2T02]>Q:K2=7[V=:LZH:K2=
7/ZZAkV=:LZH:LZH5;V=50C:V1@028=N5<ZQ?MbZ<m>Q:LZH5=>ZAmbZ<lZH
50;:XCd03LZH:NBcAm>Q:LZQ?M>H2/ZH:M>ZAlZQ?KV=:LZQ?MbZ<lZH5=>Q
:@03bYPD00mP@BWCXBW:V1C:V2W:XCfiQ1CCXBW:V2WCXBWT/c>3GS>iV5c:
XCgLZS?:V1@00m>ZA`05i;=7g;=LdjY7djY7g:Xc00;L/e`01NBnQ>g7Q>g@
V>BnQ>g7G005kM2H00?:XCg:ZVKL/e`00]bcG008i;<cbYPDg:Xcg:Xcdj4Y
g;=LdjY7g;=L0^BcA`0;g;=LbZYVg:Xcg:Xci;<cdjY7i;<cdjY7i;=7kLML
g:Xc00;CXBT03mbZ<m>Q:H=N5>fn?NBcAmbZ<ng7Q=bcG>BcAnBc<nBcAnfn
?NBc<m>Q:NBc7P02dj4Y00KCQ03CXBW]_SgCZTOT/dOCZTL2i;=700OCXBWC
V0[LZS?TZP3:XCgCXBV`SC<00^g7G006djY7g;=LkLMLbZ4mi;=7bZ5B0]bZ
<`0SbZ4mdiP:bYPD^HdD/7/:YW8DWW8:UED0LSPDLSP0JT4:ARl:4A`:8a`:
2A8:6Q8D2@T:4A`:2@TD4A`:H5hcAT4N8blN6PT:4A`:6PT:2@T:4A`:;1`D
WUhD^FL0/7/:YT`0UEDDNd`:008m70X00b<L2Q4L2QXB50026Q8D01@J2@[f
fFKL/j?]kN[CfMKLhn3ChoG]kN[]m_G1alakSFK1/jg:d=K]kN[]m_Gfooof
ooGooomZNfo]m_EQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^0C<c<`00fIVI/c<c9VIV@0FVIVI077ooo_loOSno_cooogloOoin_kX
jo;BeMjn`/jQY;F>TJAkP9InPY^=TjfDVKJRZ<;7cN?9dNC?e^WAfNcAf>_?
en[>eNS=eNS?e^W>e^W?e^W>e^W?e^W>e^W?e^W>enS?e^S>enS?e^S>enS?
e^S>enS?e^S>enS?e^S>enS?e^S>enS?e^S>enS?e^S>enS?e^S>enS?e^S>
enS?e^S>enS?e^S>enS?e^S>enS?e^S>enS?e^S>enS?e^S>enS?e^S>enS?
e^S>enS?e^S>enS?e^S>enS?e^S>enS?e^S>enS?e^S>enS?e^S>enS?e^W>
e^W?e^W>e^W?e^W>e^W?e^W>e^W=e>O=eNS@en[@f>_?e^W=eNS>eNS=eN[0
a^2Y/<bGW;V;TJ]lPYYgO9:<TJF//LBg^/W>d]g[k_Gkooonooonoognoo_m
oo[oool0RiVIV@03ooooc<c<c<c<05g<c<`2YW8D01BEEAB=E@Z3>02=E@Z3
@@2NLPZNGQBVI`2NLPZ`NaB`N`Z`NaB`N`Z`LP2`N`ZVLP2`NaB`LP2NLPZ`
LP02WW8:00R3@@3LZS?L/ecLZS?:XCgLZS>`SAjiSA@2^HdY00W:V1C1Q03:
XCfiSABVLQC:XCgL/ec:V2ViSBT00/ZQ?@03^HdDbZ4m^H@D00;:V1@00m>H
2[2=7/ZH:@02`H@000bNLQC:XE;L/ec:XCgCZTOT/dOL/hCCZTOLZS?:ZTOL
ZS?CZTL2bYPY00G:V1CCV0[:V2W:V2W:V1@00/ZQ?@;:V2T01=>Q:M>H2/ZH
59EbA`;:V1@01Nfn?LZH5;V=5=>Q:MbZ<`03dj4Y00C:V1CCXBWCV0[CXBT2
g:Xc00[CZTOL/ecT_XCT/dOCZTOLZS?T/dOL/ec]d9SLaj<2kLN400gT_XC]
d9S]d9S]d9S]fLcokHk:ZVKCZTOT/dO]_SgL/ecCZTOLZS<00]bcG00Pi;j4
g;>4djY7i;<cg;=Li;=7g:Xci;<Yg:Xci;=7i;<Ndj4Yi;<cdjY7i;<ci;=7
bYPDdj4Yi;<Yg:XcbYPDUEDDm]24i;<cdjY7g;=Li;=7i;<ci;=7i;<ci;=7
bZYV0^Bc:@07bYPDdh@0bZ4mi;<YbZ5Bi;=7djY700;T/dL01M>ZAnBc7/ZH
5>Bc<m>Q:@02bYPD00>iSC?]aecLaj<00mbcG0;CZTL01mbcG<ZH5=bZ<m>Z
AlZH:LZH5<640002/7/:00VNLPZ3GQAb>01kC1Ab9P0m70XS70XA70XJ2@X0
0Q4L2P062@T:4BHD2@T:AT4N=2lN8bH:0Q4L2P082@T:2@TD6PT:;1`DYW8D
`H@0YW8DSED:0W]<500<ARH:;2HD4A`:6PT:4BHD6Q8D2A8:0000on>>g<NS
kOKeb]3F0]cSh009kNgZdn?e`LO<Nhf4`K>]b]3FkNgZkOKem_oe00;fool0
0h=kG>g]j/c<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^0C<c<`00fIVI/c<c9VIV@0FVIVI01?ooo_ko?Ono_coooomo_oem__M
h>W2a=6Z[Kj;T:AoQ9Z2R::NXl30aN?:cnoEg?W?enkAg>kFhO<00][Um`03
f>?een;de^7c00SHhoD`f>Cd2=WTmP0Fen;df>?ef>?ef>?een;deN3be=oa
e=oedMSecmGec=;b`<KVY:W7QX^XP8BORXnUZZg0_l;Ag=kZl??hn__ooOon
0_koo@03ooooVIVIVIVI08VIVIT00oooolc<c<c<c01Mc<c<00RVLQBNLQBE
E@2=E@YkC0YkC1BEE@2=E@X2UED00[1k2P06WW8:/780WW8:/7/:/780/7/:
0k1b0005YW80/7/:/7/DPd40g:Xc00;:XCd05lZH:LZQD[V=<k24:LZH5;2=
7/ZH:KV45<ZH5;V45<640<ZQ?LZH:LZQ?L640;V=<lZQ?LZH:LZZAkV45=>Q
:DIE:LZH:@03bYPD00V`SAjVLQC:XE;T_XCL/ecT_XC:XCddEBW]_Sd00mbZ
<`07bZY7dj4YdiP:bZ4mbYPDbYPYbZ4m00;:V2T01=bZ<m>Q:M>Q:M>H2P?:
V1@04=bZ<m>H2/ZH5>Bc:K1k5<ZH5=>ZAm>Q:MbZ<lZQ?M>Q:LZQ?M>Q:M>H
2/ZH:M>Q:@CL/e`01NBcAmbZ<mbZ<mbcG>BnQ002kM2H00?C_XkT_XC]d9P0
0ng@V00:kMW<bZYVi;=7g;>4g:Xci;j4g:Xcg;=Lg;>4g;=L0]>Q:@06bYPD
bZ5Bi;=7i;<cdjY7bZ4m0^Bc<`03bZ4mg:Xcdj4Y00;T/c<00mbZ<m>Q:MbZ
<`02g:Xc00OCXBV3GQC]aecLZS?L/ecT/dOL/e`00^Bc<`0Gi;<YkLMLi;<c
i;<cdj4YbYPDdiP:dh@0^HdcbZ4mg;=Li;=7g;=LkLMLdjY7dj4YbYPDi;<Y
dj4YdiP:i;<NWUhDkLML00?L/e`01=>ZAmbZ<nBcAm>ZA`?CXBT02lZH5<64
0;V=5;1b0;1k2ZIb09ib2W8h07]106Y12TH_2P034A`:00<J2@X92A@J4Q@0
0PT92P03;2HD;4`Y;2HD008A70X05PT92Q4L2Q4L2QX92[1E0;1k59ib2ZI<
07]<58<h04HV52`L52<L2Q4L2QXB50TB2QXB50000>g@V=>nS]cSh=?IeP?L
hn003>gfmMcSh7:=Q:JZXl[@`McSh>gfmOKoooKomOKoog:=G>g]jV7<c<`0
16IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<
VIVI01JIVIT04ooooOcln_ooooooooKgnnKVk/S:eZRZ^I2CYXJ;XI>G/ZBY
akg2h/oEmlW?llcBm=CPm]OTmM[Wn002g>Wj0m_Xn@SQk_l`hNkn2=k[o004
gncmgN[kfnSif^Oh0mWVm`0BfNGkcMKgc=CibM7ea<c`_L?UZk7ATYNeO82K
UYR_ZJbob<[Gh^G/loCinO[lo?kko_omooooRiVIV@03ooooc<c<c<c<05g<
c<`2YW8D00>NGQB=E@ZEC2T00W]<2P:EE@0029iN5:Ib0:Ib5;1k2Yib2[1k
2[1b09ib2P:`LP001iib2ZIb0:Ib0:Ib0:Ib59EE0<ZH:@03bZ4m01GLZS>i
SAC1Q02`SAk1Q02`SAjiSAC:V1B`N`Z`LP3:V1C:V2W:XCg1Q02iSC?:ZTO:
V2W:ZTN`SAk:XCeP;a@00lZH500?diP:bYPD/8dN^Hdcg<NSdjY7g;=LdjY7
WW8DdjY7g:XcbZY7i;<Ndj4Yg:Xc00?:V1@01M>Q:LZH:LZH5<ZH5<ZQDP03
dj4Y00WCV0[:V1C:V1CCV0[CZTO:V1C:XCf`N`[LZS<00]>Q:@03g:XcdjY7
bYPD00;CXBT2bYPD00?CV0[CZTOL/e`00]bcG009bYPDdjY7i;=7g;=Li;j4
kLN4kM2HkLMLi;j400G]d9P02MbcQ=bZ<m>ZAnBc7]bcG=>ZAmbcG=bZ<lZH
5002dj4Y00GCZTOT/c?:XCg:XCgT/ah00]bZ<`05i;<cg:Xci;=7i;<cdjY7
00;T/bT02mbZ<m>Q:MbZ<nBc<nBZ08eE2^g7G>Bc<nBcAnfn?M>ZA`02i;<c
00[T/dO:XCgT/c?CXBWT/ak:V1B`N`[CQ03:V1CCXBT3i;=700_]ahCLZS?C
XBWCV0[T/ak:V1CTZP3:V1BVI`3]aecT/dL00]bcG0;CZTL04/ZQ?M>ZAm>Q
:LZQ?M>Q:LZH5=>H2[V45;1k2ZIb09ib2XeE2W8h07]<2VY12TH_2R<L2R`B
00<A70X01PT92Q4L2PT92S@_7THV52<_7P<A70X050TB2PT92QXB58eE2[1k
5:IW08eE2W]107]<2SdB2R<V2R<L2QXB50TB2QXB514L2P000>g7G>BnQ=cS
h0;CfMH02=cSh=?SmNg]j]cSh8fHSZJQV<[@e]cSh0;]m_D01?KomOooohf=
D^g]jV7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<
c003IVIVc<c<VIVI01JIVIT05?oooOcln_oooooooo7bmmgMikfoc9^N[h63
V8V=YZJ[bKFjf[k4j<G:l<C9lLkFn]CPn=CTm=KVm]OWm`;Fi_H00mOWmmSX
n=_[n`07fn_k<=_[nPSIjOT00m_[nmWYnMKVmP04eNGe01;Dho[MiooKhoo=
eObla>Vf^n6b^=bSYlZAU[B4R:>HVZni^l[Kg^OdmO[loOomookmoocooon;
VIVI00?oooo<c<c<c<`0GLc<c00@YW8DWW8DSED:SED:Nd`:Pd40LSP0SED:
UEDDYT`0YW8D/7/D/7/:WW8:/780WW8:0[1b0007YW80/7/:YW80YW8D/780
YW80SED:00;:V2T2g:Xc00B3GQAZIc>`SAj`SAh2^HdD02_1Q02iSC>iQ1C1
Q02iSACLZS?:V2W1Q03:XCgCZTN`SAkLZS>`N`[:V2W1Q02iSAC:V1C:V2Vi
Q1C:XE:iQ2V`SC?]aecL/ecCZTOL/ecT/dO:XCg:V1CCZTO:XCgLZS?CZTOC
V0[CXBW:V2W:V1C:V2ViQ2WCXBW:V2WLZS?CXBT00/ZH50?CV0X2bYPY00KL
/ebiSBW:V1CCZTOLZS?CZTL3dj4Y0/ZH5003diP:bYPDdj4Y00;L/e`02]>Z
AmbZ<nBcAnBcAmbcG>BnQ=c7XnBnQ>g@V>g7G0G]d9P01]bcQ=bZ<m>ZAm>Z
AmbcG=bZ<`?CXBT01<ZH5=>H2[V=<m>ZA`;LZS<01]>Q:NBc:MbZ<nBc7^Bc
:LZQ?@;T/c<00nBcAmbZ<mbZ<`02i;<N00[:XCgT/ajVLP3]aecCZTOLZS?T
/dOT/bWT/dO:V1@2i;<c00k]_SgCV0[LZS?:V1CCQ02`N`[CXBW:XCgT/dO:
ZVKL/ec]aecLZS?CXBT2bYPD01?T/ak:V1C:V1BVLQCfd8C]ahCT/dOT_XCT
/dOL/ecCXBWT/c>iSBWLZS?:V2W:V1C1Q03CV0Z`LP000[1k2P0:WUhDNd`:
Nd`DJT4:H2l:4BH:8a`:6PT:2@TD6PT:0Q4L2P052@T:;2HDAT4N8blN2@TD
008A70X02`TB2Q4L2PTB2W8h5:IW08eE2ZI107]<58<h02`V52`L50024A`:
00T94PXJ4Q@A9Q@0003L/ecT_XCLhmKChoGCfMH00]cSh007kNgZg>?PPhAk
UJ6>b]3Fg>?Pong<00?fooD00hf=D^g]j/c<c01Pc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0FVIVI01Cm
oOgkno_oooomo?o[jo?EeN6e]lJEV:^6R9n=TJbVZl^a]MRg_>;3b?;9d?cK
iOo?g_GAh_;DiOGFioL3eNKf00?FioOEi_KEi_H01]GVmS3EioD8e^Og01WH
jOWFioOEi_KEi_KFioOEi_KCi?CAh?O1bno8dO[<eOk6coRk`^b^/mVNX/NC
V;R3QjB?U:Z]/<7Be^7_l_Wkooonooonoogoool019VIV@D00004VIVI1000
00:IVIT200000YVIV@800002VIVI1@0000:IVIT2000000>IVIT000000000
1YVIV@@00002VIVI0P0000BIVIT2000000BIVIT00000002IVIT200000YVI
V@@00003VIVI100003fIVIT00oooolc<c<c<c01Mc<c<026NLQBNGQBEEABE
E@23>023@@1kC1B=E@ZEE@2=E@Z`NaBVLQB`NaBVI`2`N`ZVLP2NLPZ`N`ZV
LP2EE@0/>2VVLQBVLP2`N`Z3@@3CXBW:ZTO:V1C:V2V`SAjNSBViQ1C:V1@0
0[V=500?^H@D^HdD^H@D/780/7/DdiP:/8dN^HdcbYPDbZY7bYPYbZ4m^H@D
bYPY^H@D00;:V2T01]>H2[2=7/ZH5;2=<ij=<nBnQ0;L/e`03=>ZAm>Q:M>Z
AmbZ<lZH5<ZQD]>Q:MbZ<lZH5=>ZAlZH5>Bc:@;:V1@00lZH:LZH5=bZ<`02
dj4Y00?:V1CCXBWCXBT00m>Q:@03djY7^H@Ddj4Y00;LZS<01^BcAmbZ<m>Q
:M>Q:M>H2[2=7P?:V2T02M>ZAmbcQ=bcG=bcG>BnQ=bcG>BcAnBnQ>g@V003
i;j41Ng@V009dkj>djY7g:XcdjY7g;=Lg:Xcdj4YdjY7dj4Y00?:V1@03=>Z
AmbZ<mbZ<mbZ<m>Q:MbZ<nBc<lZQD^Bc<nBc7/ZQ?Nfn?@;LZS<05m>Q:MbZ
<nBc7^Bc7XeE2]bcG>BZ0=bZ<nBc<mbZ<nBcAmbZ<nBc<lZH5>Bc:LZH5>Bc
:M>40<640;UW0<ZH:LZQ?Ng7G002i;=700GL/ec:XCgLZS?CV0[TZP000/ZH
5005diP:WUhDkLN4g;=LbZYV00;L/e`01>BcAlZQ?M>ZAlZH50;CXBT02<ZH
:M>H2[V45;1b0;1k2ZIb59EE57]1009b>0001DHV52`B014V2PTB2Q4L2P03
2@T:00@94PXJ9Q@d;ahS9PX24A`:00H92@X94PXJ2@XJ4QAG702VLQ@2SED:
00ikC0Yb>00/9Q@S9PXS70XA70XJ2@XA70XJ4Q@92@[:ZTO:ZVK:d<7CfMH3
g>?P00K]m_GLhn23SHB=SFo1alcLhmH2m_oe00CLhmK:d<4dEBW]kNYQc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<
c9VIV@0FVIVI01?oo_oooOkoo_oin?gQhN_5amBTYkZ2QYn=T[2=TKBPY<Z/
/MVi_^S4bO?2ao78d?G7dng9f>g>gO800]7Pm@;@go@00m3Ol]3Om=3OlP07
d=ob00k@h?3@go;@h?3@go;@h?3@go;@h?3@go;@h?3@go;@h?3@go;@h?3@
go8Cd>3`00c@go;@h?3@go;@h?3@go;@h?3@go;@h?3@go;@h?3@go;@h?02
d=ob0/oNl@0OcmkccmkacmkccmkacmkccmkacmkccmkacmkcdN3cdn;gdN3c
c=_`b=K`dm_oa/gk_LC`_/G_^/7[ZK7HUic2S9:fR8b_S96_XJFna<OHi>Kb
m_Oko?cloookoooo00BIVIT200000YVIV@800002VIVI0P0000:IVIT20000
00>IVIT0000000000YVIV@8000000iVIV@0000000002VIVI0P000004VIVI
00000000VIVI0`0000FIVIT200000YVIV@8000000iVIV@0000000003VIVI
0P000005VIVI000000000000VIVI008000000iVIV@0000000002VIVI0P00
0003VIVI0000000000:IVIT20000?9VIV@03ooooc<c<c<c<05g<c<`01:Ib
59ib59ib2ZIW009kC1@019EE08=107]<59iN50:VLQ@01JIb09iN5:Ib09ib
2[1b0002YVL000^`LP2EE@2VLP2`N`ZVLP23GQC:V2W:ZTO:XCg:ZTO:XCd0
0kV=:@0A^H@D^HdD^H@DbYPD^H@D/780^HdD/8@Y/8dN`H@0^Hdc^IQL/8dN
dj4Y^H@DbZ4m^H@D00?:V1@01L640;2=7[24:JJ4D^g7G002g;=L0]>ZA`03
dj4YbYPYbZ4m00;LZS<03<ZH:LZH5<ZH5<ZH5>BcAlZH5;2=7/ZH5<ZQ?M>Z
AmbZ<m>Q:@?:V1@01m>H2/ZH5<ZH:M>ZAk2=7/ZQ?LZH5002dj4Y013:XCgC
XBW:V1BiQ1C1Q02NLS>iQ2WCXBWCZTOL/ecCZTOCXBW:XCgL/ecT/dOC_Xh2
i;j400?]d9SL/hC]d9P00^g@V00:kLN4kM2HkM2HbYPDi;j4g;=LbZYVdj4Y
g;=LdjY71M>Q:@08bYPDi;=7g:Xcdj4Yg:Xci;<cg:XcdjY70nBc<`03i;<Y
g:Xcg:Xc00;LZS<03>Bc:K1k2^BcAnBcAmbcG>Bc<m>ZAnBcAnBc<nBc:M>H
2^Bc7P?:V1@02[1k2]>40=>40=bZ<m>ZAmbcG>BcAm>ZAmbZ<m>H2P?:V1@0
1]>40=>H2ZIW0>BnQ>g7G>BnQ0CL/e`00m>ZAlZH5=>Q:@02dj4Y00NiI`2i
SAB`LP2`N`ZVLQB3GQAZ@@X00W]<2P0TEa`08bH:8a`:6PT:4A`:2@T:2A8:
4A`:6PT:8a`:=2lN8bH:4A`:6PT:4A`:2@T:4A`:2@T:?A8:YW8DPd40Nd`D
LSP0LSPD?A8:8a`:4A`:6PT:2A8:4A`:6PT:0000WUhDkM2Hg;>Sb]3F0]?I
eP;LhmH02>C@c<6cSVYW<iFQSZJQV7^=Q3eN?@TB2P8000000oKoolc<c<c<
c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
0fIVI/c<c9VIV@0FVIVI017oo?oooOoooOofmO_Ti?2n`MBHW[Q]LiElPjf:
TKnIWm6VZ]Z^/^6h^nK0`^W2a^W7d>l00/G@k006am;^bmKbc=OcbmKbb=C^
b]Ga2<[Fl00>b]K^b]K`b]K^b]K`b]K^b]K`b]K^b]K`b]K^b]K`b]K^b]K`
b]K^b]K`4l[FkP0<b]K`b]K^b]K`b]K^b]K`b]K^bmOabmO_bmOabmO_bmOa
bmO_1<_Gl@0ObmKbbmOabmKbbmOabmKbbmOabMC`b]K`bmKbc=Sbc=Ocb]K`
b=?_b=7ba/WfaLOh_l;_][_U[KGLYJgDV:7:S9FnOXFaKW>MVIg2`<7Ogmk`
m??ioOcjooojooom00BIVIT200000iVIV@8000000iVIV@0000000002VIVI
0P000003VIVI0000000000:IVIT2000000>IVIT0000000000YVIV@800000
0iVIV@0000000002VIVI0P0000BIVIT200001YVIV@800003VIVI0P0000:I
VIT2000000>IVIT00000000019VIV@<000000iVIV@0000000010VIVI00?o
ooo<c<c<c<`0GLc<c006WW8DYT`0SED:WUhDNd`DLSPD0heE2P0;UED0/7/:
WW8:/8dcWW8:/780WW8:YW80WW8:YVL0WW8:00:VI`001K1b09ib2Yib2/ZQ
?M>Q:@04bZ4m0[V=:@:iQ1@04;1b0;V=5<640;1b0;1k5<640;2=7[V45=>H
2/ZQD/ZH5<ZQ?KUW0<ZH:LZH5;V=<`?:V1@01kV=<kV459j=:MbcG>BnQ=bc
G>BcA`02djY70]bZ<`03bYPYdjY7dj4Y00G:V1@01KV=:LZH:M>Q:M>ZAmbZ
<`02dj4Y00_TZP3:V1C:V2W:V1CCV0[:V1BVLQC:V1B`N`ZiQ1C:V1@00/64
0007/8dN/780YT`0SED:`H@0bZ4mdjY700;CXBT00lZH5=>Q:MbcG002g;=L
00C]d9ST_XC]d9SffFH3kM2H00o]fLc]d9SL/hCCZTO:ZVKCXBWT/dOLZS?C
XBWLZS?CXBViSC?CQ03:V1CCV0X01=bZ<`0:i;<cg;=Lg:Xcg:XcbZ4mdj4Y
i;<Yg:Xci;<ci:X00]bZ<`0@i;<NYW80g;=Lg:Xci;=7djY7i;<ci;=7bZ4m
i;<cdj4Yi;<cdj4Yg:Xcdh@0`H@00[1k2P05dj4Yi;<cdjY7g;=LdjY700;C
XBT3bYPD0]>H2P04/780g;=Lg;=Li;<c0nBcA`09djY7g;=Ldj4YbYPYdj4Y
djY7diP:`H@0/78000>NLPX0178h06Y12W8h54H_2P8S70X00`T92Q4L2PTB
2P022@T:00LA70XJ2@Y6@AhS;ahA70X92@XA70X00PT92P0I6PT:6Q8DYT`0
LSP0H2l:ARH:H2l:?A`:4A`:6PT:4A`:6Q8D2@T:4A`:2@T:Ea`0i;<YYZ5V
g>?Pb]31g>?FdmWF`K>]UJ6>?Ehm00D00000114L2QXB50000?KfmF7<c<`0
16IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<
VIVI01JIVIT06OokooolooomooSeo]oQk[k3fHF;ZfacWG^3]8R?aINLe:2U
g:R/g;2cg[NigkZmh<36j[g5jKg5j/38k<?;l<K>l/G=lLC=k/C<l002a<g^
01C4cNc4cNk4cNc4cNk4cNc4cNk4cNc4cNk4cNc4cNk4cNc4cNk4cNc4cNk4
cNc4cNk4cNc4cNk4cNc4cNh2a<g/00g4cN[4cNc4cN[4cNc4cN[4cNc4cN[4
cNc4cN[4cNc4cN[4cNc4cNX01<C=k00<a<g^a<g/a<g^a<g/a<g^a<g/aLk_
aLk]aLk_aLk]aLk_aLk]1<G>k`0OaLgaaLk_aLgaaLk_aLgaaLk_a<c`aLk_
aLgaaLk_a<c``/_/`<S/`<G[`<3b_[k`^;_X/;GOZ;3GWjSATYk8Qi;0OhNh
JW2PP8>`_KgQhn7goOcoookko?Wbooom00BIVIT200000iVIV@8000000iVI
V@0000000002VIVI0P000003VIVI0000000000:IVIT200000YVIV@800000
19VIV@00000009VIV@800002VIVI0P0000BIVIT200001YVIV@800003VIVI
0P0000:IVIT2000000>IVIT0000000000YVIV@@00002VIVI1P0003bIVIT0
0oooolc<c<c<c01Mc<c<0Yib2P05LSPDPd40LSP0Nd`DUED000:=E@X01YEE
09ib2ZIb0;1k59EE0:Ib00:VI`000jIb0:IW0:Ib0002/7/D00RNLPZNLQBE
E@3L/ec:XCgCZTO:XE;:XCd2bYPD00RiSAB`SAjiSAB`N`ZiSABiQ1C1Q02i
Q1@3^HdD00k:V2W:XCfiSABiV5b`SAk:V2ViSBW:V1C:V2W:V1CCV0[:V1Bi
SBV=SDL2g;=L017L/hC:ZVKCZTOL/ec:XCg]_Sg:XCgLZS?CXBViSAC:V1CC
V0[:V1C:V2W:V1C:V2WCZTL00]bZ<`04bYPDdiP:bYPDdiP:0lZH500>g:Xc
bYPYbYPYbYPY/8dN^H@D`H@0^HdD`H@0/5D0PcP0^H@D^HdDbYPD0]>Q:@04
djY7bZ4mg:Xci;=70]bcG006kLMLi;j4kM2Hi;j4kM2Hg<NS0ng@V006g<NS
bYPYi;=7djY7i;=7dj4Y0]bZ<`05i;<YbYPD/7/:bYPDdj4Y00;LZS<02]bc
G<ZQ?MbZ<mbZ<nBZ0=bZ<nBc7^Bc<m>ZAnBZ00;LZS<02=bcG>Bc:MbZ<k1k
2]bZ<m>ZAnBc<lZQ?@;T/dL00m>ZAnBc<lZH5002dj4Y00S:V1C:XCgCV0Zi
I`31Q03:V1CCZTOLZS<2i;=700CCV0[:V1C:V1CCV0X2dh@000G:V1B`N`[:
XCgL/ec]ah@00]bcG00Ai;=7g:Xcg:Xcg:Xcdj4YdiP:bYPD^H@D^HdD^FL0
WW8:/7/:SED:Nd`:LSP0Nd40Ea`0008S70X0114L2QX92Q4L2PT92P894PX0
0a4L2R`V52`V50024A`:0PT92P084A`:6PT:2@T:SED:Pbl0H2l:H2lDEa`0
0R<L2P036Q8D6PT:4A`:00892@X0214L2PT92R`B03@_7Xf=Kg:=G14V514V
2P8000002PT92Q4L2PT950TB2QXB514V51XL7QX92P000?Koof7<c<`016IV
IXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI
01JIVIT06Ooko?omoOomooSgom_Mk<75gVY`TVedX7Mn]8:;a96GdIZOej6T
ejR[f:naek2dfKBihK6hh[:iiKBkiKRojk_2k;c3kKc4jk_2k002^l?Z01Bk
`nRk`nZk`nRk`nZk`nRk`nZk`nRk`nZk`nRk`nZk`nRk`nZk`nRk`nZk`nRk
`nZk`nRk`nZk`nRk`nX2^l?X00fk`nNk`nRk`nNk`nRk`nNk`nRk`nNk`nRk
`nNk`nRk`nNk`nRk`nL01;_3j00<^l?Z^l?X^l?Z^l?X^l?Z^l?X^l?Z^l?X
^l?Z^l?X^l?Z^l?X1;_3jP0O^l;/^l?Z^l;/^l?Z^l;/^l?Z^l;/^l?Z^l;/
^l?Z^L3Z][kU];_U];WS]KOX]KGW[k;OZ:cIXJSBVJ;=S9O5PXboNH2fJFnS
IVZG_/7Th>7foOcoookknoSaooom00BIVIT200000iVIV@8000000iVIV@00
00000002VIVI0P000003VIVI0000000000:IVIT200000iVIV@@000000iVI
V@0000000002VIVI0P0000BIVIT200001YVIV@800003VIVI0P0000:IVIT2
000000BIVIT00000002IVIT3000019VIV@800002VIVI0P0003bIVIT00ooo
olc<c<c<c01Mc<c<0ZIb500;SED:Nd`:Pd40Pd40UED0PcP0UEhcUED0SED:
YT`0YW8D00:EE@001ZI<0:Ib0:IW0:IW0;1k2Yib2P:VLP000iib2Yib5<ZZ
A`02bZY700WCZTO:ZTO:V2ViSBViSAC1Q02iQ1B`N`[:V1@00[V4500D^FL0
bYPD^H@D^HdD^HdcbZYV`H@0g:Xc/8dc/8dNbYPYbYPD^HdYbYPD`H@0/8dN
^HdYPg/ckLMLg;>40mbcG0;CZTL00m>Q:MbZ<mbZ<`03bYPD00[:V2WCXBW:
V1BiSBV`SAk:XCgCXBWL/ecLZS?TZP02bYPD00KCXBW:V1C:XCgCXBViQ2W:
XCd2bYPY00W:V1CCXBW:V1C1Q02`E@2VLQBEEABNLP[LZS<00]>ZA`0:bYPY
g:XcdjY7g:Xcg;=Li;j4g;>4i;j4kM2Hi;j41^g@V00=bYPDg;=Ldj4Yg;=L
dj4Yg:Xcdj4YbYPDbZ4mbYPDdj4YdjY7dj4Y00OLZS<00nBc:LZQ?NBc<`05
g:Xc00SCXBViSAC:V2WCZTOT/dOT/c?L/ecT/dL2g:Xc00KCXBWT/bWCXBWT
ZP3CV0[CXBT2`H@001ViQ1C:XCgT/c?:XE;L/ec:XCgCXBW:V1C1Q03CXBW:
V1CCV0[1Q02iSC?T/dOL/ec]ahC]aec:ZVKT/dO:XE;CXBV`SAkCXBW:V1@0
0/64000O/780YW80WW8:SED:Nd`:LSP0JT4:ARl:8bH:8a`:6PT:2@T:6PT:
2A8:2@T:4A`:2@T:AT4N8blN4A`:2A8:4A`:2@TD4A`:2@T:4A`:YT`0Nd`:
LRH0Ea`0H2l:008S70X02Cd_?@T92QX92PT92Q4L2PT92Q4L2PTB2PT95003
00000QXB50032@T:4BHD6PT:00@J4Q@0114L2QXB50000?Koof7<c<`016IV
IXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI
01JIVIT04Ookn?onnoonoo_jom[LjlG9hU5FO6UaX75g/Gb4`X^Aci>IdiZP
e:>WeZV]dj^_eJb`g@02Z[3P00F//^:^]>Ba]nNc^^Rd^nT00[>jj1Jc^^H0
3[Flj;Fli[Flj;Fli[Flj;Fli[Flj;Fli[Flj;Fli[Flj;Fli[Flj;FliP:e
_>P8/k[V2;:ii@bb^NL01;2giJjehjbchJfah0:/[]h03jN[fYnVdYZRd9BL
bhRBaGj7_Vie[6U^YEMKR/G8jm[Kl??cnooonooon?ooo@04VIVI0P0000>I
VIT200000YVIV@030000VIVIVIVI008000001IVIV@000000000009VIV@02
000000>IVIT0002IVIT00YVIV@8000000iVIV@0000000002VIVI0P0000BI
VIT200001YVIV@800003VIVI0P0000:IVIT2000000BIVIT00000002IVIT2
00000YVIV@8000000iVIV@0000000002VIVI0P0003bIVIT00oooolc<c<c<
c01Mc<c<00B`SAjVLQBEE@2=E@X3Pd4000f=E@ZEE@23@@2EE@2=E@ZVI`2=
E@Z`E@2EE@2VLP2EE@2VI`2`LP000ZIb00:NLPX038eE2/ZQD]bZ<lZQ?LZQ
D]>ZAlZH:LZH5;V=5;V45;V=5;V450:iSA@03/640;1k2[V=5;V45<ZH5<ZH
:M>ZAkV45<ZH:K24:K2=7/ZH:KV=5<ZH50;1Q0002[2=7[V=:Ij=:M>nS]bc
Q=>nS]bcG=>ZAmbcG=>ZA`;:XCd04=bZ<lZH:LZH5<ZH5=>H2/ZH5<ZH:M>H
2/ZH:LZZAnBcAm>ZAlZH5=>Q:LZH5=>H2P?:V1@01<ZZAkV=:LZQ?LZH50;C
XBT02M>ZAm>H2]>Q:JIb57]<59iN5;24:M>ZAmbcG002djY70]bZ<`03i;=7
g;=Lg;=L00?]d9P00ng7G=bn[Ng@V002kM2H00WLaj?]d9RiSBWL/ecCXBWL
ZS?CZTOT/c?LZS<00]>Q:@06bYPDg:Xc^FL0g;=Li;<cg:Xc0]>Q:@0Bi;<Y
g:Xcg:Xci;=7djY7i;<cg:Xci;<cg:Xcg;=Lg:Xci;<NdiP:/8@Yi;<cg:Xc
bZ4mg;=L0^BcA`05i;<Yg:Xcdj4Ydj4YdiP:00;:V1@02M>H2[UW0<ZH:LZQ
?LZH5>Bc<mbcG=>ZAm>Q:@02bYPD00_T/dOT/akCQ03:V1C:V2WL/ecLZS?:
XE;:XCg]_SgT/dL00]bZ<`;CXBT01<ZH5=>H2[1k2/6400:VLP001G8h57]<
2VY12W8h04H_2P028a`:0Q4L2P0300002@T:4A`:00892@X044IE:DH_2QXB
514V50T92Q4L2P0001XB50T92ZI<060_58eE2SdB2V0_2QX92R`B008A70X2
2@T:00X94PX92@X92@X94PXA70X92A@94PXJ4Q@92@XJ9Q@26Q8D00@92@X9
2A@J4Q@A70X24BHN00<J4Q@0003fool0HLc<c004IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT05YVIV@0Boocfoooj
o_cmo?cogN3_b]3ZA4UaH6NKK7:`Mgo0Q8c=SYCBU9W@WJ7AXZO?YJ[BYJ_K
YZcP0ZN]h@03Z:kRZ[3TZk7S00>//^@F[;;R0Zfch`0>[K?U[K?S[K?U[K?S
[K?U[K?S[K?U[K?S[K?U[K?S[K?U[K?S[K?U[K?S2:bbhPR[/N4<Zk7S00BZ
/>:Y[n6X[^2X[]h2YJWH00nQYMBJXLnDW<f=Ulb2RlAhPKaZL:aRIim:CWg8
c>oLg_?bl_[ooo_oooSoood019VIV@800003VIVI0P0000:IVIT400000YVI
V@8000000iVIV@0000000003VIVI100000:IVIT200000YVIV@800004VIVI
0P0000JIVIT4000000>IVIT0000000000YVIV@8000000iVIV@0000000002
VIVI100000>IVIT40000?IVIV@03ooooc<c<c<c<05g<c<`01:Ib5;1k:HeE
2XeE2P:3@@001HeE2X=108eE2X<h08=10003SED:00REE@2NGQBVI`2EE@2V
I`2VLP2`N`ZVLP02/7/:00JNLQCLZS?:XCg:V2W:V1CCZTL2^Hdc0[2=7P05
^HdD/7/DbYPD/7/:`H@000:iQ1@04kV=5;2=7/ZH:LZQD[24:LZH5;V45;V=
5<640<ZH5;V=5<ZH5=>H2[V=5;2=7X=N5>BnQ=bcG=>nSP03g;=L00?CZTO:
V1C:XE800/ZQ?@;:V1@01m>Q:LZH5<ZH5;V=:LZH5<ZQD]bcG002djY70]>H
2P03dj4YbYPDbYPD00;:V1@03kV=5<ZH:LZH:LZH:MbZ<m>ZAlZH:NBc7[V4
5<ZZAk1k:K24:NBcAmbcG=>ZA`02g:Xc00?:XCgL/ecL/e`00mbcG005kM2H
g;=LkM2Hi;j4g<NS00?]d9P01;2=7]bcG<ZQ?LZQDP;:XCd02=>Q:NBc:LZH
5<ZH5=>Q:LZQ?NBc:MbcG0?LZS<3dj4Y00KT/akCXBWLZS?T/dOLZS?L/e`3
g:Xc00k:V1B`SAkL/ecL/ecT/akT/dOLZS?T/dO:V1CTZP3CXBWLZS?:V1CT
/ah4bYPD00?CXBWCZTO:XCd00]>ZA`;:V1@03=>H2/ZQ?M>Q:LZH5<640;V4
:MbcG>g7Q<ZQ?NBcAm>ZAmbcQ0;L/e`2djY700_LZS?:V1C1Q02`LP2`N`ZN
LPZ3@@2=E@Yk@@1Z@@YP;`X00R<L2P892@X00a4L2PTB2QXB50022@T:00Y6
9Q@d;bTJ9Q@J2@XA70X92@XA70X92@X0002EEA@2Pbl000IP;`Y69PXS70XA
70XJ2@X94PX24A`:01D92@XA70XJ2@XJ4Q@94PXJ4Q@94PXJ4Q@A9Qh94PXJ
4Q@971@A70XA9Q@92@X92A@92@XJ2@XJ71iP@BWChoD0HLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT05YVI
V@0Cookeoooho?cjo_ooi^WhcmG_AT]eDeV=IFZZL7NkOHC8Q8c;RY78TIO9
V9g7VYo9WZCDX:KJXZSL00>SZMd01:BZg:F[gJF[gJF[gAJUZm/@XjWK4:F[
f`ZUZmd3Y:[L0Z>Yf`0BXjWIWZ;?Vj;>Uik<T9S9RYC9Q8g6NH6oKgNeIff[
E5^B@TIeb/kajNcon?_oo_oknocdooom19VIV@800002VIVI0P0002:IVIT2
00000YVIV@80001IVIVI00?oooo<c<c<c<`0GLc<c004YW8D/8dNNd`:Nd`D
1H=1000@SED:Pbl0LRH0Nd`:Pd40SED:UED0WUhDYVL0/780YW80/780/7/:
YW80WW8:UED00/ZZA`;:XCd04]bcG<ZH:LZQ?K2=7[V=5;V=:L640<ZH5<64
0;2=7[1b0<640;1k2[V=5;V45<ZZAk1k5<ZQ?@:iSA@03LZH:K2=7[V=5;V=
<l640;V45;2=7X=k<ng7G=bcQ=>nS]bcQ=bcG002djY70mbZ<`05bYPYbYPD
^HdDbYPD/8dN00;:V1@02<ZH:M>ZAmbcG=bcG=bZ<m>Q:LZH5=>H2P;:V1@0
1m>H2/ZH5;V45<ZH:MbZ<m>ZAm>Q:@04g:Xc00B`SC?:XE;CXBWCXBT2djY7
00?CXBWLZS?CZTL01=bcG003g;>4i;j4i;=700;T_X@02>g7G>g@V>g@V>g@
V;V=5<ZQ?M>Q:LZH:@CCXBT3bYPD00GLZS?CZTOT/c?L/ecCXBT00]bZ<`04
i;<YbYPDg:XcbZ5B0]bZ<`03i;=7g;=Lg:Xc00;LZS<02^BZ0;1k2]bcG=bZ
<m>Q:MbcG>Bc:NBcAnBc:M>Q:@;T/bT03M>Q:LZH5<ZH5<ZH5<ZH:M>40<ZH
5>Bc:M>ZAmbcQ=bcG=bZ<lZH5003`H@00]>40003^H@DkKhmkM2H00;L/e`2
i;=70]bcG007dj4Yi;=7g:Xcg:XcdiP:^FL0/78000:=E@X01W]<2V11578h
04H_2R<L2R`B008A70X52@T:00i6EBTd;ahS9PXJ71h92@XJ4Q@94PXA70X9
2AB3;`23>01b9P1P;aAG70028a`:0QX92P092@T:2A8:2A8:2A8:4A`:2@TD
2A8:2@TD6Q8D008971@00`TL7PT9500000022@T:00=69QB3Q7^VZZd00]?S
m@03kOKeg>?Pc<c<063<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c003IVIVc<c<VIVI01JIVIT04ooom?oomo_knOcoonobomCJ
m4mDOTE;OeQMWFEZ[W1g_GR0`Gn5_hJ=`HbC_hnF`9FIb9VMcIfQd@02Wj?C
00>NX]:OXm:PY=<00Z2TdaJPY=400ijRdIjRdYjRdP0<WZ;B00>NX]6PY=6P
Y=403Z2Td@RPY=<2XJGD00>PY=>OXm:NX]400YfQd00BWJ7>Ti[4TYW3SYC4
QXg1OhRoN86lKGFdHVZYFV2NADb3BDejdMKfloSonokonogho?ofooom19VI
V@D0000TVIVI100000jIVIT20000BYVIV@03ooooc<c<c<c<05g<c<`01K24
:K1k:IEE09ib2W8h0002SED:01NEE@2=E@Z3>01P;`YG701P;aB3@@2NGQBN
LPZ`N`ZVLP2NLPZ`LP2iSABVLP2`N`ZVLQBVLP3:ZVK:ZTO:V2W:XCg:ZVH0
0/ZH:@07^HdY^HdDbYPD^H@D^HdD`H@0^FL000:`N`X02KV45;V=5;V=:M>Z
AkV45<ZQ?KV45<640<ZH5002bYPY00WCV0Z`SAj`SAk:XCeZ@@[L/ec:ZVKL
/ec]ae`00]bcG00=djY7g:XcdjY7dj4YbYPY`H@0diP:bYPDbYPYbYPDbYPY
bYPDbZY700;CZTL01nBc7/ZH5<ZH5<ZH5=>Q:M>H2/ZH5002bZ4m00?:V1CC
XBWCXBT00]>Q:@07djY7g:Xcg:XcbYPD^HdcbYPYbYPD00;CZTL2bZ4m0]bc
G00Ag:XcbZY7g;=Lg;>4i;j4djY7kLN4i;j4g;>4kM2Hi;j4kM2HYW8Dg:Xc
bYPDbYPYbYPD00GCXBT01LZH5<ZQ?MbcG=bcG>BcA`03g:Xc00O:V1CCXBWL
ZS?LZS?T/bWLZS?T/c<00mbZ<`04i;<Ng;=LUEDDi;=70]bZ<`09i;=7g:Xc
g;=Ldj4Yi;<NbYPDi;<cbYPDi;<Y00;:V1@02[V45<ZH5=>Q:LZQD^Bc<lZZ
I]bcG=bZ<m>Q:M>400;CV0X2bYPD00Z`N`[fd8CT/dOCZTO]aec]_SgL/ecT
/dO]_SgT/dL2g;=L00cLZS?1Q031Q02VI`2NLPZ3GQB=E@YkC0Yb>01P@A@S
9PXm70X26PT:00PA70X94PXA70XA70X94PYP@AA6@AhS;ah24A`:00H92@X9
4PXJ2@X94PZ3;`2=E@X2Pbl000=b>1@/4P0/71@00Q4L2P0G;1`D2@T:2@T:
6Q8D2@TD4BHD2A`D4A`:2@TD2@T:2@TDARHDLW9kPhf4AVMLb]3Fdn?em_oo
kOKem_ookOKem_oodmWF067<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01JIVIT04ooom?komo[lmocoooGh
omOKmUQMQCa2M4a@SeUNX6M//6mg^7Qn^827^hR?^h^B_8bA^i6F`9NLaP02
Vj3:00>JWlVJWlNKX<P00YZOaaFJWlD00iZOaibQbibQb`0>W:7;00>JWlNJ
WlFJWlD01IZOa@RKX<H8Vj3800FMX/ZLXLVKX<RIW/JGW<@00YJK``0BUI[2
SIFlS9>mQXjmOXFiMWnhKgNeI6b]Ff2PBU2<?D=gEeb6fn3mn?komO[nm__e
o_ojooomRiVIV@03ooooc<c<c<c<05g<c<`01kV=:KV=<iib5:Ib59EE58eE
2YEE0002SED:00N3@@1P;`Xm4PY69PZ3;`2NGQBVI`000ZIb00:`N`X03<64
0;1b0;1b0;1k2ZIb0;VZKmbZ<lZQ?LZH:LZQ?MbZ<kV=:@:`SAh02;V=5<64
0;V=5;2=7[V=5<640;1b0<6400:iSA@03/ZQ?KV45<ZQ?KV=5;V=<lZH:KV=
:L640<ZH5=>H2[V=5<6406YE7_KIIP?L/e`01=>nS]bcG=bcG=>ZA`;:V2T2
bYPD00O1Q03:V1C:V1C1Q02iSC?:V1C:ZTL00]bcG003bYPDdiP:diP:00;:
V1@2diP:01S:XCfiSC?:V2W:V2WCZTOCXBWCZTOLZS?:V2WCXBViSBW:V1C1
Q03:V1C:V2WCXBW:XE;LZS?CZTOL/ec]d9RiSBW:ZVK]d9P3djY700SL/ecC
ZTOL/ecT_XC]d9RNLQC:XCg:V1@3dj4Y00W:V1CCXBWCXBW:V1CCXBWLZS?L
/ecT/dOT/c<00]bZ<`?CXBT01NBc7]>Q:NBc7]bZ<nBcA`02g:Xc00[T/bWL
ZS?T/aj=E@[]_SgLZS?CXBWT/c?LZS?T/dL3dj4Y00?T/c?:V1C:V1@00]>Q
:@0ObYPDdj4YbYPDi;<ci;=7djY7kM2Hg;=LbYPDdiP:`H@0dh@0diP:bYPD
/7/:kM2HkLMLi;j4g;=Li;j4kM2Hg;=LkLN4g;=Lg;>4^Hdcg;=LbYPDYW80
YVL0UED000:=E@X01G]106Y12TH_2SdL2R<L2P024A`:00P92@XJ2@XA70X9
2@X94PXS;aiPGS<S9PX24A`:00L92@XJ4Q@94PX92@Yb>1BVC01b>1@00V0_
2P04?A`:8a`:;1806PT:114L2P050000?A`:6PT:4A`:WXAV00;CfMH03?Ko
ongfmOKoog:=[IFQ]jK7h=?Ie^gfmOKoongfmOKoomcSh67<c<`016IVIXS0
^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01JI
VIT05_[llOoon?konoOko__ooo3eoh24ZCa0KdY?RD98QUYOWg1f]7Qn^8V@
a9RPcYfTcYjSbJBZcZR^dZJ/d:F[cJN]c`:Z/=84Z:k>1:R_c0RW[Ld2YZc<
0ZN]c@07Z:k>ZJo?Z[3@Z[3@Z[3BZJoAYjg?00:V[<h00jN]cjV_dJZ`dP08
Z:k@2:R^cPRW[Ld8Yjg?00FUZlfX[]2X[]2UZlfTZ/`00ZF[c@0BXjW;UYk3
ZK3JRY;1RI34PXS2H6JTFUnOAd^:=S]cADUhM7ZNm_conOoolOKio?omm?O`
ooomRiVIV@03ooooc<c<c<c<05g<c<`04;2=7/ZQ?JIb59ib5:IW09ib5:Ib
59ib59ib2X=1060_560_2THV2W]<2YEE09iN50:VI`003[1k2[1b0;1k2ZIb
5:Ib0:Ib59ib2/ZZAlZZI]bZ<lZZAm>ZAlZH5<ZQ?@:`SAh2^HdD01W:V1Bi
SABiQ1BiQ1B`N`ZiI`2iQ1C:V2W:XCfiSBW:XCfiQ2V`SAk:V2W:V1BiSAC:
V1CCV0[1Q02iSAAZ@@[]aecL/ec:ZVKffFH00mbcG003i;<YbZ4mbYPD00;:
V2T03lZH5<ZH:LZH5<ZH5;V=5=>H2/ZQD^BcAm>ZAlZH:M>Q:K2=7^Bc7]>Q
:LZH5002bZ4m00?:V2ViSACLZS<00m>Q:@08bYPYdiP:bYPY^H@DbYPD^H@D
bYPDbYPY1M>ZA`04kM2HbZYV^HdY^H@D0[1k5003^HdDg;=Lg;=L00;L/e`0
0oKIIYib5=>Q:@02dj4Y00FiSC?LZS?:V1CCXBW:XCd00]>Q:@0=bYPDdjY7
djY7djY7dj4Yg:XcbZ4mdiP:dj4YbYPDi;<Ndj4Yi;<c00CLZS<03>Bc:NBc
7W]<2_KII]bZ<m>Q:MbcG>Bc<mbcG=bZ<nBc:LZH50;CXBT01NBc:LZH5=>Z
AkV45<ZQ?@03dj4Y00^`SAkLaj?C_XkCXBW1Q03CV0[CQ03:V1CCQ02`N`[]
d9P00]bcG0;T/dL02NBZV>BnQ>g@V=c7XkV=<kV45=>ZAkV458eE2P02YVL0
00R`N`Z3GQAkC1Ab9P1P;`XS9PXS70XJ2@X42@T:00hA70X94PY69QAPGS<S
;ahA70XA9Q@92@XA70XJ2@X92@Y69PZV@@2=E@X2H2l:00=69PXS70XS70X0
0Q4L2P082@T:4A`:2@T:2@T:g;=LkM2H0000m_Ke1=?Sm@05kOKePiRgNhf4
`LO<b]3F00?]m_D00oKoomcSh<c<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0FVIVI01OoooSgn?;o
oo_noooen?ogn_nh^mX]<5T^<F@h?GEBEY=RJ::1R;nU[MjU[M^OYlj_]MNe
_=Vi_mng_]^f_MZh_mbi`=d00[W0g003^L3J^L3L^L3J00Bi`=X2^l;L00bk
`]jk`]bk`]jk`]bk`]jk`]bg_]Zg_]Rh_m^i`=Zi`=bj`M/3^l;N00jj`Mfh
_mbg_]Zg_]^h_m^j`Mjk`]ji`=fi`=bi`=fi`=bi`=fi`=bi`=d2^L3L00fi
`=Zi`=bi`=Zi`=bi`=Zi`=bi`=Zk`]jk`]bk`]jk`]bk`]jk`]`01;_2gP0O
^l;O^l;N^l;O^l;N^l;O^l;N]kkK^/7M^/7N]kkJ][gJ^;oK]kkK]K_K]koS
Z;3GX:SGYZgQN7jhD5BADeND?d5j@DAg:BaE_L;Pm__ol_Konoooo?omo_ok
ooom08^IVIT00oooolc<c<c<c01Mc<c<00B`SAjiV5bNLPZVLQ@2WW8D00fV
LQBiSABVLQB=E@Z3@@2=E@YP;`Yb>1BVI`2VLP2VLQB`N`Z`LP001;1k2P09
WW8:UED0bZ5BbZY7bZ4mbYPYbZ5B^HdYbZ4m00BiSA@01;1k2[2=7[V=5:Ib
00:`N`X02;2=7[V=:K2=7[24:LZH:KV4:K2=7[V=50;:V2T01L640<ZH5<64
0<ZH56YE7P02g;=L0]bcQ0;L/e`00m>ZAlZQ?MbZ<`03bYPY00g1Q03:V2W:
V1CCV0[:V1C:V2W:XCgCZTO:XE;LZS?CXBW:V1CCXBT00/ZH500?dj4YbYPD
^HdYbYPDbYPYdj4YbYPDg:XcbYPYdiP:bZ4mdiP:bYPYbYPD^H@D00?:XCd0
2/ZH:MbZ<m>ZAmbcQ;V=<heE2X<h0;V=<lZQD]>ZA`;L/e`03M>nS^BnQ>g@
V:Ib0=>ZAlZH:LZH5=>Q:LZH5=>Q:LZH5=>Q:MbZ<`02dj4Y00CL/ecT/dOL
/ec:XCd2dj4Y00oLZS?CXBWT/c?:V1CCXBWL/ecT/bWLZS?CZTOLZS?T/bWT
ZP1kC1C]aecCXBT00]bZ<`08bZ4mkKhmbYPDdj4YbYPDi;<NbYPDdj4Y0[V=
<`09dh@0dj4Ydj4Ydj4YbZ4m^G8c^Hdci;j4bYPD00;1Q0006m>H2]>40<ZH
5;V45>g7G=bcG>BnQ>BcAm>ZAmbcG>g7G=c7Xng@V<ZH:M>ZAij=:IiN58eE
2YEE09ib2[1k2XeE2W]<2V0_2TH_2SdL2R<V2P044A`:01892@XA70X92@XS
9PYPGS<J9Q@94PX92@XA70X92@XA70X92@Xm4PZ=E@Z3>0169QAP;aAG7002
8bH:00XJ2@X92@XA70X92A@J4Q@0002`Q7_fkNX94P[]m_D4dn?e00G]m_FE
/lakSHBV/l7:d=H00^gfm@03m_ookOKedmWF067<c<`016IVIXS0^8S0^4R@
R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01JIVIT06ooo
noOhlooooOkoooGfnocnoo_mogYmWSLiHRlaHSTlLF5VWIRNdZbbi:N^g;Fm
i;>ifKZog;k3hKg2gk_0gKc1g[g2gkg3gKk4g[k4g;k4gP05_/CL0[g3f`0<
_L?M_L?K_L?M_L?K_L?M_L?K_<;L_<;J_L?M_/CL_/CN_lGM0ko5g`0>_/CN
_L;O_<;L_<7N_L?M_/?P_lGO_/?P_/CN_/?P_/CN_/?P_/CN_/?P0[k4gP0=
_/CL_/CN_/CL_/CN_/CL_/CN_/CL_L?M_L?K_L?M_L?K_L?M_L?K00Bm`md0
7;g2gkg3gKg2gkg3gKg2gkg3gKg2gl36h<35h[g3gKc1g[k4g[c1g[Rog;No
hjnggZjdi:N]hHJ;`emQVSm2NBHXFb0SC7n2Xo7fooSlooOlooSlo@;nood0
0ooooiVIVIVIV@29VIVI00?oooo<c<c<c<`0GLc<c006/8@Y^IQL/7/:WW8D
WW8:WW8D0[1k2P09WW8:SED:JT4:;1808bH:Pbl0SED:/7/:YW8000:`N`X0
0jIb0;1k5:Ib0002/7/:00>VLP3:XE;:XE800]bZ<`09bZ5B^HdD^Hdc^HdD
^HdY^HdD^H@D`H@0bYPD00:`N`X02l640;1k2[24:K2=7/ZH:KV=5;V=<k2=
7[V45<ZH5<ZH:@03bYPD00NiSABiSC=G703ffFKC_XkT/dOL/h@00]bcG00=
djY7g:XcbZ4mbYPDbZ5BbZY7`H@0diP:/8dN`H@0^HdcbYPYbZ4m00;CZTL0
0m>Q:LZH5=>H2P03bYPD00[CV0[:V1C:V1B`SAkLZS?:XCg1Q03CXBW:V2WC
XBT3bYPD00JiQ1C:V1C:V2WCXBWCZTOLZS<2bYPY00kL/ebNNc>`SC>EEAC:
V1C]aecL/ec]d9ST_XC]d9SC_Xk]fLbEE@3CXBT3bYPY00[:XCgCXBW:XCg:
V1CLZS?CXBWLZS?T/dOL/ecT/dL2g:Xc0m>Q:@03bYPDi;<YdiP:00;LZS<0
7]>Q:M>ZAnBc7]bZ<nBc7X=10?KII]>ZAmbZ<nBcAm>Q:MbcG<ZH5>Bc7]>H
2]bZ<lZH5>BZ0<ZH5=>40=>Q:NBc<kV=:L640=>40;V45:I<0<ZH:L640;1k
2P?1Q0001<ZH5;1b0>g7Q>BcA`;L/e`2i;=700G:XCgL/ecL/ec:XE9kC0X0
0V0_5008^FL0`H@0/780/8dNNd`:SED:H2l:JT4:0R<L2P03;1804A`:2@T:
00894PX04A4L2PT92R`V54IE:AXV52<L2QX92Q4L2PT92Q4L2PT952<L2YEE
08<h08=108<h060_5002?A`:00<92@XA70X92@X00Q4L2P070000UG97kOKe
4BH:m_oodn?eg>?P00;ChoD01NgfmJJc`FYkKk2n`M?IeP04kOKe00?Lhn3<
c<c<c<`0Glc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4
c<c<00=VIVK<c<bIVIT05YVIV@;oo_l05_[imoShn?oooogmoocnonc^oe9C
LQLI@2/^FdY>OWIjZZbbh[>jj;Vnj;>gf[Zogkk3hkg2h[_0h;c1gkg2h;c1
gPFm`]l3_L?M2[c1gP:m`]l6_/?P00Bm`]nl`Mjl`Mjm`]l2_/?P4;g2g`Zl
`Mh06Kc1gkc1g[c1gkc1g[c1gkc1g[g2h;o4hKk3hKc1g[c1gkg2gk_0g[Jk
fk>igKFli[>jj9nReGj1]TU:P1hPDBHWDeiQP^oaooOko`02o?oo00Cino[n
ooohn_Wooon;VIVI00?oooo<c<c<c<`0GLc<c00:/8dN/8@YWW8:WW8DWW8:
YVL0YW8DWW8:WUhDUEDD0SdL2P06ARHD8a`:WUhDUED0^H@D/7800[1k2P0>
/780YW8DYW80/7/:UED0g;=LbYPDbZ5BdjY7bZ4mbYPYbZ4m`H@0/8dN0kV=
5006/8dN`H@0/780/7/:^HdD`H@00/ZQ?@05^H@DbYPY/8dN^H@D^HdD00?:
V1@2`H@000S:V1AZ@@[L/ecL/hCL/ecL/hCL/ec:ZVH2djY700?:V1C:V2W:
V1@00/ZH5009bYPYbYPDbYPD/8dNbYPYbZ4mdjY7g:XcbYPY00;:V1@01m>H
2/ZH5<ZH:M>H2/ZH5;2=7[V=:@02dj4Y00?:V1CCZTO:V1@00lZH500=bZ4m
bYPDbYPYbYPYdjY7g;=LbZ4mbYPYbZ4m`H@0H44YPehcbZYV00;L/e`03]>Z
Ang@V=c7XnBnQ>g@V?o]SXeE2/ZH:KV4:LZQ?LZH:M>Q:LZH5=bZ<`;CXBT0
0nBc<nBcAm>ZA`02g;=L00?T/bWLZS?CZTL00m>Q:@0;g:Xcdj4Yg:Xci;<c
i;<NdjY7i;<cg:Xci;<NLSP0m/Lm00;LZS<01m>ZAmbZ<mbcG=bZ<lZQ?NBc
7^Bc<`03bYPD00biQ1C:V1BiSC?CQ03:V1B`N`[:V1CT/ajVC023;`2`E@2i
I`02`H@000WCV0Z`N`[]ahCCZTOT/dOCZTO:XCgL/ec:V1@00/ZQ?@0:bYPY
Pbl0Nd`DPbl0bZ4m/8dN/780^HdDNd`DNd400VY12P058a`:=2lY8a`:6PT:
4A`:00892@X05@TB2PT92QXV54IE:B<_7Q4V2PT92PT9514L2PT92QXB51X9
2YiN59E<:HeE2X<_060_2THV2TI17Q4L2QX92P024A`:00D92A@A70Xm70[:
_Ze6@Ah01=?Sm@06g>?PkOKeY/OPH79k/;>gdmWF0^gfm@03m_ookOKeg>?P
067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c09V
IVH00lc<c9VIVIVIV@0DVIVI01;lmogooOooo?goo_oooogooooZjNonoOol
oOlc=58U9de?DWeTIiBEVLRFV/V^/]nY[=F`]=X2]KWO00>d^=je^Mjf^]l0
0[FigPBe^M`3]K[J2;NkgPBe^M`6][[M1;Fig0:f^]d@]KWL2[NkgP0O]k_P
]k_N]k_P]k_N]k_P]k_N];SM][[M]KWN/kOJ];SM]KWL/KGJ[;3EZ:gCYJ[D
Z:cKQ8JgBTao;c1P;2eI=3AFmOGonogonOgoo_oonO_hooomno_moOgooooo
08^IVIT00oooolc<c<c<c01Mc<c<00>`NaBNNc>NLPX00iib2P0AYVL0/8dN
WW8:SED:?A`:8a`:6RHD;1`DPd40WW8D/8dN/780YW8D/7/:/780/7/:/780
00:NLPX01lZQ?LZQD/ZH:LZH:LZQ?KV=:LZH:@04^HdD00?1Q02iSABiSA@0
0[1b0009/7/D^HdY/8dNbZY7/8@Y^Hdc/7/D/8dN^Hdc00:`SAh01lZH5;V=
5;V=5<ZH54H_2^g7G=bcQ006g;=L0]bZ<`05bZ4mbYPD^HdDbYPD/8dN00?:
V1@00lZH:LZQ?LZQ?@02dj4Y00G:V1CCXBW:V1C:V1C:XCd00/ZH5006/8dN
bYPYdjY7bYPDbZ4mbYPY0lZH500H^HdcdiP:bYPDbZ4mbZ5Bg;=LbYPYg:Xc
dj4Y^HdD^H@YWW8DWW/ckLN4g<NSg:Xci;j4g;=LkM2Hg;>4on>>PehD^H@D
^FL00/ZH5008^HdcbYPDbYPDdj4Yg:XcbZ5BbZ4mi;<c0^BcA`07g:XcdjY7
g:Xcg:Xcdj4Yi;<Ndj4Y00?LZS<02=>Q:LZZI]bZ<mbZ<nBc7XeE2^g7G=>Q
:@;LZS<01M>Q:MbZ<m>Q:NBZ0;V=<`04bYPD00>iI`2`N`[1Q0000/640007
/7/:/5D0SED:Pbl0PcP0YT`0/4`000;1Q0003<ZH5;UW0=bcG=bZ<mbcG=bZ
<lZH5=>Q:KV=<lZH:KV459iN50:`N`X02MbZ<kV=:KV=5;V45;1k2W]<58=N
560_2W8V00028a`:00<A9PXJ9Q@J4Q@00Q4L2P052@T:2A8:;2HDH44D8blN
00<A70X020T92Q4L2PT9514V5:I<07]<578h56Y12P9b>1@03DHV2R<L2Q4L
2QXB50T92Q4L2PT950TB2X=k<f1N<oKoojK7h=cSh002dn?e00KLhn3:d=IZ
NfnEZZgCfMKChoD2kOKe00?fm_GLhn3<c<`0H<c<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;P4c<c<00AVIVKooomVIVK<c<`EVIVI01So
o?oon_oooOooo_gln?Gooo_ako3oo_o_k_cloOm=CVdC5C]5Ag17BWN>T<2G
VlZDU/JLW/jSYMFTY]JTYmBVZMJXZmRWZ]L4YZWD1:JYdPRWZ]D6YZWD00>W
Z]FWZ]>VZM803jJYdPRVZM@@Yj[E01VUZ=>VZMBUZ=>TYm:UZ=>VZMBRYM2K
W/V<TKVRYm5`LZ9;CGi1@G<@3c]>CWClo?onoOohnOgnoogblngooo_ooogf
m_Soo_ooool0RiVIV@03ooooc<c<c<c<05g<c<`01K2=7[2=<jIb08eE2YEE
0002WW8:0ZIb000>UEDDJT4:H2l:?A`:;180PcP0WW8D/8dN/7/D/780/7/:
^HdD/7/:/8dN0[1k2P09bZ4mbZY7bZ4mbZY7bZ5BbYPD^HdY/8dN/7/:00:i
SA@2/7/:00c1Q02iQ1B`LP2`LP2iSABiSBViSC>VLQBiSC>NLQBiQ2V`SAh3
bYPD0/640003bYPDARl:g;=L00;L/e`00mbcQ=>nS]bcG002djY700C:V1C:
V2W:V2WCV0X2`H@0017:V2V`SAj`SAk:V1C:V2W:XCgCZTO:V2WCXBW:XCg:
V1C:V2WCV0[:V1CCV0[:V1B`SAh00]>ZA`05bYPYg:XcbZ4mbYPD^HdY00;:
V1@02K2=7/ZH5<ZH:NBc7]>ZAmbZ<m>Q:LZQ?LZH5002bZY700_:ZVKT_XC]
d9ST_XC]d9SL/hC]d9S]ahC]fLbNLQB`N`X00kV450?:V1@03m>Q:NBc<lZQ
?NBc<lZZI/ZQD]bcG=>Q:M>ZAmbZ<nBc<lZH5=>Q:MbZ<m>Q:@06g:Xc00cT
/aj3GQC]_SgCXBWCZTOT/bWCXBWT/dOCV0[CXBWCQ03T/ah4bYPD013CQ03:
V1CCV0ZiI`2`N`Z`E@0m4PYP;aAG702`C02`N`ZiI`2iQ1CCQ02`LP3LZS<2
g;=L00WLZS?:XCgCXBW:V1BiQ2ViQ1BVC023;`2`Na@00]>Q:@0/^HdD^H@D
/7/:Nd`:SED:H2l:JT4:8bH:8a`:6PT:2@TD6Q8D6PT:4A`:2@T:4A`:6PT:
AUDY;2HD6Q8D4A`:2A8:4A`:6PT:2@T:6Q8D/4`0/5D0UEDDPcP0Nd`DARHD
?A`:4A`:6PT:2@T:4A`:2@TD2A8:2@T:AT`m=2lNm_oog>?P0]?Sm@08g>?P
dn?eg>?PJW^4UIRSb]3FkNgZkOKe0_Koo`03g>?Pc<c<c<c<05o<c<`016IV
IXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c005IVIVooooc<c<
IVIVc<c<01BIVIT05ookooojoooloookn_[gl_oon?oon_gmoOonookmooCd
og]kWB<UC2`_FS4dHDQ:Nf=TVVa]YGAeZgIg[GQi[gam/gj0/`03OGnb1Weo
/0QkOJh8OGn`00=lOZmmOjmmOjl017eo[`03O7j^OGn_OGn_00ImOjl8OGn`
27]m[PQkOK02OGnb01MlO[5kOK1mOk9nP;=hNZeaLjAUJ9E4Ag8W:5PO850X
9UN5Q:kfmOofm?oWinoooogoooSemN_ooo[lnoWoo_oooOooool0RiVIV@03
ooooc<c<c<c<05g<c<`03:Ib5;24:JIb08eE2YiN59EE09ib2ZIW09iN5:IW
078h56Y12P9P;a@01heE2Yib2[2=<k2=7[V=5;1k2ZIb0002/78000B`SAjV
LP2`SE;CZTL2bZY700_:XE:iSBW:XE:iSAB`SAj`NaBNLQB`N`[1Q02`N`Z`
LP000[1k2P0K/8dN^Hdcg:Xc/8dN^HdY/8dN^HdD`H@0bYPD^HdD/8dNbYPD
^HdDdiP:ARHDdjY7g;=Ldkj>g;=LkLMLbZYVg;=LdjY7dj4Yg:XcbZ4mdiP:
00:iSA@01<640;V=5;V=5;V=:@;:V2T01<ZZAlZQ?LZH5=>H2P?:V1@01m>H
2/ZH5<ZH:LZH5<ZQD]bcG<ZH:@02g:Xc00C:V2W1Q03:XCfiSC<2bYPD00Bi
SBWCZTOL/hCCZTL2dj4Y00S:V1C:ZVKC_XkL/hCC_XkL_Zg]aecC_Xh3kM2H
00O]fLbEQ5:EE@2`N`ZiQ1BiQ2W:V2T00/ZH5007dj4YbZ4mbZ4mdjY7g;=L
i;<cg;>400CLZS<2dj4Y00?LZS?T/bWT/ah00]bZ<`0>dj4YdjY7g:Xci;<Y
UEDDg:Xci;=7g:Xcg;=Ldj4Yg;=Ldj4Yg:Xcdj4Y0lZH500=dh@0bYPDbYPD
dj4YbYPD/7/:YT40/7/:LRH0H2lDH2l:YT40/7/D00:iI`003[V45;UW0<ZQ
?M>ZAnBcAm>ZAlZH:M>Q:KV=:M>Q:LZH5;1k2/ZH5;V450;CXBT00kV=5;V4
5;1k5002Nd`:00lS70YG700d;ahS70XA70XJ4Q@92A@92@X94PXA70X92A@A
70YZEAhd;ahA9PX00Q4L2P0<6Q8D4A`:4A`:2@TD/7/:WUhDYT`0Pd40LSPD
H2l:;2HD8a`:0Q4L2P0:2@TD4A`:6Q8D2A8:UD`YPhAkdn?eY/OPb]3Fg>?P
0]?Sm@09kNgZJW^4UJ6>`LO<dn?em_ookOKem_oog>?P067<c<`016IVIXS0
^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c006IVIVooooc<c<c<c<
IVIVc<c<4iVIV@0FooSooo_oooWoo_ShooohmoC[ooohoOchookono_oo_co
m?Gono_oe]OoFej;;2iO61UB8B5M:R]T;RmX<C9[=CI_13LhL0Hg>6h;>3U_
1CLhKP8g>F`4>3Y]2SLiK0Pg>6h8>3U_23PiL@8i>W805cPiLCLhL3TjLSXk
Lc@eKB`^HA/MCBLZEEmPT=SIoo_ionc[ookkookmooonoo[kmO_klOoom?7a
jOoonoonooKdnOooo`2;VIVI00?oooo<c<c<c<`0GLc<c0:`Q2T01Iib59EE
59ib2XeE2ZIW0002WW8:0XeE2P03Pd40H2lDPcP000:`N`X01ZJ4D[1k2[V=
5;1k5;V=5:Ib50:`N`X04JIb0<ZZAlZZI/ZQ?LZZAlZZI/ZH:LZZAkV=:L64
0;V=59ib2[1k2[V=5;1b0;V45:Ib0002/7/:01?:V2W:ZTN`NaC:XCf`SAj`
NaBiSC?:V1C:V2W:V1BiSC?1Q03:V1A6;`[L/ecC_XkT/dOL/ecL/h@00m>Z
A`06bZY7bZ4mbYPDbYPDbYPYbYPD0[V=5007`H@0bYPD/8@YbZY7bZ4mdj4Y
bYPD00;CV0X02=bZ<lZH5<ZH:M>H2/ZZAlZH:LZQ?Nfn?@?LZS<02<ZH5<ZH
:LZH5<ZH:M>H2/ZH:LZQ?M>ZA`;L/e`2bZ4m00CCZTO:ZVKC_XkT_X@2kM2H
00_L/hC]d9S]d9S]d9SLaj?okHj=SDNVI`2`NbViQ2WCXBT00]bZ<`03djY7
bYPDi;<c00;CZTL00nBcAm>ZAmbcG002djY701KLZS?T/dO:XCgCXBWT/c?C
XBWT/dOLZS?T/c?LZS?L/ecCXBWT/ajNSBWLZS?CXBWCZTOT/dO:V2WLZS?C
XBWTZP04bYPD00GCV0[:V1C:V1CCQ03T/ah00[UW000I^H@DYT40PcP0WUhD
YT`0^H@D/4`0`H@0/7/:`H@0bYPYi;=7i;j4bYPDg:Xcdj4YbZ4mdj4YbYPY
^H@D^Hdc`H@0dj4YbYPY/8dN00:iQ1@01fY12W]<2R<V2THV2SdL2R<V2R<L
2P034A`:01lJ4Q@A70XJ4Q@J2@Xd;ah/9Q@J9Q@J4Q@A70X92A@92@XJ2@X9
2@ZVC02NGQB=E@Z3>01kC0YP;aA69Q@S70XJ2@X92@XA9Q@92A@A70X92@Y6
@AjVXIS:d=KLhn000]?Sm@;Lhn001M?SmFYkKhf=Kl77c=?Sm@02kOKe00?f
oooLhn3<c<`0H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;P4c<c<00=VIVKoooo<c<`00/c<c003IVIVc<c<c<c<0?o<c<`>c<c<00?o
ooo<c<c<c<`0GLc<c004/8@Y/8eBWW8DWW8:0XeE2P0JUED0YVL0WUhDUED0
SED:YW80/8eBWW8:UEhcWW8cYW8D^HdD`H@0^HdD/8dN^HdD/7/:/8dNYW80
bZY7djY7bZ4mdjY7bZY7bZ4mbZY70[V=:@0=^HdDSED:/7/:`H@0/780WW8:
/7/:^FL0^HdD/8dNbYPY/8dN^HdY00:iQ1@03[2=7[V=<k2=7[V=5=>H2[2=
7/ZH560_2/ZZAmbcQ=bcG<ZZI]bcG>fn?@;CZTL02]bZ<lZQ?LZH:LZH5;V=
:L640;V=5<640;2=7[V=<`;:XCd01LZQD/ZZAm>H2/ZH5=>Q:@03bYPD00C:
V2W:V1BiSBWLZS<3bYPY0lZH500=/8dNbYPD`H@0/8dNbYPYbZ5Bg;=LdjY7
dj4YbYPDg:XcdjY7dkj>00;]d9P01Mbn[Ng@V>g@V>g@V=bn[@02kM2H00BV
XFJNGQC:V1CCZTL3g;=L00[T/dO:XCgCZTOLZS?CZTOL/ecCZTOL/ecLZS?C
XBT2djY700CCXBWLZS?LZS?CXBT3g:Xc00KCXBWT/dOL/ecT/c>`N`[:V2T2
djY700GL/ecCXBWT/c?:V1C:XCd00]>Q:@03bYPD`H@0bYPD00;1Q0000lZH
5<ZQ?LZH5002`H@000>VI`2`E@2iSC<00[1k5005/7/:`H@0/7/:/7/:bYPY
00;L/e`2djY70/ZH:@07dj4YbZY7diP:^H@DbYPDdj4YbYPD00:iQ1@05KV=
:FY12THV53dL2ULL03dL2R<V2QX92PT92QX92QXB50T950TB2PT9514L2R`h
:C@_7Q4V2QX92Q4L2QXB50024A`:00@0002NGQB`NaB`LP02SED:00eP;`Y6
9PXA70XS70XA70X92A@J4Q@A70X971@/71BVQ8CChoFVan000/[@eP;ChoD0
2NgfmG:=Q7^=Q<77c=cSh?KoongfmOKoomcSh01Qc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI_ooolc<c003c<c<ofIV
IQ1VIVIPc<c<00F`Q2V`SC>VLQB=E@ZNLPX00YEE0009WUhDWW8:YVL0YW8D
WW8D/8dNSED:/7/:YW8D00FiSA@02K1k2[1b0;1b0:Ib0;VHG<ZZAlZQ?LZZ
AlZQDP03bZ4m0[V=<`03JT4:`H@0YW8000:`LP002JIb0;1k2[1b0;V=:KV=
<k1k2[V=<k2=7[V=5002^HdY00O:V1BiSABiSABiSAC1Q01P@AC:XCd00mbc
G00;bZYVg;=Lg;=LbZ4mbYPYbZY7g:XcbYPD/8dNbYPD`H@000:iSA@00lZQ
D/ZQ?LZH:@02djY70lZH500>diP:dj4YbYPDdiP:bYPD/7/:bYPYbZ4mdiP:
bYPDbYPYg:XcbYPDdiP:0/ZH5005`H@0^HdDg;=Lg;=LdjY700;:XCd01mbZ
<lZH:M>nS^g@V=>nS^g@V>BnQ005kM2H00nNSC?:XCg:ZTOL/ecL/hC]d9ST
_XCT/dOCZTOLZS?CXBWLZS?T/dOCZTNiSBT00]bZ<`0Di;<cg;=Ldj4Ydj4Y
i;<Ndj4Yi;<Ng:Xci;<NdjY7i;=7dj4Yg;=L^HdDbYPYi;<cdjY7g;=LbYPD
g;=L0]>Q:@07bYPDg:XcbYPDbYPDdh@0bYPDdh@000;:V1@03M>H2/ZH5;1k
2X<h08eE2]>ZAk1k5;1k2[UW0<ZH5;UW0<640;24:@02g;=L00CCZTOLZS?C
XBWCZTL4dj4Y00?:V1C1Q03:V1@00[V45006^HdDJT4:H2l:4A`:8bH:?A`:
0R<L2P054A`:2@T:6Q8D4A`:2@T:008A70X00b<V2S@_7QX92P022A8:01PJ
2@XJ4Q@92@X92AB`C02iI`2iQ1Ab>1AkC1AZ@@Y69PX/71@J2@XA70XJ4Q@9
2A@J4Q@92AA69QBNQ6JVan3Lhn3ChoG:d=H2g>?P00G]m_F3V8ibLW^`_/7C
fMH00^gfm@03m_Keb]3Fc<c<063<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVooooc<c<0?o<c<acc<c<00BNNc>`SC>N
LPZNLPX2PehD00F=E@ZVI`2EE@2NLPZNLS<00Yib5007UED0YW80/7/:/7/D
^Hdc^HdY^HdD00:`LP004KV=5;1k2ZIW0;V=<mbZ<lZQ?LZZAlZQD/ZH:LZQ
D/ZH:K2=7[V=:F0_2Yib2[1b0:Ib0002WW8:016VLP2`N`ZiSBW:V2V`SAji
SC>`SAj`N`[:V2W:V1BiSC>iSAC:V1BiSACCV0Y6;`[:XE800]bcG00CdjY7
g;=LdjY7bZ4mbZ5Bg:XcbYPDbYPYbYPD`H@0diP:/7/D^HdD`H@0djY7^IQL
bYPYbZ4mbZY700;:V1@05=>Q:M>H2/ZH5<ZH5<ZH:L640;1k2/ZQ?LZH:LZH
5<ZH:LZQ?LZH5;V=5<ZH5;V=5<ZH5:Ib0;V45<ZQ?@;CZTL2bZ4m013:V2W:
ZVK:XE;Laj?L/ecLaj?L/hCLaj?L_Zg]d9SLaj?okLbVXFJiZVoCZTOT_X@3
kM2H00?L/ecT/dOL/e`00m>ZA`07i;=7dj4Yg;=LdjY7bZ4mdjY7bYPD00;L
ZS<3dj4Y00SLZS?CZTOT/dOCXBWLZS?:V1B`Q2WCZTL2i;=700KCXBWL/ecC
XBWLZS>iSC?CV0X2bYPD0/640004bYPDdh@0bYPDdj4Y0/ZH500=YT40YT`0
`H@0/780^H@D`H@0dh@0/7/:`H@0^G8ckLMLdjY7g:Xc00;CZTL00mbcG=>Q
:M>ZA`02dj4Y03S:V1BiSC?:V1C1Q02`N`Z`SAj3GQAZ@@XA70XS9PXm70XS
9PXS70XJ2@XA70XJ2@X92A@92@XA70XJ2@XS9PXd;ahA9PXJ4Q@A70X94PX9
2@XA70X92@Z=E@ZiQ1B`NaBEE@23>01kC0Y69PXS9PXA70X94PXJ4Q@A9Q@A
70X94PY69QB`SE;Lhn3ChoG:d=KChoG:d=KChoG]m_F3V:eZNfn`_/7:d=H3
kOKe00?Lhn3<c<c<c<`0Glc<c004IVIVR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;P4c<c<00=VIVKoooo<c<`06lc<c0Coo_l00ooooOoonooon`02
oook00Oooogno?gfm?Oflo[_k?GSh>WPgNP00]KCgP0=e];Pe]?Ne];Pe]?N
e];Pe]?Nem?QemCOem?QemCOem?QemCOem?Q00;Ge=l0;]ODgMWCgmODgMWC
gmODgMWCgmODgMWCgmODgMWCgmODgMWCgmODgMWCgmODgMWCgmODgMWCgmOD
gMWCgmODgMWCgmODgMWCgmODgMWCgmODgMWCgmODgMWCgmODgMWCgmODgMWC
gmODgMWCgmODgMWCgmODgMWCgmODgMWCgmODgMWCgmODgMWCg`?Ge=l05]OC
hMODgmOChMODgmOChMODgmKBh=KCg]KBh=KCg]KBh=KCg]KBh=SBh=C;g^CK
k>;Lj^kXl_SfnoKfn?kno?oon`;oooX01ooonooooOonooonooomooonoooo
o`3Vc<c<0[24:@07WW8DUEDDWW8DSED:WW8DWW8:SED:00:VLQ@01K2=7[1k
:JIW0;1k2[1k5002^HdD0[1b0007/7/:UHd0/780/7/:YW80WXdcdjY700;:
ZTL01lZQ?K2=7/ZQ?K2=7[V=<kV=:F0_2P02/7/:0jIb000</7/:/8dN^HdY
bYPY/8dNbYPY/8dc^FL0/8dN^HdYbYPD^H@D0l640007ARHDbZ5Bg;=Ldkj>
g;=Ldkj>g:Xc00;CZTL01<ZQ?LZQD/ZQ?LZH50>iSA@01<ZH5<ZZAkV=:LZH
50;:XCd00mbZ<m>H2/ZQ?@04bYPD00JiSC?:V1BiQ1C:XCgLZS?:V1@2bYPY
01>iSC>iI`2`SAk1Q02`LP2VI`2EEABiSACL/ec:XE;:V1C:V2WCXBW:V2WL
/ec]d9SC_Xk]d9SL/e`00ng@V006kMW<kM2H^JY_g:Xcg;>4g<NS0^BnQ00=
g;>4g;=LdjY7g;=Ldj4Yg:Xcg;=LdjY7g:XcdjY7g:XcbZ5Bi;=700?CXBT2
g:Xc00ST/akLZS?LZS?:ZVKLZS?L/ec:V2V`Q2T2i;=700KCZTOCXBWL/ecL
ZS?CZTO:V2T3bYPD00[CV0Z`N`[:V1C:V1B`N`[:V1CCV0[:V1B`N`ZiI`02
/7/:00cCQ031Q031Q02`N`[1Q02NLP[]aecLZS?CZTOL/ecCZTOL/e`2djY7
0]>Q:@04bYPDdiP:bYPD/8dN0[V45004WW8DH2l:;2HD6PT:0R<V2P058a`:
4A`:2@TD2A`D4BHD00<92@X04B<L2R`h:AXV50TB2PTL50TB2Q4L2PT92PT9
57]<5;1E09iN58eE2X<h07]<2THV2R<L2P024A`:0QXB50078blN0000?A`:
bZYVb]3FY/OPb]3F00?Lhn001NgfmH>H[FYkKk2c]l[@`@03kOKe00?Lhn3<
c<c<c<`0Glc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4
c<c<00=VIVKoooo<c<`06lc<c006oogoookoookoookoooomoook0_oonP08
oo_hoogllnkbi=oVh=[VfM?QclSJc<GG0[ffb00=_KG:_KK8_KG:_KK8_KG:
_KK8_kO<_kS:_kO<_kS:_kO<_kS:_kO<00:o^<X0;[nhb<2gb[nhb<2gb[nh
b<2gb[nhb<2gb[nhb<2gb[nhb<2gb[nhb<2gb[nhb<2gb[nhb<2gb[nhb<2g
b[nhb<2gb[nhb<2gb[nhb<2gb[nhb<2gb[nhb<2gb[nhb<2gb[nhb<2gb[nh
b<2gb[nhb<2gb[nhb<2gb[nhb<2gb[nhb<2gb[nhb<2gbP>o^<X03;ngc;nh
b[ngc;nhb[ngc;nhb[ngc;nhb[ngc;nhb[ngc;nhbP:o]l`02;jdc<k4g<c5
emK@g^;Li^?Qi?CclOgln0;oooX01?oonooooOonooono`;ooOl00oooolc<
c<c<c03Tc<c<00jNNc>`SC>NLS>VLP2EEABNSBVNLQBNGQB=E@ZNLQBNNc>`
Q2VVLQBNLPX2/7/D00B`N`ZiSAB`NaB`N`X3/7800[1k2P07/8dN^IQLbZ4m
bZ4mg;=L/8dNbZY700:iSBT01;2=7XeE2W]10:Ib00:`LP001k1k2ZIb0;1k
5;V=:KV=<kV45;V=:@03/8dN00RiSC>iSBViSABiSAC1Q02iSAAP;aC:XE84
g;=L017:ZVKCZTO:ZTO:V2W:XCg:V2W:V1BiSAC1Q02`LP3:V1B`SAjNLQB`
NaC:XCgCZTO:ZTL00/ZH500=diP:bYPDbYPDbYPDdiP:bYPD^H@DbYPYbYPD
^H@DbYPD/8dNdiP:00:iQ1@06[UW0;V458=108eE2/ZH:M>ZAmbcG=>Q:LZH
5<ZH:LZQ?LZZI^g@V=bcQ>g@V>BnQ>g@V=bn[Ng@V=c7Xng@V<ZZI[VHG>g@
V=c7XmbcQ0;T_X@01]bcG=>ZAlZQD]bZ<lZQ?NBcA`?CZTL01]bZ<m>ZAmbc
G<ZQ?M>Q:MbZ<`?CXBT2g:Xc00KL/ecLZS?CZTOCV0ZNNc?LZS<2i;=700WC
XBWL/ecCZTOCZTNiQ1BiSC?:V1B`N`[CV0X00/640008bYPD/7/:bYPYdh@0
bYPD`H@0^G8c^FL00k1k2P07^H@D/7/:^FL0/7/:i;j4g;=LbZY700;CZTL0
1>BcAm>ZAlZZAmbZ<`;CXBT04LZH:LZH5<ZH5;V45;1k59ib57]<560_54H_
2SdL2R`V52<L2R`B01X92PT9514L2QXB50024A`:00<J4Q@d;ahA9Q@00QXB
500D2@TD4A`:2A8:2@TDPbl0^H@D/7/YWUhDSED:Nd`:H2l:ARHD;1`D6PT:
4A`:2@TD6RHD2A`D6PT:^IQL0/[@eP0:g>?Pb]3Fdn?eg>?PkOKeUJ6gJW]_
YZZ]b]3FkNgZ0^gfm@03kNgZc<c<c<c<05o<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVooooc<c<01_<c<`01_omooon
ooonooonoooooOoon`;oooX02?KbkoC`lMoJh<W3cl2ibKVab;2V_jbS_PRN
UK08W9>^<9fC[0RLTjh8WIB_00RQU[BaY/B^Y[jf[l72_<[:aLcQg>3]k>X3
oook00?ooogoo_ooo_l00_omo`03ooooc<c<c<c<0>C<c<`01;1k:K2=<iib
59j=:@:=E@X02iib2YiN59ib2Yib5:Ib5;2=7[1k59ib5;1k5;2=7[1k2P02
^HdD0k1b00:VLP000iib2Yj=<mbZ<`02bZ4m01?:XE;:V1BiSC>`LP3:V2VE
EAB3GQAZ@@ZVI`2NLPZ`N`ZNLQC1Q02`NaB`SAjiSC>`SAjiSC>iQ1@00[2=
7P;:V1@2^HdD00JiQ1C:V1AG703:ZTOL/ec:ZVH2g;=L00C:ZVK:ZTO:XE;L
ZS<2bZ4m00k:V1BiSAB`N`Z`N`[1Q02VLQA6;`YkC0[:V2W:ZVKCZTO:V2W:
V1C:XCd4bYPD026iSBViQ1BiSC?:V2W:V1B`SAk:V2W1Q02iQ1BiSAB`N`ZN
LPZEC2V`SC>`SAk:XE;:ZTO:XCg:V2W:V1CCZTO:ZVK]d9SL/hCC_XkT_XCC
_Xk]d9S]fLc]d9S]fLcC_Xk:XE800^g@V0;T_X@02=bcG=>ZAmbZ<nBc<lZQ
?M>ZAlZQD]bZ<`;CZTL01mbZ<lZQ?LZH:LZH:M>Q:MbZ<m>ZA`02dj4Y00OT
/akLZS?L/ecLZS?CZTOT/ajNLQ@01MbcG0;CZTL3bYPD00?1Q03CQ02iI`00
0l6400?:V1@00k1k2/ZH5;V45002/7/:0l64000V/7/:WW8:i;j4g;=Li;=7
g;=LdjY7g;=Lg:Xcdkj>bYPYbZ4mdj4YbYPDdj4YbYPD^H@Y/7/D/8dNPehD
LSP0ARl:?A`:;2HD8a`:6Q`N4A`:6Q8D2@T:6Q8D2@T:2A8:6Q8D=2lN6RHD
4BHD2@TD6Q8D0Q4L2P0D2@TDEa`0`H@0/7/DYVL0LSPDPd40ARl:8bH:6RHD
6PT:2A8:6Q8D4BHD6Q8D0000g;=L/;k1`LO<Y/OP0l[@eP06kOKe/;>gCfML
YZZS`LO<kNgZ0^gfm@03g>?Pc<c<c<c<05o<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVooooc<c<01_<c<`05?onooWh
oOonoooooooooOkmnoonnoolnnSTiM;=dlBlbK2W^Z>I/YZ?[HQjWX=gWHAj
WH=iW85gVWmeV09nM9L00gmeV81fVGidU`07OWBG<7idUPQmLiH00gmeV7ec
UW]aU002NW2C00=mLiJ0MYV2N9/00X=gV`08SH:RWI>^Yijc/:Rg`[[5dlkD
iN7RmO7b0_ono`05ooooookoookoookooooo0>K<c<`01Iik<ij=:Iib2Yib
2YEE0002SED:01NVLP2=E@Z`SAj`SAjVLQBNNc>VLP2iSAB`N`ZVLQBiSAB`
NaB`N`ZVLP2VLQC1Q02`N`ZNLPZNSC?CXBW:ZTO:XCfiSC<00[V=:@:iSA@0
69ib2V0_54HV58eE2Yib2[1k5;1b0;1k2[1k5;2=7/ZH:K24:KV=<k24:K1k
2[V=<l640;V=:K2=7/640;V=5<ZH56115<ZZA`;L/e`02m>ZAlZZI]>ZAmbc
G=bZ<kV=<lZH5<ZH:KV=5<ZH5<640002/7/:00AkC1@J4QB3GQB`SAh2djY7
00W:V1C:XCgCV0[CV0[:V1CCV0[1Q03:V1B`N`X00/ZH500=^HdDbYPD^HdD
bYPD^H@D^HdD^H@DYW8DWW8DJT4:YW8Dg;=LbZ4m00?:V1@01]bcG;VHG>Bn
Q=bcQ>g@V=>nSP;]d9P03]c7Xng@V>g@V;VZKlZZI^BnQ>g@V=>nS]bcG=>n
S^BnQ=>ZAlZQD/ZQ?@;CZTL01<ZQD]>ZAnBcAlZQ?@;CXBT01<ZH:M>Q:M>Z
AmbZ<`;CXBT02MbZ<lZH5=>ZAm>Q:MbZ<m>Q:H=N5>g7G>BcA`02g;=L00KL
/hCL/ecL/ecCZTOCXBViQ1@4/7/:00JiI`31Q031Q031Q03CV0ZiQ1@2/7/:
00?1Q02`N`[1Q0000[1k2P05^FL0YW80kLMLg;=LdjY700GL/e`00lZH:M>Z
Am>Q:@02bYPD00n`SAk1Q02`N`ZNLQBNLPYkC1AP;`Y6;`XS9PXS70XJ2@X9
4PX92A@A70X92@X00Q4L2P072@T:AT4N6RHD2A8:6Q8D2A8:4A`:00892@X0
4CdB2[1k2YiN5:IW07]<2W8h54H_2SdL2QX92Q4L2Q4V514L2QX92QXB5000
0>g7Q;2c]`03b]3F0]cSh005kNgZ`LO<JW]_UJ6>/;k100?]m_D00ng]j/c<
c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI_ooolc<c00Kc<c<00Coo_onoOooooooool2noWj01WflOGTgnG@
b]Bn^<JcZ[nLTZf<OZ63M9]gIiAmKIa]HXe]HXa/HHa/HH]/HHa]HXa^Hhi^
Hhe[H8][H8Y[H8][H8Y[H8][H8Y[H8/00V]PRP0]JF6:Jf2:JF6:Jf2:JF6:
Jf2:JF6:Jf2:JF6:Jf2:JF6:Jf2:JF6:Jf2:JF6:Jf2:JF6:Jf2:JF6:Jf2:
JF6:Jf2:JF6:Jf2:JF6:Jf2:JF6:Jf2:JF6:Jf2:JF6:Jf2:JF6:Jf2:JF6:
Jf2:JF6:Jf2:JF6:Jf2:JF6:Jf2:JF6:Jf2:JF6:00A[H8X036]PRf]PRV]P
Rf]PRV]PRf]PRVeRSFaQRfaQS6aQRfaQS6eRS09^Hhh037AWTfaORVeQRGea
UHn4XZ2F[[>Z_L>kb]K>fNSSj__fo?omo`;noOl00oonookmooooo`3Vc<c<
00FNLQAZEAj=E@ZEEAAkC0X00XeE2P:EE@005JIb59ib5;2=7ZIb5:IW0;2=
7ZIb5;1k2[2=7[V=5;1k2Yib2[1k2[1b0:Ib0:IW09j=<lZQD/ZQ?LZQD/ZH
5002^HdY00>`LP31Q02EE@000THV5006^H@D/7/:YW8D/780/7/:/7/D0[V=
<`04/8dN^HdY^HdY/7/D0[2=7P03diP:^HdY^H@D00;1Q0001F0_5:JQI]bc
G<ZZI]bcQ003djY7017LZS?:ZTO:V2W:V1BiQ2W1Q02`N`ZiSAC1Q023>01b
>02EEABiSC?:XE;CZTO:V2WCV0X00/ZH:@06bYPD^HdDbYPDdiP:/7/DbYPD
0[2=7P;:V2T02KV=5<ZH5<ZH5;V=<k1k58=107]<5;V4:MbZ<`03bYPY00K:
V1CCZTO:XE;L_Zg]d9SL/h@3kM2H00?Tal7Laj?]d9P00]>nSP0<g;>4i;j4
g;=LdjY7bZYVg;=LbZ5BbYPDdjY7bZ4mbZ5Bi;<c0m>ZA`03g:XcdjY7djY7
00;CXBT02lZQ?M>Q:MbZ<mbZ<m>Q:MbcG=bZ<nBcAmbZ<g]<5>g7Q002i;j4
00OL/ec]d9ST_XCT_XCT/dOLZS>VLP000XeE2P08WUhDYT`0/7/:`H@0/7/:
`H@0^H@D`H@00[1k2P09`H@0^FL0`H@0^FL0/7/:^FL0/7/:g;>4bZ4m00?L
/e`01^g@V=>ZAmbcG=>ZAm>Q:LZH:@?:V1@03[V45;1k2Yib59ib2V1155LL
04H_2S@_7R<L2Q4L2QX92QXB50T92PTB2P<92@X00dIE:AXV51X92P024A`:
0PT92P084A`:6Q8DWUhD/7/D/7/:Pbl0Pd40H2lD0R<L2P086PT:4A`:2A8:
2@TD4A`:0000m]24/;k10/77c00<b]3Fdn?eb]3Fdn?eY/OPLXf4YYR4/;k1
m_KekNgZkOKeg>?PHLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8
`;R8`;P4c<c<00=VIVKoooo<c<`06lc<c0?oool07?gmoocjooomoo;/m];<
f/>jcJZP^IZ<[HMhWhMfXYB2]9b9`:^Jd<Znl<W0kl[0l/c3l/g3mLk5m<k4
m/k5m<c2m<c3l/c2m<c3l/c2m<c3l/c2m0;<`o80;L_3l/c3l/_3l/c3l/_3
l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3
l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3
l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3lP02c<?b0/g4l`0JcL?e
cLCccL?ecLCccL?ecLCcc<;dcLCcc/Cfc/Gdc/CfcLCcc<;dcL7c`;;U]JCH
Xi?4T82]PG:KQ7JIWI2^]Zc4`[W<f=;PlN_goO[o0_ono`;nool00oooolc<
c<c<c03Tc<c<00RNLQBEEAB3GQB=E@YkC0YZ@@Z3@@2EEA@2WW8:00BVLQB`
SC>VLQBNSBT2^HdD00BVLQBiSAB`NaB`N`X2WW8:00FVLP2`N`ZVI`2NSBWC
XBT00lZQ?@0=^HdY^HdDYW8D/7/:YT`0;2HDPehc^H@D/7/D/7/:/780/7/:
/7/D00>iSBT00k2=7[1k5;2=7P02^HdY1;V=5005`H@0JT4:bZ4mg;=Ldkj>
00?L/e`04/ZZAmbcG<ZH5;V=<lZQ?KV=5<ZH5;1k2[V=<kV45=>H2ZIb0;V=
<lZZAm>ZAlZZI/ZH5<ZH:@G:V1@00m>H2ZIb0=bZ<`02bYPD0lZH:@05`H@0
bZY7dj4Y^HdYSED:00;:ZVH01kV=<lZH:LZH5;V=:M>H2]bcQ=>ZA`02kM2H
00[Laj?]d9SLaj?]d9STal7T_XC]d9SLaj>iZVoT_X@2g;>40lZZIP05djY7
/8dNdj4Yg:XcbZ4m00;CZTL2dj4Y00CCZTOLZS?CZTO:V1@3dj4Y0]bZ<`07
dj4Yg;=LdjY7i;=7i;<NNd`:m]2400;T_X@2kM2H00CC_XkL_Zg]aeb`N`X2
SED:00MkC0Z3>02EEABiI`2`N`[1Q03:V1@00[V45004bYPD/7/:^H@D`H@0
0[UW0008`H@0/7/:/780kLMLg;=Lg;>4g;=Lg;>40mbcG004bZ4mdjY7bYPY
bYPY0[V=500E/8dN/7/:YW8DSED:H2lDH2l:Ea`08bH:8a`:6PT:4A`:6Q8D
4A`:2@T:6Q8D4A`:4BHDARHD;2HD4A`:2@T:00<A70X01@T92Q4L2[1E0:Ib
5;V45002Nd`:00aP;a@S70XS70XA70XJ2@XA70XJ4Q@A9Q@0003:ZVK1/jfV
an03b]3F0mcSh007PiR>Phf4/;>gg>?PkNgZm_oog>?P067<c<`016IVIXS0
^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVooooc<c<01_<
c<`07ooooOgmnoooooonoooloo[gonGNk/>kd[BYaiN;[hamZ8em[ZREc<Jb
kLjjnMS6olg0m/c4mm36n];:oMC:o]?;o]C:o];:oMC:o]?;o]C:o]?;o]C:
o]?;o]C:oP02dl_n;];;oP?Cboh06mC:o]?;o]C:o]?;o]C:o]?;o];8o=79
o=?9oM79o=;8o<o7n/o5nLk4nM31n]G3oMG4nlJejjZHbY:1[XimYiB6ZJnR
`<Bjd^;KkOKco_kmo`02o_oo00?noogoooo<c<`0iLc<c00DWW/cWXdcUED0
?A`:ARl:LRH0Nd`:SED:UEDD/7/:YW8D/8dN^HdDWW8:/7/:YW8D/7/D^HdD
YW8D/7/:0iib2P07YW80YVL0WXdYdjY7^Hdcg:XcbYPY00:`SAh04k1k2Yib
2XeE2ULL09ik<kV45;1k2/640;1k5;V45;1k2[2=7[24:K2=7[VHG;24:K1k
5;2=7/ZH:@02^HdD01_1Q02iQ1B`SAikC0Z`SE;L/ec:ZVKL/ec:ZVKL/ecC
ZTO:XE;LZS?:V1C:V2ViSAC:V1B`NaC:XCf`SAj`NaC:V1CCZTOL/ecC_XkC
ZTOLZS<00/ZH:@?:V1@02kV=5<ZH5;V=5<ZH:M>Q:K2=7/ZH:K2=7/ZH5<ZH
:LZH5002bZ4m00B`SAk:XE;:ZTO:V1@2bZ4m00G:V1C:XCgL/ec:XCgLaj<0
0ng@V008g<NSkM2HkM2HkMW<i<O1kM2H^JY_kM2H0]bcQ008g;=LdjY7djY7
bZ5BbYPYbZ4mdj4YdjY70]>Q:@03djY7dj4Ydj4Y00;LZS<5dj4Y013LZS?C
XBW:ZTOCXBWCZTOLZS>3GQCC_Xk]aecT_XCL/hCT_XCL/ec:ZTNiSBVVLP02
LSPD00B3;`1b>1B3>02VI`02/7/:00>iQ1BiLS?:V1@00[V45008^FL0^H@D
/780`H@0/7/:`H@0/780i;j40mbcG00Cg;>4kLN4djY7g;=LbYPDdj4YbZ4m
bYPD^H@D/7/:^H@DYW80WW8DUEDDH44DH2l:ARH:ARHD8bH:008J2@X080T9
514L2PT92Q4L2Q4V500004IE:B<_7Q4L2QXB50TB2QX92PTB2QXB50T95:I<
0;V45;1k2W8h58<_07]<2R`L52<L2QX92PT92Q4L2PTB2QXB50000<ZQDZJZ
Xl77c0;:d=H02m?SmL[@e]?SmMcSh8>HSX>4NjJZ[McSh=?SmNg]j]cSh01Q
c<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIV
I_ooolc<c00Kc<c<023ooo[ko?Oooogoo_ojmooUhO;:`]Z_Y/FFR[:=OJbI
Q[f/V=?9/o?LaOoD_Oo@_OoCb?oCc?oGc_oHdOoJdOoId_oHcooFcooLdooK
e?oLdooKe?oLdooKe?oLdooKe?l`fMGo0]WBo`0Of]7ofM;of]7ofM;of]7o
fM;ofm;ofM;of<ooe/ooe/goeLkoe/goelcocKgkcK[jck_jd;ckbK?a/ikG
VHFjQgFUVhbc[Z?3cLGMj>CcmoKnnocnoOolo_okooom0>K<c<`01;VHG;2=
DYik<cdL2P969PX027]<2XeE2YEE0:Ib0:Ib5;2=7ZIb59ib50BVLQ@3YW80
00FNLQBNLPZVLP2VLP2NLQ@00/ZQ?@0=^IQLbZ4m/8dN^H@D/7/:YW80UED0
JT4:YW8D^Hdc^HdD/8dc/78000:`SAh03kV=5;V=:K1k2/ZH:K24:K1k5;V=
5;2=7[V=5;2=7[V=5;V45<6407]<2[2=<`02g;=L01OL/hCC_XkCZTO:V2WC
ZTO:V1BiSC>iSBWCV0[:V1B`N`[:V1BiQ1CCV0ZiSAC:ZVKCZTOL/ecCZTO:
V2W:XCg:V1C1Q0000lZH500N`H@0/780dj4YbYPYbYPDg:XcdiP:bYPYbYPD
bYPYbYPDg:XcbYPY^Hdc^H@DbYPY^Hdcdj4YbYPDbZ4mg;>4bZY7dkj>g;j]
dkj>g<NSkM2Hg;j]kMW<g;j]0^g@V008^IQLi;j4g;=Ldkj>bZ5BbZY7bZ5B
djY70lZH:@07dj4YdjY7dj4YbYPYbZ4mbYPYdjY700;:V2T01<ZQ?MbZ<m>Q
:LZQ?@;CXBT01m>ZAmbZ<nBcAnBc:H=N5=bcG=bcQ002g;=L00kT/dO:XCfV
LP2VLQAP;`Z3;`23>02VC02=E@Z3;`2`N`ZiI`2iQ1C1Q002^H@D00FiSC>`
N`ZiI`2`N`ZiI`000l64000J/780i;j4djY7i;j4bZYVi;j4g;>4djY7i;=7
bZ4mdj4YbYPDbZ4m`H@0^FL0`H@0WW8:YVL0WUhDARl:H2l:ARl:8bH:;180
6PT:4A`:0PT92P072A8:2@T:6PT:2A8:=5DY8bH:2A8:008J4Q@0514L2QX9
2Q4L2P0008<h0;UW0;1k2YEE08=107]<2R<L2R<V2Q4L2PT92Q4L2QXB50T9
2P000<ZQDYF4SP;1al`3b]3F0]cSh004UJZ]JW]_/;>gg>?P0^g]jP03g>?P
c<c<c<c<05o<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
1<c<c003IVIVooooc<c<01_<c<`06?oom_[klooooOonooKbomWDj[fddjFJ
`Xal[I1o]ZZFeK^VjL^do=>kolbdolnkom;7om7:o]C=omG>omK?omG>omC=
om;;o`OHdOl00mKBomGCom?Do`0]dmCo00?EdooDd?oFcol01]K?o`03fM;o
f=7oe/oo00CDcOl04]G<omo?om[6om:molZen/B]lkNPi:RBdYb7`9>1/J>D
^kndd]gIj_;anO_mo?_on_con_kooNK<c<`01KVZKk2=DYj=:HeE2W8h5002
JT4:00>EE@2=E@ZNLPX00jIb5008/8dN/7/:/7/:YW8DYW80/7/:YW80YW8D
0[1k2P0>YW8DYW80Pg/cbZY7bZ4mbZY7^Hdc^HdY/8dN/7/DYW80/7/:LSP0
WXdY0[2=7P04/7/DYW8D^HdD`H@00[V=5008/7/D^Hdc/8dN/7/D/8dN^Hdc
^HdY^H@D0[V=5006/8dNNd40UHeBg;=Ldkj>g;=L0/ZZIP04bZ4mbZY7^IQL
bYPD0/ZQ?@03/8dN/7/:bYPD00:iQ1@00kV=:LZH:LZZA`02bZYV00?:V2WL
ZS?:V2T00lZH500;^HdD`H@0^H@DbZ4mg:XcbYPDbYPYbZY7djY7bYPYbZ4m
00;:V1@05/ZH:KV=<kV=:LZQ?LZZAm>Q:LZQ?M>Q:Mc7Xm>ZAng@V>C7`Ng@
V=c7Xng@V=bn[Ng@V=c7XngIc>g@V:J4D^BnQ0;:ZVH01]>ZAlZZAkV=<lZQ
D/ZQ?LZH:@;CXBT00lZQ?LZH5=>Q:@02dj4Y00_CZTOCXBW:V1C:V1CLZS?C
XBWLZS?T/akLZS?:ZVKCZTL00]bZ<`04PehDbZYVi;j4g;>40^BnQ003g;=L
kM2Hi;<Y009b9P002V0_578h5;1E078h5;1E0;V=5<640;Ub<kV45<ZH50:i
Q1@01;1k2[V45;UW0;1k2P;1Q0001K1b0=>ZAmbcG=bcG=>ZA`02g;=L0]>Z
A`;:XCd01LZH:LZQ?L640;1k2[V45002WW8:00>NGQAP;`Yb>0000TH_2P@A
70X00`T92QX92Q4L2P022@T:00=69Q@S;ahA70X00Q4L2P0F2@TD4A`:2@T:
4A`:H2l:/7/:^G8cUED0SED:H2l:ARl:8a`:6PT:6Q8D2A8:6Q8D2A`D0000
^HdcUHAkb]3FY/OP0/[@eP;Lhn001=?SmIFZ[FYkKjJZX`;Lhn000ngfmMcS
h<c<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI_ooolc<c00Kc<c<01CoooCkoO;ooo_noOo_jo[GdN^i[mBISK^B
PKRFPl>]V=fhX^_1ZOG<]?o@]OoKaOo?a_o=bO_?bog@c?h2dLgo0]3<oPOB
c_l00m7?olo@olkAoP0]c]7n00??d?k@c_oAcOl02=7=o`0Dd/kodLgodLgo
d<cncl_mdLSoa;Cec[[oeKoodkgoajoi]YkXYi3FWXS8Th2gW8bi]:W;e<oS
knkfnogl0_con003o_omc<c<c<c<00;<c<`200000/c<c0030000c<c<c<c<
00800002c<c<100000;<c<`200000/c<c0800002c<c<1@0000C<c<`60000
00?<c<`0000000000/c<c0@00003c<c<1@000:W<c<`03;VHG8=N58=N5611
560_2VY12X=109iN58eE2[1k:JIb5;2=7PBVLQ@03k1k2ZIb0;1k2ZIb09ib
2[1k2ZIb09ib2ZIW09j=:MbcG<ZQD/ZQ?LZQD[V=5002/8dN00BNLPZVLP2=
E@Z`SC<3^HdD00_1Q02`SAj`LP2`SAjiSBV`SAjiSBV`Q2VVLP2`SC>`SAh0
0kV=50:iQ1@01YEE0:J4D]bcG<ZZI]bcG<ZZIP;L/e`01<ZQD/ZQ?LZH:KV=
<`;:V1@02[2=7[V=<kV=5;V=:LZQ?K24:NBcAlZZI]bcG<ZH50;:V2T5bYPD
00>iQ1C:V1C:XCd00/ZH:@07^HdcbYPYbYPD/8dN`H@0bYPYbYPD00;:XCd0
3/ZQD/ZQ?M>Q:LZZAlZH:MbcG=>Q:Mc7Xng@V=bcG>g@V=bcQ=c7Xng@V0?L
aj<04ij=<mbcQ=bcQ<ZZI/ZQD/ZZAlZQD]>ZAlZH:LZH5<ZQ?LZH5=>ZAm>Q
:LZQD/ZH:LZQ?M>Q:LZH:@02bYPD00?CXBW:V1CCXBT00]>Q:@06g:XcdjY7
djY7i;<YWW8DbZYV0]bcG00Ag<NSi;j4g;>4WXdcg;>4UED0Nd`:LSPDPbl0
SED:WUhDYVL0^H@DbYPD`H@0^H@Y^HdD00:iQ1@3/7/:00G1Q02`N`[:V1Bi
I`3:XE800]bcG004bYPYbZYVdjY7bYPY0]>ZA`06dj4YbZ5BbYPD^HdD^H@D
`H@00Yib2P06PehDJT4:H2l:H2l:?A`:8bH:0QX92P042@T:4A`:2@T:4A`:
0PT92P03;4`Y;2HD4A`:00892@X01`TB2PT92Q4L2PT92ULL0<ZH5;1k2P02
SED:00ib>1AG700S9PX92@XJ4Q@J2@X92@XJ4Q@0002NLS>VV6oLhn2`_/71
al`3b]3F00SChoFV/l5ZNfnVZZ?CfMKLhn3]m_GLhn1Qc<c<00AVIVJ8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI_ooolc<c00Kc<c<
02knoognoo_ooo_dm?;Sh>WAbN6^XLf5Lk6DO/NDNlbWS]nfVn[4ZOK?]?o;
/?o@^_o<`?k;`oc=a?g>a_o@aoo?b?kAb?o@bOo@aok?b?k@aok?b?k@aok?
b?k@aok?b?k<bOk:b_c:b_k:b_c:b_k:b_c:b_k:b_c:b_k:b_c:b_k:b_c:
b_k:b_`Cb/[n00o:b_c:b_k:b_c:b_k:b_c:b_k:b_c:b_k:b_c:b_k:b_c:
b_k:b_c:b_k<bOh00/k7o@0OclKmc/OmclKmc/OmclKmc/Ombl;kc<CmclKo
d<Sod<OocLGnbl;kb[okf<Codkgoc;Coajoma:Wj^Yo^ZHkKUh36TG^iUXBf
ZYk4c<CLj^Obn?Sjo?kioOoiooom00C<c<`2000000G<c<`000000000003<
c<`00P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c080
00000lc<c00000000002c<c<0P0000C<c<`200001Lc<c08000000lc<c000
00000002c<c<0P000003c<c<0000000000;<c<`20000ZLc<c003/8eBUD`Y
ARHD00969Q@02f0_57]<2XeE2Yib2ZIb09ik<kV45:Ib59ib2ZIb5;2=7P02
/7/:00>`NbVNLPZNLPX00Yib2P06/780UED0WXdYbZ5BbZ4mbZYV0/ZQ?@09
^HdY^HdD/7/:/780PehDWXdc/780^Hdc^HdD00:`LP002K2=<k2=7[V=<k2=
7/ZQ?K24:K1k2[V=:KV4:@02^HdD00FiQ1BiSABiSAAkC1BNSC<00]bcG00A
bZYVg;=Ldkj>g;=LbZYVbZY7bYPYbZY7bZ4mbYPD^HdD/8dN^Hdc/8dNbYPD
bYPY^Hdc00;:ZVH04]bZ<lZQ?LZH5;V=:M>H2[V=<l640<ZH:KV45;V=<lZH
5;V=<m>H2[V=:LZH5;2=7/ZQ?KV=50>iSBT00kV45=bcG<ZZA`02bZY701cC
ZTO:ZVK:ZTO]d9SLaj?L/hC]d9SL/hCT_XCL/hC]d9SLaj?]d9RNNc?T_XCL
/ec:ZVK:XE;:XCg:V2W:ZVK:XE;1Q02iSC?:V2W:XCgCXBW:XE82bZ4m0]>Q
:@;:V1@01m>Q:LZH:M>Q:M>Q:M>ZAmbZ<lZQDP02g:Xc00VNLQBiV5cL/ecL
/ecLaj?T_XCC_XjVLQCLZS<00W8V000@Nd`DLSPDPd40WUhD^H@D/7/Ddj4Y
bYPY`H@0^HdY^Hdc^H@D/7/D`H@0^HdD`H@00[V45004^FL0bZ4mdjY7bZYV
0m>ZA`?:XCd01=>ZAlZH5<ZH:K2=7P:`N`X01jIb08eE2YiN56Y12THV2V0_
2SdL2P028a`:00<J2@X92@XA70X00PT92P096Q8D2@T:8blY;2HD4A`:6Q8D
4A`:6Q8D4A`:00892@X01R`L5=>40;1k2X<h07]<58=1008S9PX031X92Q4L
2QXB50TB2QXB50000<ZQD[24I]?SmL77c;2n`L77c0;:d=H02=cSh<77c4mN
IYFHXl[@e]cSh>gfmMcSh67<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2h1<c<c003IVIVooooc<c<01_<c<`08?Wloo_mookon?Khj^SU
h<RmcZJAbGiQ]I5^eYahhZ^9ikRIjKnQilBYk<Z`nLfeoljiolZjol^jolbl
om2oom31olnnolbmoljnolfnoljnolfnoljmolfnolnnoljoo`S;_ol2c<3o
7<^oo`[<`?l2cKko01o>_Oo=__o>_Oo=__o>_Oo=__o>_Oo=__o>_Oo=__o>
_Oo=__o>_Oo@_?o@^?oA]Oo<[oo4Yo^mWoFeUnfXRmnLPLj<LkEjIIfTTko;
_]cWg_7jm?kon_kooOkoool01<c<c08000001Lc<c000000000000<c<c002
000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P000003
c<c<0000000000;<c<`200001<c<c0800005c<c<0P0000C<c<`3000000?<
c<`0000000000/c<c080002Yc<c<00RNSC>`NbT/71A6;`YP;`Yb>01P;aB=
E@X3WW8:00^`SAjNLPZNLS>NLS>NLPZVLQBNLPZVLP2`N`ZNLPZVLP000Yib
2P0CYVL0Pg/cdjY7bZY7bZ4mbZY7/8dc^HdY/8dN/7/D/7/:UED0/8dN^Hdc
`H@0/7/D/7/:/7/D/8dN00>iSBT02;V=<k24:K24:K24:K2=7[V=<kV45;2=
7P:iQ1@058eE2Yib5<ZZI/ZZI]bcQ<ZZI]bcG<ZQ?LZZI]bcG<ZH5<ZQD/ZQ
?LZH:LZH5=>H2/ZH5;V45;V=5;V=:@;:XE801=>ZAmbZ<lZQ?LZH50;CV0X3
bYPD00FiQ1C:V1C:V2W1Q02iSA@00/ZH:@07/8dNbYPD^H@DdiP:^HdD^HdY
/8dN00;:XCd00m>ZAlZQ?LZQ?@02djY70]bn[@04i;j4kM2HbZYVg<NS1>g@
V004WW8:g;>4bZYVbZYV0[V=<`0:bZ4mbZY7bYPDbZY7bYPDbYPYbYPDbYPY
g:XcbYPD0lZH:@07bYPDbYPYbYPDbYPDdj4YdiP:bYPD00CLZS<039j=:K2=
D]>ZAm>ZAmbcG<ZZI]bcQ<ZZAkV=<f0_57]<2V0_2P:3;`00378h5;V=<kV4
5=bcG<ZH:KV=:KV=<kUW0;V45;1k2[1k:KUW00:iQ1@01[UW0;V45;1k5<ZQ
?M>ZAlZZA`;CZTL01=>nS/ZZAlZQ?LZQ?@;:V2T02/640;V45;1k2Yib2ZIW
08eE2W]<2TH_2ULL04H_2P8S70X01A4L2QX92Q4L2QX92Q4L2P022@T:01/d
;ahS;ahA70X92A@A70X92@XJ2@XA70XJ4Q@92@[CV0Z`N`Z=E@Z3@@23>016
9Q@S9PXS70XJ2@X92A@A70XJ4Q@0002VQ5:VXFK:d=J`_/401<[@eP;Lhn00
1TIWG:JQV<[@e]cSh>g]j]cSh67<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVooooc<c<01_<c<`05OWmoo_oookon?Sk
j^GPf/RkciAi_7iL_I=ZhYedjZ^6i[FBh[ZKgkjQhl:VlLFZnLRaolN`olN`
o/Vco/bfo`02c[So00?=]oo<]oc<]o`00/bgo0?=]ol00lbholfiolfio`06
cKWo1<bho`C;]oh@bkOo1<^goPC<^?l8c[[o2<jho`;A^ol2d;[o01G?^Oo>
^?o=]oo>]_o;[_k<[?o7Yo[0X?FiV>nbTNRVQMbKNljDN<=kHZ>;Mjc4]=_X
foGon_oooOonn_Woo_l01<c<c08000001Lc<c0000<c<c0000<c<c0020000
00?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P0000;<c<`2
000000?<c<`0000000001<c<c0800005c<c<0P0000;<c<`400000lc<c080
00000lc<c0000000002Yc<c<00>EEABVLQ@A70X00V0_2P09H2lDSED:WW8:
UEDDSED:UEDDWXdYPehDWW8D00FNLPX01:Ib09EE09ib2Yib50:VLP001X=k
<m>ZAlZQ?LZQD/ZZAlZQ?@:`Q2T01ZIb5;1k2Yib5;1k2[V=:K2=7P:`Na@0
2;1k2[24:KV=:KV=:K24:KV=:K1k5:Ib50>iSA@02;V4:L640;1k5;24:JIb
08=k<ng7G=bcQ0;:ZVH01=bcG<ZQD/ZZAlZQ?@;:V2T03<ZH5;2=7/ZH5;V=
5;2=7[V=<k2=7[V45;V=<lZQ?MbcG<ZQ?@G:V1@04;V=5<ZH5;2=7/ZH5;V=
<kV=5<ZH5<ZQ?LZH:KV45;V=<k2=7[V45;1k2[2=7[V450C:XCd00m>H2/ZZ
I/ZZIP02kM2H00[Laj?C_XkL/hCT_XCC_XkL_[OLaj?]d9R3GQCL/e`2bZYV
00C:ZTNiSC?:XCgCXBT2bYPY00?:V1C:V2WCXBT00/ZH:@04bZ4mbYPDbZ4m
bYPY0/ZH5003dj4YbYPYdj4Y00;CXBT03LZH:LZZAmbZ<m>Q:K2=7Yib2]>Z
AlZZAm>ZAlZH:MbZ<mbcG<ZZA`02H2l:00Qb9P169QAb9P2EE@3:ZTO:V1C:
ZVK:XCd3^H@D01RiLS>iI`2`N`ZiQ2ViQ1C1Q02iI`2iQ1BVLQCCXBWL/ec:
XCgCZTO:XCg:ZVK:XCgCZTO:XCg:V2W:ZTO:V1B`SAj`N`ZNLPX2SED:02Qk
C0Xm70YP;`Xm70XS70XA70XJ2@XA70X92A@92@XJ4Q@A70X92@XS9PXJ9Q@S
70XA70X92@XJ4Q@92A@92@XA70X92AC1Q02`N`Z=E@Z3@@1kC1A69PXS9PXS
70XA70XA9Q@92@XA70X92@Z3GS?L/hC:d=J`_/42b]3F00[1alc:d=K:d=K:
d=JEV:>=V8k1alcCfMKChoGLhn1Qc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^0C<c<`00fIVI_ooolc<c00Kc<c<01Sko_okooonooKj
n_3Sf]o<^megFjInFl>>IM^HL>:VPMj_SMVcU=RfV=jiW>jlX?G1Y_FnY_:o
Yo71Z_;4[OG7/?K8/OG8/_<4a[3a0/J_l`;6[oD00lRamLNbmLNbm@05ak;e
2<F`la35/?D8aK3c2<Jam0C7/O84ak3d0/Ram`0Gak3faJkda:ge`jcd`Z_c
`jWc`JCf`JCh_Ykc^9S[/i7U[X[QXgoGV7C<T6k4O5f[LeZLak?Vi]WgooWo
ooojn_[`oook00C<c<`2000000G<c<`0003<c<`0003<c<`00P000003c<c<
0000000000;<c<`2000000?<c<`0000000000/c<c0800003c<c<100000C<
c<`200001Lc<c08000001<c<c0000000000000K<c<`40000ZLc<c004PehD
Nd`D?A`:Ea`00THV50:NLQ@01Yib2XeE2Yib59ib5:Ib09ib50BNLPX05;1k
2YEE09ib2Yib2ZIb09ib2ZIW08=N5=>ZAkV=<lZQ?KV=<lZZAkV=:KV=5:Ib
59ib2ZIb09ik<k24:@:iSA@2/7/D00b`SAjiSBViSBViSBViSC>`SAj`N`Zi
SC>iSAB`SAj`NaBiSA@2/8dN01>EEAB3Nc?L/ec:ZVKC_XkL/ecC_XkL/ec:
ZTO:XCf`SAk:V2ViSC?CV0[:XCfiSACCV0ZiSBV`SAh00[V=:@04bYPYbZ5B
bYPYbZ4m0/ZH500D^HdcbYPDbYPD`H@0^H@DbYPDbYPYbYPD/8dNbZ4mbYPD
^HdDbYPD^H@D/7/:`H@0/7/D^HdDbZYVbZ5B0/ZQ?@08^HdYg;=LdjY7dkj>
g;j]dkj>g;>4bZ4m0]>nSP05m]UVdkj>kM2HPehDg;=L00;:ZVH01/ZZAlZQ
D/ZH:LZQD/ZH:M>Q:@;:V1@05LZH:LZH5<ZH:LZH5;2=7/ZH:M>Q:K2=7/ZH
5=>Q:LZH5=>Q:LZH5=>Q:LZH5=bZ<lZH:M>ZAk24:H=N5=>ZA`03bYPD00Ji
I`3:V1C1Q01P;aAP;`YP;a@2H2l:00VNGQC:XCg:V2W:ZVKCZTN`SAjiQ1C1
Q03:V2T00[1k2P06/7/D^FL0/7/:`H@0/7/:WW8:0]>ZA`06bZ4mbZYVg:Xc
g;>4bYPYg;>40/ZZA`0=g:XcbYPY/8dN/7/:WW8:SED:WW8:Nd`DARl:Ea`0
ARl:8bH:6PT:00<A70X02PT92PT950TB2PT92S@_7R<_7Q4L2R`L514L2PT9
2P8A70X04aXB50000=>H2[1b09iN58eE2X=104H_2SdL2Q4L2PTB2PT951XB
50T9500004I17]bcQ;2n`L77c002b]3F00ZVan3Lhn2Van3Lhn23V8j3SHC1
alc:d=K]kN[Lhn1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^0C<c<`00fIVI_ooolc<c00Kc<c<017ko_olooooooKnnoKSf>SA_^aP
@iMnF<F7G]BBJmRONm>YQm6_S]>bT]fgU_6iV_NkW_000[^OjP05_:3Z_Z?Z
`JK[`ZOZ`jS[00?2YnX01L6VjL6Vjl6Vjl6VkL6Vj`0=`:O[0l6Xk0o0Y^d0
1<2Wjl6Xk<6Xk<6Xk0G0Yn/8_jKZ1<2Uj0C0YNX2_jC[01NnXnZmX^VlX>Zk
WnVjW^RjW^^iVo6iVo>gUnbbTN:_S=j[QMZRNMFFK/j3FkajEk=VBIWC_O_U
eo[ilogoooCjo^goooX01<c<c0@000000lc<c0000000000200000/c<c003
0000c<c<c<c<008000001Lc<c000000000000<c<c002000000?<c<`0003<
c<`00/c<c0800004c<c<0P0000G<c<`2000000?<c<`0000000000/c<c080
00000lc<c0000<c<c002c<c<0P000:W<c<`01H=N57]<2VY12W8h07]<5003
WW8D00>`N`ZEEABNLQ@00Yib500>WW8:UED0WW8:UED0WW8:UED0WW8:YW80
SED:YW80WW8:YW80JVLcbZY70kV=<`0A/8dN/8@Y/8dN/7/:YW80WW8D/7/Y
/8dN/780^HdY^HdDYW8D/7/D/8dN^HdY/8dN^HdY00:`Na@00k24:K1k5;2=
7P02^HdD01W1Q02iQ1BEE@2NLQCCZTO:ZVKL/ec:ZVKL/ecCZTO:XE;:ZVK:
V2W:ZTO:V1BiSAC:V1BiSAC:V1BiSC>iQ1BiSAB`SAjiSBW:XE800/ZQ?@09
bYPY^HdcbYPDbYPD`H@0bYPY^HdD/8dN^HdY00?:V2T01<ZQ?KV=5;V=5;V=
50:`N`X03kV=5;1b0<ZQ?LZQD]>ZAmbcG;V=:LZH:K2=7/ZQ?LZQD/ZQ?LZZ
AlZQ?MbcQ002dkj>0]bcQ00<PehDg;=Lg;=LbZ4mbZ5BbZY7bZ4mbYPDbYPY
/8dNbYPY^HdY0lZH:@06bYPDbYPYbYPYdj4YbYPD^H@D0/ZH500KbZ4mbYPD
dj4YbYPDbZ4mg:XcbZ4mbZY7PehDg:Xc/8dNbYPD/8dN^FL0/780WUhDNd`:
H2lDEa`0H2lDPbl0PehDbZY7g;=LbZYVbZ4m/8dN00:`N`X00l640;1k2[1k
2P02/7/:00BiSABiI`3:V1BNGQ@2g;=L0m>ZA`07dkj>g;=Lg;=LbZ4mdjY7
bZ4mbYPY00:iQ1@039ib2XeE2XeE2W]<2R`B04HV2ULL014L2R`B014L2QX9
2PT92P8A70X04`T92Q4L2R<_7R<V2QXV514V2PTB2Q4L2PTB2QXB50TB2PT9
2[UW0;1k2YiN58eE2X<h04HV2R`V50026PT:00H92A@J4Q@J4Q@0001P;aCf
d8@3/;k100W1alc:d=K:d=K:d=K]kNYGGVn=SFo1al7:d=H00]cSh67<c<`0
16IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVoooo
c<c<01_<c<`06?gon_kon_oomoolo^SJm=W2nUHdTWE?`85HcXiTd9afcJB2
c:V8cjb;f[:>l;JCnKNFkKRIjKVJj[VJj;ZKik^MikbNi[fOi`:mWnD00kfO
ikbNi[bNj003^igW00>lW^RlW^JlW^H01KbNiP>kWND2_9kV0kfOia2lW^P0
0kfOjKfOikfOi`02_9kV4K^Mi@:kWNL2_9kX00JlWNVkW>RkW>RkW>RjVnVj
V^d2/YK]00n_T^J/Rmb[QMRYOmFOLM>DIlj1Dl1gC[QL>IGH_ooWfOgel_Wn
ongionOnooP01<c<c0@000000lc<c0000000000200000/c<c0@00002c<c<
0P000003c<c<0000000000?<c<`400001Lc<c0800005c<c<0P0000;<c<`4
00000lc<c0@0002Zc<c<00n3GQAb>1B3@@23GQBNSBVNGQBNLPZNLQBNLPZN
GQBNLQB`SAjNLQBNLPZEEA@019ib2P0AUED0WW8:WW8:UED0WW8:UED0PehD
g:Xc/8dcbZY7/8@YbZ4m^Hdc/8dN/7/:WW8:WW8D00:`SAh06K1k2[24:JIb
5;V=5;2=7[24:KV=:K2=<k24:K2=7[1k5;V=5<ZH5;V=:K1k5;V=5;1k5;V=
59ib2VYW<nBcAm>ZAlZZI]bcG<ZZIP02bZ5B00S:ZTO:XCg:V1BiSC>iSACC
V0ZNSC?1Q002^HdD00jiQ1B`Q2ViSBW:XCg:V2V`SAk:V2ViSACCV0ZiSBW:
V1B`SAk1Q03:V2T2bYPD00RiSBW:V2W:V1BiSAC1Q02iSAB`LP2`N`X2^H@Y
0/ZQ?@03^HdcbZYVbZY700:EE@001Iib2[V45<ZH5<ZQD/ZZA`02bZYV00kL
/hCC_Xk]d9Qk@@3CZTO:ZVK:ZTO:ZVK:ZTOCXBW:XCg:V2W:V1BiSBT3bYPY
00K:V1C:V2ViSC?:V1C:XCg1Q002bYPD00b`SAk:V2W:V1C:V1C:XCg:ZTO:
XCgCZTOLZS=Z@@[L/ec:V1@2^H@D00j`NaBiI`2NLQAb>1AP;aAP;`Yb>1B=
E@YkC1C:V2W:ZVK:ZTO:V2V`Q2T3/7/:0[UW000?`H@0/7/D`H@0/7/:/8dN
WW8:g;>4g;=LbZYVg;=Ldkj>g;>4djY7g;>4g;=L00;:XE802/ZH5;2=7[1k
59ib2YiN59EE57]<2TH_2THV2ULL008A70X26PT:00<A70X92@X92@X00PT9
2P046RHD8blN6RHD4A`:0PT92P0;2@TD2A8:4A`:0000^H@D/7/:WUhDPcP0
Nd`DARHD?A`:00@A70X01Q4V50T953dB2^g@V9FZ[K2n`@;1al`2b]3F00KL
hn3ChoEbSHB3Q7^`/kO1al`2g>?PHLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P4c<c<00=VIVKoooo<c<`06lc<c00Eo_ofooofooog
oocol>7ogLGoEC>AI3j]NU;5QUc8Tfc5WGS5X7k:Y87EZH?Z[8O`/HkZ/i7W
]I?Y]YCX]ICU00:eU><00kJFh[RHi;RHi002]iOS0[JEi0:eU><03[RGi[RH
i;RGi[RHi;RGi[RHi;RGi[RHi;FDhkFEhKJEi;JFh[NFiKNGh`:hUnH2]YGT
01ffUNJfUNBfUNJfUNBfUNJfUNBfUNJfUNBfUNJfUNBfUNJfUNBfUNJfUNBh
UnJhV>BgU^FgUn>fUNBfU^:eU>>eUN6hUnJhV>BhUnJhV>BhUnJhV>BhUnH0
1KRHi0BhUnH4]iKW0kNEj@0B]YK[ZhoVZXkSYh[LY8;FXg_AXGCAUfK?SE_:
QEC:KD6bDbj>e[col>;ono[oo?o/n?oUo_oh1<c<c0<00003c<c<0`0001W<
c<`20000_/c<c004PehDJT4:PehcUED00Yib5006YW80PehDWW8DWUhDWW8D
YW800Yib2P08Nd`:UED0UEDDUED0SED:UED0YW80SED:0Yib2P04YVL0H44D
bZ4m/8dc0[V=:@0D^Hdc/8dN/8@Y/8@YWW8DYW80/8dN/7/DYW8D/7/:^HdD
YW8D^HdD/8@Y/7/D^Hdc/8dcWW/cYW80^Hdc0[2=7P0>`H@0^HdD^HdD^HdD
UED0PehDi;=7^JY_bZY7g;=LbZYVdjY7bZY7g:Xc0[V=<`07bZ4m^HdDbYPD
/780`H@0^HdD^H@Y00:iQ1@01kV=:LZQ?LZQ?LZQ?LZH:M>H2[V=5002bYPD
00?1Q02iSABiSBT00[V=<`0F`H@0^HdD^HdY^HdD/8dN^H@D/7/:`H@0^HdY
/8dN^HdcbZ4mbZ5B/8dc/8dNNd`DLSPDWUhD^HdDbZYVg;>4i;=70]>nSP;L
/h@01ng@V8=N5=>ZAlZZI/ZQD/ZZI/ZQDP03bYPY00G1Q03:V1BiSBWCXBW:
V1@00/ZQ?@?:V2T2^HdD0m>H2P?:V1@03/ZQ?MbZ<m>ZAmbZ<fYE7^g7G<ZH
:KV=5<ZH59iN5<640:Ib578h08eE2P:3>000178h5:IW0;2=<lZQDP;:V2T0
3;24:K1b0<640;1k2[UW0;V45<640;1k2[UW0<640=>H2YEE00;L/e`01=>n
S]bcQ=bcQ=bcQ0;C_Xh04]>ZAmbcG=bcG<ZH5;24:K2=7[1k59ib2X=N57]<
53dB2THV2TH_2R<L2R`B014L2PT92Q4L2P892@X01A4L2PT92QXV52<_7QXV
50044A`:01<92A@A70X92ABVC031Q02NGQB=E@Z3@@1P;a@S9PXJ2@X94PXJ
2@X94PX92A@0000S70[ohhjEV:<00/77c00;Y/OP`LO<b]3FY/OPkNgZH79k
JW]_`LO</;k1kOKeg>?P067<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2h1<c<c003IVIVooooc<c<01_<c<`2oooh01?noOSoo?oij_oR
bomN@9QH<ie/A;IgD;^7H;fAJl2GLLBIMLfONMjSO^FVP^:YR>>]S>N_S^N_
S^D00Zj>h`05[XkQ/Y;U/I7T/I7T/93S00:_Sn@2[XkS012aTNJaTNBaTNJa
TNBaTNJaTNBaTNJaTNB^S^>^S^6_SnB_Sn:`T>FaTNBaTNJbT^L2/93U01j`
SnJ`T>F`SnJ`T>F`SnJ`T>F`SnJ`T>F`SnJ`T>F`SnJ`T>F`SnJ`T>FbT^Na
TNBaTNJ`T>>_SnB_Sn:^S^>^S^6bT^NbT^FbT^NbT^FbT^NbT^FbT^NbT^D4
/i?V1;>Cj0>_S^D05Zj=i:j=iZf<iJf<iJZ<hZ27fYn6ej20di]gciY^cIIV
c8eHbX=<`ga6`68bXU/fTmo4oo_`ooonoo[ok?_oj_kon0C<c<`300000lc<
c0<0000Ic<c<0P0000G<c<`20000]lc<c005WW8DWW8cNd`DNd`:WW8D00:=
E@X01iEE08=k<iEE59ib2Yj=:IEE59EE0002SED:00NEE@23GQBEE@2EE@2E
EAB=E@ZNLPX00YEE000>JUDNg:Xc/8dcbZ4m^HdcbZY7^Hdc^HdY/7/:YW8D
WW8:WW8D^HdDYW800[1k2P:VLQ@02kV=:K24:KV=<kV=<k2=7[1k2[V=<k2=
7[24:KV=5;1b0002^HdD0X=N500<bZYVg;=LbZYVbZY7bZYVbZ5BbZ4mbZY7
bYPDbYPY^Hdc`H@00[V=5003^H@D^HdD^H@D00:`Q2T02;V=:LZQ?LZQ?LZH
:KV=5<ZH5<640<ZH50:`SAh02<640;24:LZH5;V=:KV45;V=5<ZH5;1k50:i
Q1@04/640;V=<lZQ?KV45<ZZAkV=<k2=<jIb060_59iN59EE5;1k2/ZQ?NBn
Q<ZZI]>nS]bcQ=c7X`;C_Xh01>BnQ8=k<lZZAlZZA`;:XE82bZ4m0/ZH:@:i
Q1@00lZH5;V=:LZH:@02bYPY00NiSBW:V2W:V2W:V1C1Q03:V1BiSC<00/ZH
500?bYPYbYPDbYPYbYPDbZ4mdj4YNd`:djY7bYPY`H@0^Hdc/780^FL0^H@D
PcP0009b>1@01G]<58=109EE0;1k:LZQDP02bZ4m00>`SAk1Q02iQ1@00[V4
5004/7/D/7/:/7/:/7/:0[UW0003YW80dkj>i;j400;L/h@03mbcG>g@V=bc
G=>nS]bcG<ZZI]bcG<ZZI/ZH5;2=7ZIb59iN59ib59EE52<V2P02ARl:00`A
70XS70XA70X92@XA70X92@XA70X92@X94PX92AA6@AhJ9Q@24A`:01LJ4Q@0
00094PXJ4Q@0002EC2W1Q02VLQBEEAB3@@16;`Xm70XS70XA70XJ4Q@92@XJ
4Q@94PX92@[:ZVJVZZ?1alb`_/400/77c0;:d=H01McSh8>H[G9WD[2n`L77
`@02g>?PHLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4
c<c<00=VIVKoooo<c<`06lc<c00Co_ojo_gioO[eoogooo;oiM;oJTjKDS2A
GSRUJT>`Ne>fQf2mSfS1UFk7VgKFWg_KWG_IX8;LYXSP00:YRn400jR;gjR;
gJR;g@02[8oO00B[S]jZSMfYS=jYS=h2Z8_O2:Z=g`:XRmd2ZHcN00BZSMn[
S^2/Sn6/Sn4@ZXgQ0Zb?h@04ZhkPZXgOZHcNZHcN0ZR;g@R[S^02[8oO1:b?
h@:/Sn<2ZhkR00>ZS>:YRn6XR^000ZJ8gP0BYHSJVH7;VX3:V7S;Tfk;TVG<
SE_:Q4g5NT:mIc:XEbR@K4VKk]KoooWoo?goloo[nOo_o_oji/c<c009WW/c
WW8DPehDNd`DWW8DUEDDPehDNd`:SED:00:3GQ@01Iib59ib2XeE2XeE2W]<
5003Pd4001F=E@Z3@@2=E@ZEE@2=E@ZEE@23GQC:XE:`SC?:XE:`SAjiSC>`
SAj`Q2V`SAjVLP2=E@ZVLQB`N`ZVI`2VLP000[1k2P0@YW8D^Hdc/7/D/8@Y
/8dc/7/:/8dN/8@Y/8dN^HdY^H@D/8dN/780/7/DYW80Nd`D0]bcG005bZ5B
g;=LbZYVbZYVbZY700;:XCd00kV=5<ZQ?K2=7P03^HdD00JiSBViSAB`SAji
SC>`SAkCZTL2^Hdc0171Q02iSAC:V1C1Q03:V1BiSABiQ1BiSC>iSBW:V2Vi
SBW:V1BiSC?1Q02`SAjiSAB`Na@00[V=:@0:^H@Y^HdYbZ4mbYPDWUhDARHD
H44YYW8D^IQLbZYV0]>nSP;L/h@01Mc7Xm>nS^g@V>g@V8=k<`03bZ5B00?C
ZTO:ZTO:XCd00/ZH:@0;bYPD^HdD^G8cbYPD^HdYbYPYbZ4mbYPY/8dNbYPY
/8dN00:iQ1@01LZH5<ZH:L640<ZH:LZH5002bZ4m00GLZS?:V2V3GQC:XCfi
SC<00[V4500D/780/7/:^FL0/7/:YVL0YW8DPcP0WUhDUEDD/7/YbZ4mbYPY
^HdD/7/D^FL0^H@D/7/DYW8D/7/:^H@D1;1k2P03YVL0bZYVg;>400?L/h@0
4M>nS]bcQ<ZZI]bcG=>ZAm>nS/ZZAlZQ?KV=:HeE2VYE7YEE58=N54HV53dL
2V0_2Q4L2P026PT:01<A70X92@X92@X92@XA9Q@94PX92A@dEBTS70XA9PX9
2A@94PXJ4Q@A70X92A@94PZ3;`2`N`ZVLQ@00XeE2P0;H2l:?A`:8a`:4A`:
2@T:4A`:2@TD6Q8D0000/8dcPhAk00:V/l402L77`L77c<[@eZK7h=cSh9FQ
]f1N<jJZ[K2n`@02g>?PHLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;P4c<c<00=VIVKoooo<c<`06lc<c00HookooO_nookknoGeoo_o
ooKoRW2_DC66FSFLF3:OJdB^QV35RV?0YGkG[XOP[H_Q[i;T/9GV/iSW/YOT
/IKS/IOQ]9[S]igT0[FKhP04]9[Q/iWP/YSQ/YSQ0[6Gh@RcW>@2[iSP0[2I
h@07/I[R/Y_S/icT/icT/i_U/Y[T/9SR00:_Un400k2Hh[:Ji;>Ki@02/i_U
00BbV^BaVN>`V>:`V>82[iOQ0[>Li004/Y_S/I[R/9WQ/9WQ0ZnHh0RcW>@2
]I_R1;FKi0:eVnD01;BJi;NMikJKj;:Gi0:_U>404jjCh:^AfZV@dKJMgjB4
eiagej9chgQ5_WY4`5lYXE<RSEX_R8EWYoobooojooOhn_Won?3kkOkon`3V
c<c<0Yib5003PehDSED:UEDD00:3GQ@00g]<58=N578h5002UEDD00B3GQBE
EAB3>01b>002Nd`:00=b>1B3@@1kC0X00YEE0004UEDDUED0H44Dg:Xc0/ZQ
?@:iSC<2/8@Y00FVLQB`NbUk@@2`SAjVLQ@00Yib2P0=/7/DYW8D/8dN^HdY
WXdc^HdcbZ4mWW8DYW8D^HdYbYPY^H@D^H@Y00:iSA@02K1k59ib2VYE7]bc
G<ZQD]bcG<ZZAkVZKlZQDP03bZ4m016iSBW:XCf`SAk:V1BiSAB`LP2`SAj`
N`Z`SAj`N`ZiSBV`SAjiSBW:V1B`NaBiQ1B`N`X00[V=5008/7/:^HdD^HdY
bYPY^HdY^HdD^HdcbYPD0[V4500<^H@Y/7/:bYPD^HdY/8dNbZ4m^HdY/8dN
YVL0LSPDNd`:/7/Y1=bcQ0;C_Xh01]c7Xng@V=c7Xng@V9j=<lZZA`C:ZVH0
2<ZQ?M>Q:LZQ?K2=7/ZH5;Ub<k2=7]>Q:@;:V2T0<;1k5<ZH:LZH:K2=7[V4
5<ZH5;V=:KV=5=>Q:LZH5;V=<lZH:LZH5<ZZAm>ZAg]10=>ZAkV4:KV45;V=
<k1k5<640;V45;1k2[V45<ZH5;V=<k24:IEE5<ZH5<ZQ?K2=7[V45;1k2[V4
5;1k2Yib59iN59ib2/640;1k2[1b0:IW0;1k2ZIW0;VZKnBnQ=c7X`;C_Xh2
g;>400cC_XkCZTO:XE;:XE;CZTO:XCfVLQAkC1A69PYZ@@YkC1AP;`X2ARH:
0R<L2P044A`:2@T:4A`:2A8:0PT92P8J4Q@01B`V52<_7Q4L2QXB50TB2P02
2@TD01lJ4Q@92AAP;aC:V1BVI`2NGQAkC1AZ@@Y69Q@J4Q@J2@XA70X92A@J
4Q@92A@0002ELTN`Q6K1albV/l6Van2`_/7:d=K1alcLhn2EZZe?IdN`/kN`
_/7ChoGLhn00HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;P4c<c<00=VIVKoooo<c<`06lc<c0;oo?l2ookk01GonOcml?o>^>Hi7V==
;8M78X]ZAJmaBk:ROMb]Q]njU>N`T=bmXnZnYn_1Z^k1ZnboZNVoZNO2[>[4
[n[8/nh00/Nbk@03a[7/aJo]aJo]00;4[^h8a[;_0/>_k0;4/>d01lFak/Jb
klJbklNcl<Ncl/JblLB`k`02`jo^00C4/>o6/_77/o;7/o82a[;a00?5/O34
/>o4/>l00/>_kP04ak?`a[;_a[;_aK7^0/B`k@;3[n`8a[;_0/Nbk@C7/Nl2
ak7a01W4[^k6/?36/?73[Nk1Znc2[>g1ZnbnZ>S9/N^cVMZ/Rmc:Y?n3ElYd
@[ec@KYD999L<He78fW>]>?mkoonn?onooobnoKioo_nool0i/c<c003WW/c
WW8DWW8D00:3GQ@099EE58eE2Yib2XeE2X=N59EE59ib59ib2X=N58=106Y1
2W8h07]<2W8V08<h08eE2X=109EE09iN5:I<06115=>ZAkV=<lZQ?KV=:KV=
<k2=7[24:JIb5;2=7XeE2Yib5;1k2YEE0:Ib09ib2P:VLQ@01kV=:K1k5;V=
<kV=<k1k:K2=7[24:@02/8dN00>iQ1B`N`Z`Na@00[1k2P0CH44Dg;=Lg;=L
bZYVg;>4g;=LbZ5BbZY7bZ5B^HdYbYPY/8dNbYPY^HdD/7/D/7/:/7/D^HdD
/7/D00:`Q2T00kVHG<ZH:K2=7P02/7/:0ZIb000>/7/D`H@0/7/:/7/:/8dN
bZ4m/7/DbYPD/8@Y^HdD^H@D^HdD/7/D^Hdc0[V=:@08^HdcbYPD^HdYYW8D
UED0/7/YWW8DbZYV0m>nSP03g;>4dkj>kM2H00;L_Zd05>g@V;VHG<ZQ?LZQ
D/ZZI]>ZAlZQD/ZQ?KV=<lZH:LZH5;V=:KV45<640;V=<kV=:KV=<kUb<l64
0;2=7P>iQ1@00lZH5;V4:LZH5002bYPD01o:V2W:V1CLZS?:V1B3Nc>`SAk:
V2ViSBV`SAjiQ1BiI`31Q02`SAj`N`ZiQ1C:ZTN`NbVEEAC:ZTO:XCg:V2Vi
Q1B`N`ZiI`2VLP2VI`2VLQBNLQBVI`2NLPZ`N`X00[1b0003WW8:/8eBkM2H
00;C_Xh03mbcG=>nS]>nS]bcG=>ZAlZZAlZQD]bZ<k24:JIb58=N52`L514L
2V0_56Y12P02ARl:00D/4P0S70XJ2@XA70X92@X00PTB2P064A`:2@T:6Q`N
;3PY6RHD4BHD0Q4L2P0<6Q8D4A`:4A`:2@TDEa`0`H@0WW8:WUhDPd40LSPD
ARHD;2HD0Q4V50092A8:4A`:2A`D0000UHAB/8dc/;k1Y[?1`LO100;1al`0
2:K7h=cSh:Jc`DINAjJZ[K2c]m?Ie]cSh67<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVooooc<c<01_<c<`06?omookm
oo_jn?oon_kimOoeoOogoh9^XCTOJDDVPd@QQGA@]9iif=B`olJTlLf^l/6Y
iL:_i/FbjLJdj<Bbi<>ahLFchlRgi0?9^>D00lRgi<NeiLNei@02a[CV2<Vg
i`;6]>@2akGU00?8]^K9]nO9]nL00/Vgi`06b;KVakGUa[CTa[CTakGUb;KV
1<Vgi`03b;KVakGUakGU00;6]>@3bKOW00?8]^K7]NG7]ND00/Jdi0S9]nL4
bKSU1<Vgi`0IakGWb[SZb[SZakGWakGYb;KZakGYa;3U_ZGLaZSXaJ?g]i7d
X7KVL4>hDRJGAA]m@1iXSG:Uoo;ooo_omO?hn?[inooon?kno_oo0>K<c<`0
0jJ4DYik<iik<`02WW8D00bEEAB=E@Z3GQBEE@2=E@ZNLPZEEABNLQB3@@1b
>01kC0YG7002H2l:00=G701kC0Z3@@000heE2P04JT4:bZYV^HdYbZ4m0[V=
<`0</8dN/8dc/8dNYW8DSED:YW80WW8:YVL0UED0YW80YW8D/8dN0[24:@:`
SC<01k24:K1k5;24:LZH5;2=7[V45;V=5002/7/:00>NLPYZ@@[L/e`00]bc
G00XbZYVg;=LbZ5B/8dcbZY7bYPD/8dNbYPD/8dN^HdD/780/7/:/7/D/8@Y
YW80/8dN/8dc^HdcbZ4m/8dN^HdD/780/7/:YW80YVL0/7/:/7/DYW8DbYPY
^HdY^H@DbYPY^Hdc^HdD/7/Y^H@D/8dN`H@0^Hdc/8dN0[V=<`06^H@Y/8dN
YVL0^IQL^H@DbZYV0]c7X`;C_Xh00ng@V=c7Xm>nSP02g<NS01VVXFJiSC?:
ZTO:ZVK:ZTO:XCfiSBW:ZTO:V1BiSC?:V2ViQ1B`N`ZiQ2ViQ1B`SAj`N`Zi
Q1B`LP2iQ2V`N`[1Q02iSABiQ1C1Q0000/ZH:@0G^HdY^HdDbZ4mdj4YWW8:
^HdcbZ4m^HdY/8dN^Hdc`H@0/7/:/780UED0/780^HdD/7/Y^H@YbZ5BbYPY
/8dN^H@DYW8000:`N`X03HeE2YEE09iN59ib2ZIW09EE0:Ib0:Ib5:IW0:Ib
5>g@V=bcG=>nSP02g;>400?L/ecC_Xk:XE800/ZQ?@0?^HdY^HdD/7/DEa`0
?A`:6PT:ARl:Ea`0ARH:ARl:8bH:8a`:4A`:6PT:2A8:00<92@X01a4L2PT9
52`V52<L2Q4L2PT951XB50032@TD00<94PXJ2@[:V1@00YiN500ANd`DLSP0
ARl:6Q8D6PT:2@TD6Q8D2@TD6Q8D0000bZ5BYW9B/;k1Y[?1/;>gY[?1`LO<
00?:d=H01DmWG9FHXk2c]m?Ie]cSh01Qc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^0C<c<`00fIVI_ooolc<c00Kc<c<01[ooOoin?oo
o_ofmO3oooSooOgon_ohj?maG9LT2EHj77AQ@9^BKlVbSn>kVNG8Zng1ZN?3
[n;8]>O9]NK8]>G7]>;9]^?;^N?8]N;8]^03akCQ0lJch@0>b;GSb;GRb;GS
b;GRb;GSb;GRb;GSb;GRa[?Qa[?Pa[?QakCQakCRakCQ0lReh`03akCRa[?Q
a[?Q00;6/n401<Ndh/RehlRehlReh`?7]>83a[?Q00o8]N?8]N;7]>;7]>77
]>;6/n36/n76/n38]N?8]N;8]N?8]N;8]N?8]N;8]N<01lRehP?8]N<06<Zg
iLZfilNci<Nci<RdiLJbiL>/h<f_jkVHgM6^okF@l8aUce4ZU48MOC4@HF]B
Roodoooeooojo?onoocnoO[moocoookoonK<c<`01;2=<iik<k2=<iik<`:N
LQ@01H=N59ib2YEE08=N58=k<`02WW8D01R=E@Yk@@1P;`YP@BU69PYG701P
;aAb>023@@2=E@ZNLPZVLP16;`[:XE:`SC?:XCfiSC?:XCf`SAj`SC>`SAj`
SC=P@ABNLPX2SED:00NEE@2NLPZNLPZ`Q2V`SAj`NaBiSBT00[24:@0<WW8D
^H@Y^HdY^HdY/8dN^HdD/7/:^HdD/7/:JT4:g;>4bZY70/ZZIP0;g;=LbZ5B
bZY7bZ4m^HdYbYPD^Hdc/8dN/7/D/7/:WW8:00:iSA@02[1k2ZIb5;24:K2=
<kV=<kV=:K1k2ZIb09iN5:IW00>NLPX05[1k5<ZQ?LZQ?KV=5<ZH:K2=7[V=
5;V45;2=7[1k5;2=7[V=5;24:LZZAlZQD[V4:KV=:Iib2/ZQD]>nS/ZZI]>n
SP;]d9P2dkj>013]d9S:_Zg]d9S]d9S:ZVJ`SE;:ZTO:XE:iSC?:XCg:V1B`
SAk:V2W:V1C:V2ViQ2T2^H@D00>iSABiQ1BNLPX00[V45003/7/D/7/:`H@0
00:iQ1@04LZH5;2=7/ZH5<ZH5<640<ZH:M>Q:Iib5;V=<kV=:LZH5<ZH:KV=
:KV4:LZH5;1k2YiN5002/78000JiQ1B`SAk:V2W:V2ViQ2V`N`X3WW8:012E
EABVC02NGQBVI`2NGQB=E@ZVC02NLPZVLP2VLQC]d9SL/hC:ZVKL/hC:ZVKL
aj<4bZ4m00G1Q02VLQB`N`YP;`XS9PX00THV2P0=H2l:ARH:ARH:8bH:6PT:
8a`:2@T:4A`:2@T:4A`:2@T:6Q8D2A8:008S;ah02AXV50TB2PT950TB2PT9
514L2QX92PT95=>40002YW8D00akC1AP@A@m70X/71@A70XJ4Q@94PXJ4Q@9
2A@0002`SC>NQ6H2/;>g00>V/l6`/kO1al400/77c006b]3FAVMLUJ6>UJ6g
dmWFg>?PHLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVKoooo<c<`06/c<c00KnO[onO[nooooookjooojookkin3XooWo
oo7o?BQP>R1WDSJ3MEJV/I3O]iOR^YcR]igN^j?O`JWUa:cV`jcT`Z_Q`jcP
aJoPa:gQa:kOa:gQ00;3[>03`jcR00k4[N?4[N74[N?4[N74[N?4[N74[N?4
[N73[>;3[>33[>;3[>33[>;4[N43a:gS1/>/hPC4[N<5`jcR00o4[N?4[N74
[N?3[>33[>;3[>33[>;3[>34[N?4[N74[N?4[N74[N?4[N74[N<01lB]h@;4
[N<00l:[hL>/h/:[h`03`:WQ00nlY=jgWMZnWN;3W^^[QMbAKLMN>iMA<8Lb
5V50:6Com?ojk_ooo?oooogbl_000_koo`03nO[nooooc<c<0>G<c<`00jJ4
DYj=<k2=<`02WW/c00B`SAj3GQBEEABEEA@2WW8D01JNLS>NSBUkC1AkC0YP
;aA69PYG70169QAb9P1P;aAP;`Z3@@1kC1BVC016;`[L/ebiSC>iSBViSC>i
SBV`LP2NSBT2YW8D00QP;`Z3@@2EE@2EE@2=E@ZVLP2`SAj`SC<2YW8D01:`
SC>`Q2V`SAj`SAjiSBViSC>`SAjiQ1B`NaBiSAB`LP2`N`YP;`[:ZVKL/ec1
/hk:ZVK:ZTL3bZ5B00G:V2V`SAj`SAjiSAB`SAh00[1k2P:`LP000jIb5;1k
:K24:@02bZY700j`Q2W1Q02`N`ZVLP2NGQBEE@2NLPZ`NaB`SAjiSC?:V2Vi
SBV`SAjiSBT2^H@D00ZiSBV`NaBiSABiSC>iQ1C:XE;:ZTO:XCfiSBV`Na@2
bZ5B013:ZVKC_XkC_XkL/hCC_XkL/hCLaj?C_Xk]d9S:_ZgC_XjiSAC:XCg:
XE:iSC?:XE83bYPY00>iSBV`SAjiQ1@00[V45007/7/:/780/7/:YW8DYW80
/780/7/:00:iQ1@01L640;V=<l640;V=:KV4:@02bYPD017CXBViSABNNc?:
V2W:XCf`SAk:XCfVLQBiQ1B`N`ZVLP2`N`Z`LP2iQ1B`SAjiQ2ViSA@00[1k
2P05YVL0/7/:WUhDWW8:UED000:=E@X02[1k58eE2YiN5:IW09ib2XeE2^g@
V=bcQ=>nS]bcQ0;C_Xh02=bcG<ZQD]bZ<lZZAkV45;1k2ZIW07]<508m70X0
3g8h56Y12R<V2V0_2R<V2R<L2QX92PT92QXB50T92Q4L2PT92Q4L2PT92R<_
7P026Q8D01LA9Q@J4Q@94PX94PX92@X94PX0002`SAjNGQBVLP1kC1Ab>016
9Q@/71@A70X92A@A70XJ4Q@971@92@Xd;aj`SC>VZZ<00[2c]`0:Y[?1Y/OP
Y/OP`LO1g>?PAVMLUJ6>YZZS`LO<g>?PHLc<c004IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P6c<c<00=VIVKoooo<c<`06Lc<c008noglo_oo
o?clooomoOcjooomn_Gioo_o0_ofo`0>Cc]`=QeNDcQoECJ2RVVhXh??XX??
Z8[D/9;L]9KN]IOM]9OJ]ISJ]i[J0kJIf@:fVM/4]YWL3kJIfa6fVM`E]YWK
0kJIg003]i[M]YSN]9KL00:dU]`04jnAfJV9e:Amd:f5fhMQ^6]8W4DVM1`1
AVIAR_ofoooiooomooononc/j_kooOkoong^l?koooooo`3Vc<c<00N`SE:`
Q2VEQ5:VLQB`Q2VNSBVEEA@019ib500<WW8cWW/cPd40Nd`DJT4:Pbl0?A`:
H2l:LSPDLRH0LSP0Nd`D0X=1000@H44Dg;=L/8dc^HdY/8dc/8@Y/8dN/8dc
/7/:WW8DH2l:JUDNSED:UED0SED:/7/:0ZIb5007WW8D/8@Y/8@YWXdc/8dN
YW8D/8dc00:`SAh3^HdD00>`N`Z`SAiZ@@X00]bcG0?:ZVH2bZ5B00[:XCfi
SBViSC>iSC>iSAB`SC>`N`ZVLP2`N`ZVLP02/8dN02:VLP3:XE:iSC?:V1B`
SAj`LP2NLPZ=E@ZNLPZVLQBNSBV`NaBiSC?:V2ViSBW:V1BiSBViSAB`NbV`
SAj`N`ZiSBV`Q2ViSBW:XE;:ZTO:XCf`NaB`SAk:ZVK:ZTO:ZVKC_XkLaj<4
dkj>00K]d9SC_Xk]d9RiZVn`SC>iV5`2bZ4m00C:ZTO:V1BiSC?:V1@2^HdY
00RiQ1B`SAj`LP2VLQB`LP2VI`2VLQBVI`02/7/:026`LP3:V1B`NaC1Q02i
SAC:V2W:V1B`SAk:V2WCZTN`SAjNSBW:V2ViSC>iSBW:V2V`NaC:V1BiQ1B`
N`Z`LP2NLPZ`N`ZVLP2iQ2ViQ1B`LP2NLPZVI`2VLQB=E@ZVLP2EE@000XeE
2P08YT`0UED0SED:WW8:YW8DUEDDdkj>g;>40]>nSP0Cg;=Ldkj>bZY7bZYV
bZ4m^HdY/8dN/7/:YVL0Nd`:?A`:H44DLSPDNd`:?A8:ARH:ARHD4A`:8a`:
008A70X00`0000T92Q4L2P022@T:0R<_7P0@4BHD6PT:2@TD6Q8D2@TD4A`:
6PT:2@TD^FL0WUhDWW8DSED:H2l:ARH:4A`:6PT:0QXB50072@TD2A8:2@TD
AT4NYXABUIRSY[?100>`/kL02<[@e/77c<[@eTmNIXfHSZJQV<[@e]cSh67<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1lc<c003IVIV
ooooc<c<01S<c<`01Ocon?con_SjmokoooWin`02ooko017on_knm_oonOoo
m_mkIIHl8V<n8VeA<HAG=HaeD:elEkB5H;f;Il6<J<2<J;n=JL2?K<000heZ
_P:=JL03SFW148aZ`0><J/42SF_22XaZ`A6<J/06SFW00XeY`@0ASf_3T6c4
Sf_5SV[4Sf_5T6c6RVG2QEjkLdNXFbn>CbMo;PaI?b9TPVjSoo?ooo[oj^Sf
00;nool01_SjmokooOKhmOoooo_knoooonK<c<`01ij=<iik<k2=7Yik<iib
2[24:Iib2P02WW8D02B3GQBNLQBNSBV`Q2V3GQAb>1B3GQAkC1B3;`1P;`Yb
9P1b>1AkC1Ak@@2=E@ZEE@169QCLZS>iQ2ViSBV`Q2V`LP2VLQB`SAjNLQBE
E@1b>1AP;`YkC0ZEE@2NGQBVLP2NNc>`SAjVLQB`NbT2/8@Y00>`SAjVLQBi
Q1@00[2=7P08^HdD/8@Y/7/:/8dNWW8DH44Dg;=LbZ5B0lZZIP04bZ5BbZ4m
/8eBbZ4m0[2=7P0<`H@0/780/780/7/:/780/7/:WW8D/7/:/7/YbZY7^HdY
^Hdc0[1k2P0:WW8:SED:PehDPbl0YW80YW8D^Hdc/8dN^HdD^HdY0[V45007
/7/Y/7/D/7/:/8dc/8dN^HdYbZY700;:XE801[2=7]>H2/ZQD/ZQD/ZZI]c7
X`CC_Xh2g<NS00S]d9SL_ZgC_Xj`SC?:V2W:ZTN`SAk:XCd2^HdY0/ZH500G
bYPYYW80^Hdc/7/:YVL0WW8DYW80UEDDNd`DYVL0/7/:^FL0/8dN/7/:/8dN
^H@DbYPD/8dN^H@YbYPDbZY7/780WW8c00:iSBT2bYPD00BiQ2V`SAj`SAjV
LQ@2/7/:0Yib2P:`N`X01;1b0:Ib5:IW09EE00:NGQ@00iEE09iN58eE2P02
SED:01>VC02NGQBVI`23@@3T_XC:ZVKC_XkL/hC:ZVKC_Xk:ZTO:XE;:XCg:
V2V`SAj`NaBNLPZEE@1P;`X00W]<500:JT4:8bH:ARH:8bH:4A`:6PT:2@TD
4A`:2@T:4A`:0PT92P0B2A8:;2HD;2HD6RHD2@TD6Q8D2@T:4A`:2@TD4A`:
0000/7/:YVL0/7/DPd40H2l:ARHD6Q8D0Q4L2P0:2A8:6Q8D6Q8D2@TD;1`D
bZ5BUHAkY/OPUJZ]/;>g0ZJc`@07`LO<dn?eJW]_PhB>UIRS`LO<g>?P067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h2<c<c003IVIV
ooooc<c<01O<c<`06?Snl?_omokooOSinoonoo[io_kloOoooOomooojoooh
ooocooo`on_?of];X4<PO2h8KCP?Md8IOdPPPdXRQD/SQ4`TQ4dUQ@9=9X<0
1ddUQDhVQThVQdhVQdhVRDhVQd`WQ`0<C2N60d/VQ@9;9XH4C2N71D/VQPE<
9hL3BbJ53D`WQPA>9XH4CRJ701U<98M=9HQ<98M<98M?9Xa@9he;8XQ46X0o
47Y04WE^AYodd_oolOool_oon?okn?ono_ognokgnoclooo_lNknoogooogh
n?Koool0i/c<c0FNNc<039j=<iEE57]108=N59ib59EE59ik<iib59iN560_
2YEE57]<2P=69PX2ARHD00MG701b>1B3@@16;`[:ZVJ`SAjiSBT00[2=7P03
WW8:/8dN/7/:009kC1@06DH_2VY12W]<58eE2Yib5:Ib5;2=7[24:K1k59j=
<k24:Iib2ZIb5;V45;V=:KV=5;1k2[24:KV=5;1k2[V=56115<ZZAlZZI]bc
G002bZYV0lZZA`0MbZ4m^Hdc^Hdc^HdD/8@Y/7/DWW8:/7/:YW80/7/:WW8D
YW8DbZ5BbYPY/8dN^H@D/780/7/:Nd`DARHDLSPDWUhD/7/D/8dNbYPY^HdD
^HdY/8dN/7/:00:`SAh01Yib5;1k5;V=:K2=7/ZQD[VZK`;:XCd01;2=7/ZQ
D/ZH:KVZK`;C_Xh02ng@V=>nS]>nS]c7Xm>nS]c7XlZn[M>nSYj=:LZZAkVH
G002bZ4m00W:V2ViSBViSBW:XCg:V2V`NaBiSAB`N`ZVI`000YiN50:3;`00
1JIb0;1k5;1k5;V45;2=7P03^H@D00JiSAB`SAk:V2W:XCg:V2V3GQ@2^HdY
00o:XCfiSC?:V2V`SAjiSC>`LP2iQ1BVLP2`N`ZNLPZ`NaB`NbV`N`ZNLPZE
E@000YiN50>EE@002:I<09EE09iN59EE08eE2Yib2YEE0>g@V0?:ZVH01lZQ
?LZZI]>ZAlZZI[V=<lZH:K2=7P02/7/:00JNLQB=E@Z3GQAkC1AkC0X/71@2
ARH:00TJ2@XS70XJ4Q@92@XA70X94PX92@XA70XJ2@X00QXV50056Q8D4A`:
2@T:2@T:4A`:00<92A@01[1E09ib2ZIb57]<578h04HV508J4Q@02PT92QXB
514L2PTL50T952`B0:J4DYEbAl[@eYFZ[@:`/kL2`LO<00K:d=IbSHB3SHB=
V8k1alcLhn1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0
^0W<c<`00fIVI_ooooooo`3ooooo3ooooeo<c<`019j=<k24:Ij=:Iik<`:N
LQ@2UEDD01=kC1BEEABNLQBNSBV`NbV3GQAZEAikC1@/71@m70Y69Q@m70Y6
9Q@m70Y69Q@m70Yb>016@AkLZS<00[24:@03/8dc/8dNWW8D00:VLQ@047]<
5611:A4V578h58<_08eE2Yib2Yib5:Ib59ib59j=<k2=<k2=7YEE5;1k:K2=
<`>iSBT02KV=5;1b0;1k2[1k2ULL0=>ZAmbcG<ZZAl6cSP02bZYV00_:XCg:
XE:iSC>iSBW:XCfiSAB`SAj`N`ZVLQB`N`ZVLQ@00Yib500F/8@Y^HdcbZ4m
/8dN^H@D/7/D/780YW80?A`:AT4NNd`DWW8:^H@Y^HdY/7/D/8dN^HdD^H@D
/8dN/7/DYW8D/7/D0[V=:@0:bZYVbZ5BbZ5BbYPY^H@DbZ5B^HdcbZYVg;>S
dkj>0]bcQ0;C_Xh05Ng@V=>nS^g@V=c7Xiik<lZQ?LZQD/ZZAkVHG;V=<lZH
5;V=:LZH:KV=5;V=<kV45;1k59ib2ZIW0:Ib5;V45002WW8:01Z`N`ZVLQB`
LP2`NaB`N`[1Q02`SAk:V2V`SAk:V1C:ZTO:V1B3GQC:ZTNiQ1BiSC?:V1C:
XE:iSBW:V2V`NaB`N`Z`LP2`N`ZEEAB`SAh2/7/:00>VLP2NLPZEEA@00XeE
2P04Pd40WUhDUED0/5D00XeE2P07UED0YW80UED0g;>4bZ5Bg;=LbZY700;:
ZVH03<ZZAlZZI/ZZAkV=<kV=:KV=5;1k59ib58eE2W]<2W]<56Y12P8m70X0
0b<V2R<L2Q4L2P026Q8D02494PX92@XA70X92@X92A@J71hS;ahA9Q@92A@J
4Q@A70X94PXJ4Q@A70X92@Z=E@Z`E@2EEAB3@@1P;`Y69Q@S70XJ4Q@A70X9
2A@J4Q@92A@J4Q@92ABiSC>3GS>Van2EZZd00[2c]`08Y[?1`LO<b]3FPiR>
LXf4SIR>/;>gg>?PHLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8
`;R8`;P:c<c<ofIVIQ1VIVH00oooolc<c<c<c01Mc<c<0iik<`0AWW8cUED0
PehDPehDSED:PehDUEDDWXdY/7/YWW/cUEDDNd`:LSPD;1`D;2HD;1`D6RHD
008/9Q@072`L54HV53dL2S@_7[V=<k2=<k24:K2=7ZIb5;1k2Yib2W]<578h
514L2R`V578h57]<59iN59ib2[1k2[2=7[1k:JIb5;2=<k24:K1k:K2=7[24
:@:iSBT02K2=7[1k5;2=<k1b0;1k54HV2]bcG<ZZI/ZQDP03bZYV00G:XE;:
XCg:ZTNiSC?:XCd00[V=:@07/8dN/7/D/780/8@YYW8D/8@Y/8dc00>iSC<0
2;2=7[V45;1k5;V458eE2V11:IEE59ib2P:iSBT03KV45;V=:KV=<kV=:KV=
5;1k5;1k2[2=7[V4:KV=<kVHG<ZZAlZQ?@02/8dN00?:XE;:XCg:ZVH01M>n
SP03g<NSdkj>g<NS00;C_Xh00iik<lZZI/ZZIP02bZY700k:XCf`SAk:V2V`
SAjiSBViQ2V`SAjiSC>VLP2VLQBNGQB=E@ZEEAB3@@02YW8D00>NLPZNGQB`
N`X00[V4500G`H@0/8dN^HdDbYPYg:XcH2l:bZ4m^HdYbZ4m/8dNbZ5B/8dN
bYPY/7/D^H@D/7/D/7/:UEDD/7/:^HdY/7/D/7/:WW8:00:NGQ@00jIW09EE
09EE0003SED:0YEE0003WUhDUED0djY700;:ZVH00lZQD/ZZI/ZZIP02bZYV
01W:ZTO:XCg:XCf`SAj`N`ZVLQBNLPYkC1B3GQAP@A@m70X/9QA69Q@A70XJ
2@X92A@A70X92A@J4Q@A70X92A@J4Q@A70XS;ahA70X00QXB500<2@T:2@TD
2@TD2A8:2@TDH2l:WUhDSED:Nd`:H2l:ARHD8bH:0QXB500<4A`:2@TD6Q8D
6Q8D0000bZY7JUDNY/OPYZZSUJZ]/;>gY[?10/77c005PiR]JW9LSIR>/;>g
g>?P067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<
c1[<c<`00oooolc<c<c<c03oc<c<]lc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;Soc<c<6/c<c?oooonjoooo00AVIVJ8`;R8`;Q8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^=R8`;P1B9280@00000000B8`;S8
h=R8`;R8`;PF00201001P0<00X0400>11004P@801H400`05PP06PP06PP02
00J20P07PP030@N20@R20@R2008128<40@V30`4:P`040@^30@^40@^40@^4
104<Q0<13H@40@j50`8?Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8D
Q`@25HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<3
78X40af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`0
0`@TS@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5
:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<943
1S6A0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7
=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF
23jF23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P0
0PU4V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/4
2TfK0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;
Did22eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ03
35^P0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R
0PeRXP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD3
3VZU10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`
Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX3
47RZ111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@
Ojd00a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^
4HB_4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@B
Rk424Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@
/`@CTK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<D
VKH359Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@E
X;PEX;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`04
5ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm
5jjn5jjn00@G[kh45k2n0aNa_`@G/[l35k>o=QRd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P4002000>KYo4c@jDc@jD02C=3Y@H0080400600`02
P0@00h4400B10P05P@0300F200J200J200801X8200N200<11h8128812880
0P48P`@12H<30@Z300@12h<12h@12h@12h@40@b40`4=Q0@13XD30Pn5108@
Q@@24HH30Q:60`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@3
68P010<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/4
7h/47h/4122;0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=
00<59hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]
T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i80
0PHcTP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0Lh
U0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88
@9L3246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI
00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`0
0PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh0
10]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<
GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=
IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]
Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT4
3gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k
[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d0
1161[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<B
Qk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P02
4Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]004
4iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`02
59^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i
11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[
_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o
11Nb_`<G/klf6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<00800
1i^WlOooohij]ZJKa;>YdZRMb;>YdP02YY_400Fl^=g^k_CZjO7ooolc@jD0
1@00P0@00H0300:01003P@@0184200F100<01H801X801X800P06PP801h80
0`47PP48PP48PP020@R31049P`<12X<0104;P`4;Q04;Q04;Q0@138@30@f4
104>Q@<23hD40Q25108AQP<24XH30Q>600@24hL258L258L258L40QF70P8F
Q`835XP30aN810<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<4
7XX010@NR`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<00<498d49Hd4
9Hd00PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?
10D[S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y40
0`HbTPHcTPHcTP021S>B00<6=987=987=9800PLeTP87=I<31cJC10LgT`04
1cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPn
UP@8?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH
00<9AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/0
0`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;
E9h42eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:00
10aLX@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S
0`eSX`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH4
3VbV0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?
LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/3
47Z[0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdA
P:dAP:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64
[`<AQJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@03
4Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B
]0@CTk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P03
59Zg59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i
5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY
_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P04
5jnn11N`_P<G/Kl45k:o0aNc_`8H]<0P00000QRd`10000026;C00XS0^058
T8P10000000018S0^<SPf8S0^8S0^080080019^WlOooofaJYJnUbP:l^=d0
2_omok>Yd_oooooookbhgIN:_:RMb>KVk?oooc=3Y@@0080400600`02P0@0
0h4400B10P05P@0300F200J200J200801X8200N200<11h81288128800P48
P`@12H<30@Z300@12h<12h@12h@12h@40@b40`4=Q0@13XD30Pn5108@Q@@2
4HH30Q:60`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P0
10<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/4
7h/4122;0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<5
9hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6
;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHc
TP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7
>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3
246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9
AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?
W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]G
WP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ44
35jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=
IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^
Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY
0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l
[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161
[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk04
4XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb
0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd
4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g
0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS
^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08F
Zkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb
_`<G/kl26;C000?8h=Q8T8Q8T8P034R@R0030000b>3HB92800e8T8P01000
01Rd`1Rd`<SPf0i8T8P00`0001Rd`1Rd`002R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0P00P00;VjOaooooZ9g8oooo/jWBH4bJSWZfN6F^Z9g8oooo
oogo00?oool00c=3Y@00P000P00300201001P0<00X0400>11004P@801H40
0`05PP06PP06PP0200J20P07PP030@N20@R20@R2008128<40@V30`4:P`04
0@^30@^40@^40@^4104<Q0<13H@0104>QOooooooooooo`<23hD40Q25108A
QP<24XH30Q>600@24hL258L258L258L40QF70P8FQ`835XP30aN810<HR004
0aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX010@NR`@OR`@OR`@O
R`@488/3126;10@RS0@48h`212B<00<498d49Hd49Hd00PDUS@@59Xd00`DW
S@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^
T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHcTPHcTP021S>B
00<6=987=987=9800PLeTP87=I<31cJC10LgT`041cRC1cRD1cRD1cRD0`Li
U0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8
@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9AYT9AYT010U7
V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL
0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN0`]FWP042eNN
2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<
GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=I:<00`eUX`eU
Y0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW
3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?M:T3
3gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/
47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d00Q60[@044H6]
4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<AQJl44HJ_0a:7/0@B
R;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb008BSK82
4Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@34iBd00@CUK@C
UKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g59^g008DVkL3
59bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j
0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[
_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`_P<G/Kl45k:o
0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P03HS0^005B928
00006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2002000jKYo7ooooooooKg>aPC9ZCQKZcZM:l^=eP
C9ZISkjVVlC8`moooolc@jD600200oooo`03006000:000:000Coool01@03
P@04P@04POooo`04P@0200F100<01H;oooooool00_ooo`801h84oooo00D1
28<12H<12H?oool12H<00P4:P`07oooo0@^30@^40@^4oooo0@b4oooo0081
38@0104=Q?ooo`4=Q?ooo`<13XD00oooo`8?Q@8?Q@040Q25108AQP<24XH3
0Q>600@24hL258L258L258L40QF70P8FQ`835XP30aN810<HR0040aV80aV9
0aV90aV90`<JR@@36hT30ab:10<MRP<47XX010@NR`@OR`@OR`@OR`@488/3
126;10@RS0@48h`212B<00<498d49Hd49Hd00PDUS@@59Xd00`DWS@DWSPDW
SP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i00
0`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHcTPHcTP021S>B00<6=987
=987=9800PLeTP87=I<31cJC10LgT`041cRC1cRD1cRD1cRD0`LiU0@7>Y@4
1c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8@IL424:G
0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9AYT9AYT010U7V@@9B9T3
2DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:
DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN0`]FWP042eNN2eNO2eNO
2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ
0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=I:<00`eUX`eUY0eUY004
3FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW3VjW008>
KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?M:T33gFY00@?
MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/47b/008@
O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d00Q60[@044H6]4H6^4H6^
4H6^0a62[P@APjh01164[Q64[a64[a64[`<AQJl44HJ_0a:7/0@BR;034XV`
00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>
/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@34iBd00@CUK@CUKDCUKDC
UKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g59^g008DVkL359bg0QBM
]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@F
YKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm
5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`_P<G/Kl45k:o0aNc_`8H
]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P00038h=P00XS0^0T00002
R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0<008003Y^WlOoookbhgIV?__ooomKA
gM_Lk??nojJKa>k^m8Ef/9>5^_oooc=3Y@@008002?ooo`01P001P001P?oo
o`02P?ooo`02P0800h401_ooo`03P@04P@04POooo`04P@801H402?ooo`06
PP06PP06P_ooo`07P_ooo`47PP8128801P48Poooo`49P`49Poooo`49P`81
2X<01oooo`4;P`4;Q04;Q?ooo`4<Q?ooo`020@b400<13HCoool13H@01?oo
o`<23hD40Q25108AQP<24XH30Q>600@24hL258L258L258L40QF70P8FQ`83
5XP30aN810<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX0
10@NR`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<00<498d49Hd49Hd0
0PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[
S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`Hb
TPHcTPHcTP021S>B00<6=987=987=9800PLeTP87=I<31cJC10LgT`041cRC
1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8
?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9
AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>
W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h4
2eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aL
X@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eS
X`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV
0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP2
3g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[
0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dA
P:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<A
QJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb
4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@C
Tk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg
59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i
0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY
_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn
11N`_P<G/Kl45k:o0aNc_`8H]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8
T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R000
00026;C000C8h=R8`;R8`;R8`;P2000018S0^0800002R<2h00A8T8P0000H
]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00?VjOaoooo
VHnnUhZle=?XkjbcogIkkYn[FeRUYY_4UYoBH4bJ_;SMoooo<d>U00<00800
2?ooo`01P001P001P?ooo`02P?ooo`02P0800h401_ooo`03P@04POooo`04
POooo`801H402?ooo`06PP06PP06P_ooo`07P_ooo`47PP8128802P48Pooo
o`49Poooo`49Poooo`4:Poooo`4:Poooo`812h@00oooo`4<Q?ooo`020@b4
00@13HCoool13HCoool30@j50`8?Q@@248D40Q660`8BQP<24hH0108CQ`8D
Q`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ9
10<KR@<378X40af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<10@S
S08498`00`@TS@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>
00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A
0086<9431S6A0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB
0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`Pm
U@0423fF23jF23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9
A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;
VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M
0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]I
W`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<
HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eX
Y@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`
Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmf
ZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/
0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163
[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::
/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<C
Sk<011>@/`@CTK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne
11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P3
5Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk
0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]
_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G/[l35k>o0QRd`003b>3HR<2h
R<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000
R<2hR<2hB9280000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P20000
0hS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^08008002Y^WlOoooiN:_7Y/Z[?7j:U^X<S3gi>5^U]6TiV?_P9hIJh0148W
QJnUb_oooc=3Y@@00803006000?oool00X000X001?ooo`0500>100B1oooo
00B1oooo00801H400`05P_ooooooo`02oooo0P07PP0=0@N20@R20@R20@R3
oooo0@V3oooo0@V3oooo0@Z3oooo0@Z3oooo00812h@00oooo`4<Q?ooo`02
0@b400<13HCoool13H@01?ooo`<23hD40Q25108AQP<24XH30Q>600@24hL2
58L258L258L40QF70P8FQ`835XP30aN810<HR0040aV80aV90aV90aV90`<J
R@@36hT30ab:10<MRP<47XX010@NR`@OR`@OR`@OR`@488/3126;10@RS0@4
8h`212B<00<498d49Hd49Hd00PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DY
SP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`
T@021S2A0`HaT@<6<Y400`HbTPHcTPHcTP021S>B00<6=987=987=9800PLe
TP87=I<31cJC10LgT`041cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8
?ID010PmUPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H
2DBH2DBH0089A9P42DFH00<9AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:
BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYB
W@8;DYd32e>M0P]DW@8;E9h42eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;
FIl435ZP0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82
366R0PeQXP8=HZ823F:S0`eSX`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=
J:D43VVU0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>
L:L?L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?
MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n
[08@OZd247n]00<AOjdAP:dAP:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@A
Pjh01164[Q64[a64[a64[`<AQJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4B
R[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc
4hnc00@CT;<44i6c0a>B]0@CTk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG
]@@DV;H359Vf0aBJ]P0359Zg59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh
0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW
^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G
[Kd00aN^_AN^_QN^_P045jnn11N`_P<G/Kl45k:o0aNc_`8H]<000lSPf8S0
^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@00
08S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00hS0^0@00004R<2h00A8
T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003
VjOaoooooooo00;oool02_n]/?mfNoW=e?g]k_ooojJKa8Ef/;bhgOoooc=3
Y@D00803006000Coool00X000X000X0200>100?oool00h7oool00`04P@03
oooo00F100F200<01X801?ooo`07PP07PP47PP?oool02@48P`49Poooo`49
Poooo`4:Poooo`4:Poooo`020@^400Woool138Coooooool138@13HCoool1
3HCoool00P4>Q@04oooo0Pn50Pn50Pn5108@Q@@24HH30Q:60`8CQP040Q>7
0QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<3
6XT40a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4122;0`@QR`@48X`4
12><0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5
:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946
<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087
=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D3
23fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3
V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX3
2T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:
DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l4
2eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R
0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@3
3FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`03
3W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ
3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@
OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh4
4H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa
4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?
/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<D
UkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN
^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@F
Yk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@04
5jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/kl26;C000?8h=R8
`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D0
0028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00B8`;P200001HS0^004
B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<00800
2Z6/l_W=e>8V??Be_n8V??A]OOcSjOoooog]k_n]/0;oool00c=3Y@00P000
P00400200`01P003oooo00:000:000?oool200>100Ooool018401840187o
ool01H401H800oooo`0400J200N200N2oooo0P48PP8128<01@49Poooo`49
P`49Poooo`020@Z300Ooool12h@12hCoool138Coool138@00_ooo`813H@0
0`4>QOooooooo`02oooo0P8?Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8D
Q`8DQ`@25HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ910<K
R@<378X40af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<10@SS084
98`00`@TS@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5
:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086
<9431S6A0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLe
T`<7=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@04
23fF23jF23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9
A9P00PU4V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:
C9/42TfK0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]B
W@<;Did22eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<
FZ0335^P0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ82
3F6R0PeRXP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>
JJD33VZU10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`
Z0m`Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?
MjX347RZ111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n
[@8@Ojd00a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P04
4HB^4HB_4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::
/@@BRk424Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<0
11>@/`@CTK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH
]P<DVKH359Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh
00@EX;PEX;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX
^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@03
5jjm5jjn5jjn00@G[kh45k2n0aNa_`@G/[l35k>o0QRd`003b>3HR<2hR<2h
00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2h
R<2hB9280000008H]<000lSPf8S0^8S0^003R<2h100000B8`;P014R@R000
01Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000fKYo7m
kNkR9ScnmOSgRIOdHVkcX:kdHVkooOoo[K3lhnWooolc@jD01`00P0<00H00
1?ooo`02P002P002P0@00h4400B10P05P@0300F200J200J200801X800`07
P_ooo`47PP020@R20P48P`@12H<30@Z300@12h<12h@12h@12h@40@b40`4=
Q0@13XD30Pn5108@Q@@24HH30Q:60`8CQP040Q>70QB70QB70QB7108EQ`82
5XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX3
11j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@TS00312B=12F=
12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZ
S`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A
00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<0
10LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8
?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5
V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK
00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d2
2eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP
00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeR
X`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V
10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP3
3g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[
0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]
4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lA
Q:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;40
0a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<C
T[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H0
0aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP
^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`F
ZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h0
11N__P@G/;h35k6o11Nb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B928
0000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P00000
0QRd`003b>3HR<2hR<2h00:8`;P200000XS0^0800003R<2h00A8T8P0000H
]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOam/S<
hRHl00;o[K001mlT;_nTW_JlaOn]/>ikS?oooc=3Y@0800200`01P004oooo
00:000:000:01003P@@0184200F100<01H801X801X800P06PP0300N2oooo
0@N2008128800`48Poooo`49P`030@V30`4:P`040@^30@^40@^40@^4104<
Q0<13H@40@j50`8?Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@2
5HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X4
0af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@T
S@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5
:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A
0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<4
1cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF
23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4
V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK
0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did2
2eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P
0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeR
XP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU
10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z004
3g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ
111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd0
0a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_
4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk42
4Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@C
TK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH3
59Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PE
X;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl
5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn
5jjn00@G[kh45k2n0aNa_`@G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P0
0dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf003R<2h
0P0000B8`;P200000XS0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008000i^WlOW=e?N9U`02oooo00Oo[K3Q5SCoMW_o
Y9kR9ScoRGlc@jD02000P0<00H001?ooo`02P002P002P0@00h4400B10P05
P@0300F200J200J200801X8200N21?ooo`030@R30@V30@V300812H<30@Z3
00@12h<12h@12hCoool40@b40`4=Q0@13XD30Pn5108@Q@@24HH30Q:60`8C
QP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<I
R@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4122;0`@Q
R`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd59hh59hh0
10DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6
;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB
1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10Lk
U@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88
@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9
VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L
0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]G
W`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<
Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eV
Y0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW
10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY
3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/
0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61
[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/004
4XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[80
0a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe
11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL2
5Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj
0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/
_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/kl26;C0
00?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P900000XS0^005B928
00006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2002000NKYo7oooocX:kdHVkoooogRIOicM@00_oo
o`03lj2^oooo<d>U00P0080400600`02P0@00h4400B10P05P@0300F200J2
00J200801X8200N200<11h81288128800P48P`@12H<30@Z300@12h<12h@1
2h@12h@40@b40`4=Q0@13XD30Pn5108@Q@@24HH30Q:60`8CQP040Q>70QB7
0QB70QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT4
0a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><
0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh0
10DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<940
0PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I82
1cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE
00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4
V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J
10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd2
2e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO
10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQ
XP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU
10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W
3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ
10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`2
47j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^
00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa
4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?
/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD4
59Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<E
WkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/3
5ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm
00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00
P00;VjOaooooohUooooolj2^lI>Qoooooogolj2^oo_l<d>U00P008040060
0`02P0@00h4400B10P05P@0300F200J200J200801X8200N200<11h812881
28800P48P`@12H<30@Z300@12h<12h@12h@12h@40@b40`4=Q0@13XD30Pn5
108@Q@@24HH30Q:60`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<G
R0@368P010<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/4
7h/47h/47h/4122;0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd4
1BJ=00<59hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?
10H]T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86
<i800PHcTP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0Lh
U0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0
UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI
2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:
Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;
EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<
GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS
00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH0
0`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?
LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/0
0a1k[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008A
P:d01161[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166
[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=
/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D
]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK
]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT4
5J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl
0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h3
5k6o11Nb_`<G/kl26;C03lSPf0030000b>3Hb>3H00g8h=P00`0001Rd`1Rd
`00?b>3H00<0000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0^8S0
^0@00803VjOa00KoooocX:kd]Kof_<GkfMXc@jD900201001P0<00X0400>1
1004P@801H400`05PP06PP06PP0200J20P07PP030@N20@R20@R2008128<4
0@V30`4:P`040@^30@^40@^40@^4104<Q0<13H@40@j50`8?Q@@248D40Q66
0`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR800@3
6HP36HT36HT36HT30aZ910<KR@<378X40af:0`@NRP0411j;11n;11n;11n;
10@PR`<48H/412:<10@SS08498`00`@TS@@US@@US@021BF=10DVS@031BN=
1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@
0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B0086<i80
0`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD
10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF10PoUP88@9H2242G0`Q1
U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@042DNI
10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:Ci`3
2U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;Eih;
Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ10aN
X@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS3FFT
3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>KZL>
KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?
MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@O:`@
O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@APJdA
PJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`11:8
/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=/P8B
S[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@011>E]1>E
]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK]`<D
W;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@EXkX3
5JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m
00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G/[l3
5k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PF00201001P0<0
0X0400>11004P@801H400`05PP06PP06PP0200J20P07PP030@N20@R20@R2
008128<40@V30`4:P`040@^30@^40@^40@^4104<Q0<13H@40@j50`8?Q@@2
48D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP4
0aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:0`@NRP0411j;11n;
11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@US@@US@021BF=10DV
S@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6
;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B
0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7
>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF10PoUP88@9H2
242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6
V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL
008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN
00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ
35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`03
3FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>
KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y
10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@
Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]
00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl3
4XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<BS;8BSK8BSK80
0Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@0
11>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL0
0QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR
^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08F
Zk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa
_`@G/[l35k>o=QRd`0:8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8
`;SHR<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;SoR<2hf8S0^058T8P1
000000000hS0^<SPf<SPf03ob>3HolSPf=S8h=P1B9280@000000ohS0^?n8
`;SLR<2h0@000000\
\>"], "Graphics",
  ImageSize->{731, 409},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;N0001Z2000`400?l0
0000o`00003oooo`l?3ooo3`l=7ol?3`00?ofMWIooooooooool03?ooool0
0?ool?3`ooo`l?3Aoo3`l004omWIfOooooooooooonGUi@?ooooo00GoiNGU
ooooooooooooooooonGUi@03ooooo`00ooo`l?3ooo3`l=7ol?3`00gofMWI
oooooooJf][oSHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgo
iNGU00;ooooo003ooo3`l?ool?3`dOo`l?003_oIfMWooooooooooooJf][o
SHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU0Oooool0
0?ool?3`ooo`l?3Aoo3`l00=omWIfOoooooooooooooooooJf][oSHf=onGU
iOoooooof][Johf=SOoUiNGoooooom[JfP02ooooo`00ooo`l?3ooo3`l=7o
l?3`00?ofMWIooooooooool00_ooool01ooJf][oSHf=onGUiOoooooof][J
ohf=SOoUiND00oooool00?ool?3`ooo`l?3Aoo3`l003omWIfOoooooooooo
00?ooooo00Oof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003o
oo3`l?ool?3`dOo`l?000ooIfMWoooooooooo`04ooooo`07om[Jf_n=SHgo
iNGUoooooooLg=coSHf=onGUi@01ooooo`00ooo`l?3ooo3`l=7ol?3`00?o
fMWIooooooooool01Oooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo
003ooo3`l?ool?3`dOo`l?000ooIfMWoooooooooo`06ooooo`03omcLg?n=
SHgoiNGU00?ooooo003ooo3`l?ool?3`dOo`l?000ooIfMWoooooooooo`07
ooooo`03omcLg?n=SHgoiNGU00;ooooo003ooo3`l?ool?3`dOo`l?000ooI
fMWoooooooooo`08ooooo`03omcLg?n=SHgoiNGU007ooooo003ooo3`l?oo
l?3`dOo`l?000ooIfMWoooooooooo`09ooooo`7og=cL0Oooool1ooooo`00
ooo`l?3ooo3`l=7ol?3`00?ofMWIooooooooool03?ooool00?ool?3`ooo`
l?3Aoo3`l0oofMWI003ooooooaWooooo1?obl_;oon_[jkkojn_[1?obl_81
ooooo`00ooo^k^hIonk^kP04on7QhOoJf][of][Jom[Jf_ooclo?__o?cll3
om[JfP7ok^k^0OoQhN400?ooi^KV6OoVi^H01?oJf][odm?ColS8b?o8b<So
okNg]kko]kNg0_o8b<P1onKViP7odm?C0OoJf]X00?ook^k^6Oo^k^h01?oQ
hN7of][Jolo?conm_Kgooj2PX;koX:2P00Co_Kfmonk^k_o?cloof][J0OoQ
hN400?oooooo6Oooool01Oobl_;oj^[ZomkNg_o;bl_o>c/k0?ooOgmo_Omo
Ogl01?mhN7Sobl_;omkNg_oZj^X1oo;blP00ooo^k^hIonk^kP0?on7QhOoJ
f][oclo?okfm_OnSXj?o3eJaoc1b`?mGT]GoNk7/oi_>oonhk?ooKVi^okBd
]?oPh>3ok>c/0?ook^k^/oo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00
oooVi^HIonKViP09om[Jf_oCdm?ob<S8okNg]onMWIgo2eBaojC4i_nidnoo
MZgZ00;oZn3o00CoJVYZojj^[_oHf=Soi>CToooVi^I;onKViP03oj2PX?oO
gmooi^KV06Goi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00?ook^k^6Oo^
k^h02OoQhN7of][Jolo?conm_KgoXj>So`]C[_nUa>Ko]M3^ogV^k002ojOL
o`04ofi^K_nd];Coh>3Ponc/k6[ok^k^00?og=cLonc/k?o^k^h00_oShn<>
onk^kP03omcLg?o/k>cok^k^00;ohn?S1Oo^k^h2on7Qh@Wok^k^0_oQhN4J
onk^kP03on?ShooHf=Sok^k^00gok^k^00?ohn?SomSHf?o^k^h06oo^k^h0
0ooZj^[of=SHonk^kP05onk^kP;ohN7Q2Oo^k^h00oo[jn_ogmoOonk^kP05
onk^kP;ohN7Q5Oo^k^h00ooLg=cogmoOonk^kP0<onk^kP03omcLg?o/k>co
k^k^00;ohn?S4Oo^k^h2on7Qh@Gok^k^00?og=cLonc/k?o^k^h00_oShn<;
onk^kP03okRh^?mDE5Cok^k^06Gok^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN400?oooooo6Oooool02Oobl_;oj^[ZomkNg_o;bl_o[jn_o`]D/OnTa>Ko
^=;^ogJ]jP02ojcOo`04ogIfM_o1`L7ol?3`oogmoF7ooooo017o=SHfohV9
ROoooooooooooo?clol_;boo>3PhooKfm_mADE7o20P8oaXJ6_nLW9co4a<C
oeMGEooooooo@410ogmoO`02ooooo`06ogYjN_m3@d?ooooooooooond];Co
2@T90_ooool01_mADE7o20P8oaXJ6_nLW9co4a<CoeMGE`Cooooo00Go9BDU
oa0@4?lP823oCDe=ooKfmP06ooooo`05obDU9Ol@413o820Pode=COofm_H0
0_ooool01_m0@43oOgmoooooooooooooNWYjod=3@`;ooooo00Ko];Bdo`T9
2Ooooooooooood10@?moOgl2ooooo`0:od10@?moOgoooooooooooooWinOo
BTY:o`<30olS8b?o5aLGol71`@Gooooo00?o@410ogmoOoooool00_ooool0
2OoWinOoBTY:o`<30olS8b?o5aLGol71`Ooooooo@410ogmoO`02ooooo`06
ogYjN_m3@d?ooooooooooond];Co2@T90_ooool01_m0@43oOgmooooooooo
oooo@410ogmoO`;ooooo00[oXj>Soa`L7?oooooooooookFe]Ol>3Pko0P82
obd];OnCTi?o4A4A0_ooool01OlU9BGo410@ob0P8?m=CDgom_Kf00Kooooo
00Ko_knooa/K6ol71`OoDU9BohJ6Q_l`<302ooooo`05obDU9Ol@413o820P
ode=COofm_H01_ooool02Olf=SKoYJFUooooooo]kNgoX:2Pon[Zj_oooooo
_knoo`820P02ooooo`06om_Kfole=CGo3Ph>o``<3?li>CWog=cL0_ooool0
1_m0@43oOgmoooooooooooooXj>Soa`L70;ooooo00KoDE5Ao`P82?lJ6Q[o
W9bLoa<C4omGEeL5ooooo`03ocHf=_l0003o000000;o000000Co>SXjoooo
oom0@43oOgmo0_ooool01OlU9BGo410@ob0P8?m=CDgom_Kf00;ooooo00Wo
DE5Ao`P82?lJ6Q[oW9bLoa<C4omGEeOoooooofe]KOmBDU802Oooool00omS
Hf?oQHF5ooooo`1Tooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b003oonk^
kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol=E:koY/KVokK@k_mi[nh0
0_n[g_l01?m^KVko];Bdon3Ph?o/k>aQonk^kP0=oc8b<_moOgook^k^on_[
jom5ADGo8R8Rom_Kfonh^;So0`<3olk>c_oFe]KoE5ADo`l?3`02onk^kP06
oc/k>omfMWKok^k^onk^k_maLG7o?Shn0_o^k^h02OnXZ:So20P8onk^k_nh
^;So0`<3olk>c_oFe]KoE5ADo`l?3`05onk^kP05ok>c/ooZj^[okNg]oc8b
<_n8R8P01_o^k^h01Onc/k?oj^[Zong]kOlb<S;oR8R800;ok^k^00Ko>c/k
ogIfM_o^k^kok^k^og5aLOln?Sh2onk^kP06ojRXZ?l820Sok^k^onk^k_lk
>c_oMWIf0_o^k^h02_lk>c_oMWIfonk^k_o^k^ko?clooc/k>oo@d=3ok^k^
on;Rh_oQhN45onk^kP03oc/k>omfMWKok^k^00;ok^k^00Wo?clooc/k>oo@
d=3ok^k^on;Rh_oQhN7ok^k^oc/k>omfMWH00_o^k^h01_maLG7o?Shnonk^
k_o^k^koZ:RXo`P820;ok^k^00Ko>c/kogIfM_o^k^kok^k^oc/k>omfMWH2
onk^kP0:oiRHV?lJ6Q[ok^k^onk^k_l_;booE5ADomgMgOnl_;co:RXZo`l?
3`;ok^k^00Go/k>con[Zj_o]kNgo<S8bohR8R006onk^kP06odi>C_mCDe?o
i^KVoi>CTol>3Pko;2`/0_o^k^h01Onc/k?oj^[Zong]kOlb<S;oR8R800Ko
k^k^00go<S8boiZJV_o^k^koQ8B4o`000?mlO7cok^k^ok:b/_l10@7ok^k^
ong]kOl`<33oC4a<00;og]kN00KoCdm?oc4a<Oo]kNgok^k^oc/k>omfMWH2
onk^kP09oiRHV?lJ6Q[ok^k^okRh^?l30`?oc/k>omKFe_mDE5Co3`l?00Ko
k^k^00?o<S8bofa/K?o^k^h01?o^k^h04?lk>c_oMWIfonk^k_o^k^ko/k>c
on[Zj_o]kNgo<S8bohR8R?o^k^ko^;Rho`<30oo>c/koe]KFoeADE?l?3`l2
onk^kP03olc<c?o5aLGok^k^00Sok^k^00?oa/K6oa0@4?oXj>P0I?o^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooVi^HIonKViP09om[Jf_oCdm?o
b<S8okNg]onMWIgo2U6^ojC3iOnhd^ooNJk/00;o[=oo00CoJVYZojj^[_oH
f=Soi>CTHOoVi^H03Ol`<33oNg]konKVi_mNGUko4a<ColK6a_oVi^Ko`l?3
o`820_nZZZ[oi^KVohn?SolL71`00_oVi^H01_li>CWoLW9bonKVi_oVi^Ko
KVi^oc`l?0;oi^KV00WoXZ:Ro`P82?oVi^Ko`l?3o`820_nZZZ[oi^KVohn?
SolL71`01ooVi^H00ona/K7o4a<CohB4Q008onKViP03ok6a/OlC4a?oQ8B4
00;oi^KV00Ko>CTiog9bL_oVi^Koi^KVofi^K_ll?3`2onKViP06oj:RX_l8
20Soi^KVonKVi_li>CWoLW9b0_oVi^H01_li>CWoLW9bonKVi_o7alOo0000
ojFUY@Woi^KV00Oo>CTiog9bL_oVi^Koi^KVolO7aol0003oYJFU00Goi^KV
00Ko>CTiog9bL_oVi^Koi^KVofi^K_ll?3`2onKViP06oj:RX_l820Soi^KV
onKVi_li>CWoLW9b0_oVi^H02_li>CWoLW9bonKVi_oVi^KoTi>CoaTI6OoV
i^KodM7Ao`000?na/K42onKViP03oiZJV_l?3`ooi^KV00?oi^KV00?o/K6a
oa<C4on4Q8@01_oVi^H01_lW9bOoPH61onKVi_oVi^KoKVi^ob/[:`Coi^KV
00?o/K6aoa<C4on4Q8@01_oVi^H03Ol`<33oU9BDonKVi_l];Bgo@410ob<S
8ooVi^Ko[:b/o`410OoVi^Ko`/;2o`000?nUYJD00_oVi^H01_nUYJGo0000
olK6a_oVi^Ko>CTiog9bLP;oi^KV00WoTi>CoaTI6OoVi^Ko`l?3o`820_nZ
ZZ[oi^KVohn?SolL71`01_oVi^H00ol`<33oJ6QXonKViP04onKViP03ocTi
>OmbLW;oi^KV00?oi^KV00[o/K6aoa<C4on4Q8Coi^KVol?3`ol20P;oZZZZ
onKVi_n?Shoo71`L3OoVi^H00ooOgmoo0000oj^[Z`1TonKViP04oifMWOng
]kOob<S8om?Cd`7of][J003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfm
oj>SXol=E:koYLCVokKBk_mi[^T00_nZh?l01?m^KVko];Bdon3Ph?o/k>aQ
onk^kP05oc8b<_moOgooPX:2o`T92Onk^k/00oo^k^h01OnQXJ7o;Rh^obl_
;olb<S;o7AdM00;ok^k^00Ko>c/kogIfM_o^k^kok^k^og5aLOln?Sh2onk^
kP09ojRXZ?l820Sok^k^onk^k_nQXJ7o;Rh^obl_;olb<S;o7AdM00Gok^k^
00Goe=CDodE5AOl20P;oJFUYonGUi@06onk^kP05omCDe?m5ADGo0P82ofUY
JOoUiND00_o^k^h01_lk>c_oMWIfonk^k_o^k^koLG5aochn?P;ok^k^00Ko
Z:RXo`P82?o^k^kok^k^oc/k>omfMWH2onk^kP06oc/k>omfMWKok^k^ok6a
/Ol0003o>3Ph0olj>SX00onf][Kok^k^onk^kP03onk^kP07oc/k>omfMWKo
k^k^onk^k_na/K7o0000ocPh>003ocXj>P04okJf]_o^k^ko>c/kogIfMP;o
k^k^00KoLG5aochn?_o^k^kok^k^ojRXZ?l820P2onk^kP06oc/k>omfMWKo
k^k^onk^k_lk>c_oMWIf0_o^k^h01_nHV9So6QXJonk^k_nc/k?o0000omKF
eP;ok^k^00WoX:2Po`l?3oo^k^kok^k^omCDe?m5ADGo0P82ofUYJOoUiND0
1_o^k^h01_lY:BWoRHV9onk^k_o^k^koQHF5ob`/;0;ok^k^00Goe=CDodE5
AOl20P;oJFUYonGUi@06onk^kP0=oc8b<_nJVY[ob<S8o`000?o5aLGo9bLW
okZj^_nb/[;o0@41onk^k_na/K7o0000omKFeP02onk^kP06omCDe?l0003o
];Bdonk^k_lk>c_oMWIf0_o^k^h02OnHV9So6QXJonk^k_o^k^koXJ6Qobh^
;_l_;boo<S8boadM7@06onk^kP03oc8b<_m/K6cok^k^00Cok^k^00Wo>c/k
ogIfM_o^k^kok^k^omCDe?m5ADGo0P82ofUYJOoUiND00_o^k^h01OnQXJ7o
;Rh^obl_;olb<S;o7AdM00Gok^k^00?ohn?SodA4A?m4A4@00om4A4@01OoL
g=cok^k^onk^k_lJ6Q[oTi>C06Cok^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN400?oooooo6Oooool02Oobl_;oj^[ZomkNg_o;bl_o[jn_o`]C[_nVa^Ko
^M?^ogV^j`02oj_Oo`04ogIfM_o1`L7ol?3`oogmoF7ooooo00Co=SHfod=3
@ol30`?o/k>c1_ooool00oomoOgoU9BDob4Q8@02ooooo`0:od10@?m]KFgo
oooooooooomiNGWo<c<cookno_oooooo/k>co`T92@Cooooo00?ooOgmoiBD
U?lQ8B401Oooool00om1@D7o@T92om_Kf`08ooooo`03od51@Om2@T;ofm_K
00Cooooo00[o@410ofe]KOooooooooooogUiNOlc<c?oo_knoooooonc/k?o
2@T90_ooool03_m0@43oOgmooooooooooooo@410ogmoOooooooofm_Ko`00
0?n[Zj_oclo?olO7aol30`?oiNGU1Oooool03_m0@43oJFUYoooooooooooo
fm_Ko`000?n[Zj_oclo?olO7aol30`?oiNGUoooooom0@43oKFe]0_ooool0
1_miNGWo<c<cookno_oooooo/k>co`T92@;ooooo00Ko@410ogmoOooooooo
oooood10@?mMGEd2ooooo`06oifMWOlM7Agoooooon3Ph?l0003o/[:b0_oo
ool01on/[:co4A4Aoooooooooooo@D51od92@_oKfm/02?ooool01_l/;2co
Ti>CooooooooooooShn?oc0`<0;ooooo00?o@D51od92@_oKfm/02?ooool0
3Olf=SKoYJFUogalO?l`<33oooooohV9ROmYJFWo_knoo`820_oooooog=cL
o`000?nd];@00_ooool01_nb/[;o0000on3Ph?oooooo@410oeeMG@;ooooo
00?oWIfMoadM7Oooool00oooool00oomoOgoU9BDob4Q8@06ooooo`03ocHf
=_mdM7Cooooo00Cooooo00Oo@410ogmoOooooooooooood51@Om2@T;ofm_K
00Kooooo00?ooOgmoiBDU?lQ8B401Oooool00oolo?coaLG5olG5a@03olG5
a@05ooWinOooooooooooob4Q8OnJVYX0I?ooool01?n_[joobl_;omkNg_oZ
j^X1oo;blP00ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o3eJ_
oj?2i?nhdnooMjk[00;oZ]oo00CoKVi^okBd]?oPh>3ok>c/HOo^k^h01?lb
<S;oKVi^oalO7on=SHd4onk^kP05ojRXZ?o;bl_ojn_[oeYJF_m>CTh00_o^
k^h02_lk>c_o4a<Coh:2P_oHf=So>SXjoa`L7?mIFEWod];BofUYJOl_;bl2
onk^kP05ojRXZ?o;bl_ojn_[oeYJF_m>CTh01Oo^k^h01Olc<c?oS8b<onk^
k_oHf=SojNWY00Kok^k^00Go<c<cohb<S?o^k^kof=SHonWYj@02onk^kP0:
oc/k>olC4a?oPX:2omSHf?lj>S[o71`LoeUIFOoBd];oJFUYobl_;`;ok^k^
00Ko>c/kogIfM_o^k^kok^k^oc/k>omfMWH2onk^kP05ocXj>_mSHf?oi^KV
oi>CTolX:2P01_o^k^h02_lk>c_o4A4AohN7QooDe=Cok>c/ocXj>_mSHf?o
i^KVoi>CTolX:2P2onk^kP0:oc/k>olC4a?oPX:2omSHf?lj>S[o71`LoeUI
FOoBd];oJFUYobl_;`;ok^k^00[o>c/kogIfM_o^k^kok^k^oc/k>olB4Q;o
KVi^olo?comADE7oAdM70_o^k^h01_ln?Sko@D51om?CdooKfm_oC4a<o`l?
3`;ok^k^00Go<c<cohb<S?o^k^kof=SHonWYj@06onk^kP06obTY:On9RHWo
k^k^onk^k_n5QHGo;2`/0_o^k^h01Olc<c?oS8b<onk^k_oHf=SojNWY00Ko
k^k^00Wo<S8boiVIVOlM7AgoPH61onk^k_oDe=Co4Q8Boj^[Zol10@400_o^
k^h01_ll?3co@d=3olo?coo>c/ko@T92oclo?`;ok^k^00Ko>c/koa8B4_m^
KVkoclo?oe5ADOm7AdL2onk^kP05ojRXZ?o;bl_ojn_[oeYJF_m>CTh01_o^
k^h00olb<S;oK6a/onk^kP04onk^kP09oc/k>omfMWKok^k^onk^k_lc<c?o
S8b<onk^k_oHf=SojNWY00;ok^k^00GoZ:RXol_;boo[jn_oFUYJodi>CP02
onk^kP03okbl_?nc/k?ok^k^00Sok^k^00?oj^[Zo`820_n[Zj/0I?o^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooVi^HIonKViP09om[Jf_oCdm?o
b<S8okNg]onMWIgo3eF_ojG4i_nidnooMjk[00;oZMco00CoJVYZojj^[_oH
f=Soi>CTHOoVi^H01Ol`<33oNg]kokno_ol@413o[Jf]00?oi^KV00GoO7al
obd];Ol>3Pko<c<cok2`/002onKViP0:od];BommOGgoIFEUo`h>3_lT92Co
`<30ohZ:R_lG5aOo71`LoibLW0;oi^KV00GoO7alobd];Ol>3Pko<c<cok2`
/002onKViP08ohF5QOoVi^Koi^KVojb/[?ld=3Co3Ph>oa4A4OoAdM46onKV
iP05ojb/[?ld=3Co3Ph>oa4A4OoAdM400_oVi^H02_m;Bd_oOGemofEUIOl>
3Pko92@Tol30`?n:RX[o5aLGoa`L7?nLW9`2onKViP06od];BomoOgooi^KV
onKVi_li>CWoLW9b0_oVi^H01Oo?cloo@410o`/;2olI6AWoYJFU00Koi^KV
00[oBd];og]kNomCDe?o20P8omSHf?o?cloo@410o`/;2olI6AWoYJFU0_oV
i^H02_m;Bd_oOGemofEUIOl>3Pko92@Tol30`?n:RX[o5aLGoa`L7?nLW9`2
onKViP0:od];BomoOgooi^KVonKVi_m;Bd_oOWinofe]KOlB4Q;o:BTYok2`
/0;oi^KV00Koclo?ocdm?Ol:2P[o92@Tof9RH_l?3`l2onKViP05ojb/[?ld
=3Co3Ph>oa4A4OoAdM401_oVi^H01_ll?3coSXj>onKVi_oVi^KoRh^;oclo
?`;oi^KV00Go[:b/oc@d=?l>3Pko4A4Aom7Ad@06onKViP04oc0`<?mOGeoo
0@41olk>cP;oi^KV00?o?cloof5QHOl10@400_oVi^H01_oAdM7oBDU9o`d=
3Ol=3@goBd];om;BdP;oi^KV00KoBd];oginO_m]KFgo4Q8BobTY:On`/;02
onKViP05ogalO?l];Bgo3Ph>oc<c<on`/;001_oVi^H00ol`<33oJ6QXonKV
iP04onKViP09od];BomoOgooi^KVonKVi_n/[:co=3@do`h>3_lA4A7odM7A
00;oi^KV00GoO7alobd];Ol>3Pko<c<cok2`/002onKViP03og1`L?mJFU[o
i^KV00Soi^KV00?oa/K6o`T92OoKfm/0I?oVi^H01?nMWIgo]kNgolS8b?oC
dm<1om[JfP00ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o2eBa
ojC4i_nidnooMZgZ00;oZn3o00CoKVi^okBd]?oPh>3ok>c/HOo^k^h01_lb
<S;oOgmoonk^k_nVYZKo51@Dom3@d0Cok^k^00?ok>c/onk^k_o^k^h01Oo^
k^h00oo]kNgok^k^onk^kP02onk^kP03ong]kOo^k^kok^k^00?ok^k^00Oo
k>c/onk^k_o^k^kok^k^omkNg_l0003oiNGU00?ok^k^00?ojn_[onk^k_o^
k^h02?o^k^h00oo[jn_ok^k^onk^kP05onk^kP03ong]kOo^k^kok^k^00;o
k^k^00?okNg]onk^k_o^k^h01Oo^k^h00olk>c_oMWIfonk^kP03onk^kP03
on_[joo^k^kok^k^00Wok^k^00Gojn_[onk^k_o^k^kok^k^on_[j`07onk^
kP03ong]kOo^k^kok^k^00;ok^k^00?okNg]onk^k_o^k^h02?o^k^h00oo]
kNgok^k^onk^kP04onk^kP04onc/k?o^k^koX:2Po`l?3`Cok^k^00?ojn_[
onk^k_o^k^h04?o^k^h00oo[jn_ok^k^onk^kP06onk^kP03oc8b<_lB4Q;o
?Shn00?ok^k^00?oVIVIoa4A4Ol10@401?o^k^h2ong]k@Ook^k^00?okNg]
onk^k_o^k^h01?o^k^h00oo/k>cok^k^onk^kP06onk^kP03oc8b<_m/K6co
k^k^00[ok^k^00?ojn_[onk^k_o^k^h01?o^k^h00oo/k>cok^k^onk^kP0=
onk^kP03og5aLOmUIFGok^k^06Cok^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN400?oooooo6Oooool02Oobl_;oj^[ZomkNg_o;bl_o[jn_o`]C[_nUa>Ko
]M3^ogV^k002ojOLo`04ogIfM_o1`L7ol?3`oogmoF7ooooo00Oo=SHfohV9
ROooooooooooohN7Qol];Bgolo?c01[ooooo00?oemOGo`000?oNg]h07ooo
ool01_mKFe_oTY:Boooooooooooo@410ogmoObGooooo00?oFe]Koi:BT_oo
ool03Oooool00on/[:co4A4Aooooo`0Oooooo`03ocHf=_l0003oWYjN00?o
oooo00?omOGeo``<3?l20P807Oooool00olf=SKoM7Adooooo`04ooooo`03
oe]KFonBTY;ooooo01Wooooo00?of=SHodI6A_oinOT0IOooool01?n_[joo
bl_;omkNg_oZj^X1oo;blP00ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm
_OnSXj?o2eBaojC4i_nhd^koMZgZ00;o[=oo00CoKVi^okBd]?oPh>3ok>c/
HOo^k^h00onTY:Co`l?3onk^kP02onk^kP03oiZJV_o4a<Cok^k^01Wok^k^
00?o/k>co`000?nh^;P07oo^k^h01_nXZ:So_knoonk^k_o^k^ko>c/kogIf
MRGok^k^00?oZ:RXokno_oo^k^h03Oo^k^h00onPX:3o3`l?onk^kP0Oonk^
kP03ojBTY?n?ShoohN7Q00Cok^k^00?oZJVYoi2@T?o^k^h07?o^k^h00onT
Y:Co^[Zjonk^kP04onk^kP03ojRXZ?no_kook^k^01Wok^k^00?oUYJFomkN
g_o^k^h0IOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooVi^HIonKV
iP09om[Jf_oCdm?ob<S8okNg]onMWIgo3EB^ojK6i_nfd>koNJo^00;oZmko
00CoJVYZojj^[_oHf=Soi>CTP_oVi^H00ooUiNGohN7QonGUi@0SonKViP03
on;Rh_oTi>Coi^KV03Coi^KV00?oiNGUon7QhOoVi^H0d?oVi^H01?nMWIgo
]kNgolS8b?oCdm<1om[JfP00ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm
_OnSXj?o2U6^ojC3iOnhd^ooNJk/00;o[=oo00CoKVi^okBd]?oPh>3ok>c/
ooo^k^jconk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003ooooooaWooooo
00Wol_;bon[Zj_oNg]kobl_;ojn_[ol=E:koYLCVokKBk_mi[^T00_nZh?l0
1?mfMWKo`L71oo3`l?omoOgooooook?ooooo00Co[jn_ol_;booNg]koj^[Z
0Oobl_800?ook^k^6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`]C[_nV
a^Ko^M?^ogV^j`02oj_Oo`04ofi^K_nd];Coh>3Ponc/k?ook^k^/oo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooVi^HIonKViP09om[Jf_oCdm?o
b<S8okNg]onMWIgo3eJ_oj?2i?nhdnooMjk[00;oZ]oo00CoJVYZojj^[_oH
f=Soi>CToooVi^JconKViP04oifMWOng]kOob<S8om?Cd`7of][J003oonk^
kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol?EJooYLCVokWCkomg[^/0
0_nYg?l01?m^KVko];Bdon3Ph?o/k>coonk^k[?ok^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN400?oooooo6Oooool02Oobl_;oj^[ZomkNg_o;bl_o[jn_
o`]D/OnTa>Ko^M?_ogJ]jP02oj_Po`04ogIfM_o1`L7ol?3`oogmoOoooooo
/oooool01?n_[joobl_;omkNg_oZj^X1oo;blP00ooo^k^hIonk^kP09on7Q
hOoJf][oclo?okfm_OnSXj?o2e>^ojG4i_ned>koNJk/00;oYmco00CoKVi^
okBd]?oPh>3ok>c/Foo^k^h03_lA9QCo2@TDoaXL7_l94P[o2@T:o`T95?l9
4P[o2A`No`T92_l92ACo0000o`T95?l0003o2@T:0_l000002Ol92@[o2A8:
o`000?l0003o2@T:o`T95?l0003o2@TDo`T92P03o`000007o`TB2_l0003o
2@T:o`T92_l0003o2@T:o`000002o`T92P03o`T95?l0003o2@T:00;o2@T:
00Go0000o`T92_l0003o2@T:o`000002o`T92P03o`000?l92@[o2@T:00?o
000000?o2@T:o`T95?l000001?l000001_l92@[o0000o`000?l0003o2@T:
o`0000;o2@T:00Go0000o`T92_l0003o0000o`T95006o`0000;o2@T:0_l0
00000ol92@[o0000o`000004o`000003o`T92_l0003o000000;o000000?o
2@T:o`000?l000006?l000000ol92@[o0000o`000006o`000003oaXB5?l0
003o000001go000000?o4BHNo`000?l000007Ol000000ol92@[o0000o`00
000^o`000003ob`h:Om6EE;ok^k^05kok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400?ooi^KV6OoVi^H02OoJf][odm?ColS8b?ng]kOoWIfMo`]D/OnT
a>Ko^=;^ogJ]jP02ojcOo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00Ko2A8:
oaXB5?l971Co2@TDo`TL7_lJ2@X2oaXB5007oa4V5?l92ACo4A`:oaXB5?l9
71Co2@TDoa4V5002o`T95009o`TL5?lJ4QCo2@TDo`T95?lA9QCo2A`DoaXB
5?l92@[o6Q8D00;o2@TD00Go2@T:o`T95?l94P[o2@TDoaXB5002o`T92P09
oa4L2_l92@[o4A`:o`TB2_l92@[o2@TDo`T92_lJ4QCo2@T:00?o2A8:00Co
2A`Do`T95?l94P[o2@TD0_lJ4Q@01Ol92ACo6Q8Do`TB2_l94P[o2@TD00;o
2A8:0ol92A@01?l94P[o2A`Do`T95?l92A@2o`TB2P0;o`T95?l94P[o2@T:
o`TB2_l92@[o2@TDo`TB2_lJ4QCo2A8:o`T92_l92A@00ol94PX2o`T92P;o
2A8:00Go6Q8Do`T95?l92ACo2A8:oaXB5003o`TB2P;o2@TD00?o2A8:o`T9
5?lJ4Q@00_l92A@01Ol94P[o4BHDo`TB2_l92ACo6Q8D00;o2@TD00Co2A8:
o`T95?l92ACo2A8:1?l92A@02_l94P[o2@TDoaXB5?l92ACo2A`NoaXB5?l9
2ACo2A8:o`T95?lJ4Q@2o`T95003o`TL7_lJ4QCo6Q8D00?o2@TD00oo2A8:
o`T95?lJ4QCo2A`Do`T95?l971Co2@TDo`TL5?lJ4QCo2@TDoaXB5?l92ACo
4BHDo`TL5?l92A@00olJ4Q@2o`T95004o`TB2_lJ4QCo6Q8DoaXB50;o2@TD
00Co6Q8Do`T95?lJ4QCo2A`D0_l92A@01_l971Co6Q8Do`T95?l92@[o6Q8D
oa4V50Co2@TD00Co2A`Do`T95?l94P[o6Q8D0_l92A@00olA9QCo2@TDoaXB
5002o`T95006oa4V5?l92ACo2A`DoaXB5?l92ACo4BHN0_l92A@01OlA9QCo
2@T:o`TL5?lJ4QCo2A`D00;o2@TD00Ko2A8:o`TL5?l92ACo2@TDo`TB2_lJ
4Q@2o`T95007oa4V5?l94P[o2@TDo`T95?l92@[o2A`NoaXB5002o`T95005
o`TB2_lJ71ko2@TDoaXB5?l94PX01Ol92A@04_lJ4QCo2@TDo`T92_lA9Qko
2@T:oaXB5?l971ko2A8:o`T95?lA70[o2@TDoa4V7_lA9QCo2@TDoa4L2_l9
2@[o=2lcog9bNeooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00?ook^k^
6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`eD[_nVa^Ko]]3^ogV_kP02
oj_No`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00[o6Q8Doa4V5?l94P[o6Q8D
oa4V5?lA9Qko2@TDoa4L2_lA9QCo2A8:0ol92A@04OlA9QCo2A8:oaXB5?lA
70[o2@TDoaXB5?l92ACo6Q8DoaX92_l94P[o2@T:oa4L2_l92ACo4A`:o`T9
5?l94P[o4A`:00;o2@T:00?o2@TDo`T92_l92@X00_l94PX02Ol92@[o2A8:
o`TB2_l94P[o4A`:o`T92_lA70[o2@TDoaXB5003o`TB2P03o`T92_l92ACo
2@TD00;o2A8:0ol92A@2o`TB2P04o`T95?l94P[o2@TDo`TB2P?o2@TD00[o
2@T:o`TB2_l94P[o2@TDo`T92_l94P[o2@T:o`TB2_l92ACo2A8:1_l92@X0
0ol94P[o4A`:o`T92P03o`TB2P04o`T95?l94P[o2A8:o`TB2P;o2@T:0ol9
4PX3o`T95003o`TB2_l92@[o2@TD00;o2@TD00Co2A8:o`T95?l92@[o2@TD
1?l94PX01Ol92ACo2A8:o`TB2_l94P[o2@T:00;o6Q8D00?o2A8:o`T95?l9
4PX00_l94PX2o`T950;o2A8:0_l92A@00ol94P[o2A`Do`TB2P02o`TB2P03
o`T95?lJ4QCo2@TD00;o2@TD00?o2@T:oaXB5?l92A@00_l92A@00olJ4QCo
2@TDo`T95002o`TB2P04o`T95?lJ4QCo2@TDoa4L2P;o2@TD00Ko4A`:o`T9
5?l94P[o4A`:oaXB5?l92A@2o`T92P05oa4L2_lJ4QCo2@TDo`TB2_lJ4Q@0
0ol92A@01OlJ4QCo2@TDoaXB5?lJ4QCo2@TD00;o6Q8D00?o2@TDoaXB5?lJ
4Q@00_l92A@02_lJ4QCo2@TDo`T95?l92@[o6Q8Do`T95?l94P[o6Q8Do`T9
5?lJ71h2o`T95005oaXB5?l92ACo2@TDo`T95?lJ4Q@00_l92A@00olJ4QCo
2A`DoaXB5002o`T9500=o`TB2_l92ACo2@TDo`T95?lJ4QCo2A8:oaXB5?l9
4P[o2@TDoaXB5?l92ACo2A`DoaXB5002o`T950?o6Q8D00co4A`:oaXB5?l9
71Co4A`:oaXB5?l92ACo4A`:o`T95?lA9Qko4A`:o`T95?lA9Q@2o`T95007
oa4L2_l92ACo2@TDo`T95?l94P[o?BlmodmNIP1Oonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q003ooooooaWooooo00Wol_;bon[Zj_oNg]kobl_;ojn_
[ol:DJkoY<?UokSBkomi[^`00_n/gol01?mfMWKo`L71oo3`l?omoOeKoooo
o`07oaXB5?l94P[o2@TDoa4V5?l92ACo2A8:oa4V5002o`T95003oa4L2_l9
2@[o2@T:00;o2A8:00?o2@TDo`TB2_l94PX00_l94PX01ol92@[o4A`:o`TB
2_lA9QCo2@TDoa4L2_l94PX01?l92@X00olA70[o2@T:o`TB2P02oa4L2P;o
2@T:0_l94PX3o`T92P09o`TB2_lA70[o2@T:o`T92_l0003o2A8:o`T92_l9
4P[o2@T:00Go2A8:00Co2@TDo`TB2_l92@[o2A8:0ol92@X00ol92ACo2A8:
o`TB2P05o`TB2P04o`T92_l94P[o2A8:o`T92P;o2A8:0ol92@X00ol94P[o
2@T:o`000003o`TB2P05o`000?l94P[o0000o`TB2_l92@X01?l94PX00olJ
4QCo2A8:o`T92P02o`TB2P;o2@T:00Oo2A8:o`T92_l92@[o2@TDo`TB2_l9
2@[o2@TD00;o2A8:00Ko2@TDo`T92_l94P[o2@TDo`TB2_l92@X3o`TB2P03
o`T95?l94P[o2@T:00?o2@T:00?o2A8:o`T92_l94PX00ol92@X01?lm;cgo
2@T:o`TB2_l92@X5o`TB2P03oa4L2_l92@[o2A8:00;o2@T:00Ko4A`:o`T9
2_l94P[o2A8:o`T95?l94PX2o`T92P07o`TB2_l99RWo2@T:o`T92_l92ACo
2@T:o`T95002o`TB2P0=o`T92_l94P[o2A8:o`TB2_l92@[o2A8:o`T92_lA
70[o2@TDoaXB5?l92@[o2A8:o`T92P02o`TB2P06oa4L2_l92ACo2A8:o`T9
5?l94P[o2@T:0ol94PX00ol92@[o4A`:o`T95002o`T92P05o`T95?l94P[o
2A8:oa4L2_l92@X00_l94PX00olA70[o2@T:o`T92P02oaXB5009o`T95?lJ
4QCo2A8:oaXB5?l92ACo2@T:o`TB2_l971Co2@TD00;o2A8:01Co2@TDo`TB
2_lJ4QCo6Q8Do`T95?lJ4QCo2@TDoa4L2_l94P[o2@TDo`T92_l94P[o2@TD
o`TB2_l92ACo2A8:o`T95?l94P[o2@TDoaXB50;o2@TD00?o6Q8Do`TB2_l9
2A@00_l92A@01_l971Co4A`:oa4V7_l0003o=2lcodmNIUoooooo00Co[jn_
ol_;booNg]koj^[Z0Oobl_800?ook^k^6Oo^k^h02OoQhN7of][Jolo?conm
_KgoXj>So`eD[_nUa>Ko]];^ogV^j@02oj[Po`04ofi^K_nd];Coh>3Ponc/
k5_ok^k^00co4A`:oaXB5?l971Co4A`:o`T95?lJ4QCo2@TDoa4L2_lA9QCo
2@TDo`T92_lA70X2o`T92P04oaXB5?l94P[o4A`:o`T92P?o2A8:0_l92@X0
0olJ4QCo2@TDo`TB2P08o`TB2P;o2@T:00Co2A8:o`T92_l94P[o2@T:0_l9
4PX00olA70[o2@T:oaXB5004o`T92P04o`TB2_l92@[o2A8:o`T92P;o2A8:
00Ko0000o`T95?l92@[o2A8:o`T92_l00002o`TB2P03o`T92_l0003o2A8:
00;o2@T:00[o2@TDo`TB2_l94P[o2@T:o`000?l94P[o2@T:o`000?l94P[o
2@T:0_l94PX01ol0003o2A8:o`T95?l94P[o0000o`T95?l000000_l94PX2
o`T92P05o`000?l94P[o2A8:o`T92_l94PX00_l92@X01_l92ACo2A8:o`TB
2_l94P[o0000o`TB2PCo2@T:1?l94PX3o`T92P;o2A8:00Co2@T:o`TB2_l9
2ACo2A8:0ol92@X2o`TB2P03o`T92_lA70[o2@T:00Co2A8:0ol92@X01OlJ
4QCo2A8:o`000?l92@[o2A8:00?o2@T:00Oo2A8:oa4L2_l92@[o2@T:o`TB
2_l92@[o2A8:00;o2@T:00Co4A`:o`TB2_l94P[o2@T:1ol94PX01?l92@[o
6Q8DoaXB5?l92@X2o`TB2P05oaXB5?lA70[o2@T:o`TB2_l92@X00_l94PX2
o`T92P03o`T95?l94P[o2A8:00;o2A8:00Co4A`:o`T92_l94P[o2@T:0ol9
4PX01Ol92ACo?Blmo`000?lA70[o2@T:00;o6Q8D0ol94PX00olA70[o2A8:
o`T92P03o`TB2P04o`T92_l92ACo4A`:o`T92P;o2@TD00Co2A`Doa4L2_l9
2@[o2A8:0_l92@X00ol92ACo2A8:o`T95002o`T92P;o2@TD00oo2A8:o`T9
5?l92ACo2A8:o`T95?lJ4QCo2A8:o`TL5?l94P[o4A`:oaXB5?l94P[o2@T:
o`T95?lA70X00ol92A@01?lJ4QCo2A8:oc@_:OmZNhAOonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?Cdoo8b<So]kNg
oifMWOl;DjkoY/KVokWCk_mi[^/00_n[gol01?mZJV[o[Zj^omSHf?oTi>AK
onKViP03o`TL5?l92ACo6Q8D00;o2A`D00?o2@T:oa4V5?l92A@00ol94PX0
0ol92ACo4BHDo`TB2P02o`TB2P06oa4L2_l94P[o2A8:o`TB2_l92@[o4BHD
0_l94PX01OlA70[o2@TDoa4L2_l92ACo2@T:00;o2A8:0_l92@X00ol94P[o
2@T:oa4L2P02o`TB2P;o2@T:00Co2A8:o`T92_l94P[o2A8:0_l92@X3o`TB
2P03o`000?l92@[o2A8:00?o2A8:0_l92@X3o`TB2P03o`T95?l94P[o2A8:
00;o2@T:0ol94PX00ol92ACo2@T:o`TB2P02o`TB2P03o`T95?l94P[o2@T:
00;o2@T:00?o2A8:o`T92_l94PX00_l94PX01_l0003o2@T:o`T92_l92ACo
2A8:o`0000;o2A8:0_l92@X00ol94P[o2@T:o`TB2P0:o`TB2P03o`T92_l9
4P[o2@T:00Go2A8:00?o2@T:o`TB2_l94PX00ol94PX3o`T92P07o`TB2_l9
2@[o2A8:o`TB2_l92@[o2A8:o`T92P02o`TB2P;o2@T:0ol94PX00ol92@[o
2A8:o`TB2P02o`TB2P;o2@T:0_l94PX01_l92@[o2A8:o`TB2_l94P[o6Q8D
oa4L2P;o2@T:00Oo2A8:o`T92_lA70[o2@T:o`TB2_l92@[o2@TD00Co2A8:
0_l92A@01OlA70[o2A8:o`T92_l92ACo4A`:00;o2A8:0_l92@X00ol92ACo
4A`:o`TB2P02o`TB2P04oaXB5?l94P[o2@TDoaXB50;o2A8:00Go2@T:o`TB
2_l92ACo6Q8Do`TB2P02o`T95006o`T92_l94P[o2A8:o`T95?l94P[o2@T:
0_l94PX01ol92ACo2@T:oaXB5?lJ4QCo2@T:oa4L2_l92A@01?l94PX00ol9
2ACo6Q8DoaXB5002o`TB2P08oa4L2_l94P[o2A8:o`TB2_lA70[o2@TDo`T9
2_l94PX3oaXB50;o2A8:1?l92A@00ol94P[o2@TDo`T95002o`T95008o`TL
5?lJ4QCo2A8:oa4V5?l971Co2A8:oc@_:OmZLUaOonKViP04oifMWOng]kOo
b<S8om?Cd`7of][J003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>S
Xol?EZooXl;TokSCkomg[^/00_nZgol01?m^KVko];Bdon3Ph?o/k>aKonk^
kP07oaXB5?lA9QCo2A8:oaXB5?l92ACo4A`:o`T95002o`TB2P07oaXB5?l9
2ACo4BHDo`T95?l94P[o6Q8Do`T95002o`TB2P;o2@T:00?o2A8:o`T92_l9
4PX00_l92@X00ol94P[o2@T:o`TB2P02o`TB2P;o2@TD0ol94PX01?l92@[o
2A8:o`TB2_l94PX2o`T92P07o`TB2_l0003o2@T:o`T92_l94P[o0000o`TB
2P02o`T92P04o`TB2_l92ACo0000o`T950;o2A8:00?o2@TDo`T92_l92A@0
0_l000000ol92@[o2A8:o`T92P04o`TB2P0?o`T95?l92@[o2A8:o`000?l9
2@[o2A8:o`T92_l94P[o0000o`T92_l94P[o2@T:o`T95?l92@[o2A8:00;o
2@T:00?o2A8:o`000?l92@X00_l92@X00ol94P[o2@T:o`T92P04o`T92P03
o`TB2_l92@[o2A8:00?o2@T:00?o2A8:o`000?l94PX00_l92@X01?l94P[o
0000o`T92_l94PX2o`T92P?o2A8:1?l92@X01?l94P[o2@T:o`TB2_l92@X2
o`TB2P03o`T92_l94P[o2A8:00;o2@T:00Ko2A8:o`T92_l94P[o2@T:o`TB
2_l0000:o`T92P09o`TB2_l92@[o2@TDo`TB2_l92@[o2@TDo`T92_l94P[o
2@T:00?o2A8:00_o2@TDo`TB2_l92@[o2@T:o`TB2_l92@[o2A8:o`TL5?lJ
4QCo2@T:o`T95002o`T92P;o2A8:0_l92@X01ol94P[o2@TDo`T92_l94P[o
2@TDo`TB2_l92@X00_l94PX00ol92@[o2A8:o`TB2P03o`T92P04o`TB2_lA
70[o2A8:o`T92P;o2A8:00Co2@T:oa4L2_l92ACo2A8:1?l92A@2o`T92P?o
2A8:0_l92A@01_l92@[o2A8:o`T95?l92ACo2A8:o`T92P;o2A8:0_l92@X0
1olA70[o2@T:o`TB2_l92ACo2@T:o`T95?l94PX00_l92@X2o`TB2P;o2@TD
1?l94PX00ol92ACo2A8:oaXB5002o`T95003o`T92_ld;c?oJW]_05ook^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400?oooooo6Oooool02Oobl_;oj^[Z
omkNg_o;bl_o[jn_o`mE[onUa>Ko^M?_ogN^j`02ojWLo`04ogIfM_o1`L7o
l?3`oogmoE_ooooo00[o4BHDoaXB5?l971Co2@T:oaXB5?l94P[o6Q8Do`TB
2_l92@[o2A8:1?l92@X01?l92ACo4A`:o`T92_l92@X2o`TB2P;o2@T:00Co
2A8:o`T92_l92@[o2A8:0_l92@X2o`TB2P05o`T92_l94P[o2@TDo`000?l9
4PX00_l92@X00ol0003o2A8:o`T92P02o`T92P;o2A8:0ol92@X2o`TB2P;o
2@T:00?o2A8:o`T92_l94PX00ol94PX00ol92@[o6Q8Do`T92P02o`TB2PCo
2@T:00?o2@TDo`TB2_l94PX01?l92@X00ol94P[o2@T:o`000002o`TB2P03
o`T92_l94P[o6Q`N00;o2@T:0_l94PX:o`T92P03o`TL7_l92@[o2@T:00?o
2@T:00Co2A8:o`T92_l92@[o2@T:0_l94PX3o`T92P;o2A8:00?o2@T:o`TB
2_l92@X01?l92@X00ol94P[o2@T:o`T92P02o`TB2P;o2@T:00?o2@TDo`T9
2_l94PX00ol92@X01?l92ACo2@T:o`T95?l92@X2o`TB2P;o2@T:00Ko2A8:
o`T92_l92@[o2A8:o`T92_l94PX2o`T92P;o2A8:0_l92@X00ol92ACo2@T:
o`T92P09o`T92P04o`TB2_l92@[o2@T:o`TB2P?o2@T:00?o2A8:o`T92_l9
4PX00_l92@X01Ol94P[o2@T:o`T92_lA70[o2A8:00;o2@T:00So2A8:o`T9
5?l92ACo2A8:oaXB5?l94P[o2@T:oa4L2P?o2@T:00Ko6Q8Do`T92_l92ACo
2@TDo`TB2_l92A@3o`T92P04oaXB5?l92@[o2A8:o`T92P?o2A8:00Ko2@T:
o`T95?l92ACo2A8:oa4L2_l92A@2o`T92P0;oa4L2_l94P[o2@T:o`T92_l9
4P[o2@T:oa4L2_l92@[o2A8:o`T95?lJ4Q@00ol92@X5o`T950?o2A8:00So
2@TDo`TB2_l92ACo6Q8Do`TB2_l92@[o=2lYoeMNKeoooooo00Co[jn_ol_;
booNg]koj^[Z0Oobl_800?ook^k^6Oo^k^h02OoQhN7of][Jolo?conm_Kgo
Xj>So`]D/OnTa>Ko^M?_ogJ]jP02oj_Po`04ofi^K_nd];Coh>3Ponc/k5_o
k^k^00Go2A8:oaXB5?lJ4QCo2A`Do`T92P08o`TB2P07oa4L2_lA9QCo2@T:
o`TB2_l92@[o2A8:o`T92P02o`TB2P05oaXB5?l94P[o2@T:o`TB2_l92@X0
0_l94PX2o`T92P05o`TB2_l92@[o2@T:o`T92_l94PX00_l92@X00ol92ACo
2A8:o`TB2P02o`T92P03o`TB2_l92@[o2@T:00;o2@T:00?o0000o`T92_l9
4PX00_l94PX00ol92@[o0000o`TB2P03o`TB2P04o`T92_l92ACo2A8:o`T9
2PCo2A8:00Go2@T:o`000?l94P[o2@T:o`TB2P02o`T92P07o`000?l94P[o
2@T:o`000?l92@[o2@TDob`L5002o`T92P06o`TB2_l0003o2A8:o`T92_l9
4P[o2@T:0_l94PX2o`T92P;o2A8:1?l92@X00ol94P[o2@TDo`TB2P02o`T9
2P0;o`TB2_l92@[o2@TDo`TB2_l92@[o2A8:o`T92_l94P[o2@T:o`000?l9
2@X00ol94PX6o`T92P09o`TB2_l92@[o2@T:o`TB2_l92@[o2A8:o`T92_l9
4P[o2@TD00;o2@T:0_l94PX01?l92@[o2A8:o`T92_l00002o`TB2P03o`T9
2_lA70[o2@T:00;o2A8:00Co2@T:o`TB2_l94P[o2@TD0_l94PX00ol92@[o
2A8:o`T92P03o`T92P;o2A8:0_l92@X01Ol94P[o2@T:oa4L2_l92ACo2@T:
00Go2A8:00?o2@T:o`TB2_l92@X00ol94PX02Ol92@[o2A8:o`T92_l92@[o
2@TDo`TB2_l92@[o2@TDo`TB2P03o`T92P03oa4L2_l94P[o2A8:00;o2@T:
00Co6Q8Do`T92_l92ACo2A8:0_l92@X01_lJ4QCo2@T:o`T92_l92ACo2A8:
o`T950;o2@T:00?o2A8:o`T92_l92A@00_l92@X00olA70[o2@T:o`T92P02
o`T92P;o2A8:0_l92@X00ol94P[o2@TDo`T92P02o`TB2P;o2@T:00?o4A`:
o`T92_l92@X00_l92@X01ol94P[o2@TDo`TB2_l94P[o2@TDo`TB2_lJ4Q@0
0_l92A@00old;bWo?Blmonk^kP1Nonk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q003oonKViQWoi^KV00Wof][Jom?Cdoo8b<So]kNgoifMWOl;DjkoYLCV
okG@k_mi[^`00_nWg?l01?mZJV[o[Zj^omSHf?oTi>AKonKViP07oa4V5?lJ
4QCo2A8:oa4L2_l94P[o4A`:oaXB5002o`T92P04o`TB2_l92@[o2A8:o`TB
2P;o2@T:00Ko2A8:o`T92_lA70[o2@T:o`TB2_l92@X2o`TB2P03o`T92_l9
4P[o2A8:00?o2@T:00Co6Q8Do`T92_l92@[o2A8:1?l92@X00olA70[o2A8:
o`000003o`TB2PKo2@T:0_l94PX00ol0003o2@T:o`T92P02o`T92P09o`TB
2_l92@[o2@T:o`T92_lA70[o2A8:o`T92_l94P[o000000Wo2@T:00go2A8:
o`000?l0003o2@T:oa4L2_l94P[o2@TDo`T92_l94P[o0000o`T95?l92@[o
000000Go2@T:00?o2A8:o`000?l000000ol92@X01ol94P[o0000o`TB2_l0
003o2@T:o`TB2_l000001Ol92@X00ol94P[o0000o`T92P02o`T92P03o`00
0?l92ACo000000So2@T:00Oo2A8:o`000?l92@[o2A8:o`T92_l94P[o2@T:
00?o2A8:00?o2@T:o`TB2_l92@X01Ol92@X02Ol92ACo0000o`T92_l94P[o
2@T:oaXB5?l92@[o2A8:o`T92P02o`TB2POo2@T:00?o0000o`T92_l94PX0
0ol92@X00ol94P[o0000o`T92P02o`T92P04oa4L2_l92@[o2@T:o`TB2PKo
2@T:00Co2A8:o`T92_l92@[o2A8:0_l92@X01Ol92ACo2@T:o`TB2_l92@[o
2A8:00;o2@T:0_l94PX9o`T92P;o2A8:00Go2@T:o`TB2_l92@[o2A8:o`T9
2P03o`TB2PGo2@T:00Go2A8:o`T92_l94P[o2A8:o`T92P02o`TB2P;o2@T:
1?l94PX02?l92ACo2@T:o`T92_l94P[o2@TDo`T92_lJ4QCo2A8:0_l92A@0
0ol92@[o=2lYodI<?@1OonKViP04oifMWOng]kOob<S8om?Cd`7of][J003o
onk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol;E;7oY<CVokSBk_mf
[NX00_n/gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP04oaXB5?lA9P[o2@TD
oaXL7P;o2A8:00?o6Q8Do`T95?l94PX01ol94PX00ol92@[o2A8:o`T92P02
o`TB2P05o`T92_l94P[o2A8:o`T92_l94PX00_l92@X01?lS;bWo2A8:o`TB
2_l92@X3oaXB50;o2A8:00Go2@T:o`TB2_l0003o2@TDo`000006o`T92P07
oa4V7_l0003o2A8:o`T95?l0003o2@T:o`TB2P02o`T92P04ob<_:Ol92@[o
2A8:o`TB2PGo2@T:00So2A8:o`T92_l92@[o2A8:o`T95?l0003o2A8:o`00
00;o2@T:00Go2A8:o`T92_l92@[o2@T:oaXL7P04o`T92P05o`000?l92@[o
2@T:o`T92_l94PX00_l92@X01?l94P[o2@T:o`T92_l94PX<o`T92P04o`TB
2_l92@[o2@T:o`TB2POo2@T:00Go2A8:o`T92_l92@[o2@T:o`TB2P06o`T9
2P04oaXL7_l92@[o2@T:o`0000;o2@T:00Go2A8:o`T92_l92@[o2@T:o`TB
2P02o`T92P03o`TB2_l0003o2@T:00Co2@T:00So2A8:o`000?l94P[o0000
o`T92_l94P[o2@T:o`TB2PGo2@T:00Co6Q8Do`T92_l92@[o2A8:2_l92@X0
0ol94P[o2@T:o`T92P02o`TB2P03o`T92_l94P[o2A8:00Go2@T:00?o2A8:
o`T92_l92@X00_l92@X02Ol94P[o2@T:o`TB2_l92@[o4A`:o`TB2_l92@[o
4A`:o`TB2P02o`T92P03o`TB2_l92ACo2A8:00;o2@T:00Go2A8:o`T92_l9
4P[o2@TDo`TB2P02o`T92P?o2@TD00?o2A8:o`T95?l92@X00_l92@X5o`TB
2P03o`T95?l92@[o6Q8D00?o2A8:00?o2@TDo`T92_l92A@01?l92A@01?lA
9Qko2@T:oc@_:Om?GVIOonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003o
oooooaWooooo00Wol_;bon[Zj_oNg]kobl_;ojn_[ol=E:koY/KVokK@k_mi
[nh00_n[g_l01?mfMWKo`L71oo3`l?omoOeKooooo`04o`T95?lA70[o2@TD
o`TB2P;o2@TD1Ol94PX01?l92ACo2A8:o`T92_l94PX2o`T92P;o2A8:00Oo
2@T:o`TB2_l92@[o2A8:o`T92_l0003o2A8:00;o2@T:00?o0000ocd_?Ol9
2@X01?l94PX5o`T92P07o`TB2_l92@[o2A8:o`TB2_l92@[o4A`:o`TB2P02
o`T92P04o`TB2_l0003o2@T:o`TB2P;o2@T:00Co6Q8Do`TB2_l94P[o4A`:
1?l92@X00ol94P[o2@T:o`TB2P02o`T92P03o`TB2_l92@[o2@T:00Go2@T:
00Oo0000o`TB2_l92@[o2A8:ob<_:Ol92@[o2A8:00Ko2@T:00Ko0000o`TB
2_l92@[o2A8:o`T95?l94PX5o`T92P04o`TB2_l92@[o2@T:o`T92P;o2A8:
1Ol92@X00ol94P[o2@T:o`TB2P02o`T92P04o`TB2_l92@[o2A8:o`TB2P?o
2@T:0ol94PX01_l92@[o4A`:o`T92_l94P[o2@T:o`TB2P;o2@T:00Go2A8:
o`T92_l0003o2A8:o`T92P02o`TB2P?o2@T:0_l94PX2o`T92P03o`TB2_l9
2ACo2A8:00Ko2@T:00?o0000o`TB2_l92@X01Ol92@X00ol94P[o6Q`No`T9
2P06o`T92P03o`TB2_lA70[o2A8:00;o2@T:00So2A8:o`T92_l94P[o2A8:
o`T92_l94P[o2@TDo`TB2PGo2@T:00?o2A8:o`T92_l92@X01?l92@X01_l9
4P[o2@T:o`TB2_l94P[o2@TDo`TB2P;o2@T:00Ko2@TDo`T92_lA70[o2A8:
oa4L2_l92@X4o`TB2P06o`T95?lA70[o4A`:o`TB2_lA70[o2A8:1Ol92@X0
1Ol94P[o2@T:o`T92_l92ACo2A8:00;o2@T:00go2@TDoaXB5?l94P[o2@TD
o`TB2_l92@[o6Q8Do`T95?lJ4QCo2@TDo`T92_ld;akoLW9k05oooooo00Co
[jn_ol_;booNg]koj^[Z0Oobl_800?ook^k^6Oo^k^h02OoQhN7of][Jolo?
conm_KgoXj>So`YA[_nT`nGo^=;_ogV^k002ojcOo`04ofi^K_nd];Coh>3P
onc/k5_ok^k^00Oo6Q8Do`T95?l971Co2@TDoa4L2_l92@[o6Q8D00;o2@TD
0_l94PX3o`T92P04oaX92_l92@[o2@T:o`T92P?o2A8:1ol92@X2o`TB2P?o
2@T:0_l94PX2o`T92P03o`TB2_l92@[o2A8:00?o2@T:01Wo0000oa4L2_l9
2@[o0000oa4L2_l92@[o0000oa4L2_l0003o2@T:o`TB2_l92@[o2@TDo`T9
2_l94P[o0000ob`h:Ol92ACo2@T:o`TB2_l92@[o2A8:o`000?l92@[o4A`:
00Co2@T:00Oo0000o`T92_l92@[o0000o`T92_l0003o2A8:00;o000000?o
2@T:o`000?l94PX00ol92@X01?l0003o2@T:o`TB2_l00002o`T92P;o0000
00Oo2A8:o`T92_l92@[o2A8:o`000?l92@[o000000?o2@T:00?o0000o`TB
2_l92@X00_l000001Ol92@[o2A8:o`T92_l92@[o000000;o2@T:00Go0000
o`T92_l92ACo0000oa4L2P03o`T92P08o`000?l92@[o0000o`TB2_l92@[o
0000o`TB2_l00002o`TB2P;o2@T:00Co0000o`T92_l92@[o00001?l92@X0
0ol0003o4A`:o`T92P03o`T92P03o`000?lA70[o2A8:00Go2@T:00Co0000
o`TB2_l92@[o4A`:0_l92@X2o`000003oa4L2_l92@[o2@T:00Co2@T:00?o
2A8:o`T92_l92@X01Ol92@X00ol0003o2@T:o`TB2P07o`T92P04o`TB2_l9
2@[o2@T:o`0000;o2@T:0_l94PX5o`T92P03o`TB2_l92@[o2A8:00Ko2@T:
0_l94PX00ol92@[o2A8:o`T92P09o`T92P07o`TB2_l92@[o2@T:o`T92_l9
2ACo2@T:oa4L2P04o`T92P03oa4L2_l92@[o6Q8D00?o2@T:00?o2@TDoc@_
:OmbLW/0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooVi^HIonKV
iP09om[Jf_oCdm?ob<S8okNg]onMWIgo3EB^ojG4i_nfd^koNJkY00;oZ^3o
00CoJVYZojj^[_oHf=Soi>CTFooVi^H01ol92@[o2A`Do`TL5?l92ACo4A`:
o`T92_lA70X00_l94PX00ol92ACo2@T:o`TB2P05o`TB2P07o`000?l94P[o
2@T:o`T92_l94P[o2@T:o`TB2P02o`T92P03o`TB2_l0003o2@T:00Co2@T:
00Oo0000oa4L2_l92@[o2@T:o`000?l94P[o2@T:00;o2A8:0_l92@X01?l9
4P[o2@T:o`T92_l94PX4o`T92P0<o`000?l92@[o2@T:ob`L5?l94P[o2@T:
o`TB2_l92@[o2A8:oa4L2_l94P[o2@T:0ol94PX3o`T92P03o`TB2_l92@[o
2@T:00;o000000Co2A8:o`000?l94P[o00000_l92@X02?l94P[o2@T:o`TB
2_l92@[o2A8:o`000?lA70[o00000_l92@X00ol94P[o2@T:o`000003o`T9
2P05o`TB2_l0003o2@T:o`TB2_l000000_l92@X02_l94P[o2@T:o`T92_l9
2@[o2A8:o`T92_l94P[o0000o`T92_l00003o`T92P;o2A8:0_l000000ol9
2@[o2A8:o`TB2P05o`T92P0Bo`TB2_l0003o2@T:o`T95?l0003o6PT:o`00
0?l92@[o4A`:o`000?l94P[o0000o`T92_l94P[o2@T:o`000?l94P[o0000
1Ol92@X00ol0003o2@T:o`T92P02o`T92P08o`000?l92@[o2@T:o`T92_lA
70[o6Q8Do`000?l92@X2o`TB2P03o`T92_l94P[o2@T:00?o2@T:00?o2A8:
o`000?l92@X01Ol92@X00ol94P[o2@T:o`TB2P06o`T92P03o`TB2_l92@[o
2@T:00Go2@T:00?o0000o`TB2_l92@X02Ol92@X01?lA70[o2A8:o`T92_l9
4PX2o`T92P05o`T95?l92@[o2@T:o`T92_l94PX00ol92@X2o`TB2PGo2@T:
00?o2A8:o`T92_l92@X00ol92@X00ol94P[o2@TDo`TB2P03o`T950;o2A8:
00?o0000oc@_7_mPLW/0GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00
ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o2e>^ojK6i_nidnko
NJk[00;oZmoo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h00ol971Co2A8:oaXB
5004o`TB2P06o`T95?l94P[o2@TDoa4L2_l94P[o6Q8D0ol92@X00ol94P[o
4A`:o`TB2P02o`TB2P07o`T92_l94P[o0000o`TL5?lJ2@[o2A8:oa4L2P03
o`T92P;o2A8:0ol92@X2o`TB2P04o`000?l94P[o2@T:o`0000;o2A8:00Ko
0000o`TB2_l92@[o2A8:o`T92_l94PX2o`T92P;o2A8:00Co4A`:o`TB2_l0
003o2@T:0_l94PX01ol92@[o2A8:o`TB2_lA70[o0000o`TB2_l92@X00_l9
4PX01_l0003o2@T:o`T92_l94P[o2@T:o`TB2P;o000000?o2A8:o`000?l9
4PX00_l00002o`TB2P04o`000?l94P[o2@T:o`0000?o2@T:00_o0000o`T9
2_l92@[o2A8:o`T92_l0003o2A8:o`000?l94P[o0000o`TB2P02o`T92P04
o`000?l92@[o2A8:o`0000Go2@T:00Go2A8:o`T92_l94P[o2@T:o`000003
o`T92P06o`TB2_l0003o2@T:o`TB2_l92@[o2A8:0_l92@X02_l0003o2@T:
oa4V5?l92@[o0000oaXL7_l94P[o0000o`T92_l94PX;o`T92P08oa4L2_l9
2@[o2@T:oa4L2_l92@[o2A8:o`T92_l94PX5o`T92P03o`TB2_l0003o6PT:
00?o2@T:00?o2A8:o`T92_l94PX00_l92@X3o`TB2P;o2@T:0_l94PX00ol9
2@[o2A8:o`TB2P02o`T92P04oa4L2_l92@[o2A8:o`TB2P?o2@T:00Ko2A8:
o`T92_l92@[o2A8:o`T92_lA70X2o`T92P07o`TB2_lA70[o2@T:o`T92_l9
4P[o2@T:o`TB2P03o`T92PGo2A8:0_l92@X00olA70[o2@T:o`TB2P03o`T9
2P09o`TB2_lA70[o2@T:o`T92_lA70[o2A8:o`T92_l94P[o4A`:00?o2@T:
00?o2A8:oa4L2_l94PX00_l94PX01olA70[o2A8:o`T95?l92ACo0000oc@_
7_mbLW/0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooooolIoooo
o`09oo;bl_oZj^[og]kNol_;bon_[joo3eJ_oj?2i?nhdnooMjk[00;oZ]oo
00CoMWIfol71`Oo`l?3ooOgmFoooool00olJ4QCo2A8:o`TB2P03o`TB2P03
oa4L2_l92@[o2A8:00;o2@T:0ol94PX00olA70[o2@T:o`T92P02o`TB2P05
o`T92_l0003o2A8:o`T92_l94PX00_l000002_l92@[o2A8:o`T92_l92@[o
2A8:o`T92_l94P[o2@T:o`TB2_l00003o`T92P0Ao`000?l94P[o2@T:o`T9
2_l0003o2@TDo`T92_l94P[o2@T:oa4L2_l92@[o2A8:o`T92_l94P[o0000
o`T95?l94PX00_l92@X00ol94P[o2@T:o`T92P05o`T92P05o`000?l92@[o
2@T:o`T92_l000000_l94PX6o`T92P;o2A8:00Ko4A`:o`T92_l0003o2A8:
o`000?l94PX3o`T92P06o`TB2_l92@[o2@T:o`T92_l0003o2A8:1Ol92@X0
1?l0003o2@T:o`T92_l94PX3o`T92P09o`TB2_l92@[o2A8:o`T92_l94P[o
0000o`TB2_l0003o2A8:00Oo2@T:00Co0000o`TB2_l0003o2A8:0_l92@X0
1Ol94P[o0000o`TB2_lA70[o000000?o2@T:00Co0000o`T92_l0003o2A8:
1?l92@X01Ol94P[o2@T:o`T92_l92@[o2A8:00;o2@T:00Co2A8:o`T92_l9
4P[o2@T:0_l94PX9o`T92P05o`TB2_l92@[o2@T:o`000?lA70X01ol92@X0
1_l94P[o2@T:o`T92_l92@[o0000o`TB2P?o2@T:00?o2A8:o`T92_l92@X0
1ol92@X01?l94P[o2@T:o`T92_l94PX3o`T92P05o`000?lA70[o2@T:o`T9
2_lA70X00_l92@X00ol94P[o2@T:o`T92P04o`T92P03oa4L2_l94P[o2@T:
00[o2@T:00?o2A8:o`T92_l92@X00ol92@X02Ol94P[o2@T:o`TB2_l92@[o
4A`:o`TB2_l92ACo;180og9bN`1Oooooo`04ojn_[oo;bl_og]kNon[ZjP7o
l_;b003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol?EJooYLCV
okWCkomg[^/00_nYg?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP04o`T95?l9
4P[o2A8:o`T92P;o2A8:0ol92@X2o`TB2P;o2@T:00?o2A8:o`T92_l94PX0
1?l92@X00ol94P[o2@T:o`T92P02o`000008o`TB2_l92@[o2@T:o`000?l9
4P[o0000o`TB2_l92@X2o`000005o`TB2_l92@[o2@T:o`T92_l94PX00_l9
2@X02?l0003o2@T:o`000?l94P[o2@T:o`000?l94P[o2@T:0ol000001?l9
4P[o0000o`T92_l00002o`TB2P03o`000?l94P[o2@T:00;o2A8:00Co0000
o`T92_l92@[o2A8:0_l000001ol92@[o2A8:o`000?l92@[o0000oa4L2_l0
00000_l94PX4o`000003o`TB2_l0003o2@T:00;o2@T:00?o0000o`T92_l9
2@X00_l000000ol92@[o0000o`T92P02o`00000@o`T92_l94P[o0000o`T9
2_l0003o2@T:o`000?l94P[o0000o`T92_l0003o2@T:o`000?l94P[o0000
o`TB2P;o000001;o2A8:o`T92_l0003o2@T:o`000?l94P[o2@T:o`000?l9
4P[o0000o`T92_l0003o2A8:o`000?l92@[o0000o`T92_l00003o`T92P03
o`000?l92@[o2@T:00;o2@T:00?o0000o`TB2_l92@X00ol92@X00ol94P[o
2@T:o`000002o`TB2P06o`000?l94P[o0000o`TB2_l0003o2A8:1_l92@X0
2Ol94P[o2@T:o`T92_l92@[o0000o`TB2_l92@[o0000o`TB2P04o`T92P03
o`TB2_l92@[o2@T:00;o2@T:00Oo4A`:o`T92_l92@[o2@T:o`000?l92@[o
4A`:00Co2@T:00_o2A8:o`T92_lA70[o2A8:ob`L5?l92@[o2A8:o`T92_lA
70[o2@T:o`TB2P05o`T92P;o2A8:00?o4A`:o`T92_l94PX03?l92@X01?lA
70[o2@T:o`T92_l94PX2o`T92P;o2A8:00Go2@T:oa4L2_l94P[o2@T:o`T9
5002o`T92P06o`TB2_l92@[o2A8:o`000?ld;akoLW9kGoo^k^h01?nSXj?o
_Kfmolo?cooJf]X1on7Qh@00oooVi^HIonKViP09om[Jf_oCdm?ob<S8okNg
]onMWIgo2eBaojC4i_nidnooMZgZ00;oZn3o00CoJVYZojj^[_oHf=Soi>CT
FooVi^H2oa4L2P04o`T92_lA70[o2A8:oaXB50?o2A8:00Co6PT:o`000?l9
4P[o2@T:0_l94PX00ol92@[o2A8:o`T92P04o`TB2P?o2@T:00?o2A8:o`T9
2_lA70X00ol92@X2o`TB2PGo2@T:00?o2A8:o`000?l92@X02?l92@X00ol9
4P[o2@T:o`T92P06o`T92P;o2A8:00?o2@T:o`TB2_l000000_l92@X2o`TB
2P09oaX92_l94P[o0000o`TB2_l0003o2@TDo`T92_l94P[o000000?o2@T:
00?o2A8:o`T92_l92@X01?l92@X00ol94P[o0000o`T92P04o`T92P03oa4L
2_l0003o2@T:00;o2@T:00Ko2A8:o`000?l94P[o0000oa4L2_l00006o`T9
2P03o`000?l92@[o2@T:00;o2@T:00?o2@TDo`000?l92@X01ol92@X01?l0
003o2@T:oa4L2_l00003o`T92P08o`TB2_l0003o4A`:o`000?l94P[o0000
o`T95?l94PX5o`T92P03o`TB2_l92@[o2@T:00;o2A8:00?o0000o`T92_l9
2@X01_l92@X01?lA70[o0000oa4L2_l94PX8o`T92P;o2A8:00Ko0000o`T9
2_l92@[o2@T:o`TB2_l00002o`T92P03o`TB2_l92@[o2A8:00Go2@T:00Go
2A8:o`T92_l92@[o2@T:oa4L2P03o`T92P05oaXB5?l92ACo4A`:o`T92_l9
4PX00ol92@X01?lA70[o2@T:o`T92_l92@X2o`TB2P05oaXB5?l92ACo2@T:
o`T92_lA70X01?l92@X00olA70[o2@T:oa4L2P02o`T92P04o`TB2_l92@[o
2@T:oa4L2P?o2A8:00?o2@T:o`TB2_l92@X00ol92@X02_l94P[o4A`:o`TB
2_l92@[o4A`:o`TB2_l92ACo2@T:ob`B0?n3Q8iOonKViP04oifMWOng]kOo
b<S8om?Cd`7of][J003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>S
Xol;DjkoYLCVokG@k_mi[^`00_nWg?l01?m^KVko];Bdon3Ph?o/k>aKonk^
kP06o`T95?lA70[o2@TDoa4L2_l94P[o2@TD0ol94PX01?l92@[o2A8:o`TB
2_l92@X2o`TB2PGo2@T:00Go2A8:o`T92_lJ4QCo2@T:o`T95006o`T92P03
o`TB2_l92@[o2@T:00;o2A8:1ol92@X00ol94P[o2@T:o`T92P0;o`T92P03
o`TB2_l92ACo2@T:00Co2@T:00_o2A8:o`T92_l92@[o2A8:o`T95?l94P[o
6Q8Do`T92_l0003o2@T:o`TB2P03o`T92P03o`TB2_l92@[o2@T:00So2@T:
00Go2A8:o`T92_l92@[o2@TDo`T92P02o`TB2P03o`T92_l94P[o2@T:00Go
2@T:00Co2A8:o`T92_l92@[o2A8:0ol92@X01?l94P[o2@T:o`T92_l94PX2
o`T92P03o`TB2_l92@[o2@T:00So2@T:00Co4A`:o`000?l94P[o6PT:1_l9
2@X00ol0003o4A`:o`00000Ao`T92P05o`TB2_l0003o2@T:o`T92_l92A@0
1Ol92@X00ol94P[o2@T:oa4L2P05o`T92P03o`TB2_l92@[o2@T:00Go2@T:
00?o2@TDo`T92_l92@X00ol92@X00olA70[o2@T:o`T92P02o`T92P03o`00
0?l92@[o2@T:00?o2@T:00?o2A8:oa4L2_l92@X01ol92@X00ol92ACo4BHN
o`T92P0<o`T92P03oa4L2_l94P[o2@T:00Ko2@T:00?o2@TDo`T92_lA70X0
0ol92A@2o`T92P05oaXB5?l92@[o2@T:oaXB5?n3Q7/0Goo^k^h01?nSXj?o
_Kfmolo?cooJf]X1on7Qh@00oooooolIooooo`09oo;bl_oZj^[og]kNol_;
bon_[joo2eBaojC4i_nhd^koMZgZ00;o[=oo00CoMWIfol71`Oo`l?3ooOgm
Foooool2o`TB2P06o`T95?lJ4QCo6Q8DoaXB5?l92@[o2A8:0_l92@X00ol9
4P[o2@T:o`TB2P05o`T92P05o`TB2_l92@[o2A8:o`TB2_l92A@00_l94PX0
0ol92@[o0000oa4V7P03o`T92P04o`T95?l92@[o2@T:o`T92P;o000000So
2@T:o`TB2_l92ACo2@T:o`000?lA70[o2@T:o`0000;o2A8:1_l92@X3o`TB
2P04o`000?l92@[o2@TDoaXB50Oo2@T:00co6Q`No`T92_l0003o6Q`No`T9
2_l94P[o2@T:o`000?l92ACo0000o`T92_l94PX2o`T92P;o2A8:0_l92@X0
0ol94P[o0000o`T95002o`000004o`TB2_l0003o0000o`T92P;o000000?o
6Q`No`000?l94PX01Ol92@X01Ol0003o2@T:o`T92_l0003o2A8:00;o2@T:
00Co0000o`T95?l94P[o00000_l94PX01Ol0003o2A8:o`T92_l92@[o0000
00Go2@T:00Ko2A8:o`T92_l92@[o0000o`T92_l94PX6o`T92P03o`000?l9
2@[o2A8:00Go2@T:00Go2A8:o`T92_l92@[o2@T:o`TB2P08o`T92P;o2A8:
00?o0000o`TB2_l92@X00_l92@X01ol0003o6PT:o`T92_lJ4QCo2@T:o`TB
2_l92@X00_l94PX5o`T92P03oa4L2_l92@[o2@T:00;o2@T:00?o2A8:o`T9
2_l94PX00_l92@X01?lJ2@[o2@T:o`T92_lA70X<o`T92P07oa4L2_l92@[o
2@T:o`T92_l92ACo6Q8Doa4L2P03o`T92P0:o`TB2_l92@[o2@T:o`T92_l9
4P[o2@T:oa4L2_l92@[o2A8:o`T950;o2@T:00_o2@TDo`T92_l94P[o2@T:
o`T95?lJ4QCo2A`DoaXB5?l92ACo2@T:o`TB2P02o`T92P06oaXB5?l92ACo
6Q8Do`T92_lJ2@[oPhB>Goooool01?n_[joobl_;omkNg_oZj^X1oo;blP00
ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o3EB^ojK6i_nfd>ko
NJo^00;oZmko00CoKVi^okBd]?oPh>3ok>c/Foo^k^h2o`T95004oa4L2_l9
2@[o2@T:o`TB2P;o2@T:00Oo4A`:o`TB2_l94P[o2A8:o`T92_l92ACo2@T:
00;o2A8:00So2@T:o`TB2_l94P[o0000o`T92_l0003o2A8:o`0000;o2A8:
00Go4A`:o`000?l94P[o2@T:o`TB2P03o`T92P09o`T95?l92@[o2A8:o`T9
2_l0003o2A8:o`T92_l0003o2A8:00?o2@T:00Co2A8:o`T92_l94P[o2A8:
0ol92@X2o`000005o`T95?l94P[o4BHDoaXB5?l000000_l94PX2o`T92P;o
2A8:00[o0000o`TB2_l92@[o0000o`TB2_l92@[o0000o`T92_l0003o2A8:
0ol92@X02ol94P[o0000o`T95?l0003o2@T:o`000?l94P[o0000o`TB2_l9
2@[o000000;o2A8:0_l92@X01ol94P[o2@T:o`TB2_l0003o2A8:o`T92_ld
;ah00_l92@X2o`TB2P?o2@T:0_l000000olA70[o0000o`000002o`T92P04
o`000?l94P[o2A8:o`TB2P;o2@T:00So2A8:o`T92_l92@[o2@T:o`TB2_l0
003o2A8:o`T92P?o2A8:00[o0000o`TB2_l0003o2@T:o`000?l92ACo2A8:
o`T92_l0003o2A8:0ol92@X02?l94P[o2@T:o`T92_lA70[o2@T:o`TB2_l0
003o2A8:0_l92@X01ol94P[o2@T:o`T92_l92@[o2A8:o`000?l94PX01Ol9
2@X3o`TB2P;o2@T:00Ko0000o`T92_l0003o2A8:o`T92_l94PX3o`T92P0:
o`000?l92@[o2@T:oaX92_l94P[o2@T:oa4L2_l94P[o2@T:o`0000?o2A8:
00Co0000o`TB2_l92@[o2@T:1_l94PX01Ol92@[o2A8:o`TB2_l92@[o2A8:
00?o2@T:00Go2A8:o`T92_l92@[o2@T:o`TB2P02o`T92P;o2A8:00Co2@TD
o`TB2_l92@[o2@T:0ol94PX00olJ4QCo4A`:o`T92P02o`T92P09ob<L2_l9
2ACo2A8:o`T92_l94P[o2@TDo`TB2_l92@[o2@TD00;o2@T:00?o2A8:ob<L
2_n=V8h0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooVi^HIonKV
iP09om[Jf_oCdm?ob<S8okNg]onMWIgo2U6^ojC3iOnhd^ooNJk/00;o[=oo
00CoJVYZojj^[_oHf=Soi>CTFooVi^H01?lJ4QCo2A8:o`T92_lA70X2o`T9
2P03o`TB2_l92@[o2A8:00?o2@T:00Ko2A8:o`T92_l94P[o0000o`TB2_l0
0002o`T92P0<o`000?l94P[o0000o`T92_l0003o2A8:o`000?l94P[o0000
o`TB2_l0003o=2lc0_l000002Ol94P[o0000o`TB2_l0003o2A8:o`000?l9
4P[o0000o`TB2P02o`T92P05o`TB2_l0003o2@T:o`000?l94PX00_l92@X2
o`TB2P03o`T92_l94P[o000000;o2A8:0_l000001Ol94P[o2@T:o`T92_l9
4P[o000000;o2@T:0_l000000ol94P[o0000o`000002o`TB2P04o`000?l9
2@[o2A8:o`T92P;o000000?o2@T:o`000?l92@X00ol92@X01ol94P[o2@T:
o`TB2_l92@[o0000o`T92_l000000_l94PX02?l0003o2@T:o`TB2_l92@[o
0000ob=1D_l0003o2@T:0_l000000ol92@[o0000o`T92P02o`T92P08o`00
0?l92@[o2@T:o`000?l94P[o0000o`TB2_l00002o`T92P05o`TB2_l0003o
2@T:o`T92_l94PX00_l000002_l92@[o2A8:o`000?l0003o2A8:o`000?l9
2@[o2A8:o`T92_l94PX2o`000003oa4L2_l0003o2@T:00Co2@T:00?o2A8:
o`T92_l000001Ol92@X02?l94P[o0000o`T92_l92@[o2A8:o`000?l92@[o
2A8:0_l92@X01ol0003o2A8:o`T92_l94P[o0000o`T92_l000002Ol92@X0
1ol94P[o2@T:oa4L2_l92@[o0000o`T92_l94PX00ol92@X00ol94P[o0000
o`T92P02o`T92P0:o`000?l92@[o2@T:o`T92_l94P[o0000o`TB2_l92@[o
2A8:o`0000Ko2@T:00?o2A8:o`000?l94PX00_l92@X3o`TB2P?o2@T:00?o
2A8:o`T92_l92@X00ol92@X01?lJ4QCo2@T:o`TB2_l92@X5o`TB2P04o`T9
2_l94P[o2A8:o`T92P;o4A`:0_l94PX00olJ2@[oEei_onKViP1NonKViP04
oifMWOng]kOob<S8om?Cd`7of][J003oonk^kQWok^k^00WohN7Qom[Jf_o?
cloo_Kfmoj>SXol=E:koYLCVokKBk_mi[^T00_nZh?l01?m^KVko];Bdon3P
h?o/k>aKonk^kP05o`T95?l92@[o4A`:o`000?lA70X00ol94PX01?lJ4QCo
2A8:o`TB2_l94PX6o`T92P09oa4L2_l94P[o0000o`TB2_lJ4QCo0000o`T9
2_l94P[o2@TD00;o2@T:0_l94PX03Ol0003o6Q`No`000?l0003o2A8:o`00
0?l92ACo0000o`T92_l0003o2A8:o`000?l94PX00_l92@X03?lA70[o0000
oa4L2_l0003o2@T:oa4L2_l0003o2@T:o`000?l94P[o0000o`TB2P;o2@T:
00Go2A8:o`000?l94P[o0000o`T92P04o`TB2P05o`000?l92@[o2@T:o`T9
5?l000000_l92@X00ol0003o2@T:o`T92P02o`T92P06o`TB2_l0003o2A8:
o`TB2_l0003o2A8:0ol000001Ol94P[o0000o`TB2_l92@[o000000;o2@T:
00Oo2A8:o`000?l92@[o2A8:o`000?l92@[o000000Co2@T:00Go2A8:o`00
0?l94P[o2@T:o`000003o`T92P03o`TB2_l0003o2@T:00Co2@T:00So2A8:
o`000?l92@[o2@T:o`TB2_l0003o2@T:o`TB2P?o2@T:00Co0000o`T92_l9
4P[o00001?l92@X01olA70[o2@T:oa4L2_l92ACo8a`:o`T92_lA9Qh01?l9
2@X01?l94P[o2@T:o`T92_l94PX8o`T92P03o`TB2_l0003o2@T:00?o2@T:
00?o4A`:o`T92_l92@X00_l92@X01_l0003o2@T:o`T92_l94P[o2@T:o`TB
2P?o2@T:00Co2A8:o`000?l92@[o2A8:0ol92@X01?l94P[o2@T:o`T92_l9
2@X2o`TB2PCo2@T:00?o2@TDo`T92_l92@X00_l92@X01?l94P[o2@T:o`TB
2_l94PX2o`T92P03o`TB2_l92@[o2@T:00;o2@T:00Co2A8:o`000?l94P[o
2@T:0_l94PX2o`T92P;o2A8:00Ko2@T:o`TB2_l94P[o4A`:o`T92_l94PX5
o`T92P03o`TB2_l92@[o2A8:00;o2A8:00Co2@TDo`000?l/4P3oPhB>Goo^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooooolIooooo`09oo;bl_oZ
j^[og]kNol_;bon_[joo2e>^ojK6i_nidnkoNJk[00;oZmoo00CoMWIfol71
`Oo`l?3ooOgmFoooool00ol92ACo2A8:o`TB2P02o`TB2P;o2@T:00?o6Q8D
o`T95?l94PX00_l94PX4o`T92P05o`TB2_l92@[o0000o`000?l94PX00ol0
00001?l94P[o0000o`000?l94PX2o`T92P0Bo`000?l94P[o0000o`T92_l9
4P[o0000o`TB2_l0003o2@T:o`000?lJ71ko2A8:o`T92_l0003o2A8:o`T9
2_l0003o2@TD0_l92@X2o`TB2P;o2@T:0_l000000ol94P[o0000o`TB2P02
o`T92P08o`TB2_l92@[o2@T:oa4L2_l0003o2A8:o`T92_l00002o`TB2P03
o`T92_l0003o2@T:00Go2@T:00Co0000oaXB5?l0003o2A8:0_l000000ol9
4P[o2@T:o`T92P02o`T92P07o`000?l94P[o0000o`TB2_l92@[o2A8:o`T9
5004o`T92P04o`000?l94P[o4A`:o`0000?o2@T:00?o0000o`TB2_l00000
0_l92@X03_l94P[o0000o`T92_l92@[o0000o`TB2_l92@[o0000o`TB2_l9
2@[o2A8:o`T92_l0003o2A8:0ol92@X00ol0003o2A8:o`000002o`T92P03
o`000?l92@[o2@T:00;o2@T:00Wo2A8:o`T92_lJ2@[o6PT:ob`B0?lJ2@[o
;180ob<L2_l/4P000_lA70X01_l92@[o6PT:o`T95?l94P[o2@T:o`0000Co
2@T:00Go0000o`T92_l92@[o2A8:o`000002o`T92P03o`TB2_l92@[o2@T:
00So2@T:00?o0000o`T92_l92@X00_l92@X02?l94P[o2@T:o`T92_l92@[o
0000o`TB2_l92@[o2A8:0ol92@X00ol0003o2A8:oa4L2P04o`T92P03oa4L
2_l92@[o2@T:00?o2@T:00?o2A8:o`T92_l92@X01_l92@X01?l94P[o2@TD
o`TB2_l94PX2o`T92P;o2A8:0ol92@X02Ol94P[o2@T:o`T92_l92@[o0000
o`T92_l94P[o2@T:o`TB2P04o`T92P03o`TB2_l92@[o2A8:00;o2A8:00?o
4A`:oh>4S_ooool0G_ooool01?n_[joobl_;omkNg_oZj^X1oo;blP00ooo^
k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o3eJ_oj?2i?nhdnooMjk[
00;oZ]oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h2o`TB2P08o`T92_l94P[o
2@TDoa4L2_lA9QCo2@TDoaXB5?l94PX;o`T92P07o`000?lA70[o2@T:o`00
0?l94P[o2@T:o`TB2P02o`0000;o2@T:00So2A8:o`T92_l0003o2A8:o`T9
2_l0003o2A8:o`0000;o2@T:00Ko0000o`T92_l0003o2A8:o`T92_l94PX8
o`T92P0:o`000?l94P[o2@T:o`T92_l0003o2@T:o`000?l94P[o0000o`TB
2P?o2@T:0_l000001ol94P[o2@T:o`TB2_l92@[o0000oa4L2_l000000_l9
4PX2o`T92P;o000000Oo2A8:o`T92_l0003o2@TDo`T92_l0003o2@TD00;o
2@T:0ol000001OlJ71ko6Q8Do`T92_l94P[o000000?o2@T:00?o0000o`TB
2_l000000_l92@X01_l0003o2A8:o`T92_l92@[o2A8:o`0000Co2@T:00?o
0000o`TB2_l000000_l92@X00ol0003o2A8:o`T92P03o`T92P03o`TB2_l9
2@[o2@T:00So2@T:0_lJ2@X02ol/4P3o8a`:ob<L2_lJ2@[o8a`:oaX92_lA
70[o6PT:o`T92_lS70[o;18000oo2@T:00_o0000o`T92_l92@[o2@T:o`00
0?lA70[o0000o`TB2_l92@[o0000oa4L2P02o`T92P;o2A8:00Co2@T:o`00
0?l94P[o2A8:0ol92@X00ol0003o2@T:o`T92P03o`T92P03o`000?l94P[o
2@T:00Go2@T:00?o2A8:o`T92_l92@X01_l92@X01Ol94P[o2@T:o`T92_l9
4P[o000000;o2@T:00Go2@TDo`T92_l92@[o0000o`TB2P02o`T92P03o`TB
2_l92@[o4A`:00?o2@T:00ko6Q8Do`T92_l94P[o4A`:o`TB2_l92ACo2@T:
o`TB2_l92@[o2A8:oaXB5?l92@[o;180oiF4SUook^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN400?ooi^KV6OoVi^H02OoJf][odm?ColS8b?ng]kOoWIfM
o`mE[onUa>Ko^M?_ogN^j`02ojWLo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV
00?o6Q8DoaX92_l94PX00_l94PX01_lJ4QCo6Q`No`T95?l94P[o2@T:o`TB
2P;o2@T:00Co2A8:o`T92_l92@[o2A8:0_l92@X2o`TB2P08o`T92_l0003o
2@T:o`T92_l94P[o0000o`T92_l94PX3o`T92P03o`000?l92@[o2@T:00?o
2@T:00Ko0000o`TB2_l92ACo0000o`T92_l94PX2o`T92P07o`000?lA9QCo
6Q8Do`T92_l94P[o2@T:o`000003o`T92P04o`000?l92@[o2A8:o`0000Oo
2@T:00Ko2@TDo`000?l92@[o2@T:o`TB2_l00004o`T92P07o`TB2_l0003o
0000o`TB2_l0003o2@T:o`000002o`T92P?o2A8:00_o2@T:o`000?l94P[o
2@T:oa4L2_l94P[o2@T:o`000?l99RWo6PT:o`000002o`TB2P03o`T92_l0
003o2@T:00?o2@T:00?o4A`:o`000?l92@X01?l92@X2o`TB2P04o`000?l9
4P[o2@T:o`0000?o2@T:00?o2A8:o`T92_l92@X02?l92@X02OlJ2@[o0000
ob<L2_lm4P[o6PT:o`T92_lJ2@[o8a`:oaX92P02ob<L2P03oaX92_lS70[o
8a`:00;o6PT:00?o6Q8Dob`B0?lJ2@X00ol92@X00ol94P[o2@T:o`T92P06
o`T92P09o`TB2_l92@[o2@T:oa4L2_l94P[o2@T:o`TB2_l92@[o000000Ko
2@T:0_l94PX5o`T92P03o`TB2_l92@[o2@T:00;o2@T:00?o4A`:o`T92_l9
2@X01Ol92@X00ol94P[o2@T:o`T92P02o`T92P04oaX92_l92@[o2@T:o`TB
2P;o2@T:0_l94PX5o`T92P03oa4L2_l92@[o2@T:00?o2@T:00?o2A8:o`T9
2_l92@X01?l94PX00ol92@[o2A8:o`TB2P02o`T92P03o`T95?l92@[o4A`:
00;o2A8:00Ko2@TDo`T92_l94P[o2A8:o`000?n3Q8iOonKViP04oifMWOng
]kOob<S8om?Cd`7of][J003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfm
oj>SXol;E;7oY<CVokWCkomf[NX00_n[h?l01?m^KVko];Bdon3Ph?o/k>aK
onk^kP03oaXB5?l971Co6Q8D00;o2A8:00?o2@T:ob<_7_lJ71h00ol94PX0
1Ol92@[o2A8:o`TB2_l92@[o6Q8D00;o2A8:00So2@T:o`000?l92@[o2A8:
o`T92_l94P[o0000o`T92P;o2A8:00_o0000o`TB2_l94P[o2A8:o`T92_l9
4P[o2@T:o`TB2_l0003o2A8:o`000003o`T92P05o`TB2_l0003o2A8:o`T9
2_lA70X00_l92@X00ol94P[o2@T:oa4L2P05o`TB2P;o2@T:00?o4A`:o`T9
2_l94PX01?l92@X01Ol94P[o2@T:o`TB2_l94P[o000000?o2@T:00?o2A8:
o`T92_l000001?l92@X03?l94P[o2@T:o`TB2_l94P[o0000oaX92_l94P[o
0000o`T92_l94P[o0000o`T92P;o00000_l92@X3o`TB2P05o`000?l92@[o
2@T:o`TB2_l92@X00ol94PX02_l0003o2A8:o`T92_l94P[o0000o`T92_l9
4P[o0000o`TB2_l00002o`T92P04o`TB2_l0003o4A`:o`0000;o2@T:00?o
4A`:o`000?l94PX00_l92@X01?l0003o4A`:o`T92_lJ2@X2ob<L2P;o;180
00GoEa`0ob`B0?lJ2@[o;180ob<L2P02oaXB50;o4A`:00Ko;1`Doa4L2_lS
70[o2@T:ob<L2_lA70X2o`T92P03o`000?l94P[o2@T:00;o2@T:0_l94PX5
o`T92P03o`TB2_l0003o2@T:00;o2@T:00?o2A8:o`T92_l92@X00_l92@X2
o`TB2PCo2@T:0_l94PX2o`T92P05o`TB2_l92@[o2@T:o`T92_lA70X00_l9
2@X2o`TB2P09o`T92_l94P[o2A8:o`T92_l0003o2A8:oa4L2_l94P[o2@T:
00;o2A8:00Go8blYo`T92_l92@[o2A8:o`000004o`T92P04o`TB2_l92@[o
2@T:o`TB2P;o2@T:00Co2A8:o`T92_l94P[o2A8:0_l92@X01Ol94P[o2@T:
o`TB2_l92@[o000000?o2@T:00_o4A`:o`TB2_l92@[o2A8:oaXB5?l92ACo
2A8:o`T95?l0003o6PT:oh>4SP1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q003ooooooaWooooo00Wol_;bon[Zj_oNg]kobl_;ojn_[ol;DjkoYLCV
okG@k_mi[^`00_nWg?l01?mfMWKo`L71oo3`l?omoOeKooooo`03oa4V5?lA
70[o2@TD00;o2A8:0ol92@X00ol94P[o2@TDo`TB2P03o`TB2P04o`T92_l9
2ACo2@TDo`0000?o2A8:00?o0000o`TB2_l94PX00ol92@X00ol0003o2A8:
o`TB2P02o`TB2P06o`T92_lJ2@[o2A8:o`000?lA70[o00000ol92@X01ol0
003o2@T:o`T92_l92@[o0000o`TB2_l92@X00_l94PX2o`T92P0:o`000?l9
2ACo0000o`T95?l0003o2A8:o`T92_l0003o2A8:oa4L2P;o2@T:00Go2A8:
o`T92_l94P[o0000o`T92P02o`TB2PCo2@T:00Co0000oa4L2_l92@[o2A8:
0_l92@X01Ol0003o2A8:o`T92_l92@[o000000Co2A8:0_l92@X01Ol94P[o
2@T:o`000?lA70[o2@T:00?o000000Co2@T:o`000?lA70[o00000_l94PX0
1_l0003o2@T:o`T92_l0003o2@T:o`0000?o2A8:0ol92@X00ol0003o4A`:
o`000003o`T92P04o`000?l94P[o0000o`TB2PCo2@T:00Ko6PT:oa4L2_lJ
2@[o;180ocdB2_m69PX2ocdB2P0Bob`B0?l/71Co8a`:ob<L2_l/9QCo;1`D
oaX92_l/71Co6RHDob<L2_l/71Co4A`:ob`L5?lA9QCo2@T:o`TB2_l92@[o
00000_l94PX2o`T92P05o`000?l94P[o2@T:o`T92_l94PX00ol92@X01?l9
4P[o2@T:o`T92_l00009o`T92P03o`TB2_l92@[o2@T:00;o2@T:0_l94PX0
2Ol92@[o4A`:o`T92_l94P[o4A`:o`TB2_l92@[o4A`:o`T92P03o`TB2PCo
2@T:00co2A8:o`T92_l0003o2A8:o`T92_l94P[o2@T:o`TB2_l92@[o2A8:
o`T92_l94PX2o`T92P03o`TB2_lJ2@[o2A8:00;o2@T:00Ko2A8:o`T92_l9
2@[o2@T:o`TB2_l92@X5o`TB2P?o2@T:00Ko4A`:o`T92_lJ4QCo2@TDo`T9
2_l94PX2o`T92P03ohfHS_oooooooooo05gooooo00Co[jn_ol_;booNg]ko
j^[Z0Oobl_800?ook^k^6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`]D
/OnTa>Ko^=;^ogJ]jP02ojcOo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00co
6Q8Do`T95?lJ4QCo2@TDo`TB2_lA70[o2@T:o`TB2_l92@[o2A8:o`TV:OlJ
4Q@6o`TB2P04o`T92_l0003o0000o`TB2P;o2@T:00?o0000o`TB2_l92@X0
0_l92@X02Ol94P[o2@T:o`TB2_l92@[o0000o`TB2_l0003o2A8:o`000002
o`TB2P03o`T92_l94P[o2@T:00;o2A8:00?o2@T:o`TB2_l92@X00_l94PX0
0ol92@[o4A`:o`T92P02o`TB2P?o2@T:00Go0000o`T92_l92@[o2@T:o`TB
2P02o`T92P06o`000?l94P[o2@T:o`T95?l94P[o00001Ol92@X01?l0003o
2A8:o`T92_l00003o`T92P04o`TB2_l92@[o2A8:o`T92P?o000000Oo2A8:
o`000?l92ACo2A8:o`T92_l0003o2A8:00?o2@T:00So4A`:o`T92_l0003o
2A8:o`T92_l94P[o0000o`TB2P?o2@T:00Go0000o`TB2_l92@[o0000o`TB
2P03o`T92P06o`000?l92ACo2A8:o`000?l92@[o2A8:0_l92@X01Ol94P[o
0000o`T92_l92@[o4A`:00;o6PT:00?o;180ocdB2_lm4PX00_lm4PX04Om6
9P[o;180ocdB2_lJ4QCo;1`DoaXL7_lJ2@[o4A`:oaXV5?lJ71ko4A`:oaXL
7_lJ2@[o4BH:o`TB2_l92@[o2A8:00?o2@T:00Co0000o`TB2_l92@[o2A8:
0_l92@X01ol94P[o2@T:oa4L2_l92@[o2A8:o`T92_l94PX03?l92@X01ol9
4P[o2@T:oa4L2_l92@[o0000o`TB2_l92@X00ol94PX00ol0003o2A8:o`T9
2P04o`T92P03oa4L2_l92@[o2@T:00Co2@T:00Co2A8:o`T92_l94P[o2A8:
0ol92@X2o`TB2Pgo2@T:00?o4BHDo`T92_l92@X01_l92@X2o`TB2P07oa4L
2_l92@[o2A8:o`TB2_lJ4QCo2@T:oh>4SP1Oonk^kP04oj>SXonm_Kgoclo?
om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?Cdoo8b<So]kNgoifMWOl=
E:koY/KVokK@k_mi[nh00_n[g_l01?mZJV[o[Zj^omSHf?oTi>AKonKViP03
o`TB2_lJ4QCo2@TD00?o2A8:00Go6Q8Do`T92_l92@[o;1`Do`TB2P04o`T9
2P;o6Q8D00?o2@TDo`T92_l92@X01_l92@X01_l94P[o0000o`TB2_l0003o
2@T:o`0000;o2@T:00[o0000o`T92_l92@[o2A8:o`T95?l0003o2A8:o`00
0?l94P[o00000ol92@X01?lA70[o2@T:o`T92_lA70X2o`T92P03o`TB2_l0
003o2@T:00;o2@T:00?o4A`:o`000?l92@X00_l94PX2o`T92P04o`000?l9
2@[o2@T:o`TB2P;o2@T:00_o2A8:o`T92_l92@[o0000o`TB2_l0003o2@T:
oa4L2_l0003o2@T:o`TB2P02o`000004o`T92_l0003o2@T:o`T92P;o2A8:
00Co0000o`TB2_l0003o2@T:0_l94PX01?l0003o2@T:o`TB2_l92@X2o`00
00;o2@T:00?o0000o`T92_l92@X01?l92@X01_l0003o2@T:o`000?l94P[o
0000o`T92P;o000000Go4A`:o`000?l92@[o2A8:o`000003o`T92P06o`00
0?l92@[o2@T:oa4L2_l/4P3o2@T:1OlJ2@X3ocdB2P0=oaX92_lS70[o8bH:
ob<_7_lJ4QCo;1`DoaXL7_l/71Co6Q8Dob`L5?lJ4QCo4A`:o`000006o`T9
2P03o`TB2_l0003o2@T:00?o2@T:00Co0000o`T92_l92ACo00000ol92@X0
0ol94P[o2@T:o`T92P05o`T92P04oa4L2_l92@[o2@T:oaX92POo2@T:00Go
2A8:o`T92_l94P[o2@T:o`TB2P07o`T92P05o`TB2_l92@[o2@TDo`TB2_l0
00000ol92@X01?lA70[o2@T:o`TB2_l94PX4o`T92P05o`TB2_l92@[o2@T:
o`T92_lA70X01?l92@X00olA70[o2@T:o`T92P02o`T92P03o`TB2_l92@[o
2@T:00;o2@T:00?o2A8:o`T92_l92@X00_l92@X01?l94P[o0000oaX92_n3
Q8iOonKViP04oifMWOng]kOob<S8om?Cd`7of][J003oonk^kQWok^k^00Wo
hN7Qom[Jf_o?cloo_Kfmoj>SXol:DJkoY<?UokSBkomi[^`00_n/gol01?m^
KVko];Bdon3Ph?o/k>aKonk^kP03oaXB5?lJ71ko4A`:00;o2@T:00So6Q8D
o`TB2_l94P[o2@T:oa4L2_l92ACo4A`:o`TB2POo2@T:1?l94PX3o`T92P03
o`TB2_l92@[o2A8:00;o2A8:00Go0000o`TB2_l92@[o2@T:o`TB2P02o`00
00;o2@T:00?o2A8:o`000?l92@X01_l92@X2o`TB2P03o`T92_l94P[o2A8:
00;o2@T:00Co0000o`T92_l0003o2A8:0_l000002Ol92@[o2A8:o`T92_l9
2@[o2A8:o`000?l94P[o2@T:o`000002o`T92P05o`000?l92@[o2@T:o`TB
2_l000001Ol92@X00ol94P[o2@T:o`T92P02o`000004o`TB2_l92ACo2@T:
o`T92P;o00000_l92@X2o`0000;o2@T:00So0000o`T92_l94P[o2@T:o`00
0?l94P[o0000o`TB2PGo2@T:00Oo0000o`T92_l92@[o2@T:oa4L2_l0003o
2A8:00[o2@T:0olJ2@X01?l92@[o6PT:ob<L2_lA70X2ob<L2P0<ocdB2_lJ
9QCo6Q8DoaXL7_l/71Co2@TDoaXB5?l/9QCo6PT:ob`L5?lS;ako6Q8D0ol9
2@X00ol0003o2@T:o`TB2P07o`T92P04o`TB2_l92@[o2@T:o`TB2PGo2@T:
00?o0000o`T92_l92@X00ol92@X01?l0003o2@T:o`T92_lA70X9o`T92P03
o`000?l92@[o2@T:00Ko2@T:00?o2A8:o`T92_l92@X00_l92@X00olJ4QCo
2@T:o`T92P03o`T92P03o`TB2_l0003o2@T:00;o2@T:00?o2A8:o`T92_l9
2@X00_l92@X01?l92ACo2A8:o`TB2_l94PX2o`T92P03oa4L2_l92@[o2@T:
00;o2@T:00?o2A8:o`T92_l94PX01Ol92@X01_l94P[o6Q8Do`T95?l92@[o
0000oh>4SUook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400?oooooo6Ooo
ool02Oobl_;oj^[ZomkNg_o;bl_o[jn_o`eD[_nUa>Ko]];^ogV^j@02oj[P
o`04ogIfM_o1`L7ol?3`oogmoE_ooooo00So2@TDo`TL5?l94P[o2A8:oa4L
2_l92@[o2@TDo`T92P;o2A8:00?o0000o`TB2_l94PX01?l92@X00ol94P[o
2@T:o`T92P02o`0000;o2@T:00Oo0000o`T92_l0003o2@T:o`000?l92@[o
000000;o2A8:00?o0000o`T95?l94PX01Ol92@X01_l0003o2A8:o`000?l9
4P[o2@T:o`TB2P;o2@T:0_l94PX00ol92@[o2A8:o`T92P03o`TB2P03o`T9
2_l94P[o2@T:00?o2@T:00Co2A8:o`T92_l0003o2A8:0_l92@X2o`TB2P03
o`T92_l0003o2@T:00;o2@T:00go0000o`T92_l92@[o2@T:o`000?l94P[o
2@T:o`000?l92@[o0000o`TB2_l92@[o2A8:00;o000000?o2@T:o`000?lA
70X01Ol92@X01?l0003o2@T:o`T92_l92@X2o`000004oa4L2_l0003o2A8:
o`0000?o2@T:00?o0000o`TB2_l92@X00_l92@X01?l94P[o0000o`TL5?l0
0004o`T92P05oa4L2_l92@[o0000o`TB2_l92@X00_lA70X2o`T92P03oaX9
2_lA70[o2@TD00?o6PT:00oo4A`:oaXB5?l/71Co6Q`Nob<_:Ol/71Co8blc
ob<_7_lJ71ko=2lYob`V5?lA9QCo2@T:o`000?l94PX00_l92@X01OlJ4QCo
2@T:o`T92_l92@[o2A8:00;o2@T:00Ko6Q`No`000?l94P[o2@T:o`000?l9
2@X2o`TB2Poo2@T:0_l94PX3o`T92P05o`TB2_l92@[o2@T:o`T92_l94PX0
0_l92@X01ol94P[o2@T:o`TB2_l94P[o2@T:o`TB2_l92@X00_l94PX01?l0
003o2A8:o`TB2_l94PX4o`T92P04o`TB2_l92ACo2@T:o`T92P;o2A8:00?o
6PT:o`TB2_l92@X00_l94PX3o`T92P?o2A8:0ol92@X01?l92ACo2@T:o`TB
2_lJ2@X2o`T92P06oa4L2_l94P[o2@T:oa4L2_lJ2@[oUHAkGoooool01?n_
[joobl_;omkNg_oZj^X1oo;blP00ooo^k^hIonk^kP09on7QhOoJf][oclo?
okfm_OnSXj?o2e>^ojK6i_nidnkoNJk[00;oZmoo00CoKVi^okBd]?oPh>3o
k>c/Foo^k^h02_l94P[o6Q8Do`TB2_l92@[o2A8:o`T92_lS;bWo2@T:o`TB
2_l92@X2o`TB2P;o2@T:00Ko2A8:o`T92_l92@[o2A8:oa4V7_l92@X3o`TB
2P03o`T92_l94P[o2A8:00?o2@T:00co2A8:o`T92_l92@[o0000o`TB2_l0
003o2A8:o`000?l92@[o2A8:o`T92_l94PX2o`T92P05o`TB2_l92@[o2@T:
o`000?l94PX00ol92@X00olA70[o0000o`TB2P02o`T92P0>o`000?l92@[o
2@T:o`000?l94P[o2@T:o`TB2_l0003o2@T:o`TB2_l0003o2A8:o`T92_l9
4PX2o`T92P05o`TB2_l0003o2A8:o`000?lA70X00_l000002ol94P[o2@T:
o`000?l94P[o0000o`TB2_l0003o2A8:o`T92_l0003o2A8:00?o2@T:00Co
2A8:o`000?lA70[o00000_l92@X00ol94P[o2@T:o`T92P02o`T92P04o`TB
2_l92@[o2@T:o`0000;o2@T:00Go2A8:o`T92_l92@[o2@T:o`000002o`T9
2P05o`000?l92@[o6PT:o`TB2_lA70X00ol92@X00ol0003o2@T:o`000003
o`T92P;o6PT:00[o4A`:o`T92_lJ4QCo2A`Doa4L2_l/71Co4BHDoaX92_lJ
4QCo8blN0olS;bT01Ol/>2Wo8blYob<_:Ol/>2Wo8blN00Go2@T:00?o0000
o`TL5?lA70X00ol92@X01?l92ACo2A8:o`T92_l94PX3o`T92P03o`TB2_l9
2@[o2@T:00Ko2@T:00Go2A8:o`T92_l92@[o2@T:o`TB2P05o`T92P03o`TB
2_l92@[o2A8:00;o2@T:00Wo0000o`TB2_l92@[o2@T:o`TB2_l92@[o2A8:
o`T92_l94PX00_l92@X00ol94P[o2@T:o`T92P03o`T92P04o`TB2_l92@[o
2@T:o`TB2P;o2@T:00?o2@TDo`000?l/71@00_l92@X01Ol94P[o2@T:oh<_
0?niI`3o000000Ko2@T:013o2@TDo`T92_l92@[o2A8:o`T92_l0003o2@T:
o`000?l94P[o2@T:o`TB2_l92@[o2A8:oaXB5?l92@[oPhB>Goo^k^h01?nS
Xj?o_Kfmolo?cooJf]X1on7Qh@00oooVi^HIonKViP09om[Jf_oCdm?ob<S8
okNg]onMWIgo3eJ_oj?2i?nhdnooMjk[00;oZ]oo00CoJVYZojj^[_oHf=So
i>CTFooVi^H01?lJ4QCo4BH:o`TB2_l92@X3o`TB2P05o`TV:OlJ4QCo2@T:
o`T92_l94PX00ol92@X01Ol94P[o2@T:o`TB2_l971Co2BHY00;o000000Co
2@T:oa4L2_l0003o00001?l94PX01Ol92@[o2A8:o`000?l92@[o2A8:00;o
2@T:00Oo4A`:o`000?l94P[o0000o`T92_l94P[o000000;o2A8:00Ko2@T:
o`TB2_l92@[o4A`:o`000?l92@X2o`TB2P03o`T92_l94P[o2A8:00?o2A8:
00Ko2@T:o`TB2_l0003o2@T:o`TB2_l00003o`T92P;o2A8:00So2@T:o`00
0?l94P[o0000o`TB2_l0003o2@T:o`T950Ko2@T:00?o2A8:o`000?l92@X0
0ol94PX02_l0003o2A8:o`000?l92@[o2A8:o`T95?l92@[o2A8:o`000?l9
2@X2o`TB2PGo2@T:00Co4A`:o`T92_l94P[o2A8:0ol92@X01_lA70[o2A8:
oa4L2_l94P[o0000oa4L2PSo2A8:00Ko2@T:oa4L2_l92@[o4A`:o`T92_lA
70X2oaX92P06oaXL7_lS;bWo4BH:o`TB2_lJ4QCo8blc0_l/>2T01_ld;bWo
;3PYoc@_:Olm;cgo;3PYoaXV50?o2A8:00Co2@T:o`TB2_lA70[o00000_l9
4PX2o`T92P03oc@_:Ol0003o4A`:00;o2A8:00Ko4A`:o`T92_l92@[o2A8:
o`T92_l94PX4o`T92P05o`TB2_lA70[o2@T:o`T92_l94PX01Ol92@X01_l9
4P[o0000o`TB2_l94P[o2@T:o`TB2P?o2@T:1Ol94PX00ol92@[o2A8:o`T9
2P06o`T92P03oa4L2_l94P[o2@TD00;o2A8:00Ko2@TDo`000?nV@@3oooH0
oh<_0?mG7002oh<_0009onBZ0?ood03o?A8:o`T92_l0003o4A`:o`T92_lA
70[o2A8:00Co2@T:00?o8blYo`TB2_l94PX00_l94PX01ol92@[o6Q8Do`TB
2_l92@[o4BHDoaXB5?n3Q8h0GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[J
fP00ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o3eF_ojG4i_ni
dnooMjk[00;oZMco00CoKVi^okBd]?oPh>3ok>c/Foo^k^h00olJ4QCo2@T:
o`TB2P04o`TB2P06o`T92_lA70[o4A`:o`T92_l94P[o2@T:0_l94PX03_l0
003o2A8:o`TB2_l0003o6PT:o`TB2_l92@[o4A`:o`000?l92@[o2A8:o`T9
2_l94P[o00000_l92@X2o`TB2P;o2@T:0_l94PX00ol0003o2@T:o`T92P02
o`T92P04o`TB2_l92@[o2@T:o`T92P;o2A8:00?o2@T:oa4L2_lA70X00_l9
4PX2o`T92P03o`TB2_l0003o000000?o2@T:00Go4A`:o`T92_l92@[o2@T:
o`TB2P02o`T92P03o`TB2_l0003o2A8:00?o2A8:00Oo4A`:o`000?l92@[o
4A`:o`000?l92@[o2A8:00So2@T:00?o0000o`T92_l92@X00ol92@X2o`TB
2P06o`000?l92@[o2A8:o`000?l92ACo00001?l94PX00ol0003o2@T:o`T9
2P05o`TB2PGo2@T:00Co4A`:o`T92_l92@[o4A`:1?l92@X03ol94P[o0000
oa4L2_lA70[o2@T:oaX92_lA9QCo6Q8Doa4L2_lS;ako8bH:oa4L2_lJ71ko
8blNob`h:@07oc@_:@07o`TB2_l92@[o2@T:o`TB2_l92@[o2A8:o`000002
o`T92P04o`TB2_l92@[o2@T:o`TB2P;o2@T:00?o2A8:o`T92_l92@X00_l9
2@X01Ol94P[o2@T:o`T92_l92@[o2A8:00;o2@T:00?o2A8:o`T92_l92@X0
0ol92@X02?l94P[o2@T:o`T92_l94P[o2@T:oa4L2_l92@[o2A8:1Ol92@X0
1_l94P[o2@T:o`T92_l94P[o2@T:oa4L2P;o2@T:00?o4A`:o`T92_l92@X0
1?l92@X2o`TB2P07o`T92_lA70[o0000ok1<0?oof@3oom00oooI0002ooof
0006oooI0?ofa`[om[<0odHV2_l92@[o4A`:1?l92@X02olA70[o2A8:oa4L
2_l92@[o2A8:oaXB5?l94P[o2@T:oa4L2_l94P[o6Q8D00;o2A8:00?o2@TD
o`000?n3Q8h0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooooolI
ooooo`09oo;bl_oZj^[og]kNol_;bon_[joo2eBaojC4i_nidnooMZgZ00;o
Zn3o00CoMWIfol71`Oo`l?3ooOgmFoooool2o`TB2P03o`T92_l94P[o2@T:
00Co2@T:00Co2A8:o`T92_l94P[o4A`:1?l92@X04Ol0003o2@TDo`000?l9
4P[o2@T:o`000?l94P[o2@T:o`000?l92@[o0000o`T92_l0003o2A8:o`T9
2_l0003o2A8:00;o2@T:00Co0000o`TB2_l94P[o00000_l94PX02?l0003o
2A8:o`TB2_l92@[o0000o`TB2_l92@[o4A`:0_l92@X00ol94P[o2@T:o`00
0003o`TB2P0=o`T92_l94P[o2@T:o`000?l94P[o2@T:o`000?l94P[o2@T:
o`000?l94P[o0000o`T95004o`00000;o`TB2_l92@[o0000o`TB2_l92@[o
0000o`TB2_l92@[o0000o`T92_l94PX00_l92@X02Ol0003o2@T:o`T92_l9
2@[o2A8:o`T92_l0003o2@T:o`000002o`TB2P06o`000?l92@[o0000o`T9
2_l94P[o2@T:0_l000000ol92@[o2A8:o`000002o`T92P06o`000?l94P[o
0000o`TB2_l92@[o2A8:2?l92@X02_l0003o2@T:o`000?l92@[o0000oaX9
2_lA70[o0000oaXB5?lA70X4oaXB5004ob`L5?l/>2Wo;3PYoc@_:@;o=2lc
0old;bT02?lS;ako2@T:o`T92_l92@[o0000o`TB2_l0003o2A8:0_l92@X0
0ol0003o2A8:o`T92P03o`T92P03o`000?l94P[o2@T:00Ko2@T:00Go0000
o`TB2_l92@[o0000o`TB2P04o`T92P06o`000?l94P[o2A8:o`000?l92@[o
00000_l92@X00olA70[o2@T:o`T92P02o`T92P03o`000?l92@[o2@T:00Ko
2@T:00Oo0000oa4L2_l92@[o0000o`TB2_l92@[o000000?o2@T:00co2A8:
ocdB2_o1Q03oYW80oh=10?mb>03o?A8:ob`B0?oCQ03oom00ocdB2_l94PX3
o`T92P03o`T95?l/>2Wo000000?o2@T:00Go4A`:o`T92_l94P[o2@T:o`00
0002o`T92P05o`TB2_l92@[o2A8:o`000?nEQ8h0Goooool01?n_[joobl_;
omkNg_oZj^X1oo;blP00ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnS
Xj?o2e>^ojG4i_ned>koNJk/00;oYmco00CoKVi^okBd]?oPh>3ok>c/Foo^
k^h00ol92ACo2A8:oaXB5004o`TB2P?o2@T:0_l94PX6o`T92P0Ao`TB2_l9
2@[o2A8:o`000?l94P[o0000o`TB2_l92@[o4A`:o`T92_l0003o2A8:o`T9
2_l0003o2A8:o`000?l94PX00ol92@X01Ol0003o2A8:o`000?l0003o2A8:
00;o00000ol94PX3o`T92P03oa4L2_l92@[o2A8:00;o2@T:0_l000000ol9
4P[o0000o`TB2P07o`T92P04o`000?l94P[o2@T:o`0000;o2A8:00Go2@T:
o`000?l94P[o0000o`TB2P03o`T92P03o`000?l94P[o2@T:00;o000000Co
2A8:o`T92_l94P[o00000_l92@X01?l0003o2A8:o`000?l94PX2o`T92P05
o`TB2_l0003o4A`:o`T92_l94PX01?l92@X00ol0003o2A8:o`T92P04o`T9
2P06o`000?l94P[o0000o`TB2_l92@[o2A8:1ol92@X00ol94P[o2@T:oa4L
2P02o`T92P08oa4L2_l92@[o6Q8DoaXB5?lJ2@[o4BH:ob<_7_lS;c<3oc@_
:@03oc@_<om6C3go=2lY00;o8blc00?o;1`Do`T92_l92@X00_l92@X01?l9
4P[o2@T:o`T92_l00003o`T92P03o`000?l94P[o2@T:00;o2@T:00?o2A8:
o`T92_l92@X00ol92@X00ol94P[o2@T:o`T92P05o`T92P03oa4L2_l92@[o
2@T:00Go2@T:00?o4A`:o`T92_l92@X01Ol92@X01?lA70[o2@T:o`T92_l9
4PX8o`T92P0:oa4L2_l92@[o2@T:oa4L2_l92@[o2A8:oa4L2_l92@[o2A8:
o`T950;o000000Oo2@TDo`T92_l92ACo2@T:oaX92_l94P[o2@T:00?o2A8:
00?o6Q8Do`T95?l92@X00ol92@X01Ol94P[o2@T:o`T92_l94P[o000000;o
2A8:00Go2@T:oaXB5?lA70[o0000oiFHX`1Oonk^kP04oj>SXonm_Kgoclo?
om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?Cdoo8b<So]kNgoifMWOl;
E;7oY<CVokSBk_mf[NX00_n/gol01?mZJV[o[Zj^omSHf?oTi>AKonKViP03
o`TB2_l92@[o2@TD00;o2@TD0_l92@X02?l92ACo2@T:o`T92_l92@[o2A8:
o`T92_l92ACo2A8:0ol92@X01Ol0003o2@T:o`T92_l94P[o000000Ko2@T:
00?o0000o`T92_l92@X00_l92@X00ol0003o2@T:o`T92P04o`T92P09o`TB
2_l0003o2@T:o`TB2_l0003o2@T:o`TB2_l92@[o2A8:00;o2@T:00?o4A`:
o`T92_l92@X00_l92@X00ol94P[o0000o`T92P06o`T92P04o`000?l92@[o
2@T:o`0000;o2@T:00?o0000o`T92_l000001Ol92@X01?l0003o2@T:o`T9
2_l00002o`TB2P;o2@T:0_l00002o`T92P07o`000?l92@[o0000o`T95?l0
003o2@T:o`000002o`T92P;o00000ol92@X00ol0003o2A8:o`000004o`T9
2P03oa4L2_l0003o2@T:00Co2@T:00?o4A`:o`T92_l000002Ol92@X00olA
70[o6PT:o`T92P02oa4L2P;o6Q8D00co;2HDob<_7_ld;bWo=2lcoc@_:Old
;c?o;3PYoc@_:Ol/>2Wo8blYoa4V5?l00005o`T92P03o`000?l92@[o2@T:
00ko2@T:00Go4A`:o`T92_l0003o2@T:oa4L2P03o`T92P03o`TB2_l92@[o
2@T:00Co2@T:00?o0000o`T92_l000000ol92@X00ol0003o2@T:o`T92P02
o`T92P04oa4L2_l0003o2@T:oa4L2PGo2@T:00?o0000o`T92_l92@X01ol9
2@X01_l94P[o2@T:o`TB2_l92@[o0000o`TB2P?o2@T:00Co4A`:o`T92_l9
2@[o4A`:1ol92@X01?l94P[o2@T:o`T92_l92@X2o`TB2P;o2@T:00?o0000
oiFHXooVi^H0G_oVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00ooo^k^hI
onk^kP09on7QhOoJf][oclo?okfm_OnSXj?o3EB^ojK6i_nfd>koNJo^00;o
Zmko00CoKVi^okBd]?oPh>3ok>c/Foo^k^h2o`TB2P0=o`T95?l94P[o2A8:
o`TB2_l92@[o2A8:o`T92_l94P[o2@T:o`TB2_l92ACo2@T:o`TB2P02o`T9
2P?o2A8:00?o0000o`T92_l92@X00ol92@X01?l92ACo2@T:o`T92_l94PX3
o`T92P03o`TB2_l92ACo2@T:00;o2@T:0_l94PX:o`T92P08o`TB2_l92@[o
2@T:o`TB2_l92ACo2@T:o`TB2_l00003o`T92P04oa4L2_l0003o2@T:o`TB
2P?o2@T:00Go2A8:o`T92_l0003o2@T:o`TB2P05o`T92P0:o`TB2_l92@[o
2@T:o`T92_lA70[o2A8:o`000?l94P[o2@T:o`TB2PKo2@T:00Go2A8:o`T9
2_l94P[o0000o`TB2P02o`T92P07o`TB2_l92@[o2A8:o`000?l94P[o0000
o`TB2P06o`T92P07o`000?l92@[o2@T:o`T95?l92@[o2A8:oa4L2P06o`T9
2P03o`TB2_l92@[o2@T:00;o2@T:0_lJ4Q@02_lA70[o6PT:oaX92_lJ4QCo
6Q`Nob`L5?l/>2WoAT4Nocd_?Om6@Ah2oc@_<`07ocd_?Ol/>2Wo8blNo`T9
2_l94P[o2@T:o`TB2P03o`T92P03o`TB2_l92@[o2@T:00;o2@T:00Co0000
o`T92_l92@[o2A8:2_l92@X00ol94P[o0000o`T92P03o`T92P03oa4L2_l9
4P[o2@T:00Oo2@T:00?o2A8:o`T92_lA70X03ol92@X2o`TB2PGo2@T:00_o
4A`:o`T95?l92@[o4A`:o`T95?l92@[o4A`:o`T95?l94P[o4A`:o`T92P02
o`TB2P;o2@TD00?o2A8:o`T92_l92@X00ol92@X00ol94P[o4A`:o`TB2P03
o`T92P05oa4L2_l92ACo2@TDo`000?nEQ8h0Goo^k^h01?nSXj?o_Kfmolo?
cooJf]X1on7Qh@00oooooolIooooo`09oo;bl_oZj^[og]kNol_;bon_[joo
2U6^ojC3iOnhd^ooNJk/00;o[=oo00CoMWIfol71`Oo`l?3ooOgmFoooool2
o`TB2P03oa4L2_l92@[o2@T:00?o2A8:0_l92@X2o`TB2P03oaXB5?l92@[o
2A8:00;o2@T:00?o0000o`T92_l92@X00ol92@X02Ol0003o2@T:o`T92_l9
2@[o0000oa4L2_l92@[o0000o`TB2P02o`T92P06o`000?l94P[o2@T:o`T9
2_l0003o2A8:0ol92@X02Ol0003o2@T:o`TB2_l92@[o2A8:o`000?lA70[o
2A8:oa4L2P02o`T92P03o`TB2_l0003o2@T:00Co2@T:00go2A8:oa4L2_l9
2@[o2@T:oa4L2_l0003o2A8:o`T92_l0003o2A8:o`T92_l0003o2A8:00Go
2@T:00?o0000o`TB2_l92@X00_l000001OlA70[o0000o`TB2_l0003o2A8:
00;o2@T:00So0000o`T95?l0003o2@T:o`000?l92ACo2@T:o`0000;o2@T:
0_l000001ol92@[o0000o`T92_l92@[o0000o`TB2_l000001?l92@X01OlA
70[o2@T:o`000?l92@[o4A`:00Co2@T:00Oo2A8:o`T92_lA70[o2@T:oaX9
2_lA70[o2@T:00;o4A`:0_l92@X02OlJ4QCo4A`:oa4L2_lJ2@[o6Q8Dob<_
<old;ako=2lcocd_?@03oc@_<`;o;3PY00?o6Q8Do`TB2_l000000_l92@X0
2?l0003o4A`:o`T92_l0003o2@T:o`TB2_l92@[o2@TD0ol92@X00ol94P[o
2@T:o`T92P04o`T92P03oa4L2_l92@[o2A8:00;o2@T:00Co6PT:o`T92_l9
2@[o4A`:1?l92@X01?lA70[o2A8:o`T92_lA70X3o`T92P03oaXB5?ld;bWo
6Q8D00Co2@T:00?o2A8:o`T92_l92@X01Ol92@X01?lA70[o2@T:o`T92_lJ
2@X2o`T92P06oa4L2_l92@[o2@T:oa4L2_l92ACo00001?l92A@00ol94P[o
?A8:oh<_0002o`TB2P04o`T92_l92ACo2@TDoa4L2P;o2@T:00Co2A8:o`T9
5?l94P[o2A8:0_l92@X02Ol94P[o2@T:oa4L2_l92@[o6Q8Doa4L2_lA9Qko
0000oiFHX`1Oooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b003oonk^kQWo
k^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol=E:koYLCVokKBk_mi[^T00_nZ
h?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP03o`T95?lA70[o2@TD00;o2A8:
00?o2@T:o`TB2_l94PX01?l92@X00olJ71ko4A`:o`T92P03o`T92P05o`TB
2_l92@[o2@TDo`T92_lA70X00_l92@X2o`TB2P?o2@T:00?o2A8:o`T92_l9
2@X00ol92@X2o`TB2PGo2@T:00Go2A8:o`T92_l92@[o2A8:o`T92P02oa4L
2P03o`T92_lJ2@[o4A`:00Wo2@T:00?o2A8:oa4L2_l92@X02_l92@X01?l0
003o4A`:oaXB5?l94PX2o`T92P03o`000?l92@[o2A8:00;o2@T:00Go2A8:
o`000?l92@[o2@T:o`TB2P03o`T92P;o2A8:0ol92@X01?l94P[o2@TDo`T9
2_l94PX3o`T92P03oa4L2_l92@[o2@T:00So2@T:01;o4A`:o`T92_l92@[o
2@T:o`TB2_lA70[o6PT:ob`B0?lJ2@[o;180odHV2_lm4P[o6Q8DoaX92_l9
2@[o6PT:oa4L2_lJ4Q@3oaX92P06ob<_:Ol/71Co=2lYocd_?Old;c?oAT`m
0_ld;c<2ob`h:@03o`T95?l94P[o2A8:00Co2@T:00?o2@TDo`T92_l94PX0
0olJ4Q@01?l94P[o2@T:o`T92_l92@X2oa4L2Pgo2@T:00?o2@TDoa4L2_l9
2@X02?l92@X01?lS;c?o2@T:o`T92_lA70X7o`T92P03o`TB2_l92@[o2A8:
00Ko2@T:01?o4A`:o`T95?lJ4QCo4A`:o`T92_l92ACoPbl0oonc0?mb>1Co
0000oc@_7_l/4P3odh@0oooI0?lm4P[o2@T:oa4L2_l92ACo6Q8D00;o2@T:
00Co4A`:o`TB2_l92@[o6Q8D0ol92@X02OlA70[o2@T:o`T95?l92@[o6PT:
oa4L2_l92ACo0000oiF4SP1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
003oonKViQWoi^KV00Wof][Jom?Cdoo8b<So]kNgoifMWOl;DjkoY/KVokWC
k_mi[^/00_n[gol01?mZJV[o[Zj^omSHf?oTi>AKonKViP03o`T95?l94P[o
2A8:00;o2A8:0ol92@X00ol94P[o2@T:o`TB2P02o`T92P?o2A8:00_o2@T:
o`TB2_l0003o2A8:o`000?l94P[o0000o`TB2_l0003o2A8:o`000002o`TB
2P0Bo`000?l94P[o0000o`TL5?l0003o2@T:o`TB2_l0003o2@T:o`TB2_l0
003o2A8:o`000?l94P[o0000o`T92_l94P[o00000_l94PX3o`T92P05oa4L
2_l94P[o2@T:o`000?l92@X00_l94PX01_l0003o4A`:o`T92_lA70[o2@T:
oa4L2P?o2@T:00Co2A8:o`000?l94P[o2A8:0_l92@X01Ol94P[o0000o`TB
2_l971ko000000;o2A8:0ol92@X02_l0003o2A8:o`000?l92ACo0000o`TB
2_l0003o2A8:o`000?l94PX2o`000006o`T92_l94P[o0000o`000?l92@[o
00000_l92@X2o`TB2P03o`000?l92@[o2@T:00Co2@T:013o2A8:o`T92_l9
2@[o4A`:oaX92_l92@[o4A`:o`TB2_l/4P3o6PT:odHV5?m69P[o;1`DocdB
2_mP;`[oEa`00_l/4P000olA70[o6PT:oa4L2P02oaX92P07oa4L2_l/71Co
6Q`Nob`V5?ld;c?o=5DYocd_?@02oc@_<`08ob`h:OlS;bWo6RHDoa4L2_l9
4P[o0000o`T92_l94PX2o`T92P09o`T95?l94P[o2A`Do`T95?l92@[o6Q8D
o`000?l94P[o2@T:00;o2A8:2?l92@X00ol94P[o2@T:o`T92P02o`TB2P;o
2@T:00co2A8:oa4L2_l94P[o2A8:oa4L2_l92@[o4A`:o`TB2_l92@[o0000
ocd_?Ol94PX3o`T92P04oa4L2_l94P[o2@T:o`TB2PCo2@T:00?o2A8:o`T9
2_l92@X00ol92@X2o`TB2P0>oaXB5?l92@[o2A8:o`T95?mb9P3oi:X0ooo@
0?oTZP3om[<0ooo@0?oof@3om[<0ooK72_lm4PX3o`TB2P04o`T92_lA70[o
2@T:o`T92P;o2A8:00?o2@T:oa4L2_l92@X01Ol92@X01OlA70[o2@T:oa4L
2_l92@[oPhB>05ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000Sok^k^
0_o]kNgoonc/k0ook>c/00WogmoOomSHf?o=cLgo^k^koj6QXOl>EJkoXl;T
okSCkomg[^/00_nZgol01?m^KVko];Bdon3Ph?o/k>aKonk^kP05o`TL5?lJ
4QCo2A8:o`TB2_l92@X00_l94PX00ol92@[o2A8:o`TB2P02o`T92P09o`TB
2_l92@[o2A8:o`000?l92@[o2A8:o`T92_l94P[o000000Go2@T:00go2@TD
o`000?l94P[o2A8:o`000?l94P[o2@T:o`000?l94P[o2@T:o`000?l92@[o
000000;o2@T:00go2@TDo`000?l94P[o2@T:o`TB2_l0003o2@T:oa4L2_l9
2@[o4A`:oaX92_l92@[o2A8:00?o2@T:00Wo0000oa4L2_l92@[o2@T:oa4L
2_l92@[o4A`:o`T92_l94PX01?l92@X00ol94P[o2@T:o`TB2P02o`T92P03
oa4L2_l0003o2@T:00;o00001?l92@X00ol94P[o0000o`T92P02o`TB2P05
o`000?l92@[o2@T:o`T92_l000001Ol92@X01Ol0003o2A8:o`000?l94P[o
000000;o2@T:00?o2A8:o`T92_l94PX00ol92@X04?l94P[o0000o`TB2_lA
70[o6PT:ocdB2_l/4P3o8a`:ocdB2_l/71CoH2lDoh<_0?mG703o?A`:oeLL
0?mP;`X2odHV500DoaX92_lA70[o6PT:oaX92_l94P[o8a`:oaX92_lS70[o
8blYob`L5?l/>2Wo?BlmodI<?Olm;cgo=2lcoc@_:OlS;ako6Q8Do`T92_l0
0002o`T92P04o`000?l94P[o4A`:o`TB2P;o000000Go2A8:o`000?l/71Co
2@T:o`000002o`T92P05o`TB2_lA70[o4A`:o`T92_l94PX01Ol92@X01?l0
003o4A`:o`T92_l00009o`T92P06o`TB2_l92@[o4A`:oa4L2_l92@[o4A`:
1_l92@X00olA70[o0000oa4L2P04o`T92P0;o`TB2_l92@[o4A`:o`T92_lA
9QCo2@TDoa4L2_l94P[o2@TDoh<h0?ood0000_oTZP001oo1Q03oYW80oiEE
0?oTZP3oom00oeLL0?l92@X00_l94PX00olA70[o2@T:o`TB2P02o`T92P03
o`TB2_l92@[o2@T:00Co2@T:00Oo2A8:o`T92_lA70[o2@T:o`TB2_l0003o
UIRS05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000Kooooo00KooOgm
oo[jn_ofm_KolO7aono_koo]kNgoonc/k0gok>c/00WogmoOomSHf?o=cLgo
^k^koj6QXOl>E:goYLCVokWCkomg[^/00_nYg?l01?mfMWKo`L71oo3`l?om
oOeKooooo`05oaXB5?l94P[o2@TDo`TB2_l92@X00_l94PX00ol0003o2A8:
o`TB2P07o`TB2P0@o`000?l92ACo0000o`TB2_l92@[o0000o`T92_l0003o
4A`:o`T92_l94P[o2@T:o`000?l94P[o0000o`TB2P;o2@T:00?o0000o`TB
2_l94PX00ol92@X01?l0003o2@T:o`000?l00004o`T92P04oa4L2_l92@[o
2@T:o`TB2P?o2@T:00Co4A`:o`000?l92@[o2@T:0_lA70X01ol92@[o4A`:
o`T92_l0003o2A8:o`000?l92@X00ol94PX01?l0003o2@T:o`T92_l00002
o`T92P04oa4L2_l92ACo0000o`TB2P?o2@T:00Go0000o`TB2_l0003o0000
o`TB2P04o`T92P0>o`TB2_l92@[o0000o`T92_l0003o4A`:o`000?l92@[o
0000oa4L2_l92@[o0000o`T92_l00003o`TB2P?o2@T:00?o0000oaX92_lm
4PX01?m69PX07_mG703oLSP0of0_2_mP;`[o?A`:ofY12_mP;`[oEa`0odHV
5?l/71Co?A8:oaX92_lJ4QCo;180ob<L2_lA70[o6Q8DoaXL7_l/>2Wo?Blm
ocAE:OlS@E;o=5DYoc@_:OlS;bWo6RHDoa4V5?l0003o2A8:o`0000;o2A8:
0_l000000ol92ACo2@T:o`T92P02o`T92P03o`TL5?l0003o2@T:00So2@T:
00?o2A8:o`T92_l92@X00_l92@X01ol0003o2A8:o`T92_l92@[o2A8:oa4L
2_l000000_l94PX4o`T92P05o`TB2_l92@[o2@T:oa4L2_l94PX02ol92@X0
1?l0003o2@T:oa4L2_l94PX2o`T92P03o`T95?l94P[o2@T:00;o2@T:00?o
2BHYo`000?l92A@00_l000001Ol92ACo0000ocdB2_mb>03o2@TD00Co2@T:
0_l94PX01?l92ACo2@T:o`TB2_l94PX7o`T92P?o2A8:00?o0000ojJQV?oo
ool0G_ooool01?n_[joobl_;omkNg_oZj^X1oo;blP001?o^k^h02?o]kNgo
jn_[on?ShooGemOoa/K6okNg]on][JgoZ:RXoonUYJD=ojFUY@09oibLW?nG
UiOoShn?oh>3PomaLG7o2U:/ojC4i_nidnooMZgZ00;oZn3o00CoKVi^okBd
]?oPh>3ok>c/Foo^k^h05_lS;ako2A8:o`TB2_l92@[o2A8:o`T92_l94P[o
2@T:oa4L2_l92@[o0000o`TB2_l92@[o2A8:o`T92_l0003o2A8:o`T92_l0
003o2A8:o`000?l92@X3o`TB2P03o`T92_l0003o2A8:00?o2@T:00Go0000
o`TB2_l0003o2A8:o`T92P02o`000006o`TB2_l92@[o2@T:o`T92_l94P[o
2@T:0_l94PX02?l92@[o2A8:oa4L2_l0003o4A`:o`T92_lJ2@[o4A`:0ol9
2@X2o`TB2P;o2@T:0_lA70X2o`T92P04oa4L2_l0003o4A`:o`TB2P;o0000
00go2A8:o`T92_l0003o2A8:o`T92_l94P[o0000o`T92_l0003o2@T:o`00
0?lA70[o000000;o2@T:00Co0000o`TB2_l92@[o00001ol92@X01_l0003o
2A8:o`000?l94P[o0000o`T92P;o000000?o4A`:o`T92_l92@X01Ol92@X2
o`TB2P04oeLL0?mP;aCoEa`0odHV2P?oEa`000[oH2l:og]10?m69P[oEa`0
odHV2_mk@@3oH2l:oeLL0?mP;`[oLRH00_mG70000ol/71Co6PT:oa4L2P02
ob<_7P0Aob`h:Old;bWo?Blmocd_?Old;c?o8blYob`L5?lA70[o6PT:o`T9
2_l94P[o0000o`TB2_l0003o2A8:oa4L2_l000000ol92@X01?l94P[o8blN
o`T92_l94PX2o`T92P04oa4L2_l92@[o2@T:o`T92P;o2A8:0_l000000olA
70[o2@T:o`TB2P02o`T92P03o`TB2_l92@[o2A8:00;o2@T:00?o4A`:o`TB
2_l92@X01?l92@X00ol94P[o4A`:o`T92P08o`T92P04o`TB2_l92@[o2A8:
oa4L2PKo2@T:00?o4A`:oaXB5?lA70X01?l92@X01?lA70[o2@T:o`T92_l9
4PX2o`T92P03o`T95?l0003o2A8:00Co2@T:00Co2A8:o`T92_l92@[o2A8:
0_l92@X2oa4L2P?o2@T:00?o4A`:o`T92_lJ4Q@00_l92@X00onEV:?ok^k^
onk^kP1Monk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0004onKViP0:on?S
hooIfMWo/k>coh20P?m_KfooNWYjoh^;RonBTY;oVIVIoj6QX@koYjNW1_nX
Z:P2ojVYZ@GoZZZZ2on[Zj/2ojb/[0;o[Jf]00Co[:b/ojf][On][Jgo[Jf]
2_n^[Zh3ojn_[`;o/;2`0_na/K400onb/[;o/k>cok>c/`03okBd]0So]KFe
1Onf][H00ong]kOo][JfokJf]P05okNg]`[o^;Rh0oni^KT00onj^[[o^k^k
ok^k^`02okbl_0_o_Kfm1Onn_[h2okno_`Ko`<302_o1`L43ol;2`P03olC4
a?o3`l?oaLG500;oaLG52_o6a/H=olO7a`Sob<S80oo9bLT2ol[:bP?oc<c<
0oo>c/h2olo?c`_od=3@0_oAdM43om;BdP;odm?C2ooDe=@5omGEe@03omOG
eooHf=Sof=SH00Gof][J2?oKfm/2omcLg0?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omoOg`koh>3P00Co6EbaojG4i_ned>koNJk/0_nWg?l01?mZJV[o
[Zj^omSHf?oTi>AKonKViP09oaXB5?l94P[o2@T:o`T92_l94P[o0000o`TB
2_l0003o6Q`N00Co2@T:00Go2A8:o`T92_l92@[o2@T:o`TB2P02o`T92P;o
2A8:00go2@T:o`TB2_l0003o2A8:o`000?l94P[o2@T:oa4L2_l0003o2@T:
o`TB2_l0003o2@TD00?o2@T:00Ko2A8:o`000?l94P[o0000o`T95?l94PX3
o`000006o`T92_l94P[o2A8:o`TB2_lA70[o00001?l92@X01_l94P[o0000
o`T92_l94P[o2@T:oa4L2P;o2@T:00?o2A8:o`000?l92@X00_l94PX01Ol0
003o2@T:o`T92_l0003o2A8:00;o00001Ol92@X01ol0003o2@T:o`TB2_l9
2ACo2A8:o`T92_l000000ol92@X01_l0003o2@T:o`T92_l94P[o0000o`TB
2P;o000000?o2@T:o`TB2_l000000ol92@X00ol0003o2@T:o`T92P04o`T9
2P03o`T95?l/4P3oH2lD00?oEa`000_oH2l:ocdL2_mG703oH2l:og8V0?lS
70[oARH:of0_2_m69P[oARHDoeLL0003og8V0003of0_2_m69P[o;1`D00;o
;1`D01Go8blYob`L5?ld;c?o=5Dmoc@_<ol/>2Wo=2lYob<_7_lJ2@[o4A`:
o`T92_l94P[o0000o`TB2_l0003o2@T:o`000?l92@[o2A8:o`000?l94PX0
0_l000000olJ2@[o4A`:o`T92P04o`T92P;o2A8:00Ko0000o`T92_l92@[o
0000o`T92_l00002o`T92P03o`TB2_l92@[o2@T:00;o2@T:00?o2A8:o`00
0?l92@X00ol92@X00olA70[o2@T:o`T92P03o`T92P;o2A8:0_l92@X00ol0
003o2@T:oa4L2P03o`T92P06oa4L2_l92@[o2A8:o`000?l92@[o4BHN0_l9
2@X00ol94P[o0000o`T92P02o`T92P;o2A8:00?o2@T:o`TB2_l92@X03?l9
2@X01OlA70[o2@T:o`T92_l92@[o6Q8D00Co2@T:00Co2A8:oa4L2_lJ4QCo
UHB>GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000oo^k^h01_o/k>co
hn?Soj^[ZomcLg?oOWinohf=S@Sooooo00?oo_knooooooono_h00_ofm_H0
0oo^k^kohN7QomkNgP03om[JfP?ofMWI@_oHf=P8omWIf@06omKFe_oKfm_o
i>CTonc/k?oclo?onOWi0_ooool3ooknoPKooooo0oo?cll:om3@d0?odM7A
00?od];Bom?CdooDe=@00_oDe=@:omGEe@Koe]KF0_oGemL5omSHf0kofMWI
0_oJf]X=om_Kf`?og=cL0_oMgMd3omkNgP?ogmoO0_oPh>0;on7Qh@;oh^;R
0ooTi>@2onKViP_oinOW0_oYjNT3on[ZjP03onc/k?o[jn_ojn_[00;okNg]
0oo^k^h8oo3`l0;olO7a0oobl_83ooCdm0;om_Kf0oogmoL>ooShn004oa]O
]_nTa>Ko^=;^ogJ]jP;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h2o`TB
2P03o`T92_l92ACo2@T:00;o2@T:00Ko2A8:o`T92_l94P[o2@T:o`TB2_l9
2A@2o`T92P04o`TB2_l0003o2@T:o`T92P;o00000_l92@X2o`0000;o2@T:
00?o0000o`T92_l000001?l92@X02Ol94P[o0000o`T92_l92@[o0000o`T9
2_l0003o2A8:o`000002o`T92P05o`TB2_l0003o2@T:o`T92_l94PX00_l9
2@X2oa4L2P?o2@T:0ol94PX2o`T92P?o2A8:00So6PT:o`T92_l92@[o2@T:
o`TB2_l0003o2A8:o`0000;o2@T:00Wo0000o`T92_l92@[o0000o`TB2_l0
003o2A8:o`000?lA70X00_l00002o`T92P;o2A8:00Oo0000o`T92_l92@[o
2@T:o`000?l92@[o2A8:00;o00002?l92@X01?l0003o2@T:o`T92_lA70X2
o`T92P08oa4L2_lm4P[o?A`:odHV2_lm70[oH2l:oeLL0?lm70X2odHV2P07
ocdL2_l/4P3o?A`:ocdL2_m69P[o;1`Dof0_2P02og8V000?of0_2_mb9P3o
H2lDodHV5?l/71Co8a`:oaXL7_lS;bWoAT4Nocd_?Old;c?o;2HDoaXL7_lJ
4QCo8a`:00;o2@T:00Go0000o`T92_l0003o2@T:o`TB2P02o`T92P03o`00
0?l92@[o2@T:00?o2@T:00?o0000o`T92_l92@X01?l92@X00ol0003o2@T:
o`000002o`T92P05o`TB2_l92@[o2@T:o`TB2_l000000ol92@X00ol94P[o
2@T:oa4L2P06o`T92P03o`000?l92@[o2@T:01;o2@T:00?o2A8:o`T92_l9
2@X06_l92@X01olA70[o2@T:o`TB2_l94P[o2@T:o`000?nEQ8h0Goo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@000oooool01_ojn_[odm?CogemOOnP
X:3o_Kfmok2`/0Sooooo00[oo?clookno_obl_;ohn?SomoOgooHf=SocLg=
ol[:b_o0`<3o_kno0_nn_[h01?nm_Kgo_;blok^k^onk^k]8okjn_P08ol30
`?o7alOoclo?omGEeOoKfm_oiNGUoo?cloomoOd3ooknoPKooooo2ooMgMd5
omkNgP;ogmoO1_oPh>0:on7Qh@?oh^;R0_oShn<3onCTi0[oiNGU1_oVi^H2
onSXj0Goj^[Z2oo[jn/2onc/k0;okNg]00Cok>c/ong]kOo]kNgokNg]2_o^
k^h5ono_k`?ol?3`1OoalO48oo;blP;olo?c0oodm?@00ooemOGom_KfooKf
mP02ooOgm`?on?Sh2_oinOT3oo[jnP?oo?cl0_ono_hAooooo`04oaeO/onV
a^Ko]]3^ogV_kP;oZmko00CoMWIfol71`Oo`l?3ooOgmFoooool00ol92@[o
2A8:o`T95002o`TB2P?o2@T:00Oo2A8:o`000?l94P[o2@T:o`000?l92@[o
2A8:00;o2@T:00?o2A8:o`T92_l94PX02Ol92@X00ol0003o2@T:o`000002
o`T92P09o`000?l94P[o2@T:o`000?l92@[o0000o`T92_l0003o2A8:00?o
00000_l92@X00ol94P[o2@T:oa4L2P04o`T92P03oa4L2_l92@[o2@T:00;o
00000_l92@X01?l0003o4A`:o`T92_l00003o`T92P03o`000?l94P[o0000
00;o2@T:00ko0000o`T92_l94P[o0000o`T92_l0003o2@T:o`000?l92@[o
0000o`T92_l94P[o2@T:o`T950;o000000So2@T:o`TB2_l0003o2@T:o`00
0?l92@[o0000o`TB2P;o2@T:00Co0000o`T92_l92@[o00000ol92@X00ol9
4P[o0000o`TB2P02o`T92P0Coa4L2_l/4P3o8a`:ob<L2_lm4P[o?A`:oeLL
0?m69P[o8a`:ocdB2_m69QCoARl:oaX92_lS70[o;1`DodHV5?lS;ako;180
ocdB2P02odHV2P0=odI<?Om6@Ako?Blmoc@_<olS70[o;3PYob`L5?ld;c?o
8blcoc@_:Ol/9QCo8blNob`L5002o`T92P03o`000?l94P[o000000;o2@T:
0_l000001Ol92@[o2A8:o`000?l0003o2A8:00So2@T:00[o4A`:o`000?lA
70[o0000oa4L2_l92@[o0000o`TB2_l92@[o00000_l92@X00olA70[o2@T:
o`T92P08o`T92P03oa4L2_l92@[o2@T:00;o2A8:3ol92@X01Ol94P[o2@T:
o`TB2_l0003o2A8:00Ko2@T:00?o0000o`T92_l92@X03_l92@X02Ol94P[o
2@T:o`T92_l92@[o4A`:o`T92_lA70[o0000oh>4SP1Oooooo`04ojn_[oo;
bl_og]kNon[ZjP7ol_;b0002onk^kP07ong]kOoUiNGoTI6Aoi6ATOo<c<co
eMGEol;2`P08ooooo`09ooCdm?obl_;og]kNolS8b?o0`<3o^;Rhojj^[_n[
Zj_oX:2P00;oWinO00GoWIfMoibLW?nKVi_oVYZJoiVIV@10oiZJVPSoVi^K
00SoXj>Soj^[Zonb/[;o]KFeok^k^oo:b/[ogmoOong]k@?oo_kn1_ooool3
on3Ph0[ohN7Q0ooRh^800ooTi>Cohn?SonGUi@02onGUi@[oi^KV1_oWinL0
0ooXj>SojNWYon[ZjP04on[ZjP_ojn_[0oo/k>`2ong]k@?ok^k^2_o_knl3
oo3`l0;olO7a0_obl_801?oalO7ol_;boo;bl_obl_82oo?cl`Som?Cd1Ooe
mOD3ooKfmPGomoOg2_ohn?P3ooWin@03oo_knoolo?coo?cl00;oo_kn9_oo
ool01?lJG;?oY<?UokSBkomi[^`2ojcOo`04ofi^K_nd];Coh>3Ponc/k5_o
k^k^0_l94PX00olJ4QCo2A8:o`TB2P08o`T92P06o`TB2_l92@[o2@T:o`TB
2_l92@[o00001Ol92@X01Ol94P[o0000o`T92_l0003o2A8:00;o2@T:00?o
2A8:o`000?l92@X01_l92@X01olA70[o2@T:o`000?lA70[o2@T:o`TB2_l0
00000_l92@X01_lA70[o2@T:oa4L2_l0003o2@T:o`TB2PCo2@T:0_l94PX5
o`T92P03ob<L2_l92@[o2@T:00;o2@T:00Co0000o`TB2_l92@[o2A8:0_l0
0003o`T92P06o`000?lA70[o0000oa4L2_l0003o2@T:0ol00003o`T92P03
o`000?l94P[o2@T:00Co2@T:0_l94PX2o`T92P05o`000?l92@[o0000o`TB
2_l000000_l92@X01Ol94P[o2@T:ocdB2_lJ2@[o;18000;o8a`:01[o?A`:
odHV2_m69P[o8a`:ob<V2_lm70[o8bH:ob`B0?lm70[o;1`Doc@_7_ld;c?o
2@T:ob<L2_l/71Co;3PYob<_7_ld;bWo?Blmoc@_:OlS;ako=2lNob<_:Ol/
>2WoARHDob`h:@;o;1`D0_lA70X2o`T92P04o`000?l92@[o0000o`TB2P;o
2@T:00Ko2A8:o`000?l92ACo2@T:o`TB2_l00005o`T92P03o`TB2_lA70[o
2A8:00Oo2@T:00?o2A8:o`T92_lA70X00_l92@X01?lA70[o2@T:oa4L2_lA
70X8o`T92P04oa4L2_l92@[o0000o`TB2PCo2@T:00?o2A8:o`T92_l92@X0
2?l92@X2o`TB2PKo2@T:00?o2A8:o`T92_l92@X01?l92@X00ol94P[o6Q8D
o`TB2P03o`T92P03oa4L2_l92ACo2@T:00?o2@T:00Wo4A`:o`T92_l94P[o
4A`:o`T92_lJ4QCo4A`:o`000?nEQ7/0Goo^k^h01?nSXj?o_Kfmolo?cooJ
f]X1on7Qh@000_oVi^H02OoUiNGofMWIogQhN?nl_;cof=SHom_Kfoo>c/ko
oooooogmo@05ooooo`0=ooGemOoNg]koclo?okno_ona/K7oYJFUoiNGUon<
S8coQhN7ohV9ROn8R8SoQHF5oh61P@02ogemO@03ogmoOon1PH7oOgmo03oo
Ogmo0on0P8003omnOWkoOGemogmoOon4Q8CoRHV9ohN7Qon:RX[oSXj>oiFE
UOnPX:3o/;2`ol?3`ooAdM7oi>CToo;blP02ooknoP03ooclo?oooooooooo
00;ooooo2ooUiND5onKViP;oinOW1_oXj>P:onWYj@?oj^[Z0_o[jn/3onc/
k0[okNg]0oo^k^h3ono_k`03oo7alOo`l?3ol_;b00;ol_;b0_oclo<8ooCd
m0GomOGe0oofm_H5ooOgm`gon?Sh0ooinOT?oo[jnP?ono_k00?oo?cloogm
oOomoOd00_ono_hVooooo`04oaeO/onUa>Ko]];^ogV^j@;oZ^3o00CoJVYZ
ojj^[_oHf=Soi>CTFooVi^H00ol94P[o6RHDoaXB5002o`T92P03o`TB2_l9
2@[o2A8:00;o2@T:00?o2A8:o`T92_l92@X00_l92@X01?l94P[o2@T:o`T9
2_l92@X2o`TB2P04o`T92_l0003o2A8:o`0000;o2@T:00So4A`:o`000?l9
4P[o2@T:o`000?l92@[o2A8:o`0000;o2@T:00?o0000o`TB2_l000000_l9
2@X01ol94P[o0000o`TB2_l0003o2A8:o`T92_l94PX00_l92@X03olA70[o
2A8:oa4L2_l92@[o4A`:o`T92_l94P[o2@T:o`000?l92@[o4A`:o`000?lA
70[o2@T:o`TB2P05o`T92P04o`TB2_l0003o2@T:o`0000;o2A8:00Co2@T:
o`000?l0003o2@TD0_l94PX02Ol0003o2@T:o`000?l94P[o2@T:o`000?l9
4P[o0000o`TB2P02o`T92P06o`000?lA70[o0000o`000?l94P[o00000ol9
2@X01?l0003o4A`:o`T92_l00002o`T92P08o`TB2_l0003o2@T:ob`B0?lS
70[o4A`:ob<L2_lA70X2odHV2P0:ob<L2_l/4P3o?A`:odHV5?l/9QCo4A`:
ob`L5?lS;ako=2lYoc@_<`;o2@T:00So6PT:oa4V5?lJ4QCo8blYodI17_lS
;ako?Blmob`V50;o8blc00ko;3PYob`V5?lS70[o6Q8Do`000?l92@[o0000
o`T92_l0003o2A8:o`000?l92@[o0000o`TB2P;o000000?o2@T:o`TB2_l0
00001_l92@X01?l94P[o0000o`TB2_l94PX;o`T92P05oa4L2_l92@[o2@T:
o`T92_l000001Ol92@X01_l94P[o2@T:o`TB2_l92@[o2A8:o`0000?o2@T:
00?o2A8:o`000?l92@X00_l92@X04?l94P[o2@T:o`TB2_l92@[o2A8:o`T9
2_l94P[o2@TDo`TB2_l92@[o2A8:o`T92_l94P[o2@T:oa4L2_l00002o`T9
2P07o`TB2_l92@[o2@T:o`TB2_l92@[o2A8:o`T95006o`T92P03oa4L2_l9
2@[o2@T:00;o2@T:00?o4A`:o`T92_l92@X00_l92@X00ol0003oYZ6HonKV
iP1NonKViP04oifMWOng]kOob<S8om?Cd`7of][J0002onk^kP04onc/k?oO
gmooLG5aom7Ad@;og=cL00?od=3@ooooooono_h00_ooool05?okno_on_[j
oo;bl_oRh^;oe]KFolO7aonc/k?oWinOohb<S?mkNg_oLg=cog9bL_maLG7o
LW9bog=cLombLW;oL71`ofm_Kom`L73oLG5a>?m`L708og5aL@0Cofi^K_m`
L73oLG5aog5aLOm_KfooL71`og9bL_meMGGoO7alog1`L?m^KVkoOGemoi2@
T?nNWYko/;2`ol30`?o?cloohn?SooShn002ooooo`04ookno_omoOgoo?cl
ooooo`_oi^KV3OoWinL7onSXj0?ojNWY0ooZj^X2onc/k0?ok^k^0_o_knl>
oo3`l003oo7alOobl_;olo?c00oolo?c0_odm?@3ooGem@?om_Kf2_ogmoL3
ooShn0;onOWi0oojn_X2oo_kn`?oo?cl3OomoOd3ooknoRSooooo00Co6ejc
ojK6i_nidnkoNJk[0_n[gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP07oaXB
5?l92@[o2A8:o`T92_l94P[o2@T:o`TB2P04o`T92P06o`TB2_l92@[o2@T:
o`T92_lJ2@[o2@T:0_l94PX02?l0003o2A8:o`T92_l94P[o0000o`T92_l9
4P[o00000ol92@X2o`TB2P;o00001?l92@X01?l0003o2@T:o`T92_l94PX2
o`T92P04o`TB2_l0003o2@T:o`TB2P;o2@T:00Co4A`:o`TB2_l92@[o2A8:
0_l92@X02Ol0003o2@T:o`T92_l0003o2@T:o`000?l92@[o6PT:o`T92P02
oa4L2P08o`T92_l94P[o2A8:o`T92_l0003o2@T:o`000?l94PX2o`000003
o`TB2_l92@[o2A8:00;o000000?o2A8:o`000?lA70X00ol000001?l92@[o
0000o`T92_l00003o`T92P03o`000?l92@[o000000?o2@T:00Co0000o`TB
2_l92@[o00000_l92@X3o`000004o`T92_l94P[o;180ob<L2P;o;18000?o
?A`:ob<V2_lm70X00_lm70X02OlA9P[oARHDocdL2_lm70[o6Q8DocdL2_m6
C3go4BHDo`T92P02oa4L2P04ob`L5?lJ71ko=2lYoc@_<`;o;2HD00Co;1`D
ob`V5?l/9QCo8blN0_lJ9Q@02OlA70[o2@T:o`TB2_l92@[o0000oa4L2_l0
003o2A8:o`T92P02o`000006o`TB2_l0003o4A`:o`000?l94P[o00001?l9
2@X01Ol94P[o2@T:ob`B0?l92@[o2A8:00Co2@T:00?o0000o`T92_l92@X0
1_l92@X00olA70[o2@T:o`T92P0>o`T92P03o`TB2_l92@[o2@T:00;o2@T:
0_l94PX01?l0003o2@T:oa4L2_l0000?o`T92P07o`TB2_l0003o2@T:oaXB
5?l94P[o2@T:o`000007o`T92P08o`TB2_l92@[o4A`:o`T92_lA70[o2@T:
o`000?n=V8iOonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002ooooo`09
oogmoOo]kNgoLG5aomOGeooNg]kogmoOomCDe?oooooono_k00;ooooo00oo
o_knoo[jn_o/k>coemOGokZj^_nUYJGoShn?ohN7Qon=SHgoVi^KojVYZOnd
];Coe=CDomOGeooLg=`00_oOgml00ooMgMgog=cLomcLg00homcLg0Sog]kN
00Gof][JomcLg?oNg]kog]kNomgMg@02om_Kf`0<omcLg?o=cLgo^;RhojBT
Y?nHV9SoR8R8oh61POnEUIGo];Bdokbl_?oCdm?okno_1?ooool00oomoOgo
ooooonOWi`0:onOWi`;oj>SX0ooYjNT00ooZj^[ojNWYon[ZjP02on[ZjP?o
jn_[3Oo/k>`00oo]kNgok^k^ono_k`0<ono_k`?ol?3`0ooalO400ooclo?o
l_;booCdm002ooCdm0;omOGe2?ofm_H7ooOgm`Kon?Sh2ooinOT2oo[jnP;o
o?cl00?ono_koogmoOomoOd04Oono_hZooooo`04oamQ]?nS`^Co^=?_ogN^
j`;oZ]oo00CoMWIfol71`Oo`l?3ooOgmFoooool00olA9QCo4A`:oaXB5002
o`TB2P06oa4L2_l92@[o2A8:o`TB2_l92@[o2A8:0_l92@X02?l94P[o2@T:
o`TB2_l94P[o0000o`T95?lJ2@[o00000_l94PX01?l92@[o2A8:o`T92_l9
2@X2o`TB2P05o`T92_l0003o2@TDo`TB2_l000000_l92@X04?l94P[o2@T:
o`TB2_l0003o2@T:o`000?l94P[o0000o`T92_l94P[o4A`:o`000?lJ2@[o
2A8:o`000?lJ2@X2o`T92P06o`TB2_l92@[o4A`:oa4L2_l0003o2A8:0_l9
2@X02_lA70[o2@T:oa4L2_l0003o6PT:oa4L2_l94P[o2@T:o`000?l94PX2
o`T92P08o`000?l94P[o2@T:o`000?l94P[o0000o`T95?l94PX2o`000006
o`TB2_l0003o2@T:o`T92_l0003o4A`:0_l92@X01?l0003o2A8:o`000?lA
70X3o`T92P08o`000?l94P[o2A8:o`T92_l0003o2A8:o`T92_l00002o`TB
2P?o2@T:00Ko8a`:oa4L2_lJ2@[o8bH:ocdL2_lS70X2odHV2P09ocdL2_lS
70[oARHDob`V5?m69QCo;2HDoc@_<omGEE;o2@T:00;o4A`:00Oo6PT:oaXV
5?l/>2WoAT`moc@_<olJ4QCo8bH:00;o=2lY00Go6Q`Nob`V5?l/71Co4A`:
o`TB2P02o`T92P05o`000?l92@[o2@T:o`T92_l000000ol94PX2o`T92P08
o`000?l94P[o2@T:o`000?lA70[o2@T:oa4L2_l92@X2o`TB2P03o`T92_lA
70[o2@T:00;o2@T:00?o2A8:o`T92_l92@X01Ol92@X00olA70[o2@T:oa4L
2P02o`T92P04oa4L2_l92@[o2@T:oa4L2P;o2@T:00Co4A`:o`T92_l94P[o
2A8:1Ol92@X01Ol94P[o2@T:o`T92_lA70[o2A8:00;o2@T:00?o2A8:o`T9
2_l92@X02ol92@X01_lA70[o2@T:o`T92_l92@[o2A8:o`T92P;o2A8:00?o
2@T:oaXB5?l94PX00ol92@X00olA70[o2@T:oa4L2P03o`TB2P;o2@T:00Go
4A`:o`T92_lA70[o0000oiFHX`1Oooooo`04ojn_[oo;bl_og]kNon[ZjP7o
l_;b0002onk^kP04onc/k?oLg=coMgMgomWIf@;oh>3P00?oe=CDookno_ok
no/00oooool03_ofm_Koh^;RolO7aona/K7oVYZJohR8R?nATI7o[Zj^ol_;
booKfm_ohN7QomgMgOoRh^;oinOW0_o[jn/00ooZj^[ojNWYonWYj@0hon[Z
jPSojn_[00KojNWYon[Zj_o[jn_oj^[ZonWYjOoXj>P2onOWi`0=on7QhOoO
gmoogMgMom7AdOnc/k?oTi>CohZ:R_nCTi?o[:b/ol?3`ooPh>3om?Cdoogm
o@04ooooo`_oinOW3OoXj>P7onWYj@?oj^[Z0oo[jn/00oo]kNgok>c/onk^
kP02onk^kP;okno_2oo`l?03oo7al@;olo?c0ooemOD:ooKfmP[omoOg00?o
fMWIogYjN_o`l?002oohn?P2ooWin@;ono_k00?oo?clookno_ono_h0>ooo
ool01?lOH;CoYLCVokWCkomg[^/2ojWLo`04ofi^K_nd];Coh>3Ponc/k5_o
k^k^00?o2A8:o`T95?lJ4Q@01Ol94PX00ol92@[o2A8:o`T92P03o`T92P06
o`TB2_l92@[o2A8:oa4L2_l0003o2A8:1Ol92@X02Ol0003o2A8:o`T92_l0
003o2A8:o`T92_l94P[o2@T:o`000003o`T92P07o`TB2_l92@[o2@T:o`TB
2_l92@[o0000o`T92P02o`TB2P05o`000?l94P[o2@T:o`T92_lA70X00_l9
2@X01?lA70[o2@T:o`TB2_lA70X4o`T92P04o`TB2_l92@[o4A`:oa4L2P;o
2@T:00?o2A8:o`T92_l92@X00ol92@X01?l0003o2@T:o`T92_l00003o`T9
2P04o`000?l94P[o2A8:o`T92P;o2A8:00?o2@T:o`000?l94PX00_l94PX4
o`T92P04o`000?l94P[o2@T:o`TB2P;o2@T:00?o0000o`TB2_l92@X00_l9
2@X00ol0003o2@T:o`000002o`T92P04oa4L2_lS70[o;180ob`B00?o8a`:
00Co8bH:ob<L2_lS9P[o8bH:0_l/9Q@05olS70[o8blNob`h:OlS@E;o8a`:
oaXB5?lJ2@[o6Q8Dob`h:Old;bWoEeEBoc@_7_lS9P[o;1`DodI17_l/9QCo
6Q`Nob<L2_lJ2@[o4A`:o`TB2_l92@[o2A8:00?o2@T:00Co4A`:o`000?lA
70[o00001Ol92@X01?lJ2@[o2@T:o`T92_l94PX2o`T92P06oa4L2_l92@[o
2A8:oaX92_lA70[o2A8:0ol92@X01ol94P[o2@T:o`T92_l94P[o4A`:o`00
0?lA70X00_l92@X00olA70[o2@T:o`T92P06o`T92P05o`TB2_l92@[o2@T:
o`T92_lA70X00ol92@X00ol94P[o2@T:o`T92P02o`T92P03o`TB2_l92@[o
2@T:00Co2@T:00?o2A8:o`T92_l92@X00ol92@X00ol94P[o2@T:o`T92P04
o`T92P03o`TB2_l92@[o2@T:00;o2@T:00Oo2A8:o`T92_l92@[o2A8:o`T9
2_l94P[o4A`:00;o2@T:00?o2A8:o`T92_l94PX00_l92@X01?lA70[o2@T:
o`000?n=V8iOonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002onKViP07
onCTi?oDe=CoMWIfom[Jf_oPh>3ohN7QomCDe004ooooo`0AooOgmooWinOo
bl_;ojb/[?nJVY[oUYJFoifMWOnd];Coc/k>om_KfooMgMgof][JonKVi_oY
jNWokNg]ono_koo`l?000_o_knl00oo`l?3olO7aoo7al@0noo7al@04oo?c
loobl_;ol?3`ono_k`;ok^k^0_o]kNd2omoOg`0=omgMgOoGemOoc/k>okZj
^_nNWYkoQXJ6oiZJV_n^[Zkoc<c<onOWioofm_Kono_kooknoP02ooooo`_o
inOW0_oXj>P3onWYj@;oj^[Z0oo[jn/3onc/k0OokNg]1_o^k^h00oo`l?3o
kno_oo7al@04oo7al@_ol_;b1?oclo<4ooCdm0[omOGe1Oofm_H2ooOgm`06
ooKfm_ogmoOomoOgoo?clolL71coWinO2oohn?P2ooWin@;ono_k00?oo?cl
ookno_ono_h0>oooool01?lKGkKoY<CVokWCkomf[NX2oj_Po`04ofYZJ_n^
[Zkof=SHonCTi5_oi^KV0ol92A@03ol94P[o6Q8Do`TB2_l92ACo2@T:o`TL
7_l94P[o2@T:o`TB2_l92@[o2A8:o`000?l971ko2A8:o`000002o`T92P;o
2A8:00Go2@T:o`TB2_l92ACo2A8:o`000002o`T92P03oaXB5?l0003o2@T:
00;o2@T:00Go2A8:o`T92_l94P[o2A8:o`T92P03o`TB2P05o`T92_l94P[o
0000o`000?l92@X01Ol94PX02?lA70[o2@T:o`T92_l94P[o2@T:o`TB2_l9
2@[o4A`:0_l92@X01_lA70[o2@T:o`T92_lA70[o2@T:oa4L2P?o2@T:00?o
4A`:o`T92_l92@X00ol92@X04?l94P[o2@T:o`TB2_l92@[o0000o`T92_l0
003o2A8:o`000?l94P[o0000o`TB2_l0003o2@T:o`000?l94PX2o`T92P07
o`TB2_l92@[o2A8:o`T95?l92@[o2A8:o`000005o`T92P0;o`TB2_l92@[o
2@T:o`T92_l/4P3o6PT:ob<L2_lJ2@[o6Q8Dob`B0?l/71@01OlS70X04_lJ
9QCo;1`Doc@_:Old;bWo=5DYoa4L2_l92@[o2A`Dob`L5?ld;bWo=2lcodmW
G?lJ71ko6Q8Dob`L5?l/9QCo;3PYob<L2P;o4A`:0_l92@X01ol0003o2@T:
o`TB2_l0003o2A8:o`000?l94PX00ol92@X2o`TB2P03o`T92_l94P[o2@T:
00;o2@T:00So4A`:o`T92_lA70[o2A8:oa4L2_l92@[o4A`:o`T92P?o2A8:
0_l92@X02Ol0003o2A8:oa4L2_l92@[o2A8:o`T92_lA70[o2@T:oa4L2P08
o`T92P07oa4L2_l92@[o4A`:o`T92_l94P[o2@T:o`TB2P04o`T92P04o`TB
2_l92@[o2@T:o`TB2P;o2@T:0_l94PX00ol92@[o2A8:o`TB2P02o`TB2P05
o`T92_l94P[o2@T:o`T92_l94PX00_l92@X00ol94P[o2@T:o`T92P02o`T9
2P03o`TB2_l92@[o2A8:00;o2@T:00?o4A`:o`TB2_l94PX01Ol92@X01ol9
4P[o2@T:oa4L2_l92@[o2A8:o`000?nEQ8h0GooVi^H01?nMWIgo]kNgolS8
b?oCdm<1om[JfP000_o^k^h01?o/k>cog=cLogalO?oJf]X2on3Ph003om?C
dooooooooooo00;ooooo00_olO7aomgMgOo0`<3oXJ6QohF5QOnEUIGo[Zj^
olG5aOoAdM7oemOGomkNgP02onKViP03onWYjOo[jn_ok>c/00?ok>c/00?o
k^k^ono_koo_knl0=_o_knl8ong]k@04oo;bl_o_knookNg]on_[j`;ok>c/
013ojn_[on[Zj_o`l?3okNg]on3Ph?o?clooalO7ol71`Ona/K7oWYjNoi2@
T?nQXJ7o_knoon3Ph?oemOGoo?cl0_omoOd00oooooooi^KVonKViP09onKV
iP;oinOW0ooXj>P2onWYj@03on[Zj_oHf=Sofm_K00?ojn_[1oo/k>`6ong]
k@;okno_1OoalO4;oo;blPColo?c00Coj>SXomgMgOoclo?olo?c1Oodm?@0
0oobl_;od];BomcLg002ooCdm0GomOGe0oogmoL3ooWin@03ohN7Qoll?3co
n_[j00Won_[j00?oinOWon_[jookno/00oolo?`2oogmoA7oo_kn0oooool0
0oo/k>cokno_ooooo`0?ooooo`03ooCdm?oXj>Sooooo01;ooooo00Co6ejc
ojG4i_ned>koNJk/0_nWg?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP0:oaXB
5?l94P[o2@TDo`T92_l94P[o2@T:o`TB2_l971Co;2HDo`T950?o2@T:00?o
2A8:o`T92_l92@X01?l92@X02_l94P[o2@T:o`T92_l92@[o0000o`T92_l9
4P[o0000o`T92_l00003o`T92P03o`TB2_l0003o2A8:00;o000000Ko2@T:
o`000?l92@[o0000o`TB2_l00002o`T92P03o`000?l92@[o000000;o2@T:
00Wo6PT:o`000?l92@[o4A`:o`TB2_l92@[o2A8:o`T92_l000000_l92@X0
2?lA70[o2A8:oa4L2_l92@[o4A`:o`000?lA70[o2A8:0_l000002?l92@[o
0000o`TB2_l0003o2@T:o`000?l94P[o00000_l92@X00ol94P[o2@T:o`T9
2P09o`T92P03o`000?l92@[o2@T:00?o000000Go2A8:o`T92_l0003o2@T:
o`000002o`T92P0Co`000?lA70[o2@T:o`T92_lS70[o2@T:ob<L2_lA70[o
;180ob<L2_l/4P3o8a`:ob<V2_lJ2@[o;1`Dob`V5?l/71Co;2HDoc@_7P02
odI17P0Coc@_:OlS;ako8blYob<_7_lm;cgoCeiVodI<?Ol/4P3o;1`DoaX9
2_l/71Co8a`:oaXB5?l94P[o2@T:o`000?l92@[o4A`:o`000005o`T92P03
o`TB2_l92@[o2A8:00;o000000Ko2A8:oaXB5?l94P[o2A8:o`T92_l94PX2
o`T92P07o`000?l92@[o4A`:o`T92_lA70[o2@T:o`000005o`T92P?o2A8:
00?o4A`:o`T92_lA70X00_l92@X00olA70[o2@T:oa4L2P02o`T92P03oa4L
2_l92@[o2@T:00?o2@T:00?o2A8:o`000?l92@X01?l92@X01_l0003o2@T:
o`T92_l92@[o4A`:o`0000;o2A8:00Go0000o`TB2_l92@[o0000o`TB2P03
o`T92P04o`TB2_l92@[o4A`:o`TB2PCo2@T:00Go2A8:o`000?l92@[o2A8:
o`000007o`T92P09o`TB2_l92@[o2@T:o`TB2_l92@[o4A`:o`TB2_l0003o
PhAk05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo00CooOgm
onc/k?mlO7cof][J0_oPh>005OoCdm?oooooookno_ooooooo_knonc/k?oF
e]Ko^[ZjoibLW?nHV9SoY:BTokFe]Oo3`l?ob<S8olg=cOoJf][oj>SXonGU
iOoWinOoj^[Zonc/k004on_[jcSokNg]2?o/k>`01?o^k^kok>c/on_[joo[
jn/2onc/k00@onWYjOoVi^Koe=CDom[Jf_oNg]kof=SHolc<c?nn_[ko[Zj^
oj>SXonBTY;oW9bLokBd]?oEeMGol?3`ooclo0?ooooo1OoVi^H00ol`<33o
J6QXonKViP03onKViP03onOWioli>CWoLg=c00;oj>SX00_ojNWYolS8b?l`
<33o30`<o`/;2old=3Cobl_;onc/k?o]kNgo>c/kogIfMP02ong]k@06og5a
LOln?Skok^k^onk^k_nXZ:So20P80_o^k^h2ono_k`Col?3`00?oJf][oc@d
=?oalO400ooalO401_ll?3coN7Qhoo7alOoalO7oVYZJoaXJ6P;ol_;b00Ko
fm_KodI6A_l20P;o8B4QoaHF5_nh^;P4ooGem@06ojVYZOl92@Wo30`<ob8R
8_lc<c?oX:2P0_ofm_H01olm?CgoNWYjooKfm_odm?CoBTY:ob/[:ooYjNT0
0_oinOT00on>SXko0000om;BdP03oo[jnP0>ochn?_mlO7con_[joo[jn_oF
e]Ko<c<co`d=3Ol;2`_o>3PhomWIfOolo?cooOgmoclo?omnOWh2ooooo`03
oj>SXolL71cooooo00Oooooo00?oLW9bocPh>?ooool00oooool01_oKfm_o
=CDeo`h>3_l<30co>CTiomcLg0;ooooo00?oi^KVo`000?n8R8P00_ooool0
0om9BDWo:2PXooooo`02ooooo`09onOWiom:BT[o0`<3ob<S8olG5aOo`L71
oooooom0@43oOgmo00kooooo00Co6enfojC4i_nhd^koMZgZ0_n/gol01?mf
MWKo`L71oo3`l?omoOeKooooo`;o2A8:00Oo2@T:oa4L2_l92@[o4A`:o`T9
2_l94P[o2@T:00;o4A`:0_l92@X00ol94P[o2@T:o`T92P05o`TB2P0:o`T9
2_lA70[o2@T:o`T92_lA70[o2@T:o`000?l94P[o2@T:oa4L2POo2@T:00?o
4A`:o`000?lA70X00_l92@X01_l94P[o2@T:o`000?lA70[o2@T:oa4L2P?o
2@T:00Wo4A`:o`TB2_l0003o2A8:o`T92_lA70[o0000o`T92_l94PX00_l9
2@X01OlA70[o6PT:oa4L2_l92@[o4A`:00Co2@T:00?o0000oa4L2_l92@X0
1ol92@X2o`0000;o2@T:00?o0000o`T92_l94PX00ol92@X00ol0003o2A8:
o`T92P05o`T92P03o`000?l94P[o000000?o2A8:00ko4A`:oaXB5?l0003o
2A8:oa4L2_lA9P[o;180oaX92_l/4P3o6Q8DoaX92_lA70[o8a`:oaX92P?o
8a`:0ol/9Q@02Old;ako=2lcoc@_:Ol/>2Wo8blcoc@_<om6EE;oEei_ob`h
:@02oa4L2P03ob`L5?lA70[o2@T:00;o2@T:00?o4A`:o`T92_l92@X00_l9
2@X00ol94P[o2@T:o`TB2P02o`TB2P06o`T92_l0003o2@T:o`T92_l0003o
2A8:1?l92@X02?l0003o2A8:o`T92_lA70[o2@T:o`TB2_lA70[o2@T:0_l9
4PX01olA70[o0000oa4L2_l0003o4A`:o`T92_l94PX00_l92@X00ol/71Co
6Q8Doa4L2P0Go`T92P03o`TB2_l92@[o6PT:00;o2@T:0_l94PX00ol92@[o
6PT:o`TB2P04o`T92P03o`TB2_l92@[o2@T:00;o2@T:00So2A8:o`T92_l9
2@[o2@T:o`TB2_l92@[o4A`:o`T92P;o4A`:0ol92@X02OlA70[o2@T:o`T9
2_l92@[o4A`:o`T92_lA70[o0000oiF4N`1Oooooo`04ojn_[oo;bl_og]kN
on[ZjP7ol_;b0002onk^kP04onc/k?oLg=coO7alom[JfP;oh>3P013oe=CD
ooooooooooooooooooWinOoRh^;ob<S8oj^[Zon>SXkoVi^KoinOWon[Zj_o
_Kfmol[:b_oBd];oemOG0_oLg=`01?oOgmooi>CTonKVi_oVi^H2onCTi003
on?ShooUiNGoiNGU03koiNGU01Ooi>CTon?ShooTi>Coi^KVonOWiooVi^Ko
hN7QomgMgOoUiNGoemOGolg=cOo>c/kobl_;okbl_?nYZJWoWinOoiJFU_nH
V9SoZ:RXolO7aooTi>Com_KfooknoP02ooooo`Goi^KV00?o<30`ofQXJ?oV
i^H00ooVi^H00ooWinOo>CTiog=cL`02onSXj003onWYjOl_;booBd];00;o
g=cL00KoCdm?oc4a<Oo/k>cok^k^oc/k>omfMWH2onk^kP06og5aLOln?Sko
kno_ono_konXZ:So20P82?o_knl00omZJV[o=3@doo3`l003oo3`l006oc`l
??mgMgOol?3`oo3`l?nIVIWo6QXJ0_oalO401_m0@43o?3`lomCDe?odm?Co
j>SXonOWi`ComOGe00kocLg=okNg]oo`l?3omOGeoiJFU_l30`?oe]KFooKf
m_lm?CgoNWYjooGemOmLG5co7alOomkNgP?on?Sh00?o;Bd]o`P82?m^KVh0
0ooinOT03_ln?SkoO7alooWinOohn?So<S8boe1@D?oXj>SojNWYoe=CDold
=3Cono_kooclo?lo?cooOWin0_ooool00onSXj?o71`Looooo`07ooooo`03
og9bL_lh>3Sooooo00;ooooo00?oo_knoc@d=?mBDU800_o^k^h03?mEEEGo
=CDeookno_ooooooWYjNo`l?3oli>CWoooooooShn?l:2P[o3`l?omCDe0;o
oooo00WoA4A4od10@?oOgmoooooooo?cloobl_;ooooood10@?moOgl03_oo
ool01?lMGk?oY/KVokK@k_mi[nh2oj_No`04ofi^K_nd];Coh>3Ponc/k5_o
k^k^00Ko4A`:o`T92_lA70[o2@T:o`T95?l94PX2o`T92P06o`TB2_lA70[o
2@T:o`T92_l94P[o2@TD0_l94PX00ol92@[o0000o`T92P02o`T92P03oa4L
2_l0003o2@T:00;o2@T:00Ko4A`:oaXL7_l0003o2A8:o`T92_l94PX5o`T9
2P0;o`TB2_l0003o2@T:o`000?l94P[o2@T:o`000?l92@[o4A`:o`000?l9
4PX00_l92@X01_lA70[o2@T:oa4L2_lJ2@[o2A8:oa4L2P;o2@T:00?o4A`:
o`000?l92@X00_lA70X00ol92@[o4A`:oa4L2P04o`T92P09o`000?l92@[o
2@T:o`T92_l0003o2A8:o`000?lA70[o000000?o2@T:00Go0000oa4L2_l9
2@[o2@T:o`000002o`TB2P03o`T92_l0003o2@T:00Ko2@T:00?o0000o`T9
2_l92@X00ol92@X2o`000003o`T92_l0003o2@TD00;o2@T:00Go6PT:ob<L
2_lS70[o4A`:ob`B0004ob<L2P03ob`B0?lA70[o;1`D00;o;1`D00Co=2lN
oc@_<om6@AkoAT`m0_lm;cd02?m6C3go;5ELodmWG?lJ2@[o4A`:oaX92_l/
4P3o4A`:2Ol92@X01?l94P[o2@T:o`000?l92A@2o`T92P03o`TB2_l92@[o
2@T:00Go2@T:00?o2A8:o`T92_l92@X00_l92@X00olA70[o6PT:oa4L2P02
o`T92P09o`TB2_l92@[o2@T:o`T92_l94P[o2@T:oaX92_lA70[o2@T:00;o
6Q8D00?o2@T:oa4L2_lA70X05?l92@X00ol94P[o2@T:o`TB2P02o`T92P03
oa4L2_l92@[o2@T:00Ko2@T:00?o2A8:o`T92_l92@X01?l92@X01Ol94P[o
2@T:o`T92_l92@[o2A8:00;o2@T:00?o2A8:o`T92_l92@X01Ol92@X01_lA
70[o0000oaXB5?l94P[o0000oh>=Q5ook^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN4000;oi^KV01Soi>CTomCDe?mkNg_of][Jon3Ph?oQhN7oeMGEookn
o_ooooooo?cloo[jn_oMgMgoalO7oj:RX_n2PX;oTI6AoinOWon][Jgo]kNg
okjn__o8b<Sod=3@om?CdooHf=P2omOGe`05omWIfOoMgMgog]kNomgMgOoJ
f]X0>?oNg]h8omgMg@?oh>3P01KogmoOomkNg_oMgMgofm_Kom[Jf_oEeMGo
dm?Colg=cOo5aLGo_[jnokNg]on[Zj_oXJ6QoiBDU?n2PX;oYJFUol71`OoN
g]kon?ShooooooomoOgooooo1OoVi^H00ol`<33oJ6QXonKViP03onKViP03
onOWioli>CWoLg=c00;oj>SX00?oaLG5o`000?nWYjL00_oZj^X01_nXZ:So
0000ol[:b_o/k>co>c/kogEeM@;ok>c/00KoL71`ochn?_o]kNgokNg]ojNW
Yol820P2ong]k@;okno_1?oalO400om[Jf_o=CDeoo;blP03oo;blP0:oc`l
??mhN7Sol_;boo;bl_nJVY[o6QXJoo?clooBd];o0000ojn_[`Colo?c2?od
m?@02_oGemOo0000ojj^[_oemOGo?CdmogYjN_m^KVko5ADEomCDe?oinOT2
oo_kn`05olS8b?l0003oWIfMoa8B4_ofm_H00_omoOd01_lo?cooOWinoogm
oOoFe]Ko0000okFe]@;ooOgm00Ko]KFeo`000?oKfm_oo_knod10@?moOgl2
ooooo`03oj>SXolL71cooooo00Oooooo00?oLW9bocPh>?ooool00_ooool0
0ooHf=So0000okNg]`02ooooo`0@okNg]ol0003og=cLoooooomEEEGoLg=c
oa`L7?oXj>So_Kfmob4Q8Om^KVkoPH61oooooooMgMgo0000okRh^0Gooooo
00?o@410ogmoOoooool03Oooool01?lJG;?oY<?UokSBkomi[^`2ojcOo`04
ofYZJ_n^[Zkof=SHonCTi5_oi^KV00Ko4BHDo`T95?l94P[o2A8:oaXV5?lJ
4Q@3o`TB2P06o`T95?l92@[o4BHDo`T92_l92ACo2A8:0_l92@X3o`TB2P;o
2@T:00?o4BHNo`TB2_l94PX00_l92@X02?l94P[o2@T:o`T92_l94P[o2@T:
o`TB2_l92@[o2A8:0ol92@X01?l94P[o2@T:o`T92_l92@X2o`TB2P03oa4L
2_l0003o2@T:00;o2@T:00So4A`:o`T92_lA70[o6PT:oa4V5?lJ2@[o2@T:
oa4L2P;o2A8:00Ko2@T:oa4L2_l92@[o2@T:oa4L2_lJ2@X2oa4L2P03o`TB
2_lA70[o2@T:00?o2@T:00Oo2A8:o`T92_l92@[o2@T:o`000?l94P[o0000
00Go2@T:0_l94PX01Ol0003o2@T:o`T92_l92@[o4A`:00Oo2@T:00Ko2A8:
o`000?l94P[o2A8:o`000?l92@X2o`TB2P03o`000?l94P[o2@T:00?o4A`:
00?o4BH:oaX92_lA70X00_lJ2@X3ob<L2P;o;1`D00Go;2HDocdL2_ld;bWo
AT4Noc@_<`02odIEDP07ocd_?Om6GTOoEei_odI<?Ol0003o;180oaX92P0:
o`T92P0<o`TB2_l0003o2@T:o`T92_lA70[o0000o`TB2_l0003o2@T:o`T9
5?l92@[o2A8:0_l92@X00ol94P[o0000o`T92P02o`T92P07oa4L2_l92@[o
2@T:oa4L2_l92@[o2A8:o`000002o`TB2P06o`T92_lA70[o2@T:o`T92_l9
4P[o6Q8D0_l92@X2oa4L2P?o2@T:00Co2A8:o`T92_lA70[o2@T:0_l94PX5
o`T92P03o`TB2_l92@[o2A8:00?o2@T:00Co4A`:o`T92_l92@[o2@T:0ol9
4PX00ol92@[o2A8:o`T92P02o`T92P06o`TB2_l92@[o4A`:o`TB2_l92ACo
2A8:1ol92@X01Ol92ACo0000o`TB2_l94P[o4A`:00Co2@T:0_l94PX2o`T9
2P05o`TB2_l92ACo2A8:o`T95?n3Ne`0GooVi^H01?nMWIgo]kNgolS8b?oC
dm<1om[JfP000_o^k^h01?o/k>cog=cLog]kNooJf]X2on3Ph00BomCDe?on
o_koooooooclo?ojn_[ofm_KolS8b?nATI7oQ8B4oi6ATOnMWIgoZj^[ok:b
/_nh^;So`<30olK6a_o9bLWod=3@0_o?cll01?oBd];oe]KFomSHf?oHf=Pi
omKFePSoemOG1OoFe]H05?oEeMGoe=CDom?Cdoo>c/koc<c<olO7aono_koo
^KViok:b/_nWYjOoWIfMoi6ATOn3Ph?oUIFEolC4a?oMgMgon?Shoooooook
no_ooooo1OoWinL00ol`<33oJFUYonOWi`03onOWi`03onSXj?lj>S[oM7Ad
00;ojNWY00?o[Zj^o`000?oCdm<00_oZj^X01_oBd];o0000ok6a/Oo/k>co
>c/kogEeM@;ok>c/00KoL71`ochn?_o]kNgokNg]ojNWYol820P2ong]k@;o
kno_1?oalO400om[Jf_o=CDeoo;blP03oo;blP0:oc`l??mhN7Sol_;boo;b
l_nJVY[o6QXJoo?clone]KGo0000ocXj>P?o?3`l00?o^k^kooGemOoemOD0
1OoemOD02OoVi^KoBd];o`L71ooYjNWom_Kfocdm?Olf=SKo0000okfm_@02
ooShn0;on_[j00GoIVIVoclo?oojn_[o9bLWoj6QX@02oo_kn`0>ochn?_mm
OGgono_kok^k^ol0003oh^;Roo_knoolo?cohN7Qo`000?no_koooOgmoclo
?omnOWh2ooooo`03oj>SXolL71cooooo00Oooooo00?oLW9bocPh>?ooool0
0_ooool00onn_[ko0000onKViP02ooooo`0@onCTi?l0003o`L71oo_knol?
3`oo_KfmofQXJ?nJVY[oMgMgofIVI_o0`<3o;Bd]oooooonn_[ko0000ocdm
?@?o?clo00Coa<C4oooooom0@43oOgmo3_ooool01?lMGk?oYLCVokKBk_mi
[^T2oj[Po`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Co2@T:oaXB5?l92ACo
2A8:0ol92@X2o`TB2P04o`T95?l92@[o2A8:o`0000Oo2A8:00Go2@T:o`TB
2_l92@[o2@T:o`000004o`T92P04o`000?l92@[o2@T:o`T92P;o2A8:00Co
2@T:o`000?l94P[o00000_l92@X00ol94P[o0000o`T92P02o`T92P04o`00
0?l94P[o2@T:o`T92P?o4A`:0ol92@X00ol94P[o2@T:o`TB2P02o`0000;o
4A`:00[o6PT:oa4L2_lS70[o6PT:o`T92_lA70[o2A8:o`T92_l94P[o0000
0ol92@X2o`TB2P;o2@T:00_o0000o`TB2_l92@[o2@T:o`TB2_l0003o2@T:
o`000?l92@[o2A8:o`000002o`T92P;o2A8:00Ko2@T:o`000?l92@[o2A8:
o`000?l92@X2o`000003o`TB2_l0003o000000Go2@T:00Go;180oaX92_l/
4P3o2A8:oaXB5002ob`B00?o8a`:00co;1`Dob<L2_l/71Co=2lNoc@_:Old
;c?oAT`moeMED_m6C3goAUEBoeMNKom?IdL2oa4L2P04oaX92_lA70[o4A`:
o`TB2PCo2@T:00?o2A8:o`000?l94PX00_l94PX6o`T92P04o`T95?l0003o
4A`:o`0000Ko2@T:00?o4A`:o`T92_l92@X01?lA70X01Ol92@[o4A`:o`T9
2_l94P[o000000?o2@T:00Co2A8:o`T92_l92@[o4A`:0_l92@X00olA70[o
2@T:o`T92P03o`T92P03o`TB2_l0003o2@T:00Go2@T:00?o4A`:o`000?l9
2@X01Ol92@X00ol94P[o0000o`T92P02o`T92P0>o`TB2_l0003o2@T:o`T9
2_lA70[o2@T:o`TB2_l92ACo6PT:o`000?l92ACo0000o`T92_lA70X8o`T9
2P03oa4L2_l92@[o2@T:00Oo2@T:00Co6Q8Do`TB2_lJ2@[oLUEBGoo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool01?omoOgok>c/ogalO?oJ
f]X2on3Ph00AomCDe?omoOgooooooogmoOojn_[ofMWIol[:b_mgMgOoQHF5
ohf=SOnIVIWoYJFUojb/[?n`/;3o]kNgokfm_Ono_kl00oo5aLD00oo7alOo
bl_;olk>cP02olo?ccSocLg=2?o>c/h3olc<c00Fol_;boo:b/[ob<S8olO7
aoo6a/Koa<C4ol;2`_nn_[ko]kNgok:b/_n][JgoXj>SoiVIVOn=SHgoPh>3
ogemOOo7alOog=cLooShn?oooooonOWiooooo`GoinOW00Wo<30`oa/K6olm
?Cgo?CdmoeUIFOoWinOoj>SXocXj>_mOGel00_oXj>P00oo9bLWo0000ojFU
Y@02on[ZjP06oj>SXol0003ocLg=on_[jolj>S[oI6AT0_o[jn/01_m_Kfoo
;bl_on_[joo/k>coYJFUo`P820;okNg]00?okno_onk^k_o`l?000_o`l?00
0ooalO7oJf][ocDe=@04oo;blP0>oc`l??mHF5Sol_;boo;bl_nDU9Co6a/K
oo?cloo@d=3o0000oj>SXoo6a/Ko_knoo`820_oLg=`6ooKfmP04ojn_[olK
6a_o5QHFokNg]`;omoOg00Go?CdmogYjN_mCDe?oCDe=ooGem@02ooShn006
ono_kol>3PkoWIfMooShn?n<S8co?3`l0_oinOT03_ln?SkoO7alooWinOoF
e]Ko0000ojn_[ooinOWon_[jojj^[_l0003ogMgMooclo?lo?cooG5aL0_oo
ool00onMWIgo7AdMooooo`07ooooo`03og9bL_lh>3Sooooo00;ooooo00?o
g=cLo`000?nd];@00_ooool05onb/[;o0000on3Ph?o3`l?o30`<ooWinOnf
][KoBd];oc4a<OnZZZ[ooOgmoaHF5_oJf][ofm_Ko`000?n[Zj_oclo?olO7
aol30`?oiNGUoooooom0@43oJFUY00kooooo00Co6ejcojK6i_nidnkoNJk[
0_n[gol01?mfMWKo`L71oo3`l?omoOeKooooo`06oa4L2_l92@[o4BHDo`T9
5?lA70[o2A8:1?l92@X01_lA70[o2@TDo`T92_l94P[o2@T:o`TB2P;o2@T:
00Oo0000o`TB2_l92@[o2@T:o`000?l92@[o2A8:00?o2@T:00?o0000o`T9
5?l92@X00ol92@X01Ol0003o2A8:o`T92_l92@[o000000;o2@T:00_o0000
o`TB2_l0003o0000o`TB2_l0003o2@T:o`000?l94P[o2@T:oa4L2P02o`TB
2P;o4A`:00Go2A8:o`T92_l92@[o0000oa4L2P04o`T92P06o`000?lA70[o
6PT:o`TB2_l92@[o00001?l92@X3o`000004o`TB2_l92@[o2@T:o`T92P;o
000000Co2@T:o`000?l94P[o2@T:0_l000001Ol92@[o2A8:oaXB5?lJ4QCo
000000?o2@T:00?o0000o`T92_l000001_l92@X04Ol0003o2@T:o`T92_l9
4P[o6PT:ob`B0?lJ2@[o4A`:ob`B0?lJ4QCo6PT:ob<L2_l/4P3o8a`:ob<V
2_l/4P3o6Q8D00;o=2lY00Oo=2lcoeMED_m?IecoCeiVoeMED_mGIe;o4BHN
00Go2@T:00Oo0000o`TB2_l0003o2@T:o`TB2_l0003o2A8:00;o000000[o
2A8:o`000?l92@[o2@T:o`000?l92@[o2A8:o`000?lA70[o00000_l92@X0
0ol0003o4A`:o`T92P02o`TB2P;o2@T:00Go6PT:o`TB2_lA70[o6PT:o`T9
5008o`T92P05o`000?l92@[o2A8:o`T92_lA70X00_l92@X01?lA70[o2@T:
o`T92_l94PX2o`T92P03o`TB2_l92@[o2@T:00?o2@T:00?o0000o`T92_l9
2@X01_l92@X00ol94P[o2@T:o`T92P04o`T92P0<o`TB2_l92@[o2@T:o`T9
2_l92ACo0000o`T95?lm4P[oEa`0odHV5?l92@[o2A8:0ol92@X01?lA70[o
2@T:o`000?l92A@3o`T92P05o`TB2_l92@[o2@T:oa4L2_l000000_lA70X0
1Ol92@[o2A8:o`000?lJ4QCoEfMB05oooooo00Co[jn_ol_;booNg]koj^[Z
0Oobl_8000;ok^k^01Ook>c/omcLg?mkNg_ofMWIomoOgooQhN7oe=CDoocl
o?ooooooo_knoo_knooJf][ocLg=of1PH?n2PX;oQXJ6oi:BT_nOWiooYZJV
oj^[Zonb/[;o^;Rhok^k^`03okfm_@05okno_oo2`/;oa<C4olK6a_o7alL0
>?o6a/H:olG5a@05olC4a?o3`l?o`<30okjn__nl_;`00onk^k/03ong]kOo
/K6aojf][OnXZ:SoWinOoiJFU_n8R8SoPH61ofIVI_o:b/[og=cLooShn?oo
oooon_[jooooo`03onSXj0;ojNWY00Go<C4aodm?Con_[joo[jn_okRh^002
onWYj@0;ocXj>_lA4A7oQHF5om7AdOoYjNWo>c/kod92@_o<c<cobl_;od51
@Oln?Sh00_o/k>`02_lk>c_o4a<Coh61POoFe]Ko>SXjoa`L7?mIFEWod];B
ofUYJOl_;bl2ong]k@;ok^k^1?o_knl00omZJV[o=3@doo3`l003oo3`l006
oc`l??lB4Q;oKfm_om3@d?mADE7oB4Q80_oalO401_lk>c_oIFEUon_[jonG
UiOo:BTYooCdm0GomOGe00GoNg]ko`000?mBDU;og=cLooGem@02ooKfmP0A
ocdm?OmjNW[okno_ocXj>_m/K6comoOgooShn?nNWYko3@d=onk^k_ohn?So
j>SXo`P82?oAdM7onOWiochn?_mlO7`00_oinOT01_lo?cooATI6omSHf?oH
f=SoADE5od=3@`;oo?cl00Ko?clooa<C4omfMWKog]kNoeMGEom=CDd8oooo
o`03og9bL_lh>3Sooooo00?ooooo01Oo@D51odQ8B?oNg]kogMgModM7Aom4
A4CoooooogUiNOm=CDgoooooooShn?lB4Q;o0`<3ong]kOooooooIVIVohJ6
Q_oooooo?cloof][JoogmoOoWYjNob/[:`02ooooo`05od10@?lC4a?oTI6A
onCTi?omoOd02oooool01?lOHKCoXl;TokSCkomg[^/2oj[Oo`04ofi^K_nd
];Coh>3Ponc/k5_ok^k^00Ko2@TDoa4L2_l92ACo4A`:o`T95?l92@X2oa4L
2P08o`TB2_l92@[o2A8:oa4L2_l92@[o2A8:o`T92_l94PX5o`T92P04o`TB
2_l92ACo2@T:o`TB2PKo2@T:00?o2A8:o`T92_l92@X01_l92@X00olA70[o
2@T:o`T92P02o`TB2P0=o`000?l94P[o0000o`TB2_lA70[o6Q8Do`T95?lJ
2@[o4A`:o`TB2_l92@[o6PT:oa4L2P04o`T92PCo4A`:00Go;2HDo`T92_lA
70[o2@T:oa4L2P02o`T92P03oa4L2_l92@[o2A8:00So2@T:00?o2A8:o`T9
2_l92@X00ol92@X01_l94P[o0000o`TB2_lJ4QCo2@T:o`TB2P;o2@T:00Co
2A8:o`T95?l92@[o2A8:2?l92@X01olA70[o6PT:ob<L2_lA70[o6PT:oa4L
2_lJ2@X01?lS70X03Ol/71Co;2HDoc@_7_lm70[o=2lcof11:Om?IecoEeEB
oeMNKomZLUcoCeiVo`000?l94PX02Ol92@X01_l0003o2@T:o`T92_l94P[o
2@T:o`TB2POo2@T:00Co0000o`TB2_l92@[o2A8:1?l92@X01OlA70[o2@T:
o`T92_l92ACo6PT:00;o4A`:0_l92@X01?l94P[o2@T:o`T92_l94PX3o`T9
2P04oa4L2_l92@[o4A`:o`T92P;o4A`:00?o2@T:oa4L2_lA70X01?l92@X0
0olA70[o2@T:o`T92P0<o`T92P04o`TB2_l92@[o2@T:o`TB2P;o2@T:00Ko
2A8:oa4L2_l92@[o2@TDo`000?oo/`02oooI000<ooof0?oof@3o2@T:o`T9
2_l94P[o4A`:oaX92_l92@[o6PT:o`TB2_l92@[o2A8:0_l92@X01_l94P[o
2@T:o`T92_l92@[o4A`:o`TB2P;o2@T:00Co2A8:oaXB5?l0003oUHB>Goo^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H02?oTi>Coe=CDog]k
NooIfMWogmoOon7QhOoDe=CooOgm0_ooool05Ookno_ohN7Qom7AdOmEEEGo
NGUioh61POn>SXkoVYZJoj6QXOnVYZKo[Jf]ok>c/one]KGo]kNgokRh^?ni
^KWo^[Zjok^k^onl_;co_[jnokno_`0hokfm_@So_;bl0onm_Kd05_nl_;co
^k^kokVi^Onh^;So]kNgokFe]Ond];Co/K6aoj^[ZonXZ:SoY:BToiZJV_nA
TI7oPX:2ogUiNOmIFEWocLg=omoOgoohn?SooooooogmoOooool3onOWi`;o
j>SX00?o<C4aofUYJOoXj>P01?oXj>P01om<C4coOGemoeADE?l820Sog=cL
omCDe?m;Bd/00_l=3@d03_m=CDgoemOGonc/k?o/k>coCDe=oh20P?mXJ6So
3Ph>obDU9Oo5aLGoShn?oaPH6?lM7AgoX:2P0_o]kNd2onk^kPCokno_00?o
JVYZoc@d=?o`l?000oo`l?001_ll?3coMWIfog5aLOlB4Q;o:b/[okRh^0;o
lO7a00KofMWIod=3@ol<30co6QXJojn_[oodm?@4ooGem@03omcLg?l10@7o
SHf=00?omOGe0_ofm_H02Olm?CgoNWYjooKfm_oVi^Ko<c<coj>SXooinOWo
EeMGofi^KP02ooWin@06oo[jn_mYJFWoPX:2oo[jn_ln?SkoO7al0_ojn_X0
3_oShn?oD51@o`h>3_l>3PkoDU9BonKVi_olo?cooOgmoe=CDon;Rh_oNGUi
oa@D5?l^;Rkoa<C42?ooool00ombLW;o>3Phooooo`03ooooo`09onSXj?mB
DU;o3`l?o`l?3omDE5CojNWYoooooom:BT[oWYjN00;ooooo00coHF5QodE5
AOoooooooooookfm_Om=CDgoooooonKVi_m7AdOo3@d=oa`L7?ng]kL2oooo
o`05oeADE?n9RHWoGEeMo`T92Oo`l?002oooool01?lOH;CoYLCVokWCkomg
[^/2ojWLo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00[o2@T:o`T95?lA9QCo
2@T:oa4L2_l94P[o2@T:ob`V5?l92ACo4A`:0_l94PX02?lJ4QCo2A8:o`TB
2_l92ACo2@T:o`TB2_l92@[o2A8:0_l92@X00ol94P[o2@T:o`000002o`T9
2P05o`TB2_l92@[o2A8:o`TB2_l000000_l92@X01?l94P[o6Q8Do`T92_l9
4PX2o`T92P0:o`TB2_l92@[o0000o`TB2_l0003o2A8:o`000?l92@[o2A8:
o`T92P;o4A`:00?o2@T:oa4L2_l/4P000_lA70X01Ol94P[o4A`:o`000?l9
4P[o4A`:00?o6PT:00Go4A`:oaX92_lS9P[o4A`:o`T92P02o`TB2P03o`00
0?l92@[o000000Go2@T:00?o0000o`T92_l92@X00_l92@X00ol94P[o2@T:
o`T92P0<o`T92P03o`TB2_l0003o2@T:00;o2@T:00?o0000o`TB2_l00000
0ol92@X00olJ2@[o8a`:ob`B0002ob<L2P0=oa4L2_lJ2@[o6PT:ob<L2_l/
71Co8a`:ob`L5?ld;bWoARHDodI<?Om6EE;oEeEBodmNIP02of1bN`03o`TL
5?l92@[o2A8:00;o2@T:0_l94PX6o`T92P03o`TB2_l92@[o000000;o2@T:
00?o2A8:o`T92_l92@X00_l92@X00ol94P[o2@T:o`T92P02o`T92P;o2A8:
00?o6Q8Do`T92_l92@X00_l92@X3oa4L2P0;oaX92_l92@[o2A8:o`000?l9
2@[o2A8:o`T92_l0003o2@T:o`TB2_lJ2@X00ol92@X00olA70[o2@T:o`T9
2P02o`T92P03o`000?l94P[o6Q8D01Co2@T:00Co2A8:o`T92_l94P[o2A8:
0_l92@X02olm4P[odh@0ok1b0?of/`3oUED0og8V0?niI`3oomT0oeLL0?l9
2@[o4A`:00Co2@T:00Co2@TDo`T92_l94P[o2@T:0_l94PX02_l92@[o4A`:
o`T92_l92@[o4A`:o`T92_lJ4QCo2@TDo`000?o1alaOonKViP04oifMWOng
]kOob<S8om?Cd`7of][J0002onk^kP0Jonc/k?oLg=coO7alom[Jf_oOgmoo
hN7QomCDe?ono_kooOgmooooooolo?cok>c/omKFe_mIFEWoJf][ogalO?n7
QhOoU9BDoiZJV_nNWYkoY:BTojVYZOn/[:co/;2`ok:b/_nd];@3okFe]@03
okJf]_ng]kOo];Bd03Oo];Bd2?ne]KD00ond];Co]KFeokFe]@04okJf]P0?
okFe]On^[Zko[Jf]ojVYZOnSXj?oWinOoi^KVonBTY;oR8R8ogUiNOm]KFgo
F5QHomCDe?oXj>SonOWi00?ooooo0ooWinL2onSXj003oc4a<OmYJFWoj>SX
00Goj>SX0_oYjNT01?oVi^Koj^[Zon[Zj_o[jn/2on[ZjPOok>c/00?ojn_[
onc/k?o/k>`00_o]kNd01?o/k>cokNg]ong]kOo]kNd2onk^kPCokno_00?o
JVYZoc@d=?o`l?000oo`l?001?ll?3coMgMgoo3`l?o_knl2oo3`l0?olO7a
00?olo?coo3`l?oemOD00_oemOD4ooKfmP03om3@d?l10@7og]kN00?om_Kf
0_ogmoL00olm?CgoNg]kooShn003ooWin@?on_[j0_okno/4ooclo003oclo
?ommOGgoo?cl00?oo?cl0_okno/01?olo?cooOgmoogmoOono_h3ooooo`03
ookno_oooooooooo00Sooooo00?oLW9bocPh>?ooool01Oooool2ooknoQ3o
oooo00?oo?clooooooooool01Oooool00oolo?coooooooooo`0:ooooo`04
oa]O]_nTa>Ko^M?_ogJ]jP;oZn3o00CoKVi^okBd]?oPh>3ok>c/Foo^k^h0
1?lA9QCo2A8:o`T95?lA70X2o`T92P03oa4L2_l94P[o2A8:00;o2A8:0_l9
2A@00ol94P[o2@T:oa4L2P04o`TB2P06o`T92_l94P[o2A8:o`TB2_l92@[o
6Q8D0_l94PX00olJ2@[o2@TDo`TB2P02o`TB2P03o`T92_l94P[o2A8:00Ko
2@T:00Co4A`:o`000?l94P[o00000_l92@X2o`TB2P;o4A`:00Ko8a`:oaX9
2_lA70[o4A`:oa4V2_lJ2@X2oa4L2P05o`T92_l94P[o4A`:o`T92_lJ2@X0
0_lA70X00ol92@[o6PT:oa4L2P04o`T92P06o`TB2_l92@[o2A8:o`T92_l9
2ACo2A8:0_l92@X00ol94P[o2@T:o`000002o`T92P03o`TB2_l92@[o2@T:
00Co2@T:00?o2A8:o`T92_l92@X01Ol92@X00ol94P[o2@T:o`TB2P02o`TB
2P?o2@T:00Ko2A8:oa4L2_lS70[o8a`:oa4V2_lJ4Q@2ob`B0004ob<V2_lS
70[o8a`:ob`L50;o;2HD00?o=2lYoc@_<om6C3d00_m?GVH02OmGGVooAUi7
o`000?l94P[o0000o`T95?l94P[o0000o`TB2P02o`T92P0:o`TB2_l92@[o
2@T:o`000?l92@[o2A8:o`T92_lA70[o0000o`TB2P;o2@T:00Co2A8:o`T9
2_l92@[o2A8:0_l92@X03?lA9P[o2A8:o`T92_l92@[o2A8:oa4L2_l92@[o
2A8:o`T92_lA70[o6PT:oa4V50;o2A8:00Co2@T:o`TB2_l92@[o2A8:1?l9
2@X01?lA70[o2@T:o`TB2_l92@X2oa4L2P03o`TB2_l92@[o2A8:00Co2@T:
00?o2A8:o`T92_l92@X00_l94PX01_l92@[o4A`:o`T92_l92@[o2A8:o`T9
2P;o2A8:00?o2@T:oa4L2_l94PX00ol94PX00ol92@[o2A8:o`T92P02o`T9
2P09oh<_0?ood03oLRH0oonc0?mG703o2@TDok1<0?ood03oEa`000;o2@T:
00Co4A`:o`T92_l92@[o2A8:0_l92@X03_l94P[o2@TDo`TB2_l92@[o2A8:
o`T92_l94P[o2@T:o`TB2_l92@[o2@TDo`T92_l0003o`LO<Goo^k^h01?nS
Xj?o_Kfmolo?cooJf]X1on7Qh@000_ooool06oomoOgok>c/ogalO?oIfMWo
h>3Pon7QhOoEeMGoooooooclo?oooooooOgmooOgmooIfMWoI6AToeiNG_m_
KfooO7alohR8R?n?ShooU9BDoi^KVonQXJ7oXj>SojJVY_nZZZ[o[Zj^ok6a
/@03ok2`/003ok6a/On_[joo[jn_03Ko[jn_2?n`/;03ojn_[`0Cok2`/?n_
[joo[jn_ojj^[_n][JgoYJFUojBTY?nOWiooVIVIoiFEUOn@T93oQXJ6ogal
O?m]KFgoGemOof1PH?oLg=com?Cdooclo003ooooo`GoinOW00?o<30`obTY
:OmKFe/00_mKFe/00onVYZKoj>SXonSXj003onSXj0;ojNWY1_oZj^X:on_[
j`?ok>c/0_o]kNd01_o^k^koKfm_oeiNG_mNGUko:RXZoa@D50?oGUiN00Co
gmoOoc/k>omgMgOokno_0oo`l?03oo7al@03oo?cloobl_;om?Cd00;om?Cd
0_oemOD3ooKfmP05odM7Aolg=cOoR8R8oeiNG_mDE5@00_ogmoL00olm?Cgo
Ng]kooOgm`03ooShn0GonOWi1?ojn_X00oln?SkoO7aloo[jnP04oo[jnP;o
no_k0_olo?`00oomoOgoo_knooknoP09ooooo`05ogMgMomUIFGoIFEUobd]
;OlF5QH00omUIFD00oo^k^koooooooooo`0Wooooo`04oa]N/onUa>Ko]M3^
ogV^k0;oYmco00CoMWIfol71`Oo`l?3ooOgmFoooool2o`TB2P04oaXB5?l9
4P[o2A8:oa4L2PCo2@T:00So2A8:oaXB5?lJ4QCo2@TDo`TB2_lJ4QCo2@T:
o`TB2P;o2@T:00?o0000o`TB2_l94PX00_l92@X01OlJ4QCo2@T:o`T92_l9
2@[o2A8:00;o2@T:00Go2A8:o`T92_l92@[o0000o`TB2P05o`T92P05o`00
0?l94P[o2@T:o`000?l94PX00ol92@X01olJ2@[o2A8:o`T92_lA70[o2@T:
oaX92_l/4P000ol92@X00ol0003o2@T:o`TB2P02oa4L2P;o2@T:00So4A`:
o`T92_l92@[o4A`:o`T92_l94P[o2@T:o`TB2P;o2@T:0_l94PX5o`T92P03
o`TB2_l92@[o2@T:00;o2A8:00?o2@T:o`TB2_l92@X00ol92@X01?l94P[o
0000o`T92_l00003o`T92P03o`000?l92@[o2@T:00;o2@T:00Go0000oa4L
2_l0003o4A`:oaX92P02ob<L2P05ob`B0?lS70[o8a`:ob<L2_lJ2@X00olS
70X00ol/9QCo=2lNoc@_<`02oeMEDP04odmNI_mbLW_oCfMLoa4V2P;o2@T:
00Co0000oa4L2_l0003o2A8:0ol92@X00ol0003o2A8:o`T92P02o`TB2P09
o`000?l94P[o2@T:o`T92_l0003o2A8:o`T92_l0003o2A8:00?o2@T:0_l9
4PX01?l0003o2@T:o`T92_l94PX2o`T92P0:oa4L2_l92@[o4A`:oa4L2_lJ
2@[o4A`:o`T92_l94P[o2@T:o`0000Co2@T:00Ko2A8:o`T92_lA70[o2@T:
ob<L2_lA70X2o`TB2P;o2@T:00Go2A8:oa4L2_l92@[o2@T:oa4L2P07o`T9
2P05o`TB2_l92@[o2@T:o`T92_l94PX00_l92@X04_l94P[o2@T:o`T92_l9
2@[o2A8:o`T92_l94P[o2@T:oh<_0?oomP3oLRH0o`T95?oo/`3oH2l:o`00
0?niI`3oom00oeLL00Co2@T:00?o4A`:o`T92_l92@X00ol92@X01?l94P[o
2@T:o`T92_l94PX2o`T92P06oa4L2_l92@[o2@T:oa4L2_l0003oY[?1Gooo
ool01?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h06_o/k>cog=cLogal
O?oIfMWoh>3Pon7QhOoEeMGooooooo_knooooooooOgmookno_oLg=coKFe]
oeEEEOmSHf?oL71`oginO_n6QXKoSHf=oiJFU_nMWIgoX:2PoijNW_nTY:Co
ZZZZ0_n][Jd00on/[:co[Jf]ojf][@0hojf][@So[:b/0_n^[Zh05On][Jgo
[:b/ojVYZOnWYjOoYJFUoj>SXonNWYkoWIfMoiRHV?nBTY;oSHf=ohN7Qomm
OGgoLg=cofEUIOmFEUKoJ6QXon;Rh_omoOgoo_knoo_kn`02ooooo`GoinOW
00?oWinOoh^;Ron;Rh/00_n;Rh/00onm_Kgoj>SXonSXj003onWYj@03on[Z
j_oYjNWoj^[Z00;oj^[Z0oo[jn/7onc/k0KokNg]0_o^k^h00oo_knooVi^K
oi2@T006oi2@T003onGUiOll?3coMgMg00Col?3`0ooalO400ooclo?om?Cd
ooKfmP02ooKfmPGomoOg00Golo?cok2`/?mZJV[oPh>3okVi^@02ooShn003
ochn?_mkNg_on?Sh00;onOWi00?on?ShooWinOoinOT00ooinOT4oo[jnP03
ochn?_mlO7con_[j00Con_[j0_okno/2ooclo003oogmoOono_koo_kn00Wo
oooo00?oYZJVoiZJV_nJVYX01OnJVYX00oodm?Coooooooooo`0Wooooo`04
oa]O]_nTa>Ko^=;^ogJ]jP;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h0
0ol92ACo4A`:o`T95006o`TB2P07o`T92_l94P[o2@T:oa4V5?l92@[o2A8:
o`T92P05o`TB2P08o`T92_l94P[o2@T:oa4L2_l92@[o4A`:o`TB2_l92A@2
o`TB2P?o2@T:00Oo2A8:o`T92_l92@[o2A8:o`T92_l94P[o2@T:00;o2A8:
00Ko2@T:o`000?l94P[o0000o`TB2_l00002oa4L2P03oaX92_lA70[o;180
00?o4A`:00?o2@T:oa4L2_l92@X00_l92@X01?lA70[o6PT:oaX92_l92@X2
oa4L2P05o`T92_l94P[o4A`:o`T92_l000000ol94PX2o`T92P03o`000?l9
4P[o4A`:00;o2@T:00So4A`:o`T92_l92@[o2@T:o`TB2_l0003o2A8:o`T9
2P;o2A8:0ol92@X00ol0003o2@TDoa4L2P02o`T92P03o`TB2_l92@[o2A8:
00?o2@T:00Oo2A8:o`000?l94P[o2@T:oaX92_lS70[o;18000;o8a`:00?o
;180oa4L2_l/4P000_lS70X02Ol/71Co=2lNoc@_:Om6@AkoEeEBodmNI_mb
EE;oPhB>ob<_<`02o`TB2P;o2@T:00Go2A8:o`T92_l92@[o2@T:o`TB2P02
o`T92P07o`000?l94P[o0000o`TB2_l92@[o0000o`TB2P03o`T92P03o`00
0?l94P[o2@T:00Co2@T:0_l94PX00olA70[o2@T:o`T92P02o`TB2P03o`T9
2_lA70[o2@T:00;o4A`:0_l94PX00ol0003o2A8:o`T92P02o`TB2P0:o`T9
2_l94P[o2A8:o`T92_lA70[o0000oa4V5?l92@[o6PT:o`TB2P;o2@T:00Go
4A`:o`T92_l92@[o2@T:o`TB2P03o`T92P03o`TB2_l92@[o2@T:00;o2@T:
00?o4A`:o`TB2_l94PX00_l92@X00olA70[o2@T:o`T92P03o`T92P0=o`TB
2_l92@[o2@T:og8V0?oof@3oPbl0o`000?oof@3oEa`0ocdB2_n`C03oom00
oeLL0002o`T92P05oa4L2_l94P[o2@T:o`T95?l94PX00_l92@X01?l94P[o
2@T:o`TB2_l92@X2o`TB2P;o2@T:00Go4A`:oaXB5?lA70[o0000ok2n`@1O
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002onKViP08onCTi?oDe=Co
Ng]kom[Jf_oOgmoohN7QomGEeOomoOd2ooooo`0@ooCdm?oooooom?Cdoi2@
T?m>CTkoHV9RoeIFE_mZJV[oRh^;oi6ATOnPX:3oZ:RXojn_[on^[Zko/k>c
okFe]@;o];Bd00?o][JfokNg]onf][H04?nf][HHokNg]aWo][Jf0_ni^KT0
5_nf][Ko]KFeokJf]_nf][Ko];BdojRXZ?nj^[[oVIVIoibLW?nKVi_oMWIf
ofi^K_mOGeooC4a<odi>C_n8R8Soooooooclo?o_knooooooooGemOooool3
onOWi`[oj>SX0ooYjNT2on_[j`?okNg]2_o^k^h7ono_k`Kol?3`1OoalO40
0oo]kNgokno_oo7al@03oo7al@?ol_;b0_odm?@3ooKfmP[omoOg0_ohn?P0
0oodm?Com_KfooShn008ooShn0ConOWi00?omOGeooOgmooinOT01?oinOT2
oo[jnP?oo?cl0_ono_hkooooo`04oaeO/onVa^Ko]]3^ogV_kP;oZmko00Co
JVYZojj^[_oHf=Soi>CTFooVi^H3oaXB5004oa4L2_l971Co2A8:o`T950;o
2A8:1?l92@X2o`TB2P05o`T92_l94P[o0000o`TB2_l92@X00_l94PX02?l9
2@[o4A`:o`T92_l94P[o6Q`NoaXB5?l92ACo2@T:0_l94PX02ol92ACo2A8:
o`TB2_l92@[o2A8:o`T92_l94P[o2@T:o`TB2_l0003o2@T:00;o2A8:00Oo
0000o`TB2_l0003o2@T:o`TB2_l92@[o2A8:00;o4A`:00Go4BHDo`TB2_lJ
2@[o4A`:o`TB2P02o`T92P03oa4L2_l92@[o2@T:00;o4A`:00So2@T:oaX9
2_lA70[o2@T:o`TB2_l0003o2@T:o`TB2P;o2@T:00So2A8:o`T92_l94P[o
2@T:o`TB2_l92@[o2A8:o`0000Ko2@T:00?o2A8:o`000?l94PX00_l92@X2
o`TB2P0;o`000?l92@[o2A8:o`TB2_l0003o2A8:o`000?l94P[o2@T:o`TB
2_l000000_l92@X01ol94P[o6PT:ob<L2_lS70[o?A`:ob<L2_l/71@01?lS
70X01?l/71Co=2lNoc@_<om6C3d3odmNIP05ofYkQ?l971Co4BHDo`T92_l9
4PX00ol92@X01Ol94P[o2@T:o`000?l0003o2A8:00co2@T:0_l94PX3o`T9
2P06o`TB2_l0003o0000o`T95?l92@[o4A`:0_l92@X01_lA70[o2@T:oa4L
2_l94P[o4A`:o`TB2P?o2@T:00Ko0000o`TB2_lJ2@[o2A8:o`T92_lA70X2
o`T92P03oa4L2_l92@[o2A8:00;o2A8:00?o2@T:o`TB2_l92@X00_l92@X0
1?l94P[o4A`:o`T92_lA70X3o`T92P03o`TB2_l92@[o2A8:00;o2@T:00Co
4A`:o`T92_l92@[o4A`:1ol92@X01Olm4P[oi:X0ob<L2_l0003oH2l:00?o
omT000Go2@T:o`TB2_l92@[o2@T:oa4L2P04o`T92P06oa4L2_l94P[o2@T:
oa4L2_l92@[o4A`:0ol94PX01_lA70[o2@TDo`T92_l92ACo0000ok2n`Eoo
i^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;ok^k^00Wok>c/omcLg?mg
MgOof][Jon3Ph?oQhN7oe=CDoooooooinOT00_ooool05?ogmoOoo_knol;2
`_ll?3co@T92odU9BOmZJV[oMWIfoibLW?ne]KGo_;blokBd]?no_kooa<C4
olK6a_o5aLGoa<C4olK6a_o7alOoaLG54?o9bLTHolO7aaSobLW900OoaLG5
olS8b?o8b<SoaLG5olC4a?o6a/KoaLG500;o`l?300_o]KFeokRh^?nk^k_o
QhN7ofYZJ_mbLW;oB4Q8oeIFE_m0@43o`/;2ooGem@02ooooo`03ooKfm_oo
oooooooo00_oi^KV1OoWinL00ooXj>SojNWYon[ZjP05on[ZjPOojn_[0oo/
k>`3ong]k@03ono_koo^k^kol?3`00;ol?3`0_oalO4;oo;blPColo?c1?od
m?@:ooGem@?om_Kf0_ogmoL2ooWin@04ooShn?ojn_[on_[joo[jnP;ono_k
3Oolo?`2oogmo@03ookno_oooooooooo03_ooooo00Co6UbcojC3iOnhd^oo
NJk/0_n/gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP06oa4L2_l94P[o2A8:
o`T95?l94P[o2@T:0_l94PX00ol0003o2A8:o`TB2P03o`T92P04o`TB2_l9
2@[o2@T:o`T92P;o2A8:00Go2@T:o`TB2_l94P[o2@T:o`TB2P02o`T95007
o`TB2_l92@[o2A8:o`TB2_l92@[o2A8:o`000008o`T92P06o`TB2_l0003o
2@T:o`T92_l0003o2@T:0_l94PX02?lA70[o6PT:oaX92_lA70[o;180oa4L
2_l92@[o2A8:0_l92@X01Ol0003o2@T:o`T92_l92@[o6PT:00;o4A`:00?o
2@T:oa4L2_l92@X00ol92@X01?l0003o2@T:o`TB2_l00007o`T92P03o`00
0?l92@[o000000Ko2@T:00Ko2A8:o`000?l0003o2A8:o`000?l92@X2o`00
0006o`TB2_l92@[o2@T:o`000?l92@[o00001Ol92@X01Ol/4P3o6PT:oa4L
2_l/71Co;18000Co8a`:00So;2HDoc@_:Om6@AkoAUEBoeMED_m?GVKoH79k
ofYkQ0?o00001?l92@X02?l0003o2A8:o`T92_l92@[o0000o`T92_l0003o
2A8:0_l92@X02_l94P[o2@T:o`T92_l94P[o2@T:o`000?l94P[o0000o`T9
2_l94PX5o`T92P03ob<_:Ol92@[o2@T:00Go2@T:00?o;180oaX92_l94PX0
3?l92@X00olA70[o2@T:o`TB2P03o`T92P03o`TB2_l92@[o2@T:00Go2@T:
00?o2A8:o`000?l92@X00_l000001?l92@[o2A8:o`T92_l0000:o`T92P;o
000000Ko2@TDo`000?o1Q03oYVL0oheE2_l00008o`T92P03o`000?l92@[o
2@T:00So2@T:00Co4A`:o`000?l0003oUJ6gGoo^k^h01?nSXj?o_Kfmolo?
cooJf]X1on7Qh@000_ooool01?omoOgok>c/ogIfM_oIfMT2omoOg`0FomCD
e?oooooon_[jookno_oooooolO7aooooooomoOgoPh>3odA4A?m3@d?oCTi>
ogIfM_nWYjOo_KfmokRh^?o7alOo`/;2olO7aoo:b/[obLW9olS8b0;obLW9
00?oalO7ol[:b_o:b/X0?_o:b/X05Oo9bLWobl_;ol_;boo9bLWob<S8olW9
bOo8b<SoaLG5olO7aono_koo]KFeokVi^OnXZ:SoKVi^od=3@om1@D7o=CDe
ohZ:R_oclo?on?ShooknoP02ooooo`03ooclo?ooooooiNGU00[oiNGU1OoV
i^H2onSXj0Koj^[Z2_o[jn/3onc/k0;okNg]0oo^k^h:ono_k`?ol?3`0ooa
lO400oobl_;olO7aoo;blP02oo;blP;olo?c2?odm?@3ooGem@;om_Kf0ooh
n?P3oo[jnP;ono_k3Oolo?`2oogmo@03ookno_oooooooooo03_ooooo00Co
7EncojG4i_nfd^koNJkY0_nZh?l01?mfMWKo`L71oo3`l?omoOeKooooo`03
oa4V5?l92@[o2A8:00;o2@T:00?o2A8:o`T92_l000001_l92@X00ol0003o
2A8:o`T92P03o`T92P04o`000?l92@[o2@T:o`0000;o2@T:00Co2A8:o`T9
2_l92@[o2A8:1_l92@X00ol0003o2@T:o`000003o`T92P03o`000?l92@[o
000000;o2@T:0ol000001ol94P[o2@T:oa4L2_lA70[o2@T:oaX92_l92@X0
0_l000002?l94P[o0000o`T92_l94P[o4A`:o`TB2_lJ2@[o4A`:0_l92@X0
1?l94P[o4A`:o`000?l00002o`T92P04o`000?l92@[o2@T:o`TB2P;o2@T:
00Co0000o`T92_l92@[o00001?l92@X01?l0003o2@T:o`000?l94PX3o`T9
2P03o`000?l92@[o000000;o2@T:00Ko0000o`T92_l92@[o2@T:o`000?l9
2@X2o`000007o`TB2_l0003o4A`:oaX92_lS70[o;180ocdL2P02ob`B00;o
8a`:00Wo;1`Doc@_7_ld;bWo=2lNodI<?Om?GVKoEei_og9bNom6GTL00_l0
00001_l92@[o0000o`T92_l92@[o0000o`T950?o000000?o2@T:o`000?l9
4PX00_l000001_l92@[o0000o`TB2_l0003o2@T:o`0000Go2@T:00?o0000
o`TB2_l92@X00_l92@X00ol94P[o4A`:o`000004o`T92P03oa4L2_l92@[o
4BHN00;o2@T:00?o0000oa4L2_l92@X01ol92@X01?lA70[o2@T:oa4L2_l/
71@5o`T92P03o`000?l92@[o2@T:00[o2@T:00?o0000o`TB2_l000000ol9
2@X00ol0003o2@T:o`T92P02o`T92P03o`TB2_l92@[o2@T:00;o2@T:00Co
0000o`T95?l0003o2@TD5?l92@X00olA70[o0000ojJZ[@1Oooooo`04ojn_
[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP07onc/k?oMgMgoLW9bomOGeooO
gmooh>3Pom;BdP02ooooo`03ooShn?olo?cooooo00;ooooo00kolO7aoeQH
F?l[:b_o>SXjoemOGomkNg_o`L71okjn__o1`L7o`/;2olO7aoo:b/[obLW9
olS8b0;obLW900?oalO7olS8b?o8b<P03_o8b<PHolW9bASob<S800?obLW9
olc<c?o;bl/00_o9bLT04_o:b/[ob<S8ol?3`oo3`l?oaLG5olc<c?n][Jgo
OGemof1PH?m2@T;o:b/[oe]KFooooooonOWiooOgmooooooono_kooWin@;o
oooo2ooVi^H2onOWi`?oj>SX0_oYjNT3on[ZjP?ojn_[1oo/k>`6ong]k@03
onk^k_o_knool?3`00Col?3`2ooalO43oo;blP;olo?c0oodm?@:ooGem@Go
m_Kf0_ogmoL00oofm_KomoOgooOgm`03ooOgm`_on?Sh0_oinOT3oo_kn`;o
oOgm4Oono_hZooooo`04oa]N/onVa^Ko^M?^ogV^j`;oZmoo00CoKVi^okBd
]?oPh>3ok>c/Foo^k^h2o`TB2P07oa4L2_l94P[o2@T:o`T92_lA70[o2A8:
oa4L2P04o`T92P04o`TB2_lJ2@[o2@T:o`T92P?o2A8:00Go2@T:o`TB2_l9
4P[o2A8:o`T92P06o`TB2P;o2@T:00Ko2A8:o`T92_l92@[o2A8:o`T92_l9
4PX6o`T92P08oa4L2_l0003o2@T:o`TB2_l92@[o4A`:ob`B0?lA70X2ob<L
2P04oaX92_l94P[o2@T:o`T92P;o2A8:00?o2@T:oa4L2_lJ2@X00_lJ2@X0
1OlA70[o6PT:o`T92_l94P[o6PT:00Ko2@T:00?o2A8:o`000?l94PX00_l9
2@X00ol94P[o4A`:o`T92P08o`T92P03o`000?l94P[o2A8:00;o2@T:00Go
2A8:o`T92_l92@[o0000o`TB2P02o`T92P03o`TB2_l92@[o2@T:00?o2@T:
0_lJ2@X4ob<L2P09ob<V2_l/71Co?A`:ob`V5?ld;ako=2lYodI<?OmbEE;o
Eei_00;oH79k00?o8blco`000?l94PX01Ol92@X01_l94P[o2@T:o`T92_l9
2@[o0000o`TB2POo2@T:00?o2A8:o`T92_l92@X01?l92@X04?l94P[o2@T:
o`T92_l0003o2@TDo`T92_l0003o2@TDo`T92_lA70[o6PT:oa4L2_l92@[o
4A`:oaX92_lA70X4o`T92P0;oaX92_l92@[o2@T:o`T92_l94P[o4A`:o`T9
2_lJ4QCo2@T:oa4L2_l94PX02ol92@X01?lJ4QCo2A8:ob<L2_l94PX@o`T9
2P04oa4L2_l92@[o6PT:o`TB2P;o4A`:1Ol92@X01_lA70[o0000oa4L2_l9
2@[o4A`:o`T950;o2A8:1?l92@X01ol0003o4A`:o`T92_lJ4QCo2A8:o`T9
2_nEXKL0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H01?oT
i>CoemOGog5aLOo?cll2omgMg@08om7AdOokno_oooooooooooolo?cooooo
ooclo?o[jn/2ooooo`09ocHf=_m0@43oCdm?oh61POnMWIgo[:b/ok6a/Onh
^;So_[jn00?o`/;20_o3`l<00oo1`L7o`l?3ol?3``0>ol?3`aSo`/;26?o3
`l<00oo1`L7o`l?3ol;2`P02ol71`@0=ol;2`_no_koo^KViokfm_Onh^;So
[Zj^oi:BT_mZJV[o>SXjobXZ:_m>CTkon_[jonk^kP02ooooo`05onWYjOoo
ooooooooooclo?ooool02ooUiND5onKViP03onSXj?oWinOojNWY00GojNWY
2_oZj^X3on_[j`03onc/k?o]kNgok^k^00;ok^k^2_o_knl3oo3`l0?olO7a
0_obl_83oo?cl`;om?Cd2?oemOD5ooKfmP;on?Sh00?omoOgooWinOoinOT0
0ooinOT;oo[jnP;ono_k0oolo?`2oogmoA7oo_kn:_ooool01?lOHKCoXl;T
okSCkomg[^/2oj[Oo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00So6Q8Do`T9
5?l92ACo2A8:o`T95?lA70[o2@TDo`T92PCo2A8:0_l92@X01_l94P[o2@T:
o`TB2_lJ4QCo2@T:oa4L2P?o2@T:00?o2A8:o`T92_l94PX00_l92@X00ol9
2ACo2A8:o`TB2P02o`TB2PCo2@T:00?o4A`:o`TB2_l92@X00_l92@X03?l9
4P[o2@T:o`TB2_l0003o2@T:o`TB2_l0003o2A8:oaX92_lA9Qko4A`:ob`B
00;o4A`:017o2A8:o`T92_lJ4QCo0000o`T92_l94P[o4A`:oaX92_lS70[o
6PT:oa4L2_lJ2@[o2@T:oa4L2_lJ2@[o2@T:o`TB2P03o`T92P07oaXB5?l0
003o2@T:o`T92_l94P[o2@T:o`TB2P02o`T92P04oa4L2_l94P[o2@T:o`TB
2PGo2@T:00?o2A8:o`T92_l92@X01_l92@X00ol94P[o0000o`T92P05o`T9
2P0Aoa4L2_lJ2@[o8a`:ob`L5?lS70[o?A`:ob<V2_l/71Co=2lNob<_7_ld
;c?oH44Yoc@_<om?GVKoLUEBog9WD_m?GVH00_l94PX6o`T92P05o`000?l9
2@[o2@T:o`T92_l94PX00ol92@X00olA70[o2@T:o`TB2P03o`T92P06o`TB
2_l92@[o2@T:o`T92_l94P[o00000_l92@X00ol94P[o2@T:o`T92P05o`T9
2P;o4A`:00Co2A8:oa4L2_lA70[o2@TD1ol92@X02?lJ4QCo2@T:o`T95?l9
4P[o2@T:o`TB2_lA70[o2@TD5_l92@X01ol94P[o2@T:o`TB2_l94P[o2@T:
o`TB2_lJ4Q@01Ol92@X00ol94P[o2@T:o`T92P02o`T92P03oa4L2_l92@[o
2@T:00Co2@T:00Oo4A`:o`T95?lJ4QCo2@T:o`TB2_lA70[o2A8:00?o4A`:
00Go2@T:o`TB2_l92@[o0000oiFQ]`1OonKViP04oifMWOng]kOob<S8om?C
d`7of][J0002onk^kP0:ong]kOoPh>3oNWYjokno_ooHf=Sof][Jolc<c?oo
oooon_[jooooo`;oo?cl013oooooooCdm?oooooojn_[oooooom6ATKo<S8b
odM7Aom/K6coUiNGojNWYonTY:CoZj^[ok2`/?nb/[;o/k>c0_nf][H00ond
];Co]KFeokFe]@0nokFe]@0Dok:b/_nc/k?o/[:bok6a/Onb/[;o/k>cojj^
[_nWYjOoVIVIok2`/?n:RX[oH61PodM7AolT92CoIVIVookno_oooooonOWi
ooooooobl_82ooooo`03ooGemOoooooooooo00_oi>CT1OoUiND2onOWi`Ko
jNWY2_oZj^X4on_[j`Cok>c/2_o]kNd6onk^kP03oo3`l?o_knoolO7a00Co
lO7a2?obl_83oo?cl`;om?Cd0_oemOD01?ofm_KomoOgooOgmoogmoL2ooSh
n0_onOWi0_ojn_X3oo_kn`;oo?cl4?omoOd3ooknoRSooooo00Co7f2dojG4
i_nidnooMjk[0_nYg?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP08o`T95?l9
2@[o2@T:oa4L2_l92@[o4A`:o`T92_lA70X2o`T92P;o2A8:0_l92@X02?l9
4P[o2@T:o`T92_l92@[o2A8:oa4L2_l94P[o4A`:0_l92@X01OlA70[o2@T:
o`T92_l94P[o2@T:00;o2A8:00Co2@T:o`TB2_l92@[o2A8:0_l92@X01Ol9
4P[o2@T:o`T92_l92@[o2A8:00Ko2@T:00?o2A8:o`000?l92@X00_lA70X0
0olA9P[o6PT:oa4L2P02o`TB2P04o`000?l92@[o2@T:o`T92P;o4A`:00Co
2@T:oa4L2_lJ2@[o4A`:0_l92@X00olJ2@[o4A`:o`T92P02o`T92P03oa4L
2_l0003o2@T:00So2@T:00Ko2A8:o`000?l92@[o2@T:o`TB2_l00005o`T9
2P08o`TB2_l0003o2@T:o`T95?l0003o2A8:o`T92_l94PX8o`T92P07ob<L
2_l/4P3o;180ob<L2_l/71Co;2HDoc@_:@02odHV5006oc@_<om6C3goEei_
og9bNomGGVooAUi70_l92@X01?l0003o2@TDo`T92_l94PX2o`T92P03o`TB
2_l92@[o2@T:00;o00000_l92@X00ol0003o2@T:o`000003o`T92P;o2A8:
0_l92@X00ol94P[o2@T:o`T92P08o`T92P04oaX92_l92@[o2@T:o`T92P;o
6Q8D0_lA70X01Ol94P[o2@T:o`T92_l92@[o4A`:00;o2@T:00Wo2A8:o`T9
2_lA70[o2@TDoa4L2_lJ4QCo2A8:oa4L2_l94PX01ol92@X00olA70[o2A8:
o`T92P0:o`T92P03o`TB2_l0003o2@T:00?o2@T:00Go2A8:oaXB5?l92@[o
2@T:oa4L2P02o`T92P03oa4L2_l92@[o2@T:00;o2@T:00?o2A8:o`T92_l9
2@X00ol92@X00ol94P[o2@T:oa4L2P08o`T92P05oa4L2_l92@[o2@TDo`00
0?nEZZd0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool03?on
o_kom_KfoiZJV_nTY:Cod];BomCDe?o2`/;oooooookno_oooooono_kooSh
n0Cooooo00kon_[joooooomgMgOo@T92obl_;om9BDWoEeMGogEeMOmlO7co
Ph>3ohJ6Q_n9RHWoS8b<ohf=SA7oRh^;6?n=SHdIoh^;R`0@ohb<S?n;Rh_o
RXZ:ohb<S?n=SHgoQhN7ogmoOomfMWKoE5ADoc4a<Ol_;boo?Shnohb<S?o`
l?3ono_konk^kP;ooooo00KonOWiooooooojn_[oooooooOgmoooool3on3P
h0[ohN7Q0ooRh^800ooTi>Cohn?SonGUi@02onGUi@[oi^KV1ooWinL6onSX
j0_ojNWY0ooZj^X00oo/k>cojn_[ong]k@02ong]k@[ok^k^1oo_knl6oo3`
l0SolO7a0oobl_82oo?cl`?omOGe0_ogmoL3ooShn0[onOWi0oojn_X3oocl
o0;oo_kn9_ooool01?lKGkKoY<CVokWCkomf[NX2oj_Po`04ogIfM_o1`L7o
l?3`oogmoE_ooooo00Go4BHDo`TB2_lA70[o2@TDo`T92P03o`TB2P;o2@T:
00Go2A8:o`T92_l94P[o2@T:o`TB2P09o`T92P07o`TB2_l92@[o4A`:o`T9
2_l94P[o0000o`TB2P03o`T92P03o`T95?l94P[o2A8:00;o2@T:00?o0000
o`T92_l92@X00_l92@X01?l94P[o2@T:o`T92_l94PX2o`T92P0:oaX92_lA
70[o;180oa4L2_lJ2@[o;180o`T92_lJ4QCo0000o`TB2P?o2@T:00Wo6PT:
oa4L2_lJ2@[o4A`:oaX92_lA70[o0000o`TB2_lA70X00ol92@X00ol0003o
2A8:o`TB2P09o`T92P06o`TB2_l92@[o2@T:o`000?l92ACo2@T:0ol94PX0
1Ol0003o2A8:o`TB2_l94P[o000000?o2@T:00?o0000o`TB2_l92@X00ol9
2@X01?l94P[o2@T:oa4L2_lA70X3ob<L2P04ob`L5?ld;akoH44YodI17P?o
AT`m00_oLUEBof1bNomGGVoo=2lco`000?l92ACo4A`:o`000?l92@[o0000
o`T95002o`T92P03o`000?l94P[o2@T:00Go2@T:00?o2A8:o`T92_l94PX0
0_l92@X01Ol0003o2A8:o`T92_l0003o2A8:00;o2@T:00Go2A8:o`T92_l9
2@[o0000o`TB2P06o`T92P05oaX92_lA70[o6PT:oaX92_l94PX01ol92@X0
1olA70[o2@T:o`T92_lA70[o2@T:oa4L2_lJ2@X00_l92@X01ol94P[o2@T:
o`T92_l92@[o4A`:o`T92_l000000_l92@X00ol94P[o2@T:o`T92P02o`TB
2P[o2@T:00Go2@TDo`T92_l94P[o2@T:oa4L2P02o`T92P03oa4L2_l92@[o
2@T:00Co2@T:00?o6PT:o`TB2_l94PX01?l92@X00olA70[o2@T:o`T92P02
o`T92P03oa4L2_l92@[o2@T:00;o2@T:00Co4A`:o`T92_l0003oUJ6gGooo
ool01?n_[joobl_;omkNg_oZj^X1oo;blP000oo^k^h02OoYjNWoaLG5oh>3
Pon/[:co_;blojj^[_ohn?Sooooooo[jnP02ooooo`05oo[jn_oooooooOgm
ooooooomoOd00oooool02ooOgmooH61Poclo?ol[:b_o<S8bocXj>_ln?Sko
@T92odI6A_m8B4SoATI6013oBTY:6?m9BDTHodY:BP;oBd];00coBTY:odU9
BOm;Bd_oC4a<odI6A_ln?Sko<C4aocPh>?m/K6cogmoOooooooobl_84oooo
o`03oo_knooooooomoOg00Cooooo0ooKfm/8omcLg0GogMgM0_oOgml6on7Q
h@[oh^;R0ooShn<2onCTi0?oiNGU2_oVi^H6onOWi`;oj>SX1OoYjNT;on[Z
jP;ojn_[0_o/k>`01?o]kNgok^k^onk^k_o^k^h:ono_k`Gol?3`0ooalO45
oo;blPSolo?c0_odm?@3ooGem@?om_Kf0_ogmoL3ooShn0[onOWi0oojn_X3
ooclo0;oo_kn4Oooool01?lKG[?oYLCVokG@k_mi[^`2ojOLo`04ofi^K_nd
];Coh>3Ponc/k5_ok^k^00Ko2@T:o`T95?l92ACo4A`:o`T92_l94PX2o`T9
2P04o`TB2_l92ACo4A`:o`TB2PKo2@T:0_l94PX4o`T92P04o`T95?l94P[o
4A`:o`TB2P;o2@T:0_l94PX01_l92@[o4A`:o`T92_l92@[o0000o`TB2POo
2@T:00Go0000o`TB2_l0003o2@T:o`000002oa4L2P03ob<L2_lA70[o;180
00;o4A`:00_o0000o`T92_l94P[o0000o`TB2_lA70[o;2HDo`T92_lA70[o
6PT:oa4L2P02o`TB2P03o`T92_lJ2@[o4A`:00Oo2@T:00?o0000o`T92_l9
2@X01Ol92@X00ol0003o2A8:o`T92P03o`T92P09o`000?l92ACo0000o`TB
2_l92@[o0000o`TB2_l92@[o2@TD00?o2@T:00Co2A8:oa4L2_lJ4QCo2A8:
0ol92@X04?lJ2@[o8a`:ob<L2_lS70[o;1`DodI17_ld;bWo=2lcodI<?OmP
@BWoEei_og9ED_mPLW_oCfMLoa4V2_l94PX2o`0000go2@T:00?o4A`:o`T9
2_lA70X03ol92@X00ol94P[o2@T:o`T92P03o`T92P0<oa4L2_l92@[o2A8:
oa4L2_l92@[o2A8:oa4L2_l94P[o2@T:oa4L2_l92@[o00000ol92@X01_l9
4P[o4A`:oa4L2_lJ4QCo2@T:o`TB2P?o2@T:00Go2A8:o`T92_l92@[o2@T:
o`TB2P08o`T92P03o`000?l92@[o2A8:00Co2@T:00?o2A8:o`T92_lA70X0
1Ol92@X01OlA70[o2@T:o`T92_l92@[o4A`:00So2@T:00?o2A8:o`T92_l9
2@X00ol92@X02Ol94P[o2A`Doa4L2_l92@[o4A`:o`T92_lA70[o0000ojJc
`@1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0003onKViP0;onCTi?oL
g=coYZJVog=cLon0P83oShn?oibLW?nUYJGo[:b/ok6a/Ong]kL03_nk^k/3
okbl_0?o_Kfm00?o_[jnokfm_Onn_[h00_nn_[h2okno_`_o`<300_o1`L42
ol;2`P04ol?3`oo4a<Coa<C4olC4a0[oaLG51Oo6a/H2olO7a`03olK6a_o7
alOoalO700?oalO73Oo8b<P00oo9bLWob/[:ol[:bP0?ol_;b`?oc<c<00?o
cLg=olc<c?o<c<`00_o=cLd;olk>cP;oclo?0oo@d=000ooAdM7od];Bom?C
d`02om?Cd`?oe=CD1ooEeMD6omKFeP;oemOG1OoHf=P;omWIf@?of][J0_oK
fm/3omcLg0[ogMgM1OoNg]h2omoOg`03omkNg_oOgmoogmoO00?ogmoO2?oP
h>03on7Qh@;oh^;R0_oTi>@00ooUiNGoinOWonOWi`03onSXj0[ojNWY0ooZ
j^X3onc/k0;ok^k^2oo_knl2oo3`l0?olO7a00?ol_;boo7alOoalO400_ob
l_83oo?cl`kom?Cd00Co6UjeojC4i_nhd^koMZgZ0_n/gol01?mZJV[o[Zj^
omSHf?oTi>AKonKViP03oaXB5?lA70[o2A8:00?o2A8:00[o4A`:o`T92_l9
2@[o2@TDo`TB2_l92@[o2A8:o`T92_l94P[o2@T:0_l94PX3o`T92P;o2A8:
00?o2@T:o`TB2_l92@X00_l92@X00ol94P[o2@T:o`T92P07o`T92P04o`00
0?l92@[o2@T:o`TB2PKo2@T:00[o2A8:o`T92_lA70[o6PT:oa4L2_lJ2@[o
4BH:oaX92_l94P[o4A`:0_l000000ol94P[o2@T:o`T92P02oa4L2P03ob<L
2_lJ2@[o4A`:00?o2@T:00?o4A`:oaX92_l92@X00ol92@X01_l94P[o2@T:
o`T92_lA70[o2@T:o`TB2POo2@T:00Ko0000o`T92_l92@[o2@T:oa4L2_l0
0002o`T92P08o`TB2_l92@[o2@TDo`000?l/9QCo6Q8Do`T92_l94PX2o`T9
2P03o`TB2_l92@[o2@T:00?o2@T:00oo8a`:ob`B0?lS70[o;2HDoc@_:Old
;c?oAT4NodIED_mGEE;oLUEBof1bNomGGVooCfMLo`000?l94PX01ol92@X0
0ol94P[o2@T:o`T92P05o`T92P03ob<L2_l92@[o4A`:00?o2@T:00?o2@TD
o`TB2_l92@X01ol92@X00ol94P[o0000o`T92P05o`T92P03oaXB5?lA70[o
6PT:00;o4A`:1?l92@X00ol94P[o0000o`T92P02o`T92P03o`TB2_lA70[o
6PT:00?o4A`:00So2A8:o`T92_l92@[o2@T:o`TB2_l0003o4A`:o`0000;o
2@T:00Co2@TDo`000?l92@[o4A`:1Ol92@X00ol0003o2@T:oa4L2P02o`T9
2P04oa4L2_l92@[o4A`:o`T92P;o4A`:00Co2A8:o`T92_l92ACo4A`:1ol9
2@X00olA70[o2@T:o`T92P03o`T92P0=oaXB5?l92@[o2@T:o`T92_l94P[o
2@T:oa4L2_l92@[o2@TDoa4L2_l92ACo0000ojJZ[@1OonKViP04oifMWOng
]kOob<S8om?Cd`7of][J0004onk^kP0:on_[jooPh>3o^;Rhoh61POm`L73o
N7Qhoh^;RonBTY;oVIVIoj6QX@koYZJV1_nWYjL00onXZ:SoZJVYojZZZP04
ojZZZPSoZj^[0on/[:`2ojf][@;o[Zj^00Co[Jf]ojj^[_n^[Zko[Zj^0_n_
[jl=ok2`/0;o/K6a00?o/[:bok>c/onc/k<02onc/k<2okBd]0?o]KFe00?o
][JfokFe]One]KD00_nf][H3okNg]`[o^;Rh0oni^KT00onj^[[o^k^kok^k
^`02okbl_0_o_Kfm1Onn_[h00oo0`<3o_knool71`@05ol71`@[o`/;21?o3
`l<4olC4a0[oaLG51_o6a/H00oo7alOoa/K6olO7a`04olO7a`Sob<S80oo9
bLT2ol[:bP?oc<c<0oo>c/h2olo?c`_od=3@0_oAdM43om;BdP;odm?C2ooD
e=@5omGEe@?oemOG1OoIfMT8om[JfP;ofm_K0ooLg=`3omgMg@;og]kN0ooO
gml>on3Ph004oaYL[onVa^Ko]]3^ogV_kP;oZmko00CoKVi^okBd]?oPh>3o
k>c/Foo^k^h01OlA9QCo2@TDo`TB2_lJ4QCo2A8:00;o2@T:00Go2A8:o`T9
5?l92@[o2@T:oaX92P07o`T92P05o`TB2_l92@[o2@T:o`TB2_l000003ol9
2@X00ol94P[o0000o`T92P05o`T92P03o`000?l92@[o000000;o4A`:00Ko
6PT:oa4L2_l/4P3o4A`:oaX92_lA70X3o`T92P08o`000?l92@[o4A`:oaX9
2_l92@[o4A`:ob`B0?lA70X2o`T92P07o`000?lJ2@[o2@T:oa4L2_l0003o
2A8:o`000002o`T92P03o`000?l92@[o2@T:00?o2@T:00Ko2@TDo`000?l9
4P[o0000o`T92_l00006o`T92P05o`000?l92@[o2A8:o`T92_l000000_l9
2@X01Ol0003o2A8:o`000?l92@[o000000;o2@T:017o0000oa4L2_lJ2@[o
6PT:ob<L2_lS;ako=2lYodI17_ld;c?oH44YoeMED_m?GVKoEei_odINAolS
;c?o0000o`T92P02o`000005oa4L2_l92@[o2@T:o`TB2_l000000_l92@X0
0ol94P[o2@T:o`T92P04o`T92P09oa4L2_l92@[o2@T:o`T92_l94P[o0000
o`T92_l0003o2A8:00Co2@T:00Go2A8:o`000?l92@[o2@T:o`000004o`T9
2P06o`TB2_l92@[o4A`:oaX92_lA70[o6PT:0_l92@X00ol0003o2@T:o`T9
2P02o`T92P06o`TB2_l92@[o2@T:o`T92_l94P[o6PT:2_l92@X00ol0003o
2@T:o`00000Co`T92P;o2@TD00?o0000o`T92_l92@X02?l92@X00ol94P[o
2@T:o`T92P03o`T92P03o`TB2_l92@[o2@T:00Go2@T:00?o4A`:o`000?nV
ZZd0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@001?ooool02?omoOgo
nOWionWYjOoAdM7o/K6aoiRHV?n7QhOoOgmooomjNWX=ogYjNP09og=cLom`
L73oJVYZof5QHOmCDe?o24fUojC3iOnhd^ooNJk/00;o[=oo00CoMWIfol71
`Oo`l?3ooOgmFoooool02ol92ACo4BHDoaXB5?l92@[o2A8:o`T92_lA70[o
2@TDoa4L2_l92@[o2A8:00;o2@T:00Co2A8:o`T92_l92@[o2A8:1Ol92@X0
0ol94P[o2@T:o`T92P02o`TB2P04o`T92_lJ4QCo2@T:o`TB2PGo2@T:00?o
2A8:o`T92_l92@X00ol92@X2o`TB2P;o2@T:00?o4A`:o`T92_l92@X00ol9
2@X01OlA70[o6PT:oa4L2_lA70[o6PT:00Go2@T:0_lA70X01olJ2@[o4A`:
ob<V2_l/4P3o2A8:oa4L2_l92@X00_lA70X00olJ2@[o4A`:o`000002o`T9
2P03o`TB2_l92@[o2@T:00?o2@T:0_l94PX01ol0003o2@T:o`T92_l0003o
2A8:o`000?l92@X00_l94PX2o`T92P04o`TB2_l92@[o2@T:o`0000?o2@T:
00?o4A`:o`T92_lJ2@X00_l94PX4o`T92P0>o`TB2_lJ2@[o4A`:ob<L2_lS
;ako=2lcoc@_:Om6@Ako;5ELoeMED_mGGVooLUEBob<_:Ol971@2o`TB2P;o
2@T:00Go0000o`TB2_l92@[o2@T:o`TB2P02o`T92P03o`000?l94P[o2A8:
00?o2@T:00Co2A8:o`T92_l92@[o2A8:1?l92@X01?l94P[o2@TDo`000?l9
4PX2o`T92P05o`TB2_l92@[o2@T:o`T92_l94PX01?l92@X01_lJ2@[o2@T:
oaX92_lA70[o;180o`TB2POo2@T:00Oo0000o`TB2_l92@[o6PT:oaXB5?lJ
2@[o4A`:00Oo2@T:00?o4A`:o`T92_l92@X00ol92@X00ol94P[o2@T:o`TB
2P05o`T92P03o`TB2_l92@[o2@T:00;o2@T:00?o2A8:oa4L2_l92@X00_l9
2@X02_l0003o2@TDoonc0?n3;`3o2@T:o`TB2_l92@[o4A`:o`T92_l94PX3
o`T92P03o`TB2_l92@[o2@T:00;o2@T:00Go4A`:o`T92_l94P[o2A8:o`T9
2P02o`TB2P;o2@T:00?o2A8:oaX92_nEXKL0Goooool01?n_[joobl_;omkN
g_oZj^X1oo;blP001?o^k^h02_o[jn_oh>3PokRh^?n1PH7oKFe]ogAdM?n2
PX;oQhN7ohf=SOnEUID>oiZJVPKoVi^K0_nLW9`5oifMW@_oWYjN0_nOWil2
oj2PX004oinOWonPX:3oX:2Poj2PX0goXJ6Q0_nRXZ82oj>SX`03ojBTY?nU
YJGoYJFU00?oYZJV2?nWYjL5ojRXZ003ojVYZOnXZ:SoZ:RX00GoZJVY2_nZ
ZZX3oj^[Z`03ojb/[?n][Jgo[Jf]00;o[Jf]2on^[Zh5ojn_[`;o/;2`1_na
/K4:ok:b/P?o/k>c00?o]KFeokBd]?nf][H00_nf][H:okNg]`go^;Rh2?ni
^KT5okZj^P?o_;bl0onn_[h2okno_`_o`<300_o1`L43ol;2`P;o`l?32oo4
a<@5olG5a@03olK6a_o7alOoalO700GobLW92?o:b/X2ol_;b`?oc<c<00?o
cLg=olc<c?o<c<`00_o=cLd3olk>cPkoclo?00Co6Ub_ojG4i_nfd^koNJkY
0_nZh?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP08o`TB2_lJ4QCo2@TDoa4L
2_l92@[o4A`:o`T92_lA70X2o`T92P04o`000?l94P[o2A8:o`TB2PGo2@T:
00?o2A8:o`T92_l94PX00ol94PX4o`T92P03oa4L2_l92@[o2@T:00;o2@T:
00[o2A8:o`T92_l92@[o0000oa4L2_l0003o2A8:o`T92_l94P[o00000_l9
4PX02_l0003o2@T:o`TB2_l94P[o2@T:oa4L2_lJ2@[o4A`:o`T92_lJ2@X2
oa4L2P03o`000?l94P[o2@T:00;o2A8:00Go4A`:oaX92_l/4P3o6PT:ob<L
2P02o`T92P08o`000?l94P[o2@T:oa4L2_lJ2@[o4A`:o`T92_l94PX2o`T9
2P04o`TB2_l92@[o2@T:o`TB2P?o2@T:00?o4A`:o`T92_l92@X01?l92@X0
1ol0003o4A`:o`T92_l92@[o0000o`TB2_l92@X00_l94PX01_l92@[o2A8:
o`TB2_l94P[o2@T:o`TB2P;o2@T:00Ko2A8:o`T92_l92@[o2@T:oa4L2_lJ
4Q@2ob`V5003ob<_7_m6@AkoAT`m00;oAT`m00So=5Dmoa4L2_l92@[o0000
o`T95?l94P[o2@T:o`TB2PGo2@T:00[o0000o`T92_l92@[o0000o`TB2_l9
2@[o2A8:o`T92_l0003o2A8:0_l92@X01_l94P[o2@T:o`T92_l0003o2@T:
oa4L2POo2@T:00Ko2A8:o`T92_l92@[o0000o`T92_l00002oa4L2P05o`T9
2_l94P[o2@T:o`T92_l94PX00_l92@X00olA70[o2@T:o`TB2P06o`T92P;o
4A`:1ol92@X01?l0003o2@T:o`T92_lA70X8o`T92P07o`TB2_l0003o2A8:
o`TB2_l92@[o6PT:oa4L2P03o`T92P07ok1<0?niI`3o`H@0onBZ0?l/71Co
2@T:oaX92P03o`T92P05oa4L2_l92@[o2@T:o`T92_lA70X01?l92@X01?lA
70[o2@T:o`T92_lJ2@X2o`T92P;o2A8:00Co4A`:o`T92_l0003oYZZ]Goo^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000ooVi^H02?oTi>Cog=cLojJV
Y_maLG7oOWinohb<S?nJVY[oXj>S0_ojoOd2oogmo@;ooOcm05SooOgmoocm
oOojoOgonOgmooWmn_ogn??om_7^ooCZjOo`h>3oj=SHomgAdOoLd]7ogM7A
omcBdOoMdM7og=;AomgAdOoLd]7ogM7AomcBdOoMdM7og=;AomgAdOoLd]7o
gM7AomcBdOoMdM7og=;@omgAdOoLd]3ogM7AomcBd?oMdM7og=;@omgAdOoL
d]3ogM7AomcBd?oMdM7og=;@omgAdOoLd]3ogM7AomcBd?oMdM7og=;@omgA
dOoLd]3ogM7AomcBd?oMdM7og=;@omgAdOoLd]3ogM7AomcBd?oMdM7og=;@
omgAdOoLd]3ogM7AomcBd?oMdM7og=;@omgAdOoLd]3ogM7AomcBd?oMdM7o
g=;@omgAdOoLd]3ogM7AomcBdOoMdM7og=;AomgAdOoLd]7ogM7AomcBdOoM
dM7og=;AomgAdOoLd]7ogM7AomcBdOoMdM7og=;A0_oMdM402OoMcLgoj=SH
oncNg_oaiNGono;coo_gm_oknO[ooOgmoocmo@03oo[mo@Coo?gm00?ooOgm
olg=cOo>c/h02Oo>c/h3olo?c`03om3@d?oAdM7od];B00;od];B2_oCdm<6
omCDe0;oeMGE1OoFe]H>omOGe`;of=SH3OoIfMT3om[JfP;ofm_K0ooLg=`3
omgMg@;og]kN2ooOgml2on3Ph0?oh^;R0_oTi>@;onGUi@;oinOW0ooXj>P0
0ooZj^[ojNWYonWYj@02on_[j`?ok>c/2?o^k^h2ono_k`?ol?3`0oobl_82
ooCdm0?omOGe3_ofm_H01?lJGK;oY/KVokWCk_mi[^/2oj_Oo`04ofYZJ_n^
[Zkof=SHonCTi5_oi^KV00?o2@TDob<_7_l94PX01_l94PX2o`T92P03o`TB
2_l0003o2@T:00?o2@T:00?o2A8:o`T92_l94PX01?l92@X01?l0003o2@T:
o`T92_l92@X2o`TB2P05o`T92_l94P[o2A8:o`000?l94PX01Ol92@X02?l0
003o2@T:o`T92_l92@[o2A8:o`000?l92@[o2A8:0_l00002o`T92P05oa4L
2_l92@[o4A`:oaX92_lA70X00_l92@X02ol0003o2@T:o`000?l92@[o6PT:
oa4L2_lJ2@[o4A`:o`T92_lA70[o000000Go2@T:00?o4A`:o`T92_l94PX0
1Ol92@X02ol0003o2A8:o`T92_l0003o4A`:o`T92_l0003o2@T:o`000?l9
2@[o2A8:00?o00000ol92@X00ol94P[o0000o`T92P02o`00000;o`T92_l9
4P[o0000o`T92_l0003o2A8:o`000?l92@[o2A8:o`000?l94PX00_lA70X0
1?lJ2@[o6RHDoaXL7_m6@Ah2oc@_:@03ob`L5?l0003o2A8:00;o000000Co
2A8:o`000?l92@[o00000_l92@X00ol0003o2@T:o`TB2P04o`T92P;o0000
00co4A`:o`T92_l0003o2@T:o`TB2_l0003o2@T:o`TB2_l0003o2A8:o`00
0?l94PX2o`T92P05o`TB2_l92@[o2@T:o`T92_l000000_l92@X01?l0003o
4A`:o`T92_l00002o`T92P05oa4L2_l94P[o2A8:o`000?l94PX01ol92@X0
1OlA70[o2@T:oa4L2_lJ2@[o4A`:00Oo2@T:00?o4A`:o`TB2_l92@X00_lA
70X9o`T92P04o`TB2_lA70[o2@T:o`TB2P;o2@T:00Oo2@TDoh<_0?oof@3o
m[<0ooK72_o1Q03o000000Co2@T:0_l94PX7o`T92P03oa4L2_l92@[o2@T:
00Go2@T:0_l94PX00olA70[o0000oiFQ]`1OonKViP04oifMWOng]kOob<S8
om?Cd`7of][J0003onk^kP08onWYjOo5aLGoNGUioj2PX?nm_Kgo/;2`ojj^
[_ne]KD5ooooo`1Tookoooolooooo?oooocooooho?_ol_;`onOSh?oRf=Oo
h];Bomo9booH`/CobKNgolNg]oo9]kOoakNgolVg]oo7]kOobKNgolNg]oo;
^KWobKViol^i^Oo9^KWobkViolVi^Oo;^KWobKViol^i^Oo9^[OobkViolVj
]oo;^KWobKZgol^i^Oo9^[OobkViolVj]oo;^KWobKZgol^i^Oo9^[OobkVi
olVj]oo;^KWobKZgol^i^Oo9^[OobkViolVj]oo;^KWobKZgol^i^Oo9^[Oo
bkViolVj]oo;^KWobKZgol^i^Oo9^[OobkViolVj]oo;^KWobKZgol^i^Oo9
^[OobkViolVj]oo;^KWobKZgol^i^Oo9^[OobkViolVj]oo;^KWobKViol^i
^Oo9^KWobkViolVi^Oo;^KWobKViol^i^Oo9^KWobKNgolNg]oo9]kOoakNg
olVg]oo7]kOobKNgolZf]oo?][Wof/74omc8bOoNc/koim_KongTiOocko3o
o_knookoo`;oo?oo00?onooooocoooolool00_onool00ooooooogMgMomgM
g@07omgMg@Gog]kN0_oOgml6on3Ph0[ohN7Q0ooRh^82on?Sh`?oi>CT2_oU
iND6onKViP;oj>SX1OoZj^X;on_[j`;ok>c/0_o]kNd01?o/k>cokNg]ong]
kOo]kNd:onk^kPGokno_0oo`l?05oo7al@Sol_;b0_oclo<3ooCdm003ooGe
mOofm_Kom_Kf00;omoOg0oohn?P:ooWin@?on_[j0oolo?`2ooknoQ7ooooo
00Co7f6doj?2i?nhdnooMjk[0_nZgol01?m^KVko];Bdon3Ph?o/k>aKonk^
kP06o`TB2_lA9QCo2@TDoaXB5?l94P[o2@TD0ol94PX00ol92@[o2A8:o`T9
2P03o`TB2P05o`T92_l94P[o2A8:o`T92_lJ4Q@01Ol94PX01?l92@[o2A8:
oa4L2_l92@X3o`TB2P?o2@T:00Go2A8:o`T92_l94P[o0000o`TB2P06o`T9
2P;o2A8:1?l92@X01OlA70[o6PT:oa4L2_l94P[o6PT:00;o2@T:00[o2A8:
o`T92_l92@[o2@T:oa4L2_lJ2@[o4A`:o`T92_l94P[o4A`:2_l92@X00olA
70[o2@T:o`TB2P02o`T92P05o`000?l92@[o2A8:o`T92_lA9Qh01ol92@X0
1Ol92ACo2A8:o`000?l92@[o2A8:00Co2@T:00?o2A8:o`000?l92@X01?l9
2@X03_l94P[o2@T:o`TB2_l92ACo2@T:o`TB2_lJ4QCo6RHDob`L5?l/>2Wo
8blcoaXV5?l92@[o2A8:1?l92@X00ol94P[o2@T:o`T92P02o`T92P04o`TB
2_l0003o2@T:o`T92P;o2A8:00?o2@T:oa4L2_l000000_l92@X01Ol94P[o
2@T:o`T92_lJ4QCo2A8:00Co2@T:0ol94PX01Ol92@[o4A`:o`T92_l92@[o
4BHN00;o2@T:00go0000o`T92_l92@[o2@T:o`TB2_lA70[o2@T:oaX92_l9
4P[o2@T:o`TB2_lA70[o2@T:00;o2A8:00Co6PT:o`TB2_l92ACo6PT:0olA
70X01OlJ2@[o2A8:o`T92_l92@[o2A8:00;o2@T:00Co2A8:o`T92_l92@[o
2A8:1?l92@X00olA70[o2@T:o`T92P02o`TB2PGo2@T:00_o4A`:o`T92_lA
70[o0000oh<_0?oomP3oomT0ol640?l0003o2@T:oa4L2P02o`T92P04o`TB
2_l92@[o2@T:oa4L2P?o2@T:013o4A`:o`TB2_l92@[o2@T:oa4L2_l94P[o
2@T:oa4L2_l92@[o2A8:oa4L2_l94P[o6Q8Do`T95?l0003oUJ6gGoo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool02_ono_kom_KfoiZJV_nA
TI7oc<c<omGEeOo2`/;o^KViol30`?oooOl2ooono`03ooooooonooooo?oo
00;oo?oo00WomOOfoo3_kOoRgM[odLK4olRf]_o5[k7o`jJZokbOXon_UIP0
1on^UIP8ojfDUc3o[IFE2?n]U9L7ojjEV00;ojnEV?ngUico`Z:WolBWZoo5
[:oocK^kom?7aooQf=Wol^k_ooooooonool01?olool2ookoo`03oooooooP
h>3ohN7Q00WohN7Q0ooRh^800ooTi>Cohn?SonGUi@02onGUi@[oi^KV1_oW
inL00ooXj>SojNWYon[ZjP04on[ZjP_ojn_[0oo/k>`2ong]k@?ok^k^2_o_
knl3oo3`l0;olO7a0_obl_801?oalO7ol_;boo;bl_obl_82oo?cl`Som?Cd
1OoemOD3ooKfmPGomoOg2_ohn?P3ooWin@03oo_knoolo?coo?cl00;oo_kn
9_ooool01?lOH;CoYLCVokWCkomg[^/2ojWLo`04ogIfM_o1`L7ol?3`oogm
oE_ooooo00Ko6Q8Do`T95?l92@[o6Q8Doa4L2_l92@X2o`TB2P05o`T92_l9
4P[o4A`:o`TB2_l92@X00ol94PX00ol92@[o2A8:o`TB2P05o`T92PGo2A8:
00Co2@T:o`TB2_l92@[o2@T:0_l94PX3o`T92P05o`TB2_l0003o4A`:o`T9
2_l94PX01?l92@X00ol0003o2@T:o`TB2P02oa4L2P03ob`B0?lA70[o2@T:
00;o6PT:0_lA70X01Ol94P[o2@T:oa4L2_l94P[o6PT:00?o4A`:00Go;180
o`TB2_lA70[o2@T:o`TB2P04o`T92P?o4A`:00Co2@T:oa4L2_l94P[o2@T:
0_l94PX01Ol92@[o0000o`TB2_l92@[o2A8:00;o2@T:00Go4A`:o`T92_l9
2@[o2@T:o`000003o`T92P03o`000?l94P[o000000?o2@T:00?o2A8:o`T9
2_l94PX00_l92@X01ol94P[o2@T:o`T92_l92@[o0000o`TB2_l92@X00_lJ
4Q@2ob<L2P04oaX92_lA70[o2A8:o`TB2P?o2@T:00?o6Q8Do`000?l94PX0
0_l92@X02?l94P[o2@T:o`T92_l92@[o2A8:o`T92_l0003o2A8:0_l92@X0
1_l94P[o0000o`T92_l0003o6Q8Doa4V50;o2@T:00_o2A8:o`T92_l92@[o
2@T:o`TB2_lJ4QCo4BHDo`T95?l92@[o4A`:o`T92P03o`TB2P;o2@T:00?o
2A8:o`T92_l92@X00ol92@X03?lJ2@[o2@T:o`TB2_lA70[o2@TDo`T92_l9
4P[o2@T:oaXB5?lA70[o2@T:oaX92P;o4A`:00?o2A8:o`T92_l92@X03_l9
2@X00ol0003o2A8:o`T92P02o`T92P0Bo`TB2_lA70[o2@T:o`T92_l92ACo
4A`:o`T95?nEE@3oLRH0o`T92_l94P[o4A`:o`T92_lA70[o2@T:oa4L2_l9
2@[o4A`:1?l92@X00olA70[o2@T:o`T92P02o`T92P05o`TB2_l92@[o2A8:
o`T92_l94PX00_l92@X01?l92ACo4A`:o`000?nEXKMOooooo`04ojn_[oo;
bl_og]kNon[ZjP7ol_;b0002onk^kP0>ong]kOoPh>3oNWYjokbl_?oHf=So
fm_Kolk>c_o0`<3oaLG5oookooooo?ooookoooooooolo_d2oocoo`0Aoocl
n_oUhMkoeL_9olbn_OnmZJSo]9ZKok2@TonPOH7oXGf1oiejO_nINGcoUgMj
oi=cM_nALGCoTW9eoiEeN?nHN7/0>?nEMGP:oi=cMP0Aoi9bMOn@L7?oSfmb
oi5aM?nEMGSoVgQloimhOOnNMgcoXgn3ojn?T_ngWIko_JVZol^m_?oJd<oo
j>;RooGcm?ooool01Oonool00oooooooiNGUonGUi@07onGUi@Goi^KV0_oW
inL6onSXj0[ojNWY0ooZj^X2on_[j`?ok>c/2_o]kNd3onk^kP?okno_00?o
lO7aoo3`l?obl_800_obl_82oo?cl`Som?Cd1OoemOD3ooKfmPGomoOg3Ooh
n?P3ooWin@oon_[j0ookno/00oolo?cooOgmoogmo@02ooknoRKooooo00Co
6enfojC4i_nidnooMZgZ0_n[h?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP03
oa4V5?l94P[o4A`:00;o2@T:00Go4A`:o`T92_l92@[o2@T:o`TB2P02o`T9
2P05o`TB2_l92@[o2@T:o`TB2_l92@X00_l94PX4o`T92P03o`TB2_l92@[o
2@T:00Co2@T:00?o2A8:o`T92_l94PX00_l92@X01_l0003o2A8:o`T92_l9
4P[o2@T:o`0000;o2A8:0ol92@X01Ol0003o4A`:o`T92_l0003o2A8:00;o
2@T:00Co2A8:oa4L2_lJ2@[o4A`:1Ol92@X02?l0003o4A`:ob<L2_lJ2@[o
;180oa4L2_lJ2@[o4A`:3?l92@X01?lJ2@[o0000o`TB2_l00002o`T92P03
o`TB2_l0003o2A8:00;o2@T:00Go4A`:o`T92_l94P[o2@T:o`TB2P02o`T9
2P03o`000?l92ACo2A8:00Co2@T:00co2A8:o`T92_l0003o2A8:o`000?l9
2@[o2A8:o`000?l92@[o0000o`T92_l94PX3oa4L2P09o`T92_l94P[o2@T:
o`000?l94P[o0000o`TB2_l92ACo2A8:00?o2@T:00?o0000o`TB2_l94PX0
0_l92@X00ol0003o2@T:o`T92P02o`T92P04o`000?l92ACo2@T:o`T92P;o
000000?o2A8:o`T92_l92@X00_l94PX2o`T92P;o2@TD00So2@T:oa4L2_l9
2@[o2A8:o`000?l92ACo0000o`TB2P;o2@T:00Co4A`:o`T92_lA70[o4A`:
0ol92@X02?lJ2@[o6Q8Doc@_:OlA70[o2@T:oa4L2_l92@[o;1800_lA70X2
oaX92P07o`TB2_l92@[o2A8:o`T92_l0003o2@T:o`000004o`T92P03o`TB
2_l92@[o2@T:00_o2@T:00Oo4A`:o`T92_l92@[o2A8:o`000?l92ACo0000
00;o2@T:00Oo4A`:o`T92_l92ACo2@T:o`TB2_l92@[o4A`:00Co2@T:0_l9
4PX00ol92@[o2A8:o`T92P05o`T92P;o4A`:00?o2@T:o`000?n`_/40Goo^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H01?oTi>CoemOGog5a
LOoAdM42omcLg01`om3@d?o4a<CobLW9oooloooooOooookoooooooojo?_o
nO_hoo?clOoWhn3oh=GCom;0__o:/;7o/i>Doj1lP?nFKG7oRUmVoi1UK?n7
GVCoQf1UohUPI_n7H6GoQeiTohIOI?n9H6KoRF9WohQOIOn7H6GoR5mUohMP
IOn8GfGoQf1UohQOIOn7H6GoR5mUohMPIOn8GfOoQf1UohQOIon7H6GoR5mW
ohMPIOn8GfOoQf1UohQOIon7H6GoR5mWohMPIOn8GfOoQf1UohQOIon7H6Go
R5mWohMPIOn8GfOoQf1UohQOIon7H6GoR5mWohMPIOn8GfOoQf1UohQOIon7
H6GoR5mWohMPIOn8GfOoQf1UohQOIon7H6GoR5mWohMPIOn8GfOoQf1UohQO
Ion7H6GoR5mWohMPIOn8GfOoQf1UohQOIon7H6GoQeiTohIOI?n7GVCoQUmT
ohMNI?n6GfCoQeiTohIOI?n7GVCoQf1UohUPI_n7H6GoQeiTohIOI?n9H6Ko
Rf9XoiAUKOn;G6;oRUeToiM^L_nWQ8So/iJHoknZZOo<^[[og=3@ongTiOol
n?Ooookooogmo@?oo?go00?oooooonKVi_oVi^H01ooVi^H=onOWi`Ooj>SX
0ooYjNT3on[ZjP;ok>c/0oo^k^h2ono_k`kol?3`00?olO7aoo;bl_oclo<0
3ooclo<2ooCdm0?omOGe0oofm_H:ooOgm`?on?Sh0_oinOT3oo[jnP;ono_k
0oolo?`=oogmo@?oo_kn:?ooool01?lKG[?oYLCVokG@k_mi[^`2ojOLo`04
ofYZJ_n^[Zkof=SHonCTi5_oi^KV00Go2@TDo`T92_l92@[o2@T:oa4L2P05
o`T92P03o`TB2_l0003o2@T:00Go2@T:00Co2A8:o`T92_l92@[o2A8:0_l9
2@X00ol94P[o2@T:oa4L2P02o`T92P05oaX92_l0003o2A8:o`000?l94PX0
1?l92@X01?lJ2@[o2A8:o`TB2_l00003o`T92P0>o`TB2_l0003o2@T:o`00
0?lA70[o0000o`T92_lA70[o6PT:oa4L2_l92@[o4A`:oaX92_lA70X2oaX9
2P0;oa4L2_l94P[o4A`:oa4L2_lJ2@[o4BH:ob<L2_lA70[o6PT:o`T92_lJ
2@X00ol92@X00ol94P[o2@T:o`T92P02o`T92P03oa4L2_l92@[o2@T:00Co
2@T:00ko2A8:o`000?l92@[o2@T:o`TB2_l92@[o2A8:o`T92_l0003o2A8:
o`000?l92@[o0000o`TB2P?o00000_l92@X00ol94P[o0000o`TB2P02o`TB
2P04o`000?l94P[o0000o`T92P;o2A8:00Co0000o`T92_l94P[o00000_l9
2@X01?l94P[o0000o`T92_l94PX2o`T92P03oaXB5?l92ACo6Q8D00;o2A8:
1_l92@X01_lA70[o0000o`TB2_l92@[o2A8:o`0000Go2@T:00Co2A8:o`00
0?l92@[o2@T:0ol94PX00olJ4QCo2A8:o`TB2P03o`TB2P03o`000?l92@[o
2@T:00So2@T:00?o4A`:o`T92_lA70X00_l92@X01ol94P[o2@T:o`T92_lA
70[o2A8:o`000?lA70X00_l94PX00ol0003o2@T:o`TB2P02o`TB2PCo2@T:
00Co2A8:o`000?l92@[o2A8:0ol92@X01olA70[o2@T:o`T92_l92@[o4A`:
o`T92_lA70X00ol94PX01_l92ACo0000of0_2_oTZP3ook<0ol6400;o2@T:
00Co6PT:oh<_0?l92@[o2A8:2?l92@X00ol94P[o2@T:oa4L2P02o`T92P03
o`TB2_l92@[o2A8:00;o2@T:00?o4A`:o`000?nV/l40GooVi^H01?nMWIgo
]kNgolS8b?oCdm<1om[JfP000_o^k^h0Moo/k>cogMgMog5aLOoGemOog]kN
omoOgooDe=Coa<C4olO7aoooo?oooo_oooklooooooooooomoogln?o`jnOo
g=7=olRc/?ngVIWo[hR;oj=fNOnWMWco^8F:ol>@UooFXj[ok;g5onk0b_oc
a<komLOAooK7dOoda]3om<G?ooC6d?oca<kol/C>oo?4c_oba<kollC>oo;4
c_oca<kol/C>oo?4c_oba<koll??oo;4c_oc`lool/C>oo?3cooba<koll??
oo;4c_oc`lool/C>oo?3cooba<koll??oo;4c_oc`lool/C>oo?3cooba<ko
ll??oo;4c_oc`lool/C>oo?3cooba<koll??oo;4c_oc`lool/C>oo?3coob
a<koll??oo;4c_oc`lool/C>oo?3cooba<koll??oo;4c_oc`lool/C>oo?3
cooba<koll??oo;4c_oc`lool/C>ooC5coocaLoom<G?oo?5coodaLoollG?
ooC5coocaLool/?=oo?5coofam7omLOAooC5cooba<kol/?=oo?4c?oU/;So
ej:XolBAV?naP8CoX7=hoiefNOn_SHko`jNVom2k^_oQdM7om^c[oooknooo
o_ooo_oo00;oo?oo00?oo_ooonOWiooWinL01ooWinL2onSXj0?ojNWY00?o
j^[ZonWYjOoZj^X00_oZj^X3on_[j`gok>c/00?okNg]onk^k_o_knl03?o_
knl3oo3`l0?olO7a00?olo?coo;bl_odm?@00_odm?@2ooGem@Som_Kf1oog
moL6ooShn0_onOWi0_ojn_X2ooclo003oo_knoomoOgooOgm017oo_kn:_oo
ool01?lKGkKoY<CVokSBk_mf[NX2ojcOo`04ofi^K_nd];Coh>3Ponc/k5_o
k^k^0olA70X00ol94P[o2@T:oa4L2P03o`TB2P?o2@T:0_l94PX3o`T92P;o
2A8:00Ko2@T:o`000?l92@[o2@T:o`TB2_l00002o`T92P03o`TB2_l92@[o
2@T:00?o2@T:00co2A8:o`T92_l92@[o0000o`TB2_l0003o2@T:o`000?l9
2@[o2A8:o`T92_l94PX3o`T92P04o`TB2_l92@[o2A8:o`0000;o4A`:00Go
2A8:o`TL5?l92@[o4A`:oaX92P02oa4L2P0;o`T92_l94P[o2@T:o`TB2_lS
70[o;180oa4L2_l0003o4A`:o`T92_lA70X00_l94PX2o`T92P03o`000?l9
2@[o2@T:00Ko2@T:0_l94PX01?l0003o2@T:o`TB2_l00002o`T92P04ob<L
2_l94P[o2@T:o`0000;o2@T:00Go2A8:o`000?l92@[o2@T:o`TB2P03o`00
0004o`TB2_l0003o0000o`0000;o2@T:00?o2A8:o`000?l000001?l92@X0
0ol94P[o2@TDo`T92P02o`T92P05o`000?l92@[o2@T:o`T92_l92A@00_l9
4PX01?l92@[o2A8:o`TB2_l00002o`T92P0:o`TB2_l0003o2@T:o`000?l9
2@[o0000o`TB2_l92@[o2A8:o`T92P;o2A8:0ol92@X01?l94P[o2@T:o`T9
2_l92A@6o`TB2PWo2@T:00Co4A`:o`T92_l94P[o4A`:0_l92@X00olA70[o
2A8:o`T92P03o`T92P05oa4L2_lJ2@[o4A`:oaX92_l94PX00_l92@X01?l9
4P[o0000o`T92_l92@X2o`TB2P04o`000?l92@[o2A8:o`0000Ko2@T:00?o
2A8:o`T92_l92@X01Ol92@X04_l0003o?A8:om>H2_oCV0[o`H@0oonc0?n3
;`3o2@TDok1<0?oomP3oPbl0o`T92_lJ2@[o2@T:oa4L2_l92@[o4A`:o`TB
2P?o2@T:00Co4A`:o`T92_lA70[o2A8:0_l92@X01_lA70[o2@T:oaXB5?l9
2ACo0000oiFQ]eook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo
00CooOgmonc/k?mgMgOofMWI0_oPh>005_oDe=CoalO7ol[:b_ooo?ooo_Wm
ooomo_oooogooookoocglooZgm_oe;nlolJWYOnbR8Wo[G]nok=jP?o?U9[o
k[>iooRm`ooob]3om/?<ooW7d_onc=L2ooo?fP03ooo>fOoocMSoolgH00Oo
olkI0oooc]X0;OoocMcoolkJooo=g?ooc][oolgLooo>f_oocMcoolkJooo=
g?ooc][oolgLooo>f_oocMcoolkJooo=g?ooc][oolgLooo>f_oocMcoolkJ
ooo=g?ooc][oolgLooo>f_oocMcoolkJooo=g?ooc][oolgLooo>f_oocMco
olkJooo=g?ooc][oolgLooo>f_oocMcoolkJooo=g?ooc][oolgLooo>f_oo
cMcoolkJooo=g002ooo>fPOoolkI01Koo/cGooo=f?oocMSoolgHook<eool
b]GonlWDooc9d_ok`/WoolC:ook3bOo]];[ocIVMok:1Q?nXO7goZH:3ol6Q
X_oD_;cok]cLoogcl_oooOcoo_oo0_okool00oonooooinOWonOWi`07onOW
i`goj>SX1ooYjNT3on[ZjP?ojn_[00?okNg]onc/k?o^k^h00_o^k^h2ono_
k`_ol?3`0ooalO42oo?cl`?omOGe2_ofm_H=ooOgm`_on?Sh0_oinOT2oo_k
n`03ooclo?ono_koo_kn03_ooooo00Co7EncojK6i_nfd>koNJo^0_n[g_l0
1?mfMWKo`L71oo3`l?omoOeKooooo`06o`TB2_l92ACo4A`:o`T92_lA70[o
2@T:1Ol94PX5o`T92P0:o`TB2_l92@[o2A8:o`TB2_l92@[o2A8:o`T92_l9
4P[o2@T:oa4V7PGo2@T:0_l94PX00ol0003o2A8:o`T92P03o`T92P;o2A8:
00Co2@T:o`TB2_l92@[o00000_l92@X01ol94P[o2@T:o`T92_l0003o2A8:
oa4L2_lJ2@X00ol/4P000ol94P[o4A`:o`TB2P03o`T92P06oa4L2_lJ2@[o
6PT:ob<L2_l/4P3o6PT:1Ol92@X00ol94P[o2@T:o`T92P03o`T92P04o`00
0?l92@[o2@T:o`T92P;o2A8:00Oo0000o`TB2_l92@[o0000o`TB2_l0003o
2@TD00;o000000go2A8:o`T92_l94P[o2@T:o`000?l92ACo2@T:o`000?l9
4P[o0000oa4L2_l92@[o000000?o2@T:00?o0000o`TB2_l92@X00_l92@X0
1?l94P[o2@T:o`T92_l92@X2o`000003o`TB2_l92@[o000000;o2@T:00Oo
0000o`T92_l92@[o0000o`T92_l971Co2A8:00;o2@T:00Oo2A8:o`000?l9
2@[o2@TDo`TB2_l92@[o2A8:00?o2@T:00?o0000o`T92_l92@X00ol92@X0
0ol94P[o2@T:o`T95004o`T92P04o`TB2_l92@[o2@T:o`0000ko2@T:00?o
2A8:o`T92_l94PX00_l92@X00olA70[o2@T:oa4L2P02o`T92P03oaX92_l9
2@[o4A`:00Go2@T:00?o2A8:o`T92_l92@X01ol92@X00ol94P[o0000o`TB
2P05o`T92P;o4A`:013o2@T:og8V0?oomP3oYT40o`T95?oo/`3oYT40ob`B
0?n`C03oooH0oh<h0?l92@[o6PT:oa4L2_l92@[o2A8:0ol92@X2o`T950?o
2@T:00?o6PT:o`T92_l92@X00ol92@X00olA70[o0000ojJZ[@1Oooooo`04
ojn_[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP09onc/k?oLg=coMWIfom[J
f_oPh>3ohN7QomCDe?o7alOobl_;00;ooogo017ooooooooooOojmo;ok^GP
om[7`Oo2YJ7o^8b;okEnPOo5QhcofYNNooJ`^?oo`l[oo;_1ooRla?oob]Co
olcIooo?g002ooo@g@03ooo?g?ood=goom7N00Soom?P0_ood^80;_ood^Co
om;RoooBi?ood^;oom;ToooBh_ood^Coom;RoooBi?ood^;oom;ToooBh_oo
d^Coom;RoooBi?ood^;oom;ToooBh_ood^Coom;RoooBi?ood^;oom;ToooB
h_ood^Coom;RoooBi?ood^;oom;ToooBh_ood^Coom;RoooBi?ood^;oom;T
oooBh_ood^Coom;RoooBi?ood^;oom;ToooBh_ood^Coom;RoooBi?ood^88
oooBg`03oooCh?oodMkoom3M00;oolkK0_oocMX04_oocMOool;:oojm`ool
^l7on[c1oo:d^OoJWj?o_8F8ojMeM_ndRX_oaJ>Romk6a_obi>?oo?Kfoo_m
o?oioooon_ooookoo`WoinOW0_oXj>P3onWYj@;oj^[Z0oo[jn/3onc/k0Oo
kNg]1_o^k^h00oo`l?3okno_oo7al@04oo7al@_ol_;b1?oclo<4ooCdm0[o
mOGe1Oofm_H2ooOgm`03ooKfm_ogmoOomoOg00?omoOg2oohn?P2ooWin@;o
no_k00?oo?clookno_ono_h0>oooool01?lJG;?oY<?UokSBkomi[^`2ojcO
o`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Wo4A`:o`T92_l94P[o2@T:o`TB
2_l0003o4A`:o`T92_l94PX00_l92@X3o`TB2P03o`T92_lA70[o2@T:00?o
2@T:0_l94PX01?l92@[o0000o`TB2_l00002o`T92P0:o`TB2_l92@[o2A8:
o`T92_l0003o2A8:o`000?l94P[o2@T:o`TB2P;o2@T:00oo0000o`TB2_l9
2@[o0000o`TB2_l0003o2A8:o`000?l94P[o0000o`T92_l94P[o6PT:oa4L
2_l/4P000_lA70X4o`T92P08o`TB2_l92@[o;180o`T92_lA70[o2@T:oa4L
2_l/4P02oaX92P05oa4L2_l92@[o2A8:o`000?lJ2@X02?l92@X00ol94P[o
0000o`T92P02o`0000;o2@T:00?o0000o`TB2_l92@X01?l92@X00ol0003o
4A`:o`000003o`T92P05o`000?l94P[o0000o`T92_l94PX01?l92@X01ol9
4P[o2@T:o`000?l94P[o0000o`T92_l000000ol92@X2o`TB2P;o2@T:00?o
2A8:o`T92_l92@X00_l92@X2o`T950?o2@T:00Co0000o`TB2_l0003o0000
0_l92@X01Ol0003o2@T:o`T92_l92@[o2A8:00Go2@T:00?o0000o`TB2_l9
4PX02_l92@X00olA70[o2@T:o`T92P04o`T92P03o`TB2_l92@[o2@T:00Ko
2@T:00Ko4A`:o`T92_l92@[o2@T:oa4L2_lA9Q@2o`T92P0=o`000?l94P[o
2@T:o`000?l92@[o0000o`TB2_l0003o2@T:o`T95?l94P[o2@T:o`TB2P05
o`T92P03o`TB2_l92@[o2@T:00;o2@T:013o2A8:o`T92_l92ACoLRH0ooof
0?nEE@3o2@TDooJc0?n3>03o/4`0ooof0?mG703o2@T:oaX92_l92@[o4A`:
0_l92@X01_l94P[o2@T:o`T92_l94P[o2@TDoa4L2P?o2@T:00So2A8:o`T9
2_l92@[o2@T:oa4L2_l92@[o0000ok2c]eook^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN4000;oi^KV00Coi>CTomCDe?mlO7cof][J0_oPh>005OoCdm?o
a/K6olc<c?ooo_oooOgmoooooOoooo_om_7]onGJe?oB^kGo_INDojQeM?nh
N7WofI2GonnRZ_on/k[ookk5oonk`oooa<coolWFooo<f@02ooo=fP;oolcI
00?oolgJooo?g?oodMh01_oodMh0<_ood>3oom3Rooo@h_ood>Coom3Rooo@
i?ood>;oom3Tooo@h_ood>Coom3Rooo@i?ood>;oom3Tooo@h_ood>Coom3R
ooo@i?ood>;oom3Tooo@h_ood>Coom3Rooo@i?ood>;oom3Tooo@h_ood>Co
om3Rooo@i?ood>;oom3Tooo@h_ood>Coom3Rooo@i?ood>;oom3Tooo@h_oo
d>Coom3Rooo@i?ood>;oom3Tooo@h_ood>Coom3Rooo@i?ood>;oolkN1ooo
cm`00ooodn3oom7Nooo>f`02ooo=fP;oolkK01;oolcIoooDg?oobLkookg2
ooVd^Oob[K;oiZ6TomBCUoo4RH_o/h62okfCU?oB];Coj]SFooWakoolo?[o
n?onooWoooonool5onKViP04onCTi?o6a/Koclo?onKViP;oinOW0_oXj>P0
0ooUiNGof][JonWYj@03on[ZjP?ojn_[1oo/k>`2on3Ph0CokNg]0_o_knl0
0ooVi^Kofm_Koo7al@02oo7al@;ol_;b00?ofMWIoo3`l?obl_801oobl_80
0ooAdM7od=3@oo;blP04oo?cl`[om?Cd1OoemOD3ooOgm`03onKVi_ogmoOo
nOWi00;ok^k^0_ojn_X2ong]k@Gon_[j00GoinOWooShn?okno_ol?3`oo7a
l@02ooclo003ooWinOoVi^Koo_kn00Koo_kn00?ojn_[onk^k_ono_h01oon
o_h5ooooo`;ol_;b2Oooool00oo/k>cooOgmooooo`02ooCdm0[ooooo00?o
no_konSXj?ooool02?ooool01?lMGk?oYLCVokKBk_mi[^T2oj[Po`04ofYZ
J_n^[Zkof=SHonCTi5_oi^KV0_l94PX2o`T92P05o`TB2_lA70[o2@T:o`00
0?l94PX00_l92@X01_l94P[o2@T:o`T92_l94P[o2@T:o`TB2P?o2@T:00co
2@TDo`000?l94P[o2A8:o`T92_lA70[o0000o`TB2_l0003o2A8:o`000?l9
4PX2o`0000?o2@T:00Oo2A8:o`T92_l94P[o2A8:o`000?l92@[o2A8:00;o
2@T:00?o0000o`T92_l94PX00ol92@X00olJ2@[o4A`:o`TB2P02ob`B00;o
4A`:00?o2A8:o`000?l92@X00olA70X01Ol92@[o4A`:o`T92_lA70[o2A8:
00;o4A`:00Wo2A8:ob`B0?lA70[o2@T:oa4L2_l92@[o;180o`T92_lA70X0
0_l92@X01?l94P[o0000o`T92_l00002o`TB2P06o`T92_l94P[o2A8:o`00
0?l92@[o2A8:0_l92@X01ol0003o2@T:o`000?l94P[o0000o`TB2_l00000
1?l92@X02?l0003o2A8:o`T92_l92@[o2A8:o`000?l94P[o00000ol92@X0
2_l94P[o0000o`T92_l94P[o0000o`T92_l94P[o0000o`T92_l94PX2o`T9
2P04o`TB2_l92ACo2@TDo`TB2PGo2@T:00So2A8:o`000?l92@[o2@T:o`TB
2_l92@[o2A8:o`0000Ko2@T:00Co2A8:o`T95?l92@[o2@T:0_l94PX5o`T9
2P06oa4L2_l92@[o4A`:oa4L2_l92@[o2A8:0_l92@X00olA70[o2@T:o`T9
2P05o`T92P07o`TB2_l92ACo2@T:o`T92_lA70[o6PT:ob`B0006o`T92P06
o`TB2_l0003o2@T:o`T92_l94P[o00000_l92@X01Ol0003o2@T:o`TB2_l9
2@[o2A8:00?o2@T:01co2A8:oa4L2_l92@[o2A8:oa4L2_l0003o?A8:ooK7
2_of/`3ook<0ooo@0?oof@3oom00og8V0?l92ACo2A8:oa4L2_lJ2@[o2@T:
oa4L2_l92@[o4A`:o`T92_lA70[o2@T:oa4L2_l92@[o4A`:0_l92@X00ol9
4P[o2@T:o`TB2P03o`T92P03o`000?nEV:?oi^KV05koi^KV00CoWIfMokNg
]oo8b<Sodm?C0OoJf]X000;ok^k^00Cok>c/omcLg?mlO7cof][J0_oPh>00
5ooCdm?oalO7olc<c?ooooooo?cloooooOonoOSolNcVon?DcOo=/Z_o^8b9
okb2POo:Q8Koj9NNoo:OYoohYjkoo[6gooje_?oob=3oolSEook;f_oocMco
olkM00;oolgL00?oolkMooo?g_oocmh01ooocmh2ooo?hP0^ooo>i?oocn;o
olkTooo?h_ooc^CooloRooo>i?oocn;oolkTooo?h_ooc^CooloRooo>i?oo
cn;oolkTooo?h_ooc^CooloRooo>i?oocn;oolkTooo?h_ooc^CooloRooo>
i?oocn;oolkTooo?h_ooc^CooloRooo>i?oocn;oolkTooo?h_ooc^CooloR
ooo>i?oocn;oolkTooo?h_ooc^CooloRooo>i?oocn;oolkTooo?hPSoolkM
00Coom3Oooo>gOoocMcoolkM0_oocmh04?oocMcoolWFooNf__oo^/3ookk5
oonl`?ok/;GojYnSomN@U?o8R8Wo]WiookV;Roo:Z:Ooi<o>ooO]k?omoO/2
ooWoo`03ookooooVi^Koi^KV00;oi^KV01;oWYjNo`T92Ol;2`_o820Poc0`
<?nGUiOoinOWonSXj?n][Jgo61PHo`H61_m;Bd_oNg]kob`/;?o[jn_ok>c/
oc/k>omeMGD2ong]k@09oiNGUolJ6Q[okNg]ong]kOlR8R;o3Ph>oadM7Om7
AdOoiNGU00;ok^k^00_of=SHodE5AOl20P;o820PoaDE5One]KGol?3`olO7
aolR8R;o71`Lojn_[`06oo7al@07oiZJV_lA4A7o7QhNob4Q8Ol=3@goRh^;
oo?cl`02ooCdm003ogMgMolo?coomOGe00KomOGe01Co<c<cohB4Q?ofm_Ko
m_Kfon[Zj_l];Bgo=SHfono_kom>CTko1`L7oaTI6OnHV9So4Q8BoeADE?oj
n_[o92@To`l?3olO7aooBd];oo7al@;on_[j00goCdm?o`L71olI6AWoVIVI
oa8B4_mEEEGoo?clok>c/ol=3@go0@41obd];OnCTi?o4A4A00;ooooo00Ko
fm_KocDe=Ol>3Pko30`<ocTi>OoLg=`6ooooo`09oc@d=?mfMWKooooooooo
oolU9BGo410@ob0P8?m=CDgom_Kf00;ooooo00go@410ogmoOooooooooooo
oe5ADOl820So6QXJoibLW?lC4a?oEeMGoooooom0@43oOgmo00;ooooo00[o
Xj>Soa`L7?oooooooooookFe]Ol>3Pko0P82obd];OnCTi?o4A4A1_ooool0
1?lKG[?oY/KVokWCk_mi[^/2oj_Oo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^
00Co2@TDoaXB5?lA70[o2@TD0_l92@X00olJ4QCo2@T:oaX92P05o`T92P05
o`TB2_l92@[o2@T:o`T92_l92A@00_l00002o`T92P09o`000?l92@[o0000
o`TB2_l0003o2@T:o`000?l92@[o000000;o2@T:00Co0000o`TB2_l0003o
2@T:0ol00003o`T92P03o`TB2_l0003o2@T:00;o2@T:00_o0000oa4L2_l9
2@[o4A`:oaX92_lS9P[o8a`:ob`B0?lS9P[o6PT:o`TB2P03o`T92P;o6PT:
0_lA70X01Ol/4P3o6PT:oaX92_lJ2@[o2@T:00;o6PT:00Go4A`:o`T92_lS
70[o2@T:oa4L2P02o`T92P;o4A`:00Co0000o`TB2_l0003o2@TD0ol00000
0olA70[o0000o`TB2P02o`0000?o2@T:00?o0000o`T92_l000000_l92@X0
1?l0003o2@T:o`TB2_l00002o`T92P08o`TB2_l92@[o2@T:o`000?l92@[o
0000o`T92_l00009o`T92P08o`TB2_l92@[o2@T:o`TB2_l92ACo2@T:oaXB
5?l00002o`T92P09o`TB2_l0003o0000o`000?l94P[o2@TDo`000?l94P[o
000000co2@T:00?o2A8:o`000?l92@X01Ol92@X02olA70[o2@T:o`T92_l9
2@[o2A8:o`T92_lA70[o0000o`TB2_l92@[o000000So2@T:00So4A`:o`T9
2_lA70[o2@T:oa4L2_l94P[o2@T:o`0000Go2@T:00?o0000o`T92_l00000
0ol92@X00ol94P[o0000o`TB2P06o`T92P06o`TB2_l92@[o2@T:oa4L2_l9
2ACo6PT:0_o1Q0001_nVLP3oNd40og]<2_l0003o6PT:o`0000;o2@T:00Go
2A8:o`T92_l94P[o2@T:o`T95003o`T92P05oa4L2_l92@[o2@T:o`T92_l9
4PX00ol92@X2oa4L2P03o`000?n`/kOok^k^05kok^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN4000;ooooo00CooOgmonc/k?mlO7cof][J0_oPh>005_oD
e=Cob<S8ol_;boooo_ooooklooWnn?odnO;oj>GNom[9`_o5WI_o[WAcolMm
O_o=NggohhjAonjLW_ohZJcookFioofb]ooo_<Conkg8oo_1coooaM<2ooo7
e@?oolOD1Oona]<2ooo5d`03ooo5e?onaMKoo/GH02goo/GH02;oo/GFook5
e?ona]?oo/GDook6doonaMCoo/KCook5e?ona]?oo<?Boo_3d?om`m;oolKD
ooo8eoooa]Coo<;Aoo^mb_oo`/Wook^noobd]ooj[k?onJZ]oo2PXooLS8oo
ag]mok]iNongQ8?o`ifLom[5`?oaj>?on_Wdoo[onOokoocoo_oo1?oVi^H0
4_o1`L7o[:b/on7QhOoVi^KoSHf=o`<30oo9bLWoj>SXoda<C?m@D53oh^;R
oi2@T?l=3@go;2`/onc/k?o]kNgo>c/kogIfMP;ok^k^00WoV9RHoaXJ6_o^
k^kok^k^ok>c/oo[jn_ok^k^oc8b<_n8R8P00_o_knl02_lo?coo>c/kom7A
dOo_knoohn?Son;Rh_o_knooJVYZocdm?Oo_knl6oo3`l003oiZJV_l92@Wo
[:b/00;olO7a00?o_;bloa@D5?n1PH400_odm?@00omgMgOo?cloooGem@06
ooGem@0Koc<c<on4Q8Com_Kfoo?clom7AdOo8b<Son?Shono_koo0`<3omKF
e_oOgmooF5QHoa0@4?ohn?SonOWiok^k^ooemOGon?Shoc@d=?n>SXkonOWi
ol71`Ol30`?oemOGon3Ph?mIFEWo410@00;oo?cl00[o<S8boeYJF_o/k>co
b/[:obh^;_lA4A7oooooookno_ld=3CoDU9B0_o^k^h00omEEEGo=CDeookn
oP05ooooo`09oc@d=?mfMWKoooooooooooo0`<3ono_kookno_lf=SKoTY:B
00;ooooo00Wo@410ogmoOoooooooa/K6o`@41?oMgMgoi^KVoe]KFolA4A40
0_ooool01_m0@43oOgmoooooooooooooXj>Soa`L70;ooooo00Ko<c<coe]K
Foo]kNgob/[:obh^;_lA4A46ooooo`04oamQ]?nS`^Co^=?_ogN^j`;oZ]oo
00CoMWIfol71`Oo`l?3ooOgmFoooool01ol94P[o4BHDo`T95?lA70[o2A8:
o`T92_l94PX00_l92@X00ol94P[o4A`:o`TB2P03o`T92P;o2A8:00?o0000
oa4L2_l92@X00_l92@X02Ol94P[o2@T:o`TB2_l0003o2A8:o`000?l94P[o
2@T:o`TB2P04o`T92P03o`000?l92@[o000000?o2@T:00?o0000o`TB2_l9
2@X00ol92@X01?l0003o2@T:o`TB2_l00002o`TB2P06oa4L2_lS70[o6PT:
oa4V2_lS70[o4A`:0ol92@X01_l94P[o2@T:oa4L2_lJ2@[o2@T:oa4L2P;o
2@T:00?o4A`:o`T92_lA70X00_l92@X2o`TB2P;o2@T:00?o4A`:o`T92_l9
4PX00_l92@X01?l94P[o2@T:o`000?l94PX2o`T92P04oaXB5?l92@[o0000
o`TB2P;o2@T:00Co2A8:o`000?l92@[o00001?l92@X00ol0003o2A8:o`T9
2P03o`T92P06o`000?l94P[o2@T:o`000?l92@[o00000_l94PX3o`T92P?o
2A8:1_l92@X00ol94P[o2@T:o`T92P03o`T92P05o`000?l92@[o2A8:o`T9
2_l000002_l92@X01Ol94P[o2@T:o`T92_l94P[o2@TD00Go2@T:00Co0000
o`T92_l92@[o2@T:0_lA70X01ol92@[o2A8:o`TB2_lA70[o2@T:o`TB2_lA
70X02_l92@X00olA70[o2@T:oaX92P02oa4L2PCo2@T:00?o0000o`TB2_l9
2@X01?l92@X00ol0003o4A`:o`T92P03o`T92P03o`000?lA70[o2@T:00Co
2@T:00So2A8:o`T92_l94P[o2@T:o`000?l92ACo0000o`T950;o000000So
6Q8Do`T92_lA70[o2@T:oa4L2_l92@[o6PT:o`T92P;o4A`:0_l92@X00ol9
4P[o2@T:o`TB2P03o`T92P;o4A`:0_l92@X00ol92ACo0000oiFQ]`1Ooooo
o`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP0Jonc/k?oLg=coNg]k
om[Jf_oPh>3ohN7QomGEeOo8b<Sob/[:oookoOoonoSomoojoo;omOoXjN7o
c[VdolF:S?nbH6CocV]^omUgM_oOS8KoiIbConNWWOo][:Konk6`oond^Ooo
]l42oonf``05oonia_oo_LWool3;oonnbOoo_<L01Ooo_LP3oonlb0Sookg;
:?oo_<X08Ooo_L[ookg8oonmb_oo_LSookc:oonmb?oo_<[ookg8oonjb?oo
^lKook_9oonkaooo^/SookW5oongaOon]/7ookNjoojg]Ooh/JooljVVoo6P
Woo^UIOoiXN;omQnP?o1LWGoY6QWokjITOoB_[GoimkEooWfkOooo_Soookk
ooooo@08onKViP06ol[:b_l0003oY:BTonSXj?lX:2SoPh>30_oYjNT01_m_
Kfoo;2`/on[Zj_o[jn_o>SXjogEeM@;ok>c/00?oUYJFoaTI6Oo/k>`00_o/
k>`02?o]kNgo]kNgoa@D5?n8R8SokNg]olg=cOl0003o[:b/1OoalO400om9
BDWoK6a/oo;blP05oo;blP03ong]kOlI6AWoCdm?00Colo?c00KoRh^;o`/;
2ooQhN7olo?cogIfM_lo?cl7ooCdm00>oc<c<on3Ph?omOGeofATI?lE5AGo
e=CDooShn?oCdm?o0P82okZj^_okno_oW9bLoalO7oolo?`3oogmo@0>ol?3
`olE5AGoTI6AoogmoOoGemOo0P82ok^k^oomoOgoWIfMoalO7oono_koinOW
o`000?o5aLD2ooooo`06oj^[ZolA4A7oooooomSHf?l0003o]kNg0_ooool0
0ong]kOo0000omcLg005ooooo`03oc@d=?mfMWKooooo00?ooooo00?oaLG5
oaHF5_nCTi<00_ooool02Om0@43oOgmooooooooIfMWo0`<3okfm_Ooooooo
WinOob0P8002ooooo`0:od10@?moOgoooooooooooonSXj?o71`LoooooooX
j>So0@41olG5a@;ooooo00?oZj^[oa4A4Oooool01Oooool01?lOH;CoYLCV
okWCkomg[^/2ojWLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Ko6Q8Do`TB
2_l92ACo2A8:o`T95?lJ4Q@=o`T92P06o`000?l92@[o0000o`T92_l0003o
2A8:0ol92@X02ol0003o2A8:o`T92_l92@[o2A8:o`T92_l94P[o2@T:o`00
0?l92@[o2A8:00?o2@T:00Ko0000o`T92_lA70[o2@T:o`000?lA70X2o`TB
2P;o00000_lJ2@X01_lA70[o8a`:ob`B0?lA70[o6PT:oa4L2PGo2@T:00go
2A8:oa4L2_l92@[o4A`:o`T92_lA70[o0000o`TB2_l92@[o0000o`TB2_l0
003o2A8:00?o2@T:00go0000o`TB2_l92@[o2@T:o`000?l94P[o2@T:o`00
0?lJ71ko6Q8Do`000?l92@[o6Q8D00;o000000?o2@TDo`T92_l92@X00_l9
2@X00ol0003o2A8:o`000002o`T92P03o`TB2_l92@[o2@TD00Co2@T:00?o
4A`:o`T92_l92@X00ol92@X02?lA70[o6Q8DoaXB5?lJ2@[o2A8:o`T92_l9
4P[o2@TD1?l92@X02_l94P[o2@T:o`T92_l92@[o2A8:o`T92_l0003o2@T:
o`000?l94PX3o`T92P03o`TB2_l92@[o000000Ko2@T:00?o2A8:o`T92_l9
2@X01ol92@X01?l0003o2@T:o`TB2_lA70X3o`T92P04oa4L2_l92@[o4A`:
o`TB2P?o2@T:00Ko0000o`T92_l92@[o2A8:o`T92_l00002o`T92P04oa4L
2_l92@[o4A`:o`TB2PKo2@T:00So0000o`TB2_l92@[o0000o`T92_l94P[o
0000o`TB2PCo2@T:00?o0000o`T92_l92@X01ol92@X02Olm4P[oi:X0oonc
0?oCQ03o0000o`T92_l0003o?A8:o`TB2P02o`T92P04oa4L2_l92@[o2@T:
o`TB2PCo2@T:00?o4A`:o`T92_l92@X01Ol92@X2oa4L2P03o`000?nV/l7o
k^k^05kok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV00Coi>CT
omCDe?mkNg_of][J0_oPh>006ooDe=Cob<S8ol_;booon_gooo_hooKon_oa
ooOoiNKNomFi]_nlMGWo_UeTomIXJooNMG;ogH]oomjKR_oMY9?oiJNLooFW
YOonZJkoojjfoon^]oon[[Ooo[6ioone_Ooo^;oookNnoonf_@02oojg_@Co
okJm00?ookFmoonf_Ooo][l0;ooo][l4ooni`@CookS10_oo]l42oonh`P0E
oong`Ooo]/3ookBnoonc^ook[k7onJn/oo:[Yoo]Y9kok9^Hon^AT?oVPXCo
fWMjolYaLonXHV3oZWegom>k/Oo[hMGoooodooonn?oomoCoooom00OoinOW
00oofMWIodM7Aol71`Oog=cLonWYjOlX:2SoQXJ6on[Zj_oYjNWoPh>3ob`/
;?oZj^[ojn_[ocXj>_meMGD00_o/k>`03OnFUYKo6ATIonc/k?o/k>codm?C
odA4A?l20P;oJFUYonCTi?o]kNgo/;2`o`000?li>CT00olk>c/01?ni^KWo
lO7aodU9BOm/K6`6oo;blP03ol_;bol0003oTI6A00Colo?c00Kof=SHo`00
0?nb/[;om?CdogMgMolo?cl7ooGem@06oc<c<on4Q8CoQhN7o`T92Oo1`L7o
m_Kf0_ohn?P03?nXZ:So<C4aoc8b<_ld=3Co7alOoo[jn_okno_oh>3PodQ8
B?l20P;oKfm_oo;blP;ono_k017oZZZZoc4a<Olb<S;o=CDeoalO7oomoOgo
_[jno`000?oUiNGoo_knoooooon/[:co4A4Aoooooonn_[ko0000onKViP02
ooooo`03onCTi?l0003o`L7100Gooooo00Wo=3@dogIfM_ooooooooooonCT
i?m:BT[o0`<3og5aLOofm_H00_ooool02Om0@43oOgmooooooooooooo[Jf]
oc8b<_lc<c?o=SHfob0P8002ooooo`0:od10@?moOgoooooooooooonSXj?o
71`Looooooo0`<3o0000onKViP;ooooo00?o[:b/oa4A4Oooool01Oooool0
1?lKGkKoY<CVokWCkomf[NX2oj_Po`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV
00?o2A8:oaXB5?lA70X00_l94PX00ol92@[o2A8:o`TB2P02o`T92P04o`TB
2_l92@[o2A8:o`TB2P;o2@T:00?o4A`:o`T92_l92@X00_l92@X2o`TB2P?o
2@T:00Co0000o`T92_lA70[o00000_l92@X2o`TB2P;o000000?o4A`:o`00
0?l92@X00_l92@X02OlA70[o2@T:o`TB2_l94P[o2@T:o`TB2_l92@[o6PT:
o`000002o`T92P?o4A`:00Go6PT:oa4V2_l/4P3o8blNoa4L2P02o`TB2P?o
2@T:00?o4A`:o`T92_lA70X00_l92@X01?l94P[o2@T:o`T92_l94PX:o`T9
2P04o`TB2_l0003o2@T:o`TB2P;o000000Co2@T:o`TB2_l0003o00000_l9
4PX01_l0003o2@T:o`TB2_l92@[o2A8:o`0000?o2@T:00?o0000o`TL7_l9
4PX00ol92@X2o`TB2P03o`000?l94P[o2@T:00Co2@T:00Co4A`:o`TB2_lA
;c?o2A8:0ol92@X2o`TB2P;o2@T:0_l94PX00ol0003o2A8:o`000006o`T9
2P03oa4L2_l0003o2@T:00?o2@T:0ol94PX00ol92@[o6Q`No`T92P0:o`T9
2P03o`TB2_l0003o2@T:00;o2A8:00?o2@T:ob<L2_l94PX02Ol92@X00olA
70[o2@T:o`T92P02o`T92P04oa4L2_lJ2@[o2@T:oa4L2PKo2@T:00Co0000
o`T92_lA70[o00002?l92@X06ol94P[o2@T:o`T92_l92@[o4A`:o`T92_lA
70[o2@T:oaXB5?niI`3odiP:ol640?oo/`3oPbl0o`T95?n`C03oooH0oh<h
0?l92@[o6PT:o`T92_lA70[o6PT:o`T92_lJ2@[o2@T:o`TB2P02o`T92P07
oa4L2_l92@[o2@T:oa4L2_l92@[o4A`:o`TB2P02o`T92P03o`000?nV/l7o
i^KV05koi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;ok^k^00Cok>c/
omcLg?mlO7cof][J0_oPh>006ooDe=Cob<S8olc<c?oonokoo_gkooOoo?oe
ooSoi]oIomfj^?nUFEgo`UeSomASIOoIL6cof8IhomREQ?oIVhcoh9fDoo2K
W_ohWZOomjJ/oo>WZoobYj_olJV/ooB/[ooe[k7omK6booB`/@02oo>a/P03
ooFa/_od/;7omJna00?omJna3Ood[k83ooF`/a3om:nb0ooe/;<=ooB_/PKo
lk6c0_oe/;<2ooB_/P;omJjb01Gom:faoo>//?ocZjoom:V]ooBTYoocXjCo
jj6Non>LU_oSUY3ohXf8on5mOOoILW?obfUZojmNGOnIGe_og;ZaoncNeOoo
ooKoooojooSim?ooood01_oWinL01?nTY:Co6ATIoa@D5?n/[:`2onSXj006
obPX:?n5QHGojNWYonWYjOn3Ph?o;2`/0_oZj^X01_lj>S[oEEEEon_[joo[
jn_oT92@oaXJ6P;ojn_[00Co>c/kocdm?Oo:b/[ok>c/0_o]kNd02_o;bl_o
0000oinOWoo2`/;o^k^ko`820_oHf=SolO7aodU9BOm/K6`6oo;blP03ojZZ
Z_l0003ocLg=00?olo?c00Oom?Cdoo3`l?l0003oTi>CooGemOmgMgOo?clo
00Oom_Kf00Co=3@dod10@?l20P;o[Jf]1?ogmoL2ooShn008ooKfm_n?Shoo
820PooShn?oinOWo?clood10@?oEeMD6ooWin@0?ooOgmonATI7o820Poocl
o?oMgMgo0000ok6a/Oono_koooooojb/[?lA4A7oooooomcLg?l0003o];Bd
00;ooooo00?o/[:bo`000?oPh>001Oooool01old=3CoMWIfoooooooooooo
@D51od92@_oKfm/01?ooool00om0@43oOgmoooooo`03ooooo`03oogmoOnD
U9Co8B4Q00;ooooo00[o@410oeeMGOoooooooooooifMWOlM7Agoooooon3P
h?l0003o/[:b0_ooool00on/[:co4A4Aooooo`05ooooo`04oa]N/onUa>Ko
]M3^ogV^k0;oYmco00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01?l971Co6Q8D
o`T92_l94PX4o`T92P03o`TB2_l92@[o4A`:00?o2@T:00Co2A8:oa4L2_l0
003o2@T:0_l94PX00ol0003o2@T:o`T92P05o`T92P05o`000?l92@[o2@T:
o`T92_l000001ol92@X01?l94P[o2@T:o`TB2_l00002o`T92P05o`TB2_l9
2@[o2@T:o`T92_l94PX00_l92@X00olA70[o2@T:ob`B0002oaX92P05oa4L
2_lJ2@[o0000o`000?lA70X00ol92@X02Ol94P[o4A`:oa4L2_l94P[o2@T:
o`TB2_l0003o2@T:o`TB2P04o`T92P;o000000?o4A`:o`000?l92@X00_l9
2@X01_l0003o2@T:o`000?l94P[o2@T:o`0000;o2@T:0_l000001ol92@[o
0000o`000?l94P[o0000o`T92_l000001_l92@X00ol94P[o0000o`000002
o`T92P09o`000?l94P[o0000o`000?l92@[o4A`:o`TB2_l/4P3o2A`D00;o
2@T:0_l94PX00ol0003o2@T:o`T92P03o`T92P05o`000?lJ4QCo0000o`T9
2_l000000_l92@X00ol0003o2@T:o`000003o`T92P04o`TB2_l92@[o2A8:
o`0000Ko2@T:0_l94PX4o`T92P07o`000?l94P[o2@T:o`T92_l0003o2@T:
ob`B0004o`T92P08o`TB2_l0003o2@T:o`000?l92@[o0000oa4L2_l0000:
o`T92P04o`000?l92@[o4A`:o`0000;o2@T:00Go0000o`T92_l92@[o2@T:
o`000006o`T92P03o`000?l92@[o2@T:00;o2@T:00oo2@TDoa4L2_l0003o
Ea`0ooof0?nEE@3o0000om>40?nEE@3o0000oh<_0?oomP3oPcP0o`000?lA
70X01_l92@X00olA70[o2@T:o`T92P02o`T92P09oa4L2_l92@[o4A`:o`TB
2_l92@[o4BHNo`T92_l0003oY[?105ook^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN4000;ooooo01oooOgmonc/k?mkNg_ofMWIomoOgooQhN7oe=CDolO7
aoo<c<cooo_oookno_ogooconOoionWLe_oW_[coTD54ol9IGOo?GEgoeFYT
omEoL?oESWcoeiF7omfFT?o_UYcom9VRonnOX_o/X:3ojZ2OonVRX?oZY:;o
k:JT00;okJVV0_o[ZZH2onfYYP04onjXY_o]YjGokJNUonfWY@_ok:RW6_o]
ZJP;onbXY`KojZVW0_o/Z:L2onVUY006onZTY?oYXj?ojJ>SonRRX_oXX:7o
jinQ0_o_VYl04?oTVYWogIJ@ombBROoMR87oggUeomU]Joo7FUgo^EUJoi9<
B_oZ_KSojmO@ooSek_oloo_on_olookooooXj>P4onWYj@04ogEeMOl0003o
CTi>om;BdP;ojNWY00ooj^[ZobPX:?n6QXKojn_[on[Zj_n3Ph?o;2`/on_[
joo/k>co>c/koa8B4_m]KFgocLg=oe1@D?m7AdL00_o/k>`01Olb<S;oRh^;
ong]kOoGemOoj>SX00;okNg]00_o>SXjof=SHooWinOoU9BDobPX:?o_knoo
jNWYodA4A?mVIVKoiNGUonc/k004oo3`l003ok^k^ol0003oalO700?olO7a
00Wol_;bolO7aol0003oXj>Sono_komaLG7o?3`lon[Zj_o`l?001OoemOD0
1?lc<c?oLG5aob0P8?nBTY82ooKfmP;omoOg00co[Zj^omCDe?oemOGoGUiN
oe5ADOohn?SonOWiocDe=OnBTY;onOWion;Rh_odm?@2ooWin@05ojn_[ooD
e=Com_KfoemOGomBDU800_olo?`01_m2@T;oADE5on;Rh_o[jn_oDU9Boa4A
4@;ooooo00Ko@D51odQ8B?oNg]kogMgModM7Aom4A4@6ooooo`09oc@d=?mf
MWKooooooooooolg=cOoUYJFoooooooXj>Son_[j00;ooooo00Wo@410ogmo
OooooooooooookBd]?oJf][oo?clof5QHOmDE5@00_ooool01_m0@43o51@D
ogIfM_oNg]koEeMGode=C@;ooooo00Ko@d=3odI6A_oShn?ojn_[oe9BD_lA
4A46ooooo`04oa]O]_nTa>Ko^=;^ogJ]jP;o[=oo00CoMWIfol71`Oo`l?3o
oOgmFoooool01?l92ACo6Q8Doa4L2_l92@X2o`TB2P08oa4L2_l92@[o2@TD
oa4L2_l92@[o2A8:o`T92_lA70X2o`T92P03o`TB2_l92@[o4A`:00?o2@T:
00Go2A8:o`T92_l92@[o2@T:o`TB2P02o`T92P03oa4L2_l0003o2@T:00Go
2@T:00Oo2A8:o`T92_l0003o0000o`TB2_l92@[o2A8:00Oo2@T:00Wo0000
oa4L2_lJ2@[o4A`:oaX92_lA70[o;180oaX92_lA70X00_l92@X00ol0003o
2A8:o`T92P08o`T92P03oaX92_l92@[o000000;o2@T:00?o2A8:o`T92_l9
4PX00_l92@X2o`TB2PCo2@T:00?o0000o`T92_l92@X01?l92@X00ol0003o
2@TDo`TB2P02o`T92P03o`TB2_l92@[o2@T:00Ko2@T:0_l94PX01Ol92@[o
2A8:o`T92_l0003o2A8:00;o2@T:00?o2A8:o`T92_l94PX00ol92@X2o`T9
5004o`TB2_l92@[o2@T:o`TB2P;o2@T:00?o2A8:o`T92_l94PX00_l92@X0
1_l0003o2@T:o`T92_l0003o2@T:o`0000;o2@T:00?o0000o`T92_l92@X0
1?l92@X01Ol94P[o2@T:o`T92_l0003o2@TD00;o2@T:00Oo2A8:o`T92_l9
2@[o2@TDo`000?l92@[o2A8:00?o2@T:00?o2A8:o`T92_l000001Ol92@X0
1_l0003o2@T:o`T92_l92@[o0000o`TB2P;o2@T:00?o4A`:o`T92_lA70X0
1?l92@X01?l0003o2@T:o`000?l94PX3o`T92P04o`TB2_l92@[o2@T:o`T9
2P;o2A8:0_l92@X00olA70[o2@T:o`T92P02o`T92P0Ioa4L2_l92@[o2A`N
ocdB2_oof@3oUED0o`T95?oTZP3oPd40ocdB2_n`C03oi:X0oeLL0?l92@[o
2A8:oaX92_lA70[o2@T:oa4L2_l92@[o2A8:o`T92_lJ2@[o2@TDoa4L2P02
o`T92P08oa4L2_l92ACo6PT:o`TB2_lJ2@[o4A`:o`000?n`_/5Oooooo`04
ojn_[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP0Ronc/k?oLg=coNg]komWI
fOoOgmoohN7QomCDe?o6a/Koc<c<oookooono_oomoomoogon_o_gMWol<?0
ohLe=onkDE?ocEMEom=TFooDN6WoeHIgomJ<POoLSX[ojXnHoo2CWOo[UYWo
j9RGonRJV?oWW9WoiifJonRNVooXXIgoj:>NonVTW`?oj:>N0_oXXId00ooZ
X9gojInLonRQW`07onRQW`04onNPW_oXXIooj:6OonRQW`?ojJ:P00?ojZ>Q
onVRX?oYXZ003_oYXZ001?oZXj7ojJ:PonVRX?oYXZ03onRQW`03onNPW_oX
XIooj:6O00Koj:6O00?oij6OonJRWooWXIl01OoWXIl2onRQW`03onNPW_oV
Wigoj9jM00;oiifL01?ojYbLonbBVooZTi_oh9BDomN@R_oFS8?ofX=jomac
KooIIV?obU=Eoke@Don>?Ccom;nkoo3Gdoogm>oon?omooOoooolooooinOW
00?oj>SX00?odM7Ao`410On5QHD01?oXj>P00ooYjNWo?Cdmoi2@T002on[Z
jP0:ohj>S_m0@43ojn_[onc/k?m=CDgoPH61ofm_KolB4Q;o:RXZokFe]@;o
k>c/00Go/;2`ocDe=Ol>3Pko4A4AomOGe`02ong]k@0;omKFe_m2@T;o30`<
oaXJ6_n[Zj_okno_ogMgMol71`Oo2`/;oaTI6OnSXj<01?o`l?000ooPh>3o
0P82oiRHV003oo7al@09oo;bl_n3Ph?o0000olc<c?n8R8So30`<o`H61_lI
6AWoT92@00GomOGe00Ko<c<cohB4Q?o<c<co4A4AokVi^Oofm_H2ooShn00<
ohF5QOl`<33o3`l?ocLg=ono_koonOWioo[jn_nk^k_o>3Pho`l?3olB4Q;o
hn?S0_ojn_X01On7QhOo<C4ao`l?3olh>3So`<3000;oo?cl00Koi>CTod=3
@ol;2`_o:2PXofe]KOlA4A42ooooo`06onSXj?mBDU;o3`l?o`l?3omDE5Co
jNWY1_ooool02Old=3CoMWIfoooooooooooo_knoocXj>_l@413o4a<ConSX
j002ooooo`09od10@?moOgoooooooooooon:RX[o<S8boa0@4?li>CWoa<C4
00;ooooo00KoE5ADohb<S?miNGWo51@Dobh^;_o4a<@2ooooo`06onKVi_m4
A4Co30`<obPX:?m]KFgo4A4A1_ooool01?lMGk?oY/KVokK@k_mi[nh2oj_N
o`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Go4A`:oaXB5?l92ACo4A`:o`TB
2P02o`T92P03o`TB2_lJ4QCo2A8:00?o2@T:00Go4A`:o`T92_l92@[o2A8:
o`T95002o`TB2PCo2@T:0_l94PX03?l0003o2@T:o`TB2_l0003o2A8:oa4L
2_l92@[o2A8:o`T92_lA70[o2@T:o`T950Ko2@T:00Ko0000o`TB2_l94P[o
2A8:o`T92_l94PX2o`T92P03o`TB2_lA70[o2@T:00;o8bH:00?o;180oa4V
2_lJ2@X00_l92@X01_l94P[o2@T:o`TB2_l94P[o2@T:o`TB2P;o2@T:00Ko
4A`:o`T92_l94P[o2@T:o`TB2_l92@X2o`TB2P06o`T92_l94P[o2A8:o`T9
2_l94P[o2@T:0_l000002?l94P[o2@T:o`000?lA70[o0000o`TB2_l0003o
2@T:0_l94PX01_l0003o2@T:o`000?l94P[o2@T:o`0000?o2@T:00?o2A8:
o`T92_l92@X01?l92@X00ol0003o2@T:o`000002o`T92P05o`000?l94P[o
2@T:o`T92_l000000_l92@X3o`TB2P;o2@T:0_l94PX01olJ4QCo2A8:o`T9
2_l0003o2A8:o`000?l94PX00_l92@X00ol94P[o4A`:o`T92P02o`TB2P;o
2@T:00Oo2A8:o`T92_l94P[o2@T:o`TB2_l92@[o2A8:00Oo2@T:00Oo0000
o`TB2_l0003o2A8:o`T92_l0003o2A8:00?o2@T:00?o0000o`TB2_l92@X0
0ol92@X01Ol94P[o2@T:o`TB2_l94P[o000000?o2@T:00?o0000o`T92_l9
4PX00_l94PX5o`T92P03o`TB2_l92@[o2@T:00;o2A8:00?o0000o`TB2_l9
2@X01ol92@X03olA70[o2@T:o`T92_lA70[o2@T:o`000?lm4P[oooH0ojI1
0?l0003odh@0oh=10?n3;`3oooH0o`000002o`T92P04oaX92_l92@[o6PT:
oa4L2P;o2@T:00Go4A`:o`T92_l92@[o2@T:oa4L2P05o`T92P05oaX92_l9
4P[o4A`:o`000?n`_/40Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00
0_oVi^H07?oTi>Coe=CDogalO?oJf][ogmoOon7QhOoDe=Coa/K6olc<c?oo
noooookoooWooOoooo_om^GNooK;aOn9>CSo[TA4olM@C?o@Fe;odVeQomAj
KooCP7Soeh>3on25S_oUR9?oiXfAonFASooVUI82onJGT`04onFGTooTVICo
i9^EonJMU`;oiIbF0_oUVYD2onJHU003onFGTooWVIOoiIZG00KoiIZG00?o
hiREonBIU_oTVIH00_oUVYL2onJKV003onNLVOoUVYOoiIZG00koiIZG00?o
iibIonJKV?oVViP00_oUVYL2onBIUP03on>HUOoUVYOoiIZG00KoiIZG1_oV
W9T3onNLV@03onJKV?oWVIOoiYRF00;oiINE01CoiYJEonNEUooURiCohhbD
omR<S?oAR8;odH=iomAjLOoHJF;oeE]HoleADOnc@d;oRS@cooS1__oniN7o
oociooSoooo`oocoo?ooonOWi`?oj>SX00?oa<C4o`410OoBd]801?oXj>P3
onWYj@;oj^[Z0oo[jn/4onc/k003on_[joo/k>cok>c/00?ok>c/00?okNg]
on[Zj_o]kNd00oo]kNd2onk^kP03onc/k?o_knookno_00;okno_00?oB4Q8
of][Joo`l?001_o`l?000omPH63o:BTYonCTi002oo7al@03ong]kOld=3Co
BDU900;omOGe00?oNWYjochn?_ofm_H01_ofm_H01_ld=3CoQ8B4ooOgmon/
[:co5ADEomSHf0?onOWi00?on_[jooShn?ojn_X00_okno/3ooclo003ooWi
nOolo?coo?cl00Coo?cl00?on_[jooclo?olo?`00_omoOd01_ono_kooooo
oogmoOoooooo[:b/oa4A4@Cooooo0_ono_h8ooooo`03oc@d=?mfMWKooooo
00?ooooo00?oo?clooooooooool00_ooool00om0@43oOgmoooooo`03oooo
o`03oogmoOoooooooooo00Gooooo00?oo_knooooooooool01?ooool01?om
oOgoooooojb/[?lA4A46ooooo`04oaYL/onT`nGo^=;_ogV^k0;o[=oo00Co
JVYZojj^[_oHf=Soi>CTFooVi^H01?l971Co2@TDoa4L2_l94PX3o`T92P09
o`TB2_lJ4QCo2A8:o`T92_l94P[o4A`:o`T92_l94P[o000000;o2A8:1Ol9
2@X2o`TB2P04o`T92_l94P[o2A8:o`0000Co2@T:00So4A`:o`T92_lA70[o
0000o`T92_l94P[o2@T:o`TB2P;o2@T:00?o0000o`T92_l94PX00_l00000
0ol94P[o0000o`T92P02o`T92P;o;1800_lS70X02?lS9P[o6PT:oa4L2_l0
003o2A8:o`000?l94P[o00000_l92@X02?l0003o2@T:oa4L2_lJ2@[o4A`:
o`000?l94P[o00000_l92@X01_l0003o2A8:o`000?l0003o2@T:o`0000?o
2@T:00?o2A8:o`000?l000000ol92@X01_l0003o2A8:oaX92_l0003o2@T:
o`TB2P;o2@T:00Ko0000o`TB2_l92@[o2@T:o`TB2_l92@X3o`TB2P0<o`00
0?l92@[o2@T:o`T92_l94P[o0000o`T95?l0003o2A8:o`000?l94P[o0000
0_l94PX5o`T92P0:o`TB2_l0003o2A8:o`T95?l0003o2A8:o`000?l92@[o
2A8:o`0000;o2A8:0_l000002Ol94P[o2@T:o`000?l92@[o2A8:o`000?l9
2@[o2A8:o`000004o`T92P06o`T95?l92@[o2A8:o`T95?l92@[o2A8:1?l9
2@X00olA70[o0000o`TB2P02o`TB2P0:o`000?l92@[o2@T:o`000?l92@[o
2A8:o`000?l92@[o2A8:o`0000Ko2@T:00?o4A`:o`000?l92@X00ol92@X0
1_l94P[o2@T:o`T92_l0003o2@T:o`TB2P;o000000?o2A8:o`000?l92@X0
2?l92@X03ol94P[o2@T:o`T92_l92@[o4A`:o`000?oCV0[odh@0onBZ0?of
/`3ook<0oooI0?lJ2@[o0000o`T92P02oa4L2P03o`T92_lJ4QCo2A8:00?o
2@T:00?o2A8:oa4L2_l92@X01?l92@X00ol94P[o4A`:o`T92P02o`T92P03
o`000?nEXKOoi^KV05koi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;o
k^k^01kok>c/omcLg?mlO7cofMWIon3Ph?oQhN7oeMGEolS8b?o;bl_ooo[o
oooloooko?kooookoo[`ioogd/[oT4I3oihh=?nj@cooada5oliNDooAJV7o
cG9]olegN?oENhGofX2:omj3R?oQR8[oiXf?onJ@TOoTT902on6@S`04on6A
T?oSTi;ohi>Bon:BT@;ohY6@00?ohhn?on:>S_oPShh02?oRT982on2>T004
on6?TOoRT9;ohY2Bon>AT`;oi9:D4?oRT982onBBU004on>ATooRT9;ohY2B
on6?T@;oh8j@1ooSTI<00ooRTY?oi9BEonBDU@04onBDU@;oiI>E00?ohi6C
on:@T_oSSY400ooQS8l04ooRS8oohHbAom^4SOoGQ8codH>3ol]lMoo<MFco
d6]Som5JE?o=CD[o`TE3oj@f=On??S_oo/_7ooobk_ooo__onOooooGooool
ool01OoWinL01Om3@d?o=3@doh20P?mHF5SoD51@00Coj>SX0_oYjNT6on[Z
jP[ojn_[0oo/k>`2ong]k@?ok^k^0_o_knl00ooAdM7od=3@ono_k`05ono_
k`09oo3`l?oOgmoo?ShnobHV9_mlO7coPX:2oc4a<Ol_;boof=SH00;om?Cd
00?o/K6aoadM7Oofm_H01_ofm_H01old=3CoQ8B4ooOgmoogmoOoPX:2ob/[
:oo/k>`00_ohn?P5ooWin@_on_[j0_okno/2ooclo006oogmoOono_koo_kn
oooooon/[:co4A4A3_ooool00old=3CoMWIfooooo`08ooooo`03od10@?mo
Ogoooooo01Cooooo00?o[:b/oa4A4Oooool01Oooool01?lMGk?oYLCVokKB
k_mi[^T2oj[Po`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Co6Q8Do`T95?lA
70[o2@TD0_l94PX00ol92@[o4A`:o`TB2P02o`T92P06o`TB2_l92@[o2@T:
o`TB2_lJ4QCo2@T:0_l94PX2o`T92P06o`TB2_l0003o0000o`T92_l94P[o
00000ol92@X02_l94P[o2@T:o`TB2_l0003o2A8:o`000?l92@[o2A8:o`TL
7_l00002o`TB2P03o`T92_l94P[o2@T:00;o2@T:00Go2A8:o`000?l94P[o
0000o`T92P02oa4L2P06oaX92_lS9P[o;180ob<L2_l/4P3o4A`:0_l92@X0
0ol94P[o0000o`T92P05o`T92P06oa4L2_lJ2@[o2@T:o`T92_l94P[o0000
0_l92@X02_l94P[o2@T:o`TB2_l94P[o2@T:o`TB2_l92@[o0000o`TB2_l0
0005o`T92P04o`000?l92@[o2@T:o`TB2P;o000000Ko2A8:o`T92_l0003o
2@TDo`TB2_l00002o`T92P06o`TB2_l92@[o2@T:o`TL7_l0003o2@T:0_l9
4PX2o`T92P05o`000?l92@[o0000o`TB2_l000001Ol92@X01Ol94P[o0000
o`T95?l0003o2A`N00;o000000Go2A8:o`000?l92@[o2@T:o`000004o`T9
2P03o`000?l94P[o000000;o2@T:00Oo2@TDo`TB2_l92@[o2@T:o`TB2_l9
2@[o2A8:00Co2@T:00Wo2A8:o`000?l92@[o0000o`T92_l94P[o0000o`T9
2_l92A@00_l00007o`T92P03o`000?l92@[o2@T:00;o2@T:00Ko0000o`T9
2_l92@[o0000o`T92_l92A@2o`T92P04o`TB2_l0003o2@T:o`TB2PKo2@T:
00?o0000o`T92_l92@X01ol92@X03_l94P[o2@T:o`T92_l92@[o2A8:o`T9
2_l92ACo6PT:om>H2_oTZP3o`H@0ojIW0?nEE@3o2@TD0_l94PX00ol92@[o
2@TDo`T92P02o`T92P03oa4L2_l92@[o2@T:00?o2@T:00_o4A`:o`T92_lA
70[o2@T:o`TB2_l92ACo2@T:oa4L2_l92@[o0000ok2n`@1Oonk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q0002ooooo`0OoogmoOo/k>coO7alomWIfOoP
h>3ohN7QomGEeOo7alOob/[:ooohoooon_ooo?cnookonooln>golmS=oi1D
C?n><bko[3Hdokhn>oo9Cd[oceiHolaXI_o:LG?obgR0om1oQ_oFOhGog8>7
on2:SOoRSI3ohHb?omf;S@02omb<S@;ogHn?0_oMSHh01?oMRhgog8Z<om^9
RooKRH/8omf=T0;ofXZ=00Cofh^>omb<SooMSI3ogHf@0_oNSY4@omb<S`;o
gXjA0_oMSI001?oLS8oofh^>omZ:SOoJRXd8omj>T@CogHjA1?oNSY401?oO
SI7ogXb@omf;SooKRHd3omf8S@0Bomb:S_o@OhKocWn5olYlO?o7M73obFYT
olaOF_o<Cd_o`d=0ojlh=?nF<2coUU5:oooHd_oon_Kooo_joo[koooloooo
o_oo1OoWinL01_oShn?oY:BTof=SHomkNg_o[Jf]onSXj0?ojNWY00?oj^[Z
onWYjOoZj^X00_oZj^X3on_[j`Ook>c/1_o]kNd2onk^kPGokno_2_o`l?00
1_o^k^koXj>Sog9bL_m]KFgoWIfMonk^kP?om_Kf00GolO7aod92@_lQ8B7o
6a/Kom3@d004ooOgm`03ojZZZ_o;bl_on?Sh00;on?Sh00CoX:2Polk>c_oi
nOWon?Sh1OoinOT;oo[jnP;ono_k0_olo?`01_omoOgoo_knookno_oooooo
[:b/oa4A4@kooooo00?o[jn_olW9bOooool02?ooool00om0@43oOgmooooo
o`0Dooooo`03ojb/[?lA4A7ooooo00Gooooo00Co6ejcojK6i_nidnkoNJk[
0_n[gol01?mfMWKo`L71oo3`l?omoOeKooooo`09oa4L2_lJ4QCo2@TDoaXB
5?l94P[o2@TDoa4L2_l92ACo2A8:00;o2@T:00Ko2@TDo`T92_l92@[o2@T:
oaXB5?lJ71h4o`T92P03o`TB2_l92@[o2@T:00;o2A8:00?o2@T:o`TB2_l9
2@X01Ol92@X00ol0003o2@T:o`TB2P04o`T92P05o`000?l94P[o0000o`T9
5?l94PX00ol92@X02ol0003o2A8:o`000?lA70[o6PT:oa4V2_l/4P3o8a`:
oa4L2_l92@[o6PT:00?o2@T:00?o0000o`TB2_l94PX00ol92@X01?l92ACo
4A`:oaX92_lA70X2o`T92P04o`000?lA70[o2A8:o`0000;o2@T:00Go0000
o`TB2_l92@[o2@T:o`TB2P02o`T92P03o`TB2_l92@[o2@T:00?o2@T:00Oo
2A8:o`T92_l92@[o2A8:o`T92_l0003o2A8:00;o2@T:00Ko2A8:o`T92_l9
2@[o2A8:o`T95?l94PX2o`T92P04o`TB2_l92@[o2@T:o`0000;o2A8:00Go
2@T:o`TB2_l92ACo0000o`T95002o`T92P04o`T95?l94P[o2@T:o`T92P;o
2A8:0_l92@X04?l92ACo2@T:o`000?lJ4QCo2@T:o`000?l94P[o2@T:o`TB
2_l92@[o2@TDo`TB2_l0003o2A8:o`T92_l94PX3o`T92P03o`TB2_l92ACo
2@T:00Co2@T:00Go2A8:o`T92_l92@[o2@T:o`T95005o`T92P06o`000?l9
2@[o2A8:o`T92_l0003o2A8:0ol92@X01?l94P[o2@TDo`T92_l94PX7o`T9
2P03o`TB2_l92@[o2A8:00Ko2@T:00Go2A8:o`T92_l92@[o2@T:o`000005
o`T92P03o`000?l92@[o2@T:00;o2@T:00_o4A`:o`T92_l94P[o4A`:o`T9
2_l0003o2@TDo`000?l92ACo0000o`T95003o`T92P03oaX92_l92ACo4A`:
00?o2@T:00Go6Q8Do`T92_l94P[o4A`:o`TB2P03o`T92P08oa4L2_lJ4QCo
6Q8Do`T92_l92ACo4BHDo`000?n`_/5Oooooo`04ojn_[oo;bl_og]kNon[Z
jP7ol_;b0002onk^kP0Lonc/k?oLg=coNg]kom[Jf_oOgmoohN7QomGEeOo6
a/Kob/[:ooo^o?oon?ooooooooWonOolooKoooSZojioMOn4=BkoXSDbojLZ
:?o1@D3oe5YIolmWJ?oEO7kofXnDomZCUooNTYKohi>FonFFV@;oi9RJ00?o
hiVJon:JVooSVi`00_oSWId00ooTW9gohi^LonFKW003onBJV`Sohi^N0_oP
V9/01?oQVIcohYZMon>KW_oSVih3onBLW`07on>KW_oQVIcoh9RKon2HVooQ
VIcohi^NonBLW`08on:JW@?oi9bO0_oSVih3on:JW@Sohi^N1?oRW9h4on>K
WP0JonBIWOoWW:3oiibPon>HW?oQUIWohYJJon6EVOoMTYKoeHjBonBLWooA
QHGocgMeomYbKoniAT?oadM6ojha;onC9R?oScXcoim[H?oon>oooochooch
nOooo?ooooWoooonoooWinL:onSXj0?ojNWY0_o[jn/3ong]k@[ok^k^1oo_
knl6oo3`l0_olO7a0oobl_82ooCdm0?om_Kf0_ogmoL00ooQhN7oi^KVooOg
m`05ooOgm`gon?Sh2ooinOT2oo[jnP?oo?cl0_ono_h00oooooooo_knoo[j
nP0Iooooo`03oo_knoomoOgooooo01Cooooo00?oo_knoo[jn_ooool01Ooo
ool01?lOHKCoXl;TokSCkomg[^/2oj[Oo`04ofi^K_nd];Coh>3Ponc/k5_o
k^k^00_o2A`Do`T95?l94P[o2@TDo`TB2_l92@[o2@TDoa4L2_l92@[o2A8:
oa4L2P03o`TB2P05oa4L2_l92@[o6Q8Do`TB2_lA70X00_l92@X01Ol94P[o
2@T:o`T92_l92@[o2A8:00?o2@T:00?o2A8:o`T92_lA70X01Ol92@X00ol0
003o2A8:o`TB2P03o`T92P05o`TB2_l92@[o2@T:o`000?l94PX01Ol92@X0
0olS70[o;180oaX92P03ob<L2P03oa4L2_l94P[o2A8:00;o2A8:00Wo2@T:
o`000?l94P[o2@T:o`TB2_lJ4QCo2A8:oa4L2_l92A@00_lA70X4o`T92P0;
o`TB2_l92@[o2@T:o`T92_l0003o2A8:o`T92_l0003o2@T:o`000?l94PX0
0_l92@X00ol94P[o0000o`000002o`000007o`T92_l0003o2A8:o`000?lA
70[o0000oa4L2P03o`T92P05o`T95?l94P[o2@T:o`TB2_l000001?l92@X0
3_l0003o2A8:o`000?l94P[o2@T:o`000?l92@[o4A`:o`T92_l94P[o2@T:
o`TB2_l92@[o2A8:0ol92@X03ol0003o2@T:o`000?l94P[o2@T:o`000?l9
4P[o2@T:o`000?l94P[o0000o`T95?l92@[o2A8:o`000003o`TB2P05o`T9
5?lA9QCo2@T:o`TB2_l92@X00_l92A@4o`T92P03o`000?l92@[o2@T:00Oo
2@T:00?o2A8:o`T92_l92@X00_l92@X00ol0003o2@T:o`T92P05o`T92P05
o`TB2_l92@[o4A`:o`T92_l92A@00_l92@X2o`TB2PCo2@T:00?o0000o`TB
2_l92@X01_l92@X00ol94P[o2@T:o`T92P07o`T92P06oa4L2_l92@[o2@TD
oa4L2_l92@[o4A`:1Ol92@X01OlA70[o2@T:o`T92_lA70[o2@T:00;o4A`:
00?o2@T:oaX92_l94PX00_lA70X02?l94P[o2@TDoa4L2_l92@[o2A8:o`T9
2_l0003oYZZ]Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H0
8OoTi>Coe=CDogMgMooJf][oh>3Pon7QhOoDe=CoalO7olc<c?oom?oooo?l
ooonoooioogokOW]ooklkooL_;7oKRdWohhZ:?nL92Go]SPiolY?DOoIL7Co
ihj@om^EUooFV9WojZFXonfWZOo_ZjcokZb]onf[[?o/[:cojZf/on^^[@02
onjb/@03onnb/Oo^/K3ol;2`00?okjn_2?o^/;401?o[[Jkok:j_onb^[oo]
[k02onj`/@?okk6b00Ook[2aonb^[oo[[Jkojjf^onb^[oo^/;7okk6b00So
kJn`0oo_/K82onj`/@?okJn`2?o^/;44onfa/@Cok[2a00Gokjn`oo:b/oob
/[?okZj_onj/[P02onn][`0Bon^[[?of][OogYZKomN;RoooYjKoaE]Koke6
B?nm@D?oUR0PoiXk=omW8a[ogkfaooojk_olnOCoookoooohoooonOoooogo
2OoVi^H5onOWi`03onSXj?oYjNWoj^[Z00Goj^[Z1oo[jn/3onc/k0?okNg]
00?okno_onk^k_o`l?000_o`l?02oo7al@_ol_;b1?oclo<4ooCdm0[omOGe
0oofm_H2ooOgm`;onOWi00Con?Shoo[jn_ojn_[on_[j0_okno/=ooclo0;o
oOgm00?oo_knooooooooool0>oooool01?lOH;CoYLCVokWCkomg[^/2ojWL
o`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00Go6Q8Doa4V5?lJ4QCo2@TDoa4L
2P02o`TB2P03o`T92_lJ4QCo2@T:00;o2@T:00Co2A8:o`T92_l92@[o2A8:
0_l92@X01?l94P[o2@T:o`T92_l94PX3o`T92P07oa4L2_l94P[o2@T:o`TB
2_l0003o2A8:o`T92P02o`TB2PGo2@T:0_l94PX2o`T92P;o2A8:1_l92@X0
2Ol94P[o2@T:o`T92_lA70[o2@T:ob<L2_lJ2@[o;180oaX92P03o`T92P03
o`TB2_l0003o2@T:00;o2@T:00?o2A8:o`000?l92@X00_l92@X04ol94P[o
2@T:o`T92_l94P[o2@T:o`TB2_l0003o2@T:o`TB2_l92@[o2A8:o`000?l9
2@[o2A8:o`000?l92@[o0000oa4L2_l000001_l92@X01_l0003o2@T:o`T9
2_l92@[o2A8:o`0000Co2@T:00?o2A8:o`T92_l92@X00_l94PX3o`T92P0:
o`T95?l0003o2@T:o`TB2_l92@[o0000o`TB2_l0003o2@T:o`TB2P?o2@T:
0ol94PX01ol92@[o2A8:o`000?l94P[o0000o`T92_l000000ol92@X01ol0
003o2@T:o`T92_l94P[o0000o`T92_l94PX00ol92A@00ol971ko2@TDo`TB
2P04o`TB2P;o2@T:00?o2A8:o`T92_l92@X01Ol92@X01?l0003o2@T:o`TB
2_l00002o`T92PCo2A8:00So2@T:oa4L2_lA70[o4A`:o`T95?l92@[o4A`:
o`TB2P?o2@T:0_l94PX4o`T92P03o`TB2_l92@[o2@T:00Ko2@T:00Co2A8:
o`000?l92@[o2A8:2Ol92@X01?lA70[o2A8:o`T92_l94PX2o`T92P08oaX9
2_l92@[o2@T:oa4L2_l92@[o4A`:o`T92_lA70X3o`T9500=o`TB2_l92@[o
4A`:o`T92_lJ2@[o2@T:oa4L2_l92@[o4A`:oaXB5?l94P[o0000ojJc`@1O
onKViP04oifMWOng]kOob<S8om?Cd`7of][J0002onk^kP04onc/k?oLg=co
MWIfomWIf@;ogmoO01_oe=CDolO7aoo:b/[oooGoooo`m_oooooon?omonoo
mOonooKooo[aojAaKOmf8R3oSR@VoidY;?nb?d;oh7anoojZZ_o`[jgojJn]
onR^[OoZ/:oojk>bon^e/ooZ];;oikBaonJe/OoU]K401?oW]k<2onNf/P;o
j;Fb2?oW]K@00ooU/k;oi[BconJd/`02onNe]0;oj;Je0_oY]kH01ooX][Go
i[BconFc/_oU/k;oi[BconRf]OoY]kH02?oW]K@4onRf]@coikFd1_oV][@2
onNe]003onJd/ooX][Goj[Nf00;oikBc01CojKJeonRe]?oW/JoohjVWonb[
ZOobYZKokIFDon5hO?ngAT[oVBHYoh@L7Om]7a_oZg]aoooij_ognNcoo?ok
ooOen?oon?ooooOoooomo`WoiNGU1OoVi^H2onSXj0Koj^[Z2_o[jn/3onc/
k0;okNg]0oo^k^h:ono_k`?ol?3`0ooalO400oobl_;olO7aoo;blP02oo;b
lP;olo?c2?odm?@3ooGem@;om_Kf0oohn?P3oo[jnP;ono_k3Oolo?`2oogm
o@03ookno_oooooooooo03_ooooo00Co6enfojC4i_nidnooMZgZ0_n[h?l0
1?m^KVko];Bdon3Ph?o/k>aKonk^kP09oa4V5?l92ACo6Q8Do`T92_lA70[o
2@T:oa4L2_l94P[o2@T:00;o4A`:00Oo2@T:oa4L2_lJ4QCo2@TDo`T92_lA
70[o2A8:00?o2@T:00Ko4A`:o`T92_lA70[o2@T:o`TB2_l92@X2o`TB2P05
o`T92_l94P[o2A8:o`T92_l94PX00_l92@X02_l94P[o2@T:o`T92_l94P[o
0000o`TB2_lJ2@[o2@T:o`TB2_lA70X2o`T92P03oa4L2_l94P[o000000;o
2@T:00Wo6PT:oa4L2_l/4P3o8a`:ob`B0?lJ2@[o4A`:o`TB2_l92@X00_l9
4PX2o`T92P04o`TB2_l92@[o2A8:o`TB2P;o2@T:00?o2A8:o`T92_l92@X0
1ol92@X01?l94P[o2@T:o`T92_l00002o`T92P03o`000?l92@[o2@T:00;o
2@T:00Co0000o`TB2_l92@[o2A8:0_l92@X01?l0003o2A8:o`000?l94PX3
o`T92P06o`TB2_l92@[o2@TDo`T92_l92ACo00000ol92@X00ol94P[o0000
o`T92P03o`T92P03o`TB2_l92@[o2A`D00Go2@T:00?o2A8:o`T92_l94PX0
0_l92@X01?l94P[o2@T:o`TB2_l00004o`T92P03o`TB2_l0003o2@T:00;o
2A8:00So6Q8Do`000?lA9QCo4BHDob`L5?lA9QCo2@TDoaXB50Co2A8:00?o
2@TDo`T92_l92@X00ol92@X00olA70[o2@T:oa4L2P02o`T92P0:o`TB2_l9
2@[o6Q8Do`T92_lA70[o2@T:oaXB5?lA70[o6Q8Doa4V7P;o6RHD00?o4BHD
ob<_7_lJ9Q@00olJ9Q@2oa4V5008oa4L2_lJ4QCo2A8:o`T92_lJ4QCo2A8:
o`T95?lA70X2o`TB2P;o2@T:00?o2A8:o`T92_l92@X02Ol92@X00olA70[o
2@T:o`T92P03o`T92P03oa4L2_l92@[o4A`:00Ko2@T:00Oo2A8:oa4L2_lJ
2@[o2@T:oa4L2_l92@[o4A`:00?o2@T:00Wo2A8:o`T92_l92@[o4A`:o`TB
2_lJ4QCo2@TDo`000?o1al`0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Q
h@000_ooool07oomoOgokNg]og9bL_oGemOogmoOon3Ph?oBd];oalO7ol[:
b_oomOOooo_moogmoOohookomoomooconoooo?Koon3MoieKG?mX4Q?oPAdO
ojDn@Oo2IfKoiiJCon6MV_oUZZKoiZn/onNb[_o[][;oj[NconRg/_oV]k40
1_oT]k44onJg/@0_onJf/_oT]k;oi[JbonBg/_oV][;oi;NbonJf/_oT]k;o
iKFaon>f/OoU]K7ohkJaonJf/_oT]k;oikNconFh/ooW]k?oi;NbonFe/OoS
][7oiKFaon>f/OoV][;oiKRconJf/_oT]k;oi[JbonBg/_oV][;oi;NbonJf
/_oT]k;oi[JbonBg/_oV][;oi;NbonJf/_oT]k;oi[JbonBg/_oV][;oi;Nb
onJf/_oT]k;oi[JbonBg/_oV][800_oT]k800ooS^;;oi;Nbon>h/P04onBg
/P0IonBd/?oW]k?oikNconFe/OoV]K7oikJbonFd/?oT[j_ojJjZomnKV?oo
]K;oj9BBolATI_n=:2coQR4Uog@N7onFFEKoon[Qoooll?ohooKon?omooSh
n_oon?oooo7nooomo`09onKViP;oinOW0ooXj>P2onWYj@?oj^[Z0oo[jn/7
onc/k0KokNg]00?ok^k^ono_koo`l?001?o`l?0;oo7al@?ol_;b0_oclo<3
ooCdm0[omOGe1Oofm_H2ooOgm`03ooKfm_ogmoOomoOg00?omoOg2oohn?P2
ooWin@?ono_k0_omoOdAooknoR[ooooo00Co6ejcojG4i_ned>koNJk/0_nW
g?l01?mfMWKo`L71oo3`l?omoOeKooooo`06oa4V5?lJ4QCo2A8:o`T92_lA
9QCo2@T:0_l94PX3o`T92P03oa4L2_l92@[o2A8:00;o4A`:0_l92@X01?l9
4P[o2@T:o`TB2_l94PX4o`T92P06oa4L2_l94P[o2@T:o`T92_l94P[o0000
0_l94PX2o`T92P03o`000?l94P[o2@T:00So2@T:0_l94PX01Ol92@[o4A`:
o`T92_l92@[o4A`:00;o6PT:00Go;180ob<L2_l/4P3o4A`:o`TB2P05o`T9
2P06o`000?l92@[o2@T:o`000?l94P[o2@T:0_l94PX2o`T92P04o`TB2_l9
2@[o2@T:o`TB2P?o2@T:00?o2A8:o`T92_lA70X00_l92@X3o`TB2P;o2@T:
00Go4A`:o`000?l92@[o0000o`TB2P05o`T92P05o`000?l94P[o2A8:o`T9
5?l94PX00_l92@X01?l0003o2@T:o`T92_l94PX7o`T92P03o`000?l94P[o
2@TD00;o2@T:00Co2A8:o`T92_l92@[o2@T:0ol94PX01?l92@[o0000o`TB
2_l00009o`T92P09o`000?lJ4QCo4Blcob<_:Ol99RWo8d4mo`T92_l92ACo
2A8:00;o2@TD01;o2A8:ob<_:Ol971ko2A8:o`T92_l94P[o0000o`T95?l9
2@[o2A8:o`T92_lA9QCo4A`:oaXB5?lA9QCo2A`Doa4V5?lJ4Q@4oa4V5003
ob<V2_lJ71ko;3PY00;o8blN0_lS;bT00olJ9QCo4BHNob<_:@02ob<_7P04
oaXV5?lS;ako;3PYoaXV50;o8blN00Go2A`DoaXB5?lA70[o2@TDoa4L2P02
o`TB2PCo2@T:00Go2A8:o`T92_l92@[o2@T:o`TB2P03o`T92P05oaXB5?l9
2@[o4A`:o`T92_lA70X00ol92@X00olA70[o2A8:o`T92P03o`T92P03oaXB
5?l92@[o4A`:00;o2@T:00?o4A`:o`T92_lA70X00_l94PX02?l92@[o8a`:
o`T92_lJ2@[o2@TDob<V2_l92ACoYZZ]Goooool01?n_[joobl_;omkNg_oZ
j^X1oo;blP000_o^k^h01?o/k>cogmoOog5aLOo?cll2omgMg@0Hom7AdOo4
a<Cob<S8ooomnOooo__oo?cjooWmo?okooooo_kooo;XjOoomoSoonk_ofda
<Om`9RGoRc`hoj=BCooYViOohY^Eon2MUooPXIcoh:FQonFZY_oV[:Soi:fX
0_oR[JL00ooP[ZOoh[2Yon:`Z@02on:`Z@CoiK2Z02ooiK2/on>`[?oU/:co
hk2/onF`[?oS/:coiK2/on>`[?oT[j_ohZn[onB_ZooS/:coiK2/on>`[?oU
/:cohk2/onF`[?oS/:coi:n[on:_ZooT[j_ohZn[onF`[?oS/:coiK2/on>`
[?oU/:cohk2/onF`[?oS/:coiK2/on>`[?oT[j_ohZn[onB_ZooR[j_oiK2/
on>`[?oU/:cohk2/onF`[?oS/:coiK2/on>`[?oU/:cohk2/onF`[002on>`
[003on:a[?oS/:coh[6/00Cohk2/01Woi:n[onF`[?oU/:cohjjZonB]Z_oU
[Z_ohJZWomjSWooPVYSojZ2MomF<Q_o0MG3oT40oohHd=_m[6akoMC4boooZ
iooonO;omogaooCon_o_o?Goo_ooooocoOoon?oooogo00WoiNGU1OoVi^H0
0ooXj>SoinOWonWYj@05onWYj@[oj^[Z0oo[jn/00oo/k>cokNg]onk^kP02
onk^kP[okno_0oo`l?03oo7al@;ol_;b0ooclo<2ooCdm0SomOGe1Oofm_H2
ooShn003ooOgmooinOWonOWi00?onOWi2oojn_X2oo_kn`?oo?cl0_omoOdA
ooknoR[ooooo00Co6enfojC4i_nhd^koMZgZ0_n/gol01?m^KVko];Bdon3P
h?o/k>aKonk^kP0:o`TB2_l92ACo2@T:o`TB2_lJ71ko2@TDoa4L2_l92ACo
2@T:oa4L2P;o2@TD00?o6Q8Do`TB2_l92@X00_l92@X00ol94P[o2@T:o`TB
2P08o`T92P04o`TB2_l92@[o2@T:o`TB2P;o2@T:00?o2A8:o`T92_l94PX0
4_l92@X00ol/4P3o8a`:ob`B0002oaX92P03o`TB2_l0003o2@T:00_o2@T:
0_l000001?l92@[o0000o`TB2_l00003o`T92P03o`000?l92ACo000000;o
2@T:0ol000001ol92@[o0000o`000?l94P[o0000o`T92_l92A@00_l94PX0
2Ol0003o2A8:o`T92_l92@[o2A8:o`T95?l94P[o2@TDo`TB2P03o`T92P04
o`TB2_l0003o2@T:o`0000?o2@T:00Ko2A8:o`000?l92@[o2@T:o`T95?l9
4PX2o`T92P09o`000?l94P[o2@T:oaXB5?l92@[o0000o`TB2_l92@[o0000
00;o2@T:00Ko0000o`T92_l0003o2A8:o`T92_l00003o`T92P05o`000?lS
@Cgo=2lcodIED_l971h00_l92A@01Ol971Co6Q8Do`T95?l0003o?Blm00;o
2@TD00Ko2A8:o`T92_l92@[o0000o`TB2_lJ4Q@3oa4V5004o`TB2_lJ4QCo
4A`:o`T950;o4A`:01;o2A8:oaXB5?lJ4QCo2A`NoaXV5?l971ko4A`:oaXB
5?l/>2Wo8blYoaXV5?lJ71ko8blNob`V5?lA9Qko8blNoaXL7_lJ9Q@2ob<_
7P0:oaXV5?l/9QCo6Q`NoaXV5?lS;ako4A`:oaXB5?lJ9QCo2@TDoa4L2P;o
2@T:00?o4A`:o`T92_l92@X00_l92@X01Ol94P[o2@T:o`T92_l92@[o4A`:
00Oo2@T:00Co6PT:o`T92_l92@[o4A`:1?l92@X2oa4L2P05o`T92_lA70[o
2@T:o`T92_lJ2@X01?l92@X2oaXB5003o`000?n`/kOok^k^05kok^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV01koiNGUomWIfOmhN7So_kno
omSHf?oJf][oc<c<ol71`Oo5aLGonoohoo[onOonoogoooooooOdnoooo?oo
n>geooojoOoomOKoooCcoga;A_mE61?oRD@moh4f<?o3MW3odH=oom67Q?oC
S8SofI:>ombGT_oLVI<2omZIT`GofY^D1?oLViD0;ooLViOofibGombKUooK
W9Oog9^Gom^LUooLViOofibGombKUooKW9Oog9^Gom^LUooLViOofibGombK
UooKW9Oog9^Gom^LUooLViOofibGombKUooKW9Oog9^Gom^LUooLViOofibG
ombKUooKW9Oog9^Gom^LUooLViOofibGom^JU_oJViKofiZFomZKU_oLViOo
fibGombKUooKW9Oog9^Gom^LUooLViOofibGombKUooKW9Oog9^G00;ofibG
0ooIW9L4om^LU`0Iom^JU_oLViOofiZFomZIUOoLV9GogIVFomRDTOoCS8So
dX=oomN8Pon]I5koUU5<ogTe<_m>3PkoSe5Booo`lOoom_CoooWeooWon_o_
ooSoloomoocoooohjo;oooWoooomo`09onCTi0GoiNGU0_oWinL6onWYj@[o
j^[Z1?o[jn/4onc/k0[okNg]1_o^k^h00oo`l?3okno_oo7al@04oo7al@So
l_;b0ooclo<2ooCdm0;omOGe00Com_KfooOgmoogmoOomoOg0_ohn?P;ooWi
n@;on_[j0ookno/2ooclo13ooOgm0oono_hXooooo`04oaeO/onVa^Ko]]3^
ogV_kP;oZmko00CoJVYZojj^[_oHf=Soi>CTFooVi^H00olJ4QCo6RHDo`TB
2P04o`TB2P08o`T92_lA70[o2@T:o`T92_l92ACo2@T:o`T95?lA70X2o`TB
2P03oaX92_lA70[o000000;o2A8:00Wo2@T:o`TB2_l92@[o2@T:o`TB2_l9
2@[o2A8:o`T92_l94PX00ol92@X00ol94P[o0000o`T92P02o`T92P09oa4L
2_l0003o2A8:o`TB2_l92@[o6PT:o`T92_lA9Qko4A`:00?o2@T:00Oo2A8:
o`T92_l92@[o4A`:oaX92_l92@[o4A`:00Co2@T:00Ko4A`:o`T92_lA70[o
2A8:o`T92_lA70X2o`T92P;o4A`:1Ol92@X00ol0003o2@T:o`T92P02o`T9
2P05o`000?l92@[o0000o`T92_l94PX00ol92@X00ol94P[o0000o`T92P02
o`T92P06o`000?l94P[o0000o`000?l94P[o00000ol92@X02_l94P[o2A`N
o`TB2_l92ACo2A8:o`T92_l94P[o0000o`T92_l92A@2o`TB2P04o`T92_l9
4P[o2A8:o`0000Oo2@T:00?o2A8:o`T92_l92@X00ol92@X02_l0003o2A8:
o`T92_l94P[o0000oa4L2_l0003o2A8:o`T92_l94PX2o`T92P06o`TB2_l9
2@[o2@T:ob<_7_lS;bWo;5EL0_l92@X2o`T950;o2@T:00?o2@TDocAE?Ol9
4PX01Ol92@X2o`TB2PKo2@T:00?o2A8:o`000?l94PX00_l92@X2o`TB2P07
oa4V5?lA70[o4A`:oaXV5?lA9P[o6Q`Noa4V5003oaXV5008ob`h:OlJ9QCo
6Q`NoaXL7_lJ9QCo;1`Dob<_7_lJ9Q@3ob<_7P0:oaXL7_lJ9QCo6RHDoaXV
5?lJ4QCo8a`:oa4L2_l92@[o2A8:oa4L2PWo2@T:00?o2A8:o`T92_l94PX0
2_l92@X00olJ2@[o2@T:oaX92P03o`T92P09o`000?l94P[o2@T:oa4L2_l9
2@[o4A`:o`T92_l0003o/;>g05ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJ
f]X000;ok^k^027okNg]onGUiOnATI7oY:BTom;Bd_oDe=Co`/;2okRh^?o0
`<3olOofoo;omOoloogooogoooofoooon?ooooWooooeoOoom?Kooo[foooe
kOnNLf[oEadBog<]9On2;b_oUC/jojmEE?ndFU[o^f5QokmWI_o0JVWo`6aZ
okm^Joo0Kf`00onmK6T00onnKF[o`6aZol1/JP02ol5]J`0`ol1/J_nnKF[o
`6aZoki]J_o0K6[o_VeZol1/J_nnKF[o`Fe[okm^Joo1KF_o_fi[ol5]Jono
KV_o`Fe[oki]J_o0K6[o_fi[ol5]JonoKV_o`Fe[okm^Joo1KF_o_VeZol5]
JonoKV_o`Fe[okm^Joo1KF_o_fi[ol5]JonoKV_o_f]Yoke/JOnoJfWo_VeZ
ol1/J_nnKF[o`Fe[okm^Joo0K6[o_VeZol1/J_nnKF[o`6aZoki]J_o0K6[o
_VeZ1?nmKVX4oki]JP0Jokm[JOo0K6[o_f]YokiZJ?o1Jf[o`fe/okeWI_nh
H5ko[E9?ohdh<omg;ROoEAH?of<^:?nTM73oonk_ooo_lOofhN3oookkooSo
oOo[o_SomOoooo?inOoonooooo[oooonoooPh>0:on7Qh@?oh^;R00?oi>CT
on?ShooUiND00_oUiND:onKViPOoinOW1_oXj>P;onWYj@?oj^[Z00?ok>c/
on_[joo]kNd00_o]kNd:onk^kPOokno_1_o`l?08oo7al@?ol_;b0_oclo<3
ooGem@;omoOg0oohn?P:ooWin@?on_[j0oolo?`2ooknoRKooooo00Co6Ubc
ojC3iOnhd^ooNJk/0_n/gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP04oa4V
5?l94P[o2A8:o`T950?o2A8:00Wo2@T:oa4L2_l94P[o4A`:o`T92_l94P[o
2@T:o`TB2_lA70X00_l00002o`TB2P05o`000?l94P[o2@T:oa4L2_l94PX0
0_l00002o`T92P06o`000?l92@[o2A8:o`TB2_l92@[o00000_l94PX02_l9
2@[o2A8:o`TB2_l94P[o0000o`T92_l94P[o4A`:o`T92_l00005o`TB2P;o
2@T:00Go4A`:o`000?l0003o4A`:o`TB2P03o`T92P;o4A`:00Ko6PT:ob`B
0?l92@[o4A`:oaX92_lA70X2oaX92P08oa4L2_l92@[o2A8:o`000?l94P[o
0000o`T92_l94PX2o`000004o`TB2_l0003o2A8:o`0000;o2@T:00Oo2A`D
o`000?l94P[o0000o`T92_l94P[o000000;o2@T:00Oo2A8:o`000?l94P[o
0000o`T92_l94P[o2@TD00;o2A`D00Go2@TDo`T92_l0003o2A8:oa4L2P02
o`T92P05o`TB2_l0003o0000o`TB2_l000000_l92@X01?l94P[o2@T:o`T9
2_l94PX6o`T92P;o2A8:0_l000003_l92@[o0000o`T92_l92@[o0000o`TB
2_l0003o2@T:o`000?l92@[o2A8:o`000?l92@[o2A8:0_l92A@01?l971Co
2A8:o`TB2_l92A@3o`TB2P03o`T95?lS@Cgo2A8:00Co2@T:00Go2A8:o`T9
2_l92@[o4BH:oa4L2P04o`T92P03oa4L2_l94P[o6PT:00;o2@T:00?o2A8:
o`T92_l94PX00_l92@X2oa4L2P06o`TB2_lA9QCo6RHDoa4V5?lJ9QCo4BHN
0olJ9Q@00olS;ako8bH:oaXV5003ob<_7P03ob<_:OlA9Qko6Q`N00?o6RHD
00Go6Q8Doa4L2_lA70[o6Q8Doa4L2P02o`T92P03oa4L2_l92@[o2@T:00;o
2@T:00?o2A8:oa4L2_l92@X00_l92@X00olA70[o2@T:o`T92P05o`T92P03
o`TB2_l92@[o2@T:00;o2@T:00co4A`:o`TB2_l92@[o4A`:o`T92_lA70[o
2@T:oa4L2_l92@[o4A`:o`000?o1alaOonk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q0003ooooo`05oo[jn_oCdm?oQhN7ojb/[?nl_;`00_n^[Zh06_nf
][KojOo`oo7om_okoocooo[nooohooook?ooooWooookooooo_oooo[doook
lOoolnKooo7Vooo:`_nTCd[oQBHTog0>3omg4aGoOA/Loh8R8on59BKoQ2TX
ohH[:_n6;2_oQ2XY0on5:bX2ohL/:`;oRR`/2?n7;2/4ohP];0KoQb`[1?n8
;B`2ohL/:`SoR2d/00CoQBXYohH[:_n6:b[oQR/Z0_n7;2/2ohP];0OoQb`[
0_n6;2/00on5;B_oQR`[ohH/:`02ohH/:`;oQb`[01[oQBXYohH[:_n8:R[o
R2XZoh/];On=;booQbTYoh0R8?ml6QWoNB0LoiiEC_oof];ooo;/oooYi?oo
m?CoooKhooojn_oglo3omOoloo;oooo]o?WomoooooomooojlOKoookoom_K
f`Sog=cL1OoMgMd2omoOg`KohN7Q2_oRh^83on?Sh`;oi>CT0ooUiND:onKV
iPKoinOW0_oXj>P5onWYj@_oj^[Z0_o[jn/2onc/k004ong]kOo^k^kok^k^
onk^kP[okno_1Oo`l?03oo7al@Gol_;b2?oclo<2ooCdm0?omOGe0oofm_H2
ooOgm`?on?Sh2_oinOT3oo[jnP?oo?cl0_ono_hAooooo`04oaeO/onUa>Ko
]];^ogV^j@;oZ^3o00CoMWIfol71`Oo`l?3ooOgmFoooool01_lJ4QCo2A8:
oaXB5?lJ4QCo2@TDo`TB2P;o2@T:00Ko2A8:o`T95?l92@[o4A`:o`T95?lA
70X4o`T92P03o`000?l94P[o2@T:00Go2@T:00?o4A`:o`TB2_l94PX01?l9
2@X01ol0003o4A`:o`T92_l92@[o0000o`TB2_l92@X00_l000001Ol94P[o
6PT:o`TB2_l0003o4A`:00?o2@T:00Co0000o`T92_l92@[o4A`:0_l92@X0
0ol0003o2A8:o`TB2P04o`T92P;o6PT:00Wo2@T:ob`B0?l94P[o6PT:ob`B
0?lS9P[o4A`:o`T92_lA70X01?l92@X02Ol0003o2A8:o`T92_l94P[o0000
o`T92_l0003o2A8:o`T92P02o`00000;o`T92_l0003o2@T:o`TB2_l0003o
2@T:o`TB2_l92@[o0000o`T92_l000000_l92@X01_l94P[o6Q8DodmNI_l9
71ko2@TDo`TB2P;o2@T:00?o2A8:o`T92_l92@X01_l92@X00ol94P[o2@T:
oa4V5003o`T92P04o`000?l94P[o2@T:o`TB2PGo2@T:00Co2A8:o`T92_lA
70[o00000ol92@X01Ol94P[o0000o`TB2_l92@[o000000;o2@T:00?o0000
o`TB2_l92@X00_l92@X01Ol92ACo2@T:o`T92_l92ACo2@T:00;o2@TD00oo
2A8:o`T95?l92ACo2@T:o`000?l94P[o4BHDoa4L2_l92@[o4A`:oa4V7_l9
2@[o4A`:o`T92_lA70X00_l92@X02OlA70[o2@T:oa4L2_lJ2@[o2@T:oa4L
2_l0003o2@T:oaX92P02oa4L2P06oaXB5?lA70[o6PT:o`T95?lA70[o6Q8D
0_lJ9Q@00olJ4QCo6RHDob<_7P02ob<_7P0:ob`V5?lS;ako8blNoaXL7_l/
71Co6Q`Noa4V2_lS9P[o6RHDoa4V50;o4A`:00?o2@TDo`T92_l92@X03?l9
2@X01?lA70[o2@T:o`T92_lA70X6o`T92P03o`TB2_l92@[o2@T:00?o2@T:
00Co4A`:o`T92_l0003oYZZ]Goooool01?n_[joobl_;omkNg_oZj^X1oo;b
lP000oo^k^h02oo/k>cohn?Soj^[ZomeMGGoP820ohn?SonLW9coYJFUojb/
[?na/K7o]kNg00ko^k^k0onl_;`3okfm_@03okjn__nm_Kgo_[jn00;o_[jn
0_no_kl;ol30`0;o`L710_o2`/801?o3`l?oa<C4olC4a?o4a<@:olG5a@Go
a/K60_o7alL00oo6a/KoalO7olO7a`03olO7a`gob<S800?obLW9ol[:b_o:
b/X03oo;bl/3olc<c003olg=cOo<c<coc<c<00;ocLg=2oo>c/h2olo?c`?o
d=3@00?odM7Aom;Bd_oCdm<00_oCdm<3omCDe0OoeMGE1_oFe]H2omOGe`Go
f=SH2ooIfMT3om[JfP;ofm_K0ooLg=`:omgMg@Gog]kN0_oOgml00ooNg]ko
gmoOomoOg`03omoOg`Soh>3P0ooQhN42on;RhP;oi>CT00?oiNGUonOWiooW
inL00ooXj>P:onWYj@?oj^[Z0oo/k>`2onk^kP_okno_0_o`l?03oo7al@03
oo;bl_oalO7olO7a00;ol_;b0ooclo<>ooCdm004oaYM/_nVa^Ko^M?^ogV^
j`;oZmoo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01_lJ4QCo2A`Doa4V5?l9
2@[o6Q8Do`TB2P;o4A`:00So2@TDoa4L2_l92ACo4A`:o`T92_l94P[o2@T:
o`TB2P_o2@T:00Co0000o`TB2_l0003o2A8:0ol92@X00ol0003o2A8:o`T9
2P03o`T92P03o`000?l94P[o2@T:00;o2@T:00So4A`:o`T92_lA70[o4A`:
o`000?l92@[o2A8:oa4L2P;o2@T:00?o4A`:o`T92_l92@X01Ol92@X02?lA
70[o;180oa4L2_lS70[o2A8:oa4L2_lJ2@[o4A`:0ol92@X01Ol0003o2A8:
o`000?l94P[o2@T:00?o00000_l92@X00ol0003o2@T:o`000002o`TB2P05
o`000?l92@[o0000o`000?l92@X00ol000001Ol92@[o2A8:o`000?l92@[o
000000;o6Q8D00?oCfMLo`T95?l94PX00_l94PX00ol0003o2@T:o`T92P03
o`T92P;o2A8:0_l92@X00ol0003o2@T:oc@_7P02o`T92P0;o`TB2_l92@[o
2@T:o`TB2_l0003o2A8:o`T92_l0003o2@TDo`TB2_l92@X00_l00002o`T9
2P04oa4L2_l0003o2@T:o`T92P;o000000?o2A8:o`000?l92@X01Ol92@X0
1?l94P[o2@T:o`TB2_l92A@2o`TB2P04o`T92_l92ACo6Q8Doa4V50;o2@T:
00Go2A8:ob<_7_l92@[o2A8:oa4L2P02o`TB2P07o`T92_l94P[o4BH:oa4L
2_l92@[o2A8:oa4L2P03o`T92P06oa4L2_l92@[o4A`:o`000?l92@[o2A8:
0ol92@X03?lA70[o2@T:o`TB2_lA70[o2@T:o`TB2_l92ACo6RHDoaXB5?lS
;bWo6RHDob<_:@;o4BH:0_lS;ah01OlJ4QCo6RHDoaXL7_lJ4QCo8a`:00;o
4A`:00?o0000o`T92_l92@X06?l92@X01olA70[o2A8:oa4L2_l92@[o4A`:
o`000?n=SFl0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@001?oVi^H0
2_oShn?ofMWIok:b/_mnOWkoKfm_ogQhN?n;Rh_oTY:BoiVIVOnQXJ4>ojJV
YPKoYjNW00?oZ:RXojVYZOnZZZX01?nZZZX8oj^[Z`?o[:b/0_n][Jd2ojj^
[P04ojf][On^[Zko[Zj^ojj^[P;o[jn_3On`/;02ok6a/@03ok:b/_nc/k?o
/k>c00_o/k>c0_nd];@3okFe]@03okJf]_ne]KGo]KFe00;o][Jf0ong]kL:
okRh^0?o^KVi00?o^[Zjok^k^onk^k/00_nl_;`;okfm_@Go_[jn00?o`<30
okno_oo1`L401Oo1`L4:ol;2`PCo`l?31?o4a<@:olG5a@Koa/K600?oalO7
olK6a_o7alL01?o7alL8olS8b0?obLW90_o:b/X3olc<c0?oc/k>0_o?cll;
om3@d0;odM7A0ooBd]82om?Cd`_oe=CD1OoEeMD3omOGe`GofMWI2?oJf]X2
om_Kf`?og=cL0ooMgMd2omkNgP?ogmoO3_oPh>001?lLG[3oXl;TokSCkomg
[^/2oj[Oo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00Go4BHDoaXL7_lJ4QCo
4A`:o`T95003o`T92P04oaXB5?l94P[o2@T:o`TB2P;o2@T:00?o4A`:o`TB
2_l94PX00ol94PX2o`T92P03oa4L2_l92@[o2A8:00Co2@T:00Co2A8:o`00
0?l92@[o2A8:0ol92@X01?l94P[o2@T:o`T92_l94PX4o`T92P05oa4L2_l9
2@[o2A8:o`T92_lJ2@X00ol92@X01?l92ACo2@T:o`T92_l92@X2o`TB2P?o
2@T:00?o2A8:o`T92_lJ2@X00ol92@X00olJ2@[o2@T:o`T92P02o`TB2P;o
2@T:00?o0000o`T92_l94PX00_l000000ol92@[o2A8:o`000002o`T92P04
o`TB2_l0003o2@T:o`0000Ko2@T:00Oo0000o`TB2_l92@[o2A8:o`000?l9
2@[o000000;o2A8:00Go6PT:oc@_<ol92@[o2A8:o`000002o`TB2P?o2@T:
00Go2A8:o`T92_l94P[o2@TDoa4L2P02o`T92P04o`TB2_lJ71ko2A8:o`00
00Go2@T:00Oo6Q8Do`TB2_l94P[o0000o`T92_l94P[o2@T:00;o2A8:00Co
2@T:o`000?l94P[o00000_l92@X01OlJ4QCo0000o`T92_l92@[o2A8:00;o
2@T:00Go2A8:o`T95?l94P[o2@TDo`TB2P04o`T92P0;oaXL7_lJ4QCo6Q8D
o`TB2_l92@[o4BHDob<_7_lA9QCo6PT:o`000?lA70X00ol92@X01OlJ2@[o
2A8:o`TB2_l92@[o6PT:00;o4A`:00Go6PT:oa4L2_l92@[o4A`:o`TB2P04
o`T92P03oa4L2_l92@[o2@T:00Go2@T:00Ko2A8:oa4L2_lJ9QCo6RHDob<V
2_lJ2@X2ob<_7P?o6RHD0_lS9PX00olA70[o8a`:oa4L2P02o`T92P03o`00
0?lA70[o000000Ko2@T:00?o2A8:o`T92_l92@X02ol92@X00ol/4P3o2@T:
o`T92P03o`T92P03oa4L2_l0003oUJ6>05ooi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X000Cok^k^00Sok>c/onSXj?oIfMWo`/;2ojFUYOn=SHgoOWin
ogIfM_ooLW9b3OmbLW802Om/K6coJ6QXof=SHomJFU[oCTi>o`eAY_nUa>Ko
^M?_ogN^j`02ojWLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00?o6Q8Do`T9
5?l92@X00_lJ4Q@02OlA70[o2@T:oa4L2_l92@[o4A`:oaXB5?l92@[o4A`:
o`TB2P07o`T92P03o`000?lA70[o000000;o2@T:00Co0000o`T92_l92@[o
2@T:0_l94PX02Ol92@[o0000o`T92_l94P[o2@T:o`TB2_lJ4QCo2@T:o`TB
2P02o`T92P03o`T95?lA70[o2@TD00;o4A`:00Go6PT:o`T92_lA70[o0000
oa4L2P02o`T92P06o`TB2_l92@[o2@T:oa4L2_l92@[o00000_l92@X2oa4L
2P03o`T92_lA70[o2A8:00;o2A8:00?o0000o`T92_l94PX00_l92@X2o`00
0003o`TB2_l92@[o000000;o2@T:01Co0000o`T92_l0003o2@T:o`TB2_l9
2ACo0000o`T92_l94P[o0000o`TB2_l0003o2@T:o`000?l92@[o2@TDo`00
0?l92@[o2A8:o`0000;o6Q8D00?o2@T:oc@_<ol000000_l92A@3o`T92P07
oaXB5?lA9QCo2@T:ob=1?OlS;ako6Q8Do`TB2P03o`T92P03o`000?l92@[o
2@T:00;o2A8:0_l92@X01?l92ACo0000o`TB2_l00002o`T92P0=o`TB2_l0
003o2@T:o`T92_l94P[o0000o`T95?l92@[o2A8:o`000?l94P[o2@TDoa4L
2P04o`T92P;o2@TD00So6Q8Do`T92_l94P[o2A8:o`T95?l94P[o4BHNoa4V
50;o6Q8D00Co2A8:oaXV5?l/9QCo4A`:0_l94PX2o`T92P03o`TB2_l92@[o
4A`:00;o2@T:0_lA70X00ol92@[o4A`:oa4L2P02oa4L2P08o`T92_lA70[o
6Q8Do`T92_l94P[o2@T:oa4L2_l92@X2o`TB2PGo2@T:00?o2A8:o`T92_lA
70X00_lA70X03?lJ9QCo8blNoaXV5?lJ4QCo4BH:ob<_7_lJ4QCo6Q`NoaXV
5?lJ2@[o0000oa4L2P?o2@T:00Co2A8:o`T92_l92@[o6PT:0_l92@X00olA
70[o2@T:o`T92P02o`T92P04oa4L2_l92@[o2@T:oa4L2POo2@T:00?o2@TD
o`T92_lA70X00_l92A@00ol0003oYYR4onk^kP1Nonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q0004ooooo`0:ooclo?oalO7oaLG5ohR8R?m_KfooMGEe
oh:2P_n7QhOoSHf=oiFEU@koVYZJ1_nKVi/2oibLW0GoWIfM2onNWYh2oinO
W`;oX:2P00CoWinOoj2PX?nPX:3oX:2P3OnQXJ42oj:RXP;oXj>S00?oY:BT
ojFUYOnUYJD00onVYZH8ojNWY`GoZ:RX00?oZJVYojRXZ?nXZ:P01OnYZJT:
ojZZZP?oZj^[00?o[:b/ojf][On][Jd00_n][Jd;ojj^[PGo[jn_0_n`/;06
ok6a/@[o/[:b0onc/k<00one]KGo];BdokJf]P02okJf]P[o]kNg3Onh^;P8
okVi^@Go^[Zj0onl_;`3okjn_P;o_kno2oo0`<02ol71`@?o`/;20_o3`l<;
olC4a0GoaLG500?oa/K6olO7aoo7alL01Oo9bLT8ol[:bP;obl_;0oo<c<`0
0oo=cLgoc<c<olc<c002olg=c@?oc/k>3_o?cll01?lHG;;oY<CVokWCkomf
[NX2oj_Po`04ogIfM_o1`L7ol?3`oogmoE_ooooo00Co2A`DoaXB5?l92@[o
4BHD0ol94PX2o`T92P05o`TB2_l92@[o4A`:o`T95?l94PX00ol92@X2o`TB
2P;o2@T:00[o6Q8Do`T92_l0003o0000o`TB2_l92@[o0000o`T92_l94P[o
2@T:0_l94PX2o`T92P0=o`000?l94P[o2@T:o`T92_l0003o2A8:o`000?l9
2@[o4A`:o`T92_lA70[o2@TDoaXB5002oa4L2P04oaX92_lA70[o2@T:o`T9
2P;o000000Go2A8:o`T92_l92@[o2A8:o`T92P02o`000007o`TB2_l92@[o
2A8:o`000?l92@[o0000o`TB2P02o`T92P03o`000?l94P[o2@T:00;o2@T:
00Oo0000o`TB2_l0003o2A8:o`000?l94P[o000000;o2@T:0ol000004olA
70[o6PT:o`T92_l0003o2@T:o`TB2_l0003o2@T:o`000?l94P[o2@T:o`00
0?l94P[o2@T:o`T95?lA70[o8d4mo`TB2_l92A@01?l92@X01_l94P[o0000
oaXB5?m6GTOo6Q`Nob`V50;o2A8:00Go0000o`T95?l94P[o2@T:o`TB2P02
o`0000;o2A8:00Ko2@T:o`TB2_l92@[o0000o`TB2_lA70X2o`T92P06o`00
0?l94P[o2@T:o`T92_l0003o2A8:0ol92@X01_l0003o2A8:o`T95?l94P[o
2@T:o`TB2P;o2@TD00Co2A8:o`T95?l92@[o2@T:0_l92A@2oaXB5009o`T9
5?l94P[o2A8:oaXV5?lA9P[o4A`:o`TB2_l0003o2A8:00;o2@T:00Oo0000
o`TB2_l94P[o2@T:oa4L2_lJ2@[o4BH:00;o4A`:00ko4BH:ob`B0?lA70[o
2@T:oaX92_lA70[o2@T:oa4L2_l92@[o4A`:o`T92_l94P[o2@T:oa4L2P;o
2@T:017o2A8:o`T92_lA70[o4A`:oaX92_l94P[o6Q8DoaX92_lA9QCo4A`:
ob`V5?lJ9QCo6Q8DoaXV5?lA9P[o2@TDoa4L2P04o`T92P04o`TB2_l92@[o
2@T:o`TB2PWo2@T:00Go6PT:o`T92_l92@[o2@T:oa4L2P05o`T92P06oa4L
2_l92@[o2A8:oa4L2_l0003oYXB4Goooool01?n_[joobl_;omkNg_oZj^X1
oo;blP000oo^k^h03?o/k>cohn?Soj^[ZomcLg?oOWinohb<S?nJVY[oXj>S
ojZZZ_nb/[;o][JfokRh^0;ooOgk1_omoOd2ooglo@06oocknOojnOGomo?`
onk]j?oXiN3ohn3K4?oHeM0_omKEd@03omKEd?oHeM3of=G@00gof=G@00So
fMC>omSDbOoUgm?oj>CIonkZhOojmO7oo?Seoogin0GooOcm1?oloOd00oom
oOgoc/k>olk>cP05olk>cP?oclo?00?od=3@om7AdOoBd]800_oBd]8:om?C
d`Koe=CD0_oEeMD5omKFePkoemOG0_oHf=P=omWIf@?of][J0_oKfm/3omcL
g0?ogMgM0_oNg]h;omoOg`;oh>3P0ooRh^82onCTi0_oiNGU0_oWinL3onSX
j003on[Zj_oYjNWojNWY00;ojn_[0oo/k>`8onk^kP;okno_0oo`l?03oo;b
lP;om?Cd0ooemOD>ooKfmP04oaYM/_nUa>Ko]M3^ogV^k0;oYmco00CoKVi^
okBd]?oPh>3ok>c/Foo^k^h00olA9QCo2A8:oa4V5002o`T95005o`TB2_l9
2ACo4A`:oa4L2_l92A@00ol92@X3o`TB2P;o2@T:00Co2A8:o`T92_l94P[o
00001?l92@X01ol0003o2A8:o`T92_l92@[o0000o`TB2_l000001?l92@X0
0olA9P[o2A8:o`TB2P03o`T92P;o2A8:00Go4A`:oaXB5?lA70[o4A`:o`TB
2P02oa4L2P08o`000?l94P[o2@T:o`T92_l0003o4A`:o`000?lA70X5o`T9
2P07o`TB2_l0003o2A8:o`T92_l0003o2@T:o`000004o`T92P03o`000?l9
2@[o000000?o2@T:00Co2A8:o`000?l0003o00000_l94PX3o`T92P0>o`00
0?l92@[o2A8:o`TB2_l0003o2@T:o`000?l92@[o0000o`TB2_l0003o2@T:
o`TB2_l92@X3o`T9500>o`TB2_l92@[o2@T:o`TB2_l0003o2@TDoa4V7_m6
EE;o6Q`NoaXV5?l92@[o0000o`T92_l00002o`T92P0<o`000?l94P[o2@T:
o`000?l92@[o4A`:o`000?l94P[o2@T:o`TB2_l92@[o00000_l94PX9o`T9
2P07o`000?l92@[o0000o`TB2_l92ACo2A8:o`T95002o`TB2P;o2@T:0_l9
2A@2oa4L2P05o`T92_l94P[o2A8:oa4V5?lS;ah00_l000000ol94P[o2@T:
o`000003o`T92P0<oa4L2_lJ2@[o4A`:oaXB5?lA70[o6Q8Doa4L2_lJ2@[o
4A`:oa4V2_lA70[o4BHD0olA70X01ol92@[o4A`:oa4L2_lJ4QCo4A`:o`T9
2_lA70X00_l92@X01OlA70[o6PT:o`TL5?lA70[o8a`:00;o4A`:0_lJ2@X0
1_lA70[o6Q8DoaXV5?lJ4QCo6RHDoa4L2QCo2@T:00?o6PT:o`T92_l92@X0
1_l92@X01OlA70[o6PT:o`TB2_l0003oUJ6>05ook^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN4000?oi^KV00cohN7Qokjn__mgMgOoX:2Pokfm_On`/;3o
[Zj^okFe]Onl_;co_[jnolG5aOo8b<P4ooooo`0=ooonoooooogoookooooo
oOooo_gooOWfooCak?oZin3ohmkHomcId_oGd/cod/k5olS1^@0>olW0]`03
olS1]oo6`[Woa/:i02koa/:i00?ob<6iolW0]oo9`;L03?o9`;L02Oo9`KKo
b/>comC=^ooIdLCogMG:onKOeoo]iN;om>k^ooomoP04ooono`;oo_oo00?o
o?ooookoooooool01OoMgMd5omkNgP;ogmoO1_oPh>0:on7Qh@?oh^;R0_oS
hn<3onCTi0[oiNGU1_oVi^H2onSXj0Goj^[Z2oo[jn/2onc/k0;okNg]00Co
k>c/ong]kOo]kNgokNg]2_o^k^h5ono_k`?ol?3`1OoalO48oo;blP;olo?c
0oodm?@00ooemOGom_KfooKfmP02ooOgm`?on?Sh2_oinOT3oo[jnP?oo?cl
0_ono_hAooooo`04oa]O]_nTa>Ko^=;^ogJ]jP;o[=oo00CoJVYZojj^[_oH
f=Soi>CTFooVi^H00olA9Qko2@T:o`T95002oaXB5005o`TB2_l92ACo6Q8D
o`T95?lJ4Q@00_l92@X00ol94P[o2@T:o`T92P02o`TB2P06o`T92_l94P[o
2@T:oa4L2_l92@[o2A8:1Ol92@X03?l94P[o2@T:o`T92_l0003o4A`:o`T9
2_l94P[o2@T:o`000?l92@[o2A8:o`0000?o2@T:1Ol94PX01_l/4P3o4A`:
oaX92_l94P[o4A`:oaX92P;o2@T:00Go0000o`T92_l92@[o0000o`TB2P03
o`T92P09o`TB2_l0003o2@T:o`T92_lA70[o0000o`TB2_l0003o2A8:00;o
000000_o2A8:o`000?l94P[o0000o`TB2_l0003o2A8:o`000?l92@[o0000
o`T92P02o`0000?o2@T:00Co2A8:o`000?l92@[o00000_l92@X01?l94P[o
0000o`T92_l00002o`T92P0?o`000?l92@[o2A8:o`T95?l94P[o2@T:o`TB
2_l0003o2@T:o`TB2_l0003o4BHDob<_:OlS;c?o000000;o2@T:00?o0000
o`TB2_l92@X01Ol92@X01_l971Co0000o`T92_l0003o2A8:o`0000;o2@T:
0_l000001?l94P[o0000o`T92_l94PX2o`T92P05o`TB2_l92@[o2A8:o`T9
2_l94PX00_l92@X01OlA9Qko2@TDo`T95?l94P[o2@TD00;o2A8:00?o6Q8D
o`T95?l92@X00_l92@X01?l94P[o2@T:oa4V5?lJ2@X4o`T92P0Io`TB2_l9
2@[o6PT:o`T92_l94P[o4A`:oa4V5?lA9P[o8blNoaXV5?l/71Co4BH:oaXB
5?lA70[o6Q8DoaXV5?lJ2@[o4A`:oaX92_lA9QCo4A`:oaX92_lA70[o4BH:
oaX92P03oa4L2P03o`T92_lJ9QCo8blN00;o6RHD00Go;1`Dob<L2_lA70[o
4A`:o`TB2P02oa4L2P;o6RHD00Co2A8:o`T92_l92@[o2A8:0_l92@X01ol9
4P[o8a`:o`T95?lJ4QCo2A8:o`T92_lJ2@X01_l92@X01?l92ACo2@T:o`TB
2_lA70X4o`T92P08o`TB2_l92@[o4A`:o`T92_lJ4QCo6PT:o`000?nVXIQO
onKViP04oifMWOng]kOob<S8om?Cd`7of][J0002onk^kP0=ong]kOoUiNGo
TI6Aoi6ATOo<c<coeMGEol;2`_ni^KWo`<30olC4a?o9bLWob/[:om3@d004
ooooo`;oooom00_ooookooonnooim_7olNcVonCMeOoBbl7oa[neoknh[_nj
/jWo]jnTok2TV00>ok6SV0;o/:BH02oo[ZBHojjTV_n^Y9So[ZBJojjTV?n^
Y9[o[ZBHojjTV_n^Y9So[ZBJojjTV?n^Y9[o[ZBHojjTV_n^Y9So[ZBJojjT
V?n^Y9[o[ZBHojjTV_n^Y9So[ZBJojjTV?n^Y9[o[ZBHojjTV_n^Y9So[ZBJ
ojjTV?n^Y9[o[ZBHojjTV_n^Y9So[ZBJojjTV?n^Y9[o[ZBHojjTV_n^Y9So
[ZBJojjTV?n^Y9[o[ZBHojjTV_n^Y9So[ZBJojjTV00?ok6SV009ok6TU?nc
YY?o_;6KokndX_o1]JOob/2fom?:aOoQfMOol^c/00?oooko00?oooooooko
ooonool00_olood00ooooooohN7Qon7Qh@05on7Qh@?oh^;R00?oi>CTon?S
hooUiND00_oUiND:onKViPKoinOW00?oj>SXonWYjOoZj^X01?oZj^X;on_[
j`?ok>c/0_o]kNd3onk^kP[okno_0oo`l?02oo7al@;ol_;b00ColO7aoo;b
l_obl_;ol_;b0_oclo<8ooCdm0GomOGe0oofm_H5ooOgm`[on?Sh0ooinOT0
0ookno_oo?clooclo002ooknoRKooooo00Co7EncojK6i_nfd>koNJo^0_n[
g_l01?m^KVko];Bdon3Ph?o/k>aKonk^kP0EoaXB5?lA70[o2A8:o`TB2_lJ
4QCo2@T:oa4L2_l92@[o2A8:oaXB5?l94P[o2@T:o`TB2_lJ4QCo2A8:o`00
0?l94P[o0000o`T92_l94P[o000000?o2@T:00Oo2A8:o`T92_l92@[o0000
o`TB2_l92@[o2A8:00;o2@T:00?o0000o`T92_l94PX00ol92@X01Ol94P[o
2@T:o`TB2_l94P[o000000?o2@T:00Go4A`:o`T92_lA70[o2@T:ob`B0002
o`T92P03oa4L2_l92@[o2@T:00;o2@T:00Co0000o`T92_l94P[o2A8:0_l9
2@X2o`00000>o`T92_l94P[o0000o`T92_l0003o2@T:o`TB2_l92ACo0000
o`T92_l0003o2@T:o`000?l92@X2o`000006o`T95?l92@[o0000o`T92_l0
003o2@T:0_l000001_l94P[o0000o`TB2_l0003o2A8:o`0000Co2@T:00Go
0000o`T92_l0003o2A8:o`000002o`T92P04o`TB2_l92@[o2@TDo`0000?o
2@T:0_l94PX01?l0003o2@T:o`T92_l00006o`T92P03o`TB2_l92ACo2@T:
00;o2@T:00Go0000o`T92_l0003o2@T:o`TB2P03o`T92P04o`000?l92@[o
2@T:o`TB2P;o00001Ol92@X01OlJ4QCo2@TDo`T95?l94P[o2@TD00;o2@T:
00?o4A`:o`TB2_l94PX00_l000001?l92@[o2A8:oa4L2_l94PX2o`T92P03
o`TB2_l0003o2@T:00?o2@T:00Ko4A`:ob<L2_l/9QCo8blNoaXV5?lS9PX2
ob<_7P;o6RHD00?o8bH:oaXB5?lA70X00_lA70X01Ol/71Co8bH:oa4L2_lJ
4QCo4BH:00;o4A`:00[o6PT:oa4L2_lA9P[o;2HDob<_:Ol/4P3o8bH:oaXV
5?lA70[o8a`:0_lJ2@X2oa4L2P03oaXV5?lA9P[o000000Co2@T:00?o2A8:
oaXB5?l92@X00_l92@X00olJ4QCo2@T:o`T92P05o`T92P03o`TB2_l92@[o
2@T:00Co2@T:0_lA70X2o`T92P06oa4L2_l92@[o6PT:oa4L2_l92@[oUHB>
Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool08oono_kolO7a
oginO_nl_;cof=SHom_Kfoo>c/ko`<30olG5aOo:b/[oc<c<olo?cooCdm?o
ookoooooooono_kooOgmoooooOoooo_oooghoo_fl?objn?ofmC:olNo]?no
]JWo]ZbPojVMSonPU8KoX9>3oin<O_nPRWcoWHMioiZ4M_nHPWCoUh5c00;o
UX1b1onIPgD2oiN4M@0_oiJ5MOnFQ7KoUXEeoiJ4M_nFQGGoUXAfoiJ5MOnF
Q7KoUXEeoiJ4M_nFQGGoUXAfoiJ5MOnFQ7KoUXEeoiJ4M_nFQGGoUXAfoiJ5
MOnFQ7KoUXEeoiJ4M_nFQGGoUXAfoiJ5MOnFQ7KoUXEeoiJ4M_nFQGGoUXAf
oiJ5MOnFQ7KoUXEeoiJ4M_nFQGGoUXAfoiJ5MOnFQ7KoUXEeoiJ4M_nFQGGo
UXAfoiJ5MOnFQ7KoUXEeoiJ4M_nFQGD02?nIPgD2oiR2M0;oVH=e0_nJQ7H0
4?nKQGOoVhIeoj6?NOnMSGCoXi9nojnPSOnhZi_o_k:Yolo4__oPe]CoknOU
ooWcloooo_ooo_knoo_mo?omooh2oocoo@03oooooooUiNGoiNGU00?oiNGU
1OoVi^H2onOWi`Koj>SX2_oYjNT3on[ZjP;ojn_[0oo/k>`:ong]k@?ok^k^
0oo_knl00ooalO7ol?3`oo;blP02oo;blP;olo?c2?odm?@5ooGem@?om_Kf
1OogmoL=ooShn0?onOWi3oojn_X3oo_kn`03ooclo?omoOgooOgm00;oo_kn
9_ooool01?lJG;?oY<?UokSBkomi[^`2ojcOo`04ogIfM_o1`L7ol?3`oogm
oE_ooooo00Go4A`:o`T95?l94P[o2A8:o`T92P04o`TB2P09o`T92_l94P[o
4A`:o`T92_lA70[o2@T:o`TB2_l92@[o2A8:00;o2@T:00Go2A8:o`T92_l9
2@[o2@T:o`000002o`TB2P?o2@T:00Oo0000o`TB2_l0003o2A8:o`000?l9
2@[o000000;o2A8:0ol92@X2o`TB2P04o`T92_l94P[o2@T:o`T92P;o4A`:
00Oo;180oa4L2_lA70[o4A`:oaX92_l92@[o4A`:00Co2@T:00Co0000o`TB
2_l92@[o2A8:0_l92@X2o`000003o`T92_l0003o000000;o000001co2A8:
o`T92_l0003o2A8:o`000?l94P[o0000o`TB2_l92@[o0000o`T92_l0003o
2A8:o`T92_l0003o2@T:o`TB2_l0003o2@T:o`000?l92@[o0000o`T92_l0
003o2A8:o`000?l92@[o00000_l92@X01ol0003o2@T:o`T95?l92@[o2A8:
o`T92_l000000_l92@X00ol94P[o2@TDo`TB2P02o`T92P07o`TB2_l92@[o
2@T:o`TB2_l92ACo4A`:o`T92P04o`T95005o`T92_l0003o2A8:o`000?l9
4PX00ol92@X00ol0003o2@T:o`000002o`TB2P;o2@T:00Co2A8:o`T92_l9
2@[o2@T:0_l94PX01?l92ACo2A`No`T95?l94PX2o`T950;o2A8:00?o2A`D
o`T92_l92@X00ol92@X00olA9QCo2@T:o`T92P07o`T92P05oa4L2_lJ9QCo
8blNob`h:OlJ9Q@00_lS;ah02olJ9QCo8bH:ob<_7_lS9P[o8blNob<V2_lJ
4QCo8bH:oaXV5?lS;ako4BH:00;o6RHD0_lJ4Q@02OlA9P[o4A`:oaXB5?lS
;ako=5DYo`T95?lA70[o;4`YoaXV5002oa4L2P06oaXV5?lA9P[o4BHDoaXV
5?ld;bWo4A`:1Ol92@X01?lJ2@[o6Q8Do`T92_lA70X9o`T92P03oaX92_l9
2@[o4A`:00?o2@T:00_o0000o`T92_l92@[o0000o`T92_l92ACo2@T:oa4L
2_l92@[o0000ojJHQ01Oooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0002
onk^kP04onc/k?oOgmooLG5aom7Ad@;og=cL00Ood=3@olC4a?o9bLWoc<c<
olo?cooBd];oeMGE00;oooko01koo_kooogmoOoooo_oooojoo_fl?ock>;o
dLVnom37^?o3]jOo[9n>oij>O_nFQG?oRGQVog]YEOn=Lf;oSW=RohmbH_n=
LV7oSW5QohicH_n?LV;oSgASohiaHOn=LV7oSW5QohebHOn>LF7oSG9Qohia
HOn=LV42ohabH@0^ohabHon<LV7oS79SohabHOn<LV?oS79QohabHon<LV7o
S79SohabHOn<LV?oS79QohabHon<LV7oS79SohabHOn<LV?oS79QohabHon<
LV7oS79SohabHOn<LV?oS79QohabHon<LV7oS79SohabHOn<LV?oS79Qohab
Hon<LV7oS79SohabHOn<LV?oS79QohabHon<LV7oS79SohabHOn<LV?oS79Q
ohabHon<LV7oS79SohabH@;oSG9Q01_oSW5QohebHOn>LF7oSG9QohiaHOn=
LV7oT7=SohmdHon@Lf?oT7EToi5dI?n@MFCoTGAToi1eH_nFOVKoS7MLohaf
G_nHPfkoY99nojjNS_nk[J;oa[bcom_Bboo]iN;ooOWfoooooOooool00_on
ool00oolo_goooooonKViP04onKViPgoinOW1ooXj>P3onWYj@?oj^[Z0_o/
k>`3onk^kP;okno_3_o`l?000ooalO7ol_;boo?cl`0?oo?cl`;om?Cd0ooe
mOD3ooKfmP[omoOg0oohn?P2ooWin@?on_[j0_okno/3ooclo0gooOgm0oon
o_hXooooo`04oaeO/onUa>Ko]];^ogV^j@;oZ^3o00CoKVi^okBd]?oPh>3o
k>c/Foo^k^h01?l92ACo2@T:oaXB5?l92@X2o`TB2P03o`T92_l94P[o2A8:
00Co2A8:0_l92@X01ol94P[o2@TDoaX92_l94P[o4A`:o`T92_l94PX00ol9
2@X00olA70[o0000o`TB2P06o`T92P03o`TB2_l92@[o2@T:00;o2@T:00So
0000oa4L2_l92@[o2A8:o`000?l94P[o2@T:o`TB2P;o2@T:00Go6PT:oa4L
2_lJ2@[o4BH:ob`B0003oa4L2PGo2@T:00So0000o`TB2_l94P[o2A8:o`00
0?l94P[o2@T:o`TB2P;o2@T:00?o0000o`TB2_l92@X00_l92@X01?l0003o
2@T:o`000?l92@X2o`0000;o2A8:00ko2@T:o`000?l92@[o0000oa4L2_l0
003o2@T:o`TB2_l0003o2A8:o`000?l94P[o2@T:o`0000;o2@T:00So2A8:
o`T92_l94P[o2@T:o`TB2_l0003o2@T:o`TB2PCo2@T:00Oo2A8:o`T92_l9
4P[o2A8:o`T92_l0003o2A8:00;o2@T:0_l92A@02?lA70[o2@TDoa4V5?l9
2ACo4Blmo`000?l92@[o00001?l92@X00ol94P[o2@T:o`T92P03o`T92P05
oaX92_l94P[o2@T:o`000?l94PX00_l92@X01_l92ACo6Q8Do`TL5?l92ACo
6Q8Do`TL50Go2@TD00Go2A8:o`T92_l92@[o2@T:oa4V5004o`T92P03o`TB
2_l92@[o2@T:00;o4A`:00Go6Q8DoaXV5?l/>2Wo;3PYob<_:@06ob<_7P03
ob<V2_lJ71ko8blN00?o8blN00?o8blYob<V2_lS;ah00_lJ9Q@02olA70[o
6RHDob`h:Om6C3go0000o`TB2_l92ACo=2lNob<_7_lJ2@[o8blY00?o8blN
00Go;4`YoaXB5?l94P[o2@T:oa4L2P02o`T92P03oaX92_lJ4QCo2@T:00Go
2@T:00Ko2A8:o`T92_l92@[o6PT:o`T92_lA70X5o`T92P08oa4L2_l92@[o
2@T:o`T92_lA70[o6PT:oa4L2_l92@X2oaXB5003o`000?nVV6ook^k^05ko
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV02coi>CTomGEeOma
LG7oemOGomkNg_oOgmooe=CDolC4a?o7alOoc<c<om3@d?oBd];oe]KFookn
ooonooooo_koookno_oooo_oo__doo7Zh?oRf/gocL6aol6dXonYVXGoUhM`
oj6=MOnnZ93oe;jVomg3[?oce<3om=?2ooSDa?oge/GonmO7ooWHaoolf<So
n]W8ooWEaOoge/GonMG5ooOFaOoieLGommK5ooWEa@?ommK502gommK7ooOF
aOoge/OommK5ooOFaooge/GommK7ooOFaOoge/OommK5ooOFaooge/GommK7
ooOFaOoge/OommK5ooOFaooge/GommK7ooOFaOoge/OommK5ooOFaooge/Go
mmK7ooOFaOoge/OommK5ooOFaooge/GommK7ooOFaOoge/OommK5ooOFaoog
e/GommK7ooOFaOoge/OommK5ooOFaooge/GommK7ooOFaOoge/L00ooge/D0
7ooieLGommK5ooWEaOoge/GonMG5ooOFaOoje/Kon=O6ooWEaOoge/GonMG5
ooOFaOoieLGom]K1onW;/OoL`JCoc;:GokNOQOnRS7CoW8Mboj^JR?no/Z;o
bKfaomcCb_ocknKoookioooooOooooooo_oooo_mo?ooool01OoWinL2onSX
j0?ojNWY00?oj^[ZonWYjOoZj^X00_oZj^X3on_[j`gok>c/00?okNg]onk^
k_o_knl03?o_knl3oo3`l0?olO7a00?olo?coo;bl_odm?@00_odm?@2ooGe
m@Som_Kf1oogmoL6ooShn0_onOWi0_ojn_X2ooclo003oo_knoomoOgooOgm
017oo_kn:_ooool01?lKG[?oY/KVokWCk_mi[^/2oj_Oo`04ofYZJ_n^[Zko
f=SHonCTi5_oi^KV00Co4BHDoa4L2_l94P[o6Q8D0_l92@X02?lA70[o2@T:
oaXB5?lJ4QCo2@T:o`TB2_l92@[o4A`:0_l92@X00ol94P[o2@T:o`T92P06
o`T92P05o`000?l92@[o4A`:o`T92_l94PX00_l92@X01ol94P[o2@T:o`TB
2_l92@[o2A8:ob`L5?lA9Q@00_l94PX3o`T92P;o2A8:0_l92@X01OlA70[o
2@T:oa4L2_lA70[o2@T:00;o4A`:00Wo2A8:o`T92_lA70[o2@T:oa4L2_l9
2@[o2A8:o`000?l92@X00_l94PX01?lJ2@[o2A8:o`TB2_l00002o`T92P04
o`TB2_l0003o2@T:o`T92P;o2A8:00Oo0000o`TB2_l0003o4A`:o`T92_l9
4P[o000000;o2@T:00Ko0000o`TB2_l0003o2@T:o`TB2_l00003o`T92P0:
o`000?l92@[o2@T:o`000?l94P[o0000o`T92_l0003o2A8:o`0000;o2@T:
0_l94PX3o`T92P?o2A8:1_l92@X02_lA9Qko8blco`T95?lA;c?o8blcoaXL
7_lA9Qko4A`:o`T92_l94PX4o`T92P03o`TB2_l92@[o2A8:00?o2@T:00?o
2@TDoaXB5?l92A@00ol92@X02_lJ4QCo2A8:o`TB2_l971ko2A8:o`T95?l9
4P[o2@TDoa4L2_l92A@2o`TB2P05o`000?l92@[o2@T:o`T95?lJ4Q@01Ol9
2@X01OlA70[o6Q8Doa4L2_lJ2@[o4A`:00?o;3PY00?o;4`YoaXL7_lJ9Q@0
0olS;ah01?l/9QCo6RHDob<_7_ldEBT3ob<_7P03ob<V2_lS;ako8blN00;o
8blN00So6Q8DoaXV5?ldEBWo=5DYo`000?lJ4QCo2@TDoc@_:@;o;3PY00Oo
=2lNodI17_ldEBWo8blNob<_:Ol0003o4A`:00;o2@T:00Co4A`:o`T95?lJ
71ko4A`:0ol92@X00olA70[o2@T:ob`B0004o`T92P03oa4L2_l0003o2A8:
00?o4A`:0ol92@X01?lJ2@[o2@T:o`TB2_lJ2@X2o`T92P04oa4L2_lJ2@[o
0000odmNIUooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;ok^k^00Co
k>c/omcLg?mgMgOofMWI0_oPh>001ooDe=CoalO7ol[:b_o>c/kod];BomCD
e?oFe]H00_ono_l07?onoOooooooooomn_ogln[ohm_@olo6]Oo0/j3o[Yj7
ojRDNonjYH[of;jSoncA]?ohgL3oonC;oo[E`_oke/Coo]O8ookIaooof<Wo
oMS6oogFaooke/Coo]O8oogHa_onelSooMS6ookGb?omf<H4ookGb00]ookF
b_onelSoo]K:ookGb?one/[oo]O8ookFb_onelSoo]K:ookGb?one/[oo]O8
ookFb_onelSoo]K:ookGb?one/[oo]O8ookFb_onelSoo]K:ookGb?one/[o
o]O8ookFb_onelSoo]K:ookGb?one/[oo]O8ookFb_onelSoo]K:ookGb?on
e/[oo]O8ookFb_onelSoo]K:ookGb?one/[oo]O8ookFb_onelSoo]K:00;o
o]O801gooMS6ookGb?omf<Koo]O8oogHa_onelSooMS6oogFaoolelGooMK7
oo_Fa?oleLKon]G3oo_DaOoie<7oo=RnoooO`ooohlKom]RlomVnXOnkXhOo
[9Qooj^KQ?no/9gocl>conOOe?ogln[oo_[gooomoP03ooooo`GoinOW3OoX
j>P7onWYj@?oj^[Z0oo[jn/00oo]kNgok>c/onk^kP02onk^kP;okno_2oo`
l?03oo7al@;olo?c0ooemOD:ooKfmPgomoOg2oohn?P2ooWin@;ono_k00?o
o?clookno_ono_h0>oooool01?lOHKCoXl;TokSCkomg[^/2oj[Oo`04ofi^
K_nd];Coh>3Ponc/k5_ok^k^00?o2A`Do`T95?l94PX00ol92@X01ol94P[o
4A`:o`T92_lA9QCo2A`DoaXB5?l94PX00_l92@X00olA70[o2@T:o`T92P06
o`T92P06oa4L2_l92@[o2@T:o`T92_l94P[o00000ol92@X01_l94P[o0000
o`T92_l0003o2A8:o`0000?o2@T:0_l94PX01ol0003o6PT:oa4L2_l0003o
4A`:o`T92_lA70X00_l92@X01Ol94P[o0000o`T92_l92@[o6PT:00;o4A`:
00?o0000oa4L2_l92@X00ol92@X2o`TB2P03oaX92_l92@[o2@T:00?o2@T:
0_l000002_l92@[o0000o`T92_l0003o2@T:o`000?l94P[o0000o`T92_l0
0002o`TB2P;o2@T:00go2A8:o`000?l92@[o2@T:o`000?l94P[o2@T:o`00
0?l94P[o2@T:o`000?l92@[o2A8:00?o2@T:0_l94PX02Ol0003o2@T:o`TB
2_l92ACo2A8:o`T95?l0003o2@T:o`TB2P02o`T92P0;o`TB2_l0003o2@T:
ocAE?OlJ71ko6PT:odmNI_mZNhCo;6MLo`000?l92@X00_l000002?l92@[o
0000o`TB2_l0003o2@T:o`000?l92@[o00000_l92@X00olA70[o2@T:oaXB
5003o`T92P04oa4L2_l94P[o2@TDo`T950;o2@T:00Ko2A8:o`T95?l92@[o
2A`No`T95?l94PX2o`T92P04o`TB2_l92@[o2@TDo`TB2P;o2@T:00Co4A`:
ob<L2_lA70[o2A8:0ol92@X2ob`h:@04odI<?Old;bWo8blNoaXB50;o8blN
00Oo;2HDoaXV5?lS;ako=5DYoba<:Ol/9QCo8bH:00;o;3PY00?o8bH:ob<_
7_lS;ah00_lS;ah02?l/71Co;3PYocAE:Ol92ACo4A`:o`TB2_m6@AkoAUi7
0_ldEBT01?l/C2Wo8blcob`V5?lA70X2o`T92P03o`TB2_l92@[o2@T:00;o
4A`:1?l92@X02?l0003o2@T:o`T92_lJ2@[o2@T:oa4L2_l92@[o4A`:0_l9
2@X00olJ2@[o2@T:o`T92P09o`T92P04oaXB5?l92@[o2@TDof11:Eook^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo02_ooOgmonc/k?mfMWKo
f][Jon3Ph?oQhN7oe=CDolO7aoo;bl_oc/k>om3@d?oCdm?oeMGEoocnoool
ooooo_ooookno_omnOKol>WQomK=__o0/j3oZi^4ojjJOoo2Zhcoh/NYooWK
^Ookf[OomM>`oo?>/Oole/?oo=G6oooEbOonelSoomK:oocEa_omdlOon]?4
oooEbOome/OoomG9oogFaoooeLWooMK700CoomG902goomC;oooEbOooe<_o
omG9oooDboooeLWoomC;oooEbOooe<_oomG9oooDboooeLWoomC;oooEbOoo
e<_oomG9oooDboooeLWoomC;oooEbOooe<_oomG9oooDboooeLWoomC;oooE
bOooe<_oomG9oooDboooeLWoomC;oooEbOooe<_oomG9oooDboooeLWoomC;
oooEbOooe<_oomG9oooDboooeLWoomC;oooEbOooe</00_ooeLT07Oome/Oo
omG9oogFaoooeLWooMK7oooEbOome/OoomO;oooHbOooel_oo]O8oooEbOom
e/OoomG9ookDa?oid;[om<ndooGB]?olfkcon]^lon?9Z?o1ZX[oYY=cok:R
R?o0]9koeljmonkWgOokm_;ooogn00;oooko00?oooooonOWiooWinL00ooW
inL2onSXj0?ojNWY0_oZj^X3on_[j`?ok>c/1oo]kNd6onk^kP03oo3`l?o_
knoolO7a00ColO7a2oobl_84oo?cl`Com?Cd2_oemOD5ooKfmP;omoOg00?o
m_KfooOgmoogmoL00oogmoL;ooShn0;onOWi0_okno/00oolo?coo_knookn
oP0kooooo`04oamP]?nUa>Ko^M?_ogN^j`;oZMco00CoMWIfol71`Oo`l?3o
oOgmFoooool03_lA70[o6Q8Do`T92_l94P[o6Q8Doa4L2_l92@[o6Q8Doa4L
2_l92@[o;1`DoaXB5?l92@[o4A`:0_l92A@00olA70[o2@T:o`TB2P02oa4L
2P03o`T92_lA70[o2A8:00;o2@T:00Co2A8:o`T92_l0003o4A`:1Ol92@X0
2?l94P[o2@T:o`000?l94P[o2@T:o`TB2_l0003o2@T:0ol000000ol92@[o
2A8:oa4L2P02o`T92P03oa4L2_l92@[o2@T:00;o2@T:00Go4A`:o`000?lA
70[o2@T:oa4L2P05o`T92P03o`000?l94P[o2A8:00Co2@T:00Co0000o`TB
2_l92@[o2A8:0_l000004Ol92@[o0000o`TB2_l0003o2@T:o`000?l92@[o
0000o`T92_l0003o2@T:o`000?l94P[o0000o`TB2_l92@[o000000;o2A8:
00Co0000o`TB2_l0003o2@T:0_l000003_l94P[o2@T:o`000?l94P[o0000
o`TB2_l0003o4A`:o`000?l94P[o2@TDo`T92_l0003o2A8:0_l92@X03ol9
4P[o2@T:oa4L2_l92@[o;1`Doa4_?Olm;cgo;5E_o`TB2_l0003o2@T:o`TB
2_l0003o2A8:o`000002o`TB2P;o2@T:0_l94PX01ol92@[o4A`:o`T95?l/
>2Wo2@T:o`TB2_l92@X00_l92A@01OlJ4QCo2A8:o`T92_l94P[o2@T:00?o
2@TD00Go2@T:o`000?l94P[o2@T:o`000002o`TB2P;o2@T:0_l94PX03?l9
2@[o0000o`TB2_l92@[o2A8:o`000?lS9P[o=5DYoc@_<oldEBWo;3PYoa4L
2P;o8blN00Ko6RHDob<_7_lS;ako=2lYoba<:OlS;bT2ob<_7P04ob<V2_l/
>2Wo8blNoc@_7P;o8blN00So;3PYodIE:OldEBWo0000o`TB2_lS;ako?Ehm
ob<_7P?o6RHD00?o6Q8Doa4L2_l000001Ol92@X00olJ2@[o2@T:o`T92P05
o`T92P06o`000?l92@[o2@T:o`TB2_l92@[o6PT:0_l92@X01?lS70[o2@T:
o`T92_l94PX8o`T92P04oa4L2_l92@[o0000ok1kIUoooooo00Co[jn_ol_;
booNg]koj^[Z0Oobl_8000;ok^k^00Cok>c/omcLg?mlO7cof][J0_oPh>00
6OoCdm?oa/K6olc<c?o>c/kod=3@om?CdooGemOonogooocoooonooooo?cn
ooKck_oVgmGob/6`okJWT_nTTgWo`Z^<omc2XOo[bZOolm6/oooL]_oogkSo
omZjoo_A`OoldLP00_omd/T<ookCbS3oom;<2oondlX4oogBb@0?oogCaOoo
hlgoomZnooWB/oofd[3om]B_on_=YooE_9Co`Jf8ojRHM_ndYX_oc<6]onSP
dookm_;oooko00;ooogo00?oooooonKVi_oVi^H00ooVi^H2onOWi`?oj>SX
0_oYjNT2on[ZjP04onOWiooLg=cojn_[on_[j`Ook>c/1_o]kNd2ono_k`06
oo7alOoOgmookno_oo7alOoVi^KoinOW2_obl_85oo?cl`03on3Ph?oShn?o
lo?c00Gom?Cd00?ofm_Koo;bl_odm?@00_odm?@00ooRh^;oiNGUooGem@02
ooGem@?omoOg1OoinOT00ooNg]kodM7AooWin@04oo[jnP07onOWioohn?So
n_[jono_koo`l?3ono_kooclo002ono_k`;ooOgm1?ono_h00ooTi>Coo?cl
ooknoP06ooknoP04oo?clooWinOoo_knooknoR[ooooo00Co6enfojC4i_ni
dnooMZgZ0_n[h?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP0@o`T95?lJ4QCo
2A8:oa4L2_l92ACo2A8:oa4L2_l92ACo4A`:o`T92_lS;c?o2@T:oa4L2_l9
2@[o2A8:oa4L2P;o2@T:00?o4A`:o`TB2_l92@X00ol92@X2o`TB2P04o`T9
2_l0003o2A8:o`TB2P;o2@T:0ol94PX01?l0003o2A8:o`T92_l92@X2o`00
000:o`TB2_l92@[o2@T:o`T92_lJ4QCo2@T:oa4L2_l92@[o2A8:oa4L2P?o
2@T:00Co2A8:o`T92_l94P[o2A8:0ol92@X01?lA70[o2@T:o`T92_lA70X2
o`T92P;o000000Ko2A8:o`T92_l94P[o2@T:o`TB2_l92@X2o`0000;o2@T:
00Go0000o`TB2_l0003o2@T:o`000003o`T92P0Ao`000?lJ4QCo0000o`T9
2_l0003o2A8:o`000?l92@[o2A8:o`T92_l0003o2@T:o`000?l94P[o2@T:
o`000?l94PX01?l92@X02?l92ACo2@T:o`T95?l0003o2@TDo`T92_l0003o
2@T:0_l94PX02Ol0003o2A8:o`T92_l92@[o2A`Do`T92_lm;cgoPhf4ofYk
Q002o`T95006o`TB2_l92@[o0000o`T92_l0003o2A8:0_l00004o`T92P07
o`000?lA70[o6Q8Do`TL5?l92@[o0000o`TB2P02o`T95003o`TL5?l92@[o
2A8:00?o2@TD00?o2A8:o`T95?l94PX01Ol92@X01?l92ACo4A`:oa4L2_l9
2@X2o`000006oa4L2_l0003o2A8:o`000?l92@[o8a`:0_m6C3d01?ldEBWo
;3PYoa4V5?lJ71h3ob<_7P05oaXB5?l/>2Wo=2lYoaXV5?lS;ah01?l/>2T3
ob<_:@0:odIE:Om6C3go4BHNo`T92_lJ4QCo;2HDo`TL5?l92@[o6RHDo`T9
2P;o4A`:1?l92@X00olA70[o2@T:o`T92P0<o`T92P03oa4L2_l92@[o2@T:
00?o2@T:00?o6PT:o`T92_l92@X01_l92@X01OlJ2@[o2@TDoa4L2_l0003o
b]3105ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV00Coi>CT
omCDe?mlO7cof][J0_oPh>006_oCdm?oalO7olc<c?o>c/kod=3@om;Bd_oF
e]Kon_kooocnooono_oon_[loo3]j?oMel_o`kRVojnOR?n]VWcobk:ConO9
YOoacjWomm6ZoogF[OooeJ_on/n]oooFb?oneLoooMC>0_oneLl00oooe]3o
omOAoooHdP08oooFd33oomGB2?ooe]02oocCc@GooMC>01;oomK:ooK9]?oo
dKOoombloooO^ookf;;ojl^RomZoU?o<]hco/ImiokBUQ_o4^:3ogmK7ooK_
jOoon_kooo_oooolooooool5onKViP0>oc0`<?mlO7coj>SXonSXj?oMgMgo
:RXZoc<c<ooRh^;o/;2`oaPH6?l61PKoBd];ogalO?l/;2`2ong]k@06oc/k
>omfMWKokNg]ong]kOmaLG7o?Shn0_o^k^h03OnXZ:So20P8ono_koo_knoo
C4a<o`L71olH61SoTY:Boa4A4OmBDU;olO7aoc`l??mhN7P00_oalO401_mc
Lg?o?clooo7alOoalO7oZZZZo`P820;ol_;b00Kod=3@oc8b<_l=3@go2`/;
ocHf=_oCdm<2ooGem@0<ol[:b_lS8b?o71`Lok:b/_oemOGod];Boc8b<_l=
3@go2`/;ocHf=_oDe=Com_Kf0_ohn?P06?ogmoOonOWiooWinOoinOWoVYZJ
oa8B4_l820So9RHVoaXJ6_m:BT[oe=CDoo[jn_m?Cdoo1`L7oaTI6OnHV9So
4Q8BoeEEEOokno_o92@To`l?3olO7aooC4a<ooGem@;ooooo00Oodm?CobDU
9OlN7Qko^[Zjoooooom0@43oOgmo00;ooooo00KoinOWodY:B_l30`?o8b<S
oaLG5oo1`L4Zooooo`04oa]N/onUa>Ko]M3^ogV^k0;oYmco00CoJVYZojj^
[_oHf=Soi>CTFooVi^H01?lJ4QCo4A`:o`T92_l92A@3o`T92P07oa4L2_l9
2@[o2@TDo`T92_l94P[o2@T:oaXB5004o`T92P03o`TB2_l92@[o2@T:00;o
2@T:00?o2A8:o`T92_l92@X01?l92@X2o`TB2P03o`000?l92@[o2A8:00;o
2@T:00Ko2A8:oaX92_l94P[o0000o`T92_lA70X3o`T92P03o`TB2_l92@[o
2@T:00?o2@T:00?o0000o`T92_l94PX00_l92@X01Ol94P[o2@T:o`T92_lA
70[o6PT:00Co2@T:00Co0000o`T92_l92@[o00002?l92@X00ol0003o2@T:
o`000003o`T92P04o`000?lJ2@[o2@T:o`0000;o2@T:00Go0000o`T92_l9
2@[o0000o`T92P02o`000003o`T92_l92ACo000000;o2@T:00?o2A8:o`00
0?l92@X01ol92@X01Ol0003o2@T:o`T92_l94P[o000000Go2@T:00Go2@TD
o`000?l99RWo;6MLo`TL7P02o`TB2P03o`000?l92@[o2@T:00Ko2@T:00?o
0000o`T92_l92@X01_l92@X02Ol94P[o2@TDo`T95?l92ACo2@T:o`TB2_l9
71Co6Q8Do`TB2P02o`T95003o`T92_l94P[o2@T:00;o2@T:00Go2A8:o`T9
5?l92@[o2A8:o`000006o`T92P03o`000?lS;akoAT4N00;o?Ehm00?o=2lY
ob<V2_lA9Qh01?lS;ah2odIE:@06ob<V2_lS;ako;3PYob`V5?l/>2Wo=5DY
0_lJ9Q@01Old;bWoAUi7ocAE:Ol971Co2@T:00;o4BHD00?o2@T:oa4L2_l9
2@X00_lA70X00ol94P[o2@T:o`T92P0:o`T92P03o`TB2_l92@[o2@T:00Oo
2@T:00?o6PT:o`TB2_l92@X02_l92@X01?lA70[o2@TDo`000?o1/jeOonKV
iP04oifMWOng]kOob<S8om?Cd`7of][J0002onk^kP04onc/k?oLg=coO7al
om[JfP;oh>3P01ooe=CDolS8b?o;bl_oc/k>om3@d?oBd];oe]KFooclooon
ooooookoooWgn?o]j>CofM76ol6bWon_Vh3oc;JAolbaQ_oG]XWok/ZJoocF
ZOooeZcoomVaoooO_oooe/;oo=G6oo_DaOojd/KonM75oo[Ba_okdlOoo=C8
00Sonm?7<?omd/T08OokdlOon]C7oo_Caooje<Oonm?7oo[DaookdlOon]C7
oo_Caooje<Oonm?7oo_Eb?ole<Soo=K9oogEbOooe/CoomNnoooG^?ooekGo
oMFaooOAZ_o/bIoogKj@olndQOo3[X?o_J^5ol6cU_oGc;Sok^GNooWcmOon
n?oooocoooono`05onKViP0>oc0`<?mlO7coj>SXonGUiOm3@d?o8B4QomOG
eoo/k>coCDe=oe9BD_oUiNGoTY:Bo`d=3Ol/;2`2onk^kP06oc/k>omfMWKo
k^k^onk^k_mbLW;o?Shn0_o_knl02OnXZ:So20P8ono_koni^KWo0`<3olo?
cooGemOoEEEEo`l?3`02oo3`l006oc`l??mgMgOol?3`oo3`l?mbLW;o?clo
0_o`l?001_nYZJWo20P8oo7alOo`l?3o<C4aodi>CP;ohn?S00_oDE5Aoc8b
<_odm?ComOGeofa/K?ln?Skom?CdooGemOodm?Co<C4aodi>CP02onGUi@03
oe9BD_lc<c?omOGe00?omoOg0_ohn?P03_nCTi?o0P82ohN7Qoofm_KonOWi
ooOgmon][Jgod];Bol71`Ol30`?oemOGon3Ph?mHF5So410@0_ojn_X01Onm
_Kgon?Shoo_knole=CGoTI6A00;ooooo00?oLG5aod51@Oono_h00_ooool0
2_m0@43oOgmoooooooooooooA4A4od10@?oOgmoooooooo?cloobl_8Zoooo
o`04oa]O]_nTa>Ko^=;^ogJ]jP;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^
k^h01Ol92@[o4A`:o`TB2_lJ4QCo2@TD00;o2A8:00Go0000o`T92_l94P[o
2A8:oaXB5002o`TB2P03oa4L2_l92@[o2A8:00;o2A8:00Oo4A`:o`T92_l9
2@[o2@T:oaX92_l92@[o2A8:00?o2@T:00Ko2A8:o`000?l92@[o2@T:o`TB
2_l00003o`T92P04o`TB2_l92@[o2@T:o`TB2PGo2@T:00Go8blYo`TB2_l9
2@[o2@T:o`TB2P05o`T92P05o`TB2_l92@[o4A`:o`000?ld;bT02?l92@X0
0olA70[o2@T:o`T92P09o`T92P03o`000?l92@[o2@T:00;o2A8:1?l92@X0
0ol0003o2@T:o`000004o`T92P04o`000?l94P[o2A8:o`0000?o2@T:00?o
2A8:o`T92_l92@X01?l92@X00ol94P[o2@T:o`T92P05o`T92P03o`000?l9
2@[o2A8:00;o2@TD00Oo0000o`TB2_l971Co0000o`T95?l92@[o000000Oo
2@T:00Go0000o`T92_l92@[o2@T:o`TB2P03o`T92P0;oaXB5?l94P[o6Q8D
o`T95?l92@[o6Q8Do`TL5?lJ4QCo2@TDo`TL5?l92A@00_l92@X01Ol94P[o
2@T:o`T92_l92ACo4A`:00?o00000ol92@X02Ol94P[o2@T:o`T92_l94P[o
6RHDocAE:Om6EBWoAUEBocAE:@03ob<_7P05ob`h:OlJ9QCo;3PYoc@_:Old
EBT00_l/>2T03oldEBWo;3PYoba<:Om6C3go=2lYob`h:OmZLUcoH5hcob<_
7_l0003o4BH:o`T95?l971Co2@T:oaX92P02oa4L2PCo2@T:00Go4A`:o`T9
2_l92@[o2@T:oa4L2P03o`T92P05oa4L2_lJ2@[o2@T:o`T92_lA70X01?l9
2@X01OlJ2@[o2@T:o`T92_l92@[o6PT:00?o2@T:00?o4A`:o`T92_l92@X0
0_l92@X01olJ2@[o2@T:oa4L2_l92@[o4A`:o`000?nEQ8h0Goo^k^h01?nS
Xj?o_Kfmolo?cooJf]X1on7Qh@000_ooool09OomoOgok>c/og]kNooJf][o
h>3Pon7QhOoEeMGob<S8ol[:b_o>c/kod=3@om?CdooFe]Kooo_hooonnooo
oOkooo_konKLf_oDakko]ZB>ok>MN?o6ZWSodkEgon6oOooYaHOol<^FooSC
Yoolf;KooMZloooM_Oong;Woo=ZgoocI^Ooog;koomfooooL`?onfkl00ook
f;`00oolfKgoo=VkoogJ_002oogJ_003oocI_Oolf;koo=Rn00Goo=Rn0oom
fKl2oocH_P?onmNm4?olf;h3oo_H_0;oo=Vm0oomf[h8oo_H_00Noo_H^_oj
fKSonmRhoo[I^?okf;Son]Vhoo_H^?ojfKSonmRhoo[I^?okf;Son]Vhoo_H
^?ojfKSonmRhoo_I]_oofkKoom^dookG/?ohdJ[ollbUonc5W?oO^Xgod[:1
olR/O?ncWFko_Zb4om;4Yoo/hmCooo_h0_oooOl00oooo_ooi^KVonKViP03
onKViP0:oc0`<?mlO7coj>SXoemOGolD51CobLW9onWYjOoZj^[o:2PXohB4
Q0;ojn_[00KoL71`ob`/;?o/k>cok>c/oc/k>omeMGD2onc/k00=og5aLOln
?SkokNg]ong]kOnWYjOo20P8ono_koo;bl_o0P82ok:b/_oalO7oUYJFoahN
7P02oo;blP06oc`l??mhN7Sol_;boo;bl_mcLg?o?clo0_obl_801_nZZZ[o
20P8oo?cloo=cLgo0000ojj^[P;olo?c00Ko[Zj^o`000?oBd];om?CdodU9
BOm]KFd2ooCdm003olk>c_l0003o[jn_00;omOGe00?o[jn_o`000?oDe=@0
0_ohn?P01_oinOWono_kooCdm?lC4a?oHF5Qooclo0GooOgm00KoemOGo`82
0_nk^k_ooOgmoifMWOlO7al2oogmo@;oo_kn00?oa<C4oaHF5_nCTi<00_oo
ool00om=CDgoLW9booooo`02ooooo`06od10@?moOgooooooomgMgOl0003o
^;Rh;_ooool01?lMGk?oY/KVokK@k_mi[nh2oj_No`04ogIfM_o1`L7ol?3`
oogmoE_ooooo00?o4A`:o`T92_l94PX00_l94PX01?l92@[o2A8:o`TB2_lA
70X5o`T92P07o`TB2_l92@[o4A`:o`000?l94P[o2@T:o`000002oa4L2P03
o`000?l92@[o2@T:00?o2@T:00?o2A8:o`T92_l92@X00ol92@X04Ol94P[o
2@T:o`T92_l0003o2A8:o`T92_lA70[o2@T:o`TB2_l92@[o2A8:o`T92_l9
4P[o2@T:o`TB2_l92@[o2A8:00Co2@T:0_lJ4Q@01OlA70[o2@TDo`T92_lJ
71ko000000Co2@T:00go4A`:o`T92_l0003o2@T:o`000?l92@[o0000oa4L
2_l0003o2A8:o`T92_l94P[o4A`:00;o000000?o2A8:o`000?lJ71h00_l0
0002o`T92P04o`TB2_l0003o2A8:o`0000;o2A8:00Go2@T:o`000?l94P[o
2@T:o`000002o`TB2P08o`000?l92@[o2@T:o`TB2_l92@[o2A8:o`T92_l9
4PX3o`T92P03o`000?l94P[o2A8:00?o2@T:00?o2A8:o`T92_l92@X00_l9
2@X01_l92ACo2@T:o`T95?l971Co2A8:o`0000?o2@T:00Go0000o`T92_l0
003o2@T:o`000006o`T92P03o`TB2_l92@[o2A8:00;o2@TD00Co2A`Do`TB
2_l92@[o2A8:0_l92@X3o`T95003o`TB2_l92@[o000000;o2A8:00?o2@TD
o`000?l92@X02Ol92@X03?lS;ako;3PYodI<?Om6EBWoCfM7oc@_:OlS;ako
6RHDob<V2_l/>2Wo8blNob`h:@;o;4`Y00?o=2lYob`h:Ol/C2T00_m6@Ah0
1?ld;bWoAUDYog9WD_mGIe82o`TB2P07oa4L2_lS;bWo4BHDob<_7_lJ9QCo
4A`:o`TB2P02o`T92P03o`000?l92@[o2@T:00Oo2@T:00?o0000o`T92_l9
2@X00ol92@X00olJ2@[o4A`:o`T92P02o`T92P05o`TB2_l92@[o2@T:o`T9
2_lJ2@X01?l92@X02OlA70[o2@T:o`T92_lA70[o2@T:oa4L2_l94P[o0000
ojJHQ01Oooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP04onc/
k?oLg=coNg]kom[JfP;oh>3P00Ooe=CDolS8b?o;bl_oc/k>om3@d?oBd];o
eMGE00;oookk01SooogjooolnOoYg]SoeLFfokBOP_ngW77obJYaomNdL_oS
_WSoj<=oon_7SOo_cIool]6^oo?B/ookfK?on]N]ooWF[_ojejooo=RdoogI
]Oolf;KonmNeookJ^_oofk/2oooK^@?oombh00?oomfhookL^Oonfk/01_on
fk/4oooL_0?oo]^k00?ooMZjookK^oonfk/03_onfk/01?omfkSoo]biookL
^Oong;T4oooM^POoo]bi0_ong;L7ookL]PCooM^e0oong;H04_ongKCon]N]
oo_FZ_ohdJSom<ZRoo36W_oZ`9Koh;N9omB_Noo:ZGCo]9UTok^VMooCaJ;o
kNGBoookmooooOoooO_oooono`GoinOW00[o<C4aogalO?moOgoo2@T9okNg
]ooZj^[ojNWYon[Zj_lX:2SoQXJ60_o[jn/01_n3Ph?o;2`/onc/k?o/k>co
>c/kogEeM@;ok>c/00KoLG5aochn?_o]kNgokNg]ojNWYol820P2ono_k`05
oj>SXol_;boo<30`oc<c<olN7Qh00_obl_801_ll?3coN7Qhoo;bl_obl_;o
Lg=coclo?`;ol_;b00KoZZZZo`P82?oclo?o]KFeo`000?oLg=`2ooCdm006
om[Jf_l0003o^KViooGemOm9BDWoKFe]0_oemOD00onf][Ko0000omcLg002
ooKfmP03om_Kfol0003o^[Zj00?on?Sh00Gon_[jolo?col0003o_[jnoo[j
nP06oo_kn`05ojZZZ_la<C7o<S8bocDe=OlO7al00_olo?`01OoRh^;oBDU9
o`820_m`L73omOGe00;ooooo00?oCDe=og9bL_ooool00_ooool01_m0@43o
Ogmooooooonn_[ko0000ocdm?@?o?clo00?oa<C4ooooooooool0:?ooool0
1?lJG;?oY<?UokSBkomi[^`2ojcOo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^
00?o2@TDoa4L2_l92@X00_l92@X2o`TB2P?o2@T:0_l94PX01ol92@[o4A`:
o`T92_lA70[o2@T:o`T95?lJ2@X00ol92@X00ol0003o4A`:o`T92P02o`T9
2P05o`TB2_l92@[o2A8:o`000?lA70X00_l000003ol92@[o0000o`TB2_l9
2@[o2A8:o`000?l94P[o0000o`TB2_l92@[o0000o`TB2_l92@[o2A8:oa4L
2P02o`T92P03oa4L2_l92@[o2@T:00;o2@T:00So4A`:o`TB2_l92@[o;2HD
oaXB5?lA70[o2@T:oa4L2P;o2A8:00?o4A`:o`000?l92@X00ol92@X01?l9
4P[o2@T:o`T92_l00003o`T92P;o00000_l92@X2o`000003oa4L2_l92@[o
000000;o2@T:00So0000o`T92_l92@[o2@T:o`000?l92@[o0000o`T92P;o
000000Ko2A8:o`000?l0003o2A8:o`T92_l94PX2o`T92P03o`000?l92@[o
2A8:00;o2@T:00So2A8:o`T92_lA9P[o2A8:o`000?l92ACo2@T:o`0000;o
2@T:00Ko2A8:oaXB5?l971Co2A`No`T92_l00005o`T92P03o`000?l92@[o
000000;o2@T:00Wo0000o`TB2_l0003o2@T:o`TB2_l92@[o0000o`T92_l9
4PX01?l92A@00ol94P[o2@T:o`TB2P02o`T95003o`T92_l94P[o2@T:00;o
2@T:00Co0000o`TB2_l94P[o2A8:0_l92@X02ol0003o2@T:o`TB2_l92@[o
2A8:o`T92_lA70[o;1`Dob`h:Om6C3go?Ehm00;oAT`m00?o8blYob<_7_l/
>2T00_l/>2T01OldEBWoAT4Noc@_<ol/C2WoAT4N00;o;3PY00_o;5hmob<_
:OmGEE;oJW]_ocAE:Ol0003o2@TDo`000?lS;akoAUDYoba<:@05o`T92P03
o`TB2_l92@[o2@T:00[o2@T:00?o0000o`T92_l92@X00_l92@X01OlA70[o
2@T:oaX92_l92@[o;18000?o2@T:00Co2A8:o`T92_l92@[o4A`:1?l92@X0
1Ol94P[o6PT:oaX92_l0003oUJ6>05ook^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN4000;oi^KV00Coi>CTomCDe?mlO7cof][J0_oPh>007ooDe=Cob<S8
olc<c?o>c/kod=3@om;Bd_oDe=Cooogooooloooono_oookfoncSd_oDa:[o
[9I_okNKJoo9YVcoeZi`on6hN_oU_H3oj<6:on[6U_o[bj;ojl^TooWF/?oj
e:oonM>_oo[D/?oleKKooMJgoocE^?oke;L00_ohd;H2ooWB]@;onM:c0_oj
dk@00ooid[Gomm:eooOB]@05ooOB]@;on=>f1?ogd[D2ooKA]13omm:e0_of
dK@4ooOB]@;on=>f1oogd[D2ooOC/`Oomm>a1oofd[004_ofdZkol/nUooC?
Xoo`bIkok<:HonZoU?oV^hkogKB0om>/MOo9YVko/YANok6KJ_oDa:3oknCB
ooojm_oooOoon_[oooono`GoinOW00Go<C4aoc`l??l20P;oXZ:RonSXj002
onWYj@03on[Zj_lX:2SoQXJ600;oj^[Z00KoPh>3ob`/;?o[jn_ojn_[ocXj
>_mTI6@2on_[j`08ofm_Kol_;boojn_[ong]kOnVYZKo20P8ono_koo^k^h2
oo3`l003onk^k_n;Rh_o7alO00;ol_;b00ko?3`lofMWIoobl_;ol_;bog9b
L_l`<33olO7aoo;bl_nYZJWo20P8oo?clooAdM7o0000ojb/[0;omOGe00Ko
Zj^[o`000?oHf=Som_KfodY:B_m]KFd2ooKfmP03omCDe?l0003o[Jf]00;o
moOg00?o[:b/o`000?oHf=P00_ogmoL2ooShn004ojj^[_l0003ofm_KooSh
n0SonOWi00?omoOgoi2@T?lP82000_ojn_X00om0@43o@D51omSHf002ookn
oP;ooooo00?oCDe=og9bL_ooool00_ooool02_m0@43oOgmooooooooKfm_o
0000oj^[Zoo?clooalO7o`<30ooUiNDZooooo`04oaeO/onUa>Ko]];^ogV^
j@;oZ^3o00CoJVYZojj^[_oHf=Soi>CTFooVi^H01OlJ4QCo4A`:o`TB2_lJ
4QCo2A8:00?o2@T:00Ko4A`:o`T92_l94P[o2A8:o`T92_lJ4Q@3o`T92P03
oa4L2_l92ACo2@T:00;o2@T:00?o4A`:oaXB5?l92@X00_l92@X00ol0003o
2@T:o`T92P02o`T92P05o`TB2_l92@[o0000oa4L2_l000001ol92@X02ol9
4P[o2@T:o`T92_lA70[o0000oa4L2_l94P[o2@T:o`000?lA70[o000000;o
2@T:00Ko0000o`T92_l92@[o2@T:o`TB2_l00004o`T92P;o4A`:1?l92@X0
1ol94P[o2@T:o`000?l92@[o2A8:o`T92_lA70X01?l92@X01?l0003o2@TD
o`000?l94PX4o`T92P06o`000?l92@[o0000o`TB2_l92@[o00001?l92@X0
0ol92ACo0000o`T92P04o`T92P03o`TB2_l92@[o2A8:00;o2A8:0_l92A@0
0ol94P[o2@T:o`TB2P03o`T92P03o`TB2_l92ACo2A`D00;o2@TD00Wo2@T:
o`T95?l0003o4A`:o`T92_l0003o2A8:o`000?l94PX00_l92@X01Ol94P[o
2@T:o`T92_l94P[o000000;o2@T:0ol94PX00ol92@[o2A8:o`T95002o`T9
5005oa4V7_l92ACo2A8:o`TL7_l92A@00_l92@X01_l94P[o2@T:o`T92_l9
2@[o2A8:o`0000?o2@T:00So2A8:o`T92_l94P[o2@T:oa4L2_l94P[o8blN
ob`h:@;oAT`m00?oAUEBodIE:Ol/>2T00_lS;ah06OldEBWo=2lYoc@_<old
EBWo=2lcodI<?OldEBWo;3PYocAE:Ol/C2WoEeEBoeN=G?mPGS?o8blNo`T9
5?l0003oAT4Nog:=?Ol/C2Wo0000o`TB2_l92@[o0000o`T92_l94PX04Ol9
2@X00olJ2@[o2@T:o`T92P04o`T92P07o`TB2_l92@[o2@T:o`T92_lJ2@[o
2@T:o`TB2P02o`T92P06ob<L2_l92@[o6PT:o`T92_l0003oYZ6HGooVi^H0
1?nMWIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h09oo/k>cog=cLog]kNooI
fMWogmoOon7QhOoDe=CoalO7olc<c?o>c/kod=3@omGEeOoDe=Cooogoooci
ooooo?_oookboo7Wc_oDa:3oXXaKokBEG_o5WVGodjI[omj_MooS]Wooi;^7
onO3SooXb9OoilRJon_5W_o/a:3okLFRonk6Xoo_aZKoklJXono6Z_o^aJWo
k/B[ono5[002ono6ZPCoklJX00?oklJZonk7Z_o^ajX03?o^ajX00oo]aZWo
k/NZonk7ZP0>onk7ZP03ong6ZOo^aj[ok/NZ00cok/NZ00?ok/NXonk7Y_o^
ajH01_o^ajH6ong6Y@0Conc5Y?o/aZ;ok<VOong8W?oY`iKoikbAonFiR_oT
]XCogK1iom>YKoo8XFKo[hmFojR>GOoGaIooknC@ookiloonoOoono_oooon
o`05onWYj@0:oc4a<Om[Jf_o7alOoh^;RooZj^[ojn_[on[Zj_o[jn_o:2PX
ohN7Q`;ok>c/00koQ8B4ob`/;?o/k>cok>c/oc/k>olC4a?oPH61omKFe_lj
>S[o71`LoeUIFOoBd];oJFUYobl_;`;ok^k^00GoZ:RXolc<c?o/k>coFUYJ
odi>CP02oo3`l00:oc`l??lC4a?oPh>3om[Jf_lk>c_o7AdMoeYJF_oDe=Co
JVYZoc0`<0;olO7a01Co?CdmodA4A?oDe=Codm?Cod=3@om1@D7omOGeono_
kom6ATKoJ6QXon[Zj_oalO7omOGeochn?_m5ADGoe]KFomGEeOm4A4Co@D51
ooKfmP?omoOg00Gon?Shol71`Ol0003oc<c<ooShn006ooWin@05ojn_[ooD
e=Com_KfoeiNG_mBDU800_ojn_X03_lf=SKoU9BDooclo?oWinOonOWioooo
oooinOWoBDU9ofe]KOodm?Cono_koooooom0@43oOgmo0_ooool01Olo?coo
Jf][ooOgmonNWYko:b/[02_ooooo00Co6ejcojK6i_nidnkoNJk[0_n[gol0
1?m^KVko];Bdon3Ph?o/k>aKonk^kP03o`T95?l92@[o2@T:00;o2@T:00?o
2A8:o`T92_l92@X00_l94PX01ol92@[o0000o`T92_l94P[o2@T:oaXB5?l9
2@X00ol94PX01?lJ4QCo4A`:o`TB2_lA9Q@2o`T92P07o`TB2_l92@[o2A8:
o`T92_l94P[o0000o`T92P02o`TB2P04o`000?l92@[o2A8:o`0000;o2A8:
00Go0000oa4L2_l0003o2@T:o`000002o`T92P;o2A8:00Co2@T:oa4L2_l9
4P[o00001_l92@X01?l0003o2@T:o`000?l94PX2o`T92P07o`TB2_l92@[o
2@T:o`T92_l94P[o2@T:o`000003o`T92P04o`TB2_l0003o2A8:o`0000Co
2@T:00_o2A8:o`000?l94P[o0000o`T92_l0003o2A8:o`000?l92@[o0000
o`T92P02o`0000?o2@T:00Co0000o`T92_l0003o2A8:0_l92@X2o`TB2P03
o`000?l92@[o2@T:00;o2@TD00?o2A8:o`T95?l94PX00_l92@X01_l0003o
2@T:o`TB2_l92@[o2@TDo`TB2P?o2@TD00Ko2A8:o`T92_l0003o2@T:o`TB
2_l00003o`T92P03o`TB2_l0003o000000;o2@T:00Oo0000o`TB2_l0003o
2A8:o`000?l92ACo2@T:00;o2A8:00So2A`No`T95?l/71Co8d4mo`T95?l9
71ko2A`Do`T950;o2A8:00Go0000o`T92_l94P[o2A8:o`000003o`T92P0U
o`TB2_l0003o2A8:o`TB2_lA70[o6PT:oa4L2_lS;ako;4`Yocd_?Om6@Ako
=5DmoceN?OlS;ako;4`Yoc@_:Om6C3go=5DYodI<?Om?IdOoCfMLocAE:Om6
C3go=2lcob`h:OlS;akoH5hcodmWAolmGSgo;4`Yo`000?mZEAkoPg]Lo`TL
5?l0003o2@T:o`TB2P02o`T92P03o`000?lJ2@[o2@T:00?o2@T:00?o2A8:
o`000?l92@X02ol92@X00ol94P[o4A`:o`T92P02o`T92P03o`TB2_l92@[o
2@T:00Co2@T:0_l94PX01ol92@[o2A8:oaX92_l92@[o4A`:o`000?nVV8@0
Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool08oomoOgok>c/
og]kNooIfMWogmoOon7QhOoDe=Coa/K6olc<c?o>c/kod=3@omCDe?oEeMGo
o_coooSgooomnocooog^ooG/booIbicoW8=;ojn=D?o1Uegod9mWombYM?oQ
[gcohKJ1onFnQooR`h[ohlB>onO1U?o[`IWokL>Monk4W_o^`j3ok/>Q00;o
k/>S0_o_a:@2onk3X`;ok/>Q00?ok/>Ponc4X?o/a:403Oo/a:42ong5XQ3o
k<BQ0_o]aJ8>onc4X@Sok<BP00CokLFQonc4X?o/a:3ok<BP0_o[`il04ooZ
`YkojL>LonK3VOoU`iGoi;j?on6gQooR]8;oh[5iom^ZKooCXfGoa9]Mojf9
ConNPU3oflNRoo;Ud_omn?;oookooogmooooo_l01OoXj>P01Ola<C7oO7al
ol71`Ol@413o[jn_00;oj^[Z00?ojn_[ocdm?OnATI400_o/k>`03_n?Shoo
@410onc/k?o/k>coCDe=oh20P?mXJ6So3Ph>obDU9Oo5aLGoShn?oaPH6?lM
7AgoX:2P0_o^k^h01On1PH7o;Rh^o`h>3_le=CGo]kNg00;ol?3`00[oCdm?
oh:2P_mZJV[o3`l?obDU9Oo8b<SoT92@oaPH6?lN7QkoXj>S0_oalO403ooL
g=coCTi>o`h>3_l>3PkoD51@omoOgooemOGoNWYjo`L71ol;2`_o6ATIojNW
YooemOGog]kNodi>CP02o`h>3P03oe5ADOoPh>3om_Kf00;on?Sh00KomoOg
ooWinOoWinOo0@41oiVIVOoinOT6oo[jnP05ohN7Qola<C7o3`l?ocLg=oo0
`<000_okno/03_nl_;co>CTio`l?3olB4Q;oinOWoooooomoOgoo20P8o``<
3?lK6a_o[Zj^oooooom0@43oOgmo0_ooool01OoVi^KoAdM7o`d=3OlL71co
]kNg02_ooooo00Co7f6doj?2i?nhdnooMjk[0_nZgol01?mfMWKo`L71oo3`
l?omoOeKooooo`05oa4L2_l92@[o4A`:oa4V7_l92@X00_l94PX00olA70[o
2@T:oa4L2P03o`T92P;o2A8:00Co6Q8Doa4L2_l92@[o2A8:0ol92@X01ol9
4P[o0000o`T92_l92@[o0000o`TB2_l000000_l94PX2o`T92P08o`000?l9
4P[o2@T:o`T92_l0003o4A`:o`000?l92@X2o`TB2PKo2@T:0_l94PX01Ol0
003o2@T:o`TB2_l94P[o000000;o2A8:1?l92@X02_lA70[o2@T:o`000?lA
70[o2@T:o`000?l94P[o2@T:o`000?l94PX3o`T92P05o`000?l94P[o0000
o`TB2_l000001?l92@X04Ol0003o2@T:o`T92_l0003o2@T:o`000?l92@[o
0000o`TB2_l0003o2@T:o`000?l92@[o0000o`TB2_l0003o2@TD00;o2@T:
00Co0000o`TB2_l92@[o2@T:0_l94PX01_l92@[o2A8:o`T92_l94P[o4BHN
o`T950?o2A8:00Go2@T:o`TB2_l92@[o2A8:o`TL5002o`T95007o`TB2_l9
71ko2@TDo`TB2_l0003o2A8:o`000002o`TB2P;o2@T:00So0000o`T92_l9
2@[o2@T:o`000?l92@[o0000o`TB2P;o2@T:01;o0000o`T92_l92ACo2@T:
oa4V7_l/71Co6Q`Nocd_?Ol92ACo2A`Do`TL7_l94P[o4A`:o`T92_l94P[o
2@TDoa4V5?l92A@2o`TB2P04o`T92_l0003o2A8:o`T92P;o2A8:02?o4A`:
oa4V5?lJ9QCo=2lYodIE:OldEBWoCfMLoh>4Nom6C3go=5DYob<_:Om6C3go
AT4NocAE?OmGEE;oCfMLoceN?Om6C3goAUi7odIED_m?IdOo8blNof1N<om?
IdOoJW9Lo`000?m6EBWoSHe_obaN?Ol0003o2@T:o`TB2_l92@[o0000o`TB
2P02o`T92P05oaX92_l92@[o4A`:o`TB2_lA70X01ol92@X00olA70[o2@T:
o`T92P02o`T92P05o`TB2_l92@[o2A8:o`T92_lJ2@X01?l92@X00ol94P[o
2@T:o`T92P05o`T92P05oa4L2_l92@[o6PT:o`000?nEXHh0Goooool01?n_
[joobl_;omkNg_oZj^X1oo;blP000_o^k^h08?o/k>cog=cLogalO?oJf][o
gmoOon7QhOoDe=Coa/K6olc<c?o>c/kod=3@om?CdooEeMGoo?coooOiooon
o_koo__Zoo_ccooTe:?oV7i5ojN3AOnnT5Coc9QOomNRK?oLZGCogJihomff
OOoJ^WoofKZ1onG1SOoY`iCojlFH0_o]aY/00oo/aIcok<FNong6W`03on_4
W@;oj/>L0_oZ`iX00ooY`YWoj/>JonW4VP06onW4VP03onS3VOoYa9[ojLBJ
00;ojLBJ0ooZaI/@onW4VP;oj/FK00goj/BMonW4V_oY`icojLBJonW3W?oX
`iWoj/BMon[5VooZa9goj/FKon[4WOoZaI_oj/BM00;oj/FK023oj/FIon[5
VooZaIWoj/FKon[5VOoZaI_oj/FIon[5VooZaIWojLBJonW4V?oX`iWoil:F
onO2V?oW`YKogkjAomnmSooN^8Oog;=oomf^M_oLZVooeJ9Qol^JF?nlSdko
ZH97oiUkBOoTd:_onNgGoookl_ooo_ooo?ooookoo`Goj>SX00Oo<C4aogal
O?oYjNWoXZ:Roa@D5?o<c<coj^[Z00?ojn_[2Oo/k>`00oo[jn_okNg]ong]
k@02ong]k@04onc/k?o]kNgok^k^onk^kP;okno_00?okNg]ono_koo_knl0
1Oo`l?000oo_knool?3`oo3`l002oo3`l004ono_kooalO7olO7aoo7al@;o
lo?c0_odm?@01_oemOGom_KfooKfm_ofm_KoBTY:ofe]K@Oom_Kf00?omoOg
ooShn?ohn?P00ooinOT2oo[jnP03of5QHOlT92CojNWY00Soo?cl00?on_[j
ooclo?olo?`00_olo?`2oogmo@03oo_knooooooooooo00;ooooo00?oCDe=
og9bL_ooool00_ooool00om0@43oOgmoooooo`03ooooo`03ooclo?oooooo
oooo02_ooooo00Co7f2dojG4i_nidnooMjk[0_nYg?l01?m^KVko];Bdon3P
h?o/k>aKonk^kP06o`T92_lA9QCo2@T:o`TB2_l92@[o2A8:1_l92@X02OlA
70[o2@T:o`T92_lJ4QCo2@T:o`TB2_l92@[o2A8:oa4L2P02o`T92P03o`00
0?l94P[o2@T:00Go2@T:00Go0000o`TB2_l92@[o0000oa4L2P02o`T92P06
o`000?l94P[o2A8:o`T92_l0003o2@T:1_l94PX02?l0003o2@T:o`TB2_l9
2@[o0000o`TB2_l92@[o00001?l94PX2o`000007o`T92_l0003o2@T:o`TB
2_l0003o4A`:o`000003o`T92P07oa4L2_l92@[o2@T:o`T92_l0003o2@T:
o`TB2P03o`T92P03oa4L2_l92ACo2A8:00?o2@T:00Oo2A8:o`T92_l0003o
2A8:o`000?l92@[o000000?o2@T:00Oo0000o`TB2_l0003o2A8:o`T92_l0
003o2A8:00;o2@T:00Go2@TDo`T92_l92ACo2@TDo`TL5002o`T95003o`TB
2_l0003o2A8:00Co2@T:00Go2A8:o`T95?l971ko4BHDoaXB5002o`0000;o
2@T:0_l000002?l94P[o0000o`TB2_l0003o2@T:o`000?l92@[o2A8:0ol9
2@X2o`TB2P0Ao`TL7_l92ACo2A`Nob=1?Ol/EEco6PT:oa4_<ol971ko2@TD
oa4V7_l92ACo2@T:o`000?lA70[o2A8:oaXB5?l971@00_l000000ol94P[o
2@T:o`T92P02o`T92P05oa4L2_lJ4QCo8blNoa4V2_lS;ah00_l/C2T06?lS
;akoAUi7oeMWD_m6C3goAT4NodIE:Om6C3goH5hcodmWG?mPGS?oAUEBodmW
Aom6C3goH5hcocAE:Old;akoH5hcog9bNol/GSgo6PT:ohf=Kol/GSgo0000
o`T92P;o2A8:00?o0000o`TB2_l92@X03?l92@X00ol0003o2@T:o`T92P04
o`T92P0<oaX92_l92@[o2@T:oa4L2_l0003o2@T:oa4L2_l0003o6Q8Do`00
0?lJ2@[o2A8:1?l92@X01_lA70[o0000oa4L2_l92@[o0000ojJHQ5ook^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV02Goi>CTomCDe?mlO7co
fMWIon3Ph?oQhN7oeMGEolS8b?o;bl_oc/k>om3@d?oCdm?oe=CDoo_moooh
o?ooo_oooocjjooon=Wol=ncoiQmA_nRO3ko/XA6ol6>Coo?VEgoe:1VomFW
K?oF[W?oe[=iom>eNOoD]7_of[N1omfjQ?oO^hOog[Z8omfiROoN^X[ogkZ=
00?ohkjA00Gohkn?on:nS_oR_Xkoh[j>omnnR`08on2oS004omnnRooP_hco
h;n<on2oS0CohL2=4?oP_h`2on6oS`0=on6oTOoQ_hooh;j@on2nS_oP_Y3o
gkf=on6oTOoQ_hoohKnAon6oSooQ_i7ohKn?on6oT@02on6oS`0?on70SOoQ
_hoohL2=on6oSooQ`8gohKn?on70SOoQ_hoohL2=on6oSooP_hcogkf=omjm
R_oN_8cogKf<00;oekN800oof;:1omJ]MooFZ6goe:9Sol^HE_o1STco/X92
ojAl@OnGN4Wol]bgooofh?ooo_Goo_oooocoooonool01OoWinL01ola<C7o
O7alonSXj?oXj>SoNWYjobTY:OoNg]h01_oZj^X:on_[j`?ok>c/0_o]kNd3
onk^kP[okno_0oo`l?03oo7al@03oo?cloobl_;om?Cd00;om?Cd0_oemOD0
0oofm_Kof=SHomKFeP05ooKfmPGomoOg0oohn?P2ooWin@08onGUiOlo?coo
7AdMogQhN?nDU9CoLG5aobl_;onj^[X6oo[jnP;ono_k0_olo?`00oomoOgo
o_knooknoP02ooooo`03on3Ph?oNg]kooooo00;ooooo00?o@410ogmoOooo
ool0<Oooool01?lKGkKoY<CVokWCkomf[NX2oj_Po`04ofYZJ_n^[Zkof=SH
onCTi5_oi^KV00Co4A`:o`T95?l94P[o2@T:0ol94PX2o`T92P08o`TB2_l9
2@[o0000o`T92_l94P[o2@T:o`TB2_l00002o`TB2P03o`000?l94P[o2A8:
00Co2A8:0_l92@X01Ol94P[o2@T:o`T92_lA70[o000000;o2@T:00Co0000
o`T92_l92@[o2A8:0_l00003o`T92P;o00000ol92@X2o`TB2P;o2@T:00[o
2A8:o`T92_l92@[o0000o`T92_l0003o2A8:o`000?l92@[o2A8:0_l92@X0
1_l94P[o2@T:o`000?l94P[o2@T:o`TB2P;o2@T:00?o0000o`T92_l92@X0
0_l92@X05ol94P[o0000o`T92_l94P[o2@T:o`TB2_l92@[oH44Yo`TB2_l9
2@[o4A`:o`000?l92@[o0000o`TB2_l0003o2A8:o`000?l94P[o0000o`T9
5?l0003o2A8:00;o000000?o2@T:o`000?l92@X00ol92@X02?l92ACo2A`D
o`TB2_l92ACo4BHNo`TB2_l92@[o2A8:0_l92@X02Ol94P[o2@T:o`T92_l9
4P[o2@TDo`TB2_l971Co2A8:o`000002o`T92P03o`TB2_l0003o2@T:00;o
000000Ko2A8:o`T92_l0003o2@T:o`TB2_l00003o`T92P03o`TB2_l0003o
2@T:00;o2@TD00ooJW^4oa4_?OmGEE;o2BHYoa4_<ol971ko4BHNoa4_?Ol9
2@[o2A8:o`T92_lS;akoAT`mob<_:Ol92A@00_l92@X01_l94P[o0000o`T9
2_l92@[o4A`:oaXV50;o8blN00co4A`:ob<_:Old;bWo=5DYoba<:Old;c?o
AT`mocAE:Om6C3go?EhmodIED_m6C3d5odmWA`0;oceN?OlS;akoAT`mog:=
G?mkSFKo0000og:=G?l/C2Wo0000o`T92_l94PX00_l00004o`T92P03o`00
0?l92@[o2@T:01?o2@T:00Co4A`:o`T92_l92@[o4A`:1?l92@X00ol94P[o
2@T:o`T92P03o`T92P04oa4L2_l92@[o0000og9bNeooi^KV00CoWIfMokNg
]oo8b<Sodm?C0OoJf]X000;ok^k^02Kok>c/omcLg?mlO7cofMWIon3Ph?oQ
hN7oeMGEolO7aoo:b/[oc/k>om3@d?oCdm?oe=CDooWoooojo_ooo_oooocj
k_oooN?on>K2oiUmCOnMNCooYgTkokN4@oo6TDoocIYIom2RI_oCZg3odk1h
om6bNooE]WoofKZ3omfnR?oN_hWogKf:omblRooM_Hkog[j?ombkSP;og;b=
0_oK^hX2omZjR@03omVkQooJ_8Sof[b800Kof[b80ooI^hL2omZlR0?ofkf9
4?oJ_8P00ooK_H_ofkb=om^lS@02omZkS0?ofKZ;1ooK_8d;om^mR`;of[b:
01GofK^9omRjR?oG^HOoekV7om6bPooB/X?odjijom6XL?oAXfOocYeKolBA
ConhQdCoYgTkoimh@OnGN4[onnC4oooljOooooKoo_oooo_oooonool01OoW
inL00onPX:3o_[jnonWYj@02onWYj@03oiNGUoo0`<3oj^[Z00;oj^[Z0oo[
jn/7onc/k0KokNg]0_o^k^h5ono_k`_ol?3`0ooalO400ooclo?om?CdooKf
mP02ooKfmP[omoOg1Oohn?P2ooWin@0;ooShn?oinOWonOWiooWinOohn?So
[Jf]ogemOOmVIVKoQXJ6ojVYZOo[jn/01_ojn_X2oo_kn`;oo?cl00?ooOgm
ookno_ono_h01oooool00om0@43oOgmoooooo`0aooooo`04oa]N/onUa>Ko
]M3^ogV^k0;oYmco00CoKVi^okBd]?oPh>3ok>c/Foo^k^h02OlA70[o2@TD
oc@_<ol94P[o2@T:o`TB2_l92@[o2A8:o`T92P04o`TB2P05o`T92_l94P[o
2A8:o`T92_l94PX00ol92@X02Ol94P[o0000o`000?l92@[o2A8:o`T92_lA
70[o0000o`TB2P02o`T92P03o`TB2_l92@[o2@T:00Go2@T:00?o2A8:o`T9
2_l94PX01_l92@X01Ol94P[o2@T:oa4L2_l92@[o2A8:00Oo2@T:00Ko0000
o`T92_l94P[o0000o`T92_l00002o`T92P04o`000?l92@[o2@T:o`TB2P;o
2@T:00Oo2A8:o`T92_l94P[o0000o`T92_l94P[o000000?o2A8:00?o8bH:
o`T92_l94PX00_l92@X2o`TB2P0<o`000?l94P[o0000o`T92_l0003o2A8:
o`000?l94P[o0000o`T92_l92ACo00000_l92@X00ol94P[o2@T:o`TB2P03
o`T95003o`TB2_l971Co2A8:00?o2@T:1?l94PX01_l92ACo2A`No`T95?l9
2ACo2@T:o`TB2P?o2@T:00?o2A8:o`000?l94PX00_l000001Ol92@[o2A8:
o`000?l94P[o2@TD00?o2@T:0_l94PX03?l92ACo2@T:oaXV5?n3V:goCeiV
oeN=S_l94P[o2A`No`TL5?l971ko2A`Do`T92P;o4A`:00Oo2@TDodI<?OlS
;bWo2A8:o`000?l94P[o000000;o2@T:00Ko4A`:oa4V2_l/>2Wo;4`Yob<_
7_lJ4Q@3ob`h:@03ob<_:Om6C3go?Ehm00;oAUi700?oAVMLodmWAom6EE80
0_m?IdL2oeMWDP09oceN?Ol/9QCoAT`mofYW<omkSFKo2A8:ofYW<on3Q7_o
000000Wo2@T:00Go2A8:o`T92_lA70[o2A8:o`000003o`T92P03o`TB2_l9
2@[o2@T:00;o2@T:00?o0000oa4L2_l92@X01?l92@X01olA70[o2@T:o`T9
2_l92@[o6PT:o`T92_lA70X01?l92@X01?lA70[o2@T:o`T92_lS70X2o`T9
2P03oa4L2_l0003oPhAk05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
00;ooooo02GooOgmonc/k?mkNg_of][JomoOgooQhN7oeMGEolK6a_o:b/[o
c/k>om3@d?oCdm?oe=CDooWooooam_Woo?oooooon_ooo_7ooo3GokfSO_n?
KS_oXWTkojAe;on`P3KodJ5IolBHEooI/7SojLFComRhROoK_hooekf:omRn
SOoOa9Goh/NJon76VOoRaicoiLZO00?ohLFM0_oQaY/2on76V@;ohLJG1ooO
aiL2omk6UP04omo7UooPb9Soh<RHon79V@;oh/ZJ3ooPb9P00ooPb9[oglNK
omo7V`0?omo7V`OoglNI0_oTc9h2on?;W@0Eon79VooMaIOoeknAomBiS?oR
`iGoh;j@omJbO_oV_hKobIePol2CD_ngQdGoYWThohmU:onFL3oo_9mgoooi
g?oom>;onoS_ookoooofn__oo_oo00Ooj>SX0ooYjNT2on_[j`?okNg]2_o^
k^h7ono_k`Kol?3`2ooalO43oo;blP;om?Cd0oofm_H:ooOgm`gon?Sh2ooi
nOT2oo[jnP?oo?cl0_ono_h7ooooo`03oo_knoomoOgooooo037ooooo00Co
6enfojC4i_nhd^koMZgZ0_n/gol01?mfMWKo`L71oo3`l?omoOeKooooo`03
o`T92_lA9QCo2@T:00;o2A8:0ol92@X01_lA70[o2A8:o`TB2_l94P[o0000
oa4L2P;o2@T:00?o2A8:o`T92_l94PX01?l94PX00ol92@[o2A8:o`TB2P02
o`TB2P07o`T92_l94P[o2A8:o`000?lA70[o0000oa4L2P02o`T92P0:o`TB
2_lA9P[o2@T:o`000?l92@[o0000o`TB2_l92@[o4A`:o`0000?o2A8:00?o
2@T:oa4L2_l92@X00_l94PX00olA70[o6PT:o`TB2P02o`T92P07oa4L2_l9
2@[o2A8:o`000?l94P[o4A`:o`000002o`T92P04o`TB2_l92@[o2@T:o`00
00;o2A8:00?o0000o`TB2_l94PX01?l92@X01OlJ2@[o2A8:o`T92_l92@[o
2A8:00?o2@T:0_l000002?lA70[o0000o`TB2_l94P[o0000o`TB2_l0003o
2@TD0ol92@X01?l0003o2A8:o`TB2_l94PX2o`T92P06o`T95?l971ko2A8:
o`TL7_l971Co2@TD0ol94PX03Ol92ACo2A8:o`T92_l92ACo2A`No`TL5?l9
71ko2@TDo`T92_l0003o2A8:o`000?l94PX01ol92@X00ol94P[o2@T:o`T9
2P02o`TB2P03oa4L2_l92ACo2@TD00;o2A`D00Oo6Q`NodIWG?m?LW_o8d4m
o`TB2_l92ACo2BHY00;o2A`D00So2A8:oa4L2_lJ2@[o6Q`NoeMED_lS;bWo
2@TDo`TB2P;o2@T:017o4A`:o`TB2_l92@[o8blNoaXV5?lS;ako6Q8Dob`h
:Om6EBWoAT`modIE:Om6C3goCfM7odmWG?m?IdOo=5DmoeMWDP02oceN?@;o
AUEB0_ldEBT02?ld;bWo4BHDoc@_7_n`ZXCo2A8:odI<?OmkSFKo00001?l9
2@X2o`TB2PGo2@T:00Go4A`:o`T92_l92@[o2@T:oa4L2P02o`T92P04oa4L
2_l94P[o2@T:o`TB2P?o4A`:0ol92@X01_lS70[o4A`:o`T92_lA70[o2A8:
oa4L2P?o2@T:00Oo4A`:o`T92_lJ2@[o2@T:oa4L2_l92@[o4A`:00;o2@T:
00Co4A`:o`T92_l0003oUIRSGoooool01?n_[joobl_;omkNg_oZj^X1oo;b
lP000_o^k^h05oo/k>cog=cLogMgMooJf][oh>3Pon7QhOoDe=CoalO7olc<
c?o?clood=3@om?CdooFe]Konoomoo[oo?olooooooklooohmOoonNkoflJ[
ogmR>?n@K3;oUflY00;o]HTn00cojl:0omffOooG/XKokLfVonS<Y?oSbZ7o
i<^SonS?YooZd:_oilfZonO=[?oYcjh2on_@/P;ojm6`0_o[dJh2on_A[0So
j]:/0_oVcZP2onO?Z@04onS@Z_oYdJ_ojM6[on[B[13oj=2Z00?oj]:^on[B
/?oZd[003OoZd[08on[B[P03onK>Z_oUcJWoi<bX00;oiLfY01Coi<bXon;:
Y_oPaioojl^RonW7VOoZaY;ogKUoom>[KOn/Pd?oZH10oi9Z;OnBKCWoQfHk
omc2XOoon>3oook_oooom_oinoSomo_jookoo`Goi^KV1OoWinL00ooXj>So
jNWYon[ZjP05on[ZjPOojn_[0oo/k>`3ong]k@03ono_koo^k^kol?3`00;o
l?3`0_oalO4;oo;blPColo?c1?odm?@:ooGem@?om_Kf0_ogmoL2ooWin@04
ooShn?ojn_[on_[joo[jnP;ono_k3Oolo?`2oogmo@03ookno_oooooooooo
03_ooooo00Co7EncojK6i_nfd>koNJo^0_n[g_l01?m^KVko];Bdon3Ph?o/
k>aKonk^kP?o2A8:00?o2@T:o`T95?l94PX00_l94PX2o`T92P06o`000?l9
4P[o2@T:o`TB2_l92@[o4A`:0ol92@X00olJ2@[o2@T:o`T92P03o`T92P06
o`000?l94P[o2@T:oa4L2_l0003o2A8:2_l92@X01Ol94P[o2@T:o`T92_l0
003o2A8:00;o2@T:00Co0000oa4L2_l92@[o4A`:0ol92@X00ol94P[o2@T:
o`T92P03o`T92P08o`TB2_l92@[o2@T:o`T92_l0003o4A`:o`000?lA70X2
o`000006o`TB2_l92@[o2@T:oaXB5?l0003o2A8:1?l92@X01?l0003o2@T:
o`TB2_l00002o`T92P07oa4L2_l0003o2A8:o`T92_l94P[o0000o`T92P02
o`0000;o2@T:00Co2A8:o`000?l0003o4A`:0ol92@X01Ol94P[o2@TDo`TB
2_l92ACo2BHY00?o2@TD0_l94PX01_l92@[o2A8:o`TB2_l94P[o2@T:o`TB
2P?o2@TD00?o4BHNo`000?l92@X02?l92@X01Ol94P[o0000o`T92_l92@[o
000000;o2A8:1?l92@X02Ol94P[o2A`Noa4V7_l94P[o2A`Do`T92_l971ko
2@TDo`TL7P02o`T95008o`T92_l94P[o4A`:ob<_<old;c?o2A`Do`T92_l0
0002o`TB2P;o2@T:00?o4A`:ob<_7_lS;ah00_lS;ah06OldEBWo?EhmodI<
?OmGSEcoEfMBofZ=G?m?IecoCfM7oeMED_mPGS?o;4`YodIE:OldEBWo4BHN
oaX92_l/>2Wo0000ob<_7_mbIe;o4BHNohf=Aon3SHCoAT`mo`000?l92@X0
0_l94PX2o`T92P03o`000?l92@[o2@T:00Oo2@T:00?o4A`:o`T92_l92@X0
2?l92@X00ol94P[o2@T:oa4L2P04o`T92P05oaX92_l92@[o2@T:oa4L2_l0
00002Ol92@X00olA70[o0000ojJQV01Oonk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q0002onKViP04onCTi?oDe=CoMWIfomWIf@;ogmoO01ooe=CDolO7
aoo:b/[oc/k>om3@d?oCdm?oemOGoo_omooloo[onogloooooookm_[ooocj
ooogjOnXTG7oRF/gogEC4onAKB?o^I=:olBNGooofjKoi/>Konc;Z_oZcJgo
i/f^onO>/?oYckCojLnfonO=]?oVc;Goj<jg00Coj<fh0_oXc[L:onS>]@;o
ilfd0_oXc[D01?oYckKoj]2gon[@]ooZd;L@onW?]QSoj<jg01WokM>lon_A
^_oZd;Woj]2ioncB^oo]dkcok=:kongB]Oo[bjCoiL>EonO3SooXaHgohKf1
oj9n@_nAKSCoRFPcoh5R=_n]Tg;ooo?KoooijOooo?7oooohoooonoomooko
oooo00GoiNGU1OoVi^H2onSXj0Koj^[Z2_o[jn/3onc/k0;okNg]0oo^k^h:
ono_k`?ol?3`0ooalO400oobl_;olO7aoo;blP02oo;blP;olo?c2?odm?@3
ooGem@;om_Kf0oohn?P3oo[jnP;ono_k3Oolo?`2oogmo@03ookno_oooooo
oooo03_ooooo00Co6UbcojC3iOnhd^ooNJk/0_n/gol01?mZJV[o[Zj^omSH
f?oTi>AKonKViP06oaXB5?l0003o=2lco`TB2_l92@[o4A`:0_l92@X2o`TB
2PCo2@T:0_l00004o`T92P03o`TB2_l92@[o2A8:00Co2@T:00?o0000o`T9
2_lJ2@X01?l92@X02?l0003o2@T:o`T92_lA70[o2A8:o`T92_l94P[o0000
1?l92@X02ol0003o2@T:o`T92_l92@[o4A`:o`T92_lA70[o2@T:o`000?l9
2@[o2A8:00;o2@T:00?o0000o`T92_l94PX01Ol92@X01?l94P[o0000o`T9
2_l94PX4o`T92P04oa4L2_l0003o2A8:o`0000;o2A8:00?o2@T:oa4L2_l0
00000ol92@X00ol0003o2A8:o`000002o`00000@o`TB2_l0003o2@T:o`T9
2_l0003o2@T:o`000?l94P[o2@T:o`000?l92@[o2A8:o`T92_l94P[o2@TD
oa4L2P;o2A`D00Ko2A8:oa4V5?l92ACo2@T:o`TL5?l94PX2o`T92P07o`T9
5?l94P[o4A`:o`T92_lA;cgo2A`Noa4_<`02o`T92P04o`000?l92@[o2@T:
o`0000Co2@T:00?o0000o`TB2_l000000_l92@X01?l94P[o2@T:o`T92_l9
4PX2o`T92P03o`TB2_l971Co2A`D00;o2@T:00_o6Q8Do`TL5?lA;c?o2@TD
o`TV:OlA9QCo2@T:o`TB2_l92@[o4BHDo`TL5002o`TB2PCo2@T:00?o4A`:
oaXB5?lS;ah00olS;ah01olm;cgo?EhmoeMWD_mGIe;oJW9LodmWAomGIe80
0_ldEBT05_lA9Qko;2HDoc@_7_l94P[o=2lNoaXV5?l94P[o=2lNojJHKom6
IecoLVMBoiFHI_mbSCgoH5hcoa4V5?l92@[o0000o`TB2_l92@[o2A8:o`T9
2_lA70X6o`T92P03oa4L2_l92@[o2@T:00?o2@T:00?o4A`:o`T92_l92@X0
0ol92@X01?lJ2@[o2@T:o`TB2_lJ2@X2o`T92P03oaX92_l92@[o2@T:00;o
2@T:00Co4A`:o`TB2_l92@[o6PT:0_l92@X00olA70[o2@T:oa4L2P02oa4L
2P03oaX92_l0003ob]3105ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X0
00;ok^k^02Gok>c/omgMgOmbLW;oemOGomoOgooPh>3od];BolO7aoo:b/[o
c<c<om3@d?oCdm?oe=CDoooom_oloOOoo?kmookooookn_ooookoooomm?oc
hlcoXXeRogAI8_n7J2SoVGLgol:OIOoL^8KogKZBon?2XOoXbjgoilb_on[?
]?o/d;Sok=2jon_?^Oo[ck[okM6l00Gojljl0_o[ckX00oo[ckWojlnjon_?
^P08on_?^P?ok=2k0oo]dK`@onc@^aWojlnj01Soj/jionW=^?oYcKSoj/ji
onW=^?oWbkKoilV_omfkUOolfZcoi/FBomRgPOngUekoXH9;oh5V<OmeFRgo
ZI5_ooWUcOooo>gooogdooK_jOonnoKooookookooOooool5onKViP;oinOW
0ooXj>P2onWYj@?oj^[Z0oo[jn/7onc/k0KokNg]00?ok^k^ono_koo`l?00
1?o`l?0;oo7al@?ol_;b0_oclo<3ooCdm0[omOGe1Oofm_H2ooOgm`03ooKf
m_ogmoOomoOg00?omoOg2oohn?P2ooWin@?ono_k0_omoOdAooknoR[ooooo
00Co7EncojG4i_nfd^koNJkY0_nZh?l01?m^KVko];Bdon3Ph?o/k>aKonk^
kP06oa4L2_lJ4QCo2@T:oa4L2_l92@[o2A8:1?l92@X01Ol94P[o2@T:o`T9
2_l92@[o4A`:00?o2@T:00Co2A8:o`T92_lA70[o2@T:0_l94PX;o`T92P05
oa4L2_l92@[o2A8:o`T92_l94PX00ol92@X00olA70[o2@T:o`TB2P03o`T9
2P09oa4L2_l94P[o2@T:oa4L2_l0003o4A`:o`000?l92@[o2A8:00Co2@T:
00Ko4A`:o`T92_l92@[o0000o`T92_l00006o`T92P07o`TB2_l0003o2@T:
o`T92_l0003o2@T:oa4L2P02o`T92P08o`TB2_l92@[o2@T:o`T92_l0003o
2@T:o`000?l94PX3o`T92P06o`TB2_l0003o2A8:o`000?l92@[o00000_l9
2@X02ol94P[o0000o`T92_lJ4QCo8blcoa4_<om6GTOo2A8:o`TL7_l971Co
2@TD00;o2A8:00Co2@T:o`TB2_l92@[o2A8:0ol92A@00ol/71Co2BHYo`T9
5003o`TB2P?o2@T:00Go2A8:o`T92_l92@[o0000o`TB2P02o`T92P04oa4L
2_l92@[o0000o`TB2P;o2@T:0_l94PX00ol92@[o2@TDo`TB2P02o`TB2P;o
2A`N00?o4BHDo`TL7_lJ4Q@00_l92@X2o`TB2P04oa4V7_l92ACo2@TDo`T9
2P;o2A8:0_l92@X06_lA70[o6RHDob<_7_l/>2Wo8blYodI<?OmPGS?oJW9L
og^=I_m6EE;oAUDYoc@_:OlS9P[o4A`:o`000?mP;aCo4BH:o`T95?l92@[o
LXdmo`TB2_lA9P[oLVMBoeN=G?ld;akoUIQV0_l94PX01?nEV6KoAT4No`TB
2_l00002o`T92P03o`TB2_l0003o2@T:00?o2@T:00?o6PT:o`T92_l92@X0
0ol92@X00olA70[o6PT:o`T92P03o`T92P07oaX92_l92@[o2@T:o`T92_lJ
2@[o2@T:o`000003o`T92P05ob<L2_l0003o4A`:o`TB2_lJ2@X01?l92@X0
2OlS70[o2@T:o`TB2_lJ2@[o2@T:oa4L2_l94P[o0000ohfHSP1Oonk^kP04
oj>SXonm_Kgoclo?om[JfP7ohN7Q0002ooooo`04oogmoOo_knooLg=colo?
c`;ogMgM01godM7AolC4a?o8b<Sobl_;olo?cooBd];oe=CDoooon_ooo_[o
oooooo_looojoOoon__mooOdkoooongoooCGohQeBom`ERGoV7Y6ok6AG_o:
Z7[olM2UomNgT?oO_Y_ohL>QonG6YooVajSoi/NZonK7Z`02onO7[P?oilN`
0_oWajh3onO8[0Soi/R^1?oTaZ`4onG7[A3oi<J/6?oVb:h3on?5Z`;oi<J/
01Coh/BZomk0Y_oK_9godk28onO5UooE]87od;5koib1B_m`FBGoIU4Toh=a
COool]Wooog]ookckOoooO_oookmoocknOoloOSooookooooo@GoiNGU1OoV
i^H00ooXj>SoinOWonWYj@05onWYj@[oj^[Z0oo[jn/00oo/k>cokNg]onk^
kP02onk^kP[okno_0oo`l?03oo7al@;ol_;b0ooclo<2ooCdm0SomOGe1Oof
m_H2ooShn003ooOgmooinOWonOWi00?onOWi2oojn_X2oo_kn`?oo?cl0_om
oOdAooknoR[ooooo00Co6ejcojK6i_nidnkoNJk[0_n[gol01?mfMWKo`L71
oo3`l?omoOeKooooo`05o`TB2_lA70[o2A8:o`T92_lA70X01?l94PX00olA
70[o2@T:o`T92P02o`T92P08o`TB2_l92@[o2A8:o`T92_l94P[o0000o`TB
2_l92@X2o`TB2P03o`000?lA70[o2@T:00_o2@T:0_l94PX3o`T92P04o`00
0?l92@[o0000o`0000Go2A8:00?o2@T:oa4L2_l94PX00_l92@X02?l0003o
2A8:o`T92_l94P[o2@T:o`TB2_l0003o4A`:1?l92@X00ol0003o2@T:o`T9
2P05o`T92P03o`000?lA70[o2A8:00?o2@T:00?o2A8:o`000?lA70X00_l9
2@X02ol0003o2A8:o`000?l94P[o0000o`TB2_l0003o2@T:o`000?l92@[o
000000;o2@T:00Go2A8:o`T92_l94P[o0000odmWG002o`T92P05odIED_l9
71Co2A`Do`T95?l000000ol92@X03Ol0003o2A8:o`T95?lA9QCo2@TDob<_
:Olm;cgo8blco`TB2_l971Co2@T:o`000?l94PX00_l92@X00ol0003o2A8:
o`TB2P02o`T92P07o`000?l92@[o2A8:o`TB2_l92@[o0000o`TB2P02o`T9
2P03o`000?l94P[o6Q8D00;o2@TD00?o2A`Do`T95?lA9Qh00_l971@02_l9
2ACo2A8:o`T92_l92@[o2A8:o`TL5?l92ACo2A`Do`TB2_l00002o`T92P0E
oa4L2_lA9P[o6Q8Doa4V2_l/C2Wo=5DYodI<?Om?IdOoAUDYocAE:OlS70[o
2A`Doa4L2_l92@[o6Q8Do`T92_ldEBWo2@T:oa4L2_mZIc?o=2lN00;oAT4N
00WoJXeLoc@_7_n`ZXCo0000o`T92_lJ2@[o;4`YojJQI_l000000_l94PX9
o`T92P04oa4L2_l94P[o2@T:oa4L2PGo2@T:00Co4A`:o`T92_l92@[o2A8:
0ol92@X2oa4L2P06o`T92_l94P[o2@T:oa4L2_l92@[o6PT:0ol92@X02olA
70[o2@T:o`T92_l92@[o6PT:oa4L2_lJ2@[o4A`:oaX92_l0003oYZ6H05oo
oooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000;ok^k^00[okNg]on3Ph?mj
NW[o_knoomSHf?oJf][oc<c<ol71`Oo5aLGob/[:0_o>c/h01OoDe=Coooco
ooonooooooool?Cg00;onooo01;ok_3[oooom?oooncooo7GohigEomaEBko
QVHmojZ9G?n^SF3oeKF6oln_P?oF]HSof[V<omZiS_oH]hkofKNAomZhT_oI
]i85omRfT@?of;J@00?oekNAomNfTooG]Y<07?oG]Y<2omNgT@0[omNgT?oG
]i7oekN@omNgTOoG]i3oekNAomNgT?oG]i7oekN@omNgTOoG]i3oekNAomNg
T?oG]i7oekN@omNgTOoG]i3oekNAomNgT?oG]i7oekN@omNgTOoG]i3of[ZD
omZjTooL_9Kog[jGomnoVOoM_IKof;RBomJdS_oK]XcobZEhokNGI_nOPDgo
QFhjofMC8On^WgKon^oAooonkOoonO7ooogmooObmP02ooono`03ooOhlooo
oo_oooom00Goi>CT1OoUiND2onOWi`KojNWY2_oZj^X4on_[j`Cok>c/2_o]
kNd6onk^kP03oo3`l?o_knoolO7a00ColO7a2?obl_83oo?cl`;om?Cd0_oe
mOD01?ofm_KomoOgooOgmoogmoL2ooShn0_onOWi0_ojn_X3oo_kn`;oo?cl
4?omoOd3ooknoRSooooo00Co7f6doj?2i?nhdnooMjk[0_nZgol01?m^KVko
];Bdon3Ph?o/k>aKonk^kP04oaXB5?l94P[o2@TDoa4L2P;o2@T:00?o2A8:
oaXB5?l92@X00_l92@X02?lA70[o2A8:oa4L2_l94P[o2@T:oa4L2_l94P[o
4A`:0ol92@X01?l94P[o0000oa4L2_l0000<o`T92P04o`000?l92@[o2@T:
o`0000;o2@T:00Co2A8:oa4L2_l92@[o2@T:0_l000000ol94P[o2@T:o`TB
2P04o`T92P04o`TB2_l92@[o2@T:o`0000;o2A8:00Co0000o`TB2_l0003o
2A8:1_l92@X00ol0003o2@T:o`T92P02o`T92P03o`000?l94P[o2@T:00;o
2A8:0ol92@X2o`0000;o2@T:00Go2A8:o`000?l92@[o0000o`TB2P03o`T9
2P04o`T95?l92@[o0000o`0000;o2@T:00Ko0000ob=1?Old;bWo6Q8Dob`V
5?lJ4Q@2o`T950?o2A8:0_l92@X00ol92ACo0000o`TV:@02oaXL7P04odIE
D_l/EEco2A8:o`TB2P;o2@T:00?o0000o`TB2_l000000_l92@X01Ol0003o
2A8:o`000?l92@[o000000So2@T:00Co2A8:o`T95?l971Co2A8:0_l92A@0
1OlA9Qko2A`No`TL5?l92@[o000000?o2@T:00Go2A`NoaXB5?l92ACo0000
o`TB2P02o`T92P04oa4L2_lJ4QCo6RHDob`h:@;oCfM700Co?Ehmoa4V2_l0
003o4A`:0ol92@X2oa4L2P0>ob`B0?lS70[oAUDYofYW<olS;bWoEeEBoiFQ
S_mkSFKo0000ok2ZQ?lA9P[o0000o`T92_l00002odI17P05og:=?Ol0003o
2A8:o`T95?l000000_l92@X00ol0003o2@T:o`T92P0Co`T92P03oaX92_l9
2@[o4A`:00;o2@T:00?o6PT:o`T92_l92@X00_l92@X2oaX92P09o`TB2_l9
2@[o2@T:o`T92_lJ2@[o2@T:oaX92_l0003oYZ6H05ook^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN4000;oi^KV02GoiNGUomgMgOn>SXkoY:BTom;Bd_oD
e=Co`/;2okRh^?o0`<3oa<C4olW9bOo;bl_od=3@ooohooooo?ooo_goooOk
o?oioooon?omooWon_olooSoo?S]ooomlOoom^GoWhE/ohQ[BOmjFS7oS6`k
oiMh?on_SE3o^9IGokjLGOnmVeko_9UOoknLI?o1WVKo`9eW00Go_IYT0onm
VV88ok^JIASo_IaW037o^iYTok^KH_nkVVCo^i]Rok^JI?nkVf;o^iYTok^K
H_nkVVCo^i]Rok^JI?nkVf;o^iYTok^KH_nkVVCo^i]Rok^JI?nkVf;o^iYT
ok^KH_nkVVCo^i]Rok^JI?nkVf;o^YUSokZJHOnjVF?o_9aSokfLI_nlW6?o
^IQRokRDH?nLMTWoWgY=ohe]??mVBQSoL5XXoinAI?oll/kooooXoo[fjoof
mO?oookooo7`n?ohmocooooooooonooooo[oooom00OohN7Q0ooRh^800ooT
i>Cohn?SonGUi@02onGUi@[oi^KV1ooWinL6onSXj0_ojNWY0ooZj^X00oo/
k>cojn_[ong]k@02ong]k@[ok^k^1oo_knl6oo3`l0SolO7a0oobl_82oo?c
l`?omOGe0_ogmoL3ooShn0[onOWi0oojn_X3ooclo0;oo_kn9_ooool01?lO
H;CoYLCVokWCkomg[^/2ojWLo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV0ol9
4PX01_l92@[o4A`:o`TB2_l92@[o4A`:o`T92P;o2A8:1?l92@X00ol94P[o
0000o`T92P03o`T92P03o`TB2_l0003o2@T:00?o2@T:00Oo4A`:o`T92_l9
2@[o2@T:o`TB2_l92@[o4A`:00?o2@T:00Co2A8:o`T92_lA70[o00000_l9
4PX00ol0003o2@T:o`T92P02o`T92P05o`TB2_l92@[o2A8:o`000?l94PX0
0_l92@X01Ol94P[o0000o`T92_l0003o2A8:00Go2@T:00Oo2A8:o`000?l9
2@[o0000o`T92_l0003o2A8:00;o2@T:00Ko0000o`T92_l0003o2@T:o`TB
2_l00002o`T92P07o`000?l92@[o2@T:o`000?lA70[o2A8:o`T92P02o`00
00Co2@T:0_l000001?l92@[o0000o`000?l94PX2o`T92P0:o`000?l92@[o
2A8:ob<_7_lJ71ko0000odIED_l92ACo2A8:o`T92P;o2A8:0_l92@X03Ol9
2ACoAUEBodmNI_mbLW_o?Blmo`U1Aol99RWo2@T:o`TB2_l92@[o0000o`TB
2_l000000ol92@X00ol94P[o2@T:o`TB2P02o`T92P03o`000?l92@[o2@T:
00Ko2@T:0_l94PX2o`T95004o`T92_lA;c?o2@T:o`TB2P?o2@T:00Go2A8:
o`T95?l92ACo4BHDo`TB2P03o`T92P;o4A`:01Wo6RHDob`h:OmPGS?o=5DY
oaXV5?l0003o2@TDo`T92_l94P[o2@T:oa4L2_lJ2@[o6Q8Dob`V5?ld;ako
H5hcoh=kG?mGIe;oLXdmol6cS_l/GSgo0000ol6cS_l971ko000000;o2@T:
0_l000001on3Nc?oAT4Nohf=Aol0003o4A`:o`T92_l000002ol92@X00olJ
2@[o2@T:o`T92P02o`T92P05oa4L2_l92@[o6PT:o`T92_lJ2@X01Ol92@X0
1?lJ2@[o2@T:o`T92_lA70X8o`T92P06oaX92_l0003o4A`:oaX92_l0003o
UIRSGooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000oo^k^h01OoYjNWo
aLG5oh>3Pon/[:co_;bl00;o[Zj^01_o][Jfokbl_?no_kooa<C4olW9bOoo
n_oooo_oooWgo?oloooomoolon_hkoohoo[onOohoo_jmOoon?7ooo_aoooj
j?oom]Soo^6goj20COn4I2OoLU4<ogiL5?n6I1goQfDNohQU8on<JBL00_n?
K2`2ohiZ;0CoSV/[00?oSV/Yohi[:on=Jb`02_n=JbhDohaZ;@03ohaZ:on=
JbcoSF/[01KoSF/[01WoTFl_ohm];On=Jb_oS6XZohe[:on<JR[oRfTYohUW
:_n0EbWoPE/^ojF5E_ooj[Woooo=ooooe?ooo]gooo_Uoooon?ooooool?3h
ooknooooo_oono_koooonooooo[oooom00Gog=cL1OoMgMd2omoOg`KohN7Q
2_oRh^83on?Sh`;oi>CT0ooUiND:onKViPKoinOW0_oXj>P5onWYj@_oj^[Z
0_o[jn/2onc/k004ong]kOo^k^kok^k^onk^kP[okno_1Oo`l?03oo7al@Go
l_;b2?oclo<2ooCdm0?omOGe0oofm_H2ooOgm`?on?Sh2_oinOT3oo[jnP?o
o?cl0_ono_hAooooo`04oa]O]_nTa>Ko^M?_ogJ]jP;oZn3o00CoKVi^okBd
]?oPh>3ok>c/Foo^k^h2o`T950;o2A8:0_l92@X01?lA70[o2@T:o`T92_lA
70X5o`T92P04o`TB2_l92@[o2@T:o`TB2P?o2@T:00?o6PT:o`T92_l92@X0
0_l92@X2o`TB2POo2@T:00?o2A8:oaX92_l000000ol92@X00ol0003o2@T:
o`T92P06o`T92P04oa4L2_l0003o4A`:o`0000;o2@T:00?o2A8:o`000?l9
2@X00_l94PX3o`T92P03o`000?l94P[o2@T:00;o2@T:00?o0000o`T92_l9
2@X00_l92@X00olA70[o0000o`T92P03o`T92P03o`TB2_lA70[o000000;o
2@T:00Oo0000o`T92_l92@[o2@T:o`TB2_l0003o2A8:00Go2@T:00Co2A8:
o`T92_l0003o00000_l92@X02_l94P[o2@TDoaXB5?l92@[o8blYob=1?OlJ
4QCo2@TDo`T92_l92A@2o`T92P06o`TB2_l0003oLXf4o`T95?n3Q8ko;5E_
0ol971h2o`T92P06o`TB2_l0003o2@T:o`T92_l94P[o00000_l92@X01?l9
2ACo0000o`TB2_l94PX6o`T92P03o`TB2_l92@[o2A8:00;o2@TD00?o4A`:
o`TL7_l971h00_l92A@04ol94P[o2@T:o`T92_l94P[o2@TDo`TB2_lA;c?o
2A`Do`000?l92@[o2A8:o`T95?lJ4QCoAUDYoceN?Ol0003o2A8:oaXB5?lJ
2@X00_lA70X04_l94P[o4A`:o`T92_lA70[oAT4NodI<?OmZIc?oSHe_odmW
AomPGS?oYZ6HodIWG?l0003oPg]LoiFQS_mbSCgo0000o`TB2P?o2@T:00Go
0000ojJHKom6EBWo=2lNoa4V5003o`T92P03oaXB5?l92@[o4A`:00Go2@T:
00?o6PT:o`T92_l92@X00_l92@X00olA70[o6PT:o`T92P05o`T92P03oa4L
2_lJ2@[o2@T:00Go2@T:0_lA70X03?l92@[o4A`:oaX92_l92@[o4A`:oaX9
2_l92@[o4A`:oaXB5?l94P[o0000ojJQV5ook^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN4000?ooooo00_ooOgmooCdm?ng]kOoNGUioh20P?n?ShooW9bL
ojFUYOn/[:co/K6aokNg]`0>ok^k^`?o_;bl0onm_Kd00onn_[ko_Kfmokjn
_P02okjn_P;o_kno2oo0`<02ol71`@;o`/;200Co`l?3olC4a?o4a<Coa<C4
2_o5aLD5olK6aP;oalO700?oa/K6olO7aoo7alL00oo7alL=olS8b003olW9
bOo:b/[ob/[:00oobl_;0oo<c<`00oo=cLgoc<c<olc<c002olg=c@_oc/k>
0_o?cll3om3@d003om7AdOoBd];odm?C00;odm?C0ooDe=@7omGEe@Koe]KF
0_oGemL5omSHf0_ofMWI0ooJf]X2om_Kf`?og=cL2_oMgMd5omkNgP;ogmoO
00?og]kNomoOgooOgml00ooOgml8on3Ph0?ohN7Q0_oRh^82onCTi003onGU
iOoWinOoinOW00?oj>SX2_oYjNT3on[ZjP?ok>c/0_o^k^h;ono_k`;ol?3`
0ooalO400oobl_;olO7aoo7al@02oo;blP?olo?c3_odm?@01?lJGK;oYLCV
okG@k_mi[^`2ojOLo`04ogIfM_o1`L7ol?3`oogmoE_ooooo0_lJ4Q@3o`TB
2P03oa4L2_l94P[o2@T:00;o2@T:00?o4A`:o`T92_l92@X01ol92@X00ol0
003o2@T:o`TB2P05o`T92P04o`000?l94P[o2@T:o`TB2PWo2@T:00So2A8:
o`T92_l92@[o2@T:o`000?l94P[o2@T:o`TB2P;o2@T:00?o0000o`TB2_l9
4PX00_l92@X00ol0003o2@T:o`T92P03o`T92P06o`000?l94P[o2A8:o`TB
2_lJ2@[o00000_l92@X01_l94P[o2@T:o`T92_l0003o2@T:o`0000;o2A8:
1?l92@X00ol94P[o2@T:o`TB2P04o`T92P08o`TB2_l0003o2@T:o`T92_l0
003o2@T:o`TB2_l00002o`T92P05o`000?l94P[o2@T:o`T92_l000000_l9
2@X00olJ4QCo2@TDoaXB5002o`TL7P04o`T95?lJ4QCo2A8:o`T92P;o2A8:
00So0000og9bNolm;cgoUIRSo`T95?lA9P[o2@TDoaXB50;o2@T:00go2A8:
o`T92_l0003o2@T:o`000?l92@[o0000o`T92_l0003o2@T:o`000?l92ACo
2A8:00Co2@T:00_o2A8:o`T92_l92@[o2A8:o`T95?l94P[o2@TDoa4_<ol9
2ACo4BHNo`TB2P03o`T92P0So`T95?lA9Qko2A8:o`TV:Ol94P[o2@T:o`TB
2_lA70[o6PT:odI17_l/C2Wo0000o`T92_ld;ako6RHDoa4L2_l92@[o2@TD
oaXB5?l92ACo=2lNodIE:OmbIe;oLXdmog9WD_mbSEcoNheVojJQV?mGSEco
0000oiF=D_mZIc?oUHABohf=KolA9Q@00_l92@X01_l94P[o2@T:o`T92_lS
9P[o^IQLodmWA`?o2A8:0_l92@X00olA9QCo2@T:oaXB5002o`T92P03oaX9
2_l92@[o2@T:00go2@T:00Co4A`:o`T92_l92@[o4A`:0ol92@X01OlJ2@[o
8a`:oa4L2_l92@[o6Q8D00;o2@T:00Oo6PT:oa4L2_l92@[o8a`:oaX92_l9
2@[oYZ6H05oooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000Cok^k^00[o
jn_[on3Ph?nh^;SoPH61og1`L?mhN7SoRh^;oi:BT_nIVIWoXJ6Q3_nVYZH6
ojNWY`03ojRXZ?nYZJWoZZZZ00CoZZZZ2?n[Zj/3ojb/[0;o[Jf]0_n^[Zh0
1?n][Jgo[Zj^ojj^[_n^[Zh2ojn_[`go/;2`0_na/K400onb/[;o/k>cok>c
/`0;ok>c/`;o];Bd0one]KD00onf][Ko]KFeokFe]@02okJf]P?o]kNg2_nh
^;P3okVi^@03okZj^_nk^k_o^k^k00;o_;bl2onm_Kd5okjn_P03ol30`?no
_koo`L7100Go`L712_o2`/84ol?3``Coa<C42_o5aLD6olK6aP03olO7aoo6
a/KoalO700CoalO72?o8b<P3olW9b@;ob/[:0oo<c<`3olk>cP;oclo?2oo@
d=02om7Ad@?od];B0_oCdm<;omCDe0GoeMGE0ooGemL5omWIf@Sof][J0_oK
fm/3omcLg0?ogMgM0_oNg]h3omoOg`koh>3P00Co65bbojC4i_nhd^koMZgZ
0_n/gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP;o2A8:00co2@T:o`TB2_l9
2@[o2A8:o`T92_l94P[o2@T:oa4L2_l92@[o2A8:o`T92_lA70X3o`T92P03
o`TB2_l92@[o4A`:00?o2@T:00Oo2A8:o`T92_l92@[o4A`:o`000?l92@[o
2A8:00?o2@T:00?o4A`:o`T92_l94PX01_l92@X02_l0003o2A8:o`T92_l9
2@[o2A8:o`000?l94P[o0000oa4L2_l92@X3o`TB2PCo2@T:00?o0000o`T9
2_l92@X00ol92@X01?l0003o2A8:o`T92_l92@X2o`TB2P;o2@T:00Co0000
o`TB2_l92@[o2A8:0_l000003Ol94P[o2@T:o`T92_l94P[o2@T:o`000?l9
4P[o4A`:o`000?l94P[o0000o`TB2_l92@X00_l000001_lA70[o0000o`TB
2_l92@[o0000o`T92P;o000000?o2@T:o`TB2_l92@X01Ol94PX00ol971ko
2A`Do`T92P02o`TB2P;o2@T:00Co2A8:obaEG?n3V8ko;6ML0_l971h00ol9
4P[o2A`No`TB2P02o`T92P03o`000?l94P[o000000;o2A8:00?o0000o`TB
2_l92@X00_l92@X2o`000004o`TB2_l92@[o2A8:o`TB2P;o2@TD00Wo2A8:
o`T92_l971Co2@TDoa4V5?lA;cgo4BHDo`TL5?l92A@00_l94PX2o`T92P03
o`TL5?l971ko2A`D00?o2@T:01ko4A`:ob`h:OlA9QCo0000o`T95?lJ2@[o
8blNob<V2_l/9QCo2A8:oaXV5?lJ71koJUDNog^=I_n=SE;oJW]_oeMWD_m?
IdOoYZ6HoiFQS_n=SFoo0000oiF=D_m?IdOoJUDNohf=Aon=SFoo;4`Yo`00
0?l94PX2o`T92P07o`000?m6EBWoAUDYoiF=D_ld;bWo2@T:o`T95004o`T9
2P03oa4L2_l92@[o2@T:00;o2@T:00Co4A`:o`T92_l92@[o4A`:1_l92@X0
0olA70[o2@T:o`T92P02oa4L2PGo2@T:00Oo4A`:o`T92_l92@[o6Q8Dob`h
:OlJ2@[o4A`:00Co2@T:00Co6Q8Do`T95?l0003oYZZ]Goo^k^h01?nSXj?o
_Kfmolo?cooJf]X1on7Qh@001?oVi^H02?oTi>Coh>3Pom;Bd_nl_;coX:2P
ohR8R?miNGWoLW9boom^KVh=ofi^KP09ofQXJ?mUIFGoGemOoeQHF?m:BT[o
2e2UojK6i_nfd>koNJo^00;oZmko00CoJVYZojj^[_oHf=Soi>CTFooVi^H0
1olJ4QCo2@T:oa4L2_l0003o4A`:o`T92_l94PX00_l92@X00ol94P[o0000
o`T92P03o`T92P05oa4L2_l92@[o4A`:o`T92_lA70X00_l92@X01OlA70[o
2@T:o`T92_lA70[o000000;o2@T:00?o4A`:o`T92_l92@X00ol92@X01Ol9
4P[o2@T:o`T92_l94P[o000000?o2@T:00?o0000o`T92_l92@X01?l92@X0
1_l94P[o0000o`T92_l0003o2@T:oa4L2P;o2@T:00?o2A8:o`T92_l92@X0
1_l92@X2o`TB2P06o`000?l92@[o0000o`T92_l94P[o00001Ol92@X00ol9
4P[o0000o`T92P02o`T92P03o`TB2_l0003o2A8:00?o2@T:00Wo2A8:o`T9
2_l92@[o0000o`T92_l0003o2A8:o`000?l94PX00ol92@X01Ol0003o2@T:
o`TB2_l0003o2@T:00?o2@TD00?o2A8:o`T95?l94PX00_l92@X01_l94P[o
2@TDo`000?lS@Cgo2D57oa4_<`;o2@TD00Co6Q`No`000?l94P[o00000ol9
2@X2o`000005o`T92_l0003o0000o`TB2_l000000_l92@X01Ol94P[o6Q8D
o`TB2_l92@[o6Q8D00?o2A8:0_l92A@03Ol971ko8d4mo`TL5?l92ACo2A8:
o`T92_lA70[o2A8:oa4_<ol971Co2A`No`TB2_l000000_l92@X03Ol94P[o
2@T:o`T92_l94P[o2@T:oa4L2_lS9P[o6RHDob<V2_lJ9QCoAT4Nohf=Aon=
V8h00_mZNfl03_mPGS?oSHe_ojJQV?n3Neco4BH:o`000?mZIc?oEheLob<L
2_mZEAkoYZ5VojJQV?mbSEco00000_l92@X02ol0003o2@T:o`000?mP@BWo
NheVog:=?Om6EBWo2@T:o`TB2_l92@[o4A`:00;o2@T:00Ko4A`:o`T92_l9
2@[o4A`:o`T92_lJ2@X4o`T92P04o`TB2_l/4P3o2@T:oa4L2PKo2@T:01?o
4A`:o`T92_l92@[o;180o`000?lA70[o2@T:o`TB2_l92@[o4A`:o`T95?l9
2@[o4A`:o`T92_lA70[o6PT:o`T92_l0003oYZ6H05ooi^KV00CoWIfMokNg
]oo8b<Sodm?C0OoJf]X000Cok^k^00[ojn_[on3Ph?nh^;SoPH61ofe]KOmd
M7CoPX:2ohN7Qon=SHgoUIFE3_nJVYX6oi^KV`;oW9bL1OnMWId;oijNWP;o
WinO0_nPX:001?nOWiooX:2Poj2PX?nPX:0=oj6QX@;oXZ:R0_nSXj<00onT
Y:CoYJFUojFUY@03ojJVYPSoYjNW1OnXZ:P00onYZJWoZ:RXojRXZ005ojVY
Z@[oZZZZ0on[Zj/00on/[:co[Jf]ojf][@02ojf][@_o[Zj^1On_[jl2ok2`
/0Ko/K6a2_nb/[83ok>c/`03okFe]Ond];Co][Jf00;o][Jf2_ng]kL=okRh
^0So^KVi1Onj^[X3okbl_0?o_[jn0_no_kl;ol30`0;o`L710oo2`/82ol?3
``_oa<C41Oo5aLD00oo6a/KoalO7olO7a`05olW9b@Sob/[:0_o;bl/3olc<
c003olg=cOo<c<coc<c<00;ocLg=0oo>c/h>olo?c`04oaMI[onT`nGo^=;_
ogV^k0;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h00ol94P[o2@T:o`TB
2P03o`T92P04oa4L2_l92@[o2@T:o`TB2P?o2@T:00?o4A`:o`TB2_l94PX0
0_l92@X01?lA70[o0000o`TB2_lA70X3o`T92P;o2A8:1?l92@X01_lA70[o
2@T:o`T92_l92@[o2A8:o`T92PCo2A8:0_l92@X00ol94P[o2@T:o`T92P02
o`T92P03o`TB2_l0003o2A8:00;o2@T:00?o4A`:o`T92_l92@X00_l92@X0
1?l94P[o0000o`TB2_l94PX3o`T92P08o`TB2_l92@[o2A8:o`T92_lJ2@[o
2@T:oa4L2_l92A@5o`T92P03o`TB2_l92@[o2@T:00;o2@T:00Co2A8:o`T9
2_lJ2@[o00000ol92@X00ol94P[o2@T:o`000002o`T92P05o`TB2_l0003o
2@T:o`T92_l000001?l92@X00ol94P[o2@T:o`T92P02o`TB2P03o`T95?l9
4P[o2A8:00;o2A`D00co2A8:o`T92_l94P[o2@T:o`T95?lA9QCo2A8:o`TV
:Ol92@[o2A`Doa4_<ol00003o`T92P;o2A8:0ol92@X01OlA70[o2A8:o`T9
2_l92@[o000000;o2@T:00Co6RHDoaXB5?lJ71ko6Q8D0_l971@04?l94P[o
2@TDoaXB5?lA9Qko4Blco`TB2_lJ4QCo2A8:o`T92_l94P[o2@TDo`TV:Ol9
71Co6RHDo`000?lA70X6o`T92P0>oa4L2_lA9P[o6RHDob<V2_l/>2WoAT4N
oh>4Non3SHCoJW]_og:=G?n=SFooLXdmocAE:OlA9PX2o`000006o`TB2_n=
SFoo0000ob<V2_m6@AkoPehD0_nVV6l03?l0003o2@T:o`T92_l92@[o2A8:
oa4L2_l0003oPehcok2ZQ?n3Nc?o0000oa4L2PGo2@T:00Ko4A`:o`T92_lA
70[o4A`:o`000?lS70X2o`T92P0Noa4L2_l92@[o2@T:o`T92_lA70[o2@T:
oaX92_l92@[o6PT:ob`B0?lJ2@[o2@T:oa4L2_lJ2@[o2@T:ob<L2_l92@[o
6PT:o`T92_l0003o6Q8Doa4L2_lJ4QCo2@T:oaX92_lA70[o6PT:oa4L2_l0
003oYZZSGoo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000oooool02oom
oOgom?CdokNg]omgMgOoOWinohb<S?nJVY[oXj>SojZZZ_nb/[;o][Jf017o
^;Rh1?omoOd2ooglo@?ooOgk00OooOgioo[lmoocn?7okoC]on_`jOoRjN7o
f^;G00CoeMg@1?oDg<lhomGMd0Soe]cB1ooGgM<02OoFg]7oe=g:omSQc?oQ
j=SojNoQoo?fkoohn_OooOgmooglo@03oogko@03oogloOomoOgooOgm00;o
oOgk00?ooOgmom?CdooCdm<01ooCdm<6omCDe0;oeMGE1OoFe]H>omOGe`;o
f=SH3OoIfMT3om[JfP;ofm_K0ooLg=`3omgMg@;og]kN2ooOgml2on3Ph0?o
h^;R0_oTi>@;onGUi@;oinOW0ooXj>P00ooZj^[ojNWYonWYj@02on_[j`?o
k>c/2?o^k^h2ono_k`?ol?3`0oobl_82ooCdm0?omOGe3_ofm_H01?lLG[;o
YLCVokKBk_mi[^T2oj[Po`04ogIfM_o1`L7ol?3`oogmoE_ooooo00Co6Q8D
o`T95?l92@[o2@T:0_lA70X00ol92@[o4A`:o`T92P0:o`T92P03oa4L2_l9
2@[o2@T:00?o2@T:00?o2A8:o`T92_l92@X01Ol92@X02_lA70[o2@T:o`00
0?lA70[o2@T:o`000?l94P[o0000o`TB2_l92@X2o`0000;o2A8:00?o0000
o`T92_l92@X00_l92@X00ol94P[o0000o`TB2P05o`T92P05o`000?lA70[o
0000o`T92_l000000_l92@X02ol0003o2@T:o`T92_l92@[o0000o`T92_l0
003o2A8:o`T92_l0003o2@T:00;o000000Ko2A8:o`T92_l92@[o2@T:o`00
0?lA70X4o`T92P09oaX92_lA70[o2@T:o`T92_l94P[o2@T:o`000?l94P[o
000000;o2@T:00?o0000o`TB2_l92@X01Ol92@X01Ol92ACo2A8:o`T95?l9
2ACo2A`N00;o2@T:0_l94PX2o`T95006oa4V7_l971ko2A`Do`TL7_l99RWo
00000_l92@X00ol0003o2@T:o`000003o`T92P;o000000_o2A8:o`T92_l9
4P[o2@T:o`TB2_l92ACo6PT:ob`L5?l99RWo2A`No`TL5002o`T9500:oa4V
7_lA;c?o2A`Do`T95?l94P[o2@T:oaXB5?l92ACo6Q8Doa4V7P;o2A`N00?o
2@T:o`000?l94PX00_l92@X03?lJ4QCo2A8:oa4L2_lJ4QCo4BHDoaXV5?ld
;akoCfM7ok2ZQ?mbSCgoAUDYob<V2PCo000000go2@TDo`000?mPGS?og<NS
o`000?lA70[o;1`DofYE7_n=SDOoSHeBoiFHI_l0003o2A8:00Co2@T:00Oo
0000odIE:On3Nc?oSHe_odIE:Ol92@[o2A8:00?o2@T:00Ko2A8:o`T92_l9
2@[o0000oaX92_lA70X5o`T92P03oa4L2_l92@[o6PT:00co2@T:00Co0000
o`T92_lA70[o00000_l92@X01olS70[o2A8:oaX92_l92@[o6PT:o`000?nV
ZZ<0Goooool01?n_[joobl_;omkNg_oZj^X1oo;blP000oo^k^h02ooYjNWo
aLG5ogUiNOnPX:3o_Kfmok2`/?n^[Zko]KFeokbl_?nn_[koaLG5017ob<S8
1_ooo_l2ooooo@09oooonooloOOol_G^onCZh?oLh]SoemoDom7Ic?o:d/?o
_LRg00;o_LVe0onlb;@2ok_7/cOo_LVe00?o_LRgoko7^?noakP01_noakP7
okk6]`09okk7]?o3cKCoa]>goloI`OoEg/_ogN?GonSZiOocmOCono[o00Ko
ooko0_ooood00oooooooh>3Pon3Ph00:on7Qh@?oh^;R0_oShn<3onCTi0[o
iNGU1_oVi^H2onSXj0Goj^[Z2oo[jn/2onc/k0;okNg]00Cok>c/ong]kOo]
kNgokNg]2_o^k^h5ono_k`?ol?3`1OoalO48oo;blP;olo?c0oodm?@00ooe
mOGom_KfooKfmP02ooOgm`?on?Sh2_oinOT3oo[jnP?oo?cl0_ono_hAoooo
o`04oa]N/onVa^Ko^M?^ogV^j`;oZmoo00CoKVi^okBd]?oPh>3ok>c/Foo^
k^h01?l92ACo4A`:o`TB2_lA70X2o`T92P05o`TB2_l92@[o4A`:o`T92_l9
4PX00_l92@X01?lA70[o2A8:oa4L2_lA70X8o`T92P03o`TB2_l92@[o2@T:
00Go2@T:00Co4A`:o`T92_l92@[o00000_l94PX01ol92@[o0000o`TB2_l0
003o2A8:o`T92_lJ2@X00_l000001Ol94P[o2@T:o`TB2_l94P[o4A`:00Ko
2@T:00Co0000o`T92_l0003o4A`:1?l92@X00ol94P[o0000o`T92P02o`T9
2P0<o`000?l92@[o2@T:o`000?lA70[o2@T:o`000?lA70[o0000o`TB2_l9
2@[o00001_l92@X02?l94P[o2@T:o`T92_l0003o2@T:o`000?l92@[o0000
1?l92@X00ol0003o2A8:o`T92P03o`TB2P?o2@TD0_l94PX00ol92ACo2A8:
o`T92P02o`TB2P03o`T95?l99RWo4Blm00;o2@TD00?o2A`Do`T95?l00000
0_l92@X01?l92ACo2@T:o`T92_l92@X2o`TB2PCo2@T:00So0000o`TB2_l9
2@[o8blcob<_7_lJ4QCoAUEBo`TL7P;o2@TD00go2A`Do`TV:Ol99RWo4BHD
o`000?l92@[o0000o`TL5?l92@[o4Blmoa4L2_lA9Qko2@TD00;o2@T:01oo
2A8:o`T92_l94P[o6RHDo`T92_lS9P[o6RHDof11:OmbIe;oSHe7ofYbG?o1
/hko4BH:oba<:OlA9P[o2@TDo`TB2_lA70[o2A8:o`000?n3GS?o`LO1o`TL
7_l0003o4A`:oaXB5?mP@ACoYYQ_ok2ZQ?niZVoo000000;o2A8:0ol92@X0
1_l94P[o2@T:odmWAon3Nc?oSHeBo`0000;o2A8:00?o2@T:oaX92_l92@X0
0_l92@X00olA70[o2@T:o`T92P05o`T92P04oaX92_l92@[o2@T:o`T92P;o
4A`:00So2@T:oaX92_lA70[o2@T:oaX92_l92@[o4A`:oaX92P;o4A`:00Co
2@TDo`T92_lA70[o4A`:0_l92@X01_lJ2@[o2@T:oaX92_lA70[o0000ojJZ
[Eook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV00coiNGUomgM
gOn>SXkoTI6Aolc<c?oEeMGo`/;2okVi^Oo0`<3oa<C4olW9bOo:b/XAom3@
d0Goooko0_ooood02_oooo_on?Wcoo3cj_oOiMWob];3okk6]oni`[7o];f/
oj^gXOnR/9L3oj6_U@;oX:jD0_nO[I<hoif[T@03oijZT_nPZICoX:VD00Go
X:VD1onRZiH02OnP[I?oYkFBojbjU_nb_j7o^<:Yoko8]oo;dlSogN;LonW]
kP02ookoo`Coooko0_ooood00oooooooi^KVonKViP07onKViPKoinOW00?o
j>SXonWYjOoZj^X01?oZj^X;on_[j`?ok>c/0_o]kNd3onk^kP[okno_0oo`
l?02oo7al@;ol_;b00ColO7aoo;bl_obl_;ol_;b0_oclo<8ooCdm0GomOGe
0oofm_H5ooOgm`[on?Sh0ooinOT00ookno_oo?clooclo002ooknoRKooooo
00Co7f6doj?2i?nhdnooMjk[0_nZgol01?mZJV[o[Zj^omSHf?oTi>AKonKV
iP09oaXB5?l94P[o2@T:o`T92_lA70[o2@T:oa4V5?l92@[o2A8:00ko2@T:
00?o2A8:o`T92_l92@X04_l92@X02?lJ2@[o2A8:o`000?l92@[o2A8:o`00
0?lS9P[o6PT:0_l92@X2o`TB2P;o2@T:00Oo2A8:o`T92_l92@[o2@T:o`00
0?l92@[o2A8:00;o2@T:00?o4A`:o`T92_l92@X00ol92@X00ol0003o2@T:
o`T92P02o`T92P03o`000?l94P[o2@T:00Wo2@T:0_l94PX4o`T92P03o`00
0?lA70[o2@T:00;o2@T:00Co0000o`T92_l94P[o2A8:0_l92@X00ol94P[o
2@TDo`TL5003o`T9500=o`TB2_l92@[o2@T:o`TB2_l92@[o2@TDoa4V7_l9
9RWo2@TDo`T92_lA;c?o2@TDo`TB2P02o`0000?o2@T:00Ko0000o`T92_l9
2@[o0000o`T92_l00004o`T92P07ob`h:OlJ4QCo2@T:oh>4NolA;c?o2A`N
oaXB5002oa4V7P03oa4_<ol971ko2@TD00;o2A8:00?o2A`No`TL5?l99RT0
0_l99RT04Ol92ACo2@T:o`T92_l94P[o2@TDo`TB2_lA70[o8blNodI17_mG
EE;oUHABohfHS_mkSHCoYYR4ohf=Aol0003o6PT:00;o6Q8D00Go2@TDo`00
0?ld;akoUHeVomcSh002o`0000;o2@T:00Oo6RHDodH_2_mZIc?oUHeBoiik
<olA9P[o000000Go2@T:00Oo0000odI17_mkSFKoUHeBof1N<ol0003o2A8:
00;o2@T:0_lA70X00ol92@[o4A`:o`T92P02o`T92P03oa4L2_l92@[o4A`:
00;o2@T:00Go6PT:o`T92_l92@[o6PT:o`T92P02oaX92P;o2@T:00Wo4A`:
o`T92_lA70[o6PT:o`T92_lJ2@[o4A`:ob<L2_lJ2@X00ol92@X3oa4L2P03
oaX92_l0003oYZZS05ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;o
k^k^00cokNg]on3Ph?mjNW[o_;blomSHf?oKfm_oc/k>ol30`?o5aLGob/[:
olc<c?o?cllAom?Cd`;ooogo01Koookoooomooooooooooomoognn?odmnko
ingQomCMc?o0bKKo/[jXojVeWOnO[9;oUZ>9oi2MPOn?WWgoS9ahohRHM?n5
UG7oPi=_ohBDL?n7Ug?oR9Qd>?n5UG4<ohJDL`0>ohNEM?n9UgKoRYQgohbJ
MonAX7OoTZ=goiJVPOnLZXWoYK6IokBo[_o7clCodm[ConCXiooamOH2oogn
o`05ooclo_omoOgoooomooono?ooool00_oXj>P:onWYj@?oj^[Z0_o[jn/3
onc/k0[okNg]0oo^k^h3ono_k`03oo7alOo`l?3ol_;b00;ol_;b0_oclo<8
ooCdm0GomOGe0oofm_H5ooOgm`gon?Sh0ooinOT?oo[jnP?ono_k00?oo?cl
oogmoOomoOd00_ono_hVooooo`04oamP]?nUa>Ko^M?_ogN^j`;oZMco00Co
KVi^okBd]?oPh>3ok>c/Foo^k^h00olJ4QCo4A`:o`T92P03o`T92P03o`TB
2_l0003o2@T:00?o2@T:00?o2A8:oa4L2_l92@X01?l92@X00ol94P[o4A`:
o`T92P02o`T92P03o`000?lA70[o2@T:00?o2@T:00?o0000o`T92_l92@X0
1?l92@X01Ol0003o2@T:o`T92_l0003o2A8:00So2@T:00?o0000oa4L2_l9
2@X00_l92@X01_l94P[o2@T:o`TB2_l0003o2@T:o`TB2PCo2@T:00?o2@TD
oa4V5?lJ4Q@00_l92@X02Ol0003o2@T:o`T92_l94P[o0000o`T92_l0003o
2A8:o`000003o`T92P03o`TB2_l92@[o2@T:00?o2@T:00?o2A8:o`T92_l9
2@X00_l94PX01?l92@[o2A8:o`000?l92@X3o`000004o`TB2_l92@[o2A8:
o`T92PCo2A8:00Go2@TDo`TL7_lJ4QCo2@TDo`000003o`TB2P05o`000?l9
2@[o2@TDo`T95?lA;c<00_l94PX00ol99RWo2@T:o`000002o`T92P04o`00
0?lA70[o4A`:o`TB2PCo2@T:00?o4A`:o`000?l000000ol92@X02?lA9Qko
;1`DobaN?Ol94P[o4BHDo`TL7_l971Co2BHY0_lA9Qh08_l94P[o6Q8Do`T9
5?lA9Qko2BHYo`TB2_lA;c?o;5hmo`T92_l94P[o2@T:o`T95?lA70[o2A8:
odHV5?m6@AkoSHeBog^=I_nEV:?oNheVodmWAon=SDOo0000oaX92_lA70[o
2@TDo`TL5?l0003oPg]Lol6c[OoLhmKo;5hmo`000?lA70X2o`T92P06ob<L
2_m69QCoWW/coiFHI_nVXFKo=5DY1?l92@X02Ol94P[o2@T:o`TB2_l0003o
JUDNoiF=D_n3Neco=5DYo`000008o`T92P03oaX92_l0003o2@T:00;o2@T:
00So0000oa4L2_l92@[o2@T:oaX92_l92@[o4A`:oaX92PGo2@T:00Ko6PT:
oa4L2_l92@[o2@T:o`000?l92@X3oa4L2P?o6PT:00?o2@T:o`000?nVXIP0
Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool01?omoOgokno_
og=cLooAdM42omcLg006om3@d?o4a<CobLW9olc<c?o?clood];B4OoEeMD2
ooomo`1<ooonooooooooooomookonooen>oojNoQol_D`Onnb[Co/;fSoj:a
T_nCXH3oP91/ogB2Gom^OUWoM8EKog>4F?mcQ5[oLX=Gog:3FOmbPeOoLhAJ
og>4F?meQUcoMHIJogF6G?meQU[oMHILogF6F_meQUcoMHIJogF6G?meQU[o
MHILogF6F_meQUcoMHIJogF6G?meQU[oMHILogF6F_meQUcoMHIJogF6G?me
QU[oMHILogF6F_meQUcoMHIJogF6G?meQU[oMHILogF6F_meQUcoMHIJogF6
G?meQU[oMHILogF6F_meQUcoMHIJogF6G?meQU[oMHILogF6F_meQUcoMHIJ
ogF6G?meQU[oMHILogF6F_meQUcoMHIJogF6G?meQU[oMHILogF6FP;oMHIL
0_mfQE`06OmfQEkoMXELogJ5G_mfQEcoMXENogJ5G?mgQUooMhIMogJ5G_mf
QEcoMhIOogR7G_miR67oNXUNogb>G_maQECoLHAGognAJOn>WggoVJV>ojZg
Xonja[Sod=[Aon?ZhoofnoL00_onool01?ooooooookoooomo_ooool2onOW
i`Ooj>SX0ooYjNT3on[ZjP;ok>c/0oo^k^h2ono_k`kol?3`00?olO7aoo;b
l_oclo<03ooclo<2ooCdm0?omOGe0oofm_H:ooOgm`?on?Sh0_oinOT3oo[j
nP;ono_k0oolo?`=oogmo@?oo_kn:?ooool01?lKGkKoY<CVokWCkomf[NX2
oj_Po`04ogIfM_o1`L7ol?3`oogmoE_ooooo0_l92@X01?lA70[o2@T:oa4L
2_l92@X2o`TB2PWo2@T:00?o2A8:oa4L2_l92@X01ol92@X00olA70[o0000
oa4L2P05o`T92P0:o`TB2_l92@[o2@T:o`T92_l0003o2A8:o`T92_l0003o
2@T:oa4L2P[o2@T:00Oo0000o`TB2_l0003o4A`:o`T92_l0003o2A8:00;o
2@T:00?o2A8:oa4V5?l92@X01Ol92@X00ol94P[o0000o`TB2P05o`T92P;o
2A8:00?o2@T:o`TB2_l92@X00ol92@X01_l0003o2@T:o`T92_l92@[o0000
o`TB2P;o2@T:0_l94PX2o`T92P03o`000?l94P[o2@T:00?o2@TD0_l94PX2
o`TL50;o2A8:00?o2@T:o`TB2_l94PX00_l92@X02_l94P[o4BHNoa4_<ol9
9RWo2@T:o`TL7_l92ACo2A8:o`T92_l94PX3o`T92P0:ob<L2_l0003o2A8:
o`000?l94P[o2@T:o`000?l94P[o2@T:o`TB2P;o2@T:0_l94PX01Ol0003o
4BHNoa4V2_l971ko6Q`N00;o4BHN00[o2A`Do`T95?l92ACo4BHDoa4V7_l9
71Co4BHNob<_<om?GVKo00000_l94PX05olJ4QCo4BHDof11:OmbIe;oNheV
ojJQV?nVZZ?oNheVoba<:OlA9P[o0000oaXB5?lA70[o4BHDo`000?m69QCo
UIQVol77`Oo:d=KoJW]_oa4V2_lA70[o2@T:00;o2A8:00So4A`:ob`L5?n3
Nc?o^JY_ok2ZQ?mZIc?o0000o`TB2P;o2@T:00So0000o`T92_l92@[o2A8:
oaXB5?n=SDOoPg]Loh=k<`;o2A8:00Ko2@T:oa4L2_l92@[o4A`:o`T92_lJ
2@X2o`T92P?o4A`:00ko2@T:oa4L2_lJ2@[o6PT:o`T92_l0003o6PT:o`T9
2_lJ2@[o2A8:o`T92_lA70[o2@T:oa4L2P;o2@T:00Co6PT:o`T92_lA70[o
6PT:0ol92@X01_lJ2@[o2@T:oaX92_lA70[o0000ojJZ[Eoooooo00Co[jn_
ol_;booNg]koj^[Z0Oobl_8000;ok^k^00cok>c/omgMgOmaLG7oemOGomkN
g_oOgmooe=CDolC4a?o7alOoc<c<om3@d?oBd]8>omKFeP?oemOG0_oooOl0
C?ooo_ooooooookonooho_CoinoPomGQcOo2d;OoZkZKoi>SOon9Vg?oTZ=g
ojFhR_nmciooc=j^on?eaOoVm/GojOW:on_kb_o/o<gok?c;on[jbooYnLSo
jo_<on_kb_o[nlcojo_:on_kc?o[nl[ojo_<on_kb_o[nlcojo_:on_kc?o[
nl[ojo_<on_kb_o[nlcojo_:on_kc?o[nl[ojo_<on_kb_o[nlcojo_:on_k
c?o[nl[ojo_<on_kb_o[nlcojo_:on_kc?o[nl[ojo_<on_kb_o[nlcojo_:
on_kc?o[nl[ojo_<on_kb_o[nlcojo_:on_kc?o[nl[ojo_<on_kb_o[nlco
jo_:on_kc?o[nl[ojo_<on_kb_o[nlcojo_:on_kc?o[nlX2on_kc0;okO[<
01cokO[>ongjc?o]n/kokO[<ongjc_o]n/cokO[>ongjc?o/nLgok?W;onci
cOo/nL_okO[>onclbooMl[[ob=nWokK=VOnW_HkoTJIkoh>GL_nFYhOo]<BZ
okg:]_oAg/gojO?XooSon?onoogoo_oo0oooool2on_[j`gok>c/00?okNg]
onk^k_o_knl03?o_knl3oo3`l0?olO7a00?olo?coo;bl_odm?@00_odm?@2
ooGem@Som_Kf1oogmoL6ooShn0_onOWi0_ojn_X2ooclo003oo_knoomoOgo
oOgm017oo_kn:_ooool01?lKG[?oYLCVokG@k_mi[^`2ojOLo`04ofi^K_nd
];Coh>3Ponc/k5_ok^k^0_lA70X02?l92@[o4A`:o`000?lJ2@[o2A8:o`T9
2_l94P[o2@T:0_l94PX02Ol92@[o2A8:o`TB2_l94P[o2@T:oa4L2_l92@[o
0000o`T92P02o`TB2P;o2@T:00Co4A`:o`T92_lA70[o2@T:0_lA70X2o`T9
2P0;oa4L2_l92@[o4A`:o`TB2_l92@[o4A`:o`T92_l94P[o0000o`T92_lA
70X01ol92@X2o`TB2P?o2@T:00So2A8:o`T92_l92@[o2@T:o`000?l92@[o
2A8:o`T92P;o2A8:0_l92@X00ol94P[o2@T:o`T92P02o`T92P03o`TB2_l9
2@[o000000;o2A8:00Go0000o`TB2_l94P[o2A8:o`000002o`T92P05o`TB
2_l92@[o2@T:o`T92_l94PX00_l92@X01?l0003o2A8:o`000?l94PX2o`00
000=o`TB2_l92@[o0000o`000?l94P[o6Q8Do`TL5?lA9QCo2@TDo`TB2_lJ
4QCo2A`No`T95003o`TB2P07o`000?l92@[o4A`:o`T95?l94P[o4BmBo`TV
:@02o`TB2P05o`TL7_l92@[o2@T:o`000?l94PX00ol000000ol94P[o2@T:
o`T92P02o`TB2P?o2@T:0_l00002o`TB2P04o`T92_lJ4QCo2A`Do`T950;o
4BHN0_l99RT04?l971ko2A`Doa4V5?lA9QCo2BHYo`TL7_lJ71ko;5ELobaW
G?l0003o2A8:o`000?ld;akoAT4Nohf=AomkSFH2ojJQV00@oeN=G?l0003o
2@T:o`T92_l94P[o4BH:o`TL5?l92@[oJVLcol6c[Oo1al7og>?PoceN?Ol0
003oJUDNob`V50?o2A8:00Oo4A`:odH_2_mZEAkoYXABojJQI_nNSC?o0000
00;o2A8:00?o2@T:oa4L2_l94PX00_l92@X02?l0003oAUDYojJHKon`ZXCo
ARHDo`000?l92@[o4A`:0_l92@X02?l94P[o2@T:o`T92_l92@[o4A`:o`T9
2_lJ2@[o2A8:0_lJ2@X4oa4L2P;o2@T:00?o6PT:ob`B0?l92@X00_lA70X0
1OlJ2@[o4A`:oa4L2_lA70[o2@T:00Co4A`:00Ko2@T:oaX92_lA70[o8a`:
o`000?o1/jeOonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002onKViP04
onCTi?oDe=CoMgMgomWIf@;oh>3P00Koe=CDolO7aoo:b/[oc/k>om;Bd_oD
e=@>omKFeP?oemOG04kooogoooonooooooooo_ooooconooanNcoen??ol7?
]_n/_IgoVZn8oi:XN_nQ]hKo_]FOomS`]_oVo/;ok_o8on[kaOo/oLWol_o=
oo?od?ofom7oloo@oo?oc_o`olgolOo<onooc?oaolcokoo<oo7oc?o_olco
lOo<onooc?oaolcokoo<oo7oc?o_olcolOo<onooc?oaolcokoo<oo7oc?o_
olcolOo<onooc?oaolcokoo<oo7oc?o_olcolOo<onooc?oaolcokoo<oo7o
c?o_olcolOo<onooc?oaolcokoo<oo7oc?o_olcolOo<onooc?oaolcokoo<
oo7oc?o_olcolOo<onooc?oaolcokoo<oo7oc?o_olcolOo<onooc?oaolco
koo<oo7oc?o_ol`4oo7oc00Moo7oc_oaolcolOo>oo7oc?oaolkolOo<oo;o
coobolgolOo>oo7oc?o`o/gol?k;oo3ncOo^olWoj?o4onCo`ooSolCof?Bj
okWDWonE[gooRZ5eohjTO_n[_Yko`=2fomWVe?o/m^_omocfoogoo?onool0
0_ooool2onSXj0OojNWY0ooZj^X3on_[j`03ong]kOo/k>cok^k^00;ok^k^
0_o_knl;oo3`l0?olO7a0_oclo<3ooGem@[om_Kf3OogmoL;ooShn0;onOWi
0_okno/00oolo?coo_knooknoP0kooooo`04oa]O]_nTa>Ko^=;^ogJ]jP;o
[=oo00CoJVYZojj^[_oHf=Soi>CTFooVi^H01Ol92ACo2@T:o`T92_lA70[o
2A8:00;o4A`:00Co2A8:o`T92_lA70[o00001?l92@X00olA70[o2@T:o`T9
2P02o`T92P0:o`TB2_l92@[o2A8:oa4L2_l92@[o2A8:o`T92_lA9P[o2@T:
o`TB2P;o2@T:0_lA70X2o`T92P03o`TB2_l92@[o4A`:00;o2@T:00Go2A8:
oa4L2_l92@[o4A`:o`T92P02o`TB2P06o`T92_l94P[o2A8:o`TB2_l0003o
2A8:1Ol92@X3o`TB2P03o`000?l92@[o2@T:00?o2@T:00Go0000o`T92_l9
2@[o2A8:o`000002o`T92P06o`TB2_l92@[o2@T:o`TB2_l0003o6PT:1?l9
2@X01Ol94P[o2@T:o`TB2_l0003o2@T:00;o2A8:00Go0000o`T92_l94P[o
0000o`T95002o`T92P08o`TB2_l92@[o2@T:o`T92_lA9QCo2@T:o`TL5?l9
2A@2o`TL7P06o`TL5?l92ACo2@TDo`TB2_l92ACo2@T:0_l94PX04_l92ACo
2A`Noa4_<olA9Qko2@TDo`TB2_l99RWo2A8:o`000?l92@[o0000o`T92_lA
70[o0000o`TB2_l92@[o2A8:o`0000?o2@T:0_l94PX00ol92@[o0000o`T9
2P02o`TB2P;o2@TD00Co4BHDoa4_<olA9Qko4BHN0_l971@08Ol94P[o2A`N
ob=1?Ol971ko8d4mob=1D_lA;c?o0000o`T95?ld;akoJVLcog9WD_nEV:?o
YZZSohf=KolA9P[o0000oa4L2_lJ9QCo;2HDodI17_l92ACo0000oh=N<oo1
/jgo`LO<ong]j_m6GTOo2A8:oc@_7_lJ4QCoLXdmoa4V2P02o`TB2P08ob`B
0?l/71CoPehDojJQI_niV5coYZ5Vo`000?lA70X7o`T92P09ob`V5?nESFKo
YYQ_og:=?Ol92@[o2A8:o`T92_lA70[o2@T:00;o4A`:00?o2@T:oaX92_l9
2@X01Ol92@X01?lJ2@[o2@T:oaX92_l92@X2oaX92P09ob<L2_l92@[o4A`:
o`T92_lJ2@[o2@T:oaX92_l92@[o2A8:00;o2@T:00Wo6PT:o`T92_l92@[o
4A`:oaX92_lA70[o6PT:o`000?o1/jd0GooVi^H01?nMWIgo]kNgolS8b?oC
dm<1om[JfP000_o^k^h03?o/k>cog=cLogIfM_oJf][oh>3Pon7QhOoDe=Co
alO7ol_;boo>c/kod=3@om?Cd`koeMGE0ooFe]H0C_oooOooookoooooooom
oocomokfonKahOo8el3o[/6Qoi:XPOnG[X3oZL6=olGNY?oMmkKoiOnmon7l
]OoNm;?okOk7oo3nboobo/coloo>ooCoc_ocolkoloo=oo;ocOoeoloom?o?
ooGocoodoloomOo?ooCocooeoloom?o?ooGocoodoloomOo?ooCocooeoloo
m?o?ooGocoodoloomOo?ooCocooeoloom?o?ooGocoodoloomOo?ooCocooe
oloom?o?ooGocoodoloomOo?ooCocooeoloom?o?ooGocoodoloomOo?ooCo
cooeoloom?o?ooGocoodoloomOo?ooCocooeoloom?o?ooGocoodoloomOo?
ooCocooeoloom?o?ooGocoodoloomOo?ooCoc`?omOo?013omOo=ooGocooe
olgomOo?ooGocOoeoloomOo=ooGocooeolgomOo?ooGocOodolkoloo;oo?o
cOo_olWoi?jo0_oQokd02ooRol3oh?k0olo]/On_c9CoTZikoiRbQOn[`I_o
bMVoon;_gOodno?onool00;oo_oo00?oooooonc/k?o/k>`01oo]kNd6onk^
kP03oo3`l?o_knoolO7a00ColO7a2oobl_84oo?cl`Com?Cd2_oemOD5ooKf
mP;omoOg00?om_KfooOgmoogmoL00oogmoL;ooShn0;onOWi0_okno/00ool
o?coo_knooknoP0kooooo`04oaeO/onVa^Ko]]3^ogV_kP;oZmko00CoKVi^
okBd]?oPh>3ok>c/Foo^k^h01?lJ4QCo4A`:o`TB2_l94PX5o`T92P03o`TB
2_l92@[o2@T:00;o2A8:0ol92@X00ol0003o4A`:o`T92P04o`T92P;o2A8:
0_l92@X00olA70[o6PT:o`000005o`T92P03oaX92_l92@[o2@T:00Co2@T:
00So2A8:o`T92_l94P[o0000o`T92_l94P[o0000o`TB2P;o2@T:00?o4A`:
o`TB2_l92@X01?l92@X00ol0003o2@T:o`000002o`TB2P?o2@T:00?o4A`:
o`T92_lA70X00ol92@X01_lA70[o2@T:o`T92_l94P[o2@T:o`TB2P?o2@T:
00Co4A`:o`T92_l92@[o2A8:0_l92@X01Ol94P[o0000o`T92_l92@[o0000
00;o2@T:00?o0000o`TB2_l000000ol92@X01?lA9QCo=5Dmo`T95?l99RT2
o`TL5003oa4V5?l92ACo2A8:00;o2A8:01;o2@TDo`TB2_l94P[o2@TDo`TB
2_lS;c?o2BHYo`TB2_l92@[o4Blmo`TL5?l0003o2@T:o`TB2_l92@[o2A8:
o`T92_l00002o`T92P03o`000?l92@[o2@T:00;o2@T:00Ko0000o`T92_l9
2@[o2@T:o`TB2_lA70X2o`T95003o`TL5?l971ko4BHN00;o4BHN02_o2A8:
o`TL5?l971Co8blcoa4_<ol92ACoLXf4oba<:OlA9QCo2@T:ob`L5?m6EBWo
UIQVoiFQS_n`ZXCoEheLo`000?l92@[o4BH:of11:On3Nc?o=5DYo`TB2_l0
003o`K>>ok2c]oo1al7og>?PofYkKol0003o8bH:ob<L2_lS9P[o6Q8Doh=k
<ol92ACo2A8:oa4L2_lJ2@[oJUDNokV=<oo1/hkoYZ5V00;o2@T:00Go4A`:
o`T92_l92@[o2@T:oa4L2P02o`T92P06o`000?n=SE;oNheVol6cS_lA9QCo
4A`:1Ol92@X01?lA70[o2@T:oa4L2_l92@X2oa4L2P03o`T92_lA70[o4A`:
00;o2@T:00Oo6PT:o`T92_lJ2@[o6Q8Doa4L2_lJ2@[o4A`:00?o6PT:00go
4A`:o`T92_lA70[o4A`:oaX92_l92@[o4A`:oaX92_lA70[o6PT:oa4L2_l9
2@[oYZZ]05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo00Co
oOgmonc/k?mlO7cof][J0_oPh>001_oCdm?oa/K6olc<c?o>c/kod=3@om?C
d`koemOG0ooHf=P0CooooOooookoookooooio_[ol?S]om_Xe_nkc[;oXKNC
oi6[O_nP_HOo^]JKom3]Z_oJn;3ogojbonWo]_obol?oloo9ooCoc_ogom7o
mOo?ooOodOoeoloomooAooGocoojomCon?oBoo[oe?ohom;on_oDooSod_oj
omCon?oBoo[oe?ohom;on_oDooSod_ojomCon?oBoo[oe?ohom;on_oDooSo
d_ojomCon?oBoo[oe?ohom;on_oDooSod_ojomCon?oBoo[oe?ohom;on_oD
ooSod_ojomCon?oBoo[oe?ohom;on_oDooSod_ojomCon?oBoo[oe?ohom;o
n_oDooSod_ojomCon?oBoo[oe?ohom;on_oDooSod_ojomCon?oBoo[oe?oh
om;on_oDooSod_ojom@00_ohom8<ooSod00DooOocoofolkol_o<onoob?oW
ol?ofobeom3aZ_o?l:Wob^jXokSHUonP_h?oS:Ucoi^eR?njcJgofn[Coo;l
lOokoogoo?oooognooooool2on_[j`?ok>c/00Coj^[Zol_;booDe=Cok>c/
1Oo]kNd00ooLg=coh>3Pono_k`03oo7al@03onk^k_oQhN7ol_;b00[ol_;b
1ooclo<00ooMgMgob<S8oo;blP08ooCdm0GomOGe0oogmoL5ooWin@_on_[j
0_okno/3ooclo0;ooOgm4Oono_hZooooo`04oaYL/onT`nGo^=;_ogV^k0;o
[=oo00CoMWIfol71`Oo`l?3ooOgmFoooool01?lJ4QCo2A8:o`T92_l94PX3
o`T92P03oa4L2_l92@[o2@T:00?o2@T:00Go4A`:o`T92_lA70[o2@T:oa4L
2P03o`T92P07oa4L2_l92@[o2@T:o`T92_lJ2@[o2@T:o`TB2P03o`T92P03
oa4L2_l92@[o2@T:00Wo2@T:00Co4A`:o`T92_l92@[o4A`:1?l92@X00olA
70[o2@T:o`T92P04o`T92P09o`000?l92@[o2@T:o`T92_lA70[o0000o`T9
2_l94P[o4A`:00?o2@T:00Co0000oa4L2_l92@[o2@T:0_l000000ol92@[o
0000o`T92P0=o`T92P03o`000?l92@[o2@T:00;o2@T:00_o0000o`T92_l9
2@[o6Q8Do`000?lJ9QCoAT`mo`TV:Ol92@[o2@TDo`TB2P03o`T950?o2A8:
01?o2@T:oaXB5?l92@[o2BHYoa5<D_l99RWo2A8:o`T95?l99RWo2@TDo`TB
2_l92@[o0000o`T92_l0003o2A8:o`T92_l0003o4A`:00_o2@T:01Go6Q8D
o`TB2_l971ko4BHNo`TL7_l99RWo6Q`No`TB2_lm;cgo4Blmob=1D_lS@Cgo
Cg9koh>4S_l99RWo8blYo`TB2_lJ9QCoJVLcol[@`OmbSE`00_l000007OlS
9P[oPg/coiF=D_nEV6Ko2A`No`TB2_l0003oWXAVok2c]oo1/jgokNgZo`TL
7_l0003o2@TDoa4L2_lS70[o;1`DocAE:Om6;`[o6RHDo`TB2_lJ2@[o4BH:
og]<2_nESE;oSHe7olZZI_l0003o2A8:00Oo2@T:00Ko0000odI17_n=SE;o
/;>godH_2_l94PX4o`T92P04oaX92_lA70[o2@T:oa4L2P;o2@T:00?o6PT:
o`T92_l92@X00_lJ2@X02?l92@[o4A`:o`T92_lJ2@[o;180oaX92_lA70[o
6PT:0_l92@X00olA70[o2@T:oaX92P02oaX92P04o`T92_lJ2@[o6PT:oaX9
2P;o4A`:00?o6PT:o`000?nVZZd0Goooool01?n_[joobl_;omkNg_oZj^X1
oo;blP000_o^k^h01?o/k>cog=cLogalO?oJf]X2on3Ph006om?Cdoo7alOo
c<c<olk>c_o@d=3od];B3_oFe]H3omOGe`;oooko04koo_ooooKln?oXl^Oo
dN3;ok;7Z?nI/X[oVkN6oj[9S_o2hIkodo>ZomSiZ_oFn:Cof_^TonCo/_o_
o/Gol__<ooGld?odoLkom_gAooGncooeo=3om?g>ooGld?odoLkomOc@ooCm
c_oeo=3om?g>ooGld?odoLkomOc@ooCmc_oeo=3om?g>ooGld?odoLkomOc@
ooCmc_oeo=3om?g>ooGld?odoLkomOc@ooCmc_oeo=3om?g>ooGld?odoLko
mOc@ooCmc_oeo=3om?g>ooGld?odoLkomOc@ooCmc_oeo=3om?g>ooGld?od
oLkomOc@ooCmc_oeo=3om?g>ooGld?odoLkomOc@ooCmc_oeo=3om?g>ooGl
d?odoLkomOc@ooCmc_oeo=3om?g>ooGld?odoLh8ooCnc003oo?mboodo/co
mOo=00;omOo=01Com?k<oo?mboo]o/Oogobjon?o_ooYol?oiOnmomWn/Oo9
kj;o^]jDojkBS?nE]7SoVkN4ok36Woo>h<Koj_KXooSnn_okoooooOkooooo
o`;ok>c/0_o]kNd01_nSXj?o2@T9o``<3?lQ8B7o<S8boi^KV`;ok^k^00go
eMGEoc/k>ol0003o410@oa/K6ooYjNWol?3`ok>c/olI6AWo1PH6ode=COmn
OWko;Bd]00;olO7a00Ko?3`logQhN?oalO7olO7aoc`l??mhN7P3oo;blP;o
lo?c00Oom?Cdoe9BD_l@413o=3@doaPH6?mPH63oj>SX00;omOGe00Oo<c<c
o`000?l0003o1`L7obd];Om^KVkoj^[Z00;om_Kf0_ohn?P00oogmoOonOWi
ooWin@03ooWin@_on_[j0_okno/2ooclo003oogmoOono_koo_kn03_ooooo
00Co7EncojG4i_nfd^koNJkY0_nZh?l01?m^KVko];Bdon3Ph?o/k>aKonk^
kP07o`T95?l92@[o4A`:o`T92_lA70[o2@T:oa4L2P02o`T92P03oa4L2_l9
2@[o2@T:00_o2@T:00Go6PT:o`T92_l92@[o2@T:oa4L2P03o`T92P03oa4L
2_l92@[o2@T:00Go2@T:00[o8blYo`000?l92@[o4A`:o`T92_lA70[o2@T:
o`000?l92@[o00001?l92@X00ol0003o2@T:o`T92P03o`T92P04o`TB2_l0
003o2@T:o`0000[o2@T:00?o0000oa4L2_l92@X03_l92@X00ol0003o2@T:
o`T92P02o`0000;o2@T:00?o0000o`TB2_l000000_l000000ol94P[o;3PY
o`TV:@03o`T9500;oa4V5?lJ4QCo2A`Do`TB2_l92@[o2@TDo`T92_l92ACo
2A`Doa4V7_lA;c<00_l92A@01Ol94P[o4Blco`TB2_l92@[o000000;o2@T:
00So0000o`T92_l92@[o2@T:o`000?l94P[o0000o`TB2PSo2@T:01[o2@TD
o`TB2_lJ4QCo2@TDo`TV:OlJ71ko2BHYo`T92_nEXKOoCeiVo`U1Aom?LW_o
`LO1ocAWNolS;bWo2A`No`000?nELTOo/;>goa4V5?l0003oARHDoh=k<on`
ZXCoUIQVog:=?@?o000001Oo`J64ok2c]ooLhmKokOKeoba<:Ol0003o4A`:
o`T92_lJ2@[o8a`:ob<_7_m69QCoH5hcoh=k<ol0003o4A`:ob<L2_mkC0[o
bZ5Bomc7XonVXFKo0000oa4V5009o`T92P03of1N<on=SDOoPg/c00;o2A8:
00Go2@T:o`000?lJ2@[o2@T:oaX92P04o`T92P03oaX92_l92@[o;18000?o
2@T:00?o6PT:o`T92_lJ2@X00olJ2@X01Ol94P[o6PT:oa4L2_l92@[o2A8:
00;o2@T:00Co6PT:o`T92_lJ2@[o2@T:1?lJ2@X00ol0003o`K>]onk^kP1N
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002onKViP04onCTi?oDe=Co
O7alom[JfP;oh>3P00Koe=CDolS8b?o;bl_oc/k>om3@d?oBd]8>omKFeP?o
emOG01Soo_klookoooonoooom?WlonC]j?o<flSo[L>MoiFbO?n_dXko[M>8
ok7JS?o1j9WocoJWomWn[_oPojooi_ngonSj_?o/n/Gol?g8oo7ob_ocol_o
l_o:oo7nbOo`o<X3oo7mbcGolOk92?o`olP00oo^oLKokok7oo3ob002oo7o
b@0Doo3ob?o_o/Oojoo3on?o__oHo[?oeO^^omOn[oo@nZSo`N^GokCMS_na
ehcoYLR4oj;1R?nZ`iWo`]Nhomo/f_o`n_;onOoooocoooonool2ong]k@;o
k^k^01GoalO7ok:b/_oYjNWok^k^oi:BT_l30`?od=3@ono_kolm?Cgo:BTY
okjn__o_knoob/[:ong]kOo_knooCTi>oe=CDooWinOoU9BDo`h>3_l];Bd0
0_o`l?001_ll?3coMgMgoo3`l?o`l?3o?3`logMgM`?olO7a00Wol_;boo?c
loodm?Cofm_Koo;bl_oemOGofm_Ko`d=3Om_Kfl00_oemOD02Olc<c?oKfm_
ooGemOo[jn_oa<C4od92@_lO7aooinOWooKfmP03ooOgm`Gon?Sh2ooinOT2
oo[jnP?oo?cl0_ono_hkooooo`04oa]N/onVa^Ko^M?^ogV^j`;oZmoo00Co
JVYZojj^[_oHf=Soi>CTFooVi^H2oa4L2P05o`T92_lA70[o0000o`T92_l9
4PX01Ol92@X03?l0003o2@T:o`T92_l92@[o0000oa4L2_l92@[o0000o`T9
2_lJ2@[o0000oa4L2PKo2@T:00?o0000o`T92_l000000_l92@X01?lJ2@[o
2@T:o`T92_l92@X2oa4L2P;o2@T:00?o;180oaX92_l92@X00_l92@X03?lA
70[o0000o`T92_l92@[o0000o`TB2_l92@[o0000o`T92_l0003o2@T:o`00
00;o2@T:00?o0000o`T92_l92@X00_l92@X01Ol0003o2@T:o`T92_l92@[o
000000?o2@T:00Go0000o`T92_l92@[o2@T:o`000004o`T92P03o`000?l9
2@[o2@T:00;o2@T:00Go0000o`T92_l94P[o0000o`T92P02o`00000?o`T9
5?l0003o2@T:o`T92_l0003o2@T:o`TB2_l0003o4Blmo`TL5?l94P[o2@TD
o`TV:Ol92@[o2@TD00Co2@T:00So2@TDoaXB5?l971ko4Blco`T92_l92ACo
2A`Doa4V7PCo2@T:00?o0000o`T92_l000000_l92@X01_l0003o2@T:o`00
0?l0003o2A8:o`0000;o2@T:01co0000o`T92_l92@[o2A8:oaXB5?l92ACo
2@T:oa4V7_l92ACo2D57oa4_?On3;ecoUIRSob=1D_l9@DOo=6Mkol77c?lA
;cgo8blNo`000?mP@ACoYZZSok2ZQ?l92@[oUHeBok2ZQ?nEV6Ko4BH:0ol0
00002?m69QCo`J64ok2c]oo1al7ob]3FoeN=G?l0003o2A8:0ol92@X03?lA
70[o8a`:oc@_7_lm70[oH5hcoc@_7_l0003o4A`:ofYE7_n`SE;o/:Z4ong@
V0;o00001_l92@X03Ol94P[o2@T:o`TB2_l/4P3oPg]LoiF=D_mPGS?o0000
oaX92_l92@[o0000o`T92_lJ2@X00_l92@X00ol/4P3o2@T:o`T92P02o`T9
2P0?oa4L2_l92@[o6PT:oaX92_l92@[o6PT:o`T92_lJ2@[o2@T:oaX92_l9
2@[o;180o`T92_lA70[o6PT:00Co2@T:00Oo4A`:oaX92_l92@[o6PT:o`T9
2_l0003o/;>g05ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;ok^k^
00cok>c/omcLg?mkNg_of][Jon3Ph?oQhN7oeMGEolS8b?o:b/[oc/k>om3@
d?oCdm<>omKFeP?oemOG01Goo_o]ookom?olo?ooo?koomkRjoo1cl3oWKR5
oiVnK_nNcFOoY=U_ojcRQ?ndj9Go`>jVolcg/_oFo[Gofoncomom/ooRoKKo
iOnhonGo^ooWok`00_oXokl01?oXol3oi_nnonKo__oXo[heonSn_@coi_nk
01GoiOjjonCm^OoSo;Sogofgom_o^?oFok;od?f/olSeX?o2l9So_N^AokCP
RonZeHGoY<b5oiNiO?nM^HWo_MFaomKUc_ohooKomooioo[oo_onool00_o[
jn/6onc/k007om3@d?l0003oZJVYolc<c?l0003oRXZ:ong]k@02ono_k`;o
lO7a00Ko:BTYohR8R?oalO7ol_;bog=cLol];Bd2oo;blP06oc`l??mhN7So
l_;boo;bl_ll?3coN7Qh2?oclo<2ooCdm006oeEEEOm0@43om?CdooCdm?lc
<c?oKVi^0_odm?@01OoemOGol?3`oadM7Om]KFgom_Kf00;on?Sh00ConOWi
oo_knookno_ono_k0_olo?`=oogmo@?oo_kn?Oooool01?lOHKCoXl;TokSC
komg[^/2oj[Oo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Go2A8:oaXB5?l9
4P[o2@T:oa4L2P02o`T92P04oa4L2_l92@[o2@T:oa4L2Pgo2@T:00?o2A8:
o`T92_l92@X04?l92@X01OlA70[o2A8:o`T92_l94P[o000000Wo2@T:00?o
2A8:o`T92_l92@X02?l92@X00olA70[o2@T:o`T92P07o`T92P03o`000?l9
4P[o2@T:00Co2@T:00Go0000o`T92_l92@[o2@T:o`TB2P04o`T92P04o`TB
2_l92@[o0000o`TB2PGo2@T:00So2@TDo`TB2_l92ACo6Q8Do`T95?lA9Qko
2A`No`TB2P;o2@TD00So2A8:o`T92_l971Co8blYoa4_?Ol99RWo2@T:oaXB
50;o4Blc00Ko2A8:o`000?l92@[o2A8:o`T92_l94PX3o`T92P07o`TB2_l9
2@[o4A`:o`T92_l94P[o2@T:o`000004o`T92P0So`TB2_l92ACo6Q8Do`T9
5?lA;cgo8blcof1bNonEV:?oPhB>obaWG?l/EEco8d4mobaEG?l/Ieco8blY
oa4_<om69QCoYZZSoiFQS_lA9P[okM2Hog:=G?lA9P[o0000o`T92_lJ4QCo
2@T:of0_5?o:d<7o`K>]ol[@`Oofoooo4BH:o`000?l92A@00_l92@X01?l9
4P[o2@T:o`T92_l/4P02ob<_7P0:oiEbAon=SDOo2A8:oaXB5?mkC0[o/8dc
ok2ZQ?oC_Xko=5DYo`TB2P;o2@T:00?o2A8:o`T92_l92@X01?l92@X01Ol0
003oUG97ohf=AonNSC?o000000;o2@T:00Co6PT:o`T92_l92@[o6PT:0_l9
2@X02_lA70[o6PT:oa4L2_lJ2@[o;180o`T92_lJ2@[o4A`:o`TB2_lS70X2
oaX92P0;oa4L2_l92@[o6PT:oaX92_l94P[o6PT:oa4L2_l92@[o6PT:oa4L
2_lJ2@X00_l92@X2oaX92P03oa4L2_l0003oYZZ]05ook^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN4000;ooooo00CooOgmonc/k?mkNg_of][J0_oPh>00
1_oDe=Cob<S8ol_;boo>c/kod=3@om;BdPkoeMGE0ooFe]H05?onon[oo_od
oocloooloOoog>?]ol;@_onJ^7SoU/9QoicCG?nRgFOoZ>B2ok3WU_ngjZOo
`_2_ol_f[_o>mjWoeob^omWl[?oJo:oog?ja0_oMokD2omon^0;oh?nk0ooQ
okTcon7o]`Soh?ng01WohOnhon;o^OoRokWoh_nion7o^?oPokOogonfomgo
]OoCo:kocob[olShY?o1lI_o_>fDokOXSOn_h8OoZ=F0oj3;O?nC^gGoVkZ1
ol3I[ooEj<com_obooOonookooooo_oo00;ojn_[1Oo/k>`02?oNg]koBDU9
o`L71ooPh>3o/;2`o`000?no_kookNg]0_o_knl2oo7al@06obTY:On:RX[o
lO7aoo;bl_n7QhOo;Bd]0_obl_801_ll?3coN7Qhoo;bl_obl_;o?3`logQh
N0Colo?c1?odm?@01?oemOGoj^[Zoa8B4_moOgl2ooGem@04oc<c<om_Kfoo
mOGeooGem@;om_Kf00?oMgMgob0P8?ofm_H00oohn?P5oo[jnP_ono_k0_ol
o?`3oogmo@;oo_kn>oooool01?lOH;CoYLCVokWCkomg[^/2ojWLo`04ogIf
M_o1`L7ol?3`oogmoE_ooooo00Co6Q8Do`TB2_l0003o4A`:0_l92@X00olA
70[o2@TDoa4L2P06o`T92P07oa4L2_l92@[o2A8:o`TB2_lA70[o2A8:oa4L
2P02o`T92P03oa4L2_l92@[o2@T:00;o2@T:00?o2A8:o`T92_l92@X01?l9
2@X02OlJ2@[o2A8:oa4L2_l92@[o2A8:o`T95?l92@[o4A`:ob`B0006o`T9
2P03o`TB2_l92@[o000000;o2@T:00?o2A8:o`000?l92@X01ol92@X2o`TB
2P03o`T92_l94P[o2@T:00?o2@T:00?o2A8:o`T92_l92@X00_l92@X00ol0
003o2@T:o`T92P03o`T92P03oa4L2_l92@[o2@T:00;o2@T:00So0000o`TB
2_l0003o2A8:o`T92_l0003o4A`:o`0000Co2@T:00Wo2A8:o`T95?l92@[o
4BHNo`T95?lJ4QCo2@TDo`TL5?l971h00_l92A@02_lJ4QCo2@TDoa4V7_l9
9RWo4Blco`TV:Ol94P[o2@T:o`TV:OlA9Qh2o`T92P05o`TB2_l0003o2@T:
o`000?l94PX00_l92@X01ol0003o2A8:o`T92_l0003o2@T:o`000?l94PX0
1?l92@X09Ol94P[o2@TDo`T95?lA9Qko2BHYol[@e_nEV:?oY[?1oeN=S_lS
@E;o4DaBobaEG?l/EFoo8d5Boa4_<old;ako/:Z4omc7Xol0003oYXABog:=
?Ol0003o2@T:oaX92_lA70[o0000of0_5?oLhn3o/;>gol77`OoLhn3oUJZ]
o`000?l92ACo4A`:o`T92_lA70X00ol92@X03_lA70[o8a`:ob`V5?l/9QCo
^IQLodIE:OlA9QCoJT4:ok2=<oo:_Zgo`K>>ocAE:Ol0003o2A8:0_l92@X0
0ol94P[o2@T:o`T92P03o`T92P07o`000?mP@BWoYYQ_ojJQI_l0003o4A`:
o`TB2P02o`T92P0;oaX92_l92@[o2@T:oaX92_l92@[o6PT:o`T92_lJ2@[o
2@T:oaX92_l92@X01OlJ2@X01?l92@[o;180oa4L2_l92@X3oaX92P0;oa4L
2_lJ2@[o6PT:o`T92_lJ2@[o4A`:ob<L2_l/4P3o6PT:o`000?o1/jd0Gooo
ool01?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h01?o/k>cog=cLogal
O?oJf]X2on3Ph006omCDe?o8b<Soc<c<olk>c_o@d=3od];B3_oDe=@3omGE
e@0Hoooolooooo[oo_kooo_moooMi^?o`=>eoi:dJ_nC`U[oUm5IoioKJOnV
hH?oZ^>Fok7TXOnjjJGo`njNolK`W?o?mZOocoFXoloeZ_o@mZ_od_J`om?g
/OoDmk?oeORd0ooFm[D00ooFm[?oeoJcomOf/`02omOf/S3oe_Nb2_oDn;80
5ooEnK?oe?RbomCh/_oCmk7odOF_om3fZoo;mJ?oaoBOol3`V_nijIGo]NNB
ok;TSOnZg8?oX]Eioi_<Lon?^VSoU;Qbol7LYooGj/[olooaoo[ooooloooo
o_oo00;oj^[Z1?o[jn/02onWYjOo6ATIoaDE5On_[jook>c/ol[:b_l0003o
QXJ6ong]kOo_knook^k^00;ol?3`00Ko:BTYohZ:R_oalO7ol_;bohN7Qol]
;Bd2oo;blP06oc`l??mhN7Sol_;boo;bl_ll?3coN7Qh0ooclo<2ooCdm0;o
mOGe00GoVi^KoeYJF_lS8b?oIVIVonGUi@02ooKfmP04oc@d=?m_Kfoom_Kf
ooKfmP;omoOg00?oVIVIo`820_oalO400_ogmoL6ooShn0_onOWi0_ojn_X3
ooclo0;oo_kn>oooool01?lKGkKoY<CVokWCkomf[NX2oj_Po`04ofi^K_nd
];Coh>3Ponc/k5_ok^k^00[o2@T:o`000?lA70[o2A8:o`T92_l94P[o2@T:
oa4L2_l92@[o2A8:1ol92@X01?l94P[o2@T:o`000?l94PX9o`T92P05o`00
0?lA70[o2@T:o`T92_l94PX01Ol92@X01OlA70[o6Q8Doa4L2_lA70[o0000
00;o2@T:00Co0000o`TB2_l94P[o2A8:0_l000001Ol92@[o0000o`000?l9
4P[o2@T:00?o2A8:00Go2@T:o`000?l94P[o2@T:o`TB2P03o`T92P06o`00
0?l94P[o2A8:o`TB2_l92@[o2A8:0_l000001?l92@[o4A`:o`T92_l94PX4
o`T92P0Go`000?l92@[o2@T:o`T92_l94P[o2@T:o`000?l94P[o0000o`TB
2_l92@[o2A8:o`000?l92@[o0000o`T92_l0003o2@T:o`T95?l971ko2D57
o`000?lA9Q@00_l971h02Ol94P[o2A`Noa4V7_lA9QCo2@TDoa4V5?l94P[o
4Blcoa4V7P02o`T95007o`U1Aol971ko4BHNo`T92_l0003o2@T:o`TB2P02
o`T92P;o2A8:00?o2@T:o`000?lA70X01_l92@X3o`TB2P05o`T95?lA9QCo
2@T:ob=1D_oCfMH00_o1al`07?l9@DOo8d5Bob=1?OlS@E;o8d4mob=1D_lA
;cgoUHABol6c[OlA9P[o^JY_ojJQI_l0003o4A`:o`TB2_l971Co0000ok24
Noo:d<7o`K>]ol[@e_oCfMKog>?Po`000?l92@[o2A8:o`T92_l94PX3o`T9
2P0?oa4L2_l92@[o6PT:ob<L2_ldEBWoARH:ojJQI_lS9P[oJT4:ojJ4D_o1
/hkog<NSocAE:Ol0003o2A8:00;o2@T:0_l94PX2o`T92P;o2A8:00Go2@T:
ob`V5?nVXFKo^IQLo`000003o`T92P04oa4L2_lJ2@[o2@T:oa4L2P;o2@T:
00Co6PT:o`T92_lJ2@[o2@T:0_lA70X2o`T92P03oaX92_lA70[o2@T:00;o
6PT:00_o2@T:oaX92_lA70[o6PT:o`T92_lA70[o2@T:oa4L2_l92@[o6PT:
oa4L2P03oaX92P03o`000?nVZZ?ok^k^05kok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN4000;oi^KV00coi>CTomCDe?mkNg_ofMWIomoOgooQhN7oe=CD
olO7aoo<c<coc/k>om3@d?oEeMD>omCDe0?oeMGE01Sooookookno_oooOoo
n?_oomgYfoo0ej_oQJeGohRlC_nAc5CoV=MUoj7MPonVgY?o[N2MokKTW?nn
jY7o`Nb@olG_WOo4kj3oa>jRolC^Y?o6kZOob?2YolWaZoo:lZ`4ol[_[0;o
bnjZ0oo;kjT`ol[_Z@Oob?2Y1Oo6kZL05?o4k:Go`n^Tol?/X?o4kY[o`NfD
ok_XTonchhoo[N6>oj_QRonTfgkoWMEdoiO;Ion7]UKoQjiKokkLW?oLkLWo
logboocoooonoOooooko1Oo/k>`01?mgMgOo0000odm?CooDe=@3ong]k@05
ocXj>_lT92Co/;2`ong]kOo?cll00_o_knl01_lY:BWoRHV9ono_koo`l?3o
QXJ6obd];@;ol?3`00Ko?3`logMgMoo`l?3ol?3`oc`l??mgMgL3oo7al@08
oo;bl_oclo?om?CdooCdm?nNWYkoGEeMocHf=_n^[Zh3ooGem@04oc<c<om_
KfoomOGeooGem@;om_Kf00?oRXZ:o`@41?obl_800oogmoL5ooShn0_onOWi
0_ojn_X3ooclo0;oo_kn>oooool01?lKG[?oYLCVokG@k_mi[^`2ojOLo`04
ofYZJ_n^[Zkof=SHonCTi5_oi^KV00Co4A`:o`TB2_l92@[o2@T:0_l94PX0
1_lA70[o2@T:o`T92_l0003o4A`:ob<V2P?o2@T:0_l94PX00ol0003o2@T:
ob`B0009o`T92P03oa4L2_l92@[o2@T:00Oo2@T:00?o2A8:oa4L2_lJ4Q@0
0_lA70X01Ol92@[o4A`:o`000?l92@[o2A8:00;o00000_l94PX00ol0003o
2A8:o`TB2P02o`T92P09oa4L2_l0003o2@T:o`TB2_l0003o2@T:o`TB2_l0
003o2A8:00;o2@T:0ol94PX00ol0003o2@T:o`T92P03o`T92P06o`000?l9
2@[o2@T:o`TB2_l92@[o2A8:1?l92@X00ol94P[o0000o`TB2P02o`000004
o`TB2_l0003o2A8:o`0000Co2@T:0_l94PX04?l92ACo4BHNoa4_<ol92@[o
2BHYoa4V7_lA9P[o2A`Do`T95?l99RWo2A`Noa4V5?l92ACo2A`Nob=1D_l9
4PX2o`T95004obaEKol971Co4BHDo`T92P;o2A8:00?o0000o`T92_l94PX0
0_l000000ol92@[o2A8:o`000004o`T92P03o`TB2_l0003o2@T:00;o2A8:
00Oo2A`Do`TV:OlA;c?o?Blmol77c?nVan3o2D5700?o8d5B01?o4BmBobaN
?OlA;c?oH5hcomc7Xol/C2WoWXdcoceN?Ol0003o;4`Yo`T95?l94P[o0000
ol6QQ?o:d<7o`LO1ol[@e_oLhmKodn?e00;oH5hc00Go0000o`TB2_l94P[o
2@T:o`TB2P05o`T92P0<oa4L2_lJ4QCoPg/codH_2_lA9QkoNd`Doij=:On`
ZXCob[j]odmWAol0003o2A8:0ol92@X00ol0003o2A8:oa4L2P02o`T92P06
o`000?lS9P[oUIQVol6cS_l0003o4A`:0_l92@X06OlA70[o2A8:o`T92_lJ
2@[o2@T:oa4L2_l92@[o4A`:oaX92_l92@[o;180o`T92_lJ2@[o2@T:oa4L
2_l/4P3o2@T:oa4L2_lJ2@[o;180oa4L2_lJ2@[o2@T:ob`B0?l92@X00_lJ
2@X02?l94P[o6PT:oaX92_lS70[o6PT:o`T92_l0003oYZZSGooVi^H01?nM
WIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h03?o/k>cog=cLog]kNooIfMWo
gmoOon7QhOoDe=Coa/K6olc<c?o>c/kod=3@omCDe0koeMGE0ooFe]H06?oo
oOoooocoooomooofn__ohNoFol7LYOmhXdOoO;90ohS8C_n@df;oVmZ1oj7K
SonXg9Co/N2Bok[VQonnj8Ko_NVBokcYV?nlj9Wo_NVJokoYWOo0jYko`N^Q
ol;/Y0Coa>bU0_o6k:<00oo6k:7oa>fQolC/X`0^olC/X`Wo`nfS0_o1jj40
5oo2k:;o`N^Qol7[XOo0jZ3o_^RNokkYV_noii7o_>N>okOSS_n^gHcoZMf:
ojKNQOnMfGOoUM=Xoi3:F_ml/DGoMj=4okcLTooQll_omOgboooloooonooo
ooko00Cok>c/00?oe=CDo`410On8R8P00_o/k>`3ong]k@05omOGeom@D53o
3@d=o`X:2_lS8b<00_o_knl01_ln?SkoU9BDono_koo`l?3oTI6Aod51@@;o
l?3`00Ko?3`logMgMoo`l?3ol?3`oc`l??mgMgL3oo7al@03oo;bl_oclo?o
m?Cd00;om?Cd00ComOGeom?Cdol20P;oc/k>0_oemOD01?lc<c?oKfm_ooGe
mOoemOD2ooKfmP03odm?ColZ:R[om_Kf00;on?Sh00?omoOgooWinOoinOT0
0ooinOT;oo[jnP;ono_k0_olo?`00oomoOgoo_knooknoP0kooooo`04oa]O
]_nTa>Ko^=;^ogJ]jP;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h02_l9
2ACo4A`:o`T92_lA70[o2@T:oaX92_l92@[o4A`:o`T92_l94PX5o`T92P03
oaX92_l92@[o2A8:00Co2@T:00Oo2A8:o`T92_lA70[o2@T:oa4L2_l92@[o
6PT:00Oo2@T:00Go4A`:o`T92_l94P[o2@T:o`TB2P02oa4L2P03o`TB2_l9
2@[o2@T:00Go2@T:0_l000000ol92@[o0000o`T92P07o`T92P05o`TB2_l9
2@[o2A8:o`T92_lA70X01?l92@X01Ol94P[o2@T:o`T92_l92@[o4A`:00Go
2@T:00?o4A`:o`T92_l92@X00_lA70X03Ol94P[o4A`:o`000?l92@[o2A8:
o`000?l94P[o0000o`TB2_l0003o2A8:o`000?lA70X00_l000001ol92@[o
2@TDoa4_<ol99RWo2@T:oa4V5?l971@00_l92A@03_lA;e;o2A`Noa4L2_l9
2ACo2A`Noa4V5?lAC5;o2@TDo`000?mbEE;o4BmBo`T92_l971ko2A8:0_l9
2@X00ol94P[o2@T:o`TB2P04o`T92P;o2A8:00Co2@T:oa4L2_l94P[o2@T:
0ol94PX01Ol92@[o6Q8Dob<_:OlA;c?o8d5B00?o2BHY00Co?G:4ob=1?Ol/
EEcoCg9k0_lA;cd04oo]d9So=5DYoa4L2_lS;ako0000oh=k<ol94P[o2A`N
of0_2_o1/jgo`LO1om?Ie_o:d<7og>?Fok2n`OmbIe;oLXdmofYW<ol92@X0
0_l94PX01?l92@[o4A`:o`T92_lA70X2o`TB2P0?oa4L2_l92@[o8bH:ob<L
2_n3GQCo4BHDof0_2_nNSBWoYYQ_om>nS_m?IdOo0000o`TB2_lA70[o2@TD
00;o2@T:00?o6PT:o`T95?l/71@00_m69Q@01OnNNc?oUHeVok2ZQ?l0003o
4A`:00;o2@T:00?o6PT:o`T92_l92@X00_l92@X01?lJ2@[o2@T:oaX92_lA
70X2oaX92P03o`T92_lJ2@[o2@T:00;o6PT:00?o2A8:oaX92_lA70X00olJ
2@X00ol92@[o6PT:o`T92P02oa4L2P08oaX92_l92@[o6PT:oaX92_lA70[o
8a`:o`000?n`/kMOonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002oooo
o`0<oogmoOo/k>coO7alom[Jf_oOgmoohN7QomCDe?o6a/Koc<c<olk>c_o@
d=3odm?C3_oEeMD3omKFeP0Hoooloooon_oooogoooKkmooXmm[ob>JZog2M
?_mc[3WoP<59ohW=G?nEeW[oW=N7oj7ER_n[f8Oo]=ilokKPN_nfhhSo]>B>
okGUSongii?o^^NDok[WU_njiYOo^^JI0onliYX00onliiSo_NJHokgVU`03
okgVU`0ookcWUonliiSo_>NGokcWV?nliiOo_>NHokcWUonliiSo_>NGokcW
V?nliiOo_>NHokcWUonliiSo_>NGokcWV?nliiOo_>NHokcWUonliiSo_>NG
okcWV?nliiOo_>NHokcWUonliiSo_>NGokcWV?nliiOo_>NHokcWUonliiSo
_>NGokcWV?nliiOo_>NHokcWUonliiSo_>NGokcWV?nliiOo_>NHokcWUonl
iiSo_>NGokcWV?nliiOo_>NHok_XUonkiiSo^nRGok_WV?nkj9Oo^nNHok_X
UonkiiSo_>VHokcXVOnljISo^nNHok[WU_niiIKo^NBB00;o^>2:00oo/Mb:
oj[JQ_nSfH7oWMUioiGDJon<c5[oPl=;og:[>?m_WC[o`N>IonWkdoofnoCo
oo_oooohoooooOl01?o/k>`00oo7alOo0@41omGEe@02onc/k0KokNg]00?o
jn_[onk^k_o_knl01?o_knl5oo3`l006oc`l??mgMgOol?3`oo3`l?ll?3co
MgMg0ooalO42oo?cl`?omOGe00Com_KfooGemOlJ6Q[oV9RH0_ofm_H02Old
=3CoKfm_ooKfm_ofm_KomoOgoiZJV_l0003oW9bLooShn003ooWin@?on_[j
0_okno/=ooclo0;ooOgm00?oo_knooooooooool0>oooool01?lMGk?oY/KV
okK@k_mi[nh2oj_No`04ogIfM_o1`L7ol?3`oogmoE_ooooo00?o6Q8Doa4L
2_l92@X01Ol92@X01?lA70[o6PT:o`T92_l00002o`T92P04oa4L2_l0003o
2@T:oa4L2PGo2@T:00Go2A8:o`T92_l92@[o2@T:o`TB2P02o`T92P03oaX9
2_l92@[o2@T:00?o2@T:00?o6PT:o`T92_lA70X00_l92@X01OlJ4QCo;2HD
o`TB2_l92@[o000000?o2@T:00Go0000o`T92_l92@[o2@T:o`TB2P02o`T9
2P05o`000?l92@[o2@T:o`T92_l000000_l92@X00ol0003o2@T:o`T92P04
o`T92P03o`TB2_lA70[o2@T:00?o2@T:00?o0000o`TB2_l94PX02Ol92@X0
0ol0003o2@T:o`T92P02o`T92P03o`000?l94P[o2@T:00;o2@T:00?o0000
o`TB2_l92@X00_l92@X00ol94P[o2BHYo`TV:@02oa4V7P0Do`000?lA9Qko
2A8:o`TV:Ol971ko2A`Do`T95?l0003o;5ELoa4_<olA9P[o?Blmog9bNolA
;cgo2A`No`T95?l0003o2A8:o`T92_l00008o`T92P04o`000?l94P[o0000
o`T92P?o2A8:00Co4BHDo`T92_lJ71ko4Blm0_lA9Qh07?lJ71ko;5ELobaE
G?l/EEcoCg9kocebQ?lS@E;oPg]Log:=?Ol0003o2A8:o`000?n3GS?oYZ5V
o`000?mP;`[ob]31ol[@e_oCfMKo`LO1omcSe_n`_/7o4A`:odI17_mZEAko
LXdmoc@_<ol00002o`TB2PKo2@T:01;o0000ob<V2_l/9QCoAUDYob`V5?mk
C0[o/8eBol6cS_oLaj?oAUDYoa4L2_lJ2@[o2@TDodHV2_lS70[oSED:of0_
5?n3GQ@2oiib5005ohf=Aoo1/hko/:Z4ol6cS_l000000_l92@X00olJ2@[o
4A`:oaX92P02oa4L2P?o2@T:0_lJ2@X02OlA70[o6PT:oa4L2_lJ2@[o4A`:
oaX92_l92@[o6PT:o`T92P02oaX92P05o`T92_lJ2@[o4A`:oaX92_l92@X0
1?lJ2@X01_lJ4QCo4A`:o`T92_lJ2@[o0000oiFZ[Eoooooo00Co[jn_ol_;
booNg]koj^[Z0Oobl_8000;ok^k^00cok>c/omcLg?mlO7cofMWIon3Ph?oQ
hN7oeMGEolS8b?o;bl_oc/k>om3@d?oCdm<>omCDe0?oeMGE01Sooo_ooooi
oooooOoon?ggoo3oiOoBkkGoKY]0ofnY>Omb]SgoOL=?oh_=JonCcgWoVLil
oj?@Non^eWKo/]YgojoLOOn`gh?o/n:6okGSROnfi8co]^>>okKRSOndghd3
okGOS@;o]Mn;00?o]Mn9okOOROneghT00_neghT0?_negh_o]Mn9okGORone
ghWo]Mn;okGOROnegh_o]Mn9okGORoneghWo]Mn;okGOROnegh_o]Mn9okGO
RoneghWo]Mn;okGOROnegh_o]Mn9okGORoneghWo]Mn;okGOROnegh_o]Mn9
okGORoneghWo]Mn;okGOROnegh_o]Mn9okGORoneghWo]Mn;okGOROnegh_o
]Mn9okGORoneghWo]Mn;okGOROnegh_o]Mn9okGORondh8Wo]>2;okCPROnd
h8_o]>29okCPRondh8Wo]>2;okCPROnehHco]^:;okKRSOnfhX_o]N6<okCP
ROncgh[o/mf90_nbehL03on[eXCoY=AnoigDM_nFdf_oRLaIogo3B_md]3[o
JjDdog6N?oo=kZWolooPooOim?oon_ooooWoooomo`02on[ZjP?ojn_[00Go
A4A4ocDe=On2PX;oFUYJoe5AD@02on_[j`?ok>c/0_o]kNd3onk^kPOokno_
00Ko>c/kogMgMoo_knool?3`oc`l??mgMgL3oo7al@09oo?cloobl_;om?Cd
ohb<S?mYJFWoV9RHoeaLG?l=3@goinOW00;om_Kf00Wo=3@dob`/;?mPH63o
C4a<ob/[:ol61PKoRXZ:ooKfm_ogmoL00oohn?P5ooWin@_on_[j0_okno/2
ooclo003oogmoOono_koo_kn03_ooooo00Co6UbcojC3iOnhd^ooNJk/0_n/
gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP09o`T95?l92@[o2A8:o`T92_lA
70[o2@T:o`TB2_lA70[o000000Co2@T:00Go2A8:o`T92_lA70[o6PT:o`TB
2P04o`T92P08oa4L2_l94P[o2@T:oa4L2_l92@[o6PT:o`T92_lJ2@X7o`T9
2P04oa4L2_l94P[o2@T:oa4L2P;o6RHD00Co0000o`TB2_l0003o2@TD0_l9
2@X00ol0003o4A`:o`T92P03o`000003oa4L2_l0003o2@T:00Ko2@T:00?o
2A8:o`T92_l92@X00_l92@X00ol0003o4A`:o`000009o`T92P04o`TB2_l9
2@[o2@T:oa4L2P?o2@T:00Oo2A8:o`T92_l92@[o0000o`TB2_lJ2@[o2A8:
00Wo2@T:01?o4BlmobaN?OlA;c?o0000of1bNon3V:goUJ6go`TL5?l971ko
2A`Doa4V5?l92@[o;6MLo`TB2_l971CoPbmLocAWNol99RWo4BHN00;o2A8:
0_l92@X01Ol92ACo2A8:o`TB2_l92@[o2A8:00Ko2@T:0_l94PX00ol92@[o
2@TDo`TB2P02o`T9500Ko`TV:OlS;bWo8blcob<_:OlA;cgoCeiVobaEKomG
SHko=6Mko`U1AonELTOoLXdmo`000?lA70[o0000oc@_7_niZVoo;4`Yog8h
5?o:d=Kob]31ol[@e_n`/kOokNgZoiFZ[Ol0003o;1`D00;oAT4N00KoJVLc
ofYE7_lS;ako2A8:oaX92_lA70X6o`T92P0IoaX92_ld;akoARl:oaXL7_mk
C0[oYXABokVZKoo:_ZgoYZ5VoheE2_nES@3o/7/:oij=<onNNc?o/8dNohf=
Aon3Nc?oYXABojJQI_n`ZXCoYZZSok2ZQ?nVXFKo2A8:oaX92P02oa4L2P03
oaX92_l92@[o2@T:00;o6PT:00Co4A`:o`T92_lS70[o4A`:1OlJ2@X01olA
70[o;180oaXB5?lJ2@[o2@T:oaX92_lS70X00ol92@X01?lA70[o6PT:oa4L
2_l92@X2oaX92P05ob`B0?lJ4QCo6PT:o`000?nEXHh0Goo^k^h01?nSXj?o
_Kfmolo?cooJf]X1on7Qh@000_oVi^H03?oTi>Coe=CDogalO?oIfMWoh>3P
on7QhOoEeMGoalO7ol[:b_o>c/kod=3@om?Cd`koe=CD0ooEeMD06?ooo?oo
o_Woooomoooio_[omoo_omWea?m`Vd_oL:LoofRY=Omd^DCoPlIMohc9J_nD
bW;oX<ifojgDNOnaf7_o[=MkojkKP?nagHCo]N68okKRSOndh8_o/mf;ok7K
R@;o]]f>0_nfgH`2okKMRP03okOMR_nfgH[o]]f:02ko]]f:2ondgXX05one
gh_o]=j:okCNR_ncgHWo/M^7ok7KROn/d8Ko[M67ojOBP_nPdGKoV=5Zoho?
GOn2aTgoMk]0ofZY=?mYXCKoMJ5<omSf^_ohon[omoWdooojoooonOoooogo
00;ojn_[0oo/k>`01OoXj>SoZ:RXofEUIOmmOGgo/K6a00GokNg]0_o^k^h5
ono_k`Gol?3`00Ko?3`logMgMoo`l?3ol?3`oc`l??mgMgL3oo7al@08oo?c
loodm?Com_Kfolg=cOn:RX[oJ6QXoiJFU_oHf=P3ooOgm`06ojZZZ_nEUIGo
UIFEoibLW?nn_[koi>CT0oohn?P2ooWin@03ooShn?oinOWonOWi00?onOWi
2oojn_X2oo_kn`;oo?cl00?ooOgmookno_ono_h0>oooool01?lMGk?oYLCV
okKBk_mi[^T2oj[Po`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00_o6Q8Doa4L
2_l92ACo4A`:o`TB2_l92@[o6Q8Do`T92_lA70[o2A8:oa4L2P02o`T92P09
oa4L2_l92ACo2@T:oa4L2_l92@[o4A`:o`T92_lA70[o6PT:00?o2@T:00So
4A`:o`T92_l92@[o2@T:oa4L2_l92@[o4A`:oaX92P;o2@T:00Wo;180o`T9
2_l94P[o2@T:o`TB2_l971Co;3PYoa4L2_l000000_l92@X01?l0003o2A8:
o`000?l94PX2o`0000;o2@T:00Co2A8:o`T92_l94P[o00000ol94PX4o`T9
2P03o`TB2_l92@[o2A8:00;o2@T:0_l94PX00olA70[o2A8:o`T92P03o`T9
2P03o`000?l92@[o2A8:00;o2@T:00Ko2A8:o`T92_l92@[o2A8:o`T92_l0
0002o`T92P03o`TB2_l0003o2@T:00Co2@T:00?o2A8:o`T92_l92@X00_l9
2@X05_lA9QCo4Blcoa4_?OlJ71koLW9kof1bNolm;cgoUIRSo`TL7_lA9P[o
2A`Do`T95?lJ4QCo4BmBo`T95?mGGVoodn?eobaEKol971Co4Blcoa4V7_l0
0004o`T92P03o`T95?l92@[o2A8:00;o2@T:00Oo4A`:o`T92_l94P[o2A8:
o`T95?lJ4QCo2A8:00?o2@TD00Co4BHDo`TV:OlA;c?o4BmB0_lS@Cd0=om?
LW_o4DaBoeN=S_lS@E;o6RHDoba<:Ol0003o4A`:o`T92_l/71Co`K>>o`TB
2_m69QCog>?Pong]j_nVZZ?oYZ6Hong]j_l/C2Wo0000o`T95?lJ4QCo8a`:
odIE:OmZEAkoUIQVodI17_l94P[o2@T:oa4L2_l92@[o2A8:oa4L2_l92@[o
4A`:o`T92_l94P[o8bH:ob<_7_lA9P[oNd`Doij=<on`ZXCob[j]ofYE7_o1
/hkobZ5BolZZI_nVXFKo/:Z4omc7Xoo1/hkoYZZSolZn[OnVXIP00_n`ZX@2
ojJQV004o`TB2_lA70[o6PT:o`T92P;o4A`:00Go2@T:oaX92_l92@[o2@T:
ob<L2P04oaX92P05o`T92_lA70[o6Q8Dob`B0?lJ2@X00_l92@X02ol/4P3o
6PT:o`T92_lA70[o2@T:oaX92_lA70[o6PT:ob<L2_lJ2@[o2@T:00?o6PT:
00?o2@T:oaX92_nEZZd0GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00
0_o^k^h03?o/k>cog=cLog]kNooJf][ogmoOon7QhOoEeMGoa/K6ol[:b_o>
c/kod=3@om?Cd`koe=CD0ooEeMD05_ooo__om_;aooonoooloooon?ohomkf
e?nWbh_oFH``of>Q=?mZ[CWoNKa;oho<I?n;`F?oX<idokcTS_ndfXOo^N2?
okCNS?nfgi3o_^NHol?YW_noiIX2ok_QV0;o`>BN0_o0i9`5ol;TVS3o`>BJ
1onoiIX00oo0iY_o_nFJol3VV`02ol3VV`0DokgSV?nhgY?o]=VCokWLW?o0
iJ;oXlinojOIN?nLeVKoO[i4ogk0@_mQXbSoEI0Tof>F>_nD^gSol_oOoo?o
jOojnoKooo_oooofooooo_l9onk^kPOokno_1_o`l?05oo7al@06ong]kOo_
knoolO7aoo7alOo]kNgokno_0oobl_82ooCdm0?om_Kf2_ogmoL=ooShn0_o
nOWi0_ojn_X3ooclo0;oo_kn>oooool01?lKG[?oY/KVokWCk_mi[^/2oj_O
o`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00?o4A`:o`T92_lA70X00_l92@X0
0olA70[o2@T:o`T92P03o`T92P04o`TB2_l92@[o2@T:o`T92P;o2A8:2?l9
2@X01_lJ2@[o2@T:oa4L2_l0003o4A`:oaX92P;o2@T:00co2A8:o`T92_l9
2@[o2@T:o`TB2_l0003o2@T:ob`L5?l/C2Wo2@T:o`TB2_l92@X2o`TB2P03
o`000?l94P[o2@T:00;o2@T:00?o0000o`TB2_l000000_l92@X00ol94P[o
0000o`000002o`TB2P;o2@T:00Ko2A8:o`000?l92@[o2@T:o`TB2_l00003
o`T92P03oa4L2_l94P[o2A8:00Ko2@T:00?o4A`:o`T92_l92@X00_l92@X0
0olA70[o2@T:o`T92P02o`T92P06o`TB2_l92@[o2A8:o`T92_l94P[o0000
0_l92@X06Ol94P[o0000o`T92_l92@[o4Blmoa4_<olA;cgoPiR]oh>4S_mb
EE;oPhf4o`T95?l94P[o2@TDo`T92_l99RWo4BmBofYkKon3;ecoUJ6godmb
Nol/GSgo4BHNob<_:Ol000000_l92@X3o`TB2P;o2@TD00Co2A8:o`T95?l9
2@[o4A`:0_l92A@07Ol94P[o6Q8Do`T95?lA70[o2A`Noa4V7_l971ko6Q`N
o`TV:OlS;c?o;5ELobaWG?lS@E;oEhf>ob<_:Ol971Co6PT:o`T92_l92ACo
0000oiEbAonVXFKo0000ojJQV?o:d<7og>?PojJQV?oCfMKodn?e00;o0000
0ol92@X02olS70[o=2lNofYW<on3Nc?oYZ5Voa4V2_l94P[o4A`:o`TB2_l9
2@[o000000Co2@T:00Ko6PT:ob<L2_ld;akoJUDNojJQI_o1/hh2ok2ZQ007
ol6cS_o:_Zgob[j]ojJQV?oC_Xko`K>]okVZK`03ok2ZQ00;ojJHKoo1/jgo
YYQ_ok2ZQ?l0003o2A8:oaX92_lA70[o6PT:oa4L2_lJ2@X00_lA70X5oaX9
2P06ob`B0?lJ2@[o6PT:oaX92_l92@[o;1800_lA70X01Ol92@[o4A`:oaX9
2_lJ2@[o4A`:00;o2@T:00Go6Q8Do`T92_lA70[o6PT:oa4L2P03oaX92P03
o`000?nEV:?ok^k^05kok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;o
oooo00cooOgmonc/k?mgMgOof][Jon3Ph?oQhN7oe=CDolO7aoo<c<coclo?
om3@d?oCdm<>omKFeP?oemOG01Soooofoooon_ooo_oonocooo?lmooconoo
^MJVoeEo=Om=Pb?oFI@XofVW>?mg/TKo]N^9okk/U?ncfX_od_J/olW]YOo4
jJ?o`nRSolS]Z?o<kjoobNb/olSZ[Oo9jjh2ol[Y[P;ob^V]00?obnV]ol_Y
Zoo;jJ/00_o;jJ/`ol[ZZ`Oob>^[00?obNb/olS[Zoo9k:`00_o:kJd05?o9
k:coaNRXol?UZ?nfeikob^j^ol7/W?ngjHKoULiKog6_<_m_[cCoI:<`of6G
>OmKQSko]MFTon_ohookooKoo_gkoooko_ooo?ooooko0_oZj^X7on_[j`?o
k>c/0oo]kNd00oo_knook^k^oo3`l002oo3`l0;olO7a2oobl_84oo?cl`Co
m?Cd2_oemOD3ooKfmP;omoOg0_oinOT01?ohn?Son_[joo[jn_ojn_X2oo_k
n`goo?cl0_omoOd00oono_koooooooooo`0kooooo`04oamQ]?nS`^Co^=?_
ogN^j`;oZ]oo00CoMWIfol71`Oo`l?3ooOgmFoooool01?lJ2@[o4A`:o`T9
2_lA70X2o`T92P05oa4L2_l92@[o4A`:o`T92_l94PX00_l92@X2oa4L2P04
o`T92_l/4P3o0000oa4L2PCo2@T:00Ko4A`:o`T92_l92@[o2@T:o`000?lA
70X2o`T92P03oa4L2_l92@[o4A`:00;o2@T:00Ko4A`:o`T92_l92@[o2A8:
oceN?OldEBT2o`000007o`TB2_l0003o0000o`TB2_l0003o6Q8Do`000002
o`T92P03o`TB2_l92@[o2@T:00Go2@T:00?o0000o`TB2_l92@X00ol92@X0
1Ol94P[o2@T:o`T92_l94P[o4A`:00;o2@T:00Co2A8:o`T92_l92@[o2@T:
0_l94PX00olA70[o2A8:o`T92P03o`T92P04o`TB2_l92@[o2@T:o`TB2P?o
2@T:00Co0000o`T92_l92@[o00001_l92@X01_lA70[o4Blcoa4V7_l99RWo
;5ELoiFHX`;o?Blm01WoCfMLo`000?l92ACo2A8:ob=1?OlA;cgo8blcok2c
]olmLXCoPiR]ocAE?Ol971ko4Blcoa4V5?lA70[o6Q8Doa4L2_l92ACo4BHD
o`TL5?l92ACo4BHNoa4V5?l971ko4Blc00?o6Q`N00KoAUEBob`h:OmGEE;o
8d5Bob=1?OlA;c<2ob=1?@;o;5EL01Ko4DaBodmbNol/GSgo0000o`T95?lA
70[o2@TDob<V2_mZIc?o=5DYoaX92_o:_Zgob]3FonC@c?nVXISog>?Pog^=
Q?mZ@@[o=5DYo`000?l94P[o4A`:0_l92@X01_l/9QCoARl:oh=k<om6C3go
SHeBo`0000?o2A8:00Go2@T:o`TB2_l92@[o4A`:o`T92P02oa4L2P0Koc@_
7_nNLP[o^IQLol6c[Oo:d<7o`K>]ol6cS_oLaj?ob]31oh=k<oo1/hko/;>g
om>nS_nVZZ?o/:Z4oiFZ[On3Necob]3Fog^=Q?nVV6oo0000oaX92_lA70[o
;2HDo`TB2_lJ2@[o4A`:00;o6PT:00Ko2@T:oa4L2_lS70[o6PT:ob`B0?lJ
4Q@2oa4L2P03o`T92_l/4P3o8a`:00Co6PT:00?o4A`:oaX92_lJ2@X00_lA
70X01?l92@[o6PT:ob`B0?lJ2@X2oa4L2P;o8a`:00?o0000ojJZ[Oooool0
G_ooool01?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h01?o/k>cog=cL
ogIfM_oIfMT2omoOg`06omCDe?o7alOob/[:olk>c_o@d=3odm?C3_oGemL3
omSHf00DookokoooooKoooooooOho?oho?oon?ojon3ee_n>[gSoH8dlodYn
7?m[XS[oNk9:oiO;JOo2l9So/mb@ok_PVoo<k[7ob>V`olGV[oo7j;42ol[X
]P03ol_X^?o=j[cobnJi00;obnJi00CobnNgolcV]oo<i[Ooc>Jf<?o;ikH9
ol[X]P?obNNe01Kob^RfolcZ^?o<j[Sob^RfolKV]?oCm/3o^n:SojoJR_ni
jhSo/>IdohBnA_mMURGoBX4Lodmk<?n3Z7Coj?oSooGom?okoo[oooomooom
nooonoWoooom0_oZj^X:on_[j`?ok>c/0_o]kNd3onk^kP[okno_0oo`l?03
oo7al@03oo;bl_oalO7ol_;b00;ol_;b0_oclo<8ooCdm0?omOGe0_ofm_H3
ooShn0?on_[j0_okno/=ooclo0;ooOgm00?oo_knooooooooool0>oooool0
1?lOH;CoYLCVokWCkomg[^/2ojWLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^
00So6Q8Do`TL5?l92ACo2@T:o`TB2_lA70[o2@T:oa4L2P;o2@T:00?o6PT:
o`T92_lA70X01?l92@X01OlA70[o2@T:o`T92_l92@[o4A`:00Go2@T:00Go
;180o`TB2_l92@[o2@T:oaX92P03o`T92P09ob`B0?l94P[o2@T:o`T92_lJ
2@[oCfMLoaXV5?l92@[o2A8:00Go2@T:00?o0000o`TB2_l92@X01?l92@X0
0ol94P[o2@T:o`TB2P04o`T92P0;o`TB2_l92@[o2@T:o`TB2_l0003o2@T:
o`TB2_l92@[o2A8:o`T92_lA70X01Ol92@X00ol0003o2A8:o`T92P04o`T9
2P03o`TB2_l92@[o2@T:00?o2@T:00?o0000o`T92_l92@X01?l92@X06_l9
4P[o2@T:o`000?l92@[o2@TDoa4_<ol99RWo4Blco`TB2_m?GVKoARHDoh>4
S_l99RWo2A`DoaXB5?l99RWo4Blmo`T95?mZNfooY/OPoa4_D_oChoGo2A8:
oa5<D_lA;c?o2A8:0_l92A@02Ol92@[o2@TDo`T95?l94P[o2@TDoaXB5?l9
71Co4BHNoaXL7P02o`TV:@0?oa4_<ol/EEco8d5Bog9bNol/EEco;5hmob=1
D_mGGVooAVMLodmbNolS@E;oEhf>obaWG?l0003o2@T:00?o4BHD00co8blY
o`000?nVV8Cob]31ol77c?o:d<7o`LO1om?Ie_lA9P[o;180ofYE7_n3Nc<3
o`TB2P0;oa4L2_l92@[o2@T:odI17_n3Nc?oLXdmoiEbAol/C2Wo2@T:o`T9
5?l94PX00ol92@X2o`TB2P0Ko`T95?lA70[o;1`Doh=N5?niV5co/:Z4ombn
[Oo1/hko/:Z4ol6cS_oLhn3oPehconC@c?nESFKob]31og9bNoo1/hkoPhAk
oiEbAooLaj?oYYR4ojJHKol0003o4A`:o`T92_lJ2@[o2@T:00?o6PT:00?o
4A`:o`T92_lJ2@X01?lJ2@X00ol92@[o6PT:oaXB5004oaX92P08o`T92_lJ
2@[o6PT:oa4L2_lJ2@[o2@T:ob`B0?lJ2@X2oa4L2P03oaX92_lA70[o6PT:
00;o8a`:00?o0000ong]j_o^k^h0G_o^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@000_oVi^H03?oTi>CoeMGEog9bL_oGemOogmoOon3Ph?oBd];oalO7
ol[:b_o<c<cod=3@om?Cd`koe=CD0ooEeMD06?okoo3on_gboooooOooo_oo
o?gooocoooohooCohoWCofB6BOm5L23oC7dQofnS@On:^eoo]^J@ok?MTOo?
m[?obNbbolOZ]?o6jK?oa^ReolOW]_o8j;Wob>NkolWX_0;obnRl00?obnNn
ol_X_?o<ik`00_o<ikX0D_o<j;Soc>Njol_X^?o;j;[obnRhol_X^_o;j;So
bnRjol_X^?o;j;[obnRhol_X^_o;j;SobnRjol_X^?o;j;[obnRhol_X^_o;
j;SobnRjol_X^?o;j;[obnRhol_X^_o;j;SobnRjol_X^?o;j;[obnRhol_X
^_o;j;SobnRjol_X^?o;j;[obnRhol_X^_o;j;SobnRjol_X^?o;j;[obnRh
ol_X^_o;j;SobnRjol_X^?o;j;[obnRhol_X^_o;j;SobnRjolWY^?o9jK[o
bNVholWY^_o9jKSobNVjolWY^?o9jK[ob>RgolOW^?o8j;Oob^Zkol[Z^Oo:
j[_oanVfokKLXoo1jZKoaO:QojKEMon2]DcoK:0doe617_m2KA_oNiiTomGa
boodooKonOomooCfmOonoO_oookjooojm?ooood2on_[j`Ook>c/1_o]kNd0
0oo^k^kokno_oo3`l004oo3`l0_olO7a0oobl_82oo?cl`?om?Cd2_oemOD5
ooKfmP;omoOg00?om_KfooOgmoogmoL00oogmoL;ooShn0;onOWi0ookno/2
oogmoA7oo_kn:_ooool01?lKGkKoY<CVokWCkomf[NX2oj_Po`04ofYZJ_n^
[Zkof=SHonCTi5_oi^KV00Ko4A`:o`T95?lA70[o4A`:o`T92_lJ4Q@5o`T9
2P03ob<L2_l92@[o2@T:00Co2@T:00Ko4A`:o`T92_l0003o4A`:o`000?lA
70X2o`T92P06oa4L2_l0003o2@T:o`T92_lA70[o2@T:0_lA70X2o`T92P0=
o`TB2_l0003o2@T:oa4L2_m?IdOo2A8:oa4L2_l0003o4A`:o`TB2_l92@[o
2A8:o`T92P03o`TB2P;o2@T:00Co2A8:o`T92_l0003o2@T:0_l94PX01_l9
2@[o2A8:o`TB2_l92@[o2A8:o`0000;o2@T:00Go2A8:o`000?l92@[o2A8:
o`000006o`T92P03o`TB2_l0003o2@T:00;o2@T:00Go4A`:o`000?l0003o
2@T:oaXB5003o`T92P06o`TB2_l92@[o4A`:o`000?l92@[o2A8:0_l00000
2ol92@[o2A8:o`000?l92@[o2BHYoa4_<ol971Co2A8:odIWG?l99RWo2A`N
00;o2BHY00?o2A`Noa4V7_l99RT00_l99RT02Ol9@DOoCeiVojJc`Ol92ACo
8d4moa4V5?l92@[o2A`DoaXB5002o`TB2P0:o`T95?l94P[o4A`:o`T95?lJ
4QCo4BHNo`TV:OlA9Qko2BHYoaXL7P;o8d4m01Ko4DaBob=1?OlA;e;oCg9k
ocebQ?m?LW_o=6Mkog:=[OmGSEco0000o`T92_l971Co0000o`T95?l92@[o
H44Yol6c[On`_/7ob]31ol77`Oo1/jgog>?P0_l000001?lJ4QCo;180og:=
?OmPGS<2o`TB2P0<o`T92_lA70[o2A8:ob`B0?m6@AkoWW/coh=k<onESE;o
=2lYo`T95?l92@[o4A`:0ol92@X06_l94P[o6Q8Dob<V2_l/9QCoPg/cokVZ
KooL/j?ob]31oh=kG?o:_ZgoPehcomcSh?nELTOob]31oiF4Noo1/jgoJVLc
ol6cS_nEV6KoUHAkol77`OnVV8CoSHe7o`000?lJ2@[o2@T:0_lA70X02?l9
2@[o6PT:o`T95?lA70[o2@T:ob<L2_lJ2@[o;1800olJ2@X02_lA70[o6PT:
oa4L2_lJ2@[o;180oa4L2_l92@[o4A`:oaX92_lA70X2oaX92P05o`T92_lJ
2@[o6PT:oaX92_lA70X00olJ2@X00olS70[o0000omcSh01OonKViP04oifM
WOng]kOob<S8om?Cd`7of][J0002onk^kP04onc/k?oOgmooLG5aolo?c`;o
gMgM00KodM7AolC4a?o8b<Sobl_;olo?cooBd]8AomCDe00Hoo_on?ohoOKo
o_omoooooooln_oomoGhoocon_ohonoolOoNofJ8C?m<M2_oGh`koi;2K_nF
aGCo`_6Soj?>Q_nhhIoo^n6TokgSY_nni:Wo`>>[ol3S[OnohZco_^2]0_o2
h[000oo2h[7o`^:`olCR/002olCR[P1?ol;S[?o2hjko`^>/ol;S[_o2hjco
`^>^ol;S[?o2hjko`^>/ol;S[_o2hjco`^>^ol;S[?o2hjko`^>/ol;S[_o2
hjco`^>^ol;S[?o2hjko`^>/ol;S[_o2hjco`^>^ol;S[?o2hjko`^>/ol;S
[_o2hjco`^>^ol;S[?o2hjko`^>/ol;S[_o2hjco`^>^ol;S[?o2hjko`^>/
ol;S[_o2hjco`^>^ol;S[?o2hjko`^>/ol;S[_o2hjco`^>^ol7T[?o1i:ko
`NB/ol7T[_o1i:co`NB^ol7T[?o1i:ko`NB/ol;U[oo0hj_o_n:/okoRZ_o0
hjgo`>>[okkQZonkhJKo]N2KojkLTOndi93oYM=kogbYC_mEP2OoCG<XofJ8
BooWomWom?oaonkilOokooooooooooglnP02ooonnP03oooooOoYjNWojNWY
00[oj^[Z0oo[jn/00oo/k>cokNg]onk^kP02onk^kP[okno_0oo`l?03oo7a
l@;ol_;b0ooclo<2ooCdm0SomOGe1Oofm_H2ooShn003ooOgmooinOWonOWi
00?onOWi2oojn_X2oo_kn`?oo?cl0_omoOdAooknoR[ooooo00Co6ejcojG4
i_ned>koNJk/0_nWg?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP0;oa4V5?l9
4P[o2@T:oa4L2_l94P[o2@TDoa4L2_l92@[o4A`:o`T92_lA70X00ol92@X0
3_lA70[o2@T:oa4L2_l92@[o2A8:o`T92_lA70[o2@T:oa4L2_l92@[o2A8:
o`T92_l94P[o4A`:0_l92@X00ol94P[o6PT:o`T92P06o`T92P07odINAom6
EBWoARHDoa4V2_lS70[o6PT:ob`B0002oa4L2P04oaX92_lA70[o;180o`T9
2P?o2A8:00So4A`:o`TB2_l94P[o4A`:o`000?l92@[o0000oaXB50?o2A8:
00Ko2@T:o`TB2_l92@[o2A8:o`000?l94PX5o`T92P03o`TB2_l0003o2@T:
00So2@T:0_lJ4Q@01?l94P[o6Q`No`000?l00002o`TB2P06o`000?l92@[o
2A8:o`T92_l94P[o00000_l92@X01?l99RWo4BHNo`TB2_l971@2o`T95008
o`TL7_l971Co2A`No`TB2_l99RWo4Blco`TB2_l92A@2ob=1DP03o`000?l9
9RWo2A`N00Co2A8:00?o2@T:o`TB2_l94PX00_l94PX04ol92ACo2A`Do`TL
5?m6C3go?BlmodmNI_l/EEco8d5Bob<_7_lA;c?o8d5BoeMNKom?LW_oEhf>
obaEKol/GSgo2A`Do`000?l94PX00_l92@X08?l0003oH44YolZn[On`_/7o
`LO1ojJZXon`/kOog>?Fol[@e_nVZZ?o0000oaXL7_l/71Co4A`:ofYE7_n3
GS?oPg/co`000?lJ4QCo2@T:o`TB2_l92@[oAUDYoc@_7_nESE;oLXdmoiF=
D_l0003o2A8:o`000?l92@[o4A`:0ol92@X06?lJ9QCo;2HDoiib5?nVXFKo
dkj>ol[@`OmbEE;odmWFoh=kG?oTd<coYYR4ol[@`OnVV8Co`LO1oh>4Noo:
d<7oSHe_ol6c[On`/kOo`K>>og:=?Ol0003o2@T:oa4L2P;o6PT:00Wo4A`:
oaX92_lJ2@[o;180oaXB5?l92@[o4A`:oaX92_lS70X01OlJ2@X00ol/4P3o
6PT:ob`B0002oa4L2P04oaX92_lA70[o2@T:ob<L2P;o4A`:00Wo6PT:oa4L
2_lJ2@[o6PT:o`T92_m6;`[o8a`:o`000?o:d=H0Goo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@000_ooool02_ono_kolO7aoginO_no_koof=SHom[J
f_o<c<co`L71olG5aOo:b/X2olk>cQ7oe=CD00ConOomoo_ooOonoogooogn
0_ooo?h04_onoOWonOocooSokOo[omcoH85:odef<_mDPSOoQ;ETogRYEon/
fh_oXln2ojWER_n^fXoo[mZBok7JU?nbfiOo/MZFojkGU@;o/MRG00?o/MRI
ok7HUonceiL00_ncf9D0D_ncf9?o/MREok7ITonaf9Go/MVCok7HUOnafI?o
/MREok7ITonaf9Go/MVCok7HUOnafI?o/MREok7ITonaf9Go/MVCok7HUOna
fI?o/MREok7ITonaf9Go/MVCok7HUOnafI?o/MREok7ITonaf9Go/MVCok7H
UOnafI?o/MREok7ITonaf9Go/MVCok7HUOnafI?o/MREok7ITonaf9Go/MVC
ok7HUOnafI?o/MREok7ITonaf9Go/MVCok7HUOnafI?o/MREok3ITon`fIGo
/=VCok3IUOn`fI?o/=VEok3ITonafYKo/=VCojoHU?n_f9;o[mRDojkGTOn/
eI7oZ=>;oj7BPOnFb7?oSKeYog^XEOm:LbGo=U/Eoh:QJ?oUo]ComOo]oo?o
lOokoogom?Ggooooooooo_ooo?Seooonnoooood2onWYj@[oj^[Z1?o[jn/4
onc/k0[okNg]1_o^k^h00oo`l?3okno_oo7al@04oo7al@Sol_;b0ooclo<2
ooCdm0;omOGe00Com_KfooOgmoogmoOomoOg0_ohn?P;ooWin@;on_[j0ook
no/2ooclo13ooOgm0oono_hXooooo`04oa]O]_nTa>Ko^=;^ogJ]jP;o[=oo
00CoMWIfol71`Oo`l?3ooOgmFoooool2oaXB5003o`TB2_lJ4QCo2@T:00;o
6Q8D00Ko4A`:o`T92_l92@[o2@T:o`TB2_lA70X6o`T92P07oa4L2_l0003o
2@T:oa4L2_l0003o2@T:ob<L2P02o`T92P04oa4L2_l92@[o2@T:o`T92P;o
6PT:00?o4A`:o`T92_l92@X00_l92@X02_m6EBWo=2lYodIE:Om69QCo4A`:
ob<_7_lJ9QCo4A`:ob<L2_lA9PX3oa4L2P0<o`T92_l94P[o6Q8Doa4L2_l9
2@[o6RHDoaXB5?l92@[o0000o`T92_l0003o2@TD0ol92@X00ol94P[o2@T:
o`T92P02o`T92P03o`000?l94P[o2@T:00[o2@T:00Go0000o`T92_l92ACo
2@T:o`000002o`T92P04o`T95?l92@[o0000o`TB2P;o2@T:01[o0000o`T9
2_l92ACo2A8:oaX92_l0003o4Blmo`TV:Ol92ACo6Q8Do`TB2_l971ko4BHN
o`T95?l971ko4BHNoa4_<ol99RWo2A8:ocebQ?lA;e;o4DaBoa4V7_l99RWo
2@T:oa4V7P;o6Q8D02[o2@TDoa4L2_lJ4QCo2A`Do`TB2_l92ACo4A`:o`TB
2_l92@[o2A`Noa4V7_lS;c?o8d4moa4_?OlA;e;o/;k1ojJZ[Oo]kN[oEhf>
oa4V2_lA9QCo0000oa4L2_l92@[o6Q8Do`T92_mP@BWoPhAkok2c]on3V8ko
/:Z4ok2c]ooCfMKog>?FohfHS_o1/jgodmWFo`000?l92@[o6PT:o`T92_l/
4P02oh=k<`03o`TL5?l94P[o4A`:00;o2@T:00?o;2HDofYW<omZEAh00_n=
SE801Om6@Ako2@T:o`TB2_lA70[o2@T:00;o4A`:00ko2@TDob<_7_m6;`[o
WW/cok2ZQ?o:_ZgoUJ6>ol6QQ?o1/jgo/:Z4ol[@`On`/kOob]31ojJZX`;o
b]3101OoYYR4ol[@`On3Neco`K>]ok2ZQ?lA9QCo2@TDoaXB5?l92@[o6PT:
oa4L2_lJ2@[o;180oa4L2_l92@[o6PT:ob`B0?l92ACo;180oaX92_lS70[o
6PT:ob<L2P03oaX92P03ob`L5?l92@[o6PT:00;o6PT:00So;180oa4L2_lJ
2@[o6PT:oa4L2_lJ4QCo4A`:oaX92P;o8a`:00Co6Q8Dob`B0?l0003og>?P
Goooool01?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h03?o]kNgoiNGU
oi6ATOnTY:Cod];BomCDe?o2`/;o^;Rhol30`?o4a<CobLW9ol_;ba7od=3@
01SomOooooWoooonoogoo_giooonnooooO_ooogmoogln?oamngomooaoo3o
i_mcV6;oGha7oce^7OmFRc?oK:55og^^Con3]UOoRkaPohbmH_n=_V?oT<5X
oi71Jon>_VP2oi6nJ@03oi6nJonA_VWoT[iY00;oT[iW04goT[iUoi:nIonB
_VGoT[iWoi:nIOnB_VOoT[iUoi:nIonB_VGoT[iWoi:nIOnB_VOoT[iUoi:n
IonB_VGoT[iWoi:nIOnB_VOoT[iUoi:nIonB_VGoT[iWoi:nIOnB_VOoT[iU
oi:nIonB_VGoT[iWoi:nIOnB_VOoT[iUoi:nIonB_VGoT[iWoi:nIOnB_VOo
T[iUoi:nIonB_VGoT[iWoi:nIOnB_VOoT[iUoi:nIonB_VGoT[iWoi:nIOnB
_VOoTKmUoi6oIonA_fGoTKmWoi6oIOnA_fOoTKmUoi6oIonA_fGoT/1Xoi6o
IOnA_fOoT/1Voi?1JOnA_fGoSK]SohRiG_mm/e?oNJmAodn1:_loJakoDgXi
oi:`O?oUo]OomOo/on_fi_o_m^koo_omooOgn@03ooono`03ooomo_oooooo
i^KV00Soi^KV1ooWinL6onSXj0_ojNWY0ooZj^X00oo/k>cojn_[ong]k@02
ong]k@[ok^k^1oo_knl6oo3`l0SolO7a0oobl_82oo?cl`?omOGe0_ogmoL3
ooShn0[onOWi0oojn_X3ooclo0;oo_kn9_ooool01?lMGk?oY/KVokK@k_mi
[nh2oj_No`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Oo6RHDoa4V5?l94P[o
6Q8Doa4L2_l92@[o4A`:00;o2@T:00?o4A`:o`TB2_l92@X02ol92@X00ol/
4P3o2@T:o`T92P03o`T92P03oa4L2_l0003o4A`:00Go2@T:01So2A8:o`00
0?mGIe;oCfM7ocAE:OlmGSgo=2lYoceN?Ol/9QCo6Q8DoceN?OlJ9QCo2A8:
ob<_7_l94P[o4A`:o`T92_lS;bWo4BH:oaXB5?lA9QCo6RHDo`000?l94PX2
o`T92P03o`TB2_l92@[o2A8:00Co2@T:00?o4A`:o`T92_l94PX02?l92@X2
o`TB2P?o2@T:00?o6Q8Do`T95?l92@X00_l000000olA9Qko2A8:o`000002
o`T92P0Po`000?l92@[o2@T:o`TB2_l92@[o0000o`TB2_l92ACo4Blco`TL
7_l92@[o2A8:o`T95?lA9QCo4BHNo`T92_lJ4QCo8d5BobaEG?l99RWo4A`:
obaEKolA;e;o4Blmo`TL7_lA;c?o4A`:oa4V7_l94P[o2@TDo`T92_lS;bT2
o`T9500RoaXB5?l971Co=2lcog9ED_lJ4QCo4A`:o`T95?l92@[o4BHNob<_
:OlS@CgoPiR>odmNI_l/C2Wo0000o`T95?l92@[o4A`:o`T95?l0003o2@T:
odI17_nVZZ?oUJ6>oiF=I_n=SFoo`LO1onC@c?o:d<7oPhAkoh=kG?oLhn3o
`K>]ob<V2P;o2A8:013o2@T:oa4L2_mG703oPg/coij=:Ol0003o4A`:o`00
0?l92@[o8a`:ob`V5?mZIc?oJUDNohf=Aon=SE;o00000_l94PX4o`T92P07
odHV5?mZ@@[oPg/cokVZKoo1/hko`K>]ol[@`@02ol77`@0Bol[@`On`ZXCo
i=3<ohf=Koo:d<7oYZ6HojJHKoo1al7oSHe_ojJZXom6EBWo0000o`T92_lA
70[o6Q8Do`T92_lJ2@[o4A`:0_lJ2@X01?lA70[o6PT:o`T92_lS70X2oaX9
2P03ob`B0?l92@[o6PT:00;o6PT:00?o8a`:ob`B0?l92@X01?lJ2@X00olA
70[o6PT:oa4L2P02oaX92P08ob`B0?lA70[o6PT:oaXB5?lJ2@[o8a`:oaX9
2_o1alaOonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0003onKViP05on7Q
hOnn_[koPH61ojb/[?nl_;`00_n^[Zh01?nf][Ko_;blokno_oo4a<@AolW9
b@0HooGoooohooooo?kkoooon_ooo_SoooOeookem_ooo_ooo_omooGomOo_
on[ojooOonSod_o>ok;oI9Toodb48OlmM0koAWhCodn37_m@Q1ooDHDQoeJ:
9_mHRbcoEXTZ1?mIRb`2oe^::S;oFh/X2?mIRbP00omHRROoFH/XoeZ<:@02
oeb>:`0AoeZ<:OmFR2GoDXHRoc]b3?m7OA_oIiU2ol_g[?o]omKoi_oGooCo
j_ogoo7onoohooconoo`l>koooooooomoooknO`00_ooo_l00ooooooohN7Q
on7Qh@0:on;RhP?ohn?S0_oTi>@3onGUi@[oi^KV1_oWinL2onSXj0GojNWY
2ooZj^X2on_[j`;ok>c/00CokNg]onk^k_o^k^kok^k^2_o_knl5oo3`l0?o
lO7a1Oobl_88oo?cl`;om?Cd0ooemOD3ooKfmP;omoOg0oohn?P:ooWin@?o
n_[j0oolo?`2ooknoQ7ooooo00Co6UbcojC3iOnhd^ooNJk/0_n/gol01?mZ
JV[o[Zj^omSHf?oTi>AKonKViP05o`T95?lJ4QCo6PT:o`T92_l94PX00_l9
2@X00olA70[o2@T:o`T92P02o`T92P03oa4L2_l92@[o2@T:00;o2@T:00ko
4A`:o`T92_l92@[o4A`:o`T92_lA70[o2@T:oaX92_l92@[o4A`:o`T92_lA
70[o2@T:ob`B00;o2@T:0_l94PX06?l92@[o4A`:o`T92_lA9P[o=5DYof1N
<olS;ako?Ehmob<_:Om6EBWo6RHDoaX92_ldEBWo6Q8Doa4V5?lJ9QCo8a`:
oa4V5?l92@[o4A`:oaXB5?l92@[o4BH:oaXV50;o2@T:00Co2A8:o`000?l9
2@[o2@T:0ol94PX01Ol92@[o2A8:o`T92_l94P[o000000;o2@T:00Co4A`:
o`T92_l92@[o2@T:0_l94PX01ol92@[o2A8:o`T92_l94P[o2@T:oa4L2_l9
4PX00_l92@X2o`TB2P03o`000?l92@[o2@T:00;o2A8:00?o0000o`TB2_l0
00000_l92@X2o`TB2P0Voa4_<olA9Qko2A8:oaXB5?l92ACo6Q8Do`T95?lA
9QCo4Blcoa4_?Ol/Ieco4A`:oa4_?Ol/EFoo=6Mko`TL5?l/EEco8d4mo`TV
:Ol971Co8blYo`000?l/C2Wo=5DYoa4L2_l94P[o4BHNo`000?nVZZ?oUHB>
ocdB2_nEXHko2BHYo`TB2_l971Co6Q8Dob<_7_l92@X2o`000008o`T92_l9
4P[o2@T:o`T92_mPGS?oSHeBoiFQS_o1al42ol6c[@04ojJZXooCfMKog>?F
oiFZ[@;oAT4N037o`K>>omcSh?o:d=KoUHeBo`000?l94P[o4A`:o`T92_ld
;akoARHDoh=k<om6C3go2@TDo`TB2_l92ACo2@T:ob<V2_m6@AkoPehcofYW
<on=SE;o8blYo`000?lJ4QCo2@T:oa4L2_l92@[o4BHDodHV5?mZEAkoWW/c
ol6cS_o:d<7oLXf4onBZV?oLhmKo/:Z4onC@c?nVV8CodmWFoiF=I_oLhn3o
YZZSojJHQ?o1/jgo/;>goh=kG?lA70[o2A8:00;o6PT:00oo2@T:oa4L2_lJ
2@[o4A`:oaX92_l92@[o6PT:oa4L2_lS70[o2@T:oaX92_lS70[o6PT:oaXB
5?l/4P000_lJ2@X01?l/4P3o6PT:oa4L2_lA9Q@2oaX92P03ob`B0?lA70[o
6PT:00Co6PT:00Oo2@T:ob<L2_l/4P3o6PT:ob<L2_l0003o/;>g05ooi^KV
00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000?ok^k^00_ok>c/on?Shon[Zj_o
MGEeoh20P?n?ShooW9bLojFUYOn/[:co/K6aokNg]`0>ok^k^`?o_;bl0onm
_Kd00onn_[ko_Kfmokjn_P02okjn_P;o_kno2oo0`<02ol71`@;o`/;200Co
`l?3olC4a?o4a<Coa<C42_o5aLD5olK6aP;oalO700?oa/K6olO7aoo7alL0
0oo7alL=olS8b003olW9bOo:b/[ob/[:00oobl_;0oo<c<`00oo=cLgoc<c<
olc<c002olg=c@_oc/k>0_o?cll3om3@d003om7AdOoBd];odm?C00;odm?C
0ooDe=@7omGEe@Koe]KF0_oGemL5omSHf0_ofMWI0ooJf]X2om_Kf`?og=cL
2_oMgMd5omkNgP;ogmoO00?og]kNomoOgooOgml00ooOgml8on3Ph0?ohN7Q
0_oRh^82onCTi003onGUiOoWinOoinOW00?oj>SX2_oYjNT3on[ZjP?ok>c/
0_o^k^h;ono_k`;ol?3`0ooalO400oobl_;olO7aoo7al@02oo;blP?olo?c
3_odm?@01?lLG[;oYLCVokKBk_mi[^T2oj[Po`04ofi^K_nd];Coh>3Ponc/
k5_ok^k^00Oo6Q8Doa4L2_l92@[o4A`:o`T92_lA70[o2A8:00;o2@T:00?o
4A`:oaXB5?l92@X00_l92@X01ol94P[o2@T:oa4L2_l94P[o4A`:o`T92_lA
70X01Ol92@X00ol94P[o2@T:o`T92P02o`T92P0=oa4L2_l92@[o2A8:o`T9
2_l0003o2@T:o`TB2_lJ9QCoCfMLoc@_7_lA9P[oAUDYob<_7P02ob`h:@07
ob<L2_ldEBWo4A`:ob<_:Ol/9QCo2A8:oa4V5002o`TB2P;o4A`:00Oo4BHD
oaXV5?l92@[o0000o`T92_l94P[o000000;o2@T:0_l94PX00ol92@[o0000
o`TB2P02o`T92P07o`TB2_l92@[o2@T:o`T92_l94P[o2@T:o`TB2P03o`T9
2P09o`TB2_l92@[o4A`:o`T92_lJ4QCo2A8:o`T92_l94P[o000000?o2@T:
00Co0000o`T95?l94P[o00000ol92@X01?l92ACo6Q8Do`TV:OlA9Qh2o`T9
50;o2A`N01[o4BHDo`TL7_l99RWo2BHYoa4_D_lA;cgo2D57ocebQ?l/EEco
2A`Nob<_<ombEE;oPehcog9ED_nEQ7_oPg]LodmWG?l971ko4BHNoaXV5?ld
;ako=2lcojIEI_nVQ8CoUHAkohf=K`;o;4`Y02Go6PT:oaXV5?l92@[o2@TD
ob`L5?m6@Ako8blNodHV5?mPGS?oLXdmof1N<om?IdOoPhf4ol[@`OoCfMKo
b]31om?Ie_nVZZ?o;4`YodHV2_o1/jgob[j]ol[@`Oo]kN[og>?Pog:=?On=
SDOo0000o`T95?lA70[o2@T:oaXB5?nNSBWoPg/codIE:Ol92@[o4A`:00;o
2@T:023oAT4NodIE:OmZEAkoSHeBoiF=D_lA9P[o2@TDoa4L2_l94P[o4A`:
oaX92_m6@AkoJUDNojJQI_o1/hkob]31ofYW<oo1/hkoi=3<ojJQV?oTd<co
b[j]ong]j_n`/kOoYZZSol6cS_mZIc?o/:Z4oiFQS_o1/hko0000o`T950?o
4A`:00Ko;180o`T92_lJ2@[o4A`:ob`B0?l92@X2oaX92P07ob<L2_lJ2@[o
8a`:ob`B0?lJ2@[o4A`:o`T92P02oaX92P05ob`B0?lJ2@[o6PT:oaX92_lA
70X01?lJ2@X00olA70[o6Q8Doa4L2P02oaX92P05ob`B0?lS70[o;180o`00
0?n`/kL0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@001?ooool02_ol
o?colO7aolG5aOn8R8SoLg=cogUiNOn;Rh_oTY:BoiVIVOnQXJ4>ojJVYPKo
YjNW00?oZ:RXojVYZOnZZZX01?nZZZX8oj^[Z`?o[:b/0_n][Jd2ojj^[P04
ojf][On^[Zko[Zj^ojj^[P;o[jn_3On`/;02ok6a/@03ok:b/_nc/k?o/k>c
00_o/k>c0_nd];@3okFe]@03okJf]_ne]KGo]KFe00;o][Jf0ong]kL:okRh
^0?o^KVi00?o^[Zjok^k^onk^k/00_nl_;`;okfm_@Go_[jn00?o`<30okno
_oo1`L401Oo1`L4:ol;2`PCo`l?31?o4a<@:olG5a@Koa/K600?oalO7olK6
a_o7alL01?o7alL8olS8b0?obLW90_o:b/X3olc<c0?oc/k>0_o?cll;om3@
d0;odM7A0ooBd]82om?Cd`_oe=CD1OoEeMD3omOGe`GofMWI2?oJf]X2om_K
f`?og=cL0ooMgMd2omkNgP?ogmoO3_oPh>001?lHFjooY/KVokWCk_mi[^/2
oj_Oo`04ogIfM_o1`L7ol?3`oogmoE_ooooo00Go6Q8Doa4L2_l92@[o2@T:
oa4L2P02o`T92P05o`TB2_l92@[o2@T:oa4L2_l000000ol92@X01?lA70[o
2@T:o`T92_l94PX2o`T92P0=o`TB2_lJ2@[o2@T:oaX92_l92@[o;180oa4L
2_l92@[o6PT:oa4L2_lJ2@[o4A`:o`TB2P02o`T92P0CoaX92_l92@[o;4`Y
oiFQS_l0003o8blNodmWAol0003o;3PYodI<?Ol0003o=5DYo`000?l/C2Wo
2@TDoa4L2_lJ9QCo2@T:oa4L2P02oa4V5003oaXB5?lS;ako000000;o2@T:
00?o0000o`TB2_l000001?l92@X3o`TB2PCo2@T:00?o2A8:o`T92_l92@X0
0ol92@X3o`TB2P05oaX92_l94P[o6Q8Do`000?l94PX00ol92@X2o`TB2P?o
2@T:00?o2@TDo`T92_l92@X00_l94PX04ol92ACo8d4mo`TV:Ol94P[o4BHD
o`T95?lA9Qko6Q`Noa4_?OlA;c?o6Q`NobaWG?lJ71ko8d5BobaEKolAC5;o
Eei_ombn]oo]fL`00_ofkNX05Oofm_Gom_oeoiEbAol0003oARH:okVHG?oT
ZYSog;jgongIc?ofkN[oUHB>oa4V2_lS;ako8a`:ob`L5?m6@AkoUHABoiFH
I_nVV6ooUIQVoiF4N`02ojJZX`?oUJ6>00Oog<NSol[@e_mkSFKoJW9Loa4V
2_l0003oH2lD00;o`K>]00Koi=3<om?Ie_oLhn3og>?PodI<?On=SDL3o`TB
2P03oa4L2_lJ2@[o8a`:00;oPg/c00[o0000o`TB2_lA70[o2@T:oaXV5?m6
;`[oAT4Noh=k<on=SE;oAUDY0_l94PX03olJ4QCo0000oc@_:Om6@AkoPg/c
okVHG?o:_Zgog;jgoiFZ[OoL_[Oom_oeojJQV?o:_Zgo/;>gol[@`@02ojJQ
V007ol77`OmZLUco`K>]ol6cS_mkSFKo0000oa4L2P04oaX92P0:oa4L2_lS
70[o2@T:oaX92_lS70[o2@T:oaX92_l92@[o6PT:ob<L2P?o6PT:00Co8a`:
ob`B0?lJ4QCo8a`:1olJ2@X00olA70[o6PT:ob<L2P02oaX92P03ob<L2_lJ
4QCo8a`:00;o6PT:00?o/;>gooooooooool0GOooool01?n_[joobl_;omkN
g_oZj^X1oo;blP001?o^k^h02?o/k>coj>SXomWIfOo2`/;oYJFUohf=SOmn
OWkoMWIfoombLW8=og9bLP09ofa/K?mXJ6SoHf=SoeYJF_m>CTko3E6Voj?2
i?nhdnooMjk[00;oZ]oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h00olJ4QCo
2@T:oa4L2P02oa4L2P03o`TB2_lJ4QCo2@T:00;o2@T:00?o2A8:oa4L2_l9
2@X00ol92@X01?lA70[o2@T:o`T92_lA70X2o`T92P04oa4L2_l94P[o2@T:
oa4L2P?o2@T:00?o4A`:o`000?lJ2@X00ol92@X04_lA70[o0000o`TB2_lS
@CgoSHe_o`000?lS;akoAUEBo`000?lS@Cgo=5DYo`TB2_ldEBWo0000ocAE
:Ol92@[o4BHDob<V2P;o4A`:00Oo4BH:oa4L2_lJ9QCo6RHDo`TB2_l0003o
2A8:00Co2@T:00Ko4A`:o`T92_l94P[o2@T:o`TB2_l92@X2o`TB2P05o`T9
2_l94P[o2A8:o`T92_lA70X00ol92@X00olA70[o2@T:o`TB2P02o`T92P03
oaXB5?l92@[o2@T:00Co2@T:00?o0000o`TB2_l92@X00ol92@X02Ol94P[o
2@T:o`TB2_l92ACo4BHDo`TL7_lJ4QCo2@TDo`TL5002o`TV:@0Boa4_<olA
;cgo4Blcoa4_?OlS@Cgo4BmBobaEG?l9@DOog;>]ongIc?oTal7om^gZomcS
h?oLhmKoi=3<oiEbAonNLS?o`G]k0_oTal404OofkN[og>?FooKomOn3Nc?o
0000oa4L2_l/71CoARHDohf=D_o:d<7o/;>gol6cS_n`/kOo`LO1ol[@`OoL
hmKob]3100;og>?F00?oYZZSoa4V2_l000000_l92@X01OmZIc?o/:Z4omcS
e_o1/jgob]3100?okNgZ00_o`K>>odIE:OmPGS?o2A8:oa4V5?l92@[o2A8:
ob<L2_lm70[oPg/colZQ?@03o`T92P07oa4L2_l/9QCoARHDofYE7_mbSCgo
YYQ_o`000002o`TB2P08oaXB5?m69QCoJVLcoiik<on`ZXCob]31ol6c[On3
Ne`2ol[@`@0OojJQV?o:_ZgoYZ6Hol6cS_nVZZ?oUHeVojJQV?nEV6KoUJ6>
ojJZXolJ9QCo2@TDo`T92_lA70[o6PT:o`TB2_l92@[o8a`:o`T92_lJ2@[o
8a`:o`T92_lA70[o6PT:o`TB2_lS70[o;180oaX92_l/4P3o6PT:ob`B0002
oaX92P06ob`B0?l94P[o6PT:o`T92_lJ2@[o6Q8D0olJ2@X01?l92@[o6PT:
ob`B0?l92@X2oaX92P04ob`B0?l/71Co0000ol77c5ook^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN4000Coi^KV00[ohn?SomWIfOna/K7oOGemof][Jomc
Lg?oPX:2ohN7Qon=SHgoUIFE3_nJVYX6oi^KV`;oW9bL1OnMWId;oijNWP;o
WinO0_nPX:001?nOWiooX:2Poj2PX?nPX:0=oj6QX@;oXZ:R0_nSXj<00onT
Y:CoYJFUojFUY@03ojJVYPSoYjNW1OnXZ:P00onYZJWoZ:RXojRXZ005ojVY
Z@[oZZZZ0on[Zj/00on/[:co[Jf]ojf][@02ojf][@_o[Zj^1On_[jl2ok2`
/0Ko/K6a2_nb/[83ok>c/`03okFe]Ond];Co][Jf00;o][Jf2_ng]kL=okRh
^0So^KVi1Onj^[X3okbl_0?o_[jn0_no_kl;ol30`0;o`L710oo2`/82ol?3
``_oa<C41Oo5aLD00oo6a/KoalO7olO7a`05olW9b@Sob/[:0_o;bl/3olc<
c003olg=cOo<c<coc<c<00;ocLg=0oo>c/h>olo?c`04oaaM/?nUa>Ko^M?_
ogN^j`;oZMco00CoJVYZojj^[_oHf=Soi>CTFooVi^H2oa4L2P;o2@T:00?o
4A`:o`T92_lA70X00_l92@X00olJ2@[o2@T:o`T92P04o`T92P05o`T95?lA
70[o6PT:o`T92_lA70X01?l92@X01OlA70[o2@T:oaX92_lA70[o2@T:00;o
4A`:01oo2@T:o`TB2_l92@[o2@T:o`TB2_l92@[oAT4NofZ=G?l0003o=5DY
og:=G?l94P[oH5hcodIE:Ol/4P3oCfM7o`000?m6EBWo2@T:ob<V2_l/>2Wo
0000ob`B0?lA70[o4BHDob`V5?lJ9QCo2@T:o`000?l94P[o000000?o2@T:
00?o0000o`TB2_l92@X00ol94PX3o`T92P06oaXB5?l92@[o4A`:o`TB2_l9
2@[o4A`:1?l92@X01OlA70[o2@T:o`T92_l92@[o000000?o2@T:00?o2A8:
o`T92_l000000ol92@X02?l94P[o2@TDo`TB2_l94P[o2@T:oaXB5?lA9QCo
2@T:0_lA9Qh03OlS@Cgo4Blcoa4_?OlS@E;o8blcoa4_<olS@Cgo8d5BobaE
KonVEFKog>?Fol[@`Oo]fL`00_oLhmH01OoTal7og;jgolZn[OoL/j?oi=3<
00;okMW<00oom^gZooo]c?oooooo4BH:oaXV5?lA70[o0000ofYW<onVQ5;o
NheVohf=KomkSHCoPhAkojJQV?oLhmH00_oLhn002OnVXISoAUDYo`000?l9
2@[o4A`:o`T92_mZEAkog<NSombn]`02omcSh009ol77c?o]m_Gog>?Fong]
j_o:d<7o`LO<og:=?OlS;ako4BHD00;o4A`:02_o2@T:ob<V2_mP@ACoNd`:
og:=?Ol0003o4A`:o`T92_lS70[o8bH:of115?n=SDOoYZ5Vof1N<ol92@[o
2A8:odHV5?m6@AkoPg/cok2=D_o:ZVKob]31ohf=KooTd<coYZ6HonC@c?o1
/jgob[j]ofYkKoo1/jgoYZZSojJHQ?n`/kOoYZ6Hohf=KonVV6oo0000oa4L
2_l92@[o6PT:oa4L2_lJ2@[o4A`:00;o6PT:00Co6Q8DoaX92_l/4P3o6Q8D
0_l/4P02oaX92P03ob<L2_lJ4QCo6PT:00;o6PT:00?o8a`:ob`B0?lJ2@X0
0_lJ2@X02_lS70[o6PT:oaX92_l/4P3o8a`:o`T92_l/71Co6PT:ob`B0?lJ
4Q@2ob`B0003oaX92_l/4P3o/;k105ooi^KV00CoWIfMokNg]oo8b<Sodm?C
0OoJf]X000?ok^k^00_ok>c/on?Shon[Zj_oLg=coginO_n<S8coVYZJoj>S
XonZZZ[o/[:bokJf]P07okRh^0;ooOgk1?oloO/2ooglo@0Foogjo?omnogo
oOWmooCdm_o`m_Koi??`omCYi?oAi^7ocMcGoloKeoo@fmOocm_Gom3Keoo?
fmOod=_GoloKeoo@fmOocm_Gom3Keoo?fmOod=_GoloKe`;od=_G<?o@f]T0
6?o@fmOocm_Gom3Keoo?fmOod=_GoloKeoo@fmOocm_Gom3Keoo?fmOod=_G
oloKeoo@fmOocm_Gom3Keoo=g=OobMkIol[PgOoEj>CoiO7_oo7gmOognOSo
o?_ioogkn`;ooO[k00SooO_moogloOomo?gooOgmoocmoOojoOgooOgmolk>
cP?oclo?00?od=3@om7AdOoBd]800_oBd]8:om?Cd`Koe=CD0_oEeMD5omKF
ePkoemOG0_oHf=P=omWIf@?of][J0_oKfm/3omcLg0?ogMgM0_oNg]h;omoO
g`;oh>3P0ooRh^82onCTi0_oiNGU0_oWinL3onSXj003on[Zj_oYjNWojNWY
00;ojn_[0oo/k>`8onk^kP;okno_0oo`l?03oo;blP;om?Cd0ooemOD>ooKf
mP04oaYN]OnTa>Ko^M?_ogJ]jP;oZn3o00CoKVi^okBd]?oPh>3ok>c/Foo^
k^h02?l94P[o6PT:oa4L2_lA70[o2@T:o`TB2_l92@[o4A`:1ol92@X03OlJ
4QCo4A`:o`T92_lA70[o6Q8Do`000?l94P[o6PT:o`TB2_l92@[o4A`:o`T9
2_lJ2@X01Ol92@X05OlA70[o6PT:o`T92_lA70[o6Q8Dob`V5?m6EBWo8bH:
ob<_7_mZNfoo2@TDocAE:Om6GTOo4A`:oba<:OlS;ako6RHDoa4V7_lJ4QCo
6RHDoa4L2P02o`TB2P03ob`V5?lJ71ko4A`:00Go2@T:00?o2A8:o`T92_l0
00000_l94PX01_l0003o2@T:o`TB2_lA70[o2@T:oa4L2P?o2@T:00Ko2@TD
oa4L2_l92ACo4A`:o`TB2_lJ4Q@2o`T92P04oa4L2_l92@[o2A8:o`T92P;o
2A8:00?o0000o`T92_l92@X00ol92@X05_lA70[o6Q8DoaXB5?lJ4QCo2@TD
o`T92_l99RWo2A`Noa4V7_lJ9QCo2BHYo`TL7_lS@Cgo2BHYob=1?Ol/EEco
4BlmobaEG?lmLXCoCg9konC@c?oL_[L3onC@c004ongIc?oL_ZgokMW<onC7
`@;okMW<02Oog>?FooK]j_ofooGokNgZolZn[Omb>03o4A`:oa4V2_lA70[o
2@T:oc@_:OnVXFKoPg/codI17_m6;`[okM2Hol6c[On=SFoo4BH:o`000?l9
2@[o6Q8Doa4V5?lJ4QCoJUDNol6c[OoTal7og>?Fong]j_o]m_Go`K>]ooKo
mOoLhn3og>?Fol[@`OoLhmKoYZ6Hof1N<ol000000_lJ4Q@01ol92@[o8a`:
oa4L2_mZEAkoWW/co`T95?l94PX00_lA70X07old;akoAT4Noh=N<on=SDOo
^JY_o`000?l94P[o=2lNodHV5?mZEAkoWXdcolZn[OnVZZ?oAT`mongIc?n`
ZXCog;jgol[@`Oo1al7o`LO<ok2ZQ?nVXISoNheVoh=kG?n`ZXCoUHB>ofZ=
G?l0003o2A8:o`T92_lJ2@X00_lA70X00olJ2@[o2@T:oaX92P03oaX92P05
oa4L2_lJ2@[o6PT:o`T92_lJ4Q@00_l/4P04oaX92P0Cob<L2_lJ4QCo6PT:
ob<L2_lJ2@[o8a`:ob`B0?lA70[o6PT:oa4L2_l/4P3o6PT:ob<L2_lJ2@[o
8a`:oaXB5?l/4P3o0000ok2n`@1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q0003ooooo`0;oo[jn_oCdm?oOGemoj2PX?nm_Kgo/;2`ojj^[_ne]KGo
_;blokjn__o5aLD01oo8b<P4ookoo@0Jooooooooo_ooookoooonooooo?oo
oogooo?cmOoPi^KofNGUolkQgoo0fMGo_]OAok?8`Ondal7o]/O1okC7`Onf
al7o]<O1okK7`Ondal7o^<W3okK9`onhbL?o]/W3okS9`onfbL<2okS9``03
okS8aOnhb<Oo^<S702co^<S701co^<S5okS9`onfbL?o^<W3okK9`onhbL?o
]/W3okS9`onfbL?o^<W3okK9`onhbL?o]/W3okS9`onfbL?o^<W3okG:`onb
d<So]M?;ol3Idoo=h=cofNGQonCZj?obl_;ooo_looomooooo?oooogo0_oo
o_l01?ooooooo_oooocoooooool4omkNgP;ogmoO1_oPh>0:on7Qh@?oh^;R
0_oShn<3onCTi0[oiNGU1_oVi^H2onSXj0Goj^[Z2oo[jn/2onc/k0;okNg]
00Cok>c/ong]kOo]kNgokNg]2_o^k^h5ono_k`?ol?3`1OoalO48oo;blP;o
lo?c0oodm?@00ooemOGom_KfooKfmP02ooOgm`?on?Sh2_oinOT3oo[jnP?o
o?cl0_ono_hAooooo`04oa]N/onUa>Ko]M3^ogV^k0;oYmco00CoMWIfol71
`Oo`l?3ooOgmFoooool02OlJ4QCo4A`:oaX92_lJ2@[o4A`:o`T92_lJ2@[o
4A`:o`T92P03o`TB2P?o2@T:017o6Q8Do`T92_l94P[o6PT:oa4L2_l92@[o
6PT:oa4L2_l92@[o2A8:o`T92_l/4P3o4A`:o`T92_l/4P3o2@T:oa4L2P03
o`T92P06oaX92_l92@[o4A`:ob`h:Om?IdOo6Q`N0_ldEBT02Om6C3go2A8:
oceN?OlS9P[o2@T:ocAE:Ol0003oAT4Noa4L2P02oa4V2P06oaX92_lJ4QCo
4BHDoa4V2_l92@[o2A8:1?l92@X00ol0003o2A8:o`T92P02o`T92P08o`TB
2_l92@[o2@T:o`T92_l94P[o6Q8Doa4L2_l92@X3oa4L2P08o`TB2_lJ4QCo
2A8:oaXB5?l94P[o4A`:oaX92_lA70X3o`T92P03o`T95?l94P[o2@T:00?o
2@T:0ol94PX03_l92ACo8blNo`TB2_l99RWo4BHDoa4L2_lS;ako4Blcoa4_
?Om6Ieco4Blmob=1?Ol/EEco8d5B0_l/EE`00ol/EFoog;>]onC7`@03onC@
c003onC7`OoL_Zgoi<O100;okMW<01_om^gZong]j_ofm_Gom_oeong]j_nE
EACo/5D0omc7XolA9P[o8blNoa4L2_lA9QCo2@T:o`TB2_ld;akoPg/cok2Z
Q?o1/jgo;4`Yo`TB2_lA70[o4BHDoaXB5?lA70[o2@T:ojJQI_n`ZX@00_oL
hmH03ooLhn3okNgZongfmOnVZZ?om_ooomcSh?oLhmKoi=3<omcSh?o1alco
UJ6>o`000?lA70[o2@TDoa4L2P02o`T9500TodHV5?mPGS?oJVLco`TB2_lJ
2@[o2A8:o`T92_m6@AkoJT4:og:=?OnVXFKo;3PYo`T92_ld;ako=2lYoh=k
<onNLS?oi=3<ohf=KonVV6ookNgZojJZXonVXISog>?FojJZ[Oo:_ZgoSHe_
ol6c[OnEXHkoSHe_ol6c[On`ZXCo4BH:o`T95?l92@[o4A`:1?lJ2@X01?lJ
4QCo6PT:oaX92_l/4P05oaX92P0<ob<L2_lJ2@[o6Q8Dob`B0?lJ71ko;180
ob<L2_l/4P3o8a`:oaX92_lS70[o6Q8D0_lJ2@X01_l/4P3o8a`:oaX92_l/
71Co2@T:oaX92P;o8a`:00Co?A8:ob<L2_l/4P3o/;k1Goooool01?n_[joo
bl_;omkNg_oZj^X1oo;blP000_o^k^h03?o]kNgoiNGUoi6ATOnATI7oc<c<
omGEeOo2`/;o^KViol30`?o4a<CobLW9ol[:bPOod=3@0_olood00oonoogo
ooomooono`03ooono`09ooSfnOodmOOog^CTolC@c_ngb/So[<G1oj2m^?nN
^kKoUK2Y00OoU[2W2?nE[jH00onG[ZSoUjfZoiN]ZP0/oiN]ZP03oiN^Z?nE
[jKoUJnV00goUJnV00WoT[2VoiBh[_nG^k7oX;ngojc5_ongb/Coam;>om_O
g_o]kNd00ooooOl2ooono`05ooooooonooooo_oooooooooQhN400ooRh^80
0ooTi>Cohn?SonGUi@02onGUi@[oi^KV1_oWinL00ooXj>SojNWYon[ZjP04
on[ZjP_ojn_[0oo/k>`2ong]k@?ok^k^2_o_knl3oo3`l0;olO7a0_obl_80
1?oalO7ol_;boo;bl_obl_82oo?cl`Som?Cd1OoemOD3ooKfmPGomoOg2_oh
n?P3ooWin@03oo_knoolo?coo?cl00;oo_kn9_ooool01?lKGkKoY<CVokSB
k_mf[NX2ojcOo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Ko2@TDoa4L2_l9
2@[o4A`:o`T92_lA70X2o`T92P03oa4L2_l92@[o2@T:00Go2@T:00?o4A`:
o`T92_lA70X01?l92@X01Ol/4P3o2@T:o`T92_l92@[o4A`:00Co2@T:00?o
4A`:o`T92_lA70X00ol92@X02Om6@Ako;3PYodIE:Ol/C2Wo;3PYodmWAol0
003o=2lNob`V5002o`TL5003oa4L2_lS9P[o2A8:00;o6PT:0_lA70X01?lJ
2@[o8blNo`T92_l94PX5o`T92P03o`T95?l94P[o2@T:00;o2A8:0_l92@X0
2?lA70[o2@T:o`T92_l92@[o4A`:o`TB2_l92@[o6Q`N0_l94PX01?l971Co
4A`:o`T95?lA70X2o`TB2PCo2@T:00Co2A8:oa4L2_l92@[o2A8:0ol92@X0
1Ol94P[o2@TDob<_7_lA9QCo;3PY00;o4BHD00go6Q`Noa4_<olS;bWo4Blm
oa4V7_lS;c?o4Blmob=1D_lAC5;o=6Mkoh>=Q?oTal7ob]3100;oi=3<00Go
kMW<onC@c?oTal7okMW<omcSh004ooK]jP06ol6c[Omb9P3o^G8conBnQ?oo
kLcoH2l:0_lS9PX02?lJ4QCo2@T:oa4L2_l92ACo=2lNokVZKomZEAko4BHD
0_lJ4Q@01?lA9QCo2@TDoa4L2_nNQ6H2ol[@`@07ong]j_o]m_GokNgZongf
mOoCfMKoYZ6HooKoo`02omcSeP0^ong]j_oLhn3okNgZol77`Ol0003o4BH:
oaXB5?l92@[o6PT:o`TB2_lA70[oARHDofYW<om6EBWo0000oa4L2_l92@[o
;180oc@_7_mZEAkoSHe7ohf=D_m6EBWo=2lNog8h5?n`SAkoYYQ_om?Ie_nE
Q7_oYYQ_onC@c?o1/jgoYZ6HonC@c?n3Neco`LO<oiF4Noo1/jgo`LO1ok2Z
Q?nVXISo;4`YoaXL7_l0003o6Q8Do`TB2P;o4A`:00Wo2@T:oaX92_l92@[o
;180oaXB5?lJ2@[o6Q8DoaX92_lA70X00olJ2@X2ob`B0007oaX92_l/4P3o
6PT:oaX92_lS70[o;180o`T92P02oaX92P;o8a`:00Oo6Q8Dob`B0?l92@[o
6PT:ob`B0?lS70[o6PT:00;o8a`:00?o;1`Do`000?o]kNX0Goo^k^h01?nS
Xj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H03?oUiNGofMWIogQhN?nl_;co
f=SHom_Kfoo>c/ko`<30olG5aOo:b/[oc<c<olo?c`Oodm?C00Conoooooco
ooonoooooooo0_ooo_l03_ono?oom_KhonGYj_oAfm[o^LO7ojFi]onI]:oo
Sk2YohBWXOmnXI[oP:6HogfNTomgV8goLiB90_maTXL00omcU8WoMIJ;og:C
R007og:CR33oLi::2?maTXL2ogBERP;oLiB900koM9F:ogJGS?mhVHkoMi^?
ogNQUOmjY9SoPZRMoh^/XonI]:go[L2lolC@c_oDf][oj>W]ooOen0;oooko
00Goo_coooomooooooooo_koooooo`04onKViP;oinOW1_oXj>P:onWYj@?o
j^[Z0_o[jn/3onc/k0[okNg]0oo^k^h3ono_k`03oo7alOo`l?3ol_;b00;o
l_;b0_oclo<8ooCdm0GomOGe0oofm_H5ooOgm`gon?Sh0ooinOT?oo[jnP?o
no_k00?oo?cloogmoOomoOd00_ono_hVooooo`04oaeO/onVa^Ko]]3^ogV_
kP;oZmko00CoJVYZojj^[_oHf=Soi>CTFooVi^H01olJ4QCo4A`:o`T92_l9
2@[o4A`:o`T92_lJ4Q@00_l92@X01?lA70[o2@T:o`TB2_l94PX2o`T92P04
oaX92_l0003o2@T:o`TB2PWo2@T:00So2A8:o`T92_l92@[o2@T:o`TB2_lJ
2@[o2@T:oaX92P;o4A`:00co8blNob`h:Om?IdOo6Q`Nob<_7_lmGSgo8blY
o`TB2_l/>2Wo6RHDoa4L2_l92@X2oa4L2P07o`T92_lA70[o0000o`TB2_l9
2@[o4A`:oa4V2P02o`TB2P04o`000?l92@[o0000o`TB2P;o00000_l92@X0
4_l0003o4A`:o`000?l0003o2A8:o`T92_l94P[o2@T:o`T95?l94P[o4BHN
ob=1?Ol/C2Wo4A`:o`TB2_lA70[o0000oaXB50?o4A`:00?o2@T:o`TB2_l9
2@X00_l92@X2o`TB2P07o`T92_l94P[o2@T:o`T92_l92ACo6Q8Doa4L2P03
o`T950;o4BHN00co4Blcob=1?OlS;c?o8d4moa4_?OldIg_oYZZSonC@c?oT
al7oi=3<onC7`OoTd<`4ongIc0;om^gZ00_om_Keooooooo1XHCobZYVonC7
`OoLhmKokMW<ooKomOm6EBWo4BH:oaXB5002oa4L2P03o`T92_lA70[o2@TD
00?o4A`:00Wo;1`Doa4V5?l92ACo6Q8DofYW<ooLaj?ob[j]om?Ie_o]kNX0
0_o]m_D02oofooGodmWFoh>=Q?ofooookNgZomcSh?o]m_GokNgZongfmOn`
/kOo4BH:00;o4A`:03;o6Q8Doa4L2_lJ4QCo2A8:oa4L2_m6@AkoJUDNob<_
7_l92@[o4A`:o`T95?l/9QCo6RHDodHV5?n=SDOoJUDNodI17_n3GQCodkj>
olZn[Oo1/jgog;jgol77`Oo:_Zgob]31ojJHQ?o]kN[oYYR4oiFQS_o1/jgo
Pg]LojJZXon`/kOoUIQVo`000?lA70[o2@T:oaXB5?lJ2@[o2@T:ob`B0?l9
2@[o4A`:ob<L2_l92@[o;180oaX92_lS70[o6PT:o`T92P;o;18000go6PT:
oaXB5?lJ2@[o;180ob`L5?lJ2@[o;180ocdB2_lJ2@[o4A`:oaX92_l92@[o
;18000?o6PT:00Co4A`:ob<L2_lJ2@[o6PT:0_lS70X3ob`B0003om?Ie_oV
i^Koi^KV05goi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;ok^k^00Co
k>c/omoOgomaLG7odM7A0_oLg=`01_o@d=3oa<C4olW9bOo<c<coclo?om;B
dPOoeMGE0_okooh07?ono_koo_cmooonooono?goloCfonG[joo5dLoo]l[6
oj>n^On>[jSoNj2HofZDR_mNQgooEh5goen9NomNRGSoGXMioeb7M_mMQWSo
GHQgof29NomORWWoH8Ukoen:NOmPRG_oGhYiof29NomORWT4of29N`19of:8
NomPRG_oHXQkof29NomRR7_oH8Ukof:8NomPRG_oHXQkof29NomRR7_oH8Uk
of:8NomPRG_oHXQkof29NomRR7_oH8Ukof:8NomPRG_oHXQkof29NomRR7_o
H8Ukof:8NomPRG_oHXQkof29NomRR7_oH8Ukof:8NomPRG_oHXQkof29NomR
R7_oH8Ukof:8NomPRG_oHXQkof29NomRR7_oH8Ukof:8NomPRG_oHXQkof29
NomQRWcoH8]jof6:O?mPRg[oHHYlof2;N_mQRWcoH8]joej7NOmLQgKoGHIh
oeb7M_mMQWSoGXUhof29NomORgcoIIF5oeV<OOmJR7_oJiF9ogfQUon;ZJ7o
WkFbok?3`_o>f=WohnS[ooOho002ooooo`04ooonoooooOoooO_nooooo`co
inOW1ooXj>P3onWYj@?oj^[Z0_o/k>`3onk^kP;okno_3_o`l?000ooalO7o
l_;boo?cl`0?oo?cl`;om?Cd0ooemOD3ooKfmP[omoOg0oohn?P2ooWin@?o
n_[j0_okno/3ooclo0gooOgm0oono_hXooooo`04oaYL/onT`nGo^=;_ogV^
k0;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h03?lJ4QCo6PT:oa4L2_lA
70[o2@T:oa4L2_l92ACo8a`:o`T92_lA70[o2@T:o`0000Co2@T:00Wo4A`:
o`T92_lJ2@[o2@T:o`TB2_lA70[o6PT:o`T92_lJ2@X00_l92@X01?l/4P3o
6PT:o`T92_l94PX6o`T92P0:oa4L2_m6@Ako6RHDodI17_m?IdOo0000ocAE
:Om6EBWo0000ob`h:@;o4A`:00Go2@T:oa4L2_lA70[o2@T:oa4L2P02o`T9
2P05oa4V5?lJ9QCo2A8:o`TB2_l000001?l92@X01_l94P[o2@T:o`T92_l9
4P[o2@T:o`TB2PCo2@T:00Ko0000o`TB2_l92@[o2A8:o`000?l971h2og:=
[@09odIWG?lS;bWo2@T:o`TL5?lJ2@[o4A`:oa4_<olA9Qko2@T:00?o2A8:
00?o6Q8Do`TB2_l92@X00ol94PX00ol92@[o2A`Do`T95002oa4V5004oaXL
7_l99RWo4Blmob<_<`;o4Blc00Ko4BmBoa4_?OnEQ8kokMW<ombn]ooTd<`5
ongIc0;og>?F0_ofkNX01_ofm_GokOKeooo]c?ofkN[okNgZooo]c0;om_oe
00Go4BH:o`TL5?lA70[o4A`:o`T95003o`TB2P08o`T95?lA9QCo4BHDoa4V
7_l92ACoH44YojJHKoo:_Zd2omcSePGokNgZ00?og>?Pog9WD_ofool01_o]
kNX01_lJ9QCo2A`Doa4V5?lJ2@[o2@TDoaXB50;o4A`:0_l/9Q@02?mP@ACo
2@TDoa4L2_l94P[o6PT:oaXV5?l/9QCoH44Y0_m6@Ah02_n`SC?o`K>>onC@
c?nEQ7_og>?Fol6c[OnVZZ?odmWFoiFQS_o1al42ojJQV008ol77`On`ZXCo
`K>]ol6cS_l0003o2@TDo`T92_lA70X3o`T92P05ob<L2_l94P[o6PT:o`T9
2_l/4P001_lJ2@X00olJ4QCo;180ob`B0002ob<L2P0>ob`B0?lS70[o?A8:
oaX92_lA70[o6PT:oa4L2_l/4P3o6PT:ob`B0?lJ4QCo;180oaX92_l/4P02
ob<L2P06ob`B0?lJ4QCo8a`:ob`L5?l0003odmWFGoo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@000_ooool03?omoOgokNg]og5aLOoGemOog]kNomoO
gooDe=Coa<C4olO7aoo<c<cod=3@om;BdPOoe]KF0_onool07?ooooooooko
ooonooojnogoi^c/om3Og?nhc/_oW[fgogjVWOm^W97oMJBJohRj[onQd<Ko
[moColGeiOo6mn;ob_WWol_lioo=o>[oc?gXolckjOo;o>Oob?OUolOhhoo8
mnGoaoSSolSgiOo7n><4olSgi@1;ol[fiOo8mnGob_KUolSgiOo:m^Gob?OU
ol[fiOo8mnGob_KUolSgiOo:m^Gob?OUol[fiOo8mnGob_KUolSgiOo:m^Go
b?OUol[fiOo8mnGob_KUolSgiOo:m^Gob?OUol[fiOo8mnGob_KUolSgiOo:
m^Gob?OUol[fiOo8mnGob_KUolSgiOo:m^Gob?OUol[fiOo8mnGob_KUolSg
iOo:m^Gob?OUol[fiOo8mnGob_KUolSgiOo9n>Kob?WTolWhi_o8nNCobOSV
olSii?o9n>Kob?WTolckjOo:nnKobo[XolWjiOo:nNOob__Vol_jj?o9o>Wo
_OCQojSQc_nIckooSL2aogbZWomcVi;oRZZUojc6`ongbl[ocmgMonWcm?oi
o_ooo_oo00Coooko00Koj>SXonWYjOoYjNWojNWYon[Zj_oYjNT3on[ZjP?o
jn_[3Oo/k>`00oo]kNgok^k^ono_k`0<ono_k`?ol?3`0ooalO400ooclo?o
l_;booCdm002ooCdm0;omOGe2?ofm_H7ooOgm`Kon?Sh2ooinOT2oo[jnP;o
o?cl00?ono_koogmoOomoOd04Oono_hZooooo`04oaeO/onUa>Ko]];^ogV^
j@;oZ^3o00CoMWIfol71`Oo`l?3ooOgmFoooool02?lA70[o2@T:o`T92_lJ
2@[o4A`:o`T92_lJ2@[o4A`:1Ol92@X01?l94P[o2@T:oaX92_lA70X3o`T9
2P03o`TB2_l92@[o6PT:00?o2@T:00?o4A`:o`000?l92@X00ol92@X00olA
70[o2@T:oa4L2P02o`T92P0;ob<L2_m6@Ako4A`:oaXV5?ldEBWo4A`:o`TB
2_lS9P[o8a`:o`000?lA9PX00_l92@X02Ol94P[o2@T:o`T92_l94P[o4A`:
oa4V2_ld;bWo6RHDoa4L2P04o`T92P04o`TB2_l92@[o2@T:o`0000?o2A8:
00Go0000o`TB2_l92@[o2A8:o`T92P04o`TB2P05o`T95?lA9P[o6Q8Dob=1
D_ldECd00_lS@Cd3oa4L2P06oaXL7_lS@Cgo;4`Yo`TB2_l971Co2@TD0_l9
4PX02Ol92@[o2A8:o`TB2_l94P[o4A`:o`T95?l92@[o2@TDoa4L2P02o`TV
:@08ob<_:OlA;cgo8d5Bob=1D_lmLXCoYZ6HongIc?oTal42onC@c00:omcS
e_ookLcokMW<ongIc?o]kN[og>?FooKfmOofkN[om_oeooKfm@?om^gZ00So
m_oeooK]j_ofooGog<NSo`000?l971Co2@TDo`T92P;o4A`:00co6Q8Do`TB
2_lJ4QCo6Q8DoaXL7_l94P[oH2lDomcSe_oTd<cog>?FomcSh?o]m_D3ong]
jP07ongfmOo]kN[okNgZol77c?o]kN[og>?Pong]jP02omcSh00:ol[@`OoL
hmKo`K>>o`000?lA9QCo4A`:oaX92_l94P[o6PT:o`T92P;o6PT:01OoARl:
odIE:Ol0003o4A`:o`T92_lJ4QCo=2lNofYE7_ld;akoWW/col6cS_o1/jgo
Phf4ojJHKoo1/jgob]31ojJHQ?o:d<7o/;>gol6c[Oo1al7oYZ6HojJZX`02
oiFHIP03o`000?l92ACo2A8:00?o2@T:0_lA70X01_l92@[o6PT:oaX92_lA
70[o6PT:ob<L2P;o6PT:00go;180ob<L2_lJ2@[o6PT:ob<L2_lJ2@[o8a`:
ob`B0?lS70[o6PT:ob`B0?lS70[o;18000?o6PT:00?o8a`:oaX92_l/4P00
0olJ2@X02?lS70[o;180oaX92_l/4P3o8a`:ob`L5?l/4P3o`LO<Goooool0
1?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h01?o/k>cog=cLogMgMooI
fMT2on3Ph006omCDe?o7alOob/[:olk>c_oBd];oe=CD1ooFe]H2ooooo`;o
ooko01cooooooo;fmooEhMoo^M3:oifn]on8/jWoNJfPoh6jZonLe/So^?3S
olSnlOo<oo?oa_WVolOki?o9oNOobooXol_ojOo:o^Oob?cVolOki?o<on[o
c?oYolcoj_o<onWoc?oZolcojOo<on[oc?oY<?o>onT2olcoj@0Lolcoj_o<
onWoc?oZolcojOo<on[oc?oYol_ojOo;onSob_kXolWmi_o9oNOobOgVolWm
ioo7o^Oo`_gWol3njOo1o^co^_GSoj3Fb?n1/jOoMjFKoh6YXOnQ`Kco^M;?
omOWioo]moSonOgnooono`;ooogo00?oookoonSXj?oXj>P02_oXj>P7onWY
j@;oj^[Z00Koc/k>ogAdM?oTi>Cojn_[ong]kOo/k>`3onk^kP;okno_2oo`
l?03oo7al@;olo?c0ooemOD6ooKfmP04omWIfOmiNGWokno_ooKfmPgomoOg
2oohn?P2ooWin@;ono_k00?oo?clookno_ono_h0>oooool01?lKG[?oY/KV
okWCk_mi[^/2oj_Oo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Co4A`:oaXB
5?lA70[o4A`:0_l92@X03_lJ71ko2A8:o`T92_lJ2@[o4A`:o`T92_lA70[o
2@T:oa4L2_lJ2@[o2@T:oa4L2_lJ2@[o4A`:0ol92@X01OlA70[o2@T:oa4L
2_lJ2@[o2@T:00;o4A`:00Co2@T:o`TB2_lA70[o6PT:0_l92@X02?lA70[o
8a`:oaXV5?l/C2Wo4BHDoaXB5?l/C2Wo00000_lA70X03Ol94P[o4A`:o`T9
2_lA70[o2@T:oaXB5?lJ2@[o4A`:oaXB5?l/C2Wo8blYoaXV5?l92@X00ol9
4PX2o`T92P03oaXB5?l92@[o2@T:00Go2@T:00?o2A8:o`T92_lA70X00_l9
2@X04OlJ4QCo2@TDoa4V5?lS;bWo;3PYodmWG?mZNhCoCg9koh>H[OmbSHCo
?Ehmo`000?lJ71ko2@TDoiFQ]olS;c?o000000;o2A`D01Ko6Q8Do`TB2_l9
2ACo2@TDoaXB5?l92ACo4A`:oaXB5?lA9QCo2A`Do`TV:OlS;c?o2D57oa4_
<olA;e;oEei_o`TV:OnVXISoong<omcSe_o]fLcoi=3<0ooLhmH01OookLco
kMW<ong]j_ookLcokNgZ00?om_Ke00Oom^gZooKfmOookLcoooooooo]c?lA
9P[o2A8:00;o6Q8D00?o4BHDoaXB5?lA9Q@00_lJ4Q@01?lA9QCo2@TDoaXB
5?mZEAh2omcSeP04onC@c?oLhn3okNgZong]jPGokOKe00?om_oeomcSe_o]
kNX01?oLhmH01_oCfMKo`LO1omcSh?lA70[o4BH:oaX92P?o4A`:00[o6Q8D
oa4L2_lS70[o4A`:odHV5?m6@Ako2@T:oc@_7_mZEAkoAT4N0_mP@BT06Oo:
ZVKog<NSojJZXooL_[Oo/:Z4olZn[Oo1al7oYZ5Vol77c?n3SHCo`K>]oiF=
I_nVV8Cob[j]oiFQS_l0003o2@T:o`T95?lJ4QCo2@TDo`T92_lA70[o2@T:
oaX92_lA70X00olJ2@X03?l/4P3o6PT:ob<L2_l/4P3o6Q8DoaX92_l/71Co
;180oaX92_lm70[o;180oaX92P;o;18000Ko6PT:ocdL2_lJ2@[o6PT:ob<L
2_lJ2@X2ob<L2P03oaX92_lm4P[o4A`:00;o8a`:00Oo;1`Dob<L2_l/71Co
8a`:ob`L5?l/4P3o/;>g05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
00;oi^KV00coi>CTomCDe?mfMWKof][Jon3Ph?oQhN7oe=CDolO7aoo;bl_o
c/k>om3@d?oCdm<7omGEe@0PookloooooOoooo_ooogko_ogn?[ohnc[okoC
dOnN_kSoO:ZOogbfYon8b;SoW^?AokKij?o1oo7o_O[[okSah?o9onSobOoU
olWoioo9onGobOoWolSni?o8o^KoaogSolcoj_o<onSoc?oZolcoj?o<on[o
c?oXolcoj_o=onP`olooj00Rolcoioo;onOobooYol_oioo;onWobooWol_o
jOo;onOobooYol_oioo;onWob_oVolWoioo9onGob?kVolOoi_o0onSo__oY
okkojoo0ongo__k]ojk/gOn@b[koN:^RohJaZ_nL_kWo_]ODomk/k?ocnOWo
oO_noooko_ooo?ooookoonSXj0?ojNWY0_oZj^X3on_[j`?ok>c/1oo]kNd2
onk^kP06on[Zj_lK6a_oVYZJonk^k_o`l?3okno_1OoalO4;oo;blPColo?c
1?odm?@6ooGem@04oo7alOlK6a_oWYjNooGem@Gom_Kf0_ogmoL00oofm_Ko
moOgooOgm`03ooOgm`_on?Sh0_oinOT2oo_kn`03ooclo?ono_koo_kn03_o
oooo00Co7f6doj?2i?nhdnooMjk[0_nZgol01?mZJV[o[Zj^omSHf?oTi>AK
onKViP0:oa4L2_l92@[o4A`:oaXB5?lA70[o6Q8Doa4L2_lJ2@[o2@T:o`TB
2P;o2@T:00go2A8:o`T92_lA70[o2@T:ob`B0?l92@[o2A8:o`T92_lA70[o
2@T:oa4L2_lJ2@[o2A8:00;o2@T:00[o4A`:o`T92_l92@[o0000ob`B0?l9
4P[o4A`:o`T92_l94P[o2@T:0_lS9PX02Om6;`[o4BH:o`TB2_l/4P3o2A8:
o`T92_l94P[o2@T:o`000005o`T92P05oa4V5?l/9QCoCfM7oc@_7_lA70X0
0ol94PX2o`T92P05oa4L2_l92@[o2@T:o`T92_l94PX01Ol92@X00olA70[o
2@T:oa4L2P02o`TB2P0@oaXB5?lJ9QCo8blYoa4_?OmbSHCoJW^4of1bNonV
/l7oPiR]oiFQ]on3SHCo;5hmoba<:OlS@Cgodn?eoiFHX`;o000001?o2A8:
o`TL7_lA9Qko2A`DoaXB5?l92@[o4BHNo`TV:Ol971ko2@TDob<_<olS@Cgo
Eei_og9ED_nVV8Coi<O1oiib<ol0003o?Ehm00?okMW<00Ooi=3<ongIc?oL
hn3og>?Pooo]c?ofkN[okNgZ00;om^gZ0_ofm_D03?ofkN[om_oeooKomOn3
Neco0000o`TB2_lA70[o2@TDoa4L2_l92@[o2@TDo`T92P;o4BHD00Co2@T:
oc@_7_n`ZXCo`K>]0_o:d<400ooLhmKog>?Pong]jP03ongfm@05ooKoooof
ooGog>?PomcSe_oLhn000oo]kNX3olZn[@08ombn]ooLhn3o`K>]oa4V2_l9
4P[o4A`:oaX92_l92@X3oa4L2P0?oaX92_lJ4QCoH44Doc@_7_mkC1CoPehc
odIE:Omb>1CoWW/colZn[Oo1al7o^JY_om?Ie_n3Necoi=3<00;oYZZS00_o
b]31ojJHKoo1/jgo`K>>ol77`OnEXHko0000o`T92_l94P[o2@T:oa4L2P02
o`TB2P04oa4L2_l92@[o4A`:ob<L2P?o6PT:00Go6Q8Dob`B0?lJ4QCo6PT:
ob`B0002oaX92P09ob<L2_lm4P[o6PT:ob`B0?l/71Co;180oaX92_l/71Co
?A`:00;o8a`:00Co6PT:ob`B0?lJ2@[o8a`:0_l/4P000olJ2@[o;180ob<L
2P02ob`B00;o8a`:00?o?A`:ob`B0?n`_/40GooVi^H01?nMWIgo]kNgolS8
b?oCdm<1om[JfP000_o^k^h01?o/k>cog=cLogalO?oJf]X2on3Ph006om?C
doo6a/Koc<c<olk>c_o@d=3odm?C1ooGemL04Oooo?oooogooooloooln_go
lO;domSTh_n`blKoS[R^ogB]W_moa;7oU=o;ojCagOn`nnOo]ok/ol?oloo<
ooGoboo[00?obooW0_o<onP00oo=onWoc_oZol[oiP06ol[oiP0bol_oi?o=
onCocOoRolkoh_o=on;oc_oRolgoh_o>on;ocOoRolkoh_o=on;oc_oRolgo
h_o>on;ocOoRolkoh_o=on;oc_oRolgoh_o>on;ocOoRolkoh_o=on;oc_oR
olgoh_o>on;ocOoRolkoh_o=on;oc_oRolgoh_o>on;ocOoRolkoh_o=on;o
c_oRolgoh_o>on;ocOoRolkoh_o=on;oc_oRolgoh_o>on;ocOoRolkoh_o=
on;oc_oRolgoi?o:on<7olWoi@GocOoY01Goc?oXol_oioo7onSoaoo`ol3o
k_nen^GoZ?3JojS_gOnUk=[oUMO9oh2n/OmeZZ3oR[F^ojk=b?oDj>Kol_[l
ooonooooo?oooo[nooonoooWinL00ooXj>P2onWYj@?oj^[Z0oo[jn/3onc/
k004om[Jf_oMgMgok>c/onc/k0?okNg]00?oPH61ocTi>Oo]kNd00_o_knl5
oo7al@03oo3`l?o@d=3of][J00Kol_;b00?ofMWIoo3`l?oclo<00_oclo<0
0ooPh>3ohn?Soo?cl`02oo?cl`Oom?Cd00?oQHF5oc/k>oodm?@01OoemOD3
ooOgm`;onOWi00?ogMgMom3@d?ohn?P01Oojn_X00ooWinOoj^[Zoo[jnP03
oo[jnP;ono_k0oolo?`2oogmo@Goo_kn00?olo?conOWioono_h01?ono_h0
0ooclo?oinOWooknoP02ooknoR[ooooo00Co7f2dojG4i_nidnooMjk[0_nY
g?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP07oaXB5?lA70[o2@TDocd_?Ol9
2ACo4A`:oaX92P02o`T92P03oa4L2_l92@[o2@T:00?o2@T:00?o2A8:o`T9
2_lA70X01?l92@X02OlA70[o6PT:o`T92_l92@[o;180o`T92_lA70[o2@T:
o`TB2P02oaX92P?o2@T:00Go4A`:ob<V2_l94P[o4A`:o`TB2P05o`T92P;o
2A8:00Co2@TDo`T92_l94P[o2@T:0_ldEBT01?lm;cgoAUDYoa4V2_l94PX3
o`T92P05oa4L2_l92@[o4A`:oa4L2_l94PX01_l92@X04_l94P[o2@T:o`TB
2_l94P[o2@T:oa4L2_l92ACo8blcoba<:Old;c?oPhB>oh>HS_n`/kOoUIRS
oh>HS_nEV:?o/;k1oeMWDP;o4BHN00go=6MkoiFcc?o:d=KoPhB>ocd_?OlS
;c?o;1`Do`TV:OlA9Qko;3PYoeMED_mZIc?oEei_00?oYZ6H00Wo`K>]ombc
Xoo:_Zgoi<O1ongIc?oLhmKoPehco`000?mZLU`00oofkNX04Oo]fLcog>?P
ong]j_o]kN[om^gZongIc?o]m_Goong<ooKoooo:d<7o`K>>oa4V2_l0003o
2A8:o`T95?lA70[o2A8:00?o4A`:01;o4BHDoaX92_lS;ako=2lNog:=?On`
ZXCoYZ6HolZn[OoLhmKog>?Pong]j_o]m_Gom_ooongfmOofooGokNgZomcS
h?o:_Zd3ong]jP04omcSh?o]kN[okNgZomcSh0;og>?F0_oLhn002?n=SFoo
2A8:oa4L2_lA70[o6Q8Do`T92_lA70[o2@T:0_lA70X05_l/71CoPehcodIE
:OmZIc?oJUDNolZZI_oC_Xko`K>>ojJQV?o1/hkob]3Fok2ZQ?o:d<7oYZZS
ol6cS_n`/kOoUJ6>ol77`OoCfMKo=5Dmo`000?l92A@2o`T92P?o2A8:1Ol9
2@X01_lA70[o;180oaXB5?l/4P3o8a`:ob`B00;o6PT:00co6Q8Dob`B0?lJ
2@[o8a`:ob`B0?lS70[o;180ocdB2_l/71Co;180ocdB2_l/4P02oaX92P05
oaXB5?l/4P3o6PT:ob`L5?lJ2@X00_lS70X01OlJ2@[o6Q8Dob<L2_l/4P3o
;1`D00;o;18000?o/;k1onk^k_o^k^h0GOo^k^h01?nSXj?o_Kfmolo?cooJ
f]X1on7Qh@000_ooool01?omoOgok>c/ogalO?oJf]X2on3Ph006om?Cdoo7
alOoc<c<olk>c_o@d=3od];B1ooFe]H04Oooo?oooogoooomoooknOcojno`
oloNfonWa/3oQKFYogZhZOn4ck_oUnWCojGih_nYnnGo[_WUokCfj?nkn>So
aOgT00;ob?gQ00?obOkRol[ohoo:on<00_o;on@8olcoi@;ocooR02kodOoR
olooh_oAon;ocooRom7oh_o?on;odOoRolooh_oAon;ocooRom7oh_o?on;o
dOoRolooh_oAon;ocooRom7oh_o?on;odOoRolooh_oAon;ocooRom7oh_o?
on;odOoRolooh_oAon;ocooRom7oh_o?on;odOoRolooh_oAon;ocooRom7o
h_o?on;odOoRolooh_oAon;ocooRom7oh_o?on;odOoRolooh_oAon;ocooR
2?o<onD00oo8oN7obOkRol[oh`02ol[oh`0AolWnh_o8oN7o`okRokOhh?nk
on_o`Oodokkol_nbon_oY?7MoiOQd?n@e<OoNkN]ohRj/OnSb<7obN;Noncf
moono_l00_oonol00oooo_ooinOWonSXj002onSXj005onWYjOoZj^[ojn_[
ofUYJOlc<c<00oo/k>`01oo]kNgobl_;oc4a<Ol=3@go2`/;oc@d=?o<c<`0
0oo^k^h00on8R8So0000olS8b002ono_k`Col?3`00KoYJFUo`T92Ol<30co
8R8Roc<c<onMWId2oo7al@0?olO7aolR8R;o71`Lojn_[oobl_;oclo?oc8b
<_l=3@go2`/;ocHf=_oBd];om?CdooGemOlm?CgoNWYj00ComOGe00?oS8b<
o`000?o>c/h01Oofm_H2ooShn00?ooOgmonJVY[o4Q8Bo`P82?lV9RKo6QXJ
odY:B_oDe=Con_[jomKFe_lc<c?o3@d=o`/;2olg=cOoemOG00;on_[j00Oo
NWYjod10@?olo?coo?cloogmoOmkNg_o@D5100?ooooo00goinOWodY:B_l3
0`?o8b<SoaLG5oo1`L7oooooonOWiom:BT[o0`<3ob<S8olG5aOo`L7102_o
oooo00Co6enfojC4i_nidnooMZgZ0_n[h?l01?mfMWKo`L71oo3`l?omoOeK
ooooo`05oa4L2_l92ACo8blNob`B0?lJ4Q@00ol92@X01_lA70[o2@T:o`T9
2_l92@[o;180oa4L2P;o2@T:0_lA70X02?lJ2@[o4A`:o`T92_l94P[o4A`:
o`TB2_l92@[o4A`:1?l92@X01?lA70[o2@T:oaX92_lA70X4o`T92P03o`TB
2_l92@[o2A8:00Co2@T:00?o0000oaX92_l94PX00_l94PX01ol92@[o2A8:
odI17_m6EBWoLXdmoa4V2_l92@X00olA70X01_lA9QCo;2HDoaXV5?lJ2@[o
4A`:o`T92P;o2A8:0_l92@X00ol94P[o2@T:o`TB2P02o`T92P;o2A8:00Oo
6Q8Doa4L2_l/>2Wo;4`YoeMWD_nVZZgoCeiV00;oPiR>027oNhf4oiFQS_nV
/l7o`LO1oc@_7_mbSCgo=2lNob<_:OnVan3odn?eongfmOoChoGom_oooiF=
I_nVV6ooWXAVojJ4D_nNQ6Ko/8Akol6QQ?nVQ8Co`J64ok24Noo1XHCo^JY_
ol6c[OoL/j?og;jgonC7`Oo1XHCoPehcoa4_?OnEQ8h00_o]fL`2ooK]jP09
ong]j_ofkN[okNgZong]j_oL_[Oo^JY_ob`B0?l0003o2A8:00;o2@TD00So
2A`DoaXB5?l92ACo2@T:oaXB5?l92ACo6RHDoc@_7P;oAUDY00KoPg]LojJZ
Xon`/kOo`LO1ol[@`OoLhmH2ong]jP;okOKe00KokNgZomcSh?oTd<cog>?F
ong]j_o]m_D3ong]jP;okOKe00SokNgZomcSh?oLhmKog>?PooKfmOlA9P[o
4A`:oaX92P;o4A`:00Wo6Q8Doa4L2_l92ACoH44Yoh=k<omZEAkoH44Yog]<
5?o:ZVH00_o1/hh04_o:d<7oYZ6HolZn[Oo1/jgoUJ6>olZn[Oo1al7oYZ6H
ol6c[On`/kOo`K>]oh>HS_l0003o2@T:oaXB5?l92@[o2A8:oaXB50Go2@T:
0_lA70X00olJ2@[o6Q8DoaX92P03oaX92P0Dob<L2_lJ2@[o8a`:ob`B0?lJ
2@[o8a`:ob`L5?lm4P[o?A`:ob<L2_lJ2@[o;180ocdB2_l/4P3o8a`:oaX9
2_l/4P3o6Q8DoaX92_l/4P02ob<L2P05oaX92_l/4P3o?A`:ob`B0?lS70X0
0_lm70X00ol/4P3o`LO<ooooo`1Nooooo`04ojn_[oo;bl_og]kNon[ZjP7o
l_;b0002onk^kP04onc/k?oLg=coO7alom[JfP;oh>3P00Koe=CDolS8b?o;
bl_oc/k>om3@d?oBd]87omKFeP0CoogmoOooo_oooocnoo[dn?oVinWoa]KE
oi[2^_mg/jOoR=;1ohCG`on:gl[oUn[FojOfhondo^go^?o`ok_okOo1onKo
a?oTolGoi@02olOoiP03olKoiOo4on?o`okR00Oo`okR03;oaOgRolKmg_o6
oMkoaocNolKmg_o7o=koa_gNolOlg_o6oMkoaocNolKmg_o7o=koa_gNolOl
g_o6oMkoaocNolKmg_o7o=koa_gNolOlg_o6oMkoaocNolKmg_o7o=koa_gN
olOlg_o6oMkoaocNolKmg_o7o=koa_gNolOlg_o6oMkoaocNolKmg_o7o=ko
a_gNolOlg_o6oMkoaocNolKmg_o7o=koa_gNolOlg_o6oMkoaocNolKmg_o7
o=koa_gNolKnh`Ooa?oS00?o`okRolCohoo5on@00_o6onD05Oo5onCoa?oS
ol;ni?o4onco^OkYok?mi_n`onWoY__ToiG]eon7g/_oQ]O6oh?;_On6`[Ko
UlFkokSEdOoKjNWomOKhooojooooo?ooookoonOWi`03onSXj0;oj^[Z00?o
k>c/ofUYJOlc<c<01?o]kNd01ol`<33oC4a<omkNg_oNg]koCdm?oc4a<Oo^
k^h00_o_knl00ol/;2co20P8ofUYJ@06ono_k`0;olS8b?nc/k?ojn_[oo3`
l?nCTi?o0`<3om3@d?o`l?3oJVYZocdm?Oo_knl00_o`l?002_la<C7oCDe=
on7QhOoRh^;oDE5Aoc8b<_oclo?omOGeocdm?OmjNWX4ooGem@03obd];Ol8
20SoK6a/00Gom_Kf0_ogmoL02onCTi?o0P82ohN7QooemOGon?ShooKfm_n]
[Jgod];BooShn?lb<S;oD51@00;oj>SX00KoDe=Coc<c<oohn?SonOWiogUi
NOm0@403ooclo003og]kNom1@D7ooooo00;ooooo00goA4A4od10@?oOgmoo
oooooo?cloobl_;oooooodA4A?m0@43ogmoOoooooooclo?ol_;b02_ooooo
00Co6ejcojG4i_ned>koNJk/0_nWg?l01?m^KVko];Bdon3Ph?o/k>aKonk^
kP;o6Q8D00?o4A`:o`T95?lA70X00_lA70X00olJ2@[o2@T:oa4L2P02oa4L
2P?o2@T:00?o4A`:o`T92_l/4P000_lJ2@X02olA70[o2@T:oaX92_lJ2@[o
4A`:o`T92_l/4P3o2A8:o`T92_l94P[o2@T:00;o6PT:00Go2@T:o`TB2_lA
70[o2@T:oa4L2P02o`T92P04o`000?l94P[o2@T:o`TB2P;o2@T:00Wo0000
o`TB2_lA70[o2@T:o`TB2_l/71CoH5hcodIE:OlS9PX00_l94PX02olJ2@[o
2A8:oaX92_lS9P[o;3PYob`V5?lA9P[o8a`:oa4L2_l92@[o4A`:00;o2@T:
00Co2A8:oa4L2_l92@[o00001?l94PX01_l92@[o6RHDoc@_:OmZNfooUJZ]
ofYkK`;oSIR>01CoPiR>ohfHS_nEZZgo`LO<ojJQV?nEZZgo8blNoaXV5?lA
9P[oJW^4ojJc`On`/kOoYZ6Hok24I_nNLS?o/8AVok24NonVQ8CoYYR4ojJQ
V0;oYXB400Ko/7]VojJ4Q?nVQ8Co/8Akok2ZQ?nVXIP2olZn[@08onC7`Oni
V5coH79kocebQ?n3SHCoYZZSomcSh?ofkNX2ongIc005ombn[OoT_XCokLN4
okUb<omkC1@00_lJ4Q@03?l92ACo6Q8Do`TB2_lA9QCo4A`:oaXB5?lS9P[o
=2lNocAE:OmGEE;oPg/cok2ZQ0;oYYR400?o/;>gomcSh?o]kNX00oo]m_D0
1?ofooookNgZomcSe_oTd<`3ong]jP03omcSh?ofooGokNgZ00;okNgZ00ko
g>?Pong]j_oLhmKog>?FooKomOmbSEco0000o`TL5?lA70[o6PT:o`TB2_lA
9QCoAT4NofYE7P;oH44Y01KoYXABolZZI_oLaj?o/;>goiFQS_oTal7o/;>g
ojJQV?o:d<7oYZZSol77`On`/kOoSHe_ol6c[Oo1al7oJXeLo`000?l92@[o
4A`:o`T92_lA70[o2A8:1ol92@X03_l/4P3o6PT:oaX92_l/4P3o6PT:ob<L
2_lJ2@[o;180oaX92_lS70[o6PT:ocdB2_l/4P3o?A`:0_l/4P000olm4P[o
?A`:oaX92P02ocdB2P0:oaX92_l/4P3o6Q8Dob<L2_l/4P3o6Q8DocdB2_l/
4P3o6Q8Dob`B00;o8a`:00Go;180ob`L5?l/71Co;180ok2n`@1Oonk^kP04
oj>SXonm_Kgoclo?om[JfP7ohN7Q0002onKViP0<onCTi?oDe=CoNg]kom[J
f_oPh>3ohN7QomGEeOo8b<Sob/[:olk>c_o@d=3odm?C1ooFe]H06?oboo[o
n?okooojn_oonooohMoTok[<c_n2]k7oLKnbogCA_omhe/CoRM_=oi[TeonW
jn3o[OCVoj_nj_n]on_o/ooWokGoi?ncoN;o]_oTok_oionmonWo__oYokco
i`Co^ooV0onjonH0<_njonCo^ooTok_ohonmon?o^ooSokgohonkon?o_OoS
ok_ohonmon?o^ooSokgohonkon?o_OoSok_ohonmon?o^ooSokkoi?nlonCo
__oTokcoi?nnonCo_?oTokkoi?nlonCo__oTokcoi?nnonCo_?oTokkoi?nl
onCo__oTokcoi?nmon?o^ooSokgohonkon?o_OoSok_ohonmon?o^ooSokgo
honkon?o_OoSok_ohonmon?o^ooSokgohonkonCo_?oU1OnlonL4ok_oi`?o
^?oV0_ngonD03onjo^Go`OcZokkkjoncnnOoYOWRoiOgg?n;l]OoO^K=ogKJ
`_midK_oM;f/ohFk[_nae/ood>CRooWoo`02ooomo`03ooonoooWinOoj>SX
00;oj>SX0_oYjNT00ooZj^[oJ6QXoc<c<`03on_[j`03olO7aol0003oZJVY
00;ok>c/00[oZJVYo`000?o<c<cokNg]okfm_Ol0003oTi>Coa4A4OoXj>So
kno_1OoalO43oo;blP06omGEeOl0003o[:b/oo;bl_m9BDWoK6a/0_obl_80
0oo=cLgo0000ojj^[P02oo?cl`06ojj^[_l0003odM7AooCdm?lm?CgoNGUi
0oodm?@01Oo3`l?o0000oiRHV?lB4Q;ok^k^00;omOGe0_ofm_H01?ohn?So
lO7aoa<C4omQHF42oo_kn`;oo?cl0_omoOd00ooFe]Ko0000okFe]@02oogm
o@06okFe]Ol0003of][JoogmoOmkNg_o@D510oono_h01omlO7co@T92oooo
oooooooogMgMo`000?nh^;P01?ooool00ooMgMgo0000okRh^00_ooooo`04
oa]O]_nTa>Ko^=;^ogJ]jP;o[=oo00CoJVYZojj^[_oHf=Soi>CTFooVi^H2
o`T92P08o`TB2_lJ4QCo2A8:oa4L2_lJ2@[o2@T:oa4L2_lJ2@X3o`T92P07
oa4L2_l92@[o4A`:o`000?lA70[o2@T:oa4L2P03o`T92P09oa4L2_l92@[o
2@T:o`T92_lA70[o2A8:o`T92_l94P[o6PT:00;o4A`:0_l92@X01?lA70[o
2@T:o`T92_l92@X2o`TB2P0Eo`000?l94P[o2A8:o`T92_l94P[o0000oa4L
2_l92@[o4A`:odIE:OmZLUco2A8:o`000?l94P[o4A`:o`TB2_lJ4QCo8bH:
ob`h:Old;ako;3PY00;o8blN00Co4A`:o`TB2_lA70[o2A8:0_l92@X03_l9
4P[o2@T:o`TB2_l92@[o2A8:oaXB5?l92ACo2A8:o`T95?l99RWoAUi7ofYk
Kon3Q8koSIR>0_nEZZd0:?n=V8koPiR>ok2n`Oo1alcoPhAkog^=I_ldEBWo
;3PYoc@_:On=V8ko/8AkokVZKonVV8Co`J64ojJHQ?o1XHCog;>SojJZXooL
/jgoYZZSol6QQ?nVZZ?o`J64ok24NonVXISoYYR4ojJ4Q?n`Q7_oYXB4ojJH
Q?o1XHCog;>4ojJHQ?n3V:go?G:4ojJ4Q?o1/jgokMW<ooKomOookL`2ongI
c00IokV=<omP@ACo2A`Do`T95?lA70[o2@TDoaX92_lA70[o;2HDob`L5?lJ
9QCo=2lNodI17_n3Nc?oH5hcodI17_nVV8CoYZZSolZn[Oo]m_Gom_ooongf
mOo]kN[okOKeooKoo`03omcSeP07ong]j_oLhn3okNgZomcSh?o]kN[okOKe
ooKom@02ong]jP;og>?F00goi=3<oooooom6Ieco4A`:oaX92_lA70[o2@TD
ob`V5?mP@ACo=2lNof11:OmZEAko/8eB00;og<NS00koSHe_ombn]oo:d=Ko
`K>>ol6c[On=V8koYZ6Hok2c]onVV8Co/;k1ok2ZQ?o:d<7oEheLo`0000;o
4A`:00?o2@T:o`T95?l94PX00ol92@X04Ol94P[o2@T:o`T92_l92@[o4A`:
oaX92_l92@[o6PT:ob<L2_lJ2@[o8a`:oaX92_lJ4QCo;180oaX92_lS70[o
6PT:00;o;18000[o?A8:ob<L2_lJ2@[o;180ob<L2_mG703oARHDob`B0?lJ
4QCo;1800_lJ2@X03?l/4P3o8a`:oaX92_lS70[o8bH:ob`L5?l/4P3o8bH:
ocdB2_l/71Co;180ol77c5ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X0
00;ok^k^00Cok>c/omcLg?mkNg_of][J0_oPh>001_oDe=Cob<S8ol_;boo>
c/kod=3@om;BdPOoeMGE01Sol?ohooOon_oonoWooo_oon7Pi_nfc]3oNKR`
ofS3]?m[e<?oLmS8ohWKconIgmGoYNCLojK/hOnPmnCoWogSojcoj?n^o^Go
[_cTok3ni_neonSo]ooZokSoj_ngonT2ok[ojP;o^?oZ1?ngonX@okSoj13o
^OoY4?nhonP6okWoj`Co^?o[0onfonX2okGoj@0CokOojOnim^Ko^?OVojce
h_nNlmcoT?;IohC_domhi<[oKm[0og3?^Om/_J[oOK^^ojcJd?o=j>?omOoo
oogmoooooOooookoonSXj003onWYj@05on[Zj_oYjNWoj^[ZofQXJ?lc<c<0
0oo[jn/00on_[joo0000omCDe002onc/k00:om?Cdol0003o/k>cong]kOmQ
HF7o?3`long]kOlU9BGoVIVIono_k`GolO7a0_obl_801ooShn?oBTY:o`L7
1ooUiNGol_;bodU9BOm/K6`00_obl_802one]KGo0000om_Kfooclo?om?Cd
om[Jf_l0003o^;RhooGemOlm?CgoNWYj00?omOGe00GoI6ATochn?_oemOGo
9RHVoijNWP04ooKfmP04ooShn?o>c/ko0000okjn_PCon_[j0_okno/00onk
^k_o0000on;RhP02oo_kn`06on3Ph?l0003o_Kfmoo_knomjNW[o@D510oom
oOd01omkNg_o@D51oooooooooooo_[jno`000?lm?Cd00olo?cl01?o4a<Co
_[jno`000?lm?Cd3oclo?`03olC4a?oooooooooo02Wooooo00Co7EncojK6
i_nfd>koNJo^0_n[g_l01?m^KVko];Bdon3Ph?o/k>aKonk^kP;o4A`:00Co
2A8:oaX92_lJ2@[o6Q8D0olA70X01Ol92ACo4A`:o`T92_lA70[o2@T:00;o
6PT:00So4A`:oaX92_l92@[o;180oa4L2_l92@[o;180oaX92P;o4A`:0_l9
2@X01?l0003o4A`:oaX92_lJ2@X2o`T92P03oa4L2_l92@[o2@T:00?o2@T:
00?o2A8:o`T92_l92@X01?l92@X04olJ2@[o2@T:oa4L2_lS9P[oJVLcodHV
5?l92@[o4A`:oaX92_lA70[o6PT:ob<V2_lS;ako;3PYodIE:OmP@BWo6RHD
oa4L2_lJ2@X00_lA70X3o`TB2P0@o`T92_l94P[o2A8:o`T95?l0003o8blN
oa4V2_l92ACo2A8:oa4L2_lA9QCoCfM7oiFHXonEZZgo/;k1ojJZX`;oSIR>
00Co/;k1ol[@e_mkSHCoJW9L0_m6C3d03?m?IdOoJW9LojJQV?o1XHCoYZ6H
onBZV?o1/hkog;jgombcXooTal7og;j]ombc[@;og;>S0_o:_Zd00onVZZ?o
g;>SojJQV002ojJ4Q0;oUHAk00co^IQLong@V?o:ZVKo0000obaEKomGSHko
UHABoh>4Noo1/hkoong<ombcG?l00003o`TB2P05oa4V5?l/71Co;1`DoaXV
5?lS70X00_lJ4Q@04OldEBWoAT4Nob<_7_lA9QkoJVLcojJHKon`ZXCokNgZ
ooKoooo]m_GokNgZomcSh?o]m_Gom_oeomcSh?o]kN[okOKe00?okNgZ0_o]
m_D01?ofooGokNgZong]j_oTd<`2omcSeP0@ooK]j_oooooo4BH:oa4L2_lA
9QCo2@TDoaX92_mZEAkoJVLcoc@_7_mZEAkoWW/cokVZKon`ZXCoYZZSojJH
K`;ob]3100SoSHe_onC@c?n3Necob[j]ojJZXoo1/hkob]31ok2c]`;o0000
00Go4A`:o`TB2_l92@[o2A8:oaXB5002o`TB2P03o`T92_l94P[o2@T:00;o
4A`:00go2@T:oaXB5?lJ2@[o4A`:o`TB2_l/4P3o6PT:ob`B0?lJ2@[o;180
oaX92_l92ACo;18000;o8a`:00Co?A8:ocdL2_lm70[o;1800_lJ2@X04?m6
9P[o?A8:ob`B0?lS70[o;180oaXB5?lS70[o;180ob`V5?l/4P3o8a`:ob`B
0?lm4P[o;1`Dob`B0?m69Q@2ocdB2P03ok2n`Oo^k^kok^k^05gok^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo00CooOgmonc/k?mlO7cof][J
0_oPh>001_oDe=Cob<S8olc<c?o>c/kod=3@om;BdPOoe=CD01Som?ogoo[o
nOooo?[ooo[momkSionbd]7oKKFYof33/OmVdl3oKMK5ohGIc?nDg=7oWN3G
oigWf_nElMcoUoGMojKhh_nZmN7oZoCQojceh_nbmnGo/oSVokCgi_ncm^D2
okCdi0;o/_GT1?nam^@@ok;eha3o/oKT4?nbmN<6ok?fi@Co/_OU0on_m^@3
ojkeh`0Aoj[agonWl]koX>oLoiK[e_n=jMCoQnK@og_NbOmbe[koK<^eofJk
Y_ma^:SoZMgAol[[i?o_oOgoo?goooomooooo_l01?oXj>P2onWYj@03on[Z
j_mXJ6So<c<c00?oj^[Z00?ob/[:o`000?nUYJD00_o[jn/02_nTY:Co0000
olo?cooShn?o3@d=oiJFU_o]kNgoQHF5ocXj>_o^k^h3oo3`l0;olO7a00Go
l_;bojb/[?lJ6Q[o5ADEokBd]002oo;blP07odU9BOm/K6col_;boo;bl_oA
dM7o0000oj^[Z`02ooCdm006oj^[Zol0003oemOGooKfm_lm?CgoIFEU0_of
m_H01_o]kNgo3Ph>oibLW?ofm_KoRXZ:oc`l?0GomoOg00?o[Jf]o`000?oK
fm/01?ohn?P2ooWin@03omKFe_l0003o[jn_00;onOWi00Ko[Jf]o`000?oJ
f][onOWiogUiNOm0@403ooclo00Bog]kNom1@D7ooooooooooooKfm_o0000
oj^[Zoo?clooalO7o`<30ooUiNGofm_Ko`000?n[Zj_oclo?olO7aol30`?o
iNGU:oooool01?lJG;?oY<?UokSBkomi[^`2ojcOo`04ogIfM_o1`L7ol?3`
oogmoE_ooooo00Ko4A`:oaX92_lJ4QCo4A`:ob`h:Ol92A@2o`T92P03oaX9
2_lJ4QCo4A`:00;o2@T:00Co4A`:o`T92_l92@[o6PT:0_lA70X03Ol92@[o
6PT:oa4L2_lA70[o2@T:o`000?lJ2@[o4A`:o`000?lA70[o2@T:oa4L2_l9
2@X00_lA70X00ol94P[o2@T:o`TB2P02o`T92P;o2A8:1?l92@X01?l94P[o
2@T:o`T92_lA70X2o`T92P0=odIE:Ol/4P3o6PT:oa4V2_lJ2@[o4A`:oaXV
5?ld;bWo8bH:oc@_<om6EBWoAT`mob<L2P03oa4L2P07oaX92_lA70[o2@T:
oaXB5?l94P[o2@T:o`TB2P02o`T9500=ofYbG?mGIe;o2A8:o`TL5?l94P[o
0000ob=1?On3SHCoPhB>ol77`OnEZZgoYZ6HojJZ[@02ol[@eP03oh>4NomZ
NfooUJ6>00;oNheV00Wo;3PYog:=Q?o1XHCog;>SojJQV?o1/hkog;j]ombc
XooL_[L01?o:_Zd02_oLaj?ob[j]omc7XonVXISoYZZSol6cS_nVZZ?oYZ6H
ojJHKol/>2T2o`000004o`T92_l0003o0000o`T92P;o000000[o=2lNo`00
0?l92ACo2@T:oaXB5?l/71Co6Q8Dob`L5?lJ9QCo;1`D0_lA70X02?l/9QCo
6Q8DoaXV5?lS;ako=2lNof1N<onVXISoi<O10_o]m_D00oo]kN[og>?PomcS
h002ong]jP;okOKe00KokNgZongfmOo]kN[og>?FooKomOo]m_D3ong]jP0=
omcSe_o]kN[og>?FoooooonVan3o0000o`TL5?lA9QCo4A`:ofYE7_m6@Ako
H2lDoh=k<`02okVZK`08ojJQV?n`ZXCog;jgojJQV?o:_Zgo`LO<oiF=I_o:
d<42ok2c]`08ol6c[OnEXHkog<NSoa4V2_l0003o6Q8Doa4L2_l92A@2o`TB
2P05o`000?l92ACo2A8:o`T92_l94PX01?l92@X05OlJ2@[o;180oaXB5?lJ
2@[o;180oaX92_l/71Co;180oaX92_l/4P3o8a`:oaX92_l/71Co6PT:ob`B
0?m69P[o?A8:ob<L2_l/4P3o8a`:ocdB2P02ob<L2P0@oaX92_lS70[o8a`:
ob`B0?lJ2@[o?A8:ob<L2_lJ2@[o?A`:ob<L2_lm70[o;180ocdL2_l/9QCo
;180ol[@eUoooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000;ok^k^00co
k>c/omcLg?mkNg_ofMWIomoOgooQhN7oe=CDolO7aoo<c<coc/k>om3@d?oE
eMD7omCDe00Foo[omoomooWooocmookjnooKi^So[MKBoeb]W_mD_ZSoF/jg
ofCC`?mke/OoS=W?oiGMd_nGhmKoT>gHoiCag?nKk=_oXN_Loj?[gOnTk=ko
Z>cOojW]h0;oZ^cP0_nZjMh3ojSZgP;oYn_N00?oYn_LojSZg?nXj]`03_nX
j]`@ojW[gA3oZ>[L1_nYjml2ojS/g`;oYn_N0_nUk=h3ojC[g@0Coj;/fonL
kM[oVNkIoiGZeOn?i=7oR^7>ohKOcOmlfLKoLm:nof_:]_mM]Z;oHJjNoj7M
dOo:knSojoklookooooooOooookoonWYj@03on[ZjP05on_[jooZj^[ojn_[
ofUYJOlc<c<01?o/k>`03_ll?3co@T92olg=cOo<c<co@D51ochn?_o]kNgo
UiNGo`d=3OoShn?okNg]omgMgOl820Sob<S81Oo_knl01?miNGWo0000oe1@
D?oHf=P2oo3`l008on[Zj_m4A4CoIVIVonGUiOo/k>colO7aocdm?Om4A4@2
om;BdP0?od=3@om1@D7om?CdooGemOlm?Cgo4Q8Boh^;RooKfm_oVi^Ko`d=
3Oo[jn_omOGeonCTi?l820Soclo?00?om_Kf00ComoOgol30`?l0003oc<c<
1?ohn?P3ooWin@0;oclo?om6ATKof=SHomOGeom5ADGo@T92ooWinOodm?Co
Lg=cocdm?OoalO400_ogmoL02_meMGGo?ShnooCdm?ojn_[ooooooclo?om[
Jf_omoOgoijNW_l[:b/2ooooo`05oclo?om[Jf_omoOgoijNW_l[:b/0;?oo
ool01?lMGk?oYLCVokKBk_mi[^T2oj[Po`04ofi^K_nd];Coh>3Ponc/k5_o
k^k^0_lA70X01?lJ2@[o4A`:oaX92_lJ2@X2oa4L2P08o`T92_lA70[o2@T:
oa4L2_l/4P3o2A8:o`T92_lA70X2o`T92P04ob`B0?lJ2@[o4A`:oa4L2P;o
6PT:0_lA70X01_l92@[o4A`:o`T92_lA70[o0000oa4V2P?o2@T:00Co;180
o`T92_l94P[o4A`:0_l92@X2oa4L2P06o`T92_l94P[o2@T:o`T92_lA70[o
2A8:0_l92@X2oa4L2P;o8bH:00_o4A`:oaXV5?l/9QCo;2HDob<_7_m6EBWo
H5hcodI17_lA70[o8a`:o`TB2P02oa4L2P04o`T92_l94P[o2@T:ob`L50;o
2A8:017o4A`:o`TB2_mkSFKoUJ6>odI<?Ol0003o2A`Do`TB2_lA9P[oEheL
ofYkKomPLW_oYZZ]ok2c]on3V8koUJZ]ok2c]`02ohfHSP08ojJQV?m?IdOo
CfM7og:=G?mGIe;o`K>]ol6cS_oL/j<2ol6c[@05ok2ZQ?n3SHCoAUDYob`h
:OlA9PX00ol000009Ol/>2WoLXeLojJQV?mbLW_oYYQ_oiFQS_l0003o2A8:
o`T95?l971Co6Q8Doa4V7_l94P[o6Q8Do`T95?l94P[o2@T:o`T95?l/9QCo
8a`:oaXV5?lS70[o;1`Dob`V5?l/71Co6RHDob<_7_l/9QCo4BH:oaXV5?l/
9QCoAT4Noc@_:OmP@BWob[j]omcSe_ofool00_o]kNX00ooLhmKog>?Pong]
jP02ongfm@06ooKomOo]m_GokNgZomcSe_o]fLcom_oo0oo]kNX01oo]m_Go
g>?Fong]j_o]kN[om_ooobaWG?l000000_lJ4Q@01omZEAkoPg/codHV5?n3
Nc?o`J64ol6cS_nVV8@00_o1/hh03?o1al7o`K>]ok2ZQ?n`/kOoYYR4ol77
`Oo1/jgoYZ6Hol[@`Oo1/hko6RHDo`0000;o4A`:00So2@T:oaX92_l94P[o
2@T:oa4L2_l94P[o2@T:o`TB2P?o2@T:00Oo2A8:oa4L2_l92@[o6PT:oa4L
2_lJ2@[o8a`:00;o;1800_lJ4Q@00olS70[o6PT:ob`B0002ob`B0003ocdL
2_lm4P[o8bH:00;o6PT:00Ko?A8:oeLL0?lm70[o;180oaX92_lJ4Q@2ob`B
0005ob<L2_lS9P[o;180oaX92_lm4PX00_lm70X01Om69QCo?A`:ocdL2_l/
4P3ob]3F05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV00co
i>CTomCDe?mkNg_ofMWIomoOgooQhN7oe=CDolK6a_o<c<coc/k>om3@d?oD
e=@7omGEe@0Doooon_onoOSooocmoo[hnooJkN_oZ]cCodbUTom4]YgoCl^a
oe_A^Omce/CoQ=S;ohgKc_n>gm3oRnSCohk[e_nCi]KoUnGGoi[VfOnLj=/2
oioWf`03oj3VfonQimcoY>SM00;oY>SM0onRj=d2oj7Yg@03oj;XgOnRjM_o
X^WK02goX^WK1_nSjMh2oj;ZgP;oXNWM01SoX>[MoioYg?nOjMcoWnWLoikX
fonIj]_oSn_FohgZeOn<iM7oR=o>ohOKbon5fL[oNMC3og3=^_mUa[;oDZnJ
oe6TT_nLg]3ocOK^on_ooOooo_oooogoooonoooXj>P3onWYj@;oj^[Z00?o
jn_[ofUYJOlc<c<01?o/k>`02OoFe]KoBd];o`d=3Ol=3@goCDe=omOGeoo]
kNgoDe=CofUYJ@03ong]k@03ofATI?mlO7cokno_00?okno_00?oemOGo`41
0On:RXX01?o`l?002?mgMgOo1`L7o`/;2olI6AWoXj>Soo7alOoKfm_oCDe=
0_l>3Ph02_m@D53og]kNooCdm?oemOGoD51@oh>3PomIFEWo20P8oe5ADOm/
K6`3ooGem@03ofQXJ?n0P83om_Kf00;om_Kf00Con?ShonKVi_l10@7oVIVI
1?oinOT3oo[jnP0Gon?Shom@D53o3Ph>o`h>3_mBDU;oi>CToo[jn_n<S8co
30`<o`H61_lJ6Q[oU9BDohf=SOl<30co1PH6oa/K6onFUYKoooooonKVi_m7
AdOo3@d=oa`L7?ng]kL00_ooool01OoVi^KoAdM7o`d=3OlL71co]kNg02co
oooo00Co6ejcojK6i_nidnkoNJk[0_n[gol01?mZJV[o[Zj^omSHf?oTi>AK
onKViP?o4A`:013o2@TDoa4L2_l92@[o4A`:oaX92_l94P[o6PT:oa4L2_lJ
2@[o2@T:oc@_7_l94P[o;180oa4L2_l/4P3o4A`:0_lJ2@X01_l94P[o6PT:
o`T92_l/4P3o2@T:o`TB2P;o2@T:00?o2A8:o`T92_lJ2@X01?l92@X01OlA
70[o2@T:o`T92_l92@[o2A8:00Co2@T:00?o4A`:o`T92_l92@X00_lA70X2
o`TB2P03oa4L2_lA9P[o6PT:00;o8bH:00Ko4BH:ob<_7_lJ4QCoH5hcodIE
:Ol/9Q@3oa4L2P05ob<L2_lA70[o4A`:o`T92_lA70X00_l92@X02?l94P[o
2@T:oaXV5?mkSFKoJW]_oiFQS_m6EBWo2A8:0_l000006?m6IecoH5hcoa4V
2_mbLW_oUIRSofYbG?n`/kOoYZZSol[@e_mbLW_oJW]_ohfHS_mkSHCoJW]_
odINAonVZZ?o`K>>odIE:OnVXFKo8blYob<_7_m6EBWo=2lcocAE:@;o2@TD
00ko2A8:o`T92_lS;akoEheLodmbNombSHCoPiR]oeN=G?l0003o6Q8Do`T9
5?lJ4QCo2@T:o`TB2P;o2@TD00Go6Q8Do`T95?lS;ako2@TDob<L2P02oaX9
2P?o4A`:00?o8blNob`V5?l/9Q@00_lJ4Q@01ol/71Co6RHDob<_7_lS9P[o
Pg]LomcSe_o]m_D00_o]kNX01?oLhn3okNgZong]j_o]kNX2ongfm@03ooKo
ooo]kN[og>?F00;og>?F00?om_ooong]j_o]kNX01?o]kNX08Oo]m_Gom_oo
odmWG?l0003o4BHNodHV5?mZIc?oJUDNojJ4D_niV5co`K>>ohf=Kon`Q6Ko
b]31ol6c[OnVV6oodmWFojJHQ?n`ZXCog>?Pok2ZQ?o:d=Ko`K>]oh=k<ol0
003o2@T:o`TB2_lJ2@[o2@TDo`T92_lA70[o2@T:oa4L2P02o`T92P0NoaXB
5?l94P[o2@T:o`T92_l94P[o2@T:o`TB2_lA70[o6PT:o`TB2_lS70[o6PT:
ob<L2_lJ2@[o;180ocdB2_lJ2@[o;180oaX92_lm4P[o6PT:ob`B0?m69P[o
;180ob`L5?l/4P3o8a`:ocdB2_l/71Co8a`:0_l/4P002ol/71Co?A8:ob`L
5?l/4P3o;1`Dob`B0?lS9P[o;180ob<L2_lm70[o;2HD00;o?A8:00?o`LO1
onKVi_oVi^H0GOoVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h0
3?o/k>cog=cLogalO?oJf][ogmoOon7QhOoDe=Coa/K6olc<c?o>c/kod=3@
om?Cd`OoeMGE01Goooojoogln?ooo?gonOWkon3dl_nahm[oAIj<ocZ_UOm6
aj_oCm2dofOD_omhe/KoPMG6ohGGbOn5g/coQ^7?ohgQdOn@h]CoTnGGoiKV
fOnGiMP00_nHi=P6oi_Tf@;oVNGI0onIiMP0<onKiMSoVNGHoi_Uf?nIiMSo
VnGHoiWUf?nKiMSoVNGHoi_Uf?nIiMSoVnGHoiWUf?nKiMSoVNGHoi_Uf?nI
iMSoVnGHoiWUf?nKiMSoVNGHoi_Uf?nIiMSoVnGHoiWUf?nKiMSoVNGHoi_U
f?nIiMSoVnGHoiWUf?nKiMSoVNGHoi_Uf?nIiMSoVnGHoiWUf?nKiMSoVNGH
oi_Uf?nIiMSoVnGHoiWUf?nKiMSoVNGHoi_Uf?nIiMSoW>GJoi[Vf_nLiM[o
V^KJoicUfP02oi[VfP0KoiWWf_nIiMWoV>KIoiSVfOnEiMSoUnGHoiGUf?nF
i=OoT^KFohSSdOn6iM7oQ=o=oh7Jb?moe/KoNm?3og3=^omTaK;oFkjZodZY
UOm:WH_oX^CFomKonOo]ooooookoooolooooo_ooj>SX00?ojNWY0_oZj^X0
0oo[jn_oJFUYoc<c<`06onc/k0;ojn_[0_o/k>`6ong]k@;ok^k^1?o_knl0
0oo:b/[o0@41omWIf@05oo3`l004odQ8B?m[Jf_ol?3`oo3`l0?olO7a0_ob
l_83ooGem@Com_Kf00?olo?cooKfm_ofm_H00oofm_H3ooOgm`;on?Sh0_oi
nOT01?mPH63o92@TonSXj?ojn_X2oo_kn`Goo?cl0_okno/4ooclo007ogem
OOm0@43ooOgmoogmoOono_koOgmood51@@05ooooo`03ooclo?oooooooooo
00Cooooo00?oo?clooooooooool0;?ooool01?lOHKCoXl;TokSCkomg[^/2
oj[Oo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00[o6Q8Do`TB2_lJ4QCo4BHD
oaX92_lA70[o6Q8Do`TB2_lJ2@[o4A`:0ol92@X02Ol94P[o6PT:o`T92_lJ
2@[o2@T:oaX92_lA70[o;180oaX92P02oa4L2P05oaX92_l92@[o4A`:o`TB
2_l000001_l92@X01_l94P[o2@T:oaXB5?lA70[o2@T:oa4L2P?o2@T:00Co
6PT:o`T92_l92@[o;1800ol92@X00olJ2@[o2@T:oa4L2P02oa4L2P08oc@_
7_lJ4QCo6RHDoaXL7_m6GTOoH5hcob`V5?l94PX3oa4L2P06oaX92_lA70[o
2@T:o`TB2_l92@[o2A8:0_l92@X0<OlS;akoNhf4of1bNon`/kOoUJ6>odIE
:Ol0003o2A`Doa4V2_m6Ieco=2lYodmbNonEZZgoYZZ]ok2n`OnV/l7ob]3F
ojJZXonEXHkoLW9koiFQS_n=V8koJW9LofYkKooLhmKo0000oiFHI_lS;ako
CfMLoceN?OlS;akoJW9LoaXV5?l92ACo4A`:o`000?m6C3goJW^4og:=Q?n3
V8ko4BH:o`000?l92ACo4A`:o`TB2_l92@[o4A`:o`T95?lA9Qh00_l94PX0
2OlJ4QCo2@TDo`TB2_l92ACo4A`:ob<L2_lA9QCo6Q8Doa4L2P02oaXB5003
o`TL5?l/71Co8blN00;o6RHD00Ko6Q8Dob<_7_nVV8CokNgZongfmOoLhn03
ong]jP;okOKe00GokNgZooooooo]kN[og>?PonC@c002ong]jP05ooKoooo]
m_GokNgZongfmOofkNX00_o]m_D2ooKoo`0Ioh>HS_lA9P[oLSPDofYW<omP
GS?oPehDom>nS_n`ZXCo^IQLol[@`OoLhn3oYYQ_omcSh?o1al7oYYQ_omcS
h?nVZZ?oi=3<ol6c[OoLaj?oLXeLo`000?l92ACo2@T:oa4L2P02o`T92P04
oa4L2_l92@[o2@T:o`TB2P;o2@T:00?o2A8:o`T92_l92@X00_l92@X04?lA
70[o2@T:oaX92_lJ2@[o;180oaX92_l/4P3o6PT:ob`B0?lJ2@[o;180ocdB
2_lJ4QCo8a`:ob`B0?l/71@2ocdB2P0Gob`B0?lJ2@[o6PT:ocdB2_m69P[o
;180oaX92_lJ4QCo6PT:ob`B0?lJ2@[o;180ocdB2_lm70[o8a`:ocdL2_lm
4P[o?A`:ob`L5?lm70[oARH:ocdL2_o1al`0Goo^k^h01?nSXj?o_Kfmolo?
cooJf]X1on7Qh@000_ooool03?omoOgok>c/ogalO?oIfMWoh>3Pon7QhOoE
eMGob<S8ol_;boo>c/kod=3@om?Cd`Ooe=CD01Soo_okoo_lmooooOgonoWl
ongknoo0jnCoAib9ocV[TOlh_Iko?lVXoeG?]_mVdkkoLm2nogc@`On2eLGo
QMW9ohCKb_n7h<koR^?AohgTdon>h];oS^7AohoRd_n@hM83ohoPd@KoS^7A
03CoS^7?ohoPcon>hLooSn3?ohkQcon?h<ooS^7?ohoPcon>hLooSn3?ohkQ
con?h<ooS^7?ohoPcon>hLooS]o>ohgPc_n>glkoSN3>ohkOc_n=h<koS]o>
ohgPc_n>glkoSN3>ohkOc_n=h<koS]o>ohgPc_n>glkoSN3>ohoPcon>hLoo
Sn3?ohkQcon?h<ooS^7?ohoPcon>hLooSn3?ohkQcon?h<ooS^7?ohoPcon>
hLooSn3?ohkQcon@hM;oSn;Boi3Qd_n?h];oT>7B0_n?h]806_n>h];oSN3@
ohcPd?n<h=3oR^7@oh_Ocon9h<ooRmo?ohWPcon6f/[oQ=_;oh3Hb?mie<?o
Lm71ofc?_OmOa[?oE;jXodV`Vom3XXkoC9f<ok7]hOoRooookognooomoooo
nooooogo1?oXj>P01Om/K6coG5aLoeaLG?lY:BWo51@D00?oG5aL00?ofm_K
on_[joo[jn/01oo[jn/3onc/k0;okNg]0oo^k^h2ono_k`05odE5AOlf=SKo
QHF5oe]KFomBDU800_o_knl01?oAdM7od=3@oo3`l?o`l?03oo7al@03oo?c
loobl_;om?Cd00;om?Cd0_oemOD8ooKfmPGomoOg0_ohn?P02?oTi>Co?clo
oadM7OmhN7SoTi>Cog5aLOl_;boo^[Zj2Oojn_X01onf][Ko7QhNooclo?ol
o?cooOgmokRh^?lN7Qh0>oooool01?lOH;CoYLCVokWCkomg[^/2ojWLo`04
ogIfM_o1`L7ol?3`oogmoE_ooooo01?o4A`:oaX92_lJ2@[o6Q8Do`T95?lJ
4QCo2@T:oaX92_lA70[o2@T:oa4L2_lJ2@[o2@T:oaX92_l92@[o6PT:o`T9
2_lJ2@[o4A`:00?o2@T:0_lJ2@X01?lA70[o2@T:oaX92_l94PX3o`T92P04
ob<L2_lA70[o2@T:oa4L2P;o2@T:00?o4A`:o`T92_l92@X01?l92@X01?l9
4P[o2@T:o`TB2_l92@X2oa4L2P?o2@T:00_o6Q8Doa4L2_lA70[o8bH:oaXB
5?lA9QCo;1`Dof1N<om6EBWo;3PYob<L2P04oa4L2P;o2@T:0ol94PX00olA
70[o2@TDoa4L2P02ofYkK`0Zoh>HS_nVXISoUJZ]ohf=Kol0003o2A`Doba<
:Om6IecoJW]_oiFZ[On`_/7oUIRSok2c]oo1alcoUJZ]ok2c]onVZZ?oNheV
ob`h:OmGIe;o2A8:o`TL5?l92@[oUHABocd_?OmGIe;oH5hcob<_7_n=SE;o
=5DYo`000?l94P[o6Q8DodIWG?m?LW_oJW^4odINAol94P[o2A`Doa4L2_l9
2ACo2A`D0_l92A@01_l94P[o2@TDoaXB5?l92ACo4A`:o`TB2P;o2@TD00?o
6Q8Do`T95?lA70X00_lJ4Q@03?l92@[o6PT:oa4L2_lJ9QCo;1`DoaXV5?l/
71Co6Q`Nob<L2_oL/j?okNgZongfm@;okNgZ00?og>?PooKomOo]m_D00_o]
m_D02OofooGog>?Pombn]ooLhmKokNgZomcSh?ofooGom_ooong]jP03ongf
m@0FooKomOo]m_Gom_oook2c]olS9P[oPg/cof1N<onEEACodkj>ojJHKoni
V5cob]31om>nS_o:d<7ob[j]onC7`Oo]kN[ob]31ong]j_o:_ZgodmWFog^=
IP;o000000Go6PT:o`T95?lA70[o2@TDo`TB2P02o`T92P03oa4L2_l92ACo
2@T:00Co2@T:00?o2A8:o`T92_l92@X00_l92@X3oaX92P06ob`B0?lJ4QCo
;180ob`L5?lJ2@[o;1`D0_lJ2@X01ol/4P3o8bH:ob<L2_lm4P[oARH:ocdB
2_lA70X00_lJ2@X2ocdB2P;o;18000Oo;1`Dob`B0?lS70[o;1`DocdB2_m6
9P[o6PT:00;o?A`:00Ko;1`DocdL2_m69QCo?A`:ocdB2_o:d<5Oooooo`04
ojn_[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP0<onc/k?oLg=coO7alomWI
fOoPh>3ohN7QomGEeOo7alOob/[:olk>c_o@d=3odm?C1ooDe=@06?oioo_o
mochooomooonnOgon?ooolg`j_m@V8[o?ZRAobfbTolc`9koA/^^oeS@]omX
c[WoM/fmoh??`_n9eLSoPMG5oh7Ja_n6gL[oR=o<ohWNbon8flWoR]_:oh_L
b`;oSmg=0_n=g/d4ohcOc@03ohgNcOn=g/_oSMk;00goSMk;4?n<gLX@ohgN
b`KoS]o>0_n=h<h2oh_Nc0?oRMk;0_n8gLX04on9g<coQm35ohSAa_mnd/?o
Lm2nofK@_?mMcKOoCl>/odNiX_lkYHoo@Ib:oeFMTOo0ln[ojooooo3jo?oo
o?oooo_oooonoooXj>P00ooYjNT00onHV9SoS8b<ohf=S@05ohf=S@03on7Q
hOo/k>cok>c/00Cok>c/1_o]kNd2onk^kPGokno_00Gok>c/oj^[ZomWIfOo
P820ok>c/`06oo3`l0?olO7a00?olo?cooCdm?ofm_H00_ofm_H:ooOgm`Go
n?Sh0_oinOT2ooShn006ojf][OmlO7coIVIVohF5QOnYZJWojn_[2Oojn_X0
2_oemOGo@d=3ob8R8_lK6a_oeMGEooShn?m4A4Co8b<Soa`L7?oGemLhoooo
o`04oa]O]_nTa>Ko^M?_ogJ]jP;oZn3o00CoKVi^okBd]?oPh>3ok>c/Foo^
k^h03OlJ2@[o4A`:o`T92_lJ4QCo4A`:oaXB5?lA70[o2@T:oa4L2_l94P[o
6PT:oa4L2_l92@X00_lA70X03?l92@[o6PT:o`TB2_lJ2@[o4A`:oaX92_lA
70[o2@T:oaX92_l94P[o;180oa4L2P;o2@T:00Co2A8:o`T92_l94P[o2A8:
0_l92@X01?lJ2@[o2A8:o`TB2_lA70X2o`T92P0<oa4L2_l94P[o4A`:o`T9
2_lA70[o2@T:oa4L2_lJ2@[o2@T:oa4L2_l92@[o4A`:0_l92@X2oa4L2P0;
o`T95?lS;ako=2lYoeMWD_lmGSgo8blYoaXV5?lA70[o6Q8Doa4V5?lA70X0
0ol94PX2o`T92P0]o`TB2_l92@[o2A8:oc@_<omkSHCoYZZSok2c]onVZZgo
`LO1oa4V2_l94P[o4BH:odmWAom?GVKoPiRgoh>HS_nEZZgob]3FofYkKoo:
d=Ko`LO<og^=I_l0003o2@T:og:=G?l0003o2@T:oa4V5?mkSFKo=2lcog9W
D_m?IdOo6Q8DoiFQS_mPGS?o2@T:o`TB2_l0003oEfMBoeN=G?m?LW_o?Ehm
oa4V2_l92ACo2A8:00Co2@TD00Co2@T:o`T95?l92@[o6Q8D0_l92A@02?lJ
4QCo2@TDoa4L2_lJ4QCo2A8:oa4L2_l92ACo6RHD0_lA9Q@02?lJ4QCo6RHD
oa4V2_lJ9QCo8blNob`V5?o:d<7om_Ke0_o]m_D00oo]kN[og>?Pong]jP02
ongfm@04ooooooo]kN[ob]31omcSePCokNgZ00CokOKeong]j_o]kN[okNgZ
0oo]m_D01Ooooooob]3Foa4V2_mZEAkoPehD00;odkj>00_ob[j]ongIc?o]
m_Go`K>>omcSe_n=SFooSHe7odINAon=SE;o?EhmodI17P02o`000009o`T9
5?l94P[o4A`:oa4L2_l92@[o4A`:o`T92_lA70[o2@T:00;o2A8:00So2@T:
o`TB2_l92@[o2A8:o`T92_l94P[o2@T:o`TB2P;o2@T:00Go4A`:o`T92_lJ
4QCo?A`:ob`B0002oaX92P?o;18000[o8a`:oaX92_lm4P[o?A8:ob`B0?l/
71Co;180oaX92_lS70[o;1800_m69Q@01?lm4P[o;1`Dob<L2_lJ2@X2ob`B
0005odHV2_lm4P[o6PT:ob<L2_lm70X00_l/71@01?m69P[oARHDocdL2_n`
/kMOonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002onKViP0<onCTi?oD
e=CoNg]kom[Jf_oOgmoohN7QomGEeOo6a/Kob/[:olk>c_o@d=3odm?C1ooD
e=@06?odoogomOojooomo_ooo?ooookoomc`kon7`;Oo<i1kobNTQ_lT/Hko
<kjMoe7B]?mMak7oOMC4oj3Sf_nDe/coU^?CohoPcOnBhLkoUnKCoi_Xe_nJ
i=?oVnCCoioXe`CoW>GD0_nKiM@00onIi]CoVNKBoi_VdP0_oi_VdPCoW>GD
1?nKiM@06_nLjMOoVnSFoi_Xe_nJimGoVNSEoiOVdonCh/ooU=c>oj7Je?nU
h=coO<VoogOHaomUfL;oA<>Xod72Y_lVX8Oo:YAnod6EQOml^;3ohoooonWh
noogn?gooo_ooooiooooo_ooj>SX0ooYjNT2on_[j`?okNg]2_o^k^h7ono_
k`Kol?3`2ooalO43oo;blP;om?Cd0oofm_H:ooOgm`gon?Sh2ooinOT2oo[j
nP03onKVi_o[jn_oo?cl00;oo_kn00?ojNWYonk^k_ooool0>?ooool01?lK
G[?oYLCVokG@k_mi[^`2ojOLo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV0_l9
2@X2oa4L2P05o`TB2_lS70[o2@T:oa4L2_l/4P000_l92@X01?l94P[o4A`:
oaX92_l92@X2oa4L2P0=oaX92_l92@[o6PT:oa4L2_l0003o4A`:ob`B0?l9
2@[o6PT:o`T92_lA70[o2A8:o`T92P02o`TB2P03o`T92_lA70[o4A`:00?o
2@T:00?o4A`:o`T92_lA70X00ol92@X01?l94P[o2@T:oa4L2_l92@X2oa4L
2P0=o`TB2_lA70[o2@T:oa4L2_l94P[o4A`:oaXB5?lA70[o8a`:ob`h:OmZ
LUcoEfMBodI17P02oa4V500=oa4L2_l94P[o2A8:o`TB2_l92@[o2A8:o`T9
2_lA70[o2A8:o`000?mkSHCoEfMBoa4V5002ok2c]`0ZoiFZ[Oo1alcoYZZS
o`000?l94P[o8blYodINAom?LW_oSIR>om?Ie_nEZZgoY[?1ol77`Oo:d<7o
JXeLo`000?lJ9QCoLXeLo`000?l94P[o6Q`NofYkKom?IdOoLXeLodmWAolJ
71koYYQ_odINAol0003o2A8:oa4L2_m?Ieco;6MLodIE:Ol0003o2@TDoaXB
5?l94P[o2@TDo`TB2_l92@[o4A`:0ol94PX01_lJ4QCo4BHDo`T92_l94P[o
6PT:oa4V50;o6Q8D00?o4A`:oaX92_l971@00_lJ2@X03_lA70[o6RHDoaXB
5?l/71Co6RHDof11:OnVZZgom_Keong]j_o]m_GokNgZongfmOofooookOKe
0_o]kNX2omcSeP0:onC@c?o]kN[okNgZomcSh?o]kN[om_oeong]j_ofkN[o
kOKeooKoo`;okOKe00WoooooomcSh?m6;`[obZYVombn[OoLhmKoong<og^=
I_nESE801ol00002o`T92P03o`T95?lJ4QCo6PT:00;o2A8:00?o2@TDoa4L
2_l92@X00_l92@X00olA70[o2@T:o`T92P07o`T92P0;o`TB2_l92@[o4A`:
o`T92_l92ACo;180ocdB2_l/4P3o6PT:ob`B0?lm4PX00olJ2@X00ol/71Co
6PT:ocdL2P02ob`B0004ob<L2_lm4P[o8a`:ocdL2P;oEa`000KoARH:ob`B
0?l/4P3o8a`:oaX92_lS70X2ocdL2P03oaX92_lm4P[o?A8:00;o?A`:00Co
ARH:oeLL0?lm4P[ob]3FGooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00
0_o^k^h03?o/k>cog=cLogMgMooJf][oh>3Pon7QhOoDe=CoalO7olc<c?o?
clood=3@om?Cd`Ooe]KF01SolOomooGonoooo_ooooWooogcnooeooooZmK?
ocB1LOlNSWGo9JR8oc>mW?ln_j7oONWBoh_Od?n<bl?o/^_TojS/gOnRjmSo
Xn[Hoj[_gOn/kmkoZ^gLojg[g?n`k]l4ojg[g0;o[>cL00?oZ^gLoj[]fon/
k=/0;on/k=/4ojg[g0Co[>cL01WoZnkMoj[]g?nZkMcoZ^gLoj[_gOnYk]co
Y^_IojSVfOnTd<oo]NOVoj3Yh?n8jMSoFM6hobfbUOl//ICo:JB8oc6DP?lj
Q7OoYmC?on[ooookoooooocoooohoOoon?_oooko00CoinOW00?oj>SXonWY
jOoZj^X01OoZj^X7on_[j`?ok>c/0oo]kNd00oo_knook^k^oo3`l002oo3`
l0;olO7a2oobl_84oo?cl`Com?Cd2_oemOD3ooKfmP;omoOg0_oinOT01?oh
n?Son_[joo[jn_ojn_X2oo_kn`goo?cl0_omoOd00oono_koooooooooo`0k
ooooo`04oa]O]_nTa>Ko^=;^ogJ]jP;o[=oo00CoKVi^okBd]?oPh>3ok>c/
Foo^k^h03OlA70[o6Q8DoaX92_l94P[o6PT:oa4L2_lJ2@[o2@T:oaX92_lA
70[o6PT:o`T92_lA70X00_lJ2@X00ol94P[o2@T:oa4L2P02oa4L2P04oaX9
2_lA70[o6PT:oaX92P;o4A`:00_o6PT:o`T92_l92@[o4A`:o`T92_lA70[o
2A8:oaX92_lA70[o2@T:oa4L2P04o`T92P0=oa4L2_l92@[o2@T:o`T92_lA
70[o2@T:oa4L2_lJ2@[o4A`:oaXB5?l92@[o4A`:oaX92P04oa4L2P0:o`TB
2_lS;akoJW]_oh=kG?lmGSgo8blYoa4V2_lJ9QCo;1`DoaX92P?o2A8:0_l9
2@X0;?lJ4QCo0000oiFZ[OnEQ7_o0000o`TL5?nV/l7oYZZ]ok2n`OoCfMKo
0000oa4V2_lA70[o8blYob=1?OnEZZgo/;k1ojJZ[Oo:d=Ko/;k1om?SmOm6
EBWo0000ob`h:OmGSEco2@T:o`000?m6@AkoPg]LoeMNKomZNfoo=5DYoceN
?OnVV8CoLXdmo`000?lA70[o2@TDob<_:Ol/C2Wo4Blco`000?l94P[o2@TD
1?l92@X02_l94P[o2@T:o`T92_l92@[o2@TDoa4L2_l92ACo4A`:oaXL7_lJ
4Q@2oa4L2P0Bo`TB2_lJ4QCo4A`:oa4V5?lJ2@[o2A`DoaX92_lA70[o4BHD
oc@_:OmZIc?oYZ6HongfmOo]kN[okOKeomcSh?o]kN[okOKe1?o]kNX2omcS
eP09ong]j_ofooGokNgZomcSh?ofooookNgZooKomOo]m_Gom_oo00;okOKe
00Oom_ooomcSh?oC_Xkog;j]ol[@`OmbSCgo;2HD00;o000000?o;180o`T9
5?lJ4Q@00_lA70X02olJ4QCo2@T:o`TB2_lJ4QCo2@TDoa4L2_lJ4QCo2A8:
oaX92_l94P[o2@T:00;o4A`:0_l92@X01?lA70[o2A8:o`T92_l94PX2o`T9
2P05oa4L2_l92@[o2A8:o`T92_lA70X00_l92@X01olJ4QCo;180oaX92_l/
71Co?A`:oaX92_l/71@00_l/4P002olJ2@[o;180ob`L5?lm4P[o8a`:oaXB
5?l/4P3o8a`:ocdB2_mG703oARH:00;oH2l:0_lm70X03_lS70[o;180ocdB
2_lm4P[oARH:oa4L2_m69QCoARH:ob`L5?m69P[oARHDodHV2_lm70[odmWF
Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool01?omoOgok>c/
ogIfM_oIfMT2omoOg`06omCDe?o7alOob/[:olk>c_o@d=3odm?C1ooGemL0
6?o`ooookokiooonoooon_oonnkgooonoooOo?[oLZbPobZ7L_l8NV3o9Z:6
ocfeV_mXckcoXoOZojCRgOn_i^3o[nWMoj_Xf?n_jM[o/ncMokG[gOncjM_o
]>KJokKXg0Co]NOK0_ndj=/2ok?Yf`03okCXfondjMWo]>WI02go]>WI0_ne
im/6okCXf`;o/NOI01?o[nSIok7Zfonck=go/^_Lok3Yf_naiMWoaNc[ojcJ
f?nBfM7oS>gLog;ZdOlo`JGo6ianoaF5KOl/P77oKZNPon3mnoodo_oooO_o
00;ooogo00?ooocmooonoooVi^H00ooVi^H2onSXj0Koj^[Z2_o[jn/3onc/
k0;okNg]0oo^k^h:ono_k`?ol?3`0ooalO400oobl_;olO7aoo;blP02oo;b
lP;olo?c2?odm?@3ooGem@;om_Kf0oohn?P3oo[jnP;ono_k3Oolo?`2oogm
o@03ookno_oooooooooo03_ooooo00Co7EncojK6i_nfd>koNJo^0_n[g_l0
1?mfMWKo`L71oo3`l?omoOeKooooo`0Uo`T92_lJ2@[o2A8:oaX92_lA70[o
2@T:oaX92_lA70[o2@T:oa4L2_lJ2@[o4A`:oaX92_lA70[o2@T:oaX92_l/
4P3o6Q8Do`TB2_lJ2@[o4A`:o`T92_l/4P3o2A8:oaX92_lA70[o;180o`T9
2_lA70[o2@T:oa4L2_l0003o;180o`T92_lJ2@[o4A`:o`TB2P02oa4L2P0<
o`T92_lJ2@[o4A`:o`T92_lJ2@[o4A`:oaX92_lA70[o6PT:oa4L2_l92@[o
6PT:0olA70X03olJ2@[o4A`:o`T92_l92@[o4A`:ob<_7_n3SHCoNheVodIE
:OlS;ako6Q`NoaXV5?l971Co4BHDo`T92P03o`TB2P;o4A`:01Co0000oiFZ
[OmkSFKo0000o`TB2_m6IecoUJZ]ok2c]ooLhn3oJW9Lo`000?l971Co6RHD
oa4V7_n3V:gob]3Fok2n`Oo1al7o/;>gongfm@;o4BH:01;oH5hcodIWG?lA
70[o2A8:og9WD_mZNfooLXeLoh=kG?lA9P[oEfMBojJZXoldEBWo0000oa4L
2_l971Co4A`:oaXB5?l92A@2o`TB2P;o2@T:00Co2A8:o`T92_l92@[o2@T:
0ol94PX06?lJ4QCo2@TDo`TB2_l92ACoAT4NoaXV5?lA70[o6Q8DoaX92_lA
70[o6PT:o`TB2_lA70[o4BHDo`T95?l/71Co4A`:oc@_7_mPGS?o`K>]ong]
j_o]m_Gom_ooomcSePOokNgZ00Goi=3<ooKomOo]kN[og>?FongIc002ong]
jP?om_oo00Gom_oeongfmOofm_GokOKeodH_2P02ob`B000:oaX92_l/4P3o
2@T:ob<L2_lJ2@[o2A8:oa4L2_lJ2@[o2A8:oaXB50;o4A`:00?o2@T:oaX9
2_lA70X00_l92@X01?lJ2@[o4A`:oaXB5?l92A@2o`T92P03oa4L2_l92@[o
2@T:00Co2@T:00Ko4A`:o`T92_l94P[o2@T:o`TB2_l92@X2oa4L2P03oaX9
2_l/71Co6PT:00;o;18000ko?A8:oaXB5?l/4P3o6PT:ocdL2_l/4P3o?A`:
ob`B0?lm4P[o?A`:ocdB2_mb9P3oARHDocdB2P;oEa`000WoARH:ocdB2_lS
9P[o?A8:ocdL2_lS70[o?A`:ob`B0?lm70X00_m69PX01Ol/71CoARH:odHV
2_lm70[oY[?105oooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000;ok^k^
00cok>c/omgMgOmbLW;oemOGomoOgooPh>3od];BolO7aoo:b/[oc<c<om3@
d?oCdm<7omCDe00Hoo;oooo`o?SooooooooloooolocooogoooCoooo<mNoo
Eij@obB0JolMQ6oo>jF?oefkZon@h]KoSM39ojSSgOn]im_o[nOJok7Yg?nd
j]go]NWMokCVfonfiM_o]nKL1Onhimd2okKXg@?o]^SL02co^>SLokKXg?nh
j=co]^SLokSXg?nfj=co^>SLokKXg?nhj=co]^SLokSXg?nfj=co^>SLokKX
g?nhj=co]^SLokSXg?nfj=co^>SLokKXg?nhj=co]^SLokSXg?nfj=co^>SL
okKXg?nhj=co]^SLokSXg?nfj=co^>SLokKXg?nhj=co]^SLokSXg?nfj=co
^>SLokKXg?nhj=co]^SLokSXg?nfj=co^>SLokKXg0;o^>SL0onhimd5okKX
g@0JokCVfoncim_o/nOKokCZgOnfk=oo]N_Nok?Yg?nbiMcoZ=GBok3Th?nX
lNSoNmW9odZlYOl`Z8go6HUaoaMfH_mSYI_obO;^ooCoooooo_oom>kbookh
n_ooo_goooomoooooooWinL3onSXj0;ojNWY0ooZj^X3on_[j`Ook>c/1_o]
kNd00oo^k^kokno_oo3`l004oo3`l0_olO7a0oobl_82oo?cl`?om?Cd2_oe
mOD5ooKfmP;omoOg00?om_KfooOgmoogmoL00oogmoL;ooShn0;onOWi0ook
no/2oogmoA7oo_kn:_ooool01?lJG;?oY<?UokSBkomi[^`2ojcOo`04ofi^
K_nd];Coh>3Ponc/k5_ok^k^00co4A`:oa4V5?lJ2@[o2A8:oa4L2_lJ2@[o
2A`No`T92_l/4P3o2A8:o`T92_lA70X3o`T92P05oaX92_lA70[o0000ob`B
0?lA70X00_l92@X00olA70[o2@T:ob`B0003oaX92P05ob`B0?lS70[o4A`:
oaX92_l92@X00_lA70X02?l92@[o;180o`T92_l92@[o6PT:oa4L2_l92@[o
4A`:0_l92@X01?lA70[o2@T:oa4L2_l92@X3oa4L2P0IoaX92_lA70[o4BH:
oa4L2_l92@[o4A`:o`T92_lS;akoUIRSoh=kG?mZLUco8blcoba<:OlJ9QCo
6Q8Doa4L2_l94P[o2@T:o`TB2_l92@[o2A8:o`T95?l0003oUJZ]ohf=K`02
o`00000?oa4L2_lmGSgoUJZ]ol[@e_o1alcoJXeLo`000?lA9P[o0000oh>H
[Oo:d=KoUJZ]ojJc`Oo1al7og>?P00;o000000coJXeLodI<?OlS;ako6RHD
oiFHI_m6C3goPg]LofYbG?lA9P[oPhAkol6cS_lA9PX2o`TB2P04oaXB5?l9
2ACo2A8:o`T950So2A8:00?o2@T:o`T95?l94PX00_l92A@02_l92@[o=2lN
odIE:OlS;ako6PT:oa4V2_lA70[o;2HDoa4L2_lJ2@X2oaXB5006oa4L2_lA
9P[o6Q8Dob<_:OmZIc?ob]310oo]kNX00ooTd<cokOKeooKom@04ong]jP03
omcSe_o]kN[okNgZ00;og>?P00?okNgZooK]j_ofooD01?ofool2ongfm@09
ooooool/4P3oARHDob`V5?lm70[o;1`Doa4L2_lJ2@[o2@T:00;o6PT:00?o
2A8:oaXB5?lA70X00_l92@X01OlJ2@[o4A`:o`T95?lA70[o2@TD00;o2@T:
00?o8blNo`000?lJ4Q@00_l92@X00ol94P[o2@T:o`TB2P03o`T92P05o`TB
2_l92@[o2@T:o`T92_l94PX00_l92@X02_lJ2@[o2@T:ob`B0?l/4P3o;1`D
ob`B0?lm70[o;180ob`L5?lJ2@X2ob`B0006odHV2_lS70[o?A8:of0_2_mG
703oH2lD0_mG70001_mP;`[oARH:ocdL2_m69P[o6PT:ob<L2P;o?A`:00?o
Ea`0oa4L2_m69PX01Om69PX00omG703ob]3Fonk^kP1Nonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q0002onKViP04onCTi?oGemOoLG5aolo?c`;ogMgM
00KodM7AolC4a?o8b<Sobl_;olo?cooBd]87omCDe00EooWooookoooooooo
ooomooooo?oomoGjoo;joOo^ooooeoomodV7O?l^Mfco>heoofZn/Om``[Ko
Yo;[oi;Hd?nKgM7oX^3CojGSe_nWhmOoZ>;F00;oZN7F00CoZn3FojcQeon/
hMOo[>7G0_nZh]L3ojWSe`0^oj[ReonZh]Go[>;Eoj[ReOn/h]GoZ^;EojcR
eOnZh]Go[>;Eoj[ReOn/h]GoZ^;EojcReOnZh]Go[>;Eoj[ReOn/h]GoZ^;E
ojcReOnZh]Go[>;Eoj[ReOn/h]GoZ^;EojcReOnZh]Go[>;Eoj[ReOn/h]Go
Z^;EojcReOnZh]Go[>;Eoj[ReOn/h]GoZ^;EojcReOnZh]Go[>;Eoj[ReOn/
h]GoZ^;EojcReOnZh]Go[>;Eoj[Re@;o[>;E0on/hML4oj[Re`0DojWSeonX
h]KoZ>;FojSRe_nWhmOoZ>CHojOSeonTh=CoXMoDoigJd_nCe/goSmoBogWD
`om=/9co9hQeobIjJom7Rh3odogioo3oooocm_/2ooomo`04ooolnoolo_Wo
noojookoo@Coi^KV00?oj>SXonOWiooYjNT01OoYjNT:on[ZjP?ojn_[00?o
k>c/ong]kOo^k^h00_o^k^h:ono_k`?ol?3`0ooalO42oo;blP?olo?c0_od
m?@8ooGem@Gom_Kf0_ohn?P00oogmoOonOWiooWin@03ooWin@_on_[j0_ok
no/3ooclo0;ooOgm4Oono_hZooooo`04oaeO/onUa>Ko]];^ogV^j@;oZ^3o
00CoJVYZojj^[_oHf=Soi>CTFooVi^H05olA70[o6PT:oa4V5?lJ4QCo6PT:
oa4L2_lJ2@[o4A`:oaX92_l92@[o4A`:oaX92_lA70[o6PT:oa4L2_lJ2@[o
4A`:o`T92_lJ2@[o2@T:ob`B0?l94P[o;18000;o6PT:00?o4BH:oaX92_lA
70X00_l92@X05OlA70[o6PT:oa4L2_l/4P3o2@T:ob`B0?l92@[o4A`:oaX9
2_lA70[o8a`:oa4L2_lJ2@[o2@T:oa4L2_lJ2@[o4A`:o`T92_lA70[o4BH:
oaX92P02oa4L2P0Vob<L2_lJ2@[o4A`:oa4L2_l94P[o;180ob<_7_mkSFKo
SIR>og9bNom6EBWo8blYo`TB2_lA9QCo2A`DoaXB5?l94P[o2@T:oa4L2_lJ
2@[o6Q8Do`000?mbSHCoYZZSo`TB2_l971Co4BHDo`000?mbSHCo/;k1ol77
c?o1al7o0000oa4V2_l0003o?G:4ok2c]onVZZ<2ol77c00Bol77`Ol0003o
2@T:ohf=KolA9QCo4BH:of1N<onEQ7_o?Ehmohf=KomZIc?o8blNofYbG?mP
GS?o0000o`T92_l94P[o4A`:0_l94PX01OlA70[o2A8:o`TB2_l94P[o2@T:
00?o2A8:013o2@T:oa4L2_l92ACo4A`:oaXB5?l0003o=2lNoh=kG?n=SDOo
AT4No`TL5?lS70[o6RHDob<_7_lJ9QCo4BHD0_lA70X03OlJ4QCo;2HDoa4L
2_lJ71koPg]Lol[@`OoLhn3okOKeomcSe_oLhn3okNgZooKomOoLhn001_o]
kNX01OofkN[og>?PomcSe_ofooGokOKe00Com_oo00CokOKeooKooooooooo
ARl:0_m69Q@01?lS9P[oARHDob<L2_lS70X4oa4L2P03oaX92_l92@[o4A`:
00;o2@T:00So4A`:o`T92_l92@[o4A`:o`T92_lA70[o;1`Doa4L2P;o2@T:
00Co4A`:o`T92_l94P[o2@T:0_l94PX02olJ4QCo2@T:o`TB2_lA70[o2@T:
oa4L2_l94P[o6PT:oaXB5?l/4P3o8a`:00Go;18000?o8a`:oaXB5?lS70X0
0_lm70X2ocdB2P0BodHV2_mG703oLRH0ocdB2_mG703oH2l:oeLL0?lm4P[o
ARH:oaXB5?l/4P3oARHDodHV2_lm4P[o4A`:odHV2_lm70[oARHD0om69PX0
0olm4P[ob]3FonKViP1NonKViP04oifMWOng]kOob<S8om?Cd`7of][J0002
onk^kP0:ong]kOoPh>3oNWYjokno_ooHf=Sof][Jolc<c?o1`L7oaLG5ol[:
bP;oc/k>1ooDe=@06?oknOcoookoooknooogmoWoookoookoooocm__omooo
oo3ooooRooooD85mocIcK?leOWGoH;2UoeBWWOn9gM3oP<k1oh[Daon@f/go
TMW=oi7Gc?nEfLkoU][?oiOIc`?oU=K<0_nCel`3oi7Gc0;oTmO:037oU=K:
oi?Gb_nDe/[oTmO:oiCFb_nCel[oU=K:oi?Gb_nDe/[oTmO:oiCFb_nCel[o
U=K:oi?Gb_nDe/[oTmO:oiCFb_nCel[oU=K:oi?Gb_nDe/[oTmO:oiCFb_nC
el[oU=K:oi?Gb_nDe/[oTmO:oiCFb_nCel[oU=K:oi?Gb_nDe/[oTmO:oiCF
b_nCel[oU=K:oi?Gb_nDe/[oTmO:oiCFb_nCel[oU=K:oi?Gb_nDe/[oTmO:
oiCFc?nCelcoU=K<00CoTmO<00CoTMO<oi?Ic_nBf<goT]S=0_nAfLd05?n@
f<coSMG9ohOCa_mnc/7oK/:cof6hZ?m@YiOo8gMXoaIPDomVXY[odO_goo3o
ooofnooooogooo_bmooooOoooookoo?jl_oioo_oo_om1?oUiND2onOWi`Ko
jNWY2_oZj^X4on_[j`Cok>c/2_o]kNd6onk^kP03oo3`l?o_knoolO7a00Co
lO7a2?obl_83oo?cl`;om?Cd0_oemOD01?ofm_KomoOgooOgmoogmoL2ooSh
n0_onOWi0_ojn_X3oo_kn`;oo?cl4?omoOd3ooknoRSooooo00Co6ejcojK6
i_nidnkoNJk[0_n[gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP08oaXB5?lA
70[o6PT:o`T92_lA70[o6Q8Doa4L2_l92@X2oaX92P0>o`T92_lA70[o2@T:
oa4L2_l92@[o4A`:oaX92_lA70[o2@T:oa4L2_lJ2@[o2@T:oaX92_lA70X2
oaX92P08o`T92_l/4P3o4A`:ob`B0?l92@[o4A`:oaX92_lA70X2o`T92P;o
6PT:00So2A8:oaX92_l92@[o2@T:oa4L2_l92@[o4A`:o`T92P?o4A`:00?o
6PT:oa4L2_lA70X00olA70X03_lS;ako6Q8Do`T92_l94P[o4BHDofYkKon3
SHCoPhB>odIE:Ol/C2Wo8blNoaXV5?lA9QCo2@T:0ol94PX2oa4L2P0Ro`TB
2_mkSFKoYZZ]ob`h:Ol0003o4BH:o`TB2_lmGSgoPiR>ok2n`Oo:d=Ko0000
o`TL5?lA70[o2A`NoiFZ[OnVZZgob]3FohfHS_lA9P[o2@TDoa4V7_nEV6Ko
2A`Do`TB2_m6@AkoPhB>oeMWD_ldEBWo0000o`T92_l0003o2@TDo`T92P;o
2A8:00Co4A`:o`TB2_l94P[o2A8:0ol92@X2o`TB2P05o`T95?l94P[o2@T:
o`TB2_l92A@00_l92@X05old;bWoUG97ohf=KomkSFKoPg/co`TB2_lJ9QCo
;4`Yob`V5?lJ9QCo6Q8Doa4L2_lA9QCo6PT:oa4V5?l92ACoJUDNojJQV?o:
d<7og>?Pong]j_oLhmKokNgZ00;okOKe00Sog>?Fong]j_o]kN[okNgZomcS
e_oTd<cokNgZongfm@?okNgZ00?om_KeooKoooofooD00_o]kNX2ooKoo`04
oooooon3NecoEa`0of0_50;o?A`:01[o8a`:oaX92_l/4P3o4A`:oaX92_l9
2@[o4A`:oaXB5?l92@[o4A`:o`T92_lA70[o2@T:oa4L2_l92@[o4A`:o`T9
5?lJ71ko6Q8Doa4L2_l94P[o2@T:oa4L2_l94P[o2@T:o`TB2P;o2@T:00?o
2A8:o`T92_l94PX00ol92@X02Ol94P[o;180oaXB5?l/4P3o8a`:ob`B0?lS
70[o;180ocdB2P03ob`B00?o?A8:00?oARH:odHV5?mP;a@00_mP;`X04om6
9QCoLRH0of0_2_lS9P[o8a`:oaXB5?l/4P3oARH:odHV5?m69P[o6PT:odHV
2_lm70[oARHDodHV2_mP;`[oARH:oeLL0?oLhn00Goo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@000_ooool03?ono_kom_KfoiZJV_nTY:Cod];BomCD
e?o2`/;o^;Rhol30`?o4a<CobLW9ol_;b`Ood=3@01SoooGlooolooono_oo
n?knooSooooiooooo?ooookoooogn_oomoooon[ooomVT8ooCXb7ob=cJ?la
SH3o?In@oe6_WomK]jSoH[j_of>n[omU_JooJ/2cofc2]Om^`[D3of^o/P;o
JKnb0_mX`;80=?mY_k;oJL2`ofW0/?m[_k3oJL2`of^o/?mY`;3oJkn`ofW0
/?m[_k3oJL2`of^o/?mY`;3oJkn`ofW0/?m[_k3oJL2`of^o/?mY`;3oJkn`
ofW0/?m[_k3oJL2`of^o/?mY`;3oJkn`ofW0/?m[_k3oJL2`of^o/?mY`;3o
Jkn`ofW0/?m[_k3oJL2`of^o/?mY`;3oJkn`ofW0/?m[_k3oJL2`of^o/?mY
`;3oJkn`ofW0/?m[_k3oJL2`of^o/?mY`;3oJknbofVo/_m[_k84ofVo/P04
ofS0/_mZ`[CoJL6cofS0/P;oIl:c017oI/6bof>n[omN_:coD;JQod^aVolU
PVoo6FaLocIjKomk/:[oeoWjoo;oooodmokon_?koookooohko;on_Wgooco
n`02ooSonP03oocooOoQhN7oh^;R00;oh^;R00?oi>CTon?ShooUiND00_oU
iND:onKViPOoinOW1_oXj>P;onWYj@?oj^[Z00?ok>c/on_[joo]kNd00_o]
kNd:onk^kPOokno_1_o`l?08oo7al@?ol_;b0_oclo<3ooGem@;omoOg0ooh
n?P:ooWin@?on_[j0oolo?`2ooknoRKooooo00Co7f6doj?2i?nhdnooMjk[
0_nZgol01?mfMWKo`L71oo3`l?omoOeKooooo`09oaXB5?lJ2@[o4A`:oa4L
2_lJ2@[o4A`:o`T92_lA70[o6PT:00;o4A`:00Go6PT:ob`B0?lS70[o2@T:
oaX92P02o`T92P04ob`B0?lA70[o2@T:o`T92P;o6PT:00Go;180ob<L2_lA
70[o6PT:o`T92P02oaX92P0?oa4L2_l92@[o6PT:o`T92_l/4P3o4A`:o`T9
2_lJ2@[o;180o`T92_l/4P3o2@T:oa4L2_l92@[o4A`:00;o2@T:01Oo6PT:
oa4L2_lA70[o6RHDoa4L2_l/9QCo6RHDob`V5?l94P[o4A`:o`T92_l94P[o
SHe_og^=Q?n3SHCoJW9LoeMED_lS;bWo8blNo`TB2_lA70[o2@T:oa4L2P02
o`T92P;o4A`:01ooCeiVoiFZ[OnEXHko2A`Do`000?lA9Qko4BH:o`000?nE
ZZgo`K>]o`000?l94P[o2@TDo`000?n3V:go`LO1odINAol0003o2@T:oa4V
5?lS;akoSHe_o`000?l94P[o;2HDodmWAonEQ7_o0000o`TB2_l/71Co2@T:
00?o2A8:00?o6Q8DoaXV5?lA9Q@01ol94PX06?l92@[o2@TDoa4L2_l92@[o
4BHDoaXV5?n=SDOoSHeBog^=I_mZLUcoUHAkoh=kG?ldEBWoAT4Noc@_:OlS
;ako;2HDoaXV5?lA70[o6Q8Doa4V5?lA70[o2@T:ohf=DP;o`K>]0_o]kNX0
0ooLhn3okNgZong]jP04ong]jP03omcSh?o]kN[oi=3<00;okNgZ013og>?F
ong]j_ofooGom_ooooKomOo]kN[om^gZong]j_o]m_Gom_oooooooonEQ7_o
ARl:of0_2_m69P[o?A`:0_lS70X3oaX92P05oa4L2_lJ2@[o6Q8DoaX92_lA
70X00_l92@X01OlA70[o2@T:oa4L2_l92@[o4A`:00;o6Q8D00Go4BHDoaXB
5?lA70[o6Q8Do`T92P02o`TB2P;o4A`:00Oo2@T:oa4L2_l92@[o2@T:oa4L
2_l94P[o4A`:00;o6PT:00?o8a`:ocdL2_lm70X00_lm4PX02?lm70[o?A8:
ob<L2_l/71Co?A8:odHV2_lS70[o?A8:0_mG70002Om69P[oH2lDoeLL0?mb
9P3oH2lDocdL2_lS70[o;180ob`L5002ocdL2P06odHV2_lA70[oARH:of0_
2_m69QCo?A`:0_m69Q@00omG703odmWFooooo`1Nooooo`04ojn_[oo;bl_o
g]kNon[ZjP7ol_;b0003onk^kP05onWYjOo5aLGoPh>3ojb/[?nl_;`00_n^
[Zh01?nf][Ko_;blokno_oo4a<@7olW9b@0HooohoooomOcoooooooWoooob
oooolOgmoocooooooOooo_Sooo_joooeoooojOooomGooon^o_?o?9b>ob:=
Nol>MFCo67m^ob66M_lRQgOo9HEgobZ:O?l_SGoo;Xan0_l`S7l2obn=O`Co
;Heo<?l_SGd6obn=O`Co;Heo01Oo:henobb>Ool]Sh3o;8ioobN<O?lRS7So
2GUQoaZ8Kom1XXko[?g^omGooooFo_gokooooo_ooooonooooo[ooo[]m_oo
o?ooooomooKmmOogoo[om_oioocoo@04omgMg@;ogmoO1_oQhN4:on;RhP?o
hn?S0_oTi>@3onGUi@[oi^KV1_oWinL2onSXj0GojNWY2ooZj^X2on_[j`;o
k>c/00CokNg]onk^k_o^k^kok^k^2_o_knl5oo3`l0?olO7a1Oobl_88oo?c
l`;om?Cd0ooemOD3ooKfmP;omoOg0oohn?P:ooWin@?on_[j0oolo?`2ookn
oQ7ooooo00Co7f2dojG4i_nidnooMjk[0_nYg?l01?m^KVko];Bdon3Ph?o/
k>aKonk^kP05oa4V5?lA70[o2A8:oaX92_l94PX00_lA70X00olJ2@[o4A`:
o`T92P02oaX92P03o`T92_lJ2@[o2@T:00?o4A`:0_lJ2@X2oa4L2P03o`T9
2_lJ2@[o6PT:00;o6PT:00Wo;180oa4L2_lA70[o4A`:ob`B0?lA70[o6PT:
oa4L2_l000000_lJ2@X01olA70[o6PT:o`T92_lJ2@[o4A`:o`TB2_l92@X0
1OlA70X00olA9QCo;1`DoaXV5003ob<_7P0NoaXB5?lA70[o4BHDo`000?m?
GVKoNheVog9bNon3SHCoPg]LocAE:OlS;ako4BH:o`T95?lJ4QCo2@T:oaXB
5?lA70[o2@TDoaX92_m6GTOoNhf4oiFQS_n`ZXCo2A8:o`000?l971Co0000
og^=Q?nEXHko00000_l94PX05olA70[o;5ELoa4V7_l0003o2@T:o`T95?l0
003oLVMBoh>4NomGEE;o4A`:oc@_7_m69P[o`LO1og8V0?l92@[o`LO1oeLL
0?l92ACo6Q8Do`TB2_l92@[o2@TD00Co2A8:00?o2@TDo`TB2_l94PX00_l9
4PX04OlA70[o2A8:o`TB2_l/71Co8blYodIE:OmPGS?oPhAkog:=G?n=SE;o
H5hcodmWAonELTOoLXdmoc@_7_mPGS?o=2lY00;o6RHD00Oo4BHDoaXB5?lA
9QCoJVLcojJZXoo1al7og>?F00;og>?P1Oo]kNX00ooLhmKokNgZonC@c002
ong]jP0BomcSh?o]kN[okNgZooKomOoooooog>?PooKomOoLhmKokNgZooKo
mOofooooooooog9WD_mb9P3oLSPDoeLL0?m69P[o?A`:0_lS70X2oaXB500>
oa4L2_lJ2@[o2@TDo`T95?lA70[o2@T:ob<L2_l92@[o4A`:o`T95?l92@[o
4A`:o`T95?lA70X2o`T92P03oaXB5?l/9QCo2@TD00Oo2@T:00?o4A`:o`T9
2_l92@X00_lJ2@X01Ol/4P3o8a`:ob`B0?l/71Co;18000;o?A`:0_lm4PX0
1?l/4P3o?A8:odHV2_lm4PX2odHV2P0>oeLL0?m69QCoEa`0oeLL0?mP;aCo
Ea`0odHV2_lm70[o4A`:odHV2_mG703o4A`:odHV2_lA70X3odHV2P05oeLL
0?mP;aCoH2lDoeLL0?o:d=H0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Q
h@000ooVi^H02ooTi>Cog=cLojJVY_mcLg?oP820ohn?SonLW9coYJFUojb/
[?na/K7o]kNg00ko^k^k0onl_;`3okfm_@03okjn__nm_Kgo_[jn00;o_[jn
0_no_kl;ol30`0;o`L710_o2`/801?o3`l?oa<C4olC4a?o4a<@:olG5a@Go
a/K60_o7alL00oo6a/KoalO7olO7a`03olO7a`gob<S800?obLW9ol[:b_o:
b/X03oo;bl/3olc<c003olg=cOo<c<coc<c<00;ocLg=2oo>c/h2olo?c`?o
d=3@00?odM7Aom;Bd_oCdm<00_oCdm<3omCDe0OoeMGE1_oFe]H2omOGe`Go
f=SH2ooIfMT3om[JfP;ofm_K0ooLg=`:omgMg@Gog]kN0_oOgml00ooNg]ko
gmoOomoOg`03omoOg`Soh>3P0ooQhN42on;RhP;oi>CT00?oiNGUonOWiooW
inL00ooXj>P:onWYj@?oj^[Z0oo/k>`2onk^kP_okno_0_o`l?03oo7al@03
oo;bl_oalO7olO7a00;ol_;b0ooclo<>ooCdm004oaYN]OnTa>Ko^M?_ogJ]
jP;oZn3o00CoJVYZojj^[_oHf=Soi>CTFooVi^H01?lJ2@[o2@TDoaX92_lA
70X2oaX92P;o2@T:0_lA70X01_l92@[o6PT:oaXL7_lA70[o2@T:ob`B00;o
6PT:00[o2@T:oa4L2_lJ2@[o2@T:oa4L2_lJ2@[o4A`:oaX92_l0003o4A`:
1?lJ2@X01_lJ4QCo0000ob<L2_l92@[o6PT:o`T92P;o6PT:00Co;180oaX9
2_lJ2@[o2@T:0olA70X01olJ2@[o8a`:ob<L2_lA9P[o8blNob<L2_lJ9Q@0
0olS;ah03?lJ4QCo4BHDo`T92_ld;bWoCfMLohfHS_n3V8koPhB>oeN=G?ld
;bWo8blNo`T950;o4A`:00Go2@TDo`TB2_l92@[o4BHDob<_:@02ofYkK`07
oiFHXomkSFKo4BHDo`T95?ldECgo4BHNodmWG003o`T92P0QocAE:Ol971ko
4Blcoa4L2_lJ4QCo2@TDo`000?m6EBWoCfMLol77c?l0003o8bH:ob`B0?o1
alco`J64ocdB2_nEV:?oong<o`000?lA9P[o4A`:o`TB2_lA70[o2@T:o`T9
5?lJ4QCo2@T:oaXB5?l92@[o2@TDo`TB2_lJ4QCo2@TD00;o4A`:01co;180
ob<_:OlA70[oH5hcog^=I_n3Nc?oEeEBof1N<on=SE;oSIR>ojJHQ?n=SDOo
JVLcodIE:Old;bWo4BHNo`TL5?lJ71ko2@TDodI17_nVXISo`K>]omcSh?o]
m_Gog>?Fong]j_oLhn3og>?F1?o]kNX00ooLhn3oi=3<ong]jP03ong]jP03
ooKoooofooGokNgZ00?okNgZ0oofool2oh<h000@oh<_0?mb>1CoEa`0ocdL
2_m69P[o8a`:oaX92_lS70[o2@T:oaX92_lA70[o6Q8Do`T92_lA70[o2@TD
oaXB50Ko2@T:00?o4A`:o`T92_l92@X00_l92@X00ol94P[o2@T:o`T92P05
o`T92P09o`TB2_lA70[o2@T:oa4L2_lJ2@[o?A8:ob<L2_l/4P3o8a`:00?o
?A8:00Ko?A`:ob`B0?m69P[o?A`:ocdB2_m69PX4oeLL0007odHV2_n3;`3o
H2l:ocdL2_l/71Co;180ob`L5002ocdL2P03odHV5?lJ4QCoARHD00?oARH:
00CoARHDof0_5?mb9P3ob]3FGooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[J
fP001?o^k^h02_o[jn_oh>3PokRh^?n1PH7oL71`ogQhN?n;Rh_oTY:BoiVI
VOnQXJ4>ojJVYPKoYjNW00?oZ:RXojVYZOnZZZX01?nZZZX8oj^[Z`?o[:b/
0_n][Jd2ojj^[P04ojf][On^[Zko[Zj^ojj^[P;o[jn_3On`/;02ok6a/@03
ok:b/_nc/k?o/k>c00_o/k>c0_nd];@3okFe]@03okJf]_ne]KGo]KFe00;o
][Jf0ong]kL:okRh^0?o^KVi00?o^[Zjok^k^onk^k/00_nl_;`;okfm_@Go
_[jn00?o`<30okno_oo1`L401Oo1`L4:ol;2`PCo`l?31?o4a<@:olG5a@Ko
a/K600?oalO7olK6a_o7alL01?o7alL8olS8b0?obLW90_o:b/X3olc<c0?o
c/k>0_o?cll;om3@d0;odM7A0ooBd]82om?Cd`_oe=CD1OoEeMD3omOGe`Go
fMWI2?oJf]X2om_Kf`?og=cL0ooMgMd2omkNgP?ogmoO3_oPh>001?lHFjoo
YLCVokG@k_mi[^`2ojOLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00?o6Q8D
oa4L2_lA70X00_lJ2@X01olA70[o6PT:oa4L2_l92@[o6PT:oa4L2_lJ2@X0
0_lA70X01OlJ2@[o2@T:oaX92_lA70[o6PT:00;o4A`:00Oo;180oaX92_lJ
2@[o;180oaX92_lA70[o;18000;o6PT:00_o4A`:o`TB2_l/4P3o2@T:oa4L
2_lJ2@[o4A`:ob`B0?lJ2@[o2@T:ob`B0002oaX92P?o2@T:0olA70X01_lA
9P[o8blNob<_7_lS;ako6RHDoa4V2P;o8blN01_o6RHDoa4V2_l/71Co8blN
odIWG?n3Q8koSIR>oh>=Q?mZNfooCfM7ocAE:OlA9P[o2A8:o`T92_lA70[o
2@TDoa4V5?lS;akoAT`modIED_m?IecoNheVodmWG?l/>2Wo=5Dmoa4V5?l0
00000_lS;ah01?l92@[o4BHDoaXV5?l92@X2o`TV:@0@o`TB2_lA70[o6Q`N
odI<?OmGEE;ob]3FojIbD_l0003o?A`:ok1kI_oTd<co/7/YodHV5?o]fLco
Nd`Do`0000;o2A8:00_o2@T:oa4L2_l99RWo2A`Do`T92_lA70[o2@TDo`T9
2_lJ4QCo2A`Do`T95002o`TB2P06oaXB5?lA70[o2@TDodIE:Old;bWoJVLc
0_n3Ne`2ojJHQ00<ok2ZQ?n=SFooLXdmof1N<omZEAkoH5hcodI17_lA9P[o
4A`:oaXB5?n3Q7_ob]310_o]kNX3omcSh0Cog>?F00Cog>?PomcSe_o]kN[o
g>?F0_o]kNX00oo]m_Gom_ooong]jP04ong]jP08ooKooooooooo`LO<oh=1
0?n3;`3oUED0oh<_0?mP;`X2odHV2P0;ob`B0?lS70[o6PT:oa4V5?lA70[o
6PT:oaXB5?lA70[o2@T:oa4L2_l92@X00_lA70X2o`T92P05oa4L2_l92@[o
4A`:o`000?lA70X00_l92@X3o`TB2P04o`T92_l94P[o2@T:o`TB2P;o2@T:
00Go2A8:o`T92_lS70[o6Q8Dob`B0002ocdL2P07ob`B0?lm4P[oARH:odHV
2_lS9P[o?A8:ob<L2P02ocdL2P;oARH:00[o?A8:of0_5?mG703oARH:of0_
2_n3;`3oARH:ocdL2_lS70[oARH:0_lm70X01?mG703o8a`:ocdL2_mG7002
odHV2P;oH2lD00?oEa`0om?Ie_o^k^h0G_o^k^h01?nSXj?o_Kfmolo?cooJ
f]X1on7Qh@001?ooool02?omoOgonOWionWYjOoAdM7o/K6aoiRHV?n7QhOo
OgmooomjNWX=ogYjNP09og=cLom`L73oJVYZof5QHOmCDe?o2E2WojC4i_nh
d^koMZgZ00;o[=oo00CoMWIfol71`Oo`l?3ooOgmFoooool02?lA70[o6Q8D
oaX92_l94P[o4A`:oaX92_lA70[o6PT:0_lA70X00olJ2@[o4A`:o`T92P02
oaX92P03oa4L2_lJ2@[o8a`:00?o6PT:01;o2@T:oa4L2_lJ2@[o8a`:oaX9
2_l/4P3o6PT:ob`B0?lA70[o6PT:ob`B0?lJ2@[o;180o`T92_l/4P3o2@T:
oaX92_l92@X3ob<L2P06oaXB5?l92@[o2@T:oa4L2_l94P[o4A`:0_lS;ah0
6_lS;bWo;3PYob`h:OlA9QCo4A`:oaXV5?lA9QCo8blNob`h:OldEBWo6RHD
ob`h:OmZNfooSIR>og^=Q?mbLW_oNhf4odIED_lJ9QCo0000oa4V5?l92@[o
4A`:oaXV5?lJ4QCoAVML0_m6GTL01_m6Ieco4BHNob<_:OlA9QCo0000o`T9
2P;o4BHD00?o6Q8Doa4V5?lA70X00_l92@X0>OlS@E;o6Q`Noa4L2_n`ZXCo
;180of11:OoLhn3oi<O1o`000?m6;`[oYW9Bombn]ooL_ZgoEa`0ol6QQ?oL
hmKo?A`:oa4V2_l92ACo4A`:o`000?l/GSgo0000oa4L2_l92@[o2A8:oa4L
2_lA9QCo=2lNoc@_:Ol94P[o2@T:o`T95?l971Co4BHDoaXV5?lJ4QCo=5DY
oiFQS_mbSCgoLVMBofYW<ombIe;oCfM7oh=kG?nNQ6KoYZZSojJHKon=SE;o
4BH:o`T95?lA9QkoH44YomcSh?oTd<cokNgZomcSh007omcSeP03onC@c?oL
hmKokNgZ00;okNgZ00com_ooongfmOo]m_Gom_oeooKoooo]m_Gom_oooooo
ooo]m_GoUG97ojI<0?nEE@02oh<h0007og8V0?mP;`[o?A8:ob`L5?l/4P3o
8a`:oaX92P02oa4L2P07o`T92_lJ2@[o4A`:oaX92_lA70[o2@T:o`T95002
oa4L2P04o`T92_l94P[o2@T:oa4L2PKo2@T:00_o4A`:o`T92_lA70[o2@T:
oc@_:Ol92ACo2A8:oa4L2_l92@[o8a`:ob`B0002ocdB2P05ocdL2_lm4P[o
?A8:oeLL0?m69PX00_lm4PX02_m6;`[o?A`:ocdL2_l/71CoH2l:oeLL0?mP
;`[oEa`0oh<_0?mP;`X2odHV2P0>ocdB2_lm70[oARH:ocdL2_m69P[o8a`:
odHV5?mP;`[oARHDodHV2_mb>1CoJT4:of0_2_o:d<5Oooooo`04ojn_[oo;
bl_og]kNon[ZjP7ol_;b0004onk^kP0:on_[jooPh>3o^;Rhoh61POm]KFgo
M7Adoh:2P_n7QhOoSHf=oiFEU@koVYZJ1_nKVi/2oibLW0GoWIfM2onNWYh2
oinOW`;oX:2P00CoWinOoj2PX?nPX:3oX:2P3OnQXJ42oj:RXP;oXj>S00?o
Y:BTojFUYOnUYJD00onVYZH8ojNWY`GoZ:RX00?oZJVYojRXZ?nXZ:P01OnY
ZJT:ojZZZP?oZj^[00?o[:b/ojf][On][Jd00_n][Jd;ojj^[PGo[jn_0_n`
/;06ok6a/@[o/[:b0onc/k<00one]KGo];BdokJf]P02okJf]P[o]kNg3Onh
^;P8okVi^@Go^[Zj0onl_;`3okjn_P;o_kno2oo0`<02ol71`@?o`/;20_o3
`l<;olC4a0GoaLG500?oa/K6olO7aoo7alL01Oo9bLT8ol[:bP;obl_;0oo<
c<`00oo=cLgoc<c<olc<c002olg=c@?oc/k>3_o?cll01?lJG:ooY/KVokK@
k_mi[nh2oj_No`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00?o6PT:oa4L2_lA
70X00_lJ4Q@00olJ2@[o2A8:oa4L2P02oaX92P0;o`TB2_lJ2@[o;180oa4L
2_l92@[o6PT:oa4L2_lJ2@[o2@T:oa4L2_lJ2@X00_lA70X02_l/4P3o6PT:
oaX92_lJ2@[o8a`:ob`B0?lJ2@[o4A`:oaX92_lA70X3oaX92P03oa4L2_lJ
2@[o4A`:00?o6PT:00?o;180o`TB2_l92@X00ol92@X01_lS9P[o8blNocAE
:Old;ako=5DYob`h:@;o8blN00?o8blYodIED_ld;c<00_lS;bT05OlJ71ko
;3PYoh>4S_mZNfooSIR>oh>=Q?mPLW_oAUDYo`T95?l94P[o2A`DoaX92_lJ
71ko8blYocAE?OmZNfooAVMLoa4V5?lS;ako2A8:o`T92P02oa4L2P10oa4V
5?lJ71ko4BHDoa4V5?lA70[o2A8:oa4L2_l92ACo8d5BoaX92_nVQ5;o;180
oh<_G?o1al7oong<o`T92_lA9P[oWW8col6cS_oTal7oEa`0ok24I_ofkN[o
i:ZHo`000?lA9P[o0000oa4V5?l94P[o2@TDo`T92_lA70[o2@T:oaXB5?l9
2@[o=2lcog:=?OlS;ako8bH:o`T95?lJ4QCo6PT:o`TB2_l92ACo8blNof1N
<ombEE;oCfM7ohf=KomkSFKoUHAkojJQV?nEXHkoYZ6HoiFHI_mPGS?o6Q8D
oh=k<omPGS?o2@T:ol[@`OoLhn3om_ooomcSh0?og>?F00?og>?PomcSe_oL
hmH00_oTd<`01ooLhmKog>?PooK]j_o]m_Gom_ooong]j_ofkNX00_ofool0
1Oo]m_Gog>?PooKooonVZZgoUED000?oYT`000SoPd40oh<h0?mP;`[oEa`0
odHV2_lm70[o6Q8Dob<L2P;o6PT:00[o4A`:o`TB2_l92@[o2@T:oa4L2_l9
2@[o4A`:o`000?lJ2@[o4A`:0ol92@X01_lA70[o2@T:oa4L2_lA70[o2@T:
oa4L2P;o2@T:01;o2A8:o`T92_lJ71ko6Q8Do`T95?lJ4QCo;180ob<L2_lJ
2@[o?A`:odHV5?lJ2@[o;180odHV2_mP;aCo?A8:ocdL2_lm4PX2ocdL2P0=
oaXB5?lm4P[oEa`0of0_5?mG703oH2l:og8h5?l/71CoLRH0odHV5?lS70[o
?A`:ob`L5002odHV2P05ob<V2_m69P[oH2l:odHV2_mG70000_mP;a@00omG
703odmWFonk^kP1Nonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0003onKV
iP0;onCTi?oLg=coYZJVog5aLOmnOWkoS8b<oiZJV_nSXj?oZZZZok:b/_nf
][H03?nh^;P2oogmo@GooOgk00[ooOgmooclo?oloOgoo?cmooCcn?odloWo
k>_comoNi_oKfn?oeMSO0_oDfMd3om?Hg0;od]OK2OoCf=`_om?Hf`oodmSL
00WodmSNom3GhOoBfnCog>?[onS]loo`loSom?Skoo_loOomoOd00_omoO/2
ooglo@GooOgm00CodM7Aom;Bd_oBd];od];B2_oCdm<6omCDe0;oeMGE1OoF
e]H>omOGe`;of=SH3OoIfMT3om[JfP;ofm_K0ooLg=`3omgMg@;og]kN2ooO
gml2on3Ph0?oh^;R0_oTi>@;onGUi@;oinOW0ooXj>P00ooZj^[ojNWYonWY
j@02on_[j`?ok>c/2?o^k^h2ono_k`?ol?3`0oobl_82ooCdm0?omOGe3_of
m_H01?lIFk;oY<?UokSBkomi[^`2ojcOo`04ofYZJ_n^[Zkof=SHonCTi5_o
i^KV00Oo4A`:oaX92_l94P[o6Q8Dob<L2_l92@[o;18000;o2@T:0_lA70X0
1_lJ2@[o2@T:oa4L2_lJ2@[o4A`:oaX92P;o4A`:01Go6PT:ob`B0?lJ2@[o
2A8:oaX92_l92@[o;180oaX92_l/4P3o8a`:ocdL2_lS70[o;180ob<L2_lA
70[o6PT:oa4L2_lJ2@[o;180o`T95?l/4P000_lS70X01?lA70[o2@T:o`T9
2_lA70X2o`T92P0Po`T95?lJ9QCo;2HDodI<?OmGEE;o?EhmocAE:OlJ71ko
;3PYocAE?Ol/C2WoAT`moba<:OlS9P[o2@T:odmWG?n3Q8koNhf4ofYkQ?mZ
SEcoEeEBob`h:Ol94P[o4A`:o`TB2_lS;ako;4`YodI<?Om6GTOo4BH:o`TB
2_lS;bT2o`TB2P0Uo`T92_l92ACo4BHNob`V5?l92ACo6Q8Doa4L2_l0003o
2A8:o`T92_lA9Qko6Q`Nog8h5?mP@BWoH2lDol5kNoofooooJVLcoa4V2_n3
>03oYW9Bombc[OnVLU;oUEhcombn]oookLco6PT:oa4V2_l94P[o4BHNo`T9
5?lA9QCo2A8:oa4L2_l92@[o4A`:o`T92P02oaXV500HodI17_m?IdOo4BHD
o`TB2_l92@[o4A`:oaXB5?l0003oH5hcog:=?OmPGS?oLVMBog:=G?n=SFoo
UHAkoiFQS_o1/hkoJW9LoaXV5?lA70[o/:Z4oh=kG?mZIc?o`K>]0_o]m_D0
0ooLhn3oi=3<omcSeP03omcSeP08onC@c?oLhmKog>?FomcSe_o]kN[okOKe
ooKoooo]kNX2ooKoo`0@om?Ie_o1al7oYZ6Hog9WD_ofooooWUhDojIW0?nV
C03o/5D0ojI<0?nV@@3oPcP0og8h5?mb9P3oARH:ocdL2P;o;18000?o6PT:
oa4L2_l/4P000_l92@X00olA70[o6PT:oa4L2P03o`T92P04oa4L2_l92@[o
4A`:oa4L2PKo2@T:00ko2A8:o`T92_l92@[o2@T:o`TB2_lJ4QCo6Q`No`TB
2_lJ2@[o;180ob`L5?l/4P3oEa`0ob`B00;o?A8:00KoEa`0odHV2_l/71Co
;180ocdL2_l/71@2oeLL0008of0_2_m69P[oH2l:of0_2_n3;`3oLRH0oeLL
0?mP;`X4ocdL2P03oeLL0?lm70[o?A`:00?oH2l:00CoH2lDog8h0?mG703o
b]3FGooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000oo^k^h02ooYjNWo
aLG5ogUiNOnPX:3o_Kfmok2`/?n^[Zko]KFeokbl_?nn_[koaLG500cob<S8
1?ooool4ookoo`0:oo_lo_okoooolO;gon3Sj_oLgnKoeMSQol[=e_o6b]Go
^/7;okS1bP;o]l3900Co][o8okFnaond_LKo];g61ong`<TaokO0a`oo]l39
00[o]ko:ok[3d_nnamKoaloLom3Ih_oGg^CohNKZoo3dmOolooooo_om0_oo
ood00oooooooookoooono`02ooono`03oooooooOgmooh>3P00Goh>3P2_oQ
hN43on;RhP;ohn?S0ooTi>@:onGUi@Koi^KV0_oXj>P5on[ZjP_ojn_[0_o/
k>`2ong]k@04onc/k?o]kNgokNg]ong]k@[ok^k^1Oo_knl3oo3`l0GolO7a
2?obl_82oo?cl`?om?Cd00?omOGeooKfm_ofm_H00_ogmoL3ooShn0[onOWi
0oojn_X3ooclo0;oo_kn4Oooool01?lMGk?oYLCVokKBk_mi[^T2oj[Po`04
ofi^K_nd];Coh>3Ponc/k5_ok^k^00?o4A`:o`TB2_lJ2@X00olA70X04ol9
2ACo4A`:oaX92_lJ2@[o4A`:oaX92_lA70[o;180oaX92_l/4P3o4A`:oaX9
2_l/4P3o4A`:o`T92_lJ2@[o2@T:ob`B0?lJ2@X00_l/4P002?lS70[o;180
ob<V2_lS70[o;180oaX92_l/4P3o2@T:0_lJ2@X00olA70[o;180oaX92P02
oaX92P0Mob`B0?lA70[o2@T:oa4L2_l92@[o2A8:o`T95?l92@[o6Q8Dob<_
7_mGIe;oJW9LodmWG?m6C3go=5Dmoc@_<om6Ieco=5DYo`TB2_lJ71koCfM7
odI<?Ol/IecoNhf4oh>4S_mZNhCoNheVodmWAol/>2T00_l94PX01olJ71ko
;4`YodmbNol0003o2@T:o`TB2_lS;ah00_l94PX01?l92@[o6Q8DoaXV5?lJ
9Q@2oa4V5004oa4L2_l94P[o2@T:o`T92P;o4A`:01?o6RHDof0_5?mb>1Co
/7]VooKfmOnVV8Co0000og8h5?nVLU;og;jgonC7`Omb9P3og;jgooK]j_oL
/j?o4BH:oa4V5?lA9Qko2A`N00?o2@T:00oo2A8:o`T92_lA70[o6Q8Doa4V
2_ld;bWoLXdmof1N<ol0003o2@TDo`TB2_lA70[o2@T:ob`h:Old;ah00_m6
EBT03omPGS?oPhf4ojJQV?nVV8CoUJ6>ohf=Aol/>2Wo;2HDoh=kG?nVXISo
YZZ]ol[@`Oo]m_Gom_ooomcSh008omcSeP0AonC@c?o]kN[okOKeooKomOof
oooo`LO1ojJQV?mZLUcoLVMBoij4I_oL/j?okNgZojI<0?n`E@3oYT`0ok1E
0?n`LP000_nVC0001On3>03oPbl0oeLL0?m69P[o?A`:00;o8a`:0_lJ2@X0
1olA70[o2@T:oa4L2_l92@[o2A8:o`T92_lA70X00ol92@X00ol0003o2@T:
oa4L2P02o`TB2P03o`T92_l94P[o2@T:00Co2@T:00Go6PT:o`T92_lJ4QCo
2A8:oaX92P02ob`B0008ocdB2_ld;bWo?A8:ob`B0?lm4P[oARHDoeLL0?lS
70X3ocdL2P05ocdB2_m69QCoLRH0ob`B0?mG70000_mP;`X04Omb9P3o?A`:
oeLL0?m69P[o?A8:odHV2_lm4P[oH2l:ocdL2_m69QCoLRH0odHV2_mP;aCo
JUDNof0_5?lm70[o`LO<05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
00;ooooo00coo_knooKfm_nJVY[oTI6Aolc<c?oEeMGo`/;2okVi^Oo0`<3o
a<C4olW9bOo:b/X<om3@d0Cooooo0oonool02_oloooolOCionkcnOoJg^Oo
`/WAok[1bonb^L?oZ:jjojB/]onFXZh2oiBR[@05oi:PZonAWj[oT9jYohnM
Z?n>W:L02On?WJP0;On?WJKoSifXohnMY_n?WJSoSifVohnMZ?n?WJKoSifX
ohnMY_n?WJSoSifVohnMZ?n?WJKoSifXohnMY_n?WJSoSifVohnMZ?n?WJKo
SifXohnMY_n?WJSoSifVohnMZ?n?WJKoSifXohnMY_n?WJSoSifVohnMZ?n?
WJKoSifXohnMY_n?WJSoSifVohnMZ?n?WJKoSifXohnMY_n?WJSoSifVohnM
Z?n?WJKoSifXohnMYP0:ohnMZ0OoT9jY00[oT9j[oi^X^OnO[;goYk?3ojjj
a_nf`<Wo`/_@omSPh_o/l_;oo?oo0_onool01?ooooooookoooonoooooOl2
ooono`04on?ShooUiNGoiNGUonGUi@[oi^KV1_oWinL00ooXj>SojNWYon[Z
jP04on[ZjP_ojn_[0oo/k>`2ong]k@?ok^k^2_o_knl3oo3`l0;olO7a0_ob
l_801?oalO7ol_;boo;bl_obl_82oo?cl`Som?Cd1OoemOD3ooKfmPGomoOg
2_ohn?P3ooWin@03oo_knoolo?coo?cl00;oo_kn9_ooool01?lKG[?oY/KV
okWCk_mi[^/2oj_Oo`04ogIfM_o1`L7ol?3`oogmoE_ooooo00Go4A`:oaX9
2_lA70[o6PT:oa4L2P02o`T92P07ob`B0?lA70[o2@T:oaX92_lA70[o2@T:
ob`B0002oa4L2P0=oaX92_lA70[o2@T:oaX92_l/4P3o2@T:oa4L2_lJ2@[o
;180oa4L2_lS70[o;180ob<L2P02oa4L2P0>o`T92_lA70[o2@T:oaX92_l/
4P3o2@TDoaX92_l/4P3o8a`:ob`B0?l92@[o8a`:oa4L2_l92@X3oa4L2P0L
o`T92_l94P[o2@T:o`TB2_l/C2WoJW9LofYkKomZSEcoCfM7odINAom6@Ako
8blNob<_:Ol/C2WoCfMLoceN?Old;c?oCeiVoh>HS_n3Q8koJW^4oeN=G?m6
GTOo4BHNo`TB2_lS;bWo=5Dmob<_:@;o000000?o2A8:oaXV5?lJ4Q@00_l9
4PX07olA70[o6RHDob`h:Ol94P[o4A`:o`T92_l94P[o2@T:o`TB2_lS70[o
2@TDoaXB5?l0003oUD`YoiEbAoo]fLcoi=3<oa4L2_n=E@[oYXB4ombn]oof
m_GoEa`0ong]j_ofkN[om_ooo`000?l971Co4BHDo`T92_lA9Q@00_lA70X0
2Ol92@[o2A8:o`T92_lA70[o2@TDoaX92_mZIc?oNheVoh=k<`02o`T92P0G
o`TB2_lA70[o6Q8Dob`h:OlS;akoH44YodI<?On=SE;oPg]LoiFHI_nEXHko
`K>>of1N<old;akoSHe_ol6c[Oo:d<7odmWFongfmOofoooodmWFomcSe_oC
fMH00ooLhmH01OoTd<cog>?FonC@c?oLhn3om_oe00;ooooo00[oLXf4ofYE
7_mZIc?oUHeVol6QQ?oLhmKoooooojJZXoniI`3o/4`01?n`E@002OnVC03o
Pd40oh<_0?mP;`[oLRH0odHV2_lm70[o;180oa4V2P02oaX92P;o2@T:00Wo
4A`:o`T92_l92@[o2A8:oa4L2_l92@[o4A`:o`T92_lA70X00ol92@X01_lA
70[o2@T:o`T92_l92@[o2A8:oa4L2P;o2@T:00Ko4BHDo`T92_lJ4QCo6PT:
ob<L2_lJ2@X2ocdL2P03ob`B0?lm70[oEa`000;oEa`000?o8a`:oeLL0?lm
70X00_lm70X01om69QCoLRH0of0_2_mP;`[oLRH0of0_2_n3;`001?m69PX0
3?lm70[oARH:og8V0?m69P[o?A`:odHV2_mG703oH2l:odHV5?m6;`[oEa`0
ol77c5oooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000;ok^k^00cokNg]
on3Ph?mjNW[o_;blomSHf?oKfm_oc/k>ol30`?o5aLGob/[:olc<c?o?cll<
om?Cd`04oooooOomo?[oooooooooo`;oo_oo00koo?oooo;goOoIh>SobM;K
okNob_nX/[coW:JbohbHY_n2SYcoNh^Hog^>W?mgSI_oMH^Iog67U@;oKH>A
00?oKhFCog67UOm_QI<02?m_QI<0;Om_QI;oKhFCofn5T_m_QI?oKhFBofn5
Tom_QI;oKhFCofn5T_m_QI?oKhFBofn5Tom_QI;oKhFCofn5T_m_QI?oKhFB
ofn5Tom_QI;oKhFCofn5T_m_QI?oKhFBofn5Tom_QI;oKhFCofn5T_m_QI?o
KhFBofn5Tom_QI;oKhFCofn5T_m_QI?oKhFBofn5Tom_QI;oKhFCofn5T_m_
QI?oKhFBofn5Tom_QI;oKhFCofn5TP0;ofn5T`0Fog26U?m_QI?oKXBBofb2
T?m^Q9;oLhVGogN<WOmiRJ3oO8bSoh2AYOn8V:SoUJ>`ojJc_?nka/[ob]CF
on3Xj_oamoOoo_ooooooooomnokoo_coooomo`;oooko00?oinOWonSXj?oX
j>P01?oXj>P:onWYj@?oj^[Z0_o[jn/3onc/k0[okNg]0oo^k^h3ono_k`03
oo7alOo`l?3ol_;b00;ol_;b0_oclo<8ooCdm0GomOGe0oofm_H5ooOgm`go
n?Sh0ooinOT?oo[jnP?ono_k00?oo?cloogmoOomoOd00_ono_hVooooo`04
oamQ]?nS`^Co^=?_ogN^j`;oZ]oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h0
2OlA70[o2@T:ob`V5?lA70[o6PT:ob`B0?lA70[o8a`:o`T92P02oa4L2P;o
6PT:00?o4A`:oaX92_lA70X00_lJ2@X03ol/4P3o4A`:o`T92_lA70[o2@T:
oa4L2_l92@[o6PT:ob`B0?lS70[o;180o`T92_lJ2@[o;180o`TB2P02o`T9
2P05oa4L2_l/4P3o;180oaX92_lS70X00_lJ2@X01olA70[o2@T:oaX92_l9
2@[o4A`:oaXB5?lA70X00_l94PX06Ol92@[o0000ob`h:OlmGSgoPhf4og^=
I_mZNfooCfM7odI<?OlS;ako;3PYob<_<ombSHCoJW]_odIWG?mZSEcoLXf4
ofYkQ?mZNfooEfMBoba<:OlA9Qko;3PYob<_:Ol000001?l94PX01?lA70[o
2A8:o`T92_lJ4Q@2oaXV50?o4A`:00Co2@T:o`TB2_lA70[o6PT:0_lA70X0
1ol92@[oH44YojIbD_oL_[Oom_ooojJ4Q?mb>0000_o1XH@01_ofm_GoUD`Y
ombn]ooTd<com_ooojJ4Q0;o4BH:00Go2@TDoa4L2_l92ACo4A`:o`TB2P04
oa4L2P08ob`V5?l/>2WoH5hcol6cS_n=SDOo2A8:oa4L2_l94PX2oa4L2P0>
oaXB5?ld;akoAUDYog9WD_mkSFKoUJ6>ol6c[OnEXHko=5DYoh=k<oo1/jgo
`LO1ol[@`OoLhn02ongfm@0Nom?Ie_o:d<7ob]31onC@c?oLhmKoi=3<om?I
e_o:d<7oi=3<ong]j_oooooodn?eoeN=S_m6@AkoUG97oij4I_oTal7okMW<
ooKoooooooooYXB4okUW0?n`E@3o^FL0ok1E0?n`C03o^FL0ok1E0?nV@@3o
UED00_n3;`001_mP;`[oEa`0ocdL2_l/4P3o8a`:oaX92P?o4A`:00Ko2@T:
oa4L2_l92@[o2A8:o`T92_lA70X2o`T92P03oa4L2_l92@[o4A`:00?o2@T:
00co4A`:o`T92_l94P[o2@T:oa4L2_l92@[o;1`Do`T95?l/4P3o8a`:ob`B
0?lS70X2odHV2P03ob<L2_mP;`[oH2l:00;o?A8:00GoARH:ocdL2_lm70[o
?A8:oeLL0003og8V0004og8h5?mb9P3oPbl0of0_2P;oARH:00Oo?A`:odHV
2_mG703oARH:odI17_lm4P[oH2l:00?oARH:00?oARHDoeLL0?n`_/40Goo^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H01?oTi>CoemOGog5a
LOoAdM42omcLg006om3@d?o4a<CobLW9olc<c?o?clood];B3?oEeMD06?oo
oogoo_gkoooooooooooon__oooOjooo_m?[ogNC^om3Hhonnb]SoZ;K3oi6Q
/?mmSYkoKGj@ofAgR?mRMhSoGWR9oeiiR_mONX_oGWV:oeagR?mKMXOoG7N8
oeehR@WoFgJ702goFgN5oe]fQomKMhGoFgJ7oe]gQOmKMXOoFgN5oe]fQomK
MhGoFgJ7oe]gQOmKMXOoFgN5oe]fQomKMhGoFgJ7oe]gQOmKMXOoFgN5oe]f
QomKMhGoFgJ7oe]gQOmKMXOoFgN5oe]fQomKMhGoFgJ7oe]gQOmKMXOoFgN5
oe]fQomKMhGoFgJ7oe]gQOmKMXOoFgN5oe]fQomKMhGoFgJ7oe]gQOmKMXOo
FgN5oe]fQomKMhD00_mKMXL8oeagR004oeYeQ_mLMhSoGGR9oeagR0;oFWF6
01?oG7N8oemjSOmZP9SoGg><oeeaROm/PICoPIBSoi2R[_nS];co]/?9olKA
eOoMiNSoloSkookoooooooooookoooolooomnokoooko00OoinOW1ooXj>P3
onWYj@?oj^[Z0_o/k>`3onk^kP;okno_3_o`l?000ooalO7ol_;boo?cl`0?
oo?cl`;om?Cd0ooemOD3ooKfmP[omoOg0oohn?P2ooWin@?on_[j0_okno/3
ooclo0gooOgm0oono_hXooooo`04oamP]?nUa>Ko^M?_ogN^j`;oZMco00Co
JVYZojj^[_oHf=Soi>CTFooVi^H06_lA70[o6PT:oaXB5?lA70[o6PT:o`T9
2_lA70[o2@T:oaX92_l94P[o6PT:oa4L2_lJ2@[o4A`:oaX92_l92@[o6PT:
oa4L2_lJ2@[o4A`:ob`B0?lJ2@[o2@T:ob`B0?lJ2@[o6Q8D0_lJ2@X02Ol/
4P3o4A`:o`T92_l92@[o0000o`TB2_lJ2@[o6Q8DoaX92P02ob<L2P;o6PT:
00?o;180oa4V5?l92@X00_lA70X01Ol92@[o4A`:ob<_7_lJ4QCo4A`:00;o
2@T:00Go0000o`T95?ldEBWoLXf4oh>4SP02ofYkK`;o=5Dm00koJW]_ocAE
?Om6IecoCfMLodmNI_mZNfooPhB>ofYkKom?LW_oAVMLoba<:OlA9P[o2@TD
o`T92P;o2A8:00So6Q8Do`TB2_lJ4QCo2@T:o`TB2_lA70[o6Q8DoaXV50Co
2A8:0_l92@X03OlA70[o2@TDoa4L2_l0003oARH:oh=N<ooL_[Oom_KeongI
c?lm4P[o`J64ombcXooL_[L00_o1XH@02?oTal7om^gZongIc?mbIe;o4BH:
o`TB2_lA9QCoAT4N0_lJ4Q@01Ol92ACo4A`:o`T95?l971Co6Q8D00;o8a`:
00KoPg]LoiFQS_ldEBWo2A8:o`T92_lJ4Q@3oa4L2P0;ob`V5?o1/jgoPg]L
oiFQS_n`/kOo/:Z4oa4V2_nVQ8Co`LO1ol77c?oTd<`00_o]m_D00ooLhn3o
g>?FonC@c002ol[@`@0Aom?Ie_o:d<7ob]31ol[@`OoLhmKoooooojK7h?m6
@AkoJUDNoij4I_nVV8Cob[j]omcSh?ofooookOKeooooooo1XH@00_niI`00
2on`E@3o^FL0okUW0?n`E@3o^FL0ojI<0?nV@@3oUED0oh<h0?mP;`[oEa`0
00;oARH:00Co8a`:oa4L2_l92@[o6PT:0_l92@X02?lA70[o6PT:o`T92_lA
70[o2A8:o`T95?l94P[o4A`:0_l92@X2o`TB2POo2@T:00?o0000oa4L2_lJ
4Q@00_l/4P000olm4P[oARHDocdL2P02ocdB2P0DoeLL0?mP;`[o;1`DocdL
2_lm4P[oARH:ocdB2_mP;`[oLSPDoeLL0?mP;aCoLRH0og8h5?mkC0[oH2l:
og8V0?m69P[o?A`:of0_2_m69Q@2oeLL0003ob<L2_m69P[oARH:00;oARH:
00?oARl:ocdB2_o1al`0GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00
0_o^k^h03?o/k>cogMgMog5aLOoGemOog]kNomoOgooDe=Coa<C4olO7aoo<
c<cod=3@om;BdPcoe]KF01?ooogjoo_jm_ono_cooooooognooogo?ooinkh
om3Ji_na_LgoVJViognAYOmeRYooNY2UohJO]OnE/<GoW[[?okcKkonoh?7o
a>Gf00;oanSi00?oaNKgolCUm_o4iOH02Oo4iOH0;Oo4iOCoa>GfolCUm?o4
iOKoa>GdolCUm_o4iOCoa>GfolCUm?o4iOKoa>GdolCUm_o4iOCoa>GfolCU
m?o4iOKoa>GdolCUm_o4iOCoa>GfolCUm?o4iOKoa>GdolCUm_o4iOCoa>Gf
olCUm?o4iOKoa>GdolCUm_o4iOCoa>GfolCUm?o4iOKoa>GdolCUm_o4iOCo
a>GfolCUm?o4iOKoa>GdolCUm_o4iOCoa>GfolCUm00:olCUmP05ol;Sm?o4
iOKoaNKgolGVmoo4iOH00_o2ho@03_o3h_Ko^=;[oj>me_n?ZL3oQ9fcogJ<
XOm`QISoQYVXojJha?n`_/WobmGNonW`n?olooooo_oo0_ooo_l00ooooOko
ookoonWYj@03on[ZjP?ojn_[3Oo/k>`00oo]kNgok^k^ono_k`0<ono_k`?o
l?3`0ooalO400ooclo?ol_;booCdm002ooCdm0;omOGe2?ofm_H7ooOgm`Ko
n?Sh2ooinOT2oo[jnP;oo?cl00?ono_koogmoOomoOd04Oono_hZooooo`04
oa]O]_nTa>Ko^M?_ogJ]jP;oZn3o00CoKVi^okBd]?oPh>3ok>c/Foo^k^h0
1olJ2@[o2@T:oaXB5?l92@[o6PT:oa4L2_lJ2@X00_lA70X01?lJ2@[o2A8:
oaX92_lA70X2oaX92P0=oa4L2_l/4P3o4A`:oaX92_lA70[o6PT:oa4L2_l9
4P[o6Q8Dob`B0?l92@[o8a`:oaX92P02ob`L50;o2@T:00_o2@TDo`000?lJ
2@[o8a`:oaX92_l/4P3o6PT:ob<L2_l/4P3o8a`:oaX92P02o`TB2P09oaXB
5?l94P[o2@T:oaXL7_lJ9QCo8blNoa4V5?lA70[o2@TD00;o000000go2A8:
ocAE?On3Q8koPhf4ofYkKomGSEcoEei_og^=I_mGSEcoEfMBodmNI_mbLW_o
JW^400;oLXf400Co2A8:o`000?l92@[o2@TD0_l92@X01_lJ4QCo2@TDo`T9
5?lS;ako0000o`T950;o4BHD01?o4A`:oaXB5?l92@[o2A8:o`T92_lA70[o
2@T:oaXB5?lA9QCo2A8:oaXB5?m69QCoUD`YonC7`Oofooooooooob<L2_o:
ZVKo/8Ak00;oi=3<01OoYW9BolZn[OoTal7okMW<ol[@`Ol0003o4BHDo`TL
5?ld;akoJVLcofYE7_lA9QCo2A8:oaXB5?l92ACo6Q8Doa4V5?lJ71ko6RHD
omc7Xon=SDOo2A8:o`TL5002oaXB500?oa4L2_lA9QCo6RHDojJHKonEXHko
/:Z4ojJZXonEQ7_oARHDol[@e_o1al7og>?FomcSh?oChoGokNgZ00;og>?F
0_oCfMH4ol[@`@0@omcSe_o]m_Gog>?PoeMED_nEQ5;oYYR4ol6cS_oTal7o
g>?FooKoooo]m_Gom^gZooKoooo1alco^FL0om>400;o^FL000So/5D0ok1<
0?niI`3o/5D0ojI<0?nV@@3oPd40oh<_00;oH2l:00GoEa`0oa4L2_lJ4QCo
4A`:oaX92P02oa4L2P;o2@T:00Co4A`:o`T92_l92ACo2A8:0_l92@X00olA
70[o2@T:o`TB2P02o`T92P03o`TB2_l92@[o2@T:00;o2@T:00?o4A`:o`T9
2_l92@X00_lJ2@X01Ol/71Co?A`:ocdL2_mG703o?A8:00;oH2l:00_oEa`0
ocdL2_m69P[o?A8:odHV5?mG703oH2lDog8V0?mP;aCoLRH0of0_2P02oh<_
0003odHV2_mP;`[oARH:00GoARH:00SoARHDoeLL0?m69P[o?A`:odHV5?mG
703o?A8:ol[@eUook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo
00CooOgmonc/k?mgMgOofMWI0_oPh>001_oDe=CoalO7ol[:b_o>c/kod];B
omCDe0coe]KF05koooghoogim_oooogooooooocoooocmooofn?`okk:f_nT
/lKoRifcogJ<Y?mlUZooU[C<ok;Bjoo0h__oan[ool?Vn_o6jo_ocO3oom3e
oooAm?oocoCoolobooo>looodOCoom3eoooAm?ood?Goom7dooo@mOoodOCo
om3eoooAmOood?Koom7eooo@m_oodOGoom3foooAmOood?Koom7eooo@m_oo
dOGoom3foooAmOood?Koom7eooo@m_oodOGoom3foooAmOood?Koom7eooo@
m_oodOGoom3foooAmOood?Koom7eooo@m_oodOGoom3foooAmOood?Koom7e
ooo@m_oodOGoom3foooAmOood?Koom7eooo@m_oodOGoom3foooAmOood?Ko
om7eooo@m_oodOGoom3eooo@m?oocoCoom3cooo?m?ood??oolodooo@looo
coCoolobooo?m?ood??oolkcooo>lOoobo3o0_o;k_l03_o8j?ooanGoolGS
oOnienooWKWAogjH[omfSjGoPYNZoj6ba?njamOofN?]onofo_oko?ooo_kn
0_ooood00oooooooj>SXonSXj005onSXj0OojNWY0ooZj^X3on_[j`03ong]
kOo/k>cok^k^00;ok^k^0_o_knl;oo3`l0?olO7a0_oclo<3ooGem@[om_Kf
3OogmoL;ooShn0;onOWi0_okno/00oolo?coo_knooknoP0kooooo`04oa]N
/onUa>Ko]M3^ogV^k0;oYmco00CoMWIfol71`Oo`l?3ooOgmFoooool5oa4L
2P0Iob<L2_lA70[o6PT:oa4L2_lJ2@[o4A`:ob<L2_lJ2@[o4A`:ob<L2_lJ
2@[o4A`:oaX92_lA70[o6PT:o`TB2_l/4P3o2@TDob`B0?lJ2@[o4A`:o`T9
2_lJ71ko=2lYoa4L2P02o`T92P06o`TB2_lA70[o8a`:ob`B0?lJ4QCo;180
0_lS70X00olJ2@[o8a`:oa4L2P02o`T92P06o`TB2_lA70[o2@T:oa4V5?lA
70[o4BHD0_l/>2T02Old;ako8blNoa4V5?l/>2Wo=2lYob=1?OmGGVooJW]_
og9bN`02ofYkQ009og:=Q?mPLW_oAVMLodmbNon3V8koAUi7o`000?lA9QCo
000000;o2@TD0_lA70X02ol94P[o6Q`No`T92_lJ71ko6Q8Doa4L2_l94P[o
6Q8Do`T95?lA70[o2A`D00;o2A8:00go2@T:oa4V5?lJ4QCo4A`:oaXB5?l9
2ACoARH:oiEbAooTal7om_Keoooooom6;`[o^IQL00;o`J6400koi=3<og]<
5?o1XHCoi<O1ong]j_ofooooH2l:oa4V2_l/71Co4BHNog:=?Om6C3goAUDY
oaXV50;o4A`:01Wo6Q8Dob`B0?lA9QCo=2lYol6c[OnEXHko4BH:o`T95?lA
9QCo4A`:oaXB5?lS;ako2@TDojJHQ?n`/kOoYZZSoiFQS_mZLUcoYZ6Hol6c
[Oo:d<7okOKeom?SmOofoooog>?P00;odmWF01Oog>?Fom?Ie_oLhmKo`LO<
ol6c[Oo1al7og>?Pong]j_mPLW_oUIQVol6cS_o1/jgob]31omcSe_ofm_Go
m_ooongfmOofm_GoooooomcSh?oCQ03o^FL0ol640002ok1E0004ol640?ni
I`3o/5D0okUW00;oYT`000KoPcP0og8h5?mb9P3oARH:ob`B0?l92@X2oa4L
2P;o6PT:00Oo4A`:o`T92_lJ2@[o4A`:o`TB2_l92ACo4A`:00;o2@T:00?o
4A`:o`T92_l92@X00ol94PX00olA70[o2@T:oa4L2P02o`T92P0@oa4L2_lS
70[o8a`:ob`B0?lm4P[oARH:ocdL2_l/4P3oH2lDof0_2_mG703o?A`:ocdB
2_m69QCoARH:of0_2P;oLRH000OoARHDog8V0?mb>1CoPbl0og]<5?mb9P3o
H2lD00;oARH:00OoARHDodHV2_m69P[oARH:oeLL0?m69QCoARH:00;oARHD
00?oARH:oeLL0?o1al`0Goooool01?n_[joobl_;omkNg_oZj^X1oo;blP00
0_o^k^h03?o/k>cog=cLogIfM_oJf][oh>3Pon7QhOoDe=CoalO7ol_;boo>
c/kod=3@om?Cd`coeMGE07;oookhooonnOoooogoooooooCgo_oQj?;oa<gL
oj2_`_n:W;;oPYZbohRS__nL^mOo/]GaokcSoonmi_oo^n?lol[`ooo=mOoo
d_Ooom?koooDnOoodo_oomCioooDo?oof?goomOooooHoOooeoooomSmoooG
oooof?goomOooooHo_ooeoooomSnoooGoooof?koomOooooHo_ooeoooomSn
oooGoooof?koomOooooHo_ooeoooomSnoooGoooof?koomOooooHo_ooeooo
omSnoooGoooof?koomOooooHo_ooeoooomSnoooGoooof?koomOooooHo_oo
eoooomSnoooGoooof?koomOooooHo_ooeoooomSnoooGoooof?koomOooooH
o_ooeoooomSnoooGoooof?koomOooooEnoooe?coomGjoooDo?ooeO[oomCl
oooEn_ooe?coomSmoooEoOooe?Woom;joooBmoood?Soom7fooo@mOoo`nOm
ol?Wooo2i?oo_=kiokGDl?nR`=coR:?0og::Y_n<X;SoX[?7ol??gooPjO;o
l_GjooWkn_omo?Soo_gioooooOoZj^X3on_[j`?ok>c/1oo]kNd6onk^kP03
oo3`l?o_knoolO7a00ColO7a2oobl_84oo?cl`Com?Cd2_oemOD5ooKfmP;o
moOg00?om_KfooOgmoogmoL00oogmoL;ooShn0;onOWi0_okno/00oolo?co
o_knooknoP0kooooo`04oa]O]_nTa>Ko^=;^ogJ]jP;o[=oo00CoKVi^okBd
]?oPh>3ok>c/Foo^k^h00olA9QCo6Q8Doa4L2P02oaXB5009oa4L2_lJ4QCo
4BHDoaX92_lA70[o8a`:o`T92_lJ2@[o2A8:00Co6PT:00Ko;180oaX92_lJ
4QCo;180o`T92_lS70X2oaX92P05ob`L5?lS;bWo6Q8Doa4L2_lJ2@X00_lA
70X01olm4P[o4A`:ob<L2_l/4P3o6Q8Dob`B0?lJ2@X00_lS70X00olJ2@[o
2A8:oa4V5002o`T92P0Ioa4L2_l92@[o2@TDoaXB5?lA70[o6RHDoba<:Olm
GSgoJW]_oh>4NomZSEcoPhB>ofYkKomZNhCoLXf]og:=Q?mZNfooEei_ofYk
Q?m?LW_oCeiVodIED_lS;ako0000oa4V5002o`TB2P0>o`T92_lA70[o6Q8D
o`T95?lJ9QCo4BHNoaXB5?l94P[o2@TDoa4L2_l92@[o2A8:oaXB5?l92A@2
o`TB2P0Joa4L2_l92ACo8blYoaXB5?lJ2@[o2A`DocdL2_mbEE;ob[j]ong]
j_ooooooUHB>oiib<ooL/j?oYUEVooKfmOn`Q7_oUD`YonC@c?o]m_Gom_oo
ongIc?n`Q6Ko`K>>ojIb5?lA9Q@2of1N<`0Koc@_:OlJ4QCo2A`Doa4L2_lJ
4QCo4A`:odI17_n`/kOo`K>>oaXV5?lA9P[o2A`DoaXV5?lJ4QCo6Q`Nob`V
5?n`ZXCo`K>]ojJQV?n3SHCo`LO1ok2n`On`/kOog>?FongfmOo]kN[om_oo
00;odmWF00?og>?Pom?Ie_o:d<400_o1al402_oLaj?ob]31ongfmOnEV:?o
UHAkol6cS_o1/jgob]31omcSe_ofm_D3ooKoo`08ongfmOoooooog>?Pok1E
0?oCQ03o^FL0ol640?oCQ002okUW0005ok1<0?niI`3o/5D0ojI<0?nEE@00
0_n3;`001_m69QCo6Q`Noa4L2_lA70[o6PT:oa4V50;o4A`:00Go2@T:o`T9
5?lJ2@[o6Q8Doa4L2P02o`T92P05oa4L2_l92@[o2A8:o`T92_l94PX00_l9
2@X06?lA70[o2@T:o`T92_lA70[o2@T:oaXB5?lm;cgo6PT:ocdB2_m69P[o
?A`:ocdB2_l/4P3oH2l:og8V0?ld;ako?A`:odHV2_mG703oARHDoeLL0?mP
;`[oLSPDoeLL00;oH2l:0_n3;`002?m69QCoH2l:odHV2_lm70[oARHDof0_
2_m69P[oH2lD0_mP;`X01_m69P[oEa`0odHV5?m69P[o?A8:ol77c5ook^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV00Coi>CTomCDe?mlO7co
f][J0_oPh>001_oCdm?oa/K6olc<c?o>c/kod=3@om?Cd`coemOG01?oookh
ooomnOooo_goooooonobnOoHg^[o]l?CoiBU^OmbR:3oOYVdoiFddOnYc^_o
/]_kokCQoonjj?oo`o7oolSbooo<m?kocoOo00;od?So00?ocoOoom3hoooA
nOl0>?oDo?l8om;jo`04omKnoooCnoood?Soologo`;oc_Ko01CocOGoolcd
oooCnOood?Gool?XoonbeoCoZlk^ojK7j?nI]]SoR:;3og^B/OnAXk_o]<7D
omSPkOoam_[oo?kmoognn?onoOSoooomonWYj@?oj^[Z0oo[jn/7onc/k003
om_Kfoo[jn_okNg]00;oh^;R00GokNg]ono_koo_knoogmoOon7Qh@03oo7a
l@;ol_;b00?oinOWomcLg?obl_801_obl_88oo?cl`?om?Cd00?ofm_Koo;b
l_odm?@01?odm?@5ooGem@?omoOg1OoinOT;oo[jnP;ono_k0oolo?`2oogm
oA7oo_kn:_ooool01?lMGk?oY/KVokK@k_mi[nh2oj_No`04ofYZJ_n^[Zko
f=SHonCTi5_oi^KV00_o6PT:o`T92_lJ4QCo6PT:ob<L2_lJ2@[o4A`:oaX9
2_l92@[o6Q8Dob`B0003oaX92P0>ob`B0?lA70[o8a`:oaX92_lS70[o4A`:
ob`B0?lJ2@[o4A`:oaX92_l/4P3o6PT:oa4L2_lJ2@X4o`T92P0Coa4L2_lJ
2@[o6PT:ob<L2_lJ2@[o;180oaX92_lS70[o6PT:ob`B0?lJ2@[o4A`:o`TB
2_l92@[o4A`:o`T92_lA70[o2@T:oa4L2P02o`T92P0=oaXB5?l0003oAUEB
oiFHXomkSHCoSIR>of1bNoo1alco/;>gofYkKomPLW_oJW^4of1bN`02odmb
N`05odmNI_lS;ako2@T:ob`h:Ol92@X00ol94PX01_lA70[o2@TDoaXB5?lJ
4QCo2A8:o`T92P;o4A`:00Co2@T:o`TB2_l94P[o2A8:0ol92A@02OlJ4QCo
4BHDoaXB5?lA70[o2@TDocdL2_nELTOo`J64onC@c002ooKfm@03oiEE5?ni
LS?o/7]V00;okNgZ01KoUD`Yombn]oofooookOKeooKoooo]fLcog;jgonC7
`OmZIc?o4BH:oh=kG?n3Nc?o2A8:oaXB5?lA70[o;1`Doa4V2_lJ9QCo`K>>
ojJQV?mZEAko6RHD0_lJ4Q@04OlJ9QCo;2HDofYW<on3SHCoYZZSojJZ[Oo:
d=KoYZZSok2ZQ?n`/kOokOKeom?SmOo]kN[okOKeom?Ie_oLhn3ob]3100;o
`LO100_o/;>gol6c[OoTd<cog>?Fom?Ie_nVV6ooYZ6Hol6c[Oo1alcog>?F
ongfm@03ooKoo`04ooKfmOofooooooooom?IePCodh@000Co`H@0om>40?o1
Q03o/4`00_niI`000on`E@3oYT40oiEE0002oh<h00;o?A`:00?o4A`:oaX9
2_lJ2@X00_lJ2@X01?lA70[o6PT:o`T92_lJ2@X2o`T92P05oa4L2_l92@[o
2@T:o`TB2_lA70X01Ol92@X00ol94P[o2@T:o`T92P02oa4L2P0;ob`B0?lJ
2@[o?A`:oeLL0?lm4P[o6Q8Dog8V0?mG703oH2l:ocdL2_mG70001?mP;`X0
0on3;`3oLSPDog8V0002og8h5003oh<_0?mP;`[oH2l:00CoARH:00[oH2l:
oeLL0?m69P[oARH:oeLL0?m69P[o;1`DodHV2_lm4P[ob]3FGooVi^H01?nM
WIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h01?o/k>cog=cLogalO?oJf]X2
on3Ph006om?Cdoo7alOoc<c<olk>c_o@d=3od];B3?oFe]H05_oooOGooocf
ooonnoono_oojNccoloGh_n__<goSZ2foh>K]On;Z<KoV[gMojG<kOnVd_Go
YmSiok?Uooo1loooao7oolccn_o?m_godOSoom3go_o?m_d2om3goPSod_Wo
<?oBnOh8om3goP0Fom?joooAn?oocoKmolofoOo@mokocoKmolccn_o9lO_o
]Mk`ok_So?noiooo^N3oojoCmOnQaNWoTk?Joh^Wc?mlU;KoRYfkojNfboo=
e^Goj_7goo[on`;ooooh00?oooomon[Zj_o[jn/00_o[jn/00oo/k>co<C4a
ofi^KP02ong]k@0HonCTi?lS8b?o@D51onc/k?m;Bd_o1`L7oaPH6?nATI7o
4A4Aoe5ADOo^k^koe]KFoc/k>ol0003o410@oa/K6ooYjNWol?3`om[Jf_m5
ADGo0P82ob4Q8OlE5AGo][Jf1?oalO401?m9BDWoKVi^oo;bl_obl_82oo?c
l`08ooCdm?l/;2coFUYJooGemOo:b/[o8b<Soa`L7?nb/[85ooGem@03oc@d
=?l0003o000000;o000000Co>3PhooShn?lm?CgoO7al0_oinOT02_ln?Sko
O7aloo[jn_ojn_[oWinOoa/K6oojn_[oa<C4o`000?l92@T3o`h>3P05oeaL
G?okno_oo?clooclo?omoOd00_ono_hkooooo`04oaYL/onT`nGo^=;_ogV^
k0;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01?lJ4QCo;1`Doa4L2_lJ
2@X2o`T92P0GoaX92_lA70[o6PT:oa4L2_l92@[o4A`:oaX92_l92@[o8a`:
oaX92_l/9QCo2@T:o`TB2_l/4P3o6PT:oa4L2_l94P[o;180oaX92_lA70[o
;180oaX92_l92@X00olA70X03OlJ2@[o8a`:ob<L2_l/4P3o8a`:ob<V2_lS
70[o;180oaX92_lS70[o6PT:oa4L2_l92@X00ol94PX03ol92@[o2A8:o`T9
2_lA70[o2A8:oaXB5?l92@[o4BlcofYkKonEV:?oLW9kojJc`OmZNfooLXf4
ofYkQ002og:=Q008of1bNomZNfooNhf4oeN=G?l0003o2A8:obaN?Ol00002
o`TB2P03o`T95?lA9QCo6Q8D00;o2@T:00?o2A8:o`T95?l92@X00_l94PX0
1?l92@[o2A8:oaXB5?l92@X2o`TB2P0EoaXB5?lA9Qko4BHDoaXB5?lA70[o
6Q8DofYE7_nVQ8Coi=3<ongfmOooooooLUEBok2=<oo1Ng_okMW<ooKoooo:
_Zgo/8AVooKfmOo]m_Gom_oo00?okNgZ01[oi<O1odH_2_nEV6KoPg]LocAE
:Ol94P[o6Q8Doa4L2_lS70[o4A`:oiFQS_o1/jgoAUDYob`h:OlS9P[o6Q8D
oa4V2_ld;akoJW9LoiFQS_oCfMKob]31ol77`OnEZZgoSIR>ol[@`@;okNgZ
00?om_oool[@e_o1al400_o1al44ok2c]`08omcSh?o]m_GoYZZSojJZXoo1
/hkoYZ6HomcSe_o]kNX6ooKoo`03oooooooL/jgodh@000Codh@000?o^FL0
om>40?niI`000_niI`003?n`E@3oYVL0ojI10?nEE@3oPd40odHV2_lm70[o
8a`:ob`B0?lJ2@[o2@T:oa4L2P;o2@T:00Ko4A`:o`T92_lA70[o2A8:oaX9
2_lA70X2o`T92P0>oa4L2_l92@[o2@T:oa4L2_l94P[o2@T:oa4L2_l94P[o
2@T:o`TB2_l92@[o;1`Dob`B0?mG7002odHV500<ocdB2_mP;`[oH2lDog8V
0?lm4P[oH2lDoeLL0?m69P[oARHDoh<_0?mb>03oH2lD0_mb9P001OmkC0[o
Pbl0of0_2_m69QCoEa`000;oARH:00GoEa`0of0_5?mG703oARHDoeLL0002
odHV2P;o?A`:00?o;180om?SmOo^k^h0G_o^k^h01?nSXj?o_Kfmolo?cooJ
f]X1on7Qh@000_ooool01?omoOgok>c/ogalO?oJf]X2on3Ph006omCDe?o8
b<Sobl_;olk>c_o@d=3od];B3?oFe]H2ooonn`0AoooooOohnO_og^?Yol7;
eOnN[l7oOI:]oh>M__n4Y<_oSK;Loic6l?nYeOco[]cook7RoonfiOoo_NKh
olCZmoo9k_h00_o;lOh00oo9kocob>kkolS^n`07olS^nc7ob>ki2?o8k_/0
6_o9kocob>kkolS^noo:l?gobo7nolW_o?o4j_Oo_nKgolK^oonhgoco[MKd
ojkGmon[doOoWL?Zohb_fOn4Y<goP9c4ohJL`OnJZlOo_<WLomgVkoobm_Go
o?geoooom_oooo_oj^[Z0oo/k>`00oo]kNgo<S8bofi^KP02onk^kP09ofQX
J?lB4Q;oemOGokRh^?l30`?oclo?omOGeomEEEGo3`l?00;okno_00go?Cdm
obTY:Onn_[kokno_ol[:b_o]kNgokno_od10@?ll?3codM7Aoo3`l?oTi>Co
hn?S00Col?3`00goZJVYoa<C4oo[jn_olO7aoo;bl_oclo?o`/;2o`000?nj
^[[omOGeofa/K?ln?Skom?Cd00KomOGe00?o=3@dofm_Koofm_H00_ofm_H2
ooOgm`06ocdm?OmkNg_on?ShooShn?ln?SkoNg]k0_oinOT01onOWioo6a/K
ooWinOoemOGoA4A4ocPh>?obl_800_oinOT2oo[jnP?oo?cl0_ono_hkoooo
o`04oaeO/onUa>Ko]];^ogV^j@;oZ^3o00CoMWIfol71`Oo`l?3ooOgmFooo
ool00olA70[o6RHDo`T92P03oa4L2P06o`T92_lA70[o4A`:oa4L2_l92@[o
;1800_lA70X03?l92@[o8a`:ob<L2_l/4P3o6PT:ob`B0?lA70[o6PT:o`00
0?lS70[o2A8:ob`B00Co4A`:00Co2@T:oaX92_lA70[o;1800_lJ2@X01olS
70[o;180oa4L2_lS70[o;180oaX92_lS70X00_lA70X01ol92@[o0000o`TB
2_l94P[o4A`:oaXB5?l92@X00_l94PX01?l92@[o0000oiFHXomkSH@2oiFZ
[@05odIED_mbLW_oLXf4og:=Q?mPLW/00_mbSH@01_n3V8koAVMLo`000?l9
4P[oCfM7o`0000?o2A8:00?o8blYo`TL5?l94PX00ol94PX01?lA70[o2@T:
o`TL5?l92@X2o`TB2P0Ioa4L2_l92ACo4BHDoaXB5?l971Co;2HDo`T92_lA
9QCo4A`:of0_5?oTZYSoYZZ]ombn]ooooooog;jgoiEN<on`NfKo`LO<ooKf
mOoTd<co/7]VooK]j_o]kN[om_Keongfm@02ong]jP05omcSh?niZVooH5hc
ojJQV?m6EBT00_l971@04_l92@[o6RHDoa4L2_mPGS?oUIQVodIE:OmPGS?o
4A`:oaXV5?l971koJVLcojJQV?oCfMKob]31ol77c?n`/kOo/:Z4oh>4N`;o
kNgZ0_o]m_D00on`/kOo`LO1ol6c[@02oiFQSP07ok2c]oo1/jgokNgZomcS
h?n3V:goYZ6Hok2c]`02ol6c[@03ong]j_o]m_Gom_oo00Kom_oo00Go^FL0
om>40?oCQ03odh@0onBZ0004om>400?o^FL000Oo/4`0ok1E0?nVC03oUED0
oh<_0?mb9P3oARH:00;o8a`:00Go4A`:oaX92_lA70[o4A`:o`T92P03o`TB
2P?o2@T:0_l94PX01?l92@[o2A8:o`T92_l94PX3o`T92P05oa4L2_l92@[o
4A`:oaX92_l/4P000_m69PX00omG703o?A8:og8V0002og8V0003odHV5?mb
9P3oLRH000;o?A`:00?oLRH0oh<_0?mb9P000omb9P002_mP;`[oEa`0of0_
2_mG703oARH:oeLL0?m69P[oLRH0odHV2_mG7003odHV2P04ocdL2_l/71Co
;180om?IeUoooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000;ok^k^00co
k>c/omcLg?mkNg_of][Jon3Ph?oQhN7oeMGEolS8b?o:b/[oc/k>om3@d?oC
dm<<omKFeP;oooko01Koo?kmooOmoOoGhN?o_L_Doi:W_?m]QjSoN9S7ogjS
f_n:/^goU[ogoik6monWco?o/=SbokKNmonkh?go^]knok[Noonlh?oo`>Co
ol7Uooo0i?oo_N7o@?o2iol3ol?Xo`0Gol;Wooo1i_oo_nCookkSoonmhOoo
^McookOJoon_eO[oY/kboig7kOnF`>SoR[?Ooh>WeomiVL[oJHFdoi6Wd?nc
a>;oen3aooGjoOonooSoo_ocoooonooYjNT00ooZj^X04_o[jn_o<C4aofe]
KOo/k>co/k>co`410OnSXj?ok>c/olS8b?l20P;o[jn_ong]kOnCTi?o7AdM
ong]kOo<c<co0000oh^;R`ColO7a00?od=3@o`000?n^[Zh02?obl_800oo_
knoo6QXJofa/K003oi:BTP06odE5AOlV9RKolo?cooCdm?m9BDWoKFe]1ood
m?@00olc<c?oKfm_ooGem@02ooKfmP;on?Sh00Ko?ShnogemOOokno_ono_k
oclo?ommOGd2oogmo@07oj6QXOlK6a_ooOgmoogmoOo^k^ko:BTYoeUIF@04
oogmo@?oo_kn?Oooool01?lKG[?oY/KVokWCk_mi[^/2oj_Oo`04ofi^K_nd
];Coh>3Ponc/k5_ok^k^00Ko6Q8DoaX92_lA9QCo6PT:oa4L2_lJ2@X2oa4L
2P;o6PT:00Go2A8:oa4L2_lJ2@[o6PT:ob`B0002oa4L2P07oaX92_lA70[o
4A`:oaX92_l/4P3o4A`:ob`B0003oaX92P06ob`B0?lJ2@[o6PT:oaX92_lA
70[o6PT:0olS70X02Ol/4P3o;1`DoaX92_l/4P3o6Q8Dob`B0?lS70[o6PT:
oaXB5002o`TB2P05o`T92_l94P[o6Q8Do`T95?lA9Q@00_lJ4Q@00ol92@[o
=5Dmog^=Q002oiFHX`04odmNI_mbSHCoCg9koh>=Q0;oAVML013oPiR]oiFZ
[On3V:go0000o`TB2_lJ71koAUEBo`000?l971Co2@TDo`T92_l/C2Wo6Q`N
o`TB2_l92@[o2@TD0ol94PX00olJ4QCo2A8:o`TB2P02oaXB500Do`T95?lA
70[o4BHNob<_<ol/>2Wo4A`:oaXB5?l94P[o;180ol6c[Oo1Ng_og;jgongf
mOofoooo/7]VojIbD_oL/jgokOKeong]j_oTZYP2ong]jP0FooKfmOo]m_Go
m_Keong]j_ofkN[og>?Foa4V2_nVZZ?oLXdmob<_7_l94P[o4BHDo`T95?l/
71Co8blNodI<?OnELTOoSHeBoa4V7_lA70[oJVLcol[@`@?o`LO<00Oo`LO1
ojJZXonVZZ?o/;>gooKooooChoGom_oo00?o`LO<00WoUJ6gohfHS_nEZZgo
b[j]ong]j_nVan3o6RHDodI<?Oo1/hh00_o:d<400ooL_[OoooooooKoo`05
ooKoo`05ongfmOoTZYSodh@0om>40?oTZP000ooCQ0000ooTZP3odh@0okUW
0003ok1E0004okUW0?n`C03o/5D0ok1E00;oPd4000?oLSPDodHV2_l/4P00
0_lJ2@X01olA70[o6PT:o`T92_lA70[o2@TDoa4L2_l92@X00_lA70X2o`T9
2P04o`TB2_l92@[o2A8:o`TB2P;o2@T:00Oo4A`:o`T92_l94P[o6PT:ob`B
0?l/71Co?A8:00;oEa`000ko?A8:og8V0?mb>1CoH2l:odHV2_mG703oLRH0
ocdL2_m69P[oPbl0og]<2_mb>1CoLRH0odHV2P?oH2l:00SoEa`0of0_2_mG
703oH2lDoeLL0?m69QCoEa`0odHV50?oARH:00Co?A`:ob`L5?lm4P[odn?e
Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H01?oTi>Coe=CD
og]kNooJf]X2on3Ph006omCDe?o8b<Sobl_;olk>c_o@d=3od];B3?oEeMD0
L_onoOooo_oooo[noooeoOoodmkRok_=fOmnU[3oJHV_og>Hc?miXmooQ;3_
ohjkm_nG`O?oX<K]oj[>j?n_dngo/mOkok3FoOnbeOgo/mWookWLoonigooo
^mkookOMoonjg_oo^=kook[Noonhg_oo^]kookSOoonjg_oo^=oook[No_nh
goko^]knokSOo_njg_ko^=onok[No_nhgoko^]knokSOo_njg_ko^=onok[N
o_nhgoko^]knokSOo_njg_ko^=onok[No_nhgoko^]knokSOo_njg_ko^=on
ok[No_nhgoko^]knokSOo_njg_ko^=onok[No_nhgoko^]knokSOo_njg_ko
^=onok[No_nhgoko^]knokSOo_njg_ko^=onok[No_nhgoko^]knokSOo_nj
g_ko^=oook[Noonhg_oo^]kookSNoonjg_oo^=kook[Noonhg_oo^MgookOM
oonjg_oo^=kookWMoonfg?oo]m_ookKIoonce?oo/=;oojW>n?nNb>koUl?Z
ohnliOn4/=ooNjGGog:Gc?mWQk[oP9S6ok?6iooDgo?olo_nookon?olo_7o
oookonWYj@?oj^[Z00Kojn_[oc4a<OmZJV[ogMgMob0P8?mPH603onc/k009
oj2PX?l^;Rko;bl_oc8b<_lM7AgokNg]ok2`/?l0003o`L7100ColO7a00?o
/k>co`000?li>CT00olk>c/00onj^[[ol_;boo;blP03oo;blP0;ogUiNOl>
3PkoHf=Sof=SHomHF5So0000ohF5QOodm?ComOGeodU9BOm]KFd01ooemOD0
0old=3CoKfm_ooKfmP02ooKfmP;on?Sh00Ko?ShnogalO?ojn_[on_[jochn
?_mlO7`2oo_kn`03oj2PX?lK6a_ono_k00;ono_k00Cofm_KoaDE5OmmOGgo
no_k0_olo?`3oogmo@;oo_kn>oooool01?lOHKCoXl;TokSCkomg[^/2oj[O
o`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00_o4A`:ob<L2_lJ4QCo8a`:oaXL
7_lA9QCo6Q8Do`T92_lJ4QCo2@T:ob<L2P02oaX92P06oa4L2_lJ4QCo;180
oaX92_l/4P3o6PT:0_l/4P001OlJ2@[o2@T:ob`B0?lA70[o;18000?o6PT:
00Ko2@T:oa4L2_lA70[o6PT:ob`B0?lS70X2oaX92P0<o`T92_lS70[o6PT:
oa4L2_lJ2@[o8a`:oa4L2_lA9P[o2A8:o`T92_lA70[o2@T:0_l94PX04Ol9
2ACo6Q8Doa4V2_lJ9QCoJW]_oiFZ[OmbSHCoAVMLofYkQ?mbSHCoAVMLoceN
?OlS@CgoJW^4ojK7h?n3V8ko2A`D00;o2A8:00coAVMLodmWG?l0003o8blN
oa4V5?l0003o;3PYoaXV5?l92@[o2A8:o`T95?l94PX2o`T92P0Ao`TB2_l9
2@[o2@TDo`T92_l92ACo4BHDoaXL7_lA9Qko8d5BoeMWD_lA70[o8a`:oaXB
5?l92ACoUD`Yol6c[OoL_[L00_ofool07_oTd<coUEhcol6QQ?o]fLcog>?P
ombn]oo]kN[om_Keong]j_ofm_Gom_ooongfmOo]kN[oooooodH_2_nVXISo
Pg]LodIE:Ol971Co6Q8Doa4L2_lA9QCo;2HDob<L2_mGIe;oLXdmof11:On=
SFoo`LO1ok2n`@;o`LO<0_o1al400on`/kOo`LO1ojJZ[@02ongfm@0@ol[@
e_nEV:?o/;k1ol77`Oo1alcoY[?1onC@c?nEZZgoEhf>obaN?Om6C3go6RHD
o`TB2_nEXHkob]31omcSh0Com_oo0_ooool00oofoooobZ4mom>40002om>4
00?oi:X00_oCQ0001OoTZP3odh@0om>40?oCQ03o^FL000?o/5D000Ko`H@0
ojI<0?n3@@3oUED0odHV2_lS70X2oa4L2P07oaX92_l92@[o4A`:oa4L2_lJ
2@[o2@T:oa4L2P02o`T92P0Io`TB2_l92@[o2@TDoa4L2_l92@[o2A8:o`T9
2_lA70[o2@T:oa4L2_l92@[o4A`:oaXB5?l/4P3oARH:og8V0?mP;aCoARHD
of0_2_mb9P3oPbl0of0_5?mP;`[oLRH0oeLL0002of0_2P05oh<_0?m69P[o
Ea`0odHV2_mP;a@00omP;`X03_mG703oH2lDodHV2_mG703oARH:oeLL0?m6
;`[o?A8:ocdL2_l/9QCo?A`:odI17_n3GQCob]3FGooVi^H01?nMWIgo]kNg
olS8b?oCdm<1om[JfP000_o^k^h01?o/k>cog=cLogalO?oJf]X2on3Ph006
omCDe?o8b<Soc<c<olk>c_o@d=3od];B3?oDe=@0L_ooo_Wooookoo_oo_oe
o?oocm_Yokc>i_mRO9goJX^fofbFb?maX=KoO:gUohNfj_n?^n[oUkkWoj73
i_nUb>SoY/g^ojG=l?nVc?3oYlobojcCm?n^eoOo/=OhojoHn?n_e_Go[]Oe
ojoFmOn^eoGo[mKcojkGlon_e_?o[]OcojoFlon^eo?o[mKcojkGlon_e_?o
[]OcojoFlon^eo?o[mKcojkGlon_e_?o[]OcojoFlon^eo?o[mKcojkGlon_
e_?o[]OcojoFlon^eo?o[mKcojkGlon_e_?o[]OcojoFlon^eo?o[mKcojkG
lon_e_?o[]OcojoFlon^eo?o[mKcojkGlon_e_?o[]OcojoFlon^eo?o[mKc
ojkGlon_e_?o[]OcojoFlon^eo?o[mKcojkGlon_e_?o[]OcojoFmOn^eoGo
[mKeojkGmOn_e_Go[]OeojoFmOn^eoGo[]GdojgFm?n^eOCo[=GcojcCl_nZ
do7oZM3_ojS>l_nWb_CoY/Seoj35konF`>SoSkcUohRghomm[MgoM:;Fof^D
b_mURKgoIH:^okK:jooBgo;olo_nookon?oknnoooookonWYj@Coj^[Z00Go
<C4ao`820_l0003o0000ok6a/@04on_[j`08onc/k?oZj^[oR8R8oahN7_o]
kNgobl_;o`000?n7QhL3oo3`l008oo7alOo>c/ko0000oj:RX_o4a<Co_;bl
o`820_oIfMT5oo;blP0;omKFe_l20P;od];BooCdm?nFUYKo10@4on3Ph?oe
mOGom_KfodY:B_m]KFd01oofm_H00old=3CoL71`ooOgm`04ooOgm`06ochn
?_mkNg_on?ShooShn?ln?SkoFUYJ0_oinOT00onIVIWo71`LooWin@03ooWi
n@03ol71`Ol820SoXJ6Q00;on_[j0oolo?`2ooknoS_ooooo00Co7f2dojG4
i_nidnooMjk[0_nYg?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP?o8a`:00Oo
4A`:oaXB5?lJ71ko2@T:oa4L2_l92@[o4A`:00;o6PT:00Ko2A8:ocd_?Ol/
4P3o;180oa4L2_l/4P02oaX92P06ob<L2_lA70[o2@T:ob`B0?lJ2@[o2@T:
0_l/4P001_lA70[o;180oaX92_lJ2@[o;180oaX92P;o;18000?o4A`:ob`B
0?l/4P000_l/4P00:_lJ2@[o4A`:oaXB5?l/4P3o2@T:o`TB2_l92@[o4A`:
o`TB2_lA70[o2A8:oa4L2_ld;c?oJW]_og:=Q?ld;c?oAVMLoeMWD_m6Ieco
AT`mo`TL5?lA9QCoUIRSol77c?n3V8ko4BH:o`000?l94P[o?BlmoiFZ[Om?
Ieco0000ob<_7_lA9P[o2@TDoba<:OlS;bWo2@T:o`TB2_l92@[o2@TDoa4L
2P;o2A8:01Ko2@T:oa4L2_l92@[o6RHDoa4_<olS;c?o4BlcodIWG?n3V:go
2@T:ob<_7_l971Co2A8:oeLL0?o1XHCob[j]ongfmOofoooooooook1kI_o1
XHCo`LO<0_oTd<`01?o]fLcokOKeooK]j_o]m_D3ooKfm@05oooooon`Q7_o
NheVohf=Kom?IdL00_l94PX01_lA70[o4BHDoaXB5?lJ9QCo4A`:of1N<`;o
/;>g01[o/;k1ol77c?o:d<7o`LO1ok2c]onVZZgoYYR4ok2c]oo:d=KokNgZ
ooooooo1al7o/;k1om?Ie_n3V:goNhf4odmWG?o1al7o`LO<og9ED_nVXISo
UJZ]oiFQS_m6@Ako0000odI<?@;om_oo00OokOKeooKoooooooooooooom?S
mOoT/bWoi:X000?odh@00_oTZP001?oCQ03oi:X0okUW0?oTZP02om>40006
okUW0?oCQ03o^FL0ol640?n`C03o^FL00_o1Q0001_nEE@3oLRH0ocdL2_l/
4P3o6PT:o`TB2P?o4A`:0_l92@X01olA70[o2A8:o`T92_l92@[o4A`:o`T9
2_l94PX01?l92@X03?l94P[o2@T:o`T92_l0003o8a`:ob`B0?l/71CoEa`0
of0_2_mG703oLRH0of0_2P;oLRH00_mP;`X01_n3;`3oH2l:odHV2_mP;aCo
LRH0ob`L50;oEa`000KoARH:of0_2_mG703oH2l:oeLL0?mP;`X3odHV2P05
ob<L2_m69QCo?A`:ocdB2_nNNc<00_nNSC<00onVan3ok^k^onk^kP1Monk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002ooooo`0<oogmoOo/k>coNg]k
omWIfOoOgmoohN7QomCDe?o7alOoc<c<olk>c_o@d=3oeMGE3?oDe=@04Ooo
o^ooooodookooOognooodMcbokg@l?m9I8ooI8Rhof:@`_mXW<koMJWIogjb
hOn7]^;oT;[Toi^ni_nQ`nWoW/CX00;oWLGX00GoWlOZoj;;jonTcNgoY/o_
ojO@l004ojK?kCCoY/o[2?nVcnd2ojO@kP0HojK?kOnTcN_oX/_Yoj39ionN
anGoW/GVoio2j_nN`>goVKkZohnji?n8]n?oP;?RogJZg?m]WmCoHi39of28
_?m<JiWo]lk`om;Ol_oen_koooohoocll?oooo_oj^[Z0oo[jn/01oo/k>co
<C4aofi^K_oBd];oSXj>o`L71on[Zj/00_o/k>`01OnVYZKob/[:on[Zj_mJ
FU[oCTi>00;okNg]00Go>SXjob@T9?nb/[;ok^k^om3@d002ono_k`05oc/k
>omTI6Coj>SXoiBDU?lX:2P01_o`l?001_oalO7oADE5og9bL_obl_;o=CDe
odm?C`;om?Cd00Gokno_odI6A_mXJ6Soj^[Zoo7al@05ooGem@03oc@d=?m_
Kfoom_Kf00;om_Kf0_ogmoL02_lm?CgoNg]kooShn?ohn?So?Shnoa<C4omc
Lg?of=SHoeADE?m;Bd/2ooWin@?ok^k^00CoV9RHo`H61_o1`L7on_[j0ool
o?`2ooknoS_ooooo00Co6enfojC4i_nidnooMZgZ0_n[h?l01?mfMWKo`L71
oo3`l?omoOeKooooo`0HoaXV5?lA70[o4A`:oaXB5?l92ACo6PT:oa4L2_lJ
2@[o4A`:oaX92_l92@[o4A`:ob<L2_lJ2@[o;180oaXB5?lS70[o6PT:ob`B
0?lA70[o2@T:ob`B0?l92@[o8a`:0_l/4P002OlA70[o2@T:ob`B0?l92@[o
4A`:o`T92_lJ2@[o;180ob<L2P02oaX92P07oaXB5?lJ2@[o2@T:oaX92_lS
70[o;180o`T92P02oa4L2P0<o`TB2_lA70[o2A8:o`T92_lJ9QCo8blYofYk
Kom?IdOo?Ehmob<_7_l/C2WoAT`m0_lS;ah01Ol94P[o;1`DoiFQS_nV/l7o
SIR>00;o000000go2A8:oa4V5?nEZZgoY[?1ofYkKol0003o;4`Yob<_7_l0
003oAT`moa4V5?l94P[o2@T:00Ko2A8:01Go2@TDoa4V5?lJ71ko=5Dmob<_
:Om6GTOoPhB>oeN=S_ld;ako8bH:oaXV5?lJ4QCo;1`Doij4I_o1/jgog;jg
ongfmOofoooog;jgojJZXooTal400_oTd<`06Oo]m_Gom_ooong]j_ofm_Go
kOKeooKfmOo]m_Gom_ooombn]on3NecoSIR>odmWAol/>2Wo4A`:oaXB5?l9
2ACo6PT:oa4V5?lA70[oAT`mol[@`Oo1alco`LO1ol77c?n`/kL00_nVZZd0
3_nVXISoYZZ]ol77`Oo]kN[okOKeom?SmOo:d<7o`K>]omcSh?o1al7oUJ6>
ojJZ[On`/kOodn?e0_o]m_D01Oo]kN[og>?PomcSh?o1/jgoYZZ]00CokOKe
00?og>?PoiFcc?oTZYP01?oTZP000ooCQ03oi:X0onBZ0002onBZ0003ombZ
<ooTZP3odh@000;odh@00oniI`002On`E@3o`H@0okUW0?n`LP3oUED0of0_
2_mG703o8bH:oa4L2P02oaX92P03o`TB2_lJ2@[o4A`:00;o2@T:00Oo;180
o`T95?l92@[o2@T:oa4L2_l92@[o4A`:00;o2@T:00?o4A`:o`T92_l94PX0
0_l94PX01olJ2@[o?A`:ocdB2_mb9P3oH2l:oeLL0?mb>1@00_mb9P001OmP
;`[oLRH0oh<_0?mb9P3o?A8:00;oLRH000Oo?A8:odHV2_lm4P[oLRH0of0_
2_mG703oH2l:00GoARH:00Go?A`:odHV5?l/4P3oH44YojJQIP02ohf=A`03
ofYW<oo:d=Kooooo05kooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000;o
k^k^00cok>c/omcLg?mkNg_ofMWIomoOgooQhN7oe=CDolK6a_o<c<coc/k>
om3@d?oDe=@<omGEe@0HooooioooonoooookooSloooHhOko`=?moc]JROmH
P;CoFXboof2Haom]Y]?oN:kJoh6bgOn:]N;oU[SVoiZljOnG_^OoU/3VoiO1
ionH`^SoVLCWoi[5j?nLan[oWLS[1?nLanT4oic7icSoW<OY0onMb>X05onL
anWoVlKXoiW4i_nH`nGoVL7UoiZki?nI^^OoT[WTohVdhOn0/n;oNJkPofjU
gOmWVmGoFX_5oeN0]_lmGHco^]7comGRmOoen_koooohoooolooooo_oj^[Z
00?ojn_[00?ok>c/oc4a<Om^KVh00_o/k>`02Om3@d?oC4a<onc/k?o/k>co
Ogmoobh^;_l>3Pko=3@dokJf]P02ong]k@05omSHf?mADE7o3Ph>o`X:2_lS
8b<00_o_knl01OoHf=So@T92o``<3?lJ6Q[o[:b/00Kol?3`00KolO7aojFU
YOlF5QKo`l?3o`000?n_[jl2ooCdm005ogYjN_l71`Oo2`/;oaTI6OnWYjL0
1OoemOD00old=3CoKfm_ooKfmP02ooKfmP;on?Sh00coDE5AohV9ROoinOWo
nOWioe9BD_n8R8SoMWIfoa<C4ol];Bgo`<30oo[jn_oemOD5oaXJ6P05ogMg
Mookno_oo?clooclo?omoOd00_ono_hkooooo`04oa]N/onUa>Ko]M3^ogV^
k0;oYmco00CoKVi^okBd]?oPh>3ok>c/Foo^k^h02OlJ4QCo6PT:odHV5?l/
71Co6Q8Doa4L2_l92@[o4A`:oaX92P02oa4L2P05ob`B0?lA70[o;180oaX9
2_lS70X00_lJ2@X01OlS70[o6PT:ob`B0?lJ2@[o2A8:00;o;18000co4A`:
ob`B0?lm4P[o6PT:ob`B0?lA70[o;180oa4L2_lJ2@[o8a`:oaX92_lS70X2
ob`B0003oaXB5?lS70[o6PT:00;o4A`:00co2@T:oaX92_lA70[o2A8:o`T9
2_m6C3goJW9LocAE?OlA9P[o2@T:oa4V5?l/C2T2ob`h:@0DoaXV5?l92@[o
PhB>oiFQS_nV/l7oCfM7oa4V2_lA9QCo2@TDob<_7_n3V8koY[?1ok2n`Omk
SFKo0000oba<:OlS;ako4BHNofZ=G?l00004o`TB2P06oa4L2_l92ACo6Q8D
o`T95?l94P[o=5DY0_lS@Cd03om6EE;oH79kok2c]ol/EEco/;>go`000?lS
;ako6RHDoa4L2_n3GS?oYXB4ombn]oo]m_GokNgZonC@c002ombn]`OokOKe
0_ofm_D03oofooooi=3<ocAE:On3SHCoUJ6>odIE:OlA9P[o4BHDo`TB2_lA
9QCo2@TDo`TB2_mPGS?o`LO<ol77`@02ojJZ[@0BojJZXoo1al7oYZZ]ok2n
`OnVXISokNgZooKoooo]m_Gom_oool[@`Oo:_ZgokNgZooKooon`_/7o`LO1
ol[@e_o:d<7odmWF0_o]kNX02ooChoGokNgZom?SmOo]m_Godn?eongfmOof
ooookLMLoiEN<on3Q7_ook<000;oi:X000Wom[<0onBZ0?oTZP3oi:X0ooJc
0?oTZP3om[<0om>40?oTZP001?oCQ0001OniI`3odh@0ol640?niI`3odh@0
00;oUED000?oLRH0odHV2_lm70X00_l/4P000olA70[o6PT:oa4L2P02o`T9
2P06oa4L2_lJ2@[o2@T:oa4L2_l92@[o2A8:1?l92@X02_l94P[o2@T:oa4L
2_l94P[o2@T:ob<L2_lm70[oARHDof0_2_mP;a@3og8V000:og8h5?mG703o
LRH0og8V0?mP;aCoLSPDog8V0?mP;aCoH2l:og8V00?oARH:00?oH2l:odHV
2_lm70X00_m69PX02ol/9QCoARH:odHV2_mP@ACoWW8cohf=D_n3Nc?oJVLc
of1N<om6;`[ob]3F05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;o
i^KV00coi>CTomCDe?mlO7cof][JomoOgooQhN7oe=CDolK6a_o<c<coc/k>
om3@d?oCdm<<omGEe@0Cooooi_oooncooookoo[loooSk?ooaMSoociNTOm8
LjSoE8RjoeVC`omSX<coKZWCogNZeon0[=_oRZkPoi6chonA]^?oT[WToiBj
i`02oiFli`06oiFliOnF_NSoUkkWoiFliOnE_>?oUKcU0_nE_><01?nE_N7o
UKcSoiFlhonE_><`oiFli@0?oiFlhonE_>GoUKcSoiFliOnE_>?oUKcUoiFl
honE_>GoU[gToiNnionG_^GoV;oXoiNniOnG_^OoV;gW00;oT[?N013oR[3M
oh2/fomgZM[oKjKLofFMe_mLT/koCh6lodYe[?llGX_o_mOiomk[o?ofnooo
ooohoooom?oooo_oj^[Z0oo[jn/00oo/k>co<C4aofi^KP02onc/k003oc4a
<Om>CTkok>c/00;ok>c/00?okNg]on_[joo]kNd00oo]kNd2onk^kP03ono_
koo/k>cokno_00;okno_0_o`l?000oo]kNgol?3`oo3`l006oo3`l006oo7a
lOo]kNgo5QHFobLW9olK6a_om?Cd0_oemOD00oofm_KoBTY:ofe]K@07ooKf
mP03oc@d=?m`L73omoOg00;on?Sh0ooinOT3oo[jnP;ono_k00?oo?cloo_k
noolo?`02_olo?`2oogmo@03ookno_oooooooooo03_ooooo00Co6enfojC4
i_nhd^koMZgZ0_n/gol01?mZJV[o[Zj^omSHf?oTi>AKonKViP;o8a`:0_l/
71@01olA70[o2A8:o`TB2_l94P[o;1`Doa4L2_lJ2@X00_lS70X04OlJ2@[o
8a`:ob<L2_lA70[o;180oa4L2_l/4P3o6PT:oa4L2_l/4P3o4A`:ob<L2_lJ
2@[o8a`:o`T92_lA70[o2@T:00?o6PT:00So;180ob<L2_lJ2@[o4A`:ob<L
2_lJ2@[o;180oaX92P;o;1800olA70X01?lJ4QCo0000odmWAomGSE`2o`00
0004oa4L2_lJ2@[o4BHDoaXB50;o;4`Y01?o2A8:oiFHXoo1al7oYZZ]ofYk
KolA9P[o8blNob`V5?mbIe;oPiR>oiFQ]onEZZgoY/OPofZ=G?l0003o=5DY
oa4V7_mZLUcoEheL00;o2A8:00?o0000o`TB2_lA70X00_l94PX06ol971Co
2@T:odmWAolA;c?o8blYocAE?OmGGVooPiR]oh>4S_mPLW_oY[?1odIE:OlA
9P[o8blNoaXB5?m6@AkoYW9Bol77`Oo]fLcokNgZonC@c?oL_[Ooi=3<ongf
mOo]kN[okOKeooK]jP03ong]jP;okOKe00SoooooolZn[Om6EBWo`LO1ojJZ
XoldEBWo2A8:oa4V50;o6Q8D00?o4BHDoaXB5?lA70X00_nVZZd2ok2c]`06
ok2n`Oo1alco/;>gol77`On`/kOodn?e0oo]kNX02oo]m_Gog>?FojJZ[Oof
ooookOKeojJQV?o:d=Kob]31omcSh?oChoGokNgZ00KokOKe00GokMW<olZZ
AonVZZ?og;j]ooJc0004onBZ0004om>40?of/`3om[<0om>H2PGoi:X000Co
dh@0okUW0?oCQ03o^FL00_n`C0002OniI`3oNd`DoheE2_nVC03oPbl0oeLL
0?lm70[o4A`:oaX92P02oa4L2P04o`T92_l92ACo2A8:ob<L2P?o2@T:00go
2A8:o`T92_lA70[o2@T:oa4L2_l92@[o4A`:o`T95?l92@[o4A`:oaXB5?l/
4P3oARH:00?oLRH000?oH2l:og8V0?mb9P000_mP;`X02_mb>1CoLRH0og8V
0?mb9P3oLSPDof0_5?mb9P3oH2l:odHV5?mG7002odHV2P06ocdL2_m69P[o
?A`:oeLL0?mP@ACoPehc0_n3Nc<01_mZIc?oH5hcodI17_l/>2Wo0000om?I
eUooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;ok^k^00cok>c/omcL
g?mlO7cofMWIon3Ph?oQhN7oeMGEolS8b?o;bl_oc/k>om3@d?oCdm<<omCD
e00Kooooj?oooNgoooojoo[mooo^n?oob=_oodUYV?lkIYWoAgb`od^7^omH
U<KoHig=offPcomgXm;oPJGGohRYg?n9Z]goRjoQohncionB]^SoTKGWoi6e
iOnA]NOoT[KVoi6eiOnA]^?oTKGU00;oTKKS00?oTKKRoi6fhonA]^<0<OnA
]ND08OnA]^?oTKGUoi6fhonA]NGoTKKSoi6eiOnA]^?oT;CToi2eh_nA]NGo
TKKSoi6eiOn@]N;oSk?Soi6chOn:ZmKoRJ[Eoh2VdomdXm7oK9oDofBKdomG
T/coChO4od=g/OljJ9coA6NAolSQoooZmooon_gooooon_ooooKooookonWY
j@04on[ZjP06oc4a<Ol[:b_oDU9Bob0P8?l;2`_o/k>c1_o[jn/3onc/k0;o
kNg]0oo^k^h:ono_k`?ol?3`0_oalO400omcLg?o0000ogMgM`03ooCdm003
ooGemOoGemOoe]KF00Oom_Kf00?o=3@dog1`L?ogmoL00_ogmoL2ooShn003
oeQHF?n>SXkonOWi00?onOWi2oojn_X2oo_kn`;oo?cl00?ooOgmookno_on
o_h0>oooool01?lMGk?oY/KVokK@k_mi[nh2oj_No`04ofi^K_nd];Coh>3P
onc/k5_ok^k^00Wo;1`Dob<L2_lA70[o8a`:o`T92_l94P[o4A`:o`T92_lA
70X00_lJ2@X02?l/4P3o4A`:ob<L2_lJ2@[o;180oaX92_l94P[o6PT:0_lS
70X02_l/4P3o2@T:ob`B0?lJ2@[o;180ob<L2_l92@[o4A`:ob`B0?lA70X2
ob`B0008oa4L2_l/4P3o8a`:oaX92_l/4P3o2@T:oaX92_l92@X2ob<L2P0:
oa4L2_l/4P3o2A`Doa4L2_mbEE;o?Ehmo`TB2_l92@[o2A8:o`T950;o4A`:
01Ko2A8:oaXL7_l/71Co;5hmol77c?nEXHkoJW]_odI17_ld;akoAT`moh>=
Q?nEZZgoUJ6gok2c]on`_/7og>?PodmWAol0003oAUDYoceN?On3Q7_o?Ehm
0_l94PX07?lA70[o2@TDo`TB2_lA70[o2@TDo`000?l/C2WoAUEBoba<:OlA
9QCoCeiVog^=Q?nV/l7oCfMLojJc`OnEXKOoNheVoa4V5?l/9QCo6Q`Noc@_
:OmP@BWoUHAkongIc?oTd<cokOKeongIc?oLhn03ong]jP03om?SmOo]kN[o
kNgZ00;okNgZ00Wom_KeooKooombIe;oJW]_ok2n`On=V8koEfMBoa4V2_l9
71@00olA9Q@06OlJ4QCo2@T:og^=Q?nVZZ?o`LO1ok2c]on`_/7ob]31ol77
c?o:d<7okNgZomcSh?oCfMKom_ooong]j_o]m_Gom_ooomcSe_nVZZ?om_oe
ojJZ[Oo1al7ob]3Fom?Ie_oLhn000oo]m_D04oofooookOKeooooooofooGo
i;=7oiFZ[Oo]d9Soi:X0ooK72_oTZP3om[<0onBZ0?of/`3odh@0ooK72_oT
ZP3om/LmonBc:Oof/`000_oTZP06om>4000CokUW0?n`C03oPehDoh<_0?n`
C03oPd40og8V0?m69P[o;1`Do`T92_lJ2@[o6Q8Doa4L2_l92@[o6PT:ob<L
2_l92@[o4A`:o`T92P02o`TB2PCo2@T:0ol94PX02?l92@[o8a`:ocdL2_m6
9QCoLRH0of0_2_mP;aCoLRH00_mP;`X01_mb9P3oLSPDoh<_0?mb9P3oH2l:
oh<_00;oH2l:00CoLRH0oeLL0?mG703oH2l:0_m69PX01Olm70[oARHDog8h
5?n3Nc?oSHe700;oPg/c00OoJVLcof1N<old;ako4BHNodHV2_nEE@3ob]3F
05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo00cooOgmonc/
k?mlO7cofMWIon3Ph?oQhN7oeMGEolO7aoo:b/[oc/k>om3@d?oCdm<<omCD
e00Fooonkooono3oooojoognoooeoooob]oloe9cW?lbGXgo>fjSod9j/om>
RL7oFiC;ofJHbomaWLcoOJ?@ohFWeOn2X]?oR:SKohj^hOnA/NCoTK7Roi2`
h@;oTK7R1?nB/^43oi:ch003oi:bhOnB/^?oT[;S02koT[;S2_nB/^406?nA
/N3oSjoNohf]g?n;Zm[oR:SGohNXeOn3Y<ooPJC>ogNPc?m/V/_oI9O>oe^B
bom@R<GoAWjioca_Z?lcGi3oC6jDoloWooodooooo?oooookmoooo_Soooom
onWYj@?oj^[Z00Kojn_[oj:RX_n=SHgoSXj>ojf][OoVi^H4onc/k0KokNg]
0_o^k^h5ono_k`_ol?3`0_oalO400ooJf][oTY:BomgMg@03ooKfmP[omoOg
00?oZj^[ol;2`_ohn?P00_ohn?P2ooWin@03ojn_[oo8b<SonOWi00?onOWi
2oojn_X2oo_kn`;oo?cl00?ooOgmookno_ono_h0>oooool01?lJG;?oY<?U
okSBkomi[^`2ojcOo`04ogIfM_o1`L7ol?3`oogmoE_ooooo01Oo;1`Dob<L
2_lS70[o6Q8Do`T92_lA70[o2@T:oaXB5?l92@[o8bH:ob`B0?lJ2@[o8a`:
oaX92_lS70[o6PT:ob`B0?lA70[o6PT:ob`B0?lJ2@[o8a`:o`T92P02ob<L
2P09oaX92_lS70[o;180oaX92_lS70[o;180o`T92_lS70[o;18000;o6PT:
00?o;1`Dob`B0?lJ2@X00_l/4P02oaX92P03ob<L2_lA70[o;1`D00;oCfM7
00Wo0000oa4L2_lA70[o4A`:oaXB5?lA70[o2A`Doa4V2_lJ4Q@00_lS;ah0
2?n3Q8koPhf4ofYkKon3Q7_oPhB>oiFZ[OnEXKOoUJZ]0_n`/kL01?n`_/7o
dn?eoa4V2_lA9PX2odmWG004ohfHS_l/C2Wo0000oa4L2P;o2@T:013o4A`:
o`T92_l92@[o6Q`NojJQV?lm;cgo;4`Yo`TB2_n3SHCoUIRSoiFZ[OmPLW_o
`LO<ol[@e_l971ko;2HD0_m6@Ah02Omb>1Co=2lYof0_5?oLhmKom^gZooKo
ooo]kN[okMW<onC@c002omcSh00>onC@c?oLhn3oi=3<onC@c?o]fLcog>?P
ooKfmOl0003oPhf4ok2n`OnEZZgo=5Dmoa4L2_l971@2oaXB5008oaXV5?lA
70[o2@T:ohf=Kon`_/7oUIRSok2n`OoLhn02ol[@eP0;om?SmOo:d=Kob]3F
ol[@`OoChoGom_ooongfmOoChoGooooool[@`OnVZZ<00_n`/kL00oo:d<7o
kNgZong]jP02ongfm@Com_oo00Koi<O1ol[@`OoTal7om[<0onBZ0?ofa`X2
ooJc00?oi:X000Koi;<YooK77_oTZP3om[<0onBZ0?oCQ002onBZ00Codh@0
00co^FL0ol640?n`C03oPcP0okUW0?n`E@3oYT`0oh=10?mb9P3o8bH:ob`B
0?lA70X2o`T92P;o4A`:00Co6PT:oa4L2_l94P[o4A`:0_l92@X00ol94P[o
2@T:o`TB2P02o`T92P06oaX92_lJ4QCo2@T:oaX92_l/4P3oARH:1?mb9P00
2_m69P[oLRH0og8V0?n3;`3oLSPDog8V0?mb>1CoLRH0oeLL0?mP;a@2of0_
2P06odHV5?m69P[o?A`:ob<L2_mP@ACoJUDN0_nNNc<2oh=k<`08odIE:OmP
@ACo2A`DocdB2_nNGQCoUED0o`TB2_oChoEOooooo`04ojn_[oo;bl_og]kN
on[ZjP7ol_;b0002onk^kP0<onc/k?oLg=coNg]kom[Jf_oOgmoohN7QomGE
eOo6a/Kob/[:olk>c_o@d=3odm?C3?oDe=@04oooo?SoooScooonnooin_co
mOooon7foomoW[_o:59joce/X_l[HIgo?GBdoenEdomYV];oO:SGohR_e_nC
]M_oU;?Ooi^gi_nM^^H00_nL^ND00onN^nOoWkcVoijki@02oijki@KoW[_S
00?oW[_UoijkionN^nL0;?nN^nL00onN^nGoW[_Soijkh`06oijkh`05oifj
h_nQ_^KoXKkVoijkhonM^^800_nN^n<04onJ^^7oSZoHoig2k?miX]3oNJGF
og>Tg?m;OkWo@GNcocAXXOlPCh?o=En9ofj?/?o]oooomooooo7bm_ooo__o
o?CaoooooOo[jn/00oo]kNd:onk^kPOokno_1_o`l?0;oo7al@?ol_;b0_od
m?@3ooKfmP[omoOg3Oohn?P;ooWin@;on_[j0oolo?`2ooknoS_ooooo00Co
7EncojG4i_nfd^koNJkY0_nZh?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP03
ob`L5?lS70[o8a`:00;o8a`:0olA70X00olS70[o;180ob<L2P02ob<L2P;o
;18000Go6PT:ob<L2_lJ2@[o;180oaX92P02ob`B000<o`T92_lS70[o8a`:
ob<L2_l/4P3o6PT:oa4L2_l/4P3o6PT:ob`B0?lS70[o6PT:0_l/4P001Ol/
9QCo6PT:ob`B0?l/4P3o6PT:00;o8a`:00co;180oa4L2_lS;ako=5DYo`00
0?lJ2@[o4A`:o`T95?lA70[o4BHDoa4L2_lJ2@X2o`TB2P0YoaXV5?ldECgo
8d4moiFZ[Oo1alcoUK?<ojJZXon`/kOoUJ6goiFZ[On`/kOo/;k1ol77c?oC
hoGo0000oa4V2_mkSHCoJW9LojJZXol0003o2A`Do`TB2_lA70[o4BHDoa4L
2_l92@[o6RHDoiFZ[OldECgo?Ehmoa4L2_lm;cgoUIRSojJc`On3V8ko`LO<
ojJc`OnEXHko0000oiFHXonVZZd00_nVXIP2oiF4N`09olZn[OoLhn3om^gZ
onC@c?oLhmKo`LO<omcSh?oCfMKob]3F00?o`LO<00co/;k1ofYkKolA9P[o
AT`mol[@e_nV/l7oUJ6gob<_:OlA9QCo6Q`Noa4L2_lJ9Q@2ob<_7P0=oa4V
5?m6GTOo?EhmoiFQS_o]m_Gob]3Fom?Ie_o]m_Gob]3FoiFZ[OoCfMKob]31
ong]jP03ongfm@06om?SmOo]m_GokNgZojJQV?nVV8CoUJZ]1?o]m_D4ooKo
o`07ol77c?oLhmKom/LNooJc0?oTZP3om[<0onBZ0002ooJc00;oi:X000?o
m[<0ooK77_oTZP000_oTZP000ooCQ03oi:X0om>40006om>40003okUW0?nV
C03o^FL000;o/5D000GoYT`0oh<h0?lm70[o8a`:oaX92P02oa4L2P03o`T9
2_lJ2@[o8a`:00;o2@T:00?o2A8:o`T92_lA70X00_l94PX03Ol92@[o2A8:
oa4L2_l92ACo2A8:oa4L2_lJ4QCo8a`:oeLL0?mP;`[oEa`0of0_2_mP;a@0
0_mb9P007?mb>1CoLRH0og8h5?n3;`3oH2lDog8V0?mP;`[oEa`0of0_5?m6
9P[oEa`0odHV2_m69QCoWW8DojJ4D_n=SE;oPg/cog:=?OmZEAkoAUDYo`TL
5?lJ4QCoSED:oiib2_lA9QCo2A8:o`000?oChoEOonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q0002onKViP0<onCTi?oDe=CoMgMgom[Jf_oPh>3ohN7Q
omCDe?o7alOoc<c<olo?coo@d=3odm?C3?oFe]H04ooomo_ooocmooonnooo
oogom_oooo7ooonU`=?o8dMYob5:O_lRDY3o@G:eoden`?mfYMgoTkk[oig3
ionH^m_oYlGYojg9k_n`cNl00_n^bnd00on`cNoo/<g]ojo<k002ok;?k`Ko
//o]00?o//o_ok;?lOnbco401Onbco4Hojo<kPoo//oa00?o//o_ok;?kOnb
cnd01_nbcnd06_n^bnWo/Lk/ok7>k?n^bnWo[L[Xojo<j_n^bnWoZ/SZojW;
lOnG_>KoUl3^oiS3m_mQT<So@W>]odUj/_lQD8Co<ej;obA8K?n^bNCoi_Wo
ooGnooonoooooOOgooomnooooogojNWY1_oZj^X7on_[j`?ok>c/0oo]kNd0
0oo_knook^k^oo3`l002oo3`l0;olO7a2oobl_84oo?cl`Com?Cd2_oemOD3
ooKfmP;omoOg0_oinOT01?ohn?Son_[joo[jn_ojn_X2oo_kn`goo?cl0_om
oOd00oono_koooooooooo`0kooooo`04oa]N/onVa^Ko^M?^ogV^j`;oZmoo
00CoJVYZojj^[_oHf=Soi>CTFooVi^H2ob<L2P0:oaX92_lA70[o6PT:ob<_
:Ol92@[o;1`Dob<L2_l/4P3o=2lcob`B00;o8a`:00co6PT:ob`B0?lJ2@[o
;180ob<L2_l/4P3o6PT:ob<L2_l94P[o;180ob<L2_l/4P02oaX92P03ob`B
0?lA70[o6PT:00;o6PT:00Co;180ob<L2_lJ2@[o;1800_lJ2@X01?lS70[o
6PT:ob`B0?l92@X2oa4L2P03oaX92_lJ9QCo4A`:00;o4A`:013o6Q8DoaXV
5?lJ4QCo4A`:oa4V5?lA70[o4BHNob<_:OmGIe;oAUi7ob=1?Ol/C2WoH79k
ojJc`OnEXKOoUJZ]0_mZNh@02_nEXKOo`LO<ongfmOl0003o8blNoiF4S_mZ
NfooUJZ]o`000?lA9PX2o`TB2P0Co`T95?l94P[o0000ohfHS_mbSHCoSHe_
oaXV5?l0003oJW^4ojJc`OoCfMKoPhB>ok2n`Oo1alco;5hmoaXB5?o1alco
/;k1ojK7h002ol77c003ol[@e_mkSHCoLW9k00;oJW^400?oH79koh>H]ooC
hoD00_nVan002?nE/lcoPiRgoiFcc?mbSJgoPiRgoh>H[Oo1alcoY/OP0_oC
hoD01?mPLW_o4BH:ob<_:OlA70X2ob`h:@0GodIE:Old;bWo8a`:o`T92_mb
LW_okOKeom?SmOoCfMKokOKeobaN?OmZLUco`LO1ol77c?oLhn3okNgZongf
mOofooookNgZom?Ie_o]m_Gog>?FoiF4NonEXHh00oo]m_D2ooKoo`;ooooo
00Godn?eongIc?o]aecom/LNooK72P03ooJc0003onBZ0?of/`3om[<000;o
i:X00_of/`02onBZ0003ooJc0?oCQ03oi:X000Oodh@001;o^FL0ol640?o1
Q03o`H@0ok1b0?nVC03oEa`0ob<V2_lJ2@[o4A`:oaX92_lA70[o2@T:ob`B
0?lA70[o2A8:o`T92_l94PX3o`T92P08oa4L2_l92@[o2@T:o`T92_l94P[o
2@T:oaX92_l/4P02odHV2P03of0_2_mb>1CoLRH000?oLRH000CoPbl0of0_
2_mb9P3oLRH00_mP;`X05Om69P[oEa`0ocdL2_m69QCoLSPDoij=<on3Nc?o
JVLcoiib5?mZIc?oAT4Nob`V5?lJ71koPcP0oiib2_mP@ACo2A8:oaXB5?lJ
2@[o0000ongfm@1OonKViP04oifMWOng]kOob<S8om?Cd`7of][J0002onk^
kP04onc/k?oLg=coMWIfomWIf@;ogmoO00Koe=CDolO7aoo:b/[oc/k>om3@
d?oCdm<<omOGe`0Eoookooooo?oooockoooon_ocn_;omOooonCjoom`SZSo
:4Yhob9:QOlZEYOoDGflohB_i_nKa?3oV/7Roj_?jOn/b^Co/loWokKBj?nd
d>Ko/loU00;o]M7W00?o/loUokGAi_nedNH01_ned^@8okGAiQSo]=3U4?ne
dNH8okGBi00JokCAhonfdnGo]]?UokCAhoncd>;o]=7Sok?@h_n]cNCoZloc
oj37l_nD_N_oUl7cohF`iom;MZgo8T]oob5:N?lM@6KoJXVVonCjooodoooo
l?OoooonoooooOoono;cooonoooXj>P6on[ZjP[ojn_[0oo/k>`2ong]k@?o
k^k^2_o_knl3oo3`l0?olO7a00?ol_;boo7alOobl_800_obl_82oo?cl`So
m?Cd0ooemOD2ooKfmP?on?Sh0oojn_X2oo_kn`goo?cl0_omoOd00oono_ko
ooooooooo`0kooooo`04oamQ]?nS`^Co^=?_ogN^j`;oZ]oo00CoKVi^okBd
]?oPh>3ok>c/Foo^k^h3ob<L2P03oaX92_l/4P3o;18000Go8a`:0_lJ2@X2
ob<L2P03ob`B0?lJ2@[o8a`:00;o8a`:00?o4A`:ob`B0?lA70X00_l/4P00
0olS70[o;180oaX92P02ob`B0006oaX92_lS70[o;180oaXB5?l/4P3o6Q8D
0_lJ2@X01olS70[o6PT:ob`B0?lS70[o2A8:ob`B0?lJ2@X00_lA70X07olJ
71ko2@T:oa4L2_lJ4QCo6RHDoa4V2_lA9QCo;1`Dob<_:OmPGS?o=5Dmob<_
:OlS;ako0000o`TL5?o:d=KoPhB>odIED_l/C2Wo;3PYodINAonV/l7ob]3F
ol[@`Ol0003oAT`moiFHXon3V:goUJ6>o`000?l94PX00_l92A@04_lA70[o
2@T:oaXB5?n`/kOoCfMLodINAolS;ako6Q`Nog9bNonVan3ob]3Fok2n`OnE
V:?og>?Po`000?nEV:?o/;k1ojJc`@;ob]3F00[o`LO<ongfmOlA;cgo4Blc
o`TV:OlJ71ko;5E_odmbNooChoGom_oo0_nVan02oiFcc003oiFQ]onE/lco
Y/OP00;oUK?<0_nVan001OoChoGoPhB>oceN?Ol/9QCo=2lN00;o;3PY00ko
AUEBojJQV?nVXISoUIRSojK7h?o:d=Kog>?PoeN=S_lA9P[o4A`:ok2c]on`
_/7og>?Pom?Sm@?okOKe01;og>?Pom?SmOoooooob]31oiF4Noo:d=Kom_oo
ongfmOoChoGom_oool[@e_o1alcom_ooooJc0?ood03okKhmooK72_oTZP02
ooJc0005onBZ0?of/`3oi:X0onBZ0?oCQ0000_oTZP001oof/`3oi:X0om>4
0?oTZP3odh@0onBZ0?oCQ0000_oTZP02om>4000:onBZ0?oCQ03odh@0om>4
0?o1Q03o/5D0ojI<0?mZ@@[o?A`:ob<L2P;o6PT:00[o2@T:oa4L2_lJ2@[o
6Q8Do`T92_lA70[o2A8:oaX92_l92@[o4A`:0_l92@X01olA70[o2A8:o`T9
2_l92@[o4A`:oaX92_lm4PX00_n3;`04og8V000:oh<_0?mb>1CoPbl0of0_
2_mb9P3oARH:of0_2_lm4P[o;180og8h00;oWXdc013oPg/coij=:OmZIc?o
AUDYob<_:OlJ4QCoPbl0ojIW0?mP@ACo6RHDo`TB2_l92ACo4A`:o`T92_l0
003odn?eGoo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool03?om
oOgokNg]og9bL_oGemOogmoOon3Ph?oBd];oalO7ol[:b_o<c<cod=3@om?C
d`coe=CD01?ooocoookioooln?OoooojooOjlOohoocom?ooomcaoom1GH;o
439Roa/oNOlnIJ3oFX:foj;9m?nOa^OoY/[TojW9h?n_c^;o/m;V00;o/M3T
0_nbdND00on_c^3o/<oQok3@g`0>ok3@gaSo/M7P6?n`d=l00onbd^7o]=CS
okCDh`02ok;Bh@0Eok?Ch_nadN3oZLcPojC:k_nScOOoZ]?ooh^ci_mLQ;So
@VNKobM9MolB<UWoAV>1on_oooo^o_oolokooocooooknOcooo_ooooloooo
o_oojNWY00?oj^[Z0oo[jn/7onc/k0KokNg]00?ok^k^ono_koo`l?001?o`
l?0;oo7al@?ol_;b0_oclo<3ooCdm0[omOGe1Oofm_H2ooOgm`03ooKfm_og
moOomoOg00?omoOg2oohn?P2ooWin@?ono_k0_omoOdAooknoR[ooooo00Co
7f2dojG4i_nidnooMjk[0_nYg?l01?mfMWKo`L71oo3`l?omoOeKooooo`05
ob<L2_l/71Co8a`:ob<L2_lA70X00_lS70X2ob`L50?o8a`:02oo;180oaX9
2_lA70[o8a`:ob`B0?lJ2@[o8a`:ob`B0?lJ2@[o;180oaX92_lA70[o6PT:
ob`B0?lS9P[o;180oaX92_lA70[o8a`:ob`V5?l92@[o6PT:ob<L2_l/4P3o
6PT:ob`B0?l92@[o6PT:ob<L2_lJ2@[o8a`:oaX92_lA70[o6PT:oa4L2_l/
4P3o4A`:o`T92_lS;bWo=5DYo`T92_lJ4QCo=5DYoceN?OlJ71ko4BH:oaXL
7P02ob<_:@0Roc@_<on3V8ko`LO<oh=kG?lA9P[oAUEBoh>4S_o1alcodn?e
og^=Q?lA9P[oCfMLojJZXon`_/7oJXeLo`000?lA9P[o2A`DoaXB5?l94P[o
0000oiFQS_lS;bWoPhf4odIE:Om6C3go;3PYol77c?o:d=KoPhB>ojJc`Oo1
alcoSIR>o`0000?o`LO<00cob]3FojK7h?oLhn3odmWFo`U1AolS@Cgo4Blc
ob<_<om6EE;o=6MkojK7h?ofool3ojK7h006oiFcc?nVan3oUK?<ojJc`OnV
an3oUJ6g0_nVan03om?Sm@0@ocAWNomZLUcoPhB>og9bNomPGS?oLXf4oiFZ
[OnVZZ?o`LO<ol[@e_o1al7oSIR>odIE:Ol0003oSIR>ok2n`@Cog>?P0oo]
m_D3ong]jP08oh>4Noofoooom_ooongfmOofooooUIRSojJZ[OoT/dL2ooJc
0003ooK7?Oof/`3om[<000Kom[<000?oi:X0ooK72_of/`002?oTZP004oof
/`3odiP:onBZ0?oCQ03oi:X0om>40?oCV0[odh@0ol640?n`E@3oLSP0odH_
2_lS70[o4A`:oaX92_lA70[o2A8:oa4L2_lJ2@X00_l92@X01Ol94P[o0000
o`T92_lJ71ko2A8:00;o2@T:00Wo2A8:oa4L2_l94P[o2@T:of0_5?n3;`3o
LRH0og8h5?mP;`X00_mb9P003?mb>1CoLRH0og8V0?mb9P3oLSPDodHV5?mP
;`[oARHDog]<2_n`Q2WobZ4mohf=A`;oPg/c00ooH44Yoba<:OlJ4QCoPbl0
ok1k5?nEEACo2A`Do`T95?l92@[o2A8:oaX92_l94P[o8a`:o`000?o]m_D0
Goooool01?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h01?o/k>cogmoO
og5aLOo?cll2omgMg@06om7AdOo4a<Cob<S8ol_;boo?clood];B3?oDe=@0
4_oooOoon_Smooonooooo__ooookoo[lnOo]m?[om?ooonkooolQ>f3o9DAb
oc9DQ?mSR;GoOjC@oi2cfOnE^M_oW;kJoj;4g@?oY/SQ00?oZ<[SojO9h_nU
b=h00onYc>8=ojW<h1SoYl[N6?nYc>000onWb]koZLcPojS;g`02ojO:gP0E
ojS;gonUb=coW/;Loic4j?nE_^[oS;GSog>Ib_m>Kj;o83m^oa@_F_lkDgGo
io_oonOgooogoooonoooong^l?ooo_oooocooookooooo_ooinOW00KojNWY
2_oZj^X3on_[j`03onc/k?o]kNgok^k^00;ok^k^2_o_knl3oo3`l0?olO7a
0_obl_83oo?cl`;om?Cd2?oemOD5ooKfmP;on?Sh00?omoOgooWinOoinOT0
0ooinOT;oo[jnP;ono_k0oolo?`2oogmoA7oo_kn:_ooool01?lKGkKoY<CV
okWCkomf[NX2oj_Po`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00?o6RHDob`L
5?lm70X00_lS70X02OlJ2@[o8a`:ob<L2_l/4P3o8a`:ocdB2_lS70[o;180
ob<L2P02ob`B0004oaX92_lS70[o;180oa4L2P;o;18000Ko2@T:ob`B0?l/
4P3o8a`:ob`B0?lS70X2ob`B0007oaX92_lS70[o8a`:ob`B0?lJ2@[o;180
oa4L2P02oaX92P0Moa4L2_l/4P3o6PT:ob<L2_l/4P3o6PT:oa4L2_lJ2@[o
4A`:oaX92_l94P[o6Q`NoaXV5?lJ4QCo4BHDoaXB5?lJ9QCo2@TDo`TL5?lA
9P[o;3PYob<_7_lA9QCo2A`Dol77`OmkSFKo8blNoh>=Q?nEV:<00_o:d=H2
oa4V2P04oh>4S_n`_/7o`LO<oaXV50;o2A8:01?o2@TDoaX92_l92@[o8d4m
ohfHS_m?GVKoJXeLob=1?Om6C3goJW^4ongfmOn3Q8ko/;k1oiFZ[OnVZZ?o
6RHDofYkKoo:d=Ko`LO<00;ob]3F00go`LO<omcSh?nEXKOo4DaBoba<:OlS
;c?o8blYob=1D_lm;cgoY/OPooKooooChoGoUK?<00;oY/OP00KoUK?<ojK7
h?nVan3oUJ6goh>H]onE/l`3ojK7h009om?SmOlAC5;oLXf]ol77c?nVan3o
Ehf>obaN?OmZLUco/;k100;odmWF01;ob]3Fok2c]omkSHCo4BH:ob<_7_nV
XISob]3FomcSe_oLhn3okNgZom?SmOo]m_Gom_oool[@e_o]kN[odn?eomcS
h?nVQ8@2ooooo`04ooKooon3SHCog>?Poonc00;om[<000Coom0mooK72_oT
/bWoi:X00_of/`001Oofa`[oi:X0onBZ0?oCQ03om/L:00;oi:X00_of/`02
onBZ0005ooJc0?oTZP3oi:X0onBZ0?of/`001?oTZP02om>40005ol640?n`
LP3oPd40oeLL0?lS9PX00olJ2@X01_lA70[o6PT:oaX92_lA70[o2@T:o`TB
2P;o4A`:0_l92@X02Ol92ACo4A`:o`T92_l92ACo?A8:oh<_0?mb9P3oPbl0
og8V0002og8h50;oLRH000?oH2l:oh<_0?mP;`X00_mP;`X01OmG703oH2l:
oiEE5?n`SE;oUHeB00;oPg/c00goPehDob`V5?lJ9QCoPbl0ok1E0?n3GQCo
4BH:o`T92_l94P[o6Q8Doa4L2_lJ2@[o6Q8D00;o8a`:00?o6PT:ongfmOo^
k^h0G_o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H02_oUiNGo
fMWIogQhN?no_koof=SHom[Jf_o<c<co`L71olG5aOo:b/X2olk>cPcoe=CD
00Coo_ooooooooooo_oon?Cc0_oooOl03oo/jo7onOooon3]ooo^oooo<DaZ
oaXhG?l/CGKoDGBNog^Mb_n;[]SoQj[@ohfaeOnC]]coU;SLoiJig`02oiRl
h006oiJjg?nI_MooVKgOoiVmgonI_MgoVKgO0_nI_Md9oiVnfaSoV;gJ3onI
_]/3oiVmg@0PoiVmgonI_MgoVKgOoiVmgOnI_MooVKgMoiJjg?nG^m_oU[[L
oiFifOnF^]coUk_Koi:ff?n9[m?oMj79ohfhhom[TL3o@FFEobe;OOl=:5Go
DfV@oo3oooodoooon?oooo_oooo[kN[oooomooonooo_j?3ooocoooonoooW
inL6onWYj@[oj^[Z1?o[jn/4onc/k0[okNg]1_o^k^h00oo`l?3okno_oo7a
l@04oo7al@Sol_;b0ooclo<2ooCdm0;omOGe00Com_KfooOgmoogmoOomoOg
0_ohn?P;ooWin@;on_[j0ookno/2ooclo13ooOgm0oono_hXooooo`04oa]N
/onUa>Ko]M3^ogV^k0;oYmco00CoJVYZojj^[_oHf=Soi>CTFooVi^H01Olm
70[o8bH:ob<V2_lm70[o8a`:00;o;18000?o6PT:ocdL2_lJ2@X00_l/4P00
6_lS70[o;180ob<L2_lJ2@[o8a`:oaX92_lS70[o;180oaX92_lS70[o2A8:
ob`B0?lS70[o;180ob<L2_l/4P3o8a`:oaX92_l/4P3o6PT:ob`B0?lJ2@[o
;180oaX92_l/4P3o6PT:0_l/4P002?lS70[o6PT:oaX92_lJ2@[o;180oa4L
2_l94P[o2@T:0_lA70X01OlA9P[o4A`:o`TB2_lA9QCo2A8:00;o4A`:013o
6PT:oa4V7_lJ71ko4A`:o`T92_l/>2WoSIR>oa4L2_l/GSgoYZZ]oiFQ]oof
oooo;4`Yoa4V2_m6C3goSIR>0_o1al`05?lA9P[o2A`Doa4L2_lA9QCo2@T:
o`TL5?nVV8CoH79koh>HS_m6GTOo;2HDodmNI_mZNhCokOKeojJZ[On3V:go
`LO1ob<_7_l0003o`LO<0oo:d=H03_nVan3ob]3FooKfmOmGSHko4Blcob=1
?OlA;cgo?Blmob=1D_l/EEcoPiRgom?SmOofooooUK?<1OnVan005onE/lco
LXf]oiFcc?nE/lcoY/OPom?SmOnVan3o6Q`NoiFcc?oChoGoUK?<o`TL5?l9
9RWo=2lcok2n`Oo1alcob]3Fol77c?oCfMKo`LO1odIE:Ol94P[o8blN00;o
b]3F00?og>?Pom?SmOo]kNX00oo]m_D2om?IeP0@ongfmOoLhmKo/;>gooKo
oonVan3oSIR>ofYkKoood3goUHABoiF4Non=SFooUHAkol[@e_of/`3om/L:
onBZ00?om[<000Codh@0ooK77_of/`3oi:X01?of/`001oofa`[oi:X0ooJc
0?oTZP3om[<0onBZ0?of/`000ooTZP02om>40004okUW0?n3;`3oARH:ob`B
00;o4A`:00Co2@T:oa4L2_lJ2@[o;1800_lA70X4o`T92P05o`TB2_lA70[o
2@T:o`T92_lm4PX00omb9P001On3;`3oLRH0og8V0?mb9P3oH2l:00?oLRH0
01_oARHDof0_2_m69QCoWUhDoij=<onEQ5;oPg/cofYE7_n3GQCoJUDNob<_
7_m69P[o/5D0oh=N5?l/9QCo0000o`T92_lJ2@[o2@TDoa4L2_lJ2@[o6Q8D
ob`B0?lS70[o?A`:o`000?oChoD0GooVi^H01?nMWIgo]kNgolS8b?oCdm<1
om[JfP000_o^k^h03?o]kNgoiNGUoi6ATOnTY:Cod];BomCDe?o2`/;o^;Rh
ol30`?o4a<CobLW9ol_;b`cod=3@01Ooo?omookoooooo_oonO?gooojoooo
nooooocoooknooohooookOgoongooomROYKo:TQZoaDfHOl_Ch3o?5fBoeMj
/?mMP[OoI8W0ofN<`OmZSlKoKI;7ofjCb004ofbAa@04ofbB`om/TLGoK9;3
ofbB``WoK9;16?m]Tl8@ofbB`@;oK9;3023oK975ofbB`om/TLGoK9;3ofbA
aOm/T/?oK975offCa?m/TLGoJi72offBa_m]TlCoJ8g1oej6]omDOj[o<ej9
oa8hIolC=FGo9T9aogR=^?oQlOoolOgoonWao?okooooo_okoo_jmOooo__o
oOOiooolooolmokoookoon?Sh`?oiNGU2_oVi^H7onOWi`Koj>SX2ooYjNT3
on[ZjP03onc/k?o[jn_okNg]00;okNg]2_o^k^h7ono_k`Kol?3`2?oalO43
oo;blP;olo?c0ooemOD2ooOgm`?on?Sh2_oinOT3oo[jnP?oo?cl0_ono_hV
ooooo`04oa]O]_nTa>Ko^=;^ogJ]jP;o[=oo00CoKVi^okBd]?oPh>3ok>c/
Foo^k^h04olS9P[o;1`Dob<L2_l/71Co;180ob<L2_lA70[o?A8:ob`B0?lS
9P[o8a`:ob`L5?lS70[o4A`:ob`B0?lJ9QCo8a`:ob`B0?lJ2@X00_lS70X0
0ol/4P3o6PT:ob<V2P02ob`B00;o8a`:00Oo;180ob<L2_l/4P3o6PT:ob`B
0?lS70[o;18000;o8a`:00Co4A`:oaX92_lJ4QCo6PT:0_l/4P001?lJ2@[o
6Q8Dob`B0?l94PX2oa4L2P;o6PT:01Wo4A`:oaXB5?l92ACo6Q8Doa4V5?l9
2ACo6RHDo`TL5?lJ9QCo2@TDo`000?m?GVKoLUEBob`V5?n3Q8ko/;>gol77
c?o:d=Ko0000oaXV5?m?GVKoUJZ]ol77c?nVZZ?o000000;o2A`D01[o0000
ob<_<onVZZ?oCfM7ojJZ[Om6GTOo8blNoba<:OnEV:?o/;k1ol77c?n3V8ko
SIR>ohf=Kol0003oAT`mom?SmOo1alcog>?Pol[@e_o1al7odmWFooKooold
Ig_o8d4mo`TV:@;o8blc00Oo8d4mob=1D_mbSJgodn?eooKooooChoGoUK?<
00?oY/OP02Cob]3FoiFcc?mbSJgoPiRgoiFcc?oChoGoY/OPocAWNol/EEco
Y/OPooKooonVan3o4DaBob=1?Ol94P[oLW9kol77c?n`_/7og>?Pol77c?oL
hn3oUJ6>o`TL7_l0003oYZZ]ol[@e_oCfMKog>?Pom?SmOo]m_Gom_ooong]
j_oLhn3odmWFol[@`Oooool2ojJZX`0=odIWG?mPGS?oH44YoiF4Non=SFoo
UJ6>oij4I_mZIc?o`LO<oonc0?ofacgoi:X0ooK72P02ooJc00;oi:X00_of
/`000ooT/akom/L:ooK72P03ooJc0007ooK72_of/`3om[<0onBZ0?of/`3o
i:X0ooJc0002onBZ000=om>40?o1Q03oUED0odH_2_lm70[o;180oa4L2_lJ
2@[o2@T:oa4V2_lJ2@[o8bH:o`TB2P03o`T92P06oa4L2_l0003o2A8:o`T9
2_lJ2@[oH2lD0_mb9P000omb>1CoLRH0og8V0003og8V0005oh<_0?mP;`[o
ARH:og8h0?mkC0X00_nNSC<04?nNNc?oPg/coh=N5?mZEAko;4`YoaXB5?mG
703oWUhDoa4V2_l92@[o2@TDoaX92_l92@[o4BHNob<L2_lJ2@X2ob`B0005
ob<V2_l/71Co8a`:ob`B0?o]m_D0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@000oooool01Oojn_[odm?CohN7Qon/[:co_;bl00;o[Zj^00Co][Jf
okbl_?no_kooa<C43?o9bLT06?ohooSoo?omoogko?ooo?oooo_oookdoooo
nooon_OoooWoooobooook_ooon[ooooVooooaNGoodIUVolTA7oo3C5_oa<i
N?lK@H3o7dF4ob=9R?lWCHco:4j<obM=R`Ko:E2;0_lYD8T8obU@QaSo9dj5
4?lYD8L9obU@R`0IobYAS?lYD8_o:4n:obYAS?l[DXgo9Db7oa]4N_l@>V[o
5d9]odidXoo4i?ooioooon3coooaoooomOoooo_oooohn_Oonocfoooon?of
lNgooocnoooloooonOooookoomoOg`06on7Qh@[oh^;R0ooShn<2onCTi0?o
iNGU2_oVi^H6onOWi`;oj>SX1OoYjNT;on[ZjP;ojn_[0_o/k>`01?o]kNgo
k^k^onk^k_o^k^h:ono_k`Gol?3`0ooalO45oo;blPSolo?c0_odm?@3ooGe
m@?om_Kf0_ogmoL3ooShn0[onOWi0oojn_X3ooclo0;oo_kn4Oooool01?lM
Gk?oY/KVokK@k_mi[nh2oj_No`04ogIfM_o1`L7ol?3`oogmoE_ooooo1?lS
70X04ol/4P3o8a`:ob<L2_l/4P3o;2HDob`B0?lS70[o;180ob<L2_l/4P3o
8a`:ob`B0?lS70[o6PT:ob`B0?lS70[o6PT:ob`B0?l94PX00olS70X02_lm
4P[o;180ob<V2_l/4P3o8a`:ob`B0?lS70[o;180ob<L2_l/4P02oaX92P08
ob<L2_l/4P3o;180ob<L2_lJ2@[o8a`:ob`B0?lS70X2o`T92P04oaX92_lA
70[o2@T:oaX92P;o4A`:03Oo6Q8Doa4V5?lJ4QCo2A8:oaXB5?l971Co4BHD
o`T92_l/C2WoAT`modIED_nEV:?o`LO<om?SmOlmGSgo4BH:ob<_7_mZNfoo
/;k1ol77c?mbSCgo0000o`TL5?lJ4QCo2A8:ofYbG?mkSFKoEfMBoiFZ[Omk
SFKoAUDYofYbG?o:d=Ko`LO<ojJZ[OmkSHCoYZZSoa4V2_l99RWo/;>gol77
c?o:d=KodmWFok2c]oo:d=Kog>?Pom?SmOl/Ieco8d4mocd_?OlA;c?o8blc
ob=1?Olm;cgoCg9k00;odn?e00?om_oooiFcc?nVan000onVan004OnE/lco
LXf]oh>H]onV/l7odn?eog:=[OlA9QkoEei_ojK7h?oChoGoY/OPocAWNolm
LXCo4BHNocAE:On`/kOob]3F00;o`LO<0_o:d=H01OmPGS?o4BH:oeMWD_o:
d=KodmWF00;og>?P0_o]m_D03?o]kN[o`LO<omcSh?oLhn3odmWFooKomOoT
d<coSHe7of1N<omZIc?oWXAVoiFHIP;o/:Z400GoJW9Lom?Ie_of/`3om/LN
ooK72P03ooJc0007om>H2_ofaakom[<0onBc7_ofa`[om/LNooK7?@03ooK7
2P03ooJc0?ofa`[om[<000?om[<00ooTZP02om>40003oiEE0?mG703o?A`:
00;o4A`:00Oo6Q8Do`TB2_lJ2@[o;180ob`V5?lJ4QCo4A`:00?o2@T:00Ko
4A`:o`T92_l92@[o;180of0_2_n3;`03og8V0008og8h5?mb9P3oLRH0og8h
5?mP;`[oH2lDoh<_0?n`SC<2oij=<`;oPg/c00goJT4:odI17_lJ4QCo?A`:
oh=10?mZ@@[o0000oaXB5?l94P[o4A`:o`T92_lS70[o;18000Co8a`:00Go
;1`DodHV5?lS70[o;180om?Sm@1Oooooo`04ojn_[oo;bl_og]kNon[ZjP7o
l_;b0003onk^kP0;onc/k?oShn?oZj^[ogEeMOn0P83oShn?oibLW?nUYJGo
[:b/ok6a/Ong]kL03_nk^k/3okbl_0?o_Kfm00?o_[jnokfm_Onn_[h00_nn
_[h2okno_`_o`<300_o1`L42ol;2`P04ol?3`oo4a<Coa<C4olC4a0[oaLG5
1Oo6a/H2olO7a`03olK6a_o7alOoalO700?oalO73Oo8b<P00oo9bLWob/[:
ol[:bP0?ol_;b`?oc<c<00?ocLg=olc<c?o<c<`00_o=cLd;olk>cP;oclo?
0oo@d=000ooAdM7od];Bom?Cd`02om?Cd`?oe=CD1ooEeMD6omKFeP;oemOG
1OoHf=P;omWIf@?of][J0_oKfm/3omcLg0[ogMgM1OoNg]h2omoOg`03omkN
g_oOgmoogmoO00?ogmoO2?oPh>03on7Qh@;oh^;R0_oTi>@00ooUiNGoinOW
onOWi`03onSXj0[ojNWY0ooZj^X3onc/k0;ok^k^2oo_knl2oo3`l0?olO7a
00?ol_;boo7alOoalO400_obl_83oo?cl`kom?Cd00Co6E^bojC3iOnhd^oo
NJk/0_n/gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP04ob<L2_lS9P[o?A`:
ocdL2P?o8a`:00Co2@T:ob`B0?lS70[o?A`:0olS70X01_l/4P3o8a`:oaXL
7_lS70[o;180ob<V2P;o8a`:00Oo2@T:ob`B0?lS70[o;180ob<V2_lJ2@[o
;18000;o8a`:00oo;180o`T92_lS70[o;180ob<L2_lJ2@[o8a`:ob`B0?lJ
2@[o;1`Doa4L2_l/4P3o6PT:ob`B0?lS70X00_lA70X01?l92@[o4A`:oa4L
2_lJ2@X2oa4L2P04o`TB2_lJ4QCo2A8:oa4L2P;o2A8:00ko6Q8Do`T92_lm
GSgoAT`mog^=Q?nEXKOob]3Foh>HS_lA9P[o4BHNocAE:OmZNhCob]3Fok2c
]`;o4BH:0_l94PX07ol/>2WoJW]_oc@_<on`/kOoNhf4odINAomGSEcoUJZ]
ol[@e_o1al7oPhB>oiFZ[Ol/C2Wo0000ok2c]onVZZgo`LO<ol[@e_n`_/7o
Y[?1om?Ie_oChoGob]3Foa4_?OlS@Cgo4Blcob<_:OlA;c?o8d5BobaEG?mG
GVl00_oChoD00oofooooY/OPojK7h004ojK7h00Hog:=[On3V;Oo/;k1om?S
mOl/EFoo;3PYog:=[OoChoGom_oooiFcc?mbSJgoPiRgo`TL7_lA9QCoLW9k
ok2c]ooLhn3odmWFojJc`OoLhn3oUJZ]odmWAol0003o`LO10_oCfMH02ooL
hn3okOKeooKoooo]kN[o/;k1omcSe_ofm_Gob]3FomcSh?ofoooo`K>]00;o
UHeB00SoUJ6>ol6cS_o1al7oLXdmoh=N<ooTd<com[<0ooK72P?om[<000?o
om00onBZ0?ofa`X00_ofa`X01?oofBWom/LNooK7?Oofa`X2ooK7?@;om/L:
00Koom00ooK72_ofaakom[<0onBc7_of/`02onBZ000<om>40?nEE@3oH2l:
odHV2_lJ2@[o8a`:o`TB2_lA70[o6PT:ob`L5?m69P[o8bH:0_lA70X01ol9
4P[o4A`:o`T92_l94P[o4A`:ob`B0?mb>1@01Omb9P002?mP;aCoH2l:of0_
2_mb9P3oWW8Dok2=<onEQ5;oPg/c0_mZEAh02?m6@Ako8blNob<L2_mP;`[o
JT4:o`TB2_l92@[o2A8:0olJ2@X02?lS70[o6PT:ob`B0?l/71Co8a`:ocdL
2_lS70[o;2HD0_lm70X00ol/4P3okOKeonk^kP1Nonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q0004onKViP0:on?ShooIfMWo/[:boginO_m_KfooN7Qh
oh^;RonBTY;oVIVIoj6QX@koYZJV1_nWYjL00onXZ:SoZJVYojZZZP04ojZZ
ZPSoZj^[0on/[:`2ojf][@;o[Zj^00Co[Jf]ojj^[_n^[Zko[Zj^0_n_[jl=
ok2`/0;o/K6a00?o/[:bok>c/onc/k<02onc/k<2okBd]0?o]KFe00?o][Jf
okFe]One]KD00_nf][H3okNg]`[o^;Rh0oni^KT00onj^[[o^k^kok^k^`02
okbl_0_o_Kfm1Onn_[h00oo0`<3o_knool71`@05ol71`@[o`/;21?o3`l<4
olC4a0[oaLG51_o6a/H00oo7alOoa/K6olO7a`04olO7a`Sob<S80oo9bLT2
ol[:bP?oc<c<0oo>c/h2olo?c`_od=3@0_oAdM43om;BdP;odm?C2ooDe=@5
omGEe@?oemOG1OoIfMT8om[JfP;ofm_K0ooLg=`3omgMg@;og]kN0ooOgml>
on3Ph004oaYL[onUa>Ko]];^ogV^j@;oZ^3o00CoJVYZojj^[_oHf=Soi>CT
FooVi^H01?m69QCo;1`Dob<L2_ld;ah2ob`B0003ob<L2_lA70[o8a`:00;o
8a`:0_lm4PX03?lS9P[o;1`Dob`B0?lJ4QCo;180ob<L2_lJ2@[o8a`:oaX9
2_l/4P3o8a`:ocdL2P?o8a`:00Oo;180oaXB5?l/4P3o8a`:ob`L5?l/4P3o
;1`D00;o;1800_lJ2@X01?l/4P3o6PT:ob<L2_l/4P03ob<L2P04oaX92_lA
70[o2@TDoa4L2P;o2@T:01Go4A`:oaX92_lA70[o6PT:oaXB5?l92@[o6Q8D
o`TB2_lA70[o2A8:oeMWD_n3Q8koY[?1ol[@e_mZLUcoCfM7odIE:Om6@Ako
AUDYok2c]oo]kNX00_lA9PX02?l94P[o2A`Do`000?n`/kOo6PT:ofYkKoo1
alcoNhf40_mbLW/02Oo1alco/;>gojJc`OnEZZgo;4`Yo`000?m?GVKodmWF
ojJc`@02ol[@eP0@oiFQ]oo1alcog>?Pom?SmOnV/l7o;5hmob=1?Olm;cgo
8blcocd_?Ol/EEco?Blmof1bNonVan3odn?eooKoo`?oY/OP00Go`LO<ojK7
h?nV/l7oLXf]oh>H]`02ojK7h0;o8d4m00_oLW9kom?SmOofooooUK?<ojK7
h?ldIg_o8blYoaXB5?m6C3goH79komcSh004ol[@eP06oiFQS_l0003oJW]_
ol77c?o:d=Kog>?P0_o]m_D02Oofoooo/;>gol77`Ooooooo/;k1olZn[Oo]
kN[oooooodI17P02ol6cSP07oiFQS_n`ZXCoH5hcoh=kG?ofkN[om[<0oooI
:@02ooJc000>ooK72_ofaakoi:X0ooK77_ofacgokKhmooKII_ofaakom]UV
oooI:OoofCgom]UVoooI:OoofCd3ooK72P03ooJc0?ofa`[om/L:00;oi:X0
00Kodh@0ok1b0?mP;`[oARl:ob<L2_lA70X2oaX92P07oa4L2_lm4P[oJT4:
ob<_7_lJ9QCo6PT:oaXB5002o`TB2P04oaXB5?lJ2@[o;1`Doh<_00CoLRH0
00KoLSPDoeLL0?mP;aCoYW8Dok2=<oniSC<2oh=k<`0?ofYE7_mP@ACo8bH:
oaXB5?m69QCoH2l:ob<V2_l92@[o6Q8Do`T92_lJ2@[o4A`:oaX92_lS70[o
?A`:00Go8a`:00KoARHDocdB2_m69P[oARH:ob`B0?o]m_EOonKViP04oifM
WOng]kOob<S8om?Cd`7of][J0004onk^kP08onc/k?oXj>SofMWIol;2`_nU
YJGoSHf=oginO_mfMWKoog9bLPgoLW9b00WoK6a/ofQXJ?mSHf?oFUYJodi>
C_l9CjGoY/KVokWCk_mi[^/00_n[gol01?m^KVko];Bdon3Ph?o/k>aKonk^
kP08ob`L5?l/9QCo;180ob<V2_l/71Co8a`:oaX92_l/4P02ocdL2P05ob<V
2_lS70[o8a`:ob`B0?lS70X00_l/4P004OlS70[o;180oaX92_lS70[o8bH:
o`T92_lJ4QCo8a`:ob`B0?lm4P[o;180ob<L2_l/4P3o8a`:oaX92_l/4P3o
8a`:00;o;18000Co8a`:ob`B0?lS70[o;1800olS70X01olJ2@[o;180ob<L
2_l/4P3o6PT:oa4L2_l92@X00olA70X00ol94P[o6Q8Do`T92P02oa4L2P0Q
o`T92_lJ2@[o4A`:o`TL5?m?GVKo/;>gol[@`OmbSHCo;3PYofYbG?m6EBWo
JW]_odmWAonVan3o`LO<o`000?lA9P[o2A`DoaXB5?mGIe;oCfMLog^=Q?nV
ZZ?oH79kodmbNon`/kOo/;k1ol[@e_nVZZgoSIR>ohf=Kol94P[o000000;o
b]3F0_o1al`02?n`_/7o`LO<ol77c?oCfMKokOKeoh>H]olmLXCo8d5B0_lS
@Cd01?lm;cgo8d4mobaEG?mZNh@2ojK7h0;om_oo01KoUK?<ojK7h?nVan3o
Y/OPoiFcc?mbSJgoPiRgojJc`OnE/lco8blcocd_?On3V;Oodn?eooKooon3
V;Oom_ooocAWNol/EFoo4BHDoc@_<om6C3go/;k10_oCfMH01On`/kOokOKe
ol[@e_lA9P[o6Q`N00;o`LO<01gog>?PongfmOo]m_Gom_oool[@e_mbLW_o
kNgZomcSe_n`_/7oYZZ]omcSh?o:d<7o`LO1og^=I_mZIc?oAT`mof0_5?oT
al7oong<ooJc0?ofaakoom00ooJc0?ofa`[om[<0onBZ0?offFKoon>>ooo]
SP02oooSQ0?om]UV00WoomTmooKII_oofCgom/L:onfn?Oofa`[om[<0ooK7
7_of/`000ooTZP003Oo1Q03oLRH0odHV2_lS70[o6PT:oa4L2_lJ2@[o4A`:
ob`B0?mkC0[oARl:oc@_7_lS9PX00_l92A@01Ol94P[o6Q8Do`T92_l/4P3o
LSPD00;oLRH001;oH2l:of0_5?mP;aCoPd40ok24:OnNSC?oWXdYoh=k<on3
GQCoJT4:ofYE7_lA9QCoARHDof0_2_lS9P[o2@T:oaXB5?l92@X2oa4L2P05
ob<L2_l/4P3o8a`:ob`L5?lS70X00_lm70X01?m69QCo?A`:ocdL2_l/9Q@2
odHV2P03ocdL2_lm4P[okOKe05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN4000Cooooo00[oo?cloo7alOo5aLGoR8R8ofm_KomeMGGoPX:2ohN7Qon=
SHgoUIFE3_nJVYX6oi^KV`;oW9bL1OnMWId;oijNWP;oWinO0_nPX:001?nO
WiooX:2Poj2PX?nPX:0=oj6QX@;oXZ:R0_nSXj<00onTY:CoYJFUojFUY@03
ojJVYPSoYjNW1OnXZ:P00onYZJWoZ:RXojRXZ005ojVYZ@[oZZZZ0on[Zj/0
0on/[:co[Jf]ojf][@02ojf][@_o[Zj^1On_[jl2ok2`/0Ko/K6a2_nb/[83
ok>c/`03okFe]Ond];Co][Jf00;o][Jf2_ng]kL=okRh^0So^KVi1Onj^[X3
okbl_0?o_[jn0_no_kl;ol30`0;o`L710oo2`/82ol?3``_oa<C41Oo5aLD0
0oo6a/KoalO7olO7a`05olW9b@Sob/[:0_o;bl/3olc<c003olg=cOo<c<co
c<c<00;ocLg=0oo>c/h>olo?c`04oaaN/?nS`^Co^=?_ogN^j`;oZ]oo00Co
MWIfol71`Oo`l?3ooOgmFoooool01?lS9P[o?A`:ocdL2_lS70X2ob`B0004
ob<L2_l/4P3o8a`:ob`B00;o?A`:00?o8bH:ocdB2_l/4P000_lS70X01_lJ
2@[o8a`:ob<L2_lJ2@[o;180oaXB50;o;18001?o?A`:ob<V2_lS70[o8bH:
ob`B0?lS70[o;180ob`L5?l/4P3o6PT:ob<L2_l/4P3o8a`:ob`B0?lJ9QCo
6PT:ob`B0?lJ4QCo;18000;o8a`:00Oo;180ob<L2_lA70[o4A`:o`000?lA
70[o2@T:00;o2A8:00Co4A`:o`T92_l92@[o4A`:0_lA9Q@05_ld;bWoUIRS
ol[@e_mGSHko0000oiFQS_mkSFKoAUEBoh>HS_n3Q8kokNgZoa4V2_l0003o
2A`Do`000?ld;akoUJ6>oa4V5?n=V8kob]3FohfHS_l971@2ok2n`@07ol77
c?nEZZgoSIR>oba<:Ol0003oPhB>ol[@eP03ol77c00:ok2n`Oo1alco`LO<
ongfmOn3V;Oo;5E_obaEG?lm;cgo;5ELocd_?@;o8d5B00Co8d4mocAWNon`
_/7oY/OP0_ofool03OnVan3oUK?<ojK7h?o1alcoUK?<oh>H]onEXKOoY/OP
oh>4S_lS;c?oH79koh>H]oofool00_oChoD07_nVan3oLXf]og:=[OlA;c?o
4BHNocAE?On3Q8kodmWFol[@e_oCfMKo`LO<ooKooomZNfoo0000ojJQV?o1
alcodmWFom?SmOo]m_Gom_ooong]j_mZLUco`LO<ong]j_o:d<7o/;>gonC@
c?o]m_Go`LO1odH_2P;o2A`D00GoH44YooKoooo]aecook<0ooK7?@04ooK7
2P03ooJc0?oohhkoonf>00Coonf>00?oon>4oooI?OoffFH00_oofCd00ooo
fBWoomTmooK72P03ooK72P?oi:X000oo`H@0ofY12_mG703o8bH:oa4L2_lA
9P[o2@T:oaX92_lS70[oNd`:of11:Om69QCoARl:o`TB2_lA70X00ol92@X0
5_lm4P[oLRH0of0_2_mP;`[o?A8:og8h0?nNLP[o^H@Yoij=<onNNc?oPg/c
oij=:On3GQCo6Q8Dob<L2_m69P[o8a`:oa4L2_l92@[o4A`:oaX92_lA70X3
oaX92P;o8a`:00?o;180ocdL2_m69Q@01_lm70X2odHV2P03ob`B0?oChoGo
oooo05kooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000?ok^k^00_ok>c/
on?Shon[Zj_oLg=coginO_n<S8coVYZJoj>SXonZZZ[o/[:bokJf]P08okRh
^0Coo?gk1?oloOd00ooko?goo?gmoo[ko@02oo;cn005on_/lOoNgnCofm_S
omKFh?oFe^801?oEeN49omCDh37oe=CN2?oDe>07omGEh@07omGEgooBd]co
emOOon7Pj?oYj^oolO3eooOgn@03oogmo@?ooOgk1OomoOd3olo?c`03om3@
d?oAdM7od];B00;od];B2_oCdm<6omCDe0;oeMGE1OoFe]H>omOGe`;of=SH
3OoIfMT3om[JfP;ofm_K0ooLg=`3omgMg@;og]kN2ooOgml2on3Ph0?oh^;R
0_oTi>@;onGUi@;oinOW0ooXj>P00ooZj^[ojNWYonWYj@02on_[j`?ok>c/
2?o^k^h2ono_k`?ol?3`0oobl_82ooCdm0?omOGe3_ofm_H01?lNGk?oYLCV
okWCkomg[^/2ojWLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00?o8a`:ocdL
2_l/71@00olS70X01_l/4P3o;1`Dob`B0?lS70[o8bH:ocdL2P;o;18000Oo
8a`:ob`B0?lS70[o=2lNob`B0?lS70[o;18000;o4A`:00ko;180ob`L5?l/
4P3o8bH:ob<L2_l/4P3o8bH:oaX92_l/4P3o8a`:oaX92_lS70[o;180ob<L
2P;o6PT:0_l/4P000olS70[o;180ob<L2P02ob`B0003ob<L2_lm4P[o6PT:
00?o4A`:00Co2@TDoaX92_l92ACo4BHD0_lA70X05OlJ2@[o2@T:odI<?OnV
ZZ?o`LO<o`TL5?m6@Ako;3PYoiFHXomkSHCoJW]_oh>4S_nEZZgoUJ6>o`00
0?lA9QCo2@TDo`T92_nEXHko8blNodI<?@02ol[@eP0?odIWG?l971Co`LO<
ok2c]oo1alcoPhB>oiFQS_l0003oAT`mok2n`OoCfMKoY[?1ol77c?n`_/7o
`LO<00?ob]3F00coPhB>ojJZ[OnVZZ?oUHB>oij4I_nVLU;oUG97odmNI_lS
@E;oEei_ojK7h?oChoD2ooKoo`0<om?SmOnE/lcoY/OPojK7h?nE/lcoPiRg
oiFcc?nV/l7oCg9kocd_?OmbLW_oPiRg0ooChoD01on3V;OoUK?<oiFcc?lA
;c?o=5Dmob<_<om6@Ah00_o:d=H02?oCfMKo`LO<ol[@e_o1alco8blNocAE
:OnVXISo`LO<0oo]m_D03oofooooPiR>ohf=Koo]m_Go/;>gol[@e_n`/kOo
g>?PongfmOo1alcoARl:oiEbAoo1al7oonf>ooKIIP02ooK72P0:ooK7?Oof
/`3om/L:ooK72_of/`3oon>>ooo]c?ofooGoonf>oooSQ0;oonf>00_oon>4
ooKII_offFKoomTmooKII_oofCgoomTYooK77_ofa`[oi;<NooK72P02onBZ
0005ol640?n3;`3oH2lDob<V2_lJ2@X00_lA70X04olJ2@[o8a`:og]<5?n`
Q2WoPehDof115?l94P[o2@TDoaX92_lJ4QCo4A`:ob`B0?mP;`[oARH:og8V
0?nNGQCodj4YolZZI_nVXFH00onNSBT01om6;`[o6PT:ob<V2_lS9P[o6PT:
oa4L2_l94PX01?lJ2@X01OlS70[o;180ob<L2_m69QCo?A8:00Ko?A`:00Oo
ARH:ocdL2_m69P[o?A`:odHV2_l/4P3okOKe05ook^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN4000?oi^KV00_ohN7Qokjn__mgMgOoX:2Pokfm_On`/;3o
[Zj^okFe]Onl_;co_[jnolG5a@08olS8b0Coo_ok00coo_omookoooonoooo
o_oooo[noookooook_7fomkQj?oJgNCoe=ONolW<eOo7bMD2okVkb0?o^;[7
0ong^LH9okVkb2oo^K_72?ni^lP8okZlb@08ok^mb_o2a=3oc<cHom7DgOoI
fN7oi>GZoo;cn?omo_l4ookoo`Coooom00CoooooomkNg_oNg]kog]kN0_oO
gml6on3Ph0[ohN7Q0ooRh^82on?Sh`?oi>CT2_oUiND6onKViP;oj>SX1OoZ
j^X;on_[j`;ok>c/0_o]kNd01?o/k>cokNg]ong]kOo]kNd:onk^kPGokno_
0oo`l?05oo7al@Sol_;b0_oclo<3ooCdm003ooGemOofm_Kom_Kf00;omoOg
0oohn?P:ooWin@?on_[j0oolo?`2ooknoQ7ooooo00Co6enfojC4i_nidnoo
MZgZ0_n[h?l01?mZJV[o[Zj^omSHf?oTi>AKonKViP07ocdL2_l/71Co;180
ob`L5?lm70[o8a`:ocdL2P02ob<L2P03ocdL2_lS9P[o;18000;o?A`:00_o
8a`:ob`B0?lS70[o;180ob<L2_lJ2@[o8bH:ob`B0?lJ2@[o;2HDob`B0002
ocdL2P0:ob`B0?lS70[o;180ob`B0?lS9P[oARH:ob<V2_l/4P3o8a`:ob`B
00;o8a`:00co6PT:ob<L2_l/4P3o=2lNob`B0?lJ2@[o8a`:oaX92_lS70[o
8bH:oaX92_l94PX3oa4L2P03oaX92_lA9QCo6PT:00;o4A`:00go0000ohfH
S_nVZZgo0000oeMWD_nVZZ?oJW]_ojJZXomZNfooUIRSoiFQS_oChoGo0000
00;o2A`D01Co0000ojJHQ?lS;bWo4A`:oh>4S_o1alcog>?Poa4V2_mGSEco
UIRSok2c]onEZZgoYZZSoceN?Ol0003o/;k1oiFHXooLhn3oUJ6gol77c0;o
/;k100gob]3FomcSh?nVZZ?oYZZSojJHQ?nVQ8CoUHAkoij4I_n3NecoUG97
og9ED_l/EEcoPiRg00;oY/OP0_oChoD05oofooooY/OPojK7h?nVan3oUK?<
oh>H]onEXKOoY[?1odIED_m?IecoLW9koiFQ]ooChoGom_oooiFcc?n3V;Oo
dn?eojK7h?lA;c?oCg9kob=1?OlJ9QCoLW9k00;ob]3F00Gog>?Pok2c]ooo
ooooUJ6goa4V2P02oiFHX`0GongfmOoChoGom_ooooKoooo1alcoJW9Lom?I
e_o:d<7ob]3FongfmOn`_/7oY[?1ol77c?o]kN[om_ooooo]S_ofd8Com]UV
ooJc0?o]_SgoomTmooK72_oofBT00_ofa`X00ooohhkoonf>ooo]SP02ooo]
SP?oon>400Wom]UVoooSQ?oofCgom]UVoooI?Oofaakom/LmooK72_ofacd0
0ooTZP000ooCV0[oNd40og8h0002ob<L2P09oaX92_l92@[o4A`:ob<L2_mP
;`[o/8@Yoiik<on=E@[o4BHD00;o4A`:00oo2@T:oa4L2_lS70[o?A`:oeLL
0?niSACoWXdYokVZKon=SDOoWW8Doh=k<om6@Ako;1`DoaX92_lS9PX00_l9
2@X00olA70[o6PT:oa4L2P02oaX92P08ob<L2_l/4P3o6PT:oa4L2_lm70[o
8bH:odHV2_m69Q@3ocdL2P03odHV2_l/71CoARH:00CoARH:00?o;180om?S
mOoVi^H0G_oVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h03?o]
kNgoiNGUoi6ATOnATI7oc<c<omGEeOo2`/;o^KViol30`?o4a<CobLW9ol[:
bPSod=3@0_onooX2ookon`1TookooOonooooo_ooookooooamOSoko;gom[M
i?o4am3o^kg9ok>g`_nZ[;WoYZVhoiRJZOnGVZWoV9V[oiJIZ?nGV:[oUIRW
oiJGZOnEV:OoUIJXoiBGY_nEUZSoU9NVoiFFZ?nDUjKoUIJXoiBGY_nEUjKo
U9RToiFGY_nDV:CoUINVoiBHY?nEUjKoU9RToiFGY_nDV:CoUINVoiBHY?nE
UjKoU9RToiFGY_nDV:CoUINVoiBHY?nEUjKoU9RToiFGY_nDV:CoUINVoiBH
Y?nEUjKoU9RToiFGY_nDV:CoUINVoiBHY?nEUjKoU9RToiFGY_nDV:CoUINV
oiBHY?nEUjKoU9RToiFGY_nDV:CoUINVoiBHY?nEUjKoU9RToiFGY_nDV:Co
UINVoiBGY_nEUjKoU9NVoiFFZ?nDUjKoUIJXoiBGY_nEUZSoU9NVoiJGZOnE
V:OoUYNYoiFHYonFUjWoUIRWoiJGZOnEV:OoWj6`ojBW]_n][kco/[C1okRj
a_o6bM;ofmkUong^l`Coo_oo0_ooood2oooon`06oooooooRh^;oh^;Ron;R
h_oTi>Cohn?S0ooUiND:onKViPKoinOW00?oj>SXonWYjOoZj^X01?oZj^X;
on_[j`?ok>c/0_o]kNd3onk^kP[okno_0oo`l?02oo7al@;ol_;b00ColO7a
oo;bl_obl_;ol_;b0_oclo<8ooCdm0GomOGe0oofm_H5ooOgm`[on?Sh0ooi
nOT00ookno_oo?clooclo002ooknoRKooooo00Co6ejcojG4i_ned>koNJk/
0_nWg?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP0Aob`V5?l/71Co;180oa4L
2_lm70[o;1`Dob<L2_l/4P3o?A`:ocdB2_lS9P[o?A`:ob<L2_lm70[o?A8:
ob`B0?lS70X00_l/4P003OlS70[o6PT:ob`B0?lJ2@[o;180ob<L2_l/4P3o
?A`:ob<L2_lm70[o8bH:ob`B0?lS70X00_l/4P000ol/71Co;180ob`B0003
ob`B0004ocdB2_lS70[o;180ob<L2P?o;18000Co8a`:ob`B0?lA70[o6Q`N
0_l92@X09olA70[o2A8:oaX92_lA70[o6Q8Doa4L2_l0003o`LO1odI17_lA
70[o`LO1ohfHS_n3SHCoSIR>og9bNonEZZgo`LO1ohfHS_l0003o6Q8Do`T9
5?lS;akoEheLoeMWD_mZNfooUJ6gol[@e_n`/kOo2A`Doh>HS_n=V8ko/;k1
og^=Q?n=V8ko0000og9ED_mZNhCoUJ6gol[@eP02ok2n`@05ojJc`Oo1alco
b]3Fok2n`OoL_[L00_o:_Zd02?n`ZXCo/8Akoij4I_n`NfKoWXAVoiEbAom6
C3goJW^40_nVan004?oChoGom_ooooKooooChoGoPiRgojK7h?nV/l7oPiRg
oiFQ]onE/lcoCeiVof1bNonEV:?o/;k1om?SmOofool2oh>H]`0Com?SmOo:
d=Ko2D57oh>4S_n3V;Oo2A8:oeMED_mZNhCo`LO<om?Ie_oLhn3ob]3Fongf
mOldEBWoAUDYol77c?n`_/7ob]3Fongfm@02ooKoo`03oiFHXooCfMKodn?e
00;okOKe00Kog>?FongIc?o]d9Soon>>onfn?Oofacd2ooKIIP05ooo@0?of
/`3om/LmooK72_o]_Sd00_ofa`X01?oohhkoong<ooo]S_oohh@2ooo]SP;o
on>400Oom]UVoooSQ?oofCgoomTmooKII_oofCgom/LN00;om/L:00_om[<0
onBZ0?oCQ03odiP:oh<h0?mZ@@[o8bH:ob`L5?lJ2@[o6Q8Do`T95002ob`B
000>olZZAonNSC?o/8@Yo`TB2_lJ2@[o2@T:oa4L2_lJ2@[o2@T:oheE2_nV
XFKoWXdYoh=k<omZEAh2odI17P04oa4V7_lJ2@[o4BH:oaX92P;o2@T:00Co
4A`:o`T92_lS70[o6PT:0_lS70X01?l/4P3o;1`Dob`B0?lS70X4ocdL2P03
odHV2_lm70[o?A`:00;o?A`:00?oARH:ocdB2_lm70X00_m69PX00ol/4P3o
kOKeonk^kP1Nonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002ooooo`0<
ookno_oalO7oOWinokbl_?oHf=Sofm_Kolk>c_o0`<3oaLG5ol[:b_o<c<co
clo?2?oCdm<0J_oooo[oo?ggoognnOoooo_ooOolookooooloooom?Skon3S
j_o<cmSo_/;=ojV]^OnKWZgoT9JVoh23U_moQ9OoOh:Eogb2T_mlOi;oMWb<
ogEhRomcNHWoN7^>ogQnS_miO8ooMgf=ogUlSomgOHgoNGb?ogMmSOmiO8oo
Mgf=ogUlSOmgOH_oNGb=ogMmRomiO8goMgf;ogUlSOmgOH_oNGb=ogMmRomi
O8goMgf;ogUlSOmgOH_oNGb=ogMmRomiO8goMgf;ogUlSOmgOH_oNGb=ogMm
RomiO8goMgf;ogUlSOmgOH_oNGb=ogMmRomiO8goMgf;ogUlSOmgOH_oNGb=
ogMmRomiO8goMgf;ogUlSOmgOH_oNGb=ogMmRomiO8goMgf;ogUlSOmgOH_o
NGb=ogMmRomiO8goMgf=ogQkS?mfO8coN7^>ogIlS?mhNhkoMWb<ogQkS_mf
O8coNGb?ogQnS_mjOI3oMWb<ogMjSOmgOHgoOX6Doh25V?mnPICoP8FHohR;
W_n@TjCoVij]oj^_^onm`LcoblkGon?VkOobmOX2ookoo`05oo_mn_olo__o
oookoooonoooool00ooVi^H2onOWi`Koj>SX2_oYjNT3on[ZjP;ojn_[0oo/
k>`:ong]k@?ok^k^0oo_knl00ooalO7ol?3`oo;blP02oo;blP;olo?c2?od
m?@5ooGem@?om_Kf1OogmoL=ooShn0?onOWi3oojn_X3oo_kn`03ooclo?om
oOgooOgm00;oo_kn9_ooool01?lKGkKoY<CVokSBk_mf[NX2ojcOo`04ogIf
M_o1`L7ol?3`oogmoE_ooooo02CoARHDob`L5?lm70[o;180ob`L5?l/9QCo
;180ob<L2_l/4P3o8a`:ocdL2_l/4P3o?A`:ob<L2_l/71Co;180ob<L2_lJ
2@[o;180ocdB2_l/4P3o8a`:oa4L2_lS70[o;180ob`V5?lm70[o;180ob<L
2_l/4P3o8a`:ob`B0?lA9P[o;180ocdL2_l/4P03ob<L2P08oaX92_lS70[o
?A`:ob<L2_l/4P3o8a`:oaX92_lS70X2oaX92P07ob<L2_lA70[o4A`:o`T9
2_lA70[o6PT:o`TB2P02o`T95006o`TB2_l/>2Wo=5DYoa4V5?nVZZ?o`LO<
0_mkSH@06om?GVKoYZ6Hok2c]omGSEco0000oa4V5?l0003o8blNoh>4Nom6
@Ako8blNoh>HS_n`_/7ob]3Fog^=Q?lA9QCo=5DmojJZXonEXHko`LO1oa4V
2_l0003o/;>godIED_oLhn3o/;k1ol77c002ok2n`@08ol77c?o1al7og;>]
ol77c?oTal7og;jgol[@`OnVQ8@2ok24N`06ojJ4Q?nVXISo/8AkocAWNonE
/lcoY/OP0_oChoD2ooKoo`0:om?SmOnE/lcoUK?<oh>H[OnEXKOoY[?1odmb
NombEE;oPiR]ojK7h0;om_oo00GoLXf]oiFcc?oChoGoY/OPobaEG002ojK7
h00?o`000?nEV:?oLW9koiFQ]ooChoGokNgZoiFHXoooooooYZZ]ocAE:On`
/kOo`LO<ojJc`OoChoGokOKe00Com_oo00kokOKeong@V?ofa`[om/LmooKI
I_ofaakoomTYooK7?Oofd8Coon>4ooK72_ofaakom]UVooo@00;oomTY00Go
om00ooKII_ookLcoong<oooSQ003ooo]SP05oooSQ?offFKom]UVoooI?Oof
fFH00_oofCd01?ofacgom/LNooK72_oT/ah3onBZ0003oheE2_mb9P3oARl:
00;o4A`:00So6PT:oa4L2_lS70[o6PT:ok1k:Oo:XE;o/8dcob<_7P;o4A`:
00co2@T:o`TB2_lJ2@[oWXdcofYW<om6@Ako=2lNoa4V5?l94P[o0000oa4L
2_lJ4Q@3o`TB2P0;oa4L2_l92@[o8a`:oaXB5?l/4P3o8a`:ob`B0?lS70[o
8bH:ocdL2_lS70X01?lm70X01?lS9P[o?A`:ocdL2_lm70X6odHV2P03ocdB
2_oChoGooooo05kooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000;ok^k^
00Cok>c/omoOgomaLG7odM7A0_oLg=`01_o@d=3oa<C4olW9bOo<c<coclo?
om;BdPSoeMGE06_oooojookonOonoo[oo_klooWkn_oin_col?CgomoRjOo@
dmco^ko;ojf`_onBUj[oP8FIogMlT?m[L8KoL7F;ofEZO_mVKGooJ6f0ofI]
OomUJWgoI6]mofEZOOmUK7koJ6f0ofM^P?mXKH3oIfj0ofQ]P?mWKX3oJ6f0
ofM^P?mXKH3oIfinofQ^O_mWKWkoJ6inofM^O_mXKWkoIfinofQ^O_mWKWko
J6inofM^O_mXKWkoIfinofQ^O_mWKWkoJ6inofM^O_mXKWkoIfinofQ^O_mW
KWkoJ6inofM^O_mXKWkoIfinofQ^O_mWKWkoJ6inofM^O_mXKWkoIfinofQ^
O_mWKWkoJ6inofM^O_mXKWkoIfinofQ^O_mWKWkoJ6inofM^O_mXKWkoIfin
ofQ^O_mWKWkoJ6inofM^O_mUJWgoI6]mofEZOOmTJggoIFYmofA[OOmUJWgo
I6]mofAYO?mUK7koIfaoofI]OomUJWgoIFanofQ]P?mZLHCoL7F;ofAZP?mT
JGooM7V?ohN<X?nHVjkoZJbmokVmbOo;cMWoh>?ZooOho@02ookoo`04oogo
o?omo_Woo?ghooooo`_oinOW1ooXj>P3onWYj@?oj^[Z0_o/k>`3onk^kP;o
kno_3_o`l?000ooalO7ol_;boo?cl`0?oo?cl`;om?Cd0ooemOD3ooKfmP[o
moOg0oohn?P2ooWin@?on_[j0_okno/3ooclo0gooOgm0oono_hXooooo`04
oaeO/onVa^Ko]]3^ogV_kP;oZmko00CoKVi^okBd]?oPh>3ok>c/Foo^k^h4
ob<L2P07ob`B0?m6C3go?A`:ocdL2_lS70[o;180odHV2P02ob<L2P04ocdL
2_l/4P3o8bH:ob`B00?o8a`:00Oo8bH:oaX92_lS70[o8a`:ocdB2_l/4P3o
8bH:00Co8a`:00Go;180ob<L2_lm4P[o8bH:ob<L2P02ob`B0003ob<L2_l/
4P3o8bH:00;o?A`:03Ko6PT:ob<V2_l/4P3o8a`:ob`B0?lA70[o6PT:oc@_
7_lJ4QCo4A`:oa4V5?l92@[o6Q8Doa4V5?lJ4QCo0000ok2ZQ?l94P[o?Ehm
oiFZ[OmbLW_o?Ehmohf=Kon3V:goY[?1oiFQS_l0003o4BHDo`TB2_lS;c?o
JW]_o`000?o1al7o6Q`NofYbG?o1alcob]3FodIE:Ol0003oJW9LojJZ[Omb
SHCoYZ6Ho`000?m6C3goAUDYol77c?o:d=KoNhf4ol[@e_n`_/7o`LO<ol6c
[OoL_[L2onC@c0;og>?F00?og;jgol6QQ?nVXIP00_nVV8@2ol6QQ004ojJ4
Q?nE/lcoY/OPom?Sm@;om_oo0ooChoD2oh>H]`0KoiFQ]onV/l7oLUEBog9b
NonEXKOodn?eooKooooChoGoLXf]oh>H]ooChoGoUJ6goeMNKooChoGoUK?<
o`TL7_lS@Cgo`LO1og9ED_o1alcob]3FongfmOnEXKOom_oooiF4S_mZLUco
dmWF00;ob]3F01CokOKeom?SmOo]m_Gom_Keong@V?offFKom/L:oooI:Oof
acgoomTYooK72_of/`3okKhmooo]S_oohhCom/L:oooI:Oofacgom/L:onfn
?@;om/LN00?okLMLooo]c?ookHh01?ookHh00ooohhCom]UVooo]SP04ooKI
IP04ooK72_oofBWom/LmooK72P;oi:X000Sodh@0oh=10?mkC0[o?A`:ob<L
2_lJ2@[o4A`:ob<L2P;o6PT:00GobYPYombcQ?o:ZTOoJT4:o`TL5002oa4L
2P;o;18001;obZ4moh=N5?n3GQCoARl:ob`h:OlJ2@[o8a`:oaXB5?l94P[o
2@T:oaXB5?l92@[o6PT:o`T92_lJ2@[o;180ob<L2_lJ2@X2ocdL2P05odHV
2_lm70[o?A8:ocdL2_m69Q@00_lm70X01?lm4P[oARH:ocdL2_m69PX2ocdL
2P;oARH:00CoARHDodHV2_lm4P[odmWFGoo^k^h01?nSXj?o_Kfmolo?cooJ
f]X1on7Qh@000_oVi^H03?oTi>CoeMGEog5aLOoGemOog]kNomoOgooDe=Co
a<C4olO7aoo<c<cod=3@om;BdPSoe]KF077ooookoocmn?ono_coooomoocm
oooin_koj>_bom;Eg_nn`/koXJBeohjAY?mkP9KoOX:KohfC[OnDVKKoXZS2
olO=hoo9dNCocmKYom7Ik?oAf>_ocmOZolkEj?o=eNSocmKYolkFjOo?e^Wo
c]KYoloFjOo>e^WocmKYolkGj?o?e^Soc]OXoloFj?o>enSocmKXolkGj?o?
e^Soc]OXoloFj?o>enSocmKXolkGj?o?e^Soc]OXoloFj?o>enSocmKXolkG
j?o?e^Soc]OXoloFj?o>enSocmKXolkGj?o?e^Soc]OXoloFj?o>enSocmKX
olkGj?o?e^Soc]OXoloFj?o>enSocmKXolkGj?o?e^Soc]OXoloFj?o>enSo
cmKXolkGj?o?e^Soc]OXoloFj?o>enSocmKXolkGj?o?e^Woc]KYoloFjOo>
e^WocmKYolkFjOo?e^Woc]KYolgDioo=eNSod=OZom3Hjoo?e^WocMGXolkE
j?o=eN[o`<KPojV`c?nGW;WoRi6[ogb2V_mgO9;oS96Uojbaa?ng^/Woc];M
on_^mOokooooo_ooookooOonoo_ooOojooooo`03onWYj@03on[Zj_oYjNWo
j^[Z00;oj^[Z0oo[jn/=onc/k003ong]kOo^k^kokno_00cokno_0oo`l?03
oo7al@03oo?cloobl_;om?Cd00;om?Cd0_oemOD8ooKfmPOomoOg1_ohn?P;
ooWin@;on_[j0_olo?`00ookno_ooOgmoogmo@0AooknoR[ooooo00Co6Ubc
ojC3iOnhd^ooNJk/0_n/gol01?mZJV[o[Zj^omSHf?oTi>AKonKViP06ocdL
2_lS70[o;180ocdL2_lS9P[o;1800_lS70X02_lm4P[o6PT:ob<L2_lm4P[o
8a`:ocdL2_lS70[o;180ocdL2_l/4P03ob<L2P09ob`B0?lJ2@[o8a`:ocdL
2_lS70[oARH:ob`B0?lm70[o;18000?o6PT:00_o;180ob<L2_mG703o8a`:
ob`B0?lm70[o;180ocdB2_lS9P[o;180ocdB2P02ob<L2P0ioa4L2_lS70[o
6PT:oa4L2_l94P[o8bH:oa4L2_lJ2@[o4A`:ob`B0?l92ACoAUDYoa4L2_m?
IdOo6Q`NocAE:Olm;cgo?EhmoeMWD_l/C2Wo/;k1ok2c]ol0003o2A8:o`TL
5?l92@[oJXeLodI<?OmZLUco/;>gog^=Q?mZLUco`LO<oh>=Q?lA9P[o?Ehm
og9bNomkSHCo`LO1oa4V5?l94P[oSHe_odmNI_oLhn3o/;>goiFZ[On`/kOo
/;k1ojJHQ?oL/jgoi<O1ongIc?ofkN[og>?PongIc?oTd<cob[j]00?og;>S
0ooL_[L00oo:_Zgo/;>gol[@eP02om?Sm@0:ooKooooChoGodn?eojK7h?mb
LW_oPhB>ojJZ[OmbLW_oPhB>oiFHX`;odn?e01?om_ooog:=[On3V;OoY/OP
oh>4S_n3V;Oom_oooiFcc?lAC5;o?BlmodmNI_o]kN[oPhB>ol77c?o]m_Go
`LO<ol[@e_oChoGoEeEB00;odmWF00So`LO<ongfmOooooookMW<onfn?Ooo
fBWom/LmooK77P?om/Lm01?om/LNooJc0?oofCgom]24oooSQ?ood03om/L:
ooKII_ofa`[oomTYooJc0?oofCgom[<0ooo]c?ookHkom]UVooo]S_offFKo
onf>00;oon>400Woonf>oooI?OoohhCoon>4oooI?Oofacgoom00ong7G?of
aah00ooTZP003onEE@3oLSP0odHV2_lA70[o8a`:oa4L2_l92@[o8a`:oaX9
2_nNLP[okM2HolZZI_nNLQCo2A`Doa4L2P02oaX92P07o`000?oT/dOoWXdc
oh=k<on3GQCoARl:ob<V2P02oa4L2P04o`T95?lA70[o2@T:o`T92P;o4A`:
0olS70X00omG703o?A`:ocdL2P03ocdL2P03ob`L5?lm70[o?A`:00;oARH:
00?oARHDocdL2_lm70X00olm70X01OmG703o;2HDodHV5?l/4P3okOKe05oo
i^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;ok^k^00Cok>c/omcLg?mg
MgOofMWI0_oPh>001_oDe=CoalO7ol[:b_o>c/kod];BomCDe0Soe]KF01?o
oookoo_lmoono_cooooooognoooem__ogN3Yol;4dOnZ[KkoRi2Togn4V_n2
R:;oWZ?0ol35hoo:cnooeMcioloGk_oAg>koe^7c00;of^Gg00?of>?eomOR
m?oFhO<02?oHhoD`omSTm0SofNCf01Koen;domSSmOoHhoGof>?eomORm?oE
h?;oe=oaomCOmOoAf?GocmGeolcBl_o0a^KoY:W7ohJ;Z?n0Q9ooRXnUojZ]
`?no`]7og=kZoo3cn?ojnooooOon0_onood00oooooooj>SXonSXj009onSX
j0OojNWY0ooZj^X3on_[j`03ong]kOo/k>cok^k^00;ok^k^0_o_knl;oo3`
l0?olO7a0_oclo<3ooGem@[om_Kf3OogmoL;ooShn0;onOWi0_okno/00ool
o?coo_knooknoP0kooooo`04oaeO/onUa>Ko]];^ogV^j@;oZ^3o00CoKVi^
okBd]?oPh>3ok>c/Foo^k^h00ol/71Co8a`:ob`L5002ob`B0009ob<L2_lm
70[o?A8:ob`B0?l/71Co?A`:ob<L2_lm70[o;18000;o?A`:00?o;180ocdL
2_lJ2@X00_l/4P03ob<L2P04ocdB2_l/4P3o?A`:ocdL2P?o8a`:00Oo;180
ob<L2_l/71Co8bH:ob`B0?lS70[o;18000;o8a`:037o;180oeLL0?lS9P[o
;180ob<L2_l/4P3o?A8:ocdL2_lJ2@[o2A8:oaXB5?l92@[o8a`:oaX92_l9
2@[o4A`:odIE:OmkSFKo;3PYoa4V5?l94P[o4A`:oa4V5?m6EBWo;2HDoh>4
NonVZZ?o6RHDo`TB2_lA9QCo2@TDob`h:Om6EBWo;3PYoh>4Non`_/7o`LO1
oiFHXoo:d=Ko4BHDoa4V2_l/C2Wo`LO1oiFQS_n=V8ko0000og^=I_lA9Qko
/;>g00;o`LO100_oUIRSok2n`OnVXISo`J64ombn[OoTd<cog>?FongIc?of
kN[og>?FomcSh002ombn[@03olZn[OoL_[Oog>?F00?okMW<00Oog;jgol6Q
Q?nVQ8Co`G]kom?SmOofoooodn?e00;oY/OP01GoEei_og9bNonEQ8koUHB>
oiFQ]ooChoGom_ooom?SmOnEXKOoPhB>oh>H[OmbSJgo`LO<om?SmOnE/lco
LXf]ob=1?Om?GVKo`LO<ol77`OnEZZd00_o]m_D02_nVZZgob]3FoiFQ]on`
/kOodn?eooKoooofkN[og;j]ooK7?Oof/`03ooK7?@03ooK77_ofacgom]UV
00;om/L:00gom/Lmooo]S_offFKom/LNooK72_offFKom/LmoooI:Oof/`3o
omTmonBZ0?ofooGoonf>00Goon>400Kom]UVoooSQ?oohhCom]UVoooI?Oof
fFH2oooI:@03ooK7?Oofaakoi:X000;oi:X000?oUED0og]<2_m6;`X00_lS
70X03olJ2@[o4A`:ob`B0?l92@[o^H@Domc7XooC_Xko^HdYob`L5?lJ4QCo
2@T:oa4L2_l/4P3og;=Lok2=DP02oiik<`06odIE:Old;ako6RHDoaX92_lJ
4QCo2@T:0_lA70X01olJ2@[o2@TDob`B0?l/71Co;180oaXB5?l/9Q@00_lm
70X01?lm4P[oARH:ob<V2_m69Q@2ocdL2P03ob<V2_lm70[o?A`:00;o?A`:
00OoARHDocdL2_m6@AkoARHDodHV2_nVLQCodn?e05ook^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN4000;ooooo00cooOgmonc/k?mfMWKof][Jon3Ph?oQ
hN7oe=CDolO7aoo;bl_oc/k>om3@d?oCdm<8omGEe@0CoooooOolo?[ooooo
ooooooofmo_oi^K^olS:e_nXZ[WoT9>VohJ;XOnCUk;oY:W7okg2h_o?eOOo
bLocolcBm?oDh?KoenCeom[Wn002omcYnP?ofnSi2?oQk_l`on7^oPSog^_l
00CogncmomgZnooKj?Wof^Oh0ooIi_L04_oIiO_ocMKgolcDnOo9dOGoa<c`
okg3iOn[/M7oTYNeogb0VonFV:ooZJboolS:eooRiNcoloCiooWjo?olo__o
o_omooooo`?ojNWY0_oZj^X3on_[j`?ok>c/1oo]kNd6onk^kP03oo3`l?o_
knoolO7a00ColO7a2oobl_84oo?cl`Com?Cd2_oemOD5ooKfmP;omoOg00?o
m_KfooOgmoogmoL00oogmoL;ooShn0;onOWi0_okno/00oolo?coo_knookn
oP0kooooo`04oa]N/onVa^Ko^M?^ogV^j`;oZmoo00CoMWIfol71`Oo`l?3o
oOgmFoooool01?l/9QCo?A`:ob<L2_lS70X2ocdL2P?o8a`:00Co?A`:ob<V
2_l/4P3o8bH:0_lm70X07Ol/4P3o8bH:ocdL2_lS9P[o;1`Dob<L2_l/4P3o
6PT:ob<V2_m69P[o?A`:ob<V2_l/4P3o8a`:ob`B0?l/71Co;180ob<L2_l/
4P3o?A8:odH_2_lJ2@[o?A`:ob`B0?lm70[o8a`:ocdL2_lS70[o;18000Co
8a`:00_o;180o`TB2_l92@[o2@T:o`TB2_ld;ako;1`Do`T92_m6C3go4BHD
of1N<`02oa4L2P;o6Q8D02GoAT`modmNI_nEXHko4BH:oaXV5?lA9QCo2@T:
oa4L2_mPGS?o8blNoh>4Non3SHCoUJZ]ok2c]on`_/7ob]31o`000?ldEBWo
Phf4og9bNonVZZgoEheLo`000?mZSEcoLUEBojJZXonV/l7o/;>goiFQS_n=
SFooLVMBok24Noo1/jgoi=3<onC7`OoTd<cog>?F00;oi=3<00Sog;jgol[@
`OoL_[Ooi<O1ongIc?ofkN[om_Keongfm@;om^gZ017oi<O1ombn]oo1Ng_o
dn?eooKoooo1alcoY/OPoiFQ]omGGVooPhf4oiF4S_n`_/7odn?eooKooooC
hoGoPiRgog9bN`02oh>H[@0:om?SmOnVan3oY/OPoiFcc?ldIg_oCg9kodIE
D_oooooo`LO<om?IeP;okOKe00?o/;k1om?SmOo]m_D00_ofool00ooLaj?o
m[<0ooK77P03ooK7?@0<onBc7_oofBWom/L:ooK7?OoofBWom/L:ooK77_oo
hhkom]UVooK7?Oood03oomTm0ooofBT00oofacgom[<0ooo]c002ooo]SP;o
on>400Coonf>ooKII_ookHkoon>40_offFH01?oohhCom]UVoooI:OoofCd2
ooK7?@;oi:X000oodiP:oiEE0?nEE@3oARH:oaXV5?lS70[o2@T:oaX92_lA
70[o6Q8Dom>Q:Oo]fLcom]UVombcG?m6;`X00_lA70X03_lJ2@[o;180ong7
G?o:ZVKoWXdcokV=<omZEAko=2lNob<V2_lA70[o2A8:oa4L2_l92@[o6PT:
0_l92@X01olJ2@[o;180ob<L2_lm4P[o?A`:ob`V5?m6;`X00_m69PX01?lm
70[oARH:ocdL2_m69Q@2ocdL2P;oARH:00SoARHDocdL2_m69QCoEa`0ol5k
NooL_[Ooooooom?IeUoooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000;o
k^k^00Cok>c/omcLg?mlO7cof][J0_oPh>001_oCdm?oa/K6olc<c?o>c/ko
d=3@om?Cd`SoemOG01Coooomoocln_oooooooooooo7bmooMgNOo_Ko<oi^N
[on1PiSoRHfVojJ[bOne^][o_/CXolG:l?o4bO7oc]KjomCPn?oDi?Coe^Kf
omOWm`;oe^Kf00?oenOgomSXn?oKjo/01ooKjo/`om_[nPSofNWi00?ofn_k
omWYnOoFi_H01?oEiOD04_oDho[ogNOoom_Sooo=eOco_<CYokJkhOnb^=co
XjO:oi6F]?n4R:?oV9Z_okVkb_oKg^Oom?GjoocmooomookooOolooooo`?o
j>SX0_oYjNT3on[ZjP?ojn_[1_o/k>`00ooJf][og]kNong]k@04ong]k@;o
kno_1OoalO401?obl_;ogmoOoo3`l?obl_82onOWi`;ol_;b00?okno_on;R
h_obl_802?oclo<3ooCdm003omWIfOo<c<colo?c00Com?Cd1OoemOD00ood
m?CoinOWooOgm`05ooWin@Con_[j0_o]kNd5oo[jnP03oo_knoo`l?3oiNGU
00;oo?cl0_omoOdAooknoR[ooooo00Co7f6doj?2i?nhdnooMjk[0_nZgol0
1?m^KVko];Bdon3Ph?o/k>aKonk^kP04ob`L5?lS70[o?A`:ob<L2P;o8bH:
00?o?A`:ob`L5?ld;ah00_lm70X01_l/71Co8bH:odHV2_lm70[o8a`:ocdL
2PCo;18000[o?A8:ob`B0?lS70[o;180odHV2_lm70[o;180ocdL2_lS70[o
?A`:1?lS70X02?l/4P3o?A`:ob`B0?lS9P[o8a`:ocdB2_lm70[o;1800_lm
70X01_l/4P3o;1`Dob`B0?lS70[o?A8:ob`B00;o4A`:00goAT`moeN=G?nE
V:?o/;>godHV5?ldEBWo4A`:oaXB5?lA9P[o8blNodIE:OmZNfoo2A8:00;o
4A`:00Oo2@TDoa4V2_lJ4QCo4BHDodI<?On3V8koUJZ]00;oUIRS01Wo/;k1
ohfHS_ldEBWo8blNojJQV?mbLW_oSIR>oa4V2_mGIe;o?Blmog^=Q?mbSHCo
?Ehmob<_:Old;c?oH44Yoh=N<onNQ6KoYXB4ol6QQ?o1/jgog;jgol77c?oT
d<cob]3100;o`K>]00Go`J64ombc[Oo]fLcokMW<ooKoo`02ooKfm@0;ooK]
j_o]kN[om^gZongIc?o1Ng_oYZZSom?SmOnVan3o/;k1ojJc`OmGEE800_n`
/kL3om?Sm@0>og:=[On3Q7_oUIRSojJc`OofooooY/OPom?SmOnVan3oLXf]
ofYkQ?lm;cgoUIRSongfmOo1al`2ongfm@06om?SmOoLhn3om_ooooKooooo
ooookLML0_ofaah01?oT/akom]UVooK7?Oofaah2ooK7?@09ooKII_ofacgo
m/LNooK77_oohhCom]UVooK7?Oof/`3om]UV00;om/Lm00?om/LNoooI?OoT
ZP000oookHh01?offFKoon>4ooo]S_oohhh3ooo]SP07oooSQ?ookHkom]UV
ooKII_oofBWom]UVooK7?@02onBZ000@om>H2_nEE@3oNd`:odH_2_l/4P3o
6Q8Doa4L2_lJ4QCo8a`:oaX92_oLZS?okM2HongIc?offFKo=5DYoa4V2P;o
4A`:00SoEa`0olZQD_nNNc?oPehDoij=<onVQ5;o;2HDodI17P;o6Q8D00Co
4A`:oaXB5?l94P[o4A`:0olS70X02Ol/71CoARH:ocdL2_lm4P[oEa`0odHV
2_m69QCoARH:odHV5002odHV2P08odHV5?lm70[oARH:ocdL2_ld;akoEa`0
ok1kI_ofkNX3ooooo`03ol[@e_o^k^kok^k^05gok^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN4000;oi^KV00Coi>CTomCDe?mlO7cof][J0_oPh>001_oC
dm?oalO7olc<c?o>c/kod=3@om;BdPSoe]KF01CooOgmoo_knooooooooOco
on_[looEeN7o]KO6oiFHZon6R9ooSI6/ojJ[bona]MSo]kcRol?8l_o9d?co
fnGooloNmOoAh_;oe>GeomKWm`?oeNKf00?oe^OgomGVm_oEi_H01_oEi_H`
omGWm@Soe^Og01Wof>WiomKWmooEi_KoeNKfomKWmooEi_KodnCdom7Pmoo1
bnoob=7jolcEo_o6coSo^l;/ojjcfOnNX/OoTiRhoh>7Y?n?U:[o[K31om;F
hOo_l_Wonoooookoooonoogooooo00?oj>SX00?ojNWYon[Zj_la<C400_l0
00001?l71`Oo:b/[ofYZJ_oQhN43ong]k@06ol_;bola<C7o3@d=o`/;2ole
=CGocLg=0_o^k^h01_lk>c_oMgMgono_koo`l?3oVIVIoaXJ6P;ol?3`00ko
C4a<o`L71olH61SoTi>Coa4A4OmBDU;olO7aokBd]?lI6AWo1PH6ode=COmo
Ogoo;Bd]oo;blP;olo?c0oodm?@02ooemOGoUiNGoa8B4_l820So9BDUoaTI
6Om9BDWod=3@ooGemOlm?CgoNWYj00?om_Kf00Ko^;RhoaXJ6_l61PKoCdm?
oh:2P_l^;Rh2ooWin@09ochn?_mlO7con_[joo[jn_lT92Co3`l?oalO7om;
Bd_olO7a00;on_[j00Koh^;RodQ8B?l20P;o8R8RoaHF5_no_kl2ooknoS_o
oooo00Co7f2dojG4i_nidnooMjk[0_nYg?l01?mZJV[o[Zj^omSHf?oTi>AK
onKViP08ob`V5?lm70[o8a`:ocdL2_lS70[o?A`:ob`B0?lm70X2ob`B0004
ob<L2_lS9P[o;180oeLL00;o?A`:00Co;180ob<L2_lS70[o;1800_lS9PX0
1OlS70[o;180ocdL2_lS70[o?A`:00;o8bH:00?o?A`:ob`B0?lm70X00_l/
4P001Olm70[oARl:ob`B0?lm70[o;18000;o?A`:017o8bH:ocdL2_lS70[o
?A`:odH_2_l/4P3o?A`:ob<V2_lS70[o4A`:o`T92_l/71CoCfM7ofYbG?nE
V:?odmWFooKoo`02oa4V2P;o4A`:02;oAT`moc@_7_l0003o4BHDo`TB2_l9
2ACo6Q`NodI<?Ol/>2Wo2@TDodI<?Om6EE;oPhB>ok2c]om?GVKog>?Poba<
:Ol971koLUEBofYkKonEZZgo;4`Yo`T92_n=SE;oUHAkoh>=Q?n=SE;oARHD
oaXB5?l/71CoH44YofYW<onELTOoYW9B0_nEQ7/02onVQ8CoLVMBog9ED_n3
NecoLVMBog9ED_nEQ7_oYXB4ol[@`OoL_[OokMW<00Com_Ke00Kom^gZooKf
mOoLhn3og;>]om?Ie_oChoD2ojK7h003ofYkQ?n3Q8ko/;k100?odn?e00oo
PiR]og9bNonEV:?o`LO<om?SmOnVan3om_ooojK7h?n3V:goUJ6gofYkQ?m6
C3goUIRSoooooooChoD00oo]m_D2ooKoo`05oooooooT/dOoi:X0ooK7?Oof
/`000_ofacd04oofa`[om/LNooK7?Oo]aecoomTYooK7?OofaakokM2HoooS
Q?ood3gom/L:ooK7?OoofBWom/LNooK72_ofacgoi:X0ooo]c?ookHh00_oo
hh@00ooffFKoon>4ooo]SP03ooo]SP04ooKII_oohhCom]UVooKIIP;oomTm
01kom/LmonBc7_oTZP3odh@0ojIb0?mkC0[oH2l:oa4V2_lS70[o4A`:oaX9
2_lS70[o2@T:om>Q:OofooGokM2Homc7Xon3GQCo8bH:o`TL7_l/4P3oEa`0
oiib<oniLS?o=2lcofYW<oo:V2Wo6RHDob<_7_lS70X2oa4L2P05o`T92_l9
4P[o6PT:ob<L2_lm70X00_lS70X01_l/71Co?A`:odHV2_m69P[oARHDoeLL
00?oARH:00WoARHDob<V2_lm4P[o=2lNoh<_0?o1XHCoong<ooooooofool0
0oooool00oo:d=Koi^KVonKViP1MonKViP04oifMWOng]kOob<S8om?Cd`7o
f][J0002onk^kP04onc/k?oLg=coO7alom[JfP;oh>3P00Koe=CDolS8b?o;
bl_oc/k>om3@d?oBd]88omKFeP0CooonoooooOkoookoooWhoOoQhN_oaLOD
ojBW^_n2QYooSI:`ohfA]?nPY<[o[;7IokVnj?o4bO?o`/OaolS@mOo7dngo
bMS]olkMlP02om7Pm@;od=od00?od=obom3Om?o@go801oo@go803_o@h?3o
d=obom3Pl?o@go;od>3`om3Ol_o@h?3od=obom3Pl?o@go;od>3`om3Ol_o@
h?3od=ob4oo@h?003?o@go;od>3`om3Ol_o@h?3od=obom3Pl?o@go;od>3`
om3Ol_o@h?3od=obom3Pl0;od=ob0_o?g_407oo?g_?ocmkaoloNloo?g_7o
cmkcoloNlOo?g_?ocmkaoloNlooAh??odn;gom7Ploo<fo3ob=K`om?Kooo6
cO_o_LC`okk5konj`N_oZK7HoiNL`_n<T[KoR8b_ohbA[onQYKkoa<OHonCV
l_ofmo_oo?cloooonoooool00ooXj>P2on[ZjP0Doc4a<Om[Jf_ok>c/on?S
honm_Kgo@410oahN7_oPh>3ok^k^ong]kOl`<33oC4a<omkNg_oOgmooCdm?
oc4a<Oo^k^kokno_oc/k>omgMgL2ono_k`09oiRHV?lJ6Q[okno_okVi^Ol3
0`?od=3@omSHf?mEEEGo410@00;ol?3`00WoCdm?oe=CDooXj>SoU9BDo`h>
3_l];BgolO7aoo;bl_oclo<00oodm?@02onBTY;o0P82ohF5QOobl_;omOGe
oo?clon[Zj_oclo?ooGemOlm?CgoNWYj00?om_Kf00KoDE5AoeIFE_o_knoo
VIVIo`h>3_l^;Rh2ooShn009ochn?_mlO7conOWiooWinOnk^k_omOGeooSh
n?ld=3CoSXj>00;onOWi00Ko@T92ochn?_oJf][oo?cloo3`l?o_knl2ookn
oS_ooooo00Co6enfojC4i_nidnooMZgZ0_n[h?l01?m^KVko];Bdon3Ph?o/
k>aKonk^kP04ob`L5?m6;`[o8a`:ob<L2P;o?A`:00Go8a`:ocdL2_l/71Co
?A`:ob<V2P02ocdL2P04odHV2_lS70[o;180ob<L2P;o;18000co8a`:ob`B
0?l/4P3o6PT:ob<L2_l/4P3o?A`:ob<V2_lm70[o8a`:ocdL2_l/4P02ob<L
2P0kob`B0?lS9P[o;180ocdL2_lS9P[o?A`:odHV2_lS9P[o?A`:ob<L2_l/
4P3o8bH:ob`B0?lS9P[o?A`:odHV2_lS9P[o6PT:ob<L2_lJ2@[oEeEBofYb
G?nEXKOob]3Fom?SmOmPGS?o4BH:ob<V2_l/>2Wo4BH:o`TL5?lA70[o2A8:
o`T95?lJ2@[oLXeLo`T92_mbSEcoCfMLof1N<omGEE;oJW9LodIWG?l/C2Wo
/;>go`000?l/71CoJVLcofYbG?nVZZ?o0000ojJHKold;bWoPhAkog:=G?m6
C3go4BHDoa4L2_lA9Q@00_mP@BT04OmbIe;oLUEBoh=kG?mbEE;oJVLcoiEb
AombEE;oJVLcoiEN<on`NfKo`J64ombcXooL_[Ooi<O1onC@c?o]kN[om_Ke
00?om_oo00Com_oeooK]j_ofm_GoLUEB0_oChoD01?n`_/7ob]3Foh>4S_nE
XKL2ol77c007ojK7h?nEV:?oSHe_oiFQ]ooChoGoUK?<ojK7h002om?Sm@0E
oh>H]ooChoGoUK?<ocAE:OmGIe;ob]3FongfmOoChoGoooooongfmOo]fLco
m_ooooooooo]_Sgoi:X0ooK72_oT/akom/LNooK72_oT/bWom/LN00Com/Lm
00Kom/L:ooKII_offFKom/LNoooI:OoffFH2ooK7?@03ooK72_ofaakoi:X0
00;oonf>0_offFH00ooohhkoonf>ooo]SP03ooo]SP?oon>400Com]UVoooI
?Oo]aecom/Lm0_oTZP001OoCV0[oYW80oh=10?mP;`[o;2HD00;o4A`:01_o
6Q8Dob<L2_l92ACoYW80ooo]c?o]fLcoonf>og]10?lS9P[o2A8:ob<L2_lm
4P[obZ5BonBcAoniLS?oPehcok2=<omkC1Co8bH:oaXV5?lJ4QCo2@T:oa4L
2_lJ4QCo6PT:oa4L2_l/4P000_lm70X02_lm4P[oARH:odHV2_mG703oARH:
of0_2_m69P[oARHDob`V5?ld;ah2odHV5005ok1k:OookLcoooooooooooof
ool01?ooool00oo:d<7ok^k^onk^kP1Monk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q0002ooooo`0<oogmoOo/k>coNg]kom[Jf_oPh>3ohN7QomGEeOo8
b<Sob/[:olk>c_o@d=3odm?C2?oFe]H04Oooo?oooogoooomooofmO_oi>C`
okk1e?nHW[SoKG>Eogb3[On:TKooVIoAojJZf_n^/^7o^;_Vol32jOo2a^Wo
am3_00;oaM3/00Koam;^ol_Fl_o<eo?obmKbolSDk_o:eO48ol[Fl00>ol[F
k_o:e_3ob]K^ol[Fl?o:e^kob]K`ol[Fk_o:e_3ob]K^ol[Fl?o:e^kob]K`
ol[Fk_o:e_0Col[FkP0<ol[Fl?o:e^kob]K`ol[Fk_o:e_3ob]K^ol_GlOo;
enoobmOaol_Gkoo;eo7obmO_1?o;eo407oo;e_;obmOaol_Fl_o;eo7obmKb
ol_GlOo9e?3ob]K`ol_Fl_o<f?;oc=Ocol[Fl?o8dnoob=7bolK9m_o5aoSo
_l;_okJkiOn]]McoYJgDoiRQb_n<UKkoOXFaoficWOnIWL;o`<7OomoNl?od
loWooOcjoooon_ooood00ooXj>P2onWYj@03oc4a<OmZJV[oj^[Z00;ojn_[
01[oi^KVoa`L7?mXJ6Sok>c/olO7aol0003oZJVYonc/k?o]kNgoZZZZo`00
0?o<c<cokNg]oc/k>omgMgOokno_oo7alOnJVY[o6QXJoo7alOo=cLgo0P82
ok>c/oobl_;oUYJFoahN7P;ol_;b00Ko:BTYohR8R?obl_;ol_;bogAdM?l]
;Bd5oo?cl`03onc/k?lC4a?oGUiN00Oom?Cd00oo?CdmogYjN_oemOGomOGe
ooKfm_lZ:R[oS8b<ooShn?oinOWoN7Qhobl_;ookno_oo?cloclo?omnOWh0
1?omoOd02?o3`l?o5ADEoi6ATOomoOgofm_Ko`000?nf][KooOgm0oono_hm
ooooo`04oa]N/onUa>Ko]M3^ogV^k0;oYmco00CoMWIfol71`Oo`l?3ooOgm
Foooool02olS70[o;1`Dob<L2_l/71Co;180ob`L5?lS9P[o8a`:ob`B0?lS
70[oARH:00;o?A`:00co8bH:ocdL2_lm70[o?A`:ob<L2_l/4P3o8bH:ocdL
2_lS70[o;180oa4V2_m69PX5ocdL2P0:ob<L2_lS9P[o?A`:ob<L2_lm70[o
ARHDob`B0?m69P[o?A`:odHV2P;o?A`:00?o8a`:ocdL2_lm70X00olm70X2
odH_2P;o8a`:00Go6Q`NodmWAomkSFKoUJZ]ol77c002om?IeP0Do`000?lA
9QCo4BH:o`T92_lJ4QCo2@T:oaXB5?m6EBWo;4`YoaXB5?lJ71koPhAkob<_
7_n3V8koUJ6>oiFHXombSCgo;3PYoaXV5?lS;ah2og:=G00;ofZ=G?l/>2Wo
NheVoiFQS_l971Co=5DYodIE:OlJ71ko2A8:oaXB5?m69Q@00_mP@BT01?mb
EE;oPehcofYW<omP@BT2og9EDP07ofYW<onEC2Wo/7]Vok24I_o1Ng_oi:ZH
onC@c002ongIc005ooK]j_ofm_Gom_ooooooooofool00_ofm_D01OofkN[o
`J64ok2n`OoChoGo`LO<00;oY/OP027oUK?<oiFQ]ooChoGoY/OPoiFHXomG
GVoo`LO<ooKooonVan3oPiRgom?SmOofooooY/OPom?SmOnVan3oLXf]ob<_
:Oofoooodn?eongfmOofooooUIRSomcSe_ofooooooooom>H2_of/`3om/LN
ooJc0?ofaakokLMLooK7?Oofaah00_ofacd03ooffFKom/LmooK72_oohhko
m]24oooI?Oofaakoom0moooI?Oofacgom/LNooKII_of/`3om]UVoooSQ002
ooKIIP?oonf>00?oon>4ooo]S_ookHh00_oohh@01_ookHkoon>4oooI:Oof
fFKom/L:onBZ00;odiP:00?o/780oheE2_m6;`X00_l/71@2oa4L2P0KoaX9
2_lJ4QCo^H@Dooo]c?o]fLcoong<og:=?OlA9P[o2A8:oa4L2_mG703obZ5B
onBcAooT/c?odj4YoiEN<oniSBWoH2lDob`L5?lJ9QCo6Q8Do`TB2_lA70[o
6PT:ocdB2_lJ4QCo;1`D00;o?A`:00koH2lDoeLL0?mP;aCoH2l:odHV2_m6
9QCoAT4NodHV5?mG703oYW9BooK]j_ofm_Goooooongfm@Kooooo00?ob]3F
ooooooooool0GOooool01?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h0
1?o/k>cog=cLog]kNooJf]X2on3Ph006omCDe?o8b<Sobl_;olk>c_o@d=3o
d];B2?oEeMD06OoonooooocoooomooohmOkogn7^okk3fOn5Rj_oK7>Mog^3
]?n8SlGoUicDoj2Ug?nX[=co/;?NokNigonj_N3o`<KZokg5jOnmaN[o`<S/
ol?;l?o6c_;oaLgaolC=k_o4c?000_o4cNh05?o4cNcoa<g^olC=k?o4cNko
a<g/olC=k_o4cNcoa<g^olC=k?o4cNkoa<g/olC=k_o4cNcoa<g^olC=k?o4
cNkoa<g/olC=k_o4cNcoa<g^0_o4cN`03Oo4cN[oa<g/olC=j_o4cNcoa<gZ
olC=k?o4cN[oa<g/olC=j_o4cNcoa<gZolC=k?o4cNX01?o4cN`03?o4cNko
a<g/olC=k_o4cNcoa<g^olC=k?o5c^ooaLk]olG>koo5c^goaLk_olG>k@Co
aLk_01ooaLgaolG>koo5cO7oaLk_olG=lOo5c^ooa<c`olG>koo5cO7oaLk_
olC<l?o2bnco`<S/ol35joo0`?;o_[k`okRkj?n`]MooZ;3GoinXdOnBW/So
Qi;0ogn7^?mZL:3oP8>`okfmhOoShOOooOcoooonnoolnO;oooom00?ojNWY
00Goj^[ZonWYjOla<C7oJVYZon[ZjP03on_[j`0Bog9bL_lO7aook>c/ojn_
[ol0003oe=CDonc/k?o]kNgodm?Co`000?nc/k?okNg]oc/k>omgMgOokno_
oo7alOnJVY[o6QXJ0_oalO401OnTY:Co;bl_oc0`<?lc<c?o7QhN00;ol_;b
00Ko:BTYoh^;Roobl_;ol_;bohR8R?l];Bd2oo?cl`?om?Cd00?ob/[:o`00
0?nj^[X01ooemOD00olm?CgoNWYjooKfmP02ooKfmP06obXZ:_n>SXkon?Sh
ooShn?n<S8co;bl_0_ojn_X03Oln?SkoOGemoo_knookno_oh>3PodQ8B?l2
0P;oKfm_oo;bl_okno_o^k^ko`000?ll?3`00oln?Sh00oo2`/;oo_knookn
oP0kooooo`04oa]O]_nTa>Ko^=;^ogJ]jP;o[=oo00CoKVi^okBd]?oPh>3o
k>c/Foo^k^h01Olm70[oARHDoaXB5?mP@BWo;1`D00;o?A`:00?o8a`:odHV
2_m69PX00_l/4P000om69P[oARl:ocdL2P02odHV2P;o?A`:01co8a`:ob`B
0?m69P[o?A`:oaX92_m69P[oEa`0odHV2_lS70[o8bH:ob<L2_lm70[o;180
ob`L5?ld;ako?A`:ob<V2_m69QCo;180ocdL2_lS9P[oARH:ob<V2_lm70[o
ARl:ocdL2_m6;`[o?A`:0_m69PX04Olm70[o8bH:oaX92_lS9P[oEfMBofYk
KonEV:?odmWFong]j_ofoooo`J64o`000?lA9P[o?A`:oa4V5?lJ9QCo?Ehm
00?o8blN013o2A8:ob`h:Ol0003oJW9LohfHS_nVZZ?o0000oiFQS_nEV6Ko
=5DYoa4V5?lS;ako;3PYo`000?m?IdOo4BH:0_lA70X05olJ4QCo0000oaXB
5?lS;akoAT4Nof11:OmkC1CoPehcog9ED_n3GS?oJVLcoh=N<omP@BWoUD`Y
ojJHKon`Q6KoUG97ol6QQ?oL/jgoi=3<onC7`Oo]fLcom_oo00;om_Ke0oof
ool2ooKfm@0?ongIc?nNQ6Kodn?eol77c?nVan3om_ooom?SmOnE/lcoY[?1
ok2n`OnV/l7oPg]Lom?SmOofoooodn?e00;oPiRg00cokOKeooKooooChoGo
m_ooojJZ[On3GS?oYZZ]ooKooooLhn3oYZ6Hol6cS_oLhn02ooooo`05olZH
5?ofaakoi;<cooK72_ofacd00_ofaah5ooK7?@05onBZ0?oohhkom]24oooI
?Oofaah00_offFH03?ofa`[om/LmooK7?Oofaakoon>>ooo]c?oohhCom]UV
oooSQ?ookHkoong<oooSQ0;oonf>00?oon>4ooo]S_oohh@00_oohh@03oof
acgom]UVonBZ0?oCV0[oi:X0ok1b0?n3@@3oJT4:oc@_7_lJ9QCo;1`Doa4L
2_l/71Co2@T:ok1k5003ooo]c00Hoij=<om6@Ako4A`:o`TB2_l/4P3om]UV
ooK@Q?o]aecoi;=7okUb<oo:XCgo/4`0ob`L5?lS;ako4A`:oaXB5?l94P[o
6PT:ob<L2_l/71Co?A`:ocdB2_mP;aCoEa`01?mP;a@01?m69P[oYT`0ombc
[OookL`4ooooo`03ongfmOofoooooooo00Cooooo00?o`LO<onk^k_o^k^h0
GOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H01?oTi>Coe=CD
ogalO?oJf]X2on3Ph006omCDe?o8b<Soc<c<olk>c_o@d=3od];B2?oDe=@0
6Ooonocooogmooomooohmooofmg/ol75g_mZL9;oKGBPogMn]?n2RlCoTIOA
oiZOeonQY=OoZ:_Hojnaeon`]=Wo];WQok6hh_nb^NGo];_UokRojonk`^co
_<?]okc4jonk`^`00_nk`nX05?nk`nSo^l?Zok_3j?nk`n[o^l?Xok_3j_nk
`nSo^l?Zok_3j?nk`n[o^l?Xok_3j_nk`nSo^l?Zok_3j?nk`n[o^l?Xok_3
j_nk`nSo^l?Z0_nk`nP03Onk`nOo^l?Xok_3ionk`nSo^l?Wok_3j?nk`nOo
^l?Xok_3ionk`nSo^l?Wok_3j?nk`nL01?nk`nP03?nk`n[o^l?Xok_3j_nk
`nSo^l?Zok_3j?nk`n[o^l?Xok_3j_nk`nSo^l?Zok_3j0Co^l?Z01oo^l;/
ok_3j_nk`^co^l?Zok_2k?nk`n[o^l;/ok_3j_nk`^co^l?ZokW0j_nf_^Go
];_UokBihone]nSo]KGWojnbgonX[=WoXJSBoiVRcOn<UlGoPXboogV0]_mY
Kj?oIVZGokk1i?oPhOKooOcoooonnookn?7oooom00?oj>SX0_oYjNT00ola
<C7oJVYZon[ZjP03on[ZjP0Boi6ATOl20P;oiNGUol[:b_l0003oYJFUon_[
joo/k>coY:BTo`000?o@d=3okNg]oc/k>omGEeOok^k^oo3`l?nCTi?o6a/K
0_oalO42oo;blP03oo3`l?n<S8co7alO00;ol_;b00Oo:BTYoh^;Roobl_;o
l_;bohR8R?l];Bgolo?c00;om?Cd0_oemOD00on[Zj_o0000om[JfP07ooKf
mP03ocdm?OmUIFGomoOg00;omoOg00Ko:RXZohj>S_ogmoOon?Shoh^;Rol^
;Rh2ooShn007ochn?_mlO7conOWiooWinOlo?coo@410omGEe@03ooWin@07
omGEeOl0003oYjNWol[:b_o4a<Co0P82on;RhP02ooknoS_ooooo00Co7Enc
ojK6i_nfd>koNJo^0_n[g_l01?mZJV[o[Zj^omSHf?oTi>AKonKViP04ob`V
5?l/71Co?A`:oa4L2P;o?A`:00WoARH:ocdL2_lS9P[o;180ocdL2_lS9P[o
?A`:og]<2_mG70000_m6;`X01?lm70[oARH:odHV2_lm70X2ob<V2P0:ob<L
2_lm70[o8bH:ob<V2_lm70[o8a`:ocdL2_l/4P3o?A`:ob<V2P;o;18000?o
?A`:odH_2_lS70X00_lm70X01_m69P[o?A`:ocdL2_lm70[o;180ocdB2P;o
ARH:01GoARl:odHV2_m6;`[o?A`:oaXV5?mGIe;oPhAkoiFZ[On`_/7ob]3F
ooKooonVXFKoJT4:oa4V5?lJ9QCo4BH:oaXB5?l0003oEfMBohf=Kol00000
0ol94PX06?m?IecoSIR>odmWAol0003oUJ6>odmWAolS;bWoH5hcocAE:Ol9
2@[o4A`:oaXB5?l92ACo6Q8Do`TB2_lA70[o2@TDob`h:Om69QCoJUDNoh=N
<omP@BWoPehcofYE7P;oJVLc00WoJUDNoh=N<on`Q7_o`J64ojJHKon`NfKo
`G]kombn]ooTal400_o]fL`00oofkN[om_Keooooo`02ooKoo`0@ooKfmOof
oooom_ooongfmOn3GS?odn?eol[@e_nEXKOodn?eooKooooChoGo`LO<ok2n
`Oo1alcoUIRSom?Sm@?om_oo00cog>?PongfmOo]m_GokOKeooKoooofooGo
ooooooK]j_ofm_GokNgZooK]j_o:d<42ooKoo`09ooooooo:V1Coi:X0ooK7
?Oof/`3om]UVooK77_oT/bWom/L:00;om/Lm00Oom/LNooK7?Oofaakom]24
oooSQ?offFKom/LN00;om]UV00?oomTYooK7?OoofCd00_ofacd01ooohhko
on>4oooSQ?ookHkom]24ooo]S_oohh@00_ookHh3oooSQ00>ooo]S_offFKo
m/LmooK77_oT/c?oi:X0ol640?n`LP3oUED0ofY12_l/71Co8bH:oa4L2_lJ
2@X2oa4L2P0>og]<5?ofooGom_oeooo]c?nNSBWo=5DYo`T92_lA70[o;180
ooo@?Oofd8CokLN4ooKII_oCZTL2om>Q:@05og]<5?ld;ako4A`:oaX92_l9
4PX00olS70X00om69P[o?A8:of0_2P04of0_5003og8V0?o]d9Sooooo00Go
oooo00?om_ooongfmOofool01Oooool00oo:d<7oi^KVonKViP1MonKViP04
oifMWOng]kOob<S8om?Cd`7of][J0002onk^kP0<onc/k?oLg=coNg]komWI
fOoOgmoohN7QomCDe?o7alOoc<c<olk>c_o@d=3oeMGE2?oDe=@04OoonoSo
ookkooonoookn_oof]c[olG9h_mAEWcoJG6Pog5g/OmlQ<;oRi7?oi>IdonJ
X=CoXjOFojV]don[[mGo[;3M00;oZ[3P00Go[;;Rojjdi?na]nOo/k[XokBk
j@02ok>jj1Ko/k[V00ko]KcXokFli_ne_>So]KcVokFlj?ne_>Ko]KcXokFl
i_ne_>So]KcVokFlj?ne_>Ko]KcXokFliP;o]KcX2?nc^^H8ok:ii@co/[WW
00Co/;OUojjehon//n7o[K7P0_n/[]h03onWZm[oWjKBoiZRd?nDW<_oR9;5
ogj7__m^MJcoJFjUoeMKR_o5b>_of]_`oo?cnooooo_oooohooooo@03on[Z
jP05on_[jooZj^[o<C4aofYZJ_o[jn/00oo/k>`01_n5QHGo10@4onSXj?o/
k>co?3`lod92@P;ocLg=00[o@D51oclo?oo]kNgokNg]oc/k>olB4Q;oKVi^
om3@d?mADE7oB4Q80_o_knl01OnYZJWocLg=ong]kOmKFe_oCdm?00;ol?3`
00Wo:BTYohZ:R_o`l?3ol?3`ohN7Qol];BgolO7aoo;bl_oclo<00_odm?@0
0onn_[ko0000olW9b@07ooGem@07ocdm?OlB4Q;oRh^;om_Kfoodm?Co:RXZ
ohj>SP02ooOgm`06oh^;Rol^;Rkon?ShooShn?ln?SkoO7al0_oinOT01Ole
=CGoTY:BooWinOoRh^;om?Cd00;onOWi00Ko?CdmofQXJ?obl_;oW9bLobXZ
:_olo?`2ooknoS_ooooo00Co6UbcojC3iOnhd^ooNJk/0_n/gol01?m^KVko
];Bdon3Ph?o/k>aKonk^kP03odHV5?m69P[o8a`:00?o?A`:00Ko8bH:odHV
2_lm70[o;1`DodHV2_l/4P02ocdL2P06odH_2_mG703oARH:ocdL2_lS9P[o
ARl:0_lm70X02?l/4P3o2@T:oeLL0?m69P[o;180ocdL2_m6;`[o;1800_lS
70X02?lm70[o;180ocdL2_lS9P[o?A`:ob`B0?lm70[o8bH:1?lm70X2odHV
2P0AodH_2_lm70[o?A`:odHV2_lm70[o8a`:oaXL7_mkSFKoPhAkog^=Q?o1
/jgog>?PooooooldEBWo8bH:odH_2_lS;bT00_l92@X04OlA9QCoAUDYodIE
:OlA9P[o;2HDo`TB2_l92@[o;3PYog^=I_l92@[o2A8:odmWAom6@Ako0000
o`TB2_l92ACo4A`:00;o2@T:00Oo6Q8Doa4V5?lJ4QCo2@TDoaXV5?mP;aCo
H44Y00;oPehc0_nELTL03?nNQ6KoUG97oh=N<on3GS?oYXABojJQV?nVQ8Co
YW9Bol5kNoo1XHCog;>SonC7`@;okMW<00Com^gZooKfmOofm_Gom_Ke0_of
ool01?o:d=Ko`LO<odIED_lm4PX2ongfm@03ong]j_o]m_Gom_oo00?om_oo
0_oLhn001OofooookOKeong]j_ofooGokOKe00;og>?P00?og>?FongfmOo]
m_D00_o]m_D02oooooookNgZong]j_oLhn3oooooooKooooooooodiP:onBZ
0?oT/c?om[<000;om/Lm00?oi:X0ooK77_ofacd00oofacd01Oofaakom]24
oooSS_oohhCom/L:00;om]UV0_oofCd3ooK7?@?oon>400Goonf>oooSS_oo
kHkoon>4oooSSP05oooSQ004ooo]S_ofacgom/LmonBc:@;oi:X000[o/780
oiib2_mZ@@[o?A`:oaXV5?lJ2@[o6Q8DoaXL7_l94P[oPcP00oookL`04OnE
SE;oH44Do`TL5?lA70[o6PT:onBcAoookLcom]UVoooSS_o]aecobZ4molZH
5?nVLQCoARHDo`TB2_lA70[o2A8:00;o8a`:00Wo6Q`NodHV5?m69QCoH2lD
of11:OmP;aCoH2l:ok2=D_oLaj<01oooool00oofooookNgZooooo`05oooo
o`03om?Ie_o^k^kok^k^05gok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
00;ooooo00cooOgmonc/k?mkNg_ofMWIomoOgooQhN7oe=CDolK6a_o<c<co
c/k>om3@d?oDe=@8omGEe@0Booolm_oooo[oo_cmoocloooMh>oob]3ZodA9
LOmPIi_oK7:`ogMo`?n4S<goSYCBoiBId?nMXM7oXZO?ojFZd_nUZm_oYZcP
0_nW[N400onX[^;oZ[3Toj^ah`03ojbbi1Ko[;;R0_n]/n<03_n]/nGo[K?S
ojfciOn]/n?o[K?Uojfchon]/nGo[K?SojfciOn]/n?o[K?Uojfchon]/nGo
[K?S2?n//^88oj^ah@coZk7S00CoZ[3RojV_hOnX[^3oZ:kN0_nUZMP03onQ
YMCoVZ7?oiBLcOn=UlcoPX_4ogR1_?mZL:coHVNOodY>OOo8c>oog=kcoo;b
n_oooo_oooohooooo@03onWYj@;oj^[Z00?o<C4aofYZJ_o[jn/00oo/k>`0
1_m;Bd_o:2PXonc/k?o/k>coe]KFod];B`;o3@d=00[oCTi>omSHf?o]kNgo
kNg]odi>C_n2PX;oL71`oa8B4_l[:b_o]kNg0_o_knl01On1PH7o;bl_o`l?
3ole=CGo^;Rh00;ol?3`00Wo?clooiBDU?o`l?3ol?3`oi:BT_m2@T;olO7a
oo;bl_oclo<00_odm?@00ooRh^;o0@41oiJFUP07ooGem@0;oe1@D?n4Q8Co
FEUIo`P82?oWinOo@410oiVIVOohn?SomoOgoiNGUom4A4@00_oinOT02OmB
DU;oRXZ:oo[jn_ojn_[o^k^kocPh>?l?3`oo4Q8Bon?Sh`02oo[jnP06on7Q
hOm5ADGo30`<oa/K6ond];CooOgm0_ono_hkooooo`04oaeO/onUa>Ko]];^
ogV^j@;oZ^3o00CoMWIfol71`Oo`l?3ooOgmFoooool01Olm70[oARH:ob<L
2_lm70[o;18000;o?A`:02?o8bH:ocdL2_l/4P3oARl:oaX92_lS70[o8bH:
ob<L2_mG703oARl:oeLL0?m6;`[o?A`:ob`B0?lS9P[oEa`0o`TB2_lS9P[o
ARH:ob`B0?m6;`[o;180ob<L2_lm70[o8a`:ob`B0?lS9P[o?A`:ob`B0?m6
9P[o?A`:ob<L2_mG703o;180odH_2P04odHV2P0^odH_2_mG703oH2l:odH_
2_lm70[oARl:oaXV5?m6@AkoJW9LoeMWD_n`/kOodmWFongfmOnNLP[oNd`:
ofYE7_mZ@@[oPehDo`TB2_lA9QCoAUDYob`V5?lS;ako6RHDo`T95?lS;ako
6Q`Noba<:Ol94P[o4A`:oaXB5?l94P[o2@T:o`000?l94P[o2@TDoa4L2_l9
4P[o4A`:o`T92_l94P[o4A`:oc@_:Omb>1CoNd`DofYE7P;oUG9700CoYYR4
ombcXonESE;oPehc1?nELTL01?n`NfKoYZ6Hombn]ooL_[L3ongIc0?om^gZ
0_ofool02_o]fLco8bH:o`TL7_lJ2@[okOKeom?Ie_n`_/7og;jgol77c?oT
d<`2ombn]`09onC7`OoL/j?okMW<ong@V?o]fLcokLN4omcSe_o]fLcoon>>
00;okMW<01GokM2HonBnQ?oC_Xko`G]kojK7h?n3V8ko/;k1ong]j_ofm_Go
m_oeooooooniLS?odh@0ooK77_oT/c?om/LmooK77_ofacgom/LNooK7?Oof
aah00_ofacd04Oofa`[okLMLoooSS_ofacgom/L:ooKII_oohhCom/LNooKI
I_ofacgoomTYooo@?Oofd8Coon>4oooSS_ookHkom]UV00;oon>>0oookHh0
1ooohhCom]UVoooSQ?offFKom/LmooKII_oT/ah00_oCV0X01Oo1Q03oUED0
ofY12_l/9QCo8bH:00;o4A`:00go8a`:oa4V5?mG703om_oeooo]c?ofooGo
YZ5VodH_2_lA9P[o2@T:o`000?oT/bWoonf>00;oon>>00SokLMLolZZI_oT
/bWoWUhDog]<5?lJ4QCo4A`:o`T92P;o8a`:00Oo6Q`NoeLL0?m69QCoH2lD
ojIW0?niZVoom^gZ00;ooooo00?om_oeooooooooool01Oooool00oo]m_Go
m_ooooooo`04ooooo`03om?Ie_oooooooooo05gooooo00Co[jn_ol_;booN
g]koj^[Z0Oobl_8000;ok^k^00cok>c/omcLg?mlO7cof][JomoOgooQhN7o
e=CDolK6a_o<c<coc/k>om3@d?oCdm<8omGEe@0CooonmOooooSoo?cjooko
oooVjOSocmG_odI;MOmCFHgoIFZZog1g^ommQ<SoQ8c;ohZAb?nAUlWoV9g7
oiZObOnNY=CoX:KJoj:Xg003oj>Yg@04ojBZg?nUZmgoYJ_MojF[gAKoYJ_K
4?nSZM/@ojF[f`[oYJ_M0onTZ]`2oj>Yf`0Boj>YfOnNX/ooVj;>oiNNc?n@
V<WoRYC9ohB=a_miPKooKgNeofM]ZomDFi;o@TIeol[>lOoYk?oon?_oooko
nooko?Coooom0ooYjNT2on[ZjP03oc4a<OmZJV[ojn_[00;ok>c/00?oTi>C
o`000?nEUID01?o/k>`00oo[jn_ok>c/ong]k@04ong]k@?ok^k^1?o_knl2
oo3`l003onk^k_o`l?3ol?3`00Kol?3`0ooalO42oo?cl`?omOGe00?oGemO
ob<S8ooTi>@01oofm_H2ooOgm`03ooCdm?ohn?Son?Sh00?onOWi0oojn_X2
oo_kn`Goo?cl00?onOWiooclo?olo?`01?olo?`01?oinOWooOgmoogmoOon
o_hmooooo`04oa]N/onVa^Ko^M?^ogV^j`;oZmoo00CoKVi^okBd]?oPh>3o
k>c/Foo^k^h00om69QCoARH:ob<L2P03ob<L2P;o?A`:0_m69PX01?lm70[o
8a`:oaX92_l94PX2oaX92P0<odHV2_l/4P3o;180ocdL2_l/9QCo;180ob<V
2_lJ2@[o;180ob<V2_lm70[o;1800_lS70X2ob`B0004ob`V5?l/4P3o?A`:
odH_2P;o?A`:00So8bH:ob<L2_lm70[o?A`:odHV2_lm70[oARl:odHV2P;o
Ea`001koLSP0odHV5?lm70[o;180oc@_:OmkSFKoPhAkoiF4Noo:d<7odmWF
odI<?OnVV6oo/:Z4ohf=D_nVXISob]31ob<V2_lA9P[o2A`Do`000?lA9QCo
;2HDoa4L2_lS9P[o=2lNo`T92_lA70[o2A8:oa4L2_l92@X2o`TB2P09oa4L
2_l92@[o2A8:oa4L2_l92ACo4A`:oaXB5?lS9P[oH44D00;oH44Y00OoUD`Y
oiik<on`Q6Kog;>Sol[@`OnVLU;oPg/c00;oPehc00SoJVLcoh=N<onVLU;o
/8Akol6QQ?oL_[Ooi=3<ongIc0;om_Ke0_ofkNX2ooKoo`0=ooooooo1Ng_o
/8dcolZn[OoC_Xkodh@0olZH5?oCQ03oi:X0om>H2_oT/bWoi;=7ooK7?@03
ong7G00@ooKII_ofd8Coon>>ooKII_o]ahCom]UVonfn?Oofacgom/LNom>H
2_of/`3o?A8:ofYE7_nELTOoi=3<ooKoo`;ooooo00WobYPYonBZ0?of/`3o
kKhmooK7?OoT/bWom/L:onBc7_ood3d00_ofacd2ooK77P0;ooK7?Oofd8Co
om0mooK7?OoohhCom]24oooI:OoffFKom/LmooKII_oT/dL00ooohh@00ooo
kHkoon>4ooo]SP04ooo]SP;oon>401[om]UVoooSQ?ofacgokLMLonBc<oo:
V1CodiP:ol640?n=E@[oJT4:oc@_7_l/9QCo4A`:oaX92_lA70[o6RHDob`B
0?ookLcom_oeooo]c?niZVoo=5DYoaXB5?lJ9QCo2@T:om>Q:@;oong<00oo
onf>ong7Q?o]aecokKhmom>Q:OmkC1Co;2HDoa4L2_lA9QCo6Q8Dob`V5?l/
71CoPbl0ok1k2_oL/jd01Oooool00oofooooooooooooo`05ooooo`03ong]
j_o]m_Gooooo00Cooooo00?odmWFonk^k_o^k^h0GOo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@000_oVi^H03?oTi>Coe=CDogalO?oIfMWoh>3Pon7Q
hOoEeMGob<S8ol_;boo>c/kod=3@om?Cd`Soe=CD01?oooodoooomooknoWo
o?ooonoboooDf_CoCeAnodE;OomHGIgoIFZ^og1g_OmhP<7oOhFoohJ=`On<
TkooSiK0oiFIb?nIWLgoWJ7A00;oWj?C00?oWZ;BoinSd_nPY=<00_nPY=<F
oj2Td@03oijRdOnNX];oWZ;B00coWZ;B00?oWZ;Aoj2TdOnPY=403_nPY=48
oj2Td`;oXJGD00?oX:CCoinSd_nNX]400_nMXM004_nMXLkoTi[4oi:I`on>
U<CoQXg1ogn8_omhPKcoKGFdof9ZZOmJH9koADb3odU=N_oAe_KoloSooo_n
oookoOSoo?ofooooo@?oj>SX0_oYjNT02?la<C7o:RXZoe]KFom8B4So:BTY
o`H61_n3Ph?oj^[Z2?o[jn/3onc/k0;okNg]0oo^k^h:ono_k`?ol?3`0ooa
lO400ooclo?ol_;booCdm002ooCdm008on7QhOln?Sko71`LogIfM_nATI7o
Kfm_obh^;_ng]kL2ooKfmPGomoOg0oohn?P4ooWin@03oeQHF?n?Shoon_[j
00Won_[j0_okno/2ooclo003oogmoOono_koo_kn03_ooooo00Co7f6doj?2
i?nhdnooMjk[0_nZgol01?mZJV[o[Zj^omSHf?oTi>AKonKViP05ocdL2_lS
9P[o?A`:ob<L2_lm4PX00_lm70X5odHV2P;o4A`:00Oo2@T:ob`B0?lm70[o
?A8:odHV2_m6;`[o;18000;o?A`:00Co4A`:ob`B0?m69P[o;1800_lm70X0
1olS9P[o?A`:ob`B0?lS9P[o8a`:ocdL2_l/4P000olm70X01?lS9P[o?A`:
ocdL2_m6;`X2oeLL00?oARl:01CoARHDoeLL0?m69P[o;180odI<?OmbSEco
LXf4ok2n`OoLhn3odmWFong]j_n`/kOob]3Fom?Ie_o]m_Go`LO1oa4L2_lA
9P[o2@T:oa4V50;o4A`:00Oo6Q8Doa4L2_l94P[o/:Z4odHV5?l92@[o2A8:
00;o4A`:00?o2@TDoaXB5?lA70X00_l92@X02_lA70[o2@T:ob<_7_ld;ako
H44Yog8h5?nEC2WoUEhcok2=D_o1XH@2onC7`@0:oiEbAon3GQCoPehcog]<
5?mP@BWoPehcoij4I_o1Ng_og;>SonC7`@;okMW<00Com^gZooKfmOofkN[o
m^gZ0_ofool05?ooooookMW<ok1b0?oCV0[o^H@Dom>40?oCXBWobYPDonBZ
0?o:V1Coi;<conBcAoo]_Sgoi;=7oooSS_ofacgokLMLooKII_oohhkom]24
0_offFH02OoofCgokLMLooK77_oT/akoi:X0of115?mPGS?oYXABong]jP03
ooKoo`04onfn?OoCQ03oom0monBcA`;om/Lm00?oi;<NooK72_oT/c<00_of
aah03OoT/bWom[<0ooJc0?ofacgokLMLooK72_ofacgom]UVooK7?OoffFKo
i;=7ooKII_ofaah00_offFH3oooSQ004ooo]c?ookHkoon>4oooSSP?oon>4
01gom]UVoooSS_ofacgom]24onBc7_oCXBWodiP:okV45?nNLP[oNd`:odHV
5?l/9QCo8a`:oa4L2_lJ2@[o4A`:ob`B0?ookLcom_oeongIc?o1/hkoJT4:
oa4V5?l92ACo2@T:om>40?ofooGoonf>ong@V002ooK@Q00:ooK7?OoCQ03o
UEDDof0_5?lA9QCo6Q8Dob`L5?l92@[obZ4mooo]c0Oooooo00?om_oooooo
ooooool01?ooool2ooKoo`03ooK]j_oooooooooo00?ooooo00?odmWFonKV
i_oVi^H0GOoVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h03?o/
k>cog=cLogalO?oIfMWoh>3Pon7QhOoEeMGoalO7ol[:b_o>c/kod=3@om?C
d`Soe=CD01?oooodookomoojo?Ooo?ooooGhoooGfoKoF5f5oca2M?m<D8oo
FEjPofM//?m_MkSoN7jhoh27^on8Sk_oRi:lohbA^onAU/3oUic600;oVj3:
00?oVYo9oiZOaonKX<P00_nJWlLEoiZOa@03oiZOaonLXL_oW:7;00koW:7;
00?oVYo7oiZOaOnJWlD01OnJWlD8oi^PaPSoVj3800GoWJ;:oibQbOnKX<So
VIk6oiNLa002oiJK``0BoiFJ`_n=UKcoS9>mohJ>_OmnQKWoMWnhofmg]OmT
K:goFf2PodY@S?lm@gOoEeb6om_PoOoho_oomO[nooKkmOonoo[oooom0ooY
jNT00ooZj^[ojNWYoj6QX@02ohf=S@03oiFEUOnd];Cof=SH00Ook>c/1_o]
kNd2onk^kPGokno_2oo`l?03oo7al@03oo?cloodm?Com_Kf00;om_Kf00So
moOgooKfm_n/[:coNg]kofEUIOn4Q8CoYjNWonSXj0;omoOg1Oohn?P2ooWi
n@03ooShn?oinOWonOWi00;onOWi00?o[jn_olS8b?ojn_X02Oojn_X2oo_k
n`;oo?cl00?ooOgmookno_ono_h0>oooool01?lOH;CoYLCVokWCkomg[^/2
ojWLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00ooH2lDob<V2_lS70[o;180
ob<L2_l/4P3o8a`:odHV2_l/4P3oH2l:odHV2_l/4P3o8a`:oaX92_lA70X0
0_lS70X01olS9P[o;180ocdL2_lm70[o8bH:ob`B0?lJ2@X00_lS9PX01OlS
70[o;180ob<L2_lm70[o8bH:00;o8a`:0_m6;`X01ol/4P3oARl:ocdL2_lS
9P[o?A`:odH_2_lm70X00_m69PX01Olm70[oEa`0odHV2_m6;`[oEa`000;o
ARl:00Go8bH:ob<_7_mZNfooPhAkojJc`@02ol[@eP03ongfmOn`/kOob]3F
00;ob]3F00[odn?eol[@`OmkSFKoUIQVo`T92_lA9P[o4A`:o`TB2_l92ACo
H44Y0_n3Nc<00om6;`[o8a`:oa4L2P05oa4L2P;o2A8:00go2@TDodHV5?mP
;aCoH2lDof11:OmkC1CoUEhcok24Noo1XHCokMW<onC7`OnNNc?oJUDN00?o
H44Y00GoLSPDojIEI_n`NfKog;>Sombn]`02ongIc0?om_Ke00?om^gZooKo
ooofool00_ofool01?o1XHCo/780olZH:Oo:XCd2olZH500:om>Q:OoCV0[o
bYPDonBc<ooT/akokLMLonBZ0?o]aecom]UVoooSSP?om]UV00_om/Lmong7
Q?ofacgokLMLonfn?OoTZP3oH44Dog9WD_n`ZXCom^gZooKfm@02ooooo`0:
ombcQ?oT/akoi;<cooKII_ofacgom/LNonBc:Oof/`3oi;<NooK7?@?om/LN
00ooi:X0ooo@?Oo]aecom[<0ooK7?Ooohhkom/L:ooKII_ofacgoom0monBc
Aoo]aecoon>>ooKII_ookL`00oookHh08?oohhkoonf>ooKII_oohhCoonf>
oooSQ?offFKom/LmooKII_o]_SgobYPDom>40?o1Q03oWW8:og]<2_m69P[o
6RHDob<L2_lJ2@[o6RHDoaXB5?l0003okM2HooKomOookLco`K>>of115?lA
9QCo2A`Do`T95?niI`3oong<0_oohhh2ooK@Q009ooKII_oT/bWoSED:of11
5?lJ71ko2A`Dob`L5?lJ2@[obZYV00Sooooo00?om_ooooooooooool01Ooo
ool00oo]m_Gom_Keooooo`04ooooo`03om?Ie_o^k^kok^k^05gok^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo00cooOgmonc/k?mkNg_of][J
omoOgooQhN7oeMGEolK6a_o:b/[oc/k>om3@d?oCdm<8omCDe00Foo[llOoo
ooSoo_okooOko_okooool?Gooh24ZOll@6ooBTn9od98Q_mJGiooL7JdogQn
^?n9T<CoV:3>oifTc_nNXlWoY:[>ojR^d_nV[=3oYJ_=ojN]c`;oZ[3B1?nX
[/h4ojR_c0SoYjg=0_nV[<`2ojN]c@07ojR^c_nY[looZ[3@ojZ`d?nZ/=;o
ZJoAojN]c`02ojJ/cP03ojN]conY[m7oZ[3B00SoZ:k@2?nX[/h8ojN]c@So
Yjg?00GoYJ_=ojR^d?nX[]3oYJ_=ojBZc002ojF[c@0Boj>YbonFW/?oZK3J
ohZB`On9T<CoPXS2of1VY?mJGiooAd^:ocHkLom5BGSoM7ZNooKloooioooo
lOKioocooOodmo3oooom0ooYjNT2on_[j`?okNg]2_o^k^h7ono_k`Kol?3`
2ooalO43oo;blP;om?Cd0oofm_H:ooOgm`gon?Sh2ooinOT2oo[jnP?oo?cl
0_ono_hkooooo`04oa]O]_nTa>Ko^M?_ogJ]jP;oZn3o00CoMWIfol71`Oo`
l?3ooOgmFoooool01_mP@ACoEa`0oaXV5?lA70[o8a`:oa4L2P;o?A`:0_m6
9PX01_mG703oARH:ob`B0?lS9P[oEa`0ob`V50;o;18000KoARl:ocdL2_l/
4P3o8bH:ob`B0?l94PX2ob`B0007ocdL2_m6;`[o8bH:ob<V2_lm70[o8bH:
ocdL2P02ob`B0003odH_2_lm70[o;18000;oARl:00Oo;180odHV2_m69P[o
ARH:odH_2_m69P[oEa`000;oARl:00OoARH:oeLL0?m6;`[o8blNoiFHXonE
XHkoYZZ]00;ob]3F00KokNgZohfHS_nVV8CoLXeLofYW<ombSCd2oh=k<`0@
oiEE0?mkC0[o2@TDodHV2_mP@ACoLSP0og]10?mb>03oH2l:oeLL0?lm70[o
4A`:oaX92_lA70[o6PT:oa4L2P;o2A8:00Go4A`:ob`L5?m6;`[oARHDof0_
2P02og8h500AoiE<:Oo1Ng_og;>]ongIc?o:d<7oUEhcoh=N<omkC1CoH44Y
oeLL0?mb>1CoUD`Yok11<oo1Ng_oi:ZHooo]c?ofkNX01_ofm_D01?ofoooo
ooooooK]j_n`LP02olZH500BolZH:OoCXBWodiP:olZH5?oTZP3oi;<conBc
:Oo]_Sgoi;<Yonfn?Oo]aecokM2HoooSQ?o]aecom]UVonfn?OoffFKokLML
0_ofacd01OoTZP3oWW8Dof1N<onVXISokNgZ00;om_oo00cooooookV=<oo]
_Sgom/LNonfn?OoffFKom/Lmonfn?Oof/`3om/LNooJc0?oT/dL2onBc:@0?
oonc0?ofacgokLMLooK72_oofBWom]UVooo@?OoohhCom/Lmong7G?oTZP3o
m]UVoooSS_oohhCoon>>00Goonf>00Gom]UVoooSQ?ookHkokLMLoooSQ002
ooK7?@08onBc<ooT/akodiP:om>H2_nVLP3oNd`:odH_2_l/9Q@2oa4L2P0>
o`T95?lS70[o0000ombcQ?ofooGoong<ol6cS_mZIc?o4BHDoaXB5?l94P[o
Pbl0ooo]c?ookHh2oooSSP;om]UV00Soi;<NoiiN5?mkC1Co8blNoa4L2_lJ
9QCo6PT:okUb<a3ooooo00?om_ooomcSh?ooool01?ooool00ooCfMKooooo
ooooo`1Mooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP0<onc/
k?oLg=coMgMgom[Jf_oPh>3ohN7QomCDe?o7alOoc<c<olo?coo@d=3odm?C
2?oFe]H05oooooSomoSboooonoonoooomOSoooOjoonh^m[o;C1IobhaI?lh
?GGoDUJCof9XX_n1R;ooYJgNojF]fonOYlko[kGGokFlfOni_moo]kkKokJm
f_nh_mco^L3M00;o^L3L00?o^L3JokW0g?ni`=X01?ni`=X2ok_2g00<ok_2
g_nk`]co^l;Nok_2g?nk`]ko^l;LokNnf_ng_]So^;oKokW0f_ni`=co^/7K
0onk`]h03_nj`Mgo^;oLokNnf_ng_]_o^;oKok[1g_nk`]ko^L3MokW0g?ni
`=go^L3LokW0gOni`=co^L3M0_ni`=`03Oni`=[o^L3LokW0f_ni`=co^L3J
okW0g?ni`=[o^l;Nok_2g?nk`]ko^l;Lok_2g_nk`]`01?nk`]h07onk`]oo
^l;Nok_2gonk`]ko^l;Ook_2g_ng_]_o^/7Mok[1g_ng_][o][gJokRofong
_]_o]K_KokNohonX/=OoX:SGojJ]hOmhO[SoD5BAoe=GU?lo@G[o@DAgobT/
EOnm`^3om__ooo;foookooooo?omookonoooood00ooWinL00ooXj>SojNWY
on[ZjP05on[ZjPOojn_[0oo/k>`3ong]k@03ono_koo^k^kol?3`00;ol?3`
0_oalO4;oo;blPColo?c1?odm?@:ooGem@?om_Kf0_ogmoL2ooWin@04ooSh
n?ojn_[on_[joo[jnP;ono_k3Oolo?`2oogmo@03ookno_oooooooooo03_o
oooo00Co6ejcojG4i_ned>koNJk/0_nWg?l01?m^KVko];Bdon3Ph?o/k>aK
onk^kP0<of0_5?m6;`[oPcP0ob`V5?lS9P[o?A`:odHV2_mG703oH2l:og8V
0?m69P[oLRH00_m69PX00olA70[o;180ob<V2P02ocdL2P05odHV2_l/4P3o
ARH:ob`B0?l92@X00_lm70X02?lS9P[o?A`:ob`B0?m6;`[o8bH:ob`V5?lm
70[o8bH:0_lm70X00om69P[oARl:ocdL2P02ocdL2P0PodHV2_lm70[oARl:
oeLL0?m6;`[oARH:odH_2_mb9P3oARl:of0_2_lm70[o2A`Nog^=I_n3V8ko
/;k1ol[@e_o]m_Go/:Z4oeLL0?n3GQCoLSP0og]10?mb9P3oLSP0og]10?nE
E@3oYW80oh=N5?n3@@3oNd`:ofY12_mP;`X2odH_2P04ob<V2_lS70[o4A`:
oaXB50;o4A`:01;o4BHDoa4L2_l94P[o2A8:odI17_ld;c?oH44Yoc@_<omb
>1CoJUDNoiE<:Oo1XHCog;jgonC7`Oo1/jgoSHe7ofYW<olS70X2of0_5009
of11:OnELTOoUD`YojIEI_n3;`3og;jgooo]c?oooooom_oo00;om_Ke0_of
kNX02_ofm_Gom_oooooooon`LP3o^HdYolZH5?o:V2Woi:X0om>40?oLZS<2
onBc<`09onBc7_o]_SgokKhmonBc:Oofaakoon>>ooKII_o]aecoom0m00;o
kLML00Som/LNong7G?ofacgoi;<Yoh=N5?mZIc?ob]31omcSeP?ooooo00Co
YW8DooK@Q?oT/c?om]UV0_ofacd01ooT/c?om[<0ooK7?OoT/c?oomTYonBc
:Oof/`000_oTZP004_o]aecom[<0ong7G?offFKoom0mooKII_ood3gom]UV
onBc7_offFKoon>>ooK@Q?offFKoon>>ooK@Q?ookHkom]24ooo]SP;oon>4
00kom]24ooKII_offFKom/Lmonfn?OoT/c?odj4YolZH5?niQ1Co/7/:og]<
2_m69QCo;2HDob<V2P;o6Q8D01Wo4BH:o`000?niV5coong<ongIc?oC_Xko
JUDNo`TL5?lA9QCo2A`Dog8V0?ookLcoon>4ooK@Q?offFKom]24ooKII_oT
/bWo/7/:ojI<0?ld;ako4BHDob`L5?lJ4QCoYT4000Wooooo00?om_oooooo
ooooool01?ooool00oofooookNgZooooo`04ooooo`03omcSe_o^k^kok^k^
05gok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV00Coi>CTomCD
e?mfMWKofMWI0_oOgml01_oDe=CoalO7ol[:b_o>c/kod=3@om?Cd`SoemOG
01_ooookooOhlooooogoo_ooooGfnoolo_oonogoogYmW_lg>F;o;c5RocTl
LOmQIYgoV9kBojbbi?nW[]co]KgTok>ifOnj_mco_/?Qokg2gonk`=go_<7N
okg2gonm`mgo_/CNokk4g?nna=h01Onna=`2okg3f`0<okg3gOnm`m_o_L?M
okg3fonm`mgo_L?Kokc2g?nl`][o_L?Mokk4g?nna=ko_lGM0onoaMl03_nn
a=ko_L;Ookc2g?nl`Mko_L?Mokk3h?noaMoo_/?Pokk4g_nn`n3o_/CNokk3
h?nna=ko_/?P0_nna=h03Onna=co_/CNokk4g?nna=ko_/CLokk4g_nna=co
_L?Mokg3fonm`mgo_L?Kokg3gOnm`m/01?nm`md07?nm`]oo_L?Mokg2gonm
`mgo_L;Ookg3gOnm`]oo`<KPol35h_nm`mgo_<7Nokk4g_nl`Mko^;oLokNo
hon_]mko[[CTojN]hOn6Rl?oGf6Jocm2NOlV:5_o82=<ogn2Xooam_oon?co
ooOloooho?d2ookoo@04oooooooVi^Koi^KVonKViP;oj>SX1_oZj^X:on_[
j`?ok>c/0_o]kNd3onk^kP[okno_0oo`l?03oo7al@03oo;bl_oalO7ol_;b
00;ol_;b0_oclo<8ooCdm0?omOGe0_ofm_H3ooShn0?on_[j0_okno/=oocl
o0;ooOgm00?oo_knooooooooool0>oooool01?lKGkKoY<CVokSBk_mf[NX2
ojcOo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00?oNd`DoiEE5?lA70X00_l/
4P04odHV2P03of0_2_mZ@@[oH2l:00;oH2l:0_lm70X02?mP;`[oARl:oeLL
0?m69P[o?A`:ob<L2_m69P[o2A8:0_m69PX00om6;`[oEa`0ocdL2P02ocdL
2P0=ob`B0?m6;`[oARH:ocdL2_m6;`[oEa`0ocdL2_lS9P[oEa`0ocdL2_m6
9P[oARl:oeLL0002of0_2P0JoeLL0?m6;`[oARHDoeLL0?m6;`[o?A`:odHV
5?lmGSgoH5hcojJQV?oTd<cog>?Poiib5?mkC0[oWUhDoh=N5?nNLP[oPehD
oh=10?n3GQCoNd40oiib5?n3GQCoSED:og8h0?n=E@X2odH_2P;o4A`:02;o
8a`:oaX92_lA70[o4A`:o`TB2_lS70[o;180o`TB2_lS9P[o?A`:oeLL0?m6
;`[oAT4Nof11:Omb>1CoUD`Yom>nS_oTal7o`J64oiEbAon3GS?oLSPDodHV
5?mP@ACoWW8DokVHG?o:_Zgo`K>>oooooooL_ZgoYW9BojIEI_ofkN[ooooo
0_ofool02_oTal7okMW<ooKfmOofoooooooooiib2_nNNc?o/8@Yok2=D_n`
Q2T2oh=N50;o^IQL00OoYXABoiik<onNNc?obZ4moiF4D_nNNc?oSHe700;o
UIQV01[o^IQLojJ4D_nEV6KoPg/cofYW<oo1/jgokNgZoiF4D_o1al7og>?F
ooKooooooooom_oookV4:Ooohhkom/LmooKII_ofacgokKhmooK7?OoT/bWo
m/LNonBc<oof/`3om/LNonBc:@;om[<000Gom/LmooJc0?oofBWokLMLooK7
2P02ong7G003ooo@?OoTZP3om]UV00;oon>>00Goon>4ooo]S_oohhkoon>>
ooKIIP02oooSQ004oooSS_oohhCoon>>ong7G0;om/Lm00Koi;=7ombZ<ooC
V0[odiP:okV=5?mkC0X2odH_2P0Lob<L2_lJ2@[o4A`:oaX92_l92ACoWW8c
ooKomOo]fLcodkj>oh=k<ol971Co4A`:o`T95?mG703oong<ooo]S_ofd8Co
m]UVooK@Q?offFKokKhmokUb<oniQ1CoH2lDoa4V7_lJ9QCo6Q8Doh<_013o
oooo00?om_ooomcSe_ooool01?ooool00ooCfMKoi^KVonKViP1MonKViP04
oifMWOng]kOob<S8om?Cd`7of][J0002onk^kP0<onc/k?oMgMgoLW9bomOG
eooOgmooh>3Pom;Bd_o7alOob/[:olc<c?o@d=3odm?C2?oDe=@2ooono`0F
oo[imoohn?Sooooooogmooolo_ook>kooe9CL_lG6D3o:biKodY>O_mfNZ[o
[;;Rok>jj?ni_^So/kOJokZogonn`n?o_L;Rok_0h?nl`Moo_L;Pokc1gPGo
_L;O0onm`md:okc1gP;o_L;O1_nn`n001?nm`]oo_<7Nokc1g_nm`]l2okk3
h13o_L;O2_nl`Mh06Onl`Moo_<7Nokc1gonl`Mko_<7Ookc1g_nm`^3o_lCQ
okk3hOnl`Mko_<7Ookg2gonk`=ko][_Kok>igOne_>Ko/k[XoinReOmnPKKo
BDZ0oahPDOlV9e?oGV62onoaooognol00_olool01?oino[oo_ooooSjnOoo
ool3onSXj0;ojNWY0ooZj^X3on_[j`Ook>c/1_o]kNd00oo^k^kokno_oo3`
l004oo3`l0_olO7a0oobl_82oo?cl`?om?Cd2_oemOD5ooKfmP;omoOg00?o
m_KfooOgmoogmoL00oogmoL;ooShn0;onOWi0ookno/2oogmoA7oo_kn:_oo
ool01?lMGk?oY/KVokK@k_mi[nh2oj_No`04ofi^K_nd];Coh>3Ponc/k5_o
k^k^00GoJUDNof0_5?lS9P[o6Q8Dob<V2P02oeLL00;oH2l:00KoLRH0og]<
5?mP;aCoJT4:of0_2_m6;`X3oeLL00;oARl:00CoEa`0odHV2_lS9P[o2A8:
1?m6;`X04?lm70[oARl:odH_2_l/4P3oARH:ob<V2_m6;`[o?A`:odHV2_lS
9P[oARl:ob`B0?m6;`[o?A`:of0_2_m69PX2odH_2P0@ofY12_mP;aCoLSP0
of0_2_m6;`[oARH:ob`h:OmbSEco/:Z4ojJHKoo:d<7og>?FoiF=0?mZEAko
WW8:oheE2P?oWW8:01GoYVL0oheE2_nEEACoWW8:oh=N5?mkC0[oJT4:odH_
2_lJ2@[oARl:oeLL0?lS9P[o6Q8Do`T92_l971Co6PT:ob<L2_lm70[o8a`:
ob<V2_ld;ah00_m69Q@02_mG703oLSPDof0_5?nEC2Wo/8AVombn[On`Q6Ko
UEDDog8h5?mP@BT3oiE<:@0XoiEE5?n`SE;oYW9BomcSh?oTal7oooooonC@
c?nVEFKom^gZooKoooofm_Gog;>4onC7`Oofm_Gom_oooooooonNNc?oWXdY
okVHG?nESE;oH5hcoh=k<oo1/hkog>?PoiFHI_n=SE;o^JY_oiF=I_mP@ACo
^IQLok2ZQ?oL_Zgoi=3<okVZKon`ZXCoYYR4oij4I_nESE;odkj>onC7`@;o
b]3100?oYZ6HongfmOofool00_ofool02?o]ahCom]24ooKII_oT/dOom]UV
ooK7?Oo]_Sgom/LN0_oT/bT02_oT/c?om/LNonBc<ooCV0[om[<0onBc<oof
/`3oi;<YonBcAoofaah2ooo@?@03ooK@Q?oT/c?oon>400Coon>>00Ooon>4
ooo]S_ofd8Coon>>ooK@Q?offFKoon>400;om]UV00[oi;<NooKII_oT/dOo
i;<colZH5?o1Q03o^HdDog]<2_mP;`[o8bH:0olA70X02olJ4QCo2@T:oh=N
5?o]d9SokMW<okVZKonNSBWo8blNo`T95?lS70[o6PT:00;oong<00coonf>
ooo]c?ookHkom]24ooKII_o:V1CodiP:og]<5?lA9QCo6Q8Dob`L5?mb9P09
ooooo`03ooKomOoooooooooo00Cooooo00?om_ooomcSe_ooool01?ooool0
0ooCfMKok^k^onk^kP1Monk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002
ooooo`04oogmoOo_knooLg=colo?c`;ogMgM00KodM7AolC4a?o8b<Sobl_;
olo?cooBd]88omCDe00BoocgoOoooOoooocmooonoooooogoooooon[Ykoon
oOooo?gooc<dD_lU9dgoCe9mofAWU?nEVLSoUY[9ojjbgonY[=Go/;CJ0_ne
^Ml00ond^=ko]KWNokJjg`02okFigPCo]KWL0one^]X8okNkgPCo]KWL1_nf
^]d4okFig0;o][[M4?ne^M`:okNkgP0OokNkh?ng^mko]k_PokNkg_ng^n3o
]k_NokBhgOnf^]go]KWNok>gf_nd^=go]KWLok6ef_n//=GoZ:gCojFZe?nX
[=_oQ8JgodY<Ool_<63o;2eIoc@dE_oemOoonogoooWmooonoooonO_hoooo
oOoknogooOgoooooo`03onKViP03onSXj?oWinOojNWY00GojNWY2_oZj^X3
on_[j`03onc/k?o]kNgok^k^00;ok^k^2_o_knl3oo3`l0?olO7a0_obl_83
oo?cl`;om?Cd2?oemOD5ooKfmP;on?Sh00?omoOgooWinOoinOT00ooinOT;
oo[jnP;ono_k0oolo?`2oogmoA7oo_kn:_ooool01?lJG;?oY<?UokSBkomi
[^`2ojcOo`04ogIfM_o1`L7ol?3`oogmoE_ooooo00SoH2l:ob<L2_lS9P[o
;180odHV5?mP;aCoH2l:of0_50;oH2l:013oLSP0ofY12_mb>1CoH2l:oeLL
0?m69P[oH2l:odH_2_mG703oH2l:odH_2_m69P[o?A`:o`TB2_mkC0[oEa`0
0_mP;`X00om69P[oARl:ocdL2P02ob<V2P04odHV2_lm70[o?A`:odH_2P;o
?A`:02?o;180odHV2_mG703oH44Dof0_2_mZ@@[oLSP0ofY12_mG703oLSP0
odH_2_mG703o8bH:odI17_mPGS?oJVLcojJHQ?o:d<7obZYVoh=N5?mk@@3o
PehDog]<2_n3GQCoSED:oh=10?mb>03oJVLcodHV2_mkC1CoJUDNog]<2_m6
;`[o2@T:ob`L5002odHV5006oa4L2_l/4P3o2A8:oaX92_lS70[o2@T:0_lS
70X03?l/9QCoARHDodH_2_m6@AkoH2lDog8h0?mb>1CoUD`YojIbD_o1Ng_o
g;>Sok2=DP;oLSPD01?oH2lDof11:OmP@BWoYUEVok1kI_o1Ng_oi:ZHombn
]oofooooooooonC7`On`Q7_om_KeonC@c?n`SE;okMW<ooKfmOofkN[ooooo
00;o`K>>00KoUIQVoh=k<onNLS?oi<O1om>nS_o1al42ol6c[@08ol6cS_nE
SE;odkj>ok2ZQ?o:_Zgob]31ok2ZQ?oLaj<2ol6cSP08oh=k<oo:d<7odmWF
ol[@`Oo1/hkob]31oiFQS_ofkNX2ooKoo`05ooKomOoffFKokM2HoooSS_of
fFH00_o]ae`01Oof/`3om/LNong7G?oT/bWom[<000;oi;<Y00com[<0onBZ
0?oT/bWom[<0onBc7_oT/dOom/LNong7G?ood3gokLMLonBZ0?o]d9P2oooS
SP06ong@V?ookHkoon>>oooSS_offFKoon>40_oohhh05ooffFKoom0mooK7
?Oofacgom]UVong7G?oLZS?obYPDol640?niSACoNd`:ofY12_l/9QCo4A`:
ob<V2_lA70[o6PT:oa4L2_mb>1Coi<O1omc7Xoo1/hko^HdY00;o4BHD00?o
2@TDo`000?o]d9P01?ookL`02OoohhCom]UVonBc7_o:V1CoPehDob`V5?lA
9Qko6Q8DoeLL0009ooooo`03ooKomOoooooooooo00Cooooo00?om_ooomcS
h?ofool01?ooool00ooLhmKoooooooooo`1Mooooo`04ojn_[oo;bl_og]kN
on[ZjP7ol_;b0002onk^kP0:ong]kOoPh>3oNWYjokno_ooHf=Sof][Jolc<
c?o1`L7oaLG5ol[:bP;oc/k>2?oDe=@06?ooo?oooo[oooomooooo_goo?Se
oooonooako3oookoono^o?oloOooCDi]oa<E>om5Ag3oAdYgohj@`?nGVl[o
U9K6oibNc_nSYMGoY:KFojBWe?nVZMKoZ:_HojNZe`CoYZWD1?nVZM88ojNZ
e@KoYZWD00?oYj[EojNZdonVZM803onVZM88ojJYe13oYj[E01WoYJSCojJY
e?nUZ=?oY:OBojFXdonVZMCoXZG@oi^NbOn<TKWoXZOAog1bX_m;CGko@D5c
oa0?>om>CWCoo?coookmooohnOgoo_omoo;ckOoooo_oooomooKfn?ooo_oo
oooo00?oiNGU0_oWinL6onWYj@[oj^[Z1?o[jn/4onc/k0[okNg]1_o^k^h0
0oo`l?3okno_oo7al@04oo7al@Sol_;b0ooclo<2ooCdm0;omOGe00Com_Kf
ooOgmoogmoOomoOg0_ohn?P;ooWin@;on_[j0ookno/2ooclo13ooOgm0oon
o_hXooooo`04oaeO/onUa>Ko]];^ogV^j@;oZ^3o00CoKVi^okBd]?oPh>3o
k>c/Foo^k^h2ob<V2P05ocdB2_lS9P[oH2l:odHV5?n=E@X00_mb>0002?mb
>1CoLSP0og8V0?mP@ACoJT4:of0_2_mZ@@[oH2l:0_mG70001_mP;`[oEa`0
odH_2_m6;`[o2A8:og]100;oH2l:01;oPg]LodH_2_m6;`[o;180ocdL2_mG
703o8bH:ocdL2_ld;akoARH:ocdL2_l/4P3o;2HDob<V2_m69QCoLSP0oeLL
0?mZEAh2of0_2P?oARl:00[o?A`:ob<V2_m6@AkoJVLcoh=k<on=SDOoWXdc
oiF=0?mG703oJT4:0_mkC0X04OnNLP[o2@TDoa4V2_lm70[oLXdmoh=k<on3
GS?oARl:of115?lS70[o;1`Doh=k<omZEAkoARl:ob<V2_lA70[o6Q8D00;o
4A`:00?o8a`:o`TB2_lS70X00om69Q@03?mP@ACoARHDof0_5?mP;`[o/44c
ok2=D_o1XHCog;>]ojIbD_mkC1CoJUDNof0_2P;oH2lD00CoUG97ol6QQ?oT
al7og;>S0_o]fL`02oofkN[okMW<og8V0?nVQ8Cog;jgokUb<ooTal7oong<
ooKfmOofoooog;>]00;oYYQ_00?oYXABok2ZQ?o]kNX00_o1/hh05?oC_Xko
`K>]okVZKoo1/hkoi=3<ojJQI_oLhmKobZYVom>nS_nVXFKo/:Z4og]<2_nV
V6oom^gZomc7Xoo1/hkodkj>omcSe_o1/jgog>?P0_ofool02oo]fLcokLN4
oooSQ?oohhkokKhmooK7?Oofd8CokKhmooK7?OoT/bWom/LN00?oi:X000Co
diP:ooK77_oT/bWoi;<Y0oof/`001_oT/c?om/LNong7G?o:XCgom]UVong@
V0?oon>>01Kom]UVoooSS_oohhkom]24oooSQ?offFKom]24ooK7?Oo]aeco
m/Lmong7G?oT/dOodjY7olZH5?oCV0[o/7/:oheE2_mP@ACoARHDob<L2_lJ
2@[o6Q8D0_lA70X03OmP;aCodkj>olZn[On`ZXCoUHeBoa4V2_lA9QCo6Q8D
o`T92_o]ahCom_oeooo]c?ofooD00_ookHh02?offFKodj4YonBc7_nNLQCo
;2HDoaXV5?lS;akoEa`02Oooool00oofooGoooooooooo`05ooooo`03omcS
h?ofkN[ooooo00?ooooo00?odmWFonk^k_o^k^h0GOo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@000_oVi^H03?oUiNGogMgMohj>S_nTY:Cod];BomCD
e?o2`/;o^;Rhol30`?o4a<CobLW9ol_;b`Sod=3@01Oooo_oooojooooo?oo
oo_joo[gl_ooooSoooojoogmoOooo_ooo_goooCdoomkNigo8bE<ob`_F_la
=67oB4Ykof=TV_m/KJGoM7F[ogIg[OmhNJooO7fcogj0/`03ogeo/PKoOGn`
2?mkOJh8ogeo/003ogan[ommOjooOGn_00CoOGn_00?oO7j^ogeo[ommOjl0
1_mmOjl8ogeo/0SoNgf^2?mkOK02ogeo/P0Gogan/OmkOK3oOGnbogj0/omh
NZgoLG>TofEXUOm4Ag;o9bQHoalPD?lX9UOoQHB^ooKeooofm?ooinO_oooo
oOooooSomOG[oooon_olnoWoookoooomooooool00ooRh^800ooTi>Cohn?S
onGUi@02onGUi@[oi^KV1ooWinL6onSXj0_ojNWY0ooZj^X00oo/k>cojn_[
ong]k@02ong]k@[ok^k^1oo_knl6oo3`l0SolO7a0oobl_82oo?cl`?omOGe
0_ogmoL3ooShn0[onOWi0oojn_X3ooclo0;oo_kn9_ooool01?lKG[?oY/KV
okWCk_mi[^/2oj_Oo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00?oARHDocdL
2_m69Q@00_m69PX2og]<2P0Doh<h0?mb>1CoNd40og]<2_mP;`[oNd`Dog8h
0?mP;`[oLRH0og8h0?m6;`[oH2l:oeLL0?m6;`[oEa`0odHV2_l94P[oJT4:
og8h0?mZ@@X2odH_2P03oeLL0?lS9P[o8bH:00;o8bH:0_l/4P000olS9P[o
;180ob<L2P02ob`B0009ocdL2_m69P[oARl:of0_2_m6;`[oH2l:oeLL0?lm
70[oARl:00;o;18000[o;2HDodIE:OldEBWoJT4:og]10?mP;`[o?A`:odH_
2_lm70[oH2l:0_lS70X01OlA70[oAUDYofYW<omkSFKoAT4N00;oARl:027o
8a`:ofYE7_nNSC?oJUDNodI17_lA70[o2A8:ob`B0?lJ4QCo6PT:ob<L2_l/
4P3o;1`Dob`V5?m69QCoARH:ocdL2_m69P[oH2lDog8h5?nEC2Wo^G8col5k
NooTZYSodkj>oiEE5?nEC2WoH2lDodHV2_ld;bWoH2lDoiEN<onVQ8@00_o]
fL`08Oofm_Gom_ooooKfmOofm_Gom^gZonBZV?nEC2Wog;>SongIc?ofm_Go
ooooombn]onNSC?oYYQ_omcSe_o1/jgoYYR4ol6cS_o]d9Sodkj>oij=<on`
ZXCob[j]ol[@`OoLaj?o^JY_ombn[Oo:_ZgoWXdcol6cS_o:d<7o^JY_omcS
h002okVZK`04ol6cS_o]fLcom^gZonC@c0;ooooo00Coong<ooo]S_o]d9So
on>>1?ofacd01OoT/c?om/LmonBc:OoT/akom[<000?odiP:00kobYPDooJc
0?oCV0[oi;<conBc7_ofacgoi;<Yong7G?oT/akokLMLooo]S_oohhkoon>4
oooSSP;oonf>0_offFH00ooohhCom]UVooK7?@02ooK7?@04ong7G?ofacgo
kLMLombZ<`;obYPD01?o^HdDoheE2_mP@ACoARHDoaXV5?lA70[o2A8:oa4V
5?l92ACoARl:okVZKooC_XkoYYQ_oij=<olA9P[o2A`NoaXB5?l0003og:Xc
00;oong<00com_oeooo]c?ookHkokLMLonBc<ooLZS?o`H@0oc@_7_lJ71ko
6RHDocdB2_ookL`8ooooo`03ooK]j_oooooooooo00Cooooo00?om_ooongf
mOoLhn001?ooool00ooCfMKoi^KVonKViP1MonKViP04oifMWOng]kOob<S8
om?Cd`7of][J0003onk^kP05onWYjOo5aLGoPh>3ojb/[?nl_;`00_n^[Zh0
1?nf][Ko_;blokno_oo4a<@8olW9b@0FooohoooonoooooWoookhn?ooooSo
moC[oooon?omo?Soookooo_kooono?oom?Gooo_koooFeoooFej;ob`^GolH
6E;o8B5MobX[I?l^;fSo<C9[ocDfK`Co=cQ`1_lg>6h;ocPiK`Go=cQ^0_lg
>F`4ocPjK@[o=cU/2?lg>6h8ocPiK`So>3Ua0_li>W805olh>G7o=cQ`ocTj
L_lj>g?o=3E]ob`^HOlK7Dgo9bYEoemPT?oHfOoonoWoonc[ooonnoooo_go
ooonooojnoGono_aoooom?oalNWooookooonooofm?Wooooo00?ogMgM0_oO
gml6on7Qh@[oh^;R0ooShn<2onCTi0?oiNGU2_oVi^H6onOWi`;oj>SX1OoY
jNT;on[ZjP;ojn_[0_o/k>`01?o]kNgok^k^onk^k_o^k^h:ono_k`Gol?3`
0ooalO45oo;blPSolo?c0_odm?@3ooGem@?om_Kf0_ogmoL3ooShn0[onOWi
0oojn_X3ooclo0;oo_kn4Oooool01?lOHKCoXl;TokSCkomg[^/2oj[Oo`04
ofi^K_nd];Coh>3Ponc/k5_ok^k^00GoARH:ocdL2_m69P[o?A`:oh<h0002
og]<2P0Aoh=10?mk@@3oNd`:og]10?mP;`[oLSPDog8h0?mP;`[oNd`:og8V
0?mP;`[oLSP0of0_2_mG703oARl:oeLL0?l94PX00_mZ@@X01OmP;`[oEa`0
odHV2_m6;`[o8bH:00?o;18000oo8a`:oaX92_lm70[o;180oaX92_lS70[o
?A`:oa4L2_m6;`[o;180of0_2_lS9P[oARl:ocdL2_l/4P000_lS70X01olJ
2@[o8bH:ob<_7_lS;ako=5DYoaXB5?l94PX00_lS70X04_lm70[oARH:o`TB
2_lJ4QCo2A8:odI<?On3GS?oJVLcohf=Aold;akoPg/co`000?mZEAkoPg/c
o`TL5?l92@[o4A`:oaXB50;o;18000Co4A`:o`T92_lA70[oARH:1?m69Q@2
odHV2P0@of0_5?mkC1Co^G8cokUb<oo1XHCoi:ZHok1k:Omb>1CoH2lDodHV
5?mb>1CoH2lDog8h5?nEEACoong<ooK]jP;om_Ke00gom_ooooKfmOofoooo
dkj>ojI10?oTZYSokMW<ooo]c?ofooookM2Hol6QQ?niZVookNgZ00?odkj>
00Go`K>>ohf=D_n`ZXCodkj>om?IeP03om>nSP0Aol6cS_niZVooYYQ_ol6c
[Oo]m_Go`K>>olZQD_oL/hCog<NSongIc?ofooGooooooiF4Noo1alcom_oo
ooKomOo]d9P00_oohhh2ong7G00GooKII_o]aecoi;<NooK7?OoT/c?oi;<Y
onBc7_of/`3odiP:onBZ0?oCQ03oi:X0om>H2_oTZP3om/LNonBc<oofacgo
kLMLonBcAooT/c?oonf>oooSS_o]d9P00_oohhh01?o]d9Soon>>ooKII_o]
d9P2ooKIIP0Kong7G?o]ahCom/Lmong7G?oL/ecog:XcokV45?o:V1Co`H@0
oh=N5?mZ@@[oARHDob`V5?lJ2@[o6Q8Doa4L2_lJ4QCo?A`:ok2=D_oLaj?o
UHeBoij=<om6@Ako2@T:oa4V5?lJ2@[o^G8c00?oong<00?oonf>oooSQ?of
d8@00_oT/bT01_n`SAkoAT4Noa4V5?lJ4QCo;180ooo]c0Sooooo00?okNgZ
ooooooooool01?ooool00oofooookOKeongIc004ooooo`03om?Ie_o^k^ko
k^k^05gok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000?ooooo00_ooOgm
ooCdm?ng]kOoNGUioh20P?n?ShooW9bLojFUYOn/[:co/K6aokNg]`0>ok^k
^`?o_;bl0onm_Kd00onn_[ko_Kfmokjn_P02okjn_P;o_kno2oo0`<02ol71
`@;o`/;200Co`l?3olC4a?o4a<Coa<C42_o5aLD5olK6aP;oalO700?oa/K6
olO7aoo7alL00oo7alL=olS8b003olW9bOo:b/[ob/[:00oobl_;0oo<c<`0
0oo=cLgoc<c<olc<c002olg=c@_oc/k>0_o?cll3om3@d003om7AdOoBd];o
dm?C00;odm?C0ooDe=@7omGEe@Koe]KF0_oGemL5omSHf0_ofMWI0ooJf]X2
om_Kf`?og=cL2_oMgMd5omkNgP;ogmoO00?og]kNomoOgooOgml00ooOgml8
on3Ph0?ohN7Q0_oRh^82onCTi003onGUiOoWinOoinOW00?oj>SX2_oYjNT3
on[ZjP?ok>c/0_o^k^h;ono_k`;ol?3`0ooalO400oobl_;olO7aoo7al@02
oo;blP?olo?c3_odm?@01?lNGk;oYLCVokWCkomg[^/2ojWLo`04ogIfM_o1
`L7ol?3`oogmoE_ooooo00CoARH:of0_2_m69QCoNd400_mkC1@01?n3>03o
JT4:ofY12_mZ@@X2og]<2P09og8h0?mkC0[oLSP0og8h0?mP;`[oLRH0of0_
2_mb>03oARl:00;oEa`000co2@T:og8h0?mb9P3oEa`0odH_2_m69P[o;180
ob<V2_lS70[o4A`:oaX92_lS70X2ob`B000:oaXB5?l/4P3o4A`:oaX92_lS
70[o;180ob`L5?l/4P3o8bH:ob`B00Co8a`:00So6PT:ob<V2_l/C2Wo;2HD
oba<:OlA70[o0000oaX92P?o8a`:01[o2A8:oa4L2_lJ4QCoJVLcoij=<onN
SBWoH44Dog]<2_n3GQCo2@T:of115?l/4P3o2A8:o`T92_lJ2@[o;180ob<L
2_lJ2@[o4A`:o`TB2_lA70[o?A`:odHV5?lS9P[oARH:ob`V50;oARHD00[o
Ea`0oh<h0?n`@C?o/8eBombcQ?oL/j?oYW9Boh<h0?l/9QCoARH:0_mP;a@0
1?nEC2Wo`G]kooK]j_ofool2ooK]jP0:ooKfmOofkN[okMW<ojIbD_niLS?o
i:ZHongIc?ofkN[om_KeomcSeP;o^JY_00Woi=3<ol6cS_o1/hko`K>>oiFH
I_nNNc?o`LO1ol[@`OoTd<`00_oC_Xh02?oLaj?okM2HojJHKon`ZXCog<NS
omcSh?oLaj?okM2H0_o:d<401?o1al7og;jgooKooonELTL2ooooo`0:ong@
V?ookLcoonf>ooKII_o]aecom]UVong7G?ofacgoi;=7ooK7?@;okKhm00Co
i;<conBZ0?oCV0[oi:X00ooCQ0001ooCV0[oi:X0onBc7_oT/akom]24ong7
G?o:XCd01?oohhh00ooffFKoon>>oooSSP03ooKIIP03ong7G?ofacgom/Lm
00;okLML00WokKhmombcG?oCV0[obYPYokV45?nNLQCoJT4:odH_2_lJ9Q@0
0olA70X06OlJ2@[o4A`:oiik<ooC_XkoSHe7oij=<om6;`[o2A`Doa4V5?l9
2@[oWUhDooo]c?ookHkoong<oooSQ?ookHkom]24onBcAooT/c?o^HdYof11
5?l92ACo6RHDob`B0?oL/j<02?ooool00ooTd<coooooooooo`04ooooo`03
ooKoooo]m_GodmWF00Cooooo00?odmWFooooooooool0GOooool01?n_[joo
bl_;omkNg_oZj^X1oo;blP001?o^k^h02_o[jn_oh>3PokRh^?n1PH7oL71`
ogQhN?n;Rh_oTY:BoiVIVOnQXJ4>ojJVYPKoYjNW00?oZ:RXojVYZOnZZZX0
1?nZZZX8oj^[Z`?o[:b/0_n][Jd2ojj^[P04ojf][On^[Zko[Zj^ojj^[P;o
[jn_3On`/;02ok6a/@03ok:b/_nc/k?o/k>c00_o/k>c0_nd];@3okFe]@03
okJf]_ne]KGo]KFe00;o][Jf0ong]kL:okRh^0?o^KVi00?o^[Zjok^k^onk
^k/00_nl_;`;okfm_@Go_[jn00?o`<30okno_oo1`L401Oo1`L4:ol;2`PCo
`l?31?o4a<@:olG5a@Koa/K600?oalO7olK6a_o7alL01?o7alL8olS8b0?o
bLW90_o:b/X3olc<c0?oc/k>0_o?cll;om3@d0;odM7A0ooBd]82om?Cd`_o
e=CD1OoEeMD3omOGe`GofMWI2?oJf]X2om_Kf`?og=cL0ooMgMd2omkNgP?o
gmoO3_oPh>001?lHEZOoY<CVokWCkomf[NX2oj_Po`04ofi^K_nd];Coh>3P
onc/k5_ok^k^00GoARH:odH_2_mkC1CoSED:og]10002oh=10007og]<2_mb
9P3oPd40og]<2_mb>03oJT4:og]10002ofY12P05og8h0?mP;`[oLRH0og8V
0?mG70000_m6;`X02olA9P[oARl:of0_2_m6;`[oARH:ob<V2_l/4P3o8a`:
ob`B0?lS70[o;18000;o6PT:00Go4A`:oaX92_lA70[o6PT:oa4L2P02oaX9
2P04ob<L2_lJ2@[o4A`:ob`B00;o8a`:00Co6PT:o`TB2_lA70[o8bH:0ol/
9Q@01?l94P[o4A`:oa4L2_lS70X2oaX92P03oa4L2_lJ4QCo000000;oJUDN
01;oPg/codHV2_o:XE;oJT4:oa4V2_lS70[o6PT:o`T92_lA70[o;180oaXB
5?l/4P3o4BHNoaX92_l94P[o8a`:ocdL2_lS9PX2ob`L500=ocdB2_lm70[o
?A`:odHV2_mb>1Co/44cojIbD_oTZYSog;>Sol6QQ?n`NbWo8bH:ob<_7P02
ob`L500=oiE<:Oo1XHCokMW<ooKoooo]fLcom^gZongIc?nVV8CoUEhcokUb
<ooTZYSokMW<ooo]c002ooKfm@03ooooooniZVoo`J6400;odkj>00kog<NS
om>nS_n3GQCo`K>>olZn[Oo:d<7ob[j]omc7Xoo:d<7odkj>olZn[OnVV6oo
i=3<ol[@`@;oi<O100Oog>?FongIc?n=SE;og;jgomcSe_ofooooWXAV00;o
m_oo00Soong<ooo]S_o]fLcom]UVooK@Q?ofacgoon>>ong7G0;om]UV00Co
kLMLooK7?Oo]aecoi;<N0_oCV0X3om>400;o^FL000So/5D0om>40?o]_Sgo
djY7okV=<oookHkoong<ooK@Q0;om]UV00KokM2HooKII_ofd8CokM2HooK@
Q?offFH4onfn?@;oi;=70oo:V1@08?nNLP[oJT4:ofY12_l/71Co4A`:oaX9
2_lA9QCo4A`:o`T92_n3GS?odkj>oiF=D_n=SDOo=5DYoa4L2_lA9QCo4A`:
oh<_0?ookLcoonf>ooo]c?ofd8CokM2HooK@Q?oT/dOoi;<Nok2=7_mZ@@[o
2A`Dob<V2_lJ2@[okLN42?ooool00oo]kN[om_oeooooo`06ooooo`03ol6c
[Ooooooooooo00;ooooo00?og>?Fonk^k_o^k^h0GOo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@001?oVi^H02?oTi>Coh>3Pom;Bd_nl_;coX:2PohR8
R?miNGWoLW9boom^KVh=ofi^KP09ofQXJ?mUIFGoGemOoeQHF?m:BT[o1SMe
ojG4i_ned>koNJk/00;oYmco00CoJVYZojj^[_oHf=Soi>CTFooVi^H04_m6
9P[o?A8:oh=N5?n=E@[oNd`:ofY12_mkC0[oLSPDoh=10?mk@@3oNd`:oh<h
0?mkC0[oNd40og8h0?mkC1CoLRH0og8h00;oH2l:00GoEa`0of0_2_mG703o
6PT:of0_2P02oeLL000=odH_2_m69QCo;180ob<L2_lA70[o6PT:oa4V5?lJ
2@[o2@T:ob<L2_lA70[o6PT:o`T92P02oa4L2P03oaX92_lA70[o;18000;o
8a`:00Wo4A`:oaX92_l94P[o;180oa4L2_lS;ako=2lNob<_7_lJ9Q@00_l9
4PX01?lA70[o6PT:ob<L2_lJ2@X2oa4L2P03oaXB5?nNSC?oARl:00;oPg/c
00?o/:Z4ofYE7_lS9PX00_lA70X02?lS70[o4BH:o`TB2_l/4P3o4A`:oaX9
2_lJ4QCo2@TD0olS70X07Ol/71CoAT`modHV5?lm70[oH2lDodHV5?n3;`3o
UD`Yok1k:OoC_Xkog;>Sol6QQ?n`NbWoEa`0oaXV5?l/71Co=2lNoiEN<ooT
ZYSom^gZooKoooookLcoi=3<ok1kI_n`@C?o^G8conBZV?oTal7okMW<00;o
m^gZ00Com_KeooKomOniZVoo^IQL0ooC_Xh06OniZVoo`K>]om>nS_oCfMKo
dkj>om?Ie_o:_Zgog<NSolZn[OoTd<cob]31onC@c?o:d<7o`K>]om?Ie_o1
/jgoUIQVoij4I_nVV6ooLVMBojJHQ?oL_[OoooooooKoooo]d9P00_ookHh0
1?ofd8Com]UVooK@Q?ofd8@2ooKIIP05ooK@Q?offFKokLN4oooSS_o]ae`0
0_oT/bT01Oo:V1CodiP:om>40?niI`3oi:X000;oi;<Y00?om]UVonfn?Oni
Q1@00oookHh02Oo]ahCoon>>ooKII_o]ahCom]UVoooSS_ofd8Com/Lmong7
G002onfn?@03ong7G?o]_Sgog;=L00;obYPD00Ko/8dNoiib5?mkC0[oARl:
ob`V5?lA70X2oaXB50;o4A`:00_oPehcokVZKon=SDOoPg/coc@_7_lA9P[o
6Q8Doa4V5?mb9P3oong<ong@V002ooK@Q0;om]UV0_oCXBT01_niSC?oH44D
o`T95?lJ71ko2@TDom>ZA`Sooooo00?okNgZooKomOooool01?ooool00oof
oooooooool6c[@04ooooo`03omcSe_oVi^Koi^KV05goi^KV00CoWIfMokNg
]oo8b<Sodm?C0OoJf]X000Cok^k^00_ojn_[on3Ph?nc/kgoH62>obHbOol9
;HKo03ZCo`=2V?l=CIgo5EFSoaePZP0@ob9T[P;o8fF^0olTIJh3obEV[`?o
9fN`0olXIk08obUX/0?o:VVa0ol[J[800ol]K;?o;6bboba//P02obi^/`?o
;fnd2Ol`KkD3oc1_]P;o<72f0_laLKL01?laL;So<W6ioc9a^OlbLKT3oc9b
^@So<W:j0olcLkX3ocAc^P03ocIe_?lfM[co=WJl00?o>7Rn0_liN;l9ocYi
_`?o>g[00ollNl400olmO<;o?7_1ocel`P02ocel`P?o?Wc32?lnOL@3ocmm
a@?o?gk50_m0P<H01?m1P<Oo@X;9od:2bOm2P/T3od:3b@So@h?:0om3Q<X3
odB4b`03odF4c?m4Q<_oA8C;00;oAHC<0om6Q<d9odJ5c@;oAhK>0om7Qll2
odR8d@04odV8d_m:R]?oBX[CodZ:d`?oBX_D2?m:S=D3odZ<eP?oBXcG00?o
BXgHodZ>eom:S]L00om:SmP2odZ?f@WoBXoJ0om:T=/2od^Af`;oCI;M00Co
C97NodjBgom>T]ooCY;O0om?Tml8odnDh0?oD9CQ0om@UN<00om@UNKoDIGU
oe6Ei@03oe6Fj0?oDIOZ3_mBUn/01?mGYOgoXL;UokSBk_mf[NX2ojcOo`04
ofi^K_nd];Coh>3Ponc/k5_ok^k^0_mb>1@04_n3GQCoPd40ofY12_mZ@@[o
Pd40oh<h0?mZ@@[oSED:og]10?mkC0[oPd40og8h5?mkC0[oLRH0og]<2_mP
;`[oLSP0og8V00;oH2l:00[oEa`0oa4L2_mP;`[oH2l:oeLL0?mP;`[o;180
odHV5?l/4P3o8a`:0_l/4P001olJ2@[o4A`:oa4L2_lJ2@[o;2HDoa4L2_lJ
2@X00_lA70X04?lJ2@[o4A`:ob`B0?l92@[o8a`:ob`B0?l92@[o;180oa4L
2_ld;ako;2HDoaXV5?lA70[o2A8:oa4L2_lJ2@X2ob<L2P0Goa4V2_lJ2@[o
6RHDoa4L2_nESE;oNd`:ofYW<oo1/hko^IQLoh=k<olS9P[o4A`:o`TB2_lS
70[o2@TDob<L2_l/4P3o2A8:oa4L2_l94P[o4A`:ob<L2_lS9PX00_lS70X0
1OlA70[oARHDodHV5?m69P[oH2lD00;oLSPD00ooWUhDol6QQ?oTZYSo`J64
ok2=D_m6;`[o;2HDocdL2_mG703oYW9BonC7`OookLcom_KeonBZV?o1Ng/0
0_niLS<06?oT_XCog;>]ongIc?ookLcom^gZooKfmOofooooi=3<ol6QQ?n`
SC?o`K>>ol6c[OnVV6oo`K>>ooKooooCfMKo`LO<omcSh?o:d<7oi=3<olZn
[Oo:d<7og>?Fongfm@;ob]31013ob[j]omcSe_n`ZXCo/8AVok2ZQ?oLaj?o
b]31omcSh?oooooom_oeooKoooo]d9Soong<ongIc?offFKokM2H0_offFH0
3?ofd8CokLMLooKII_ofd8Coon>>ong@V?ofd8Com]UVonBcAoofacgokM2H
ooK7?@;okLML00[oi;=7ong7G?oCXBWo^H@Yoiib2_oohhCokMW<ooo]S_oo
hhCokM2H0_oohhh02?ofd8Coon>4ooK@Q?offFKom/Lmong7G?ofacgokKhm
0_oT/dL01oo:V2Wo^HdDolZH5?nNLQCoNd`:of115?lS70X00_lA70X06_lA
9QCo6Q8Do`TB2_mZEAko^JY_ojJQI_nESE;oARl:oaXV5?l971Co6Q8Dog8V
0?oohhkom]UVooK@Q?oohhkokLMLonBc<ooCXBWobYPYok2=7_mP@ACo2@TD
oa4V2_l92ACo^G8c2?ooool00oo]m_GokMW<ooooo`04ooooo`05ooKooooo
ooooYZZSooK]j_ofool00_ooool00ooCfMKok^k^onk^kP1Monk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q0003ooooo`0<oogmoOodm?CoZj_0ocPmR_l7
;Y?o0D6No`mDZOlSI;7o<G2gocik_om4P<7oBXG43OmBRlP4ooglo@03oogm
noomoOWooOgi00;ooOgi00OooOgkoocjnoodl_Gom?7hongZlooQg^Oog]_V
00;oe=7L00goe=3NomCAg?oDd=koe=7LomC@g_oDdMcoeM7OomGBgOoEdMoo
eM;MomGAgooEd]goeM7O00;oeM;M02koeM;KomOAgOoEd]_oem7MomGBfooG
dMgoeM;KomOAgOoEd]_oem7MomGBfooGdMgoeM;KomOAgOoEd]_oem7MomGB
fooGdMgoeM;KomOAgOoEd]_oem7MomGBfooGdMgoeM;KomOAgOoEd]_oem7M
omGBfooGdMgoeM;KomOAgOoEd]_oem7MomGBfooGdMgoeM;KomOAgOoEd]_o
em7MomGBfooGdMgoeM;KomOAgOoEd]_oem7M0ooEd]d05_oEdMooeM;MomGA
gooEd]goeM7OomGBgOoDd=koe=7LomC@g_oDdMcoe=3NomCAg?oDd=koe]3N
om;9g?oRfN[oh=[XoncVl?ofm?Wom?Cfoocln_omoOT2oogmn007oogmnOom
oO_ooOcmoogloOomnogooOcmoogmo@02ofnUh@?oKjKQ0om`Yn82og6Xh`04
og6WhombZ>CoLZSTog:Xi0?oLjWU2?mcZ^D6og>ZiP03ogB[iomeZnOoMJ_W
00GoMZcX2Omf[>T2ogN]jP?oN:k/0_mj/>h01?mi/>goNk;_og^bkomk/^l3
ogbcl@SoOKCb1_mn]O<00omn]_CoO[Oeogjgm@05ogjhmPWoO[Wg0omo^_L2
oh2ln0;oP[oj00CoPkkjohG1o?n5`OcoQL7l0on6`od8ohO4o@?oQlGm0on7
a_d3ohS7o@?oRLSm0on9bOd>ohW:o@04oh[=o_nM`n[o]]3^ogV_kP;oZmko
00CoMWIfol71`Oo`l?3ooOgmFoooool05?mZ@@[oLSP0oh=N5?n=E@[oARH:
og8h0?n3@@3oLRH0oh<h0?n3@@3oSED:oh=10?mkC1CoPd40og]<2_mb>03o
Nd`:og8V0?mkC0[oLRH00omP;`X03?lA70[oJT4:og]10?mb>03oARHDoeLL
0?l/4P3o8a`:ob`B0?lJ2@[o8a`:oa4L2P;o6PT:00_o4A`:o`T92_l92@[o
6PT:o`T92_l/4P3o4A`:oaX92_lA70[o8a`:o`T92P02ob<L2P;o4A`:00?o
;2HDoa4V2_lA70X00_l92@X00ol94P[o6PT:oa4L2P02ob`B000Co`TL5?lS
70[o0000ofYW<on3Nc?oH5hcol[@`On`ZXCoUIQVog]<2_l94P[o8a`:ob<V
2_l/4P3o4A`:ob`B0?l92ACo2@T:oa4L2P02ob`B00?o8a`:00?o6PT:ob<V
2_mP;a@00_mP;a@05?nEC2WoUEhcoiE<:On`SE;o`J64ok2=D_nEC2Wo?A`:
ob`V5?lJ9QCoH2l:ol5kNoookLcom_KeooKoooo1Ng_obZYVombcQ?oTZYSo
g;>]0_ookL`02_ofkN[om_KeooKfmOofooGokMW<om>nS_niSC?obZYVonC@
c?o1/hh2ong]jP07omc7Xoo1/hkog<NSonC@c?n`ZXCob]31ooKom@02omcS
eP05ol6cS_o:_Zgob[j]onC7`On`ZX@00_o:_Zd02OnVZZ?og;jgongfmOof
oooom^gZooKooooT/dOoong<ooo]SP04ooKIIP03onfn?Oo]aecom]2400?o
m]2400CokLN4onfn?Oo]_Sgom]240_o]ae`05OoffFKoi;=7ong7G?oT/bWo
^H@DojI10?nEEACoong<ongIc?ookHkokM2Hooo]c?o]fLcoong<ong7G?of
d8CokLN4ooKII_oT/dOokLMLonBc<`02onBcA`0FombcG?o:V2Wo^HdDokV4
:OnVLP3oJUDNofY12_lS;ako4A`:oaX92_lA70[o2A8:oaXB5?m6;`[obZYV
ohf=D_n=SDOo8blNoaXV5?l971Co6Q8DocdB2P;oon>>00gom]UVong7G?of
acgoi;=7ombZ<onVLQCoSED:oh=N5?l971Co6Q8Doa4V5?nNGQCom_oo00Oo
oooo00Gom_oeonC@c?ooooooooooooKoo`02ooooo`08ooKooooooooo`K>]
omcSh?oooooom_oooooooooLhn1Oooooo`04ojn_[oo;bl_og]kNon[ZjP7o
l_;b0003onk^kP0<onWYjOo0`<Wo>Sn=ocMN[?mHS<Ko>gFiocIc^?m5P<3o
DhW4oeZ@a_mRV<ooJI_@3Om_X=@01_oooOooookoooonooooo_ooooomoooo
n`;ooooj00Sooo_hooomo?ock_;oi=oVon3Ji_oIdn7oclSJolc5e`;o_KK8
00go_KG:okffb?nm]L[o_KK8okfeb_nm]/So_kO<oknhb_no]lco_kS:okng
c?no^<[o_kO<00;o_kS:02ko_kS8ol2gb_no^<So`;O:oknhb?o0]l[o_kS8
ol2gb_no^<So`;O:oknhb?o0]l[o_kS8ol2gb_no^<So`;O:oknhb?o0]l[o
_kS8ol2gb_no^<So`;O:oknhb?o0]l[o_kS8ol2gb_no^<So`;O:oknhb?o0
]l[o_kS8ol2gb_no^<So`;O:oknhb?o0]l[o_kS8ol2gb_no^<So`;O:oknh
b?o0]l[o_kS8ol2gb_no^<So`;O:0ono^<X03?no]lco_kS:okngc?no^<[o
_kO<oknhb_no]lco_kS:okngc?no^<[o_kO<oknhbP;o_kO<00So_[C<olk4
g?o<aMOoe]3Non;Li_oShNCom??aoogln0;ooooj00CooookoooooOooo_oo
ooko0_oooOl00oooooooR[[[ohZjj`03ohZjk0?oRk_]0_n<_>h01?n<_Nko
SKk_ohfnkon=_^l3ohjol0SoS[oa0on?`?83oi31l`03oi72mOnA`OCoTL7d
00;oT/;f0onC`oL9oiC4n0;oU<Gh0onDaOT2oiG6nP04oiK7nonGb?coUlSl
oiO8o0?oUlSm2?nGbOd3oiS9o@?oVL[m00?oV/cnoi[;o_nJboh00onKcOl2
oic>o`WoWLko0onNd?l2oikAo`?oX=?o0onReOl3oj;Fo`SoXmSo0onTfOl3
ojKJo`03ojSLoonXgOooZ=go00?oZ]oo0on/h?l>ojgQo`04ojgWoonQb>go
^=;_ogV^k0;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01_n3@@3oSED:
og]10?mkC1CoPd40og]100?oNd`:00?oPcP0og]<2_n3@@000_n=E@X01Omk
C0[oPd40og]<2_mb9P3oLSP000;oH2l:00OoLRH0oh<_0?lJ4QCoNd`:oh=1
0?mb>1CoJT4:00;oARH:00?o;180ob<V2_lS70X00_l/4P002OlJ2@[o2@T:
oaX92_lA70[o6Q8Doa4L2_lJ2@[o4A`:oaX92P02o`T92P;o;18000Co4A`:
o`T92_lJ2@[o6PT:0_lA70X05Ol94P[o4A`:o`T92_l92@[o6PT:ob`B0?lJ
4QCo2A8:o`T92_lA70[o6PT:of11:On`Q2Wo^IQLojJHKonVXFKo/8eBoij=
:Ol94P[o8a`:ob`B0002oaX92P06ob<L2_lA70[o4A`:oa4L2_lJ2@[o8a`:
0_l/71@01OlS70[o;1`Doa4L2_m69QCoJUDN00;oH44Y00ooUEhcoh=N<onE
C2WoYXABoiik<omP@BWo8bH:ob<_7_l/71CoLSPDombn]oofm_Gom_ooooKf
mOoL/jd00ooTZYP00ooL_[Ooong<ooKfm@03ooKfm@0>ooKoooofkN[ob[j]
okVZKoniV5cokNgZol6c[Oofoooo/;>golZn[OoL_[OokMW<ojJQV?n`ZX@2
ongfm@0Fol77`Oo:d<7ob]31onC7`On`ZXCog>?Fombn]oo:d<7o`LO1onC@
c?oLhmKom_KeooooooofooooooooonBc:OookHkokM2HooKII_o]ahCom/Lm
ong7Q0?okKhm0oo]ae`3onfn?@0;ooKII_o]_SgokLMLooKII_o]aecokKhm
om>40?n`C03o/5D0oheE2_ookL`00ooohhh01Oo]d9Soon>>oooSS_oohhko
kLN400;oon>>0_o]ae`0:?o]_Sgoi;=7onBcAooL/ecobZY7okV45?o:V1Co
WXdYog8h0?mP@ACo;1`Doa4V5?lJ4QCo2@TDoa4L2_l92@[o8bH:ol6cS_n=
SE;oPg/cob<_7_lJ9QCo6PT:oa4V5?l/4P3om]UVooK@Q?offFKoi;=7ooK7
?Oo:XCgodj4YokV45?nNLS?oNd`Do`T95?lJ9QCo4BHDog8V0?ofkNX7oooo
o`03ooKoooo:d<7om_oo00Cooooo00Com_ooooooooo1al7og>?F0_ofool0
0ooooooog>?Fonk^kP1Nonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002
onKViP0=onGUiOoMgMgoKVjMobU9X_mkYM?oT[GJofFEbOm>Q/?oG977ofRJ
cOm`W];oLj;BogbWeP0=ogn/f006ooomooooo_ooookoooonoooooogooook
0_ooooX02?ofl^oom?3aomoJh?o9`loo`;W9okVab?n`Y[oo[:>n2?nNUK08
oibC[S3oWI>/2?nLTjh8oifD[`08oj6F]?naY/Co[ZJnokJ_`Oo2_<[ob/G<
on7Lh?o]k>X3oooon`03oooooOooo_ooooko00;ooogo00?ooooooi_6lOnK
a_400onLao83oig8l`;oW/We00CoWLWdoik:m_nNb_KoW/[f0onOboL8oj3<
n0?oX<gh0onQcOT00onRc_[oXlkkoj?>n`02ojC?o0?oYLom2OnUd?d2ojK@
o@?oY]7m0_nXd_h01?nWdokoZMCoojWDoonYe?l3ojWEo`SoZ]Go0onZe_l3
oj_Fo`03ojcHoon]f?oo[MSo00?o[][o0_n_f_l9ojoKo`?o/Mco0_nbg_l2
okCPo`04ok?OoonehOoo]N7ookGQo`?o]^?o2?nhi?l6okSUo`03okWWoonj
j?oo^^So00Ko^n[o3_nkjol01?nol?ooZ<k`okKBk_mi[^T2oj[Po`04ofYZ
J_n^[Zkof=SHonCTi5_oi^KV00WoNd`:og]<5?n3@@3oNd`Doh=10?mk@@3o
PcP0og]<2_n3>0000on3@@003_n=E@[oPehDoh=10?n3@@3oPcP0og]<2_n3
@@3oNd40og8V0?mP;`[oPbl0ob<L2_mZ@@[oSED:0_mZ@@X01_mP;`[oARl:
ob`B0?lm70[o;180ob<L2P?o6PT:00?o4A`:oaX92_l92@X00_l92@X02olJ
2@[o4A`:o`T92_lA70[o2A8:oaX92_lJ4QCo2@T:oa4L2_lJ2@[o;2HD00?o
4A`:0_l94PX01?lA70[o2@TDo`TB2_l94PX2oa4L2P0:o`T92_l/>2WoPg/c
oh=kG?nVZZ?oUIQVoiF4D_n3Nc?o2A8:oa4L2P;o8a`:00Go4A`:oaX92_l9
2@[o2@T:oa4L2P02oaX92P0@ob<L2_l/9QCo?A`:odHV2_m6;`[o2@T:oa4V
5?lS70[oJUDNoiik<on`Q6Ko/7]VoiEN<omb>1Co=2lNoaXV50;o;1`D00_o
Pbl0ongIc?ofm_Gom_KeoooooooL_[Oog;>]onBnQ?oL/jgoi<O1ongIc002
ooKfm@0NooKoooofm_Gom_KeongIc?o1/hko^IQLolZQD_o]m_Gog;jgolZn
[Oo1/hkoi=3<ol[@`OoLhmKoLVMBol[@`Oo:d=Kob]31olZn[OoCfMKob]31
ol6c[OnESFKokOKeong]j_oLhmKoYZ5Vog9WD_nVV8CoYZZS0_ofool01?o]
m_Goi;<Yooo]c?oohhh2ooK@Q00lonfn?OofacgokLMLonfn?OofacgokLML
onfn?OoT/c?okLMLooK7?Oo]aecom]UVooK7?OoT/c?oi;=7onBc<ooT/dOo
i;<Nok1k2_nV@@3oPbl0ooo]S_oohhkokM2HooK@Q?ookLcokLMLoooSS_o]
d9Soon>>ong@V?o]ahCom]UVong7G?oT/bWoi;<NombZ<ooL/ecobYPDokV4
5?o:V1CoWW8Dog8h5?mkC0[o8bH:ob<L2_l92ACo;180oaXB5?lJ2@[o8a`:
ojJHKon3Nc?oUG97odI17_lJ9QCo4A`:ob<L2_lJ2@[oom0m0_offFH02?oT
/c?okLMLonBc7_oCXBWo^H@Doiib2_n3GQCo2@TD0_lJ4Q@00olm4P[okM2H
ooooo`07ooooo`03olZn[OofkN[om_oo00;om_oo00?oooooooKoooooool0
0_o:d<401?o]m_Gom_oooooooooCfMIOonKViP04oifMWOng]kOob<S8om?C
d`7of][J0002onk^kP0=ong]kOoPh>3o=Sf>ofB;a_nH^McoWkoOoh2ZeOmP
T/OoK9[<og:Od?miYMKoOJOFoh>]f@0=ohVdg`0Dooonoooin?goookooooo
oooooogoo_gkooonnoooo?_oj>CUom;=doo4_<Wo/:Njoj>I/_nJSjgoR7ZN
oh=gWOn4NYgoPgVLoh5gV_moMIP2ogidU`03ogmeV?n0MYWoOWBG00OoOWBG
<?mnM9H8ogecUP03ogmeV?mmLiKoNg6D00;oNW2C00?oOG>Foh1fVOn2N9/0
0_n3Mi/02?n=PZ;oWI>^ojNN/on`Z;Oo`[[5om?>e?oUhN;omO7b0_ooo_l0
1Oooooooookoooonooooo_oooooo00;oX/ce0onRcOH3oj?=mP;oY<kh00Co
Y<kgojG?nOnUcoWoYLoi0onVcoT8ojK@nP?oYm7j0onXd_/00onYe?coZ]Cm
oj[Do@02oj_FoP?o[=Oo2On]f?l5ojkHo`;o[mWo00?o[m[ook3Koon`fol0
1?n`fol8ok7Ko`?o/Mco0onbgOl00oncg_oo/mgook?Mo`03okCNo`;o]Moo
2Oneh?l3okOQo`;o^>;o0_nkiOl01?nji_oo_NWookgYoonmjOl3okkZo`So
`>_o0oo0k?l3ol7^o`03ol?aooo3l?oo`o3o00?oaO?o0oo6mOl>olKfo`04
olSioon/do3o^M?^ogV^j`;oZmoo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h0
2On3@@3oSED:oh=10?n3@@3oPcP0og8h5?n3@@3oPcP0oh<_0002og]10005
oheE2_mb>1CoUED0oh=10?mkC0X00_n3@@02og]10008og8h0?mb9P3oH2l:
ob`B0?mkC0[oPd40og]10?mb>002of0_2P03ob<V2_m6;`[o8bH:00;o;180
00Co6PT:o`T92_lS70[o2@T:0_lA70X00olJ2@[o4A`:o`T92P03o`T92P0<
oa4L2_l/4P3o4A`:ob`B0?lA70[o;2HDob<V2_l/71Co4A`:o`TB2_l92@[o
6Q8D0_lJ2@X02OlA70[o6PT:ob<L2_l/4P3o=2lNohf=KonVXISo`K>>ojJH
K`02ol6cSP03ob`B0?lS9P[o4BH:00?o8a`:00Co4A`:o`T92_lA70[o4A`:
0olS70X06olS9P[oH44Dof0_5?m69QCo4A`:oaXB5?l/71CoH44Yoh=N<oo1
XHCoYZZSof115?lJ9QCo6Q8Dob`L5?l/4P3oYUEVongIc?o]kN[om_KeonC@
c?oTZYSo`G]kombcQ?oTZYSog;jgongIc002ooKfm@08ooKoooofm_Gom_Ke
ooKfmOnVXFKo`J64om>nS_o]kNX2ok2ZQ0;ob[j]00GoYZZSongfmOnVQ8Co
b[j]ol6cSP02olZn[@;o`K>]027oi=3<ojJZ[Oo]m_Go/;>goiFQS_nEQ5;o
/:Z4ombn[Oo]kN[om_ooooooooofooGodj4Yooo]c?o]d9SokLMLooKII_o]
_SgokLMLooK7?OoT/dOokKhmooK@Q?o]aecom]UVong7Q?o]d9Som]24oooS
S_o]d9Soi;<cong7G?o:V1@00_o]_Sd00ooffFKodh@0oiEE0002oooSSP06
ooK@Q?o]ahCoon>>oooSS_o]d9Som]240_oohhh0:oofacgokLN4onfn?Oo]
_Sgog:XcombcG?oCZTOobZ4mok1k5?o:XCgoWXdYoh=N5?mZ@@[o;2HDob<L
2_lJ4QCo2BHYoa4L2_l94P[o;180oiFHI_n3Nc?oJVLcodI17_lA9QCo6PT:
o`T92_l/4P3oi;<Yong7G?ofacgokLMLonBc<oniSC?obYPYok2=7_n3GQCo
Nd`Doa4V5?l92ACo8a`:oaXB5?oT_X@02?ooool01Oo1al7og>?FooKoooof
oooooooo00;om_oo00?ooooool[@e_o:_Zd00_ofool00ooooooodmWFonk^
kP1Nonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002ooooo`0=oogmoOo_
knoo4BJ8ohV]e_nS`^3oXl;QohR^eOmYUl[oLio@ogVTe?mnYmGoQ:kIohZc
fP0=ohffg004ooonooonoOooooooooooo`;onoWj01Wom_7eonCOiOo@b]Co
_[S6ok>Z_onLTZgoS7jQoh=dVomgIiCoOFfLofeRSOm]HXcoK66<ofaQRom/
HHcoKF:<ofiSS_m^HhgoJf2;of]PR_m[H8_oJf2:of]PRom[H8[oJf2;00;o
Jf2:02goJF6:of]PR_mYHH[oJf2:ofUQR_m[H8[oJF6:of]PR_mYHH[oJf2:
ofUQR_m[H8[oJF6:of]PR_mYHH[oJf2:ofUQR_m[H8[oJF6:of]PR_mYHH[o
Jf2:ofUQR_m[H8[oJF6:of]PR_mYHH[oJf2:ofUQR_m[H8[oJF6:of]PR_mY
HH[oJf2:ofUQR_m[H8[oJF6:of]PR_mYHH[oJf2:ofUQR_m[H8[oJF6:of]P
R_mYHHX01?m[H8X03?m[H8_oJf2:of]PRom[H8[oJf2;of]PR_m]HXgoK66;
ofaQS?m/HH_oK66<ofeRS0;oKV>>00coM6NCofaOR_m]HHWoOG6Eohn4X_nP
UZko/jZmol>kb_oFc]Woj>?Zoo_fo?oooOl2ookmo`03ooonooonoOoooooo
00;oYLcc0onVcO@3ojK>m@?oZ=3g0onZd_T3oj[CnPSoZmCk0on[eO/3ojcE
o0?o[MKm0_n^eoh3ojoGo`Wo[mSo0_n`f?l3ok7Io`;o/m_o00Co/]_ookCM
oondgOoo]=go0oneg_l8okKNo`?o]moo0ongh?l00onhhOoo^N7ookWQo`03
ok[Ro`;o^^?o2Onki?l3okcUo`;o_NGo0_noiol01?nnj?oo`>[ool3Zooo0
j_l3ol7Zo`So`^_o0oo3k?l3olC^o`03olG`ooo6l?ooa_3o00?oao;o0oo8
m?l>olWeo`04olknoon^dnoo^=?_ogN^j`;oZ]oo00CoMWIfol71`Oo`l?3o
oOgmFoooool04omkC1CoLSPDoh<h0?mkC0[oPd40og]<2_n3>03oNd`Doh<h
0?mkC0[oSED:oh=10?nEE@3oSED:og]<2_n3@@3oUED0oh=10?nEE@000omk
@@001On3;`3o8bH:ofY12_nEE@3oPd4000;oNd`:0_mG70001_lm70[o;180
ocdL2_lA9P[o8a`:ob`B00;o6PT:00?o;180oaX92_lA70X00_l92@X00ol9
4P[o4A`:oa4L2P02oaX92P04oa4L2_lJ2@[o6PT:ob`V50?o6RHD00?o6Q8D
o`TL5?lA70X00_lS70X01olS9P[o8a`:ob<V2_lS70[oAUDYok2ZQ?nVV6l0
0_n`ZX@00onESFKoYZZSob`B0003ob<V2P;o8a`:00Go2@TDoa4L2_l92@[o
6PT:oa4L2P02ob<L2P07oaXB5?m69QCoH2lDof0_5?lJ71ko;2HDob<_7P02
o`000008omcSh?n`Q7_oPehcob`V5?lJ4QCo;2HDoeLL0?oC_Xh2ooK]jP07
ongIc?oTal7odkj>om>nS_oL/hCog;>]ombn]`02ooo]c006ooKfmOofoooo
m_KeooKoooookLcoYYR40_o1/hh0:?oL/j?og;jgonC7`Oo:_Zgo`K>]omcS
e_o]m_Gob]3FojJZXoo:d<7og>?Fol6c[OmZLUcog>?Fong]j_o1al7o/;>g
oiFHI_nVV6ooJVLcooK]j_nVXISoi=3<ooKomOofooooi=3<onBc<oookLco
m]UVoooSS_o]aecokKhmooK@Q?o]aecom]UVong7G?o]ahCom]24ong7G?o]
ah@3ooK@Q003oooSS_o]_Sgom/Lm00;oi;<Y00_oi:X0ooK7?Oo]_Sgodj4Y
ongIc?ofd8Coon>>ong@V?oohhkog;=LoooSSP02ong7Q004ong@V?offFKo
kLN4ong7G0;oi;<c00_og:XcolZQ?Oo:V2Wo/7/DokV4:On`SAkoLSPDofY1
2_m6;`[o8a`:o`T95003oa4L2P0:oaX92_n=SDOoPg/coh=k<om6EBWo4A`:
oa4V5?lA70[o6PT:om>H2P;oi;<c00Woi;=7ooK7?Oo:V2Wo^H@Yok1k2_nE
EACoLSPDo`TL5?lA9Q@00_lJ4Q@00oo:XE;om_oeooooo`06ooooo`03ol6c
[OoCfMKokOKe00;om_oo00WoooooooKooooooooob]3Fol6c[OofkN[okNgZ
ooooooo:d=H0Goooool01?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h0
3Oo/k>cogMgMo`0PR?nF^=coY/?Qoj_6hon=/MSoK9S:ogFOcOmmYMCoP:SF
ohB/f_n;/m`03OnA^^<3ooooo`0Loogmoooln_oooogooo;/m_oBc=[o`k[=
ojZP^OnJS:goQgROohMfX_nDP[CoW8W0oj^Jd?o:__3obL3_ol[0l_o<`o;o
cL?eolk5m?o>a?Koc/Gdolc2m?o<`o;oc<;dolc3l_o<`_Coc<?bolc2m0;o
c<?b02gobl?bolc3l_o;`o;oc<?bol_3l_o<`o;obl?bolc3l_o;`o;oc<?b
ol_3l_o<`o;obl?bolc3l_o;`o;oc<?bol_3l_o<`o;obl?bolc3l_o;`o;o
c<?bol_3l_o<`o;obl?bolc3l_o;`o;oc<?bol_3l_o<`o;obl?bolc3l_o;
`o;oc<?bol_3l_o<`o;obl?bolc3l_o;`o;oc<?bol_3l_o<`o;obl?bolc3
l_o;`o800_o<`o82olg4l`0Jolg3mOo=a??ocL?eolg4loo=`oGocLCcolc2
m?o=a??oc/Cfolk5m?o>a?KocLCcolc2m?o=`O?o`;;UokFTf?nSTlCoT82]
oh5bVon4MYWoWI2^okJ/a?o2^Lcof=;Poo7[moomn_l2ooono`;oo_oo00?o
ooooojS>mOnXc_D00onXcoH3ojW?mP;oZ]3h00CoZ]7goj_BnOn[d_WoZm;i
0on/d_T8ojcCnP?o[MCj0on]eO/00on_eoco/=Omok3Go@02ok;IoP?o/][o
2Oncfol2okCKo`?o]Mco0_nfgOl01?negOoo]]kookKNoonfg_l3okOOo`So
^=oo0onhh?l3okWPo`?o^^7o0onkh_l2okcRo`Wo_>?o0onmi?l2okkVo`?o
`NWo0oo4k?l3olG^o`Soa^oo0oo7lOl3olSbo`03ol[eooo;m?ooboCo00?o
cOOo0oo>n?l>olojo`04om3ooonaeO3o^M?_ogN^j`;oZMco00CoKVi^okBd
]?oPh>3ok>c/Foo^k^h01OmkC1CoNd`:og]<2_n=E@[oUED000;oNd4000[o
Nd`:oheE2_n=E@[oPd40og]<5?n=E@[oUED0oheE2_n3@@3oUED00_n3@@00
1on=E@[oPd40og8h0?mP;`[oEa`0ofY12_n=E@X00_n3@@001?mb>03oH2l:
odH_2_m69PX2ocdL2P05ob`B0?m6;`[o8a`:ob`B0?l92@X00olJ2@X3oa4L
2P;o6PT:0_lA70X07?lJ2@[o4A`:ob<V2_ld;bWo4BHNob<_7_lS;bWo4BH:
o`T92_m6@AkoARl:ob`V5?m69P[o8bH:oaXV5?l/71Co4A`:ohf=Koo1/jgo
g>?PojJHKonVZZgoSHe7odH_2_lS;ako4A`:ob<L2_l94PX2oa4L2P03o`T9
2_l94P[o4A`:00;o6PT:01Go8a`:oa4L2_m69QCoH2lDodI17_n3;`3oARHD
ocdB2_mP;aCo;180ooKooon3NecoARl:oc@_7_l971CoEa`0oiE<:OoL_[Oo
m_KeongIc?oTd<`00oo1XH@01?oL/hCog;>]onBZV?oTal42ooKfm@08ooKo
ooofm_Gom_ooooo]c?nNLS?o`K>>ojJQI_oC_Xh2olZn[@03ojJZXooLhn3o
b]3100;ob]3100?oi=3<ol[@`OoCfMH00_nVXIP03_oCfMKo`LO<ok2c]oo1
/jgob]31ojJZXomPGS?ooooool77c?o]kN[okOKeooKoooo]fLcoi:X00_o]
d9P02Oofd8CokLMLong7Q?o]aecom]24ong7G?o]_Sgom]UVong7Q002ong7
G009ooK@Q?o]ahCom]24ong@V?o]aecom]UVonBZ0?oT/bWobYPD00;o^FL0
00?o/7/:ong@V?oohhh00_o]d9P07ooohhkokLN4ong@V?o]ahCom]UVoooS
S_o]ahCokLMLonfn?OoT/dOog:XcolZH5?oCXBWo^Hdcok24:OniQ1Co/8dN
og]<5?mZ@@[oARl:oa4L2_lJ2@[o4A`:o`T95?lJ4QCo0000ohf=Aon3Nc?o
JVLcodI17_lJ9Q@00olJ4Q@04?o:V1Coi;<Nong7G?oT/c?oi;<YokV4:Oni
Q1Co/7/Doh=N5?mkC1Co2@TDoa4L2_lJ4QCo4BHDoiib<oofooD5ooooo`06
ooKooooooooo`LO1ombn]oo]kN[om_oe0oofool01oooooookNgZojJZXoof
kN[okNgZoooooooCfMH0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00
0_oVi^H03OoTi>Coe=CDo`0VRonJ^mko[<OSojg8honA]=SoL9g<og^Ud_mo
Z=KoQ:gIohN_f_n<]=`03On@^>007ooooogooOgkooooooooo_oooocooo[g
oooUg^ko`k_BokBYaonGRjooS7fXohem[_nXULcoa[;]oljjnOoHa_oocL3f
olc4moo@a_[od/[momC:o_oCbokoe<[nom;:oOoDb_kodl_nomC:o_oCboko
e<[nom?;o_oDb_h00_oCboh^om;;oP?odl_n01_oe<[nom?;o_oDb_kodl_n
omC:o_oCbokod/Slom79o?oCbOgodLWlom;8o?o?ao[oclGiolk4nOo@`O[o
eL?momG4noo6]N_oZYS:oi:1[_n>OJOoU8JYojnR`?o4^];oh]_]ooKco_on
oOl00_onool01?onoogoooooojS=lonXcO<3ojS>m0?oZLoe0_n[dOL01?n[
d?Oo[M;iojgBnOn]d_T3ojkCnPSo[]Ck0on_eO/3ok3Eo003ok7GoOnbf?go
/]Sm00;o/m[n0ondf_l9okGKo`;o]]_o0onfg?l3okOMo`?o^=ko0onhgol8
okWOo`?o^^7o0onkh_l3okgTo`?o_nKo0_o0iol<ol7Yo`;o`^[o0oo4k?l3
olK^o`_oanoo0oo8lOl3olWbo`?oboCo0oo=m_l3olkgo`kocoWo00Coco_o
ok3El?nidnooMZgZ0_n[h?l01?mZJV[o[Zj^omSHf?oTi>AKonKViP06og]<
2_n3@@3oSED:og8h0?n=E@[oPd400_n=E@X00on3@@3oSED:oiEE0004oiEE
0004oh=10?nEE@3oPd40og]<2P;oPd40013oPcP0oh=10?m69P[oJT4:oiEE
0?n3@@3oNd40og]<2_mb>03oEa`0odH_2_lm70[oARH:ocdL2_l/4P3o8bH:
1OlS70X3oaX92P05o`T92_lA70[o6PT:ob<L2_l/4P000_lS70X02om?IdOo
ARl:ob<V2_lS9P[oAT`moiFQS_m6;`[oH2l:odH_2_lm70[o8bH:00;o;2HD
00[o4BH:ol6cS_nEXHkoUJ6>ol[@`Oo1al7oPehDodH_2_lJ9QCo8bH:0_lS
70X09Ol94P[o4A`:oa4L2_l94P[o6PT:ob<L2_lA9P[o4A`:ob<L2_lJ9QCo
ARHDofYE7_n3GS?oWUhDoiF4D_n`NfKo/8AVojJHKonVLU;oNd`Dob`V5?lm
4P[oUD`Yol5kNoo]fLcokNgZooK]j_nVXISoWW8col5kNoo1XHCokMW<onC7
`OoL/jgog;jgongIc?ookL`00_ofm_D02oofooookM2HojJ4D_oL/j?oYXAB
ol6cS_nVV8Cog>?Fol6c[Oo1al7o`K>]00;ob]3100Co/;>gol77c?o:d<7o
b]310oo1al`03OoTd<coUJZ]oiFZ[OnVQ8CoYYR4omcSh?o]kN[om_ooongf
mOooooookM2HolZH5?o]ah@00_ofd8@02OoffFKokLMLooK@Q?o]ahCokLML
onBcAoo]aecom]24ong7Q003ong7G00:ooKII_oLaj?okLMLong7Q?oT/bWo
kKhmong7G?o]_SgokLMLombZ<`;okM2H00Soon>>ong@V?oohhkokLMLoooS
S_o]d9SokLMLong@V0;okLN400Ooi;=7onBc<ooLZS?odj4YombZ<oo:XCgo
/7/:00;o/8dN00CoJUDNog]<2_ld;ako8bH:1?lA70X02_l94P[oJUDNohf=
AomZIc?oAT4Noa4V2_lA70[o2A`DoaX92_niLS<2onBc:@0?olZQ?OoLZS?o
bYPDoiib<onNGQCoLSPDof115?lA9Qko4A`:oa4V5?l92ACoSED:ooo]c?of
ooGooooo00;om_oo0oooool00oo1al7o`K>]ong]jP05ooKoo`06ongfmOnV
XISog>?Pong]j_ofoooog>?PGooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[J
fP000_o^k^h03Oo/k>cog=cLo`0WSOnK_=ko[<SSojk9honB]][oLik>ogZT
d?mnZ=CoPjcHohR_f_n</m/03On@^>008?oooo[onocgoooooOooo_oon_Oo
onGQl_o:`][o[jK5oiJ:/_n=OJcoVHJmojbHdoo9/o?og<GoomBmooo@_Ooo
dlSoom?<oooGc_oof=7oom[AoooId_oof<ooomK?oooLdooofmCoomcCoooK
e?oog=?oom_DoooLdooofmCo<?oIeOl2omWBo`0Oom[AoooId_oof]7oomWB
oooJdOoofM;oom_BoooId_oof<ooomK?oooFcOooeLkoomK=oooGc?oocKgk
olfjn_o?^o[od;ckolVclOncW]OoVHFjohMeYOnKS;?o[Z?3olg5gOoXi??o
moKnoo_lo_omoocoo_okooooo@02oj[?mP?oZ]3g0on[dOP2ojcCnP04ojcB
n_n]e?co[MClojgDo0?o[]Gm2?n^e_h6ojoGoP03ok3Ho_naf?oo/MSo00Go
/]Wo2Oncf_l2okCJo`?o]M_o0_nfg?l01?negOoo]]kookKNoonfg_l3okOO
o`So^=oo0onih?l3ok[Qo`03okcSoonlh_oo_>;o00?o_^Co0_noiOl9ol3V
o`?o`NSo0_o2jOl2olC[o`04olC/ooo6k_ooa^koolK^o`?oanoo2oo8lOl3
olWbo`03ol[dooo:looob_?o00?oboGo4Oo<m_l01?o>n_oo/=G`okG@k_mi
[^`2ojOLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00CoNd`:oiEE5?n3@@3o
Nd`:0_n=E@X2oh=10007oheE2_nEE@3oWW8:oiEE0?nNGQCoSED:oiib2P05
oiEE000<oh=10?mkC0[oPd40of0_2_mZEAkoWW8:oiEE0?n3@@3oNd`:og]1
0?mP;`[oEa`00_m6;`X2odHV2P07ob<V2_lS70[o;180oaXB5?l/4P3o8a`:
ob<V2P02ob<L2P03o`TB2_lA70[o?A`:00;o8a`:00?o?A`:ob<V2_ldEBT0
0_mGEE805?nEQ8koYZZ]omcSh?l0003o2A`Do`T92_l94P[o4A`:o`TB2_l9
2ACo=2lNojJHQ?n=SFooARl:ol77c?nEQ7_oWXdcodH_2_lS9P[o8a`:0_lA
70X00olJ2@[o4A`:oaX92P02o`T92P;o6PT:0_lS70X06OlJ4QCo4A`:ocdL
2_n3GS?o/8eBok24Noo1XHCog;>Sol6QQ?o1/hkoPehcob`V5?n=E@[o`J64
ombc[OofkN[okOKeonC@c?n`Q7_oJUDNof11:On3Necob[j]ooK]j_ofm_D0
0_o]fL`02?ofkN[om_KeooKfmOofoooog;>Soiib<onNNc?o^G8c0_o:d<44
ol77`@0AojJZ[Oo1al7og>?Pong]j_o:_Zgog;>Som>nS_o:ZVKodj4YolZZ
I_o:XE;okLMLooK@Q?mGSHkoUJ6>onC@c?o]kNX00_ofool01Oo]ahCodiP:
ong7Q?o]ahCom]2400;okLML00Kom]24ooKII_o]aecokLMLombcG?ofd8@4
ong7G00Confn?OoffFKokLN4ooKII_oT/dOom/LmonBc<ooffFKokLN4onfn
?OoT_XCoon>>ong@V?oohhkokLN4oooSS_o]d9Soon>>ooKIIP02ooK@Q0;o
kLML00goi;<NolZH5?o:V2WobYPYolZZAon`Q2Wo/8dNok2=<omk@@3oNd`D
odH_2_lJ2@[o4A`:00;o6PT:00Oo6Q8Do`T92_n3GS?oSHeBoh=k<om6@Ako
8blN00;o6Q8D01Go2@TDojI<0?oT/bWoi;<NolZH5?oCXBWobYPDok1k5?nV
LQCoLSPDog]10?lA9QCo6Q8Doa4V5?lA9QkoLRH0ooKomOo]kN[om_oooooo
ooofool00oooool01?o1al7o`K>]omcSe_o]m_D3ooKoo`07ooooooofoooo
YZ6HomcSe_o]kN[oooooom?IeP1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q0002ooooo`0=oogmoOo/k>co02^>oifmg_n/b>Co[l[Uoi6ef_mbWloo
NjGBognXe?n3[=SoQjgIoh^cfP0=oi2hh00Hoooom_ojno?oooomooonooof
l_oofMCZokfddonUV/;oS7b]oi1o]_nZU]Go^jKYol^do?oC^oooc;Coolnk
oooBaooodL[nomC=oooEc_ooe/ooomG>oooDcOood/_o1ooHdOl00ooFd_oo
eM?oom?Do`0]om?Do`03omGCoooDd?ooe/oo00Koe/oo00?ofM;oomSAoooF
col01?oDcOl04_oEc?ooglooom[6oooB_Ooob[GjolB]longX>CoZ9;Boib7
`?nCPK7oXiBkokndd_oMfN[ol_7ioo_mo?okoo[oo?ojookoo@;oZ]3f0onZ
d?L3oj_An0;o[=;i00Co[M?jojkDnon^e?_o[]Ck0on_eO`00on_eOgoXLGZ
ojC7k@05ojoEo@?o/=Km0onae_d2ok;HoP03ojC7jonaf?go/m[o00;o[=3d
00?o]=[ookGKoonefol01onefol2okKLo`?o]]go0_nhg_l01?n]d_;o[m?b
okWOoonigol3okWPo`03ojc@k?nhgogo^^7o00;o/MOd0onjhOl3ok_Qo`?o
_>;o00?o_NCookgSoonmhol00onniOl2okoVo`Wo`>Ko1Oo0iol3ol7Xo`Ko
`^Wo2?o2j_l3ol?/o`?oaNko0oo8lOl3ol_do`?ocOKo3_o>n?l01?o?o_oo
[mK`okSBk_mf[NX2ojcOo`04ogIfM_o1`L7ol?3`oogmoE_ooooo0_n=E@X0
1On3@@3oLSPDoiEE0?n=E@[oWUhD00;oUED000CoSED:oiEE0?nEE@3oWUhD
0onEE@001?nEEACoUED0oheE2_nEE@03oh=10007of0_2_mkC0[oYVL0oiib
2_nEEACoPd40og8h0003of0_2P04oeLL0?m6;`[oARl:ocdL2P;o8bH:0_lS
70X03ol/4P3oARHDocdL2_l/4P3o8a`:oeLL0?lm70[oARH:ocdL2_m69P[o
6Q8DodI<?OmPGS?oNheVok2n`@02om?IeP03odH_2_mZEAko;18000;o=2lN
013o2@TDoa4L2_lS;akoPg/cofYbG?n`ZXCoUHAkok2ZQ?mP@ACoARHDob<V
2_lJ2@[oARl:o`TB2_lA70[o6PT:1?lA70X07OlS70[o6PT:ob<L2_l/71Co
6RHDob`V5?lJ9QCoAT4Noh=N<on=SDOoUHABojJHKon3GS?oNd`DoiE<:On`
Q7_og;jgonC@c?o]fLcom_ooombn]oniSC?oPehco`T95?lS;c?og>?Pom?I
e_oLhn3okNgZ00;om^gZ0_ofm_D03?oooooo`J64okVHG?o:ZTOo`K>>ok2c
]ooTd<co`K>]ojJZXon`_/7og>?Pol77c0;ob]3F0_o]m_D04?ofoooooooo
ooKooooLhmKokM2HonBZ0?oT/c?oom0mo`T92_nEQ5;og>?PooK]j_ofoooo
kNgZombcG?oT/bT3ong7Q00:onfn?Oo]ahCokLMLong@V?o]_SgokLMLonBc
Aoo]d9SokLN4onBc<`;okLML00Soi;<cong7G?o]aecokLN4onfn?OoT/c?o
m/Lmong7Q0;okKhm00CobZYVoooSS_o]d9SokM2H0_ofd8@07?o]ahCokM2H
ooK@Q?o]ahCom]24ooKII_o]_Sgog:Xcom>Q:Oo:V1Codj4YokV=<oniSACo
/7/Doij=<onNSBWoH44DodHV5?lS9P[o6PT:ob`h:Ol92ACo4A`:o`T92_mZ
Ic?oSHe7ofYW<om6EBT3oa4L2P09oa4V5?n3;`3oi;<colZH5?oT/akodh@0
om>Q:On`LP3oWUhD00;oNd`D00Go6Q8Doa4V5?lA70[o;1`DocdB2P02ooo]
c003ooooooofoooom_oo00?ooooo00Kob]31ojJZXooLhn3okOKeooKooooo
ool2ooKoo`06oooooonEV:?okMW<ooK]j_ofoooog>?PGoooool01?n_[joo
bl_;omkNg_oZj^X1oo;blP000_o^k^h03Oo/k>cog=cLo`0]TOnM_Mko[<ST
ojo9i?nA]=_oL9g=ogZTd_mnZ=?oPj_HohR_f_n</m/03On@]]h05?ooooCo
nogboooonoonoOookn_jomOAjoni[mCoVHfkoi:1^?nFPl?o[ISMokRRjoo1
ZOGoc;Coom2eoooKaOooclKoolg9noo?bogod<cn0_oAcOl2om3<oPOod/ko
00?odLooolo@ooo>dOh0;Oo>dOh00oo?d?kod<koom7=o`08om7=o`0Dom;>
oooAcOoodLgoom3<o_o?bogodLSoolBdmOo>^_ooeKooom>mooo7[oWo]YkX
ojN@e_nNR<SoTh2goib<^OndZL_oe<oSono^m_okoO`2oocon003ookooOnZ
cOCoZ/gd00?oZloe00Wo92`dofn6Won/d?KoXLCWoff4W?nO`>Go/=Gmoh>O
_Ol10@400_nae_h01_nH]m[o92`eo`T;3_l82Pco9c0ioiVjg0;o/]So00ko
;3I0oeQ[Oonbf?oo/]Soog::XolC5aco/mSook?IooliAE7o1@H8oa8F6_m^
QIco3A0Coce:E`Go]M_o00?o9Rhfo`000?l000000_l000002olY<S[o]]co
obdg@?mKKWoo]mgookWOoolJ82Go2`d@oaLL8?lh@dgo/mWf00;o^n;o00Ko
>dMAo`D72?lC5a[oLhZLo`h@4om0CEL3okcSo`?o_N?o0onmi?l00onniOoo
_nGookoUo`03ol3Vo`;o`>Oo2Oo1iol3ol7Yo`;o`^[o0_o4k?l01?o3jooo
aNgoolG]ooo5kOl3olK^o`Soa_3o0oo7lOl3olSbo`03ol[eooo;mOooboGo
00?ocOSo0oo>nOl>olojo`04om?ooonaeo3o]]3^ogV_kP;oZmko00CoKVi^
okBd]?oPh>3ok>c/Foo^k^h01on=E@[oYVL0og]<5?mb>1CoWW8:oh=10?n=
E@X00_nEE@001on=E@[oWW8:oheE2_n=E@[oYW80oiEE0?n=E@X01onEE@00
4omZ@@[oNd`:ok1k5?n`N`[oWW8:oiEE0?mkC0[oPd40og8h0?mZ@@[oH2l:
odHV2_mG703oARHDodH_2_l/4P3o8bH:ocdL2_lS9PX00_lm70X02om69P[o
8a`:odHV2_mP;`[oARH:of0_2_m69P[o;2HDoeMWD_mZLUcoJW^400;ob]31
017oLVMBofYW<oo1/jgo/:Z4oiFHI_nVV6ooJT4:o`000?n3Nc?oYZZSol6c
S_o1/jgo/:Z4ojJQV?mZEAkoARl:ob<V2P02ob<L2P08oa4L2_lJ2@[o4A`:
o`T92_lA70[o2A8:o`T92_lA70X3ob<L2P0Cob`V5?m69QCo?A`:ob<V2_m6
9QCoH2lDog8h5?nEGS?oWW8cojJHKoo1/hkog;>Sombn]ooTd<coi<O1ooK]
j_o]fLco`J64ok1k:@02og8h5007ojK7h?oL_[Oo`G]konC7`Oo]fLcom^gZ
ooKfm@02ooKoo`0Sok1k:OnNQ6Ko/8AVokVHG?nNGQCo^HdDoiib5?mk@@3o
UD`Yoh=N5?mP@ACoPehcof115?mZIc?oLSPDoiF4D_nVV8Co`LO<ongfmOoo
oooom^gZom>H2_ofacgo8bH:ojJHQ?o]kN[om_KeooKoooofkN[og;=LonBc
<oo]ahCokLMLooKII_oT/dL00_o]_Sd01?ofd8CokLMLonfn?OoT/dL2ong7
G0?oi;=700KokKhmonBcAoofd8CokLMLooK@Q?o]_Sd2ong7G007onfn?Oo]
aecodjY7ong@V?oohhkokLN4ooK@Q002ong7Q007oooSS_o]ahCom]UVong7
Q?o]aecog;=LonBcA`02olZH500PolZH:Oo:XCgo/8@Yok1k2_n`SC?oPehD
og]<2_m6;`[o4BH:oa4L2_lJ2@[o4BHDoaX92_l92@[oJUDNokVHG?mZIc?o
AT4NoaXL7_lA9QCo6Q8Doa4L2_mb>1Coi;<YonBc7_oCV0[o^Hdcom>40?n`
NaCoYVL0of115?mZ@@X2oa4L2P05oaXB5?lA70[o6PT:ooo]c?o]fL`01Oof
ool01Ooooooob]3FoiFQS_o]kN[okOKe00?om_oo0_ooool01OnVXISog>?F
omcSh?ofooGog>?F05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;o
i^KV00goi>CTomCDe?l0;I;oW[gOojc7honab^GoTKGJog:Oc_mkYmCoOjSD
oh>[f?n8[m[oRk?J00goT;KN02koo_omookonooooo_om?Cbon?PjOoAbN7o
[Z7=ohEc/OnDO/OoU7_<ojN>gonfVn[oa:Wfolndooo;/?ood;[oolc0o_o;
`ococLCmolk6ooo@aoooclSnom78ooo@bOood<Onolo8o_o@aokoclSnom37
o_o?b?kod<Onolo8o_o<bOkob/[lol[:o_o:b_cob/[nol[:o?o:b_kob/[l
ol[:o_o:b_cob/[nol[:o?o:b_kob/[l4oo:b_h03oo:b_cob/[nol[:o?o:
b_kob/[lol[:o_o:b_cob/[nol[:o?o:b_kob/[lol[:o_o:b_cob/[nolc9
oP02olk7o@0Oolo6oOo>aogoclKmolk7oOo?a_goc/Omol_2noo<a?goclKo
om38ooo@aooocLGnol_2noo:_o_of<Coom>mooo<]?ooajomolBYn_njWnko
ZHkKoiN0a_nANkWoUXBfojZNa?o<a=coj^ObooShn_olo_WooOoiooooo@02
ojO=m0?oZ<ke00go8b/coff5W_nYcoGoGgB9o`000?mHK87o[=;joh2M^ol1
0@7o[M?jojcBnOlS:c;o=dA@00;oX/GZ00Ko>TICob@/=?n]do[o[]Ckob/e
?_mGJWd2ojoEn`09og28XOlC5a_o/=GlohVVa?l20`?oV[_Koj74iOloCE[o
30hA00;o]=[o1?nefol00olV;SKoDV=dokGKo`04okGKo`0@obdg@?mJKGoo
]McookKLoon9YL3o/]OkokGJo_lV;SKoJ7fBokKLoon=Z/Ko0P<4oifngOnT
a^Ko@4iKo``>4@Co]]co0onhgOl3okWNo`?o^n7o0onmi?l2okkUo`Wo`>Ko
0oo0j?l2ol7Yo`?o`n_o0oo5kOl3olK^o`Soa_3o0oo7lOl3olSbo`03ol[e
ooo;mOooboGo00?ocOSo0oo>nOl>olojo`04om?ooon_dnoo^=;_ogV^k0;o
[=oo00CoJVYZojj^[_oHf=Soi>CTFooVi^H2oheE2P04oiEE5?n=E@[oUED0
ojI<00;oUED000?oYT`0oiEE0?nEE@000_nVI`000onNLP[oUED0oiEE0002
oiEE0005oiiN5?nEE@3oUED0oh=10?nEE@000_mZ@@X02_o1Q03o/7/:ojIb
0?nNLP[oPd40og]<2_mk@@3oNd`:og8V0?mZ@@X2oeLL00;o?A`:0_lS9PX0
1_lm4P[oARl:ocdL2_m6;`[o?A`:of0_2P;oJT4:0_mP;`X04?lS9P[oAUDY
oh>4NonEXHkob]3Fom?SmOo]m_GoJW]_om?SmOo:d=Ko/;>gol77c?o1al7o
UHeVok2c]oo1al42ojJZX`;oYZ6H00?oYYQ_oh=k<olA70X00_lA70X02_l/
4P3o2@T:oa4L2_lJ2@[o4A`:o`T92_lA70[o6PT:oa4L2_l/71@2ob<L2P06
ob`V5?mP;aCoJUDNoiE<:OnVLU;oYXAB0_o1XH@2ombcX`0@olZn[OoL_[Oo
g;jgonC7`OoLhmKokNgZombc[OoTZYSo`J64ombcQ?oTal7om^gZooKfmOoL
hmKom^gZooKfm@;om_oo00Com_oeoiib<onELTOo/7/Y0on`Na@0<?nEE@3o
YT`0oh<h0?nEEACoPbl0oheE2_mkC0[oLSPDog]<2_nNLP[o/7/:okUW0?n`
SE;o/;>gooKoooo]fLcoomTYodH_2_n`ZXCokNgZongfmOooooookNgZong7
G?oLZS?okLMLooK@Q?o]ahCoi;<cong7Q?o]_SgokM2Honfn?OoT/dOog;=L
onBcAoo]aecoi;<Yong7G?oT/dOoi:X0ojK7h?o1XHCokLMLonBcAoofacgo
i;=7ong7G0;okKhm00WobZ4moooSS_o]ahCom]24ong7Q?o]d9Som]UVong@
V?ofd8@00_o]ah@2ong7G00<onBc<ooCXBWobYPYokV=<on`SC?o/8dNoiib
2_niSACoPg/cofY12_mP;aCo8a`:0_lA70X03ol92@[o4A`:o`000?mZIc?o
WXdYofYW<om6@Ako8bH:oaXV5?lA9QCo4A`:oeLL0?o:V1Coi;<Nom>40002
olZH500<okV45?n`NaCoLSPDofY12_lJ9QCo6Q8Doa4V5?lJ4QCo2@T:ooo]
S_oL_Zgooooo1?ofool01OoooooodmWFoiFZ[OoTd<cokOKe00Com_oo00Ko
ooooojJQV?oCfMKog>?PooKooooCfMIOonKViP04oifMWOng]kOob<S8om?C
d`7of][J0002onk^kP0=onc/k?oLg=co02fAoijmg_n/b>Co/lcUoi:ef_ma
W/ooO:SDogjXe?n3ZmSoR;7Johfeg00=oi6hg`0PooWloookoOooo_ohooKh
j_oXiN3ob;g>ojJAbOmnHKGoTFkFoiahh_n[RNOo^9WYoknQioo4ZNcob[3i
olfeooo>^Ooob[[ool^jooo<_?ood;ooom31ooo?__ooc;gooljnooo=__oo
c[koolfnooo>_OoocKkoolnnooo>_ol8ol^oo`;oc<3o7?o;_ol:olc0o`;o
cKko01ooc[goolfnooo>_OoocKkooljmooo=__ooc[goolfnooo>_OoocKko
oljmooo=__ooc[goom2looo@^?oodKGoolb_ooo4Yo_o_IoeokFGkOnXRmoo
W87>ohac]OmjIIgoY9>ool^ng?oWg_7on_Cnooojo_oooOkooooo00;oZ]3f
0onZd?L03OlT;3CoKXNOoj_AmolQ:C3o;cY5oaXP9_n]do[oPIjko`410On^
e?[oTk?Co`000?mlV;@00_n^e?/01_mlV;Co0000oiJff?n^e?_o:cDnoeMZ
O@;o[mGk00WoL8RQoa<G6on`e_coU[OGo`820_n3X;_o/m[nofn7W_lF6b00
0_ndfol4okGLo`03obH^=_mBI7Co]Mco00;o]Mco0_nfgOl00ol]=d3oFVio
okKMo`02okSNo`0;okONoon>[<Go3a<FofZ0TonigoooWKgIo`820on9Y[go
^^3oog>;WolG72001?njh?l3ok_Po`?o_>7o0onmhol3okkUo`;o_nKo2Oo0
i_l3ol3Wo`;o`NSo0oo3j_l3olG/o`?oa^go2?o6k_l3olO`o`?ob?7o00?o
b_Cool_dooo;m?l00oo=mol3olkho`koco[o00Coco_ook7El?nfd^koNJkY
0_nZh?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP04oiiN5?n=E@[oSED:oiEE
00;oSED:1?nEE@001OnNGQCoSED:oiEE5?nVI`3oWUhD00;oYVL01?nEE@00
3on=E@[oUED0og]10?mZ@@[o/8dNok1b0?n`N`[oYW80oiEE0?n3@@3oNd`:
oh=10?mkC0[oJT4:oeLL0002of0_2P05odH_2_lm70[o8bH:ocdL2_m6;`X0
0_mG70008Om69P[oLSP0og8h5?n3@@3oPcP0og]<2_ld;akoLVMBoh>=Q?nE
XHko`LO<omcSh?o]m_GoUJZ]omcSh?nVZZ?oYZ6HoiF4Non=SE;oYYQ_oiF=
D_m6;`[o=2lNomcSh?o1al7o/;k1ol77`OnEV6Ko4A`:oa4V2_lA70[o6PT:
ob<L2P02oa4L2P05oaX92_lA70[o2A8:oa4L2_l/71@00_lS70X04olS9P[o
;2HDodHV5?mP@BWoPehcoiik<onVQ8Coi:ZHol6c[Oo:_Zgog;>]ombn]ooT
al7og;jgonC7`OoL_[Oodkj>ombcXooL_[L00oo]fL`01?ofkN[okMW<ong]
j_ofkNX3ooKoo`0<ong]j_n3Nc?oWW/cokV=:On`N`[o/7/DojIW0?nNGQCo
WW8:oh<h0?n=E@[oWUhD0_mkC0X05omZ@@[oLSPDoheE2_nNLP[o/8dNokV=
:Oo1Q03oYYR4ooooooo:_ZgoARl:ojJQV?o]fLcom_KeooKoooo]fLcog;=L
onBZ0?o]aecokLN4ong7G?oT/c?oi;=700;okLML01gokKhmonBcAooT/ako
m]UVombcG?oT/akog;=Long7G?oT/c?oY/OPolZZI_oT/dOoi;<Yong7G?o]
_Sgoi;<Yong7Q?ofacgo^H@Dooo]c?offFKokM2HooKII_o]d9SokLN4ooo]
S_o]ahCom]UVong7Q002ong7G00MombZ<ooT/akodiP:olZH5?o:XCgo/8@Y
ok1k2_n`SC?oNd40og]<2_m6@Ako;1`Doa4L2_l94P[o6Q8Do`TB2_l92@[o
PehcoiFHI_n3Nc?oAT4NoaXV5?lJ4QCo2@T:oaX92_m69QCodh@0onBc<ooT
/ah00_oCQ0001?niQ1CoWW8:oh=N5?mP;`X3oa4L2P06oa4V5?l0003oon>>
ombcXoofooookOKe0oofool01?ooooookNgZojJQV?o:d=H2ongfm@;om_oo
0_ooool01On`/kOoi=3<omcSh?ofooGodmWF05ook^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN4000;ooooo00gooOgmonc/k?l0;I7oWkoOoj_7i?n_bNCo
T;CIog6Nc_mjY]?oOZSDoh>[f?n8[m[oS;CN00goTKSP01GonOgooo_oooon
ooSon?_ZonGPf_o8^looU7VlogiL_OnCJ^;oWGCZoj^6i_neT^;o^Y_OokjQ
hoo2Y_7oaJ[iolRaooo7/?ooak3nolVco_o<]_l00_o>^?l00oo=]oooc;Ol
olbgo002olbgo0?ocKOo00?oc;Soolfiooo=^Ol01_o=^Ol4olbho`CobkOn
4?o;]ol4ol^goPCoc;So2?o>^_l8oljho`;odK_o0_o@^_l05Oo?^Oooc[So
olfgooo>]_oobjknolb/ooo7Yo[o`:3eokVHkonbTNSoYXGLoi]kc_nDN<?o
Nf:Soh]g[?o4]=_oj=_eooojoooooOooo_[iooono`02oj_?mP?o[=7g00go
92`dofn7X?nA/M7o0000oi6`colL8RWoRZO6oh>O_Ol10@7o/MKnoh>O_Ol0
003oX<;V00;o/]So00KoWl7To`000?n6Xl7o/]Soob`f@?mHJgl2ok;Ho`09
og6:XolC5aco/]Sook;IoomiTjgo8bXbob<[<olU;SKo5Q/P00Ko/m[o00?o
9Bhfoe5SM?ncf_l00_ncf_l2okCKo`09obdg@?mJKGoo]McookOMoonSaNCo
=41:o`820omAHW7o/MKf00;o^Moo00GoOIN]ob@[<_lU;3?o9blfoaLL8007
ok[Po`?o^n7o00?o_>;ookgSoonmhol00onni?l;okoUo`?o`NOo0_o2j?l2
olC[o`04ol?[ooo5k_ooaNkoolG^o`?oa^oo2oo8lOl3olWbo`03ol[dooo;
looobo?o00?oc?Go4Oo=m_l01?o@oooo/=G`okWCk_mi[^/2oj_Oo`04ogIf
M_o1`L7ol?3`oogmoE_ooooo00CoSED:oiEE5?n=E@[oSED:0_nEE@003on=
E@[oUED0oiEE5?n=E@[oUED0ojIW0?nNLP[oYVL0oiib2_n=E@[oUED0ojIW
0?nEE@3oYVL0oiiN5002oiEE0004og]<2_mZ@@[o`H@0ojIb50;oYW8001?o
SED:oiEE0?mk@@3oNd`:oh=10?mk@@3oH2l:og8h0?m69P[oEa`0ocdL2_m6
;`[o8bH:oeLL0?mZ@@[oARl:of0_2_mkC0[oNd4000?oSED:01SoAT4NofYk
Kon=V8koYZZ]ol[@e_oChoGom_oooiib5?nVLQCoYW80okUW0?nVC03oH2l:
og8h5?n=SFoo/8AkofYkKoo]m_Go`LO<ok2c]onESFKoNd`Do`TB2_lA70X2
oaX92P;o4A`:00Ko6PT:oa4L2_lA70[o2@T:oaX92_l/4P02ob<L2P08ob`V
5?m69QCoARHDof0_5?mZEAkoYW9Bok2=D_oL/jd2ombcX`09ol6c[OoL_[Oo
g;jgombn]ooTal7og;jgombcXon`SE;oYYR400;okMW<01Kom_KeooK]j_of
m_Gom_KeooK]j_ofm_Gom_ooooK]j_o1/jgoYXABok1k:OniQ2Wo^FL0okV4
5?niI`3o/7/DojI<0?nNGQCoUEDDoiib2_mkC0[oLSPD0_mZ@@X01?mZEAko
UEDDoiib5?n`Na@2ol64000AojK7h?o]kN[o4A`:ok2ZQ?ofm_GokOKeooKo
oooL/hCokLMLombZ<ooL/ecokM2Honfn?OoL/ecoi;=7onBc:OoffFH00_oT
/dL00ooT/c?obZ4mombcG002onBcA`0fonfn?OoT/dOodjY7ombcG?oT/dOo
bZ4monBc7_oT/dOom/LmonBcAoofacgo/8dNoooSS_o]d9Som]24ong@V?oo
kLcokM2HoooSS_o]ahCom]UVong@V?o]_SgokLMLonBc<ooLZS?obYPDolZH
:OniSBWo/8@YojIb5?n`SAkoPehDog]<5?m6;`[o8bH:o`T95?l/4P3o2A8:
oa4L2_l92@[oAT4NoiF4D_n3Nc?oAUDYob`V5?lS9P[o6Q8Doa4L2_l/71Co
/7/:ooK77_o:V1Cog:Xc0on`N`X02_mkC1CoARHDob`V5?lJ4QCo4A`:oaXB
5?l92@[okM2HombcQ?ofool2ongfm@;om_oo00KoooooongfmOnVZZ?oi=3<
ong]j_o]m_D3ooKoo`06oooooon`/kOob]31omcSe_ofm_Gog>?PGoooool0
1?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h03Oo/k>cog=cLo`0/TOnM
_=ko[<STojo9i?nA]=WoLZ3@ogVUd?mnZ=CoPj_FohJ^f_n<]=/03OnA^N40
6?oko_oonoooookom_ojn_3ohm[OolbkgOmgFjKoOU_3ohiUfonHL>;oYX7N
ojn=fOncU=So]YSNokVLk_nlX?Go`JKeokjVl_noYo7o`J[bolB]mOo7/?Ko
b;7eolRbl`Coa[3a0_o6[o<2olJ_m@03olRamOo7/_Goak;e00Goak;e2?o5
/?<@olF`m@SoaK3c2?o6/O@4olNalPCoak3d0_o8/OL05oo7/?KoaJkdolB]
mOo3[?Co`Z_col>Yloo1Y?Ko`JChokjNlonhV>_o/i7Uojj:hOnSOmOoV7C<
oi1^a?mlGJ_oLeZLolNci_oVfOOoooWooooon_ojn_3ooook00GoZm3i00go
92`dofn7XOmCIGWo82L_ojgBn_mLL8KoAeIWoh6N_?l10@7o[]CkoiJff?l0
003oNYFa00;o[]Ck00KoNI>_o`000?nH^]co[]Ckob/e?_loCE/2ojoEn`03
ofb3VolD61co/=Gl00?o/MOm00?o/=OlofMmTolG72400_ncfOl4okCJo`03
obH^=_mAHgCo]=[o00;o]=[o0_nefol01ol]=d3oFVeookGLoonfgOoo;SQ1
obli@_nN_]/00_nhg_l3okSOo`04okWPoongg_goJh:DoaLL8@Oo^N3o0onj
hOl00onlh_oo_>?ookcSo`03okkTo`_o_nGo0oo0i_l2ol3Wo`;o`N[o00Co
`NWool;/ooo2k?oo`^co0oo2kOl8ol?^o`?oa?3o0oo6lOl00oo9looob??o
olSco`03ol_eo`?ocOKo3_o>n?l01?o?oOoo[]C_okSCkomg[^/2oj[Oo`04
ofi^K_nd];Coh>3Ponc/k5_ok^k^00SoSED:oiiN5?n=E@[oPd40oheE2_nE
E@3oSED:oiEE50?oUED000CoWUhDoiib2_nNLP[oWUhD0_nNLPX00onNGQCo
UED0oiEE0002oiEE000;ojIW0?n3@@3oJT4:ok1k5?n`N`[o/780ok2=7_nN
LP[oUED0oheE2_nEE@000_n3@@00;?mkC0[oLRH0odHV2_mP;`[oARH:ocdL
2_lS9P[o?A`:of0_2_m69P[oEa`0og]<2_n=E@[oUED0oiEE5?nVC03oAT4N
og^=I_nEV:?o/;>gomcSh?ofooookNgZojIb0?niSACo^FL0oh=10?mZLUco
b]31omcSh?o:d=KoSHe_oiib5?n3GS?oPd40ok2=7_nVI`3oNd40oa4L2_l9
4P[o2@T:oa4L2_l92@[o4A`:0_l92@X3oa4L2P05ob<L2_lJ2@[o8bH:ocdL
2_ld;bT00_mP@BT01onEC2WoWW8cok1kI_nVQ8Co`J64ombcXoo:_Zd01?oL
_[L04OoTal7okMW<ombcXon`Q6Ko/8AkolZn[Oo]fLcokOKeomcSh?o]fLco
kNgZooKfmOofooookMW<ohf=D_nEQ5;oWW8c00;obYPD00Co^H@Yol640?nV
I`3o/7/:0_nVI`003OnNGQCoPd40og]<2_m69QCoH2lDog]<5?n3GQCoUEDD
ojIb5?n`SAkodiP:ofYbG?n`/kL00_o:_Zd00oo]m_Gom_KeooKoo`02ombc
G00?onBc<oo]ahCokLMLong7G?oT/c?oi;=7onBc<oo]ahCokLMLonBcAoo:
V1Coi;<conBZ0?oCQ03og;=L00?oi;=700Koi;<NonBc<ooT/akom/LmonBc
AooT/bT2ong7G003okV45?o]d9Soon>>00;okLN400?oonf>ong7Q?oohhh0
0_o]ah@04?ofd8CokLN4ong7G?o]_Sgog:Xcom>Q:Oo:V2Wo^HdYok24:OnV
LQCoWXdcoh=N5?mkC0[oARl:ob<V2_lJ2@X2o`TB2P;o2@TD00CoARHDojJQ
I_n3Nc?oH5hc0_lJ9Q@01OlA70[o6Q8DoaXB5?n`E@3oi;<N00;obYPD00Oo
dh@0ok1k2_n`NaCoPehDof0_5?lA9P[o;1`D00;o6Q8D00Co0000ombcG?o:
ZVKokNgZ0_o]m_D3ooKoo`05ongfmOn`/kOob]31omcSh?o]m_D00oofool0
1_oooooo/;k1ol77`OoLhmKom_ooom?IeUook^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN4000;oi^KV00goi>CTomCDe?l0;93oW[gOojc8i?n_bNCoT[GK
og>PcomgY<ooOZSDoh:[f?n8[m[oS;CK00goTKSO017onokooocoooooooKo
o__fon?Hj?oA_^coH4>GogiHaOn7G]CoTV_HoimkdonYQm7o[hkCok:BgOng
U_7o^I[gok^Nl002ok^OjP05okbPj_nnXn[o`JK[ol:Wj_o3Z>/00oo2YnX0
1Oo1Y^Wo`JK[ol6Vjoo1Y^go`JK[00go`:O[0oo1Z>`?ol2Vk@04ol2Wjoo1
Z>co`JS/ol6Xk0Go`:O[2?noY^X4ol2Uj0Co`:GZ0_noY>/05onnXn[o_J;Y
okbPj_nkWnWo^YkXokZNjoniVo7o^I_cokNGk?nbTN;o[hcNoj^5f_nRNMGo
UVk>oh=K_?mjEk?oITVIom>mnooUeo[onO?moooom?ojo^gooooj00;oZ/oe
0on[d?H02OlT;3CoKXJNoaDJ7_mNLhSo[M?joi^kg_l=41?oOYReo`410@02
ok3Eo@06ob`f@?la?4OoV[[MoiVig?la>dKo;cU30_nae_h03Ol/=Coo3A0C
oe5SMOnJ^mgo?4UFocE0C?nbeoko/mOnogfH]?nH^=[o/=GlodABHOlkAe@0
0_ndf?l4okCIo`03obH]=_mAHWCo]=Wo00;o]=Wo0_nef_l02Ol]=d3oFVeo
okKLoonhgooo9c0gofb2U_nkhOooZ/cXokOLnP02okcSo`05ohBP]?nQ`][o
^^7lodMFHOlnBe@01?nmi?l6okkTo`03okoUoonoi_oo_nKo00Go`>Oo2Oo1
iol3ol7Yo`;o`^[o0_o4k?l01?o3joooaNgoolG]ooo5kOl3olK^o`Soa_3o
0oo7lOl3olSbo`?ob_Co0oo<m_l3olggo`koc_So00Cod_oook7Fl?nidnoo
Mjk[0_nYg?l01?mZJV[o[Zj^omSHf?oTi>AKonKViP;oWUhD00OoSED:oh<h
0?n=E@[oYT`0oheE2_nEE@3oWUhD00;oSED:00WoYW80ojIb5?n`LP3oSED:
ok1k2_nVC03oYW80oiiN5?nVI`001?nEE@001omZ@@[o^HdDol640?n`N`[o
YW80oiib5?nEE@000_n3@@002OmkC0[oSED:og8h0?mkC0[oH2l:ofY12_mP
;`[oARl:ocdL2P02odH_2P04odHV2_m6;`[oJT4:oiEE50;oSED:01SoYVL0
odI17_n=V8koYZ6Hok2n`OoLhn3om_ooongfmOnVLP3o`H@0og9ED_nVZZ?o
kOKeojJQV?n`SC?o/780oiEE0?mb9P3oUED0ok1k2_niSC?o/8dNog]<2_l9
4PX2oa4L2P07o`T92_lA70[o6PT:oa4L2_lJ4QCo4A`:ob`B0004ob<L2P08
ob<V2_m69QCoARHDof115?mP@BWoUEhcoiEbAon`NfH2ol6QQ004ombcXooL
_[Oog;>]ombn]`;oi<O101goi=3<ongIc?ookLco`J64ok24Noo1XHCodkj>
ombn]ooTal7om^gZooKfmOoooooo/:Z4ofY12_mbIe;o/7/YolZH5?n`SAko
`H@0ok1k5?n`LP3o/5D0oheE2_nNGQCo/5D0oiiN5?mkC0[oH44Dof0_5002
of11500Loh=N5?nNGQCo`H@0oh=N5?mkSFKo`K>]ol77`OoCfMKom^gZooKo
oooooooog:Xcong7G?oT/dOokLMLooK@Q?oT/dOoi;<YonBcAooT/bWoi;=7
ong7G?oT/dOog:XcolZQ?OoL/ecobYPDonBc7P;okKhm01Coi;<YonBc<ooT
/c?oi;<Nong7G?oT/dOoi;<YonBcAoo]_Sgo`H@0ooo]c?oohhkokLN4oooS
S_o]d9Som]UVong7Q?ofd8CokLMLooK@Q0;okLN400kokLMLol640?n`Q2Wo
bZY7olZH:On`Q2Wo^HdDoiib5?n3GQCoNd`:odHV5?lS9P[o4A`:oaXB50;o
4A`:01_o2@T:ob<L2_nEV6KoSHe7ofYE7_lA9P[o6Q8Doa4V5?lJ2@[o;1`D
ojI<0?ofaakoi:X0olZH5?niSC?o^FL0oheE2_nNLP[oH2l:ob`L5?lJ9QCo
6Q8Doa4V5?l0003obZ5BolZZI_oTd<`00oo]m_D3ooKoo`05ojJc`Oo:d<7o
kOKeong]j_o]m_D00_ofool01_oooooo`LO<ol6c[OoLhmKokNgZomcSh5oo
i^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;ok^k^00gok>c/omcLg?l0
;97oW[gNojc8i?n_bNCoT[GJog:OcomjY];oP:[Eoh:Ze_n8[]WoRk;K00go
T;SO01SooOojookon_ooooOooocnonSJm?oI`_[oESBBogE?`?n1F<koSVC@
oiafcOnTP/coZHS?ojb;f_nbS_3o]Y?iokNFkOnhVNWo^I[ZokVJj?njVnOo
^igWokbNi_nmWnL2okfOi@03okfOionlW^Ko_9kX00?o^igW00?o_9kXokbN
i_nlW^H01OnlW^H3ok^Mi@;o_9kV0onmWnL@okbNj003okfOjOnmWnOo_IoW
00;o_9kV4OnkWND2ok^Mi`;o_9kX00Ko_9gYok^Lj?nkW>So^icXokZKjOnj
V^d2ok:Fk@0?ojnBi_n/RmcoZhGHojUoeOnOLM?oU6O>oh5C`?mgC[SoG3VE
omRooooWfOgomO;iookokOoionOoo_oh00;oZ<of0onYdOL02OlT;3CoAUMW
o`410OnK_^3o[MCjojgCnol`>TGoBUY[o`410@02ok7FoP06oj72ioliAE;o
2P`?o`X<3oljAeCoX/GY0_nbf?l03OljAeCoHGJ<oeAVNOl=41Co82L^ohVV
a?ncfOoo/m[oof5eR_lS:S;o2`d@obP`>On;ZL@01_neg?l00olV;SKoDVAd
okGLo`02okGLo`;o]]go00Wo>dQDofAjSOnfgOoo]mkoohVV_olY<S[o2`d@
o`d@4onWb^P00_nhgol01OmSN8[o92/bo`/>4?lY<SWoSZc400Co^N3o0onj
h?l3ok_Qo`03okgSoonmi?oo_NCo00?o_nKo0_o0iol9ol7Wo`?o`^Wo0_o3
j_l2olG/o`04olC/ooo6k_ooa^koolK^o`?oanoo2?o8lOl3olSbo`?obO?o
0oo;mOl3olggo`?oc_So3_o>nOl01?o@oooo/=G`okWCkomf[NX2oj_Po`04
ofi^K_nd];Coh>3Ponc/k5_ok^k^00OoWUhDojIW0?mkC1CoPd40oheE2_nN
LP[oPcP000?oUED000KoYVL0ojIb5?nVI`3o/780ok1k2_nNLPX4ojIW000?
oiib2_nVI`3oUED0oiEE0?mZ@@[obYPDokV45?n`SAkoYW8DojIb0?nVI`3o
UED0ojIb0?n3@@3oUED000;oPd400_mP;`X01Omb>03o?A`:oc@_7_lm70[o
ARH:00;oARl:0_mkC0X0:OnVLP3oSED:ojIW0?ld;akoJW9LojJQV?nVZZgo
g>?Pong]j_oLhn3o`H@0ofY12_oChoGob]31ojIb0?nEE@3oYW80ok1b0?nV
LP3oWW8:oiEE0?niSACo/8@YolZH:OnEE@3o2A8:ob`B0?lA70[o2@TDoaX9
2_lA70[o2@T:o`TB2_lJ2@[o8a`:ob<V2_lA70[o8a`:ob<V2_lJ9QCoARHD
00;oH2lD00OoUD`YoiEN<onELTOo`J64ojJ4Q?oL/j?o`J6400?og;>]00Co
g;jgonC@c?o]fLcokMW<0_ofkNX01?ookLcoi<O1onC7`Oo]fL`3ooKoo`0B
ooK]j_mZIc?oJUDNoiEE5?o:ZVKo^HdDok1k5?o:V1Co/780ok1k2_nVLQCo
YVL0oiEE0?nNGQCoSED:og]<5?mb>1Co=2lN0_m69Q@02?mb>1CoWUhDokV4
5?lJ4QCo`K>>olZn[OoTd<cog>?F0_ooool05?o1/jgoi;=7ombcG?o]aeco
g;=LonBnQ?o]ahCoi;<conBcAooT/bWoi;=7onfn?Oo]aecoi:X0olZQ?OoL
/ecom]24olZH5?oL/ecoi;=70ooT/c<00ooT/bWobZ4monBc:@03onBc<`0:
okV=<ooohhkokM2Hong7G?o]ahCoon>>ong@V?offFKokLN4ong7G0;okLN4
02cokLMLonfn?On`SAko/5D0ol640?n`SAko/8@Yok2=7_nVLP3oPehcofY1
2_mP;`[o8bH:oa4L2_lJ2@[o2@T:oa4L2_l92@[o;180ojJHKombSCgoJUDN
ob<V2_lJ9QCo6PT:oa4V2_lJ4QCoPbl0onBc:Oo:V1Codh@0olZH5?niQ1Co
YVL0oh=N5?mP;`[o6RHDob<L2_lA70[o6Q8Do`000?niV5cokLN4omcSeP?o
kOKe0_ofool01OofooGo/;k1ol6c[OoLhn3okNgZ00;om_oo0_ooool01OoC
fMKoYZZSonC@c?o]m_GodmWF05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN4000;ooooo00gooOgmonc/k?l0;93oW;cNojc8i?n_bNCoTKCJog6Oc_mk
Ym?oOj[Eoh>[f?n:/M_oRk;K00goT;KN01Goo_ofoooom_ooooOooocooo3Q
oooMaOooEC>Aof@n[OmjD/GoQUc8oi=/aOnMN<GoX7k:ojB1eOnYPn[o[8O`
ok6>j_ncTNOo]I?YokJDj?neU>D00_neU><00onfU^;o^9STokRHi002okNG
h`;o]YGT0_neU><03_nhUnKo^9STokRGi_nhV>Co^9OVokRHi?nhUnKo^9ST
okFDhoneUN7o]YGTokJFh_ngU^Go]iOS0_nhUnH2okJEi00MokJEi_nfUNCo
]YGVokJEi?nfUNKo]YGTokJEi_nfUNCo]YGVokJEi?nfUNKo]YGTokJEi_nf
UNCo^9OVokRHi?ngU^Go]iOSokJEi?nfU^;o]ICSokFEhOnhUnKo^9STokRG
i_nhV>Co^9OVokRHi?nhUnH01OnhV>@4okRGiPCo]iKW0ongUNT04_nfU^_o
ZhoVojZ>honWR]coY8;Foj=kdOnQM=7oUfK?oheKb_n5E<[oKD6boe<^S_oF
_?ool>;ooo_joooloncon?oUookon0;oZ/oe0onZd?H00olT;3Co3A0Cob`f
@002ojcBn004ojcAn?m_Qj3o30lBo`410@?o[]?j00?o[]CkojgCn_n]doX0
1On^e?/2ojoEn`05ojkDn_n_eOco[mGlojoEo?n`eod00_naeod00on`eoco
/]Wnok;Io`02ok;Io`Co/m[o00?o9Bhfoe5SM?ncf_l00_ncf_l2okCKo`?o
]Mco0_nggOl01?nfgOoo]M_lokSNoonhg_l3okWOo`03ok[Poonhg_go^^3o
00Go^^3o0onkh?l3okcQo`?o_N?o0onniOl2okoVo`Wo`>Ko0oo0j?l2ol7Y
o`;o`n_o00Coa>_oolK]ooo6kOooa^go0oo7k_l8olO`o`?ob?7o0oo9l_l0
0oo:m?oob_Gool[eo`03ol_go`?oc?So3_o=nOl01?oBoooo/=C`okG@k_mi
[^`2ojOLo`04ogIfM_o1`L7ol?3`oogmoE_ooooo00coSED:oiib2_nEE@3o
PcP0oh=10?n=E@[oUED0oheE2_nEE@3oWUhDojIb0?nNLQ@4oiib2P04ok1b
0?nVLP3oYW80ojIb00?oYVL000KoSED:ofY12_o:V2Wo/8dNolZH5?niSA@2
ojIb0004oh=10?nVI`3oUED0ojIW00;oPd4001SoLSP0of0_5?mP;`[oARH:
oeLL0?m6;`[o8bH:ocdL2_lS70[oJT4:og]<2_nEEACoWW8Dok1k5?lA70[o
LXdmoiFZ[On`_/7og>?PooKooooLhmKoLSP0ojK7h?o:ZTL2ol640003ok1b
0?n`N`[o/7/:00;o/7/:00OoUED0ok1k2_niSACobZ4mojIb5?lA70[o8a`:
00?o4A`:00Ko2@T:oa4L2_lA70[o8a`:oa4L2_m6;`X2ob<L2P09ob<V2_l/
9QCoARHDodH_2_mP@BWoPehcoiEN<onNLS?o/8AV00;o`J640_oL/j<01oo:
_Zgog;jgonC7`Oo]fLcoi<O1ongIc?ofkNX00_o]m_D0:ooLhn3om^gZooKf
mOofm_GokOKeooK]j_o:_ZgoH44Dof0_5?n`SE;om_ooonC7`OniV5cobYPD
oheE2_n`N`[oPehDojI<0?mkC1CoPd40oheE2_mkC1CoAT4Nob`V5?m69QCo
;2HDof0_5?mb>1Co8blNof115?n`ZXCo/;>gomcSh?o]kN[om_oooooooonN
LP[okLMLong7Q?oT/dOoi;j4ooKII_o]ae`00_oT/dL02OoT/bWokLMLonBc
Aoo]aecodj4YolZQ?OoCXBWom]24ombcG002onBcA`0:onBc<ooTZP3oi;<c
onBZ0?oT/akoi;<confn?OoT/akoi;=7om>H2P;okM2H00Som]24ong7Q?o]
d9SokLN4ooK@Q?o]ahCoi;=7ong7Q0;okLML01kog:Xcol640?nVLP3oSED:
oiEE0?nNLQCo/8dcoiib5?n3GQCoNd`:odHV5?l/9QCo2@T:oaXB5?lA70[o
2@T:oaX92_lS70[oWXAVoiEbAomPGS?o;2HDoaXV5?l94P[o6PT:oaXB5?mb
9P3oi;<conBc:OniSC<2ok1k2P0;ojIW0?n3GQCoH2l:ob`V5?lJ4QCo2@TD
oaXB5?l92@[o/7/Yong7Q?oL_[L01?o]m_D01_ofoooooooool[@e_n`/kOo
g>?Fong]jP?om_oo00Koooooom?Ie_o1/jgob]31ooK]j_oLhn1Oooooo`04
ojn_[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP0=onc/k?oLg=co02fAoifm
g_n[an?o//[Toi6ef_maW/goO:ODogjXe?n2Z]KoR:oJohbcf`0=oi2hh0;o
oooh01?oo_ghoooloooij_ooh/_ooei0V?mH<igoK4BfogM@^on7H;goTF_0
oiMaa?nIMLgoWgWNoj=niOnVP^;oZHSSojf<ion_S^Oo[hkU00;o[XkS00Go
[XkQok:BiOnaTNCo/I7Tok2@h`02ojn?i0;o[XkS013o/I7Vok6Ai?naTNKo
/I7Tok6Ai_naTNCo/I7Vok6Ai?n^S^?o[XkQojn?i?n_Sn;o/93Uok6Ai?na
TNKo/Y;W0_n`T>D07_n`SnKo/93Uok2?i_n`T>Go/8oVok2@iOn`SnKo/93U
ok2?i_n`T>Go/8oVok2@iOn`SnKo/93Uok:BionaTNCo/I7Vok2@hon_SnCo
[hoRojj>hon^S^7o/Y;Wok:BiOnbT^Oo/Y;Uok:BionbT^Go/Y;Wok:Bi@Co
/i?V1?ncTnP3ojn>i@0Fojj=i?n^SNKo[HcUojf<iOnZS>;oX8OJoin6eonP
P=?oVgO?oiY^cOnFI/coSES:oh=<`omlA/3oHS:Roe/fTooOa?oono3oooon
ooojonconooZookon0;oZloe0on/d?H00olT;3Co0000of^1V@03ojkBn@03
ojS:lOl82@_o0@4100?o/=Cl2?naeOd3ok7Fo@?o/]Km00?o/mSnok;Ho_nb
f?h00_ncf_l3okCJo`Co]=_o00?o9Rhfoe5SM?ndfol00_ndfol2okGLo`03
od1>FomWOY;o]Mgo00;o]mko00Co^=kook[Ooonjgooo^]oo0onjh?l8ok_Q
o`?o_>7o0onmh_l00onni?oo_N?ookgSo`03okkUo`;o_nKo2Oo0i_l3ol3W
o`;o`>So0_o1j_l01?o2j_oo`ncool?/ooo3k?l3ol?]o`So`nko0oo4l?l3
olKao`03olWcooo9m?oobOCo00?oc?Ko0oo>mol>oloio`04om3ooon_e?3o
^=;^ogJ]jP;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01?nNLP[oUED0
oheE2_mk@@03oiEE000:oheE2_nEE@3oYVL0ok1k2_nVLQCoYVL0ok1k5?nV
LP3o/7/:ok1b00;oYW8000SoYVL0ok1k2_nEE@3oUED0oiib2_mZEAkobYPD
okV450;o/8dN00Co/7/:ojIb0?nVLP3oWW8:1?nEE@002OmkC0[oLRH0odHV
2_mP;`[oARH:ocdL2_lS9P[o;2HDob<L2P02ofY12P0<oheE2_nEEACo/7/:
odHV5?nEZZgoYZZSol77`OoTd<com_ooojJZXom?IdOom_oo0_o1Q0003on`
SAko^H@Dok1b0?o1Q03o/7/:ok1b0?nEEACo^H@Dok1b0?o:V2Wo`H@0o`TB
2_lA9P[o8a`:o`T92P02o`TB2P06oa4L2_l92ACo8a`:ob<L2_l/9QCo4A`:
0olS70X01?m69QCoH2lDofYE7_mkC1@2oiEbA`07ok24I_o1XHCo`J64ombc
[OoL_[Oog;>Sombn]`02onC7`@07ongIc?ofkN[okNgZooK]j_ofm_Gom^gZ
ooKfm@02ooKoo`0JooK]j_o]fLcoUHeBof115?nNLQCobZYVol[@`Oofoooo
ooooomcSh?o1XHCo/8@YoeLL0?lm70[oARl:of0_2_mb>1CoH2l:ocdL2_lA
9QCo2A`Noa4V7_l/71Co4A`:oiib5?nVXIP2ol6c[@0:omcSe_o]m_Gom_oo
omcSh?n`N`[om]24onBnQ?oT/dOokLMLong@V0;oi;=700Goi;<colZQ?Oof
fFKoi;=7ong7G002olZH500?okUW0?oT/dOoon>>ombcG?oT/dOoi;<YolZH
5?oTZP3obZ4monBc:Oofacgoi;=7onBc<oofacgobYPD00;okM2H0_o]ah@0
0oo]d9SokLN4ong7Q004ong7G00IombcG?oLZS?o^HdDog8h5?n3>03oPehD
oiEE5?n`SAkoWW8:oh=N5?mZ@@[oARl:oc@_7_l94P[o6Q8Doa4L2_l92@[o
4A`:o`T92_n=SDOoPg/cofYE7_lA9P[o6RHDo`TB2P02oa4L2P0CoeLL0?of
/`3oi;<Nom>40?o:V1Co/5D0ok1k2_nVC03oJT4:ob`V5?lS9P[o6Q8Doa4V
5?l92@[oNd`DoooSS_nVXISokOKeong]jP03ongfm@05ooKoooo1alcoYZ6H
omcSe_oLhn000oofool01_ooooookNgZoiFQS_o1alcom^gZol[@eUook^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV00goi>CTomCDe?l0;97o
W[oOojc8i?n^b>CoT[GJog:Oc_mjYM?oOZSDoh:[e_n7[m[oS;CL00goT;SP
01?oo_ojookmnOomn_GooogooooboooUd_ooJTjKoe8`TOmN>:GoJT>`og]C
]_n7H;goSfS1oiE^aonKM]KoWg_KoiekfOnPP]coYXSP00;oZH_Q00?oZ8_O
ojR;gOnXRmd00_n/Sml01?n[S]koZXgMojV<g_nYS=h2ojR;g`SoZXgO0_nX
Rmd2ojV<gP04ojZ=gon[S^3o[8oQojb?hA3oZXgQ0_n/Sn401?n[S^3oZXgO
ojV<g_nYS=h2ojR;g@SoZhkP0_n/Sml4ojb?h@;o[8oS0_n[S^800onZS>;o
ZH_QojR:h002ojJ8gP0BojF8f_nIPL_oVX3:oiQhbonCK/_oTVG<oheKb_n4
CLGoNT:mofLbZ?mG:93oK4VKonkFoooonOooo?gooo?ojooionooo_oj0_n[
d_T3ojcCn@03ogNB[?mXP9KoY<W]00;o[mGl00Co[]Glok3Fo_mmV;GoJX:J
0onaeol>ok;Ho`03ok;IooncfOoo/mWo00Wo/m[o00?oNiJ`ohbZb?ncf_l0
0_ncf_l2okCKo`03ognK]?nA/<go]Mco00?o]]go0ongg_l3okSOo`So^N3o
0onjh?l3ok_Qo`03okgSoonmi?oo_NCo00?o_nKo0_o0iol9ol7Wo`?o`NSo
0_o1jOl2ol;[o`04ol;Zooo3k?oo`ncool?/o`?o`ngo2?o3k_l3olC`o`?o
a_7o00?obO?oolWdooo9m?l00oo<m_l3olkgo`kocoWo00Cod_oook3Fl?nf
d>koNJo^0_n[g_l01?mZJV[o[Zj^omSHf?oTi>AKonKViP;oWW8:1On=E@X0
1?nEE@3oWW8:oiEE0?nNLPX2ojIb50;oWW8:0_nVLQ@07onVLP3oYW8DojIb
0?nVI`3oWW8:ojIb0?n=E@[oJT4:onBcAoniSACo^HdYokV=5?n`NaCo/7/:
ojIW0?n`N`[oSED:ojIb0?nEE@3oYVL0oh=10?mZ@@[oH2l:og]<2_mP;`[o
ARl:ob<V2_lS70[o4BH:odHV5?m6;`X00_n3GQ@06?nNGQCoAT4Noh>4NonV
ZZ?o`LO1ongfmOofooooH5hcoh>4Noofm_Go`H@0okV=5?n`SAko^HdDok1k
5?n`N`[o^HdDok1b0?nEE@3o/7/DojIb5?niSACodiP:oaXB50?o4A`:00?o
2@T:oaXB5?l94PX00_lJ4Q@01_l/71Co6RHDoa4L2_lJ2@[o;1`DoaXB50;o
ARHD00KoH2lDoh=N<on3GS?oYW9BojJHKonVQ8@2ol6QQ004onBZV?oL_[Oo
g;jgonC7`@;okMW<0oofkNX3ooKfm@0<ooKoooofooGob]31olZn[On3GS?o
UEhcok1k:OnVXFKoWXdcojJHQ?n`/kOom_oo0_ooool07ooTd<coYYQ_oiF=
I_nVV6ooWW/coh=k<omZIc?oJT4:ofYE7_n3GQCoPg/cojJHKoniZVoo`LO1
ol[@`OoL_[OokNgZooKoooo]fLcokLMLok2=7_o]ahCokLMLonfn?OoT_XCo
kLN4ong7G?oT/c?okLMLonBcAoo]d9P00_o]ae`01ooT/bWo^H@Dok1k5?n`
N`[og:Xconfn?Oo:ZVH00ooT/bT00ooT/c?obZ5Bong7G002onBc:@07ong7
G?o:V1CokLN4ong@V?oL/ecokLN4ong7G003ong7Q00=ombcG?o]aecokKhm
onBcAooCXBWobYPDoh<_0?nNGQCoPd40oiib5?nNLS?oWW8Doh=N5002ofY1
2P0Aob`V5?lS70[o2A`Do`TB2_l971Co6PT:o`000?n=SDOoPg/cof1N<old
;ako6RHDoaXB5?lA9QCo6PT:ocdB2_oT/bT00_o:V1@03oniQ1Co/7/:oiib
2_mkC1CoH2lDob`V5?lS70[o2@TDoa4L2_l92@[oLUEBooK@Q?nVV8Com_oo
ong]jP02ongfm@;om_oo00godn?eoiFQS_oLhn3og>?PooKomOoChoGokOKe
ooooooofooooYZ6Hol[@`Oo]fLcodmWF05ooi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X000;ok^k^00gok>c/omcLg?l0:i3oW[oNoj_7hon_b^GoT;CI
og:OcomjY=;oOZSDoh:Ze_n7[MWoS;CL00goT;SO01Soookooogko_ooo__o
noGeoookoooom_ooRW2_oe4aQ_mJ=IcoF3:Oof]4[_n6H<GoRV?0ojEneon^
Qn3o[H_QojnBi?n`UNKo/iSWok:Gi?naU^?o/IOQokBJhongWN@2okFKhP04
okBJhOncVN3o/YSQok:Hh@;o/IOQ2?ncW>@2ojnHh0;o/9WQ00Oo/I[Rok:K
honcW>Co/icTok>KiOnbV^Co/9SR00;o[iOQ00?o/9SRok:Ji?ncVnD00_nc
VnD01?nbV^Co/IWSok2Hh_n`V>82ojnGh@;o/icT00Co/Y_Sok6Jh_n`VN7o
/9WQ0_n_V>08ok>Li0;o]I_R1?neVn@2okFKi@04okBJi?ngWNOo]Y_Xok:G
i0;o[iCQ01?o[Y?Poj^Af_nYT=7o]YgOojB4eonLMmOoXW?SogQ5__mjA<3o
GbVQoe<RSOmJ;hSoQFNWoooboooon_oomoSjooWon?o`nngoo_ok00;oZ/oe
0onZd?H3oj_AmP;o[=;h00Co[=7hojgBn_n]d_[o[M;j0on^doX8ojkDn`?o
[mGk0on`eO`00onae_go/MOmok7Go@02ok;HoP?o/mSo2OndfOl2okGIo`?o
]M[o0onfg?l3okONo`?o]moo2?nhgol3okSPo`?o^N7o00?o^^;ook_Qoonk
hOl00onlh_l2okgSo`Wo_NCo0onni_l2okoWo`;o`^[o00Co`N[oolC]ooo4
kOooa>go0oo5k_l8olK`o`?oao7o0oo8l_l00oo:m?ooboGool_eo`03olgg
o`?oc_So3_o?nOl01?o@o_oo/=C_okSBkomi[^`2ojcOo`04ofi^K_nd];Co
h>3Ponc/k5_ok^k^0_nNGQ@3oheE2P0;ojI<0?nEE@3oWUhDoiiN5?nNLQCo
WW8:ojIW0?nNLP[o/7/:ojIW0?nNLPX00_n`LP003?nVLQCo/780oiib2_nV
LP3oYVL0oiib2_mZ@@[og:XcolZQ?Oo:V2WodiP:ok2=7P;o/7/:00GoYW80
oiib2_n`LP3oSED:ojIb0002og]1000Nog]<2_mZ@@[oLSPDodH_2_lm70[o
8bH:ob<L2_l/71Co6RHDofY12_mP@ACoPehDob<V2_mZLUcoUIRSol[@e_o]
kN[oPhB>ok2c]oo]kN[og>?Fol640?oLZS?o`H@0ok2=7_niSACo/7/:okV4
5?n`N`[oSED:0_nNLPX01?mb>1CobYPDodHV2_l94PX4oa4L2P0Ao`TB2_l9
2@[o4A`:odH_2_l/71Co4A`:ob<L2_l/71Co;180oc@_7_m6@AkoH44Yog8h
5?nELTOoYW9Bok24I_n`Q7/00oo1XH@00ooL/jgog;jgonC@c002ongIc0Go
m^gZ0_o]kNX05_oTd<co`J64okVZKon3Nc?oWW/cojJ4D_o:XCgoJVLcoh=N
5?mZ@@[oARHDof1bNombSJgodn?eol[@e_o1alcom^gZong]j_oLhmKog;jg
omcSe_oLaj<4ol[@`@0?ol6c[OoLhmKog>?Pooooooo]m_GodjY7ong7G?ni
Q1Com]24ombcG?oT_XCokLMLong7Q?o]aecoi;=700;okLN400KokM2HonBn
Q?o]ahCokLMLojIW0?nVC002ok1E0003okUW0?oT/c?oi;<c00Ooi;<c00Ko
i;=7onBc7_oT_XCom]UVong7Q?o]ae`2ong7Q00;ong7G?o]ahCoi;=7onfn
?OoT/dOokKhmol640?n3GQCoUEDDojIb5?niQ1@00_n`SAh07onNLQCoPehD
of115?m6;`[o8bH:o`TB2_lS70[o2A8:oaXB5?l92ACo2A8:oh=N<on3Nc?o
JUDNodI17_lS70[o2A`DoaXB5?l/71Co6Q8Doonc0?o:V1Codh@0okUW0?ni
Q1CoYT`0oheE2_mP;aCo;2HDob<L2_lA9Q@00_lA70X01?lJ2@[okLMLok24
I_ofool2ong]jPCokOKe00?oYYR4ol77c?oLhn000_o]m_D01oofoooooooo
oooooon=SFoog;jgomcSe_oCfMH0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@000_ooool03OomoOgok>c/o`0XSOnL_=ko[<OSojk9honA]M[oLIg?
ogZTd_mnZ=GoPjcHohR_f_n<]=`03On@]]l2ooolo`;oookk01GoooWloog`
ooo>^>Ko>AiSodd/Qom78X_oJTF_og5;/_nROMco[HKOokZDion`T=co_J?Z
okjWjoo1Z^ko`J_/oknYjOnoZNOo`ZcZolB_j_o8/nh00_o7/^d00oo6/Nco
aJo]olF_k@02olB^kPSoa[;_0_o3[n`2olB`k@07olFak_o6/^ooa[;_olNc
l?o7/o;oa[;aolB`k`02ol>_kP04olB`koo6/_7oak?bolNclP;oa[;a00?o
aK7`olB`koo4/>l00_o3[nh01?o7/o3oa[;_olJbkoo5/Nh2olB`k@;o`jo/
2?o6/^l2olNbk@Coak7_0_o7/O406Oo4[^koa[3`olJ`lOo3[Nko`J_/ol:/
kOo1Znco_ZSXolVajoncVM[o[8_LolZToon3El[oM4:mog=1^_mD99;oG36=
odLSJOo>]>?ooNooookhooonooool__fooWonoonool00_nZcoH3oj_@m`?o
[=7h0_n]doX01?n^d_[o[mClojoDo?n_e?`3ok3Eo@So/MKn1_naeoh00onb
f?ko/]Sook;Ho`05ok?Io`Wo/m[o0_ndfol3okKLo`;o^=ko00Co]moookWQ
oonihOoo^N7o0onkh_l8okcSo`?o_NCo0onmiOl00onoiooo_nKookoVo`03
ol7Xo`;o`NWo3?o2j_l2ol?[o`?oa>co0oo5kOl;olK^o`?oao3o0oo8lOl0
0oo9looob_?ool[co`03ol_eo`?oc?Ko3_o=n?l01?o?nooo/=?`okKBk_mi
[^T2oj[Po`04ogIfM_o1`L7ol?3`oogmoE_ooooo00GoYVL0oiiN5?n3@@3o
SED:oh<h0002oheE2P;oWUhD00SoYVL0ojIb5?n`NbWoWW8Dok1k2_nNGQCo
WW8:ok1b00;oWW8:00co/780oiib2_n`LP3oWW8:oiiN5?mZ@@[og;=Lom>Z
Aoo:XCgobYPYokV=:On`LP02ok1k2P?oYW8000Go/7/:oiEE0?nEE@3oSED:
oh=10002og]<2P06odH_2_l/9QCo4A`:ob<V2_l/71Co6RHD0_m69Q@03Om6
;`[oLXdmoiFHXon`/kOo/;k1omcSe_o]kN[odn?eongfmOn`LP3o/8dNokV=
5?n`SAh00_n`N`X01OnES@3o/7/:oheE2_nNLP[oYVL000;o^HdD01goWW8D
oa4L2_l94P[o4A`:oaX92_l94P[o4A`:oaX92_l94P[o8bH:ob<L2_l/71Co
4A`:ob<V2_l/9QCoARHDodI17_mP;aCoPehcoiib<onEGS?oWXAVojJHQ?o1
XHCo^JY_ombcXooL/jgog;jgonC7`@02ongIc004ooK]j_ofm_Gom^gZooKf
m@;om^gZ00Koi=3<om>nS_niZVoo/8eBokVHG?oTZYP2ol6cSP03ol6QQ?n`
SE;o/:Z400;odkj>00ko^JY_oh=N5?l0003o/;>gongfmOoLhmKokNgZol[@
e_o]kN[og>?FonC@c?oLhn3og>?Fom?IeP;og>?F00Wog>?PooKfmOoL/eco
i;<cong7G?niSACom]24ong7G?oT/dL00_o]ah@2ong7G00<onfn?Oo]ahCo
kM2Hong7Q?o]d9Sog;=LoiEE0?n3;`3oYT`0oiiN5?nV@@3obYPD0_oT/dL2
onBc<`Coi;<Y00Coi;<NombZ<ooCZTOokM2H0_o]ah@02_o]aecokM2Hong7
G?o]ahCoi;=7ong7G?oL/ecoi;=7olZH5?niI`02ok1k5003olZQ?On`SC?o
YW8D00;oWW8D02CoNd`Dof0_5?lS9P[o6Q8DoaX92_l94P[o2@TDo`TB2_l0
003oJVLcoh=N<omZEAkoAT4Nob<_7_lA9QCo6Q8Dob<L2_lJ2@[om/LNokV=
<ooCQ03o^H@Dok1k2_nNGQCoPehDofY12_l/9QCo;1`Doa4L2_lJ2@[o6Q8D
oaX92_offFKoYW9BooKooooLhn03ongfm@03ooKoooo]m_GoSIR>00;og>?F
00Wom_KeooKoooofoooom_oooooooon=V8ko`LO1omcSe_oCfMH0Goooool0
1?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h03Oo/k>cog=cLo`0URonJ
^mkoZlCSojc7hon@]=SoLIk=ogZTd_mnYmGoPj_HohR_f_n=]M`03On@^>00
6?oooOooo_gooo_jn?oooo[oo_WeoooeoOoomoooPVjQocTOJOm59X?oA265
ogA@]?nNNMSoe;3oolJTlOo=[_;o`JWUol:_i_o5/^Woa[CXolBbi?o3/N7o
aK?SolRgi0?obKSU00?ob;OTolNeiOo7]ND00_o6]>H8olVgi`;oa[CT0_o7
]ND00oo8]^KobKOWolVgi`02olVgi`06olRfi_o7]NGoa[CTolJdi?o7]NGo
b;KV1?o9]nL00oo8]^KoakGUolNei@02olJdi0?obKOW00?ob;KVolNeiOo7
]ND00_o6]>@8olVgi`CobKSU1?o9]nL06Oo7]NOob[SZolZhj_o7]NOoakGY
olRfj_o7]NWoa;3UokjUg?o6Z>SoaJ?gokNAm?nPM^KoL4>hoe8VUom56ggo
@1iXohebYOool_oooo_oooGcn?ohn_WonoooooSno_onool00_nZcoD3oj[@
mP?oZm7f0_n/d_P01?n/dOSo[M;jojgBn_n]d_X3ojkCnPSo[]Ck0on_eO/3
ok3Eo003ok7FoOnaeogo/MOm00;o/]Sn0oncf?l9okCIo`;o]M[o0onffol3
okSNo`?o^^7o0onkh_l8okcSo`?o_N?o0onmi?l00onniOoo_^CookkTo`03
okoUo`;o_nKo2Oo0i_l3ol3Wo`;o`NSo0_o3j_l01?o3joooaNgoolG]ooo5
kOl3olK^o`Soa^oo0oo7l?l3olSao`03olWcooo:l_oob_;o00?oboCo0oo<
mOl>olgfo`04olokoon`eO3o^M?^ogV^j`;oZmoo00CoKVi^okBd]?oPh>3o
k>c/Foo^k^h02OnNLP[oWW/coh=10?nNLP[oPcP0oheE2_nEE@3oYW80oiiN
5002oiib2P07ojIW0?nNGQCo/7/:oiib2_nVI`3oWW8:ok1b0002ok1k2P06
ojIb0?nNLP[oYW80ojIb5?mZEAkog:Xc0_oCZTL00oo:V2Wo^HdYokV=5003
ok1k2P?oYW800onEE@02oheE2P04oiib2_mP;aCoARH:oa4L2P;o6PT:0_lA
70X03OlJ9QCo4A`:og9WD_nEXHkoYZZ]ol77`OoChoGog>?FomcSh?ofoooo
YW8Dok1k2_nVLQ@00_nNLQ@02_n`N`[oUED0ojIb0?n=E@[oUED0oiib2_n3
GQCoSED:ofY12_m69Q@3oa4L2P03oaX92_lA70[o4A`:00;o4A`:00So8bH:
oa4L2_lS9P[o;1`DodH_2_m6@AkoPehcof0_2P;oPehc00CoUHABok1kI_nN
Q6Ko/8Ak0_o1XH@01OoL/jgog;jgonC7`OoTal7okMW<00;om^gZ00Com_Ke
ooK]j_oLhmKoi<O10_o1/hh00oniV5coYYQ_olZZIP02okVZK`04ombn[OoT
d<cob]31ong]jP;og>?P00Cog>?FonC@c?n3Nc?oYZ6H0_oTd<`05?o]kN[o
dmWFong]j_oLhn3odmWFomcSe_oLhn3okNgZom?Ie_o]kN[okOKeolZQD_o]
_Sgoi;<conBcAoniSACokM2HombcG?o]_SgokM2H0_o]ah@01ooT/dOog;>S
ong7G?o]aecog;=Long7Q?o:V1@00_n3;`001?n`C03odh@0ok1k2_nEE@02
ombZ<`05onBZ0?oT/dOoi;<conBc<ooT/dL00_oT/bT00ooLZS?obZ5Bong7
Q002ong7Q004onBnQ?o]d9SokKhmong7G0;oi;=700SokLMLonBcAooTZP3o
dj4Yol640?n`NaCobZ4mok2=7P?oWW8D00CoH44DodH_2_ld;ako2@T:0_lA
70X2oaXB500Mo`000?mZIc?oPg/cofYW<om6@Ako8blNo`TB2_l971Co8a`:
o`T95?oT/akodh@0ok1k2_niQ1Co/7/:ok1E0?mkC1CoLSPDob`L5?lS9P[o
4BHDoa4L2_l/71Co2@T:oooSQ?nVLU;om_ooom?SmOoLhn000_o]m_D01Oof
ooookOKeoh>4S_o1alcog>?F00;okOKe0_ofool01OooooooPhAkol6c[OoT
d<codmWF05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV00go
i>CTomGEeOl088SoU[SLojO3hOn/a^?oRjoEofjKc_mgXm3oOJGDoh2Xe_n6
[][oRK7K00goT;SP01[ooogoooWhooooo_oom_G`oooon?oooOgooo[oooSX
oomaG9Oo90UFocXLM?mQ@9_oTVo9ok:?honkVNGob:_]ol6Yhoo3[n;ob;CW
olVei_o8]>GoakCRolVfhoo;^N?ob;GRolRfh0?oakCQ0oo6/n403_o8]N?o
b;GRolRehoo8]N;ob;GSolReh_o8]N?ob;GRolJchOo6/n3oa[?QolNdhOo7
]>;oakCQ0oo8]N<00oo7]>;oa[?QolJch@02olJch@04olNdh_o8]N?ob;GS
olReh`?oakCR0oo6/n403oo8]N?ob;GRolNdh_o7]>7oakCRolJch?o6/n7o
a[?PolRehoo8]N;ob;GSolReh_o8]N?ob;GRolReh`07olRehP?ob;GS01So
b[OUolZfioo7/nCoak?TolRdiOo6/^Go`jcPolf_joniV=godJkookF@l?n<
ILooDBZDod8MOOla467oJe:;ooodoooomOoooo[looonooolo_gon_goooco
ooonool2ojS?m@?oZ=3f0onYdOL3oj_Bn@?o[M?k0on^e?`8ojkEo@Ko[mKm
00?o/=Snok3Go_n`eoh01OnafOl9ok;Jo`;o/m[o0ondfol2okGLo`04okGM
oonfg_oo]]kookKNo`?o]moo2?nhgol3okSPo`?o^N7o00?o^^;ook_Qoonk
hOl00onlh_l2okgSo`Wo_NCo0onniOl2okoVo`;o`^Wo00Co`NWoolC/ooo4
k?ooa>co0oo5kOl8olK^o`?oanoo0oo8l?l3olWbo`?ob_Co0oo;mOl>olcf
o`04omCooon^d^oo^=?_ogN^j`;oZ]oo00CoJVYZojj^[_oHf=Soi>CTFooV
i^H03_nNLP[oYW8DoheE2_n3;`3oSED:oiEE0?n=E@[oWUhDojIW0?nVLP3o
YW8Dok1k5?nVLP3o/7/:0_nVLQ@01_nVLP3o/7/:ok1k2_n`LP3oWW8:ok1b
00;oWW8:00_oJT4:ombcG?oCZTOobZ5BolZZAoniSBWo/8@YokV45?n`N`[o
/780ok1k2P02ok1b0006oiib2_nEE@3oWUhDoheE2_nNLQCoUEDD0_mb>1@0
1?lS70[o4A`:ob<L2_lA70X2oaXB500=o`T92_mPGS?oYZ6HojJZXon`_/7o
dmWFom?SmOo:d<7okOKeom?SmOnESFKoWXdYog8h0002oh=N500Bof0_2_mk
C0[oH2l:ofY12_mG703oJT4:oh>=Q?oLhn3o/:Z4o`000?lA9P[o6PT:oa4L
2_lJ2@[o4A`:o`TL5?l94P[oARl:0_lA70X01OlS70[o=2lNog8h5?mbSCgo
UG9700;oPehc00[oWW8cojJ4D_n`Q6Ko/8Akol6QQ?oTZYSob[j]onC7`OoL
_[Ooi<O10_o]fL`2ooK]jP03omcSe_o]fLcog<NS00;o`J6400WoSHe_ol6Q
Q?nVV6oog;>Sombn]oo:d<7odn?eomcSh?o]kNX00ooLhmH02ooCfMKoi=3<
ojJQV?o:d<7o`K>]ongfmOoLhn3okNgZomcSh?o]kN[og>?P00;ob]31013o
kOKeong@V?o:ZVKoi;<NombcG?o]_Sgoi;=7om>Q:OoT_XCokLMLombcG?o]
aecoi;j4ong7G?oT/dOokLML0ooT/dL02OoCZTOodj4YojI<0?nNGQCoPbl0
ok1E0?n`N`[o/4`0om>Q:@02onBc<`;oi;<Y00?oi;<NolZQ?OoLZS<00_oT
/bT01_niSC?om]24ong@V?o]ahCokLMLong@V0;okLML013og;=Long7G?oL
/ecokLMLonBc:OoCXBWobYPDokV45?o:V2Wo/7/Yoiib5?nNLP[oPehDog]<
2_m6;`[oARHD0_lJ2@X08?l92@[o6Q8Do`T92_l92ACoAT4Nohf=Aom6EBWo
=2lNob<_7_lA70[o2@TDoa4L2_l92ACodh@0ombZ<ooCQ03o^H@Dok1E0?n`
NbWoPd40og]<2_l/71Co8a`:oaX92_lA9QCo6Q8Do`000?o]aeco^Hdcongf
mOoLhn3okNgZ0oo]m_D01?ofooooSIR>ol[@`Oo:d<42ongfm@;om_oo00Go
oooooiFQS_n`/kOog>?Fom?IeP1OonKViP04oifMWOng]kOob<S8om?Cd`7o
f][J0002onk^kP0=onc/k?oOgmoo3bB6ohB[eOnU`^3oYL?QohJ^eOmXUl[o
Lio?ogNTdomoZ=KoQ:kIohVbf@0=ohffg00KooWjoooin_koooooooonn_oo
oo[oookkonOPj?oonOoooo7oocdXH?lj86OoDSJ3ogEFY_naT=oo]iORokZL
h_ngWMko^j?Ool6YiOo4[>Ko`jcTol:[hOo3[>3oaJoPolB]hOo4[]ooa:gQ
00;o`jcP0oo3[>803_o4[N?oa:gQolB]hoo4[N7oa:gSolB]hOo4[N?oa:gQ
ol>/h_o3[>3o`jcRol>/h?o3[>;oa:gQ0oo4[N<6ol>/hPCoa:gS1Oo3[>80
3oo4[N?oa:gQolB]hoo3[>3o`jcRol>/h?o3[>;o`jcPolB]hoo4[N7oa:gS
olB]hOo4[N?oa:gQolB]h`07olB]h@;oa:gS00?o`Z_Qol>/h_o2Zn<00oo0
ZN403onlY=ko]igJokjMh_o3W^_oZhGLoi5]aomN>iOoDC27oc8FHOm0:6Co
ooCooo[^ooooo?ooooomoo;bl002ookoo`04ooWjo_ooooooY/keojK>m@?o
Ylof0onXcoH2ojW@n004ojWAmonZd_WoZ];ioj[Bn@?oZm;i2?n/doX3ojgD
nP?o[MGk00?o[mOlojoFoOn_e_d00_naf?h3ok7Io`Wo/][o0_ncfol3okCL
o`;o]]go00Co]]kookSOoonhgooo^=oo0onih?l;ok[Qo`?o^n;o00?o^n?o
okcSoonlhol00onli?l;okgUo`Go_^Ko0oo0j?l6ol;Zo`So`n_o0oo4k?l3
olG]o`03olK_ooo5koooaNoo00?oa_7o0oo7l_l>olSco`04olknoon_e?3o
^M?_ogN^j`;oZMco00CoKVi^okBd]?oPh>3ok>c/Foo^k^h00onNLP[oWUhD
oheE2P02oheE2P05oh=10?nVC03oSED:oiEE0?nNGQ@00_nNLPX01?nNGQCo
/780ojIW0?n`N`X2ok1b0008ojIb0?n`N`[o/780oiiN5?n`N`[oWUhDofY1
2_oL/e`3olZZA`05olZH:On`LP3o^HdDok1b0?nVLP000on`LP001?nVI`3o
WW8:ok1k2_nNLPX2oiiN5004og]<2_n=E@[oH2l:ob<L2P;o4A`:01go4BHD
o`TB2_l92@[o4A`:oiFZ[OmbLW_o/;k1omcSh?o:d=KokNgZol[@`Oofoooo
/;>gong]j_n=SFooPg]LofYE7_m69QCoJVLcohf=D_nVQ8CoYYR4ol[@`On`
/kOoAUDYofY12_l/9QCo4A`:o`TB2P02oa4L2P0EoaX92_lJ4QCo6Q8Doc@_
7_lA70[o6PT:oa4V2_l94P[o6Q8Dof11:OmZEAkoUHABoiEbAonNQ6KoUHAB
oij4I_nVQ8Co`J64ombcXooL_Zgob[j]00;og;jg00ooi<O1ongIc?oLhmKo
i<O1ombn[OoTal7o^JY_ok2=D_nVV6oo/8dcok2=D_oC_Xkob[j]omcSe_o:
_Zd00_oTd<`04ooLhn3odmWFol[@`Oo1alcodmWFong]j_o1/jgo/;k1ol[@
`Oo]kN[odmWFong]j_oCfMKog>?Pol[@`OoCfMKog;>4om>ZAooT/c<00_oT
/bT02ooT/c?oi;<YombZ<oo:ZTOoi;=7ombcG?oT/c?okLN4onBcAoo]aeco
bZ4m00Coi;<c01Gog:XcokV45?n3;`3oH2lDoh<_0?nV@@3o/4`0oiiN5?oC
Q03oi;=7olZQ?OoT/bWog:XconBc<ooT/dOoi;<combZ<ooT/bWo^H@Yong7
G?o]ah@00_o]ae`01oo]d9Sog;=LooKII_oT/dOokKhmong7G?oL/e`00_oL
ZS<01Oo:V1Co`H@0olZH:OnNSC?o/7/:00;oSED:00CoNd`DodH_2_l/9QCo
2A8:0_lA70X02?l92@[o4A`:o`000?m6@AkoLXdmofYE7_m6C3go4BHD0_lJ
4Q@01OlS70[o4BHNom>40?oCQ03o^FL000;o/7/:00ooYT`0og]<5?mkC1Co
8bH:ob`L5?l/9QCo6Q8Doa4V5?l0003obZYVokV=<ooChoGog>?FomcSh?oC
hoD00_o]m_D01oooooooSIR>ol77`OoTd<cokNgZongfmOofool00_ooool0
1?nEXHkoYZZSonC@c?oCfMIOonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
0002ooooo`0=ookno_oalO7o>T6Bof^Ab?nJ^]coWkoOogbUdomQTlOoK9[<
og:Od?mkZ=SoO:GEohB]fP0=ohRcgP08oo_mo?onooooo?cloooooOomo?[o
ooomoo[enOoonol2ooofo`0>odlkL?lf7EkoDcQooeDfP_n:JKSoXh??oj:3
conXR]Co/9;LokBFg_neUmgo]9OJokFHf_ngV]X3okJIf@;o]YWK1?nfVM`?
okJIfa7o]YWL5OnfVM/3okJIg003okNJgOnfV=ko]9KL00;o]9KL01?o[i7I
ojV9e?nTOM3o[HGKohMQ^?m[B9coABIdoa`1A_mVDH[oooKooooioooooOoo
ookoonc/j_onoogoo_ooong^l?onoooooooo00;oY<ce1_nTcOH2ojC>n003
ojG>monUcoWoYLoi00CoYLoi2?nUd?X3ojK@nP?oYm7k00?oZM;lojSCoOnX
dod00_nZe?h3oj_Eo`Wo[=Go0_n]e_l3ojkGo`?o/=[o0onbgOl3ok?No`So
]=oo1_neh?l3okKQo`Go]n;o2Onhhol3okSTo`;o^NGo0_nkiol01?nli_oo
_^SookkXoonnj?l3okoYo`So_n[o0oo0jol3ol3/o`03ol7]ooo0k_oo`>ko
00?o`Noo0oo1l?l>ol;ao`04olWjoon]do3o^M?_ogJ]jP;oZn3o00CoMWIf
ol71`Oo`l?3ooOgmFoooool01_nNLP[oWUhDoheE2_nEE@3oPd40oheE2P?o
UED000OoYVL0ojIb5?nNLP[oYVL0ok2=7_nNLP[o/7/D00?o/7/:00Oo/780
ok1k5?nVLP3o/7/:oiib2_mZ@@[om]UV00;obZY700KobZ4molZZAoniSACo
^HdDokV45?n`N`X2ok1b000=okV=5?n`LP3oYW80ok1b0?nVLQCo/8dNoiik
<onEE@3oSED:og]<2_n3;`3oARH:oa4L2P02oaXB500@oa4V5?l0003oSHe_
ojJZ[Oo1al7o/;>gom?Ie_o:d<7odmWFol[@e_mZNfoom_oeonC@c?oLhn3o
i=3<ol[@eP;o`LO100SokNgZol6c[OnESFKoPehcojJQI_o1/hkoWW8Do`TB
2P;o4BH:0_l92@X03OlA70[o6Q8Dob<L2_lA70[o6PT:o`T95?l92@[o6PT:
ob`V5?m6@AkoWW/coij4I_nELTL00_nVLU80:on`Q6Ko`J64ombn]oo:_Zgo
g;>]olZn[OoL_Zgog;jgongIc?oTal7og;>Sol6QQ?o]fLcoYYQ_oiF=D_nN
Q6Ko^JY_ol6QQ?oCfMKo`LO1onC7`Oo1alcob]31ol77c?oLhmKob]31ol77
c?n`/kOo`LO<omcSe_o:d<7oYZZ]ol77`Oo1alcob]3Fok2c]ooL/j?odkj>
onBnQ?oT/dOoi;<combZ<ooL/e`00_oT/dL02?oL/ecoi;=7onBcAooLZS?o
g;=LonBnQ?oT/akog;=L0_oLZS<01Oo:V1Cog:XcolZH5?oCXBWodiP:00;o
bYPD00WoLSPDoh<_0?n`C03oYT40oh<_0?niQ1CobYPDom>ZAooL/e`00_oT
/c<03OoCZTOoi;=7om>ZAooT/c?odjY7oiiN5?offFKokLN4ombcG?o]aeco
kM2Hong7G?o]ah@00_oT/dL02Oo]aecoi;=7ombZ<ooT/bWodiP:ol640?o:
V1Co/8@Yoiib2P02oheE2P03og]<2_m69P[oARl:00;o6PT:00Wo2A8:oa4L
2_l92@[o2@T:ob`L5?n3Nc?oJUDNoc@_7_lS9PX00_lJ4Q@00olJ2@[o0000
oiiN5002olZH500;ok1k2_nVC03oUEDDog]<5?mP;aCo8bH:ob`L5?lJ9QCo
2@TDoaXB5?l000000_o:XE82omcSh00:om?SmOo]kN[okOKeongfmOoooooo
SIR>ol77`Oo:d<7og>?Pongfm@;om_oo00GooooooiFHXonVXISoi=3<omcS
h01Oooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP0=ong]kOoU
iNGoLG6PodQS/_n;/MSoS[?Iof:CbOm>Q/7oG937ofNGc?m^WLooLj?BogfW
f00=oh2/f@05oocon?oloo[on?[gookooooinO/00_ooo_l04Ooon_koo_Ko
oooioooom_ooNfFFoc`RHoln8VgoDC64oeLeS?meD:goO5NdohEP_On;Il7o
S6S0ohaX_on=JL3oSfc000?oSFZn0_n=JL03oheY`A3oS6[00on<J/42ohe[
`P[oS6[14On<J/06oheY`0;oSFW1017oSf_3oi1/a?n?JlGoSV[4ohm[aOn@
K<KoRVG2ohEN^omcAjSoFbn>odlWOol^35Wo?b9Toh9^Xooolooooo[oon[X
mP02ookoo`06ooSjmoonoogom_Seoooooookno_ooooo0_nKa_43oi_7l@?o
W<Ob0_nMao<01?nMb??oW/Sdoik8m?nNb?@3oio8m@SoWlWe0onPbOH3oj7:
mP03oj;<n?nQc?SoXLch00;oX/kj0onScoX9ojC?n`;oYM3k0onUdO`2ojKB
o@04ojKAoOnWd_koYm;nojOBoP?oYm?o2?nXe?l3ojWEo`?oZ]Ko00?o[=So
ojgHoon]f?l00on_f_l2ok3Ko`Wo/Mco0onagOl2ok;Mo`;o/mko00Co/moo
okCPoondh?oo]>3o0oneh?l8okGQo`?o]^;o0onfhol00onhi_oo]nKookOV
o`03okWYo`?o^N[o3_njjol01?o0lOooZ<k`okG@k_mi[^`2ojOLo`04ofi^
K_nd];Coh>3Ponc/k5_ok^k^00CoWW8DoiiN5?n3@@3oWUhD0_n3@@002On=
E@[oUED0oheE2_nNGQCoYW8DojIW0?nVLQCo/780ojIb0002ok1k2P0Coiib
2_n`N`[o/7/:oiEE0?n`N`[oYW80ok1b0?mZ@@[oi;=7olZQD_oCZTOog:Xc
olZQ?On`SAko^HdDokV=:OniSACo^FL0okV45003ok1b000<ok1k2_n`NaCo
/7/Dok24:OnEEACoWW8:oiEE0?mkC1CoPd40odHV5?lA70[o4BHD0_lJ2@X0
6_lA9QCoSIR>ojJZXoo:d<7o`LO1ok2n`Oo]kN[oJW]_ol6c[OoLhn3o`LO<
omcSe_o1alcob]31ol6c[Oo1al7ob[j]ol6c[Oo1al7og;jgok2c]oo1/jgo
YZZSog]<2_l0003o2A`D0_lA70X01?lJ2@[o4A`:oa4L2_lJ2@X4oa4L2P0=
oaXB5?l/71CoAT4Noh=N<on3Nc?oJUDNoh=N<onEQ5;oYW9Bol6cS_o1/jgo
g;>Sombc[@03ombn]`0=om>nS_niV5co^JY_ombn[OnEQ5;oUG97oiik<oo1
XHCodkj>olZn[Oo1/jgo`LO1ol[@`@02ol6c[@;o`LO<00Wob[j]ol6QQ?nE
Q7_o`K>]ojJHQ?o1/hkodkj>ol6QQ?o:ZVH01OoL/e`2onBcA`0Pong7G?oT
/dOog;=Long7G?oT/c?oi;=7olZH5?o:XE;oi;=7ombZ<ooT_XCoi;=7onBc
<ooCXBWobYPDom>40?o1Q03odh@0ol640?oLZS?oEa`0og8V0?mP;`[oH2lD
og8h5?n`E@3oi;<combcG?oT/dOobZ4mom>Q:OoT/bT3onBc<`0<olZH5?nV
I`3okLN4ombcG?o]ahCoi;=7ong7Q?oL/ecokLN4onfn?OoT/dOoi;j40_oT
/dL00ooLZS?obYPDolZH5002okV=:@0Aoiib<omkC0[oSED:oh=N5?m6@Ako
;2HDoaX92_lA70[o6PT:oaXB5?lA70[o6Q8Dob`V5?nEQ5;oH5hcoc@_7_lS
9PX00_lA70X2oaXB500DojIW0?o:V1Codh@0okV45?nNGQCoUEDDog]<5?m6
9QCo;2HDob`L5?lJ4QCo4A`:oa4V5?l971ko/8dcombcG?oLhmKodn?eomcS
h?o]kNX2ongfm@06ooKomOnEZZgoYZ6HonC@c?oLhn3okOKe0_ofool01Ooo
ooooYZZSojJZXooTd<codmWF05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN4000?oi^KV00GohN7QokVi`_m4BI?oCg:foeJ:aP02ocMc^@05odF0`?mD
RLKoFi77of:Hc_m[W=803Om`X]D06?oho_3onoogookooOohnO_oookooo[i
o_ono?goooomooomoooon_ooooSoooocooool?oojlooof];X?m387co;PQ]
ocP?Mom26GooB223odXRQOm;8hCoC2B4oddUQ@;oCBJ300OoCBF5odhVQ_m>
9XOoCRJ7odhVROm>9XOoC2N700coC2N60om;9XD2od/VQPCoC2N71Om;9XH5
od`WQ`?oBbJ53Om<9hH4odhVQPCoCRJ701WoC2B7oddUR?m<98OoC2B7odlV
S?m@9hgoBb:8od@JP?lo47[o@19eofi6Woodd_oooo7ooooboooon?oonoSo
ooknooognokomo_loocoooo_lNkoo_omoooooOohn?Kooooo00;oRk_/0on;
^nd3ohblk@;oSKg^00CoS;g_ohfnl?n=__3oSKk`0on>_o08ohjol@?oSl3b
0on?`O<00on@`_GoTL7doi71m002oi;2mP?oT/?g2OnCa?P2oiC5n0?oULGi
0_nGao/01?nFao_oV<WmoiS9oOnHbOd3oiW9oP_oV/[n0onKboh00onLc?ko
W<gooic=o`03oig>o`_oW/oo0onOd?l2oj3Ao`;oXM?o00CoXM;ooj;DoonR
e?ooX]Co0onSeOl8ojCFo`?oYMOo0onUf?l3ojOJo`?oZMco0onYgOl>oj[N
o`04oj_ToonQb>ko^=;^ogJ]jP;o[=oo00CoJVYZojj^[_oHf=Soi>CTFooV
i^H03On`N`[oWUhDoheE2_n=E@[oUEDDoiEE0?n=E@[oYT`0oiEE0?nVI`3o
WW8:ok1k2_nVI`000_n`N`X00on`LP3o/7/:ojIb0003ok1k2P06ojIb0?n`
N`[oYW80of0_2_o]aecodjY70_o:XE801?o:V1Co^HdYokV=5?n`LP03okV4
500AokV=5?niI`3o/7/:ok1k2_niQ1Co/7/DokV=5?nVI`3oWW8:oiiN5?nN
LP[oYT`0oheE2_n3;`3o8bH:oa4L2_lA9Q@00_l94PX01ooCfMKo`LO1ohfH
S_oCfMKo`LO<ofYbG?o:_Zd00_o:d=H01ooLhmKo`LO1ol77c?o1/jgo`LO<
ol[@`OoLhmH00_o:d<405?oCfMKo`K>>ojJHKon`ZXCoPg/co`000?lA9P[o
2@T:oa4L2_lJ2@[o4A`:ob<L2_lA70[o2A8:oaX92_lA70[o4BH:oaX92_lS
70[oAUDY0_n3GS<2oiEbA`0GofYW<onNNc?o/8eBojJHKoo1XHCo`K>]ol6c
S_n`ZXCoWXAVokVHG?oC_Xko^JY_oij4I_nELTOo/8dconBnQ?oL/hCog<NS
okVZKoo:XE;og;=LonBcAooL/e`00_o:V1@01_oCV0[obYPDolZH5?oCQ03o
i;<combcG0?oi;=700Gog;=Lomc7XooL/ecoi;=7ong7G003ombcG003om>Z
AooL/ecog;=L00;oi;=700_og;=LokV=<ooT/dOodjY7onBc<ooCZTOoi;<c
om>Q:OoCQ03obYPDol640002om>40008okV45?mb>1CoARHDodHV5?mP;`[o
H2lDojI<0?oT/dL2ombcG004om>ZAooCXBWodj4YolZH50?odj4Y00?o/7/D
ong7G?o]ae`00_oL/e`02?o]ahCog;=Long7G?oCZTOoi;=7ombcG?oT/dOo
g:Xc0_oCXBT03?niQ1Co^H@Yok2=7_nNLQCoNd`:oheE2_mkC0[oARl:ob<V
2_lJ2@[o4A`:oaXB50;o2@T:01;o6Q8Dob<L2_mbSEcoJUDNoc@_7_lS;ako
4A`:oaXB5?lA70[o6PT:og8h5?oCQ03o^H@DokV=5?nVC03oYVL0og]<2_mP
;a@2ob<V2P?o6Q8D00Oo0000oiib<ooL/eco`LO<ongfmOoLhmKodn?e00;o
kOKe00gom_oook2c]onVZZgob]31omcSh?o]m_Gom_oeooKooooooooo/;>g
oiFQS_o1alcog>?P05ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000?o
k^k^00cok>c/on?ShonOWk?o=S^9o`/`UOl3AJ3o4UNZobAU/olaL[So?7Vm
odF2`_m:QlP@oeB=c0GoEHk=0_mFT<l00omGSlooF97AoeRAd@04oeRAd@_o
FI;B0omJTm800omLU=;oG9CCoebDd`02oejEd`coGiKC0omPUm<2of6He0;o
HYWE00CoHI[Dof:KeOmRVmGoHY_E0omSW=H8ofBMePKoIIkG00?oIYoHofNN
f?mWW]P01OmXWmT9ofVPfP?oJZ7K0om[X]`00om]Y=koK:COofjVh@02ofjV
h@?oKjOR2?m`Z><3og2Xi0?oLJWU0_mbZ^H01?mcZnKoM:cWogB/iomd[>L3
ogF]j0SoMJgY0omf[^T3ogJ^jP?oMjo/0_mh/>h3ogR`k`WoNK7_0_mi/O03
ogZbl0?oNk?a0oml]?83ogfelPSoOKGc0omn]_@3ogjgmP03oh2in?mo^OSo
OkWh00?oPK_j0_n1_?`9oh:mo@?oP[km0_n3__d2ohC0oP04ohG0o_n6`_oo
Q/;oohK2o`?oQl;o2?n7`ol3ohS4o`?oRLGo00?oR/KoohW6oon9a_l00on:
aol3oh_8o`koS<Wo00CoR/kooik3j_nfd>koNJo^0_n[g_l01?m^KVko];Bd
on3Ph?o/k>aKonk^kP09oiib2_nVI`3oUED0oheE2_mk@@3oSED:oiEE0?n=
E@[oYVL000;oWW8:00_o/780oiib2_n`N`[o/7/:ok1k5?n`LP3o/7/:ojIb
0?n`LP3oWW8:ojIb0002ok1k2P0;ofY12_oCZTOobZ4mom>ZAoo:ZTOobYPY
om>H2_n`SAko/7/:okV=5?n`Na@00_niSA@03?n`N`[o`H@0okV45?niQ1Co
^HdDolZH5?n`N`[o/8@YojIb0?n`NaCo/7/:ok1b00;oSED:00coPbl0of0_
5?ld;ako4A`:ocAE?On3SHCodmWFoiFQS_o1al7oYYR4ol[@`Oo1/jd2ol[@
`@;o`LO100Wo/;>gol77`Oo1/jgob]3Fol[@`Oo1/jgo`LO<ojJQV?nVV8@0
0_n`ZX@00ol0003o2A8:oa4L2P02oa4L2P0Gob<L2_lA70[o8a`:oa4L2_l9
2ACo6Q8DoaX92_lA70[o6RHDodHV5?m6@AkoYZ5VojJHKombIe;oJVLcof0_
5?nNNc?oWW8cokVHG?nVV6ooYXABok2=D_nVQ5800_o1/hh00onNQ6KoYXAB
olZQDP02ong@V00;ongIc?ookHkog;=LokV=<oo]aecog;=Long7G?oLZS?o
dj4YonBZ0?oCV0X00ooCXBT01?oT/dOodjY7ombcQ?oL/e`2onBnQ005ong7
G?oL/ecog;>4ombZ<ooCZTL00_oT/dL04ooCZTOog;=LonBcAooT/dOog;=L
okV=<oo]aecoi;=7onBnQ?oT/c?oi;=7onBc:OoCXBWoi:X0olZH5?oTZP3o
diP:okUW0?nV@@000_mb>1@01OmP;aCoPbl0ok1b0?o:ZVKog;=L00?oi;<c
01;oi;<Yom>H2_oCV0[odjY7om>Q:OnNLP[okLN4onBnQ?oT/dOog;=Long7
G?oT/dOoi;j4onBcAooLZS?oi;j4onBcAooTZP02om>Q:@;o^H@D027o/8dN
oiib5?mkC1CoWW8:of115?mP;aCo8bH:ob<L2_lJ2@[o2@T:oa4L2_lJ2@[o
2@T:oa4L2_n=SE;oPehcodI17_l/9QCo4A`:o`TB2_lJ2@[o2@T:og8h5?o:
V1Co^G8col640?nNGQCoUEDDoheE2_m69QCo8a`:oaXV5?lS70X00_lJ4Q@0
5_l92ACoUEDDombcG?n`/kOodn?eomcSh?o]kN[odn?eongfmOofooGo`LO<
ojJQV?o:d<7og>?Fong]j_ofm_Gom_ooooooooo1al7oUJ6>ol[@`OoLhn1O
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0004ooooo`0;ooclo?oalO7o
`/;<ofUYV?l[>HSo2c2>o`0oW?l4BZCo3eBZoaUM[_lNIKH04?lUK;`2obI]
_@?o9ffm0_lZKkh01?lYKkoo;770obaa`?l/LL03obea`0So;W;10ol_L/43
obmc`P03oc1d`olaM<;o<GC200;o<WG30olbM/@9oc=fa0?o=7O50_leN<D2
ocIiaP04ocIjaolgNlSo=g_8ocMkb0?o>7c82?liOLT3ocUnb@?o>Wk:00?o
?83;oc]obolkOl/00olmPL`2ocj1c@Wo?X;=0oloPlh3ocn4c`03od25dOm1
Q]3o@XOB00;o@XOB0om2R=<8od>9e0?o@hWE0om4RMD2odF:eP04odB:e_m5
RmOoAH_GodF;e`?oAX_G2?m6RmP3odN<f0?oB8gI00?oBHkKodV=fom9SM/0
0_m:S]d3od^?gPWoC93N0_m=T=l3odfAh0;oCi?Q00CoCiCRoe6FhomAU^?o
DIKS0omAUn@8oe:Gi@KoDYSV00?oDIWXoe:Ij?mBVNP01OmAV^X9oe6Kj`?o
DIc/0_mBWNd2oeBNkP04oe>Mk_mEW^ooEIk_oeFNk`?oEYo`2?mFX?43oeNP
lP?oEj7d00?oEj;hoeRRmomHX_L00omHXo/3oeRTo@koFJCn00CoF:Oooj71
i?nhd^ooNJk/0_n/gol01?mfMWKo`L71oo3`l?omoOeKooooo`03oiib2_nN
GQCoSED:00;oSED:00coPd40oiEE0?nNGQCoWW8:oiiN5?nNLP[o/7/:ok1k
5?n`N`[oYW80ok1k2_n`LP02ok1k2P03ok1b0?nVLP3o/78000;o/7/:01Go
LSP0ong7G?oLZS?obZ5BolZZAoo:XCgo/8dNolZH5?n`NaCo/8dNol640?oC
V0[o/7/:okV=5?oCV0[o/7/:okV=5?o:V1Cog:XcokV=5?niSBT00_niQ1@0
4on`LP3o^H@Dok1k2_nVI`3oWW8:ok1b0?n=E@[oYT`0o`T92_m69QCoJW9L
oiFZ[OmbLW_og>?FojJZXonVZZgo/;k1ol6c[Oo:d=H00_o1al`04?n`/kOo
UIRSol77`Oo:d<7o`LO1ol[@e_n`/kOoUJ6>ojJZ[OoChoGoUEDDo`T95?lA
9P[o2A`Doa4L2_lS70X3oa4L2P04oaXB5?lA70[o4A`:oaX92P;o;1`D01?o
AT4Noh=kG?nESFKoUG97oh=k<ol/9QCoJVLcog:=?OnEQ5;o^JY_ok24NonV
V6oo`J64om>nS_n`ZXCoPehcolZQ?OoL/hCoi;j400?okM2H00Kodkj>okV=
:Oo]aecog;=LonBnQ?oCZTL2om>Q:@;obYPD00OobZYVonBcAooT/bWodjY7
ombZ<ooT/dOobZYV00;og;=L00KobZYVonBcAooL/ecobZ4monBcAoo:XCd2
onBcA`0=ombcG?o:ZVKokM2Hoiik<oofacgokLMLong7Q?oL/ecokLN4ombc
G?oT/c?okKhmom>Q:@02om>H2P03om>Q:On`E@3o/5D000?oPbl000OoWUhD
onBcAooT_XCog;=LonBc:Oo:XE;obYPD00?odj4Y00Godh@0oiib2_o]aeco
g;=LonBnQ002ombcG003onBnQ?o]aecokKhm00?oi;=700Ooi;<colZH5?oC
XBWobYPDok1k2_n`SC?oWW8:00?oNd`D00CoARl:ocdL2_lA70[o6PT:0_lA
70X04ol92@[o8blco`T92_m6@AkoPg/cocAE:OlJ9QCo6Q8DoaX92_lA70[o
6PT:ocdB2_oTZP3o/7/Dok1k2_nNGQCoYT`0og8h5?mP;a@00_l/71@04_lA
9P[o6Q8Doa4V5?l92@[oNd`Dong7Q?o1XHCokOKeol[@e_oChoGokNgZongf
mOofooooY/OPojJHQ?o1al7og>?Fong]jP;om_oo00Gooooool[@`OnEXHko
b]31ong]jP1Oooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0004onk^kP08
ong]kOo[jn_ohn?SomOGeoo6a/Ko]kNgojf][OnXZ:SoojFUY@goYJFU00Wo
W9bLoiNGUon?ShooPh>3og5aLOl9>WSoYLCVokKBk_mi[^T00_nZh?l01?m^
KVko];Bdon3Ph?o/k>aKonk^kP08oiib2_nNGQCoSED:ojI<0?mb>1CoPcP0
oiEE5?n`N`X2ojIW00;oYW8D00CoWW8:ok1k2_n`N`[o/7/Y0on`LP004on`
N`[oYW8Dok1b0?n`LP3o/7/:ofY12_oL/ecodjY7olZZAooCZTOog:Xcok1k
2_niSC?o^H@DolZH5?n`NaCobYPDok1k2_oCV0X00_o1Q0001_oCV0[obYPD
olZQD_niSACobYPYokV=50;o^Hdc0_niQ1@03oniSACo/7/:okV45?n`N`[o
bYPDodHV5?niSACoYT`0oiEE0?nEEACoUJ6>ojJQV?nEXHko/;>gok2n`@03
ol77c00=oiFQS_nVXISo`K>]ol6c[OnVXISobZYVokVZKon`SE;o^HdYok2=
<oo:V1Co/5D0odHV5002o`TB2P05oa4L2_lS70[o6PT:oa4V2_l94PX00_lJ
4Q@07_lJ2@[o6RHDoc@_7_mP@BWoUG97oh=kG?n3GS?oH44YodI17_mZEAko
Pehcog9ED_nESE;oYYQ_okVHG?o1/hkoPg]LoiF=I_oT_XCog;=Long@V?oT
_XCokM2HonBnQ?oLaj?og;>4ok2=7_oL/ecoi;=7onBnQ0;og:Xc02Oodj4Y
om>H2_oCXBWobYPDom>ZAoo:XCgoi;=7ombZ<ooCZTOog:Xcom>ZAooL/eco
g:XcombcG?oT/dOodj4YonBcAooT/c?oi;<Nom>ZAooT/dOog:Xcong7G?nN
LQCom]24ombcG?o]ahCoi;=7onBnQ?o]_Sgoi;<cong7G?oCXBWodiP:onBc
7_o1Q03obYPDok1k2_n`C0000_oCQ0002?o:ZVKoi;j4onBnQ?o]ahCoi;<c
olZQ?Oo:V1Cog:Xc0_oCXBT01Oo:V1CoYVL0oooSS_o]ahCodjY700;og;=L
01;oi;j4ombcG?oL/ecog:Xcom>ZAooT/dOodjY7om>Q:Oo:V1Co/8dNokV4
5?n`SC?oWW8Doh=N5?mkC0[oNd`DodHV5?ld;ah2oa4L2P0OoaXB5?l92ACo
4A`:oaX92_lA9QCoAT4Nog9ED_m6@Ako8blNoa4L2_l94P[o6Q8Doa4L2_lJ
2@[odiP:ok1k2_nNGQCoYVL0oij4I_n3;`3oH2lDoa4L2_l/9QCo6PT:oa4L
2_lA9QCo2A`Dof0_5?oT/dOo`J64om?Sm@02omcSh00?ong]j_oChoGokOKe
ol[@e_n=V8ko`K>]omcSe_o]m_Gom_oeooKooooooooodmWFohfHS_o:d<7o
g>?P05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000Koi^KV00Koi>CT
on7QhOoMgMgofMWIomOGeooEeMGoomCDe0goe=CD00WobLW9ol?3`oni^KWo
ZJVYoi6ATOl:C:7oY/KVokWCk_mi[^/00_n[gol01?mZJV[o[Zj^omSHf?oT
i>AKonKViP07oiib2_nNGQCoUED0oiEE0?n=E@[oPcP0oiiN5002oiEE0005
ojIb0?nNLP[o/7/:ok1k5?n`N`X00_n`Na@01_n`LP3o/7/:ok1k2_n`N`[o
/780ojIb00;o/78000?oLSP0ombcG?oCZTL00_oCZTL01oo:V2Wo/8@YolZH
5?niQ1Co/8dNol640?oLZS<00_o1Q0003OniSACo`H@0okV45?o:V1CodjY7
okV=5?o:XCgo^H@DolZQ?OniQ1Codj4YokV=5?niQ1@00_o:V1@02oo1Q03o
dj4Yof0_2_oLZS?og;=LombZ<oo:V2Wo`H@0okV=5?n`SAko^H@D00;o^Hdc
00go/8dcok1k5?n`SAkodj4Yol640?o:V1Co`H@0onBc<ooL/ecobYPYom>Q
:Oo1Q03odiP:00;obYPD00KoARHDo`TL5?lJ4QCo4A`:ob<L2_lJ2@X2oa4L
2P09oaXB5?lJ2@[o;2HDodI17_mP@ACoPg]Loij4I_n3NecoAUDY00;oAT4N
00coH44YoiEbAonEQ7_oYYQ_ol6cS_nVV8Co^HdcombcQ?o]ahCog;>4ong@
V?oL/h@2ong@V00RoooSS_oL/hCoWXdYong7Q?oL/ecoi;=7ombcG?oLZS?o
dj4YombZ<oo:V1CobZ5Bom>ZAooLZS?oi;=7ombZ<ooT/dOog:XconBcAooL
/ecoi;<conBcAooCZTOoi;<YombcG?oCZTOoi;=7ombcG?oT_XCoi;=7onBc
<onEEACokLMLong7Q0;okLML00[okLN4ombcG?oT/bWokLMLonBc:Oo:V1Co
i;<Nok1E0?oCQ03oi;<c0_o:XCd05OniSC?og;>4onBnQ?oL/ecoi;=7onBc
<ooT/dOobYPDonBcAooLZS?obZ4molZH5?n`LP3okM2HonBnQ?oLZS?og;=L
ombZ<ooT_XCog:XconBnQ002onBcA`09om>ZAooLZS?obYPDok2=7_o1Q03o
/7/Dok2=7_nVLQCoPehD00;oNd`:0_m6;`X04_lJ2@[o4A`:oa4L2_l92@[o
4A`:o`T92_lJ4QCo=2lNoh=k<om6@Ako;2HDoa4L2_lJ4QCo2@T:oaXB5?lJ
2@[om/LNol6400;oWUhD00KoYVL0og]<5?mZ@@[o6Q8Dob`L5?l94PX2oaX9
2P08o`T95?lm4P[oi;=7ojJHKoo]m_Gog>?Pong]j_oLhn02ongfm@0<om?I
e_mkSHCo`K>]om?Ie_o]kN[okOKeooKfmOoooooog>?PoiFHXoo1al7og>?P
GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP002?o^k^h2ong]kOook>c/
3oo/k>`02OoOgmoof=SHolg=cOnk^k_oXJ6Qo`iE[OnS`^Co^=?_ogN^j`02
oj[Oo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00CoYW80oiiN5?nEEACoWW8D
0_n=E@X2oiiN5005ojIW0?nVLQCo/7/Yok1b0?nVLQ@01_n`N`X07onNLP[o
/7/:ok1b0?nNLP[o/7/:ofY12_oT/dOobZYVombZ<ooC_XkobZ4mokV=5?o:
XCgo^HdDolZQ?Oo1Q03obZY7ok2=7_o:V1CobYPYokV45?o:V1Co/8dNolZQ
?OniQ1CobYPDok1k2_o:V1Co/8dNolZH5?oCV0X00_n`SAh2olZH5003om>Q
:OmZ@@[okLML00;og;=L00Codkj>olZQ?OoLZS?obYPY0_niSBT01?oLZS?o
bYPDokV=:Oo:XCd2olZH:@03okV=5?o:XCgog:Xc00;odjY700WodiP:ok1k
2_oCV0[o`H@0olZH5?oLZS?oEa`0o`TB2_lA9Q@00_lS70X02_l94P[o;180
oa4L2_lS70[o6RHDodHV5?mP@BWoUHeBohf=D_m6@Ah2odHV500=oh=N<omZ
EAkoWXAVol6c[OoL/j?o/:Z4oh=N<ooT_XCog;>4ong@V?oL/ecokM2Hombc
G002ong@V004ongIc?o]d9SoYW80ong@V0;og;=L00?og:Xcom>Q:OoT/bT0
0_oCXBT01ooLZS?odjY7onBcAooCZTOog;=LonBcAoo:XCd00_oL/e`01?oC
ZTOoi;=7ombZ<ooLZS<3onBcA`05om>ZAooT/c?og:Xcong7G?nEE@000_o]
ah@06ooL/ecoi;j4ong7G?oL/ecoi;=7onBc7_oT/c?obYPDom>Q:Oo:V1Co
^FL0okV45?o:XCgog;=Lom>ZAooL/hCog;=LonBcAoo:XCgoi;<cong7G?o:
XCgodj4YombZ<ooT/c?odj4YokV45003ombcG00RonBnQ?o:XCgoi;j4onBc
AooL/ecobZ4mom>Q:OoL/ecog:Xcom>Q:Oo:V1Co^H@DokUW0?n`Q2WoWW8D
oh=N5?mb>03oNd`:ofY12_lS9P[o;180oaX92_l92@[o4A`:o`T92_lA70[o
2@T:ocdL2_mbSCgoARl:oc@_7_l94P[o2@T:oaXB50;o2@T:00SobYPDokUb
<onNGQCoWUhDok1E0?n=E@[oH2lDob`B00;o8a`:00[o2@TDoa4V5?l92ACo
8a`:ombZ<on`NfKom_oool[@e_oLhn3odn?e0_o]kNX03?o]m_GoPhAkol6c
[OoCfMKokNgZongfmOofooooooooongfmOnEXHko/;>gomcSh5ook^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN400?oooooo6Oooool02Oobl_;oj^[ZomkN
g_o;bl_o[jn_o`mE[onUa>Ko^M?_ogN^j`02ojWLo`04ogIfM_o1`L7ol?3`
oogmoE_ooooo00KoWW8Doiib2_n3GQCoWUhDoiEE5?mk@@02oiiN500;ojIW
0?nNLP[oYW8Dok1k2_nVLP3oYW9Bok1b0?n`N`[o/780ok1k2_n`LP000_n`
N`X03on`LP3o/7/:ojIb0?mk@@3oi;=7olZQ?Oo:ZTOobZYVombZ<on`SC?o
bYPYokV=5?o:V2Wo/8dNom>Q:@02olZH50;o^H@D00_o^HdDolZH5?o:ZTOo
/8dNolZH5?niSBWobYPYokV=:OoCXBWobYPDokV=5002olZH500DolZQ?OoC
ZTOoPehDong7G?oCZTOog;=LonBcAooLZS?obZ4molZH5?oCV0[obYPDolZH
:OniSBWo^H@YolZH5?oCXBWodjY7olZH5?oCV0X2om>ZA`0Fom>Q:Oo:V1Co
diP:om>H2_o1Q03obYPDombZ<oo:V1CoH2lDoaXV5?lA70[o2A8:ob`B0?l9
4P[o4BH:ob<L2_l/71CoARH:ofYW<om6@AkoARl:oc@_7P;oH44Y00SoJVLc
oiF4D_niZVoo`K>>oiF=D_n3GS?o^Hdcong7Q0;oi;j400[og;=Lombn[Oo]
d9Soi;j4ong@V?oLaj?okM2Hoiib5?o]aecodjY70_oL/e`2om>ZA`09olZQ
?OoCV0[obYPDombZ<oo:XCgoi;<combcG?oT/dOoi;<Y00?oi;=700Gog;=L
onBc<ooT/akog;=LonBc<`02ombZ<`;oi;<c00WokKhmoiEE0?oT/dOokLML
onBc<oo]ahCokKhmonBcAooL/e`00_oT/dL01ooCV0[odj4Yom>H2_n`E@3o
^H@DombZ<ooT_X@00ooL/e`2onBcA`05onBc7_oT_XCobZ4monBc:OoT/dL0
0ooCXBT2onBcA`;og;=L00KodjY7ong7G?oCZTOoi;=7ombZ<ooT/dL2ombZ
<`0Hom>Q:Oo1Q03o`H@0okV45?n`NaCoYW8Doh=N5?mb>03oLSPDofY12_lm
70[o4A`:o`TB2_lA70[o2@TDoa4L2_l92@[o6PT:ob<V2_n3Nc?oAT4Nob<V
2_lA70[o2@TD0_lA70X02Ol92ACodh@0olZH:OniQ1CoUEDDoiiN5?n3@@3o
ARHDob`V5002ob<L2P08oa4L2_lJ4QCo6PT:o`T92_oL/ecobZY7ongfmOoC
hoD2omcSh009ong]j_oChoGokOKeog^=Q?nVZZ?oi=3<omcSh?o]m_Gom_Ke
00;om_oo00?oYZZSojJQV?o]kNX0Goooool01?n_[joobl_;omkNg_oZj^X1
oo;blP00ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o2eBaojC4
i_nidnooMZgZ00;oZn3o00CoKVi^okBd]?oPh>3ok>c/Foo^k^h00onNLP[o
UEDDoheE2P02oheE2P05oh<h0?nEEACoYVL0ojI<0?nVLQ@00_n`Na@03_n`
LP3o/7/Dok1k2_n`SAko/7/:ok1b0?niI`3o/7/:ojIb0?n`N`[oYW80ok1k
2_mb>03oi;=70_o:XCd05_oCZTOog:XcolZH:Oo:V1Co/8dNolZH:OniSACo
bYPYolZH5?oCXBWoWW8:okV45?niSACobYPDolZQ?OniQ1CobYPYol640?o:
V2Wo/8dNom>Q:On`SAh2olZH5005olZH:Oo:V1Cog:XcofYE7_oL/e`00_oC
ZTL01_o:V1Codj4YombZ<oo:V1CobYPYom>H2P;obYPY02Go/7/:okV=<ooC
XBWobYPDokV45?o:XCgog:XcolZH:OoCXBWobYPDom>Q:OoCQ03obYPDom>H
2_o:XCgodj4Yok2=7_nEEACoH2lDob`B0?lJ4QCo6Q`NoaX92_lJ4QCo6Q`N
of1N<olS;akoAT4Nob`L5?m6@AkoJUDNoh=k<onVQ5;oYYQ_ok2ZQ?nVLU;o
/8dc00;obZ5B00Koi;j4onC7`OoT_XCog;=Long@V?o]ae`3ong@V005oooS
S_mkC0[oi;=7ombZ<ooL/e`00_oCZTL00ooL/ecog:Xcom>Q:@02om>Q:@06
ombZ<ooT/dOoi;j4ombcG?oCXBWog;=L0_oT/dL00ooT/akoi;<com>ZA`02
ombcG00PonBc<ooLZS?oi;<combZ<ooT/c?oSED:ombcG?oT_XCoi;<cooKI
I_oL/ecokLN4onBc<ooT/akoi;=7olZH5?oT/bWoi;<colZH5?n`E@3odiP:
olZZI_oT/dOobZYVombcG?oT/dOog;=LonBc<ooT/dOodj4YolZH5?oT/c<2
om>Q:@0?olZH5?o]ahCodjY7ombcG?oT_XCoi;=7ombcQ?oCZTOobZYVonBc
<oo:XCgoi;<com>Q:Oo:V1Co/8dN00;o/7/:00co/7/YojIb0?n3GQCoNd`:
og]10?mZ@@[o8bH:ob<L2_lA70[o2A8:o`T92_lA9Q@2oa4L2P0MoaXB5?n3
Nc?oAT4Noc@_7_lA9P[o4A`:o`T92_lA70[o2@T:om>40?o:V1Co^FL0ojI<
0?n`E@3oSED:og8h5?lm70[o8a`:oa4L2_lJ9QCo6Q8Doa4V5?l92@[o^Hdc
ok2=D_ofoooob]3Fong]j_oChoD00_o]kNX01oofooooNheVojJZ[Oo:d<7o
g>?Pong]j_ofm_D00_ofool00on`/kOoYZ6HomcSh01Oonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?Cdoo8b<So]kNg
oifMWOl;DjkoYLCVokG@k_mi[^`00_nWg?l01?mZJV[o[Zj^omSHf?oTi>AK
onKViP06oiib5?nVI`3oUD`Yoh=10?n=E@[oUED00_n=E@X00onVLQCo/7/D
oiib2P02ok1k2P09ojIb5?n`NaCo/7/Dok1b0?n`N`[oYW80ok1b0?nVLP3o
/7/:00;o/78000KoPd40ong7G?oCZTOobZ4molZQD_o:ZTL2olZQ?@0@okV4
5?o:V1Co^H@DolZH:Oo1Q03o^HdYok1k2_o1Q03odiP:olZH5?oCV0[o^H@D
olZZAoniQ1CobZ4mok2=7P;obYPD0_niSA@2olZH5008olZH:OmkC0[odjY7
onBcAooCZTOog;=Lom>ZAoo:ZVH2ombZ<`03olZH5?niSBWobYPY00;o/8dN
0_o:V1@01_oCV0[obYPDombZ<oo:V2Wog;=Lom>Q:@;obYPD00oodiP:olZH
5?o:V1CobZ4molZZAoo:V2Wo^HdDojIb5?nVI`3oNd`Dob`V5?ld;akoAT4N
of11:Om6@Ah00_mP@BT01_mZEAkoLUEBoiF4D_n`Q7_oYXABokV=<`?obYPY
0_oCZTL3ombcG003ombcQ?offFKokM2H00?okM2H00KoWW8Donfn?OoL/eco
djY7ombcG?oCZTL3om>Q:@03ombZ<oo:V1Coi;=700?og;=L00?og:Xcombc
G?oL/e`00ooL/e`02_oLZS?oi;=7ombZ<ooLZS?odj4YonBc<ooT/akokKhm
oiib2_oCZTL2ombcG006ong7G?oL/ecokLN4onBc<ooLZS?oi;=70_oCXBT0
3_oT/bWog:Xcom>H2_n`N`[og;=LombZ<ooT/dOoi;j4onBc<ooT/dOobZ4m
onBc<ooCXBWokKhm0_oCXBT01?oT/akobYPDombcG?oT/dL2ombcG00@om>Z
AooL/ecodjY7ombcG?oCZTOobZ4mombcG?oLZS?odiP:olZH:OniQ1Co`H@0
ok1k2_n`NaCoPehDog8h00;oJT4:01[o?A`:oa4L2_lJ2@[o2@T:oa4L2_l9
2@[o2A8:o`T92_lJ4QCoJUDNocAE:Ol/9QCo2@TDoc@_7_lA70[o6PT:oa4L
2_nNGQCobYPDokV45?n`NbWo/5D0oiEE5?n3;`3o;2HDob<V2P;o6PT:00?o
2@TDoa4L2_l92@X00_niSC<03?o]m_Gog>?Pom?Ie_o]kN[og>?Pong]j_o]
m_GoPiR>oiFQS_o:d<7okNgZongfm@?om_oo00?o`LO<oiFQS_o]kNX0GooV
i^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00ooo^k^hIonk^kP09on7QhOoJ
f][oclo?okfm_OnSXj?o2eBaojC4i_nhd^koMZgZ00;o[=oo00CoKVi^okBd
]?oPh>3ok>c/Foo^k^h01?n`N`[oWUhDojIW0?n=E@X2oh=10008oheE2_nV
I`3oUED0ojIb0?nNLP[o/7/Dok1k2_n`Na@2ok1k2P;o/78002?o/7/:ojIb
0?n`NaCo/7/:ok1b0?nVLP3oPd40ombcG?o:XE;og:XcolZQ?On`SAkobZ4m
olZH:OniSACo^HdcokV=5?o:V1Co`H@0okV45?n3GQCodj4Yok2=7_o:XCgo
bYPYol640?o:V1Co^HdYolZH5?niSC?o`H@0okV=<oo:V1CobYPYolZH5002
olZH:@0Coiib5?o:XE;odjY7om>ZAooL/hCoi;=7om>ZAooCXBWodjY7olZH
5?oCZTOobZY7olZH:OniSC?odiP:om>Q:Oo:V1Codj4YombZ<`02om>ZA`03
om>Q:Oo:V1CobYPD00;obYPD01Codj4YolZH:Oo:XCgobZ4molZZI_niSACo
`H@0okV=<omb>1CoAT4Noc@_:OmP@BWoAT4NofYW<on3GS?oWW8cojJ4D_o:
ZVKo^JY_ok1k:@;obZ4m0_oCZTL01ooT/dOoi;j4omc7Xoo]d9Sog;=Long@
V?oL/h@00_o]d9P03Oo]fLcokM2HokV=<oo]_Sgoi;=7onBc<ooCZTOog;=L
om>ZAooT/dOodjY7onBnQ?o:XE800_oL/e`01OoT_XCog;=LonBcAooT_XCo
g;=L00?oi;=700Gog:XconBcAooT/dOoi;<NolZH5002ombZ<`0;onfn?On`
N`[o^Hdconfn?OoL/ecoi;=7onfn?OoT_XCoi;=7onBc<ooT/dL00_oCXBT0
1OoT/akodj4Yom>H2_niI`3obYPD00;og;=L01OobZYVom>ZAooCXBWog:Xc
onBcAooT/c?oJUDNonBc:Oo:XCgoi:X0olZH5?o:ZVKoi;=7ong7Q?o:ZTOo
YXABooKII_oCZTOoi;=7om>ZAooLZS?odjY7ombZ<`02olZH5006okV45?n`
LP3o/7/Doiib2_mkC1CoNd`:0_mP@A@03_m6;`[o4A`:oa4L2_lA70[o2@T:
oa4L2_lJ4QCo4A`:o`TB2_mPGS?oH44Doc@_7_lA70[o6RHD0ol92@X01OnV
I`3obYPDokUW0?nNGQCoYW8D00;oSED:01Co?A`:oa4V2_lA70[o4A`:o`TB
2_lJ4QCo4BHDofYE7_o:XCgokOKeom?Ie_oChoGog>?Pom?SmOo]kN[om_oe
oh>H[OnVV8Co`LO1omcSeP;okOKe00Gom_ooooooooo1alcoYYR4ong]jP1O
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003ooooooaWooooo00Wol_;b
on[Zj_oNg]kobl_;ojn_[ol=E:koY/KVokK@k_mi[nh00_n[g_l01?mfMWKo
`L71oo3`l?omoOeKooooo`06oiiN5?nNLQCoUED0oheE2_n3>03oUD`Y0_nE
E@002OnNGQCoYW80oiib2_n`N`[oYW8Dok1b0?nVLQCo/7/:oiib2P02ok1b
0003ok1k2_nVLQCo/78000;o/7/:01GoPehDombcG?oCXBWobZ4molZZAooL
ZS?obYPDokV=:OniQ1CobYPDokV=5?o1Q03o^HdDojIb0?mk@@3oi;<NolZH
5?o:V2Wo`H@0okV=5?o:ZTL00_o:V2T03?niQ1Co^HdYom>H2_o:V1Co`H@0
ok2=7_niSBWobYPYoh=k<oo:XCgog:XcolZQ?@;og;=L00Koi;j4onBcAooC
ZTOoi;=7olZQ?Oo:V2T2olZH5005om>Q:OoCZTOobYPDolZH5?o:V2T00_oL
ZS<00ooL/ecodj4Yom>H2P03olZH500>onBc7_o:V2Wog:XcolZZAoniQ2Wo
bYPYolZH5?n`NbWoNd`DofYE7_n3GS?oPg/cojJ4D_n`SE83olZQDP04olZQ
?OnNLS?obYPYolZQDP?og;=L00cokLN4ombcQ?o]d9SokLMLong7Q?oT_XCo
kM2HoooSS_oL_Zgoonf>okVHG?oLZS<3ombcG009onBc7_o:V1Codj4Yom>4
0?oCXBWobYPDom>ZAooL/ecoi;=700;og;=L01koi;=7ombcG?oT/dOog;>4
ombZ<ooTZP3oi;=7ombcG?oTZP3odjY7om>Q:OoLZS?oi;<Yok24:On`SAko
i;=7ombZ<oo:XCgo/8dcooK@Q?oT/dOog;=LonBcAooT/c?og:XconBc:OoC
XBWoi;<Yok1k2_oCXBT2ombZ<`0Gong7G?oT/dOoi;=7ombZ<ooL/ecobYPY
oh=N5?oT/bWodj4YonBc<oo:V1Cog;=Long7G?oLaj?oWW8:oiEbAoo]aeco
bZ4monBcAooL/ecobZ4mombZ<ooCXBT00_o:V1@03Oo1Q03o^H@Dok1k5?nN
LP[oPehDog]10?mkC0[oJT4:ocdL2_lA70[o;180o`TB2_lJ4Q@00_l92@X0
5?lJ4QCo0000ofYW<om6EBWo8bH:oa4V5?lA70[o2@T:o`TB2_lA70[oPbl0
ok1k2_o:V2WoWUhDok1E0?nEEACoNd`Dob`V5?l/71Co8a`:0_lJ4Q@04OlA
70[o2@TDog8h5?o:XCgog>?FomcSh?oCfMKokNgZomcSe_o]kN[om_oooiFZ
[On=SFoo`K>]om?SmOo]kN[okOKe00;om_oo00?og>?Poh>=Q?o]kNX0Gooo
ool01?n_[joobl_;omkNg_oZj^X1oo;blP00ooo^k^hIonk^kP09on7QhOoJ
f][oclo?okfm_OnSXj?o2U6^ojC3iOnhd^ooNJk/00;o[=oo00CoKVi^okBd
]?oPh>3ok>c/Foo^k^h04?nNLQCoWUhDoheE2_n=E@[oWUhDoiEE0?nVC03o
WUhDoiEE0?nNGQCo/7/:ok2=7_n`NaCo/7/:ok1k5?nVLQ@2ok1k2P08ojIb
5?nVLP3o/7/:ok1k2_nVLP3o/7/:oh=10?oL/e`2olZZA`05olZQD_o:V2Wo
bZ4mokV=5?o:V1@00_n`SAh01?o:V1Co^HdDok1b0?mkC0X2olZH500;olZZ
Aoo:V2WodiP:om>ZAon`SAkobYPYokV45?o:V1Co^HdDokV45?n`SAh00_o:
V1@02Oo:V2WoSED:om>ZAooL/ecog:Xcom>Q:OoCZTOobZYVom>ZA`02olZQ
?@;og:Xc00OodiP:olZH5?o:V1CodiP:olZH5?niQ1CobZ4m00;odjY700Co
g:Xcom>Q:Oo:V1Co^HdD0_o:V1@05ooCXBWobYPDolZQ?Oo:ZVKo^H@DolZQ
?OoCZTOo^HdYokV=<on`SE;o^IQLolZQD_o1XHCobZ4molZZAooCXBWobZ5B
ombcG?nEEACobYPYombcG?oCZTOog;=L00;oi;j40_o]d9P00ooL/hCodkj>
ong@V004ong@V00Ook2=D_oL/ecoi;j4onBcAoo]aecoJUDNom>Q:Oo:V1Co
`H@0om>Q:Oo:V1CobZ5BonBc<ooT/dOog;=LonBc<ooCZTOoi;=7ombcG?oT
/dOoi;<Nom>ZAooT/c?okLMLoiib2_nNSC?okKhmonBc:OoT/c?o`H@0oheE
2P02ong7G009ok2=7_n`Q7_okLMLong7G?oT/dOokLMLonBc<ooCXBWoi;<c
00;og:Xc01;o^G8com>Q:OoT/c?oi;=7olZZI_oT/dOobZ5BonBcAooL/eco
i;<NonBc:OoCXBWoi;<Yom>Q:Oo:V1CodjY7olZZI_o]ae`2onBcA`07ombc
G?o:V1Cog;=Lom>Q:Oo:XCgoi;=7ombZ<`02olZH50;o/7/:00co/7/Doiib
5?nEE@3oNd40oh=10?mZ@@[o?A`:oa4L2_lJ2@[o2A8:oa4L2_l92@X2oa4L
2P06o`T95?mbIe;oARl:ob<_7_lA70[o6PT:0_lA70X02Ol94P[oLSPDokUb
<on`N`[oYVL0oiiN5?n3>03oNd`DocdL2P02ob<L2P0:oaX92_lJ4QCo4A`:
oaXB5?lm4P[odjY7ol77c?oChoGodmWFomcSh0;odn?e00OokOKeoiFZ[Omk
SFKo/;k1omcSe_o]kN[okOKe00;om_oo00?okOKeoh>=Q?oLhn00Goo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooVi^HIonKViP09om[Jf_oCdm?o
b<S8okNg]onMWIgo3EB^ojG4i_nfd^koNJkY00;oZ^3o00CoJVYZojj^[_oH
f=Soi>CTFooVi^H01?nVLQCoWW8DoiEE5?n=E@X2oh<h000;oheE2_nVC03o
UEDDojIW0?nVLQCo/7/YokV45?nVLP3o/7/:ok1b0?n`N`X00_n`LP002_nN
LP[o/780ok1k5?n`LP3o/7/:oheE2_oT/bWog:XcolZQ?OoLZS<2olZQ?@08
okV=:On`SAkobYPDokV=<oo:V1CobYPYokUW0?nNLQ@2olZH5007olZH:Oni
SBWo/8dNok2=7_niSC?obYPYok2=7P02olZH:@0?ol640?o:V2Wo^HdYokV=
5?n`SAkoPg/cokV=:OoCZTOodj4Yom>ZAooLZS?odj4YombZ<ooT/akobYPY
00;odjY700Wodj4YolZH:OoCV0[og:Xcom>Q:Oo:V2Wodj4Yom>ZAoo:XCd0
0oo:V2T02oo:V1Cog:Xcom>H2_oCXBWobYPYolZQ?OoLZS?o^H@DolZH5?oL
/ecog:Xc00;odjY700CobZ4molZQD_oCXBWobZ4m0_oCXBT01OoT_XCodkj>
olZZI_oCZTOobYPY00;og:Xc00Sog;=LonBnQ?o]d9Soi;j4ong7G?m6;`[o
g;>4ongIc0?okM2H00KobZY7ong7G?oL/ecog;=Long7G?n3GS<5om>Q:@05
ombcG?oT_XCog;=LombcG?oCZTL00_oT/c<04?oT/dOodjY7onBcAooT/ako
i;=7onfn?OnEEACo^H@Dom>ZAoo:V1Cog;=LolZH:OnEEACom]24onBcAooL
ZS<2ong7G00IonBcAoo]aecoi;=7ong7G?oCXBWoi;=7onBZ0?o:V1Codh@0
okV45?oCXBWobZ4monBc<ooL/ecodjY7onBc<ooCZTOodiP:om>Q:OoT/c?o
bYPDonBc7_o:V1Co^Hdcong7G004ombcG006okV=<ooT/c?obZ4mom>Q:Oo:
XCgog:Xc0_oCXBT03_o1Q03o^H@Dok2=7_nNLP[oSED:ofY12_n3GQCoJT4:
odHV2_l/4P3o4A`:ob`B0?l92@[o4A`:0_lJ2@X01?l0003oH44YodI17_l/
9Q@2oa4L2P07oaX92_lA70[o2@TDoeLL0?o:V1Co/7/:ok1k5002oheE2P03
og]<2_l/71Co;2HD00Co4A`:00Co4BHDoaX92_oT/dOo`K>]0ooLhn02ong]
jP07ongfmOn`_/7oNhf4ok2c]oo:d=KokNgZongfm@02ooKoo`03ong]j_n3
Q7_okNgZ05ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00?ook^k^6Oo^
k^h02OoQhN7of][Jolo?conm_KgoXj>So`]C[_nVa^Ko^M?^ogV^j`02oj_O
o`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00?oYW8Doiib5?nNGQ@00_n=E@X0
1?n3@@3oNd`DoiEE0?n=E@X2ojIb5003ok1k5?nNLP[o/7/Y00;o/7/:00?o
YW80ok1k2_nVI`000_n`LP004_nVI`3o/7/:ok1k2_n3@@3odkj>ombZ<oo:
V2WobZY7olZH5?o:XCgobYPDokV=<oo:V2WobYPDokV=<ooCZTOo/7/Dok1k
2P;obYPY00[odj4Yok2=7_niSBWobYPYok2=7_o:ZTOo^HdYolZH:Oo:V1Co
^HdD1?o:V1@02?n3GQCobZ4mombZ<ooCXBWobYPDom>ZAooLZS?obYPD0_o:
XCd03Oo:V2Woi;=7om>Q:Oo:XCgodiP:olZH:OoCZTOobZ4mokV=:Oo:XCgo
g:XcolZH5?oCXBT00oo:V1@03omP@BWodj4YolZH5?o:V2WobZ4mokV45?oC
XBWobYPYom>Q:OoT/c?oPehcokVHG?o:XCgog:XcolZH5003om>ZA`05onBc
AooL/ecodjY7om>ZAooLZS<00_oL/e`01OoT_XCokLN4ong@V?oT_XCokLML
00GokM2H00?obZ4molZZI_oL/e`00_oL/e`02?oT/c?obYPDombZ<ooLZS?o
dj4YombcG?oCZTOog;=L0_oT/dL02ooL/ecobZYVombZ<ooLZS?oi;<com>Z
AooT/c?odjY7onBcAoo]aecog:Xc00;odj4Y00oog:Xcom>Q:On3GQCokKhm
onBcAooLZS?okLN4ombcG?oT/dOoi;<conBcAoo]_Sgoi;<com>Q:OoT/ah0
0_oCXBT01_oCQ03odj4Yonfn?OoCZTOoi;=7om>ZA`;oi;=700Oodj4Yom>H
2_oLZS?oi:X0olZQ?OoCXBWo/8dc00;okLML00KodjY7ombcG?o]aecobZ4m
onBcAoo:XE82ombZ<`0SolZQ?OoCV0[obYPDokV=5?n`N`[oYW8Doiib2_nE
E@3oLSPDog8h0?mZ@@[oARl:oa4L2_lS70[o2A8:oaXB5?l92@[o4A`:o`T9
5?lA70[oH5hcodI17_lS;ako6PT:oa4L2_lJ2@[o2@T:oa4L2_l/71CoWUhD
okUW0?n`N`[oYT`0oiEE5?mkC0X00_lm70X00olS70[o4A`:oaXB5002oaXB
500DoaX92_offFKog;>Song]j_oCfMKog>?Pom?SmOo]kN[okOKeol77c?mk
SFKo`K>]ol[@e_o]kN[okOKeooKoooofooGoooooofYkKoo]m_EOonk^kP04
oj>SXonm_Kgoclo?om[JfP7ohN7Q003ooooooaWooooo00Wol_;bon[Zj_oN
g]kobl_;ojn_[ol?EZooXl;TokSCkomg[^/00_nZgol01?mfMWKo`L71oo3`
l?omoOeKooooo`;oYW8D01CoUEDDoheE2_n3>03oSED:oh=10?nNLP[oWUhD
ojIW0?nNLP[o/7/Dok1k2_n`NaCo/7/:ok1b0?n`N`[oYW80ok1k5?n`LP3o
WW8:ok1b00;oWW8:00SoPd40ombZ<ooL/ecog:XcolZQ?OoLZS?o/8dNokV=
50;o^HdY00WobYPDol640?o:XCgo^HdDojIb5?o:XCgog;=LolZH:OniSBT0
0_o:XCd00oniSACobZ4mokV45002olZH5003om>H2_n`SAkobYPY00;o`H@0
00coWW8DolZQD_oL/ecobZ4mom>ZAooT/dOog;>4om>ZAooLZS?obZY7ombZ
<ooCZTL2olZH:@05olZH5?oCV0[obYPYolZH:Oo:V1@00_o:XCd2olZH:@04
om>Q:OoCV0[obYPDoiEbA`;obYPD00GokKhmolZH5?niSACodj4YombZ<`03
om>Q:@04olZH5?oCXBWodiP:om>Q:@;og:Xc00[odjY7ombcG?oT_XCoi;=7
om>ZAooLZS?oi;=7ombcG?o]d9Sog<NS0_o]ah@03OoT_XCokM2Hong@V?o]
d9SokMW<ooo]S_o:ZVKodjY7onBcAoo]_Sgog;=Lom>ZAooLZS<00_oL/e`0
8?oT_XCog;>4om>ZAooT/c?og;=LonBcAooLZS?oi;<YombZ<ooT/dOoi;<N
om>Q:OoT/c?odjY7onBc<ooT/dOobYPDom>Q:OoT/bWog:XcolZH5?nEEACo
m]24onBc<ooCZTOog;=LonBcAooT/c?oi;=7onBc<ooT/dOobZYV0_oT/bT0
1oo:V1Codh@0olZQ?OoT/bWobZ5BonBcAooCZTL00_oT/dL01OoCZTOoi;<N
olZH5?oT/c?odj4Y00;obYPD00?o^Hdcong7G?oLaj<00ooL/e`2om>ZA`07
ombcG?o:V1Cog:Xcom>ZAoo:V2WobYPDol640002ok1k2P09oiib2_n3GQCo
LSP0og]<5?mb9P3o?A`:ob<L2_lA70[o6PT:00;o4A`:00Ko2@T:oa4V5?l9
2@[oAT4Noc@_7_lS9PX2oa4L2P08o`T92_l92ACo6PT:ob`L5?nVLQCo`H@0
ojIb5?n=E@X2og]<500<odHV2_l/9QCo4A`:oaX92_lA9QCo6Q8Do`TB2_l0
003oon>>omc7Xoo]m_Gob]3F0_oLhn002Oo]kN[odn?eol77c?mkSHCo`K>]
ol[@e_o]kN[okOKeooKom@02ooKoo`03oh=kG?o]kN[ooooo05kooooo00Co
[jn_ol_;booNg]koj^[Z0Oobl_800?ook^k^6Oo^k^h02OoQhN7of][Jolo?
conm_KgoXj>So`mE[onUa>Ko^M?_ogN^j`02ojWLo`04ofi^K_nd];Coh>3P
onc/k5_ok^k^00SoYW8Doiib5?nEE@3oSED:og]<2_mkC1CoUED0oheE2P;o
UED00_n`N`X01_nNLP[o/780oiib2_n`N`[o/780ok1k2P?o/78000GoYW80
ok1k2_n`NaCoPd40ombZ<`02olZQ?@0GolZH:Oo:XE;o^Hdcok24:Oo:V1Co
/8dNolZH:OniQ1CobYPDokV45?o1Q03obZ4molZH:Oo:XCgo`H@0okV=<oo:
XCgobYPYolZZAoniQ1Codj4YodIE:Oo:V2T00oo:V1@02On`SAkoYW8DolZQ
D_oT_XCog;=LonBnQ?o:XCgo=5DYonfn?@03ombZ<`07olZZAooCXBWodiP:
olZQ?Oo:V1CobYPYolZQ?@02olZH:@04ombZ<ooCXBWodj4Yom>H2P?obYPD
013og:Xcom>H2_o:V1Coi;<Yok1k5?o:V1CodjY7om>Q:OoLZS?obZ4mom>Q
:Oo:XCgodj4Yom>H2_o:V2Wodj4Y1?oL/e`01OoT/dOog:XcombZ<ooL/eco
i;j400;okM2H00?odkj>onBnQ?o]d9P00oo]d9P02_o]fLcobZYVonBcAooL
/hCog:XconBnQ?oLZS?og;=LombcQ?oL/e`2om>Q:@06olZH5?o:XE;oi;=7
onBc<ooCZTOobZ4m0_oT/c<00oo:XCgog:Xcom>Q:@02onBc<`03ombZ<ooC
XBWog:Xc00;og:Xc00Oodj4Yoh=N5?o]aecog:XcombcG?oT/dOog;=L00;o
i;<c01Ooi;<Yong7G?oT/c?oi;<com>Q:Oo:V1CodiP:om>40?niSC?obZ4m
ombcG?oT/dOog;=Long7G?oCZTOodj4YolZH5?oT/bWodj4Yom>H2_oT/ako
WUhDong7G003ombcG004om>ZAooLZS?oi;=7om>ZA`?odj4Y00_obYPDol64
0?niSACo/780ok1k2_nVLP3oWW8:og8h0?mk@@3oJT4:odH_2P03oa4L2P03
oaX92_l92ACo6Q8D00;o2@T:00?o;2HDoba<:Ol/9Q@00_lA70X05_l92@[o
4A`:oa4L2_lJ2@[o/5D0ok1k5?nNLP[oYT`0og]<5?n3>03oARHDob`L5?lS
70[o4A`:oaXB5?l94P[o6Q8Do`000?o]d9Sodkj>omcSh?oCfMH3omcSh00<
ongfmOoLhn3oLXf4ojJZXoo:d<7og>?PongfmOofoooom_oeooKooombSEco
kNgZGoo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooVi^HIonKViP09
om[Jf_oCdm?ob<S8okNg]onMWIgo2eBaojC4i_nidnooMZgZ00;oZn3o00Co
JVYZojj^[_oHf=Soi>CTFooVi^H2ojIb5003oiiN5?n=E@[oUD`Y00;oNd`:
0_nEE@002?nNGQCoYW80ojIb5?n`N`[oWW8:ok1k2_n`LP3oWW8:0_n`LP00
1onNLP[oYW80ojIb0?nVLP3oYW8DoiEE0?o:V2T00oo:XCd05OoLZS?o^HdD
ol640?n`SAko`H@0ok2=7_niSACobYPDok1k2_n`LP3obYPDolZH:Oo:XCgo
`H@0okV=<oo:ZTOobYPYolZZAon`SAkobZ4mof0_5003olZH500?om>H2_o:
V1Co/8dNokV=<ooLaj?odjY7ombcG?oCZTOoWW8Dom>ZAooLZS?obZY7onBc
7_oCXBWog:Xc00?obYPD00Godj4YolZH:Oo:V1CobYPDolZQDP03om>Q:@09
om>H2_o:V1CobYPDom>H2_oCZTOobYPDolZQ?On`N`[og:Xc00;odj4Y00?o
g:Xcom>ZAoo:V1@00_oCXBT2olZH5003om>H2_oCZTOog;=L00;og;=L00Wo
bYPDom>ZAooT/dOog;=LonBnQ?o]ahCokM2Hong7G?oT_X@01Oo]d9P02OoL
/hCog:Xcom>ZAooT/akog;=Lom>ZAooL/ecog:XcolZH5002om>Q:@05om>Z
AooT/c?obZ4molZQ?OoT/ah00_oLZS<01OoT/c?og:XconBcAooT/c?odjY7
00;oi;<Y00_og:Xcom>Q:OoLZS?oi;<conBZ0?n=E@[okLMLonBc<ooT/dOo
kKhmom>ZA`02onBc<`0:onBcAoo:XCgoi;<com>Q:OoT/akobYPDok1k2_oC
Q03obYPDom>Q:@?oi;=700_okLN4ombZ<ooCXBWodiP:onBc7_o:V1Coi:X0
olZH5?nVI`3okLMLonBcA`02ombcG0;odjY701;obZ4mom>ZAooCXBWobZ4m
om>Q:Oo:V1CodiP:okV45?n`N`[oYW80oiib2_n=E@[oLSP0og]<2_mZ@@[o
ARl:ob<L2_l/4P03oa4L2P06o`T92_lA70[o2@T:oc@_7_m69QCo8blN0olA
70X05?l94P[o2@T:oaXB5?n=E@[o/7/DojIW0?n=E@[oNd40og]<2_lm4P[o
8bH:ob<L2_lJ4QCo2A8:oaXB5?lA70[o0000ong7G?oT_XCog>?P0_oCfMH0
2?oLhn3odn?eong]j_oLhn3oSIR>ojJQV?o:d=Kog>?P0_o]m_D01?ofooGo
ooooohf=D_o]kNYOonKViP04oifMWOng]kOob<S8om?Cd`7of][J003oonk^
kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol;DjkoYLCVokG@k_mi[^`0
0_nWg?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP0@ojIb5?nNLQCoSED:oheE
2_mkC0[oPd40og8h0?n=E@[oUEDDojI<0?nVLQCo/7/Dok1k2_nNLP[o/780
oiib2P;o/78000OoYW80ok1k2_nVLP3oYW8Dok1b0?nVLP3oSED:00;obYPY
0_oLZS<01?n3GQCoJVLcok2=7_n`SAh2okV=500[ol640?niSC?o^H@Dol64
0?niSACog:XcolZH:Oo1Q03obZ4mom>ZAon`SAkog:Xcok1k2_o:V2Wo`H@0
okV=5?o:V1CobYPYokV45?o:XE;o^H@Yok2=<oo]aecog;=Lom>ZAooL/eco
i;=7olZQ?Oo:V1CodjY7olZQ?OoLZS?odjY7om>H2_oCXBWobYPYolZH5?o:
V2Wo^H@Yom>Q:Oo:V2Wog:Xcom>Q:@02olZH50?odiP:0_o:V2T01_oL/eco
^HdYolZH5?oCZTOog:Xcom>ZA`?odj4Y0_o:V1@00ooCV0[obYPDom>Q:@02
ombcG00:om>ZAooLZS?oi;=7onBcAooL/ecoi;j4omc7XooT_XCokM2Hong7
G0GokM2H00Kog;>4ombZ<ooCZTOodjY7ombcG?oLZS<3om>Q:@04olZH5?oC
V0[o^Hdcom>ZA`;og:Xc00Kodj4YonBc:OoLZS?oi;<NonBc:Oo:XCd2onBc
<`03onBcAooLZS?og:Xc00;oi;<N00[obZ4monBc7_nVLP3okLMLom>ZAooL
ZS?oi;=7onBc:OoT/dOobYPD0_oT/c<03_o]_SgodiP:ombZ<oo:V1Codh@0
ok1k2_oCXBWobZ4monBcAoo:ZVKog;=Long7G?oLZS?odj4Y0_o:V1@04ooT
/akobYPDolZH5?nVLQCom]24ong7Q?oT/dOoi;j4onBcAooL/ecodj4YonBc
<oniSBWog:XcolZH:Oo:V1Co`H@0om>H2_n`LP000_n`N`X02_nNGQCoNd`:
og]<5?mZ@@[oH2l:oa4V2_lS70[o6PT:o`T95?lJ2@X2oa4L2P05o`T92_l/
9QCoAT4Nob<_7_l92A@00_lA70X02ol94P[o4A`:o`TB2_mb>1CoYVL0oheE
2_nV@@3oNd`Doh<h0?l/9QCo;1`D00;o4A`:00Wo2A8:oaXB5?lA9QCo0000
ombcG?oT_XCog>?Fom?SmOoCfMH00_oLhn001oo]kN[og>?Poh>4NonEXHko
b]3FomcSh?ookL`00oofooD00on=SE;okNgZonk^kP1Nonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q003ooooooaWooooo00Wol_;bon[Zj_oNg]kobl_;
ojn_[ol;E;7oY<CVokSBk_mf[NX00_n/gol01?mfMWKo`L71oo3`l?omoOeK
ooooo`0Qoiib5?nNGQCoUEDDoiEE0?n3>03oPd40og]<5?n=E@[oUED0oheE
2_n`NaCoYW8Dok1k5?nVI`3o/7/:ojIb0?nNLP[o/7/:ojIb0?nEE@3o;3PY
ojIb5?nVLP3o/7/:oh=10?oCXBWobZY7olZH5?o:V2Wo/8dNoij=:OniQ1Co
bYPD00;o^HdD00oo^H@DokV=5?niQ1Co/780ok1k5?oCV0[o/8dNokV=<oo:
V1CobZY7olZH:Oo:XCgo^H@DolZH:OniQ1@00_o:V2T01_oCV0[o/8dNolZH
5?n`SC?oWXdconBnQ0;og;=L00codjY7om>Q:OoCZTOog:XcolZH5?o:XE;o
dj4YombZ<oo:V1CodjY7olZH5?oT/bT2olZH5003olZH:Oo:V1Cog:Xc00;o
dj4Y00?obYPDom>Q:OoCXBT00ooCXBT00ooCZTOo^H@Dom>Q:@02ombZ<`06
onBcAooLZS?odj4Yom>Q:OoCV0[o/8dN0oo:V2T02OoCZTOog;>4ombcG?oL
/ecoi;j4ombcG?oT/dOoi;j4ong@V003onBnQ0GokM2H00Wodkj>om>ZAooL
ZS?odjY7ombcG?oLZS?odj4Yom>ZAooCXBT00oo:V1@03?oCZTOog:XcombZ
<ooLZS?odj4YombZ<ooT/c?obZ5BonBc<ooT/akobZ4monfn?@;og:Xc01Oo
dj4YombZ<ooT/akoi;<NoheE2_oL/ecoi:X0ombZ<ooT/c?og:XconBcAooL
ZS?oi;<colZH5?oT/bWobYPDonBc:OoCQ03o`H@0okUW0?o:V2WobZ4mong7
G002onBcA`05ombcG?o:XCgog:Xcom>H2_oTZP000_o:V1@01OoCV0[oWUhD
ong7Q?oL/ecobZYV00;og;=L00Coi;=7olZQ?OoCZTOobYPD0_oCXBT02?o:
V2WodiP:okV45?n`LP3o/7/:ojIb5?nEEACoNd400_mb>0001Om69QCo;180
oa4V2_l94P[o4A`:00?o2@T:00Co2A8:oaXV5?ld;ako8bH:0_lA70X01_l9
2@[o2A8:oaX92_lJ4QCoEa`0ojIb50;oSED:00koNd`:og8h0?l/9QCo8bH:
ob<L2_lA70[o6PT:oa4L2_lJ4QCo2@T:olZZAoo:ZVKob]31om?IeP?og>?P
00KokOKeomcSh?n3SHCoSHe_ol77c?oLhmH2ooKom@04omcSe_o:d<7o=5DY
ong]jUoooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800?ook^k^6Oo^k^h0
2OoQhN7of][Jolo?conm_KgoXj>So`eD[_nVa^Ko]]3^ogV_kP02oj_No`04
ofi^K_nd];Coh>3Ponc/k5_ok^k^00CoYW8Doiib5?nNLP[oYVL00_mkC1@0
1?nEE@3oPd40og]<5?nNGQ@2ojIb5005ojIb0?nNGQCoYW80oiib2_n`LP00
0_nVI`002on`LP3oUED0ojIb0?n`N`[oYW80oh=N5?o:V2WobZY7olZQ?Oo:
ZTOobZ4m00?o^HdY017o^H@DokV=5?niQ1CobYPDokV45?n`LP3o^HdDok24
:On`SAko`H@0okV=<oniV5co/8dNom>Q:OniQ1CobZ4mokV45003olZH5005
ol640?n`SAko/8@YojJ4D_o]ae`00_oL/e`2om>ZA`03om>Q:Oo:V2WobZ4m
00;og:Xc00cobYPYolZH5?o:V1CobYPDonBcAoo:V1Co/8dNolZH5?o:XCgo
djY7ombZ<ooCXBT3olZH5007om>H2_o:V1CobYPYom>ZAon`SAkobZ4molZH
5002om>Q:@0@olZQ?OoCXBWobYPDokV45?o1Q03oWW8cokV4:OoCXBWodjY7
ombcG?oCZTOodj4YolZQ?OoL/ecoi;=7om>nSP;oi;j400?okM2HombcQ?o]
d9P00_o]d9P02_o]ahCokM2Hong@V?o:V1Coi;j4ombcG?o:ZVKodj4Yombc
G?oCZTL5om>Q:@08olZH5?oT/dOog:Xcom>Q:OoLZS?oi;<combZ<ooCZTL3
onBc<`03onBc:OoLZS?og:Xc00;og:Xc00coi;<Yok1k2_oT/dOoi;=7ombc
G?oT/c?odjY7onBcAooT/c?oi;<Yom>H2_oT/ah3olZH500:ok1k2_oCQ03o
dh@0ombZ<ooCZTOog;=LonBcAooCZTOog:Xcom>H2P?obYPD00Kodh@0om>H
2_nVI`3oi;j4ong7G?oT_X@4ombcG003om>ZAoo:V1Codj4Y00;odj4Y00Oo
^FL0okV=5?n`LP3o/7/:ojIb5?n3GQCoJT4:00;oNd`:02CoEa`0ob<V2_lS
70[o6PT:oa4L2_l92@[o2A8:oa4L2_lJ2@[o8a`:oc@_7_lS9P[o4A`:oaX9
2_lA70[o2@T:oa4L2_l92@[o?A8:ojIb5?n3@@3oNd`Dog8h0?mb>1Co?A8:
ob<L2_lA70[o6PT:o`TB2_lA70[o6PT:o`000?nNGQCokM2HombcXoo:d=H2
om?IeP;og>?F00Soi=3<ol6cS_mZIc?oUJ6>ojJQV?mkSHCo?Ehmo`TB2P;o
000000?om_ooonk^k_o^k^h0GOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Q
h@00oooVi^HIonKViP09om[Jf_oCdm?ob<S8okNg]onMWIgo2U6^ojC3iOnh
d^ooNJk/00;o[=oo00CoJVYZojj^[_oHf=Soi>CTFooVi^H01_nNLQCoYT`0
oheE2_nNGQCoNd`Dog8h50?oSED:00_oUED0ok1k2_nNLP[o/8dcoiib2_n`
LP3oWW8:ojIb0?nNLP[oYVL0oiib2P02ojIW0005ok1b0?nNLP[oWW8:olZQ
?OoCXBT01?o:XCd2okV=:@;o^H@D013o/780okV=5?o1Q03o/780ok1k5?o1
Q03o/8dNokV45?oCV0[obZ5BolZH5?o:XCgo^FL0olZH:Oo:V1Co^Hdc0oo:
V1@01oniSC?o^H@Doij=:OoL/ecoi;j4ombcG?oT/dL00_oCZTL2ombZ<`03
olZH:OoCZTOodj4Y00GobYPD00Go^HdYolZH:OoCXBWodjY7ombZ<`02om>Q
:@0;onBZ0?o:V1CobYPYolZH5?oCV0[obYPDojIb5?o:V1Co/7/:okV45?o:
V1@00_o1Q0001on`SAko/780ojI<0?n=E@[o`H@0olZQ?OoCZTL00_oCXBT0
0oo:V1Codj4YombcG002ombcG004ong@V?oT_XCokM2HooKIIP?okM2H00oo
kMW<ong@V?oL/hCodjY7olZZI_oCXBWoi;=7ombZ<ooCXBWog:Xcom>Q:Oni
SC?odh@0olZH5?oCV0X01?oLZS<02_oT/c?og;=LombZ<ooLZS?obZ4mom>Q
:OoT/bWog:XconBc<ooTZP02ombZ<`0@onBc7_nVLP3og;=LombZ<ooT/dOo
djY7onBc<ooT/dOobZ4monBc<ooCXBWoi;<com>Q:OoLZS?odh@0ol6400;o
/7/:00Godj4YonBc<ooCZTOog;=Lom>ZA`02om>Q:@?obYPD0_oCV0X01?n`
LP3og;=LombcG?oT/c<3onBcA`09om>ZAooL/ecodj4YolZH:OoCXBWodjY7
om>H2_o1Q03o/78000?oWW8:00CoLSP0ofY12_mb>1CoARl:0_lS70X00ol9
2@[o4A`:o`TB2P02o`T92P07oa4L2_lJ2@[oAT4Nob<_7_lA70[o2@T:oa4L
2P02o`T92P0IoaX92_lJ4QCoYT`0og8h0?mP;`[oARH:of0_2_lm70[o4A`:
oaX92_lA70[o6Q8Do`T92_lA70[o2@T:oeLL0?oT/bWoYZ5VomcSh?o:d<7o
g>?Fom?Ie_o1/jgoUJ6>oceN?@05o`000004oa4L2_lJ4QCo0000ooKfmEoo
i^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00?ook^k^6Oo^k^h02OoQhN7o
f][Jolo?conm_KgoXj>So`eD[_nUa>Ko]];^ogV^j@02oj[Po`04ofi^K_nd
];Coh>3Ponc/k5_ok^k^0_nNLPX01Omb>1CoPd40og8h0?mkC1CoUED000;o
SED:00KoUED0oiib2_nVLP3o/7/DoiEE0?nVLP02ojIW0003ojIb0?nVI`3o
YW8000;o/7/D00SoWW8:oiib5?nEE@3og;=LolZQ?OoCZTOobZ5BolZQ?@;o
bYPD00So^HdDok2=7_niSACo/7/:okV=5?niQ1Co`H@0okV450?o^HdD00ko
bYPYolZQ?OniSACo^IQLok2=7_o:V2Wo^HdYolZH5?o:V2WobYPDom>H2_o:
V1Co^HdYohf=A`;og;=L017og;>4olZZI_oCZTOog;=LolZQ?Oo]_SgobZ4m
ombZ<ooCXBWo^HdDolZH5?oCV0[obYPDolZH:Oo:V1CobYPYom>ZA`02ombZ
<`04olZH5?oCV0[obYPDom>H2P?obYPD00kog:XcolZH:Oo:V2WobYPYok2=
7_niQ1Co`H@0okV=5?o1Q03o/5D0oh<h0?niQ1Co^HdDolZH50;odj4Y00Co
djY7olZQ?OoLZS?oi;=70_oL/e`01_o]aecoi;j4ong@V?oT_XCokM2Homc7
X`?okM2H00Kog<NSolZH:OoT/dOodjY7onBcAooCXBT2ombZ<`05onBc:Oo:
V1Co/7/:olZH5?oCXBT00_oLZS<02_oL/ecobZ4mombZ<ooLZS?oi:X0ombZ
<ooT/akoi;<com>ZAooTZP02ombZ<`08ombcG?oT/bWog:Xcok1k2_oLZS?o
djY7onBc<oo:XCd2onBcA`03om>ZAooT/c?obYPD00;odj4Y00SobYPDolZQ
?OoCV0[o^FL0ol640?o:V1CodjY7ombZ<`;oi;=700CodiP:olZH5?o:V1Co
diP:0_oCQ0001Oo:V1Co/7/:olZQ?OoL/ecokLN400;og;=L017oi;=7ombZ
<ooLZS?og:Xcom>Q:OoCV0[obYPDokV45?niSACo^FL0oiib2_n`N`[oSED:
og]<2_mb>03oNd40oeLL0002ob<L2P04oa4L2_lJ2@[o4A`:o`T92P;o2A8:
00?o4A`:ob`V5?l/9Q@00_lA70X2o`T92P08oa4L2_lJ2@[o2@T:oheE2_n3
;`3oH2l:of0_5?mG7002ob<L2P03oaXB5?lJ2@[o4A`:00;o2@T:00So4A`:
o`T92_l/4P3o=2lNohf=KombSEco4BHDoa4V2P;o000000[o2@T:oa4L2_l9
2ACo2A8:oaXB5?lA9QCo6Q`NoaX92_l0003om_ooGoo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@00oooooolIooooo`09oo;bl_oZj^[og]kNol_;bon_
[joo2e>^ojK6i_nidnkoNJk[00;oZmoo00CoMWIfol71`Oo`l?3ooOgmFooo
ool2ojIb500;oheE2_mkC0[oPd40oh=10?nEE@3oPcP0oiEN<onEE@3oSED:
ojI<0?nVLQ@00_nEE@001_nVC03oYW80ojIW0?nVI`3o/7/:oiib2P;oYW80
00?oWW8:oiib5?o:ZTL00_o:ZTL02OoCZTOobZY7olZH:OniSBWo^HdDol64
0?niQ1Co/7/:olZH5002okV4500DokUW0?o:V1Co^H@DokV=5?niSC?obZYV
ol640?oLZS?o/8dcok2=7_o:V2WobYPDokV=:Oo:V1Co`H@0ok2=7_niSBWo
Pg/cong7G?oL/h@3ombcG0;odjY700?odj4YombZ<ooLZS<00oo:V1@02_o:
V2Wodj4YolZH5?niSBWo/8dNolZQ?OoCXBWog;=LombZ<ooTZP02olZH5006
om>Q:Oo:V1CobZ4mom>Q:OniQ2WobZ4m0_o:V2T02Oo:V1Codj4YolZH5?o1
Q03o/5D0ojIb5?nEEACoWW8:ombZ<`02om>ZA`0:olZH:OoLZS?odjY7ombZ
<ooL/ecoi;j4ombcQ?oT_XCokM2HonBnQ0KokM2H00gobYPDombcG?oCXBWo
g;=Lom>Q:OoLZS?odj4YolZH5?o:XCgobYPDom>Q:OoCZTOodj4Y00Oog:Xc
00?oi;<YolZQ?OoT/c<01OoLZS<02?oCXBWo^HdDolZH:OoCZTOoi;=7onBc
<ooL/ecoi;=70_oLZS<01_oCXBWoi;<Yom>Q:OoTZP3odiP:om>Q:@;o`H@0
01Wo^H@DolZQ?OoT/c?obZ5BombcG?o:XCgodj4YolZH5?o1Q03odj4YolZH
5?oCV0[o`H@0okV=<ooT/dOog;=Long7Q?o]aecobZYVonBcAoo:XE;odj4Y
ok2=7_oCXBWobYPD00;o`H@001oo/780ojIb0?nNLP[oSED:og]<2_mb>03o
JT4:odH_2_lS9P[o8a`:oaX92_l92@[o6PT:o`TB2_l92@[o4A`:o`T92_m6
@Ako8blNoa4L2_l94P[o4A`:o`T95?lA70[o2@T:oa4L2_nVC03oNd`:og8V
0?mG703oH2l:00;o8a`:00Wo?Blmo`T92_lJ2@[o2@T:oa4L2_l92@[o4A`:
o`TB2_l92A@00ol00002oaXB5003o`T92_lA9QCo6PT:00Co6Q8D00Co4A`:
oaXB5?l0003om_ooGoooool01?n_[joobl_;omkNg_oZj^X1oo;blP00ooo^
k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o3eJ_oj?2i?nhdnooMjk[
00;oZ]oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01?n`SAkoYW8DoiEE0?n=
E@X3oh=1000=oheE2_nEE@3oPd40oiEE0?n=E@[oYVL0oheE2_n`E@3oUED0
ojIb0?nEE@3oYVL0ok1b0002ojIb00;oWW8:00coSED:olZQD_oLZS?obZ4m
olZQD_oCZTOobYPYolZH5?niSACo^H@DokV=5?niQ1@2okV=500>ol640?n`
N`[o^HdDokV45?o:V1CobYPYom>ZAoniQ1CobYPYok24:On`SAkobYPYokV=
5?o:V1@2ol64000:ok2=7_niSBWoWXdYom>nS_oL/hCodkj>ombcG?oCZTOo
g;=Lom>ZA`;obZ4m013og:XcolZH:Oo:V1CobYPDom>H2_o:V1CobYPYom>H
2_o:V2WobZY7onBcAooCZTOobYPDom>Q:Oo:V1CodiP:0oo:V1@01?o:ZTOo
^HdYolZQ?Oo:V1@2om>Q:@09om>ZAooCV0[odj4YojIb5?mkC1CoWUhDok24
:OoCZTOog;=L00;odjY70_oLZS<00ooT/dOog;=LombcG003ong@V003ong7
G?oL_ZgokM2H00;okM2H00Wog<NSong@V?niSBWog;=Lom>Q:OoLZS?odjY7
onBc<ooLZS<00_oCXBT01_o:V1Cog:XcokUW0?oL/ecoi;<combZ<`;odj4Y
01;oi;<YombZ<ooLZS?oi;=7om>ZAooT/c?og:XconBc<ooLZS?og;=LombZ
<ooT/akodiP:ok24:OoT/c?og:XcolZQ?OoL/e`2onBcA`05onBc:OoLZS?o
dj4Yom>Q:OoCV0X00_o:V1@02OoCV0[o^FL0olZH:Oo:XCgobYPDonBc<ooL
/ecodjY7om>Q:@02olZH500;onBcAooT/akodh@0olZH5?o:V2Wog;=LombZ
<oo:XE;obZ4monfn?OoT/dL00_oLZS<2om>Q:@04olZH5?oCV0[o/7/:ol64
00;oYW8000GoLSPDog]<2_mZ@@[oLSP0odH_2P02ob<L2P;o4A`:00?o0000
o`T92_lA70X00_l92@X04?m6EBWoARl:oaXB5?lA9QCo2@T:oa4L2_l0003o
6Q8Do`T92_nVC03oH2lDoheE2_lm4P[oH2l:oaX92_l/4P02oa4L2P;o2@T:
00[o2A8:o`T92_l92@[o2A8:oa4L2_l92ACo2A8:oaXB5?l92@[o6RHD0_lJ
4Q@01?l92@[o2@TDoaXB5?lA70X2oa4V7P03oaXB5?l0003om_oo05ook^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400?ooi^KV6OoVi^H02OoJf][odm?C
olS8b?ng]kOoWIfMo`mE[onUa>Ko^M?_ogN^j`02ojWLo`04ofYZJ_n^[Zko
f=SHonCTi5_oi^KV00CoYW8Dok1k:On=E@[oSED:0_n3@@001On=E@[oPd40
oheE2_n3>03oPd4000?oSED:00SoUED0oiiN5?nVI`3oUED0ojIW0?nVLP3o
/7/:ojIb00;o/7/:00KoWW8DombZ<oo:XCgobYPYolZH5?oCZTL2okV=<`;o
/8dN00Go^HdDok1k5?o:V1Co/7/:ol640002okV4500CokV=5?n`SAkobYPY
olZQD_n`Q2WobYPDokV45?niSACo`H@0olZH5?niSACobYPDom>H2_niSACo
/8dNoh=N5?oT_XCog;=Lom>nSP03ombcG003om>ZAoo:V1CobZ5B00;obZ4m
0_o:V1@01ooCXBWobYPDolZH5?niSBWobYPDolZQD_oL/e`00_oCZTL2om>H
2P03om>Q:Oo:V1CobYPD00;obYPD00oo^HdDolZH:Oo:V2WobYPYombZ<ooC
ZTOobYPYonBc7_niQ1CobZY7ok1k:On`Q2Woi;=7ombcG?oCZTL00_oLZS<0
0oo:XCgog;=LombcG003ombcG005ong@V?oL/ecokM2HonBnQ?oLaj<00oo]
d9P01?n`SAkog;=LolZQ?Oo:XE82olZQ?@08om>Q:OoT/bWobYPDolZH5?oC
XBWobZ4monBc:OoL/e`3ombZ<`?odj4Y00Koi;<Nom>Q:OoLZS?oi;=7ombZ
<ooL/e`3ombZ<`0>olZH5?n`SAkog;=LombcG?oT/akoi;=7ombZ<ooT/dOo
bYPDonBZ0?oCXBWog:XcolZH5?oT/ah4olZH5003om>Q:OoCZTOobZ4m00;o
djY70_o:V1@03?oCV0[obZ4mom>Q:Oo:V1Co`H@0okV4:OoL/ecokLN4olZQ
?OoT/dOodjY7ombcQ0;og;=L0_oCZTL02ooLZS?obYPDol640?n`LP3o/7/:
oiib2_n3@@3oSED:og]10?mZ@@[oH2l:00;o8a`:0_l92@X00olA70[o2A8:
oaXB5002o`T92P0:odHV5?ld;bWo6RHDoaX92_lA70[o2@T:oa4L2_l92@[o
0000oiEE50;oPbl000KoH2l:odHV2_lS70[o4A`:oaX92_l94PX2oa4L2P0E
o`T92_lA70[o6PT:oaXB5?l94P[o6Q8Do`TB2_lJ4QCo4BHNo`TB2_lJ4QCo
2A`Doa4L2_lA9QCo2@T:o`T95?l92@[o6PT:oaXL7_mP@BWodn?e05ooi^KV
00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00?ook^k^6Oo^k^h02OoQhN7of][J
olo?conm_KgoXj>So`]D/OnTa>Ko^M?_ogJ]jP02oj_Po`04ofi^K_nd];Co
h>3Ponc/k5_ok^k^00CoYW8Dok2=7_mkC0[oNd`D1On3@@004?n=E@[oPbl0
og8V0?mkC0[oPd40oheE2_nEE@3oWUhDojIW0?n`LP3oYW80ok1b0?n`N`[o
YW80oiib2_nEE@02olZZA`;obZ4m01;og;=LolZH:Oo:XCgo/8dNokV=5?ni
SBWo`H@0olZH5?o1Q03o/8dNok1b0?o1Q03o/7/:okV=5?niQ1CobZY7ok1k
5?o:XCd2okV=500=olZH:On`SAko^HdDokV=<oo1Q03o^H@Dok2=7_n3Nc?o
kLMLombcQ?oC_Xkog;>4ombcG002om>ZA`?og:Xc00GobYPYolZH5?niSACo
bYPDok2=7P02olZH5008olZH:OoCZTOog;=LombcG?oLZS?odj4YolZH5?oC
V0X2olZH5007om>H2_o:V1Co^H@DolZH:OoLZS?odjY7om>Q:@04ombZ<`04
ok2=<oo:XE;odj4Yom>Q:@;odjY700?odj4YombZ<ooCZTL01?oL/e`00ooL
/hCoi;j4onBcA`02onBnQ008ong7G?o]d9SokM2Hong@V?niSACobZ4mom>Q
:Oo:V2T4om>Q:@?obYPD00Gog:Xcom>ZAooT/c?og;=Lom>Q:@02ombZ<`04
onBc:Oo:V1Cog:XcolZQDP;og:Xc00?oi;=7ombcG?oLZS<00_oLZS<02_oT
ZP3o/7/:ombcG?oLZS?odj4YombcG?oT/bWoi;=7onBc:OoCXBT2onBc:@0=
om>Q:Oo:V1CobYPDolZH5?o:V2Wodh@0olZH5?oT/bWodjY7ombcQ?oL/eco
g:XcolZH5003ol6400;odh@000?o^H@Donfn?Oo]d9P00_oL/e`2onBcA`;o
g;=L00Oodj4YonBcAooLZS?og:Xcom>H2_niI`3o/78000;oSED:00KoNd`:
of115?mb>03oARl:ob<L2_l/4P02oa4L2PGo2@T:00koAUDYoc@_7_lS9P[o
6Q`No`T92_lJ4QCo2A8:oa4L2_l92ACoPbl0oh<h0?mb9P3oH2lDoeLL00;o
8a`:0_lJ2@X02Ol92@[o2A8:o`TB2_l94P[o4A`:o`T95?l94P[o2@TDoaXB
5002o`TL5003o`TL7_l92ACo000000;o2@T:00?oARHDoh>4NonVZZd00_oC
hoD00oo]m_Gog>?Ponk^kP1Nonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
003ooooooaWooooo00Wol_;bon[Zj_oNg]kobl_;ojn_[ol;DjkoYLCVokG@
k_mi[^`00_nWg?l01?mfMWKo`L71oo3`l?omoOeKooooo`05ok24:On`NbWo
UED0oiib2_mb>0000_n=E@X05onEE@3oSED:oh<h0?mP;`[oEa`0of0_5?n3
@@3oWUhDoiib2_n`N`[oYW80oiib2_n`LP3o^HdDojIb0?n`N`[oYW8DojIb
0?o:ZVKobZY7olZH:Oo:XCgobZYV00;obYPY00Oo^HdYokV=5?o:V1Co^H@D
okV=5?o1Q03o^FL000;o/7/:00Wo^H@DokV=5?niSBWodjY7okV45?o:XCgo
^H@Dol640?o:V1@00_o:V2T02OoCV0[o/8dNok2=7_o:XCgoJT4:ombcG?o:
ZVKog;=Long7G002ombcG00=om>ZAooLZS?odjY7om>Q:Oo:V2Wo`H@0om>H
2_o:V1CobYPYolZH5?o:V2WobYPDolZZA`02om>ZA`07onBc7_o:V1CobYPD
olZH5?oCXBWodiP:olZH5002olZQ?@03olZH5?oCXBWodj4Y00;odj4Y00Oo
djY7ombZ<ooLZS?obYPDokV=<oo:V2WobYPD00;odjY70_o:XCd2ombcG00A
ombZ<oo:ZTOog;=LombcQ?oT_XCodjY7ong7Q?oT_XCog;>4ong@V?oT_XCo
kM2HojIb5?oLZS?obYPDolZH:Oo:V1@01OoCXBT01Oo:V1CobZ4mombcG?oL
/ecoi;=700?og:Xc00OobYPDom>Q:OoLZS?og:XconBc:OoLZS?oi;<c00?o
g:Xc00Coi;<NombcG?nEEACoi;=70_oLZS<02OoT/dOog:XcombcG?oCXBWo
i;<NolZH5?oT/c?obYPDonBc:@02olZH500:okV45?o:V1Codj4YolZQD_oT
/c?obZYVombcG?oLZS?odj4Yom>400;odiP:0_o:V1@02_n`N`[om]24onBc
AooCZTOokLMLonfn?OoL/ecoi;=7onfn?OoT/dL2ombcG00<ombZ<oo1Q03o
`H@0ojIW0?nNLP[oPehDoheE2_mkC0[oLSP0of115?lS9P[o?A`:0_lJ2@X0
2?lA70[o2A8:oa4L2_lA70[o2A8:of115?m6@Ako8blN0_lA70X01_l92@[o
2A8:oaX92_l94P[oPbl0oheE2P;oPbl000?oLSPDob`B0?l/71@00_lA70X0
5ol/71Co2@T:o`T92_lJ4QCo2@TDoa4V5?l971Co4A`:o`T95?l92@[o2@TD
odHV5?mbLW_oPhf4odIWG?o:d=Kodn?eooKoooo]m_Gom_ooongfmOofoooo
dmWF05oooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800?ook^k^6Oo^k^h0
2OoQhN7of][Jolo?conm_KgoXj>So`]D/OnTa>Ko^=;^ogJ]jP02ojcOo`04
ofi^K_nd];Coh>3Ponc/k5_ok^k^00Oo^HdYokV=<onNLQCoYW8DoiEE5?n=
E@[oUED000;oSED:00OoPd40of0_2_lm4P[oARH:oh<_0?nNGQCoYVL000;o
YW800_n`N`X03?o1Q03o/780ok1b0?n`N`[oYW80okVZKooLZS?obZ4molZH
:Oo:XCgog:XcokV=:@;o/8dN00So^HdDol640?niSACo/8dNokV=5?o1Q03o
/780ol6400;o^HdD00kobZ4mokV45?o:XCgo^HdDokV=<oo:V2Wo^HdYol64
0?o:V1CodiP:okV=5?o1Q03oJUDNooKIIP?og;=L00Codkj>ombcG?oL/eco
djY70_o:V2T2olZH5007ol640?o:V1CobYPDol640?niSC?obYPDolZZA`02
ombcG003olZH5?oCV0[odiP:00;obYPD0_oCV0X06?o:XCgo^HdcolZH:Oo:
V2WodjY7om>Q:OoCZTOog:XcolZH:OoCXBWo^HdYolZH5?o1Q03obYPDolZH
:OoCXBWobZ5BombZ<ooCZTOog;=Long@V?niSBWobZYVong@V0?odjY700So
g;=Lom>ZAooL/ecoi;j4ong@V?nNLQCobZ4molZH50?odj4Y00WobYPDom>Q
:OoCXBWobYPDom>Q:OoLZS?og;=LonBcAooT/c<00_oLZS<3om>Q:@05onBc
7_oCXBWoi;<NombZ<ooT/dL00_oLZS<02_oT/bWog:XconBc7_n=E@[okKhm
ombZ<ooCXBWoi;<combZ<ooT/dL3om>Q:@03onBc<oo:V1CobYPD00;odj4Y
01oobYPDom>Q:Oo:V1Coi;<conBcAooCZTOokM2HombcG?o:V1CodiP:ol64
0?oCQ03odiP:olZH5?n`N`[okM2Hong7G?oT_XCog;=LonBnQ?o]d9Sog;=L
ong7Q?oL/ecog;>4okV=<ooL/ecobYPDojIb0?nVI`3oUED000;oSED:00Go
Nd40ofY12_m6;`[o?A`:ob<L2P02oa4L2P08o`T92_lJ2@[o4A`:o`T92_l9
4P[o8blNof1N<olS9PX2oa4L2P07o`T92_lJ4QCo2A8:o`T92_mb>1CoYT`0
og8h5002of0_2P04ocdL2_lS70[o;180oaX92PCo4A`:00Go0000ocdL2_lJ
2@[o4A`:oij4IP02om?IeP0<ooKoooo]m_Gom_ooog:=[OnEXKOoY/OPom?I
e_o]m_Gom_ooongfmOofoooog>?PGoo^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@00oooVi^HIonKViP09om[Jf_oCdm?ob<S8okNg]onMWIgo3EB^ojK6
i_nfd>koNJo^00;oZmko00CoJVYZojj^[_oHf=Soi>CTFooVi^H04?n`SAko
bZ4mojIb5?nNLQCoYVL0oiib5?nVLQCoWW8Doiib2_n3@@3oH2lDof0_2_m6
9P[oNd`:oiEE0?nNGQ@2ojIW000>ok1k2_n`LP3o/7/:ojIb5?nVLP3oYW8D
oiib2_o:ZTOobZYVombZ<oo:ZTOodjY7olZH5?o:XCd2ok2=7P;o^HdD01Wo
bYPDokV=5?niQ1Co^H@Dok1k2_niI`3o^H@DolZH:Oo:XCgo^HdYolZQ?Oni
Q2Wo/8dNolZH:Oo:V1Co^HdDolZH5?oCV0[o`H@0okV=5?mZ@@[okLMLombc
G?o:ZVKom]UV00?og;=L00?oi;<YolZQ?Oo:V1@00_o:V2T03oo:V1CobYPY
olZH5?o:V1Co^HdDom>H2_o:XE;oi;=7om>ZAoo:V2Wodj4Yok2=7_oT/ako
dj4YolZH5002olZQ?@03olZH:OniSACog:Xc00?odj4Y00SobYPYom>H2_o:
V2Wo^H@DolZH5?niQ1CobYPDolZH:@GodjY700CokM2HolZZI_niSBWo^H@D
0_n`Na@00oniSACog;=LombcG002ombcG003ooKII_nNLQCodj4Y00;odj4Y
00Go^HdcombZ<oo:V1Codj4YolZQ?@02om>Q:@0=olZH5?oCZTOodjY7om>Z
AooCXBWog:XcolZQ?OoCV0[odj4YolZH5?oT/akodj4YonBc<`04ombZ<`0<
onBc:OoT/akoNd`:ooKII_oLZS?odj4YombcG?oT/c?og;=LombZ<ooT/bWo
bYPD0_oCXBT01OoT/bWobYPDom>ZAoniQ1CobZ4m00?odj4Y00_o/8dNomc7
XooC_Xkodj4Yol640?oCV0[odh@0olZH5?oCQ03o/7/:ong@V002ombcG0;o
i;=700Woi:ZHonBnQ?o]d9Sog<NSokV=<oniQ1CodjY7okV45?n=E@X00_nV
I`002?n`N`[oPehDog]<5?mb9P3oH2l:ob<V2_lS70[o6PT:1?l92@X03_lA
70[o2A8:odHV5?mPGS?o8blNoa4L2_lA9QCo2@T:oa4L2_lJ2@[o2@T:odHV
2_nV@@3oSED:0_mP;`X00om69P[o8a`:ob<L2P02oa4L2P08o`T92_lA70[o
2@T:o`T92_oL/ecokM2Ho`000?ofm_D4om?Sm@05ongfmOn3V;OoNhf4ol77
c?o:d=H00oo]m_D00oofoooog>?PonKViP1NonKViP04oifMWOng]kOob<S8
om?Cd`7of][J003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol:
DJkoY<?UokSBkomi[^`00_n/gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP04
ok2=7_niV5coWW8:ojIb50;oWW8D00goYW8DokV=5?nVLQCoSED:oh=10?n=
E@[oH2l:og8h5?nVI`3oYW80ojIb5?n`N`[o/78000Co/7/:00WoWW8:oiEE
0?o:XE;obZY7olZQ?Oo:V2WobZ5BokV=:Oo:XCd01?niSA@01?n`N`[o/8dN
okV=5?nVLP02ok1k2P08ok2=7_niSBWo/8dNok24:Oo:V2Wo^H@Yok2=7_ni
SA@2olZH:@05ol640?o:V1Co`H@0olZH5?mZEAh00_oL/e`2ombcQ0;og;=L
00?odjY7olZQ?OoLZS<00oo:V2T03Oo1Q03obYPYolZH5?oCV0[obYPDolZH
:Oo:XCgodjY7olZQD_oLZS?odj4YolZH5?oCXBT00_o:V1@03ooCXBWobYPD
okV=:Oo:V1CobYPYom>Q:Oo:V1Cog:XcolZH:OoCV0[obZ4mom>H2_o:V2Wo
bYPDokV45003olZQ?@0:olZH:OoLZS?odjY7ombcQ?niSC?oSED:oh<h0?ni
SC?obZ5Bom>ZA`;og;=L00godkj>onBnQ?o]d9SoYW80om>ZAoo:V2WobYPD
om>Q:Oo:V1Codj4YolZH5?oCXBWog:Xc00;odj4Y00Cog;=LonBcAooL/eco
bZ4m0_oCXBT03ooLZS?odj4YonBc<oo:V1Codj4YombcG?oT/bWog:Xcom>Z
AooLZS?oi;<YonBZ0?mkC1CokLMLom>Q:@02ombZ<`08olZQ?Oo]_SgobYPD
om>Q:Oo:V1Coi;<NolZH5?oCXBT2okV=<`09om>40?oCXBWodj4Yom>Q:Oo:
XCgo^G8cokV=<ooT_XCobYPD00;o`H@001_odiP:om>40?o:V1Co^H@Dong7
G?oL/ecoi;j4onBcAooCZTOog;=Long7G?oLaj?okM2HolZH:OoCZTOoWXdY
oiiN5?n=E@[oUED0oiib2_n`N`[oSED:og]<2_mP;`[oARl:ocdL2_lS9PX0
1?lA70X04_l92@[o4A`:o`T92_lS9P[oH5hcoaXV5?l94P[o2@T:oa4L2_l9
2@[o4A`:o`T92_lm4P[oSED:oh<h0?m69QCoH2lDoeLL00;o8bH:00[o6PT:
o`T92_lA70[o2@TDoaXB5?l0003o/8AkooK]j_l94P[okOKe1?oChoD01Oo]
m_GoUK?<og^=Q?nV/l7ob]3F00;okOKe00?om_ooongfmOoCfMH0Goo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooooolIooooo`09oo;bl_oZj^[o
g]kNol_;bon_[joo3EB^ojG4i_nfd^koNJkY00;oZ^3o00CoMWIfol71`Oo`
l?3ooOgmFoooool01_n`Q2Wo^IQLok1k2_nNLQCoWW8:oiib50;o/7/:00Wo
WW8:oheE2_mZ@@[o;180ob<V2_n3;`3oSED:ok1k2_nVLP000_n`N`X00onV
LP3o/7/DojIb0002ok1k2P03ojIb0?o:XE;obZ5B00;og:Xc00WobZ5BokV=
5?niSC?o^HdDokV=:OniSACo^H@Dol640?o:V1@00_n`N`X02oo1Q03o/7/:
ok24:On`SAkobYPYokV=5?niSC?o/8dNokV45?o:V1CobYPY00?obYPD00Oo
^HdDokV=<omG703om]UVom>nS_oT/dOog;>400;og;=L00godjY7ombZ<oo:
XCgobYPDolZQD_o:ZTOo`H@0om>H2_n`SAko`H@0okV=<oo:V2WobZ4m00;o
djY700?odj4YolZH5?oCV0X00oo:V1@02_oCV0[obYPDolZH5?n`SAkog:Xc
olZQ?Oo1Q03odj4YolZH:OoCXBT3olZH5006okV45?o:V1CobYPYom>Q:OoC
ZTOog:Xc0_o:V2T03_oL/ecoWW/cok2=<onEEACobYPDong7G?oL/ecokM2H
onBnQ?o]d9Sodkj>ongIc?nEE@3odj4Y0oo:V2T02_o:XCgodj4YolZQ?Oo:
V1Cog:Xcom>Q:OoLZS?oi;=7ombcG?oT/dL2ombZ<`?odj4Y00?obYPDonBc
:OoCV0X00_oLZS<07_oCXBWodjY7onBc7_oLZS?oi;<Noh=10?offFKodjY7
ombZ<ooT/dOodj4YombcG?o:V1Coi;<Nom>H2_oLZS?obYPDonBZ0?o:V1Co
dh@0om>Q:OoT/c?o^HdYol640?oCQ03o^H@DojI<0?o:V2Wo`H@0ok1k2P?o
`H@000CobYPDok1b0?o]ahCoi;=70_oL/e`2onBcA`05olZQ?OoL/ecog;=L
olZQD_mkC0X00_mP;a@02?niI`3o`H@0ok1b0?n`SAkoNd`:oheE2_mP;`[o
JT4:0_lS70X00ol/4P3o4A`:o`T92P02o`TB2P0Aoa4L2_l92@[o;2HDodIE
:OlJ9QCo8a`:oaX92_lA70[o2@T:oa4L2_l92ACo8a`:oiEE0?n3>03oPd40
oh<h0?mP;a@00_lm70X00ol92@[o4A`:o`T92P02oa4L2P07o`000?nELTOo
kOKeoa4V2_ofoooodn?eomcSh002om?Sm@05ongfmOnV/l7oJW]_ok2n`OoC
fMH01?o]m_D00ooLhn3oooooooooo`1Mooooo`04ojn_[oo;bl_og]kNon[Z
jP7ol_;b003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol;Djko
Y/KVokWCk_mi[^/00_n[gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP0:ok2=
7_n`Q2WoWW8:oiib5?nNLP[oYVL0ojIb5?nNLP[oWUhDoiEE50;o?A`:00Ko
ARHDob<L2_nNGQCoUED0okV45?n`LP02ok1k2P0>ok1b0?nVLQCoYW80ok1k
2_nEE@3og;=LolZH5?o:XE;odjY7olZQ?Oo:V2WobZ4mol640?n`SAh3okV=
5006ok2=7_o1Q03o/780ok1k2_niSACo`H@00_o:XCd01OniQ1CobYPYok2=
7_niQ1Co^HdD00?obYPD0_o1Q0002?o:V1CoJT4:ombcG?oL/hCog;=Lombc
Q?oL/ecobZYV0_oCZTL00oo:V1CobYPYolZH5002olZH5009olZH:Oo:V1Co
bYPDok2=7_o:V2WobZ4mom>ZAooLZS?obYPY00;obYPD00OodiP:olZH5?o:
V2WodiP:olZH5?n`SAko^HdY00;odj4Y00?obYPDom>ZAoo:V1@00oo:V1@0
3Oo:XCgobYPDolZH:Oo:V2WodjY7ombcG?o:XCgobYPYolZQ?Oo1Q03oH44Y
oh=N<oo:ZVH00_oL/e`03_oCZTOokM2Homc7XooT_XCokM2Hooo]S_n=E@[o
bYPYokV4:Oo:XCgobYPYom>Q:Oo:V1Cog:Xc0_oCXBT00ooT/c?oi;=7om>Z
A`02ombcG003onBc:OoLZS?odjY700?odj4Y00_og:Xcom>Q:OoLZS?oi;<c
onBc7_oCZTOoi;<combZ<ooT/akoLSP0ooK7?@02ombZ<`07om>ZAooLZS?o
g;=LombZ<oo:XCgoi;<NonBc<`03olZH500<okV45?o:V1Co^Hdcom>40?o:
V1Co/7/:olZH5?oT/akoYT`0oh<_0?n`E@3o^FL00_o1Q0002OoCV0[o/7/:
ong7Q?oCZTOoi;=7om>ZAoo:XCgog;=LolZH5002olZQ?@0:olZH:On3;`3o
Nd`Doh<_0?o:XCgo/8dNok1b0?niSACoNd`Dog]100;oJT4:00Go8a`:oc@_
:OlS70[o6PT:oa4L2P02o`T92P0Eo`TB2_l92@[o6RHDodIE:OlS;ako4BH:
o`T92_l92ACo4A`:o`T92_lJ4QCo6PT:oiiN5?nEC2WoSED:oh<_0?mP;`[o
ARH:odI17_lA70[o6PT:00;o4A`:00Go2@TDoa4L2_lm70[ob[j]odI17P04
om?Sm@06omcSh?o]m_GoY/OPof1bNon`/kOodmWF0_o]m_D00oofooookOKe
omcSh01Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003oonKViQWoi^KV
00Wof][Jom?Cdoo8b<So]kNgoifMWOl?EZooXl;TokSCkomg[^/00_nZgol0
1?mZJV[o[Zj^omSHf?oTi>AKonKViP03ok1k5?nNNc?oWW8:00?oWW8:017o
YVL0ok2=7_nNLP[oSED:ocdL2_lS70[o6RHDob`L5?n3@@3oWW8Dok2=7_n`
LP3oYW8Dok1k2_n`LP3o/7/:ok1b0002oiib2P07olZQ?Oo:XE;obYPYolZH
:Oo:XCgo^HdYolZH:@04okV=5003ol640?niSACo^HdD00;o/78000Wo/7/D
okV=:On`SAkobZY7ok24:OniSC?o/7/Dok2=7_niSC<00_n`SAh01oo:V1Co
^HdDokV=5?o:V1CoARl:ong7G?oL/h@01_oL/e`2ombZ<`05olZQ?Oo:V1Co
^HdDolZH5?n`SAh00oo:V1@00oo:V2WobZ4molZQ?@02om>Q:@05olZH5?oC
XBWobYPDolZH5?o:XCd00_o:V1@01_n`SAkobYPYom>ZAoo:V1CobZ4molZH
:@?obYPD01So^Hdcom>H2_o:V1CobZ4molZQD_oL/ecobYPYombZ<ooCXBWo
^HdDokV4:OnNLQCoWW/cong7Q?oLaj?og:XconBnQ?oL/ecokM2HombcQ?oo
hhkoPehDokV45?niI`02olZH5008okV=<oo:V1CobYPDom>Q:OoLZS?obZ5B
olZQ?OoT/c<2onBcA`07ombZ<ooCZTOog:XcombZ<ooCXBWoi;<Nom>Q:@03
ombZ<`08om>Q:Oo:ZVKog:XcombZ<ooT/akoSED:ong7G?oCXBT2ombZ<`05
om>Q:OoLZS?odj4YonBZ0?niSC<01?o:V1@00oniI`3o/7/:ol640002ol64
0007ok1k2_n`E@3oSED:oh<_0?n3>03oYT`0ok1<0002ol64000<olZH5?ni
I`3og;=LombZ<ooL/ecog:XcolZH5?oCXBWo^HdcolZH:OniQ1CoWUhD0_n`
N`X02OoLZS?o^HdYokV=5?niQ1Co/7/:og]<5?n3GQCoH2l:og8V0002ob<L
2P03oa4V2_lJ9QCo6Q8D00;o4A`:00Go2@T:o`TB2_l/9QCoH44Dob<_7P03
oa4L2P08o`T92_lA70[o2@TDoa4V5?nVC03oNd`Dog8h5?mZ@@X2og8h500=
odHV2_lS70[o4A`:oaXB5?l92@[o4A`:o`T95?l94P[oPg/cof1N<oofoooo
Y/OPomcSh002om?Sm@06omcSh?o:d=KoJW]_oiFZ[OoCfMKodn?e0_o]m_D0
0oofm_Gog>?PonKViP1NonKViP04oifMWOng]kOob<S8om?Cd`7of][J003o
onk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol?EJooYLCVokWCkomg
[^/00_nYg?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP05ok2=7_n`SC?oYW80
oheE2_nEE@000_nNLPX2ojIb000>oiEE5?mZ@@[oH2l:ocdL2_l/4P3oPcP0
oiib5?n`SAko/7/Dok1b0?n`N`[o^HdDok1k2_n`SAh2ok1k2P09olZQ?Oo:
ZTOobZ4molZZAoo:XE;obYPDokV=:On`SAko/7/:00;o^HdD0_n`N`X03?o1
Q03o^H@Dok1b0?n`LP3o^HdDokV=:OniSC?oYW8DokV=<onNLQCo^H@Yok2=
7P?obYPD0_o1Q0000oo:V1CoARl:ombcG002ombcG003ombcQ?oC_Xkog;=L
00;odjY700CobYPDolZH:Oo:V2WodiP:0_o1Q0004Oo:V2Wo/8dNok2=7_o:
V1CobYPYolZQ?OoCZTOobYPYom>Q:Oo:XCgobYPDolZH:OoCV0[obYPDom>H
2_o:V1Co/8dN00;odjY700GobYPYombZ<oo:XCgobYPDokV=:@02olZH5009
ok2=7_o:V1CobYPYonBc7_oCZTOog:Xcom>Q:Oo:XCgobYPD00;obZY700_o
bZYVonBnQ?o]d9Soi;j4ong@V?oL/hCokM2Hong7Q?o]fLcoWW8Dok1k2P03
okV450?obYPD00oodj4YonBc<oo:XCgoi;<colZZI_o:XE;og;=Lom>Q:OoC
ZTOog:XconBc<oo:V1Codj4YombZ<ooCXBT01_oLZS<03?oT/akoPehDonfn
?OoCXBWodjY7onBc:OoCXBWoi;=7om>H2_oCXBWodh@0onBc7PCobYPD013o
dh@0olZH5?oCV0[o^FL0ok1k2_n`E@3o?A8:of0_5?mG703o/4`0ok1k2_ni
I`3o^H@Dom>40?n`LP3og:Xc0_oL/e`02OoLZS?obZ4mom>Q:Oo:V1Co^H@Y
okV45?nVC03oPbl0ok1k5002om>Q:@0/okV=5?niQ1Co/7/:og]<2_n=E@[o
H2l:ofY12_lS9P[o8a`:oaX92_l92ACo6Q8DoaX92_lA70[o2@T:oa4L2_lJ
2@[oAUDYob`V5?lJ4QCo4A`:o`TB2_lA70[o6PT:o`T92_lJ4QCo/4`0ok1E
0?nEEACoPcP0og]<5?m69QCo?A`:oa4L2_lJ2@[o2@T:oa4L2_l92ACo2A8:
o`T92_m6C3go=2lNooKooooLhn02om?Sm@08omcSh?oChoGog>?PofYkQ?nE
V:?ob]3Fong]j_o]m_D2ooKoo`03omcSh?o^k^kok^k^05gok^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400?oooooo6Oooool02Oobl_;oj^[ZomkNg_o;
bl_o[jn_o`]D/OnTa>Ko^M?_ogJ]jP02oj_Po`04ogIfM_o1`L7ol?3`oogm
oE_ooooo00coYW8Dok24:OnVLP3oSED:oiiN5?nEE@3oWW8:ojIW0?nNGQCo
YVL0og8h5?mZ@@X2of0_5007oheE2_nNLP[o/8dcok2=7_niSACo/7/:ojIb
0002ok1b0004ok2=7_nVLP3o/8eBom>ZA`;obZY700_obZ5BokV=:Oo:XE;o
^HdDok2=7_n`NaCoWW8Dok1k2_o1Q03o/7/:ok1b0002ok1k2P0Kok2=7_ni
SC?og:Xcok2=7_niSBWo/8dNokV=5?o1Q03obYPDokV=5?n`SAkobYPDokV=
5?oCV0[oARHDom>ZAooL/ecodkj>ombcG?o]aecobZYVombcG?oCZTOodj4Y
ombZ<oo:XCgodiP:00;o^HdD00Co`H@0okV=5?niSACo^HdY0_o:V2T01?o:
ZTOobZ4molZH5?oCV0X3olZH5007om>H2_o:V1CobYPYolZH5?o:XE;og;=L
olZH:@02ombZ<`04olZH:Oo1Q03obZ4mokV=<`;obYPD00Co^HdYom>ZAooL
/hCodjY70_oCXBT02?o:V1CobZYVom>nS_oL/hCodkj>ombn[Oo]aecodkj>
0oo]d9P01oo]fLcoUHABoiEE0?n`N`[o^H@DokV4:Oo:V2T00_o:V1@01ooC
XBWobZ4molZQ?OoCZTOog;=LonBc<ooL/h@01?oLZS<2om>Q:@03ombZ<ooT
/bWoi;<N00;og:Xc00kodj4Yom>ZAooLZS?oi;<YoiEE5?oLZS?oi;=7ombZ
<ooL/ecodj4YombcG?oCXBWog:Xcom>Q:@?obYPD00godh@0olZH5?o:V1Co
dj4YolZH5?n`N`[oYT40ok1k2_mb9P3oH2lDof0_2_nV@@3o/7/D00;o^FL0
00ko^H@DokUW0?o:XCgodjY7onBcAooCZTOobYPYom>Q:OniSBWodj4YolZH
5?n`N`[obYPDokV450;odj4Y00?o^HdDokV45?n`Na@00_mkC0X03olS70[o
Ea`0oc@_7_lS70[o4A`:oaXB5?l92ACo2@T:o`TB2_lA70[o2@TDoa4L2_mZ
EAko=2lNoa4V2P02oa4L2P0<oaXB5?lA70[o4A`:o`T95?n`N`[oWUhDojI<
0?n3@@3oLSPDof0_2_l/9QCo8a`:0_lA70X02_l92ACo4A`:oaXB5?l94P[o
UD`Yoh>4NooChoGoY/OPol[@e_oLhn02om?Sm@09ong]j_mZNhCoUJ6>ol77
c?oChoGom_ooongfmOofoooog>?P05oooooo00Co[jn_ol_;booNg]koj^[Z
0Oobl_800?ook^k^6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`]C[_nU
a>Ko]M3^ogV^k002ojOLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^0_n`Q2T0
1OnNLQCoUEDDoiib2_n=E@[oYVL000;oWW8:0_n=E@X00on3@@3oH2lDoh<h
0002ok1k2P06ojJ4D_n`N`[o^HdDok1k5?niSACoYW8D0_n`N`X04OnVLP3o
bZY7olZZI_o:XCgobZY7olZZI_o:V2WobZY7okV=:Oo1Q03o^HdDoiib2_n`
N`[o^HdDok1b0?niQ1CoYW8000;o/7/:01?obYPYolZZAon`NaCobZ4mok2=
7_n`NaCo^HdcolZH5?o:V2WobYPDokV=<oo1Q03obYPDodH_2_oL/ecodkj>
onBcAooL/ecog;>400?odjY700KobZY7olZQ?Oo:V1CobYPDolZH:Oo:V1@2
okV=5007ol640?o:V1Co/8@YolZZAoo:XCgodj4YolZH5002om>H2P08ombZ
<oo:V1CobYPYom>H2_o:ZTOobYPYolZQ?Oo]_Sd3ombZ<`08olZH5?o:V2Wo
bYPDolZH:OoCV0[obYPYolZQ?OoCZTL2ombcG0;obZ4m00CodjY7olZZI_oC
_Xkoi;j40_o]d9P02ooL/hCokM2Hong@V?o]d9Sog<NSooo]S_n=SDOoYVL0
ok1k:OniQ2Wodj4Y00;og:Xc00?odjY7olZH5?oT/c<00_oCZTL00ooT/dOo
djY7ombcG002om>ZA`0FombZ<ooT/dOobZ4mom>Q:OoT/c?odj4YonBcAooL
ZS?oi;<combZ<ooL/ecodj4YonBc7_nNSBWog:Xcom>Q:OoCZTOoi;=7olZH
:OoLZS?odj4YonBZ00CobYPD00GodiP:olZH5?o:V1Codh@0onBc7P02okUW
000IokV45?nV@@3oPcP0oiiN5?nVC03o^H@Dok1<0?o1Q03o/7/:ol640?o:
V2Woi;=7onBnQ?o:V1Cog:Xcom>Q:Oo:XCgodj4YolZH:OniQ1Co^Hdcol64
0?oCXBWobYPYok2=7P02okV45007ofY12_mkC0[o8bH:odHV2_lm70[o8bH:
ob<L2P03oa4L2P0OoaXB5?lA70[o6Q8DoaX92_ld;ako;2HDoaXV5?lJ4QCo
4A`:o`T95?l92@[o6PT:o`T92_nVC03oWUhDoheE2_n3>03oNd`:of0_5?m6
9QCo8a`:oaX92_l92@[o4BHDo`T95?lA70[o2@T:odI17_nVXISob]3FomcS
h002om?Sm@;og>?P00Godn?eofYkKon=SFoo`LO<om?Sm@02ongfm@03ooKo
oooLhn3ok^k^05kok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400?ooi^KV
6OoVi^H02OoJf][odm?ColS8b?ng]kOoWIfMo`]D/OnTa>Ko^=;^ogJ]jP02
ojcOo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00Co/8@Yok2=D_nNLQCoWW8:
0_n=E@X06_nEE@3oYVL0oiiN5?nEE@3oSED:ojIb0?n`SE;oWW8:oiEN<onN
LS?oYW8DokV=5?o1Q03o^HdDok2=7_niSACo/7/:ok2=7_nVLP3obZY7om>Z
Aoo:XCgodjY7olZZAoo:XCgobZY70_niSBT03OniSACoSED:ok1k2_o1Q03o
/780oiib2_n`N`[o^FL0okV=5?n`SAkobYPYok2=7_niSBT00_niQ1@03_n`
SAko^Hdcok2=7_niSACodiP:ok2=7_o:V1CoH2l:olZZAooL/hCog;=LolZZ
I_oL/ecokKhm0_oCZTL02_oLZS?obZ4molZH:Oo:V1Co^HdYol640?niSACo
`H@0ok2=7_niSC<2olZQ?@05olZQD_o:ZTOodiP:olZH5?oCXBT00oo:V1@0
1?o:V2WobYPDokV=:OoLZS<3olZH:@?obYPD00go/8dNolZH5?o1Q03o/8dN
olZH:Oo:XE;og;=Lom>ZAooCXBWobYPDombZ<ooCZTOodkj>00;okM2H00Go
g;j]ong@V?o]d9SokM2Hombn[@02ong@V004ojJQI_nNGQCobYPDom>ZA`?o
g;=L00[oi;=7olZQ?OoCZTOog:Xcom>ZAooL/ecodjY7ombcG?oLZS?odj4Y
0_oCZTL01?oCXBWog:XcombZ<ooCXBT3ombZ<`06om>Q:OoT/dOog;=LonBc
<on`N`[obYPY0_oCZTL01OoL/ecodj4YonBc<oo:V1CobZ4m00;odj4Y00?o
bYPDol640?o:V1@00_o1Q0000oo:V1CobZ4molZH5002ol640003ojIW0?n`
E@3o^Hdc00;o/7/D00Go/7/:ol640?n`N`[o/7/:olZH:@02ombcG0;odjY7
0_o:V2T01ooCXBWobZY7om>H2_niQ1CobYPDom>Q:Oo:V1@00_niQ1@05Oni
SBWoJT4:odHV5?lm70[oEa`0ocdL2_lS9P[o6PT:o`T92_lJ2@[o6Q8Do`T9
5?l94P[o2@TDoa4L2_l/>2Wo=2lNoa4V2_lJ2@[o4A`:oaXB5002oa4L2P04
o`000?nNGQCo/7/Dok1b00;oSED:00goH2l:odHV2_lA70[o8a`:oa4L2_l9
2ACo6Q8Doa4L2_l971Co;1`DojJ4Q?oChoGoY/OP00;ob]3F0_oChoD02Oo]
m_GoLXf4og^=Q?o1alcog>?PooKoooo]m_Gom_ooomcSh01OonKViP04oifM
WOng]kOob<S8om?Cd`7of][J003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo
_Kfmoj>SXol=E:koY/KVokK@k_mi[nh00_n[g_l01?m^KVko];Bdon3Ph?o/
k>aKonk^kP05ok24:On`SC?oYW8DoheE2_nNLPX00_nEE@002OnNGQCoWW8:
ojIW0?nVLQCoWW8Dok2=7_n=E@[o/7/:ojIb5005okV=5009ok1k2_n`LP3o
/780ojIb0?niV5cobZY7olZQ?Oo:ZTOobZ5B00?obZ4m0_niSC<00omZ@@[o
`H@0ojIb0002ok1b0009ojIb0?n`N`[o/780okV=:OniSC?o/7/:okV=<on`
SAko^HdD00;o^HdY00OobYPDokV=5?niSACo^HdDol640?mP@ACobZ4m00?o
g;=L00_obZYVombcG?oL/ecobZ4molZH:Oo:ZTOog:XcolZH5?n`SAkobYPD
ol640002okV=5003olZQD_o:XCgobYPY00;odjY70oo:V1@03_oCV0[odj4Y
olZH5?oCV0[obYPDok1k2_o:V2WobZ4mom>H2_o:V1CobYPYombZ<oo:V1Co
diP:0_o:V1@01Oo1Q03o^HdDombcG?oL/ecodjY700;obZ4m00Oog:XcolZH
:OoC_XkokM2Hom>nS_o]d9Soi;j400GokM2H00ooWXdcolZQ?Oo:ZTOog;=L
ombcQ?o]d9Soi;j4onBcAooCZTOog:Xcom>Q:OoLZS?oi;=7om>ZAoniSBT0
0_oLZS<05?oT/c?og;=Lom>Q:OoCXBWoi;<Nom>Q:OoT/akog:XconBc7_oC
ZTOoi;=7om>Q:OoL/eco^HdDolZH:OoT/c?odjY7ombcG?o:V1Cog;=L0_oC
XBT01oo:V1Cog:XcolZH5?o:V1Codh@0olZH5?oCQ0000_o:V1@03OoCV0[o
bYPDok1k2_n3>03oSED:om>ZAon`NaCo/7/:okUW0?o:V1Co^FL0ol640?n`
Q2T00_oL/e`01?oCZTOog:Xcom>Q:OoCZTL4om>Q:@03olZH5?o1Q03obYPD
00;o^H@D00Ko^HdDofY12_mP;`[o4A`:ob<V2_lm70X2ob<L2P05oa4L2_l9
2@[o6Q8Doa4L2_l92@X00_lA70X00olS9P[o=2lNoaX92P02o`TB2P0HoaX9
2_lJ4QCo2@T:o`T95?n`C03o^FL0okV45?mb>1CoNd`DofY12_m69P[o;1`D
oaX92_lA70[o6Q8Do`T95?lJ4QCo2@TDodHV5?nNQ6KoY/OPomcSh?oChoGo
b]3F0_oLhn001Oo]m_GoPiR>og9bNon`_/7odmWF00;okOKe00?om_Keol[@
e_o^k^h0G_o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooooolIoooo
o`09oo;bl_oZj^[og]kNol_;bon_[joo2U6^ojC3iOnhd^ooNJk/00;o[=oo
00CoMWIfol71`Oo`l?3ooOgmFoooool01?nNNc?o/8dcoiib2_nNLPX2oh=N
5005oheE2_nVI`3oUED0oiib2_nNLS<00_nNLQ@01onEE@3oYW80ok1k2_n`
NaCo^HdcokV=:OniSA@00_n`LP004OniSACo/7/:ojIW0?niSC?og:XcolZQ
?Oo:ZTOobZ5BolZH:Oo:XE;obYPYok2=7_niSBWoH2l:oiib2_n`LP3oYW80
00;oWW8:017oYW80ok1k2_niSBWobYPYok2=7_niSC?o/8dNok1k2_o:V2Wo
bYPDokV=<oniSACobYPDokV=5?oCV0[oARl:olZQDP02ombcG00Com>ZAooL
/ecodjY7olZQ?Oo:XE;og:XcolZH5?o:V2WobYPDol640?oCV0[o/7/DokV=
5?o1Q03odjY7okVHG?o:V2WobZ4molZZA`02olZH500Dom>Q:OoCV0[obYPD
olZH5?o:V2Wo`H@0ok1k2_o:XCgobYPYolZH5?o:V2WobZ4molZH5?niSACo
bYPDokV=5?o:V1CoYW80okV45?o:XCd2om>ZA`;obZ4m013obYPYolZZI_o:
XE;og<NSombcG?oLaj?og;>4omc7XooL_ZgokM2Homc7XoookLcoYZ5VokVZ
KooCZTOoi;j40oo]d9P00ooL/ecoi;=7ombcG003om>ZA`07onBcAooCXBWo
g;=Lom>ZAoo:XCgodjY7olZH5002ombZ<`?odj4Y00Sog:Xcom>ZAooT/dOo
dj4YombZ<oo:V1Co/8@Yom>ZA`;oi;=700Kodj4YombcG?oCXBWog:XcokV=
<ooCV0X2olZH50;o`H@000CobYPDom>40?o:V1Codj4Y0_o:V1@03OnV@@3o
YT`0ol640?n`LP3o^H@Dol640?oCQ03o/7/:ol640?niLS?okLMLom>ZAooL
ZS<00_oCZTL00ooL/ecodj4Yom>ZA`02om>Q:@0holZH5?niSC?obYPDol64
0?n`N`[o/8dNoh=N5?mZ@@[o4A`:ob<V2_lm70[o8bH:ob<L2_lJ2@[o4A`:
oaX92_l92ACo2@T:oa4L2_lJ2@[o8bH:oc@_7_lA9P[o6Q8Doa4L2_l94P[o
2@T:oa4L2_l92@[oSED:okV45?n`NaCoUED0oh<h0?mkC0[oARH:ob<V2_lA
70[o2A8:oaXB5?lA9QCo4A`:o`TB2_m69QCo/8eBomcSh?oChoGob]3Fom?S
mOo:d=Kodn?eongfmOn3V:goJW]_ok2n`Oo:d=H3ongfm@03omcSh?oooooo
oooo05gooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800?ook^k^6Oo^k^h0
2OoQhN7of][Jolo?conm_KgoXj>So`eD[_nUa>Ko]];^ogV^j@02oj[Po`04
ofi^K_nd];Coh>3Ponc/k5_ok^k^0_n`Q2T01onNLQCoUEDDoiib5?n=E@[o
WW8Doiib2_n=E@X00_nVLQ@01On`SAko/7/YojIW0?n`N`[o/7/D00;o^HdD
0_n`LP001on`N`[oUHd0ok1b0?n`N`[oYW80oij=<ooCZTL00_o:ZTL01oo:
XCgo/8dNolZQ?On`SAko^HdcokV=:OmP;`X00_n`N`X3ojIb000<ok1k2_n`
SAko^HdYolZH:On`SAkobYPYok2=<oniI`3o/8dNokV=:Oo:V1Co^H@D0oo1
Q0001om69QCobZ5BombcG?oC_Xkog;=Lom>nS_oLZS<00_oCZTL01?o:XCgo
bZ5BolZQ?Oo:V1@3okV=5004olZH5?o:ZTOo^HdYolZH50;obZ4m00?og:Xc
om>H2_o:XCd01?o:V1@01_niSC?obYPDokV45?o:XCgog:XcolZH50;obYPY
01?o^HdcokUW0?n`SAko`H@0ok1b0?nVI`3oUEDDokV=5?oL/ecobZ5BolZH
5?o:V2Wodj4YolZH:OoL/ecokM2Hom>nS_o]d9Sog;=L00?okM2H00KokMW<
ong@V?niZVoog:XcombcQ?oLaj<2onBnQ00=ombcQ?oL/ecodjY7ombcG?oC
XBWog:XcombcG?oCZTOog:Xcom>ZAooLZS?obZ5BonBcA`03om>Q:@;og:Xc
00Soi;<NombZ<ooLZS?obZYVombZ<ooL/ecobYPYok24:@;oi;=700KodjY7
om>Q:OoL/ecog:Xcom>ZAoo:V2T3olZH500:om>H2_n`N`[obYPDolZH5?n`
N`[obYPDom>H2_o:V1Co/7/:okUW00;o/7/:00codh@0ol640?o1Q03o/7/:
ol640?nNLP[okLMLombZ<ooCZTOog;=Lom>ZAooL/e`2om>ZA`;odj4Y00Co
bYPDom>H2_o:V1Co/8dN0_niQ1@01?nNLQCoH2l:ob`V5?lJ2@X2ob<V2P05
ob<L2_lA70[o2@TDo`TL5?lA9Q@00ol92@X04OlS70[o;3PYoaXV5?l94P[o
2A`Do`TB2_lA70[o2@T:o`T95?mkC1Co/5D0oiiN5?n=E@[oPcP0og]<2_m6
9P[o8a`:00;o4A`:0_lJ4Q@01olS;ako0000ocdL2_o:ZVKob]3FojK7h?o:
d=H00ooLhn001Oo]m_GoPiR]ofYkKon`/kOob]3100?okOKe00?og>?Ponk^
k_o^k^h0GOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooVi^HIonKV
iP09om[Jf_oCdm?ob<S8okNg]onMWIgo2e>^ojK6i_nidnkoNJk[00;oZmoo
00CoJVYZojj^[_oHf=Soi>CTFooVi^H03_nNNc?o/8dcoiib<onVLP3oUEDD
oij=:OnNLQCoWUhDoheE2_nNLQCoWW/cok24:OnVLQCoWW8:0_n`Na@01?n`
N`[o^HdDok1k5?n`N`X3ok1b00;o/7/:00Oo/8dNokVHG?o:XCgobZ4mombc
G?n`SAkobZY700;o^HdY00Co/8dNoheE2_mk@@3oYW800_n`LP001on`N`[o
YW80ok1k5?niSBWo^HdcokV45?niSBT00on`SAh02?niSC?o^HdYokV=5?ni
SACo`H@0okV=5?mP;aCobZ5B1?oL/e`04Oo:ZVKodjY7olZZAoo:V2WobZ4m
olZH:Oo:V1Co^HdDol640?n`LP3obYPDok2=7_nNLQCo/7/DolZQ?OoCZTOo
bZY700;obYPD00godiP:olZH5?o:V1CobYPDom>H2_o:V1Co^H@DolZH:Oo:
V1Co^H@DolZH5?n`SAkodiP:00;o^H@D01[o^FL0okV45?n3@@3oSED:olZH
:OoCZTOog;=Lom>Q:Oo:V1CobYPYolZQ?Oo:ZVKokM2HombcQ?o]d9Soi;j4
ong@V?oL_ZgokM2Homc7Xoo]d9SobZYVokVHG?o]d9Sog<NSombcQ0;oi;j4
00Kog;=Lom>ZAoo:XE;og:XcolZQ?OoT/dL3om>ZA`06ombZ<ooCZTOog;=L
olZQ?OoCXBWog:Xc0ooCXBT2ombZ<`06ombcG?oLZS?odjY7om>H2_nNNc?o
g:Xc0_oT/dL02OoCXBWog;=Lom>ZAooCZTOo^H@DokV=<oo:V1Co/7/:om>H
2P02ol640008olZH5?n`N`[obYPYom>40?o:V1Co`H@0okUb<oniI`03ok1k
2P07okV45?n`N`[o^FL0ok1k2_oT_XCog;=LolZZA`02om>ZA`04onBcAooC
ZTOobZY7ombZ<`;odj4Y017obYPYolZH5?o:V1Co^H@Dok1k5?nNLQCoNd`D
of0_5?m6;`[o?A`:ob`V5?lS70[o;180oaX92_l92ACo4A`:oaXB5002oa4L
2P03oaXB5?ld;ako4BHD00;o6Q8D01Co2@TDoa4L2_l94P[o2@TDoh<_0?ni
Q1Co/7/YoiiN5?n=E@[oNd`:of0_2_m69QCo;1`DoaX92_lA70[o2@TDoaXV
5?l971Co6PT:okVHG0;ob]3F00[og>?Pol[@e_oChoGog>?PongfmOnEXKOo
JW]_ojJZ[Oo:d=KokNgZ0_o]m_D00oo]kN[oi^KVonKViP1MonKViP04oifM
WOng]kOob<S8om?Cd`7of][J003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo
_Kfmoj>SXol?EZooXl;TokSCkomg[^/00_nZgol01?m^KVko];Bdon3Ph?o/
k>aKonk^kP04ok1k:On`SC?oWW8Doij=:@;oSED:00_oWW8:oiiN5?nNLP[o
WW8DojIb5?n`SAko/7/Doiib5?n`NaCo/8dNok1k2P02okV=50?o/7800_nV
LP000onNLP[oWXdcombZ<`02olZQ?@0ColZQD_o:V1Co^Hdcok1b0?o:V2Wo
UEDDoh=N5?mZ@@[oYVL0oiib2_n`N`[oWW8Dol640?n`NaCo/8dNokV=<on`
SAko^HdcokV45002ok2=7P;obYPD0_niSA@01_niQ1CobYPDoeLL0?o:ZTOo
g;=LolZZIP;og;=L00CobZYVolZZAoo:XE;og:Xc0_o:XCd03_o:V1Co^HdD
ok1k2_n`N`[o`H@0ojIb5?m6;`[oNd`:olZH:Oo:ZVKodjY7olZH:Oo:V1Co
bZ4m1?o:V1@08OniSBWo^H@DokV=<oo:V2WobYPDok2=7_o:V2Wo`H@0okV4
5?niSACo/7/:oiib2_nEC2Wo/8dcok2=7_o:XE;obZY7olZQ?Oo:V2WobYPD
om>ZAoo:ZVKokM2HombcQ?oC_Xkoi;j4om>nS_o]d9SokMW<ong@V?o]fLco
dkj>olZQDP02ong@V0;oi;j400Sog;=Lom>ZAooLZS?oi;<colZQ?OoCZTOo
bZ5BombZ<`;odjY700Oog:XcolZQ?Oo:V2WobYPYom>Q:OoLZS?odjY700;o
dj4Y00Ooi;<NombZ<ooL/ecog:Xcom>ZAooT/akoWW8D00Gog;=L0_oCZTL3
olZH5003ol640?oCQ03o^FL000?o`H@00oo:V1@00on`N`[obYPDokV45002
ok1k2P?o`H@002Ko/7/:oiib2_oT_XCog;=LonBcAooL/ecodjY7ombcG?oL
ZS?odkj>olZH:Oo:XCgodj4YolZH5?oCXBWobYPDokV4:On`NaCo/8dNoh=N
5?mb>03oARl:ocdL2_l/9QCo8a`:oaXL7_lA70[o6Q8Do`T92_lJ4QCo2@T:
o`TB2_lJ4QCo=2lNoaXV5?lA9QCo2@TDoaXB50;o4A`:01Co2@TDoeLL0?o1
Q03o/7/DojIW0?mb>1CoPd40odH_2_lS9P[o6RHDoaX92_l94P[o6Q8Doa4V
5?lJ4QCo0000ombcG?n`_/7o`LO<ojK7h0?ob]3F00KokOKeok2c]om?Ieco
YZZSol77c?o]kNX2ongfm@03omcSh?o^k^kok^k^05gok^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN400?oooooo6Oooool02Oobl_;oj^[ZomkNg_o;bl_o
[jn_o`mE[onUa>Ko^M?_ogN^j`02ojWLo`04ogIfM_o1`L7ol?3`oogmoE_o
oooo00GoWW/coij=:OnNLP[oWW8:oiEE0002oheE2P0GojIb0?n=E@[o/8dN
ok2=7_nVLQCoWW/cojIb0?niSACo/7/:ojIb5?niSACo/7/Dok1k2_nVLP3o
YW8Dol640?n`N`[oWW8:oij=<ooCXBWobZY7olZQ?OniSC<00_niSBT2okV=
500Hoiib2_mP;aCoARHDoheE2_nNLP[o/7/Dok1b0?n`N`[o/7/Dok2=7_o:
V2Wo/8@YokV=<on`Q2Wo/7/:okV=<oo1Q03o^HdYok2=7_o1Q03o^HdDolZH
5?mP@ACobZY70_oL/e`02ooCZTOobZYVom>ZAooL/ecog:XcokV=<oo:V1Co
bYPYokV=5?o:V1Co`H@000;o/7/:00CoNd`DoaXB5?n3GQCo/8dN0_oCZTL0
2Oo:V1CobZ4mom>H2_oCV0[obYPDom>H2_o1Q03obYPDok1k2P02olZH500=
okV=5?o:V1Co^HdDolZH5?niQ1Co^HdDokV45?nVLQCoWW8DofY12_nVLQCo
g;=LolZQ?@03olZH5006ombcG?niV5coi;j4ombcQ?o]d9Sodkj>0_o]d9P0
3_oLaj?okM2Hong@V?niZVoobZYVonBnQ?o]d9Sodkj>ombcG?oC_Xkoi;j4
om>ZAoo:XE;obZ4m0_oCZTL01?o:XE;odjY7onBcAoo:XCd2om>Q:@04olZH
:OoCXBWodjY7ombZ<`;odj4Y00Wog:XcolZH5?oCZTOodj4YombZ<ooCXBWo
PehDong7G?oT/dL00_oL/e`01_oL/hCog;=LombcG?oCZTOodj4YokV450Co
/7/:00Ko^FL0ol640?o1Q03o`H@0om>H2_niQ1@2ok1k2P03ol640?n`N`[o
`H@000;o/7/:00Go^FL0ojIb0?o]aecog;=Lom>ZA`05ombcG003olZH:OoC
ZTOodj4Y00;obYPD00oo/8dNol640?n`N`[oWW8Doiib2_mkC1CoH2l:odH_
2_lS9P[o8a`:oaX92_l94P[o2@TDoa4L2_l92@X00_lA70X01ol92@[oAT4N
oaXV5?l94P[o6Q8Do`TB2_lA70X00_l92@X04Olm4P[o/7/:oiiN5?nVI`3o
Nd`:og8h5?m6;`[o?A`:oaX92_lA70[o4BHDoa4L2_lJ2@[o6Q8Do`000?o]
ahCo/;>g00?ob]3F0_oLhn001Oo]kN[o`LO<ofYkKonEXHko/;k100?okOKe
00?okNgZooooooooool0GOooool01?n_[joobl_;omkNg_oZj^X1oo;blP00
ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o2eBaojC4i_nidnoo
MZgZ00;oZn3o00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01OnNLQCoJUDNoheE
2_nEEACoNd`:00;oSED:0_nEE@005OnVLQCoWW8Dok2=7_nVLQCoYVL0ok2=
7_nVLQCo/7/:ok2=7_niSACo/7/:oiib2_n`N`[o/780ojIb0?nVI`3oWXdc
olZQD_o:XCgobZ5BolZH5002okV=:@03ok1b0?o1Q03oUED000;oARHD00Ko
^H@Dok1k2_nVLQCo/780ok1k2_n`Na@2okV=<`04ok2=7_niSBWo^HdYok1k
50;o/8dN00?odiP:okV=:OniQ1@00_o1Q0001OmP;aCoYZ5VombcG?o:ZVKo
g;>400?odjY7017og:XcolZZAoo:V2WobYPDokV4:Oo1Q03o/7/:okV=5?o1
Q03oPcP0og8h0?nEEACo^HdcolZQD_oCZTOobYPYom>H2P02olZH:@06olZH
5?niSACobYPDom>H2_n`NaCobYPD0_n`SAh2olZH:@09okV=5?o:V1CobYPD
okV=<on`NaCoPd40og]<5?niQ2Wog:Xc00?obYPY00KobYPDom>ZAoo:XE;o
g;j]ong@V?oL/h@3ong@V003onC7`OoLaj?okM2H00;odkj>00cog;>4onBn
Q?oL/ecodjY7olZZI_oL/ecobZ5BolZH5?oCZTOobZ4molZQD_oT/c<3om>Z
A`03ombZ<ooCZTOodjY700;odj4Y00_obZ4mom>Q:OoLZS?og:Xcom>Q:OoL
/ecog:XconBcAooLZS?oNd`Dong7Q002onBnQ007ombcG?o]d9Soi;j4onBn
Q?oT/dOog:XcojIb0002oheE2P08oiiN5?nVC03o/7/:ol640?n`N`[o`H@0
okV45?o1Q002ok1k2P09ol640?niI`3o`H@0okUW0?n`N`[o^FL0ok1k2_oL
/hCobZ4m00?og;=L00KokM2Hom>ZAooL/ecodjY7om>Q:Oo:V2T3olZH500>
okV45?n`N`[oWW8Doiib2_mP@ACoEa`0odH_2_ld;ako8a`:oa4L2_lJ2@[o
6Q8Do`T92_l94PX3o`T92P03odIE:OlJ9QCo6PT:00;o4A`:0_l92@X02?lA
70[o6Q8DoiiN5?n`NaCo/7/:oh<_0?n3@@3oH2lD0_lS70X02?lJ2@[o4A`:
o`TB2_l92ACo4A`:o`000?ofd8Co/;k10_o1al`03?o:d=Kodn?eol[@e_oC
hoGoY/OPog:=Q?nVV8Co/;k1ooKfmOo]kN[okOKeomcSh5ook^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400?ooi^KV6OoVi^H02OoJf][odm?ColS8b?ng
]kOoWIfMo`]C[_nUa>Ko]M3^ogV^k002ojOLo`04ofYZJ_n^[Zkof=SHonCT
i5_oi^KV00SoWW8DoiEE5?n3GQCoSED:og]<2_mZ@@[oPd40oiEE50;oWW8:
00CoYW8Dok2=<onVLQCoWXdY0_niSA@01?nVLQCo^HdDok1k5?n`N`X2oiib
2P05ojIb0?n`N`[oYVL0oij=:OoCXBT00oo:XCd03OniSBWo^HdDojIb5?n`
N`[oYT`0ob`V5?n3GS?o^H@Dok1k5?n`N`[o/780ok1k2_n`Na@00oniSBT0
0on`SAko/7/Dok2=7P02okV=:@Co^HdD00Go`H@0ofY12_o:XCgog;=Lom>n
SP03ombcG00BolZZAooL/ecobYPDokV=<oo:XCgo^HdDolZH5?n`N`[o^Hdc
okV45?oCV0[oYW80okV=<oo:ZTOodjY7olZZI_o:V1CobYPY1Oo:V1@00ooC
V0[oYW80ombZ<`02olZH50?obYPY00Go`H@0olZZAooCXBWo^HdYoheE2P02
olZZIP07okV=<oo:V2WobYPDokV=:OoCV0[og;>4om>ZA`02ong@V00:omc7
Xoo]d9Sog<NSong@V?oTal7oi;j4ong@V?oLaj?o^JY_onBnQ0;og;>40oo:
ZVH01OoCZTOo/8dNom>Q:OoLZS?obZ4m00;odjY70_oCXBT01?oCZTOog:Xc
om>ZAoo:V1@3om>Q:@;og:Xc00Oodj4YombcG?oCZTOoi;=7onBc7_mkC0[o
m]2400;oi;j40_o]d9P01?oC_Xkog;j]ong7G?n`N`X2oheE2P07og]<2_n3
>03oUEDDokUW0?n`N`[o`H@0olZH5002okV45004olZH5?n`N`[o^H@Dol64
00;o^FL000So`H@0ok1k2_n`LP3okLMLombcG?oL/hCog;=LombcQ0?og;=L
00CobZ4mom>ZAoo:V2WobYPY0_niSA@05On`SAko/7/:ojIb5?n=E@[oH2lD
of0_2_mG703o8bH:ob<L2_lJ2@[o4A`:oaXB5?lA70[o2@T:oaXB5?lA70[o
4BHDodHV5?l/9QCo4A`:o`T92P03oa4L2P05o`T92_lA70[o/5D0ojIb5?ni
Q1@00_mkC0X03?mP;aCo8a`:ob<L2_lA70[o6PT:oa4L2_lJ4QCo4BHDo`00
0?o:ZVKo`K>]ojK7h0?ob]3F0ooLhn001on3V8koPhf4ok2c]ooLhn3okNgZ
ooKooooLhn00GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00ooo^k^hI
onk^kP09on7QhOoJf][oclo?okfm_OnSXj?o2eBaojC4i_nhd^koMZgZ00;o
[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h05?nNNc?oWXdcoiEE0?lm70[o
ARl:og8V0?mkC0[oSED:oiEE5?n`N`[oYW8Dok2=7_niSACoWW8:ok1k2_nV
LQCo/7/DokV=5?nVLQCo/7/:0onNLPX01onVLP3oYVL0oij=:OoCZTOo^Hdc
ombZ<oo:V2T00_n`SAh04on`N`[oWW8:oheE2_mG703oWW/cokV45?n`N`[o
`H@0ok1k5?niQ1Co/7/:ok2=7_n`Q2Wo/8dNokVHG?n`Q2Wo/7/Dok2=7_o:
V2T00_niSA@06oo1Q03o^H@Dok2=7_mkC0[o/8eBombcG?o:ZVKog;=LolZZ
I_oL/ecodjY7olZQD_oLZS?obYPDolZH:OniSACobYPDok1k5?o:XCgo/8dN
ok1k5?o:V1CodjY7ombcG?oC_XkodjY7ombZ<`02olZH:@?obYPD00_o^HdD
olZH5?niSACobYPYom>Q:On`SAkobYPYok2=7_o:V1CobYPYolZH5002olZQ
?@04ok2=7_o:XE;obZY7olZH50;obZ4m00GobYPDolZQ?OoL/ecobZ4momc7
X`03ong@V008omc7Xoo]d9SokM2HongIc?oTal7okM2HokVZKoo]d9P2ombc
Q008ombcG?oCZTOodjY7olZQD_o:V2WobZ4mom>Q:OoCZTL2om>Q:@03om>Z
AooCXBWodj4Y00;og:Xc1OoCXBT04?oLZS?odj4YolZZAooCXBWodjY7ombZ
<on3GQCodkj>ong7G?oT_XCog;>4onBnQ?oL/ecobZY7okV=:OnVLP02og8h
5004oh<_0?mb>1CoPcP0ojIW00;o/7/:00?o^H@DokUb<oo:V1@00_niQ1@0
2?niI`3o^H@Dok1b0?o1Q03o/7/:ol640?n`LP3oi;j40ooL/e`04ooL/hCo
kLN4om>ZAooL/ecobYPDom>Q:Oo:XCgobYPDokV45?n`N`[o^H@DojIb0?nN
LQCoUEDDof115?mP;`[oARH:odHV5?lS9PX00_lJ2@X08?l92ACo4A`:o`T9
2_lA70[o4BHDo`000?m6EBWo8blNoa4L2_lJ4QCo2A8:oaX92_l94P[o6Q8D
o`T95?nVC03o^H@Dok1k2_mb>1CoPbl0og]<2_l/71Co8a`:oaX92_l92@[o
4A`:o`TB2_lJ4QCo0000olZQD_nVZZ?o`LO<0_o:d=H02ooChoGob]3Fom?S
mOoLhn3oPiR>oh>4NonVZZgog>?Pom?SmOo]kN[og>?P05ook^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400?oooooo6Oooool02Oobl_;oj^[ZomkNg_o;
bl_o[jn_o`eD[_nVa^Ko]]3^ogV_kP02oj_No`04ogIfM_o1`L7ol?3`oogm
oE_ooooo00Co^IQLok2=D_nNNc?o?A`:0_m69PX02?mkC0[oSED:oiEE0?nV
LP3oYW8Dok2=7_nVLQCoWW8D1?nVLQ@3ojIb0005oiib5?nNLP[oYW80ojIb
0?nNLQ@00_o:XCd03OniV5cobZ4mok2=7_niQ1Co/7/:ojIb0?nEE@3oJT4:
ojIb5?niSC?o^HdDok2=<on`LP000_n`SAh03oniSACo^HdYok1k2_o:V2Wo
/8@Yok1k5?niSACo/8dNokV=5?n`SAko^HdDokV45?o1Q03oNd`:ok2=<`02
ombcG00GombcQ?oC_XkodjY7olZH:OoCZTOobYPDokV=<oniSBWodiP:olZH
5?n`N`[obYPDokV45?oCV0[o^HdDolZZI_oCZTOog;=Lom>ZAoo:V2WobZ4m
olZH5?o1Q0000oo:V1@07_o1Q03o/780om>Q:Oo:V2WobYPDombZ<ooCV0[o
bYPYolZH5?o:V2WobYPDombZ<oo:V2Wo^HdcokV45?o:V2Wo^Hdcom>Q:Oo:
V1CobZ4mombcQ?o:ZTOodkj>ombn[OoC_Xkog<NSong@V?oL_ZgokMW<ombn
[@;okM2H00So^IQLonBnQ?oL/ecodkj>olZQD_o:ZTOobZ5Bom>ZA`?obYPY
00Oodj4Yom>ZAooCXBWobYPYolZQ?Oo:V2WodjY700;obYPY00CobZ4mombZ
<ooCXBWobZ4m0_oCXBT01ooCZTOog:XconBcAooT/bWoPehDombcG?oL/h@0
0_oL/e`03_oT/dOobZ4mojIb0?nVLQCoH2l:oh<_0?n3>03oYT`0oheE2_n3
;`3o/7/:okUW0?niQ1Co`H@00_niQ1@01OniSC?o/7/:okUW0?n`N`[o^FL0
00?o`H@001[o/780onBnQ?oCZTOoi;j4olZZI_oT_XCog;>4om>ZAooT/dOo
bZ4mom>Q:Oo:V1CobZ4mol640?niI`3o`H@0oiib2_nVI`3oWUhDodH_2_mP
;`[oARl:ob<V2_l/4P3o6PT:oa4L2P;o2@T:00Oo2A8:o`T92_lJ2@[o2A8:
ocAE:OlS9P[o2A8:00;o6Q8D01Co4A`:oaX92_lA70[o0000oh<h0?niI`3o
/7/:oiEE0?n3@@3oNd`:ob<L2_lS9P[o4A`:o`T92_lA70[o6Q8Do`T92_l0
003obZ5BoiF4SP;o`LO<0oo:d=H2omcSh004oiFZ[OmZNfoo/;>gomcSh0;o
kNgZ00?og>?Pooooooooool0GOooool01?n_[joobl_;omkNg_oZj^X1oo;b
lP00ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o2U6^ojC3iOnh
d^ooNJk/00;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01OniZVoo/8eB
oij=:On=E@[oLSPD00;oJT4:00?oUED0oheE2_nNLPX00onVLQ@02?n`SAko
/7/:ok1k2_nVLQCoYW80ok1k2_nVLP3oYW8D0_n`N`X03_nVLQCoYW80oh=k
<oo:ZTOobZ4molZZAoniSC?o^HdYok2=7_n`NaCoYW80ok1k2_mb>03oWXdY
0_n`SAh01?n`NaCoYW8DokV=5?o1Q002okV=5008ok1k5?niSC?o/8dNok1k
5?n`SAko^HdcokV=:OniQ1@2okV=5006ok2=7_mk@@3oUHeBombcG?oC_Xko
g;=L0_o:ZVH01?o:XCgobZY7okVHG?o:V1@2olZQ?@03ok2=7_n`N`[obYPD
00;o^H@D00?o^HdYolZH:Oo:ZTL00_o:ZVH00oo:V2Wog:XcolZH:@03olZH
500;okV=5?o1Q03o^H@DolZQ?OoLZS?obYPDolZH:Oo:ZTOodjY7olZH:Oo:
XCd00_o:V1@05_o:V2Wo^HdcokV=:Oo:XCgobZY7om>Q:Oo:XCgodj4Yomc7
XooCZTOokM2HonC7`Oo]d9Sog<NSong@V?oL_ZgokM2Homc7Xoo]fLcokM2H
ojJ4D_oT_X@2olZZIP06om>ZAoo:ZTOo^HdcolZQD_o:XCgobYPY0_oCXBT0
0oo:XCgobYPDom>Q:@02om>Q:@0;om>ZAooCXBWobYPDolZH5?oLZS?odj4Y
ombZ<ooT/akog:XcolZZI_oCZTL00_oLZS<01?n3GQCobZYVonBnQ?oL/h@2
onBnQ003ombcG?o]d9Soi;<Y00;oLRH000[oH2lDog8h5?n`E@3oLSPDok1E
0?niSACo`H@0okUb<oniQ1CobYPD0_niQ1@01?n`N`[o^H@DokUW0?n`N`X2
ol640005ok1b0?oCZTOog;=LombcG?oCZTL00_oL/e`2om>ZA`;obZ4m00Go
bYPYolZQ?Oo1Q03o/7/:okV45002oiib2P03oiiN5?mP;`[oLSP000;oARl:
1?lA70X00ol92@[o6PT:oa4L2P02o`T92P03odHV5?lS;ako4A`:00;o4A`:
01Ko2@TDoa4L2_l92@[o4A`:of0_2_n`N`[o^G8coiEE0?n=E@[oH2l:odH_
2_lS70[o6PT:oaXB5?l94P[o6Q8Do`TL5?l0003o^HdcoiF4Noo:d=KoY/OP
0_o:d=H2omcSh004om?SmOnEZZgoJW]_ojJZX`;og>?P00?okOKeomcSh?o^
k^h0G_o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooVi^HIonKViP09
om[Jf_oCdm?ob<S8okNg]onMWIgo3EB^ojG4i_nfd^koNJkY00;oZ^3o00Co
JVYZojj^[_oHf=Soi>CTFooVi^H03?niV5coPehDoh=N5?mP@ACoH2l:ofY1
2_n3@@3oWUhDoheE2_n`NbWoYW8Dok2=7PCoYW8D00oo/7/:ojIb0?n`N`[o
YW80oiib2_n`N`[oYW80oiib2_nVI`3oWXdYombcG?o:XE;obZ4molZQD_ni
SA@00_n`SAh01?nNLP[oYW80oheE2_n`SC<3okV=500;ol640?n`SAko/780
ok2=7_niSBWo/8dNokV=:On`Q2WoYW80ok2=<on`SAh00oniSA@2okV45006
oiEE0?nVQ5;og;=LolZZI_oL/ecobZYV0_oL/e`01?o:XE;obZ4molZH:Oni
SC<2olZH500:ok2=7_niSC?o^HdDokV=:Oo:XCgo/8@YonBcAoo:ZVKog;=L
olZH50;obYPY1Oo:V1@00oniQ1CobYPDolZQ?@02olZH:@07okV=<oo:V2Wo
bYPDok2=7_o1Q03obYPYolZH5002olZQ?@0>olZQD_o:XCgodj4YolZZAoo:
V2Wog;=Lom>Q:OoLaj?okM2HombcG?o]d9Sog;>4omc7Xoo]d9P3omc7X`0C
oij=<ooL/hCog;>4olZZI_o:XE;obZY7olZQD_oCZTOobYPYolZH5?o:XCgo
bYPDom>ZAooCXBWobZ5BolZH:Oo:XCgodj4YolZH:@02olZH5003om>Q:Oo:
V1Codj4Y00;odj4Y00Kog:Xcom>ZAooCZTOoi;<Yoiib5?o:ZVH2ombcG00A
omc7XooT_XCog;>4oij=<ooL/hCoUED0og]<2_mb>1CoPbl0oheE2_nNGQCo
YVL0okV45?o:V1Co`H@0okV4:OniSA@00_niQ1@3ok1k2P05ol640?n`N`[o
bYPDokUW0?o:XE800_oL/e`01?o:V2WobZYVom>ZAoo:V2T2om>ZA`06om>Q
:Oo:XE;obYPDokV=5?niQ1Co`H@00_nNLPX01_n3GQCoJT4:of0_2_mP;`[o
?A`:ob<V2P;o6PT:00Co2@T:oa4L2_l92@[o4A`:0_l92@X00ol/C2Wo;2HD
oa4L2P02o`T92P07o`TB2_l92@[o4A`:o`T92_mG703obYPDok1k2P02oheE
2P0>og8h5?mG703o8bH:o`T92_lJ4QCo6PT:o`T92_lJ4QCo0000oiib<onV
V6oog>?Pok2n`Oo1al`3ol[@eP08om?SmOnV/l7oJW]_ojJZXooCfMKog>?P
ongfmOoLhn1OonKViP04oifMWOng]kOob<S8om?Cd`7of][J003oonk^kQWo
k^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol;DjkoY/KVokWCk_mi[^/00_n[
gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP03ok2=D_nEC2WoARHD00;oARHD
00_oH2lDog]<2_n=E@[oWW8:ojIb0?nNNc?o^H@DojIb5?nNLP[oYW8Dok2=
7P02ok1k2P03ok1k:OnNLP[oWW8:00;oWW8:00Ko/780oiEE0?nNSBWobZ5B
olZQ?Oo:ZVH2olZQ?@09okV=:OniSACo/7/:ok1b0?n3GQCoWXdcok1b0?ni
SC?o^HdD00;o/78000Wo/8dcok2=7_niSC?o/8dNolZQ?On`Q2Wo/7/:okV=
:OniQ2T00_niSA@01OniQ1Co^HdDokV=5?mkC1CoWXdc00;og;=L017obZYV
ombcG?oC_Xkog;=LolZZI_o:ZTOobYPYolZZAoo:XCgobYPDokV=5?n`SAko
^Hdcok2=7_o:V1CobYPYokV=<`02olZZIP0BombZ<oo:XCgobYPDokV=:OoC
V0[o^Hdcol640?o:V2Wo^H@DokV=<oo:V1Co^Hdcom>H2_niSBWobYPDok2=
7_o:XCgo^HdD0oniSBT00oniQ1Cog;=LolZZA`02olZZA`0Lom>ZAoo:ZVKo
bZY7ong@V?oLaj?og;>4ong@V?oL/hCoi;j4ombcQ?o]d9Sog<NSong@V?nN
Nc?oi;j4ombcG?o:ZVKobZ5BolZQ?Oo:V2WobZYVolZQD_o1Q03o^HdcolZH
:Oo:XCgodj4YolZQDP;obZ4m0_oCXBT2olZH5007om>Q:Oo:V2Wodj4Yom>Q
:OoCZTOog:XcolZQDP02ombZ<`09oiib5?niV5cog;=LombcG?oLaj?oi;j4
om>nS_nVLQCog:Xc00;oLRH0013oNd`Dog8h5?n3@@3oWUhDokV45?n`NaCo
dj4YolZH:Oo1Q03o^HdYokV=<oniQ1Co/7/Dol640?niSACo`H@00_niQ1@0
1?niI`3obZ4mom>ZAoo:ZVH3om>ZA`?obZ4m00CodjY7olZH5?o:V2Wo/8dN
0_n`N`X01onVLP3oSED:oiiN5?mZ@@[oARH:of0_2_lm70X00_lS70X00olJ
2@[o2@T:oa4L2P02o`T92P09oaXB5?l92@[o8blYob`V5?lA70[o6Q8Doa4L
2_lJ4QCo4A`:00;o2@T:00Ko;1`Dom>40?n`N`[oPcP0og]<5?n3@@02ob<V
2P0<oaX92_lA70[o6Q8Do`TB2_lJ4QCo0000olZQD_n`Q6Kodn?eol77c?n`
_/7o`LO<0_o:d=H02?oLhn3o`LO<odmNI_nEV:?ob]3FomcSh?o]m_Gog>?P
Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooooolIooooo`09oo;b
l_oZj^[og]kNol_;bon_[joo3eJ_oj?2i?nhdnooMjk[00;oZ]oo00CoMWIf
ol71`Oo`l?3ooOgmFoooool02?nNSC?o/7/Yob`L5?m6;`[oH2l:og8h0?mP
;aCoSED:0onNLPX02on`SAkoWW8:oiib<onNLS?oWW8:ojIb5?nNLP[oYW80
ok1k2_nNLP[oYW8000;oWW8:01?oYVL0oh=k<ooCZTOobZY7olZQ?Oo:ZTOo
/8dcokV=:On`SAko/7/Dok1k2_nEE@3o/8dNokV=<oo1Q03o/7/Dok1k2_n`
NaCo/8dN00?o^HdY00So^Hdcok24:On`Q2Wo/8@Yok2=7_niSC?o^H@Dok2=
7P;o^H@D01CoSED:oiib5?o:ZVKobZYVombcQ?o:ZVKog;=LolZQ?Oo:ZVKo
g;=LolZH5?o:XE;obZ4molZH:Oo:V1CodiP:olZH5?niQ1Co^HdDokV=:@;o
bZ5B00CodjY7ombZ<oo:XCgobYPD0_oCV0X3olZH5005okV45?o:V1CobYPY
ol640?niSA@00_o:V2T01on`SAkobYPDokV45?oCV0[o^HdDokV=:On`SAh0
0_o:XCd00ooCZTOobZ4molZQ?@02om>ZA`;og;j]00Coi;j4ong@V?o:ZVKo
g<NS1?o]d9P01?nNLP[og;>4olZZI_o:ZVH2okV=<`0:olZQ?Oo:ZTOobYPD
olZZAoo:V1CobYPYolZH5?o:V2Wog:XcolZH50?obYPY00OobYPDolZH:Oo:
V1CobYPDom>Q:OoCV0[obYPD00Cog:Xc00coWXdYok2=D_oCZTOodjY7ombc
G?o:ZVKog;>4olZZAoniSC?oH2lDog]<2_mP;`X2oh<_000<og8h5?niSC?o
^H@DombcG?o:V2Wo^HdYokV=<oniI`3o^H@Dok1k2_n`NbWo^FL00_niQ1@0
1_niI`3o^H@Dok1k5?o:XCgodjY7olZZA`;odjY700Codkj>olZZAoo:XCgo
bZ4m0_o:V2T02_o1Q03o^H@Dok1k2_nNLP[oYVL0oheE2_mkC0[oARl:oeLL
0?m6;`X2ob<L2P05oa4L2_lJ2@[o4A`:oaX92_lA70X00_l92@X06old;ako
8blNoa4L2_l92ACo4A`:o`T92_lJ2@[o4A`:oaXB5?l92@[odiP:ok1k2_n=
E@[oPd40oh<h0?m69QCo8bH:ob<L2_lJ2@[o2@TDoa4L2_lJ4QCo0000ojJ4
D_nVXFKob]3Fok2n`@04ol[@eP;og>?P00KoAVMLojJQV?o:d=Kog>?Pong]
j_oLhn1Oooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b003oonk^kQWok^k^
00WohN7Qom[Jf_o?cloo_Kfmoj>SXol?EJooYLCVokWCkomg[^/00_nYg?l0
1?m^KVko];Bdon3Ph?o/k>aKonk^kP03oiEE5?nVLQCo4A`:00;oH2l:00Wo
H2lDoheE2_nNLP[oUEDDoheE2_nEEACoWXdYoh=N5?nNLQ@01OnNLPX01?nV
LP3oUED0oiib2_nNLQ@2ojIb0006oh=k<ooCZTOobZ4molZQD_o:ZTOobZ4m
0_n`Q2T01_nVLQCo/7/:oiib5?n`N`[o^HdYok2=7P;o/7/D00So/7/:ok24
:OniSBWo^HdYok24:OniSBWo/7/DojIb50?o^HdD00So^H@Yol640?n`NaCo
/8@YojIb0?n3Nc?okLMLombcQ0;obZYV00Cog;=LolZQD_o:ZTOobZ4m0_o:
V2T03?o:V1Co/8dNolZH5?niSACo/8dNokV=<on`SAko^H@DokV=<oo:XCgo
g;=LolZQ?@GobYPD013o^HdDolZH5?n`SAkobYPDokV=<oniSACobYPDolZQ
?Oo:V2Wo^H@DokV=<on`SAko^H@Dok1k2_n`SAko^H@D1?o:XCd00ooCV0[o
bZYVolZZIP02ong@V00:omc7XooC_Xkog;>4onBnQ?oC_Xkog;jgomc7Xoo]
d9SoPehDombcG0;obZYV00CobZY7okV=<oo:XCgodj4Y0_o:V2T00oo:V1Co
bYPYom>Q:@02olZH:@04olZQ?Oo:V1CobZ4molZH:@;obYPD00?odj4YolZH
:OoCXBT00_oCXBT03Oo:V2WobZY7ombZ<ooCXBWo/8dNoiib2_oCZTOobZY7
om>ZAoo:V2Wog:XcombcG?o:ZTL00_mP;`X02?mb9P3oARHDog8V0?nEE@3o
bZY7olZH5?o:ZVKobZ4m0oniQ1@06?niLS?o^FL0ok1k2_niQ2Wo^H@Dol64
0?niI`3o^H@DojIb5?oCXBWog;=LolZQ?OoCZTOobZ4molZZI_o:XCgodjY7
olZQ?Oo:V2WobZY7olZH5?n`SAko/7/:oiib2P;oSED:02SoNd`:ocdL2_mP
;`[o?A`:ob<L2_lA70[o6PT:oa4L2_l92ACo2@T:oaXB5?lA70[o2@T:ob<V
2_lJ9QCo8a`:oa4L2_l92@[o6Q8Do`T95?l92@[o4A`:o`T95?o1Q03o/7/:
oheE2_n3@@3oNd`DodHV2_lS9P[o8a`:oa4L2_lA9QCo2@T:oa4L2_l92@[o
PehcombcQ?o:d=Ko/;k10_o:d=H02_o1alcob]3Fol[@e_o:d=KoUIRSohfH
S_o1alcodmWFom?SmOoLhn1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
003oonKViQWoi^KV00Wof][Jom?Cdoo8b<So]kNgoifMWOl;E;7oY<CVokWC
komf[NX00_n[h?l01?mZJV[o[Zj^omSHf?oTi>AKonKViP04oh=N5?mkC1Co
?A`:oeLL00;oARHD0_nNLQ@01_nNLP[oSED:oiib5?nNLQCoYW80oiib50Co
WW8:01Co/7/:oiEE0?nNLP[oWW8:ojIb0?nNLP[oYVL0oh=N5?oCZTOo^Hdc
olZQ?OniSC?obZY7okV=:OniSACoYW8Doiib2_nVLP3oWW/cok24:@;o^HdD
0_n`Na@03?n`SAko^HdYokV=:OniSBWo^Hdcok2=7_n`N`[o^HdcokV=5?n`
SAko/7/DokV=50;o/8dN01?oUEDDoh=k<ooL/ecobZYVom>nS_oL/ecodkj>
ombcG?o:ZTOobZ4mok2=7_o:V2Wo^Hdcom>H2_o:XCgo^HdDom>H2_niSBWo
/8dN00;o^HdY00CobYPYolZQD_o:V2WobZ4m0_o:V1@05?niSC?obYPDolZH
5?o1Q03o^H@DolZH5?o:V2WobYPDok2=7_o:XCgobYPDokV=5?o:V1Co^H@D
ok1k2_o1Q03o/7/DokV=5?o:ZVKobZ5B0_o:XCd02?niSBWog;=Lom>ZAooC
_Xkog;j]om>nS_oL/hCobZ4m0_oC_Xh01OoffFKodkj>ong@V?n3GQCog;=L
00;obZYV00KobZY7olZQD_o:V2WobZ5BolZH:OoCXBT2olZH500EolZH:Oo:
V1CobYPYolZH5?n`SAkobYPYom>Q:On`SAkobYPDom>Q:Oo:V1Codj4YolZH
5?oCXBWobYPDombZ<oo:V2WodjY7ok24:On3GQCodjY700?obYPD00Ko^FL0
olZH5?o1Q03oH2lDof0_2_mP;a@2of0_2P09oiiN5?o:XCgobYPYolZZI_oC
ZTOo/8dNokV45?o1Q03obYPY00;o/7/:00Ko/7/DokUW0?n`N`[o`H@0ok1k
2_nNLPX2om>ZA`06olZQ?Oo:ZVKog:XcombcQ?o:V2Wog;>40_o:ZTL03OoL
ZS?obYPYok2=7_n`N`[oWW8:oheE2_nNLP[oNd`DodH_2_mG703oARl:ob<V
2_lJ2@X00olA70X02_l92@[o2@TDo`TB2_l92@[o=2lNob<_7_lA70[o;1`D
oa4L2_l92@X2oa4L2P0CoaXB5?l0003odiP:ok1b0?nNGQCoSED:oh=10?m6
;`[o?A`:oa4L2_l94P[o2@TDoaXB5?l92ACo0000odI17_oL/hCo/;k1ol77
c002ol[@eP0:ojK7h?oLhn3oY/OPomcSh?n3V8koPhf4ol77c?o:d=KokNgZ
omcSh5ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00?ook^k^6Oo^k^h0
2OoQhN7of][Jolo?conm_KgoXj>So`]C[_nUa>Ko]M3^ogV^k002ojOLo`04
ofi^K_nd];Coh>3Ponc/k5_ok^k^00GoPehDog]<2_mZ@@[oLSP0og]<5003
oiib5003ok1k2_nEEACoWW8D00;oWW8D00koWW8:oiEE0?nNLP[oUED0oiib
2_nEE@3oWW8:ojIb0?n=E@[oYW80oiib2_nVLP3oJVLcolZZA`?o^Hdc017o
/8dNok24:On`SAko/7/:ojIb0?nNLQCo/7/Yok2=7_n`LP3o^HdYokV=5?nV
LQCo/7/Dok2=7_niSBWo/8dNokV=:@02ok1k5003ok24:On`NaCo/8dN00;o
^HdD01Wo`H@0okV45?nEE@3oWW8Dom>ZAoo:ZVKog;=LolZZI_oL/ecodjY7
olZQD_o:ZVKobYPYolZZAoo:V1Co^HdDolZH5?niSACobYPDokV=<oniQ1Co
^HdDok2=7_niSBWobZ5B00;obZ4m00WobYPYokV=<oo:V1CobYPDol640?o:
V2Wo^HdDok2=7_niSBT00oo:V2T01?o:XCgo^HdDokV=5?niSA@2ok1k2P0?
okV=5?n`LP3obZ4molZQD_oCZTOog;=LokV=:Oo:V2Wo/8dNolZQ?Oo:XE;o
bZ4molZZAoo:XCgog;>400;odkj>0_oL/h@03?n3GQCog;=LombcG?o:XCgo
bZ5BolZZAoo:XCgobYPDolZH:On`SAkobYPYokV=:@?obYPY00KobYPDolZH
:Oo:V2Wodj4YolZH5?niQ1@2olZH500KolZQ?Oo:V1Codj4YolZH5?o:XCgo
g:XcolZQ?Oo:ZTOoPehDombZ<on`SAkobYPDok2=7_niI`3o/780oiiN5?mk
C0[oH2lDoeLL0?mP;aCoPbl0oh=N5?o:ZTOog;=LolZZI_o:XCgo/8dN00;o
/7/:00?o`H@0ok1k2_n`N`X00_n`N`X01?niSACo^FL0olZH5?nNGQ@2ombc
G0?odjY700Oodkj>ombcG?oL/ecobZ4mom>ZAoo:XCgobYPY00;o^H@D00co
WW8:oheE2_n=E@[oNd`:ob`B0?m69P[oEa`0oa4L2_l/4P3o4A`:oaX92_l9
2@X2oa4L2P0Co`T92_lA70[o8blNob<V2_lJ9QCo4BH:o`TB2_lA70[o2A8:
oaXB5?l94P[o2@T:okUW0?n`N`[oWUhDoheE2_n3>03oARH:ob`V5002oaX9
2P06o`T95?lJ4QCo6Q8Do`000?mP;aCom]240on`_/402Oo1alcob]3Fol[@
e_o:d=KokNgZoeMNKon=SFoo`LO1ol[@eP02omcSh5ook^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN400?oooooo6Oooool02Oobl_;oj^[ZomkNg_o;bl_o
[jn_o`]D/OnTa>Ko^=;^ogJ]jP02ojcOo`04ogIfM_o1`L7ol?3`oogmoE_o
oooo00ooPehDog8h5?n3@@3oPehDoij=:OnNGQCoWW8:oiib5?nNLP[oWUhD
oiib5?n`SAkoWW8Doiib2_nEEA@01?nNLPX04OnEE@3oWW8:oiib2_nEE@3o
WW8:oiEE0?n3GQCog:Xcok2=<oo:ZTOo/8@YolZQ?OniSC?o/8dNok1k2_nN
LP[oWW8D00;o/8dN01Wo/7/:ok24:OnVLQCo^HdDok2=7_n`Q2Wo^HdYok2=
<on`Q2Wo/8dNok1k5?niSACobYPDokV=:On`NaCo^HdDok1k5?niSACoWW8:
ofYW<ooT/dOodjY7olZZI_oL/ecobZYV00;obZ5B00SobZY7olZQ?Oo:V1Co
^HdcokV=5?oCV0[oWXdcol6400;o^HdD00ko^H@Dok24:OniSBWobZ4molZH
:On`SAkobYPYokV=5?oCV0[o^HdYolZH5?n`SAko`H@0olZH:@;obYPD00So
^HdYolZH:Oo:V1Co^HdDol640?niSACo/780ok1k2P;o^H@Y0_o:XCd00oni
SC?obZYVolZZA`02oiEE0005oiib2_niQ1CobYPDolZQD_o:ZTL00_o:ZVH0
3_oL/hCodkj>ong@V?mk@@3odjY7olZZI_o:ZTOobZYVolZZAooCXBWobZ4m
olZH:Oo:V1Co^HdY0oo:V2T01_o:V1CobYPYokV=<oo:V1CobZ4mol6400;o
bYPD00co/8dNolZH:Oo:V1CobYPDolZQ?Oo:ZTOobZ4mom>ZAooLZS?oJT4:
ombcG?o:V1@2okV4500>ok1k5?niI`3oWW8Dog8h5?mP;aCoH2l:og8h5?n=
E@[oNd`DolZH:Oo:ZVKobZY7olZH:On`Q2T3ok1k2P;o^FL000oo`H@0ok1k
5?o1Q03o/7/:ok2=7_nNLP[og;>4ombcG?o:ZVKog;=Lom>nS_oL/hCodjY7
ombcQ?oL/e`00_o:XE802_o:V1Co/8dNok1k5?nNLP[oWUhDoiEE5?mkC0[o
ARl:odHV2_mG7002oa4L2P;o6PT:00?o4A`:o`T92_l92@X00_l92@X01?lJ
9QCo8blNoaXV5?lA70X2o`T92P0;o`T95?l94P[o4A`:o`000?niQ1Co/7/:
oiiN5?n3>03oNd`DodHV5?lm70X01?lA70X01_lA9QCo2@TDocdB2_o]d9So
UJZ]ok2n`@;o`LO<0_o:d=H01_oLhn3odn?eog:=Q?n3Q7_o/;>gol77c0;o
g>?PGoooool01?n_[joobl_;omkNg_oZj^X1oo;blP00ooo^k^hIonk^kP09
on7QhOoJf][oclo?okfm_OnSXj?o3EB^ojK6i_nfd>koNJo^00;oZmko00Co
KVi^okBd]?oPh>3ok>c/Foo^k^h01?n3GQCoJT4:oh=N<onEE@02oiib5006
ojIb0?n3GQCoWW8DoiiN5?nNLQCoYW800_nNLPX02?mkC0[oUED0oiEE5?nE
E@3oSED:oiEE0?nVLP3oSED:0_nNLPX01?nVI`3oH44DolZQ?On`SC<2okV=
:@0DokV=<on`SAko/8@Yok24:OnNLQCoYW80ok2=7_n`NaCoYW8Dok1k2_ni
SACoYW8DokV=5?n`Q2Wo/7/DokV=<on`SC?oWW/cojIb0?niSC<2ok2=7P0>
ol640?niSACo^HdDokV=5?nEE@3oPehDonBcAoniZVoobZY7ombcG?o:ZVKo
djY7olZZAooLZS<2okV=<`07olZQ?OniSACobYPDok1b0?o1Q03o^HdDokV4
:@02okV45007okV=:Oo:XCgobZ4molZQ?Oo:V2WodiP:okV=5002olZH5003
ol640?niSACo^HdY00;o^Hdc01Ko`H@0okV=5?niSBWo^HdDok2=7_niQ1Co
/7/:ol640?niSBWo/8dNokV=<oo:XCgobZ5Bok2=<on`SAkoNd`Dog8h5?nN
GQCo^HdDolZZI_oL/hCoi;=70_oC_Xh2ombcQ007ong@V?n3GQCodjY7olZZ
I_o:XE;obZYVolZQDP03olZH:@05ol640?o:V1Co^HdYom>Q:Oo:V1@00_o:
XCd3olZH:@;o^HdD0ooCV0X3olZH500>olZQ?OoLZS?odjY7ombZ<omZEAko
kLMLolZH:OniSACobYPDoiiN5?o1Q03oYW8Dog8h0?n=E@X2oh<h0004og8h
5?nVI`3o/8dcolZQDP;obYPY00co/8@Yok1b0?o1Q03o/7/:okUW0?niQ1Co
`H@0ok1k2_niI`3o`H@0om>H2_nEE@02ombcG004om>nS_oL/hCog;>4ombc
Q0;odkj>01;odjY7ombcG?oL/ecobYPDok24:On`SAko/7/Doiib2_n3GQCo
Nd`DocdB2_m69P[oARl:ob<L2_l/4P3o4A`:o`T92_lA70X2o`T92P05oa4L
2_l92@[o6RHDob<_7_lJ9Q@01?lA70X04ol92ACo4A`:o`T95?nVC03o`H@0
oiiN5?n=E@[oPd40of0_5?lS9P[o6PT:o`TB2_lJ2@[o2A8:o`T95?l0003o
8a`:oooSS_nEV:<00_o1al`02onVan3o`LO<ol[@e_nVan3okNgZof1bNomZ
Nfoo`LO<ok2n`Oo]m_Gog>?P05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN400?ooi^KV6OoVi^H02OoJf][odm?ColS8b?ng]kOoWIfMo`YA[_nT`nGo
^=;_ogV^k002ojcOo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00GoWW8Doiib
<omkC1CoNd`:oiib5002oheE2P07oiEE0?n3Nc?oUEDDoiib2_nNSBWoUEDD
oiEE0002oheE2P07oiEE0?n3GQCoUED0oiEE0?nEEACoSED:oiib2P02oiEE
000>ofYE7_oLZS?o/8dcolZQ?OniSC?obZY7okV=<oniSBWo/7/:ojIb5?nN
LP[oWW8DokV=5?nVLP02ok1k2P;oYW8D00_o^HdYok24:OniSC?o^Hdcok2=
7_n`N`[o^Hdcok2=7_n`Q2Wo^HdDok1b0002okV=50;oPehD00cobZYVombc
G?o:ZVKobZY7olZZI_o:XE;obZ4molZZAoo:V1CobYPYokV=<oo1Q002okV=
5003okV45?niSACo^H@D00;o/8@Y00So^HdYolZQ?Oo:XCgobYPYokV=5?o:
V1Co`H@0olZH50;o/8dN00So`H@0ok24:Oo:V1Co^HdYokV45?niSACobYPD
ok1k50;o^H@D01;o`H@0okV=<oo:XCgo^H@DolZZAoniSC?o/8dcojIb0?mP
;aCoWUhDoiEE5?n`N`[obZ4monBnQ?o:ZVKodkj>ombcQ?oLaj<2om>nSP04
onBnQ?n3Nc?obZY7olZZA`;obZ5B0_o:XCd2olZH:@;o^H@D00?obYPDokV=
:Oo:V2T00_o:V2T01oniSBWobYPYolZH:Oo:V1Co`H@0olZH5?niSC<00_o:
V1@03oo:V2WobYPDolZH:Oo:V1CobZ4mom>Q:OmkC0[odjY7olZH:Oo1Q03o
^Hdcok1b0?niI`3o^H@Doh<h0002og8h5005og]<5?n3@@3oUED0ok1k:Oo:
XE800_o:XCd00on`SAko`H@0okV45002okV45004ok1k5?n`N`[o/7/:ok1k
2P;o^FL000?oYW80om>nS_oT_X@00_oL/h@03ooL/ecokM2HombcG?oC_Xko
g;=LolZZI_oL/ecobZYVolZH5?n`SAkoYW8DoiiN5?nNLQCoUEDDob<V2P02
odH_2P0<oa4L2_lS70[o4A`:o`T92_lA70[o2@T:oa4L2_l92@[o2A8:o`T9
5?m6@Ako6RHD0_lA70X05olJ4QCo0000o`TB2_lJ4QCo0000oiE<:Oo1Q03o
YW8DoiEE5?n3@@3oARl:ocdL2_lS70[o4A`:oaXB5?l92@[o6Q8Do`TB2_l9
2@[obZYVojJZXoo1alco/;k100;o`LO<0_o:d=H01OoLhn3oPiR]og9WD_n`
_/7o`LO100;og>?PGooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00ooo^
k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o3EB^ojG4i_nfd^koNJkY
00;oZ^3o00CoKVi^okBd]?oPh>3ok>c/Foo^k^h02OnNNc?oWW8Doh=N5?mk
C1CoWW8DoiEE5?n3GQCoNd`:oheE2P02oh=N5005oiib5?nNLP[oSED:oheE
2_mkC1@00on3@@005On=E@[oPd40oheE2_nEE@3oSED:oiEE0?n3GQCobZ5B
ok2=<oo:XE;o/8dNokV=<on`SAko/8@Yok2=7_nVLP3oSED:ojIb5?n`N`[o
YVL0ojIb0002ok1k2P0@ojIb5?niSC?o/7/Dok24:On`SC?o/7/:ok2=7_n`
Q2Wo/8dNokV=:OniQ1Co/8dNok1b0?n`NaCoYW80og]<50;og;=L00GobZ5B
ombcG?o:ZVKobZYVolZZA`02olZQ?@03okV=5?o:XCgo/8dN00?o^HdD00Ko
^HdYokV=5?n`SAko^Hdcok2=7_oCZTL2okV=<`0Aol640?niSACobYPDol64
0?o:V1Co^HdDokV45?niSC?o^HdYolZH:OniSBWobYPDokV=<oo1Q03o/8dN
okV=5?n`Na@00_niSBT02_niQ2Wo^HdYolZQ?Oo:V1CoWUhDodHV5?mP@BWo
YW8DokVHG?o:ZVH2om>nSP;og;>400Gog<NSom>nS_o]d9SokM2Hoh=k<`03
olZQDP03om>ZAoo:ZTOobZ4m00;obYPY00_obYPDokV=5?niLS?obYPDokV=
:Oo:V2WobZ4molZH:On`SAkobYPYok2=7P02okV45005olZH5?o:V2Wo`H@0
olZH:Oo:V1@00_o:XCd01OoLZS?obYPYoh=N5?o:XCgo^Hdc00;o^H@D01Co
/780ok1k2_niI`3o/7/:ojIW0?nVLQCoPcP0oiiN5?nEEACo/7/YolZQ?Oo:
V2Wo^HdDok1k5?niI`3o^H@Dok1k5?nVLQCo/7/:okV450Co/7/:00?oYVL0
olZZI_oL/h@00ooL/h@04OoC_Xkog;>4olZZI_oL/ecodjY7om>nS_o:ZTOo
bZ4mokV=:On=E@[oJUDNoiEE5?n3GQCoARHDocdL2_mP;`[o4A`:00;o6PT:
01?o4A`:o`T92_l92@[o2@T:oa4V5?l94P[o2@TDocAE:OlS70[o4BH:o`T9
5?l94P[o6Q8Doa4L2_l92ACo2A8:oh<_0?n`N`[oYW8D00;oSED:00_oH2l:
ocdL2_lS70[o4A`:o`T92_lA70[o2@TDoaXB5?l0003o/8dcoh>4N`02ojJc
`@09ol77`Oo1alcob]3FojK7h?oLhn3oUJ6gof1N<onVZZgo/;k100;og>?P
Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooooolIooooo`09oo;b
l_oZj^[og]kNol_;bon_[joo2e>^ojK6i_nidnkoNJk[00;oZmoo00CoMWIf
ol71`Oo`l?3ooOgmFoooool2oiib5003oh=N5?n=E@[oUEDD00;oPehD00?o
Nd`Doh=N5?mb>1@00_nEEA@01?n3GQCoUEDDoh<h0?mb>002og]<2P03og8h
5?n3@@3oNd`:00;oUED000CoUEDDoiEE0?mP@ACog:Xc0_o:XCd2okV=<`;o
/8@Y00GoYW8Dok1k:Omk@@3o/8dNojIb5002oiib2P0=ok1k5?nVLQCo/8dN
okV=:OnNSC?o^HdcolZQ?OnNLQCoYW8DokV=:Oo:V2Wo^H@DokV4:@02okV=
5009ok1k5?nNLP[oJUDNombcG?o:XE;og;=LolZZAoniZVoobZ5B00?obZ4m
017o^HdYolZQ?On`SAkobYPDokV=5?n`LP3o/8dNok1k2_n`SAko/7/:okV=
:On`SAko^HdYolZH5?n`NaCo^H@Dok1k2P02okV=5008ok1k2_niSACo^HdY
olZH:OniSBWo^HdDokV=<oo:V1@2okV4500<okV4:On`N`[obYPDokV=:On`
SAkobZ4mokV=:On`SAkoYVL0og8h5?mkC0[o/7/Y1?oL/h@2om>nSP06omc7
Xoo]d9Sog<NSong@V?nNSC?obZY71?o:ZVH02?o:XCgodj4YolZQ?On`SAko
bYPDokUb<on`SAkodj4Y0_o:V2T0<?n`NaCobYPYolZH:On`SAko^H@DolZH
5?niSBWo^HdDom>Q:Oo:V1Co^HdcolZH:Oo:V1CobZY7om>ZAomk@@3odjY7
okV4:OniQ1Co^Hdcok1k5?o1Q03o^H@Dok1k2_niQ1CobYPDokV=<on`Q2Wo
UEDDolZH5?o:XCgo/8dNokV45?n`N`[o^H@Dok1k2_nNLQCoWUhDoiib2_o1
Q03o/7/:ok1b0?nVI`3o/7/:ojIW0?niZVooi;j4omc7X`;odkj>0_oL/h@0
3?oC_XkodjY7olZQD_o:XE;odjY7olZQ?OnVLQCoNd`DodHV2_mZ@@[oNd`D
of0_2P;oARH:0_lS70X01?lA70[o2@T:oa4L2_l94PX2o`T92P;o6Q8D00Go
;2HDob<_7_lA70[o6Q8Do`TB2P02o`T9500OoaXB5?l92ACoH2lDolZH5?nV
I`3oWUhDog]<5?mZ@@[oARHDoaXB5?lJ2@[o4A`:o`T95?lJ4QCo2@TDo`00
0?nELTOo/8AVol77c?nV/l7oY/OPok2n`Oo:d=Ko`LO<omcSh?nEZZgoCfM7
ok2c]on`_/7odn?eomcSh01Oooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b
003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol?EZooXl;TokSC
komg[^/00_nZgol01?m^KVko];Bdon3Ph?o/k>aKonk^kP03oiik<onNLQCo
WW8D00;oPehD02CoUEDDoheE2_nNLP[oSED:oh=N5?nEEACoWW8Doiib2_n3
GQCoPd40ofY12_mb>03oNd`:og8V0?n3>03oSED:oh=10?nEE@3oWUhDojI<
0?mP@ACodjY7okV=<oo:XCgo^HdYokV=<on`SAko/8@YojIb5?n`SAkoSED:
oiib5?n`N`[oUED0ojIb0?nNLPX2ojIb5007okV=:On`NaCo^HdcokV=<on`
NbWo/8dNok24:@02ok2=7P03okV45?n`N`[o/7/D00;o/7/:01?oH44Dombc
G?oL/ecobZYVombcQ?oL/ecobZ5BolZZAoo:XE;o^HdYolZH:On`SAkobYPY
okV=5?n`NaCo/7/:ok1k5?niSACo/7/D00;o/8@Y00?o^IQLolZH:On`SAh0
0_n`N`X2ojIb000>ok1k5?o1Q03o/7/:ok1k2_n`SAkobZ4mok1k5?o:V1Co
/8@YokV=5?niQ1Co^HdDok1k5?niSC<2okV=:@08okV=<oo:V1Co^HdYojIb
5?nEE@3o/7/Yoiib5?o:ZVH3om>nSP03ombcQ?oC_XkokM2H00;og;j]01Co
kM2HokVHG?o:XCgobZ5BolZZI_oCZTOobZ5BolZQ?OniSC?obYPYolZH5?ni
SBWo^H@Dol640?niSC?o^HdYokV=<oniLS?o`H@0ok2=7P?o^H@D00?obYPD
okV4:Oo:V1@00_o:V1@07oo:V2WobYPDombZ<oo:V1CoPg/cok2=7_o:V2Wo
^HdYok2=7_niQ1Co^FL0ol640?n`SAko/7/:okV45?o:ZTOo/7/YoiEE5?o:
ZTOobZ4molZH:OniQ1Co/7/:okUW0?nVLP3oYVL0ojIb5?nNLQCoYVL0oiib
2_n`N`X00_n`LP000onNLP[o/8eBong@V002om>nSP0?ombcG?oC_Xkodkj>
ombcG?oCZTOobZY7olZQD_oLZS?o/8@YojIb5?n3GQCo;1`Doa4L2_mP;aCo
JT4:00;oARl:00Go;180ob<L2_lJ2@[o4A`:o`T92P02o`TB2P06oa4L2_l9
2@[o6Q`Nob`h:OlJ9QCo4BHD0_lA70X03?lJ4QCo4A`:oa4L2_l92ACoEa`0
ol640?nNLP[oWUhDoh=10?mb>1CoARHDob`V50;o4BHD00Wo2A8:oa4L2_l9
71Co0000oiF4D_n`SC?o/;k1ojJc`Oo1al400_o1al`02?nVan3og>?PojJc
`Om6GTOoYZZ]ok2c]ooCfMKog>?PGoo^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@00oooVi^HIonKViP09om[Jf_oCdm?ob<S8okNg]onMWIgo3eF_ojG4
i_nidnooMjk[00;oZMco00CoJVYZojj^[_oHf=Soi>CTFooVi^H00onVQ5;o
WW/coiik<`02oiib500<oiEE5?n=E@[oPehDoiEE0?n=E@[oWW8:oiEE5?nN
LQCoPd40og8h0?mkC0[oEa`00_mP;`X00omG703oNd`:oh=10003oheE2P04
ofY12_o:ZVKo^HdYolZQ?@;o^Hdc00co/8dNok2=<on`SAkoYW8DoheE2_nV
LP3oWW8:ojIW0?nEE@3oYW80ojIb5?n`SAh2ok24:@;o/8dc00Oo/8@Yok1k
5?n`Q2WobYPDok2=7_niQ1Co^HdD00;o/7/:00?oWW8:ofY12_oL/e`00_oL
/e`0:?o:ZVKog;=LolZQD_n`SC?obZY7olZH5?n`SAkobYPDok2=7_niSACo
/780ok1k2_n`NaCo/8@YojIb0?n`SAko/8dcokV=<oo:XCgo/8dNokV=5?n`
LP3o/7/:ojIb0?nVI`3o/7/:ok1k5?nVLQCobYPYokV=:OniQ1CobYPYokV=
<oniSACo/7/YokV45?n`SAko`H@0okV=<on`SAh2okV=<`06okV4:On`SAko
YVL0okVHG?niQ1CobZYV0_oLaj<2om>nSP03ong@V?oLaj?odkj>00;og<NS
01WoYZ5VokV=<oo:ZTOobZYVolZZAoo:XCgo^HdYolZZAoo:V1Co^HdcolZH
:OniQ1Co/7/:okV4:OniQ1Co/8dNok1k2_niQ1Co/780okV4:On`N`[o`H@0
okV=5?niQ1Co`H@000;obYPY01Oo^HdYokV=5?o:XCgodj4Yoiib2_niSC?o
bZ4mokV=:On`SAko^Hdcol640?n`N`[o/780oiEE0?n`LP3o^HdDok1k:Oni
Q2WobZ5BolZH:On`SAko^H@DojIb0002ok1k2P0=oheE2_nEE@3oWUhDoiib
2_nVI`3oUED0ojIb0?nVLQCoYVL0ojIb5?o]d9Sog;=Lom>nSP02ombcQ003
ombcG?oC_XkobZ5B00;obZ4m00oo^HdYokV=5?n`NaCoEa`0ocdL2_lJ2@[o
ARl:oeLL0?m69P[oARl:ob<V2_lS70[o4A`:oaX92_l94PX00ol92@X01olA
70[o2@TDob`V5?lS70[o4A`:o`T95?lJ4Q@00ol92A@00ol94P[o6PT:olZH
5002oiiN500Aog]<5?mb>03oARl:oaXB5?lJ2@[o2@TDoaXB5?l92ACo6Q8D
o`000?o:XE;oYW9Bok2n`OnV/l7o/;>gojJc`Oo1al`00oo:d=H01Om?Ieco
UIRSok2c]ooCfMKog>?P05ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X0
0?ook^k^6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`]D/OnTa>Ko^M?_
ogJ]jP02oj_Po`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Co/8dcoiik<on`
SC?oWW/c0_nNLQ@01On3GQCoWW8:oiEE0?n3GQCoPg/c00;oWW8D01SoSED:
og]10?mP;`[oH44YodHV2_mG703oH2lDog8h0?n3@@3oSED:oiib2_nVLP3o
ARl:olZQD_n`SC?obZ4mokV=<oo:XCgo/8dNok2=<on`SAko/8dcof115?nN
LPX2oheE2P07oiEE0?nNLP[oWW8:ok24:On`SAko/7/DokV=:@02ok24:@0<
oiib5?niQ2Wo^HdYokV=:On`SAko^HdDok1k2_niSACo/7/:ofY12_oL/hCo
bZY70_o:ZVH02ooL/ecobZ5BolZZAoo:XCgo^HdYolZH5?niSC?o/8dNok1k
5?n`N`[oWW8:00;o^HdD00[o/7/:ojIb5?n`Q2Wo/8dcokV=<oniSBWo/7/:
ojIb0?nNGQCoYVL00onNLPX05_n`NaCobZ4molZQ?OniSACobYPYok2=7_ni
SACo^H@Dok2=7_n`NaCo/8dNokV=5?n`Q2WobZY7olZQD_niQ2Wo^HdYoiib
2_o:XE;odkj>olZZI_oC_Xh2ong@V0;odkj>013okM2HolZn[Oo]d9SokM2H
olZZI_n`SE;obZY7olZQD_niSC?obZ4molZH5?n`SAkobYPYolZH5?o:V2Wo
^H@Y0_niQ1@00oniSACo^H@Doiib2P02okV45003ok1k5?n`N`[o`H@000;o
^H@D017obYPDok2=7_o:V1CobYPDol640?o:V2Wodj4Yoiib5?niSC?o^HdY
olZH5?o:V2Wo^HdYokV4:Oo:V1Co/7/:oiiN5002ok1b0006okV45?n`SAko
bYPYolZH:OniQ2Wo/7/:0onNLPX04?nEEACoYT`0oiiN5?nVI`3oWUhDoheE
2_nVC03oWW8:ojIb0?nVLQCokM2HombcQ?o:ZVKog;>4olZZI_oLaj<4olZQ
?@05ol640?nVLQCo/7/:of0_2_lS9PX00_m69PX03OmP;`[oARH:odHV2_lS
9P[o6PT:ob<L2_l92@[o4A`:o`T92_lA70[o2@T:oaXB5?l94PX00_lS;ah0
2OlJ9QCo2A8:o`T95?l94P[o2@TDoa4L2_lJ2@[o2@TDom>40002ojIb500<
og]<5?mP@ACo?A`:ob`L5?lA70[o6Q8Do`TB2_lJ4QCo2@TDo`000?n`SC?o
WXAV0_n`/kL00onV/l7o/;>gol77`@02ol77c006ol[@e_m6IecoUJ6>oiFQ
]ooCfMKog>?PGoo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooooolI
ooooo`09oo;bl_oZj^[og]kNol_;bon_[joo2e>^ojG4i_ned>koNJk/00;o
Ymco00CoMWIfol71`Oo`l?3ooOgmFoooool00onVQ5;oWXdcok2=<`02oiik
<`04ok2=7_n3GQCoUEDDoiEE50;oWW8D01KoWW8coij=:OmkC1CoNd`:of0_
5?m69P[oEa`0odHV5?mb9P3oH2lDof0_2_n3@@3oNd`DojI<0?m6;`[og;=L
okV=<oniSBWo^HdcokV=:On`LP3oWXdY0_nVLQ@02?mP;`[oPd40oiEE0?nE
E@3oSED:ojIb0?n`SAko/8dc0_nVLQ@04_n`SC?o/8@Yok2=7_n`SAko^HdY
okV=<on`SAko^H@Dok1k5?niSACo/780ok1k2_mP;`[obZYVombcG?o1/hko
bZYVolZZA`?obZ5B00GobYPYok2=7_n`SAko^HdDok2=7P02ok1k2P;o/780
00?oYW8Dok1k:On`Q2T00_o:ZTL03_n`Q2Wo`H@0ok1k2_nVLP3oWUhDoiEE
0?nNLP[o/7/Dok2=7_niSC?obYPYokV=:On`SAko^HdY0_niQ1@02_niSBWo
/7/DokV=5?niSC?o^H@DolZQD_o:ZTOobZ4mokV=:On`Na@2olZQDP0@olZZ
I_oC_Xkodkj>ombcQ?oC_Xkog;>4omc7XooC_XkokM2HolZn[OoC_Xko^HdD
olZQ?Oo:XE;o^HdcolZQDP?obYPY00?o^HdYok2=7_niQ1@00_niQ1@01on`
N`[o/780ok1k2_nVLQCoYW80ok1b0?n`N`X00_niQ1@01Oo1Q03o^Hdcol64
0?niSBWo^H@Y00;obYPD017odj4YokV=5?nNNc?obYPYolZQ?On`SAkobZ4m
ojIb5?niQ1Co/7/:ojIb0?n`N`[o/780okV45?n`SAko^H@YokV=5002ok1k
2P05ojIW0?n`N`[oWUhDoiib2_nEE@000_n=E@X02_n`NaCoSED:oiiN5?nV
I`3oWW8:oheE2_o]d9Sog;>4om>nS_oL/h@2om>nSP08ombcG?o:XE;og:Xc
olZZAoniQ1Co/7/:ojIW0?mkC1@2ocdL2P0?og8h5?mZ@@[o8bH:of0_2_lS
9P[o8a`:oaX92_l92@[o6Q8Do`T92_lA70[o2@T:oa4L2_l92@[o8blN00;o
6Q8D01Oo4BHDoaXB5?l94P[o2A8:o`T92_l94P[o0000ok2=7_nNGQCoYW80
og]<5?mb>03oARHDob`L5?lA70[o2@TDoa4L2_lJ4QCo2A`Do`T92_ld;ako
/8dcojJZX`02ok2c]`0:ojJc`OnVan3oY/OPol77`OoLhn3oAVMLoiFQS_nV
ZZ?o`LO<omcSh5oooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800?ook^k^
6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`]D/OnTa>Ko^=;^ogJ]jP02
ojcOo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Oo/8eBok24:OnEQ5;oYW8D
ok24:OnNSBWoUEDD00CoWW8D00coWW8coiik<on3@@3oNd`DofY12_n3;`3o
?A`:of0_2_mb>1CoLRH0og8h0?mkC1@2oh=1000@of115?oL/eco/8dcokV=
:On`SC?o/8@Yok2=7_n`SC?o/7/:oiib5?mP;`[oJUDNoheE2_nEE@3oSED:
ok1k2P;oYW8D00OoWW8Dok24:On`Q2WoWXdcok2=7_nVLQCo/8dc00;o/8dN
0oniSA@00on`N`[o/8dNofY12P02ombcG0?obZYV0_o:XE802_o:XCgo^HdY
okV=<oniSC?o^HdDok2=<on`N`[oYW80ok1k2_nVLP02ok2=7P0RojIb0?o:
XE;o^HdcolZH5?n`SAko/780oiib2_n=E@[oWW8:ojIb5?nNSBWo/7/DokV=
<oo:V2Wo^HdYolZH5?niSBWo^HdDok1k:On`SAko/7/:okV=:On`Q2Wo^HdY
olZQD_o:ZTOobZ4mok1k5?n`SAkobZYVolZZAoo:ZVKodkj>omc7X`Codkj>
00KokM2Hom>nS_o]d9So^JY_ok2=<oniV5`2olZQ?@04olZZAoo:V1Co^Hdc
olZH50;o^HdY00So^H@Dok2=7_n`LP3oYW8Dok1b0?nVI`3oYW8DojIW00;o
/7/:027o/780olZH5?n`NaCo`H@0okV=5?o:V2WobYPDok2=7_o:V2WodjY7
ok2=7_nNSBWobYPYokV=<oniSBWobYPYok1k5?o:V1Co^H@Dok1k2_n`LP3o
WW8:ok1k2_nVLP3o^H@YokV45?n`LP3oWW8:ojIW0?nVLQCoSED:ojIb0?nE
E@000_n=E@X02?nVC03oUED0oheE2_nNLP[oYW8DoiEE5?oC_Xkog;>40_oC
_Xh04ooL/ecodkj>olZZAoo:ZVKobZ4mokV=:On`SAko/7/:ojIW0?mkC0[o
?A`:of115?mb>1CoNd`:ocdB2_m69P[oARHDoa4L2_lS70X00_lA70X00ol0
003o2@T:oa4L2P02o`T92P;o8blN013o4BHDoaX92_l92ACo6Q8Do`T95?lA
70[o6PT:o`T95?niI`3oWUhDoiib5?n=E@[oH2l:odHV2_lA70[o6PT:0_lJ
4Q@01ol92ACo2A8:o`T95?m6@AkoYXABoiFHXonV/l400on`/kL02?o:d=Ko
`LO<ol[@e_m?GVKoSIR>ojJQV?o:d=Kog>?PGoo^k^h01?nSXj?o_Kfmolo?
cooJf]X1on7Qh@00oooVi^HIonKViP09om[Jf_oCdm?ob<S8okNg]onMWIgo
3EB^ojK6i_nfd>koNJo^00;oZmko00CoJVYZojj^[_oHf=Soi>CTFooVi^H0
1onNSC?oWW/cok2=7_nNNc?oWW8:ok24:OnNLPX00_nNLQ@09?n3GQCoWW8D
oij=:On`Q2WoPehDog8h5?n3GQCoNd`Doh<_0?mP;`[oLRH0og8h5?mkC1Co
Nd40oheE2_nEE@3oARHDombZ<oniQ2Wo^HdYok24:On`LP3oYW8Dok2=7_nN
LQCoUED0og8h5?mP;`[oNd`:oiEE0?nNGQCoYW80oiik<on`SAkoYW8Dok1k
:@;o/8@Y00?o/8dNojIb5?niQ1@00_n`SAh02?niSACo/8@Yok1k2_n`SAko
WW8Dof115?oL/ecobZ5B0oo:ZVH01?o:XE;obZ4mok2=D_o:XCd2ok2=7P0<
ol640?n`LP3o/780ok1k2_n`LP3o/7/:oiib5?n`N`[o/7/YolZZAoniSBWo
^Hdc0_n`N`X02_nNLP[oSED:oh=N5?n3;`3oYW80ojIb5?niSC?o/8dNokV=
5?niSBT2okV45007ok1k:On`NaCo/7/:ok2=<on`SAko^HdYolZZA`02olZQ
DP06ok2=7_oCV0[obZ5BolZQD_o:ZVKog<NS1?oC_Xh2omc7X`08ong@V?oL
_Zgodkj>ok2=<oo:V2WobZY7ok2=7_o:XCd2okV=:@;obYPD01OobYPYojIb
0?niSC?o/7/:ojIW0?nNLQCoYW80oiEE5?mkC1CoYVL0ok1k2_niI`3o/8dN
ok1k2_n`SAko^H@DolZH5?n`SAko^H@YolZH5?o:ZTOo/780oiib<`02okV=
:@;obYPD00Co^H@Yok2=7_n`SAkoYW8D0_n`N`X2oiib2P;o/7/:00Co/780
ojIb5?nVI`3oUED00_nNGQ@00onEE@3oWUhDoheE2P02oheE2P0CojI<0?nN
GQCoYVL0oh=10?oT_XCobZYVom>nS_oL/hCobZYVom>nS_o:ZTOobZ5BolZQ
?Oo:V2Wo/8dNok1k5?nNLP[oUED0of0_2P02og]<500:ofY12_lS9P[oARH:
ob<V2_lA70[o6PT:o`T95?lA70[o2@T:oa4L2P;o2@T:01;o2A8:ob`V5?l/
9QCo6RHDo`T95?lJ4QCo2@T:oa4L2_l92ACo4A`:o`000?n`N`[oYVL0ok1k
5?n3@@3oH2l:odHV5?lJ4Q@2oa4L2P0:o`TB2_lJ4QCo6Q8Do`T95?l/71Co
bZ5BoiF4NonVan3oUJZ]ok2c]`;oY[?100Oo`LO<om?SmOmZNfooPhB>oiFH
Xoo1alcog>?P05ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00?ook^k^
6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`YA[_nT`nGo^=;_ogV^k002
ojcOo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^1OnNNc<03?nNSC?oUEDDog]1
0?n3GQCoWW8DoiEE5?nNNc?oWW8DoiiN5?mP;`[oUEDDog]<2P?oARH:0_m6
9Q@01omG703oLSPDoh=10?m6;`[obZYVok2=7_niSBT00_n`SAh00onNLP[o
/8dNok1k2P02og]<500IodH_2_mZ@@[oNd`DoheE2_nNLQCoYW8Dok2=7_n`
Q2Wo/7/Doij=<on`Q2WoWW8:ojIb5?niQ1Co^HdYokV=5?n`N`[o/8@YokV=
5?n`N`[o^HdDof115?o:ZTOobZYVombcG002olZZIP?obZY701gobZ4mokV=
<oniSC?o^HdDok24:On`NaCoWW8:ok1k2_nVLP3o/7/:oiib5?nVLQCobZ5B
olZH:On`SAko^H@Dok1b0?n`N`[oNd`DodHV5?mb>1CoWUhDok1k5?n`SAko
bYPYokV=5?niSBWo/8dNok1k2P02ok2=7P06oiib5?n`NaCo^HdYok2=7_o:
XE;o^JY_0_o:XCd01?n`SAkobZ5BolZH:OniZVl2om>nSP0;ong@V?oC_Xko
dkj>omc7XooC_Xkog<NSolZn[OoC_XkoWXdYolZZAoniV5`00_o:XCd02Oo:
V2Wo^HdYokV=:Oo:XCgobYPYok1k5?niSACo/7/:ojIW0002oiiN50;oPbl0
00GoYW80ok1k5?n`NaCo^H@Dok2=7P03okV45006okV=5?n`SAkobYPYolZQ
?Oo:V2WoPehD0_niSBT03oo:XCgo^HdcolZH:On`SAko^Hdcok1b0?niQ1Co
YW80ok1k2_nNLP[o/7/Dok1k:On`N`[oWW8:oiEE0002oiiN50?oUED000So
YT`0oiEE0?nNGQCoUED0oheE2_nNLP[oUED0ong@V0?obZYV00OobZ4molZZ
I_oCZTOobZYVokV=<oo:V2Wo/8dN00;o/7/:00KoWW8DoheE2_n3GQCoNd`D
og]<2_l/71@2odHV2P09oaX92_lS70[o6Q8Do`T92_lA70[o2A8:o`T92_lA
70[o6PT:00;o6RHD00Go6Q8Doa4L2_l92@[o2@T:oa4L2P03o`T95006ok1E
0?nNLP[oYW8Dog]<5?mb>03oARHD0_lJ4Q@02_l92@[o6Q8Doa4L2_l971Co
2@TDob`B0?nVQ5;oUG97ol[@e_nEZZd2ok2c]`;o`LO<00Kob]3Fog:=Q?n3
SHCoSIR>ol77c?oLhn1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003o
oooooaWooooo00Wol_;bon[Zj_oNg]kobl_;ojn_[ol=E:koYLCVokKBk_mi
[^T00_nZh?l01?mfMWKo`L71oo3`l?omoOeKooooo`04oij=<on`Q2WoWXdY
oiik<`;oWW8D0_nEEA@04omkC1CoUEDDoiib5?nNSBWo/7/Yoh=N5?mZEAko
Nd`Dob`L5?lm70[oARHDocdL2_m69QCo?A`:odHV5?lm70[oLSP0odI17_oL
ZS<00_n`Q2T00on`SC?o/8dNoiib5002ojIb500@og]<5?mP@BWo4BHDog8h
5?n3;`3oSED:oiib2_nNLQCoYW8Doiib5?nNSC?o/8dcok2=7_nEEACo/7/Y
ok2=<`?o^HdY00Wo^HdDok1b0?n`N`[o/7/:oeLL0?oCZTOog;=LolZZAoo1
/hh00_o:ZVH02oo:XCgobZ5BokV=<oniSBWobZ4mokV=5?n`SAko/7/:ojIb
5?n`N`[oYW8D00;oWW8D01Ko/8@YokV=<oo:XCgo/8dNokV45?n`NaCo/780
ojIb0?lm70[oAT4Nog]<5?nNLP[o^H@YokV=:On`NaCo/8dNokV=5?niQ1Co
/8dNok1k5?nVLQCo/7/D0_niSBT02_o:ZVKobZ5BolZQD_o:V2Wo^H@DolZQ
D_niSC?obZYVombcXooC_Xh2ombcQ0;odkj>01GokM2Hom>nS_o]d9Sog<NS
oiik<oo:XCgobZ5BolZZAoniV5co^HdcolZH5?niSBWobYPYokV=5?niSC?o
^H@Dok1k5?nNLP[oYVL0ojIb5?niQ1@00_nNLPX06_n`N`[oYW8Dok1b0?n`
NaCo/7/:ol640?n`SAkobYPYok2=7_o:V1CobZY7olZH5?n3GQCobZY7okV4
5?niSC?obYPDolZQD_niSBWobYPYok1k5?n`N`[o/780ok1k2_nEEACo/8dN
0_n`N`X00onVLP3oWW8:oiEE5002oheE2P04oh=10?nNGQCoUED0ok1E00;o
SED:00OoUED0ojIb0?nEE@3og;>4olZQD_oL/ecobZY700;obZYV00cobZY7
olZZI_o:ZTOo^HdcokV=:OniSACo/7/Doiib5?n=E@[oNd`:og]<5?mZ@@X2
ocdL2P03ob<V2_lS70[o4A`:00;o6Q8D027o2A8:o`T92_lA70[o2@T:o`T9
5?lJ71ko8blNoa4V5?l92ACo6Q8Doa4L2_l94P[o6Q8Doa4L2_l92@[oSED:
ok1E0?nEEACoPd40of0_2_m69QCo8a`:oaXB5?lA70[o2@TDoaXB5?l92ACo
6Q8Do`T95?niSC?oPehcojK7h?nEZZd00_n`/kL02?nV/l7o`LO<ol[@e_n3
V8koLXf4ohfHS_n`/kOog>?PGoooool01?n_[joobl_;omkNg_oZj^X1oo;b
lP00ooo^k^hIonk^kP0?on7QhOoJf][oclo?okfm_OnSXj?o3eJaoc1b`?mG
T]GoNk7/oi_>oonhk?ooKVi^okBd]?oPh>3ok>c/05_ok^k^0onNNc<04OnN
LS?oUED0oh=N5?n3GQCoSED:oh=N5?nEEACoWXdYok1k:OnNNc?oUEDDog]<
2_mb>1Co;1`Dob`V5?l/71Co6RHD00;o;2HD01co;1`DodHV5?lm70[o=2lN
okV=<on`SC?o/8@Yok2=7_nVLQCo/7/:oiib2_mkC1CoLSPDoa4L2_l/9QCo
LSPDog]<5?nNGQCoWW8:ok1k2_n`SAko/7/YojIb5?n`SC?o/8@Yok1k:On`
SAko/8@Y0_niSBT02On`SAko/7/Dok2=<on`LP3o/7/DodHV2_oL/ecobZYV
olZQDP03olZZIP05olZQD_o:XCgobZY7okV=<oo:XCd00_niSBT01on`SAko
/7/Dok1b0?n`Q2WoYW8Dok24:On`SC<00oniSC<02?n`SAko^H@Dok1k5?ni
Q1CoSED:of11:OnEEACoWW8:0_niSBT03OniQ1Co^HdYokV=<oniSBWo^HdD
ok1k5?n`N`[o/8dNokV4:OniSC?o^IQLolZZAoo:XCd00_n`SAh00oo:XE;o
bZ4molZZIP05om>nSP03omc7XooC_Xkog<NS00;odkj>00?oWW/colZZI_o:
ZVH00_o:ZTL03_o:XCgo/8dNolZH:On`SAko^HdYokV4:On`SAko^HdcojIb
0?nVLQCoWUhDoheE2_nEEACoPd400_nVLQ@00onNLP[oWUhDok1k2P02okV4
500Gol640?n`SAko^HdDolZH:OoLZS?oH2l:olZQ?OniSBWobZ4mok2=7_o:
XE;o/8dNolZH:On`NaCo^H@Dok1k5?n`N`[oUEDDok1k2_niSBWo/7/Dok1k
2_nNLPX00_nNGQ@00onVI`3oUED0oiEE0003oheE2P;oUED000?oWUhDoiEE
0?oCZTL00_o:ZVH00oo:XE;obZYVolZZIP02olZZIP0IolZZAoo:XCgobZ4m
ok2=7_n`N`[oYW8Doiib2_mkC1CoPehDof115?lm70[o;2HDodHV5?lA70[o
6PT:o`T95?lA70[o2@TDoaXB5?lA70[o2@TDoaXB5?lA70[o8blNoa4L2P02
oaXB500<o`T92_l92ACo2@TDo`TB2_l92ACoH2l:oiiN5?n=E@[oNd`:of0_
2_m69QCo8bH:0_lJ4Q@03?lA70[o2@TDoaXB5?lJ4QCo0000olZZAomZEAko
Y/OPojJZXonEZZgo/;>gojJc`@;o`LO<00GoPiR]ofYbG?n=V8ko/;>gomcS
h01Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003oonKViQWoi^KV00Go
f][Jom?Cdoo8b<So]kNgogUiN@3ool71`Kgo`L7100CoT92@okNg]oo8b<So
dm?C0OoJf]X00?ook^k^7?o^k^h00ooQhN7oeMGEomGEe@3oomGEeKcoeMGE
00?ohN7Qonk^k_o^k^h00_o^k^h00?oooooo6oooool2ooOgmoookno___o_
knl2ooOgm`?ooooo003oonk^kQ[ok^k^0ooYjNWoonCTi;koi>CT0ooYjNT2
onk^kP00oooVi^HIonKViPCohn?SoooPh>2non3Ph0Cohn?S0OoVi^H00?oo
OgmoQ_moOgl7oginO_ooOgmoDomoOgl00004on_[jooVi^Koh^;RomkNgP?o
gMgM0?oog=cLomkNg_oNg]kog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMd004Oog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomgMg@02omcLg00mom_KfooMgMgog=cLomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oLg=gog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkogMgMom_KfooJf][oemOGomSHf?oGemOof][Jom_Kg002omgMg@3oomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN0015omgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM00?og]kN00?o
gMgMomkNg_oNg]h00ooMgMd1on7Qh@7oinOW0OoZj^X00003onc/k?oVi^Ko
h>3P00?ofMWI00Sof=SHomWIfOoIfMWofMWIomSHf?oFe]Kodm?Com3@d0?o
cLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03
olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@
0oo=cLd01?o@d=3odm?ComOGeooHf=SoomWIf@_ofMWI0_oHf=P01_oFe]Ko
dm?Com?CdooDe=CoemOGomSHf0;ofMWI00?of=SHomWIfOoIfMT00_oHf=P9
omWIf@03omSHf?oIfMWofMWI00;of=SH00?ofMWIomSHf?oGemL00_oHf=PG
omWIf@04omSHf?oFe]Kod];Bolo?c`;ocLg=00Coclo?om?CdooGemOof=SH
oooIfMU5omWIf@03omSHf?oIfMWofMWI00KofMWI0OoNg]h1onKViP7ok>c/
00001oo^k^kojNWYonCTi?oPh>3ohN7Qon3Ph?oRh^800_oQhN403OoNg]ko
g=cLom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooO
gml02OoQhN403OoOgmoofm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k
^oo7alOodm?Com_KfooOgml02OoQhN403OoOgmoofm_Kom?Cdoo7alOo^k^k
ok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml0oooQhN4:on7Qh@09
on3Ph?oOgmoofm_KomKFe_oDe=Coe]KFom[Jf_oNg]koh>3P00KogmoO0ooP
h>000ooOgmooh>3Pon3Ph002on3Ph0SogmoO0_oNg]h2omoOg`?oh>3P0_oO
gml2on3Ph0;ogmoO3OoPh>001OoOgmoogMgMomWIfOoEeMGodm?C00;od];B
00?oe]KFomcLg?oPh>00oooQhN57on7Qh@03on;Rh_oQhN7oh^;R00CohN7Q
0OoTi>@1onWYj@7okNg]00000oo`l?3okno_oo7al@02oo3`l0;okno_0?oo
l?3`onk^k_oXj>Sofm_Kol71`OnTY:CoS8b<og]kNomgMgOoNg]kohb<S?nT
Y:Co`/;1om[Jf_oZj^[okNg]oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<RomkNg_oMgMgog]kNon<S8coY:BT
ol;2`_oJf][oj^[Xong]kOoalO7okno_oo7alOo_knoolO7aono_kooalNoo
kNg]on[Zj_oJf][o`/;2ojBTY?n<S8coNg]kogMgM_mkNg_oS8b<ojBTY?o2
`/;of][Jon[Zj_o]kNgolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO4004kokno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knool?3^ong]
kOo/k>coiNGUon;Rh_oOgmooiNGUonWYjOo]kN/2onSXj006onKVi_oYjNWo
inOWon_[joo/k>cok^k/0ooZj^X02Oo_knook^k^onk^k_oXj>Soj>SVonKV
i_oYjNWoinOWon[ZjP02onWYj@0=onGUiOoWinGoinOWon_[joo/k>cokno_
on_[jooZj^[ojNWYonk^k?o/k>cojn_[onSXj002ong]k@0Donk^k_oZj^[o
k>cZonc/k?o^k^koj^[Zonc/k?o]kNgok^k^on[Zj_o/k>[ok>c/onk^k_n]
[JgoMgMgoeUIFOm_Kfoo][Jfon7Qh?oWinL2ono_k`3ooo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
k^k^oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7a001<ono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7ol?3`ono_koo`l?3okno_oo3`l?o_
knool?3`ono_k`Col?3`00000oobl_;ok^k^onOWi`04onGUi@0@onCTi?oO
gmoodM7Aok6a/On:RX[oIFEUoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:
ROna/K7odM7AomkNgP;oi>CT00?oiNGUonCTi?oUiN@00_oTi>@03ooNg]ko
dM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na
/K7odM7@omkNgP02onCTi03oonGUiOoTi>CoiNGUonCTi?oTi>?og]kNom7A
dOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6a
om7AdOoNg]koi>CSonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGU000WonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTon?Shoo6a/Ko
:2PXodE5AOn?Shood];Bom_KfooLg=_oe]KF00?oeMGE00coe=CDom[Jf_oO
gmoogmoNomWIfOoEeMGof=SHomoOgooQhN7ogMgMomKFe_oEeM@2omGEe@0;
omCDe?oIfMWof][JomSHf?oEeMGoe]KEomKFe_oIfMWogMgMon3Ph?oKfm/0
0_oFe]H02OoMgMcog=cLomSHf?oEeMGog=cLon3Ph?oOgmoof][Jom_KfP02
omgMg@3oomWIfOoLg=cogmoOon3Ph?oKfm_of][IomgMgOoPh>3oLg=cofQX
J?n=SHgoE5ADo`P82?nSXj;ofm_Kon?ShooTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGohn?SonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoShn?oiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT001FonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>@4onGUi@06onCTi?oUiNGoiNGUonGU
iOoXj>Sok>c/0Oobl_800003ooCdm?o]kNgoinOW00?oh>3P01;ogmoOomkN
g_oBd];o];BdohN7QomKFe_oKC/eoii>@_o=KeoojH=_ole_GonNCT?oKC/f
oeaLG?n7QhOo];Bdom;Bd_oNg]h5on3Ph00AomkNg_oBd];o];BdohN7QomL
G5coKF0/oijF;_o=cCoojNU=olg=?onNVRooKF<]oeaLG?n7QhOo];Bdom;B
d_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLodMW;_mXWS?oTLe7
oj[YEOnAcDOoJYhdodUZ;omLG5coQhN7okBd]?oBd];og]kN0?ooh>3P2OoP
h>001_oOgmooclo?oiVIVOnBTY;o6ATIohb<S0;oeMGE01ooclo?ol;2`_o>
c/koc/k>olG5aOo:b/[of][JomSHf?o@d=3obl_;olo?cooHf=Sof][JomGE
eOo?cloo`L71om3@d?o>c/koa<C4ol_;booHf=SoemOGokjn__nk^k_odM7A
om3@d?oEeMGof=SHom?Cdoo<c<coc/k>00;oeMGE00Goc/k>olc<c?oCdm?o
f][JomSHf002om;BdP04omSHf?oGemOodM7Aom?Cd`;ofMWI00Kodm?Com7A
dOoGemOof=SHom7AdOo@d=02om7Ad@04odI6A_m1@D7oemOGomkNgT7oh>3P
00?ogmoOon3Ph?oPh>00oooPh>01on3Ph003omoOgooPh>3ogmoO00;ogmoO
0ooPh>000ooQhN7oinOWonc/k001ooCdm00000?om_Kfoo;bl_o[jn/00ooX
j>P04ooWinOoh^;Rolg=cOnOWiooJemOohlf;_o]LF7onIf@oofaYOom_:oo
oKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;Rh_oWinL00ooXj>P04ooW
inOoh^;Rolg=cOnOWiooKVIOoi=b8_o]dDConO=doogmSOomoIGooOf>ooWh
M_o]edOoTg<RofiWGonOWioocLg=on;Rh_oWinL00ooXj>P04ooWinOoh^;R
olg=cOnOWiooH6QOod]l8onBhD_o_OUkom3mT_oHoI_oe?fEol3iO_nHj4go
CH0Tof1YGonOWioocLg=on;Rh_oWinL0oooXj>P:onSXj004onKVi_oQhN7o
GEeMode=C@;ogMgM01ooD51@o`L71olE5AGoQ8B4oaHF5_m3@d?oh^;RomgM
gOnLW9co0000ohn?SooMgMgohN7Qom_Kfom0@43o20P8oaTI6On8R8So2`/;
oeQHF?ng]kOo30`<o`L71olS8b?o9bLWogemOOoJf][ogMgMomCDe?l;2`_o
FEUI00;ofMWI00?oGEeMo`/;2ooCdm<00_oOgml01_mJFU[oCTi>omkNg_oN
g]ko8b<SohB4Q0;ohN7Q00coNWYjobh^;_oMgMgogMgMol;2`_m@D53o<c<c
ofi^K_n3Ph?o8B4QomkNg_oVi^KoonSXj4koj>SX0Oo/k>`1oo;blP7om_Kf
00006OogmoOon?ShooShn?ohn?SomoOgooShn?ogmoOok^k^olk>c_n@T93o
QBl[onUTE_ojTXOooZJKoojaYOoo^:_oo[>VoojXW?okU8WokVQIohTa:on@
T93oc/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93oVFT[oo2m
?Ookh6koo_B2ooknR_oooi;oo_j<ookhPookiG3ol<8noiUZ:on@T93oc/k>
onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93o@W<[ohC>@on]kg?o
`_j8olknT?oFoiOod?jBolKnROnbmGCoR==3odAe:on@T93oc/k>onk^k_og
moL0ooohn?P:ooShn00UooKfm_oalO7oPH61oalO7oo]kNgoa/K6o`000?o3
`l?odm?CoeaLG?l820Soj^[Zoo3`l?oZj^[oDU9Boa@D5?lm?CgojNWYoo3`
l?n_[joo1`L7om;Bd_o=cLgoCTi>oa/K6oo^k^kofm_Kojj^[_oXj>Sok>c/
ojj^[_l0003o];Bdonc/k?n`/;3o2`/;oaXJ6P02onCTi00;ob<S8ol>3Pko
Y:BTong]kOo^k^koH61PoeADE?o^k^kokNg]obHV9_n=SHd00_o`l?003?n2
PX;o<C4aonc/k?oZj^[o@d=3obl_;onLW9coLg=cobXZ:_lJ6Q[ok^k^ooKf
mS[on?Sh00?omoOgooShn?ohn?P01Oohn?P00oogmoOon?ShooShn00booSh
n003ooOgmoohn?Son?Sh0<con?Sh00?omoOgooShn?ohn?P00_ohn?P01?og
moOonOWiooOgmoofm_H1ooShn00000?on_[jooGemOo^k^h00_o/k>`0ooo[
jn_ojNWYomoOgoni^KWoNE9Boklb9?oWM6WooHUnoonHS?onXYKoojRLoojT
V?ooVXgooXYoonifJ_o3<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/
on[Zj_oOgmoo^[ZjohQUD_oRTAconL=@oogJHooojW;oo_=nooojP_onmWoo
onacookNI?ojae7ohY8LohUVDonj^[[ogmoOon[Zj_o[jn_ok>c/on_[jooZ
j^[ogmoOokZj^_mBKE;oDJ<Loi7BEOnVif[o^?Ujol3nP_o7ohWo`oj4okWm
NonWk6coU=IGoe:V7?mBKE;o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k000M?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[on[Zj_oTi>CoNWYjoa`L7?oRh^;obl_<o`<30onOWioo
gmoOoiBDU?lC4a?oh>3Pon7QhOo@d=3o1PH6oj6QXOl92@Wo_[jnon;Rh_ni
^KWo0P82ok6a/_oNg]koP820obTY:OoRh^;oj>SXonCTi?oOgmoof][KomCD
e?l820SoQXJ6omoOgomZJV[oBDU9ocDe=On/[:go_[jno`L71omhN7SoEEEE
0_oOgml01_mKFe_oCdm@on;Rh_oPh>3o92@TohB4Q0;oh>3P0?ooNg]kobl_
;ooQhN7oe=CDo`D51OnWYjOoi>CTon;Rh_moOgoo5ADFon;Rh_oYjNWok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>`0053ojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k0Oojn_[00Gok>c/on_[
joo[jn_ok^k^ooKfmP01ooWin@0000?ono_koo?cloo]kNd00_oUiND0oooV
i^Kohn?SomWIfOnb/[;oNBh^olQ2=?oSJUcolgU/oof8O?onUh[ooY^>oojH
RoonRWkom7]]onM[GOo:@SCoNbh^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGV
onCTi?oHf=So/[:boiIE;_oZW2_onka4ook<Doomf6;oo^=bookYMOoniW?o
o]]Uoog<Dook`DGokYh[oiUF;_nb/[;of=SHonCTi?oUiNGoi^KVonGUiOoT
i>Cof=SIok:b/_l^HRkoHjd[ohO:B?nGg5WoYNEYok;cMonhmW_o]?EiojOZ
JonHg5WoRLm;of>^:ol^Hbko/[:bomSHfOoTi>CoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUiP00EOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonCTi?oNg]koMgMgoa/K6ooLg=coh>3QoijNW_l^;Rko
:b/[oc8b<_lB4Q800_oKfm/09On4Q8Co8B4QomoOgomCDe?oIfMWom_KfooM
gMgoT92@obTY:_l_;boo;2`/obPX:?oMgMgogmoOomSHf?oCdm?oclo@oe]K
Fol0003o_[jnomWIfOlX:2SoQXJ6ogQhN?mXJ6SoPX:2oc`l??o3`l?o3`l?
omGEeOoIfMWoFEUIodi>C_oMgMgog=cLob<S8on1PH400_oFe]H0QomgMgOo
;Rh^omgMgOnRXZ;o0000olK6a_oIfMWof=SHohj>S_lE5AGogMgMon?ShooV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKViP02onGU
i@37onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUi@02onKViP03onGU
iOoVi^Koi^KV00?oi^KV00?oiNGUong]kOoclo<00Ookno/00003ooclo?oh
n?SolO7a00?ok^k^01?ojn_[on7QhOnl_;coNQLGol<o<_oBEDSoi6QJonmg
K?odPgWon8MlooF4N_ocNFgoiFUKomUHB_o4?c;oO1LGokbl_?oQhN7ok>c/
00?ok^k^01?ok>c/on7QhOnl_;coYDLGonJG<_oe[33ooKa1oog9Doomd63o
nm=UoogBH?oncECooKe2ooZ_<_oYVc;oYDHGokbl_?oQhN7ok>c/00?ok^k^
01?ok>c/on7QhOnl_;co5eTGoenX<_mf_COoQ/e7oiKFF_nRh6GoXn1Yoj?Q
IonGfUcoQ/i7ogNo=omOZc;o5eTGokbl_?oQhN7ok>c/0?ook^k^2_o^k^h0
;_o/k>coinOWog]kNolL71coi>CTonWYjOoVi^KohN7QomkNg_n=SHgo51@D
onKVi_oTi>Co=CDeogUiNOo[jn_o/[:boaDE5OoOgmooi^KVonCTi?oQhN7o
gMgMogYjN_lY:BWoj>SXonGUiOoMgMgo/K6aobHV9_l;2`_oVi^KonWYjOo<
c<co0000olk>c_o3`l?o9BDUod];BomlO7coj>SXoc4a<OnUYJGoi>CToeeM
GOmADE42onOWi`0:obDU9OmYJFWogmoOomoOgomgMgOo<C4aonWYjOo1`L7o
0000ojNWY`;ogmoO00CoTi>CoaHF5_oWinOok>c/??o^k^h00oo]kNgok^k^
onk^kP02onk^kP03ong]kOo^k^kok^k^0?ook^k^2Oo^k^h00oo]kNgol_;b
ooShn001ooclo0000oomoOd05_olo?cooOgmoogmoOolo?colo?com7AdOmX
1`Oo^3@dolLo<ooBD4?ofV9Eon=^H_oTLVCoi6mRomaTEooCDD?oc44dokTd
=?m[1`Ood];Boo?cloolo?`3oogmo@0Cooclo?oclo?od];Boih[1ooJRSCo
ji/IooFX:Ooh]3oonKe:ooRoCOoj_d[onKPoooJZ:_o_WQWofh/doj8]1ooB
d];olo?cooclo003oogmo@0Cooclo?oclo?od];Bo`M01om=VSCoGj/Pog2h
;omo`d?oR/e@ohg=D_n:cU3oPLM4og6i;omR[R3oCY/do`M21ooBd];olo?c
ooclo03ooogmo@[ooOgm02?ono_kooOgmon4Q8Co7QhNoo?clooinOWo/k>c
om3@d?oclo?oJ6QXodM7AooinOWoe=CDo`000?oMgMgoo?cloo_knolW9bOo
Z:RXooWinOn[Zj_oeMGEoo7alOmDE5CoGUiNooWinOodm?CoU9BDo`D51Om0
@43odM7AooOgmoohn?SoUiNGob/[:`02oo[jnP0Kob@T9?l71`Oob<S8oo_k
non5QHGoHf=SooOgmomSHf?oEeMGooShn?oinOWo9bLWoaDE5On3Ph?oemOG
od92@_mSHf?ono_koo[jn_ld=3CoBDU9om_KfooUiNGoCdm?oaLG5oojn_[o
o?cl0?oooOgmBoomoOd00oolo?cooOgmooclo003oogmo@0003[ooOgmoo[j
n_oclo?ok^k^oo3`l?o_knook^k^onWYjOoCdm?oFQ`Loj8d=?nd:1go`CT/
olM9??o?ET[od5M;om1GB_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[o
k^k^oo3`l?o_knool?3_onk^k_oZj^[odm?Coh`U7Oo8LCCofH@MonBD5OoW
WBCokZPcoo2Z=?o_ZS?ok:0UonNG5OoLR1gob74doh`U7OoCdm?oj^[Zonk^
k_o`l?3okno_oo3`l?o^k^koj^[Yom?CdolM>1go=88dodNE7OmJYA_oJJdZ
0_md^3P0oome^CSoJk4[oe^W7?m8VQgo=88doadh7OoCdm?oj^[Yonk^k_o`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`00>_o`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3ok^k^on_[jommOGgo71`LonOW
ioo^k^goR8R8oc0`<?l>3Pko<C4aok2`/?o_knooQ8B4ode=COo^k^kokno_
onk^k_n:RX[oFEUIono_komhN7So;2`[o`h>3_lh>3So_[jnonk^k_oShn?o
3Ph>ofUYJOoPh=ooh^;RonKVi_oZj^[oHF5QogIfM_o_knook^k^ogMgM_lV
9RH2onk^kP0Folg=cOl/;2cojn_[ofa/K?mSHf;ojn_[onk^k_lj>S[oU9BD
of9RH_l>3Pko=3@dolC4a?o^k^kokno_om7AdOll?3co2PX:obLW9om/K6co
;2`/onk^kP;okno_0?ool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3ok^k^oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o^k^kol?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?00
04Gokno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knl00_o`l?06ono_k`7olo?c0Oohn?P1ooknoP0000?oo_knooOg
moo`l?000_oYjNT04ooXj>SojNWYonKVi_oKfm_oHd];oh4b<_nV=3Co]S@]
ol9=@Oo3E4Woa5E:ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooWinL0
1OoYjNT04OoWinOofm_KohU;Bon_Bc;ocGLeomJ;;OoPW2koh:0bon6P=?oP
X3;ogiX^omJ;;Oo:MCGo[d/bohU;BooKfm_oinOW00GojNWY017oinOWom_K
fom;Bd_o<V0bocZ9=OmCVbgoJj/_og2]>?m_[S[oL:dhofZZ;omCVbgo>HPe
oc9P<_m;Bd_ofm_KonOWi`3oonWYj@_ojNWY00Koj>SXonKVi_mkNg_o71`L
onCTi?oXj>P2onWYj@03onOWiooYjNWojNWY00_ojNWY00coinOWonWYjOoY
jNWoj>SXomSHf?l:2P[o[Zj^omcLg?oNg]koh>3PonGUiOoXj>P8onWYj@06
onSXj?oVi^Kohn?Son?ShooVi^Koj>SX0ooYjNT00ooXj>SojNWYonWYj@04
onWYj@03onOWiooYjNWojNWY07[ojNWY00?oj>SXonWYjOoYjNT00ooYjNT0
0ooXj>SojNWYonWYj@36onWYj@03onSXj?oYjNWojNWY00CojNWY0Oo`l?01
ooOgm`7oo_kn00001?ono_kon_[jooCdm?o_knl3oo3`l00Aono_koo[jn_o
UIBDodlS8onEE5Co^g=com>EUOoJW9cofYjLomVLW?oDUIGo^g=coiEDE?m?
8b?oUIBDon[Zj_o_knl01Oo`l?004Oo_knooj^[ZojVDU?n18b?o^VYDomBJ
LooT_9Goj/NLonW7W?oZaicoiKbEomBJLonkJUCoPB<SojZDU?oZj^[okno_
00Gol?3`017okno_on[Zj_nDU9Co8bXSoeAjE?mcYG?oW/JEojc>W?n]cYco
[<jLoik6UOmcYG?oE7YDob<Z8onDU9Coj^[Zono_k`3ooo3`l0_ol?3`0_o_
knl01?n0P83o7AdMonk^k_o_knl5oo3`l003ono_koo`l?3ol?3`00_ol?3`
0_o_knl01omTI6Co:BTYoh61POmSHf?o>c/konk^k_o_knl02?o`l?001_o_
knook^k^og=cLomYJFWok^k^ono_kd_ol?3`0_o_knoooo3`l0ool?3`00Co
lO7aoo3`l?odm?Con_[j0Oono_h00004ong_l_ooooooooooooknoP;ooooo
0_ono_h0ooomoOgomoOgofi^K_mJ?coo/I2@omk9bOo`i>ColnKVoo3Ti?oN
bLWo/I2@oeXo?om]KFgon?Shooclo?ooooooo_knooooooono_koooonookn
o_ooooooo?clooShn?n=KFgoRSloolVAT?oYd<Wom>WTooK[i_odjNCojM39
olVAT?n9?cooSFe]ooShmoolo?coooooookno_ooooooo_knooooooono_ko
ooonooclo?ohn?SoKFe]oclo?on@WI3obMG9onC/i?oVk^Koi>cTolWEbOn@
WI3o?cloofe]KOohn?Soo?clooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooooknoP00Aooooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_kooooo00;oo_kn01Soclo?ojJVY_omoOgoooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooool2ooknoP0>ol30`?maLG7oP820ok2`
/?omoOgoooooookno_ooooooo_knooooo_ono_koooooookno_ooool2ookn
oP3ool71`Onm_KcooOgmooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_kn001Looooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooooono_h2
ooooo`03ookno_oooooooooo00?ooooo0Oojn_/00004olC<doono_kon_[j
oo?cl`GolO7a00gokno_omKFe_m[Jf_o@cdmoi^<S?o6^[[oe/c<olNj^_nK
S8co@cdmof][JooFe]Kokno_00WolO7a00gokno_omOFe_n3Jf_oM3dmokF<
S?oE^[[ohLc<omJj^_nfS8coLSdmoh5[JooGe]Kokno_00WolO7a00gokno_
omKFe_m[Jf_o?Cdmohb<S?nj^[[oc<g<okZj^_n<S8co?Cdmof][JooFe]Ko
kno_0?oolO7a5_oalO400oo`l?3olO7aoo7al@0Aoo7al@03oo3`l?oalO7o
lO7a09golO7a00?ol?3`oo7alOoalO40a?oalO401?o`l?3olO7aoo7alOo`
l?04oo7al@03ooCdm?ojn_[oo_kn007ojnk_00005On:V:?ooOgmooShn?o`
l?3ojn_[on[Zj_oYjNWoj^[ZonWYjOoZj^[ojNWYonSXj?nKVi_oFEUIobHV
9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoX9^K
ofYIFOm39RKo;@T9od8V9_mYFEWoX9^KonSXj?oYjNT02ooZj^X02ooYjNWo
j>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY0?ooj^[Z
:_oZj^X00ooYjNWoj^[Zon[ZjP2Lon[ZjP03onWYjOoZj^[oj^[Z0<goj^[Z
00Cojn_[oo3`l?ohn?SooOgm0Oo?d]H00004od5@G_nla/gon_[joo?cl`So
lO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`l?0?oo7al@;o
l?3`0oo_knl2oo3`l?oolO7aoooalO6Hoo7al@03oo3`l?oalO7olO7a00;o
lO7a00?omOGeoo[jn_oYjnd00OnKWj800003obDlC_mAHg3o^lG<0?oooooo
oooooooJooooo`7okNoa0On//;@1ojN//00000Ko:D1Gob8iC?lhBUWoQY6M
ol78c_o/k_3oooooooooooooe?ooool01OohnO[ok>k_om7DeonKWj?oWJ>W
007o/kZo0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{734, 424},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(aquaButtons = {\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<Aqua/GrapeButton.JPG\>"]], \
\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<Aqua/GraphiteButton.JPG\>"]], \
\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<Aqua/BlueberryButton.JPG\>"]], \
\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<Aqua/BondiblueButton.JPG\>"]], \
\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<Aqua/LimeButton.JPG\>"]], \
\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<Aqua/TangerineButton.JPG\>"]], \
\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<Aqua/StrawberryButton.JPG\>"]], \
\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<Aqua/GrayButton.JPG\>"]]\
\[IndentingNewLine]}\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject112126983143425], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject43348735819777], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject105017503645697], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject40394888839169], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject140173539016705], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject91890103877633], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject84774601359361], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject121275380924417]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(icons = {\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<MonaLisa.gif\>"]], \
\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<DonauCruise.gif\>"]], \
\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<RaceAtLinz.gif\>"]], \
\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<ToyStoryCoffee.gif\>"]], \
\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<Scull3D.GIF\>"]], \
\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<KumamotoCastle.jpg\>"]], \
\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<SunsetOfKasadoIsland.jpg\>"]], \
\[IndentingNewLine]NewImageIcon[
          StringJoin[$JavaSwingMaterial, "\<FromTheSkylonTower.gif\>"]]\
\[IndentingNewLine]}\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject115021774323713], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject982708649985], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject50351478669313], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject13776527032321], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject28977758470145], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject77673174925313], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject113025503723521], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.ImageIcon"] \[RightGuillemet]\),
          JLink`Objects`JavaObject86018262827009]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(tabbedPane = 
      NewJTabbedPane[pane, javax`swing`JTabbedPane`LEFT]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JTabbedPane"] \[RightGuillemet]\),
      JLink`Objects`JavaObject5149313466369]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(names = {\[IndentingNewLine]"\<Mona Lisa              \>", \
\[IndentingNewLine]"\<Donau Cruise           \>", \[IndentingNewLine]"\<Race \
At Linz           \>", \[IndentingNewLine]"\<Toy Story Coffee       \>", \
\[IndentingNewLine]"\<Scull 3D               \>", \
\[IndentingNewLine]"\<Kumamoto Castle        \>", \
\[IndentingNewLine]"\<Sunset Of Kasado Island\>", \[IndentingNewLine]"\<From \
The Skylon Tower  \>"\[IndentingNewLine]}\)], "Input"],

Cell[BoxData[
    \({"Mona Lisa              ", "Donau Cruise           ", 
      "Race At Linz           ", "Toy Story Coffee       ", 
      "Scull 3D               ", "Kumamoto Castle        ", 
      "Sunset Of Kasado Island", "From The Skylon Tower  "}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(labels = 
      Table[\[IndentingNewLine]NewJLabel[Null, names[\([i]\)], 
          icons[\([i]\)]], \[IndentingNewLine]{i, 1, 
          Length[names]}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.JLabel"] \[RightGuillemet]\),
          JLink`Objects`JavaObject10463026872321], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.JLabel"] \[RightGuillemet]\),
          JLink`Objects`JavaObject63689247948801], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.JLabel"] \[RightGuillemet]\),
          JLink`Objects`JavaObject55262186569729], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.JLabel"] \[RightGuillemet]\),
          JLink`Objects`JavaObject70702275231745], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.JLabel"] \[RightGuillemet]\),
          JLink`Objects`JavaObject56740158636033], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.JLabel"] \[RightGuillemet]\),
          JLink`Objects`JavaObject79424447840257], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.JLabel"] \[RightGuillemet]\),
          JLink`Objects`JavaObject811446829057], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.JLabel"] \[RightGuillemet]\),
          JLink`Objects`JavaObject123399158366209]}], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(Do[\[IndentingNewLine]labels[\([i]\)]@
          setHorizontalTextPosition[
            javax`swing`JLabel`CENTER]\[IndentingNewLine]labels[\([i]\)]@
          setVerticalTextPosition[
            javax`swing`JLabel`BOTTOM], \[IndentingNewLine]{i, 1, 
        Length[names]}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[{
    \(labels[\([1]\)]@
      setText["\<Kama's smile reminds us Mona Lisa:-)\>"]\), "\
\[IndentingNewLine]", 
    \(labels[\([2]\)]@
      setText["\<IMS'99 had been over. Then I was free!\>"]\), "\
\[IndentingNewLine]", 
    \(labels[\([4]\)]@
      setText["\<Toy Story had an influence even on a coffee shop in \
Korea!\>"]\)}], "Input"],

Cell[BoxData[
    \(Do[\[IndentingNewLine]tabbedPane@
        addTab[names[\([i]\)], aquaButtons[\([i]\)], labels[\([i]\)], 
          names[\([i]\)]], \[IndentingNewLine]{i, 1, 
        Length[names]}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[{
    \(\(JavaShow[frame];\)\), "\[IndentingNewLine]", 
    \(frame@repaint[]\)}], "Input"],

Cell[BoxData[
    \(frame@pack[]\)], "Input"],

Cell[BoxData[
    \(tabbedPane@setTabPlacement[javax`swing`JTabbedPane`LEFT]\)], "Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Table[tabbedPane@getTitleAt[i], {i, 0, Length[names] - 1}]\)], "Input"],

Cell[BoxData[
    \({"Mona Lisa              ", "Donau Cruise           ", 
      "Race At Linz           ", "Toy Story Coffee       ", 
      "Scull 3D               ", "Kumamoto Castle        ", 
      "Sunset Of Kasado Island", "From The Skylon Tower  "}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[BoxData[
    \(tabbedPane@setEnabledAt[3, False]\)], "Input"],

Cell[BoxData[
    \(tabbedPane@setEnabledAt[3, True]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(Do[\[IndentingNewLine]ReleaseObject[
        aquaButtons[\([i]\)]], \[IndentingNewLine]{i, 1, 
        Length[aquaButtons]}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(Do[\[IndentingNewLine]ReleaseObject[
        icons[\([i]\)]], \[IndentingNewLine]{i, 1, 
        Length[icons]}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(Do[\[IndentingNewLine]ReleaseObject[
        labels[\([i]\)]], \[IndentingNewLine]{i, 1, 
        Length[labels]}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(DeleteJObject[pane, tabbedPane]\)], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["<<< SimpleJTabbedPane >>>",
  FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;K0001VAP00`40o`00
0?l0003oo`000?l0003M000000000hS0^4R@R4R@R03oB928odR@R=U8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^=R8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;SHR<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c1[<c<coIVIV^fIVIP:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<
6/c<c003ooooc<c<c<c<0?o<c<bgc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0olc<c;O<c<`016IV
IXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<
c<c<c03oc<c<]lc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;Soc<c<6/c<c003ooooc<c<c<c<0?o<c<a2c<c<00<0003<c<c<c<`0L/c<
c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003
ooooc<c<c<c<0?o<c<a2c<c<0P0007?<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01]c<c<0P0000?<
c<`200000/c<c0D000000lc<c00000000002c<c<0P0000;<c<`200000/c<
c0D00005c<c<100000K<c<`400000/c<c0800002c<c<0P0000;<c<`20000
00C<c<`00000003<c<`200000/c<c0@00005c<c<0P0000C<c<`400000/c<
c0800002c<c<0P0000;<c<`2000000C<c<`00000003<c<`200000/c<c080
0002c<c<0P000003c<c<0000000000;<c<`400001/c<c08000000lc<c000
00000002c<c<100000G<c<`200000/c<c0030000c<c<c<c<00800002c<c<
100000;<c<`200000/c<c0800002c<c<1@0000C<c<`6000000?<c<`00000
00000/c<c0@00003c<c<1@000003c<c<0000000000K<c<`00`000<c<c<c<
c01ac<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`J
c<c<00?oooo<c<c<c<`0KLc<c0800003c<c<0P000003c<c<0000000000;<
c<`2000000?<c<`0000000000/c<c0800002c<c<0P000003c<c<00000000
00;<c<`200001<c<c0800002c<c<0P0000C<c<`200000/c<c08000000lc<
c00000000002c<c<0P0000;<c<`2000000C<c<`00000003<c<`2000000?<
c<`0000000000/c<c0800004c<c<0P0000?<c<`200000/c<c08000000lc<
c00000000002c<c<0P0000;<c<`2000000C<c<`00000003<c<`200000/c<
c08000001<c<c00000000<c<c0<000000lc<c00000000002c<c<0P0000C<
c<`2000000G<c<`000000000003<c<`00P0000;<c<`200001<c<c0800000
1Lc<c000000000000<c<c002000000?<c<`0000000000/c<c08000000lc<
c00000000002c<c<0P000003c<c<0000000000;<c<`200001<c<c0800005
c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c080
00000lc<c00000000006c<c<0P0007;<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01]c<c<0P0000;<
c<`200000/c<c0800002c<c<0P000003c<c<0000000000;<c<`200000/c<
c08000000lc<c00000000002c<c<0P0000O<c<`300001lc<c0<000000lc<
c00000000002c<c<0P0000;<c<`2000000C<c<`00000003<c<`2000000?<
c<`0000000002<c<c0800003c<c<0P0000G<c<`200000/c<c0800002c<c<
0P000004c<c<00000000c<c<0P0000;<c<`2000000?<c<`0000000000/c<
c0800004c<c<0`0000C<c<`200000/c<c0800004c<c<0`0000C<c<`20000
00G<c<`000000000003<c<`00P000003c<c<0000000000;<c<`2000000?<
c<`0000000000/c<c08000000lc<c00000000002c<c<0P0000C<c<`20000
1Lc<c0800004c<c<0`000003c<c<0000000000;<c<`200001<c<c0<00002
c<c<0P0007;<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
olc<c1[<c<`00oooolc<c<c<c01]c<c<0P0000;<c<`200000lc<c0800000
1<c<c00000000<c<c0800002c<c<0P0000;<c<`200000/c<c08000000lc<
c00000000005c<c<100000K<c<`400000/c<c0800002c<c<0P0000;<c<`2
000000C<c<`00000003<c<`2000000?<c<`000000000100000C<c<`20000
0lc<c0H000000lc<c00000000002c<c<0P0000;<c<`2000000C<c<`00000
003<c<`200000/c<c08000000lc<c00000000002c<c<0P0000;<c<`40000
1Lc<c0800002c<c<0P0000;<c<`400001Lc<c08000001Lc<c0000<c<c000
0<c<c002000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<
0P0000;<c<`2000000?<c<`0000000001<c<c0800005c<c<0P0000;<c<`4
00000lc<c08000000lc<c00000000009c<c<0P0007;<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01]
c<c<1P0000C<c<`4000000?<c<`0000000000/c<c0800002c<c<0P0000?<
c<`400001<c<c0<00007c<c<0`0000C<c<`200000/c<c0800002c<c<0P00
0004c<c<00000000c<c<0P000003c<c<0000000000;<c<`200001<c<c080
0003c<c<0P0000;<c<`2000000?<c<`0000000000/c<c0800002c<c<0P00
0004c<c<00000000c<c<0P0000;<c<`2000000?<c<`0000000000/c<c080
00001<c<c0000000000000O<c<`200000/c<c08000001<c<c00000000000
00O<c<`2000000G<c<`0003<c<`0003<c<`00P000003c<c<0000000000;<
c<`2000000?<c<`0000000000/c<c0800003c<c<100000C<c<`200001Lc<
c08000001<c<c0000000000000K<c<`400002Lc<c080001bc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<
c<`0KLc<c0D00003c<c<00@0003<c<c<c<c<c<`2000000G<c<`000000000
003<c<`00`000005c<c<00000000c<c<000000?<c<`200001<c<c0800002
c<c<0P0000C<c<`200000/c<c08000001Lc<c000000000000<c<c0030000
00C<c<`00000003<c<`2000000C<c<`00000003<c<`200000/c<c0800004
c<c<0P0000?<c<`200000/c<c08000001Lc<c000000000000<c<c0030000
00C<c<`00000003<c<`2000000G<c<`000000000003<c<`00P000004c<c<
00000000c<c<0`000003c<c<0000000000;<c<`200001<c<c0800002c<c<
0P000003c<c<0000000000;<c<`200001<c<c0@000000lc<c00000000002
00000/c<c0030000c<c<c<c<008000001Lc<c000000000000<c<c0020000
00?<c<`0003<c<`00/c<c0800004c<c<0P0000G<c<`2000000?<c<`00000
00000/c<c08000000lc<c0000<c<c002c<c<0P000003c<c<0000000000K<
c<`20000L/c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;So
c<c<6/c<c003ooooc<c<c<c<06g<c<`2000000?<c<`0000000001<c<c0@0
0002c<c<0P000003c<c<0000000000;<c<`200000lc<c0@00002c<c<0P00
00;<c<`400001/c<c0@00002c<c<0P000003c<c<0000000000;<c<`20000
0/c<c08000000lc<c00000000002c<c<100000G<c<`400000/c<c0@00002
c<c<0P000003c<c<0000000000;<c<`200000/c<c08000001<c<c0000000
0<c<c0800003c<c<0P000003c<c<0000000000;<c<`400001Lc<c0800002
c<c<0P0000;<c<`400001Lc<c0@000000lc<c0000000000200000/c<c0@0
0002c<c<0P000003c<c<0000000000?<c<`400001Lc<c0800005c<c<0P00
00;<c<`400000lc<c0@00002c<c<0P0000K<c<`00`000<c<c<c<c01ac<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?o
ooo<c<c<c<`0KLc<c0800002c<c<0P0001_<c<`200008<c<c080000`c<c<
0P0001c<c<`300000lc<c0<0000Ic<c<0P0001g<c<`20000Llc<c004IVIV
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<
c<c<06g<c<`200000lc<c080000Jc<c<0P0001g<c<`2000000?<c<`00000
00008/c<c080000<c<c<0P0001c<c<`300000lc<c0<0000Ic<c<0P0000G<
c<`200005/c<c0030000c<c<c<c<07;<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c03oc<c<]lc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003oooo
c<c<c<c<0?o<c<bgc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0olc<c;O<c<`016IVIXS0^8S0^4R@
R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c03oc<c<
]lc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<
c003ooooc<c<c<c<0?o<c<bgc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0olc<c;O<c<`016IVIXS0
^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<
c03oc<c<]lc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;So
c<c<6/c<c003ooooc<c<c<c<0?o<c<bgc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c00>4BHD
2@TD6Q`N2A8:2@T:2@TD2A8:2A`N2@T:2@TD00002@TD00002@T:0P000009
2@T:2A8:000000002@T:2@TD00002@TD2@T:00<000001`TB2P0000T92PT9
2P0000T92P0000022@T:00<92A@000092@X00PT92P0500002@T:00002@T:
000000892@X00`0000T92PT92P03000000<92@X92A@00000100000062@T:
0000000000002@T:00000PT92P0500002@T:000000002@TD00H000022@T:
0P0000032@T:0000000000@000000`T92P0000000002000000<92@X00000
0000600000032@T:0000000000H000000aXB50000000000M000000<A9Qh0
000000007@0000032@T:0000000002h000000b`h:DIED/c<c01Pc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<
c<c<c<`0GLc<c0062A8:6Q8D2A`D2@TD2A`N6PT:0QXB50074BHD2@TD4A`:
6Q8D2A`D2@TD4BHD00892A@02@TL51XB50T950T9514V50TL51XB50T92QXB
50022@TD00D92@X92A@94PX92A@J4Q@00PT92P094A`:2@T:4A`:2A8:2@T:
2@TD2@T:6Q8D2@T:00<94PX010TL50T950TB2PT9508J4Q@01@T951XB50TB
2PTB2PT950022A8:0`T950042A8:2A`D2@TD2@TD0PTB2P0;2@TD2A8:2@T:
2A8:2@T:2@TD2A8:6Q8D2A8:2@T:2@TD00<94PX22@T:0PTB2P056Q8D2@TD
2@TD2A8:6Q8D00<94PX22@TD00<94PX92A@J4Q@00PT950052A8:4BHD2A8:
2@TD6Q8D00892A@010TB2PT950T950TB2P@92A@02PTB2PT951XB50T950TL
7QXB50T950TB2PT951XB50892A@00`TL7QXB51XB50032@TD00l94PX92A@J
4Q@971@92A@971@92A@971@J4Q@92A@J4Q@92A@A9Q@971@92A@00aXB5089
2A@010TB2QXB51XB51XB50892A@011XB50T951XB50TL50892A@01PTL51XB
50T950T92QXB514V50@92A@010TL50T950TB2QXB50892A@00a4V50T951XB
50022@TD00HA9Q@92A@971@J4Q@92A@A9Qh22@TD00DA9Q@92@X971@J4Q@9
71@00PT950062A8:2A`D2@TD2@TD2A8:6Q8D0PT950074BHD2A8:2@TD2@TD
2@T:2A`N6Q8D00892A@01@TB2QXL7PT951XB50TB2P052@TD018J4Q@92A@9
2@XA9Qh92@XJ4Q@971h94PX92A@A70X92A@A9QhA9Q@92A@A70X92@Xd;c=b
LW]Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`J
c<c<00?oooo<c<c<c<`0GLc<c00:6Q8D4BHD2A8:6Q8D4BHD4BHN2@TD4A`:
4BHD2A8:0`T9500A4BHD2A8:6Q8D4A`:2@TD6Q8D2@TD6Q8D6PT:2A8:2@T:
4A`:2@TD4A`:2@TD2A8:4A`:00892@X00`T950T92PT92P022A8:00T92@X9
4PX94PX94PXA70X92@XA70X92A@J4Q@00`TB2P032@T:2@TD2@TD00894PX3
2@TD0PTB2P042@TD2A8:2@TD2A8:0`T9500:2@T:2A8:2A8:2@TD2@T:2A8:
2@T:2A8:2@TD2A8:1PT92P032A8:4A`:2@T:00<94PX010T950TB2PTB2PTB
2P892@X32A8:0`T950032A8:2@T:2@TD00892A@010TB2PT950T92PT950@9
4PX01@T950TB2PTB2PTB2PT92P026Q8D00<94PX92A@94PX00PTB2P892A@2
2A8:0PT950032A8:2A`D2A8:00894PX00`T951XB50T950022@TD00<92@XJ
4Q@92A@00PT950036Q8D2@TD2@TD00894PX010T951XB50T9514L2P892A@0
1Q4L2PT950TB2Q4L2QXB50T950892@X01A4L2QXB50T950TB2QXB50032@TD
00DJ4Q@92A@J4Q@J4Q@92A@00QXB50032@TD6Q8D6Q8D00892A@02QXB50T9
50T950T92QXB50T950TB2QXB50T951XL7P892A@01AXB50T950T950T951XB
50022@TD00<J4Q@971@J4Q@00PT9500=2A8:2@TD2@TD2@TD6Q8D2A8:6Q8D
2A8:2@TD6Q8D2@TD2A`D6Q8D00892A@36Q8D00`A70XJ4Q@971@A70XJ4Q@9
2A@A70X92A@A9QhA70X92A@A9Q@22@TD00LA70X92A@92A@92A@94PXm;ce?
GVH0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<
6/c<c003ooooc<c<c<c<05g<c<`01aXB50TB2PT9514V50T950TB2Q4V5002
2@TD00<A70X92@X92@X00PTB2P032@TD2A8:2A8:00894PX01`T92Q4L2PTB
2Q4V50T9514L2PTB2P042@T:00<A70X92@X94PX00Q4L2P892@X22A8:0`T9
2P092A8:4A`:2@T:2@T:00002A8:2@T:2A8:2@T:00D94PX010T950TB2PT9
2PTB2P<92@X00`T950TB2PTB2P052A8:00@92@X94PX94PX92@X22A8:0`T9
2P032A8:2@T:000000<94PX01@0000TB2P0000TB2PT92P042A8:00<J4Q@9
4PX92@X00PTB2P892@X01`TB2PT92PT92PT950TB2PT92PT950022A8:00H9
2A@92@X94PX92A@94PX92@X32A8:00<92A@94PX92@X00`T92P032A8:2@T:
2A8:00<92@X013d_?@T92PTB2PT92PD94PX00a4L2PT92PTB2P022@T:00HA
70X92@X94PX94PX92A@94PX22@T:00L94PX99RT92@X92@X92A@92@X92A@0
0PTB2P0=2@T:2A8:2A8:2A8:2@T:2A8:2@T:4A`:2@TD6Q8D2@T:2A8:2@T:
00894PX01Q4L2PT950TB2PT950TB2PT92P<94PX00`T92Q4L2PT950022@T:
00D92A@94PX94PXA70X92@X00PTB2P034A`:2@T:2@T:008J4Q@02@T951XB
50TB2QXB50T950T92PTB2PTL50T950022A8:01@92A@94PXJ4Q@J4Q@92A@J
4Q@92A@A70X94PX92A@92@X94PX92A@94PX92A@94PX92A@94PX92A@J4Q@2
2@TD00<J4Q@94PX92A@00PT950062A`D4A`:4BHN0000=2lcCeiVHLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003oooo
c<c<c<c<05g<c<`0314L2QXB50TL514L2PT951XB50T9514L2Q4V50T950T9
2Q4L2P892@X011XB50TB2Q4L2PT92P<94PX22@T:00<J4Q@92A@94PX020TB
2P892@X010TB2PT92PTB2PT92P894PX00a4L2PT92QXB50042@T:00@94PX9
2@X94PX92@X22A8:00H000092A@92@X94PX92@X000022A8:00<92@X00009
4PX00PT92P0:2@TD2A8:2A8:2@T:00002A8:2@T:00002A8:2@T:0PTB2P07
00002A8:2@TD2A8:00002@TD000000894PX22@T:00D000094PX94PX92@X9
4PX00PT92P062@TD2A8:2A8:2A8:00002A8:10T92P@94PX32@T:0PTB2P04
2@T:2A8:2@TD2A8:0`T92P894PX00`T92Q4L2PT92P042A8:0`T92P056Q8D
2A8:00002@T:2A8:00<92@X01`TB2Q4L2PT92PT92PTB2PT92PTB2P022@T:
00@A70X94PX94PX92@X72A8:00@92@XJ4Q@J4Q@92@X22A8:00DJ4Q@A70X9
2@X94PX92@X00PTB2P892@X00`T950TB2PTB2P022A8:00@A70X92@X94PX9
2@X32A8:00D92A@m;cd0000A70X92@X00QXB50<94PX00a4L2PTB2PT92P03
2A8:00@92@X92A@A70X92@X22@TD00@971@A70X92@X94PX22@T:00<92A@9
4PX92A@00PT92P892A@03`TB2PT950T950TB2PT951XB50TB2PTL50TB2Q4L
2QXB50TB2PT92PT9514L2P032@TD00@J4Q@94PXd;bUZNhAQc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<
c<`0GLc<c0032A`D2@TD6Q8D008971@00`T92Q4V50T950032A8:00<92A@A
9Q@94PX00PTB2P064A`:2A8:2A8:2A8:2@T:4BHD0PTB2P054A`:2@TD4A`:
2@TD2@T:00894PX22@T:00<94PX92@XA70X00PTB2P892@X010TB2PT92PTB
2PTB2P892@X32A8:00<000092@X94PX00`TB2P892@X32A8:00<92A@94PX9
4PX00PT92P<94PX00`T950T92PTB2P022A8:00<92A@94PX92@X00PT92P03
2A8:2@T:2A8:00894PX01P0000T92PT92PT950TB2P0000894PX22@T:00<9
4PX92@X94PX02PTB2P032@T:2A8:2@T:00D94PX00`T92PTB2PTB2P032A8:
0`T92P072A8:2@T:2A8:2A8:2@T:2A8:2@T:00894PX22@T:0`TB2P032@T:
2A8:2A8:00894PX22@T:0PTB2P062@T:2A8:2A8:2A8:6Q8D4A`:0PT92P07
2A8:2@T:4A`:2@T:2A8:2@T:2@TD00@94PX22@TD00DA70X94PX92@X92A@A
70X00PTB2P892@X00`T9514L2PTB2P022A8:00@J4Q@94PX92A@J4Q@22A8:
00D92@X94PX92A@J4Q@94PX00PT950062@T:2A8:2A8:2@TD2A8:2@T:0PTB
2P072@TD2@T:6Q8D6Q8D2@T:4A`:2@TD00@94PX00`T951XB51XB50022A8:
00PA70X94PX94PX94PXA70X92A@92@X94PX36Q8D0PTB2P@92A@00`TB2PT9
50T950022@TD00P971@J4Q@94PXA9Q@971@94PXd;bUZLUaQc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<
c<`0GLc<c0076Q8D4BHD2A8:6Q8D2@TD4A`:2@TD00894PX01aXB50T9514V
50T950TB2QXB50T950022A8:0PT92P032A8:2@T:2A8:00892@X00`TB2PT9
2PTB2P022A8:0PT950<94PX010T92PTB2PTB2PTB2P892@X01`TB2P0000T9
2PT92PTB2P0000TB2P022@T:00@94PX92A@000092A@22A8:00<92A@92@X9
2A@00P0000032@T:2A8:2@T:00@94PX03`T950T92PTB2P0000T92PTB2PT9
2PTB2P0000T92PTB2PT92PT950T92PTB2P022@T:00<94PX000092@X00PT9
2P032A8:2@T:2@T:00@92@X00`TB2PT92PTB2P032@T:00<94PX000094PX0
0PT92P042A8:00002@T:2A8:0PT92P<94PX42@T:00@94PX92@X94PX92@X2
2A8:00<92@X94PX94PX00PT92P062A8:2@T:2A8:2@T:2A8:00002PT92P09
2A8:2@T:2@TD2A8:2@T:2@TD2@T:2A8:2@T:00<94PX02`T950TB2PT92PT9
2PTB2PT92PTB2PTL51XB50T92PT950022@T:0PTB2P892@X01`TB2PT950T9
2PTB2PT950TB2PT92P022A8:00<92@X94PX94PX00`T92P042A8:4A`:2A8:
2@T:0PTB2P042@T:4A`:2@TD2A8:10T950892@X32A8:0PT950062@T:2A8:
2@TD2@TD2A8:2@T:0PTB2P892@X01a4L2PT92PTB2PT950T92PT950TB2P02
2@T:0PTB2P892A@42A8:00<92A@94PXJ4Q@00PT950032@T:=2lcJW]_067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`0
0oooolc<c<c<c01Mc<c<00XA9Q@J4Q@971@92@XJ4Q@94PXJ4Q@94PX92@X9
4PX42@T:00@92A@A70X92@X92@X22A8:0PT92P042A8:2@T:2@T:2A8:0PT9
2P894PX01@T92PTB2PT9500000TB2P022@T:00<000094PX92@X00PT92P89
4PX32@T:0PTB2P892@X00`TB2PT92PTB2P032A8:00<92@XJ4Q@92@X00PTB
2P@92@X00`T950TB2PTB2P042@T:00<94PX92@X000000PTB2P032@T:2A8:
6Q`N00892@X22A8:2PT92P032A`N2@T:2@T:00<92@X010TB2PT92PT92PT9
2P894PX32@T:0PTB2P032@T:2A8:2@T:00@92@X00`TB2PT92PT92P022A8:
0PT92P032@TD2@T:2A8:00<92@X010T950T92PT950T92P894PX22@T:00H9
4PX92@X92@X94PX92@X94PX22@T:0PTB2P892@X00`T950T92PT92P092@T:
00@94PX92@X92@X94PX32@T:00<94PX92@X94PX00PT92P052A8:2@T:2@T:
4A`:2A8:00892@X020TB2PT950T950TB2QXB50TB2PT92Q4L2P<92@X01QXB
50T92PT950T950TB2PT950<92@X011XB50T92PTB2PT92P<94PX01PT92PT9
50T950TB2Q4L2PT950892@X02a4L2PTB2PT92PT92PTB2PT92Q4L2PT92PTB
2PT951XB50032@T:1@T950<94PX020T950TB2PT951XB50TB2PT92S@_:EMN
Kf7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<
c<`00oooolc<c<c<c01Mc<c<00D94PXJ4Q@J4Q@971@92@X020TB2P074A`:
4BHD2@T:2A8:2@T:2A8:2@T:00894PX01AXB50TB2PT92PTB2PT92P022A8:
0PT92P052A8:2@T:2@T:2@T:2A8:00892@X00`T950TB2PTB2P022@T:00<9
4PX92@X92@X00PT92P0300002@T:2A8:00894PX00`T92P0000TB2P032A8:
00@92@X92A@94PX92@X42A8:00D92@X000094PX92@X94PX00PT92P070000
2A8:2@T:00002@T:2@TD;1`D00892@X01PTB2P0000TB2PT92PTB2PT92P89
4PX22@T:0PTB2P@92@X00`TB2PT950TB2P022@T:00/94PX92@X92A@94PX9
2@X94PX92@X94PX92@X000092@X00`TB2PH92@X02@TB2PT92PT92PTB2PT9
2PTB2PT92PTB2PT950022@T:0PTB2P042@T:2A8:2@T:00000PTB2P032@T:
4A`:2@T:00894PX010T92PTB2PTB2PT950894PX00`T92PTB2PT92P032@T:
0PTB2P892@X01@TB2PT92Q4L2PT950T92P052A8:00<92@X94PX92@X00`TB
2P092@T:2A8:2@T:2@T:2@TD2A8:2@T:2@TD2A8:00<92@X00a4L2PTB2PTB
2P022@T:00@J4Q@92@X92A@94PX22@T:00HJ4Q@92@X92@X92A@94PX92A@2
2@T:00<94PX92@X92A@00PT92P034A`:2@T:2@T:00892@X22A8:0PT92P03
2A8:2@TD2@T:00894PX22@T:00<A70X92@X92@X00PT92P072A8:2@TD2A8:
2A8:2@TD2A8:6Q8D00892A@00c@_:Cd_?Lc<c01Pc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<
c0074BHD6Q8D2A8:4A`:2A8:4A`:6Q8D00892@X010TB2PT92PTB2PTB2P89
2@X01PTB2PT92Q4L2PT92PTB2PT92P894PX00`T92PTB2PTB2P032@T:00@J
4Q@92@X92@X94PX42@T:00<A70X94PX000000`TB2PH92@X22A8:00<00009
2@X92@X00PT92P092A8:2@T:2@T:2@T:4A`:2A8:2@T:2A8:000000T92@X0
3@TB2P00000000T92Q4L2PTB2PT950T92PTB2P0000T950T92P0000052@T:
00<94PX0000000000`T92P072A8:00002A8:00002@T:2A8:000000D92@X0
0`TB2P0000T92P022@T:00<000092A@0000020T92P072A8:00002@T:2A8:
2@T:2A8:2@T:00<94PX00`T92PTB2PT92P052@T:00T92A@000092@X94PX9
2@XJ4Q@92@X94PX92@X00PTB2PL92@X00`0000T92PTB2P032@T:00<94PX0
00092@X00PT92P044A`:2@T:2@T:2A8:1PT92P042A8:2@T:2@T:2A8:0PT9
2P052@TD2@T:2A8:2@T:2A8:00892@X22A8:2@T92P894PX01@T92PTB2PT9
2PTB2PT92P032A8:1@T92P052A8:2@T:2A8:2A8:2@T:00894PX22@T:10TB
2P082@TD2@T:2@T:2A8:2@TD2@T:6Q8D2A8:0PT950032@T:=2lYAT`m067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`0
0oooolc<c<c<c01Mc<c<00@J4Q@A9PX92A@J71h22A8:00<J4Q@92A@94PX0
1`TB2P032@T:2A8:2@T:00894PX01@T92PTB2PTB2PT92PTB2P022@T:00@S
;bT94PX94PX92@X36Q8D0PTB2P052@T:2A8:00002@TD000000H92@X01a4V
7P0000TB2PT9500000T92PTB2P022@T:00@S;bT92@X94PX94PX52@T:00P9
4PX92@X92@X94PX92A@000094PX000022@T:00D94PX92@X92@X92@XJ71h0
10T92P0500002@T:2@T:2@T:2A8:00892@X010TB2PT92PT92PTB2P`92@X0
10TB2PT92PT92PTB2PL92@X01@TB2PT92PT92PT92PTB2P062@T:00@J71h9
2@X92@X000022@T:00D94PX92@X92@X92@X94PX00PT92P032A8:00002@T:
00@92@X020TB2P0000TB2P0000T92PTB2PT92PTB2PD92@X011XB50T92PT9
2PTB2PX92@X00`TB2PT92PT92P022A8:00<92@X94PX94PX01@T92P032A8:
2@T:2@T:00892@X02@TB2PT92PTB2PT92Q4L2PTB2PT92Q4L2PTB2P022@T:
00<94PX92A@94PX00PT92P052A8:2@T:2A8:2@TD2A8:00892@X32@TD00<9
4PX92A@92@X00PT92PD94PX00`T950T92QXB50032A8:00<92A@92@X92A@0
10T950044BHN2@T:=2lYCeiVHLc<c004IVIVR<2hR<2hB9280@00000000B8
`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`010T9514L2PT9
50TB2P892A@52A8:00@92A@94PX92@X94PX22@T:0PTB2P072@T:2A8:2@T:
2A8:2@T:00002A8:00892@X00`0003d_?@T92P042A8:1@T92P072A8:2@T:
2A8:2A8:2@T:4A`:2A8:00892@X010TB2P0000T92PTB2P892@X011XB50TB
2PTB2Q4L2P@92@X00`TB2PT92PTB2P022@T:00<94PX92@X92@X01@T92P07
00002A8:2@T:2A8:8blY2@T:2A8:00H92@X01P0000TB2PT92PTB2PT950TB
2PD92@X010TB2PT92PT92PT92P894PX52@T:00<94PX92@X94PX00PT92P04
2A8:2@T:2A8:2A8:0`T92P<94PX01PT92Q4L2PT92PTB2PT92PTB2P892@X0
1@TB2PT92P0000TB2PT92P022A8:0`T92P894PX22@T:00<94PX92A@94PX0
1PT92P0300002A8:2@T:00D92@X00`TB2QXL7PT92P062@T:00<94PXA70X9
4PX00PT92P082A8:2@T:2A8:2A8:2@T:2A8:2@TD2A8:1@T92P032A8:2@T:
2@T:00@92@X01PTB2PT92PTB2PTB2PT950TB2P892@X01PT950T92Q4L2PTB
2Q4L2PT92P@94PX01PT9514L2Q4L2PTB2Q4L2PTB2PD92@X01@TB2PT92PT9
2PT950TB2P022@T:00d92A@J4Q@94PX92A@94PX92@XJ4Q@92A@J4Q@92A@9
2@Xd;aibLW/0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`01aXB50T950TL50T9514L2PT9
2QXB50022@TD0PTB2P<92@X011X92PT92PT92PT92P<94PX72@T:0PTB2P<9
2@X22A8:0PT92P032A8:2@T:2A8:00<92@X06@00014L2PT92P00014L2PT9
2P00014L2P0000T92PTB2PT92PT950T92PTB2P0002`h:@T950T92PTB2PT9
2PTB2P0000T92Q4L2P042@T:00L000092@X92@X000092@X000094PX00P00
00032@T:00002A8:00<92@X0100000T92PTB2P0000892@X2000000L94PX9
2@X92@X94PX000092@X000000`T92P0300002A8:2@T:008000001@T92PTB
2PT92PT92P0000022@T:00D000092@X92A@0000A70X00`T92P0800002@T:
00002A8:2@T:00002A8:00000PTB2P892@X0100000T92PT92P0000@92@X0
0`00014L2PT92P032@T:00<0000A70X94PX01@T92P0400002A8:2@T:4A`:
0PT92P8000000a4L2PT92PT92P042@T:00<94PX92@X92@X01@T92P030000
2@T:2A8:00L92@X010TB2PT92PT92P0000892@X22A8:1@T92P032A8:2@T:
2A8:00H92@X22A8:00<92@X94PX92@X02@T92P072A8:2@T:2@T:2@T:2@TD
2@T:4A`:00@92@X00a4L2PT92QXB50032@T:00<92A@d;bUbLW/0HLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003oooo
c<c<c<c<05g<c<`01`T92PTL50TL50T9514L2PT92Q4L2P022A8:00<92A@9
2@X94PX01@TB2P0700002A8:2@T:2@T:2A8:2@T:2A8:00892@X00`TB2P00
00T92P042@T:00L0000A70X92@X92@X000094PX92@X00PTB2P892@X010TB
2PT92PT92PTB2P@92@X0300000T92PT92R`L50TB2PT92PTB2PT92PTB2Q4L
2PTB2PT92P<94PX32@T:00<94PX92@X92@X00P0000042A8:00002A8:0000
0PT92P082A8:2@T:2A8:2@T:2A8:00004A`:00000PT92P032A8:2@T:0000
00<92@X01@TB2P0000T92PTB2P0000022@T:00X94PX92@X92@X92@X94PX9
2@X94PX000092@X000032@T:0PTB2P8000000`T92PTB2PTB2P052@T:0189
4PX000092@X92A@0000J2@X000092@XA70X000094PX000092@X94PX92@X0
00094PX000052@T:00<000092@X92@X00PT92P0800002@T:2@T:2@T:4A`:
6Q8D00002@T:0PTB2P032@T:2A8:2@T:00<92@X00`TB2P0000T92P052@T:
00<94PX92@X94PX01PT92P032A8:2@T:2@T:00D92@X00`0000TB2PT92P09
2@T:00@A70X94PX92@X94PX22@T:00D92A@92@X92@X92@X94PX00`T92P89
4PX52@T:00<94PX92@X92@X00`T92P032A8:2@TD2A8:00<92A@22A8:00<0
000d;aiPLW/0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`00`TL50TB2QXB50042A8:00H9
2A@94PX92A@A70X94PXJ4Q@32@T:00<94PXA70X94PX00PTB2P072@T:2A8:
00002A`D6PT:2A8:4A`:00<92@X22A8:0`T92P894PX0100000TB2PT92P00
00894PX01P0000TB2PT92PTB2PT92PTB2P892@X22A8:00@A70X94PX00009
2@X22A8:00L92@X94PX94PXA70X000094PX92@X00PTB2P0600002@T:2@T:
2A8:2@T:2A8:0P0000032A8:00002A8:008000022A8:00@000094PX92@X0
00032@T:00/000092@X92@X94PX92@X000094PX000094PX000094PX00PT9
2P0400002@T:2A8:00001@T92P052A8:2@T:2A8:2@T:000000<92@X01PTB
2P0000T92PTB2PT92PTB2P892@X02P0000T92Q4V50T92P0001XL7PTB2P00
00T92PTB2P/92@X0214L2PT92PT92Q4L2PT92PTB2PT92PTB2PD92@X00`TB
2P0001X92P032@T:00<94PX92@X94PX00PT92P<94PX22@T:0PTB2P032@T:
2A8:2A8:00892@X0114L2PT92PTB2PTB2P<92@X01PTB2PT92PT92PTB2PT9
2Q4L2P892@X01`TB2Q4L2PT92PT92PTB2PT92PTB2P032@T:1@TB2P892@X0
0a4L2PT92PTB2P032@T:00T94PXA70X92@X92@XA70X94PX92@X94PXA70X0
0`T92P032A8:4A`:2A8:00894PX01a4L2PTB2PT950T9500003@_7W9bN`1Q
c<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<
00?oooo<c<c<c<`0GLc<c0036Q8D2A8:2A8:00<94PX00a4L2PT92PTB2P02
2@T:0`TB2P034A`:2@T:2@T:00894PX01@T92P0000TB2PT92PTB2P020000
00X92@X94PX92@X92@X94PX92@X94PX92@X94PX000032@T:014000094PX9
2@X92@X000092A@92@X94PX92@XA70X92@X94PX92@X94PX000092A@94PX0
0PT92P032A8:2@T:2@T:00D92@X01@0000T92PT92PT92P0000022A8:1PT9
2P894PX01Q4L2PT92P0000TB2P0000TB2P<92@X01PTB2PT92PT92PT92P00
00TB2PD92@X0100000T92PT92PTB2P<92@X02@TB2PT92PTB2PT92PTB2P00
00TB2P0000TB2P072@T:00@000094PX000094PX22@T:00D94PX000094PXA
70X000000`T92P0400002@T:00002A8:10T92P052A8:2@T:2@T:2@T:2A8:
00892@X010TB2PT92PTB2PT92P894PX92@T:00D94PX92@X92@X0000A70X0
1`T92P062A8:2@T:2@T:2@T:00002A8:0`T92P032A8:2@T:2@T:00L92@X0
10TB2PT92PT92PTB2P<92@X01@00014L2PT92PT92Q4L2P022@T:00<94PX9
2@X92@X010T92P034A`:2A8:2@T:00X92@X00`TB2PT92PT92P032@T:00T9
4PX92@X94PX92@XA70X94PX92A@/4P1bLW/0HLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`0
10T950TB2PTB2PT92P894PX32@T:0PTB2P892@X00`TB2PT92PTB2P042@T:
00<94PX92@X92@X00P0000082A8:2@T:2@T:00002A8:00002A8:2@T:0P00
00052A8:2@T:2@T:2@T:2A8:00892@X0200000T92P0000TB2PT92P0000TB
2PT92P<0000010TB2P0000T92P0000894PX00`0000TB2PT92P022A8:00@0
00092@X92@X94PX2000000L92@X94PX000092@X0000A70X000000PTB2P@0
00000`TB2P0000T92P022@T:00<000092@X92@X00P0000032@T:00002@T:
0080000040T92PTB2P0000T92P0000T92P0000TB2P0000T92P0000T92P00
00TB2P0000TB2P8000004PTB2PT92P0000T92P0000TB2PT92P0000TB2P00
00T92P0000TB2P0000T92P0000T92P0000<92@X00`0000T92PT92P022@T:
00<000094PX92@X00`T92P032A8:2@T:000000894PX01P0000TB2P0000TB
2P0000TB2PH92@X02@TB2PT92PT92PT92P0000TB2PT92P0000TB2P042@T:
00<94PX92@X92@X00PT92P074A`:2@T:2@T:2@T:00002@T:4A`:00@92@X0
2`TB2PT92Q4L2PTB2R`L50T92PTB2PT92Q4L2PT92PTB2P052@T:0PTB2P03
4A`:2@T:2A8:00`92@X0114L2PT92PT92PTB2P892@X22A8:00D92@XA70X9
4PX92@X92A@00PT92P062A8:2@T:2A8:0000=2lNLW9kHLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<
05g<c<`24A`:00@92@XA70X94PXJ4Q@32A8:00@J2@X000094PX92@X22A8:
00<92@X94PX92@X010TB2P<92@X00`TB2PT92Q4L2P032@T:0PTB2PD92@X0
0`TB2P0000T92P082@T:00<94PX92@X92@X01PT92P894PX00`T92PTB2P00
00022@T:0PTB2P096PT:2A8:00002A8:00002@TD2@T:2A8:000000<92@X0
0`TB2PT92PT92P042@T:00<94PX000092@X010T92P034A`:00002@T:0089
2@X01PTB2P0000TB2P00014L2P0000H92@X00`0000T92PT92P022@T:00<9
2A@000092@X01`T92P0400002@T:4A`:00000`T92P082A8:00004A`:0000
2A8:00002@TD2A8:1@T92P032A8:2@T:2@T:00894PX00`0000T92PT92P06
2@T:00@A70X0000A70X94PX82@T:0PTB2P0600002@T:2@T:2@T:2A8:0000
0PT92P032A8:2@T:2A8:00D92@X01@TB2PT92PT92PT92Q4L2P032@T:00DJ
4Q@92A@A70X92@X94PX00`T92P044A`:2@T:2@T:2@T:0PTB2P056Q8D2@TD
2@T:2@T:4A`:00@92@X00a4L2PT92Q4L2P022@T:00@94PX92@X92@XA70X3
2A8:00<92@X94PX92@X00`T92P0:2A8:4A`:2A8:2@T:4A`:2A8:2@TD2@T:
;180PhB>HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;So
c<c<6/c<c003ooooc<c<c<c<05g<c<`01PT9514L2PT9514L2PTB2PT950<9
4PX010T92PTB2PTB2PT92P894PX52@T:00D94PX92@XJ4Q@92@X92A@01PT9
2P032A8:2@T:2@T:00894PX72@T:00<94PX92@X92@X02`T92P032A8:2@TD
2@T:00@92@X02`TB2PT92PT92PTB2PT950TB2QXB50T92P0000T92PTB2P03
2@T:00<94PX92@X92@X020T92P052A8:2@T:2@T:2@TD2@T:00894PX00`T9
2PTB2PT92P052@T:00@94PX92@X92@X94PX32@T:00@94PX92@X92@X94PX2
2@T:00<94PX92@X92@X020T92P044A`:00002A8:6PT:1PT92P0300004A`:
000001492@X01@TB2P0000T92PT92PT950052@T:00<94PX92@XA70X01@T9
2P032A8:2@T:2@T:00D92@X00`T950T92PT92P032@T:00<A70X92@X92@X0
0PT92P0300002@T:2@T:00<92@X00`TB2Q4L2PT92P072@T:00<92A@A9Qh9
2@X030T92P034A`:2A8:2@T:00H92@X00`T950T92Q4L2P032@TD0PT92P05
6Q8D2@T:2@T:6Q8DPhAk067<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<0PTB2P062@TD6Q8D
6Q8D6Q8D2@T:2A8:0PT92P032A8:2@T:2A8:00D92@X01@TB2PT92PTB2PTB
2PT950022A8:00<92@X0000A9Qh00`T92P042@TD2@T:2@T:2@T:0P000008
2@T:2A8:2@TD2@T:00004A`:2@T:00000PTB2PH92@X32A8:00@000092@X9
2A@J4Q@72@T:00`J71h92@X0000J71h92@X94PX92@X000092A@000092@X9
4PX22@T:0PTB2P892@X00`TB2P0000T95002000000@94PX0000000092@X2
000000<J71h000094PX01@T92P0500002@T:2@T:00002A8:00892@X01000
00T950TB2P0000894PX01@0000TB2PT92PT92P0000052@T:00H94PX92@X9
2@X000092@X94PX62@T:00<000092@X94PX01@T92P052A8:2@T:2@T:2@T:
2A8:00P92@X22A8:00<000094PX92@X00PT92P0700006PT:2@T:6Q8D2@T:
2A8:2@T:00894PX52@T:00<A70X92@X92@X00PT92P032A8:2@T:2A8:0089
2@X011X92PT92PT92Q4L2P`92@X01a4L2PT92PT92PT92PT951XB514L2P03
2@T:00X94PX92@X92@X92@X94PX92@XA70X92@X94PX92A@22@T:00/92A@9
2@X94PX92@X92A@J4Q@971@J4Q@92A@92@X94PX00PT92P066Q8D2@TD6Q8D
2@T:6PT:PhB>HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`22@TD00@A70X92@X92@X94PX2
2@T:00LA70X94PX94PX94PX92@X92A@92@X00PTB2P082@T:2A8:2A8:0000
2@T:00002A8:00000PTB2P054A`:00002A8:2@T:2A8:00<92@X02@T950T9
2PTB2PT92P0000TB2PT92P0000TB2P032@T:00@94PX92@X94PX94PX32@T:
0P0000052@TD2A8:4BHD6Q8D000000894PX22@T:0PTB2P0:00002A8:2@T:
00002A8:2@T:00002@T:00002A8:0`T92P0;2A8:00002@TD00002@T:0000
2A8:00002A8:2@T:000000894PX22@T:00L94PX92@X94PX000094PX92@Xd
;ah00PT92P894PX32@T:0P0000034A`:0000000000892@X0100000TB2PTB
2PTB2P892@X020TB2PT92PT92PT92PTB2P0000TB2PT92P<94PX02P0000TB
2P0000T92P0000T950TB2PT92P0000TB2P<92@X020TB2PT92PT92Q4L2PT9
2PTB2P0000TB2P892@X01`TB2PT92PT92PT92PTB2P0000TB2P052@T:0`TB
2P892@X01P0000T92P0000TB2PT92PTB2P<92@X02P0000T92PT92QX92PTB
2PT92Q4L2PTB2PT92P0000<94PX0100000TB2PT92PT92PH94PX01@T92PTB
2PTB2PT92PTB2P032@T:00D94PX92@X92@X92@X94PX00PT92P894PX010T9
50TB2PT92PT92P<94PX00aXB514L2PT92P022@T:00TS70X92A@94PX92@X9
4PX92A@94PX92@X92A@00PT92P032A8:8a`:SIR>067<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01M
c<c<00@J4Q@94PX92@XA70X22@T:00<94PX92@X94PX00`T92P062A8:2@T:
2A8:00002A8:00000PT92P0<00002A8:00002@T:00002A8:00002A8:0000
2A8:0000=2lc0P0000092A8:00002A8:00002A8:00002A8:00002A8:0089
2@X01@TB2P0000T92P0000TB2P022@T:0PTB2P032@T:2A8:000000894PX2
000000D94PX92@X92@X94PX000000PT92P8000000`TB2P00000000022A8:
00@000092@X94PX92@X2000000<92@X000092@X00`T92P072A8:2@T:2A8:
2@T:00002@T:000000894PX0200000T92PTB2PT92P0002=1DP0000T92P80
00000`T92P0000T92P022@T:00P000092@X92@X000094PX000094PX00002
2@T:00D94PX000092@X92@X94PX00P00000:2@T:2A8:000000002A8:0000
2@T:2A8:2@T:2A8:0P0000034A`:00002@T:00@92@X00`TB2PT92P000005
2@T:00P94PX000092@X92@X94PX000092@X94PX22@T:00L000094PX92@X9
4PX000092@X000002@T92P072A8:2@T:4A`:2@T:00002@T:2A8:00<92@X0
0`TB2P0000T92P022@T:00X000092@X92@X92@X94PX000094PX92@X94PX0
00062@T:00<94PX000094PX00PT92P<94PX32@T:00<94PX92@X92@X00`T9
2P046Q8D2@T:2A8:2@T:1@TB2P042@T:2A8:2A8:2@T:0Q4L2P894PX00aX9
2UMNKlc<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0
^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0052@TD2@T:4A`:00004A`:00<9
4PX011XB50TB2PTB2PTB2PH92@X02A4L2PTB2P0000TB2QXB500000T92PTB
2PT950022@T:0PTB2P0=00006Q`N000000002A8:00002@TD00002@T:0000
2A8:00002A8:00892@X0314L2P00014L2P0000T92Q4L2P0000T92P0000TB
2P0000TB2P892@X01@TB2P0000TB2P0000T92P042A8:00D000092@X92@X9
2A@000000PT92P0300002@T:2@T:00892@X01PTB2P0000TB2PTB2P0000TB
2P<000001@TB2P0000TB2PT92P0000022@T:00L94PX000092@X94PX00009
2@X0000010T92P052A8:00002A8:2@T:000000<92@X00`TB2P0000T92P04
2@T:00P94PX000092@X92@X94PX000092@X94PX32@T:00@000092@X94PX0
00042@T:00LA70X92@XA70X92A@S70X92@XA9Qh010T92P042A8:2@T:2@T:
2A8:20T92P032A8:00002@T:00<92@X00a4L2PT92PT92P022@T:00H00009
2@X92@X94PX92@X94PX32@T:00@94PX000092@X94PX32@T:00@94PX92@X9
2@X92@X22A8:10T92P032@TD2@T:2@T:00892@X010TB2PT92PTB2PTB2P89
2@X00`TB2PT92PT92P022@T:00@94PX000094PX92@X22A8:0PT92P894PX0
1PT92PTB2PTB2Q4L2PT92PTB2PD92@X00`TB2PT92PTB2P022A8:00@92A@0
000/4P23Q8iQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0
^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0032@TD2A8:2A8:00894PX22@T:
00<J4Q@92A@94PX00PTB2P@92@X01@TB2PT92P00000000TB2P03000000@9
4PX0000000094PX22@T:018000094PX000092@X94PX000094PX000092@X0
000J71h94PX92@X000094PX92@X000092A@22@T:0PTB2P892@X2000000<9
4PX000094PX00PT92P082A8:2@T:2@T:4A`:00002A8:2@T:00000PTB2P03
2@T:00002@T:00D92@X0100001XB500000TB2P8000000`TB2PT92PT92P02
2@T:00L000094PX000094PX92@X94PX92A@010T92P0400002A8:4A`:0000
0`T92P0300002A8:000000892@X03PTB2P0000T92PT92P0000TB2PT92P00
00TB2PT92PTB2PT92P0000TB2P<92@X00`0000TB2P0000022@T:00<00009
2@X92@X00PT92P092A8:2@T:6PT:6PT:;1806PT:;1808a`:;180008A70X0
1PT92QX92PT950TB2PT92P0000@92@X01@0000T92PT92PTB2P0000022@T:
00<94PX92@X92@X020T92P0300002@T:2@T:00892@X020TB2PT92PT92PT9
2P0000TB2PT92PTB2P<92@X00`0000TB2Q4L2P042@T:00<A70X92@X92@X0
0`T92P032A8:2@T:2@T:00H92@X010TB2PT950TB2PTB2P892@X22A8:0`T9
2P092A8:2@T:2@T:2@T:00002@T:2A8:2@T:2A8:00@92@X00`TB2PT92PTB
2P022A8:00<A70Z3Q8k<c<`0H<c<c004IVIVR<2hR<2hB9280@00000000B8
`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`22A8:00P92@X9
4PX92A@A70XA9Q@92A@J4Q@94PX;2@T:00L0000A70X92@X000094PX92@X9
4PX00P0000892@X020TB2PT92P0000TB2PT92P0000TB2P0000892@X01P00
00T92P0000TB2PT92PTB2PP92@X02P0000TB2PT92PT92P0000T92P0000TB
2P0000TB2P<92@X2000000L94PX92@X94PX92@X0000A70X000000PTB2P89
2@X2000000L94PX92@X000092A@92@X000092A@00PT92P<000001AXL7QXB
50T92PTB2P0000032@T:00<000094PX000000PT92P0600002A8:2@T:2@T:
2A8:000010T92P0300002A8:000000892@X00`0000TB2PT92P032@T:00<9
4PX92@X92@X020T92P8J2@X02b`B02<L2R<L2QX92R<L2QX92Q4L2QX92PT9
2R<L2R`B000?2@T:00/000092@X92@X92@X0000A70X000094PX92@X0000A
70X00PT92P894PX010T92P0000TB2PTB2P<92@X00`0000T92PT92P032@T:
00<000094PX92@X01@T92P032A8:2@T:2@T:00H92@X01@TB2PT92PT92PTB
2P0000022@T:00D92A@92@X92@X000094PX00PT92P032A8:2@T:4A`:00<9
2@X03QXB50T92PTB2Q4L2PTB2PT950T92PTB2PT92PTB2QXB50T92R`B09F4
SV7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<
c<`00oooolc<c<c<c01Mc<c<00<J4Q@J2@X94PX00PTB2P066Q8D6Q`N2@TD
2A8:2@T:2A8:0PT92P042A8:2@T:2@T:2A8:0PT92P894PX020T92P0000T9
2PT92PTB2P0000T92PTB2P<92@X00`0000T92PT92P032@T:00H000094PX9
2A@000092@X94PX22@T:00L0000A9Q@J4Q@92@X94PX92@X000000`T92P04
00002@T:2A8:00001`T92P062@TD00002@T:2@T:2A8:000010T92P072A8:
000000002A8:00002@T:000000892@X32A8:00/92@X000094PX92@XA70X9
4PX92@X000099RTJ2@X000000PTB2P032@T:00002@T:00<92@X00a4L2P00
00T92P042@T:0PTB2P0400002A8:2@T:00000`T92P032A8:2@T:2@T:00P9
2@X02AX92P0002<L2SdB2QX92PT92QX92R<L2QX92P028a`:00<J2@XS70XS
70X00QX92P036Q8D;1806PT:00<92@X00`TB2PT92PT92P062@T:00T94PX9
2@X92@XA70X94PX92@X94PX92@X000001PT92P894PX52@T:00<94PX92@X9
2@X00PT92P034A`:2@T:2@T:00D92@X00`TB2PT92PT92P022@T:00@J2@X9
2@X92@X94PX22@T:0PTB2PD92@X00a4L2PT92PT92P032@T:00<94PX92@X9
2@X010TB2P032@T:2A8:2A8:00892@X00`T950T92Q4L2P022A8:00H92A@9
2@X94PX94PX00023Q8iQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0036Q8D2A`D6Q8D0089
4PX00`T92R<_7QXL7P032A8:00D92@X94PX94PX92@XJ4Q@00PTB2P082@T:
00002@T:2A8:2@T:2A8:00002@T:0PTB2P0;00002A8:2A8:2A8:2@T:2A8:
2@T:2A8:00002A8:000000<92@X01@TB2P0000TB2PT92Q4L2P022@T:00<9
4PX92@XA70X01@TB2P892@X00a4L2PT92PTB2P042@T:00D94PX92@X94PX9
4PX000000`T92P032A8:2@T:000000@92@X030TB2PT92PTB2PTB2P0001X9
2PTB2P0000T92PTB2P0000T92P8000022@T:0`TB2P0500002@T:2@T:2A8:
2@T:00<94PX02P0000TB2PT92PTB2P0000T92PTB2P0000TB2P0000892@X0
10TB2P00014L2P0000892@X00a4L2P0000TB2P022@T:00@0000A70X92@XJ
2@X28a`:0R`B0005Ea`0;1806PT:;1808a`:008J4Q@24A`:00H/71@A70XS
70X92@XS70XA70X22@T:00<000094PX92@X00PT92P894PX52@T:00<94PX0
00092@X00PT92P032A8:2@T:2@T:00892@X22A8:10T92P894PX22@T:00D9
4PX92@X92@X92@XA70X00PT92P894PX02@T92PTB2PTB2PT92P0000TB2Q4L
2PTB2PT92P022A8:00DS;bT92@X92@X94PX0000010T92P042A8:2@T:2@T:
2A8:0PT92P042A8:2@T:2A8:2A8:0PT92P052A8:2@T:2A8:2@T:000000<9
2@X02a4L2PTB2PT92PTB2QXB50T950TB2PT9500001X92X>4SP1Qc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<
c<c<c<`0GLc<c0034BHD4A`:2@TD00894PX32@T:00<94PX92A@94PX00`TB
2P042@T:2@TD2@TD00000`TB2P0300002A8:2A8:00<92@X00`0000TB2PTB
2P022A8:00H92@XJ2@X94PX0000A70X000032@T:00L000092@X92@X92@X0
00094PX92@X00PTB2P892@X02P0000T9500000T9500000TB2PT92P0000TB
2Q4L2P892@X01@TB2PT92PTB2P0000T92P022A8:10T92P0400004A`:2@T:
2A8:0PT92P0500002A8:2@T:2@T:000000@94PX22@T:00D94PX92@X0000A
70X92@X00`0000042@T:00004A`:00000PTB2P0600002@T:2@T:00002@T:
00000`TB2P<92@X00`00014L2P0000032@T:00@000094PX000094PX42@T:
00HJ2@XA70XJ2@X/4P0m4PY69PX2?A8:018/4P0/71@S70XS70X/9Q@/71@J
2@X/71@J9Q@S70X/71@A70X/71@A9Q@92@X94PX92@X000022A8:0PT92P05
00002A8:2@T:2@T:2A8:00<92@X010TB2PT92PT92P0000T92@X00`TB2PT9
2PT92P022@T:0PTB2P092@T:4A`:2@T:2A8:4A`:2A8:2@T:4A`:2@T:00<9
4PX42@T:00`94PX92@X000094PX92@X94PX92@X94PX92@X94PX92@X94PX2
2@T:00<94PXJ2@X94PX00PT92P062A8:2@T:2@T:2@T:2A8:2@T:1@TB2P<9
2@X01Q4L2PT92QXB50T950T92PTB2P892@X00hfHS/c<c<c<c01Oc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<
c<c<c<`0GLc<c00<6Q8D2@TD6Q8D2@TD2A8:4A`:2@T:2A8:2@T:2A8:2BHY
6Q8D1PTB2P042@T:000000002A8:0PT92P0300002A8:2@T:00892@X02@TB
2PT92PTB2PT92P0000TB2P0000TB2P0000022A8:00<92@X94PX92@X00PTB
2P032@T:2A8:2@T:00894PX00`T92Q4L2PT92P022A8:0`T92P0500002@T:
2@T:2@T:2A8:00892@X01P0000TB2PT92PT950TB2P0000D92@X0100000TB
2PT92P0000<92@X010TB2PT92PTB2PT92P<000001`TB2P0000T950TB2PT9
2P0000TB2P032@T:00PA70X92@X000094PX92@X94PX000094PX32@T:00D0
00094PX92@X000094PX00`T92P0600002@TD2A8:00002@T:2A8:0PT92P05
2A8:00002@T:2@T:4A`:008J2@X00b`B03dB2SdB2P02?A8:01569PX/4P0m
4PXJ4Q@/71@J71hJ2@XA70XJ9Q@J71hA70XJ71hJ2@XA9PX94PX92@X94PX0
0`T92P0400002A8:2@T:2A8:0PT92P072A8:2@T:4A`:2@T:2A8:2@T:2A8:
00`92@X01`TB2PT92Q4L2PT92P0000TB2PT92P032A8:00<000094PX92@X0
10T92P034A`:2@T:2@T:00@92@X010TB2PT92PTB2PTB2P<92@X22A8:3@T9
2P034BHD2@T:2@T:00H92@X22A8:00LA70X92@X94PX94PXJ4Q@92@Z3Q8h0
HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<
c003ooooc<c<c<c<05g<c<`00`TB2QXB50T950032A8:00DJ4Q@92@X92@X/
71@94PX010T92P8J4Q@00`T950T92PT92P062@T:00H94PX000094PX00009
2@X000022@T:00X000092@X92@X94PX92A@000094PX000094PX000032@T:
00@A70X92@X92@XA70X22@T:00<94PX000092@X00PT92P034A`:00002@T:
00894PX22@T:00@000092@X92@X94PX22@T:00/94PX92@X92@X000094PX0
00092@XA70X000092@X94PX00P0000042@T:00002@T:2@T:0PTB2P040000
2A8:00002@T:0PTB2P0400002@T:2A8:2@T:0P0000892@X00`0000T92PT9
2P042@T:00H000092@X000094PX000092@X2000000DA70X000092@X94PX0
00000`T92P0600002@T:2@T:4A`:;1802@T:1AX92P<m4PX03AX92R<L2R<V
2R<_7QXB52`L51XL7R`L51XB52`L51XB514L2P0000062@T:00<94PX00009
2@X00`T92P0400002@T:2@TD00000`T92P032A8:2@T:2@T:00D92@X0114L
2PT92PT92QX92PL92@X01@TB2PT92PTB2PT92PTB2P072@T:00D94PX92@X9
2A@94PX000000`T92P044A`:2@T:2A8:2A8:10T92P052A8:2@T:2@T:2@T:
4A`:00@92@X00a4L2PT92PT92P022@T:00<94PX92@X92@X00PT92P032A8:
2@T:2@T:00892@X010TB2P0001X92X>4SV7<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00<J
4Q@J71hA70X00PT92P086Q8D2A8:2A8:2@T:4A`:2@TD4A`:2A8:1`T92P@9
4PX32@T:00<94PX92@X94PX00PTB2P0500002A8:2@T:2@T:2A8:00800002
2@T:00<94PX000092@X01PT92P894PX00`T92PTB2PTB2P022@T:00@00009
2@X000094PX2000000T92@X94PX92@X92@X94PX000094PX92@X000000PT9
2P0500002@T:2@T:2A8:000000D92@X00`TB2PT92PT92P02000000@94PX9
2A@92@X92@X200000PT92P8000022@T:00P000092@X94PX92@X000094PX0
00094PX52@T:00L000092@X92@X92@XA70X000094PX02PT92P<J2@X010T9
2QX92R<L2Q4L2P8S70X033dB2QXV51XB51XL7R`L50T951XB52`V51X92R`L
52<_7QXB50<92@X00`0000T92PTB2P072@T:00@94PX92@X92@X94PX52@T:
00<000092@X92@X00`T92P0400002@T:2@T:4A`:2@T92P0300002@T:2@T:
00H92@X00`TB2PT92PT92P022@T:00<J4Q@92@X92@X00`T92P032A8:0000
2@T:00892@X00`TB2PT92PT92P022@T:00@92A@94PX94PX94PX22@T:00<A
70X92@X92@X00PT92P032A8:2@T:2A8:00D92@X01PTB2QXB50T950T92P00
08>4SV7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<
c1[<c<`00oooolc<c<c<c01Mc<c<00P92A@971@94PX94PXA70X92@X92A@9
2@X22A8:00<000094PX94PX010T92P032A8:2@T:2@T:008000022@T:00L0
00092@X000092@X000092@X000000PTB2P0300002@TD2A8:00D92@X01P00
00TB2P0000TB2PT92PTB2P892@X22A8:00<92@X94PX92@X00`TB2P032@T:
2A8:2@T:00<92@X010TB2PT92P0000TB2P892@X22A8:00<92@X000092@X0
0PT92P0=00002@T:2@T:2@T:00002A8:2@T:00002@T:00002A8:2@T:2A8:
008000000`T92P00014L2P052@T:00@000092@X92@X92@X2000000@A70X0
00094PX000032@T:00<000094PX92@X00PT92P042A8:00002A`D000010T9
2P054A`:2@T:00002A8:2@T:008A70X22@T:00<J2@XA70X92A@00aX92P0?
4A`:6Q8D;1`D6Q`N8blY;1`D8blc8blN6Q`N=2lY;2HD4BHD2@T:00002A8:
00892@X01AXB50T92PT92PT92PTB2P022@T:00HJ71h000094PX92@X00009
2@X22A8:3`T92P894PX32@T:00D94PX92@X92@X92@X94PX00PT92P072A8:
2@T:2A8:2A8:2@T:2A8:2@T:00894PX0100000TB2PTB2PTB2P@92@X010TB
2PT950T92PT92P894PX00aX92PTB2PT92P022A8:0`T92P<94PX32@T:00@9
2A@92@X94PXJ2@X22@T:00HA70X94PX92@XA70XJ2@ZEQ7]Qc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<
c<`0GLc<c00:2A8:6Q8D2A8:2@T:2A8:2@T:8blY2@T:2A8:2@T:0PTB2P89
2@X01PTB2PT92PT92PTB2Q4V7PT92P<94PX00`T92PTB2PTB2P032@T:00`9
4PX92@X92@X000094PX000094PX000092@X94PX92@X94PX22@T:00D94PX9
2@X92@X000094PX00`T92P034A`:00002A8:00892@X03P0000T92PT92P00
00TB2PT92PTB2P0000T92PTB2P0000TB2PT92PTB2P892@X01@TB2P0000TB
2P00014L2P02000000/94PX92@X000094PX000094PX000094PX92@X00009
4PX00`T92P042A8:00004A`:00000PT92P032A8:2@T:2@T:00892@X010TB
2PT92PT92P0000892@X01@TB2PT92PT92PT92P0000022@T:00D000092@XJ
2@X94PXA70X00`T92P0300002@T:000000<92@X26PT:00XA70X92@XJ4Q@9
71@A70X/71@A9Q@J2@XJ4Q@S;ah38blY00D/>2TS;bTS;bT/>2TS;ah01@T9
2P0300002A`D4A`:00<92@X010T950TB2PT92PTB2P<92@X00`TB2PT92PT9
2P062@T:00D94PX92@X92@X92@X94PX01@T92P032A8:2@T:2A8:00892@X0
2@0000TB2PT92PT92PTB2PT92PTB2PT92PTB2P022@T:00<94PX92@X92@X0
0`T92P042A8:2@T:2@T:2A8:0PT92P032@TD0000;1`D00892@X01@TB2PT9
2X<_0;UW000000062@T:01092A@92@X92@X94PX92@X000092@X000094PX9
2@X94PX92@X94PXJ4Q@92@Z3Q8iQc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0046Q8D4BH:
2A8:2@T:0`TB2P052BHY6Q8D2@T:2@T:2A8:00<92@X01@TB2PT92PTB2PTL
50TV:@02000000@92@XA70X0000000042A8:00D92@X94PX000092@X94PX0
0PT92P074A`:00002A8:00002@T:2A8:000000894PX01PT92PTB2PT92Q4L
2P0000T92P894PX00`T92PTB2PTB2P032A8:00H92@X94PX000092@X94PX0
00032@T:0PTB2P082@T:00002A8:00002A8:00002@T:2@TD1PT92P032A8:
00002@T:00<94PX02P0000TB2P0000T92PTB2PT950T92PTB2P0000T92P89
4PX52@T:00@A70X92@X94PX94PX32@T:00HA70X94PXA70X94PX0000A70X8
2A8:00H92@XA70X92@XA70X92@XA70X26PT:00HJ71hS;bTA9PX94PXJ4Q@S
;c<2;3PY00Hd;bT/>2Td;bTm;cd/>2TJ9Q@32A8:00@92@X94PXA70X00002
2A8:0PT92P03=2lY00004A`:00894PX01Q4L2PT92PT92PTB2PT92PTB2P@9
2@X01@TB2Q4L2PT92PT92PTB2P052@T:00H94PX000094PX94PX92@X94PX3
2@T:1@TB2P032@T:2A8:2@T:00H92@X00a4L2PTB2PT950022A8:00H92A@0
002V@@3omP23;`1G7002Pbl000WTZP3od00m4PX92@X0000A70X92@XA70X9
4PX010T92P038blY2A8:2A8:00894PX01`T92QXB50TB2PT92Q4V51XB58>4
SP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`J
c<c<00?oooo<c<c<c<`0GLc<c0036Q8D2@T:2A8:00@94PX01PT92Q4L2Q4L
2PT92PTB2PT92P894PX03P0000TB2PTB2P0001X92PTB2PT92Q4L2P0000T9
2PTB2PT92PTB2P0000892@X22A8:0PT92P894PX00`0000T92PT92P022@T:
00@94PX92@X92@X92@X22A8:00<92@XA70XA70X00PTB2P892@X00`TB2P00
000000032@T:00DA70X92@X92@X92@X94PX00PT92P032A8:00002A8:00<9
4PX01a4L2P0000T92Q4L2P0000T92PTB2P082@T:00<000092@X92@X00`T9
2P894PX01P0000T92PTB2P0000T9500000@94PX00`0000T92PT92P052A8:
1@T92P044A`:2@T:2@T:4A`:10T92P0?2A8:00004A`:4A`:2@T:6PT:4BHD
6Q8D4A`:8blN8bH:4A`:6Q`N8blN;3PY00Ld;bT01`TB2PT92PT92PTB2PT9
2PTB2P0000022@T:00@94PX92@X92@X94PX22@T:00<94PX92@X92@X00PT9
2P052A8:2@T:2@T:2@T:2A8:00892@X00`TB2PT92PT92P032@T:00P94PX9
2@X92@X94PX92@XA70X92@X94PX52@T:00H94PX92@X92@X94PX92@XA70X2
2@T:00<A70X92@X92@X010T92P894PX01`T92Q4L2P000;1<0?oI0?o@0?oI
0002ooH000Kof@3fa`[f/`169PX92@XA70X42@T:00/A70X94PXA70X92@X9
4PXJ4Q@94PX92@XA70X94PXJ4Q@00PTB2P032@TD0000PhB>067<c<`016IV
IXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<
c<c<c01Mc<c<0PTB2P032@T:2A8:2@T:00@92@X010TB2PT92PTB2Q4L2P@9
2@X04@0000T9500000TB2PT92P0000TB2PT92P0000T92P0000T92P0000TB
2PT92P0000TB2P022@T:00@000094PX94PX000022A8:00P000094PX94PX9
2@X000094PX92@XA70X22@T:00<94PX92@X000000`TB2P0=2@T:2A8:2@T:
00002A8:2@T:00002A8:2@T:00002A8:00002@TD00@000002`TB2PT92P00
00TB2PT92P0000TB2PT92P0000T92PTB2P022@T:00T000092@X92@X92@X9
4PX92@X000092@X000000PTB2P0600002@T:00002@T:2A8:2@T:0P000003
2@T:2A8:000000892@X01P0000TB2P0000TB2PT92PTB2PP92@X02P0000T9
2P0000T92P0001X92Q4L2P0001XB514L2P@J4Q@012`L52`h:B`h:C@_:@8d
;c<3=2lY00PS;ah92@X92@X92@X000094PX000094PX22@T:00<000094PX9
2@X00`T92P0300002A8:2@T:00H92@X01@0000TB2PT92P0000TB2P042@T:
00H000094PX94PX000092@X000022@T:00<A70X92@X92@X00PT92P030000
2@T:2@T:00H92@X01`00014L2PT92P0000TB2PT92P0000032@T:00`94PXm
4P[1Q02VLP23@@1b>00m4PX/4P3CQ03od00m4PX94PX32@T:00<92A@/>2T0
00000`T92P054A`:2@T:2A8:2@T:000000892@X01@TB2PT92PTB2P0009F4
SP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`J
c<c<00?oooo<c<c<c<`0GLc<c0032@TD2A8:6Q8D00@94PX32@T:0PTB2PH9
2@X04@TB2PT92PTB2P0000TB2P0000TB2PT92Q4L2PT92P0000TB2PT92P00
00TB2P0000TB2P032@T:00D000094PX0000000094PX00P0000<94PX32@T:
00<A70X92@X94PX00PT92P8000000`TB2P0000TB2P072@T:00@000094PX9
2@X000022A8:00D92@X000094PX000094PX00`T92P0300002A8:2@T:0080
000010TB2PT92PTB2P0000892@X0100000TB2P0000TB2P892@X01@TB2P00
014L2PT92PTB2P042@T:00<000094PX92@X010T92P0600002A8:00002A8:
2@T:2A8:1`T92P032A8:2@T:4A`:00892@X0214L2PT92QXB51XB51X92Q4V
2R<_7R<_<`<d;bT00c@_<dI<?C@_:@028blc00</71@92@X92@X00PT92P04
2A8:2@T:2@T:00000`T92P0300002A8:2@T:00892@X00`TB2PT92PT92P03
2@T:00<94PX92@X92@X01@T92P034A`:2@T:2@T:00D92@X00a4L2PT92PT9
2P052@T:00@A70X92@X92@X94PX82@T:00XA70X92@X92@XA70X92@X94PXA
70X92@X94PX92A@2000000L92A@92@X92A@92@XJ2@X94PX92@X00`TB2P03
6Q8D2@TD2@T:00<92@X01@TB2PT92PT92PTB2P0000022A8:00D92@XJ4Q@A
70X0002EV:<0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`00`TB2PT92PT950022@TD0PT9
2P082@TD2@T:2@T:2@T:2A8:2@T:2@TD2A8:0`T92P0500002@T:2@T:2A8:
000000H92@X00`0000T92PT92P022@T:00<000092@X92@X010T92P092A8:
00002@T:2A8:00002@T:2A8:2@T:2A8:00892@X00a4L2PT92PT92P022@T:
00<94PX000092@X01PT92P0400002@T:2@T:00000PT92P0300002@T:0000
00D92@X0100000T92PT92P0000894PX22@T:0P0000892@X01`0000T92P00
00T9500000T92P0000022@T:0P0000<92@X00`0000TB2P0000042@T:00<A
70X000092@X010T92P034A`:2@T:000000T92@X00a4L2QX92PT92P024A`:
0QXB500<;2HD8blN=2lY=2lc=2lY=2lc;3PY=2lY;3PY8blY4BHD00001@T9
2P0300002@T:2@T:00h92@X01A4L2PT92P0000T92Q4L2P032@T:00<94PX9
2@X92@X010T92P0300002@T:000000<92@X00`0000T92PT92P022@T:00@A
70X000092@XA70X52@T:00<000092@X92@X01`T92P062A8:2@T:2A8:2@T:
00002A8:0`T92P044A`:2@T:2@T:4A`:1`T92P042A8:2@T:2@T:2@T:0PTB
2P892@X00`0009FHXlc<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0894PX03@T950TB
2PTB2PTB2PT92PTB2PT92PTB2PT92PTB2PT950T92PTB2P022@T:0`TB2P03
00002@T:2@T:00<92@X010T950T92PT92PTB2P<92@X00`TB2PT950T92P02
2@T:0PTB2PX92@X020TB2PT92PT92PTB2PT950T92PTB2P0000<92@X0114L
2P0000T92PTB2P<92@X01@TB2PT92P0000T92PTB2P052@T:00X94PX92@X9
2@X92@XA70X94PX000094PX92@X94PX62@T:00D94PX92@X94PX000094PX0
0PT92P072A8:2@T:2A8:00002A8:00002A8:00H92@X01`0000T92PT92PT9
50T92PTB2Q4L2P062@T:00<94PX92@X92@X00PT92P8J4Q@02Q4L2QX92QX9
2QXB51XL7R`L52`h:DI17Sd_?DI17P8d;c<01cd_?B`h:B<_7PT92PTB2PT9
2PTB2P032@T:00<94PX92@X92@X00PT92P0400002@T:2@T:2A8:2PT92P03
2A8:00002@T:00<92@X00a4L2PTB2PT92P072@T:00<94PX92@XA70X03`T9
2P894PX52@T:00/A70X92A@92@XA70X92A@92@XA70X92A@94PXA70X92@X0
0PTB2P892A@00`TB2PT92PT92P032@T:00<94PXA70X94PX00`T92P054A`:
2@TD2@TD0000UHB>067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<0PTB2P034A`:2@T:2@T:
00<94PX22@T:0PTB2P036Q8D2@T:2A8:00892@X00`0000T92PT92P032@T:
00T000092@X92@X92@X0000A70X92@X000094PX00PT92P0600002A8:2@T:
2@T:00002A8:0`T92P0900002@T:2A8:2@T:2A8:00004A`:2A8:4A`:0089
2@X00`TB2P0000T92P042@T:00d94PXA70X92@X92@XA70X000094PX92@X0
00094PX92@X000094PX01@T92P0300002A8:2@T:008000001A4L2P0000TB
2P0000TB2P022@T:00P000092A@000092@X000092A@92@X000022@T:0P00
00072@T:00002@T:2@T:00002A8:000000@92@X01A4L2PT92P0000T92Q4L
2P042@T:00L94PX92@XA70X92@XJ2@XA70X92@X00Q4L2P892@X02AXB514L
2Q4L2QX92QXB52<_<c@_7S@_<cd_?@03=2lc0R`h:@036Q8D2A8:00000089
2@X02000014L2PT92P0000T92PTB2PT92PT950<92@X00`TB2PT92PT92P04
2@T:00<A70X92@X94PX00PT92P046PT:2@T:2@T:4A`:10T92P044A`:2A8:
2@T:4A`:0`T92P036Q8D=2lY6Q8D00@92@X00`TB2PT92PT92P052@T:00@A
70X92@X92@XJ2@X22@T:00HA70X92@X92@XA70X92A@000042@TD00<94PXm
4PZ3;`000PTB2P042@T:2@TD2@TD4A`:0PT92P042A8:2@TD2A8:2A8:0PT9
2P092A8:2@T:4A`:2@T:6Q8D4A`:4BHN0000UIRS067<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01M
c<c<00<92A@A70X92A@00PTB2P032@T:2A8:2A8:00@92@X00aXL7Q4L2PT9
2P032@T:00D94PX92@X92A@92@XA70X00PT92P894PX32@T:00<94PX92@X9
2@X00`T92P894PX52@T:00D94PX92@X92@X94PX92@X00Q4L2P032@T:6PT:
4A`:00T92@X00`TB2Q4L2PT92P0:2@T:00@0000A70XJ4Q@94PX22@T:00<0
00092@X94PX00PT92P052A8:00002@T:2@T:2A8:00<92@X22A8:0`T92P04
2A8:2@TD2@T:2A8:0`T92P034A`:2@T:2@T:00P92@X04Q4L2PT92PT92PT9
2PTB2Q4L2QX92R`B01X92R`B04HV2SdB2QXB51X92PT92QX92Q4L2QXB50<J
2@X01R<_:B`L53@_:Cd_?C@_<dI<?@8d;c<2;3PY00<92A@94PX94PX010T9
2P032@TD2@T:2A8:00<J4Q@010TB2PT92PT92PT92P8A70X=2@T:00<92A@A
70X92@X020T92P048blc2@T:2@T:4A`:1`T92P032A8:2@T:2A8:00H92@X0
4a4L2PT951XB514L2PT92PT958<_0?nc078h500003@_7R`B0=>40?oI03dB
2PT92Q4L2PT951XB50022@T:00@A70X94PX92@XJ4Q@32@T:00TA70X92@X9
2A@92@XJ2@XA70X92A@0002EQ8h0HLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`00`T950TB
2PTB2P022A8:0`T92P032A8:2@T:2A8:00892@X32A8:00/92@X94PX00009
4PX000094PX000094PX000094PX000000PTB2P0B00002A8:00002A`D0000
2@T:2A8:00002@T:2A8:00002A8:00002A8:00002@T:2A8:00000PTB2P<9
2@X01A4L2PTB2PT92P0000T92P022A8:00H0000A70X92@XA70X92@XA70X3
2@T:00@94PX000094PX94PX22@T:00D94PX000094PX971h000000PTB2P<9
2@X02P0000TB2P0000T9500000TB2P0000TB2P0000TB2P8000001PT92PTB
2P00000000T92P0000892@X22A8:00<000092@X92@X010T92P0@2A8:2@T:
2@T:4A`:6PT:2@T:4A`:2A8:;1806PT:ARHDARH:;1`D?A8:H2l:Ea`00R`B
00034A`:6PT:4A`:008J2@X01a4L2R`L51XL7R`V53@_<cAE:Cd_?@02=2lc
00P/>2TS;bTJ9Q@A70X94PX000092@X94PX22@T:00T92A@94PX971@92A@9
2@XJ4Q@000094PX92@X00PTB2PP92@X00`TB2PT92PT92P022A8:0PT92P0<
2A8:4A`:2A8:2A8:4A`:2@T:4A`:2A8:2@T:0000?Blm2A8:0`T92P044A`:
2A8:2@T:2A8:10T92P032A8:2@T:2@T:00<92@X22A8:00hJ4Q@92@X94PX9
2AAb9P3TZP3od03TZP3f/`3od03of@3f/`3fa`Xm4PX32A8:00@92@XA70X9
2@X92@X22A8:00<92@XA70X92@X01@T92P054A`:2@T:4A`:2@T:PhB>067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`0
0oooolc<c<c<c01Mc<c<00D971@J4Q@94PX94PX92@X00PTB2P032@T:2A8:
2A8:00892@X02@TB2PT92PTB2P0000T92PTB2PT92PTB2P0000052@T:00d9
2A@000094PX94PX000094PX92@X000094PX92@X000092@X000000PT92P0=
2@TD00002A8:2@T:2A8:00002@T:4A`:2@T:4A`:6PT:2@T:2A8:00<92@X0
2@00014L2PT92PT92Q4L2PT92Q4L2PT92PTB2P042@T:00<94PX92@X94PX0
0PT92P034A`:00002@T:008000042@T:00<94PX000092@X00PTB2P050000
2@T:2@T:2@T:000000D92@X01@0000TB2P0000TB2P0000022@T:00<94PX9
2@X94PX00`T92P0@2A8:00002A8:4A`:6PT:?A8:;1808a`:?A8:;1`DH2lD
Pbl0Ea`0?A`:Ea`0H2l:0THV500D6PT:4A`:6PT:6PT:2A8:8a`:6PT:8a`:
8blY;1`D;3PY?BlmAT`m?Blm=2lc=2lY8blN6Q8D2@T:00000PT92P040000
2A8:4A`:2A8:0P0000052A8:0000;1`D2@T:000000892@X01@TB2Q4L2Q4L
2PT92PTB2P052@T:00@0000A70X92@X000092@T:00H94PX92@XA70XA70X9
2@XA70X62@T:00<A70X0000A70X010T92P0;2A8:2@T:4A`:2@T:4BHD2@TD
4A`:2A8:2@TDPcP0om0000;TZP001l640:Ib09EE0>BZ0?o@05LL00T92P02
2A8:00<A70X92@X94PX00PT92P032A8:2@T:2@T:00@92@X01`TB2PT92Q4L
2PT92PTB2P0009FHX`1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0056Q8D2A8:2@TD2A8:
2@T:00894PX00`0000TB2PTB2P072A8:010000092A@000094PX92@X00009
2@X0000A70X92@X94PX92@X000094PX000094PX22@T:00<000094PX94PX0
0`T92P0400002@T:0000000010T92P044A`:2@T:2@T:2A8:0`T92P044A`:
00002@T:2@T:0Q4L2P072@T:4A`:2@T:00002A8:00002@T:00<94PX01000
00T92PT92P0000892@X0114L2PT9500000TB2P<92@X01@0000TB2P000000
00TB2P042@T:00h94PX92@X000092@X0000A70X000092@X0000A70X92@X0
00092@X000032A8:0`T92P0300006PT:?A8:00A69PX07ULL078h060_2V0_
2SdL2VY12V0_2ULL04HV52`L53dB2QX92QXB52`B02<L2Q4L2QXB51XL7R`h
:Cd_?CAE:B=1DSAE:C@_:B<_:AXV514V500000TB2P0000894PX2000000<9
2A@92@X92@X00PT92P032A`D00002@T:00P92@X00`TB2PT92PT92P022@T:
00L000094PX92@X92@X94PXA70X000000PTB2P@92@X01@TB2PT92PT92Q4L
2PTB2P0;2@T:00@000092@XA70X94PX22@T:00<92A@94PX92@X00PT92P03
2BHY00002@TD008000001@T9500003dB2W8h00T950042@T:0PTB2P042@TD
2@T:2A8:2A8:1`T92P<94PX00`000:JQV<c<c01Pc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<
c00F8blN2A8:2A8:2@T:2A8:2@T:2A8:2@T:4A`:2@T:00002A8:2@T:2A8:
2@T:00002A8:2@T:00002A8:00002@T:0`TB2P032@T:00002A8:00<92@X0
1@0000TB2P0000TB2PT92P02000000H94PX92@X92@X92@X94PX92@X22A8:
00P92@X94PXA70X0000A70X92@XJ2@XA70X32@T:0PTB2P892@X24A`:0PT9
2P044A`:00004A`:2A8:0P00000=2A8:2@T:00002A8:2@T:2A8:00002@T:
00002@T:00004A`:000000892@X0100000TB2PT92P0000L92@X01P0000TB
2P0000TB2P0000T92P8000000a4L2PT92PT92P052@T:0PTB2P04Ea`0H2lD
Ea`0ARH:0eLL000:H2l:Nd40ARH:Ea`0ARH:Nd40H2l:Ea`0H2l:LRH00ULL
0003;1`D6PT:4A`:008S;ah04B`h:C@_:Cd_?Cd_?C@_<b<_:B`L514L2QX9
2PT92PTB2P0000TB2P0000TB2Q4L2P0000032@T:00@94PXS;ah92@X94PX2
2@T:00@A70X92@X92@X92@X22A8:0P0000034A`:2@T:2A8:00892@X00`TB
2PT92PTB2P022@T:00<A70X94PX92@X010T92P032A8:4A`:2@T:00P92@X0
10TB2PT92PTB2Q4L2PH92@X00a4L2QXB514L2P042@T:00@A70X92@X92@X9
4PX22@T:00<92A@000094PX010T92P042A8:2@T:2@T:2A8:0PT92P8A70X3
2@T:00<A70X92@XJ4Q@00PT92P03UIRSc<c<c<c<05o<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01M
c<c<00TJ4Q@94PX92@X92@X94PX000094PX0000J71h010T92P052A8:2@T:
2@T:2@T:2A8:00892@X22A8:00d92@X94PX000094PX000094PX92@XA70X0
00092@X94PX000092A@00`T92P062A8:00002A8:00002@TD2A8:0`000006
2@T:2A8:2A8:2A8:4A`:000010T92P062A8:00002@T:2A8:2@T:4A`:0PT9
2P032A8:00002@T:00894PX01@0000T92PT92P0000TB2P0200001@T92P07
00002@T:2A8:2@TD2A8:2@T:000000<92@X01P0000T92PT92PTB2P0000TB
2P8000000`T92PTB2P0000032@T:00<000092@X92@X010T92P032@TD;180
H2lD00=G70002f0_2SdL2ULL060_2W8V02<L2THV2V0_2THV2THV55LL0003
LRH000=P;`Y69PX/71@00R`L500E8blY;1`D=2lc=5Dm=2lc;3PY=2lY8blN
6PT:4A`:2@T:2A8:00002A8:00002@T:00002@T:2A8:00002A8:00800000
0aX92Q4L2PT92P042@T:0PTB2P0600002@T:2@T:00002@T:00000PT92P03
2A8:2@T:2@T:00892@X00`TB2P0000T92P032@T:00<A70X92@X92@X00`T9
2P894PX22@T:00<000092@XA70X00`T92P064A`:2@T:2A8:00002@T:4BHN
0PT92P032A8:00002@T:00892@X22A8:00<92@X94PX92@X030T92P054A`:
2@T:2@T:2@T:6Q8D00@92@X010TB2Q4L2QXB59F4SV7<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01M
c<c<0PTB2P032@T:2@TD2@T:00892@X01PTB2PT92PTB2PT92PTB2PT95089
2@X010TB2P0000T92PT92P8000022@T:0P0000892@X00`0000T92P000004
2@T:00T94PX000092@X92@X000092@X000094PX000000PT92P052A8:0000
2@T:2@T:2A8:00892@X24A`:0`T92P<94PX22@T:0`TB2P086PT:2@T:2@T:
2@T:2A8:00002A8:00000PT92P0900002@T:2@T:00002A8:00002A8:0000
4A`:008000022@T:0PTB2P0700002@T:2@T:2@T:00002@T:2A8:00800008
2@T:00@000092@X92@XA70X22@T:00PA70Xm4PXm70Y69PXm70YP;`YG700m
70X2ARH:00Lm70X/4P0m70Xm70Y69PX/71AP;`X00W8V000?H2l:LRH0H2lD
ARHD;1`D8a`:6Q`N8blYAT4N?Blm=2lc;2HD6Q`N6Q8D8a`:00892@X01@00
00T92P0000T92PTB2P022@T:00<000092@X92@X00`T92P0300002@T:2@T:
00@92@X00`0000T92P0000022@T:00D94PX92@X92@X94PX000000`T92P03
2A8:2@T:4A`:00H92@X00`0000T92PT92P0B2@T:00<94PX92@X92@X06PT9
2P074A`:2@T:2A8:2A8:2@T:0000UHB>067<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00<9
2@X94PX92A@00PTB2P<92@X01`TB2P0000TB2PT92P0000T92PTB2P022@T:
00<94PX92@X94PX02@T92P0300002@T:000000892@X02@0000TB2PT92P00
00T92P0000T92P0000TB2P0300000PT92P032A8:2@T:4A`:00@92@X00a4L
2PT92PT92P0200000PT92P0400004A`:2@T:00000`T92P0300002A8:0000
00892@X03P0000T92PTB2P0000T92P0000T92P0000T92P0000T92PTB2PT9
2PT95080000020T92PTB2P0000T92P0000T92P0000TB2P892@X0100000T9
2PT92P0000<92@X00`TB2P0000TB2P022@T:01<A70X/4P0S70XS70Xm4PXm
70YG70169PXS70Xm4PY69QA6;`XJ2@XS70X/71A69Q@S;ah/4P0m4PX00THV
2P0=AT`mAT4N?Blm=2lc8a`:;3PY;1`D=2lc8blc=2lY;2HD8blN;1`D0089
2@X00`0000TB2P0000022@T:0P0000052@T:2A8:000000002A8:00P92@X0
2Q4L2P00014L2P00014L2PT92P0000TB2PT92P0000892@X00a4L2PT92PT9
2P082@T:00<A70X92@X92@X00PTB2Pl92@X01@TB2PT92PTB2P0000TB2P06
2@T:00<000092@X92@X03PT92P092A8:2@T:2@T:2@T:4A`:2@T:4A`:0000
PhB>067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<
c1[<c<`00oooolc<c<c<c01Mc<c<0PTB2P036Q8D2A8:2A8:00P92@X01PTB
2PT92PT92PTB2PT92P0000D92@X01@TB2P0000T92P0000TB2P022@T:00<9
4PX000092@X01PT92P074A`:2@T:00004A`:2@T:2A8:000000892@X01Q4L
2PT92Q4L2P0000T92PTB2P@92@X22A8:1@T92P038a`:2@T:2@T:00892@X0
100000TB2PT92PTB2P8000032@T:00H0000A70X0000A70X000092@X30000
0`T92P0300002A8:2@T:00@92@X22A8:0PT92P0500002@T:00002A8:0000
00892@X01@TB2PT92SdB2QX92R`B00028a`:01Xm70Y69PY69PXS70XS9PXm
70XS9PX/4P0m70X/71@d;ahd;c<92@XS70X/71@/>2TS;ahd;bTm;cdd;bTS
;ahd;ahS;bT/>2U69Q@/>2T2;1`D0Q4L2P892@X0100000T92P0000TB2P89
2@X01PTB2P0000T950T92PTB2P0000D92@X00`TB2Q4L2PTB2P072@T:00<9
4PX92@XA70X00PT92P044A`:2@T:4A`:4A`:20T92P044A`:2@T:00002A8:
10T92P032A8:2@T:2@T:00P92@X22A8:1PT92P032A8:2@T:2@T:00@92@X0
0`TB2QXB50TB2P032@T:00<A70X92A@92@X00`T92P094A`:2@T:2A8:4A`:
2@T:6Q8D4A`:0000UHAk067<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00<94PXJ9Q@J4Q@0
0PT92P032A8:2@T:2A8:00892@X00`TB2PT92PT92P022@T:00@94PX92@X9
2@X92@X22A8:00@92@X000094PX000022@T:00PA70X000094PX92@X00009
2@X94PX000022@T:00<000094PX000000PT92P072A8:00002A8:00002A8:
2@T:2A8:00892@X03a4L2PTB2Q4L2PT92Q4L2PT92PTB2PT92P0000T92Q4L
2P00014L2PT92PTB2P052@T:00@94PX000092@X000022A8:00@92@X00000
00092A@22A8:00T000092@X000094PX92@X000094PX000094PX00PT92P06
00004A`:000000002A8:00000`T92P0400004A`:2@T:00000PT92P082A8:
00002@T:;1808a`:4A`:8a`:4A`:0THV2P0:8a`:;180?A`:ARHD;2HD4A`:
;1`D8blN=2lY=2lc0PT92P086PT:4BHD6Q8D8blYAT4N8blN?Blm;2HD0R<_
<`0>;3PY;2HD8a`:6Q8D00002@T:00002@T:00002A8:00002@T:00002A8:
0P0000032@T:2A8:000000H92@X010TB2P0000TB2PTB2P/92@X01A4L2PT9
2PT92PT92P0000052@T:00H94PX92@X94PX92@X94PX000032@T:00<94PX0
00092@X00PT92P0@2A8:2@T:2A8:2@T:2A8:2@T:2A8:2@TD2A8:2@T:2A8:
2@T:2A8:2@T:4A`:00000PT92P072A8:2@T:2@T:2A8:2@T:2A8:2@TD00H9
2@X00a4L2PT92PT92P022@T:00<A70X92@X92@X00PT92P030000YZ6Hc<c<
063<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<
c<`00oooolc<c<c<c01Mc<c<00LJ4Q@92@X94PX92@X94PX92@X94PX010T9
2P062A8:2@T:2@T:2@T:6PT:2@T:0PTB2P0800002A8:2@T:2A8:00002@T:
2A8:00000`T92P894PX2000010T92P0400002@T:2@T:2A8:0PT92P042A8:
00002@T:2A8:0PT92P044A`:2A8:2@T:2A8:0PT92P0900002@T:2@T:0000
2@T:00002@T:6PT:2@T:008A70X020T92PTB2PTB2PT92P0000T92P0000TB
2P8000000`TB2PT92PTB2P02000000<94PX0000A70X00`0000042@T:0000
2@T:00000`T92P0300002@T:000000<92@X0100000TB2PT92P0000892@X3
000000@92@X94PX/4P0S70X2;18000<m70XS9PXm70X00SdL2P094BH:ARHD
?A`:?A`:6Q8D?A`:AT`m4BHD2@T:008A70X012`L51XL7S@_:C@_<`8/9Q@0
12`L52`V52`V52<_7P8J9Q@02A4L2PT92PTB2PT92P00014L2P0000TB2PT9
2P02000000H94PX0000A70X000094PX000042@T:00D94PX92@X/4P092@X9
4PX010T92P0300002@T:2@T:00H92@X00a4L2PT92PT92P0>2@T:00<94PX9
2@X92@X00PT92P894PX0100000T92Q4L2P0000l92@X01`TB2P0000T92QXB
50TB2PT92P0000072@T:00P94PX92@XA70X92@XA70X92@X0002=V8iQc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?o
ooo<c<c<c<`0GLc<c0034BHD4A`:6Q8D00894PX01Q4L2PT92PTB2PTB2PT9
2PTB2P892@X020TB2PT92PTB2PTB2P0000T951X92P0000894PX010T92PTB
2PT92PT92P894PX01@T92P0000T950TB2P0000022@T:01094PX92@X94PX0
00092@X000094PX000092@X94PXA70X0000J2@X94PX0000J2@X22@T:00H9
4PX92@XA70XA70X000094PX22@T:00XA70X92@XA70X0000J2@XA70X94PX9
2@X000094PX22@T:00P000094PX92@X000094PX000092A@94PX2000000H9
4PX000092@X92@X0000A70X22@T:00@000094PX0000A70X32@T:00P00009
4PX94PX92@X000094PX92@X000022A8:0`T92P068a`:4A`:6PT:8bH:?A`:
8a`:0THV2P09?A`:8a`:ARHD;2HDARHD;2HD=2lcEeEB2@T:008A70X01aX9
2QXV52`h:DI<?C@_<aXB52<V2P02=2lY00DJ71h/9Q@/71@A70X94PX00PT9
2P0500002@T:2@T:2@T:000000<94PX22@T:00P000094PX92@X0000A70X9
2@XA70X92@X22A8:00<92@XA70X92@X00PT92P032A8:2@T:2@T:00D92@X0
0a4L2PT92Q4L2P022@T:00@A70X92@X92@XA70X22@T:00@A70X92@X94PX9
4PX52@T:00D94PX92@X92@XA70X94PX00PT92P032A8:2@T:2@T:00/92@X0
1Q4L2PT92PT92PT92PTB2PT92P894PX00`T92QXB50TB2P032@T:00<A70X9
2@XA70X00`TB2P892@X01A4L2PT92Q4L2P0009FHX`1Qc<c<00AVIVJ8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0
GLc<c0032A8:2@TD6Q8D00D94PX00`T92PTB2PT92P032@T:00H94PX92@X9
4PXA70X000094PX52@T:00T000094PX92@X000094PX92@X94PX92@X00000
0`T92P072A8:2@T:2@T:2A8:2@T:00002@T:00894PX01@0000TB2PT92PT9
2Q4L2P022@T:00@A70X92@X94PXA70X42@T:00@94PX92@XA70XA70X22@T:
00<94PX92@X92@X00`T92P0400002@T:2@T:00000`T92P0400002A8:2A8:
2@T:0PTB2P032@T:00002A8:00894PX42@T:00@000094PX92@X94PX22@T:
00<000094PX92@X00PT92P0300002@T:000000892@X0114L2R<L2R`B02`B
00<S70X012<V2R<L2R<V2R<V2P8/9Q@05b<L2R<_7R`h:B=1DR<L2QXB51X9
2QXB52`h:C@_:EMEDS@_7R<V2R`L54I17R`V51XL7R<L2QX92Q4L2PTB2PT9
2PTB2P032@T:00@A70X0000A70X000052@T:00@J2@X92@X92@X94PX22@T:
00HA70X92@X94PXJ2@XA70X94PX32@T:00L94PX92@X92@X94PXA70X0000A
70X00PT92P034A`:2@T:2@T:00H92@X01@TB2PT92PT92PT92Q4L2P032@T:
00<94PX92@X92@X00PT92P032A8:2@T:2@T:00@92@X00`TB2PT92PT92P03
2@T:00<94PX92@X92@X010T92P032A8:2@T:2@T:00892@X01`TB2PT92PT9
2PTB2PT92PTB2Q4L2P022@T:00<94PX92@X94PX00PT92P044A`:2@T:0000
SIR>HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<
6/c<c003ooooc<c<c<c<05g<c<`32@TD00l94PXJ4Q@94PX92A@92@X971h9
4PX92@X94PX92@X94PX0000971h94PX000000PT92P894PX01@T92PTB2PT9
50TB2P0000022@T:00<J4Q@000092@X00PT92P052A8:2@T:2A8:2A8:2@T:
00<94PX01@T92PTB2P00000000T92P052A8:00PA70X92@X92@X94PX92@X9
4PX92@XA70X22@T:00HA70X92@X92@XA70X92@XA70X32@T:00<A70X92@X9
2@X00`T92P0@2A8:2@T:2A8:2@T:00002@T:00002A8:00002A8:00002A8:
00002@T:00002A8:0PT92P072A8:2@T:2A8:2@TD2@T:2A8:000000D92@X0
2`TB2PT92PT92PT92R`B01X92R<L2QX92QXB52`B02`L50058a`:018J9Q@/
71@d;bTd;bTdEBTA70X92@X971@/71@d;bTd;c=?Ie`J71hJ4Q@/71@/9Q@/
>2TS70X24A`:0PT92P0700002@T:2A8:00002A8:00002A8:00<92@X22A8:
00<92@X94PX92@X00PT92P084A`:2@T:4A`:2A8:4A`:2@T:4A`:2@T:0`TB
2P892@X02@0000TB2Q4L2PT92PTB2PT92Q4L2PT92Q4L2P082@T:00LA70X9
2@XA70X92@X94PX92@X94PX010T92P042A8:2@T:2@T:2A8:0PT92P894PX0
0`T92PTB2PTB2P022A8:00D92@X94PX92@X92@X94PX00PT92P032A8:2@T:
2@T:00892@X00`TB2PT92PTB2P022@T:00<A70X94PX94PX01@T92P072A8:
2@T:4A`:2@T:2A8:0000UHB>067<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00XJ4Q@94PX9
2A@92@X94PX92@X94PX971@/9Q@92A@32@T:00<94PX92@X92@X010T92P0:
2A8:2@T:2@T:2@T:00002@T:2A8:00002@T:00000`T92P032A8:00002A8:
008000001PT92P0000T92P0000TB2P0000892@X00`0000T92P0000022@T:
00TJ2@X000092@XA70X94PX92@X94PX92@X000000PT92P084A`:2A8:4A`:
2@T:4A`:00004A`:2A8:0P0000082@T:00002A8:00002@T:00002A8:0000
0PT92P032A8:2@T:2@T:00T92@X00`0000T92PT92P03000000D94PX92@X0
00092@X000000PT92P0C00004A`:2@T:2@T:8a`:2@T:8a`:4A`:;1808a`:
;1808a`:8bH:6PT:;1`D;2HD;1`D;2HD=2lN0096@Ah04c@_:B<_7R<_:B<_
7Sd_?DmNITI<?B`B02`L51X92R`L52<L2QXB50TB2PT92P0000T92Q4L2P00
00052@T:00<94PX92@X94PX00P0000062A8:6Q8D2A8:2A8:2@T:2A8:0PT9
2P0700002@T:4A`:2@T:4A`:2@T:000000D92@X32A8:00<A70X92@XA70X0
0PT92P034A`:2@T:4A`:00892@X00a4L2PT92PT92P032@T:00<94PX00009
2@X010T92P0600002@T:2@T:2@T:4A`:00000PTB2P0500002A8:2@T:0000
2A8:00<92@X010TB2PT92Q4L2PTB2P@92@X01@TB2P0000T92PTB2P000007
2@T:00T94PX92@X92@X94PX92@XA70X94PX00023Q7/0HLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<
05g<c<`22A8:00L92@XA70X92@XA70X92@X94PX92@X00Q4L2P892@X00`TB
2PT92PT92P052A8:00X92@XA70X92@X92@XA70X92@X000094PX92@XA70X7
2@T:00<A70X0000A70X00PT92P062A8:2@T:00004A`:2@T:4A`:0`T92P09
4A`:2A8:00002A8:2@T:4A`:00002@T:2A8:00892@X01A4L2QX92Q4L2PT9
2Q4L2P042@T:00<0000A70X92@X01`T92P8000022@T:00<000092@X94PX0
0`T92P0300002A8:2@T:00D92@X00`0000TB2P0000032A8:00hA70XJ4Q@0
00094PXA70XA9PX/4P0J2@X/4P0J4Q@J2@XA70XS70XJ2@X38a`:0b`V5009
=2lN=2lc=2lY;3PY8blc=2lcAUEBEei_;3PY008A70X00b`L514L2PT92P02
2@T:00<A70X92@X92@X00PT92P032A8:2@T:2A8:00894PX01PT92P0000T9
2PT92P0000TB2P@92@X0200000TB2PT92Q4L2PT92PTB2Q4L2PT92P894PX0
1a4L2P00014L2P00014L2PT92PTB2P022@T:00</71@J4Q@A70X05`T92P03
2A8:2@T:6PT:00892@X22A8:00<92@XJ2@X94PX010T92P032A8:2@T:2@T:
00892@X020TB2PT92PT92PT92PTB2PT92Q4L2PT92P8A70X32@T:00TA70X9
2@X92@X92@XA70X92@XA70X0002EQ7/0HLc<c004IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`01Q4L
2PT92Q4L2PT92PT950TB2P892@X01PTB2Q4L2PT92PT92PTB2PT950894PX0
0`T92P0000T92P022@T:00<A70X000092@X00PT92P064A`:6Q`N00002A8:
2@T:2A8:1@T92P0;2A8:00002@T:00002A8:2@T:00002@T:4A`:00002A8:
00892@X01Q4L2PT92Q4L2QX92PTB2Q4L2P892@X00a4L2P0000T92P024A`:
00<92@XA70XA70X010T92P0900002@T:2@T:2@T:00002A8:00004A`:0000
00<92@X01@00014L2PT92PT92P0000022A8:00<92@X000092@X01PT92P03
00002@T:2@T:00<92@X2000000<92@X000092A@00PT92P056PT:8a`:8a`:
4A`:;18000@S70X00b`B014L2R`L5002;1`D00@d;ahd;c=6@Ai6C3d2?Blm
00Q6C3d/EEa?Ie`J2@XA70XJ2@X/4P0A70X92@T:00@94PX92@X000092A@2
2@T:00<94PX92@X92@X01@T92P032A8:2@T:2@T:00892@X00a4L2QX92Q4L
2P022@T:00T94PX92@X92@X92@X94PX92@XJ2@XA70X92@X00QXB50032@T:
4A`:4A`:01@92@X00`TB2PT92PTB2P022@T:00<A70X92@X92@X01PT92P03
2A8:2@T:2@T:00@92@X01@TB2PT92PT92PT92PTB2P022@T:00<94PX92@X9
2@X01@T92P064A`:00006Q8D2A8:0000Phf4HLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`0
1Q4V50T950TB2PTB2QXV51XB50<94PX01PT950T92Q4V50T92PT950TB2P89
2@X32A8:0PT92P034BHN2A8:2A8:00892@X020TB2PT92PT92PTB2PT92PTB
2PT92PTB2P<92@X010TB2PT92PT92PT92P894PX00a4L2P0000T92P022@T:
00PA70X92@XA70XJ2@XA9Q@J2@X92@XA70X22A8:00H92@XA70X92@X92@XA
70XJ2@X24A`:00<94PXA70X92@X00`T92P072A8:2@T:2@T:2@T:00002A8:
000000D92@X22A8:00D000092@X92@X92@XA70X01`T92P062A8:00002A8:
2A8:00002@T:0PTB2P0300002A8:2@T:00<A70X00a4V2QX92Q4L2P026PT:
0b<L2P8/71@01B`V53dL2S@_:DI17S@_<`02AUEB00Lm;ce6GTMGGVm6C3d0
000/4P0J2@X02PT92P0<2A8:00002@T:2@T:4A`:00002A8:00002@T:2@TD
2@T:2A8:0PT92P032A8:00002@T:00892@X01a4L2PT92PT92Q4L2PT92PTB
2P0000022A8:00H92@XA70X92@X92@X94PXJ4Q@22@T:0Q4L2P<92@X010TB
2PT92Q4L2PT92P894PX52@T:00<94PX92@X94PX00`T92P044A`:2@T:2@T:
2@T:0`TB2P032@T:2A8:2@T:00892@X01PTB2PT92Q4L2PTB2PT950TB2PL9
2@X01@T9500000TB2PTB2Q4L2P042@T:0PTB2P892@X01@TB2PT950TB2PT9
58=kG01Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<
c<`Jc<c<00?oooo<c<c<c<`0GLc<c0042@T:6Q8D2@TD2A8:0`T92P894PX0
10T950T92PTB2P0000L94PX01@T92PTB2PT92PT92P0000042@T:00@00009
2@X92@X92@X22A8:00@92@X000094PX000022@T:00<94PX000092@X00PT9
2P0400002A8:2@T:2@T:0a4L2P<92@X00`TB2PT92PTB2P0200000Q4L2P0:
6PT:4A`:8a`:6PT:2@T:4A`:2A8:2@T:2A8:00000`T92P894PX22@T:00/0
00094PX92@X92@X94PX000092@X000092@X94PX000000PT92P894PX01PT9
2P0000T92PTB2P0000T92P8000000`TB2P00000000052@T:00D/4P0J2@X/
4P094PXJ4Q@00R`B00<S70X032`L52<L2R`L53@_7S@_:C@_<dI<?EMEDTI<
?DIEDUMNKdmWA`8A70X011X92Q4L2Q4L2PTB2P@92@X00`TB2P0000TB2P02
2A8:1PT92P042@TD00004A`:00001PT92P034A`:2@T:2@T:00@A70X01@T9
2Q4L2PT92PTB2P0000032@T:00@94PX92@X92@XA70X22@T:00<A70X92@X9
2@X00`T92P032A8:00002@T:00D92@X00a4L2P0000T92P052@T:00<94PX0
00092@X00PT92P0>2A8:00002@T:2@T:4A`:2@T:2A8:2@TD6PT:00002@TD
00002@T:4A`:20T92P034A`:2@T:2@T:00L92@X011XB50TB2QX92W9EDV7<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`0
0oooolc<c<c<c01Mc<c<00HA70X92@XA9Q@92A@A70X94PX42@T:00HA70X9
2A@92@X94PX92@X94PX22@T:00L000094PX92@X92@X000092@X94PX00`T9
2P0300002@TD2@T:00<92@X01@0000TB2PT92PT92P0000022@T:00/00009
4PX0000000094PX000092@X000094PX92@XA70X00PTB2P8A70X01@TB2PT9
2PT92P00014L2P042@T:00H0000A70XJ2@X94PX92@X000042@T:0`000004
2A8:2@T:2@T:2@T:0P0000042@T:00002A8:2@T:0P0000052@T:2A8:6Q8D
6Q8D000000<92@X00`0000T92P0000062@T:014000092@X92@X94PXJ2@X/
4P0J2@XA70X/4P0J4Q@J2@XS70X/4P0S70XS9PX/4P0J4Q@00S@_:@07=2lc
EeEBCfMLCeiVEeEBEfMB4BHN00D92@X01`0000TB2P0000T92PTB2P0000TB
2P02000000X94PX000092@X92@X000092@X94PX0000A70X000022@T:00<0
000A70X92@X00PTB2P892@X01AX92PTB2Q4L2QX92PT950082@T:00D00009
2@X94PX92@XA70X00PT92P044A`:2@T:2@T:2A8:0PT92P032A8:2@T:2@T:
00<92@X00`0000T92PT92P062@T:00<94PX92@X92@X010T92P0<2A8:2@T:
2@T:2@T:2@TD00002@TD?A8:Ea`0ARHD2@T:2A8:0`T92P044A`:2@T:0000
2@TD0`T92P052A8:2@T:2@T:4A`:0000008A70X01@T92PTB2P0001XB55MW
DP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`J
c<c<00?oooo<c<c<c<`0GLc<c0062@TD4A`:2@TD4A`:2@TD2@T:0Q4L2P08
2A8:2@T:2A8:4A`:2@T:2A8:2@T:2A8:1@T92P042A8:2@TD2@T:2A8:1PT9
2P032A8:2@T:2@T:00H92@X00a4L2PT92PT92P022A8:00d000094PX00009
4PXA70XJ4Q@92A@J2@XA70X94PX92@XJ2@XA70X010T92P@A70X01B`V50T9
2Q4L2PT92Q4L2P022@T:00<A70X92@X94PX020T92P032A8:2@T:2@T:00<9
2@X01PTB2P0000TB2QXB50T92PTB2P892@X010TB2PT950T92PTB2PP92@X0
1a4L2QX92R<L2Q4L2QX92Q4L2QX92P048a`:00d/71@/9Q@d;ahm70Xd;c=P
@BU?IeaGEE9GGVmZLUa?GVH000094PX02@T92P0600002@T:2@T:2A8:2@T:
2A8:1`T92P0400002A8:2@T:2A8:10T92P054A`:2@T:2@T:2@TD6PT:008A
70X22@T:00@94PX92@X92@X94PX32@T:00@A70X92@XA70X92@X24A`:00<9
2@XA70XA70X010T92P034A`:2@T:2@T:00`92@X010TB2PT92PT92PTB2P89
2@X01PTB2Q4L2PT92PT950000?nc00;of@003?of0?oI00T92PT92PTB2Q4L
2QX92PT92QX92PTB2PT92PTB2P892@X01PTB2PT92PT92PT92Q4L2PTB2P89
2@X010TB2QXB500009F4SV7<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00X92@X92A@A9Q@9
2@XA70X94PX92@X/9Q@92A@A70X22A8:00PJ4Q@94PX94PX92A@92@X94PX9
2@X94PX22@T:00<94PX92@X000000PT92P052A8:2@T:2A8:2A8:00000089
2@X010TB2QXB50T92PTB2P892@X02PTB2PT92P0000TB2P0000TB2P0000T9
2PTB2PT92P8A70X00`T92Q4L2R`B00024A`:00D94PXA70X000094PXA70X0
0aX92P054A`:6PT:8bH:4A`:2@T:00894PX00`0000T92P0000052@T:00<0
00092@X92@X00PT92P032A8:2@T:2@T:00`92@X00`TB2P0000T92P022@T:
00<000094PX000000`T92P036PT:8a`:;180008S70X03A4L2QX92QX92R<L
2R`L52<L2R`L53@_:DHV54I<?DIEDUMEDTmNIP02H79k00<971@92@X94PX0
0PT92P894PX62@T:00<94PX92@X000000PT92P032A8:2@T:2@T:00892@X0
0`TB2PT92PT92P022@T:0PTB2P036Q8D2@T:2@T:00892@X34A`:00/J2@X9
2@X94PX000092@X94PX92@X000092@X94PXJ2@X00`T92P034A`:2@T:2@T:
00892@X00`0000TB2QXB500D2@T:00@94PX92@X94PX94PX22@T:00/m4P[C
Q02`LP3f/`2EE@1b9P2iI`3of@1G70092@XA70X010T92P042@TD2@T:2A8:
2@T:0PTB2P0:2@T:4A`:2@T:2@T:4A`:2@T:6Q8D2@TD0000`LO<HLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003oooo
c<c<c<c<05g<c<`0114V50TB2PT9514L2P892@X00a4L2PTB2PTB2P022A8:
0PT950032A8:2@T:4A`:00@94PX01PT92PTB2PTB2PTB2PT92QXB50894PX0
0aX92PT950TB2P022A8:00<92@X94PX94PX01PT92P044A`:00002A8:0000
0PT92P894PX24A`:00HS70XJ2@XA70XA70XA9PXJ2@X24A`:00D92@X94PXA
70X92@XJ2@X00Q4L2P032@T:6PT:4A`:00@92@X01PTB2PT92PTB2PT92PT9
50TB2P892@X00`TB2PT92P0000022@T:00<94PX92@X92@X010T92P032A8:
2@T:2@T:00D92@X00`TB2PT92PTB2P022A8:0`T92P062A8:4A`:8a`:8a`:
4BH:6Q8D0R`B00048bH:8a`:8a`:;1`D0R`V5003=2lY=2lcAT`m009?GVH0
2EMNKdINA`0000TB2P0000T950TB2P0000TB2P022@T:00X94PX92@X92@X0
00092@X94PX92@XA70X000094PX22@T:00@94PX92@X92@X94PX22@T:00`A
9PX94PX92@X92@X94PXA70X92@X94PX92@XA70XJ2@XA9Q@22A8:00@92@X9
4PX92@X94PX42@T:00@A70X92@X94PX92@X24A`:00<94PX92@X94PX010T9
2P032A8:2@T:2@T:00894PX01PT92Q4L2PT92PT92PTB2PT92P894PX00`T9
2Q4L2PTB2P032A8:00<92@X94PX92@X00PT92P09Pbl0om00LRH0ok<0Ea`0
2@TD/4`0om00Ea`000892@X0114L2PT92PT92PTB2P892@X03PTB2PT950TB
2PT92PTB2PT92PTB2PT92PTB2PT92PT950T92P000<77c67<c<`016IVIXS0
^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<
c01Mc<c<0PTB2P046Q8D2A8:2A8:4A`:10T92P082A8:6Q8D6Q8D2@TD2A8:
6Q8D2@T:2A8:0PT92P0300002A8:2A8:00892@X01AXB50T92PT92PT92PTB
2P022@T:00D94PX92@X92@X000094PX01@T92P0500002A8:2@T:00002A8:
00<92@X01aX92PTB2PT92Q4L2PT92QX92R`B00032@T:00<000092@X94PX0
0Q4L2P892@X0214L2PT92PT92Q4L2PT92PTB2PT92PTB2P892@X22A8:1@T9
2P032A8:2@T:2@T:00894PX00`T92PTB2PT92P032@T:00@94PX000092@X0
00032@T:00<000092@X92@X00PT92P0500004A`:00004A`:6PT:008S70X0
1B`B02<L2R<L2R<L2QX92P038a`:00</9Q@d;ahd;c<00UMEDP04CeiVLW9k
CfML4BH:0PT92P0400004A`:00002A8:0`T92P0300002A8:2@T:00894PX0
2@0000TB2PT92PT92P0000TB2PT92P0000TB2P032@T:0PTB2P0400002@T:
2@T:2A8:0PT92P0:4A`:2@T:4A`:4A`:6PT:4A`:2@T:2A8:2@T:000010T9
2P062A8:2@T:4A`:2@T:8a`:4A`:0PTB2P892@X01@TB2Q4L2PT92PT92Q4L
2P072@T:00D94PX92@X92@X92@X94PX00PT92P0B2A8:2@T:2@T:2@T:2A8:
2@T:2A8:2@T:Pbl0ooH0LRH02@TDok<0H2l:0000^FL0om00Ea`010T92P03
4A`:2@T:2@T:00<92@X010TB2PT92PT92PTB2P892@X01Q4L2PT92PT92Q4L
2P000:Jc`F7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
olc<c1[<c<`00oooolc<c<c<c01Mc<c<00<92A@A70X92A@01PTB2P072@T:
2A8:2@T:4BHD2@T:2A8:2@T:00D94PX020T92PTB2PT92Q4L2PT92Q4L2PTB
2PT950894PX32@T:00L94PX92@X92@X94PX92@X94PX92@X00PTB2P062@T:
00002A8:00002A8:00000Q4L2P036PT:4A`:;18000<A70X00`T92Q4L2PT9
2P022@T:00@A70XJ2@XJ2@X92@X24A`:00D92@X94PXA70X92@X000000`TB
2P892@X00`0000TB2Q4L2P022@T:00PA70X92@X92@X92@X94PX000094PX9
2@X22A8:0`T92P0300002@TD4A`:00892@X00`TB2PT92PTB2P032@T:00L9
4PX000094PX92@XJ2@XS70X/4P000R<L2P03;1804A`:;180008S70X02B`L
53@_7S@_:DI17UMEDTmNIW9EDX>4SR<_<`022A8:0PT92P052A8:2@T:2@T:
2@T:2A8:00892@X01`0000TB2P0000TB2PT92P0000TB2P032@T:00<00009
4PX92@X010T92P894PX00a4L2PT92PT92P022A8:00<92@XA70X92@X00Q4L
2P894PX00`0000TB2PT92P022A8:00X92@X94PX94PX92@XA70X0000A9Q@9
2@XJ2@X94PX22@T:00DA70X92@X92@X92@X94PX00`T92P032A8:2@T:2@T:
00892@X00a4L2PTB2PTB2P022@T:00<A70X92@X92@X00`T92P0=2A8:2@T:
2@T:LRH0omT0Pbl00000omT0Ea`0?A8:/4`0om00Ea`000892@X01A4L2PTB
2PT92PT950TB2P022@T:00@94PX92@X94PX92@X22A8:0PT92P054A`:6Q8D
4A`:0000/;k1067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2h
R<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<0aXB50044A`:2A`D2A8:2@TD
0PTB2P@92@X22A8:00D92@X94PX000094PX92@X00PTB2P082@T:4A`:2@T:
2A8:6Q`N6Q8D2@TD2@T:0PTB2P0;2@TD2A8:2A8:2@T:2A8:2@T:2A8:2@T:
2A8:00002@T:00894PX01`0000TB2P0000T92PTB2PT92PTB2P024A`:00DA
9Q@94PXJ2@XA70X94PX00PT92P034A`:2@T:2@T:008A70X020T92QX92Q4L
2PT92PTB2P0000T92PTB2P892@X020TB2PT92PTB2PT92PTB2PT92PTB2P00
00H92@X00`TB2P0000TB2P022@T:0PTB2P0;00002@T:2A8:2A8:00002A8:
00002A8:2@T:2A8:000000892@X01`TB2QX92R<L2R<L2SdL2R<L2R`L5004
8a`:00@/71@d;ahd;c=6C3d3CeiV00EZNh@971@A9Q@92@X94PX00`T92P05
2A8:2@T:000000002A8:00`92@X22A8:0`T92P062A8:000000002@TD2@T:
4A`:0PT92P064A`:2@T:4A`:2A8:4A`:2A8:0`T92P0600002A8:6PT:2A8:
2@T:4A`:0PT92P034A`:2@T:2A8:00894PX00`T92PTB2PT92P022@T:00@9
4PXA70X92@XA70X32@T:00<94PX92@X94PX00PT92P044A`:2@T:2@T:4A`:
1`T92P05?A8:i:X08a`:0000H2l:00?of@001@T92PTB2PT92PT92Q4L2P04
2@T:00HA70X94PX92@XA70X92@XA70X32A8:00HA70X92A@92@X92A@0002`
_/5Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`J
c<c<00?oooo<c<c<c<`0GLc<c0064A`:2A8:2A8:2@TD2A8:2@T:0PTB2P03
00002A8:2A8:00<92@X010TB2PT92PT92PT92P894PX01@T92PTB2PTB2PT9
2PTB2P022@TD00L94PX92@X94PX94PX92@X94PX0000020T92P062A8:0000
2@T:2@T:00002@T:0PTB2P084A`:6PT:6PT:4A`:;1804A`:2@T:2A8:0PT9
2P0500002@T:2@T:2@T:6PT:008A70X00`T92Q4L2PT92P032@T:00@00009
2@X94PX000072@T:00<000092@X000001PT92P062A8:000000002A8:0000
2@T:0P0000062A8:2@T:2@T:00002@T:00001@T92P05;1806PT:4A`:;1`D
;18000@S70X022`V53@_:DI17TIEDUMEDTmNIV1bNfYkQ0<000042@T:00P0
00094PX92@X92@X000092@X000094PX22@T:00X94PX92@X92@X94PX92@X0
00094PX000092@X94PX52@T:00<S;bT92@X92@X01@T92P03;1806PT:2A8:
00`92@X00a4L2PT92PTB2P032@T:00<94PX92@X92@X01@T92P032A8:0000
2@T:0080000010T92PTB2PT92P0000X92@X2000000H92A@00031Q02VI`2=
E@X000082@T:00<000092@X92@X020T92P044A`:00000000UJ6gHLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003oooo
c<c<c<c<05g<c<`00a4V50T92PTB2P022@T:00<94PX92@X000001PT92P03
00002A8:2@T:00<92@X0100000T92PT92P0000892@X010TB2PT92PT92PTB
2PH92@X00`0000T92P0000032@T:00<000092@X000000PT92P<000001`TB
2PT92Q4L2Q4L2PT92QX92PT92P02000000P94PX000092@X94PXA70X94PXJ
2@XA70X22@T:00@94PXA70X0000000022@T:00@000092@X92@X94PX22@T:
00@000092@X92@X000042@T:00@000092@X000094PX32@T:00<000092@X0
00000PT92P0600002@T:2@T:2@T:00002@T:0P0000072A8:00004A`:6PT:
8a`:;180?A`:008/4P028a`:00T/71@d;ahd;bTd;ai6C3e?GVIGGVmbLW]6
GTL00P0000062@T:00002@T:2@T:00002@TD0`0000032@T:00002A8:0080
00001PT92P0000TB2P0000T92P0000D92@X00`0000TB2PT92P022@T:00<9
4PXA70X0000010T92P034A`:2@T:4BHN00892@X00`00014L2PT92P072@T:
00@A70X92@XA70X/71@52@T:00<000092@X92@X02PT92P0300002A8:0000
00<92@X00`0000T92PT92P022@T:00<94PX92@X92@X00PT92P0400002@TD
00002@TD50T92P034A`:0000YZZ]067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<0PTB2P07
4A`:2A8:2@T:2@T:4A`:2A8:4A`:00@92@X010TB2QX92PT92PT92P<94PX0
1@T92PTB2PTB2PTB2PT92P062A8:0PT92P062A8:2@T:2@T:2A8:2@T:2A8:
1PT92P084A`:00002@T:2A8:2@T:4A`:;1804A`:0R<L2P046PT:2A8:2@T:
2@T:0PTB2P032@T:4A`:6PT:008J2@X01A4L2QX92PT92PTB2QX92P062@T:
00<94PX000094PX00PT92P032A8:4A`:2@T:00P92@X00`0000TB2PTB2P02
2@T:00D94PX92@X92@X000094PX00PT92P032A8:2@T:2@T:00<92@X26PT:
12<L2P098bH:;1`D?A`:;2HD=2lN=2lYAT`mLUEBEei_009PLW/00b<_<`00
00TB2P052@T:00H94PX92@X92@X92@X000094PX72@T:00<94PX92@X92@X0
10T92P0@2A8:2@T:2@T:00002@TD2@T:00002@TD2@T:4A`:6PT:4A`:2@T:
4A`:6PT:4A`:10T92P0;6PT:2@T:2@T:2@T:2A8:4A`:2@T:6Q8D2@T:4A`:
2A8:00/92@X011XB50TB2R<L2PTB2Q092@X0114L2PT92QX92PTB2P8A70X5
2@T:00HA70X0000A70X92@XA70X92A@22A8:10T92P0700004A`:2@T:6Q8D
2A8:2@T:UJ6g067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2h
R<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00PJ4Q@92A@92A@94PX92A@A
70X92A@92@X42A8:0PT92P062A8:2@T:2A8:6Q8D2@T:4A`:0`T92P032A8:
2@T:2A8:00892@X00`T950TB2PTB2P022A8:10T92P034A`:2A8:2@T:0089
2@X030TB2PT92PTB2P0000T92PTB2P0000TB2QX92Q4V7Q4L2R`B008A70X0
4@TB2PT92QXB500000T92PTB2Q4L2QX92R<L2QX92Q4L2QX92PT92Q4L2QX9
2PT92PTB2P032@T:00LJ4Q@000092@X92@X94PX92@X94PX00PT92P044A`:
2A8:2@T:2A8:1@T92P032A8:2@T:2@T:00H92@X00`TB2P0000T92P052@T:
014A70XJ2@XS70X/71@S70Xm70XS9PX/71@d;ahS;ahd;c=P@BTd;c=?GVIb
EE9bIe9?GVH00PTB2PH92@X01@0000T92PT92PT92PTB2P032@T:00<A70X9
2@X94PX00`T92P062A8:2@T:2@T:2@T:2A8:00000PT92P032A8:2@T:2@T:
00D92@X24A`:00@94PXA70XA70X92A@72@T:00PJ4Q@92@X92A@94PX92@X9
4PXA70X92A@F2@T:00L94PX92@X94PX94PX92@X94PXJ4Q@01@T92P032A8:
2@T:2@T:00892@X00a4L2PT92PT92P042@T:00LA70X92A@J4Q@92@X94PXA
70X94PX00a4L2P052@T:2A8:2@T:0000UJ6g067<c<`016IVIXS0^8S0^4R@
R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<
00P92A@92@X92@XA70X92@XA70X92@XA70X22@T:0PTB2P892@X020TB2PT9
2PT92PT92PTB2Q4L2PTB2Q4L2P892@X01A4L2PT92PT92PTB2PT92P022A8:
00@92@X94PX92@X94PX22@T:00D94PX92@X92@X92@X94PX01PT92P032A8:
00002@T:008A70X00a4V2QX92Q4L2P022A8:00@000092@X92@X92@X24A`:
00@92@XA70XJ2@XA70X22@T:00<J2@XA70X92@X00PT92P034A`:00002@T:
00P92@X01PTB2P0000T92PT92PTB2P0000D92@X020TB2P0000T92PT95000
00TB2PT92PTB2PP92@X01b<L2R`B02`B02<L2R`L52`V53@_:@02ARHD00Hd
;c=6C3eGGVmbLW]GGVm6GTL22@T:00@000092A@92@X94PX22@T:00<94PX9
2@X92@X00P0000892@X00`0000T92P0000032@T:0PTB2P892@X00`TB2PT9
2PT92P082@T:00@J2@X92@X92@X92@X26Q8D0Q4L2P052A8:2@T:2@T:2@T:
4A`:00892@X02@TB2PT92Q4L2PT9514L2QXB50TB2Q4L2PTB2P072@T:00<A
70X94PX92@X02PT92P032A8:00002@T:00<92@X01@TB2QXB50T92PT92Q4L
2P022@T:00<A70X92@X92@X00PT92P032A8:2@T:2@T:00<92@X00`TB2PT9
2Q4L2P082@T:00DA70X92@X92A@0002EZZd0HLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`0
1A4V50TB2Q4L2PT950T92P032A8:0PT92P052A8:2@T:2A8:2@T:2A8:00T9
2@X01`TB2PT92Q4L2PT92PTB2P0000TB2P032@T:00<92A@94PX94PX00PT9
2P0300002@T:2@T:00892@X010TB2PT92PT92PTB2P892@X02QX92Q4L2R`B
014L2QX92R`B00T92QXB500000TB2P<92@X02AX92Q4L2QX92Q4L2QX92Q4L
2P0000TB2Q4L2P032@T:00<000094PX94PX02@T92P062A8:2@T:2@T:0000
2@TD2@T:0`TB2P0500002A8:2A8:2A8:000000<92@X00`0000TB2PT92P03
2@T:00@94PX92@XA70XA70X38a`:00@/71@d;aiP@BU6@Ah3AT`m00]bEE9P
LW]GGVld;c<000092A@A70X000092@X000092A@00PT92P0300002A8:2@T:
00D92@X00`TB2PT92PTB2P022@T:00D000094PX92@X000094PX00PT92P05
2A8:2@T:2@T:00002A8:00H92@X01AX92Q4L2QX92QX92PTB2P072@T:00LA
70X92@X92@XA70X92@XA70XJ2@X00PT92P072A8:2@T:2@T:2@T:4A`:2@T:
000000892@X00`TB2PT92PT92P022A8:2PT92P052@TD2@T:2A8:2@T:4A`:
00892@X00a4L2PT92PT92P042@T:00<J2@X94PX94PX010T92P034A`:2@T:
2@T:00892@X00a4L2PT92PT92P022@T:00@A70X92@X0002EXKMQc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<
c<c<c<`0GLc<c0062@T:2@TD2@TD4A`:2@T:2A8:0PT92P042A8:2@TD4A`:
2A8:1PT92P894PX42@T:00@92A@94PXA70X94PX22@T:0PTB2P062@T:4A`:
2@T:2@T:00002A8:1`T92P0500002A8:00002@T:0000008A70X00b<L2Q4L
2R`B00024A`:00/000092@X94PX000094PXA70X/9Q@92@XA70XJ2@XA70X0
0PTB2P032@T:6PT:4A`:00L92@X00`0000T92PT92P052@T:00<000094PX9
2@X00`T92P0900002@TD00002A8:2@T:00002A8:2@T:2@TD00<92@X010TB
2Q4L2QXB50TB2P<92@X041X92R<L2R<L2R<L2R`L54I17S@_:C@_<dI<?F11
:EMNKg9EDV1bNdmWG14V2PTB2P80000=2@T:00<A70X92@XA70X03`T92P03
2A8:2@T:2@T:00<92@X0314L2PT92PTB2Q4L2PT92PTB2Q4L2PTB2PT92Q4L
2PT92P0000<92@X01PTB2Q4L2Q4L2QXB50T92PTB2P<92@X01@TB2PT92PT9
2PT92PTB2P082@T:00<000092@X94PX010T92P032A8:2@T:4A`:00D92@X0
1A4L2PT92PT92PT92Q4L2P082@T:00<94PX92@X92@X00`T92P092A8:2A`D
4A`:2@T:4A`:2@T:4A`:0000Y[?1067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00<J4Q@A
70X94PX00`TB2P0:4A`:2@T:2@T:2@TD2A8:2@T:2A8:2@T:2A8:2@T:0PTB
2P<92@X22A8:00<92@X94PX92@X00PT92P032A8:2@T:2@T:00L92@X01000
00T92PT92PTB2PH92@X02PTB2PT92Q4L2QX92Q4L2QX92Q4V2QX92PTB2Q4L
2P8000000`TB2PT92PT92P024A`:00<S70XJ2@XA70X00`T92P034A`:6PT:
2@T:00<92@X01PTB2PT92PT92Q4L2PT92PTB2PL92@X01P0000T92PT92PT9
2Q4L2P0000892@X020TB2PT92PT9500002`V51XB50T92PTB2P892@X00`TB
2PT92PT92P032@T:00lS70X/4P0S70X/9Q@d;bTd;c=6@Ai6EE9GEE9bEE9P
LW]GGVm?Ie`000094PX01`T92P032A8:2@T:2@T:00D92@X00b<L2PT92Q4L
2P032@T:00<92A@94PX92@X01`T92P032A8:00002@T:00D92@X00aXB514L
2QX92P024A`:10T92P032A8:00002@T:00892@X00`TB2Q4L2QX92P034A`:
00P94PX92@X92@X92@X94PX0000A70X000022@T:00@92A@000092@XA70X5
2@T:00<000092@XA70X00PT92P044A`:2@T:4A`:2@T:0Q4L2P042A8:2@T:
2@TD4A`:1`T92P034A`:2@T:2@T:00<92@X03AXB50T92PT92PT92PTB2PT9
2Q4L2PT92PT9514L2PT950000:JZ[@1Qc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0054BHD
2@TD2A8:6Q8D2A8:00892@X01@TB2PT950T92PT92QX92P072@T:00D94PX9
2@X92@X94PX000003`T92P032A8:00002@T:00D92@X00`0000T92P000002
4A`:00HJ2@XA70X/4P0A70XJ2@XA70X32@T:00P000092@XA70XJ2@X92@XA
70X/4P0A70X22@T:00L0000J2@X92@XA70X000094PX000000PT92P030000
2@T:2@T:00<92@X01PT9500000TB2P0000T92P0000H92@X01@0000T92PTB
2PT92P0000022@T:00D000094PX000092@X000000PT92P0A00004A`:6PT:
6PT:8a`:8blN=2lYAT4N=2lcH44YEeEBCeiVEei_AUi78blc00002@T:0080
00001A4L2PT92PT92PTB2P0000022@T:00<94PX92@X92@X010T92P094A`:
2@T:2@T:2@T:2A8:00002@T:00002A8:00@92@X01@TB2P0000T92PT92P00
00042@T:00H94PX92@XA70XJ2@XA70XJ2@X22@T:00<000092@X92@X00PT9
2P062A8:2@T:2@T:2@T:2A8:6PT:2PT92P0300002@T:000001<92@X22@TD
00<000092@X92@X020T92P032A8:2@T:2@T:00<92@X00`TB2PT92PT92P05
2@T:00<A70X0002VZZd0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`02`T9514V51XB50T9
2PTB2PT92Q4L2PT9514L2PT92PTB2P022@T:00@94PX92@X92@X94PX52@T:
00<94PX92@X92@X00PTB2P042@T:6Q8D2@T:2A8:1@T92P032A8:2@T:2@T:
00<92@X22A8:0PT92P034A`:2@T:2@T:00<92@X01A4L2QX92Q4L2Q4L2QX9
2P052@T:0Q4L2P076PT:4A`:8bH:;1802A8:4A`:2@T:008A70X00aX92Q4L
2P0000022@T:00<94PX92@X92@X00`T92P894PX01`0000T92PT92P0000TB
2P0000T92P022A8:0PT92P042A8:2@T:2@T:00000`T92P034A`:2@T:6PT:
00894PX42@T:00h94PXJ2@XA70XS70XS;ahd;c<d;bU6@Ah/EEaGEE9GGVmb
EE8S;bT971@22A8:0PT92P0500002A8:2@T:2@T:2A8:00892@X00`0000TB
2PTB2P032@T:00@94PX92@X92@X94PX42@T:00@94PX92A@000094PX22@T:
00D94PX92@X92@X92@X94PX010T92P066PT:2@T:6PT:4A`:;1802A8:1`T9
2P0700002A8:2@T:6PT:6Q8D6PT:4A`:00L92@X00a4L2PT92PT92P032@T:
00<94PX92@X94PX01@T92P032A8:2@T:2@T:00892@X00`TB2Q4L2PT92P02
2@T:00X000092ACo/`23;`092@X94PX92@XA70X92@X94PX32@T:00<94PX9
2@X92@X00PT92P054A`:2@T:2A8:2A8:2@T:00894PX22@T:00<94PXJ2@ZE
XKL0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<
6/c<c003ooooc<c<c<c<05g<c<`020TB2QXB50T9514L2PT92Q4L2PT92Q4L
2P892@X0100000TB2PTB2PTB2PD92@X00`TB2PT92PTB2P032A8:10T92P03
4A`:2@T:2@T:00892@X02PTB2PT92PT92P00014L2P0000TB2PT92PTB2P00
00894PX02P0000T92PTB2PTB2PT92Q4L2QX92Q4L2PT92QX92P8A70X00`00
00TB2PT92P022A8:00DA70XJ2@X/4P0J2@XS70X00PT92P0800002A8:2@T:
4A`:6PT:4A`:2@T:2A8:0PT92P042A8:2@T:2@T:2A8:0`T92P034A`:2@T:
2@T:00@92@X01`00014L2PT92PT92P0000TB2PT92P022A8:00H92@X94PX9
4PX94PX92@X94PX22@T:00H94PX92@X92@X92@XA70XJ4Q@2;2HD00<S;ai6
@Ai6C3d00TI<?@08=5Dm4A`:2@T:00002@TD2A8:2@T:2A8:1@T92P0:0000
2@T:2@T:00002A8:2@T:2A8:2@T:00002A8:0PT92P062A8:2@T:2@T:0000
2@T:4A`:1`T92P062A8:2@T:2@T:00002@T:00000Q4L2P052@T:2A8:2@T:
2@T:2A8:00892@X00a4L2PT92PTB2P062@T:0Q4L2PL92@X0100000T92PT9
2Q4L2PP92@X01`TB2P0000TB2PTB2PT92QX92Q4L2P032@T:00N`C02iI`31
Q03TZP0/71@92@XJ2@X00`T92P054A`:2@T:2@T:2@T:4A`:00@92@X0114L
2PT92PT92QX92P892@X22A8:00@A70X92@X0002VZZeQc<c<00AVIVJ8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0
GLc<c0032@TD8blN2A8:00H94PX22@T:00<94PX000092@X00`T92P032A8:
2@T:2A8:00@92@X0100000T92PT92PT92P894PX01@T92PTB2PTB2P0000TB
2P052@T:00P000092@X92@X92@X94PX000092@X94PX200000PT92P054A`:
2@T:4A`:6PT:4A`:00892@X02`0000T92P0000T92QX92Q4L2QX92Q4L2PT9
2Q4L2P0000052@T:00<A70X92@X94PX01@T92P0;00002A8:2@T:00004A`:
2@T:00002@T:00002@T:2A8:00<000032@T:00<94PX000092@X00P00000;
2@T:2A8:00002@T:00002A8:00002@T:2A8:00002A8:008A70X011X92QXV
51XL7TI17P8d;bT00b`L500000TB2P02000000@94PX000092@X000022@T:
00<000092@X94PX010T92P800000314L2PT92P0000T92PTB2P0000T92PTB
2P0000TB2P0000TB2P892@X01@TB2PT92PT92PT92P0000022@T:00@0000A
70X92@X000022@T:00DA70X94PX94PX000094PX01`T92P054A`:2@T:4A`:
6PT:4A`:00L92@X00a4L2PTB2PT92P024A`:2@T92P042A8:4A`:2@T:2A8:
0PT92P072@TDPbl0omT0m[<0m/L:`H@0000000@92@X22A8:1`T92P034A`:
2@T:2@T:00D92@X22A8:00<A70X0002EXKL0HLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`0
1PTB2Q4V50T951XB50TB2PT950<94PX00`T92PTB2PT92P032A8:00D92@X9
4PX94PX92@XJ4Q@01@TB2P042@T:2A8:4A`:2@T:0`TB2P<92@X01@TB2PT9
2PTB2P0000TB2P062@T:0PTB2P@92@X01A4L2QX92Q4L2PTB2QX92P022@T:
00X94PX92@X92@X92@XA70XJ2@XA70X92@X94PXA70X:2@T:00<A70X92@X9
4PX00PT92P0500002@T:2A8:2@T:4BHN00L92@X01@T950TB2P0000T92PTB
2P042@T:00<94PX000092@X010T92P0>2A8:2@T:2A8:2@TD2@T:2A8:6Q8D
6RHD;1`D;3PY8blc6RHD2@T:2A8:10T92P032A8:2@T:2@T:00892@X010TB
2P0000T92PT92P894PX00`T92Q4L2P0000022@T:00D94PX92@X92@XJ4Q@9
4PX010T92P<94PX01@T92Q4L2PT92PT92Q4V7P022@T:00d000092@X92@X9
2@X94PXA70X92@XJ2@X94PX92@X94PXA70X92@X00PTB2P046PT:2A8:2@TD
6PT:0a4L2P056PT:2A8:2@T:2@T:2A8:00892@X010TB2PT92PT92PTB2P@9
2@X00a4L2PT92PT92P022A8:1@T92P0;4A`:2@T:4A`:0000Pbl0ooH0omT0
`H@000002@T:4A`:00892@X010TB2PT92PT92Q4L2P<92@X0414L2PTB2PT9
2PT92Q4L2PTB2PT92Q4L2PT92PTB2Q4L2PTB2QXB50T9500009FQ]f7<c<`0
16IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`00ooo
olc<c<c<c01Mc<c<00HJ4Q@92A@92@XJ4Q@A70X92@X22A8:00D92@X94PXA
70X94PX92@X00`TB2P032@T:2A8:2A8:00D92@X52A8:00@92@X94PX92@X9
2@X22A8:0`T92P052A8:00004A`:2@T:2A8:00@92@X00`0000T92PTB2P02
4A`:00</4P0A70X92@X00QX92P8A70X01@TB2PT92Q4L2PTB2QX92P034A`:
00D/4P094PXA70X92@X94PX010T92P<A70X010T92Q4L2PTB2PT92P894PX0
1@T92P0000TB2PT92PTB2P022@T:00DA70X92@X92@X92@X000000`T92P03
00002A8:000000<92@X00`TB2PT92PTB2P022@T:00L94PX92@X92@X92@X0
00094PX92@X00QXB508S70X011X92Q4L2PTB2PTB2P<92@X00aXB500000TB
2P022@T:00P94PX92@X92@X92@X94PX92@X000094PX22@T:00H94PX00009
2@X0000J4Q@A9Q@22@T:00/94PX92@X92@X92@X94PXJ4Q@A9Q@92A@92@XA
70X92@X00`TB2P892@X00`TB2PT92PT92P032@T:00`J2@X92@X94PXA70X9
2A@92@X94PX92@XJ4Q@A70X92@XJ2@X24A`:00<94PX92@X92@X03PT92P03
00002A8:2@T:00892@X04PTB2Q4L2PT92PT92PT9514L2PT959EE078V00T9
2PTB2Q4L2PT92Q4L2PT92Q4L2PT92Q4L2P@92@X00a4L2PT92PT92P022@T:
00D94PX92@X94PX92@X94PX00PT92P042@TD4A`:0000UJ6gHLc<c004IVIV
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<
c<c<05g<c<`00a4V50TB2Q4L2P022@T:00DA70X92@X92@X92@X94PX00PT9
2P052A8:2@T:2@T:2A8:2@T:00894PX42@T:00<94PX92@X92@X010T92P03
2A8:2@T:2A8:00892@X01P0000TB2PT92PTB2PT92P0000894PX32@T:00D0
000A70X92@X000094PX00PT92P042A8:4A`:6PT:4A`:1@T92P0800004A`:
8a`:6PT:;1804A`:6PT:4A`:30T92P046PT:00002A8:00000PT92P032A8:
00002A8:00892@X01A4L2PT92PTB2PT92PTB2P022@T:00<000092A@94PX0
10T92P0<2A8:2@T:00002A8:00002@T:2A8:00002@T:00002@T:2A8:0a4L
2P092@T:2A8:2@T:00002A8:00002A8:2@TD2A8:00<92@X00`0000TB2PTB
2P022@T:00<000092@X92@X00PT92P0400002@TD2@T:2@T:0P0000032A8:
2@T:2@T:00894PX22@T:0PT950082@T:4A`:2@T:2A8:00002@TD00002A8:
0PT92P044A`:2@T:4A`:4A`:0`T92P086PT:6Q8D=2lY4A`:2@T:4A`:2@T:
;1800Q4L2P8J2@X01`TB2PT92PTB2PT92P0000T92P0000042@T:00<94PX9
2@X92@X02`T92P074A`:2@T:2@T:2A8:00002@TD000000892@X01a4L2PT9
2PT950T92PTB2PT92Q4L2P042@T:0PTB2P032@T:2A8:2@T:00D92@X24A`:
00<92@X0002`_/40HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8
`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`01@T950T92PT92PT92Q4L
2P052@T:00<94PX000092@X01@T92P042A8:2@T:2@T:2A8:0PT92P032A8:
2@T:4A`:00892@X01AX92P0000TB2P0000TB2P042@T:00@J2@X94PX94PX0
00032@T:00h94PX000092@X0000A70X000092@XA70XJ2@XA70X92@XA70XJ
2@XA70X26PT:00/A70X94PXA70XA70XJ2@XA9PXS70XA70XJ2@X92@XJ2@X0
0`T92P032A8:2@T:2@T:00892@X00a4L2PT92PT92P042@T:00h94PX00009
2@X92@X94PX92@X94PX92@X000094PX000092@X000094PX300000PT92P03
2A8:00002A8:00894PX0100000TB2P0000T92P894PX0100000T92PTB2P00
00892@X010TB2P0000T92PTB2P892@X00aXB50T951XB50022A8:1PT92P06
4A`:00002A8:2@T:2A8:00001@T92P042A8:00002@T:2@T:0`TB2P036Q8D
2A8:2A8:00<94PX00`0000T92PT92P082@T:00<A70X92@XA70X00PT92P07
2A8:2@T:2@T:4A`:2A8:00004A`:00894PX00`0000T92PTB2P022A8:10T9
2P042A8:00002@T:2A8:0`T92P074A`:2@T:2@T:2@T:4A`:2@T:4A`:00<9
4PX01PT95000060_2^BZ0?nc0<6400892@X011X92X<_00T92PTB2PP92@X0
0`TB2PT92Q4L2P022@T:00<94PX92@X94PX00PT92P034A`:0000Y[?1067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`0
0oooolc<c<c<c01Mc<c<0a4L2P032A8:2@T:4A`:00<94PX32@T:0PTB2P<9
2@X22A8:00H92@X000092@X92@X94PX000022@T:00<94PX92@X92@X00`T9
2P0<2A8:2@T:2@T:00002A8:00002@T:00002@T:2A8:2@T:2A8:0`T92P04
2A8:2@T:2A8:00000Q4L2P052A8:2A`D2@T:4A`:6PT:008A70X02`T92PTB
2PT92PTB2R<L2R`B014L2P00014L2PT92Q4L2P022A8:0PT92P0300002@T:
2@T:00H92@X22A8:00@000092@X94PX000022@T:00@S70X94PX92@X00002
2@T:00D94PX000092@X92@X94PX00`0000042A8:0000000000000PT92P03
2A8:0000000000@92@X00`TB2PT950T92P022@T:00D000092@X92@X92@X9
2A@00PTB2P042@T:2A8:2A8:00000PT92P0:2A8:00002@T:00002@T:0000
2A8:2@T:2A8:2@T:0PTB2P<92@X010TB2PT92PT92PT950H94PX92@T:00@A
70X92@X94PXA70X22@T:00<A70X94PX92@X00`T92P054A`:6PT:4A`:6PT:
2A8:00892@X010TB2P0000T92PT92P894PX0100000T92PTB2P0000H92@X0
0`TB2PT92PT92P052@T:0180000m4P[CV0[CV0[1Q03o/`23;`092AB`C03o
mP23;`092@XJ2@X92@XA70X92@XA70X94PX32@T:00@A70X92@XA70X94PX2
2@T:00HA70X92@XJ4Q@92A@0002EXKMQc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0062A8:
2@TD4A`:2@T:4A`:2@T:1@TB2PD92@X02PTB2PT92PTB2PTB2PT92PTB2PT9
2PTB2PT92Q4V7PD92@X22A8:00<000094PX92@X00`T92P894PX010T92PTB
2PT92P0000892@X01`TB2PT92PT92P0000TB2Q4L2QX92P03;18000<94PXA
70X94PX00`T92P064A`:6PT:6PT:8a`:;1806PT:1@T92P032A8:2@T:2@T:
00<92@X0100000T92PT92PT92P894PX01`0000TB2PT92P0000TB2P0000T9
5002000000d94PX92@X94PX92@X000092A@92@X000094PX0000A70X92@X0
00000`T92P0300002A8:2@T:00892@X010TB2PT92PT92PT92P8000000`TB
2PT92P0000022@T:00L000092@X92@X000092@X971@94PX00PT92P072A8:
00002@T:2@TD2A8:2@T:2A8:00<92@X00`0000T92PT92P032@T:00<94PX9
2@X92A@010T92P042A8:2@T:2@T:00003PT92P032A8:2@T:2A8:00892@X0
0a4L2PT92Q4L2P022@T:00<J2@X92@XA70X01@T92P032A8:2@T:2@T:00L9
2@X00`TB2P0000TB2P052@T:0Q4L2P0@2@T:LRH0ooH0YT402@TDok<0YT40
;180/4`0ooH0PcP02@T:6PT:4A`:2@T:2A8:0`T92P892A@32@T:00<J2@X9
2@X92@X00`T92P034A`:0000YZZ]067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00TA70X9
2@X94PX92@X94PX0000A70X92@X94PX00PT92P<94PX00`T92Q4L2PT92P03
2@T:0PTB2P042@T:00002A8:00000PT92P0:2A8:2@T:2A8:2@T:00002A8:
00002A8:2@T:2A8:0PT92P0?00002A8:2@T:00002A8:00002A8:00002A8:
00002@T:2A8:6PT:4A`:;180008A70X42@T:00P94PX92@X/4P092@XA70X9
2@XA70X/4P026PT:00DA70X92@X94PX0000J2@X020T92P032A8:00002@T:
008000022@T:00<000094PX92@X010T92P0300004A`:000000<92@X01@00
00TB2P0000T92PTB2P042@T:00L94PX92@X000094PX000092@X000000`T9
2P894PX22@T:00<94PX92@X92@X00PT92P892A@32@T:00@000094PX00000
00022@T:00D000092@X92@X92@X94PX01@T92P0300002A8:2A8:00X92@X0
0a4L2PT92PT92P042@T:00<94PX92@X92@X01PT92P064A`:2@T:2@T:2@T:
4A`:4BHD0PT92P0=00002A8:2@T:00002@T:00002A8:00002@T:2@TD2A8:
2@T:2A8:00D92@X00`TB2PT92PT92P022@T:01094PX92@X92AAb9P3omP2E
E@092ACf/`23>02`C03omP1G70092@XJ2@X92@XA70X22@T:00H94PX92@X9
2@X94PX92A@A70X32@T:00P94PX92@X92@X92@XA70X92@X0002`/kMQc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?o
ooo<c<c<c<`0GLc<c0894PX22@T:00D94PXA70X92@X000094PX00PT92P06
2A8:2@T:2@T:2A8:2@T:2A8:0`T92P0<2@TD00002A8:2A8:2@T:4A`:0000
2A8:00002A8:00002A8:0P0000<92@X01`TB2PT92PTB2PTB2P0000T92PTB
2P022@T:00<000092@X94PX00`T92P036PT:4A`:2A8:008/4P024A`:00<9
4PX000092@X00a4L2P052@T:4A`:2@T:4A`:2A8:008A70X02@TB2R`B014L
2PT92Q4L2PT92R`B00T92Q4L2P022@T:00@94PX000092@X000022A8:00H9
2@X94PX94PX000092@X94PX22@T:00L000092@X000094PX000094PX00000
10T92P0800002A8:2@T:2@T:2A8:00002A8:00000`T92P0:2A8:00002@T:
2A8:00002@T:2A8:00002@T:2A8:0PT92P042A8:2@TD2@TD2A8:1@T92P08
2A8:00002@T:2@T:2A8:2@T:2A8:00001PT92P042A8:2@TD2@T:2@T:0PTB
2PD92@X01Q4L2PT92Q4L2Q4L2PT92PTB2P892@X00a4L2PT92PT92P052@T:
00L94PX92A@92@X92@XA70XJ2@X/4P001PT92P062A8:00002@T:2@T:2A8:
00000PT92P0500002@T:2A8:2@T:2A8:00<92@X070TB2Q4L2PT92PTB2Q4L
2P0003dB2_K72_Jc0?nc0?o@0?oI0?o@078V00T950TB2Q4L2QX92PT92Q4L
2PT92Q4L2PT92Q4L2PT92Q4L2PT92Q4L2P892@X00`TB2PT92PTB2P032@T:
00<0002EV:?<c<`0H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8
`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`010T951XB514L2PT95089
2@X00aXB50T92QX92P052@T:00D94PX92@X92@X92@X92A@00P0000892@X0
2@0000T92P0000TB2P0000T92P0000T92P0000022@T:00@000094PX00009
2@X300000`T92P032A8:00002@T:00892@X02`00014L2PT92Q4L2QX92R<V
2R<L2R`B02<V2QX92PTB2P032@T:0QX92P8A70X01B`B01X92QX92QX92PT9
2P026PT:00DA70X92@XS70X92@XA70X00PT92P8A70X0100000TB2P0000T9
50<000000a4L2P0000TB2P0200000`T92P0300002@T:000000892@X01000
00T92PTB2P0000892@X020TB2PT92PT92P0000T92P0000T92P0000T92@X0
20TB2PT92PT92PTB2PT950T92QXB500000892@X02@TB2P000000000000TB
2PT9500000TB2P00000<2@T:00<94PX000092@X01@T92P0;4A`:2@T:2@T:
2@T:2A8:2@T:4A`:00002A8:2@T:000000P92@X0214L2PT92Q4L2PT92Q4L
2PTB2PT92P0000D92@X00`0000T92P0000032@T:00<94PX000094PX01PT9
2P062A8:2@T:2@T:4A`:2@TD6PT:0/640006YW80Nd40Nd`:00006PT:0000
0PT92P052A8:2@T:2A8:2@T:2@TD00<92@X01A4L2PT92PT92PT92PTB2P03
2@T:0Q4L2P030000/;>gc<c<063<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00L94PXA9Q@9
2A@A70X94PX92@X94PX00PT92P032A8:4A`:2A8:00<92@X22A8:00<0000A
70X92@X00PT92P092A8:2@T:2A8:00002A8:00002A8:2@T:2A8:00@92@X0
0`0000T92P0000032@T:00<000094PX92@X00`T92P0400002@T:2A8:0000
0PTB2P064A`:8a`:6PT:4BH:8a`:4A`:0`T92P062A8:2@T:4A`:6PT:2@T:
4A`:0PT92P034A`:2@T:4A`:00892@X22A8:0PT92P034A`:2@T:2A8:0089
2@X010TB2PT92P0000TB2P892@X011XB50T92P0000TB2P892@X010TB2P00
00T92P0000@92@X00`0000TB2PT92P032@T:00H000094PX92@X000092@X0
00022A8:0`T92P<94PX62@T:00<94PX92@X92@X00`T92P0500002@T:2A8:
2@T:000000X92@X01@TB2PT92PT92PTB2PT950052@T:00@000092@X92@X9
2@X24A`:00L92@X94PX94PXA70X92@X94PXA70X02PT92P034A`:2@T:6PT:
008A70X42@T:00<000094PX92@X010T92P0300004A`:2@T:00<92@X00`00
014L2PT92P042@T:00P94PX92@X94PX92@X000092A@000092A@2000000PJ
4Q@92@XA70X92@XA70X92@XJ2@X92@X24A`:0PT92P032A8:2@T:2A8:00<9
2@X24A`:0PT92P032@TD0000UJ6g067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00HJ4Q@9
4PX92A@94PX92A@J4Q@=2@T:00H000092@X000092@X000094PX32@T:00/0
00094PX92@X92@X94PX92@X94PX92@X000092@X94PX00`T92P0600002@T:
4A`:2@T:00004A`:0PTB2P8000026PT:00HA70XS70X/4P0A70XJ2@XA70X5
2@T:00d94PXA70X92@XA70X92@XA70X000094PX92@X000094PX000094PX0
0`T92P0=00002A8:2@T:2@T:00002A8:2@T:00006Q`N6Q8D00002@T:6Q8D
008000000`T950T92PT92P022@T:00<000094PX000000PT92P032A8:2@T:
2@TD00@92@X00a4L2PT92PT92P032@T:00PA70XJ4Q@J4Q@J2@X94PX92@X9
4PX92A@42@T:00X94PX92@X92@X92@X94PX92@X000092@X000094PX32@T:
00<94PX92@X000001PT92P032A8:2@T:2@T:00L92@X0100000T92PTB2Q4L
2P<92@X0114L2PT92Q4L2PTB2P<92@X01P0000T92PT92PTB2PT92P000089
2@X0114L2PT92Q4L2PTB2PH92@X0200000TB2PT92P0000T92PTB2P0000TB
2P@92@X00`0000T92PT92P072@T:00Tm4P[TZP3o/`3CQ00000092@X0000m
4PX94PX00PT92P044A`:2@T:2@T:2A8:10T92P034A`:2@T:2@T:00D92@X2
4A`:00<0002V/l7<c<`0H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`00`TB2QXB514L2P02
2A8:00<92@X94PX94PX00PT92P042A8:2@T:2A8:2A8:0PT92P034A`:2@T:
2@T:00892@X22A8:0`T92P0400002@T:4A`:00000PT92P894PX2000000<A
70X000092@X00PT92P094A`:2@T:2A8:2A8:2@T:2A8:2@T:6PT:00000089
2@X34A`:00DJ2@XA9PX/4P0S;ahA70X00PTB2P<92@X00a4L2PT92Q4L2P02
2@T:00@94PX92@X92@X94PX:2@T:00@94PX000092@X94PX2000000@92@X9
4PX0000000022A8:00H000092@X94PX92@X94PX000032@T:00<0000971h9
4PX00`T92P894PX00`0000TB2PT92P042@T:00@A70X94PXA;c<94PX32@T:
0PTB2P892@X22A8:00<000094PX000001PT92P034A`:00002@T:00<92@X3
2A8:00<92@XJ71h92@X02PT92P032A8:00002@T:00894PX00`T92R<L2PTB
2P092@T:00<A70X92@X92@X00PT92P044A`:6PT:2@T:4A`:1PT92P040000
2@T:4A`:000020T92P0K2A8:2@T:2@T:2@T:4A`:2@T:4A`:2@T:6Q8D^FL0
diP:`H@0ok<0Pbl02@TD/4`0ooH0PcP02@T:6PT:2@T:4A`:6PT:2@T:6PT:
2@T:2A8:00892@X01a4L2PT92PT92Q4L2PT92Q4L2PTB2P022@T:00<0002V
/l7<c<`0H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;So
c<c<6/c<c003ooooc<c<c<c<05g<c<`010TL51XB50T92PTB2P@92@X00`TB
2PT92Q4L2P032@T:00@94PXA70X000092@X22A8:00<000092@X92@X01@T9
2P0500002@T:2@T:2@T:000000L92@X010TB2PT92PTB2P0000892@X01@TB
2PT92PT92PT92PTB2P022@T:00<A70X92@X/4P000QX92P054A`:6PT:0000
00004A`:00<92@X02@TB2Q4L2Q4L2PTB2PT92PTB2P0000T92PTB2P042@T:
0P0000034A`:00002@T:00892@X01P0000T92P0000TB2PT92P0000892@X2
000000L92@X0000000094PX000092@X000001PT92P032A8:000000000089
2@X02@0000TB2P00000000T92Q4L2PTB2R`B00TL50022@T:0PTB2P030000
2@T:2@T:00<92@X01@0001XB500000T92P0000022@T:00<000092@X00000
0`T92P042A8:2@T:2A8:00001PT92P894PX42@T:00L000094PX92@X92@X0
00092@X/4P0010T92P082A8:00002@T:00002@T:00004A`:00002PT92P04
00002@T:4A`:00000PT92P0500002@T:2@T:2@T:000000H92@X00`0000T9
2PT92P022@T:00l92A@A70X0001G703omP2EE@00003CQ02EE@000023;`3o
mP23>000000A70X01PT92P034A`:2@T:2@T:00892@X02A4L2PT92Q4L2PTB
2PT92Q4V7PT92P000:Jc`@1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0042@TD6Q8D4A`:
2@T:0PTB2P084A`:2@T:2@TD4A`:2@T:2A8:2@T:4A`:0PT92P032A8:2@T:
4A`:00<92@X01@TB2PT92PT92PT92PTB2P022@T:00<A70X000092@X01@T9
2P072A8:2@T:000000002A8:2@T:2A8:00L92@X02@00014L2QX92Q4L2QX9
2Q4L2R`B01X92Q4L2P022@T:00<000094PX92@X020T92P036PT:2@T:0000
00892@X00`TB2PT92PTB2P022@T:0PTB2P@92@X00`0000T92PT92P042@T:
00<000092A@94PX00PT92P032A8:2@T:2@T:00H92@X22A8:00D92@X94PX9
2@X000094PX00PT92P032A8:2@T:2A8:00<92@X22@TD00@94PX92@X92@X9
4PX22@T:00<94PX92@X94PX00PT92P0600002@T:2@T:00002@T:00000PT9
2P0300002@T:2@T:00@92@X01@TB2PT92PT92P0000T950022@T:00L94PX9
2@X92@X92A@000092@X94PX00`T92P032A8:2@T:000000D92@X01P0000T9
2PT92PT92P0000TB2P892@X00a4L2PT92Q4L2P042@T:00@000092@X00009
4PX32@T:00@94PX92@X92@X92@X22A8:0PT92P034A`:2@T:2@T:00892@X0
6A4L2PT92PTL7SdB2_oI09EE00T95>BZ08=103dB2[1<0>BZ05LL00T92PTB
2QX92Q4L2PT92Q4L2PT92PTB2PT92QX92PT9514L2P022@T:00PA70X92A@J
2@X94PXJ2@XA70X0002`_/5Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0054A`:6Q8D2@TD
4A`:2A8:00892@X00`TB2QXB50TB2P032@T:00DA70X92@X92@X94PX92A@0
0PTB2P@92@X22A8:00`000092@X94PX000094PXA70X92@X94PX92@XA70X9
2@X92A@62@T:00H000094PX94PX94PX92@X94PX22@T:00<94PXA70X92@X0
0R<V2P03;1804BH:6PT:00892@X01PTB2PT92PTB2PTB2PT92PTB2P892@X0
1Q4L2PT92PTB2PT92PTB2PT92P894PX01PT92PTB2PTB2PT92PTB2PT92P80
000020TB2PT92P00014L2P0000TB2P0000T92P894PX01P0000T92P0000TB
2PT92P0000<92@X00`TB2PT92PT92P042@T:00<000092@X000000PT92P05
00002A8:2@T:2@T:000000892@X32A8:0PT92P894PX01aXB50TB2PT92P00
00TB2P0000TB2P022@T:00<94PXA70X92@X00PTB2P892@X01`TB2PT92PTB
2PT92PTB2PT92PTB2P072@T:00L000094PX000094PX92@X000094PX00`T9
2P0300002A8:2@T:00<92@X01@TB2PT92PTB2PTB2P0000032@T:00<00009
2@X94PX00PTB2PD92@X00`TB2PT92PT92P022A8:00<000094PX92@X01`T9
2P0?4A`:2@T:2@T:4A`:2@T:0000?A8:ooH0YT400000dh@0Pd40Pbl0ooH0
000000892@X011X92PT92QX92Q4L2P892@X01A4L2PT92PT92PT92Q4L2P05
2@T:00DJ2@X94PXA70X0002`_/40HLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`010TL50T9
514L2PTB2P<92@X02@TB2QXB50TB2PT92PTB2Q4L2PT92PTB2P0000022A8:
1@T92P894PX010T92PTB2PTB2P0000@92@X0214L2PT92Q4L2P0000T92PTB
2PT92PTB2P892@X00`0000T92PTB2P02000000<94PX000092@X00PT92P8/
4P028a`:00PS9PXJ2@XA70X000094PX000094PX000022@T:00P000092@XA
70XJ2@XA70X000094PX000022@T:00H000094PX0000000092@X000032@T:
00<94PX0000000000`T92P0600002A8:6PT:00002@T:2A8:0PT92P060000
2A8:2@T:2@T:2A8:2@T:0`TB2P0<00002@T:2@T:2@T:2A8:00002@TD0000
2A8:00002A8:00000PTB2PD92@X02PTB2P0000TB2PT9500000TB2P0000T9
2PTB2P0000894PX2000000T94PX92@X000092@X94PX000092@X94PX00000
10T92P062@TD2@T:2A8:2@TD2@T:2A8:10T92P034A`:00002A8:00894PX0
2P0000T92PT92P0000T92PTB2P0000T92PTB2P0000H92@X00a4L2P0000T9
2P032@T:00H94PX92@X92@X000092@X94PX2000000<94PX000092@X020T9
2P0?2A8:2@T:2@T:2@T:4A`:0000diP:dh@0i:X0m[<0ok<0omT06PT:0000
2@T:008A70X00`T92QXB50TB2P032@T:00<94PXA70X92@X010T92P032A8:
4A`:2@T:00892@X00`0009FQ]lc<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0046Q8D
2@TD4A`:2@TD0PTB2P032@T:4A`:2A8:00892@X01PTB2PT92PT92PTB2QXB
50T92P894PX22@T:00H94PX0000000092@X94PX000032@T:00X94PX92@X9
4PX000094PX000092@X94PX971h000022A8:00<92@X94PX92@X00PT92P05
2A8:00002A8:00002@T:008A70X01QX92R<V2R`B02<L2R`B014L2P892@X0
0`TB2P0000T92P052@T:00HA70XJ2@X92@X92@X94PX000022@T:00X94PX9
2@X94PX94PX92@X94PX92@X000094PX000052@T:00@000092@X92@X94PX2
000000H94PX92@X000092A@94PX000022@T:00H94PX92@X92@X971h00009
2@X22A8:0PT92P0500002@T:00002A8:000000D92@X01@TB2P0000T95000
00TL7P02000000D94PX000092@X92@X0000010T92P0300002A8:00000089
2@X01`T950TB2PT92PT92PTB2PT92PTB2P042@T:00T94PX000092@X00009
2@X94PX000092@X92A@00P0000L92@X00`0000T92PT92P022@T:00H00009
2@X92@X000092@X92A@22@T:00@94PX000092@X94PX62@T:00<000092@X9
2@X01`T92P0>2A8:2@T:2@T:2@T:2A8:2@T:2@TD6PT:diP:i:X0`H@0YVL0
UED02@TD0PTB2P032@T:2@TD2@T:00892@X00a4L2PT92PT92P032@T:00/A
70X92@XA70X92@X94PX92A@92@XA70X92@X0002`_/40HLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<
05g<c<`02A4L2QXB50T951XB50TB2PT9514L2PT950TB2P022@T:00H92A@9
2@X92@X92@XJ4Q@J71h42@T:00<94PX92@X92@X00PTB2P032@T:2A8:2@T:
00D92@X00`0000T92PTB2P042@T:00D000094PX000092A@94PX00`T92P0;
00002A8:00004A`:6PT:4BH:;1808a`:4A`:2@T:6PT:00<92@X00`0000TB
2PTB2P032@T:00@92A@A70XJ2@XA70X22@T:00@0000A70X94PX000022@T:
00D000094PX92@X92@X94PX00PT92P032A8:2@T:2@T:00<92@X01`TB2PT9
2PT92PTB2PT92P0000TB2P022@T:00H94PX92@X92@X94PX92A@94PX22@T:
00@94PX92@X92@X000022A8:00D92@X94PX92A@000092A@00PT92P042@TD
2A8:2@T:2@T:0PTB2P892@X040T950T92P0001XB50T92P0000TB2PT92PTB
2PT92PT950TB2P0000TB2PT92PTB2P<92@X00`TB2PT950T92P042@T:00D9
4PX92@X92@X92@X92A@01@T92P0600002@T:2A8:2@T:00002A8:0`T92P04
2A8:2@TD2@T:2A8:1`T92P032A8:2@T:2A8:00H92@X01@TB2PT92PT92PT9
2P0000052@T:00<000092@X92@X00PT92P0;4A`:2@T:2A8:4A`:2@T:0000
2@TD00002@TD00002@TD00<92@X00aX92PT9514L2P032@T:00DJ4Q@92@X9
4PXA70X94PX00`T92P084A`:6Q8D6Q8D2@T:2@TD4BHD0000/;k1HLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003oooo
c<c<c<c<05g<c<`02`TL50T950TB2PT950TB2PT92PT9514L2PT92PTB2Q4L
2P032A8:00DA70X92@XJ4Q@94PXA70X00PT92P052A8:2@T:2@T:2@T:2A8:
00<92@X00`TB2PT92Q4L2P052@T:00<000094PX94PX00`T92P052A8:2@T:
2@T:00002A8:00D92@X00b<L2R`B01X92P038a`:00<A70X94PX94PX00PTB
2P092@T:00002A8:2@T:2A8:6Q8D2A8:4A`:2@TD008A70X42@T:00/94PX9
2@X92@X92@X000094PX92@X000092@X000094PX00PT92P032A8:00000000
008000001`T92P0000TB2P00014L2P00014L2P032@T:00D92A@94PX92@X9
4PX0000010T92P0>00002A8:00002A8:2@T:00002@T:4A`:2@T:2A8:2@T:
2A8:2@T:2A8:0`T92P0?00002@T:00002A8:2@T:00002A8:2@T:00002A8:
00002@TD2@T:2A8:000000<94PX01@T9514V50T92PTB2PT92P022@TD10T9
2P0300002@T:2@T:00L92@X00`TB2PT92PT92P022@T:00<000092@X92@X0
1@T92P052A8:2@T:4A`:2@T:2@TD00892@X22A8:10T92P0300002A8:2@T:
00H92@X00`TB2PT92PT92P072@T:00HA70X92@X92A@A70X92@XA70X52@T:
00DA70X92@X92@XA70X92@X00Q4L2P032@T:6PT:2A8:008A70X020TB2PT9
514L2PT92PTB2PT92P000:JZ[F7<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00DJ4Q@A9Q@J
4Q@92A@A70X00PTB2P032@T:6Q8D2@T:00892@X010TB2PT92PT92PTB2P89
2@X010TB2PT92PT92PTB2P<92@X01a4L2PTB2PT92PTB2P0000TB2PT92P02
2A8:1@T92P894PX22@T:0PTB2PH92@X02@TB2PT92PT92Q4L2PT92R<L2QX9
2R`B01X92P032@T:00<94PX000092@X00PT92P032A8:00002@T:00892@X0
4`TB2PT92PT92PTB2PT92PTB2P0000T92PTB2PT92PTB2P0000T92PTB2P00
00T92P00014L2P0000062@T:00H000092@X92@X92@X94PX000042@T:00<9
4PX92@X92@X00PTB2P<92@X02PT9500000T92PTB2PT92P0000TB2P0000T9
2PTB2P<92@X32A8:00L92@X94PX000094PX000092@X000000`T92P070000
2@T:2@T:2A8:00002@T:2A8:00<92A@00`TL7PT950TB2P042A8:0PT92P03
2A8:2@T:2@T:00D92@X0100000T92PTB2P0000892@X42A8:00P92@XA70XA
70XA70X92A@92@XA70X94PX32@T:0PTB2P@92@X00`TB2PT92PT92P062@T:
00@94PX000092@X94PX92@T:00@A70X94PX92@X94PX22@T:00PJ2@X92@X9
2@XA70X92@XA70X92@XA70X32@TD00d94PX92@XA70X92@XJ2@X92@XA70X9
2@XA70XJ4Q@94PX0002V/l40HLc<c004IVIVR<2hR<2hB9280@00000000B8
`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`02A4V50T951XB
50T92Q4L2PT92Q4L2PTB2PT92P024A`:00L92@XA70XJ4Q@92A@92@XA70X9
4PX00`T92P064A`:2@T:4A`:2@T:2A8:2@T:0PTB2P052@T:2A8:2A8:2@T:
2A8:00892@X02PTB2PT92PT92PTB2P0000TB2QX92PT92PTB2Q4L2P892@X0
0a4L2PTB2P0000022@T:00TJ2@XA70X/4P0S70X/4P0J2@XA70X94PX92@X0
0PTB2P892@X010TB2PT92PTB2PTB2P892@X00`TB2PT92PT92P072@T:00@9
4PX92@X92@X000022@T:00<000092@X92@X00PT92P0400002A8:2@T:2A8:
0PT92P0400002A8:00002A8:0`T92P062A8:2@T:2@TD2@T:2@TD00000`T9
2P032A8:00002@T:00<92@X00`TB2PT92PTL50052@T:00<94PX92@X94PX0
0PT92P042A8:2@T:2A8:000010T92P032A8:00002@T:00894PX021XB5000
014V514V52`L514V50T951XB50@94PX00`T950T92PT92P032@T:00<A70X9
2@XA70X00PT92P0:2A8:2@T:6Q8D2@T:4A`:2@T:6Q8D4A`:6Q8D4BHN0QXV
50034BHD8blN6RHD00<J9Q@24BHD00PA70XJ4Q@94PX92@XJ4Q@94PX92A@A
70X22A8:0PT92P032A8:2@T:2@T:00T92@X00a4L2PT92PT92P032@T:00<A
70X92@XA70X01PT92P072A8:4A`:6PT:2@T:4A`:2@T:4A`:00<92@X02@TB
2PT92PT92Q4L2PTB2QXB50T950000<77c01Qc<c<00AVIVJ8`;R8`;Q8T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c006
4BHD6Q8D2A8:2@T:4BHD2@T:0PTB2P<92@X00a4L2PT92PTB2P024A`:0PT9
2P042A8:2@T:2A8:2A8:10T92P064A`:2A8:2@T:2@T:2A8:00000PTB2P89
2@X00`0000TB2PT92P082@T:0PTB2P052@T:4A`:2@T:2@T:4A`:008J2@X0
1B`B02<L2R`B014L2PTB2P052@T:00H000092@X92@X000094PX92@X22A8:
0PT92P042A8:2@T:2@T:2A8:0`T92P032A8:2@T:4A`:00892@X32A8:0PT9
2P054A`:00002@T:00002A8:00D92@X01@0000TB2PTB2PT950TB2P022@T:
00@000092@X92@X94PX72@T:00<000094PX92A@00PT92P042A8:2@T:2@T:
2@T:0`TB2P042@T:00002A8:00002@T92P0900006Q8D4Blc8blY2BHY8d4m
2@T:2@TD2A8:00892A@04PTB2R<_:@TL7PTB2PT92PTB2P0000T950T92PTB
2PT92Q4V514L2QXB514V50TL514V51XB50@A9Q@00b<V2QXL7R`h:@028blN
0R<_:@036RHD4BHN8blY008S;ah011XV52<_7R`h:AXV508S;ah01@TL51XB
514L2PT9514L2P022A8:10T92P052A8:2@T:2@T:2@T:2A8:00<92@X01AXB
50T92Q4L2PT92Q4L2P032@T:00<A70X94PX92@X00`T92P036Q8D2@T:4A`:
00892@X00a4L2PT92Q4L2P022A8:00P92@XS70X92@XJ2@X92A@S9PX92ABV
ZZeQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`J
c<c<00?oooo<c<c<c<`0GLc<c00:2A8:2@TD2@T:2A8:6Q`N2@TD4A`:2@TD
2@T:4A`:0PT950036Q8D2A8:2@T:00892@X00`TB2PT92PTB2P082@T:00@9
4PX92@X92@X94PX22@T:00<94PX92@X94PX04PT92P03;1808a`:;180008J
2@X00`TB2P0000T92P0;2@T:0P0000042@T:00002A8:00000`T92P030000
2@TD000000892@X3000000L92@X0000000094PX000092@X92A@00PTB2P09
00002A8:2@T:2@T:2A8:2@TD2A8:2@TD2A8:00<92@X010TB2P0000T92P00
00<92@X01PTB2P0000T92PT92PT950TB2P892@X02@0000TB2PT92QXB50T9
2P0000TB2PT92P0000022@T:00H000092@X000094PX92@X000032@T:00D0
000S@Cdd;c=6EE8971h00PT950052A`D6Q8D2@TD0000?Blm00892A@01PTB
2PT92PT92P0000TB2QXB50<A9Q@010TB2QXB514L2PT9508A70X04PTB2QXB
51XB50TL7QXV50TL7Q4L2QXB52`h:B<_:AXV51XL7R<_7R`V514V7R<_7QXL
7QXV508S;ah02QXV52`V51XL7QXV52<_7Q4L2QXB51XV50T9514L2P892@X0
0a4L2PT92PT92P022@T:00D94PX92@X92@X92@XA70X01`T92P046PT:2@T:
2@T:4A`:10T92P8A70X01@T92Q4L2PT92PT92QX92P042@T:0QXB50030000
/;>gc<c<063<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
olc<c1[<c<`00oooolc<c<c<c01Mc<c<00<J4Q@J9Q@94PX010TB2P082@T:
4A`:2@T:2@T:2@TD2@T:2@TD4A`:0PTB2P036PT:4A`:000000894PX02@T9
2PTB2PT92PT92PTB2PT92PTB2PT92PTB2P032@T:00<94PX000092@X00PT9
2P094A`:00002A8:2A8:2@T:6PT:2@T:4BHN4A`:00<92@X01`TB2PT92PT9
2Q4L2QX92PT92Q4L2P042@T:00HA70X92@XA70X94PX92@XA70X22@T:0Q4L
2PD92@X00`0000T92PT92P022@T:00D000092@X000092@X94PX00`T92P03
2A8:00002@T:00892@X01P0000TB2P00000000TB2P0000<92@X02PTB2PTL
7PTB2PT950TB2PT92PTB2P0000T92PT950894PX010T92PTB2PTB2P0000L9
2@X00`TB2PT92PT92P032@T:00X000094PX92@X94PX0000A70X000094PX9
2@X94PX22@T:00H94PX92@X92@XS;ahS;bT/EE`22@T:0PT950892@X00`T9
53AE?@TB2P052@T:0PTB2PH92@X00`TB2P0000TB2P022@T:0PTB2P074BHD
4A`:4A`:6RHD4BH:6Q`N4BHD00<J9Q@022`h:AXV51XL7QXL7QXV52`L52<_
7QXV50<S;ah02QXL7QXV51XV51XV51XB52<L2Q4L2PT92PTB2Q4L2PT92@X0
0`TB2PT92PTB2P0:2@T:00<J2@X92@XJ2@X00`T92P0900002A8:2@T:4A`:
2@T:4A`:2@T:0000/;>g067<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00@A9Q@94PX94PX9
2A@32A8:00T92@XA70X94PXA70X92@X94PX92@X94PXA70X00P0000894PX0
1@0000TB2PT92Q4L2PTB2P0200000PT92P0600002@T:2A8:2A8:2@T:0000
0PTB2P0:2@T:2A8:2A8:2A8:00002@T:2A8:4A`:2@T:00001@TB2P892@X0
1A4L2P000000014L2PTB2P032@T:0Q4L2P066PT:;1802@T:4A`:6PT:4A`:
0QX92P084A`:2@T:2A8:00002A8:00002@T:2A8:0P0000042A8:00002A8:
00000PT92P072A`D00002A8:00002@T:2A8:000000892@X01`TB2P0000TB
2P0000T92PTB2PT950022A`D00D92A@92@X000094PXA70X00PT92P052A8:
000000002A8:000000892@X010TB2PT92PT92PTB2PH92@X22A8:0P00000>
2@T:00002@T:2@T:00002A8:00002@T:00002@T:2A8:00002@T:2A8:0PT9
50042A`D2A8:2A8:2@TD0`TB2P032@TD8d4m2A8:00@92@X01@TB2PT92PT9
2Q4V2Q4L2P042@T:00<A70X94PXJ2@X00PT92P032A8:2@T:2A8:00892@X2
4A`:00H94PXA9Q@J9Q@A9Q@J9Q@A9Qh36RHD00<S;ahS9PXJ9Q@00b<_7P03
8blY4BHN6Q`N00<J9Q@01AXB514L2Q4L2QXB514L2P022@T:00<A70X92@X9
2@X00PT92P032A8:4A`:2@T:00892@X00a4L2PT92PT92P052@T:00<94PX9
2@X92@X00PT92P0<4A`:2A8:2@T:4A`:2@T:4A`:2@T:4A`:2@T:4A`:0000
`LO<HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<
6/c<c003ooooc<c<c<c<05g<c<`01QXB50TB2QXB51XB50T950TB2P892@X0
1PTB2PT950T92Q4L2PT9514L2P@92@X00`0000TB2PT92P052@T:00<A70X9
4PX94PX010T92P0700004A`:2@T:2@T:00002A8:2@T:008000001@TB2QX9
2PTB2P00014L2P032@T:00@000092@X92@XA70X22@T:00<000094PX94PX0
10T92P8J2@X02@T92R`B00TB2QX92R`B02<V2Q4L2PT92Q4L2P042@T:00T0
00094PX92@X94PX000092@X000094PX92@X00P00000;2@T:00002@T:2A8:
00002@T:2A8:2@T:00002@T:000000892@X01PTB2QXB54mNIPTL7PT950TB
2P892@X00`TB2PT92PT92P062@T:00<94PX92@XA9Q@00`T92P0400002A8:
2@T:2A8:1@T92P042A8:2@T:4A`:00000`T92P052A8:00002A8:2@T:0000
00892@X00`0000TB2PT92P022@T:00D92A@92@X92@X92A@92@X00PT9500?
2A8:2@TD2@TD2@T:00002A8:4BHD4A`:2@T:4A`:4BHN2@T:4A`:2@T:4A`:
00892@X02A4L2PT92Q4L2QX92PT92Q4L2P0000T92QX92P024A`:00HJ4Q@A
70XJ2@X92A@A70XJ4Q@26RHD00<J4Q@J9Q@S;ah00R<_7P0:;2HD8blN8blN
6Q`N;1`D6Q`N4BH:8bH:6RHD4BHD0Q4L2P032@TD2@T:2@T:00`92@X0114L
2PT92PT92Q4L2PH92@X00`TB2PT92PT92P032@T:00@A70X92@X0002VZZeQ
c<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<
00?oooo<c<c<c<`0GLc<c0066Q8D2A`D4BHD2@T:6Q8D2A8:0Q4L2P082@TD
4A`:2@TD4A`:2@T:2A8:2@T:2A8:2`T92P0400002A8:00002A8:0`T92P03
00002A8:2@T:00<92@X00`0000TB2PT92P022@T:00PA70X92@XA70XA70X0
00092@X94PXA70X22@T:00<A70X92@X92@X01@T92P084A`:;1804A`:8a`:
2A8:4A`:6PT:4A`:0`T92P0500002A8:00002A8:2@T:00<000022@T:00<0
00092@X000000PTB2P0500002@T:000000002@T:00<000001@T92PTB2P00
00T92P0000026Q8D00=?Ie`92A@94PX00PTB2P0300002@T:2@T:00<92@X2
2A8:0PT92P0300002@T:=2lN00892@X02`TB2PT92PT92PTB2P0000TB2PT9
2P0000T950TB2PT92P0200000PT92P044A`:00002@T:2@T:0P0000032A8:
00002@T:00D92@X010TB2PT92PTB2PT950894PX010T92PT951XB514V5089
2@X01@TB2R<_7PT92PTB2Q4L2P022A8:00L92@X94PXA9PXA70X92@X94PXA
70X00`T92P064A`:2@T:4A`:00002@T:2A8:0`T92P0<4A`:2@T:2A8:4A`:
2@T:2A8:2@TD6RHD6Q8D8blY6RHD8blY0Q4V2P8S;ah01AXB51XV51XL7QXB
52<L2P024A`:00<000092@X92@X060T92P074A`:2A8:4A`:2@T:4A`:0000
SHe_067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<
c1[<c<`00oooolc<c<c<c01Mc<c<00DA9Q@J71hJ4Q@A70X92A@00`T92P04
6Q8D2A8:2@T:2A8:0PT92P034A`:2A8:2A8:00<94PX22@T:00<A70X92@X9
4PX010T92P042A8:00002@T:2A8:0`T92P042A8:2@T:2@T:2A8:10T92P05
4A`:2@T:2A8:2@T:6PT:00<92@X010T950T92PT92PT92P894PX32@T:00<9
4PX92@XJ2@X00`T92P036PT:2@T:2@T:00894PX22@T:00<000092@X94PX0
0P0000032@T:2A8:000000892@X010TB2P0000T92P0000H92@X01`0000TB
2PT92PTB2P0000T92P0000022A8:00DJ2@Xd;c<92@X94PX000000PTB2P<9
2@X01@TB2PT92PTB2PT9514L2P022@T:00@94PXJ71h94PX000052@T:00LJ
4Q@94PX94PX000092@X94PX92@X00PTB2P042@T:00002A8:00000PT92P05
6Q8D00002@T:2@T:2A8:00892@X01@TB2PT950TB2PT950TB2P042@T:00/J
71hJ4Q@J4Q@94PX92@XA9Q@S;ahA9Q@J2@X0000A70X00`T92P056PT:2A8:
2A8:2@T:6PT:008A70X01AX92Q4L2PT92Q4L2PTB2P042@T:00<A70X92@X9
2@X01@T92P062A8:4A`:6RHD6RHD8bH:6PT:0R<_7P<J9Q@28bH:00<A70XS
70XA70X00PT92P0300004A`:000000H92@X00`TB2PT92PT92P0;2@T:00</
4P092@X92@X00`T92P034A`:0000UJ6>067<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00<J
4Q@92A@92@X00QXB50094A`:2@T:4A`:2@T:4A`:6Q8D2@T:4A`:2A8:00L9
2@X00`00014L2P0000022@T:00@000092@X92@X92@X22A8:00T92@X00009
2@X94PX92@X94PXJ4Q@92@X94PX00PT92P032@TD4A`:2@TD008A70X01AX9
2PT92Q4L2P00014L2P022@T:00H94PX92@X92@XA70X92@X000022@T:0Q4L
2P032@T:4A`:2A8:00894PX00`0000T92PTB2P022@T:0P0000032A8:2@T:
000000892@X0500000T92P0000T92PTB2PT9500000T92PTB2P0000TB2P00
00T92P0000T92PT9500000T92PTB2P00008J4Q@00`T92S@_<`0000022@TD
0`T92P076Q8D4BHD2@T:8d4m8blN6Q8D2A8:00<92@X00`0000T92PT92P02
2A8:0PT92P042@TD00002A8:00000PT92P0=2A8:00002@T:2@T:2A8:0000
2@TD2@T:2A8:00002A8:2@TD4A`:00@92@X22@TD00PJ4Q@92@X94PX94PX9
2A@94PXA9QhA9Q@26Q8D00@94PXJ9Q@/9Q@A70X22A8:0PT92P032A8:2@T:
4A`:00892@X24A`:00<92@XA70XA70X00Q4L2P082@T:4A`:6Q8D2@T:2A8:
2@T:4A`:2@T:0PTB2PD92@X00`TB2PT92Q4L2P024A`:00`J9Q@S;ahJ9Q@J
4Q@A9PXS;ahJ4Q@J71hJ9Q@J2@X0000A70X32@T:00@94PX92@X92@XJ2@X2
2@T:00<A70X92@X92@X00PT92P044A`:2@T:2@T:4A`:1`T92P032@TD2@T:
4A`:00892A@00`000:JHQ<c<c01Pc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0042A`D6Q8D
2@T:4BHD0`TB2P892@X01@TB2PT92Q4L2PT950TB2P032@T:0PTB2P892@X0
2QXB50T92P00000000TB2PT92P0000T92PTB2PT92P894PX22@T:00d00009
4PX92@X92@X000094PX000092@XA70X92@XA70X92A@J4Q@00Q4L2P046PT:
4A`:2@T:2@T:0P0000052A8:2@T:2@T:2A8:2@T:008000001`TB2PT92PTB
2P0000T92P0000TB2P022@T:00<000094PX92@X00PT92P0700002A8:0000
2A8:00002A8:000000892@X3000001<A70XJ2@X92@X000092@X94PX00009
2@X000094PX92@X000094PX92@X92A@A70XS@Cd94PX92A@010T92P062A8:
00006Q8DAUi76Q`N;2HD0PTB2P0500002@TD2A8:2@T:2A8:008000022A8:
00H92@X94PX92@X000094PXA70X22@T:00H000094PX92@X92@X000094PX3
2@T:00H000094PX92A@94PX92@X94PX22@TD00@94PX92A@92@X92@X22@TD
0QXB50092@TD2A8:2A8:6RHD4BH:4A`:2A8:00002A8:00892@X01`0000TB
2PTB2PT92Q4L2QX92Q4V2P024A`:00hA9PX/4P0A70X92@XJ2@XA70X92@XA
70X92@XA70X92@X94PX92@XA70X22@T:01494PX92@XA70XA70XJ2@X94PXJ
4Q@J2@XA9Q@A70X/9Q@J9Q@J4Q@J9Q@A9PX92A@A70X010T92P042A8:2@T:
2@T:2A8:2@T92P056PT:2@T:2@T:2@T:4A`:00D92@X01Q4L2PT92PTB2Q4L
2P000:J4Q67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
olc<c1[<c<`00oooolc<c<c<c01Mc<c<00<A9Q@94PXA9Q@00PT950052A8:
2@TD4A`:4A`:2@TD00<92@X32A8:0PT92P042A8:2@T:2A8:000010T92P07
00002A8:2@T:2@T:00002A8:000000@92@X00a4V2PTB2PTB2P032@T:0PTB
2P054A`:6Q8D4A`:4A`:2A8:008A70X0200000TB2PT92PT92P00014L2P00
014L2PD92@X01`TB2P0000TB2PT92P0000T92P0000042@T:00<000092@X0
00000`T92P042A8:0000000000000PTB2P<92@X03P0000T92PTB2PTB2P00
00T92P0000T92P0000TB2P0000T92PTB2PT92P<92A@03PTB2PT92PT92PTB
2P0000T9514V7TIEDQXL7QXV50T92P0000T92P0000892@X0300000TB2PT9
2P0000T92Q4L2P0000TB2PT92PTB2PT92P0000894PX92@T:00L000092@X0
00094PX92A@94PX92A@00PTB2P892@X22@TD0Q4L2P052@T:2A8:2A8:4BHD
8blN008000000`TB2PT92P0000032@T:00`A70XJ2@XA70XJ4Q@A70XJ4Q@A
70XJ2@XA70XA9PXA70XA9Q@34A`:00L92@XA70XA70XJ4Q@A70X92@XA70X0
0PT92P054A`:6PT:2A`D4A`:8a`:008A70X26PT:00HA70XJ4Q@J9Q@J4Q@J
9Q@A70XD2@T:00<J2@X92@X92@X01PT92P054A`:6PT:2A8:0000UJ6>067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2holc<c1[<c<`0
0oooolc<c<c<c01Mc<c<00<A9Qh92@X92A@00QXB50052A8:2@TD6Q8D2@TD
6Q8D00892@X00`TB2PT92PT92P022A8:00H92@X94PX92@XA70X92@X94PX5
2@T:00`94PX92@X92@X0000A70X92@X94PX92@X000092@X94PX000032@T:
1@TB2P06;1804A`:6PT:2A8:4A`:6PT:0PT92P0500002@T:2@T:00002A8:
00<92@X02@TB2P0000T92PT92Q4L2P0000TB2P0000TB2P02000000/94PX0
00094PX000094PX000094PX000092@X000092@X00P0000<92@X010TB2P00
00T92P0000892@X010TB2P0000T92P0000892@X03`0000T92PTB2PT950TB
2PT92PTB2P0000T92PTB2P00014V52<_:B<_<`0000022@T:00<000094PX9
2@X01@T92P062A`D00002@T:00002A8:00000PT92P80000010TB2P0000T9
2PTB2P892@X01@TB2PT92PTB2PT92PTB2P022@T:00DA9Qh92A@92A@94PX9
2A@00PTB2P036Q8D2@TD2@T:00892@X010TB2PT92Q4V51X92P@92@X06@TB
2PT92QX92PT92PTB2Q4L2Q4V514V2R<_7QXV52`L514V2QXB514L2QXB51XV
51X92Q4L2QX92Q4V514L2QX92Q4L2Q4V2QX92P034A`:00<92@XJ9Q@S;ah0
0QXV5005;1`D8a`:4A`:4A`:2A8:008A70X26RHD00@94PX92@X92@X94PX2
2@T:00L94PXS70X92A@J4Q@94PX92@XJ2@X01PT92P042@TD2@T:2A8:4A`:
10T92P082A8:2@T:4A`:2@T:6Q8D6PT:0000YZ6HHLc<c004IVIVR<2hR<2h
B9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<
c<`05AXB514L2PTB2PTB2QXB50T92Q4L2PT92PTB2QXB50TB2PT92PTB2QXB
50TB2P0000TB2P0000T92PTB2P0000032@T:00L94PX92@X92@X000094PX9
2@X94PX00PT92P0300002@T:2A8:00<92@X01@TB2PT92PTB2PTB2P000003
2@T:00DA70X92@XA70X92@X/4P000PT92P034A`:2@T:2@T:00892@X01000
00T92PTB2PTB2P892@X2000000h92@X94PX000092@X000092@X94PX92A@0
00092@X000092@X000092@X2000000H92A@92@X000092@X000092@X20000
00H94PX000094PX000094PX000042@T:00D000092@X000094PX000000PT9
2P042A8:2@T:2@TD00000`T92P894PX0100000T92PT92P0000H92@X00`TB
2PT950T92P022@T:00D000092@X000092@X94PX00`T92P0400002@T:2@T:
2A8:0P0000D92@X01AXB50T950T950TB2PT950022@T:00<A70X94PX94PX0
0P0000042@T:2A8:4A`:2A8:0PT92P032A8:00002@T:00<92@X01Q4L2R<L
2R`V52<_7QXV52<V2P8S;ah26RHD00<S9PXJ4Q@A70X00Q4L2P05;1`D8bH:
4A`:6Q8D4BH:008A70X02QX92Q4L2Q4V2R`V52<_:B`B02<V2QXV514L2R<L
2P8J2@X24A`:00<J9Q@A9PX0000010T92P032A8:6Q8D2@T:00892@X00aXB
50T92PT92P052@T:00<94PX92@X92@X010T92P8A70X22@T:00HA70X92@XJ
2@XA70X92@ZEQ8iQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c0054A`:2@TD2A8:2A8:2@T:
00@94PX02@T92PTB2Q4L2PT92Q4L2PT92PTB2PT92PTB2P022@T:00D94PX9
2@X92@X92@X000000PTB2P<92@X01`0000TB2P0000TB2P0000T92P000002
2A8:0`T92P894PX010T92PTB2PT92PT92P8A70X01b`B014L2Q4L2Q4L2QX9
2PT92Q4L2P042@T:00@000094PX92@X94PX22@T:0P0000032@T:00000000
0080000070TB2PT92P0000TB2P0000TB2P0000TB2PT92P0000T92P0000TB
2PT92P0000T92PTB2P0000T92P0000T92P0000T92P0000TB2P0000T92P00
00892@X01`0000T92PT950T92PTB2PT92P0000022@T:00<94PX92A@94PX0
0PT92P072A8:2@T:2@T:2A8:2@TD4A`:2@T:00@92A@01@T92P0000TB2P00
00TB2P032@T:00<000092@X000000PTB2P892@X010TB2PT92PT92PT92P89
4PX010T950TL7PT950TB2P892A@22A8:00<971@92@X92@X00`T92P034BHD
2@T:2@T:00L92@X01A4L2QXV52<_7R`h:AXV50028blN00/J9Q@S9PXS;ahS
9PXS;ahS9PXJ4Q@S9PXJ9Q@S;ahA9PX00QXV508J4Q@02A4V2Q4L2QXB52<_
7SAE:@T9514L2Ra<:AXV50024A`:00HJ9Q@A9PXA9Q@J9Q@d;bTA70X52@T:
00@J2@XJ4Q@92@XA70X92@T:00<J2@X92@XA70X00`T92P0;00002@T:2@T:
00002@T:2@TD2@T:4A`:2@T:0000YYR4067<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c01Mc<c<00@9
2A@92@XJ4Q@92@X22A8:00<92@X94PX94PX010TB2P892@X01`TB2PT951X9
2PTB2Q4L2PT92PTB2P032@T:00<A70X000094PX01PT92P032A8:2@T:2@T:
00892@X02000014L2PT92PTB2P0000TB2PT92PTB2P892@X01AX92Q4L2QX9
2Q4V2R`B00034A`:1@T92P0800002A8:2A8:2A8:00002A8:2@T:2A8:0PT9
2P0300002A8:2@T:00892@X0100000T92P0000T92P8000022A8:00h92@X0
00092@X0000A70X000092@X94PX000094PX000094PX92@X000022@T:00P9
4PX92@X94PX92@X94PX000092@X94PX42@T:00L94PX92@X94PX94PX92@X0
00094PX00PT92P892A@0214L2PT9514V50T9514_?@0000T92P0000@92@X0
0`TB2PT92PT92P032@T:00DJ2@X94PX92@X000094PX00PT92P062@TD6Q8D
2A`D2@TD6Q8D2A`D1@T950052A8:2@T:2@T:2@T:4BHD00@92@X00`TB2PT9
2PT92P024A`:00DJ4Q@J9Q@/>2T/>2TS;bT01R<_7P038bH:6Q`N8blN00<S
;ah00b<_:B<V2R<_7P026RHD00/A70XJ9Q@/>2U6C3d000094PX92A@d;ahS
;ahJ2@XS;bT00b<_7P05;4`Y6Q8D2A8:2@T:4A`:00892@X00aX92QXB50T9
2P052@T:00H94PX92@X92@XJ2@X92@XA70X52@T:00PA70X92@X92@X92@XA
70XJ2@XA70X92@X26Q8D00<0002VV6o<c<`0H<c<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<05g<c<`0
114V514L2PTB2QXB50892@X0214L2PT92QXB51XB50T92PTB2PT92Q4L2P89
2@X00`TB2PT92PT92P062@T:00D000092@XA70X92@X94PX00PT92P072A8:
2@T:2A8:2@T:2A8:;1`D4BHD00894PX32@T:0PTB2P892@X01A4L2PT92Q4L
2Q4L2PT92P024A`:00T94PX92@XA70X92@XA70X92@X94PX000092@X00PTB
2P046PT:2A8:2A8:00000PT92P042A8:00002@T:2@T:0PTB2P0700002A8:
00004A`:2@T:2A8:000000892@X01P0000TB2P0000T92PTB2P0000<92@X0
2P0000T92PT92P0000TB2P0000T92P0000TB2P0000892@X22A8:0`T92P<9
4PX62@T:00XA9QhS;c<92A@A;c<S;c<J71hA9QhA70X92@X94PX42@T:00<9
4PX92@X94PX00`T92P032@TD6Q8D2@TD00<92@X02QXB50TB2PTB2PTL7PTB
2PT950TB2PT9514L2PT950894PX01@0000T92PT92PT951XB50052@T:00DA
70XJ4Q@A70XJ2@XA70X00b`h:@03;4`Y6Q`N6RHD00<S;ah012`V51XV52<_
7SAE:@<S;ah00b<V2R<_7R<_7P028blN00PJ4Q@J9Q@dEBTdEBT0000J4Q@9
2A@d;bT2;3PY00Ld;ai6@AhdEBTS;ahS;bT0000A70X00PT92P044A`:2@TD
6Q`N4A`:0`T92P034A`:2@T:;18000@92@X00a4L2P0000TB2P034A`:0`T9
2P046PT:2@T:2A8:6PT:0PT92P044A`:6PT:0000CeiVHLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c003ooooc<c<c<c<
05g<c<`00`TL50T950TB2P032@T:00L94PXA70X92@XA9Q@971@J4Q@94PX0
0PT92P034A`:2@T:2@T:00H92@X01Q4L2PT92PT92PT92PTB2P0000<92@X0
1PTB2P0000T92P0000TB2P0000<92@X22A8:00L0000J2@XA70X0000A70X9
2@XA70X00PT92P052A8:00002@T:2@T:6PT:008A70X00`00014L2PT92P03
2@T:0PTB2P036PT:2@T:2@T:00<92@X2000000X92@X000092@X000092@X0
00094PX000092@X000022A8:0PT92P0=2A8:00002@T:2@T:00002A8:2@T:
00002A8:2@T:00002@T:2A8:00<92@X22A8:00T000092@X94PX92A@94PX9
2A@000092@X94PX00PT92P0;2A8:00002@T:=5Dm6Q`N6PT:CeiVJW^4;6ML
00002@T:0080000020T92P0000TB2P0000T92P0000T92P0000892@X00a4L
2PT92QXB50032@T:00@A70X94PX92A@92A@22@T:00H94PX92A@92@X971h9
2A@94PX22@T:00@94PX92@X92A@94PX22@T:00@A70XS70XA70X94PX32@T:
0R`h:@04AT`m=2lY8blN6Q8D0R<_7P07;2HD6RHD8blN=5DY;4`Y;2HD8bH:
008/>2T00b<V2R<_7R<_7P028blN00P/71@/>2TdEBT92A@A70X94PY6@Ai6
GTL2=5DY00@/C2TS;c</9Q@A70X22@T:00<94PX92@X92@X00Q4L2P@92@X0
200000T92PT92QX92PT92Q4L2PT92Q4L2P892@X00aX92PT92PT92P092@T:
00@J4Q@92@X92AAP@BUQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^?o<c<`Jc<c<00?oooo<c<c<c<`0GLc<c00>4A`:6Q8D2@T:2A8:
6Q8D4A`:2@T:6Q8D4A`:2@T:;1`D6Q8D2@T:4A`:0PT950034A`:2@T:2A8:
008A70X00`T92Q4L2PTB2P022@T:00@94PX92@X0000A70X52@T:00P94PX9
2@X000094PX92@X94PX000092@X3000000<92@X94PXA70X00PT92P034A`:
2@T:2@T:00892@X01A4L2P00014L2PT92Q4L2P052@T:00<000094PX94PX0
10T92P0400002A8:2@T:2A8:0P00000A2@T:00002A8:00002@T:00002@T:
00002@T:00002@T:00002A8:00002A8:2@T:000000894PX0100000TB2P00
00T92P8000003PTB2PT92P0000TB2P0000TB2P00014L2P0000TB2PT950T9
2P0000TB2P892@X03`TB2PT92Q4L2PT92R`L514_?Cd_?BaEK`TB2P0000T9
2PTB2P0000TB2P0000022A8:0PT92P894PX01`T92Q4L2PT952`h:@T92PTB
2PT92P022@TD00DJ4Q@94PX92@X94PX92@X00`T950052@T:00002A8:2@T:
000000894PX22@T:0PTB2P0<2@T:00002A8:2@T:2A8:00008bH:=5DY=2lc
=5DY;3PY4A`:0R<_7P066RHD8blN8blN=2lY;4`Y8blY0R<_7P048bH:;3PY
8blN=2lN0R<_7P08;3PYAUDY=5DY00002A8:8blN?Ehm8blN0aXV50036Q8D
4A`:000000D92@X00aX92PT92PT92P052@T:00H000092@X92@X94PX92@XJ
2@X22@T:00@S70X92@X92@X94PX82@T:00@A70X92@X0002`NfIQc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?o<c<`Jc<c<00?oooo<
c<c<c<`0GLc<c00@2@TD6Q8D2A8:4A`:2@TD2A8:4A`:2@TD4A`:2@T:8blc
2@T:4A`:2@T:2A8:4A`:0PT92P034A`:2A8:2@T:00<92@X22A8:00@92@X0
00094PX94PX22@T:0`TB2P0400002A8:2@T:2@T:0P00000:2A8:2@T:2@T:
2@T:6Q8D2@T:4A`:2@T:2A8:4A`:0`T92P042A8:2@T:2A8:2A8:0`T92P04
4A`:2@T:2@T:4A`:0PT92P8000001PTB2PT92PTB2PT92PTB2PT92P800002
2@T:00D000094PX000092@X000000`T92P0A00006Q8D00002@T:00002A8:
00002@T:2A8:2@T:00002@T:00002A8:2@T:00002A8:00@92@X020T950T9
2PT9500000T950T92P0000T92P894PX02@0000TB2PT92PT92PTL50T92Sd_
?H>=Q6YkQ0022@TD00H94PX92@X000092@X000094PX2000010T92P070000
4A`:6Q8D2A`D2@T:00002A8:00892A@00`TL50T92PTB2P032@TD00<94PX9
2A@94PX01@T92P042@TD4A`:4A`:2@T:0P0000064A`:00002A8:00002@T:
8a`:0TI<?@04=5DY;3PY4BHD6Q`N0b<_7P056Q8D;3PY=2lY6RHD8blN00@/
>2T38blY00Y6EBU6C3dA9Qh92@XJ4Q@/9Q@971@92@XJ9Q@92@X24A`:10T9
2P034A`:2@T:2@T:00`92@X00a4L2PT92PT92P032@T:00<J2@X92@X92@X0
1PT92P056PT:2@TD4A`:0000b]31067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c?mVIVHFIVIV00?oooo<c<c<c<`0GLc<c004
6Q8D4A`:2@T:2@TD0`T92P074A`:2@T:2@TD2@T:2A8:2@T:6Q8D00@92@X0
0`TB2PT92PT92P022@T:00<94PX92@X92@X010T92P894PX00`0000T92PTB
2P022@T:00H94PXJ2@X94PX000092@XA70X32@T:00<94PX92@X92@X00`T9
2P0300002@T:2A8:00892@X01@TB2PT92PT92Q4L2QX92P042@T:00@00009
2@X92@X000082@T:00<000092@X000000`T92P0400006PT:2@T:00000PT9
2P0500002@T:2@T:00002@T:008000000`T92PT9500000022@T:00<94PX0
00092@X01`T92P0500002@T:2@T:2A8:000000D92@X01@T9500000TV:BaW
G0TL7P022A8:00<000092@X92@X01PT92P0300002@T:2@T:00H92@X02@TB
2PT950T950T950T92PTB2PTL51XB50TB2P022@TD00<92@X94PX92@X00PT9
2P052A8:2@TD2@T:2A8:000000H92@X00`0002<_7TI17P02?Ehm00<d;bTS
9PXA9Qh012<_7P96EBT01R<V2R<_7R`h:B`V52`h:CAE:@8J9Q@01C@_:DIN
AcAE:@TL50T92P024BHD00<92@XA70X92@X00Q4L2P032A8:2@T:2@T:00X9
2@X00`TB2PT92PT92P072@T:00<J2@X94PX92@X02PT92P044A`:2@TD0000
`K>]HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<
00=VIVK<c<bIVIT01iVIV@Soool00okno_ooooknoP02m_Kf00?^k^kQhN7N
g]h00m[JfP?IfMU2f=SH2=WIf@06e]KFfm_Ki>CTk>c/lo?cnOWi0_ooo`?n
o_h6ooooVYVIV@03ooooc<c<c<c<05g<c<`01@T92Q4L2PTB2QXB50T95002
2A8:00D000092@X94PX94PXJ4Q@00PTB2P034A`:2@T:2A8:00894PX01a4L
2PT92PT92PT92QX92PT92PTB2P032@T:00H94PX000092@X92@X94PX00003
2@T:00@94PX92@X92@X94PX52@T:00DS;bT94PX92@X92@X94PX01@T92P05
2A8:2@T:4A`:0000=2lY00P92@X00a4L2PT92PT92P092@T:00<000092@X9
2@X00PTB2P@92@X00`0000T92P0000042@T:00@000094PX94PX000032@T:
00<94PX92@X92@X010T92P032A8:2@T:2@T:00D92@X00`0000T92PTB2P02
2@TD00L000094PX971@000092A@92@X000001`T92P0500002@T:2@T:2@T:
2A8:00<92@X02aXB50TB2QXB50T950T92QXB50TL51XB50T950TL50T95002
2@T:00D94PX92@X92@X92A@A70X00`0000<92@X02@TB2PT92PT92PTB2QXV
53AE:DIE:DIEDSAE:@038blN00D/>2TJ9Q@/>2Td;bTdEBT00R`h:@0?=5DY
;3PY;4`YAT`m=2lY;3PYJW9LH5hc8blN00004BH:2@TD2A`D2@T:6PT:008A
70X42@T:00DA70X92@X92@X92@XA70X00`T92P054A`:6PT:2@T:2@T:4A`:
00@92@X01AX92PT92PT92PT92QX92P032@T:00<A70X92@X92@X00PT92P07
6PT:2@T:4A`:2@T:4A`:0000UHB>067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT8oooo00[lo?cn
o_kbl_;Shn?OgmoHf=S=cLg:b/[0`<2o_kl2_[jn00Bm_Kfl_;bk^k^k^k]8
_[jn00S0`<37alO?cloEeMGKfm_UiNGclo?moOd3o_kn1_oooiZIVIT00ooo
olc<c<c<c01Mc<c<00<A70X92@X94PX00PTB2P042@T:2A8:2A8:4A`:1@T9
2P072A8:2@T:4A`:00002A8:2@T:0000008A70X00`0000T92PT92P032@T:
00<94PX92@X92@X00`T92P0A2A8:2@T:2@T:00002A8:2@T:4A`:2@T:2A8:
2@T:2A8:2@T:2A8:2@T:2A8:2@T:2A8:00@92@X26Q8D00DA70X92A@92@XJ
71h0000010T92P0=4A`:2@T:00002@T:00002@T:00004A`:00002A8:2@T:
2A8:4A`:008000000`TB2P0001XL7P0200000PT92P042A8:00002A8:0000
0PTB2P052@T:00002A8:2@T:000000894PX0200000T92PT92PTB2PT92PTB
2PT92PTB2P<92@X00`0000TB2PTB2P032@T:00<94PX92@X92@X00PT92P06
2@TD2@T:2@TD2A`D2A8:00000`T92P0500002@T:00002@T:000000H92@X0
0`TB2PT92PTB2P022@TD00@971@94PX92@X94PX22@T:0`T950032A8:2@T:
000000894PX00`T9500000T92P092@T:00`S;ah/>2U6C3e6EBU?IdLd;bTS
;ahJ9Q@S9PX/>2TS;ah/>2T2;4`Y00<d;bT/>2T/C2T00TI17P04=2lYAUDY
LVMBEfMB0PTB2P074A`:8blY4BHD8blN6RHD4A`:2A8:00892@X00`0000T9
2PT92P072@T:00<000092@X92@X00`T92P036PT:4A`:2@T:00892@X01@TB
2PT92PT92PT92QX92P042@T:00TA70X92@X92@XA70X92@XA70X94PX0002V
V8@0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<
00=VIVK<c<bIVIT01iVIV@Soool02OCdm?;bl]kNg/S8b<30`;Rh^:j^[Z^[
Zj2PX002WinO00FMWIfLW9bKVi^JVYZIVIT0@9ZJVPRKVi/02:>SXj^[Zk:b
/[Fe]K^k^l[:b]oOgng]k@?no_h6ooooVYVIV@03ooooc<c<c<c<05g<c<`0
0`T9514L2PT92P022@T:0PTB2P<92@X22A8:00L92@XA70X92@XA70X92@X9
2A@J2@X00`T92P0300004A`:2@T:00892@X01@TB2PT92PTB2P00014L2P02
000000l92@X000094PX92@X94PX000094PX000094PX92@X000094PX92@X9
4PXA70X00PT92P034A`:2@T:2@T:00892@X0214L2PTB2PT92R`V51XB514L
2PT92Q4L2P894PX00a4L2P0000T92P032@T:00@94PX92@X92@X000032@T:
0P0000892@X2000000<A70X92@X000000PT92P0800002@T:2@T:2@T:0000
2@T:00002@T:0P0000062A8:000000002A8:2@T:2A8:0PT92P0300002@T:
2A8:00892@X020TB2PT92Q4V2PTB2P0000T950T92P0000892@X01PTB2QXB
50TL50TL7PT92P0000D92@X00`0000T92P0000022@T:00T000094PX00009
2@X94PX92@X000092@X94PX010T950032A8:2@T:2A8:00892A@00`T92PTB
2PT92P022@T:00@000094PX94PX94PX22@T:00/000092@X94PX92@X94PX9
2@XA70X/71@/>2U6C3dmGSd00TI<?@038blY8blN;3PY008/>2T01CAE:DI1
7S@_<ba<:DI17P02;3PY00//GSdS;bUGEE9ZNfldEBT000092A@0000S;ai6
EBT/C2T01@T92P032A8:2@T:2@T:00X92@X00`0000T92PT92P022@T:00DA
70X92@XJ2@X92@X/4P000`T92P042A8:2@T:2@T:4A`:10T92P052A8:6PT:
6PT:0000UJ6>067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2h
R<2h1<c<c003IVIVc<c<VIVI00NIVIT00ooooogmoOooo`04oooo00gemOGN
g]k?clno_kna/K6UYJFGUiN<S8b7QhN9RHV8R8R5QHF1PH400WemO@03Ogmo
PH61Ogmo03moOgl3P82000mnOWimOGeoOgn4Q8B9RHV7QhN:RXZ>SXjEUIFP
X:2`/;33`l?AdM7Ti>Cbl_800_knoP03o?cloooooooo00;ooonJVIVI00?o
ooo<c<c<c<`0GLc<c0056Q8D4A`:2A8:6Q8D2A8:00<92@X01Q4L2PT92PTB
2PTB2PT92QXB50<92@X00a4L2PT950T92P022@T:00<A70XJ4Q@92@X00PT9
2P0300002@T:2@T:00892@X01@TB2PT92P00014L2P0000072@T:00/94PX9
2@X92@XA70X0000A70X94PX92@X0000A70X000000PT92P0600002@T:2@T:
2@T:2A8:000010T92P8A70X42@T:00L94PX92@X000092@X94PX92@XA70X0
10T92P0400002@TD00002A8:10T92P0600002@T:00002A8:2@T:000010T9
2P032@TD00002@T:00@92@X00`TB2PT92PTB2P022A8:0PT950032A8:2@T:
2A8:00<92@X00`TB2PT950TL50022@TD00T92@X92A@0000A70X92@X00009
4PX000094PX00PT92P052A8:2@T:2@T:2A8:000000892@X32A8:00<92@X9
4PX92A@00PT950054BHN2@TD2A8:2A`N2@TD00892@X01PTB2PT92PT92PT9
2PTB2P0000<92@X020TB2PT92PTB2PT92Q4L2PTB2R<_7R`h:@96C3d00dIE
DTIE:B`h:@028blN01TdEBTd;bTd;c<dEBTd;c=6C3ddEBT/>2TdEBT/C2UG
EE9GSEaPGS<S;ah92A@00016@AibSCd/C2T000094PX92@X000092@X94PX0
4@T92P036PT:2@T:2@T:00@92@X01`TB2PT92PT92PT92QX92PT92PTB2P02
2@T:00HS70X92@XJ2@X92@X0002VXIQQc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI01Soooono_ko
oooooookno_jn_[bl_;Rh^;Fe]K7alNc/k>OWin<S8akNg]cLg=bLW9aLG5b
LW9cLg=bLW9`L71_Kfm`L71aLG4hL71`275aL@0CKVi^L71`LG5aLG5aKfm_
L71`LW9bMGEeO7alL71`KVi^OGemT92@WYjN/;2``<30clo?hn?Sn?Sh00;o
ool01?kno_gmoOclo?oooiZIVIT00oooolc<c<c<c01Mc<c<00<92A@92@X9
2@X00PT92P032A8:2@T:2@T:00894PX01`T92P0000T92PTB2PT92QXB50T9
2P032A8:00@J4Q@A70X94PXA9Q@22@T:00L94PX92@X94PX92@X94PX00009
2@X00PTB2P0400002@T:2A8:00000PTB2P0500004A`:00002@T:00000089
2@X22A8:00@92@XA70X94PX000062@T:00@000092@X000094PX22@T:00L9
4PX92@X92@X92@X94PX92@X000000`T92P042A8:00002A8:000010T92P0;
2A8:00002A8:00002@T:00002A8:00002@T:00002@T:008000032@T:00@0
00092@X000094PX22@T:0PTB2P0300002@T:2@T:00892A@00`TB2PT950TB
2P022@T:00H000092@X94PX92@X92A@94PX32@TD00H94PX92@X000092@X9
4PX000032@T:00<94PX0000000000PT92P0700002A8:00002A8:00002@TD
2@T:00894PX020TL7PT952`L52=1?@T950TL7PTL50T950894PX01@0000T9
2PTB2PTB2P0000032@T:02D94PX000094PX94PXA70XJ2@XA70XS;ah/C2Tm
;ce6@AhdECdmGSdS;ah/C2Td;bU6C3ddEBU6C3e?IdM?Ie`dEBU6C3dd;c</
>2TS;aiPGS=?IdLmGSd/C2T0001ZEAj3Ne`971@000092@X94PX00PT92P03
00006PT:2@T:00<92@X00`TB2P0000T92P0;2@T:00<94PXA70X92@X00PT9
2P032A8:2@T:2@T:00@92@X22A8:00L92@X94PXJ2@X92@XA70X0002VV8@0
HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT01iVIV@0Coooono_kooooooooo_knn_[jk>c/emOG^[ZjYJFU
Shn?QhN7SHf=Vi^KZJVY];Bde=CDemOGg=cL00;Ogml00mgMgMcLg=cLg00h
g=cL2=kNgP05f][Jg=cLg]kNg]kNgMgM00;Kfm/03=cLg<g=cKRh^:BTY9RH
V8R8R861PIFEUKBd];bl_=?Cdno_k`Coool00ogmoOoooiVIV@2IVIVI00?o
ooo<c<c<c<`0GLc<c0054A`:2@T:4A`:4BHN2@T:00894PX00a4L2PT92Q4L
2P032@T:0PTB2P046Q8D4A`:2@T:2A8:0`T92P072A8:00002@T:2@T:0000
2A8:000000894PX22@T:00P000094PX92@X92@X0000A70X000092@X22A8:
1PT92P894PX01@0000T92PTB2PTB2P0000022A8:10T92P0:4A`:2@T:0000
4A`:2@T:00002A8:2@T:00002A8:0`T92P0500002A8:00002A8:000000@9
2@X04@0000T92PT92P0000T92P0000T92P0000TB2P0000T92P0000T92P00
00TB2P0000T950022@T:00@000094PX92@X92@X22A8:00H92@X94PX92@X9
4PXA9Qh92A@32A8:00D92@X94PX92@X94PX971@00PT950072A8:2A`N2@TD
2A8:00002A8:000000894PX22@T:00P000092@X92@X92@X000092@X00009
4PX22@T:018000092@X92A@92@XA9Qh/71@J71hm;cd92A@971@971h94PXA
70X92@X94PX92A@A9Q@92A@22A8:00@92@X000094PX92@X22A8:02<A70XA
9Q@J9Q@d;bU6EBTdEBU?Ieb3Q7]6C3ddEBTS;bU6C3e6@AhdECeGEE9?Ie`m
GSe6C3e6GTM6EE9?IdLS;aiPGS=?IdMZLU`00016EBV=SFl/GSd000092@X9
4PX92@X000094PX00PT92P056PT:2@T:4A`:2A8:4A`:00L92@X00a4L2PT9
2PT92P022@T:00D94PX92@X94PX92@XJ2@X010T92P032A8:2@T:2@T:00D9
2@X01A4L2PT92QX92P0009FQSP1Qc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI00?no_kkno_oool0
0_ooo`0>m_Kfh^;RalO7/K6aVYZJR8R8TI6A[Zj^bl_;fm_KhN7QgMgMh^;R
inOW0^_[j`03j^[ZjNWYjNWY03SZj^X8jn_[00KYjNWZj^[[jn_Zj^[YjNWX
j>P2inOW00gQhN7OgmoMgMgAdM6c/k>CTi>:RXZCTi>/[:c3`l?Ph>3dm?Cm
oOd01?oooiZIVIT00oooolc<c<c<c01Mc<c<00H92@XA9Q@92@X94PX92@X9
4PX62@T:00TA70X92@X92@XJ4Q@92@X94PX92@X94PXA70X00PT92P030000
2A8:2@T:00D92@X01@0000TB2PT92P00014L2P022@T:00H000094PX94PX9
2@X000092@X62A8:00P000092@X94PX92@X000094PX92@X000042A8:0P00
00072@T:00002@T:2A8:00004A`:000000<92@X01a4L2PT92PT92PT92P00
00T92PTB2P032@T:00<A70X92A@94PX00`T92P072A8:2@T:00002A8:0000
2@T:000000<92@X01`0000TB2P0000TB2PT92P0000TB2P022@T:00D92A@9
2@X92A@92A@971@00PT950032A8:00002A8:00@92@X01@TB2PT950TL7Q4V
51XB500200000PT92P80000020TB2P0000TB2P0000T92P0000T92PTB2P<9
2@X22A8:014971h92A@971hS@Cd/EE`J2@XA;c<971h92A@A9Qh92A@92@X0
000A70X94PXJ4Q@971@00P0000032A8:2@T:2@T:00892@X01A4L2QXB52<_
7Q4V2R<_7P02;4`Y01PS;ai6GTMGIe96C3e6@Ai6EBU6C3ePGS=?IeaPGS=6
EE9?IdM6C3ePGS<dEBTd;aiPGS=bLW//GSdJ2@Z=SFl/GSd000092@X22A8:
00<000094PX92@X030T92P0300002@T:2@T:00@92@X031X92PT92PT92Q4L
2P0000T92Q4L2P0001XB500001X92PTB2P@92@X01Q4L2P00014L2PT92P00
0:JHQ67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<
c003IVIVc<c<VIVI00NIVIT4oooo017gmoOWinO;bl^/[:bJVYZFUYJMWIfd
];C>c/kKfm_MgMgJf][Vi^KYjNW]kNg_kno`l?000^o_k`03l?3`lO7alO7a
03kalO401??clo;bl_3`l>o_k`;^k^h2kNg]0]oOg`0=gMgMemOGc/k>^[Zj
WYjNQXJ6VYZJ[Zj^c<c<inOWm_Kfno_ko_kn00;ooom:VIVI0`0004fIVIT0
0oooolc<c<c<c01Mc<c<00@A70X92A@94PX92@X32A8:0PT92P082A8:2@T:
00002@T:2A8:2@T:2A8:00000PTB2P0300002A8:2A8:00@94PX22@T:00D9
4PX92@X92@XA70X000000PT92P0400002@T:2@T:2A8:0P0000<92@X20000
0`T92P894PX22@T:00X94PX92@X92@X000092@X000094PX000092@X94PX2
2@T:00H94PX92@X000094PX92@X94PX22@T:00<000092@X92@X00PT92P0G
2A8:00002@T:2A8:2@T:2A8:2@T:H44Y2A8:2@T:4A`:00002@T:00002A8:
00002A8:00002A8:00002@TD00002A8:008000000`T92P0000T92P032@T:
00P92A@971@94PX92A@A9Qh94PX92@X94PX22@T:00T94PX92@X92@X94PX9
2A@94PX971@94PX000000PT92P032A8:00002@T:008000001PTB2PT92P00
00T92PTB2P0000<92@X00`TB2P0000T92P022@TD00mZNh@A;ceGEE899RTA
;c<971hA9QhA;cd92@X94PX92@XS;ai6C3dS;bT92A@00PT92P062A8:0000
2@T:2@T:4A`:6RHD0R<_7P0<4A`:8blY=2lY=5DY;4`Y=2lcAT`m=5DYAT`m
?EhmAUEBAT`m1DmWA`0;?Ehm8blNAT`mLXeLNheV0000LXeL;4`Y00002@T:
2A8:008000042@T:00<000092@X92@X04`T92P044A`:2@T:2@T:4A`:10T9
2P032A8:2@T:2@T:00<92@X0114L2PT92P00079bNf7<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT4
oooo00_alO7MgMg0`<2QXJ65QHFEUIF^[Zk5aLGAdM7GemONg]h00^KViP03
jNWYjn_[k>c/00?/k>`00nk^k^o_kno_k`0fkno_2>g]k@04l_;bkno_kNg]
jn_[0^c/k00@jn_[j^[Zl?3`kNg]h>3Pclo?alO7`L71/K6aWYjNT92@XJ6Q
_knoh>3PmOGeo?cl0_gmo@03ooooVIVIVIVI04ZIVIT20000C9VIV@03oooo
c<c<c<c<05g<c<`02A4L2PT953@_<`TB2PT92PTB2PT92PTB2PT92P042A8:
00D92@X94PX94PX92@X94PX00`T92P092A8:000000002@T:2A8:2@T:4A`:
00002A8:00892@X00`TB2PT92PT92P052@T:00<94PX92@X94PX01PT92P05
2A8:2@T:4A`:2@T:2A8:00L92@X01P0000T92PTB2P0000T92P0000892@X0
100000T92PT92PTB2P892@X01`TB2PT92PTB2P0000T92PTB2P0000032A8:
00<S9PX92@X94PX00PT92P894PX0300000TB2P0000T92P0000TB2P0000TB
2P0000T92PT9500000892@X00`TB2PT92PTB2P032@TD00<94PX971@94PX0
0`T92P@94PX01PT950TL7PT950T950T92PTB2P<92@X00`TB2P0000TB2P02
000000D92@X94PX000094PX92A@00`T92P894PX030T950T92QXV58>H[DmN
IUN=SPTB2PTL7PTL50TL7PTL50T92P8A70X01`T954I<?B<_:@TB2P0000TB
2P0000022@T:00HA70XA9PX/>2T/C2TS;ahJ4Q@3;3PY00<S;bU6C3dmGSd0
0TINA`03AVMLCfM7AUEB009?IdL2EfMB00TmGSd/9QA6C3eZIc=kSFH94PYZ
Ic>3Q7/000002@T92P052A8:2@T:4A`:2A8:000000<92@X00`TB2PT92PT9
2P022@T:00<0000A70X92@X010T92P074A`:2@T:2@T:2@T:6PT:2@T:4A`:
00@92@X0114L2PT92PT92R<L2P892@X00a4L2P0008>4N`1Qc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07
VIVI01Coooono_koooono_k/k>cFe]Jj^[ZLW9bHV9RTY:Be]KG3`l?8b<S=
cLgJf][Xj>SUiNGWinOZj^[/k>`4jn_[>>g]k@S/k>`01>k^k^c/k>_[jn_[
j`;/k>`04>WYjNKVi]CDe=[Jf]kNg]SHf<c<c;jn_Zj^[Z>SXi:BTYbLW;Bd
]=GEeO3`l?clo0?oool4VIVI0P0000BIVIT2000019VIV@@00002VIVI0P00
00:IVIT200000YVIV@800006VIVI0P0000>IVIT200000YVIV@800002VIVI
100000JIVIT500000YVIV@800002VIVI0P0000:IVIT300000YVIV@800002
VIVI100000:IVIT200000YVIV@800006VIVI0P0000BIVIT400000iVIV@<0
0002VIVI0P0000>IVIT400000YVIV@80000DVIVI00?oooo<c<c<c<`0GLc<
c0032@T:4BHD2@T:00894PX32@T:00HA70X94PX94PX94PX0000A70X22@T:
00<94PX92@X94PX010TB2P032@T:2A8:2A8:00894PX01`T92PTB2PTB2P00
014L2P00014L2P022@T:00X94PXA9PX92@X000092@X000094PX92@XA70X0
00032A8:00<92@XA70X92@X00PTB2P034A`:6PT:2A8:00892@X01a4L2PT9
2PTB2P0000TB2Q4L2P0000022@T:00@94PX92@X92@X000022A8:00<00009
4PX94PX010T92P056PT:2A8:2@T:2@T:2A8:00<92@X2000000PA70X00009
4PX94PX000094PX000092A@32@T:00@000094PX94PX94PX22@T:00H92A@9
71h94PX971h971@92A@32A8:00d92A@94PX92@X92A@971h971@971h92A@9
2@X000094PX000094PX01`T92P032A8:2@T:2@T:00894PX00a4L2PT950T9
50022A`D00LJ71i6Iea?LW/S@Cd94PX92A@99RT00PTL50082A8:4A`:6PT:
6Q`NEeEB8blY2@TD2A8:0PT92P0A4A`:2A8:2@T:8blN6RHD8blN6Q8D;3PY
AUDYAT`mAUDYAT`mCfM7CfMLCfM7=5DmEfMB008mGSd2AUEB0SAE:@08=2lY
4BHD=2lN/:Z42A8:AT`mNheV000010T92P894PX52@T:00DA70X92@X92@X9
2@XA70X00PT92P044A`:2A8:2@T:2A8:0a4L2P<92@X01R<L2Q4L2PT92Q4L
2PTB2Q4L2P<92@X01a4L2PT92QX92PT92Q4L2PT92Q4L2P022@T:00@A70X9
2@X0002EV:=Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0
^0C<c<`00fIVI/c<c9VIV@07VIVI0oooo`0<nOWih^;Rb<S8Zj^[SXj>Vi^K
WinOZj^[_Kfmb/[:d];BemOG0]cLg004gmoOi>CTi^KVi^KV0^CTi003hn?S
iNGUiNGU03kUiND05nCTi>?ShnCTi>KVi^OWinKVi^7QhMgMgNGUiMOGelg=
cLk>c/_;bkbl_:VYZInOWiJFUYRHV:RXZ<O7anCTi?Kfm_knoP02oooo19VI
V@800004VIVI0P0000>IVIT200000YVIV@8000000iVIV@0000000002VIVI
0P0000:IVIT200001YVIV@800003VIVI0P0000:IVIT2000000>IVIT00000
00000YVIV@800004VIVI0P0000>IVIT2000000>IVIT0000000000YVIV@80
0002VIVI0`0000:IVIT2000000>IVIT0000000000YVIV@8000000iVIV@00
00000002VIVI0P0000JIVIT200000iVIV@800002VIVI0P0000:IVIT30000
00BIVIT0000000000002VIVI0P0000:IVIT2000000>IVIT00000000059VI
V@03ooooc<c<c<c<05g<c<`32A8:00<92@X92A@94PX00PTB2P892@X01P00
00TB2PT92PTB2PT92Q4L2P<92@X00aX92PT92PT92P032@T:00H000094PX9
2@XA70X000094PX:2@T:00D94PX92@X92@X000094PX00PT92P0400004A`:
2@T:4A`:0`T92P032A8:2@T:2@T:00<92@X020TB2PT92PT92PT92P00014L
2P00014L2P8000001PTB2PT92PT92QXB500000TB2P@92@X0100000T92PTB
2P0000892@X01a4L2P0000TB2PT92PTB2P0000T92P0200000PT92P042A8:
000000004A`:0`T92P052A8:2@TD2A8:2@TD2BHY00<92A@22A8:00H92@X9
4PX94PX94PX92@X94PX32@TD00<A9Qh000092@X020T92P052A8:00002@T:
2@T:000000894PX42@T:00T94PX971hA9Qh94PX971@92@X971h92A@971h0
0PT950082@T:2A8:4A`:8blc=2lc2A`D2@T:00000PTB2P892@X00a4L2R<_
7R<_7P028blN01TdEBTmGSe6C3eGSEaGIe9ZSEa?Iea?IdMGEE9PGS</C2U6
EBTdEBTA9QhJ2@X/>2T0000S;aibIe8A9Qj=SDN3SHA6C3d000092@X00PTB
2P892@X00`0000T92PT92P072@T:00<A70X92@X92@X020T92P032A8:2@T:
4A`:00@92@X01AX92PT92PT92Q4L2P0000092@T:00<A70X0002VXIP0HLc<
c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<
c<bIVIT01iVIV@0Ao_knooooo?cln_[jgMgMalO7XZ:RPX:2TI6AWinO[Jf]
]kNg_[jnb<S8d=3@dm?Cf=SH00;GemL01MWIfMgMgMkNg]gMgM[JfP0hg]kN
2=gMg@?Ph>005]oOgmkNg]gMgM_Kfm[Jf]GEeM?Cdlg=cLG5aKjn_[Ng]j^[
Zj6QXIBDU8:2PZFUYL71`MkNg_Shn?oooogmoOooo`BIVIT2000019VIV@80
0003VIVI0P0000:IVIT2000000>IVIT0000000000YVIV@800002VIVI0P00
00JIVIT200000iVIV@800002VIVI0P000003VIVI0000000000fIVIT20000
00BIVIT00000002IVIT200000YVIV@80000019VIV@00000009VIV@800000
0iVIV@0000000002VIVI0P000003VIVI0000000000:IVIT200001YVIV@80
0003VIVI0P0000:IVIT200000YVIV@<0000019VIV@000000000000:IVIT2
00001IVIV@80000DVIVI00?oooo<c<c<c<`0GLc<c0066Q8D0000=2lc2A8:
2@T:4A`:0PT92P894PX42@T:0P0000@92@X00`TB2PT92PTB2P042@T:00<0
00092@XJ2@X010T92P0800002@T:2@T:4A`:2A8:2@T:2A8:000010T92P0;
00002@T:2@T:2@T:4A`:2@T:4A`:2@T:00002@T:2A8:00892@X00`0000T9
2PTB2P052@T:00@94PX000092@X94PX42@T:00@A70X000094PX000022A8:
00<92@XA70X000000`T92P0300002A8:00000080000040TB2P0000T92PT9
2P0000T92P0000TB2PT92P0000T92PTB2PT92PTB2PT9514L2P8971@01PTB
2Q4V50T950T92PTL50TB2P892@X01`T950TB2Q4L2PT92Q4_?@TL7Q4_<`02
2@T:00@000092@X92@X000042@T:00<000094PX000000PT92P042A8:2@T:
2@T:2A8:0PT92P032A8:2A`D2A`D00892@X02aXB50TL514_<`T950TV:A4V
50T92PTB2PT92Q4V50TL50022A8:10T92P034A`:6Q8D8blN00<S;ah01cd_
?CeN?EMWDUMWDVYbG4mWAeMWDP02=5DY01HA9Qh/9Q@d;ah94PXd;ahJ9Q@9
4PXd;ajVV6m6IeabIe:EV6IbSCePGS<A9Q@92@X000094PX92@X94PX92@XA
70X62@T:00<A70X92@X92@X00`T92P034A`:2@T:2@T:00<92@X011X92PT9
2PTB2QX92P892@X00aX92PT92PT92P022@T:00@A70X94PX92@XJ2@X22@T:
00<A70X92@XA70X00Q4L2P036PT:0000b]31067<c<`016IVIXS0^8S0^4R@
R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT04Okn
o_ooooclo?[jn]_KflS8b96ATHB4Q96ATIfMWJ^[Zk:b/[Rh^<30`<K6a/W9
bM3@d002clo?00CBd];Fe]KHf=SHf=Pie]KF2=OGe`GFe]H05=GEeMCDe=?C
dlk>c/c<c<O7akno_kVi^K:b/ZNWYifMWI6ATH>3PiFEULC4a=gMgOShn?oo
oo_knoooo`BIVIT2000019VIV@800003VIVI0P0000:IVIT2000000>IVIT0
000000000YVIV@800002VIVI0P0000JIVIT200000iVIV@800002VIVI0P00
0003VIVI0000000000@00007VIVI10000003VIVI0000000000<00002VIVI
0P000004VIVI00000000VIVI0P000003VIVI0000000000:IVIT2000000>I
VIT0000000000YVIV@800006VIVI0P0000>IVIT200000YVIV@80000029VI
V@00000009VIV@0009VIV@0009VIV@8000000iVIV@0000000004000000>I
VIT00000000059VIV@03ooooc<c<c<c<05g<c<`01Q4L2QXB50T92Q4L2PT9
2PTB2P@92@X01@TB2PT92PT92PT92Q4L2P032@T:00@94PX92@XA70X92@X2
2A8:2`T92P054A`:2@T:2A8:2@T:2A8:00<92@X00a4L2PT92PTB2P032@T:
00TA70X94PX92@XA70X0000A70X000092@X94PX010T92P064A`:2@T:2@T:
00002@T:00001PT92P072A8:00002@T:2@T:00002@T:4A`:00892@X020TB
2PT92PT92PT92P0000T92P0000TB2P<92@X01PTB2P0000TB2P0000T92P00
00892@X02`TB2P0000T92QXB52<_<a4_<dINA`TB2PTL7PTL50T950022A8:
00@92@X94PX92@X94PX32@TD00</71@99RT92A@00`TB2P<92@X01@TB2PT9
2PT92P0000TB2P022@T:00@A70X92@X000094PX22@T:0PTB2P032@T:2@TD
2A8:00894PX22A`N00<A9Q@971hJ4Q@00PT92P894PX0114V7PT950T950T9
2P894PX22@T:01XA70XJ9Q@S;ah/>2TS;bU6C3ePGS=ZLUakSFI6EE96EBTd
;bTS9PXA70X0001P;a@A9PX92A@92@YbSCd94PXA9PYbIe9GSE`d;ajEV6H2
2A8:00BEV6I6@Ah94PX000022@T:00<94PX000092@X00`T92P036PT:2@T:
2@T:00<92@X00a4L2QX92PT92P032@T:00LJ2@X92@X92@X92@XJ2@X92@X0
00000`T92P058a`:00004A`:2A8:6PT:00@92@X02B<L2PT92PTB2QX92PT9
2Q4L2PTB2P0008fHSP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI013moOgoooomoOgjn_[IfMW:
b/YgMgN5QHF=SHfIVIVUYJF/[:b`/;2g]kNm_Kfo_kl3aLG500?7alO;bl_>
c/h00/o?ccS=cLd8c/k>0lc<c00Fbl_;b/[:b<S8alO7a/K6a<C4`/;2_[jn
]kNg/[:b[Jf]Xj>SVIVISHf=Ph>3OGemalO7g=cLn?ShoooonOWioooo19VI
V@D000000iVIV@0000000003VIVI0P0000:IVIT2000000>IVIT000000000
0YVIV@800002VIVI0P0000JIVIT200000iVIV@800002VIVI0P000003VIVI
0000000000:IVIT200001IVIV@D00002VIVI100000>IVIT2000000BIVIT0
0000002IVIT2000000>IVIT0000000000YVIV@8000000iVIV@0000000002
VIVI0P0000JIVIT200000iVIV@800002VIVI0P000004VIVI00000000VIVI
0`000004VIVI00000000VIVI0P0000:IVIT2000000>IVIT00000000059VI
V@03ooooc<c<c<c<05g<c<`01@TB2Q4L2PTB2PT92Q4L2P042A8:00<A70X9
2@X92@X00PT92P082A8:2@T:2A8:2@T:2A8:00002A8:2@T:0PTB2P030000
4A`:2@T:00/92@X22A8:0`T92P0400002@T:000000001@TB2P032@T:4A`:
2A8:00892@X0200000TB2PT92PTB2PT92PTB2P00014L2P@92@X00`0000T9
2PT92P052@T:00<0000A70X94PX00`T92P032A8:00004A`:00892@X02`00
00TB2P0000TB2P0000TB2P0000T92P0000T92P0000022@T:00D94PX92@X9
4PX0001?Ie`00PT92P05AUEB2A`D2A`D2@TD000000<92@X03@0000TB2PT9
514V50T952<_:Cd_?B<_<`TB2PTL50T92P0000TB2P022@T:00<000094PX9
4PX00PT92P0700002@T:2A8:2A8:2@T:00002A8:00892@X00`0000TB2QXB
50022@TD00<971@92A@A9Qh00PTL500:2@TD2A8:2@T:2@T:2A8:2A`D2@TD
2A`D2A8:00000PT92P0E4A`:4BH:6Q8D4BH:;4`Y=5DYAT`mCfM7AUDY=5DY
8a`:2A`D4A`:2@T:6Q8D2@T:=5DY2@T:4A`:JVLc=2lN0096@Ah02FZ=G3@_
7[2ZQ00000T92QX92Ra<:JJQIP0000022A8:2@T92P044A`:2A8:2@T:4A`:
1@T92P044A`:2@T:2@T:2A8:0`T92P8A70X01PT92PTB2PT92Q4L2PT92QX9
2P<92@X02a4L2PT92PT92PT92QX92Q4L2QX92Q4L2QX92P000:JQV01Qc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<
c9VIV@07VIVI013lo?coooono_kkno_Jf][=cLePH622PX:6QXJBTY:OWinV
YZJ[Zj^b/[:h^;Rk^k/3_Kfm00Fo_ko2`/;4a<C6a/K7alL0><K6aP[5aLD0
1LC4a<?3`l30`;jn_[bl_003^k^k00ng]kNa/K6][JfXZ:ROWinFUYJ8R8R1
PH5VIVK:b/[Lg=chn?Soooojn_[oool019VIV@800004VIVI0P0000BIVIT0
0`0009VIVIVIV@02000000FIVIT000000000002IVIT00`000003VIVI0000
000000JIVIT200000iVIV@<0000019VIV@00000009VIV@800002VIVI0P00
00BIVIT4000019VIV@80000019VIV@00000009VIV@800003VIVI100000:I
VIT00`0009VIVIVIV@02000000FIVIT000000000002IVIT00P0000JIVIT2
000019VIV@030000VIVIVIVI0080000019VIV@00000009VIV@<0000019VI
V@00000009VIV@800002VIVI0P000003VIVI0000000001BIVIT00oooolc<
c<c<c01Mc<c<00@J4Q@94PX92A@A70X22@T:00<94PXJ4Q@92@X00PT92P08
4A`:2A8:4A`:2A8:2@T:4A`:2A8:4A`:0`T92P042A8:00004A`:000030T9
2P0400002@T:2@T:00000PT92P042A8:4A`:2@T:2@T:0P0000032A8:2@T:
2A8:00@92@X010TB2PT92PT92P0000894PX0100000TB2P0000TB2PH92@X0
0`0000T92PT92P022@T:00<000094PX92@X00PTB2P<92@X200000PT92P05
2A8:00002@T:00002A8:00<92@X010T950T92P00000000892@X01P0002=1
?C@_:AXB52`V51XB50892A@32A8:0PT92P032@TD00002BHY008J71h014IE
DRaEG0TB2PTB2P892@X00`0000TB2P0000022@T:00D000094PX000092@X0
000020T92P042A8:2@TD2A`D2A8:0PT950054BHN2A`N2A`D2@T:000000<9
2@X01@TL7QXB50T9500000TB2P022@T:00@A70XJ4Q@J9Q@/>2T2CfM700@m
GSdA9PX0000A70X32@T:0Q4L2P0>;1808a`:AUDYJVLc8blYEeEBUJ6>NheV
0000/:Z44BH:00002@T:00000TI17P05LXdm00002A8:2@TD000000892@X0
0`0000T92PT92P0C2@T:00<J2@X92@XA70X00PT92P036PT:2@T:2@T:0089
2@X26PT:00T94PX92@X92@X92@XJ2@X92@XJ2@X0002VXIP0HLc<c004IVIV
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT0
1iVIV@0HoOgmoooooooono_khN7QdM7AEEEENGUiPH61SXj>VYZJXJ6QYZJV
[Jf]/k>c]KFe]kNg^;Rh^KVi^[Zj^k^k_;bl_[jn_kno>;fm_@Rl_;`3_Kfm
01Jl_;bk^k^i^KVh^;Rg]kNe]KFd];Ba/K6[Zj^XZ:RTY:BJVYZATI62PX9i
NGUIFEW=cLgOgmohn?SoooomoOgoool4VIVI0P0000BIVIT400000YVIV@@0
0002VIVI0P000003VIVI0000000000:IVIT200001iVIV@800003VIVI0P00
0003VIVI0000000000>IVIT400001IVIV@800006VIVI0P0000:IVIT40000
0iVIV@@00002VIVI100000:IVIT2000000>IVIT0000000001iVIV@800004
VIVI100000:IVIT200000YVIV@030000VIVIVIVI00800002VIVI100000:I
VIT400004YVIV@03ooooc<c<c<c<05g<c<`32A8:00H92@XA70X94PX92@XA
70X92@X22A8:10T92P032A8:00002@T:00<92@X00`TB2P0000T92P032@T:
00LA70X92@X92@X92@X94PX92@XA70X00`T92P042A8:2@T:4A`:00000PTB
2P0300002@T:2@T:00892@X01@TB2PT92PTB2P0000TB2P022@T:00D94PX0
00092@X000094PX01@T92P072A8:00002@T:00002@T:00002A8:00892@X0
1P0000T92P0000T92PTB2P0000892@X01`0000T92PT92P00014L2PTB2PT9
2P02000010T92P80000010T92P00000000TB2P892@X02P0000T92PTB2R<_
7QXL7P0004IEDPT950TB2PT92P894PX22@T:00d92AA6EE9?GVIbLW/m;cd9
@DL99RT92@X94PX92@X000094PX000000`T92P032A8:2@T:2A8:00892@X0
0`0000T92PT92P062@T:0PTB2P892A@010T92Q4_<`T92PTB2P<92@X01@TB
2PT950T9514V50TB2P032@T:0Q4L2P0I6RHD;3PYH5hc=5DY6RHD00002@TD
2@T:2A8:2@T:4A`:6PT:6Q8D;2HD=2lNH5hcPg]LEfMBLXdm`K>>;5hm0000
`K>>2A`N000000892@X2000000N3Nc=6@Aj=SDL0000A70X92@X000002`T9
2P036PT:2@T:2@T:00892@X01A4L2PT92QX92PT92QX92P052@T:00@J2@X9
2@X92@XA70X82@T:00HJ2@X0000A70XJ2@X0002EV:=Qc<c<00AVIVJ8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI
01?no_kmoOgoooolo?c/k>cFe]IIFEU[Jf]lO7b7QhNDU9BJVYZNWYjTY:BY
ZJV/[:b`/;2b/[:d];@00kFe]@03][Jf]kNg];Bd03Nd];@8]KFe00>d];Be
]KFe]KD01;Jf]P0?]KFe[Zj^[Jf]ZJVYXj>SWinOVi^KTY:BR8R8NGUiKFe]
F5QHe=CDj>SXnOWi00?oool4VIVI0P00022IVIT200000iVIV@80000?VIVI
0P0000>IVIT2000000>IVIT0000000002iVIV@80000DVIVI0P00036IVIT0
0oooolc<c<c<c01Mc<c<0PT950894PX22@T:00@A70X92@X92@XA70X52@T:
00@94PX92@X92@X94PX32@T:00<J2@X92@X92@X00PT92P894PX72@T:00<9
4PXJ2@X000000`T92P0300002@T:2@T:00H92@X0114L2P00014L2P000089
2@X00`TB2P0000T92P022A8:0`T92P0300002A8:2@T:00892@X00`0000T9
2PT92P022@T:00<A70X000092@X00`T92P032A8:4A`:000000892@X01`00
00T92PT92PT92PTB2P0000TB2P052@T:00@94PX92@X0000000022@T:00X9
4PX92A@J4Q@92@XS;bTS@CdJ4Q@92A@92@X92A@22@T:00H94PX0001bSH@9
2AB3Q8h/EFl32A`N0PT92P062A8:00002@T:2@T:2A8:00000PT92P042@TD
00002A8:2A8:1PT92P032A8:2@T:2A8:00892A@00a4L2PTL7PTL7P022@TD
01<94PX92@X92@X94PX92A@94PXA;c<971@000092@X94PX92A@J4QA6EBTm
GSd000094PXJ4Q@J2@X00Q4L2P0B2A8:4A`:2@T:4A`:AT4NAT`mJVLcSHe_
CfM7H5hcYZ6HAVML0000Pg]LUJ6>LXdm00002A8:0`T92P050000YYQ_AUDY
=2lN4BHD00<92@X00aXB50T92Q4L2P052@T:00<J2@X92@X92@X00PT92P03
4A`:6PT:2@T:00D92@X00a4L2QX92PT92P052@T:0Q4L2P0<2@T:4A`:6PT:
2@T:4A`:6PT:2@T:4A`:6Q8D2A8:0000YZ6HHLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT01iVIV@0Doooo
o?cloooooOgmmoOgfMWII6ATGUiNKfm_O7alR8R8Shn?U9BDVi^KXJ6QXj>S
YZJVZZZZ[Zj^/K6a0k2`/003/K6a[jn_[jn_03J_[jl8/;2`0jn_[`0C/;2`
[jn_[jn_[Zj^[Jf]YJFUY:BTWinOVIVIUIFET92@QXJ6O7alKFe]GemOH61P
g=cLm?Cdo?cl00?oool4VIVI1@0001^IVIT6000000>IVIT00000000049VI
V@D00002VIVI0P0000^IVIT200004YVIV@H0000_VIVI00?oooo<c<c<c<`0
GLc<c08J4Q@32A8:00<A70X94PX92@X00PT92P034A`:2@T:2@T:00L92@X0
0`0000T92PTB2P052@T:00@000094PX92@X94PX92@T:00P94PX92@X92@X9
2@X000094PX92@X94PX22@T:00<000094PX94PX00PT92P0300002@T:2@T:
00<92@X01P0000TB2PTB2PTB2QX92P0000892@X01PTB2PT92PT92P0000T9
2P0000894PX42@T:00<94PX92@X94PX010T92P082A8:00002@T:2@T:0000
2@T:2A8:00000PT92P0500002A8:2@T:2@T:000000892@X00aXB50T951XB
50022A`N00@92A@J4Q@94PX92@X22A8:00P0001bLW/m;cfEV:<92A@A9PX9
2A@J4Q@22@T:00d94PX92@X000092@X000092@X000092@X000092@X00009
2A@94PX010T92P0;2A8:2@T:2@T:2A8:2@TD2A8:2@TD4Blc2@TD4BHN2A8:
00<92@X08`T9514V7PTB2PTV:@TB2PT92PTB2Q4L2QX92TI17Ra<:@0000T9
2S@_7QXV514L2PT92PT951XB50T953@_7TIE:G9WDW:=?G9WDW:=G7^=IZJQ
V5N=G00009F=DVYW<iF4DXf=Ka4V50022@T:00H94PX92@X92@XS9PZiV5a?
IdL32A8:0PT92P034BHD2@T:6Q8D00892@X00aX92PT92PT92P0=2@T:00@A
70X92@X92@XA70X32@T:00DJ2@XS70XA70X92@XJ4Q@00PT92P076PT:4A`:
2@T:8a`:6PT:2@T:YZ6H067<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT04ooooo_knooooogmoOkn
o]cLg6e]KEEEEF=SHg1`L7inOXJ6QXf=SIJFUYfMWJ2PX9jNWZBTY:ZZZP02
[Jf]00>/[:b][Jf][Jd0>:f][@R/[:`2[Zj^01F][Jf/[:bYZJVWYjNUYJFS
Xj>NWYjMWIfHV9RBTY:=SHf7QhMmOGecLg=UIFEFEUIXJ6SRh^;moOgno_kk
no/00_oooiZIVIT00oooolc<c<c<c01Mc<c<0PTB2P0<2@T:2A8:2@T:2A8:
2@T:2A8:2@T:4A`:2@T:2A8:2@T:4A`:0`T92P032A8:2@T:4A`:00<92@X0
1`TB2PT92PT92Q4L2P0000T92PTB2P032@T:00<A70X92@X94PX01PT92P0:
00002A8:2@T:2@T:2A8:00002A8:00004A`:2@T:0`TB2P@92@X00`0000T9
2PT92P032@T:00@000094PX92@X92@X22A8:0PT92P0400002A8:2@T:2A8:
0P00000=2A8:2@T:2@T:2A8:2@T:00002A8:4A`:00002A8:00002A8:2@T:
008000001Q4L2P0000TB2PT92P0000T92P8000000`T92PTB2PT92P052A8:
00<971h971@92@X00PTB2P892@X010TB2RaEG8>HSRaWG08971h00`TB2PTL
7PTB2P022@T:00<000094PX000000PTB2P0300002A8:2@T:00892@X20000
00@94PX92@X94PX94PX22@TD00T94PX92@X971@92A@A9Q@A;cdA9Q@971@9
2A@00PTB2P892@X00`TL50TL7PTL50032@T:01hA70X/>2TA9Q@000092A@J
2@XS;ahS9PX/9Q@94PXJ9Q@J71iZEAikSFJ=SE9ZNfmGIe9?IdNVXIREXHj=
SFl0002ESE9?IdMZEAj=SDN=SFl/C2T000094PX22@T:00L00016EBU6EBVE
SE8d;bT92@X92A@010T92P034A`:2@T:2@T:00892@X0114L2PT92PT92Q4L
2PH92@X00a4L2PT92PT92P024A`:1@T92P074A`:2@T:2@T:6Q8D;3PY6PT:
4A`:00@92@X011XB50T950000:JZ[F7<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT04ogmoOoooooo
ooCdm?ooooCdm92@T4i>CV9RHUIFEVYZJX^;Ri6ATJ2PX:RXZ:n_[jj^[[>c
/kFe]@02];Bd00>f][Jg]kNf][H04;Jf]QRg]kLI][Jf0[Vi^@0F][Jf]KFe
][Jf][Jf];BdZ:RX^[ZjVIVIW9bLVi^KMWIfKVi^GemOC4a<CTi>R8R8oooo
o?clkno_oooomOGeooooVYVIV@03ooooc<c<c<c<05g<c<`01aXB50T92Q4L
2P00014L2PT92PTB2P022@T:00<94PX000092@X00`T92P054A`:2@T:4A`:
2@T:4A`:00892@X01A4L2PT92PT92Q4L2P0000022@T:00<A70X92@X92@X0
0`T92P052A8:2@T:2@T:2A8:000000<92@X00`0000T92PT92P042@T:00H9
4PX000092@X000092@XA70X22@T:00<94PX92@X92@X01PT92P894PX01P00
00T92P0000T92PTB2P0000D92@X00`TB2P0000T92P022@T:00<94PX00009
4PX00`T92P092A8:2@T:2@T:00002@T:00002A8:00002A8:00<92@X01@00
00T92PTB2P0000T92P032@TD00<94PX92A@94PX00PT92P062A8:2@TD0000
8d4m2D574Blc0PT950046Q`N00002A8:00000`T92P8000001@T92P000000
00TB2P0000022@T:00D94PXJ4Q@94PX92@XJ4Q@00`TB2P892A@03@TL7R=1
?@TL50T950TB2PT92Q4L2PTB2Q4_<`TL50TL7PTB2P0000022@T:00d94PX9
2@X92@X94PX92@XA70XS9PXJ9Q@S9PXJ9QA6@Aj=SDN=V8h00VYkK`0>H5hc
SHe_YZ6HPg]L4BH:0000JVLcEheL8a`:JUDNYZ5VYZ6HLXeL00000PT92P0;
00002@T:0000H44YNheVLXdmAUDY2@T:2A8:2@T:4A`:00892@X01Q4L2PT9
2PT92Q4L2PT92QX92P@92@X010TB2R`B00T92Q4L2PH92@X04a4L2PT92PT9
2R`B0000014L2PT92PTB2PT92Q4L2PT950T92Q4L2PT92Q4L2QX92PT92P00
0:JQV01Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@07VIVI01SooooinOWoooooooogmoOno_k2`/8l?3a2
@T99BDUZJVYfMWJLW9be]KFl_;bd];Bo_ko4a<C6a/K5aLG4a<C6a/K7alO5
aLD@bLW96<O7aaS9bLT01lG5aLS8b<S8b<G5aLC4a<K6a/G5a@02`l?300^e
]KFh^;Rk^k^7QhMZJVYbLW98B4QFEUI0@432`/;emOD00_ooo`03m_Kfoooo
oooo09ZIVIT00oooolc<c<c<c01Mc<c<00<94PX92@X94PX00`T92P044A`:
2@T:2@T:2A8:0`T92P034A`:2A8:2A8:00892@X0114L2P0000TB2Q4L2P<9
2@X22A8:10T92P064A`:2@T:2@T:2@T:2A8:2@T:10TB2P892@X00`TB2PT9
2PT92P022@T:00<94PX000094PX00PT92P034A`:2@T:2@T:00892@X010TB
2P0000TB2PTB2P<92@X020TB2PT92PTB2PT92QX92PT92Q4L2PT950D92@X0
0`TB2PT92PT92P022@T:00@94PX92@XJ2@X000032@T:00<94PX92@X00000
0PT92P052A8:00002@T:2@T:000000@92@X00`TB2PT92PT92P022A8:00<9
2A@94PX94PX00PTL500<2A8:2@T:2A8:2@T:2@TD4BHD2A8:2BHY2@T:2A`D
4Blc00000`T92P894PX32@T:00DA70X94PX92@X92@X000000PT92P046RHD
6Q8D6Q`N6Q8D0PTL500@2A8:2@TD6Q8D4BHN4Blc2A8:6Q8D2A8:2@T:2A8:
2@TD2BHY2A`D6RHD00004A`:1PT92P0>4A`:4BH:6RHD8bH:;3PYAT4NPhAk
Phf4JW]_LXeLSHe_LXdm=5DY4BH:0P0000062A8:SHe_00008bH:AT4NPehD
0ZJHK`0<00002@T:2@T:2@T:2A8:4A`:0000Pehc/:Z4Pg/c00004A`:1@T9
2P064A`:2@T:4A`:4A`:00008a`:0PT92P0N4A`:2@T:2@T:2@T:4A`:2@T:
6PT:2@T:6PT:;1806PT:2@T:4A`:6PT:2@T:8a`:2@T:6PT:2@T:00006Q8D
4A`:6Q8D2@T:6PT:4A`:6PT:4A`:0000YZZSHLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT01iVIV@0Eoooo
n_[jo_knoooolO7aoooooOgmPh>3A4A4@d=3CTi>MWIfYjNW_Kfm^;RhalO7
`/;2alO7b/[:bLW9b<S800;9bLT00lO7al[:b/[:bP0nb/[:01G9bLW;bl_;
bl_9bLW8b<S9bLW8b<S5aLG7alNo_kne]KFi^KVXZ:Q^KVi3@d=1@D4e=CF:
RX[clo?hn?Sno_h00_ooo`03o?clooooVIVI09VIVIT00oooolc<c<c<c01M
c<c<00@J4Q@92A@92@X92@X24A`:00<92@XA70X92@X02PT92P034A`:2@T:
2@T:00<92@X00`TB2PT92PT92P052@T:00XA70X92@X0000A70X92@X00009
4PX000094PX92@X200000PTB2P0300002@T:2@T:00892@X00`TB2P0000TB
2P052@T:00D0000A70X000092@X000000PT92P0;00002@T:2@T:2@T:0000
2@T:00002A8:2@T:00002@T:008000001PTB2PT92PT92PT92P00014L2P@9
2@X02AX92Q4L2PT92PT92PTB2PT92P0000TB2P0000022@T:00<000094PX9
2@X01@T92P052@TD2A8:2@TD2@TD2A`N00892@X22A8:0PT950064BHN2A`N
2A`D2A`N2BHY00000PT92P0300002@T:000000<92@X2000000/94PX92@X9
4PX92@X94PX92A@J2@X/71@99RT971h971@00PT9500:4BHN4Blc2A`D2@TD
2A8:2@T:6Q8D2@TD6Q8D4BHN0PTL7P032@T:00002A8:00892@X031XB50TB
2Q4L2QXB514V51XV53@_7TmWAk2ZQ7:=?DIE:B<V2P@000003@T95000061N
<mc7X`00014L2R`L56YE7Xf=Ahf=DYFHIP0000TB2P042@T:00L00016EBV3
Nc>=SFm6EBT92@X94PX00`T92P062A8:2@T:2@T:00006PT:4A`:1@T92P03
4A`:2@T:6PT:00`92@X0100000T92Q4L2P0000892@X01b<L2PTB2QX92PT9
2QX92P000:JZX`1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI0_ooo`03n?Sho?cloooo00;oool0
3_7alEQHF2/[:cXj>UmOGg]kNl71`Kjn_/71`L;2`/O7al[:b/W9bLS8b0;9
bLT00lO7alS8b<S8b00>b<S86<W9bAS8b<P00lW9bLc<c<_;b`02bLW901;:
b/[8b<S3`l?3`l?5aLG<c<b][JemOGePH612@T8[:b]KFe_ooooinOWgmoOo
oookno_inOT2ooooVYVIV@03ooooc<c<c<c<05g<c<`010T9514L2PTB2Q4L
2P892@X01@TB2PT92Q4L2PT92PTB2P022@T:00@A70X94PXA70XA70X82@T:
00<94PX92@X92@X01@T92P044A`:2@T:2@T:00000PTB2P072@T:00002A8:
00002A8:2@T:6PT:008000001@TB2PT92PTB2PTB2Q4L2P062@T:00@00009
2@X0000A70X42@T:00<94PX000092@X00PT92P0<00002@T:2@T:00004A`:
2@T:00004A`:00002A8:2@T:00001PT92P082A8:2@T:2@T:00002@T:0000
2@T:000010T92P0300002A8:2@T:00<94PX32@TD0PTB2P032@TD2A8:2@T:
00894PX00`T950TV:A4_?@022@TD00<971@92A@000000PT92P042@TD2@T:
2@T:2@T:0PTB2P@92@X0200000TB2PT92R<_<b<_7QXB54IEDPTL7P892A@0
3@TL50TV:@TV:A4V500000T92P0000TL50T92Q4_?A4L2Q4V7PT950022@T:
01l94PX92@X94PXJ9Q@92@XS9PXJ9QAP@BUbIe:=SDMZLUc1/hhA9PX/C2TA
9PX92A@94PXA70X94PX00023GS?1al4971h0000A70XJ4QAP@ABVV6n`ZXBi
ZVl000000PTB2P<92@X01PTB2PT92TmWAh=k<hf=DP0000894PX00`T92QX9
2PT92P022@T:00<A70X92@X92@X01@T92P046PT:2@T:2@T:2@T:0Q4L2P08
2@T:6PT:4A`:2@T:6PT:2@T:4A`:6PT:0Q4L2P042@TD2@T:4A`:4A`:0PT9
2P066PT:2@T:6PT:4A`:0000YZZ]HLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P4c<c<0VIVIP03c<c<VIVIVIVI00FIVIT01o_knooo
ooooooclo?ooooclo>_[j`02oooo00Tf=SI0@41?Cdn1PH6MWIf/[:ba/K6h
^;Rn_[h00l;2`P;3`l<00l71`L?3`l?3``0>`l?36<;2`QS3`l<00l71`L?3
`l;2`P02`L7100g2`/:o_kni^KVm_Kfh^;R^[ZjBTY9ZJVXj>SXZ:RY>CTkj
n_[^k^h00_ooo`05jNWYooooooooo?cloooo09ZIVIT00oooolc<c<c<c01M
c<c<00TJ4Q@94PX92@X92@XA70X92@XA9Q@92@X94PX03PT92P032A8:2@T:
2@T:01892@X021X92PTB2P0000T92PTB2P0002<V2QX92P892@X22A8:0PT9
2P072A8:2@T:2@T:2@T:00002@T:2A8:00892@X00a4L2PT92PT92P032@T:
00<000092@X92@X00PT92P0300002A8:2@T:00T92@X22A8:10T92P030000
4A`:2@T:00892@X0100000T92PTB2PTB2P892@X00`TB2PT950TL50032@TD
00d94PX92@X92@X94PX92@X92A@A9Qh99RT92A@92@XA;c<92A@94PX00P00
00<92@X01P0000T92PT92P0000T92P0000@92@X01b`h:AXB50T92X>4Na4_
<`TL7QXB50024BHN00<A;c<971h92A@00PTB2P032A`N2A`D2BHY00899RT0
4@T950T92PT92PTB2PT950TB2Q4L2R<_7TI17UMEDYF4DXfHSW^=Q:JHQ8f=
A`0001X92P026Q8D00D92A@0000d;ajESFKLhn000P0000892@X01aXV54H_
2VYW<iF=DYik<a4V2P0000052@T:00L00016@AikSFJESE9PGS<000094PX0
0PT92P8A70X00`T92Q4L2PT92P022@T:00<A70X92@XA70X00PT92P056PT:
2@T:2@T:6PT:2@T:008J2@X22@T:00TA70X92@XA70XJ2@X92@XJ2@XA70XS
70XJ2@X00`T92P<A70X00aX92P000:JZX`1Qc<c<00AVIVJ8`;R8`;Q8T8P1
0000000018S0^<SPf8S0^8S0^0C<c<`016IVI/c<c6IVI/c<c0JIVIT00ooo
oo[jn_ooo`02o?cl013oooodm?Coooo[jn_ooom6ATHb<S97AdM/K6bGUiNW
YjNTY:B[Zj^`/;2b/[:c/k<2][Jf00>d];Be]KFe]KD0?[Fe]@0D/[:b/k>c
/[:b/K6a/[:b/k>c[Zj^YjNWVIVI/;2`RXZ:H61PAdM792@TIVIVo_knoooo
nOWiooool_;b0_ooo`03mOGeoooooooo09ZIVIT00oooolc<c<c<c01Mc<c<
00<J4Q@A70X92@X00`T92P032A8:00002@T:00<92@X00`TB2Q4L2PT92P04
2@T:00<94PXA70X92@X00PT92P0300004A`:2@T:00<92@X00`0000T92PT9
2P042@T:00D000092@X92@X000094PX020T92P0300004A`:2@T:00892@X0
1PTB2PT92PTB2P0000T92PTB2P@92@X00`T9514V51XB50022@T:00T00009
2@X92@X94PX000092@X000094PX000000`T92P032A8:2@T:2@T:00<92@X0
0`TB2PT92PT92P022A8:00@92@X94PX000092@X3000000@94PX92@X94PX9
2@X42A8:00D92A@971hJ4Q@92A@000000`TB2P0500002@T:2@TD2@TD4Blc
00894PX00`TV:@T92P0000022@T:00@0000A70XA70X94PX42@T:00<A70X0
000000000`T92P084BHN;1`D;5hm2A8:4BHD2A`N2A`D2BHY0Q4V7P0R2A8:
6Q8D2@TD4BHN2BHY2A8:4Blc;5hm2@T:2A8:2@T:2@TD4A`:2A8:ARHDAT4N
SHeBNheVUIRSNheVCfM7SHe700006PT:4A`:2@TD2A`D0000Pg]L`K>]g>?F
;5hm00004A`:0PT92P068a`:ARHDWW/cUIQVYZ5V=5DY10T92P092A8:2@T:
2A8:0000JUDNUHeBPg]L=5DY000000P92@X00aX92P0000T92P022@T:00P0
000A70X92@X92@XJ2@X92@XA70XJ2@X52@T:00HJ2@XA70X92@X92@X00009
2@X34A`:0aX92P032@T:0000YZ6H067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c005IVIVc<c<VIVIIVIVc<c<00FIVIT01Ooo
ookno_oooo_knoShn004oooo00kjn_[ooomgMgM2@T8_;bm9BDUGEeMeMGEl
O7b3Ph>6QXJ9RHV<S8b=SHdARh^;68f=SAV;Rh/048b<S8^;RhZ:RXb<S8f=
SHN7QgmoOgIfMUADE34a<Bl_;chn?Xb<S?3`l?_knnk^kP;oool01_WinOoo
oo[jn_ooooOgmooooiZIVIT00oooolc<c<c<c01Mc<c<0PT92P044A`:2@T:
4A`:2@T:0PTB2PT92@X00`TB2Q4L2PT92P072@T:00<A70X0000A70X01@T9
2P0:2A8:2@T:2@T:2@T:00002A8:2@T:00002@T:4A`:2PT92P0700002A8:
00004A`:2@T:00002A8:00892@X00`TB2Q4V50T92P052@T:00<94PX00009
4PX01@T92P894PX00`T92PTB2PT92P032@T:00H000092@X92@X92@X00009
4PX22@T:0PTB2P892@X00`0000TB2PT92P032@TD0PTB2P8971@22A8:00<9
2@X94PX94PX00PT92P0:2A8:4BHN4Blc2BHY2@T:2A`N2@TD2A8:2@T:2A8:
0`T92P0:8a`:00002A8:00002A8:2@T:00002A8:2@T:2A8:0PT92P894PX0
1@00014V7Q4V2PTL7QXL7P024BHN00X971@92A@92A@A9Q@A9Qh971@A9QhS
;c=?GVH000022A8:01LJ4Q@A9QAP@BUbIe9kSFJVXIRVZZ=kSFH/C2TA9PX0
000J4Q@A70XA9Q@000169QBEV6K1al7:d=IZNflA9PXA70X92@X00PTB2P08
4A`:;1`DPg/c^JY_/:Z4JVLc00002A8:0PT92P0800002@T:2@T:2A8:6Q8D
SHe7Pg]LPg/c0PTB2P062@T:4A`:2@T:4A`:2@T:6PT:0PT92P<A70X03PT9
2Q4L2QX92QX92PT92P0001X92PT92QX92PTB2PT92Q4L2PT92Q4L2P892@X0
11X92PT92Q4L2QX92P<92@X01QX92PT92QX92Q4L2P000:JZ[F7<c<`016IV
IXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c006IVIVc<c<VIVI
VIVIIVIVc<c<19VIV@03n?Shoooon_[j00;oool01O[jn_oooogmoOoooogm
o@03oooo00_OgmmPH60o?cl[:b/b<S8j>SXn?Si2@T96ATI8B4Q6ATH044Y:
BQQ9BDTHBTY:0T];B`0<BTY:BDU9Bd];C4a<ATI6?Shn<C4a>3PhK6a/gmoO
ooool_;b1?ooo`03no_koooomoOg00CooonJVIVI00?oooo<c<c<c<`0GLc<
c08A70X020T92Q4L2P0001X92PTB2PT92PTB2PT92P894PX02@T92PTB2PTB
2PTB2PT92Q4L2PT92P0000T92P022A8:0PT92P044A`:2@T:4A`:2@T:0Q4L
2P892@X02a4L2PT92Q4L2PTB2PT92Q4L2PT92PTB2P0000T92Q4L2P072@T:
0PTB2P<92@X020TB2PT92PT92PT92P0000T92PTB2PT92P894PX22@T:00<9
4PX92@X92@X00PT92P032A8:2@T:000000894PX01@0000TB2PTB2PTB2P00
00022@T:00D94PX92@X92@X92@X94PX00PT92P0400002A8:00002A8:0P00
000=2A8:2@T:000000002A8:6Q8D2A`D4BHD2@TD2A8:6Q8D2A`N2@TD00<9
4PX01`0000T92Q4L2PT950TB2Q4_DPTV:@022A8:00D971h92@X92@X00009
4PX00`0000032A8:2@T:2@T:00894PX32@T:0P0000894PX010T92QXB50TL
50T9508A9Qh22BHY010971h971@A9Q@A9Q@99RT971hJ71h/EE`/Ie`00009
4PX0000d;ai6@Aj=SDMkSFH2YZ6H011GSE`000092@X92@X94PXA9PX971@9
2@YZIc?1/jg1al7Lhn0mGSd0001ZEAh/9Q@32A8:00LA70Y6;`YZEAjVQ5:V
XFJNSC<000000PTB2P032@T:4A`:2A8:00892@X0200004IE:JJHKk2ZQ4HV
500000T92Q4L2P892@X020TB2PT92PT92PT92Q4L2PT92QX92PTB2P8J2@X4
4A`:0PT92P036PT:;1802@T:008A70X01AX92Q4L2Q4L2Q4L2PT92P044A`:
00H92@XJ2@XA70XS70X00031/jeQc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@02VIVI00=VIVK<c<c<c<`0
olc<c0k<c<`00oooolc<c<c<c01Mc<c<00D92A@92@X92@XA70X94PX00Q4L
2P042A8:2@T:4A`:000010T92P034A`:2@T:2@T:00892@X02PTB2PT92PTB
2Q4L2PT92PTB2PT92Q4V2PT92PTB2P892@X24A`:0PT92P032A8:2@T:4A`:
00892@X01@TB2Q4L2PT92Q4L2PT92P022A8:00H92@X94PX94PX94PX00009
4PX52@T:0`TB2P0300002@T:2@T:00<92@X01@0000T92PT92PTB2P000002
2@T:00H94PX92@X92@X94PX0000J2@X42@T:00D94PX92@X94PX000092@X0
0PTB2P0500002@T:2A8:00002@TD00892@X020TB2PT92PT92PT92Q4V50T9
2PTL50T9508971h01PTL50T950T950TB2PT950T92P894PX04PT950TL7Q4_
<a4V7PT950TB2PTV:@TB2P0000T92P0000T92Q4L2P0000TB2PT92PTB2P00
00<92@X22A8:00<92@X000092@X00PTB2P892A@0114V514_<a4V7Q4V7P89
71@08@TB2PTL7R=1?@TL7R=1?B=1DQ4_<`0000T953@_7VYW<g9WDYFHXjJZ
Xhf=Ka4V2P00014L2QXV52`V54I17PT9500008=N<l6c[L77c>g]jTINA`TB
2S@_7QXB57:=?A4V2P022A8:00P/4P0/71B3GQBVXFJiV5bVXFH0000A70X7
2@T:00T/9QBESFJVV6mbSCd92@X94PX92@XA70X92@X00Q4L2P032@T:6PT:
2@T:00D92@X011X92PT92QX92PT92P8J2@X02B<L2PT92Q4L2PT92QX92PT9
2QX92PT92PTB2P022@T:00TJ2@X92@X92@XA70XJ2@XA70XJ2@X00031/jd0
HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT00iVIVOmVIVH@IVIV00?oooo<c<c<c<`0GLc<c0046Q8D4A`:
2A8:2A8:1@T92P032A8:2@T:2@T:00894PX32@T:00<0000A70X92@X010T9
2P894PX22@T:00<A70XJ2@X000001@T92P036PT:2@T:2@T:00@92@X020TB
2PT92PTB2P0000T92PTB2P0000TB2P892@X00a4L2PTB2PT92P042@T:00<0
00092@X000000PTB2P<92@X00a4L2PT92Q4L2P032@T:00HA70X92@X92@X9
4PX92@X94PX32@T:00@A70X92@X92@X94PX22@T:00D94PX000092@X92@X0
00000PT92P0300002A8:000000<92@X0114V53AE?@T950TV:@8971@00a4V
50T950TB2P022A8:01892A@94PX94PX92A@94PXS;c<99RT94PX92@XA;cd9
71@000092@X94PX92@X94PX92@X000022@T:00<000092@X92@X00PT92P06
00002@T:2@T:2@T:2A8:4A`:0PT950032A`D2A`N4BHN008A9Qh0:`TB2PTL
50TL52<_<a4_<`T957:=Q2a<:A4V50T92R`L54IE:IFHIYFQS[2ZQ5N=G000
00T92Q4V2V11:H=k<cAE:@TB2P000<6cS[2c]l77`McSh6YkK`0002<V2R<L
2R<V2QXB58=k<`T950TB2Q4L2QX92VYE7[V=<l6cSZJQIP022@T:00DA70X9
2@X92@X92@XA70X00PT92P060000SHeBNheV`K>>4BHD4A`:1@T92P044A`:
2@T:4A`:2@T:0Q4L2P032@T:4A`:4A`:00892@X01aX92PT92QX92QXB514L
2QX92Q4L2P036PT:00dA70X92@XA70XA70XJ2@X92@XA70XJ2@XA70XJ2@XA
70X92@ZVZZd0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;P4c<c<00=VIVK<c<bIVIT0oiVIVA>IVIT00oooolc<c<c<c01Mc<c<00@J
4Q@94PX92@X94PX32@T:00<A70X92@X92@X00`T92P054A`:2@T:4A`:2@T:
4A`:00<92@X01a4L2PT92PT92PT92QX92PT92PTB2P032@T:00<A70X92@X9
2@X02@T92P044A`:2@T:2@T:4A`:10T92P034A`:2@T:2@T:00@92@X02@00
00T92PT92PT92Q4L2P0000T92PTB2Q4L2P032@T:00@0000A70X92@X92@X2
000000<92@X000092@X03@T92P0300002@T:2@T:00892@X02`0000T92PT9
2QXB500001XV54I<?@TV:@T92PT950TB2P032@TD0`TB2P0C2@T:6Q8D2@T:
2BHY4DaB2BHY2A8:2@TD2BHY2@TD2A8:2@T:00002@T:00002A8:2@T:0000
4A`:00/92@X05AXB50TB2PTL7Q4V7PTL7PTV:AXL7PTB2Sd_?A4_?B=1DR=1
?DmbNh>4SPTV:B<_:@TB2QXV56YW<l[@`G:=G002000001dS9PZ3Nc>ESE:E
V6H971h94PX0002NQ6J`/kO1/jg]kNX971h000092A@A70XS70X/71@dEBU6
;`XJ9Q@94PXJ2@XA9PYkC0ZESE:=SDO:ZVH000094PX01`T92P060000AT4N
SHeB/;>gARl:2A8:10T92P046PT:4A`:2@T:4A`:0PT92P036PT:2@T:2@T:
008J2@X020T92Q4L2PT92QX92R`B01X92Q4L2QX92P892@X00a4L2PT92QX9
2P026PT:00@92@XJ2@XJ2@XJ2@X24A`:00<J2@X0002VZZd0HLc<c004IVIV
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT0
1iVIV@;lool2oooo0_ono`1Hooooo_ooo?oonooonoolnO[en??`m^c[l^;R
j][Jgm?Cg]CCgm?Cg]CCgm?Cg]CCgm?Cg]CCgm?Cg]CCgm?Cg]CCgm?Cg]CC
gm?Cg]CCgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?C
g]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CB
gm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?Cg]CBgm?C
g]CBgm?Cg]CBgm?Cg]CCgm?Cg]CCgm?Cg]CCgm?Cg]CCgm?Cg]CCgm?Cg]CC
gm?Cg]CCgm?Cg]CC0]oCd`09glo?j][Jk^3PlnOWoOCeoOWhoO_looooo_oo
00?lool4o_oo00?ooonIVIVIVIT0V9VIV@03ooooc<c<c<c<05g<c<`01`T9
50T92Q4L2PT92Q4L2PT92Q4L2P022@T:00<A70X92@X92@X02`T92P056PT:
2@T:2@T:2@T:4A`:00<92@X00a4L2PT92PT92P052@T:00XS;bT000092@XA
70X92@XA70X92@X000092@X000042@T:00<000092@X92@X00`T92P042A8:
00002@T:00002PT92P0300004A`:2@T:00h92@X00`0000T92PT92P020000
0PT92P0300002A8:0000008000000`TB2R`h:@TV:@032@TD00/A9Q@J4Q@9
71@94PX92@X92A@92@X92A@971@A9QhA;c<00PT950052A8:4Blc2A8:2@T:
000000892@X0200000T92PT92PT92P0000TB2P0000TB2PP92@X06PT950TB
2QXB50T950TV:AXL7PTV:@T92YFQ]dmNIPU1AdmbNl77`CAWNb<_:@TL7P00
09EbAk2c]a4V500004HV58=k<k2ZQ9FHIW:=?@<000005l6QQ;2c]mcSe^gf
mBa<:@00014L2PT92QX92R<L2R<_7THV561N<h=k<`00014L2R<L2W]<2/ZQ
D]c7XjJQIP00014V50092@T:00=PGS>=SDN3Nc<00PTB2P052@T:00006PT:
2@T:6PT:00@92@X00aX92PT92R`B00032@T:00<J2@X92@XJ2@X00aX92P05
2A8:6PT:4A`:2@T:2A8:00892@X011X92PT92QX92PT92P@J2@X00`000<6c
[Lc<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@07VIVI1Oooo`1To_ooo?ooo?ooo?oon?ckl_;`in?P
h]SGh];BglW;f<;4bKNgakNgbKNgakNgbKNgakNgbKNgakNgbkVibKVibkVi
bKVibkVibKVibkVibKVibkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZg
bkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVi
bKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZgbkVibKZg
bkVibKZgbkVibKZgbkVibKZgbkVibKVibkVibKVibkVibKVibkVibKVibkVi
bKVibKNgakNgbKNgakNgbKNgakNgbKNgb[JgckJif/74g<S9g/k>im_KkNCU
lno`o_kno_oo0_coo`03noooo?ooo?oo00;nool00ooooiVIVIVIV@2HVIVI
00?oooo<c<c<c<`0GLc<c08A70X01@T92Q4L2P0000T92PTB2P052@T:00`0
00092@X92@X92@X0000A70X92@X000092@XJ2@X0000A70X62@T:00<00009
2@X000000PT92P046PT:2@T:2@T:2@T:0Q4L2P892@X00b`B01X92PT92P02
2@T:00`A70X000092@X92@X000094PX92@X000092@X000092@X000022@T:
00<000092@X92@X00PT92P0500002@T:2@T:2@T:000000<92@X01@0000T9
2PT92PT92P0000042@T:00<000092@X92@X00PT92P0500002@T:2A8:0000
2@T:008000003`T9500000T92PT92P0000T92PTB2P00014_?@TL50TB2PT9
50TV:@T92PT950042@T:00P92A@J4Q@971hA;c<92@X92A@971@A9Qh42@T:
00<000092@X000000PT92P0600002@T:000000002A8:00000PT92P0L0000
2@T:2@T:2A8:6Q8D2@TD2@T:4BHN2@TD2D574BlmPbmLUIRS8d5B2D57=6Mk
`LO<4Blm8blN0000H44DYZZS/:Z42@T:UHeB/:Z4UIQV4BH:0`000008ARHD
`J64/;>g`LO1b]3FEheL00002A8:0`T92P0<4A`:8a`:=2lN?A`:H5hc=2lN
00004A`:JUDN/8eB/:Z4kM2H0P0000H92@X03@TB2PT92PTB2R`B08=kG9F=
DV1N<`0001X92PT92P0000T92QX92P022@T:00</4P092@X92@X00PT92P0?
4A`:2@T:6PT:6PT:2@T:6PT:2@T:6PT:2@T:6PT:2@T:;1802@T:4A`:6PT:
00@92@X01a4L2QX92PT92QX92PT92P000;2c]`1Qc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI00Go
oOooo_ooo_ooooonool00ocoo`09mOOfl>o]h]gJdLK4b;JfaJna`jJZ_9nS
[iFH00N^UIP8[IBG<:fEU@R]U9L7[YFH00^_UIRgUic2XZO4Yj_5[:o=^k_C
alOQf=Wbk^ooooonool01?coo`;nool00ooooiVIVIVIV@2HVIVI00?oooo<
c<c<c<`0GLc<c0052A8:6Q8D2A8:2@T:4A`:00892@X0114L2PT92PT92Q4L
2Pd92@X00`TB2PT92PT92P0@2@T:00DA70X94PX92@X94PX000002@T92P03
2A8:2@T:2@T:00P92@X00a4L2PT92PT92P072@T:00<000094PX92@X010T9
2P0500002@T:2@T:2@T:2A8:00@92@X010TB2PT92P0000TB2PD92@X020T9
50TB2PT951XB50T9514V7PTL7PTB2P892A@020TB2PT92PTL52<_:A4_?@TV
:@T92QXB508A;c<01PTB2P0000T92PTB2PT92PTB2P<92@X01`TB2PT92Q4L
2PT92PTB2PT92P0000042@T:02<94PX92A@J4Q@92A@A;cdS;c=PLW^EV:>3
Q8h/Ie`/EE`S@Cd/EE`/Ie`S;bTA;c=69QBVZZ>EXHhA9P[]d9QbSE`A9PX0
00092@XJ4Q@92@YP;aC:d<71/jg:d<7foolA9PX000092A@00PT92P042A8:
2@T:2@T:;1800R<_7P0:UG97SHe72A8:6Q8DNd`:/8dc/:Z4dkj>=5DY2A8:
0PT92P032A8:2@T:2@T:00@92@X01@0009EbAhf=Aij=<`0000022@T:00@J
2@X92@X92@XJ2@X22@T:00XA70XJ2@XA70XJ2@X/4P092@XJ2@XA70X94PXS
70X26PT:00/A70X92@XJ2@XJ2@X94PXJ2@XA70X92@XJ2@XA70XJ2@X00PT9
2P8J2@X00a4L2P000:JZ[@1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI00Gonoooo?ooo_oooool
o_d00_coo`0Ao?cjiN7NeL_9c;jm_JVX]9ZK/92CX7f1XGf1WGYnVGUlUgMj
Tg=fTG5dTW9eUGEhV7Qk03REMGP:Tg=f016BLWF@L7>?Kg:ALGBEMGRKN7bO
N7fNMgbSOh>_Si:gWIjmZJ[;_KcJd<oXh^;eloCoool01Okoo`03ooooVIVI
VIVI09RIVIT00oooolc<c<c<c01Mc<c<00@J4Q@94PX0000A70X22@T:00<A
70X92A@A70X01PT92P074A`:2@T:2A8:2A8:4A`:2A8:4A`:00892@X00a4L
2PT92PT92P022@T:00<94PX92@X92@X010T92P096PT:2A8:4A`:2@T:2A8:
2@TD2@T:4A`:;18000H92@X00`TB2PT92P0000022@T:00<94PX000092@X0
1`T92P894PX00`T92PTB2PT92P032@T:00<94PX92@X92@X00PT92P030000
2@T:2@T:00<92@X00a4L2PT92PT92P022@T:00P000094PX000094PX92@X0
000A70X000042@T:00T94PX92A@92@XA9Qh92A@J4Q@92A@971@971h00PT9
500:6Q8D2@TD4BHN2BHY4Blc2BHY2A8:2@T:2BHY4BHN0PT92P052A8:0000
2@T:00002A8:00892@X01`0000TB2PT92P0000T92P0000TB2P042@T:02D9
4PX92A@92A@A9Qh99RW:d=JEV:>V/l5GSHhS@E8AC58/EE`/EFlS@E8A;c<d
;aj`ZXCLaj<0002VQ59bSCd000092@XJ2@XA70X0001P;aCLhn2`/kO1al7L
hn2EZZd000092A@A70X92@XA70X00`T92P0>4A`:8a`:;2HD;2HD^IQLAUDY
4BHDJT4:/8dcb[j]`K>>=5DY00002A8:0PT92P032A8:2@T:2@T:00<92@X0
1`000611:JJHKjJQIP00014L2PTB2P022@T:00/J2@X92@X92@XJ2@X92@XJ
2@X92@XJ2@X92@XJ2@X92@X01AX92P042@T:;1804A`:2@T:0aX92P0;4A`:
6PT:6PT:2@T:6PT:4A`:8a`:;1806PT:0000`K>]067<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT0
KOolooomooonoooooo[lnoWkn??clNOSh>3Edm;0_/Z`/K>CU:1lP9I]LHYO
IY1UK8MNI8MPIHUPIXMPIHMNI8IOI8UPIXURIhQOIHMPIHQOIHMPIHQOIHMP
IHQOIHMPIHQOIHMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQO
IhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMP
IHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQOIhMPIHQO
IhMPIHQOIhMPIHQOIhMPIHMNI8IOI8MNI8IOI8MNI8IOI8MNI8IOI8MNI8MP
IHUPIXMPIHMNI8IOI8UPIX]RJ9AUKH]LHXYMI9M^LZN4R;>FV;nZZLbj^]c@
d>gTiOchmoonoogmo@03o?go00?ooonIVIVIVIT0V9VIV@03ooooc<c<c<c<
05g<c<`02PT92P00014L2PTB2PT92PTB2PT92Q4L2PT92PTB2PL92@X010TB
2PT92P0000TB2PT92@X01@00014L2PT92PT92PTB2P052@T:00DA70XJ4Q@A
70XA70X000000PT92P0400002A8:2A8:2A8:0P0000052@T:000000002A8:
2@T:00<94PX01@T92P0000TB2PT92PTB2P032@T:00H000094PX94PX94PX9
2@X94PX2000000@92@XA70X92@X94PX42@T:01L000092@X92@X92@X94PX9
2@X000094PX000094PX92@X94PX000092@X000092@X000092@X92A@971h9
@DL0000A9Q@00PTL7P092A8:2A`N4BHN4BHD2@TD4BHD2A8:4Blc4BHN0089
2A@01`U1A`TL7Q4V7PT92P0000T92PTB2P022@T:0PTB2P032@T:00004A`:
00H92@X32A8:00D92A@A9Q@92@XS@E;CfMH00/77c00L2D578d5B8d4m8d5B
8d4m8d5B4BlmUHAB`K>]4BH:^JY_YZ5V00004A`:2A8:2A`D0000/8Akb]31
`K>]b]3FdmWFg>?P00002@T:2A8:2@T:2A8:0`T92P0?4A`:2@T:6PT:8a`:
=5DYARH:YZ5V8bH:JT4:YXAB`K>>g<NS=5DY00002A8:00892@X22A8:0PT9
2P894PX01@T92R`V5:JQI[VHG00000032@T:00@A70XJ2@X92@XA70X22@T:
00@J2@X92@XJ2@X92@X24A`:0PT92P036PT:4A`:2@T:008J2@X02`T92QX9
2Q4L2QX92PT92Q4L2PT92Q4L2PT92QX92Q4L2P036PT:00<0002VZZ?<c<`0
H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT01iVIV@1^oocooo_oo_coooooooomoOchl>_Wg=7=b;>`]iVI
[hR;XgIiYgIl^8F:`i2GeZ>Zk;g5k/3:llC>mLOAm/OAm<K@m<G?m<K@llC>
l/C>llC>l/C>llC>l/C>llC>l/C>llC>l/C>ll??l/C>ll??l/C>ll??l/C>
ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??
l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>
ll??l/C>ll??l/C>ll??l/C>ll??l/C>ll??l/C>m<G?llG?m<G?llG?m<G?
llG?m<G?llG?l/?=llG?m/OAmLOAm<G?l/C>l/?=llC<iK2hej:Xa96H/H24
X7=hWGIi[hf>`jNVd;^jhM7Am^c[oo_kookoo_oo0_coo`03o_ooVIVIVIVI
09RIVIT00oooolc<c<c<c01Mc<c<00@A70X94PX92@X92@X22A8:00HA70X9
2@X92@X0000A70XS9PX32@T:0PTB2P0300002@T:;18000T92@X00a4L2PT9
2PT92P072@T:00<94PXA70XJ4Q@00Q4L2P052@T:4A`:00002@T:2A8:0080
00022A8:00<000094PX94PX00PT92P094A`:00002@T:2A8:00002@T:2A8:
00002A8:00892@X32A8:00<000092@X92@X00`T92P0600002@T:2@T:2A8:
2@T:2A8:10T92P032A8:00002A8:0080000010TB2P0000TB2P0000@92@X2
2A8:01092A@A9QhA;c<92@X99RTA9QhA9PX971@92A@99RT971hA9Q@92A@9
71hS@E894PX22@TD00@/EFl971@A9Q@92@X22A8:00<000092@X94PX00P00
00032@T:2A8:000000@92@X00`TB2P0000T92P022A8:00L971@99RTA;c<m
;cg1albVan09@DL00b=1DP0C4BmB;5hm4BlcH5hcg<NS;4`YWXdc?Ehm0000
;4`Y2@TD2A8:0000`J64b]31`LO1b]3Fg>?Fdn?e009PGS<01@0000TB2PTB
2PT92PTB2P052@T:00`A70XJ4QB3Nc=6;`XA9QikC1BNSBV`ZXC:_Ze?IdL0
00094PX32@T:00<000094PXA70X00PT92P0600008bH:UIQV`K>>00004A`:
0PT92P0I4A`:2A8:2@T:6PT:2@T:4A`:2@T:4A`:6PT:2@T:;1802@T:6PT:
2@T:4A`:;1802@T:4A`:6PT:;1804A`:6PT:2@T:;1802@T:008J2@X020TB
2QX92QX92R<L2QX92PT92P000:JZXf7<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT04oolookioOom
o_oooOoonocgln[OfmBo_<JWYK:8RJekO[=jP<nDV^jc^ORm`oo:d?K3c?W7
d_k<e`02oloJ00?oc]WocMSocMP01oo>f@?oc]X0;Oo=g?o>f_o=g?o>f_o=
g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>
f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=
g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g?o>f_o=g002olkJ1oo>f@0Fo/cG
olgHolgHolgHo/cGo<[EnlWDo<WBnl;9olC:o/?9kKBjcIVM/X64Z7amZH:3
`J6Re;blk]cLoO?booglo_oo0__oo`03o_ooVIVIVIVI09RIVIT00oooolc<
c<c<c01Mc<c<00X92A@A70X92@XA70X92@XJ2@X92@XA70X92@X94PX52@T:
00<J2@X92@X94PX010T92P072A8:2@T:4A`:2@T:4A`:2@T:6PT:00L92@X0
1A4L2PT92PTB2PT92PTB2P024A`:00<94PX92@X92@X01@T92P8000000`T9
2P0000T92P072@T:00D94PX92@X94PX92@XA70X010T92P052A8:2@T:2@T:
2@T:4A`:00D92@X00a4L2PT92PT92P024A`:00d94PXA70X000092@X94PX0
00094PX000094PX000094PX0000A70X00P0000072@T:2@TD4Blc2BHY2@T:
4BHD2A`D00892A@03Q4_DPTL7Q4L2PT950TL7Q4V515<DPT95000079EDQ4_
DPT92PTL7PTB2P892@X00`TB2PT92PTB2P042@T:0PTB2P042@T:4A`:2A8:
2@T:0`TB2P052@T:6Q8D8blY4Blc8d5B00<99RT013ebQ2=1?BaEG4mbN`8A
;cd04ng@V3AE:A4L2R<_7P0008=k<`TB2PTL7V0_2/6c[L77`M?Ie/[@`McS
e[2n`G9WDW:=?FYW<`T92P022A8:00@92@XA70X92@XA70X22A8:00lA70X9
2@XS9PXS70Z3GQ@A9QAP;`ZNSBVVV6oC_Xi?IdL000094PXA70X92A@00PT9
2P036PT:2@TD;1`D00969Q@01Iik<iF=I[2ZQ000014L2P022@T:00<J2@X9
2@X92@X00PT92P046PT:2@T:6PT:4A`:0QX92P032@T:6PT:2@T:008J2@X0
0`TB2QX92Q4L2P036PT:00<92@XJ2@X92@X00Q4L2P086PT:2@T:6PT:6PT:
4A`:8a`:0000/;>gHLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8
`;R8`;P4c<c<00=VIVK<c<bIVIT01iVIV@;ooOl04OoooooooO[gl^kUh=[7
`L:UXKR<RkEnPLF7S=ZGW_J`^?o3b_bk`ORla?o:e?o<fOo?g002om3M00?o
cmcod=godMh02?oCh0;od^80;_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oB
i?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oB
h_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oBi?oBh_oB
i?oBh_oBi?oBh_oBi?oBh_oBi?oBhPSod]l00ooCh?oAg_o@g@02olkK0_o=
fP0BolgGol;:o[g3o;_1n[c1l[BifYnS_8F8YgEf]8Z;aJ>Rg/K6l^CSo?Kf
noglnOoon_ooo_ooVYVIV@03ooooc<c<c<c<05g<c<`00aXB514L2PT92P05
2@T:00@A70XJ2@X92@X000022@T:00@A70X000092@XA70X52@T:00D94PX9
2@X92@X92@X94PX00PT92P036PT:2@T:2@T:00<92@X00aX92PT92Q4L2P02
2@T:00DJ4Q@/9Q@94PX92@X000000`T92P0500002@T:2@T:2@T:2A8:0089
2@X01@0000T92PT92PT92P0000022@T:00<000092@X92@X010T92P032A8:
4A`:2@T:00<92@X00`0000TB2PTB2P092@T:00<000092@X92@X00PT92P03
00002A8:2@T:00892@X00`0000TB2PT92P022@T:00<94PX99RT99RT00Q4V
7P0D00004BHN2A8:2BHY2A`N2A`D2@TD0000;5EL4Blc4BH:?BlmLW9k4Blm
2A`N2@TD00002A8:2@T:000020T92P0400002A8:00002@T:0`TB2P044BHD
2@T:6Q`N4Blm0Q4V7P0L6Q`N;5EL;5EL;5ELCg9k?G:48d5BPg]LLXdm0000
2A8:0000PehcYZ5V0000H2l:b]31b]3FdmWF`LO1g>?F/;k14A`:AT4NJUDN
LXdm=2lc00000PTB2PH92@X04P0002<V2R`V54IE:B`V57]<2[2=D/6cS]c7
XdIE:A4L2QX92PT954HV2R<L2XeE2V0_58=N50:NLQ@01Hf=Al6cS[2ZQ<6c
SP0000022@T:00<J2@XA70XJ2@X00Q4L2P<92@X26PT:00TA70XJ2@XA70XJ
2@XA70XJ2@X92@XJ2@X92@X00QX92P052@T:6PT:4A`:6PT:2@T:00@J2@X0
1QXB514L2PT92QX92P0009FZ[F7<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT04_onoogmoOoooOoo
noKakNGJe=:k]KfGU:QeM;QhNMV@UnnRZ_jc^_nnaOnk`oo4c?o9e_o<f@;o
cMX2olcI00?ocM[ocmcodMh01_oAgP0bom3Pom3Rom3Rom3Tom3Rom3Tom3R
om3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3T
om3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3R
om3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3Rom3Tom3RolkN1oo?g003
om?Pom7NolkK00;ocMX2olkK01;oc=Woe=cobLko_L;i];Wb[K;VXJCDTiO4
RH^cPH:mTiCB];CZf=KilNolo?[hookiooonoonJVIVI00?oooo<c<c<c<`0
GLc<c0092@TD2@T:2A8:2@T:4A`:2@T:2A8:4A`:000000@92@X01@TB2PT9
2Q4L2QX92PTB2P042@T:00PA70X94PX92@XA70X92@XJ2@X92@XJ2@X72@T:
00@A70X94PX92@XA70X26RHD00@000094PX000092A@22@T:00<0000A70X9
2@X00`0000034A`:00002@T:00H92@X00`TB2PT92PT92P022@T:00<0000A
70X000002@T92P042A8:2@T:2@T:4A`:0`T92P072A8:2@T:2@T:00002A8:
6PT:2A8:00T92@X04a4_?BaN?A4_<`00061bNh>H[IFQ]`TL50TL7PTL514V
50T92RaWG0TB2PTL58<_G3AWN`TV:A4V7P022A8:0PT92P052@TD2A8:2A8:
2@T:2A8:00H92@X22A8:00<92@X92A@94PX00PT9500K2BHY8blY8blc8blY
4BlmCeiV;5E_Ehf>=6Mk2D57UG97LXdm00004A`:0000=2lN^JY_;4`YLSPD
b]3Fb]31b]3F/;>gkNgZUJZ]0000;1`D0096@Ah01VYW<fYE7R<_7PTB2QX9
2Q4L2PH92@X06AX92S@_7TH_2QXL7W]<2ZJ4D[VZKlZn[JJQIXeE2YF=0;1k
2Yj=<iik<k2=7Xf=Ah=k<jJ4DZJQI[2ZQ:JZXk2ZQ:JQIPTB2QX92P024A`:
00<J2@X92@X92@X00QX92P044A`:2@T:8a`:4A`:1AX92P074A`:;1806Q8D
6PT:2@T:6PT:8a`:00<92@X0114L2QX92Q4L2PT92P8J2@X01B`B01XB51X9
2P0009FQSP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0
^0C<c<`00fIVI/c<c9VIV@07VIVI01Coooolo?cooognoOSak>KSe<g=/Z^h
S8VlPX7:Q8KXUikbWjOhYjkn/KOn]Kcob=3ob=Gnbm[ocMcoc]d2olgL00?o
c]gocmkocmh01oo?gP;ocn80;_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>
i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?
h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>i?o?h_o>
i?o?h_o>i?o?h_o>i?o?h_o>i?o?hPSoc]d01?o@goo>gOo=g?o>g@;ocmh0
4?o=g?o9e_Nf__nj`?nnaOnl`?^`]NZOXmN@U<R8RKInOkV;RlZXYnC?c_O]
k?gmn`;iool00okooiVIVIVIV@03VIVI1@0000>IVIT2000000BIVIT00000
002IVIT200000YVIV@800002VIVI100000>IVIT400000iVIV@800006VIVI
100000>IVIT200001IVIV@800003VIVI0P0000:IVIT500000YVIV@@00003
VIVI1@0000:IVIT2000000>IVIT0000000000YVIV@@00005VIVI0P0000:I
VIT400000YVIV@800002VIVI1@000003VIVI0000000000:IVIT200000YVI
V@8000000iVIV@000000000<VIVI00?oooo<c<c<c<`0GLc<c00;6Q8D4A`:
2@TD4A`:2A8:2@T:6Q8D2@T:4A`:2A8:4A`:00892@X02A4L2PT950T92Q4L
2PT92Q4L2PT92Q4L2QX92P032@T:00PA70X92@X92@X92@XA70X92@XA70XJ
2@X22@T:00T/4P092@X94PX92@X94PX971@/>2TA70X000000PT92P040000
2A8:00002A8:0P0000892@X010TB2PT92PTB2P0000<94PX42@T:00<94PX9
2@X94PX00PT92P894PX00a4L2PTB2PT92P032@T:00<000092@X94PX00PT9
2P062A8:2@T:2@T:2A8:2@T:00000PT92P032A8:00002@T:00@92@X00`TB
2PT92PT92P022@T:01HA9Q@A;c<A;cdJ71ibLW]PLW/m;cfEV:<971hA9PX9
71@92A@J4Q@A;e892AAGGVoChoD/EFl971@A;c<A9Qh000042@T:00<92A@9
2@X94PX00PT92P074A`:2@T:2A8:2A8:2@TD6Q8D2A8:00<92A@0114V50TV
:A4_<a4_DP8S@Cd0=dmbNa5<DUN=SR=1DQXV52a<:@00014L2PT92R`L5<6c
SPTB2THV5=cSh>g]jZJZXjJQV>g]jRa<:@0000T951XB52<L2TIE:FYE7YFH
ITI17PTB2PT92Q4L2PT92PTB2Q4L2PT92Q4L2PT92PTB2R<V2R<_7Q4V2W]<
59j=<k2ZQ<Zn[FYE7/6cS/ZQD/ZZIZJQI[2ZQ=c7Xl6cSZJZXlZn[JJQV002
/:Z40ZJQV0042A8:4A`:6PT:2@T:0Q4L2P052@T:6PT:2@T:2@T:8a`:00@J
2@X01@T92Q4L2QXB52`B01X92P022@T:00//4P0J2@X92@XA70X92@XJ2@XA
70XJ2@XS70XJ2@X92@X00aX92P032@T:6PT:UJZ]067<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00NIVIT0
4oonooono?Wnn?Cil^SUg][9`/FMVjidLlMmO/ekON>>TNjLW_RY[?ne^Ofb
]onla?^mb?_1coo5d`02olOE0oo7e0Gna]<2olGC00?oaMCnaMKnaMP0;Ok5
f00Ro/GFo/GDo/KCo/GDo/KCo/GDo/KCo/GDo/KCo<?Bnl?@oL?BolKDolSG
olKDo<;Ankg:ol;9ok^no;BgnZncnJZ]l:2Sg8b?ag]m^gUk]hB3`ifLf/G0
lNSSn_Wdn_oinoolo_oo19VIV@800003VIVI0P000004VIVI00000000VIVI
0`000003VIVI0000000000:IVIT2000000>IVIT0000000000YVIV@800000
0iVIV@0000000002VIVI0P000003VIVI0000000000JIVIT200000YVIV@80
0002VIVI0P0000FIVIT200000iVIV@8000000iVIV@0000000002VIVI0P00
0003VIVI0000000000:IVIT2000000>IVIT0000000000YVIV@80000019VI
V@00000009VIV@<000000iVIV@0000000002VIVI0P0000BIVIT2000000>I
VIT0000000000YVIV@80000019VIV@00000009VIV@800002VIVI0P000003
VIVI0000000000:IVIT2000000BIVIT00000002IVIT3000039VIV@03oooo
c<c<c<c<05g<c<`00a4L2PT92Q4L2P022@T:00<A70X92@X92@X00`T92P04
2A8:2@T:2@T:2@T:0PTB2PP92@X01QX92PT92Q4L2P00014L2QX92P892@X0
30TB2PT92PT92PT92PTB2P0000T92R`L52a<:@T92PTB2PT92P894PX00`00
00TB2PT92P022@T:00<000094PX000000PT92P032A8:0000000000894PX2
2@T:00H94PX000092@X92@X94PX000032@T:00<A70X94PX94PX01PT92P03
4A`:2@T:2@T:00892@X00a4L2PT92PT92P022@T:00H94PX92@X94PX92@X9
4PX000022@T:01T94PX000092@X92@XA;cdA;c<A;cf3V:f3Q8ibEE:3SH@9
2A@94PX92A@92@X99RTA;e9ZNfn3;ebEXKM?LW//GSdA9QhS;bT000000PT9
2P<94PX22@TD00@94PX92A@92@XA70X22@TD01d94PXJ4Q@92A@A70X971hA
9Qh971hJ71h99RTS;c</EE`/Ie`S@E9GSHhS;bT971@J2@X92@X92A@0002E
LTNVXFH0002VXIS:d<7Lhn2VXISCfMKChoD00P0000<92@X02b<L2S@_7VYW
<h=k<jJQIQ4V2PTB2Q4L2PTB2PT92P0000042@T:00HJ2@XS70Xd;aiZEAjV
XFK1/hh2/:Z400O1/hk:_Zg:_ZfVXISC_Xk1/jfiZVl00k2ZQ00;YYQ_`K>]
YYQ_/:Z400002A8:6PT:4A`:6PT:4A`:6PT:008A70X56PT:00H/4P0J2@XJ
2@XJ2@X92@X/4P024A`:00D92@XA70XJ2@XJ2@XA70X00PT92P056Q8D2@T:
4A`:6PT:4A`:00<J2@X00`0009FHXlc<c01Pc<c<00AVIVJ8`;R8`;Q8T8P1
0000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI017onogo
noSgoo[booGXjN7>^KC5RXbbH6C>JfkIMgKOS8KUW9?WYig][:Kk/K3o];Wo
]l400_nf``05okW6okg9ol3;okk9okc700Go_LP3okc82?nmbbSo_<X08Onm
b_nmb?nmb_nmb?nlb_nmb?nlb_nmb?njb?nka_nkbOnkaonjb?niaOngaOjf
`Ong^_jg]ORa[o>YY_6PWnjEUnJ7RmQnP<5bMJAXIkjITM:n]NONeOWfkOon
n?onnoooo@09VIVI0P000003VIVI0000000000:IVIT2000000>IVIT00000
00000YVIV@800004VIVI0`000003VIVI0000000000FIVIT200001IVIV@80
0004VIVI0P000003VIVI0000000000FIVIT200000YVIV@800002VIVI0P00
00:IVIT2000019VIV@<000000iVIV@0000000002VIVI0P000003VIVI0000
000000:IVIT2000000>IVIT0000000000YVIV@800004VIVI0P0000BIVIT3
000000BIVIT00000002IVIT200000YVIV@8000000iVIV@0000000002VIVI
0P000003VIVI0000000000:IVIT2000039VIV@03ooooc<c<c<c<05g<c<`0
11X92Q4L2PT92Q4L2P892@X01A4L2PT92Q4L2PT92PTB2P022@T:0Q4L2P04
2@T:;18000004A`:10T92P064A`:2@T:2@T:2@T:00004A`:0PT92P034A`:
2@T:4A`:00892@X01Q4L2PT92PT92PTB2SeN?CAE:@8000001`TB2P000000
00TB2P0001XB500000022@T:00<94PX92@X92@X01@T92P0300002A8:2@T:
00<92@X01@TB2PT92PT92PTB2Q4L2P022@T:00@94PX92@X92@X92@X22A8:
00<A70X94PX92@X00`T92P042A8:2@T:2@T:2A8:0`T92P0400002@T:2@T:
00001PT92P064A`:4Blc4BHN2BHY;5ELUIRS0Sd_?@0ICfML00002@TD2A8:
8d4m4Blm8blc/;>g?G:4PiR]=5Dm2A`N4Blc4BHD4A`:6Q8D4A`:2@TD4BHD
2A`D2@TD4BHN4BHD2A`N4Blc00<J71h01TIEDR`h:EMEDR=1DR=1?A4_<`8S
@Cd2;5EL01HAC59?LW//GSd000092A@A70X92A@S9PYZIc<dEBTJ2@[:_Zg:
d=KTd<bVXISLhn1kSHAZ@@XdEBT000094PXA70X22@T:00H/9QA6;`Z3Nc=6
C3f=SE8000032A8:00D92@X94PX92@XA70X92@X00Q4L2P0K=2lNWW8:^IQL
`K>]b]31`K>]`K>>g<NSb]31Pg/c`K>>/;>gdkj>YZZS/:Z4UJZ]Pg]Lb]3F
Nhf4YYQ_00006PT:4A`:;2HD2A8:6PT:4A`:008J2@X01PT92Q4L2R<L2QX9
2R`B01XB508A70X00`T92R`B02<L2P046PT:00<A70XJ2@XJ2@X00Q4L2P04
2@T:6PT:;1806PT:0Q4L2P8S70X00`000:JZ[Lc<c01Pc<c<00AVIVJ8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI
01Son_gonoSfoo[aooOUi]kE^KJlMGVnGFCFJ6_NMG;MRgoNVh[MY9?UYice
YjGnZJko[[Ko[[On[[On/KWo]Kgo^;oo]kko][d2o[Nm1?nf_@03okFmokJm
okJo02oo][l4okW11?nh`@;o]l42okS201Go]l7o]/3o];ko/k_k[k7i[jcb
ZjO]Y9k/ViS[TI3VPXCJMg[:LG>XHV2ZOGOC^k7[hMGoooCoo_SomoCoood0
1iVIV@@000000iVIV@0000000002VIVI0P000003VIVI0000000000:IVIT2
00000YVIV@@00002VIVI1P000003VIVI0000000000FIVIT2000019VIV@80
00000iVIV@0000000005VIVI0P0000:IVIT200000iVIV@8000000iVIV@00
00000002VIVI100000>IVIT2000000BIVIT00000002IVIT200000YVIV@80
00000iVIV@0000000002VIVI0P0000BIVIT200000YVIV@@00002VIVI0P00
00:IVIT2000000BIVIT00000002IVIT200000YVIV@8000000iVIV@000000
0002VIVI0P0000bIVIT00oooolc<c<c<c01Mc<c<00PJ4Q@971@92A@92@X9
4PXA70X92@XA70X22@T:00<J2@X92@XA70X010T92P054A`:2@T:2@T:2@T:
4A`:00D92@X01B`B00TB2PT92PT92QX92P032@T:00T/4P094PX92@X92@XJ
2@Y?Ie`J9Q@92@X94PX01@T92P0300002A8:2@T:00@92@X00`TB2PT92PTB
2P042@T:00/94PX92@X92@X94PX000092@X94PX92@X94PX92@XA70X01@T9
2P0300002A8:2@T:00@92@X00`TB2PT92PT92P032@T:00<000092@X92@X0
10T92P0J2A8:2@T:00002@T:2@TD4Blc2BHY4Blc2A8:CeiVARHDPhB>2BHY
2A`D6Q8D2BHY4Blm2@TDJW]_Y/OP4BmBdn?e2A8:4DaB4Blc2A8:0PT95009
2@T:2@TD2@TD2A8:2@TD6Q8D2A`D4BHN6Q`N00899RT03a4_<baEG2=1DW9b
NbaEG2aN?B=1DUMNKdIWG4mbNb=1DUN=SRaWG00000T92P034BHD00`S;bT0
002VV8C:d<71alc:d<71al7CfMHA9PX/4P1ZEAj3Nc<32A8:00/A70X92@X9
2@Y6@Aj3Nc=bSCfELTL/C2T92@X92A@94PX00`T92P894PX06`T9514L2R`L
58=N5;VHG;2ZQ=bn[L6cS[2ZQ<6cS]cSh8=N<nC@c9F=I/[@`G9bNl6cSX>4
NiEbAmc7XjJHQ:JHK`00014L2PT92QX92PT92P036PT:00<A70X92@XJ2@X0
11X92P032@T:6PT:6Q8D00@J2@X020T92QX92QX92Q4L2QX92PT92R`B01X9
2P8A70X00aX92Q4L2QX92P028a`:00<0003]kN[<c<`0H<c<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT01iVI
V@0Hoo_no_gkmoolmOohi]oIgKZhYEUM`UeSe6=UfG1/f8Ihf9F4fI^<h9fD
l9^Nn9jWmjJ/ljN[lZN[lJV/m:b_mJnamK6bm;2a0_>a/P03mK6bm;2amJna
00?e[k4=m:nb0oF`/a3d[k83mK2c3OB_/PKc/K<2mK2c0_B_/P;e[[805OB]
/O>//?>[[oBY[OBTYo>SY>^QW^>LU^>FT>:=R>5mOMUbLl]YJZmNGIUOFmbj
/NcNeOoom_oon_Sim?ooo@05VIVI1@0000:IVIT200000YVIV@8000000iVI
V@0000000002VIVI0P000004VIVI00000000000019VIV@800002VIVI0P00
0003VIVI0000000000FIVIT2000019VIV@8000000iVIV@0000000005VIVI
1P0000BIVIT4000000BIVIT0000000000006VIVI10000003VIVI00000000
00:IVIT2000000>IVIT0000000000YVIV@800004VIVI0P000004VIVI0000
0000000019VIV@800003VIVI10000003VIVI0000000000:IVIT2000000>I
VIT0000000000YVIV@80000<VIVI00?oooo<c<c<c<`0GLc<c0064A`:2@TD
4A`:4A`:2@T:6Q8D1@T92P038a`:2@T:2@T:00@92@X01Q4L2PT92P00014L
2P00014L2P892@X01Q4L2P0000T92PT92Q4L2PT92P8A70X22@T:00d94PX0
00092@XA70Y?IdL94PXA70X0000A70X94PX92@X94PX92@X00`TB2P892@X0
10TB2PT92P0000T92P894PX01PT92PTB2PTB2PT92PTB2P0000892@X01@TB
2P0000T92PTB2P0000062@T:00<94PX000092@X00PT92P054A`:00000000
2@T:6Q8D00<92@X01PTB2PT92Q4L2P0000T92PTB2P8000002`T92PTB2P00
00T92PTV:A4_<`TL50TB2TIWG0TV:@TL7P022BHY00<971hA9Qh99RT00PTV
:@092D57CeiVY[?12@TD8d4m4BHD2@T:2A`D6Q8D00894PX02PT950TB2Q4L
2PT951XB514V7PTV:A4V7PTV:AXL7P8S@Cd05Q5<DR=1?A4_DTmbNcebQ4mb
NcAWNg:=[EN=G00000T92PTL500000T950T92V11:L6c[K2n`L[@`L77`L6c
[McSh080000011XB52`B07:=?F1N<`894PX030T92Q4L2PTB2R`B04I17Yik
<h=k<iF=DS@_:@T950T92Q4L2P<92@X06PTB2QXB52<V2R`V58=k<kVZKmbc
Xl[@`H=kG<Zn[H=N<mcSh9EbAl[@`IF4Nl6c[FYW<l6cSYFHIYF4Nl77`JJH
Q8f=A`0001X92PT92P8A70X020T92QX92PT9514L2PT92R<L2QX92R`B00<J
2@X02Q4L2QX92Q4L2QX92R`B014L2PT92Q4L2QX92Q4L2P8J2@X01@T92QX9
2QX92QX92Q4L2P036PT:00<S70X0003Lhn00HLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT01iVIV@0Foo_o
o_knmoolnOoijMcFikjlTD54`UUMceeMeFYTeGm`eHileiF7gIJ@kiJLm9VR
kinRk:2PjZ2OjJ:PjZBRk:JT0^fYYP;[ZZH2kJVV00C^Z:K]YjG]YjG]YjD;
k:RW6^fYZ0_/Z:L6jZVW0^bXY`;YYJ@01^ZTY>VSXnVSXnRRX^RPXN^OX@;_
VYl03nBJVMfFT=bBRMf8PMmiMMU]JlMJGKUIFY9<B^Zm^>_Gd?Sek_cono[o
o?koo`04VIVI100000BIVIT200000YVIV@8000001IVIV@000000000009VI
V@02000000>IVIT0000000000YVIV@8000000iVIV@0000000002VIVI0P00
0003VIVI0000000000FIVIT2000019VIV@8000000iVIV@0000000005VIVI
1@0000>IVIT0100009VIVIVIVIVIV@8000000iVIV@0000000002VIVI0P00
0003VIVI0000VIVI00:IVIT2000000BIVIT00000002IVIT300000YVIV@03
0000VIVIVIVI00800004VIVI0P000003VIVI0000000000:IVIT2000000FI
VIT00000002IVIT000000iVIV@8000001IVIV@000000000009VIV@020000
00BIVIT00000002IVIT3000039VIV@03ooooc<c<c<c<05g<c<`02a4V50TB
2PT92Q4L2PTB2PT9514L2PT92Q4L2PT92Q4L2P032@T:00hA70X92@XA70X9
2@X94PX92@XA70X92@XA70X92@X94PX92@X94PXA70X22@T:00<94PXJ2@X9
2@X01PT92P07AUi7AUDYARHD4BH:8a`:6PT:;180008A70X011X92Q4L2R`B
00T92P<94PX0214L2PTB2PTB2Q4L2P0000T92P0001XB50<94PX01PT92PTB
2PT92PTB2P0000TB2PD92@X00`TB2P0000T92P082@T:0QXB50042A8:6Q`N
000000000PTB2P0600002@T:2A8:2@T:2A8:00000PT92P042BHY4BHN2A8:
2A`D0PT950082A`N2A`D2A`N2A8:2BHY4Blc2A8:2@TD0R=1DP0300002BHY
2A`N00@94PX00`T92PTB2PTB2P022A8:01<92A@971@971A6C3dm;ce?GVH/
EE`S@E8S;ahA;c<S@E9GGVm?LW]GSHh/EFl/GSd971@000094PX00PT92P0P
0000H44Yb[j]/;k1`LO1YZZS/;>gg>?Fb]3FYZZS00006Q`N;1`D4A`:JUDN
PehcPg/c00006Q8D2@T:2A8:2@T:AUDY=2lNUHeBLXdmUHeB00002A8:0000
2@T:4A`:0`T92P0H6RHD;2HDWW8DYZ5Vdkj>b]31LUEBdmWFPg]Li=3<YYR4
b]31YYR4`LO1PhAkb]31SHe_`K>]/;>g`K>>LXdm00002@T:4A`:0QX92P09
4A`:6PT:6PT:;1806Q8D2@T:4A`:6PT:8a`:00DJ2@X00b`B01X92R`B0002
4A`:00@J2@XA70X92@XS70X24A`:00TJ2@XA70XJ2@XJ2@X92@Y6;`XS70X0
003:d=H0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4
c<c<00=VIVK<c<bIVIT01iVIV@0Ioo_oo_komoomoOojkmgIl<?0QcDg^e5C
cEMEdfAKe7QYeHIgeXb1g8j:jXnHl9>MjiJIj9RGj9ZHiibIiifJj9jKj:6M
j:>NjJBO00?XXih2j:6M00?ZX9gYWicXXIl01nRQW`04ij2Nj:6Oj:6Oj:6O
0nVRX003jZ>QjJ:PjJ:P00kYXZ001>ZSXNVRX>VRX>VRX0?XXIl00nNPW^RQ
WnRQW`06j:6O00?WXIoVXYoWXIl01NNQW`;XXIl00nNPW^JOWNRNW@02iifL
01;ZW9c/TY_ZTi_PU9CGT8[FS8?JPg[LLfoIIV?:DeFmD5>>?Ccd_k_`em?g
m>ohooggooolool4VIVI0P0000JIVIT200000YVIV@80000019VIV@000000
09VIV@800003VIVI100000>IVIT4000000>IVIT0000000000P0000BIVIT2
000019VIV@H00004VIVI0P000003VIVI0000000000BIVIT400000iVIV@@0
0003VIVI100000>IVIT2000000>IVIT0000000000YVIV@@00005VIVI0P00
00:IVIT400000YVIV@800002VIVI100000:IVIT2000000>IVIT000000000
0iVIV@8000000iVIV@000000000<VIVI00?oooo<c<c<c<`0GLc<c08J4Q@0
0`TB2QXB50T92P026Q8D00HA70X92@X92@X92@X94PXA70X62@T:00LA70X0
00092@XA70X000092@XS70X00PT92P044A`:2@T:2@T:2@T:0QX92P034A`:
2@T:2@T:00892@X02TIE:C@_:DIE:DHV514L2R<_7QXV514L2R<L2Q4V2P<A
70X030T92PTB2QXB514L2PT92QXV51XB50T92P0000T92P0000T950<92@X0
0`TB2PT92PT92P022@T:00<000094PX92@X02PT92P0500002@T:2@TD2@T:
000000892@X010T950T92P0000TB2P892@X06P0000T92PT950TB2QX92P00
014_?@TV:@T951XB50TB2PTL7Q4V7PT950TL7Q4V7Q4_<`TV:@TB2SebQ14_
DQ5<DQ4V7PTV:@T92Q4V7P8J4Q@0:PT9514L2QXB50TL50TB2PT9514L2PTB
2PT92PTL7Q4V7R<_<b=1?A4_?A4_D[2n`JJZ[Ng]jUN=SQ4V2Q4V5000014L
2PT92QXB50T92V11:H>4Nk2c]h>HS[2ZQ;2c]m?Ie]cSeXfHS/6c[M?IeP00
00T92QX92PT92R`B00:3Nc<00`TL50TB2Q4L2P022@T:00</9QAZIc=ZEAh0
0Xf=DP05AT4N2@T:2A8:4A`:2@T:008A70X03PT952<_7TH_2Yik<k2ZQ<Zn
[IFQS/6QQ<6c[K2ZQ<[@`K2c]l[@`JJZX`;:d<405jJHQ<[@`H=kG<6c[K2Z
Q14V50T951XB50T92QX92Q4L2QX92R`B014L2PT92QX92R`B00T952`B01X9
2R<L2QX92R<L2P036PT:00</71@92@XJ2@X00QX92P08;1804A`:6PT:6PT:
4A`:6Q8D4A`:6PT:0R<L2P046Q8D;1800000g>?PHLc<c004IVIVR<2hR<2h
B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT01iVIV@0C
oo_oookonOomoookm^GNm/_5RCTh[TA4ae1<d5]BdVeQe7Y_dh1heh>3h8F>
iHRCiXfAiI6?iYFB00;VUi<01>FGTnBIU>BKUNJMU`;UW9H2iIZE0^JHU003
iINCiiVGiIZG00KUVYL00n>HUNBIU^BIUP02iIZG0^JKV003iibIiIZGiIZG
00kUVYL00nNLVNJKV>JKV002iIZG0^BIUP03hiREiIZGiIZG00KUVYL6iYbI
0nNLV@03iY^HiiVGiYRF00;UUiD04nJFUNNEUnF;U>><U=R<S=68P]63NMAj
LMQYH]EKF<eADK=3@XXd<oS1__kUhOolnOSooo3oo?coo`04VIVI0P0000>I
VIT200007IVIV@800006VIVI0P0000:IVIT200000YVIV@800005VIVI0P00
00:IVIT200006iVIV@80000;VIVI0P0000RIVIT200004iVIV@80000<VIVI
00?oooo<c<c<c<`0GLc<c0076RHD4BHD2A8:6Q8D4A`:2@T:4A`:00892@X0
0a4L2PTB2PT92P0;2@T:00</4P092@X92@X00`T92P034A`:00004A`:00D9
2@X060TB2P0005MWDTmWAcAE:CeN?C@_:CeN?B`V51XB53eN?AXV50TB2R<_
7PTB2Q4L2PT92R<_:A4V2QXB514V51XV500000TB2P892@X00`TB2PT92PTB
2P042@T:00<A70X92@X94PX020T92P894PX32@T:00<J4Q@92A@92@X00P00
00034BHN2A8:000000892@X0800000T92PT92PTB2PT92P0000TB2PT9514_
<`TL7PT92PTB2PT9514V514V7PT92QXB52=1DRaEG0TV:A4L2RaEKa4_DQ4_
?@TL7Q4_<a4L2Q4V7PTB2PT950T92R<_:@892A@08QXB50TL53@_<g9EDQXB
514L2PT950T92Q4V7R<_:B=1?H>HSTmNIRa<:@0000T950T92Q4L2PT95000
00T92TI17ZJZXiFQSYF=IXf=Kl77`NC@c<[@`H>4Nh=kG=cSh<6c[B<V2P89
4PX040T92Q4L2ULL08=k<ij=:@00014L2P0000T92R<L2R`V56YW<fYE7Xf=
Ahf=DP0000894PX42@T:00M69QAZ@@Z3Nc>iZVo1/hk1/jg:d<400/77`@0B
b]31/:Z4i=3<SHe_b]31YZ6HYYQ_`LO1SHe_YZZSAUDY00002@T:4A`:6Q8D
2@T:6PT:4A`:0QX92P044A`:6PT:2@T:8a`:0QX92P03;1802@T:6PT:008J
2@X00b<L2R`B00T92P046PT:00<A70XJ2@XA70X00QX92P08;1804A`:6PT:
6Q8D6PT:8a`:6PT:`LO<HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT01iVIV@0Eoo[oooconocnoookn_3W
mm;:T4I3WSPd^T<oada5cUiCdFYQcG9]cGMheG^5fX2:gX>8hHR:iXf?iY2A
i92@00;QT8l01>6AT>>CT^>CT^:BT@;RTI000n>?Sn:>S^2?SP08hY2B0^2>
T004hHnAhY2BhY2Bhi6C0^BBU13RT982i9:D00CSTI?RT9;RT9;QSi42h8j@
1n>AT`03hY:Ci9BEi9BE00CTU9D2iI>E00?STI?RT9;SSY400n6<S`0ChXb?
hHbAfhB=ehB<dH>3bgagc7E/d6]SdEYDcDe:`TE3Y3HeSchko/_7oo;^ookk
nOoomOooo?oo00FIVIT500007iVIV@030000VIVIVIVI00FIVIT4000019VI
V@<00003VIVI0P0000>IVIT200006YVIV@80000;VIVI0P0000RIVIT20000
4iVIV@80000<VIVI00?oooo<c<c<c<`0GLc<c0052@TD6Q8D6PT:2@T:2A8:
00892@X00a4L2PT92PT92P022@T:00<A70X92@X92@X00PT92P0>4A`:2@T:
2@T:4A`:2@T:4A`:2@T:6PT:2@T:4A`:2@T:4A`:2@T:;1800PT92P894PX0
60T92Q4L2PT92Q4V2SAE:F1N<b<_7SeN?B<_:DIE:AXV51X92SAE:AXB514V
51XV52<L2Q4V50T92Q4L2QXB50T92Q4V2QXV50892@X010TB2P0000T92PT9
2P<94PX01@T92PTB2PT92PTB2P0000022@T:00@A70X92@X92@X92@X22A8:
00L92@X94PX92@X94PX92@XA70X94PX00PT92P894PX00`0000T92PT92P02
2A8:00<000094PX000000PT92P894PX09Q4_<a4V7PTB2QXB50T951XB50T9
514V514_<a4_?BaWG14L2Q4_?BaEKcAWN`TL52aEG2=1?@TV:@TL52<_:@00
02a<:CAE:A4L2PTB2Q4V7P000:JZXiF4SSdB2YFQSPTV:@TB2PTL51XB52<_
7PT92P80000020T92PTB2PT92PT92V1N<hf=DYFQS/77`@;1/jd01:JZXm?I
e]cSeYFZ[@96@Ah0<L6cS]cSh<[@eYF=DP0000TB2Q4L2PT92S@_7THV58=k
<dI<?@T950TB2PT950T92R<V2TI17X=N<fYW<hf=DR<_:@0001XB50T92Q4L
2PT92Q4V54HV56YE7Yik<l6cS/[@`G:=Q>BZV=cSe[2ZQ>C@c:JHQ=?IeYF=
I]cSh:JZXjJHQ<6c[K2c]h=kG14L2PTB2P026PT:00l92@XA70XJ2@XA70XJ
2@X92@XJ2@XA70XS70X92@XJ2@XS70XJ2@XJ4Q@/4P000QX92P04;1806PT:
4A`:4BHD0QX92P03;1804A`:6PT:00@J2@X01`T92R<L2R`B01X92R<L2P00
0;2c]`1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@07VIVI01Kon?oon_olo?knoo_ln>gcf<f@E4b><bj/
=SBn?S_9Cd[?GUS<J6K:LG?;N83@OhKFOhGLPhOPRXgRSI3QS8oMRhd2g8b=
0]f?S`;MSHh01=f;SMb:S=^9Rm^9R`SMSI02fXZ=00CKRhkLS8oMSI3MSI02
gXjA4=b<S`;NSY42gHf@00CLS8oKRhkJRXgJRXd8gXjA1=f>T@CNSY401=n=
TMj<T=f;Sm^9S@?MR8d04]b:S]1oQ/ioQLYlO<MdL<UZI<aOF/a?Bl=3@:lh
=9H`;9IAB_oHd_ojm_okn_[koocoookooiZIVIT00oooolc<c<c<c01Mc<c<
00LJ4Q@A70X92@XA70X92@XA70X94PX00PT92P034A`:6Q8D2@T:00892@X0
1`TB2PT92Q4L2PTB2Q4L2PT92Q4L2P052@T:00<94PX92@X92@X00PT92P0=
4A`:2@T:2A8:2@T:00002@T:2A8:6RHDCfML=2lN4BH:AUDY8blN008/>2T0
1b<L2SAE:A4L2R<_:B`V50TB2Q4V50022A8:0Q4L2P074BHD6RHD2@T:0000
2@T:2A8:000000892@X22A8:00<92@X000094PX00PT92P072A8:2@T:2@T:
2@T:2A8:2@T:2A8:00<92@X02@TB2PT92Q4L2PT92QXB50TB2PT92PTB2P00
00032@T:00@000092A@94PX000032@T:00@92A@J4Q@99RTA9Qh22@TD0PTL
7P0J4BHD2A`N2BHY2BHY4BmB4Blm2D57?G:4;5EL2A`N8blcLUEBPehcLUEB
UHAkPg]LCfML2A`N4BHN6RHD=2lN=2lcYUEVYXB4UHAkSHe_0Ra<:@0U6PT:
6RHD2@T:2@TD;1`DAT4N8blNARHDH5hcLXdmH5hcCfM7Phf4b]31dmWFb]31
dmWFYZZS;4`YARH:`K>]b[j]b]31kNgZg>?PLXdmSHe700002@TD4A`:2@T:
6Q8DWXdYPg/cAUDY2@T:4A`:00892@X084I17TIE:FYE7Xf=DYF=DQ4V2PT9
514L2PTB2Q4L2QX92TI17VYE7ZJQI/6cS/[@`FYW<l6cS^C@c:JQV>C@c<Zn
[Ng]j[2c]jJZXl6cSVYW<k2ZQ9FQS/6cSP0000T950<A70X01R`B00T92QX9
2Q4L2R`B00T92P8J2@X01b<L2QX92R<L2R`B01X92Q4L2PT92P026PT:00D/
4P0J2@XJ2@XJ2@XA70X011X92P034A`:6Q8D4A`:008J2@X01B`B02<L2R`B
00000;2c]`1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0
^0C<c<`00fIVI/c<c9VIV@07VIVI01?ok_con?oooooiooWlooKon>Z^OgF4
=BjR=C:W:RS1@D3DFUW?IfSEO7kJSiCJTiONTYKSTiKUUYT00^BHVP03hiVJ
hYZKhi^L00;SWId00nBLWN>KW>FKW003i9ZK2>>KWP;PV9/01>6IW>:JWN>K
W^>KWP?TW9l01n>KW^6IW>2HVn2HVn6IW>>KW^BLW`08hYZM0nBLW`;SVih3
hYZM2>>KWPCRW9h4hi^N01WTVIgWW:3WW:3SV9cQUIWRUY[QUIWMTYKESY;T
W9oAQHG?MgGJLVniAT?7AdJ^<BnC9R>?>S>OJf3on>ooo?Sln?Woo?oonOoo
o_l0VYVIV@03ooooc<c<c<c<05g<c<`01AXB514L2PT92PT92Q4L2P022@T:
00D94PX92@X92@XA70X000000`T92P044A`:2@T:2@T:2A8:0PT92P0=2A8:
6PT:2@T:6PT:2@T:;1804A`:2@T:6PT:4A`:6PT:4A`:2A8:00892@X04aX9
2PT92Ra<:IFQSP0002<_7TmWA`0002`h:DI<?@0003AE:@0002a<:@T9514L
2QXV50T92Q4L2P024BHD00<J4Q@S;ah000000PT92P0300002A8:000000@9
2@X32A8:10T92P032A8:2@T:2@T:00<92@X32A8:00DJ2@X94PXJ4Q@00009
4PX00`T92P894PX32@T:00<92A@92@X92@X00PTB2P0C2@TD8d4m2BHY2A8:
4BHD2@TD4BHN6Q`N4Blm4Blc6Q`N;6ML6Q`N8d5B;5E_4DaBEei_g;jgkMW<
00;fkNX05OKfmOKomIEbA`0004HV2[VHG>BZV=bn]ngIc?K]jYF4SQ4V2R<_
7R<L2R`L54I17YF4DYFHIZJHKiFHIYF4N`02YZZS0iFQSP07g<NSb]3FNheV
JW9L4BH:0000H2lD00;1/jd01^C@c=?Ie]cSh=cSh4I<?Hf=A`<94PX00a4L
2QX92R<L2P02Pg/c00X000094PXA70X92@XJ9QA6;`Y6@Aj3Nc>=SE96EBT2
2A8:00lJ4Q@0000d;bU6@Aj3Nc>iV5c:_ZgL_[NEZZgL_[OfooFVXIS:_Zf`
/kO:d<400ZJQV007`LO1JW9L`K>]`K>>NheV00004A`:00@J2@X02Q4L2R<L
2PT92QX92R<L2PT92QX92PT92QX92R<L2P<J2@X012<L2R`B01XB52<L2PLJ
2@X00a4L2QX92R<L2P026PT:00<S70XJ4Q@S70X00QX92P03/;>gc<c<c<c<
05o<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003
IVIVc<c<VIVI00NIVIT06?odoooco?onooWooNgikOklkmbl/Fh]9hhZ:9`T
9KHh>LY?DMU`M>N>T=^EUmJHVNZUZ>fWZNn[[>j/[Nf[[>b/[>Z][>^^[@;^
/[400nnb/Nja/?2`/003kjn_2>j`/@04jjf^k:j_k:j_kJn`0^j`/@?_/K80
1nj`/Nb^[n^][^^][^b^[nj`/Nna/P08kJn`0nna/P;^/;43kJn`2>j`/@C]
/K44k[2a00G_[k3b/[?b/[?^[Zo^[:h00^n][`0Bjj^/m[JggYZKeh^;ojNV
aE]K_DI8_D53UR0PVS/gIb<Jgkfaoo[^o?WdookoooSoooWooogoVYVIV@03
ooooc<c<c<c<05g<c<`00aXB50T92Q4L2P024A`:00<94PXJ4Q@92@X00PT9
2P032A8:4A`:2@T:00<92@X0114L2PT92PT92Q4L2P892@X0114L2PTB2PT9
2Q4L2P<92@X00a4L2P0001X92P032@T:018A70X000094PXS@Cf=SFl0000S
;ai6EE80000S@CddEBT94PXdEBT0000dEBT92@XA9Q@S9PX24A`:00LA9PXA
70XJ9Q@J9Q@94PX000094PX010T92P064A`:2@T:2A8:2@T:2A8:2@T:0PTB
2P052@T:2A8:2A8:2@T:4A`:00<92@X00a4L2PT92PTB2P022@T:00<J4Q@9
2@X92@X010T92P0300002A8:2@T:00<92@X02@TB2PT92PTB2PT9514V50TL
7QXB50T950TL50022BHY018A;c<A;cdA;c<A;cdS@CdA;e8/EE`9@DOL/jg]
fLcTal7fkN[Lhn3LhmKTd<bELTNNLS?1Ng/2i<O1017fkN[LhmKfooF3Nc<0
000A70X/71A69QB=SE;:d<6`/kO1/hj`/kO1al7:d<7LhmK:d<400]cSeP03
YZZS4BH:000000892@X01FYW<k2ZQ=cSe/6c[L[@`@03kNgZ00_1/hi6EBUP
GS<94PXA9Q@92@X94PXS70Xm70Z3Nc?:XCd00`T92P074A`:;2HDARHDJUDN
LXdmYYQ_000000894PX021XB54HV56YW<iik<k2ZQ<[@`L6c[H=kG0;:d<40
7jJQV<Zn[JJQV<6cSZJZXiF=IZJQV9FHIYFQSZJZXaXV50T950T92Q4L2QX9
2PTB2PT92R<L2PT92QX92R<L2PT92Q4L2QX92PTB2R<L2R`B01X92R`B01X9
2R`B00026PT:00H/4P094PXJ2@X92@XJ2@XJ4Q@36PT:00@92@XJ2@X/4P09
2@X26PT:00@/4P0/71@00031alaQc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@07VIVI01SomOool?Kooooh
oog_ooGnooKon_6TLFef8R2>92JM:Bbb?d;PO7knZZ[`[jgY[jgX[ZgZ/:o[
/k;[]K?Z];;W];7V]K7U]K44ikNc0^Nf/P;X]K88ikFd00?U/k;V];?V];<0
0^Ne]0;X][D2jKNf00OX][GV];?U/k;U/k;V];?X][GY]kH02>Ne]0CX][D<
ikFd1^Jf]0;W]K@00nJd/nRf]NZg]P02ikBc01CY][GX]KCW/JoSZJO/ZjWb
YZK]UICQN7bgATZI9RV471e]7a^[Ng7onN[gnNcloo_gmOSon?oomooooOnJ
VIVI00?oooo<c<c<c<`0GLc<c08A70X22@T:00<A70X92@XA70X00PT92P03
6PT:2@T:2@T:00@92@X01@T9514L2QX92PT92Q4L2P042@T:00DA70X92@XJ
2@XA70X92@X00Q4L2P0O2@T:2A8:2@T:2@T:2A8:2@T:AT4NJXeL0000=5DY
LXeL2A8:H5hcAUDY;180CfM70000AUDY2@T:8bH:;3PY0000;1804A`:4BHD
;2HD6RHD2@T:00002A8:000000<92@X00`0000TB2PT92P032A8:0`T92P06
6Q8D2@T:4A`:2A8:2@T:4A`:10T92P054A`:2@T:2@T:2@T:000000<92@X0
0`TB2PT92P0000032@T:00P94PX92A@94PX94PX92@XJ4Q@A9Q@92@X24BHN
00dS@CdA;c<A;cdS@E8S;c<A;c<S@CdS@E8/EFnVEFKLhmK:d<7]fL`00]cS
eP05i<O1g;jgb[j]g;>Si=3<00;]fL`03oK]j_o]c?oooa4V2QXV514L2P00
06YW<jJ4DW^=IXf=Kg^=Q8>4NjJQV=cSeP02g>?P00VVXIQ6EBT000092@XA
70X92@YZEAkLaj?L_[L00]cSh009`LO<kOKeg>?FkNgZb]31`LO<LXdm8blN
4BHD008A70X0:`T92R<V2V1157]<2W:=?@00014L2PT92R<L2R<V2V1158f=
AjJQIV1N<`T92PTB2THV54I17X=k<k2=D/ZZI/[@`Hf=KnC@c:JQV>C@c<6c
[LZn[FYkKl6c[JJZXjJHQ;2c]jJQV8f=KjJHK`00014L2PT92QX92Q4L2QX9
2Q4L2P026PT:00@J4Q@J2@X/4P0J4Q@2;1800QX92P038a`:6Q8D6PT:008J
2@X00b<L2R`B01X92P026PT:00XS70XJ2@XJ2@X/4P0S70X92@X/71@J2@X/
4P0J4Q@2;18000<J2@X/4P2`_/40HLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT01iVIV@0FooGgoo_moOgm
n?onmoomo?okoocfon3MWE]LJ18CPAdOYCi1`VMViiJChIfJiJZViZn/ik:^
jkJbj[Ncj;Nbi[Na1^Bg/@CV]k40;nJf/^Bg/^Jf/^Bg/^Jf/^Bg/^Jf/^Bg
/^Fe/N>f/NFe/N>f/NJf/^Bg/^Ng/nFh/nNg/nBg/^Fe/N>f/NFe/N>f/NJf
/^Fh/nJf/^Bg/^Jf/^Bg/^Jf/^Bg/^Jf/^Bg/^Jf/^Bg/^Jf/^Bg/^Jf/^Bg
/^Jf/^Bg/^Jf/^Bg/^Jf/^Bg/^Jf/^Bg/^Jf/P02i;Nb00?S^;;T]k;S^;80
1>Bg/P0Ii;B`ikNcikNciKFai[FaikJbiKB`i:n[jJjZgi^HokFbj9BBa6AV
SBP/QR4UM1hOUUUFon[Qooc`n?ofn?omn?SjooSooo7noogo09ZIVIT00ooo
olc<c<c<c01Mc<c<00P94PXJ2@XA70XA70X92@X94PX92@XA70X72@T:00dJ
4Q@A70X92@XA70XJ4Q@000094PXJ2@X94PX92@XA70X92@XJ2@X01@T92P0E
4A`:6PT:2@T:4A`:6Q8D;2HDAUDY8bH:8blNJW]_2@TD=5DYAUi74A`:;4`Y
8blN6RHD4BHN6Q8D6RHD4A`:00894PX00b`V51XL7Q4L2P052@T:00<94PX9
2@X000000PTB2P0600002@T:2A8:4A`:2@T:4A`:0`T92P062@TD4A`:2@TD
4A`:2A8:6Q8D0PT92P044A`:2@T:2A8:2@T:0PTB2P0300002@T:2@T:00<9
2@X05Q4L2QXB51XB51XB50T950T92PTV:@TL7Q4V7QXV50TV:@TL7R=1?@TV
:B=1?BaEG14_?BaEG3ebQ4mbNnC@c=bn]`?Td<`01>gIc=bn[NgIc>C7`@;]
fL`09mcSe_K]j_KomNg]j/Zn[G8h014L2Q4V2Q4L2PT92S@_:JJQIX=k<dI1
7TH_2^g@V<6c[Hf=Ka4V2P0000T92QXB514V51XB56YE7/6c[NC7`McSe^g]
j^gfmL6c[OKomMcSh=cSe/[@`McSeZJQV61N<`0000026Q8D00L92@XS70XA
70YZEAjNNc<92A@94PX00Q4L2P0O=2lNAT4NPehcSHe7^JY_00002A8:=2lN
ARHDJUDNWXdcb[j]YZZSAT`mkMW</:Z4g;jgb]31`LO1`LO</:Z4YZ6HNheV
Pg]L/:Z4UHB>JXeL00002A8:2@T:6PT:008A70X00aX92PT92QX92P036PT:
00DA70XJ2@XJ2@X92@XJ4Q@00R`B00@J2@X04b<L2QXB51X92R<L2QX92R<L
2R`B014L2QX92Q4L2R`B01X92R<L2QX92R<L2QXB52`B00000;2n`@1Qc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`2IVIV00?<
c<bIVIVIVIT01IVIV@0Eoogiookko?cjnOglnoooo_kol^SYooOhonk_KC4a
L2HURc`hXe9?jI^GhY^Eh9fGh:6Lh:FQiJZViZbXi:fX00;R[JL00n2^Yn:`
ZN:`Z@02h[2Y1>F`ZP0_iK2/hk2/iK2/hk2/iK2/hk2/iK2/hk2/i:n[hZn[
i:n[hk2/iK2/hk2/iK2/hk2/iK2/hk2/i:n[hZn[i:n[hZn[iK2/hk2/iK2/
hk2/iK2/hk2/iK2/hk2/iK2/hk2/i:n[hZn[i:n[hZn[iK2/hk2/iK2/hk2/
iK2/hk2/iK2/hk2/iK2/hk2/iK2/00;S/:`00n:a[>>`[>:a[004hk2/01WT
[j_U/:cU/:cS[Z[T[J[U[Z_QZZONXioPVYSZX9gES8K0MG2@@3n6=3I[6aie
<C;oj^OonO;goO7doo[_o?Gnoooologon?oooOl0VYVIV@03ooooc<c<c<c<
05g<c<`02AXB514L2QX92QX92Q4L2PT92QX92Q4L2PT92P032A8:0`T92P0A
6Q8D2@T:2A8:6PT:4A`:2@T:6PT:4A`:2@T:2A8:2@T:;1804A`:2@T:;180
2@T:4A`:00<92@X01QX92PT92Q4L2R`h:DmWAaXL7P8dEBT02DI<?@TB2SeN
?B<V2PT92SAE:@0004I17Q4L2P024BH:00HJ2@XJ4Q@A9Q@A9PX92@X94PX4
2@T:00<000094PX92@X00PT92P082A8:2@T:2@T:2@T:2A8:6Q8D4A`:2@T:
0a4L2P082A8:6Q8D2A8:6Q8D2A8:4A`:6PT:4A`:0`T92P032@TD2A8:2@T:
00<92@X32A8:00h92A@S;ah94PX99RTA9Q@A70XS;ahA;c<A;ce6Ie`A;cdS
@Cd/EE`S@E82;5EL00</EFoL/jgTal400nC@c003i<O1g;j]i<O100;]fL`0
6oK]j^g]j_KfmOKomNg]jYEE5;1E0=c7Xa4V2R<_7Q4L2Q4V50T92PTB2S@_
7X=k<k2ZQ<6c[Ba<:@TB2Q4L2Q4V51XB514L2PT92ZJQI[2ZQ002g>?F00oL
hn3]kN[]m_FVZZ?foooLhn3LhmKTd<cLhn31albEXHh0000A70X92A@A70X0
0PT9500TARHDH5hcJVLc2A8:6PT:2A8:2@T:AT4NJT4:LXdmYZ5V;3PY2@T:
=2lN=2lYPg/cWW8ci=3<SHe_YYQ_kNgZYZZSYZ6Hg>?FYZZ]b[j]SHe_`K>]
UJ6>SHe_`K>]/:Z44BH:2@TD2@T:4A`:11X92P046Q8D6PT:6PT:;1801AX9
2P0<8a`:6PT:6Q8D;1806Q`N;1808a`:;1808a`:6PT:8a`:6Q8D0QX92P06
;1808a`:6PT:;1`D2@T:6PT:0R<L2P04?A8:8a`:;180/;k1HLc<c004IVIV
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00AVIVK<c<aVIVK<
c<`6VIVI01GkooSjooWnoogoooogm?_oo?ohkOGon_gomOKom?=lBdIE61>9
A3f1=S33MW3APgoAQhCCS8SITXkLUi;LVI<00]ZIT`GJVi@4g9^E02oLViOK
W9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OL
ViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOK
W9OKVYKJViKKVYKJViKLViOKW9OLViOKW9OLViOKW9OLViOKW9OLViOKW9OL
ViL00]^LU`?IW9L4fibG01WKVYKLViOKVYKJVIGLV9GMVIKHU97CS8SBPgoG
R8>]I5jFDDai=C9>3Pj?DE;ol?7om_ConOGioo[_ooScooglooohjo;onOoo
oOl0VYVIV@03ooooc<c<c<c<05g<c<`01PT9514L2PT92Q4L2PT92Q4L2P89
2@X00a4L2PT92PT92P052@T:00<A70X92@XA70X010T92P05;1802@T:2@T:
2@T:4A`:00@92@X00a4L2PT92Q4L2P032@T:00U6@Ah/>2U6EBT/C2T/>2U?
IdL0000d;ah/9Q@00PTL50034A`:8bH:2A8:008J2@X24A`:00@J2@XS;ah9
2@X94PX52@T:00<92A@94PX92@X00PTB2P892@X0214L2PT92PT92PT92Q4L
2PTB2PT92QXL7P894PX010TL514L2PT9514L2P894PX42@T:00@94PXA70X9
2@X94PX32@T:00D94PX92A@S;ahA9Q@/>2T00Q4V500=6Q`N4Blc8blY4Blm
4BHN8blc4Blm8d5B4DaB=6MkPhf4i<O1b]3100;Td<`01NgIc>C@c>C7`NgI
c=cSh004m^gZ00K1/jeb9P2iLS?T_XCokLaP;`X28bH:00PJ4Q@92@XA70X9
2A@d;ajiZVmZEAhA9Q@26Q8D00@A9Q@92A@A70ZNQ6H2b]3100O]kN[]m_G]
kN[]m_GCfMJVXISfool00]cSeP0^kNgZg>?PkNgZ`LO100004BH:6Q8D2@T:
6PT:2A8:4A`:ARHDJVLcAUDY00004A`:2@T:;180=2lNJUDNSHe7SHeBAUDY
=2lNLSPD/8dNYYQ_dmWFUHAkYYQ_i=3<`K>]YZ6Hi=3<Pg]L`LO<UHAk`K>]
`LO1/:Z4YZ6H;4`Y6Q`N00006Q8D2A8:0Q4L2P092@T:6PT:2@T:;1806Q8D
6PT:6Q8D6PT:4A`:00<J2@X2;18000LJ2@X/4P0J2@XJ2@XS70X/4P092@X0
0QX92P8S70X01aXB52`B00T92QX92R`B02<L2QX92P028a`:00</71@0003]
kNX0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<
00EVIVK<c<bIVIUVIVK<c<`01IVIV@0HlOofl_oeo?omoogoooKoooSoooWo
ooGmooCfoo[fooG]WW=ZEadBLbdUPRl[UC/j[eED]5YJ^f5Q_fMV`6YY`6aZ
_fi[`6m/0ke/J@03_VeZ`6aZ`6aZ00;1KF/0<<1/J[i]J/1/J[i]J/1/J[i]
J/1/J[i]J/5]Jkm^Jl5]Jkm^Jl5]Jkm^Jl5]Jki]J/1/J[m^Jl5]Jkm^Jl5]
Jkm^Jl5]Jki]J/5]Jkm^Jl5]Jkm^Jl5]Jkm^Jl5]Jkm^Jkm[JKe/JKm[JKi]
J/1/J[i]J/5]Jkm^Jl1/J[i]J/1/J[i]J/1/J[i]J/1/J[i]JPBmKVX4_VeZ
01VoJfW0K6ZoJfVnJVS1Jf[3KFbmIfJhH5j]DTn=>3=g;RME5PmS;RRTM73o
k^ooko7fhN3oo__hoog[o_SeooocnOWonooon_ooo_l0VYVIV@03ooooc<c<
c<c<05g<c<`01aXB514L2PT92PT92Q4L2PT92QXB50022@T:00@A70X92@X9
4PX94PX22@T:00@J2@X000092@X94PX92@T:00P94PX92@X92@X92@X94PXJ
2@X92@XJ2@X24A`:00`S;ah/>2U?IdLJ71hS;ahmGSdS;bT94PX/>2TJ9Q@A
70X92@X24A`:00L92@XA70X000094PX92@XA70XA9PX00PTB2P0400002@T:
00002A8:0P0000892@X04P00014L2P00000000TB2PT92PTB2PT92PT950TB
2Q4V7R=1?Ba<:A4L2PTB2Q4L2P0001XB50<A70X00`T92PTB2PT92P022@T:
0PTB2P072@T:2A8:2@T:2@T:2@TD6Q8D4A`:00<92A@24BHN00`A;c<S@CdS
;c<S@CdA;cddIg^VZZ?Td<cTal7Td<cTal7Td<`4kMW<0_K]jP0;m_Keoooo
`J64bZYVi<O1g>?FkMW<m_oeAUDY4BH:6Q8D008A70X00`T92Q4L2PT95003
4A`:00T/71@A9Q@92A@J4QAZIc?Laj?:_ZgCfMK]kNX00^gfm@0;m_oedmWF
Phf4m_ookNgZg>?PkOKekNgZkOKe/;>g4BH:008A70X0<QXB514L2QXB50TB
2Q4L2TI17VYE7R<_7PT92Q4L2PT952`V51XV54HV58f=AfYE7TI17X=N5=>n
S/Zn[L6c[Mbn]l77`LZn[L[@`JJHQ>g]jZJHQ9FQS/6c[H=kG:JZXk2c]iFH
IP00014L2PT92QXB51X92PT92R`B00T92Q4L2R<L2PT92R`B01X92R<L2QX9
2PT92P8/4P003AX92QXB51X92R`B02`L51X92R`B03dB2QX92Q4L2QX92PT9
2R`B00036PT:00@A70XS70XJ2@XJ2@X28a`:0b`B0003dmWFc<c<c<c<05o<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c006IVIV
c<c<VIVIVIVIIVIVc<c<19VIV@0IjOo`lOofnooloo[nooSooncoooWooo_o
ookooo[doo_aoo?Voo7Vol[2Y4m:QBHTL0h?Ma<EOA/LPR8SQBDVQ2TXQR/Z
QR`[Q2XY00>5:bX2Qb`[0XX/;0R7;2/4R2d/1XL/:`B8;B`2Qb`[28P];004
QBXYQR/ZQR/ZQR/Z0XL/:`:8;B`7Qb`[0XH/:`03QBd[QR`[QR`[00:6;2/2
Qb`[01V5:RV6:bZ8:RZ8:RZ;;Bf=;bn7:BV08R1l6QUi81bNEDkof];ol^co
jNCom?Com_Son_[glo3eoocbooo]o?WgoooooOojlOKoo_l0VYVIV@03oooo
c<c<c<c<05g<c<`031XB51X92Q4L2Q4L2PT92Q4L2PT952<L2PT92Q4L2PT9
2P0000@92@X02A4L2PT92QX92PT92PTB2Q4L2QX92PT92QX92P022@T:00@/
4P0J2@X92@X94PX62@T:00XA70Y6@AhJ9QA6@Ai?IdL0000dEBU6EBT0000/
>2T24A`:00D92@XA70XA70X92@XA70X00PT92P054BHD6RHD2A8:2A8:0000
00@92@X01PTB2PT92PT92PTB2PT92PTB2P@92@X01P0000TB2PT92PTB2P00
00TL7P9bSJd02DIWG2<_:@T92PTL51X92Q4L2Q4_<a4V7PT92P032A8:00<J
4Q@94PX92@X00`TB2P032@T:2A`D2@TD008A9Q@011XL7PTV:A4_?B<_<`8A
;c<01Q4_DQ4_?IF4S^gIc=bn]nC@c0G]fL`2g>?F0_K]jP06m_KekOKeong<
m^gZkNgZong<0_Kom@054BH:2A`D4A`:4A`:2@TD00<94PX020T9514V514V
514V7PT95611:JJHKlZn[@;LhmH5kNgZ00?Lhn1bIe;fool01^g]jP066RHD
2A`D4BHD6PT:2@TD6Q8D0Q4L2P8/9Q@0261150T9514L2PTB2QX92QXV52`V
5611:@96@Ah02[2=<l6cS^C@c9F4NmcSe/6c[JJZXm?IeYFQS/77`@:VXIP0
2<77`K2ZQ<6c[L6cSP0000T950T92Q4L2P<92@X01B<L2PTB2QX92PT92R`B
00066PT:00<J4Q@/4P0/4P000R<L2P0>;1808a`:?A8:6PT:4A`:6PT:4A`:
;1806PT:;1806Q8D;1806PT:;1800R<L2P06;1806Q8D8a`:;1`D0000dmWF
HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT00YVIV@03IVIVc<c<c<c<0?o<c<`>c<c<00?oooo<c<c<c<`0
GLc<c0084A`:2@T:2@T:6PT:4A`:2@T:6PT:4A`:1@T92P042A8:2@T:6PT:
4A`:0`T92P032A8:2@T:6PT:00<92@X00a4L2P0000T92P032@T:00<A70X9
2@XA70X00PT92P0;8a`:AT4N4A`:6RHD=5DY4A`:2A8:8bH:8a`:00004BH:
00892@X02@TB2PT92PT92PTB2Q4L2Q4V2S@_:AXV514L2P042@T:00@94PX9
2@X92@X000032A8:00D000094PX92@X94PX92@X010TB2P052@TD4BH:6Q8D
8d5B=5Dm008S@Cd34A`:00HJ71hS@Cd/C2T94PX971@92A@22A8:00T92@X9
4PX94PX94PXA70X92A@92@X92A@A70X00PTV:@088blY4Blm8d5B8d5B?G:4
YZ6HkMW<i<O10^C@c00:g>?Fong<kMW<kMW<kNgZg>?Fm_Kem^gZm_oem_Ke
0oK]jP08m_oem^gZm_oeg<NS00002A`D2@TD2@T:0Q4L2P0<6Q8D2A8:6Q8D
6Q8D6Q`N2A8:H2lDg>?Fi=3<g>?Fg>?PkOKe0ng]jP07kOKekNgZkNgZ`LO<
kNgZg>?PkNgZ00;Lhn002/[@`McSe/6cSP00014V514L2QX92PTB2QX92PT9
2P8J2@X05dH_2TIE:@00014L2PT92QXB53@_7VYE7S@_7Yik<l6cS/6c[H>=
Q:JHKl6c[L[@`JJHQ<[@`K2c]l6c[L77`JJQV:JZX`02UIQV00<000092A@9
4PX00`T92P8A70X01PT92QX92QX92Q4L2QX92R<L2P8J2@X03B`B02<L2QX9
2QX92R<L2QX92R<L2R`B02<L2QX92R`B02<L2R`B00036PT:00<S70XJ2@X/
4P000aX92P088a`:;1806PT:;1808a`:;1`D;180`LO<HLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT00iVI
VOmVIVH@IVIV00?oooo<c<c<c<`0GLc<c0044A`:6Q8D4A`:4A`:0PT92P0>
6Q`N2A8:2@T:6PT:4A`:2@T:4A`:2@T:4A`:6PT:2@T:4A`:6PT:4A`:0`T9
2P054A`:2@T:4A`:6PT:2@T:008A70X010T92PTB2Q4L2QX92P892@X0214L
2R<L2QXV52a<:A4V51XB52a<:@00008A70X03@TB2Q4L2PT92Q4L2PT92QXB
51X92Q4L2QXB52a<:B<_:AXV50T92P032A8:0PT92P036Q8D2@T:2@T:00D9
2@X00`TB2PT92Q4L2P022@T:014J4Q@92A@A9Q@S;bT/>2U?IeaZNhA?LW^3
V:ebSH@mGSd0000J71h92ABEXKLS;c<000000PTL500F6Q8D2A8:2@TD2@TD
6Q8D2@TD4A`:6Q8D4BHD2A`D2BHY8blc2D574Blc4BmBEei_2BHYYZ6Hong<
g>?FkMW<i=3<0mcSeP05ong<kMW<kNgZong<kNgZ00?fm_D01oK]j_KfmOo]
c?ooooo]c14V2PTB2P026Q8D00<A9Q@J4Q@A9Q@00QXB50044BHD2@TD6Q8D
JUDN0]cSeP04i=3<g>?PkNgZkNgZ1Ngfm@03m_oeg>?FkNgZ00CLhmH01]?I
e/77`McSh14L2Q4V2QX92P<A70X02QXB514L2R<L2Q4L2THV54I17PT92S@_
7VYE7TI17P9P@BT06LZZI]c7XjJZXmbn]k2ZQ<Zn[L77`JJQI/77c8>=Q<6c
[IF=IZJHQ<Zn[IFQSP0000T92PT951XB50T950T92Q4L2PT92QX92Q4L2P03
6PT:00`/4P0J2@XS70X/4P0J4Q@J2@X/71@/4P0J2@Xm70X/4P0J2@X2;180
00HJ2@Xm70XJ2@XJ2@XS70XJ2@X28a`:00<J2@Xm4PXA70X00R<L2P07;1`D
8a`:;1`D8a`:;1`D;180/;>g067<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI0?nIVITCVIVI00?oooo<c<c<
c<`0GLc<c00:4A`:2@T:4A`:6Q8D4A`:6Q8D4A`:6PT:2@T:2A8:0PT92P0=
2A8:2@T:4A`:2@T:;1802@T:2A8:2@T:4A`:2@T:4A`:6PT:2A8:00892@X0
2Q4L2PT92PT92P0002`B00TB2Q4L2PT92PTB2PT92P8S9PX02DH_2Q4V2PTB
2R`B00TB2PT92PTB2PT92P0000052@T:00DA9Q@/9QA?IdLd;ahA70X00`TB
2P892@X01A4L2PT92PT92PT92PTB2P052@T:00<A70X92@XA70X00PTB2P0@
6Q8D6RHD8blY4BlmLXf4JW^4H79kY[?1PiR]UJ6gPhf4;5hm;4`Y8d4mdn?e
UIRS0P00000C2A8:2A`N4BHN2A`D6Q8D2@T:4BHN2BHY2A`N2@TD8blc8d4m
Eei_LUEBYYR4i<O1WW8c0000?Ehm00?]fL`01nC@c>gIc=cSh=cSh?o]c?K]
j^g]jP02m^gZ0_Kfm@0<m^gZm_oem_oePg]L00002A8:4A`:2@TD4A`:2@T:
2@TD2@T:0Q4V50042@T:=2lN/:Z4`K>]0/[@`@03g>?Fg>?PkNgZ00?]m_D0
1OKoooKomMcSh=cSe]cSh003kNgZ0lZn[@08g;jgg>?P`K>]4BH:2A8:4A`:
6PT:2@T:0a4L2P0?6PT:6Q8DH44D=2lNNd`DPehcAUDYLSPDWW/cb[j]`LO1
^JY_dmWFPg]Li=3<00:VZZ<02l[@`JJHKl6c[L6cS/77`IFQSP0000T92PTB
2PT92Q4L2P022A8:00@A70X92@XA70XS70X36PT:00DJ4Q@/4P0J4Q@J2@X/
4P000QX92P098a`:?A8:6PT:;180;1`D;1806PT:;1`D?A`:008S70X011X9
2R`B01X92R<L2P8/4P000aX92R`B02<L2P02;1800R<L2P03?A`:;180/;k1
067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003
IVIVc<c<VIVI00jIVIT2ooom1_ooo`;oo_l01_kmnockmoWel_3_j^[Wh^GR
gA3Jem8_f=OC00?Hem;Jem;Jem803M[GdP08fmK@f]K;in7Ej^KKl>cSo?Oc
o_[goo_j1Oono`Cnool00ooooiVIVIVIV@2AVIVI00?oooo<c<c<c<`0GLc<
c0076Q8D4A`:2@TD?Blm2@TD4A`:6PT:00892@X00a4L2PT92PT92P032@T:
00<94PX92@XA70X010T92P094A`:6PT:2@T:2@T:;1802@T:4A`:2@T:2A8:
008J2@X32@T:00DA70XS9PX94PXA70X94PX01@T92P894PX010T950T92PTB
2PT92P8dEBT013d_?DIE:A4V2PTB2P<92@X01A4L2PT92Q4L2Q4L2PTB2P06
2@T:01894PX92@X94PX94PX92@XA70X92A@S;c</C2Td;c>3Q8j3V8j`/kNE
V:>3V8jEV:>`_/5GIe824BHN00ddIg^E/lc:d=J3Q8hm;cdS;c</71@99RTA
9Qh/>2UGEE9ZIc=GGVl00jJQV009`K>]g;>Sb[j]i<O1kMW<g>?FPehc0000
JW9L00?fkNX04NgIc=cSh>g]j^g]j_K]j^gIc>gfmOo]c?Kool[@`L6cSQ4V
2P0000TB2PT9514L2PTB2P034A`:018A9Q@J2@XS;ahd;aibSCf`ZXBVXIS:
_ZgLhmKLhn3]kN[]m_Gfooo]m_GfooG]kN[Lhn3:_Zd3kNgZ00CLhn3]kN[]
kN[Lhn02g>?F0]cSh008SHe_2A8:4A`:4A`:6Q8D2@T:4A`:2@T:0Q4L2P0F
;1`DPehcAUDYJVLcJUDNbZYVdkj>`K>>YZ6H`K>>b]3F/:Z4b]31YZZS`K>>
/;>gUJ6>`LO1dmWF=5Dm00002@TD0PT92P<94PX52@T:00HA70X/4P0J4Q@/
4P0S70X/4P026PT:00`J4Q@/4P0J2@XS70X/4P0S70X/4P0m4PX/71@/4P0m
4PX/4P026PT:00DJ4Q@/4P0J2@X/71@J2@X00R<L2P056PT:6Q8D8a`:;180
;1`D008/4P000k2n`Lc<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0>VIVI1?ooo`0=ookoooom
ookoooomookmoOWfm?7/j^OPhmkHg=WBem;<d/k5b<6i00k9`;L00lS1]lK2
^LK2^@0^a/:i00?8`KW9`;O9`;L03<W0]`09bL6fb/>ce<fkfM74gMG:i]oG
kNGRm>k^oogn00Coo_l2o_oo00?looonooooool0TiVIV@03ooooc<c<c<c<
05g<c<`01A4L2PT952<_7R`B01XB50032@T:00HA70X92@X92@X92@X/4P0A
70X22@T:0Q4L2P086PT:4A`:2@T:2A8:4A`:2A8:2@T:4A`:10T92P044A`:
2@T:6PT:4A`:10T92P032A8:2@T:2A8:00@92@X00`0001X92PTB2P022A8:
00L92@X94PY6@Ai6EBUbSCdA9PX92@X00a4L2P064BHD;2HD6RHD6PT:4A`:
2@T:0PTB2P892@X00`TB2PT92PTB2P022@T:0PTB2P076Q8D4A`:;3PY;4`Y
EfMBYZZ]CeiV00:3V8h08G^=Q9FQSZJc`L77`C@_7W:=?C@_7R<_:JK7h=?S
mNgfmM?SmOKooiF=IZJHKij4IZJ4DYj4I[24Nl6QQ:J4Q<6QQ;24Nl6QQ;VZ
Kl6c[MbcXmbn]nC7`L6QQ8=N<a4_?IF4SP02kMW<0_K]jP09kNgZm^gZkNgZ
kNgZg;jg^JY_;18000002A8:00892A@020TL51XB50T950T92QXB50T951XV
53@_7P96EBT01X=kG:JZXk2c]l77`L[@`McSeP;]kNX2kOKe00K]kN[Lhn3T
d<cLhmK]kN[]m_D3kNgZ0^gfm@08kNgZg>?Pg>?Fg>?Pm_Ke4BH:4A`:6PT:
0Q4L2P096Q8D4A`:2@TDH44YPg/cJUDNH44YNd`DbZYV00;1/hh04/[@`JJQ
V<Zn[L6c[IFQS/Zn[L77`JJQV<6c[K2c]l6c[H>HSP0000T92QXB50T92PTB
2QXB50D92@X24A`:00<J2@XJ4Q@J2@X00aX92P0D8a`:6PT:8a`:;1806PT:
8a`:;1`D?A8:?A`:8a`:6PT:;180?A8:;1808a`:6PT:;1806Q8D6PT:;180
0R<L2P056PT:;180?A`:;1808a`:008m70X00b`B0<77c<c<c01Pc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VI
V@0>VIVI1?ooo`;oood02ooonoonnoWflO7/i^CMeM;;`LJo]Knh[[ZcZKN_
Y;2TV00>/J>H0[2TV00_[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ
[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH
[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ
[ZBH[ZBJ[ZBH[ZBJ[ZBH[ZBJ[ZBH00naXiP02K6TU;>VTkbaVkndX/6eYl[0
]]?:aN7Ieo;/k003ooko00?oooonooonool00_coo@03ooooVIVIVIVI096I
VIT00oooolc<c<c<c01Mc<c<0QXB50034A`:2@TD4A`:008A70X00aX92PT9
2Q4L2P024A`:0`T92P034A`:2@T:;180008J2@X02a4L2PT92QX92QX92Q4L
2PT92R`B00TB2PT92PTB2PT92P026PT:00D92@X94PXA70X92@XA70X00PT9
2P0400002A8:2@T:2A8:0PT92P0900002A8:4A`:2@T:2A8:;1`DH5hcAUDY
8bH:00894PX02aX92PTB2QX92R<V2R`h:B`V514V2R<L2Q4L2PT92Q4L2P02
2@T:00@94PXA70X92@X000042A8:00H92@XJ9Q@d;bUZNfnEZZeZNfl2SIR>
01B3V8j=V8jEZZg1albVXIREZZdS;ahJ9Q@A9PYZNhBV/l6`/kNVXIR`Q6JN
LS>`Q6J`Q7^VQ8BVV8BVXIP2YXB400J`NfJVQ8BVQ8B`Q7^`ZXBVXIP2b[j]
00STal6iV5aPLW/mLXB3SHBVZZ?Lhn3fkNX2kMW<00GL_ZgT_XC]ahBiLS=k
C1@00QXB500<2@TD6Q8D2A8:4BHD4A`:6Q8D8bH:=2lN=5DYEeEBPg/c/:Z4
0ZJHQ003/;>gg>?PkNgZ00?]m_D01?Koong]j]cSe^C@c0?]kNX00mcSh?Ko
mNg]jP02kNgZ00kLhn3]kN[LhmKLhmKfooEbSE`0000971@A70XJ2@X94PXA
9QA6@AiZEAh2H44Y01JVQ5;:ZVKLaj>`/kNEXHkTal6`/kNVXIS:d<6VZZ?1
al6`/kN=SFo1/jg1al5ZSE`000092@XA70X92@XA70X94PX72@T:00h/4P0J
2@XJ2@X/4P0J2@XS70XJ2@X/4P0J2@XS70XJ2@Xm4PX/4P0m70X2;18000<m
4PXm70XJ2@X00SdB2P0:6PT:;1806Q8D8a`:;1806Q8D?A8:;1806Q8D;180
0R<L2P05;180;1`D;1`D;180/;k1067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00jIVIT05_onooooookn
o_gmoOoooOoonoomn?_fl?;[hm_Db/No];neZKJ/X:VMSj2DQZ2CPin<OZ2:
O9f7NIZ4MYR2M9N1L`:FP787VH=e0YN4M@0_UXEeUXAfUXEeUXAfUXEeUXAf
UXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEe
UXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAf
UXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEeUXAfUXEe00RIPgD2V89d0YV3
M@:JQ7H049^5Mi^6MJ6?NIf=M:>BOZnPSKR[VknbZLo4_^3Fe>oWiOWcloon
ookno__mo?gooP;lood00ooooiVIVIVIV@2AVIVI00?oooo<c<c<c<`0GLc<
c0892@X020TB2QXB50TB2Q4L2QX92PT92Q4L2QX92P<92@X01a4L2PT92Q4L
2P00014L2PT92Q4L2P032@T:00TA70X92@X92@X92@XA70X94PX92@X94PXJ
2@X00Q4L2P892@X0114L2PT92PT92PT92P894PX05@0000TB2PTB2PT92PTB
2P00014L2PT92Q4L2TIE:FYbG0TB2P0000TB2Q4L2PTB2QXB52<V2R`h:C@_
7R`h:@028blN00@A70X94PXA70X94PX22@T:00h94PX92@X94PX92@X94PXJ
4Q@92A@94PX92A@99RU6GTMZNfn3Q8j=V8h2UJZ]02R=V8j3V8j`_/71alb3
Q7]kSFHdEBT/>2Td;bV=V8j`Q7^iZVnVV8C1XHBVV8C1XHCL/j>VZZ?L/jfV
ZZ?1XHBVZZ?1XHB`Q7^VXIRVV8BVQ8B`Q7^VQ8BVV8C1XHCL/hBVV8B3V:dm
LXBVQ8C1/jg]fLcfooGokL`2kMW<01ViSC=P@A@971@92A@A70X92A@J2@XA
70X/9Q@/71@J9Q@d;ai6@Aj3Nc=PGS=6@AjVV8BVZZ?:_Zg]m_Gfooo]m_G]
kN[]m_Gfool00mcSeP07kNgZg>?PkNgZg>?PkNgZkOKem_oe00;]kNX2g>?F
00gTd<cooom6Ie`A70XJ2@XA70X92A@/9QAP@A@d;aiP@BUZEAj`SE800]c7
X`0>SHe_g;jgb]3F`K>>`K>]SIR>YZ6H/;>gYYR4/;k1/:Z4b]31EheL0000
0Q4L2P032@T:2@TD2A8:00<92@X04@TB2PT92PT92PT92Q4L2QX92PT92QX9
2R<L2QX92R<L2QX92QXB52`B01X92R<L2QX92P02;18000Xm4PXS70XJ2@X/
4P0S70YG70169Q@/4P0J4Q@/4P026PT:00`/4P0S70XJ2@XS70XS9PX/71@/
4P0S9PXm4PX/71@/4P31alaQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0>VIVI0_ono`0No_kooOgmoook
ooojnoK`lncRdLVnd<Nh`kNW[9n>WXinUXEcRGQVNfUESG=RSW=RSg9RSG9Q
SW5QSW=RSg9RSgASSW5QSG9QSW5QSG9QSW5QSG9QSW5QSG9Q0XabH@0^S79S
S79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79Q
S79SS79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79QS79S
S79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79QS79SS79Q
0XebH@0KSW5QSG9QSW5QSG9QSW5QSG9QT7=SSgAST7=ST7ETTGATT7ETTGAT
T7ERUWiVS7MLS7INV8=^Y99n[Yj>^jfRa[bcfm;;kNGRoOWfooomoooo00;n
ool00ocnoOoooiVIV@2BVIVI00?oooo<c<c<c<`0GLc<c08A70X010TB2QX9
2QX92QXB50<A70X01@T9514L2PT92Q4L2PT92P026PT:00PA70XJ2@X92@X/
4P0A70X92@X/4P0J2@X24A`:0PT92P0400004A`:6PT:6PT:0PT92P034A`:
2@T:2@T:00<92@X00`TB2PT92PT92P042@T:01<J2@X92@XA70XS9PYZIc=6
9Q@92@XA70XJ2@XA70XJ2@XS9PXS;ah/>2U6EBUP@BTJ9Q@A70XJ2@X00Q4L
2P<94PX040T92PTB2PTB2PT9500002<_7Q4V2PT950TB2Q4L2Q4V54mWAiFH
XiFZ[K2n`JJZX`:=V8h01;2n`L[@eW^=Q6YbG096C3d034mWAfYbG:JQV<6Q
Q:JQV>BZV<6cS]bn]mbcXnC7`Mbn[Mbc[@;L/j<2b[j]00>VZZ?L/j>VXIP0
0ZJ4Q0:EQ7/03;VHG>g@V<ZZIP0002aEKeN=SYF4DX>4Nl6cS_o]c=bcG000
00<94PX01A4V52`L52`L51XV52<L2P026Q8D014dEBU6@AhS;ahA9QiZIc>V
V6n`ZXC]kN[fooo]m_G]kN[Lhn3]m_GfooGLhn3]kN[]m_D00ng]jP;]m_D0
1?KomNg]j^g]j^C@c0;LhmH04?K]j_oooa4V2Q4L2Q4V50T951X92VYE7VYW
<c@_7VYE7Yik<kVZKk2ZQ:JZXjJHK`;:d<4028f=KnC@c8=kG<Zn[JJZXl6c
S/[@`K2c]`8000001A4L2PTB2PT92PTB2QXB50022A8:00<92@X94PX92@X0
0Q4L2P0=2@T:6Q8D6PT:4A`:2A8:;1806PT:;1806PT:;1806PT:2@TD;180
008S70X013dB2SdL2SdL2R`B008J2@X044HV2SdB2R`B02<L2R`B01XB52<L
2R`B02`V52`B02<L2R`B03dB2R`L52`B04HV508m4PX00k2n`Lc<c<c<c01O
c<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIV
I/c<c9VIV@0>VIVI01ono_onooono_ono_kooo_nnoCaj^3Rf/g=`K71]:>Y
VXFGQg2QSGFnZ93D_ZKM`jcce<3ddl;he<Cge/GkelOif<Olf<SjfLSieLGg
e/GieLGge/GieLGge/GieLD00oOFa@0]mmK7mmK5mmK7mmK5mmK7mmK5mmK7
mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5
mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK7
mmK5mmK7mmK5mmK7mmK5mmK7mmK5mmK700?ge/D07oWEaOOFaOWEaOOFaOWE
aOOFaO[Fa_SGa_WEaOOFaOWEaOOFaOWEaOKF`NW;/Mc1Y<bbUkNOQJ:<M9b7
LZ^JR;nbX/Vm/McCb_?_i_onnOoooOooookooo_mo?ooo`2CVIVI00?oooo<
c<c<c<`0GLc<c0064A`:6PT:6Q8D4A`:;3PY2@TD0PT92P036PT:6Q8D4A`:
00892@X0114L2PT92PT92QX92P8A70X03@T92QX92Q4L2Q4L2PT92P0001X9
2Q4L2P00014L2PT92Q4L2PT92P024A`:00<94PX92@X94PX00PT92P894PX4
2@T:00@94PX92@X92@XA70X22@T:00e6EBT/4P0J2@XA9PXJ2@XA70XJ9Q@d
;bTS9PXd;c=6EBU6C3dS70X00a4L2P076PT:4A`:2@T:6Q8D2A8:2@T:2A8:
00892A@03FYbG5MWDPTB2PTL50TB2P0002=1?H>=Q8>4S/77`IFZ[JJQV:JZ
[@02b]3F00>3Q7]ZNfnEXHh00W^=IP09;3PYLXf4`J64g;>SYZ6H`K>>g;j]
g;>Sg;jg00C:_Zd02]c7XlZn[Mc7XjJQV:JZXl6cSZJZXjJQV:JHKb`h:@80
000010T92P00000000T92P8000002S@_7P0000T950T92QXB52`L51XB52`L
51XV52`L508A70X022`V51XB51XV52<_7S@_7V1N<jJQV>C7`@;]m_D00ng]
j]cSh=cSh002kNgZ0^gfm@06kNgZkOKekNgZg>?Fm_oekOKe0ng]jP0=g>?F
kNgZg>?FooooY/OP00002A`D4BHD4A`:JUDNAT4NH2lDPg/c00:iZVl02:JQ
V;2ZQ=bn]jJQV<Zn[L77c9F=I/[@`@:`/kL02<6c[IFQS]c7Xa4V2P0001XB
514L2PT950894PX01@0000T950TB2PT92PTB2P042@T:01DJ2@X/4P0J4Q@J
2@X/4P0J2@X/71@/4P0J2@X/4P0S70XJ2@X/71@J2@X/4P169PXm4PXS70X/
4P0S70Xm4PX00R<L2P0@6PT:8a`:8a`:;1806PT:?A8:8a`:6PT:?A`:8a`:
?A`:;180?A`:;2HD;180b]3FHLc<c004IVIVR<2hR<2hB9280@00000000B8
`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT03YVIV@;no_l07?kmooooooom
n_Ocj^?Kd<o6]L2cX:jNQjRDNkZUR]RnXncA]?SM`?oTbo[E`__Fa?kGb?kI
aooHbOgHa_gFao_Fa?kGb?gHa_kGb?gHa_kGb?gHaPCnelP0;OkFb_kGb?kF
b_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kG
b?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kF
b_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFb_kGb?kFbP02o]O801gm
f<KnelSmf<KnelSmf<KnelSmf<Kme/OlelGme/Oke/CleLKjeL?ke<Gie<7l
f;kogl?ohlKff;cI_Z6kXhN/V7n[VhBo/9g?`k?WgmCgln[nn_OooOh00ooo
oi>IVIT00oooolc<c<c<c01Mc<c<0Q4L2P046PT:4A`:6PT:6PT:0Q4L2P08
2@T:4A`:2@T:4A`:;1802A8:2@T:4A`:0PT92P04;1806PT:4A`:4A`:0QX9
2P8A70X01PT92Q4L2PT92Q4L2P00014V2P<92@X012`B00T92PTB2Q4L2P89
2@X24A`:00H92@X94PX92@X92@XA70X94PX22@T:0Q4L2P8S9PX02a4L2QXV
52`V52`V52<_7TIE:F1N<dI17Q4L2R<L2PTB2P024A`:00@92@X94PX92@X/
71@22A8:014A70X94PYkSFJEXHi6C3d0000971@94PXA9PYGSEaZNfmPLW^V
ZZf`/kN3V8jEZZf`/kL00XfHSP08YZ6HCfM7CfM7LXeLEfMB`K>]`K>>g;>S
0/6c[@05/:Z4Phf4AUDY;3PY4BH:00<000009B`h:G:=G:JQV79bNjJHKiFQ
SP0000TB2PT950TL51XB514V7PTB2QXB50T950TB2PT92PT952`V52<L2QXV
52<L2R`L52`V52`L51XV52<_7R`V514V2QXV52`V54I17S@_:F11:LZn[McS
e_Koo`02kNgZ00?LhmKLhn3]kNX00^gfm@06m_oekOKekNgZg>?FkMW<m_oo
0ng]jP07kOKeg>?FkNgZkNgZm_oo;6ML0000008J4Q@01fYE7X=k<dHV58=k
<l6QQ<6cSZJHQ002`K>>00c1al71/jf`ZXB`/kNVV8C1al71/jfVXIS:d<71
/hhJ9Q@000024A`:00P92@XJ2@X94PX92@XA70X94PX92@X94PX32@T:00L9
4PXA70X92@XJ2@XA70XJ2@XS70X00R`B008J4Q@00b<L2QX92R`B0002;180
00<m70Xm4PXS9PX00QX92P06?A8:Ea`0?A`:;1806PT:6Q8D0R`B00058a`:
8bH:;1806PT:?A8:008m70X01DHV53dL2SdL2R`B0<[@eP1Qc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0>
VIVI01klo_olooonooono_kmnOK`jN7FcKk0/j2[VhB^VWo2ZhcRajWifkWk
f[Oedk3cc[7le/?leLKoeLWnelSoe/[leLKmdlOjdlCoeLWme/OoeLWme/Oo
eLWme/L4omG902goe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_o
eLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWo
e<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_oeLWoe<_o
eLWoe<_oeLWoe</00_oEb@0MoMK7omG9oMK7omG9oMK7omG9oMK7omO;omS9
omO;o]O8omG9oMK7omG9o]C4nM2jm<ndmM:do=^ln]^lhlVX`JZ:YY=c/Z:8
`;BNeljmk^OMnoKboogn00;oo_l00ooooiVIVIVIV@2AVIVI00?oooo<c<c<
c<`0GLc<c0<A70X040T9514L2PT92Q4L2QX92PTB2QX92Q4L2QX92PT92S@_
7PTB2R`B014L2R`B014L2P8J2@X01PTB2QX92PT92R`B00T92PTB2P892@X0
0`TB2PT92QX92P042@T:00DA70X92@X92@X92@X94PX010T92P034A`:2@T:
2@T:008A70X22A8:00<A70XA9PXJ2@X00R<V2P064BH:8blN6Q8DH5hcAUDY
;2HD0a4L2P058a`:4A`:4A`:2@T:4A`:00892@X020TB2PT92QXV57^=IVYk
KiFQSTIE:@TB2P80000064IWG61N<a4V2W9bNiFHXfYbG;2c]jJZXl[@eW9b
NfYkKhfHSW^=Q6YkKdINAjJZXl6cSTIE:JJQIR<_:B<_7TIE:C@_<cAE:@89
2A@03PTB2PT92R<_7UN=G4mbNg:=Q8>H[EN=G00001XB50T951XB50T92PTB
2P892A@01AXB50T952<_7PT952<L2P026PT:0a4L2P038blN;2HD;2HD008J
4Q@01b`L51XV52<_7R<V2X=kG=cSe^gfm@02kNgZ00CLhn3]kN[]kN[]kNX2
kOKe00?fooo]kN[LhmH00]cSeP03m_ookNgZkNgZ00C]kNX08NgfmOKoodmW
G000014V7THV56YW<fYE7ZJ4D[VHG<6cSXf=Kk24I/[@`L6c[JJHKm?IeZJH
Q;2ZQ=cSh;2ZQ<[@e/6c[H=k<`0000T92PTB2QX92PT950T92Q4L2PT92Q4L
2P022@T:01hJ4Q@94PX92@X92@X94PX92@X94PXA70XJ2@X94PXS70XJ2@XS
70XJ2@X/4P0m4PXJ2@X/4P0J2@Xm4PXJ2@X/4P169PX/4P0/71@/4P0S70Xm
4PX/71@S70X2;18000//71@m4PX/71@/4P0/71@/4P0S9PX/4P0S70Xm70X/
9Q@00SdB2P03`LO1c<c<c<c<05o<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00jIVIT04__moocoookooocl
o_Kck^KOeL[1/;JWTZBCNL:[S=c2XN_:Yo?A[?oL]_oO^?oJ^__A`OcAb0;m
d/T<o]?:<?oBc0_ndlX4oM;900omdlGohlgof[kid[?fd[3fe:o[cJOE_9C1
[HRXV7JdYX_<`JgXh=?km_;oo_l00_omo`03ooooVIVIVIVI096IVIT00ooo
olc<c<c<c01Mc<c<00XJ4Q@94PXJ4Q@A9Q@J2@XA70XJ4Q@94PXJ2@XA70X3
2@T:00T94PXJ2@X92@XJ2@X92@XJ2@XA70X/4P0J2@X00Q4L2P056PT:2@T:
4A`:2A8:000000H92@X01PTB2PT92QXB514L2PT92Q4L2P<92@X011X92PT9
2PT92R`B00<92@X00aX92PT92Q4L2P024A`:00Pd;ahJ4Q@J9Q@J71i6GTMP
GS</9Q@94PX34A`:00HJ2@XA70X92@X94PX92@X94PX22@T:034S;aikSHAP
LW^`/kNEXHi6EBT0000971@A9PY6Ie`d;bU?LW^EZZfVZZf`_/6V/l7:d=JV
ZZ>EXHibLW^EXHj=V8iZLUaZNfoLhmH0002EV6HS;ai?Ie`mGSdS;aiZLU`J
9Q@92A@A70X00016C3eZNhAbSHB3V8hA9PX000092A@A70X94PX92@XA70X9
2A@A9Qh00PTB2P096Q8D2@TD2A8:2@TD4A`:8a`:4BHD6Q8D4A`:008J4Q@0
0`TL52`L52<_7P026RHD00HJ4Q@S;ajVV8C]kN[]m_GLhn03kNgZ0^gfm@05
kNgZooookNgZg>?Pi=3<00;]kNX01OKoongfmNg]j^gfmOK]jP02kOKe0_Ko
o`0IPiR>4BH:LSPDJVLcH5hcPehDdkj>/:Z4^IQLb]31g>?PYYQ_g>?P`LO1
YYQ_g>?PYZZSi=3<`K>]g<NSLXeL00002@TD2@T:4A`:00892@X0114L2PT9
2PT92PTB2P892@X00`TB2PT92PT92P022@T:010A70X92@XJ2@XJ2@X/4P0J
2@X/4P0J2@X/4P0J2@X/4P0m4PXJ4Q@S70X/4P0/71@2?A8:01L/4P0J2@XJ
2@Xm4PY69PX/4P0J2@XJ4Q@J2@X/4P0J2@X/4P0m4PXm70XS70Xm70Xm4PXm
70X/71@m70Y69PXm70[1al`0HLc<c004IVIVR<2hR<2hB9280@00000000B8
`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT03YVIV@0Cn_koo?koo_kon_[l
l>gXgMO;`kRV[in8[IYlbk:CilVUlLnYmm6ZoMJ]omF[n/n]omK8o]G?oMC>
00;neLl00ooFd?oGdOoHdP08omK@<?oEdPSoe]02o=?=1OgDcP0BomK:m/Vd
om6gomblomnknmRbjl^Rf[nDc;N</Imi]:F6a;RPgmK7m^oYoo[noo_oooco
oooo19VIV@800003VIVI0P0000:IVIT2000000BIVIT00000002IVIT20000
0YVIV@800002VIVI0P0000:IVIT5000000>IVIT0000000000YVIV@800002
VIVI0P0000:IVIT400000iVIV@800002VIVI100000NIVIT400000iVIV@D0
0002VIVI100000>IVIT2000000>IVIT0000000000YVIV@@0000/VIVI00?o
ooo<c<c<c<`0GLc<c00C4A`:6PT:6PT:6Q8D2@TD6Q8D2@T:6PT:4A`:2@T:
4A`:6PT:2@T:6PT:2@T:6PT:2@T:6PT:4A`:00<92@X26PT:00@A70X92@XJ
2@X94PX32@T:00@S70XA70X92@XA70X22@T:00<A70X92@X92@X010T92P04
2A8:2@T:2A8:2@T:0Q4L2P<92@X02aXB514L2Q4L2R<V2QXB514V52`L561N
<dIE:B`h:B<L2P044A`:0PT92P<94PX00a4L2PT9514L2P02JW]_02Z3V8jV
XIREZZf=SFl0000971@/C2U6IeaZNfnEZZf`_/6EV:>`/kO1albEZZf`/kNV
ZZ=kSFH/>2UGIe894PX971@92@ZEQ58m;ceGIe9PGS<S;aj=SE8dEBT00009
4PXJ4QA6Iea?LW]ZNhA6GTL94PX971@A70X92A@971@22@TD00H94PX92A@J
4Q@92A@A70X94PX22@TD00<J4Q@92A@A70X00QXB500<2@T:6PT:4A`:6RHD
;1`D6RHD;1`D6Q`N8a`:g;>SkNgZkOKe0^g]jP03g>?Pm_oekOKe00;]m_D0
2OKomMcSh=bn]mcSe^g]j]cSh?KomOKoong]jP03kOKe01KfooG]m_Gfoon`
/kLS9PZ3Nc=PGS>EEACC_XjVV6niV5c:d<7C_Xk:d<7:_ZgTal7]kN[:d<7]
kN[:_ZgCfMIkSFH2000000DJ2@X92A@A70X92A@94PX00PT92P034A`:2@TD
2@T:00@92@X00`TB2PT92PT92P022@T:0aX92P06;1806Q8D;180;1`D6PT:
;1`D0QX92P07;1808bH:8a`:?A8:ARH:?A8:4A`:008J2@X2?A8:0R`B0007
;1`D;1808a`:;1`D?A8:ARH:6PT:008m70X01R`L53dL2THV53dL2SdB2/[@
`F7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003
IVIVc<c<VIVI00jIVIT06?clookoooonooWgn>gXi=WAa/6bWjnKP<bfTLba
Q]NfRNk:V_cFZOoF[?oI/OoO_ooF`_cEa__DaO[Ba_WAaO[Ba__CaocDb0Sk
dlL`oM;9027kdlOje<OkdlOje<OkdlOje<OkdlOje<OkdlOje<OkdlOkeLSl
e<Sle/WmeLWoe/CoekkoekSoekGmeK7gdJ[/bIoM_Y3?]8G3[X>mZhG1/iKG
c;S^iMkiloGnn?ooo?ooo_l019VIV@800003VIVI0P000004VIVI00000000
VIVI0`000003VIVI0000000000:IVIT200000YVIV@8000000iVIV@000000
0002VIVI0P000003VIVI0000000000:IVIT200000YVIV@8000000iVIV@00
00000002VIVI0P000003VIVI0000000000:IVIT200000YVIV@800005VIVI
0P0000:IVIT2000000>IVIT0000000000YVIV@8000000iVIV@0000000002
VIVI0P000003VIVI0000000000:IVIT2000000>IVIT0000000000YVIV@80
000[VIVI00?oooo<c<c<c<`0GLc<c00=6PT:4A`:2@T:6Q8D4A`:6Q8D4A`:
2@T:4A`:2A8:6PT:4A`:2@T:008A70X030T92QX92PTB2QX92Q4L2QX92Q4L
2PT92QX92PTB2R`B014L2P892@X010TB2PT92PTB2PTB2P892@X011X92PTB
2PTB2Q4L2P892@X0314L2PTB2Q4L2PT92Q4L2PT92Q4L2QX92PT92Q4L2PT9
2Q4L2P892@X24A`:00/92A@S;ahd;bUGIe8mGSdS;bTJ9Q@A70XJ4Q@A9Q@A
70X00`TB2P892@X0;@TB2PT92PTB2S@_<g^=Q:JZXk2c]jJZ[L77`A4V2PTB
2Q4V2TmWAdmNIX>H]h>HSYFZ[L[@eVYkKl[@e/77c7^=IP0000T92W:=G000
00T92Q4V57^=IS@_<g9WDTmWAaXB59FQSV1N<`T92PTB2P0005MWDUN=G4mb
NceN?A4V2PT950TB2P042@TD00@92@X92A@92@XJ4Q@22@TD00PJ4Q@92A@A
70XJ4Q@94PXA70X92A@J9Q@24BHD00PJ4Q@J9Q@A9PXJ9Q@S;ah/9QC:d<7f
m_D2kOKe00?]kN[Lhn3]kNX00^gfm@04ooookNgZb]31g>?F1>g]jP04kOKe
kNgZkNgZkNgZ0ngfm@05oooob]3F4BH:JUDNPehD00;C_Xh02lZn[NgIc>gf
mL6cS]cSeXf=Khf=AdINAhf=DSeN?DI17P02000000T92A@94PXA70XA70X9
2@XA70X92@XA70X92@X00PTB2P082@T:2A8:2@T:2A8:2@T:2A8:2@T:2A8:
0PT92P054A`:2@T:6Q8D?A`:;180008J2@X3;18000XS70XJ2@Xm4PXm4PX/
4P0/71@/4P0J2@XS70X/4P02ARHD00@m4PX/71@S70XJ2@X2;18000E69PXm
4PXJ2@XS70Xm70X00R`L5004ARH:ARHD?A`:/;>gHLc<c004IVIVR<2hR<2h
B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT03YVIV@0H
oo_hookkoognoo_ki]cJe<Nn]ZB>/iehaZYhdkEghKmojLF7l<^Fn=>Wo=Rf
oMZlomfmo]bio=Zgo=Viombnomfoomc0o]^o0o_H_003o=Vmo=VkoMZl00;m
f[`00ocI_OcH__cH_P05o=Rn0ogI_`;lf;h3nmNm4?cH_P?kf;`2o=Vm0ogJ
_PSkf;`07__H^_[I^?_H^?[I^?_H^?[I^?_H^?[I^?_H^?[I^?_H^?[I^?_H
^?[I^?_H^?_I]_oK]_oK]?kG/?SAZ_?<YNc5W=njSM:bPLR/O;>MK[j/Q=;4
YncSe?okn0;ooOl00oonoiVIVIVIV@02VIVI0P0000:IVIT200000YVIV@80
0002VIVI0P000003VIVI0000000000:IVIT200000YVIV@8000000iVIV@00
00000002VIVI0P000003VIVI0000000000:IVIT200000YVIV@8000000iVI
V@0000000002VIVI0P000003VIVI0000000000:IVIT200000YVIV@800004
VIVI0P0000JIVIT200000YVIV@800004VIVI0`000003VIVI0000000000:I
VIT2000000>IVIT000000000;iVIV@03ooooc<c<c<c<05g<c<`22@T:0Q4L
2P052A8:8a`:2@T:4A`:;18000892@X010TB2Q4L2QX92PT92P8A70X03AX9
2PT92QX92Q4L2P00014L2R`B00T92QX92PT92Q4L2PTB2PT92P022A8:00<9
2@XA70XA70X00`T92P034A`:2@T:4A`:00<92@X010TB2PT92Q4L2PT92P8A
70X03@TB2Q4L2PT92Q4L2PTB2Q4L2QXB514L2R<L2R`h:FYbG5MWDTI17P02
4BHD00dA70X94PX94PX94PX92@X94PX92@XA70X94PX0001kSHAGIe8A9Q@0
0[2c]`0ZUJZ]`LO<YZZS00002A8:8blYAUi7Cg9kSIR>dmWFUJZ]Y[?1`LO1
b]31JXeL00006RHDLXeL00002A8:6Q`NJW]_CfM7LXeLCfM76Q`NYYQ_AUi7
00002A8:4A`:CfML;6MLAUDY00002@TD6Q8D2A8:2@TD2A8:2@T:4A`:0`TB
2P066Q8D4BHD2@T:2A8:6PT:4BHD0QXB50034A`:6PT:2A`D008J2@X03Q4L
2QXV51XB52`L51XV5611:JJZ[OKfmNg]j^gfmNg]j^gfmOKoongfm@;]kNX2
g>?F00[Td<c]kN[]kN[Lhn3]kN[fooG]kN[fkN[]m_Gfool2kOKe00WooooL
hn16;`[:ZVKL_ZgLhmKokLakSFJESE801`0000892@X00`T951XB51X92P02
2A8:00<92A@A70X92@X00PT92P034A`:2@T:2@T:00L92@X02`TB2PT92Q4L
2PT92PT952`B03dB2R`B01X92R`B03dB2P036PT:00</71@J2@Xm70X00R`B
00048a`:?A8:8a`:?A`:0ULL0006ARH:;180;1808a`:6PT:8a`:0SdL2P03
6PT:?A8:?A8:008m70X014HV2ULL03dB2/[@eV7<c<`016IVIXS0^8S0^4R@
R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00jIVIT2ookk
01SooO[oo?WYg]SEaKJdWh:gW779ZW7G]7;S_WSX`go[ahg_cIobdJkcd[?k
fK?jejgieZkjejolf;CmfKGlf;KkekGnf[[ofk/2om^i0ooL^003omfho]bi
o]^k00Knfk/4ombl0okK^`03oMZjo]^ko]^k00knfk/01?gK^?kL^OkL^OkL
^@CogKX7o]bi0_kL]`Ong;H4oM^e0okL]P0Bo]fdn]N]nmJZn=6Xm<ZRl<JN
j/2Fh;N9e:mkbZUd]9UT^jIgdlFRkNGBoo_googooO_oooko19VIV@800002
VIVI0P0000:IVIT200000YVIV@8000000iVIV@0000000002VIVI0P0000:I
VIT200000YVIV@80000019VIV@00000009VIV@800002VIVI0P0000:IVIT2
000000>IVIT0000000000YVIV@8000000iVIV@0000000002VIVI0P0000:I
VIT2000019VIV@800007VIVI0P000003VIVI0000000000:IVIT400000YVI
V@800002VIVI0P000003VIVI0000000000@0000[VIVI00?oooo<c<c<c<`0
GLc<c00=4A`:6Q8D6PT:2A8:6PT:4A`:6PT:2@T:6PT:4A`:6PT:2@T:4A`:
008J2@X00`TB2PT92Q4L2P024A`:00@J2@XA70XJ2@XJ2@X24A`:00/J2@X9
2@X92@XA70X92@XA70X94PXJ2@XA70X92@XA70X010T92P0=4A`:2@T:2@T:
2@T:4A`:2@T:4A`:6PT:4A`:6Q8D2@T:4A`:6PT:00@A70X02PTB2R<_7VYk
Kh=kG3eN?B<_:A4V2QXV52`L51X92P<94PX22@T:02`J4Q@0002EZZfEQ7/0
000971BV/l6VZZf`_/7CfMH0000A9PXA70XS;bTS@CfEZZf`_/6VZZg:d=J`
_/7ChoE6EBT0000/>2UGSE`92@X00016@Aj3NeaGGVmZNfldEBTmGSfVV8Ab
SCd0000A70X92A@S;bT/C2TA;c<000094PX92A@42@T:00X94PX92@X92@X9
2@X92A@A70X92A@A70XJ71hJ4Q@24A`:01894PXJ4Q@A70XA9Q@J2@X971@J
2@XA70XA9Q@d;bUZIc>VXIS]m_G]kN[]m_GLhn3]kN[]m_D4kNgZ0]cSeP09
kNgZm_oekNgZg>?Pm_ookNgZm_oekOKem_oo00;]m_D01oKoomcSh=>nS]bn
[L[@`G:=?B`V5002000000</4P092A@J4Q@00Q4L2P0;6Q8D2@T:2A8:6Q8D
2@TD4A`:6Q8D2A8:6PT:2A8:2@T:008A70X22@T:00@A70X94PX92@X94PX2
2@T:00DA70X92@X94PX92@XA70X00PT92P076Q8D;1806PT:;1`D?A`:6PT:
;1`D008/4P002aX92R`B02`L53dB2R<L2QXB52`B02<L2SdB2ULL04HV2P02
H2l:0SdL2P0>8a`:;180?A8:?A8:ARH:4A`:ARHDARH:;1`DARH:ARHDARH:
?A`:dmWFHLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4
c<c<00=VIVK<c<bIVIT03YVIV@0Hoogooocooo_kookfk>?Be<BZ[9I_]i][
bJI/eZi`hKQjiKf0j<6:j/JFjl^Rjl^TnMJ`n]B_nM>_n]B`o=FfoMJgo=Fh
nmBg0_S@]P;id[D2nM:c0_[C]003nM:emm:emm:e00Ggd[D2n=>f1?OB]@;f
dK@@mm:e0_KA]0Cgd[D2n=>f1oOB]@;gdk<7mm>a1oKB/00Bm]:^l/nUm<nS
l<VNk<:Hj[nDi[^>gKB0djaebJI^/YAN/I]Ze<BPknCBoo[foogon_[oooko
19VIV@H00002VIVI0P0000:IVIT2000000>IVIT0000000000YVIV@800002
VIVI0P0000>IVIT4000000>IVIT0000000000YVIV@800002VIVI0P000003
VIVI0000000000:IVIT2000000>IVIT0000000000YVIV@800002VIVI0P00
00BIVIT2000029VIV@@0000019VIV@000000000000BIVIT200000YVIV@80
00000iVIV@0000000002VIVI0P0002^IVIT00oooolc<c<c<c01Mc<c<02D9
2@XJ2@X94PXJ2@XA70X92@XJ2@XA70X92@XA70XJ2@XA70XJ2@XA70X92@XJ
2@X/4P0J4Q@94PXJ2@XA70X92@X/4P094PXJ2@XA70X/4P092@XA70X92@XA
70X0000/4P092@XJ2@XA70X94PX00Q4L2P0<2@T:6PT:4A`:2@T:6PT:4A`:
6PT:4A`:6PT:4A`:2@T:6PT:0a4L2P0?6PT:4A`:2@T:2@T:4A`:8blNPhf4
NheVAUDY8blN6Q`N6RHD2A`D4BHD2@T:00<94PX24A`:01@0002EZZekSFH0
00094PY6IebEZZf`/kOLhn1ZLU`0000971@J9Q@A9Qj3V:g:d=J`_/71al6`
/kO]m_D24BH:019PGS=6Ie`A70X94PYbIe9ZNfmbSEb3Ne`A9PYGIe:VZZ<d
EBT0000A70X971@A70XJ4Q@92A@22A8:0PT92P042A8:2@T:2@T:2@T:0`TB
2P0H6Q8D2@TD2A8:2@TDAT4N6RHD4A`:6Q8D6PT:4A`:6PT:2A8:4A`:4BHD
2@TD;1`D4A`:=2lNH5hc`K>]kNgZkOKem_oog>?F1ng]jP05i=3<m_oekNgZ
g>?FkMW<00;]kNX3m_oo00GfooG]m_Gfm_G]m_E6;`X00R`B000:6PT:;180
2@T:8a`:6PT:2A8:4A`:6PT:2A8:6Q8D0Q4L2P032@T:6PT:4A`:00892@X0
11X92Q4L2QXB50T950892@X00a4L2PT92PT92P042@T:00HA70X92@X94PX9
2@X94PX92@X24A`:00<J2@X/71@J2@X00R`B000>?A8:6Q8D;1806PT:?A`:
;180?A`:;180?A8:?A`:?A8:LRH0ARHD?A8:0ULL0009ARH:?A8:8bH:?A8:
?A`:8a`:?A`:;180?A`:00969PX01B`L54HV2THV2SdL2ZJc`@1Qc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VI
V@0>VIVI01[ooOolnOooo?_oo_;ailkDa:2RS5^dUEk5WVGCYV_N[gOS]WoT
^hOW`hoXb9OWb9[[aIk/a:3]aJ;^aZ?_aZK_aZS_aZ[^aJW^a:__aJ`2klJZ
1>o6Z003klJZk/NZk/NZ00c^ajX00ng6ZNk7Z^k7ZP0>k/NZ00?]aZW^aj[^
ajX03>k7ZP03k/NXk/NVk/NV00K^ajH6kLJU01?/aJC/aZ;/bIo]b9cY`iKW
_97U^H[T]XCM/7WCZFo8XFJ_SeJXSUgGaIo_i=3nnO?noOoknoooo_l019VI
V@D00003VIVI0P0000:IVIT2000000FIVIT000000000002IVIT00`000005
VIVI00000000VIVI000000>IVIT2000000FIVIT000000000002IVIT00`00
0003VIVI0000000000:IVIT00`0009VIVIVIV@02000000>IVIT000000000
0iVIV@030000VIVIVIVI00800004VIVI0P0000JIVIT0100009VIVIVIVIVI
V@8000000iVIV@0000000002VIVI0P000003VIVI0000000000:IVIT20000
00>IVIT0000000000YVIV@80000[VIVI00?oooo<c<c<c<`0GLc<c00<4A`:
4BHD6PT:2A8:4A`:6PT:2A`N2@T:;1802A8:2@T:4A`:0`T92P056PT:4A`:
0000;1804A`:00892@X00a4L2PT92R`B00036PT:00D/4P0S70XA70XJ2@X9
2@X00Q4L2P082@T:;1802@T:2@T:6PT:4A`:2@T:4A`:0PT92P044A`:2@T:
4A`:2@T:0a4L2P0I6PT:4A`:4BH:4A`:2@T:4A`:2@T:8blNUIRSPg]LJW9L
8blc;4`Y6RHD6Q8D4A`:2A8:2@T:2A8:2@T:2A8:2@TD0000UJZ]SHe_0080
00003a4L2SeN?IFZ[L[@e/77c6Z=G000014V2P0008>H[L[@eYFZ[JJc`L77
`McSh002000000aZSEa6C3dS;ahJ9QBEV6I6C3f3NeaZLU`A9PZ3Q7_1/hhA
9PX22A8:00@J4Q@92A@94PX92A@82A8:00<92@X92A@94PX00PT9500:2@T:
=2lNAUDY8blN6PT:4BH:4A`:;2HD4A`:6PT:0QXB50064A`:4BH:6Q8D8blY
JVLcb]310ng]jP03i=3<kOKem_oe00C]kNX00mcSe^g]j^g]jP02g>?P00?]
kN[fkN[fooD01?Koo`;]m_D02Oooob`B04HV52`V53dL2R`L514L2QX92PT9
2P026PT:00<94PXJ4Q@A70X00PT92P056PT:4A`:2@TD4A`:2@TD00892@X0
0b<_7P0001XB50022@T:00<94PX92@X94PX00`T92P052A8:2@T:2@T:2@T:
2A8:00892@X02QX92PT92R`B02`B02`L52`B03dL2R`B02`L51X92P8/4P00
1THV2R<L2SdB2V0_2ULL060_509G70001V0_2THV2SdL2THV2QX92R<L2P8m
70X00eLL014L2THV2P05ARH:00=G703:d=K<c<`0H<c<c004IVIVR<2hR<2h
B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT03YVIV@0F
o_con?OooO_loog^mNc;fL^LW8=;[he@`IMMd9mWg:UdhJmlhKJ1iKj7h/>:
hlB>il6Djl6IkL>Mk/BNk/>Pk/>Q0^k3X`;_a:@2k/>S0^k3X@03k/>Pk<BP
k<BQ00g/a:42kLFR4>c4X@;]aJ8>k<BQ2>c4X004kLFQk<BPk<BPk<BP0^_3
W`0Cj/:NjL>Li/>IiL>Ei;j?hKN7h[B2h[5ifjY_dj=Ua9]M[HU?WX9@flNR
l^GBoOSbookooOgoooko00BIVIT2000000>IVIT0000000000iVIV@800002
VIVI0P000004VIVI00000000VIVI0P0000:IVIT200000iVIV@@00002VIVI
0P000003VIVI0000000000:IVIT200000iVIV@@000000iVIV@0000000002
00000YVIV@@00005VIVI0P0000NIVIT400000iVIV@@000000iVIV@000000
0002000000>IVIT0000000000YVIV@@0000/VIVI00?oooo<c<c<c<`0GLc<
c00G4A`:6PT:4BHD6Q8D6PT:4A`:6PT:4A`:6PT:2@T:4A`:6PT:4A`:6PT:
4A`:6PT:4A`:2@T:6PT:2@T:;1802A8:;180008J2@X00a4V2QX92Q4L2P02
2@T:01DA70XJ2@XA70X/4P092@X/4P092@XA70XJ2@XA70XS70XA70XJ2@X9
2@XA70XJ2@XA70X92@XA70XA9PXJ2@X00Q4L2P0V8a`:6PT:4A`:4A`:2A8:
;1808blNNheVSIR>LW9kAUDY8blY2A8:4BHD2A`D6Q8D2A8:2@T:4A`:6PT:
6Q8D0000LXf4YZZS2A8:2A`D4BHD0000LXf4/;k1`LO<`LO100004BH:0000
?G:4/;>gYZZS0/77c00B`LO100002@T:SHe_4BHD4BH:H5hcUHAk?EhmSHe_
JVLc8blNJW9LH5hc00002@T:2A8:4A`:0PTB2P054A`:2A8:2A8:2A8:2@T:
00<94PX040T92Q4L2PT9514L2QXB500003@_7X=kG8f=AdI17PTL52<L2QXV
52<_7QXV514V508A70X03AXB52`V514L2QXL7X=kG<[@`McSh>gfmMcSe]cS
h>g]j_KomMcSh006kNgZ00GfkN[Lhn3LhmKfooG]m_D01?Koo`04kOKem_oo
ooooARl:0THV50048bH:ARHD8a`:8a`:114L2P036PT:2@T:4A`:00892@X0
214L2PT92PT92Q4L2PT92Q4L2R`L514L2P892@X0114L2PT92PTB2PT92P89
4PX02aXB50T92PTB2Q4L2PT92Q4L2PTB2QX92QXB52`B02<L2P05;18000<S
70XJ4Q@S70X00SdL2P8m4PX04THV2ULL078V03dB2ULL060_2ULL03dB2THV
2QXB52`B04HV54HV2SdB2Q4L2THV2SdL2THV50=69PX00cdB2/[@e/c<c01P
c<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIV
I/c<c9VIV@0>VIVI01?lo?ognOono_knnn[klloTe:>HOTFWPdFnT5C<V5oG
XVcLZGCM[WSM]WgJ^WoI^X7U`HgY`iC[aIP00^g6V`03k<FLk<FNkLJO00?[
a9d2j/>L0^[3VP03jL:Ij/>JjLBJ00KYa9X00nS3VNW4V^W4VP02jLBJ0n[5
Va3Ya9X2j/FK00gZa9gYa9[Y`icYa9[Y`icX`iWZa9gZaI_Za9gZaI_Za9gZ
aI_Za9d00^[5V`0Pj/FIj/FKj/FIj/FKj/FIj/FKj/FIj/FKj/FIjLBJjLBH
j<>Iil:Fil:Hil:FgkjAgkf?g[R7g;=ogJifg:Y_eJ9QbiYH_8m>ZH97VG]9
i=2[nNgGoo_bookoo?ooo_oo19VIV@800002VIVI0P0002fIVIT200003IVI
V@800002VIVI0P0000nIVIT200000YVIV@80000bVIVI00?oooo<c<c<c<`0
GLc<c0086Q8D4A`:6PT:2@T:4A`:6Q8D4A`:2@T:0QX92P0>2@T:4A`:2@T:
4A`:2@T:4A`:6PT:4A`:2@T:4A`:6PT:2@T:6PT:4A`:0QX92P082@T:;180
4A`:;1802@T:4A`:6PT:4A`:0PT92P8J2@X020TB2QX92PT92PT92Q4L2PT9
2Q4L2PT92P<A70X00aX92Q4L2Q4L2P034A`:00hS;ahJ4Q@92@X94PXA9QAZ
Nfn3SHB3Q8i6EBT/C2TS;ahJ9Q@A9Q@92@X32A8:0Q4L2P0R2A8:NheVYZZ]
;3PY00004BH:2A8:?EhmPiR>/;k1b]3F00002A`D4A`:2A`NUJZ]YZZ]b]3F
SIR>4BH:2@TD4BHNUIQV2A`D2A8:AT4NPhB>EfMB=5DY00002@T:00002@TD
2@T:0PTB2P044A`:2A8:2A8:2A8:0`T92P894PX01@T950TB2PT92PTB2PT9
50022@T:01Ld;bVELTN=SFmkSFJ3Nc<94PXJ9Q@/C2T/9Q@J9Q@J4Q@A70XA
9Q@J2@XA9Q@92AAZEAjVXIS:d<7Lhn3]kN[LhmK]kNX00^gfm@08g>?FkNgZ
kNgZkNgZg>?Fi=3<kNgZkOKe0ng]jP03m_Kem_oom_oe00;]kNX2m_oo00Co
oon3NeaG701P;a@2?A`:01XS70XJ2@X/4P0A70XJ2@X92@XA70XJ4Q@92@XA
70X92@XA70X92@XA70X92@XA70X92A@J71hJ4Q@A70X94PX92@XA70X94PX9
2@X94PX22@T:00<94PX92@X94PX00`T92P092A8:;1806Q8D;1808a`:;180
8a`:;180?A8:00</4P03?A8:00=69PY69QAP;a@00V0_2P0CARHDLRH0H2l:
8bH:8a`:6Q8D;180ARH:ARHDARH:6PT:ARH:?A`:ARHDARH:H2l:ARH:Ea`0
g>?P067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<
c003IVIVc<c<VIVI00jIVIT06?_mooSlookooocjjoohfO3O/iQmAZ9l?[:4
A/6>ClnIGMBPI]FWK=J^LmJcNM>eNMBdNmZgPMfjQ=nkQmjjR=fiRMjjR]nj
S@?S_Y401N>oSn:nS^:nS^:nS]nnR`08h;n<00CO_X_P_hcP_hcP_h`4hL2=
4>2oS0;Q_hl03N6oTN6oSn2nT>2nS^2nT=nmSN6oTN6oSn6oTN6oSn6oTN6o
Sn6oT@02hKn?00oQ`8gQ_hoQ`8gQ_hoQ`8gQ_hoQ`8gQ_hoQ`8gQ_hoP_hcO
_HgN_H[N_8cM_H`00]NgR00?f;:1eZegeZQ]e:9SbiQF`Hi</X92Y7a1UgQ9
l]bgooKPookeo_ooo?ooo_oo00BIVIT200000iVIV@80000]VIVI00<0002I
VIVIVIT039VIV@@0000AVIVI00<0002IVIVIVIT00P0003:IVIT00oooolc<
c<c<c01Mc<c<00TJ4Q@J2@XA70XA70XJ2@XA70X92@XA70XJ2@X00Q4L2P05
6PT:;1808a`:2@T:6PT:00892@X012`B014L2PT92PT92P8J2@X01B`B02<L
2Q4L2QX92PT92P026PT:00lA70X92@XJ2@X92@X/4P0A70X92@XJ2@X/4P09
2@X/4P092@XA70X92@XA70X00PT92P0G6PT:4A`:4A`:6RHD4A`:;2HD6RHD
;2HD2A8:4A`:2@T:2A8:SHe_Nhf4Phf4JW9LEeEB8blY8blN2A8:4A`:2@T:
4A`:00892@X24A`:01m?GVJEZZfEXHh971@0000A9QhA9PX0002EZZg1/jd0
00094PX92A@00023V:g1al56GTL000092@XA9Q@S;aj=SFl000094PX/9QA?
IdNEQ7/000094PX/71@92@X00`TB2P036Q8D6RHD4BHD00L94PX060T92PT9
514L2PT92Q4V51XV58f=Ahf=DW^=IVYbG9F4Nh=kG3AE:DI17S@_:B<_7R`V
51XV514L2QXB514V514L2PT92Xf=DP;1/jd2kNgZ00?Lhn3]kN[]kNX01>g]
jP03g>?PkNgZi=3<00;]kNX04=cSe^g]j_KomOKoooKomNg]j_K]j^g]j^gf
mOKooooooiF4NdH_2V0_2THV2SdL2P8S70X36PT:00DA70XJ2@XJ4Q@J2@XA
70X00PT92P054A`:2@T:4A`:2@T:4A`:008J4Q@01A4V51XB514L2QXB50T9
2P022A8:0Q4L2P072@T:4A`:2@T:2@T:4A`:2A8:4A`:008J2@X00b<L2SdL
2SdL2P02?A8:00Pm70Xm4PXS70X/71@m4PY69PXS70Xm4PX2Ea`000U69PYP
;aAG701b9P1P;a@m70XS70X/4P0/71@00SdL2P06ARH:4A`:ARH:H2l:ARHD
?A`:0THV5003Ea`0dmWFc<c<063<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00jIVIT06OWooo[nookooocj
k_omhoSV`YUmCIei?jMi>kN4@lJAClfJFM2RI]>[L=>`N=6bNmFfOmVjPmfn
R=joRMfmR]blRmfmS]jnSmbkSP02g;b=0]^kRP;J^XT00mVkQmZlR=ZlR006
f[b80mVkQ`;J_8P3fkf94=ZlR003fkf;fkb=fkb=00;J^h`3fKZ;1m^lS@_K
_H/2f[b:01GI^hWH^XSG^HOG^HOA/X?B/X?C[W[AZ73AXfO>WE_4TDnhQdBW
NC^ON46GN4[ki<Coo>WoooKnoookooonool0TiVIV@03ooooc<c<c<c<05g<
c<`01A4V514L2PTB2QX92PTB2P024A`:00<J2@XA70X92@X00QX92P032@T:
6PT:2@T:00<A70X26PT:0Q4L2P032@T:6PT:6PT:008J2@X02B`B014L2Q4L
2Q4L2R`B014L2QX92Q4L2P0000026PT:00LA70XJ2@X92@XJ2@XA70X94PX9
2@X01A4L2P034BHD;1`D6RHD00<S;ah07QXB514L2Q4V500004mNIW^=IW9b
Nh>=Q8=kG3AE:B<_7Q4V2PT951XB50T92QXB514L2PT951X92TINAg^=Q9FQ
S[2ZQ0TB2P0000TL500007^=Q9FQSP0000894PX05a4L2RaEG14V7P0000T9
2PT95000079WDX>4NeMEDQ4L2S@_7THV2/77`G8V00T92/77`ELL00T951XB
50TB2PT92PT950042A8:00<92A@94PX94PX00PTB2P0A4A`:2A8:2A8:;1`D
8blYAUDYH5hcPhAkLXeLSHeBH5hcCfM7UG97LXdm=2lNH5hc=2lY008J9Q@0
1a4V51XB514V56YW<jJZXl77`McSeP02g>?P1Ng]jP03g>?FkNgZi=3<00;]
kNX04]cSh>g]j^g]j_KomOooomcSh?KomMcSe^g]j_KomOKoooooog9WDW8V
078h55LL04HV2SdL2P8S70X26Q8D00hA70XJ2@X92A@92A@A70X92@XS70X9
2@XA70X92A@92@XA70X92A@A70X22@T:00<J4Q@/9Q@92A@01`T92P034A`:
2@T:2@T:008J2@X01B`B02<L2R`B02`L52`B0002?A`:0SdB2P04;180?A8:
ARH:?A8:0THV2P0>Ea`0ARHDEa`0Ea`0H2lDEa`0ARH:?A`:4A`:ARH:Ea`0
4A`:ARH:4A`:0dHV2P05Ea`0H2lDH2lDEa`0b]3F067<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00jIVIT0
6?Wooo7fnOcooooon_onlOo`ekfSOXm^>j9i>jAe;k20=]6QFLBHEmV`N>W5
TmRhRM^oSmNmR]RnSMo4UN;7V^76VN;7W>G:W`?QaId2hLJK0^76V@;QaYL7
glNG0]k6UP04glNGh<RHh<RHhLVI0^;:VPoPb9P00n38V]o7Vmo7V`0?glNK
1mo7V@;Tc9h2hl^M01GQbI_MaIOG_i7D^HcR`iGP_Y3F/WkV_hK9WF30Te:g
QdFVNCR?IB^FL3nlWgOonMcom>;kn>onooofn__nool0TiVIV@03ooooc<c<
c<c<05g<c<`011X92PT951X92Q4L2P8J2@X22@T:0Q4L2P062@T:6PT:6Q`N
4A`:2@T:;1800QX92P0:2@T:4A`:6PT:2@T:4A`:6PT:4A`:6PT:00004A`:
11X92P066Q8D00008a`:2@T:6PT:2@T:0QX92P04;1806PT:6PT:2@T:0a4L
2P076PT:8a`:8a`:4BH:8blN8a`:6RHD00<S;ah031XB514V50T92S@_:DmW
G8fHSX>HSX>4SUN=G3@_:B<_7PT9508A70X01@T950TB2PT92Q4V52<_:@02
JW]_00NEV:=kSFHA9Q@92A@dECdA9Qi?Ie`00`T92P0Q=5DY2A`N4Blc4A`:
6Q8D2@TD0000AUDYCfML`LO<00008bH:;180`LO<`J64?A8:UIRSong<0000
4BH:4A`:2A8:4A`:2@T:2@TD6Q8D2@T:6Q8D2@T:2@TD2A8:6Q8D2@TD008A
70X072`B02<_:A4L2V1N<g^=IX=k<eMEDV1N<hf=DXfHSZJHQ8f=AfYW<dIE
:C@_:A4V7PTL51XL7PT954I17ZJQV<6c[McSh>gfmMcSe^g]j]cSh=cSePC]
kNX00mcSh>C@c>g]jP03kNgZ00?fooofooG]kNX00ng]jP?fool2PcP00123
;`1b>1AG700m70Y69PXS70XJ2@XS70X92@XJ2@XA70XJ4Q@92@XA70X92A@J
4Q@62@T:00<A70X92@X92@X00PT92P032A8:2@T:2@T:00D92@X02@TB2Q4L
2PT92Q4L2QX92SdB2R<L2R`B02<L2P03?A8:00Hm70X/4P169PXm70Xm4PY6
9PX4Ea`000M69PZ3;`1P;`Xm70X/71@/4P0/71@00SdL2P03ARHD6Q8DARHD
00=69PX014HV560_578V0<[@eV7<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00jIVIT02__ooO[oo?coooon
o?ohmOoik]_6ZgmR>91/<YM_:@:eRCh03>_2P=ffOmNbQ^g=Y^S<Y>?:XNC;
XnS?Yn[@ZnO=Z^O=[>W?[P;[d;82jm6`0^_A[P;[dJ`8j]:/0^K>Z0;WcjT0
1>S@Z^WAZnWAZn[B[13Xd:X00n[B[^[B/>[B/00=j]:`2>[B[P03i/jZiLfY
i<bX00;UcJT05>C<Z>;:Y^37Wn_;X^W7VN[6T]fiOm>[KJb3@jV0@99Z;I9]
>HMV>mc2XOohh?onkooom_Wkn?Okn_kooi>IVIT00oooolc<c<c<c01Mc<c<
00<J4Q@A70XA70X00QX92P074A`:6PT:4A`:2@T:6PT:4A`:6PT:008A70X0
1AX92PT92QX92Q4L2QX92P024A`:00L/4P0J2@XJ2@X/4P0J2@XA70X/4P00
0QX92P0;4A`:2A8:;1802@T:4A`:6PT:4A`:;1806PT:2@T:;180008J2@X3
2@T:0a4L2P064BH:8blN8blN8blN6RHD4BH:0R<_7P0K6RHD4BH:;1`D8blN
AVMLPhB>SIR>Phf4JW]_CfM7=5DY4BH:2A8:2@T:4A`:2@TD4BHD8blNAT`m
AUEBCfMLNheVCfML;3PY=5Dm4BHD0000008S;ah010T92Q4V51XV50T92P89
9RT040TB2Q4L2QXL7TI<?EMED/[@eZIbDP0003dL2[1kI^C@c;1k:DHV5>gI
c7]<500000894PX02`T92Q4L2PTV:@TL50T92Q4L2PT950T92QXB50TL50T9
50022A8:00HJ4Q@A70X92AA6EBTd;bUZIc<2Pg]L0ZJHQ00</:Z4SHe_LXdm
H5hcJUDNH5hcAT4N4BH:4A`:6Q8DPhAkb]310^g]jP?Lhn04g>?F00CLhn3L
hmK]kN[LhmH2kNgZ00?]m_Gfooo]kNX01>g]jP08m_oooooo`LO<Pd40Pbl0
UED0Pbl0H2l:0THV2P0;;1808a`:6PT:4BHD4A`:6PT:6Q8D4A`:2@T:4A`:
2@T:008A70X22@T:00DA70X92@XA70X0000A70X00PT92P<94PX010T92PTB
2PT92PTB2P892@X01@TB2PT92R<L2QXB52`B0002?A`:00L/4P0m4PY69PY6
9PXS9PXm4PXS70X00SdL2P969PX02SdB2V0_55LL04HV2V0_2X<_04HV2SdL
2R<L2THV2P8m70X015LL02<L2SdL2ULL00969PX2H2lD00=G703CfMK<c<`0
H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT03YVIV@0Hnoogo?ojnogloooonoKjoocjooOYZ95aRF/gME<C
TFdS^I=:a9iOom^Vi/>Kk<^Zj/f]i/f^ilj`jLndjLnfilfdi/bej<jg1>S=
^0;Xc[L:j<je0^O=]0;Xc[D01>W?]^[@]n[@]n[@]a3YckHHj<jg01W]dkc[
dK[Zd;WZd;W/d[_]dkc/d[_]d[G[bjCU`iGW`hoXaHgQ_H6ROT:AKSB9J3>1
HSJ]Tg;olm_onNWoo?7oooSooo_mookoool0TiVIV@03ooooc<c<c<c<05g<
c<`0214L2QXB51X92PTB2Q4L2QX92Q4L2QX92P8A70X00aX92Q4L2PT92P02
6PT:00<A70XJ2@XS70X00aX92P0B2@T:4A`:6PT:8a`:6PT:;1806PT:;180
4A`:6PT:;1806PT:;1802@T:;1802@T:6PT:2@T:0b<L2P066Q8D2@T:2@T:
4A`:2A8:4A`:0R<_7P0J8blY;3PY;3PY4BHD4A`:6RHD4BHD8blN;3PY=5DY
6RHD;3PYJW]_SIR>Nhf4LW9kNhf4AUEB6RHD00004BHD2@T:4A`:6RHD6Q8D
AVML0TINA`06AVML4BHN8blY4BHD00002@T:0Q4V50036Q8D4BHD4A`:0089
2@X0>B=1DQXL7Q4L2[2ZQ2`B0611:McSh>C7`@0004H_2ZIbD]bn]mbn[ELL
0<6QQ=cSeSdL2Q4V2PT9514L2P0002aN?@00014L2PT92PTB2Q4L2Q4V53@_
7S@_:@TB2PT92PT950TL514V51XV51XB53AE:IFQSW:=?G9WDVYW<g9WDTmW
Ah=kG9j4IZJZXjJHKhf=DQ4V2PT9514V7V11:McSh>C@c>g]j]cSh007g>?F
00?Td<cLhmK]kNX00^g]jP0<m_ookOKekOKem_oem_ookOKem_ooooookOKe
UG97YT`0UED00X<h0007LRH0H2l:?A8:;1`D;1808a`:6PT:008A70X01`T9
2QX92Q4L2QX92Q4L2PT92PT950024A`:00@92@X94PX92@XA70X62@T:00/A
70X92@XA70X92@Xd;bT92A@94PXA70X92@XS70X/4P000SdB2P05?A`:?A8:
?A8:Ea`0ARH:008m4PX02TH_2SdL2SdL2R`L560_2ULL060_2ULL08<_060_
2P969PX03SdB2SdL2THV2SdL2THV2R<L2THV560_2THV54HV2W8h56Y12V0_
2/[@`F7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<
c003IVIVc<c<VIVI00jIVIT06?oom_cmmocnoOkooo_jooonooomm??Sc::=
HWAI8XMX:9Ug=l:OIMbhQ]fjT^?2XNS;[NO<[n[?]>c@^>c@^^_?^N_?^^gA
_0G[c[`2jlnj00?[ckW[ck[[ckX02>_?^P?/d;/3kM6l4>c@^aW[ckX06>[>
^NW=^>W=^>[>^NW=^>O;]^O9[mfkUOcJ[>K5T]RgPKNGGZ62Bh5V<GEJ;JVA
KoWUcOolkOomm?K_jOkkm_oonokooOoooi>IVIT00oooolc<c<c<c01Mc<c<
00<J2@XA70XA70X00QXB50036PT:2A8:4A`:008J2@X02`TB2QX92R`B014L
2PT92QX92Q4L2QX92PT92Q4L2QX92P024A`:00X/4P0J2@XJ2@XJ2@XS70X/
4P0J2@XA70XJ2@XA70X36PT:00<A70XJ2@XA70X00aX92P03;1802A8:2@T:
00<92@X01R<V2R<_7SAE:C@_7SAE:B`h:@8S;ah00b<_:DIEDS@_<`028blY
01DJ71h/>2V3Q8iZNfn=V8j3SHAPLW]6EBT92A@94PX971@J2@XJ71hS;bTd
ECeZNfm6Ie`A9Q@S;ah94PX92@X00Q4L2P104BHD6Q`N4BHD4BHD4A`:2A8:
4A`:2@TD8d5B6PT:YXAB;180PbmL`LO1ong<2@T:4BH:WW8c`K>>i<O1Ea`0
/8AVm^gZi:ZH00004BH:00004BHD2A8:2@TD2@T:4A`:2@T:6Q8D2@T:=2lc
LXdm8blN8bH:2@TD6Q8D6PT:2A8:2@TD8blNH5hcLUEBCfM7SHe_NheVUHAk
YZ6HUJ6>YZ6HUIQVH5hc6Q8DPg/cH5hc2@T:b]31g>?Pm_oog>?P0mcSeP03
g>?Pg>?Fg>?F00;Td<`01mcSe]cSh?K]j^gfmOKoong]j_K]jP02m_oo00G]
m_GLhn3foonVZZfEE@000jI<0008Pd40PcP0H2l:Ea`0ARH:?A`:6Q8D8a`:
0QX92P0:4A`:2A8:2@T:2@T:4A`:2@T:4A`:00006PT:4A`:0`T92P064A`:
2@T:4A`:4A`:2@T:4A`:0PT92P0B2A8:2@T:6Q`N6Q8D2@TD6Q8D;1808a`:
6PT:?A`:ARHD6PT:;180ARH:H2lD?A8:?A`:?A8:0SdL2P0=6Q8D?A8:Ea`0
H2lDEa`0H2l:LSPD;1`DLRH0ARHD8a`:?A`:;1`D00969PX01B<V2THV2V0_
2THV2ULL0002H2lD00=G703CfMK<c<`0H<c<c004IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P4c<c<0VIVIP03c<c<VIVIVIVI00bIVIT05_oo
n_onn_oooo_loo[moo[koOOdkoookOodehQeBg1F9IQjA[6AG/ZXN_7@YMNg
T=nnVn73XNG6YnK7Z>K7Z^K7Z`;Wajh3ilN`0^O7[P?Wb:`8i/R^1>C6[0CU
ajd@i<J/6>K8[P?SaJ/2i<J/01CRa:[N`:KK_9gC/8SWaIOE]87@/G^LPDY`
FBEVDBB3LDgol]WooNgnlngooO_oo_glnoWloOSooo_ooofCVIVI00?oooo<
c<c<c<`0GLc<c0074A`:6PT:2A8:6Q8D8a`:2@T:;18000892@X24A`:00HJ
2@X92@XA70XJ2@XA70XJ2@X24A`:01DJ2@X/4P0J2@X94PXJ2@X92@X/4P0J
2@X/4P0S70Xm70XS70X/4P0S70XA70XJ2@XA70XJ2@X/4P092A@/4P000R<L
2P044A`:2@T:2@T:4A`:0PT92P0P2@TD6RHD;2HDAT`mEeEB?Ehm=5DY6Q`N
;3PY=5Dm;4`YAT`m;4`Y8bH:2@T:CfMLPhB>Nhf4JW^4JXeLEeEB;3PY2A8:
4A`:2A8:8blN;4`YAT`mAUi74BH:2A8:8blY0PTB2P0U2@T:2@TD4BHN;2HD
2@TD6Q8D4A`:00002A8:2@T:4BHN6Q`NLSPDH44YH2lD`G]km_ooJVLc4BH:
PcP0YW9Bg;>]YW9BUEhcg;jgong<6PT:4BH:2A8:4BHN2@TD4BHD2A8:4A`:
2@T:4A`:2@T:008J9Q@064I17TmWAa4V50TB2PT92Q4L2QXB5000061N<g:=
?F1N<g9WDW:=G8f=KiF4NiFQS/6cSVYbG1XV514L2[2ZQ8=kG6YW<l6c[@;]
m_D00mcSh>C@c=cSeP03g>?F00STd<cLhmKLhmKLhmK]kN[]m_Gfooo]kNX2
m_oo013CfMK1al6VXIQbIe;foonNGQBVI`2VC02`E@2VC02V@@23>01b>1Ab
9P169PXm70X2;18000<J2@XA70X/4P000PT92P034A`:6PT:4A`:00<92@X0
114L2PT92Q4L2Q4L2PH92@X03PTB2PT92PT92PT92PTB2QXB51XL7PTB2QX9
2R`B02`L52`B05LL02`B008m4PX01ULL04HV2R`L52`B03dL2R`L509G7000
260_2THV2V0_2V0_2X<_078V05LL060_2P@m70X00eLL03dL2SdL2P03H2l:
00AP;aAb>01G703:d=IQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^0C<c<`016IVI/c<c6IVI/c<c0fIVIT01?olooonoooooo3dm`;k
ool04^k`jooom?ook?oaehigEg5E;XIV?JZ9G:j=H=FeQ/n_P=JeR=ZiS=Zi
S]RgS]VgTMZhT]VgTPGH]Y43f;J@00?G]i7G]Y?G]Y<07=NfT`;G]i40:mNg
T=NgTMNgT=NgTMNgT=NgTMNgT=NgTMNgT=NgTMNgT=NgTMNgT=NgTMNgT=Ng
TMNgT=NgTMNgT=NgTMNgT=NgTMNgT=ZjU=ZjTmblU]jnUmnoVMfmU]RhT]Jd
S]^fS<ZUN;NGIYn1CHE^>VMC8JjOM_[_dOonkOoilOomoOObmP02ooko00?g
n??ooo_oood0TiVIV@03ooooc<c<c<c<05g<c<`00a4L2PTB2QX92P034A`:
01<92A@A70XJ2@XJ2@XA70XJ2@XA70X/4P0J2@X/4P0A70XJ2@X/4P0A70X9
2@XJ2@X92@X/4P0J2@X00R`B00088a`:;1808bH:8a`:;1806PT:;1802@T:
0QX92P034A`:;1806PT:008J2@X07B`B014L2PT92Q4L2PT92PTB2PT950T9
2QXB52<_7UMWDVYbG4mWG4I<?CAE?C@_<dIWG3AE:@TB2QXL7TmWAdI<?BaW
G7^=Q8>4SVYkQ7^=ITmWAb`h:@022A8:00LJ71h/C2U?LW/000092@X94PXS
;ah00PTB2P042@T:6Q8D6RHD6RHD0Q4V50044A`:2A8:2@T:2@T:0Q4L2P0C
6RHDH2lDLSPD/7]Vm_KeYYR40000LSPDYW9Bg;jgi<O1LRH0g;jgm^gZg;>S
4BH:4BHD4BHN2A`N00<92@X03`TB2PT92Q4L2QXB514V2S@_:G:=?F1N<`00
00T950TB2Q4L2PT92R`h:C@_7P02AUDY00mPGS>3SHBVXIRVV8BEXHj=SDL/
>2T/9QB3NebVXIRVZZg:d<7]m_GfoooLhn002=cSeP0Ai=3<kNgZkOKem_oe
m_oo`LO1YZ6HJW9LLVMBWXAVg;>SkNgZYT`0/5D0YT`0/5D0/78000:VC000
1H<h08<_05LL04HV2SdL2P028a`:0QX92P074A`:2@T:4A`:2@T:2A8:2@T:
4A`:00<92@X00`0000T92Q4L2P022A8:00<92@X94PX92@X010T92P056PT:
2@T:6Q8D2A8:6PT:008/4P0023dB2S@_:CdB2R`B03dB2THV55LL02<L2P<m
70X01CdB2THV578V02`B05LL0002H2l:015b9P0m70YG70169PXm4PY69PXm
4PYP;`Xm70Y69QAb9P169PYP;aAZEAiP;a@m70[1al`0HLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00EVIVK<c<bIVIUVIVK<
c<`039VIV@0HooSooocoo_gomo_lnOoon?omnOojo?oho?S]oogaooKUWhE/
R6]9NUXaS6`kUgPo[he@^9IG_YaM_I]N_9UO_iaT`IiV`9eW1KfJI0>mVV88
^iYU6;fLI`0a^iYT^i]R^iYT^i]R^iYT^i]R^iYT^i]R^iYT^i]R^iYT^i]R
^iYT^i]R^iYT^i]R^iYT^i]R^iYT^i]R^iYT^i]R^iYT^i]R^YUS^YYQ^YUS
_9aS_IaV_9aS^IQR^9APW7I9WgY=SFdlITXHL5XXWi5To?;>oooXn_K[m_Gc
ookolO3hn?Oloooooookooojooom09>IVIT00oooolc<c<c<c01Mc<c<00DA
70XJ2@XA70XJ2@XA70X00PT92P07;1804A`:2@T:6PT:4A`:2@T:;180008A
70X03AX92Q4L2PT92QX92R`B00T92Q4L2QX92R`B014L2R<L2R`B02<L2P02
4A`:00h92@XA70X92@XJ2@X/4P092A@J2@X/4P0S70X/4P092@XS70XA70X9
2@X34A`:01`92@X94PX92@X94PX/C2UZLUaZNfmZSEa?IdM6GTM6@AhS;ahS
;bT/C2U?Ie`mGSdd;c=?GVJ3V8j3Q8iZNhAGSEa6GTLA9Qh94PXS;bTdECdS
;bT2000000<94PXJ9Q@J4Q@00PTB2P0O4A`:6RHD;3PY2A8:4A`:2@T:2A8:
2@T:2A8:8a`:2@TD6Q8D0000UD`YUG97kMW<i=3<4A`:SED:YXB4g;jgm_Ke
Ea`0kNgZm^gZm_oo00002A`D4BHD2@T:4BHD008A70X02@T92PTB2PT92Q4L
2PT951X92VYW<g^=IX=k<`022@T:01L94PXA70XJ4Q@/>2TS;aiP@BU6C3f=
SE:3NebEV6JEXHk1/hiPGS<d;aj=SFo1/jg:d<7CfMK]m_GfoooCfMKLhmKC
fMH00mcSeP05i=3<g>?Fi=3<g>?Pm_oe00;oool02W:=Q6YE7VYW<iF=I/6Q
Q=cSe_ooojJZXkUW0;1<00B`E@002JI<08=108<_060_2W8V04HV2SdL2R`B
014V2P026PT:0PT92P094A`:2@T:2@T:2A8:4A`:2@T:4A`:2@T:4A`:00<9
2@X01Q4L2PT92PT92PT92PTB2Q4L2P892@X01Q4V50T92QXB51X92R<L2QX9
2P8m70X00b`B03dL2ULL0002Ea`000<S70YG700m70X00SdL2P07ARHDLRH0
H2l:H2l:LRH0H2l:Pbl000A69PX033dL2THV2W8V04HV2SdL2THV2ULL060_
2THV54H_2ULL0<77c67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c006IVIVc<c<VIVIVIVIIVIVc<c<2iVIV@0Foo[ooo_onOOl
o?oomooljoS_n?ojnOohno[eooSaoo_aoo[XooKHo^6gX81=Q6@WLU4<OU`D
QV@MQfDNR6DSS6TW0Xm/;0:>JR`4SV/[00>>JbV>Jb^=Jb`02Xe[;QB<JRd0
0haZ:he[;8e[:`0FSF/[01VAKbn?KBf=Jb^<JRZ=Jb^<JRZ;JBV9IbZ0EbV1
FbjUQEKoj[WoolgoomCoo]gonnGoooSoooo`l?Sno_ooo_okno_ooo_ooo[o
ood0TiVIV@03ooooc<c<c<c<05g<c<`02A4L2PT92R`V514L2QX92R`B014L
2R<L2PT92P024A`:0QX92P034A`:6PT:4A`:008J2@X03b`B014L2PT92Q4L
2PT92Q4L2PT92QX92R`B02<L2R`B00T92QX92R`B00TB2P022@T:00DA70X/
4P0/4P0J2@XS70X00QX92P074A`:2@T:6PT:2@T:4A`:6Q8D4A`:00894PX0
6@T92P0002`h:CeN?H>=Q7^=IVYkKdmWAdI<?B<_7R`h:B<_<g:=Q6YkKdIW
G6Z=G7:=Q6YkQ6YkKeMWDRa<:A4V7R`h:B<_:@0000042A8:00@A70X94PX9
2@XJ4Q@26RHD0a4L2P042@T:2A8:4A`:6PT:0Q4L2P072@T:H44YYW9Bg;jg
m_ooYXB4LSP000;1XH@01_KfmIE<:Mbn]nC@c?KoojJ4Q08A9PX01@T9514L
2PT9514L2PTB2P044A`:00P/9Q@/>2UPGS?1/hj=SDL94PXA70X94PX24A`:
00hJ4Q@d;ai6EBUbIe9kSFJEXHk1/jfEXHhdEBV3Nc?1/jg1al7:d<7Lhn02
kOKe01kCfMK:d<7:d<7Td<cLhmKTd<cCfMK:d<7Td<c]kN[ooooChoEGSHi6
@AjELTNNQ6KTal7]fLcfoooooonVQ8BiI`2`E@2iI`2`E@2`C02iI`2`E@2V
@@2EE@02Pbl000IP;`YG700m70X/4P0S70XJ2@X34A`:00H92@XA70X92@X9
4PX92@XA70X22@T:00<A70X92@XA70X00`T92P0<4A`:2@T:2A8:2@T:4A`:
2@T:;1`D2@TD;1808a`:;1808a`:0THV2P038a`:H2l:H2l:008m4PX01DHV
2SdL2SdL2SdB2ULL0003LRH000Ab>1Ab9P23;`1P;`X2ARH:00Lm70Y69PYG
70169PY6@Ahm4PYP;`X00dHV2P03ARHDEa`0/;k1067<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI00:IVIT0
0fIVI/c<c<c<c03oc<c<3/c<c003ooooc<c<c<c<05g<c<`06Q4L2QX92QXB
514L2QX92PT92Q4L2PT92QX92PTB2QX92Q4L2QX92Q4L2QX92PT92QX92Q4L
2QX92Q4L2R`B01X92PT92R`B01X92QXB508J2@X02B`B014L2PT92PT92P00
00TB2QX92QXB51X92P028a`:0QX92P03;1804BHD2@T:008A70X01@T92Q4L
2R<_7QXB514L2P022@T:00D000092A@dEBUbSHB3Q8h00VYkK`8dECd03VYk
KcAE?DIWG4mWG4mNIVYkKh>4SVYkKdmbNdIWG2a<:A4V2PT950T92P894PX0
21XB50TB2QXB50T92PTB2Q4L2QXB51XV50@94PX22@T:00dA70X92A@A70X0
00169PZ3GS?L_[Ofm_G]fL`m4P[1XHCL/j?L_[L00/6QQ008i<O1m^gZkMW<
LVMB4BH:2A8:4BHDAT4N0QXB50052@TD4A`:2@TD2A`D6Q8D008S70X01X=k
G9FQSSAE:@TB2PT92QXB50<A70X02b`V5<6c[H=kG9FQS[2c]k2ZQ14V2ZJ4
Q<77`L77c>C@c002kOKe00?Lhn3LhmKTd<`00/[@`@0AdmWFb]31b]31b]31
g>?FooooY/OPAT4NJUDNWXAVYYR4b[j]g>?Pm_ookOKeoooo`J6400:iI`00
2k1E0;UW0;UW0;1E0;UW0:I<0:I109EE08<h060_2ULL0002ARH:00@S70XA
70X92@XJ2@X22@T:00PA70XJ2@X92@XA70X94PX92A@94PXA70X22@T:0PTB
2PL92@X00`00014L2QXB5002;18000<m4PY69Q@m70X00SdB2P0DEa`0H2l:
;1`D?A`:?A8:ARH:?A8:H2l:LSPDEa`0H2lDLRH0LSPDNd`:H2l:LRH0ARH:
?A`:H2l:ARHD0ULL00038a`:ARH:ARH:00969PX00dH_2SdB2/77c01Qc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<
c9VIV@03VIVIofIVIQ1VIVH00oooolc<c<c<c01Mc<c<00LJ2@X92@XJ4Q@9
2@XJ2@XA70XJ2@X00Q4L2P046PT:2A8:6PT:4A`:0QX92P0=4A`:;1804A`:
6PT:4A`:6PT:4A`:2A8:6Q8D;1802@T:8a`:6PT:008/71@22@T:00/92A@0
000J2@XS70XJ2@X/4P0J2@XS70X/4P0S70XJ2@X00PTB2P096Q8D2A8:2@T:
6Q`N6RHD8blN4BHD4A`:2@TD008000003@TB2SAE?H>4SX>=Q6YkKeN=G5MN
Kg^=IUN=G5MWDTmNIW9bNfYkQ002LXf400@94PX000092@X92A@22@T:00HJ
4Q@92A@92A@S;ah000092A@24BHD01<A70XJ4Q@92@X94PX92@XA70X92@XJ
4Q@A9Q@94PXJ4QA69QBEC2WTal7foooooolS70[:ZVJ`Q7/00^C@c00GYW9B
b[j]i<O1kMW<b]3100004BHD2A`D=2lNJVLcJUDN4BHD2A8:6Q8D2@TD6Q8D
4BHD6Q`N6RHDg<NSSHe72A8:2A`D008J4Q@03a4L2Q4V51XV5:JHKiFQS[2Z
Q:JZXiF4NdHV5<[@e/77`McSe]cSh=?SmNg]jP02g>?F0]?IePC:d<404=cS
e^gfmMcSh5MEDYF4DZJHQ<6cS^C7`McSe_KoongfmOK]j_Kool77c;UW0=>4
00:iI`002;1E0;1<0;UW0;1E0:I<0:I108=108<_009P;`X01ELL014L2QXB
514L2QX92P024A`:0PT92P044A`:2@T:2@TD2A8:0PT92P034A`:2@T:2A8:
00892@X00`TB2PT92PT92P022@T:00<A70X92@X92@X00QX92P05;1`D?A`:
?A`:Ea`0?A8:009P;`X02eLL03dL2THV2SdB2THV55LL060_578V060_578V
060_2P02Pbl000=69PYP;`Y69PX01DHV2P08ARHDEa`0ARH:?A`:ARHDEa`0
?A8:b]3FHLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4
c<c<00=VIVK<c<bIVIT0oiVIVA>IVIT00oooolc<c<c<c01Mc<c<1A4L2P0I
8a`:4A`:6PT:4A`:6PT:4A`:8a`:6PT:4A`:8a`:6PT:4A`:6PT:4A`:6PT:
2A8:;1802@TD;1806PT:4A`:2@T:6Q`N=2lY4A`:00892@X01PTB2Q4L2R<L
2R`B01XB52`B008S70X00aX92R<L2Q4L2P022@T:00H94PXA70X92@XA9Q@A
70XA9Q@2;3PY00Td;ahS;ahA9Q@/>2Td;bTS@CeGGVmZNfmbLW/00VYkQ009
LXf4H79kAVMLCg9kPiR>AUi700004BHD000000892A@24A`:00/94PXJ71h9
2@XJ71hJ4Q@A70X94PXJ4Q@92A@A70X971@00PTB2P0=2@T:4BHD6Q8D4A`:
6Q8D2@TDARH:UG97i<O1m_KeooooARl:^IQL00;1XH@03^C@c7]<5<6QQ>C7
`Ng]j_Koof0_2Q4V2R`L514V7W:=?DI<?DIE:AXV508A70X06AXB52`B014V
53@_:L6c[IFQSQ4V2PT9514V514L2QXB52<_7PT95:JHQ;2c]jJZXiFQSVYb
G:JQV<6c[L[@`NgfmM?SmOKoomcSh002dmWF01OLhmKCfMKLhmK1alc1/jg1
al7Lhn3]kNYPLW^EV6K1/hk1/jg:d<7LhmKfm_Gfooo]m_Gfm_GooooLhn3C
Q02iI`31Q0000[1E0004`H@0^FL0/5D0^FL00ZI<0006PcP0LSPDLRH0ARH:
;1802@T:0Q4L2P8J2@X01a4L2PT92QX92Q4L2PTB2PT9514L2P022@T:00<A
70X92@X92@X00`TB2P034A`:2@T:4A`:00892@X0414L2R<L2R<L2R`B03dB
2THV2SdL2R`B060_560_2ULL03dL2SdB2THV54HV2V0_2P9b9P001dHV578V
078h58<_07]<578V060_5002ARH:00M69QA69PY69PY69PYG70169QA69PX0
0THV5003ARH:Ea`0`LO<067<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01nIVIT4oooo0_ono`?oood01ooo
nocnnOGjlo7fkngbjnC[hmcTf@04emoB1=KNdCSGgm88f=kD1mWOe@09f>3C
e]o<f^?>hn[Jjo7SmOSan_ciooooooko00?ooOl00oonooooooooo`02ooom
00?ooonIVIVIVIT0P9VIV@03ooooc<c<c<c<05g<c<`00a4V51XB514L2P02
6Q8D00TA70XJ4Q@A9Q@J2@XA70XS70X92@XJ2@X94PX011X92P06;1806PT:
6Q8D;1802@T:8a`:0QX92P05;1`D8blY6Q8D4A`:6PT:008A70X01cdB2Q4L
2R<L2R`B01XB52`B01X92P028a`:00<J2@X94PXA9Q@00PT92P0I4A`:2@T:
2@TD6Q8D4A`:6RHD;4`Y?EhmJW]_PhAkJXeLPhB>JW]_JW^4LXf]LXf4JW]_
Eei_JW^4Cg9kCeiVAUEB8blN00004BHD00894PX03PT92Q4L2QXB50T951XV
514V7QXB50TB2PT9514L2PT92PTB2QXB50T950894PX06Q4L2PT952<_:AXB
51X92PTL53dL2W9ED/Zn[Ng]j_oooiF4SYib<mbcXjIEI_KfmK24NiE<:NC@
c>gfmOKoongIc;24I/6cSZIb514V509PGS<06c@_:AXB50TL514L2QXB514L
2TI17[2c]l6cSQXV514V2PTL51XV51XB51XL7R`V5;2ZQ<6c[JJQV8>=Q<77
`K2n`K2c]mcSe^gfmNg]j_Koo`02dmWF00?Lhn3CfMK:d<400/77`@0:g<NS
b]31kOKeUIRSUHAk`K>>`K>]b]31g>?Fm_Ke0oKoo`08kOKeoooog>?P/5D0
dh@0^FL0`H@0dh@00[UW0005/4`0^FL0/5D0YT`0UED000:3;`001THV51XL
7Q4L2Q4L2QX92Q4V508A70X01@T92PT951X92QXB514L2P022@T:00DA70X9
2@X94PX92@X94PX00PT92P0H4A`:2@T:2@T:4A`:2@T:6Q8D?Blm6PT:?A8:
ARH:?A`:?A8:;180H2l:LRH0=2lN?A`:ARH:Ea`0ARHDEa`0H2l:LSPDEa`0
0V0_2P:3;`0024HV560_2THV2SdL2THV560_2THV2V0_509P;`X01THV2ULL
04HV54HV2SdB2/77c67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c003IVIVc<c<VIVI01nIVIT6ooko0_ooo@09oooko?ggl_G^
i>[Pg>;HemoDdMW<b];3_LRg00:mbKD3_<Rd0[_7/cNmbKD00kg8]ko7^;o7
^006_lNh1kk6]`09_/Nd`lfda]>gcmW1eMk;gN?Gj>[UloGdno[o00Koo_l2
ooom00?ooonIVIVIVIT0P9VIV@03ooooc<c<c<c<05g<c<`02aX92PT92QXB
51X92R<L2QX92Q4L2QX92PT92QXB52`B00036PT:00h/4P0A70XS70XJ2@XS
70XA70X/4P0J2@XA70XJ2@X/4P0J2@XA70XJ2@X42@T:01<A70XJ2@XJ2@XS
70XJ2@X/4P0J2@XS70XJ2@X/4P0J2@XA70X94PX92@XA70X92@XA70X92@XA
70X00PT92P0=6Q8D0000AUEBUIRSNhf4SIR>H79k`LO</;>gJW]_H79kJW^4
H79k009?LW/01DmNIR<_7PT92R`h:@T92P032A8:00HA70X92A@J4Q@J4Q@9
4PX92@X24A`:00@92@X94PX94PX94PX32@TD00TJ4Q@A9Q@J4Q@A70X92A@m
70ZELTO1XHCTd<`00_Kfm@03UEDD^G8c/7]V00;]kNX05YE<:Mbn]oKoongf
mOKoongIc=bn]nC7`FYW<a4V2X=kG8=k<`TB2QXB514L2R`L514V2QXV5<6c
SZJQV6YE7QXV508J4Q@04AXV52`V56YW<h>=Q:JZXjJZ[L[@eZJZXk2ZQ;2c
]ngfmM?SmNg]j^gfmM?Ie]cSh<[@`@02`LO100^`/kO1/jgTd<cLhmKCfMJV
V6nVXIS1/jg1alcLhmK]m_D00oKoo`04m_Kem_oooooodmWF1=>40004`H@0
dh@0`H@0/4`00[UW0003/5D0YT40UED000:3>002?A`:00<A70XJ2@XJ2@X0
0QX92P044A`:6PT:2@T:6PT:0PT92P054A`:2@T:2@T:2A8:4A`:00D92@X0
0`TB2PT92PT92P024A`:00//4P0J2@Xm70YG700m4PXJ4QAb9P1G701P;`Xm
70YG7000160_2P03Pbl0LSPDLRH0009b>1@00h<_060_2V0_2P04ARH:00YP
;`YG70169PY69PYG70169PX/71A69PXm4P[:d=IQc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0OVIVI1Oon
o`;oood02_oonoSilo3cj]oUfL[B`kk6]kW2/KBm[:^gXJ:`U`>Q[iD2X:jD
0Yn]TcRMZi400ijZTZ2YU:2YU005X:VD1j:[UP09X:fCYkFB[;ZF/[nQ^<:Y
_lRgbm?8gN;LjNg^00;nool4ooko0_ooo@03ooooVIVIVIVI082IVIT00ooo
olc<c<c<c01Mc<c<00@J4Q@/71@A70XJ2@X22@T:01LJ2@XA70XJ2@XA70X9
2@XA70XJ2@X92@XS70XJ2@X/9Q@92@X94PX/4P0J2@XA70X94PX/4P0J2@XA
70X/4P0J2@X92@X00a4L2P0=6PT:8a`:8a`:;1808a`:8bH:8a`:;1806PT:
8a`:6PT:4A`:2@T:00<94PX03`T92PTB2PT92Q4L2PTB2QXB50T92Q4_<fYk
KiFHXg9bNjJc`FYkKg:=Q6YkQ002LXf400QPLW]ZNfmkSHAGSE`000094PX/
GSd000022A8:00<92A@A9Q@J4Q@00PT92P032A8:2@TD2@T:00894PX010T9
2PTB2QXB50T92P894PX05AXB514V7Q4V51XB514L2QXB56YE7ZJ4Q>C@c>gf
mOooog9ED[2=<l5kNngIc?KoolZn[K24I_KfmNgfmOKoo`03kNgZ01[Tal56
;`ZEV6J3Ne`dEBT94PXJ4Q@A70XS70XA70ZEXHk1/je6EBT/>2TS9PXJ4Q@A
9PXd;aiZLUbEXHkCfMK:d<71al6EZZf=V8k:d<42kNgZ00?fooo:d=K1al40
0/77`@B`/kL02=cSh>gfmJJZXjJZXl6cSZJQV=cSe^g]jPKfool00oooombc
[M>40004dh@000>iI`3CQ02iI`000[UW000</5D0YVL0YT40UED0Pd40ARH:
?A`:8a`:;1806PT:2@T:4A`:0PT92P064A`:2@T:4A`:2A8:6PT:4A`:0PT9
2P0>4A`:2@T:2@T:4A`:2A8:2@T:4A`:2A8:2@T:2A8:2@T:;1`D;180Ea`0
0THV500<?A8:H2l:H2lDLRH0?A8:H2lDEa`0ARH:ARHDPbl0LSP0H2lD0W8V
0005Nd`:Pbl0H2l:ARHDEa`000969PX01ELL060_55LL04HV55LL0002ARH:
0SdL2P03;180dn?ec<c<063<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01nIVIT2oogo01Koo_oooOoooooo
oogmo_SdmnkWkN7DgLc0bKJb_ZRY]IfO[9:FXhV@WH6?WWf<W7R8V7B5UG63
Tfn4U727Ug>8V7@hQIEa38JDL`0>QiEdRIMfRYQgS9YgTJ1gTZ=gUZJ1W:Z9
YK6I];n^alo4dm[Ci>SWlOGf0_gno`05o?cnoOgmooomookloooo08:IVIT0
0oooolc<c<c<c01Mc<c<00<A70XJ9Q@92@X00a4L2P062@T:4A`:4A`:4A`:
2@T:;1800Q4L2P0<2@T:8a`:8a`:;1806PT:;1804A`:6PT:00008a`:2A8:
;180114L2P042@T:6PT:4A`:;1800QX92P078a`:;1804A`:8a`:;1806PT:
8a`:008A70X01`T92P0000TB2PTB2Q4L2QXB50T92P022A8:00@92@X0002E
V:=kSH@2UJZ]00E6EE9bLW]bSHAbSHAPLW/00W:=Q006PiR>AVML00002A8:
CfM700000`TB2P038blY2A`D2A8:00<94PX0114L2PT92PTL50T92P894PX0
6A4L2PT9514V51XB50TL52`V50T92Q4V514L2V0_5>BZV:JZ[Mbn]oooombn
]iEN<k1kI/77c?KfmNC@c;1kI_K]j^g]j_KfmNgfm@02kNgZ00GLhn2iZVmP
GS>VXIQ6EBT00PTL500B2@T:6RHD4A`:H5hcUIQVAUDYH5hc4A`:6RHD2A`N
JVLcYZ6HdmWFb]31`LO</;>g/:Z4PhAk0^g]jP;]m_D00k2c]l77`L6c[@02
UJ6>00N`/kO1/jg]kN[Lhn23V:fVXIR`/kL00/6c[@03kNgZkOKem_oo00Kf
ool01KUW0=>40=>40=>40>BZ0004dh@00kUW0007/4`0/5D0YT`0UED0Pbl0
LRH0ARH:008S70X01A4L2QX92Q4L2Q4L2PT92P032A8:0`T92P894PX010T9
2PTB2PT92PTB2P<92@X01A4L2PT92Q4L2QX92R`B0002ARH:00=G700m4PYb
9P000W8V0003ARHDLRH0LRH0008m70X00g8V08<_078V0003LRH000YP;`YG
701P;`YG70169PYG70169PYb9P169PYG7003ARH:00@m70X/71@/4P3CfMIQ
c<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIV
I/c<c9VIV@0OVIVI0_omo`1<ookoooooooomo_okmOS_jNoQbmC1_/Zd/;fS
X[6BTj60P91/M89OKWiIM8EKLhAHLhAJLX=GLX=ILX=GLhAJLhAHMHILMHIJ
MHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHIL
MHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJ
MHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHILMHIJMHIL
MHIJMHILMHIJMHILMHIJMHILMHIJ0WF6G09fQE`06GJ5GWJ5G7J5GWJ5G7J5
GWJ5G7N6GgN6GGJ5GWJ5G7N6GgR7GWV8HGZ9GWb>GW65E764EgnAJHjOOIVY
SZZgXk[6^=3JdN?ZhoKkm`02o_oo00Coooooo_oooOkooon2VIVI00?oooo<
c<c<c<`0GLc<c0066Q8D6PT:4BHD6PT:4A`:6PT:0Q4L2P8J2@X01@TB2Q4L
2QX92QX92R`B00024A`:00LJ2@XA70XA70XJ2@X/4P0A70X/4P000aX92P06
;1806PT:6PT:6PT:4A`:6PT:0b<L2P09;180;1`D6PT:;1806Q8D;1808a`:
6PT:6Q8D00894PX01@T92PTB2QXB50T9514V50026Q8D00<92@XdECekSH@0
0YFHX`04CeiVLXf4Cg9kPhf40TIWG00@PiR]UJZ]PiR]00002A8:6Q`NAUEB
00002A`D2@TD2@T:;4`Y6Q`N2A8:2@T:2@TD0`TB2P036Q8D2A8:2A8:008J
4Q@050T9514L2Q4V7R<_<b`h:A4L2QXB50TB2R`B0<6c[L5kNmbn]ngfmOKo
ok1kIZIbD]bc[NgfmNg]j^BZV0;]kNX05_KfmNgfmOKfmNg]j_K]j]cSeQ4V
2ZJZXg:=?B<_7PTB2Q4V50T952`L52<_7TI<?IEbAhf=DQ4V7Q4L2VYW<l[@
`@?1al`01l77`JJZXjJZXk2c]oKoom?SmOKoo`03`LO<00VEXKN=V8jEZZg:
_Zg]kNZVan0J9QA6C3g1/hh00/[@`@03g;jgoooom_oo00Gfool01NgfmNBZ
V=>40=>40>BZ0003dh@000?TZP3CQ02iI`000k1E0004^FL0/4`0/5D0/5D0
0X=10003LSPDARH:;180008J2@X01a4L2QX92PT92Q4L2PT9514L2PT92P02
4A`:0PT92P042A8:2@T:2A8:2A8:0PT92P074A`:2@T:2A8:6PT:;180;1`D
?A8:009G70003SdB2W8V078h560_2THV2ULL078V03dL2THV2X<_07]<2W8h
578V04HV2P=P;`X025LL060_2ULL060_55LL04HV55LL04HV50=69PX013dL
2R`L53dB2]?SmF7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2h
R<2h1<c<c003IVIVc<c<VIVI01nIVIT2oogo04coo_ooooonoo_ho_CWkn3E
hLg2d;N[^Y^CXgn9Vg>BXgNU^8Zmcio<gZkSmLGVm/GYnL[[nl[/o<g/o<_Z
n/_YnLS[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[
nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[
nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[
nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nl[[nlc[nlX2jo_<0^gjc00LkO[>
kO[<kO[>kO[<kO[>kO[<kO[>kO[<k?W=k?W;k?W=k?W;kO[>k?c;gO:jb=nW
]/fIYkf>TJIkPiMbUZN7]<BZ_LZfdMk=jO?Xn?oho_omo_oo0ooooh:IVIT0
0oooolc<c<c<c01Mc<c<00/A70XS70XJ4Q@S70XJ71hA9Q@J4Q@92@XJ4Q@9
2@XS70X00QX92P064A`:6Q8D;1806PT:;1806PT:0R`B00056PT:2@T:;180
4A`:;18000<J2@X01PT92Q4L2Q4L2QX92R`B02<L2P8J2@X030T92R<L2QX9
2Q4L2QX92R<L2Q4L2Q4V2PTB2PT92Q4L2PT92P894PX04@T951XB514V2QXV
56YkKiFZ[G:=Q4IWG6YkQ7:=Q4IWG3eN?B=1?FYkQ:K7h8>HSPTL50022A8:
00a6Iea?Ie`0000S;ahA9Q@0000/>2TJ9Q@92@X94PX92A@94PX22@T:0149
4PX92@X92A@92@X92A@A9Q@J71hA9QhS@E9GIe8A70XS70XJ4Q@92ABEC2W1
/jgL_[L00_Koo`0Ni=3<UEhc`J64kMW<g>?Pg;jgkNgZm_KekNgZm_Kem_oo
kOKekNgZooooARl:YZ6HPg]LAUDY2A`D6Q8D4A`:4BHD;2HD8a`:EfMBLXdm
H44YSHe_`LO1/;k10/77c0;1al400k2c]l77`JJZ[@02kOKe013:d=JEV:>`
_/71al71albV/l7Td<bEZZeGSHh/GSe6C3dJ9Q@94PZEXHk:d<7Lhn04m_oo
0_ooo`03m_oobZ4mdh@000;CQ003i:X00]>40005i:X0dh@0dh@0dh@0^FL0
00>`E@001/640:I<08=109EE04HV2R<L2P8A70X01aX92PT92Q4L2Q4L2QX9
2PT92Q4L2P022@T:01T94PX92@X92A@A70X92@X94PX92@XA70X92@XA70X9
2@XA70XJ4Q@/4P169PYb9P1P;aA69QAP;`Yb9P23;`1P;aAP;`Yb9P1G7000
0V0_2P05Pbl0ARH:Ea`0ARH:H2lD00=P;`X03ULL060_54HV2ULL04HV2ULL
04H_2SdB2SdL2R`V53dL2TI17X=N5<[@eV7<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01nIVIT0C_omooon
ooooookooocono7ik=OScl7?]ZbmWIZ_R9:XNZ6gQ[kEWmS`]^Kn`^kob>[k
aNcmbO;ocO?od?KodO?od??oc_3ocO7oc>ooc?7oc>ooc?7oc>ooc?7oc>oo
c?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7o
c>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>oo
c?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7oc>ooc?7o
c>ooc0Caol`07O7oc_7oc?7oc_7oc?7oc_7oc?;oco;ocO7oc_7oc?3ncO3n
bo3ncNkobNSoa>Co`n?oa=Sd^[WDWiF_OhZQMHjTOZ^nW/3@]]WVe>cfjoOl
m_goo?koo`02ooooPYVIV@03ooooc<c<c<c<05g<c<`38a`:00LA70XJ4Q@J
71h92@XA70X92@XA70X00QX92P062A8:?Blm;180;1804A`:;1800QX92P06
8a`:4A`:2@T:;1806PT:2@T:0R`B00064A`:;1806PT:6PT:;1806PT:0R`B
00034A`:;180;180008/4P00:QX92Q4L2QXB52`B00T92PTB2PT92Q4L2PTB
2Q4L2PTB2Q4L2S@_<fYkKg:=Q3@_<dIWG5MWDTIWG4I<?@TL514V59FHXl77
c8>HSQ4V2P0000TB2Sd_?IFZ[DmWG00002<_7Q4V2PT952a<:B<_:@T92PTB
2PT92PT9514L2P894PX05PT92Q4L2PT92QXV514_<b<_<a4_<dIWG8>H[@T9
2R<_7PTL50TB2ULL0<6QQ<Zn[NgfmOKooooook1kI/6QQ<77c0;Td<`01>gI
c>gfmOK]j^gfm@?fm_D01Ooook24Ng^=IXf=KdmWA`022A8:00HA70XA9Q@J
4Q@J9Q@A70YPGS<2/;>g01Z`_/71alc:d<71al6`/kNVZZfVV8B`/kO:d=K]
kN[oooo1al6`_/7CfMJ3V:ekSHA?Iec1al71alabEE:VXIREZZfEXHi6@Ah0
0016C3d2m_oo00O]m_GfoooooooooooChoGT/bWTZP000m>400;TZP001=>4
0>BZ0;UW0>BZ00;CQ0001[UW0=>40;UW0<640;1<0;UW00;1Q0001YEE078V
03dL2R`B01X92PTB2P<A70X22@T:00LA70X94PX92@X92@XA70X92@X94PX0
10T92P0<2A8:2@T:2@T:00008a`:;180;1`DEa`0H2l:Ea`0LRH0H2l:0W8V
009P;`X01X<_060_2THV2V0_578V02`L509G70001THV2V0_2ULL060_2ULL
060_2P=69PX01B<L2THV53dL2SdB2Yik<`02WXdc00>Van3<c<c<c<`0Glc<
c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<
c<bIVIT07iVIV@1>oogoookooooooOolmokfi_7Qb=O0[/6QTZR1Ujj0ZL6=
aMjTgONfiOnmhObeg_BckOk7l?k;l_k<loo>m?o>loo>loo=l_o=mOo?m?o?
mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?
m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?
mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?m?o?mOo?
m?o?mOo?m?o?mOo?m?o?mOo?m?o?0oGoc`0@mOo=mOo?mOo=mOo?mOo=mOo?
mOo=mOo?mOo=mOo?mOo=m?o>loo;loo=koo9i?jo0^7o_@0;h_o0h?k0cnfa
[lbDTZikV;:5Zl6KbMVoh^oMm?_cnool00;nool00ooooiVIVIVIV@20VIVI
00?oooo<c<c<c<`0GLc<c00H6RHD4A`:4A`:6Q8D2@TD6PT:4A`:6PT:4A`:
6PT:2@T:4A`:8a`:6PT:;1806Q8D8a`:6PT:;1804A`:2@T:;1802@T:8a`:
0R`B00094A`:2@T:;1802@T:4A`:2@T:6PT:;1808a`:008J2@X01aXB51X9
2PT92QX92R<L2R`B00T92P024A`:00`94PXA70X94PX92@XJ9Q@S;bUZNfm?
IdLmGSdS;ah/C2U6C3d28blN00D94PX/71BEXHjV/l6=V8h00P00000=2A8:
4BHDUJZ]Y[?1JW]_0000;4`Y8blN0000AT`m4BHD2A8:2@T:00H94PX05@T9
514V51XL7SAE?B<_:DINAh>4SUN=SS@_7R<V2QXV51XB52`L59j4I/6c[Mbn
]ngfmOKoombn]jJZXnC7`@02i=3<01W]m_Gfooo]kN[fm_G]m_Gfm_G]m_Gf
oooL_[N3Neb=V8i?IdL/>2TA70XJ4Q@92A@J2@XA9Q@A70Y6C3g:d<71alc1
al71alb`/kL00ZJZ[@0>YZ6HYZZ]`LO1kNgZkOKedn?eb]31`K>]g>?P`LO1
UJ6>YZZ]/;>gdn?e0^gfm@05kNgZg>?Pg>?P`K>]YZZ]00C]m_D00mcSh9Fc
c>BZV004i:X000?CQ03TZP3TZP000^BZ0003g:Xci:X0dh@000;CQ003^FL0
00V`E@31Q02iI`2`LP2EE@1P;`YG700S9PXA70X00QX92P032A8:6PT:4A`:
00892@X01b`B00T950T92PT92Q4L2PT92Q4L2P022@T:00<A70X92@X94PX0
0PTB2P076PT:?A`:?A8:LRH0H2l:Ea`0LSPD009b9P001F0_2W8V08<_078V
03dB2P02LRH000Lm4PY69PXm4PYb9P1P;`YG701P;`X01DHV2P05?A`:ARHD
;180H44YYZ5V00:=SDL00fYW<l[@e/c<c01Pc<c<00AVIVJ8`;R8`;Q8T8P1
0000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0OVIVI04oooOoo
o_onoooio_[`n>gKj=Jkc[:Q]i>AZgjP_HNjeY_@kJ[Jn;3Oo[;YokKbol?c
olWdolkgom7eologom7eologom7eolojomChom;jomChom;jomChom;jomCh
om;jomChom;jomChom;jomChom;jomChom;jomChom;jomChom;jomChom;j
omChom;jomChom;jomChom;jomChom;jomChom;jomChom;jomChom;jomCh
om;jomChom;jomChom;jomChom;jomChom;jomChom;jomChom;jomChom;j
omChom;jom@00_SodPchom005?OocoKoc_;oc>oob>Oo`m_l]M3aZ/o`ZL[^
Z;SHUj2oPhbYLi^eR;[=[M_Zdo;llO_ooOcooognoooooh:IVIT00oooolc<
c<c<c01Mc<c<00TJ4Q@J2@Y69Q@/71@J4Q@A70X92@XA70XJ2@X00Q4L2P05
;1804A`:;1806PT:8a`:008J2@X01B<L2QX92R`B01X92PTB2P02;18000`A
70X/4P0m4PXJ2@X/4P0A70X/4P0A70XJ2@XS70XJ2@XS70X2;18000<J4Q@S
70XJ2@X00Q4L2P0<2@T:6PT:4A`:2A8:2@T:AT`mJW9L=5Dm4BH:2@T:4BHD
;4`Y0R`h:@0D6RHD2@T:PhB>UJ6>Y[?1CfM74BH:4BHD2@TD8blNPiR>Y[?1
/;k1NheV0000;4`Y8blN4BHNJXeL000010TB2P064A`:2@TD6Q8D2@TD2A8:
=5DY0R=1?@0?AUEBH79k/;>g;5EL/;>g00008blN6RHD4A`:PehcYXB4g;jg
kOKekNgZi=3<00;L_[L7kOKe0_Kfm@0?m_ooi=3<=5DYPhf4UJ6>AUDY4BH:
4BHD2A8:4BHD2@TD2A8:H5hc`LO<`LO100:VZZd04ZJZXl77`JJZ[K2n`JJQ
V>g]j_KoongfmOKool[@`LZn[Ng]j_Kook2n`L77`L[@e/[@`M?IeP;]kNX0
2m?SmNg]j]?SmNgfmM?SmNgfmOKoong7G9EN<h>4Nonc0002i:X000Wf/`3T
ZP3TZP3TZP3f/`3TZP3f/`3CQ03TZP001=>40005^FL0dh@0`H@0^FL0dh@0
00:EE@000g8V04HV2SdL2P02;18000<A70XJ2@XA70X00PT92P064A`:6PT:
2@T:4A`:2@T:2A8:10T92P0:2A8:2@T:4A`:2A8:2@T:8a`:?A`:ARHDH2l:
H2lD0g8V000:LSPDEa`0LRH0LRH0H2lDLSPDLRH0H2lDH2l:LRH00dHV2P03
H2l:ARH:?A`:00969PX02b`V54HV2THV2V1159ib<hf=DX=k<fYW<f1N<dH_
2/[@eP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@0OVIVI0_ono`1>o_oom_chj?;WdN3;//NXVK::VkN6
Z/V>`^6Ndo>Zf?VZe_RTf_^Ti?nbkok5l__<mOc@m?g>m_gAmOk?mOc@m?g>
mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@
m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>
mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@
m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>mOc@m?g>2?Cnc003log;m?k<
mOo=00;eold05?Cnc??mbngnamol^^?o_nWo`nGo_MWn/LW_X[[NU:kBS9Fd
N9^gQ;36WlkPa^[fj?Snn__ooognooooo`FIVIT500000iVIV@@00003VIVI
0P000004VIVI00000000VIVI0P000003VIVI0000000000FIVIT400000YVI
V@D0001CVIVI00?oooo<c<c<c<`0GLc<c08S70X2;1`D00LA70X94PX94PX9
4PX/71@A70XJ2@X00R<L2P0A6PT:8a`:8a`:4A`:;1804A`:;1806PT:4A`:
;1804A`:8a`:6PT:8a`:2@T:4A`:2@T:00<J2@X022`B02<L2QX92Q4L2R<L
2QX92R`B01X92P8/4P034A`:00@J4Q@0001?IdMGSE`2000000@A70XJ2@XA
9Q@J4Q@2;4`Y01<94PZEV:?1al6VZZeZNflA9PXS;ah/9QAbIe:3V8jEXKNE
ZZfVan1ZSE`0000dEBTA9QiZLUaGSE`00PTB2P0300002A8:4A`:00894PX0
6`TL50T92TmWAa4_<b<_:CAE?EMNKh>H[H>4SV1bNjJc`DIE:A4V2R<_7QXB
54I17ZIbD/77`NgIc>g]j^C@c=bn]nC@c>gfmNg]j^gfmOK]jP03kNgZ0^gf
m@08oooob[j]AUDY`LO1YZZS=5DY2A8:4BHD0QXB50034BHD6Q8D4A`:00:V
ZZd2/;>g00J`_/71alb`/kO1al6`/kOChoD3kNgZ00_]m_GLhmJVZZgfooo]
m_FVXIS:d=K:d<7Lhn3ChoG]kNX01^gfm@05kMW<bZY7YZZSg;j]m[<000CT
ZP001=>40?Jc0?Jc0=>H2PGTZP001=>40;UW0=>40;UW00:`C0002KUW07]<
58eE2ZI<08<_05LL03dL2Q4L2QX92P024A`:00@92@X92A@94PXS70X32@T:
00d94PX92@XA70X92@XA70X92@XA70X92A@92@XA70XJ4Q@/4P169PX00g8V
0003H2l:LRH0LRH0009P;`X02W8h578V078V078V078h560_578V060_2THV
55LL00969PX01SdL2THV2SdL2ULL061158=N<`:3Nc<01VYW<f1N<dI17R`h
:@000=?IeV7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
1<c<c003IVIVc<c<VIVI01nIVIT06?kno?koookoooCio>C]j<cKb:g3WIFb
O:oBSZgCR;7JS<7XVLofYmWn[^3o[nKo]nSj_>cjaO3mb?7ob_?obo;ob_7n
bO3lbP?aoL/elOk92?3ob003k_g6kok7l?o800;aolT05?3ob>onan_o`n?o
_]Sn/mGk[]On[m3jZ<7[UkCMS[7GS:G8Q:;1R:[3VL;G^=o/f_3jl_Woooco
ookoo`BIVIT200000iVIV@8000000iVIV@0000000002VIVI0P000004VIVI
00000000VIVI0`000004VIVI00000000VIVI0P0000BIVIT200000YVIV@80
00000iVIV@0000000002VIVI0P0005:IVIT00oooolc<c<c<c01Mc<c<00T/
71@S70XA70XS70X92@X94PXA70X92@XA70X00QX92P08;1804A`:8a`:6PT:
;1806PT:2A8:6PT:0R<L2P0:;1802@T:;1806PT:;1808a`:2@T:4A`:;180
4A`:0R`B00084A`:;1808a`:6PT:;1802@T:6PT:2@T:0R<L2P0:4A`:;180
2A`D4A`:LUEB?Ehm2A8:2@T:2A8:2@TD0Q4L2P0F2A8:6Q`N;1`D;5hm`LO<
UJ6>JW]_AT4N=2lNAT`mPhf4UJZ]UJ6g/;>g/;k1g>?PCfM70000AUDY?Ehm
PhAk?Ehm0PTB2P0L4A`:2@TD2A8:4A`:2@TD0000;4`YAUEB;4`Y4BHDCeiV
Nhf4Y[?1CfMLY[?1UJ6gNheV4BHD;2HD6Q`N=2lYH44YUHAkkMW<i=3<kOKe
kMW<g>?P0ng]jP03dn?ekNgZkNgZ00;]kNX02OKfmOKoog9WDVYkKk2n`HfH
SUMWDQ4V2PTL50034BHD01TJ4Q@92@YkSHBVZZ?1al6`/kN`_/7:d<71alc:
d<7]kN[Lhn3CfMKfooo]kN[]m_GfoooLhmJVZZ?fooFVZZg1al7:d=KCfMKL
hn000ngfm@0Cm_ookOKeoooom_oei;=7UJZ]kM2Hi:X0m/L:i:X0m[<0i:X0
m[<0dh@0m/L:i:X0m/Lmi;<Ym[<000;TZP06dh@001>iI`2`C023GQB3;`2`
C023@@1b9P169PX/71@92@XJ2@XJ4Q@A70X92@XJ2@XS70X92@XA70X92@X0
0PTB2P@92@X32A8:00P92@XS70Xm70Y69QAb9P1P;`YP;aAb9P02H2l:00Ib
9P1b>1B3;`1b9P1P;`Z3;`02H2l:00Ab9P1G701G701P;`X2ARH:00Dm70Y6
9QAb>1B3Nc>=SDL00X=k<`07JVLcH5hc=2lN4BHNARH:UED0b]3F067<c<`0
16IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<
VIVI01nIVIT05OkokOkom?cloocnomkRjl7?`9fhQIVnKYk=IjCIKjcRQ;CX
UL3^Y/cg/]Kn]M_o/mom/n;m]^Go^>Go^nOo_002j?no00CXol3VokkVokkX
o[hej?jm3>Ko^`0EiOjji?fihobhgofgfonhe_nbd?f/b?FP`_2H_N^A]>2;
Z]F5Y<b5UkUlWKV9_MFae^G>n?ofmooin_ono_oo00VIVIT2000000>IVIT0
000000001IVIV@800002VIVI0P000004VIVI00000000VIVI0P0000RIVIT2
000000>IVIT0000000000iVIV@80001AVIVI00?oooo<c<c<c<`0GLc<c00G
;1`D8a`:8a`:6Q8D2@T:4A`:2@T:6Q8D2@T:8bH:;1806PT:8a`:6PT:8a`:
6PT:;1804A`:6PT:;1806PT:8a`:2@T:008S70X02AX92R<L2R`B01X92R<L
2R`B00T92R<L2R`B00026PT:00</71@/4P0J2@X00R`B008J2@X00b<L2Q4L
2R`L5002CfM700T0000A70XA70XA70XJ4Q@A70X971@A9PXJ4Q@00R<_7P08
PhB>Phf4JW]_PhAkPhB>UJZ]UJ6gUJZ]0[2c]`04/;k1dn?e4BH:4BH:0TmW
G004SIR>;4`Y00004A`:0PT92P0@4A`:2@T:2@T:6Q`NYZ6H?Blm;4`Y2A8:
Phf4UIRSUJZ]H79k`LO<b]3F2A`N;2HD0TI17P09LSPD=2lYH2lDg>?Fm^gZ
m_ookNgZkMW<i=3<00;Lhn003^C@c=cSh>C@c>C@c>gIc=cSh?Kfm@0008>=
Q;2n`IFZ[CAE?A4L2PTL508J4Q@021XV514L2PT92Xf=Kk2n`IFHXk2n`McS
h0;:d=H02m?SmL[@e/[@e/[@`M?SmOKoongfmM?SmOoool[@`JJZX`02/;>g
00?:d<7]kN[]kNX00^gfm@Cfool01^C7`L[@`NC7`OJc0>BZ0?K72P;f/`03
i:X000KT/bWfaakTZP3f/`3TZP3CQ002i:X01=>4000<^FL0`H@0/4`0PcP0
^FL0/5D0YT`0Pd40LRH08bH:;1804A`:0PT92P8A70X011X92Q4L2PTB2Q4L
2P892@X00`TB2PT92PTB2P022@T:00HJ2@XJ4Q@92@XJ2@X/4P169PX4LRH0
00Y69PYb9P1b9P23;`1b>1Ab9P1b>1Ab9P1G701P;a@2H2l:00I69QA69PXm
70XS70YP@AAZEAh2WW/c0X=k<`08AUDYH44D2A`D?A8:WUhDUED02A8:dn?e
HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT07iVIV@0Do_oZo_odo?coo?gog>?]`]2oV[QhU/9QW==LX]eW
Z>B2/>NF]nZW`_2_boJ^c_NYeob^fOb/f_b_g?ja0]go]@;Oo[P2h?nk0n7o
^C?QokL8h?ng01WQokSRokWRokWRokWQokSPokOOokKMokGCo:k?o:_8n:C1
lI^lkIBgj8f_h8NXeH2PbgbC^gFK^X70fJoEj<cfoo;goo_kooonool01iVI
V@@000000iVIV@0000000005VIVI0P0000:IVIT2000000BIVIT00000002I
VIT2000029VIV@8000000iVIV@0000000003VIVI0P00056IVIT00oooolc<
c<c<c01Mc<c<00</71@S70XS70X00R<L2P<A70X00b<L2R`B02<L2P028a`:
0R`B00056PT:8a`:6PT:;1806PT:008/4P0030T92R<L2R<L2R<L2R`B01X9
2Q4L2R`B01X92R`B02<L2QX92P8/4P001B`V51X92R`B02`B01X92P028a`:
00`/4P0A70XS;ahdEBT0000J2@XA70X92A@A70XA9Q@A70XJ2@X22A8:02TJ
9Q@dECdS@CfEZZg1albE/lbVZZ>`/kNEXKNEZZf`/kN`_/71alcChoD0000A
9PYkSHAZLUbVZZ<0000971@94PXA70XA9Q@A70X92@XJ9QBEZZddECdmGSdA
70Xm;cfEV:>V/l63V8k1albV/l6EXHh0002EV:>VZZd00ZJQV0:EQ7/02LZn
[McSh?K]j^C@c=cSe/77c=cSh=?Ie/[@eP03`LO<00b`_/5ZNflA9PY6C3g:
d=JV/l6EXKLS;bTA9Q@J71hA70XJ9Q@28blN00dA9QA6GTLmGSfEXHk]m_G:
d=KCfMK]m_G:d=JEZZgCfMK:d<7]kNX00ngfm@06dn?ekOKekNgZYZ6HYYR4
UJZ]1>gfm@Cfool01l77c=cSe_K77_Jc0>BZ0?Jc0>BZ0002m[<00^BZ0003
m[<0m/LNi:X000;TZP000m>40>BZ0=>40006dh@000>iI`2VC02iI`000[1E
0005YT`0PcP0?A`:8a`:6PT:008A70X00`T92QX92R<L2P022@T:00<94PX9
2@XA70X00PTB2P0=2@T:2A8:4A`:2@TD2A8:4A`:6Q8D8a`:Ea`0H2l:Ea`0
H2l:H2lD009b9P00778h578V078h58<_060_578V060_2ULL060_54HV2ULL
04HV2THV59ib5:J4DXf=DX=k<g:=?FYE7TIE:@TL51XB58eE2Yib2Q4V50TB
2P000=?SmF7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
1<c<c003IVIVc<c<VIVI01nIVIT06?oolooon_knoo_momgVhl3C]I:dJY?2
FYOAFIoKJJKQPj[SU[7TXK[YYL?^W/K`W<ofYloeZ<oeZ]3fZm;f/=?g/MCg
/mGh]0?Fm[D00mKf/mOf/mOf/`02eoJb<=Kg/P[Dn;805mGi/mCh/]Ch/]?g
/M7e[m3fZl_eXlOdWl3`V[WYUKGWT[;TSJ[LPj;ENI_<LhnjJ9BhL/7LYmOZ
b_?olO[ooocoookoo`05VIVI1@0000:IVIT200001IVIV@800002VIVI0P00
0004VIVI00000000VIVI0P0000RIVIT2000000>IVIT0000000000iVIV@80
001AVIVI00?oooo<c<c<c<`0GLc<c08S70X02QX92Q4L2QX92R<_:@T92R`L
52<L2R`B03@_<b`B008S70X031X92R`B01X92R`B02<L2R`B01X92R<L2PTB
2R`B02<L2R`B008J2@X00b`B014L2QX92P026PT:00@/4P0S70XJ2@X/4P02
6PT:00@S70XJ2@X/4P092@X24A`:00<J2@XJ9Q@A70X00Q4L2P0@6Q8D6RHD
6Q8D4A`:4BHD4A`:4BHN8blYEfMBAUi78d4m;4`YH79kY[?1UJ6gUJZ]0VYk
Q00:UJ6g`LO<kOKe00008blNUHB>JW]_UJZ]00004BH:0PTB2P0C2@TD2A8:
0000SIR>LXf4SHe_6RHD0000JW^4Y[?1dmWFPhB>/;k1`LO<;5hm6Q8D`LO<
/;k1Y/OP00;1al`00l[@eW^=Q79bN`02JW^400=PLW^3V;OChoD00ZK7h008
UK?<PiRgUK?<LXf]PiRgPiR]`LO<Y/OP0]?Sm@04H79k4BH:8blY4A`:0R`h
:@0GAUDY=2lY8a`:2@T:LW9kkOKedn?edmWFkOKe;5hmJW9L`LO1`LO<g>?P
kNgZkOKem_ookNgZdmWFkOKeg>?FUHAkUJ6>00?]m_D2m_oo0_ooo`05dn?e
kMW<kLMLm/LNm/L:00?f/`000nBZ0?Jc0?Jc0002i:X00_Jc00;TZP000oJc
0=>40>BZ0007dh@001:iI`31Q031Q031Q02`LP2VC01G700S9PXJ2@XA70XJ
2@XA70X92@X/4P0A70X94PX92@X94PX32@T:00PA70X92@X92@X92@X94PX9
2@XJ2@X/4P02ARH:00=P;`Yb>1Ab9P000g8V0004Pbl0H2l:LRH0LRH00V0_
2P0EARH:Ea`0?A`:ARHDLSPDWXdcPg/cJVLcWW8DJVLcAT4N;2HD6Q`NPcP0
WW8:H44D2A8:6Q8D6PT:0000kOKe067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01nIVIT06?oonokno_om
ooSkomgYfl3GZhF]EhRlCY7<E9SGIJ7MPjKNTjgPWKKTW;kZTL7/T<G_WLC_
X<C^X/C^Y<K^YlS`ZLWaZl[b[0C:kj`2bnjZ0l__ZC3:kjT7b?2Y1LK^Y`0D
a>bU`n^T`nbPa>jJ`NfD^nRC/n>?[N6>Zn6;Y=]nWMEdUl]WQkIFQjiK_]bL
g>g9logbo?ooo_goooko19VIV@@00004VIVI0P0000:IVIT2000000>IVIT0
000000000YVIV@80000019VIV@00000009VIV@800006VIVI0`0000:IVIT2
00000iVIV@80001AVIVI00?oooo<c<c<c<`0GLc<c0<S70X00aX92R`B02`B
00058a`:0QX92P8S70X00b`B01X92R<L2P028a`:00<A70X/4P0A70X00R`B
00038a`:;1806PT:008/4P001QX92R<L2R`B01XB52`B01XB508J2@X01b<L
2QX92R`B02<L2PTB2R`B01X92P024A`:01lJ71h92@XA70XJ4Q@J9Q@A9PXA
9Q@/71@S;bUPGS<dECdS;bTS;ah0000971C:d=J3Q8i6EE8/C2T/>2U6GTNV
/l7:d=K:d<400016C3fEV:>3V:fEXHh000094PX00PT9500B4A`:2@T:6Q8D
/;>gCfMLAUi78blN6Q`NLW9kY/OPb]3F/;k1UIRSg>?P0000UIRS/;k1Y[?1
0/[@eP0:`LO<kOKe4Blm4Blc2BHY6Q`N;5E_Cg9kdn?em_oo0ZK7h0:E/l`0
0iFQ]iFcc:K7h002UK?<0ZK7h005dn?ePhB>?Ehm;2HD=2lN008/>2T03TIE
DZJQV:JQV9FHXjK7h<[@e]cSh5N=SQ4V2Q4L2[2c]k2n`McSh=?Sm@?]m_D0
4]cSh=?SmOoool[@`IF4Nl[@e_KoongfmM?SmOKool[@e/77c?KoooJc0?o@
0>fn?OK72^BZ00;f/`001NBZ0?Jc0>BZ0>BZ0=>40002i:X000Of/`3TZP3C
Q03TZP3CQ03TZP3CQ0000^BZ00;CQ0002^BZ0=>40=>40=>40<640;1E0:I<
06Y12SdL2R<L2P8J2@X02PT92Q4L2QX92QXB50T92Q4L2PTB2QX92PT92Q4L
2P892@X01a4L2PTB2PT92PT92Q4L2QX92SdB2P02Pbl0178V000:Pbl0LSPD
Pbl0H2l:LRH0ARH:H2l:?A8:;180LSP00Yj=<`0@Pg/cWXdYJVLcAUDY8blY
6Q8DPbl0YVL0H44D6RHD2A8:2@TD4A`:2@T:0000dn?eHLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT07iVI
V@0Hoogooocooogom_[khNoF`MbUN:=7O;90R<Q>T==RVmZ1XM^?Z=bD/N2B
^^J7_^R6_NVB_>VH_>RI_NVJ_nVM`>ZN`N^Q`^bT1<C/Y@;6k:<00lK/XLC]
XLC/X`0^a>bS2L?]X`;1jj405l;/X/7[XL7[XL3ZX;kXW[kYV[oWTKcWS[OS
SZkMS:WMRZKNQIgIMiGCJ93:FWbaAGNSA;cLTn7cboGml_oloookooono`04
VIVI0P0000NIVIT400000YVIV@800002VIVI0P000004VIVI00000000VIVI
0P0000RIVIT2000000>IVIT0000000000iVIV@80001AVIVI00?oooo<c<c<
c<`0GLc<c0058a`:;1`D8a`:8a`:4A`:008S70X2;1`D0b<L2P0_;1806PT:
4A`:8a`:;1806PT:8a`:;1806PT:;1806PT:4A`:6PT:;1808bH:;1806PT:
4A`:8a`:;2HD2@T:6PT:8a`:;1806PT:;1802@T:6PT:8a`:6PT:8a`:6PT:
4A`:6PT:4A`:;1804A`:2@T:8blY=5DY2@T:6Q8D=5DY?Ehm6Q`N4BH:6Q`N
008S;bT08S@_<h>HS/77c8=kG14V2TIEDX>4S/77c=?SmG^=Q14V2TmWG:JZ
Xk2n`FZ=G000014V2PTL51XB50TB2P0009FQSR<_:H>=Q4IE:DI<?B`h:L77
c<[@eX>4SZJc`L77c8fHSP0000?1al`03<[@eZK7h=cSh=?IePU1Ab=1?A4_
<b<_<dIEDSAWNjK7h?Koo`>Van001YFcc:K7h9Fcc:Jc`JK7h9FQ]`:Van03
dn?e010dIg]ZLUb3Q8ibLW]PGS=bSHBEZZfVZZ?1alc:d=K1al6=V8i6EBT0
002=V8j`_/44g>?P0ngfm@?]kNX028>4NoKoooKoongfmOKooiFHXjJZ[NBc
A`;f/`000oK7?OJc0?Jc0006m[<000?TZP3fa`[f/`002>BZ000Cm[<0diP:
i:X0dh@0i:X0dh@0diP:dh@0`H@0/5D0LSP0ARl:8a`:4A`:6PT:4A`:2A8:
4A`:6PT:00892@X01@TB2P0000T92QXL7PTB2P022@T:00T94PXA70X94PX9
2@YP;aB3;`1b9P1b>1AP;`X00W8V000<LSPDLRH0LRH0LRH0LSPDARHDH2l:
ARHDNd`:/8@YbZ4mSHe70X=k<`0?H44Y;4`Y6Q8DPbl0/7/DUEDD2A`D2@TD
2@T:2A8:6PT:2A8:8a`:0000kOKe067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01nIVIT06?olooojooom
ooKkmnSgf/SVZW2M?W>/>H31BHW=G9GFNYcGQj7ERZ_HQkCNO;KPN[KSR;CT
S[GUSkOWTk[WU;[WU[[VUk[VV@>liYX00kcWV;gVV;gVU`03_NJG03nliiNl
iiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRl
iiNliiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRliiNl
iiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRliiNliiRl
iiNliiRkj9NkiiRkj9NkiiRkj9NkiiRkj9NkiiRljIRlj9VljIRkiiRjiiJi
iIJii9800[SPRP0?/Mb:Z]Z6XmV1WMUiUMA[S<aJPl=;LZ/hKidj`N>IjO_C
m__doo_oooSooogo00BIVIT200000iVIV@80000?VIVI0P000003VIVI0000
000000BIVIT200000YVIV@8000000iVIV@0000000002VIVI0P0005:IVIT0
0oooolc<c<c<c01Mc<c<00<J9Q@/71@m70X00R<L2P096PT:8a`:8a`:;180
8a`:?A8:8a`:;1808a`:008/4P0011X92R<L2R`B014L2P8/4P001PT92R`B
02`B02<L2R`B02<L2P8/4P001aX92R<L2R<L2R`B01X92R`B014L2P026PT:
01dA70X/4P0J2@XS70X/4P0J2@XA70XJ2@XA70XJ2@X94PXJ71hJ9Q@J4Q@A
9Q@J4Q@J9Q@92A@971@A9PX/>2TS;ahA9Q@971C1al5kSFHS;aj3SHBEV:<0
0/[@eP8A9PX018>4S[2n`L77c1XV50894PX04`T951X92PT92R=1?HfHSTmN
IVZ=G2=1?DI<?FYkQ>gfmH>4S[2n`IFZ[JJZXaXV56YkKl[@e/77c002b]3F
00g1alcLhn2EXKLAC58/C2TS;c<S;bTS@E8m;cfVan3foooChoFE/l`00ZK7
h006UK?<Y/OPY/OPUJ6gPiRgUK?<0jK7h009dn?e4DaBLXf]`LO<Y/OPEhf>
;5hmJW9L/;k100;CfMH04/[@e[2c]g^=Q14V2R<_7ZJQV<[@e]cSe]cSh>g]
j]?SmNgfmOKool[@e^g]j]?SmMcSh:J4Q0;oool01?Kooh>=Q=cSh?nc00;f
/`001?o@?OK72^Bc:NBZ00;f/`001OK72^BZ0>BZ0=>40?K72P02i:X00_Jc
00;TZP001OJc0>BZ0>BZ0>BZ0?Jc0004i:X00]>40005`H@0/780Pd40Ea`0
8bH:00<J2@X01Q4L2QX92QX92Q4L2PT92PTB2P8A70X22@T:00T92A@A70X9
2@X92A@m4PZ3;`1b9P23;`1b9P000W8h509b9P000f0_2X<_060_2P02H2l:
00EG701P;`ZEEAB`SE:ESE800X=k<`0=PehD;2HD6RHDPbl0/5D0PehD4BH:
2@T:2A8:6Q8D4A`:6PT:6Q8D008S70X00aX92^gfmLc<c01Pc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0O
VIVI01SonooonOoooOohoOO`onGBkkE^Vd1_ZCUb]Sem`dn;cF^CcgVIcWbS
d7^^eWJbfWN_g7f`gh>chXJehhVfi8bfhhjfhXfdghd3]Mn=0[GOR`03]Mn9
]mn9]Mn900:eghT0?[GORkGORKGORkGORKGORkGORKGORkGORKGORkGORKGO
RkGORKGORkGORKGORkGORKGORkGORKGORkGORKGORkGORKGORkGORKGORkGO
RKGORkGORKGORkGORKGORkGORKGORkGORKGORkGORKGORkGORKGORkGORKGO
RkGORKGORkGORKGORkCPRKCPRkCPRKCPRkCPRKCPRkCPRKCPRkCPRKGQS;KR
RkKRSKKRRkGQS;CPRK?OR[?MR@:behL03j_FQ:CDOYgDMYKCJhW<FGo3BWBd
>V^U=76N?lg^ZO?oh?Oim?ojoooiooomo`05VIVI1@00012IVIT2000000>I
VIT0000000001IVIV@@00002VIVI1@0005>IVIT00oooolc<c<c<c01Mc<c<
00Dm70XS9PXS9PXm70XS70X00R`B00036PT:?A`:6PT:008/4P006R<L2R`B
02<L2QX92R<L2QX92R<L2R`B01X92R<L2PTB2R`B02<L2R`B02<L2R`B02<L
2QX92R`B01X92R`B01X92R`B01X92R`B01X92P8/4P0022<L2QX92QX92QX9
2R`B014L2PTB2PT92P8A70X01A4V2Q4L2PTB2Q4V50TB2P024A`:010J2@XA
9QhJ71hA70X92@X/>2V=V8hA70X/GSfVZZfEXKOfool/C2TA9PY6C3f=V8h2
`LO<01@A9PX971@A70XA9Q@92@X971BVV8APLW^3V8i6GTL/9QA?GVIZNhC]
m_FVZZf3V:g1al4S;ah00031al`3b]3F00jVan3:d=Kfm_EGSHhA;c<S@CdA
;cdm;cdS@E8/EEb3V;OChoGfoonE/l`5Y/OP01NE/labSJfE/lbE/lbVan3C
hoFVan0J71jE/lcChoFE/l`971@99RTd;c>`_/71alc:d=K1alcCfMK1al56
EBT94PXS;ah00/[@eP03g>?Pdn?ekNgZ00?]m_D2dmWF013]m_GLhmJ`/kOf
oonVan2=V8iZNfood3fEQ5:EQ7^=SFnEQ7_:d=Kf/`3fa`[TZP03m[<000CC
Q03faakf/`3TZP04m[<000Ofa`[TZP3f/`3TZP3f/`3TZP3f/`000nBZ00;C
Q0001;UW08<_04HV2R`B008A70X010T92Q4L2QX92R`B008A70X42@T:00D9
4PXA70X92@X92@Xm4PX00g8V0005Pbl0LRH0LRH0LRH0H2l:00=b9P006dHV
560_2THV59iN59j=<iF4DX=k<fYE7X=N56YE7R<_7THV2[1E08=N52`V5000
00T92QX92PT9514L2QX92QXB52`B02<L2SdL2P000=?Sm@1Qc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0O
VIVI01Soo?onnOoooOoio_[gonoImLA`Vd]`YcmXZCEd^DB3aUf<bFZDbW:P
cWJ]e7Vaf7^/eg^^fh2agHBehHRfhXfdh8^cgH^afhT2]]f>0[KMS0:fgHX0
0kOMR[KMR[KMRP0^]]f:2kCNRP0G]Mn;]=j:]=j:/mf9/M^7/M^9[=26[M67
Ym:2X=5fV=5ZSlmMP/I=Mk]0JZTdJJ4fMJ5<f?Jjn?oZmoWdoo[oooWooogo
08:IVIT00oooolc<c<c<c01Mc<c<01<S9PX/71@S70X/71@/4P0S70XA70Xm
4PX/4P0S9PXS70X/71@S70XA70X/4P0J9Q@S70X/4P0J2@X00R<L2P03;180
6PT:8bH:008/4P028a`:00L/4P0S70X/4P0J2@X/4P0S70X/4P000R<L2P04
4A`:6PT:6Q8D6PT:0R`B00046PT:6Q8D;1802A8:0Q4L2P8J2@X06A4L2QXB
50T951XB514V50T951XV50TL51XV50T9500004mNIW9EDR`V58>4S[2c]l77
c<[@eP0001XV54mNIYFZ[L77c:JZX`0000022A`D01X0000S;c>VZZ=?IdNV
ZZe6GTLS;ah/C2VEV:>`_/71alb3V8j=V8j=SFl00016C3gChoG1alcLhn3:
d=K1al7CfMKfooldIg/S@Cd99RT28blc00LS@CdS@E9bSJgChoGfoooChoFE
/l`00jK7h00Tb]3FUK?<LXf]PiRgUK?<dn?eY/OP=6Mk;5ELY/OPm_ooY/OP
4DaB8d4m2A8:LW9k`LO</;k1g>?P`LO<g>?PUJ6>2A`N0000YZZ]b]3FdmWF
g>?Pdn?ekOKem_ookNgZg>?PdmWFb]31oooo0ZJZX`0=AVMLH5hcH44YUHAk
SHe_UJ6>WXAVJVLc`LO<ok<0m/Lmi:X0m/L:00;f/`02i:X00_Jc0003i;<N
m/L:m/L:00?f/`001oK72_Jc0?Jc0>BZ0?Jc0>BZ0?Jc0002i:X000gCQ031
Q02EE@16;`Xm70X/4P0A70XJ2@X92@XA9PXJ2@XS9PX94PX00`T92P064A`:
00002A8:2@T:6PT:H2lD0W8V0003LSPDLRH0LRH000=b9P001H<_060_2THV
2W8h07]<2P02WXdc012NNc>3Nc>3GQAZEAh/C2TJ4QAG702NGQ@A9PX92@X9
2A@J2@X92@XA9QhS70XJ2@X2;18000DS9PX/71@S70X/4P3]m_D0HLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bI
VIT07iVIV@0Fookkm_;aookoo?oon?ohg_KDYl^;FH``Hj4dJZdiNKa;SlaT
Rl5SX<id_>B>]=Z7^N2?]=j<]]n@_^NH`nVN_nFJ0[_QV0;0i9h2`>BL1L;T
VS30i9X7_nFJ00?0iY^oiI[0iY/00/3VV`0D_N>H^=jC]=VC^MbL`>FRXlin
YmUhW=IVO[i4O/12HJ<XEI0THiHjU;]hl_oOlooYn__foo_oooKoookoPYVI
V@03ooooc<c<c<c<05g<c<`48a`:01</4P0S70XS70X/4P0/9Q@/4P0S70X/
4P0S70X/4P0S70X/4P0S70XJ2@X/4P0S70XJ2@X/4P094PX00b<L2P0:?A8:
;1808bH:;1808a`:;1808a`:;1808a`:;1800QX92P088a`:;180;1808a`:
6PT:8a`:;1808a`:0PT92P046PT:4A`:2@T:6PT:0Q4L2P0g6Q8D4BHD6Q8D
2A8:6Q8D2A`D4BHD2@T:;4`YAT`mAUEBUIRS`LO<dn?e?Ehm4BH:8blNJW]_
/;k1`LO<LXdm00002A`D6Q8D2A8:JW9LNheVEfMBUJZ]NheVAUDYJW9Lb]3F
`LO<YZZ]Nhf4YZZS4BH:2BHY/;>g`LO<b]3FdmWF/;>gb]3Fg>?Pdn?e;6ML
8d4m?Blm4Blc8blc8d4m?BlmCg9k00;ChoD00oKooiFcc:K7h003Y/OP016E
/labSJf3V;NV/l7ChoEbSJdA9QiGGVnVan3ChoFVan0dIg/mLX@A9QhdEBV`
/kO:d=H00/77c0;:d=H01F1N<a4V2UMWD/[@e]?IeP02g>?P0^gfm@0<kNgZ
`LO<g>?Pg>?PdmWFm_oei=3<SHe7H5hcJVLcWXAVUIQV0[2ZQ005JW9LdmWF
m[<0m/LNm/L:00?f/`001m>H2_K77_Jc0>Bc7_K72_K77_K7?@03m/L:00?f
/`3fa`[f/`000oJc00?TZP02dh@000>EE@1G700m70X00Q4L2P076Q8D2A8:
6PT:;180;2HD6Q8D4A`:00<92@X01Q4L2PT92PT92R`B060_2X<_00=b9P00
278h578V078V078h560_2V0_58<_0;2=<`:NSC<2Pg/c00eZ@@Y6@AhJ4Q@m
70Z3@@1Z@@X0000J4Q@94PXA70X92@XS70X/4P0012<L2P05;1`DARHD8a`:
;180dn?e067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
1<c<c003IVIVc<c<VIVI01nIVIT06?oom_oon_onoo_loo?lmo?okkWFYUEo
=Df38eVD:6VW>7NbA[G[RKk/U;?JRm;f[<W]YLCYXl?XXlS]Z<c_[lW/[<SZ
[LW[[P;:jJh2b^V]00?;jJg;jJ_;jJ/00/_YZc3:jZ/7b>^[00?9k:c8jj_9
k:`00/[][@0DbNb/aNRX`nFX]]NNb^j^`NbL]nV6ULiKLJlbKjldI:<`HILi
FhHn]MFTjooSnoofo_gkoo_noocoookoPYVIV@03ooooc<c<c<c<05g<c<`0
12<L2R<V2SdL2SdL2P<S70X010T92R`B02<L2SdL2P<S70X01R`B02<L2QXL
7R<L2R`B02<V2P8S70X01`T92R`B02<L2R`B02<V2QX92R`B00028a`:00l/
4P092@XS70X/4P0S70XJ2@XS70X/4P0J2@X/71@A70X/4P0J2@X/4P0S70X0
0Q4L2P042@T:4A`:4A`:6PT:0Q4L2P042A8:6Q8D2A8:4A`:0PTB2P0>6Q8D
2@T:?EhmAT`mNhf4UJ6gb]3FPiR>4BH:4BHN=5DYJW^4b]3F/;>g0Q4V2P89
4PX07b`h:FYkKc@_<k2c]g^=Q4INAeN=G9FZ[L[@e/77`H>4SYFZ[Ba<:@00
0;2c]jJZ[L77c<[@e[2n`JJc`M?Ie]?SmL[@eQ4_?B=1?A4_<b<_:A4_<b=1
DRaEG5MNK`02dn?e00?foonVan2Van001:K7h00HLXf]PiRg/;k1dn?e;5E_
;3PYLXf]dn?em_ooUK?<LXf]PiRg2A`N4BHDLW9k/;>gg>?PdmWFY[?1g>?P
UJZ]CfM70000`LO10]?IeP0;g>?PkOKem_ookNgZ/;k1g>?Fm_Keb]3Fg>?P
m_oo`K>]00:ESE8029FQS/6cS/77`G:=?H=N<nC@c?Jc0?K72P?f/`000oo@
0>BZ0?K72P02m/L:00CofBWfaakfacgfa`X2m/Lm0_K72P06om00m/L:m/LN
m[<0i;<Nm[<00^BZ000<dh@0UED0H2l:ARH:6PT:8a`:2A8:4A`:6PT:;1`D
ARH:8bH:0Q4L2P072A8:4A`:2@T:2A8:4A`:;180LSPD00Eb9P00260_560_
2V0_2W8V09ib5;2=<iF4DX=k<`9ZEAh024I17R<_7R<L2V0_2VY12PTB2PT9
2PTB2P<J2@X022<L2QX92R`B02`L52<L2SdL2R<L2R`V508m70X00b`B0>gf
mLc<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@0OVIVI01CnonooooKoooogn?cho?ohoo[PmMJ>[gQP
SCa:OQa[XSYk/TZGbfW2l9Rcg92kh9_<k[78jK35iZo7j;42b^Rf00?;j;S=
j[c;i[T00/_V^@04bnNgc>Jgc>Jgc>Jf<<_W]PW:j;H3bNNe01K:j;K<j[S<
j[S:j;K6i[CCm/2khZ>_fXZijhR`iWB4_TIMURE:PAa?Nc23Z7CXon?eooCk
oo[ooogooO_onoWooof2VIVI00?oooo<c<c<c<`0GLc<c004ARHD;1`D8a`:
=2lN0R`B00038a`:4A`:8a`:008S70X2?A8:00`S9PX/71@/4P0J4Q@/4P0S
70XJ2@XS70XJ2@X/4P0S70Xm70X38a`:00L/4P0J4Q@/4P0S70X/71@/4P0/
71@00R`B008J2@X012`B01X92R<L2R`B00<S70X011X92Q4L2PT9514L2P89
2@X05A4L2QX92Q4L2QX92QXB50T92QXB50TB2Q4L2PTB2UMWDX>4SZJc`L[@
eVYbG4mWAdIE:DI17TIE:K2c]ng]jP024BH:00P94PX971@0002`/kLJ2@YZ
Nfo1alakSH@2LW9k00W1alb`/kNV/l6EZZd/C2T0001?GVKCfMJV/l400/[@
eP0@UJ6g`LO<g>?Pdn?eY[?1;5hm8d4m?Blm8blc?Blm;5EL?BlmH79kY/OP
dn?em_oo0jK7h005`LO<Y/OPY[?1LXf]PiRg00:Van028d4m00]bLW_ChoGf
oonE/lbVan0dIg/S;bTJ4QA6C3ePLW_Lhn001<[@eP06UJ6>0000JW]_`LO<
b]3Fg>?P0^gfm@09m_oo/;>g`LO1oooo/;k1b[j]kNgZooooAT4N00;1/hh0
1iFQS[2ZQ61N<h=kG?K]j_Jc0?oI:@02m[<000kfa`[faakTZP3faakfacg]
_SgffFKfaakffFKofBWofCgffFKofBWofCd3m/L:00?f/`3fa`[fa`X00^BZ
0006dh@0/780H2l:ARl:8a`:4A`:0QX92P074A`:?A8:JT4:8blN6RHD6PT:
6Q8D00894PX011XB51X92R`L58<_00Ab9P001W8h55LL060_5:Ib5;2=<kV=
<`:3Nc<03fYE7V1152<V2QXB54HV560_2R<V2PT92QXB50T92QX92Q4L2QX9
2R<L2SdL2P058a`:00I69Q@m4PY69PY69PX/4P3]m_EQc<c<00AVIVJ8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0OVIVI
01Skoo3joO;ooogoo_oloOolooohooCSnM=TQTU5L21<OB5_Xd6:^enfiY2c
gI7?m[?9k;;7j[C6jK?6j;G7ikK8j;W8ik_9j;`2bnRl00?;ikk;j;c<ik`0
0/cW^P1Bc>Rhc>NjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRh
bnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRj
bnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRhbnRjbnRh
bnRjbnRhbnRjbnRhbnRjbnRhbnRjbNVhbNVjbNVhbNVjbNVhbNVjbNVhbNVj
b>RganNhb>Rgb^Zkb^Zib^ZkanVf]]bS`NZVaO:QY]EgP[E<K:0dDH4N@VdK
NiiTeO7;m?ofnOomm?Keo_gkookjoo[dooomPYVIV@03ooooc<c<c<c<05g<
c<`022`L52`V52`B02<V2R`L52<L2QX92R`B008m70X01B<V2R<L2R<L2R`B
02<L2P02;180014S70X/4P0J2@XS70XS9PX92@XJ4Q@S70X/4P0m4PX/4P0S
70X/4P0S70XJ2@X/4P0S70X00R`B00048a`:;1808a`:;1800b<L2P076PT:
;1808a`:;1806PT:4A`:2@T:00<A70X00`TB2QXB50T92P024A`:02492@XJ
2@XA70X971A?GVJ`/kO:d<5bSH@/>2UZLUa6EBUZNfm?IdNVan31al`0000A
9PX971@J4QAGIe9?IeakSHBVZZ=PLW]?LW^`/kN`_/7:d=JVZZf=V8j=SFl9
4PX000000/[@eP;1al`02;2n`L77c<77c=?Ie^gfmH>H]cebQ2=1DP8S@Cd0
13d_?B=1?BaEG6YkQ0:Van02m_oo01JE/lbVan2Van2Van2E/labSJf3V;NV
/l6E/l`S;c<m;cf3V;OChoGfoon3V;OfooldIg//EFlA9Q@d;c=6C3f`_/42
dmWF00F`/kO]m_G:d=HA9PXJ71h00/77c00Mg>?PkOKekOKem_oob]3FLW9k
kNgZg>?F/;k1YZZ]g>?Pb]31`LO1NheVJVLcAT`mH2lDi<O1ong<m[<0m/LN
om00m[<0m/L:m[<0i:X0m]UVon>>onf>00;ohh@3m]UV00WofCgffFKofCgf
a`[]_Sgfa`[f/`3faakf/`000nBZ000=`H@0LRH0ARH:8a`:6PT:4A`:6PT:
4A`:;180Nd`:ARl:=2lN8bH:00892A@01@TB2QXB50T92R`B078h5002LRH0
019P;`YP;aAP;aB3@@2`Q2VNSC>NSBV3Nc>3GQAZ@@YZEAhA9QA69QAP;`XS
9PX92@XJ4Q@92@X24A`:00DS70X/4P0S70X/71@S70X00SdL2P04ARHD?A`:
?A`:;2HD0THV2P03?A`:?A8:kOKe067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c09VIVH00lc<c9VIVIVIV@0MVIVI01SkooSh
oOKnoogooooln_ogmOSloo[honoaomiVR4a<M2]OS3^B`VjFaGC2lJ>ScXJh
hInkhJBmhjJni:W0hj_0hjfohZbnh:d2`^:`00?2h[72h[34h[000/CR[P1?
`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/
`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^
`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/`^>^`^>/
`^>^`^>/`^>^`NB/`NB^`NB/`NB^`NB/`NB^`NB/`NB^`NB/`^F_`>>[_n:/
_n:Z`>>]`>>[_^6[^n6V]N2K[]bA]>B@YM=kO:U>EH0WCG<XIXQ;iooIm?oa
k_WanooooooooOcj00;oo_X00ooooIVIVIVIV@20VIVI00?oooo<c<c<c<`0
GLc<c0048bH:?A`:?A`:8a`:0R`B00048a`:;1808a`:;1800SdL2P038bH:
?A8:;180008S70X01QX92R<L2R<L2QX92R`B01XB508/4P004cdL2R<V2R<L
2R<V2R`B02<L2R`B02`L52`B01X92R<L2R`B02<L2R`B01XV51X92R`B01XB
52`B00028a`:00L/4P0S70XA70XA70X0000A70X92@X00PTB2P044A`:2@T:
2@T:4A`:0Q4V500F=2lYUIRSb]3FEhf>0000UJ6>NheVAUEBPiR>PhB>kNgZ
4BH:00002A`D0000=2lNUJ6>4BHDSIR>b]3FSIR>2A`D0[2n`@07`LO<UJZ]
SIR>;4`Y0000PhB>b]3F00?1al`02[2n`L77c<77c>gfmH>H]baEKbaEG3d_
?BaEG3d_?@8S@E8012=1?CAWNk2n`JK7h0;fool03JK7h9Fcc:K7h<77c9Fc
c8>H]iFQ]jK7h8>4SR<_<f1bNh>H]oKoo`02dn?e01jVan1bSJebSJdA;c<A
9QhdECf3Q8kCfMK:d=KCfMK1alcfoomZNfl0002VXIS1alcCfMKChoG]m_Gf
ooo]kNYZLUc1alc]kN[:d<6`/kOTd<c]m_G1al56;`X22A`D00EP@BWfooo]
aeco/`3facd01?K72P03m[<0on>>onf>00CokHh00ooSQ?oI?OKIIP02omTm
00?ofBWofCgfa`X00oK72P?TZP003l6406Y12ULL02<V2Q4L2Q4V2PT92QX9
2R<L2W]<2V11:DHV54H_2PTB2Q4L2P032@T:01Hm4PYb9P1P;`YP;`Xm4PYb
>02NLPZiQ2VNSC>NNc>3Nc>NSBV3GQ@J4Q@S70Y69PXS70XA70X92@XA70XJ
2@XA70X36PT:0R<L2P03;180?A`:ARHD00Hm70X2ARH:00</4P3ChoG<c<`0
H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00AV
IVK<c<aVIVK<c<`NVIVI00CioogkoognoogooOh2oocn01;noOWioo?hong[
omaPPDY=MS9DPSN4]FAhZEN/fh^Sch:YeHZ^fXn_fY:afYBbfiNafYJ^eiD2
/MRG00>af9Vaf9NceiL00[?HU@1B/mRC/MRE/MVC/MRE/MVC/MRE/MVC/MRE
/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC
/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE
/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/MVC/MRE/=VC/=VE/=VC
/=VE/=VC/=VE/=VC/MZF/=VC[mRD[mRB[mRD[]NA[=FAZ=>;XM:1U/QcSKeY
NjQEBW<U=U/EPZ5XiOkDmOo]looanoomm?Ggooooookoo?SeookkooomPYVI
V@03ooooc<c<c<c<05g<c<`00b<L2SdL2R`L50038a`:00H/4P0/71@/4P0S
70XS9PXm70X2;18000LS70X/4P0S70Xd;ah/4P0S70X/4P000Q4L2P0>;180
;1`D;1808bH:8a`:;1808bH:6PT:;1808a`:6PT:8a`:;1808a`:0QX92P8/
4P000b<L2R`B02<L2P02;18000<S70Xm4PXJ2@X00a4L2P042@TD6PT:2@TD
4BHD0Q4L2P0E6PT:2@T:AT`mYZZS`LO<2A`DAT4N;3PYUIRSNhf4JW]_PhB>
UJZ]UJ6>00004BHD2@TD2@T:UJ6>8blNAT`m00;:d=H03dIWG0TL5<77c;2c
]l77c8>4SYFQSP0004I<?K2n`M?IeZJc`L77c;2n`L77c003b]3F00b3Q8jV
ZZfVZZ>EQ8jNQ6JVLU:ELTM?GVHS@E9GGVnVan3ChoD2m_oo00cChoFE/lbV
an2Van2E/lb3V;NE/lbV/l5?LW/m;cebLW^3V;L3dn?e00N3V;NE/lbE/l`A
;c<dECdS;c=6@Ah00/[@eP08dmWF`LO<b]3F`LO<8blN=5DYYZ6H`LO<0ngf
m@0?m_ooPiR>SHe_kOKe/;>gb]3F/;>gg>?PkOKe`LO<ARl:UG97`LO1onf>
m]UV00;fa`X02_K7?OJc0?K72_K72_Jc0?oSS_o]c?KomOo]S_oSQ0;okHh0
2ooSQ?KII_KII_oI?OKII_oI?OoI:OK77_K72^Bc7_K72P02i:X000G1Q023
;`1P;a@S9PXJ2@X00Q4L2P0C6PT:8a`:Nd`D/8@YPehDH44D2A8:2@TD6PT:
6Q8D4A`:;180H2l:ARH:LRH0WUhDdj4YbZYVYZ5V00>NSBT01dH_2QX92R<V
2R<V2QX92Q4L2PTB2P046PT:00DS70X/4P0S70Y69Q@m4PX01SdL2P07ARH:
?A`:ARH:?A`:ARH:;180kOKe067<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c005IVIVc<c<VIVIIVIVc<c<01fIVIT06?GoooWo
ookooOkmnOonnoomnoomoOgln?7gkOOolO3oiW>HHUn<Ace^7EJ;<fbQAG^^
Ch>fEh^lH8bmHXfnHi31J971JhjnJ0:A_VT00i6nJi6nJI:nJ@02T[iW04fB
_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB
_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB
_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB_VNB_VFB
_VNB_VFB_VNA_fFA_fNA_fFA_fNA_fFA_fNA_fFA_fNA_fFB`6RA_fFA_fNB
`6JC`FVA_fF=^f>8^Eim/e=i[e5?PBXoJaiCNSVB/7cUo]Oeonc[m^K_m^kn
ooggmoT00oono`03oognooooVIVI086IVIT00oooolc<c<c<c01Mc<c<00Lm
70X/71@/4P0/71@m70XS70Xm70X00R<L2P03?A`:8bH:;180008m70X02b<L
2R`B02<L2R`B02<L2QX92R<V2R`B01X92R`V52`B0002?A`:00X/4P0S70X/
4P0/4P0S9PY69PXS9PX/4P0S70X/4P028a`:00`J2@XS70X/4P0d;ah/4P0J
2@XS70XJ2@XS70XS9PXJ2@X94PX34A`:00<J2@XA9Q@J2@X00Q4L2P0=0000
SIR>YZZ]0000EfMBYZZSJW]_YZZSJW]_UIRSUJ6>dn?e0000008971@05000
0:JHQ2<_:A4L2X>4S/77c=cSh14V2UN=G9FHXk2c]iFZ[JJZXceN?@000;2n
`IFHXmcSh9FQ]l77c0:`_/403L[@e]cSh:JZXjJZXjJHQ:J4Q9F4Nij4IX=k
G9EbAg9EDRaEG8>H]`02Y/OP0]?Sm@0Gm_ooY/OPY/OPY/OPUK?<PiRgUJ6g
Y[?1AUEBCfMLLW9kUJ6gdn?em_ooUK?<PiRgdn?eY/OP4BlcCg9k8d4m6RHD
LW9k00;:d=H01McSh;2c]ooooiFQ]a4V2P02UIRS01O]m_GChoGfooofooo1
alaZLUcCfMK:d<7:d=K]m_F`_/6V/l71alc]kN[fooookHkfd8CffFKf/`3]
_SgofCgfa`[ofBT00_K72P03on>>onf>onf>00;okHh3on>400WffFKohhCo
fCgffFKofCgfaakfacgfa`[facd00nBZ0003diP:Nd40LSP0008S70X02AX9
2PT92Q4L2R<L2V0_2[24:Iik<heE2Q4V50024A`:00l92@XA70XS70Xm70YG
702iSABNSBViZVn=SDNNLQB3Nc=6@Ah/71@J2@XS9PX00PT92P034A`:6PT:
4A`:008J2@X022<L2R`B01X92Q4L2SdL2R<V2THV2THV50<m70X00dHV2R`L
54HV2P04ARH:00</4P3ChoG<c<`0H<c<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P4c<c<00IVIVK<c<bIVIVIVIUVIVK<c<`LVIVI01Se
ooohooolo__ooo[oo_SomoGnmOKoo_onoogeooG_on[[omoXom;>ok9TVCm<
Q24mM0i6OQ=?Pai@Q1mAQB5FRRIHRbaFRBX4FH//0U^::S9KRbP8FH/X00=H
RRMIRbQJS2T00Ub>:`0AFX`YEXPUDXHR>g8<AgdKIiU2boN/kOoFi_oGm?oZ
mooanooho?okl?3^oooooogonoWl00;oo_l00ooooiVIVIVIV@20VIVI00?o
ooo<c<c<c<`0GLc<c00A;2HD;1`D;1804A`:?A`:;1`D8a`:;180?A`:?A8:
8bH:?A`:8a`:?A`:?A8:;1808a`:008/4P003B<L2QX92R`B01X92R`B02<L
2R`B03dL2R<L2SdL2R<V2R`B02<L2P02;18000</71@/4P0/4P000b`B0004
?A8:8a`:;1808a`:0b`B00048a`:;1804A`:6Q`N0PT92P0W4A`:2A8:6PT:
4A`:6Q8D4A`:0000`LO1AT4N4A`:`LO1SIR>Phf4SIR>LW9kUJZ]`LO1SIR>
00006Q8D2@TD8blNEheLEfMBJW]_UJ6gb]3F/;>g2A`DPiR>SIR>/;k1Nhf4
SIR>0000LUEBJW^4UJ6gb]3F00:`_/401JJc`L77c<[@e[2n`Mbn]`02b[j]
00R`ZXB`Q7^NQ6J`NfJNQ6JELTM6C3eZNh@2Y/OP013ChoGfooofoooChoF3
V;NVan2V/l63V;NEXKNE/la?GVIPLW^EV:>`_/7ChoGfool2PiRg01?ChoG:
d=H9@DN3Q8j3V;L94PYGEE9ZNhC1alcCfMKLhn3:d=K]m_DdEBU6EBW1alb`
_/7:d=K]m_D00_Koo`03UIRSdmWFdn?e00;]m_D01]cSe^gIc>g@V?oSS^fn
?OK7?@;ffFH01Oo@0?Jc0?K7?OK72^fn?@02m/L:00CohhkokLcokHkohh@2
onf>0_oSQ007m]UVon>4omTmomTmm]UVomTmm/LN00;fa`X02oJc0>BZ0=>4
0=>H2X<h06Y12R<V2R`L51X92QXB50T95002;18000k:ZTNNSC>`Q2T94PXJ
2@X92@XA70XJ2@X92@Z=E@ZVXFJNSBV3Nc=ZEAh2AT4N00@A9QhJ2@XA9PXJ
2@X22@T:00@A70X92@XS70XJ2@X28a`:00@/4P0/71@/4P0S70X4?A`:00=6
9PXm70Xm70X00SdL2P03ARH:?A8:?A`:00969PX00b`B0>gfmLc<c01Pc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<
c9VIV@02VIVI00=VIVK<c<c<c<`0olc<c0k<c<`00oooolc<c<c<c01Mc<c<
02A69Q@/71@m70X/4P0/71@/9Q@/4P0S70X/4P0S70Xm70X/4P0m70XS70X/
71@/4P0S70XJ2@X/4P0m4PX/4P0S70XA70XS70X/4P0/9Q@m70X/4P0S70X/
4P0S70X/4P0A9PX/4P0m70X/4P038a`:00PJ2@XS70Xm70XS70X/4P0S70XJ
2@XS70X26PT:00LS70XA70XA70X92@XA70XJ2@X94PX00PT950062A8:;3PY
=5DY4BHDYZZS`LO<0W^=Q00KCeiVYZ6H/;>gEheL00004BHD00008blNPhAk
AT4N8blNPiR>/;k1b]3FNhf44BHD=5DmYZZSUJ6>`LO14BH:0000/;>gAUEB
g>?P/;k1`LO<00:`_/402<77c<77`Mbc[L77c>C7`Mbn]l[@`JJ4Q0:`Q7/0
1ZJ4Q:JQV;24NcAWNiFcc:K7h0;ChoD2m_oo00[ChoFE/lbE/lb3V:fEXKNV
/l5?LW]bEE:3V:fVan02m_oo00EbSJfE/lcChoFVan0/EE`00ZK7h00?0000
UIRSLW9kUJ6gdn?ekNgZUIRSooooYZZ]=5DY/;>g`LO<Y[?1dn?ekOKe00Cf
ool03^gfmNg@V?K72_K7?OKII_K77_oI:OK7?OK@Q?oSQ?K72_K77_KII_o@
00;ofBT01Oo@0?KII_o]c?o]c?oSQ003onf>00GohhCffFKffFKofCgffFH0
0_oI?@04m/Lmm/LNm/L:i;<N0nBZ0003SED:LRH0ARl:008A70X021X92Q4L
2R<L2QX92[1k:LZQD[2=<b<_7P8A70X030T92PTB2QX92Yj=<fYW<dI17S@_
7Q4V50TB2P00014L2QXB50<94PX02a4L2PT92R<L2QXB52`B02<L2R`B02<L
2R<V2SdL2R<L2P04?A`:00@S9PXm70Xm70Xm70X6ARH:00<m4P[ChoG<c<`0
H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT00iVIVOmVIVH@IVIV00?oooo<c<c<c<`0GLc<c0@S70X01b`B
04I<?CdL2SdL2R<L2R`B04HV2P028a`:00@m70X/4P0S9PX/4P038a`:00LS
9PXJ2@XS70XS70Xm4PX/4P0S9PX012<L2P05;1808a`:?A8:8bH:8a`:008/
4P000b<L2R`B02<V2P02?A`:03HJ2@XS9PX/4P0S70X/4P0A70XJ2@Xd;ahJ
4Q@A70XA9Q@92@XJ4Q@A9Q@J4Q@0002`ZX@94PXmGSfEZZebLW/mGSf=SFn3
V:fV/l6EXHh0000A9Q@94PXS;c=ZNfl00031al4J71iZLUc1alc:d=I6EBT0
001ZLUbVZZebSHBVXIP00016C3e6EBW1alc:d=IkSHC:d=J`_/71alc1/jgL
_[L2i=3<0]cSeP03g;jg`J64YZ6H00:VV8@2`J6400BVQ8BE/lbVan3ChoD2
m_oo0m?Sm@:3V;L06iFQ]jJc`G9EDW9bNiFQ]m?SmOKoom?SmG:=[H>H]m?S
mIFQ]eMNKm?SmIFcc0TL7R=1?L77`G9ED/77c<[@e^gfmIFQ]oKooiF4SVYb
G=?IeP02b]3F01C]m_GChoG]m_Gfm_G]d9SffFKfa`[ofBWfacgofBWfa`[f
/`3]_SgokHkohhCfa`[ofBWfacgfa`[]_Sd2m/LN00?]aecokLcokHh01?o]
SP03on>4m]UVonf>00CffFH01?K72_oI:OK7?OK72P;TZP002=>408=107]<
2SdL2R<L2QX92Q4L2R<L2P8J2@X01LZH:MbcQ<ZZAfY12PTL50024A`:0R`B
000BbZ4mPehDPehDARl:;3PY6PT:8a`:6Q8D2A8:2@T:6Q8D2@T:6PT:2@T:
6PT:;1808a`:6PT:0SdL2P05ARH:?A`:?A8:?A`:ARHD008m70X013dB2THV
2SdL2THV2P8m70X2ARH:00A69QA69PXm4P[CfMIQc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@3oVIVI4iVI
V@03ooooc<c<c<c<05g<c<`01SdL2R<L2R`B03dL2R<V2R`B008S70X02SdB
2QX92R<L2SdB2R<L2SdL2R<L2R`B03dL2R`B00<S70X02B`B01X92R<L2SdL
2R<L2THV2R`B03dL2R`B00036PT:00//4P0S70YG700S70X/4P0m70X/4P0m
4PXS9PX/4P0m4PX00R<L2P0i4A`:8a`:6PT:4A`:2A8:8bH:4A`:6PT:4A`:
;1802@TDAUDY4A`:CfM76Q`N=5DY?Blm?EhmEfMB;4`Y/;k1/;>g00002A8:
2A`D2@T:JXeLAT`mJW9L/;>gNhf4JW9L`LO<Phf44BH:?EhmLW9kNhf4`LO1
4BHD2A8:SHe_CeiVg>?P/;>gUJZ]/;>g/;k1YYR4g;>]i<O1kMW<m^gZg>?P
kMW<i=3<b[j]00?L/j<3g;jg00?:_Zf`/kO:d=H00]?Sm@0:m_oodn?edn?e
Y/OPLW9kPhB>YZZ]LW9kPhB>UIRS0]?Sm@0Cm_ooLXf]PiRgY/OPPhB>PiRg
m_ooUK?<4DaB?BlmCeiVkNgZPhB>`LO<kOKe`LO<b]3Fdn?eEeEB00;CfMH0
2<77c>gfmOooongIc>fn?OoI:OK7?OK77P?facd04oK77_Jc0?oI?OK@Q?oS
Q?o@0?K72_KII_K72_oI:OJc0?oI?OJc0?o]c?o]S_KII_o]S_KII_o]SP02
on>400WokHkofCgohhCohhCofCgfacgod03]aecfaah00nBZ000?UED0LSP0
ARH:4A`:8a`:4A`:2@T:8a`:6PT:WW8:kM2HbZYVWW8D2A`D4A`:008J2@X0
1`000>BcAij=<h=k<h=N54H_2R<V2P024A`:00@92A@A70X92@X92@X24A`:
0b<L2P03Ea`0?A`:?A`:00<m70X00b`L53dL2SdL2P02ARH:00=69Q@m70Xm
70X00cdL2P05Ea`0;2HDARHD;180kOKe067<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01BIVIT2ooom1?ko
o@;oo_l05_olo_omoookooKfn?;hn>Kel]K[i]?XhloNfM7MfM;MfM7MfM;M
fM7MfM;MfM7MfM;MfM7MfM;MfM7MfM;MfM7Mf@;BgMT`d]cK01SBgMWAgMWB
gMWAgMWBgMWAgMWBgMWAgMWBgMWAgMWBgMWAgMWBgMWAgMWBgMW?g]W;h=_<
h]oGj^KWlo7cnOOino[noO_ooOd2oocm00OooOooo_ooo_ooooonoooloooo
ool0SIVIV@03ooooc<c<c<c<05g<c<`00b`L52<L2R`L5002;18000TS70Xm
70Xm4PX/4P0/71@m70XS70Xm70X/4P000SdL2P03;180?A`:6PT:008/4P03
8a`:00@m4PX/4P0m70Xm70X38a`:00L/4P0S70X/71@S9PX/4P0S70X/4P00
0R<L2P0a;180Ea`08bH:;1808a`:;180?A8:?A`:6PT:2A8:6Q8D2@T:8a`:
6PT:2@T:4A`:AUDYNheV;3PY4BHD2A8:4A`:4BHDAUDY;2HDPhAkYZZS6RHD
2A8:4BHD2@TD;3PYAUDY;3PYPhAk/;k1`LO1UIRSb]3F4BHD4BH:;4`Y`LO1
UJ6>SIR>0000NheV4BHN/;>g00;1al402iFHXk2n`JJQV<6QQ=bn[NC@c=cS
e^gIc?K]j]cSe]cSh002g;j]00?:_ZgL_[OLhmH00ngIc007g;jg`J64YXB4
`G]kdn?em_oodn?e00:Van005EMNKg9bNiF4SYF4SYFQ]m?SmOKoom?SmIFQ
]h>4SX>H[G:=[L77c=?SmIFcc7:=[B=1?DmNI/77c<77`IFZ[@02kOKe00ZV
ZZg:d=JEXKN`/kOChoGfooofkN[L_Zgfacgf/`03m/Lm00?faakfacgffFH0
0_K72P0=m/Lmonf>m]UVm/LNm/L:m]UVm/LmomTYm[<0omTmi:X0m_oeonf>
00Gohh@01_KII_oSQ?oSQ?KII_oI?OKIIP;ofBT00oK7?OK77^BZ0002i:X0
00>EE@1kC0Y6;`X00R<L2P0?6PT:4A`:;1802@T:^H@Dg<NSdkj>^HdY;1`D
6Q8D2@T:4A`:;180g;=L/8eB00:NNc<01TIE:C@_7QXV51X92QXB50T92P8A
70X01aX92PT952`B02`L52`B01XB52`V5002?A`:00@m4PY69PXS9PY69Q@2
?A`:00<S9PXm70Xm70X00SdL2P07ARHD?A`:AT4NARHDARH:YW8Ddn?e067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIV
c<c<VIVI01BIVIT4o_om01[oooooo_ooo_ooo_ooo?oooOocloGPi^KIiNG>
hMo0fMFnem6cb<6dal6fal6dal6fal6dal6fal6dal6hbL>fbL>hbL>fbL>h
bL>fbL<2^<W300>hb<Fhb<Nhb<L0;;S8a`0L^<S5^<W3]/W3^<W3]/W3^<W3
]/W3^<W3]/W3^<W3]/W3^<W3]/W3^<W3]/W3^<W3]L[3/]38]M?;`=WCcN3L
fNGQi>[Xl_;boo_loogooocooogo0_ono`04ooooo_ooo?ooooooSIVIV@03
ooooc<c<c<c<05g<c<`012`V53dL2R<L2R<L2P8m70X38a`:00@m70XS9PX/
4P0S9PX2?A`:01d/4P0S9PXm70XS9PX/71@S70X/4P0J2@XS9PY69PXm70XS
9PX/4P0S70X/4P0/71@/4P0S70X/4P0m4PY6;`XJ2@Xm70X/4P0m70XS70Xm
70XS70X/4P0012<L2P0;;1802A8:2@T:2@T:2A8:=2lN;1`D2@T:AT`m4BHD
H5hc008A70X26Q8D02E6C3e?GVJEXHhA9PXJ9Q@A9Q@92@XA70YPGS<S;aj3
Q7^3SHBEZZf`/kN`_/7:d<40000dEBV3SHAbLW^VZZeGSE`0001ZSEabEE:V
ZZ>V/l6`/kNEXHj=SFmbIe:`Q7_1/jgTd<cTal7Td<cLhmH00^C@c008g;jg
b]31g;jgi<O1kMW<m^gZm_KekOKe0_K]jP0Ai<O1g;jg`G]kdn?em_oo`LO<
Y/OPUJ6gEei_Phf4UHB>/;k1dn?em_oodn?ePiRgLW9k00:3V:d02]?SmJK7
h:K7h9Fcc3AWNdmbNdIED_oool77c=?IeP;]m_D00k2n`M?SmNgfm@02m_oo
00?Laj?f/`3faah00oK7?@0<i;<NomTYm/L:m/LmomTYm/L:m/LNon>>m]UV
m/Lmom00omTm0ooI:@03m/Lmm[<0ong<00;okHh2on>400CokHkffFKokHko
hh@2m]UV00CohhCffFKofBWofCd2m/Lm0^BZ000?diP:UED0UED0ARH:6RHD
8a`:2@T:6PT:4A`:6Q8Ddj4YkMW<m]UVg;=LARl:008A70X03QX92R`B0>g7
G<ZZIYj=<kV=<fYE7S@_7R<V2Q4L2PTB2Q4L2PT92QX92P892@X01aX92R`B
02<L2SdB2SdL2R`V54H_2P02ARH:00@m70Y69PXm70Y69Q@2?A`:0THV2P08
ARHD?A`:ARHDEa`0`G]kg;jgoooodmWFHLc<c004IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT059VIV@;lood00oko
oOoooOono`03ooko00Whm_WdmOONi>C4d<jgb/R/aL6P_KRN^kJE/:T01iJ`
Y`RE[jH00iN^Z9N]ZYN]ZP0/UjfZ00>G[ZRE[jJE[jH03IF_YP09T[2VU;R^
Uk^aX;ng[<Fo]l[4am;>fmoNkNg]00?ooOl2ooko00Coooonooonoooooon=
VIVI00?oooo<c<c<c<`0GLc<c004;1`D8a`:?A`:8a`:0R<V2P03?A`:;1`D
=2lN008m70X01R`L52<V2THV2SdL2R<L2SdL2P@/4P002SdB2R`B02<L2R`B
04HV2SdL2R`B03dL2R<L2SdL2P@S70X022`B03dL2R`B02<V2R<L2SdB2SdL
2R`B008m70X01R`B02`L52`B02<L2SdB2R`B008A70X03DI<?EN=G9FHXk2c
]dHV53AE:A4L2QXB514V2R<_7TIE:FYkK`TB2P024A`:00L92A@A9PXJ4Q@A
9QA6C3f3V8jEZZd00YFHX`0I/;k1SIR>=5DY8blNYZ6HLW9kSIR>4BH:EfMB
?BlmNhf4LXf4?Ehm8blY=2lcH44YPehcWXAVYXB4`J64`K>]g;jg`LO<i=3<
b]3100;1/jd01L6QQ=bc[NgIc>gIc?Koo`02m_Ke00_fkN[]kN[fkN[]fLc1
Ng^VZZ?ChoFVan2`_/6V/l5GEE800[2c]`?ChoD03W:=[H>4NiFHXjJc`OKo
ojK7h=?SmJK7h7:=[FYkQ3d_?IFHXngfmL77c0;]m_D01]?SmMcSh?KoooKo
ooooong7G0;faah01>Bc7_KII_K7?OK77P;facd02OKII_K7?OK77_K77_oS
Q?KII_K7?OJc0?KIIP02m/Lm00?faakofCgTZP000oo]SP04m]UVon>4onf>
on>>0oo]SP07on>4onf>m]UVm]UVomTYm]UVm/Lm00;TZP004=>H2YEE07]<
2TH_2R`B01XB514L2QXB52<L2QX92]bZ<ng@V>gIc?KIISAE:A4V2P8A70X0
25LL0<ZQDYik<h=N59j=<jJ4DR`V54I17P8J4Q@0114L2QXB50TB2Q4L2P<S
70X02B`L54HV2SdL2SdB2ULL04HV2THV54HV2THV5002ARH:00Q69Q@m70Y6
9PXm70Xd;aiG702`NfKfkNX3oooo00?:d=K<c<c<c<`0Glc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT059VI
V@04noooo?ooo_oooooo0_ono`0>o_com_KhiNWZdM_J^LO7YKVgVKB_Sk2Y
Q:NQOZ6JP:6HOIjCMiR=LiB90W6BQ`03LiB9MIJ;LY>800MbThP`Li::276B
Q`9dUHX2LiB900idUHYfUhahVHigVhmgXIEjY9R2Z9f;[:>I]:f]`;c4d<kD
f][XjNggmOP2ooko00Gno?oooOooooono_ooool0SIVIV@03ooooc<c<c<c<
05g<c<`022`V53dL2R<L2SdL2R<L2SdL2R`B03dL2P8/4P0012<L2R<V2R`B
05LL008m70X012`B02<L2R<L2R`B008S9PX01B<L2R`B03dL2R<L2SdL2P02
8bH:00<m70X/4P0m70X00R`B0005?A`:ARl:;180?A`:;180008m70X04B<V
2SdL2R<L2SdL2TH_2R`B03dL2R<V2R<L2Q4L2PT92R`L54mWAfYbG9FHXm?I
e_Koo`024BH:0Q4L2P0RAT`m=2lN00004BHD2A8:2@TD6Q`NAT`m;3PY2@TD
AT`mAUEBPhB>/;>gCeiVg>?P;4`Y2A`NLUEBJW]_UJZ];4`Y2@T:SHeBUHAk
Phf4SHeBARHD6Q8D;1`DH44YJVLcUG97YW9B0YF4N`0;YXB4LVMBLUEBPg]L
LVMBLUEBUHAkYXB4b]31g;jgkMW<00Cfm_D01_K]j_KfmMcSh=bc[M?Ie]?S
m@:Van000fYkQ8>4S[2n`@03dn?e00n3V:ebLW^EV:?1alcChoFVan3foonV
an23V:fEXKMZNhA6C3fEV:?ooooChoD00ngfm@;fool01OooonBcAnBZ0?K7
?OJc0002m/Lm01?fa`[faakfacg]aecofBWfacgfaak]d9SohhCod3gfa`[f
acgofBWfaakfa`[facgTZP3okLcokHh00_oSQ003m]UVon>4onf>00?okHh0
1?KII_oSQ?KII_KIIP;ofCd07_K7?NBc7^BZ0=>40:Ib07]<2V0_2Q4V2R<L
2Q4L2QX92R<L2PT92]>Q:OKomNg@V=c7Xh=N52<V2PTL7R`B05LL09ib<kUb
<c@_<fYW<lZH:AXV52<_7R<L2P8A70X01@T92PTB2QX92R<L2SdL2P028a`:
00H/71@m70Y69PY69PY69QAG7003ARH:00U69Q@S9PXm4PXd;aj3;`31XHCo
kLcoooofool00oooo`03b]3Fc<c<c<c<05o<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01BIVIT2noon01cn
o_kno?goo_ono?gcm?KUjn_5dLngb/JS_[V>[jQkX9QZU8YNQgmGPGMORG]N
RGQNQgULQgIMQWQMR7MPRG]ORWUPRG]ORWUPRG]ORWUPRG]ORWT4H8Uk04UR
R7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]P
RG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]R
R7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]PRG]RR7]P
RG]QRWaPRgYQRWaPRgYQRWaPRgYQRWaPRgYNQgULQgIMQWQLQgIMQWQNRGQP
RG]ORgaUUHEIS7eJR7][UHUmXIN;ZJ6O]K:c`l;>f=WSj>_gn?`00_ooo`04
ookooogooO_nooooSIVIV@03ooooc<c<c<c<05g<c<`012`L54H_2R<L2R<L
2P8m70X01B<L2SdL2R`L53dL2R<V2P02?A`:00A69PXS70X/4P0S70X2;180
00`S70X/4P0/4P0J2@XS70X/4P0m70XS9PXm70XS70Xm70X/4P028a`:03//
4P0S9PX/4P0m70XS9PXm70Y69PXS9PXm70XS70X/4P0S9PX/4P0S9PXm70Y6
9PXS9PXJ2@XS70XJ2@YGEE9ZLUbEXKO:d=KChoEPGS<A9PXS9PX/>2TA9PX9
71@A70X94PX92A@J2@YbSE`92@YbSEa?IeaPGS=GEE9ZLUa6Ie`/C2V`/kL0
000/71AZIc=ZLUbVZZ<0002VV6ld;bV3Q7]bSEa6C3dA9Q@A70XA9Q@00V11
:@0ALVMBLUEBPg]LLUEBJVLcUG97LUEBJVLcUEhc/7]V`J64g;>Sg;jgi<O1
i=3<kNgZm_Ke00?fool01?KomOK]j_KfmG9EDP;ChoD01;2n`L[@eX>4SYFQ
]`;1al`01jK7h9FHXhf=KiFQ]m?SmIFcc:K7h002dn?e01F3V;OChoFE/l`d
EBUGIe;:d=K]m_GChoGoooo]m_G]fLcfooooooo]_SgTZP3fa`[T/akfaakf
a`[T/bWfaah01?K7?@06m/L:m]UVm]UVm/LNomTYm]UV0_K7?@03m/L:m/LN
i:X000;okHh2m]UV00?ohhkokHkokHh00oo]SP?ohh@01?KII_oI?Ng7G?K7
?@;TZP001M>H2ZIb08=1060_2R`V50024A`:01/J4Q@S70X92ABVLP3okLc]
fLcokHik@@0S9PX94PXS70Xm4P[:XE;T/dNiLS>3GS>`SC=kC1@S9PXJ9Q@J
4Q@92@XA70XJ4Q@J2@XA70X/4P000SdL2P0:?A8:ARH:ARH:Ea`0ARH:H2l:
ARH:ARHD;2HD=2lN0THV5005/7/Yong<oooooooom_oo00Coool00l[@`Lc<
c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@0DVIVI0_koo`0Looooookoookon__mi^c/d=oL^<k;
W[fgOZJMKYbAMJBJR;Z_XM36[moCaOGUa_ORb_WWbocWcOcZc?gXc?_YbocW
b?OUaoSSb?OUaoSSb?OUaoSS1<Sgi@1;b_KUb?OUb_KUb?OUb_KUb?OUb_KU
b?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OU
b_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KU
b?OUb_KUb?OUb_KUb?OUb_KUb?OUb_KUb?OUbOSVb?WTbOSVb?WTbOSVb?WT
bOSVb?WTc?_Yb__Vbo[XbO[Ub_WWb__Vbo[XbOcY_OCQZ>7>VLnoSL2aO:ZO
Li^BRZZU[<K3]l_:cmgMjO?dnOkoo_oo00Coo_n=VIVI00?oooo<c<c<c<`0
GLc<c00;8a`:;1`D8a`:;1`D;180;1`D8bH:8a`:;1808a`:ARH:008m70X0
32<V2SdL2SdL2SdL2R<L2R`B02<V2SdL2R<L2R`B014V2THV2PDm70X02R<L
2R<V2SdL2R<L2SdL2THV52`B04HV2SdL2THV2P8m70X00b<L2SdL2SdL2P03
?A`:0TH_2P8S70X01AXL7TmWAg^=IYFZ[L77c002dmWF01@0000A9Q@A9PX9
2@XJ4Q@92@XJ4QA6EBT/C2TJ4Q@J71j3Q7/S;aj3V8jEXHjEV:=bSCd/>2TJ
9Q@S;ah2LXeL00]ZSE`/>2UkSFJEXHh971@dEBU6EBTJ71h94PXJ4QA69Q@0
0V11:@04LUEBPehcJVLcH44Y0W9EDP07JVLcUD`Y/7]V/8AV`G]ki:ZHi=3<
00;]fL`01OK]j_KfmOKoooooooKoo`02m_Ke00GfkN[1XHB`_/7ChoG1al`0
0ZK7h00QUK?<UJ6gdn?eY/OPUIRSEei_`LO<m_ooY/OPPiRgdn?em_ooY/OP
dn?eY/OPLXf]8blYm_oodn?ekOKem_ooUIRSg>?Fm_oooooodiP:m[<0m/LN
m[<0m/LNkLMLm/Lmm/LN00;facd03oKII_K7?OK72_oSS_K@Q?oI?OK77_o@
?OoI?OK7?OK77_KII_Jc0?KII_oSQ002m]UV0oo]SP03on>4onf>onf>00;o
hh@01_o]S_oSQ?oI:OKII_K72^BZ00;CV0X00k1b08eE2TH_2P02;1`D0Q4L
2P0K6PT:6Q8D^H@Dong<kMW<ong<LXdm4BH:2A8:4A`:Ea`0bZ5Bi;=7i;<c
dj4YUEhc^HdYH2lD;1`D6RHD6Q8D2A8:4A`:6PT:?A8:6Q8D;1`D008m70X0
3V0_55LL060_560_2THV2THV54I17THV55LL0:IbD_K]j_KfmOooongfm@Ko
ool00l[@e/c<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^0C<c<`00fIVI/c<c9VIV@0DVIVI0_ooo`;oo_l07?oooo;fmmGQ
gkW@bYfn]hRcZGV]X86jZicFb;S`hlSnlLcollKii/Oki<Wmil_oj<_ojL[n
ilSli/Oki<coj/cojLcoj/cojLcoj/cojLcoj/cojC3>onT2c?oY01c<on[<
onW<on[<onW<on[<onW;onW;onS:o^S9oNK9oNO9oNK9oNO7o^O2oNO0o^W1
o^bjmN>Pe/R1/jMgYI^1ZJ6Q`Kbid/oGinO]moSioOkoo_l2oogo00?oo_nI
VIVIVIT0RiVIV@03ooooc<c<c<c<05g<c<`01CdL2THV51XB5611:B`L5002
?A`:00<S70Y69PY69PX00R`B0003ARH:ARl:?A`:00969PX2?A`:01`S70X/
4P169PXm70XJ2@Y69PYG70169PXS70XS9PXS70Xm70X/4P0/71@d;ahm70XS
9PY69Q@/4P0m70XS9PY69PXS9PXm70Y6;`Xm70Y6;`Xm70X2ARH:014m70XS
9PXJ2@XS9PYGIe9ZNfnEV:?CfMK]kN[fooo1XH@0000A9PXm70XA9Q@J9Q@m
GSd00b<_7P0@2A8:;3PY0000JW9LSIR>YZZS0000UJ6>UIQV=5DY4BHD8blN
;3PY0000CfM74BH:0Q4L2P0G6Q8D00006Q8D8blNAT4NH44YNd`DPehcLUEB
PehcJVLcPehcH44YUD`YYYQ_/8AVUG97`J64g;>]i=3<i<O1kMW<m_oo00;f
m_D3m_oo0_Kfm@0?kMW<WXAVdn?e`LO<Y/OPm_oodn?eUK?<Y[?1/;k1Y[?1
Pg]Ldn?em_oodn?e00:3V;L03>gfmOKoom?SmOKoojJZ[H=N<jJZ[OKoomcS
h:JQV<6cS]cSh0;oool01LZH5?K77^Bc<oK72_K7?@02m/LN1OK7?@05i:X0
on>>m]24omTmm/LN00;ffFH03?K72_K7?OK7?OK77_oSS_o]c?oSQ?KII_oS
Q?o]S_o]c?oSQ0;okHh00ooSQ?o]S_oSQ002on>400ofacgffFKTZP3CV0[T
ZP2`LP23@@1Z@@Xd;ahJ9Q@/71@A70X/71@92@Z`Na@00oo]c00HWXdcAT4N
4A`:2A8:;180m]UVm]24kLMLi;=7^G8cbZ4m/4`0;1`D8blN4A`:6Q8D2A8:
6PT:8a`:;1`D?A`:?A8:H2lDEa`0160_5004ARH:YT`0g;>]ong<1?ooo`03
kOKem_oooooo00Coool00l77c<c<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P1
0000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0DVIVI023no?oo
oOoonoomnokgn?[Sk>^odm6N_kQlZYml]ZN8b;RNhm6fnNS1oo6mn^^hlN39
onS9onG9onO9onG9onO8o^C8o^K7oN?<on[<onS<on[<onS<on[<onS<on[=
onP`cooX027<onO;onO;onW;onO;onW;onO;onW;onO;onW;onO;onW:onK9
onO9onG8o^K7onK0onRnonVnon_0onfno^f^k=f@b[ihZj:6/JZL_kVnemCN
k>ccnOWmnokonokoo?ooo_l04IVIV@<0000NVIVI0`0005RIVIT00oooolc<
c<c<c01Mc<c<00@/9Q@/71@m70XA70X2?A`:00U69PXm70XS9PX/4P0m70XS
9PXm70YkC0YG70000TH_2P04?A`:ARH:ARH:?A`:0R<V2P0:8a`:?A`:8bH:
8bH:?A`:8a`:?A`:;180?A`:8bH:0R`B0003?A`:ARl:8a`:008m70X01THV
2SdL2SdL2SdL2R`B03dB2P969PX05DH_2THV2TH_2SdL2QXV55MWDX>4NiFZ
[K2n`L[@e_KoojJQIVY12Q4V51XV514V2QXB500005MWDXf=K`0000032A8:
01Q?Ieb=V8i?IdL0002EXHi?IdLS;bUPGS<dEBT92@XA70XJ4Q@92A@J4Q@9
4PXA70X92A@/>2U69QAZEAj3GS=P@BV3GS=ZEAh2JVLc00UZEAj3GS>`Q7_1
XHBVV6n`NfK1Ng_L_[OTal400^gIc003m^gZm_Keoooo00;fool04?KfmOKo
ooKoongfmH=N<m?SmL[@eYFQ]m?SmOKoom?SmL77c;2n`L77c9FHXm?Sm@?f
ool03=cSh>gfmNgfmNgfmOKoooKomOooooK]j_KfmNg]j_K]j/[@`@;fool0
2OooolZH5>BZ0?K7?OJc0?KII_K77^Bc:OK72P02m/Lm00Ofaakfacgfaakf
d8CohhCffFKfaah00_KIIP03omTYm/LmomTm00;facd01ooSS_oSQ?oSQ?o]
S_K@Q?o]S_oSQ002onf>0ooSQ00>onf>m]UVm/Lmm/LNi;<ci:X0`H@0/780
UED0JT4:;1`D8bH:4A`:6PT:0Q4L2P0>Nd`Dm_oem_oeong<WXdY=5DY2@T:
4A`:;180om0mm]24kLN4m]UVdjY70]>Q:@05Nd`D=2lN4A`:6PT:2A8:00<S
70X00dHV2SdB2V0_2P04H2lD00=b9P3]d9Soool01Oooo`03m_ookOKem_oo
00Goool00l[@`Lc<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0DVIVI017oo?oooOooo?oln_ga
l_CHi>:`blJ>^:id[Iioa;6Dgl^TlMf`nnNgo^c3oo?<ooG;on/00l_oi`;<
onP00lgojLkoj/[oiP06b_oV03;;onC=onC=on;>on;=on;>on;=on;>on;=
on;>on;=on;>on;=on;>on;=on;>on;=on;>on;=on;>on;=on;>on;=on;>
on;=on;>on;=on;>on;=on;>on;=on;>on;=on;>on;=on;>on;=on;>on;=
on;>on;=on;>on;=on;>on;=on;>on;=on;>on;=onC:on<7bOoU1Lgoj@0D
c?oXbooWaooXaoo``?o^]O[UZ?3JZ>oMYNcJUMO9P;jaMJZPR[F^[/g8e>SV
l_[lookooocooo[nooko4iVIV@80000OVIVI0P0005NIVIT00oooolc<c<c<
c01Mc<c<00=69QA69PXS70X00cdL2P068bH:ARH:?A`:;1`DARH:;1800SdL
2P06ARl:Ea`0ARH:?A`:8bH:ARl:0SdL2P08;1802@T:Ea`0ARH:;180?A`:
ARl:;1800R<L2P08?A`:;180?A`:8bH:?A`:;180?A`:8bH:13dL2P969PX0
4DH_2SdL2SdL2THV2SdL2R<L2QXL7W^=IX>4Ng^=Q<6c[McSh?ooocAE:B<V
2TH_2R<_:@022@T:014A9QA6EBU6EBTA9PX/9Q@94PX92@X/>2UkSFH92@X9
4PY?IdM6@Ah000094PX92A@A70X00PT92P076Q8D4BHD6Q8D2@TD6RHDH2lD
H44Y00:3GS<2UG9700bNQ6JELTN3GS>3GS>VQ5:VXIRVQ8BVLU;1Ng_1XHCL
/j?Tal42kMW<00CfkN[fm_Gfm_Gfm_D2m_oo00C:d=K1ala6EE8m4PX2kOKe
00?]kN[]m_Gfool00oKoo`;Lhn001OKoongfmNg]j_KomNgfm@02g>?P00?L
hmK]m_G]m_D00^gfm@0;ooookNgZkNgZg>?Poooom_oooooodiP:i:X0i;<c
m[<000;facd00nBZ0?K77_K7?@03m/Lm00Gfaakfd8CohhkohhCfa`X00_KI
IP;ofCd3m/Lm0ooSQ005onf>on>>onf>on>4on>>00Gohh@01?o]S_K7?OK7
?NBc:@;TZP002[1b09ib2VY12SdL2QXV51X92QXB51XL7PTB2X<h00?okL`0
4IF=DV1150TL514L2QX92^BcAoo]c?KII_oSS^g7G<ZQ?LZH5:Ib54HV50TB
2Q4L2PTB2P028a`:00TJ71i69QA69QAP;aAP@BUP;aAP;`Z`SE;Laj<01ooo
o`03m_ookNgZoooo00Goool00m?Ie/c<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0DVIVI017o
o?oooOoooOoknOc[ko3?g]^Wa/25]JUj^:V4ck^GjM>UnN:YnnF^nNFdm^Rk
n>S5oN@00/Smh@03bOkRb_oSb_oS00;;on@8c?oU0/oohP0^dOoRcooRdOoR
cooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooR
dOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoR
cooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooRdOoRcooR2<coi@03
b?gQbOkRb_oS00;:on<04LWnh/SmhL?nh[Ohh;_ojl7om;kol[;ojjCagIOQ
d93Dag^g[HRj/J?8`LWRg^cfmokno`02oo_o00?oo_nIVIVIVIT019VIV@80
0004VIVI100000>IVIT300001YVIV@D00003VIVI0P0000:IVIT400000YVI
V@800004VIVI0`0000NIVIT400000iVIV@@00002VIVI0P0000:IVIT20000
0iVIV@@00003VIVI100002jIVIT00oooolc<c<c<c01Mc<c<00Dm70Y69PXS
70Xm70X/4P000SdL2P0S8bH:?A`:;180ARl:6PT:8a`:8bH:8a`:Ea`0ARl:
Ea`0ARl:?A`:;1808bH:Ea`02A8:8bH:ARH:;180ARl:;1808a`:?A`:8a`:
;1808bH:?A`:;180ARH:?A`:8a`:Ea`0;180ARl:00A69PX0;TH_2ULL060_
2TH_2SdL2TH_2QXV54I17VYbG5MWD[2c]m?Ie^gfmIib2W]<2VYE7VY12X=N
50TB2Q4V54IE:B`V52<_7QXV50T952<_7QXL7Ra<:@TB2Q4L2QXB50TB2PT9
2P0000TB2PT9514L2PTB2Q4L2PT92PTB2Q4L2S@_:G8h57]<56YE7P:ELTL0
1:JHQ=bcXiF=DX=N<`BELTL01;1kIZJQV=bn]mbn]`?]fL`3m^gZ0_Koo`0:
kMW<8bH:2A`N6PT:kOKedmWF/;k1g;jg`LO<i=3<0]bn]`09i<O1g;>SkMW<
kM2HkMW<kLN4g>?FkMW<on>>00;]fL`05Ng@V>BnQ=>nS/5kNjK7h8>HS[2n
`Ng]j_KfmOKomOoookUb<m>40?K77^Bc<oK7?OK77_K7?OK77_K7?OK77P02
m/Lm017fa`[]aecohhkfacgfa`[ffFKohhCfaakffFKfacgofBWod3gfd8Co
hhCohhkokHkffFH00_oSSP?okHh01ooSQ?KII_oSQ?KII_K7?OKII^Bc7P02
diP:00G1Q02EE@1Z@@X/9Q@S9PX00Q4L2P0=8a`:4BHDEa`0m_oeong<m_oe
YZ5VARl:4BH:2@T:0000i;<Yonf>00;ohhh02>g7G<ZZI^Bc:IiN57]<51XB
514L2PT92P8S70X01aXL7ULL04HV560_5:IW0;VZKoK]jP02oooo00?fooGo
ooooool01Oooo`03kOKem_oooooo00Coool00m?Ie/c<c<c<c01Oc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VI
V@0DVIVI01?moOgoo_ooo?kjm?SVinW6e]FJ`[Yg/jN8d/64el>:glZGj]JW
m^>do^fhoo2kong1onK4onC5onD00/OoiP03a_oUa?oS`okR00O3o^80</Gm
h/Kmg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Ol
g/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Km
g/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Olg/Kmg/Ol
g/Kmg/Olg/Kmg/Knh`O4on<00l?nh/CohlGoi002a_oU01C5onC4on?2o^C4
onbio^VcoNJ`onVVnnBEkMN7g/^6elJ3bkf6`[JGaK^heM7KjNWem_Son_oo
o?ooo_l6VIVI0P0000>IVIT200000YVIV@800002VIVI0`0000FIVIT20000
0iVIV@8000000iVIV@0000000002VIVI0P0000:IVIT2000000>IVIT00000
000019VIV@<00006VIVI0P0000:IVIT2000000>IVIT0000000000YVIV@80
00000iVIV@0000000002VIVI0P0000:IVIT200000YVIV@8000000iVIV@00
00000002VIVI0P0002fIVIT00oooolc<c<c<c01Mc<c<00=69QA69PXS70X0
0b<L2P8m70X2ARH:00@m70XS70XJ2@X94PX26PT:00a69PX/4P0/4P0m70X/
9Q@/4P0S9PXJ2@X/4P0S9PXm70X/4P028a`:0R`B0004;2HD;180?A`:ARl:
0SdL2P088bH:8a`:?A`:?A`:ARH:?A`:ARl:ARH:0ULL000NLSP0ARHD?A`:
;180=2lYNheVPhAkUHAkb]31dmWFAT`mYYQ_/:Z4SHeBYZ6Hb]318bH:4BH:
2A`D00004BHD;2HD4A`:8bH:=2lN2@T:4A`:2A8:4A`:2@T:0PTB2P094A`:
2@T:2A8:4A`:2@TD4A`:6Q8D8bH:H44D009P@BT01iE<:Iik<k24I]bcXl[@
`JIbDX=k<`02Pehc00QZIc>3GS>VLU:`Q7_1XHCL_[OTd<c]fL`2m_Ke0_K]
jP;fool03Ooool5kNk2=<lZn[M>nS]>40<ZH5=>40>BZ0=>H2^Bc:NBcAoK7
?@03kLML013ffFKfd8CohhkffFK]ahCffFK]_SgfacgfaakCV0[f/`0m4PYZ
EAjELTOTd<cfool2oooo00W:V2WTZP3f/`3]_SgfacgT/bWfa`[T/akod3d0
0_K7?@;faah02oK7?OK@Q?o@?OK7?OoSQ?K@Q?oI:OKII_K7?OKII^BcA`03
on>400?okHkohhCokHh01?o]SP;ohh@06_KII_oSQ?K7?Ng7G>Bc<lZH5=>H
2/6408eE2VY12S@_7R`V514L2QX92Q4L2QXV52`B0?o]c?KomOo]c;VZKcAE
:AXB51XV50T92]>Q:@;okL`03oo]S^g7Q>g7G>fn?M>Q:G]<52`V514L2Q4V
51XB52`V52`L58<_0;1k2]bc[@05oooo00?fooooooooool01Oooo`03kNgZ
kOKeoooo00Coool00m?Ie/c<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0DVIVI01Sboo[hoo_o
n_[onooQgnBjc<j2]k5a_k9ddKmhe/B9flfJi=NWjn2]m>J[o^Z]on^conNe
onBcoN:fonBkonNmonVnonVlonL4^ooV0k[oiP0b^_oT^ooT^ooS_OoS^ooS
_OoS^ooS_OoS^ooS_OoS^ooS_OoS^ooS_OoS^ooS_OoS^ooS__oT_?oT__oT
_?oT__oT_?oT__oT_?oT__oT_?oT__oT_?oT__oT_?oT__oT_?oT_OoS^ooS
_OoS^ooS_OoS^ooS_OoS^ooS_OoS^ooS_OoS^ooS_OoS^ooS_OoS^ooT_?oU
1Kcoi`BkonL3^?oV0[Ooi@0?^_kU`OcZ___[/o_WYOWRUoOLRo;GO^K=M][2
NM6kM;f/QK^^/MK?d>CRnOoo00;ooOl00oonoiVIVIVIV@04VIVI0P0000>I
VIT200000YVIV@80000019VIV@00000009VIV@800009VIVI0P000003VIVI
0000000000:IVIT200000YVIV@8000000iVIV@0000000003VIVI0P000003
VIVI0000000000BIVIT200001YVIV@800002VIVI0P000003VIVI00000000
00:IVIT200000YVIV@800005VIVI0P00036IVIT00oooolc<c<c<c01Mc<c<
00Dm70XS9PXm70XS70Xm4PX00SdL2PE69PX24A`:00L92@X/4P0m70Xm4PY6
9PY6;`X/4P000SdL2P044A`:;180ARH:;1800SdL2P078bH:?A`:;1808bH:
8a`:?A`:;18000<m70X012<V2SdL2SdL2TH_2P9G7003ARl:01A69QAG7016
9PX/4P16C3ebSEabSHB`_/7Lhn3CfMK]kNZ`/kO:d=KCfMK]m_G1al4A70XA
9PX92@XA9Q@24A`:00LJ4Q@A70X94PZ`ZXA69Q@92@X94PX00Q4L2P032@TD
6Q8D4A`:00892@X02Q4L2PT92R<_7S@_7V11:G8h59E<:IEN<k2=D/6QQ0;T
al402YEbAh=N58=N<g]<5611:H=N<ij4I/5kNmbcXnC7`@;]fL`01?K]j_Kf
mOK]j_K]jP;fool05?ooongIc;1b0=>H2[V45=>40=>Q:LZH5>BZ0<ZH5>Bc
<nBcAnfn?NBcAooSS_K7?Ng7G?KII_oSS_K@Q0;ffFH02OoI?Ng7G?K77^Bc
7^BZ0611561N<jJ4D^g]jP03m_oo00C]_SgCQ03od3gT/dL2m/Lm00?T/akf
a`[T/c<00_K77P0=i;<Ym[<0m[<0m/LmkLMLm/L:m/Lmm]UVm/Lmm]UVi;=7
m]UVm/LN00;ffFH3on>400CokLcokHkohhCohhh3on>401gffFKohhkfacgf
d8CT/akCXBWCV0ZiQ1BNLPYkC0Y69Q@/9Q@S70XA70XJ2@XA70X/4P3okLcf
ooG]fLc1/hiZ@@XA9Q@92A@92@[CQ03fooGokHk]d9P00_K@Q00:m/Lmdh@0
UEDDH2lD4BHD6Q8D;1`D2@T:bZ4mong<1oooo`03m_oooooooooo00Coool2
m_oo00?fkN[oooooool00oooo`03dmWFc<c<c<c<05o<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01BIVIT0
6?3on?Oon_oknOokon7Pi[K>d7Vh/6S3]6_D`g?Hb8WKciWOeJGTg:K/hJ3g
i9omhjcoj:kniJkli;3ni[Goj;Ooj[Soj[Ooj@:jonX2^?oZ1;OojQ2honP@
^OoY4;Soj0Jion/4^?o[0kKojP:eonT04[OojKWfi[SgiZcehYkcg93bfHC_
dgSTbVoJ`73?^FbmZWfk[ZcJd<gXhoGooogmooomooono`JIVIT200000iVI
V@800002VIVI0P000004VIVI00000000VIVI0P0000NIVIT4000000>IVIT0
000000000YVIV@800002VIVI0P000003VIVI0000000000>IVIT2000000>I
VIT00000000019VIV@800006VIVI0P0000:IVIT2000000>IVIT000000000
0YVIV@800002VIVI1P000003VIVI0000000000@0000]VIVI00?oooo<c<c<
c<`0GLc<c00?H2lD8bH:8a`:;1808a`:;1808a`:ARH:;180H2l:ARH:;180
8a`:6PT:4A`:008S70X01b<V2R`B03dL2SdL2R<V2R`B01X92P028bH:00DS
70X/4P0S70Xm70XS9PX00R<L2P96;`X01b`B04H_2SdL2R<V2SdL2TH_2SdL
2P02ARH:00Dm70YG70169PY6;`YG70000TH_2P058bH:8blNJW]_PhAkY[?1
00;:d=H00ngfmK2c]l[@eP02b]3F00[ChoG:d<5kSFJEV6H92@XA9PXA70X9
4PX92AAP@BT2Pg/c00=6;`XS70XA70X01A4L2P894PX03@T954HV560_560_
5611:G]<59EN<k24Nl6QQ>gIc>C7`Iik<fYE7P03H44Y00Eb>1BVEFJ`NfKL
/j?L_[L00^gIc0?fm_D00oK]j_KoooKoo`02m_oo00C1XHB`LP3:V2W:XCd2
bYPD00[CXBWCV0[:V1CT/c?T/ak]aecTZP3]aecffFKohhh3m]UV00_facg]
ahCfacg]aec]_SgTZP1P@AAbIe:`ZXCfkN[fm_D00_ooo`0:g;>4i;<Ni;<c
m]UVm/Lmm/LNi;<Ym[<0i;<Nm/Lm0oK77P0?i:X0om0mkLMLm[<0m/Lmon>>
m/L:m]UVm/Lmom0mi;=7kLMLon>>m]UVong<00?okHh08?oSS_o]S_KII_oS
Q?o]S_oSQ?KII_K7?OKII^fn?LZH5=>40<6409ib2W]<2THV2QXV52<L2QX9
2QXV51XB50000>g@V?KomOo]c<6cSV11514V50TL50T95;UW0?o]c0;ohhh2
m]2400WffFKT/bV=E@YP@A@J71h971@/71@J2@[:ZVH02?ooo`03m_oooooo
oooo00Goool00ngfmOKfmOooo`04oooo00?CfMK<c<c<c<`0Glc<c004IVIV
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT0
59VIV@0Hm?ogn_oioocjoo[mg^?W/];AKKFYH<>aI]?0KMK5QMW<U=cAWN3G
WNOJUO7LUoGMY_SRZ_GQZoCQ[?GR/_OU/oSV]?OV/oKU0[Cdi0:bmN@4/OKT
4;;eha2cm^@@/_GS1[?fi@BbmnD3[oKT0jkeh`0AZ_7OYo;NX>oLU^_FSNWD
QnK@Nmk9L]JnK<^eI[^VLKRXZMgAb^_Tkogmo?gooogoooko00JIVIT20000
0iVIV@800002VIVI0P000004VIVI00000000VIVI0P0000FIVIT500000YVI
V@800002VIVI0P0000:IVIT2000000>IVIT0000000000iVIV@8000000iVI
V@0000000004VIVI0P0000JIVIT200000YVIV@8000000iVIV@0000000002
VIVI0P0000:IVIT200000YVIV@8000000iVIV@0000000002VIVI0P0002fI
VIT00oooolc<c<c<c01Mc<c<00IP@AAG700J9Q@A70XS70XA70X2?A`:0THV
2P06Ea`0ARH:;1808bH:Ea`0;2HD0R`B0006ARl:?A`:;1808bH:;1802A8:
0R`B0007?A`:ARl:8bH:8bH:?A`:8bH:?A`:008/4P000dH_2SdL2R`B0002
ARl:00L/4P169PY69PY69PY6;`Y69PYG70000TH_2P07ARH:Ea`0ARl:8blN
UIRSUJ6>YZZ]00;:d=H01^g]jXfHSZJHQ7:=G6YW<g:=?@:3Nc<049EE07]<
2PT954HV2V11578h07]1078h060_2ULL03dL2Q4L2QX92Q4L2QX92Q4L2P89
4PX01A4L2R`L54H_2THV560_2P02LSPD016EC2W1Ng_L/jg]fLc:d<6EGS>3
GS=kC1AP@BUG701b>1BEC2V`@C?1Ng_TZYSokLcfkNX01_Kfm@04m_oooooo
m^gZ/7800/ZH500BbYPYdj4YdiP:bYPDi:X0i;<ci;<YkKhmi;<YkKhmkLML
kM2Hon>4kLMLm]UVkKhmm]UVkLML0_K7?@05i:X0WW8DH5hcYZ6HkNgZ00;f
ool03?oookV=<nfn?OK77^fn?OKII_K7?Nfn?OJc0?K77_Jc0>BcA`;T/bT0
3onc0?K7?Ng7G?K72_oI:OKII_o@?OoSQ?K7?Ng7G>BZ0?KII_oSS_oSQ?oS
SP05onf>00GffFKohhCokHk]aecohh@00_K7?@08i;<ci;<NdiP:diP:YW80
Nd`:ARl:;2HD0Q4L2P0>2@TD8a`:0000g;>4m_oeong<`K>>JVLc4BHD6Q8D
2A8:Pbl0ong<onf>0_oSSP;ffFH02>Bc7YiN57]<52<_7Q4L2QXV51X92[Ub
<a3oool00oKoomcSh?ooo`04oooo00?CfMK<c<c<c<`0Glc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT059VI
V@0Fn_ogoOoioocmo_[kfnKX[MKBG:fNE;jXF/jgI=?0NmK7S=W?UMgBUn?F
T>gHU?7LVncKXN_LXn_MY>cNZ>cOZNgP0Z[/h0:ZjMh3Z>[N0ZO[gP03Yn_L
Z>[LZ>[L00jXj]`@ZN_M4:SZg0JYjml2Z>cO0ZO[gP:Uk=h3Y>_M01:Rk=^L
kMZIk]VEj]F?i=6:hLj6glelfLIcd[i[b[IM]Z9Q[YjQgM7:knS[o_cnoooo
oOooo_l6VIVI0P0000BIVIT00`0009VIVIVIV@0400000iVIV@800003VIVI
100000BIVIT200000iVIV@030000VIVIVIVI008000000iVIV@0000000002
VIVI0P0000>IVIT200000iVIV@800007VIVI00<0002IVIVIVIT00P000003
VIVI0000000000:IVIT200000YVIV@800002VIVI0P000003VIVI00000000
00:IVIT20000;IVIV@03ooooc<c<c<c<05g<c<`0360_54H_2X<h02`V52<V
2SdL2THV2ULL060_2W8V04HV2W8V00969PX00a4L2R`B02<V2P02?A`:00E6
9PX/4P169PX/4P092@X00SdL2P088bH:?A`:;180ARl:8bH:;2HD?A`:8bH:
0SdL2P03ARH:ARl:?A`:008m70X084HV2SdL2TH_2ULL04H_2THV2TH_2W8V
04H_2V0_2SdL2PTL7W^=IX>HS[2n`L[@e^gfmK2ZQ5LL08=N578h07]1078V
078h07]109EE0:Ib08=N58=107]<2VY12V0_2P96;`X012<V2R<L2Q4L2QXB
508A70X04Q4V514L2PTB2PTB2TI17S@_<f11:C@_<g8h56YE7YE<:L6QQ=bn
]nC7`L6c[Hf=AfYW<b<L2P9P;a@02F11:IEbAiE<:JIEIX<_0=bn]oo]c?oo
ooKoo`02m_Ke0_K]jP0:m_Kem_oooooo/780^HdYbYPDbYPYi:X0dh@0g:Xc
0^Bc<`09i;<NkKhmkKhmi;<Ym/LNon>>m]UVkLMLom0m00;]ae`02?K77^g7
G?K7?NBc:H=N56YW<l[@`McSeP?oool01:Ib5?K@Q>Bc<oKIIP;facd01nBc
<oJc0?K7?NBc<ooI:NBc:OJc0002i:X001;]aecf/`3]aecffFKod3gffFKo
d3gffFKT/akffFKohhkfd8CffFKohhkfd8CokHkfd8CokHh2on>400kfd8Cf
fFKffFKfacg]_SgT/c?CXBW:V1BiQ1B`N`YkC0Y69Q@/9Q@S9PX26Q8D01TA
9PX0002iV5cokLc]fLcC_XiZEAh971@A9Q@971Ab9P3okLcohhCfd8CffFKf
d8CffFKT/bV`N`ZVC00d;ahA9Q@/71@J4QBV@@002Oooo`03m_oooooooooo
00Coool00oKoong]j_ooo`04oooo00?LhmK<c<c<c<`0Glc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT059VI
V@0Dooojo_ghoocmn_Skf^g[Z]cCC:FCA;JMCl^aFm6iLmK4Q=S;SM_>S]o@
RnSCS^_FTnKFUnGGV^KIW>SK0YoWf`03X>KKXNOLY>SM00:Tj=d3X^SM0Z7Y
g@03X^SMX^WKX^WK02fRjM/6XnWN0Z;ZgP:QjMd05j3ZgIoYg9oYg9oYg9kX
fiWZfho[eXgZeHcUdHSOcXOKbhGIbWWD`g3=^VG6/U:_VU6TTYcNd<gfk^_o
oOonooomooono`06VIVI0P0000BIVIT4000000>IVIT0000000000iVIV@80
0003VIVI0P0000FIVIT400000YVIV@@00002VIVI1P0000>IVIT200000iVI
V@800007VIVI10000003VIVI0000000000H00002VIVI100000>IVIT40000
;YVIV@03ooooc<c<c<c<05g<c<`00g]<59EE514L2P02;18014HV2P03H2l:
JT4:H2l:009P;`X2?A`:00QP;`Y6;`YG70169PXm70XS70Y69PX94PX2ARH:
00=6;`YG700m70X00SdL2P0=;180ARl:ARH:?A`:ARl:Ea`0?A`:8bH:Ea`0
?A`:ARH:ARl:Ea`0009P;`X06ULL04H_2THV55LL04H_2SdL2THV53eN?F1N
<jJQV>C@c=cSh9ib57]<2YiN58=N59ib2X=N58=108=N57]109ib58=N58eE
2W8h08eE2P96;`X24A`:028S70XJ2@XA70XA70X94PXS70X/4P094PXS9PXm
70YG7016;`Y6@AiP@BUb>1BEC2WC_XkTal71XHBELTN3GS=b>1A69QAP@ABN
LQBiV5c:_Zg1/hkooooL_ZfVLU:VEFKfkN[oool2m_oo00[Tal7]fLcfm_Gf
oooooonNLPZNNc>`Q2V`SE:`Q2T2PehD0[VHG007YXABWW/cWW/cbZ4mUHAB
WW/cSHe700:EV6H06[VHG:J4DYFHIX=k<fYW<l6c[Ng]jYF4D/77`McSe_Ko
ooooooKookV4:OoSS_K7?OKII_K7?Nfn?OK7?NBc:OK77^Bc<oJc0?K77^Bc
:@;f/`001OK7?OJc0?oI:Ng7G?K72P02kLML00?od3gTZP3ffFH00_oSSP05
on>4onf>on>>on>>m]UV00;ohh@01?oSS_oSQ?oSS^g7G0;facd01^BcAmbZ
<m>H2]>H2[V=57]<2P96;`X072<L2QX92Q4L2QX92PT959ib<oKomNgIc=>n
SX=k<`TL514L2PT955LL0?o]c?o]S_K@Q?KII_K@Q?KII^fn?KUb<kV4560_
514V7QXV51XB58<_013oool00oKoomcSe_ooo`04oooo00?CfMK<c<c<c<`0
Glc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT059VIV@0EooojoOchoocmnOWkh?Cb/N?JAIj<>ZnEA/N[Cm2d
ImBoN=K6PMG6QMO9QMk<Q^7?SN7AT>;DTnGGU^KIUnGH00:Hi=P6VnCI0YWU
f@>IiMP0<i_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_U
f9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WU
f9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_Uf9WUf9_U
f9WUf9_Uf9WUf9cUfY[VfYcUfY[VfYcUfP02V^KJ01ZIimZIiMVHi]VHi]VE
iMRGiMREiMRFi=NBi]J8hm66iM64glf1f/Qoe/Ikdl=`cK]TaK9K_ZY:ZIE:
WH^Ri=KFooW]ooooo_ooo?ooo_l6VIVI0P0001>IVIT200000iVIV@800000
0iVIV@000000000HVIVI0P0000:IVIT2000029VIV@800002VIVI0P0003bI
VIT00oooolc<c<c<c01Mc<c<00EZEAiP;a@S9PXJ4Q@S9PX00ULL009P;`X0
1W8V07]<560_56Y12V0_2TH_2P=G7002ARl:00AG70169PXS9PX94PX4ARl:
010m70Y6;`Y6;`X/4P169PXS9PY6;`Xm70Y69PXS9PY6;`X/4P16;`Xm70YP
;`Y69PX2ARl:011Z@@YP;aAb>01P;`Y6;`Y69PX/>2UbSEb`ZXBVV6o:d<7L
hmJES@1ZEAjNLPZ=E@X3WW8:01FVI`2=E@ZEEABNLPZ3GQAkC0YZ@@Y6;`XJ
2@Y6;`YG700S9PXJ4Q@92@X971@J2@XS70Xm70XS70XS9PXd;ah00THV500:
Ea`0LSPDH2lDUD`Y/8AVg;j]/8AVUEDDLSPDH44Y0iE<:@0XUEDD/8eBYW9B
g>?Pi<O1ooooi=3<YUEVm^gZm_oom_Keg;>4i<O1m_Kem_ooooooWW/cWXdY
^IQLUHeBH5hcPg/c`K>>g>?PUIQVSHeB^JY_UHeVH44D^IQL/:Z4g;j]i=3<
^JY_/:Z4YYR4WXAVUHeBdkj>i<O10/[@`@03YZ6HkOKem_oo00;fool02>g7
Q?K@Q?KII^BcAoKII_K7?Nfn?OK77P;T/bT02^Bc<oK77^Bc<m>H2_Jc0>Bc
<oJc0>Bc:NBcAoK77P;od3d00oK@Q>Bc<ooSQ004on>>00OohhCokHkfd8Co
hhkfd8CffFKohh@00_KIIP0:i;<Nm]UVi;=7i;<cbYPD`H@0^HdDNd`:H2l:
8bH:0a4L2P0;6Q8D2@T:PehDkM2HkMW<^JY_WXdY8blN2@TD8a`:6PT:00;o
kL`03?o]S_o]c?o]S_K@Q?KII/ZH5=>H2W]<514V51XB52`L578V00Woool0
0oKomOooooooo`04oooo00?foooLhmKoool01?ooo`03dmWFc<c<c<c<05o<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIV
c<c<VIVI01BIVIT06?kono_lmoomoO_io>gknl3[i4NLRCV[TCRmWSo9Z5G?
]VKC_W?@_Wc@`H;EaHGIbHCKbXOPcX[SdHgTdhkRdXkQdHoRdY3QdP>?h=46
S^7A03B>hLn?h<n>hLn?h<n>hLn?h<n>hLn?h<n>hLn?h<n>hLn?h<n>hLn?
h<n>hLn>glj=h<j>glj=h<j>glj=h<j>glj=h<j>glj=h<j>glj=h<j>glj=
h<j>glj=h<j?h<n>hLn?h<n>hLn?h<n>hLn?h<n>hLn?h<n>hLn?h<n>hLn?
h<n>hLn?h<n>hLn@hM:?h]:@hM:?h]:@hM82Sn;B01Z>h]:=h=2<h=2<h=2:
hM2;gln9h<n;gln9h<n6f/Z4fl^0f<Qie<=cdL5/ckeOa[=D_ZQ9/9]3XXi<
WHbakN7Rooo_oOkooOoonooooOl4VIVI1P0001:IVIT500000iVIV@030000
VIVIVIVI01NIVIT400002YVIV@<0000019VIV@000000000003ZIVIT00ooo
olc<c<c<c01Mc<c<00QP;`XS70XS9PX/4P169QAP;aAP;`YP;a@2H2l:011b
>01Z@@Yb>1AP;`YG70169PYP;`Y6;`YG701P;`Y6;`Y69PXm70X94PYkC0YG
7002H2l:00=69PY6;`Xm70X00R<V2P04ARH:?A`:?A`:ARl:0SdL2P0S;180
ARH:Ea`0H44DH2l:JT4:LSP0JT4:Ea`0LSP0ARl:Ea`08bH:AT4NH5hcJVLc
YYR4b]31bZYVPehDNd40PehDNd`:PehDSED:Pd40LSP0JVLcARH:Nd`DJUDN
Nd`:ARl:2@T:;1`D00969Q@01Q4L2R`B00TB2QX92R<L2PT92P8S70X032`V
54HV54H_2TI17V0_578h078h59E<:JIbD/5kNmbcXk2=DP9b>1@04f0_5611
:F11:JIEI[1kI/5kNnBZV=bn]oKoooooonC7`K24NoKfmNC@c;2=D^gIc?Kf
mOK]j_ooo`02`K>>00JEV6J3Nc>NLS?Tal7C_Xk1al42`K>]00S1/hjESE;C
_Xj`ZXC:_Zg:d<6`ZXCLaj<2`K>>00R3Nc?:d<7CfMK:d<71/hk:d<6EXHkf
kNX2m_oo00GfooGffFK]d9SohhkffFH00^g7G005m[<0m/LNkLMLi;<Ym[<0
00;T/bT03?Jc0>BZ0>Bc:OJc0>Bc7^BcAoK77^g7G?o@?Ng7G>BZ0>g@V0;o
hhh01^g@V?o]S_oSS_oSS_KII_oSQ0;ohhh05oKII_o@?OK7?OK7?OKII^g7
G=bZ<lZH5<640;V=57]<2VY12R`V514L2R<V2Q4L2QX92Q4L2W8h5>C7`Mc7
Xl6cS[V=:@024BHD00<92A@0003]d9P01?o]c009on>4m]UVi;<NbYPDPehD
;2HD4BHN6Q8DEa`000Woool00oKomOooooooo`04oooo00?foooLhn3fool0
1?ooo`03g>?Fc<c<c<c<05o<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01BIVIT06?WonoOln?omookioOSo
olg`jU2HRSjXTBfbTc?0WTK;[US@]fS>^GK=_H??`XWEb87EaH7JaXKMbXSO
c8WNbhSKbH[KbX_Lb`:?gLd2SMk=18cOc@03SMk=SMk;SMk;00f=g//@S=g:
48gNb`J>glh2SN3>0X_Nc0>9g//2R=g:01:9g<b7d<F8dLInd/=cd;iVd;aM
cKM?`ja7^J8kYHm1W8YEWI70ln[[ooo`n_coo?oonoooo_n=VIVI00?oooo<
c<c<c<`0GLc<c08S9PX01CdB2R<V2V0_2THV58eE2P02LSP000Qb>1Ab>01b
9P1P@AAZ@@YP;`YZ@@YP;`X2Ea`000IP;`YG7016;`Y6;`X94PYk@@02H2l:
01:3Nea6;`Y6;`X/4P0m70YG700S9PXm70Xd;ai69PXm70X/4P0/9Q@S9PY6
9QAb>01G701ZEAh2H2l:0dH_2P0:?A`:8bH:AT4NJVLcPg/cSHe7WXdcUHd0
Ea`0JT4:0W]<2P0AWW8:2@TD4BH:?A`:LXdmPg/cPehcARl:H44D8a`:;1`D
Pg/cJUDNARl:8bH:4A`:6Q8D008A70X00b<L2PTB2R<L2P03ARHD00aP@AA6
9QAP;aAP;`Z`@C>`SE;1XHCL/jfVLU9kC1AZEAiP;`X2H2lD00BELTO1XHCT
al7L/j<2kMW<00_fkN[]fLab9P2VQ8CL_[NiLS?Tal7okLcfm_GfoooL/jd0
0ZJHK`03YXAB/:Z4kNgZ00;1/hh05=>nS/6c[KVZKl6cS^C@c:JQI]cSe/ZZ
I]>nSZJQI[2ZQ7]<2ZJHKoK]j]c7Xl6cS]>nS]cSe/6c[McSh0;fool02ngI
c>g7Q?oSQ?oSS^fn?OK7?OK@Q>fn?OK7?NBc:OK77P03i:X000CCV0[faakT
/bWT/bT3m[<000KT/c?faak]aec:XCgffFK]d9P3on>>01KffFKohhkohhkf
d8CohhCffFKfd8Cfacg]aecfacg]aecT/dOCZTO:V1CCV0Z`N`Z=E@YP@AA6
9Q@S70XJ2@XJ4Q@24A`:00eP;aCC_Xk:_Zf`ZXBESE8A9PXA9Q@J4Q@92@[]
ahCfooGokLcfooD00_o]SP08m]UVdj4Yi;<NWW8D;2HD6RHD8blNEa`02Ooo
o`03m_oeoooooooo00Goool00mcSh?K]j_ooo`03oooo00?CfMK<c<c<c<`0
Glc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT059VIV@0Hm?ommOojoognoocoookog?3_Ql2g<i1k9jB69;6>
<kjMDM:dGLNaOMC4X>?JU=K<U^?CSn3=T^7>UnKCVnSFV^CCVnCCWnSG19cU
e0:KiM@00iWVe9WVdY_VdP0_VnKB19cUe0BKiM@06IcYei_XeY_XeY[WeIWX
eIOVdi?RciCLcZ7Je:GPg7c9_gOHafGI`TC3Z472YRJPQbZDOT6EQGbh/>?o
onWhnoOhoOokoooiooono`2=VIVI00?oooo<c<c<c<`0GLc<c003ARHD?A`:
ARHD00969PX2Nd`:01B3>01b>1Ak@@1kC0YP;`YkC1Ab>01P;`Yb9P1b>016
;`YP;`YG7016;`YG70169PX94PYZ@@Yb>01Z@@X2ARl:00=G700S9PXS9PX0
0R<V2P8/4P000b<V2R`B02<L2P02;18000Tm70Y69PY6;`YP;`Y6;`YP;`YG
700m70Y6;`X00R`B000:;2HDAUDY=5DYJT4:Nd40H2l:?A`:ARl:?A`:H2l:
0R<L2P054A`:AUDYJVLcNheVAT4N0096;`X08B<L2VYE7Yj=<fYE7TI17Q4L
2PTB2R`B01XB51X92R<L2R`B02`L52`V54HV54HV2SdL2THV2V0_578h59E<
:KUb<l5kNnBZV=>nSYEE59E<:F0_54HV2S@_:F0_59EN<jJ4Q002kMW<027f
m_Gfooofm_Gfm_GfkN[TZYREC2WL/j?]fLcfm_GooooL_[NNSC>VV6oLhmK1
/jfVV8C1/hk]d9SC_XjNSC>`ZXC:_Zg:d<7Laj>iZVoL_Zg:_ZfNSC?1/hk:
d<6iZVoLhn000[VZK`04`K>>kMW<m^gZi=3<0_ooo`04ong<onf>kM2Hon>>
1?K7?@05i;<cm/Lmi;<Yi;<Nm[<000?CV0X03/ZH5?Jc0=>H2^Bc<nBc7_K7
?NBc:Ng7G>Bc7^g7G?o]S_oSS_oSQ?oSSP;okHh2m]UV00?ohhCffFKfacd0
0_K7?@04kLMLm/LmkLMLg:Xc0/ZH500C^HdDSED:H44DARHD6RHD4A`:2A8:
4BHD2@TDARl:^JY_dkj>YYQ_WXdc4BH:2A`N6Q8D0000g:Xc00;okL`03?Ko
mOo]c?o]S^g7G>Bc<mbZ<l6403@_7QXL7QXV53dB2_o]c0Soool00oK]j_oo
ooooo`04oooo00?fooo]m_GLhn001?ooo`03dmWFc<c<c<c<05o<c<`016IV
IXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI
01BIVIT06?7ooOGonoonoooioogcnoGooj_FccB1LAj>MBFXR3>mW3joXGgY
dX_Od8c;`k;[i:S/gJ;[f:?Zf:[_gJc_gZ[]g:g[g;3^g`B]jm`2[>cL00>Z
kMbZkM^/k=/0;jc/f`B]jm`4[>cL01V[k]fZkMbZkMbZkMbZkmfYk]bVjmVX
i]VTd<neinJPjN28jMQIdKP]/YD//I@YY8PaU80jQ7NWe<oZoookooooo?oo
n?gon?_oo_l0SIVIV@03ooooc<c<c<c<05g<c<`01DHV2SdL2THV2SdL2X<h
0002Nd`:0163@@1k@@1kC0Yk@@1P;`Yb>1Ab>01P;`YkC0Yb9P1P;`Yb>01P
;`YG7016;`YG70094PX00VY12P05H2l:Ea`0ARH:ARl:8bH:00</4P003b<L
2QX92SdL2R`B01X92R<L2SdL2Q4L2TH_2R`B060_2R<V2TH_2SdL2R`B0002
8a`:00LJ2@XS9PXS;ahS;ahdEBTJ4Q@94PX00R<L2P0B?A`:ARH:2A8:6Q8D
2A8:AT`mPehcJVLcSHe7=2lNPg/c0000JUDNPg/c2A`D2@T:4A`:6Q8D0R`B
00044A`:2@T:4A`:ARH:14HV50969PX0460_57]<5;Ub<kUb<l6QQ>BZV;1k
:G8h560_54HV578h560_578h59EE5?o]c?K]jP;fm_D03OKoooKfmOKoom>n
SZI10>BZV>gIc?o]c?Koong@V<6QQ;VZKng]jP03dkj>00G1/hj=SE:`ZXCC
_XkCfMH00m>nSP0A`K>>^JY_YYQ_`K>]kOKe`K>>bZ5Bg;>4g<NSkMW<m_oe
ooooUHAk`LO<m_oom_oekM2H00;ohhh2kLML01OffFK]aecT/akfacgT/c?T
/bWT/akf/`3CV0[TZP3CQ03TZP3CV0[TZP3faakT/c?facg]aecT/dOT/c?o
kHkohhk]d9P00_oSSP04kM2Hon>>m]UVkM2H0_KIIP0KkLMLkLN4m/LmkLML
g;=Lg:Xc^H@DbYPD`H@0PehDJT4:ARHD;2HD6PT:6Q8D4A`:6Q8D?A`:/8eB
g<NSUHeBWXdcAT4N2@T:4BHD6PT:^G8c00?okL`00oo]S_oSQ?K@Q002i;<Y
00J`SAi6@AhA9Q@J4Q@/4P3okL`8oooo00?]kN[oooooool01?ooo`03m_oo
kOKekMW<00Coool00m?Ie/c<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0DVIVI01S`ooo_o_Wo
o_oon_okk_Ooo_oOo?Yb[:0ZQg88NV0VXXHm]IYXckbSmnZTh]f_i^2_jMf[
j=R_jMZck=fejmfcjM^di]Zfj=`4]NOK0[CXf`:cjM/00kCXfkCYfKCYf@0]
]>WI0[GWf`Jdj=/2/NOI01>_j=Vaj]^ck=fbjmb`jMZaiMW5k>^/f]RBfM6<
kMabj]4o`JDKW7hEQFd/P75^Yj3PoO_do_omnol00_omo`03oocmookoVIVI
08bIVIT00oooolc<c<c<c01Mc<c<00A69PYP;`Y69QAk@@02Nd`D00B3>01Z
@@YZ@@YZ@@X2Nd`:00Ub>01kC0Yb>01b>01P;`Yb9P1P;`Yb>016;`X00ULL
000<2@T:LSP0LRH0Ea`0ARl:ARH:;1808bH:8a`:4A`:6PT:8a`:0R`B000:
6Q8D;1804A`:6PT:8a`:;180;1`D;1808bH:;18012<L2P086PT:8bH:;4`Y
;2HD;4`Y4A`:00006PT:0b<L2P0J2A8:4A`:6Q8DJVLcWXdcWXdYH44DNd`:
PehD2@T:H44D;1802A8:2@T:6PT:;1808a`:6PT:4A`:2A8:4A`:?A`:ARHD
8bH:ARH:;2HD0THV500:Ea`0PcP0/44c/8eBg;>4g;>SYW9BPcP0;2HDARH:
0V0_5004UD`Y`G]km^gZm_oo0_K]jP0:m_Kem^gZkMW<YW9B^G8ci:ZHkMW<
m^gZm_Keg>?F0[VZK`09i=3<`K>>`K>>`K>>UIQVWW/c`LO1b]31i=3<00;C
_Xh02=c7Xng@V:JHKk2ZQ=c7XmcSh=c7Xng@V0;:d<401<77`Mbn]oKooiEb
A`;oool02^g@V?o]c?o]S_KII^g7G?KII^g7G?K7?NBcAoK7?@;]_Sd01>Bc
<nBZ0=>H2^BZ00?CQ0001m>H2^BZ0>Bc7^Bc7_K@Q>g7G<ZQ?@04on>>00?f
fFKohhkohhh00oKIIP03kLMLm/Lmm/Lm00;]ae`02Nfn?MbcG=>H2/ZH:KV4
59ib56Y12TH_2QXV50034A`:01TJ2@XA70ZNNc?C_Xj=SDNNSC=6;`X971@A
9Q@92@ZNGQCokLcokHkokLcohhCokHkfd8CT/dOT/c>iSBUP@A@92A@J9Q@/
4P3L/j<02?ooo`03i=3<oooooooo00Coool00oKoongfmM?IeP04oooo00?C
fMK<c<c<c<`0Glc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;P4c<c<00=VIVK<c<bIVIT059VIV@0Hl_ool?choooooocooo?loogom?oo
c?G_Eij@981[7HA_>jF?GK^[T>;FSM39Z>?M[NOK[nOJ/NWL]>[M]NWM]>KK
]^GK]nKL1KSWg@:fj=d3]^SL02bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bh
j=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bf
j=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bhj=bfj=bh
j=bfj=bhj=bfj=bhj=bfj=`2^>SL0kSWg@Ffj=d06KCVfk?Wfk?WfkCZgKK/
gkG[g[?Yg;;Ug:SEd[3Th:Saj7_IbDZlYC2XSAV9LAMfHV>UVlWbk_Coooon
ooC^l_khn_onoOoooOooo`2=VIVI00?oooo<c<c<c<`0GLc<c005ARH:ARl:
Nd`DSED:Nd4000:3@@001g]<2W8V08=107]<2W8h06Y12W]10002JT4:00Eb
>01P;`Yb9P1b9P1G70000TH_2P0;4BH:ARl:H2l:ARl:ARH:8bH:;1808a`:
;1808a`:;180008J2@X01A4L2QX92Q4L2QX92Q4L2P026PT:00@S70XJ2@XA
70X/4P028a`:00@J2@X94PXA70XS9PX3;2HD00@94PXA70XA70XS70X26PT:
00<A70XJ4Q@000000VYE7P0BPg/cARH:bZ5BJT4:4BH:8a`:6PT:2@T:4A`:
;1806Q8D;1804BHN6PT:2A8:8a`:?A`:8bH:0R`L500=?A8:?A`:?A`:ARH:
LSPD/44cYW9Bi:ZHg;>S`J64/7/Y8bH:8blN008/71@03IE<:L6QQ>gIc?Ko
ongIc?K]j^gIc:JHQ9EN<kUb<nBZV>gIc?o]c002m_Ke00?oooniZVo1XH@0
0]>nSP0>g<NSdkj>PehD`K>>b[j]b]31b[j]g<NSb]31dkj>b[j]YYQ_i=3<
b]310^C7`@07g>?FkMW<SHeBg;jgg>?Fm_ooWXAV00;fool02?o]c?o]S^gI
c?KII_K@Q?K7?OoSS^g7G0;ffFH01>g7G?K7?Ng7G>Bc7P;CV0X3dh@00[UW
0008/5D0dh@0kKhmdjY7^Hdconf>ong<m]240_KIIP06kM2Hm]UVm]24kM2H
m]24m]UV1>fn?@;T/dL3bYPD022NLPYZ@@YZ@@X/71@A70XJ2@XA9Q@A70X9
2@Z3GS?C_XjESE:=SDLdEBTA70XA9Q@A70Z3;`3okLcokHkokLcfd8C]d9Sf
d8CT/dOT/aj`SAiZ@@X971@S9PXJ2@[]ah@8oooo00?]kN[fooGoool01_oo
o`03`K>]oooooooo00;oool00mcSe/c<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0C<c<`2IVIV00?<c<bIVIVIVIT04YVI
V@0EnOoonooooooooogooocomoGjl_[mk_ooeoomBHMl;WM/>heoJ[jaL<:f
Yo;[T]S@VmgAX^3CYN?FYn?GZ>;F00:YhMH01:_PeZcQejcQejcQe`:Zh]L3
ZN?G02jZh]NZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZ
h]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/
h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZh]F/h]FZ
h]F/h]FZh]D2[>;E0jcQe`BZh]L05:WSejSReZSReZSReZOSejSTf:OSejCP
e:7Oe9gJdY?FcHoOdWWD`df`W2N8MBIjJdN;P=?mnO3ooo?fn`;ooOl01?ol
nocnnO_on_kooHfIVIT00oooolc<c<c<c01Mc<c<01969PXm4PZ3GQB=E@Yk
C0YZ@@YkC0Yb>1B3@@1k@@1kC0Z3>01kC0Yk@@1b>01kC1Ab9P1b>002H2l:
00EG701P;`YG700J2@YP;`X00ULL000=ARl:ARHD;1808a`:4A`:6PT:4BHD
6PT:2@T:8a`:4A`:6PT:2@T:008A70X00aX92Q4L2R`B00028a`:00TA70XJ
2@X94PX/4P0A70XS;ahd;ahS;ahJ9Q@00PTB2P044A`:6PT:8a`:6PT:0Q4L
2P036Q8DWXdcARl:00:3Nc<00k2ZQ6YE7R<V2P024A`:00PS70XA9PX94PX/
4P0A70XJ2@XJ4Q@92A@38a`:01d/71A6C3e69Q@m70YP;aA69QB3;`2EC2V`
NbWC_XkL/j?1XHB`NbUG700J9Q@/71@d;ajEGS?TZYSfkN[fooookLcTd<b`
NfJ`@C>iLS?TZYSTal7]fL`00_K]jP04m_Kem_oe^JY_^IQL0m>nSP0I^JY_
`K>]dkj>dmWFdkj>dmWFb[j]g<NSb[j]i=3<b]31i=3<b]31`K>]dmWF`K>]
UIQVWXAVYYQ_LVMBYYR4g;jgoooom_ookM2H00;okHh01?K@Q?KII_K@Q?K@
Q0;ffFH01OK@Q?KII^g7Q?oSS^g7G002i;<Y00G:V1CCV0[CQ02iI`3TZP00
0^Bc:@03m]UVkKhm^H@D00?okHh02Ng7Q?oSS_KII^g7Q?KII_oSS_K@Q?K7
?Ng7G002kKhm00?]aec]_SgL/e`00/ZH5006/8dNWW8DNd`:ARl:;2HD4A`:
0QXB508A70X02h=N<kVZKhf=Ah=k<c@_7Q4V2QXB514V578V0?o]c>g@V002
m]240_KIIP;CXBT01[V=<f1150T951XL7PT95=>ZA`Soool00ng]j_KomOoo
o`04oooo00?fooooooo1/jd01?ooo`03g>?Fc<c<c<c<05o<c<`016IVIXS0
^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c004IVIVc<c<IVIVc<c<
4iVIV@0HnoWlookoo_komoOiookoo_ooloKkmoool?ooh_ooD85m=W=/=Gie
H;2UE:NMRMg@P<k1R]C7T=[=TMW=TMO<UMW>U][?UmW?0iCFc0:Cel`3TMO<
0Y?GbP0aU=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:
TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:
U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:TmO:U=K:
TmO:U=K:TmO:U=K<TmO<U=K<00BCel`0197Gc9?IcY;HcI;Hc@:AfLd0593H
c8gEbHOCaWk>`Fk2/f6hZ52WUb=gJ1IPDfJRV]7kmo3oooKkooomoo_bmoom
oooono?jl_WonokooHfIVIT00oooolc<c<c<c01Mc<c<0W8h500BPehDPd40
JT4:JT4:Pd40PcP0JT4:SED:Nd40Nd`:Pd40LSPDNd`:LRH0Nd`:H2l:LSP0
LRH00V0_2P0:Ea`04A`:H2l:H2l:Ea`0H2l:;180ARHD;1808a`:0R`B0007
6PT:4A`:4A`:6PT:;2HD4A`:6PT:008A70X041X92Q4L2R`B00T92R<L2R`B
00T92R`B014L2S@_7R`V51XV514L2PTB2Q4L2QX92P8S70X05a4V2QX92QXV
514L2YF=DW]<2VYW<l6cS[VHG8=k<b<V2Q4L2PTB2R<L2PT952<L2R`B00TB
2Q4L2PTB2Q4L2R<L2R<V2P028a`:00DA70Y69QA69QA69PYP;a@00W8h500?
WUhD`J64i:ZH`J64/8eBARl:;2HD?A`:Ea`0YW9Bi<O1ong<m_Kei:ZH`G]k
00:iLS<06>BnQ=bc[NgIc?o]c?K]j_KfmOKoonC@c<6QQ;2=<l6cS/6c[JJH
Kl6cS_Koom?Ie/77c=cSh<[@`NC@c<Zn[L[@`McSe^gfm@;:d<404<Zn[McS
e[2ZQ;24I[2ZQ=c7Xl[@`McSh?ooooKomOKoong@V?o]c>gIc?KII^g@V0;f
fFH03?K@Q>g7G?KII_K@Q?oSS^g@V?K@Q?KII^BcAoK7?Ng@V?K7?@;]ae`0
2^BcAng7G=>Q:KV4:Iib2_oSQ>gIc?o]S_oSQ>g@V0;ohhh02?K@Q?oSQ?K@
Q?KII_K7?Ng7G?K7?Nfn?@;T/dL01lZH:KV=5<ZH59ib57]<2V1152<L2P02
4A`:01XA9Q@J4Q@94PYZEAjiZVnVXFJESE96;`XJ9Q@971@J4QAb9P3ohhkf
fFKfd8Cohhk]aecT/c?CXBW:V2V`SAiP@A@92A@A9PX92ABiLS<8oooo00?]
m_G]fLcoool01?ooo`05m_ooooooYZZSm^gZm_oo00;oool00m?Ie/c<c<c<
c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
1FIVI/c<c9VIVFIVI/c<c00BVIVI01SomOcoo?ono_oho_khoooiooolooon
ooogn_ogoooZoomVT8m>S8LSLfPaSH0mWi1A[imK]jQR_ZmS_ZmU_JmZ`;=/
`[E^`[D3Jknb0VVo/P9X`;80=6Vo/VW0/6W0/6^o/6W0/6^o/6W0/6^o/6W0
/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o
/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0
/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/6W0/6^o/VVo/V^o/PAY_k80
16S0/V[2]6W1/fS0/P9W`[<04FK1/V>n[ejl[52fXD^aVbF2KaU/G3IjKg^`
Z]Oin_;oooCgo_[cnookooS_l_[imocon`02n?oj00?loofIVIVIVIT0RiVI
V@03ooooc<c<c<c<05g<c<`056Y12W8h08=N58eE2THV2W8h08=1078V08<h
08=108eE2X=107]<58=107]<2W8h07]<2W8V07]<2W8V00=P;`X0314L2VY1
2W]1078h04HV55LL02`B02<L2R`B01X92R<L2Q4L2P8J2@X02a4L2PT92PT9
2QX92PT92R`B014L2QX92Q4L2R<L2PT92P028a`:0Q4L2P03;2HD4BH:4A`:
00892@X00`TB2QX92Q4L2P02;18001<971@S70X0001ZIc>3Nc=PGS?:d<6`
ZXBEV6IkC0X94PXS70XS9PX/4P0A70X/4P092A@92@XA70X00R`B00<S70X0
0aX92R<V2V0_5002H2lD01BEC2VEGS>EC2V`SE;1XHB`SE:EC2Tm70X/9Q@J
9QAP;`[1Ng_okLcfm_Gfooo1Ng_:ZVKL/hCTZYSL/jd2ong<00[fkN[fm_Gf
m_GfooG]fLcC_XjiSC?:ZVKTd<c1/hh2kNgZ00OLaj?1/hkLaj?Td<b`ZXC:
d<7fooD00]cSeP05`K>>b[j]b[j]i<O1/:Z400;:_Zd02JJZXmbn]ngfmOKo
ooK]j_KoonBcAoo]c?o]SP04m]UV00?]_Sg]aecfd8@00oK@Q004kLN4kKhm
kKhmm]240^g7G00Em]UVi;=7kLMLi;<Y^H@DYT40UEDDong<kMW<onf>kM2H
ong<kMW<ong<kLMLm]24kLN4m]UVi;=7kLMLi;<c00;T/dL05]bcG<ZH:KV=
5;V4:JIb06YE7VY12R<_7Q4L2QX92Q4L2PTB2QXB54H_2/ZZIXf=DXf=Ab<_
7QXV50TL51XB53dB2P;ohhh03OKII^g7G?K7?NBcAmbZ<jIb58eE2X=N50TL
51XB514V59iN5?Koo`07oooo00GfooGTd<coooooooofool00_ooo`08m_oo
oooo`K>]g>?Poooom_oooooog>?PHLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P4c<c<00IVIVK<c<bIVIVIVIUVIVK<c<`AVIVI01So
n?oomOcooooioooboooaoOgloooooOonn?okn_oeoooYoooEoon^o_<lW8hR
SG/>MF@HOfhQQWHRQgLUQGLZRW`_SGl^S7h2<8ao0Rn=O`@]SGl`;hem1Rn=
O`@]SGl05b^=ORb>Obf?P2b>ObN<O2:<N0UiHAZ8Kd6RSZcmk]GoomKnoNoo
oo_ooookooojoo[]m_oloooooOKmmOOon_KonOcoo@2=VIVI00?oooo<c<c<
c<`0GLc<c006Pd40SED:Nd40Nd`DPd40Nd400g]<2P03PcP0Nd`:Pd4000:=
E@X01G]<2X=107]<2W8V078h0002H2l:00Mb9P23;`0J4QAkC0Z3@@1b>1AZ
@@X00THV2P03;1808bH:8a`:008/4P002AX92PT92QX92Q4L2QXB514L2QX9
2Q4L2QX92P022@T:0R`B00044A`:2@T:6PT:6PT:0Q4L2P0E2A8:4A`:2@T:
2@T:6PT:;1806Q8D2A8:2@T:4A`:6PT:H44Y/8@Y^IQLYYQ_YZ5V/8eBWXdY
2A8:8a`:;180008J2@X01R<L2Q4L2Q4L2Q4L2QX92R<L2P8/71@01B<L2R`L
514L2THV56YE7P02H44Y00nEGS>3GS>EC2VVQ5:NNc=P@BTS9PXS;ah/71Ab
>1CL_[Ofm_Gfooofm_GL/jd00nBZV003g;jgong<m_Ke00?fm_D03_KoooK]
j/Zn[KVZKkVHG>g]j/6c[OKook2c]lZn[Mbn]ngIc:JQV;2ZQ0;]m_D05/77
`L[@`L[@`NC7`K2ZQ=cSe]bn]l[@`L77`NC@c=cSe_KfmOooooKoooooonBc
:Oo]S^g@V?KII^g7Q?K7?Ng7Q0?]_Sd3kLML0nfn?@0;m]UVkKhmkLMLm]UV
kLMLkKhmdh@0/4`0/5D0SED:ong<00?ohhh01Ng@V?oSS_oSS_oSS^g7Q002
on>>0^g7G00XkKhmi;=7i;=7g;=LbZY7^H@DbYPDWXdYLSP0H44D;1`D4BHD
6Q8D2@TD4A`:2@T:8bH:`K>>SHeBPg/c8blN6RHD6PT:4BHD;180m]UVm]24
m]UVi;=7m/LmbZ4mdj4Y^H@DWW8cNd`D2@TD6RHD4BHDLRH0m^gZ1oooo`03
m_oob]31m_oo00Coool01?Kooooool77`McSeP;fool00oooomcSe/c<c01P
c<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIV
I/c<c9VIV@02VIVI00=VIVK<c<c<c<`0olc<c0k<c<`00oooolc<c<c<c01M
c<c<00UkC0YkC1B3@@1kC1B3@@1k@@23>01kC0Z3>0000h=1000>SED:PehD
Pd40Pd40PcP0Nd`:Pd40Nd40LRH0H2l:Pbl08a`:JT4:SED:0VY12P06H2l:
ARl:;180?A`:;1808a`:0aX92P034A`:6PT:2@T:00892@X02aX92Q4L2PT9
2Q4L2PTB2QX92QXB50T92Q4L2QX92R`V50034A`:0PTB2P044A`:2@TD2A8:
2A8:0Q4L2P0:2@T:;3PYPg/cPg]LYZZSUIQVUHABPg/c2A8:4A`:0R<L2P05
4A`:6PT:2@T:2@T:4A`:008J2@X042<L2R`V53dL2THV2TH_2PT92Q4V52<L
2VYE7Yik<k24I[1kIYEN<g8h53@_7QXV508/71@02h<_0>gIc?KfmOKfmOoo
ombn]mbc[NBnQ=bc[NC7`NgIc002m_Ke01kfooofm_Gfm_G]fLc1/hjiV5c:
XE;]m_GL_[O:_Zg1/hkTd<c:d<7LhmIbIe;:d<7:d=K:d<7:_ZgCfMK:d<71
/jfESFK]m_G]kN[LhmJVXFIbIe:VV8BVZZ<2m_oo00C]m_GT/bWokLcohhh2
m]2403c]_Sgfacg]aec]_Sgfacg]aec]_SgT/c?]aecfacg]aecffFKfacgT
/c?T/dOT/c?T/dOT/aj`N`ZV@@23;`3okHkohhk]d9Sfd8CokLc]aecohhk]
d9Sohhk]d9S]ahCffFK]aecT/bWT/akLZS?L/ec:V1BiQ1C:V1BNLQAb>1Ak
C0XS9PXS70X92A@/4P0J4Q@J2@XS70ZVV6n3Nc>ELTM6@AhJ9Q@A70XS70XJ
2@[od3d2m]UV00ST/c?]aecT/akCXBViQ1BNLPZ3GQ@92A@26Q8D00<m4P[]
d9Soool01oooo`03b[j]m^gZm_oo00;fool00oooooKoooooo`02b]3100C]
m_GfoooooooCfMIQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^0C<c<`00fIVI/c<c9VIV@03VIVIofIVIQ1VIVH00oooolc<c<c<c01M
c<c<00V3@@2=E@Z3@@23@@23>01b>1B3@@23>023;`000W]10005SED:LSPD
UED0Pd40Nd`:00:3@@02Nd4000Qb>01b9P1P;`X/4P1kC0Z3@@1k@@1b>002
H2l:00<S9PY6;`XS9PX00R`B00046PT:2@T:8a`:2@T:0Q4L2P036PT:4A`:
2@T:00<92@X0314L2R`B014L2R`B014L2R`V52<V2R`L514L2PTB2PT92QXB
508J2@X02A4L2QX92R<L2R`B03@_7Xf=KjJQV<6cSZJHK`02`K>>00</4P0S
9PXA9PX00b<L2P044A`:2@T:4A`:4A`:0b<L2P0K8bH:H44DH2lDARHD4A`:
6Q8D;1`DH44YPehc`J64YZZSH44D6RHD6Q8D;1`D;180YUEVkMW<kNgZm_Ke
i=3<i:ZH`G]kg;>4i:ZHg;jgkMW<00;fm_D02?KoooKfmOKfmOKfmJJQI/6Q
Q=>nS^g]jP:`ZX@2b[j]00FVZZ?]m_FVQ8C:_Zg1/hh00/Zn[@;1/jd08NC@
c:JZ[NgfmK2c]iFQSYF4D[2ZQ=bn[Ng]j_KoooooooKomM>Q:Oo]c>g@V>g7
G?KII^fn?Ng7G?K7?NBcAnfn?OK@Q>g7G?KII^g7Q>g@V?K@Q?oSS^g@V>Bc
<ng7G<ZH5002kKhm00?ffFKCQ02EE@000_oSSP06m]24kLN4on>>on>>kM2H
m]240_oSSP0[m/LmkLN4kKhmkKhmg:Xcg;=LdjY7bZ4m/7/DbZ4mWXdYPehD
JT4:;2HD8a`:6Q8D2BHY4A`:2A8:;180UIQVPg/cJVLcAT4N4BHD6PT:2@T:
;180i;<YkLMLm/LmkLMLi;<c^HdcbYPY/8dNPehDNd`D4BHD2@TD8a`:6Q8D
i;j400Soool01L77`McSe_KoooKoooooo`02m_oo00?oooo:d=K:_Zd00_Ko
o`03oooodmWFc<c<063<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c003IVIVc<c<VIVI0?nIVITCVIVI00?oooo<c<c<c<`0GLc<
c00CNd`DLSPDPcP0Nd`:Pd40Nd`:PcP0Nd`DPcP0Nd`:SED:Pd40UED0SED:
Nd`:Pd40UED0Pd40UED000=k@@001H<_02<V2VY12YEE08=10002Nd`:0ULL
0006?A`:;180?A`:4BH:8a`:;1800QX92P03;1806PT:4A`:00892@X00`TB
2Q4L2Q4L2P026PT:00@A70XJ2@XJ2@X/9Q@36RHD00<J4Q@971@A70X00R<L
2P078bH:8a`:8bH:8a`:AUDY/:Z4YYQ_00:`ZX@00iF=IZJZXb`B00038bH:
0R<L2P052@TD4A`:2@T:6PT:4A`:008S70X01aXB54HV560_560_51XL7R`V
52<_7P02000000SLhn2`Q7^3GS</9Q@J4Q@/9QAG703C_Xh2m^gZ00O]fLcT
al7C_XkC_XkL/hCL/jgL_[L00_o]c006m_Kem_oom_Kem_ooong<YYR40/6c
SP0Xg;>Sg;jgi<O1b[j]`K>]g>?FkOKeb]3FYZZSb]31g>?F`K>]JW9Lg>?F
kNgZ`LO1/;>gUIQVYYQ_JVLcm^gZYZ6Hi=3<m_oem_ooi=3<i;<cong<m]UV
on>>kLMLkKhmm]24kLMLm]UVkLMLkLN4m]24kLMLkLN40oK@Q003on>>kKhm
m/Lm00;T/bT02nBZ0?K7?Nfn?M>Q:NgIc?K@Q?oSS^g@V?oSS]bcG?oSSP02
kLN400C]d9SffFK]ahC]ae`2i;<c00_LZS?:XCg:V2V`NaBiQ2V`SAib>1AZ
@@Y6;`XS70X92A@00a4L2P0:6PT:SHe7Pg/cPg/cAUDY4A`:4BHD4A`:6PT:
diP:0^Bc<`09i;=7m/LmbYPY^H@Y/7/:UEDDLSPD2A`D4BHD008J4Q@00lZQ
D_KomOooo`06oooo00?1/jgCfMK]m_D00_Koo`09oooom_oooooob]3F`K>]
m^gZkNgZoooob]3F067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c003IVIVc<c<VIVI01VIVIT2oooo1Oooo@0:ooooo_kno_oo
o_kom_Gjm_Gkk^gehN3XgMgUem[Q0]KKg`?Ef]h2e=WM2MGJgRoEf]d?eM[N
00WEf^3BfN?DgNKNiNgZkoGbmO[fn_gmo_ooool00_ooo@;oo_l5ooooR9VI
V@03ooooc<c<c<c<05g<c<`01G]<57]<2W]<2XeE2YEE0002Nd4000YkC0Z=
E@Z=E@Z3@@1kC1B=E@ZEE@2=E@Z3@@2EE@02Pd4000N=E@Z3@@1b>01P;`YG
701Z@@Z=E@X00X=10004LSP0H2l:ARl:ARH:0SdL2P05;180ARl:8a`:;180
2@T:00<J2@X34A`:0QX92P8A70X071X92Q4L2R<V2S@_:A4V7R<_7R<_:A4V
2PT92TI17TH_2R`V54HV2R<V2QXV52`L514L2Xf=Kl6c[McSh:JHKjJZ[Hf=
AdH_2R<_7Q4L2R<L2PTB2P8A70X00`T92PTB2Q4L2P026PT:01DS70XA70Y6
9QAP;aA6@Aj3;`169Q@m4PYP;a@/4P3foon3Nea6;`Xd;ah971AG702EC2WL
_[Ofm_G]fLcTd<`00l6QQ004g;>4g;>]i:ZHi<O10_Kfm@08m_oom_Kem_oo
ong<WW8c`K>>YZ5Vdkj>0/Zn[@03YZZSg>?Pb]3100;:d<400nC@c<[@`M?I
eP02YZ6H00kCfMK1alb`/kO1/jg:d<6VZZ=PGS?oooo1alc]kN[]m_Gfooo]
fLcTZP02kM2H00Wfd8C]aec]ahC]aecfd8C]aec]_SgffFK]ah@00^g7G009
m]24kLN4m]24kM2HkLMLm]UVi:X0i;<YbYPD00:iI`000k1k2^g@V?oSSP02
kM2H01oohhk]ahC]d9S]ahCffFKohhk]ahC]aec]_SgT/dOLZS?:V1CCXBVi
SC>`Q2ViQ1B`SAikC1AZ@@Y6;`XA70XJ2@XA70X92A@J4Q@0002=SDN3Nc=Z
Ic=6@AhJ9Q@00aXB500@bYPDi;<NkLMLi;<ci;<Y^H@Y^H@D/7/DPehDNd`D
2@TD4A`:6Q8D4BHDWW8cm_oe1Oooo`06m_oooooo`LO1g;jgkNgZm_oe0oKo
o`07ooookNgZYZZSm^gZkNgZoooodmWF067<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01VIVIT4oooo1?ko
o`0:nocnnooolO;gh>?Zg=oVeMSQb/gFa/[E^/7;^<7:0[O0b@04][o8]Kk7
];g6];g61kO0bC6g`<L?]l3900Zg_lZj`m:namK7cmc@fN;Gg^CQi^[`m?Gl
ooonood2ooom00?oooooo_ooo_l00_ono`03ooooVIVIVIVI08JIVIT00ooo
olc<c<c<c01Mc<c<00IkC0Z3@@2=E@Yb>02=E@Z3@@02SED:00>3@@2=E@ZE
E@0019EE0004Pd40UED0Pd40Nd`:0X=1000@PcP0Pd40ARH:JT4:UED0Pd40
Nd40Nd`:LSP0Ea`0ARl:?A`:ARH:?A`:;1808bH:1B<L2P<J2@X01@T92Q4L
2QX92R<L2R`B00028a`:00]?IdM6;`XS9PXS9PY6C3fEXHi6;`YP;`Y6;`Xm
70XS9PX00R`V500:4BH:`K>>UJ6>UJ6>b]31`LO1PehDARl:6RHD8bH:0R<L
2P0U2A8:4A`:4A`:2A8:6PT:8a`:4BH:4A`:8a`:6RHDARHDJUDNPehcWUhD
UHAB/7]V/8AVYYQ_YW9BNd`D;2HD?A8:UD`Y`G]kkMW<kNgZm^gZYZ6HWW8c
`G]k`J64kMW<i<O1g;>]g;jgkMW<ong<00;fm_D02oKoong@V:J4D]bcXjJ4
D/6cSZJHQ=cSe/6c[L77`L6c[@02b]3100B`/kO1alc:d<7:d<43`LO<00gT
d<bEZZfEZZfVQ8BVV8CLhn3]kN[fooo]m_Goooo]d9S:V1C]ah@00_K@Q009
m]UVkLMLm]24kLN4kLMLi;=7kLMLm]24kLN400?]ae`02_KII]c7Xng7G>g7
Q>Bc:Nfn?Ng7G>fn?Ng7G=bZ<`;]d9P02?oSS^g@V?oSS^g7G?oSS^g@V>g7
G>g@V0;]ah@01nBcAnBc<mbZ<m>Q:MbZ<lZQ?K1k2P02/8dN00AZEAikC0Xd
;ahS9PX44A`:00X94PYZEAj=SDMZIc=6@AhA9PXA70X971@J2@ZiLS<2i;<Y
00o:XCgLZS?:V1BNLS>NGQAb>1AP@A@A9QhA70XA9Q@92AB=E@[okLcfooGo
ool00_Koo`?oool00l77`L6c[Ng]jP05m_oo00K]m_FVXISLhn3]kN[foooL
hn1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
0fIVI/c<c9VIV@0IVIVI1?ooo`?nool02_cooo7dnNkcnM[Nil;9dK[1bk:i
`jR^^ZB/]iJR[P:DXZd01I:PZi6OZY2NZHnMZ8jLY`09SifX02f?WJJ?WJR?
WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?
WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?
WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJJ?WJR?WJH02XnMZ0N@
WZT02Y2NZi^X^In/_JNc`jjja[K0bL;;d=SPh^cbl_coo`;nool01?ooooon
ooonooomo`;oo_n8VIVI00?oooo<c<c<c<`0GLc<c004Nd`:UEDDPd40Nd`:
0XeE2P:3@@001heE2YEE09ib2YEE09iN58eE2Yib2P05UED000b3@@1kC0Z3
@@1P;`YZEAjNLPZEE@23@@1kC0Yk@@1P;`YG7002ARl:0THV2P078bH:8a`:
;1806Q8D;1808a`:8bH:008S70X00`TB2Q4L2SdL2P028a`:00<m70XS9PXd
EBT00UMEDP0DUHB>YZZ]g>?P00002A`D2@T:2A8:4A`:2A8:2@TD=2lNYYR4
SHe_ARl:`LO<UHAkWXdcARl:8bH:8a`:0Q4L2P036PT:4A`:6PT:00892@X2
6PT:0R<L2P0I6Q8D4A`:?A`:Pehc/8eB/8Ak`J64g;>S`J64`K>>Pehc;2HD
SED:`J64g;>]m^gZkOKei=3</8AkJUDNH44YPg]Lb[j]m^gZm_Ke00;]fL`0
2?K]j_KfmOKfmOKoombcXiib<iik<kUb<`;:d<44`LO1016VZZg1al7Lhn3]
kN[:_ZgL/j?C_Xk:ZVKCXBW:ZVK:XE;]aecfd8AGSHjEXHkTd<c]kNX00_Ko
o`05kLN4diP:kLN4kLN4m]2400;]ae`01_K@Q?KII^g7G>g7G=bcG?K@Q0C]
ae`04nfn?OKII^g7Q?KII^BcAoK7?NBc<oKII^g7Q>fn?NBnQ?oSS^g@V?oS
S^g7Q?oSS^g@V?oSS_KIIP02m]240^g7G00=i;<NbYPDbYPYbYPYbZY7/8@Y
/8dN/8dcNd40Nd`DARl:6PT:4A`:008J2@X01aXB50T92X=N<hf=DX=k<dI1
7R<_7P026Q8D01D92ABVC03T/bWT/ak:V1CCXBW:V1B`NaBVLQAb>1Ak@@0A
9Q@J4Q@A9Q@A9Qib9P3fooG]kN[fooooooofool00oooo`04`LO1`K>]g>?F
kOKe0oKoo`07oooom_ooYZ6Hg>?FkNgZoooodmWF067<c<`016IVIXS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01VIVIT0
1?oooOgln_ooooooo`;nool03_cooo;goMWPj<WBfkNobZRb_9bV/XbHYX:>
W7^;V7^>W7N=VgF;VG67U@9]Pi400fn5Tg67UFn5T`08KhFC02e_QI9_QI=_
QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_
QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_
QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI9_QI=_QI802fn5T`0F
L8JDKhFCKXBBK8:@KXBBLhVGMhbMNHVPO8bSP96UR9RXUJ>`Y[>l^lK:b]CF
h>SZlOOgo_oooooooO_no_cooogo0_onohRIVIT00oooolc<c<c<c01Mc<c<
0XeE2P05Pd40LSPDUED0SED:WUhD00:EE@0018eE2YEE09EE09iN50>EE@00
19EE59EE08eE2YEE00>3@@001f0_2W]<2ZIW09ib2YEE58=1078h0003H2l:
00AG7016;`Y6;`Xm70X28bH:0R<L2P0?;180ARHD?A`:;1808a`:Ea`0?A`:
ARH:?A`:ARH:6Q8DAT`mH5hcNheV/;k100;CfMH00dH_2VYE7R`B0002=2lN
01092A@A70XS;aj3Nc=ZLUb`ZXBEQ7^`ZXAP@AA69Q@S9PXJ2@Y6;`X94PXA
70XJ2@X44A`:01dS70XJ2@XS70X/71@J9Q@/9Q@J9QA6@Aj3GS>=SDNEQ5:V
V6n3GS=kC1BEC2V`Q7_L_[OTd<c]fLcfoooL_[NiSC>3GS<92A@S;c?Lhn3C
fMKLhn3]kNX00_K]jP;fm_D03?oool6QQ;VHG<ZZAl6cS[2c]nC@c<6c[JJZ
Xk2n`McSh<77c0;:d=H2kOKe013fooooooofoooLhmK]d9STZP3T/c?od3d9
2@ZEQ5;Lhn3fkN[fooo]kN[L/ecT/bT3kLN400[]_Sg]ahC]aec]d9S]_Sg]
aecT/dO]d9S]ahCT/c<2kLML00ST/c?]aec]aec]ahC]_SgT/c?facg]ah@2
kKhm00C:ZVKohhk]d9S]d9P2m]2401c]ahC]d9Sfd8C]ahCfd8CffFK]_SgL
ZS?CXBW:V1CCXBViSC>iSAB`NaBNSC>NSBUP@AA69Q@S9PXJ2@X/>2T92A@A
70X92@YZIc>=SDMZIc=6EBT34A`:00TA9QB3;`3T/c?:V1CT/akCQ03CXBV`
LP2NGQ@00W]<50056Q8D4BHD4A`:;1`D?A8:00;okL`00oooooKoooKoo`03
oooo00K:d<6VZZ?Lhn3]m_Gfooooool2m_oo00KooonEV:?]fLcfkN[foooL
hn1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
0fIVI/c<c9VIV@0IVIVI01SooognoO_oooooooojnoogn_o_m?[Mi>k@f>>n
b]RX]/>AXK1mSYi]OY1TMhQRMhQNN8UNNHYONX]NNHYLMhQKMXMLMhQMN8T9
FgJ702eKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEK
MXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMK
MhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEKMXMKMhEK
MXMKMhD00U]fQ`QLMhP015YeQUagR5ehREagR09JMHH04eagR5mjSFZ0V5mc
S5eaRFb1U86DXi2R[Z>d_;K3bLKAeMgUj??hnokoooooooonoooloogko_on
o`28VIVI00?oooo<c<c<c<`0GLc<c007SED:YVL0Nd`DLSPDWW8:Pd40SED:
00:EE@001heE2Yib2XeE2XeE2ZIb09EE08eE2P07UED001=Z@@YkC0Z`NaB`
N`ZNLPZEE@1kC0Z3@@1b>01Z@@YP;`Y69PYG70169QA6;`X/4P0S9PXm70XS
9PX00SdL2P0;ARH:8a`:ARH:H2l:ARH:H2l:ARH:;2HDEfMBJW9LJW^400;:
d<404G9WDVYW<l6c[K2ZQ9FHIZJHKfY12P0008=k<jJZXl6cS/6c[K2ZQ:JQ
V6YE7TH_2R<V2P028a`:00PA70XJ2@XA70X92@XA70X94PX92@XA70X38a`:
01</9QA69Q@m70XS9PY69QAP;aAb>1BEGS>NLS>VV6o1/hkL/j?L_[OTd<cT
al7fkN[]fLc1XHB`NbT00W8h5007Y/OPg;jg`G]ki<O1kMW<m^gZm_Ke00;f
ool08k1k:Ij4I[24I[VHG9iN5;V=59ib57]109E<:H=N561158=N<f1156YW
<g8h59F4DZJHQ<77c>gfmOooooK]j]>H2_K7?B<V2ZJHQ>g]j_KfmOKoooK]
j]bcG>Bc<ng7Q>g7G?KII^BcA`02kKhm00Cfd8C]aec]_SgT/dL2kLML0nBc
A`06kKhmi;=7m]24kLMLm]24kKhm0^g7G007kKhmkLMLdjY7kM2Hon>>kLN4
m]2400;]ah@01ooSS^g7Q?KII^g7Q>g7G=bcG>BcA`02bYPD023:V2W:XCf`
Q2V`N`Z`SC>3GQAkC0Y6;`XA9PXA70XJ2@XA9Q@J2@X92@YZEAjiV5aZIc=6
@AhJ71hA9Q@J4Q@A70Yb>1CT/bWT/akCV0ZiSC?CQ02`NaBVI`1P@AAZ@@X2
4A`:00DJ4Q@A70XJ2@[okLc]fL`01OKoo`05oooob]3FUJ6>kNgZkOKe00?f
ool2oooo00FVXISLhmKLhn3fooGLhmH0HLc<c004IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT06IVIV@0Coogjno[f
o_kloooooOkomocoinkhd=[V/Kg=VJViOi6UMHZONY2UQYneUK35W[[?_=__
_n3aa>Gf00;7j?T00lGVmlCUm/CUmP09a>Gf02g4iOC4iOK4iOC4iOK4iOC4
iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4
iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4
iOK4iOC4iOK4iOC4iOK4iOC4iOK4iOC4iOK4iO@02/CUmP05`^?da>GfaNKg
aNKga>Gf00;2ho@03/?Rm[SBjj>meXnY`8BM/gJ<XG25V8JIZ:Jha;2nbL_E
g^W`n?coookoo`;oo_l00oomo_onoiVIV@27VIVI00?oooo<c<c<c<`0GLc<
c0:=E@X019EE58eE2YEE0:I<00:EE@000jI<09EE09EE0002YVL000>NLPZE
E@2EE@000YEE0005WUhDUED0UED0Pd40UED0009Z@@X02/640;1k2ZIb09ib
2X=107]<2W]107]<2W8V06Y12P9G7002?A`:0R<V2P06?A8:ARl:?A`:ARl:
?A`:H2l:0VY12P9P;`X042<V2TIE:H>4NiFQS/[@e]?SmNgfmFYkKm?SmL[@
e[2c]l77c<77`IF=I[2c]l77`@:VZZ<2YZ6H00>VV6n3Nc<A70X00Q4L2P0:
;1802@T:4A`:6PT:4A`:2@T:4A`:6PT:4A`:;1`D0R<L2P06;2HDH2lDJUDN
UD`YYW9BYXAB0/6QQ0;L/j<04<Zn[Mbn]mbn]nC7`McSe^g]j]bc[NBZV<6Q
Q=bcQ>C7`OK]j_KfmMcSe_K]j_Kfm@;fool01?KomIib<iEbAk1k:@>`Na@0
<9EE0:I<08<h09EE58<_08eE2W]<2W8h57]<2Yib2[1k2[UW0;2=D[2c]oKo
ongIc?oI:DH_2[2ZQ>g]j^gfmOooong]j^g7G=bZ<ng7G?K@Q>g7Q>Bc<ng7
Q>fn?Ng@V>fn?NBcAmbcG>BcAng7G>Bc:Ng7G>BcAnBZ0:K7h<6QQ>g7G>Bc
AoK7?NBcAng7G0;]_Sd02LZQ?OoSS^g7Q?K@Q>g7Q>g@V?KII^g@V?K@Q002
kLN40^g7G00<i;<cdj4YbYPY^Hdc/8dc/8dNWW8:^HdDPg/cJT4:H2lD8a`:
0Q4L2P0?2@T:4A`:0000JVLcWXdYJVLcAT4N8bH:6RHD4BHD4A`:Ea`0bYPD
i;<Ndh@000;:V1@03;V45;1k578h56Y12QXV51XB514V51XB50T92_o]S]bn
[Oooo`Cfool01Oooom?IeYFZ[NC@c>gfm@04m_oo00KooonVXISCfMKLhn3f
oooCfMIQc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@0IVIVI05kooOSmnOKooogoooolooocmooKho2nb]ZT
/lJ;WK=fS:AlUZnF]<bbd^_0h__7j_o3i_[6jo_=l?o@mOoAm?o?m?o?l_o>
looAm?o@mOoAm?o@mOoAm?o@mOoAm?o@mOoAmOo@m_oAmOo@m_oAmOo@m_oA
mOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@
m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oA
mOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@m_oAmOo@mOo@m?o?m?o@loo?
m?o@loo?m?o@loo?m?o?l_o?m?o@loo>loo>lOo;l?l2bnko00k8j?o7iOo5
hofiennM^M5nV:mfSjF2UjZQ//BjamOIhng_m_kko?ono_h2ooom00?ooonI
VIVIVIT0QYVIV@03ooooc<c<c<c<05g<c<`019iN58eE2XeE2YEE00:=E@X4
UED000FNGQB=E@ZEEABVI`2NGQ@00ZIW00BEE@003heE2YEE07]106Y12[2=
7[1b0;1k2ZIb09EE08=107]<2X=107]<2VY12ULL0002H2l:00E6;`Xm70XS
9PXm70Y6;`X00ULL000QARH:LSP0LSPDPd40PcP0Nd`:=2lNLVMBPhf4UJ6>
`LO<g>?PkOKeUJZ]g>?PYZZSYZ6HUHAkSHeBYYQ_UHeBARl:=2lNg>?P`LO1
/;k1`LO1UIQV4A`:4BH:4A`:6PT:8a`:008A70X01AX92Q4L2PTB2Q4L2R`L
50028a`:01<S9PX/9QA69QAP@BV3GS>NNc>VQ8CTZYS1/jg:_ZgL/jgL_[OT
al7L_[OTal7L_[OC_XkL/j?L_[L00ngIc004m^gZkMW<kNgZm^gZ0oKoo`0<
kNgZPg/cWW/c^HdY/7/:/7/DYVL0WUhDWW8:PcP0SED:WUhD0W]<2P0GJT4:
LSPDSED:WW8:/8dN^HdY`H@0YYR4oooob[j]ARl:YZ6HkMW<m_Kem_ookMW<
g;=Li:X0kLMLkLN4kLMLi;<ci;=700;]ae`07Nfn?NBcAnBc7_KII]bcG>Bc
7]bcG>g7G>Bc<jK7h<ZZI^BcAnBc:Ng7G>fn?NBc:Ng7Q?K7?KV45?o]c?KI
I^g@V?KII^g@V>g7Q?o]S^g7Q?KII^g7Q002kLML01gLZS?T/akCV0[:V1C:
XCf`Q2V`N`Z`SC=k@@1kC0Y6@Ah/71@A70X94PXJ4Q@94PX92@Z3GS>EV6J3
Nc=6@AhJ9Q@J4Q@92@XJ2@Y69QCCQ03T/c?T/ah00]>40004^H@DWW8:PehD
H2l:0a4L2P064BHD0000on>>g;>Sm_ookOKe0oKoo`04ooookNgZYZ6Hb]3F
0^gfm@;fool2oooo00F`/kOTd<cLhn3fooGCfMH0HLc<c004IVIVR<2hR<2h
B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT06IVIV@1a
ookhookiooomoooom?OnhNSba<gLX:o2RYbbPYZbR:>nW;_G/]Ga_>?o_NKo
^n?lb_3ocOGod_Oodo_oe?Wodo_oe?Woe?cof?goeooof?goeooof?goeooo
f?goeooof?koeooof?koeooof?koeooof?koeooof?koeooof?koeooof?ko
eooof?koeooof?koeooof?koeooof?koeooof?koeooof?koeooof?koeooo
f?koeooof?koeooof?koeooof?koeooof?koeooof?koeooof?koeooof?ko
eooof?koeooof?koeoooeO_oe?coeO[oe?coeO[oe?coeO[oe?cof?goeOgo
e?Wod_[od_Ood?SodOKod?Go`nOm`nOo`^Co_=ki]MC`X/3LR:?0LXZVS:2h
X[?7`loOh>Wbl_GjnO_joOcho_giooom08RIVIT00oooolc<c<c<c01Mc<c<
00B=E@ZEEAB=E@Z=E@X2UED000n=E@ZEE@2EEAB=E@ZEE@2VI`2NLPZVI`2N
LPZ=E@ZEE@2VI`2EE@2VI`2NGQ@00YEE0004Nd`:JT4:`H@0YW8D0ZIb000C
SED:UED0Nd40Nd`:Pd40Nd40H2l:LSP0ARH:Ea`0?A`:ARl:8bH:Ea`0JT4:
ARl:H2l:Nd`:Nd4000>=E@X064I17VYkKhfHSZJZ[L[@e]?SmOKooiib5:Ib
5:Ib0;UW0:I<060_2W8h58f=Kk24NfYkKngfmL77c;2c]iF=IW]<50TB2Q4L
2P8J2@X24A`:00HJ2@XA70XA70X92@XJ2@X/4P028a`:00P/9QA69QA69QAP
;aAZEAjVLU:`SE;L/jd2g;>S00W1/jgL_[OL_[OL_[OTal7L_[OL/j>`SE:V
V8@00^gIc00Fm_Kem^gZm_Kem_Kem^gZm_Kem_oom^gZ`K>]YXAB/7/Y^H@Y
^FL0^H@D^FL0/7/DYT`0WUhDUEDDWW8:Nd`:LSPD0VY12P04JUDNUEDDWW8D
/7/D0/64000AY/OPkNgZ4A`:/:Z4m_KekOKem_oog;>4kLMLg:Xcg;=LkM2H
kKhmg;=Li;=7i;<Ym]UV00;T/dL00nBc<lZQ?MbcG002i;=703K]_SgT/dOC
ZTOL/ecT/dO:XCgT/akT/dOfacgT/dOfacf`SAkohhk]d9Sfd8C]d9SokLc]
d9Sohhk]ahCffFK]d9S]_Sg]aecT/c?LZS?:V1C:V2ViSBV`Q2VVLQB`SAj3
GQAkC1A6;`XS9PX92A@/4P094PXA70X92@Y6@AjEQ5:3Nc=6EBT/9Q@S9PXJ
4Q@A70X/71B`N`[faak:V1CLZS<3/7/:00YkC1A69Q@/9Q@J4Q@A70XJ4Q@9
2@[]d9SL/hCfool2kOKe0_Koo`06ooookOKeYZZSi=3<kNgZkOKe0oKoo`06
oooo/;>gb]31g>?Fm_Keg>?PHLc<c004IVIVR<2hR<2hB9280@00000000B8
`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT06IVIV@0Cookhoogiookmoooo
ko;if=kZ]l?CU:FiLXRPOYVdUKCAZLk[/]_k]>7o^^So`o7ob?;oc?CncoOo
00;@n?l00logom3hom7io`0he?co2=;jo`04e_kodo_od?SocoOo0/kfo`0C
cOGoc?CodoWod?Go`nSo/]OdZlk^Y/OXVKKHR:;3Ni:aTJ>k]<7Df>3]lOKj
o?kmoOkho_ghooom08RIVIT00oooolc<c<c<c01Mc<c<00R=E@ZNGQB=E@Z3
@@2=E@ZEE@2=E@ZEEA@3UED000BNGQBNLPZNLPZNGQ@2WW8:00>NGQBEE@2E
E@000YEE000;YVL0Pd40JT4:/7/D/7/:/780/8dNWW8:UED0SED:UED000:3
@@00;7]<2W8V04HV2V0_2THV2SdL2R<V2SdL2V0_2THV2ULL07]<2XeE2YEE
09EE5:I<04I17W^=IYFHXk2c]mcSh?Koong]jZIb0;V=5;UW08=106YbG<[@
`McSh<[@eXf=Kiib58=N<h=10;2=7ZIW07]1014L2PTB2PT92Q4L2PT92Q4L
2P892@X34A`:00DS70XJ2@XS9PXm70Xd;bT00V11:@07UD`YWW8c/7]VYXB4
`J64g;>Sb[j]00CL_[L04NC7`NgIc=bcXk24I[24NlZn[NgIc>gfmMcSh>gI
c>g]j_KfmOKoongIc8f=DYF4DYib<`02bYPD00BiQ2W1Q02VI`2`N`X2YVL0
00fNGQB3@@1kC0Y69QAP;aAkC1B3GQBEEABVLQB`SAkCV0YZLUb`/kL00/Zn
[@03kOKem_Kem_oo00;L/e`03nBc<ng7Q>g7G>g7G>Bc<nBcAnBc<ng7Q>g7
G>BcAlZH5>Bc<nBZ0=>40=bcG003i;=700KT/akT/c?T/akfacgT/dOT/bT2
kLML00>iQ1C]d9Sohhh00^g7Q003onf>kLN4on>>00;]ah@04?K@Q>g7Q>g7
G>fn?MbZ<m>Q:LZH:KV=:K24:JIb59j=<h=N57]<2TH_2R<V2QX92P894PX2
2@TD00A69QBVXFJ3Nc=PGS<26RHD00DA70XJ4Q@J4QB`E@3T/ah00/ZH5007
dh@0/7/:/7/DPehDH2lD4BH:;1`D008J4Q@010000=bcG<ZZI^g]jP;]m_D3
m_oo00G]m_F`/kO:d<7Lhn3]m_D00oKoo`06oooo/;k1`LO1g>?Fm_oodmWF
HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=V
IVK<c<bIVIT06IVIV@0Foogeoocfookko_kojNcccmOR[kc=SZ2fPi^eRjS6
V[gMYLc]Y];eYmSi/nGo`O?oao7oc??jcoKmdOSod?OncoKm0]3goPSBnOl`
d_Wn2=3goP0Fdo[odOSocoKmcoKmd?OncoKmc??jbO7k]Mk`^n?l_nOo^N3o
[m?eXLGYTk?JRjO<O9BfRYfkYkK;cMKUj_7gn_ok0_oon003ooomVIVIVIVI
00:IVIT2000019VIV@8000000iVIV@000000000300000YVIV@@00003VIVI
100000FIVIT200000iVIV@800002VIVI0P0000BIVIT6000000BIVIT00000
002IVIT200000YVIV@8000000iVIV@00000000030000?iVIV@03ooooc<c<
c<c<05g<c<`2WUhD00N=E@Z3>02=E@ZVC02=E@ZEE@2NGQ@00XeE2P09YW80
YW8D/780SED:/7/:YT`0YW80WUhDYVL000BEE@001fY12[V=5<640;1k2ZIb
09ib59EE0002Pd4000UkC0Z=E@Yb>01kC0YP;`YZ@@YP;`Y6;`Xm70X00TH_
2P04ARH:ARl:JT4:UEDD0XeE2P0HYVL0AT4NSIR>YZ6H/;k1g>?Pm_ookOKe
YW80`H@0LUEBYZZSkOKeYZ6H/8dc/780UED0LRH0UED0/7/:^Hdc/8dNNd`:
2A8:0Q4L2P072@T:4A`:6PT:4A`:6Q8D4A`:;18000@S70X022<V2THV54HV
56115611:IEN<iEbAk1kIP;1XH@01=bcXmbn]mbc[Mbn]`;Tal407NC@c>gI
c?o]c<6QQ;24Nl6QQ=>nS]bn]nC7`OK]j_KfmOoook2ZQ6Y12W9WD[1k:LZH
5;2=7/640;1k5;1b0;1E08eE2YiN5;1E09iN57]<2V11560_5002H44D01b3
GQBNGQC1Q023GQAkSFK1/jg1al7CfMKfkN[foooooooLZS?]aecT/dO]aecf
d8CT/dOT/bWT/dOT/bWT/dO]aecT/dOLZS?:XCgL/ec:V1CT/ah2kKhm01CT
/bWT/c?T/c?T/ak]aecT/dOT/bWT/dO]_Sg1Q03okLcohhk]ahCohhk]d9Sf
fFK]ahCfd8C]aecfd8@2kLN400k]aec1Q02`Q2W:ZTO:V2V`Q2ViSABNLQB3
GQAkC0Y69Q@S9PXA70XJ4Q@24A`:01/92@XS70ZEV6J=SDMZEAhA9PXJ4Q@A
9Q@J2@X/71BVC03faakTZP3:V1BiSC>iI`2=E@ZNLPYP;`X/71@J9Q@J4Q@A
9Q@0003:XE;:ZVKTd<`00ngfm@?fool01JJc`L[@`NgfmNg]j^gfm@02m_oo
00Koooo1alc1/jgLhmK]kN[Lhn1Qc<c<00AVIVJ8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0IVIVI0_onn`0Aooomn?Wk
g^?Y`L_EWZo1OI:]PifnQ:C;SK;LW<K`ZMGl[]co/N;o]^Go_NKha>[gbNkn
00;;lOh00lW_o<S^nlS^n`07b>kk<LS^n@S8k_/06LW_o<S^nlS^nl[`oL_a
o/W_o<CZmkoVmlK^okSOo:gFm:kGmj_Cmig3jXb_fHBTcH2La8JL`IZ[akc9
g=gVko;fmOcmmOoom_oon`04VIVI0P0000>IVIT2000000>IVIT000000000
0YVIV@8000000iVIV@0000000002VIVI0P000003VIVI0000000000:IVIT2
000019VIV@800003VIVI0P000003VIVI0000000000FIVIT200001IVIV@80
00000iVIV@0000000002VIVI0P000003VIVI0000000004:IVIT00oooolc<
c<c<c01Mc<c<00NNGQBVI`1kC1B3@@2=E@ZNLPZ3>0000iEE0006YVL0YW8D
YVL0/780/7/:WW8:1:IW000?WW8:YVL0UED0UED0JT4:bYPD^H@D/8dNYW8D
YW80YVL0UED0YW80Pd40UED000:3@@02H2l:00Eb>00m70Xd;ahm70Y69PX0
0TH_2P9kC0X0:JIb08eE2ZIW03@_7VYbG:JQV:JZ[McSh>g]j]cSh<6406Y1
2]?SmL[@`JIb09EE0:Ib0;1b0:Ib09ib2YEE0;V=5;24:LZH:IEE00TB2R`B
014L2PT951X92Q4L2PT92PTB2QX92R<L2R<V2Q4L2R<L2R<V2QXV54HV5002
H2lD00NEC2VEGS>ELTO1XHBVQ8CL/j?1XH@00mbc[@04g;jgi=3<kMW<kMW<
0_K]jP04ong<i<O1i<O1kMW<0oKoo`0Bm^gZJVLcJUDNUEDDbZYV^HdD/7/D
bYPD/780/7/:YW8DYVL0UED0WUhDSED:Nd`DLSPD=2lN0THV5008LSPDWUhD
^H@D6Q8D`K>>b[j]i=3<g>?F0_ooo`0D`K>]i;=7g;=LkLMLg;=Li;j4kLN4
i;<ci;=7i;<Yi;=7kKhmkLMLi:X0bZ4mg;=Lm]24bYPDg;=Li;=70nBc<`03
i;<YbZ4mi;<Y00?T/c<02[V=<ooSS^g@V>g7G>g7Q?oSS^g@V?KII^g7Q>g7
G0;]ah@0;>g7G>fn?K2=7[1E0<640;2=7[24:K2=7ZIb08=N<fY12V0_2R<V
2Q4L2QX92PT92Q4L2PT92R`B0:JHKg:=?FYE7R<V2QXV51X92Q4V2QXB58<_
0>Bc:LZH5=>40<ZH5;V45:IW08=N560_2QXV52<L2Q4L2QXB50000;VHG>g7
Q=cSeP?]m_D2m_oo00GfooF`_/71/jgLhn3]kNX00_Koo`;oool01M?IeZJZ
XnC@c>gfmM?IeP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^0C<c<`00fIVI/c<c9VIV@0IVIVI0_ono`0Fo?kmmogmen7S_L_DTZNl
KHNXN9S7OZ?JR[;]U[ogW/KgYloc/=Sb]]kg^n3m^]kn^]ko_>3o`>Co`NGo
`>Co_N7o@<;Wo`?3j?l05/;Wol7VokoTokkSokgQokWLokOJojoEnZK>lYg7
kIK0j8Zcgh>WegVIbVV5]96Wd;?4h]OPlOGjoOkon?kolooon`BIVIT20000
0iVIV@8000000iVIV@0000000002VIVI0P000003VIVI0000000000FIVIT2
000029VIV@L000000iVIV@0000000005VIVI0P0000FIVIT2000000>IVIT0
000000000YVIV@800002VIVI0P00046IVIT00oooolc<c<c<c01Mc<c<00b=
E@ZNLPZEE@23>023@@2=E@ZEE@2=E@ZEE@2NGQBVLP2NLQ@4WW8:00B`LP2V
LP2VLP2VLP03YVL000J=E@YZ@@[:V2V`SAk:V1BiSA@2YW8000B3@@2VI`2E
E@2VI`02Pd4001Qb>01P;aAP;`Y69PYG7016;`XS9PXm70XS70YZ@@YkC0ZE
EABNLQB`Na@A70YbSCfEZZf`_/7Lhn3foooLhmIb>02Van3:ZTL2`H@000>`
LP2`N`Z`N`X00[1k2P07UED0/7/:^HdDbZ4mYW8D4A`:8a`:00<A70X01PT9
2Q4L2Q4L2R<L2Q4L2TH_2P8S70X02B<V2R`V54HV54H_2V11:H=N<iEN<iib
<k24IP02`J640]bcX`07b[j]g;jgi<O1kMW<i<O1kMW<m^gZ00;]m_D0:mcS
h?K]j_KfmOKfmNgfmOK]j/Zn[F11560_5;2=D_KoonC7`KVHG<ZH58eE2[1k
2X=N5:I<07]<58=108eE2W]<54I17R`V54HV52`V560_578h52<_7V115;2Z
Q;2c]mcSh>g]j_Kooooooiib2^g7G>g7Q>BcAnBnQ?KII^g7G002i;=700WT
/bW]aecT/dO]aecCXBW:XCgCXBWfd8CL/e`00^BcA`0:i;<ci:X0i;<ci:X0
i;<Ni;<ckKhmi;<Ni;=7diP:0^g@V008m]24kLN4kM2HkLN4m]24kLN4i;=7
kLN40^g7G00Ng:Xc`H@0YW80SED:UED0WW8D/8dcWW8DPehDNd`:ARHD;2HD
2@T:6Q8D4A`:2@T:6PT:8a`:WXAVUG97H5hc;2HD6RHD2A8:6PT:6Q8DLRH0
i;<ci;<Y^Hdc0[1k2P0;YVL0PehDH2l:;2HD6Q8D2@TD6Q8D2@T:/7/YkLN4
g;jg00C]m_D01_Kooooool[@e[2c]mcSe^g]jP?fool01_ooom?Ie/6c[L[@
`OK]j]cSh67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
1<c<c003IVIVc<c<VIVI01VIVIT0LOkmookooo[nooGmom?Nh[_=fGjF/6V9
[g>Hc7VSghB`khjkmYO1lj36kJ[>j:oCkK?Gnk3FoK;EoK?IokWLokWOok_N
okOMok[NokSNok[NokSNok[NokSOok[NokSOok[No[SOo[[No[SOo[[No[SO
o[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[N
o[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SO
o[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOo[[No[SOok[NokSNok[N
okSNok[NokSNok[NokSNokWMokOMok[NokSNokWMokKLokOKokKIok?Dok3B
ojW>n9k8kYO3jXnliHB`gg^Ueg:Gc6N7^X2Ha[?6imCOlo?ko_kon?cnlOoo
n`04VIVI0P0000:IVIT200000iVIV@80000019VIV@00000009VIV@800005
VIVI1P0000FIVIT2000000>IVIT0000000000YVIV@800005VIVI0P0000FI
VIT2000000>IVIT0000000000YVIV@800002VIVI0P00046IVIT00oooolc<
c<c<c01Mc<c<00BNLPZEE@2=E@Yk@@03UED000Z=E@ZEE@2VI`2`N`ZVLQBV
I`2`NaBVLP2`N`Z`LP02YW8000RVI`2`N`ZEE@2EE@2NLPYZEAk:V1BiQ1@2
/8dN00B`N`ZVLP2VLP2NLPX4UED000UkC0Yb9P169PYP;`Y69PXm70XS9PX/
9Q@S70X00VY12P0<SED:UEDD/7/:ARHDUJZ]YZZS`LO1i=3<m_ooYZZSCfM7
m_oo0/64000?/8dN^H@D/780`H@0/7/:/780UEDD^H@D/780bYPY`H@02A8:
4BH:8a`:2@T:00894PX01Q4L2PT952<L2R<L2R`V514L2P<S70X014HV560_
56YE7W]<50:ELTL01k24I/6QQ<6QQ=bc[Mbn]mbcXmbn]`02i<O100O]fLcf
kN[]kN[fkN[fm_GfkN[fm_D00_Koo`0Jm^gZkMW<UHeBH44DWW8DbZYVb]31
m_oooooog>?P`J64/8@YEa`0?A`:ARl:H2l:LSPDH2l:?A`:4BHD2A`N4BHN
;1`D4A`:WW8DYZ6H0/6c[@0:g>?FkOKem_oog>?P/7/:m]24i;j4i;=7kLML
kM2H0^BcA`05i;<cbZ4mm]UVi;=7kLML00;:V1@03kUW0>BcAooSS]bcG>Bc
AnBc:LZH5>BZ0<ZQ?NBc:OK7?NBcAnBc<oK7?LZH5002kM2H0^g7Q003kM2H
kLN4kLN400C]ae`06MbcG=bZ<kV=578h58<h08=N59EE5;2=7Yib2X=N56Y1
2TH_2S@_7PTB2QXB514L2PT92Q4L2PT92Xf=Ah=k<fYE7Q4V2QXV50TB2P02
4A`:01=G703f/`3T/akCQ03:V1B`E@2`N`ZVC01Z@@X/9Q@S9PXJ4Q@A9Q@9
2@YkC1CohhjVXIS]m_G]kNX00ngfm@05m_oo`LO<YZ6Hg>?Fg>?P00?fool0
1_ooong]jYFQS/77c?K]j/[@eV7<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01VIVIT0LOonnOoono_oo_Gl
oloKjKc>iV9lWFZ;]VbFb76PeWb]iHNfjXnkjYNnij73iZG8j:K=kZG=l:K<
l:O?lZcCm:kGmk3Gn:oHn:oFmJkGmJoFmJkGmJoFljkGljoFljkGljoFljkG
ljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoF
ljkGljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoFljkG
ljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoFljkGljoF
ljkGljoFmJkGmJoFmJkGmJoFmJkGmJoFmJkGmJkEm:gFm:kEm:cEljcClZ[C
lJW@kjS>lZO:m:K8mJ35kiK0j8nliHRghgf]gGBReV^DbVF9_FF2[[K:jm;O
l_?ko_kon?_kkooon`04VIVI1P0000BIVIT4000000>IVIT0000000001IVI
V@800002VIVI0P0000FIVIT2000000>IVIT0000000000YVIV@800005VIVI
0P0000FIVIT2000000>IVIT0000000000YVIV@800003VIVI0P00042IVIT0
0oooolc<c<c<c01Mc<c<0Yib2PF=E@X019EE09ib2YEE09ib2P:VLQ@2WW8:
0ZIb500OYW80YW8DYW80YVL0WW8:YW80SED:JT4:i;=7^HdD^HdY^HdD/7/D
/7/:YVL0/7/:SED:YW80UED0YVL0Pd40JT4:H2l:Nd`:H2l:ARl:8bH:8a`:
4BH:ARHDARl:00:3GQ@069iN54I17X>4NjJZXl77`NgfmOKoof1N<h>4NoKf
mL640;V=5;2=7[V=5;1k5;1k2[V=5;1b09EE0;1k5:Ib5;V=5=>H2QXB50<A
70X00`T92QXB50TB2P026Q8D00H/71@J9Q@A70XJ2@X/71@J4Q@2ARHD00IP
;aB3GS>3GS>VLU:VV6nVQ8@2`J6400CTZYSL_[OL_[OTal42kMW<0oK]jP?f
m_D03?KoooKomL[@`LZn[H=N<iEN<k1k:JJQIYj=<jJHQ;2c]oKoo`;oool0
7nC@c:JHKiF=IZJHKiik<h=k<fYW<fY12VYE7X=N58=k<jJHKkVZKl77`L[@
`Mbn]ng]j_KoongIc>g7G;2=7^g7Q>g7G>fn?NBnQ>g7Q>g7G>Bc<ng7G>Bc
Ang@V002kLML00OT/bViQ1B`NaB`N`[LZS?]_Sg:ZVH00nBc:@03i;<cbZ5B
kLML00;T/bT01ng7G<ZH5>g7Q>g@V=bcG>g7Q>g7G003kLN400gL/ec]aec]
_SgT/dOCXBW:V1B3;`2NGQB3@@2NLQBNLS>NLQB3GQ@00VY12P0A;2HD8a`:
2A`D2A8:2A`D6PT:0000SHe7Pg/cH5hc=2lN6RHD6Q8D4BHD6PT:?A8:i;<Y
00;:V1@03kV45;1k2Yib2W]<560_52`V52<L2PT9514L2PT92W9ED_K@Q:JH
Q?Koong]jP02kOKe0_Koo`0=dn?eUJ6>g>?Pg>?Pm_oedn?ekOKeoooom_oo
YZ6Hb]31kMW<dmWF067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c003IVIVc<c<VIVI01VIVIT04Oonkooom?kooOOkom7Ll[g@
l4UTSfB8^6:@`VRLcWFYfGjbhHNfhY2ji9^niZ73jIk4j002WLGX00FOanZR
bn^TcNfVcnnWd?001:K?kCBVcn/8Y/o]0ZO@kP0GY/o]Y<g[X/_YX<WWW/OU
W/GVWl;ZW/3]VKkZSk[TR;OSP;?RMZ[LKIoDHi39H8RlC6^I]lk`d]obmO[n
oooho?c`oook00BIVIT200000iVIV@8000000iVIV@0009VIV@02VIVI0P00
0003VIVI0000000000:IVIT2000000>IVIT0000000000YVIV@800005VIVI
0P000003VIVI0000000000:IVIT200001IVIV@800005VIVI0P000005VIVI
000000000000VIVI00800004VIVI0P0003nIVIT00oooolc<c<c<c01Mc<c<
0YiN50>=E@X02jI<09EE09iN59iN59ib59ib2ZIW09ib2[1k2ZIW09ib2P02
/78000bVLQB`LP2NLPZVLP2VI`2NLPYZ@@[LZS?:XCg:V2WCV0Z`SAh2/7/:
00FVLP2NLPZ`LP2=E@ZVLP000W]1000NNd`:JT4:LSPDARl:?A`:8bH:8a`:
;1`D6RHDJT4:H44DPehD8bH:JW9LUIRSb]3FkNgZPhB>/;>gkNgZg>?F`H@0
g:Xc`H@0/8dN^HdD/7/:^H@D/7/:SED:0Yib2P04LSPDbYPDARH:2A8:114L
2P0A2A8:2@T:4A`:ARl:;1`D4A`:8a`:;1`D;180=2lNAT4NH44YLSPDUG97
YW9B/8AV/8Ak00?1XH@00mbc[Mbn]nC@c002kMW<1OK]jP;]kNX05^C@c<6Q
Q;VZKh=k<iik<jJ4D/ZQ?FYW<h=N56Y12THV561bNg:=[M?SmL[@e/77c?K]
j^g]j]cSe]bn]mcSe]c7X`C:d<403l6c[McSe]cSh?ooongfmM>ZAng7G;V4
5?K@Q=bcG>BnQ>g7G>g7Q>g7G>BcA`02kLN400K]d9ST_XC]ahC]aebVI`2V
C002/5D000>iI`3T/c?T/c<01nBc<`06i;=7i;<Ni;j4m]UVkLN4kLML0^g7
Q00;kLMLkLN4i;=7kKhmi;=7kKhm`H@0PehDUEDDYW8D^H@D00:`SAh07iib
58=N561154H_2R<V2PTB2R<L2PTB2QXB50T950TB2X=N<h=k<fYE7TI17R<L
2PTL51XB52`L51XB5?nc0<ZH5=>40;UW0;V45:I<08eE2V0_52`V52<L2Q4V
50024A`:00@J2@[]aeb`Q6Kfool2kNgZ1>gfm@03YYR4`LO<g>?P00;]m_D0
1oKoooooooooohf=Kmbn]mcSe]?IeP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0IVIVI01SoonOoonoo
oo_ho?oHhOk0dodkFXUHP;AJS;mPV<M]Y]=h[]Z1/]f:]N:F^>JJ_>VG_^NF
`>JG`NNH`^RIa>NJaNRLanZMb>/4W<OY19c7icRLanT3WLSZ01JLanVKa^RI
a>JH`nFI`NFJ^nBI^^NB^NB9]>60/n9i[^1^YMeWVmEJRlEGP;HmGHbjdO?E
h_Gen_koooSooo?ooo/4VIVI0P0000>IVIT200000YVIV@@00003VIVI1000
00>IVIT400001YVIV@80000019VIV@00000009VIV@@00004VIVI0P0000FI
VIT2000000BIVIT00000002IVIT200000YVIV@D0000oVIVI00?oooo<c<c<
c<`0GLc<c005YVL0WUhDPd40SED:PcP000:=E@X2WUhD00RVI`2VLQB`NbVN
LQB`N`ZNGQBNLPZ`LP02WW8:00b`LP2NLPZ`LP2NLPZNGQAZ@@[L/ecCZTO:
XCg:V2ViSBV`LP02/7/:0jIb0005/7/:UED0UED0SED:Pd40009kC0X01TH_
2R`V514L2R<V2R`L51XV50969Q@03DH_2W:=?IFHXk2c]k2n`McSe^g]j]?S
mNgfmK1b0;2=7[V=5;2=7P02/7/:00FES@2`N`Z=E@ZNLPZVI`000[V=500M
WW8D4A`:2A8:4A`:6PT:2A8:4A`:6PT:2A8:8bH:8a`:;1`D4A`:8bH:;2HD
ARHDAT4NH2lDPehcWW8cUEhcWXAVYYR4`J64^JY_g;>Sg;>]g;jgi<O100;]
fL`01?K]j_KfmOK]j_Kfm@;fkNX01^C@c=>nS[VZKk2=D[VHG>BZV0;1/hh0
0l6QQ;2=D[2ZQ002dkj>00jiZVn3GQ@0002`/kO]m_GLhmK]kN[:d=K]kN[L
hmKTd<cLhn3LhmKCfMH2g>?F00WLhn3fm_GL/ecT/c?]aebiSACfd8C]aecT
/dL00^g7Q0;]ae`03>fn?Ng7Q>g@V>g7Q>g@V=bcG9EE08<_0:I<09iN5:I1
0<ZH50;T/dL2i;<c1>Bc:@04i;<Ng:XcdjY7kM2H0^g7Q00:kLMLkM2HkLML
kLN4i;=7kLMLg;=Li;=7bYPD^FL00[1k5003bZ4m/8dcYW8D00:NLQ@097]<
560_52<V2QXB51X92PTB2PT950TB2P0006YW<h=N<fYE7TI17R<_7Q4V51XB
52<L2QX92_K77[V=<m>40;V45;1k2YiN58=N56Y12R`V52`L514L2QX92QXB
51X92_KIIZIbD_KoomcSh0?]m_D00oKoongfmHfHSP02g>?F00Wfm_Gfooof
ooofoooooon=V8k1al7LhmKCfMH0HLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT06IVIV@0CoooVooo/oook
n_cohncoaMSo?UjAB7>XE8RjFI?3Hj3<KZWCMj[GP:cKRZkPTK?STKKST[WT
U;[W00:E_>L01YFliIJmj9NniiFliIFlhiFli@:E_><019FmhIFlhiFlhiFl
hc2E_>D03iFlhiFliIFlhiFliIFlhiFliIFlhiFliIJmi9NniiNniIRoj9Nn
iINniiRmi`02T[?N00n:/=f0[=]gZMY_Y]aUWMILT/i?PKa:MJ`lGX^oeoWN
jocfnoooooSoooCooo/019VIV@800003VIVI0P0001^IVIT300000iVIV@80
0005VIVI0P0005>IVIT00oooolc<c<c<c01Mc<c<00VNLPZNNc>3@@2NLPZ3
>02=E@ZEE@2VLP2NGQ@00Yib2P07YVL0WUhD/7/:WW8:YVL0WW8:/78000:`
N`X01ZIb09ib2ZIb0:Ib56YE7]bZ<`;CZTL00lZH:KV=:KV=5003/7/:0jIb
00>EE@02SED:00BNLPYP;aA69PXA70X26PT:0Q4L2P0=6RHD4A`:LVMBUJ6>
YZZ]`LO1dn?eg>?Fg>?Pm_ooYW8D/7/:YW8D00:NLQ@02[1k2YEE0:Ib08eE
2YEE09ib2X=N58eE2VY12THV50<A70X00aX92Q4L2Q4L2P024A`:00PS9PXA
70XS9PX/71A6;`Y6@Aj3GS=P;`X2Pehc00BEQ5:`NfJNQ6J`Q7/2`J6400GL
/jgL_[OTal7Tal7]fL`00_K]jP04m_Kem^gZg>?Fi<O10/6cSP03^IQLYYQ_
bZYV00:iZVl01=bn[NC@c<[@`Ng]jP;Lhn001=cSe^C@c8=k<jJQV0;Td<`0
5>g]j]?Ie^g]j]cSh=?Ie]cSe]cSh>g]j]?Ie^g]j^gfmLZQD^fn?NBc<nBc
AkV=5>g@V=bcG>fn?Ng@V0;]ah@01nBcAmbcXng7G>g7G=bcG>g7Q<ZH5002
Pbl000B`C03CQ02`N`ZEE@02g:Xc00GTZP3T/dOT/c?T/c?T/dL00^Bc:@03
g:XcbZ5BkLN400;]ah@01>BnQ>g@V>fn?Ng7G0;T/dL02>g7G>BcAnBZ0=>Q
:L640;1k5<ZQ?K2=7P>NLQ@0161154H_2S@_7PT92P8A70X26Q8D01d0001Z
Ic>3Nc=ZIc=6@AhS;ah94PX971@S70X92ACT/akCQ02`N`ZiQ1B`N`Z`E@1k
C1Ab>1@/71@S9PXA9Q@A70X/71@92@[ohhBVLU;foooChoGLhn000^gfm@05
m_ookOKePhB>`LO<g>?F00;]m_D2m_oo00Gooon3Q7_1/jgTd<cCfMH0HLc<
c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<
c<bIVIT06IVIV@0KoooXoog]ooojn_gok_Sob=_oBFVH>fJIAgb`BhNkF9C6
Hig=KJ3?Mj?BPJGGR:WLRJ[MRjoQSk?WT[KXTKGWTKGUTKGWT[KVTKGUTKKS
TKGU00:A]^<00i6fhY6fhi6fh`0aTKGU022A]^>A]NFA]^>A]NFA]^>A]NFA
]^>@]>B@]N:A]NFA]^>A]NF@]N:?/n>A/n6:ZmJ9Z]F0Y]=dXm5/WmATVm=G
T/a?QlA3Mk4jJ9a4Ii78hOoZmoojoOoooo[oooKooo/4VIVI1P0001bIVIT3
000019VIV@030000VIVIVIVI00>IVIT200001IVIV@80001<VIVI00?oooo<
c<c<c<`0GLc<c00>WW8:YW8DSED:Pbl0SED:UED0SED:WUhDYVL0YW80YW8D
/7/DYW80/7/:0ZIb5006YW80/7/:/7/:/780WW8:/7800Yib2P0;JT4:g;=L
djY7bZ5BbZY7^HdY/8@Y^H@D/7/:/780/7/:00:`LP001Yib2YEE09iN58eE
2Yib59EE509b>1@012<L2Q4L2R<L2Q4L2P8J4Q@03@T92V1N<jJQV:JZXk2n
`M?Ie]?SmL[@`NgfmM?SmIF=IYj=:G8h0002PehD019P;`YkC0YP;`YZ@@YG
701Z@@Z3SHCLhn2`ZX@0000A9PXJ2@XA70XJ2@XA70X971@94PY6;`X24A`:
00DS70Xd;aib>1AbSCfELTL00X=N<`0:WW8cYXAB/8AV/8Ak`J64i:ZHb[j]
i<O1g;jgi<O10^gIc0;fkNX00mcSe^gIc=c7X`02`J6400V=SFo1XHBVV6oL
/j?L_[O:d<7ChoGLhn3]kNX00mcSeP0;dmWFi=3<YZ6Hb]31`K>]kOKeg>?P
kNgZg>?PkNgZg>?P00;:d<404>gfmNg@V<ZZI^Bc7]bcG>fn?NBcAm>Q:NBn
Q>g7G=bcG>g7G>BnQ>g7G>BcAng7G0?T/dL02M>ZAm>Q:JI<09iN58<_0;1E
0;1k2[1<0=>Q:@02i;<c0^Bc:@03i;<NbZ4mg:Xc00;T/bT01[V=<oK@Q>g@
V>g7Q>g7G>g@V0;]ae`04=bcG>g7G=bcG>g7G>Bc:M>Q:LZH5;V45<ZH:K1k
:Iib59ib2X=N57]<2TH_2THV508J2@X080T92QXB50T92PT954I17Xf=AdIE
:C@_7R<_7Q4L2PT9514L2PT95=>40=bZ<m>40;V45;1E0;1k:H=107]<2R`L
52<L2QX92Q4V51XB50000>g7G;V=<ngfmMcSh>g]jP?]m_D01?KoohfHS/[@
`L[@`@;]m_D2m_oo00GooonEXHj`/kOLhmKCfMH0HLc<c004IVIVR<2hR<2h
B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT06IVIV@0F
ook_oo_`ooojoOkomOoob]olDW>L<Uj=>fjS@WZcCXW1FiC;IYS;LIg<OJ?@
QJOEPZ;CR:SKSZkQTK7TTK7RT;3Q0Y6ahPBB/^43T[?P00>B/^6B/^>B/^<0
;Y:bh`ZB/^405i6ah8n_gXf]g8^[fXRXehNXeH>Tch6TcWNPc6bJbfBGcU^B
be28aDIn^Ca_Z3=OT4a^U<oWooCooocooookmoonn?ooo@28VIVI00?oooo<
c<c<c<`0GLc<c003WW8:WUhDSED:00:=E@X01H=10:I<08eE2YEE09iN5002
WW8:00BNGQB`LP2VI`2`N`X2/78000RVLP2`N`Z`LP2NGQB`N`ZNGQAZ@@[L
/e`3bZY700G:V2V`LP2iSAB`LP2VLP000k1b0004YVL0WW8:/7/:WW8:0YiN
5004Nd`:SED:H2l:8a`:0Q4L2P0M4BHD2A8:2@T:4A`:UJZ]LW9k/;k1g>?P
b]3FkNgZb]31m_oo/;>gkNgZSHe_Pg]LJUDNARHDJVLcSHeBYXB4YYR4b]31
/;>gAUDYJT4:;2HD4A`:2A8:008A70X05AX92QXB51XB53@_7Q4L2QX92Q4V
2PTB2QXB5611:FYE7YF4DYEbAij4IYF4DYj4IZJ4Q<6QQ=bcXmbn[LZn[@02
g;jg00oTal7]fLcLhmKTal7L_ZgTal6iZVn`SE:VV6n`SC>`SE;C_Xk:_ZgL
hmK:_Zd00^C@c00Cg>?PdmWFb]31`LO<dmWFkNgZ`K>]/;k1b]31kNgZdmWF
kNgZdmWFg>?Pb]31dmWFg;>4djY7i;<c00;T/bT02nBc<nBc:MbZ<lZZAnBc
AmbcG>Bc<ng7Q>BcAng7G<ZQ?@04i;<c01GLZS>iQ1B3;`1P;aB3;`2V@@2`
C02NGQCCQ03T/dO:XCgT/bWLZS?T/c?T/dOT/c?LZS?T/bViQ2W]aec]ah@0
0^g7G007kM2Hg;=Lm]UVi;=7kKhmkLMLg;=L00;LZS<01LZH5<640<ZH:Ij=
<k1k2P02SED:00AkC1A6;`X/9Q@94PX24A`:00P92@XA70X00016@AibSCeZ
EAi6C3dA9Q@26Q8D00DS70XA9QkCQ03CQ02iI`000[1k2P0?YT`0Nd`DNd`D
8bH:;1`D;2HD6Q8D4BHD0000bZYV^Hdcdn?eg>?Fg>?Pdn?e00;]m_D01ooo
ohfHS/77`NC@c>g]j^gfmOKoo`02oooo00BEXHjVZZ?Td<cCfMIQc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VI
V@0IVIVI01?oo?Son??oo__in_ceoooQm_moW[/XDWXmK:8[HIdmM;AOUM=Y
V]9lZ=N8[mJC]M^D/mnK]nJM^^H00Ybii@03W[_WWkcVW[_U00:N^nD6W[_S
00>N^nFN^nNN^nL0;9jki`03W[_UW[_SW[_S00JN^n<01IfjhZ6niZ6niYjk
hifjhP02W[_S01:J^^6>[mRM`^aiX]1iYMIcY=a;OkU1Mk<dJ:4PCh<eGhU^
Sk3]ooogoooal_Koo__lm?7ooof8VIVI00?oooo<c<c<c<`0GLc<c006WW8:
WUhDSED:UED0Pd40SED:0iEE0007YVL0YW8DWW8:YVL0/8dNWW8:/7/D00>`
N`X01k1b0;1k5:Ib0;1k2Yib2VY12_KIIP02bZY700K:XCg:ZTNiSABiSABi
Q1B`N`X2/78000fiSAB`LP2VLP2`LP2VLQB`SAjNNc>EE@2=E@YkC0Z3;`16
9PXA70X00QXB500@4BHD0000SHe_YZZ]`LO1/;>gdmWFb]31dmWFb]3FJW]_
m_oei=3<g>?Pi=3<b]3F0/77`@08kNgZ`K>]UHeVPehcYZ5V`K>>WW8D2A8:
0Q4V2P892@X03A4L2QXB52<L2Q4L2QX92PT950T92QX92R`V54I17Yik<ij4
IYEbA`02YW9B02^`Q6K1XHCL_[O:_ZgL/jg:_ZgL_ZgL_[O]fLcTal7L/j?1
XHC]fLbVV6nESE:NQ6JiZVo1XHCCfMK1al7Tal71alc:d<71alcLhmK:d<71
alb`/kO1alcLhmK:d<6VZZg1al71alc:d=J`/kOL/j?C_XkT_XCT/dOT/c?L
ZS?L/e`00^BcA`08g;=Li;=7i;=7g:Xcg;=Li;j4i;<Ng;=L0]bZ<`05bYPD
g:XcbYPDdj4YdiP:00;:V1@02G8h58<_0;1<0:I108<_0;V45<ZH5=>ZAmbc
G002i;<c00gCZTOT/dOCZTOT/c?CZTNNGQCffFK]ahCL/ec]aec]d9S]aec]
ah@00^BcA`09kLMLi;=7g:Xci;<YdiP:`H@0bYPD/8@YWW8:00:=E@X00g]<
2THV2TH_2P026PT:00T94PXA70X92@X92@X/71B3Nc=ZEAhd;ahS9PX00QXB
50036PT:0000WUhD00;:V1@02k1k2ZI<09EE57]<560_52<V2R`L51XV50T9
51XB50000002bZ5B0]cSh00:dn?ekNgZkOKekOKeooooSIR>`LO1b]31g>?P
kOKe0_Koo`05ooooUIRSYZ6Hi=3<g>?P067<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01VIVIT04oognool
oOonnooooOKooo7oojG0db=7JB5:OR9BT45b]Den`7JUgI>njig3iiRkfjO5
jJg9k[3=k`02[/_]00>`cNn`cNf_c>`00[;?k`Jbcnd00k;?kk;?lK;?l@05
//oa6:o<kPnbco400k;?kk;?kK;?k@06//o]01V^bnVac^bac^b^bnV]b^R_
c>Z^bnVZb>ZYbo6G_>JG`>jH`oIQT<Q2Lje9N[8QD8@cGX/TB6b^bNCVnOoe
o_onooommoOooO_oood0R9VIV@03ooooc<c<c<c<05g<c<`019ib59iN58=1
09iN50:3@@002HeE2YEE08eE2YiN5:Ib5:IW0:Ib5;1b0:Ib0002/7/:01>N
LPZ`N`Z`N`ZEE@2`N`ZVLP2`LP1Z@@[T/dO:XE;CZTOLZS?:XCf`SAjiSABi
SBViSABiI`2iQ1@00k1b000</7/:/7/D/7/D/8@YUEDDWW8:UED0Nd`DPd40
ARHD4A`:4BHD0QX92P0J4BHDSIR>YZZSb]31`LO1/;k1kNgZJW]_`K>]g>?P
`LO<g>?F`LO<b]31`K>]`LO1b[j]`K>]`LO1g;jg/;>g`K>]YZZSNd`:0000
2A`D0Q4L2P046PT:4A`:4A`:6PT:114L2P0=6Q8D;1`DAT4NPehcPg/cJUDN
PehcUHABYW9B`K>>`K>]g;>Sg;>]00?L_[L03M>nS[VHG;VZKmbn[IF4DYEb
Aiik<l6QQ=>nS/Zn[L6c[L77`L[@`@02`K>]0/77c009b[j]`J64UHAk`K>]
YYR4`K>>dkj>`J64bZYV00GL/e`2i;=7023]aecT/dOL/ec]aecT/c?T/dO:
V1C:XE;T/dOLZS?T_XCT/dOT/c?CXBW:V1CCQ031Q03CQ031Q03LZS=G701b
9P1P;`YP;aAb>1B`E@3T/c?L/ecT/dO:XCgCXBWT/bT3i;<c00c:V1BVI`3]
ahCL/ec]ahCT/dO]ahCL/ec]ahC]_SgT/dOT_X@2i;=700?LZS?:V1C:V1@0
0[V=:@0AWW8cNd`:SED:PehDAT4N;2HD6PT:4A`:6PT:6Q8D4A`:6Q8D;2HD
UHABH5hc=2lN8bH:008A70X26Q8D01BVI`3:V1CCQ02iQ1BNGQBEEAAkC1A6
9Q@/9Q@/71@J4Q@A70XA9Q@971j`SC?L/ecLhmKChoGLhn3]kNX2kOKe00Kf
ooFEZZfVXISTd<cLhn3]m_D2m_oo00GooonVZZ>VZZ?Td<cCfMH0HLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bI
VIT06IVIV@0Eoo_ooocooockooojlo[bmOooi?[oL8jX:4Yh8TZ5:UJGDGfl
Q:oVVlC`V/7RZloY[<[T/loW]];X]=3V/loU00:edNL00k??iKGAi[GAiP06
]M;T2;GAiQRdd>D@]M7V2;GBi00I]=7S]]?U]]?U]=7S/m3R]=7S/m3R[LgT
ZlocX<ObU;g[Ul7cQK3WBgJ]8T]o8DYh7D1VJXVVi?[om?ool?Ooookooogo
no;cooko08RIVIT00oooolc<c<c<c01Mc<c<00f`N`ZNGQB=E@Z=E@ZEEABE
E@2=E@ZVC02EE@2VI`2NLPZ`N`ZVI`000[1k2P03/780/7/:YW8000>`N`X0
1ZIb0;1k2ZIb060_2^g7G=>ZA`;:XE801<ZH5;V=:KV=5;1b00>iQ1@04KV=
5;UW0;1k2[1k2[V45;1k5;V=5:IW09ib2YiN59ib2ZI<08eE2X<_02<V2Q4L
2Q4V50022A8:00OCfMK1al6=V8kCfMK1alaZLUc:_Zd00/[@eP07g>?F`LO1
`LO<`K>]`LO<b]31g>?F00;:d<405=?Ie/6cSZJHKk2ZQ8=k<`00014V2PT9
2Q4L2QX92Q4L2R<L2Q4L2PTB2QX92Q4L2Q4V2QX92R<L2TIE:@:3GS<2UG97
01MZIc>NNc>`SE:VV6o1XHC1/jg1/hj`ZXBNQ6JiV5cC_XjiZVnNQ6JELTN`
SC?T_XCL/hCLaj>iZVo:XE;L/ecT/dOL/e`00/ZH5006diP:bYPDbYPDdh@0
i;<cg;=L0nBcA`05g;=Lg<NSg;=Li;=7kLML00?L/e`00m>ZAmbcG=bcG002
i;=700_L/ebiSC?T/dOCZTOT/c?CZTOT/c?CXBWCQ03:V1C1Q0000]>40008
^H@DLSPDARHDARHDH2l:H2lDYT`0i;=70]bcG004djY7dj4Ydj4YbYPD0m>Q
:@03/7/DkLMLkLML00;L/e`02>g7Q=bcG>g7G=>ZAnBcAmbcG>BcAmbZ<`;C
XBT03;V45;V4:K2=7Yib57]<2XeE2W]<2TH_2R<V2QX92Q4L2QXB50892@X0
4QXB52<L2W:=G6YE7S@_7R<_7Q4L2QXB514L2QX92W8h5=>40;V45;V=5:I<
0:IW07]<2V0_508S9PX36Q8D00L0002NLS?L/ec1alc]m_GLhmKChoD00^gf
m@0=m_oo/;>gYZZ]b]31g>?PkOKem_oem_oooooo/;>gUJ6>`LO<g>?P067<
c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003IVIV
c<c<VIVI01VIVIT04oolookioochmooon_OjlOSoo?Coomcaod5MPQ0bHQ/o
NCiUX5Z2]Z;9m9o6ijK:i:W9h:o>h[?BiP02/M3T0[;Ai@03[lkP/<oQ/=3O
00j`d=lH/M7P6;3@g`03/];Q]=CS]=CS00:bd^405;?Ch[7Ah:W<h:C:kZ?=
mj[Coh^ciUb4^49WVbM9Ma8bFDISPN_oonknoo?noocooo_io?okooolooon
ohRIVIT00oooolc<c<c<c01Mc<c<00VNLPZVI`2EE@2=E@Yk@@2=E@ZEE@2=
E@ZVI`000Yib2P0;/780WW8:/7/:/7/:/7/D/780/7/:YW80/780WW8:YW80
00:`N`X02fY12]>ZAlZQ?M>ZAlZZAlZH:M>H2[2=7[1k2[V=5;1k5002^HdD
00b`N`[1Q02iQ1BiQ1BiSAC:V1B`N`Z`Q2VVLP2`NaB`N`Z`LP02SED:00b3
;`1P;a@d;ahA70XdECf3SHCCfMJEXHk1al6VV8C:d<71/jd2b]310/77`@09
/;>g`LO1`K>]b]3Fb]31`K>]`LO<YZ6HYYR400:`ZX@00`0000TB2Q4L2P02
4A`:01LS70XA70XS70XA70X92A@J4Q@J2@XA70XJ9QA69QA6@AjVXFJVV6mb
Ie9ZIc=P;aBNNc>NLS>iV5bVV6nVQ5:`SE:VQ5800/6cSP03WXAVYXABbZ5B
00;]d9P02ngIc?o]S]bcG;V=<ng7G=bcG>g7G=bZ<m>Q:NBZ0=>H2P03dj4Y
00CT/dOCZTOL/hCL/e`2i;j400G]aecL/ecL/hCLZS?CZTL00^BcA`0CdjY7
g;=Li;=7i;=7g;=L^HdckLMLi;=7i;j4i;<ci;=7i;<Ydj4Yi:X0bYPDi:X0
diP:^FL0YT40009b>1@01F0_58<_0;1b0<ZZI]bcG003i;<c01;T/bWCV0[C
V0[CZTOCXBVNLP[]ahCT_XCT/dOL/ec]aecT/dOT_XCT/dOLZS?T_XCT/dOT
ZP02dj4Y0[V4500Q/8dNWW8DNd`DWW8:H44DH2lD8bH:8a`:6PT:2@T:4A`:
6PT:2@T:4A`:SHeBPehcAT4N;2HD4A`:2A8:6PT:2@T:LSPDbYPD^G8c`H@0
WUhDUEDDSED:ARHD8a`:6RHD8a`:008J4Q@05PT959EE5=bcG;2c]m?SmMcS
h>g]j]?SmNgfmOKomL77c:JQV<[@`McSe^g]j_KfmOKooooool77`IFQS/[@
`McSh67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<
c09VIVH00lc<c9VIVIVIV@0GVIVI01;ooOojn?goo_ooo__ooo_jo?W]m?[d
ooo^oolQ>f0UA78bE8ASR;EoY=2@/mVE^M^L_]ZRa=d3Y/SQ00>Xb^>WbN:U
b=h00jW<hPfYc>0HYl[N6:W<h003Yl[NZLcPZ<_O00:Wb]h05:S;gjG8g9k2
g9c4j9FnjXbehg>IbTi_XR0oKQ@_FS]CMNOkonOgooOooo_oong^l?onoool
oookooonohRIVIT00oooolc<c<c<c01Mc<c<00>NLPZNGQB=E@X00XeE2P0<
Pd40UED0WUhDWW8:WUhDWW8:/7/:/7/D/7/:YW80/7/:/7800[1k2P03/780
YW80/78000:`N`X05G8h0>g7G=bZ<lZQD/ZZAlZQ?K2=7/ZH5;1k5;2=7/64
0=>H2[1k2[V=5=>H2[1k2[V=5<ZH5=bZ<kV=5;V=:@02^H@D01>`LP2iQ1B`
N`ZVI`2NLPZ`LP2=E@ZVC0092@Y69QAZLUbEZZebLW_LhmJVZZ>VZZf`_/71
/jg:d=H00/77c00@/;>gUIRS`LO1b]31`LO1b]3F/;>gUJ6>YZZ]dn?eUEDD
2@TD4BH:2A`D4A`:8a`:0a4L2P046Q8D4A`:4A`:6PT:0R`L500CAT4NPg]L
UHeVUG97Pg/c;2HDJVLcLXdmUHAB^JY_/8AkYYQ_`J64dkj>/:Z4PehcbZ4m
g;>4i;j400?]d9P01]>nS[V=:Ng7G=bcG>BnQ=>ZA`;CXBT2bYPD00O:ZVKT
/dOT/bWCZTOLZS?T/dO:ZVH00]bcG006bZYVi;=7g;=LbZ4mi;=7bZ4m0^Bc
A`0=g;=LbZYVkM2HWW/cm/LmkLMLkLN4g;=LkLN4g;=Li;<ckKhmdj4Y00;C
V0X00m>Q:K1E0;1E0003Pbl000NNGQCT/dOT_XCL/ecT/bW:XE;:V1@00m>Q
:@05dh@0WW8:kLMLg;=Li;j400;L/e`00nBnQ>g7G>fn?@03i;=700OT/c?:
V1CCXBW:V1B`N`Z`SC>NLPX00g]<5004ARl:?A`:4A`:6PT:0Q4L2P0C2@T:
8blc2@T:AT4NPg/c=5DY6RHD6Q8D6PT:4A`:6PT:?A8:i:X0/7/D/7/:WUhD
YT`0LSPDH2lD008/71@04Q4V2QXB514V50T92W]<5>g7Q<6QQ>gfmL[@e]?S
mNg]j^gfmOKoojK7h:JHQ<77`McSe^g]jP;fool01Ooool[@`IFQS/[@`Ng]
jP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
16IVI/c<c6IVI/c<c1RIVIT01?koooooooonooSdl`;ooOl03nc[lOWoon3]
onkooc5<JQXhG2a=MU5dWW^MbX^^f8NZd8faeI>fg9Bhg9Jig`02V;cP00JF
^]bI_MnI_MnI_MnI_MfI_Ml2VKgM2IVnfaRH_MX?VKkK0iVmg@0OVKgOVKgM
VKgOVKgMVKgOVKgMU[[LUk_KU[[LUKWIU[[LUk_KT[KHRJoCMj79SKSSJi70
@FFE;D]m3BQEDfV@l?oom?oon?oonooojngZooomookoknS`oocoooko08RI
VIT00oooolc<c<c<c01Mc<c<00RNLPZNGQB=E@ZVC01b>1B3>02EEAB`N`X2
YVL00ZIb5004WW8:/7/:/7/:/7/Y0k1b000C/7/:YW8D/780/780/7/:JT4:
g;=LdjY7bZY7djY7g:Xc/7/:^Hdc^H@DbYPD/7/DbYPD/7/:diP:00;1Q000
1]>H2/ZH5<ZQD[V=5<ZH:KV=50:iSC<2^H@D00niSAB`N`ZiQ1B`N`[:V1A6
9QBiSABVC02EE@2EEABEXHjVXIREXHj`/kN`_/400l77c00=UJ6>YZ6H`K>]
`K>]YZ6HbZYV^JY_/8eB^HdY/8dcbYPD/5D0ARHD00894PX01A4L2R<L2QX9
2Q4V2PTB2P026Q8D01hJ2@XJ9Q@d;aiP@BVELTN3Neb3GS=P@BU6@AiZEAj3
GS=bEE:ESE:VV6niV5c1/hj3NebESFKT_XCL/ec]d9ST_XC]d9ST_XCLaj?L
/hB`SAkL/ecT/dOT_X@2g:Xc02OCXBWCV0[CXBW:V1CCZTO:XCgT/dOLZS?C
ZTOLZS?CZTOL/ecLZS?L/ecT/dOCXBWT/dOT/c?T/akCZTOT/dOLZS?]aebN
LQCfd8CL/ec]ahCT/dOT_XC]_SgT/c?]aecCXBWCV0[T/ak1Q03:V1B`N`Z`
C0000]>40008bZYVi;j4i;j4kLN4i;<cbZ4mbYPDg:Xc0]>Q:@05bYPDYVL0
on>>kLN4djY700;L/e`04^BnQ=bcG=bcG=bZ<m>ZAnBcAm>ZAm>Q:LZH5;2=
7[V45;2=<iib58=N57]<2W]<54HV53@_7P8A70X07aXB50T9514L2QX92Q4V
54I17W9EDTI17R<_7Q4L2PTB2QXB514L2QX92]>H2[1k2YiN5:IW09j4IX<_
060_514L2R`V51X92Q4L2Q4V50TL560_5>BcAl6QQ=?Sm@02g>?P00o]kN[C
hoG]m_G:d=J=V8k1/jgLhmK]m_GfooGfoooooooCfMJ=V8k:d<7Lhn00HLc<
c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00EVIVK<
c<bIVIUVIVK<c<`05iVIV@0Go?omo_ooookonO?goo[ooo_ooocoo_kon?oo
kOgokOooHWjF:TQZ5CIQ;dn0?5fBEgZ`GH:gI8W0Ihc1JXo6KI;7KY?800A/
TLD016bB`fbAaFbB`fbB``U/T/4HKI?246bB`@9/T/<07fbAaFbB`fbAaFbB
`fbAaFbB`fbAaFfCa6bAaF^A`VfBaVfCa6R=`Ej6]eAoZS=NRA8hIa<eIBI2
LGR=^>7aoo7monWao?_oookono_jmOonnoggnOoloocgo_ono`28VIVI00?o
ooo<c<c<c<`0GLc<c007WW8:WUhDUED0UED0SED:PcP0WUhD00:EE@001JIb
09ib2[1k2[1k5;1k2P02/7/D00J`LP2`N`Z`N`Z`N`Z`LP2VLP02/78000=b
>03L/ecCZTL00]>ZA`07bYPY/8@YbYPD^H@D/8dN`H@0g:Xc00;1Q0003KV=
5<640;V45<ZH5=>ZAkV=5<ZQ?KV45<ZQ?KV45=>Q:KV=5;V45002bYPD00_1
Q03CXBUP;`[LZS?L/ecLZS?:V2W1Q02iSAB`SAjiQ1@00[V=<`0=/8dc/7/D
/8dNdj4Y`H@0bYPD`H@0i;<cg;=LbYPYdj4Y`H@0diP:00;:V1@01THV50TL
51XB514L2R<L2QX92P8A70X02AXB51X92R`V54I17V1158=kG9j4IX=kG4IE
:@02AT4N00aP@BVELTNEQ7^VV6o1/hjVV8BiSC?L/hC]ahCL/hC]d9SL/h@2
kM2H02;ohhkL/hBNSBW]ahCL/ecT/dOL/ecLZS?CXBWLZS?:V1C:XE;CZTOL
ZS?T/dOLZS?T/dOLZS?T/dOL/ecT/c?T/dOCZTOT/bWL/ecCZTOT/dOL/ecT
_XCT/dOT/c>EEAC]aec]ah@2kLML00[]ahCL/ecT/bW]aecT/bW:V1CT/aj`
E@3CQ03T/c<2bZ4m01FiSC?L/hCT_XCL/ecT/dOT/c?T/dO:V1CT/dOLZS?:
XCg:V1B`LP3]d9ST_XCLZS?L/ecLZS?T_XCLZS?T_X@00^BcA`09djY7g:Xc
bYPD/8dN`H@0/7/D/8dNYW8DPehD009kC0X2ARl:018J2@XA70XA70X92@XA
70X92@XJ4Q@d;aj3Nc=6@Ah/9Q@A70XJ4Q@92@XJ4Q@J2@[faak1Q002WUhD
00JVI`1kC1AZ@@XJ4Q@/71@94PX26PT:00P92A@m4P[T/dNVV6o]m_GLhn3]
kN[Lhn02kOKe00cCfMIkSHC1/jgCfMK]kN[]m_Gfm_GooooLhn2EV:?1al7L
hn1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
1VIVI/c<c9VIVIVIVFIVI/c<c1JIVIT06?Son?cooOgko?oloookookdoook
oo[gooWooo;oonkoon[oonKoolGUodIUVbA4O`daKa<iN1]1P1m5Q2=9R2M=
S2Q>S2M=R`HYD8/2:E2922U@QaPWCXD@:E272BU@R`0H:U6<:E2;:4n::U6<
:e:=9Db76dAj43YZ5d9]CWBSa>Coioooh??olOoomOoonooon?[gnocfoooh
m_7]oocnoocoooWoookoR9VIV@03ooooc<c<c<c<05g<c<`01:Ib09iN59EE
59ib50:=E@X2WUhD00FVI`2VLQB`NbV`LP2VLQ@01[1k2P0OWW8:/7/:/780
WW8:/7/:JT4:i;=7bZYVg:Xcdkj>bZ4m^HdDbZ4m^HdDbZ4m`H@0bZY7/8dN
bYPDbYPY^H@DbYPD/8dNbZ4m^H@DbYPD/7/:bYPD/8dNbYPDdiP:00:`SAh2
bYPD00?CXBUZ@@[]ae`00]bcG004dkj>bZ4mg:XcbYPY0[V=:@04g:XcbYPD
^HdYbZ4m0/ZH:@03^HdDbZ4mg:Xc00;CZTL02M>H2[1k2]>H2/640<ZH5=bZ
<eLL00TB2Q4V50028a`:00X94PX/4P0A70XS70XJ9QA69QAP@BVESE:=SE96
@Ah2ARHD00f3GS=ZEAjNQ6K1/jgL/j>`ZXB3GS?T_XCL/hC]d9SL/ec]d9SL
/e`00^g@V004kMW<kM2HYW80kM2H0]bcG003g:Xcdj4Yi;<Y00;CXBT01mbZ
<m>ZAnBcAm>ZAmbcG>BcAlZQ?@02g;=L00CCZTOT/dOLZS?LZS<3i;=700GC
ZTOT/c?LZS?]aebEE@000^g7Q00Kg;=Li;j4kLMLg;=Li;=7i;<Ni;<cbYPD
dj4YbYPD^FL0^H@DbZ4mg;=LdjY7g;>4g;=Li;=7bZ4mi;<ckLMLbZ4mdj4Y
g:Xci;<cdj4Y^H@D00?L/e`08^BnQ<ZQ?NBnQ>BcAmbcG<ZQ?M>Q:MbcG=bZ
<m>Q:LZH5;V45;UW0;24:Iib58=N578h07]<2VY12R<V2R`B01X92PT92Q4L
2PT92Q4L2PT92SdL2W:=?DH_2S@_7PTB2PT92QXB50892@X02<ZH5;Ub<iiN
59iN5;1E08eE2V0_52`B008S70X02PT9514V50T952<L2]bZ<k1kI_Kool[@
e]cSh=?Sm@;]kNX03>gfmH>4Nl6c[M?Ie^g]j^gfmOKoooooongfmIFQS[2c
]mcSh67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<
c003IVIVc<c<VIVI00:IVIT00fIVI/c<c<c<c03oc<c<3/c<c003ooooc<c<
c<c<05g<c<`01Yib59ib2X=N59iN59EE57]100:NGQ@02jIW09ib2ZIb5;1k
2ZIb0:IbD[1b0;1k2[1b0;1k2[1b0002/7/:00n`LP2`N`ZVLP1k@@3T/dO:
XCg:ZTO:ZVKLZS>`SC?:V2ViSAC:V2V`SAkCXBT00/ZH50:iQ1@02kV=5<ZH
5<ZZAk2=7/ZH5;V=:LZH:KV=:M>Q:LZH5;V=5002bYPD01C:XCgCZTN3GQC]
aecCZTOL/ecT/dOLZS?:XCg:V1CCV0[:V1C:V2ViSBViQ2W:V1CCXBWCZTO:
V1CCV0X2djY701KCXBW:V1CCV0[CV0[1Q03:V1CLZS?:V1AP;a@J9Q@A70X9
4PX/4P094PXA9PXS70X/71A69PYZIc=6@Ai6;`Xd;ah2H44Y00QZIc>EQ5:i
ZVo1/hjESE:3GS>iSC?]ah@2i;j400[L/ecL_Zg]d9ST_XC]d9SLaj?]d9RN
LQC]aecCZTL2g;=L0]>ZA`09bZ4mdiP:bYPDg:XcbZ4mi;<cg;=Li;=7i;<Y
00?T/dL01MbcG>Bc<nBc7]bcG>Bc<`02g:Xc0^Bc<`09kKhmUED0i;=7kLML
i;<ckLN4kKhmi;=7g;=L00;T/dL01m>H2]>Q:M>H2[1E0;V45=bZ<nBnQ003
g;=L0^BcA`05i;<Ni;j4bZ4mi;<Yi;=700?CXBT2i;=70]bcG006djY7kLML
djY7i;=7g:Xci;=70]bZ<`0Hdj4Y`H@0`H@0^H@D/7/DYW8DPehDLSP0LSPD
JT4:?A`:4A`:2A8:4A`:2@TD4A`:2@T:6PT:8bH:Pg/cAT4N8bH:4A`:2@TD
0Q4L2P092@TDdh@0bYPY^H@DUEDDWUhDPd40ARHD;2HD008S70X0214L2QXB
51X92PT92]bcG<ZZAngfmM?Sm@;Lhn002Ng]j]?SmNgfmG^=Q:JZXnC@c=cS
h>gfmOKfm@02m_oo00>VZZ>VXIS]kNX0HLc<c004IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT00iVIVOmVIVH@IVIV
00?oooo<c<c<c<`0GLc<c003WW8:UEDDSED:00:=E@X01H<h09EE5:IW0:I<
0:Ib5002/7/D00j`LP2`NaB`N`Z`SAj`N`Z`LP2iI`2`N`ZVLP2`N`ZVLP2`
N`Yb>03T/dL2bZ4m01KCZTOLZS?:V2W:V1B`SAk:V2ViSAC:V2W:V1CCXBVN
LPZiQ1BiSAC:V1C:XCfiQ1C:V2W1Q03:V2V`SAkCXBV`SAh2bYPD00G:V2W:
V1CLZS=ZEAkL/e`00]>ZA`06bYPDdj4Yg:XcbYPDbYPYdiP:0/ZH:@0U/7/:
^Hdcdj4YbYPD^H@DbZ4mg:XcbYPYdj4YbYPDdj4Ydh@0bYPDdiP:bZ4mdj4Y
/8dNUEDDH2lD;1806Q8D6Q`N6PT:6Q8D6Q`NH5hc8blNAT4N;1`DAT4NJUDN
Pg/cYXABYYQ_/:Z4YW9B/8dc00;:XE801^BnQ>C7`NBnQ=bcG>g@V>g7G0?]
d9P01OoSSW]<2^BcAmbZ<mbcG002djY700?L/ecLZS?CXBT00]>Q:@06g:Xc
i;=7i;j4g;=Ldj4Yg;=L0^BcA`03i;<Ni;<cdjY700;L/e`08>Bc<mbZ<nBc
<mbZ<nBc<heE2]bcG>BnQ>Bc<oKII]bcG>g7Q>Bc<nBc7^BcAlZH5>Bc:NBc
<lZH5;1E0=>H2/ZZI^BcAlZZI]bcG>BcAmbcG>Bc<nBcAm>Q:LZH5>Bc<`;C
XBT03lZH5>g7Q=>ZAmbcG>BnQ>BcAmbcQ=>ZAlZZI^Bc<lZQ?NBc<m>Q:LZH
5;2=7P02/7/:00b`NbVVLP23GQAkC0Yk@@1Z@@XS9PXS70XA70X94PX92@XA
9Q@24A`:01dJ4QB3Nc=6@Ahd;ahA9PXA70X92@XA70X92@[CQ03:V1BiI`2V
C02`E@2=E@Yb>1@m70XS70XA70XJ9Q@J4Q@A9Q@92@ZiSC>`SE;fooo:d=K]
kN[ChoD00^g]jP07m_ooNheVYZZ]b]31g>?PkNgZm_Ke00;fool00k2c]jJQ
V=cSh01Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI/c<c9VIV@3oVIVI4iVIV@03ooooc<c<c<c<05g<c<`01Yib5:IW
09E<:H=108eE2YEE00:=E@X00jIb5;1k59ib2P02/7/:00VVLQB`NaB`NaB`
LP2`N`ZVLP2`LP2VLP2`N`X00[1b0006Pd40kLMLdjY7bZ4mbZ5BbZY70/ZQ
?@0@^H@DbYPD^H@DbYPY`H@0^HdY/7/:`H@0diP:bYPDdiP:^H@DbZY7^H@D
bZ4m/8dN0/ZH50:iSA@2bYPD00S:V2UkC0[CZTOT/dOCZTOL/ecCZTO:ZVH2
g:Xc00?:V1BiSBW:V2T00[2=7P;:V1@01]>H2/ZH5=bZ<lZH:MbcG=>Q:@;:
V1@03m>H2/ZH5<ZH5<ZQ?LZZAlZH:KV=5:Ib5:IW07]<52`V53@_7TI17V11
:DI17P02H44Y00IZEAibEE:EQ5:`Q7^VQ5:iSC<3bYPY0]>ZA`?L/e`00mbc
Q?KII^g@V003kM2H00JNLQC]_SgL/ecCZTOL/ecCZTL3dj4Y00?LZS?:V1CT
/dL00mbcG003g:Xcg;=Lg;=L00?L/e`02]bZ<nBcAmbZ<mbZ<m>Q:NBc<nBc
7^fn?Iib2]>ZA`;L/e`01^g7G=bcG>g7Q>Bc<mbZ<nBcA`;CXBT03^Bc:MbZ
<m>H2[1k2]bcG=bZ<nBcAnBnQ>Bc<nBcAlZQ?NBc<m>Q:Nfn?@;CXBT01>Bc
7/ZH5=bcG>BcA`;L/e`04=>ZAmbcG=>ZAmbcG=>ZAlZQ?MbcG=bZ<m>H2/ZH
:KV45<640;1k2[1k58=N578h009Z@@X06SdL2Q4L2QX92PT92Q4L2PT92PTB
2PT92QXB56YE7SAE:B`V50T953@_7Q4L2QX92Q4L2YiN5<ZH5;V45;1k:K1E
09EE58<_02`V52<V2P8J2@X00`T9514L2PT92P02^Hdc00c]m_GLhn3CfMK]
kN[Lhn3]kN[]m_F3V8jEXHk:d<7]kN[]m_D3m_oo00?1albEXHk]kNX0HLc<
c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<
c<bIVIT05YVIV@Cnood4o_oo00?mo_onoooloOl00_CenP05kNkch>7VgMgU
f=SRf=ST00CGen<9e]KR<MKFh0SFe^87emOS00OGen7De=kIfN7Sh^[[k?7c
l_OinO/00oooo`?oood5ooooRiVIV@03ooooc<c<c<c<05g<c<`01;1k2YiN
5:IW08eE2P:3@@0028eE2ZIW09EE0:Ib09ib2[1k5;1k2[1k50:`N`X2/780
02>`N`ZVLP2`NaB`N`Z`LP2VLP23@@3L/ec:XE;LZS?:XCf`SAk:XCg:V2Vi
SABiSC>iSAC:V1C1Q02iQ1B3GQCCXBV`SAk:XCg:V2W1Q03:V1BiSBW:V1Bi
SC?1Q02iSC?:V1C:V2W:V1@00/ZH:@0CWW8DbZ5BdjY7djY7g;>4i;=7djY7
dj4YdjY7bYPDdjY7bZY7bYPY^HdcdiP:dj4YbYPDdj4Yg:Xc00;CZTL00m>Q
:LZH5<ZH5002bYPD01CCXBW:V2W:XCg:XCg:ZVJiSAC1Q02iSC=b>1A6@Ahd
;bUP@BU6@AiZIc>3GS>NLS>VQ5;:ZVJiZVn`NbT2bZ4m0]>ZA`07i;=7i;j4
g<NSkM2Hg;=LkM2Hg;>400;]d9P03NgIc>g@V;V=<nfn?NBcAnBc<m>ZAmbc
G=>ZAnBcAm>ZAnBnQ<ZQDP02g;=L00GT_XCL/ecT/dOT_XCL/e`00nBcA`05
g:Xci;=7i;=7i;<NbYPD00;LZS<02nfn?K1k2[V=<nfn?MbcG>BcAnfn?NBn
Q>BcAnBc<nBcA`02dj4Y00GT/akCXBWCV0ZiI`3:V1@00]bcG00GbZYVdjY7
dj4Yg:Xci;=7i;<cJUDNi;<YbZ4mi:X0bYPDbZYVi;=7kLN4bZY7YXABm]UV
djY7i;=7djY7g:XcdjY7g:Xc00;:V1@01[V45;1b0;1k59ib2W]<57]<2P9P
@A@03TH_2Q4L2Q4L2Q4L2PT92Q4L2QXB514L2PTB2V1N<f1153@_7Q4L2QXV
50<92@X01JIW0<ZH5;UW09iN5:Ib5002SED:01@m70XA9PXA70XA70X94PXJ
4Q@A9QAZEAk:XCg]m_GCfMKChoGLhn3ChoG]kN[fooF3V:fVV8C1al7LhmH2
kOKe00Gfooooooo1albVV8C]kNX0HLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT05YVIV@Cnoo/03?kooOko
ookoookooo[noo_oonkam]kQj=[Mi=CGg/W<eLO9e@:i^lP3^;[70kNiaPVi
^lP_^K_72;Vkb0Rj_<T02;^mb/;4d<c<f=7DgMWIhNCUj_;cn?gno`Cnool4
ooom00?ooonIVIVIVIT0RIVIV@03ooooc<c<c<c<05g<c<`01YiN59ib59EE
08eE2X<h09E<:@:EE@002IiN5:Ib09ib2[1k2ZIb5;1b0:Ib5;1k2Yib2P02
/78000>`N`ZVLQB`LP000[1k2P0EPehDg;=Ldj4YbZ4mbZY7g:XcbYPD^HdY
^H@DbYPD^HdD`H@0^HdDYW80Nd40i;<NbYPDbYPY`H@0^HdDbZY700;:V2T0
3;V45;V=:M>H2/ZH5<640;2=7[V=:LZH:H=k<lZQ?MbZ<lZQ?@;L/e`01^Bn
Q>BcAm>ZAnBcAlZQ?LZH:@;:V1@01M>Q:M>ZAlZH5<ZH5<ZH:@02g:Xc00?L
/ecCXBWCV0X00lZH500>i;<NbYPYg:XcbZY7^H@YbYPYbYPD/7/YNd`DJUDN
PehcPg/cYXAB/8eB0lZQDP04bZ4mWW8cbYPYbZ5B0mbcG00<kLN4g;>4kM2H
kLMLkLN4i;j4kM2Hon>>g;j]onf>^IQLg:Xc0mbcG009i;<NbYPDdj4Ydh@0
dj4YbYPDdjY7g;=Li;=700;L/e`07^BcAmbcG>BcAmbcQ=bZ<nBZ0>BcAmbc
G>BZ0=>ZAm>Q:MbZ<nBc:K24:K2=7^BcAmbZ<lZQ?K2=<oK@Q>BcAmbcG>Bc
AnBc<mbZ<nBc:M>Q:NBc:K1k2]>Q:@;LZS<05ng7G>BcAnBcAmbZ<mbcG<ZH
:H=N5>Bc:M>Q:NBc<lZH5=bcG>g7G=c7Xiib2YEbAng7G<ZQ?NBcAmbcG<ZQ
?MbZ<m>Q:@02bYPD00g1Q02iQ1B`NaBNLPZ3GQAk@@1kC0YZ@@Xm70XA70X/
4P094PXJ4Q@00PT92P0D6Q8D0000JVLcAUDY8bH:4BHD4A`:2@T:2A8:4A`:
Pbl0/7/:bYPYWUhD/5D0UEDDNd`D;2HD;1`D8a`:0QXB500A4A`:2@TDLSPD
bZ4mg>?Fg>?PdmWFkNgZg>?FkNgZm_ooUJZ]SHe_`K>]dn?ekNgZkOKe00;f
ool00mcSh8>=Q>g]jP1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^0C<c<`00fIVI/c<c9VIV@0FVIVI0_konP;noo/0I?kooOkoooko
ookooo7en>obmm[Mi<C7d;^mbK>g`ZZ/^JJY^9RJZINJZIRIZiJIZ9NHZYFH
YiJGZIFHYiFFZ9BGYYFFZ9BGYYFFZ9BGYYFFZ9BGYYFGYYBHY9FGYYBHY9FG
YYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBH
Y9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FG
YYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBHY9FGYYBGYYFGYYBG
YYFFZ9BGYYFFZ9BGYYFFZ9BGYYJGZIFHYiJGZIFHYiJGZIFHYiJGZIFHYinQ
/:BW]Zf__;:d`KRja/K9d]_NiNg^l`Cnool2ooom0_oon`03ooooVIVIVIVI
08VIVIT00oooolc<c<c<c01Mc<c<012NLQBNGQB=E@Z=E@ZNGQBEE@2VC02N
GQBEE@2NGQB`N`Z`SAj`NaB`N`Z`NaBVLQ@2/7/:00RVLQBVLP2`N`Z`N`ZV
LP2`N`Z3@@3L/e`2bZY700G:XE;:V2W:XCfiSAC:V1@00[2=7P04bYPD^HdD
/780Nd`:0/ZH500;bZY7bYPYdiP:djY7/8dNbYPY^H@DbYPD^HdD^H@D/8dN
00;:V1@02LZH:HeE2]>ZAmbcG=bZ<m>Q:M>ZAlZZI]>ZA`02bZ4m0]bZ<`07
diP:bYPDbYPDdiP:bYPD^H@DbZ4m00;CZTL01=bZ<m>Q:LZH5;V=50;:V1@0
5m>Q:LZH5<ZQ?LZZI[V45<ZQ?M>ZAkV=:KV=<k2=D[VHG<ZQD/6QQ<ZQ?LZZ
Am>Q:LZQD]bcG9EE5<ZH:MbcG=>ZAmbcG002i;j40^g@V003g;>4dkj>kM2H
00C]d9P07k2=D]bcG>BnQ>BcAng7G6YE7]>Q:LZH5<640=>Q:LZH5<ZQD^Bc
<nBcAmbcG>Bc<m>ZAnBcAmbcG>BcAnBc7]>ZAnBc<ng7G9ib2Yj=<nfn?NBc
:NBc<l6408eE2P02kLML00V`SAj`Q7_]aec]aecT/dO]aecT/c?CXBWT/c<0
0]bZ<`0B^G8cdj4Yi;<ci;=7bZYVi;=7bZ5Bi;=7g;=Li;<Ni;<Ydj4Yi;<Y
dj4YbYPDdjY7bZYVkLML0^BcA`07g;=LbYPDg;=Ldj4YbZ4mi;=7g:Xc00;:
V1@2/7/:00b`NaBNLQBEE@1k@@23@@1Z@@Xm70XA70XJ2@X94PXA70X92@X2
4A`:00H92AAbIe96;`XS;ahA70XJ2@X24A`:00T94PYb>1BiLS>`N`ZVI`2N
GQB3>01kC1@m70X00R<L2P0:6PT:6Q8D4A`:6Q8D?A8:djY7`LO<dn?edmWF
g>?P0]?Sm@07kOKeUJZ]NheV/;k1g>?FkNgZkOKe00;fool00ngfmH>=Q=cS
h01Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
0fIVI/c<c9VIV@0FVIVI06[ooo[loOOmo_Wooo_moocnooolooodn?_Phn[<
cmRn`/fY[KVKWZf@UZJ0PiIoQ9MoPYElPY9lOi9fO8aeN8]cNHUhNhihOXii
O8mgOHeiO8mgOHeiO8mgOHeiO8mgOHeiO8egOH]iO8egOH]iO8egOH]iO8eg
OH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]i
O8egOH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]iO8eg
OH]iO8egOH]iO8egOH]iO8egOH]iO8egOH]iO8egOHehNhafO8ahNhifO8ah
NhifO8ahNhifO8aiO8mhOXijOI1fO8agNXegOHenPIB0QIQnPIB0QIR8Rij@
TjBKWZf[[k^m`Lc;c]OSi^gbmOX2o_oo00GkoO[lo__ooo_ooo_oool0>YVI
VF]VIYU6c<c<00BVLQBNLQBEEAB=E@X2PcP000^=E@ZVC02EEABVI`2VLQB`
NbViQ1BVLP2`N`Z`LP2`N`X00[1b000:WW8:/780/7/D/780/7/:SED:i;<Y
g:XcbZ4mg:Xc0/ZQ?@08^HdY/8dNbYPD^HdcbYPDbYPY^FL0WW8D0/ZH5007
bYPY^HdY/8dN/8dN^HdcbYPY/8dN00;:V2T03l640<ZH:KV=:KV=5;2=7X=k
<kV=:M>ZAm>Q:M>ZAmbZ<m>Q:MbZ<nBc7/ZH:@02djY700WCXBW:V2WCV0[L
ZS?CXBW:V2WCXBWCZTO:XCd00lZH:@0;bYPDg:XcdiP:dj4YbYPYbZ4mg:Xc
^H@DbYPDg;=Lg:Xc00;CZTL01<ZQ?LZQD]>Q:LZQ?@;CXBT01NBnQ=>nS/ZZ
I]>ZAlZH:@02g:Xc00SL/ecT_XC]d9ST_XC]aea6;`[L/hC]fL`3kM2H00K:
ZTO]aecL/ecL/ec]aeb3GS<5dj4Y00GL/ecT_XCL/ecL/ecCZTL00^Bc<`0@
i;=7djY7i;=7i;<Ni;=7kKhmUEDD^H@DdjY7bYPDg;=LbYPYUEDDm]24i;=7
g:Xc0^g7G00Ii;=7kLMLi;=7kLMLdj4Yi;=7i:X0bYPDdh@0^H@Ddj4YbZ4m
i;<cg;=LdjY7i;<cdjY7diP:dj4Yi;<cbYPDi;<NbYPD^HdckLML00CL/e`0
1[V=<nBc<lZQ?M>Q:LZQ?MbZ<`;CXBT03/640;V45;2=7Yib2XeE2VY12X=N
56Y12THV2R`B014L2R`B00T92Q4L2P8J2@X010000611:DI17R`V508A70X0
1aX92Q4L2PT955LL0<ZH5;1k2[1k5002SED:00=kC0X/71@/9Q@0114L2P04
4BHD6PT:i;=7`K>]0mcSh0;]kNX01ngfmK2n`G^=Q;2c]l[@e^g]j^gfm@02
m_oo00?]kNZ3Q7_]kNX0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT05YVIV@1[ooojo_oio_ojo_klnO_j
nO[ll?Cggn;Yd=?L^ko;[K2oTYNZP8FIMgb@Jg26L7F;IFYnIVeoJ6f0IVeo
IFYmI6]mIFYmIFanJ6f0Ifj0J6f0Ifj0J6f0Ifj0J6f0Ifj0J6f0IfinJ6in
IfinJ6inIfinJ6inIfinJ6inIfinJ6inIfinJ6inIfinJ6inIfinJ6inIfin
J6inIfinJ6inIfinJ6inIfinJ6inIfinJ6inIfinJ6inIfinJ6inIfinJ6in
IfinJ6inIfinJ6inIfinJ6inIfinJ6inIfinJ6inIfinJ6inIfinJ6inIfin
IFYmI6]mIFYmI6]mIFYmI6]mIFYmI6]mI6UlIFanIfaoIVeoIFYmIFanJ6f0
JW64L7F;I6Z0I6UoM7V?QhbPV9^^ZJbm^Kg9blgIh>?ZmoSm00;nool01?go
o?gnnOcmn?ooocZIVIT00fIVVLc<olc<o`1Wc<co00=VIYW<c<c<c<`0A<c<
c003YW8DWW8DWUhD00:=E@X018=107]<59EE08eE2P:VLQ@00k1k59ib2[1k
:@02/7/:00>VLP2`N`ZVI`000[1b000BYVL0/7/:/7/:Pd40dkj>g:XcbYPY
bZY7bYPDbZ4mbYPD^HdcbYPYbYPD^HdcdjY7/7/D/7/:0/ZH:@0:dj4Y/8dN
^HdYbYPY/8dNbZY7^HdYbYPYbYPD^HdD1<ZH5008PehDbZ4mg:Xcdj4YbYPD
djY7g:XcbYPD0/ZQ?@0=bYPYi;=7dj4YbZ4mdiP:bYPYdjY7bZ4m^HdYbZ4m
g:XcbYPDdj4Y00?:V1@03f11:M>Q:LZH5<ZH:LZQ?KV45=>Q:LZH:M>Q:NBc
<h=N<kVHG<ZQ?MbZ<lZH5003djY700GT/dOL/ecCZTOCZTOLZS<00]bcG005
i;j4kLN4kM2Hi;j4kLML00G]d9P00lZQ?LZZI]bcG002g;=L00ST/c?:V1CL
ZS?LZS?CXBWL/ecCZTOL/e`2i;=700_L/ec:ZVKLZS?LZS?T/c?CZTOT/c?C
ZTOT/dO]aecLZS<00]>Q:@0?g:Xcdj4YPehDkKhmi;=7g:XckLN4g;=Li;=7
i;<ci;=7kKhmi;<cdj4Yi;<N00;CXBT01]>40=>Q:Nfn?M>ZAnBcAm>ZA`;T
/dL01m>Q:M>H2]bZ<nBZ0<ZQ?M>Q:K2=<`02kLML00KCZTOL/ec]aec:XCgT
/dO:XE82g:Xc02?:XCgCV0[:V1BiSAB`N`ZVLQBNLPZEE@1b>1Ab>01Z@@Y6
;`XA70XS70X94PXJ4Q@92@XA70X92A@A70YPGS=6@AhS;ahJ2@XA70XJ2@X9
2@XA70X/71BNGQBiI`2`N`ZVC02EEAAkC0X00SdL2P038a`:4A`:6Q8D008J
4Q@051X92_KII]bcXng]j]?Ie]cSh=?SmNg]j^gfmL77c7^=I/6c[L[@e^g]
j^gfmOKoooKomOooofYkKngfmF7<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01JIVIT0LOoonocmn?kno?oo
oOcmooWjo^S[l];Eg[k2cZ6T]HjAY7^0UWj2VhfC[IBI]Z:X`/O=hlWAi<oF
jM7Ik=7HjloGj/kEj<gEj<oFjLkFjLoFjLkFjLoFjLkFjLoFjLkGj<oFj<kG
j<oFj<kGj<oFj<kGj<oFj<kGj<oFj<kGj<oFj<kGj<oFj<kGj<oFj<kGj<oF
j<kGj<oFj<kGj<oFj<kGj<oFj<kGj<oFj<kGj<oFj<kGj<oFj<kGj<oFj<kG
j<oFj<kGj<oFj<kGj<oFj<kGj<oFj<kGj<oFj<kGj<oFj<kGj<oFj<kGj<oF
j<kGj<oFjLkFjLoFjLkFjLoFjLkFjLoFjLkFjLgDilgEj=3Gj]3HjloFjLgE
j<kEj<gEj/36h:V`c9NL^H^AZgb2VWMlTXbAYJbaa;NjbLkBgN_^mO_oooko
ookooOkonogon_ooo`0jVIVI00=VIYW<c?o<c?l0Ilc<o`03IVJIc<c<c<c<
04C<c<`2YW8D01BEEAB=E@Z3>02=E@Z3@@2NLPZNGQBVI`2NLPZ`NaB`N`Z`
NaB`N`Z`LP2`N`ZVLP2`NaB`LP2NLPZ`LP02WW8:00R3@@3LZS?L/ecLZS?:
XCgLZS>`SAjiSA@2^HdY00W:V1C1Q03:XCfiSABVLQC:XCgL/ec:V2ViSBT0
0/ZQ?@03^HdDbZ4m^H@D00;:V1@00m>H2[2=7/ZH:@02`H@000bNLQC:XE;L
/ec:XCgCZTOT/dOL/hCCZTOLZS?:ZTOLZS?CZTL2bYPY00G:V1CCV0[:V2W:
V2W:V1@00/ZQ?@;:V2T01=>Q:M>H2/ZH59EbA`;:V1@01Nfn?LZH5;V=5=>Q
:MbZ<`03dj4Y00C:V1CCXBWCV0[CXBT2g:Xc00[CZTOL/ecT_XCT/dOCZTOL
ZS?T/dOL/ec]d9SLaj<2kLN400gT_XC]d9S]d9S]d9S]fLcokHk:ZVKCZTOT
/dO]_SgL/ecCZTOLZS<00]bcG00Pi;j4g;>4djY7i;<cg;=Li;=7g:Xci;<Y
g:Xci;=7i;<Ndj4Yi;<cdjY7i;<ci;=7bYPDdj4Yi;<Yg:XcbYPDUEDDm]24
i;<cdjY7g;=Li;=7i;<ci;=7i;<ci;=7bZYV0^Bc:@07bYPDdh@0bZ4mi;<Y
bZ5Bi;=7djY700;T/dL01M>ZAnBc7/ZH5>Bc<m>Q:@02bYPD00>iSC?]aecL
aj<00mbcG0;CZTL01mbcG<ZH5=bZ<m>ZAlZH:LZH5<640002/7/:00VNLPZ3
GQAb>01kC1Ab9P0m70XS70XA70XJ2@X00Q4L2P062@T:4BHD2@T:AT4N=2lN
8bH:0Q4L2P082@T:2@TD6PT:;1`DYW8D`H@0YW8DSED:0W]<500<ARH:;2HD
4A`:6PT:4BHD6Q8D2A8:0000on>>g<NSkOKeb]3F0]cSh009kNgZdn?e`LO<
Nhf4`K>]b]3FkNgZkOKem_oe00;fool00h=kG>g]j/c<c01Pc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0F
VIVI01?ooo_ko?Ono_coooomo_oem__Mh>W2a=6Z[Kj;T:AoQ9Z2R::NXl30
aN?:cnoEg?W?enkAg>kFhO<00][Um`03f>?een;de^7c00SHhoD`f>Cd2=WT
mP0Fen;df>?ef>?ef>?een;deN3be=oae=oedMSecmGec=;b`<KVY:W7QX^X
P8BORXnUZZg0_l;Ag=kZl??hn__ooOon0_koo@03ooooVIVIVIVI03RIVIT0
0fIVVLc<olc<o`1Wc<co00=VIYW<c<c<c<`0A<c<c008YW8DWW8DUED0SED:
Nd`:Nd`DUED0SED:0YEE00:`N`X01Yib2[1b09ib2[1k2[1b0;1k2P>`LP00
1JIb0;1k2[1k58=10=bZ<`02bZ4m01O:V2W:XE:iSC>`Q2W:V1B`SAk:V2Vi
Q1C:V1BiQ1C1Q03:XCg:V2W:XCg1Q02iSC?:XCg:V2W:ZTNiQ1CCXBU6EBW:
V2T00lZH5009/8dNYW8DbZ5Bi;j4g;=Li;j4bZ4m=5DYkKhm00?LZS<01lZZ
Am>Q:M>H2/ZQ?LZH5<ZH:LZQ?@02bYPY00CLZS?CXBWCXBWCV0X3bYPD013L
ZS?CV0[:V1CT/bV`NaC:V1CCZTOCXBWLZS?:XCgCXBW:XCgCXBWCV0[:V2WC
XBT4g;=L00GT/dOLZS?LZS?L/ecT_X@00^g@V003dkj>i;j4kM2H00?]d9P0
2^gIc<ZZI^BcAmbcQ=bZ<nBnQ=bZ<mbcG=bcQ=bcG0;CXBT01/ZH5<ZQD^Bc
AnBc<m>ZAlZQ?@;T/c<00lZQ?MbZ<m>Q:@02i;<c00?LZS?CXBWLZS<00]bZ
<`07dj4YPehDkLMLg:Xcg;=Li;=7g;=L00;T/c<05nBc:Ng7G>Bc<nBc<m>Q
:LZH5=>H2]>40;V=<lZQ?MbcG>BcAmbcG>g7G=>ZAm>Q:LZH5>Bc:M>Q:M>H
2^Bc7YiN5>g7G003g;=L00CCZTOLZS?T/dOCZTL3dj4Y00_:V1C1Q02iSAB`
LP2`N`ZVLP2NLPYb>01k@@1Z@@Y6;`X00a4L2P036PT:2@TD6Q8D00892@X0
0b`V52a<:B`V50024A`:01H92@XA70XA70XJ2@Z`E@2`NaBNLPZVC01kC1B3
>0169Q@/71@S70XA70XJ4Q@94PXJ4Q@0003]d9SC_XkLhn3CfMH3g>?P00c]
m_GLhn1bSHBVZZ?:d<7Lhn3]m_GfooofooGfoombSEc]kNYQc<c<00AVIVJ8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0F
VIVI01?oooglo?[oooooooofmo_Vi^k8b]JXZ[V@TjJ6Rj6CUk:TZLNm`^;?
eOO9co?<d_CDh?KGi?GJioP00]cYnP?Kj?T8hNko<>7^oPSNjo`01=o/oMgZ
nm_XnM[Wn0?Ii_L04]WUnlgFmlcDnLWAmLC<l;g3iJ^adI:G]Gb0ViJH[jV/
_lS:en;Uk??dnOWjo?cnnokooOooocZIVIT00fIVVLc<olc<o`02c<co00@0
003<c?o<c?l00002c<co00@0003<c?o<c?o<c?l300000lc<o`050000c<co
c<coc<co000000?<c?l2000000?<c?l0003<c?l01<c<o`H000000lc<o`00
0<c<o`02c<co0`0000C<c?l2000000?<c?l0003<c?l0;Lc<o`03IVJIc<c<
c<c<04C<c<`2YW8D00>NGQB=E@ZEC2T00W]<2P:EE@0029iN5:Ib0:Ib5;1k
2Yib2[1k2[1b09ib2P:`LP001iib2ZIb0:Ib0:Ib0:Ib59EE0<ZH:@03bZ4m
01GLZS>iSAC1Q02`SAk1Q02`SAjiSAC:V1B`N`Z`LP3:V1C:V2W:XCg1Q02i
SC?:ZTO:V2W:ZTN`SAk:XCeP;a@00lZH500?diP:bYPD/8dN^Hdcg<NSdjY7
g;=LdjY7WW8DdjY7g:XcbZY7i;<Ndj4Yg:Xc00?:V1@01M>Q:LZH:LZH5<ZH
5<ZQDP03dj4Y00WCV0[:V1C:V1CCV0[CZTO:V1C:XCf`N`[LZS<00]>Q:@03
g:XcdjY7bYPD00;CXBT2bYPD00?CV0[CZTOL/e`00]bcG009bYPDdjY7i;=7
g;=Li;j4kLN4kM2HkLMLi;j400G]d9P02MbcQ=bZ<m>ZAnBc7]bcG=>ZAmbc
G=bZ<lZH5002dj4Y00GCZTOT/c?:XCg:XCgT/ah00]bZ<`05i;<cg:Xci;=7
i;<cdjY700;T/bT02mbZ<m>Q:MbZ<nBc<nBZ08eE2^g7G>Bc<nBcAnfn?M>Z
A`02i;<c00[T/dO:XCgT/c?CXBWT/ak:V1B`N`[CQ03:V1CCXBT3i;=700_]
ahCLZS?CXBWCV0[T/ak:V1CTZP3:V1BVI`3]aecT/dL00]bcG0;CZTL04/ZQ
?M>ZAm>Q:LZQ?M>Q:LZH5=>H2[V45;1k2ZIb09ib2XeE2W8h07]<2VY12TH_
2R<L2R`B00<A70X01PT92Q4L2PT92S@_7THV52<_7P<A70X050TB2PT92QXB
58eE2[1k5:IW08eE2W]107]<2SdB2R<V2R<L2QXB50TB2QXB514L2P000>g7
G>BnQ=cSh0;CfMH02=cSh=?SmNg]j]cSh8fHSZJQV<[@e]cSh0;]m_D01?Ko
mOooohf=D^g]jV7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2h
R<2h1<c<c003IVIVc<c<VIVI01JIVIT05?oooOcln_oooooooo7bmmgMikfo
c9^N[h63V8V=YZJ[bKFjf[k4j<G:l<C9lLkFn]CPn=CTm=KVm]OWm`;Fi_H0
0mOWmmSXn=_[n`07fn_k<=_[nPSIjOT00m_[nmWYnMKVmP04eNGe01;Dho[M
iooKhoo=eObla>Vf^n6b^=bSYlZAU[B4R:>HVZni^l[Kg^OdmO[loOomookm
oocoooljVIVI00=VIYW<c?o<c?l00/c<o`040000c<coc<co00000/c<o`04
0000c<coc<co00000lc<o`040000c<coc<co00000lc<o`040000c<coc<co
00000/c<o`800005c<co00<0003<c?o<c?l01<c<o`040000c<coc<co0000
0lc<o`040000c<coc<co00000/c<o`80000^c<co00=VIYW<c<c<c<`0A<c<
c00@YW8DWW8DSED:SED:Nd`:Pd40LSP0SED:UEDDYT`0YW8D/7/D/7/:WW8:
/780WW8:0[1b0007YW80/7/:YW80YW8D/780YW80SED:00;:V2T2g:Xc00B3
GQAZIc>`SAj`SAh2^HdD02_1Q02iSC>iQ1C1Q02iSACLZS?:V2W1Q03:XCgC
ZTN`SAkLZS>`N`[:V2W1Q02iSAC:V1C:V2ViQ1C:XE:iQ2V`SC?]aecL/ecC
ZTOL/ecT/dO:XCg:V1CCZTO:XCgLZS?CZTOCV0[CXBW:V2W:V1C:V2ViQ2WC
XBW:V2WLZS?CXBT00/ZH50?CV0X2bYPY00KL/ebiSBW:V1CCZTOLZS?CZTL3
dj4Y0/ZH5003diP:bYPDdj4Y00;L/e`02]>ZAmbZ<nBcAnBcAmbcG>BnQ=c7
XnBnQ>g@V>g7G0G]d9P01]bcQ=bZ<m>ZAm>ZAmbcG=bZ<`?CXBT01<ZH5=>H
2[V=<m>ZA`;LZS<01]>Q:NBc:MbZ<nBc7^Bc:LZQ?@;T/c<00nBcAmbZ<mbZ
<`02i;<N00[:XCgT/ajVLP3]aecCZTOLZS?T/dOT/bWT/dO:V1@2i;<c00k]
_SgCV0[LZS?:V1CCQ02`N`[CXBW:XCgT/dO:ZVKL/ec]aecLZS?CXBT2bYPD
01?T/ak:V1C:V1BVLQCfd8C]ahCT/dOT_XCT/dOL/ecCXBWT/c>iSBWLZS?:
V2W:V1C1Q03CV0Z`LP000[1k2P0:WUhDNd`:Nd`DJT4:H2l:4BH:8a`:6PT:
2@TD6PT:0Q4L2P052@T:;2HDAT4N8blN2@TD008A70X02`TB2Q4L2PTB2W8h
5:IW08eE2ZI107]<58<h02`V52`L50024A`:00T94PXJ4Q@A9Q@0003L/ecT
_XCLhmKChoGCfMH00]cSh007kNgZg>?PPhAkUJ6>b]3Fg>?Pong<00?fooD0
0hf=D^g]j/c<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^0C<c<`00fIVI/c<c9VIV@0FVIVI01CmoOgkno_oooomo?o[jo?EeN6e
]lJEV:^6R9n=TJbVZl^a]MRg_>;3b?;9d?cKiOo?g_GAh_;DiOGFioL3eNKf
00?FioOEi_KEi_H01]GVmS3EioD8e^Og01WHjOWFioOEi_KEi_KFioOEi_KC
i?CAh?O1bno8dO[<eOk6coRk`^b^/mVNX/NCV;R3QjB?U:Z]/<7Be^7_l_Wk
ooonooonoogoool019VIV@D00004VIVI100000:IVIT200000YVIV@800002
VIVI1@0000:IVIT2000000>IVIT0000000001YVIV@@00002VIVI0P0000BI
VIT00`0006IVVLc<o`03c<co00L0003<c?l0003<c?l0003<c?l000000/c<
o`050000c<coc<coc<co000000;<c?l01@000<c<olc<olc<o`000002c<co
00D0003<c?o<c?o<c?l000001Lc<o`030000c<coc<co00C<c?l00`000<c<
olc<o`04c<co00@0003<c?o<c?l00003c<co00<0003<c?o<c?l0;<c<o`03
IVJIc<c<c<c<04C<c<`08Iib59iN59EE59EE08<h08=107]<58eE2YEE08eE
2[1k5:Ib5;1k5:IW0;1k2ZIb09ib2[1k2ZIb09EE02`h:JIb5:Ib0;1k2X=1
0=>Q:LZZAlZH5<ZH:K2=7Yj=:KV45<ZH5002^HdD00niQ1BiSABiQ1B`LP2`
NaCCV0Z`SAjiSC?:V1C:ZTO:V2W:XCfiQ1C:V2ViQ1@00/ZH:@06diP:/8dN
bYPD/8dcWXdci;j40]bcG00<djY7dj4YdjY7g:XcbYPDbZ5Bdj4Yg:XcbYPD
djY7bYPDi;<Y0/ZH5003bYPYbYPDg:Xc00;CXBT00lZH5=>Q:M>Q:@03dj4Y
00?CZTNiQ1CCXBT00]bZ<`06i;=7g:Xcdj4Ydj4YdiP:/8dN0lZH:@09djY7
g;>4g;=Lg;=Li;j4g;=Li;=7i;j4kM2H00?T_X@5kM2H00WC_XkCZTOLZS?C
ZTOL/ecLZS?CXBWCZTOCXBT00lZH500<djY7g:Xcg:Xcg:Xcdj4Yg:Xci;<c
bZ5Bi;<ci;<NbZ4mkKhm0]bZ<`0Gdj4Yg:Xci;<Ni;<NSED:g;=Li:X0g:Xc
i;<cg:Xci;=7g:Xci;<cbYPDi;<YbYPDi;<Ydh@0`H@0^FL0bYPYbZ4mkLML
00;T/dL01MbcG<ZQ?MbZ<m>H2^BZ0002bYPD00GCV0ZNGQC]ahCL/ec:ZVH0
0]bcG004i;=7bZ4mdjY7bYPD0]>Q:@08bYPYdiP:^H@D/780/7/:YW8DUEDD
Nd400W8h0005ARHD;1804BH:2A8:4A`:00<92@X010TB2QXV53@_7R<V2P8A
70X01PT92PTB2QX92QXB55LL0:Ib50:=E@X03W]<2W8h02`V52<V2R<L2Q4L
2QX92Q4L2QXB50T92/ZZAlZZI/[@`M?IeP?Lhn001^gfmMcSh8>=Q8f=Kl77
c=cSeP;fooD01=cSe/[@`CAE:Ng]jV7<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01JIVIT04oonooomo_on
ooWhoN7QjlG7e:BW^X:6WhfB/8fA]:2TbZbafKVnj<C9ll;7lLS@mLOCkLWH
kLkMlP02dN3e0]3Om003d=obd=odd=ob00O@go803]3Pl=3Ol]3Pl=3Ol]3P
l=3Ol]3Pl=3Ol]3Pl=3Ol]3Pl=3Ol]3Pl=3OlQ?@h?003=3Ol]3Pl=3Ol]3P
l=3Ol]3Pl=3Ol]3Pl=3Ol]3Pl=3Ol]3Pl0;@go82cmka01o?g_??g_7?g_??
g_7?g_??g_7?g_??g_7?g_?Ah??Ch_OAh??<fo38e_3Cfoo6cO^ma?2naNnj
`N^Y/MRGW<:<T[J8S:n<TJnQYKk4amSTi_;fmo_lo?cooo_oool019VIV@80
0002VIVI0P0000:IVIT200000YVIV@8000000iVIV@0000000002VIVI0P00
0003VIVI0000000000:IVIT2000000BIVIT00000002IVIT300001IVIV@80
0002VIVI0P000003VIVI0000000000>IVIT2000000=VIYW<c?o<c?l00/c<
o`070000c<co0000c<co0000c<co000000;<c?l01@000<c<olc<olc<o`00
0002c<co00D0003<c?o<c?o<c?l000000lc<o`@00005c<co00<0003<c?o<
c?l01<c<o`040000c<coc<coc<co0`0000C<c?l40000;/c<o`03IVJIc<c<
c<c<04C<c<`01:Ib59ib59ib2ZIW009kC1@019EE08=107]<59iN50:VLQ@0
1JIb09iN5:Ib09ib2[1b0002YVL000^`LP2EE@2VLP2`N`ZVLP23GQC:V2W:
ZTO:XCg:ZTO:XCd00kV=:@0A^H@D^HdD^H@DbYPD^H@D/780^HdD/8@Y/8dN
`H@0^Hdc^IQL/8dNdj4Y^H@DbZ4m^H@D00?:V1@01L640;2=7[24:JJ4D^g7
G002g;=L0]>ZA`03dj4YbYPYbZ4m00;LZS<03<ZH:LZH5<ZH5<ZH5>BcAlZH
5;2=7/ZH5<ZQ?M>ZAmbZ<m>Q:@?:V1@01m>H2/ZH5<ZH:M>ZAk2=7/ZQ?LZH
5002dj4Y013:XCgCXBW:V1BiQ1C1Q02NLS>iQ2WCXBWCZTOL/ecCZTOCXBW:
XCgL/ecT/dOC_Xh2i;j400?]d9SL/hC]d9P00^g@V00:kLN4kM2HkM2HbYPD
i;j4g;=LbZYVdj4Yg;=LdjY71M>Q:@08bYPDi;=7g:Xcdj4Yg:Xci;<cg:Xc
djY70nBc<`03i;<Yg:Xcg:Xc00;LZS<03>Bc:K1k2^BcAnBcAmbcG>Bc<m>Z
AnBcAnBc<nBc:M>H2^Bc7P?:V1@02[1k2]>40=>40=bZ<m>ZAmbcG>BcAm>Z
AmbZ<m>H2P?:V1@01]>40=>H2ZIW0>BnQ>g7G>BnQ0CL/e`00m>ZAlZH5=>Q
:@02dj4Y00NiI`2iSAB`LP2`N`ZVLQB3GQAZ@@X00W]<2P0TEa`08bH:8a`:
6PT:4A`:2@T:2A8:4A`:6PT:8a`:=2lN8bH:4A`:6PT:4A`:2@T:4A`:2@T:
?A8:YW8DPd40Nd`DLSP0LSPD?A8:8a`:4A`:6PT:2A8:4A`:6PT:0000WUhD
kM2Hg;>Sb]3F0]?IeP;LhmH02>C@c<6cSVYW<iFQSZJQV7^=Q3eN?@TB2P80
00000oKoolc<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^0C<c<`00fIVI/c<c9VIV@0FVIVI017oo?oooOoooOofmO_Ti?2n
`MBHW[Q]LiElPjf:TKnIWm6VZ]Z^/^6h^nK0`^W2a^W7d>l00/G@k006am;^
bmKbc=OcbmKbb=C^b]Ga2<[Fl00>b]K^b]K`b]K^b]K`b]K^b]K`b]K^b]K`
b]K^b]K`b]K^b]K`b]K^b]K`4l[FkP0<b]K`b]K^b]K`b]K^b]K`b]K^bmOa
bmO_bmOabmO_bmOabmO_1<_Gl@0ObmKbbmOabmKbbmOabmKbbmOabMC`b]K`
bmKbc=Sbc=Ocb]K`b=?_b=7ba/WfaLOh_l;_][_U[KGLYJgDV:7:S9FnOXFa
KW>MVIg2`<7Ogmk`m??ioOcjooojooom00BIVIT200000iVIV@8000000iVI
V@0000000002VIVI0P000003VIVI0000000000:IVIT2000000>IVIT00000
00000YVIV@8000000iVIV@0000000002VIVI0P0000BIVIT200001YVIV@80
0003VIVI0P000003IVJIc<coc<co00;<c?l01`000<c<o`000<c<o`000<c<
o`000002c<co00D0003<c?o<c?o<c?l000000/c<o`050000c<coc<coc<co
000000K<c?l00`000<c<olc<o`03c<co00<0003<c?o<c?l01<c<o`040000
c<coc<co00002/c<o`030000c<coc<co02c<c?l00fIVVLc<c<c<c014c<c<
00JNLQBVC02=E@ZNGQAkC1Ab>1@3SED:00^EE@2`N`ZNLPZ`SC>NLPZ`LP2N
LPZVLP2NLPZVI`2NLPX00ZIW0005/780WW8:WW8:bZ4mdj4Y00C:XCd2^HdY
0[V4500@/780^HdD`H@0/780/7/D`H@0/8dN^H@DdiP:bZ5BbYPDbZ4m^FL0
bYPYbYPD^Hdc0lZH5007^Hdc^H@DWXdYg;=Li;j4g;=Li;=700;CZTL2g:Xc
00?:V2WCZTOCXBT01LZH5005^HdYbYPYdj4YdjY7g:Xc00;CXBT02nBZ0<ZH
5<ZH:LZH5=>H2/ZH5:Ib5<ZH5;1k2[V45<ZH5002`H@000N`SAj`LP2VC02=
E@[1Q03:XCgCZTL00]>Q:@03bYPDdj4Yg;=L00;L/e`01>g@V>BnQ>g@V?KI
IP?]d9P03ngIc>g@V=bcQ=>ZAlZZI]>Q:NBcAmbZ<m>Q:MbZ<m>Q:KV=<m>4
0<ZH5=>H2P04g:Xc00[T/c?L/ecLZS?LZS?:XCgCXBWT/bWLZS?T/c?TZP02
g:Xc013T/ajVLP3L/ecLZS?T/dOCZTOT/c?T/dO:XCgT/c?CXBWT/c?CXBWL
ZS?CQ031Q002/7/:00GCXBWT/c?CZTOL/ecCZTL00]>Q:@?:V1@2diP:00B`
LP3L/ecL/ecT/c<3i;=700WCZTOL/ecCXBW:V2WCXBWCZTOCV0[1Q02`LP00
0iib2P04LSP0JT4:LSPDARl:0R<L2P032@T:4A`:2A8:00892@X01a4L2QX9
2TI17R<_7Q4L2PT92Q4L2P022@T:01TJ2@XJ4QBVC01b>01P;`Y69PYP;`Xm
70XA70XJ2@XA70XJ4Q@92@XA70X92@YG703T/bVVXFKLhn3:d<7LhmKCfMK1
/jfEXHhmGSd01@0000044A`:6Q8D0000m_KeHLc<c004IVIVR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT05YVIV@0Ioo_o
oocooogon?Gngn7^_/?IQH^[K7>MNh>dR8o5UicDX:GLZ:cL/;?N]kWO^[gP
`<KZ_LGY_LGZ`<S/`l_`a/kbaLgaa<g^a<c`00;4cNh05<C=k<C=k/C=k<C=
k/C=k<C=k/C=k<C=k/C=k<C=k/C=k<C=k/C=k<C=k/C=k<C=k/C=k<C=k/C=
k<C=kP;4cN`03LC=j/C=k<C=j/C=k<C=j/C=k<C=j/C=k<C=j/C=k<C=j/C=
k<C=jP04a<g/00c4cNk4cNc4cNk4cNc4cNk4cNc5c^o5c^g5c^o5c^g5c^o5
c^d4aLk_01o5cO75c^o5cO75c^o5cO75c^o4c?35c^o5cO75c^o4c?32bnc0
b>c0aN_0`?:n__2h^nR`]MnX/=NOZ=6BW/R7T/1oQkQZL:20Pk2m_N7ShOOm
o?ooo__lnO;oood019VIV@800003VIVI0P000003VIVI0000000000:IVIT2
000000>IVIT0000000000YVIV@800002VIVI0P000004VIVI00000000VIVI
0P0000:IVIT2000019VIV@800006VIVI0P0000>IVIT2000000=VIYW<c?o<
c?l00/c<o`070000c<co0000c<co0000c<co000000;<c?l01@000<c<olc<
olc<o`000002c<co0P0000;<c?l010000<c<olc<o`0000?<c?l00`000<c<
olc<o`03c<co00<0003<c?o<c?l01<c<o`040000c<coc<co00000lc<o`04
0000c<coc<co00000lc<o`030000c<coc<co02c<c?l00fIVVLc<c<c<c014
c<c<0Yib2P05LSPDPd40LSP0Nd`DUED000:=E@X01YEE09ib2ZIb0;1k59EE
0:Ib00:VI`000jIb0:IW0:Ib0002/7/D00RNLPZNLQBEE@3L/ec:XCgCZTO:
XE;:XCd2bYPD00RiSAB`SAjiSAB`N`ZiSABiQ1C1Q02iQ1@3^HdD00k:V2W:
XCfiSABiV5b`SAk:V2ViSBW:V1C:V2W:V1CCV0[:V1BiSBV=SDL2g;=L017L
/hC:ZVKCZTOL/ec:XCg]_Sg:XCgLZS?CXBViSAC:V1CCV0[:V1C:V2W:V1C:
V2WCZTL00]bZ<`04bYPDdiP:bYPDdiP:0lZH500>g:XcbYPYbYPYbYPY/8dN
^H@D`H@0^HdD`H@0/5D0PcP0^H@D^HdDbYPD0]>Q:@04djY7bZ4mg:Xci;=7
0]bcG006kLMLi;j4kM2Hi;j4kM2Hg<NS0ng@V006g<NSbYPYi;=7djY7i;=7
dj4Y0]bZ<`05i;<YbYPD/7/:bYPDdj4Y00;LZS<02]bcG<ZQ?MbZ<mbZ<nBZ
0=bZ<nBc7^Bc<m>ZAnBZ00;LZS<02=bcG>Bc:MbZ<k1k2]bZ<m>ZAnBc<lZQ
?@;T/dL00m>ZAnBc<lZH5002dj4Y00S:V1C:XCgCV0ZiI`31Q03:V1CCZTOL
ZS<2i;=700CCV0[:V1C:V1CCV0X2dh@000G:V1B`N`[:XCgL/ec]ah@00]bc
G00Ai;=7g:Xcg:Xcg:Xcdj4YdiP:bYPD^H@D^HdD^FL0WW8:/7/:SED:Nd`:
LSP0Nd40Ea`0008S70X0114L2QX92Q4L2PT92P894PX00a4L2R`V52`V5002
4A`:0PT92P084A`:6PT:2@T:SED:Pbl0H2l:H2lDEa`00R<L2P036Q8D6PT:
4A`:00892@X0214L2PT92R`B03@_7Xf=Kg:=G14V514V2P8000002PT92Q4L
2PT950TB2QXB514V51XL7QX92P000?Koof7<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVc<c<VIVI01JIVIT06Ooko?om
oOomooSgom_Mk<75gVY`TVedX7Mn]8:;a96GdIZOej6TejR[f:naek2dfKBi
hK6hh[:iiKBkiKRojk_2k;c3kKc4jk_2k002^l?Z01Bk`nRk`nZk`nRk`nZk
`nRk`nZk`nRk`nZk`nRk`nZk`nRk`nZk`nRk`nZk`nRk`nZk`nRk`nZk`nRk
`nX2^l?X00fk`nNk`nRk`nNk`nRk`nNk`nRk`nNk`nRk`nNk`nRk`nNk`nRk
`nL01;_3j00<^l?Z^l?X^l?Z^l?X^l?Z^l?X^l?Z^l?X^l?Z^l?X^l?Z^l?X
1;_3jP0O^l;/^l?Z^l;/^l?Z^l;/^l?Z^l;/^l?Z^l;/^l?Z^L3Z][kU];_U
];WS]KOX]KGW[k;OZ:cIXJSBVJ;=S9O5PXboNH2fJFnSIVZG_/7Th>7foOco
ookknoSaooom00BIVIT200000iVIV@8000000iVIV@0000000002VIVI0P00
0003VIVI0000000000:IVIT200000iVIV@@000000iVIV@0000000002VIVI
0P0000BIVIT200001YVIV@800003VIVI0P000003IVJIc<coc<co00;<c?l2
00000lc<o`800003c<co0`0000?<c?l010000<c<o`00000000C<c?l30000
1/c<o`030000c<coc<co00C<c?l010000<c<olc<olc<o`<00004c<co0`00
02o<c?l00fIVVLc<c<c<c014c<c<0ZIb500;SED:Nd`:Pd40Pd40UED0PcP0
UEhcUED0SED:YT`0YW8D00:EE@001ZI<0:Ib0:IW0:IW0;1k2Yib2P:VLP00
0iib2Yib5<ZZA`02bZY700WCZTO:ZTO:V2ViSBViSAC1Q02iQ1B`N`[:V1@0
0[V4500D^FL0bYPD^H@D^HdD^HdcbZYV`H@0g:Xc/8dc/8dNbYPYbYPD^HdY
bYPD`H@0/8dN^HdYPg/ckLMLg;>40mbcG0;CZTL00m>Q:MbZ<mbZ<`03bYPD
00[:V2WCXBW:V1BiSBV`SAk:XCgCXBWL/ecLZS?TZP02bYPD00KCXBW:V1C:
XCgCXBViQ2W:XCd2bYPY00W:V1CCXBW:V1C1Q02`E@2VLQBEEABNLP[LZS<0
0]>ZA`0:bYPYg:XcdjY7g:Xcg;=Li;j4g;>4i;j4kM2Hi;j41^g@V00=bYPD
g;=Ldj4Yg;=Ldj4Yg:Xcdj4YbYPDbZ4mbYPDdj4YdjY7dj4Y00OLZS<00nBc
:LZQ?NBc<`05g:Xc00SCXBViSAC:V2WCZTOT/dOT/c?L/ecT/dL2g:Xc00KC
XBWT/bWCXBWTZP3CV0[CXBT2`H@001ViQ1C:XCgT/c?:XE;L/ec:XCgCXBW:
V1C1Q03CXBW:V1CCV0[1Q02iSC?T/dOL/ec]ahC]aec:ZVKT/dO:XE;CXBV`
SAkCXBW:V1@00/64000O/780YW80WW8:SED:Nd`:LSP0JT4:ARl:8bH:8a`:
6PT:2@T:6PT:2A8:2@T:4A`:2@T:AT4N8blN4A`:2A8:4A`:2@TD4A`:2@T:
4A`:YT`0Nd`:LRH0Ea`0H2l:008S70X02Cd_?@T92QX92PT92Q4L2PT92Q4L
2PTB2PT9500300000QXB50032@T:4BHD6PT:00@J4Q@0114L2QXB50000?Ko
of7<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003
IVIVc<c<VIVI01JIVIT04Ookn?onnoonoo_jom[LjlG9hU5FO6UaX75g/Gb4
`X^Aci>IdiZPe:>WeZV]dj^_eJb`g@02Z[3P00F//^:^]>Ba]nNc^^Rd^nT0
0[>jj1Jc^^H03[Flj;Fli[Flj;Fli[Flj;Fli[Flj;Fli[Flj;Fli[Flj;Fl
i[Flj;FliP:e_>P8/k[V2;:ii@bb^NL01;2giJjehjbchJfah0:/[]h03jN[
fYnVdYZRd9BLbhRBaGj7_Vie[6U^YEMKR/G8jm[Kl??cnooonooon?ooo@04
VIVI0P0000>IVIT200000YVIV@030000VIVIVIVI008000001IVIV@000000
000009VIV@02000000>IVIT0002IVIT00YVIV@8000000iVIV@0000000002
VIVI0P0000BIVIT200001YVIV@800003VIVI0P000003IVJIc<coc<co00;<
c?l200000lc<o`80000Jc<co00<0003<c?o<c?l0@Lc<o`03IVJIc<c<c<c<
04C<c<`01;2=7ZIb59EE08eE2P>3@@003HeE2YEE08=109EE08eE2ZIW08eE
2[1E09EE0:Ib09EE0:IW0;1b0002YW800Yib2P0<SED:bZ5Bg:XcbZ4mbZ5B
djY7bYPYbYPD^HdD^H@D^HdD^H@D0[V=500>`H@0/7/:^HdD^H@DbYPDbYPY
djY7^H@DbYPY/8@Y/8dNbYPY^HdDbYPD0/64000:/8dN^HdYWXdYdkj>g;>4
dkj>g;=LdjY7g;=LdjY70/ZQ?@0@g:XcbYPYbYPDbYPDdiP:bYPDbYPYdiP:
bYPYbZY7i;=7djY7bYPDdj4YbYPDdiP:0lZH5004bZY7^HdYbZ4mbYPD0]>Q
:@09djY7diP:dj4YYW8DNd`DWUhD/8@YdjY7g;=L00;CZTL2g:Xc00?T/dOL
/ecL/e`00ng@V003kLMLg;j]kM2H00;]d9P02Mc7Xng@V;V=:MbcG=>Q:MbZ
<m>ZAnBc<mbZ<`02dj4Y00K:V1CLZS>iI`3L/ecT/c?LZS<2dj4Y01;T/bWL
ZS?LZS?T/dOCZTOT/c?LZS?T/c?LZS?L/ecLZS?T/akCV0Z`Q2WT/c?LZS?:
XCgL/e`2i;=700GT/bWLZS?CXBWCXBWCV0X00/ZH5009diP:^FL0bYPYbZ4m
bYPDi;<cg;=LdjY7dj4Y00;:V1@02nBcAnBc7]>40<ZH5<ZH:MbcG=bZ<lZQ
D/ZQ?Nfn?NBcA`02g:Xc0]>Q:@04bYPDdiP:/7/:`H@00ZIb0005LSPDNd`:
JT4:LSP0ARl:008S70X24A`:00<000092@XA70X00PT92P0@AUDYARl:6Q8D
4BHD2@T:4A`:00006Q8D2@T:YT`0H2lDSED:?A8:H2l:6PT:;1800Q4L2P89
2@X02PTB2PT92PT92PTB2Q4L2PT950TB2QXB50T92QXV508J4Q@010T92PT9
51XB514L2P8A9Qh00aXB50000?Koo`1Qc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0FVIVI01;oo?Kooo[n
o?glo?oMh>o:d>Y4BG5PIi]/L[1gOl24S<f>U=:DVM2MXM6RYlnUZ]:UZm^V
[>02YjgQ00>X[^:Z/>B[/N<00jbbi1J//^82[K?S00j]/nF]/n>]/nF]/n>]
/nF]/n>]/nF]/n>]/nF]/n>]/nF]/n>]/nF]/n<8[;;R2:^ah@b[/N<01:Z`
hZV_hJR^h:R^gP:UZMP03j6Ue9ZQciBLcHfGc8:;a7R1_6Y`[69WWdY>OLS<
kmcNlo;bn_oonooon?ooo@04VIVI0P0000>IVIT200000YVIV@@00002VIVI
0P000003VIVI0000000000>IVIT400000YVIV@800002VIVI0P0000BIVIT2
00001YVIV@@0000019VIV@00000006IVV@C<c?l00`000<c<olc<o`03c<co
00<0003<c?o<c?l06<c<o`030000c<coc<co00C<c?l00`000<c<olc<o`0j
c<co00=VIYW<c<c<c<`0A<c<c004YW8D/7/YSED:SED:0X=10005SED:Pd40
SED:PcP0Pd4000>=E@X029EE09iN5:IW09EE0:IW0:Ib0;1k2ZIb00:`N`X0
1Yib5=bZ<lZQ?LZH:LZH5=>ZA`:iSC<2/8dN00FiSAB`NaC:V1B`N`[1Q000
0[V4500C^HdD/8dNbYPYbZ5B/8@YbYPD^H@D^HdD`H@0bYPD^HdDbYPDdiP:
^HdD/8dNPehDi;j4g;=Ldkj>00?L/e`00m>ZAlZH5<ZQDP02bZ4m0/ZH5007
dj4YbYPDbYPD^HdYbYPDbZ5Bg;=L00;CZTL2diP:00?CXBW:V1C:V1@00/ZH
500?^HdDbYPYbYPYbYPYg:XcdjY7bYPYi;<N^H@DbZY7/7/Y/8@Yi;=7g;=L
djY700;LZS<00lZQ?MbcG=bcG003g;=L00G]d9SL/ec]d9ST_XCLaj<00ng@
V004/8dNg;=LbZ4mbZ5B0/ZQ?@08dj4Yi;<YbYPDbYPDdj4YbZ4mi;<Yg;=L
0mbZ<`?CXBT01^Bc7]>Q:MbZ<nBcAmbZ<mbcG0?LZS<03/ZH5;2=7]bcG=bc
G>Bc7^BcAmbZ<nBcAlZH5>BZ0=>Q:MbZ<lZH5>Bc7PC:V1@00m>Q:M>ZAlZQ
?@02djY70/ZH500<diP:bZ4mdj4YbYPD`H@0^H@Yg;=LkLN4bZ4mi;=7djY7
g;>40]bcG0;CZTL02mbZ<lZH5<640;1b0;1k2Yib2X=108eE2W]106Y12V0_
2P028a`:0PT92P034A`:2A8:6Q8D00892@X02THV53@_:AXV51X92Q4L2PT9
2Q4L2PT92P0009EE50:3;`001V0_2THV2R<L2Q4L2QX92PTB2P8A70X05@T9
2Q4L2QX92QXB50TB2QXB50TB2QXB514V7PTB2QXB50TL514L2Q4V50T92PT9
50T92QX92QXL7V11:M?Sm@1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VIV@0FVIVI01?oo_GoooSlo?[noooV
jOS?eNm6BgECFHeUJZY`Mk]mQ<R4S<^:TLRAUlVHWLNJWlVNY=BPY]ZRZ=`0
0j>Yg@04Y:[LYJ_MYJ_MYJ_M5ZF[fa2SZM/@YJ_K2ZF[g@>TZ]`2XjWK01:S
ZMVNX/nKX/jGW/b@V<V:U<V4SLIiPKm_MkEWKJ]DFi92AWG:c_7Yk?ohnoon
oo_ko?Coood4VIVI0P0000:IVIT200008YVIV@800002VIVI0P0000RIVIT0
0fIVVLc<olc<o`1Wc<co00=VIYW<c<c<c<`0A<c<c004YW8D/8dNNd`:Nd`D
1H=1000@SED:Pbl0LRH0Nd`:Pd40SED:UED0WUhDYVL0/780YW80/780/7/:
YW80WW8:UED00/ZZA`;:XCd04]bcG<ZH:LZQ?K2=7[V=5;V=:L640<ZH5<64
0;2=7[1b0<640;1k2[V=5;V45<ZZAk1k5<ZQ?@:iSA@03LZH:K2=7[V=5;V=
<l640;V45;2=7X=k<ng7G=bcQ=>nS]bcQ=bcG002djY70mbZ<`05bYPYbYPD
^HdDbYPD/8dN00;:V1@02<ZH:M>ZAmbcG=bcG=bZ<m>Q:LZH5=>H2P;:V1@0
1m>H2/ZH5;V45<ZH:MbZ<m>ZAm>Q:@04g:Xc00B`SC?:XE;CXBWCXBT2djY7
00?CXBWLZS?CZTL01=bcG003g;>4i;j4i;=700;T_X@02>g7G>g@V>g@V>g@
V;V=5<ZQ?M>Q:LZH:@CCXBT3bYPD00GLZS?CZTOT/c?L/ecCXBT00]bZ<`04
i;<YbYPDg:XcbZ5B0]bZ<`03i;=7g;=Lg:Xc00;LZS<02^BZ0;1k2]bcG=bZ
<m>Q:MbcG>Bc:NBcAnBc:M>Q:@;T/bT03M>Q:LZH5<ZH5<ZH5<ZH:M>40<ZH
5>Bc:M>ZAmbcQ=bcG=bZ<lZH5003`H@00]>40003^H@DkKhmkM2H00;L/e`2
i;=70]bcG007dj4Yi;=7g:Xcg:XcdiP:^FL0/78000:=E@X01W]<2V11578h
04H_2R<L2R`B008A70X52@T:00i6EBTd;ahS9PXJ71h92@XJ4Q@94PXA70X9
2AB3;`23>01b9P1P;aAG70028a`:0QX92P092@T:2A8:2A8:2A8:4A`:2@TD
2A8:2@TD6Q8D008971@00`TL7PT9500000022@T:00=69QB3Q7^VZZd00]?S
m@03kOKeg>?Pc<c<063<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c003IVIVc<c<VIVI01JIVIT04ooom?oomo_knOcoonobomCJ
m4mDOTE;OeQMWFEZ[W1g_GR0`Gn5_hJ=`HbC_hnF`9FIb9VMcIfQd@02Wj?C
00>NX]:OXm:PY=<00Z2TdaJPY=400ijRdIjRdYjRdP0<WZ;B00>NX]6PY=6P
Y=403Z2Td@RPY=<2XJGD00>PY=>OXm:NX]400YfQd00BWJ7>Ti[4TYW3SYC4
QXg1OhRoN86lKGFdHVZYFV2NADb3BDejdMKfloSonokonogho?ofooom19VI
V@D0000TVIVI100000VIVIT00fIVVLc<olc<o`1Wc<co00=VIYW<c<c<c<`0
A<c<c005/8@Y/7/YUED0WW8:LSP000:=E@X05iEE08eE2X<h060_2ULL060_
58=109iN59ib2[1k2ZIb09ib2[1b0;V=5:Ib0;1k2ZIb5:Ib0<ZZI/ZZAlZH
:LZQ?LZZIP02bYPY00NiSBViSAC:V1BiQ1BiSAC1Q02iI`000[1k2P09^H@D
^HdD^HdYdjY7^H@DbZ4m^H@D`H@0bYPD00;:V2T02M>H2[2=7[2=7/ZQ?FY1
2]bcG<ZZI]bcG>g7G002g;=L00gCZTOLZS?CZTOCXBW:V2W1Q03CV0[:V1C:
V2W:V1C:V2W:V1C:ZTL00]>ZA`07i;<NbYPDbYPDbYPDdj4YdiP:bYPD00;:
XCd00lZH5=>Q:M>Q:@02dj4Y00OCZTOLZS?LZS?:V1BiSC?:V2W:V1@00]>Z
A`;:XCd2g;=L017LZS?:ZTOL/ecL/hCT_XCCZTO]ahCT_XCL/hC]d9ST_XC]
d9RVLQCLZS?:V1C:V2W:V1@01M>Q:@05bYPDbZ4mg;=Lg;=Li;=700?LZS<0
1lZH5=>Q:MbZ<mbZ<nBc:MbZ<nBc<`03g:Xc00CT/akL/ebEEACT/dL2g:Xc
00WT/dOLZS?L/ecCXBWT/ak:V1CT/c?:V1CT/bT00/ZH500:^H@DbYPDdj4Y
bZ5Bi;<cbZYVg;=Lg:Xcdj4Ydh@00]>H2P;:V1@02[1k2_K@Q>BcAm>ZAng7
G>fn?MbcG>BcAnfn?NBcA`;L/e`03=bZ<l640<640:IW09ib2X=N58eE2W]<
2W8h061152<V2SdL2P8J2@X0214L2PTB2Q4L2Q4L2PTB2V1154I17R<_7P8A
70X01PT92PTB2QX92PTB2X<_08eE2P:3;`000g8h52`B02`L50024A`:01L/
71@92@X92@XJ4Q@92A@A9Q@971@A70X92A@92@X92AA69QAbLW^3SHA6Iec:
d=KChoGfooo]m_Gfooo]m_GfoooCfMH0HLc<c004IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT05YVIV@0Cooodo_og
n_cgo?oomOSoem_fF5f5?49dC52?FEjPIfb`KgNhN7jhP8NkR8nkRi:lS96k
TIK0Uic600:KX<X00iZObIZOai^Pb002VYo75IZOa@03VYo7W:7;W:7;00jL
XL/00iZOaiZOaIZOa@05VYo529^PaPRKX<P01IfRbYbQbI^Pb9VNaYNLa002
UY_301:EV/:=UKb<Tkf6S[enQKUfOkQ_MkETK:eKH:1:D8`m@gMGG8KKh?gh
o_oen_kfnoGnoo[ooodjVIVI00=VIYW<c?o<c?l0Ilc<o`03IVJIc<c<c<c<
04C<c<`01kV=:KV=<iib5:Ib59EE58eE2YEE0002SED:00N3@@1P;`Xm4PY6
9PZ3;`2NGQBVI`000ZIb00:`N`X03<640;1b0;1b0;1k2ZIb0;VZKmbZ<lZQ
?LZH:LZQ?MbZ<kV=:@:`SAh02;V=5<640;V=5;2=7[V=5<640;1b0<6400:i
SA@03/ZQ?KV45<ZQ?KV=5;V=<lZH:KV=:L640<ZH5=>H2[V=5<6406YE7_KI
IP?L/e`01=>nS]bcG=bcG=>ZA`;:V2T2bYPD00O1Q03:V1C:V1C1Q02iSC?:
V1C:ZTL00]bcG003bYPDdiP:diP:00;:V1@2diP:01S:XCfiSC?:V2W:V2WC
ZTOCXBWCZTOLZS?:V2WCXBViSBW:V1C1Q03:V1C:V2WCXBW:XE;LZS?CZTOL
/ec]d9RiSBW:ZVK]d9P3djY700SL/ecCZTOL/ecT_XC]d9RNLQC:XCg:V1@3
dj4Y00W:V1CCXBWCXBW:V1CCXBWLZS?L/ecT/dOT/c<00]bZ<`?CXBT01NBc
7]>Q:NBc7]bZ<nBcA`02g:Xc00[T/bWLZS?T/aj=E@[]_SgLZS?CXBWT/c?L
ZS?T/dL3dj4Y00?T/c?:V1C:V1@00]>Q:@0ObYPDdj4YbYPDi;<ci;=7djY7
kM2Hg;=LbYPDdiP:`H@0dh@0diP:bYPD/7/:kM2HkLMLi;j4g;=Li;j4kM2H
g;=LkLN4g;=Lg;>4^Hdcg;=LbYPDYW80YVL0UED000:=E@X01G]106Y12TH_
2SdL2R<L2P024A`:00P92@XJ2@XA70X92@X94PXS;aiPGS<S9PX24A`:00L9
2@XJ4Q@94PX92@Yb>1BVC01b>1@00V0_2P04?A`:8a`:;1806PT:114L2P05
0000?A`:6PT:4A`:WXAV00;CfMH03?KoongfmOKoog:=[IFQ]jK7h=?Ie^gf
mOKoongfmOKoomcSh67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c003IVIVc<c<VIVI01JIVIT05_[llOoon?konoOko__ooo3e
oh24ZCa0KdY?RD98QUYOWg1f]7Qn^8V@a9RPcYfTcYjSbJBZcZR^dZJ/d:F[
cJN]c`:Z/=84Z:k>1:R_c0RW[Ld2YZc<0ZN]c@07Z:k>ZJo?Z[3@Z[3@Z[3B
ZJoAYjg?00:V[<h00jN]cjV_dJZ`dP08Z:k@2:R^cPRW[Ld8Yjg?00FUZlfX
[]2X[]2UZlfTZ/`00ZF[c@0BXjW;UYk3ZK3JRY;1RI34PXS2H6JTFUnOAd^:
=S]cADUhM7ZNm_conOoolOKio?omm?O`ooom>YVIV@03IVJIc<coc<co06O<
c?l00fIVVLc<c<c<c014c<c<012`SAk:XCfVLQBNLQBVI`2NLQBVLQBNLQBN
LPZ3@@1P;aAP;`Y69PYkC0ZEE@2NGQ@2YVL000j`N`Z`LP2`N`ZVLQBVLP2V
LQBNLP[:ZTO:ZVKLZS?:ZTOCZTO:V1C:XCd2/8dN0[V=500IbYPD^HdD^H@D
^H@D/7/:^FL0^H@DbYPYbZ4m^HdYbZ4m^H@Y/8dNbYPYbYPD^HdDbYPDdiP:
`H@0^HdDJT4:kLMLg;=LbZYVm]UV00?L/e`00nBc:LZQ?LZH5002bYPY00o:
V1C:V2W:V1C:V1BiSACCV0[:XE;T/dOCZTO:V2WCXBV`SAkT/akCXBW:V1@0
0/ZQ?@03bYPY^HdDg:Xc00?CXBT02<ZH:M>H2/ZH:KV45<ZH5;V45<ZH5<ZH
:@GCZTL01>g@V<ZZI[V=:KV450:`Na@00kV=5=bcG=bcG002g;=L00?ffFJN
LQCCXBT00]>Q:@05^Hdcg:XcbYPDdj4YbZ4m00;CXBT03LZH5=>ZAm>ZAm>Z
Am>Q:MbZ<lZQ?M>H2]>Q:LZH5>Bc7]>Q:NBc<`04g:Xc00cT/bWT/aikC0[f
fFKLZS?CXBWL/ecT/c?L/ecLZS?T/bW:V1@2dj4Y00GT/bW:V1CCZTNiQ1C:
XCd00m>Q:@0;/8dNg<NSdkj>dj4Y`H@0diP:dh@0bYPDdh@0/7/:kM2H00;L
/e`2i;=700WTZYST_XC]d9SLaj>iSC>iQ1CCZTNiQ1B=E@X00ZIW0008/7/:
PehDNd`DLRH0H2l:8bH:8a`:6PT:10T92P0>4A`:2A8:ARHDH5hc8blN4A`:
4BHD2@T:4A`:6PT:2@T:ARH:YT40SED:0V0_2P03ARH:8a`:8a`:008A70X0
20T92Q4L2PT92PT92]bcG>g@V0000?Kfm@CChoD01NgfmH>H]g^=Q<77c<[@
eP03kOKe00?foooLhn3<c<`0H<c<c004IVIVR<2hR<2hB9280@00000000B8
`;S8h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT05YVIV@0GooohmoSboooko_oo
mOSomo[o^;_J;C1I;S5T>3eeDUJCHVRRPHRoYJgNYJgKWjO>[kGG]KcI^KoO
]kkK][gJ^;oL^L3M00:i`=`00kW0f[W0g;W0fP04^L3J0[_2g00<^l;N^l;L
^l;N^l;L^l;N^l;L]kkJ]kkH^;oK^L3J^L3L^/7K0k_2gP0>^/7M^;oL]kkJ
]kkK^;oK^/7N^l;N^L3M^L3L^L3M^L3L^L3M^L3L^L3M0[W0g00=^L3J^L3L
^L3J^L3L^L3J^L3L^L3J^l;N^l;L^l;N^l;L^l;N^l;L00Bk`]h07k_2gk_2
g[_2gk_2g[_2gk_2g[Nnfk[1gK[1g[Nnf[Jmf[RofkNnfkFkfkNohjR`ej2X
ejJ]hGQn^51DTE=GU3m1NT54MbT/EKg2h?Kkoo;foo_ooocooOkonoooo@0j
VIVIJfIVVDK<c<`01;2=7[VHG9ib2ZIb50:NLQ@03JIb5;V=5:Ib58eE2X=1
08eE2V0_2W8h5:IW0:Ib0:Ib5;1k2[1b0004/7/:00VNLPZEE@3:XE;:ZTO:
XCg:V2W:XE:iSBW:XCd01;V=5004/7/:/8dN^HdDYW800[1k2P08/8dN^HdY
/8dN/8@YbYPY^H@Y/8dN^HdD0/ZH:@05`H@0bYPD`H@0bYPDJUDN00;L/e`2
g;>40]bcG003djY7bZ4mg:Xc00?:V2T03L640<ZH:LZH5=>H2/ZH5<ZH:LZQ
?M>ZAlZQD]bZ<m>Q:LZH5=>Q:@02bYPD00oCXBW:V1BiSBW:V1C:V2WCXBW:
V1CLZS?:V2WCV0[:XCgCV0[:V2W:V1BiQ1@00lZQ?@0:bYPYg:XcdjY7g;>4
^HdcSED:PcP0^HdcbZ5BdjY70]bcG00=dkj>i;j4kM2HYW80djY7bYPYbYPD
dj4YbYPDdj4YbYPDdj4Yg:Xc00;CXBT01=bcG>BcAmbcG<ZQ?@;CXBT03mbZ
<m>Q:NBc<lZH5=>Q:MbcG>Bc:MbZ<m>ZAmbZ<nBc:NBZ07]<5>g7G=>Q:@02
g:Xc00S:XCg]_Sg:V1CCXBW:V1CT/ak:V1CCXBT2^Hdc00WCQ03CXBWCXBWC
XBW:XCfiLS>iSC?T_XC:V1@00/64000KdiP:dh@0bYPD^H@DkLMLg;=Li;j4
i;=7djY7g;=LkLMLg<NSkM2HbYPYdjY7WXdYWUhDSED:UED0WW8:/7/:SED:
Nd`:H2l:ARl:?A`:8bH:00@A70X04PT92Q4L2PT92R<V2V1N<aXV50TB2PT9
2Q4L2PT92Q4L2PT92SdB2XeE2X<h04HV560_55LL008S9PX02QX92PT92Q4L
2PT951XB50000;24NoK]jPTB2^gfm@CChoD01NgfmIFcc7^=Q:Jc`L[@eP02
kOKe00?fooo]m_GCfMH0HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;P4c<c<00=VIVK<c<bIVIT05YVIV@0KoookmoScooomo_oomOKk
o?konogoNWfN=cUR;c5R>CaaHFJMV9kB[;;TYjkL]KgT/kWI^[oL_/?Q_L;O
^l3M_<7N_L;O_L?M_/CN_/CL_/CN00Fna=`2_L?K00bm`mfm`m^m`mfm`m^m
`mfm`m^l`]bl`]Zm`mfna=bna=joaMd3_lGO00jna=jm`]nl`]bl`Mjm`mfn
`n2oaMnn`n2na=jn`n2na=jn`n2na=jn`n02_/CN00fna=bna=jna=bna=jn
a=bna=jna=bm`mfm`m^m`mfm`m^m`mfm`m/01;g3g@0L_L;O_L?M_L;O_L?M
_L;O_L?M_L;O`<KP`<GR_L?M_<7N_/CN_<7N^;oL]koS[kON[[CTYjgQQX_3
Gf6J?d9i9RQK82=<Oh:SlOKon?comocon?cm0_koo@03ooooVIVIVIVI08VI
VIT00oooolc<c<c<c01Mc<c<00J`Q2ViV5b`N`ZNLQBNLPZNLQ@2/7/:00VN
LPZ=E@YZ@@X/4P0S9PZ3;`2=E@Z`N`ZVLP000[1k2P03YW80/7/DYW8000:`
N`X00jIb0<ZQD/ZQDP02g:Xc00W:XE:iSABiSC>iSABiSBViSABiQ1C1Q03:
V1@00[1k2P0;`H@0/7/:/8@Y/8dNbYPY^HdD^Hdc/8dN^H@DbYPDbYPY00?:
V1@01kV=5;V=<eLL0?KII]>nS^BcAmbcQ002g;=L00gCZTOLZS?:XCg:V1C:
XE;:ZTO1Q03CV0Z`SAk1Q02iSC?:V2W:XCd00]>ZA`03dj4YbYPDdiP:00?:
V1@02]>H2/ZH5<ZH5;2=7]bZ<lZQ?L640=>Q:LZH:M>Q:@?:V1@01[V45<ZH
5<ZH:M>Q:M>ZAmbZ<`;:V2T03]bcG9ik<k2=<iEE5<ZH5>g7G=bcG>g@V>Bn
Q>g@V=>nS^gIc9EE0=>Q:@?:V2T02/ZQ?M>Q:LZQ?LZH5=bZ<m>Q:MbZ<nBc
AmbcG>BcA`;LZS<3dj4Y00?:V1CT/bWCV0X00]bZ<`0Ndj4YdjY7i;<Ng:Xc
i;<NPd40m]UVdjY7g:Xci;=7dj4Yg;=LbYPDi;<NdiP:g:XcbYPDi:X0bYPD
dh@0dj4Yi;<c^HdY`H@0dh@0^H@DYT`0bYPY`H@0/7/:0l640004bYPD/780
kLN4i;=70]bcG0;T/dL01LZQ?MbcG=bcG<ZQDW]<2P02H2lD00RiI`31Q02`
LP2`SAikC0Z=E@YP;`YZ@@X28a`:00</4P0A70X92@X00PTB2P0A4A`:2@T:
;2HDAUDY6RHD8a`:6PT:4A`:2@T:4A`:2@TD8a`:UED0PcP0Pd40PcP0H2lD
008m70X00`T92Q4L2PT92P024A`:00L0002ELTO]m_DA9P[foooChoGLhn00
0]?Sm@05kOKeY[?1JW]_/;k1dmWF00C]m_D00mcSh<c<c<c<c01Oc<c<00AV
IVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI/c<c9VI
V@0FVIVI0_ono`0Fn_Wgn?ShoooooOgoo?kok>koDU=b5aU0:biKBTinMWZZ
[;;R/k[X^KkX/kOJ^[oO_/?S_L;R^l3P_<7O_L;P_<7N1Kg2g`>m`md:_<7N
0[g2g`Jn`n001;g2gkc1g[c1g[g2g`:n`n0@_L;O2[c1gP0I_<7O_<7N_<7O
_<7N_<7O_<7N_L;P_lCQ_/?Q_<7N_<7O_L;O^l3N][_K/kWM]KcV/k[XWj;E
OX6fBDZ07R1A9RMCGV62ko7omo_o00;lool01?Wkn_koooSjnOoooh^IVIT0
0oooolc<c<c<c01Mc<c<00Z`SAj`Q2VNLPZNLQBNLPZVI`2VLQBNLPZNGQBE
EA@2?A`:00I69Q@S70ZNGQBEE@2iQ1B`LP02/7/:00j`LP2VLQBVLP2`N`ZE
E@3L/ec:V1C:XE;CZTO:XCg:V2W:XCg1Q02`SAh3^HdD00J`SAk1Q02`LP2`
N`ZiSAC1Q002bZ4m00FiQ1C:V2V`SAjiQ1BiSA@00lZH50;1Q0002<ZH56Y1
2]bcG=bcQ=bcG=bcQ=bcG<ZZIP;CZTL00lZH5<ZH:LZH5002bYPD00W:V2W:
V1C:V1B`SAk:V2W:XCgCZTOLZS?:V2T00/ZH5007diP:bYPDbYPYdiP:bYPD
/8dN^HdY00;CXBT00lZH5=>ZAlZH5003bYPD00g:XCg:V1C:V2W:V2WCZTOL
/ec:XCg:V2W:XCg1Q01P@BV3GS?:ZVH00]bcG00>djY7kM2Hg<NSi;j4kM2H
onf>SED:bYPY^H@YbZ4mbYPYdj4YbYPDg:Xc0]>Q:@03i;<ci;=7djY700;L
/e`00nBc:MbZ<m>ZA`03dj4Y00_LZS?CXBWLZS?T/c?T/akCZTOT/c?LZS?T
/aib>03facd00]bZ<`07djY7g:Xcg;=Lg:XcbZ4mi;<Ni;<c00?:V1@03;V4
5<ZH5;V=<m>40<ZH5;1k2/ZH5>Bc7ZI<08<_0;1E0;UW00;1Q0002M>H2[1k
2^g7Q=>ZAnBcAm>ZAlZQ?MbcG<ZH5002bZ4m00[:V2V3;`1kC1B3;`3:XCf`
SAj`LP2iSAAkC1Ak@@02JT4:00DS70Xd;bTS70XJ2@XA70X00PT92P0E2A8:
2@T:6RHDAUDY8blN4BH:2@T:2@TD4A`:2@T:6Q8D6PT:WUhDUD`YSED:Pbl0
H2l:ARH:AT4N4A`:6PT:008A70X01@T9514L2SdL2/Zn[DI17P04dn?e00KL
hn3]m_FVan1PLW^`/kOCfMH2kOKe00?fooo]m_GLhn00HLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<0VIVIP03c<c<VIVIVIVI
01BIVIT04_cgoOomoooloOonoooooOooon[Ykokmoocmoc<dDRDWCDmBOFAW
U9FIb9JJbJjbgjV/eK2dfP:e^Ml00kBhg[Fig[Jjg`02]KWN1;Fig0>e^]X8
]k_N1;Fig0Jf^]d4]KWL0[JjgA2e^M`:]k_N01ng^n2g^mjg^n2g^mjg^n2g
^mjd^=ff^]fe^Mjc]mZd^=fe^Mba]MZ//=FX[M>UZ]BX[=^4Q[M:C7l_<60/
;ETd=5KemOokoOoioOonoooinoSooogknogmoOooool0RiVIV@03ooooc<c<
c<c<05g<c<`00k1k59ik<iib2P03WW8:016VI`2`SAjNLPZ=E@Xm70XS70XJ
9Q@/71B3@@2NLQB`SAj`LP2VLQB`N`Z`LP2`N`Z`LP000Yib2P07bZ4mbZ5B
bYPYbYPYbZ4m^HdYbYPY00BiSA@00l640;V=5;V=5002/78000V`NaBiSBV`
SAk:ZTN`Q2ViSC>`NaB`SAjiSC<00[2=7P07bYPD^HdD^HdDbYPDARl:kLML
g;>400KL/e`2g:Xc00G:XCg:V1BiSAC:V1B`SAh00lZH5003bYPYbZ4mbZ4m
00;CXBT01LZH5=>Q:LZH5<ZH5<ZQ?@02bYPD00J`SAk:V2WCZTO:V1C:XCg:
V2T3bYPD01RiSC?CV0[:V1C:XCg:XE;L/ec:V2WLZS?CXBViSABiQ2VNLQBN
Nc?]ahCLaj?LZS?T_XCL/ec]d9SL/hCohhj3GQBiQ1BiI`02bYPD00RiSC?:
V1C:V1CCXBWLZS?:XE;:XCgT/c<2i;=700OLZS?CZTOLZS?LZS?CXBWT/akC
XBT00mbZ<`08dj4YbZYVg:Xcg:Xci;<NSED:kLMLdj4Y0]bZ<`05dj4Yg:Xc
dj4Yi:X0^Hdc00C:V1@00kUW0;1k2/640002`H@000N`N`Z`E@2=E@Z3;`23
>02VC02`C0000/64000<bYPD^FL0g;=Lg:Xcg;=Lg:XcbYPDdj4Y^HdcbYPY
^H@DWUhD0[1k2P09g:Xc^HdY^HdD^H@D/7/:Nd`DPehDH2l:LRH0008S70X0
0a4V2QXV51XB50024A`:00D92@X94PX/9QAP@A@S;ah00a4L2P082@T:4A`:
2@TD4BHDYT`0Nd`DLSPDJT4:0W8h500=ARH:8a`:4A`:6Q8D2@T:4A`:2@TD
2A8:Pg/cH5hcm_ooY/OPg>?P00;ChoD01]cSh<[@eVYkKiFZ[M?Ie]?Sm@;]
m_D00oKfmMcSh<c<c01Pc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^0C<c<`016IVI_ooofIVI/c<c1FIVIT06?olooojooomooonoOch
mOoono7_l?onono^o?cmode>KA<E>dE7L4M:Mhj@`9NKbYBFaYbNcZ>UeJBV
eZBWe:JYeZR[f:NZe`BVZM@4YZWB2:NZe@JVZM@00jNZeJNZdjJYdP0?YZWB
2:JYe12WZ]D06JFXdjJYe:FXdjBWdZFXdjJYe::Ud9^NbHbA^J:WdG1bXT]=
OT51La0?>di>M?clookmooSioOkooO;ckOoonooooOKfn?onooooo`2;VIVI
00?oooo<c<c<c<`0GLc<c005/8dN/8dcYW80SED:UED000:NLPX2YW8000jE
EAAZ@@YP;`Xm70X/4P23>02NLQB`SAj`NaB`LP2`N`ZiSAB`N`Z`SAh2/7/:
00W:XCg:ZTO:XCg:ZTO:XE;:V1BiSBV`SAj`N`X00[V=50:`N`X03<640;V4
5;1b0;1b0;V=5;V=:KV=<jIb5;V=<iib5;V4:K2=7P?:V1@2`H@000?:V1A6
;`[L/e`00]bcG003g;>4dkj>g;=L00;CZTL01<ZH5<ZH:LZH:M>H2P;1Q000
4LZH:K2=7[2=7/ZH5<ZH:LZQ?M>ZAlZH:M>Q:LZQ?LZH5<ZH:M>H2/ZH5=>H
2/ZH5;2=7P02djY700G:V2WLZS?:XCg:V1BiSBT00/ZH5009/8dNbYPDbYPY
i;<NdjY7g:Xcdj4YbZ4mbYPD00;:ZTL02lZZI^BnQ>g@V>BnQ>g@V=bcQ>g@
V>g7Q>gIc9ib5;1k2P03^H@D0lZH500?dj4Yi;<cbZ4mi;<cbZYVbZ5Bg;=L
dj4YdjY7g:Xci;<cbYPDdj4Yg:Xcdj4Y00KLZS<03>Bc7X=N5>fn?M>Q:M>Z
AnBc:M>Q:NBcAm>H2]>Q:M>40>Bc7PC:V1@04=>40<ZH5=>H2[UW0;1k2[1E
03dB2V0_55LL0;1<0;1k2[UW0;V45=>40;1b0=bZ<`;L/e`02MbZ<lZQ?M>Q
:LZH5;V4:KV45:I<08<_0;1k5002dj4Y02biSABiQ1B`N`YkC0Z=E@YP;`YZ
@@XS9PXS70XJ2@X92A@J4Q@J2@XA70X92@XA70XJ2@Y6EBT/9Q@J4Q@A70X9
4PXA70XJ2@X92@XJ4QB`C02`E@2EEAB3>01kC1A69Q@m70XA70XJ2@X92@XA
70X92A@94PX92@Y6C3dd;akfoooLhn02dn?e00SLhn3ChoGLhn1ZNhBEV:?:
d=K]kN[]m_D2m_oo00?Lhn3<c<c<c<`0Glc<c004IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P4c<c<00EVIVKoooo<c<aVIVK<c<`059VIV@0G
oo_ooo[ooocooo_jn_ObooohooojoOgmookoo_gom?CoNg^M8bE<;2mJ<CAQ
B4YkHfBJK6fUM7F[MWN]N7V_O7fcOX2c00=mOk86OGn`27]m[PQmOk000gan
[geo[geo[`04OGn_00=lOZimOjmmOjl01Weo[`QmOk08Ngf^27]m/09mOk80
5gan/G]m/7eo/Wj0/gQj[G5cY6EXUDA7LRLXF1lPD2PVEhF4[_KeooKdonOW
kooooOoon?Gejooon_cknOonooomooooo`2;VIVI00?oooo<c<c<c<`0GLc<
c00<YW8D/8@YYW80SED:WUhDUED0WW8:YVL0WUhDYVL0LSPDJT4:0V0_5007
SED:WW8:/8dc/8dN^HdD/7/:YW8000:`LP001;2=7ZIb0;2=D]>ZA`;:ZTL0
2lZQD[V=:LZQD[V=5;2=7[1k59ib5;1k2/640;1k2[1b0002/7/:01^`SAji
SC?LZS>`SAjiSBV`SAjiSAC1Q03:V1BiSAB`SAk:V1BiSACCV0Y69QCCZTOL
/ecC_XkL/ec]aec:ZVKL/ecCZTOCXBWLZS?:XCgCV0X00[V=5004`H@0^HdD
^HdD^HdY0/ZH:@04bZY7bZ4mbYPDdiP:0lZH5007diP:bYPDbYPYbYPDbZ5B
g;=LbYPY00;LZS<01<ZH:L640<ZQ?KV=<`;:V1@01;V=:M>ZAmbcQ=>ZA`;C
XBT02<ZH5<ZZI]>nS]bcQ=>nS]bn[Ng7G=>nSP?]d9P01ngIc9F4DYEE0;1k
2[V45;V4:LZH:@02bYPD00OCXBW:XCg:XCgCZTOL/ecT/c?L/h@01=bZ<`;C
XBT00mbZ<nBc:NBc7P02g:Xc00kCXBWCZTOLZS?T/bVEEACLZS?T/dOLZS?L
/ecCXBWL/ecCXBWLZS?CXBT3bYPD00gCQ03:V1C:V1CCXBW:V1B`N`ZV@@2`
N`Yb9P1P;aAP;`ZV@@2`Na@00[UW000>^H@D^FL0bZ4mdjY7i;=7djY7bYPY
dj4Y^HdYdj4YbYPD/7/:bYPD^H@D0]>Q:@03^HdD^H@D/7/D009kC0X03b<L
2ULL03@_7R<L2Q4L2QXB50T950T92PTB2Q4L2PT9514L2VYE7S@_7Q4V2P02
4A`:00`J4Q@A70XA70X92AB`N`ZNGQBVC023@@1b>1AP;`X/9Q@S70X24A`:
00X92A@A70XJ4Q@94PZEC2V3Q7_ChoFVan3:d=KLhn02dn?e00W]kNYZNhBE
XHk1alcChoGfooo]m_GfoooLhn00HLc<c004IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P4c<c<00IVIVKoooo<c<c<c<aVIVK<c<`CVIVI01Ko
n?oonooonOonn?SoooSgm>_oooSmo?Soo_oknoono?odmOoknooFeomKGX//
;UlH6E8Q8EdZ:f@^;fPa<V/e=Vl4=cQ`1SLhKP/h>Fl5=cQ^0SLiK0@h>Vd:
=cU/23LhKPPh>Fl8>3Ua0STjLP0G>3Ua=cQ`>CYb>S]c=3E];2iQ6ae=9bYE
Gf2@f=WonoWok>_oo__oo_goookon__eno_aooodlO7Yoookookom_Cioooo
08^IVIT00oooolc<c<c<c01Mc<c<0[24:@05WW8DUEDDWW8:SED:YVL000:N
LPX2SED:00>3@@1P;aB3>0000[1k2P06YXAB/7/:^HdD/7/D^HdDYW8D0[1k
2P0AYW80bZY7bZYVbZ4mbZY7bZYVbYPYbZY7^HdY`H@0^HdDWW8:/7/:^HdD
/780^H@DYW8000:`N`X04lZH:LZZAk1k5<ZQ?K2=7[1k5;V=<lZH5<ZH:LZH
5;V=<l640<ZH54H_2]bcG=>nS^BcAmbcG=bcQ003djY700K:ZTO:XCg:V1C:
V1C:V2W:V1@2^HdD00O1Q03:V1B`Q2W:ZTO:XCgCXBW:V1@00]>H2P08g:Xc
bYPDbYPYdiP:bZY7bYPYbZ4mkKhm0mbZ<`08bYPDbYPYbYPDbYPYdiP:bYPY
bZ4mdjY70]bcG0;:XCd01=>ZAlZZI]>nS^BnQ0;]d9P02mbcQ>g@V>g@V>g@
V=c7Xoo]SXf=AjIW0;1k:KV4:M>Q:@02g:Xc00?CZTO:V1CT/c<00]>ZA`03
i;=7djY7g;=L00;CZTL05]bZ<nBcAlZQ?M>Q:NBc<m>Q:NBcAmbZ<nBc<mbZ
<mbcG=>Q:NBc7Yj=:MbZ<m>Q:M>ZAnBcAlZH:MbZ<m>Q:NBZ00C:V1@01M>H
2/ZH5<ZH5=>40>Bc7P02^FL001ViQ1BV@@23>02NGQBVC02iQ1B`C031Q02`
N`[1Q03:V2WT/dOT_XC:V1CLZS?CXBW:XCgCXBW:V2ViQ1BiSC?1Q03CXBW:
V2V`SAh00[V45007JT4:Nd`:8bH:ARH:?A`:8bH:8a`:00<A70X07aXB514L
2QXB51X92S@_7R`V51XV51XB514L2PT950T92QX92PT92ZI<09iN58eE2X<h
07]<2V0_54HV52<L2QX92PT92Q4V50T9514L2PT92TI17ZJQV<[@e]cSh002
dn?e0]cSh005dn?eJW]_SHe_`LO<dn?e00;]m_D00oKoomcSh<c<c01Pc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI_oo
olc<c002c<c<00=VIVK<c<c<c<`0olc<c0k<c<`00oooolc<c<c<c01Mc<c<
00B`Q2V`SE:NLQBNLPX2SED:01ZEE@2VI`2NGQBEE@2=E@ZVLP2`SE:NLPZE
GS>NLS>VLQBiSAC1Q02iSAB`SAjiSAB`N`Z`SAjVLP3:ZTOCZTO:XCgCZTO:
ZTO:XCg:ZTL2^HdY00fiSAB=E@Z`N`[1Q02`LP2NLPZ`N`ZiI`2iSAB`SAk:
V2V`SAjiSBT00[V4500>/8dN^Hdc/8dN^HdDdiP:/8dNbYPDH2l:bZY7g;>4
g;=LbZYVg;=LkKhm0]>ZA`0:g:XcbZ4mbYPYbYPD^HdY`H@0^HdD`H@0/8dN
^Hdc0/ZQ?@05bZ5BbZY7diP:bYPDdj4Y00?:V1@01<ZH:LZH5;V=:MbZ<`?:
V2T3bYPD00f`SAk:V1C1Q02`SAk:V2W:XE;L/ecCZTOCXBW:V1CLZS?CZTOC
_Xh00^g@V005g;j]kM2HkM2HkM2Hg;j]00;]d9P01:JQIYiN5<ZH5=>ZA`?L
/e`02^BcAlZQ?M>ZAmbZ<m>ZAmbcG=>ZAmbcG=bZ<m>Q:@;CZTL01=>Q:MbZ
<mbZ<m>Q:@?LZS<01]>Q:NBcAmbcG>Bc<k1k2/ZH:@;CZTL01MbcG=>Q:NBc
<lZH5<ZQ?@02dj4Y00?:V1C1Q03:V1@00/640003bYPDbZ4mbYPD00;1Q000
0jIW0;1E0;V=<`02/7/D00F`N`[1Q02`N`Z`N`[:V2T00]bcG0;CZTL2bYPY
00OCXBW:ZTOCV0ZiQ1C:V1CCXBW:V1@00[V4500E^HdYJT4:ARHD?A`:Ea`0
?A`:8bH:6PT:2@T:6PT:6Q8D2@TD2A8:2@TD4A`:;3PY=2lN4BH:6PT:4A`:
6Q8D008A70X0100009iN5;1k5;1b00:=E@X03F0_2THV2Q4L2R<L2Q4L2PT9
51XB514L2PTL52`L5:J4Q=?SmJK7h002b]3F0]?Sm@09kOKeLXf4Nhf4`LO<
g>?Pm_ookOKem_oog>?P067<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2h1<c<c003IVIVooooc<c<00?<c<coIVIV46IVIV3<c<`01K24
:K2=<jIb58eE2Yib2P02UED000VNGQBNLPZVI`2VLQBNLQB`SAj=E@Z`N`ZV
LQ@01KV=5009/7/:/780/780YW80^IQLbZY7bZ4mbZY7bZ5B00?:XCd2^Hdc
00=Z@@[1Q02VLP000[1b0009YW80/7/:/780^HdY^Hdc/7/:^Hdc/8dN^HdD
00:iSBT01lZH5;V=5;V=5;V=5<6406115<ZQ?@03g;=L00_:ZVKL/ecL/ec:
XCg:V2W:ZTOLZS?:V1B`SAk:V1C1Q0000[V=5003bZ5BbZ4mbYPY00;CZTL3
bYPD00kCV0[CXBW:V1CCV0[:V1B`N`[:V2W:XCgCV0[:V1C:V2WLZS?:V1CC
V0X2bYPD00G1Q02iSACL/ecL/ecCZTL00/ZQ?@07g:XcbYPYdkj>kM2Hdkj>
kM2Hi;j400G]d9P03ij=<lZQ?LZZAmbcG=bcQ>g@V>BnQ>BcAm>ZAmbZ<m>Q
:MbZ<nBcAm>ZAkV=:@02g:Xc01CT/c?L/ecCXBWCXBWT/akCXBWT/akLZS?T
/akCZTOT/dOCXBWL/ebiSAC:V2WT/c?CZTOL/ec:V1CL/e`2dj4Y00O:V1CL
ZS?:V1C:V1CCQ03:V1CCQ0000/ZH500=diP:bYPD/7/:PcP0SED:djY7/7/D
/7/:^FL0bYPD^FL0`H@0/8@Y00;L/e`01=>ZAmbZ<m>Q:M>ZA`CCXBT00lZH
5<640<ZH5002^H@D00JiSAAZ@@YP;`XA70XS9PXm70X28a`:00DA70X92@XJ
4Q@A70X92@X00Q4L2P038bH:=2lN6PT:00894PX061X92QXB50T92PT95;1<
0;UW0;V4578h57]<56Y12THV2R`L51X92Q4L2QXB50T951XB50T954HV59j4
IZK7h=cSh=?SmL[@eP;Lhn001NgfmH>HSW9bNk2n`M?IeP02kOKe00?fm_G:
d=K<c<`0H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4
c<c<00=VIVKoooo<c<`0olc<c7?<c<`019ik<k2=<iib2Yib2P:3GQ@01HeE
2ZIW09EE09ib2Yib<`02WW8D00NEE@2VLP2`N`Z`NaBiSC>iSBViSA@00[1b
000A^HdD/7/:YVL0^Hdcg:XcbZ4mbZY7bZ5BbYPYbZ5BbYPY/8dN^HdYH2l:
WW8:/780YW8000:NLPX04JIb0;1k2[V=:LZH:K2=7[V=<k2=7[1k2/ZH:LZH
5;V=<kV=5<ZH5;V=5=>H2TH_2/ZQDP02g;=L01?CZTOL/ecCZTO:XCg:XE;L
ZS?:V1C:V2W:V1C1Q03CV0Z`NaBiSAC1Q03CZTNiV5c:V2W:XCg:ZTL00/ZH
500Ddj4YdiP:bYPDbYPDbYPY`H@0/7/:bZ4mbYPYbYPDbYPYbZ4mbYPD^HdD
bYPD^HdDbYPDYW80^H@DbZ4m0]>ZA`;:XCd04<ZH:LZZI/ZQD]c7XmbcG=c7
XmbcQ=c7Xmbn[Ng@V=c7Xoo]c:JQI[VZKm>ZAnBnQ0?]d9P00mbcG>BcAmbc
G003djY700OT/dOCXBWL/ecCZTO:XCgCZTO:V1@00]bZ<`?CXBT02=bZ<m>Z
AnBcAm>Q:MbZ<lZH5;24:M>ZA`;T/dL01]>Q:MbcG=>Q:MbZ<kV=<m>H2P;:
V1@2`H@000C:V1CCQ03:V1CCXBT2bYPD00fV@@2VC031Q02`LP2iQ1C1Q03C
Q02`N`[1Q02iLS?]aecCZTOLZS<00]>ZA`03g;=Ldj4YdjY700;CXBT0><ZH
5;V=<lZH5<640;1k2[2=7X=N56Y12Q4L2R<V2SdL2R<V2R<L2QX92Q4L2QX9
2PT950T92Q4L2QX92R<V2S@_7Q4V2QXB514L2PTB2PT92Q4L2PT92XeE2[V4
5;1k59EE08<h07]<2THV2R<V2Q4L2PTB2QXB514V514L2PTB2THV5;2=D]cS
h=?SmL[@e]?SmL[@e]?SmNgfmH>H[FYkKk2n`L[@eP?]m_D00mcSh<c<c<c<
c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
0fIVI_ooofIVV@3oIVJI4fIVVF3<c<`2/8@Y00NNLQBEEABNLQB=E@ZNLQBN
LPZ=E@X00ZIb5005/8dN/7/YYVL0/7/:/7/D00:iSA@2/78000N`N`ZES@2`
LP2`N`ZVLP2NSC?CZTL00/ZZA`07bZ4m/8dNbZ4m/8dN^Hdc^HdYH2l:00:`
N`X3YW8000b`N`Z`SAjiSBW:V2V`SAk:V2V`SC>iI`2`SAjiSBW:V1BiQ1@3
`H@000M69QC:XE;L/ecC_XkL/ecC_XkLZS<00]>ZA`04bZ4mbZ5BbZ4mbYPD
0kV=5004bYPDbZY7^HdYbYPD0/ZQ?@03g:XcdiP:bZ4m00C:V1@01[V=<lZH
5;V45<ZQ?MbZ<lZH50;:V2T04kV=<kUW0;2=7/640;1b0:IW09EE5;V=5=bc
G<ZQD/ZH5<ZH:M>Q:LZH:MbcG>g@V=>nS^g@V=bcG003kM2H00K]fLc]d9Ri
ZVoLZS?L/hCLaj<2i;j400gL/hCL/ecCZTOL/ecCXBWLZS?L/ecCZTOLZS?C
ZTOLZS?:XE;T/dL00m>Q:@;LZS<02>Bc7]bZ<mbZ<lZZI]bZ<mbcG<ZH:K24
:@;T/dL01]>ZAm>Q:MbcG=bZ<m>ZAlZH:@?:V1@02]>H2[1k2/ZH5<ZH5;1k
2/ZH5=>H2/ZH5;1k2[UW00:`N`X03=>40<640<640;1k2/6409ib2^g7G=bZ
<m>ZAmbcG=>ZAmbcG0;CZTL2dj4Y00C:V1CCV0[:V1B`SAh2^H@D00BNLQAP
;`X/9Q@J2@X28bH:00DS70XA70X92A@971@A9Q@00`T92P0A8a`:;3PY6RHD
2A8:2A`D2A8:4A`:2@T:2@TDNd`D/5D0WUhDSED:PcP0Nd`:ARH:8a`:008A
70X26Q8D00LS;ah0000m70[:ZVK:d=JVan3:d=H00mcSh005kOKePiR]JW]_
/;>gb]3100?]m_D00mcSh<c<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^0C<c<`00fIVI_ooofIVV@0Kc<c<00KooOooo_oo
o_ooo_oooogooo/2oooj00SonoSooOcck_;TgnKPf^KIdn7?b=[<aML2_KK8
00fm]LZm]/Rm]LZm]/Rm]LZm]/Ro]lbo^<Zo]lbo^<Zo]lbo^<Zo]l`00[nh
bP0^_kS8`;O:_kS8`;O:_kS8`;O:_kS8`;O:_kS8`;O:_kS8`;O:_kS8`;O:
_kS8`;O:_kS8`;O:_kS8`;O:_kS8`;O:_kS8`;O:_kS8`;O:_kS8`;O:_kS8
`;O:_kS8`;O:_kS8`;O:_kS8`;O:_kS8`;O:_kS8`;O:_kS8`;O:_kS8`;O:
_kS8`;O:0knhbP0<_kO<_kS:_kO<_kS:_kO<_kS:_kO<_kS:_kO<_kS:_kO<
_kS:0[ngc008_[C<c/CLc<GGe]3Nh]cVhn7Tm??aoOch0_oonP04oookooom
ookoooko0_omo`03ooooc<c<c<c<08?<c<`00fIVVLc<c<c<c01Nc<c<00jN
Nc>`SC>NLS>VLP2EEABNSBVNLQBNGQB=E@ZNLQBNNc>`Q2VVLQBNLPX2/7/D
00B`N`ZiSAB`NaB`N`X3/7800[1k2P07/8dN^IQLbZ4mbZ4mg;=L/8dNbZY7
00:iSBT01;2=7XeE2W]10:Ib00:`LP001k1k2ZIb0;1k5;V=:KV=<kV45;V=
:@03/8dN00RiSC>iSBViSABiSAC1Q02iSAAP;aC:XE84g;=L017:ZVKCZTO:
ZTO:V2W:XCg:V2W:V1BiSAC1Q02`LP3:V1B`SAjNLQB`NaC:XCgCZTO:ZTL0
0/ZH500=diP:bYPDbYPDbYPDdiP:bYPD^H@DbYPYbYPD^H@DbYPD/8dNdiP:
00:iQ1@06[UW0;V458=108eE2/ZH:M>ZAmbcG=>Q:LZH5<ZH:LZQ?LZZI^g@
V=bcQ>g@V>BnQ>g@V=bn[Ng@V=c7Xng@V<ZZI[VHG>g@V=c7XmbcQ0;T_X@0
1]bcG=>ZAlZQD]bZ<lZQ?NBcA`?CZTL01]bZ<m>ZAmbcG<ZQ?M>Q:MbZ<`?C
XBT2g:Xc00KL/ecLZS?CZTOCV0ZNNc?LZS<2i;=700WCXBWL/ecCZTOCZTNi
Q1BiSC?:V1B`N`[CV0X00/640008bYPD/7/:bYPYdh@0bYPD`H@0^G8c^FL0
0k1k2P07^H@D/7/:^FL0/7/:i;j4g;=LbZY700;CZTL01>BcAm>ZAlZZAmbZ
<`;CXBT04LZH:LZH5<ZH5;V45;1k59ib57]<560_54H_2SdL2R`V52<L2R`B
01X92PT9514L2QXB50024A`:00<J4Q@d;ahA9Q@00QXB500D2@TD4A`:2A8:
2@TDPbl0^H@D/7/YWUhDSED:Nd`:H2l:ARHD;1`D6PT:4A`:2@TD6RHD2A`D
6PT:^IQL0/[@eP0:g>?Pb]3Fdn?eg>?PkOKeUJ6gJW]_YZZ]b]3FkNgZ0^gf
m@03kNgZc<c<c<c<05o<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c003IVIVooooIVJI01_<c<`01_omooonooonooonoooooOoo
n`;oooX02?KbkoC`lMoJh<W3cl2ibKVab;2V_jbS_PRNUK08W9>^<9fC[0RL
Tjh8WIB_00RQU[BaY/B^Y[jf[l72_<[:aLcQg>3]k>X3oook00?ooogoo_oo
o_l00_omo`03ooooc<c<c<c<08?<c<`00fIVVLc<c<c<c01Nc<c<00B`NbV`
SC>NLQBNSBT2SED:00^NLPZNGQBNLPZNLQBVLQB`SAj`NaBNLQB`NaB`SAj`
N`X00[V=50>`LP02YW8000>NLPZNSC?LZS<00/ZQ?@0CbZ5BbYPD^Hdc/780
bYPYUEDDPehDJT4:YVL0WW8:/7/:WW8D`H@0/7/D/8dN^Hdc/8dN^Hdc^H@D
00:`SAh2bYPD0[V=5006^H@DbYPDEa`0bZY7g;=LbZYV0]bcG004bZYVbZY7
bZ5Bg:Xc0/ZQ?@0>bYPD^HdD/7/:/7/:`H@0YW8DARl:Nd`:bYPYbZYVdjY7
bYPYbYPDbZ4m1<ZH500Q^HdY^H@D^HdcbYPYbYPD/8dNbYPY`H@0^H@D^HdD
/7/:WW8:UD`Y/8dc/8dNbZ5BbZY7bZ4mbYPYbYPDdjY7bZYVkM2Hg;>4dkj>
i;j4dkj>kM2HkMW<kM2HkMW<dkj>bZ5B00;]d9P2i;j400SL/ecCZTOLZS?T
/c?:XCgCZTO:XE;LZS<2djY700OLZS?:XCg:V2W:V2WCXBWLZS?CZTL00]>Q
:@07i;<Ng:Xcg;=Lg:XcdjY7i;<NWW8D00GL/e`2djY70lZH5003`H@0dh@0
^FL000?1Q003bYPD00>`N`[:V1BiQ1@00[1k2P?1Q0009[1k2Yib2^BnQ=bc
G>BcAmbcG=>ZAmbcG=bZ<m>nS/ZH:LZQ?M>Q:LZH5=>Q:LZH5;V4:K1k5;2=
7X=N578h04H_2SdL2R`V52<L2QXL7Q4L2QXB50T92QXB50T92PTB2QXB53@_
7QXV514V50T951XB508A70X050T955LL0<640;1k5:IW078h58=104H_2R<V
2QXV51X92PTB2QXB514V51XB50000=bcG;2n`L77c:K7h0?:d=H01^gfmK2c
]dmWG:JZXl77c>g]jP;]m_D00mcSh<c<c<c<c01Oc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI_ooofIVV@0Kc<c<01Co
o_oin?goo_oooooooognoO_oo__oo?_Xi>GBcM?4_<V`YkZSVK:JSjf8NYj3
Mif4NYf3NIb1MiYoMIP2OWBG00=oMIR0MYUnM9L01gidUc1nM9H8OG>F00=o
MIQmLiIkLI@00WY`T`03OG>FP7JIPWRK00:3Mi/028f2XYfC[ZNN/k2X]l:j
aM?>e>GQh_GalP;oo_l01Oooooonooonooonooooo`25c<c<00=VIYW<c<c<
c<`0G/c<c005WW/cWXdYWW8:WW8:UED000:=E@X05jIb08eE2[2=7[2=7ZIb
59ik<jIb0;V=5;1k2ZIb5;V=5;1k5;1k2ZIb0:Ib5<640;1k2Yib2Yj=<m>Q
:LZZAlZQ?KV=<`02^HdY0[V=500HWW8:H2lDARHDSED:WW8:/7/D/780/7/:
/7/D/8dNbYPY/8@Y^Hdc/8@Y/7/:^Hdc`H@0^HdY/8dN`H@0^HdDbYPDH44D
bZY70]bcG00;djY7bZYVdjY7g;=Lg:Xc^HdcbYPDbYPY^HdDbYPD`H@000:`
N`X017]<51XB58=N5;2=7P;CZTL02LZH5<ZQ?M>H2]>H2/ZH5=>H2/640<ZH
5;1k2P02bYPD00fiSAC:V1BiSAC:V1BiQ1BiSABiQ1BVLQBNLQAZ@@ZVLQCL
/ec:XCd00lZH5006g;=L^IQLi;j4g;>4kM2Hdkj>0^g@V00>g<NSkM2HkM2H
^JY_bZYVi;j4kM2Hdkj>g;=Ldkj>i;j4djY7bZ5BbZ4m0]>ZA`04bZ5BdjY7
i;=7bZ4m0]>Q:@04bYPYdj4YdjY7g:Xc0]>Q:@09g:XcbYPDdjY7dj4Yg:Xc
dj4YPehDkLMLi;=700;L/e`01]bcQ=bcG=bcG=>ZAm>Q:KV450B`N`X01[UW
0<640<640<640=>H2[V450:`N`X00l640;1k2/640002/7/:00FiI`2VLP3]
aecL/ecCZTL01MbcG003bYPYdjY7dj4Y00;:V1@03k2=7/640;1k2Yib59ib
2W]<560_2TH_2R<V2R<L2QX92PTB2PT9514L2PT92P024A`:00L92@Y6@AhJ
9Q@94PXJ4Q@94PXA70X00PT92P0A?A8:/7/:WUhDYVL0Nd`:LSPDARl:?A`:
6PT:4A`:4BHD4A`:6PT:6Q8D0000kLN4/;>g00?:d=H2g>?P00G]kN[1alaZ
NfnEXHj`_/400ngfm@03kNgZc<c<c<c<05o<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVooooIVJI01_<c<`01?onookm
ooooooooo`;knOX06OKamNCOiM3:e;jha[>Z_ibB[HanXH=dVgMWU7e]W6eR
SFeRS6aQS6aQRfaQS6eRS6iSSViSSF]PRf]PRV]PRf]PRV]PRf]PRV]PR`02
Jf2:02eYHHY[H8YYHHY[H8YYHHY[H8YYHHY[H8YYHHY[H8YYHHY[H8YYHHY[
H8YYHHY[H8YYHHY[H8YYHHY[H8YYHHY[H8YYHHY[H8YYHHY[H8YYHHY[H8YY
HHY[H8YYHHY[H8YYHHY[H8YYHHY[H8YYHHY[H8YYHHY[H8YYHHY[H8YYHHY[
H8YYHHX016]PRP0<Jf2;Jf2:Jf2;Jf2:Jf2;Jf2:KF:=K66;K66<K66;K66<
KF:<0ViSSP0<M6NCK5n:KF69OG6EShBRX9J^/jZm`k_:e/kIj>?ZnoKloogo
0_kmo`03ookoo_gooooo08G<c<`00fIVVLc<c<c<c01Nc<c<00FNLQAZEAj=
E@ZEEAAkC0X00XeE2P:EE@005JIb59ib5;2=7ZIb5:IW0;2=7ZIb5;1k2[2=
7[V=5;1k2Yib2[1k2[1b0:Ib0:IW09j=<lZQD/ZQ?LZQD/ZH5002^HdY00>`
LP31Q02EE@000THV5006^H@D/7/:YW8D/780/7/:/7/D0[V=<`04/8dN^HdY
^HdY/7/D0[2=7P03diP:^HdY^H@D00;1Q0001F0_5:JQI]bcG<ZZI]bcQ003
djY7017LZS?:ZTO:V2W:V1BiQ2W1Q02`N`ZiSAC1Q023>01b>02EEABiSC?:
XE;CZTO:V2WCV0X00/ZH:@06bYPD^HdDbYPDdiP:/7/DbYPD0[2=7P;:V2T0
2KV=5<ZH5<ZH5;V=<k1k58=107]<5;V4:MbZ<`03bYPY00K:V1CCZTO:XE;L
_Zg]d9SL/h@3kM2H00?Tal7Laj?]d9P00]>nSP0<g;>4i;j4g;=LdjY7bZYV
g;=LbZ5BbYPDdjY7bZ4mbZ5Bi;<c0m>ZA`03g:XcdjY7djY700;CXBT02lZQ
?M>Q:MbZ<mbZ<m>Q:MbcG=bZ<nBcAmbZ<g]<5>g7Q002i;j400OL/ec]d9ST
_XCT_XCT/dOLZS>VLP000XeE2P08WUhDYT`0/7/:`H@0/7/:`H@0^H@D`H@0
0[1k2P09`H@0^FL0`H@0^FL0/7/:^FL0/7/:g;>4bZ4m00?L/e`01^g@V=>Z
AmbcG=>ZAm>Q:LZH:@?:V1@03[V45;1k2Yib59ib2V1155LL04H_2S@_7R<L
2Q4L2QX92QXB50T92PTB2P<92@X00dIE:AXV51X92P024A`:0PT92P084A`:
6Q8DWUhD/7/D/7/:Pbl0Pd40H2lD0R<L2P086PT:4A`:2A8:2@TD4A`:0000
m]24/;k10/77c00<b]3Fdn?eb]3Fdn?eY/OPLXf4YYR4/;k1m_KekNgZkOKe
g>?PHLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P4c<c<
00=VIVKooomVIYT06lc<c0?oool07?gmoocjooomoo;/m];<f/>jcJZP^IZ<
[HMhWhMfXYB2]9b9`:^Jd<Znl<W0kl[0l/c3l/g3mLk5m<k4m/k5m<c2m<c3
l/c2m<c3l/c2m<c3l/c2m0;<`o80;L_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3
l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3
l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3l/_3l/c3
l/_3l/c3l/_3l/c3l/_3l/c3l/_3lP02c<?b0/g4l`0JcL?ecLCccL?ecLCc
cL?ecLCcc<;dcLCcc/Cfc/Gdc/CfcLCcc<;dcL7c`;;U]JCHXi?4T82]PG:K
Q7JIWI2^]Zc4`[W<f=;PlN_goO[o0_ono`;nool00oooolc<c<c<c023c<c<
00=VIYW<c<c<c<`0G/c<c008WW8DUEDDPehDSED:Nd`:JT4:Pd40UEDD0Yib
2P04YW8D/8dcYW8DWXdY0[V=5004YW8D^HdD/7/D/7/:0Yib2P05YW80/7/:
YVL0WXdYdj4Y00?:XCd03KV=:KV=5:Ib5;1k2ZI<02`V58=N<kV45;1k5;1k
2[1b0;1k2[1k5003^HdY00>`SAj`NaB`SAh00[V=:@BiSA@01L6406Y12/ZQ
?MbcG=>nSP03g;=L01;:ZTOL/ec:V1BiSC?:XCfiSAC:V1B`N`ZiSC>iQ1CC
V0ZVLP2iSC?:ZTOCZTO:ZVK:V1C:V2T5bYPD00?CV0ZVLP3LZS<00/ZH50?:
V2T01L640<ZZAm>Q:KV=:HeE2P02bZYV00NiSC?:V2W:V1BiSBWCV0[L/hCC
ZTL00^g@V00:g<NSkM2Hg<NSkM2Hi<O1i;j4kM2Hg<NS^JY_i;j40]bcQ0?:
ZVH01M>ZAk2=7]>Q:MbZ<lZQ?@02djY70]>Q:@04djY7g:XcdjY7bYPD0m>Q
:@;LZS<01m>Q:MbcG=>ZAnBcAnBc7W]<2_K@Q002i;j40^g@V004dkj>g;j]
kLML/7/:0XeE2P07Nd`:PcP0UEDD^FL0/7/:`H@0bYPD00:iQ1@01<ZH5;1k
2[V45<6400:iI`002<640;1k2[1b0>g7G=bcG=bcQ=bcG=bcQ0?L/e`01<ZQ
?M>ZAlZH:LZH:@:iSA@05K2=7[1k2ZIb58eE2V0_560_2ULL02<V2R<L2QX9
2Q4L2QXB514L2PT92QXB514L2Q4V54HV52`V514L2PT92P034A`:00D92@XA
70Z`E@2VLQBiQ1@00W]<2P0<H2lD8a`:8a`:4A`:6PT:4A`:6Q8D4BHD0000
bZYV`K>]Y/OP0l[@eP?Lhn001h>HSX>=Q;2c]mcSh>g]j_KoomcSh01Qc<c<
00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI_oo
ofIVV@0Kc<c<01oooogmoO_oooooo_ooo?ojmooUg^k3^m:dZLNGRjn<OJR=
OJjXULc6/^g>^_WHa_o=`?K<a?O@a_[Bb_gDb_kCbokDb_kBb_gDb_kCbokD
b_kCbokDb_kCbokDb_h00]?;oRkBboh3dl_n01_Db_kCbokDb_kCbokDb_kC
bokBb?cAbOcCbOgAbOcBb?c?ao[?aOW>a?W@`O[E`ogEa?_6]N^ZV<ZBPJj>
OJNDQZV_X/34^];RfngfloknoOl00_koo`03o_omooooc<c<08C<c<`00fIV
VLc<c<c<c01Nc<c<01BNNc>NSC>EE@0m70Y6;`Yb9P1kC0Z=E@ZEEAB`N`ZV
LQB`SAjiSABNLPZ`N`ZVLQB`NaBiSABVLQB`N`X3WW8:00NVLP2VI`2NSBWC
ZTNiSC?LZS?:V2T00[2=7P0C/7/:WW8:SED:Ea`0WW/c^H@D/7/:`H@0/7/D
^H@D/7/:/8dN/8@Y/8dN^IQL/8@Y/7/D/8dNbYPY00:iSA@06l640;V45;2=
7W]<2[2=D]bcG<ZZI]bcG<ZZI]bcG=>ZAlZQD]bZ<lZH5<ZH:KV=5<ZH5;1k
5<ZQ?K2=7[1k5<ZH5=>ZAmbcG=>nS]>ZAmbZ<`02bYPY0lZH500;^HdDbYPD
^HdDbYPYdj4Y/8dNbYPY/8dNbYPDbYPYbYPD00;:XCd01;2=7/ZQD/ZZAlZH
50;:XCd01LZH5<ZQ?MbcG<ZQ?Mc7X`03kM2H00SLaj?]d9S]d9S]fLcTal7]
d9RiZVo]d9P2g;>400SL/ecCZTOCZTO:XE;:V2W:XCgCXBWCZTL2dj4Y00?C
ZTOCXBWCXBT00]bZ<`GCXBT04=bZ<m>Q:LZZAm>Q:M>ZAmbZ<h=N5=>nS^g7
G>BnQ=bcQ>BnQ=bcG<ZZAkV=:JIb009b>1@018<_078h58<h0:IW00:`N`X0
0kV45;Ub<lZH5002^H@D00RiI`2iQ1B`LP31Q02`N`[1Q02`LP3T_X@3g;=L
01?L/hC]ahCCZTOL/ec:V1CCXBW:XCg:V1BiQ1B`N`ZiQ1BVLP2NLQBEEAAP
@AAP;`Y69PY69Q@S9PX00QX92P0P2@TD4A`:2@T:4A`:4BHD0000AUDY8blN
4A`:6Q8D2A8:6PT:2A8:6Q8D2@TDYT`0^H@D/7/:LSPDPbl0Nd`:;1`D8a`:
6PT:2@T:4A`:2A8:6Q8D0000bZ5BYZZS`LO<0/[@eP0;dn?eb]3Fdn?eg>?P
PiR>PhAkYZZ]g>?Pdn?ekNgZg>?P067<c<`016IVIXS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h1<c<c003IVIVooooIVJI01_<c<`08?oon__lmooo
oOonoo[gonGQl/[2fZnVaIJ:/Xem[9V6_JbHdlVclmc5omBmom2mom?8om?<
omO>omSAom[AomWBomS?omK?omcCom_DomcCom_DomcCom_DomcCom_Doc3I
eOl2fM;o01oJdOoId_oJdOoId_oJdOoId_oKd_oId_oHcooFcooFcOoEc_oF
cOoGc?o=_O_=^_[?^o[@_?_9/o6cW]NIQKZ7MJFKS;>^Xl?=aMgXi??gm_kk
o?kmoocnoo_oood0QLc<c003IVJIc<c<c<c<05k<c<`01;VHG;2=DYik<cdL
2P969PX027]<2XeE2YEE0:Ib0:Ib5;2=7ZIb59ib50BVLQ@3YW8000FNLQBN
LPZVLP2VLP2NLQ@00/ZQ?@0=^IQLbZ4m/8dN^H@D/7/:YW80UED0JT4:YW8D
^Hdc^HdD/8dc/78000:`SAh03kV=5;V=:K1k2/ZH:K24:K1k5;V=5;2=7[V=
5;2=7[V=5;V45<6407]<2[2=<`02g;=L01OL/hCC_XkCZTO:V2WCZTO:V1Bi
SC>iSBWCV0[:V1B`N`[:V1BiQ1CCV0ZiSAC:ZVKCZTOL/ecCZTO:V2W:XCg:
V1C1Q0000lZH500N`H@0/780dj4YbYPYbYPDg:XcdiP:bYPYbYPDbYPYbYPD
g:XcbYPY^Hdc^H@DbYPY^Hdcdj4YbYPDbZ4mg;>4bZY7dkj>g;j]dkj>g<NS
kM2Hg;j]kMW<g;j]0^g@V008^IQLi;j4g;=Ldkj>bZ5BbZY7bZ5BdjY70lZH
:@07dj4YdjY7dj4YbYPYbZ4mbYPYdjY700;:V2T01<ZQ?MbZ<m>Q:LZQ?@;C
XBT01m>ZAmbZ<nBcAnBc:H=N5=bcG=bcQ002g;=L00kT/dO:XCfVLP2VLQAP
;`Z3;`23>02VC02=E@Z3;`2`N`ZiI`2iQ1C1Q002^H@D00FiSC>`N`ZiI`2`
N`ZiI`000l64000J/780i;j4djY7i;j4bZYVi;j4g;>4djY7i;=7bZ4mdj4Y
bYPDbZ4m`H@0^FL0`H@0WW8:YVL0WUhDARl:H2l:ARl:8bH:;1806PT:4A`:
0PT92P072A8:2@T:6PT:2A8:=5DY8bH:2A8:008J4Q@0514L2QX92Q4L2P00
08<h0;UW0;1k2YEE08=107]<2R<L2R<V2Q4L2PT92Q4L2QXB50T92P000<ZQ
DYF4SP;1al`3b]3F0]cSh004UJZ]JW]_/;>gg>?P0^g]jP03g>?Pc<c<c<c<
05o<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<c003
IVIVooooIVJI01_<c<`06?oom_[klooooOonooKbomWDj[fddjFJ`Xal[I1o
]ZZFeK^VjL^do=>kolbdolnkom;7om7:o]C=omG>omK?omG>omC=om;;o`OH
dOl00mKBomGCom?Do`0]dmCo00?EdooDd?oFcol01]K?o`03fM;of=7oe/oo
00CDcOl04]G<omo?om[6om:molZen/B]lkNPi:RBdYb7`9>1/J>D^kndd]gI
j_;anO_mo?_on_con_kooHG<c<`00fIVVLc<c<c<c01Nc<c<00FiZVn`SE:N
SBV=E@Yb>1@00VY12P03UED0SED:WW8:00>VLQ@02;2=7[1k2[1k2ZIb5:Ib
0;1k2ZIb0:Ib50:`N`X03ZIb5:Ib08=k<lZZAlZQ?LZZAkV=<kV=:K2=7[1k
5:Ib0;1k2W8h09j=:@:`SAh01;1k5:Ib5;V=5<6400:iSA@02;1k5;V=<k2=
7[1k5;2=7[V=<kV=:KV450:iSA@01[2=7W]109F=D]bcG=>nS]bcG0;:ZVH0
1<ZQ?LZZAkVHG<ZH50;:XCd00k2=7[1k2/ZH5002^H@D00>iSBW:V2W:ZTL0
0/ZZIP03bYPYg:XcbYPY00?:V1@02kV=5<640;V45<ZQ?MbZ<lZH5<ZH:LZZ
Am>ZAlZH:LZQ?@02bYPD01K:V2ViSC>iSBW:XCg:ZTOCXBW:XCgCXBWLaj?C
ZTO]d9STal7]d9SLaj?]d9SL_Zg]d9SLaj?]fLc]d9RVQ5;T_X@2bZYV00KC
ZTO:ZTNiSC?:XE;:XCg:V2T2dj4Y00?:XCg:V1CCXBT00]>Q:@0;djY7dj4Y
bYPDbYPDg:Xcdj4Yg:Xci;<Ng:XcbZYVdjY700;LZS<018=N5<ZZI^BnQ=bc
Q0;T_X@00mbcG>g@V>Bc:@02LRH000YP;aAb>1B`E@1b>1B`E@2iSAC1Q02i
LS>iQ1C:V1@2^H@D00B`N`ZiQ1BiI`2`N`X2`H@000F`LP3CZTOL/ecL/ecC
ZTL00]bcG0;CZTL2bZ4m00G:V2W:XCg1Q02`N`ZiQ1@00Yib2P03WUhDH2l:
LSP00096;`X44A`:00<92@XJ2@XA70X00PT92P03ARHD8blN4A`:008A70X0
5PT9514L2PT92Q4L2V0_2[1k2[Ub<iEE08eE2V0_2TH_2R<L2QX92QXB50TB
2QXB50TL50000;V=<iF4Nl[@eZK7h0;:d=H2g>?P00CChoFEZZeZNfnVZZ<2
g>?P00?]m_GLhn3<c<`0H<c<c004IVIVR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;P4c<c<00=VIVKooomVIYT06lc<c00Dooodnogboooko_gokn_j
em7[^JoDVHfkTX6hUX?3[ISM^:;[`JWec;Cod;GoflGoclKocLWkcl_md<cn
0]7=o`;@c?h7d/ko00?Acoo?d?o>dOh0;LkAoP03cm3nd<kodLgo00SAcOl0
5=;>om7=om7=om3<o/o;oM78olBdmLjjomFoom>molN_nKJNj:N@eYj8b9>0
]ib<^KBYbmC?hno^m__mo0;looP00okooLc<c<c<c002c<c<0P0000;<c<`0
0`000<c<c<c<c00200000/c<c0@00002c<c<0P0000;<c<`200000/c<c0D0
0004c<c<1P000003c<c<0000000000;<c<`400000lc<c0D00018c<c<00=V
IYW<c<c<c<`0G/c<c00<^IQLPehDPehDH44DH2l:JT4:Pd40WUhDSED:/7/Y
YW8D/8dN1:Ib500?/7/:YW80/7/:YW80WW8:/7/:YW80WW8:YVL0WXdYg;=L
bZ5BbZ4mbZ5B^HdD00:`SAh019ib2ZIb08eE2[2=<`>iSA@02l640;2=7[1b
0;2=7[V=:K2=7[V=:K24:JIb0;2=<k2=7P03^HdD0[V45006UED0YXABg;=L
bZYVg;=LbZYV0]bcG004bZ5BbZ4mbYPY^Hdc0/ZH500:/8dN^Hdc^HdD^HdY
bZ4m/8@Yi;=7bZYVg;=LbYPD0/ZH:@G:V1@00kV45<ZH5<ZQ?@02bYPY00Ni
SC?:V2W:V1B`SAk1Q03:V2W:V1@00/ZQ?@0>bZ5BbZ4mdj4YbZY7bYPYg;=L
dj4Yg<NSkM2Hg;=LkM2Hg;>4g<NSkM2H0mc7X`0CWXdcg;>4g;>4bZYVbZ5B
bZY7bZ5BdjY7bYPYbYPDbZ4mbYPDdjY7dj4YbZ5BbYPYbZ4mdj4YbYPY00;:
V1@00m>Q:LZH5=>Q:@02dj4Y00KLZS?CZTOCZTOT/bVNLQC:ZVH2g;=L017L
aj?T_XCL/hBNSC?L/hBEE@1kC0Yb>1B3;`2=E@ZNGQBVI`2iQ1C:V1C1Q02i
Q2ViSA@00[V450>`N`X01L640;1k2/ZH5;UW0<ZQDP02g;=L00C:V2W:ZVKC
ZTO:V2T2djY700KCXBW:XE;:V1BiSABiQ1C1Q002WW8:00J3GQAZ@@YP;`YP
;`Xm70XS9PX26PT:00@92@XA70X92@XA70X22@T:00</C2T/9Q@A70X00PT9
2P072A8:2@T:4A`:2@T:Ea`0bYPD/7/:00:=E@X03W8h55LL02<V2PT92QXB
51X92PT92QXB500009ib<jJHKmcSh;2n`L77c0?:d=H02=?SmJJc`FYkKjJZ
Xm?Ie]cSh>gfmMcSh67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c003IVIVooooIVJI01_<c<`0;_kooOkonooonoCdl^?PjM79
hJjQcHEc/IAnaiAkc:N>gkJKj/BYm/ndol^`om2jolc0o/_3o<g4oLk6om37
olo8o]78om39om37o/o8o]37o/o8o]37o/o8o]37o/o8o/c9o/[:o<[:o/[:
o<[:o/[:o<[:o/[:o<[:o/[:o<[:o/[:o<[:o/[:o1?:b_h03l[:o<[:o/[:
o<[:o/[:o<[:o/[:o<[:o/[:o<[:o/[:o<[:o/[:o<[:o/c9oP02c/Om01o?
a_g>aog?a_g>aog?a_g>aog;`__<a?g?a_o@b?o@aoo=aOk;`__:_o_Ha?oC
_Oo<]?o7[og4ZOZjWnjYS]^GP<JANkVFQ;JZW/C<a=cZio;hn?[lo_WmooWo
ood01<c<c08000001Lc<c000000000000<c<c002000000?<c<`000000000
0/c<c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`2
00001<c<c0800005c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0
000000000/c<c0800018c<c<00=VIYW<c<c<c<`0G/c<c003/8eBUD`YARHD
00969Q@02f0_57]<2XeE2Yib2ZIb09ik<kV45:Ib59ib2ZIb5;2=7P02/7/:
00>`NbVNLPZNLPX00Yib2P06/780UED0WXdYbZ5BbZ4mbZYV0/ZQ?@09^HdY
^HdD/7/:/780PehDWXdc/780^Hdc^HdD00:`LP002K2=<k2=7[V=<k2=7/ZQ
?K24:K1k2[V=:KV4:@02^HdD00FiQ1BiSABiSAAkC1BNSC<00]bcG00AbZYV
g;=Ldkj>g;=LbZYVbZY7bYPYbZY7bZ4mbYPD^HdD/8dN^Hdc/8dNbYPDbYPY
^Hdc00;:ZVH04]bZ<lZQ?LZH5;V=:M>H2[V=<l640<ZH:KV45;V=<lZH5;V=
<m>H2[V=:LZH5;2=7/ZQ?KV=50>iSBT00kV45=bcG<ZZA`02bZY701cCZTO:
ZVK:ZTO]d9SLaj?L/hC]d9SL/hCT_XCL/hC]d9SLaj?]d9RNNc?T_XCL/ec:
ZVK:XE;:XCg:V2W:ZVK:XE;1Q02iSC?:V2W:XCgCXBW:XE82bZ4m0]>Q:@;:
V1@01m>Q:LZH:M>Q:M>Q:M>ZAmbZ<lZQDP02g:Xc00VNLQBiV5cL/ecL/ecL
aj?T_XCC_XjVLQCLZS<00W8V000@Nd`DLSPDPd40WUhD^H@D/7/Ddj4YbYPY
`H@0^HdY^Hdc^H@D/7/D`H@0^HdD`H@00[V45004^FL0bZ4mdjY7bZYV0m>Z
A`?:XCd01=>ZAlZH5<ZH:K2=7P:`N`X01jIb08eE2YiN56Y12THV2V0_2SdL
2P028a`:00<J2@X92@XA70X00PT92P096Q8D2@T:8blY;2HD4A`:6Q8D4A`:
6Q8D4A`:00892@X01R`L5=>40;1k2X<h07]<58=1008S9PX031X92Q4L2QXB
50TB2QXB50000<ZQD[24I]?SmL77c;2n`L77c0;:d=H02=cSh<77c4mNIYFH
Xl[@e]cSh>gfmMcSh67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h1<c<c003IVIVooooIVJI01_<c<`08?Wloo_mookon?Khj^SUh<Rm
cZJAbGiQ]I5^eYahhZ^9ikRIjKnQilBYk<Z`nLfeoljiolZjol^jolblom2o
om31olnnolbmoljnolfnoljnolfnoljmolfnolnnoljoo`S;_ol2c<3o7<^o
o`[<`?l2cKko01o>_Oo=__o>_Oo=__o>_Oo=__o>_Oo=__o>_Oo=__o>_Oo=
__o>_Oo@_?o@^?oA]Oo<[oo4Yo^mWoFeUnfXRmnLPLj<LkEjIIfTTko;_]cW
g_7jm?kon_kooOkoool01<c<c08000001Lc<c000000000000<c<c0020000
00?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P000003c<c<
0000000000;<c<`200001<c<c0800005c<c<0P0000C<c<`3000000?<c<`0
000000000/c<c0800018c<c<00=VIYW<c<c<c<`0G/c<c008WXdc/7/Y;1`D
ARl:H2l:LSP0H2lDSED:0iib2P0;/8dNWW8:WW8cWW8cWW8:YW8DWW8:YW80
/7/:WW8:YW8000:NLPX04jIW08=k<m>ZAlZZAlZQ?LZZAk2=<kV=:K2=7[1k
5;1k2YEE0;2=7[V=<l640;1k5;1k2[1k5;2=7P03^HdY00RiSC>`Q2V`Q2V`
Q2V`SAjiSC>iQ1B`SAh2^H@D01B=E@ZNLQC:ZVK:ZVKL/hC:ZVKL/ec:XCg:
ZVKL/ec:V1C:XE;:XCg:V2W:V1CCV0[:V1BiQ1BiSABiSBT2bZ5B00CCZTOL
ZS?:XCg:V1@2diP:0lZH5005^H@DbYPDbYPY`H@0^HdD00;:V2T01k2=7/ZH
5;V45=>H2[V=5;V=:K2=7P02bZ4m00?CZTO:XCg:XCd00]>ZA`;L_Zd01>Bn
Q>g@V<ZZI]c7X`C]d9P019ib2]bcQ<ZZI/ZZIP:iSC<02/ZQ?LZZAlZH5<ZZ
AlZH5<ZH:LZH5<ZH:MbZ<lZH50?:V2T01lZH5<ZH:LZH5<ZH5=>Q:M>H2/ZH
5004g:Xc00bNSBV`SE;CZTOCZTOL/ec:ZVKL/hC:ZTNiSC=P;aAkC0YP;`X2
Pbl000ab>1BiSC>iQ1CL/ec:V2ViSBViSC>iI`2iQ1B`N`Z`NbViI`02^H@D
00JiI`2iQ1B`NaC:XCgCZTO:ZTL2djY700CC_Xk:ZTO:XCg:XCd2bYPY00[1
Q02iQ1B`N`ZNLPZVI`2=E@YkC0Y6;`YG7016;`X28a`:00DA70XJ2@XA70XJ
2@XA70X00PT92P0K=2lN8blN4A`:2@TD4A`:2@T:6PT:4A`:6Q8D2@T:diP:
/7/:SED:Pd40PcP0ARHD8bH:8a`:6PT:2@TD4A`:6Q8D0000YXABYZ5Vb]3F
/;k100C:d=H2g>?P00I6IebVXIS:d=KLhn3]kN[Lhn1Qc<c<00AVIVJ8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`00fIVI_ooofIVV@0Kc<c<
01GioOokooonooShnn[Uh=[8^lnDNKanG;fCJ^:MM>Z[Q^JeT^:jVmnnXN?2
Y_75Z_W8/Oo7/?o7/?k9/ok<]_l00/jho`03cKOoc;Olc;Ol00;<]o`3cKOo
00?<^?o=^Oo=^Ol01/fio`C<^?l4bkOn4<^go`C;]oh4c;So2<jjo`S>^?l2
dK_o0]2jo`0EckWoc[SocKOoc[Kobjknc:coajOj`:3e^IS_/Y7XYXGLVg_>
U7S3Nf:SRgN/a;CKj=_eoo[ooogoo_[iooko00C<c<`2000000G<c<`0003<
c<`0003<c<`00P000003c<c<0000000000;<c<`2000000?<c<`000000000
0/c<c0800002c<c<0P000003c<c<0000000000C<c<`200001Lc<c0800002
c<c<100000?<c<`2000000?<c<`000000000B<c<c003IVJIc<c<c<c<05k<
c<`00iEE5:Ib514L2P02H2l:00UP;aB=E@ZNLPZEEAB=E@ZEEABNSBV3GQBN
LQ@01Iib2P04YW80UED0WW8:WW8D0ZIb0006Pg/cdjY7bZ4mbZ5BbZY7bZ4m
0[24:@06YW8D/7/:WW8D/7/:^HdY/8dN0[1k5008/7/:/8@Y^HdY^HdY/8@Y
^HdY/7/DYW8D0kV=5008^H@Y`H@0/7/D/8@YYW80Pg/ckLMLg;>40/ZZIP04
g;=LbZ5BbZY7bZ4m0/ZH:@0<bYPD/8dNbYPD^HdD/8dN^Hdc/8dN^H@D^Hdc
bZ4mg;=LbZ4m1LZH500@^HdDbYPD/8dNbYPD^Hdc^HdDbYPDbZ4mbYPY^H@D
^Hdc/8dN^H@D/7/:/8dN^H@D1<ZQ?@03diP:bZYVbZYV00;]d9P02]c7Xm>n
S]bcQ>BnQ=>nS]bn]mc7Xng@V8=N5=bcG0;:ZVH01<ZZAkV=<lZQ?M>Q:@;:
V2T00lZH5<ZH:M>Q:@02bYPY00C:XCg:V1C:XCg:V2T2bYPD00?CXBW:V2WC
XBT00]>Q:@0=bYPYbZY7g:Xcdj4Y/8dNWW8:djY7bZY7djY7bYPYg:Xcg;=L
bZY7009P;`X0278V04HV578V09EE0<ZZAlZH5<ZZI/ZQ?@>iQ1@06;Ub<kUW
0;1k2[V4:KV45<640;UW0;V45:Ib5=>Q:MbcG<ZQ?M>ZAlZQ?LZZI/ZQ?M>Z
AlZQ?LZH:LZZAlZH5;2=7[1k2Yib2P:=E@X0:7]<2SdL2V0_2SdL2R<L2Q4L
2QX92Q4L2PT950T92QXB514L2PT92R<V2QXV52<L2Q4L2PT92QXB50T950T9
2Q4L2PT95<640;1k2XeE2X=107]<54HV2R<V2R<L2Q4L2Q4V50T92Q4L2PT9
2X=N<mbcQ<[@e[2n`@;:d=H02/77c<[@e/[@e/[@eYFHXhfHS/77c=?Ie]?S
mMcSh67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1<c<
c003IVIVooooIVJI01_<c<`06?_noo_oookom_[jl>?JglbkgGMKYWiK`hiU
fiQ`hZJ1gZn=fK>Df;JHg[VLk[bPmL6VmKjVl[nWlL6Zl/B]mLN`m/RamLRb
l`C6/?42aZoc0/J_m@03b;7eak;eak;e00G7/_D8aK3c4<F`m@S5/?<8a[7d
1<NalPC7/?@2b;7g01O7/?K5[_C4[OG3[?C2Zo?3ZO?1Y?K1Y?RnW_>hV>^c
TNF^R^6SOmNHM<b@K/AlGJ]cFYc7/nKVfOOonOoooo[jn_3ooo/01<c<c080
00001Lc<c0000<c<c0000<c<c002000000?<c<`0000000000/c<c0800000
0lc<c00000000002c<c<0P0000?<c<`400001<c<c0800005c<c<0P000004
c<c<0000000000001/c<c0@00018c<c<00=VIYW<c<c<c<`0G/c<c004PehD
Nd`D?A`:Ea`00THV50:NLQ@01Yib2XeE2Yib59ib5:Ib09ib50BNLPX05;1k
2YEE09ib2Yib2ZIb09ib2ZIW08=N5=>ZAkV=<lZQ?KV=<lZZAkV=:KV=5:Ib
59ib2ZIb09ik<k24:@:iSA@2/7/D00b`SAjiSBViSBViSBViSC>`SAj`N`Zi
SC>iSAB`SAj`NaBiSA@2/8dN01>EEAB3Nc?L/ec:ZVKC_XkL/ecC_XkL/ec:
ZTO:XCf`SAk:V2ViSC?CV0[:XCfiSACCV0ZiSBV`SAh00[V=:@04bYPYbZ5B
bYPYbZ4m0/ZH500D^HdcbYPDbYPD`H@0^H@DbYPDbYPYbYPD/8dNbZ4mbYPD
^HdDbYPD^H@D/7/:`H@0/7/D^HdDbZYVbZ5B0/ZQ?@08^HdYg;=LdjY7dkj>
g;j]dkj>g;>4bZ4m0]>nSP05m]UVdkj>kM2HPehDg;=L00;:ZVH01/ZZAlZQ
D/ZH:LZQD/ZH:M>Q:@;:V1@05LZH:LZH5<ZH:LZH5;2=7/ZH:M>Q:K2=7/ZH
5=>Q:LZH5=>Q:LZH5=>Q:LZH5=bZ<lZH:M>ZAk24:H=N5=>ZA`03bYPD00Ji
I`3:V1C1Q01P;aAP;`YP;a@2H2l:00VNGQC:XCg:V2W:ZVKCZTN`SAjiQ1C1
Q03:V2T00[1k2P06/7/D^FL0/7/:`H@0/7/:WW8:0]>ZA`06bZ4mbZYVg:Xc
g;>4bYPYg;>40/ZZA`0=g:XcbYPY/8dN/7/:WW8:SED:WW8:Nd`DARl:Ea`0
ARl:8bH:6PT:00<A70X02PT92PT950TB2PT92S@_7R<_7Q4L2R`L514L2PT9
2P8A70X04aXB50000=>H2[1b09iN58eE2X=104H_2SdL2Q4L2PTB2PT951XB
50T9500004I17]bcQ;2n`L77c002b]3F00ZVan3Lhn2Van3Lhn23V8j3SHC1
alc:d=K]kN[Lhn1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^0C<c<`00fIVI_ooofIVV@0Kc<c<017ko_olooooooKnnoKSf>SA_^aP
@iMnF<F7G]BBJmRONm>YQm6_S]>bT]fgU_6iV_NkW_000[^OjP05_:3Z_Z?Z
`JK[`ZOZ`jS[00?2YnX01L6VjL6Vjl6Vjl6VkL6Vj`0=`:O[0l6Xk0o0Y^d0
1<2Wjl6Xk<6Xk<6Xk0G0Yn/8_jKZ1<2Uj0C0YNX2_jC[01NnXnZmX^VlX>Zk
WnVjW^RjW^^iVo6iVo>gUnbbTN:_S=j[QMZRNMFFK/j3FkajEk=VBIWC_O_U
eo[ilogoooCjo^goooX01<c<c0@000000lc<c0000000000200000/c<c003
0000c<c<c<c<008000001Lc<c000000000000<c<c002000000?<c<`0003<
c<`00/c<c0800004c<c<0P0000G<c<`2000000?<c<`0000000000/c<c080
00000lc<c0000<c<c002c<c<0P0004S<c<`00fIVVLc<c<c<c01Nc<c<00F3
GQAkC0YZ@@Yb>01kC1@00iib5003/7/:UEDDWW8D00:NLQ@03Yib2YEE09ib
2YEE09ib2YEE09ib2ZIb08eE2ZIb09ib2ZIb06YW<lZZA`>iSC<04K2=7[24
:K2=7[1k2ZIb09ib5;1k:K2=7[1b0;V=:KV=5:Ib5;1k5;2=7[V=:K2=7[V=
:@02/7/D00>`Q2V`NaB`SAh00[V=500I`H@0^H@DUED0WW8DdjY7bZYVg;=L
bZYVg;=LdjY7bZ5BbZYVbYPYbZY7bYPD^HdDbYPD^HdDbYPD^Hdc^H@D^HdD
/8dN^HdYbZ5B00;:XCd02LZH:KV=<lZH5<ZH5<640<ZH:KV=5;2=7[V=:@03
bYPY00C:XCfiSABiSABiSA@2/7/:00niSAB`LP3:XCg:XE;CZTOL/ebiSBW:
V2V`SAk:XCg:XE;:XCg:ZTO:XCgL/h@00]>nSP;L/h@038=N5=bcG=bcG<ZQ
?LZQD/ZZAlZQ?LZH5<ZH:K2=7/ZH:KV=:@?:V2T01/ZH5<ZH:LZH:M>Q:LZH
5;V450;:V1@06lZQ?LZH5=>Q:LZH5<ZQ?MbZ<lZQ?LZZAh=N5=bZ<k2=7/ZH
5;2=7[UW0;1b09iN57]<2V0_55LL060_58<_08=N5<ZZAmbcG<ZZI/ZQ?K2=
7P02/7/:00?1Q02`N`Z`N`X00[1k2P04^HdD^FL0bYPDWUhD0]bcG0?CZTL0
1m>nS]bcG=bcG<ZQ?M>ZAlZQ?LZH:@02^H@D00bNLPZ=E@Z=E@YkC0X/4P16
9PYG700A70X/4P0A70XJ2@X92@X24A`:01<92@XA70XS;ahS9PXJ9Q@A9PX9
4PXA70X94PXJ4Q@94PX92@ZiI`2`N`ZNGQB=E@Z3>0169PX/9Q@00QX92P06
2@TD6Q8D6Q8D0000H2lDm]240k2n`@09`LO<b]3Fb]3Fb]3FkNgZEei_SHe_
`LO1b]3F00;Lhn1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^0C<c<`00fIVI_ooofIVV@0Kc<c<01Smoo[noo[oooOoo?kXf_CI`_YF
=99eCl21F<j>I=2LM/fTP/bYR<n/RmZbS_2fToVgU^fhVNViV^ZiV^RjVnNk
WNNlW^JmWnL2_IoU00>mWnNlW^JlW^P00k^Mi`03_9kX_9kV_9kV00FlW^H3
^igU0[bNiP>mWnL@_9kX00>mWnVmWnNmWnL00[bNiQ6kWND2^igW0[bNj006
_9gY^icX^icX^icX^Y_Y^Y[]0[:Fk@0?[i;V[8_LZhGHZGoEWg7CU6O>PE?0
MdjhG3VEf;ooimWmmO;io_o]nOoWo_oh00C<c<`4000000?<c<`000000000
0P0000;<c<`400000/c<c08000000lc<c00000000003c<c<100000G<c<`2
00001Lc<c0800002c<c<100000?<c<`40000BLc<c003IVJIc<c<c<c<05k<
c<`03h=N578h58=108=N59j=:IiN59ib2Yib59ib2YiN59ib5;2=7Yib59ib
2YEE5004WW8:016EE@2NLPZNLPZEE@2NLPZEE@23GQCLZS>`SC?:ZTN`Q2W:
XCfiSC>`SAj`N`ZNLPZNLQ@00[2=7P0I/7/:/8@YYW8D^HdD/8dN/8@Y^HdY
/8dc/8@Y/8dN/7/D^HdDbYPD^HdY/7/D^HdD/7/D^HdDWW8:JVLci;=7djY7
bZYVg;=LbZYV00;:XE802<ZZAlZQ?LZH5;V=<kV=5=>H2Yj=<l6400:iSA@0
3[V45;24:KV=:LZQ?LZH:K2=7/ZH:KV=5=>H2[V=:LZH5;2=7/640<ZH:@;:
V1@02;V=:LZH:LZH5;V=5<640;V=5;1b0;1k2P:iQ2T2bZ4m00>iSC?:ZVK:
ZTL00YEE0005WW8:^H@DbYPDbZ5BbZY700;:ZVH03]bcQ=>nS^g@V7]10=>Z
AlZZI/ZZAlZZI/ZZAm>Q:LZQ?LZH:LZH5;V=:@?:V2T01/ZH5<ZH:KV=<lZH
5<ZQ?L6400;:V1@03;2=7/ZH:LZH5<ZH5<ZQ?LZZAlZQ?M>ZAmbZ<fY12]bc
G<ZH50:iQ1@03[1k5;UW09ib578h560_560_2W8h58eE2W]<5<ZH:LZZI/ZZ
AlZH:K24:@>`N`X2^FL000o1Q02`NaC1Q02`N`Z`SAjNLP[L/hCL/ec:ZVKL
/ecC_XkL/hCCZTOL/hCL/e`00/ZQDP0:bYPD/8dN/7/DWW8:WUhDUEDDNd`:
ARl:ARH:Ea`00Q4L2P8J2@X00a4L2PT92PT92P022@T:00@J9Q@S;ahJ9Q@A
70X22@T:00/92A@94PXA70X0002iQ1B`N`ZNGQB3>01kC1A69Q@m70X0114L
2P064BHD2@TD?A8:kM2HUJZ]/;k10/77c0;:d=H01]cSh=?SmG:=Q8>4Nk2c
]l77c0;Lhn1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0
^0C<c<`00fIVI_ooofIVV@0Kc<c<01GnooKoooKoooOoo?o`hOoMaOmE<i5T
?ZejD/F6G<RCK<FMN<FPO/ZTPMFYPnZ/Qo2aS^ZcTNNeTnVfU>ReU>D00[FD
h`03]YKR^9ST^9ST00:gUn<2]YGT0[FDh`0>^9OV^9ST^9OV^9ST^9OV^9ST
^9OV^9ST]ICS]IGQ]YGT]YKR]iKU]iOS0[RGiP:fUN@07KJEi[JEi;JEi[JE
i;JEi[JEi;JEi[JEi;JEi[JEi;JEi[JEi;JEi[JEi;RGi[RHi;NFiKNGhkJE
i;JFh[FDhkFEhKRGi[RHi;RGi[RHi;RGi[RHi;RGiP05^9ST1;RGiPBgU^L3
]iGY01:fU^^[SnJZS^>WR]bTP]JSNm6QM=6GI/n=FlZ5E<Y]@K9C;XkF_?o`
h_okn_olonchonGnooP4c<c<0`0000?<c<`300006Lc<c080001Mc<c<00=V
IYW<c<c<c<`0G/c<c004PehDJT4:PehcUED00Yib5006YW80PehDWW8DWUhD
WW8DYW800Yib2P08Nd`:UED0UEDDUED0SED:UED0YW80SED:0Yib2P04YVL0
H44DbZ4m/8dc0[V=:@0D^Hdc/8dN/8@Y/8@YWW8DYW80/8dN/7/DYW8D/7/:
^HdDYW8D^HdD/8@Y/7/D^Hdc/8dcWW/cYW80^Hdc0[2=7P0>`H@0^HdD^HdD
^HdDUED0PehDi;=7^JY_bZY7g;=LbZYVdjY7bZY7g:Xc0[V=<`07bZ4m^HdD
bYPD/780`H@0^HdD^H@Y00:iQ1@01kV=:LZQ?LZQ?LZQ?LZH:M>H2[V=5002
bYPD00?1Q02iSABiSBT00[V=<`0F`H@0^HdD^HdY^HdD/8dN^H@D/7/:`H@0
^HdY/8dN^HdcbZ4mbZ5B/8dc/8dNNd`DLSPDWUhD^HdDbZYVg;>4i;=70]>n
SP;L/h@01ng@V8=N5=>ZAlZZI/ZQD/ZZI/ZQDP03bYPY00G1Q03:V1BiSBWC
XBW:V1@00/ZQ?@?:V2T2^HdD0m>H2P?:V1@03/ZQ?MbZ<m>ZAmbZ<fYE7^g7
G<ZH:KV=5<ZH59iN5<640:Ib578h08eE2P:3>000178h5:IW0;2=<lZQDP;:
V2T03;24:K1b0<640;1k2[UW0;V45<640;1k2[UW0<640=>H2YEE00;L/e`0
1=>nS]bcQ=bcQ=bcQ0;C_Xh04]>ZAmbcG=bcG<ZH5;24:K2=7[1k59ib2X=N
57]<53dB2THV2TH_2R<L2R`B014L2PT92Q4L2P892@X01A4L2PT92QXV52<_
7QXV50044A`:01<92A@A70X92ABVC031Q02NGQB=E@Z3@@1P;a@S9PXJ2@X9
4PXJ2@X94PX92A@0000S70[ohhjEV:<00/77c00;Y/OP`LO<b]3FY/OPkNgZ
H79kJW]_`LO</;k1kOKeg>?P067<c<`016IVIXS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVooooIVJI01_<c<`2oooh01?noOSoo?oi
j_oRbomN@9QH<ie/A;IgD;^7H;fAJl2GLLBIMLfONMjSO^FVP^:YR>>]S>N_
S^N_S^D00Zj>h`05[XkQ/Y;U/I7T/I7T/93S00:_Sn@2[XkS012aTNJaTNBa
TNJaTNBaTNJaTNBaTNJaTNB^S^>^S^6_SnB_Sn:`T>FaTNBaTNJbT^L2/93U
01j`SnJ`T>F`SnJ`T>F`SnJ`T>F`SnJ`T>F`SnJ`T>F`SnJ`T>F`SnJ`T>Fb
T^NaTNBaTNJ`T>>_SnB_Sn:^S^>^S^6bT^NbT^FbT^NbT^FbT^NbT^FbT^Nb
T^D4/i?V1;>Cj0>_S^D05Zj=i:j=iZf<iJf<iJZ<hZ27fYn6ej20di]gciY^
cIIVc8eHbX=<`ga6`68bXU/fTmo4oo_`ooonoo[ok?_oj_kon0C<c<`30000
0lc<c0<0000Ic<c<0P0000G<c<`20000E/c<c003IVJIc<c<c<c<05k<c<`0
1Iib59ib<g]<57]<2Yib5002SED:00NEE@23Nc>EEABNLPZNSBVEEABEE@00
0XeE2P07UED0PehDUED0UED0UEDDSED:WW8:00:EE@003VYE7]bZ<k2=<lZQ
?KV=<lZZAkV=<kV=:K1k2ZIb59ib2Yib5;V=5:Ib00:`N`X2YW8D00^iSBV`
Q2ViSC>iSC>`SAj`N`ZiSC>`SAj`Q2ViSAB`LP000[V=50:3GQ@03<ZZI]bc
G<ZZI/ZZAlZZI/ZQD/ZQ?LZZAlZH5<ZH:KV=<l6400:iSA@00kV45;V=5;V4
5002/8@Y00RiSBW:XCg:XCg:V2ViSAC:V1C1Q03:V1@2/8dN00S1Q02`Q2W:
V1BiSBViQ1BiSAC:V1B`Na@2^H@D01;1Q02iSC?:XCfiQ1C:ZTNiSC>`SC>V
LP1P;aBNGQBEEAB`N`[:XCgT_XC:ZVKC_XkL/hCLaj<2dkj>00CT_XB3Nc?:
ZTO:ZTL2bZ5B0/ZQ?@;:V2T2^H@D00?:V1BiSBW:V2T00/ZH:@07^HdYbYPY
bYPYbYPD`H@0bYPD^Hdc00;:V1@03lZH:LZH5<ZH:LZH5<ZQ?M>Q:G]<2]>Z
AlZH:L640;V=<k1b0;UW0;V458<h0002LSPD00EkC1B3@@2EE@2`NbW:XE80
0/ZQ?@03/8dN`H@0^H@D00:iQ1@01;1k5;1k2[1k2[1k2P:iI`000jIb0=>n
S^BnQ002g;>400oL/ec]d9SL/ecC_XkL/ec:ZVKL/ec:ZVK:V1B`SAjVLQBN
GQBNLQBEEA@S9PX00TH_2P0<4A`:8a`:4A`:2@T:4A`:2@T:4A`:2@T:2A8:
2@TDAT4N6RHD0Q4L2P0G6Q8D00002A8:6Q8D0000UD`Y`H@0YW8DUEDDPd40
ARl:?A`:8a`:4A`:6Q8D2@T:6Q8D2A8:2@T:bZYVYZZS`LO</;k100;1al`2
b]3F00GLhn23V:ebIe:`_/71al400]cSh67<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1<c<c003IVIVooooIVJI01_<c<`04okon_km
nOgjmOomooobonGBofY>Ve8`TEhhYFY3/7]C]XMP_HmX`IE^ai]feYmkfiek
fJ22g:J8h002ZH_Q00>XRmnXRmfXRmd00Zb?g`04ZhkNZXgMZHcNZHcN0ZR;
g`RZSMl2Z8_M0ZV<gP04ZXgOZhkP[8oQ[8oQ4:Z=h@:/Sn401:^>h:Z=gjV<
gZV<gP:XRmd8ZhkP0Zb?g`B/Sn42[8oS0Z^>hP03ZXcRZH_QZ8[P00:VR=h0
4ZF8fYV1biZ0bYQhbi=^bi9Uc8eKbXA=aGY2_FLbZ5LXT6a9VnkFoooioocm
oo?ojoWokokonXG<c<`00fIVVLc<c<c<c01Nc<c<00VNNc>NLQB3GQAkC1BN
LQBEEAB3GQAkC0Z=E@X00X=N5005WW8DWW8:SED:SED:Nd`D00>3@@005HeE
2X=108eE2YEE08eE2YEE08=N5<ZQD[2=<lZQD[2=7[V=<k2=7[24:K2=7ZIb
08eE2ZIb5;1k2ZIW0:Ib0002/7/:012VLQBiSC>`NaB`Q2V`SC>`N`Z`SAj`
Q2V`SAjiSBViQ1B`SAj`LP2`NaBVLP1kC1@2g;=L00G:XE;L/ec:ZVK:ZVK:
ZTL00/ZQ?@03^HdDbZ4m/8dN00>iSA@01[V=:KV=5;2=7[V=<k2=7]>ZA`:i
SC<04L640;V=5<ZH5<640<ZH5;V=5;V45;V=<kV=:LZH:KV=:LZH5;V=<l64
0;2=7[V=5;1k5002^HdY00ZiQ2ViSBW:XCg:V1BNGQA69QAP@BVVLQBiV5c:
ZVH2dkj>0]bcQ005g<NSdkj>kM2HkM2HPg/c00?:XE800m>ZAlZZAlZQ?@02
bYPY00_:V1BiSABiLS?:V1BiSBW:V2W:XCg:V2V`SAk:V2V`SAh00[V45005
bYPDbYPY`H@0bYPYbYPD00;:XCd01MbZ<lZH:H=N5<ZQ?KV=<`02^H@D01B`
LP2`N`ZiI`2`N`ZVI`2VLQB3>02NGQBEEAB`NbW:XCg:V2ViSAB`NaBiI`2i
Q1B`NaBVLQB`N`ZiQ1@4/7/:00>VI`3:ZVKL/h@00mbcQ00Adkj>g;>4bZYV
g;=LdjY7dkj>bZY7bZ4m^HdYSED:JUDNUEDDPehDARHD?A`:H2l:4A`:008J
2@X04a4L2PT92PT92PT92Q4V50TB2PT953AE:B<L2Q4V2PT950TB2QXB514L
2PT950TB2X<_0;1k2ZIb5002SED:00]P;`Xm70XS70XA70X92@XA70X92A@J
4Q@0002`SC>3Q7/00ZJc`@09`LO1`LO<b]3FY/OPg>?PUJ6gH5hcYZZ]/;k1
00;Lhn1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<
c<`00fIVI_ooofIVV@0Kc<c<01Soo_omnokoo__kmOGonooom_n:L:mA<HIJ
=IaH<Ym[A:j6H<F:Hl2UO]N^Qn2]Rn6_T^B`UNJcV>NbUnBaU^>aUn6dV^>g
WN@2]I_R00BdV^6cVN2bV>6bV>42/IOQ2;>Li0:_V>02/9WQ00NaV^:bVn>c
W>BcW>BcVnFbV^B`V>800ZnGh@03/9SR/Y[T/i_U00:cVnD01;:Ji;6Ihk2H
h[2HhP:_Un42/icT00BbVn>aV^:`VN6`VN42[iSP2;>Li0:eVn84]I_T0[FK
i@04]9[T]igW]Y_X/YOT0ZnDh@0C[Y?PZi7JZI3A]YgOY8CGW7OGXW?SN4Fn
NTC0GbVQDb:=FRn8QFNWoo;ooo[omoSjnOohl?_]o_ok08G<c<`00fIVVLc<
c<c<c01Nc<c<0Yib5003PehDSED:UEDD00:3GQ@00g]<58=N578h5002UEDD
00B3GQBEEAB3>01b>002Nd`:00=b>1B3@@1kC0X00YEE0004UEDDUED0H44D
g:Xc0/ZQ?@:iSC<2/8@Y00FVLQB`NbUk@@2`SAjVLQ@00Yib2P0=/7/DYW8D
/8dN^HdYWXdc^HdcbZ4mWW8DYW8D^HdYbYPY^H@D^H@Y00:iSA@02K1k59ib
2VYE7]bcG<ZQD]bcG<ZZAkVZKlZQDP03bZ4m016iSBW:XCf`SAk:V1BiSAB`
LP2`SAj`N`Z`SAj`N`ZiSBV`SAjiSBW:V1B`NaBiQ1B`N`X00[V=5008/7/:
^HdD^HdYbYPY^HdY^HdD^HdcbYPD0[V4500<^H@Y/7/:bYPD^HdY/8dNbZ4m
^HdY/8dNYVL0LSPDNd`:/7/Y1=bcQ0;C_Xh01]c7Xng@V=c7Xng@V9j=<lZZ
A`C:ZVH02<ZQ?M>Q:LZQ?K2=7/ZH5;Ub<k2=7]>Q:@;:V2T0<;1k5<ZH:LZH
:K2=7[V45<ZH5;V=:KV=5=>Q:LZH5;V=<lZH:LZH5<ZZAm>ZAg]10=>ZAkV4
:KV45;V=<k1k5<640;V45;1k2[V45<ZH5;V=<k24:IEE5<ZH5<ZQ?K2=7[V4
5;1k2[V45;1k2Yib59iN59ib2/640;1k2[1b0:IW0;1k2ZIW0;VZKnBnQ=c7
X`;C_Xh2g;>400cC_XkCZTO:XE;:XE;CZTO:XCfVLQAkC1A69PYZ@@YkC1AP
;`X2ARH:0R<L2P044A`:2@T:4A`:2A8:0PT92P8J4Q@01B`V52<_7Q4L2QXB
50TB2P022@TD01lJ4Q@92AAP;aC:V1BVI`2NGQAkC1AZ@@Y69Q@J4Q@J2@XA
70X92A@J4Q@92A@0002ELTN`Q6K1albV/l6Van2`_/7:d=K1alcLhn2EZZe?
IdN`/kN`_/7ChoGLhn00HLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;P4c<c<00=VIVKooomVIYT06lc<c0;oo?l2ookk01GonOcml?o>
^>Hi7V==;8M78X]ZAJmaBk:ROMb]Q]njU>N`T=bmXnZnYn_1Z^k1ZnboZNVo
ZNO2[>[4[n[8/nh00/Nbk@03a[7/aJo]aJo]00;4[^h8a[;_0/>_k0;4/>d0
1lFak/JbklJbklNcl<Ncl/JblLB`k`02`jo^00C4/>o6/_77/o;7/o82a[;a
00?5/O34/>o4/>l00/>_kP04ak?`a[;_a[;_aK7^0/B`k@;3[n`8a[;_0/Nb
k@C7/Nl2ak7a01W4[^k6/?36/?73[Nk1Znc2[>g1ZnbnZ>S9/N^cVMZ/Rmc:
Y?n3ElYd@[ec@KYD999L<He78fW>]>?mkoonn?onooobnoKioo_nool0QLc<
c003IVJIc<c<c<c<05k<c<`00iik<iib59ib5002PehD02BEEAB=E@ZNLPZ=
E@Z3GQBEEABNLQBNLPZ3GQB3@@1Z@@Yb>01kC0Yb9P23>02=E@Z3@@2EE@2N
GQBVC01P@ACCZTNiSC?:XCfiSBViSC>`SAj`Q2VVLQB`SAj=E@ZNLQB`N`ZE
E@2VLP2NLPX2YW8D00NiSBV`NaBiSC>iSC>`NbV`SAj`Q2T00[2=7P03^H@D
/7/:/7/D00:`N`X04f115=bcG=bcG<ZZI]bcQ=bcG<ZQD/ZZAlZQD[V=:LZH
:K2=7/ZH:KV=5;1k5;1k2[1k5;V=5;1k5002/8@Y00>iV5c:V2V`SAh00[1k
2P:VLP003[1k5<640;1k2[1k2[2=7/ZQ?K1k5<ZH5;24:KV=5;V45;V=5;1k
5;V=<`:iSBT02;V=<lZH5;V=:JIb59EE0;1k:Iib5<ZZIP?C_Xh00mbcQ=>n
S^g@V002g;j]01C]d9RiV5c:XCg:XE;:ZVKCZTO:XE;:XCfiSC?:V2W:V1Bi
SBViQ1C1Q02iSC>iSBViSC>iLS?1Q02`SAh3^H@D00?:V1BiQ2W:V1@00/ZH
500ObYPYbYPDg:XcbYPDPg/c/8dNbYPY^HdY/8dN^H@D^FL0`H@0/8dN/7/:
^H@DbZY7/7/YUEDDbZY7bZ4mbYPY^H@D/7/:^FL0YW80YVL0YW8DWW8DYVL0
WW8:/7/:00:`LP000iib2[2=D^g@V002dkj>00oL/ecC_XkC_XkL/ecCZTO:
ZTO:XE;LZS>`Q2VVLQB3GQ@/71@A70YP;aAZ@@X00TH_2P05;1808a`:6PT:
4A`:2@T:00894PX01Q4L2PT92QXL7R`h:AXV514V508A70X031XB514L2Q4L
2PT955LL0<6409ib2YiN58=1078h54HV52`V508A9Q@02@TB2Q4L2PTL5000
09F4D[2=<k2n`JJc`L77`@02`LO<00RVan3Lhn2V/l56GTNVZZf`/kOCfMKL
hn1Qc<c<00AVIVJ8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
0fIVI_ooofIVV@0Kc<c<01SooOonoOokn_Sooo[nnOGomOgomon2KZ4i7fU5
9X=48HEdD;BNNMSD/?o6Y?7=[_;1ZNG2[nK5/^W6]>S4/^C3/N75/n?8]n@3
bKSU00?8]nC7]NG7]ND00/JdiPS9]nL2a[CT0/Nei@03b;KVbKOWbKOW00;9
]nL01/Rfi/NeiLJdi<Jdi<NeiLRfiPC9]nL00lRfi/NeiLNei@02a[CT0lVg
i`03b;KVakGUakGU00;6]>@8bKOW1<Vhi@C9]nL06LNeilZhj/Zhj/NeilNe
jLRfj/NejLB`iKjUg<JXj<FSmkNAm:1fiW13^58VUdDKOD0NJ8ebYOoboook
ooGcn?SjnO_oooSno_koo`25c<c<00=VIYW<c<c<c<`0G/c<c003YXABWW/c
WW/c00:NLQ@039EE58eE2X=N59EE08eE2Yib2YEE59ib58=1078h07]<2ULL
009P;`X00eLL07]<2X=10003SED:00AZ@@[:ZVJiSBW:XCd2^Hdc00b`SAj`
SC>`SAjVLQB=E@ZVLP2NLPZVI`2EE@2VLP2VLQB`SAh2/8@Y0[2=<`07/8@Y
/7/D/8@YbYPD/8dN^H@D^HdD00:`N`X00iib2VY12]bcG002g;=L02S:ZVKL
/ec:XE:`SC?:ZTO:V1B`SAk:V1B`SAjiSAB`LP2`N`Z`NaB`Q2VVLP2`SAj`
SC>iSC?:XCf`SAjiSAB`LP2`N`ZVLP2VI`2`N`Z`NaBVLQC:V2ViSBViQ1C:
V2ViSC>iSAB`NbViQ1B`SAk1Q02iSC>`SAh2^Hdc00JiQ2V`SAjVI`2iV5bi
Q1C:ZVH2g<NS0]>nSP03kM2Hg<NSdkj>00;Laj<06JJQI[V=<lZZAlZZI/ZZ
AlZQ?KV=:LZZAlZH5;V=<lZH:KV45;1k2[V4:KV45;2=7[1k2[V45;1b0;V4
:K1k2/640;V=5;V45<640002bYPY01NiSBViSAC:XCgCXBVNLPZiSC?:XCfi
SBV`SAjiSC?1Q02`N`Z`LP2EE@2`LP2iSAB`NbViQ2W:XE;:V2V`SAjiQ1BV
LP000[1k2P0=SED:UED0WUhDWW8:YVL0UED0YW80YW8DYVL0YW8DkM2Hg;=L
dkj>00;L/h@00mbcG=>nS/ZQDP02bZ4m00niSBViSAB`NaAG700m70XJ2@Y6
;`YG70169PY6;`XS9PXS70XA70XJ2@X94PX00`T92P074A`:2@TD;2HD8a`:
4A`:2@TD6Q8D00<92A@00`TB2QX92/ZH5002WUhD015kC1Ab>016;`XJ4Q@J
2@X92A@J4Q@92A@J4Q@0003:XE:VLU:`_/6V/l6`/kNV/l71al`00l[@eP05
CfMLUIRS/;>gdmWFg>?P067<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2h1<c<c003IVIVooooIVJI01_<c<`06_omooWhooonooKel?oo
n?omoOojooSXog5LUb@9ESXLM650Vi9_bK:?hk^IiLR[kL6Yhl>_h/RdilVe
i/RdiLNdh/Vfhl^ihlReh/Rfh0?7]>43a[?Q00k8]N?8]N;8]N?8]N;8]N?8
]N;8]N?8]N;6/n76/n36/n77]>77]>;7]>43b;GS00?7]>;6/n76/n400/Jc
h@04akCRb;GSb;GSb;GS0lNdhP?6/n403lRehlReh/Ndh/NdhLNdh/Jch<Jc
hLJch<RehlReh/RehlReh/RehlReh/Reh`07b;GR0lReh`0Hb[OUb[KWak?T
ak?Tb;CUa[;U`jcPcJo[^ISMdJko]I3`S6G?DBZD@Qem<A1QJe:;ooCoooGo
oo[lookoo?kmn_goo?ooo_ooQLc<c003IVJIc<c<c<c<05k<c<`01;2=<iik
<k2=<iik<`:NLQ@01H=N59ib2YEE08=N58=k<`02WW8D01R=E@Yk@@1P;`YP
@BU69PYG701P;aAb>023@@2=E@ZNLPZVLP16;`[:XE:`SC?:XCfiSC?:XCf`
SAj`SC>`SAj`SC=P@ABNLPX2SED:00NEE@2NLPZNLPZ`Q2V`SAj`NaBiSBT0
0[24:@0<WW8D^H@Y^HdY^HdY/8dN^HdD/7/:^HdD/7/:JT4:g;>4bZY70/ZZ
IP0;g;=LbZ5BbZY7bZ4m^HdYbYPD^Hdc/8dN/7/D/7/:WW8:00:iSA@02[1k
2ZIb5;24:K2=<kV=<kV=:K1k2ZIb09iN5:IW00>NLPX05[1k5<ZQ?LZQ?KV=
5<ZH:K2=7[V=5;V45;2=7[1k5;2=7[V=5;24:LZZAlZQD[V4:KV=:Iib2/ZQ
D]>nS/ZZI]>nSP;]d9P2dkj>013]d9S:_Zg]d9S]d9S:ZVJ`SE;:ZTO:XE:i
SC?:XCg:V1B`SAk:V2W:V1C:V2ViQ2T2^H@D00>iSABiQ1BNLPX00[V45003
/7/D/7/:`H@000:iQ1@04LZH5;2=7/ZH5<ZH5<640<ZH:M>Q:Iib5;V=<kV=
:LZH5<ZH:KV=:KV4:LZH5;1k2YiN5002/78000JiQ1B`SAk:V2W:V2ViQ2V`
N`X3WW8:012EEABVC02NGQBVI`2NGQB=E@ZVC02NLPZVLP2VLQC]d9SL/hC:
ZVKL/hC:ZVKLaj<4bZ4m00G1Q02VLQB`N`YP;`XS9PX00THV2P0=H2l:ARH:
ARH:8bH:6PT:8a`:2@T:4A`:2@T:4A`:2@T:6Q8D2A8:008S;ah02AXV50TB
2PT950TB2PT9514L2QX92PT95=>40002YW8D00akC1AP@A@m70X/71@A70XJ
4Q@94PXJ4Q@92A@0002`SC>NQ6H2/;>g00>V/l6`/kO1al400/77c006b]3F
AVMLUJ6>UJ6gdmWFg>?PHLc<c004IVIVR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;P5c<c<00=VIVKooomVIYT06/c<c00KnO[onO[nooooookjoooj
ookkin3XooWooo7o?BQP>R1WDSJ3MEJV/I3O]iOR^YcR]igN^j?O`JWUa:cV
`jcT`Z_Q`jcPaJoPa:gQa:kOa:gQ00;3[>03`jcR00k4[N?4[N74[N?4[N74
[N?4[N74[N?4[N73[>;3[>33[>;3[>33[>;4[N43a:gS1/>/hPC4[N<5`jcR
00o4[N?4[N74[N?3[>33[>;3[>33[>;3[>34[N?4[N74[N?4[N74[N?4[N74
[N<01lB]h@;4[N<00l:[hL>/h/:[h`03`:WQ00nlY=jgWMZnWN;3W^^[QMbA
KLMN>iMA<8Lb5V50:6Com?ojk_ooo?oooogbl_000_koo`03nO[nooooc<c<
08C<c<`00fIVVLc<c<c<c01Nc<c<00>VQ5:NSC>`SC<00Yik<`04/8dNPehD
UEDDUEDD0Yib500FWW8cWXdYNd`DNd`:H2lDARH:Ea`0ARHDLRH0H2lDH2l:
Pd40Nd`DYT`0ARl:g;=L^Hdc^HdY^Hdc^HdY/780WXdY0ZIb5008H2l:Pd40
UED0UED0SED:YW80/8dN/8dc0ZIb500B/8dc/8@Y/8dN/8dN^HdY^Hdc/8dN
^H@D/7/D^HdD/780/7/:H2l:bZYVg;=L`K>>bZYVbZY70lZQDP05bYPY/8dN
/8dN^HdD/8dN00:`N`X2/78000>VLQB`NbV`Q2T00/ZZA`0>/8@Y`H@0/7/:
YW80WUhDUED0WW8:/7/D/8dN^HdcbYPY^HdY/8dN^HdY0[V4500:^HdY/7/D
^HdD^Hdc^H@DbZ5BbZY7bZ4m^HdY/7/D0/ZQDP0@bZYVdkj>dkj>g;>4dkj>
g;>4g<NSdkj>kM2Hb[j]dkj>^HdDbZ4mbZ5B^HdcbZ5B0lZH:@03^HdY/8dN
^H@D00:iQ1@01k1k2[1b0;1k2ZIb5:Ib0;1b0;1k2P02^H@D00G1Q02iSC?1
Q02iSBViQ2T00/ZH500Adj4Y^HdDWW/cbYPYbZ4m/8dNbZ4mYW8D^H@D/7/:
YW80/7/:/780^H@D/8dN^H@Y^HdD00:`N`X01JIW0;1k2YiN59ib2YEE0002
SED:00Z`NaB=E@ZNGQBVI`2NLPZ=E@[]d9SL/hCC_XkL/h@2dkj>00SL/ec:
XE;LZS?:ZTNiQ1B`N`ZVI`1kC1@2?A`:00mb>1AZ@@XS9PYP;`XS9PXS70XJ
2@X92@XJ4Q@92@XA70X92@XA70X92@XS;ah00QXB500G4BHD6Q8D2A8:2A8:
2@T:2A8:0000/8dNWUhDYW80Nd`DLSP0ARHD;1`D4A`:2@TD4A`:6Q8D2A`D
2@T:=2lN/8dcYZZS00:`/kL02ZJc`JK7h:K7h<77`McSh4IWG9FQSZJZXl77
c=cSh67<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1/c<
c003IVIVooooIVJI01W<c<`02?_mo?koooclo?oooOgln_oooO[enOoko`;o
m_l03TlkL3HMGU<hOeDfPXYY^:>3cj:3cjR:e;2Bg;BFg[FGgKBGf[FHf[NJ
fP>fVMT2]YWK1;JIg0nfVM/A]YWL5KJIf`>fVM`00kNJgKJHg[BFg002]9KL
01>_TMVYRMBTOM2]QM^7HKQ[B9a59W@L0DIVDH[om_oonOoooOooo_o/k>[n
oognooo]k_3nooooool0QLc<c003IVJIc<c<c<c<05k<c<`01k2=D[24:IF4
DZIb5;24:Ij=:IEE5004WW8D00bNLS>NNc>3@@1kC1AZ@@Z3;`0m70YP;`Yb
>1Ab9P1b>01kC1@2Pd40011P@ACL/eb`SC>iSBV`SC>`Q2V`SAj`SC>`N`ZN
LQAP;`YZEAj=E@ZEE@2=E@Z`N`X2YW8D00NNLQB`Q2V`Q2VNSC>`SAjVLQB`
SC<00[2=7P>iSA@00k1k2[2=7VY12P02g;=L0lZZIP;:XE802/ZQ?KV=:KV=
<kV=<kV=5;2=<k1k2ZIb0;1k2ZIb00:`SAh08ZIb0<ZQD[V=<lZH5;2=7[1b
09ib2XeE2Yib2ZIb59j=:K1k5;V=<lZH:KV=:LZH5;V=:KV=5;1k:K2=7[1k
2[V=:K24:KV=:LZQD/ZZAlZQ?K1k5;2=7/ZZI/ZZAlZZI]>nS]c7X`CC_Xh0
1^g@V=>nS^g@V;VZKk2=<kVHG0;:XCd01<ZZAlZH5;V=<lZH50:iSBT02;V4
5;2=7[1b0:Ib5;1b0:IW0:Ib5:IW00:`N`X08K1b0<ZH5;1k5<640;V=5<ZH
:LZH5;2=7/ZH:M>ZAk2=7Yj=:LZH:KV=<kV=:LZH:K1k5<ZH5;V45;1k2[1b
09ib2[1k2ZIb0;V4:KV45;1b09ib2ZIW0:Ib58eE2ZIb09EE0002SED:00RV
C02EE@2=E@ZNLPZVLQBEEACC_XkL/h@2dkj>01?L/ecC_Xk:ZTO:ZVK:XCfi
SBV`SAj`N`ZVI`1kC0Xm70YP@AAb>1AkC0Xm4PY69PY69Q@A70XS70X00Q4L
2P0300002@T:4A`:00892@X28blN010A9Q@J2@X92A@J4Q@92A@A70XJ2@X9
2ABiI`2NGQBNLQB=E@YP;`Y69PXA70XJ2@X26Q8D00L92A@94PX92AA6@AjV
Q5:EV:>V/l400k2c]`08b]3F`LO<b]3FCeiVSIR>YZ6Hb]3Fg>?PHLc<c004
IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P7c<c<00=VIVKooomV
IYT06<c<c005o?oho?ojn?[go_oonOWk00;oo_l04Oojo_kfoooiooofog]U
US`RHchRKE4aQ5LeS7E@[GaG]8EP_H]W`HaX`8aX_heY`8m/`003SFZn0XeY
`0>=JL4@S6[00haZ`@:=Jl8:S6[14HaZ`0J=JL02SFW1016?Jl>@K<B?JlF>
J/B?JlF@K<J:IL:5G[]cAjQK;hi?9gl^35To8VB2KZ?olooon_oZj?H00_ko
o`06n?[go_omm_Seoooono_kooooQLc<c003IVJIc<c<c<c<05k<c<`01ij=
<iik<k2=7Yik<iib2[24:Iib2P02WW8D02B3GQBNLQBNSBV`Q2V3GQAb>1B3
GQAkC1B3;`1P;`Yb9P1b>1AkC1Ak@@2=E@ZEE@169QCLZS>iQ2ViSBV`Q2V`
LP2VLQB`SAjNLQBEE@1b>1AP;`YkC0ZEE@2NGQBVLP2NNc>`SAjVLQB`NbT2
/8@Y00>`SAjVLQBiQ1@00[2=7P08^HdD/8@Y/7/:/8dNWW8DH44Dg;=LbZ5B
0lZZIP04bZ5BbZ4m/8eBbZ4m0[2=7P0<`H@0/780/780/7/:/780/7/:WW8D
/7/:/7/YbZY7^HdY^Hdc0[1k2P0:WW8:SED:PehDPbl0YW80YW8D^Hdc/8dN
^HdD^HdY0[V45007/7/Y/7/D/7/:/8dc/8dN^HdYbZY700;:XE801[2=7]>H
2/ZQD/ZQD/ZZI]c7X`CC_Xh2g<NS00S]d9SL_ZgC_Xj`SC?:V2W:ZTN`SAk:
XCd2^HdY0/ZH500GbYPYYW80^Hdc/7/:YVL0WW8DYW80UEDDNd`DYVL0/7/:
^FL0/8dN/7/:/8dN^H@DbYPD/8dN^H@YbYPDbZY7/780WW8c00:iSBT2bYPD
00BiQ2V`SAj`SAjVLQ@2/7/:0Yib2P:`N`X01;1b0:Ib5:IW09EE00:NGQ@0
0iEE09iN58eE2P02SED:01>VC02NGQBVI`23@@3T_XC:ZVKC_XkL/hC:ZVKC
_Xk:ZTO:XE;:XCg:V2V`SAj`NaBNLPZEE@1P;`X00W]<500:JT4:8bH:ARH:
8bH:4A`:6PT:2@TD4A`:2@T:4A`:0PT92P0B2A8:;2HD;2HD6RHD2@TD6Q8D
2@T:4A`:2@TD4A`:0000/7/:YVL0/7/DPd40H2l:ARHD6Q8D0Q4L2P0:2A8:
6Q8D6Q8D2@TD;1`DbZ5BUHAkY/OPUJZ]/;>g0ZJc`@07`LO<dn?eJW]_PhB>
UIRS`LO<g>?P067<c<`016IVIXS0^8S0^4R@R04000000004R<2hb>3HR<2h
R<2h2<c<c003IVIVooooIVJI0?mVIYT?IVJIH<c<c0FNNc<039j=<iEE57]1
08=N59ib59EE59ik<iib59iN560_2YEE57]<2P=69PX2ARHD00MG701b>1B3
@@16;`[:ZVJ`SAjiSBT00[2=7P03WW8:/8dN/7/:009kC1@06DH_2VY12W]<
58eE2Yib5:Ib5;2=7[24:K1k59j=<k24:Iib2ZIb5;V45;V=:KV=5;1k2[24
:KV=5;1k2[V=56115<ZZAlZZI]bcG002bZYV0lZZA`0MbZ4m^Hdc^Hdc^HdD
/8@Y/7/DWW8:/7/:YW80/7/:WW8DYW8DbZ5BbYPY/8dN^H@D/780/7/:Nd`D
ARHDLSPDWUhD/7/D/8dNbYPY^HdD^HdY/8dN/7/:00:`SAh01Yib5;1k5;V=
:K2=7/ZQD[VZK`;:XCd01;2=7/ZQD/ZH:KVZK`;C_Xh02ng@V=>nS]>nS]c7
Xm>nS]c7XlZn[M>nSYj=:LZZAkVHG002bZ4m00W:V2ViSBViSBW:XCg:V2V`
NaBiSAB`N`ZVI`000YiN50:3;`001JIb0;1k5;1k5;V45;2=7P03^H@D00Ji
SAB`SAk:V2W:XCg:V2V3GQ@2^HdY00o:XCfiSC?:V2V`SAjiSC>`LP2iQ1BV
LP2`N`ZNLPZ`NaB`NbV`N`ZNLPZEE@000YiN50>EE@002:I<09EE09iN59EE
08eE2Yib2YEE0>g@V0?:ZVH01lZQ?LZZI]>ZAlZZI[V=<lZH:K2=7P02/7/:
00JNLQB=E@Z3GQAkC1AkC0X/71@2ARH:00TJ2@XS70XJ4Q@92@XA70X94PX9
2@XA70XJ2@X00QXV50056Q8D4A`:2@T:2@T:4A`:00<92A@01[1E09ib2ZIb
57]<578h04HV508J4Q@02PT92QXB514L2PTL50T952`B0:J4DYEbAl[@eYFZ
[@:`/kL2`LO<00K:d=IbSHB3SHB=V8k1alcLhn1Qc<c<00AVIVJ8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0W<c<`00fIVI_ooooooo`3ooooo3ooo
oeo<c<`019j=<k24:Ij=:Iik<`:NLQ@2UEDD01=kC1BEEABNLQBNSBV`NbV3
GQAZEAikC1@/71@m70Y69Q@m70Y69Q@m70Y69Q@m70Yb>016@AkLZS<00[24
:@03/8dc/8dNWW8D00:VLQ@047]<5611:A4V578h58<_08eE2Yib2Yib5:Ib
59ib59j=<k2=<k2=7YEE5;1k:K2=<`>iSBT02KV=5;1b0;1k2[1k2ULL0=>Z
AmbcG<ZZAl6cSP02bZYV00_:XCg:XE:iSC>iSBW:XCfiSAB`SAj`N`ZVLQB`
N`ZVLQ@00Yib500F/8@Y^HdcbZ4m/8dN^H@D/7/D/780YW80?A`:AT4NNd`D
WW8:^H@Y^HdY/7/D/8dN^HdD^H@D/8dN/7/DYW8D/7/D0[V=:@0:bZYVbZ5B
bZ5BbYPY^H@DbZ5B^HdcbZYVg;>Sdkj>0]bcQ0;C_Xh05Ng@V=>nS^g@V=c7
Xiik<lZQ?LZQD/ZZAkVHG;V=<lZH5;V=:LZH:KV=5;V=<kV45;1k59ib2ZIW
0:Ib5;V45002WW8:01Z`N`ZVLQB`LP2`NaB`N`[1Q02`SAk:V2V`SAk:V1C:
ZTO:V1B3GQC:ZTNiQ1BiSC?:V1C:XE:iSBW:V2V`NaB`N`Z`LP2`N`ZEEAB`
SAh2/7/:00>VLP2NLPZEEA@00XeE2P04Pd40WUhDUED0/5D00XeE2P07UED0
YW80UED0g;>4bZ5Bg;=LbZY700;:ZVH03<ZZAlZZI/ZZAkV=<kV=:KV=5;1k
59ib58eE2W]<2W]<56Y12P8m70X00b<V2R<L2Q4L2P026Q8D02494PX92@XA
70X92@X92A@J71hS;ahA9Q@92A@J4Q@A70X94PXJ4Q@A70X92@Z=E@Z`E@2E
EAB3@@1P;`Y69Q@S70XJ4Q@A70X92A@J4Q@92A@J4Q@92ABiSC>3GS>Van2E
ZZd00[2c]`08Y[?1`LO<b]3FPiR>LXf4SIR>/;>gg>?PHLc<c004IVIVR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P:c<c<ofIVIQ1VIVH00oooolc<
c<c<c01Mc<c<0iik<`0AWW8cUED0PehDPehDSED:PehDUEDDWXdY/7/YWW/c
UEDDNd`:LSPD;1`D;2HD;1`D6RHD008/9Q@072`L54HV53dL2S@_7[V=<k2=
<k24:K2=7ZIb5;1k2Yib2W]<578h514L2R`V578h57]<59iN59ib2[1k2[2=
7[1k:JIb5;2=<k24:K1k:K2=7[24:@:iSBT02K2=7[1k5;2=<k1b0;1k54HV
2]bcG<ZZI/ZQDP03bZYV00G:XE;:XCg:ZTNiSC?:XCd00[V=:@07/8dN/7/D
/780/8@YYW8D/8@Y/8dc00>iSC<02;2=7[V45;1k5;V458eE2V11:IEE59ib
2P:iSBT03KV45;V=:KV=<kV=:KV=5;1k5;1k2[2=7[V4:KV=<kVHG<ZZAlZQ
?@02/8dN00?:XE;:XCg:ZVH01M>nSP03g<NSdkj>g<NS00;C_Xh00iik<lZZ
I/ZZIP02bZY700k:XCf`SAk:V2V`SAjiSBViQ2V`SAjiSC>VLP2VLQBNGQB=
E@ZEEAB3@@02YW8D00>NLPZNGQB`N`X00[V4500G`H@0/8dN^HdDbYPYg:Xc
H2l:bZ4m^HdYbZ4m/8dNbZ5B/8dNbYPY/7/D^H@D/7/D/7/:UEDD/7/:^HdY
/7/D/7/:WW8:00:NGQ@00jIW09EE09EE0003SED:0YEE0003WUhDUED0djY7
00;:ZVH00lZQD/ZZI/ZZIP02bZYV01W:ZTO:XCg:XCf`SAj`N`ZVLQBNLPYk
C1B3GQAP@A@m70X/9QA69Q@A70XJ2@X92A@A70X92A@J4Q@A70X92A@J4Q@A
70XS;ahA70X00QXB500<2@T:2@TD2@TD2A8:2@TDH2l:WUhDSED:Nd`:H2l:
ARHD8bH:0QXB500<4A`:2@TD6Q8D6Q8D0000bZY7JUDNY/OPYZZSUJZ]/;>g
Y[?10/77c005PiR]JW9LSIR>/;>gg>?P067<c<`016IVIXS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2holc<c1[<c<`00oooolc<c<c<c03oc<c<]lc<
c004IVIVR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;Soc<c<6/c<c?oo
oonjoooo00AVIVJ8`;R8`;Q8T8P1000000000hS0^<SPf8S0^03oR<2hohS0
^=R8`;P1B9280@00000000B8`;S8h=R8`;R8`;PF00201001P0<00X0400>1
1004P@801H400`05PP06PP06PP0200J20P07PP030@N20@R20@R2008128<4
0@V30`4:P`040@^30@^40@^40@^4104<Q0<13H@40@j50`8?Q@@248D40Q66
0`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR800@3
6HP36HT36HT36HT30aZ910<KR@<378X40af:0`@NRP0411j;11n;11n;11n;
10@PR`<48H/412:<10@SS08498`00`@TS@@US@@US@021BF=10DVS@031BN=
1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@
0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B0086<i80
0`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD
10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF10PoUP88@9H2242G0`Q1
U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@042DNI
10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:Ci`3
2U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;Eih;
Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ10aN
X@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS3FFT
3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>KZL>
KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?
MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@O:`@
O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@APJdA
PJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`11:8
/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=/P8B
S[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@011>E]1>E
]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK]`<D
W;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@EXkX3
5JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m
00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G/[l3
5k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P4002000>KYo4c
@jDc@jD02C=3Y@H0080400600`02P0@00h4400B10P05P@0300F200J200J2
00801X8200N200<11h81288128800P48P`@12H<30@Z300@12h<12h@12h@1
2h@40@b40`4=Q0@13XD30Pn5108@Q@@24HH30Q:60`8CQP040Q>70QB70QB7
0QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^9
0`<LRP@37HX311j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@T
S00312B=12F=12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZ
SPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`
T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC
0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8
?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4
V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<
V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M
0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJ
X0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=
HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iY
Y@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X
3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mg
ZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]
0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@A
Q:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa
11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`04
4i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf
0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP0
11FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk
00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G
[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/klf6;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0<008001i^WlOooohij]ZJKa;>YdZRMb;>YdP02
YY_400Fl^=g^k_CZjO7ooolc@jD01@00P0@00H0300:01003P@@0184200F1
00<01H801X801X800P06PP801h800`47PP48PP48PP020@R31049P`<12X<0
104;P`4;Q04;Q04;Q0@138@30@f4104>Q@<23hD40Q25108AQP<24XH30Q>6
00@24hL258L258L258L40QF70P8FQ`835XP30aN810<HR0040aV80aV90aV9
0aV90`<JR@@36hT30ab:10<MRP<47XX010@NR`@OR`@OR`@OR`@488/3126;
10@RS0@48h`212B<00<498d49Hd49Hd00PDUS@@59Xd00`DWS@DWSPDWSP04
1BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i000`H_
T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHcTPHcTP021S>B00<6=987=987
=9800PLeTP87=I<31cJC10LgT`041cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E
0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8@IL424:G0PQ3
U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9AYT9AYT010U7V@@9B9T32DVJ
10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`2
2U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN0`]FWP042eNN2eNO2eNO2eNO
0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ0PaO
XP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=I:<00`eUX`eUY0eUY0043FJT
10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW3VjW008>KZL4
3VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?
MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/47b/008@O:`3
47f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d00Q60[@044H6]4H6^4H6^4H6^
0a62[P@APjh01164[Q64[a64[a64[`<AQJl44HJ_0a:7/0@BR;034XV`00@B
RK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P03
4hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@34iBd00@CUK@CUKDCUKDCUKD4
59Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g59^g008DVkL359bg0QBM]`8E
WKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX3
5ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm
5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`_P<G/Kl45k:o0aNc_`8H]<0P
00000QRd`10000026;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
080019^WlOooofaJYJnUbP:l^=d02_omok>Yd_oooooookbhgIN:_:RMb>KV
k?oooc=3Y@@0080400600`02P0@00h4400B10P05P@0300F200J200J20080
1X8200N200<11h81288128800P48P`@12H<30@Z300@12h<12h@12h@12h@4
0@b40`4=Q0@13XD30Pn5108@Q@@24HH30Q:60`8CQP040Q>70QB70QB70QB7
108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^90`<L
RP@37HX311j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@TS003
12B=12F=12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZSPDZ
S`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6
<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC0`Lf
T`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8
?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4V002
2DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:
CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]C
W@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<
Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ82
3F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>
JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X
00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@
N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o
[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@AQ:hA
Q:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;
/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c
11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI
]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP
^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@F
Z;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG
[[hG[[h011N__P@G/;h35k6o11Nb_`<G/kl26;C000?8h=Q8T8Q8T8P034R@
R0030000b>3HB92800e8T8P0100001Rd`1Rd`<SPf0i8T8P00`0001Rd`1Rd
`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00;VjOaooooZ9g8
oooo/jWBH4bJSWZfN6F^Z9g8oooooogo00?oool00c=3Y@00P000P0030020
1001P0<00X0400>11004P@801H400`05PP06PP06PP0200J20P07PP030@N2
0@R20@R2008128<40@V30`4:P`040@^30@^40@^40@^4104<Q0<13H@40@j5
0`8?Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<F
R0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:0`@NRP04
11j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@US@@US@02
1BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?
0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@031S:B
1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7
>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF10Po
UP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6
V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL
2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;
EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ
35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S
10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H2
3VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?
LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/3
47^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60
[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_0a65
[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<BS;8B
SK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C
]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LD
VkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T3
5J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl
11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh4
5k2n0aNa_`@G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SP
f00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^08008003Y^WlOooooooom_Lk61<
VY>5^[>Yd[bhgF1<VYV?_ZJKa<S3gooooc=3Y@D008000oooo`01P001P002
006000@00X3oool00X000h44oooo0`04P@03oooo00F1oooo00<01X801?oo
o`07PP07PP47PP?oool01@48P`49P`49Poooo`49P`030@Z300@12h?oool1
2h@12h@20@b41?ooo`030@f40@j5oooo00813XD01?ooo`8?Q@8?QOooo`82
48D3oooo0P8AQP<24XH30Q>600@24hL258L258L258L40QF70P8FQ`835XP3
0aN810<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX010@N
R`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<00<498d49Hd49Hd00PDU
S@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5
;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHc
TPHcTP021S>B00<6=987=987=9800PLeTP87=I<31cJC10LgT`041cRC1cRD
1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2
242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9
AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?
W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN
0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aM
X@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=
I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]
YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X
0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1k
Z`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d0
0Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<AQJl4
4HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb
4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@3
4iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g
59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ
^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@F
Z[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`
_P<G/Kl45k:o0aNc_`8H]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P0
0038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008003Y^W
lOoookbhgIV?__ooomKAgM_Lk??nojJKa>k^m8Ef/9>5^_oooc=3Y@@00800
2Oooo`01P001P?ooo`01P002P?ooo`02P?ooo`0300>100Coool01840187o
ool200F100Goool01X801X801X;oool00P07PP05oooo0@R20@R20@R3oooo
00812H<00oooo`49P`4:P`020@Z300H12h?oool12h@12h@138Coool20@b4
00D13HCoool13H@13XGoool00P4>Q@07oooo0Pn50Pn5oooo0Q25oooo0Q25
00824HH00oooo`8AQP8BQP020Q:60`8CQP040Q>70QB70QB70QB7108EQ`82
5XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX3
11j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@TS00312B=12F=
12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZ
S`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A
00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<0
10LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8
?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5
V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK
00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d2
2eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP
00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeR
X`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V
10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP3
3g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[
0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]
4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lA
Q:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;40
0a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<C
T[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H0
0aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP
^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`F
ZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h0
11N__P@G/;h35k6o11Nb_`<G/kl26;C000C8h=R8`;R8`;R8`;P6000018S0
^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8
T8P000000QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008003i^W
lOoooiV?_YN:_=CCj>n//omfNnjOZe]HYJJKa9JOdV1<V[bhgOoooc=3Y@03
002000Woool00H000H3oool00H000X3oool00X3oool00`03P@04oooo00B1
00B1oooo0P05P@05oooo00J200J200J2oooo00801h801Oooo`48PP48PP48
Poooo`020@V300?oool12H<12X<00P4:P`060@^3oooo0@^40@^40@b4oooo
0P4<Q0050@f4oooo0@f40@j5oooo00813XD01oooo`8?Q@8?QOooo`8@QOoo
o`8@Q@040Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<3
5hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:0`@NRP0411j;
11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@US@@US@021BF=
10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/
S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@031S:B1S>B
1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7
>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF10PoUP88
@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6
V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL
2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;EIh3
2eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ35fQ
35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S10eT
X`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H23VfV
00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP2
3g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/347^[
00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60[@02
4H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_0a65[`@A
QZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<BS;8BSK8B
SK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C]0<C
U;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LDVkLD
VkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T35J6i
11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ
_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh45k2n
0aNa_`@G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002
R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSP
f8S0^8S0^002R<2h0P0000:8`;P200000hS0^004B92800006;C06;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^08008002Y^WlOoooiN:_7Y/Z[?7
j:U^X<S3gi>5^U]6TiV?_P9hIJh0148WQJnUb_oooc=3Y@<008002Oooo`01
P?ooo`01P?ooo`02P?ooo`02P003P@04oooo0P04P@04oooo00F100F1oooo
0`06PP04oooo00N200N20@N20P48PP060@R3oooo0@V30@V3oooo0@V30`4:
P`040@^3oooo0@^40@^40P4<Q0Coool00`4=Q04>QOooo`020@j500Goool2
3hD23hGoool248D01Oooo`040Q660Q:60Q:60Q:60`8CQP040Q>70QB70QB7
0QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^9
0`<LRP@37HX311j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@T
S00312B=12F=12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZ
SPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`
T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC
0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8
?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4
V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<
V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M
0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJ
X0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=
HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iY
Y@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X
3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mg
ZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]
0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@A
Q:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa
11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`04
4i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf
0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP0
11FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk
00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G
[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/kl26;C000?8h=R8`;R8`;P0
2hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8
`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8`;P4000018S0^004B9280000
6;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008000i^WlOoo
ooooo`02oooo00[o[K3oMW_icMCmkNkooonVVlB5M[2l^=gooolc@jD40020
00Soool00H3oool00H3oool00X3oool00X0400>100Coool01840187oool2
00F10_ooo`801X801?ooo`07PP07PP47PP8128801048Poooo`49P`49P`Co
ool01@4:P`4;Poooooooo`4;Q0040@b400@13HCoool13H@13XD2oooo00P1
3XGoooooool23hGoool248Goool248D20Q6600?oool24HH24XH00P8BQP<2
4hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR800@36HP36HT3
6HT36HT30aZ910<KR@<378X40af:0`@NRP0411j;11n;11n;11n;10@PR`<4
8H/412:<10@SS08498`00`@TS@@US@@US@021BF=10DVS@031BN=1BN>1BN>
00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T003
1RnA1S2A1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B0086<i800`HdTPLd
TPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7
>iD323bE0`PmU@0423fF23jF23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL2
24>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9
BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYA
W08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;
Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj42
35nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=
IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^
Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mf
Z@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l
[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@APJdAPJhAPJhA
PJh34H:^1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK00
11:9/A::/A::/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb
00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E
]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg
0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU
^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG
[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G/[l35k>o0QRd
`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P0
1HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^004R<2h0P00
00F8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3002000ZQ[?;icMCR9Scd]KoR9ScdKGglhnWoooomkNko[K02oooo00<c
@jD0080008000`00P009oooo0060oooo0060oooo00:0oooo00:000>100?o
ool200B10oooo`0300F1oooo00J200;oool01006PP07PP07PP47PP812880
1P48Poooo`49P`49Poooo`49P`<12X<0104;Poooo`4;Q?ooo`8138@3oooo
0P4=Q0030@j5oooo0@j500;oool00`8?QOooo`8@Q@020Q250oooo`824HH3
0Q:60`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P010<I
R0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4
122;0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd5
9hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y03
1Rn@00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP03
1SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@4
1cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G
10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT4
2DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:
D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]G
W`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ
0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=
IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^
Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`me
Z@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l
[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61
[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`
0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>
/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe
4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL
]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<E
Y;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd0
0aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G
/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0
^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8
`;P4000018S0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_ARK_omoon]/?cS
jOoooc=3Y@0600200_ooo`<00H02oooo00<00X000h400h400P03P@<01840
1?ooo`05P@05POooo`@01X8200N200D11h812881288128?oool00P49P`03
oooo0@V30@Z300812X<0104;P`4;Q04;Q04;Q0@138@30@f4104>Q@<23hD4
0Q25108AQP<24XH30Q>600@24hL258L258L258L40QF70P8FQ`835XP30aN8
10<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX010@NR`@O
R`@OR`@OR`@488/3126;10@RS0@48h`212B<00<498d49Hd49Hd00PDUS@@5
9Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l4
1Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHcTPHc
TP021S>B00<6=987=987=9800PLeTP87=I<31cJC10LgT`041cRC1cRD1cRD
1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2242F
0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9AYT9
AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?
W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN0`]F
WP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aMX@aM
X@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=I:<0
0`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]YP03
3VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X0Pmc
Z@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`03
47^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d00Q60
[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<AQJl44HJ_
0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb
008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@34iBd
00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g59^g
008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@E
X[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`2
5Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`_P<G
/Kl45k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0
^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8
`;R8`;P00XS0^0800002R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7fb<cR9S`00_n]/007
gb@^ojBNm[c5ojf`kW^<oooo<d>U00L00802oooo0`01P0;oool00`02P003
P@03P@0200>10`04P@04oooo00F100F1oooo1006PP801h801@47PP48PP48
PP48Poooo`020@V300?oool12H<12X<00P4:P`040@^30@^40@^40@^4104<
Q0<13H@40@j50`8?Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@2
5HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X4
0af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@T
S@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5
:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A
0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<4
1cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF
23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4
V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK
0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did2
2eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P
0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeR
XP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU
10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z004
3g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ
111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd0
0a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_
4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk42
4Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@C
TK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH3
59Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PE
X;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl
5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn
5jjn00@G[kh45k2n0aNa_`@G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P0
0dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf003R<2h
0P0000B8`;P200000XS0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008000i^WlOW=e?N9U`02oooo00Oo[K3Q5SCoMW_o
Y9kR9ScoRGlc@jD01`00P003oooo0060006000800H000`02P?ooo`02P004
00>11004P@801H400oooo`06PP06PP0200J20P07PP050@N20@R20@R20@R3
oooo00812H<5oooo00@12h<12h@12h@12h@40@b40`4=Q0@13XD30Pn5108@
Q@@24HH30Q:60`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@3
68P010<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/4
7h/47h/4122;0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=
00<59hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]
T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i80
0PHcTP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0Lh
U0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88
@9L3246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI
00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`0
0PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh0
10]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<
GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=
IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]
Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT4
3gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k
[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d0
1161[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<B
Qk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P02
4Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]004
4iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`02
59^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i
11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[
_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o
11Nb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P9
00000XS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000NKYo7oooocX:kdHVko
ooogRIOicM@00_ooo`03lj2^oooo<d>U00P0080400600`02P0@00h4400B1
0P05P@0300F200J200J200801X8200N200<11h81288128800P48P`@12H<3
0@Z300@12h<12h@12h@12h@40@b40`4=Q0@13XD30Pn5108@Q@@24HH30Q:6
0`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<I
R@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4122;
0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd59hh5
9hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@
00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB
1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD
10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2
U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI
0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`2
2U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]G
W`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaO
X@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@0
10eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`02
3VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@04
3gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[002
47b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61
[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9
/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8C
S[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe
4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8D
WKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X4
5ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/
_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/kl2
6;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd
`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0`00P00;VjOaooooohUooooolj2^lI>Qoooooogolj2^oo_l
<d>U00P0080400600`02P0@00h4400B10P05P@0300F200J200J200801X82
00N200<11h81288128800P48P`@12H<30@Z300@12h<12h@12h@12h@40@b4
0`4=Q0@13XD30Pn5108@Q@@24HH30Q:60`8CQP040Q>70QB70QB70QB7108E
Q`825XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@3
7HX311j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@TS00312B=
12F=12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZ
S`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6<I43
1S:A00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC0`LfT`@7
=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8
?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH
10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/2
2TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;
E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj03
35bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R
0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD4
3V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?
LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X4
47V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o[@03
4Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lA
Q:lAQ:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8B
S;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A
/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<D
V[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP
^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`F
ZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG
[[h011N__P@G/;h35k6o11Nb_`<G/kl26;C03lSPf0030000b>3Hb>3H00g8
h=P00`0001Rd`1Rd`00?b>3H00<0000H]<0H]<000XS0^058T8P100000000
18S0^<SPf8S0^8S0^0@00803VjOa00KoooocX:kd]Kof_<GkfMXc@jD90020
1001P0<00X0400>11004P@801H400`05PP06PP06PP0200J20P07PP030@N2
0@R20@R2008128<40@V30`4:P`040@^30@^40@^40@^4104<Q0<13H@40@j5
0`8?Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<F
R0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:0`@NRP04
11j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@US@@US@02
1BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?
0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@031S:B
1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7
>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF10Po
UP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6
V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL
2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;
EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ
35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S
10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H2
3VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?
LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/3
47^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60
[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_0a65
[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<BS;8B
SK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C
]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LD
VkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T3
5J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl
11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh4
5k2n0aNa_`@G/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PF00201001P0<00X0400>11004P@801H400`05PP06PP06PP0200J20P07
PP030@N20@R20@R2008128<40@V30`4:P`040@^30@^40@^40@^4104<Q0<1
3H@40@j50`8?Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL2
0QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:
0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@U
S@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5
:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`Hb
T@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC
00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF
23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9
AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>
V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM
0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aL
X00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=
HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[
YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X
0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111i
Z`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o
[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_
4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba
00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<3
4i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf
00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TE
X;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl
5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn
00@G[kh45k2n0aNa_`@G/[l35k>o=QRd`0:8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;SHR<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;So
R<2hf8S0^058T8P1000000000hS0^<SPf<SPf03ob>3HolSPf=S8h=P1B928
0@000000ohS0^?n8`;SLR<2h0@000000\
\>"], "Graphics",
  ImageSize->{731, 409},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;N0001Z2000`400?l0
0000o`00003oooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?000?oo
l?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`goo`
l?01ono_k`00ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`goo`l?01ono_
k`00ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?000?ool?3`ooo`
l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?000?oo
l?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`
l?000?oooooo6Oooool4oo;bl_oojn_[__o[jn/4oo;blP7ooooo003oonk^
kQWok^k^00CohN7Qom[Jf_oJf][of][Jooo?clnnolo?c`?of][J0Oo^k^h1
on7Qh@00oooVi^HIonKViP04om[Jf_oCdm?ob<S8olS8b?oo]kNg__ng]kL2
olS8b07oi^KV0OoCdm<1om[JfP00ooo^k^hIonk^kP04on7QhOoJf][oclo?
okfm_OooX:2P__nPX:001?nm_Kgok^k^olo?cooJf]X1on7Qh@00oooooolI
ooooo`05oo;bl_oZj^[og]kNol_;bolk>c/0oomoOgnmogmoO`04ogQhN?o;
bl_og]kNon[ZjP7ol_;b003oonk^kQWok^k^00oohN7Qom[Jf_o?cloo_Kfm
oj>SXol?E[7o<7;0oeNBeOmk/NcoVlkookS/oom^KVko];Bdon3Ph?o/k>`0
ooo^k^jconk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003oonKViQWoi^KV
00Wof][Jom?Cdoo8b<So]kNgoifMWOl;E;7oY<CVokWCkomf[NX00_n[h?l0
1?mZJV[o[Zj^omSHf?oTi>CoonKViT_oi^KV00?oX:2PomoOgooVi^H0IOoV
i^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00ooo^k^hIonk^kP09on7QhOoJ
f][oclo?okfm_OnSXj?o2e>^ojG4i_ned>koNJk/00;oYmco00CoKVi^okBd
]?oPh>3ok>c/J_o^k^h00ooLg=cok>c/onk^kP02on?Sh`kok^k^00?og=cL
onc/k?o^k^h00_oShn<5onk^kP;ohN7Q2Oo^k^h2on7QhA[ok^k^00?ohn?S
omSHf?o^k^h03Oo^k^h00ooShn?of=SHonk^kP0Konk^kP03on[Zj_oHf=So
k^k^00Gok^k^0_oQhN49onk^kP03on_[jooOgmook^k^00Gok^k^0_oQhN4E
onk^kP03omcLg?oOgmook^k^00cok^k^00?og=cLonc/k?o^k^h00_oShn<A
onk^kP;ohN7Q1Oo^k^h00ooLg=cok>c/onk^kP02on?Sh`_ok^k^00?o^;Rh
oeADE?o^k^h0IOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooooolI
ooooo`09oo;bl_oZj^[og]kNol_;bon_[joo2eBaojC4i_nhd^koMZgZ00;o
[=oo00CoMWIfol71`Oo`l?3ooOgmHOooool04Olf=SKoRHV9oooooooooooo
lo?cobl_;olh>3Som_Kfoe5ADOl820So6QXJoibLW?lC4a?oEeMGoooooom0
@43oOgmo00;ooooo00KoNWYjod=3@ooooooooooookBd]?l92@T2ooooo`06
oe5ADOl820So6QXJoibLW?lC4a?oEeMG1?ooool01OlU9BGo410@ob0P8?m=
CDgom_Kf00Kooooo00Go9BDUoa0@4?lP823oCDe=ooKfmP02ooooo`06od10
@?moOgoooooooooooomjNW[o@d=30_ooool01_nd];Co2@T9oooooooooooo
@410ogmoO`;ooooo00[o@410ogmoOoooooooooooonOWiom:BT[o0`<3ob<S
8olG5aOo`L711Oooool00om0@43oOgmoooooo`02ooooo`09onOWiom:BT[o
0`<3ob<S8olG5aOo`L71oooooom0@43oOgmo00;ooooo00KoNWYjod=3@ooo
oooooooookBd]?l92@T2ooooo`06od10@?moOgoooooooooooom0@43oOgmo
0_ooool02_nSXj?o71`Loooooooooooo]KFeo`h>3_l20P;o;Bd]oi>CTolA
4A42ooooo`05obDU9Ol@413o820Pode=COofm_H01_ooool01_no_koo6a/K
o`L71omBDU;oQXJ6oc0`<0;ooooo00Go9BDUoa0@4?lP823oCDe=ooKfmP06
ooooo`09ocHf=_nUYJGoooooong]kOnPX:3oj^[Zoooooono_koo0P8200;o
oooo00Kofm_KocDe=Ol>3Pko30`<ocTi>OoLg=`2ooooo`06od10@?moOgoo
oooooooooonSXj?o71`L0_ooool01_mADE7o20P8oaXJ6_nLW9co4a<CoeMG
E`Gooooo00?o=SHfo`000?l000000_l000001?lj>S[ooooood10@?moOgl2
ooooo`05obDU9Ol@413o820Pode=COofm_H00_ooool02OmADE7o20P8oaXJ
6_nLW9co4a<CoeMGEoooooooKFe]oe9BDP09ooooo`03of=SHon5QHGooooo
06Cooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800?ook^k^6Oo^k^h02OoQ
hN7of][Jolo?conm_KgoXj>So`eD[_nVa^Ko]]3^ogV_kP02oj_No`04ofi^
K_nd];Coh>3Ponc/k67ok^k^00go<S8bogmoOoo^k^kojn_[odE5AOlR8R;o
fm_KokRh^?l30`?oc/k>omKFe_mDE5Co3`l?00;ok^k^00Ko>c/kogIfM_o^
k^kok^k^og5aLOln?Sh2onk^kP09ojRXZ?l820Sok^k^okRh^?l30`?oc/k>
omKFe_mDE5Co3`l?00Gok^k^00Go/k>con[Zj_o]kNgo<S8bohR8R006onk^
kP05ok>c/ooZj^[okNg]oc8b<_n8R8P00_o^k^h01_lk>c_oMWIfonk^k_o^
k^koLG5aochn?P;ok^k^00KoZ:RXo`P82?o^k^kok^k^oc/k>omfMWH2onk^
kP0:oc/k>omfMWKok^k^onk^k_lo?coo>c/kom3@d?o^k^koh^;Ron7Qh@Go
k^k^00?o>c/kogIfM_o^k^h00_o^k^h02Olo?coo>c/kom3@d?o^k^koh^;R
on7QhOo^k^ko>c/kogIfMP02onk^kP06og5aLOln?Skok^k^onk^k_nXZ:So
20P80_o^k^h01_lk>c_oMWIfonk^k_o^k^ko>c/kogIfMP;ok^k^00[oV9RH
oaXJ6_o^k^kok^k^obl_;omDE5CogMgMokbl_?lZ:R[o3`l?0_o^k^h01Onc
/k?oj^[Zong]kOlb<S;oR8R800Kok^k^00KoCTi>oe=CDooVi^KoTi>Co`h>
3_l/;2`2onk^kP05ok>c/ooZj^[okNg]oc8b<_n8R8P01_o^k^h03Olb<S;o
VYZJonk^k_n4Q8Co0000ogalO?o^k^ko/[:bo`410Oo^k^kokNg]oc0`<?m<
C4`00_oNg]h01_m?Cdoo<C4aong]kOo^k^ko>c/kogIfMP;ok^k^00WoV9RH
oaXJ6_o^k^ko^;Rho`<30oo>c/koe]KFoeADE?l?3`l01_o^k^h00olb<S;o
K6a/onk^kP04onk^kP0@oc/k>omfMWKok^k^onk^k_nc/k?oj^[Zong]kOlb
<S;oR8R8onk^k_nh^;So0`<3olk>c_oFe]KoE5ADo`l?3`;ok^k^00?oc<c<
olG5aOo^k^h02?o^k^h00oo6a/Ko410@onSXj01Tonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?Cdoo8b<So]kNgoifM
WOl:DJkoY<?UokSBkomi[^`00_n/gol01?mZJV[o[Zj^omSHf?oTi>AQonKV
iP0=oc0`<?mkNg_oi^KVoeiNG_lC4a?oa/K6onKVi_o3`l?o0P82ojZZZ_oV
i^KoShn?oa`L7002onKViP06ocTi>OmbLW;oi^KVonKVi_m^KVko?3`l0_oV
i^H02OnRXZ;o20P8onKVi_o3`l?o0P82ojZZZ_oVi^KoShn?oa`L7007onKV
iP03ok6a/OlC4a?oQ8B400Soi^KV00?o/K6aoa<C4on4Q8@00_oVi^H01_li
>CWoLW9bonKVi_oVi^KoKVi^oc`l?0;oi^KV00KoXZ:Ro`P82?oVi^Koi^KV
ocTi>OmbLW82onKViP06ocTi>OmbLW;oi^KVolO7aol0003oYJFU2OoVi^H0
1oli>CWoLW9bonKVi_oVi^KoalO7o`000?nUYJD01OoVi^H01_li>CWoLW9b
onKVi_oVi^KoKVi^oc`l?0;oi^KV00KoXZ:Ro`P82?oVi^Koi^KVocTi>Omb
LW82onKViP0:ocTi>OmbLW;oi^KVonKVi_nCTi?o6ATIonKVi_oAdM7o0000
ok6a/@;oi^KV00?oVYZJo`l?3ooVi^H00ooVi^H00ona/K7o4a<CohB4Q006
onKViP06obLW9on1PH7oi^KVonKVi_m^KVko:b/[1?oVi^H00ona/K7o4a<C
ohB4Q006onKViP0=oc0`<?nDU9Coi^KVobd];Om0@43o8b<SonKVi_n/[:co
0@41onKVi_o2`/;o0000ojFUY@02onKViP06ojFUYOl0003oa/K6onKVi_li
>CWoLW9b0_oVi^H02OnCTi?o6ATIonKVi_o3`l?o0P82ojZZZ_oVi^KoShn?
oa`L7006onKViP03oc0`<?mXJ6Soi^KV00Coi^KV00?o>CTiog9bL_oVi^H0
0ooVi^H02_na/K7o4a<CohB4Q?oVi^Ko`l?3o`820_nZZZ[oi^KVohn?SolL
71`=onKViP03omoOgol0003oZj^[06Coi^KV00CoWIfMokNg]oo8b<Sodm?C
0OoJf]X00?ook^k^6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`eD[_nU
a>Ko]];^ogV^j@02oj[Po`04ofi^K_nd];Coh>3Ponc/k67ok^k^00Go<S8b
ogmoOon2PX;o2@T9ok^k^`03onk^kP05oj6QXOl^;Rko;bl_oc8b<_lM7Ad0
0_o^k^h01_lk>c_oMWIfonk^k_o^k^koLG5aochn?P;ok^k^00WoZ:RXo`P8
2?o^k^kok^k^oj6QXOl^;Rko;bl_oc8b<_lM7Ad01Oo^k^h01OoDe=CoADE5
o`820_mYJFWoiNGU00Kok^k^00Goe=CDodE5AOl20P;oJFUYonGUi@02onk^
kP06oc/k>omfMWKok^k^onk^k_maLG7o?Shn0_o^k^h01_nXZ:So20P8onk^
k_o^k^ko>c/kogIfMP;ok^k^00Ko>c/kogIfM_o^k^ko/K6ao`000?lh>3P3
ocXj>P03okJf]_o^k^kok^k^00?ok^k^00Oo>c/kogIfM_o^k^kok^k^ok6a
/Ol0003o>3Ph00?o>SXj00Co][Jfonk^k_lk>c_oMWIf0_o^k^h01_maLG7o
?Shnonk^k_o^k^koZ:RXo`P820;ok^k^00Ko>c/kogIfM_o^k^kok^k^oc/k
>omfMWH2onk^kP06oiRHV?lJ6Q[ok^k^ok>c/ol0003oe]KF0_o^k^h02OnP
X:3o3`l?onk^k_o^k^koe=CDodE5AOl20P;oJFUYonGUi@06onk^kP06obTY
:On9RHWok^k^onk^k_n5QHGo;2`/0_o^k^h01OoDe=CoADE5o`820_mYJFWo
iNGU00Kok^k^00go<S8boiZJV_o8b<So0000olG5aOlW9bOo^[Zjok:b/_l1
0@7ok^k^ok6a/Ol0003oe]KF00;ok^k^00Koe=CDo`000?nd];Cok^k^oc/k
>omfMWH2onk^kP09oiRHV?lJ6Q[ok^k^onk^k_nQXJ7o;Rh^obl_;olb<S;o
7AdM00Kok^k^00?o<S8bofa/K?o^k^h01?o^k^h02Olk>c_oMWIfonk^k_o^
k^koe=CDodE5AOl20P;oJFUYonGUi@02onk^kP05oj6QXOl^;Rko;bl_oc8b
<_lM7Ad01Oo^k^h00ooShn?oA4A4odA4A003odA4A005omcLg?o^k^kok^k^
oaXJ6_nCTi<0I?o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooooolI
ooooo`09oo;bl_oZj^[og]kNol_;bon_[joo2e>^ojK6i_nidnkoNJk[00;o
Zmoo00CoMWIfol71`Oo`l?3ooOgmHOooool01?lf=SKo@d=3o`<30onc/k<6
ooooo`03oogmoOnDU9Co8B4Q00;ooooo00[o@410ofe]KOooooooooooogUi
NOlc<c?oo_knoooooonc/k?o2@T91?ooool00oomoOgoU9BDob4Q8@05oooo
o`03od51@Om2@T;ofm_K00Sooooo00?o@D51od92@_oKfm/01?ooool02_m0
@43oKFe]ooooooooooooNGUioc<c<oono_kooooook>c/ol92@T2ooooo`0>
od10@?moOgoooooooooooom0@43oOgmooooooooKfm_o0000oj^[Zoo?cloo
alO7o`<30ooUiND5ooooo`0>od10@?mYJFWooooooooooooKfm_o0000oj^[
Zoo?clooalO7o`<30ooUiNGooooood10@?m]KFd2ooooo`06ogUiNOlc<c?o
o_knoooooonc/k?o2@T90_ooool01_m0@43oOgmooooooooooooo@410oeeM
G@;ooooo00KoWIfMoadM7Oooooooh>3Po`000?nb/[82ooooo`07ojb/[?lA
4A7ooooooooooom1@D7o@T92om_Kf`08ooooo`06ob`/;?nCTi?ooooooooo
oon?Shoo<30`0_ooool00om1@D7o@T92om_Kf`08ooooo`0=ocHf=_nUYJGo
O7aloc0`<?ooooooRHV9ofUYJOno_koo0P82oooooooLg=co0000okBd]002
ooooo`06ok:b/_l0003oh>3Poooooom0@43oGEeM0_ooool00onMWIgo7AdM
ooooo`03ooooo`03oogmoOnDU9Co8B4Q00Kooooo00?o=SHfogAdM?ooool0
1?ooool01om0@43oOgmooooooooooooo@D51od92@_oKfm/01_ooool00oom
oOgoU9BDob4Q8@05ooooo`03ooclo?o5aLGoaLG500?oaLG500GonOWioooo
oooooooo8B4QoiZJVP1Tooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b003o
onk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol?EZooXl;TokSCkomg
[^/00_nZgol01?m^KVko];Bdon3Ph?o/k>aQonk^kP04oc8b<_m^KVko7alO
ohf=S@Cok^k^00GoZ:RXol_;boo[jn_oFUYJodi>CP02onk^kP0:oc/k>olC
4a?oPX:2omSHf?lj>S[o71`LoeUIFOoBd];oJFUYobl_;`;ok^k^00GoZ:RX
ol_;boo[jn_oFUYJodi>CP05onk^kP05oc<c<on<S8cok^k^omSHf?oYjNT0
1_o^k^h01Olc<c?oS8b<onk^k_oHf=SojNWY00;ok^k^00[o>c/koa<C4on2
PX;of=SHocXj>_lL71coFEUIom;Bd_mYJFWo;bl_0_o^k^h01_lk>c_oMWIf
onk^k_o^k^ko>c/kogIfMP;ok^k^00Go>SXjof=SHooVi^KoTi>CobPX:006
onk^kP0:oc/k>olA4A7oQhN7omCDe?o/k>co>SXjof=SHooVi^KoTi>CobPX
:0;ok^k^00[o>c/koa<C4on2PX;of=SHocXj>_lL71coFEUIom;Bd_mYJFWo
;bl_0_o^k^h02_lk>c_oMWIfonk^k_o^k^ko>c/koa8B4_m^KVkoclo?oe5A
DOm7AdL2onk^kP06ochn?_m1@D7odm?Com_Kfom<C4co3`l?0_o^k^h01Olc
<c?oS8b<onk^k_oHf=SojNWY00Kok^k^00Ko:BTYohV9ROo^k^kok^k^ohF5
QOl/;2`2onk^kP05oc<c<on<S8cok^k^omSHf?oYjNT01_o^k^h02Olb<S;o
VIVIoadM7On1PH7ok^k^omCDe?lB4Q;oZj^[o`410@02onk^kP06oc`l??m3
@d?oclo?olk>c_m2@T;o?clo0_o^k^h01_lk>c_o4Q8Bofi^K_o?clooDE5A
odM7A`;ok^k^00GoZ:RXol_;boo[jn_oFUYJodi>CP06onk^kP03oc8b<_m/
K6cok^k^00Cok^k^00Wo>c/kogIfM_o^k^kok^k^oc<c<on<S8cok^k^omSH
f?oYjNT00_o^k^h01OnXZ:Sobl_;on_[jomJFU[oCTi>00;ok^k^00?o_;bl
ok>c/oo^k^h02?o^k^h00ooZj^[o0P82oj^[Z`1Tonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?Cdoo8b<So]kNgoifM
WOl?EJooYLCVokWCkomg[^/00_nYg?l01?mZJV[o[Zj^omSHf?oTi>AQonKV
iP05oc0`<?mkNg_o_knooa0@4?n][Jd00ooVi^H01OmlO7co;Bd]o`h>3_lc
<c?o/;2`00;oi^KV00[oBd];ogemOOmUIFGo3Ph>ob@T9?o0`<3oRXZ:oaLG
5olL71coW9bL0_oVi^H01OmlO7co;Bd]o`h>3_lc<c?o/;2`00;oi^KV00So
QHF5onKVi_oVi^Ko[:b/oc@d=?l>3Pko4A4Aom7Ad@Koi^KV00Go[:b/oc@d
=?l>3Pko4A4Aom7Ad@02onKViP0:od];BommOGgoIFEUo`h>3_lT92Co`<30
ohZ:R_lG5aOo71`LoibLW0;oi^KV00KoBd];ogmoOooVi^Koi^KVocTi>Omb
LW82onKViP05olo?com0@43o2`/;oaTI6OnUYJD01_oVi^H02_m;Bd_oNg]k
oe=CDol820Sof=SHolo?com0@43o2`/;oaTI6OnUYJD2onKViP0:od];Bomm
OGgoIFEUo`h>3_lT92Co`<30ohZ:R_lG5aOo71`LoibLW0;oi^KV00[oBd];
ogmoOooVi^Koi^KVod];BomnOWkoKFe]oa8B4_lY:BWo/;2`0_oVi^H01_o?
cloo?Cdmo`X:2_lT92CoHV9Ro`l?3`;oi^KV00Go[:b/oc@d=?l>3Pko4A4A
om7Ad@06onKViP06oc`l??n>SXkoi^KVonKVi_n;Rh_o?clo0_oVi^H01On/
[:co=3@do`h>3_lA4A7odM7A00Koi^KV00Co<30`oemOGol10@7oc/k>0_oV
i^H00olo?cooHF5Qo`410@02onKViP06om7AdOm9BDWo3@d=o`d=3Om;Bd_o
d];B0_oVi^H01_m;Bd_oOWinofe]KOlB4Q;o:BTYok2`/0;oi^KV00GoO7al
obd];Ol>3Pko<c<cok2`/006onKViP03oc0`<?mXJ6Soi^KV00Coi^KV00Wo
Bd];ogmoOooVi^Koi^KVojb/[?ld=3Co3Ph>oa4A4OoAdM400_oVi^H01Oml
O7co;Bd]o`h>3_lc<c?o/;2`00;oi^KV00?oL71`oeYJF_oVi^H02?oVi^H0
0oo6a/Ko2@T9om_Kf`1TonKViP04oifMWOng]kOob<S8om?Cd`7of][J003o
onk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol;E;7oY<CVokWCkomf
[NX00_n[h?l01?m^KVko];Bdon3Ph?o/k>aQonk^kP06oc8b<_moOgook^k^
ojJVY_lD51Cod=3@1?o^k^h00oo/k>cok^k^onk^kP05onk^kP03ong]kOo^
k^kok^k^00;ok^k^00?okNg]onk^k_o^k^h00oo^k^h01oo/k>cok^k^onk^
k_o^k^kog]kNo`000?oUiND00oo^k^h00oo[jn_ok^k^onk^kP08onk^kP03
on_[joo^k^kok^k^00Gok^k^00?okNg]onk^k_o^k^h00_o^k^h00oo]kNgo
k^k^onk^kP05onk^kP03oc/k>omfMWKok^k^00?ok^k^00?ojn_[onk^k_o^
k^h02Oo^k^h01Oo[jn_ok^k^onk^k_o^k^kojn_[00Ook^k^00?okNg]onk^
k_o^k^h00_o^k^h00oo]kNgok^k^onk^kP08onk^kP03ong]kOo^k^kok^k^
00Cok^k^00Cok>c/onk^k_nPX:3o3`l?1?o^k^h00oo[jn_ok^k^onk^kP0@
onk^kP03on_[joo^k^kok^k^00Kok^k^00?o<S8boa8B4_ln?Sh00oo^k^h0
0onIVIWo4A4Ao`410@04onk^kP;okNg]1oo^k^h00oo]kNgok^k^onk^kP04
onk^kP03onc/k?o^k^kok^k^00Kok^k^00?o<S8bofa/K?o^k^h02_o^k^h0
0oo[jn_ok^k^onk^kP04onk^kP03onc/k?o^k^kok^k^00gok^k^00?oLG5a
ofEUIOo^k^h0I?o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooooolI
ooooo`09oo;bl_oZj^[og]kNol_;bon_[joo2e>^ojG4i_ned>koNJk/00;o
Ymco00CoMWIfol71`Oo`l?3ooOgmHOooool01olf=SKoRHV9oooooooooooo
QhN7obd];Ooclo<06_ooool00ooGemOo0000omkNgP0Oooooo`06oe]KFonB
TY;ooooooooooom0@43oOgmo9Oooool00omKFe_oTY:Booooo`0=ooooo`03
ojb/[?lA4A7ooooo01oooooo00?o=SHfo`000?nNWYh00oooool00ooemOGo
30`<o`820P0Mooooo`03ocHf=_mdM7Cooooo00Cooooo00?oFe]Koi:BT_oo
ool06Oooool00ooHf=SoATI6ooWin@1Uooooo`04ojn_[oo;bl_og]kNon[Z
jP7ol_;b003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol;E;7o
Y<CVokSBk_mf[NX00_n/gol01?m^KVko];Bdon3Ph?o/k>aQonk^kP03ojBT
Y?o3`l?ok^k^00;ok^k^00?oVYZJolC4a?o^k^h06Oo^k^h00onc/k?o0000
okRh^00Oonk^kP06ojRXZ?no_kook^k^onk^k_lk>c_oMWIf9Oo^k^h00onX
Z:So_knoonk^kP0=onk^kP03oj2PX?l?3`ook^k^01ook^k^00?oY:BTohn?
SooQhN401?o^k^h00onYZJWoT92@onk^kP0Lonk^kP03ojBTY?nj^[[ok^k^
00Cok^k^00?oZ:RXokno_oo^k^h06Oo^k^h00onFUYKog]kNonk^kP1Uonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?C
doo8b<So]kNgoifMWOl=E:koY/KVokK@k_mi[nh00_n[g_l01?mZJV[o[Zj^
omSHf?oTi>B2onKViP03onGUiOoQhN7oiNGU02?oi^KV00?oh^;RonCTi?oV
i^H0=?oVi^H00ooUiNGohN7QonKViP3@onKViP04oifMWOng]kOob<S8om?C
d`7of][J003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol:DJko
Y<?UokSBkomi[^`00_n/gol01?m^KVko];Bdon3Ph?o/k>coonk^k[?ok^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400?oooooo6Oooool02Oobl_;oj^[Z
omkNg_o;bl_o[jn_o`eD[_nUa>Ko]];^ogV^j@02oj[Po`04ogIfM_o1`L7o
l?3`oogmoOoooooo/oooool01?n_[joobl_;omkNg_oZj^X1oo;blP00ooo^
k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o2e>^ojK6i_nidnkoNJk[
00;oZmoo00CoKVi^okBd]?oPh>3ok>c/ooo^k^jconk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?Cdoo8b<So]kNgoifM
WOl?EZooXl;TokSCkomg[^/00_nZgol01?mZJV[o[Zj^omSHf?oTi>CoonKV
i[?oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00?ook^k^6Oo^k^h02OoQ
hN7of][Jolo?conm_KgoXj>So`mE[onUa>Ko^M?_ogN^j`02ojWLo`04ofi^
K_nd];Coh>3Ponc/k?ook^k^/oo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Q
h@00oooooolIooooo`09oo;bl_oZj^[og]kNol_;bon_[joo2eBaojC4i_ni
dnooMZgZ00;oZn3o00CoMWIfol71`Oo`l?3ooOgmooooooncooooo`04ojn_
[oo;bl_og]kNon[ZjP7ol_;b003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo
_Kfmoj>SXol;DjkoYLCVokG@k_mi[^`00_nWg?l01?m^KVko];Bdon3Ph?o/
k>aKonk^kP0>oa4V5?l92ACo6Q`No`TB2_l92@[o2@TDo`TB2_l971ko2@T:
o`T95?l0003o2@TDo`000?l92@X2o`000009o`T92_l94P[o0000o`000?l9
2@[o2@TDo`000?l92ACo2@T:00?o000000Oo2A8:o`000?l92@[o2@T:o`00
0?l92@[o000000;o2@T:00?o2@TDo`000?l92@X00_l92@X01Ol0003o2@T:
o`000?l92@[o000000;o2@T:00?o0000o`T92_l92@X00ol000000ol92@[o
2@TDo`000004o`000006o`T92_l0003o0000o`000?l92@[o00000_l92@X0
1Ol0003o2@T:o`000?l0003o2@TD00Ko00000_l92@X2o`000003o`T92_l0
003o000000Co000000?o2@T:o`000?l000000_l000000ol92@[o0000o`00
000Ho`000003o`T92_l0003o000000Ko000000?o6Q8Do`000?l000007Ol0
00000olA9Qko0000o`00000Mo`000003o`T92_l0003o000002ko000000?o
;3PYodIED_o^k^h0G_o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooV
i^HIonKViP09om[Jf_oCdm?ob<S8okNg]onMWIgo2eBaojC4i_nhd^koMZgZ
00;o[=oo00CoJVYZojj^[_oHf=Soi>CTFooVi^H01_l94P[o6Q8Do`TL5?l9
2ACo2A`NoaX92P;o6Q8D00Oo4BHDo`T95?lA70[o6Q8Do`TL5?l92ACo4BHD
00;o2@TD00Wo2A`DoaXB5?l92ACo2@TDoa4V5?l971Co6Q8Do`T92_lJ4Q@0
0_l92A@01Ol92@[o2@TDo`TB2_l92ACo6Q8D00;o2@T:00Wo4A`:o`T92_lA
70[o2A8:o`T92_l92ACo2@T:oaXB5?l92@X00ol94PX01?l971Co2@TDo`TB
2_l92A@2oaXB5005o`T95?lJ4QCo2A8:o`TB2_l92A@00_l94PX3o`T95004
o`TB2_l971Co2@TDo`T950;o2A8:00_o2@TDo`TB2_l92@[o2A8:o`T92_l9
2ACo2A8:oaXB5?l94P[o2@T:o`T95003o`TB2P;o2@T:0_l94PX01OlJ4QCo
2@TDo`T95?l94P[o6Q8D00?o2A8:0_l92A@00ol94P[o2@TDoaXB5002o`T9
5005o`TB2_lA9QCo2A8:o`T95?lJ4Q@00_l92A@01?l94P[o2@TDo`T95?l9
4PX4o`T9500:o`TB2_l92ACo6Q8Do`T95?l971ko6Q8Do`T95?l94P[o2@TD
oaXB50;o2@TD00?o2A`NoaXB5?lJ4Q@00ol92A@03ol94P[o2@TDoaXB5?l9
71Co2@TDo`TL5?l92ACo2A`DoaXB5?l92ACo6Q8Do`T95?lA9QCo2A`Do`T9
5003oaXB50;o2@TD00Co2A8:oaXB5?lJ4QCo6Q8D0_l92A@01?lJ4QCo2@TD
oaXB5?l971@2o`T95006o`TL5?lJ4QCo2@TDo`T92_lJ4QCo4BHD1?l92A@0
1?l971Co2@TDo`TB2_lJ4Q@2o`T95003oa4V5?l92ACo6Q8D00;o2@TD00Ko
4BHDo`T95?l971Co6Q8Do`T95?lA9Qh2o`T95005oa4V5?l92@[o2A`DoaXB
5?l971@00_l92A@01_l94P[o2A`Do`T95?l92ACo2A8:oaXB50;o2@TD00Oo
4BHDo`TB2_l92ACo2@TDo`T92_l971ko6Q8D00;o2@TD00Go2A8:oaXL7_l9
2ACo6Q8Do`TB2P05o`T9500BoaXB5?l92ACo2@T:oa4V7_l92@[o6Q8Do`TL
7_l94P[o2@TDoa4L2_l92ACo4BHNoa4V5?l92ACo4A`:o`T92_ld;c?oLW9k
GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00ooo^k^hIonk^kP09on7Q
hOoJf][oclo?okfm_OnSXj?o3EB^ojK6i_nfd>koNJo^00;oZmko00CoKVi^
okBd]?oPh>3ok>c/Foo^k^h02_lJ4QCo4BHDo`TB2_lJ4QCo4BHDoa4V7_l9
2ACo4A`:oa4V5?l94PX3o`T9500Aoa4V5?l94P[o6Q8Doa4L2_l92ACo6Q8D
o`T95?lJ4QCo6PT:o`TB2_l92@[o4A`:o`T95?lA70[o2@TDo`TB2_lA70X0
0_l92@X00ol92ACo2@T:o`T92P02o`TB2P09o`T92_l94P[o2A8:o`TB2_lA
70[o2@T:oa4L2_l92ACo6Q8D00?o2A8:00?o2@T:o`T95?l92A@00_l94PX3
o`T950;o2A8:00Co2@TDo`TB2_l92ACo2A8:0ol92A@02_l92@[o2A8:o`TB
2_l92ACo2@T:o`TB2_l92@[o2A8:o`T95?l94PX6o`T92P03o`TB2_lA70[o
2@T:00?o2A8:00Co2@TDo`TB2_l94P[o2A8:0_l92@X3o`TB2P?o2@TD00?o
2A8:o`T92_l92A@00_l92A@01?l94P[o2@TDo`T92_l92A@4o`TB2P05o`T9
5?l94P[o2A8:o`TB2_l92@X00_lJ4Q@00ol94P[o2@TDo`TB2P02o`TB2P;o
2@TD0_l94PX2o`T95003o`TB2_l971Co2A8:00;o2A8:00?o2@TDoaXB5?l9
2A@00_l92A@00ol92@[o6Q8Do`T95002o`T95003oaXB5?l92ACo2@TD00;o
2A8:00Co2@TDoaXB5?l92ACo4A`:0_l92A@01_lA70[o2@TDo`TB2_lA70[o
6Q8Do`T950;o2@T:00Go4A`:oaXB5?l92ACo2A8:oaXB5003o`T95005oaXB
5?l92ACo6Q8DoaXB5?l92A@00_lJ4Q@00ol92ACo6Q8DoaXB5002o`T9500:
oaXB5?l92ACo2@TDo`T92_lJ4QCo2@TDo`TB2_lJ4QCo2@TDoaXL7P;o2@TD
00Go6Q8Do`T95?l92ACo2@TDoaXB5002o`T95003oaXB5?l971Co6Q8D00;o
2@TD00go2A8:o`T95?l92ACo2@TDoaXB5?l94P[o6Q8Do`TB2_l92ACo6Q8D
o`T95?l971Co6Q8D00;o2@TD0olJ4Q@03?lA70[o6Q8Do`TL5?lA70[o6Q8D
o`T95?lA70[o2@TDoa4V7_lA70[o2@TDoa4V50;o2@TD00Oo4A`:o`T95?l9
2ACo2@TDo`TB2_lm;cgoCeiV05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN400?oooooo6Oooool02Oobl_;oj^[ZomkNg_o;bl_o[jn_o`YA[_nT`nGo
^=;_ogV^k002ojcOo`04ogIfM_o1`L7ol?3`oogmoE_ooooo00Oo6Q8Do`TB
2_l92ACo4BHDo`T95?l94P[o4BHD00;o2@TD00?o4A`:o`T92_l92@X00_l9
4PX00ol92ACo2A8:o`TB2P02o`TB2P07o`T92_lA70[o2A8:oa4V5?l92ACo
4A`:o`TB2P04o`T92P03oa4L2_l92@[o2A8:00;o4A`:0_l92@X2o`TB2P?o
2@T:00Wo2A8:oa4L2_l92@[o2@T:o`000?l94P[o2@T:o`TB2_l92@X01Ol9
4PX01?l92ACo2A8:o`T92_l94PX3o`T92P03o`T95?l94P[o2A8:00Go2A8:
00Co2@T:o`TB2_l94P[o2@T:0_l94PX3o`T92P03o`TB2_l92@[o000000?o
2A8:00Go0000o`TB2_l0003o2A8:o`T92P04o`TB2P03oaXB5?l94P[o2@T:
00;o2A8:0_l92@X01ol94P[o2@T:o`T92_l92ACo2A8:o`T92_l92A@00_l9
4PX01_l92ACo2@T:o`TB2_l92ACo2A8:o`T92P?o2A8:00?o2@TDo`TB2_l9
2@X00ol92@X00ol94P[o2@T:o`TB2P03o`T92P04ocd_?Ol92@[o2A8:o`T9
2PGo2A8:00?o4A`:o`T92_l94PX00_l92@X01_lA70[o2@T:o`TB2_l94P[o
2@TDo`TB2P;o2@T:00Oo2A8:o`TV:Ol92@[o2@T:o`T95?l92@[o2@TD00;o
2A8:00go2@T:o`TB2_l94P[o2A8:o`T92_l94P[o2@T:oa4L2_l92ACo6Q8D
o`T92_l94P[o2@T:00;o2A8:00Ko4A`:o`T95?l94P[o2@TDo`TB2_l92@X3
o`TB2P03o`T92_lA70[o2@TD00;o2@T:00Go2@TDo`TB2_l94P[o4A`:o`T9
2P02o`TB2P03oa4L2_l92@[o2@T:00;o6Q8D00Wo2@TDoaXB5?l94P[o6Q8D
o`T95?l92@[o2A8:o`TL5?l92A@00_l94PX05?l92ACo2A8:oaXB5?lJ4QCo
2@TDoaXB5?l92ACo4A`:o`TB2_l92ACo2@T:o`TB2_l92ACo2A8:o`T95?l9
4P[o2@TDo`TB2_l92ACo6Q8D0_l92A@00olJ4QCo2A8:o`T95002o`T95006
o`TL5?lA70[o4BHNo`000?ld;c?oCeiVGoooool01?n_[joobl_;omkNg_oZ
j^X1oo;blP00ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o3EB^
ojG4i_nfd^koNJkY00;oZ^3o00CoKVi^okBd]?oPh>3ok>c/Foo^k^h03?lA
70[o6Q8Do`TL5?lA70[o2@TDoaXB5?l92ACo4A`:oa4V5?l92ACo2@T:oa4L
2P;o2@T:00Co6Q8Do`TB2_lA70[o2@T:0ol94PX2o`T92P03oaXB5?l92ACo
2A8:00So2A8:0_l92@X01?l94P[o2@T:o`TB2_l92@X2o`TB2P03oa4L2_l9
2@[o6Q8D00Co2@T:00Co2A8:o`T92_l94P[o2@T:0_l94PX01_l0003o2@TD
o`T92_l94P[o2@T:o`0000;o2A8:00?o2@T:o`000?l94PX00_l92@X02_l9
2ACo2A8:o`TB2_l92@[o0000o`TB2_l92@[o0000o`TB2_l92@X2o`TB2P07
o`000?l94P[o2@TDo`TB2_l0003o2@TDo`000002o`TB2P;o2@T:00Go0000
o`TB2_l94P[o2@T:o`TB2P02o`T92P06o`T95?l94P[o2A8:o`TB2_l0003o
2A8:1?l92@X4o`TB2P?o2@T:0_l94PX01?l92@[o2A8:o`T95?l94PX3o`T9
2P;o2A8:00?o2@T:oa4L2_l92@X01?l94PX3o`T92P05oaXB5?l94P[o0000
o`T92_l94PX00ol92@X01ol94P[o4A`:o`T92_l92@[o2A8:o`T92_l94PX0
0_l92@X01?lA70[o2A8:o`TB2_l92@X7o`TB2P04o`T92_lJ4QCo6Q8Do`T9
2P;o2A8:00Go6Q8Doa4L2_l92@[o2A8:o`T92P02o`TB2P;o2@T:00?o2@TD
o`TB2_l94PX00_l94PX01?lA70[o2@T:o`TB2_l92@X3o`TB2P05o`T95?lm
;cgo0000oa4L2_l92@X00_lJ4Q@3o`TB2P03oa4L2_l94P[o2@T:00?o2A8:
00Co2@T:o`T95?lA70[o2@T:0_l92A@01?l971Co4A`:o`T92_l94PX2o`T9
2P03o`T95?l94P[o2@TD00;o2@T:0_l92A@03ol94P[o2@TDo`T95?l94P[o
2@TDoaXB5?l94P[o2A`Do`TB2_lA70[o6Q8Do`TB2_l92@[o2@TDoa4L2P03
o`T95004oaXB5?l94P[o=2lYofYkQ5ook^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400?ooi^KV6OoVi^H02OoJf][odm?ColS8b?ng]kOoWIfMo`]C[_nV
a^Ko^M?^ogV^j`02oj_Oo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00?o2A`D
o`T95?lJ4Q@00_l971@00ol92@[o4BHDo`T95003o`TB2P03o`T95?lA9QCo
2A8:00;o2A8:00Ko4A`:o`TB2_l94P[o2A8:o`T92_lA9Q@2o`TB2P05oa4L
2_l92ACo4A`:o`T95?l92@X00_l94PX2o`T92P03o`TB2_l92@[o4A`:00;o
2A8:0_l92@X01?l94P[o2@T:o`TB2_l94PX2o`T92P?o2A8:00?o0000o`T9
2_l94PX00ol94PX2o`T92P?o2A8:00?o2@TDo`TB2_l94PX00_l92@X3o`TB
2P03o`T95?l92@[o2A8:00;o2A8:00?o2@TDo`TB2_l92@X00_l92@X00ol9
4P[o2@T:o`TB2P02o`TB2P06o`000?l92@[o2@T:o`T95?l94P[o00000_l9
4PX2o`T92P03o`TB2_l92@[o2A8:00[o2A8:00?o2@T:o`TB2_l92@X01Ol9
4PX00ol92@[o2A8:o`TB2P03o`TB2P?o2@T:00Oo2A8:o`T92_l94P[o2A8:
o`T92_l94P[o2@T:00;o2A8:0_l92@X3o`TB2P03o`T92_l94P[o2A8:00;o
2A8:0_l92@X2o`TB2P06o`T92_l94P[o2A8:o`TB2_lJ4QCo4A`:0_l92@X0
1ol94P[o2@T:oa4L2_l92@[o2A8:o`T92_l92A@01?l94PX2o`T95005oa4L
2_l94P[o2@T:o`T95?lA70X00_l94PX2o`T92P03o`T95?lA70[o2A8:00;o
2A8:00Co6Q8Do`TB2_l92ACo6Q8D0_l94PX01Ol92@[o2A8:o`T95?lJ4QCo
2A8:00;o2@TD00Ko2@T:o`TB2_l94P[o2@TDo`TB2_l92@X2o`TB2P07o`T9
5?l92@[o6Q8DoaXB5?l92@[o4A`:o`T95004o`TB2P03o`T95?lJ4QCo6Q8D
00;o2A8:00So4A`:o`TB2_l94P[o2A8:oa4L2_l92ACo2@T:o`TB2P?o6Q8D
0_l94PX4o`T95003o`TB2_l92ACo2@TD00;o2@TD00So2A`DoaXB5?l94P[o
4BHDo`TL5?l94P[o=2lYofYbG5ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJ
f]X00?ook^k^6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`mF[onS`^Co
^=?_ogN^j`02oj[Oo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Oo6Q8Doa4V
5?l94P[o6Q8Do`T95?lA70[o2@TD00;o2A8:00Oo6Q8Do`T95?lA9QCo2@TD
o`TB2_lJ4QCo2@TD00;o2A8:0_l92@X00ol94P[o2@T:o`TB2P02o`T92P03
o`TB2_l92@[o2A8:00;o2A8:0_l92A@3o`TB2P04o`T92_l94P[o2A8:o`TB
2P;o2@T:00Oo2A8:o`000?l92@[o2@T:o`TB2_l0003o2A8:00;o2@T:00Co
2A8:o`T95?l0003o2@TD0_l94PX00ol92ACo2@T:o`T95002o`000003o`T9
2_l94P[o2@T:00Co2A8:00oo2@TDo`T92_l94P[o0000o`T92_l94P[o2@T:
o`TB2_l0003o2@T:o`TB2_l92@[o2@TDo`T92_l94PX00_l92@X00ol94P[o
0000o`T92P02o`T92P03o`TB2_l92@[o2@T:00Co2@T:00?o2A8:o`T92_l9
4PX00ol92@X00ol94P[o0000o`TB2P02o`T92P04o`TB2_l0003o2@T:o`TB
2P;o2@T:0ol94PX4o`T92P04o`TB2_l92@[o2A8:o`T92P;o2A8:00?o2@T:
o`TB2_l94PX00_l92@X01_l94P[o2@T:o`TB2_l92@[o2A8:o`0000[o2@T:
00Wo2A8:o`T92_l92ACo2A8:o`T92_l92ACo2@T:o`TB2_l92@X00ol94PX0
2ol92ACo2A8:o`T92_l92@[o2A8:o`T92_l94P[o2A`DoaXB5?l92@[o2@TD
00;o2@T:0_l94PX2o`T92P07o`TB2_l92ACo2@T:o`TB2_l92ACo2A8:o`T9
2P02o`TB2P03o`T92_l94P[o2A8:00?o2@T:00Co2A8:oa4L2_l94P[o2@T:
0_l94PX01?l92@[o4A`:o`T95?l94PX4o`T950;o2@T:0ol94PX2o`T95006
o`T92_l94P[o2@TDo`T95?l94P[o2@T:0_l94PX2o`T92P07oa4L2_l92@[o
2A8:o`T95?l92@[o2@TDo`TB2P02o`T92P;o2A8:0_l92A@4o`TB2P03o`T9
5?l94P[o6Q8D00;o2@TD00?o2@T:oc@_<omZNfl0Goo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@00oooooolIooooo`09oo;bl_oZj^[og]kNol_;bon_
[joo3eF_ojG4i_nidnooMjk[00;oZMco00CoMWIfol71`Oo`l?3ooOgmFooo
ool02_lA9QCo6Q8Do`TL5?l92@[o6Q8Do`TB2_lJ4QCo2A8:o`T92_l94PX4
o`T92P04o`T95?lA70[o2@T:o`T92P;o2A8:0_l92@X01?l94P[o2@T:o`T9
2_l94PX2o`T92P;o2A8:00Go2@T:o`TB2_l92ACo0000o`TB2P02o`T92P03
o`000?l94P[o2@T:00;o2@T:0_l94PX3o`T92P;o2A8:0_l92@X00ol94P[o
2@T:o`TB2P03o`TB2P03o`T92_lJ4QCo2@T:00;o2A8:1?l92@X00ol92ACo
2A8:o`TB2P04o`T92P03o`TB2_l92@[o000000;o2A8:00?o2@T:o`TB2_lJ
71h00_l92@X2o`TB2P[o2@T:00?o2A`No`T92_l92@X00ol92@X01?l94P[o
2@T:o`T92_l92@X2o`TB2P?o2@T:0_l94PX00ol92@[o2A8:o`T92P04o`T9
2P03o`TB2_l92@[o2@T:00;o2A8:0_l92@X00ol92ACo2@T:o`TB2P03o`T9
2P04o`T95?l92@[o2@TDo`T92P;o2A8:0_l92@X01_l94P[o2@T:o`T92_l9
4P[o2@T:o`TB2P;o2@T:0_l94PX2o`T92P03o`T95?l92@[o2@T:00Wo2@T:
00Co2A8:o`T92_l92@[o2A8:0ol92@X00ol94P[o2@T:o`TB2P02o`T92P05
o`TB2_l92@[o2@T:oa4L2_l94PX00_l92@X02?l94P[o2@TDo`T95?l94P[o
6Q8Do`TB2_l92@[o4A`:0ol92@X01_lJ4QCo2@T:o`T95?l92ACo2A8:o`T9
50?o2@T:00Co6Q8Do`T92_l94P[o2@T:0ol94PX01_l92@[o2@TDo`T95?l9
4P[o4A`:o`T950;o2@T:00_o4A`:o`TB2_l92@[o2@T:o`TB2_l92@[o4A`:
o`T92_l94P[o2@TDoaXB5003o`T92PGo2@TD0ol94PX02?l92ACo2A8:o`T9
5?lJ4QCo2A8:o`T92_ld;bWoEei_Goooool01?n_[joobl_;omkNg_oZj^X1
oo;blP00ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o2eBaojC4
i_nidnooMZgZ00;oZn3o00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01Ol94P[o
6Q8DoaXB5?l971Co2@T:00So2A8:00Oo4A`:oa4V5?l92@[o2A8:o`T92_l9
4P[o2@T:00;o2A8:00Go6Q8Do`TB2_l92@[o2A8:o`T92P02o`TB2P;o2@T:
00Go2A8:o`T92_l92@[o2@T:o`TB2P02o`T92P03o`T95?l94P[o2A8:00;o
2@T:00?o2A8:o`T92_l92@X00_l92@X00ol0003o2@T:o`TB2P02o`TB2P03
o`T92_l0003o2A8:00?o2A8:00Co2@T:o`T95?l94P[o2@T:1?l94PX01Ol9
2@[o0000o`TB2_l92@[o2A8:00;o2@T:00Oo0000o`TB2_l92@[o0000o`T9
2_l92ACo;1`D00;o2@T:00Ko2A8:o`000?l94P[o2@T:o`TB2_l92@X2o`TB
2P;o2@T:0_l94PX4o`T92P03o`TB2_l92ACo2A8:00;o2@T:00_o2A8:o`T9
2_l92ACo2A8:o`T92_l94P[o2@T:o`TB2_l92@[o0000o`T92P03o`TB2PKo
2@T:00Wo2A8:o`T92_l92@[o2A8:o`T92_l94P[o2@T:o`TB2_l92A@00_l9
2@X2o`TB2P04o`T92_l94P[o2@T:o`0000;o2A8:00?o2@T:oa4L2_l92@X0
0_l94PX01?l92@[o2A8:o`TB2_l92A@2o`TB2P03o`T92_l94P[o2@T:00?o
2@T:0_l94PX2o`T92P05o`TB2_l92@[o4A`:o`T95?l92@X01Ol94PX00ol9
2@[o2A8:o`T92P03o`TB2P09o`T92_l94P[o2@T:o`T92_l92ACo2A8:o`T9
2_l92ACo2A8:00?o2@T:00?o4A`:o`TB2_l94PX00_l92@X01?lJ4QCo2@T:
o`T95?l94PX2o`T92P06oaXB5?l92@[o2@T:o`T95?l94P[o2@TD0_l92@X0
0ol94P[o2@T:o`T95002o`T92P03oa4L2_l92@[o2@T:00;o2@T:0_l94PX2
o`T92P03o`TB2_l92ACo2@T:00;o2A8:0_l92@X00olA70[o2@T:o`T92P02
o`T92P07o`TB2_l92ACo2A8:o`TB2_l92ACo2A8:oaXB5002o`T95003oc@_
:Olm;cgok^k^05kok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400?ooi^KV
6OoVi^H02OoJf][odm?ColS8b?ng]kOoWIfMo`]C[_nUa>Ko]M3^ogV^k002
ojOLo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00Oo4BHDoaXB5?l94P[o4A`:
o`TB2_lA70[o6Q8D00;o2@T:00Co2A8:o`T92_l94P[o2A8:0_l92@X01_l9
4P[o2@T:oa4L2_l92@[o2A8:o`T92P;o2A8:00?o2@T:o`TB2_l94PX00ol9
2@X01?lJ4QCo2@T:o`T92_l94PX4o`T92P03oa4L2_l94P[o000000?o2A8:
1_l92@X2o`TB2P03o`000?l92@[o2@T:00;o2@T:00Wo2A8:o`T92_l92@[o
2@T:oa4L2_l94P[o2@T:o`TB2_l000002Ol92@X03Ol94P[o0000o`000?l9
2@[o4A`:o`TB2_l92ACo2@T:o`TB2_l0003o2@TDo`T92_l000001Ol92@X0
0ol94P[o0000o`000003o`T92P07o`TB2_l0003o2A8:o`000?l92@[o2A8:
o`000005o`T92P03o`TB2_l0003o2@T:00;o2@T:00?o0000o`T95?l00000
2?l92@X01ol94P[o0000o`T92_l94P[o2@T:o`TB2_l92@X00ol94PX00ol9
2@[o2A8:o`T92P05o`T92P09o`T95?l0003o2@T:o`TB2_l92@[o6Q8Do`T9
2_l94P[o2@T:00;o2A8:1ol92@X00ol0003o2@T:o`TB2P03o`T92P03o`TB
2_l0003o2@T:00;o2@T:00Co4A`:o`T92_l92@[o2A8:1_l92@X01?l94P[o
2@T:o`T92_l94PX2o`T92P05o`T95?l92@[o2A8:o`T92_l94PX00_l92@X2
o`TB2PWo2@T:0_l94PX01Ol92@[o2A8:o`T92_l94P[o2@T:00?o2A8:1Ol9
2@X01Ol94P[o2@T:o`TB2_l94P[o2@T:00;o2A8:0_l92@X4o`TB2P08o`T9
5?l92@[o2@T:o`TB2_l92ACo2@T:oaXB5?l94PX2o`T95003o`T92_ld;bWo
AT`m05ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00?ook^k^6Oo^k^h0
2OoQhN7of][Jolo?conm_KgoXj>So`]D/OnTa>Ko^=;^ogJ]jP02ojcOo`04
ofi^K_nd];Coh>3Ponc/k5_ok^k^00Co6Q8Doa4V2_l92ACo6Q`N0_l94PX0
0olJ4QCo2@TDo`TB2P07o`TB2P03o`T92_l94P[o2@T:00;o2A8:00Go2@T:
o`TB2_l94P[o2@T:o`TB2P02o`T92P04ob<_:Ol94P[o2A8:o`T92P?o6Q8D
0_l94PX01Ol92@[o2A8:o`000?l92ACo000000Ko2@T:00Oo4BHNo`000?l9
4P[o2@TDo`000?l92@[o2A8:00;o2@T:00Co8blYo`T92_l94P[o2A8:1Ol9
2@X02?l94P[o2@T:o`T92_l94P[o2@TDo`000?l94P[o00000_l92@X01Ol9
4P[o2@T:o`T92_l92@[o6Q`N00Co2@T:00Go0000o`T92_l92@[o2@T:o`TB
2P02o`T92P04o`TB2_l92@[o2@T:o`TB2Pco2@T:00Co2A8:o`T92_l92@[o
2A8:1ol92@X01Ol94P[o2@T:o`T92_l92@[o2A8:00Ko2@T:00Co6Q`No`T9
2_l92@[o00000_l92@X01Ol94P[o2@T:o`T92_l92@[o2A8:00;o2@T:00?o
2A8:o`000?l92@X01?l92@X02?l94P[o0000o`TB2_l0003o2@T:o`TB2_l9
2@[o2A8:1Ol92@X01?lJ4QCo2@T:o`T92_l94PX:o`T92P03o`TB2_l92@[o
2@T:00;o2A8:00?o2@T:o`TB2_l94PX01Ol92@X00ol94P[o2@T:o`T92P02
o`T92P09o`TB2_l92@[o2A8:o`T92_lA70[o2A8:o`T92_lA70[o2A8:00;o
2@T:00?o2A8:o`T95?l94PX00_l92@X01Ol94P[o2@T:o`TB2_l92ACo2A8:
00;o2@T:0ol92A@00ol94P[o2@TDo`T92P02o`T92PGo2A8:00?o2@TDo`T9
2_lJ4Q@00ol94PX00ol92ACo2@T:o`T95004o`T95004oa4V7_l92@[o=2lY
odmNIUook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400?oooooo6Oooool0
2Oobl_;oj^[ZomkNg_o;bl_o[jn_o`eD[_nVa^Ko]]3^ogV_kP02oj_No`04
ogIfM_o1`L7ol?3`oogmoE_ooooo00Co2@TDoa4L2_l92ACo2A8:0_l92A@5
o`TB2P04o`T95?l94P[o2@T:o`TB2P;o2@T:0_l94PX01ol92@[o2A8:o`T9
2_l94P[o2@T:o`000?l94PX00_l92@X00ol0003o?Blmo`T92P04o`TB2PGo
2@T:00Oo2A8:o`T92_l94P[o2A8:o`T92_lA70[o2A8:00;o2@T:00Co2A8:
o`000?l92@[o2A8:0_l92@X01?lJ4QCo2A8:o`TB2_lA70X4o`T92P03o`TB
2_l92@[o2A8:00;o2@T:00?o2A8:o`T92_l92@X01Ol92@X01ol0003o2A8:
o`T92_l94P[o8blYo`T92_l94PX01_l92@X01_l0003o2A8:o`T92_l94P[o
2@TDo`TB2PGo2@T:00Co2A8:o`T92_l92@[o2@T:0_l94PX5o`T92P03o`TB
2_l92@[o2A8:00;o2@T:00Co2A8:o`T92_l94P[o2A8:0ol92@X3o`TB2P06
o`T92_lA70[o2@T:o`TB2_l92@[o2A8:0_l92@X01Ol94P[o2@T:o`000?l9
4P[o2@T:00;o2A8:0ol92@X2o`TB2P;o2@T:00?o2A8:o`T95?l94PX01_l9
2@X00ol0003o2A8:o`T92P05o`T92P03o`TB2_lJ71ko2@T:00Ko2@T:00?o
2A8:oa4L2_l94PX00_l92@X02?l94P[o2@T:o`TB2_l94P[o2@T:o`TB2_l9
2ACo2A8:1Ol92@X00ol94P[o2@T:o`T92P04o`T92P06o`TB2_l92@[o2A8:
o`TB2_l92ACo2A8:0_l92@X01_l92ACo2@T:oa4L2_l94P[o4A`:o`T92PCo
2A8:00Ko2@TDoa4L2_lA70[o2A8:oa4L2_l94PX5o`T92P05o`TB2_l92@[o
2@T:o`T95?l94PX00_l92@X03Ol92ACo6Q8Do`TB2_l92ACo2A8:o`T92_lJ
4QCo2@TDoaXB5?l92ACo2@T:oc@_7_mbLW/0Goooool01?n_[joobl_;omkN
g_oZj^X1oo;blP00ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o
2U6^ojC3iOnhd^ooNJk/00;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h0
1olJ4QCo2@TDo`TL5?l92ACo4A`:o`T92_lJ4Q@00_l92A@2o`TB2P?o2@T:
00Co6PT:o`T92_l92@[o2@T:0ol94PX7o`T92P;o2A8:0ol92@X2o`TB2P;o
2@T:00?o2A8:o`T92_l94PX00ol92@X06Ol0003o4A`:o`T92_l0003o4A`:
o`T92_l0003o4A`:o`000?l92@[o2A8:o`T92_l92ACo2@T:o`TB2_l0003o
;3PYo`T95?l92@[o2A8:o`T92_l94P[o0000o`T92_lA70X01?l92@X01ol0
003o2@T:o`T92_l0003o2@T:o`000?l94PX00_l000000ol92@[o0000o`TB
2P03o`T92P04o`000?l92@[o2A8:o`0000;o2@T:0_l000001ol94P[o2@T:
o`T92_l94P[o0000o`T92_l000000ol92@X00ol0003o2A8:o`T92P02o`00
0005o`T92_l94P[o2@T:o`T92_l000000_l92@X01Ol0003o2@T:o`T95?l0
003o4A`:00?o2@T:00So0000o`T92_l0003o2A8:o`T92_l0003o2A8:o`00
00;o2A8:0_l92@X01?l0003o2@T:o`T92_l00004o`T92P03o`000?lA70[o
2@T:00?o2@T:00?o0000oa4L2_l94PX01Ol92@X01?l0003o2A8:o`T92_lA
70X2o`T92P;o000000?o4A`:o`T92_l92@X01?l92@X00ol94P[o2@T:o`T9
2P05o`T92P03o`000?l92@[o2A8:00Oo2@T:00Co2A8:o`T92_l92@[o0000
0_l92@X2o`TB2PGo2@T:00?o2A8:o`T92_l94PX01_l92@X2o`TB2P03o`T9
2_l94P[o2@T:00Wo2@T:00Oo2A8:o`T92_l92@[o2@T:o`T95?l92@[o4A`:
00Co2@T:00?o4A`:o`T92_lJ4Q@00ol92@X00ol92ACo=2lYog9bN`1Oonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?C
doo8b<So]kNgoifMWOl=E:koYLCVokKBk_mi[^T00_nZh?l01?mZJV[o[Zj^
omSHf?oTi>AKonKViP07o`T92_l971Co2A`Do`T95?lA70[o2@T:oa4L2P02
o`TB2P03o`T95?l92@[o2A8:00Go2A8:00Oo0000o`TB2_l92@[o2@T:o`TB
2_l92@[o2A8:00;o2@T:00?o2A8:o`000?l92@X01?l92@X01ol0003o4A`:
o`T92_l92@[o0000o`TB2_l92@X00_l94PX2o`T92P04o`TB2_l92@[o2@T:
o`TB2PCo2@T:00co0000o`T92_l92@[o;1`Do`TB2_l92@[o2A8:o`T92_l9
4P[o4A`:o`TB2_l92@X3o`TB2P?o2@T:00?o2A8:o`T92_l92@X00_l00000
1?l94P[o0000o`TB2_l00002o`T92P08o`TB2_l92@[o2A8:o`T92_l94P[o
0000oa4L2_l00002o`T92P03o`TB2_l92@[o000000?o2@T:00Go2A8:o`00
0?l92@[o2A8:o`000002o`T92P0:o`TB2_l92@[o2@T:o`T92_l94P[o2@T:
o`TB2_l0003o2@T:o`0000?o2@T:0_l94PX2o`000003o`T92_l94P[o2A8:
00Go2@T:01;o2A8:o`000?l92@[o2@TDo`000?lJ2@[o0000o`T92_lA70[o
0000o`TB2_l0003o2@T:o`TB2_l92@[o0000o`TB2_l00005o`T92P03o`00
0?l92@[o2@T:00;o2@T:00So0000o`T92_l92@[o2@T:oa4L2_lJ4QCo0000
o`T92P;o2A8:00?o2@T:o`TB2_l92@X00ol92@X00ol94P[o0000o`T92P05
o`T92P03o`TB2_l92@[o2A8:00Ko2@T:00?o2A8:o`T92_l92@X01Ol92@X0
0ol0003o2A8:o`T92P09o`T92P04oa4L2_l94P[o2@T:o`TB2P;o2@T:00Go
2@TDo`T92_l92@[o2@T:o`TB2P03o`T92P;o2A8:1Ol92@X00ol94P[o2@T:
o`T92P03o`T92P03o`TB2_l92ACo2A8:00?o2@TD0_l94PX00ol0003o=2lN
of1bN`1OonKViP04oifMWOng]kOob<S8om?Cd`7of][J003oonk^kQWok^k^
00WohN7Qom[Jf_o?cloo_Kfmoj>SXol;DjkoY/KVokWCk_mi[^/00_n[gol0
1?m^KVko];Bdon3Ph?o/k>aKonk^kP03o`TL5?l94P[o6Q8D00Co2A8:00Ko
2@TDo`TB2_l92ACo4A`:o`TB2_lJ4Q@3o`T92P03o`TB2_lA70[o2A8:00;o
2A8:00Oo2@T:o`TB2_l0003o2A`DoaX92_l94P[o4A`:00?o2@T:0_l94PX3
o`T92P;o2A8:00Co0000o`TB2_l92@[o00000_l94PX01_l0003o2A8:o`T9
2_l94P[o2@T:o`TB2P;o2@T:0_l94PX01?lA70[o2A8:o`000?l92@X2o`TB
2P07o`T92_l94P[o2A8:oa4L2_l0003o2A8:o`T92P02o`TB2P06o`000?l9
2@[o2@T:o`TB2_l92@[o2A8:0_l000000ol94P[o0000o`TB2P02o`0000;o
2A8:00Co0000o`TB2_l92@[o00000ol92@X02ol0003o2@T:o`T92_l94P[o
2@T:o`000?l94P[o0000o`TB2_l0003o2A8:00;o2@T:00Co0000o`T92_l9
4P[o00001Ol92@X01Ol94P[o2@T:o`TB2_l92@[o000000?o2@T:00Ko2A8:
o`000?l92@[o2A8:o`T92_l94PX2o`T92P0:o`000?l92@[o4BHDo`T92_l0
003o6Q`No`TB2_l0003o2@T:o`TB2P_o2@T:00So4A`:o`T92_l92@[o4A`:
o`T92_l94P[o2@T:o`TB2PGo2@T:00?o2A8:o`000?lJ2@X00ol92@X00ol9
4P[o2@T:o`TB2P02o`T92P?o2A8:0_l92@X2o`TB2P03o`T92_l94P[o2A8:
00;o2@T:00Co4A`:o`T92_l94P[o2A8:0ol92@X01_l94P[o2@T:o`T92_l9
4P[o2@T:oa4L2P;o2@T:00Oo2A8:oa4L2_l92@[o2@T:o`TB2_l92@[o2A8:
00?o2@T:1Ol94PX2o`T92P03oa4L2_l92@[o2A8:00?o2@T:00Wo2A8:oa4L
2_l92@[o2@T:oa4L2_l94P[o2@T:o`TB2_lA70X00ol92@X00ol94P[o4A`:
o`TB2P02o`TB2P07oa4L2_l94P[o2@TDo`T95?l0003o=2lNog9bN`1Oonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003ooooooaWooooo00Wol_;bon[Z
j_oNg]kobl_;ojn_[ol?EZooXl;TokSCkomg[^/00_nZgol01?mfMWKo`L71
oo3`l?omoOeKooooo`03oaXB5?l94P[o2A8:00?o2A8:00?o4A`:o`T92_l9
4PX00_l92@X3o`TB2P03oa4L2_l92@[o2@T:00;o2A8:00Go2@T:o`000?l9
4P[o2@T:o`TB2P02o`00000:o`T92_l94P[o2@T:o`T92_l94P[o2@T:o`TB
2_l92@[o2A8:o`0000?o2@T:017o0000o`TB2_l92@[o2@T:o`000?l92ACo
2@T:o`TB2_l92@[o4A`:o`T92_l94P[o2@T:o`TB2_l0003o2@TDo`TB2P02
o`T92P03o`TB2_l92@[o2@T:00Go2@T:00Go0000o`T92_l92@[o2@T:o`00
0002o`TB2PKo2@T:0_l94PX01_lA70[o2@T:o`000?l94P[o0000o`TB2P?o
2@T:00Ko2A8:o`T92_l92@[o2@T:o`000?l94PX5o`T92P04o`000?l92@[o
2@T:o`TB2P?o2@T:00Wo2A8:o`T92_l94P[o2@T:o`TB2_l0003o2A8:o`00
0?l94PX01ol92@X01?l0003o2A8:o`000?l94PX2o`T92P05o`TB2_l0003o
2A8:oa4L2_l000000ol92@X01?l0003o2@T:o`000?l94PX4o`T92P05o`TB
2_l92@[o2@T:o`T92_l94PX00_l92@X01?l94P[o2@T:o`TB2_l92@X2o`TB
2PWo2@T:00Go2A8:o`T92_l92@[o0000oa4L2P07o`T92P06o`TB2_l92@[o
2@T:o`T92_l0003o2A8:0ol92@X00ol94P[o2@T:o`T92P07o`T92P04o`TB
2_l92@[o2@T:o`TB2P?o2@T:00Go0000oa4L2_l92@[o2@T:oa4L2P02o`T9
2P03o`TB2_l92@[o2@T:00Co2@T:00?o4A`:o`TB2_l92@X02_l92@X00ol9
4P[o2@T:o`T92P03o`T92P09o`TB2_l92@[o2A8:o`T92_lA70[o2A8:o`T9
5?l/4P3oLW9k05oooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800?ook^k^
6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`mE[onUa>Ko^M?_ogN^j`02
ojWLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Co2@TDo`TB2_l94P[o2@T:
0_l94PX3o`T92P;o2A8:0_l92@X00ol94P[o2@T:o`TB2P04o`T92P03o`TB
2_l92@[o2@T:00;o000000So2A8:o`T92_l92@[o0000o`TB2_l0003o2A8:
o`T92P;o000000Go2A8:o`T92_l92@[o2@T:o`TB2P02o`T92P08o`000?l9
2@[o0000o`TB2_l92@[o0000o`TB2_l92@X3o`000004o`TB2_l0003o2@T:
o`0000;o2A8:00?o0000o`TB2_l92@X00_l94PX01?l0003o2@T:o`T92_l9
4PX2o`000007o`T92_l94P[o0000o`T92_l0003o4A`:o`000002o`TB2PCo
000000?o2A8:o`000?l92@X00_l92@X00ol0003o2@T:o`T92P02o`000003
o`T92_l0003o2@T:00;o0000013o2@T:o`TB2_l0003o2@T:o`000?l92@[o
0000o`TB2_l0003o2@T:o`000?l92@[o0000o`TB2_l0003o2A8:0_l00000
4_l94P[o2@T:o`000?l92@[o0000o`TB2_l92@[o0000o`TB2_l0003o2@T:
o`000?l94P[o0000o`T92_l0003o2@T:o`0000?o2@T:00?o0000o`T92_l9
2@X00_l92@X00ol0003o2A8:o`T92P03o`T92P03o`TB2_l92@[o000000;o
2A8:00Ko0000o`TB2_l0003o2A8:o`000?l94PX6o`T92P09o`TB2_l92@[o
2@T:o`T92_l0003o2A8:o`T92_l0003o2A8:00Co2@T:00?o2A8:o`T92_l9
2@X00_l92@X01olA70[o2@T:o`T92_l92@[o0000o`T92_lA70X01?l92@X0
2ol94P[o2@T:oa4L2_l94P[o;1`Do`T92_l94P[o2@T:oa4L2_l92@[o2A8:
00Go2@T:0_l94PX00olA70[o2@T:o`TB2P0<o`T92P04oa4L2_l92@[o2@T:
o`TB2P;o2@T:0_l94PX01Ol92@[o4A`:o`TB2_l92@[o2@TD00;o2@T:00Ko
2A8:o`T92_l94P[o0000oc@_7_mbLW]Oonk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q003oonKViQWoi^KV00Wof][Jom?Cdoo8b<So]kNgoifMWOl;E;7o
Y<CVokWCkomf[NX00_n[h?l01?mZJV[o[Zj^omSHf?oTi>AKonKViP;o4A`:
00Co2@T:oa4L2_l94P[o6Q8D0ol94PX01?lJ2@[o0000o`TB2_l92@X2o`TB
2P03o`T92_l94P[o2@T:00Co2A8:0ol92@X00ol94P[o2@T:oa4L2P03o`T9
2P;o2A8:1Ol92@X00ol94P[o0000o`T92P08o`T92P03o`TB2_l92@[o2@T:
00Ko2@T:0_l94PX00ol92@[o2A8:o`000002o`T92P;o2A8:00Wo6PT:o`TB
2_l0003o2A8:o`000?l92ACo2@T:o`TB2_l000000ol92@X00ol94P[o2@T:
o`T92P04o`T92P03o`TB2_l0003o2@T:00Co2@T:00?o4A`:o`000?l92@X0
0_l92@X01_l94P[o0000o`TB2_l0003o4A`:o`0000Ko2@T:00?o0000o`T9
2_l92@X00_l92@X00ol92ACo0000o`T92P07o`T92P04o`000?l92@[o4A`:
o`0000?o2@T:00So2A8:o`000?lA70[o0000o`TB2_l0003o2@TDo`TB2PGo
2@T:00?o2A8:o`T92_l92@X00_l94PX00ol0003o2@T:o`T92P06o`T92P04
oa4L2_l0003o4A`:o`TB2PSo2@T:0_l94PX01_l0003o2@T:o`T92_l92@[o
2A8:o`0000;o2@T:00?o2A8:o`T92_l94PX01Ol92@X01Ol94P[o2@T:o`T9
2_l92@[o4A`:00?o2@T:00Go6Q8Do`T95?lA70[o2@T:o`TB2P03o`T92P04
oa4L2_l92@[o2@T:o`T92P;o2A8:00Go6Q8Do`T95?l92@[o2@T:oa4L2P04
o`T92P03oa4L2_l92@[o4A`:00;o2@T:00Co2A8:o`T92_l92@[o4A`:0ol9
4PX00ol92@[o2A8:o`T92P03o`T92P0:o`TB2_lA70[o2A8:o`T92_lA70[o
2A8:o`T95?l92@[o;180oh>4SUooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJ
f]X00?ook^k^6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`]C[_nUa>Ko
]M3^ogV^k002ojOLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Ko2@TDoa4L
2_l92ACo4A`:o`TB2_l92A@3o`TB2P04o`T92_l94P[o2A8:o`T92P;o2A8:
1Ol92@X01Ol94P[o2@T:oaXB5?l92@[o2@TD00Ko2@T:00?o2A8:o`T92_l9
2@X00_l94PX7o`T92P03o`TB2_l92@[o2@T:00_o2@T:00?o2A8:o`T95?l9
2@X01?l92@X02ol94P[o2@T:o`T92_l94P[o2@TDo`TB2_lJ4QCo2@T:o`00
0?l92@[o2A8:00?o2@T:00?o2A8:o`T92_l92@X02?l92@X01Ol94P[o2@T:
o`T92_l92ACo2@T:00;o2A8:00?o2@T:o`TB2_l92@X01Ol92@X01?l94P[o
2@T:o`T92_l94PX3o`T92P04o`TB2_l92@[o2@T:o`TB2P;o2@T:00?o2A8:
o`T92_l92@X02?l92@X01?lA70[o0000o`TB2_lJ2@X6o`T92P03o`000?lA
70[o0000017o2@T:00Go2A8:o`000?l92@[o2@T:o`T95005o`T92P03o`TB
2_l92@[o4A`:00Go2@T:00?o2A8:o`T92_l92@X01Ol92@X00ol92ACo2@T:
o`T92P03o`T92P03oa4L2_l92@[o2@T:00;o2@T:00?o0000o`T92_l92@X0
0ol92@X00ol94P[o4A`:o`T92P07o`T92P03o`T95?lA9Qko2@T:00co2@T:
00?o4A`:o`TB2_l92@X01_l92@X00ol92ACo2@T:oa4L2P03o`T950;o2@T:
00Go6Q8Do`T92_l92@[o6Q8Doh>4N`1Oonk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q003ooooooaWooooo00Wol_;bon[Zj_oNg]kobl_;ojn_[ol;E;7o
Y<CVokSBk_mf[NX00_n/gol01?mfMWKo`L71oo3`l?omoOeKooooo`;o2A8:
00Ko2@TDoaXB5?lJ4QCo6Q8Do`T92_l94PX2o`T92P03o`TB2_l92@[o2A8:
00Go2@T:00Go2A8:o`T92_l94P[o2A8:o`T95002o`TB2P03o`T92_l0003o
4BHN00?o2@T:00Co2@TDo`T92_l92@[o2@T:0_l000002?l92@[o2A8:o`T9
5?l92@[o0000oa4L2_l92@[o00000_l94PX6o`T92P?o2A8:00Co0000o`T9
2_l92ACo6Q8D1ol92@X03?lJ71ko2@T:o`000?lJ71ko2@T:o`TB2_l92@[o
0000o`T95?l0003o2@T:o`TB2P;o2@T:0_l94PX2o`T92P03o`TB2_l0003o
2@TD00;o000000Co2A8:o`000?l0003o2@T:0_l000000olJ71ko0000o`TB
2P05o`T92P05o`000?l92@[o2@T:o`000?l94PX00_l92@X01?l0003o2@TD
o`TB2_l00002o`TB2P05o`000?l94P[o2@T:o`T92_l000001Ol92@X01_l9
4P[o2@T:o`T92_l0003o2@T:o`TB2PKo2@T:00?o0000o`T92_l94PX01Ol9
2@X01Ol94P[o2@T:o`T92_l92@[o2A8:00So2@T:0_l94PX00ol0003o2A8:
o`T92P02o`T92P07o`000?lJ2@[o2@T:oaXB5?l92@[o2A8:o`T92P02o`TB
2PGo2@T:00?o4A`:o`T92_l92@X00_l92@X00ol94P[o2@T:o`TB2P02o`T9
2P04oaX92_l92@[o2@T:oa4L2Pco2@T:00Oo4A`:o`T92_l92@[o2@T:o`T9
5?lJ4QCo4A`:00?o2@T:00[o2A8:o`T92_l92@[o2@T:o`TB2_l92@[o4A`:
o`T92_l94P[o2@TD0_l92@X02ol92ACo2@T:o`TB2_l92@[o2@TDoaXB5?l9
71Co6Q8Do`T95?l92@[o2A8:00;o2@T:00Ko6Q8Do`T95?lJ4QCo2@T:oaX9
2_n3Q8iOooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b003oonk^kQWok^k^
00WohN7Qom[Jf_o?cloo_Kfmoj>SXol=E:koY/KVokK@k_mi[nh00_n[g_l0
1?m^KVko];Bdon3Ph?o/k>aKonk^kP;o2@TD00Co4A`:o`T92_l92@[o2A8:
0_l92@X01olA70[o2A8:o`TB2_l94P[o2@T:o`T95?l92@X00_l94PX02?l9
2@[o2A8:o`TB2_l0003o2@T:o`000?l94P[o00000_l94PX01OlA70[o0000
o`TB2_l92@[o2A8:00?o2@T:00Wo2@TDo`T92_l94P[o2@T:o`000?l94P[o
2@T:o`000?l94PX00ol92@X01?l94P[o2@T:o`TB2_l94PX3o`T92P;o0000
00Go2@TDo`TB2_lA9QCo6Q8Do`000002o`TB2P;o2@T:0_l94PX02_l0003o
2A8:o`T92_l0003o2A8:o`T92_l0003o2@T:o`000?l94PX3o`T92P0;o`TB
2_l0003o2@TDo`000?l92@[o0000o`TB2_l0003o2A8:o`T92_l000000_l9
4PX2o`T92P07o`TB2_l92@[o2A8:o`000?l94P[o2@T:oc@_7P02o`T92P;o
2A8:0ol92@X2o`000003oa4L2_l0003o000000;o2@T:00Co0000o`TB2_l9
4P[o2A8:0_l92@X02?l94P[o2@T:o`T92_l92@[o2A8:o`000?l94P[o2@T:
0ol94PX02_l0003o2A8:o`000?l92@[o0000o`T95?l94P[o2@T:o`000?l9
4PX3o`T92P08o`TB2_l92@[o2@T:oa4L2_l92@[o2A8:o`000?l94PX2o`T9
2P07o`TB2_l92@[o2@T:o`T92_l94P[o0000o`TB2P05o`T92P?o2A8:0_l9
2@X01_l0003o2@T:o`000?l94P[o2@T:o`TB2P?o2@T:00[o0000o`T92_l9
2@[o6PT:o`TB2_l92@[o4A`:o`TB2_l92@[o00000ol94PX01?l0003o2A8:
o`T92_l92@X6o`TB2P05o`T92_l94P[o2A8:o`T92_l94PX00ol92@X01Ol9
4P[o2@T:o`T92_l92@[o2A8:00;o2@T:0_l94PX01?l92ACo2A8:o`T92_l9
2@X3o`TB2P03oaXB5?lA70[o2@T:00;o2@T:00Wo8a`:o`T95?l94P[o2@T:
o`TB2_l92ACo2A8:o`T92_l92A@00_l92@X00ol94P[o8a`:ohfHSP1Oonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?C
doo8b<So]kNgoifMWOl:DJkoY<?UokSBkomi[^`00_n/gol01?mZJV[o[Zj^
omSHf?oTi>AKonKViP04oaXB5?l94P[o2@T:oa4L2P;o2@T:00?o2A8:o`T9
2_l94PX00ol92@X01_l94P[o2@T:o`TB2_l0003o2A8:o`0000;o2@T:00co
0000o`TB2_l0003o2@T:o`000?l94P[o0000o`TB2_l0003o2A8:o`000?ld
;c<2o`000009o`TB2_l0003o2A8:o`000?l94P[o0000o`TB2_l0003o2A8:
00;o2@T:00Go2A8:o`000?l92@[o0000o`TB2P02o`T92P;o2A8:00?o2@T:
o`TB2_l000000_l94PX2o`000005o`TB2_l92@[o2@T:o`TB2_l000000_l9
2@X2o`000003o`TB2_l0003o000000;o2A8:00Co0000o`T92_l94P[o2@T:
0_l000000ol92@[o0000o`T92P03o`T92P07o`TB2_l92@[o2A8:o`T92_l0
003o2@T:o`000002o`TB2P08o`000?l92@[o2A8:o`T92_l0003o8d5Bo`00
0?l92@X2o`000003o`T92_l0003o2@T:00;o2@T:00So0000o`T92_l92@[o
0000o`TB2_l0003o2A8:o`0000;o2@T:00Go2A8:o`000?l92@[o2@T:o`TB
2P02o`00000:o`T92_l94P[o0000o`000?l94P[o0000o`T92_l94P[o2@T:
o`TB2P;o000000?o4A`:o`000?l92@X01?l92@X00ol94P[o2@T:o`000005
o`T92P08o`TB2_l0003o2@T:o`T92_l94P[o0000o`T92_l94PX2o`T92P07
o`000?l94P[o2@T:o`TB2_l0003o2@T:o`000009o`T92P07o`TB2_l92@[o
4A`:o`T92_l0003o2@T:o`TB2P03o`T92P03o`TB2_l0003o2@T:00;o2@T:
00[o0000o`T92_l92@[o2@T:o`TB2_l0003o2A8:o`T92_l94P[o00001_l9
2@X00ol94P[o0000o`TB2P02o`T92P?o2A8:0ol92@X00ol94P[o2@T:o`T9
2P03o`T92P04oaXB5?l92@[o2A8:o`T92PGo2A8:00Co2@T:o`TB2_l94P[o
2@T:0_lA70X2o`TB2P03oaX92_mGGVooi^KV05koi^KV00CoWIfMokNg]oo8
b<Sodm?C0OoJf]X00?ook^k^6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>S
o`eD[_nUa>Ko]];^ogV^j@02oj[Po`04ofi^K_nd];Coh>3Ponc/k5_ok^k^
00Go2@TDo`T92_lA70[o0000oa4L2P03o`TB2P04oaXB5?l94P[o2A8:o`TB
2PKo2@T:00Wo4A`:o`TB2_l0003o2A8:oaXB5?l0003o2@T:o`TB2_l92A@0
0_l92@X2o`TB2P0=o`000?lJ71ko0000o`000?l94P[o0000o`T95?l0003o
2@T:o`000?l94P[o0000o`TB2P02o`T92P0<oa4L2_l0003o4A`:o`000?l9
2@[o4A`:o`000?l92@[o0000o`TB2_l0003o2A8:0_l92@X01Ol94P[o0000
o`TB2_l0003o2@T:00Co2A8:00Go0000o`T92_l92@[o2@TDo`000002o`T9
2P03o`000?l92@[o2@T:00;o2@T:00Ko2A8:o`000?l94P[o2A8:o`000?l9
4PX3o`000005o`TB2_l0003o2A8:o`T92_l000000_l92@X01ol94P[o0000
o`T92_l94P[o0000o`T92_l000001?l92@X01Ol94P[o0000o`TB2_l92@[o
000000?o2@T:00?o2A8:o`000?l92@X01?l92@X02?l94P[o0000o`T92_l9
2@[o2A8:o`000?l92@[o2A8:0ol92@X01?l0003o2@T:o`TB2_l00004o`T9
2P07oa4L2_l92@[o4A`:o`T95?lS70[o2@T:oa4V7P04o`T92P04o`TB2_l9
2@[o2@T:o`TB2PSo2@T:00?o2A8:o`000?l92@X00ol92@X00olA70[o2@T:
o`T92P02o`T92P06o`000?l92@[o2@T:o`TB2_l92@[o2A8:0ol92@X01?l9
4P[o0000o`T92_l94PX3o`T92P04o`TB2_l92@[o2@T:o`T92P;o2A8:1?l9
2@X00ol92ACo2@T:o`T92P02o`T92P04o`TB2_l92@[o2A8:o`TB2P;o2@T:
00?o2A8:o`T92_l92@X00_l92@X01?l94P[o0000o`TB2_l92@X2o`TB2P;o
2@T:0_l94PX01_l92@[o2A8:o`TB2_lA70[o2@T:o`TB2PGo2@T:00?o2A8:
o`T92_l94PX00_l94PX01?l92ACo0000ob`B0?n3Q8iOonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q003ooooooaWooooo00Wol_;bon[Zj_oNg]kobl_;
ojn_[ol;DjkoY/KVokWCk_mi[^/00_n[gol01?mfMWKo`L71oo3`l?omoOeK
ooooo`03o`T95?l94P[o2A8:00;o2A8:0_l92@X00olJ4QCo2@TDo`TB2P02
o`TB2PCo2@T:00Go2A8:o`T92_l0003o0000o`TB2P03o`000004o`TB2_l0
003o0000o`TB2P;o2@T:01;o0000o`TB2_l0003o2@T:o`TB2_l0003o2A8:
o`000?l92@[o0000oaXL7_l94P[o2@T:o`000?l94P[o2@T:o`000?l92A@2
o`T92P;o2A8:0_l92@X2o`000003o`TB2_l0003o2A8:00;o2@T:00So2A8:
o`T92_l92@[o4A`:o`000?l94P[o2@T:o`0000;o2A8:00?o2@T:o`000?l9
2@X01Ol92@X01?l0003o6Q8Do`000?l94PX2o`000003o`TB2_l92@[o2@T:
00;o2@T:00Oo0000o`TB2_l0003o2A8:o`T92_l94P[o2@TD00Co2@T:00Co
0000o`TB2_lA70[o00000ol92@X00ol0003o2A8:o`000002o`T92P0>o`TB
2_l0003o2@T:o`T92_l0003o2A8:o`T92_l0003o2A8:o`T92_l94P[o2@T:
o`000?l94PX3o`T92P03o`000?l94P[o000000;o2@T:00?o0000o`T92_l9
2@X00_l92@X02Ol94P[o2@T:oaX92_lJ2@[o;180oaX92_l/4P3o8a`:ob`B
0002oa4L2P06o`T92_lJ2@[o2@TDo`TB2_l92@[o00001?l92@X01Ol0003o
2@T:o`T92_l94P[o000000;o2@T:00?o2A8:o`T92_l92@X02?l92@X00ol0
003o2@T:o`T92P02o`T92P08o`TB2_l92@[o2@T:o`T92_l0003o2A8:o`T9
2_l94PX3o`T92P03o`000?l94P[o4A`:00Co2@T:00?o4A`:o`T92_l92@X0
0ol92@X00ol94P[o2@T:o`T92P06o`T92P04o`TB2_l92ACo2A8:o`TB2P;o
2@T:0_l94PX3o`T92P09o`TB2_l92@[o2@T:o`T92_l0003o2@T:o`TB2_l9
2@[o2A8:00Co2@T:00?o2A8:o`T92_l94PX00_l94PX00olA70[oPhB>oooo
o`1Nooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b003oonk^kQWok^k^00Wo
hN7Qom[Jf_o?cloo_Kfmoj>SXol?EZooXl;TokSCkomg[^/00_nZgol01?m^
KVko];Bdon3Ph?o/k>aKonk^kP;o2A8:00So2@T:o`TB2_l92ACo4A`:oa4V
5?l92ACo6Q8Do`TB2P_o2@T:00Oo0000oa4L2_l92@[o0000o`TB2_l92@[o
2A8:00;o00000_l92@X02?l94P[o2@T:o`000?l94P[o2@T:o`000?l94P[o
00000_l92@X01_l0003o2@T:o`000?l94P[o2@T:o`TB2PSo2@T:00[o0000
o`TB2_l92@[o2@T:o`000?l92@[o0000o`TB2_l0003o2A8:0ol92@X2o`00
0007o`TB2_l92@[o2A8:o`T92_l0003o4A`:o`000002o`TB2P;o2@T:0_l0
00001ol94P[o2@T:o`000?l92ACo2@T:o`000?l92A@00_l92@X3o`000005
oaXL7_lJ4QCo2@T:o`TB2_l000000ol92@X00ol0003o2A8:o`000002o`T9
2P06o`000?l94P[o2@T:o`T92_l94P[o00001?l92@X00ol0003o2A8:o`00
0002o`T92P03o`000?l94P[o2@T:00?o2@T:00?o2A8:o`T92_l92@X02?l9
2@X2oaX92P0;ob`B0?lS70[o8a`:oaX92_lS70[o6PT:oa4L2_lJ2@[o2@T:
ob<L2_l/4P003ol92@X02ol0003o2@T:o`T92_l92@[o0000oa4L2_l0003o
2A8:o`T92_l0003o4A`:00;o2@T:0_l94PX01?l92@[o0000o`TB2_l94PX3
o`T92P03o`000?l92@[o2@T:00?o2@T:00?o0000o`TB2_l92@X01Ol92@X0
0ol94P[o2@T:o`T92P06o`T92P05o`TB2_l92@[o2@T:o`TB2_l000000_l9
2@X01Ol92ACo2@T:o`T92_l0003o2A8:00;o2@T:00?o2A8:o`T92_lA70X0
0ol92@X03_lJ4QCo2@T:o`TB2_lA70[o2A8:o`T95?l92@[o2A8:o`T92_l9
4P[o6Q8Do`T92_l/4P3oUHB>Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Q
h@00oooVi^HIonKViP09om[Jf_oCdm?ob<S8okNg]onMWIgo3eF_ojG4i_ni
dnooMjk[00;oZMco00CoJVYZojj^[_oHf=Soi>CTFooVi^H00olJ4QCo6PT:
o`TB2P02o`TB2P06oaXB5?lJ71ko2@TDo`TB2_l92@[o2A8:0_l92@X01?l9
4P[o2@T:o`T92_l94PX2o`T92P;o2A8:00So2@T:o`000?l92@[o2@T:o`TB
2_l0003o2@T:o`TB2P?o2@T:00?o0000o`T92_l92@X00ol92@X01_l0003o
2A8:o`T95?l0003o2@T:o`TB2P;o2@T:00Oo0000oa4V5?lJ4QCo2@T:o`TB
2_l92@[o000000?o2@T:00Co0000o`T92_l94P[o00001ol92@X01_l92ACo
0000o`T92_l92@[o2A8:o`0000Co2@T:00Oo2A8:o`000?l0003o2A8:o`00
0?l92@[o000000;o2@T:0ol94PX02ol92@[o0000o`TB2_l92@[o4A`:o`TB
2_l92@[o0000o`TV:OlJ2@[o000000;o2A8:00?o2@T:o`000?l92@X00ol9
2@X00olA70[o0000o`T92P04o`T92P;o2A8:00Co0000o`TB2_l92@[o0000
0ol92@X00ol94P[o2@T:o`T92P08o`T92P09oaX92_l0003o8a`:ocdB2_lJ
2@[o2@T:oaX92_lS70[o6PT:00;o8a`:00?o6PT:ob<L2_lS70X00_lJ2@X0
0olJ4QCo;180oaX92P03o`T92P03o`TB2_l92@[o2@T:00Ko2@T:00Wo2A8:
o`T92_l92@[o4A`:o`TB2_l92@[o2A8:o`T92_l000001_l92@X2o`TB2PGo
2@T:00?o2A8:o`T92_l92@X00_l92@X00olA70[o2@T:o`T92P05o`T92P03
o`TB2_l92@[o2@T:00;o2@T:00Co6PT:o`T92_l92@[o2A8:0_l92@X2o`TB
2PGo2@T:00?o4A`:o`T92_l92@X00ol92@X00ol94P[o2@T:o`T92P04o`TB
2P03o`T92_l94P[o2A8:00;o2@T:00?o2@TDo`T92_lA70X00_l94PX01_l9
2ACo2@T:o`TB2_l94P[o0000oh>4SUooi^KV00CoWIfMokNg]oo8b<Sodm?C
0OoJf]X00?ook^k^6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`]D/OnT
a>Ko^M?_ogJ]jP02oj_Po`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00?o6Q8D
o`TL5?lJ4Q@00_l94PX00ol92@[o8blNoaXL7P03o`TB2P05o`T92_l94P[o
2A8:o`T92_lJ4Q@00_l94PX02?l92@[o0000o`T92_l94P[o2@T:o`TB2_l0
003o2@T:0_l94PX02ol0003o2A8:o`TB2_l94P[o2@T:o`TB2_l92@[o2A8:
o`000?l94P[o000000?o2@T:00Go2A8:o`000?l94P[o2@T:oa4L2P02o`T9
2P03o`TB2_l92@[o4A`:00Go2A8:0_l92@X00olA70[o2@T:o`TB2P04o`T9
2P05o`TB2_l92@[o2A8:o`TB2_l000000ol92@X00ol94P[o2@T:o`000004
o`T92P0<o`TB2_l92@[o2A8:o`TB2_l0003o6PT:o`TB2_l0003o2@T:o`TB
2_l0003o2@T:0_l00002o`T92P?o2A8:00Go0000o`T92_l92@[o2A8:o`T9
2P03o`TB2P0:o`000?l94P[o2@T:o`TB2_l0003o2@T:o`TB2_l0003o2A8:
o`0000;o2@T:00Co2A8:o`000?lA70[o00000_l92@X00olA70[o0000o`TB
2P02o`T92P04o`000?lA70[o2@T:oaX92P;o8a`:0_l/4P001OmG703o;180
oaX92_l/4P3o8a`:00;o6Q8D0_lA70X01_l/71Co4A`:ob<L2_l92@[o8a`:
oa4L2P;o2@T:00?o0000o`TB2_l92@X00_l92@X2o`TB2PGo2@T:00?o2A8:
o`000?l92@X00_l92@X00ol94P[o2@T:o`T92P02o`T92P;o2A8:1?l92@X2
o`TB2P;o2@T:00Go2A8:o`T92_l92@[o2@T:oa4L2P02o`T92P;o2A8:00Wo
2@T:o`TB2_l94P[o2@T:o`000?l94P[o4A`:o`TB2_l92@X00_l94PX01OlS
;bWo2@T:o`T92_l94P[o000000Co2@T:00Co2A8:o`T92_l92@[o2A8:0_l9
2@X01?l94P[o2@T:o`TB2_l94PX2o`T92P05o`TB2_l92@[o2A8:o`T92_l0
00000ol92@X02olA70[o2A8:o`T92_l94P[o6Q8Do`T95?l94P[o2@TDo`00
0?lJ2@[oPhB>05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400?oooooo
6Oooool02Oobl_;oj^[ZomkNg_o;bl_o[jn_o`]C[_nUa>Ko]M3^ogV^k002
ojOLo`04ogIfM_o1`L7ol?3`oogmoE_ooooo00?o4BHDoa4L2_l92A@00_l9
4PX3o`T92P03o`TB2_l92ACo2A8:00?o2A8:00Co2@T:o`T95?l92ACo0000
0ol94PX00ol0003o2A8:o`TB2P03o`T92P03o`000?l94P[o2A8:00;o2A8:
00Ko2@T:oaX92_l94P[o0000oa4L2_l00003o`T92P07o`000?l92@[o2@T:
o`T92_l0003o2A8:o`T92P02o`TB2P;o2@T:00[o0000o`T95?l0003o2@TD
o`000?l94P[o2@T:o`000?l94P[o4A`:0_l92@X01Ol94P[o2@T:o`TB2_l0
003o2@T:00;o2A8:1?l92@X01?l0003o4A`:o`T92_l94PX2o`T92P05o`00
0?l94P[o2@T:o`T92_l000001?l94PX2o`T92P05o`TB2_l92@[o0000oa4L
2_l92@X00ol000001?l92@[o0000oa4L2_l00002o`TB2P06o`000?l92@[o
2@T:o`000?l92@[o00000ol94PX3o`T92P03o`000?lA70[o000000?o2@T:
00Co0000o`TB2_l0003o2A8:1?l92@X01_lJ2@[o4A`:oaX92_l/4P3o?A8:
odHV2P;o?A8:01;o;180ob`L5?lS70[o8a`:ob`V5?l/71Co6PT:ob`L5?lJ
9QCo8a`:ob`L5?lA70[o;1`Doa4V5?l92@[o2A8:o`T92_l00002o`TB2P;o
2@T:00Go0000o`TB2_l92@[o2@T:o`TB2P03o`T92P04o`TB2_l92@[o2@T:
o`0000Wo2@T:00?o2A8:o`T92_l92@X00_l92@X2o`TB2P09o`T92_lA70[o
2@T:o`TB2_lA70[o2A8:o`T92_lA70[o2@T:00?o2A8:1?l92@X03?l94P[o
2@T:o`000?l94P[o2@T:o`TB2_l92@[o2A8:o`T92_l94P[o2@T:o`TB2P;o
2@T:00?o2A8:oaX92_l94PX00_l92@X01_l94P[o2@T:o`T92_l92@[o2A8:
o`T92PGo2A8:0ol92@X01_lA70[o2@T:oaXB5?l92ACo2@T:o`TB2P;o2@T:
00?oSIR>ooooooooool0GOooool01?n_[joobl_;omkNg_oZj^X1oo;blP00
ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o2eBaojC4i_nhd^ko
MZgZ00;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h03?lJ4QCo2@TDoaXB
5?l92ACo2A8:oa4L2_l92@[o2A8:o`T92_l94P[o2BHYoaXB50Ko2A8:00Co
2@T:o`000?l0003o2A8:0_l92@X00ol0003o2A8:o`T92P02o`T92P09o`TB
2_l92@[o2A8:o`T92_l0003o2A8:o`000?l94P[o000000;o2A8:00?o2@T:
o`TB2_l92@X00_l94PX00ol92@[o2A8:o`T92P02o`TB2P03o`T92_lA70[o
2@T:00;o2A8:0ol92@X01Ol0003o2@T:o`T92_l92@[o2A8:00;o2@T:00Ko
0000o`TB2_l92@[o2@TDo`TB2_l00005o`T92P04o`000?l94P[o2@T:o`00
00?o2@T:00Co2A8:o`T92_l94P[o2@T:0ol000001ol94P[o0000o`T95?l9
4P[o2@T:o`000?l94PX00ol92@X02?lA70[o2@T:o`000?l94P[o2@T:o`TB
2_l0003o2A8:0ol92@X01Ol0003o2A8:o`T92_l0003o2A8:00?o2@T:00Ko
0000o`T95?l94P[o0000o`T92_l94PX2o`T92P05o`TB2_l0003o2@T:o`T9
2_lA70X00_lJ2@X00ol/4P3o?A8:ocdB2P02ocdB2P0AodHV2_l/4P3o?A8:
oaXB5?l/71Co6Q`NoaX92_lA70[o6RHDoaXL7_lA70[o6Q`NoaX92_lA9P[o
2A8:o`T92_l94PX00ol92@X01?l0003o2A8:o`T92_l94PX2o`T92P07o`TB
2_l92@[o4A`:o`T92_l94P[o2@T:o`TB2P0<o`T92P07o`TB2_l92@[o4A`:
o`T92_l0003o2A8:o`T92P03o`TB2P03o`000?l94P[o2@T:00Co2@T:00?o
4A`:o`T92_l92@X01?l92@X01?l94P[o2@T:o`TB2_l94PX3o`T92P;o2A8:
3Ol92@X00olA9QCo2@T:o`T92P06o`T92P;o2A8:00Oo4A`:o`T92_l94P[o
2A8:oaXB5?l92@[oPhB>05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
0?ooi^KV6OoVi^H02OoJf][odm?ColS8b?ng]kOoWIfMo`eD[_nVa^Ko]]3^
ogV_kP02oj_No`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00?o2A8:oaXB5?l9
2A@00ol94PX01OlJ4QCo2@T:o`T92_l/71Co2A8:00Co2@T:0_lJ4Q@00ol9
2ACo2@T:o`T92P06o`T92P06o`TB2_l0003o2A8:o`000?l92@[o00000_l9
2@X02_l0003o2@T:o`T92_l94P[o2@TDo`000?l94P[o0000o`TB2_l00003
o`T92P04oa4L2_l92@[o2@T:oa4L2P;o2@T:00?o2A8:o`000?l92@X00_l9
2@X00olA70[o0000o`T92P02o`TB2P;o2@T:00Co0000o`T92_l92@[o2A8:
0_l92@X02ol94P[o2@T:o`T92_l0003o2A8:o`000?l92@[o4A`:o`000?l9
2@[o2A8:00;o000000Co2@T:o`000?l92@[o2@T:0_l94PX01?l0003o2A8:
o`000?l92@X2o`TB2P04o`000?l92@[o2A8:o`T92P;o00000_l92@X00ol0
003o2@T:o`T92P04o`T92P06o`000?l92@[o0000o`TB2_l0003o2@T:0_l0
00001OlA70[o0000o`T92_l94P[o000000?o2@T:00Ko0000o`T92_l92@[o
4A`:ob`B0?l92@X5oaX92P?o?A8:00go6PT:ob<L2_lS9P[o8blNoaXB5?l/
71Co6Q`Nob`L5?lJ4QCo;1`DoaXB5?lA70[o000000Ko2@T:00?o2A8:o`00
0?l92@X00ol92@X01?l0003o2@T:o`T95?l00003o`T92P03o`TB2_l92@[o
2@T:00Go2@T:00Co4A`:o`T92_l92@[o6PT:1ol92@X01Ol94P[o2@T:o`TB
2_l92@[o2A8:00Oo2@T:00Go2A8:o`T92_l92ACo2A8:o`000003o`T92P04
oa4L2_l92@[o2A8:o`TB2PCo2@T:00Go2A8:o`T92_l92@[o2@T:oa4L2P04
o`T92P03oa4L2_l92@[o2@T:00;o2@T:00?o2A8:o`T92_l92@X00_l92@X0
0ol94P[o2@T:o`T92P02o`T92P04o`TB2_l0003o6PT:oh>4SUooi^KV00Co
WIfMokNg]oo8b<Sodm?C0OoJf]X00?ook^k^6Oo^k^h02OoQhN7of][Jolo?
conm_KgoXj>So`YA[_nT`nGo^=;_ogV^k002ojcOo`04ofi^K_nd];Coh>3P
onc/k5_ok^k^00?o6Q8DoaXL7_lA70X00_l92@X02?lJ4QCo2A8:o`TB2_l9
2@[o4A`:o`T95?lA70[o2A8:1ol92@X4o`TB2P?o2@T:00?o2A8:o`T92_l9
4PX00_l94PX01Ol0003o2A8:o`T92_l92@[o2A8:00;o00000_l92@X00ol9
4P[o0000o`T92P06o`T92P;o2A8:00?o2@T:o`TB2_l94PX00_l92@X01?l0
003o2@T:o`000?l94PX2o`000009o`T92_l94P[o2@T:o`T92_l94P[o0000
o`TB2_l92@[o000000;o2@T:00Go0000o`T92_l92@[o2A8:o`000005o`T9
2P03o`TB2_l92@[o2@T:00;o000000Co2A8:o`T95?l92@[o2@T:0_l00002
o`T92P;o00000_l92@X02?l0003o2@T:o`TB2_l92@[o0000o`TB2_l0003o
2A8:1Ol92@X01ol0003o2@T:o`T92_l92@[o4A`:o`000?l94PX02_l92@X3
oaX92P04o`T92_lJ2@[o8a`:oa4L2P;o8a`:00co?A8:oaXV5?lJ4QCo6Q`N
ob`L5?l92ACo6Q8Dob`V5?lJ2@[o;1`Dob<_7_lJ4Q@3o`T92P03o`000?l9
2@[o2A8:00Oo2@T:00Co2A8:o`T92_l92@[o2A8:1Ol92@X00ol0003o2@T:
o`T92P03o`T92P04o`000?l92@[o2@T:oa4L2PWo2@T:00?o0000o`T92_l9
2@X01_l92@X00ol94P[o2@T:o`T92P02o`T92P03oaXB5?l92@[o2@T:00?o
2@T:00?o2A8:o`000?l92@X00_l92@X00ol94P[o2@T:o`T92P02o`T92P04
o`T95?l94P[o2A8:o`TB2P;o2@T:00?o4A`:o`T92_l92@X00_l92@X00ol9
4P[o2@T:o`TB2P05o`T92P06o`TB2_lJ4QCo2@TDo`T92_l0003oPhB>Goo^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooooolIooooo`09oo;bl_oZ
j^[og]kNol_;bon_[joo3EB^ojG4i_nfd^koNJkY00;oZ^3o00CoMWIfol71
`Oo`l?3ooOgmFoooool02?l92ACo2A`Do`TB2_l94P[o4A`:o`T92_l92ACo
2@T:0_l94PX00ol0003o2A8:o`TB2P04o`T92P03o`TB2_l92@[o2@T:00;o
00000_l92@X01ol0003o2@T:o`000?l92@[o0000o`T92_l000000_l94PX0
0ol0003o2@TDo`TB2P05o`T92P06o`000?l94P[o0000o`TB2_l92@[o2A8:
0_l92@X2o`TB2P03o`T92_l94P[o2@T:00?o2A8:00?o2@T:o`TB2_l92@X0
0ol92@X01?l94P[o2@T:o`000?l94PX2o`T92P;o2A8:00?o2@T:o`000?l9
2@X00_l92@X03Ol0003o2@T:o`T92_l92@[o0000o`TB2_l92@[o0000o`T9
2_l0003o2A8:o`T92_l94PX00_l000000ol92@[o0000oa4L2P05o`T92P04
o`000?l92@[o2@T:o`T92P;o000000Co4A`:o`000?l94P[o00000ol92@X0
0ol0003o2A8:o`T92P02o`T92P04o`TB2_l0003o2A`Do`0000Co2@T:00Go
4A`:o`T92_l0003o2A8:o`T92P02oa4L2P;o2@T:00?o6PT:oa4L2_l92A@0
0olJ2@X03olA70[o6Q8Dob`L5?lJ71ko8blYob`L5?lS;c?o8blNoaXL7_ld
;bWo;2HDoa4V5?l92@[o0000o`TB2P02o`T92P05oaXB5?l92@[o2@T:o`T9
2_l94PX00_l92@X01_lJ71ko0000o`TB2_l92@[o0000o`T92P;o2A8:3ol9
2@X2o`TB2P?o2@T:00Go2A8:o`T92_l92@[o2@T:o`TB2P02o`T92P07o`TB
2_l92@[o2A8:o`TB2_l92@[o2A8:o`T92P02o`TB2P04o`000?l94P[o2A8:
o`TB2PCo2@T:00Co2A8:o`T95?l92@[o2@T:0_l94PX00olJ2@[o2A8:o`T9
2P02o`TB2P?o2@T:0ol94PX3o`T92P04o`T95?l92@[o2A8:oaX92P;o2@T:
00Ko4A`:o`TB2_l92@[o4A`:oaX92_nEQ7]Oooooo`04ojn_[oo;bl_og]kN
on[ZjP7ol_;b003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol;
DjkoY/KVokWCk_mi[^/00_n[gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP0:
o`TB2_lJ4QCo2A8:o`T92_l94P[o2@T:ob<_:Ol92@[o2A8:o`T92P;o2A8:
0_l92@X01_l94P[o2@T:o`T92_l94P[o4BHNo`T92P?o2A8:00?o2@T:o`TB
2_l94PX00ol92@X03?l94P[o2@T:o`T92_l0003o2A8:o`000?l94P[o0000
o`T92_l94P[o2@T:o`TB2P;o2@T:00Go2A8:o`T92_l92@[o0000o`TB2P03
o`T92P03oa4L2_l0003o2A8:00;o2@T:00ko0000o`T92_l92@[o0000o`TB
2_l92@[o2A8:o`000?l92@[o2A8:o`000?l94P[o2@T:o`TB2P;o2@T:00Go
2A8:o`000?l94P[o0000oa4L2P02o`00000;o`TB2_l92@[o0000o`TB2_l0
003o2A8:o`000?l94P[o2@T:o`000?l94PX00ol92@X01?l94P[o0000oa4L
2_l00002o`T92P03o`TB2_l92@[o2@T:00;o2@T:00Co2A8:o`T92_l92@[o
00000_l92@X01Ol94P[o2@T:o`T92_l92@[o000000;o2@T:00Go0000o`T9
2_lJ2@[o2A8:oa4L2P03o`T92P03o`000?l92@[o000000?o2@T:0_lJ2@X0
2_lA70[o2@T:oaXB5?l971Co4A`:ob`L5?lA9QCo6PT:oaXB5?lS;ah3ob<_
:@05ob`h:OlS;bWo8blYob`h:OlS;ah01Ol92@X00ol0003o2A`Doa4L2P03
o`T92P04o`T95?l94P[o2@T:o`TB2P?o2@T:00?o2A8:o`T92_l92@X01_l9
2@X01Ol94P[o2@T:o`T92_l92@[o2A8:00Go2@T:00?o2A8:o`T92_l94PX0
0_l92@X02Ol0003o2A8:o`T92_l92@[o2A8:o`T92_l94P[o2@T:o`TB2P02
o`T92P03o`TB2_l92@[o2@T:00?o2@T:00Co2A8:o`T92_l92@[o2A8:0_l9
2@X00ol92ACo0000ob`L5002o`T92P05o`TB2_l92@[oPbl0okUW0?l00000
1_l92@X04?l92ACo2@T:o`T92_l94P[o2@T:o`000?l92@[o0000o`TB2_l9
2@[o2A8:o`T92_l94P[o6Q8Do`T92_n3Q8iOonk^kP04oj>SXonm_Kgoclo?
om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?Cdoo8b<So]kNgoifMWOl?
EZooXl;TokSCkomg[^/00_nZgol01?mZJV[o[Zj^omSHf?oTi>AKonKViP04
oaXB5?lA9P[o2A8:o`T92P?o2A8:00Go2BHYoaXB5?l92@[o2@T:o`TB2P03
o`T92P05o`TB2_l92@[o2A8:o`TL5?l99RT00_l000001?l92@[o4A`:o`00
0?l00004o`TB2P05o`T92_l94P[o0000o`T92_l94PX00_l92@X01olA70[o
0000o`TB2_l0003o2@T:o`TB2_l000000_l94PX01_l92@[o2A8:o`T92_lA
70[o0000o`T92P;o2A8:00?o2@T:o`TB2_l94PX00ol94PX01_l92@[o2A8:
o`000?l92@[o2A8:o`0000?o2@T:0_l94PX02?l92@[o0000o`TB2_l0003o
2A8:o`000?l92@[o2@TD1_l92@X00ol94P[o0000o`T92P03o`TB2P0:o`00
0?l94P[o0000o`T92_l94P[o2@TDo`T92_l94P[o0000o`T92P;o2A8:1Ol9
2@X01?lA70[o2@T:o`TB2_l94PX3o`T92P06oa4L2_l94P[o4A`:o`TB2_l0
003o4A`:2?l94PX01_l92@[o4A`:o`T92_lA70[o2@T:oa4L2P;o6PT:00Ko
6Q`Nob<_:OlA9P[o2A8:oaXB5?lS;c<2ob`h:@06oc@_:Ol/>2Wo=2lYocd_
?Ol/>2Wo6RHD0ol94PX01?l92@[o2A8:oa4L2_l00002o`TB2P;o2@T:00?o
=2lYo`000?lA70X00_l94PX01_lA70[o2@T:o`T92_l94P[o2@T:o`TB2PCo
2@T:00Go2A8:oa4L2_l92@[o2@T:o`TB2P05o`T92P06o`TB2_l0003o2A8:
o`TB2_l92@[o2A8:0ol92@X5o`TB2P03o`T92_l94P[o2@T:00Ko2@T:00?o
4A`:o`TB2_l92A@00_l94PX01_l92ACo0000ojI10?oomP3oPbl0oeLL00;o
Pbl000Woi:X0ooo@0?lm4P[o2@T:o`000?lA70[o2@T:oa4L2_l94PX01?l9
2@X00olS;bWo2A8:o`TB2P02o`TB2P07o`T92_lJ4QCo2A8:o`T92_lA9QCo
6Q8Doh>4SP1OonKViP04oifMWOng]kOob<S8om?Cd`7of][J003oonk^kQWo
k^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol?EJooYLCVokWCkomg[^/00_nY
g?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP03oaXB5?l92@[o2A8:00Co2A8:
00Ko2@T:oa4L2_lA70[o2@T:o`TB2_l92@X2o`TB2P0>o`000?l94P[o2A8:
o`000?lJ2@[o2A8:o`T92_lA70[o0000o`T92_l94P[o2@T:o`TB2_l00002
o`T92P;o2A8:0_l92@X2o`TB2P03o`000?l92@[o2@T:00;o2@T:00Co2A8:
o`T92_l92@[o2@T:0_l94PX00ol92@[o4A`:oa4L2P02o`TB2P;o2@T:00?o
2A8:o`000?l000000ol92@X01OlA70[o2@T:o`T92_l92@[o2A8:00;o2@T:
00?o2A8:o`000?l94PX00ol94PX01olA70[o0000o`T92_lA70[o0000o`T9
2_l94PX02?l92@X00ol0003o2@T:o`T92P03o`T92P;o2A8:00Ko0000o`T9
2_l94P[o0000o`T95?l00004o`TB2P03o`000?l92@[o2@T:00Go2A8:1Ol9
2@X01?lA70[o2@T:o`T92_lA70X4o`T92P0?o`TB2_l0003o4A`:oa4L2_l9
2@[o6PT:oa4V5?lJ4QCo4A`:ob<_7_lS9P[o4A`:oaXL7_lS;ako;3PY00Oo
=2lY00Oo2A8:o`T92_l92@[o2A8:o`T92_l94P[o000000;o2@T:00Co2A8:
o`T92_l92@[o2A8:0_l92@X00ol94P[o2@T:o`T92P02o`T92P05o`TB2_l9
2@[o2@T:o`T92_l94PX00_l92@X00ol94P[o2@T:o`T92P03o`T92P08o`TB
2_l92@[o2@T:o`TB2_l92@[o4A`:o`T92_l94PX5o`T92P06o`TB2_l92@[o
2@T:o`TB2_l92@[o4A`:0_l92@X00olA70[o2@T:o`T92P04o`T92P;o2A8:
00Oo2@T:oa4L2_l0003o/4`0oooI0?ood03oomT000;oooH000KoomT0ooK7
2_of/`3oARH:o`T92_lA70X4o`T92P0;oa4L2_l94P[o4A`:o`T92_l94P[o
6Q8Do`TB2_l92@[o4A`:o`TB2_lJ4Q@00_l94PX00ol92ACo0000oh>4SP1O
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003ooooooaWooooo00Wol_;b
on[Zj_oNg]kobl_;ojn_[ol;E;7oY<CVokWCkomf[NX00_n[h?l01?mfMWKo
`L71oo3`l?omoOeKooooo`;o2A8:00?o2@T:o`TB2_l92@X01?l92@X01?l9
4P[o2@T:o`TB2_lA70X4o`T92P0Ao`000?l92ACo0000o`TB2_l92@[o0000
o`TB2_l92@[o0000o`T92_l0003o2@T:o`000?l94P[o2@T:o`000?l94PX0
0_l92@X01?l0003o2A8:o`TB2_l00002o`TB2P08o`000?l94P[o2A8:o`T9
2_l0003o2A8:o`T92_lA70X2o`T92P03o`TB2_l92@[o000000?o2A8:00go
2@T:o`TB2_l92@[o0000o`TB2_l92@[o0000o`TB2_l92@[o0000o`TB2_l0
003o2@TD00Co000000_o2A8:o`T92_l0003o2A8:o`T92_l0003o2A8:o`T9
2_l0003o2@T:o`TB2P02o`T92P09o`000?l92@[o2@T:o`T92_l94P[o2@T:
o`000?l92@[o000000;o2A8:00Ko0000o`T92_l0003o2@T:o`TB2_l92@X2
o`000003o`T92_l94P[o000000;o2@T:00Ko0000o`TB2_l0003o2A8:o`T9
2_l94PX8o`T92P0:o`000?l92@[o0000o`T92_l0003o6PT:oa4L2_l0003o
6Q8Doa4L2PCo6Q8D00Co;1`Dob`h:Ol/>2Wo=2lY0_ld;c<3oc@_:@08ob<_
7_l92@[o2@T:o`T92_l0003o2A8:o`000?l94PX2o`T92P03o`000?l94P[o
2@T:00?o2@T:00?o0000o`TB2_l92@X01_l92@X01Ol0003o2A8:o`T92_l0
003o2A8:00Co2@T:00Ko0000o`TB2_l94P[o0000o`T92_l00002o`T92P03
oa4L2_l92@[o2@T:00;o2@T:00?o0000o`T92_l92@X01_l92@X01ol0003o
4A`:o`T92_l0003o2A8:o`T92_l000000ol92@X03?l94P[o?A8:ol640?nV
LP3oPd40og8h0?lm4P[o;180om>40?ood03o?A8:o`TB2P?o2@T:00?o2@TD
ob`h:Ol000000ol92@X01OlA70[o2@T:o`TB2_l92@[o000000;o2@T:00Go
2A8:o`T92_l94P[o0000oiF4SP1Oooooo`04ojn_[oo;bl_og]kNon[ZjP7o
l_;b003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol;DjkoYLCV
okG@k_mi[^`00_nWg?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP03o`T95?l9
4P[o6Q8D00Co2A8:0ol92@X2o`TB2PKo2@T:017o2A8:o`T92_l94P[o0000
o`TB2_l0003o2A8:o`T92_lA70[o2@T:o`000?l94P[o2@T:o`000?l94P[o
0000o`TB2P03o`T92P05o`000?l94P[o0000o`000?l94PX00_l00003o`TB
2P?o2@T:00?o4A`:o`T92_l94PX00_l92@X2o`000003o`TB2_l0003o2A8:
00Oo2@T:00Co0000o`TB2_l92@[o00000_l94PX01Ol92@[o0000o`TB2_l0
003o2A8:00?o2@T:00?o0000o`TB2_l92@X00_l000001?l94P[o2@T:o`TB
2_l00002o`T92P04o`000?l94P[o0000o`TB2P;o2@T:00Go2A8:o`000?lA
70[o2@T:o`TB2P04o`T92P03o`000?l94P[o2@T:00Co2@T:00Ko0000o`TB
2_l0003o2A8:o`T92_l94PX7o`T92P03o`TB2_l92@[o4A`:00;o2@T:00So
4A`:o`T92_lJ4QCo6Q8DoaX92_lA9P[o8blNob<_<`?o=2lY00?o=2lcodI<
?Old;bT00_lS;c<00ol/71Co2@T:o`T92P02o`T92P04o`TB2_l92@[o2@T:
o`0000?o2@T:00?o0000o`TB2_l92@X00_l92@X00ol94P[o2@T:o`T92P03
o`T92P03o`TB2_l92@[o2@T:00Go2@T:00?o4A`:o`T92_l92@X01Ol92@X0
0olA70[o2@T:o`T92P05o`T92P04oa4L2_l92@[o2@T:o`TB2PSo2@T:00[o
4A`:o`T92_l92@[o4A`:o`T92_l94P[o4A`:o`T92_l94P[o2@TD0_l00000
1ol92ACo2@T:o`T95?l92@[o6PT:o`TB2_l92@X00ol94PX00olJ4QCo2@TD
o`T92P03o`T92P05o`TB2_l92@[o2@T:o`TB2_l000000_l94PX01Ol92@[o
6Q8Doa4L2_l0003oUIRS05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
0?ooi^KV6OoVi^H02OoJf][odm?ColS8b?ng]kOoWIfMo`]D/OnTa>Ko^=;^
ogJ]jP02ojcOo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00?o2A8:o`T92_l9
2A@00_l92A@2o`T92P08o`T95?l92@[o2@T:o`T92_l94P[o2@T:o`T95?l9
4PX3o`T92P05o`000?l92@[o2@T:o`TB2_l000001_l92@X00ol0003o2@T:
o`T92P02o`T92P03o`000?l92@[o2@T:00Co2@T:00Wo2A8:o`000?l92@[o
2A8:o`000?l92@[o2A8:o`T92_l94PX00_l92@X00olA70[o2@T:o`T92P02
o`T92P03o`TB2_l0003o2@T:00Ko2@T:00Co0000o`T92_l92@[o00000_l9
2@X00ol0003o2@T:o`000005o`T92P04o`000?l92@[o2@T:o`0000;o2A8:
0_l92@X2o`0000;o2@T:00Oo0000o`T92_l0003o2@TDo`000?l92@[o0000
00;o2@T:0_l00003o`T92P03o`000?l94P[o000000Co2@T:00?o4A`:o`00
0?l92@X01?l92@X00olA70[o2@T:o`000009o`T92P03oa4L2_lJ2@[o2@T:
00;o4A`:0_lJ4Q@03?l/9QCo8blNoc@_:Old;c?o=2lYoc@_<ol/>2Wo=2lY
ob`h:OlS;bWo4BHDo`0000Go2@T:00?o0000o`T92_l92@X03_l92@X01OlA
70[o2@T:o`000?l92@[o4A`:00?o2@T:00?o2A8:o`T92_l92@X01?l92@X0
0ol0003o2@T:o`000003o`T92P03o`000?l92@[o2@T:00;o2@T:00Co4A`:
o`000?l92@[o4A`:1Ol92@X00ol0003o2@T:o`T92P07o`T92P06o`TB2_l9
2@[o2A8:o`T92_l0003o2A8:0ol92@X01?lA70[o2@T:o`T92_lA70X7o`T9
2P04o`TB2_l92@[o2@T:o`T92P;o2A8:0_l92@X00ol0003oUIRSonKViP1N
onKViP04oifMWOng]kOob<S8om?Cd`7of][J003oonk^kQWok^k^00WohN7Q
om[Jf_o?cloo_Kfmoj>SXol=E:koY/KVokK@k_mi[nh00_n[g_l01?m^KVko
];Bdon3Ph?o/k>aKonk^kP;o2A8:00go2@TDo`TB2_l94P[o2A8:o`T92_l9
4P[o2@T:o`TB2_l92@[o2A8:o`T95?l92@[o2A8:00;o2@T:0ol94PX00ol0
003o2@T:o`T92P03o`T92P04o`T95?l92@[o2@T:o`TB2P?o2@T:00?o2A8:
o`T95?l92@X00_l92@X2o`TB2P[o2@T:00So2A8:o`T92_l92@[o2A8:o`T9
5?l92@[o2A8:o`0000?o2@T:00Co4A`:o`000?l92@[o2A8:0ol92@X01Ol9
4P[o2@T:o`000?l92@[o2A8:00Go2@T:00[o2A8:o`T92_l92@[o2@T:oa4L
2_l94P[o0000o`TB2_l92@[o2A8:1_l92@X01Ol94P[o2@T:o`TB2_l0003o
2A8:00;o2@T:00Oo2A8:o`T92_l94P[o0000o`TB2_l0003o2A8:00Ko2@T:
00Oo0000o`T92_l92@[o2@TDo`T92_l94P[o4A`:00Ko2@T:00?o2A8:o`T9
2_l92@X00_l92@X2oaXB500:oa4L2_lJ2@[o6PT:oaXB5?lJ71ko;1`Dob`h
:Om6@Ako?BlmodI17P;o=2lc00Oo?Blmob`h:OlS;ako2@T:o`TB2_l92@[o
2A8:00?o2@T:00?o2A8:o`T92_l92@X00_l92@X01?l0003o2@T:o`T92_l9
4PX:o`T92P03o`TB2_l0003o2@T:00?o2@T:00?o4A`:o`TB2_l92@X01ol9
2@X00ol94P[o2@T:oa4L2P0?o`T92P;o2A8:1Ol92@X02olA70[o2@TDo`T9
2_lA70[o2@TDo`T92_lA70[o2@TDo`TB2_lA70[o2@T:00;o2A8:0_l92A@0
0ol94P[o2@T:o`T92P03o`T92P03o`TB2_lA70[o2A8:00?o2@T:00Go4A`:
o`T95?l92ACo0000oiF4SP1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
003ooooooaWooooo00Wol_;bon[Zj_oNg]kobl_;ojn_[ol:DJkoY<?UokSB
komi[^`00_n/gol01?mfMWKo`L71oo3`l?omoOeKooooo`;o2A8:00?o4A`:
o`T92_l92@X00ol94PX2o`T92P;o2A8:00?o6Q8Do`T92_l94PX00_l92@X0
0ol0003o2@T:o`T92P03o`T92P09o`000?l92@[o2@T:o`T92_l0003o4A`:
o`T92_l0003o2A8:00;o2@T:00Ko0000o`TB2_l92@[o2@T:o`000?l94PX3
o`T92P09o`000?l92@[o2A8:o`T92_l94P[o0000oa4L2_l94P[o4A`:00;o
2@T:00?o2A8:o`000?l92@X01?l92@X03Ol94P[o4A`:o`T92_l92@[o4A`:
o`000?l94P[o2@T:o`000?l94P[o2@T:o`000?l94PX01Ol92@X00ol0003o
2A8:o`T92P02o`000005oa4L2_l0003o2A8:o`000?l94PX00_l92@X02?l0
003o2@TDo`000?l92@[o0000o`T95?l92@[o00000_l92@X2o`000007o`T9
2_l0003o2@T:o`T92_l0003o2A8:o`000004o`T92P05oa4L2_l92@[o0000
o`T92_lA70X01?l92@X01ol94P[o2@T:oa4L2_l92@[o6PT:oa4L2_l92@X0
0_lA70X2o`T92P09oaXB5?lA70[o4A`:oaX92_lJ4QCo8blcoc@_7_ld;c?o
?Blm00?o=2lc0_l/>2T00olJ4QCo2A8:o`000002o`T92P08o`000?lA70[o
2@T:o`000?l92@[o2A8:o`T92_l92A@3o`T92P03o`TB2_l92@[o2@T:00Co
2@T:00?o4A`:o`T92_l94PX00_l92@X01?lJ2@[o2@T:o`T92_lA70X4o`T9
2P04oa4L2_l94P[o2@T:oa4L2P?o2@T:00?o6Q8Doc@_:OlJ4Q@01?l92@X0
0ol94P[o2@T:o`T92P05o`T92P04oa4L2_l92@[o2@T:oaX92P;o2@T:00Ko
4A`:o`T92_l92@[o4A`:o`T95?l00004o`T95003o`TB2_lm4P[oPbl000;o
2A8:00Co2@T:o`T95?l92ACo4A`:0_l92@X01?l94P[o2@TDo`TB2_l94PX2
o`T92P09o`TB2_l92@[o4A`:o`T92_lJ4QCo4A`:oa4V7_l0003oUIRS05oo
oooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800?ook^k^6Oo^k^h02OoQhN7o
f][Jolo?conm_KgoXj>So`eD[_nUa>Ko]];^ogV^j@02oj[Po`04ofi^K_nd
];Coh>3Ponc/k5_ok^k^00?o2@TDoa4L2_l92A@00_l94PX00ol92@[o2A8:
o`TB2P04o`T92P03oaXL7_lA70[o2@T:00?o2@T:00Go2A8:o`T92_l92ACo
2@T:oa4L2P02o`T92P;o2A8:0ol92@X00ol94P[o2@T:o`T92P03o`T92P;o
2A8:1Ol92@X01Ol94P[o2@T:o`T92_l94P[o2@T:00;o4A`:00?o2@T:oaX9
2_lA70X02Ol92@X00ol94P[o4A`:o`T92P0:o`T92P04o`000?lA70[o6Q8D
o`TB2P;o2@T:00?o0000o`T92_l94PX00_l92@X01Ol94P[o0000o`T92_l9
2@[o2A8:00?o2@T:0_l94PX3o`T92P04o`TB2_l92ACo2@T:o`TB2P?o2@T:
00?o4A`:o`T92_l92@X02?l92@X04_lA70[o2@T:o`T92_l92@[o2A8:oa4L
2_lJ2@[o;180oaX92_l/4P3oARH:ocdB2_lJ4QCo6PT:o`T92_lJ2@[o4A`:
oaXB50?o6PT:00Ko8blYob`L5?ld;bWo?Blmoc@_<om6C3d2oc@_<`;o;3PY
00?o2@TDo`TB2_l94PX01?l92@X00ol92ACo2@T:o`TB2P03oaXB5004o`TB
2_l92@[o2@T:o`T92P;o4A`:3Ol92@X00ol92ACo4A`:o`T92P08o`T92P04
ob<_<ol92@[o2@T:oa4L2POo2@T:00?o2A8:o`T92_l94PX01_l92@X04olA
70[o2@TDoaXB5?lA70[o2@T:o`T95?n3;`3ook<0og8h5?l0003o=2lNob`B
0?oCQ03oomT0ocdB2_l92@[o4A`:o`T95?lJ4Q@00_l92@X01?lA70[o2A8:
o`T92_lJ4Q@3o`T92P09oa4L2_l92@[o2@TDo`T92_lJ2@[o4A`:o`T95?l0
003oUHB>05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400?ooi^KV6OoV
i^H02OoJf][odm?ColS8b?ng]kOoWIfMo`]C[_nVa^Ko^M?^ogV^j`02oj_O
o`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00?o2@TDo`TB2_l94PX00_l94PX3
o`T92P03o`TB2_l92@[o2A8:00;o2@T:0ol94PX02ol92@[o2A8:o`000?l9
4P[o0000o`TB2_l0003o2A8:o`000?l94P[o000000;o2A8:01;o0000o`TB
2_l0003o2A`Do`000?l92@[o2A8:o`000?l92@[o2A8:o`000?l94P[o0000
o`TB2_l0003o2@T:o`TB2_l00002o`TB2P?o2@T:00Go4A`:o`TB2_l92@[o
0000o`T92P02o`TB2P06o`000?lA70[o2@T:oa4L2_l92@[o4A`:0ol92@X0
1?l94P[o0000o`TB2_l94PX2o`T92P05o`TB2_l0003o2A8:o`TL7_l00000
0_l94PX3o`T92P0:o`000?l94P[o0000o`T95?l0003o2A8:o`000?l94P[o
0000o`TB2P;o000000Ko2@T:o`TB2_l0003o0000o`T92_l00002o`T92P;o
2A8:00?o0000o`T92_l92@X01?l92@X04?l94P[o2@T:o`T92_lA70[o6PT:
o`T92_lA70[o2A8:ob`B0?lJ2@[oARHDodHV2_l/71Co?A8:of0_2_mG7002
ob`B0003oa4L2_lJ2@[o4A`:00;o6PT:00Oo4A`:ob`L5?lJ71ko;2HDoc@_
<oldEBWo?Blm00;o=2lc00So;3PYob<_:OlJ9QCo4A`:o`TB2_l0003o2@T:
o`TB2P;o2@T:00Wo2@TDo`TB2_l971Co2@TDo`T92_lJ4QCo0000o`TB2_l9
2@X00_l94PX8o`T92P03o`TB2_l92@[o2@T:00;o2A8:0_l92@X03?l94P[o
4A`:o`TB2_l94P[o4A`:o`T92_lA70[o2A8:o`T92_l0003o?Blmo`TB2P?o
2@T:00Co4A`:o`TB2_l92@[o2A8:1?l92@X00ol94P[o2@T:o`T92P03o`T9
2P;o2A8:00ko6Q8Do`T92_l94P[o2@TDog8V0?oTZP3oom00onBZ0?of/`3o
om00oooI0?of/`3om/L:ocdB2P?o2A8:00Co2@T:oa4L2_l92@[o2@T:0_l9
4PX00ol92@[o4A`:o`T92P05o`T92P05oa4L2_l92@[o4A`:o`T92_n3Q8h0
GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP002?o^k^h2ong]kOook>c/
3oo/k>`02OoOgmoof=SHolg=cOnk^k_oXJ6Qo`mF[onS`^Co^=?_ogN^j`02
oj[Oo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Go2A`DoaXB5?l94P[o2A8:
o`T92P02o`TB2P03o`T92_l94P[o2A8:00;o2@T:00Wo2A8:o`T92_l94P[o
0000o`T92_l94P[o2@T:o`TB2_l000001Ol92@X03Ol92ACo0000o`TB2_l9
4P[o0000o`TB2_l92@[o0000o`TB2_l92@[o0000o`T92_l000000_l92@X0
3Ol92ACo0000o`TB2_l92@[o2A8:o`000?l92@[o4A`:o`T92_lA70[o6PT:
o`T92_l94PX00ol92@X02Ol0003o4A`:o`T92_l92@[o4A`:o`T92_lA70[o
2@T:o`TB2P04o`T92P03o`TB2_l92@[o2A8:00;o2@T:00?o4A`:o`000?l9
2@X00_l00004o`T92P03o`TB2_l0003o2@T:00;o2A8:00Go0000o`T92_l9
2@[o2@T:o`000005o`T92P05o`000?l94P[o0000o`TB2_l000000_l92@X0
0ol94P[o2@T:o`TB2P03o`T92P0@o`TB2_l0003o2A8:oa4L2_lJ2@[o?A8:
ob`B0?lS70[o?A8:ob`L5?mP;aCoPbl0oeLL0?lm70[oEa`0of0_2P;oARHD
01Co6PT:oa4L2_lJ2@[o6PT:o`TB2_lS70[o6PT:ob<L2_lS;bWo;1`Dob`h
:Olm;cgoAT`mocd_?Old;c?o=2lYob<_7_lJ4QCo2@T:o`0000;o2@T:00Co
0000o`TB2_lA70[o2A8:0_l000001Ol94P[o0000ob`L5?l92@[o000000;o
2@T:00Go2A8:oa4L2_lA70[o2@T:o`TB2P05o`T92P04o`000?lA70[o2@T:
o`0000Wo2@T:00Ko2A8:o`T92_lA70[o4A`:o`T92_lA70X6o`T92P03oa4L
2_l0003o4A`:00Co2@T:00_o2A8:o`T92_lA70[o2@T:oa4V5?l92ACo4A`:
o`TB2_l92ACoPcP0ooo@0002onBZ0007ol640?nVLP3oUED0onBZ0?ood03o
Ea`0o`T92P02o`TB2P03oa4L2_l92@[o2A8:00;o2@T:00?o2A8:o`T92_l9
2@X01?l92@X01ol94P[o2@T:oa4L2_l92@[o2A8:o`000?nEV:<0Goo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@001_ooool01_omoOgon_[jooKfm_oa
lO7okno_ong]kOook>c/3Oo/k>`02OoOgmoof=SHolg=cOnk^k_oXJ6Qo`mE
[onUa>Ko^M?_ogN^j`02ojWLo`04ogIfM_o1`L7ol?3`oogmoE_ooooo00Go
6Q8Do`TB2_l92ACo2A8:o`T92P02o`TB2P03o`000?l94P[o2A8:00Oo2A8:
013o0000o`T95?l0003o2A8:o`T92_l0003o2@T:o`000?lA70[o2@T:o`TB
2_l92@[o0000o`TB2_l0003o2A8:0_l92@X00ol0003o2A8:o`TB2P03o`T9
2P04o`000?l92@[o0000o`0000Co2@T:00Co4A`:o`T92_l92@[o2A8:0ol9
2@X01?lA70[o0000o`T92_l92@X2oa4L2P07o`T92_lA70[o2@T:o`000?l9
4P[o0000o`T92P03o`TB2P04o`000?l92@[o2@T:o`0000;o2@T:00Co4A`:
o`T95?l0003o2A8:0ol92@X01Ol0003o2A8:o`000?l0003o2A8:00Co2@T:
00ko2A8:o`T92_l0003o2@T:o`000?lA70[o0000o`T92_l0003o4A`:o`T9
2_l0003o2@T:o`0000?o2A8:0ol92@X00ol0003o6PT:ocdB2P04odHV2P0N
oeLL0?mb>03oH2l:of0_2_lm70[oJT4:of0_2_mG703oARHDob`L5?lm4P[o
6PT:oaXB5?l/4P3o8a`:oa4L2_lJ4QCo6Q`Nob`h:Olm;cgo=5DYob=1D_ld
EBWo=2lYob<_:OlJ9QCo4BHDo`000?l94P[o00000_l94PX2o`000003o`T9
5?l92@[o2@T:00;o2@T:00?o2A`Do`000?l92@X02?l92@X00ol94P[o2@T:
o`T92P02o`T92P07o`000?l94P[o2@T:o`T92_l94P[o4A`:o`000002o`TB
2PCo2@T:00Go2A8:o`T92_l92@[o4A`:o`TB2P0;o`T92P04o`000?l92@[o
4A`:o`TB2P;o2@T:00?o2@TDo`TB2_l92@X00_l92@X00ol99RWo0000o`T9
5002o`000005o`T95?l0003o?A8:og8h0?l92A@01?l92@X2o`TB2P04o`T9
5?l92@[o2A8:o`TB2POo2@T:0ol94PX00ol0003oYZ6Hooooo`1Nooooo`04
ojn_[oo;bl_og]kNon[ZjP7ol_;b0004onk^kP08ong]kOo[jn_ohn?SomOG
eoo6a/Ko]kNgojf][OnXZ:SoojFUY@goYJFU00WoW9bLoiNGUon?ShooPh>3
og5aLOl;E;7oY<CVokWCkomf[NX00_n[h?l01?m^KVko];Bdon3Ph?o/k>aK
onk^kP0Fob<_7_l94P[o2A8:o`T92_l94P[o2@T:o`TB2_l92@[o4A`:o`T9
2_l0003o2A8:o`T92_l94P[o2@T:o`000?l94P[o2@T:o`000?l94P[o0000
o`T92P?o2A8:00?o2@T:o`000?l94PX00ol92@X01Ol0003o2A8:o`000?l9
4P[o2@T:00;o000000Ko2A8:o`T92_l92@[o2@T:o`TB2_l92@X2o`TB2P08
o`T92_l94P[o4A`:o`000?lA70[o2@T:oaX92_lA70X3o`T92P;o2A8:0_l9
2@X2oa4L2P;o2@T:00Co4A`:o`000?lA70[o2A8:0_l000003Ol94P[o2@T:
o`000?l94P[o2@T:o`TB2_l0003o2@T:o`000?l92@[o0000oa4L2_l00000
0_l92@X01?l0003o2A8:o`T92_l00007o`T92P06o`000?l94P[o0000o`TB
2_l0003o2@T:0_l000000olA70[o2@T:o`T92P05o`T92P;o2A8:00CoEa`0
of0_5?mG703oARH:0omG70002_mP;`[oNd40odHV2_mG703oARH:og]10?mP
;`[oEa`0of0_2_mb9P02oeLL0003ob`L5?lJ2@[o4A`:00;o8blN017o;3PY
oc@_:Olm;cgo?Blmoc@_<olS;bWo;1`Doa4L2_lJ2@[o2@T:o`TB2_l0003o
2A8:o`000?l94P[o4A`:o`000003o`T92P04o`TB2_lS;ako2@T:o`TB2P;o
2@T:00Co4A`:o`T92_l92@[o2@T:0_l94PX2o`000003oa4L2_l92@[o2A8:
00;o2@T:00?o2A8:o`T92_l94PX00_l92@X00olA70[o2A8:o`T92P04o`T9
2P03o`TB2_lA70[o2@T:00So2@T:00Co2A8:o`T92_l94P[o4A`:1_l92@X0
0olA70[o6Q8Doa4L2P04o`T92P04oa4L2_l92@[o2@T:o`TB2P;o2@T:00?o
2@TDo`000?l94PX01?l92@X01?l94P[o2@T:o`T92_l94PX2o`T92P;o4A`:
0ol92@X00olA70[o2@T:oaXB5002o`T92P03oiFHXoo^k^kok^k^05gok^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN4000Coi^KV00[ohn?SomWIfOnc/k?o
P820ofm_KomjNW[oRh^;oi:BT_nIVIWoXJ6Q3_nWYjL6ojRXZ0;oZJVY1OnZ
ZZX;oj^[Z`;o[:b/0_n][Jd01?n/[:co[Jf]ojf][On][Jd:ojj^[P?o[jn_
0_n`/;02ok6a/@03ok:b/_nc/k?o/k>c00?o];Bd2?ne]KD5okJf]P03okNg
]onf][Ko][Jf00Go]kNg2_nh^;P3okVi^@03okZj^_nk^k_o^k^k00;o_;bl
2onm_Kd5okjn_P;o_kno1_o0`<0:ol71`@?o`/;200?oa<C4ol?3`oo5aLD0
0_o5aLD:olK6aPgoalO72?o8b<P3olW9b@;ob/[:0oo<c<`3olk>cP;oclo?
2oo@d=02om7Ad@?od];B0_oCdm<;omCDe0GoeMGE00?oemOGomSHf?oHf=P0
1OoJf]X8om_Kf`;og=cL0ooMgMd00ooNg]kogMgMomkNgP02omkNgP?ogmoO
3_oPh>001?l;DjkoYLCVokG@k_mi[^`2ojOLo`04ofYZJ_n^[Zkof=SHonCT
i5_oi^KV00Wo6Q8Do`TB2_l92@[o2@T:o`TB2_l0003o2A8:o`000?lJ71h0
1?l92@X01Ol94P[o2@T:o`T92_l92@[o2A8:00;o2@T:0_l94PX03Ol92@[o
2A8:o`000?l94P[o0000o`TB2_l92@[o4A`:o`000?l92@[o2A8:o`000?l9
2A@00ol92@X01_l94P[o0000o`TB2_l0003o2@TDo`TB2P?o000000Ko2@T:
o`TB2_l94P[o2A8:oa4L2_l00004o`T92P06o`TB2_l0003o2@T:o`TB2_l9
2@[o4A`:0_l92@X00ol94P[o0000o`T92P02o`TB2P05o`000?l92@[o2@T:
o`000?l94PX00_l00005o`T92P07o`000?l92@[o2A8:o`T95?l94P[o2@T:
o`000003o`T92P06o`000?l92@[o2@T:o`TB2_l0003o2A8:0_l000000ol9
2@[o2A8:o`000003o`T92P03o`000?l92@[o2@T:00Co2@T:00?o2@TDob`B
0?mP;a@00omG70002omP;`[o?A`:oeLL0?mP;`[oLRH0ob<L2_m69P[oH2l:
odHV2_m69QCoEa`000?oLRH000?oH2l:odHV2_l/71@00_l/71@05OlS;bWo
;1`Doc@_<oldECgo=2lcob`h:Old;bWo8blNoaX92_lA70[o2@T:o`TB2_l0
003o2A8:o`000?l92@[o0000o`T92_l94P[o0000o`TB2P02o`000003oaX9
2_lA70[o2@T:00Co2@T:0_l94PX01_l0003o2@T:o`T92_l0003o2@T:o`00
00;o2@T:00?o2A8:o`T92_l92@X00_l92@X00ol94P[o0000o`T92P03o`T9
2P03oa4L2_l92@[o2@T:00?o2@T:0_l94PX2o`T92P03o`000?l92@[o4A`:
00?o2@T:00Ko4A`:o`T92_l94P[o0000o`T92_lA9Qh2o`T92P03o`TB2_l0
003o2@T:00;o2@T:0_l94PX00ol92@[o2A8:o`T92P0<o`T92P05oa4L2_l9
2@[o2@T:o`T92_lJ4Q@01?l92@X01?l94P[o4A`:oaXB5?nEQ8iOonKViP04
oifMWOng]kOob<S8om?Cd`7of][J0003onk^kP06onc/k?oShn?oZj^[og=c
LomnOWkoSHf=2?ooool00oono_koooooooknoP02ooKfmP03onk^k_oQhN7o
g]kN00?of][J0ooIfMU2omSHf0SofMWI00Koe]KFom_KfooTi>Cok>c/oo?c
looinOT2ooooo`?oo_kn1_ooool3olo?c`[od=3@0ooAdM400ooBd];odm?C
omCDe002omCDe0[oeMGE1_oFe]H2omOGe`Gof=SH3_oIfMT2om[JfPgofm_K
0ooLg=`2omgMg@?og]kN0ooOgml2on3Ph0_ohN7Q0_oRh^83onCTi0;oi^KV
2ooWinL2onWYj@?oj^[Z00?ok>c/on_[joo[jn/00_o]kNd3onk^kPSol?3`
0_oalO43oo;blP;om?Cd0oofm_H3ooOgm`kon?Sh00Co2eBaojC4i_nhd^ko
MZgZ0_n/gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP;o2A8:00?o2@T:o`T9
5?l92@X00_l92@X01_l94P[o2@T:o`TB2_l92@[o2A8:o`T950;o2@T:00Co
2A8:o`000?l92@[o2@T:0_l00002o`T92P;o00000_l92@X00ol0003o2@T:
o`000004o`T92P09o`TB2_l0003o2@T:o`T92_l0003o2@T:o`000?l94P[o
000000;o2@T:00Go2A8:o`000?l92@[o2@T:o`TB2P02o`T92P;o4A`:0ol9
2@X3o`TB2P;o2@T:0ol94PX02?lJ2@[o2@T:o`T92_l92@[o2A8:o`000?l9
4P[o00000_l92@X02Ol0003o2@T:o`T92_l0003o2A8:o`000?l94P[o0000
oa4L2P02o`0000;o2@T:0_l94PX01ol0003o2@T:o`T92_l92@[o0000o`T9
2_l94PX00_l00008o`T92P04o`000?l92@[o2@T:oa4L2P;o2@T:00So4A`:
ocdB2_lm70[oARH:ocdL2_mP;`[oEa`0ocdL2P;oARH:00Oo?A`:ob`B0?lm
70[o?A`:odHV2_l/71CoH2l:00;oLRH000ooH2l:og8V0?mP;aCoARHDob`L
5?lS70[o6Q`Nob<_:Om6@Ako?Blmoc@_<ol/9QCo6Q`NoaXB5?lS70X00_l9
2@X01Ol0003o2@T:o`000?l92@[o2A8:00;o2@T:00?o0000o`T92_l92@X0
0ol92@X00ol0003o2@T:o`T92P04o`T92P03o`000?l92@[o000000;o2@T:
00Go2A8:o`T92_l92@[o2A8:o`000003o`T92P03o`TB2_l92@[o4A`:00Ko
2@T:00?o0000o`T92_l92@X04_l92@X00ol94P[o2@T:o`T92P0Jo`T92P07
oa4L2_l92@[o2A8:o`TB2_l92@[o0000oiF4SP1Oonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q0003ooooo`06oo[jn_oCdm?oOGemoj2PX?nm_Kgo/;2`
2?ooool02_olo?coo_knoo;bl_oShn?ogmoOomSHf?o=cLgob/[:ol30`?no
_kl2okjn_P04okfm_Onl_;co^k^kok^k^dSo_[jn00So`<30olO7aoo?cloo
eMGEom_KfooUiNGolo?coogmo@?oo_kn1_ooool;omgMg@Gog]kN0_oOgml6
on3Ph0[ohN7Q0ooRh^82on?Sh`?oi>CT2_oUiND6onKViP;oj>SX1OoZj^X;
on_[j`;ok>c/0_o]kNd01?o/k>cokNg]ong]kOo]kNd:onk^kPGokno_0oo`
l?05oo7al@Sol_;b0_oclo<3ooCdm003ooGemOofm_Kom_Kf00;omoOg0ooh
n?P:ooWin@?on_[j0_olo?`3ooknoQ7ooooo00Co3EB^ojK6i_nfd>koNJo^
0_n[g_l01?mfMWKo`L71oo3`l?omoOeKooooo`03o`T92_l94P[o2@TD00;o
2A8:0ol92@X01ol94P[o0000o`TB2_l92@[o0000o`T92_l94PX00_l92@X0
0ol94P[o2@T:o`TB2P09o`T92P03o`000?l92@[o000000;o2@T:00Wo0000
o`TB2_l92@[o0000o`T92_l0003o2@T:o`000?l94PX00ol00002o`T92P03
o`TB2_l92@[o4A`:00Co2@T:00?o4A`:o`T92_l92@X00_l00002o`T92P04
o`000?lA70[o2@T:o`0000?o2@T:00?o0000o`TB2_l000000_l92@X03_l0
003o2@T:o`TB2_l0003o2@T:o`000?l92@[o0000o`T92_l0003o2@T:o`TB
2_l92@[o2@TD0_l000002?l92@[o2A8:o`000?l92@[o0000o`T92_l0003o
2A8:0_l92@X01?l0003o2@T:o`T92_l00003o`T92P03o`TB2_l0003o2A8:
00;o2@T:01?o4A`:ob`B0?lS70[o8a`:ocdB2_lm70[oEa`0odHV2_lS70[o
?A8:odHV5?m6;`[o6PT:ob<L2_l/71CoARHDob<_7_l/4P3o?A8:00;oARH:
00goAT`modI17_lm;cgo=2lcob<L2_l/>2Wo;1`Doc@_<olS;c?o=2lYob`V
5?lS;ako;1`D00;o2@T:00?o0000o`TB2_l000000_l92@X2o`000005o`T9
2_l94P[o0000o`000?l94PX02?l92@X02_lA70[o0000oa4L2_l0003o4A`:
o`T92_l0003o2A8:o`T92_l00002o`T92P03oa4L2_l92@[o2@T:00So2@T:
00?o4A`:o`T92_l92@X00_l94PX?o`T92P05o`TB2_l92@[o2A8:o`000?l9
4PX01_l92@X00ol0003o2@T:o`T92P0>o`T92P09o`TB2_l92@[o2@T:o`T9
2_lA70[o2@T:oa4L2_l0003oPhB>05oooooo00Co[jn_ol_;booNg]koj^[Z
0Oobl_8000;ok^k^00OokNg]onGUiOnATI7oTI6Aolc<c?oEeMGo`/;200So
oooo00Wom?Cdoo;bl_oNg]kob<S8ol30`?nh^;So[Zj^oj^[ZonPX:000_nO
Wil01OnMWIgoW9bLoi^KVonJVY[oVIVI043oVYZJ2?nKVi/02?nSXj?oZj^[
ok:b/_ne]KGo^k^kol[:b_oOgmookNg]0oono_h6ooooo`?oh>3P2_oQhN43
on;RhP03onCTi?oShn?oiNGU00;oiNGU2_oVi^H6onOWi`03onSXj?oYjNWo
j^[Z00Coj^[Z2oo[jn/3onc/k0;okNg]0oo^k^h:ono_k`?ol?3`0_oalO42
oo;blP04oo7alOobl_;ol_;boo;blP;olo?c2?odm?@5ooGem@?om_Kf1Oog
moL:ooShn0?onOWi00?ono_kooclo?olo?`00_ono_hVooooo`04o`YA[_nT
`nGo^=;_ogV^k0;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h2o`TB2P03
oaXB5?l94P[o2A8:00So2@T:00Ko2A8:o`T92_l92@[o2A8:o`T92_l00005
o`T92P05o`TB2_l0003o2@T:o`000?l94PX00_l92@X00ol94P[o0000o`T9
2P06o`T92P07oa4L2_l92@[o0000oa4L2_l92@[o2A8:o`000002o`T92P06
oa4L2_l92@[o4A`:o`000?l92@[o2A8:1?l92@X2o`TB2PGo2@T:00?o8a`:
o`T92_l92@X00_l92@X01?l0003o2A8:o`T92_l94PX2o`0000?o2@T:00Ko
0000oa4L2_l0003o4A`:o`000?l92@X3o`0000?o2@T:00?o0000o`TB2_l9
2@X01?l92@X2o`TB2P;o2@T:00Go0000o`T92_l0003o2A8:o`000002o`T9
2P05o`TB2_l92@[o?A8:oaX92_l/4P000_lS70X06_lm70[oARH:odHV2_lS
70[o8bH:ocdL2_lS9P[o;180ocdL2_l/71Co=2lNoc@_<ol92@[o8a`:ob`L
5?l/>2Wo8blNoc@_:Olm;cgo=2lYob<_7_ld;ako8blYob`h:Om69QCo;3PY
0_l/71@2oa4L2P;o2@T:00Co0000o`T92_l0003o2A8:0_l92@X01_l94P[o
0000o`T95?l92@[o2A8:o`0000Go2@T:00?o2A8:oa4L2_l94PX01ol92@X0
0ol94P[o2@T:oa4L2P02o`T92P04oa4L2_l92@[o4A`:oa4L2PSo2@T:00Co
4A`:o`T92_l0003o2A8:1?l92@X00ol94P[o2@T:o`T92P08o`T92P;o2A8:
1_l92@X00ol94P[o2@T:o`T92P04o`T92P03o`TB2_lJ4QCo2A8:00?o2@T:
00?o4A`:o`T95?l92@X00ol92@X02OlA70[o2@T:o`TB2_lA70[o2@T:oaXB
5?lA70[o0000oiF4N`1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002
onKViP09onGUiOoIfMWoN7Qhokbl_?oHf=Sofm_Kolk>c_oooooooOgm00Go
oooo00gomOGeomkNg_o?cloo_knook6a/OnUYJGoUiNGohb<S?n7QhOoRHV9
ohR8R?n5QHGoPH6100;oOGem00?oOgmooh61POmoOgl0?omoOgl3oh20P00?
oginO_mmOGgoOgmoohB4Q?n9RHWoQhN7ohZ:R_n>SXkoUIFEoj2PX?n`/;3o
`l?3om7AdOoTi>Col_;b00;oo_kn00?oo?clooooooooool00_ooool;onGU
i@Goi^KV0_oWinL6onSXj0[ojNWY0ooZj^X2on_[j`?ok>c/2_o]kNd3onk^
kP?okno_00?olO7aoo3`l?obl_800_obl_82oo?cl`Som?Cd1OoemOD3ooKf
mPGomoOg3Oohn?P3ooWin@oon_[j0ookno/00oolo?cooOgmoogmo@02ookn
oRKooooo00Co3EB^ojG4i_nfd^koNJkY0_nZh?l01?mZJV[o[Zj^omSHf?oT
i>AKonKViP03o`TB2_lJ9QCo6Q8D00;o2@T:00?o2A8:o`T92_l94PX00_l9
2@X00ol94P[o2@T:o`T92P02o`T92P04o`TB2_l92@[o2@T:o`T92P;o2A8:
00Co2@T:o`000?l94P[o00000_l92@X02?lA70[o0000o`TB2_l92@[o0000
o`T92_l94P[o00000_l92@X00ol0003o2A8:o`000002o`T92P07o`TB2_l0
003o2A8:o`000?l94P[o2@T:o`TB2P02o`T92P0?oa4L2_l94P[o4A`:o`T9
2_lA70[o2@T:o`TB2_l92@[o0000o`T92_lA70[o0000oa4L2_l92@[o2A8:
00Go2@T:00Co2A8:o`000?l92@[o00000_l94PX01?l92@[o0000o`000?l9
2A@2o`TB2P09o`000?l92@[o0000o`TB2_l92@[o0000o`TB2_l0003o2A8:
00;o2@T:00Ko0000oa4L2_l0003o0000o`TB2_l00003o`T92P04o`000?lA
70[o2@T:o`0000;o2@T:00So2A8:o`000?l92@[o;180ob<L2_lA70[o8a`:
oa4L2P;oARH:00[o8a`:ob`B0?lm70[oARHDob`V5?lA70[o;1`Dob<_7_ld
;bWo=2lc0_l92@X02?lJ2@[o4BHDoaXB5?lS;bWoAT4Nob<_7_lm;cgo;2HD
0_lS;c<03_l/>2Wo;2HDob<L2_lJ4QCo0000o`T92_l0003o2@T:o`000?l9
4P[o0000o`T92_l0003o2A8:0_l000000ol92@[o2A8:o`000006o`T92P04
o`TB2_l0003o2A8:o`TB2P_o2@T:00Go4A`:o`T92_l92@[o2@T:o`000005
o`T92P06o`TB2_l92@[o2A8:o`T92_l94P[o00000ol92@X00ol94P[o0000
o`T92P02o`T92P0@o`TB2_l92@[o2A8:o`T92_l94P[o2@T:o`TB2_l92ACo
2A8:o`T92_l94P[o2@T:o`TB2_l92@[o4A`:o`0000;o2@T:00Oo2A8:o`T9
2_l92@[o2A8:o`T92_l94P[o2@TD00Ko2@T:00?o4A`:o`T92_l92@X00_l9
2@X00olA70[o2@T:o`T92P02o`T92P03o`000?nVXISoi^KV05koi^KV00Co
WIfMokNg]oo8b<Sodm?C0OoJf]X000;ok^k^00Cok>c/omoOgomaLG7odM7A
0_oLg=`00oo@d=3oooooooknoP02ooooo`0Doo_knoojn_[ol_;bon;Rh_oF
e]KoalO7ok>c/onOWiooS8b<og]kNomcLg?oLW9bog5aLOmbLW;oLg=cog9b
L_m`L73oKfm_og1`L?maLG4hog1`L0SoLG5a01?oKVi^og1`L?maLG7oLG5a
ofm_Kom`L73oLW9bogEeMOmlO7coL71`ofi^K_mmOGgoT92@oijNW_n`/;3o
`<30olo?cooShn?on?Sh00;ooooo00Coo_knoogmoOolo?cooooo2ooVi^H=
onOWi`Ooj>SX0ooYjNT3on[ZjP;ok>c/0oo^k^h2ono_k`kol?3`00?olO7a
oo;bl_oclo<03ooclo<2ooCdm0?omOGe0oofm_H:ooOgm`?on?Sh0_oinOT3
oo[jnP;ono_k0oolo?`=oogmo@?oo_kn:?ooool01?l;DjkoY/KVokWCk_mi
[^/2oj_Oo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Oo6Q8Do`T92_l94P[o
2@T:o`TB2_l92@[o2A8:00Co2@T:00Ko2A8:o`T92_l92@[o2@T:oaX92_l9
2@X2o`TB2P08o`000?l94P[o2@T:o`TB2_l0003o2@T:o`TB2_l00003o`T9
2P;o2A8:0_l00004o`T92P04o`000?l92@[o2@T:o`TB2P;o2@T:00Co2A8:
o`000?l92@[o2A8:0_l92@X01?lA70[o2A8:o`T92_l94PX2o`T92P09o`00
0?l92@[o2@T:o`000?l92@[o0000o`T92_lJ2@[o2@T:00;o4A`:00So2@T:
o`TB2_l94P[o2@T:o`000?l92@[o0000o`TB2P;o000000?o2A8:o`T92_l9
4PX00_l000000ol94P[o0000oa4L2P03o`000004o`T92_l0003o2@T:o`00
00?o2@T:00?o0000o`T92_l000000ol92@X01?l0003o2A8:o`T92_l00002
o`T92P?o000000Co2@T:o`TB2_l/4P3o8a`:0_l/4P000olm70[o8bH:ocdL
2P02ocdL2P09oa4V2_m69QCo?A`:ocdL2_lJ4QCo?A`:odI<?OlA9QCo2@T:
00;o4A`:00Co;1`DoaXL7_ld;bWo=2lc0_l/9Q@01?l/71Co;2HDob`V5?lS
;ah2oaXV5009oa4L2_l92@[o2A8:o`T92_l0003o4A`:o`000?l94P[o2@T:
00;o000000Ko2A8:o`000?lA70[o0000o`TB2_l00004o`T92P05o`TB2_l9
2@[o;180o`T92_l94PX01?l92@X00ol0003o2@T:o`T92P06o`T92P03oa4L
2_l92@[o2@T:00ko2@T:00?o2A8:o`T92_l92@X00_l92@X2o`TB2P04o`00
0?l92@[o4A`:o`0000oo2@T:00Oo2A8:o`000?l92@[o6Q8Do`TB2_l92@[o
000000Oo2@T:00So2A8:o`T92_lA70[o2@T:oa4L2_l92@[o0000ohfHSUoo
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo00WooOgmong]kOma
LG7oemOGomkNg_oOgmooe=CDoooooookno/00_ooool03oono_kon_[jonc/
k?oGemOo^[ZjojFUYOn?ShooQhN7ohf=SOnKVi_oZJVYokBd]?oDe=CoemOG
omcLg002omoOg`03omgMgOoLg=cog=cL03Sog=cL2?oNg]h01OoJf][og=cL
omkNg_oNg]kogMgM00;ofm_K00cog=cLolg=cOnh^;SoY:BToiRHV?n8R8So
PH61oiFEUOnd];Co_;blom?Cdoo_knl4ooooo`03oogmoOooooooinOW00[o
inOW0_oXj>P3onWYj@03on[Zj_oYjNWoj^[Z00;oj^[Z0oo[jn/=onc/k003
ong]kOo^k^kokno_00cokno_0oo`l?03oo7al@03oo?cloobl_;om?Cd00;o
m?Cd0_oemOD8ooKfmPOomoOg1_ohn?P;ooWin@;on_[j0_olo?`00ookno_o
oOgmoogmo@0AooknoR[ooooo00Co3eJ_oj?2i?nhdnooMjk[0_nZgol01?mf
MWKo`L71oo3`l?omoOeKooooo`03oa4V5?lA70[o6Q8D00;o2A8:00Ko4A`:
o`T92_l94P[o2A8:o`T92_l94PX2o`T92P08o`TB2_l92@[o2A8:o`TB2_l0
003o2@TDoaX92_l00002o`TB2P04o`T92_l94P[o2@T:o`T92P;o2A8:00Go
2@T:o`000?l92ACo2A8:o`000002o`T92P0@o`TB2_l92@[o2A8:o`000?l9
2@[o0000o`TB2_l0003o2@T:o`TB2_lA70[o0000oaX92_l94P[o0000oaX9
2P;o2@T:00Ko2A8:o`T92_lA70[o4A`:o`000?l94PX2o`T92P0:oa4L2_l9
2@[o4A`:o`000?lJ2@[o4A`:o`TB2_l92@[o0000o`TB2P;o2@T:00So0000
o`TB2_l92@[o0000o`TB2_l0003o2@TDo`TB2P;o000000Ko2A8:o`000?l9
2@[o2@T:o`000?lA70X2o`T92P04o`000?l94P[o0000oa4L2P?o2@T:00So
0000o`TB2_l94P[o2@T:o`000?l94P[o2@T:o`0000;o2A8:0ol92@X01_lS
70[o4A`:oaX92_lS9P[o?A`:ob<L2P;oARH:00Wo?A`:ob<L2_m69QCo;2HD
odHV5?l/9QCo=2lcoeMED_l92@X00_lA70X01olJ2@[o6RHDob`h:Om6C3go
=2lcoaXB5?lS9PX00_ld;bT01OlJ71ko;2HDob`L5?lA70[o2A8:00;o2@T:
00Go0000o`T92_l92@[o2@T:o`000003o`TB2P;o2@T:00So0000o`TB2_l9
2@[o0000oa4L2_l92@[o4A`:o`T92P;o2A8:00?o2@T:oa4L2_l92@X00_l9
2@X00ol94P[o2@T:o`T92P05o`T92P03oa4L2_l92@[o4A`:00;o2@T:00Co
4A`:o`T92_l92@[o4A`:0_l92@X01?lA70[o2@T:o`TB2_l94PX5o`T92P05
o`TB2_l92@[o2@T:oa4L2_l94PX00_l92@X00ol94P[o2@T:o`T92P0;o`T9
2P06oa4L2_l92@[o2@T:o`T92_l94P[o2@T:0_l94PX00ol92@[o6Q8Do`TB
2P03o`T92P03oa4L2_l92@[o4A`:00?o2A8:0_l92@X01OlA70[o2@T:oa4L
2_l0003oUIRS05oooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000;ok^k^
00Cok>c/omcLg?mgMgOofMWI0_oPh>000ooDe=Coo_knoo_kn`03ooooo`0>
ooKfm_oRh^;oalO7ok6a/OnJVY[oR8R8oi6ATOn^[Zkobl_;om_KfooQhN7o
gMgMon;Rh_oWinL2on_[j`03on[Zj_oYjNWojNWY03Soj^[Z2?o[jn/01_oY
jNWoj^[Zon_[jooZj^[ojNWYonSXj0;oinOW00gohN7QomoOgooMgMgodM7A
ok>c/onCTi?oRXZ:oi>CTon/[:co`l?3on3Ph?odm?CooOgm00Cooooo2ooW
inL=onSXj0OojNWY0ooZj^X3on_[j`03ong]kOo/k>cok^k^00;ok^k^0_o_
knl;oo3`l0?olO7a0_oclo<3ooGem@[om_Kf2_ogmoL00ooIfMWoNWYjoo3`
l00;ooShn0;onOWi0_okno/00oolo?coo_knooknoP0kooooo`04oa1F[onU
a>Ko^M?_ogN^j`;oZMco00CoKVi^okBd]?oPh>3ok>c/Foo^k^h00ol94P[o
2@TDoaXB5005o`TB2P03o`T92_l94P[o2@T:00?o2@T:00Ko2A8:o`T92_l9
4P[o4A`:o`000?l94PX5o`T92P09o`000?l94P[o2@T:o`000?l94P[o2@T:
o`TB2_l92@[o000000?o2@T:00Oo2A8:o`T92_l92@[o2A8:o`T92_l0003o
2@T:00;o2A8:00Go0000o`TB2_l92@[o2@T:oa4L2P02o`T92P04oa4L2_l9
2@[o2A8:oa4L2PCo2@T:00Co2A8:o`T92_lA70[o4A`:0_l92@X00ol94P[o
2@T:o`T92P03o`T92P04o`000?l92@[o2@T:o`0000?o2@T:00Co0000o`TB
2_l94P[o2@T:0_l94PX00ol92@[o0000o`TB2P02o`TB2PCo2@T:00Co0000
o`TB2_l92@[o2A8:0_l92@X00ol0003o2A8:o`T92P02o`T92P03o`000?l9
2@[o000000;o2@T:00Co4A`:ob<L2_l/4P3o;1800olS70X01?lS9P[o8a`:
ob<V2_lS9PX2ob`V500Gob<L2_lS;ako;3PYob=1D_lS70[o6Q8DoaX92_lJ
4QCo;3PYoc@_:OmGEE;o=2lNob<V2_l/71CoAT4Nob`V5?lJ71ko8a`:oaX9
2_lA70[o2A8:o`T92_l94PX00ol92@X01?lA70[o0000oa4L2_l00005o`T9
2P04oaX92_l92@[o2@T:o`TB2P;o2@T:00Ko4A`:o`T92_l94P[o6PT:oa4L
2_l94PX3o`T92P07o`TB2_l92@[o2@T:o`TB2_lA70[o0000oa4L2P02o`T9
2P03oa4L2_l92@[o2@T:00Ko2@T:00Go2A8:o`T92_l92@[o2@T:oa4L2P03
o`T92P03o`TB2_l92@[o2@T:00;o2@T:00?o2A8:o`T92_l92@X01?l92@X0
0ol94P[o2@T:o`T92P03o`T92P03o`TB2_l92@[o2@T:00Co2@T:00?o2A8:
o`T92_l92@X00_l92@X01ol94P[o2@T:o`T92_l94P[o2@T:o`TB2_lA70X0
0_l92@X00ol94P[o2@T:o`TB2P02o`T92P04oa4L2_l92@[o0000ohfHSUoo
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV00Ooi>CTomCDe?mf
MWKof][Jon3Ph?oQhN7oe=CD00Cooooo017omoOgonOWioo;bl_o[:b/oiZJ
V_nFUYKoWIfMokBd]?o>c/kofm_KomgMgOoJf][oi^KVonWYjOo]kNgokno_
oo3`l002ono_k`03oo3`l?oalO7olO7a03kolO7a00Colo?coo;bl_o`l?3o
kno_0_o^k^h2ong]k@;ogmoO00gogMgMomOGeoo>c/ko^[ZjoijNW_n6QXKo
VYZJojj^[_o<c<coinOWooKfm_okno_oo_kn00;ooooo2ooWinL2onSXj0?o
jNWY0_oZj^X3on_[j`?ok>c/1oo]kNd6onk^kP03oo3`l?o_knoolO7a00Co
lO7a2oobl_84oo?cl`Com?Cd2_oemOD5ooKfmP;omoOg00Kom_KfooOgmoog
moOolo?coa`L7?nOWil;ooShn0;onOWi0_okno/00oolo?coo_knooknoP0k
ooooo`04o`aE/OnTa>Ko^M?_ogJ]jP;oZn3o00CoJVYZojj^[_oHf=Soi>CT
FooVi^H3o`T9500?o`TB2_lJ4QCo2A8:o`T95?l92@[o2A`No`TB2_l92@[o
2A8:o`T92_l94P[o0000o`TL7_l94P[o000000;o2@T:0_l94PX01Ol92@[o
2A8:o`T95?l94P[o000000;o2@T:00?o6Q8Do`000?l92@X00_l92@X01Ol9
4P[o2@T:o`TB2_l94P[o2@T:00?o2A8:00Go2@T:o`TB2_l0003o0000o`T9
2P05o`TB2P08oa4L2_l92@[o2@T:o`TB2_l92@[o2A8:o`T92_lA70X2o`T9
2P06oa4L2_l92@[o2@T:oa4L2_l92@[o4A`:0ol92@X00olA70[o2@T:o`T9
2P03o`T92P0@o`TB2_l92@[o2A8:o`T92_l0003o2@T:o`000?l94P[o0000
o`TB2_l0003o2A8:o`000?l92@[o0000o`TB2P;o2@T:00Oo2A8:o`T92_l9
4P[o2@TDo`T92_l94P[o000000Go2@T:00_o2A8:o`T92_l92@[o2@T:ob`B
0?lJ2@[o8a`:oaX92_lJ4QCo;180ob`L5005ob<L2P0BoaXV5?l/71Co=2lY
oc@_:OldEBWo4A`:o`T92_l971Co;1`Doc@_:Old;c?oCfMLoaXL7_lJ4QCo
;1`Dob`V5?l/>2Wo8a`:0_lA70X2o`T92P07o`000?l92@[o2A8:o`000?l9
4P[o0000o`TB2P03o`T92P;o2A8:00?o2@T:o`TB2_l92@X00_l92@X02?lA
70[o2@T:oa4L2_l94P[o4A`:o`T92_lA70[o2@T:0ol94PX2o`T92P09o`00
0?l94P[o4A`:o`T92_l94P[o2@T:oa4L2_l92@[o4A`:00So2@T:00Oo4A`:
o`T92_lA70[o2@T:o`TB2_l92@[o2A8:00Co2@T:00Co2A8:o`T92_l92@[o
2A8:0_l92@X2o`TB2P03o`T92_l94P[o2A8:00;o2A8:00Go2@T:o`TB2_l9
2@[o2@T:o`TB2P02o`T92P03o`TB2_l92@[o2@T:00;o2@T:00?o2A8:o`T9
2_l94PX00_l92@X00olA70[o2A8:o`TB2P05o`T92P07o`TB2_l92@[o4A`:
o`T92_l94P[o0000oiF4SP1OonKViP04oifMWOng]kOob<S8om?Cd`7of][J
0002onk^kP04onc/k?oLg=coO7alom[JfP;oh>3P00?odm?Cooooooooool0
0_ooool02ooalO7ogMgMol30`?nQXJ7oQHF5oiFEUOn^[ZkoaLG5om7AdOoG
emOog]kN00;oi^KV00?ojNWYon_[joo/k>`00oo/k>`00oo^k^kokno_ono_
k`0fono_k`SokNg]00Col_;bono_koo]kNgojn_[0_o/k>`04?o[jn_oj^[Z
oo3`l?o]kNgoh>3Polo?coo7alOo`L71ok6a/OnNWYkoT92@oj6QXOno_koo
h>3PooGemOolo?`2oogmo@03oooooooVi^Koi^KV00Woi^KV0_oWinL3onSX
j0;ojNWY00?oj^[ZomSHf?oKfm/00oo[jn/7onc/k0KokNg]0_o_knl5oo7a
l@_ol_;b1?oclo<01?oXj>SogMgMoo?clooclo<5ooCdm003oo;bl_oBd];o
g=cL00;om?Cd1OoemOD3ooOgm`?onOWi00?oQhN7oc`l??ojn_X02Oojn_X0
0ooWinOojn_[oo_kn`03ooclo0;ooOgm4Oono_h3ooooo`03onc/k?o_knoo
oooo00oooooo00?om?CdonSXj?ooool04_ooool01?l<E:koYLCVokG@k_mi
[^`2ojOLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00[o6Q8Do`TB2_l92ACo
2@T:o`TB2_l92@[o2A8:o`TL5?l/9QCo2@TD0ol92@X00ol94P[o2@T:o`T9
2P04o`T92P0:o`TB2_l92@[o2@T:o`T92_l0003o2@T:o`TB2_l0003o2@T:
o`0000?o2@T:00?o2A8:o`000?l94PX00_l000001_l92@[o0000o`T92_l0
003o2A8:o`0000;o2@T:00?o0000o`T92_l000000_l92@X02OlJ2@[o0000
o`T92_lA70[o2A8:o`T92_l94P[o2@T:o`000002o`T92P08oa4L2_l94P[o
4A`:o`T92_lA70[o0000oa4L2_l94PX2o`000008o`T92_l0003o2A8:o`00
0?l92@[o0000o`TB2_l00002o`T92P03o`TB2_l92@[o2@T:00Wo2@T:00?o
0000o`T92_l92@X00ol000001Ol94P[o2@T:o`000?l92@[o000000;o2@T:
01?o0000oa4L2_l92@[o2@T:ob<L2_l92@[o8a`:oa4L2_l/4P3o8a`:ob`B
0?lS70[o8bH:oaX92_l/71Co;2HDob`L5?l/9QCo=2lN00;oAT4N01?o=2lY
ob<_7_lS;bWo8blNocd_?Om?GVKoAT`mob`B0?l/71Co6PT:ob`L5?lS70[o
6Q8Do`TB2_l92@[o0000o`T92_lA70[o000000Go2@T:00?o2A8:o`T92_l9
4PX00_l000001_l94P[o6Q8Do`TB2_l94P[o2@T:o`TB2P;o2@T:00Oo0000
o`T92_lA70[o2@T:oa4L2_l92@[o000000Go2@T:0ol94PX00olA70[o2@T:
oa4L2P02o`T92P03oa4L2_l92@[o4A`:00;o2@T:00?o4A`:o`T92_l92@X0
0ol92@X00ol94P[o0000o`T92P04o`T92P06o`000?l92@[o2@T:o`T92_lA
70[o00000_l94PX01Ol0003o2A8:o`T92_l0003o2A8:00?o2@T:00Co2A8:
o`T92_lA70[o2A8:1?l92@X01Ol94P[o0000o`T92_l94P[o000000Oo2@T:
00Wo2A8:o`T92_l92@[o2A8:o`T92_lA70[o2A8:o`000?n3Q7/0Goo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool01?omoOgok>c/ogalO?oJ
f]X2on3Ph00Eom?Cdoooooooo_knooooooono_kok>c/omKFe_nj^[[oW9bL
oiRHV?nTY:Co]KFeol?3`oo8b<SocLg=om[Jf_oXj>SoiNGUonOWiooZj^[o
k>c/00Cojn_[>?o]kNd8onc/k004onk^k_o/k>cojn_[on_[j`;ok>c/013o
jNWYonKVi_oDe=Cof][JomkNg_oHf=Soc<c<okjn__n^[ZkoXj>Soi:BT_nL
W9co];BdomGEeOo`l?3oo?cl0oooool5onKViP03oc0`<?mXJ6Soi^KV00?o
i^KV00?oinOWocTi>OmcLg<00_oXj>P02ooYjNWob<S8oc0`<?l<30co2`/;
oc@d=?o;bl_ok>c/ong]kOlk>c_oMWIf00;okNg]00KoLG5aochn?_o^k^ko
k^k^ojRXZ?l820P2onk^kP;okno_1?o`l?000om[Jf_o=3@doo7al@03oo7a
l@06oc`l??mhN7SolO7aoo7alOnJVY[o6QXJ0_obl_801_oKfm_oATI6o`82
0_lQ8B7o5QHFokRh^0ComOGe00KoZJVYo`T92Ol<30co8R8Roc<c<onPX:02
ooKfmP07ocdm?OmjNW[om_KfooCdm?m:BT[o:b/[onWYj@02ooWin@03ohj>
S_l0003od];B00?on_[j00ko?ShnogalO?ojn_[on_[jomKFe_lc<c?o3@d=
o`/;2olh>3SofMWIooclo?omoOgo?clooginOP;ooooo00?oXj>Soa`L7?oo
ool01oooool00ombLW;o>3Phooooo`03ooooo`06om_Kfole=CGo3Ph>o``<
3?li>CWog=cL0_ooool00ooVi^Ko0000ohR8R002ooooo`03odU9BOlX:2So
oooo00;ooooo00WoinOWodY:B_l30`?o8b<SoaLG5oo1`L7ooooood10@?mo
Ogl03_ooool01?l<EK7oY<CVokSBk_mf[NX2ojcOo`04ogIfM_o1`L7ol?3`
oogmoE_ooooo0_l94PX01ol92@[o4A`:o`T92_lA70[o2@T:o`TB2_l92@X0
0_lA70X2o`T92P03o`TB2_l92@[o2@T:00Go2A8:00[o2@T:oa4L2_l92@[o
2@T:oa4L2_l92@[o0000o`TB2_l92@[o4A`:1ol92@X00olA70[o0000oa4L
2P02o`T92P06o`TB2_l92@[o0000oa4L2_l92@[o4A`:0ol92@X02OlA70[o
2A8:o`000?l94P[o2@T:oa4L2_l0003o2@T:o`TB2P02o`T92P05oa4L2_lJ
2@[o4A`:o`T92_lA70X01?l92@X00ol0003o4A`:o`T92P07o`T92P;o0000
0_l92@X00ol0003o2@T:o`TB2P03o`T92P03o`000?l94P[o2@T:00Go2@T:
00?o0000o`TB2_l000000ol94PX03_lA70[o6Q8Do`000?l94P[o4A`:oa4V
2_l/4P3o6PT:ob`B0?lJ4QCo6PT:oa4L2_lS70[o6PT:0olS70X3ob`V5009
oc@_7_ld;c?o=2lYob`h:OlS;c?o=2lcodIED_mGGVoo;3PY00;o4A`:00?o
;1`Doa4L2_l92@X00_l92@X00olA70[o2@T:o`T92P02o`T92P03o`TB2_l9
2@[o2A8:00;o2A8:00Ko2@T:o`000?l92@[o2@T:o`000?l94PX4o`T92P08
o`000?l94P[o2@T:oa4L2_l92@[o2A8:oa4L2_l92@X2o`TB2P07oa4L2_l0
003o4A`:o`000?lA70[o2@T:o`TB2P02o`T92P03ob`L5?lJ4QCo4A`:01Oo
2@T:00?o2A8:o`T92_lJ2@X00_l92@X2o`TB2P03o`T92_lJ2@[o2A8:00Co
2@T:00?o2A8:o`T92_l92@X00_l92@X02?l94P[o2@T:o`T92_l92@[o2A8:
o`T92_lA70[o2@T:0_lA70X3o`T92P09oa4L2_l92@[o2@T:o`T92_lA70[o
2@T:oa4L2_l0003oUHAk05oooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_80
00;ok^k^00Cok>c/omcLg?mlO7cof][J0_oPh>004?oDe=Cooooooooooooo
oooonOWion;Rh_o8b<SoZj^[ohj>S_nKVi_oWinOoj^[Zonm_Kgob/[:om;B
d_oGemL2omcLg004omoOgooTi>Coi^KVonKViP;oi>CT00?ohn?SonGUiOoU
iND0?_oUiND05ooTi>Cohn?SonCTi?oVi^KoinOWonKVi_oQhN7ogMgMonGU
iOoGemOocLg=olk>c_o;bl_o_;blojVYZOnOWiooUYJFoiRHV?nXZ:SoalO7
onCTi?ofm_Koo_kn00;ooooo1OoVi^H00ol`<33oJ6QXonKViP03onKViP03
onOWioli>CWoLg=c00;oj>SX00?ojNWYobl_;om;Bd/00_oLg=`01_m?Cdoo
<C4aonc/k?o^k^ko>c/kogIfMP;ok^k^00KoLG5aochn?_o_knookno_ojRX
Z?l820P8ono_k`03ofYZJ_ld=3Col?3`00?ol?3`00Ko?3`logMgMoo`l?3o
l?3`oiVIVOlJ6QX2oo7al@06od10@?ll?3coe=CDooCdm?oXj>SoinOW1?oe
mOD03_o=cLgo]kNgoo3`l?oemOGoUYJFo`<30ooFe]Kom_Kfocdm?OmjNW[o
mOGeoeaLG?lO7aoog]kN0oohn?P00ol];Bgo20P8ofi^KP03ooWin@0>ochn
?_mlO7conOWiooShn?lb<S;oD51@onSXj?oYjNWoDe=Coc@d=?okno_oo?cl
oclo?omnOWh2ooooo`03oj>SXolL71cooooo00Oooooo00?oLW9bocPh>?oo
ool00_ooool00oono_ko=3@doe9BDP02onk^kP0<oeEEEOle=CGoo_knoooo
oonNWYko3`l?ocTi>Ooooooon?Sho`X:2_l?3`ooe=CD0_ooool02Om4A4Co
@410omoOgooooooolo?coo;bl_oooooo@410ogmoO`0>ooooo`04o`iE[_nV
a^Ko]]3^ogV_kP;oZmko00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01_lA70[o
2@T:oa4L2_l92@[o2@TDo`TB2P;o2@T:00Ko2A8:oa4L2_l92@[o2@T:o`TB
2_l92A@2o`TB2P03o`T92_l0003o2@T:00;o2@T:00?o4A`:o`000?l92@X0
0_l92@X01_lA70[o6Q`No`000?l94P[o2@T:o`TB2PGo2@T:00_o2A8:o`00
0?l92@[o0000o`TB2_l92@[o0000o`T92_lA70[o0000o`TB2P02o`T92P06
oa4L2_l92@[o4A`:oaX92_l94P[o4A`:0_l92@X00olA70[o0000o`T92P02
oa4L2P03o`T92_lA70[o4A`:00Co2@T:00Wo0000o`T92_l92@[o2@T:o`00
0?l94P[o0000oa4L2_l000000ol92@X01Ol0003o4A`:o`T92_l92@[o0000
00;o2A8:00?o2@T:o`000?l92@X01_l92@X00ol0003o2@T:o`T92P03o`T9
2P;o000000?o2@T:o`000?l92A@00_l92@X01OlJ2@[o8a`:ob<L2_lA70[o
;18000Co8a`:00?o;180oa4L2_l/71@00_l/71@01?ld;ako=2lcodI17_m6
C3d2ocd_?@08odI<?Ol/EEcoCfMLoaX92_lA70[o6PT:ob`B0?lA70X9o`T9
2P04o`TB2_l92@[o0000o`T950;o2@T:00?o2A8:o`T92_l92@X01Ol92@X0
0ol94P[o2@T:o`T92P02o`T92P03oa4L2_lJ2@[o4A`:00;o2@T:00Wo2A8:
o`T92_l92@[o2@T:o`TB2_l92@[o6PT:oa4L2_l92@X00_lJ4Q@00ol92@[o
4A`:oa4L2P0Do`T92P03o`TB2_l92@[o2A8:00;o2@T:00?o4A`:o`T92_l9
2@X01_l92@X00ol94P[o2@T:o`T92P04o`T92P05o`TB2_l92@[o2@T:o`T9
2_l94PX00_l92@X00ol94P[o2@T:o`T92P05o`T92P06oa4L2_l0003o6Q8D
o`TB2_l0003oPhf4Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oV
i^H06?oTi>Coe=CDog]kNooJf][oh>3Pon7QhOoEeMGoo_knooooooolo?co
n_[jomgMgOo7alOoXZ:Roh:2P_nATI7oWinOojf][Ong]kOo_[jnolS8b?o@
d=3odm?ComSHf0;oemOG00GofMWIomgMgOoNg]kogMgMom[JfP0homkNgPSo
gMgM0ooPh>005_oOgmoog]kNomgMgOoKfm_of][JomGEeOoCdm?ocLg=olG5
aOnn_[ko]kNgoj^[ZonQXJ7oU9BDoh:2P_nUYJGo`L71omkNg_ohn?Sooooo
oogmoOooool5onKViP03oc0`<?mXJ6Soi^KV00?oi^KV00?oinOWocTi>Omc
Lg<00_oXj>P00oo5aLGo0000ojNWY`02on[ZjP06ojRXZ?l0003ob/[:onc/
k?lk>c_oMGEe0_o/k>`01_m`L73o?Shnong]kOo]kNgoYjNWo`P820;okNg]
0_o_knl4oo7al@03of][Jole=CGol_;b00?ol_;b00[o?3`logQhN?obl_;o
l_;boiZJV_lJ6Q[olo?com;Bd_l0003o[jn_1?oclo<8ooCdm00:omOGeol0
003o[Zj^ooGemOlm?CgoNWYjofi^K_lE5AGoe=CDooWin@;ono_k00Gob<S8
o`000?nMWIgo4Q8BooKfmP02oogmo@06oclo?omnOWkooOgmomKFe_l0003o
]KFe0_omoOd01_ne]KGo0000om_Kfoono_ko@410ogmoO`;ooooo00?oXj>S
oa`L7?ooool01oooool00ombLW;o>3Phooooo`02ooooo`03omSHf?l0003o
]kNg00;ooooo013o]kNgo`000?oLg=cooooooeEEEOmcLg?o71`LonSXj?nm
_Kgo8B4Qofi^K_n1PH7oooooomgMgOl0003o^;Rh1Oooool00om0@43oOgmo
ooooo`0=ooooo`04o`]B[_nT`nGo^=;_ogV^k0;o[=oo00CoJVYZojj^[_oH
f=Soi>CTFooVi^H01_lA9QCo2@TDo`TB2_l94P[o6RHDoaXB50?o2A8:00Ko
2@TDo`T92_lA9QCo2@T:o`T95?l94PX2o`T92P?o2A8:0_l92@X00olA9Qko
2A8:o`TB2P02o`T92P08o`TB2_l92@[o2@T:o`TB2_l92@[o2A8:o`T92_l9
4PX3o`T92P04o`TB2_l92@[o2@T:o`T92P;o2A8:00?o4A`:o`000?l92@X0
0_l92@X02?lA70[o2@T:oa4L2_lJ2@[o4BHDoaX92_l92@[o4A`:0_l94PX0
1_l92@[o4A`:o`T92_l92@[o4A`:oaX92P;o4A`:00?o2A8:oa4L2_l92@X0
0ol92@X01ol94P[o2@T:o`T92_l92@[o0000o`TB2_l000001Ol92@X2o`TB
2P05o`000?l92@[o2@T:o`T92_lA70X01ol92@X01_l94P[o0000o`TB2_l9
4P[o0000o`T92P;o2A8:00?o0000o`TB2_l92@X00olA70X00olA9P[o6PT:
oa4L2P02oaX92P?o8a`:0_l/71@01Ol/9QCo?A`:oc@_:Om6@Ako=2lc00;o
AUEB00Oo?BlmodINAomGGVooAT`mo`000?l/4P3o6PT:00[o2@T:00co2A8:
o`000?l92@[o2@T:oa4L2_l0003o2A8:o`000?l92@[o2@TDo`T92_l94PX2
o`T92P03o`TB2_l0003o2@T:00;o2@T:00Oo4A`:o`T92_l92@[o4A`:o`T9
2_l94P[o000000;o2A8:00Ko2@T:oa4L2_l92@[o2@T:o`TB2_lJ4Q@2o`T9
2P;o4A`:0ol92@X01?l94P[o2@T:oa4L2_l92@X2o`TB2PGo2@T:00?o2A8:
o`T92_l94PX00ol92@X01?lA70[o2@T:o`T92_l92@X3o`TB2P03o`T92_l9
4P[o2@T:00;o2@T:00Ko2A8:o`T92_lA70[o2A8:o`T95?l94PX7o`T92P05
o`T95?l0003o2A8:o`TB2_lA70X01?l92@X2o`TB2P;o2@T:00Go2A8:o`T9
5?l94P[o2@TDoh=kG01OonKViP04oifMWOng]kOob<S8om?Cd`7of][J0002
onk^kP04onc/k?oLg=coNg]kom[JfP;oh>3P01;oe=CDookno_ooooooo?cl
oo[jn_oKfm_ob<S8oi6ATOn4Q8CoTI6AoifMWOn[Zj_o/[:bokRh^?o0`<3o
a/K6olW9bOo@d=02olo?c`04om;Bd_oFe]Kof=SHomSHf3Woe]KF2?oGemL5
omKFeP0DomGEeOoDe=Codm?Colk>c_o<c<coalO7okno_oni^KWo/[:bojNW
YonMWIgoTI6Aoh>3PonEUIGoa<C4omgMgOohn?Sooooooo_knoooool5onOW
i`03oc0`<?mYJFWoinOW00?oinOW00?oj>SXocXj>_mdM7@00_oYjNT00on^
[Zko0000om?Cd`02on[ZjP06om;Bd_l0003o/K6aonc/k?lk>c_oMGEe0_o/
k>`01_m`L73o?Shnong]kOo]kNgoYjNWo`P820;okNg]0_o_knl4oo7al@03
of][Jole=CGol_;b00?ol_;b00[o?3`logQhN?obl_;ol_;boiZJV_lJ6Q[o
lo?cokFe]Ol0003o>SXj0oll?3`00onk^k_omOGeooGem@05ooGem@09onKV
i_m;Bd_o1`L7onWYjOofm_Ko?CdmocHf=_l0003o_Kfm00;on?Sh0_ojn_X0
1OmVIVKo?clooo[jn_lW9bOoXJ6Q00;ono_k00ko?ShnogemOOokno_o^k^k
o`000?oRh^;ono_kooclo?oQhN7o0000okno_oomoOgo?clooginOP;ooooo
00?oXj>Soa`L7?ooool01oooool00ombLW;o>3Phooooo`02ooooo`03okjn
__l0003oi^KV00;ooooo013oi>CTo`000?o1`L7ono_ko`l?3onm_KgoJ6QX
oiZJV_mgMgOoIVIVol30`?l];Bgooooookjn__l0003o?Cdm0olo?cl01?o4
a<Cooooood10@?moOgl>ooooo`04o`iE[_nUa>Ko]];^ogV^j@;oZ^3o00Co
KVi^okBd]?oPh>3ok>c/Foo^k^h01?l92@[o6Q8Do`T95?l94PX3o`T92P;o
2A8:00Co2@TDo`T92_l94P[o00001ol94PX01Ol92@[o2A8:o`T92_l92@[o
000000Co2@T:00Co0000o`T92_l92@[o2@T:0_l94PX01?l92@[o0000o`TB
2_l00002o`T92P03o`TB2_l0003o2@T:00;o2@T:00Co0000o`TB2_l92@[o
2@T:0olA70X3o`T92P03o`TB2_l92@[o2A8:00;o00000_lA70X02_lJ2@[o
4A`:ob<L2_lJ2@[o2@T:oa4L2_l94P[o2@T:o`TB2_l00003o`T92P;o2A8:
0_l92@X02ol0003o2A8:o`T92_l92@[o2A8:o`000?l92@[o0000o`T92_l9
4P[o000000;o2@T:0_l94PX01_l92@[o0000o`T92_l94P[o0000o`T92P;o
000000?o2A8:o`000?l000001Ol92@X01Ol/4P3o6PT:ob`B0?l94P[o6Q8D
00;o;1800olS70X03?l/71Co8a`:ob`L5?ld;ako=2lYoc@_<om6C3goEeEB
odI<?Om6EE;oEei_odmWA`;o4A`:00Co6PT:oa4L2_lA70[o2A8:1?l92@X0
0ol94P[o0000o`TB2P02o`TB2PKo2@T:00Co2@TDo`000?lA70[o00001_l9
2@X00olA70[o2@T:o`T92P04oa4L2P05o`T92_lA70[o2@T:o`TB2_l00000
0ol92@X01?l94P[o2@T:o`T92_lA70X2o`T92P03oa4L2_l92@[o2@T:00?o
2@T:00?o2A8:o`000?l92@X01Ol92@X00olA70[o0000o`T92P05o`T92P03
o`TB2_l0003o2@T:00;o2@T:00ko2A8:o`000?l92@[o2@T:oa4L2_l92@[o
2A8:o`T95?lJ2@[o0000o`T95?l0003o2@T:oa4L2PSo2@T:00?o4A`:o`T9
2_l92@X01ol92@X01?lJ4QCo2A8:oaX92_mbEE9Oonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q0002ooooo`04oogmoOo/k>coO7alom[JfP;oh>3P017o
e=CDoogmoOoooooooOgmoo[jn_oIfMWob/[:ogMgMon5QHGoSHf=oiVIVOnU
YJGo[:b/ok2`/?ng]kOo_Kfmokno_`03olG5a@03olO7aoo;bl_oc/k>00;o
clo?>?o=cLd8olk>cP?oc<c<01Kobl_;ol[:b_o8b<SoalO7olK6a_o4a<Co
`/;2okjn__ng]kOo/[:bojf][OnSXj?oVIVIohf=SOn3Ph?oOGemolO7aooL
g=con?ShoooooooinOWooooo1OoWinL02Ol`<33o6a/Kocdm?Olm?CgoFEUI
onOWiooXj>So>SXjoemOG`02onSXj003olW9bOl0003oYJFU00;oj^[Z00Ko
Xj>So`000?o=cLgojn_[ocXj>_mTI6@2on_[j`06ofm_Kol_;boojn_[onc/
k?nUYJGo20P80_o]kNd00oo_knook^k^oo3`l002oo3`l003oo7alOm[Jf_o
=CDe00Col_;b00ko?3`loeQHF?obl_;ol_;boiBDU?lK6a_olo?com3@d?l0
003oXj>SolK6a_no_koo0P82omcLg0Kom_Kf00Co[jn_oa/K6olF5QKo]kNg
0_ogmoL01Olm?CgoNWYjoe=CDom=CDgomOGe00;on?Sh00Kokno_o`h>3_nM
WIgon?Shohb<S?ll?3`2ooWin@0>ochn?_mlO7conOWiomKFe_l0003o[jn_
ooWinOojn_[o[Zj^o`000?oMgMgoo?cloclo?omLG5`2ooooo`03oifMWOlM
7Agooooo00Oooooo00?oLW9bocPh>?ooool00_ooool00ooLg=co0000okBd
]002ooooo`0Gok:b/_l0003oh>3Pol?3`ol<30conOWiokJf]_m;Bd_o<C4a
ojZZZ_omoOgo5QHFom[Jf_oKfm_o0000oj^[Zoo?clooalO7o`<30ooUiNGo
oooood10@?mYJFT03_ooool01?l<E:koY/KVokWCk_mi[^/2oj_Oo`04ogIf
M_o1`L7ol?3`oogmoE_ooooo00Ko4A`:o`T92_lA9QCo2@TDoa4L2_l94PX4
o`T92P06oa4L2_l92ACo2@T:o`TB2_l92@[o2A8:0_l92@X01ol0003o2A8:
o`T92_l92@[o0000o`T92_l94PX00ol92@X00ol0003o2@TDo`T92P03o`T9
2P05o`000?l94P[o2@T:o`T92_l000000_l92@X02ol0003o2A8:o`000?l0
003o2A8:o`000?l92@[o0000o`TB2_l92@[o4A`:00;o2A8:0_lA70X01Ol9
4P[o2@T:o`T92_l0003o4A`:00Co2@T:00Ko0000oa4L2_lJ2@[o2A8:o`T9
2_l00004o`T92P?o000000Co2A8:o`T92_l92@[o2@T:0_l000001?l92@[o
0000o`TB2_l92@X2o`000005o`T92_l94P[o6Q8DoaXB5?l000000ol92@X0
0ol0003o2@T:o`000006o`T92P0Ao`000?l92@[o2@T:o`TB2_lJ2@[o;180
oaX92_lA70[o;180oaXB5?lJ2@[o8a`:ob`B0?lS70[o8bH:ob`B0?lJ4Q@0
0_ld;bT01old;c?oEeEBodmWG?m?GVKoEeEBoeMWD_lA9Qh01Ol92@X01ol0
003o2A8:o`000?l92@[o2A8:o`000?l94PX00_l000002_l94P[o0000o`T9
2_l92@[o0000o`T92_l94P[o0000oa4L2_l00002o`T92P03o`000?lA70[o
2@T:00;o2A8:0_l92@X01OlJ2@[o2A8:oa4L2_lJ2@[o2@TD00So2@T:00Go
0000o`T92_l94P[o2@T:oa4L2P02o`T92P04oa4L2_l92@[o2@T:o`TB2P;o
2@T:00?o2A8:o`T92_l92@X00ol92@X00ol0003o2@T:o`T92P06o`T92P03
o`TB2_l92@[o2@T:00Co2@T:00co2A8:o`T92_l92@[o2@T:o`T95?l0003o
2@TDocdB2_mG703oARHDo`T92_l94PX3o`T92P04oa4L2_l92@[o0000o`T9
50?o2@T:00Go2A8:o`T92_l92@[o4A`:o`000002oa4L2P05o`T92_l94P[o
0000oaXB5?mGIe80Goooool01?n_[joobl_;omkNg_oZj^X1oo;blP000_o^
k^h05oo/k>cog=cLog]kNooIfMWogmoOon7QhOoDe=Coo?clooooooono_ko
no_kom[Jf_o=cLgoH61Poh:2P_n6QXKoTY:BoinOWonVYZKoZj^[ok:b/_nh
^;So^k^k00?o_Kfm00Go_knool;2`_o4a<Coa/K6olO7a`0holK6aP[oaLG5
00Goa<C4ol?3`oo0`<3o_[jnokbl_003ok^k^`0?okNg]ona/K7o[Jf]ojRX
Z?nOWiooUYJFohR8R?n1PH7oIVIVol[:b_oLg=con?Shooooooojn_[ooooo
00?oj>SX0_oYjNT01Ola<C7oCdm?ojn_[on_[joo^;Rh00;ojNWY00_o>SXj
oa4A4On5QHGodM7AonWYjOlk>c_o@T92olc<c?o;bl_o@D51ochn?P02onc/
k00:oc/k>olC4a?oPH61omKFe_lj>S[o71`LoeUIFOoBd];oJFUYobl_;`;o
kNg]0_o^k^h4ono_k`03ofYZJ_ld=3Col?3`00?ol?3`00Ko?3`loa8B4_m_
Kfood=3@oe5ADOm8B4P2oo7al@06oc/k>omUIFGojn_[oiNGUolY:BWom?Cd
1OoemOD01OmkNg_o0000oe9BD_oLg=comOGe00;om_Kf017o?CdmogYjN_o_
knoo>SXjofa/K?ogmoOon?ShoijNW_l=3@gok^k^ooShn?oXj>So20P8om7A
dOoinOWo?ShnogalO002ooWin@06oclo?om6ATKof=SHomSHf?m5ADGo@d=3
0_olo?`01_lo?coo4a<CogIfM_oNg]koEeMGode=C@Sooooo00?oLW9bocPh
>?ooool00oooool05om1@D7oB4Q8omkNg_oMgMgoAdM7odA4A?ooooooNGUi
ode=COoooooon?Shoa8B4_l30`?okNg]oooooomVIVKoQXJ6oooooolo?coo
Jf][ooOgmonNWYko:b/[00;ooooo00Go@410oa<C4onATI7oi>CToogmo@0;
ooooo`04oa1G[onS`^Co^=?_ogN^j`;oZ]oo00CoKVi^okBd]?oPh>3ok>c/
Foo^k^h01_l92ACo4A`:o`T95?lA70[o2@TDo`T92P;o4A`:00So2A8:o`T9
2_l94P[o4A`:o`T92_l94P[o2@T:o`TB2PGo2@T:00Co2A8:o`T95?l92@[o
2A8:1_l92@X00ol94P[o2@T:o`T92P06o`T92P03oa4L2_l92@[o2@T:00;o
2A8:00go0000o`TB2_l0003o2A8:oa4L2_lJ4QCo2@TDoaX92_lA70[o2A8:
o`T92_lJ2@[o4A`:00Co2@T:1?lA70X01Ol/9QCo2@T:oa4L2_l92@[o4A`:
00;o2@T:00?o4A`:o`T92_l94PX02?l92@X00ol94P[o2@T:o`T92P03o`T9
2P06o`TB2_l0003o2A8:oaXB5?l92@[o2A8:0_l92@X01?l94P[o2@TDo`T9
2_l94PX8o`T92P07oa4L2_lJ2@[o8a`:oa4L2_lJ2@[o4A`:oaX92P04ob<L
2P0=ob`L5?l/9QCo=2lNocdL2_ld;c?oH44YodmWG?mGEE;oEei_ofYbG?m?
GVKo0000o`TB2P09o`T92P06o`000?l92@[o2@T:o`TB2_l92@[o2A8:1ol9
2@X01?l0003o2A8:o`T92_l94PX4o`T92P05oa4L2_l92@[o2@T:o`T95?lJ
2@X00_lA70X2o`T92P04o`TB2_l92@[o2@T:o`TB2P?o2@T:00Co4A`:o`T9
2_lA70[o2@T:0_lA70X00ol92@[o4A`:oa4L2P04o`T92P03oa4L2_l92@[o
2@T:00co2@T:00Co2A8:o`T92_l92@[o2A8:0_l92@X01_l94P[o4A`:o`T9
2_l92ACo0000oonc00;oomT000coooH0oooI0?l92@[o2@T:o`TB2_lA70[o
6PT:o`T92_lJ2@[o2A8:o`T92_l94PX2o`T92P06o`TB2_l92@[o2@T:o`T9
2_lA70[o2A8:0_l92@X01?l94P[o6Q8Do`000?nEQ8iOonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q0002onKViP08onCTi?oDe=CoNg]komWIfOoOgmoo
hN7QomCDe?omoOd2ooooo`0Eoo_knooQhN7odM7AoeEEEOmiNGWoPH61ohj>
S_nJVY[oXJ6QojJVY_n][Jgo/k>cokFe]Ong]kOo^;RhokVi^Onj^[[o^k^k
okbl_?nn_[ko_kno03So_Kfm2?nl_;`3okfm_@0Fokbl_?nk^k_o^KViokRh
^?ng]kOo]KFeokBd]?na/K7oZj^[ojRXZ?nTY:CoVYZJoi6ATOn2PX;oNGUi
oeUIFOo=cLgogmoOooShn?oooooooOgmooooo`?oinOW0_oXj>P00ola<C7o
JFUYonSXj004onSXj007oda<C?mmOGgoE5ADo`P82?oLg=coe=CDod];B`02
o`d=3@0>ode=COoGemOok>c/onc/k?m=CDgoP820ofQXJ?l>3Pko9BDUolG5
aOn?Shoo61PHoadM7OnPX:02ong]k@;ok^k^1?o_knl00omZJV[o=3@doo3`
l003oo3`l006oc`l??mfMWKoLG5aoa8B4_l[:b_o^;Rh0_oalO401_oIfMWo
@d=3o``<3?lJ6Q[o[jn_ooCdm0ComOGe00?og=cLo`410On=SHd00ooemOD2
ooKfmP09ocdm?OmjNW[om_KfonKVi_lc<c?oXj>SooWinOmGEeOoKVi^00;o
nOWi00Kon_[jofUYJOn2PX;on_[jochn?_mlO7`2oo[jnP0>on?Shom@D53o
3Ph>o`h>3_mBDU;oi^KVooclo?omoOgoDe=Coh^;RomiNGWo51@Dobh^;_o4
a<@8ooooo`03og9bL_lh>3Sooooo00?ooooo00Woj>SXoe9BD_l?3`oo3`l?
oeADE?oYjNWoooooodY:B_nNWYh00_ooool03?mQHF7oADE5oooooooooooo
_Kfmode=COooooooi^KVodM7Aol=3@go71`LokNg]`;ooooo00GoE5ADohV9
ROmMGEgo2@T9oo3`l00;ooooo`04oa1F[onUa>Ko^M?_ogN^j`;oZMco00Co
JVYZojj^[_oHf=Soi>CTFooVi^H02_l92@[o2@TDoa4V5?l92@[o4A`:o`TB
2_l92@[o;2HDo`T95?lA70X2o`TB2P08oaXB5?l94P[o2A8:o`T95?l92@[o
2A8:o`T92_l94PX2o`T92P03o`TB2_l92@[o000000;o2@T:00Go2A8:o`T9
2_l94P[o2A8:o`000002o`T92P04o`TB2_lJ4QCo2@T:o`TB2P;o2@T:00[o
2A8:o`T92_l0003o2A8:o`000?l94P[o0000o`T92_l94P[o2@T:0_lA70X0
0ol92@[o4A`:ob`B0002oa4L2P05o`TB2_lA70[o0000o`TB2_lA70X00olJ
2@X01OlA70[o6PT:ob<V2_lA70[o2@T:00;o2A8:00?o0000o`T92_l00000
1Ol92@X00ol0003o2@T:o`T92P02o`T92P03o`TB2_l92@[o2@T:00co2@T:
00?o2A8:o`000?l92@X00_l92@X00ol0003o2A8:o`000003o`T92P03oaX9
2_lS70[o;18000;o8a`:00go4A`:oaX92_lJ2@[o8a`:ob`L5?lS70[o;1`D
oc@_:Om69QCoAT`modIED_mGEE;oCeiV00;oH79k00?o2A`Do`T92_l94PX0
0_l92@X2o`TB2PKo2@T:00?o2A8:o`T92_l000000_l92@X00ol94P[o2@T:
o`T92P02o`T92P03o`TB2_l92@[o2@T:00;o2@T:0_l94PX00olJ4QCo2@T:
o`T92P02o`T92P?o4A`:00_o6PT:o`T92_l94P[o0000o`T92_l94P[o2@T:
o`000?l92@[o2A8:oaX92P03o`T92P03oa4L2_l92@[o2@T:00;o2@T:00?o
0000o`TB2_lJ4Q@05?l92@X01?l94P[o2@T:o`TB2_l94PX2o`T92P0;ocdB
2_oCQ03o/780ooJc0?nEE@3oLRH0okUW0?oof@3oEa`0o`T92_lA70X01?l9
2@X01?l92ACo2@T:o`TB2_l92@X2o`TB2P0:o`T92_lA70[o2@T:o`T92_lA
70[o2@T:oaXB5?l92ACo0000ol77c5ooi^KV00CoWIfMokNg]oo8b<Sodm?C
0OoJf]X000;ok^k^01[ok>c/omcLg?mlO7cof][JomoOgooQhN7oe=CDookn
o_omoOgoooooooclo?o/k>coe]KFoeUIFOm[Jf_oO7alohN7QonDU9CoVYZJ
oijNW_nTY:CoZJVYojb/[?n`/;3o/[:bokBd]0?o]KFe00?o][JfokNg]ond
];@0=ond];@8okFe]@03okBd]?ne]KGo]KFe00Co][Jf00oo]KFeojj^[_n]
[JgoZJVYoj>SXonOWiooVi^Koi:BT_n8R8SoNGUiofe]KOmHF5Soe=CDonSX
j?oinOT00oooool3onOWi`;oj>SX00?o<C4aofUYJOoXj>P01OoXj>P2onWY
j@04onKVi_oZj^[oj^[Zon_[j`;oj^[Z1oo/k>`00oo[jn_ok>c/onc/k002
ong]k@04onc/k?o]kNgokNg]ong]k@;ok^k^1?o_knl00omZJV[o=3@doo3`
l003oo3`l004oc`l??mgMgOol?3`ono_k`;ol?3`0ooalO400ooclo?ol?3`
ooGem@02ooGem@Com_Kf00?od=3@o`410OoNg]h00oofm_H2ooOgm`03ocdm
?OmkNg_on?Sh00?onOWi0oojn_X2oo_kn`Coo?cl00?o?cloogemOOolo?`0
0oolo?`2oo_kn`04ooclo?omoOgooOgmooknoP?ooooo00?oo_knoooooooo
ool02?ooool00ombLW;o>3Phooooo`05ooooo`;oo_kn4?ooool00oolo?co
ooooooooo`05ooooo`03ooclo?oooooooooo00[ooooo00Co35FaojC4i_ni
dnooMZgZ0_n[h?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP04oa4V5?l94P[o
2@TDoa4L2P;o2@T:00?o4A`:o`TB2_l94PX00_l94PX2o`T95003o`TB2_l9
2@[o4A`:00Co2A8:00Ko2@T:o`TB2_l94P[o2A8:o`T92_lJ4Q@2o`TB2P03
oaX92_l92ACo2A8:00;o2A8:00?o2@T:o`TB2_l94PX01_l92@X01?lA70[o
0000o`TB2_l00002o`T92P;o2A8:0_lA70X01_lS70[o6PT:oa4L2_lA70[o
4BH:oaX92P;o4A`:00Go2@T:o`TB2_lA70[o2@T:oaX92P02oa4L2P03o`T9
2_lJ2@[o4A`:00Co2@T:00Ko2A8:o`T92_l94P[o2@T:o`T95?l94PX2o`T9
2P03o`TB2_l92@[o000000;o2@T:00?o2A8:o`T92_l92@X01?l92@X00ol9
4P[o2@T:o`T92P05o`T92P03o`TB2_l92@[o2A8:00;o2A8:0ol92@X01_l9
4P[o4A`:ob<L2_lS70[o4BH:oaXB50;o;18000Co8bH:ob<L2_lS70[o;1`D
0_l/9Q@00old;bWo=2lcodI<?@02odmNIP09oeMNKom6GTOo0000o`TB2_l0
003o2@TDo`TB2_l0003o2A8:00;o2@T:00[o2A8:o`T92_l92@[o0000o`T9
2_l94P[o2@T:oa4L2_l0003o2A8:0_l92@X01?l94P[o2@T:o`T92_l94PX2
o`T92P0<oa4V2_l94P[o2@T:o`T92_l94P[o4A`:o`T92_l94P[o2@T:oa4L
2_lJ2@[o4BHD0_l94PX01?l92@[o2A8:o`T92_l94PX4o`T92P04oa4L2_l9
2@[o2A8:o`T92P;o4A`:00?o2A8:o`T92_l94PX01?l92@X00ol94P[o2@T:
o`T92P02o`TB2P06o`T92_lA70[o2@T:o`T92_l94P[o2@T:0_l94PX00ol9
2@[o4A`:o`TB2P03o`TB2P03o`T92_l94P[o2@T:00;o2@T:00WoPbl0ooo@
0?mb9P3ook<0oeLL0?l92ACo/4`0ooo@0?mG70000_l92@X01?lA70[o2@T:
o`T92_l94PX2o`T92P0>o`TB2_l92ACo2A8:o`T92_l94P[o2@T:o`TB2_l9
2@[o2A8:o`T92_l92ACo2@T:o`000?o1alaOonk^kP04oj>SXonm_Kgoclo?
om[JfP7ohN7Q0002ooooo`0KoogmoOo/k>coO7alomWIfOoPh>3ohN7QomGE
eOooooooo?clooooooomoOgomoOgomWIfOmTI6CoGUiNofm_KomlO7coR8R8
ohn?SonDU9CoVi^Koj6QXOnSXj?oYZJVojZZZ_n^[Zko/K6a00?o/;2`00?o
/K6aojn_[on_[jl0=_n_[jl8ok2`/0?o[jn_01?o/;2`ojn_[on_[joo[Zj^
ojf][OnUYJGoY:BToinOWonIVIWoUIFEoi2@T?n6QXKoO7alofe]KOmOGeoo
H61PomcLg?odm?Coo?cl00?ooooo1OoWinL00ol`<33o:BTYoe]KF`02oe]K
F`03ojJVY_oXj>Soj>SX00?oj>SX0_oYjNT6on[ZjP[ojn_[0oo/k>`2ong]
k@06onk^k_m_KfooGUiNoeiNG_lZ:R[o51@D0omNGUh01?oOgmoo>c/kogMg
Moo_knl3oo3`l0?olO7a00?olo?coo;bl_odm?@00_odm?@2ooGem@?om_Kf
00GoAdM7ocLg=on8R8SoGUiNoeADE002ooOgm`03ocdm?OmkNg_omoOg00?o
n?Sh1OoinOT4oo[jnP03ochn?_mlO7con_[j00Con_[j0_okno/2ooclo003
oogmoOono_koo_kn00Wooooo00GoMgMgofEUIOmUIFGo;Bd]oaHF5P03ofEU
I@03onk^k_oooooooooo02Oooooo00Co35B^ojG4i_ned>koNJk/0_nWg?l0
1?mfMWKo`L71oo3`l?omoOeKooooo`;o2A8:00Co6Q8Do`TB2_l94P[o4A`:
1?l92@X02?l94P[o6Q8DoaXB5?l92ACo2A8:oaXB5?l92@[o2A8:0_l92@X0
0ol0003o2A8:o`TB2P02o`T92P05oaXB5?l92@[o2@T:o`T92_l94PX00_l9
2@X01Ol94P[o2@T:o`T92_l0003o2A8:00Go2@T:00Go0000o`TB2_l92@[o
0000o`TB2P03o`T92P07oaX92_l94P[o2@T:oa4L2_l92@[o6PT:ob`B0003
o`T92P03o`000?l92@[o2A8:00;o4A`:0_l92@X02?lA70[o2@T:o`T92_lA
70[o2@T:o`TB2_l92@[o2A8:0_l92@X2o`TB2PGo2@T:00?o2A8:o`T92_l9
2@X00_l94PX00ol92@[o2A8:o`T92P03o`T92P04o`TB2_l0003o2@T:o`00
00?o2@T:00?o0000o`T92_l92@X00_l92@X01Ol0003o4A`:o`000?lA70[o
6PT:00;o8a`:00Go;180ob<L2_lS70[o8a`:oaX92P03ob<L2P03ob`V5?ld
;ako=2lc00;oEeEB00CoCeiVog9bNom?Ieco4BH:0_l92@X01?l0003o4A`:
o`000?l94PX3o`T92P03o`000?l94P[o2@T:00;o2A8:00Wo0000o`TB2_l9
2@[o2@T:o`000?l94P[o2@T:o`000?l94PX00ol92@X2o`TB2P04o`000?l9
2@[o2@T:o`TB2P;o2@T:00[o4A`:o`T92_lA70[o4A`:oaX92_lA70[o2@T:
o`TB2_l92@[o00001?l92@X01_l94P[o2@T:oa4L2_l92@[o8a`:oa4L2P;o
2A8:0_l92@X01Ol94P[o4A`:o`T92_l92@[o4A`:00Oo2@T:00Go2A8:o`T9
2_l92@[o2@T:o`TB2P02o`T92P0Bo`TB2_l92@[o2@T:o`T92_l94P[o2@T:
o`TB2_l92@[oPbl0ooof0?mb9P3o2@TDoonc0?mP;`[o0000okUW0?ood03o
Ea`01?l92@X00olA70[o2@T:o`T92P03o`T92P04o`TB2_l92@[o2@T:o`TB
2P;o2@T:00Ko4A`:o`T92_l92@[o4A`:o`000?nV/l5Oooooo`04ojn_[oo;
bl_og]kNon[ZjP7ol_;b0002onk^kP0Jonc/k?oLg=coO7alomWIfOoPh>3o
hN7QomGEeOoooooono_kooooooomoOgoo_knomcLg?m]KFgoEEEEof=SHom`
L73oOWinohJ6Q_n=SHgoUYJFoifMWOnPX:3oWYjNojBTY?nZZZX2ojf][@03
ojb/[?n][Jgo[Jf]03So[Jf]2?n/[:`2ojj^[P0Eojf][On/[:coZJVYojNW
YonUYJGoXj>SoijNW_nMWIgoV9RHoi:BT_n=SHgoQhN7ogemOOmcLg?oIFEU
oeIFE_mXJ6Soh^;RoogmoOono_kono_k00;ooooo1OoWinL00onOWiooRh^;
oh^;R`02oh^;R`03okfm_OoXj>Soj>SX00?ojNWY00?oj^[ZonWYjOoZj^X0
0_oZj^X3on_[j`Ook>c/1_o]kNd2onk^kP03ono_konKVi_oT92@00KoT92@
00?oiNGUoc`l??mgMgL01?o`l?03oo7al@03oo?cloodm?Com_Kf00;om_Kf
1OogmoL01Ooclo?o/;2`ofYZJ_n3Ph?o^KVi00;on?Sh00?o?Shnog]kNooh
n?P00_oinOT00oohn?SonOWiooWin@03ooWin@Con_[j00?o?ShnogalO?oj
n_X01?ojn_X2oo_kn`;oo?cl00?ooOgmookno_ono_h02Oooool00onVYZKo
VYZJoiZJVP05oiZJVP03ooCdm?oooooooooo02Oooooo00Co35FaojC4i_nh
d^koMZgZ0_n/gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP03o`T95?lA70[o
2@TD00Ko2A8:00Oo2@T:o`TB2_l92@[o4BHDo`T92_l94P[o2@T:00Go2A8:
00So2@T:o`TB2_l92@[o4A`:o`T92_lA70[o2A8:o`T950;o2A8:0ol92@X0
1ol94P[o2@T:o`T92_l94P[o2@T:o`TB2_l92@X00_l94PX01_l92@[o0000
o`TB2_l0003o2A8:o`0000;o4A`:00?o6PT:oa4L2_l/4P000olA70X00ol9
2@[o4A`:o`T92P02o`T92P04oa4L2_lJ2@[o6PT:o`T92P;o4A`:00Go2@T:
o`TB2_lA70[o2@T:o`000003o`TB2P;o2@T:00?o0000o`TB2_lA70X00_l9
2@X02?lA70[o2@T:o`T92_l92@[o2A8:o`000?l94P[o2@T:0_l94PX3o`T9
2P03o`000?l92ACo4A`:00;o2@T:00?o2A8:o`T92_l94PX00ol92@X01ol9
4P[o0000o`TB2_l92@[o6PT:ob<L2_l/4P000_lS70X00ol/4P3o4A`:ob`B
0002ob<L2P09ob`L5?ld;ako=2lYodI17_mGEE;oCeiVog9ED_n3Q8ko8blc
00;o2A8:0_l92@X01Ol94P[o2@T:o`T92_l92@[o2A8:00;o2@T:00Oo0000
o`TB2_l0003o2A8:o`T92_l0003o2A8:00?o2@T:00?o0000o`TB2_l92@X0
1?l92@X2o`TB2P03oa4L2_l92@[o2@T:00;o2A8:00?o2@T:oa4L2_l92@X0
0_lA70X2o`TB2P03o`000?l94P[o2@T:00;o2A8:00[o2@T:o`TB2_l94P[o
2@T:oa4L2_l0003o4BHDo`T92_lJ2@[o2A8:0_l92@X01OlA70[o2@T:o`T9
2_l92@[o2A8:00?o2@T:00?o2A8:o`T92_l92@X00_l92@X00olA70[o2A8:
o`TB2P02o`T92P03oa4L2_l92@[o2@T:00?o2@T:00go2A8:o`T92_l92@[o
LRH0oooI0?n3;`3o0000oooI0?mG703o?A8:ok1<0?ood03oEa`000;o2@T:
00Go4A`:o`TB2_l92@[o2@TDo`TB2P02o`T92P04o`TB2_l92@[o2A8:o`T9
2P;o2A8:0_l92@X01OlA70[o6Q8Doa4L2_l0003o/;k105ook^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN4000;oi^KV00Soi>CTomCDe?mkNg_of][JomoO
gooQhN7oeMGEoogmo@;ooooo013om?Cdooooooodm?CoT92@odi>C_mRHV;o
EUIFofYZJ_n;Rh_oTI6Aoj2PX?nXZ:So[jn_ojj^[_nc/k?o]KFe0_nd];@0
0onf][Ko]kNgokJf]P0@okJf]QSo]kNg6Onf][H2okVi^@0FokJf]_ne]KGo
][JfokJf]_nd];CoZ:RXokZj^_nIVIWoW9bLoi^KVomfMWKoKVi^oemOGom<
C4coCTi>ohR8R?ooooooo?clono_kooooooomOGeooooo`?oinOW2_oXj>P3
onWYj@;ojn_[0oo]kNd:onk^kPOokno_1_o`l?05oo7al@03ong]kOo_knoo
lO7a00?olO7a0oobl_82ooCdm0?om_Kf2_ogmoL2ooShn003ooCdm?ofm_Ko
n?Sh00Son?Sh1?oinOT00ooemOGomoOgooWin@04ooWin@;on_[j0oolo?`2
ooknoS_ooooo00Co3UF^ojK6i_nfd>koNJo^0_n[g_l01?mZJV[o[Zj^omSH
f?oTi>AKonKViP?o6Q8D00Co4A`:o`TL5?l94P[o2@TD0_l94PX4o`T92P;o
2A8:00Go2@T:o`TB2_l0003o2A8:o`T92P02o`TB2P08o`T92_lA70[o2@T:
o`TB2_lJ71ko6Q8Do`T95?l92@X2o`TB2P0;o`T95?l94P[o2A8:o`T92_l9
4P[o2@T:o`TB2_l92@[o2A8:o`000?l92@X00_l94PX01ol0003o2A8:o`00
0?l92@[o2A8:o`T92_l94PX00_lA70X01OlA9QCo2A8:oaX92_lA70[o2A8:
00;o2@T:00?o4A`:o`T92_l92@X00_lA70X02?l92@[o6PT:oa4L2_l92@[o
2A8:o`000?l92@[o2A8:0_l92@X02?l94P[o2@T:o`TB2_l92@[o2A8:o`T9
2_l94P[o00001_l92@X00ol94P[o0000o`TB2P02o`T92P;o2A8:00_o0000
o`T92_l94P[o2A8:o`000?l94P[o0000o`TB2_l92@[o2A8:o`000002o`T9
2P07o`TB2_lJ2@[o8a`:ob<L2_lm70[o8a`:ob`L5004ob<L2P04ob`L5?ld
;ako=2lcodI<?@?oCeiV00GoJW^4o`TL5?lA9QCo2@T:o`TB2P03o`T92P05
o`TB2_l92@[o0000o`000?l94PX03?l92@X2o`TB2P?o2@T:00Ko2A8:o`00
0?l0003o2@TDo`T92_lA70X2o`T92P06oa4L2_l92@[o4A`:o`TB2_lA70[o
2A8:0ol92@X01_l0003o2A8:oaX92_l94P[o2@T:oa4L2P;o2@T:00?o4A`:
o`T92_l94PX00_l94PX00ol92@[o2A8:o`T92P02o`T92P04o`TB2_lA70[o
2@T:oa4L2P?o2@T:00?o2A8:o`T92_l94PX00_l92@X01?lA70[o2@T:o`T9
2_lA70X7o`T92P05ocdB2_oTZP3o8a`:o`000?mP;`X00ooof@001Ol92@[o
2A8:o`T92_l92@[o4A`:00Co2@T:00Ko4A`:o`TB2_l92@[o4A`:o`T92_lA
70X3o`TB2P06oa4L2_l92ACo2@T:o`T95?l0003o/;k1GooVi^H01?nMWIgo
]kNgolS8b?oCdm<1om[JfP000_o^k^h02Oo/k>cog=cLogMgMooJf][oh>3P
on7QhOoDe=CoooooooWin@02ooooo`0DooOgmoono_ko`/;2oc`l??m2@T;o
BDU9ofYZJ_mfMWKoW9bLokFe]Onl_;co];Bdokno_oo4a<Coa/K6olG5aOo4
a<Coa/K6olO7aoo5aLD@olW9bASoalO76?o9bLT01oo5aLGob<S8olS8b?o5
aLGoa<C4olK6a_o5aLD00_o3`l<02one]KGo^;Rhok^k^on7QhOoJVYZog9b
L_m8B4SoEUIFod10@?o2`/;omOGe00;ooooo00?om_Kfooooooooool02ooV
i^H5onOWi`03onSXj?oYjNWoj^[Z00Goj^[Z1oo[jn/3onc/k0?okNg]00?o
kno_onk^k_o`l?000_o`l?02oo7al@_ol_;b1?oclo<4ooCdm0[omOGe0oof
m_H2ooOgm`;onOWi00Con?Shoo[jn_ojn_[on_[j0_okno/=ooclo0;ooOgm
00?oo_knooooooooool0>oooool01?l;DZkoY<?UokSBkomi[^`2ojcOo`04
ofi^K_nd];Coh>3Ponc/k5_ok^k^00Ko4A`:o`TB2_l94P[o2@TDo`TB2_l9
2@X2o`TB2P03o`000?l94P[o2A8:00?o2@T:00Co2A8:o`T92_l92@[o2@T:
0_l94PX01Ol92@[o2A8:o`TB2_l92@[o2A8:00;o2@TD00Oo2A8:o`T92_l9
4P[o2A8:o`T92_l94P[o000000So2@T:00Ko2A8:o`000?l92@[o2@T:o`00
0?l92@X2o`TB2P08oa4L2_lJ2@[o6PT:oa4L2_l/4P3o4A`:o`T92_l94PX2
o`T92P05o`000?l92@[o2@T:o`T92_lJ2@X00_lA70X00ol92@[o4A`:o`T9
2P03o`T92P04o`000?l92@[o2A8:o`0000Oo2@T:00?o0000o`T92_l00000
1_l92@X01_l94P[o0000o`000?l94P[o0000o`T92P;o000000Ko2A8:o`T9
2_l92@[o0000o`T92_l00005o`T92P05ob`B0?lJ2@[o4A`:ob`L5?l/4P00
1?lS70X02?l/9QCo=2lYodI17_m6EE;oEeEBodmNI_mPLW_oJW^40ol00004
o`T92P08o`000?l94P[o2@T:o`T92_l0003o2@T:o`000?l94PX2o`T92P0:
o`TB2_l92@[o2@T:o`TB2_l92@[o0000o`TB2_l0003o2@T:o`TB2PGo2@T:
00?o8blYo`T92_l92@X01Ol92@X00ol/4P3o6PT:o`TB2P0<o`T92P03oa4L
2_l92@[o2A8:00?o2@T:00?o2A8:o`T92_l92@X01Ol92@X00ol94P[o0000
o`T92P02o`000004o`T92_l94P[o2@T:o`0000[o2@T:0_l000001_l92ACo
0000ol640?nVI`3oSED:o`0000So2@T:00?o0000o`T92_l92@X02?l92@X0
1?lA70[o0000o`000?nEXKMOonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
0002ooooo`04oogmoOo/k>coMWIfomWIf@;ogmoO01Koe=CDooooooojn_[o
o_knoooooooalO7ooooooogmoOn3Ph?oA4A4od=3@om>CTkoMWIfojNWYonm
_Kgo^;RholO7aoo2`/;oalO7ol[:b_o9bLWob<S80_o9bLT00oo7alOob/[:
ol[:bP0nol[:bP0EolW9bOo;bl_obl_;olW9bOo8b<SobLW9olS8b?o5aLGo
alO7okno_one]KGo^KViojRXZ?m^KVko@d=3od51@Ole=CGoRXZ:oo?clooh
n?Soo_kn00;ooooo00?oo?cloooooooUiND02_oUiND5onKViP;oj>SX1_oZ
j^X:on_[j`?ok>c/0_o]kNd3onk^kP[okno_0oo`l?03oo7al@03oo;bl_oa
lO7ol_;b00;ol_;b0_oclo<8ooCdm0?omOGe0_ofm_H3ooShn0?on_[j0_ok
no/=ooclo0;ooOgm00?oo_knooooooooool0>oooool01?l>EJkoYLCVokKB
k_mi[^T2oj[Po`04ogIfM_o1`L7ol?3`oogmoE_ooooo00?o4BHDo`T92_l9
4PX00_l92@X00ol94P[o2@T:o`000006o`T92P03o`000?l94P[o2@T:00?o
2@T:00Co0000o`T92_l92@[o00000_l92@X01?l94P[o2@T:o`T92_l94PX6
o`T92P03o`000?l92@[o000000?o2@T:00?o0000o`T92_l000000_l92@X3
o`000007o`TB2_l92@[o4A`:oa4L2_l92@[o6PT:o`T92P02o`000008o`TB
2_l0003o2@T:o`TB2_lA70[o2A8:oaX92_lA70X2o`T92P04o`TB2_lA70[o
0000o`0000;o2@T:00Co0000o`T92_l92@[o2A8:0_l92@X01?l0003o2@T:
o`T92_l00004o`T92P04o`000?l92@[o0000o`TB2P?o2@T:00?o0000o`T9
2_l000000_l92@X01_l0003o2@T:o`T92_l92@[o0000o`T92P;o000000Oo
2A8:o`000?lA70[o6PT:ob<L2_l/4P3o?A`:00;o;1800_lS70X02Ol/71Co
=2lNoc@_:Old;akoAT`modmNI_mGGVooLW9kodINA`02o`000006o`T92_l0
003o2@T:o`T92_l0003o2@TD0ol000000ol92@[o0000o`TB2P02o`000006
o`T92_l0003o2A8:o`000?l92@[o00001Ol92@X00ol0003o2A8:o`T92P02
o`T92P03o`TB2_lA70[o000000Co2@T:00?o4A`:o`T92_lA9Qh00_l92@X0
0ol0003o4A`:o`T92P07o`T92P04oa4L2_l92@[o4A`:ob`L50Go2@T:00?o
0000o`T92_l92@X02_l92@X00ol0003o2A8:o`000003o`T92P03o`000?l9
2@[o2@T:00;o2@T:00?o2A8:o`T92_l92@X00_l92@X01?l0003o2@TDo`00
0?l92A@Do`T92P03oa4L2_l0003oYZZ]05oooooo00Co[jn_ol_;booNg]ko
j^[Z0Oobl_8000;ok^k^00Ook>c/omgMgOmbLW;oemOGomoOgooPh>3od];B
00;ooooo00?on?Shooclo?ooool00_ooool03_oalO7oF5QHob/[:olj>S[o
GemOog]kNoo1`L7o_[jnol71`Oo2`/;oalO7ol[:b_o9bLWob<S80_o9bLT0
0oo7alOob<S8olS8b00>olS8b1SobLW96?o8b<P00oo9bLWoc<c<ol_;b`02
olW9b@0Bol[:b_o8b<So`l?3ol?3`oo5aLGoc<c<ojf][OmmOGgoH61Pod92
@_l[:b_oFe]KoooooooinOWomoOgoooooookno_onOWi0_ooool;onKViP;o
inOW0ooXj>P2onWYj@?oj^[Z0oo[jn/7onc/k0KokNg]00?ok^k^ono_koo`
l?001?o`l?0;oo7al@?ol_;b0_oclo<3ooCdm0[omOGe1Oofm_H2ooOgm`03
ooKfm_ogmoOomoOg00?omoOg2oohn?P2ooWin@?ono_k0_omoOdAooknoR[o
oooo00Co35B^ojK6i_nidnkoNJk[0_n[gol01?m^KVko];Bdon3Ph?o/k>aK
onk^kP;o2A8:00Oo4A`:o`TB2_l92@[o2@T:oa4L2_l94P[o4A`:00Co2@T:
00Co2A8:oaX92_l92@[o2@T:0ol94PX01Ol92@[o2A8:o`TB2_l94P[o2@T:
00Ko2A8:0_l92@X01_l94P[o2@T:o`T92_l94P[o2@T:o`TB2PKo2@T:00So
4A`:o`000?l92@[o2A8:o`T92_lA70[o;180oa4L2P;o8a`:00Co6PT:o`TB
2_l92@[o2@T:0_l94PX00ol92@[o4A`:oaX92P02oaX92P05oa4L2_lJ2@[o
2@T:o`TB2_lJ2@X01_l92@X00ol94P[o0000o`TB2P02o`T92P03o`TB2_lA
70[o2@T:00So2@T:00?o0000o`TB2_l94PX00_l92@X01Ol94P[o2@T:o`T9
2_l0003o2A8:00;o2@T:00?o2A8:o`T92_l92@X00ol92@X2oaX92PCo8a`:
00Wo8bH:ob`L5?lm70[o;2HDoc@_7_ld;bWoAT`mog9ED_mGGVl00_mPLW/0
0olS;c?o0000o`TB2P05o`T92P06o`TB2_l92@[o2@T:o`T92_l0003o2A8:
1ol92@X00ol94P[o2@T:o`T92P04o`T92P0@o`TB2_l92@[o2@T:o`000?l9
2ACo2@T:o`000?l92ACo2@T:oa4L2_lJ2@[o4A`:o`T92_lA70[o6PT:oa4L
2PCo2@T:00_o6PT:o`T92_l92@[o2@T:o`TB2_lA70[o2@T:oaXB5?l92@[o
4A`:o`TB2P0;o`T92P04oaXB5?l94P[o8a`:o`TB2Q3o2@T:00Co4A`:o`T9
2_lJ2@[o2A8:0_lA70X5o`T92P06oa4L2_l0003o4A`:o`T92_lA70[o2@TD
0_l94PX4o`T92P07o`000?lA70[o2@T:oaXB5?l94P[o2@T:oiFQ]`1Oonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002onKViP04onCTi?oGemOoLG5a
olo?c`;ogMgM00SodM7Aoo_knoooooooooooooclo?ooooooo?clon_[j`;o
oooo00Wo=SHfod10@?m?CdooPH61oifMWOn/[:co/K6aokRh^?nn_[h00oo2
`/82ol?3``03ol71`Oo3`l?o`l?300ko`l?36?o2`/8Hol?3``03ol71`Oo3
`l?o`/;200;o`L7100go`/;2okno_oni^KWo_KfmokRh^?n^[ZkoTY:BofYZ
J_lj>S[o:RXZodi>C_ojn_[ok^k^00;ooooo00GojNWYooooooooooooo?cl
ooooo`0;onGUi@Goi^KV00?oj>SXonOWiooYjNT01OoYjNT:on[ZjP?ojn_[
00?ok>c/ong]kOo^k^h00_o^k^h:ono_k`?ol?3`0ooalO42oo;blP?olo?c
0_odm?@8ooGem@Gom_Kf0_ohn?P00oogmoOonOWiooWin@03ooWin@_on_[j
0_okno/3ooclo0;ooOgm4Oono_hZooooo`04oa1G[onS`^Co^=?_ogN^j`;o
Z]oo00CoJVYZojj^[_oHf=Soi>CTFooVi^H02?lJ4QCo2@TDo`T95?l94P[o
2@TDoa4L2_l92ACo2@T:1?l94PX2o`T92P06o`TB2_l92@[o2A8:oaXB5?l9
2@[o4A`:0ol92@X00ol94P[o2@T:o`TB2P02o`T92P03o`T95?l94P[o2A8:
00;o2A8:1?l92@X00olA70[o2A8:o`T92P02o`T92P0<o`TB2_l92@[o2A8:
o`000?l92@[o2A8:o`000?l94P[o6PT:oa4V7_lA70[o;1800_lA70X04Ol9
4P[o2@T:oaXB5?l0003o2@T:o`TB2_lA70[o6PT:ob<L2_lJ2@[o4A`:oaX9
2_l92@[o4A`:oaX92_l92@[o2A8:00?o2@T:00Oo6Q8Do`000?l92@[o2@T:
o`TB2_l92@[o2A8:00;o2@T:00Co4A`:o`TB2_l92@[o2A8:1Ol92@X00ol9
4P[o2@T:o`T92P06o`T92P03o`TB2_l0003o2@T:00Go2@T:017o4A`:oaX9
2_lS70[o;1`Dob<L2_lm70[o8bH:ob`L5?ld;ako8blNoc@_<omP@BWo=2lc
odmNI_mbEE;oLVMBodmNIP02o`TB2PKo2@T:00Go0000o`T92_l92@[o2@T:
o`TB2P03o`T92P03oa4L2_l92@[o2A8:00?o2@T:00Ko2A8:o`T92_l92@[o
2@T:o`TB2_l00002o`T92P03o`TB2_l92@[o2@T:00Go2@T:0_lA70X01?l9
4P[o4A`:oa4L2_l92A@7o`T92P08oaXB5?l92@[o2@TDo`TB2_l92@[o2A8:
oa4L2_l92A@Fo`T92P07o`TB2_l92@[o2A8:o`TB2_l92@[o2A8:oaXB5005
o`T92P03o`TB2_l92@[o2@T:00;o2@T:00?o4A`:o`T92_l92@X01?l92@X0
1olA70[o2@TDoaXB5?l92@[o2A8:oa4L2_l94PX00olA70X01Ol92@[o2A8:
o`T92_l0003oUJ6g05ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;o
k^k^00[okNg]on3Ph?mjNW[o_knoomSHf?oJf][oc<c<ooooooojn_[ooooo
0_olo?`04?oooooom?Cdooooooo[jn_oooooodI6A_lb<S;oAdM7ofa/K?nG
UiOoYjNWojBTY?n[Zj_o/;2`ok:b/_nc/k<2okJf]P03okBd]?ne]KGo]KFe
03ko]KFe01Co/[:bok>c/onb/[;o/K6aok:b/_nc/k?o[Zj^ojNWYonIVIWo
/;2`ohZ:R_mPH63oAdM7ob@T9?mVIVKoo_knoooooooinOWooooooo;blP;o
oooo00?omOGeooooooooool02ooTi>@5onGUi@;oinOW1_oYjNT:on[ZjPCo
jn_[1?o/k>`:ong]k@Kok^k^00?ol?3`ono_kooalO401?oalO48oo;blP?o
lo?c0_odm?@2ooGem@04ooKfm_ogmoOomoOgooOgm`;on?Sh2ooinOT2oo[j
nP?ono_k0_olo?`@oogmo@?oo_kn:?ooool01?l@EZooYLCVokWCkomg[^/2
ojWLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00So2@TDo`T92_l92@[o4A`:
o`T92_lA70[o2@T:oa4L2P;o2@T:0_l94PX2o`T92P08o`TB2_l92@[o2@T:
o`T92_l94P[o4A`:o`TB2_lA70X2o`T92P05oa4L2_l92@[o2@T:o`TB2_l9
2@X00_l94PX01?l92@[o2A8:o`T92_l94PX2o`T92P05o`TB2_l92@[o2@T:
o`T92_l94PX01_l92@X00ol94P[o0000o`T92P02oa4L2P03oa4V2_lJ2@[o
4A`:00;o2A8:00Co0000o`T92_l92@[o2@T:0_lA70X01?l92@[o4A`:oaX9
2_lA70X2o`T92P03oaX92_lA70[o2@T:00;o2@T:00?o4A`:o`000?l92@X0
2?l92@X01_l94P[o0000o`T92_l92@[o2A8:o`0000Go2@T:00So2A8:o`00
0?l92@[o2@TDo`000?l94P[o2@T:o`TB2PSo2@T:00Oo8a`:ob`B0?l/4P3o
8a`:ob`L5?l/9QCo=2lY00;oARHD00Ko=2lcodI<?OmGGVooLW9koeMNKom6
GTL2o`T92P04o`000?l92ACo2@T:o`TB2P;o2@T:00?o2A8:o`T92_l92@X0
0_l00002o`T92P03o`000?l92@[o000000?o2@T:0_l94PX2o`T92P03o`TB
2_l92@[o2@T:00So2@T:00Co6PT:o`T92_l92@[o2@T:0_lJ4Q@2oa4L2P05
o`TB2_l92@[o2@T:o`T92_lA70X00_l92@X02Ol94P[o2@T:oa4L2_l92ACo
4A`:oaXB5?l94P[o4A`:o`TB2P07o`T92P03oa4L2_l94P[o2@T:00[o2@T:
00?o2A8:o`000?l92@X00ol92@X01Ol94P[o6Q8Do`T92_l92@[o4A`:00;o
2@T:00?o4A`:o`T92_l92@X00_l92@X00ol94P[o2@T:o`T92P03o`T92P03
o`TB2_l92@[o4A`:00So2@T:00Go4A`:o`T92_l92ACo0000oiFZ[@1Oonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002ooooo`0<ookno_ofm_KoVYZJ
ojBTY?oBd];oe=CDol;2`_ooooooo_knoooooookno_on?Sh1?ooool03_oj
n_[oooooogMgMom2@T;o;bl_odU9BOmGEeOoMGEeogalO?n3Ph?oQXJ6ohV9
ROn<S8coSHf=4On;Rh/Hohf=SAWoRh^;013oS8b<oh^;Ron:RX[oS8b<ohf=
SOn7QhOoOgmoogIfM_mDE5Co<C4aobl_;oln?SkoS8b<oo3`l?okno_ok^k^
0_ooool01_oinOWooooooo[jn_oooooomoOgooooo`?oh>3P2_oQhN43on;R
hP03onCTi?oShn?oiNGU00;oiNGU2_oVi^H7onOWi`Koj>SX2ooYjNT3on[Z
jP03onc/k?o[jn_okNg]00;okNg]2_o^k^h7ono_k`Kol?3`2?oalO43oo;b
lP;olo?c0ooemOD2ooOgm`?on?Sh2_oinOT3oo[jnP?oo?cl0_ono_hVoooo
o`04o`aE/OnTa>Ko^M?_ogJ]jP;oZn3o00CoMWIfol71`Oo`l?3ooOgmFooo
ool01OlA9QCo2A8:oa4L2_l92ACo2@T:00?o2A8:0_l92@X01Ol94P[o2@T:
o`TB2_l92@[o2A8:00Wo2@T:00Oo2A8:o`T92_lA70[o2@T:o`TB2_l0003o
2A8:00?o2@T:00?o2@TDo`TB2_l94PX00_l92@X00ol0003o2@T:o`T92P02
o`T92P04o`TB2_l92@[o2@T:o`TB2P;o2@T:00[o6PT:oa4L2_l/4P3o4A`:
oaX92_l/4P3o2@T:oaXB5?l0003o2A8:0ol92@X02OlJ2@[o4A`:oaX92_lA
70[o6PT:oa4L2_l0003o2A8:oa4L2P03o`T92P03o`000?l94P[o2A8:00Wo
2@T:00Ko2A8:o`T92_l92@[o0000o`T95?l92@X3o`TB2P05o`000?l94P[o
2A8:o`TB2_l000000ol92@X00ol0003o2A8:o`T92P03o`T92P04o`TB2_l9
2@[o4A`:oa4L2P?o8a`:00Co;1`Doc@_7_mP@BWoAT4N0om6C3d02ombEE;o
H79koeMNKold;c?o0000o`T95?lA70[o0000o`T92_l0003o2@TD00;o2@T:
00?o0000o`TB2_l92@X01Ol92@X00ol94P[o2@T:o`TB2P02o`T92P05o`00
0?l94P[o2@T:o`000?l94PX00_l92@X01Ol94P[o2@T:o`T92_l0003o2A8:
00Ko2@T:00Go6PT:oa4L2_lJ2@[o6PT:o`TB2P07o`T92P07oa4L2_l92@[o
2@T:oa4L2_l92@[o4A`:oaX92P02o`T92P07o`TB2_l92@[o2@T:o`T92_lA
70[o2@T:o`000002o`T92P03o`TB2_l92@[o2@T:00;o2A8:2_l92@X01Ol9
2ACo2@T:o`TB2_l92@[o4A`:00;o2@T:00?o4A`:o`T92_l92@X01?l92@X0
0olJ2@[o2A8:o`TB2P04o`T92P03oa4L2_l92@[o2@T:00;o2@T:00?o4A`:
o`T92_l92@X00_l92@X01?lA70[o2@T:o`000?nEXKMOooooo`04ojn_[oo;
bl_og]kNon[ZjP7ol_;b0003onk^kP09onWYjOo5aLGoPh>3ojb/[?nl_;co
[Zj^ooShn?oooooon_[j00;ooooo00Gon_[jooooooomoOgooooooogmo@03
ooooo`0;omoOgomPH63o?cloob/[:olb<S;o>SXjochn?_m2@T;oATI6odQ8
B?m6ATH04?m:BTXHodU9BASoBTY:0_m;Bd/03?m:BT[oBDU9od];Bom<C4co
ATI6ochn?_la<C7o>3Phofa/K?oOgmoooooooo;blPCooooo00?ono_koooo
ooogmoL01?ooool3om_Kf`Sog=cL1OoMgMd2omoOg`KohN7Q2_oRh^83on?S
h`;oi>CT0ooUiND:onKViPKoinOW0_oXj>P5onWYj@_oj^[Z0_o[jn/2onc/
k004ong]kOo^k^kok^k^onk^kP[okno_1Oo`l?03oo7al@Gol_;b2?oclo<2
ooCdm0?omOGe0oofm_H2ooOgm`?on?Sh2_oinOT3oo[jnP;oo?cl0oono_hA
ooooo`04o`aD[_nUa>Ko]M3^ogV^k0;oYmco00CoKVi^okBd]?oPh>3ok>c/
Foo^k^h01_l92@[o2@TDo`T95?lA70[o2@T:o`TB2P;o2@T:00Co2A8:o`T9
5?lA70[o2A8:1_l92@X2o`TB2PCo2@T:00Co2@TDo`TB2_lA70[o2A8:0_l9
2@X2o`TB2P06o`T92_lA70[o2@T:o`T92_l0003o2A8:1ol92@X01Ol0003o
2A8:o`000?l92@[o000000;o4A`:00?o8a`:oa4L2_l/4P000_lA70X02ol0
003o2@T:o`TB2_l0003o2A8:oa4L2_l/9QCo2@T:oa4L2_lJ2@[o4A`:00;o
2A8:00?o2@T:oaX92_lA70X01ol92@X00ol0003o2@T:o`T92P05o`T92P03
o`000?l94P[o2@T:00?o2@T:00Wo0000o`T95?l0003o2A8:o`T92_l0003o
2A8:o`T92_l92A@00ol92@X01?l94P[o4A`:oaXB5?l94PX3o`T92P0@oaX9
2_lS70[o8a`:ob<L2_l/71CoAT4Noc@_:Old;c?oAT`mof11:OmGGVooLUEB
of1bNom?Ieco4BH:o`TB2P;o00003Ol92@X00olA70[o2@T:oa4L2P0?o`T9
2P03o`TB2_l92@[o2@T:00?o2@T:00co4A`:o`T92_l94P[o4A`:o`T92_l9
4P[o4A`:o`TB2_l92@[o4A`:o`T92_l00003o`T92P06o`TB2_lA70[o4A`:
oaXB5?l92@[o2A8:0ol92@X01Ol94P[o2@T:o`T92_l92@[o2A8:00So2@T:
00?o0000o`T92_l94PX01?l92@X00ol94P[o2@T:oa4L2P05o`T92P05oa4L
2_l92@[o2@T:o`T92_lA70X02?l92@X00ol94P[o2@T:o`T92P03o`T92P09
o`TB2_l971Co4A`:o`T92_lA70[o2@T:oa4L2_l0003oY[?105ook^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN4000?oi^KV00_oi>CTomcLg?nVYZKoLg=c
oh20P?n?ShooW9bLojFUYOn/[:co/K6aokNg]`0>ok^k^`?o_;bl0onm_Kd0
0onn_[ko_Kfmokjn_P02okjn_P;o_kno2oo0`<02ol71`@;o`/;200Co`l?3
olC4a?o4a<Coa<C42_o5aLD5olK6aP;oalO700?oa/K6olO7aoo7alL00oo7
alL=olS8b003olW9bOo:b/[ob/[:00oobl_;0oo<c<`00oo=cLgoc<c<olc<
c002olg=c@_oc/k>0_o?cll3om3@d003om7AdOoBd];odm?C00;odm?C0ooD
e=@7omGEe@Koe]KF0_oGemL5omSHf0_ofMWI0ooJf]X2om_Kf`?og=cL2_oM
gMd5omkNgP;ogmoO00?og]kNomoOgooOgml00ooOgml8on3Ph0?ohN7Q0_oR
h^82onCTi003onGUiOoWinOoinOW00?oj>SX2_oYjNT3on[ZjP?ok>c/0_o^
k^h;ono_k`;ol?3`0ooalO400oobl_;olO7aoo;blP02oo;blP?olo?c3_od
m?@01?l;E;3oY<CVokSBk_mf[NX2ojcOo`04ofYZJ_n^[Zkof=SHonCTi5_o
i^KV00?o6Q8Doa4L2_l94PX00ol94PX02_lA70[o2@T:o`T92_l92ACo2A8:
o`T92_l94P[o2@T:o`TB2_l92@X2o`TB2P?o2@T:0_l94PX00ol92@[o2A8:
o`T92P02o`T92P03o`TB2_l92@[o2@T:00Oo2@T:00Co0000o`T92_l92@[o
2A8:1_l92@X02_l94P[o2@T:oa4L2_lJ2@[o4A`:oaX92_lA9P[o6PT:o`TB
2_lA70X2o`000003o`TB2_l92@[o2@T:00;o4A`:00?o8a`:oaX92_lA70X0
0ol92@X00olA70[o6PT:o`T92P03o`T92P06o`TB2_l92@[o2@T:oa4L2_l9
2@[o2A8:1ol92@X01_l0003o2@T:o`T92_l92@[o4A`:o`0000;o2@T:00So
2A8:o`T92_l92ACo0000ob`V5?lJ4QCo2@T:o`TB2P;o2@T:00?o2A8:o`T9
2_l92@X00ol92@X03olS70[o;180ob<L2_l/9QCo=2lYoc@_<om6@AkoAUEB
oeMED_mbEE;oH79koeMNKom?Ieco0000o`TB2P07o`T92P03o`TB2_l92@[o
2@T:00Go2@T:00?o8a`:o`T92_lA70X00ol92@X00ol92ACo2A8:o`T92P07
o`T92P03o`TB2_l0003o2@T:00Go2@T:00?o6Q8Doa4L2_lJ2@X00_lA70X4
o`T92P03o`TB2_l0003o2@T:00;o2@T:00?o2A8:oa4L2_lJ2@X00olA70X0
2?l94P[o2@T:o`T92_l92@[o2A8:o`000?lA70[o00000_l92@X01?l92ACo
0000o`T92_lA70X5o`T92P03o`000?l92@[o4A`:00;o2@T:00Co4A`:o`T9
2_lA70[o2@T:0_lA70X01?l94P[o2@T:o`T95?lA70X7o`T92P03oa4L2_l9
2@[o2@T:00?o2@T:00go6Q8Do`T92_l92@[o2@T:o`TB2_l92@[o4A`:o`T9
2_l92ACo4A`:o`T95?l0003oYZZ]05ooi^KV00CoWIfMokNg]oo8b<Sodm?C
0OoJf]X000Cok^k^00[ojn_[on3Ph?nh^;SoPH61og1`L?mhN7SoRh^;oi:B
T_nIVIWoXJ6Q3_nVYZH6ojNWY`03ojRXZ?nYZJWoZZZZ00CoZZZZ2?n[Zj/3
ojb/[0;o[Jf]0_n^[Zh01?n][Jgo[Zj^ojj^[_n^[Zh2ojn_[`go/;2`0_na
/K400onb/[;o/k>cok>c/`0;ok>c/`;o];Bd0one]KD00onf][Ko]KFeokFe
]@02okJf]P?o]kNg2_nh^;P3okVi^@03okZj^_nk^k_o^k^k00;o_;bl2onm
_Kd5okjn_P03ol30`?no_koo`L7100Go`L712_o2`/84ol?3``Coa<C42_o5
aLD6olK6aP03olO7aoo6a/KoalO700CoalO72?o8b<P3olW9b@;ob/[:0oo<
c<`3olk>cP;oclo?2oo@d=02om7Ad@?od];B0_oCdm<;omCDe0GoeMGE0ooG
emL5omWIf@Sof][J0_oKfm/3omcLg0;ogMgM0ooNg]h3omoOg`koh>3P00Co
3EB]ojK6i_nfd>koNJo^0_n[g_l01?m^KVko];Bdon3Ph?o/k>aKonk^kP05
oa4V5?l92ACo2A8:oaXB5?l94PX00_l92@X01Ol94P[o2@TDo`T92_l92@[o
6PT:00Oo2@T:00Go2A8:o`T92_l92@[o2A8:o`00000?o`T92P03o`TB2_l0
003o2@T:00Go2@T:00?o0000o`T92_l000000_lA70X01_lJ2@[o4A`:ob`B
0?lA70[o6PT:oa4L2P?o2@T:00So0000o`T92_lA70[o6PT:o`T92_lA70[o
;180oa4L2P;o2@T:00Oo0000oaX92_l92@[o4A`:o`000?l94P[o000000;o
2@T:00?o0000o`T92_l92@X00ol92@X01_l92ACo0000o`TB2_l0003o2@T:
o`0000Ko2@T:00Go0000o`T92_l94P[o2@T:o`000002o`T92P05o`000?l9
4P[o0000o`T92_l000000_l92@X04Ol0003o4A`:oaX92_lJ2@[o8a`:ob<_
7_ld;bWoAT4Noc@_<omP@BWoEeEBodmNI_mGGVooAUi7ob<_<ol0003o2@T:
00;o000000Go4A`:o`T92_l92@[o2A8:o`000002o`T92P03o`TB2_l92@[o
2@T:00Co2@T:00Wo4A`:o`T92_l92@[o2@T:o`TB2_l0003o2@T:o`000?l9
4PX01?l92@X01Ol94P[o0000o`T92_l92@[o000000Co2@T:00Ko2A8:o`T9
2_lA70[o6PT:oa4L2_lJ2@X2o`T92P03o`000?l92@[o2@T:00;o2@T:00Ko
2A8:o`T92_l92@[o2@T:o`TB2_lJ2@X:o`T92P03o`000?l92@[o000001?o
2@T:0_l92A@00ol0003o2@T:o`T92P08o`T92P03o`TB2_l92@[o2@T:00?o
2@T:00?o2A8:o`T92_l92@X01Ol92@X00olA70[o0000ojJZ[@1Oonk^kP04
oj>SXonm_Kgoclo?om[JfP7ohN7Q0004ooooo`08oogmoOoinOWojNWYom7A
dOna/K7oV9RHohN7QomoOgooogYjNPgoNWYj00WoLg=cog1`L?mZJV[oHF5Q
oe=CDol8CjcoY<?UokSBkomi[^`00_n/gol01?mfMWKo`L71oo3`l?omoOeK
ooooo`0;o`T95?lA9QCo6Q8Do`T92_l94P[o2@T:oa4L2_l92ACo4A`:o`T9
2_l94PX00_l92@X01?l94P[o2@T:o`T92_l94PX5o`T92P03o`TB2_l92@[o
2@T:00;o2A8:00Co2@T:oaXB5?l92@[o2A8:1Ol92@X00ol94P[o2@T:o`T9
2P03o`T92P;o2A8:0_l92@X00olA70[o2@T:o`T92P03o`T92P05oa4L2_lJ
2@[o4A`:oa4L2_lJ2@X01Ol92@X2oa4L2P07oaX92_lA70[o8bH:ob`B0?l9
4P[o4A`:o`T92P02oa4L2P03oaX92_lA70[o000000;o2@T:00?o2A8:o`T9
2_l92@X00ol92@X2o`TB2P07o`000?l92@[o2@T:o`000?l94P[o0000o`T9
2P02o`TB2P;o2@T:00Co2A8:o`T92_l92@[o00000ol92@X00olA70[o2@T:
oaX92P02o`TB2PCo2@T:00ko2A8:oaX92_lA70[o8a`:ob<_7_ld;c?o=2lY
odI17_l/EEcoEeEBoeMNKombEE;o8blYo`TL50;o2A8:0_l92@X01Ol0003o
2A8:o`T92_l92@[o2A8:00;o2@T:00?o0000o`TB2_l94PX00ol92@X01?l9
4P[o2@T:o`T92_l94PX4o`T92P04o`TB2_l92ACo0000o`TB2P;o2@T:00Go
2A8:o`T92_l92@[o2@T:o`TB2P04o`T92P06oaX92_l92@[o6PT:oa4L2_l/
4P3o2A8:1ol92@X01ol0003o2A8:o`T92_lJ2@[o6Q8DoaX92_lA70X01ol9
2@X00olA70[o2@T:o`T92P03o`T92P03o`TB2_l92@[o2A8:00Go2@T:00?o
2A8:o`T92_l92@X00_l92@X00ol94P[o4A`:o`T92P02o`T92P0:o`000?l9
2ACook<0oh<_0?l92@[o2A8:o`T92_lA70[o2@T:o`TB2P?o2@T:00?o2A8:
o`T92_l92@X00_l92@X01OlA70[o2@T:o`TB2_l94P[o2@T:00;o2A8:0_l9
2@X00ol94P[o6PT:oiFQ]`1Oooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b
0004onk^kP0:on_[jooPh>3o^;Rhoh61POm]KFgoM7Adoh:2P_n7QhOoSHf=
oiFEU@koVYZJ1_nKVi/2oibLW0GoWIfM2onNWYh2oinOW`;oX:2P00CoWinO
oj2PX?nPX:3oX:2P3OnQXJ42oj:RXP;oXj>S00?oY:BTojFUYOnUYJD00onV
YZH8ojNWY`GoZ:RX00?oZJVYojRXZ?nXZ:P01OnYZJT:ojZZZP?oZj^[00?o
[:b/ojf][On][Jd00_n][Jd;ojj^[PGo[jn_0_n`/;06ok6a/@[o/[:b0onc
/k<00one]KGo];BdokJf]P02okJf]P[o]kNg3Onh^;P8okVi^@Go^[Zj0onl
_;`3okjn_P;o_kno2oo0`<02ol71`@?o`/;20_o3`l<;olC4a0GoaLG500?o
a/K6olO7aoo7alL01Oo9bLT8ol[:bP;obl_;0oo<c<`00oo=cLgoc<c<olg=
c@02olg=c@?oc/k>3_o?cll01?l=E:goYLCVokKBk_mi[^T2oj[Po`04ofi^
K_nd];Coh>3Ponc/k5_ok^k^00So2A8:oaXB5?l92ACo4A`:o`T92_lA70[o
2@T:oa4L2P;o2@T:00Co0000o`TB2_l94P[o2A8:1Ol92@X00ol94P[o2@T:
o`TB2P03o`TB2PCo2@T:00?o4A`:o`T92_l92@X00_l92@X02_l94P[o2@T:
o`T92_l0003o4A`:o`000?l94P[o2@T:o`TB2_l00002o`TB2P0:o`000?l9
2@[o2A8:o`TB2_l92@[o4A`:oaX92_lA70[o2@T:oaX92P;o4A`:00?o0000
o`TB2_l92@X00_l94PX01OlA70[o6PT:ob`B0?lJ2@[o8a`:00;o2@T:00So
0000o`TB2_l92@[o4A`:oaX92_lA70[o2@T:o`TB2P;o2@T:00Co2A8:o`T9
2_l92@[o2A8:0ol92@X00olA70[o2@T:o`T92P04o`T92P07o`000?lA70[o
2@T:o`T92_l0003o2A8:o`T92P02o`TB2P06o`T92_l94P[o2A8:o`TB2_l9
2@[o2A8:0_l92@X01_l94P[o2@T:o`T92_l92@[o4A`:oaXB50;o;2HD00?o
8blNodI17_m6C3d00_m6C3d02?ldECgo4A`:o`T92_l0003o2@TDo`TB2_l9
2@[o2A8:1Ol92@X02_l0003o2@T:o`T92_l0003o2A8:o`T92_l94P[o2@T:
o`000?l94PX2o`T92P06o`TB2_l92@[o2@T:o`000?l92@[o4A`:1ol92@X0
1_l94P[o2@T:o`T92_l0003o2@T:o`0000;o4A`:00Go2@T:o`TB2_l92@[o
2@T:o`TB2P02o`T92P03oa4L2_l92@[o2A8:00Ko2@T:0_lA70X7o`T92P04
o`000?l92@[o2@T:oa4L2PSo2@T:00Oo2A8:o`000?l94P[o2A8:o`T92_lJ
2@[o4A`:00?o2@T:00Oo/4`0okUW0?o1Q03oi:X0ob`L5?l92@[o6PT:00?o
2@T:00Go4A`:o`T92_l92@[o2@T:oa4L2P04o`T92P04oa4L2_l92@[o2@T:
oaX92P;o2@T:0_l94PX01?lA70[o2@T:o`000?nVZZeOonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q0003onKViP08onCTi?oLg=coYZJVog5aLOmnOWko
S8b<oiZJV_nSXj<2oo[mo@;ooOgm0_omo?d0F?omoOgoo?gmoo[moOoioOgo
nOgjooOhlooflNkom>[Yoo3Ph?oXf=SogM7AomcBdOoMdM7og=;AomgAdOoL
d]7ogM7AomcBdOoMdM7og=;AomgAdOoLd]7ogM7AomcBdOoMdM7og=;AomgA
dOoLd]3ogM7AomcBd?oMdM7og=;@omgAdOoLd]3ogM7AomcBd?oMdM7og=;@
omgAdOoLd]3ogM7AomcBd?oMdM7og=;@omgAdOoLd]3ogM7AomcBd?oMdM7o
g=;@omgAdOoLd]3ogM7AomcBd?oMdM7og=;@omgAdOoLd]3ogM7AomcBd?oM
dM7og=;@omgAdOoLd]3ogM7AomcBd?oMdM7og=;@omgAdOoLd]3ogM7AomcB
d?oMdM7og=;AomgAdOoLd]7ogM7AomcBdOoMdM7og=;AomgAdOoLd]7ogM7A
omcBdOoMdM7og=;AomgAdOoLd]42omgAd@09omg=cOoXf=Sok=kNoo7UiOok
l_?onoOfoo_in_omoOgoo?gm00?on_gm1?oloOd00oomoOgocLg=olk>cP09
olk>cP?oclo?00?od=3@om7AdOoBd]800_oBd]8:om?Cd`Koe=CD0_oEeMD5
omKFePkoemOG0_oHf=P=omWIf@?of][J0_oKfm/3omcLg0?ogMgM0_oNg]h;
omoOg`;oh>3P0ooRh^82onCTi0_oiNGU0_oWinL3onSXj003on[Zj_oYjNWo
jNWY00;ojn_[0oo/k>`8onk^kP;okno_0oo`l?02oo;blP?om?Cd0ooemOD>
ooKfmP04o`]C[OnVa^Ko^M?^ogV^j`;oZmoo00CoJVYZojj^[_oHf=Soi>CT
FooVi^H00ol92ACo8blNo`TB2P06o`TB2P;o2@T:00?o2A8:o`000?l92@X0
0ol92@X00ol94P[o2@T:o`TB2P04o`T92P04o`000?l92@[o2@T:o`T92P;o
2A8:00Go2@T:o`TB2_l94P[o0000o`TB2P05o`T92P08o`000?l92@[o2@T:
o`T92_l94P[o0000o`T92_l94PX2o`0000;o2@T:00Go4A`:o`T92_lA70[o
6PT:oa4L2P02o`T92P0;o`000?l92@[o0000o`T92_lJ2@[o4A`:oaX92_lA
70[o2@T:oa4L2_l000001Ol92@X00olA70[o2@T:o`TB2P05o`T92P0;o`00
0?l94P[o2@T:o`000?lA70[o2@T:o`000?l92@[o0000o`T92_l94PX00ol0
0003o`T92P03o`TB2_l0003o2@T:00;o000000_o2@T:o`TB2_l0003o2@T:
o`000?l94P[o0000o`T92_l94P[o0000o`TB2P02oa4L2P04oaX92_lJ9QCo
6Q`NodI17P;o=2lY00?o;1`Do`000?l94PX00_l000001?l94P[o0000o`T9
2_l00002o`T92P03o`000?l92@[o2A8:00Co2@T:0_l000003?lA70[o2@T:
o`000?l92@[o2A8:o`000?l92@[o2A8:o`000?l94P[o0000o`TB2P;o2@T:
00Go2A8:o`T92_l92@[o2@T:o`000002o`T92P04o`000?lA70[o2@T:o`00
00;o2@T:00Go4A`:o`TB2_l94P[o0000o`TB2P07o`T92P05oa4L2_l92@[o
4A`:oaX92_lA70X01ol92@X00olA70[o2A8:o`T92P02oa4L2PWo2@T:00Co
2A8:oa4L2_l92@[o2A8:0_l92@X01ol92ACoPbl0oooI0?of/`3om/L:ol64
0?l000001?l92@X2o`TB2POo2@T:00?o4A`:o`T92_l92@X01Ol92@X2o`TB
2P03oa4L2_l0003oUJ6g05ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X0
00?ok^k^00SojNWYolG5aOmiNGWoX:2Pokfm_On`/;3o[Zj^okFe]@Gooooo
06Coo_oooocoooolooooo?ooooSlnoobl_3oin?Pon;HeooRd];oglW;omS2
a?o9]kOoakNgolVg]oo7]kOobKNgolNg]oo9]kOoakNgol^i^Oo9^KWobkVi
olVi^Oo;^KWobKViol^i^Oo9^KWobkViolVj]oo;^KWobKZgol^i^Oo9^[Oo
bkViolVj]oo;^KWobKZgol^i^Oo9^[OobkViolVj]oo;^KWobKZgol^i^Oo9
^[OobkViolVj]oo;^KWobKZgol^i^Oo9^[OobkViolVj]oo;^KWobKZgol^i
^Oo9^[OobkViolVj]oo;^KWobKZgol^i^Oo9^[OobkViolVj]oo;^KWobKZg
ol^i^Oo9^[OobkViolVj]oo;^KWobKZgol^i^Oo9^KWobkViolVi^Oo;^KWo
bKViol^i^Oo9^KWobkViolVi^Oo9]kOoakNgolVg]oo7]kOobKNgolNg]oo9
]kOob[Jgolnf^OoJ`LCog<S9omk>c_oWfm_okNCUoo?_l?ono_koo_oo0_ol
ool00ookooooo?oooocoo`02ookoo`03oooooooMgMgogMgM00OogMgM1OoN
g]h2omoOg`Koh>3P2_oQhN43on;RhP;ohn?S0ooTi>@:onGUi@Koi^KV0_oX
j>P5on[ZjP_ojn_[0_o/k>`2ong]k@04onc/k?o]kNgokNg]ong]k@[ok^k^
1Oo_knl3oo3`l0GolO7a2?obl_82oo?cl`?om?Cd00?omOGeooKfm_ofm_H0
0_ogmoL3ooShn0[onOWi0oojn_X2ooclo0?oo_kn4Oooool01?l@EjooXl;T
okSCkomg[^/2oj[Oo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Ko2A8:oa4V
5?l92ACo6Q8Do`TB2_l92A@3o`TB2P03o`T92_l94P[o2@T:00?o2A8:00Go
2@T:o`TB2_l94P[o2@T:oaXB5005o`TB2P04o`T92_l94P[o4A`:o`T92P?o
2A8:0ol92@X01Ol94P[o2@T:o`TB2_l0003o2A8:00Ko2@T:0_l94PX4o`T9
2P05oa4L2_lJ2@[o4A`:o`TB2_lJ2@X00_l92@X02_l94P[o2@T:o`T92_l9
2@[o4A`:oaX92_lA70[o2@T:o`TB2_lA70X:o`T92P03oa4L2_l92@[o2A8:
00;o2@T:00Go0000o`T92_l94P[o2@T:oa4V7P07o`T92P05o`T95?l94P[o
0000o`T92_l94PX01?l92@X00ol94P[o0000o`T92P04o`T92P0>o`TB2_l9
2@[o2A8:o`T95?l92@[o2A8:oaXB5?lJ9QCo;1`Dob`h:OlS;c?o6RHDo`T9
2_l94PX4o`T92P03o`TB2_l92@[o2@T:00;o2@T:00Co2A8:o`000?l92@[o
2@T:0_l94PX00ol92@[o4A`:o`000002o`T92P05o`TB2_l92@[o2@T:oaXB
5?l94PX01?l92@X3o`TB2P05o`T92_lA70[o2@T:o`T92_lA9Qh00_l92@X0
3Ol0003o2@T:o`T92_l92@[o2A8:oa4L2_l92@[o6PT:o`TB2_l92@[o2A8:
oa4L2_l92@X00_l94PX01?lJ2@[o2A8:o`T95?lJ2@X3oa4L2P05oaX92_l9
4P[o2@T:o`T92_l94PX00_l92@X01?l94P[o2@T:o`T92_l94PX4o`T92P03
oa4L2_l92@[o2@T:00;o2A8:1Ol92@X02olA70[o2@T:oa4L2_l0003oPbl0
ooof0?oof@3o`H@0o`000?l92@[o4A`:00;o2@T:00Co2A8:o`T92_l92@[o
4A`:0ol92@X04?lA70[o2A8:o`T92_l92@[o4A`:o`TB2_l92@[o4A`:o`T9
2_l94P[o4A`:o`TB2_lJ4QCo2@TDo`000?nEXKMOonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q0002ooooo`0:ookno_ofm_KoVYZJoi6ATOo<c<coeMGE
ol;2`_ni^KWo`<30ooomo`;oooko00?oooooookoooolool00_olool02Ooe
moKol>o]on;Mf_oAa/Cob;JfolF_/Oo3YZ[o_9nSojnEV007ojjEV0So[IBG
<?n]UID8ojfDU`Oo[YFH00_o[iFHokNGW?o2XZOoa:N[olF/[oo=^k_odlO7
on7HfOobk^ooooooookoo`04oocoo`;oo_oo00?oooooon3Ph?oQhN402OoQ
hN43on;RhP03onCTi?oShn?oiNGU00;oiNGU2_oVi^H6onOWi`03onSXj?oY
jNWoj^[Z00Coj^[Z2oo[jn/3onc/k0;okNg]0oo^k^h:ono_k`?ol?3`0_oa
lO42oo;blP04oo7alOobl_;ol_;boo;blP;olo?c2?odm?@5ooGem@?om_Kf
1OogmoL:ooShn0?onOWi00?ono_kooclo?olo?`00_ono_hVooooo`04oa1F
[onUa>Ko^M?_ogN^j`;oZMco00CoMWIfol71`Oo`l?3ooOgmFoooool01_lJ
4QCo2@TDo`T92_lJ4QCo4A`:o`T92P;o2A8:00Go2@T:o`TB2_lA70[o2A8:
o`T92P03o`TB2P03o`T92_l94P[o2A8:00Go2@T:1Ol94PX01?l92@[o2A8:
o`T92_l92@X2o`TB2P?o2@T:00Go2A8:o`000?lA70[o2@T:o`TB2P04o`T9
2P03o`000?l92@[o2A8:00;o4A`:00?o;180oa4L2_l92@X00_lJ2@X2oa4L
2P05o`TB2_l92@[o4A`:o`TB2_lJ2@X00olA70X01Ol/4P3o2A8:oa4L2_l9
2@[o2A8:00Co2@T:0olA70X01?l92@[o4A`:o`TB2_l92@X2o`TB2P05o`T9
2_l0003o2A8:o`T92_l94PX00_l92@X01OlA70[o2@T:o`T92_l92@[o0000
00?o2@T:00?o0000o`TB2_l000000ol92@X00ol94P[o2@T:o`TB2P02o`T9
2P07o`TB2_l92@[o2@T:o`T92_l0003o2A8:o`T92P02oaXB50;o8a`:00Co
6PT:oa4L2_l94P[o2A8:0ol92@X00olJ4QCo0000o`TB2P02o`T92P08o`TB
2_l92@[o2@T:o`T92_l94P[o2@T:o`000?l94PX2o`T92P06o`TB2_l0003o
2@T:o`000?lJ4QCo4BHD0_l92@X02ol94P[o2@T:o`T92_l92@[o2A8:oaXB
5?lA9QCo2@TDo`T92_lA70[o2@T:00?o2A8:0_l92@X00ol94P[o2@T:o`T9
2P03o`T92P0<oaX92_l92@[o2A8:oa4L2_l92ACo2@T:o`TB2_l92@[o6Q8D
oa4L2_l92@[o6PT:0_lA70X00ol94P[o2@T:o`T92P0>o`T92P03o`000?l9
4P[o2@T:00;o2@T:01;o2A8:oa4L2_l92@[o2@T:o`T95?lA70[o2@TDoiEE
0?mb9P3o2@T:o`TB2_lA70[o2@T:oa4L2_l92@[o4A`:o`T92_lA70X4o`T9
2P03oa4L2_l92@[o2@T:00;o2@T:00Go2A8:o`T92_l94P[o2@T:o`TB2P02
o`T92P04o`T95?lA70[o0000oiFQ]eoooooo00Co[jn_ol_;booNg]koj^[Z
0Oobl_8000;ok^k^00kokNg]on3Ph?mjNW[o_;blomSHf?oKfm_oc/k>ol30
`?o5aLGooo_oooolooooo_oooooooocno@;oo?oo017oo?cjonGQg_oEblWo
c;jmokfYZ?ndVY_o/92Coj1mPOnQOH7oWGYnoiUiO?nGMg[oTg=foi5aM?nB
LWGoUGEhoiQhN`0hoiEeN0[oTg=f017oTW9eoi1`Lon?Kg;oTG5doiEeN?nK
N7coWgQmoiigO?nSOh?o[hnBokNMW_nmZJ[obkflom[@cooXh^;omO?doooo
o`05ookoo`03oooooooUiNGoiNGU00OoiNGU1OoVi^H2onOWi`Koj>SX2_oY
jNT3on[ZjP;ojn_[0oo/k>`:ong]k@?ok^k^0oo_knl00ooalO7ol?3`oo;b
lP02oo;blP;olo?c2?odm?@5ooGem@?om_Kf1OogmoL=ooShn0?onOWi3ooj
n_X3oo_kn`03ooclo?omoOgooOgm00;oo_kn9_ooool01?l<EK7oY<CVokWC
komf[NX2oj_Po`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00?o4BHDo`TB2_lA
70X00_l92@X01OlA70[o2@T:o`T92_l92@[o2A8:00;o2@T:00Go2A8:o`T9
2_l92@[o2A8:o`T92P02o`TB2PCo2@T:00?o2A8:o`T92_l92@X01?l92@X0
0ol94P[o2@T:o`TB2P02o`T92P06o`000?l94P[o2@T:o`TB2_l92@[o0000
0_l94PX3o`T92P05o`000?lA70[o2@T:o`000?l94PX00_l92@X01?l94P[o
4A`:oaX92_lA70X5o`T92P08o`000?lA70[o8a`:oaX92_l/4P3o4A`:oaX9
2_lA70X<o`T92P04oaX92_l0003o2A8:o`0000;o2@T:00?o2A8:o`000?l9
4PX00_l92@X01OlA70[o2@T:o`TB2_l92@[o2A8:00;o2@T:00?o0000o`T9
5?l94PX01?l92@X03?l94P[o2@T:o`000?l94P[o0000o`T92_l94P[o0000
o`T92_l0003o2@T:o`TB2P?o4A`:00Wo2@T:o`TB2_l92@[o0000o`TB2_l0
003o2A8:o`T95?l94PX00ol92@X00ol0003o2A8:o`TB2P02o`T92P03o`00
0?l92@[o2@T:00;o2@T:00Co0000o`T95?l92@[o2@T:0_l000000ol94P[o
2@T:o`T92P02o`TB2P;o2@T:0_l92A@02?l92@[o4A`:o`T92_l94P[o0000
o`T95?l0003o2A8:0_l92@X01?lA70[o2@T:oa4L2_lA70X3o`T92P08oaX9
2_lJ4QCo=2lYoa4L2_l92@[o4A`:o`T92_l/4P02oa4L2P;o6PT:00Oo2A8:
o`T92_l94P[o2@T:o`000?l92@[o000000Co2@T:00?o2A8:o`T92_l92@X0
2ol92@X01olA70[o2@T:o`T92_l94P[o0000o`T95?l000000_l92@X01olA
70[o2@T:o`T95?l92@[o2A8:o`T92_lA70X01?l92@X2o`TB2P03o`T92_l9
4P[o2@T:00Go2@T:0_lA70X00ol92@[o0000ok2n`@1Oonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q0002onKViP04onCTi?oGemOoLG5aom7Ad@;og=cL
073od=3@olC4a?o9bLWooocoooomooooo_oooooooo[lnooinoSolo?aonOS
h?oPeM?od/2nolZ`/OncTiCoX7b0oiI]LOn:GfKoT6E/ohMNI?n7H6GoRF1V
ohMPIOn7GVCoQUmTohUPI_n9HVOoR5mUohMPIOn8GfGoQf1UohQOIOn7H6Go
R5mUohMPIOn8GfGoQf1UohQOIon7H6GoR5mWohMPIOn8GfOoQf1UohQOIon7
H6GoR5mWohMPIOn8GfOoQf1UohQOIon7H6GoR5mWohMPIOn8GfOoQf1UohQO
Ion7H6GoR5mWohMPIOn8GfOoQf1UohQOIon7H6GoR5mWohMPIOn8GfOoQf1U
ohQOIon7H6GoR5mWohMPIOn8GfOoQf1UohQOIon7H6GoR5mWohMPIOn8GfOo
Qf1UohQOIon7H6GoR5mWohMPIOn7GVCoQUmTohMNI?n6GfCoQeiTohIOI?n7
GVCoQUmTohMNI?n7H6GoRF1VohMPIOn7GVCoQUmTohUPI_n;HVSoU6E]oh]L
H_n:GFCoUfibojN4R?ncUYSo_jZYolbj^_oLd=3okNCUoochmoooo_oooOgm
0ooloOl00oooooooi^KVonKViP07onKViPgoinOW1ooXj>P3onWYj@?oj^[Z
0_o/k>`3onk^kP;okno_3_o`l?000ooalO7ol_;boo?cl`0?oo?cl`;om?Cd
0ooemOD3ooKfmP[omoOg0oohn?P2ooWin@?on_[j0_okno/3ooclo0gooOgm
0oono_hXooooo`04o`aD[_nUa>Ko]M3^ogV^k0;oYmco00CoJVYZojj^[_oH
f=Soi>CTFooVi^H01Ol92ACo2@T:o`T92_l92@[o4A`:00Go2@T:00?o2A8:
o`000?l92@X01Ol92@X01?l94P[o2@T:o`T92_l94PX2o`T92P03o`TB2_l9
2@[o4A`:00;o2@T:00Go6PT:o`000?l94P[o0000o`TB2P04o`T92P04oaX9
2_l94P[o2A8:o`0000?o2@T:00ko2A8:o`000?l92@[o0000oa4L2_l0003o
2@T:oa4L2_lJ2@[o4A`:o`T92_lA70[o6PT:oa4L2P;o6PT:00_o4A`:o`TB
2_lA70[o4A`:oaX92_lA9P[o8a`:oa4L2_lJ2@[o2@T:oaX92P03o`T92P03
o`TB2_l92@[o2@T:00;o2@T:00?o4A`:o`T92_l92@X01?l92@X03_l94P[o
0000o`T92_l92@[o2A8:o`T92_l94P[o2@T:o`000?l94P[o0000o`T92_l0
003o2A8:0ol00002o`T92P03o`TB2_l0003o2A8:00;o2A8:00Co0000o`TB
2_l0003o2@T:0_l94PX01?l0003o2@T:o`TB2_l00002o`T92P04o`TB2_l0
003o2@T:o`TB2P;o2@T:00?o6Q8Do`T95?lJ4Q@00_l94PX6o`T92P06oa4L
2_l0003o2A8:o`T92_l94P[o00001Ol92@X01?l94P[o0000o`T92_l92@X3
o`TB2P03oaXB5?l94P[o2A8:00?o2A8:00?o0000o`T92_l92@X02?l92@X0
0olA70[o2@T:oa4L2P02o`T92P07o`TB2_l92@[o2@T:oa4L2_l94P[o0000
oa4L2P02o`TB2P03o`000?l92@[o2A8:00;o2A8:1?l92@X01?l94P[o0000
o`T92_l94PX3o`T92P07oa4L2_l92@[o2@T:o`T92_lA70[o2@T:oa4L2P03
o`TB2P06o`T95?l0003oH2l:onBZ0?oo/`3o`H@00_l92@X01?lJ2@[oPbl0
o`T92_l94PX8o`T92P03o`TB2_l92@[o4A`:00;o2@T:00?o2A8:o`T92_l9
4PX00_l92@X00olA70[o0000ojJc`@1OonKViP04oifMWOng]kOob<S8om?C
d`7of][J0002onk^kP1gonc/k?oMgMgoLG5aomOGeooNg]kogmoOomCDe?o4
a<CoalO7oooloooonoooo_cooooooooooogooOchoo3[iooLdLgob;>`okNI
VOn_R8_oXgIiojMfO?nhQH[o`i2GomJSZ_o/_LGok/3:oo?4c_oeam7om/OA
ooC6d?odaLoom<K@oo?4c_oba<kollC>oo;4c_oca<kol/C>oo?4c_oba<ko
llC>oo;4c_oc`lool/C>oo?3cooba<koll??oo;4c_oc`lool/C>oo?3coob
a<koll??oo;4c_oc`lool/C>oo?3cooba<koll??oo;4c_oc`lool/C>oo?3
cooba<koll??oo;4c_oc`lool/C>oo?3cooba<koll??oo;4c_oc`lool/C>
oo?3cooba<koll??oo;4c_oc`lool/C>oo?3cooba<koll??oo;4c_oc`loo
l/C>oo?3cooba<kom<G?oo?5coodaLoollG?ooC5coocaLoom<G?oo?5coob
`lgollG?ooK7dOoeam7om<G?oo;4c_ob`lgollC<onF`^?oGXZSoa96Hok60
Q?nPLgSoWGIiojn=S_o3YjKod;^jon7AdOofk>_ooo_kooonooonool00_ol
ool00oonooooinOWonOWi`07onOWi`;oj>SX0ooYjNT00ooZj^[ojNWYon[Z
jP02on[ZjP?ojn_[3Oo/k>`00oo]kNgok^k^ono_k`0<ono_k`?ol?3`0ooa
lO400ooclo?ol_;booCdm002ooCdm0;omOGe2?ofm_H7ooOgm`Kon?Sh2ooi
nOT2oo[jnP;oo?cl00?ono_koogmoOomoOd04Oono_hZooooo`04o`aE/OnT
a>Ko^=;^ogJ]jP;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h3oa4L2P03
o`TB2_l92@[o4A`:00?o2A8:0ol92@X2o`TB2P?o2@T:0_l94PX01_l92@[o
0000o`T92_l92@[o2A8:o`0000;o2@T:00?o2A8:o`T92_l92@X00ol92@X0
3?l94P[o2@T:o`T92_l0003o2A8:o`000?l92@[o0000o`T92_l94P[o2@T:
o`TB2P?o2@T:00Co2A8:o`T92_l94P[o00000_lA70X01Ol94P[o2A`Do`T9
2_lA70[o6PT:00;o4A`:00_o2@T:o`TB2_l92@[o2A8:ob<L2_l/4P3o4A`:
o`000?lA70[o2@T:oa4L2P02o`TB2P;o2@T:00?o0000o`T92_l92@X01_l9
2@X2o`TB2P04o`000?l92@[o2A8:o`0000;o2@T:00Co8a`:o`TB2_l92@[o
00000_l92@X01Ol94P[o0000o`T92_l92@[o2A8:00?o000000Co2A8:o`00
0?l0003o00000_l92@X00ol94P[o0000o`000004o`T92P03o`TB2_l92ACo
2@T:00;o2@T:00Go0000o`T92_l92@[o2@T:o`T95002o`TB2P04o`T92_l9
4P[o2A8:o`0000;o2@T:00[o2A8:o`000?l92@[o0000o`T92_l0003o2A8:
o`T92_l94P[o2@T:0_l94PX3o`T92P04o`TB2_l92@[o2@T:o`T950Ko2A8:
2Ol92@X01?lA70[o2@T:o`TB2_lA70X2o`T92P03oa4L2_l94P[o2@T:00?o
2@T:00Go4A`:oaX92_lA70[o6PT:o`TB2P02o`T92P04o`TB2_l0003o2@T:
o`T92P;o2A8:00Co0000o`T92_l94P[o00001_l92@X00ol94P[o2@T:o`T9
2P05o`T92P0Bo`000?lm4P[odiP:om>H2_o1Q03ook<0oh<_0?l92ACo/4`0
ooof0?n3;`3o2@T:oaX92_l92@[o4A`:o`T92_lA70[o2A8:0ol92@X01?lA
70[o2@T:oa4L2_l94PX2o`T92P06oa4L2_l92@[o6Q8Do`T95?l0003oUJ6g
Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool01?omoOgok>c/
ogMgMooIfMT2on3Ph00FomCDe?o7alOob/[:ooolooonnOgooognoooooOoo
oo_oo?Ocon[OfooD_kcoaZNUok:8ROn]Ngko/gZ0olnDV_o^/kWon;g3ooo:
d?of`lconLOBook<e`;ooloJ00?oolkIooo=f?oocMP01oooc]T3ooo>fP0]
ooo=g?ooc][oolgLooo>f_oocMcoolkJooo=g?ooc][oolgLooo>f_oocMco
olkJooo=g?ooc][oolgLooo>f_oocMcoolkJooo=g?ooc][oolgLooo>f_oo
cMcoolkJooo=g?ooc][oolgLooo>f_oocMcoolkJooo=g?ooc][oolgLooo>
f_oocMcoolkJooo=g?ooc][oolgLooo>f_oocMcoolkJooo=g?ooc][oolgL
00;oolkJ1oooc]T05_onc=OoolgHooo=f?oocMSoo/cGooc:eOokbMCoo<WB
oo_2bOooa<[oo/?9onfd^_o=VIgo/X64ojQlOOnYPX?o`J6RomBl_?o^g=co
oO?booomo?onool2oo_oo`03ookooooWinOoinOW00OoinOW3OoXj>P7onWY
j@?oj^[Z0oo[jn/00oo]kNgok>c/onk^kP02onk^kP;okno_2oo`l?03oo7a
l@;olo?c0ooemOD:ooKfmPgomoOg2oohn?P2ooWin@;ono_k00?oo?clookn
o_ono_h0>oooool01?l>EJkoY/KVokK@k_mi[nh2oj_No`04ogIfM_o1`L7o
l?3`oogmoE_ooooo00Ko2A8:o`T95?lA70[o2@T:oa4L2_l92@X5o`TB2PGo
2@T:00[o2A8:o`T92_l94P[o2A8:o`T92_l94P[o2@T:o`TB2_l92@[o4BHN
1Ol92@X2o`TB2P03o`000?l94P[o2@T:00?o2@T:0_l94PX01?l92@[o2A8:
o`T92_l00002o`T92P07o`TB2_l92@[o2@T:o`000?l94P[o4A`:oaX92P03
ob`B0003o`TB2_lA70[o2A8:00?o2@T:00Ko4A`:oaX92_lJ2@[o8a`:ob`B
0?lJ2@X5o`T92P03o`TB2_l92@[o2@T:00?o2@T:00Co0000o`T92_l92@[o
2@T:0_l94PX01ol0003o2A8:o`T92_l0003o2A8:o`000?l92A@00_l00000
3Ol94P[o2@T:o`TB2_l92@[o0000o`T95?l92@[o0000o`TB2_l0003o4A`:
o`T92_l000000ol92@X00ol0003o2A8:o`T92P02o`T92P04o`TB2_l92@[o
2@T:o`T92P;o000000?o2A8:o`T92_l000000_l92@X01ol0003o2@T:o`T9
2_l0003o2@T:o`TL5?l94PX00_l92@X01ol94P[o0000o`T92_l92ACo2A8:
o`T92_l94PX00ol92@X00ol0003o2@T:o`T92P03o`T92P03o`TB2_l92@[o
2@TD00Co2@T:00Co2A8:o`T92_l92@[o00003_l92@X00ol94P[o2@T:o`TB
2P02o`T92P03oa4L2_l92@[o4A`:00;o2@T:00?o6PT:o`T92_lA70X01Ol9
2@X00ol94P[o2@T:o`T92P07o`T92P03o`TB2_l0003o2A8:00Go2@T:0_lA
70X04?l92@[oLRH0ooof0?nV@@3o2@TDoonc0?nV@@3o;180ok1<0?oomP3o
PcP0o`T92_lJ2@[o4A`:o`T92_l94PX3o`T92P;o2@TD0ol92@X00olJ2@[o
2@T:o`T92P03o`T92P03oa4L2_l0003oYZZ]05oooooo00Co[jn_ol_;booN
g]koj^[Z0Oobl_8000;ok^k^00Wok>c/omcLg?mfMWKof][Jon3Ph?oQhN7o
e=CDolO7aoo;bl/00_oooOl04Oooooooooomoo[gl_o^iN3of/O1ol:UXOnh
S8_o]Gj1olF7S?oJUikom[2hooo3b_ol^l7on;c4ooo:e?ooc=WooloL00;o
om3M00?ooloLooo@gOoodMh02?oodn02oooBhP0^oooBi?ood^;oom;ToooB
h_ood^Coom;RoooBi?ood^;oom;ToooBh_ood^Coom;RoooBi?ood^;oom;T
oooBh_ood^Coom;RoooBi?ood^;oom;ToooBh_ood^Coom;RoooBi?ood^;o
om;ToooBh_ood^Coom;RoooBi?ood^;oom;ToooBh_ood^Coom;RoooBi?oo
d^;oom;ToooBh_ood^Coom;RoooBi?ood^;oom;ToooBhPSoom;O00?oom?P
oooAg_ood=d00_ooc]/2ooo=fP0Booo=eooo`/[oo[g3oobk`Ooj_<7ol[Bi
omZOXonlQHSoYgEfokB:Roo5Xj;og/K6oo;Thoolm_KonoglooWoooojoooo
o_oo2OoWinL2onSXj0?ojNWY0_oZj^X3on_[j`?ok>c/1oo]kNd6onk^kP03
oo3`l?o_knoolO7a00ColO7a2oobl_84oo?cl`Com?Cd2_oemOD5ooKfmP;o
moOg00?om_KfooOgmoogmoL00oogmoL;ooShn0;onOWi0_okno/00oolo?co
o_knooknoP0kooooo`04o`]B[_nT`nGo^=;_ogV^k0;o[=oo00CoKVi^okBd
]?oPh>3ok>c/Foo^k^h02OlA70[o2@T:o`TB2_l92@[o2A8:o`000?lA70[o
2@T:o`TB2P02o`T92P?o2A8:00?o2@T:oa4L2_l92@X00ol92@X2o`TB2P04
o`T92_l0003o2A8:o`0000;o2@T:00[o2A8:o`T92_l94P[o2@T:o`000?l9
4P[o0000o`TB2_l92@[o2A8:0_l92@X03ol0003o2A8:o`T92_l0003o2A8:
o`000?l94P[o0000o`TB2_l0003o2@T:o`TB2_lJ2@[o4A`:ob`B0002oa4L
2PCo2@T:00So2A8:o`T92_l/4P3o2@T:oa4L2_l92@[o4A`:ob`B00;o6PT:
00Go4A`:o`T92_l94P[o0000oaX92P08o`T92P03o`TB2_l0003o2@T:00;o
00000_l92@X00ol0003o2A8:o`T92P04o`T92P03o`000?lA70[o000000?o
2@T:00Go0000o`TB2_l0003o2@T:o`TB2P04o`T92P07o`TB2_l92@[o0000
o`TB2_l0003o2@T:o`000003o`T92P;o2A8:0_l92@X00ol94P[o2@T:o`T9
2P02o`T92P;o2@TD0ol92@X01?l0003o2A8:o`000?l00002o`T92P05o`00
0?l92@[o2@T:o`T92_l94PX01Ol92@X00ol0003o2A8:o`TB2P0:o`T92P03
oa4L2_l92@[o2@T:00Co2@T:00?o2A8:o`T92_l92@X01_l92@X01_lA70[o
2@T:o`T92_l92@[o4A`:oa4V50;o2@T:00go0000o`TB2_l92@[o0000o`T9
2_l0003o2A8:o`000?l92@[o2@TDo`TB2_l92@[o2A8:00Go2@T:00?o2A8:
o`T92_l92@X00_l92@X04?l94P[o2@T:o`T95?mb9P3oooH0oiEE0?l92ACo
m[<0oh<h0?n`C03oooH0oeLL0?l92@[o6PT:o`T92_lA70X2o`T92P06o`TB
2_l92@[o2@T:o`TB2_l92ACo4A`:0ol92@X02?l94P[o2@T:o`T92_l92@[o
4A`:o`T92_l0003o/;>gGoo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00
0_oVi^H01?oTi>Coe=CDogalO?oJf]X2on3Ph00Eom?Cdoo6a/Koc<c<ooon
ooomoOgoooomoooonooflNgoiM[Dom:k]OnmUiCoZ7EdokQhNOoIT9Ookj:Z
oojc^_oo_/Gook_3ooo4c?oobMKoolcI00;oolgJ0_ooc=T00ooocM[ooloL
oooAgP06oooAgP0booo@h?ood>;oom3Rooo@i?ood>;oom3Tooo@h_ood>Co
om3Rooo@i?ood>;oom3Tooo@h_ood>Coom3Rooo@i?ood>;oom3Tooo@h_oo
d>Coom3Rooo@i?ood>;oom3Tooo@h_ood>Coom3Rooo@i?ood>;oom3Tooo@
h_ood>Coom3Rooo@i?ood>;oom3Tooo@h_ood>Coom3Rooo@i?ood>;oom3T
ooo@h_ood>Coom3Rooo@i?ood>;oom3Tooo@h_ooc]h7ooo?g003oooCh?oo
dMkoolkK00;oolgJ0_ooc]/04_ooc=WoomCLooo9c_oo_L;onKBioo:]/_oV
XJCoe9>GolB9RoncPH;o_I>Dom:d]?oZf=KonO7_oocln_ohookonOooooko
o`Goi^KV00Coi>CTolK6a_o?clooi^KV0_oWinL2onSXj003onGUiOoJf][o
jNWY00?oj^[Z0oo[jn/7onc/k0;oh>3P1?o]kNd2ono_k`03onKVi_oKfm_o
lO7a00;olO7a0_obl_800ooIfMWol?3`oo;blP07oo;blP03om7AdOo@d=3o
l_;b00Colo?c2_odm?@5ooGem@?omoOg00?oi^KVooOgmooinOT00_o^k^h2
oo[jnP;okNg]1Oojn_X01OoWinOon?Shoo_knoo`l?3olO7a00;oo?cl00?o
nOWionKVi_ono_h01_ono_h00oo[jn_ok^k^ooknoP07ooknoPGooooo0_ob
l_89ooooo`03onc/k?omoOgooooo00;om?Cd2_ooool00ookno_oj>SXoooo
o`08ooooo`04o`iE[_nUa>Ko]];^ogV^j@;oZ^3o00CoJVYZojj^[_oHf=So
i>CTFooVi^H2o`TB2P;o2@T:00Go2A8:oa4L2_l92@[o0000o`TB2P02o`T9
2P06o`TB2_l92@[o2@T:o`TB2_l92@[o2A8:0ol92@X03?l92ACo0000o`TB
2_l94P[o2@T:oa4L2_l0003o2A8:o`000?l94P[o0000o`TB2P;o00000ol9
2@X01ol94P[o2@T:o`TB2_l94P[o0000o`T92_l94PX00_l92@X00ol0003o
2@T:o`TB2P03o`T92P03oaX92_lA70[o2A8:00;o;1800_lA70X00ol94P[o
0000o`T92P03oa4L2P05o`T92_lA70[o2@T:oa4L2_l94PX00_lA70X02Ol9
4P[o;180oa4L2_l92@[o4A`:o`T92_l/4P3o2@T:oa4L2P02o`T92P04o`TB
2_l0003o2@T:o`0000;o2A8:00Ko2@T:o`TB2_l94P[o0000o`T92_l94PX2
o`T92P07o`000?l92@[o0000o`TB2_l0003o2A8:o`000004o`T92P08o`00
0?l94P[o2@T:o`T92_l94P[o0000o`TB2_l00003o`T92P0:o`TB2_l0003o
2@T:o`TB2_l0003o2@T:o`TB2_l0003o2@T:o`TB2P;o2@T:00Co2A8:o`T9
5?l92ACo2A8:1Ol92@X02?l94P[o0000o`T92_l92@[o2A8:o`T92_l94P[o
00001_l92@X01?l94P[o2@TDo`T92_l92@X2o`TB2PGo2@T:00Ko4A`:o`T9
2_lA70[o4A`:o`T92_l94PX2o`T92P03oa4L2_l92@[o2@T:00Go2@T:00Oo
2A8:o`T95?l92@[o2@T:oa4L2_lJ2@[o;18000Ko2@T:00Ko2A8:o`000?l9
2@[o2@T:o`TB2_l00002o`T92P05o`000?l92@[o2A8:o`T92_l94PX00ol9
2@X07?l94P[o4A`:o`T92_l94P[o4A`:o`000?lm4P[om/L:ooJc0?oo/`3o
om00oooI0?ood03oLRH0o`T95?l94P[o4A`:oaX92_l92@[o4A`:o`T92_lA
70[o2@T:oa4L2_l92@[o4A`:o`T92_lA70X2o`T92P03o`TB2_l92@[o2A8:
00?o2@T:00?o0000oiFHXooVi^H0G_oVi^H01?nMWIgo]kNgolS8b?oCdm<1
om[JfP000_o^k^h01?o/k>cog=cLogalO?oJf]X2on3Ph00Gom?Cdoo7alOo
c<c<ooooooolo?coooomookmn?oak>KohmC=olfbZonhS8Wo_8:1olZ4Q_oX
UikolYnWooRW[_on/KOoo[Flooo8d?oob=Goo/_Jooo=g?ooc]d00_oocM`0
0oooc]gooloNooo?gP07ooo?gP;ooloR02koolkTooo?h_ooc^CooloRooo>
i?oocn;oolkTooo?h_ooc^CooloRooo>i?oocn;oolkTooo?h_ooc^CooloR
ooo>i?oocn;oolkTooo?h_ooc^CooloRooo>i?oocn;oolkTooo?h_ooc^Co
oloRooo>i?oocn;oolkTooo?h_ooc^CooloRooo>i?oocn;oolkTooo?h_oo
c^CooloRooo>i?oocn;oolkTooo?h_ooc^CooloR2?ooc]d01?ood=ooolkM
ooo=g?ooc]d2ooo?gP0@ooo=g?oobMKomkJnoonj`?oo_/Gookc0oo^`]OoZ
Wj?oei2DolR8ROnfOWoo^H^;olZXYooTclkomng/oogmn`;onOoo00?oo_oo
onKVi_oVi^H00_oVi^H04_nNWYko2@T9o`/;2olP823o<30`oiNGUooWinOo
j>SXojf][OlH61So1PH6od];BomkNg_o;2`/on_[joo/k>co>c/kogEeM@;o
kNg]00WoUiNGoaXJ6_o]kNgokNg]ob8R8_l>3Pko7AdModM7AooUiND00_o^
k^h02ooHf=SoADE5o`820_lP823o5ADEokFe]Oo`l?3oalO7ob8R8_lL71co
[jn_00KolO7a00OoVYZJoa4A4OlN7Qko8B4Qo`d=3On;Rh_olo?c00;om?Cd
00?oMgMgoclo?ooemOD01_oemOD05?lc<c?oQ8B4ooKfm_ofm_Koj^[Zobd]
;Olf=SKokno_odi>C_l71`Oo6ATIoiRHV?lB4Q;oE5ADoo[jn_lT92Co3`l?
oalO7om;Bd_olO7a0_ojn_X03Om?Cdoo1`L7oaTI6OnIVIWo4Q8BoeEEEOol
o?co/k>co`d=3Ol10@7o;Bd]oi>CTolA4A400_ooool01_oKfm_o=CDeo`h>
3_l<30co>CTiomcLg0Kooooo00Wo=3@dogIfM_ooooooooooobDU9Ol@413o
820Pode=COofm_H00_ooool03Om0@43oOgmoooooooooooooDE5Ao`P82?lJ
6Q[oW9bLoa<C4omGEeOooooood10@?moOgl00_ooool02_nSXj?o71`Loooo
oooooooo]KFeo`h>3_l20P;o;Bd]oi>CTolA4A46ooooo`04o`aD[_nVa^Ko
^M?^ogV^j`;oZmoo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01?l92ACo6Q8D
oa4L2_l92A@2o`T92P03oaXB5?l92@[o6PT:00Go2@T:00Go2A8:o`T92_l9
2@[o2@T:o`T95002o`0000;o2@T:00Wo0000o`T92_l0003o2A8:o`000?l9
2@[o0000o`T92_l000000_l92@X01?l0003o2A8:o`000?l92@X3o`0000?o
2@T:00?o2A8:o`000?l92@X00_l92@X02ol0003o4A`:o`T92_lA70[o6PT:
ob<V2_lS70[o;180ob<V2_lJ2@[o2A8:00?o2@T:0_lJ2@X2oa4L2P05ob`B
0?lJ2@[o6PT:oaX92_l92@X00_lJ2@X01OlA70[o2@T:ob<L2_l92@[o4A`:
00;o2@T:0_lA70X01?l0003o2A8:o`000?l92A@3o`000003oa4L2_l0003o
2A8:00;o00000ol92@X00ol0003o2@T:o`000002o`T92P04o`000?l92@[o
2A8:o`0000;o2@T:00So2A8:o`T92_l92@[o0000o`T92_l0003o2@T:o`00
00Wo2@T:00So2A8:o`T92_l92@[o2A8:o`T95?l92@[o6Q8Do`0000;o2@T:
00Wo2A8:o`000?l0003o0000o`TB2_l92ACo0000o`TB2_l000003?l92@X0
0ol94P[o0000o`T92P05o`T92P0;oa4L2_l92@[o2@T:o`T92_l94P[o2@T:
oa4L2_l0003o2A8:o`T92_l000002?l92@X02?lA70[o2@T:oa4L2_l92@[o
4A`:o`TB2_l92@[o00001Ol92@X00ol0003o2@T:o`000003o`T92P03o`TB
2_l0003o2A8:00Ko2@T:00Ko2A8:o`T92_l92@[o4A`:o`T95?lJ2@X2ol64
0006ojIb0?mk@@3oNd`:o`000?lJ2@[o00000_l92@X01Ol94P[o2@T:o`TB
2_l92@[o2@TD00?o2@T:00Go4A`:o`T92_l92@[o2@T:o`TB2P03o`T92P;o
4A`:00?o0000ok2c]oo^k^h0G_o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Q
h@000_ooool01?omoOgok>c/ogalO?oJf]X2on3Ph00FomCDe?o8b<Sobl_;
ooonooooo_conOkhooCil_oXiMkof/W2olFMVon^M7?oagenolekOOoSSY7o
kYbNooRY[?oo]KWooK:goonla?ok_LSonl7?ooo5d`;oolOE0oooam@5ook6
d`;oolGC00?oolGDook5e_onaMP0;OonaMP08_onaMKoo/GDook6doonaMCo
o/KCook5e?ona]?oo/GDook6dool`m;onl?@oog3d_ooa]CoolSGooo6e?ol
`]7onkg:ooo2bOoo^kkoo;BgooZ_/ooiZZgol:2Somb<Soo7Nggo^gUkokN4
Poo3WIcof/G0oo7XhoojnOCon_oioo_oo?onool4onKViP0Bol71`On/[:co
hN7QonKVi_n=SHgo0`<3olW9bOoXj>SoC4a<oe1@D?oRh^;oT92@o`d=3Ol/
;2cok>c/ong]kOlk>c_oMWIf0_o^k^h02OnHV9So6QXJonk^k_o^k^ko/k>c
on_[joo^k^ko<S8bohR8R002ono_k`0:oclo?olk>c_odM7Aono_kooShn?o
h^;Rono_komZJV[o?Cdmono_k`Kol?3`00?oVYZJo`T92On/[:`00_oalO40
0onl_;co51@Doh61P@02ooCdm003ogMgMolo?coomOGe00KomOGe01_o<c<c
ohB4Q?ofm_Kolo?codM7AolS8b?ohn?Sokno_ol30`?oe]KFomoOgomHF5So
410@ooShn?oinOWo^k^kooGemOohn?So=3@dohj>S_oinOWo`L71o`<30ooG
emOoh>3PoeUIFOl@41000_olo?`02_lb<S;oFUYJonc/k?o:b/[o;Rh^oa4A
4Oooooooo_knoc@d=?mBDU82onk^kP03oeEEEOle=CGoo_kn00Gooooo00Wo
=3@dogIfM_oooooooooool30`?okno_oo_knocHf=_nBTY800_ooool02Om0
@43oOgmoooooooo6a/Ko10@4omgMgOoVi^KoFe]Koa4A4@02ooooo`06od10
@?moOgoooooooooooonSXj?o71`L0_ooool01_lc<c?oFe]Kong]kOo:b/[o
;Rh^oa4A4@Kooooo00Co45N_oj?2i?nhdnooMjk[0_nZgol01?mfMWKo`L71
oo3`l?omoOeKooooo`07o`TB2_lA9QCo2@TDoa4L2_l94P[o2@T:o`TB2P02
o`T92P03o`TB2_lA70[o2A8:00?o2@T:0_l94PX00ol0003o4A`:o`T92P02
o`T92P09o`TB2_l92@[o2A8:o`000?l94P[o0000o`TB2_l92@[o2A8:00Co
2@T:00?o0000o`T92_l000000ol92@X00ol0003o2A8:o`T92P03o`T92P04
o`000?l92@[o2A8:o`0000;o2A8:00Ko4A`:ob<L2_lJ2@[o4BH:ob<L2_lA
70X3o`T92P06o`TB2_l92@[o4A`:oaX92_l92@[o4A`:0_l92@X00olA70[o
2@T:oa4L2P02o`T92P;o2A8:0_l92@X00olA70[o2@T:o`TB2P02o`T92P04
o`TB2_l92@[o0000o`TB2P;o2@T:00Co6Q8Do`T92_l0003o2A8:0_l92@X0
1?l94P[o0000o`T92_l00004o`T92P03o`000?l94P[o2@T:00?o2@T:00Ko
0000o`TB2_l92@[o0000o`T92_l00002o`TB2P?o2@T:0ol94PX6o`T92P03
o`TB2_l92@[o2@T:00?o2@T:00Go0000o`T92_l94P[o2@T:o`00000:o`T9
2P05o`TB2_l92@[o2@T:o`TB2_l92A@01Ol92@X01?l0003o2@T:o`T92_l9
2@X2oa4L2P07o`T92_l94P[o2A8:oa4L2_l92@[o2A8:oa4L2P0:o`T92P03
oa4L2_l92@[o6PT:00;o4A`:1?l92@X00ol0003o2A8:o`T92P04o`T92P03
o`000?lA70[o2@T:00?o2@T:00?o0000oa4L2_l92@X01?l92@X02?l94P[o
2@T:o`TB2_l92@[o0000o`T95?l0003o2@TD0_l000002?lJ4QCo2@T:oa4L
2_l92@[o4A`:o`T92_lJ2@[o2@T:0_lA70X2o`T92P03o`TB2_l92@[o2A8:
00?o2@T:0_lA70X2o`T92P03o`T95?l0003oUJ6g05oooooo00Co[jn_ol_;
booNg]koj^[Z0Oobl_8000;ok^k^01[ok>c/omcLg?mkNg_of][Jon3Ph?oQ
hN7oeMGEolS8b?o:b/[ooo_moookn?ogoo[ol_oeonSYhOo>^KCoaHZ<ok9P
I?o>JfkofGMfomn<Q_oUW9?oijNMonf/Y_ok/K3ookBioong`@;ookK300Go
okW6oonmbOoo`<_ookk9oonla`05oonmb0?ookc82?oo_L/XoonlbP0Qoonm
b_oo_LSookg:oonmb?oo_<[ookg8oonlb_oo_LSook[8oonka_oo^lWook_7
oonjb?oo^LGookO5oojf`Ooo]k[oo[NeooRa[oocZJKolJ2OonjEUooVQh_o
f7j0ol5bMOnTJ6Oo_YVAom:n]OoWg]GonOK]ooonn?ooo__oooom00Soi^KV
00Kob/[:o`000?nTY:Coj>SXobPX:?n3Ph<2onWYj@06ofm_Kol/;2coj^[Z
on_[jolj>S[oMGEe0_o/k>`00onFUYKo6ATIonc/k002onc/k008ong]kOng
]kOo51@DohR8R?o]kNgocLg=o`000?n/[:`5oo7al@03odU9BOm/K6col_;b
00Gol_;b00?okNg]oaTI6Om?Cdl01?oclo<01_n;Rh_o2`/;on7QhOoclo?o
MWIfoclo?`Oom?Cd00ko<c<coh>3PooemOGoI6AToaDE5OoDe=Con?Shom?C
dol20P;o^[Zjoo_knonLW9co7alOooclo0?ooOgm00ko`l?3oaDE5OnATI7o
oOgmomOGeol20P;o^k^koogmoOnMWIgo7alOookno_oWinOo0000olG5a@;o
oooo00KoZj^[oa4A4Ooooooof=SHo`000?ng]kL2ooooo`03okNg]ol0003o
g=cL00Gooooo00?o=3@dogIfM_ooool00oooool00oo5aLGo5QHFoi>CT`02
ooooo`09od10@?moOgooooooomWIfOl30`?o_KfmoooooonOWioo820P00;o
oooo00[o@410ogmoOooooooooooooj>SXolL71coooooonSXj?l10@7oaLG5
0_ooool00on[Zj_o4A4Aooooo`05ooooo`04oa1F[onUa>Ko^M?_ogN^j`;o
ZMco00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01_lJ4QCo2A8:o`T95?l94P[o
2@TDoaXB50go2@T:00Ko0000o`T92_l0003o2@T:o`000?l94PX3o`T92P0;
o`000?l94P[o2@T:o`T92_l94P[o2@T:o`TB2_l92@[o0000o`T92_l94PX0
0ol92@X01_l0003o2@T:oa4L2_l92@[o0000oa4L2P;o2A8:0_l00002oaX9
2P06oa4L2_lS70[o;180oa4L2_lJ2@[o4A`:1Ol92@X03Ol94P[o4A`:o`T9
2_lA70[o2@T:oa4L2_l0003o2A8:o`T92_l0003o2A8:o`000?l94PX00ol9
2@X03Ol0003o2A8:o`T92_l92@[o0000o`TB2_l92@[o0000oaXL7_lJ4QCo
0000o`T92_lJ4Q@00_l000000ol92ACo2@T:o`T92P02o`T92P03o`000?l9
4P[o000000;o2@T:00?o2A8:o`T92_l92A@01?l92@X00olA70[o2@T:o`T9
2P03o`T92P08oa4L2_lJ4QCo6Q8DoaX92_l94P[o2@T:o`TB2_l92A@4o`T9
2P0:o`TB2_l92@[o2@T:o`T92_l94P[o2@T:o`000?l92@[o0000o`TB2P?o
2@T:00?o2A8:o`T92_l000001_l92@X00ol94P[o2@T:o`T92P07o`T92P04
o`000?l92@[o2A8:oa4L2P?o2@T:00Co4A`:o`T92_lA70[o2A8:0ol92@X0
1_l0003o2@T:o`T92_l94P[o2@T:o`0000;o2@T:00Co4A`:o`T92_lA70[o
2A8:1_l92@X02?l0003o2A8:o`T92_l0003o2@T:o`TB2_l0003o2A8:1?l9
2@X00ol0003o2@T:o`T92P07o`T92P09ocdB2_oTZP3ook<0om>40?l0003o
2@T:o`000?lm4P[o2A8:00;o2@T:00Co4A`:o`T92_l92@[o2A8:1?l92@X0
0olA70[o2@T:o`T92P05o`T92P;o4A`:00?o0000ojJc`Oo^k^h0G_o^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H01?oTi>Coe=CDog]kNooJ
f]X2on3Ph00KomCDe?o8b<Sobl_;ooojoOoonoSom_ojoo7omooUi]koeKVf
okaeNOnnGFCoeVQ[omieL_oMRgoogY^:omfTTooUYicomJNUoojY[_oo[[Ko
ojjgooj^]oon/KWookFmoonh_ooo]kkookJm00;oo[Nm1?oo][d00ooo]Kgo
okJmoonf_`0_oonf_`CookW11?oo^<42oong`@;ookS201GookO1oonf`?oo
];kook>koo^_/Ooi[jcolZ^WonfTW_o/ViSoji6@onJ2Q?oJMg[obW5cojQR
H?nZOGOodk^aon_QeOooooCoookhooogm?ooood01ooWinL03ooIfMWoAdM7
o`L71ooLg=cojNWYobPX:?n6QXKoj^[ZonWYjOn3Ph?o;2`/on[Zj_o[jn_o
>SXjogEeM@02onc/k00=oiJFU_lI6AWok>c/onc/k?oCdm?oA4A4o`820_mY
JFWoi>CTong]kOn`/;3o0000ocTi>@03oc/k>`04okVi^OoalO7oBDU9ofa/
K0Kol_;b00?obl_;o`000?nATI401?oclo<01_oHf=So0000ok:b/_odm?Co
MgMgoclo?`OomOGe00Ko<c<cohB4Q?n7QhOo2@T9ol71`Oofm_H2ooShn00<
ojRXZ?la<C7o<S8boc@d=?lO7aoon_[joo_knooPh>3oB4Q8o`820_m_Kfoo
l_;b0_okno/04OnZZZ[o<C4aoc8b<_le=CGo7alOoogmoOnn_[ko0000onGU
iOono_koooooojb/[?lA4A7ooooookjn__l0003oi^KV00;ooooo00?oi>CT
o`000?o1`L401Oooool02Old=3CoMWIfooooooooooooi>CTodY:B_l30`?o
LG5aooKfmP02ooooo`09od10@?moOgoooooooooooon][Jgo<S8boc<c<olf
=SKo820P00;ooooo00[o@410ogmoOooooooooooooj>SXolL71cooooool30
`?l0003oi^KV0_ooool00on/[:co4A4Aooooo`05ooooo`04o`aE/OnTa>Ko
^M?_ogJ]jP;oZn3o00CoJVYZojj^[_oHf=Soi>CTFooVi^H00ol94P[o6Q8D
oa4L2P02o`TB2P03o`T92_l94P[o2A8:00;o2@T:00Co2A8:o`T92_l94P[o
2A8:0_l92@X00olA70[o2@T:o`T92P02o`T92P;o2A8:0ol92@X01?l0003o
2@T:oa4L2_l00002o`T92P;o2A8:0_l000000olA70[o0000o`T92P02o`T9
2P09oa4L2_l92@[o2A8:o`TB2_l92@[o2A8:o`T92_lJ2@[o000000;o2@T:
0olA70X01OlJ2@[o4BH:ob`B0?lS;ako4A`:00;o2A8:0ol92@X00olA70[o
2@T:oa4L2P02o`T92P04o`TB2_l92@[o2@T:o`TB2P[o2@T:00Co2A8:o`00
0?l92@[o2A8:0_l000001?l92@[o2A8:o`000?l00002o`TB2P06o`000?l9
2@[o2A8:o`T92_l94P[o00000ol92@X00ol0003o2A`No`TB2P03o`T92P;o
2A8:00?o0000o`TB2_l92@X01?l92@X01?lA70[o2A8:oa4_<ol94PX3o`T9
2P;o2A8:0_l92@X2o`TB2P03o`000?l94P[o000000Ko2@T:00?o4A`:o`00
0?l92@X00ol92@X3o`TB2P03o`T92_lJ71ko2@T:00[o2@T:00?o2A8:o`00
0?l92@X00_l94PX00ol92@[o8a`:o`TB2P09o`T92P03oa4L2_l92@[o2@T:
00;o2@T:00Co4A`:oaX92_l92@[o4A`:1_l92@X01?l0003o2@T:oa4L2_l0
0008o`T92P0Ko`TB2_l92@[o2@T:o`T92_lA70[o2@T:oa4L2_l92@[o6Q8D
okUW0?oCV0[o`H@0oonc0?n3;`3o2@TDok1<0?oomP3oPcP0o`T92_lJ2@[o
2@T:oa4L2_lJ2@[o2@T:oaX92_l92@[o2A8:00;o2@T:00Oo4A`:o`T92_l9
2@[o4A`:o`T92_lA70[o2A8:00;o2@T:00?o0000ojJc`OoVi^H0G_oVi^H0
1?nMWIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h01?o/k>cog=cLogalO?oJ
f]X2on3Ph00KomCDe?o8b<Soc<c<oooko_onoO_omoolooGon?oVgmWogKZh
ojEIGOo2GF?oe6=UomU`K?oHQWSof9F4omVKS?oPWICol9^NooRNYoogYZco
ljN[oo:WZooaZJcom:b_ooF_/Ooe/K;om;2a00;olk6b00?omK6booB`/Ooe
[k400ooe[k4=ooB_/P?omK2c4?od[k83ooF`/`gom:nb1_oc/K<2ooF`/`;o
m:nb0_oe[[805Ood[K7oljb`oo>[[oodZJgom:BWoo>SY?o[XIkohibFon>F
T?oRSHSohGemomUbLoo;JF[o[eiMoiUOFooL^[7ok=kEoooom_oooo[on?Wd
ooooo@06onOWi`04ojBTY?lI6AWo51@Dojb/[0;oj>SX00Ko:2PXohF5QOoY
jNWojNWYoh>3Pol/;2`2on[ZjP06ocXj>_mEEEGojn_[on_[jon@T93o6QXJ
0_o[jn/01?lk>c_o?Cdmol[:b_o/k>`2ong]k@0:ol_;bol0003oWinOol;2
`_nk^k_o0P82omSHf?oalO7oBDU9ofa/K0Kol_;b00?oZZZZo`000?o=cLd0
0ooclo<01oodm?Col?3`o`000?nCTi?omOGeogMgMolo?cl01oofm_H01?ld
=3Co@410o`820_n][Jd4ooOgm`;on?Sh00Som_Kfohn?SolP823on?ShooWi
nOlo?coo@410omGEe@KonOWi00oomoOgoi6ATOlP823oo?clomgMgOl0003o
/K6aookno_oooooo[:b/oa4A4Ooooooog=cLo`000?nd];@00_ooool00onb
/[;o0000on3Ph005ooooo`07oc@d=?mfMWKooooooooooom1@D7o@T92om_K
f`04ooooo`03od10@?moOgoooooo00?ooooo00?ooOgmoiBDU?lQ8B400_oo
ool02_m0@43oGEeMooooooooooooWIfMoadM7Oooooooh>3Po`000?nb/[82
ooooo`03ojb/[?lA4A7ooooo00Gooooo00Co35B^ojG4i_ned>koNJk/0_nW
g?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP04o`TL5?lJ4QCo2@T:o`TB2PCo
2@T:00?o2A8:o`T92_lA70X00ol92@X01?l94P[o4A`:o`000?l92@X2o`TB
2P03o`000?l92@[o2@T:00Go2@T:00Go0000o`T92_l92@[o2@T:o`000007
o`T92P04o`TB2_l92@[o2A8:o`0000;o2@T:00Go2A8:o`T92_l92@[o2@T:
o`TB2P02o`T92P03oa4L2_l92@[o;18000;o6PT:00Go4A`:oaX92_l0003o
0000oa4L2P03o`T92P09o`TB2_lA70[o4A`:o`TB2_l92@[o2A8:o`000?l9
2@[o2A8:00Co2@T:0_l000000olA70[o0000o`T92P02o`T92P06o`000?l9
2@[o0000o`TB2_l92@[o00000_l92@X2o`000007o`T92_l0003o0000o`TB
2_l0003o2@T:o`000006o`T92P03o`TB2_l0003o000000;o2@T:00Wo0000
o`TB2_l0003o0000o`T92_lA70[o2A8:ob`B0?l971@00_l92@X2o`TB2P03
o`000?l92@[o2@T:00?o2@T:00Go0000oaXB5?l0003o2@T:o`000002o`T9
2P03o`000?l92@[o000000?o2@T:00Co2A8:o`T92_l94P[o00001_l92@X2
o`TB2PCo2@T:00Oo0000o`TB2_l92@[o2@T:o`000?l92@[o;18000Co2@T:
00So2A8:o`000?l92@[o0000o`T92_l0003o4A`:o`0000[o2@T:00Co0000
o`T92_lA70[o00000_l92@X01Ol0003o2@T:o`T92_l92@[o000000Ko2@T:
00?o0000o`T92_l92@X00_l92@X03ol92ACo4A`:o`000?mG703oooH0oiEE
0?l0003odh@0oiEE0?l0003oPbl0ooof0?n3>03o0000oa4L2P06o`T92P03
oa4L2_l92@[o2@T:00;o2@T:00Wo4A`:o`T92_lA70[o2A8:o`T92_lA9Qko
2@T:o`000?nV/l40Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oo
ool07oomoOgok>c/og]kNooIfMWogmoOon7QhOoDe=CoalO7olc<c?oonooo
o_knooOoo?oiooWojMcFonNn_?nA@DCo`UUMolmMGOoEJVCoeGm`omF>O?oG
UHOogIJ@onnFW?odVJ;okinRonbPX?oZX9oojJ:PonZTX_o/YZ@00_o]ZJH2
on^ZYP;okJVV00CokZRVonfWYOo]YjGokJNU2oo/Z:LJonfYZ0_ok:RW1_oZ
ZJL2onbXY`;ojJFT00KojZBTonVSXooYXj?oj::RonRPXOo[Wj42onnJW`0@
onBJVOoMUY3og9:9omf8POoONGGofFe[olMJGOniFE[oTTa:onZm^?o[em3o
n?G^ooconoojoocoo_ooonSXj0CojNWY00CoMGEeo`000?m>CTkod];B0_oY
jNT03ooZj^[o:2PXohJ6Q_o[jn_oj^[Zoh>3Pol/;2cojn_[onc/k?lk>c_o
4Q8Bofe]KOo=cLgoD51@odM7A`02onc/k005oc8b<_n;Rh_okNg]omOGeooX
j>P00_o]kNd02olj>S[oHf=SonOWionDU9Co:2PXono_kooYjNWoA4A4ofIV
I_oUiNGok>c/00Col?3`00?o^k^ko`000?o7alL00ooalO402Oobl_;oalO7
o`000?nSXj?okno_og5aLOll?3coj^[Zoo3`l005ooGem@04oc<c<omaLG7o
820Poi:BTP;om_Kf0_ogmoL03?n^[Zkoe=CDooGemOmNGUkoDE5AooShn?oi
nOWo=CDeoi:BT_oinOWoh^;RooCdm0;onOWi00Go[jn_omCDe?ofm_KoGemO
oe9BDP02ooclo006od92@_m5ADGoh^;Ron_[jomBDU;o4A4A0_ooool01_m1
@D7oB4Q8omkNg_oMgMgoAdM7odA4A0Kooooo00Wo=3@dogIfM_oooooooooo
ocLg=onFUYKoooooonSXj?ojn_X00_ooool02Om0@43oOgmooooooooooooo
];Bdom[Jf_olo?coHF5QoeADE002ooooo`06od10@?lD51CoMWIfomkNg_mG
EeOoCDe=0_ooool01_m3@d?oATI6on?Shoo[jn_oDU9Boa4A4@Kooooo00Co
35FaojC4i_nhd^koMZgZ0_n/gol01?mfMWKo`L71oo3`l?omoOeKooooo`04
o`T95?lJ4QCo4A`:o`T92P;o2A8:00So4A`:o`T92_l92ACo4A`:o`T92_l9
4P[o2@T:oa4L2P;o2@T:00?o2A8:o`T92_lA70X00ol92@X01Ol94P[o2@T:
o`T92_l92@[o2A8:00;o2@T:00?o4A`:o`000?l92@X01Ol92@X01ol94P[o
2@T:o`000?l0003o2A8:o`T92_l94PX01ol92@X02Ol0003o4A`:oaX92_lA
70[o6PT:oa4L2_l/4P3o6PT:oa4L2P02o`T92P03o`000?l94P[o2@T:00So
2@T:00?o6PT:o`T92_l000000_l92@X00ol94P[o2@T:o`TB2P02o`T92P;o
2A8:1?l92@X00ol0003o2@T:o`T92P04o`T92P03o`000?l92ACo2A8:00;o
2@T:00?o2A8:o`T92_l92@X01_l92@X2o`TB2P05o`T92_l94P[o2@T:o`00
0?l94PX00_l92@X00ol94P[o2@T:o`TB2P03o`T92P;o2@TD00Co2A8:o`T9
2_l92@[o2A8:0_l92@X00ol94P[o2@T:o`TB2P02o`T92P06o`000?l92@[o
2@T:o`000?l92@[o00000_l92@X00ol0003o2@T:o`T92P04o`T92P05o`TB
2_l92@[o2@T:o`000?l92A@00_l92@X01ol94P[o2@T:o`T92_l92ACo0000
o`T92_l94PX00ol92@X00ol94P[o2@T:o`000005o`T92P06o`000?l92@[o
2@T:o`T92_l0003o2A8:0_l92@X00olA70[o2@T:oa4L2P04o`T92P04o`00
0?l92@[o0000o`TB2P?o2@T:00Co2A8:o`T92_l92@[o2@T:0_l94PX2o`T9
2P03oa4L2_l92@[o2@T:00;o2@T:01Wo4A`:o`T92_l971ko?A8:oooI0?nE
E@3o2@TDonBZ0?n3@@3o?A8:ok1<0?oTZP3oEa`0o`T92_l94P[o6PT:oa4L
2_l92@[o4A`:o`T92_l94P[o2@T:oaX92_l92ACo4A`:00;o2@T:00So4A`:
o`T95?lJ2@[o2A8:oaX92_lA70[o0000ok2n`Eoooooo00Co[jn_ol_;booN
g]koj^[Z0Oobl_8000;ok^k^02;ok>c/omcLg?mkNg_ofMWIomoOgooQhN7o
e=CDolK6a_o<c<cooo_oooknooogoogooOojonoMfOo``l3oQcDgok]ADoo=
EeGodfAKomAhJOoEQWOoeXb1omb>R_oZSiSol9>Mon^FVOoXV9Ooj9ZHonNL
VOoWWI[oj9jKonRQWOoXXikojJBO0ooXXih2onRQW@03onZPWOoYWicoj:6O
00Ooj:6O00Coij2NonRQWooXXIooj:6O0ooYXZ000ooZXj7ojJ:PonVRX00>
onVRX004onZSXOoYXZ3ojJ:PonVRX0?oj:6O00?oij2NonRQWooXXIl01_oX
XIl00ooWXIooiZ:OonNQW`05onNQW`;oj:6O00?oij2NonJOWOoXWYd00_oW
WI`04ooZW9cok9:KonZCVooPU9Coei2:omJ<PooJPg[og7=_omUVHoo:DeGo
_E1Cohhm??od_k_ol=OCooOdkoohoogomooooocooooWinL00ooXj>P00ooA
dM7o0@41ohF5Q@04onSXj003onWYjOlm?CgoT92@00;oj^[Z00[oSXj>od10
@?o[jn_ok>c/ode=COn1PH7oKfm_oa8B4_lZ:R[o]KFe0_o/k>`01On`/;3o
=CDeo`h>3_lA4A7oemOG00;okNg]00_oe]KFod92@_l<30co6QXJoj^[Zoo_
knooMgMgo`L71ol;2`_o6ATIoj>SX`04oo3`l003on3Ph?l20P;oV9RH00?o
lO7a00Wol_;boh>3Pol0003oc<c<ohR8R?l<30co1PH6oaTI6On@T9001Ooe
mOD01_lc<c?oQ8B4olc<c?lA4A7o^KViooKfmP;on?Sh00coQHF5oc0`<?l?
3`oo=cLgokno_ooinOWon_[jok^k^olh>3So3`l?oa8B4_oShn<2oo[jnP05
ohN7Qola<C7o3`l?ocPh>?o0`<000_olo?`01_oTi>Co@d=3o`/;2olX:2So
KFe]oa4A4@;ooooo00Koj>SXoe9BD_l?3`oo3`l?oeADE?oYjNT6ooooo`09
oc@d=?mfMWKooooooooooono_koo>SXjoa0@4?lC4a?oj>SX00;ooooo00Wo
@410ogmoOoooooooooooohZ:R_lb<S;o410@ocTi>Oo4a<@00_ooool01_mD
E5CoS8b<ogUiNOlD51Co;Rh^olC4a0;ooooo00Koi^KVodA4A?l<30co:2PX
ofe]KOlA4A46ooooo`04o`iE[_nVa^Ko]]3^ogV_kP;oZmko00CoKVi^okBd
]?oPh>3ok>c/Foo^k^h01OlA70[o6Q8Do`T95?lA70[o2A8:00;o2@T:00?o
2A8:oaXB5?l94PX00ol92@X01OlA70[o2@T:o`T92_l94P[o2@TD00;o2A8:
1?l92@X2o`TB2P0<o`000?l92@[o2A8:o`000?l94P[o4A`:o`T92_l94P[o
2@T:oa4L2_l92@[o2@TD1_l92@X01_l0003o2A8:o`TB2_l94P[o2@T:o`TB
2P;o2@T:00?o2A8:oa4L2_l92@X00_lS9PX00ol/4P3o4BH:oaX92P02o`T9
2P06o`TB2_l92@[o2A8:o`TB2_l92@[o2A8:0_l92@X01_lA70[o2@T:o`TB
2_l92@[o2A8:o`T92P;o2A8:00Ko2@T:o`TB2_l94P[o2@T:o`TB2_l92@X2
o`000008o`TB2_l92@[o0000oa4L2_l0003o2A8:o`000?l92@X2o`TB2P06
o`000?l92@[o0000o`TB2_l92@[o00000ol92@X00ol94P[o2@T:o`T92P04
o`T92P03o`000?l92@[o000000;o2@T:00Go0000o`TB2_l92@[o2@T:o`00
0002o`T92P?o2A8:0_l92@X2o`TB2P07oaXB5?l94P[o2@T:o`000?l94P[o
0000o`TB2P02o`T92P03o`TB2_lA70[o2@T:00;o2A8:0_l92@X01ol94P[o
2@T:o`TB2_l92@[o2A8:o`T92_l94PX01ol92@X01ol0003o2A8:o`000?l9
4P[o2@T:o`000?l94PX00ol92@X00ol0003o2A8:o`T92P03o`T92P05o`TB
2_l92@[o2A8:o`TB2_l000000ol92@X00ol0003o2@T:o`TB2P02o`TB2PGo
2@T:00?o2A8:o`T92_l92@X00_l94PX00ol0003o2A8:o`T92P07o`T92P0?
oa4L2_l92@[o2@T:oa4L2_l92@[o0000ocdB2_oomP3oYT40o`000?oCQ03o
Pd40oh<_0?oomP3o000000;o2@T:00Co6PT:o`T92_lJ2@[o4A`:0_l92@X0
1OlA70[o2@T:o`T92_l92@[o4A`:00Go2@T:00Go6PT:o`TB2_lA70[o0000
ok2n`@1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002onKViP0LonCT
i?oDe=CoO7alom[Jf_oOgmoohN7QomCDe?o6a/Koc<c<oookooooo_oonOom
oooonoofiMkom/_5ohTi>?n^A4Coae1<om1KD_oBKF7oe7Y_om>0N?oGPh?o
h8F>onF8TooVSI7oiI6?onJETP;oiYNC00CoiINConBIU?oTViGoiYfG0_oU
W9H2onFJU@;oiYRD00?oiINConNIUooUVYL01_oUVYL00ooSV9Goi9VFonBI
UP02onFJU`;oiY^H00?oiibIonFJUooUVYL03_oUVYL00ooWW9WoiY^HonJK
V002onFJU`;oi9VF00?ohiREonFJUooUVYL01_oUVYL6onJLV@?oiibI00?o
iY^HonNIUooVV9H00_oUUiD05?oVUYGoiiFGonF;U?oSS9Cof8b<om68P_oA
PgWoe7YaomQYH_oEFeSocE5Aok=3@_n:=3?on<6nookUhOooo?Won?oooo3o
o?olooooinOW0ooXj>P00oo4a<Co0@41om;BdP04onSXj0?ojNWY0_oZj^X3
on_[j`Cok>c/00?ojn_[onc/k?o/k>`00oo/k>`00oo]kNgoj^[Zong]k@03
ong]k@;ok^k^00?ok>c/ono_koo_knl00_o_knl00om8B4SoJf][oo3`l006
oo3`l003of1PH?lY:BWoi>CT00;olO7a00?okNg]oc@d=?m9BDT00_oemOD0
0omjNW[o?ShnooKfmP06ooKfmP06oc@d=?n4Q8ComoOgojb/[?lE5AGof=SH
0ooinOT00oojn_[on?Shoo[jnP02oo_kn`?oo?cl00?onOWiooclo?olo?`0
1?olo?`00oojn_[oo?clooclo002oogmo@06ookno_oooooooOgmoooooon/
[:co4A4A1?ooool2ooknoPSooooo00?o=3@dogIfM_ooool00oooool00ool
o?coooooooooo`02ooooo`03od10@?moOgoooooo00?ooooo00?ooOgmoooo
ooooool01Oooool00oono_koooooooooo`04ooooo`04oogmoOoooooo[:b/
oa4A4@Kooooo00Co2e:^ojC3iOnhd^ooNJk/0_n/gol01?mZJV[o[Zj^omSH
f?oTi>AKonKViP04o`TL5?l92ACo4A`:o`TB2P?o2@T:00Wo2A8:oaXB5?l9
4P[o2@T:o`TB2_lA70[o2@T:o`TB2_l000000_l94PX5o`T92P;o2A8:00Co
2@T:o`TB2_l94P[o00001?l92@X02?lA70[o2@T:oa4L2_l0003o2@T:o`TB
2_l92@[o2A8:0_l92@X00ol0003o2@T:o`TB2P02o`000003o`TB2_l0003o
2@T:00;o2@T:0_l/4P02ob<L2P08ob<V2_lJ2@[o4A`:o`000?l94P[o0000
o`TB2_l00002o`T92P08o`000?l92@[o4A`:oaX92_lA70[o0000o`TB2_l0
0002o`T92P06o`000?l94P[o0000o`000?l92@[o00000ol92@X00ol94P[o
0000o`000003o`T92P06o`000?l94P[o6PT:o`000?l92@[o2A8:0_l92@X0
1_l0003o2A8:o`T92_l92@[o2A8:o`T92P?o2A8:00co0000o`T92_l92@[o
2@T:o`TB2_l0003o2@TDo`000?l94P[o0000o`TB2_l00002o`TB2PGo2@T:
00[o2A8:o`000?l94P[o2@TDo`000?l94P[o0000o`T92_l94P[o00000_l9
4PX2o`000009o`TB2_l92@[o0000o`T92_l94P[o0000o`T92_l94P[o0000
00Co2@T:00Ko2@TDo`T92_l94P[o2@TDo`T92_l94PX4o`T92P03oa4L2_l0
003o2A8:00;o2A8:00[o0000o`T92_l92@[o0000o`T92_l94P[o0000o`T9
2_l94P[o00001_l92@X00olA70[o0000o`T92P03o`T92P06o`TB2_l92@[o
2@T:o`000?l92@[o2A8:0_l000000ol94P[o0000o`T92P08o`T92P0?o`TB
2_l92@[o2@T:o`T92_lA70[o0000om>H2_oCQ03oi:X0ooJc0?oo/`3oomT0
oaX92_l0003o2@T:00;o4A`:00?o2@T:oaXB5?l94PX00ol92@X00ol94P[o
4A`:o`T92P04o`T92P03o`TB2_lA70[o2@T:00;o2@T:00?o0000oiFQ]ooV
i^H0G_oVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h07_o/k>co
g=cLogalO?oIfMWoh>3Pon7QhOoEeMGob<S8ol_;booon_oooocooo_lo_oo
oo_on_3WooOBb_n@AT?oWSPdokY3?oo7C4GocUiCom5ZHOo=LVgocGMhomEk
QOoJP8[ogX>8on68R_oVSHooiY2AonB@T0;ohI2?00CohI6@on>CT_oSTi;o
hY:A0_oRTI000ooSShoohXj>on2?SP08on:@TP;oh8j@00CohHnAon:@T_oR
T9;ohi6C0_oTTY@@on:@TP;oi9:D00Cohi6Con:@T_oRT9;ohHnA0_oPSY07
on>AT`03on:BTooTU9Goi9BE00Coi9BE0_oUTiD00ooSTI?ohY2Bon>>T@03
on6<S`0Con:<SooQS97ofhB=omN4S?oAPh?obgagolaeK?o@Jf?odEYDole=
B_o2AD?oY3Heohln>oonblOooo;^ooonnooioooomOoooocoo`05onOWi`05
od=3@old=3CoP820oeQHF?m@D5001?oXj>P2onWYj@Koj^[Z2_o[jn/3onc/
k0;okNg]0oo^k^h2ono_k`03om7AdOo@d=3okno_00Gokno_00Wol?3`omoO
goln?Sko9RHVogalO?n2PX;o<C4aobl_;ooHf=P00_odm?@00ona/K7o7AdM
ooKfmP06ooKfmP07oc@d=?n4Q8ComoOgooOgmon2PX;o:b/[onc/k002ooSh
n0GonOWi2oojn_X2oo_kn`;oo?cl00KooOgmookno_ono_koooooojb/[?lA
4A4>ooooo`03oc@d=?mfMWKooooo00Sooooo00?o@410ogmoOoooool05?oo
ool00on/[:co4A4Aooooo`05ooooo`04o`iE[_nUa>Ko]];^ogV^j@;oZ^3o
00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01?lJ4QCo2@TDoa4L2_l92A@2o`TB
2P03o`T92_lA70[o2A8:00;o2@T:00Ko2A8:o`T92_l92@[o2A8:oaXB5?l9
2@X2o`TB2P;o2@T:00Ko2A8:o`000?l0003o2@T:o`TB2_l00003o`T92P0:
o`TB2_l92@[o2A8:o`000?l94P[o0000o`T92_l94P[o2A`No`0000;o2A8:
00?o2@T:o`TB2_l92@X00_l92@X01Ol94P[o0000o`TB2_l0003o2@T:00;o
4A`:00Ko6PT:ob<V2_l/4P3o8a`:ob`B0?lA70X2o`T92P03o`TB2_l0003o
2@T:00Go2@T:00Ko4A`:oaX92_l92@[o2@T:o`TB2_l00002o`T92P0:o`TB
2_l92@[o2A8:o`TB2_l92@[o2A8:o`T92_l0003o2A8:o`0000Go2@T:00Co
0000o`T92_l92@[o2A8:0_l000001_l94P[o2@T:o`000?l92ACo2A8:o`00
00;o2@T:00Ko2A8:o`T92_l92@[o2A`No`000?l92@X2o`TB2P;o2@T:00Go
0000o`T92_l0003o2A8:o`000005o`T92P05o`TB2_l0003o2@TDo`000?l9
71h00_l000001Ol94P[o0000o`T92_l92@[o000000Co2@T:00?o0000o`TB
2_l000000_l92@X01ol92ACo2A8:o`T92_l92@[o2A8:o`T92_l94PX01?l9
2@X02Ol94P[o0000o`T92_l0003o2@T:o`TB2_l0003o2@T:o`T95002o`00
00Oo2@T:00?o0000o`T92_l92@X00_l92@X01_l0003o2@T:o`T92_l0003o
2@T:o`T950;o2@T:00Co2A8:o`000?l92@[o2A8:1_l92@X00ol0003o2@T:
o`T92P07o`T92P0>o`TB2_l92@[o2@T:o`T92_l94P[o2@T:o`T95?lJ2@[o
diP:onBZ0?o1Q03oYVL0oiEE0?l92A@2o`TB2P03o`T92_l92ACo2@T:00;o
2@T:00?o4A`:o`T92_l92@X00ol92@X02olA70[o2@T:oa4L2_l92@[o2A8:
o`T95?l92@[o4A`:o`T92_l0003o/;k105ook^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN4000;ooooo01oooOgmonc/k?mlO7cofMWIon3Ph?oQhN7oeMGE
olO7aoo:b/[oooSoooojooolo?koo_okoochkOocf<goT5A<ohhc;_n/=SCo
_ShkolU?B_o?GUSoc6QVolYaLoo;N83od7n6omIoQOoLPhOoh8Z=on:=T?oQ
S8oogH^=00;og8b=0_oMShl2omf=SP04omf;SOoLRXcofhV;om^9R`SogHf@
0_oJRXd01?oKRhkog8b?omf=T?oMSI02omj>TA3og8b?0_oNSY42omf=T004
omb<SooKRhkofXZ=omZ:S@SogXjA1?oMSY44omj>T@04omn=TOoNS93ogH^?
om^9S@?ogHR=01;og8Z>om1oQ_o>OhGobWalolMdL?o9JVCoc5mJola?Boo3
@d3o[cPdoiH`;?nFDD[oomSBooojm_oono[on__ooocoooonool5onOWi`06
on?ShonTY:CoHf=Sog]kNon][Jgoj>SX0ooYjNT00ooZj^[ojNWYon[ZjP02
on[ZjP?ojn_[1oo/k>`6ong]k@;ok^k^1Oo_knl:oo3`l006onk^k_nSXj?o
LW9bofe]KOnMWIgok^k^0oofm_H01OoalO7o@T92ob4Q8OlK6a_od=3@00Co
moOg00?oZZZZol_;boohn?P00_ohn?P01?nPX:3oc/k>ooWinOohn?P5ooWi
n@_on_[j0_okno/2ooclo006oogmoOono_koo_knoooooon/[:co4A4A3_oo
ool00on_[joobLW9ooooo`08ooooo`03od10@?moOgoooooo01Cooooo00?o
[:b/oa4A4Oooool01Oooool01?l<E:koY/KVokWCk_mi[^/2oj_Oo`04ogIf
M_o1`L7ol?3`oogmoE_ooooo00Wo4A`:oaXB5?l92ACo6Q8Do`TB2_l92ACo
4A`:o`T95?l94PX00_l92@X01_l92ACo2@T:o`T92_l92@[o6Q8DoaXL7PCo
2@T:00?o2A8:o`T92_l92@X00_l94PX00ol92@[o2A8:o`T92P05o`T92P03
o`000?l92@[o2A8:00Co2@T:00Go0000o`TB2_l0003o2@TDo`TB2P03o`T9
2P0;o`000?l94P[o0000oa4L2_lJ2@[o4BH:ob`B0?lS70[o4A`:o`T92_lJ
2@X00ol92@X00ol0003o2A8:o`TB2P03o`T92P04o`T95?lA70[o6PT:oa4L
2P;o2@T:00Co0000oa4L2_l94P[o00000_l92@X01Ol0003o2A8:o`T92_l9
2@[o2A8:00;o2@T:00?o2A8:o`T92_l92@X00ol92@X01ol94P[o2@T:o`T9
2_l94P[o2@T:o`000?l94PX00_l92@X01_l94P[o2@T:o`T92_l94P[o2@TD
o`TB2P;o2@T:00Co2A8:o`T92_l92@[o00000_l94PX01Ol92@[o2A8:o`T9
5?l0003o2@TD00;o2@T:00Co2@TDo`TB2_l92@[o2@T:0_l94PX2o`T92P0@
o`T95?l92@[o0000oaXB5?l92@[o0000o`TB2_l92@[o2A8:o`T92_l92ACo
2A8:o`000?l94P[o2@T:o`TB2P?o2@T:00?o2A8:o`T95?l92@X01?l92@X0
1Ol94P[o2@T:o`T92_l92@[o2@TD00Go2@T:00Ko0000o`T92_l94P[o2@T:
o`000?l94PX3o`T92P04o`TB2_l92ACo2@T:o`TB2POo2@T:00?o2A8:o`T9
2_l94PX01_l92@X01Ol94P[o2@T:o`T92_l92@[o000000Go2@T:00?o0000
o`T92_l92@X00_l92@X02olA70[o2@T:o`TB2_lA70[o2@T:o`000?l92ACo
0000o`T95?l0003o2@TD00?o2@T:00?o6PT:o`T95?lA70X00ol92@X01OlJ
4QCo2@T:o`TB2_lA70[o2A8:00?o2@T:00So4A`:oaXB5?lJ4QCo2@T:o`T9
5?lA9QCo0000ok2n`Eoooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000;o
k^k^01cok>c/omcLg?mkNg_of][JomoOgooQhN7oeMGEolK6a_o:b/[oonkl
ooohoooooooonOoioocom_oon>[o[Wmeoh@e;_nR=C;oYbXXol51@?oDFUWo
cfMXomElO_oJSiCofY>GomjBU_oSTiKoiIJI0_oTV9X00ooSVI[ohYZKon>K
W002on>MW@03onBLWOoSVicoiI^L00?oi9ZK2?oSVih2on2HV`04on6IW?oR
VYgohi^Non>KWP?oi9bO00Oohi^Non6IW?oPV9_oh9RKon6IW?oSVikoi9bO
00SohYZM0ooTW9l2on>KWP?ohYZM2?oSVih4on:LWPCohi^N01[oi9VMonNL
X?oWW:3ohiRLon6EVOoRUY[ohIFIomfBU_oESY;oi9bOom65QOo?MgGofW9_
okU6@oo7AdKo[S4_oi<V8on?>S?oWf]Pooohkoooo?Soo?SioooloooonOoo
ookoonOWi`[oj>SX0ooYjNT2on_[j`?okNg]2_o^k^h7ono_k`Kol?3`2ooa
lO43oo;blP;om?Cd0oofm_H2ooOgm`03on7QhOoVi^KomoOg00GomoOg3Ooh
n?P;ooWin@;on_[j0oolo?`2ooknoP03ooooooono_kon_[j01Wooooo00?o
no_koogmoOooool05?ooool00oono_kon_[jooooo`05ooooo`04oa1G[onS
`^Co^=?_ogN^j`;oZ]oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h02ol971Co
2@TDo`TB2_l92ACo2A8:o`T92_l92ACo4A`:o`T92_l94P[o4A`:00?o2A8:
00Go4A`:o`T92_lJ4QCo2A8:oa4L2P02o`T92P05o`TB2_l92@[o2@T:o`T9
2_l94PX00ol92@X00ol94P[o2@T:oa4L2P05o`T92P03o`000?l94P[o2A8:
00?o2@T:00Go2A8:o`T92_l92@[o0000o`TB2P05o`T92P03ob<L2_l/4P3o
6PT:00?o8a`:00?o4A`:o`TB2_l94PX00_l94PX02Ol92@[o0000o`TB2_l9
2@[o2A8:oaXB5?l94P[o4A`:o`T95002oa4L2PCo2@T:00_o2A8:o`T92_l9
2@[o2@T:o`000?l94P[o2@T:o`000?l92@[o0000o`TB2P02o`T92P03o`TB
2_l0003o000000;o000000Oo2@T:o`000?l94P[o0000oa4L2_l0003o4A`:
00?o2@T:00Go2@TDo`TB2_l92@[o2A8:o`000004o`T92P0>o`000?l94P[o
0000o`TB2_l92@[o0000o`T92_lA70[o2@T:o`TB2_l92@[o2A8:o`T92_l9
4PX3o`T92P0?o`000?l92@[o0000o`TB2_l92@[o0000o`TB2_l92@[o0000
o`TB2_l0003o2@TDo`T92_l94P[o000000?o2A8:00Go2@TDoa4V5?l92@[o
2A8:o`T92P02o`T950Co2@T:00?o0000o`T92_l92@X01ol92@X00ol94P[o
2@T:o`T92P02o`T92P03o`000?l92@[o2@T:00Go2@T:00Go2A8:o`T92_lA
70[o2@T:o`T95002o`T92P;o2A8:1?l92@X00ol0003o2A8:o`T92P06o`T9
2P03o`TB2_l92@[o2@T:00Oo2@T:00Ko4A`:o`T92_l92ACo4A`:o`T92_lA
70X5o`T92P05oa4L2_l92@[o2@T:oa4L2_l92@X00_lA70X00ol92@[o6PT:
o`TB2P02oa4L2P08o`TB2_l92ACo4A`:o`T92_l94P[o2@T:o`000?nVZZeO
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002onKViP0QonCTi?oDe=Co
MgMgom[Jf_oPh>3ohN7QomCDe?o7alOoc<c<ooodoooolocoookoooWooOo]
nNgoo_c_ombl/Om^;BOoSRXXoi`T9Onf>3WobTmAomU`M?oWSY3ofiFGomJH
VOoZYJSokJNYonn[[?o^[:gokJ^/onb/[?oZ[Jcojjj]00;ok[:a00?okk:a
onja/?o`/;000oo_[jl8onj`/@04on^][_o/[Zook:j_onf_/0;ok[2a0oo_
/K801oo^/;7ok:j_on^][_o[[Jkok:j_onj`/Oo_/K802?o][k03onna/P;o
k[2a0oo][k08onj`/@CokK6a1?o^/;401Oo_[k3ol[:coo:b/oo^[ZookZb^
00;okjf_01;ojj^/ooJf]ooNVY_oeh^;oonWY_o5Fe_o_DI8oke1@onF823o
VS/gofLS6_oO_K7ooo[^oocim?ooo_ooooSooooioooooOl9onKViPGoinOW
00?oj>SXonWYjOoZj^X01OoZj^X7on_[j`?ok>c/0oo]kNd00oo_knook^k^
oo3`l002oo3`l0;olO7a2oobl_84oo?cl`Com?Cd2_oemOD3ooKfmP;omoOg
0_oinOT01?ohn?Son_[joo[jn_ojn_X2oo_kn`goo?cl0_omoOd00oono_ko
ooooooooo`0kooooo`04oa1F[onUa>Ko^M?_ogN^j`;oZMco00CoJVYZojj^
[_oHf=Soi>CTFooVi^H01OlJ4QCo4BHDoaXB5?l92ACo4A`:00;o2A8:00?o
2@T:oaXB5?l92@X00_l92@X01?l94P[o2@T:o`T92_l94PX2o`T92P04o`TB
2_l92@[o2@T:o`TB2P?o2@T:00Oo4A`:o`TB2_l92@[o2A8:o`000?l94P[o
2@T:00;o2A8:1Ol92@X2o`TB2P;o2@T:0_l94PX6o`T92P09o`TB2_l92@[o
2@T:oa4L2_l92@[o8a`:oaX92_l/4P3o6PT:00?o2@T:00?o2A8:o`000?l9
2@X00_l92@X00ol94P[o0000o`T92P02o`T92P0Co`TB2_l92@[o2@T:o`TB
2_l92@[o2A8:o`000?l92@[o2A8:o`T92_l94P[o0000o`T92_l94P[o0000
o`T92_l0003o4A`:o`000006o`T92P06o`000?l92@[o2@T:o`T92_l94P[o
00001?l92@X00ol94P[o2@T:o`T92P02o`TB2P?o2@T:00[o2@TDo`000?l9
2@[o2A8:o`T92_l0003o2A8:o`000?l92@[o2A8:0ol92@X3o`TB2P07o`T9
2_l94P[o0000o`TB2_l0003o2@T:o`000003o`T92P07o`000?l92@[o2@T:
o`TB2_l0003o2@T:o`TB2P03o`T95003o`TL7_l92ACo2A8:00Co2A8:0_l9
2@X00ol94P[o2@T:o`T92P05o`T92P04o`000?l92@[o2A8:o`0000;o2@T:
1?l94PX02?l92@[o4A`:oa4L2_lA70[o2@TDo`T92_lA70[o2A8:0ol92@X2
o`TB2PCo2@T:00?o2A8:o`T92_l92@X01_l92@X01?l94P[o0000o`T92_l9
4PX9o`T92P04oa4L2_l94P[o2@T:o`TB2P;o2@T:00So6PT:o`T92_l92@[o
4A`:o`T92_lA70[o2@T:oa4L2P?o2@TD00go2A8:o`T92_lA70[o2@T:oaX9
2_l92@[o4A`:o`T92_lA70[o6Q8Do`TB2_l0003oY[?105ooi^KV00CoWIfM
okNg]oo8b<Sodm?C0OoJf]X000;ok^k^00Cok>c/omcLg?mfMWKofMWI0_oO
gml06ooDe=CoalO7ol[:b_oomOoooo3fooooooohoogokooeookom_oon_7o
Y75]ogHR8?n>92KoWBT/ok8o@_oPO7kooZZZoo2_[OoY[jgoj:j]onZ`[oo[
/k;ojkFconZd/_oW];7oi[FaonFe/@04onNg/`;oikJb0_oX]K88onNe]003
onFc/_oV];?oi[Bc00;oikFd0_oX][D2onVg]P07onRf]OoV];?oiK>bonFc
/_oV];?oj;JeonVg]P08onNe]0Coj;Je3?oW]K@6onJf]0;oikFd00?oi[Bc
onRf]OoZ]kH00_oW];<05?oY][Goj;FdonNa[ooSZJOok:^Yoo:VY_o]UICo
hGQlokM6B_nI9RWoQ1`MofdO6on[Ng7oooWZooOik?oloo_omoGhooohoooo
mooooogo2OoUiND5onKViP;oj>SX1_oZj^X:on_[j`?ok>c/0_o]kNd3onk^
kP[okno_0oo`l?03oo7al@03oo;bl_oalO7ol_;b00;ol_;b0_oclo<8ooCd
m0?omOGe0_ofm_H3ooShn0?on_[j0_okno/=ooclo0;ooOgm00?oo_knoooo
ooooool0>oooool01?l<EK7oY<CVokWCkomf[NX2oj_Po`04ofi^K_nd];Co
h>3Ponc/k5_ok^k^00Wo4BHDo`T95?lJ4QCo2@T:oa4L2_l92@[o4A`:o`TB
2_l92@X00_lA70X01ol92@[o4A`:oaXB5?l92ACo2@T:oa4L2_l94PX00ol9
2@X01_lA70[o2@T:oa4L2_l92@[o2A8:o`T92P;o2A8:00Go2@T:o`TB2_l9
4P[o2@T:o`TB2P02o`T92P0:o`TB2_l92@[o2@T:o`TB2_l0003o2A8:oaX9
2_l92@[o2A8:oa4L2P;o2@T:00?o4A`:o`TB2_l000000_l92@X02OlJ2@[o
4A`:ob`B0?lS70[o;180oaX92_lA70[o2A8:o`T92P02o`TB2P;o2@T:00Co
2A8:o`T92_l94P[o2A8:0_l92@X00ol94P[o2@T:o`T92P07o`T92P04o`TB
2_l92@[o2@T:o`0000;o2@T:00?o0000o`T92_l92@X00_l92@X01?l0003o
2A8:o`T92_l94PX2o`T92P04o`000?l94P[o0000o`TB2P?o2@T:00Ko2A8:
o`T92_l92ACo2@T:o`T95?l00003o`T92P03o`TB2_l0003o2@T:00?o2@T:
00?o2A8:o`T92_l971@01Ol92@X00ol94P[o2@T:o`TB2P02o`T92P04o`TB
2_l92@[o2A8:o`0000Co2@T:00?o2A8:o`000?l92@X00_l94PX02?lJ4QCo
0000oa4V5?lA9QCo;1`Doa4V5?l92ACo6Q8D1?l94PX00ol92ACo2@T:o`T9
2P03o`T92P03oa4L2_l92@[o4A`:00;o2@T:00[o2A8:o`T92_lJ4QCo2@T:
oa4L2_l92@[o6Q8Doa4L2_lJ4QCo4BHN0_lJ9Q@00olA9QCo8blNoaXV5003
oaXV50;o4BHD00So4A`:oaXB5?l94P[o2@T:oaXB5?l94P[o2@TDoa4L2P;o
2A8:0_l92@X00ol94P[o2@T:o`T92P09o`T92P03oa4L2_l92@[o2@T:00?o
2@T:00?o4A`:o`T92_lA70X01_l92@X01ol94P[o4A`:oaX92_l92@[o4A`:
o`T92_lA70X00ol92@X02Ol94P[o2@T:o`T92_lA70[o2A8:oaXB5?l92ACo
0000ol77c01Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002ooooo`0O
oogmoOo]kNgoLW9bomOGeooOgmooh>3Pom;Bd_o7alOob/[:oooemooonogo
oOgmooSoo_ogoogoo?okooolm_ooh=goWE]LofPB4on17AooYCi1ol9WI_oW
UY?ohIfJonFZY_oV[jcoik:^on^f/_oZ]k?oj;NbonJg/@06onBg/@Coi[Na
02ooi[JbonBg/_oV][;oi;NbonJf/_oT]k;oi[JbonBg/_oU]K7ohkJaonFe
/OoS][7oi[JbonBg/_oW]k?oiKRconNg/ooT]k;oiKFaon>f/OoU]K7ohkJa
onJf/_oU^;?oi[JbonBg/_oV][;oi;NbonJf/_oT]k;oi[JbonBg/_oV][;o
i;NbonJf/_oT]k;oi[JbonBg/_oV][;oi;NbonJf/_oT]k;oi[JbonBg/_oV
][;oi;NbonJf/P02onBg/P03on>h/_oT]k;ohkRb00Coi;Nb01Woi;B`onNg
/ooW]k?oiKFaonJe/OoW][;oiKB`onB_ZooY[Z[ogi^Hoone/_oXU9;oa6AV
ohdX;?n68BGoM1hOoiIIE_ooj^7oooc`ooSom_ohoogon?SjooohoooolOko
oogo00Woi^KV0_oWinL3onSXj0;ojNWY0ooZj^X3on_[j`Ook>c/1_o]kNd0
0oo^k^kokno_oo3`l004oo3`l0_olO7a0oobl_82oo?cl`?om?Cd2_oemOD5
ooKfmP;omoOg00?om_KfooOgmoogmoL00oogmoL;ooShn0;onOWi0ookno/2
oogmoA7oo_kn:_ooool01?l<E:koYLCVokG@k_mi[^`2ojOLo`04ogIfM_o1
`L7ol?3`oogmoE_ooooo00Ko4BHDoaXB5?l94P[o2@T:oa4V5?l92@X2o`TB
2P?o2@T:00?o4A`:o`T92_l94PX00_lA70X2o`T92P04o`TB2_l92@[o2A8:
o`TB2PCo2@T:00Ko4A`:o`TB2_l92@[o2@T:o`TB2_l00002o`TB2P;o2@T:
00?o0000o`TB2_l92@X02?l92@X2o`TB2P05o`T92_lA70[o2@T:o`T92_lA
70X00_lJ2@X01Ol/4P3o8a`:ob`B0?lA70[o2A8:00Go2@T:00Ko0000o`T9
2_l92@[o0000o`TB2_l92@X2o`TB2P;o2@T:00Co2A8:o`T92_l92@[o2A8:
0ol92@X00ol94P[o2@T:oa4L2P02o`T92P?o2A8:0_l92@X01OlA70[o0000
o`T92_l0003o2A8:00Go2@T:00Go0000o`TB2_l94P[o2@TDo`TB2P02o`T9
2P04o`000?l92@[o2@T:o`TB2POo2@T:00?o0000o`TB2_l92A@00_l92@X0
1?l94P[o2@T:o`T92_l92@X3o`TB2P04o`T92_l0003o2A8:o`0000Wo2@T:
00Wo0000oaXB5?lA;c?o8blYo`TV:OlS@Cgo2@T:o`T95?l94PX00_l92A@0
4_l94P[o8blYo`TL7_l94P[o2@T:o`TB2_l0003o2@TDo`T92_l94P[o2@T:
oa4V5?lA70[o6Q8Doa4V5?l971Co4BHDoaXB50Co4BHD00?o8bH:oaXL7_l/
>2T00_lS;ah2ob<_:@03oaXV5?lA9Qko8blY00;o8blN00Co6RHDob<_7_l/
>2Wo6RHD0_lS;ah01Ol971Co6Q8Doa4L2_l92ACo4A`:00;o2A8:1?l92@X0
1Ol94P[o2@T:o`T92_l92@[o2A8:00?o2@T:00Go6Q8Do`T92_lA70[o2@T:
oa4L2P03o`T92P03oa4L2_l94P[o2@T:00?o2@T:00?o6Q8Do`T92_lA70X0
0_l92@X00olA70[o2@T:oa4L2P02o`TB2P08o`T92_lS70[o2@T:oaX92_l9
2ACo8bH:o`T95?nVZZeOooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0002
onk^kP04onc/k?oOgmooLG5aolo?c`;ogMgM01SodM7AolC4a?o8b<Sooogi
ooonnoolo?[onOgloo_oooono_ool^SYooogn?ook^ooKC4aog0V9On;?3So
Xe9?onVKUooRViGoh9fGon2QW?oPYJ7oiJZVonJ/Z?oT[JP2on:]Y`03on2^
YooR/:Woh[2Y00;oh[2Y1?oU/:X0;ooU/:cohk2/onF`[?oS/:coiK2/on>`
[?oU/:cohk2/onB_ZooR[j_oi:n[on>`[?oU/:cohk2/onF`[?oS/:coiK2/
on>`[?oT[j_ohZn[onB_ZooR[j_oiK2/on>`[?oU/:cohk2/onF`[?oS/:co
iK2/on>`[?oU/:cohk2/onB_ZooR[j_oi:n[on:_ZooU/:cohk2/onF`[?oS
/:coiK2/on>`[?oU/:cohk2/onF`[?oS/:coiK2/00;ohk2/00?oh[6/on>`
[?oR/J`01?oS/:`06OoT[j_oiK2/onF`[?oS[Z[oi:fZonF^ZooQZZOogZ>O
on2JV?oZX9goeHb6ol1eL?n@@3ooQS@fof/K7_me<C;oon[Woooil_ogoO7o
m?ojonolmOonoooooo?mooohoooooOl02OoUiND5onKViP03onSXj?oWinOo
jNWY00GojNWY2_oZj^X3on_[j`03onc/k?o]kNgok^k^00;ok^k^2_o_knl3
oo3`l0?olO7a0_obl_83oo?cl`;om?Cd2?oemOD5ooKfmP;on?Sh00?omoOg
ooWinOoinOT00ooinOT;oo[jnP;ono_k0oolo?`2oogmoA7oo_kn:_ooool0
1?l<EK7oY<CVokSBk_mf[NX2ojcOo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^
00[o2A8:o`T95?l92@[o2A8:oaXL7_l92ACo4A`:o`T95?l92@[o4A`:0_l9
2A@00olJ4QCo2A8:o`T92P02o`T92P03o`TB2_l92@[o2A8:00So2@T:00Co
2A8:o`T92_l92@[o2A8:0_l92@X00ol94P[o2@T:o`TB2P0Bo`T92P03ob`B
0?lS70[o;18000;o6PT:00?o2A8:o`000?l92@X02ol92@X2o`000004o`T9
2_l0003o2A8:o`0000?o2@T:00?o0000o`T95?l000000_l92@X3o`000007
o`T92_l0003o0000o`TB2_l0003o2@T:o`T95002o`TB2P09o`000?l94P[o
2@T:o`T92_l94P[o2@TDo`TB2_l92ACo2A8:00?o2@T:00Co2A8:o`000?l9
2@[o00000ol92@X01_l94P[o0000o`T92_l92@[o2@TDo`TB2P;o2@T:00Wo
0000o`TB2_l92@[o6Q8Do`T92_l0003o2A8:o`T92_l000000_l92@X01_l0
003o2@T:o`000?l94P[o2@T:o`0000?o2@T:00Go0000ob=1?Old;c?oAUEB
o`TL7P02o`T95005o`TL5?lJ4QCo2@TDo`000?lm;cd00_l92A@01_l94P[o
2@T:o`T92_l0003o2A8:oaXB50?o4BHD00Co2A8:oaXB5?lA70[o2@TD0_lA
70X04_l94P[o6Q8DoaXB5?l971ko6RHDo`TL7_lA70[o6Q8Dob`h:OlS;bWo
6RHDoaXL7_lS;ako;2HDoa4V7_lS;ako6Q`NoaXV50;o8blN00[o6RHDob`V
5?lJ71ko6RHDob<_7_lA70[o6Q8DoaXV5?l92ACo4A`:0_l92@X00olA70[o
2@T:o`T92P02o`T92P05o`TB2_l92@[o2@T:o`T92_lA70X01ol92@X01?lJ
2@[o2@T:o`T92_lA70X4o`T92P;o4A`:00Go2@T:oa4L2_l92@[o2@T:oaX9
2P04o`T92P;o6Q8D00?o0000ok2c]oo^k^h0G_o^k^h01?nSXj?o_Kfmolo?
cooJf]X1on7Qh@000_oVi^H07_oUiNGofMWIogQhN?no_koof=SHom[Jf_o<
c<co`L71olG5aOokooSon_oiookooOoooooomoCkooolooohkOGooo[moooe
m_oom??oO4]6oeDH4on9A3goPCH`ol=fL?oAPgoodHN4om><R?oITXkog9NB
ombIT`;ofYVC1OoJVi@4ombKU@0_ombKUooKW9Oog9^Gom^LUooLViOofibG
ombKUooKW9Oog9^Gom^LUooLViOofibGombKUooKW9Oog9^Gom^LUooLViOo
fibGombKUooKW9Oog9^Gom^LUooLViOofibGombKUooKW9Oog9^Gom^LUooL
ViOofibGombKUooKW9OofiZFomZKU_oKVYKofY^FombKUooKW9Oog9^Gom^L
UooLViOofibGombKUooKW9Oog9^Gom^LUooLViL00_oKW9L3omVLU`CofibG
01WofiZFombKUooKVYKofYVEombHUOoMVIKof9BAom><R?oBPgooehR3ojeT
G_nFDDcoNCDbodh>3_n?DE;ooo3aooofm?oonOGonOojonoon?ocoogoo?oo
ooS[l_oonOoooogo00Woi>CT1OoUiND2onOWi`KojNWY2_oZj^X4on_[j`Co
k>c/2_o]kNd6onk^kP03oo3`l?o_knoolO7a00ColO7a2?obl_83oo?cl`;o
m?Cd0_oemOD01?ofm_KomoOgooOgmoogmoL2ooShn0_onOWi0_ojn_X3oo_k
n`;oo?cl4?omoOd3ooknoRSooooo00Co3UF^ojK6i_nfd>koNJo^0_n[g_l0
1?mZJV[o[Zj^omSHf?oTi>AKonKViP03oaXB5?lJ9QCo2A8:00Co2A8:00So
2@T:oa4L2_l92@[o2@T:o`T95?l92@[o2@TDoa4L2P;o2A8:00?o6PT:oa4L
2_l000000_l94PX02Ol92@[o2A8:o`T92_l92@[o2A8:o`T92_l94P[o2@T:
o`TB2P03o`T92P03o`TB2_l0003o2@T:00;o2@T:00Wo4A`:o`000?l94P[o
2A8:o`T92_lJ2@[o2@T:oa4V7_lA70X00ol92@X01ol94P[o2@T:o`T92_lA
70[o6PT:o`T92_lA70X01?l92@X01_lA70[o2@T:oa4L2_l94P[o2@T:oa4L
2P;o2@T:0_lA70X5o`T92P03o`000?l92@[o2@T:00;o2@T:00Go0000o`T9
2_l0003o2@T:o`TB2P03o`T92P03o`TB2_l0003o2@T:00;o2@T:00Ko0000
o`TB2_l0003o0000o`TB2_l00003o`T92P0:o`TB2_l971ko2A8:o`T95?l9
4P[o2@T:o`TB2_l0003o2@T:o`T950;o2A8:00Co2@T:o`TB2_l94P[o0000
1ol92@X00ol94P[o2@T:o`T92P03o`T92P0:o`000?l94P[o2@T:o`TB2_l0
003o4A`:o`000?l94P[o2@T:o`TB2P;o2@T:00Ko2A8:o`T92_l92@[o8blN
ob<_:Ol/EE`2o`T92P;o2@TD0_l92@X00ol92ACo=5Dmo`TB2P05o`T92P;o
2A8:1_l92@X00ol94P[o0000o`TB2P02o`T92P;o2A8:00Oo4BHDoa4L2_lA
70[o6RHDoa4V2_lJ71ko4BHD00?o6RHD00So;3PYoaXV5?lJ71ko6Q`NoaXV
5?l/71Co8blNoaXV50?o8blN00[o6Q`NoaXV5?lJ9QCo6RHDoaXB5?lS70[o
4A`:o`T92_l94P[o4A`:2Ol92@X00ol94P[o2@T:o`TB2P0:o`T92P03oaX9
2_l92@[o6PT:00?o2@T:00Wo0000o`TB2_l92@[o4A`:o`T92_lA70[o2@T:
o`000?n`/kL0GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h0
8Oo]kNgoiNGUoi6ATOnTY:Cod];BomCDe?o2`/;o^;Rhol30`?oaooKol_oe
oocooOoooOooooKoooohoooonOooooGmooodm_oon_KoooG]oiicJ_mG7A;o
LbdUoh8_:onE>c[o[eEDokAJF_nkHF7o_fMVol1ZJOo0K6[o_fi[ol1_K003
oke/J@03oki]J_o0K6[o`6aZ00;o`Fe[033o`6aZoki]J_o0K6[o_VeZol1/
J_nnKF[o`6aZoki]J_o1KF_o_fi[ol5]JonoKV_o`Fe[okm^Joo1KF_o_VeZ
ol1/J_noKV_o`Fe[okm^Joo1KF_o_fi[ol5]JonnKF[o`Fe[okm^Joo1KF_o
_fi[ol5]JonoKV_o`Fe[okm^JonoJfWo_FaYokm[JOnnKF[o`6aZoki]J_o1
KF_o_fi[ol1/J_nnKF[o`6aZoki]J_o0K6[o_VeZol1/J_nnKFX4oke^JPCo
_VeZ01[o_f]Yol1/J_noJfWo_VYXol5[J_o3KFco_FMVokQPG_n]DTooSCPc
ogL^9omE5PooHbhXojAdL?ook^ooonoaooKQh?ooo__on?omon_nn?oeoooo
loWioookoooon_ooookoon3Ph0[ohN7Q0ooRh^800ooTi>Cohn?SonGUi@02
onGUi@[oi^KV1ooWinL6onSXj0_ojNWY0ooZj^X00oo/k>cojn_[ong]k@02
ong]k@[ok^k^1oo_knl6oo3`l0SolO7a0oobl_82oo?cl`?omOGe0_ogmoL3
ooShn0[onOWi0oojn_X3ooclo0;oo_kn9_ooool01?l;DZkoY<?UokSBkomi
[^`2ojcOo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Co4BHDo`TB2_l94P[o
2@TD0ol94PX02Ol92@[o4A`:o`TB2_lA70[o2@T:o`TB2_l92@[o2A8:oa4L
2P02o`0000;o2A8:00Go0000o`TB2_l92@[o4A`:o`TB2P02o`0000;o2@T:
00Ko0000o`T92_l94P[o2A8:o`T92_l00002o`TB2P0:o`T92_l94P[o2A8:
o`TB2_l0003o2@T:o`TB2_lA70[o2@T:o`0000Go2A8:0_l92@X01OlA70[o
0000o`000?lA70[o2A8:00?o2@T:0_lA70X01_lJ2@[o;180o`T92_lA70[o
6PT:oa4L2P;o6PT:00So4A`:o`T92_l94P[o0000o`TB2_l0003o2@T:o`TB
2P;o000000Co2A8:o`000?l94P[o00000_l92@X01ol971Co0000o`TB2_l0
003o2@T:o`TB2_l000000_l92@X01ol94P[o0000o`TB2_l0003o2@T:o`TB
2_l92A@00_l971@01Ol92ACo2@T:o`000?l94P[o4A`:00;o2@T:00Go2A8:
o`000?l0003o2A8:o`000002o`T92P04o`TB2_l92@[o2@T:o`TB2PKo2@T:
0_l94PX2o`00000>o`T92_l0003o2@T:o`T92_l0003o2A8:o`000?l92@[o
0000o`T92_l94P[o0000o`T92_l94PX2o`T95004o`TL5?l94P[o2A8:o`T9
50?o2A8:00?o2@TDob=1?Ol94PX01?l92@X01Ol94P[o2@T:o`T92_lA9P[o
4A`:00Co2@T:00?o4A`:o`TB2_lJ2@X00_l92@X00ol94P[o2@T:o`TB2P02
o`T92P;o4A`:00Ko2A8:oa4V5?lJ9QCo4BHDoaXV5?lA9Qh3oaXV5003ob<_
7_lS9P[o6RHD00?o8blN00?o8blYoa4V7_lJ71h00olJ9Q@01OlJ4QCo4A`:
oa4L2_lJ4QCo4A`:00;o2@T:00?o4A`:o`T92_l92@X00_l92@X00ol94P[o
4A`:o`T92P02o`T92P03oa4L2_l92@[o2@T:00Go2@T:00?o2A8:o`T92_l9
2@X00_l92@X03?lA70[o2A8:o`T92_lA70[o2@T:oa4L2_l92@[o4A`:o`T9
2_lA70[o0000ol77c5ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000?o
oooo00Gon_[jom?Cdon7QhOo[:b/okbl_002ojj^[P0JokJf]_oYoo3olOof
oo_oo?oon_koooSoooo/oooonOoooo_oooonoooon_Cooo_aoooci_oolNKo
ol[2ojA?B_n59RCoL0h?ogLC5Omm6acoPR8SohDU9_n4:BSoQR/ZohH/:on4
:RT3ohD[:P;oQb`[0_n:;2`8ohL/:`CoR2d/1_n7;2/4ohP];0;oQb`[2?n8
;B`01?n5:RWoQR/ZohH[:_n6:bX2ohL/:`;oR2d/1on7;2/2ohH/:`03ohD]
:on6;2_oQR`[00;oQR`[0_n7;2/06_n5:RWoQR/ZohPZ:_n8:R[oRbd]ohd_
;on7:BWoP28Pog`J6Omi81coWUE>oooJd_ool^coonWTooodm?oom_Sooo[j
ooOcl?oeoocol_ooonglnOogoooooogooo[am_ooo_oofm_K2?oLg=`5omgM
g@;ogmoO1_oQhN4:on;RhP?ohn?S0_oTi>@3onGUi@[oi^KV1_oWinL2onSX
j0GojNWY2ooZj^X2on_[j`;ok>c/00CokNg]onk^k_o^k^kok^k^2_o_knl5
oo3`l0?olO7a1Oobl_88oo?cl`;om?Cd0ooemOD3ooKfmP;omoOg0oohn?P:
ooWin@?on_[j0_olo?`3ooknoQ7ooooo00Co3UF^ojG4i_nfd^koNJkY0_nZ
h?l01?mfMWKo`L71oo3`l?omoOeKooooo`06oaXB5?l94P[o6Q8DoaXB5?l9
2ACo2A8:0_l92@X01_l94P[o2@TDo`T92_lA70[o2@TDoa4L2PCo2@T:00?o
0000o`TB2_l92@X01Ol92@X00olA70[o2A8:o`TB2P04o`T92P07o`000?lA
70[o2@T:o`T92_l0003o2A8:o`T92P02o`000005o`TB2_lJ2@[o2A8:o`00
0?lA70X00ol92@X01?l0003o2@T:o`T92_lA70X2o`T92P03o`000?l94P[o
2A8:00Co2@T:0_lJ2@X02Ol92@[o;180o`TB2_lJ2@[o;180ob<V2_lA70[o
2@T:oa4L2P04o`T92P09o`000?l94P[o2@T:o`TB2_l0003o2@T:o`000?l9
4P[o2@T:00;o000000_o2@T:o`000?l92@[o2A8:o`000?l92@[o2A8:o`T9
2_l0003o2@T:o`000002o`T92P06o`TB2_lJ4QCoCeiVo`TL7_l92ACo2A8:
0_l92@X00ol94P[o2@T:o`T92P06o`T92P03o`TB2_l92@[o4BHD00?o2@T:
00Co0000o`TB2_l92@[o2A8:1Ol92@X01?l94P[o2@T:oa4L2_l00003o`T9
2P05o`TB2_l0003o2A8:o`T92_l000000_l92@X00ol0003o2A8:o`T92P02
o`T92P05o`T95?l92@[o2@T:o`T95?l92@X00_l92A@03ol94P[o2@TDo`T9
5?l92@[o0000o`TB2_lA9QCo4A`:o`T92_lA70[o4BHNo`T92_lA70[o2@T:
oa4L2P02o`T92P09oa4L2_l92@[o4A`:oaX92_l92@[o4A`:o`000?l92@[o
6PT:00;o4A`:00Ko6Q8Doa4L2_lJ2@[o2@TDoa4L2_lJ4Q@2oaXV5003oaXB
5?lJ9QCo8blN00;o8blN00[o;2HDob<_7_lS;ako6Q`Nob`L5?lJ71ko4BH:
ob<V2_lJ9QCo4BHD0_lA70X00ol92ACo2@T:o`T92P0<o`T92P04oa4L2_l9
2@[o2@T:oa4L2PKo2@T:00?o2A8:o`T92_l92@X00ol92@X01?lA70[o2@T:
o`000?nVZZeOooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0003onk^kP0;
onc/k?oShn?oZj^[ogEeMOn0P83oShn?oibLW?nUYJGo[:b/ok6a/Ong]kL0
3_nk^k/3okbl_0?o_Kfm00?o_[jnokfm_Onn_[h00_nn_[h2okno_`_o`<30
0_o1`L42ol;2`P04ol?3`oo4a<Coa<C4olC4a0[oaLG51Oo6a/H2olO7a`03
olK6a_o7alOoalO700?oalO73Oo8b<P00oo9bLWob/[:ol[:bP0?ol_;b`?o
c<c<00?ocLg=olc<c?o<c<`00_o=cLd;olk>cP;oclo?0oo@d=000ooAdM7o
d];Bom?Cd`02om?Cd`?oe=CD1ooEeMD6omKFeP;oemOG1OoHf=P;omWIf@?o
f][J0_oKfm/3omcLg0[ogMgM1OoNg]h2omoOg`03omkNg_oOgmoogmoO00?o
gmoO2?oPh>03on7Qh@;oh^;R0_oTi>@00ooUiNGoinOWonOWi`03onSXj0[o
jNWY0ooZj^X3onc/k0;ok^k^2oo_knl2oo3`l0?olO7a00?ol_;boo7alOob
l_800_obl_83oo?cl`kom?Cd00Co2e>]ojK6i_nidnkoNJk[0_n[gol01?m^
KVko];Bdon3Ph?o/k>aKonk^kP06oaXB5?l971Co4BHDo`T92_lJ4QCo2A8:
0_lA70X02?l92ACo4A`:o`T95?lA70[o2@T:o`TB2_l92@[o2A8:2ol92@X0
1?l0003o2A8:o`000?l94PX3o`T92P03o`000?l94P[o2@T:00?o2@T:00?o
0000o`TB2_l92@X00_l92@X02?lA70[o2@T:oa4L2_lA70[o0000o`T92_l9
4P[o4A`:0_l92@X00olA70[o2@T:o`T92P05o`T92P08oa4L2_l/4P3o4A`:
ob<L2_l94P[o4A`:oaX92_lA70X3o`T92P05o`000?l94P[o0000o`TB2_l9
2@X00ol00002o`T92P03o`000?l92@[o000000;o2A8:00Go0000o`T92_l0
003o0000o`T92P03o`000005o`T92_l94P[o0000o`T92_l000000_lJ4Q@0
0om?Ieco2@TDo`TB2P02o`TB2P03o`000?l92@[o2@T:00?o2@T:0_l94PX2
o`T92P03o`000?l92@[o=2lN00;o2@T:00_o2A8:o`T92_l92@[o2A8:o`00
0?l94P[o2@T:o`000?l92ACo2A8:o`T92P02o`0000;o2@T:00Co4A`:o`00
0?l92@[o2@T:0_l000000ol94P[o0000o`T92P05o`T92P04o`TB2_l92@[o
2A8:o`T950;o2A8:00Co2@T:o`T95?lJ4QCo4BHD0_l92@X01Ol94P[o8blN
o`T92_l94P[o4A`:00;o2A8:00Oo2@T:o`TB2_lA9P[o4A`:o`T92_l94P[o
4A`:00?o2@T:00Ko4A`:o`T92_lA70[o0000o`T92_l94PX3o`T92P0<oa4L
2_l92@[o2A8:oa4L2_l92@[o2A8:o`T95?lJ9QCo6Q8Dob<_:OlJ9QCo8blY
0_lA9PX2ob<_7P05oaXB5?lJ9QCo6Q`NoaXB5?lS70X00_lA70X00ol0003o
2@T:o`T92P0Ho`T92P07oa4L2_l94P[o4A`:o`T92_lA70[o0000ohf=K`1O
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0004onKViP0:on?ShooIfMWo
/[:boginO_m_KfooN7Qhoh^;RonBTY;oVIVIoj6QX@koYZJV1_nWYjL00onX
Z:SoZJVYojZZZP04ojZZZPSoZj^[0on/[:`2ojf][@;o[Zj^00Co[Jf]ojj^
[_n^[Zko[Zj^0_n_[jl=ok2`/0;o/K6a00?o/[:bok>c/onc/k<02onc/k<2
okBd]0?o]KFe00?o][JfokFe]One]KD00_nf][H3okNg]`[o^;Rh0oni^KT0
0onj^[[o^k^kok^k^`02okbl_0_o_Kfm1Onn_[h00oo0`<3o_knool71`@05
ol71`@[o`/;21?o3`l<4olC4a0[oaLG51_o6a/H00oo7alOoa/K6olO7a`04
olO7a`Sob<S80oo9bLT2ol[:bP?oc<c<0oo>c/h2olo?c`_od=3@0_oAdM43
om;BdP;odm?C2ooDe=@5omGEe@?oemOG1OoIfMT8om[JfP;ofm_K0ooLg=`2
omgMg@?og]kN0ooOgml>on3Ph004o`mF[_nS`^Co^=?_ogN^j`;oZ]oo00Co
JVYZojj^[_oHf=Soi>CTFooVi^H01OlA9QCo6Q`NoaXB5?lA70[o2@TD00?o
2@T:00Co6Q8Do`TB2_l92@[o2A8:0_l92@X00olA70[o2A8:o`TB2P03o`TB
2P;o2@T:00?o4A`:o`T92_l94PX01?l92@X01?l94P[o0000o`T92_l94PX3
o`T92P04o`TB2_l92@[o2@T:o`TB2PCo2@T:00Go4A`:o`T92_l94P[o2@T:
oaX92P03o`T92P04o`T95?l92@[o2@T:o`T92P;o2A8:0ol92@X00ol94P[o
2@T:oaX92P03o`T92P03oaX92_l92@[o2@T:00;o2A8:0_l92@X00ol0003o
2@T:o`TB2P02o`000003o`T92_l94P[o000000;o2@T:00Co2A8:o`000?l9
2@[o00001_l92@X01ol0003o2A8:o`T92_l94P[o0000o`T92_l000000_l9
4PX01OlJ2@[o=2lco`T92_l94P[o000000;o2A8:0ol92@X01Ol94P[o2@T:
o`TB2_l92ACo4A`:00;o2@T:00Co2A8:oaXL7_l94P[o00001Ol92@X01olJ
4QCo2A8:o`TB2_l0003o2@T:o`TB2_l92@X00_l94PX01?l92@[o0000o`TB
2_l00002o`T92P05oaXB5?l0003o2@T:o`T92_l94PX00_l92@X01Ol94P[o
2@TDo`TB2_l92ACo2A8:00Co2@T:00_o6Q`NoaXB5?lJ4QCo2A8:o`T92_lA
9QCo8blNoa4V5?lJ2@[o0000oa4L2P03o`T92P05oaX92_l94P[o2A8:o`T9
2_lJ2@X00_lA70X01OlJ2@[o4A`:o`T92_lA70[o2A8:00Co2@T:00?o4A`:
o`T92_l92@X01Ol92@X01_l94P[o4A`:oaXV5?lJ9QCo8bH:oaX92P;o8blN
0olJ9Q@2ob<V2P03oa4L2_lS70[o4A`:00;o2@T:00?o0000oa4L2_l00000
1_l92@X00ol94P[o2@T:o`T92P0;o`T92P03ob`B0?l92@[o2@T:00?o2@T:
00?o4A`:o`000?nEXHh0GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00
1?o^k^h02?o/k>coj>SXomWIfOo2`/;oYJFUohf=SOmnOWkoMWIfoombLW8=
og9bLP09ofa/K?mXJ6SoHf=SoeYJF_m>CTko3E>]ojG4i_nidnooMjk[00;o
ZMco00CoKVi^okBd]?oPh>3ok>c/Foo^k^h00olJ4QCo2@TDo`T92P02oaXB
5009oa4L2_l92@[o4A`:o`T92_lA70[o6Q8Do`T92_lA70[o2A8:00Oo2@T:
00?o0000oa4L2_l000000_l92@X01?l0003o2@T:o`T92_l92@X2o`TB2P09
o`T92_l0003o2@T:o`TB2_l92@[o2A8:oaXB5?l92@[o2A8:00;o2@T:00?o
2@TDoa4L2_l92A@00_lA70X01OlJ2@[o2@T:oa4L2_l0003o4A`:00;o2@T:
00Ko2A8:o`T92_l92@[o4A`:o`T92_l00002o`T92P;o4A`:00?o2@T:oa4L
2_l94PX00_l94PX00ol0003o2@T:o`TB2P02o`T92P;o000000?o2A8:o`T9
2_l000000_l92@X05?l0003o2@T:o`000?l92@[o2A8:o`T95?l0003o2@T:
o`TB2_l0003o2A8:o`000?l92@[o0000o`T92_l92ACo0000o`T92_l94P[o
00000_lJ4Q@00ol92@[o=2lco`000002o`T950?o2@T:00Oo6Q8Doa4V5?l9
2@[o8d4mob<_7_lJ4QCo2A8:00?o2@T:00?o0000o`T92_l92@X00_l94PX2
o`T92P04o`T95?l0003o2A8:o`0000;o2@T:00go2A8:o`000?l92@[o2@T:
o`TB2_l0003o2@TDo`T92_l94P[o0000o`TB2_l92ACo4A`:00Co2@T:0_l9
2A@02?lJ4QCo2@T:o`TB2_l94P[o2@TDo`TB2_lA9Qko4BHD0_lJ4Q@01?l9
4P[o6RHDob`V5?lA70X2o`TB2P;o2@T:00?o2A8:o`T92_lA70X00_l92@X2
oa4L2P03o`T92_lA70[o4A`:00;o4A`:00So2@T:oa4L2_lJ4QCo2@T:o`TB
2_l92@[o4A`:o`T92P;o2A8:1Ol92@X00ol94P[o2@T:oa4L2P02oa4L2P0<
oaXV5?lS;ako6RHDoaXB5?lA9P[o8blNoaXB5?lJ71ko6RHDoaX92_l0003o
4A`:0ol92@X01?l94P[o2@T:o`T92_lJ2@X2o`T92P03oa4L2_l92@[o2@T:
00;o2@T:00Co4A`:o`T92_l92@[o4A`:1ol92@X00ol92ACo2@T:oa4L2P02
o`T95003o`000?nVV8Cok^k^05kok^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN4000Cooooo00[oo?cloo7alOo5aLGoR8R8ofm_KomeMGGoPX:2ohN7Qon=
SHgoUIFE3_nJVYX6oi^KV`;oW9bL1OnMWId;oijNWP;oWinO0_nPX:001?nO
WiooX:2Poj2PX?nPX:0=oj6QX@;oXZ:R0_nSXj<00onTY:CoYJFUojFUY@03
ojJVYPSoYjNW1OnXZ:P00onYZJWoZ:RXojRXZ005ojVYZ@[oZZZZ0on[Zj/0
0on/[:co[Jf]ojf][@02ojf][@_o[Zj^1On_[jl2ok2`/0Ko/K6a2_nb/[83
ok>c/`03okFe]Ond];Co][Jf00;o][Jf2_ng]kL=okRh^0So^KVi1Onj^[X3
okbl_0?o_[jn0_no_kl;ol30`0;o`L710oo2`/82ol?3``_oa<C41Oo5aLD0
0oo6a/KoalO7olO7a`05olW9b@Sob/[:0_o;bl/3olc<c003olg=cOo<c<co
cLg=00;ocLg=0oo>c/h>olo?c`04o`]D/?nTa>Ko^M?_ogJ]jP;oZn3o00Co
MWIfol71`Oo`l?3ooOgmFoooool01?l971Co6Q8Do`T92_lA9Q@3o`TB2P;o
2@T:00Go2A8:o`T92_lA70[o2@TDo`TB2P03o`T92P;o2A8:0_l92@X02_lJ
4QCo2@T:o`000?l0003o2A8:o`T92_l0003o2@T:o`TB2_l92@X2o`TB2P;o
2@T:00go0000o`TB2_l92@[o2@T:o`000?l94P[o0000o`T92_lA70[o2@T:
oa4L2_l92ACo6Q8D00;o4A`:00Co6PT:oa4L2_l92@[o2@T:0_l000001Ol9
4P[o2@T:o`T92_l94P[o2@T:00;o000000Oo2A8:o`T92_l94P[o0000o`T9
2_l0003o2A8:00;o2@T:00?o0000o`TB2_l92@X00_l92@X01ol0003o2A8:
o`000?l94P[o0000o`TB2_l000000_l92@X3o`00000Coa4L2_lJ2@[o2@T:
o`000?l92@[o2A8:o`000?l92@[o0000o`TB2_l92@[o0000o`TB2_l92@[o
2@TDoa4L2_lS@Cgo2A8:o`T95004o`T92P06o`TB2_l0003o6Q8DodINAolJ
71ko;2HD0_l94PX01Ol0003o2@TDo`TB2_l92@[o2A8:00;o00000_l94PX0
1_l92@[o2A8:o`T92_l0003o2A8:oa4L2P;o2@T:00Ko0000o`TB2_l92@[o
2@T:o`000?l94PX3o`T92P06o`000?l94P[o2@TDo`TB2_l92@[o2A8:0_l9
2A@01?l94P[o2@TDo`T92_l92@X2o`T950;o6Q8D00Wo2@TDo`TB2_l94P[o
6RHDoa4V2_lA70[o2A8:o`000?l94PX00_l92@X01ol0003o2A8:o`TB2_l9
2@[o4A`:oaX92_lA9PX00_lA70X03_lA9P[o;180oa4L2_l92@[o6PT:oa4L
2_l92@[o4A`:o`T92_lA70[o2@T:o`TB2_l92@[o4A`:0_l92@X04Ol94P[o
2@T:oa4L2_lA70[o6PT:o`TB2_lJ4QCo6PT:oa4V5?lA70[o;2HDoaXV5?lJ
4QCo6RHDoa4V2_l92ACo4A`:00Co2@T:00Co2A8:o`T92_l92@[o2A8:2Ol9
2@X01OlJ2@[o2@T:o`T92_l92@[o4A`:00Go2@T:00Ko4A`:o`T92_l94P[o
4A`:o`000?nVQ8AOooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0003onk^
kP0<onc/k?oShn?oZj^[og=cLomnOWkoS8b<oiZJV_nSXj?oZZZZok:b/_nf
][Ko^;Rh0_omoO/6oogmo@;ooOcm00Koo?_ioo[imOoglo3ok^gXonSUh?oS
h=/@omSEd2ooe]GA00?oe]G@omSEd?oHeM003OoHeM002?oIe<kof=C9onGO
dooXi=Wok^[Qoo[elOoln?GooOWh1Oomo?d4oocmo@03oogmoOo>c/koc/k>
00Goc/k>0oo?cll00oo@d=3odM7Aom;BdP02om;BdP[odm?C1_oDe=@2omGE
e@Goe]KF3_oGemL2omSHf0gofMWI0ooJf]X2om_Kf`?og=cL0ooMgMd2omkN
gP_ogmoO0_oPh>03on;RhP;oi>CT2ooUiND2onOWi`?oj>SX00?oj^[ZonWY
jOoYjNT00_o[jn/3onc/k0Sok^k^0_o_knl3oo3`l0;ol_;b0oodm?@3ooGe
m@kom_Kf00Co2e>]ojG4i_ned>koNJk/0_nWg?l01?m^KVko];Bdon3Ph?o/
k>aKonk^kP03oa4V5?l94P[o4BHD00;o2@TD00Go2A8:o`T95?lA70[o4A`:
o`T95003o`T92P?o2A8:0_l92@X01?l94P[o2@T:o`TB2_l00004o`T92P07
o`000?l94P[o2@T:o`T92_l0003o2A8:o`000004o`T92P03oa4V2_l94P[o
2A8:00?o2@T:0_l94PX01OlA70[o6Q8Doa4L2_lA70[o2A8:00;o4A`:00So
0000o`TB2_l92@[o2@T:o`000?lA70[o0000oa4L2PGo2@T:00Oo2A8:o`00
0?l94P[o2@T:o`000?l92@[o000000Co2@T:00?o0000o`T92_l000000ol9
2@X01?l94P[o0000o`000?l00002o`TB2P?o2@T:00ko0000o`T92_l94P[o
2A8:o`000?l92@[o0000o`T92_l0003o2A8:o`000?l92@[o2A8:o`T92P?o
2@TD00ko2A8:o`T92_l92@[o2A8:o`000?l92ACo4BHNodIED_lJ71ko6RHD
o`T92_l0003o2@T:o`0000;o2@T:00co0000o`TB2_l92@[o0000o`T92_lA
70[o0000o`TB2_l92@[o2A8:o`T92_l00002o`TB2PWo2@T:00Oo0000o`T9
2_l0003o2A8:o`T95?l94P[o2@TD00;o2A8:0_l92@X2o`T950;o4A`:00Go
2@T:o`TB2_l94P[o4BHDob<_7P02o`000003o`TB2_l92@[o000000?o2@T:
00co4A`:oaX92_lA70[o6Q8Doa4L2_lJ4QCo4A`:oaX92_lA70[o4BH:oa4L
2_lA9Q@3oa4L2P07o`T92_lA70[o4A`:oaXB5?lA70[o2@T:oa4L2P02o`T9
2P05oa4L2_lJ2@[o2A`Doa4L2_lS70X00_lA70X2oaX92P06oa4L2_lJ4QCo
6RHDoaXB5?lJ9QCo4A`:5?l92@X00olJ2@[o2@T:o`T92P06o`T92P05oa4L
2_lJ2@[o2A8:o`000?nEXHh0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Q
h@000ooVi^H03?oQhN7o_[jnogMgMonPX:3o_Kfmok2`/?n^[Zko]KFeokbl
_?nn_[koaLG5olS8b0Cooooo00goookooooooOooo_ooooomooonoOomnOKo
m?7/on[Wh?oSg]Sog=WBomOBc?oBc/Gob<6i00kobL2g00?ob<6golK2^Oo6
`[T0;_o6`[T00oo8`KWobL2golW0]`0<olW0]`09olW1]_o:`k?oe<fkomWA
a?oMeL[oi]oGongUh_odk^kooogn00Coooko0_onool00oolooooo_oooooo
o`05omgMg@Gog]kN0_oOgml6on3Ph0[ohN7Q0ooRh^82on?Sh`?oi>CT2_oU
iND6onKViP;oj>SX1OoZj^X;on_[j`;ok>c/0_o]kNd01?o/k>cokNg]ong]
kOo]kNd:onk^kPGokno_0oo`l?05oo7al@Sol_;b0_oclo<3ooCdm003ooGe
mOofm_Kom_Kf00;omoOg0oohn?P:ooWin@?on_[j0_olo?`3ooknoQ7ooooo
00Co35FaojC4i_nhd^koMZgZ0_n/gol01?mZJV[o[Zj^omSHf?oTi>AKonKV
iP03oa4V7_l92@[o2@TD00;o6Q8D00Go2A8:o`T95?lJ4QCo2@TDoaXB5002
o`T92P03o`TB2_l92@[o2@T:00;o2A8:00Ko2@T:o`TB2_l92@[o4A`:o`T9
2_l94PX5o`T92P0<o`TB2_l92@[o2@T:o`000?lA70[o2@T:o`TB2_l92@[o
0000o`T92_l94P[o00000ol92@X5o`TB2P06ob`B0?lA70[o6PT:o`TB2_lA
70[o6PT:0_l92@X01Ol0003o2@T:o`T92_l0003o2A8:00?o2@T:00Wo2A8:
o`000?l92@[o2@T:oa4L2_l0003o2A8:o`000?l94PX00_l000002ol94P[o
0000o`TB2_l0003o2A8:o`000?l94P[o0000o`T92_l0003o2@T:00;o0000
0ol92@X01?l94P[o0000o`T92_l00002o`T92P04o`TB2_l0003o2@T:o`00
00;o2@T:00oo0000o`T92_l94P[o2@TDo`TB2_l92@[o2A8:o`000?l92@[o
2A8:o`000?lA9QCo8blYob<_<ol000000_l92@X00ol0003o2A8:o`T92P05
o`T92P06o`TL5?l0003o2@T:o`000?l94P[o00000_l92@X2o`000004o`TB
2_l0003o2@T:o`TB2P;o2@T:00Go2A8:o`T92_l94P[o2@T:o`TB2P02o`T9
2P05oa4V7_l92ACo2@TDo`TB2_l92A@00_l94PX00olJ4QCo2@TDo`T92P02
o`T92P04o`TB2_l92@[o4BHDoaX92PCo2@T:01Wo2A8:o`T92_lJ2@[o2@T:
o`TB2_lA70[o4BHDoa4V2_lS;ako6RHDob`L5?lA9P[o6Q8Doa4L2_lJ4QCo
6RHDoaX92_lA70[o6PT:oa4V5?lA70[o6PT:oa4L2_lA9P[o6PT:00?o4A`:
00?o2@T:oaXV5?lS;ah00_lJ9Q@01Ol/71Co8a`:oa4L2_lA70[o2A8:00;o
4A`:0_lJ9Q@01?l94P[o2@T:o`T92_l94PX2o`T92P07o`TB2_lS70[o2@TD
oaXB5?l94P[o2@T:oaX92P06o`T92P04o`T95?l92@[o2A8:oa4L2PCo2@T:
00So2A8:o`T92_lA70[o2@T:oaXB5?lJ2@[o0000ojJQV5ooi^KV00CoWIfM
okNg]oo8b<Sodm?C0OoJf]X000;ok^k^00gokNg]onGUiOnATI7oTI6Aolc<
c?oEeMGo`/;2okVi^Oo0`<3oa<C4olW9bOo:b/[od=3@00Cooooo0_ooood0
2ooooo_oookkooWflOoak>Koi=gEom;;`Oo6_kGo_kR^okZcZOng[jCo/:BH
00ko/J>H0_n`Y9P0;on^Y9So[ZBJojjTV?n^Y9[o[ZBHojjTV_n^Y9So[ZBJ
ojjTV?n^Y9[o[ZBHojjTV_n^Y9So[ZBJojjTV?n^Y9[o[ZBHojjTV_n^Y9So
[ZBJojjTV?n^Y9[o[ZBHojjTV_n^Y9So[ZBJojjTV?n^Y9[o[ZBHojjTV_n^
Y9So[ZBJojjTV?n^Y9[o[ZBHojjTV_n^Y9So[ZBJojjTV?n^Y9[o[ZBHojjT
V_n^Y9So[ZBJojjTV?n^Y9[o[ZBH00oo/J>H00Wo/JBDok>VTonl/I_o_kBR
ol6eYoo:`;Kodl[5on7Ieoobk>`00oooo_l00oooooooo_ooookoo`02ooco
o@03oooooooQhN7ohN7Q00GohN7Q0ooRh^800ooTi>Cohn?SonGUi@02onGU
i@[oi^KV1_oWinL00ooXj>SojNWYon[ZjP04on[ZjP_ojn_[0oo/k>`2ong]
k@?ok^k^2_o_knl3oo3`l0;olO7a0_obl_801?oalO7ol_;boo;bl_obl_82
oo?cl`Som?Cd1OoemOD3ooKfmPGomoOg2_ohn?P3ooWin@03oo_knoolo?co
o?cl00;oo_kn9_ooool01?l>EJkoY/KVokK@k_mi[nh2oj_No`04ofi^K_nd
];Coh>3Ponc/k5_ok^k^01Go6Q8Doa4L2_l94P[o2A8:oaXB5?l92@[o4A`:
o`T92_l94P[o6Q8Do`TB2_l92@[o2A8:oaXB5?l94P[o0000o`TB2_l0003o
2@T:o`TB2_l000000ol92@X01ol94P[o2@T:o`T92_l0003o2A8:o`T92_l9
4PX00_l92@X00ol0003o2@T:o`TB2P03o`T92P05o`TB2_l92@[o2A8:o`TB
2_l000000ol92@X01OlA70[o2@T:oa4L2_l92@[o;18000;o2@T:00?o4A`:
o`T92_l92@X00_l92@X01?l0003o2@T:o`TB2_l94PX2o`T92P;o000000ko
2@T:o`TB2_l0003o2@T:o`000?l92@[o2A8:o`T95?l0003o2@T:o`000?l9
2@[o0000o`T92P;o000000Ko2@TDo`T92_l0003o2@T:o`000?l92@X2o`00
0006o`TB2_l0003o2A8:o`000?l94P[o00001?l92@X01Ol0003o2@T:o`00
0?l94P[o000000;o2@T:00Co2A8:o`T92_l92ACo00000ol92@X2o`TB2P04
o`000?l92@[o2@T:o`0000Ko2@T:00?o2A8:o`T95?l92@X00_l92@X01Ol0
003o2@T:o`000?l92@[o2A8:00?o2@T:00Co0000o`T92_l92@[o2A8:0_l0
0005o`T92P05oaXB5?l92ACo2@TDo`TB2_l92A@00_l92@X00olA70[o2A8:
o`TB2P02o`000004o`T92_l94P[o4A`:o`TB2P;o2@T:00?o2A8:o`000?l9
2@X00ol92@X01_lA70[o8a`:ob`V5?lS;ako6RHDob<V2P;o8blN0_lJ9Q@0
0olS9P[o6Q8Doa4L2P02oa4L2P05ob`L5?lS9P[o4A`:oaXB5?lA9PX00_lA
70X02_lJ2@[o4A`:oa4V2_l/9QCo8blYob`B0?lS9P[o6RHDoa4L2_lS70X2
oaX92P;o4A`:00?o6RHDoa4V2_l000001?l92@X00ol94P[o6Q8Do`T92P02
o`T92P03oaXB5?l92@[o2@T:00Go2@T:00?o2A8:o`T92_l92@X01?l92@X2
oa4L2P;o2@T:00Ko4A`:o`T92_lJ2@[o4A`:o`T92_nEQ8iOonk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q0002ooooo`0Sookno_oalO7oOWinokbl_?oH
f=Sofm_Kolk>c_o0`<3oaLG5ol[:b_o<c<coclo?om?Cdoooo_ooooooookn
o_omoOgoooomoooonooooOSonoK`oo;[hooKe<[oakndokneZOnf[:3oZIf?
oj2DQ_nPTh?oWhanoj2:O?nMQgWoVXAfoiR2M?nGPG<00_nFP787oiV3M@;o
UhAe02ooUXEeoiJ4M_nFQGGoUXAfoiJ5MOnFQ7KoUXEeoiJ4M_nFQGGoUXAf
oiJ5MOnFQ7KoUXEeoiJ4M_nFQGGoUXAfoiJ5MOnFQ7KoUXEeoiJ4M_nFQGGo
UXAfoiJ5MOnFQ7KoUXEeoiJ4M_nFQGGoUXAfoiJ5MOnFQ7KoUXEeoiJ4M_nF
QGGoUXAfoiJ5MOnFQ7KoUXEeoiJ4M_nFQGGoUXAfoiJ5MOnFQ7KoUXEeoiJ4
M_nFQGGoUXAfoiJ5M@08oiV3M@;oV89d0_nIPgD2oiZ4MP0@oi^5MonKQWGo
XHmioif=M?nSTWko[j2=okR[Vono/ZWoclBnon3Fe?o_inGonO?cooonooon
o_konogloogooP;oo?om00?oooooonGUiOoUiND00ooUiND5onKViP;oinOW
1_oXj>P:onWYj@?oj^[Z0_o[jn/3onc/k0[okNg]0oo^k^h3ono_k`03oo7a
lOo`l?3ol_;b00;ol_;b0_oclo<8ooCdm0GomOGe0oofm_H5ooOgm`gon?Sh
0ooinOT?oo[jnP?ono_k00?oo?cloogmoOomoOd00_ono_hVooooo`04o`]B
[_nT`nGo^=;_ogV^k0;o[=oo00CoMWIfol71`Oo`l?3ooOgmFoooool01OlA
70[o2@TDo`TB2_l94P[o2@T:00Co2A8:00Wo2@T:o`TB2_lA70[o2@T:oa4L
2_l92@[o2A8:o`T92_l94PX00_l92@X01Ol94P[o2@T:o`T92_l92@[o0000
00;o2A8:0ol92@X01ol0003o2A8:o`000?l94P[o0000o`T92_l000000_l9
4PX3o`T92P;o2A8:00Co2@T:o`TB2_l92@[o2@T:0_lA70X01ol/4P3o4A`:
oa4L2_lA70[o6PT:o`T92_lA70X01?l92@X01?l0003o2A8:o`T92_l94PX2
o`T92P;o000000?o2@T:o`000?l000000_l000007?l94P[o2@T:o`000?l9
4P[o0000o`TB2_l0003o2A8:o`T92_l0003o2@T:o`000?l94P[o2@T:o`00
0?l92@[o2A8:o`000?l92@[o0000o`T92_l0003o2@T:o`000?l94P[o0000
o`T92_l00002o`T92P07o`000?l92@[o2@TDo`T92_l94P[o2@T:o`000002
o`T92P03o`TB2_l92ACo2A8:00;o2@T:00Oo2A8:o`T92_l92@[o2A8:o`T9
5?lA70[o2@T:00Co2@TD00Go2@T:o`000?l94P[o0000o`TB2P03o`T92P03
o`000?l92@[o000000;o2A8:0_l92@X01?l94P[o2@T:o`T92_l92@X2o`TB
2P04o`T95?l971ko2@TDo`TB2P;o2@TD0_l94PX00ol971Co2@T:o`T92P03
o`T92P03oa4V5?l92@[o2@T:00Oo2@T:00Go4A`:oaXV5?lS;ako;3PYoaXV
5002ob<_7P0;oaXV5?lS9P[o8blNob<V2_lS;ako8bH:oaXB5?lS9P[o6RHD
ob<_7_lA9PX00_lJ9Q@2oaXB5009oa4V2_lA70[o6Q8Dob<_7_ldEBWo2@TD
oa4L2_l/C2Wo6RHD00;o4A`:00Ko6RHDoa4V2_lA9QCo6RHDoc@_:OlA70X5
o`T92P04oaX92_lJ4QCo2@T:oa4L2PWo2@T:00?o6PT:o`T92_lA70X00ol9
2@X02ol0003o2@T:o`T92_l0003o2@T:o`T95?l92@[o4A`:o`T92_l0003o
YYR405oooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000;ok^k^00Cok>c/
omoOgomaLG7odM7A0_oLg=`01oo@d=3oa<C4olW9bOo<c<coclo?om;Bd_oE
eMD00_ooo_l07_ono_oooOgmoooonooooo[onoK`oo?/h_oAbKkod<Nhol>g
Yon/WhkoWXinoiJ5Lon9N6KoNfUEohecH_n>Lf;oSg9RohebHOn>LF7oSW=R
ohmbH_n?M6?oSW5QohebHOn>LF7oSG9QohiaHOn=LV7oSW5QohebH@;oS79Q
02koS79SohabHOn<LV?oS79QohabHon<LV7oS79SohabHOn<LV?oS79Qohab
Hon<LV7oS79SohabHOn<LV?oS79QohabHon<LV7oS79SohabHOn<LV?oS79Q
ohabHon<LV7oS79SohabHOn<LV?oS79QohabHon<LV7oS79SohabHOn<LV?o
S79QohabHon<LV7oS79SohabHOn<LV?oS79QohabHon<LV7oS79SohabHOn<
LV?oS79Q0_n=LV406on>LF7oSG9QohiaHOn=LV7oSW5QohebHOn@Lf?oSgAS
oi1cHon@MFCoTGAToi1eI?nAM6CoT7ERoiInI_n<MecoS7INoiR3K_nTTWko
[Yj>ok^]X_o6_;?ofm;;ongUh_omnOKoooomooooo`02ookoo`03oocnoOoo
ooooi^KV00Coi^KV3OoWinL7onSXj0?ojNWY0ooZj^X2onc/k0?ok^k^0_o_
knl>oo3`l003oo7alOobl_;olo?c00oolo?c0_odm?@3ooGem@?om_Kf2_og
moL3ooShn0;onOWi0oojn_X2oo_kn`?oo?cl3OomoOd3ooknoRSooooo00Co
3UF^ojG4i_nfd^koNJkY0_nZh?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP04
o`T95?l92@[o6Q8Do`T92P;o2A8:00?o2@T:o`TB2_l94PX01?l94PX2o`T9
2P07o`TB2_l92ACo6PT:o`TB2_lA70[o2@T:o`TB2P03o`T92P03oa4L2_l0
003o2A8:00Ko2@T:00?o2A8:o`T92_l92@X00_l92@X02?l0003o4A`:o`T9
2_l94P[o0000o`TB2_l92@[o2A8:0_l92@X01OlJ2@[o4A`:oaX92_lA9P[o
;18000?o4A`:1Ol92@X02?l0003o2A8:o`TB2_l94P[o0000o`TB2_l92@[o
2A8:0_l92@X00ol0003o2A8:o`T92P02o`T92P04o`000?l92@[o0000o`T9
2P;o00000_l94PX03_l92@[o0000o`T92_l0003o4A`:o`000?l92@[o2A8:
o`000?l94P[o0000o`TB2_l92@[o00000_l92@X02?l94P[o2@T:o`TB2_l9
2@[o2A8:o`000?l92@[o2A8:1?l92@X01ol94P[o2@T:o`TB2_l94P[o2@T:
o`000?l94PX00_l92@X2o`T95008oa4L2_l92ACo4BHDo`T95?lA;cgo0000
o`T92_l00004o`T92P03o`TB2_l92@[o2@T:00?o2@T:00Go6PT:o`TB2_l9
2@[o0000o`TB2P02o`T92P06o`T95?lJ4QCo2A`Do`T95?lJ4QCo2A`D1Ol9
2A@01Ol94P[o2@T:o`T92_l92@[o4BHD00Co2@T:00?o2A8:o`T92_l92@X0
0_lA70X01OlJ4QCo6RHDob`h:Ol/>2Wo8blY00Ko8blN00?o8bH:oaXL7_lS
;ah00olS;ah00olS;bWo8bH:ob<_7P02oaXV500;oa4L2_lJ9QCo;3PYodI<
?Ol0003o2A8:o`T95?ld;ako8blNoaX92_lS;bT00olS;ah01Ol/C2Wo6Q8D
o`TB2_l92@[o4A`:00;o2@T:00?o6PT:oaXB5?l92@X01Ol92@X01_l94P[o
2@T:o`T92_lJ2@[o2@T:oa4L2PGo2@T:00So4A`:o`T92_l92@[o2@T:oa4L
2_lJ2@[o4A`:o`T92P;o6Q8D00?o0000ojJHKoo^k^h0G_o^k^h01?nSXj?o
_Kfmolo?cooJf]X1on7Qh@000_oVi^H0;?oTi>CoeMGEog5aLOoGemOog]kN
omoOgooDe=Coa<C4olO7aoo<c<cod=3@om;Bd_oFe]Koo_koookoooono_oo
o_knoooonoonnoColN[Pon;JcOo=`K7o`KBSojVJQOnGQg3oXHeeokjXT?oD
_ZKogL>/oo?D`?oddl;on=C4ooOFaOokelOonMS7oocHb?ojfLSonMG5ooOF
aOoieLGommK5ooWEaOoge/GonMG50ooge/D0;Ooge/OommK5ooOFaooge/Go
mmK7ooOFaOoge/OommK5ooOFaooge/GommK7ooOFaOoge/OommK5ooOFaoog
e/GommK7ooOFaOoge/OommK5ooOFaooge/GommK7ooOFaOoge/OommK5ooOF
aooge/GommK7ooOFaOoge/OommK5ooOFaooge/GommK7ooOFaOoge/OommK5
ooOFaooge/GommK7ooOFaOoge/OommK5ooOFa`03ooOFa@0OooWEaOoge/Go
nMG5ooOFaOoieLGommK5oo[Fa_ohelKonMG5ooOFaOoieLGommK5ooWEaOof
e/7ojL^aomc1Y?o</YOo]in5oj:<M?nLQg;oZiZ8oknbX_o9_K7og=?:oo?_
i_ooo_Woooomooooooonoooonoglooooo`05onOWi`;oj>SX0ooYjNT00ooZ
j^[ojNWYon[ZjP02on[ZjP?ojn_[3Oo/k>`00oo]kNgok^k^ono_k`0<ono_
k`?ol?3`0ooalO400ooclo?ol_;booCdm002ooCdm0;omOGe2?ofm_H7ooOg
m`Kon?Sh2ooinOT2oo[jnP;oo?cl00?ono_koogmoOomoOd04Oono_hZoooo
o`04o`aD[_nVa^Ko^M?^ogV^j`;oZmoo00CoJVYZojj^[_oHf=Soi>CTFooV
i^H01?lA9QCo4A`:o`TB2_lJ4Q@2o`T92P08oa4L2_l92@[o6Q8DoaXB5?l9
2@[o2A8:o`T92_lA70X2o`T92P03o`TB2_l92@[o2@T:00Ko2@T:00Go0000
o`T92_lA70[o2@T:o`TB2P02o`T92P07o`TB2_l92@[o2A8:o`T92_l94P[o
;1`Doa4V5002o`TB2P?o2@T:0_l94PX2o`T92P05oa4L2_l92@[o4A`:oa4L
2_l92@X00_lA70X02Ol94P[o2@T:oa4L2_l92@[o4A`:o`T92_l94P[o0000
o`T92P02o`TB2P04oaX92_l94P[o2A8:o`0000;o2@T:00Co2A8:o`000?l9
2@[o2@T:0_l94PX01ol0003o2A8:o`000?lA70[o2@T:o`TB2_l000000_l9
2@X01_l0003o2A8:o`000?l92@[o2A8:o`0000?o2@T:00[o0000o`T92_l9
2@[o0000o`TB2_l0003o2@T:o`000?l94P[o00000_l92@X2o`TB2P?o2@T:
0ol94PX6o`T92P0:oa4V7_lS;c?o2@TDoa4_<olS;c?o6Q`Noa4V7_lA70[o
2@T:o`TB2PCo2@T:00?o2A8:o`T92_l94PX00ol92@X00ol92ACo6Q8Do`T9
5003o`T92P0:oaXB5?l94P[o2A8:o`TL7_l94P[o2@TDo`TB2_l92ACo4A`:
o`T950;o2A8:00Go0000o`T92_l92@[o2@TDoaXB5005o`T92P05oa4L2_lJ
4QCo4A`:oaX92_lA70X00ol/>2T00ol/C2Wo6Q`NoaXV5003ob<_7P04ob`V
5?lJ9QCo8blNocAE:@?o8blN00?o8bH:ob<_7_lS;ah00_lS;ah02?lJ4QCo
6RHDocAE:OldEBWo0000oaXB5?l92ACo=2lY0_l/>2T01old;akoAT4NocAE
:OlS;ako8blYo`000?lA70X00_l92@X01?lA70[o2@TDoaXL7_lA70X3o`T9
2P03oa4L2_l92@[o;18000Co2@T:00?o4A`:o`000?l94PX00olA70X3o`T9
2P04oaX92_l92@[o2A8:oaX92P;o2@T:00Co4A`:oaX92_l0003oCeiVGooV
i^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h01?o/k>cog=cLogMg
MooIfMT2on3Ph007omCDe?o7alOob/[:olk>c_oBd];oe=CDomKFeP02ookn
o`0LookmoooooooooogjooOcj_oSfm3oclJeol2cX?n^WXOoZ9AkokZUR_oH
_Z?ok=6dooSM`?ooi<_on]G2oo_Fa?onelSoo]W7oooHbOomf<KooMK7oo_F
a?onelSooMS6ookGb?omf<Koo]O8oogHaPCoo]O802goo]K:ookGb?one/[o
o]O8ookFb_onelSoo]K:ookGb?one/[oo]O8ookFb_onelSoo]K:ookGb?on
e/[oo]O8ookFb_onelSoo]K:ookGb?one/[oo]O8ookFb_onelSoo]K:ookG
b?one/[oo]O8ookFb_onelSoo]K:ookGb?one/[oo]O8ookFb_onelSoo]K:
ookGb?one/[oo]O8ookFb_onelSoo]K:ookGb?one/X00_onelP07Oomf<Ko
o]O8oogHa_onelSooMS6ookGb?omf<KooMK7oocGaOome/OonmK4oocEa_oj
eL?onmC5ooWD`Oolf;koomo3oooSa_off;cofKjQok^SQon/V7ooZi^4okn`
WOo?`k?oimoDooOcj_onn_Oooogn00?ooooo1OoWinL=onSXj0OojNWY0ooZ
j^X3on_[j`03ong]kOo/k>cok^k^00;ok^k^0_o_knl;oo3`l0?olO7a0_oc
lo<3ooGem@[om_Kf3OogmoL;ooShn0;onOWi0_okno/00oolo?coo_knookn
oP0kooooo`04oa1G[onS`^Co^=?_ogN^j`;oZ]oo00CoKVi^okBd]?oPh>3o
k>c/Foo^k^h00ol971Co2@TDo`TB2P03o`T92P07o`TB2_lA70[o2@T:oa4V
5?l971Co6Q8Do`TB2P02o`T92P03oa4L2_l92@[o2@T:00Ko2@T:00Ko4A`:
o`T92_l92@[o2@T:o`TB2_l00003o`T92P06o`TB2_l0003o2@T:o`000?l9
4P[o00000ol92@X2o`TB2P07o`000?lJ2@[o4A`:o`000?lA70[o2@T:oa4L
2P02o`T92P05o`TB2_l0003o2@T:o`T92_lJ2@X00_lA70X00ol0003o4A`:
o`T92P03o`T92P;o2A8:00?o6PT:o`T92_l92@X00ol92@X2o`00000:o`T9
2_l0003o2@T:o`000?l92@[o0000o`TB2_l0003o2@T:o`0000;o2A8:0_l9
2@X03Ol94P[o0000o`T92_l92@[o0000o`TB2_l92@[o0000o`TB2_l92@[o
0000o`T92_l94PX00ol92@X2o`TB2P09o`000?l92@[o2A8:o`T95?l94P[o
2@TDo`000?l92@[o2A8:00;o2@T:00_o2A8:o`000?l92@[o=5DmoaXL7_lJ
2@[oCeiVofYkQ?l/Ieco0000o`T92P02o`000008o`T92_l0003o2A8:o`00
0?l92@[o0000o`T92_l00002o`T92P03oa4L2_l92@[o6Q8D00?o2@T:00Co
4A`:o`TB2_l92ACo2@TD0_l92@X01_l94P[o2@TDo`T92_l971ko2@TDo`TB
2P;o2@T:00Co2A8:o`T92_l92ACo2A8:0_l92@X01?lA70[o8a`:oa4L2_l9
4PX3o`T92P;o;3PY00CoAT`moc@_:OlS;ako6Q8D0_lS;ah01ol/9QCo6RHD
ob<_7_ldEBWo;4`Yob`V5?lS9PX00_l/>2T00olS9P[o8blNob<_7P02ob<_
7P08ob`L5?l/>2Wo=5DYo`T95?lA70[o2A8:odI17_m6GTL2ocAE:@04oba<
:OlS;c?o;2HDoa4L2P;o2@T:00?o2A8:o`T92_l92@X00_lA70X4o`T92P08
o`000?l92@[o2@T:oaX92_l92@[o4A`:o`T92_lA70X2o`T92P03oaX92_l9
2@[o2@T:00Wo2@T:00Co6Q8Do`T92_l92ACoH44YGoo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@000_ooool0:oomoOgok>c/ogIfM_oJf][oh>3Pon7Q
hOoDe=CoalO7ol_;boo>c/kod=3@om?CdooEeMGoo?kooocoooonooooo_kn
oogim_o`jN7oe/fnol2cX?n[VhCo[YYool:[S?oRajWonM^ioo_J]ooedk3o
lljaoocF`ooleLKoomG9ookGb?ooe/[oo=G6oogCaoojdlCoomG9oogFaooo
eLWooMK7oooEbOome/L01?ooeLT0;Oooe<_oomG9oooDboooeLWoomC;oooE
bOooe<_oomG9oooDboooeLWoomC;oooEbOooe<_oomG9oooDboooeLWoomC;
oooEbOooe<_oomG9oooDboooeLWoomC;oooEbOooe<_oomG9oooDboooeLWo
omC;oooEbOooe<_oomG9oooDboooeLWoomC;oooEbOooe<_oomG9oooDbooo
eLWoomC;oooEbOooe<_oomG9oooDb`02oooEb@0MoogFaoooeLWooMK7oooE
bOome/OoomG9oogFaoooel_oomS9oooGboonelSoomG9oogFaoooeLWoo]C4
ooW@^_odckComM:doocK_?ojfkcohlVXol6ZR_nVTg?o/Z:8ol2dW_oGc[go
k^OMoo_fl_oooOh00_ooo_l00oooooooinOWonOWi`03onOWi`;oj>SX0ooY
jNT2on[ZjP?ojn_[0oo/k>`7ong]k@Kok^k^00?ol?3`ono_kooalO401?oa
lO4;oo;blPColo?c1?odm?@:ooGem@Gom_Kf0_ogmoL00oofm_KomoOgooOg
m`03ooOgm`_on?Sh0_oinOT2oo_kn`03ooclo?ono_koo_kn03_ooooo00Co
45J_ojG4i_nidnooMjk[0_nYg?l01?mfMWKo`L71oo3`l?omoOeKooooo`0>
oa4L2_lJ4QCo2@T:o`TB2_lJ4QCo4A`:o`T92_lJ4QCo4A`:o`T92_l/71Co
6Q8Do`T92_lA70X2o`T95003oa4L2_l92@[o2A8:00;o4A`:00?o2@T:oa4L
2_l94PX00_l92@X01?l94P[o2@T:o`000?lA70X5o`T92P08o`TB2_l92@[o
0000o`TB2_l92@[o2A8:o`000?l92@X3o`000003o`T92_l94P[o4A`:00;o
2@T:00?o4A`:o`T92_l92@X00_l92@X01OlA70[o0000oa4L2_l92@[o4A`:
00Go2@T:00?o0000o`TB2_l94PX01?l92@X01?l0003o2A8:o`T92_l94PX2
o`00000Ao`T92_l0003o2A8:o`000?l92@[o0000o`T92_l0003o2@T:o`00
0?l92@[o0000o`TB2_l0003o2A8:o`T92_l000000_l94PX01?l0003o2A8:
o`000?l92@X2o`00000>o`TB2_l92@[o0000o`TB2_l0003o2A8:o`000?lA
70[o0000o`TB2_l92ACo2@T:o`000?l94PX2o`T92P0?o`TB2_l92@[o4A`:
o`T92_l/71Co4Blmocd_?Ol/EFoo2A8:o`000?l92@[o2A8:o`000?l94P[o
000000;o2A8:0_l92@X2o`TB2P07o`T92_lA70[o2@TDob`h:Ol92@[o2A8:
o`T92P02o`T95005oaXB5?l94P[o2@T:o`TB2_l92@X00ol92A@01Ol92@[o
0000o`TB2_l92@[o000000;o2A8:0_l92@X2o`TB2P0<o`T92_l0003o2A8:
o`T92_l94P[o0000ob<V2_ldEBWo=2lcocAE:Ol/>2Wo4A`:0_lS;ah01_lJ
9QCo8blNob<_7_ld;bWo;4`Yob<_:@;o8blN00Co8bH:ob`h:OlS;ako=2lN
0_lS;ah02?l/>2WoAUDYocAE:Ol0003o2A8:ob<_7_lmGSgo8blN0olJ9Q@0
0olJ4QCo4A`:o`000005o`T92P03oaX92_l92@[o2@T:00Go2@T:00Ko0000
o`T92_l92@[o2A8:o`T92_lJ2@X2o`T92P04ob<L2_l92@[o2@T:o`TB2PSo
2@T:00Co4A`:o`T92_l0003o/7]VGoooool01?n_[joobl_;omkNg_oZj^X1
oo;blP000_o^k^h01?o/k>cog=cLogalO?oJf]X2on3Ph00Iom?Cdoo6a/Ko
c<c<olk>c_o@d=3odm?ComOGeookoOooo?ooookoooolo?kom_?^onKOeOo:
`K3o]ZNBojBCNOo2Zhcog<:Qon_:YoocdJcoombfoooO^?oof[[onm71oocA
b002oogBb@coo]?:<?ood/`;ookCbPCooM;900oooM?5oooScOoof[konM:c
ooKB/?ofe:oojlfWomFlU?o1[HSoZ9QfokBVRoo<`Jgoj>3Coo_fl_ooo_l0
0_oooOl00oooooooi^KVonKViP03onKViP;oinOW0ooXj>P2onWYj@;oj^[Z
00CoinOWomcLg?o[jn_ojn_[1oo/k>`6ong]k@;okno_00KolO7aomoOgoo_
knoolO7aonKVi_oWinL:oo;blPGolo?c00?oh>3Pon?Shooclo<01Oodm?@0
0ooKfm_ol_;booCdm002ooCdm003on;Rh_oUiNGomOGe00;omOGe0oogmoL5
ooWin@03omkNg_oAdM7onOWi00Con_[j00OoinOWooShn?ojn_[okno_oo3`
l?okno_oo?cl00;okno_0_omoOd4ooknoP03onCTi?olo?coo_kn00Koo_kn
00Colo?conOWioono_koo_kn:_ooool01?l<EK7oY<CVokWCkomf[NX2oj_P
o`04ofi^K_nd];Coh>3Ponc/k5_ok^k^013o2@TDoaXB5?l94P[o4A`:o`T9
5?l94P[o4A`:o`T95?lA70[o2@T:ob<_<ol92@[o4A`:o`T92_l94P[o4A`:
0_l92@X00olA70[o2A8:o`T92P03o`T92P;o2A8:00Co2@T:o`000?l94P[o
2A8:0_l92@X3o`TB2P04o`000?l94P[o2@T:o`T92P;o000000[o2A8:o`T9
2_l92@[o2@T:oaXB5?l92@[o4A`:o`T92_l94P[o4A`:0ol92@X01?l94P[o
2@T:o`TB2_l94PX3o`T92P04oa4L2_l92@[o2@T:oa4L2P;o2@T:0_l00000
1_l94P[o2@T:o`TB2_l92@[o2A8:o`T92P;o00000_l92@X01Ol0003o2A8:
o`000?l92@[o000000?o2@T:017o0000oaXB5?l0003o2@T:o`000?l94P[o
0000o`T92_l94P[o2@T:o`000?l92@[o0000o`TB2_l92@[o0000o`TB2P04
o`T92P08o`T95?l92@[o2@TDo`000?l92ACo2@T:o`000?l92@X2o`TB2P09
o`000?l94P[o2@T:o`T92_l971Co2@T:ocd_?On3SHCoJW^400;o2@TD00Ko
2A8:o`T92_l0003o2@T:o`000?l94PX2o`0000Co2@T:00Oo0000oa4L2_lJ
4QCo2A`Do`T92_l0003o2A8:00;o2@TD00?o2A`Do`T92_l94PX00ol92A@0
0ol94P[o2@TDo`TB2P05o`T92P04o`T95?lA70[o4A`:o`T92P;o000000Ko
4A`:o`000?l94P[o0000o`T92_lS70X2odI<?@04ocAE:Ol/>2Wo4BHDoaXL
7P?o8blN00Go6Q8Dob`h:Old;bWo6RHDob<_7P04ob`h:@?o8blY00[oAUDY
odI<?OlA9Qko2@T:oaXB5?l/9QCo2A`Do`T92_lJ9QCo2@T:0_lA70X4o`T9
2P03oa4L2_l92@[o2@T:00co2@T:00?o4A`:o`T92_l92@X00ol92@X00olJ
2@[o2@T:o`T92P06o`T92P05oaX92_l92ACo4A`:o`000?o:d<40Goo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H01?oTi>Coe=CDogalO?oJ
f]X2on3Ph00Jom?Cdoo7alOoc<c<olk>c_o@d=3od];BomKFe_ojo_ooo?ko
ooknooojn_col>gXomgGboo3^:Ko[in8ojfJO?o;/Y?oilVUoo7?ZOogdJ[o
oMJ]oooEZoojcjgoomK8ookEcoome<h2ookEc`03oooFd?ooem7oomSB00So
omK@<?ooeM88oooFd0;oo=?=1Oome<h04_ooe/[om/VdoooA]ooog;coomnk
oo_H/_o[bj;of[nDolbgS?naWgWo]:F6olBhX?oOe/Oom^oYooojo_oonooo
oocoooooo`Goi^KV00ko<30`ogalO?oXj>Soj>SXomgMgOlZ:R[o<c<con;R
h_n`/;3o61PHo`H61_m;Bd_oO7alob`/;0;okNg]00Ko>c/kogIfM_o]kNgo
kNg]og5aLOln?Sh2onk^kP0=ojRXZ?l820Sokno_ono_kom<C4co1`L7oaPH
6?nBTY;o4A4Aoe9BD_oalO7o?3`logQhN002oo7al@06og=cLolo?coolO7a
oo7alOnZZZ[o20P80_obl_801_o@d=3o<S8bo`d=3Ol;2`_o=SHfom?Cd`;o
mOGe00cob/[:ob<S8olL71co/[:booGemOoBd];o<S8bo`d=3Ol;2`_o=SHf
omCDe?ofm_H2ooShn00HooOgmooinOWonOWiooWinOnJVY[o4Q8Bo`P82?lV
9RKo6QXJodY:B_oDe=Con_[jodm?Col71`Oo6ATIoiRHV?lB4Q;oEEEEoo_k
nolT92Co3`l?oalO7om<C4comOGe0_ooool01ooCdm?o9BDUoahN7_nj^[[o
oooood10@?moOgl00_ooool01_oWinOoBTY:o`<30olS8b?o5aLGol71`B[o
oooo00Co35B^ojG4i_ned>koNJk/0_nWg?l01?mZJV[o[Zj^omSHf?oTi>AK
onKViP04oaXB5?lA70[o2@T:o`T950?o2@T:00Oo4A`:o`T92_l92ACo2@T:
o`TB2_l92@[o6Q8D00Co2@T:00?o2A8:o`T92_l92@X00_l92@X00ol94P[o
2@T:o`T92P04o`T92P;o2A8:00?o0000o`T92_l94PX00_l92@X01_l94P[o
6PT:o`TB2_l0003o2@T:oa4L2P?o2@T:00?o2A8:o`T92_l92@X00ol92@X0
0ol0003o2@T:o`TB2P02o`T92P05o`TB2_l92@[o2@T:oa4L2_lJ2@X01?l9
2@X01?l0003o2@T:o`T92_l00008o`T92P03o`000?l92@[o000000?o2@T:
00Co0000oaX92_l92@[o00000_l92@X01Ol0003o2@T:o`T92_l0003o2@T:
00;o000000?o2@T:o`T95?l000000_l92@X00ol94P[o0000o`T92P07o`T9
2P05o`000?l92@[o2@T:o`TB2_l000001Ol92@X01Ol92ACo0000o`TV:Ol/
Ieco2A`N00;o2A8:00?o0000o`T92_l92@X01_l92@X00ol0003o2@T:o`T9
2P06o`T92P09o`TB2_l92ACo2@TDo`T95?l92@[o2A8:o`TL5?lJ4QCo2A8:
00;o2@TD00?o2@T:o`TB2_l92@X00_l92@X01Ol94P[o2@TDo`T92_l94P[o
000000Ko2@T:00?o0000ob<_7_m6@Ah00_lmGSd00old;bWo8bH:oa4V7P04
ob<_7P;oAUDY00Ko8bH:ob<_7_l/>2Wo;2HDob`h:OldEBT2oaXV5005oc@_
:Om6GTOo=5DYo`TL5?l92@X00_lA9Q@00ol92@[o4A`:o`T92P02oa4L2P03
o`TB2_l92@[o2@T:00[o2@T:00?o2A8:o`T92_l92@X01ol92@X00olJ2@[o
2A8:o`T92P0:o`T92P04oa4L2_l92ACo0000ol6c[Eooi^KV00CoWIfMokNg
]oo8b<Sodm?C0OoJf]X000;ok^k^00Cok>c/omcLg?mlO7cof][J0_oPh>00
7ooDe=Cob<S8ol_;boo>c/kod=3@om;Bd_oFe]Koo?coookoooooo_oonOOh
ongXi?oIdLKo`K:OojnKP?o<]Y7oc;66omNfROo^bY[oo=JYoooF[?oofK7o
omnooooF`_oleLKonmC5oo[Ba_oidLGon];6oo_Caoole<P02?okdlL`oogB
b@0Qoo_Caooje<Oonm?7oo[DaookdlOon]C7oo_Caooje<Oonm?7oo[Daook
dlOonmG8oocDb?ole/WooMG9oooFa?ooekkoomNhoooG]OomeK7omm6Zonc9
WooM_Y3ockB5ol>^PonmZhGo`K>FomO<^?o^iMkonO?eookhooooo?ooooko
00Goi^KV00ko<30`ogalO?oXj>SoiNGUod=3@olQ8B7oemOGonc/k?m=CDgo
DU9BonGUiOnBTY;o3@d=ob`/;0;ok^k^00Ko>c/kogIfM_o^k^kok^k^og9b
L_ln?Sh2ono_k`09ojRXZ?l820Sokno_okVi^Ol30`?oclo?omOGeomEEEGo
3`l?00;ol?3`00Ko?3`logMgMoo`l?3ol?3`og9bL_lo?cl2oo3`l006ojVY
ZOl820SolO7aoo3`l?la<C7oCTi>0_oShn<02omADE7o<S8booCdm?oemOGo
K6a/ochn?_odm?ComOGeooCdm?la<C7oCTi>00;oiNGU00?oDU9Boc<c<ooe
mOD00oogmoL2ooShn00>oi>CTol20P;oQhN7ooKfm_oinOWomoOgojf][OoB
d];o`L71o`<30ooGemOoh>3PoeQHF?l@4102oo[jnP05okfm_Oohn?Sono_k
ocDe=OnATI400_ooool00omaLG7o@D51ooknoP02ooooo`0:od10@?moOgoo
oooooooooom4A4Co@410omoOgooooooolo?coo;blR[ooooo00Co35FaojC4
i_nhd^koMZgZ0_n/gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP05o`T92_lA
70[o2A8:oaXB5?l92A@00_l94PX01Ol0003o2@T:o`TB2_l94P[o6Q8D00;o
2A8:00?o4A`:o`T92_l94PX00_l94PX01olA70[o2@T:o`T92_l92@[o6PT:
o`T92_l94PX00ol92@X01_l94P[o0000o`T92_l92@[o2A8:o`0000?o2@T:
00Co2A8:o`T92_l92@[o2A8:1Ol92@X01OlS;bWo2A8:o`T92_l92@[o2A8:
00Go2@T:00Go2A8:o`T92_lA70[o0000oc@_:@08o`T92P03oa4L2_l92@[o
2@T:00Wo2@T:00?o0000o`T92_l92@X00_l94PX4o`T92P03o`000?l92@[o
000000Co2@T:00Co0000o`TB2_l94P[o00000ol92@X00ol94P[o2@T:o`T9
2P04o`T92P03o`TB2_l92@[o2@T:00Go2@T:00?o0000o`T92_l94PX00_l9
2A@01ol0003o2A8:o`TL5?l0003o2@TDo`T92_l000001ol92@X01Ol0003o
2@T:o`T92_l92@[o2A8:00?o2@T:00_o6Q8Do`TB2_lJ4QCo2@TDo`T92_lJ
4QCo2A`DoaXB5?l92ACo2A`Do`T95002o`T92P05o`TB2_l92@[o2@T:o`T9
5?lA70X00ol00003o`T92P09o`TB2_l92@[o2@T:o`TB2_lJ9QCo=5DYodIE
:Om6EE;o=5DY00?o8blN00Go;3PYoaXV5?l/>2Wo=2lYocAE:@02ob`h:@0?
ocAE:Ol/>2Wo;4`YodI<?Old;bWo;3PYofYbG?mPGS?o8blNo`000?lA9P[o
2@TDo`TL5?l92@[o6PT:00;o4A`:1?l92@X01OlA70[o2@T:o`T92_l92@[o
4A`:00?o2@T:00Go4A`:oaX92_l92@[o2@T:oa4L2P04o`T92P05oaX92_l9
2@[o2@T:o`T92_lJ2@X00ol92@X00olA70[o2@T:o`T92P02o`T92P07oaX9
2_l92@[o4A`:o`T92_lA70[o0000oiF4SP1Oonk^kP04oj>SXonm_Kgoclo?
om[JfP7ohN7Q0002ooooo`0UoogmoOo/k>coNg]kom[Jf_oPh>3ohN7QomGE
eOo8b<Sob/[:olk>c_o@d=3odm?ComKFe_oonoSoookkooomo_oono_oi]cJ
omC7__nfY8ko/ieholJZN?oC]GOohKmoonW5Qoo`biKon=>WoocH]_omf[co
omfmookL^Oolf[Ooo=VioooL__oogKooomc0ookK_`03oo_H_003oocI_Ool
fK_ooMZl00;ooMZl00?oo=VmoocH__olf;h01Oolf;h3oogI_`;oo=Rn0ook
ekd@oocH_P?onmRl0_olfKd3oogJ_PSonmRl01konmRjoo[I^?okf;Son]Vh
oo_H^?ojfKSonmRhoo[I^?okf;Son]Vhoo_H^?ojfKSonmRhoo[I^?okf;So
nmVfoooK]_oofkCoo]N`ooSAZ_occ:Gok<FLomnjSOoB/X7ob:alok>MK_nn
[8Cod/BWoncSe?oonoP2ooomo`03ooonoooVi^Koi^KV00?oi^KV00[o<30`
ogalO?oXj>SoGemOoa@D5?o9bLWojNWYon[Zj_lX:2SoQ8B40_o[jn/01_m`
L73o;2`/onc/k?o/k>co>c/kogEeM@;ok>c/00goLG5aochn?_o]kNgokNg]
ojNWYol820Sokno_ol_;bol20P;o/[:boo7alOnFUYKo7QhN00;ol_;b00Ko
?3`logQhN?obl_;ol_;bog=cLolo?cl2oo;blP06ojZZZ_l820Solo?colg=
cOl0003o[Zj^0_oclo<01_n^[Zko0000om;Bd_odm?CoBDU9ofe]K@;om?Cd
00?oc/k>o`000?n_[jl00_oemOD00on_[joo0000omCDe002ooShn006ooWi
nOokno_om?Cdoa<C4omQHF7oo?cl1OomoOd01_oGemOo0P82ok^k^oomoOgo
WIfMoalO7`;ooOgm0_ono_h00oo4a<Co5QHFoi>CT`02ooooo`03ode=COmb
LW;ooooo00;ooooo00Ko@410ogmoOooooooogMgMo`000?nh^;P^ooooo`04
o`iE[_nVa^Ko]]3^ogV_kP;oZmko00CoMWIfol71`Oo`l?3ooOgmFoooool0
0olA70[o2@T:o`TB2P02o`TB2P04o`T92_l94P[o2A8:oa4L2PGo2@T:00Oo
2A8:o`T92_lA70[o0000o`TB2_l92@[o000000;o4A`:00?o0000o`T92_l9
2@X00ol92@X00ol94P[o2@T:o`T92P03o`T92P0Ao`TB2_l92@[o2@T:o`00
0?l94P[o2@T:oa4L2_l92@[o2A8:o`T92_l94P[o2@T:o`TB2_l92@[o2A8:
o`T92_l94PX01?l92@X2oaXB5005oa4L2_l92ACo2@T:oaXL7_l000001?l9
2@X03OlA70[o2@T:o`000?l92@[o0000o`T92_l0003o4A`:o`000?l94P[o
2@T:o`TB2_lA70X00_l000000ol94P[o0000oaXL7P02o`0000;o2@T:00Co
2A8:o`000?l94P[o00000_l94PX01Ol92@[o0000o`TB2_l92@[o000000;o
2A8:00So0000o`T92_l92@[o2A8:o`T92_l94P[o2@T:o`TB2P?o2@T:00?o
0000o`TB2_l94PX00ol92@X00ol94P[o2@T:o`T92P02o`T92P06o`T95?l9
2@[o2@TDo`TL5?l94P[o00000ol92@X01Ol0003o2@T:o`000?l92@[o0000
00Ko2@T:00?o2A8:o`T92_l94PX00_l92A@01?l971Co2A8:o`T92_l94PX2
o`T92P?o2@TD00?o2A8:o`T92_l000000_l94PX00ol92ACo0000o`T92P09
o`T92P0<ob<_7_l/>2WoAT`modIE:Om?IdOo=2lYob<_7_lJ9QCo8bH:ob`h
:OlS;ako;3PY0_l/C2T00old;bWo;3PYoba<:@02odI17P04oc@_:Om6EBWo
LVMBoeMWDP;o2A8:00Oo4A`:ob<_:OlA9QCo8blNoaXV5?lA70[o2A8:00;o
2@T:00?o0000o`T92_l92@X01ol92@X00ol0003o2@T:o`T92P03o`T92P03
oaX92_lA70[o2@T:00;o2@T:00Go2A8:o`T92_l92@[o2@T:oaX92P04o`T9
2P09oa4L2_l92@[o2@T:oa4L2_l92@[o4A`:o`TB2_l0003oYYR405oooooo
00Co[jn_ol_;booNg]koj^[Z0Oobl_8000;ok^k^00Cok>c/omcLg?mkNg_o
f][J0_oPh>001ooDe=Cob<S8ol_;boo>c/kod=3@om;Bd_oEeMD00_ooo_/0
6?oooO[ooocionWNf?oEaKKo]9n2okNLLOo9ZW7oekAbon>nN?oX`goojlN=
ono=WoobdJkolm:coo_I/oojejgonMJ^oo[G[oolf;CooMVeoocH]_okekGo
o]ZjoooK^`;oom^i0ooog;P00ooogKSoo]biookK^`06ookK^`Coombl0oon
fk/00oomf[[oo]^kookK^`0>ookK^`04oogK^?ong;Woo]biookL^@Coomfj
1oong;T2ookL]`Ooo]bf1?omfkD3ookL]P0BookM]?ojejgonmJZooSAZ?od
bZ;ol<JNon[0U_oP]hWoe:mkolZYM?ndVFCo^jIgom?5X_o]iM;ooo_gooom
ooomnoooooko1OoWinL02_la<C7oO7alogmoOol92@Wo]kNgon[Zj_oYjNWo
j^[ZobPX:?n6QXH2on_[j`06oh>3Pol/;2cok>c/onc/k?lk>c_oMGEe0_o/
k>`01_maLG7o?Shnong]kOo]kNgoYjNWo`P820;okno_00GoXj>Sobl_;ol`
<33o<c<coahN7P02oo;blP06oc`l??mhN7Sol_;boo;bl_mcLg?o?clo0_ob
l_801_nZZZ[o20P8oo?clone]KGo0000omcLg0;om?Cd00Kof][Jo`000?ni
^KWomOGeodU9BOm]KFd2ooGem@03okJf]_l0003og=cL00;om_Kf00?ofm_K
o`000?nj^[X00oohn?P01Oojn_[oclo?o`000?nn_[kon_[j00Kono_k00Go
ZZZZoc4a<Olb<S;o=CDeoalO7`02ooclo005on;Rh_m9BDWo0P82og1`L?oe
mOD00_ooool00om=CDgoLW9booooo`02ooooo`06od10@?moOgoooooookjn
__l0003o?Cdm0olo?cl00oo4a<Coooooooooo`0Xooooo`04o`]B[_nT`nGo
^=;_ogV^k0;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h00ol92ACo4A`:
o`T92P02o`T92P;o2A8:0ol92@X2o`TB2P07o`T92_lA70[o2@T:oa4L2_l9
2@[o2@TDoaX92P03o`T92P03o`000?lA70[o2@T:00;o2@T:00Go2A8:o`T9
2_l94P[o0000oa4L2P02o`00000?o`T92_l0003o2A8:o`T92_l94P[o0000
o`TB2_l0003o2A8:o`T92_l0003o2A8:o`T92_l94P[o4A`:00;o2@T:00?o
4A`:o`T92_l92@X00_l92@X02?lA70[o2A8:o`T92_l/9QCo6Q8Doa4L2_l9
2@[o4A`:0_l94PX00olA70[o0000o`T92P03o`T92P04o`TB2_l92@[o2@T:
o`0000?o2@T:0_l00002o`T92P;o000000?o4A`:o`T92_l000000_l92@X0
2?l0003o2@T:o`T92_l92@[o0000o`T92_l0003o2@T:0_l000001_l94P[o
0000o`000?l94P[o2@T:o`TB2P;o2@T:00?o0000o`T92_l94PX00_l92@X0
2?l94P[o2@T:oa4V2_l94P[o0000o`T95?l92@[o00000_l92@X01_l94P[o
6Q8Do`TL5?l971ko2@T:o`0000Go2@T:00?o0000o`T92_l000000_l92@X0
2Ol0003o2A8:o`000?l92@[o2A8:o`T92_l0003o2@T:o`TB2P04o`T95003
o`TB2_l92@[o2A8:00;o2@TD00?o2@T:o`TB2_l92@X00_l92@X01?l0003o
2A8:o`TB2_l94PX2o`T92P0;o`000?l92@[o2A8:o`T92_l94P[o2@T:oa4L
2_l/71Co;3PYodI<?OlmGSd00_m6C3d00olS;bWo8blNob`h:@02ob`h:@05
ocAE:Om6@Ako=2lcoba<:Om6@Ah00_l/>2T02ol/GSgo8blYoeMED_mZNfoo
=5DYo`000?l92ACo0000ob<_7_m6EBWo;4`Y00Go2@T:00?o2A8:o`T92_l9
2@X02_l92@X00ol0003o2@T:o`T92P02o`T92P05oa4L2_l92@[o6PT:o`T9
2_l/4P000ol92@X01?l94P[o2@T:o`T92_lA70X4o`T92P05o`TB2_lJ2@[o
6PT:o`000?nEXHh0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oV
i^H01?oTi>Coe=CDogalO?oJf]X2on3Ph00OomCDe?o8b<Soc<c<olk>c_o@
d=3od];BomCDe?oooOoooocooooknoooo_Kok>?BomC4Z_n/UVoo]i][olVV
K?oF[W3ohKQjonFmP?oX`H[oj/JFon_;X_o[bjConMJ`oo[D[ooidjoon]B`
oocE]_ome[Ooo=Fhoo_D]`02ooS@]P;onM:e0_oid[<2oo[C]003ooWB]Oog
d[Gomm:e00Gomm:e0_ohdkH4ooOB]@;om]6d4?ogd[D2ooKA]0Comm:e0_oh
dkH7ooOB]@;omm>c1oogdk47ooKB/00BooKB[_obcjGom<nSoo39W_o/`YSo
j[nDonJkS_oM]83odjaeolVVK_nbU5ko/I]ZomC4X?o_i=;ooo[fooomoooj
n_ooooko1OoWinL01Ola<C7o?3`lo`820_nRXZ;oj>SX00;ojNWY00?oj^[Z
obPX:?n6QXH00_oZj^X01_n3Ph?o;2`/on_[joo[jn_o>SXjofATI0;ojn_[
00SoKfm_obl_;oo[jn_okNg]ojJVY_l820Sokno_onk^kP;ol?3`00?ok^k^
oh^;RolO7al00_obl_803_ll?3coIfMWoo;bl_obl_;oLW9boc0`<?oalO7o
l_;bojVYZOl820Solo?com7AdOl0003o[:b/0_oemOD01_n[Zj_o0000omSH
f?ofm_KoBTY:ofe]K@;om_Kf00?oe=CDo`000?n][Jd00_ogmoL00on/[:co
0000omSHf002ooOgm`;on?Sh00Co[Zj^o`000?oKfm_on?Sh2?oinOT00oog
moOoT92@ob0P8002oo[jnP03od10@?m1@D7of=SH00;oo_kn0_ooool00om=
CDgoLW9booooo`02ooooo`0:od10@?moOgooooooom_Kfol0003oZj^[olo?
coo7alOo0`<3onGUiB[ooooo00Co3UF^ojG4i_nfd^koNJkY0_nZh?l01?mZ
JV[o[Zj^omSHf?oTi>AKonKViP05oaXB5?lA70[o2A8:oaXB5?l94PX00ol9
2@X01_lA70[o2@T:o`TB2_l94P[o2@T:oaXB50?o2@T:00?o4A`:o`T95?l9
2@X00_l92@X00olA70[o6Q8Do`T92P02o`T92P03o`000?l92@[o2@T:00;o
2@T:00Go2A8:o`T92_l0003o4A`:o`000007o`T92P0;o`TB2_l92@[o2@T:
oa4L2_l0003o4A`:o`TB2_l92@[o0000oa4L2_l000000_l92@X01_l0003o
2@T:o`T92_l92@[o2A8:o`0000Co2@T:0_lA70X4o`T92P07o`TB2_l92@[o
0000o`T92_l94P[o2@T:oa4L2P04o`T92P04o`000?l92ACo0000o`TB2PCo
2@T:00Ko0000o`T92_l0003o2A8:o`T92_l00004o`T92P03o`T95?l0003o
2@T:00Co2@T:00?o2A8:o`T92_l94PX00_l94PX2o`T95003o`TB2_l92@[o
2A8:00?o2@T:00?o2A8:o`T95?l971@00_l92A@02Ol92@[o2@TDo`000?lA
70[o2@T:o`000?l94P[o0000o`TB2P02o`T92P05o`TB2_l92@[o2@T:o`TB
2_l000000_l92@X3o`TB2P03o`T92_l94P[o2@TD00;o2@TD00Go4BHNo`T9
5?l94P[o2A`No`T95002o`T92P06o`TB2_l92@[o2@T:o`T92_l94P[o0000
0ol92@X02?l94P[o2@T:o`TB2_l92@[o4A`:o`TB2_lS;ako;3PY0_m6C3d0
0om6EE;oAUDYob`h:@02ob<_7P0IocAE:Old;bWo=2lcocAE:Old;c?oAT`m
ocAE:Ol/>2Wo=5DYoba<:OmGEE;oEheLof1N<olS;ako2@TDo`000?m6@Ako
LXdmoba<:Ol0003o2A8:o`T92_l0003o2@T:o`TB2P0Ao`T92P03oaX92_l9
2@[o2@T:00Co2@T:00Oo2A8:o`T92_l92@[o2@T:oaX92_l92@[o2A8:00;o
2@T:00Ko8a`:o`T92_lJ2@[o2@T:o`000?nVXIQOonKViP04oifMWOng]kOo
b<S8om?Cd`7of][J0002onk^kP0Wonc/k?oLg=coNg]komWIfOoOgmoohN7Q
omCDe?o7alOoc<c<olk>c_o@d=3oeMGEomCDe?oooOooo?Woooolnoooo_;o
lNO>omC4X?nRS5_o]9ENolFNIOoCYV_ogZmgon>fOooT^hOoil>?onS8UooW
b9[ojlFNonc4X?o]aJ;ok/JSono6Y_o_aZSoklJZonk5ZOo^a:_oklF/00;o
klJZ1?o_aZP00oo_aZ[ok/NZonk7ZP0<onk7ZP03ong6ZOo^aj[ok/NZ00ko
k/NZ00?okLJYonk7Z_o^ajX03?o^ajX00oo^ajSok/NVonk7YP06onk7YPKo
kLJU01?ok<FTonc6X_o/bIookLRLonW3U_oW_97oiKV:onBfQ?oM/7WodjU_
olRQI_n_SeKoZ8iMomO5Woo_i=3oo_Wcookmoooknoooooko00GojNWY00[o
<C4aof][JolO7aooRh^;on[Zj_o[jn_oj^[Zon_[jolX:2SoQhN70_o/k>`0
3_n4Q8Co;2`/onc/k?o/k>co>c/koa<C4on1PH7oe]KFocXj>_lL71coFEUI
om;Bd_mYJFWo;bl_0_o^k^h01OnXZ:Soc<c<onc/k?mJFU[oCTi>00;ol?3`
00[o?3`loa<C4on3Ph?of][Joc/k>olM7AgoFUYJomCDe?mZJV[o<30`0_oa
lO405?lm?CgoA4A4omCDe?oCdm?o@d=3od51@OoemOGokno_odI6A_mXJ6So
j^[Zoo7alOoemOGo?ShnodE5AOoFe]KoeMGEodA4A?m1@D7om_Kf0oogmoL0
1Oohn?So`L71o`000?o<c<con?Sh00KonOWi00Go[jn_omCDe?ofm_KoGUiN
oe9BDP02oo[jnP0>ocHf=_nDU9Coo?clonOWiooinOWoooooooWinOm9BDWo
KFe]ooCdm?okno_ooooood10@?moOgl2ooooo`05oclo?om[Jf_omoOgoijN
W_l[:b/0:oooool01?l<E:koY/KVokWCk_mi[^/2oj_Oo`04ofi^K_nd];Co
h>3Ponc/k5_ok^k^00?o2@TDo`T92_l92@X00_l92@X00ol94P[o2@T:o`T9
2P02o`TB2P07o`T92_l0003o2@T:o`TB2_l92@[o6Q8Do`T92P03o`TB2P04
oaXB5?lA70[o2A8:oa4V50;o2@T:00Oo2A8:o`T92_l94P[o2@T:o`TB2_l0
003o2@T:00;o2A8:00Co0000o`T92_l94P[o00000_l94PX01Ol0003o4A`:
o`000?l92@[o000000;o2@T:0_l94PX01?l92@[o4A`:o`TB2_l00006o`T9
2P04o`000?l92@[o0000o`TB2P;o2@T:00Oo2A8:o`T92_l92@[o2@T:o`TB
2_l92@[o000000?o2@T:00Co2A8:o`000?l94P[o00001?l92@X02ol94P[o
0000o`TB2_l0003o2@T:o`000?l94P[o0000o`T92_l0003o2@T:00;o0000
0ol92@X01?l0003o2@T:o`000?l94PX2o`T92P;o2A8:00?o0000o`T92_l9
2@X00_l92A@00ol94P[o2@TDo`TB2P02o`T92P06o`000?l92@[o2A8:o`T9
2_l92ACo2A8:0ol92A@01_l94P[o2@T:o`000?l92@[o2A8:o`0000?o2@T:
00?o2A8:o`000?l000000_l92@X01ol0003o2A8:o`000?l94P[o0000o`T9
5?l92@X00_l94PX02?l971ko2@TDob`L5?lS@Cgo2@TDo`TL7_l971Co2@TD
0_l94PX01Ol0003o2@T:o`TB2_l94P[o000000?o2@T:02Go2A8:o`000?l9
4P[o2A8:oa4L2_lJ2@[o4A`:ob<_7_l/C2Wo?BlmodI17_ldECgo?Ehmob<_
7_l/C2Wo=2lYodI<?OldEBWoAT`modmWAom?Ieco=5DYodI<?Old;c?o;3PY
ob<_7_mPGS?oCfM7oceN?Ol/C2Wo0000ofYE7_n3Neco2A`Do`000?l92@[o
2A8:00;o2@T:00?o0000oaX92_l92@X00ol92@X00ol94P[o0000o`T92P0;
o`T92P03o`TB2_lA70[o2@T:00;o2@T:00?o2A8:o`T92_l92@X01?l92@X2
o`TB2P07o`T92_l94P[o6PT:o`T92_lA70[o0000ojJHQ01Oonk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q0002ooooo`0SoogmoOo/k>coNg]komWIfOoO
gmoohN7QomCDe?o6a/Koc<c<olk>c_o@d=3oe=CDomGEeOono?oon?Oooogk
o?oooNkomNc;omW;W?nLPd_o[he@ol6GGOo@WfOog:Udon6_O?oQ]X7oiKj7
on;3R_oSa8koil6Don_1VOo]`igok/BNonk3X?o^`j400_o^`j<2ono4Y0;o
k/>S0_o^`j400oo^`j3ok<BPonc4X@0=onc4X@;okLFR4?o/a:42ong5XPko
k<BQ2?o/a:001?o]aJ7ok<BPonc4X?o/a:02on_3W`0Con[2W_oY`icoi/>I
onG3UOoT_XoohKN7on:dP_oR/GWofjY_om>SIOo4Vego[HU?oij2D?oKaj;o
l^GBooghl_ooo_oooOgoooono`05onSXj005oc4a<OmlO7co`L71oa0@4?n_
[jl00_oZj^X00oo[jn_o?Cdmoi6AT@02onc/k00>ohn?Som0@43ok>c/onc/
k?m=CDgoP820ofQXJ?l>3Pko9BDUolG5aOn?Shoo61PHoadM7OnPX:02onk^
kP05oh61POl^;Rko3Ph>ocDe=Ong]kL00_o`l?002_m?CdooPX:2ofYZJ_l?
3`oo9BDUolS8b?n@T93o61PHoahN7_nSXj<2oo7al@0?omcLg?m>CTko3Ph>
o`h>3_m@D53ogmoOooGemOmjNW[o1`L7o`/;2olI6AWoYjNWooGemOoNg]ko
CTi>00;o3Ph>00?oDE5Aon3Ph?ofm_H00_ohn?P01_ogmoOonOWionOWiol1
0@7oVIVIooWin@Kon_[j00GoQhN7oc4a<Ol?3`oo=cLgol30`002oo_kn`0>
okbl_?li>CWo3`l?oa8B4_oWinOoooooogmoOol820So30`<oa/K6on^[Zko
oooood10@?moOgl2ooooo`05onKVi_m7AdOo3@d=oa`L7?ng]kL0:oooool0
1?l@EjooXl;TokSCkomg[^/2oj[Oo`04ogIfM_o1`L7ol?3`oogmoE_ooooo
00Go4A`:o`T92_lA70[o4BHNo`T92P02o`TB2P03oa4L2_l92@[o4A`:00?o
2@T:0_l94PX01?lJ4QCo4A`:o`T92_l94PX3o`T92P07o`TB2_l0003o2@T:
o`T92_l0003o2A8:o`000002o`TB2P;o2@T:00So0000o`TB2_l92@[o2@T:
o`000?lA70[o0000o`T92P;o2A8:1_l92@X2o`TB2P05o`000?l92@[o2A8:
o`TB2_l000000_l94PX4o`T92P0:oa4L2_l92@[o0000oa4L2_l92@[o0000
o`TB2_l92@[o0000o`TB2P?o2@T:00Go0000o`TB2_l0003o2A8:o`000004
o`T92P0Ao`000?l92@[o2@T:o`000?l92@[o0000o`T92_l0003o2A8:o`00
0?l92@[o0000o`T92_l0003o2A8:o`000?l92A@00_l92@X01?l0003o2A8:
o`T92_l92@X2o`TB2P06o`T92_l94P[o2@T:o`TB2_lA9Qko2@TD0ol94PX0
1Ol92@[o2A8:o`T92_l94P[o2A`D00;o2@TD00Oo2A8:o`TL7_l92ACo2A8:
o`000?l94P[o000000;o2A8:0_l92@X02?l0003o2@T:o`T92_l92@[o0000
o`T92_l0003o2A8:0_l92@X04_l0003o2@T:o`T95?l92@[o4BHNob`L5?lJ
71ko?Blmo`T95?l971Co2A`No`TB2_lA70[o2@T:o`TB2_l92ACo4BHDo`T9
50;o2A8:00Co2@T:o`000?l94P[o2@T:0_l94PX08olA70[o4BHDoaXV5?ld
;bWoAUDYocAE:Om?IecoPhAkodI<?OldEBWo8blYodI<?Om6@Ako=5DmoeME
D_m?Ieco?EhmodI<?Om6GTOoAUEBodmWAolS;akoH5hcodmWAomZLUco0000
odIE:On=SFoo;5hmo`000?l92@[o2A8:o`T92_l0003o2A8:00;o2@T:00Go
6PT:o`T92_lA70[o2A8:oa4L2P07o`T92P03oa4L2_l92@[o2@T:00;o2@T:
00Go2A8:o`T92_l94P[o2@T:oaX92P04o`T92P03o`TB2_l92@[o2@T:00Go
2@T:00Go4A`:o`T92_lJ2@[o0000oiFQSP1Oooooo`04ojn_[oo;bl_og]kN
on[ZjP7ol_;b0002onk^kP0Ponc/k?oLg=coO7alom[Jf_oOgmoohN7QomCD
e?o6a/Koc<c<olk>c_o@d=3odm?ComGEeOolo?oomoWoookno_onnn[ono??
onCDXonHOTGoYh=5okj@E?o<V5ooej9/ombYM?oM[WSogKImomZjOooI^X7o
iL6=onW3U?o[aIP2ong6V`03onc5W?o/aIkokLJO00?ojlBM0_oZ`i`2on[3
VP03onW2VOoZ`i[ojLBJ00KojLBJ00?oj<>IonW4V_oYa9X00_oYa9X3on[5
Va3ojLBJ0_oZaI/03OoZa9gojLBJonW3W?oYa9[ojL>LonS3VOoZa9goj/FK
on[4WOoZaI_oj/BMon[5VooZa9d00_oZaI/08?oZaIWoj/FKon[5VOoZaI_o
j/FIon[5VooZaIWoj/FKon[5VOoYa9[ojLBHonS3VOoW`YKoil:HonO2U_oO
_Y7ogkf?omjhQooL/googJifombZKooEXV7obiYHokb?C_nYPTOoVG]9onC@
ZooikMOooo_booonooolooooo_oo1OoXj>P01ola<C7oO7alonWYjOnRXZ;o
51@Dolc<c?oZj^X00oo[jn/9onc/k003on_[joo]kNgokNg]00;okNg]00Co
k>c/ong]kOo^k^kok^k^0_o_knl00oo]kNgokno_ono_k`05oo3`l003ono_
koo`l?3ol?3`00;ol?3`00Cokno_oo7alOoalO7olO7a0_oclo<2ooCdm006
ooGemOofm_Kom_KfooKfm_m:BT[oKFe]1oofm_H00oogmoOon?ShooShn003
ooWin@;on_[j00?oHF5Qob@T9?oYjNT02?olo?`00oojn_[oo?clooclo002
ooclo0;ooOgm00?ono_kooooooooool00_ooool00om=CDgoLW9booooo`02
ooooo`03od10@?moOgoooooo00?ooooo00?oo?clooooooooool0:oooool0
1?l@EZooYLCVokWCkomg[^/2ojWLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^
00Ko2@T:oa4V5?l92@[o2A8:o`T92_l94PX6o`T92P09oa4L2_l92@[o2@T:
oaXB5?l92@[o2A8:o`T92_l94P[o4A`:00;o2@T:00?o0000o`TB2_l92@X0
1Ol92@X01Ol0003o2A8:o`T92_l0003o4A`:00;o2@T:00Ko0000o`TB2_l9
4P[o2@T:o`000?l92@X6o`TB2P08o`000?l92@[o2A8:o`T92_l0003o2A8:
o`T92_l00004o`TB2P;o000000Oo2@T:o`000?l92@[o2A8:o`000?lA70[o
000000?o2@T:00Oo4A`:o`T92_l92@[o2@T:o`000?l92@[o2A8:00?o2@T:
00?o4A`:o`T95?l94PX00ol92@X01ol94P[o2@T:o`000?l94P[o0000o`T9
2_l000000ol92@X01ol0003o2A8:o`000?l94P[o2@T:o`000?l94PX00_l9
2@X01Ol92ACo2@T:o`T95?l92ACo2A`D00;o2@TD00?o2A8:o`000?l94PX0
1?l92@X01Ol94P[o2@TDo`TL7_lA9QCo6Q8D00;o00000_l92@X2o`000008
o`TB2_l0003o2A8:o`000?l92@[o0000o`T92_l94PX3o`T92P;o2A8:017o
2A`No`T95?l971ko8d4mobaEG?lJ2@[o4Blco`TL7_l92ACo4BHNo`T95?l9
2@[o0000oa4L2_l94P[o6Q8Do`TL5002o`000003o`TB2_l92@[o2@T:00;o
2@T:00Go4A`:oaXB5?lS;ako4BH:ob<_7P02oba<:@0Hob<_7_m6GTOoEfMB
odI<?Om6@AkoAUDYodI<?OmPGS?oCfMLof1N<om6EE;oCfM7odI<?OmPGS?o
=5DYoc@_7_mPGS?oLW9kobaN?OlJ2@[oSHe_obaN?Ol0003o2@T:0_l94PX0
0ol0003o2A8:o`T92P0<o`T92P03o`000?l92@[o2@T:00Co2@T:00co6PT:
o`T92_l92@[o4A`:o`000?l92@[o4A`:o`000?lJ4QCo0000oaX92_l94PX4
o`T92P06oa4L2_l0003o4A`:o`T92_l0003oYYR4Goo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@000_oVi^H09OoTi>Coe=CDogalO?oIfMWoh>3Pon7Q
hOoEeMGob<S8ol_;boo>c/kod=3@om?CdooDe=ConogoooSlooonooooo?[[
ooohfOo`gk?oV7e6oj9l?_nbQ4Ko`Hi?olnIGOoDX6KoeJM/omJ^LooF/gWo
dkEiomBdNooJ]h7ogKZ4omnkQooN^XSogKV9omjjR_oO^Xd00ooS_Y401OoS
_hooh[j>on:nS_oR_Xkogkj;00Soh;n<00Cogkj;on2oS?oP_hcoh;n<1?oQ
`8d@on2oS0;ohKn?00gohKnAon6oSooP_Y3oh;j>on2nT?oO_HgohKnAon6o
SooQ_i7ohKn?on6oTOoQ_hoohKnA00;ohKn?00oohL2=on6oSooQ`8gohKn?
on70SOoQ_hoohL2=on6oSooQ`8gohKn?on2oS?oO_Hgog[f:omjlS?oM_H`0
0_oG]hP03ooH/X7oeZegomJXKOoDXV?obiQFol6>C?nbPT;oY7a1oiMhBOob
g;OoooKPooonmOonooooo?ooookoo`05onOWi`07oc4a<OmlO7coj>SXonSX
j?mjNW[o:BTYomkNgP06on[ZjP[ojn_[0oo/k>`2ong]k@?ok^k^2_o_knl3
oo3`l0?olO7a00?olo?coo;bl_odm?@00_odm?@2ooGem@03ooKfm_oHf=So
e]KF00Gom_Kf1OogmoL3ooShn0;onOWi00SoiNGUoclo?olM7AgoN7QhoiBD
U?maLG7o;bl_okZj^PKon_[j0_okno/2ooclo003oogmoOono_koo_kn00;o
oooo00?oh>3PomkNg_ooool00_ooool00om0@43oOgmoooooo`0aooooo`04
o`aE/OnTa>Ko^M?_ogJ]jP;oZn3o00CoJVYZojj^[_oHf=Soi>CTFooVi^H0
1?lA70[o2@TDo`TB2_l92@X3o`TB2P;o2@T:00So2A8:o`T92_l0003o2@T:
o`TB2_l92@[o2A8:o`0000;o2A8:00?o0000o`TB2_l94PX01?l94PX2o`T9
2P05o`TB2_l92@[o2@T:oa4L2_l000000_l92@X01?l0003o2@T:o`T92_l9
4PX2o`0000?o2@T:0_l00003o`T92P;o2A8:0_l92@X02_l94P[o2@T:o`T9
2_l0003o2@T:o`000?l94P[o0000o`T92_l94PX2o`T92P06o`TB2_l92@[o
0000o`TB2_l92@[o2A8:0_l92@X00ol0003o2@T:o`T92P02o`T92P0Go`TB
2_l0003o2@T:o`TB2_l92@[o2A8:o`T92_mP@BWo2A8:o`T92_lA70[o0000
o`T92_l0003o2A8:o`000?l94P[o0000o`TB2_l0003o2@TDo`000?l94PX0
0_l000000ol92@[o0000o`T92P03o`T92P08o`T95?l971Co2A8:o`T95?lA
9Qko2A8:o`T92_l94PX2o`T92P09o`TB2_l92@[o2@T:o`TB2_l92ACo2A8:
o`TL5?l94P[o000000;o2@T:00?o2A8:o`000?l92@X00_l000001_l94P[o
2@T:o`000?l92@[o2A8:o`0000?o2@T:00?o2A8:o`000?l92@X00_l92A@0
3omZNhCo4BlmoeMED_l99RWo4Blco`TL7_lA9Qko4Blmo`T92_l94P[o2@T:
ob<_7_m6C3go8blYo`T95002o`T92P06o`TB2_l0003o2@T:o`T92_lA70[o
6RHD0_lS;ah03?lA70[o8blYoc@_:OldEBWo;4`Yoc@_<om6C3go=5DYodI<
?OlmGSgoAUEBodI<?@GoCfM700_o?Ehmob<_7_m6C3goLXeLog^=I_l0003o
LXeLoba<:Ol0003o2@T:o`TB2P02o`0000Co2@T:00?o0000o`T92_l92@X0
4ol92@X01?lA70[o2@T:o`T92_lA70X4o`T92P03o`TB2_l92@[o2@T:00?o
2@T:00Co4A`:o`T92_l0003oLW9kGooVi^H01?nMWIgo]kNgolS8b?oCdm<1
om[JfP000_o^k^h09_o/k>cog=cLogalO?oIfMWoh>3Pon7QhOoEeMGoalO7
ol[:b_o>c/kod=3@om?CdooDe=ConOoooo[nooonooooo?[^ooomhoohi/;o
VGe=oiei?onWNC_o]hA3olJACoo=VUWod:9Vom>[L?oC/7SodK9komFfOooI
^X?ogKj8omjoROoM_H[og;b;omfmS_oN_Xoog;^>0_oL_8d2om^kRP;of[Z9
00?ofK^7omZlR?oJ_8P01_oJ_8P3omVkQ`;of[b80ooK_HT@omZlR003om^m
RooK_8gofkb=00;of[^<0ooI^X/7om^lS@_ofkf;0_oJ_8X05OoI^hWof;Z8
omNiQooG^HOodK:3om:bPooC[W[odJQ`om6SIoo>WE_oa95?okR7A?nWNC_o
WgQ1oiMhB_oki<CooocYoooom_onoooonoooookoo`05onOWi`03oj2PX?nn
_[kojNWY00;ojNWY00?oUiNGol30`?oZj^X00_oZj^X3on_[j`Ook>c/1_o]
kNd2onk^kPGokno_2oo`l?03oo7al@03oo?cloodm?Com_Kf00;om_Kf2_og
moL5ooShn0;onOWi00_on?ShooWinOoinOWonOWiooShn?n][JgoOGemofIV
I_n6QXKoZJVYon_[j`06oo[jnP;ono_k0_olo?`00oomoOgoo_knooknoP07
ooooo`03od10@?moOgoooooo037ooooo00Co35B^ojG4i_ned>koNJk/0_nW
g?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP09oa4L2_l92ACo=2lco`TB2_l9
2@[o2A8:o`T92_l94P[o2@T:00Co2A8:00Go2@T:o`TB2_l94P[o2@T:o`TB
2P03o`T92P09o`TB2_l0003o0000o`T92_l94P[o2@T:oa4L2_l0003o2A8:
00;o2@T:00?o2A8:o`T92_l92@X01Ol92@X00ol94P[o2@T:o`TB2P06o`T9
2P05o`TB2_l92@[o4A`:o`T92_l94PX01ol92@X01_l0003o2@T:o`TB2_l0
003o2@T:o`0000;o2@T:00Co0000o`T92_l92@[o2A8:0_l92@X01ol94P[o
2@T:o`TB2_l0003o2@T:o`TB2_l000000ol94PX00olS9P[o2@T:o`TB2P02
o`T92P;o2A8:00co0000o`TB2_l0003o2@T:o`000?l94P[o0000o`TB2_l0
003o2@T:o`T95?l00002o`T92P03o`TB2_l92@[o2A8:00?o2@TD00?o2A8:
o`TL5?l94PX00ol92@X4o`TB2P06o`T95?l971ko2@TDo`T95?l92@[o2A8:
0ol92@X00ol94P[o0000o`TB2P02o`000005o`T92_l94P[o0000o`TB2_l9
2A@00ol92@X2o`TB2P0<o`T95?l92@[o6RHDoh>H[Om?GVKoEhf>o`TB2_l9
71ko2A`Do`TL7_l971Co2@T:0_lA70X01ol92ACoAT`mob<_:Ol94P[o0000
o`TB2_l000000_l92@X01_lA70[o4BH:ob`h:Ol/C2Wo8blNoaXB50?o;3PY
00?o8blYodI<?OlmGSd00_m6GTL00om6IecoCfM7odIEDP02odmWA`;oEfMB
00Wo?Ehmob`V5?m6C3goJVLcog^=I_l94P[oJVLcoh>4Nol000002Ol92@X0
1Ol94P[o2@T:oa4L2_l94P[o000000?o2@T:00?o2A8:o`T92_l92@X00_l9
2@X00ol0003o4A`:o`T92P04o`T92P07oa4L2_l92@[o2@T:o`T92_lJ2@[o
2@T:oa4L2P04o`T92P04oa4L2_l92@[o2@T:ob<L2P;o2@T:00?o4A`:o`00
0?n3Q7/0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool09Oom
oOgok>c/og]kNooJf][ogmoOon7QhOoEeMGoa/K6ol[:b_o>c/kod=3@om?C
dooDe=ConOoooo7fnOolooooooojooonlOool=Oo_J=nohm^>onRNC_oY7D_
ok20=_oAXEWoa9QGomV`N?oYaI?of;R9om^oSooG_H[of;j=omo4UOoRai[o
hLJIon;7W?oUbYl00ooQaId2on76V`;ohLJI0_oQaYL7omo7U`;og/JF00Co
glNGon38V?oPb9SohLVI0_oRbYX?on38V003on38V_oOai_oglNK00ooglNK
1ooOaiT2onC<WP;ohl^M01GohLVKomg5UooG_i7oe;V<on;3UOoP_Y3oe[9n
onJoQ_o9WF3o`9=BokN7AOnVNCSoSfD[oiI`?onlWgOoooWLooodh_okn>oo
o_ooooKjnoonool01ooXj>P3onWYj@;ojn_[0oo]kNd:onk^kPOokno_1_o`
l?0;oo7al@?ol_;b0_odm?@3ooKfmP[omoOg3Oohn?P;ooWin@;on_[j0ool
o?`2ooknoPOooooo00?ono_koogmoOooool0<Oooool01?l<EK7oY<CVokSB
k_mf[NX2ojcOo`04ogIfM_o1`L7ol?3`oogmoE_ooooo00?o2@T:oa4V5?l9
2@X00_l94PX3o`T92P06oa4L2_l94P[o2A8:o`TB2_l0003o4A`:0_l92@X0
0ol94P[o2@T:o`TB2P04o`TB2P03o`T92_l94P[o2A8:00;o2A8:00Oo2@T:
o`TB2_l94P[o0000oa4L2_l0003o4A`:00;o2@T:00[o2A8:oa4V2_l92@[o
0000o`T92_l0003o2A8:o`T92_lA70[o00000ol94PX00ol92@[o4A`:o`T9
2P02o`TB2P03oa4L2_lJ2@[o2A8:00;o2@T:00Oo4A`:o`T92_l94P[o0000
o`TB2_lA70[o000000;o2@T:00Co2A8:o`T92_l92@[o00000_l94PX00ol0
003o2A8:o`TB2P04o`T92P05oaX92_l94P[o2@T:o`T92_l94PX00ol92@X2
o`000008oa4L2_l0003o2A8:o`TB2_l0003o2A8:o`000?l92A@3o`T92P04
o`000?l94P[o2A8:o`TB2P;o2@T:00Ko2@TDo`TL7_l94P[o2A`No`TL5?l9
2A@3o`TB2P0=o`T95?l94P[o2@T:o`T95?l971ko2A`Do`TL7_l92ACo2@T:
o`000?l94P[o0000o`TB2P07o`T92P03o`TB2_l92@[o2@T:00;o2A8:00?o
4A`:o`T95?l92A@00_l971@01olJ71koAVMLodmbNolS@Cgo2A8:o`T95?l9
9RT00_l971@02?l94P[o4A`:oaX92_lJ71koEeEBob<_:Ol92ACo2A8:0_l9
2@X04OlA70[o2A8:o`T92_lS;ako6RHDob<_7_lJ4QCo;3PYodIE:Om6C3go
AUDYodI<?Om?IdOoCfMLodmWAoldECgoEfMB00;o?Ehm0_m6EE82ocAE:@08
oc@_:OlA9QCo=2lNok2ZQ?l94P[oAT`mog^=I_l00004o`T92P;o2A8:1Ol9
2@X01OlA70[o2@T:o`T92_l92@[o4A`:00;o2@T:00Co4A`:o`TB2_l92@[o
2A8:0olA70X3o`T92P06ob<L2_lA70[o2@T:oa4L2_l94P[o4A`:0ol92@X0
1olA70[o2@T:oaX92_l92@[o4A`:o`T92_lA70X00_l92@X01?lA70[o2@T:
o`000?nEV:=Oooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP0G
onc/k?oLg=coMgMgom[Jf_oPh>3ohN7QomCDe?o7alOoc<c<olo?coo@d=3o
dm?ComKFe_okoogon_oloocoooooo_coooSeoooik_oKaZ_oOf8hoi1/<_nG
KbT00_neRCh03?o[`X3ogKIoomNbQ_o]cJKoj<bTon?:XOoTbj?oj<nWon[@
ZooWcJ[oilf/onW?[P;ojm2b0_o[dK02on_A[P;ojm6/2?oZdZ`2onK>Z0;o
ilnY00Coj=2ZonWAZooYdJ_oj]:/4?oXd:X00ooZdZkoj]:`on[B/00=on[B
/0Soj]:^00?oi/jZonG=ZOoTc:P00_oUcJT05?oTc:Soh/ZVon37Woo[bj;o
jLNIon[6T_oM^Goodj]]ojb3@onYP43oTVX]oi9]>On7IS_og<:Qooohh?oo
o^ooooofooWkn?ogno[oo_oo1OoVi^H5onOWi`03onSXj?oYjNWoj^[Z00Go
j^[Z1oo[jn/3onc/k0?okNg]00?okno_onk^k_o`l?000_o`l?02oo7al@_o
l_;b1?oclo<4ooCdm0[omOGe0oofm_H2ooOgm`;onOWi00Con?Shoo[jn_oj
n_[on_[j0_okno/=ooclo0;ooOgm00?oo_knooooooooool0>oooool01?l>
EJkoY/KVokK@k_mi[nh2oj_No`04ofi^K_nd];Coh>3Ponc/k5_ok^k^0ol9
4PX00ol92@[o2@TDo`TB2P02o`TB2P;o2@T:00Ko0000o`TB2_l92@[o2A8:
o`T92_lA70X3o`T92P03oaX92_l92@[o2@T:00?o2@T:00Ko0000o`TB2_l9
2@[o4A`:o`000?l94PX:o`T92P05o`TB2_l92@[o2@T:o`000?l94PX00_l9
2@X01?l0003o4A`:o`T92_lA70X3o`T92P03o`TB2_l92@[o2@T:00?o2@T:
00So2A8:o`T92_l92@[o2@T:o`000?lA70[o0000oa4L2P;o000000Ko2A8:
o`T92_l92@[o6Q8Do`000?l94PX4o`T92P04o`000?l92@[o2A8:o`0000;o
2@T:00Oo4A`:o`000?l94P[o2@T:o`TB2_l0003o2@T:00;o00000_l92@X0
1?l94P[o0000o`000?lA70X3o`T92P05o`TB2_l92ACo2A8:o`T95?l99RT0
0ol92A@2o`TB2P06o`T92_l94P[o2A8:o`TB2_l92@[o2A8:0ol92A@00olA
9Qko0000o`T92P08o`T92P05o`TB2_l0003o2@T:o`T92_l000000_l94PX4
o`T92P09o`TB2_l971ko4BHNo`TB2_l971Co2@T:o`TL7_l92ACo2A`N00;o
2@TD00So2@T:o`TB2_lA70[o8blcoc@_<ol971Co2@T:o`0000;o2A8:0_l9
2@X00olA70[o8blNob<_7P02ob<_7P0IocAE:OlmGSgoAT`moeN=G?mGIe;o
JXeLodmWG?m?IdOoEeEBof1N<ol/C2WoAUDYocAE:OlA9Qko6PT:ob`h:Ol0
003o8blNog9WD_lA9QkoSHe7oh>=Q?m6C3go0000o`T92P02o`TB2P;o2@T:
00?o0000o`T92_l92@X01ol92@X00olA70[o2@T:o`T92P08o`T92P03o`TB
2_l92@[o4A`:00Co2@T:00Go6PT:o`T92_l92@[o4A`:o`000009o`T92P03
oa4L2_l0003oYZ6H05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;o
i^KV00Coi>CTomCDe?mfMWKofMWI0_oOgml07ooDe=CoalO7ol[:b_o>c/ko
d=3@om?CdooGemOonoogoocon_okoOcooooooo_fn_ooo?[oooOYojRALOn9
JcOoME<Coi5]8oniTd[oa9iOoooKY_oV`i_ok<^Zon[=[OoVcJkoilj`onW?
]?oYckKoilfdonK<]OoXc[L01?oXcKP2onS>]`[oj<je0_oWcK@2onS>]@04
onW?]_oZd;Ooj]2gon[@]a3ojLnf6?oXc[L06Oo]dkcojm6jon[@^OoZd;Wo
k=:kongC_?o/d[_okM:eon_;Y?oU`iGoil>?onS5SOoQ_H7oXWi2oi5^=?n9
J3?oPF8fojfCL_oolm_oooWYooollOooooSooookoogoo_ooool01OoUiND5
onKViP;oj>SX1_oZj^X:on_[j`?ok>c/0_o]kNd3onk^kP[okno_0oo`l?03
oo7al@03oo;bl_oalO7ol_;b00;ol_;b0_oclo<8ooCdm0?omOGe0_ofm_H3
ooShn0?on_[j0_okno/=ooclo0;ooOgm00?oo_knooooooooool0>oooool0
1?l;DZkoY<?UokSBkomi[^`2ojcOo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV
00Ko6Q8Do`000?ld;c?o2A8:o`T92_lA70X2o`T92P;o2A8:1?l92@X2o`00
00Co2@T:00?o2A8:o`T92_l94PX01?l92@X00ol0003o2@T:oaX92P04o`T9
2P08o`000?l92@[o2@T:oa4L2_l94P[o2@T:o`TB2_l00004o`T92P0;o`00
0?l92@[o2@T:o`T92_lA70[o2@T:oa4L2_l92@[o0000o`T92_l94PX00_l9
2@X00ol0003o2@T:o`TB2P05o`T92P04o`TB2_l0003o2@T:o`TB2PCo2@T:
00Co4A`:o`000?l94P[o00000_l94PX00ol92@[o4A`:o`000003o`T92P03
o`000?l94P[o000000;o0000013o2A8:o`000?l92@[o2@T:o`000?l92@[o
0000o`TB2_l92@[o0000o`T92_l94P[o2@T:o`TB2_l92ACo4A`:0_l971@0
1_l94P[o4BHDo`T95?l92@[o2A`Do`TB2P;o2@T:00Oo2@TDo`TB2_lA70[o
2@T:oa4_?Ol971ko4Blc00;o2@T:00Co0000o`T92_l92@[o00001?l92@X0
0ol0003o2A8:o`000002o`T92P04o`TB2_l92@[o2@T:o`TB2P;o2@T:00?o
2A8:o`TL5?l971@00_l92@X02olJ4QCo2A`Doa4_<ol92ACo2BHYoa4V5?l9
2@[o2A8:o`T92_lA9QCo2A`D00;o2A8:1?l92@X00olA70[o6Q8Dob<_7P03
ob<_7P07ocd_?OlmGSgoEfMBoeMWD_mZLUcoCfM7oeMWDP02ocAE:@0Foa4V
7_l/9QCo=2lNo`TB2_ld;ako6RHDo`TB2_ld;akoYYQ_odIWG?mbIe;oUIQV
og:=?OmPGS?o4BHDo`T92_l0003o2A8:o`T92_l94P[o2@T:oa4L2PKo2@T:
00?o4A`:o`T92_l92@X00ol92@X00olA70[o2@T:o`T92P03o`T92P04oaX9
2_l92@[o2A8:oaX92P;o2@T:00?o6PT:o`T92_l92@X00_l92@X01?lA70[o
2A8:o`T92_lJ2@X2o`T92P03oa4L2_l92@[o4A`:00;o4A`:00?o6PT:o`00
0?o:d<40GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h09Oo/
k>cogMgMog9bL_oGemOogmoOon3Ph?oBd];oalO7ol[:b_o<c<cod=3@om?C
dooDe=Coooofoocmmoolo_goo_oooo_jooooo_oooogdoo?Sc?nRSF;oM5TR
ohMX:?nIMcOo`YmUombhQ_oM^Y;ohl:QonS;[OoWc:ooj/ndonc@^?o/d;[o
jlnion_?^_o]dK`01Oo[c[`2on_?^P03on_?^Oo[ck[ojlnj00Sojlnj0oo/
d;/3ongA_13ok=2k6Oo[ckX06?oZc[WojLfhonW=^?oZc[WojLfhonO;]_oW
bJoogK^EoocJ[?oVaI;of;N1okNGG_nQPT_oPFHaogEJ;OnYTFoonNG=oool
kOoooOCom^oYookkm_oooo_oo_omooooo`Goi^KV0_oWinL3onSXj0;ojNWY
0ooZj^X3on_[j`Ook>c/1_o]kNd00oo^k^kokno_oo3`l004oo3`l0_olO7a
0oobl_82oo?cl`?om?Cd2_oemOD5ooKfmP;omoOg00?om_KfooOgmoogmoL0
0oogmoL;ooShn0;onOWi0ookno/2oogmoA7oo_kn:_ooool01?l>EJkoYLCV
okKBk_mi[^T2oj[Po`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Ko4A`:oaXB
5?l92@[o4A`:o`T92_l94PX4o`T92P05o`TB2_l92@[o2@T:o`T92_lA70X0
0ol92@X01?l94P[o2@T:oa4L2_l92@X2o`TB2P_o2@T:00Go4A`:o`T92_l9
4P[o2@T:o`TB2P03o`T92P03oa4L2_l92@[o2A8:00?o2@T:00Wo4A`:o`TB
2_l92@[o4A`:o`000?lA70[o0000o`T92_l94PX01?l92@X01_lA70[o2@T:
o`T92_l0003o2@T:o`0000Ko2@T:00Oo2A8:o`000?l92@[o2@T:o`000?l9
2@[o4A`:00;o2@T:00So2A8:o`T92_l92@[o2@T:o`000?l92@[o0000o`TB
2P?o2@T:00Ko2A8:o`000?l94P[o0000o`T92_l00002o`T92P0;o`TB2_l0
003o2@T:oaXB5?lS;c?o4BlcodINAol94P[o2A`No`TL5?l92A@00_l94PX0
1?l92@[o2A8:o`T92_l94PX3o`T95003ob`L5?l99RWo2@TD00?o2A8:0ol9
2@X01Ol94P[o2@T:o`T92_l0003o2A8:00;o2@T:00Co4A`:o`T92_l0003o
2A8:0_l92@X2o`TB2P03o`T92_l92ACo2A8:00;o2A8:0_l971h00olA9QCo
2A`NoaXB5002o`T92P;o2A8:00Co4BHNo`T95?l92ACo2@T:0_l94PX2o`T9
2P0Joa4L2_lJ9QCo8blNob`h:OlS;bWoAT`mof1N<omZLUcoNheVodIED_m6
EBWo=2lYob<V2_lA70[o0000of0_5?lA9P[o2@TDo`T92_mbSCgo2A8:oa4V
2_mbIe;oEheLoc@_7_nEV6H2o`TB2P04oiFHI_m6@Ako2A8:o`0000;o2@T:
00?o2A8:o`000?l92@X00ol92@X00olJ2@[o2@T:o`T92P03o`T92P03oa4L
2_lJ2@[o2@T:00?o2@T:00Oo6PT:o`T92_l92@[o2@T:oaX92_l92@[o0000
00?o2@T:00Go8a`:o`000?lA70[o2A8:oaX92P04o`T92P09ob<L2_l92@[o
2A8:oaX92_l92@[o4A`:o`TB2_l0003oSIR>05ook^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN4000;ooooo00CooOgmono_komcLg?oclo?0_oMgMd07OoA
dM7oa<C4olS8b?o;bl_oclo?om;Bd_oDe=Coooojooonn_oooooonocooo[m
ooojnogomoC_ooookOoom=OoR7E;og1F9OnHNTKo/I5NolZXN_oad:GoekN@
omnnVooQ`j7oiLJWonK7Z?oVaj[oi/N[00;oilN^0ooWak02onO7[P?oilR/
2?oVb:h4onC6[0CoiLN]4?oTaZ`HonK8[P?ohlF[0_oTaZ`05?oRa:[og/2V
om^lWOoC/8SoilFGomFdPOo@/G_oW85:og1I9OmVDBCoPg5=ooobfOoooNgo
o_?]ooomnoooo_goo?_ioocmn?oooo_oooom1OoUiND5onKViP03onSXj?oW
inOojNWY00GojNWY2_oZj^X3on_[j`03onc/k?o]kNgok^k^00;ok^k^2_o_
knl3oo3`l0?olO7a0_obl_83oo?cl`;om?Cd2?oemOD5ooKfmP;on?Sh00?o
moOgooWinOoinOT00ooinOT;oo[jnP;ono_k0oolo?`2oogmoA7oo_kn:_oo
ool01?l<E:koY/KVokWCk_mi[^/2oj_Oo`04ogIfM_o1`L7ol?3`oogmoE_o
oooo00Go2A8:oa4L2_l94P[o2@T:oa4L2P04o`TB2P03oa4L2_l92@[o2@T:
00;o2@T:00So2A8:o`T92_l94P[o2@T:o`TB2_l0003o2A8:o`T92P;o2A8:
00?o0000oa4L2_l92@X02ol92@X2o`TB2P?o2@T:00Co0000o`T92_l0003o
00001Ol94PX00ol92@[o4A`:o`TB2P02o`T92P08o`000?l94P[o2@T:o`TB
2_l92@[o2A8:o`000?lA70X4o`T92P03o`000?l92@[o2@T:00Go2@T:00?o
0000oa4L2_l94PX00ol92@X00ol94P[o0000oa4L2P02o`T92P0;o`000?l9
4P[o0000o`TB2_l0003o2A8:o`000?l92@[o0000o`T92_l000000_l92@X0
1Ol94P[o2@T:o`TB2_l0003oCfML00;o2@T:00GoAUEBo`TL5?l971Co2@TD
o`000003o`T92P0=o`000?l94P[o2@TDoa4V5?l92ACo8blYocd_?OlS;c?o
2A8:o`TL5?l92@[o0000o`TB2P02o`T92P03o`000?l94P[o2A8:00;o2@T:
00Oo0000o`T92_l94P[o2A8:o`T92_l0003o2A8:00;o2@T:00?o0000o`TB
2_lJ4Q@00_l92A@00ol971Co2@TDoa4V7P02o`TL500:o`T95?l94P[o2@T:
o`T92_l94P[o2A`Do`T95?l971Co2A8:o`0000;o2@T:01Go4A`:oa4V2_lJ
4QCo4BH:oba<:OldEBWoAT`modmWAom6EBWo=5DYob<L2_l971Co4A`:o`T9
2_lJ4QCo2@T:ocAE:Ol92@[o4A`:ofYW<old;ah00_m6@Ah02OmZSEco=2lN
ok2ZQ?l0003o2@T:oaX92_l/C2WoYZ5Vo`000002o`TB2PWo2@T:00Co4A`:
o`TB2_l92@[o4A`:1Ol92@X01?lA70[o2@T:o`T92_l94PX3o`T92P;o4A`:
00Ko2@T:o`TB2_l92@[o4A`:o`T92_lJ2@X3o`T92P0;oa4L2_l92@[o2@T:
o`T92_lJ2@[o4A`:oaX92_lA70[o6PT:o`000?nVXIP0Goooool01?n_[joo
bl_;omkNg_oZj^X1oo;blP000_o^k^h02_o]kNgoh>3PogYjN_no_koof=SH
om[Jf_o<c<co`L71olG5aOo:b/X2olk>cP05omCDe?ooo?ooookoooooooo`
m?L00_okool04_o^l>_oooodooook?oolMOoSWMGog5E;_n6ISgoZXULojj=
H?oE]HKocjn0omJeR?oJ^Hcof[V>omRgS_oI]i7of[RBomVgTPGof;JA0ooH
]Y000ooG]i7oekJComNfT`0LomNfT`;oekNA02_oekN@omNgTOoG]i3oekNA
omNgT?oG]i7oekN@omNgTOoG]i3oekNAomNgT?oG]i7oekN@omNgTOoG]i3o
ekNAomNgT?oG]i7oekN@omNgTOoG]i3oekNAomNgT?oJ^YCof[ZComblU_oN
_YOogknIomfmU_oH^9;oe[B>om^fS?o:YGSo]iMVoin1COn5KS[oIe<QojjO
M_ojkm7oook]oooilOoooOgomo;f00;oooko00?omoScoooonoooood01OoT
i>@5onGUi@;oinOW1_oYjNT:on[ZjPCojn_[1?o/k>`:ong]k@Kok^k^00?o
l?3`ono_kooalO401?oalO48oo;blP?olo?c0_odm?@2ooGem@04ooKfm_og
moOomoOgooOgm`;on?Sh2ooinOT2oo[jnP?ono_k0_olo?`@oogmo@?oo_kn
:?ooool01?l@EjooXl;TokSCkomg[^/2oj[Oo`04ofi^K_nd];Coh>3Ponc/
k5_ok^k^00Co6Q8Do`TB2_l92ACo4A`:0_l92@X00ol94P[o6Q8Do`T92P02
o`T92P08oa4L2_l94P[o4A`:o`TB2_l92@[o4A`:o`TB2_lA70X3o`T92P04
o`TB2_l0003o4A`:o`0000co2@T:00Co0000o`T92_l92@[o00000_l92@X0
1?l94P[o4A`:o`T92_l92@X2o`000003o`TB2_l92@[o2A8:00Co2@T:00Co
2A8:o`T92_l92@[o00000_l94PX01?l0003o2A8:o`000?l94PX6o`T92P03
o`000?l92@[o2@T:00;o2@T:00?o0000o`TB2_l92@X00_l94PX3o`T92P;o
00000_l92@X01Ol94P[o0000o`T92_l0003o2A8:00?o2@T:00Co2@TDo`T9
2_l0003o00000_l92@X01_l0003o8d4moc@_:OlJ4QCo;2HDoaXB50;o2@TD
0ol94PX2o`T92P03o`T95?l0003o2BHY00;o6Q`N00CoAUEBobaEG?l94P[o
2A8:0_l92@X00ol0003o2A8:o`000002o`T92P05o`000?l94P[o0000o`T9
2_l000002?l92@X01?l94P[o2@TDo`TL5?l94PX2o`T95005oa4V7_l971ko
2A`Do`T92_l000000ol92@X01Ol971ko6Q8Do`T95?l0003o2A8:00;o2@T:
00Co4A`:oaXB5?lJ9QCo;3PY0_m?IdL01?lmGSgo4BH:o`000?lA70X3o`T9
2P;o4A`:00ko;180ob<L2_m6EBWoJVLcob<_:OmGEE;oUJ6>og^=I_l0003o
/:Z4oa4V2_l0003o2@T:o`0000;oAT4N00GoLXdmo`000?l94P[o2@TDo`00
0002o`T92P03o`000?l92@[o2@T:01?o2@T:00?o6PT:o`T92_lA70X00_l9
2@X00olJ2@[o2@T:o`T92P02o`T92P;o6PT:00Wo2A8:o`T92_l92@[o2@T:
oaX92_l92@[o6PT:o`000?nVXIP0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@000_oVi^H09OoUiNGogMgMohj>S_nTY:Cod];BomCDe?o2`/;o^;Rh
ol30`?o4a<CobLW9ol_;boo@d=3oooSoooolooonoOoomo_looWoooohoogo
nOojoocon?oln>gooogaooofiOnOQFcoR6]9ogYJ<On<K3_oUgPoojn=D?nh
UUOo_YaMokfKG_nlVEoo_iaTol6NI_o0WFL01OnmVV@3okfJHPSo^iYU6?nm
W6L0<OnkVVCo^i]Rok^JI?nkVf;o^iYTok^KH_nkVVCo^i]Rok^JI?nkVf;o
^iYTok^KH_nkVVCo^i]Rok^JI?nkVf;o^iYTok^KH_nkVVCo^i]Rok^JI?nk
Vf;o^iYTok^KH_njVF?o^YYQokZIHonlW6?o_IaVokbLHoniV6;o^9APoiaf
BOnONTgoSFdlofI:6?m`FRSoWi5Toocbc_ooonSon_K[ooKeloooo_oolO3h
ooSgo?oooooooookoooon_ooood01ooQhN43on;RhP03onCTi?oShn?oiNGU
00;oiNGU2_oVi^H7onOWi`Koj>SX2ooYjNT3on[ZjP03onc/k?o[jn_okNg]
00;okNg]2_o^k^h7ono_k`Kol?3`2?oalO43oo;blP;olo?c0ooemOD2ooOg
m`?on?Sh2_oinOT3oo[jnP?oo?cl0_ono_hVooooo`04oa1F[onUa>Ko^M?_
ogN^j`;oZMco00CoJVYZojj^[_oHf=Soi>CTFooVi^H3o`TB2P06o`T92_lA
70[o2A8:o`T92_lA70[o2@T:0_l94PX4o`T92P03o`TB2_l0003o2@T:00?o
2@T:00?o2A8:o`000?l92@X00ol92@X01olA70[o2@T:o`T92_l92@[o2A8:
o`T92_lA70X00ol92@X01?l94P[o2@T:oa4L2_l00002o`TB2P03o`000?l9
2@[o2@T:00;o2@T:00Go2A8:o`T92_l94P[o0000o`TB2P02o`T92P05o`TB
2_l0003o2@T:o`000?l94PX01Ol92@X01ol94P[o0000o`T92_l0003o2@T:
o`000?l94PX00_l92@X01_l0003o2@T:o`000?l92@[o2A8:o`0000;o2@T:
00Oo0000o`T92_l92@[o0000oa4L2_l94P[o2@T:00;o00001?l92@X2o`00
0004o`T92_l0003o0000o`TB2P;o2@T:00[o0000o`T92_l94P[o8blNoaXL
7_l0003oAUEBo`T95?l94P[o2@T:0_l94PX2o`T92P0=o`T95?m6EE;oCeiV
og9bNolm;cgo2D57o`TV:Ol92@[o2A8:o`T92_l0003o2A8:o`000003o`T9
2P03o`TB2_l92@[o2A8:00;o2@T:00?o0000o`T92_l92@X01_l92@X2o`TB
2P;o2@TD00Co2@T:oa4_<ol92@[o2A8:0ol92@X01Ol94P[o2@TDo`T95?lA
9QCo2A8:00?o2@T:0_lA70X06OlJ9QCo;3PYof1N<oldEBWo6RHDo`000?l9
2ACo2@T:o`TB2_l92@[o4A`:oaX92_lJ4QCo;2HDoc@_7_mPGS?oPg]LoeMW
D_mbSCgo`K>>obaN?Ol0003o`K>>o`TL7_l000000_l92@X2o`000007oh=k
<om6@AkoSHe7o`000?lA70[o2@T:o`00000;o`T92P03oaX92_l92@[o2@T:
00;o2@T:00Go4A`:o`T92_lJ2@[o2@T:oaX92P05o`T92P04oaX92_l92@[o
2@T:oa4L2PSo2@T:00Ko6PT:o`000?lA70[o6PT:o`000?nEV:=OonKViP04
oifMWOng]kOob<S8om?Cd`7of][J0003onk^kP05onWYjOo5aLGoPh>3ojb/
[?nl_;`00_n^[Zh06onf][Ko_;blokno_oo4a<CobLW9ooojoooonooonOOl
oocoooogoocojoS_ooSon_oiooSono[eooohlOoono7ooo[Xoooff?onhKOo
X81=ohAT9ombD@coOU`DohIT7On7IAkoR6DSohaY9`02ohm/;0;oSVX/1?n>
Jb/00on>JbWoSV/[ohe[;00:ohe[;QCoS6X]00?oS6X[ohe[;?n=Jb/05_n=
Jb/06OnAKbooSfd]ohe[:on<JR[oSF/[ohaZ:_n;JBWoRFLZoh1G:On1Fbko
YHEFoooZ^OooolgooooDooongOoonnGoooohooooooo`l?Soo_koooonoook
no_ooookoooon_ooood01OoLg=`5omgMg@;ogmoO1_oQhN4:on;RhP?ohn?S
0_oTi>@3onGUi@[oi^KV1_oWinL2onSXj0GojNWY2ooZj^X2on_[j`;ok>c/
00CokNg]onk^k_o^k^kok^k^2_o_knl5oo3`l0?olO7a1Oobl_88oo?cl`;o
m?Cd0ooemOD3ooKfmP;omoOg0oohn?P:ooWin@?on_[j0_olo?`3ooknoQ7o
oooo00Co35FaojC4i_nidnooMZgZ0_n[h?l01?m^KVko];Bdon3Ph?o/k>aK
onk^kP;o2@TD0_l94PX2o`T92P04oa4L2_l92@[o2@T:oa4L2PGo2@T:00Co
2A8:o`T92_l92@[o2A8:0ol92@X00olJ2@[o2@T:o`T92P02o`T92P;o2A8:
1ol92@X00ol94P[o6PT:o`000003o`T92P03o`000?l92@[o2@T:00Ko2@T:
00Co4A`:o`000?lA70[o00000_l92@X00ol94P[o0000o`T92P02o`TB2P?o
2@T:00?o0000o`TB2_l92@X00_l92@X00ol0003o2@T:o`T92P02o`T92P03
oa4L2_l0003o2@T:00?o2@T:00?o2A8:oa4L2_l000000_l92@X01ol0003o
2@T:o`T92_l92@[o2A8:o`000?l94PX01Ol92@X01?l94P[o2@T:o`000?l0
0002o`T92P0:o`TB2_l92ACo6Q8Do`T92_lS;bWo8d4moaXB5?l92ACo2@T:
o`T950;o2@T:00Ko2A8:o`000?mbSHCo2@TDoh>4S_l/EFl3o`TL7P;o2@T:
00Ko2A8:o`000?l92@[o2@T:o`TB2_l00002o`T92P04o`T95?l0003o2A8:
o`TB2PKo2@T:00?o2A8:o`T92_l94PX00_l92A@00olA70[o2A`No`TL7P02
o`T9500Co`TB2_l92@[o2@T:o`TB2_l92ACo2A8:oa4_<ol971Co0000o`T9
2_l94P[o2@TDoaXB5?m6EBWo?Ehmo`000?l94P[o6Q8DoaX92P02oa4L2P0B
o`TB2_lA70[o2@T:oa4L2_m6@AkoAT`mofYW<on=SFooCfM7of1N<onVXISo
AVMLo`000?n3NecoUJ6>og:=?Ol0003o2A8:0ol92@X01Ol0003oYYQ_odIE
:Old;ako4BHD00?o2@T:00?o6Q8Do`T92_lA70X01Ol92@X00olJ2@[o2@T:
o`T92P02o`T92P03oa4L2_lJ2@[o2@T:00Go2@T:00?o4A`:oaX92_l92@X0
1Ol92@X2oa4L2P0<o`T92_lA70[o6PT:o`T92_lA70[o6PT:o`T92_lA70[o
6Q8Do`TB2_l0003oYZ6HGoo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00
0oooool02oomoOgom?CdokNg]omiNGWoP820ohn?SonLW9coYJFUojb/[?na
/K7o]kNg00ko^k^k0onl_;`3okfm_@03okjn__nm_Kgo_[jn00;o_[jn0_no
_kl;ol30`0;o`L710_o2`/801?o3`l?oa<C4olC4a?o4a<@:olG5a@Goa/K6
0_o7alL00oo6a/KoalO7olO7a`03olO7a`gob<S800?obLW9ol[:b_o:b/X0
3oo;bl/3olc<c003olg=cOo<c<coc<c<00;ocLg=2oo>c/h2olo?c`?od=3@
00?odM7Aom;Bd_oCdm<00_oCdm<3omCDe0OoeMGE1_oFe]H2omOGe`Gof=SH
2ooIfMT3om[JfP;ofm_K0ooLg=`:omgMg@Gog]kN0_oOgml00ooNg]kogmoO
omoOg`03omoOg`Soh>3P0ooQhN42on;RhP;oi>CT00?oiNGUonOWiooWinL0
0ooXj>P:onWYj@?oj^[Z0oo/k>`2onk^kP_okno_0_o`l?03oo7al@03oo;b
l_oalO7ol_;b00;ol_;b0ooclo<>ooCdm004o`]C[OnUa>Ko]M3^ogV^k0;o
Ymco00CoMWIfol71`Oo`l?3ooOgmFoooool2oaXB50?o2A8:00?o4A`:o`TB
2_l92@X00_l92@X00olA70[o2@T:o`T92P07o`T92P03o`000?l92@[o2A8:
00Go2@T:00Co0000o`TB2_l92@[o2A8:2Ol92@X02?l94P[o2@T:o`T92_l9
2@[o0000o`TB2_l92@[o2A8:0_l92@X00ol0003o2A8:o`TB2P02o`T92P03
o`000?l92@[o2@T:00?o2@T:00Ko0000o`TB2_l94P[o2A8:oaX92_l00002
o`T92P06o`TB2_l92@[o2@T:o`000?l92@[o00000_l94PX4o`T92P03o`TB
2_l92@[o2A8:00Co2@T:00So2A8:o`000?l92@[o2@T:o`000?l92@[o2A8:
o`0000;o2@T:00Go0000o`TB2_l92@[o2@T:o`000002o`T92P03oaXB5?l9
2ACo6Q8D00;o2A`N00Co2@TDoaXB5?l94P[o2@T:0_l94PX02?l0003oLW9k
ocd_?OnEV:?o2@TDoa4V2_l92ACo6Q8D0_l92@X03Ol94P[o2@T:o`000?l9
2@[o0000o`T92_l0003o2@T:o`000?l92@[o0000o`T95?l94PX01?l92@X0
2ol94P[o2@T:o`T92_l94P[o2@TDo`TB2_l92ACo4Blco`T95?lA9Qko2A8:
00?o2@T:02?o2@TDoa4V7_l94P[o2BHYo`TB2_l92@[o2A8:oa4L2_lJ2@[o
AT4Noba<:Ol0003o2@T:oc@_7_lJ9QCo4A`:o`T92_l92ACo6Q8Do`T95?ld
;akoAUDYog9WD_mbSCgoLVMBog:=G?mkSFKoYZ6HoeN=G?l0003oUHeBofYW
<onEQ5;oSHe_oa4V5002o`T92P06o`TB2_l92@[o2@T:ob<V2_niV5coCfM7
0ol94PX2o`T92P03oa4V5?l92@[o6Q8D00;o2@T:00?o6PT:o`T92_l92@X0
3Ol92@X01?lA70[o2@T:o`T92_lA70X3o`T92P05oaX92_lS70[o4A`:o`T9
2_lJ4Q@00_l92@X01olJ2@[o4A`:o`T92_lS70[o6PT:o`T92_nVXIP0Gooo
ool01?n_[joobl_;omkNg_oZj^X1oo;blP001?o^k^h02_o[jn_oh>3PokRh
^?n1PH7oL71`ogQhN?n;Rh_oTY:BoiVIVOnQXJ4>ojJVYPKoYjNW00?oZ:RX
ojVYZOnZZZX01?nZZZX8oj^[Z`?o[:b/0_n][Jd2ojj^[P04ojf][On^[Zko
[Zj^ojj^[P;o[jn_3On`/;02ok6a/@03ok:b/_nc/k?o/k>c00_o/k>c0_nd
];@3okFe]@03okJf]_ne]KGo]KFe00;o][Jf0ong]kL:okRh^0?o^KVi00?o
^[Zjok^k^onk^k/00_nl_;`;okfm_@Go_[jn00?o`<30okno_oo1`L401Oo1
`L4:ol;2`PCo`l?31?o4a<@:olG5a@Koa/K600?oalO7olK6a_o7alL01?o7
alL8olS8b0?obLW90_o:b/X3olc<c0?oc/k>0_o?cll;om3@d0;odM7A0ooB
d]82om?Cd`_oe=CD1OoEeMD3omOGe`GofMWI2?oJf]X2om_Kf`?og=cL0_oM
gMd3omkNgP?ogmoO3_oPh>001?l;E;3oY<CVokSBk_mf[NX2ojcOo`04ofi^
K_nd];Coh>3Ponc/k5_ok^k^0_l94PX03?l92@[o2A8:o`T92_l94P[o2@T:
o`TB2_l92@[o4A`:o`T92_l94P[o2@T:oa4L2P?o2@T:00?o2A8:o`T92_lA
70X00ol92@X01ol94P[o2@T:o`T92_lA70[o0000o`T92_l94PX00ol92@X0
0olA70[o2@T:o`TB2P06o`T92P0:o`000?l94P[o2@T:o`T92_l94P[o0000
o`TB2_l0003o4A`:o`T92P?o2A8:1?l92@X00ol0003o2@T:o`T92P03o`T9
2P04o`000?l94P[o2@T:o`T92P;o2A8:0_l92@X01?l0003o2A8:o`T92_l9
4PX2o`00000=o`TB2_l92@[o2@T:o`TB2_l92@[o0000o`TB2_lA70[o0000
o`TB2_l0003o2A8:o`T92P02o`000006oa4L2_l0003o2A8:o`T92_l0003o
2@T:0_l000000ol92@[o2A8:o`T92P05o`TB2P03o`TL7_l971Co2@T:00;o
2A8:0_l92@X01?l94P[o;5ELoh>HS_l/Ie`2o`TL7P03o`TB2_l971ko2A8:
00;o2@T:00?o0000o`TB2_l000000_l94PX00ol0003o2A8:o`T92P02o`T9
2P;o000000Co2A8:o`T92_l94P[o2A8:0_l92A@02Ol94P[o2@T:o`TL5?l9
2ACo4BHDoa4_?OlA9QCo2A`Do`T95002o`TB2P;o2@T:00?o2A`Do`TL7_l9
71@00ol92@X07_lA70[o;3PYoa4V5?l0003o2@TDoaX92_lS;ako8bH:ob`V
5?l94P[o6RHDoaXL7_mZEAkoNheVohf=D_mZNfooEfMBodmWAonVXISoUJ6>
ohf=Kol0003oUHeBodmWAomZEAkoSHe7ohf=Kol/C2Wo0000o`TB2P;o2@T:
00Oo0000odIE:Om6EBWoUHeBoc@_:Ol92@[o2@TD00Co2@T:00?o4A`:o`T9
2_l92@X00_l92@X01?lA70[o2@T:o`T92_lA70X6o`T92P03oa4L2_l92@[o
2@T:00;o4A`:1Ol92@X01olA70[o2@T:o`T92_lJ4QCo;3PYoaX92_lA70X0
1?l92@X01?lJ4QCo2@TDo`000?nVZZeOonk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q0004onKViP08onCTi?oPh>3od];Bokbl_?nPX:3oR8R8ogUiNOmb
LW;oofi^KPgoKVi^00WoJ6QXofEUIOmOGeooF5QHodY:B_l;DZcoY/KVokK@
k_mi[nh00_n[g_l01?mZJV[o[Zj^omSHf?oTi>AKonKViP07oaXB5?l92@[o
4A`:o`000?lA70[o2@T:o`TB2P02o`T92P03o`TB2_l0003o2@T:00?o2@T:
00Go4A`:o`T92_lA70[o2@T:oa4L2P02o`T92P05oa4L2_l92@[o2@T:oa4L
2_l000000_l92@X00olA70[o2@T:o`T92P03o`T92P05o`TB2_l92@[o2@T:
o`TB2_l000000ol92@X00ol0003o2@T:o`T92P04o`T92P06o`TB2_l0003o
2@T:o`000?l92@[o4A`:0_l92@X00ol94P[o2@T:o`T92P06o`T92P;o2A8:
00Ko0000o`T92_l0003o2@T:o`TB2_l00005o`T92P03o`TB2_l0003o2@T:
00;o2@T:00?o2A8:o`000?l94PX00ol92@X02Ol94P[o2@T:o`T92_l0003o
2@T:o`000?l94P[o0000o`TB2P03o`T92P05o`000?l92@[o2A8:o`000?l9
2@X00ol92A@00ol94P[o2@TDo`TB2P02o`T92P06o`TB2_l92ACo0000ob=1
?Ol9@DOo4Blc0_l92A@01?lJ71ko0000o`TB2_l00003o`T92P;o000000Go
2@T:o`000?l0003o2A8:o`000002o`T92P05o`TB2_lJ4QCo2A8:o`T92_lJ
4Q@00ol94PX2o`T9500=o`TL7_lS@Cgo2A`Do`T95?l94P[o2@T:oa4L2_l9
4P[o4Blco`TL5?l971ko2A8:o`000002o`T92P0=o`TB2_l92@[o2@T:o`TB
2_l92@[o4A`:ob<V2_lJ9QCo8bH:oaXV5?m6@AkoSHe7ohfHSP02ofYkK`0>
of1N<on=SFooYZ6Hoh=kG?lA9P[o0000ofYW<omGSEco8a`:ofYE7_nVXFKo
YZ6Hog:=G?l00002o`T92P0;o`000?l92@[o0000of11:OmkSFKoLXdmodIE
:Ol92@[o2A8:o`T92_lA70X00_l92@X01_lA70[o2@T:o`T92_lA70[o2@T:
oaX92PCo2@T:00Co2A8:ob`B0?l92@[o4A`:1_l92@X04olA70[o2@T:o`T9
2_l/4P3o0000oa4L2_l92@[o2A8:o`T92_lA70[o2@TDo`T92_lA70[o2@T:
oa4L2_lJ2@[o2@T:o`000?nVXIP0GooVi^H01?nMWIgo]kNgolS8b?oCdm<1
om[JfP001?o^k^h02_o[jn_oh>3PokRh^?n1PH7oKFe]ogAdM?n2PX;oQhN7
ohf=SOnEUID>oiZJVPKoVi^K0_nLW9`5oifMW@_oWYjN0_nOWil2oj2PX004
oinOWonPX:3oX:2Poj2PX0goXJ6Q0_nRXZ82oj>SX`03ojBTY?nUYJGoYJFU
00?oYZJV2?nWYjL5ojRXZ003ojVYZOnXZ:SoZ:RX00GoZJVY2_nZZZX3oj^[
Z`03ojb/[?n][Jgo[Jf]00;o[Jf]2on^[Zh5ojn_[`;o/;2`1_na/K4:ok:b
/P?o/k>c00?o]KFeokBd]?nf][H00_nf][H:okNg]`go^;Rh2?ni^KT5okZj
^P?o_;bl0onn_[h2okno_`_o`<300_o1`L43ol;2`P;o`l?32oo4a<@5olG5
a@03olK6a_o7alOoalO700GobLW92?o:b/X2ol_;b`?oc<c<00?ocLg=olc<
c?o=cLd00_o=cLd3olk>cPkoclo?00Co2U6]ojC3iOnhd^ooNJk/0_n/gol0
1?m^KVko];Bdon3Ph?o/k>aKonk^kP03o`TB2_l92@[o2A8:00?o2@T:00Co
4A`:o`T92_l92@[o2A8:0ol92@X00olA70[o2A8:o`TB2P02o`T92P04oa4L
2_l0003o2A8:oa4L2P?o2@T:0_l94PX4o`T92P06oa4L2_l92@[o2@T:o`T9
2_l94P[o2@T:1?l94PX2o`T92P03o`TB2_l92@[o2@T:00;o2@T:00?o2A8:
o`000?l94PX00_l92@X00olA70[o2@T:o`T92P02o`T92P04o`TB2_l0003o
2A8:o`TB2P?o2@T:00So2A8:o`T92_l94P[o2@T:oaX92_l92@[o4A`:o`T9
50Go2@T:00?o2A8:o`T92_l92@X00_l92@X01?l94P[o2@T:oaX92_l00003
o`T92P03o`TB2_l92@[o000000;o2@T:00Go2A8:o`000?l92@[o2@T:o`00
0004o`T92P03o`TB2_l92@[o2@T:00;o2A8:00?o2@TDo`TB2_l94PX00_l9
71@03?l94P[o2@T:o`TB2_l92@[o2@TDoa4V5?l94P[o2BHYo`T92_l971Co
4Blco`0000?o2@T:0_l94PX3o`T92P05oa4L2_l94P[o2@T:o`T92_l00000
0_l92@X01?lJ9QCo6Q8DoaXL7_lJ4Q@2o`TL500@o`TB2_l92ACo6Q8Doa4V
7_lA;c?o2A8:oaXB5?l94P[o2@T:o`TB2_l92ACo2BHYo`TL5?lJ9QCo0000
oa4L2PKo2@T:00ko4A`:oa4V2_lJ9QCo8bH:ob`h:Om6@AkoPhAkoh>=Q?mZ
NfooLXeLohf=KombSCgo=5DYoa4V2P;o000000Ko2A8:ohf=Kol0003o8bH:
odI17_n3GQ@2ojJHK`0<o`000?l92@[o2@T:o`T92_l94P[o4A`:o`000?n3
GS?o/:Z4oh=k<ol0003o4A`:1Ol92@X01_lA70[o2@T:oa4L2_lA70[o0000
ob<L2P;o2@T:01ko4A`:o`T92_l92@[o2@T:oa4L2_l92@[o6PT:o`T92_lJ
2@[o;180oaX92_l92@[o4A`:oaX92_l92@[o8a`:o`T92_lJ2@[o2@T:o`00
0?lJ4QCo4A`:oaXB5?l92@[o6PT:oa4L2_lJ2@[o4A`:o`000?nVZZ=Oonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0003ooooo`0;oogmoOodm?Co]kNg
ogMgMomnOWkoS8b<oiZJV_nSXj?oZZZZok:b/_nf][H04Onh^;P4oogmo@;o
oOcm0oomoO/01oomoOWon_cgoo?hlOo_m>gojo3Yon;YhOoJh]L01?oEgM04
omCLccSoeMg@2?oFg=87omOMd`09omKNdOoDgL[of>7<on7Xf?oYkn7oloK_
ooSjmoomoOgooOcm00?ooO_m00?ooOcmoogmoOomoOd00_omoO/00oomoOgo
dm?Com?Cd`07om?Cd`Koe=CD0_oEeMD5omKFePkoemOG0_oHf=P=omWIf@?o
f][J0_oKfm/3omcLg0?ogMgM0_oNg]h;omoOg`;oh>3P0ooRh^82onCTi0_o
iNGU0_oWinL3onSXj003on[Zj_oYjNWojNWY00;ojn_[0oo/k>`8onk^kP;o
kno_0oo`l?02oo;blP?om?Cd0ooemOD>ooKfmP04o`eD[OnUa>Ko]];^ogV^
j@;oZ^3o00CoMWIfol71`Oo`l?3ooOgmFoooool01?lJ4QCo2@TDo`T92_l9
2@X2oa4L2P03o`T92_lA70[o2@T:00[o2@T:00?o4A`:o`T92_l92@X00ol9
2@X00ol94P[o2@T:o`T92P05o`T92P0:oa4L2_l92@[o0000oa4L2_l92@[o
0000o`TB2_l0003o2A8:o`T92P;o00000_l94PX00ol0003o2@T:o`T92P02
o`T92P03o`TB2_l0003o2A8:00Go2@T:00Go0000oa4L2_l0003o2@T:o`00
0002o`T92P0;o`000?l92@[o2@T:o`T92_l0003o2@T:o`000?l94P[o2@T:
o`000?l92@X00_l000001_l94P[o2@T:o`T92_l92@[o0000oa4L2PCo2@T:
00Wo6PT:oa4L2_l92@[o2@T:o`TB2_l92@[o0000o`TB2_l000000_l92@X0
0ol0003o2A8:o`T92P05o`T92P05o`T95?l94P[o2@TDo`T95?l971h00_l9
2@X2o`TB2P;o2@TD00Ko4BHNo`TL7_l971Co2A`No`TV:Ol00002o`T92P03
o`000?l92@[o000000?o2@T:0_l000002ol94P[o2@T:o`TB2_l92@[o2A8:
o`T95?lJ2@[o;1`Do`TV:Ol971ko2A`D00;o2@TD00[o4BHNoa4_<ol971Co
2@TDo`TB2_l92@[o6Q8Do`T95?lJ4QCo4BHN0_l971h00ol92@[o0000o`TB
2P02o`T92P0<oaXB5?l94P[o4A`:oaXB5?lA9QCo6RHDoc@_7_m?IdOo/:Z4
og:=?Om6EBWo8bH:1?l000003Ol92ACo0000of1N<ooLaj?o0000oa4L2_l/
71CoJUDNohf=Aon=SE;oUIQVo`000?l94PX01?l92@X01ol0003oAUDYoh=k
<on=SFooAUDYo`T92_l94PX00ol92@X01_l94P[o2@T:o`T92_l0003o6PT:
oa4L2PGo2@T:00?o4A`:o`T92_lJ2@X03?l92@X01?l0003o2@T:oa4L2_l0
0002o`T92P07ob<L2_l94P[o6PT:o`T92_lJ2@[o0000ojJZX`1Oooooo`04
ojn_[oo;bl_og]kNon[ZjP7ol_;b0003onk^kP0;onWYjOo5aLGoNGUioj2P
X?nm_Kgo/;2`ojj^[_ne]KGo_;blokjn__o5aLD04Oo8b<P6ooono`;oooom
00WooookoocmmoobmNkoi>[PomcRf?oGgmCodMW<ol[B`onmb;L00_nmbKD3
okc8]0;o^lNc=onmbKD00onmb;Oo_lNhoko7^006oko7^0Oo_/Jg00Wo_/Nd
ol?=]?o6dkOocmW1omGNbooMhmOoj>[Uoo?em?okn_l01_ooo_l2ooooo@03
oooooooPh>3oh>3P00[ohN7Q0ooRh^82on?Sh`?oi>CT2_oUiND6onKViP;o
j>SX1OoZj^X;on_[j`;ok>c/0_o]kNd01?o/k>cokNg]ong]kOo]kNd:onk^
kPGokno_0oo`l?05oo7al@Sol_;b0_oclo<3ooCdm003ooGemOofm_Kom_Kf
00;omoOg0oohn?P:ooWin@?on_[j0_olo?`3ooknoQ7ooooo00Co35B^ojK6
i_nidnkoNJk[0_n[gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP04o`T95?lA
70[o2A8:oa4L2P;o2@T:00Go2A8:o`T92_lA70[o2@T:o`TB2P02o`T92P04
oa4L2_l94P[o4A`:oa4L2PSo2@T:00?o2A8:o`T92_l92@X01Ol92@X01?lA
70[o2@T:o`T92_l00002o`TB2P07o`T92_l0003o2A8:o`000?l94P[o2@T:
oaX92P02o`000005o`TB2_l92@[o2A8:o`TB2_lA70X01_l92@X01?l0003o
2@T:o`000?lA70X4o`T92P03o`TB2_l0003o2@T:00;o2@T:00co0000o`T9
2_l92@[o0000oa4L2_l92@[o0000oa4L2_l0003o2A8:o`T92_l00006o`T9
2P08o`TB2_l92@[o2@T:o`000?l92@[o0000o`T92_l00004o`T92P03o`00
0?l94P[o2@T:00?o2A8:0ol92A@2o`TB2P03o`T95?l94P[o2@T:00;o2A8:
00?o2@TDo`TV:OlA;cd00_l92A@00ol971Co2@TDo`000002o`T92P04o`T9
5?l92@[o2@T:o`T92P;o2A8:1?l92@X02?l0003o2A8:o`T92_lS;c?o8blN
oaXB5?m6EE;o2A`N0_l92A@03Ol971Co2BHYo`TV:OlA9QCo0000o`T92_l0
003o2A`Do`T92_lA;cgo4A`:oa4V7_l92A@00_l92@X07ol94P[o2@T:o`TB
2_lJ9QCo2@T:ob<V2_lJ9QCoH44Yog9WD_n=SDOoJW9Lol6cS_lA9P[o;4`Y
oa4V2_l92ACo2A8:oa4L2_l94P[o0000oh=N<oo1al7o2A`No`000?lA70[o
6Q8Dof115?nVV6oo/:Z4okVZKol000000_l94PX3o`T92P06o`TB2_l92@[o
CfM7oh=k<on=SE;o00000_l94PX00ol92@[o6PT:o`T92P02o`T92P03oa4L
2_l92@[o2@T:00Go2@T:00Co6PT:o`T92_l92@[o2@T:0_lA70X02?l92@[o
6PT:oa4L2_l92@[o6PT:o`T92_lA70[o6PT:0_lA70X01?l92ACo2@T:oa4L
2_lA70X2o`T92P06oaX92_l92@[o6PT:oa4L2_l0003oYZZ]Goo^k^h01?nS
Xj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H03?oUiNGogMgMohj>S_nATI7o
c<c<omGEeOo2`/;o^KViol30`?o4a<CobLW9ol[:bQ7od=3@1Oooo_l2oooo
o@0:oooonoohnO?ol??ZomoUfOo:d/?o_/JgokW2/Ond_JcoZkNQoj:`U`?o
XJnE0_nP[Y@2oin]TcSoWJ^A00?oWZZBoj2YU?nPZI@01OnPZI@7oj:[UP09
oj2]TonW]I;o[;ZFok:oXOnh`ZWo_lRgol_Cb?oMh]cojNg^00;oo_oo1?oo
o_l2ooooo@03oooooooVi^Koi^KV00Ooi^KV1_oWinL00ooXj>SojNWYon[Z
jP04on[ZjP_ojn_[0oo/k>`2ong]k@?ok^k^2_o_knl3oo3`l0;olO7a0_ob
l_801?oalO7ol_;boo;bl_obl_82oo?cl`Som?Cd1OoemOD3ooKfmPGomoOg
2_ohn?P3ooWin@03oo_knoolo?coo?cl00;oo_kn9_ooool01?l@EjooXl;T
okSCkomg[^/2oj[Oo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00Wo6Q8Do`TB
2_l92@[o2@T:oa4L2_l92@[o4BHDo`T92_l94PX03_l92@X00ol94P[o2@T:
o`T92P0Bo`T92P08oaX92_l94P[o0000o`T92_l94P[o0000ob<V2_lJ2@X2
o`T92P;o2A8:0_l92@X01ol94P[o2@T:o`T92_l92@[o0000o`T92_l94PX0
0_l92@X00olA70[o2@T:o`T92P03o`T92P03o`000?l92@[o2@T:00;o2@T:
00?o0000o`TB2_l92@X02Ol92@X2o`TB2PCo2@T:00?o0000oa4L2_l92@X0
0_l92@X01?l0003o2@T:o`TB2_l94PX2o`T92P03o`TB2_l92ACo2A`D00?o
2@TD00go2A8:o`T92_l92@[o2A8:o`T92_l92ACo4BHNo`TV:Ol92ACo2@T:
oa4_<ol92ACo2A8:00;o00000ol92@X01_l0003o2@T:o`T92_l0003o2@T:
o`0000Co2@T:00Oo;3PYoaXB5?l92@[oPhAkoa4_<ol971ko6Q8D00;o4BHN
00?o4Blco`TL7_l92A@00_l94PX00ol971ko2A`Do`TV:@02o`TV:@0Ao`T9
5?l92@[o2@T:o`TB2_l92ACo2A8:oa4L2_lS;akoAT4NoeMED_nEQ5;oSIR>
og^=Q?nVV8CoSHe7o`000?lJ2@X00_lJ4Q@01Ol92ACo0000oc@_7_nESFKo
g>?P00;o00000_l92@X01olJ9QCoARl:ofYW<onESE;oWW/coa4V2_l00000
1Ol92@X01ol0003oAT4Nog^=I_nESE;oH5hco`000?l94PX00_l92@X2oa4L
2P03o`T92_lA70[o2@T:00;o2@T:00?o4A`:o`T92_lA70X00_l92@X01OlJ
2@[o2@T:o`T92_lJ2@[o2@T:00;o6PT:0_l92@X02OlA70[o2@T:oa4L2_lJ
2@[o2@T:oaX92_lA70[o8a`:oaX92P03o`T92P?o4A`:00?o6PT:o`000?nV
ZZ<0GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h03?o]kNgo
h>3PogYjN_nl_;cof=SHom_Kfoo>c/ko`<30olG5aOo:b/[oc<c<olo?ca7o
dm?C0_oooOl05_ooo_oooogooooooooooogooOkhooCgk_oWkN7oe=g<ol39
]_nb_ZSoZKFMoin/T_nFXhWoT9f1ohnNOOn<W7SoR9QdohFELOn3TfooQ9A`
ohNGLon8V7@hohFEL@coQYAc00koQiEdohVGM_n:V7OoS9Ygoi6PMonBXgOo
UZJ1oibZROnU/IWo];n^olO?a?oCf]?oi>SWoo7emP;ooOko00Goo?cnoogm
oOoooogoooklooooo`02onSXj0[ojNWY0ooZj^X2on_[j`?ok>c/2_o]kNd3
onk^kP?okno_00?olO7aoo3`l?obl_800_obl_82oo?cl`Som?Cd1OoemOD3
ooKfmPGomoOg3Oohn?P3ooWin@oon_[j0ookno/00oolo?cooOgmoogmo@02
ooknoRKooooo00Co45J_ojG4i_nidnooMjk[0_nYg?l01?m^KVko];Bdon3P
h?o/k>aKonk^kP03oaXB5?lA70[o2@T:00?o2@T:00?o2A8:o`000?l92@X0
0ol92@X00ol94P[o4A`:o`T92P04o`T92P03o`TB2_lA70[o2@T:00;o2@T:
00?o0000oa4L2_l92@X00ol92@X00ol0003o2@T:o`T92P04o`T92P05o`00
0?l92@[o2@T:o`000?l94PX02?l92@X00ol0003o4A`:o`T92P02o`T92P06
o`TB2_l92@[o2A8:o`000?l92@[o2A8:1?l92@X00ol92ACo4BHDoaXB5002
o`T92P09o`000?l92@[o2@T:o`TB2_l0003o2@T:o`000?l94P[o000000?o
2@T:00?o2A8:o`T92_l92@X00ol92@X00ol94P[o2@T:o`T92P02o`TB2P04
o`T92_l94P[o0000o`T92P?o000000Co2A8:o`T92_l94P[o2@T:1?l94PX0
1Ol92ACo2A`NoaXB5?l92ACo000000?o2A8:00Go0000o`T92_l92ACo2@TD
oa4_<`02o`TB2P03o`TV:Ol92@[o000000;o2@T:00Co0000oa4L2_lA70[o
2A8:1?l92@X00olA70[o0000o`000003o`T92P08oa4V7_l/71Co;5hmo`TB
2_lA9QCo2A`No`TL5?l99RT2oa4V7P0Ro`TB2_lJ4QCo2@TDoa4V7_l99RWo
2A8:oa4_<ol/GSgo2@T:o`TB2_l92@[o2@TDoa4L2_l94P[oARHDodI17_n=
SE;oNheVoiFHXomkSFKoCfM7ohf=Aol0003o6PT:oa4L2_l92ACo2A`Do`00
0?n3Neco`K>]omcSe_l/GSgo0000oa4L2P;o2@T:00Ko8a`:odHV5?nNNc?o
UIQVojJQI_ldEBT4o`T92P09o`TB2_l92@[o2A8:o`000?mZEAkoUHeBoh=k
G?ldEBWo000000So2@T:00?o6PT:o`000?l92@X00_l92@X02?l0003o4A`:
o`T92_l92@[o6PT:o`T92_lA70[o6PT:1Ol92@X01_lJ2@[o4A`:o`T92_l9
2@[o0000o`T92P?o4A`:0olJ2@X00ol92@[o0000ojJQV01Oonk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q0002ooooo`04oogmoOo_knooLg=com7Ad@;o
g=cL00Kod=3@olC4a?o9bLWoc<c<olo?cooBd]8AomGEe@;ooogo04coooko
oooooooooogoo_okooGhkooYkn7obmC1okk:]?n`_J?oX[6Boi>QP?n0T6co
M89OofinFOmdQE_oLhAHog>4F_mbPeOoLX=Iog:3EomcQ5[oLhAHogF6G?me
QU[oMHILogF6F_meQUcoMHIJogF6G?meQU[oMHILogF6F_meQUcoMHIJogF6
G?meQU[oMHILogF6F_meQUcoMHIJogF6G?meQU[oMHILogF6F_meQUcoMHIJ
ogF6G?meQU[oMHILogF6F_meQUcoMHIJogF6G?meQU[oMHILogF6F_meQUco
MHIJogF6G?meQU[oMHILogF6F_meQUcoMHIJogF6G?meQU[oMHILogF6F_me
QUcoMHIJogF6G?meQU[oMHILogF6F_meQUcoMHIJ0_meQU`2ogJ5G00IogJ5
G_mfQEcoMXENogJ5G?mfQEkoMXELogN6GomgQUgoMXENogJ5G?mgQUooN8MN
ogV8HOmjREkoO8iNog65E?maQ5OoOi5YohjOOOnIZHkoZ[NSok[6^?o@f]7o
hn[SooKkm`02ookoo`04ooooooooo_oooognooooo`;oinOW1ooXj>P3onWY
j@?oj^[Z0_o/k>`3onk^kP;okno_3_o`l?000ooalO7ol_;boo?cl`0?oo?c
l`;om?Cd0ooemOD3ooKfmP[omoOg0oohn?P2ooWin@?on_[j0_okno/3oocl
o0gooOgm0oono_hXooooo`04o`aE/OnTa>Ko^M?_ogJ]jP;oZn3o00CoMWIf
ol71`Oo`l?3ooOgmFoooool2o`T92P04oa4L2_l92@[o4A`:o`T92P;o2A8:
2Ol92@X00ol94P[o4A`:o`T92P07o`T92P03oa4L2_l0003o4A`:00Go2@T:
00[o2A8:o`T92_l92@[o2@T:o`000?l94P[o2@T:o`000?l92@[o4A`:2_l9
2@X01ol0003o2A8:o`000?lA70[o2@T:o`000?l94PX00_l92@X00ol94P[o
4BHDo`T92P05o`T92P03o`TB2_l0003o2A8:00Go2@T:0_l94PX00ol92@[o
2A8:o`T92P03o`T92P06o`000?l92@[o2@T:o`T92_l0003o2A8:0_l92@X2
o`TB2P;o2@T:00?o0000o`TB2_l92@X00ol92A@2o`TB2P;o2A`D0_l94PX0
0ol92@[o2A8:o`TB2P02o`T92P0:o`TB2_lA9Qko4Blco`TV:Ol92@[o2A`N
o`T95?l94P[o2@T:o`TB2P?o2@T:00[o8a`:o`000?l94P[o0000o`TB2_l9
2@[o0000o`TB2_l92@[o2A8:0_l92@X2o`TB2P05o`000?lA9Qko4BH:o`TL
7_lJ71h00_lA9Qh02_l971Co2@TDo`T95?lA9QCo4BHNo`TL5?lA9Qko8blc
odmNI_l00002o`TB2P0GoaXB5?lA9QCoH44Yog9WD_mkSFKoYZ6HojJZXomk
SFKo;4`Yoa4V2_l0003o6Q8Doa4L2_lA9QCo0000odHV5?nEV6Ko`LO1ol[@
e_mZNfoo4BH:oa4L2_l92@X00_l94PX02?lA70[o;1`Doh=k<oniZVoo/:Z4
ofYW<ol0003o2A8:0_l92@X02?l0003o2@T:o`T92_l94P[o6Q8Dohf=Aon3
NecoPg/c0_l94PX01_l92@[o4A`:o`T92_lA70[o2@T:oaX92P;o2@T:0olA
70X03_l92@[o4A`:oaX92_lJ2@[o2@T:o`000?lJ2@[o2@T:oaX92_l94P[o
2@T:oa4L2_l92@[o4A`:0_l92@X01?lJ2@[o2@T:oa4L2_lJ2@X3o`T92P06
oaX92_l92@[o6PT:oa4L2_l0003oYZZ]Goooool01?n_[joobl_;omkNg_oZ
j^X1oo;blP000_o^k^h03?o/k>cogMgMog5aLOoGemOog]kNomoOgooDe=Co
a<C4olO7aoo<c<cod=3@om;BdPkoe]KF0ooGemL2ooomo`1<ooonoooooooo
o_okooSnm?oWkn3oeN7=ol;@]on[^Y_oTj=oohVKLonBXgOoYKR:okg?Woo<
gZkohoG5onKfaOoYnL[ojo_:onclcOo/o<_oj_[;onWib?o[nlcojo_:on_k
c?o[nl[ojo_<on_kb_o[nlcojo_:on_kc?o[nl[ojo_<on_kb_o[nlcojo_:
on_kc?o[nl[ojo_<on_kb_o[nlcojo_:on_kc?o[nl[ojo_<on_kb_o[nlco
jo_:on_kc?o[nl[ojo_<on_kb_o[nlcojo_:on_kc?o[nl[ojo_<on_kb_o[
nlcojo_:on_kc?o[nl[ojo_<on_kb_o[nlcojo_:on_kc?o[nl[ojo_<on_k
b_o[nlcojo_:on_kc?o[nl[ojo_<on_kbP;ojo_<0_o]n/`07?o]n/kokO[<
ongjc_o]n/cokO[>ongjc?o]n/kokO[<oncicOo/nL_ok?W=onciboo]n/ko
k?c;omgb^_o8gjOo]/fIojNmS_nAYW_oPiMboiJWQonda:[o_LZfom7NcOoY
lnSon?ohookooOonool3ooooo`;ojn_[3Oo/k>`00oo]kNgok^k^ono_k`0<
ono_k`?ol?3`0ooalO400ooclo?ol_;booCdm002ooCdm0;omOGe2?ofm_H7
ooOgm`Kon?Sh2ooinOT2oo[jnP;oo?cl00?ono_koogmoOomoOd04Oono_hZ
ooooo`04o`aD[_nUa>Ko]M3^ogV^k0;oYmco00CoKVi^okBd]?oPh>3ok>c/
Foo^k^h2oa4L2P08o`T92_lA70[o0000oaX92_l94P[o2@T:o`TB2_l92@X2
o`TB2P09o`T92_l94P[o2A8:o`TB2_l92@[o4A`:o`T92_l0003o2@T:00;o
2A8:0_l92@X01?lA70[o2@T:oa4L2_l92@X2oa4L2P;o2@T:00_o4A`:o`T9
2_lA70[o2A8:o`T92_lA70[o2@T:o`TB2_l0003o2@T:oa4L2P07o`T92P;o
2A8:0ol92@X02?l94P[o2@T:o`T92_l92@[o0000o`T92_l94P[o2@T:0_l9
4PX2o`T92P03o`TB2_l92@[o2@T:00;o2@T:00?o2A8:o`T92_l000000_l9
4PX01Ol0003o2A8:o`TB2_l94P[o000000;o2@T:00Go2A8:o`T92_l92@[o
2@T:o`TB2P02o`T92P04o`000?l94P[o0000o`TB2P;o000000go2A8:o`T9
2_l0003o0000o`TB2_lJ4QCo2A`Doa4V5?l92ACo2A8:oaXB5?l971ko2@TD
00?o2A8:00Oo0000o`T92_lA70[o2@TDo`TB2_lA;e;o2BHY00;o2A8:00Go
2A`No`T92_l92@[o0000o`TB2P03o`000003o`TB2_l92@[o2@T:00;o2A8:
0ol92@X2o`0000;o2A8:00Co2@T:oaXB5?l971Co2@TD0_lA9Qh2o`TV:@0@
o`TL7_l971Co4BHDoa4V5?l99RWo2A`NoaXL7_l/EEco;6MLo`000?l94P[o
0000oc@_7_m6@AkoSHe7og^=IP;oYZ6H013oEheLo`000?l92@[o2@T:o`TB
2_lA9P[o2A`Do`T92_mZIc?o`K>]ol77`OoLhn3o?Ehmo`000?mZEAko;2HD
0ol94PX01olA70[oARl:ofYE7_nVQ5;oYZ5Voij=<ol000000_l94PX00ol9
2@[o4A`:o`TB2P02o`T92P08o`000?m6EBWoYYQ_ok2ZQ?m69QCo0000o`T9
2_lA70X2o`T92P08o`TB2_l92@[o2@T:o`T92_lA70[o2@T:oaX92_l94PX2
oaX92PCo4A`:0_l92@X00olJ2@[o;180o`T92P02oa4L2P05oaX92_lA70[o
4A`:oa4L2_l92@X01?lA70X01_l92@[o6PT:oa4L2_lS70[o0000ol6c[Eoo
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV00Coi>CTomCDe?mg
MgOofMWI0_oPh>001_oDe=CoalO7ol[:b_o>c/kod];BomCDe0koe]KF0ooG
emL0C_oooOooookoooooooonooooo?okoo7ik?oGhloo`LnfojbmWOnJ[hSo
TZQjoj6gQ_nneIoof?2fonKn`_o^olSoj__5oncmbOobolgoloo@ooKodOoc
om3oloo>oo3ocOoaolcokoo<oo7oc?o_olcolOo<onooc?oaolcokoo<oo7o
c?o_olcolOo<onooc?oaolcokoo<oo7oc?o_olcolOo<onooc?oaolcokoo<
oo7oc?o_olcolOo<onooc?oaolcokoo<oo7oc?o_olcolOo<onooc?oaolco
koo<oo7oc?o_olcolOo<onooc?oaolcokoo<oo7oc?o_olcolOo<onooc?oa
olcokoo<oo7oc?o_olcolOo<onooc?oaolcokoo<oo7oc?o_olcolOo<onoo
c0ColOo<01golOo>oo7oc?oaolkolOo<oo7oc_oaolcol_o?oo;ocOoaolko
lOo<oo3ncOo`o/_ol?k=onkobOoXolCoi?o3on?oa?oHm;[o^MBOoiF_Oon:
XGGoSZAnoj^nW_o0d;KofNKDoncfjoogo?KooOolookoo`02ooooo`;oj>SX
1ooYjNT3on[ZjP?ojn_[00?okNg]onc/k?o^k^h00_o^k^h2ono_k`_ol?3`
0ooalO42oo?cl`?omOGe2_ofm_H=ooOgm`_on?Sh0_oinOT2oo_kn`03oocl
o?ono_koo_kn03_ooooo00Co35FaojC4i_nhd^koMZgZ0_n/gol01?mZJV[o
[Zj^omSHf?oTi>AKonKViP05o`T95?l92@[o2@T:oa4L2_l94PX00_lA70X0
1?l94P[o2@T:oa4L2_l00004o`T92P03oa4L2_l92@[o2@T:00;o2@T:00[o
2A8:o`T92_l94P[o4A`:o`T92_l94P[o2@T:oa4V2_l92@[o2A8:0_l92@X2
oa4L2P;o2@T:00?o2A8:o`T92_lA70X00_l92@X01Ol94P[o4A`:o`T92_lA
70[o2@T:00;o2A8:00Ko2@T:o`TB2_l94P[o2A8:o`000?l94PX5o`T92P?o
2A8:00?o0000o`T92_l92@X00ol92@X01Ol0003o2@T:o`T92_l94P[o0000
00;o2@T:00Ko2A8:o`T92_l92@[o2A8:o`000?lJ2@X4o`T92P05o`TB2_l9
2@[o2A8:o`000?l92@X00_l94PX01Ol0003o2@T:o`TB2_l0003o2@TD00;o
2@T:00So2A8:o`T92_l92@[o2@T:oa4V5?l92@[o2A`Do`T950;o2A`N00Ko
2A`Do`T95?l92ACo2A8:o`T95?l92@X2o`TB2P0Bo`T95?l971ko4Blcoa4V
7_l92ACo2A8:o`TV:Ol94P[o0000o`T92_l0003o2@T:oa4L2_l0003o2A8:
o`T92_l94P[o00000ol92@X2o`TB2P03o`T92_l0003o2@T:00;o2A8:0_l9
2A@01?lA9QCo4Blcoa4V7_lA9Qh2o`TL500Qo`TB2_l971ko8d4mo`TL7_lS
@Cgo8d5Boa4_<ol0003o2@TDoc@_7_mZIc?oLVMBoiFHXonVZZ?oSHe_oa4V
2_l0003o4A`:oaXV5?l/9QCoAT4No`T95?l0003oPehcol6c[Oo1alcokNgZ
odINAol94P[o=2lNoaXB5?mbSCgo4BH:00;o2A8:00So;180ob`L5?n3GQCo
YZ5VokVHG?nVXFKo0000oa4L2POo2@T:00Wo;2HDoiF=I_nVV6ooLXdmo`T9
2_l94P[o2@T:oa4L2_l92@X00_lA70X00ol92@[o6PT:o`T92P05o`T92P04
oaX92_l92@[o6PT:o`T92P;o6PT:00Wo8a`:o`T92_lA70[o2@T:oaX92_l9
2@[o6PT:o`T92_l94PX00_l92@X02OlJ2@[o2@T:o`T92_lA70[o6PT:oa4L
2_lJ2@[o0000ol6c[@1OonKViP04oifMWOng]kOob<S8om?Cd`7of][J0002
onk^kP0<onc/k?oLg=coMWIfom[Jf_oPh>3ohN7QomCDe?o7alOobl_;olk>
c_o@d=3odm?C3_oEeMD3omKFeP1>ooomooooo_oooooooogoo?ogo_Koi_7Q
olSG`?n^`J7oTZR1oiN^P?nY`HgoaMjTomgg]_oUokgohObeomkd/oo]o/Oo
l?k;oo;nc?ocolkom?o>oo?oc_ocolgol_o=ooGocoodoloomOo?ooCocooe
oloom?o?ooGocoodoloomOo?ooCocooeoloom?o?ooGocoodoloomOo?ooCo
cooeoloom?o?ooGocoodoloomOo?ooCocooeoloom?o?ooGocoodoloomOo?
ooCocooeoloom?o?ooGocoodoloomOo?ooCocooeoloom?o?ooGocoodoloo
mOo?ooCocooeoloom?o?ooGocoodoloomOo?ooCocooeoloom?o?ooGocood
oloomOo?ooCocooeoloom?o?0ooeoll04?oeolgomOo?ooGocOoeoloomOo=
ooGocooeolgomOo?ooGocOoeoloomOo=ooCoc_ocol_oloo=onoobOoTo[l2
on7o_@0;on;o`?oPo/3ocnfaojo<U?nB[W_oV;:5oj_1Voo9fKooh^oMooCk
lookoo`00_onool00oooooook>c/onc/k007ong]k@Kok^k^00?ol?3`ono_
kooalO401?oalO4;oo;blPColo?c1?odm?@:ooGem@Gom_Kf0_ogmoL00oof
m_KomoOgooOgm`03ooOgm`_on?Sh0_oinOT2oo_kn`03ooclo?ono_koo_kn
03_ooooo00Co3UF^ojK6i_nfd>koNJo^0_n[g_l01?m^KVko];Bdon3Ph?o/
k>aKonk^kP04oaXB5?lA70[o2A8:o`TB2PGo2@T:00?o2A8:o`T92_l92@X0
0_l94PX3o`T92P03o`000?lA70[o2@T:00Co2@T:0_l94PX2o`T92P03oa4L
2_lJ2@[o000000Go2@T:00?o6PT:o`T92_l92@X01?l92@X02?l94P[o2@T:
o`TB2_l0003o2@T:o`TB2_l0003o2A8:0_l92@X00olA70[o2A8:o`T92P04
o`T92P03o`000?l92@[o000000;o2A8:0ol92@X00olA70[o2@T:oa4L2P03
o`T92P06oa4L2_l92@[o2@T:o`TB2_l92@[o2A8:0ol92@X01?lA70[o2@T:
o`T92_l94PX2o`T92P05o`TB2_l0003o2@T:o`T92_l000000_l92@X00ol0
003o2A8:o`000003o`T92P04oa4V5?ldECgo2@TDo`TV:@;o2A`D00?o4BHD
o`T95?l94PX00_l94PX04_l92ACo2A8:o`TB2_l92ACo2A8:ob<_<ol99RWo
2A8:o`T92_lA;cgo2A`Do`000?l92@[o2A8:o`T92_l94P[o2@T:o`0000;o
2@T:00?o0000o`T92_l92@X00_l92@X01_l0003o2@T:o`T92_l92@[o2A8:
oa4L2P;o2@TD00?o2A`Do`TL7_lA9Qh00_lA9Qh0:ol94P[o2A`Do`TL5?lS
;c?o4Blco`T95?mbSHCo;4`Yoa4V5?l92@[o;1`DodIE:OnEV6KoUJ6>ok2Z
Q?mGSEco0000o`T92_lA9P[oH44Yoh=k<oldEBWo2A8:o`000?o1/hko/;>g
ol77`OoLhn3oJW]_o`000?lS9P[o8a`:ob<V2_lJ4QCoPg/co`T95?l94P[o
4A`:oaX92_mZEAko^Hdcol6cS_nVXFH00_l92@X01OlA70[o2@T:o`T92_l9
2@[o4A`:00;o2@T:00Ko0000ohf=D_mkSFKo`K>>oa4V5?lA70X5o`T92P04
oa4L2_l92@[o4A`:o`T92P;o4A`:00?o2@T:oa4L2_lA70X00_l92@X01olJ
2@[o2@T:oaX92_lJ4QCo4A`:oaX92_lA70X00olJ2@X03OlA70[o2@T:oa4L
2_lA70[o6PT:o`T92_lA70[o6PT:oa4L2_lJ2@[o4A`:o`T92_nVZZd0Goo^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool01?omoOgok>c/ogal
O?oJf]X2on3Ph006om?Cdoo6a/Koc<c<olk>c_o@d=3odm?C3_oGemL3omSH
f01?ooomooooo_ooo_ooooWnn_o`n>gofnSFok_>/_nQ]i?oTJ]noj2mQonj
eY_od>fZom[h/?oOo[;ojOnfoo;o`oocolWom?o>ooOodOoeoloomooAooGo
coogom7omOo?oo[oe?ohom;on_oDooSod_ojomCon?oBoo[oe?ohom;on_oD
ooSod_ojomCon?oBoo[oe?ohom;on_oDooSod_ojomCon?oBoo[oe?ohom;o
n_oDooSod_ojomCon?oBoo[oe?ohom;on_oDooSod_ojomCon?oBoo[oe?oh
om;on_oDooSod_ojomCon?oBoo[oe?ohom;on_oDooSod_ojomCon?oBoo[o
e?ohom;on_oDooSod_ojomCon?oBoo[oe?ohom;on_oDooSod_ojomCon?oB
oo[oe002ooSodPcon?o@01Comoo?ooKoc_obolcokoo8onOo`ooKo;God?6Z
olo`ZOo:kZSo^=RGoj2oPon<ZG?oVkF8ok[=[OoKj]?ol_caoo_ooOoloooo
oOkoooooo`;ojn_[0oo/k>`01?oZj^[obl_;omCDe?o/k>`5ong]k@03omcL
g?oPh>3okno_00?olO7a00?ok^k^on7QhOobl_802_obl_87oo?cl`03omgM
gOo8b<Sol_;b00Som?Cd1OoemOD3ooOgm`GonOWi2oojn_X2oo_kn`?oo?cl
0_omoOdAooknoR[ooooo00Co35>^ojC3iOnhd^ooNJk/0_n/gol01?mfMWKo
`L71oo3`l?omoOeKooooo`04oaXB5?l94P[o2@T:o`TB2P?o2@T:00?o4A`:
o`T92_l92@X00ol92@X01OlA70[o2@T:oa4L2_l92@[o4A`:00?o2@T:00Oo
4A`:o`T92_l92@[o2@T:oaX92_l92@[o2A8:00?o2@T:00?o4A`:o`T92_l9
2@X02Ol92@X01?lA70[o2@T:o`T92_lA70X4o`T92P03oa4L2_l92@[o2@T:
00Co2@T:00Wo0000o`T92_l92@[o2@T:oa4L2_l0003o2@T:o`TB2_lA70X0
0ol92@X01?l0003o4A`:o`T92_l92@X2o`000003o`T92_l0003o2@T:00go
2@T:00?o0000o`T92_l92@X00_l92@X02ol0003o2@T:o`T92_lJ4QCo0000
oaXV5?m6C3go2BHYo`T92_l92ACo2A8:00?o2@TD0ol94PX04ol92@[o6Q8D
o`T92_l99RWo4DaBo`TV:Ol94P[o2@TDo`TV:Ol92ACo2A8:o`T92_l0003o
2@T:o`000?l94P[o2@T:o`000?lA70X02ol92@X05OlJ4QCo2A8:o`TL7_lA
9Qko2A`No`TV:OlJ71ko2A8:ocd_?OlA;cgo8d5Bob=1?Om?LW_oPhB>o`TV
:OlS;bWo2A8:oaXV5?mZIc?ob]31og:=G002o`00000Mob<V2_n3Nc?oUHeB
oiFHI_l971ko2A8:o`000?nNQ6Ko/;>gol6c[Oo]kN[o2A`No`000?l92ACo
4A`:ob<L2_l/71Co=5DYodH_2_lJ9QCo2A8:oaX92_lA9P[oNd`:oiF=D_n=
SDOobZYVo`000?l94PX01ol92@X01_l0003oAT4Nohf=D_n`/kOoARl:o`TB
2PCo2@T:00Co6PT:oa4L2_l92@[o4A`:0_l92@X00olJ2@[o2@T:o`T92P02
oaX92P08o`T92_lA70[o2@T:oaX92_l/4P3o6PT:oa4L2_lJ2@X2o`T92P03
oa4L2_l92@[o6PT:00;o6PT:00Co2@T:oaX92_lJ2@[o6PT:0_lA70X00olJ
2@[o0000ojJZ[@1Oooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0002onk^
kP04onc/k?oLg=coO7alom[JfP;oh>3P00Kodm?ColO7aoo<c<coc/k>om3@
d?oBd]8>omKFeP?oemOG0_ooo_l0C_onoooom_chonSbiooAh<_o//NXoiVb
R_nK]hKoZ/V>ol;QW_oClj[of?VZomKhY?oJnjCoi?nbononaOobnlcomOc@
ooCmc_ofoM7omOk?ooGld?odoLkomOc@ooCmc_oeo=3om?g>ooGld?odoLko
mOc@ooCmc_oeo=3om?g>ooGld?odoLkomOc@ooCmc_oeo=3om?g>ooGld?od
oLkomOc@ooCmc_oeo=3om?g>ooGld?odoLkomOc@ooCmc_oeo=3om?g>ooGl
d?odoLkomOc@ooCmc_oeo=3om?g>ooGld?odoLkomOc@ooCmc_oeo=3om?g>
ooGld?odoLkomOc@ooCmc_oeo=3om?g>ooGld?odoLkomOc@ooCmc_oeo=3o
m?g>ooGld?odoLkomOc@ooCmcPSom?k<00?olog;ooCnc?oeold00_oeold0
5?odo/colog;ongnaooOo;[ohonoonWo`ooUokgofOjaolW_X_njgYCo[]:<
oiFdN?nK]hCo/<JOolkPa_oZm^Son?kjoo_oooomo_oooooo0_o/k>`2ong]
k@06oj>SXol92@Wo30`<ob4Q8Olb<S;oVi^K0_o^k^h03OoEeMGo>c/ko`00
0?l@413o6a/KonWYjOo`l?3o/k>coaTI6Ol61PKoCDe=oginO_l];Bd00_oa
lO401_ll?3coN7Qhoo7alOoalO7o?3`logQhN0?ol_;b0_oclo<01oodm?Co
DU9Boa0@4?ld=3Co61PHof1PH?oXj>P00_oemOD01olc<c?o0000o`000?l7
1`Oo;Bd]ofi^K_oZj^X00_ofm_H2ooShn003ooOgmooinOWonOWi00?onOWi
2oojn_X2oo_kn`;oo?cl00?ooOgmookno_ono_h0>oooool01?l?EZkoYLCV
okKBk_mi[^T2oj[Po`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Oo2@TDo`T9
2_lA70[o2@T:oa4L2_l92@[o4A`:00;o2@T:00?o4A`:o`T92_l92@X02ol9
2@X01OlJ2@[o2@T:o`T92_l92@[o4A`:00?o2@T:00?o4A`:o`T92_l92@X0
1Ol92@X02_lS;bWo0000o`T92_lA70[o2@T:oa4L2_l92@[o0000o`T92_l0
0004o`T92P03o`000?l92@[o2@T:00?o2@T:00Co2A8:o`000?l92@[o0000
2_l92@X00ol0003o4A`:o`T92P0>o`T92P03o`000?l92@[o2@T:00;o0000
0_l92@X00ol0003o2A8:o`000002o`000003o`TB2_l/>2Wo2BHY00?o2@TD
00_o4BHDoaXB5?l971Co2A8:o`T92_l92ACo2@T:o`T95?l971Co4BHNoa4_
<`02o`T95005o`TB2_lA;c?o2A8:o`T92_l000000_l92@X02?l0003o2@T:
o`T92_l92@[o0000o`TB2_l0003o2A8:2?l92@X06_l92ACo2A8:oaXB5?l9
2ACo2BHYoaXL7_l99RWo2@T:oiFQ]om?GVKo2D57odmbNoo1al7o=6Mkob<_
:Ol971ko0000oiEbAon`/kOo4BHDo`000?m69QCoPg/cok2ZQ?nEV6KoLXdm
0ol000005oo1XHCo/;>gomcSe_o]m_Go;4`Yo`000?lA70[o2@T:oaX92_lS
70[o8blNodHV5?mPGS?oPg/co`000?lA70[o8a`:og]<2_o:XE;og<NSojJQ
I_l0003o4BHD00Wo2@T:00?oH5hcohf=Aon3Nc<00_l94PX01Ol92@[o0000
oaX92_l92@[o6PT:00Co2@T:00?o6PT:o`T92_l/4P000ol92@X00olJ2@[o
2@T:oaX92P03oaX92P05o`TB2_lJ2@[o4A`:o`T92_l94PX00_l92@X01?lJ
2@[o2@T:oaX92_l92@X4oaX92P03o`000?o1/jgok^k^05kok^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN4000;oi^KV00Coi>CTomCDe?mlO7cof][J0_oP
h>001_oDe=Cob<S8ol_;boo>c/kod=3@om;BdPkoe]KF0ooGemL06?ono_co
o_ooookoooodnOcoi>gXolcKb?n]`igoUK9lojoBS_n]dhSo/MZ<ol7XVOo?
mZOofOj^on3o[ooVokOoj?ZloncjaOo`oLSolOo:oo?oboobol[olOk9oo3l
bP?olOg;=Ooao/T8oo3ob003onkma_o_o/Ool?o800;olOo901Col?o8onon
aoo[ol?ohonnomSn/ooEnjkoeoj_om3jZ?o1jiOo]=f>ok7GS?nUb8CoX/68
oj[3VOo2ekSogncJoo3jl_oiooooo?ooookoo`;okNg]0_o^k^h05Oo7alOo
/[:bonWYjOo^k^koTY:Bo`<30oo@d=3okno_ocdm?OlY:BWo_[jnono_koo:
b/[okNg]ono_kom>CTkoDe=ConOWionDU9Co3Ph>obd];@02oo3`l006oc`l
??mgMgOol?3`oo3`l?ll?3coMgMg0ooalO402Oobl_;olo?cooCdm?oKfm_o
l_;booGemOoKfm_o3@d=ofm_K`02ooGem@09oc<c<om_KfoomOGeon_[joo4
a<Co@T92oalO7ooWinOom_Kf00?omoOg1Oohn?P;ooWin@;on_[j0oolo?`2
ooknoS_ooooo00Co3EF^ojK6i_nidnkoNJk[0_n[gol01?mZJV[o[Zj^omSH
f?oTi>AKonKViP;o4A`:00Go2@T:oa4L2_l0003o2@T:o`TB2P05o`T92P0<
o`000?l92@[o2@T:o`T92_l0003o4A`:o`T92_l0003o2@T:oaX92_l0003o
4A`:1_l92@X00ol0003o2@T:o`000002o`T92P04oaX92_l92@[o2@T:o`T9
2P;o4A`:0_l92@X00ol/4P3o6PT:o`T92P02o`T92P0<oa4L2_l0003o2@T:
o`T92_l0003o2A8:o`T92_l0003o2@T:o`000?l92@[o00000_l92@X00ol0
003o2@T:o`T92P02o`T92P05o`000?l92@[o2@T:o`T92_l000000ol92@X0
1Ol0003o2@T:o`T92_l92@[o000000Co2@T:00?o0000o`T92_l92@X00_l9
2@X01Ol0003o2@T:o`TB2_l0003o2@T:00;o000000oo2@TDo`000?l92@[o
2@T:o`000?l92@[o2A8:o`000?lA;cgo2A`Do`TB2_l92ACo2BHYo`T92_l9
2A@01?l92@X02?l92ACo6Q8Do`TL7_lA;c?o2@T:o`T95?l971Co4BHN1?l9
2@X00ol0003o2@T:o`000002o`T92P06o`000?l92@[o0000o`000?l94P[o
00000_l92@X07?l0003o2@T:o`T92_l94P[o6Q8Do`T95?l92@[o4BHNo`T9
5?l9@DOo4Blmoh<_G?nEV:?o8d5Bo`U1AoldIg_o`LO<oa4_?OlS;ako0000
of115?nVZZ?o/:Z4o`T92_nESE;o/:Z4oiFHI_lA9PX3o`000008odHV5?o1
XHCo/;>gol77`Oo:d=KoEheLo`000?l94PX3o`T92P0<oa4L2_lS70[o=2lN
ocdL2_mPGS?o=2lNo`000?lA70[oJUDNok2=D_n`ZXCokM2H0_l00006o`T9
2P0=o`TB2_l92@[o2A8:ob`B0?n3NecoUHeBof1N<ol0003o6PT:o`T92_l0
003o2@T:oaX92P02o`T92P03ob`B0?l92@[o2@T:00;o2@T:00oo4A`:o`T9
2_lJ2@[o6PT:o`T92_lJ2@[o2@T:oaX92_l92@[o6PT:o`T92_l/4P3o2@T:
oa4L2_lJ2@X01?l92@X01olA70[o6PT:o`T92_lJ2@[o2@T:o`000?n`/kL0
GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h03?o/k>cog=cL
og]kNooJf][oh>3Pon7QhOoEeMGob<S8ol[:b_o>c/kod=3@om?Cd`koe]KF
0ooGemL05Oonongoo_odooclooolo_oog^;[ol7?`?nM^8GoVKi^oik=IonT
fFoo[>:4okCXUOo0kZKoc?NbomKn]OoKok?ogofcon;m]_oUokSoiOnkonOo
_002onSo_`04onSo`?oVokkoi_nnonSn_SGoj?jm3?oVok/05OoUo[[oi?fi
on?l^?oOoKOofonhomKo/_o@oJcob?FPol;`V?nmji7o]>2;oj[EQOnTc8Go
UkUloifiROnmeK7oe^G>ooSom_ogooWon_onookoo`02on_[j`Kok>c/00Oo
d=3@o`000?nYZJWoc<c<o`000?n:RX[okNg]00;okno_0_oalO401_lY:BWo
R8R8oo7alOobl_;oLg=cobd];@;ol_;b00Ko?3`logQhN?obl_;ol_;boc`l
??mhN7P8oo?cl`;om?Cd00KoEEEEod10@?odm?Com?Cdoc<c<om^KVh2ooCd
m005ooGemOo`l?3o7AdMofe]KOofm_H00_ohn?P01?oinOWono_koo_knook
no/2ooclo0gooOgm0oono_hmooooo`04oa5G[onS`^Co^=?_ogN^j`;oZ]oo
00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01Ol94P[o6Q8Do`TB2_l92@[o4A`:
00;o2@T:00Co4A`:o`T92_l92@[o4A`:3Ol92@X00ol94P[o2@T:o`T92P0@
o`T92P05oa4L2_l94P[o2@T:o`TB2_l000002Ol92@X00ol94P[o2@T:o`T9
2P08o`T92P03oa4L2_l92@[o2@T:00Oo2@T:00?o0000o`TB2_l92@X01?l9
2@X01Ol0003o2@T:o`T92_l92@[o2A8:00Co2@T:00Co2A8:o`T92_l0003o
2A8:1Ol92@X02?l92ACo2A8:o`T95?lJ4QCo2@TDoa4V7_l971ko2A8:0_l9
2A@02?l94P[o2@T:o`TL5?lS;bWo4Blmo`TV:Ol92@[o6Q8D0_lA;c<01_l9
4P[o0000o`T92_l94P[o2@T:o`TB2P?o2@T:00Oo2A8:o`T92_lA70[o2@T:
o`TB2_l92@[o000000Co2@T:02?o2A8:o`T95?lJ4QCo2@TDoa4_?OlS;c?o
H79koiFHXon3Q8ko;6MLobaEG?lS@Cgo;5ELobaWG?lS;bWo4BlcodHV5?nV
ZZ?oUJ6>oa4V2_o]d9SoLXeLoa4V2_l0003o2@T:oaXB5?l92@[oH2lDol[@
`Oo1/jgob]31ooKooolA9P[o0000o`T95002o`T92P04o`TB2_l92@[o2@T:
ob`B00;o8blN00[oUG97ohf=Aol94P[o6Q8Dog]<2_n`SC?o/:Z4om>nS_ld
EBWo2A8:0_l92@X00ol94P[o2@T:o`T92P04o`T92P05o`000?nELTOoSHe7
oij=<ol000000_l92@X01?lJ2@[o2@T:o`T92_lJ2@X2o`T92P0:oa4L2_lJ
2@[o4A`:oaX92_l/4P3o2@T:oaX92_lA70[o2A8:ob<L2P;o6PT:00_o4A`:
o`T92_lJ2@[o6PT:o`TB2_lJ2@[o4A`:o`T92_lJ2@[o4A`:oaX92P02o`T9
2P;o6PT:00?o4A`:o`000?nVZZd0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@000_ooool01?omoOgok>c/og]kNooJf]X2on3Ph006omCDe?o8b<So
bl_;olk>c_o@d=3od];B3_oEeMD3omKFeP0Dookoj_onooCoo?cooocmoooL
hngo`]2ooiZhN?nF`V7oW==Loj;MIonXi8;o/>NFokOZYoo2l:ooboJ^olkg
ZOoGo:kofOb/om[l[ooLo[42omgo]@;ogojh0_oPok/3on7o^C?ohOng2?oP
okL06OoQokSoh_nion;o^OoRokWohOnhon3o]ooOokKogOneom?l[_o?o:_o
b?RTol7aVonlkICo]nR=ojoPQonXeH3oX<]loi>kMOnK^X7o`=V_omGXc?of
oo;omookoo_oooonool00_o[jn/5onc/k008omkNg_m9BDWo1`L7on3Ph?n`
/;3o0000okno_oo]kNd2ono_k`;olO7a00Ko:BTYohZ:R_oalO7ol_;bohN7
Qol];Bd2oo;blP06oc`l??mhN7Sol_;boo;bl_ll?3coN7Qh1?oclo<4ooCd
m004ooGemOoZj^[o4Q8BogmoO`;omOGe00Co<c<cofm_KooemOGomOGe0_of
m_H00omgMgOo820PooKfmP03ooShn0Gon_[j2ookno/2ooclo0?ooOgm0_on
o_hkooooo`04oa5G[onUa>Ko^M?_ogN^j`;oZMco00CoMWIfol71`Oo`l?3o
oOgmFoooool01?lJ4QCo2A8:o`000?lA70X2o`T92P03oa4L2_l92ACo4A`:
00Ko2@T:00Oo4A`:o`T92_l94P[o2A8:oa4L2_l94P[o4A`:00;o2@T:00?o
4A`:o`T92_l92@X00_l92@X00ol94P[o2@T:o`T92P04o`T92P09oaX92_l9
4P[o4A`:o`T92_l94P[o2@TDo`T92_lA70[o;18000Ko2@T:00?o2A8:o`T9
2_l000000_l92@X00ol94P[o0000o`T92P07o`T92P;o2A8:00?o2@T:o`TB
2_l92@X00ol92@X00ol94P[o2@T:o`T92P02o`T92P03o`000?l92@[o2@T:
00?o2@T:00?o4A`:o`T92_l92@X00_l92@X02?l0003o2A8:o`000?l94P[o
2@T:o`000?lA70[o00001?l92@X02Ol94P[o2@TDo`T92_lA9Qko2@TDoaXB
5?l92ACo2A`Do`TL7P02o`T9500:oaXB5?l92ACo4BHNo`TV:OlA;c?o2BHY
o`TB2_l92@[o2BHYoa4V7P;o2@T:00Go2A8:o`000?l92@[o0000o`TB2P02
o`T92P07o`000?l94P[o2@T:o`000?l92@[o0000o`TB2P04o`T92P0Uo`TB
2_l92ACo2@TDoa4V7_l99RWob]3FoiFHXonV/l7oEhf>ob=1D_lAC5;o;5EL
obaEKolS@E;o4Blcoc@_7_n`ZXCog<NSo`000?nVQ5;oLXdmo`000?l92@[o
6PT:oa4L2_l0003oH2lDomcSh?n`/kOo`LO1omcSh?nEZZgo0000o`T95?lA
70[o2@T:oa4L2P03o`T92P0>oa4L2_lS70[o;2HDob`V5?niV5coAUDYoa4V
5?mZ@@[o/8dcolZn[Oo1/hko=5DYo`000?l94PX2o`T92P03o`TB2_l92@[o
2@T:00?o2@T:00Oo0000of11:OnVV6ooYZ5Vo`000?lA70[o2A8:00;o2@T:
00_o6PT:o`T92_l92@[o6PT:o`T92_lJ2@[o2@T:oaX92_l92@[o6PT:o`T9
2P05oaX92P04o`T92_l/4P3o4A`:o`T92P?o6PT:00_o4A`:oaX92_lJ2@[o
2@T:oaX92_lA70[o8a`:ob`B0?lJ2@[o0000ol6c[@1Oooooo`04ojn_[oo;
bl_og]kNon[ZjP7ol_;b0002onk^kP04onc/k?oLg=coO7alom[JfP;oh>3P
00Koe=CDolS8b?o<c<coc/k>om3@d?oBd]8>omCDe0?oeMGE01Soooocoooo
n_ono_oonogoomgVhoo0dkGoT[AZoi?2F_nGdEWoWm]YojKQPonZhiKo/NBQ
ok[YYOo3kYkoa_2LolofYoo?mJSocoFZom3fZooBm[3odoNaomCg/ooEn;@3
omKf]@03omKf/ooGm[?oeoJc00;oeoJb<?oFmk8:omCh/P0GomGi/ooDn;;o
e?Rbom?g/OoAmJood?J[ol_eXoo7m9oo`?2JokWYUOneii;o/^B=oj[LPonR
eGWoVlacohnjJ?nD^7;o`MbWomOZb_ocoo7on_oooocoooonool00_oZj^X4
on_[j`0;ojNWYolI6AWo5ADEojn_[oo/k>cob/[:o`000?n6QXKokNg]ono_
koo^k^h00_o`l?001_lY:BWoRXZ:oo7alOobl_;oQhN7obd];@;ol_;b00Ko
?3`logQhN?obl_;ol_;boc`l??mhN7P3oo?cl`;om?Cd0_oemOD01OnKVi_o
FUYJob<S8omVIVKoiNGU00;om_Kf00Co=3@dofm_Koofm_Kom_Kf0_ogmoL0
0onIVIWo0P82oo7al@02ooOgm`Kon?Sh2ooinOT2oo[jnP?oo?cl0_ono_hk
ooooo`04o`eF/OnTa>Ko^M?_ogJ]jP;oZn3o00CoKVi^okBd]?oPh>3ok>c/
Foo^k^h02_l92@[o0000oa4L2_l94P[o2@T:o`TB2_l92@[o4A`:o`T92_l9
4PX7o`T92P04o`TB2_l92@[o0000o`TB2PWo2@T:00Go0000oa4L2_l92@[o
2@T:o`TB2P05o`T92P05oa4L2_lJ4QCo4A`:oa4L2_l000000_l92@X01?l0
003o2A8:o`TB2_l94PX2o`000005o`T92_l0003o0000o`TB2_l92@X00ol9
4PX01Ol92@[o0000o`TB2_l92@[o2A8:00?o2@T:00Ko0000o`TB2_l94P[o
2A8:o`T92_l94PX2o`000004o`T92_lA70[o2@T:o`TB2PCo2@T:01Oo0000
o`T92_l92@[o2@T:o`TB2_l92@[o0000o`TB2_l0003o2A8:o`T92_l94P[o
0000o`T92_l0003o2@T:o`000?l92@[o2@TDo`TL7_l9@DOo0000oa4V5002
o`TL7P09o`TB2_l971ko4BHNoa4V5?l92ACo4BHDo`TB2_lA;c?o4BHN00;o
2@TD00Oo2D57o`TL7_lA9Qko2@T:o`000?l92@[o2A8:00;o2@T:0_l94PX0
0ol92@[o0000oa4L2P06o`T92P?o2A8:00Go2@TDoa4V5?l92@[o8d5Bom?I
eP02ol77c00Lo`U1AolS@E;o8d4mob=1D_lS@Cgo8d5Boa4_?OnEQ5;o`K>]
oa4V2_niZVooYZ5Vo`000?lA70[o2A8:o`TL5?l0003o/8Akol[@`Oo1/jgo
b]3Fom?Ie_oLhn3o0000o`T92_l94P[o2@T:o`TB2P?o2@T:00oo4A`:o`T9
2_lJ2@[o8a`:ocAE:Om69P[oYZ5Vob<V2_mZ@@[oYXABol6cS_oLaj?o=5DY
o`000?l94PX00_l92@X2o`TB2P;o2@T:0_l94PX01Ol92@[o;2HDojJQI_ni
V5co000000?o2@T:00Co4A`:oaX92_l92@[o4A`:0_l92@X01?lJ2@[o2@T:
oaX92_l92@X2oa4L2P;o2@T:00?o6PT:oa4L2_l92@X00_lJ2@X02ol92@[o
6PT:oa4L2_lJ2@[o2@T:oa4L2_l92@[o4A`:o`T92_lJ2@[o4A`:00?o6PT:
00?o0000ojJZXoo^k^h0G_o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00
0_oVi^H03?oTi>Coe=CDog]kNooIfMWogmoOon7QhOoDe=CoalO7olc<c?o>
c/kod=3@omGEe@koe=CD0ooEeMD06?oooo_oo_knooomooohnooogNWKol3G
Zon5[EOoR;a>oi7<E?nHefGoXMf3ojKNTon]h9go]^BLokkZTOo1k93oaNnM
olC_X?o4kZ;oa>jTolK^Yoo8l:WobO6[ol[b[0Cob^n/0_o;kZX3ol__ZC3o
b^nY1oo8l:T5olK^Y`0DolC/YOo3jjCo`nbPolC^V_o1kICo^nRCok?SSon]
hHkoZn6;ojCKO_nMeGCoUl]WohNfE_n7[U_o_]bLomc]bOocoO;oo?ooookm
ooooo_l5onc/k004ogMgMol0003oCdm?omCDe0?okNg]00Go>SXjob@T9?n`
/;3okNg]olo?c`02ono_k`06obTY:On9RHWokno_oo3`l?n6QXKo;Bd]0_o`
l?001_ll?3coMgMgoo3`l?o`l?3o?3`logMgM`?olO7a00Sol_;boo?clood
m?Com?CdoijNW_mMGEgo=SHfojj^[P?omOGe00Co<c<cofm_KooemOGomOGe
0_ofm_H00on:RX[o10@4oo;blP03ooOgm`Gon?Sh2ooinOT2oo[jnP?oo?cl
0_ono_hkooooo`04o`eE[_nUa>Ko]M3^ogV^k0;oYmco00CoJVYZojj^[_oH
f=Soi>CTFooVi^H01?lA70[o2A8:o`T92_l92@X2o`TB2P06oa4L2_l92@[o
2@T:o`000?lA70[o8bH:0ol92@X2o`TB2P03o`000?l92@[o;18000Wo2@T:
00?o4A`:o`T92_l92@X01ol92@X00ol94P[o4A`:oaXB5002oa4L2P05o`T9
2_lA70[o0000o`T92_l94PX00_l00002o`TB2P03o`000?l94P[o2A8:00;o
2@T:00Wo4A`:o`000?l92@[o2A8:o`000?l92@[o2A8:o`000?l94PX00_l9
2@X3o`TB2P03o`000?l92@[o2@T:00?o2@T:00Ko0000o`T92_l92@[o2A8:
o`T92_l94PX4o`T92P03o`TB2_l0003o2A8:00;o000000Co2A8:o`000?l9
4P[o00001?l92@X2o`TB2P0@o`T95?lA9Qko4Blco`T92_l99RWo4BHNoa4V
2_l971Co2@TDo`TV:Ol971ko4BHDo`T95?l971ko8d5Bo`TB2P;o2@TD00Co
;5E_o`TL5?lA9QCo2@T:0_l94PX00ol0003o2@T:o`TB2P02o`000003o`T9
2_l94P[o000000Co2@T:00?o2A8:o`000?l92@X00_l94PX01ol971Co2BHY
oa4_<olm;cgo`LO<ojK7h?l9@DL00olS@E804olA;e;o;5hmoa4_<omPGS?o
g<NSoba<:OnNSC?o?Ehmo`000?l/C2Wo2@TDo`TB2_l0003o`J64ol[@`Oo1
al7ob]3FomcSe_oChoD00_mPGS<01Ol0003o2A8:o`TB2_l92@[o2A8:00Go
2@T:00co4A`:oaXB5?n3Nc?oARl:oa4V7_mkC1CoWXdYok2ZQ?o:_ZgoCfM7
o`000?l94PX3o`T92P03o`000?l94P[o4A`:00;o2@T:00Ko0000ob<V2_nE
V6Ko`K>>o`000?lA70X2o`T92P0Ioa4L2_l94P[o2@T:oaX92_l92@[o4A`:
o`T92_lA70[o6PT:o`T92_l/4P3o2@T:oaX92_l92@[o4A`:ob`B0?l92@[o
4A`:oaX92_l/4P3o4A`:oaX92_l92@[o;180o`T92P02oaX92P08o`TB2_lJ
2@[o6PT:ob<L2_lJ2@[o2@T:o`000?nVZZ=OonKViP04oifMWOng]kOob<S8
om?Cd`7of][J0002onk^kP0<onc/k?oLg=coNg]komWIfOoOgmoohN7QomCD
e?o6a/Koc<c<olk>c_o@d=3oe=CD3_oEeMD3omKFeP0Hooomooooo?oooogo
ooKjnooQkmKo`MbUogRSAoml/T3oR<Q>oi3CH_nKfX7oXM^?ojSLU?nah9;o
^^J7okkXQ_nmjI;o_>VHokcXVOnmjI[o_nVMol3ZW_o1jj7o`^bT1?o4k:D2
olK/X`03olK/XOo4kJ7oa>bS02koa>bS2Oo3kJ<2ol7[X@0Gol;/X_o1jj7o
`N^Qol3ZX?nnj9ko_^VJokoWTOnlihko]n>>ojkMS?nYgH[oY]j5oigIMonE
dfSoT<YJogbaAOmgXdCo_=bCon7cbooeoO;ooocooookooooo_l01?o/k>`0
0ooDe=Co0@41ohR8R002onc/k0?okNg]00GoemOGoe1@D?l=3@go2PX:ob<S
8`02ono_k`06ochn?_nDU9Cokno_oo3`l?nATI7o@D510_o`l?001_ll?3co
MgMgoo3`l?o`l?3o?3`logMgM`?olO7a00?ol_;boo?cloodm?@00_odm?@0
1?oemOGodm?Co`820_o>c/h2ooGem@04oc<c<om_KfoomOGeooGem@;om_Kf
00?oCdm?obXZ:_ofm_H00_ohn?P00oogmoOonOWiooWin@03ooWin@_on_[j
0_okno/2ooclo003oogmoOono_koo_kn03_ooooo00Co3EJaojC4i_nhd^ko
MZgZ0_n/gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP0:o`T95?lA70[o2@T:
oa4L2_l92@[o6PT:o`T92_lA70[o2@T:o`TB2PGo2@T:00?o6PT:o`T92_l9
4PX01?l92@X01ol94P[o2@T:oa4L2_l92@[o4A`:o`T92_lJ2@X01ol92@X0
1OlA70[o2@T:o`TB2_l92@[o2A8:00;o4A`:00?o2A8:o`T92_l92@X01Ol9
2@X2o`000003o`T92_l0003o2@T:00Oo2@T:00Go2A8:o`T92_l94P[o2@T:
oa4L2P04o`T92P05o`TB2_l92@[o2@T:o`T92_lA70X01Ol92@X00olA70[o
2@T:o`T92P02oa4L2P0=o`TB2_lA70[o0000o`T92_l94P[o0000o`TB2_l0
003o2A8:o`000?l94P[o0000oa4L2P02o`000007o`T92_l92ACo4Blco`TV
:Ol92@[o4BHDo`TL5002o`T9500>oa4_D_l971ko4A`:o`T95?l971ko4BHD
oa5<D_l92ACo0000og9ED_lA;e;o2@T:o`TL7_l94PX2o`T92P03o`TB2_l9
2@[o2A8:00Co2@T:0_l94PX01?l92@[o4A`:o`TB2_l92@X3o`TB2P05o`T9
2_lJ4QCo8blYoa4_<olS@E800ol99RT01?lmLXCo8d4mobaEG?m?LW/2oa4_
?@0Cong@V?ldEBWo4A`:ob<_7_l0003oPg/co`TB2_l971koH2l:ol6c[Oo1
al7odmWFol[@`OoLhmKo/;k1og9WD_mbSCgoJVLco`T92P02o`TB2P04o`T9
2_lA70[o2@T:oa4L2P;o2A8:00oo4A`:o`T92_lS9P[o8a`:oh=N5?lA9QCo
H2l:oij=:OnVV6oodkj>odmWAol0003o2A8:oa4L2_l92A@00_l92@X00olJ
2@[o2@TDob`L5002odHV5005oiik<onESFKo/:Z4o`000?lA70X00_l92@X0
0olJ2@[o2@T:o`T92P02o`T92P04oaX92_l92@[o6PT:oa4L2P;o6PT:00?o
2@T:oaX92_l92@X00_lJ2@X00ol94P[o6PT:oa4L2P03oaX92P03o`T92_lJ
2@[o2@T:00;o4A`:00So6PT:o`T92_lJ2@[o6PT:oa4L2_lS70[o0000ok2c
]eook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo00cooOgmonc/
k?mlO7cof][JomoOgooQhN7oe=CDolK6a_o<c<coc/k>om3@d?oCdm<>omGE
e@?oe]KF01SooocoooojoooooOoom__gonSgf_o8iZ[oL9dnog>/>On0`DWo
RLeLoiGFN_nLehOoXMF:oj_HQondgWco]^1jokKSR?ndi8ko]NF?okOWTonj
iiCo^^NFok[VUonjiYT3okcVVP03okcWV?nmiYSo_NJG00?o_NJG03oo_>NG
okcWV?nliiOo_>NHokcWUonliiSo_>NGokcWV?nliiOo_>NHokcWUonliiSo
_>NGokcWV?nliiOo_>NHokcWUonliiSo_>NGokcWV?nliiOo_>NHokcWUonl
iiSo_>NGokcWV?nliiOo_>NHokcWUonliiSo_>NGokcWV?nliiOo_>NHokcW
UonliiSo_>NGokcWV?nliiOo_>NHokcWUonliiSo_>NGokcWV?nliiOo_>NH
okcWUonliiSo^nRGok_WV?nkj9Oo^nNHok_XUonkiiSo^nRGok_WV?nljISo
_>RIokcYV?nkiiSo^^NFokWUU_nii9800_nhh8X03onag8[oZ]Z6oj?IPOnM
fGWoUMA[ohc<F_n3`d_oLZ/hofnM>_o1hiWojO_CooKkm?oonoooooSoooom
o`04onc/k003olO7aol10@7oeMGE00;ok>c/1_o]kNd00oo[jn_ok^k^ono_
k`04ono_k`Gol?3`00Ko?3`logMgMoo`l?3ol?3`oc`l??mgMgL3oo7al@;o
lo?c0ooemOD01?ofm_KomOGeoaXJ6_nHV9P2ooKfmP09oc@d=?m_Kfoom_Kf
ooKfm_ogmoOoVYZJo`000?nLW9con?Sh00?onOWi0oojn_X2oo_kn`goo?cl
0_omoOd00oono_koooooooooo`0kooooo`04o`mF[_nVa^Ko]]3^ogV_kP;o
Zmko00CoMWIfol71`Oo`l?3ooOgmFoooool00olJ4QCo4A`:o`T92P05o`T9
2P04oa4L2_lJ2@[o2@T:o`0000;o2@T:00Co4A`:o`000?l92@[o4A`:1Ol9
2@X01Ol94P[o2@T:o`T92_l92@[o2A8:00;o2@T:00?o6PT:o`T92_l92@X0
0ol92@X00olJ2@[o2@T:oa4L2P02o`T92P05oaXB5?l/9QCo2A8:o`T92_l0
00000ol92@X01Ol0003o2@T:o`T92_l92@[o2A8:00;o2@T:00Go0000o`T9
2_l92@[o2@T:o`000002o`T92P03o`000?l92@[o2@T:00Co2@T:00?o2A8:
oa4L2_l92@X00ol92@X00ol0003o2A8:o`TB2P09o`T92P03o`000?l92@[o
2@T:00;o2@T:00?o0000o`TB2_l92@X00_l92@X00ol0003o2A8:o`T92P02
o`T92P03o`TB2_l99RWo2BHY00;o4BHN01Co0000oa4V7_l94P[o2BHYo`TL
7_l971Co2@TDo`000?l/EEco4Blcoa4V2_lm;cgoLW9koa4_?Ol971ko2@TD
o`000?l94P[o2@T:o`0000So2@T:00Co0000o`TB2_l0003o2@T:0ol94PX0
1?lA9QCo2@T:oaXL7_lA;cd2oa4V7P0LoaXL7_l/EEco;5ELobaEG?m?LW_o
?G:4ob=1D_n3NecoLXdmo`000?l94P[o0000oh=N<onVXFKo0000of0_2_o:
d<7ob]3Fom?Ie_o1al7og>?Fok2n`OlA70[oAT4NofYE7_mbSCgo=2lco`00
00;o2A8:1_l92@X04_l0003o8bH:ob`V5?m6EBWo;2HDog]<2_n`SE;o`K>>
omc7Xom6EBWo4A`:oaX92_l92ACoARH:ob<L2_n=E@[oH2lDoh=N50;oWW8D
00GoSHe7ol6cS_n`ZXCo`K>>o`000002o`T92P03oaX92_lA70[o6PT:00;o
4A`:0ol92@X2oaX92P09oa4L2_lJ2@[o4A`:oaX92_lA70[o6PT:o`T92_lJ
2@[o2@T:00;o6PT:00Go2@T:oaX92_lA70[o6PT:o`T92P04oaX92P06oaXB
5?lA70[o2@T:oaX92_l0003oUJZ]Goooool01?n_[joobl_;omkNg_oZj^X1
oo;blP000_o^k^h03?o/k>cog=cLogalO?oIfMWoh>3Pon7QhOoEeMGob<S8
ol_;boo>c/kod=3@om?Cd`koe=CD0ooEeMD06?oonoooooWoooomooohoOOo
l?oUom;_]Om^Vd3oKjTiog:f?Omm`dooRle[oi??NOnIcWcoXm1kojkFM_nb
fWOo[mamok3OPonchXKo]N>9okKTS?nfhhko]^:=okCOS@?o]Mn=0_negh/0
0oneghWo]mn9okGOR@02okGOR@0nokGORoneghWo]Mn;okGOROnegh_o]Mn9
okGORoneghWo]Mn;okGOROnegh_o]Mn9okGORoneghWo]Mn;okGOROnegh_o
]Mn9okGORoneghWo]Mn;okGOROnegh_o]Mn9okGORoneghWo]Mn;okGOROne
gh_o]Mn9okGORoneghWo]Mn;okGOROnegh_o]Mn9okGORoneghWo]Mn;okGO
ROnegh_o]Mn9okGORoneghWo]Mn;okCPROndh8_o]>29okCPRondh8Wo]>2;
okCPROndh8_o]>29okGQS?nfhX_o]^:=okKRRonehHco]>29ok?OR_ncgHT2
ok;GQ`0?oj_FQ?nTe7koWMAfoiKCJon9c5WoOl=:ogBd>_m[YCCoLIhoolg^
ZOocon3omoWdooojoooonOoooogo00;oj^[Z0oo[jn/01Om4A4Co=CDeoh:2
P_mJFU[oDE5A00;ojn_[0oo/k>`2ong]k@?ok^k^1oo_knl01_lk>c_oMgMg
ono_koo`l?3o?3`logMgM`?olO7a00Wolo?coo;bl_odm?CoS8b<ofUYJOnH
V9SoG5aLo`d=3OoWinL00_ofm_H02Old=3Co;2`/of1PH?m<C4co:b/[o`H6
1_n:RX[om_KfooOgm`03ooShn0GonOWi2oojn_X2oo_kn`;oo?cl00?ooOgm
ookno_ono_h0>oooool01?l<DjkoY<?UokSBkomi[^`2ojcOo`04ofi^K_nd
];Coh>3Ponc/k5_ok^k^00Wo2@TDo`T92_l94P[o2@T:oa4L2_l92@[o2A8:
oa4L2_l000001?l92@X01Ol94P[o2@T:oa4L2_lJ2@[o2A8:00Co2@T:00So
4A`:o`TB2_l92@[o4A`:o`T92_lJ2@[o2@T:oaX92POo2@T:00Co4A`:o`TB
2_l92@[o4A`:0_lJ9Q@01?l0003o2A8:o`000?l92A@2o`T92P03o`000?lA
70[o2@T:00?o000000?o4A`:o`000?l92@X01_l92@X00ol94P[o2@T:o`T9
2P02o`T92P03o`000?lA70[o000000Wo2@T:00Co2A8:o`T92_l92@[o4A`:
0ol92@X01ol94P[o2@T:o`T92_l0003o2A8:oaX92_l94PX02Ol92@X04olA
;cgo;5hmoa4_<ol0003oH79koh>H[OnEXKOo2A`Do`TL7_l971Co4BHDo`T9
2_l/Ieco2A8:o`TL5?n3;eco=6Mko`TV:OlA9Qh00_l94PX2o`T92P05o`T9
5?l94P[o2A8:o`T92_l94PX01_l92@X2o`TB2P03o`T92_l92ACo2A8:00;o
2@TD01_o2BHYob<_:OlS;c?o8blYoa4_?Om?GVKo;5E_oeN=S_ldIg_o2D57
oiEbAombSCgo0000oa4L2_l0003o=2lNokVZKol/C2WoLSPDol[@e_o:d<7o
b]3Fok2c]oo]kN[oUJZ]o`000?l/71@00_m6@Ah01_mZIc?oJUDNob<_7_l9
4P[o6PT:oa4L2PKo2@T:01Wo6PT:oc@_7_m6;`[o6Q`Nog]<2_nVQ5;o^JY_
olZn[OnVXFKoSED:oiF=0?n`N`[oWXdcoiik<on`SAkoSHe7oh=k<onVQ5;o
YZ5Vok2ZQ?nVZZ?o/:Z4ojJQI_l94P[o6PT:00;o4A`:00?o6PT:o`T92_l9
2@X00_lJ2@X01?lA70[o2@T:ob<L2_lA70X5oaX92P07oa4L2_l/4P3o6Q8D
oaX92_l92@[o6PT:ob<L2P03o`T92P04oa4L2_lJ2@[o4A`:o`T92P;o6PT:
00Go;180oaXB5?lJ2@[o0000oiFQSP1Oonk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q0002onKViP0<onCTi?oDe=CoO7alomWIfOoPh>3ohN7QomGEeOo7
alOob/[:olk>c_o@d=3odm?C3_oDe=@3omGEe@0HooolooonnOoooogoooWn
n_ogonoofOG4og2KBom`YcooJ:TeogBiA?n3aUgoS<UZoiC:L_nPcWKo[MAi
ok7HNon/eg_o[]^0ok7MQ?nehHSo]^:=okCPRoncgH_o/M^90_nfgHh2okKM
S0;o]]f:00?o]mf:okKMR_nfgHX0;_nfgHX;okCNRP0GokGORondgX[o]=j:
ok?MROnafhOo/M^9ojc@Q_n]dHOoYm:2oj3AM_nHdF[oSlmMoh;6COmg^d3o
JZTdofVQ=_meXDcof?JjooSoj_ognOCooo[ooooioooooOl00_o[jn/3onc/
k005onSXj?nXZ:SoIFEUogemOOna/K401Oo]kNd2onk^kPGokno_1Oo`l?00
1_ll?3coMgMgoo3`l?o`l?3o?3`logMgM`?olO7a00Solo?cooCdm?ofm_Ko
cLg=ohZ:R_mXJ6SoUYJFomSHf0?omoOg00KoZZZZoiFEUOnEUIGoW9bLokjn
__oTi>@3ooShn0;onOWi00?on?ShooWinOoinOT00ooinOT;oo[jnP;ono_k
0_olo?`00oomoOgoo_knooknoP0kooooo`04o`mF[_nUa>Ko]];^ogV^j@;o
Z^3o00CoJVYZojj^[_oHf=Soi>CTFooVi^H02olJ4QCo4A`:o`T95?lA70[o
2A8:o`T92_lJ4QCo2@T:oa4L2_l94P[o4A`:00;o2@T:00Wo4A`:o`T95?l9
2@[o4A`:o`T92_lA70[o2@T:oa4L2_lJ2@X00ol92@X02?lA70[o2@T:o`T9
2_l92@[o4A`:o`T92_lA70[o6PT:0_l92@X02Ol/4P3o2@T:o`TB2_l92@[o
2A8:o`TL5?l/>2Wo4A`:o`000002o`T92P04o`000?l94P[o0000o`TB2P;o
00000_l92@X01?l94P[o2@T:o`TB2_l00003o`TB2PCo2@T:00?o2A8:o`T9
2_l94PX00_l92@X2o`TB2P03oa4L2_l94P[o2@T:00?o2@T:00?o0000o`T9
2_l94PX00_l92@X01_l94P[o2@T:o`T92_l94P[o2@T:o`0000;o2@T:00?o
2A8:o`000?l92@X01?l92@X00ol94P[o2@T:o`T92P02o`T92P0Foa4V5?lA
;c?o4BlmoaXL7_mbLW_oH79kocd_?OnEV:?o2A`Noa4V2_l971Co2@TDoaXB
5?lA;e;o2@TDoeMNKooChoGo;5E_o`TL5?lA;c?o4BHNo`0000Co2@T:00?o
2@TDo`T92_l94PX00_l92@X01olA70[o2@T:o`TB2_l94P[o2@TDoaXB5?l9
4PX00ol92A@01?lA9QCo2BHYoa4_<olA;e82ob=1?@0godmbNolAC5;oEhf>
ob=1D_lJ9QCo;4`Yo`000?lA70[o2@T:ob`L5?o1/hko2A8:odHV5?oLhn3o
kNgZojJZXonVXISokNgZoba<:Ol0003o2@TDoaXB5?lS70[oAUDYofYE7_nE
V6KoAT4No`TB2_l92@[o4A`:o`T92_l94P[o4A`:o`T92_lA70[o2@T:o`TB
2_lS9P[o8blNoa4V2_mkC1CoWXdcok2ZQ?o:_ZgoJUDNol6cS_o:XE;obZYV
ojJQI_n`ZXCog<NSol6cS_nVZZ?ob[j]ojJQV002ok2ZQ0;oYZ6H00Co2A8:
oa4L2_lJ2@[o2@T:0_lA70X01Ol92@[o6PT:o`T92_l92@[o8a`:00Co6PT:
00Go2@T:oa4L2_lJ4QCo;180oaX92P02o`T92P0;ob`B0?lJ2@[o2@T:oa4L
2_l92@[o6PT:oa4L2_lJ2@[o8a`:oaX92_l92@X00olJ2@X00ol92@[o6PT:
oiFZ[@1OonKViP04oifMWOng]kOob<S8om?Cd`7of][J0002onk^kP0<onc/
k?oLg=coNg]kom[Jf_oOgmoohN7QomGEeOo6a/Kob/[:olk>c_o@d=3odm?C
3_oDe=@3omGEe@0Fooonnoofl_7oookooocoooohooSog_KDojO;RomIS33o
Hj4dofZ]>Omi_4_oSlaToh_1HonPcWCo_>B>okCJQonih8oo]=j<okKOT?nn
iiSo`nVNokoUVP;o^n6H0_o0i9h2ol3TW0Go`^BJ<?o0i9X7okoUVP03ol3V
VonoiI[o`>JK00;o`>JK01Co_N>HokSNTondfI?o^MbLol3UX_nScWkoYmUh
oicFI_mn_TCoO/12of6S:?mET2CoHiHjoiBkN?obomoolooYoo[km_oonooo
ooKoooono`Wok^k^1oo_knl6oo3`l0GolO7a00KokNg]ono_kooalO7olO7a
ong]kOo_knl3oo;blP;om?Cd0oofm_H:ooOgm`gon?Sh2ooinOT2oo[jnP?o
o?cl0_ono_hkooooo`04o`eE[_nVa^Ko^M?^ogV^j`;oZmoo00CoKVi^okBd
]?oPh>3ok>c/Foo^k^h00olA70[o2@T:oa4L2P02o`T92P03oa4L2_l92@[o
2@T:00?o2@T:00Co2A8:o`T92_l92@[o2@T:0_l94PX8o`T92P06oaX92_l9
2@[o4A`:o`000?lA70[o6PT:0_l92@X03?l94P[o2@T:o`T92_l92@[o2A8:
o`000?l92@[o;1`Doba<:Ol92@[o2A8:o`T92P;o2A8:00?o0000o`TB2_l9
2@X00_l92@X00ol0003o2A8:o`000002o`T92P03o`TB2_l0003o000000;o
2A8:0_l92@X01_l94P[o0000o`T92_l92@[o2A8:o`0000?o2@T:00?o4A`:
o`TB2_l94PX01_l92@X00olA70[o2@T:o`T92P02o`T92P03oa4L2_l92@[o
2@T:00;o2@T:00Ko2A8:o`T92_l94P[o2@T:o`TB2_l00002o`T92P0Io`TB
2_l0003o2@T:o`T92_lA;cgo4Blcoa4_?On3V:goPhB>og9ED_n3SHCo2@TD
o`TB2_l92ACo2@T:o`TV:OlA;e;oJW]_oh<_G?nEXKOoCg9kobaN?OlA9Qko
8blYo`000002o`T92P?o2A8:0_l92A@01?l94P[o2@TDo`T92_lA70X2o`T9
500Mo`TB2_lJ4QCo2@TDoa4L2_l971ko4BHNo`TL7_lJ71ko2BHYob<_<ol/
EEco;6MLob=1D_mGSHko8blYo`TL5?lJ2@[o2@T:o`T95?l0003oUG97ojJQ
I_l0003oYZ6Hol[@`OoLhn3oYZ6Hom?Ie_oChoD00_l00003o`T92P0;ob<L
2_ld;akoJVLcoh=k<onVXFKo4BH:o`TB2_lA70[o2A8:o`T92_l000001?l9
2@X01_lJ2@[o8a`:oc@_7_mZEAkoYZ5Vol6cSP;o/:Z400Oo`K>>olZn[Oo:
_ZgoYZ6Hom>nS_o1/jgo^JY_00?o/:Z400_oYYQ_ol6c[OnVV6oo/:Z4o`00
0?l94P[o6PT:oa4L2_lJ2@[o4A`:oaX92P02oa4L2PGo6PT:00Ko;180oaX9
2_lJ2@[o6PT:o`T92_l/4P02oa4L2P05o`T92_lA70[o6PT:oaX92_lA70X0
0_l92@X01OlJ4QCo2@T:oa4L2_lJ2@[o4A`:00?o6PT:00?o0000oiFHXoo^
k^h0G_o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool03?omoOgo
k>c/ogMgMooJf][oh>3Pon7QhOoDe=CoalO7olc<c?o?clood=3@om?Cd`ko
e]KF0ooGemL06?ooooKoooojooonoooko?oolocgoo?okonieZKoEGleodf3
8omIU2SoJJLhogNbA_nejhWo_^bDok?JRooBmZcobNfUolCYXoo3j:?ob>fX
olc_[oo9k:cob>Z]olW[[P;ob^V^0_o:jJd00oo;jJgobnV[ol_YZ`02ol_Y
Zc3ob^Z[1oo8jj/00oo9k:cob>^[olW/[002ol[][@0DolW/[?o5j:So`nFX
okKGW_o:kZko`NbLokOYQ_nEcU_oLJlbofn_=?mTXc3oHILioe^6?_neeJCo
jooSoo_om_onoO_ooo_nooolooooo_l2on[ZjPOojn_[0oo/k>`3ong]k@03
ono_koo^k^kol?3`00;ol?3`0_oalO4;oo;blPColo?c1?odm?@:ooGem@?o
m_Kf0_ogmoL2ooWin@04ooShn?ojn_[on_[joo[jnP;ono_k3Oolo?`2oogm
o@03ookno_oooooooooo03_ooooo00Co4EN_oj?2i?nhdnooMjk[0_nZgol0
1?mfMWKo`L71oo3`l?omoOeKooooo`04oaX92_lA70[o2@T:oa4L2P;o2@T:
00Go4A`:o`T92_lA70[o2@T:o`TB2P02o`T92P;o4A`:00Co2@T:ob`B0?l0
003o4A`:1?l92@X01_lA70[o2@T:o`T92_l92@[o0000oa4L2P;o2@T:00?o
4A`:o`T92_lA70X00_l92@X01_lA70[o2@T:o`T92_l94P[o?EhmocAE:@;o
000000Oo2A8:o`000?l0003o2A8:o`000?lJ4QCo000000;o2@T:00?o2A8:
o`T92_l92@X01Ol92@X00ol0003o2A8:o`T92P03o`T92P05o`TB2_l92@[o
2@T:o`TB2_lA70X00_l92@X01?l94P[o2@T:o`T92_l92@X2o`TB2P03oa4L
2_l94P[o2@T:00?o2@T:00Co2A8:o`T92_l92@[o2A8:0ol92@X01?l0003o
2@T:o`T92_l00006o`T92P06oa4L2_lA;c?o4BHNo`TV:Ol/EEcoUIRS0_lm
;cd06Om?Ieco0000o`T95?l94P[o8d4moa4_?OlS;c?o/;>gocebQ?n3V:go
=5Dmo`TL7_lA;c?o4BHDoa4L2_lJ4QCo4A`:o`T95?lA9QCo2A`Do`T95?lA
9Qko4BHDo`TL7_lA;c<00olJ71h01_m6EE;o;3PYoeMED_lS@E;o8d4moa4_
<`;o8d4m0_l/EE`05_lAC5;oCg9kobaN?Ol0003o2@TDoa4L2_l92ACo8bH:
ofYW<oldEBWo6PT:olZn[Oo:d=Koi=3<ojJQV?oLhn3oNhf4ofY12_ldEBWo
0000o`TB2_lA70X2o`T92P06ob`V5?m6;`[oPg/codI<?On=SE;o00000ol9
4PX01Ol92@[o2A8:o`T92_lA70[o2@T:00;o4A`:01_o=2lNoiib2_niV5co
`K>]ol[@`Oo1/jgo`K>>omc7Xoo:d<7oPg/col6cS_n`/kOodkj>ojJZXon`
ZXCoUJZ]oh=kG?o:d=KoNhf4ojJHKol0003o6PT:oa4L2_l/9QCo2A8:oaX9
2_lA70X00_lJ2@X01_l92@[o4A`:ob<L2_lJ2@[o;180oaXB50;o4A`:00?o
2@T:ob`B0?lS70X01?lJ2@X00olA70[o6PT:oaX92P02oa4L2P04o`T92_lJ
2@[o;180oaX92P;o4A`:0_lS70X00ol0003oYZZ]ooooo`1Nooooo`04ojn_
[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP04onc/k?oLg=coMWIfomWIf@;o
gmoO00Koe=CDolO7aoo:b/[oc/k>om3@d?oCdm<>omOGe`?of=SH01Coo_o_
oooom_oooooomoSlooSlooohoo[oh?GFohj_N?mPSCcoBWhLof^R>_mk/T[o
Ul]Yol;`V?ncg93o^n2Kolc^/Oo8jK3oaNJ_olOX/@;ob^Rf00?obnRholgZ
_?o;i[T00_o;i[T01?o;ikOoc>JgolcV]oo<i[H`ol_W]PWob^Rf0oo9ikD0
5_o:j;Koc>ZholcZ^?o:j;Koa^Jdom?f`?nkhZ?o[mZ:okW[R?n`iWCoQ;i6
oefF9Om:PAcoCg/`oh>XM?oXon?omOodoo_on_oooogooogkoooknOooood2
on[ZjP[ojn_[0oo/k>`2ong]k@?ok^k^2_o_knl3oo3`l0?olO7a00?ol_;b
oo7alOobl_800_obl_82oo?cl`Som?Cd0ooemOD2ooKfmP?on?Sh0oojn_X2
oo_kn`goo?cl0_omoOd00oono_koooooooooo`0kooooo`04oa5G[onUa>Ko
^M?_ogN^j`;oZMco00CoKVi^okBd]?oPh>3ok>c/Foo^k^h02?lJ4QCo2A`D
o`T95?l92@[o2A8:oa4L2_l92@[o4A`:0_l92@X00olJ2@[o2@T:oa4L2P04
o`T92P05oa4L2_l92@[o2@T:o`T92_lA70X01Ol92@X01Ol/4P3o2A8:o`T9
2_l92@[o6PT:00?o2@T:00Wo;180o`TB2_l92@[o2@T:oaX92_m?Ieco6RHD
o`T92_l94PX01Ol92@X00ol0003o2A8:o`T92P04o`T92P03o`TB2_l92@[o
2A8:00Co2@T:00_o2A8:o`T92_l92@[o2A8:o`000?l92@[o2A8:o`T92_l9
4P[o2@T:oa4L2P05o`T92P03o`000?l94P[o2@T:00Co2@T:00?o2A8:o`T9
2_l92@X00ol92@X00ol0003o2@T:o`T92P04o`T92P0Jo`TB2_l92@[o0000
o`T92_l92ACo4Blco`TV:OlA;c?o2A8:odmNI_m69QCoPhB>o`TV:Ol971Co
6Q8Do`TV:OlA;cgo2@TDofYkKonVan3o4BmBom?SmOl94P[o4DaBoa4_<ol9
4PX2o`T95009o`T92_l92ACo2@TDo`TB2_l92ACo6Q8Do`TL5?lA9Qko6Q`N
00;o2BHY00oo4BlcobaEG?lS@E;oLW9kobaEG?l/GSgo8d5BoeMNKom6Ieco
Cg9kob=1D_mGSHko;6MLo`000?l92@X00olA9Q@03?lS;bWo0000ojJHQ?o:
d<7o`LO<ol[@`Oo1al7odmWFoa4V2_l/4P3oJUDNoh=k<`?o2A8:00_o4A`:
o`T92_l92@[oAT4Noh=k<ombSCgoUG97oba<:Ol92@[o2@TDo`TB2P03o`T9
2P;o2A8:01_o2@TDoa4L2_l/71CoPehDokVHG?n`ZXCog;j]ol6cS_n`ZXCo
`K>>omcSh?n3GS?oi=3<oiF=I_o:d<7oLW9kol6cS_n3Q7_oUG97omc7XonV
V8CoYYQ_o`000?lA70[o2@T:oaX92_l92@X00olJ2@X00olA70[o2@T:oaX9
2P04oaX92P03o`T92_lJ2@[o6Q8D00Co6PT:00So2@T:oaX92_lJ2@[o4A`:
oaX92_l92@[o;180oaX92P;o4A`:00?o6PT:oa4L2_lJ2@X00_lS70X00ol0
003okNgZonk^kP1Nonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002onKV
iP0<onCTi?oEeMGoLW9bomOGeooOgmooh>3Pom;Bd_o7alOob/[:olc<c?o@
d=3odm?C3_oDe=@3omGEe@0Hoo_ol?ojoO;oooomooonoooloOooo?ooooSo
m?oSnM?oI8I9odE`8?m<OB7oKj=1ohZkGonfiY3o/mfAolof/oo9k;;oanZd
olKY/oo6j;GoanNfolSX^Oo8ik_obNRl0_o;j;`00oo;ikkobnRlolcW_002
olcW^P1BolcX^?o<ik[obnRhol_X^_o;j;SobnRjol_X^?o;j;[obnRhol_X
^_o;j;SobnRjol_X^?o;j;[obnRhol_X^_o;j;SobnRjol_X^?o;j;[obnRh
ol_X^_o;j;SobnRjol_X^?o;j;[obnRhol_X^_o;j;SobnRjol_X^?o;j;[o
bnRhol_X^_o;j;SobnRjol_X^?o;j;[obnRhol_X^_o;j;SobnRjol_X^?o;
j;[obnRhol_X^_o;j;SobnRjol_X^?o;j;[obNVholWY^_o9jKSobNVjolWY
^?o9jK[obNVholWY^_o8j;OoanNholSX]oo:j[_ob^Ziol[Z^oo7jKKo]]bS
ol7ZY_o5lZ7oY]Egoh:eC?m/X3CoDH4Nod9]6omkWVCoeO7;ooCom_oioogo
m?Keookmnoooo_[ooo[dooooo@;ojn_[1oo/k>`6ong]k@03onk^k_o_knoo
l?3`00Col?3`2ooalO43oo;blP;olo?c0oodm?@:ooGem@Gom_Kf0_ogmoL0
0oofm_KomoOgooOgm`03ooOgm`_on?Sh0_oinOT3oo_kn`;ooOgm4Oono_hZ
ooooo`04o`eF/OnTa>Ko^M?_ogJ]jP;oZn3o00CoJVYZojj^[_oHf=Soi>CT
FooVi^H01_lA70[o2@TDoa4L2_lA70[o2@T:oaXB50Go2@T:00?o8a`:o`T9
2_l92@X01?l92@X01_lA70[o2@T:o`000?lA70[o0000oa4L2P;o2@T:00Ko
4A`:o`000?l92@[o2@T:oa4L2_l92@X2oa4L2P;o2@T:00go2A8:o`000?l9
2@[o4A`:odmWAol94P[o4A`:o`000?lA70[o2A8:o`T92_l94P[o2@T:00?o
2A8:0_l92@X01?l94P[o2@T:o`000?l92@X2o`TB2P06o`T92_l94P[o2A8:
o`T92_l94P[o00000_l92@X01Ol94P[o0000o`T92_l94P[o000000Ko2@T:
00?o2A8:o`000?l92@X00_l92@X01OlA70[o0000o`000?l92@[o6Q8D00?o
2@T:00Ko2A8:o`T92_lA70[o0000o`T92_l94PX2o`00000;o`T92_l94P[o
0000o`T92_l99RWo4Blco`TL5?l94P[oAVMLo`TV:Ol971h00_l99RT00ol9
71ko4BHNo`TV:@02o`TV:@09o`U1Aom?GVKoY[?1o`T95?lS@Cgo4BHDo`T9
2_l971Co6Q8D00;o2A8:00[o2@TDo`TB2_lA70[o2@TDoaXB5?lA9Qko2BHY
oa4V7_l99RWo6Q`N0_lS@Cd05_lAC5;o8d4moa4_D_m?LW_o?G:4odmbNold
Ig_oLXf]oeN=G?l0003o2@T:o`TL5?l0003o2@TDo`T92_mP@BWo`K>]ok2n
`Oo:d<7o`LO1ol6c[OoLhn02o`000004oaXB5?l/4P3oLXdmof1N<`;o2A8:
00co2@T:oa4L2_l94P[o;180odI17_nNNc?oPg/coiF=D_ld;bWo2@TDo`T9
2_lA70X3o`T92P0Jo`TB2_lJ4QCo8bH:ob`V5?n3Nc?o^JY_ombcXoo:d<7o
Pg]LolZn[On3GS?og>?PoiEbAoo:d<7oUHAkol6c[OmZIc?o`K>>oiFHI_nE
Q7_o`LO1ojJHQ?n=SDOo0000oaX92_l92@X2oa4L2P08o`T92_lJ2@[o2@TD
oa4L2_l92@[o8a`:oaX92_l/4P03oaX92P0:oa4L2_lJ2@[o4A`:oaX92_l/
4P3o4A`:o`T92_lA70[o6PT:oa4L2P;o6PT:00Go2@T:oaX92_lJ2@[o6PT:
oa4L2P03oaX92P03ob<L2_l0003og>?P05ooi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X000;ok^k^00Cok>c/omoOgomaLG7oclo?0_oMgMd01_oAdM7o
a<C4olS8b?o;bl_oclo?om;BdQ7oe=CD01SonoohooSmm_onoogooooooocj
ooogmOSoo?ojooSokooaomkoIXQ<odad:omOS3_oT/9^oiK5M?o2lJ?oXlj6
okSQWonkhJCo_N>VokkTZOo0hj_o`>>]okoR[?nnh:d2ol;R/003ol;R/Oo2
h[3oa>:`00;oa>:^04oo`^>/ol;S[_o2hjco`^>^ol;S[?o2hjko`^>/ol;S
[_o2hjco`^>^ol;S[?o2hjko`^>/ol;S[_o2hjco`^>^ol;S[?o2hjko`^>/
ol;S[_o2hjco`^>^ol;S[?o2hjko`^>/ol;S[_o2hjco`^>^ol;S[?o2hjko
`^>/ol;S[_o2hjco`^>^ol;S[?o2hjko`^>/ol;S[_o2hjco`^>^ol;S[?o2
hjko`^>/ol;S[_o2hjco`^>^ol;S[?o2hjko`NB/ol7T[_o1i:co`NB^ol7T
[?o1i:ko`NB/ol7T[_o1i:co`^F_ol3SZonohZco_n:Zol3S[Oo0hj_o_^6[
ok_QY_neh9_o[]bAokCTT?nUdg_oO:U>oeF09om=LbSoIXQ;onOofOodoo7o
k_Waoo_ooooooooooOcj00;oookj00?oooomonWYjOoYjNT02_oZj^X3on_[
j`03onc/k?o]kNgok^k^00;ok^k^2_o_knl3oo3`l0?olO7a0_obl_83oo?c
l`;om?Cd2?oemOD5ooKfmP;on?Sh00?omoOgooWinOoinOT00ooinOT;oo[j
nP;ono_k0oolo?`2oogmoA7oo_kn:_ooool01?l=EJkoYLCVokG@k_mi[^`2
ojOLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00_o4BHDo`TB2_l92@[o4A`:
o`TB2_l92ACo4A`:o`T92_lA70[o2@T:oa4L2P03o`T92P0>oa4L2_l92@[o
4A`:o`T92_l94P[o2@T:oa4L2_l92@[o4A`:o`T92_l94P[o2@T:o`TB2_lA
70X2o`T92P03o`TB2_lJ2@[o2@T:00Ko2@T:00OoAUi7odIE:Om69QCo4BH:
ob<L2_lJ2@[o;18000;o4A`:00Co6PT:oa4L2_l/4P3o2@T:0ol94PX02?lA
70[o2A8:o`TB2_lA70[o0000o`T92_l0003o6Q8D0ol94PX01_l92@[o2A8:
o`T92_l94P[o0000o`TB2PGo2@T:00?o2A8:o`000?l92@X02?l92@X2oaXB
5004o`TB2_lJ71ko0000o`0000;o2A8:00Ko0000o`T92_l94P[o2@T:o`TB
2_l00002o`T92P04o`TV:OlA9Qko2A8:o`TL50;o2@TD00So2A`No`TL5?l9
71ko2A8:o`TV:OlA;c?o2A8:o`T950;o8d5B00?o0000o`TV:Ol971h01?l9
4PX00ol92@[o2A8:o`TB2P02o`TB2P0Co`T95?l971Co2A`DodI<?Olm;cgo
CeiVobaEG?lS@E;o8blNoa4_<olS@E;oEei_odmbNomGSHko;5E_obaN?Ol9
71Co0000o`TB2P02o`T92P0Po`000?mP@BWob[j]ok2n`Oo1al7oYZZSok2c
]ooLhmKob]3FojJZXol0003o6Q`Nob`L5?lA70[oJUDNoh=N<on3Nc?o0000
oaXB5?l92@[o2A8:o`T92_m6EBWo=2lNoiF=D_mbSCgoUHeBo`000?l94P[o
0000o`T92_lA70X3o`T92P0HoaXV5?l/9QCoWW8DojJQI_oC_Xkob]31og9E
D_oCfMKoPg]LonC@c?nVV8Cob]31ojJHQ?o1al7oPhAkol[@`On=SFoo`K>]
ok2c]oo1/hkoLXdmo`000?l92@[o4A`:0_lJ2@X02OlA70[o6PT:oaX92_l/
4P3o6Q8Do`T92_lA70[o6PT:ob<L2P05oaX92P03ob`B0?lJ2@[o;18000;o
4A`:00Co6PT:oa4L2_l92@[o8a`:0_lA70X02OlJ2@[o4A`:oaX92_lJ2@[o
2@T:odH_2_lS70[o0000ol[@eP1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q0002ooooo`0:ookno_oalO7oOWinokno_ooHf=Sof][Jolc<c?o1`L7o
aLG5ol[:bP;oc/k>4OoDe=@01?oioogonoomookooOoooOh2oooloP0Bookm
nOoioo?on?o]on_og?mPPD[oCGHboeB2=on4]FCoN:UGojcKRonSch;oZMF:
ojkJSon_fY;o/MZDok;KUonafYKo[]NE0_naf9L00onaf9Wo/MRGok?GU`02
ok?HU@1Bok?HTonaf9Go/MVCok7HUOnafI?o/MREok7ITonaf9Go/MVCok7H
UOnafI?o/MREok7ITonaf9Go/MVCok7HUOnafI?o/MREok7ITonaf9Go/MVC
ok7HUOnafI?o/MREok7ITonaf9Go/MVCok7HUOnafI?o/MREok7ITonaf9Go
/MVCok7HUOnafI?o/MREok7ITonaf9Go/MVCok7HUOnafI?o/MREok7ITona
f9Go/MVCok7HUOnafI?o/MREok7ITonaf9Go/=VCok3IUOn`fI?o/=VEok3I
Ton`fIGo/=VCok7JU_n`fI?o[mRDojoHT_n_f9Co[]NAojcETOnXdh_oXM:1
oiK8Lon=_FWoNjQEodYc9OlfFaGoPZ5XonGne?oeongolooaoo_ooOodmOOo
ooooooonoooln?Goookkooooo@;ojNWY2_oZj^X4on_[j`Cok>c/2_o]kNd6
onk^kP03oo3`l?o_knoolO7a00ColO7a2?obl_83oo?cl`;om?Cd0_oemOD0
1?ofm_KomoOgooOgmoogmoL2ooShn0_onOWi0_ojn_X3oo_kn`;oo?cl4?om
oOd3ooknoRSooooo00Co3EJaojC4i_nhd^koMZgZ0_n/gol01?mfMWKo`L71
oo3`l?omoOeKooooo`;o6Q8D00?o2A8:oaXB5?l92@X00_lJ4Q@01_lA70[o
2@T:o`T92_l92@[o2A8:oa4L2PKo2@T:00Oo4A`:o`000?l92@[o4A`:o`00
0?l92@[o8a`:00;o2@T:00Co4A`:o`T92_l92@[o2@T:0_lJ2@X00olA70[o
2@T:o`T92P02o`T92P0:odIE:Old;bWoAUDYodHV5?lA70[o8blNoaXV5?lA
70[o8a`:oa4V2P?o4A`:00co2@T:o`TB2_lJ4QCo4A`:o`T92_lJ9QCo6Q8D
o`T92_l0003o2@T:o`000?l92A@3o`T92P03o`TB2_l92@[o2@T:00;o2@T:
00?o0000o`TB2_l92@X02_l92@X01Ol0003o2@T:o`T95?l92@[o000000;o
2@T:00Co2@TDo`T92_l0003o2A8:0_l92@X06_l0003o2@T:o`T95?l94P[o
6PT:o`000?lA;cgo2BHYo`T95?lJ4QCo2A8:o`TL7_lA9Qko2@TDo`TL7_lA
9Qko4Blco`TV:Ol94P[o?G:4oa4_D_lAC5;o4BHNo`TV:Ol92@[o4BHN0_lJ
4Q@0:_l92ACo4A`:oaXB5?l971Co2A8:o`T95?lA70[o2A8:o`T92_l971ko
4BHNob<_<olS@Cgo4Blmoa4_D_n`_/7oYZZ]ong]j_mGSHko4BH:oa4V5?l0
003o4A`:o`T92_lJ4QCo2@T:of11:On3Q7_o/;>goh>HS_n`ZXCo/;>gom?I
e_oLhmKoSIR>ol6c[OoCfMKo0000o`T92_lJ2@[o2@T:ob`B00;oPg/c00?o
2A`Do`TB2_lA70X00_l92@X00ol/9QCoJVLcofYE7P02ohf=DP05odI17_l9
2@[o2A8:oa4L2_l92@X00_lA70X03_l92ACo8blNodH_2_nNNc?o/:Z4olZn
[OnEXHko`J64ol6c[On`ZXCob]31ok2c]oo:d<7oYZZS0_o:d<405onVV8Co
b]31oh=kG?o1/jgo/:Z4oa4V5?l92ACo6Q8Do`T92_lJ2@[o4A`:oaX92_l/
4P3o4A`:o`T92_lJ2@[o;180o`T95?l/4P3o6PT:ob<L2_lJ2@[o8a`:00?o
6PT:00?o;1`Do`T92_lJ2@X00_lJ2@X02?l/4P3o4A`:oaX92_lJ2@[o4A`:
oaXB5?lA70[o6PT:0_lS70X01?lJ4QCo;180o`000?oLhn1Oooooo`04ojn_
[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP0<ong]kOoUiNGoTI6AojBTY?oB
d];oe=CDol;2`_nh^;So`<30olC4a?o9bLWobl_;4Oo@d=006?oeoooonOoo
ookooOonoOWoookkooomnooooOgooOchoo7gkOogoo7ol?oVog>HH_mOS4Oo
?FhMoeJ;<om/XDGoNji?oh>fEon;_63oS;eRohfnHon@`FSoTL5[ohjnJ0;o
TKiY00?oTKi[oi6nJOnB_VT00_nB_VL0COnB_VGoT[iWoi:nIOnB_VOoT[iU
oi:nIonB_VGoT[iWoi:nIOnB_VOoT[iUoi:nIonB_VGoT[iWoi:nIOnB_VOo
T[iUoi:nIonB_VGoT[iWoi:nIOnB_VOoT[iUoi:nIonB_VGoT[iWoi:nIOnB
_VOoT[iUoi:nIonB_VGoT[iWoi:nIOnB_VOoT[iUoi:nIonB_VGoT[iWoi:n
IOnB_VOoT[iUoi:nIonB_VGoT[iWoi:nIOnB_VOoT[iUoi:nIonA_fGoTKmW
oi6oIOnA_fOoTKmUoi6oIonA_fGoTKmWoi6oIOnB`6SoTKmUoi6oIonB`6Ko
Tl5Yoi6oIOn=^f?oR;UNogfcDomi[e7oCh4Zocm[7_mCNSWoT[1lonGneooe
oncojoKVonofk_onoogomoOi00?oooko00?ooognoooooooVi^H02?oVi^H7
onOWi`Koj>SX2ooYjNT3on[ZjP03onc/k?o[jn_okNg]00;okNg]2_o^k^h7
ono_k`Kol?3`2?oalO43oo;blP;olo?c0ooemOD2ooOgm`?on?Sh2_oinOT3
oo[jnP?oo?cl0_ono_hVooooo`04o`mF[_nVa^Ko]]3^ogV_kP;oZmko00Co
KVi^okBd]?oPh>3ok>c/Foo^k^h01olJ9QCo4BHDo`TB2_lJ4QCo4A`:o`T9
2_lA70X00_l92@X00olA70[o2A8:o`T92P0;o`T92P03ob`B0?l92@[o2@T:
00?o2@T:00?o4A`:o`000?lA70X01Ol92@X06?l94P[o0000oeMWD_m?IdOo
=5DYoceN?Old;bWo?Ehmob`V5?lJ4QCo?EhmoaXV5?l94P[o8blNo`TB2_lA
70[o2@T:ob<_:OlA9P[o6Q8Doa4V5?lJ9QCo0000o`TB2P;o2@T:00?o2A8:
o`T92_l94PX01?l92@X00olA70[o2@T:o`TB2P08o`T92P;o2A8:0ol92@X0
0olJ4QCo2@TDo`T92P02o`000003oa4V7_l94P[o000000;o2@T:023o0000
o`T92_l92@[o2A8:o`T92_l0003o2A8:o`T95?lA;c?o2A`No`T92_l94P[o
2@TDoa4V5?lA9Qko2@T:oaXB5?lS@E;o;5ELo`TV:OlA70[o;5E_oa4_D_lA
;cgo2A`Noa4_<olA70[o4BHNo`TB2_l92ACo2@T:ob<_:@;o2@TD02;o6Q8D
o`TL5?ld;c?oLUEBoaXB5?lA70[o2@TDo`T92_lA9Qko8blYob=1?On3V8ko
CeiVoba<:Ol0003o2@TDo`T92_lA70[o2@TDo`000?l92@[oAT4NojJZXonE
XHkoUHeVohf=Koo1al7oi=3<ol[@`On3Q7_oPg]LomcSh?o1/jgo8bH:0_l9
4PX04?l92@[o4A`:oeLL0?n3Nc?oWXdYo`000?lA70[o0000o`T92_lS70[o
;2HDofYW<omZEAkoSHe7ohf=D_l00002o`TB2PCo2@T:00OoARHDofY12_n3
Nc?o^JY_ol6cS_o1/jgob]3100;o`LO101;ob]31ok2ZQ?oTd<coSHe_ol[@
`OnVXISoYYQ_ol77`On=SFooYZZSodIE:Ol0003o2@T:oa4L2_lJ4QCo2@T:
oaX92_lA70X2oaX92P04oa4L2_lJ2@[o2@T:ob<L2P;o6PT:00?o;180o`T9
2_lJ2@X00_lJ2@X00olS70[o;180o`T92P04oaX92P03oa4L2_lJ2@[o4A`:
00;o6PT:00So;180oa4L2_lJ2@[o6Q8DoaX92_lS70[o6PT:ol77c5ook^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN4000?oi^KV00GohN7Qokjn__n1PH7o
[:b/okbl_002ojj^[P04okJf]_nl_;co_knoolC4a17obLW901SomOooooSo
ooolo__oooojooonn?oomoGoo_GfooonooonoogomOoeonooj_o[omooj?oB
olko/_mTVCooC8@Qoced3_m6OQ?oCh<Noe247omAQB7oEXXVoeR;;?mFRBX4
oeV;;0;oFhXZ<_mKRbP8oeV;:003oeR:9omIRbSoFX`Y00;oG8h[017oFX`Y
oeJ89OmBQR;o>g8<odMm6omWVD;oboN/ongoe_oVomOom?oZooOolOokooSo
o?okoo3`k_oooooooogooo_io002ooono`03oooooooQhN7ohN7Q00[oh^;R
0ooShn<2onCTi0?oiNGU2_oVi^H6onOWi`;oj>SX1OoYjNT;on[ZjP;ojn_[
0_o/k>`01?o]kNgok^k^onk^k_o^k^h:ono_k`Gol?3`0ooalO45oo;blPSo
lo?c0_odm?@3ooGem@?om_Kf0_ogmoL3ooShn0[onOWi0oojn_X2ooclo0?o
o_kn4Oooool01?l<DjkoY<?UokSBkomi[^`2ojcOo`04ofYZJ_n^[Zkof=SH
onCTi5_oi^KV00Go2@TDoaXB5?lJ2@[o2@T:o`TB2P02o`T92P03oa4L2_l9
2@[o2@T:00;o2@T:00?o4A`:o`T92_l92@X00_l92@X03_lA70[o2@T:o`T9
2_lA70[o2@T:oa4L2_l92@[o6PT:o`T92_lA70[o2@T:oa4L2_l92@[o;180
0_l92@X2o`TB2P0Ho`T92_lA70[o2@T:oa4V2_ldEBWoH5hcob<_7_lmGSgo
8blYodIE:OlJ9QCo6PT:ocAE:OlJ4QCo4BHDoaXV5?lS70[o4BHDo`T92_lA
70[o6Q8Do`T92_lA9P[o6RHD0_l92@X01?l94P[o0000o`T92_l92@X3o`TB
2P05o`T92_l94P[o2@T:o`TB2_l000000_l92@X01?lA70[o2@T:o`T92_l9
2@X2o`TB2P07o`T92_l94P[o2@T:o`TB2_l92@[o4A`:o`TB2P02o`T92P;o
2A8:00?o0000o`T92_l92@X00_l94PX00ol0003o2A8:o`000002o`T92P;o
2A8:02Ko4Blcoa4V7_l94P[o6Q8Do`T95?lJ4QCo2@TDoa4V5?lA;c?o4Blm
obaWG?lA70[o4BlmobaEKoldIg_o2A`DobaEG?lS@Cgo2BHYo`TL5?lS;bWo
0000oba<:OldEBWo4A`:o`TB2_lA9Qko0000ojJZXonEQ8ko?A8:oiFQS_l9
9RWo2A8:o`TL5?lJ4QCo8blNo`T92P;o000000So2@T:o`TB2_l92@[o2@T:
of1N<on=SE;oUJ6>ol77`@;o`K>]00CoYZZSom?Ie_oLhmKoUJZ]0_m6@Ah0
<Oo1/hkog>?Pol[@e_nESE;o0000o`TB2_lA70[o2@T:oc@_7_m69QCoPg/c
odI<?Ol92ACo2A8:o`T95?l92@[o8bH:odI17_n3GS?oJVLcohf=D_lS;bWo
0000oaXB5?l92@[o4A`:o`T92_lA9QCoARHDofYE7_nNNc?o`K>>ol[@`Omb
SHCoi:ZHomcSe_n`ZXCoi=3<ojJHQ?oCfMKoUHeVomcSh?nVZZ?oYYR4ol6c
[On`/kOoPg]Loa4L2_l94PX00_lJ2@X03ol92@[o4A`:oaX92_lA70[o6PT:
o`T92_lJ2@[o4A`:ob<L2_l92@[o6PT:ob<L2_lJ2@[o6Q8Dob`B0002oaX9
2P04ob`B0?lJ2@[o4A`:oa4V50;o6PT:00?o;180oa4L2_lJ2@X01?lJ2@X0
1ol92@[o8a`:ob`B0?lJ2@[o8a`:o`000?n`/kL0GooVi^H01?nMWIgo]kNg
olS8b?oCdm<1om[JfP000oo^k^h02oo/k>cohn?Soj^[ZomeMGGoP820ohn?
SonLW9coYJFUojb/[?na/K7o]kNg00ko^k^k0onl_;`3okfm_@03okjn__nm
_Kgo_[jn00;o_[jn0_no_kl;ol30`0;o`L710_o2`/801?o3`l?oa<C4olC4
a?o4a<@:olG5a@Goa/K60_o7alL00oo6a/KoalO7olO7a`03olO7a`gob<S8
00?obLW9ol[:b_o:b/X03oo;bl/3olc<c003olg=cOo<c<coc<c<00;ocLg=
2oo>c/h2olo?c`?od=3@00?odM7Aom;Bd_oCdm<00_oCdm<3omCDe0OoeMGE
1_oFe]H2omOGe`Gof=SH2ooIfMT3om[JfP;ofm_K0ooLg=`:omgMg@Gog]kN
0_oOgml00ooNg]kogmoOomoOg`03omoOg`Soh>3P0ooQhN42on;RhP;oi>CT
00?oiNGUonOWiooWinL00ooXj>P:onWYj@?oj^[Z0oo/k>`2onk^kP_okno_
0_o`l?03oo7al@03oo;bl_oalO7ol_;b00;ol_;b0ooclo<>ooCdm004o`iE
[OnUa>Ko]];^ogV^j@;oZ^3o00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01olJ
4QCo4A`:o`T92_lA70[o2@T:oa4L2_l94PX00_l92@X00olA70[o6Q8Do`T9
2P02o`T92P07o`TB2_l92@[o4A`:o`TB2_lA70[o2@T:oa4L2P05o`T92P03
o`TB2_l92@[o2@T:00;o2@T:00go4A`:o`T92_l94P[o2@T:o`000?l92@[o
2A8:oaXV5?m?Ieco=2lNoa4V2_m6EBWo8blN00;o;3PY00Oo8a`:ocAE:OlA
70[o8blYob`V5?l94P[o4BHD00;o2A8:0_lA70X01olA9QCo6RHDo`T92_l0
003o2@T:o`TB2_l000000_l92@X2o`TB2P03o`T92_l0003o2A8:00;o2@T:
00Oo2A8:o`T92_l92@[o2@T:o`TB2_l92@[o2A8:00?o2@T:00Wo2A8:o`T9
2_lA70[o2@T:oaXB5?l94P[o2@T:o`TB2_l000000ol92@X01?l0003o2@TD
o`TB2_l00003o`T92P04o`T95?lJ4QCo2BHYoa4V7P;o2@TD0_l971h06_lA
9QCo2A`No`TV:Ol99RWo4BmBoa4_?Ol9@DOo?G:4obaEG?l971ko8blcog9E
D_n3GS?oLUEBoiF4Non3NecoCfMLo`TL7_lA9Qko6RHDoc@_7_ld;c?oYUEV
ojJ4Q?nEQ7_oSHe_0_l/C2T09OlJ2@[o6RHDo`T92_l92ACo;1`DodI17_lS
;akoARHDof1N<ombSCgoH5hcodmWAon3SHCob]31om?Ie_o:d<7odmWFojJZ
Xol/C2WoARH:ol6c[Oo:_Zgob]31ong]j_oLhn3oLXdmohf=Aol0003o2@TD
oa4L2_l92@[o6Q8Doij=:On3Nc?oAUDYo`T92_lA70X00_l92@X08?m6@Ako
AUDYofYE7_n=SE;oUHeBoa4V2_l92ACo4A`:o`TB2_lA70[o6PT:odI17_mZ
EAkoYZ5Vol6cS_o:d<7oJVLcol6cS_oTd<coYZ6HonC@c?o:_ZgokNgZok2c
]onVZZ?o`K>>ofYW<on`ZXCoUJ6>ol6cS_l0003o2@TD0olA70X01_l/4P3o
2@T:oaX92_lA70[o;180o`T92P;o6PT:00Oo8a`:oaX92_lS70[o;180oaX9
2_lA70[o2@T:00;o6PT:00Go;180oaX92_lJ2@[o6PT:oa4L2P04oaX92P03
oa4L2_lJ4QCo4A`:00;o6PT:00Go;180ob<L2_l/4P3o0000ok2c]`1Oonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0004ooooo`0:ooclo?oalO7oaLG5
ohR8R?mcLg?oNGUioh^;RonBTY;oVIVIoj6QX@koYZJV1_nWYjL00onXZ:So
ZJVYojZZZP04ojZZZPSoZj^[0on/[:`2ojf][@;o[Zj^00Co[Jf]ojj^[_n^
[Zko[Zj^0_n_[jl=ok2`/0;o/K6a00?o/[:bok>c/onc/k<02onc/k<2okBd
]0?o]KFe00?o][JfokFe]One]KD00_nf][H3okNg]`[o^;Rh0oni^KT00onj
^[[o^k^kok^k^`02okbl_0_o_Kfm1Onn_[h00oo0`<3o_knool71`@05ol71
`@[o`/;21?o3`l<4olC4a0[oaLG51_o6a/H00oo7alOoa/K6olO7a`04olO7
a`Sob<S80oo9bLT2ol[:bP?oc<c<0oo>c/h2olo?c`_od=3@0_oAdM43om;B
dP;odm?C2ooDe=@5omGEe@?oemOG1OoIfMT8om[JfP;ofm_K0ooLg=`2omgM
g@?og]kN0ooOgml>on3Ph004o`aD[OnVa^Ko^M?^ogV^j`;oZmoo00CoMWIf
ol71`Oo`l?3ooOgmFoooool01OlJ4QCo4A`:o`T92_l92@[o4A`:00;o2@T:
00Go2A8:o`T92_l92@[o4A`:o`000003o`T92P04oa4L2_l92@[o2@T:o`TB
2P;o2@T:00go2A8:oaX92_l92@[o6PT:o`T92_l/4P3o4A`:o`T92_lJ2@[o
4A`:oaX92_lA70[o2A8:00;o2@T:01?o6PT:o`T92_l/C2WoUJ6>o`000?lS
;akoCfM7o`000?l/>2WoAT`mo`000?ldEBWo0000oba<:Ol92ACo4A`:oaXV
5?l92@[o4A`:00;o4BHD00?o6Q8Dob<_7_l000000_l92@X00ol0003o2A8:
o`000004o`T92P?o2A8:1?l92@X00ol94P[o2@T:o`T92P03o`T92P?o2A8:
00Go6PT:o`TB2_lJ4QCo0000o`TB2P03o`T92P;o2A8:0ol92@X00ol92ACo
2@T:o`T92P02o`TB2P0Co`T95?lS@Cgo2BHYo`TB2_lA9QCo2@TDoa4V7_lJ
71ko4Blmoa4_<olJ71ko;6MLoaXL7_lS@E;o;5E_oa5<D_mGGVoog;jgongI
c002ooK]jP0EooKfmOofooGoUG97o`000?m69P[o^IQLonBZV?oL_[OokMW<
ooK]j_nEQ8ko4BH:ob<_7_lS70[o;1`DodI17_nEQ5;oUIQVojJHKonEV6Ko
UHAk00;oYZZS0onEXHh01ooLaj?ob]3Fog^=I_mZLUco4BH:o`000?mP;a@0
0_o1/jd01_oTd<codmWFomcSh?oLhn3oAT`mohf=A`?o2A8:00?o4A`:oaX9
2_lS70X00_n3Nc<02_l0003o2A8:oa4L2_l92@[o6RHDodH_2_m6@AkoPg/c
ohf=D_m6EBT2o`TB2P0?oaXB5?l0003o=2lYodI17_n3Nc?o^IQLolZn[OoL
_[OoUJZ]ombn]oofooGoYZ6HolZn[On`/kOob]3100;oYZ6H00Oo`LO1ofYb
G?o1/jgo`K>>og^=I_l0003o4A`:00Co6PT:00[o4A`:ob<L2_l92@[o6PT:
ob<L2_l92@[o6PT:o`T92_lJ2@[o8a`:0olJ2@X01?lS70[o;180oaXB5?lS
70X7oaX92P03oa4L2_lJ2@[o8a`:00;o6PT:00?o8a`:oaXB5?lS70X00_lJ
2@X00on`/kOoooooooooo`1Mooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b
0004onk^kP08onc/k?oXj>SofMWIol;2`_nUYJGoSHf=oginO_mfMWKoog9b
LPgoLW9b00WoK6a/ofQXJ?mSHf?oFUYJodi>C_l=E:goXl;TokSCkomg[^/0
0_nZgol01?m^KVko];Bdon3Ph?o/k>aKonk^kP03oaXB5?l92@[o4A`:00;o
4A`:00?o2A8:oaXB5?l92@X00_l92@X00ol94P[o4A`:o`T92P03o`T92P04
oa4L2_l92@[o2@T:oa4L2P;o2@T:00Co4A`:o`TB2_l92@[o4A`:0ol92@X0
0olA70[o0000oaX92P03o`T92P0Boa4L2_l0003o2A8:ob=1?On=SFoo0000
ob<_7_m6EE;o0000ob=1?OldEBWo2A8:ocAE:Ol0003o=5DYo`T92_lA9QCo
8bH:0_lA70X01olA9P[o4A`:oaXV5?lJ9QCo2A8:o`000?l94PX01?l92@X0
1_lA70[o2@T:o`TB2_l92@[o2A8:o`T92P;o2A8:00Go2@T:o`TB2_l94P[o
2@T:oa4L2P03o`T92P03oa4L2_l92@[o2A8:00;o2@T:00?o6Q8Do`T92_l9
2@X01?l92@X00ol0003o2A8:o`T92P03o`T92P09o`TB2_l92@[o2A8:o`T9
5?lA9QCo2A`NoaXB5?l92ACo2A`D00;o2BHY01;o4Blcoa4_?OlA;c?o4Blm
ob=1?OlA;e;o;5ELo`U1AooL/jgokMW<onC7`OofkN[og>?PomcSe_oTd<co
UG97oiib<oo1Ng/2onC7`@0AooK]j_oLhmKom_oeoh=k<ol0003o4A`:ob`L
5?m69QCoSHeBol[@`On`/kOo`K>>ok2c]oo1al7ob]31omcSe_o:d<400_oL
hmH00onVZZ?o4BH:o`000002o`T92P05ofYW<on`ZXCog>?Fol6c[Oo:d<40
0oo]kNX02oo1/hkoAUDYof1N<ol94P[o4BHDo`T92_l94P[o8a`:ocdL2_n3
Nc?obZ4m00?o2@T:00Oo4A`:ob`V5?m69QCoJUDNog:=?OnVV6oo000000;o
2A8:00So6Q8DodHV5?mZIc?oWW/cok2ZQ?o:d<7o`K>]oh=kG0;ob]3101oo
YZ6HolZn[OnVXISo`K>>ojJZXonESFKoYZ6HoiFHI_nEXHkoYZZSoaXV5?l9
2ACo2@T:oa4L2_lJ2@[o2A8:o`T92_lS70[o2@T:oaX92_lS70[o2@T:oa4L
2_lJ2@[o2A8:ob<L2_l/4P3o6PT:ob`B0?lJ2@[o;18000;o6PT:00Ko;180
o`TB2_lJ2@[o2@T:oaX92_lJ4Q@3oaX92P04o`T92_lJ2@[o;180o`T92P;o
6PT:00Co;180ob`L5?l0003o`LO<Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@001?oVi^H02_oShn?ofMWIok6a/OmmOGgoJf][og=cLon2PX;oQhN7
ohf=SOnEUID>oiZJVPKoVi^K0_nLW9`5oifMW@_oWYjN0_nOWil2oj2PX004
oinOWonPX:3oX:2Poj2PX0goXJ6Q0_nRXZ82oj>SX`03ojBTY?nUYJGoYJFU
00?oYZJV2?nWYjL5ojRXZ003ojVYZOnXZ:SoZ:RX00GoZJVY2_nZZZX3oj^[
Z`03ojb/[?n][Jgo[Jf]00;o[Jf]2on^[Zh5ojn_[`;o/;2`1_na/K4:ok:b
/P?o/k>c00?o]KFeokBd]?nf][H00_nf][H:okNg]`go^;Rh2?ni^KT5okZj
^P?o_;bl0onn_[h2okno_`_o`<300_o1`L43ol;2`P;o`l?32oo4a<@5olG5
a@03olK6a_o7alOoalO700GobLW92?o:b/X2ol_;b`?oc<c<00?ocLg=olc<
c?o=cLd00_o=cLd3olk>cPkoclo?00Co45J^ojG4i_nidnooMjk[0_nYg?l0
1?mZJV[o[Zj^omSHf?oTi>AKonKViP;o4A`:0_l92@X00olA70[o2@T:oa4L
2P02o`T92P03oaX92_l92@[o2@T:00Co2@T:00Go2@TDoa4L2_lJ2@[o2@T:
oa4L2P04o`T92P05oa4L2_l92@[o6PT:oa4L2_l92@X00_lA70X07ol92@[o
2A8:o`T92_l92@[o2A8:o`T92_m6@AkoJXeLo`000?ldEBWoLXeLo`TB2_mP
GS?oAUDYob`B0?m?IdOo0000odIE:Ol92@[o8bH:ob`h:Ol0003o;180oa4L
2_lA9QCo;2HDoaXV5?l92@[o0000o`TB2_l000000ol92@X00ol0003o2A8:
o`T92P03o`TB2P?o2@T:00Ko6Q8Do`T92_lA70[o2A8:o`T92_lA70X4o`T9
2P05oa4L2_l92@[o2@T:o`T92_l000000ol92@X00ol94P[o2@T:o`000003
o`T92P08o`TB2_l92ACo2A8:o`TB2_l92@[o6Q8Doa4V5?l92@X2oa4V7P0=
ob=1?OlA;c?o4Blmob=1D_lS;c?o4Blcob=1?OlS@E;o;5E_ojIEI_oLhmKo
b]31ongIc002omcSeP05onC7`OoL_[Oob[j]ombcXooTd<`00_o]fL`03oof
kN[oong<oooooolA9P[o6RHDoa4L2_l0003oJVLcojJ4D_mkSFKoSHe_og^=
Q?n3Q7_oYZ6HomcSeP02omcSh009ojJQV?m6EBWo0000o`T92_lA70[o2@T:
ofYE7_oLaj?og;jg00;og>?P00Wo`LO<ongfmOoLhmKokNgZol[@`Oo1alco
LXdmob<_7_lA9Q@00_lA70X0:ol92@[o8bH:of115?mkC0[oLXdmo`000?lA
70[o2@T:ob<L2_lS9P[oH44Dohf=AonVXFKoH5hco`T92_l94P[oARHDodI1
7_n3Nc?o/8eBolZZI_o:d<7oSHe_onC@c?nVXISoi=3<ol6c[Oo:_ZgoJW]_
ol6c[OnVZZ?oYYR4ok2c]onVXISoSHe_ojJHKol0003o4A`:o`T92_lJ2@[o
4A`:oaX92_lA70X00_lJ2@X01?lJ4QCo6PT:ob`B0?lJ4Q@2ob`B00;o6PT:
00?o8a`:oaXB5?lJ2@X00_lJ2@X00olS70[o;180oaX92P02oaX92P0:ob<L
2_lJ2@[o6PT:ob`B0?lS70[o2@T:ob`L5?lJ2@[o;180oaXB50;o;18000?o
6PT:ob`B0?n`_/40GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000oo^
k^h02oo/k>cohn?Soj^[ZomcLg?oOWinohb<S?nJVY[oXj>SojZZZ_nb/[;o
][Jf00Oo^;Rh0_omoO/4oocmn`;ooOcm01KooO[loogkoOomnOgom?Cfoo3f
m_oTlo3oe>WTom7VhOo=g=Oocm_Gom3Keoo?fmOod=_GoloKeoo@fmOocm_G
om3Keoo?fmOod=_GoloKeoo@fmOocm_G0_o@fmL`om3Jf@0Hom3Keoo?fmOo
d=_GoloKeoo@fmOocm_Gom3Keoo?fmOod=_GoloKeoo@fmOocm_Gom3Keoo?
fmOod=_GolgLeoo9g]Wob^3MomGXi?oUlNoolOOeooOin?olnoWooO_k0_om
n_/02?omnogooOcmoogloOomoOgoo?gmoo[moOomoOgoc/k>0oo?cll00oo@
d=3odM7Aom;BdP02om;BdP[odm?C1_oDe=@2omGEe@Goe]KF3_oGemL2omSH
f0gofMWI0ooJf]X2om_Kf`?og=cL0ooMgMd2omkNgP_ogmoO0_oPh>03on;R
hP;oi>CT2ooUiND2onOWi`?oj>SX00?oj^[ZonWYjOoYjNT00_o[jn/3onc/
k0Sok^k^0_o_knl3oo3`l0;ol_;b0oodm?@3ooGem@kom_Kf00Co35F`ojC4
i_nidnooMZgZ0_n[h?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP08o`TB2_lJ
2@[o4A`:oa4L2_l92@[o2A8:o`T92_lA70X7o`T92P0=oaXB5?lA70[o2@T:
oa4L2_lJ4QCo0000o`TB2_lJ2@[o2A8:o`T92_lA70[o2@T:oaX92P05o`T9
2P0Eoa4L2_lJ2@[o2@T:oa4L2_lJ4QCo;2HDodIE:OlS9P[o8blNofYkKol9
2ACo=5DYodINAolA70[o;4`Yob<_7_lJ9QCo4BHNoaXB5?lJ9QCo4A`:00;o
2A8:00?o;2HDoaXL7_lA70X01Ol92@X00ol94P[o2@T:o`000002o`TB2P06
o`000?l92@[o2A8:oa4L2_l92@[o4A`:0ol92@X01_l92ACo4A`:o`T95?lA
70[o2A8:oaXB50;o2@T:00Co4A`:o`T92_l94P[o2@T:0_l94PX00ol0003o
2@T:o`T92P03o`T92P0Foa4L2_lJ4QCo6Q8DoaXB5?l92ACo2@T:o`TV:Ol9
71ko4BHNoaXV5?l99RWo2A`Nob=1?Ol99RWo8d4mobaEG?lA;cgo;5ELoceb
Q?m?LW_oi=3<ombn]`?oi=3<00CokMW<ombn[Oo]fLcoi<O10_o]fL`09ooL
hmKom^gZooKomOo]kN[ob[j]og8h0?lA70[o4BH:oa4L2_l92@[o=2lYojJQ
I_n3Nc?oAT4NodH_2_o]d9So`K>]ohf=KolA9P[o0000o`T92_lJ4QCo4BHD
oaXB5?mZEAko`K>]onC7`OoLhmKokNgZongfmOo1/jgom_oeomcSh?oLhmKo
b]31omcSe_nVXISoH5hco`000002oaXB5007o`T92_lS70[o4A`:ofYE7_nN
Nc?o2@TDo`TB2P02oa4L2P0Ooc@_7_m6@AkoPehcohf=AoniZVoo0000o`TB
2_ld;akoARHDofYE7_nNSC?ob[j]ojJZXom6C3gokMW<ok2ZQ?oL_[Oob]31
ol77`Oo1alco/:Z4ojJQV?mkSFKoPg]Lok2ZQ?nEQ8koJXeLo`000?l94P[o
2@T:oaX92P02oa4L2P03oaX92_l92@[o6PT:00?o6PT:00Go4A`:oaX92_lJ
2@[o2@T:oaXB5002ob`B00Co6PT:01?o8a`:oaXB5?lJ2@[o8a`:oaX92_lS
70[o;180oa4L2_lJ2@[o4A`:ob`B0?lJ2@[o8a`:oaX92_lS70[o6Q8Dob`B
0?l0003o/;k105ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000?ooooo
00_on_[jom?CdommOGgoX:2Pokfm_On`/;3o[Zj^okFe]Onl_;co_[jnolG5
a@07olS8b0Coo_om01[oooooooonooooo_ooookooooloooooOoolo?eon3V
i_oIiNGoc^7Ool3IeOnnem7o/lS1okC7`Onfal7o]<O1okK7`Ondal7o]/O1
okC7`OnhbL?o]/W3okS9`onfbL?o^<W3okK9``;o^<W300?o^<S5okS8aonh
b<L0;?nhb<L07?nhb<Go^<W3okK9`onhbL?o]/W3okS9`onfbL?o^<W3okK9
`onhbL?o]/W3okS9`onfbL?o^<W3okK9`onhbL?o]L[3ok;@b?nedl_o`=WC
olgPg?oIiN7oi>[Xoo;bl_oonocooogooooloooooOl2ooono`04ooooooon
ooooo?ooooooo`Cog]kN0_oOgml6on3Ph0[ohN7Q0ooRh^82on?Sh`?oi>CT
2_oUiND6onKViP;oj>SX1OoZj^X;on_[j`;ok>c/0_o]kNd01?o/k>cokNg]
ong]kOo]kNd:onk^kPGokno_0oo`l?05oo7al@Sol_;b0_oclo<3ooCdm003
ooGemOofm_Kom_Kf00;omoOg0oohn?P:ooWin@?on_[j0_olo?`3ooknoQ7o
oooo00Co3EF^ojG4i_ned>koNJk/0_nWg?l01?mfMWKo`L71oo3`l?omoOeK
ooooo`09oaXB5?lA70[o6PT:oaX92_lA70[o2@T:oaX92_lA70[o2@T:00?o
2A8:0ol92@X04OlJ4QCo2@T:o`TB2_lJ2@[o4A`:o`T92_lJ2@[o4A`:o`T9
2_l94P[o2@T:ob`B0?lA70[o2@T:ob`B0?l92@[o4A`:00?o2@T:00Ko6PT:
o`T92_lA70[o;3PYodmWAolJ71h2ocAE:@09odI<?Ol94P[o?Ehmob<V2_l9
2@[o=5DYo`000?m6@Ako4A`:00;o4BH:00Ko6PT:oaXB5?lA9QCo4BH:o`T9
2_l94PX4o`T92P03o`000?l94P[o2@T:00;o2@T:00So2A8:o`T92_l92@[o
2@T:o`TB2_lJ4QCo4A`:o`T92P?o4A`:00So2A8:oaXB5?l94P[o6Q8Do`TB
2_lA70[o6PT:oa4L2P?o2@T:00?o2@TDo`TB2_l92@X00ol92@X3o`TB2P0>
o`T95?lS;ako2A8:o`TV:OlA9QCo4A`:ob<_7_lA;c?o4BlmodIWG?lA;cgo
8d4mobaEG?lS@E82obaEG003obaEKooL/jgoi<O100?oi=3<00?oi<O1ombn
[OoTal400_o]fL`06oofkN[okNgZooKfmOofooGokNgZoiEE5?n`E@3og<NS
oa4V2_lS;ako4A`:oa4V5?l92@[o2A8:oc@_7_n3Nc?o/:Z4ol6c[Ol/C2Wo
2A8:oa4L2_lA9QCo6Q8Doa4L2_l92@[oYZ5Vok2ZQ002omcSeP0?omcSh?o]
kN[okOKeojJZXoofoooog>?PomcSe_oTd<cog>?Pol77c?nEXHko0000oa4L
2_l92ACo4A`:00;o2@TD02CoARHDof1N<omZIc?o2A8:oaX92_l94P[o2@T:
odI17_mZ@@[oLXdmojJQI_l/>2Wo2@T:oc@_7_ld;bWoPg/coiib<ooTd<co
SHe_ojJHKoo]kN[oYZZSojJQV?oLhmKoYZZ]olZn[On=SFoo`K>]oiFQS_n=
SFoo`K>]ok2ZQ?lA9P[o2@TDo`T92_lA70X4oaX92P04oaXB5?lJ2@[o6PT:
ob`B00Go6PT:00co8a`:oaX92_lJ4QCo;180oaXL7_l/4P3o8a`:ob`B0?lS
70[o6PT:ob<L2_lJ4Q@2oaX92P06ob`B0?lS70[o6PT:ob`L5?l92@[o6PT:
0_lS70X01?lm4P[o8a`:ob`B0?n`_/5Oooooo`04ojn_[oo;bl_og]kNon[Z
jP7ol_;b0002onk^kP0<ong]kOoUiNGoTI6Aoi6ATOo<c<coeMGEol;2`_ni
^KWo`<30olC4a?o9bLWob/[:1oo@d=02oocoo@03ookooOoooogoooko00?o
ooko00Won?KiooCemooNi>Coa=3>okO:b?n/aL7oX;fhoijk]_nE/:T01onF
/:L8oiF_YP03oiN^Z?nG[J[oUjfZ02coUjfZ00?oUjjXoiF_Y_nE[jH03OnE
[jH02OnB/:KoU;R^oiNk/OnP_kOo[<FookO:a?o7d/kofmoNong]k@03ooom
o`;oooko00Goooooookoooonooooooooon7Qh@03on;RhP03onCTi?oShn?o
iNGU00;oiNGU2_oVi^H6onOWi`03onSXj?oYjNWoj^[Z00Coj^[Z2oo[jn/3
onc/k0;okNg]0oo^k^h:ono_k`?ol?3`0_oalO42oo;blP04oo7alOobl_;o
l_;boo;blP;olo?c2?odm?@5ooGem@?om_Kf1OogmoL:ooShn0?onOWi00?o
no_kooclo?olo?`00_ono_hVooooo`04o`eF/OnTa>Ko^=;^ogJ]jP;o[=oo
00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01_l92ACo4A`:o`T92_lA70[o2@T:
oa4L2P;o2@T:00?o4A`:o`T92_l92@X01Ol92@X00olA70[o2@T:oa4L2P04
o`T92P05ob`B0?l92@[o2@T:o`T92_lA70X01?l92@X00olA70[o2@T:oa4L
2P03o`T92P09odI17_l/>2WoAUDYoba<:Ol/>2WoCfM7o`000?ld;ako;2HD
00;o2A`D00?o4A`:ob<V2_l94PX00_lJ2@X2oa4L2P04oaX92_lS;ako2@T:
o`TB2PGo2@T:00?o2@TDo`TB2_l92@X00_l94PX2o`T92P08oa4L2_l92@[o
2@T:o`T92_lA70[o2A8:o`T92_lJ71h2o`TB2P04o`TL5?lA70[o2@TDoa4L
2P;o2A8:1?l92@X01?l94P[o4A`:o`T92_l94PX3o`T92P05o`TB2_l92ACo
8blNoa4V5?l/>2T00_lA9Q@03OlJ71ko4Blcob<_:OlA;cgo4BHNob<_<olA
;cgo8d5Boa5<D_ldIg_oPhf4onC7`Oo:d<400_oTd<`01Oo]fLcoi=3<onC7
`Oo]fLcog>?P00Com^gZ00Ko`K>]og8V0?niLS?oi;j4ooo]c?mP;`X2ob<V
2P08oaXB5?l92@[o4A`:o`T95?ld;ako^JY_ofYE7_lA9Q@2oaXB5004oa4V
5?l92ACo4A`:oij4IP;ob]3100OokNgZongfmOo]kN[okOKeom?Ie_nVXISo
m_oo00;og>?F02kokNgZomcSh?o]kN[o`LO1o`000?lA9P[o6Q8Do`T92_lJ
2@[o2A8:oa4L2_m69QCoJVLcodIE:Ol0003o4A`:o`T92_l/4P3o=2lNofYE
7_n=SDOoSHeBodIE:Old;akoLSPDok2=7_nVV6oodmWFoiF4NonVV6ooi=3<
ol6c[OnVXISoi=3<oh=kG?o1alcoUHAkol6c[Oo1al7o/:Z4ojJQV?l/C2Wo
6Q`No`000?lJ4QCo2A8:0_lA70X02Ol92@[o6PT:o`T92_l/4P3o6Q8DoaX9
2_lJ4QCo6PT:oa4L2P03oaX92P;o;18000Oo6PT:ob`B0?lJ2@[o6PT:ob<L
2_l/4P3o2@T:00;o6PT:0_lS70X01olJ4QCo;180o`T92_lJ2@[o;180ob<L
2_lJ2@X00_lS70X00ol/71Co0000ong]jP1Oonk^kP04oj>SXonm_Kgoclo?
om[JfP7ohN7Q0002onKViP0<onGUiOoIfMWoN7Qhokbl_?oHf=Sofm_Kolk>
c_o0`<3oaLG5ol[:b_o<c<coclo?1ooCdm<01?okooooo?ooookoooooool2
ooono`0>ooklooofm_SoiNWZom7Kf_nialOoYKVgoiVd[on?/:WoQ:NQogjQ
V_n0XISoOIjCogNHSOmcU8T2og6BQ`03og>DROmeUX_oLY>800OoLY>8<?mc
TXX8og6BQ`;oM9F:0_mcU8T03_mdUH[oMYN<ogRIS_mgVhooMj6EogZTV?n2
Z9goRjbSoiVd[On]`;coa=3>omCJf_oXjNgomoGh0_ooo_l01Oono?oooogo
ooooooono_oooooo00Coi^KV0_oWinL6onSXj0[ojNWY0ooZj^X2on_[j`?o
k>c/2_o]kNd3onk^kP?okno_00?olO7aoo3`l?obl_800_obl_82oo?cl`So
m?Cd1OoemOD3ooKfmPGomoOg3Oohn?P3ooWin@oon_[j0ookno/00oolo?co
oOgmoogmo@02ooknoRKooooo00Co3eJ^ojK6i_nfd>koNJo^0_n[g_l01?mZ
JV[o[Zj^omSHf?oTi>AKonKViP07oaXB5?lA70[o2@T:o`T92_lA70[o2@T:
oaXB5002o`T92P04oa4L2_l92@[o2A8:o`TB2P;o2@T:00Co6PT:o`000?l9
2@[o2A8:2Ol92@X02?l94P[o2@T:o`T92_l92@[o2A8:oaX92_l92@[o6PT:
0_lA70X03?lS;ako;3PYodmWAolJ71ko8blNoceN?OlS;bWo2A8:ob`h:OlJ
9QCo4A`:o`T92P;o4A`:00Oo2@T:oa4L2_l0003o2A8:o`T92_lA70[o4BH:
00;o2A8:00Co0000o`T92_l0003o2A8:0_l00002o`T92P0Bo`000?lA70[o
0000o`000?l94P[o2@T:o`TB2_l92@[o2@TDo`TB2_lA9Qko8d4moba<:OlA
70[o2A8:oa4L2_l0003o6Q8D0olA70X00ol92@[o2A8:o`T92P02o`T92P;o
2A8:00Oo2@T:o`TB2_l92@[o2@T:o`T95?lJ4QCo4A`:00?o2@TD0_lA9Qh0
3?lA;c?o8d4mob<_<olS@Cgo4BlmocAWNonVZZ?oi=3<onC7`OoTd<coi<O1
onC@c0CokMW<0_ofkNX02oofm_Gooooool6QQ?o:ZVKoi<O1omcSe_o]fLco
m_oeodIE:OlA9P[o6Q8D00;o4A`:00?o2@T:oa4L2_l92A@00olA70X02Ol/
71Co4BHDo`T95?lJ4QCoJVLcomc7Xoo:_ZgodmWFong]jP02ongfm@0;ooKo
mOoCfMKoPhf4ooKoooo]kN[og>?PongfmOo]kN[okOKeok2c]olA9PX00_lA
70X0<_lJ4QCo4A`:oaXB5?l94P[o4A`:odI17_mZEAko8blNo`T92_lA70[o
2@TDob`V5?lJ9QCoARHDohf=AomZEAkoAT4Noh=N5?oC_Xkob[j]ol6c[OoL
_[Oo`LO1olZn[Oo:d<7oYYR4ong]j_nVV8CoUJ6>ol6c[On3NecoYZZSok2c
]onEV6Ko0000oa4L2_l92@[o6Q8DoaX92_l92@[o;180o`T92_lA70[o8a`:
o`T92_l/4P3o6PT:ob<L2_lJ2@[o2@T:0_l/4P003OlJ2@[o6Q8DoaX92_l/
4P3o;1`DoaX92_l/4P3o?A8:oaX92_lA70[o6PT:o`T92_l/4P000olJ2@X0
1?lA70[o8a`:oaX92_lJ2@X2ob<L2P?o;18000?odmWFonKVi_oVi^H0GOoV
i^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h01?o/k>cogmoOog5a
LOoAdM42omcLg006om3@d?o4a<CobLW9olc<c?o?clood];B1ooEeMD2oo_o
oP0Lookno_ono?goookoookloOocm?KoiN_[olGAcongb/KoXkjiohj_Z?mk
X9SoJYB:oej7OomGPGOoGhUkoej9N?mNQgWoG8Mfoef6N?mMR7OoH8Ukoen:
NOmPRG_oGhYiof29NomORWWoH8Ukoen:N@CoH8Uk04WoHXQkof29NomRR7_o
H8Ukof:8NomPRG_oHXQkof29NomRR7_oH8Ukof:8NomPRG_oHXQkof29NomR
R7_oH8Ukof:8NomPRG_oHXQkof29NomRR7_oH8Ukof:8NomPRG_oHXQkof29
NomRR7_oH8Ukof:8NomPRG_oHXQkof29NomRR7_oH8Ukof:8NomPRG_oHXQk
of29NomRR7_oH8Ukof:8NomPRG_oHXQkof29NomRR7_oH8Ukof6:O?mPRg[o
HHYlof2;N_mQRWcoH8]jof6:O?mPRg[oGXMioeb7M_mMQWSoG8Mfoef6N?mN
RGSoH8Ukoen;O?mUUHGoFHamoeZ8Nom[UHWoOJ6Goh^YXOnO]K;o/l?2olkH
fOoSj>_omoSl00;ooooo00Coookoooomooomnokooooo3?oWinL7onSXj0?o
jNWY0ooZj^X2onc/k0?ok^k^0_o_knl>oo3`l003oo7alOobl_;olo?c00oo
lo?c0_odm?@3ooGem@?om_Kf2_ogmoL3ooShn0;onOWi0oojn_X2oo_kn`?o
o?cl3OomoOd3ooknoRSooooo00Co35>^ojC3iOnhd^ooNJk/0_n/gol01?m^
KVko];Bdon3Ph?o/k>aKonk^kP0<oaXB5?lJ2@[o4A`:oa4L2_l92@[o4A`:
o`T95?lS70[o2@T:oa4L2_l92@[o00001?l92@X02OlA70[o2@T:oaX92_l9
2@[o2A8:oa4L2_lJ2@[o2@T:oaX92P02o`T92P04ob`B0?lJ2@[o2@T:o`TB
2PKo2@T:00[o4A`:odI17_lJ9QCoAT4NodmWAol0003o=5DYodIE:Ol0003o
;3PY0_lA70X01Ol92@[o4A`:oa4L2_l92@[o4A`:00;o2@T:00Go4BHDoaXV
5?l94P[o2A8:o`000004o`T92P06o`TB2_l92@[o2@T:o`TB2_l92@[o2A8:
1?l92@X01_l0003o2A8:o`T92_l94P[o0000o`TL7P;oLXf]00WoAVMLob<_
:Ol92@[o2A`DoaX92_lA70[o4Blcoa4V7_l92@X00ol94PX00olJ4QCo2A8:
o`T92P03o`TB2P03o`T92_l971Co2@TD00;o4BHD00Co6Q`No`TV:OlA;cgo
8blc0_lA;c<01_lA;e;o4BlmoiF4S_o]fLcog;jgonC@c0GokMW<0_oLhmH2
ooK]jP06ooKfmOo]m_Goong<ooK]j_o]kN[oong<0_ofooD01OlA9P[o2A`D
oa4L2_lA70[o2@TD00?o2A8:00So2@TDoa4V5?lA9QCo4BHNo`T95?mP@BWo
YYQ_olZn[@;og>?F1Oo]kNX00ooLhn3oLVMBooKoo`06ong]jP06oaXV5?l9
71Co4BHDoaX92_l92ACo6Q8D0_lA70X2ob`V5008of115?l92ACo4A`:o`TB
2_lJ2@[o6RHDob`V5?mP@BT2odI17P0:ok2=<oo1/hkoi=3<oiF4NooLhmKo
`K>]ojJZXooCfMKoUJ6>ol77`@;oYZ6H00So`LO1ok2ZQ?o1/jgo`K>>o`00
0?l92ACo2@T:oa4L2P?o2@T:00Go8a`:o`TB2_lJ2@[o2@T:ob`B0006oaX9
2P03oaXB5?l/4P3o;18000;o8a`:00ko;180ob<L2_lm4P[o6PT:oa4L2_lJ
2@[o4A`:ob`B0?lJ2@[o;180oaXB5?l/4P3o6PT:ob`B00;o8a`:00Ko;180
oaXB5?lS70[o;1`Do`000?oCfMIOonk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q0002ooooo`0<oogmoOo]kNgoLG5aomOGeooNg]kogmoOomCDe?o4a<Co
alO7olc<c?o@d=3od];B1ooFe]H2ookoo`0Looooooooo_ooookooo[koOoV
k>cod=oLokS>bonN_KOoOZJMofjLTOmeY9[oR;Z_oj7@a_n_gm?oaOGUolKg
h_o:nNOobocWolglj_o<oNSoc?_Yol_lioo8mnGoaoSSolSgiOo7n>?ob?OU
olOhh`Cob?OU04_ob_KUolSgiOo:m^Gob?OUol[fiOo8mnGob_KUolSgiOo:
m^Gob?OUol[fiOo8mnGob_KUolSgiOo:m^Gob?OUol[fiOo8mnGob_KUolSg
iOo:m^Gob?OUol[fiOo8mnGob_KUolSgiOo:m^Gob?OUol[fiOo8mnGob_KU
olSgiOo:m^Gob?OUol[fiOo8mnGob_KUolSgiOo:m^Gob?OUol[fiOo8mnGo
b_KUolSgiOo:m^Gob?OUolWhi_o8nNCobOSVolSii?o9n>Kob?WTolWhi_o8
nNCoc?_Yol[ki_o;n^SobO[Uol[iioo:nnKobo[XolWljOnmm>7oZ>7>oiW?
_on=`;7oO:ZOog>KT_n:ZZGo[<K3okO;b_o?gMgojO?dooWnooonool01?oo
o_l01_oXj>SojNWYonWYjOoYjNWoj^[ZonWYj@?oj^[Z0oo[jn/=onc/k003
ong]kOo^k^kokno_00cokno_0oo`l?03oo7al@03oo?cloobl_;om?Cd00;o
m?Cd0_oemOD8ooKfmPOomoOg1_ohn?P;ooWin@;on_[j0_olo?`00ookno_o
oOgmoogmo@0AooknoR[ooooo00Co3eJ^ojG4i_nfd^koNJkY0_nZh?l01?mf
MWKo`L71oo3`l?omoOeKooooo`08oa4L2_l92@[o2@T:oaX92_lA70[o2@T:
oaX92_lA70X5o`T92P04o`TB2_l92@[o6PT:oa4L2P?o2@T:00?o2A8:o`T9
2_lJ2@X00ol92@X00olA70[o0000o`T92P03o`T92P03oa4L2_l92@[o4A`:
00;o2@T:00_o8a`:odI17_lA70[o6RHDocAE:OlA70[o2A8:ob<V2_lS70[o
0000oa4V2P02o`T92P09o`TB2_l92@[o2@T:o`TB2_lA70[o4BH:oc@_:OlJ
9QCo4A`:00Co2@T:00Co2A8:o`T92_l92@[o00000ol94PX01Ol0003o2A8:
o`T92_l94P[o2@T:00Co2A8:00Go2@TDoa4V2_lJ4QCo8d5BocAE?@02ob=1
?@?o4A`:00Ko6Q`Nob=1?Ol/C2Wo2A8:o`TL5?l92A@2o`TB2P09o`T92_l9
4P[o2A8:o`TB2_lA70[o2@TDo`T92_l92ACo4A`:00;o2BHY00So8blYoa4_
?OlS@E;o8d5BocebQ?nVXISokMW<onC7`@;oi=3<00[og>?Fooo]c?o]fLco
kMW<ong]j_oLhmKom_KeooK]j_ofooGom_Ke0oofkNX02?ofooGom^gZooKo
mOoLaj?o0000o`TL5?l92ACo2@T:0_lA70X03?lJ4QCo2A8:oaXB5?lJ4QCo
6Q`No`TB2_mP;aCog>?FonC@c?oLhmKog>?Pongfm@?okNgZ00OokOKeong]
j_o]kN[o`LO<ong]j_oLhn3okNgZ00;og>?P00[ob]31omcSe_o1/hko0000
oa4V5?lA70[o6PT:o`TB2_lJ2@[o2@T:0_lJ2@X05om6;`[oAUDYo`000?lA
70[o2@T:oaXB5?ld;akoJUDNoc@_7_nNNc?o`K>>ol6c[On3SHCoYYQ_ol6c
[Oo:d<7oYYR4ol[@`On`/kOo`K>]ol77`OnVXISoYZZS00;oUIQV00?o0000
o`T95?l94PX00ol92@X2oa4L2P06o`T92_lJ2@[o6PT:oa4L2_lJ2@[o8a`:
0_lJ2@X03Ol/4P3o8a`:oaX92_lJ2@[o8a`:oaX92_lS70[o;180ob<L2_lJ
2@[o;180ob<L2_l/4P000olJ2@X00olS70[o6PT:ob`B0003oaX92P08ob<L
2_l/4P3o6PT:ob`B0?lS70[o;1`Dob`B0?o1alaOooooo`04ojn_[oo;bl_o
g]kNon[ZjP7ol_;b0002onk^kP04onc/k?oLg=coMgMgomWIf@;oh>3P00Ko
e=CDolO7aoo:b/[oc/k>om;Bd_oDe=@7omKFeP;ooooo0_ooo_l07?oooooo
l_KgomGQgonid<[oWKjgohRcZOmi[J3oPKZ[oicFb?nhl>?ob?kaolcoloo6
nNKoao_TolWmioo;onSobooYol[nioo8o>Koao_Tolcoj_o<onWoc?oZolco
jOo<on[oc?oYolcoj_o<onT`olkoj@;oc?oY01coc?oZolcojOo<on[oc?oY
olcoj_o<onWobooYol_oj?o:o^SobOgVolWmioo9oNKobOgWolOnioo2oNOo
`?kYol7nk?njmN?oX=K8oh6cYomgYI_oPJVQoj71_?nid/ooenOWonggn?oi
oOkoooko0_oooOl00oooo_ooj>SXonSXj00:onSXj0OojNWY0_oZj^X01_o>
c/koM7AdonCTi?o[jn_okNg]onc/k0?ok^k^0_o_knl;oo3`l0?olO7a0_oc
lo<3ooGem@Kom_Kf00CofMWIogUiNOo_knoom_Kf3OogmoL;ooShn0;onOWi
0_okno/00oolo?coo_knooknoP0kooooo`04o`eE[_nVa^Ko^M?^ogV^j`;o
Zmoo00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01?lA70[o6Q8Doa4L2_lA70X2
o`T92P0>oaXL7_l94P[o2@T:oaX92_lA70[o2@T:oa4L2_l92@[o4A`:oaX9
2_l92@[o4A`:oaX92_lA70X3o`T92P05oa4L2_l92@[o4A`:oaX92_l92@X0
0_lA70X01?l92@[o2A8:oa4L2_lJ2@X2o`T92P08oa4L2_lS70[o6RHDoba<
:OlA9QCo6Q8Doba<:Ol00002oa4L2P0=o`TB2_lA70[o2@T:oa4L2_l92@[o
6Q8DoaX92_lA70[o6Q8Doba<:OlS;bWo6RHDo`T92P03o`TB2P;o2@T:00?o
6Q8Do`T92_l92@X01Ol92@X00ol94P[o2@T:oa4L2P02o`T92P0AoaXB5?l9
2ACo4BHDob<_:Ol/>2WoCfMLofYkQ?m?LW_oPiR]og:=Q?lmGSgo0000oaXL
7_l92ACoUJ6gob<_<ol000000_l971@05_lJ4QCo2A8:o`T95?l92ACo6Q8D
o`T95?lA70[o6Q8Doa4V5?l971Co2BHYob<_<ol9@DOo4Blcoa4_D_mGGVoo
2BHYojJQV?ookLcog>?FongIc?oTd<`3omcSeP05ooo]c?o]fLcokNgZooo]
c?o]kNX00oofm_D01oofkN[om_Keooo]c?ooooooong<oa4V2_l94PX00_lJ
4Q@00olA9QCo6Q8Doa4V5002oaXB5004oa4V5?l92ACo6Q8DofYE7P;og>?F
00Coi=3<omcSh?o]kN[okNgZ1Oo]m_D00oofooGog>?Fong]jP04omcSeP06
om?Ie_o1al7og>?Poa4L2_lA9P[o6PT:0olA70X02_lJ4QCo4A`:ob<L2_lA
70[oARHDodI17_l92@[o=2lNofYE7_m6@Ah2of11:@0IolZZI_oLaj?oYZZS
ombn]on`ZXCob[j]ol77`OnVXFKo`LO<oh>=Q?o1/jgoUHeVojJHQ?o:_Zgo
UJ6>o`000?l92@[o2@TDoaXB5?l92ACo2@T:oa4L2_l92@[o6PT:oa4L2P03
oaX92P0<ob`B0?lJ2@[o8a`:ob`B0?lJ4QCo6PT:ob`L5?l/4P3o6PT:ocdL
2_l/4P3o6PT:0_l/4P001_lJ2@[o?A`:oaX92_lJ2@[o8a`:oaX92P;o8a`:
00?o6PT:ocdB2_lA70X00_lS70X01ol/71Co8a`:ob`L5?lS70[o;1`Dob`B
0?n`/kL0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H03?oT
i>Coe=CDogIfM_oJf][oh>3Pon7QhOoDe=CoalO7ol_;boo>c/kod=3@om?C
d`OoeMGE023oo_coooomoooonooooO_nooOhn_oSk>_o_m?Aoijo^?mlZYoo
O;JWohS8^?nNhm7o]_WXol7olOnmn^_o^?7PolWoj?o9onGobOoWolWoiOo9
onOob?kTolSni_o7oN?oc?oZolcoj?o<on[oc?oXolcoj_o<onSoc?oZolgo
j33ocooX02;oc?oWol_oioo;onWobooWol_ojOo;onOobooYol_oioo;onWo
booWol_ojOo:onKobOoWolWoiOo8o^KoaooVol3oj?nnonWo__o[ol3okOnn
o^go[^cMoi3:__mhZj;oQ[6Zoibo^OnnemCog^c/oo?inOomnokooo_noool
ooooo_ooj>SX0ooYjNT2on[ZjP?ojn_[0oo/k>`7ong]k@;ok^k^00Koj^[Z
oa/K6onJVY[ok^k^oo3`l?o_knl5oo7al@_ol_;b1?oclo<4ooCdm0KomOGe
00ColO7aoa/K6onNWYkomOGe1Oofm_H2ooOgm`03ooKfm_ogmoOomoOg00?o
moOg2oohn?P2ooWin@;ono_k00?oo?clookno_ono_h0>oooool01?lAEjoo
Xl;TokSCkomg[^/2oj[Oo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00[o4A`:
o`T92_lA70[o6Q8Doa4L2_lJ4QCo4A`:oaX92_l92@[o2A8:0_l92@X03Ol9
4P[o2@T:oa4L2_l92@[o;180o`T92_l94P[o2@T:oa4L2_l92@[o4A`:oaX9
2_l94PX00_l92@X02_lA70[o2@T:o`T92_l0003o;180o`TB2_lA70[o2@T:
o`TB2_l92@X2ob<V2P09odH_2_lA9P[o2A8:ob`B0?l94P[o2@T:o`TB2_l9
2@[o000000Go2@T:00Go4BHDob`V5?m?IdOo=2lNoa4L2P03o`TB2P;o2@T:
00Go4A`:o`T92_l92@[o2@T:o`TB2P05o`T92P03oa4L2_l92@[o4A`:00;o
2A8:013o6Q8DoaXV5?lS;bWo4Blmog:=Q?mZNhCoH79kojJc`On3V:goUJ6g
oh>=Q?l/GSgo;4`Yob=1?OoChoGoUIRS0_l000004ol94P[o2A`Noa4V7_l9
71Co6Q8Do`T92_lA9Qko2BHYo`TL7_l92ACo8blcob=1?OmGGVooLUEBojJH
Q?oTal7oWW8co`000?lmGSd00oo]fL`01ooTd<cokMW<omcSh?oLhn3oong<
ooK]j_o]kNX00_ofkNX2ooKfm@0<ooK]j_ofooGom_oeoh=kG?l0003o2A8:
oa4L2_l92ACo4A`:o`T92_l92ACo2@T:0_lA9Q@01?l92@[o=2lNok2ZQ?o1
/jd2ol[@`@03omcSe_oLhn3okNgZ00?okOKe00Gom_ooooKomOoLhn3og>?F
omcSh003ong]jP?ob[j]00Sog;jgomcSh?o1/jgo4BH:o`TB2_lA70[o6PT:
o`T92P?o4A`:00oo6PT:oaXB5?mP@ACo=2lNog]<5?n3GS?oAUDYog8h5?nN
Nc?ob[j]ol77`OniZVoodmWFoh=kG?oTd<`00_nVZZ<02oo:d<7oYYQ_ol6c
[Oo1/hko`LO1oiFQS_l0003o2@T:o`TB2_l92@[o4A`:00;o2A8:00Co4A`:
o`T92_lA70[o8a`:0olJ2@X01OlJ4QCo;180oaXB5?lJ2@[o;18000;o6PT:
00Wo8a`:ocdB2_lJ2@[o;180ob`L5?l/4P3o6PT:ob`L5?lm70X00_lS70X0
1?lJ2@[o;180oaX92_lS70X2ob`B0003oaX92_l/4P3o8a`:00;o;1800_lS
70X00olm70[o;180ok2n`@1OonKViP04oifMWOng]kOob<S8om?Cd`7of][J
0002onk^kP04onc/k?oLg=coO7alom[JfP;oh>3P00Kodm?ColK6a_o<c<co
c/k>om3@d?oCdm<7omOGe`0AoooloooooOoooocooocjoOoal_Cof>CRok3;
a_n>^:koM:fNogo4/OnDgl_oY?7Mok3kiongo^co`oocolcomOo;on/00oo;
onL2olcoj003olgojOo>on[ob_oV00Kob_oV03;obooTolgoi?o=on;oc_oR
olgoh_o>on;ocOoRolkoh_o=on;oc_oRolgoh_o>on;ocOoRolkoh_o=on;o
c_oRolgoh_o>on;ocOoRolkoh_o=on;oc_oRolgoh_o>on;ocOoRolkoh_o=
on;oc_oRolgoh_o>on;ocOoRolkoh_o=on;oc_oRolgoh_o>on;ocOoRolko
h_o=on;oc_oRolgoh_o>on;ocOoRolkoh_o=on;oc_oRolgoh_o>on;ocOoT
ol[oh`OobOoU1Oo=onT05Oo<onSobooWolOoj?o7oo3o`?o^okGjiOnXl=[o
Z>oMojG/f_nEelWoP;jaogFZX?n:]Jko[/g8omCXi_obn_coookooooloooo
n_koookoonOWi`03onSXj0;ojNWY0ooZj^X3on_[j`?ok>c/00Cof][JomgM
gOo/k>cok>c/0oo]kNd00on1PH7o>CTiong]k@02ono_k`GolO7a00?ol?3`
om3@d?oJf]X01_obl_800ooIfMWol?3`oo?cl`02oo?cl`03on3Ph?oShn?o
lo?c00;olo?c1oodm?@00on5QHGo>c/kooCdm005ooGem@?omoOg0_oinOT0
0ooMgMgod=3@ooShn005oo[jnP03onOWiooZj^[on_[j00?on_[j0_okno/3
ooclo0;ooOgm1Oono_h00ooclo?oinOWooknoP04ooknoP03oo?clooWinOo
o_kn00;oo_kn:_ooool01?lAEjooYLCVokWCkomg[^/2ojWLo`04ofi^K_nd
];Coh>3Ponc/k5_ok^k^00Oo6Q8Doa4L2_l92ACo?Blmo`T95?lA70[o6PT:
00;o2@T:00?o4A`:o`T92_l92@X00ol92@X00ol94P[o2@T:oa4L2P04o`T9
2P09oa4L2_lJ2@[o2@T:o`T92_l/4P3o2@T:oa4L2_l92@[o2A8:00;o6PT:
0ol92@X01OlA70[o8bH:o`TB2_lA70[o2A8:00Go2@T:0_l94PX01?l92ACo
2@T:o`TB2_l92@X2ocAE:@04ocd_?Om6EBWo4BH:o`TB2P?o2@T:00Go4A`:
o`T92_lA70[o4A`:o`TB2P06o`T92P0Bo`TB2_l92@[o2A8:o`TB2_l92@[o
4A`:o`T95?lS;c?o;4`Yoc@_<on3Q8koPiR>ok2c]onEV:?oPiR>oiFHXon`
_/7oEfMB0_lA9Qh03OldIg_oUK?<ol[@e_n3Q8ko?Blmob<_<ol/71Co2BHY
oa4V7_l/>2WoEeEBofYW<omGGVl00onVXIP02Oo1/jgog;>SolZn[OoTal7o
kMW<omcSe_n3GS?o0000ofYbG003ooK]jP0AongIc?oLhn3okNgZong]j_of
kN[okMW<ongfmOookLcom_oool[@`Oo1/hko4BH:o`000?l94P[o2@TDoa4L
2_l94PX00olA70X04_lA9QCo6PT:ob<_7_ld;akoLXdmok2ZQ?nVXISob[j]
omcSe_oLhn3okNgZongfmOofooookOKeooKomOo]kN[og>?PolZn[@?okNgZ
00Cog>?Pong]j_o]kN[og>?P0_oLhmH2omcSh008ohf=Kol94P[o4A`:oa4L
2_lJ4QCo2@T:oa4L2_l92@X2oa4L2P0Fob`L5?n3GS?oAUDYofYW<omZEAko
bZYVom>nS_o1/hkoYZ6Hol6cS_o:d=Ko/:Z4ol[@`OnVZZ?o`K>>ok2c]onE
XHko`LO1om?Ie_ldECgo0000o`T950;o2@T:0ol94PX5o`T92P06oa4L2_l/
4P3o6Q8Dob`B0?lS70[o;1800_lJ2@X03?lJ4QCo;180oaX92_lS70[o;180
ob<L2_l/4P3o?A8:ob`L5?l/4P3o?A8:ob`B00;o6PT:00Go6Q8Dob`B0?lJ
2@[o;1`DoaX92P02ob<L2P05oaX92_lJ4QCo8a`:ob`B0?l/71@00_l/4P00
0on`_/7ok^k^onk^kP1Monk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002
ooooo`04oogmoOo/k>coO7alom[JfP;oh>3P00Kodm?ColO7aoo<c<coc/k>
om3@d?oBd]87omKFeP0AoooloooooOoooogooo_io?o[ko3ocmkKojO6`?n5
]JWoN[RYohC?^onGjM?oYOWRojWkiOn^nNGo]?KXok_hj?o5oN@00_o8oN40
0oo9o^;ob_oSol[oh`02ol_oi0Soc?oU0_o?on80;_oAon;ocooRom7oh_o?
on;odOoRolooh_oAon;ocooRom7oh_o?on;odOoRolooh_oAon;ocooRom7o
h_o?on;odOoRolooh_oAon;ocooRom7oh_o?on;odOoRolooh_oAon;ocooR
om7oh_o?on;odOoRolooh_oAon;ocooRom7oh_o?on;odOoRolooh_oAon;o
cooRom7oh_o?on;odOoRolooh_oAon;ocooRom7oh_o?on88olcoi@03olSm
hOo9o^;ob_oS00;ob_oS017obOkRolSmhOo3o^;o]oSPok_ojoo1ooCo__ob
ok;ojonTlMgoUn7@oi3Daomk]jgoR;Zaoj?8`Oo9h]kok?Kgookno`02oook
o`03ooonoooWinOoj>SX00;oj>SX00GojNWYon[Zj_o[jn_oJFUYoc<c<`03
onc/k007ong]kOo;bl_o<C4ao`d=3Ol;2`_o=3@dolc<c003onk^kP03ohR8
R?l0003ob<S800;okno_1?o`l?001_nUYJGo2@T9o``<3?lR8R;o<c<coifM
W@;olO7a00ooalO7ob8R8_lL71co[jn_oo;bl_o?cloo<S8bo`d=3Ol;2`_o
=SHfom;Bd_odm?ComOGeocdm?OmjNWX01?oemOD00on<S8co0000olk>cP05
ooKfmP;on?Sh00oomoOgoiZJV_lB4Q;o20P8obHV9_lJ6Q[oBTY:omCDe?oj
n_[oe]KFoc<c<ol=3@go2`/;ocLg=ooGemL00_ojn_X01omjNW[o@410oocl
o?olo?cooOgmog]kNom1@D400oooool03OoWinOoBTY:o`<30olS8b?o5aLG
ol71`OooooooinOWodY:B_l30`?o8b<SoaLG5oo1`L40:oooool01?l=E[7o
Y<CVokWCkomf[NX2oj_Po`04ogIfM_o1`L7ol?3`oogmoE_ooooo00Go4A`:
o`T95?lS;ako;180oaXB5003o`T92P06oa4L2_l92@[o2@T:o`T92_l/4P3o
4A`:0_l92@X2oa4L2P08oaX92_lA70[o2@T:o`TB2_lA70[o2A8:o`T92_lA
70X4o`T92P04oa4L2_l92@[o6PT:oa4L2PCo2@T:00?o2A8:o`T92_l94PX0
1?l92@X00ol0003o6PT:o`TB2P02o`TB2P07o`T92_l94P[oAT4NodIE:Omb
SCgo4BH:o`T92P03oa4L2P06oa4V5?l/9QCo6RHDoaX92_lA70[o2@T:0_l9
4PX2o`T92P03o`TB2_l92@[o2A8:00;o2@T:0_l94PX01olJ4QCo4A`:ob`h
:Ol/C2WoEfMBojJZ[Om?GVH00_n3V8h08OmkSHCoUJ6>ojJc`Oo1al7o=2lN
og:=?Old;ako8blYojK7h?oChoGokOKeom?SmOofooooUHeVojJHKonNQ6Ko
YXABoij4I_n`Q7_o`J64ojJ4Q?o1XHCo/8Akol6QQ?niZVoo`K>]ombcXooL
_[Ooi<O1ol6QQ?n3GS?o4BlmoiF4SP02ongIc0;om^gZ00WokNgZooK]j_o]
kN[okNgZombn]oniZVoo;180o`000?l94PX00_l92A@02?l971Co6Q8Do`T9
5?l92@[o6Q8Do`T95?lJ9QCo=2lN0_m6EBT01_n3NecoYZZSok2c]oo1al7o
b]31omcSeP;okNgZ0_o]m_D01_o]kN[og>?PonC@c?oLhmKokNgZongfm@?o
kNgZ0_o]m_D02?o]kN[og>?PomcSe_oLhn3om_Keoa4V2_lA70[o6PT:0_lA
70X02OlJ4QCo4A`:o`T95?mP@BWoPg/cofYE7_mP@BWoNd`DolZZIP02ol6c
SP0Bol[@`OnVXISob[j]ol6c[OnEXHkob[j]ol77`OnVXISo`K>]ok2c]oo1
/jgoPiR>o`000?l92@[o6Q8Do`T92_l94P[o6Q8D1Ol92@X2oa4L2P03oaX9
2_lJ4QCo6PT:00?o6PT:01Co8a`:oaX92_lS70[o;180oaX92_lS70[o;1`D
ocdB2_lm70[o8a`:oaX92_l/4P3o?A8:ob`B0?lS70[o6PT:ob`B0?lJ4QCo
6PT:ob`B00;o8a`:00Go6PT:ob`B0?lm70[o;180ob<L2P02ocdL2P03ob`B
0?o1alcooooo05kooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000;ok^k^
00Cok>c/omcLg?mlO7cof][J0_oPh>001_oDe=Cob<S8ol_;boo>c/kod=3@
om;BdPOoe]KF01?ooOgmooonooooo?kon_ChonKWjOo6e]GoV/:jogNcYon8
d/7oQ=O3oh[Ob_nGj]KoYoKSokCnkOnhoo3o^oo]ol7oi_o4onCoaOoU00;o
aooV00?oa_oUolCohoo3o^801oo3o^80<_o5oN;oa_gNolKmg_o7o=koa_gN
olOlg_o6oMkoaocNolKmg_o7o=koa_gNolOlg_o6oMkoaocNolKmg_o7o=ko
a_gNolOlg_o6oMkoaocNolKmg_o7o=koa_gNolOlg_o6oMkoaocNolKmg_o7
o=koa_gNolOlg_o6oMkoaocNolKmg_o7o=koa_gNolOlg_o6oMkoaocNolKm
g_o7o=koa_gNolOlg_o6oMkoaocNolKmg_o7o=koa_gNolOlg_o6oMkoa_kS
1oo4on<00oo3o^;oa?oSolGoi002olKoi@0EolGoi?o4on?o`_kTolCok?ni
o^Wo/ogVok3ojOnVnnCoUNgGohONbon6elKoPl^mohK2]_nGaK_o^=GAom_Y
jOoem_Sooo[oooolooooo_ooinOW00?oj>SX0_oZj^X00oo/k>coJFUYoc<c
<`04ong]k@07oc0`<?m<C4cog]kNomkNg_m?Cdoo<C4aonk^kP02ono_k`03
ob`/;?l820SoJFUY00Kokno_00_ob<S8ok>c/oo[jn_ol?3`oi>CTol30`?o
d=3@oo3`l?mZJV[o?Cdmono_k`02oo3`l00:oc4a<Om=CDgohN7Qon;Rh_mA
DE7o<S8boo?clooemOGo?CdmogYjNPComOGe00?o;Bd]o`P82?m/K6`01Oof
m_H2ooOgm`0;oi>CTol20P;oQhN7ooGemOohn?Som_Kfojf][OoBd];on?Sh
oc8b<_m@D5000_oXj>P01_mCDe?o<c<cooShn?oinOWoNGUiod10@0?oo?cl
00?oNg]kod51@Oooool00_ooool03Om4A4Co@410omoOgooooooolo?coo;b
l_ooooooA4A4od10@?oOgmoooooooo?cloobl_80:oooool01?l=EJkoYLCV
okG@k_mi[^`2ojOLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^0_lJ4Q@00olA
70[o2@TDoa4L2P02oa4L2P03oaX92_l92@[o4A`:00;o4A`:0ol92@X00olA
70[o2@T:ob`B0002oaX92P0;oa4L2_l92@[o6PT:oaX92_lA70[o2@T:ob`B
0?l94P[o2@T:o`TB2_l92@X00_lJ2@X01Ol92@[o2A8:oa4L2_l92@[o4A`:
00;o2@T:00Co0000o`TB2_l92@[o2A8:0_l92@X02Ol0003o2A8:oa4L2_l9
2@[o2A8:ob`L5?mPGS?oAUDYob<V2P02o`TB2P0;oaX92_l94P[o6PT:ob<V
2_l/>2Wo;2HDoa4V2_lS70[o4A`:o`T92_lA70X00_l92@X01?l94P[o4A`:
o`T92_l00004o`TB2P06o`T92_lJ9QCo=2lYofYkKonEZZgoJW]_0_n=V8h0
5?n3V8koSIR>oiFZ[Oo1alcoYZ6HoiFZ[OlS;ako6RHDoa4V2_mZNhCoY[?1
ok2c]onVXISo/8AVoiib<on`Q6Ko/8AkojJ4Q?nVV8CoYZ6H0_nVQ8@01_n`
NfKoYXB4ojJ4Q?n`Q7_o/:Z4ojJQV0;ob[j]00Soi<O1okVHG?mPLW_o?G:4
oh>=Q?nVZZ?og>?PooK]jP;okMW<00Gog;j]onBnQ?o]ahCo^G8cog]<5002
oaXB500<o`T95?lJ4QCo2A8:oa4V5?lA70[o6Q8Dob<V2_ld;ako=5DYoeME
D_n3Nc?o/:Z40_nVV8@00on`/kOog>?Pong]jP03ongfm@04ooKoooo]kN[o
g>?FonC@c0?okNgZ00?og>?PooKomOo]kNX00_o]kNX03_oLhn3okNgZomcS
e_oLhmKom_oeog:=G?l0003o2A`Doa4L2_lJ2@[o2A8:oa4V5?m6@AkoJUDN
0_mP@BT05_nVQ5;obZYVomc7Xon`/kOoUJ6>onC7`On`/kOoYZ6Hol[@`OnV
ZZ?o`LO1ok2c]on=SFoo`K>]ol77`OmZSEco0000o`T92_lA70[o2@T:oa4L
2_l94PX7o`T92P0>ob`B0?lJ2@[o6PT:ob`B0?lJ2@[o8a`:oaX92_l/4P3o
6PT:ob<L2_lJ2@[o?A8:ob`B0?lm70X2ob`B0003ocdB2_lm70[o6PT:00;o
?A8:00[o6PT:ob`B0?lJ4QCo8a`:ob`B0?lJ4QCo?A8:ob`B0?lJ4QCo;180
0_lS70X01Ol/4P3o;1`Dob`L5?l/4P3o/;k105ook^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN4000;oi^KV00coi>CTomCDe?mkNg_of][Jon3Ph?oQhN7o
eMGEolS8b?o:b/[oc/k>om3@d?oCdm<7omKFeP0Hoo;on_ohoo_ooo[joook
oooQgnCo^/c>oh:g/Oma_k;oM=6oogSFa?n9flgoV^CGojO[h?n]m>KoZokZ
ojgojonconOo]OoTok?mh_nfonCo^ooWokgojOnnonWo_?oW1?nkonH3ok[o
iP0bok[oi?nkonCo^ooSokgohonkon?o_OoSok_ohonmon?o^ooSokgohonk
on?o_OoSok_ohonmon?o^ooSokgohonkon?o__oTokcoi?nnonCo_?oTokko
i?nlonCo__oTokcoi?nnonCo_?oTokkoi?nlonCo__oTokcoi?nnonCo_?oT
okgohonkon?o_OoSok_ohonmon?o^ooSokgohonkon?o_OoSok_ohonmon?o
^ooSokgohonkon?o_OoSok_oi?nlonD5okcoi`Co^ooW0onhonH2okOoi@0?
ok[niOo1o>[o___[ok?kionUnN;oUoOLoh_beomni/goM][2ogWA^omd_Jco
QK^^ok7Fcoo@i>;onOoo00;ooogo00?oookoonOWiooXj>P00_oXj>P2onWY
j@03on[Zj_mXJ6So<c<c00?ojn_[00?oalO7o`000?nYZJT00_o/k>`02_nY
ZJWo0000olc<c?o]kNgo_Kfmo`000?nCTi?o4A4AonSXj?o_knl5oo7al@?o
l_;b00KoeMGEo`000?n/[:col_;bodU9BOm/K6`2oo;blP03olg=cOl0003o
[Zj^00;olo?c00Ko[Zj^o`000?oAdM7om?Cdocdm?OmiNGT3ooCdm005ol?3
`ol0003oV9RHoa8B4_o^k^h00_oemOD2ooKfmP04ooShn?oalO7o4a<Cof5Q
H@;ono_k0_olo?`2oogmo@03omKFe_l0003o]KFe00;ooOgm00Ko]KFeo`00
0?oJf][ooOgmog]kNom1@D43ooknoP07ogalO?m2@T;ooooooooooooMgMgo
0000okRh^004ooooo`03omgMgOl0003o^;Rh02oooooo00Co3EJaojC4i_nh
d^koMZgZ0_n/gol01?mZJV[o[Zj^omSHf?oTi>AKonKViP;o2@T:00So2A8:
oaXB5?l94P[o4A`:oaX92_l92@[o4A`:oaX92P?o2@T:00Oo4A`:o`T92_lA
70[o0000oa4L2_l92@[o4A`:00?o2@T:00Wo4A`:o`T92_l92@[o2@T:oa4L
2_l94P[o2@T:o`TB2_lJ2@X00_lA70X2o`T92P04oa4L2_l92@[o2@T:o`T9
2P;o2A8:01Go0000o`TB2_l94P[o2@T:o`TB2_l0003o4A`:o`T92_lA70[o
AUDYofYbG?l94P[o0000o`TB2_lA70[o2A8:oaXB5?lS9P[o;3PYoc@_7_l/
>2T00_lS;ah01?lA70[o2A8:oa4L2_l94PX2o`T92P0>o`TB2_l92@[o2A8:
o`T92_l94P[o6Q8Do`T95?l94P[o2@TDo`TV:Om6GTOoJW]_oh>4S_n=V8h2
oiFZ[@0XohfHS_n3V8ko/;k1ol77c?n3Q7_oNheVocAE:Ol/>2Wo=2lYohfH
S_n`Q7_o^JY_ojJHQ?o1XHCoYYR4ol6QQ?oL/j?oYZZSombc[OnVZZ?o`J64
ojJZXoo1XHCo/8AkojJQV?nVV8CoYXB4ok24NonVQ8CoYYR4ol6QQ?oL/hCo
YYR4oh>H[OlmLXCoYXB4ol6c[Oo]fLcom_oeooo]c0;okMW<01Wo^Hdcof11
5?l971Co2@TDoa4L2_l92ACo6PT:oa4L2_l/9QCo;1`DoaXV5?ld;akoAT4N
oh=k<omPGS?oAT4NojJHQ?nVZZ?ob[j]ongfmOofooookOKeong]j_o]m_Go
m_oo00?og>?F00OokNgZomcSh?o]kN[og>?Pong]j_o]m_Gom_oe00;okNgZ
0_oLhmH03OoTd<coooooodIWG?lA70[o6PT:oa4L2_l92ACo;2HDof115?ld
;akoH44YofYE7_n`SE800_oLaj<03_n=SFoog;jgol[@e_o1/hko`K>]ohfH
S_nVXISo/;>gojJHQ?n`_/7o/:Z4ol[@`OmGSEco00000_lA70X00ol92@[o
2@TDo`TB2P03o`T92P0Ao`TB2_l92@[o2@T:o`T92_lA70[o6PT:o`T92_lJ
2@[o8a`:oaX92_lS70[o6PT:oaXB5?l/4P3o6PT:ob<L2_lJ2@X00_l/4P00
2_lm4P[o8a`:oaX92_l/4P3o8a`:oeLL0?m69QCo;180oaXB5?l/4P02oaX9
2P0<ob`B0?lS70[o6PT:ob<L2_lS9P[o;1`Dob`B0?lS9P[o?A8:ob`L5?l/
4P3o`LO<GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h01?o/
k>cog=cLog]kNooJf]X2on3Ph006omCDe?o8b<Sobl_;olk>c_o@d=3od];B
1ooEeMD06?o`ooSomoojoooknOoonooohN3VokK>d?mi^;3oJ<>dof_D`omc
f<SoRM_?oiWOeOnUi=coY^cQoj3gi?nOoN?o[?oXojkniOn^o>Co/?kVokGo
j?ngon[o^?oZokOoj@;o^_oZ0_nhonX4okOojQ3o^?oX4?nionT@okSoj0Ko
^Oo[1?nhon/3okKojP;o]OoY01?o]ooYokWfi_nhmnKo[?GRoikcg?n@l]Wo
Q>oCogSTb_m_f/3oL<niofbmZ_mm^jko[=[@olgXhooeoooooOgoooomoooo
o_ooj>SX00?ojNWY00Goj^[ZonWYjOoZj^[oJ6QXoc<c<`03on_[j`03ojn_
[ol0003oe=CD00;ok>c/00[odm?Co`000?nc/k?okNg]of5QHOll?3cokNg]
obDU9OnIVIWokno_1OoalO42oo;blP07on?Shom:BT[o1`L7onGUiOobl_;o
BDU9ofa/K002oo;blP0;okFe]Ol0003ofm_Koo?cloodm?Cof][Jo`000?nh
^;SomOGeocdm?OmjNWX00ooemOD01OmTI6Co?ShnooGemOlV9RKoWYjN00Co
m_Kf00Con?Sholk>c_l0003o_[jn1?ojn_X2oo_kn`03ok^k^ol0003oh^;R
00;ono_k00Koh>3Po`000?nm_Kgono_kogYjN_m1@D43oogmo@07og]kNom1
@D7ooooooooooonn_[ko0000ocdm?@03oclo?`04olC4a?nn_[ko0000ocdm
?@?o?clo00?oa<C4ooooooooool0:Oooool01?l?EZkoY/KVokK@k_mi[nh2
oj_No`04ofi^K_nd];Coh>3Ponc/k5_ok^k^0_lA70X01?l94P[o6PT:oaX9
2_lJ4Q@3oa4L2P05o`T95?lA70[o2@T:oa4L2_l92@X00_lJ2@X02?lA70[o
6PT:o`T92_l/4P3o4A`:o`T92_l/4P3o6PT:0_lA70X2o`T92P04o`000?lA
70[o6PT:oaX92P;o2@T:00?o4A`:o`T92_l92@X00ol92@X00ol94P[o2@T:
o`T92P04o`T92P0CoaX92_l92@[o4A`:ob<V2_mZIc?oARHDo`T92_lA70[o
6PT:oa4L2_lJ2@[o8bH:ob<_7_l/>2WoAUDYof11:OlJ9QCo4A`:oaX92P02
oa4L2P?o2A8:013o2@T:o`TB2_l94P[o2@TDo`000?lS;ako4BH:o`T95?l9
4P[o4A`:oa4V5?m?IdOoUIRSoiFZ[On`_/7oYZZS0_n=V8h01?n`_/7ob]3F
og^=Q?mZLU`2odI<?@0<odmWAomZLUcoYZ6Hol6QQ?nVXISoi:ZHol6cS_oL
_[Oog;>SonC7`OoL_Zgog;>]0_oL/j<2olZn[@03ojJZXooL/j?oYZ6H00;o
YXB40_nEQ7/03?niV5cokM2HolZZI_l0003o;5E_oeN=S_nEQ5;oPhAkol6c
S_ookLcog;=Lo`0000?o2A8:00Go4BHDob`L5?l/71Co6RHDob<L2P02oaXB
500AocAE:Om6@Ako8blNoa4V7_mZIc?oYYQ_ok2ZQ?o]kN[om_ooongfmOo]
kN[og>?PongfmOofooGog>?Pong]j_o]m_D00oo]kNX2ongfm@04ooKomOo]
kN[okNgZonC@c0;og>?F013om^gZoooooolA9P[o4A`:oa4V5?l92ACo6PT:
ofYE7_mZIc?o=2lNofYE7_nNNc?o^JY_ok2ZQ?nVZZ?oYYQ_0_o:d<402?n=
SFooi=3<oh=kG?o:_ZgoYZZSol6cS_o:d<7o/;>g0_l000001OlA70[o2A8:
o`T92_l94P[o6Q8D00;o2A8:00?o2@T:o`TB2_l92@X00_lA70X03Ol92@[o
6Q8DoaX92_lA70[o2A8:ob`B0?lJ2@[o;180oaX92_l/4P3o6PT:o`T95?l/
4P000_lS70X01?lm4P[o?A`:ocdL2_l/4P02oaX92P0@odHV2_lm4P[o;180
ob<L2_l/4P3o6Q8Dob<L2_l/4P3o;2HDob`B0?lS70[o;180ocdB2_l/71Co
;180odHV50;o?A8:00?o/;k1onk^k_o^k^h0GOo^k^h01?nSXj?o_Kfmolo?
cooJf]X1on7Qh@000_ooool01?omoOgok>c/ogalO?oJf]X2on3Ph006omCD
e?o8b<Soc<c<olk>c_o@d=3od];B1ooDe=@06?odooOon_oioooln_oon_go
g^?Wok;BdOm]]JWoH<>aofKC`?m]e/GoQMW<oiCLdOnMh=OoWNOJoiGag?nG
mMgoY_SRoj[ehOn[m>7o[?GRok;giOncn>Ko]?OVok?fi@;o]?CT0_nbmN@4
ok7fi13o/_GS4?ncm^@@ok;eh`Ko/oKU1?nbmnD3ojofi0?o[_GS017oZ_7O
ojObg_nPkmcoU^_FohgYe?n7i]3oNmk9og;F__m/bkGoI[^Vog6hZ?nYgM7o
b^_TonomoOoloOoooogoooono`04onSXj0;ojNWY00?oj^[ZofQXJ?lc<c<0
0ooZj^X00oo:b/[o0000ojFUY@02on_[j`0:ojBTY?l0003oclo?on?Shol=
3@goUYJFong]kOn5QHGo>SXjonk^kP?ol?3`0_oalO401Oobl_;o[:b/oaXJ
6_lE5AGo];Bd00;ol_;b00OoBDU9ofa/K?obl_;ol_;bom7AdOl0003oZj^[
00;om?Cd00KoZj^[o`000?oGemOom_Kfocdm?OmUIFD2ooKfmP06ong]kOl>
3PkoW9bLooKfm_n:RX[o?3`l1OogmoL00on][Jgo0000om_Kf`04ooShn0;o
nOWi00?oe]KFo`000?n_[jl00_oinOT01_n][Jgo0000om[Jf_oinOWoNGUi
od10@0?oo?cl01;oNg]kod51@Oooooooooooom_Kfol0003oZj^[olo?coo7
alOo0`<3onGUiOoKfm_o0000oj^[Zoo?clooalO7o`<30ooUiND[ooooo`04
o`aC[_nT`nGo^=;_ogV^k0;o[=oo00CoMWIfol71`Oo`l?3ooOgmFoooool0
1_lA70[o6PT:oaXB5?lA70[o;3PYo`T950;o2@T:00?o6PT:oaXB5?lA70X0
0_l92@X01?lA70[o2@T:o`T92_lJ2@X2oa4L2P0=o`T92_lJ2@[o4A`:oa4L
2_l92@[o0000oaX92_lA70[o0000oa4L2_l92@[o4A`:o`T92P02oa4L2P03
o`TB2_l92@[o2A8:00;o2@T:0_l94PX4o`T92P04o`TB2_l92@[o2@T:oa4L
2P;o2@T:00goAUDYob`B0?lJ2@[o4BH:oaX92_lA70[o6RHDoc@_:OlS9P[o
=2lcodIE:Om6C3go8a`:00?o4A`:00Oo6PT:oa4L2_l92@[o6Q8Do`TB2_l9
2@[o2A8:00;o2@TD00goJW9LoeMWD_l94P[o2A`Do`TB2_l0003o8d4moh>=
Q?n3Q8ko`LO1oiFZ[OnVXISoYZZ]00;ob]3F00?oPhAkofYkKonEXHh00_mk
SFH02Ol/>2WoLXf4ol6QQ?oL/j?oYZ6Hol6cS_oL_Zgog;>Sombn]`04olZn
[@0:omc7Xoo:_Zgog<NSojJQV?nVZZ?o`K>>ojJZXonVXISoYYQ_ob`h:@;o
000000Co2@T:o`000?l0003o2@T:0_l000002_ld;ako0000o`T95?l92@[o
6Q8Dob`L5?lJ4QCo;1`DoaXV5?l/71@2oa4L2P08ob`V5?lJ4QCo6RHDob<_
7_ld;akoH5hcojJQV?oTal42ongfm@03ong]j_oLhn3og>?P00;okNgZ0_o]
m_D01_o]kN[okOKeong]j_oLhmKom_oeongfm@?okNgZ00gog>?Fong]j_oL
hmKoooooojK7h?l0003o2A`Doa4V5?lA70[oJUDNodI17_mP;aCoPg/c00;o
^JY_00SoYZ6Hok2ZQ?oL_[OoYZ6HolZn[Oo1alcoUHeVol[@`@;o/;>g00So
`K>]oiFQS_oLaj?o4BH:o`000?lJ4QCo4A`:o`T950;o2A8:00Go0000o`T9
5?l94P[o2@T:o`TB2P04o`T92P0EoaX92_l/4P3o6Q8DoaX92_l/4P3o6PT:
ob`L5?l/4P3o6PT:ob`B0?lS70[o6PT:ob`L5?lJ2@[o;180odHV2_lm4P[o
8a`:ob`B0?lS70[o?A8:00;o8a`:013o6PT:ob<L2_lS70[o;180oaX92_lm
4P[o8a`:oaX92_lm70[o8a`:ocdL2_l/4P3o?A`:ob`V5?l/4P3ob]3FGooo
ool01?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h03?o/k>cog=cLog]k
NooIfMWogmoOon7QhOoDe=CoalO7olc<c?o>c/kod=3@omGEe@Ooe=CD01Ko
n_ogoogonOooo?goo_[kom_Vj?n]e];oG:fNoeBnZ?mJc[OoI=?0og_Faon<
fLooUMgBoiOSe_n@kMSoU?7Loi_/fonQjmcoXn_MojC/g_nXk=ooZNgP0_nZ
k>02oj[YgP?oZ>[N0_nWjmh00onWjmcoZ>[LojSZg00>ojSZg13oZN_M4?nX
j]`6ojW[g`;oZ>cO0_nWjmh2ojG/gP?oY>_M01?oX^cKoic]f_nIk]WoUN[E
ohoTdOn:hLkoQ]o=ogcIa_mcd[koJlZfoeffX_mQ[YkoXMgAol[_j?o[o_co
o_ooooomooooo_oojNWY00?oj^[Z00Gojn_[on[Zj_o[jn_oJFUYoc<c<`04
onc/k00>oc`l??m2@T;ocLg=olc<c?m1@D7o?Shnong]kOnGUiOo3@d=on?S
hoo]kNgogMgMo`P82?o8b<P5ono_k`04ogUiNOl0003oD51@omSHf0;ol?3`
00Soj^[ZodA4A?mVIVKoiNGUonc/k?oalO7o?CdmodA4A0;od];B00oo@d=3
od51@Oodm?ComOGeocdm?OlB4Q;oRh^;om_KfonKVi_o3@d=on_[jooemOGo
i>CTo`P82?o?cll00oofm_H01?ogmoOo`<30o`000?o<c<`4ooShn0?onOWi
00_o?cloodI6A_oHf=SoemOGodE5AOm2@T;onOWiooCdm?mcLg?o?Cdmoo7a
l@02ooOgm`0:ogEeMOln?Skom?Cdoo[jn_oooooo?cloof][JoogmoOoWYjN
ob/[:`;ooooo00Go?cloof][JoogmoOoWYjNob/[:`0/ooooo`04o`mF[_nU
a>Ko]];^ogV^j@;oZ^3o00CoKVi^okBd]?oPh>3ok>c/Foo^k^h2oa4L2P04
oaX92_lA70[o6PT:oaX92P;o4A`:00So2@T:oa4L2_l92@[o4A`:ob`B0?l9
4P[o2@T:oa4L2P;o2@T:00Co;180oaX92_lA70[o4A`:0_lJ2@X2oa4L2P06
o`T92_lA70[o2@T:oa4L2_l0003o4BH:0ol92@X01?l/4P3o2@T:o`TB2_lA
70X2o`T92P;o4A`:00Ko2@T:o`TB2_l92@[o2@T:oa4L2_l94PX2o`T92P;o
4A`:0_lS9PX02olA70[o6RHDob`V5?l/9QCo8blNodIE:OmPGS?oAT4Noa4L
2_lS70[o2A8:00;o4A`:00Co2@T:o`TB2_l92@[o;1`D0_l94PX04OlA70[o
2A8:og^=I_nEXHkoAT`mo`000?l971Co2A8:oa4V2_mGSEcoJW]_of1bNonV
ZZgo/;>goh>HS_nEZZgo/;>g00;oSIR>00SoYZ6HodmWAom?IdOoLXeLoeMW
D_o1/jgo`K>>ombcX`;o`K>]00Go/:Z4oh>=Q?m6EBWo;3PYoa4V2P03o`00
000Uob`h:OmbSEcoYZ6Hog9bNonVV6ooUJ6>o`000?l94P[o2@TDo`TL5?lJ
4QCo4BHNo`TB2_lJ4QCo2@TDo`TB2_l92@[o2@TDob`V5?lS70[o6RHDob<L
2_l/71Co;2HDob`L5?lJ9QCo8blNob`V5?lA9P[o6RHDob`V5?m6@Ako=2lY
of11:Oo:_Zgog>?FooKoo`02ong]jP03omcSe_oLhn3okNgZ00;okOKe00Ko
m_oeongfmOo]kN[og>?FongIc?ofool3ong]jP07ongfmOoLhmKokNgZong]
j_ofoooo;6MLo`000002oaXB5007ofYE7_n3Nc?oARHDoh=k<oo1XHCo`K>>
ojJHQ002ol6cSP0<ol77`Oo1/jgo/:Z4ok2c]onVV8Co`LO1ol6c[OnVXISo
b]31ol6cS_lJ9QCo00000_lA70X02?l92@[o6PT:o`TB2_l92@[o4A`:o`TB
2_l92@[o2A8:0ol92@X01ol94P[o4A`:o`T92_lJ2@[o4A`:oaX92_lS70X0
0_l/4P02oaXB5003ob<L2_lJ2@[o;18000;o;18000?o?A`:ocdB2_lS9PX0
0_lJ2@X01_lm4P[oEa`0ocdL2_l/4P3o6PT:oaXB50;o;18000Go8a`:ob<V
2_l/4P3o6PT:ocdB2P02ocdL2P05odHV5?lm70[o?A`:ob`B0?o:d=H0Goo^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H03?oTi>Coe=CDog]k
NooIfMWogmoOon7QhOoDe=Coa/K6olc<c?o>c/kod=3@omCDe0OoeMGE01Co
ooojookmn?ooo?gon_Skom[]jonZg=?oC:FCodBfWOm?bk7oFm6iog?Fa?n4
f<_oSM_>ohkOd?n;j=?oS^_Foi?Ve_nGiMOoV^KIoicXf`;oWnOK00?oX>KK
oj7Wg?nTj=d00_nTj=d3oj;Xg@;oXNWM00?oX^SMoj;YfonRjM/0;OnRjM/6
oj?YgP;oX^[N0_nQjMd06?nPj]goWnWLoioYg?nOjMcoW^SKoiWZfon?jmKo
SN[EohcUdOn8glkoQm_;ohGIb_mie<?oL<fjofG6/_mB[i[oDJBBoicNd?o=
m^kojoomooonoooooOooookoonSXj0?ojNWY0_oZj^X00oo[jn_oJFUYoc<c
<`04onc/k009omKFe_m;Bd_o3@d=o`d=3Om=CDgoemOGong]kOmCDe?oJFUY
00?okNg]00?oI6ATogalO?o_knl00oo_knl00ooGemOo0@41ohZ:RP04oo3`
l008ogMgMol71`Oo2`/;oaTI6OnSXj?olO7aom_Kfom=CDd2o`h>3P0:oe1@
D?oNg]kom?CdooGemOm@D53oPh>3oeUIFOl820SoDE5Aofa/K0?omOGe00?o
J6QXoh20P?ofm_H00_ofm_H01?ohn?Soi^KVo`410OnIVIT4ooWin@?on_[j
01Oohn?Soe1@D?l>3Pko3Ph>oe9BD_oTi>Con_[johb<S?l<30co1PH6oaXJ
6_nDU9CoSHf=o``<3?l61PKo6a/KoiJFU_ooooooi^KVodM7Aol=3@go71`L
okNg]`02ooooo`05onKVi_m7AdOo3@d=oa`L7?ng]kL0;?ooool01?l=EJko
Y/KVokWCk_mi[^/2oj_Oo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV0olA70X0
4?l92ACo4A`:o`T92_lA70[o6PT:o`TB2_lJ2@[o4A`:oaX92_l92@[o=2lN
o`TB2_l/4P3o4A`:ob`B0?lA70X2oaX92P06o`TB2_lJ2@[o2@T:ob`B0?l9
2@[o2A8:0_l92@X00ol94P[o2@T:oaX92P04o`T92P05oa4L2_l92@[o2@T:
o`T92_l94PX01?l92@X00olA70[o2@T:o`T92P02oa4L2P;o2A8:00?o4A`:
oa4V2_lJ2@X00_lS9PX01_lA9P[o8blNoaXB5?mPGS?oAUDYob`V50?o4A`:
00Go8a`:oa4L2_lA70[o2@T:oa4L2P02o`T92P08o`TB2_l92@[o6RHDog^=
I_mZNfooUJ6>odIE:Ol94PX2o`00000HodIWG?mPGS?o4BH:og9bNonEV:?o
JW9Lok2c]onVZZ?ob]3Fog9bNomZNfooSIR>og^=Q?mZNfooAUi7ojJZXoo1
/hkoAUDYojJQI_lS;bWo8blNodIE:Old;c?o=5DY0_l92A@03_l94P[o2@T:
ob<_7_mGSEcoCg9kog:=Q?n3V:goEheLo`000?lJ4QCo2@TDoaXB5?l92@[o
2A8:0_l92A@01OlJ4QCo2@TDob<_7_l92ACo8a`:00;o6PT:0olA70X00olS
;ako;2HDob`V5002oaXB5007ob`L5?lJ9QCo8blNob<V2_n3Necog>?Fongf
m@02ong]jP04omcSh?o]kN[okNgZong]jP;okOKe00?om_ooong]j_oLhmH0
0_oLhmH00oofooookNgZong]jP04ong]jP0QongfmOofooooCfMLo`000?lA
9QkoARHDofYW<omZEAkoYXABokVHG?o1/hkoSHe_ok24I_o:d<7o`K>]ojJH
KooCfMKoYYR4ok2ZQ?oLhn3o/:Z4ol[@e_o1/jgoPg/co`000?l92@[o2A8:
oaX92_l92ACo2@T:oa4L2_l92@[o4A`:00;o2@T:01ko6Q8Do`TB2_l92@[o
2@T:o`TB2_l92@[o2A8:oa4L2_lJ2@[o2A8:ob<L2_lJ2@[o8a`:oaX92_l/
4P3o?A8:oaX92_l/4P3o6PT:ocdB2_lJ2@[o;180odHV2_l/4P3o;1`Dob`B
0?lS70[o?A8:ob`L5?lS70X2ob`B000;ob`L5?lm4P[o;1`Dob`B0?l/71Co
;180ob<V2_l/4P3o8a`:ocdL2_l/9Q@00_lm4PX00oo1al7oi^KVonKViP1M
onKViP04oifMWOng]kOob<S8om?Cd`7of][J0002onk^kP0<onc/k?oLg=co
O7alom[Jf_oOgmoohN7QomCDe?o6a/Koc<c<olk>c_o@d=3odm?C1ooEeMD0
5Ooooo[ooOchoooloOoinO_oh?Cbok7Sf_m5WXco>ZnEodK7Zom?d;CoImBo
ogSFa_n1eLKoQMO9ohGNc?n6hLooSN7Aoi3Re?nCiMOoU^KIoiOUf002oiST
f0KoVnCI0_nIiMT3oiWUf00coi_Uf?nIiMSoVnGHoiWUf?nKiMSoVNGHoi_U
f?nIiMSoVnGHoiWUf?nKiMSoVNGHoi_Uf?nIiMSoVnGHoiWUf?nKiMSoVNGH
oi_Uf?nIiMSoVnGHoiWUf?nKiMSoVNGHoi_Uf?nIiMSoVnGHoiWUf?nKiMSo
VNGHoi_Uf?nIiMSoVnGHoiWUf?nKiMSoVNGHoi_Uf?nIiMSoVnGHoiWUf?nK
iMSoVNGHoi_Uf?nIiMSoVnGHoiWUf?nLiM[oV^KJoicUf_nJi][oW>GJ00;o
V^KJ01_oVNOJoiWUfOnHi]WoV>KIoiGUf?nGiMSoUNGHoiKTeonBi]KoR>?A
ohKUdOn4glgoPM[8ogoFa_mkdl?oL<fkofC5/_mK_Z[oBZVEodZMRonRi=Ko
e_oiongoooooo_oooocoooonoooXj>P00ooYjNT2on[ZjP03on_[jomYJFWo
<c<c00Kok>c/0_o[jn/2onc/k0KokNg]0_o^k^h4ono_k`03ol[:b_l10@7o
fMWI00Gol?3`00CoB4Q8of][Joo`l?3ol?3`0ooalO42oo;blP?omOGe1?of
m_H00ooclo?om_KfooKfmP03ooKfmP?omoOg0_ohn?P2ooWin@04of1PH?lT
92Coj>SXoo[jnP;ono_k1Oolo?`2oo_kn`Coo?cl00OoOGemod10@?omoOgo
oOgmookno_moOgoo@D5100Gooooo00?oo?clooooooooool01?ooool00ool
o?coooooooooo`0/ooooo`04oa5G[onS`^Co^=?_ogN^j`;oZ]oo00CoKVi^
okBd]?oPh>3ok>c/Foo^k^h02_lJ4QCo2A8:oaXB5?lA9QCo6PT:oa4L2_lJ
4QCo2A8:oaX92_lA70X3o`T92P09o`TB2_lJ2@[o2@T:oaX92_l92@[o6PT:
oa4L2_l/4P3o6PT:00;o4A`:00Go6PT:o`T92_lA70[o2A8:o`000006o`T9
2P06o`TB2_l92@[o6Q8Doa4L2_l92@[o4A`:0ol92@X01?lJ2@[o2@T:o`T9
2_l/4P03o`T92P03oaX92_l92@[o4A`:00;o4A`:00So=2lNoaXB5?lJ9QCo
6Q`NodINAomPGS?o;2HDo`TB2P?o4A`:00Ko6PT:oa4L2_l92@[o2A8:o`T9
2_l94PX2o`T92P0aob<_7_mkSHCoH79kok2c]onEXHkoAUDYo`000?l971Co
4BH:odIWG?ld;bWoCg9koiFZ[OnVZZgo/;k1ojJc`Oo:d=KoYZZSoiFQS_mb
LW_oUJ6>ohfHS_mZLUcoJW]_omcSe_l0003oUIQVob<_7_m?Ieco?Ehmob<_
7_mZLUco6RHDo`T95?lA70[o0000odI<?OmZNhCoLXf4oh>HS_lA9P[o0000
o`T95?lA70[o2A8:o`T92_lA70[o2@TDoa4V7P02o`TB2P09oaXB5?l92ACo
2A8:o`T95?lA70[o8a`:oa4V5?lJ4QCo4A`:00;o6Q8D00?o2A`Dob`L5?lS
;ah00_lJ9Q@01_lJ4QCo8blNojJHQ?o]kN[okOKeomcSh0?okNgZ0_o]m_D0
1Oo]kN[oooooong]j_oLhn3oi=3<00;okNgZ00Gom_ooongfmOo]kN[okOKe
ooK]jP02ongfm@;om_oo01WoPiR>oa4V2_mb>1CoJVLcof1N<on3GQCodkj>
ok2ZQ?niV5cob]31omcSh?nVV6oog>?Pol77`OnVV6oog>?PojJZXooTd<co
`K>]omc7XombSEco0000o`T95?l92@[o4A`:00;o2@T:00Co4A`:o`T92_l9
2@[o2A8:0_l92@X00ol94P[o2@T:o`T92P02o`T92P0@oa4L2_l92@[o6PT:
oaX92_l/4P3o6PT:ob`B0?lJ2@[o;180oaX92_l/4P3o?A8:oaXB5?lS70[o
;180ob`L50;o?A8:01Oo;180oaX92_lJ2@[o?A8:odHV2_l/4P3o6PT:oaXB
5?lJ2@[o;180oaX92_l/4P3o?A8:ocdL2_lS70[o?A`:ocdB2_lm70[o;1`D
ocdL2_m69P[o?A`:ol77c01Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
0002ooooo`0<oogmoOo/k>coO7alomWIfOoPh>3ohN7QomGEeOo8b<Sobl_;
olk>c_o@d=3odm?C1ooDe=@06?onoo_onocgooomoOoknOcokO_kol3[i?m7
W8Wo>J^AocRmW_lobJSoELnfofKC__mcd;koO=31oh;EaOn5fLWoQ=_:ohOP
c_n:hm7oSNCCohkRd_n>hM7oSn;Boi3QdP?oSn3A1_n>hM40=?n>hLooSn3?
ohkQcon?h<ooS^7?ohoPcon>hLooSn3?ohkQcon?h<ooS^7?ohoPcon>hLoo
Sn3?ohkQcon>glkoSN3>ohkOc_n=h<koS]o>ohgPc_n>glkoSN3>ohkOc_n=
h<koS]o>ohgPc_n>glkoSN3>ohkOc_n=h<koSn3?ohkQcon?h<ooS^7?ohoP
con>hLooSn3?ohkQcon?h<ooS^7?ohoPcon>hLooSn3?ohkQcon?h<ooS^7?
oi3Qd_n?h];oT>7BohoRd_n@hM82ohoRdP0JohkRd_n=h=3oS>3@ohcPd?n:
hM3oRmo?ohWPcon;glooRN3?ohKJb_n4fl_oP=S8ogWD`omcdL7oK<nmoeo6
/omD_ZSoBK2Kod>RS_m<WHco/NgQon;oooo_oOkooogooookoooooOl4onSX
j005ofa/K?mLG5coG5aLobTY:OlD51@00omLG5`00ooKfm_ojn_[on_[j`07
on_[j`?ok>c/0_o]kNd3onk^kP;okno_00GoADE5ocHf=_n5QHGoFe]Koe9B
DP02ono_k`04om7AdOo@d=3ol?3`oo3`l0?olO7a00?olo?coo;bl_odm?@0
0_odm?@2ooGem@Som_Kf1OogmoL2ooShn008onCTi?lo?coo7AdMogQhN?nC
Ti?oLG5aobl_;onj^[X9oo[jnP07okJf]_lN7Qkoo?clooclo?omoOgo^;Rh
oahN7P0kooooo`04oa5G[onUa>Ko^M?_ogN^j`;oZMco00CoMWIfol71`Oo`
l?3ooOgmFoooool04olA70[o6PT:oaX92_lJ4QCo2@TDoaXB5?l92@[o6PT:
oa4L2_l92@[o4A`:oaX92_l92@[o6PT:o`T92_lJ2@[o2@T:oaX92_lA70X0
0ol92@X2oaX92P04oa4L2_l92@[o6PT:o`TB2P?o2@T:00Co8a`:oa4L2_l9
2@[o4A`:0_l92@X00olA70[o2@T:o`T92P04o`T92P04o`TB2_l92@[o2A8:
o`T92P;o4A`:0ol92@X02olJ4QCo4A`:oa4L2_lS9P[o6Q8Doa4V5?l/71Co
H5hcodIE:Ol/>2Wo8a`:00Co4A`:0_l92@X3o`TB2P03oa4L2_l92ACo4A`:
00;oJW]_02[oPiR>ojJQV?nEZZgoSHe_o`000?l971Co;4`YodIWG?mZNfoo
UJZ]ok2n`OnEV:?o/;>gol77c?nEZZgo/;>gojJZXomkSFKo;3PYoeMWD_l9
4P[o2A`Do`T92_nEQ5;o?BlmoeMWD_mPGS?o8blNohf=D_ldEBWo0000o`TB
2_lJ4QCoAVMLodmbNomZNhCoAUi7o`TB2_l971Co4A`:o`T95?l971@2o`T9
5006o`TB2_l92ACo6Q8Do`T95?lA70[o2A8:0_l92A@00olJ4QCo2@TDoa4L
2P02oaXB500<o`T92_lJ2@[o4A`:oaXV5?l/71Co6RHDob`L5?lJ71ko8a`:
ombcXoo]kN[okOKe0_o]kNX00ooLhn3om_oeongfm@02ongfm@09ooKomOoL
hn3og;jgomcSe_o]kN[og>?PooKomOofooookNgZ00?okOKe01Kom_oeongf
mOofoooo/;>gob<V2_n3Nc?oH5hcoiEE5?oC_XkoYYQ_okVHG?o:d<7odkj>
ol[@`Oo:_Zgoi<O1ong]j_o:d<7okNgZolZn[OoCfMKoNheV0_l000001OlJ
2@[o2@TDoa4L2_l92ACo2A8:00;o2@T:00?o4A`:o`T95?l92@X01?l92@X0
0ol94P[o2@T:o`T92P02o`T92P?o6PT:00Ko;180oaXB5?l/4P3o;1`DoaX9
2_l/71@2oaX92P07ob`B0?lS9P[o8a`:ocdB2_m69P[o?A8:oa4L2P02oaX9
2P;o?A8:0_l/4P001ol/71Co;180ob<L2_l/71Co?A8:odHV2_lJ2@X00_lm
70X01_l/71Co?A`:odHV5?lm70[o?A8:ol[@`Eoooooo00Co[jn_ol_;booN
g]koj^[Z0Oobl_8000;ok^k^00cok>c/omcLg?mlO7cofMWIon3Ph?oQhN7o
eMGEolO7aoo:b/[oc/k>om3@d?oCdm<7omCDe00HooWonoogo?Sooogoooki
oOohoooocO3Zoe2HR_lnZ97o;K:Coc?0W_m6bjkoF=2gofS>^OmfcKgoPlo2
ohWEb?n1eLGoPM[6ohKMb_n8glcoRMk;ohSKbOn:fl[oRmc;0_n?gLd2ohgN
c@CoS=o=00?oSMk=ohgNbon=g//03On=g//@ohcMbQ3oSMk;1_n>glh2ohgP
cP;oRmk<0on9g//2ohSMbP0CohWLc?n7d<GoR=76ogkB`omcd;koI]2loeg=
]om?`jcoAkVRoc^USom1W8[oEIfAol3cj_o[ooool?[loooloooonoooooko
onSXj003onWYj@03oiRHV?n<S8coSHf=00GoSHf=00?ohN7Qonc/k?o/k>`0
1?o/k>`6ong]k@;ok^k^1Oo_knl01Oo/k>coZj^[ofMWIon0P83o/k>c00Ko
l?3`0ooalO400ooclo?om?CdooKfmP02ooKfmP[omoOg1Oohn?P2ooWin@;o
n?Sh00Ko[Jf]ogalO?mVIVKoQHF5ojVYZOo[jn/9oo[jnP0:ooGemOm3@d?o
8R8Roa/K6ooEeMGon?ShodA4A?lS8b?o71`LomOGecSooooo00Co3EJaojC4
i_nidnooMZgZ0_n[h?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP0=oaX92_lA
70[o2@T:oaXB5?lA70[o6Q8Doa4L2_l92@[o4A`:o`TB2_lJ2@[o4A`:o`T9
2P02oa4L2P0<o`T92_lJ2@[o2A8:oaX92_lA70[o6PT:oa4L2_l92@[o6PT:
o`TB2_l/4P3o4A`:0_l92@X01?l94P[o2@T:o`TB2_l94PX2o`T92P04oaX9
2_l94P[o2A8:oa4L2P;o2@T:00co4A`:o`TB2_lA70[o2@T:oa4L2_l92@[o
4A`:oaX92_l92@[o4A`:o`T92_lA70X2o`T92P;o4A`:00_o2@TDob<_7_ld
;bWoEfMBoceN?OlS;bWo6RHDoa4L2_lJ4QCo4BHDoa4L2P03o`TB2P;o2@T:
02go2A8:o`T92_l94P[o=2lcog^=Q?nVZZ?o/;>gojJZ[Oo1al7o4BH:o`TB
2_lA9P[oCfM7odmNI_n3V;OoPiR>oiFZ[Oo:d=KoJW]_ol[@e_o1alcoNheV
o`000?l92@[oLXeLo`000?l92@[o4BHDog^=I_ld;c?oLVMBodmWAolJ4QCo
UJ6>of1N<ol92@[o2A8:o`000?mGIe;oEheLodmbNolmGSgo4BH:o`T95?l9
4PX01?l92A@01?l92@[o2@TDo`T92_lJ4Q@2o`T95008oaXB5?l92ACo4A`:
oaXB5?l94P[o4A`:o`T95?lJ9Q@2oa4V5008oaXB5?lJ9QCo4BH:oaXV5?lS
;ako;2HDol[@`Oofm_D2ongfm@03ong]j_oLhn3okNgZ00;okOKe00Cooooo
ong]j_o:d<7og>?F1?o]kNX01?o]m_GokNgZong]j_o]kNX3ongfm@05oooo
ooo:d=Ko4BH:ofYE7_n3GQ@00_oC_Xh02oo:_ZgokMW<ongfmOo1/hkog>?F
ohf=Kon=SDOoAUi7ohf=D_lmGSgoAT4N00;o000000Wo2@TDo`TB2_lA70[o
4A`:o`T92_lA70[o2@T:oa4L2_l92@X00_l94PX02?l92@[o2A8:o`T92_l9
4P[o2@T:o`TB2_l92@[o2A8:0_l92@X01OlA70[o2@T:oaXB5?lm70[o;180
00;o6PT:0ol/4P002_lS70[o6PT:ocdB2_lm4P[o;180ob`L5?l/4P3o6PT:
ob<L2_l/4P02odHV5004ocdB2_l/71Co8a`:oaX92P;o;18000GoARH:ocdB
2_lJ2@[o8a`:ocdL2P02ob`L5004odHV2_m69QCo?A`:ok2c]eook^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV00coi>CTomCDe?mkNg_of][J
omoOgooQhN7oeMGEolK6a_o:b/[oc/k>om3@d?oCdm<7omCDe00HooCooOoe
oo[ooognooolooooo_oog?3_ohO0]olcT7_o9jB6obBaS_lc_YgoDM:doeg7
/Omme<CoX>?JoiCFc?nFhm?oSn3=oi;Qc_nGi]?oVnSFoi[TdonKi=?oWnSG
1?nLiM@2oi_Ue003oiWVe?nIi];oVnKB02ooVnKB1?nLiM@4oi_Ue00JoicY
eonKj=KoVnSFoi[WeOnIj=GoUnKCoi?RconDg<koXM[DojGPg?mlbKooMmS7
ofGI`_m4`jSo@L:VobJPQolZU7ko@IF5ogbh/?oSoooojOSkooOhoOoonooo
ooWoooonoooXj>P3onWYj@;ojn_[0oo]kNd:onk^kPOokno_1_o`l?0;oo7a
l@?ol_;b0_odm?@3ooKfmP[omoOg3Oohn?P;ooWin@;on_[j00?oi^KVon_[
joolo?`00_ono_h00ooYjNWok^k^ooooo`0hooooo`04o`eE[_nUa>Ko]M3^
ogV^k0;oYmco00CoJVYZojj^[_oHf=Soi>CTFooVi^H2o`T92P;o4A`:00Go
2A8:ob<L2_l92@[o4A`:ob`B0002o`T92P04o`TB2_lA70[o6PT:o`T92P;o
4A`:00go6PT:o`T92_lJ2@[o4A`:o`000?lA70[o;180o`T92_lJ2@[o2@T:
oa4L2_l94P[o2@T:00;o2A8:00?o2@T:oa4L2_lA70X00ol92@X00olA70[o
2@T:oa4L2P03o`T92P04o`TB2_l92@[o4A`:o`T92P;o4A`:00go2A8:oa4L
2_l92@[o4A`:o`TB2_lA70[o6Q8Doa4L2_lS70[o;3PYofYbG?mGIe;oAT4N
00;o4BHD00go4A`:o`TB2_l94P[o2A8:o`T92_l94P[o2@T:oa4L2_l94P[o
0000og^=Q?mGIe;o4BHD00;o/;>g02[oUJZ]ol77c?nVZZ?o0000o`TB2_lS
;bWoAUi7odmbNon=V8kodmWFoiFZ[OnV/l7o`LO1ol[@`OmZSEco0000oaXV
5?mbSEco0000o`TB2_lJ71koJW]_odmWAombSEcoCfM7oaXL7_nVV6ooAUi7
o`000?l94P[o4A`:odmWG?l/IecoAUDYo`000?l92ACo6Q8Do`TB2_l92ACo
2A8:o`T92_lA70X3o`TB2P06oaXB5?lA9QCo2@T:o`TB2_lJ2@[o4BHD0_lJ
4Q@00olA70[o6PT:o`TL5002oaX92P0>oa4L2_lJ9QCo6Q8Dob`L5?lJ9QCo
H44YojJZ[Oofm_GokNgZongfmOo]kN[okOKeooKoooo]m_D2ong]jP;og>?F
00[oi=3<ong]j_o]kN[og>?Pong]j_ofooGokNgZooK]j_o]m_Gom_oo0_o]
m_D02Ooooooog>?PodH_2_o:ZVKog;j]omcSe_ookLcoNheVoiF=DP07o`00
00;o2@T:00?o2@TDoaXB5?lJ2@X00_l94PX00ol92ACo4A`:o`T92P02o`T9
2P03oa4L2_l92@[o2@T:00Oo2@T:00_o2A8:o`T92_lA70[o2@T:o`T95?l/
4P3o?A8:ob`B0?lJ2@[o;180ocdB2P03oaX92P03ob`L5?lJ2@[o?A`:00;o
;18000Co8a`:ocdB2_lS70[o?A`:0_mG70001_m69P[o;180ob`B0?lS70[o
6PT:ob<L2P;o?A`:00?o6PT:ocdB2_lm4PX00_lm70X01?m69P[oEa`0ocdB
2_o:d=IOonKViP04oifMWOng]kOob<S8om?Cd`7of][J0002onk^kP0<onc/
k?oLg=coMgMgom[Jf_oPh>3ohN7QomCDe?o7alOoc<c<olo?coo@d=3odm?C
1ooFe]H06?oaoogomOokooonoooonOoooO?kooGooon[e/oo=85aoaj>MOlU
Z8So<kfLocjoXOmmjM;oRmo@ohc;`onbjnCoZ>cMoj;[f?nSj]SoZ^oMojc_
g_nZkMco[N_Lok3^g`Co[N_L0_n/k=`00onZkMcoZ^gKojc/f`0_ojc/f`Co
[N_L1?n/k=`06On[k]goZ^gLoj[]g?nZkMcoZ^oMojW^g?nVjmWoZ>KIojC@
coneinKoX>WPohSYf?mIdKSo;K:EobbaU?lYY8So<IB0ocZ4MonWe<ooj_oo
oo_oooooo?ooooSmooohnoooo_l01?oWinL00ooXj>SojNWYon[ZjP05on[Z
jPOojn_[0oo/k>`3ong]k@03ono_koo^k^kol?3`00;ol?3`0_oalO4;oo;b
lPColo?c1?odm?@:ooGem@?om_Kf0_ogmoL2ooWin@04ooShn?ojn_[on_[j
oo[jnP;ono_k3Oolo?`2oogmo@03ookno_oooooooooo03_ooooo00Co3EJa
ojC4i_nhd^koMZgZ0_n/gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP0=oa4L
2_lJ4QCo6PT:o`TB2_lJ2@[o4A`:oaX92_l92@[o6PT:oa4L2_lJ2@[o2@T:
oa4L2P02oaX92P03o`TB2_l92@[o4A`:00;o4A`:00Co6PT:oa4L2_lJ2@[o
6PT:0_lA70X02olJ2@[o2@T:o`T92_lA70[o2@T:oa4L2_l94P[o6PT:oa4L
2_l92@[o4A`:00Co2@T:00go4A`:o`T92_l92@[o2@T:oa4L2_l92@[o4A`:
oaX92_lA70[o6Q8Do`T92_lA70[o6PT:00Co4A`:00[o2A8:ob<_7_mZNfoo
Pg]LoceN?OlS;bWo4BH:oaXV5?l/71Co6PT:0ol94PX2o`T92P0/oaXB5?l0
003oUJZ]oiF4Nol0003o2A`DojJc`OnVZZgo/;k1om?Ie_l0003o4BH:oa4L
2_lS;bWo8d4moiFZ[On`_/7oYZZ]ol[@e_n`_/7odn?eodIE:Ol0003o;3PY
oeN=G?l92@[o0000odI17_n3NecoEei_ofYkKoldEBWo?EhmojJHQ?mbSCgo
0000oa4L2_l92ACo8blYoba<:OlA;c?o0000o`TB2_l92A@4o`T92P0:o`TB
2_l92@[o2@T:o`T92_l92ACo4A`:o`T95?lA70[o6Q`NoaXB50;o4A`:01;o
2A8:oaXB5?lA70[o4BHDoaX92_l971Co6PT:oa4L2_lA9QCo=2lYofYW<onV
XISokOKeong]j_o]m_Gog>?Pong]j_o]m_D4ong]jP;og>?F00WokNgZooKo
mOo]kN[og>?PooKoooo]kN[om_oeongfmOofool00_o]m_D01oofoooog>?P
om>nS_oL_Zgob]31og:=?Ol/9Q@00_l000000ol/4P3o2@TDoaXB5002oa4L
2P0;oaXB5?l92@[o2A8:oaXB5?l92ACo4A`:oaXB5?l94P[o6PT:o`TB2_l9
2@X00_lA70X2o`T92P04oa4L2_l94P[o2@T:o`TB2P;o2@T:00Go4A`:o`T9
2_l94P[o2@T:oa4L2P02o`T92P07oaXB5?l/4P3o6PT:ob`L5?lm70[o6PT:
ob`L5002ob`B000;oaX92_l/4P3o;1`DocdB2_lS70[o6Q8Dob`B0?lS70[o
?A8:oeLL0?m69PX00_mP;`X2ocdL2P0>ob<L2_l/4P3o?A8:ocdB2_m69P[o
4A`:odHV5?m69P[o;1`DodHV2_m69QCoARH:ocdL2_oCfMIOonk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q0002ooooo`04oogmoOo/k>coMWIfomWIf@;o
gmoO00Koe=CDolO7aoo:b/[oc/k>om3@d?oCdm<7omOGe`0Hoo3oooo_o_Wo
ookoooojoookk_Ooookoomoln_mb[:3o:XMbo`QjH?lVXXKo?KFJofS?_?nS
mn[oY>;MojoVh?n_jMgoZnSHojoYf_nck=go]N_Mok?Yfondi][o]^SL1?ne
im/2okCXf`;o/nWK00?o]>SKokCYfOndjMT0;OndjMT2okGWf`Ko]>SK0_na
imT04on_j=Wo/N[Kok?/gOnbjmco/>WJok7UfOo5k>_o[=[Hoi;IdOn<kMco
L^[Aoco1YOlKW7ko5HE]obb0LOm^Yj3oh?gkooCnooomnol00_oooOl00ooo
o?goookoonKViP03onKViP;oj>SX1_oZj^X:on_[j`?ok>c/0_o]kNd3onk^
kP[okno_0oo`l?03oo7al@03oo;bl_oalO7ol_;b00;ol_;b0_oclo<8ooCd
m0?omOGe0_ofm_H3ooShn0?on_[j0_okno/=ooclo0;ooOgm00?oo_knoooo
ooooool0>oooool01?l?EZkoY/KVokK@k_mi[nh2oj_No`04ogIfM_o1`L7o
l?3`oogmoE_ooooo02Go2@T:oaX92_l94P[o6PT:oa4L2_l92@[o6PT:oa4L
2_l92@[o4A`:oaX92_lA70[o6PT:oa4L2_l92@[o6PT:ob`B0?lJ4QCo2A8:
oaX92_lA70[o2@T:ob`B0?l94P[o6PT:oa4L2_l/4P3o2@T:oa4L2_l92@[o
4A`:o`000?l/4P3o2@T:oaX92_lA70[o2A8:00;o4A`:00co2@T:oaX92_lA
70[o2@T:oaX92_lA70[o6PT:oa4L2_lJ2@[o4A`:o`T92_lJ2@X3oa4L2P0?
oaX92_lA70[o2@T:o`T92_lA70[o8blNoh>=Q?mkSFKoAUDYob<_7_lJ71ko
6RHDo`TL5?lA9QCo2@T:00?o2A8:0_lA70X05?l0003oUJZ]og^=I_l0003o
2A8:odIWG?nEZZgo/;>gomcSh?mZLUco0000o`TL5?lJ9QCo4BHNoh>H[Oo:
d=Ko/;k1ol77`On`/kOokOKe0_lA9PX04_mPGS?oAVMLoa4L2_l94P[oLVMB
ofYkKombSEcoPg]Loa4V2_mGIe;oYZZSocAE:Ol0003o4A`:o`TL5?lA70[o
6Q8Do`T950;o2A8:0_l92@X01?l94P[o2@T:o`T92_l92@X3o`TB2P0HoaXB
5?l92ACo2A8:o`T95?m6@Ako6RHDoa4L2_lJ4QCo6PT:oa4L2_lJ2@[o2A8:
oa4L2_lA9QCo2@TDob`L5?lA70[o=2lNof1N<oo1/jgokNgZongfmOofoooo
g>?F1oo]kNX01OoTd<com_oeong]j_oLhmKokMW<00;okNgZ0oofool01Oof
ooGokOKeooKfmOo]m_GoARl:00;o;18000[o6PT:ob`B0?l92@[o8a`:oaX9
2_l94P[o4A`:oaX92_l94P[o6Q8D0_lA70X00ol92@[o6PT:oa4L2P02o`T9
2P04oaX92_lA70[o6Q8Do`T950;o2@T:00?o4A`:o`T92_l92@X01?l92@X0
1_lA70[o2@T:o`TB2_l92@[o2A8:o`T92P;o4A`:00?o6PT:ob`L5?lJ2@X0
0_l/4P003_lm4P[o6Q8Dob`B0?lJ2@[o?A`:ob`B0?lm70[o;180ocdB2_lm
70[o?A8:og8V0?m69QCo?A8:0_mG70002Om69P[o?A8:ob<V2_lm4P[o?A`:
ob<L2_lm70[o;180ocdL2P02odHV2P05ob`L5?m69P[oARH:ocdL2_nV/l40
Goooool01?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h03?o/k>cogMgM
og9bL_oGemOogmoOon3Ph?oBd];oalO7ol[:b_o<c<cod=3@om?Cd`Ooe=CD
01Sol_oooo3ln?oooooooocooooco?oooOoom?ooolcekomGWY3o981[oaf4
KolkYHooGK^[oi3Re_n=d<WoZ>?MojgWfon_im[o/NWLokCZgOnejMgo]>KK
okKUfongi]`5okSWg@;o]^SM0onfj=`0;?nhj=co]^SLokSXg?nfj=co^>SL
okKXg?nhj=co]^SLokSXg?nfj=co^>SLokKXg?nhj=co]^SLokSXg?nfj=co
^>SLokKXg?nhj=co]^SLokSXg?nfj=co^>SLokKXg?nhj=co]^SLokSXg?nf
j=co^>SLokKXg?nhj=co]^SLokSXg?nfj=co^>SLokKXg?nhj=co]^SLokSX
g?nfj=co^>SLokKXg?nhj=co]^SL0_nhj=`3okSWg@Go]^SM01[o]>KKok?W
foncim_o]>[MokK/gonejmko/nWLok;Ug?nXeM;o/>CPojSaj?mkfLWoB[bU
oc2XSOlIRG7o5gIRof>UVoo9l^kom?ooooonooodk_;oo_SjooonoOoooogo
ooooonOWi`?oj>SX0_oYjNT3on[ZjP?ojn_[1oo/k>`6ong]k@03onk^k_o_
knool?3`00Col?3`2ooalO43oo;blP;olo?c0oodm?@:ooGem@Gom_Kf0_og
moL00oofm_KomoOgooOgm`03ooOgm`_on?Sh0_oinOT3oo_kn`;ooOgm4Oon
o_hZooooo`04o`aC[_nT`nGo^=;_ogV^k0;o[=oo00CoKVi^okBd]?oPh>3o
k>c/Foo^k^h03?lA70[o4BHDoaX92_l94P[o4A`:oaX92_l971ko2@T:ob`B
0?l94P[o2@T:oa4L2P?o2@T:00Go6PT:oa4L2_l0003o;180oa4L2P02o`T9
2P03oa4L2_l92@[o;18000?o6PT:00Go;180ob<L2_lA70[o6PT:o`T92P02
oa4L2P08o`T92_l/4P3o2@T:o`T92_lJ2@[o4A`:o`T92_lA70X2o`T92P04
oa4L2_l92@[o4A`:o`T92P?o4A`:01Wo6PT:oa4L2_lA9P[o4A`:o`T92_lA
70[o2@T:ob<_7_nEV:?oPg]LofYbG?lS;c?o;4`YoaXV5?lJ4QCo4A`:o`TB
2_l92@[o2A8:o`T92_l94P[o2@TDo`000?nEZZgoSHe_00;o000000oo4A`:
oceN?OnEZZgob]3Fol77c?mZSEco0000oa4V2_l0003oPiR]ol[@e_nEZZgo
Y[?1ol77`OoLhn000_l000003?mZSEcoAT`mob<_7_lJ9QCoUIQVodI<?On3
NecoJW9Loa4V2_n3Q7_o`K>>oa4V2P;o2A8:00Co6Q8Do`T95?l94P[o2@TD
2?l94PX00ol92@[o2@TDo`TB2P02o`T9500:o`T92_ld;akoAUDYob<_7_lJ
2@[o4BH:oa4L2_l/9QCo4A`:oaX92P;o6Q8D00Ko4A`:oa4V2_lJ4QCo8blY
ofYW<oo:d<43ong]jP03onC@c?o]m_Gom_oe00CokNgZ00?og>?Fong]j_o]
kNX00_oLhn000oo]kN[om^gZooKom@04ooKoo`;okOKe00Woooooob`B0?m6
9QCo;2HDocdL2_l/71Co4A`:oaX92_l92@X00_lJ2@X00ol94P[o6Q8Doa4L
2P02o`T92P05oaX92_lA70[o2@TDoa4L2_l92A@00_l92@X00olS;ako0000
oaXB5002o`T92P03o`TB2_l92@[o2A8:00?o2@T:00Go2A8:o`T92_l92@[o
2@T:o`TB2P02o`T92P0:oaX92_l92@[o;180ob`B0?l/71Co;180ocdL2_l/
4P3o;1`DoaX92P;o;18000KoARH:ob<L2_lm4P[oH2l:oeLL0?mP;a@2oeLL
0006of0_2_m69P[o?A`:odHV2_lJ2@[o8a`:0_lm70X00omG703o4A`:odHV
2P05odHV2P03oeLL0?o:d=Kok^k^05kok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN4000;oi^KV00Coi>CTomOGeomaLG7oclo?0_oMgMd01_oAdM7oa<C4
olS8b?o;bl_oclo?om;BdPOoe=CD01GonOoooo_ooooooooooogoooolooog
mO[ol_[monkooooGoogoBHMlobigK?lkSGooJ[jaog32]_nWl^_oT]S@oi_M
dOnRh=?oYN?FojOSeonXh]H00_nYhMH01?n[h=Ko[>7GojcQeon/hML2oj[R
e`?oZN?G02koZ^;Goj[ReOn/h]GoZ^;EojcReOnZh]Go[>;Eoj[ReOn/h]Go
Z^;EojcReOnZh]Go[>;Eoj[ReOn/h]GoZ^;EojcReOnZh]Go[>;Eoj[ReOn/
h]GoZ^;EojcReOnZh]Go[>;Eoj[ReOn/h]GoZ^;EojcReOnZh]Go[>;Eoj[R
eOn/h]GoZ^;EojcReOnZh]Go[>;Eoj[ReOn/h]GoZ^;EojcReOnZh]Go[>;E
oj[ReOn/h]GoZ^;E0_n/h]D3ojcQe`CoZ^;G01CoZN?GojSRe_nXh]KoZ>;F
ojOSeonXi=SoYn?GojCPe?nQgmCoWM[Boi?FcOn?gm;oNMC3odf`W?lWR7Go
9WY[odN;P?oCoOWol?oooo?fn`;ooogo00CooockoocnnOokoo[oo_om1?oV
i^H00ooXj>SoinOWonWYj@05onWYj@[oj^[Z0oo[jn/00oo/k>cokNg]onk^
kP02onk^kP[okno_0oo`l?03oo7al@;ol_;b0ooclo<2ooCdm0SomOGe1Oof
m_H2ooShn003ooOgmooinOWonOWi00?onOWi2oojn_X2oo_kn`?oo?cl0_om
oOdAooknoR[ooooo00Co3eJ^ojG4i_nfd^koNJkY0_nZh?l01?mZJV[o[Zj^
omSHf?oTi>AKonKViP0Goa4L2_lJ2@[o4BHDoaXB5?lJ2@[o4A`:oaX92_lA
70[o6PT:o`T92_lA70[o6PT:oa4L2_lJ2@[o4A`:oaX92_lA70[o2@T:oaX9
2_l92@[o;180o`TB2_l/4P000_lJ2@X00olA9P[o6PT:oa4L2P02o`T92P0E
oa4L2_lJ2@[o4A`:ob`B0?l92@[o;180o`T92_lA70[o6PT:oa4L2_lS70[o
4A`:oaX92_l92@[o4A`:oaX92_lA70[o2@T:oa4L2_lA9P[o6PT:00;o4A`:
02Ko8a`:oaX92_lA70[o4A`:o`TB2_l/4P3o8blNog^=I_n=V8koLW9kodIE
:OlS;bWo2A8:oa4V5?l971Co6Q8Do`TB2_l92@[o4A`:oaX92_lJ4QCo0000
og:=Q?nVZZ?o2A8:o`TL5?lA9QCo0000og:=Q?n`_/7o`LO<ol77`Ol0003o
4BH:o`000?lmLXCo/;>gojJZX`;o`LO<01;o`LO1o`000?l92@[oSHe_oa4V
5?lA9P[oH5hcoiF4NolmGSgoSHe_ofYW<olS;akoJW9Lof1N<ol0003o2@T:
o`TB2_lA70X2o`TB2P05oa4L2_l94P[o2A8:o`TB2_l92@X00ol94PX04?l9
2@[o4A`:o`T95?lA70[o6Q8Do`000?ld;akoPg]Lohf=Aom6@Ako2A`Dob<L
2_lJ9QCo8blNoaXV5?lA9Q@2oa4L2P0=oaXB5?l/9QCo4A`:oaXL7_n3Neco
b]31omcSh?o]m_Gog>?FomcSh?o]kN[om_oeomcSh006ong]jP05ooK]j_oL
hn3og>?FooKomOo]m_D01?ofool01?o]m_Gom_oooooooom6;`X2odHV5004
ob<V2_m69QCo8a`:ob<L2PCo4A`:00?o6PT:o`T92_lA70X00_l92@X02?lA
70[o2@T:o`T92_lA70[o2@T:oa4L2_l/71Co4A`:0_l92@X01?lA70[o2@T:
o`TB2_l92@X2o`TB2P0;oaXB5?l92@[o2A8:oa4L2_l92@[o4A`:o`TB2_lJ
2@[o6Q8Dob`B0?lS70X01Ol/4P000olS70[o6Q8Dob<L2P02ocdL2P;o?A8:
01;oARH:oeLL0?mb9P3o?A8:oeLL0?mP;`[oEa`0ocdB2_m69P[o6Q8Dob`B
0?m69QCoARH:ocdB2_lA70[oARH:ocdL2_m69Q@3odHV2P03ocdB2_o:d=Ko
i^KV05koi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;ok^k^00[okNg]
on3Ph?mjNW[o_knoomSHf?oJf][oc<c<ol71`Oo5aLGob/[:0_o>c/h7omCD
e00Hoo_io?ooo_ooo_koooOgnOooo_ooo_oooo?fnoogooool?ooon;ooom@
PGgo=W=/ocEnMOmP/:GoE:NMohWMd?n0c/7oR]C7oi3JcOnAfLgoTMO<oiGI
c_nFf/ooUmW?0onDe/`2oi?Gc0?oTMO<0_nCelX0<OnDe/[oTmO:oiCFb_nC
el[oU=K:oi?Gb_nDe/[oTmO:oiCFb_nCel[oU=K:oi?Gb_nDe/[oTmO:oiCF
b_nCel[oU=K:oi?Gb_nDe/[oTmO:oiCFb_nCel[oU=K:oi?Gb_nDe/[oTmO:
oiCFb_nCel[oU=K:oi?Gb_nDe/[oTmO:oiCFb_nCel[oU=K:oi?Gb_nDe/[o
TmO:oiCFb_nCel[oU=K:oi?Gb_nDe/[oTmO:oiCFb_nCel[oU=K<oi?Gc?nD
e/`01?nCel`01?nAelcoTmW>oi;HcOnBf<d2oi7Ic@0Doi3Hc?n=eLWoQm?6
ogk>`Om^`[?oHKRXoe2WUolSMfSo5V1CofJRV_oAnoOol?ooooKkoooooOoo
no;gooomoooooo_olo[booWonoonood4onGUi@;oinOW1_oYjNT:on[ZjPCo
jn_[1?o/k>`:ong]k@Kok^k^00?ol?3`ono_kooalO401?oalO48oo;blP?o
lo?c0_odm?@2ooGem@04ooKfm_ogmoOomoOgooOgm`;on?Sh2ooinOT2oo[j
nP?ono_k0_olo?`@oogmo@?oo_kn:?ooool01?l=EJkoY/KVokWCk_mi[^/2
oj_Oo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00So6Q8Doa4L2_lJ2@[o2@T:
oa4L2_lJ4QCo4A`:o`T92P;o6PT:00ko2@T:oa4L2_l92@[o4A`:o`T92_lA
70[o6PT:oa4L2_l92@[o4A`:oaX92_l92@[o6PT:oa4L2P;o6PT:00So2@T:
ob`B0?lA70[o;180o`T92_lA70[o6PT:oa4L2P;o2@T:0_lJ2@X02?l94P[o
6PT:o`T92_l92@[o4A`:o`T92_lA70[o2@T:0olA70X00olJ2@[o4A`:oa4L
2P03oa4L2P0>ob<_7_lJ4QCo2@T:o`TB2_lA9QCoJW]_oh>=Q?n3Q8koAUDY
oba<:OlS;ako6RHDoa4V5?l92@X3o`TB2P;o4A`:02;o2A8:og^=I_nVZZgo
;3PYo`000?lA9P[o2A8:oceN?On3V8ko/;k1ol[@e_l0003o2A`Doa4L2_l9
71koUJZ]ojJZ[Oo:d=KoSIR>oa4V2_l92ACo4BHNoiFHI_l971Co2A8:odI1
7_n3Q8koEfMBocAE:Ol0003o2@T:o`000?l92ACo2@T:0_l94PX01?lA70[o
2A8:o`TB2_l94PX3o`T92P;o2A8:00Go2@TDo`TB2_l92@[o2A8:o`T95002
o`T92P0Goc@_:OnELTOoSHe_og^=I_n3Nc?o2A8:oaXV5?l/C2Wo;2HDoaXV
5?lJ4QCo4A`:oa4V5?lJ2@[o4BHDo`T95?mZEAkoYZ6Hol[@`OoLhn3okNgZ
omcSe_o]kNX00_o]m_D02?oLhmKokNgZong]j_o]kN[og>?FonC@c?o]kN[o
kOKe0oo]kNX00oofm_Gom_ooooKom@02ong]jP;om_oo00Cooooooh=kG?mG
703oH2lD0_lm70X06_lS70[o6PT:ob`B0?lA70[o6PT:o`T92_lA70[o6Q8D
o`T92_lA70[o2@T:oa4L2_l92@[o4A`:o`T92_lA70[o2@TDoaXL7_lJ4QCo
4A`:o`TB2_l92@[o4A`:o`TB2_l92@[o2A8:0_l92@X00ol94P[o2@T:o`TB
2P03o`T92P09o`TB2_l/4P3o6Q8Dob`B0?lS70[o;180ob<L2_l/4P3o?A8:
00?o;1800olm4PX00om69P[oARHDof0_5002of0_2P0CodHV5?mb9P3oH2l:
ob<V2_lS70[o6Q8Dob`B0?m69P[oARHDodHV2_lJ2@[oARH:ocdL2_m69QCo
ARH:of0_2_m69P[oEa`0omcSh01Oonk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q0002ooooo`0<ookno_ofm_KoVYZJojBTY?oBd];oe=CDol;2`_nh^;So
`<30olC4a?o9bLWobl_;1oo@d=006?oomOcooocoooknoooho_kon?ooooWo
ooolooooo_ooooOjooogooooj_ooofJ@Som>S8Oo8g=Xoc6=P?lmWi3oDJnO
oe^gZ?mR_ZooHkj_ofFm[omZ`;?oK<:eofk2]@?oJknb0_mY_k82ofS0/P0d
ofVo/_mY`;3oJL2`of^o/?mY`;3oJkn`ofW0/?m[_k3oJL2`of^o/?mY`;3o
Jkn`ofW0/?m[_k3oJL2`of^o/?mY`;3oJkn`ofW0/?m[_k3oJL2`of^o/?mY
`;3oJkn`ofW0/?m[_k3oJL2`of^o/?mY`;3oJkn`ofW0/?m[_k3oJL2`of^o
/?mY`;3oJkn`ofW0/?m[_k3oJL2`of^o/?mY`;3oJkn`ofW0/?m[_k3oJL2`
of^o/?mY`;3oJkn`ofW0/?m[_k;oJKnbof^o/PCoJKnb00CoJ<2bof[2]?mY
`K?oJ<2b0_mW`[<04OmV`K;oHkj_oejl[?m@]Z7oBk6KobF2KolIK5co=WY_
og^`Z_oGnO[ol_ooooCgo_ojlo_ooo_oooS_l_ojnOOoo?ok00;on?oj00?o
o?omon7QhOoRh^800_oRh^800ooTi>Cohn?SonGUi@02onGUi@[oi^KV1ooW
inL6onSXj0_ojNWY0ooZj^X00oo/k>cojn_[ong]k@02ong]k@[ok^k^1oo_
knl6oo3`l0SolO7a0oobl_82oo?cl`?omOGe0_ogmoL3ooShn0[onOWi0ooj
n_X3ooclo0;oo_kn9_ooool01?lAEjooXl;TokSCkomg[^/2oj[Oo`04ogIf
M_o1`L7ol?3`oogmoE_ooooo00Wo6Q8DoaX92_lA70[o4A`:oaX92_lA70[o
2@T:oa4L2_lJ2@X00_lA70X01OlJ2@[o;180ob<L2_l92@[o6PT:00;o2@T:
00Co;180oa4L2_l92@[o2@T:0_lJ2@X01Ol/4P3o8a`:oa4L2_lJ2@[o2@T:
00;o6PT:00oo4A`:o`T92_lJ2@[o2@T:ob`B0?lA70[o2@T:oaX92_l/4P3o
2@T:ob`B0?l92@[o4A`:o`T92_lA70X00_l92@X05olJ2@[o4A`:oa4L2_lJ
9QCo4A`:ob`V5?lJ9QCo;2HDo`TB2_lA70[o2@T:o`TB2_n=SFooNhf4oh>=
Q?mZLUcoEeEBob<_:OlS;ako2A8:oa4L2_l92@[o4A`:00;o2@T:0_lA70X0
7om?GVKoUJZ]oiFQS_l971Co0000oa4V7_lA9P[o0000oiFZ[Oo1/jgo0000
o`TB2_l92ACo0000oh>H[Oo1al7oAUi7o`000?l92@[o4BHDob<_7_n=SFoo
0000o`TB2_l/9QCoCfM7oiF4Nol0003o2A8:ob`L5?l92@X00ol94PX00olJ
4QCo6RHDoa4V5007o`TB2P0Ho`T92_l92ACo4A`:o`T92_lA9QCo6RHDohf=
Aon=SE;oNheVofYbG?nEQ7_oPg]LocAE:Om6@Ako=2lYob<_7_l/9QCo6RHD
oa4L2_lJ4QCo4BHDoa4L2_l92@[oSHeB0_o1/jd2ong]jP03omcSh?o]kN[o
kNgZ00CokNgZ00?og>?Pong]j_oTd<`00_o]kNX04?oLhmKokNgZooKomOof
oooom_oeong]j_ofkN[okNgZongfmOofoooooooooiF4Nom6;`[oH2l:odHV
2_lm70X2ob<L2P?o6PT:00Go4A`:oaX92_lJ4QCo6PT:oa4L2P02o`T92P05
oa4L2_l92@[o4A`:o`T92_lA70X00_lJ4Q@01OlA9QCo6Q8Doa4L2_lJ4QCo
2@T:00;o2A8:0_lA70X01ol92@[o4A`:o`T92_l92@[o4A`:o`TB2_lA70X0
0_lJ2@X00olS70[o?A`:ocdL2P02ocdB2P08ocdL2_lm4P[o8a`:ob`L5?lm
4P[oARH:ob<L2_lm4PX2oeLL0009odHV2_mP;aCoEa`0og8V0?mP;aCo?A`:
ob<L2_l/4P3o;1`D00;o?A`:00KoARH:oa4L2_m69P[oH2l:odHV5?lm70X2
odHV5003oeLL0?oCfMKooooo05kooooo00Co[jn_ol_;booNg]koj^[Z0Oob
l_8000?ok^k^00GojNWYolG5aOn3Ph?o[:b/okbl_002ojj^[P04okJf]_nl
_;co_knoolC4a0OobLW901SoooSooooeo?oooooonOoooo;ooooaoOgoo?oo
ooomooonn?oono[oooGooooYooooeOooojknlollW8ko8Xeko`ieI?lHOfko
8HIfob:7MolUQGOo:XYlobn=Ool^S7h2oc2<O`;o;heo1?l]SGl`obn=O@Ko
;heo1?l]SGl05ol[SGko;8ioobf?P?l/SWoo9halob:<N?l9NF7o6XQ_od6R
S_n/oNkoeOooomKnoOo_oooonooooookoooon_oon^gfoooloooooogom_ge
ooOon_ofooWoo?om00CogMgM0_oOgml6on7Qh@[oh^;R0ooShn<2onCTi0?o
iNGU2_oVi^H6onOWi`;oj>SX1OoYjNT;on[ZjP;ojn_[0_o/k>`01?o]kNgo
k^k^onk^k_o^k^h:ono_k`Gol?3`0ooalO45oo;blPSolo?c0_odm?@3ooGe
m@?om_Kf0_ogmoL3ooShn0[onOWi0oojn_X2ooclo0?oo_kn4Oooool01?lA
EjooYLCVokWCkomg[^/2ojWLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Go
4BHDoa4L2_l94P[o6PT:o`TB2P02oa4L2P03oaX92_lA70[o2@T:00;o6PT:
00?o2@T:oaX92_l92@X00olA70X2oaX92P;o4A`:00?o2@T:oaX92_lJ2@X0
0_lJ2@X02Ol/4P3o4A`:oa4L2_lA70[o;180oa4L2_lJ2@[o4A`:o`000002
oaX92P07oa4L2_lJ2@[o2@T:oaX92_lA70[o2A8:o`T92P05oa4L2P03oa4V
5?l/71Co6RHD00?o8blN01ko6Q8Doa4L2_lA9QCo0000odmNI_mkSFKoLW9k
oh>=Q?n3Neco=5DYob<_7_lA9P[o2@TDoaXB5?l92@[o6Q8Doa4L2_l92ACo
6PT:odINAomkSHCoUJ6>ok2ZQ?l94P[o0000o`TL5?l0003oNhf4oiFQS_l0
0002o`TB2P0Goa4L2_l/EEco4BHNo`000?l92@[o2@TDo`000?mbIe;oPhAk
oeMED_lA70[o=2lNodHV2_o1al7oLRH0o`T92_o1al7oEa`0o`T95?lJ4QCo
2A8:o`T92_l92A@01?l94PX00ol92ACo2A8:o`TB2P02o`TB2P0Aoa4L2_l9
4P[o2A8:ob`L5?lS;bWoAUDYof1N<on3Q7_oLXeLohf=D_mPGS?oCfM7oiEb
AombSCgo=2lNof1N<old;bT00_lJ9Q@01olA9QCo6Q8Doa4V5?mZIc?oYZZS
ol77`OoLhmH00_oLhn05ong]jP03omcSe_o]kN[oi=3<00;okNgZ01;og>?P
ong]j_o]kN[om_oeoooooooLhn3om_oeomcSe_o]kN[om_oeooKooooooooo
LVMBog8V0?mb>1CoEa`0odHV2_lm70X2ob<L2P;o6Q8D00ko4A`:oaX92_l9
2ACo2@TDoa4L2_l92@[o8a`:o`T92_lA70[o2@TDo`T92_lA70[o2@TDoa4L
2P;o2@T:00?o6Q8Dob`V5?l92A@01ol92@X00olA70[o2@T:o`T92P02oaX9
2P05ob`B0?lS70[o;180ob`L5?l/4P000_lm70X2ocdB2P04ob`B0?lm4P[o
ARH:ocdB2P;oARH:00koEa`0odHV5?mG703oEa`0of0_5?mG703oARH:ocdL
2_lA70[oARH:oeLL0?lA70[oARH:oa4L2P?oARH:00GoEa`0of0_5?mP;aCo
Ea`0ol[@eP1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0003onKViP0;
onCTi?oLg=coYZJVog=cLon0P83oShn?oibLW?nUYJGo[:b/ok6a/Ong]kL0
3_nk^k/3okbl_0?o_Kfm00?o_[jnokfm_Onn_[h00_nn_[h2okno_`_o`<30
0_o1`L42ol;2`P04ol?3`oo4a<Coa<C4olC4a0[oaLG51Oo6a/H2olO7a`03
olK6a_o7alOoalO700?oalO73Oo8b<P00oo9bLWob/[:ol[:bP0?ol_;b`?o
c<c<00?ocLg=olc<c?o<c<`00_o=cLd;olk>cP;oclo?0oo@d=000ooAdM7o
d];Bom?Cd`02om?Cd`?oe=CD1ooEeMD6omKFeP;oemOG1OoHf=P;omWIf@?o
f][J0_oKfm/3omcLg0[ogMgM1OoNg]h2omoOg`03omkNg_oOgmoogmoO00?o
gmoO2?oPh>03on7Qh@;oh^;R0_oTi>@00ooUiNGoinOWonOWi`03onSXj0[o
jNWY0ooZj^X3onc/k0;ok^k^2oo_knl2oo3`l0?olO7a00?ol_;boo7alOob
l_800_obl_83oo?cl`kom?Cd00Co35F`ojC4i_nidnooMZgZ0_n[h?l01?mZ
JV[o[Zj^omSHf?oTi>AKonKViP04oaX92_l92ACo6PT:oa4L2P;o6PT:0_l9
2@X2oa4L2P06o`T92_lJ2@[o6Q`Noa4L2_l92@[o;1800_lJ2@X02_l92@[o
4A`:oaX92_l92@[o4A`:oaX92_lA70[o6PT:o`000?lA70X4oaX92P06oaXB
5?l0003o8a`:o`T92_lJ2@[o2@T:0_lJ2@X01?l/4P3o6PT:oaX92_l92@X3
oa4L2P07oaX92_lS70[o8a`:oa4V2_lS;ako8a`:oaXV5003ob<_7P0<oaXB
5?lA9QCo2@T:oc@_:Om?IecoSIR>oh>HS_n3Q8koEheLoc@_:OlS;ako2@TD
0_lA70X01Ol92ACo2A8:o`T92_lA9QCo8blY00;oJW]_00OoUIRSog^=I_lA
9QCo2@TDocAE?OlA9QkoCfML00?o2@T:027o=5DYo`TL7_lA;c?o4A`:oaXB
5?l92ACo0000odIE:Om?Ieco`LO<o`000?lS9P[o;180ol77c?o1XHCo?A8:
oiFHXoookLco0000oa4V2_lA70[o2A8:oa4L2_l92@[o2@TDoaXB5?l92@[o
6Q8Do`T92_l92ACo2A8:oaXB5?l92A@00_lA70X07?l/4P3o8blYoa4L2_mP
GS?oNheVoh=k<omGEE;oH5hcohf=D_n=V8koYYR4ohf=AomZIc?oAUDYoc@_
:OlA9Qko2A`DoaXL7_l92ACoAT4NojJQV?o1/jgog>?PongfmOoLhmKokNgZ
omcSh?oLhmH4ong]jP03omcSh?oTd<cokNgZ00?okNgZ00?om_ooooKomOo]
kNX00oo]kNX3ooKoo`;oPcP0013oPbl0og8h5?mG703o?A`:odHV2_lS70[o
6PT:ob<L2_l92@[o6PT:oa4L2_lJ4QCo2@T:oa4L2_l92ACo6Q8D1_l92@X0
0olA70[o2@T:o`T92P02o`T92P03o`TB2_l92@[o2@T:00Go2@T:00Wo2A8:
oa4L2_l92@[o4A`:oaX92_lm4P[o8a`:ob`B0?lS70X00olm4PX01_lm70[o
;180odHV2_lm70[o?A8:odHV2PCoEa`000OoARH:oh<_0?mP;`[o?A`:ob`L
5?l/4P3o;1`D00;o?A`:00?oARHDoaXB5?m69Q@00om69PX01?m69QCoH2lD
og8V0?o:d=IOonKViP04oifMWOng]kOob<S8om?Cd`7of][J0004onk^kP0:
on_[jooPh>3o^;Rhoh61POm`L73oN7Qhoh^;RonBTY;oVIVIoj6QX@koYZJV
1_nWYjL00onXZ:SoZJVYojZZZP04ojZZZPSoZj^[0on/[:`2ojf][@;o[Zj^
00Co[Jf]ojj^[_n^[Zko[Zj^0_n_[jl=ok2`/0;o/K6a00?o/[:bok>c/onc
/k<02onc/k<2okBd]0?o]KFe00?o][JfokFe]One]KD00_nf][H3okNg]`[o
^;Rh0oni^KT00onj^[[o^k^kok^k^`02okbl_0_o_Kfm1Onn_[h00oo0`<3o
_knool71`@05ol71`@[o`/;21?o3`l<4olC4a0[oaLG51_o6a/H00oo7alOo
a/K6olO7a`04olO7a`Sob<S80oo9bLT2ol[:bP?oc<c<0oo>c/h2olo?c`_o
d=3@0_oAdM43om;BdP;odm?C2ooDe=@5omGEe@?oemOG1OoIfMT8om[JfP;o
fm_K0ooLg=`2omgMg@?og]kN0ooOgml>on3Ph004o`aD[OnUa>Ko]M3^ogV^
k0;oYmco00CoKVi^okBd]?oPh>3ok>c/Foo^k^h00olJ4QCo4A`:oa4L2P02
oaX92P07oa4L2_lJ2@[o4A`:o`T92_lJ2@[o4A`:oaX92P02oa4L2P05oaX9
2_l92@[o6PT:oa4L2_lJ2@X00_lA70X01ol/4P3o6PT:oaX92_l/4P3o6PT:
oa4L2_l/4P000_lJ2@X02olA70[o2A8:ob`B0?l92@[o4A`:oaX92_lA70[o
;180oaX92_l92@[o;18000;o6PT:0ol92@X3oa4L2P06oa4V2_lS;ako8blN
ob<_7_lJ9QCo4BH:0_lS;ah06olJ9QCo4BH:ob`L5?lS;akoAVMLoh>4S_n=
V8koPhf4ofYkKom?IdOo=5DYoa4V2_l94P[o2@T:oa4L2_l92ACo4BHDob<_
7_m6C3goAUEBodmWG?mkSFKoCfMLob`h:OldECgo4BHDo`000002ob<_7P04
o`T92_lA9QCo6RHDo`T92P;o2BHY013o2A8:oa4L2_lJ71koAT`moeMED_o:
d=KoYW9Bo`000?lm70[o/7]VonC@c?n`NbWoARHDongIc?mkC1Co00000_l9
4PX02ol92@[o4A`:o`TV:Ol971Co2@T:oa4L2_l92ACo2@T:oaXB5?l971Co
2@TD00;o2A8:00Ko6Q8Doa4L2_l92ACoAUDYoc@_:OmZIc<2oh=kG0;oYYR4
00co/:Z4ohf=KombSCgoH5hcofYE7_mPGS?oAT4Noa4V2_lA70[o6Q8Doh>4
Noo:d<42ong]jP?og>?P1?oLhmH01?oLhn3og>?Fong]j_oLhmH2ong]jP03
ongfmOofooookNgZ00CokNgZ00Som_ooooooooo1alcoPd40oh<_0?nEE@3o
Pbl0of0_2P;oARH:00_o;180ob<L2_lJ2@[o4BHDoa4L2_lJ2@[o6Q8Doa4L
2_l92@[o4A`:o`T92P02oa4L2P;o2@T:00Go4A`:o`T92_lA70[o0000oa4L
2P02o`T92P?o2A8:00Co2@T:o`TB2_l92@[o2A8:0_l92@X01Ol94P[o2@T:
ob<L2_lJ4QCo;18000;o?A`:00Oo;180ocdB2_m69P[oARH:ob<V2_lm4P[o
8a`:00;o?A`:0_m69PX02_lm4P[oH2lDoeLL0?m69P[oH2l:oh<_0?m69P[o
?A`:ob<L2_m69PX2ocdL2P04oeLL0?lS70[o?A`:oeLL00;oARH:0_mP;a@0
0omG703odmWFonk^kP1Nonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0004
ooooo`08oogmoOoinOWojNWYom7AdOna/K7oV9RHohN7QomoOgooogYjNPgo
NWYj00WoLg=cog1`L?mZJV[oHF5Qoe=CDol9DZooY<CVokSBk_mf[NX00_n/
gol01?mfMWKo`L71oo3`l?omoOeKooooo`08oa4L2_lJ4QCo6PT:o`TB2_lA
70[o6PT:oa4L2_lJ2@X2oa4L2P03oaX92_lA70[o2@T:00;o6PT:00?o4A`:
oaX92_lS70X00olJ2@X04_l92@[o4A`:oaX92_lS70[o6PT:ob`B0?lJ2@[o
;180oa4L2_lJ2@[o;180oaX92_l/4P3o2@T:ob`B0?l92@[o6PT:o`T92P?o
8a`:00Ko6Q8Do`T92_l92@[o4A`:o`TB2_lA70X2ob<_7P0Job<_:Ol/>2Wo
;3PYoa4V5?lA70[o6RHDoa4V5?lS;ako;3PYocAE:OlJ9QCo;3PYofYkKon=
V8koNhf4og9bNomkSHCoAUEBoaXV5?l0003o4BHDo`T92_lA70[o6RHDoaXB
5?m6Ie`2odINA`06odIWG?lA9Qko8blYoa4V5?l0003o2@T:0_lA9Q@00olJ
4QCo4BHDoa4L2P02o`T92P0iob=1D_lJ71ko4A`:ok2ZQ?l/4P3oH44YomcS
h?oTal7o0000odH_2_nVLU;og;jgombn[OmG703o`J64omcSe_lm70[o4BH:
o`T95?lA70[o0000obaN?Ol0003o4A`:o`T92_l94P[o4A`:oa4V5?ld;ako
=2lYo`TB2_l92@[o2@TDo`TL5?lA9QCo6RHDoaXB5?ldEBWoUJ6>og:=?Omb
Ie;oJVLcog9WD_m?IdOoPg]Loij4I_nVZZ?oYYQ_ohf=D_lA9P[o2@TDoa4V
7_mP@BWog>?PonC@c?o]kN[og>?P00Oog>?F00?oi=3<omcSe_o]kNX00_o]
kNX03?ofooookOKeongfmOofooGom_ooongfmOofooooooooongfmOnELTOo
YT`0oiEE00;oPcP000OoLRH0of0_2_lm4P[o;1`Dob`B0?lS70[o6PT:00;o
4A`:00Oo2@T:oaX92_lA70[o6PT:oa4L2_l92@[o2@TD00;o4A`:00Co2@T:
o`TB2_l92@[o4A`:1_l92@X02olA70[o2@T:oa4L2_l92@[o=2lYo`T95?l9
4P[o4A`:o`T92_lS70[o;18000;o?A8:00Go?A`:ocdB2_lm4P[oEa`0odHV
2P02ocdB2P0:odH_2_lm70[o?A`:ob`L5?mP;`[oEa`0of0_2_mG703oPbl0
of0_2P;oARH:00ko?A8:ocdL2_m69P[o?A`:odHV2_lS70[oARHDof0_2_m6
9QCoARH:og8h5?mZ@@[oH2l:ol[@`Eoooooo00Co[jn_ol_;booNg]koj^[Z
0Oobl_8000Cok^k^00[ojn_[on3Ph?nh^;SoPH61ofe]KOmdM7CoPX:2ohN7
Qon=SHgoUIFE3_nJVYX6oi^KV`;oW9bL1OnMWId;oijNWP;oWinO0_nPX:00
1?nOWiooX:2Poj2PX?nPX:0=oj6QX@;oXZ:R0_nSXj<00onTY:CoYJFUojFU
Y@03ojJVYPSoYjNW1OnXZ:P00onYZJWoZ:RXojRXZ005ojVYZ@[oZZZZ0on[
Zj/00on/[:co[Jf]ojf][@02ojf][@_o[Zj^1On_[jl2ok2`/0Ko/K6a2_nb
/[83ok>c/`03okFe]Ond];Co][Jf00;o][Jf2_ng]kL=okRh^0So^KVi1Onj
^[X3okbl_0?o_[jn0_no_kl;ol30`0;o`L710oo2`/82ol?3``_oa<C41Oo5
aLD00oo6a/KoalO7olO7a`05olW9b@Sob/[:0_o;bl/3olc<c003olg=cOo<
c<cocLg=00;ocLg=0oo>c/h>olo?c`04o`iE[OnVa^Ko]]3^ogV_kP;oZmko
00CoKVi^okBd]?oPh>3ok>c/Foo^k^h00olJ2@[o4A`:oa4L2P02oaXB5003
oaX92_l94P[o4A`:00;o6PT:00_o2A8:oaX92_l/4P3o4A`:o`T92_lJ2@[o
4A`:oaX92_l92@[o4A`:oaX92P02oa4L2P0:ob`B0?lJ2@[o6PT:oaX92_lS
70[o;180oaX92_lA70[o6PT:oa4L2P?o6PT:00?o4A`:oaX92_lA70X00olJ
2@X00ol/4P3o2A8:o`T92P03o`T92P06ob<V2_lS;ako=5DYoc@_7_ldEBWo
;3PY0_lS;ah00olS;bWoAUEBoc@_<`02ob<_:@0EoaXL7_l/>2WoPhB>ofYk
Kon=V8koPhf4of1bNom6EBWo2@TDo`TB2_l971Co6PT:oaXL7_lS;bWo=5Dm
ofYkKom6Ieco4BHDob<_7_l94P[o2@T:00;o4A`:043o4BHDoaXL7_lA9QCo
4BHDoa4L2_l94P[o4A`:o`T95?lS@E;o6PT:ojJ4D_l/4P3oPbmLol77`Ooo
kLco2@T:oa4V2_nNLS?o`K>>onC7`OmG703o/8AVooK]j_oTZYSo0000oa4V
2_l0003o4BHDo`TB2_l92ACo2@T:oa4L2_l92@[o6Q8Do`T92_ld;c?oLXdm
ob<_7_lS9P[o2@TDoaXB5?lJ2@[o2A8:o`T95?lS;akoH5hcog9ED_m?IdOo
SHe_og^=I_nEQ7_oYZ6HoiFQS_nVXISoUIQVof1N<olJ4QCoPg/cof1N<ol9
2@[ob]31omcSh?ofoooog>?P0ooLhmH00ooLhn3og>?FomcSeP02onC@c007
omcSe_oLhn3om^gZongfmOofooookNgZooK]jP02ooKoo`05ongfmOoLhn3o
m_ooojJZ[OnEE@000onVC0002?n3@@3oPcP0of0_2_mG703oARH:ocdL2_lJ
4QCo8a`:0_lJ2@X02_lA70[o2A8:o`T92_l92@[o4A`:o`T92_lA70[o0000
oaX92_lA70X3o`T92P06oa4L2_l92@[o4A`:oa4L2_l92@[o4A`:0_l92@X0
4_l94P[o2@T:oaXL7_lJ4QCo2@TDoaXB5?l/4P3o8a`:oaX92_lm70[oARHD
oaX92_l/4P3oARH:of0_5?lm4P[o?A`:ocdB2P;o?A`:00go6Q8DocdB2_mG
703oH2lDoeLL0?mP;`[oLSPDob`L5?mb9P3oARHDob<L2_lm70[o;1`D00;o
ARH:00Go8bH:odHV2_mP;`[oARH:oeLL0002of0_5003oeLL0?oCfMKok^k^
05kok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000?oi^KV00_oi>CTomcL
g?nVYZKoLG5aoginO_n<S8coVYZJoj>SXonZZZ[o/[:bokJf]P0<okRh^0;o
oOgm1OomoO/02_omoOgoo?cloocmoOolo?gom??hooCcnOo/jo?ogmkVom_K
hooEf=l2omCIg@?odmSL0_oBem/9om?Hg2oodmSK3ooCf=`02OoCf=kod=OQ
om;Ki?oLhn_oj>gcoo3cn?odn?_onocmoogmo@02oogmn`;ooOcm1OomoOd0
1?oAdM7od];Bom;Bd_oBd]8:om?Cd`Koe=CD0_oEeMD5omKFePkoemOG0_oH
f=P=omWIf@?of][J0_oKfm/3omcLg0?ogMgM0_oNg]h;omoOg`;oh>3P0ooR
h^82onCTi0_oiNGU0_oWinL3onSXj003on[Zj_oYjNWojNWY00;ojn_[0oo/
k>`8onk^kP;okno_0oo`l?02oo;blP?om?Cd0ooemOD>ooKfmP04o`]B[OnT
`nGo^=;_ogV^k0;o[=oo00CoJVYZojj^[_oHf=Soi>CTFooVi^H01olA70[o
6PT:o`TB2_lJ4QCo8a`:o`T92_l/4P000_l92@X2oa4L2P06oaX92_l92@[o
4A`:oaX92_lA70[o6PT:0_lA70X05OlJ2@[o;180oaX92_l94P[o6PT:o`T9
2_l/4P3o6PT:ob`B0?lS70[o?A`:ob<L2_l/4P3o8a`:oa4L2_lJ2@[o4A`:
oaX92_l/4P3o2@TDob`B0002ob<L2P04oa4L2_l92@[o2@T:oa4L2P;o2@T:
023o2@TDoaXV5?l/9QCoAT`moeMED_lmGSgo=5DYoaXL7_l/>2Wo=5Dmoba<
:Om6C3go;4`Yob<V2_l92@[oCfMLoh>4S_mkSHCoJW^4ofZ=G?mGEE;o;3PY
o`TB2_lA70[o2A8:ob<_7_l/C2WoAT`modINAolA9P[o2A8:ob<_:@;o2A8:
02Go2@T:o`T95?lA9Qko;2HDo`T95?lJ4QCo4A`:o`000?l94P[o2@T:oa4V
7_lJ71koLSPDof11:OmP;aCo`G]kooKooomZIc?o4BH:oh<h0?nVLU;og;>]
ojIbD_nEGS?og;jgooo]c?lJ2@[o4BH:o`TB2_lA9Qko2@TDoa4V5?l94P[o
4A`:o`T92_lA70[o2@T:00;o6RHD01SoAT4NodmWAolA9QCo2A8:o`T92_lA
70[o6Q8Do`000?mPGS?oLXdmof1N<ombIe;oLXeLohf=KonEQ7_oUJ6>ol6c
S_mZLUco6RHDoa4L2_n`ZXCoPg]LofYW<oo1/jd2ongfm@03omcSh?oTd<co
g>?F00?og>?F00Soi=3<omcSe_oLhmKog>?Fong]j_o]m_Gom_ooong]jP;o
m_oo013odmWFol77`OnVXISoLVMBooKooonNGQCoYVL0ojI<0?n`E@3oYT`0
ojI10?n3>03oLSPDog8V0?m69P[o?A`:0_l/4P000olJ2@[o4A`:ob`B0002
o`T92P03oa4L2_lJ2@[o4A`:00?o2@T:00Co4A`:o`T92_lA70[o4A`:1_l9
2@X03_l94P[o2@T:o`T92_l92@[o2A8:oaXB5?lJ71ko2A8:oaX92_l/4P3o
;1`Dob`B0?mG703o;1800_lm4PX01_mG703oARH:ob`L5?l/4P3o?A`:ob`L
50;oEa`000SoH2l:odHV2_mP;`[oH2l:oh<_0?mb9P3oEa`0of0_2PCo?A`:
00?oEa`0ocdL2_lm70X00omP;`X01?mP;aCoLSP0oeLL0?o:d=IOonKViP04
oifMWOng]kOob<S8om?Cd`7of][J0003onk^kP0;onWYjOo5aLGoNGUioj2P
X?nm_Kgo/;2`ojj^[_ne]KGo_;blokjn__o5aLD03?o8b<P4ooooo`Coo_oo
00[onocnoo_ooooal_Ooh>?ZomcOi_oEf>7ob/gFolK:eOnj`L_o^<7:0_ng
`<T01?nf_lSo]Kk7okBma_nd_LH7okO0bC7o]l373ong`<T02_ng_l[o^/?B
okk7e_o7cmcod=WRomONi?oQi^[ol?Ceoocoooonood2ooooo@03oooooooo
o_ooooko00;oooko00?oooooomoOgooPh>001OoPh>0:on7Qh@?oh^;R0_oS
hn<3onCTi0[oiNGU1_oVi^H2onSXj0Goj^[Z2oo[jn/2onc/k0;okNg]00Co
k>c/ong]kOo]kNgokNg]2_o^k^h5ono_k`?ol?3`1OoalO48oo;blP;olo?c
0oodm?@00ooemOGom_KfooKfmP02ooOgm`?on?Sh2_oinOT3oo[jnP;oo?cl
0oono_hAooooo`04o`mF[_nUa>Ko]];^ogV^j@;oZ^3o00CoKVi^okBd]?oP
h>3ok>c/Foo^k^h00olA70[o2A8:oaX92P03oa4L2P0Co`T95?lA70[o6PT:
oaX92_lA70[o6PT:oa4L2_l/4P3o6PT:ob`B0?lA70[o6PT:ob`B0?lA70[o
2@T:oaX92_l92@[o;180oaX92P02ob`B0008ob<L2_l/4P3o8bH:ob<L2_l/
4P3o6PT:ob`B0?l92@X2oaX92P03oa4L2_l/4P3o6PT:00;o6PT:01go;180
oa4L2_l92@[o4A`:o`T92_l94P[o2@TDo`T92_lJ4QCo8blNoeMWD_mZLUco
CfMLodI<?OldECgo=2lcodIWG?ldEBWo2A8:oaXL7_m?IdOoAT`mobaWG?mk
SHCoPhB>ofYkQ?mkSFKoCfM7ob`h:@02o`TB2P07oaXL7_l/C2WoCg9ko`00
0?l92@[o2A8:ob<_7P02o`TB2P04o`T92_lJ4QCo6RHDoaXV50;o4BHD00Co
4A`:o`TB2_l92@[o2@T:0_lA70X04olJ9QCoH2lDog8h5?n`NfKom_KeojJH
Q?l0003oLSPDojIbD_oL_[Ooi<O1og8V0?oL_[Oom^gZombcXolA9P[o4BHD
oa4V7_l971h00ol92@X03ol94P[o2@T:oa4L2_lJ4QCo4BH:oc@_:OmbSCgo
H5hco`000?l92ACo2A8:oa4L2_l92@[o;3PYoc@_7P02odIE:@0?of1N<on3
SHCoYZ6HojJHQ?nEXHkoSHe7ob`h:Ol/9QCoPg]LojJQV?nVZZgob]31ongf
mOofoooog>?P00Sog>?F017oi=3<ong]j_o]m_Gom_oeooKoooo1al7oYZ6H
ofYbG?mbIe;oWXAVombcXoo]kN[oYT`0ok1E0?nVC03o/5D0ok1b0002ojI<
0005oh<h0?n3;`3oEa`0odHV2_lm70X00_lS70X2oaX92P07oa4L2_l92@[o
4A`:o`T92_l94P[o2@T:oa4L2P03o`T92P03o`000?l92@[o4A`:00;o2A8:
00?o2@T:o`TB2_l92@X01?l92@X01OlJ2@[o2@T:oaXB5?l94P[o6PT:00;o
;18000So?A8:oc@_:Olm4P[o;180ocdB2_m69QCoEa`0ob<L2P?o?A`:00Go
?A8:odHV5?mb9P3o;180oeLL0002of0_2P0Aog8V0?lm70[oEa`0odHV2_lm
4P[oARH:ocdB2_mP;`[o?A`:odHV5?mb9P3oARH:of0_5?mZEAkoH2lDocdL
2_o1al`0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool03?on
o_kom_KfoiZJV_nATI7oc<c<omGEeOo2`/;o^KViol30`?o4a<CobLW9ol[:
bPcod=3@1?ooool3ookoo`0:oocooooam?Wok_?iom[Nioo2bM7o^/7;ok:i
`onX[[[oY:bgoiJR[P;oU::]00GoTZ2[oi6OZ_n@WZWoSifXohjLY`09ohnM
Z00]ohnMY_n?WJSoSifVohnMZ?n?WJKoSifXohnMY_n?WJSoSifVohnMZ?n?
WJKoSifXohnMY_n?WJSoSifVohnMZ?n?WJKoSifXohnMY_n?WJSoSifVohnM
Z?n?WJKoSifXohnMY_n?WJSoSifVohnMZ?n?WJKoSifXohnMY_n?WJSoSifV
ohnMZ?n?WJKoSifXohnMY_n?WJSoSifVohnMZ?n?WJKoSifXohnMY_n?WJSo
SifV00[oSifX1on@WZT02_n@WZ_oVjRioin/_OnW/l?o[[[6okK0bOo2bm3o
f>3Roncbl_olool2ookoo`04ooooooooo_ooookoooomo`;oooko00Cohn?S
onGUiOoUiNGoiNGU2_oVi^H6onOWi`03onSXj?oYjNWoj^[Z00Coj^[Z2oo[
jn/3onc/k0;okNg]0oo^k^h:ono_k`?ol?3`0_oalO42oo;blP04oo7alOob
l_;ol_;boo;blP;olo?c2?odm?@5ooGem@?om_Kf1OogmoL:ooShn0?onOWi
00?ono_kooclo?olo?`00_ono_hVooooo`04o`eE[_nVa^Ko^M?^ogV^j`;o
Zmoo00CoMWIfol71`Oo`l?3ooOgmFoooool01OlA70[o6PT:oa4L2_lJ2@[o
4A`:00;o2@T:00Oo;180oa4L2_l92@[o6PT:oa4L2_l92@[o;18000;o4A`:
00go6PT:oa4L2_l92@[o6PT:ob`B0?l92@[o4A`:oaX92_l/4P3o4A`:ob<L
2_l/4P3o8a`:00;o4A`:00ko2@T:oa4L2_l92@[o6PT:ob`B0?l92ACo6PT:
ob`B0?lS70[o;180o`T92_lS70[o4A`:o`T92P?o4A`:01co2@T:o`TB2_l9
2@[o2A8:oba<:OmZLUcoJW]_ofZ=G?m?IdOoAUi7odI17_lS;ako8blYoba<
:Om?Ieco?Ehmoc@_<om?GVKoPiR>oh>4S_mZNhCoEheLodINAolA9Qko2A8:
ob<_:OldECgo8blY0_l000000ol94P[o6RHDoaXB5002o`TB2P0Ooa4L2_lJ
9QCo;3PYo`TB2_lA70[o2@T:o`TB2_l92@[o2A8:ob<L2_l92ACo6Q8Do`00
0?nEC2WoUG97ongIc?oTd<co4A`:oheE2_nVQ8Cog;jgooKfmOmG703okNgZ
ooK]j_ofoooo0000o`TL5?lA9QCo2@T:oa4V5002oa4L2P09o`T92_l94P[o
2@T:oa4L2_l92ACo6PT:ofYW<omkSFKoPg/c00;o2@T:01Oo2A8:oa4L2_lJ
4QCo;3PYob<_7_mP@BWoAT`mohf=D_n3NecoUIQVoiFQS_o1/hkoH5hcoc@_
7_n=SFoo`K>]ol[@`OoCfMKokOKeooKooooCfMKog>?Fom?IeP03omcSeP05
onC@c?oLhmKoi=3<omcSh?ofooD00_ooool02_mbSHCoJUDNofYW<onESFKo
`J64omcSe_ooooooYZZSokUW0?n`C004ok1E0009ojI<0?n3@@3oPbl0of0_
2_mb9P3oARH:ocdL2_l/4P3o4BH:00;o6PT:0_l92@X02OlA70[o2@T:o`T9
2_l94P[o4A`:o`T92_lA70[o2@T:oa4L2P03o`T92P06oa4L2_l92@[o2@T:
o`T92_l94P[o4A`:0_l92@X01_lA9QCo2@T:oaXB5?lJ2@[o8a`:oaX92P;o
?A`:00?o;180ocdL2_mG70000_mG70000olS70[oEa`0ocdL2P02ocdL2P07
odHV5?mb9P3oH2l:of0_2_mb9P3oH2l:oh<_0004odHV2P0<ocdL2_m69P[o
LRH0odHV2_lm70[oARH:oeLL0?mP;`[oARHDodH_2_mG703o`LO<Goooool0
1?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h03?o]kNgoh>3PogYjN_nl
_;cof=SHom_Kfoo>c/ko`<30olG5aOo:b/[oc<c<olo?c`codm?C00Coooom
oogln_oooooooooo0_onool03_olooool_OmomWPj?o9d]_o]ko:ojRb_?nL
Y[;oS9RVoh:>W?mkRiSoNhjLogN=VomeRiWoLHNE0_m]Pi400om_QI?oLHNE
ofn5T`08ofn5T`0]ofn5T_m_QI?oKhFBofn5Tom_QI;oKhFCofn5T_m_QI?o
KhFBofn5Tom_QI;oKhFCofn5T_m_QI?oKhFBofn5Tom_QI;oKhFCofn5T_m_
QI?oKhFBofn5Tom_QI;oKhFCofn5T_m_QI?oKhFBofn5Tom_QI;oKhFCofn5
T_m_QI?oKhFBofn5Tom_QI;oKhFCofn5T_m_QI?oKhFBofn5Tom_QI;oKhFC
ofn5T_m_QI?oKhFB00_oKhFC01KoL8JDofn5Tom^Q9;oK8:@ofj4T_mcRIOo
MhbMogV9X?mlS:?oP96UohRHZ?nEXk3oY[>lok_6b_o:e=Koh>SZoo7gmoon
oooooooooogko_ono?oooogo0_ooo_l00ooWinOoj>SXonSXj004onSXj0[o
jNWY0ooZj^X2on_[j`?ok>c/2_o]kNd3onk^kP?okno_00?olO7aoo3`l?ob
l_800_obl_82oo?cl`Som?Cd1OoemOD3ooKfmPGomoOg3Oohn?P3ooWin@oo
n_[j0ookno/00oolo?cooOgmoogmo@02ooknoRKooooo00Co4EN_oj?2i?nh
dnooMjk[0_nZgol01?m^KVko];Bdon3Ph?o/k>aKonk^kP09oa4L2_l92@[o
;2HDoa4L2_lJ2@[o;180oa4L2_lS70[o2@T:00;o4A`:0_lJ2@X00olA70[o
6PT:oa4L2P02oaX92P0?ob`B0?lA70[o2@T:oa4L2_l92@[o4A`:o`T92_lJ
2@[o;180ob<L2_l/4P3o2@T:oaX92_l/4P3o2A8:00;o2@T:00Go4A`:ob`B
0?l/4P3o6PT:ob<L2P02oaX92P07oa4L2_l92@[o6PT:o`T92_lA70[o6Q8D
oa4L2P02o`TB2P0Io`T92_l0003o;3PYoceN?On3SHCoNheVofYkKom?IdOo
AT`mob<_7_l/>2Wo8blcog:=Q?mZNfooAVMLofZ=G?mbSHCoJW^4ofYkKomG
Ie;o;4`Yoa4V7_l/>2Wo8blYo`000004o`TB2P04oa4L2_l94P[o2@T:oaXB
50;o6RHD0olA70X01?l92@[o2A8:oa4L2_lJ2@X2oa4L2P07o`T92_mP@BWo
YW9Bombn]oofooooYXB4og8h0002ol6QQ006ooKfmOnEC2Wog;jgonC@c?of
ooooYXB40_lA9PX01Ol92ACo4A`:o`T95?lA70[o2A8:00Co4A`:00So;2HD
ob`h:OmPGS?o`K>>ohf=Aol94P[o4A`:o`TB2P;o4A`:00ko6Q8Doc@_7_m6
EBWoLVMBog^=I_nEXHko`K>]oiFQS_ldEBWoPg/col6c[Oo1al7ob]31omcS
h0;okOKe01kodmWFol[@`Oo:d<7oi=3<omcSe_oTd<codmWFol[@`OoTd<co
kNgZoooooooChoGoEhf>odI17_nELTOoWXAVonC7`Oo]fLcom_oooooooonV
Q8Co^FL0ok1E0?niI`3o/5D0ok1<0?niI`3o/5D0ojI10?nEE@02oh<_0006
of0_2_mG703o?A`:ob`B0?lS70[o6PT:0olA70X01_l92@[o4A`:o`T92_l9
4P[o2@T:oa4L2P;o2@T:00?o4A`:o`T92_lA70X00ol92@X03?lA70[o2@T:
o`TB2_l92@[o4A`:o`T92_l/71Co2@TDob`B0?lS70[o;180ob<L2P;oARH:
00?o8a`:of0_2_mP;`X00_lm4PX01Om69P[o?A`:ocdL2_lm4P[oEa`000?o
LRH000CoLSPDog8V0?n3;`3oH2l:0_m69PX01olm70[oARH:oeLL0?m69P[o
AT4NocdB2_mP;`X00om69PX00om69QCoEa`0ok2n`@1Oonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q0002onKViP04onCTi?oGemOoLG5aom7Ad@;og=cL
00Kod=3@olC4a?o9bLWoc<c<olo?cooBd]8<omGEe@0HoooooOonoO_ooooo
ooooooojnooomo[oonodn_oMi>kod=SSokk:f?nX]/?oTJ6`ogf>W_m]OY3o
I7N8of9gR?mNN8WoGWV:oemjRomNNH[oG7N8oe]fQomLMhSoGGR92OmKMXL0
;OmKMhGoFgJ7oe]gQOmKMXOoFgN5oe]fQomKMhGoFgJ7oe]gQOmKMXOoFgN5
oe]fQomKMhGoFgJ7oe]gQOmKMXOoFgN5oe]fQomKMhGoFgJ7oe]gQOmKMXOo
FgN5oe]fQomKMhGoFgJ7oe]gQOmKMXOoFgN5oe]fQomKMhGoFgJ7oe]gQOmK
MXOoFgN5oe]fQomKMhGoFgJ7oe]gQOmKMXOoFgN5oe]fQomKMhGoFgJ7oe]g
Q@02oe]fQ`SoG7N800CoFWF6oeagR?mMN8WoG7N80_mJMHH04omLMhSoGgZ=
ofZ0V?mOLhcoGG69ofb1U?n1U:?oT::^oj>d_?nf`lWoa]7EomgUj?ocn?_o
o_ooooooooooo_oooocooogko_ooo_l01ooWinL7onSXj0?ojNWY0ooZj^X2
onc/k0?ok^k^0_o_knl>oo3`l003oo7alOobl_;olo?c00oolo?c0_odm?@3
ooGem@?om_Kf2_ogmoL3ooShn0;onOWi0oojn_X2oo_kn`?oo?cl3OomoOd3
ooknoRSooooo00Co4EN_ojG4i_nidnooMjk[0_nYg?l01?mZJV[o[Zj^omSH
f?oTi>AKonKViP0Joa4L2_lJ2@[o6Q8Doa4L2_lJ2@[o2@T:oa4L2_l92@[o
6PT:o`TB2_lJ2@[o4A`:oaX92_lA70[o6PT:o`T92_lJ2@[o4A`:oaX92_lA
70[o;180oaX92_l92@[o;180oaX92_lJ4Q@2oaX92P09ob`B0?lA70[o2@T:
o`T92_l0003o2A8:oaX92_lJ4QCo6PT:00;o8a`:0_lJ2@X00ol/4P3o4BHD
o`T92P02oa4L2P05o`T92_lA70[o8blNoaXB5?lA70X00_l92@X01Ol0003o
2@TDocAE:OmbSHCoPhB>00;oJW]_0_ldECd03_mZNfoo=5DmodIWG?m?Ieco
CeiVofYkKon3Q8koJW]_odmbNom6Ieco;4`Yoa4V2_l92ACo2@T:0_l94PX0
2?lJ4QCo2A8:oaXB5?l92@[o2A8:oa4L2_lJ4QCo6RHD1?l94PX2o`T92P0=
oa4L2_l92ACo4A`:o`000?m69P[oPehcombn]oofm_GokMW<ocdB2_o1XHCo
g;>Sombn]`02ol6QQ008onC7`OofkN[okMW<og9WD_lA9P[o2A8:oa4V5?m6
@Ah2oaXB5005o`T95?lA70[o2@TDo`TL5?lJ4Q@00_lS70X01_n3NecoUJ6>
ocAE:Ol94P[o2@T:oaXB50?o4A`:00_o;2HDol6c[On3NecoUJ6>ok2c]on`
ZXCo4BH:ojJ4Q?o1al7o`LO<onC@c002ongfm@03omcSh?oLhmKoi=3<00;o
b]31017odmWFol[@`Oo:d<7ob]31omcSe_ooooooY/OPodI17_mZEAkoWXAV
ojJHQ?o:_Zgog>?PooKoooo]m_Gooooool6QQ002okUW000;ok1E0?niI`3o
^FL0ok1E0?niI`3oYT`0ojI10?nEE@3oPcP0of0_2_mG70000_m69PX01?lS
70[o4A`:o`T92_lJ2@X2o`T92P08oa4L2_lJ2@[o2@T:oa4L2_l94P[o2@TD
o`TB2_lA70X2o`T92P;o2A8:1ol92@X00ol0003o4A`:oaXB5002ob`B0003
ocdB2_m69QCo?A`:00;o?A8:01CoEa`0of0_2_l/71Co?A`:ocdB2_m69P[o
?A8:of0_2_mb>1CoEa`0of0_5?mb9P3oLSPDog]<2_mP;`[oLRH0odHV2_lm
70[oH2l:odHV50;oEa`000?o8a`:odHV2_m69PX00_m69PX00om6;`[o?A8:
ol77c01OonKViP04oifMWOng]kOob<S8om?Cd`7of][J0002onk^kP0<onc/
k?oMgMgoLG5aomOGeooNg]kogmoOomCDe?o4a<CoalO7olc<c?o@d=3od];B
3?oFe]H04ooooO[ono[fookno?oooooooOkoooOloooWk_Sod=[Vok6mcOnI
ZKWoOi6UogF:WomjT:GoQYneoiF`aOnN^/oo_=__okoPlOo4iOH00_o7j?T0
0oo5i_Ooa>GfolCUmP09olCUmP0]olCUm?o4iOKoa>GdolCUm_o4iOCoa>Gf
olCUm?o4iOKoa>GdolCUm_o4iOCoa>GfolCUm?o4iOKoa>GdolCUm_o4iOCo
a>GfolCUm?o4iOKoa>GdolCUm_o4iOCoa>GfolCUm?o4iOKoa>GdolCUm_o4
iOCoa>GfolCUm?o4iOKoa>GdolCUm_o4iOCoa>GfolCUm?o4iOKoa>GdolCU
m_o4iOCoa>GfolCUm?o4iOKoa>Gd00[oa>Gf00Go`^?dolCUm_o5i_OoaNKg
olCUmP02ol;Sm00>ol?Rm_nhd^_oXkgFohnY`?n4WK?oMXbQog25V?n6VJSo
Y[S4ok2nbOo;eMkojO3hoocoooonool2ooono`03ooomo_ooo_oojNWY00?o
j^[Z0oo[jn/=onc/k003ong]kOo^k^kokno_00cokno_0oo`l?03oo7al@03
oo?cloobl_;om?Cd00;om?Cd0_oemOD8ooKfmPOomoOg1_ohn?P;ooWin@;o
n_[j0_olo?`00ookno_ooOgmoogmo@0AooknoR[ooooo00Co3EJaojC4i_ni
dnooMZgZ0_n[h?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP07oaX92_l92@[o
6Q8Do`T92_lJ2@[o4A`:oaX92P02oa4L2P04oaX92_l94P[o6PT:oa4L2P;o
6PT:00go4A`:ob`B0?lA70[o6PT:oa4L2_lJ2@[o4A`:o`TB2_lJ4QCo;180
o`T92_lS70[o6PT:00;o;1`D0_l92@X02ol92ACo0000oaX92_lS70[o6PT:
ob`B0?lJ2@[o8a`:ob`B0?lS70[o6PT:00;o2A8:00Wo6Q8Do`TB2_l92@[o
6Q`NoaXV5?lS;ako4BHDoa4L2_l92A@00_l000003Ol94P[o=5Dmoh>4S_n3
SHCoJW]_oeN=G?mGGVooNheVoeN=G?mGIe;oCeiVog9bNomZNh@00_mbSH@0
1?l94P[o0000o`T92_l92A@2o`T92P06oaXB5?l92ACo2@TDob<_7_l0003o
2@TD0_lA9Q@04olA70[o6Q8Do`T92_l94P[o2@T:oa4L2_l92@[o6Q8Doa4V
5?l94P[o6Q8DodHV5?nEC2Woi<O1ooKooooooooo8a`:olZZI_n`Q7/00_oT
d<`05onVLU;ob[j]onC7`Oo]fLcob]31o`000?lA9QCo2A`Doc@_7_mZIc?o
JUDNoa4V5?l94P[o6Q8Do`T95?lJ4QCo4BHDoaXL7_lJ9QCog<NSohf=Aol9
4P[o2A`D00;o6Q8D00oo4A`:oa4V5?lJ9QCoYYQ_oiFQS_n`ZXCoYZZSoiF4
Nom69QCob]3Fol77`OoLhmKog>?Pom?SmOo]kNX00_oLhmH2om?IePCob]31
013og>?FongfmOoLhn3oEeEBoiF4D_nVV8Co`K>>onC7`OoLhmKom_ooongf
mOofkN[om_oool77c?niI`3odh@00_niI`002?n`E@3o/4`0okUW0?n`E@3o
YT`0ojI10?n3@@3oPbl00_mP;`X01OmG703o4A`:oaXB5?lA70[o6PT:00;o
4A`:0_l92@X01?lA70[o2@T:o`T95?l94PX2o`T92P03oa4L2_l92@[o2A8:
00;o2@T:00?o2A8:o`T92_l92@X00_l92@X00olA70[o2@T:o`T92P02oaX9
2P05ob`L5?lm70[o?A`:oeLL0?lm4PX00_mP;`X02omG703o?A`:odHV2_lm
4P[oARHDoeLL0?mP;aCoLRH0of0_5?mb9P3oH2l:00;oPbl000?oARH:of0_
2_m69PX01Om69PX02?m69QCoEa`0odHV2_lm70[oARHDoeLL0?lm4P[ob]3F
Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool01?omoOgok>c/
ogMgMooIfMT2on3Ph006omCDe?o7alOob/[:olk>c_oBd];oe=CD3?oFe]H0
G_oooOSooOWfoooooOooooooo?oooo?goooKho3o_/[JojBca_n;WK?oMXbT
ogbF[onF]<co/];[ol3Rnoo7j_oo`nKjolK[noo=l?ood?Goom7dooo?m?oo
co;oolkcoooAm?ood?Goom7dooo@mOoodOCoom3eoooAm?ood?Goom7eooo@
m_oodOGoom3foooAmOood?Koom7eooo@m_oodOGoom3foooAmOood?Koom7e
ooo@m_oodOGoom3foooAmOood?Koom7eooo@m_oodOGoom3foooAmOood?Ko
om7eooo@m_oodOGoom3foooAmOood?Koom7eooo@m_oodOGoom3foooAmOoo
d?Koom7eooo@m_oodOGoom3foooAmOood?Koom7eooo@m_oodOGoom3foooA
mOood?Goom3dooo?m?ood??oolodooo@looocoCoom3cooo?m?ooco;oolod
ooo@loooc_?oolkaooo;l?l2ol_^o`0>olSXooo7iOooaN?mokWGkonM^M7o
OYR_ogJ?YOn2Uj[oXK;4ok[7eooIhngokoKnoo_looono_h2ooooo@03oooo
oooXj>Soj>SX00Goj>SX1ooYjNT3on[ZjP?ojn_[00?okNg]onc/k?o^k^h0
0_o^k^h2ono_k`_ol?3`0ooalO42oo?cl`?omOGe2_ofm_H=ooOgm`_on?Sh
0_oinOT2oo_kn`03ooclo?ono_koo_kn03_ooooo00Co3EF^ojG4i_ned>ko
NJk/0_nWg?l01?mfMWKo`L71oo3`l?omoOeKooooo`Go4A`:01Wo8a`:oa4L
2_lJ2@[o4A`:oaX92_lA70[o8a`:oaX92_lA70[o8a`:oaX92_lA70[o6PT:
oa4L2_lJ2@[o2A8:ob`B0?l92ACo;180oaX92_lA70[o2@T:oaXL7_ld;bWo
4A`:00;o2@T:00Ko2A8:oa4L2_lS70[o;180oaXB5?l/4P02ob<L2P03oaX9
2_lS70[o4A`:00;o2@T:00Ko2A8:oa4L2_l92@[o4BHDoa4L2_lA9Q@2ob`h
:@09oc@_7_lS;ako4BHDob`h:Old;bWo8d4moeMNKomZNfooLW9k00;oJW^4
00WoLXf4of1bNom6IecoCg9koh>HS_m6GTOo0000oa4V5?l000000_l92A@2
oa4L2P0;o`TB2_lJ71ko2@T:oaXL7_lJ4QCo4A`:o`TB2_lJ4QCo2@TDoa4L
2_l971@00_l94PX03Ol92@[o4BHDoaXB5?lA70[o6Q8Do`T95?m69P[oUG97
onC7`Oofm_GoooooodH_2_niV5`00_o1XH@03_oTd<coNd`Dol6QQ?oTal7o
kNgZooKooomP;`[o4BH:ob`L5?lA9QkoLXdmodI<?Om6EBWo6RHD0_lA70X0
6OlJ4QCo;180oa4V5?ld;bWo`K>]oiFQS_lA9P[o2@TDoa4V5?lA70[o6Q8D
ob<_7_l92ACoYYR4ok2c]onVZZ?oUJ6>ofYbG?nVXISo`K>]ol[@`Oo]m_Go
dn?eooKooooLhn000_oCfMH05ooLhmKodmWFomcSe_o1alco`K>]ol77`OoL
hn3okNgZof1bNonEV6Ko`K>>ol6c[Oo:d<7og>?FooKfmOofooookOKeooKf
mOoooooog>?Pom>40?niI`3o`H@000;o/5D000Co`H@0okUW0?n`E@3o^FL0
0_nVC0001_n3>03oLSPDog8V0?m69P[o;180o`T92P;o4A`:0_lJ2@X01olA
70[o2@T:oaX92_lA70[o2A8:o`T95?lA70X00_l92@X00olA70[o2@T:o`T9
2P03o`TB2P03oa4L2_l92@[o4A`:00;o2@T:013o4A`:ob<L2_lS70[o;180
ocdB2_m69P[o?A`:ob`B0?mP;aCoH2l:oeLL0?lm70[o?A8:odHV5?m69P[o
H2l:0_mb9P001om69QCoLRH0og8h5?n3;`3oNd`Dog8V0?mP;a@00_m69PX0
1om69QCoARH:odHV2_m69P[oEa`0odHV5?m69PX00_m69Q@00om69P[oEa`0
ol77c01Oooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP0<onc/
k?oLg=coMWIfom[Jf_oPh>3ohN7QomCDe?o7alOobl_;olk>c_o@d=3odm?C
3?oEeMD0L_ooo_SoookioooooOoooooom?Onon7Xl_o4cMcoX:o2ohZL/_n2
V[;oR:>noibkeonbeO7o_>?ookgVoonkhocob_3oolgeoooBmooodo_oomCi
oooCnoooe?WoomCloooHoOooeoooomSmoooGoooof?goomOooooHoOooeooo
omSnoooGoooof?koomOooooHo_ooeoooomSnoooGoooof?koomOooooHo_oo
eoooomSnoooGoooof?koomOooooHo_ooeoooomSnoooGoooof?koomOooooH
o_ooeoooomSnoooGoooof?koomOooooHo_ooeoooomSnoooGoooof?koomOo
oooHo_ooeoooomSnoooGoooof?koomOooooHo_ooeoooomSnoooGoooof?ko
omOooooHo_ooeoooomGkoooDo?ooeO[oomCloooEn_ooe?coomGjoooDo?oo
f?goomGmoooDnOood_[oom;gooo@n?oodOKoom3eooo3iogo`nOool;Toonl
g_Wo]MC`oj;0g?n8Xl3oLXZVohbP^?nR/lOo`loOon3Yl_obmO[onO_joogl
n?onoOWoooomon[ZjP?ojn_[0oo/k>`7ong]k@Kok^k^00?ol?3`ono_kooa
lO401?oalO4;oo;blPColo?c1?odm?@:ooGem@Gom_Kf0_ogmoL00oofm_Ko
moOgooOgm`03ooOgm`_on?Sh0_oinOT2oo_kn`03ooclo?ono_koo_kn03_o
oooo00Co3EJaojC4i_nhd^koMZgZ0_n/gol01?m^KVko];Bdon3Ph?o/k>aK
onk^kP03oa4V5?lJ4QCo4A`:00;o6Q8D00Wo4A`:oaXB5?lA9QCo6PT:oa4L
2_lS70[o2@T:oaX92_l94PX01?lJ2@X01_l/4P3o6PT:oaXB5?l/4P3o2@T:
ob<L2P;o6PT:00Go;1`Dob<_:OlJ4QCo4A`:oaX92P02oa4L2P07ocdB2_lA
70[o8a`:ob`B0?lJ4QCo;180oaX92P02ob<L2P03oaX92_l94P[o4BHD00;o
2@T:01Wo4A`:o`T92_l92ACo6Q8Doa4L2_lJ9QCo;4`YoceN?OmZNfooPhAk
ofZ=G?n3Q8koJW]_ofYkQ?mbSJgoLXf4ofYkKomGGVooJW^4odmbNom?GVKo
AUEBob<_7_l0003o4BHD00;o2A8:00ko2@T:oa4L2_lJ4QCo2@TDoaXV5?lA
9Qko6Q8Do`TB2_l92ACo4A`:o`T92_l94P[o6Q8Do`T950;o2A8:01[o4A`:
o`T95?lS;bWo6Q8DoaX92_l971Co?A`:og9ED_o:_ZgokNgZoooooonEQ8ko
WW8combcXonVEFKom_Keok24NonEC2Woi=3<ongfmOofooookMW<ok24I_o1
/hkoYW8Doa4V50;oH5hc01_o=2lYoaXB5?l971Co4A`:oaXB5?lA70[oAT4N
ok2c]oo1/hko6RHDoa4V2_l971Co6RHDoaXB5?lJ71ko;2HDok2ZQ?o1/jgo
YZ6Hoh>=Q?o1al7o/;k1ok2c]ooLhmKokOKeong]j_ofool00_oCfMH00ooL
hn3odmWFol[@`@02ol77`@0:omc7Xoo:d<7okOKeoiFHXonEQ7_o`K>>ol6c
[Oo:d<7og>?FooKfm@?om_oo00SokOKeoooooooLhn3o/5D0om>40?niI`3o
`H@0om>400;o^FL000Go/4`0okUW0?n`E@3oYT`0oiEE0002oh<_0006odHV
5?lJ71ko4A`:oa4L2_lJ2@[o4BHD0_lA70X01Ol92@[o2@TDoaX92_lJ4QCo
4A`:00;o2@T:00Go4A`:o`T92_l94P[o2@T:o`TB2P02o`T92P0Hoa4L2_l9
2@[o2@T:oa4L2_l92@[o6Q8Docd_?OlJ2@[o?A8:odHV2_lm70[o?A8:ob`B
0?mP;`[oLRH0oc@_7_lm70[oARH:oeLL0?m69QCoEa`0of0_2_mb>1CoEa`0
0_mP;`X2oh<_0008odHV5?mP;`[oARH:ocdL2_m69QCoH2l:odHV2_mP;a@2
of0_2P06odHV2_mG703oARHDodHV2_lm4P[o`LO<Goo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@000_oVi^H01?oTi>Coe=CDogalO?oJf]X2on3Ph006
om?Cdoo6a/Koc<c<olk>c_o@d=3odm?C3?oGemL04oooo_SooogiooonoOoo
ooooko;iomSNj_ng`m?oU:Fiog:8X?mnVKCoUKCAojW>jonbfo_o]>7ook[X
ooo3lOoob?;oolcdo_o?mol00_o@n?l00oo?moood?Soom7io`0homClo`So
d_[o00Coe_koom?kooo@n?oocoOo0_o>m_l05?o=mOooc?Coom?iooo@mOoo
`nSook;Gm?n[c^koY/OXoiVff?n8X/?oNi:aoi6S^ond`MCof>3]oo7fn_ol
o_gooOkhookmn?oooogojNWY0ooZj^X3on_[j`Ook>c/00?ofm_Kon_[joo]
kNd00_oRh^801Oo]kNgokno_ono_kooOgmoohN7Q00?olO7a0_obl_800ooW
inOog=cLoo;blP06oo;blPSolo?c0oodm?@00ooKfm_ol_;booCdm004ooCd
m0GomOGe0oogmoL5ooWin@_on_[j0_okno/3ooclo0;ooOgm4Oono_hZoooo
o`04o`mF[_nVa^Ko]]3^ogV_kP;oZmko00CoJVYZojj^[_oHf=Soi>CTFooV
i^H02olJ2@[o2@T:oaXB5?lJ2@[o8a`:oaX92_lA70[o6PT:o`T92_lJ4QCo
;18000?o6PT:00ko;180oa4L2_lS70[o6PT:ob<L2_lA70[o;180oaX92_lA
70[o6PT:ob`B0?lJ2@[o4A`:oaX92PCo2@T:01?o4A`:oaX92_lJ2@[o8a`:
oaX92_l/4P3o6PT:ob<L2_lJ2@[o;180oaX92_lA70[o2A8:o`T92_lA70[o
2@T:oa4L2_l92@[o4A`:00;o2@T:00go6Q8Do`000?m6EE;oUIRSog^=Q?n=
V8koH79kol77c?n`/kOoJW]_of1bNomZNhCoH79k00;oCg9k00GoCeiVob<_
7_l92@[o;3PYo`T92P03o`TB2P06oa4L2_l92ACo6Q8DoaXB5?l94P[o2@T:
0_lA70X01?l92@[o2A8:o`TB2_l94PX3o`T95009oaXB5?lA9QCo6Q8Doa4L
2_l92ACo?A`:oiEbAoo1XHCoi=3<00;om_Ke00?oUEDDokUb<on`NfH00_o]
kNX05_nEC2Wog;jgooKoooo]m_Gom_ooongIc?oL_[Ooi<O1ofYW<olA9P[o
Pg]Loh=k<ol94P[o6Q8Doa4L2_l/71Co4BH:oaXV5?o1/hkoYZ6HofYE7_lJ
9Q@2oaXB500AoaXV5?l/9QCoJVLcoh>=Q?nVZZ?oYZZ]ol[@e_nVZZ?o/:Z4
ok2c]oo]m_Godn?eong]j_o]m_GodmWFomcSh?o:d<400_o1al402on`/kOo
`K>]onC@c?oLhmKodmWFojJHKonVXISo`K>]ol77c?oLhmKokOKe00?om_oo
00Com_KeooKooooooooodmWF1?oCQ0001?o1Q03odh@0ol640?n`C002okUW
0003ok1E0?nV@@3oUED000;oPcP00_lm70X00olA70[o6PT:oaX92P02oaX9
2P04oa4L2_lJ2@[o2@T:oaX92P;o2@T:00Go4A`:o`T92_l92@[o2A8:oa4L
2P05o`T92P03o`TB2_l92@[o2@T:00;o4A`:00_o;180oaX92_lm70[oEa`0
ocdB2_lJ4QCoLRH0oeLL0?mP;`[o?A`:oeLL0004of0_2P03oh<_0?mb>1Co
LRH000;oLSPD00?oPbl0of0_2_mP;`X01?m69PX02_mP;`[oEa`0odHV2_m6
9P[oEa`0odHV2_l/71CoARH:ocdB2_o:d=IOonKViP04oifMWOng]kOob<S8
om?Cd`7of][J0002onk^kP04onc/k?oLg=coO7alom[JfP;oh>3P00Kodm?C
olO7aoo<c<coc/k>om3@d?oBd]8<omKFeP0FooommOooo?KoookkooknoooY
k??ocmORojnlcOn>X;KoPi^eoh^Xa_nJ_MgoYLc]ojKBmOnWf?Wo/nGool7c
ooo7lOooc??jolofoOoAn?ood?Onolofo@;od?On2?oBnOl`om;ioPSod?On
01Kodo[oom7hooo?m_gocoKmom3go_o?m_goc??jolWanoneg_3o^n?lokoW
oonih?oo[m?eoj75jOnC/m[oRjO<ogbD]_n:WK_oYkK;olgFiOoZlOOon_ok
0_ooooP00ooooogoj^[Zon_[j`02on_[j`03onc/k?la<C7oKVi^00;okNg]
01Soi>CTob<S8om1@D7ok>c/od];Bol71`Oo61PHoi6ATOlA4A7oDE5Aonk^
k_oFe]Ko>c/ko`000?l@413o6a/KonWYjOo`l?3of][JodE5AOl20P;o8B4Q
oaDE5Onf][H4oo7al@04odU9BOm^KVkol_;boo;blP;olo?c00Som?Cdob`/
;?mJFU[omOGeol[:b_lS8b?o71`Lok:b/PGomOGe00?o=3@do`000?l00000
0_l000001?lh>3Son?Shocdm?OmlO7`2ooWin@0:ochn?_mlO7con_[joo[j
n_nOWioo6a/Koo[jn_o4a<Co0000o`T92@?o3Ph>00GoG5aLoo_knoolo?co
o?cloogmo@02ooknoS_ooooo00Co35>^ojC3iOnhd^ooNJk/0_n/gol01?m^
KVko];Bdon3Ph?o/k>aKonk^kP04oaXB5?l/71Co4A`:oaX92P;o2@T:01Oo
6PT:oa4L2_lJ2@[o4A`:o`T92_lA70[o6PT:o`T92_lS70[o6PT:ob`V5?l9
2@[o2A8:ob`B0?lJ2@[o4A`:o`TB2_l/4P3o6PT:oa4L2_l/4P3o6PT:o`T9
2P03oa4L2P0=oaX92_lS70[o8a`:ob`B0?lS70[o8bH:ob<L2_l/4P3o6PT:
ob<L2_lJ2@[o4A`:o`T92P03o`TB2P0?o`T92_l94P[o2@T:oa4L2_l94P[o
6Q8Do`T92_lA;c?oJW]_oiFHXombLW_oY[?1ofYkKombSHCoJW^400;oLXf4
00SoH79kofYkKomkSHCoEheLo`000?l94P[o;5hmo`0000;o2A8:00?o2@TD
oa4V5?lJ4Q@00_l92@X00ol94P[o2@TDo`T92P02o`TB2P04o`T92_l94P[o
6Q8Do`T92P;o2A8:01Go6Q8Doa4V7_lA9QCo6Q8Doa4L2_lJ4QCoJUDNojJ4
Q?oTd<cokOKeoooooombEE;o/8dcol5kNoo]fLcom_ooolZn[On`Q6Kom_Ke
ongfmOofool00oo]kNX06_oTal7oARl:oiFHI_n3Neco=5DYo`TB2_lJ4QCo
4A`:ob<L2_lA70[oUJ6>ol6c[Om6EBWo;3PYob<V2_lJ4QCo4BH:oc@_7_mZ
LUcoUJ6>om?Ie_o:d<7o`LO1oiFZ[On=V8kob]310_o]kNX00oofoooob]3F
ol77`@02ol77`@Co/;>g00Sog>?PongfmOnVZZ?oYZZSol6cS_nVXISog>?F
ong]jPKom_oo00?oooooombc[OoCQ0001?oCQ0000oniI`3odh@0okUW0002
okUW000<ok1E0?nVI`3oYT40oiEE0?n3@@3oARH:ocdL2_lS70[o;180oaX9
2_l92@[o4A`:0_l92@X01_lA70[o2@T:oa4L2_l94P[o6PT:oa4L2P;o2@T:
00ko4A`:o`T92_l92@[o4A`:o`TB2_l92@[o4A`:o`TB2_l92@[o2A8:o`T9
2_l/71Co;180oeLL00;oARHD00co?A8:of0_2_mP;aCoLRH0ocdB2_mP;aCo
Ea`0odHV2_m69QCoPbl0og8h0?mP;a@2og8V0005og]<2_n3;`3oH2l:odHV
5?mG70000_m69PX01OmG703oH2lDoeLL0?m69QCoEa`000;oARH:0_lm70X0
0ol/4P3odn?eonk^kP1Nonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002
ooooo`04oogmoOo/k>coO7alom[JfP;oh>3P00Koe=CDolS8b?o;bl_oc/k>
om3@d?oBd]8<omKFeP;oookk017oooomooSinooNhnWo`L_Eoij_`OmmTZgo
PifnohBTbon=/]coW<K`ojWEo?n^g?oo/N;ookKUoonmi_Soa>[golW^oP02
ol_aoP03olW_o?o8k__ob>kk00Oob>kk<Oo8k_T8olS^n`0JolW_o?o8k__o
b>kkol[`oOo;lOkobNololCZmonoi_Ooa^kookSOo?n]e_Co[]Ogoj_CmonM
`n[oS:oIohBTcOn0W<CoQYc1oiZ[aonlbMcogNK_oo;fmOoloOGoooofoooo
nooZj^X3onc/k003ong]kOlb<S;oKVi^00;ok^k^00WoJ6QXoa8B4_oGemOo
^;Rho`<30oo?clooemOGoeEEEOl?3`l00_o_knl03Olm?Cgo:BTYokjn__o_
knoob/[:ong]kOo_knoo@410oc`l??oAdM7ol?3`onCTi?oShn<01?o`l?00
3OnYZJWo4a<Con_[jooalO7ol_;boo?cloo2`/;o0000okZj^_oemOGoK6a/
ochn?_odm?@01_oemOD00old=3CoKfm_ooKfmP02ooKfmP;omoOg00Ko?Cdm
og]kNoohn?Son?Shochn?_mkNg/2ooWin@07oinOWolK6a_onOWiooGemOm4
A4Co>3Phoo;blP02ooWin@;on_[j0oolo?`2ooknoS_ooooo00Co3eJ^ojG4
i_nfd^koNJkY0_nZh?l01?mfMWKo`L71oo3`l?omoOeKooooo`03oa4L2_lJ
9QCo2@T:00?o4A`:00Ko2@T:oa4L2_lA70[o4A`:o`T92_l/4P02oa4L2P0<
o`T92_lS70[o8a`:ob`B0?lJ2@[o;180oa4L2_lJ2@[o0000ob<L2_l94P[o
;1801?lA70X01?l92@[o6PT:oa4L2_l/4P02oaX92P07ob<L2_l/4P3o4A`:
ob<L2_l/4P3o6PT:ob<L2P02oa4L2P07o`T92_l0003o2A8:o`TB2_lA70[o
6Q8Do`T92P02o`TB2P04o`T92_l0003oUIRSog^=Q0;oUJZ]00GoAUEBog9b
NombSHCoLXf4of1bN`02og:=Q006oh>HS_m6Ieco0000o`TB2_m?IdOo0000
0ol94PX00olS;bWo2A`Do`TB2P03o`TB2P04oa4L2_l92@[o2A`Do`T92P;o
2A8:01Wo4A`:o`T95?lA9QCo6Q8Do`TL5?l/9QCo2@T:oa4V5?lA70[oH2lD
onBZV?nVZZgog;jgoooooooL_[OoUEhcok1kI_o1alcom_KeonC@c?n`NfKo
m^gZong]j_ofm_GokOKe00;okNgZ00Gog>?PokVZKomPGS?oYZ6HodIE:@02
o`TL500Bo`T92_lJ9QCo4A`:of1N<onEV6KoAUDYof1N<olA70[o6RHDo`TL
7_mZIc?oYZ6Hom?Ie_o:d<7o`LO<ok2c]on`ZXCoPhAk0_o]kNX2ongfm@03
ok2c]oo1al7o`K>]00;oUJ6>00Oo/;>gol6c[Oo]kN[og>?Poh>H[OnVXISo
/;>g00;o`K>]00?okNgZongfmOofool01_ofool01OniI`3odh@0om>40?oC
Q03oi:X000Codh@00oniI`001on`C03o/5D0ojI<0?nEE@3oPbl0og8V0?m6
9PX00_lS70X01OlA70[o6PT:oa4L2_lA70[o2@T:00?o2A8:0ol92@X2o`TB
2P04o`T92_l94P[o2@T:o`TB2P?o2@T:00Go4A`:o`T92_lA70[o6PT:ob`B
0002odHV2P03oeLL0?lm4P[oLRH000;oLRH000?oARHDog8V0?mb9P000_lm
70X00omb9P3oPbl0og8V0003og8V000:of0_2_mG703oH2l:oeLL0?m69P[o
Ea`0odHV2_mb9P3oARH:oeLL00?oARH:00Co?A`:ob`L5?l/4P3odmWFGooo
ool01?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h03?o/k>cog=cLog]k
NooJf][oh>3Pon7QhOoEeMGob<S8ol[:b_o>c/kod=3@om?Cd`coe]KF0_oo
o_l05_olo_gomogmomOQhonmbmCoTZNloff7Z?mhV<OoOZ?JohZbkOnF_oOo
W/KgojO?lon`f?;o]]kgok_PoOnjg_ko^]kookcPooo0i?oo`NGool3Toonm
hOm0ol;Wo`?o`nSo01Oo`^Oool7Voonoi?oo_^?ookgQoonig?oo]m[oojoE
n_nVc_;oWLO]oiK0j?n:/mooPjOGogVIb_mYQKCoTJO@ok?4h_oGh?7omO[m
ookon?onoo?ooookonWYj@03on[ZjP0Bon_[jola<C7oKFe]onc/k?nc/k?o
0@41oj>SXoo/k>cob<S8o`820_n_[jookNg]oi>CTolM7AgokNg]olc<c?l0
003oRh^;1?oalO400oo@d=3o0000ojj^[P08oo;blP03ono_kolJ6Q[oK6a/
00?oTY:B00KoADE5obHV9_oclo?om?CdodU9BOm]KFd7ooCdm003oc<c<om_
KfoomOGe00;om_Kf0_ohn?P01_ln?SkoOGemoo_knookno_o?cloogemO@;o
oOgm00OoXJ6Qoa/K6oomoOgooOgmonk^k_lY:BWoFEUI00CooOgm0oono_hm
ooooo`04o`eE[_nVa^Ko^M?^ogV^j`;oZmoo00CoKVi^okBd]?oPh>3ok>c/
Foo^k^h01_lJ4QCo6PT:oa4V5?lJ2@[o4A`:oaX92P;o4A`:0_lJ2@X01Ol9
4P[o4A`:oaX92_lJ2@[o;18000;o4A`:00Oo6PT:oa4L2_lA70[o6PT:ob`B
0?lA70[o;18000?o6PT:00Ko;180oaX92_lJ2@[o6PT:oa4L2_lJ2@X3ob<L
2P09ob`B0?l/71Co6PT:ob`B0?lJ4QCo;180ob<L2_lJ2@[o6Q8D00;o2A8:
00Go2@T:o`TB2_lJ4QCo2@TDoa4V5002oaXB5003o`T92_ldECgoNhf400;o
UIRS00CoCeiVog:=Q?m?LW_oPhf40_m6Ie`04?n3V:goUJZ]oh>H[Ol0003o
2A8:oaXL7_m6EE;o0000o`TL5?l92ACo2@T:oba<:OlJ71ko2A8:o`T92_l9
2A@3o`TB2P03oaXB5?l94P[o2A8:00;o6Q8D01Co2@TDoa4L2_lA9Qko8blc
ob`h:OlA70[o6Q8Do`TB2_l/4P3o`K>]ol5kNooL_[OokOKeooKooon`NfKo
YW9Bombc[Oo]m_GokNgZonBZV0;okNgZ01Kom_KeongfmOofm_GokNgZooK]
j_oLhmKo4BH:ojJZXombSCgo8blNo`TB2_lA9QCo2@TDob`L5?lS;akoAT`m
oiEbAon=SE;o4BHNoa4L2_mZIc?ob]310oo1al`01oo1al7oYZZSojJZXon`
/kOom_ooom?SmOofool00oo1al`02OnEXKOoSIR>oiFZ[Oo:_ZgokNgZojK7
h?lJ9QCoAT`mol6cSP02ol[@`@03ombn]ooooooom_oo00Gom_oo00GokOKe
onBZV?oCQ03odh@0onBZ0003om>40003onBZ0?oCQ03o^FL000?o/5D000Co
^FL0ok1<0?n`E@3o/5D00_n3@@000omb>1CoARH:ob`B0002oaX92P07oa4L
2_lJ2@[o2@T:oa4L2_l92ACo4A`:o`T92P02oa4L2P;o2@T:00Co2A8:o`T9
2_l94P[o2A8:0_l92@X01olA70[o2@T:o`TB2_lJ2@[o;180ob`L5?lm4PX0
0_mG70003_lm4P[oLRH0og8h5?mP;`[oARH:oeLL0?mb9P3o?A`:odHV2_n3
;`3oNd`:og8h5?mb9P3oARH:0omP;`X02?mG703oH2l:oeLL0?mP;aCoEa`0
odHV5?mG703oARHD0om69PX01?lm70[o;1`DocdB2_oChoEOonk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q0002onKViP04onCTi?oDe=CoNg]kom[JfP;o
h>3P00Koe=CDolS8b?o;bl_oc/k>om3@d?oBd]8<omGEe@1bookmooonoooo
n_koooGmoooCg^;o^lgIogjF/?mYRJooLiS<ogVSgon4/>ooS[_foiO1lonP
a^goZ/kXojoCkOnceo_o/=Kmok;EoOncfOoo^McookWOoonkg_oo]mgook[N
oonhg_oo^]kookSNoonjg_oo^=oook[Noonhgooo^]knokSOo_njg_ko^=on
ok[No_nhgoko^]knokSOo_njg_ko^=onok[No_nhgoko^]knokSOo_njg_ko
^=onok[No_nhgoko^]knokSOo_njg_ko^=onok[No_nhgoko^]knokSOo_nj
g_ko^=onok[No_nhgoko^]knokSOo_njg_ko^=onok[No_nhgoko^]knokSO
o_njg_ko^=onok[No_nhgoko^]knokSOo_njg_ko^=onok[No_nhgooo^]ko
okSNoonjg_oo^=kook[Noonhg_oo^]kookSNoonigOoo]mgook[Noonhg_oo
^MgookKLoongfooo]]Wook?Doon`d_ooZLkhoik8k_nG`n[oSkcUohB`gomk
YMOoLYO<ofN7^_n0V<Ko/lKWomCOloocnokoo_ohoocnlOoooo_ojNWY0ooZ
j^X01_o[jn_o<C4aofYZJ_oMgMgo820Pof1PH0?ok>c/00WoX:2Pobh^;_l_
;boo<S8boadM7Oo]kNgo/;2`o`000?o1`L401?oalO400onc/k?o0000ocTi
>@03oc/k>`03okZj^_obl_;ol_;b00?ol_;b00_oNGUio`h>3_mSHf?oHf=S
oeQHF?l0003oQHF5ooCdm?oemOGoBDU9ofe]K@07ooGem@03oc@d=?m_Kfoo
m_Kf00;om_Kf0_ohn?P01_ln?SkoO7aloo[jn_ojn_[o?ShnogalO0;ono_k
00?oX:2Poa/K6ookno/00_okno/01?oKfm_o5ADEogemOOokno/2ooclo0?o
oOgm0_ono_hkooooo`04oa5G[onS`^Co^=?_ogN^j`;oZ]oo00CoJVYZojj^
[_oHf=Soi>CTFooVi^H02olA70[o8a`:oaXB5?lS70[o6Q`Noa4V5?lJ4QCo
2@T:oaXB5?l92@[o8a`:00;o6PT:00Ko4A`:oaXB5?l/4P3o6PT:ob`B0?lJ
2@X2ob`B0005oaX92_l92@[o;180oa4L2_l/4P000olJ2@X01_l92@[o4A`:
oa4L2_lJ2@[o;180ob<L2P;o6PT:00co2@T:ob<L2_lJ2@[o4A`:oaX92_lS
70[o4A`:oa4V2_l94P[o2@T:oa4L2_l92@X2o`TB2P0Ao`T95?lJ4QCo4BH:
oaXV5?mZNfooUJZ]og:=Q?m6IecoJW^4og:=Q?m6Ieco?Ehmob=1?OmZNhCo
Y/OPoh>HS_l971@00_l94PX03?m6IecoCfMLo`000?lS;ako4BHDo`000?l/
>2Wo6RHDo`T92_l94P[o2@TDo`TB2P;o2@T:017o2A8:o`T92_l92ACo2@T:
o`T95?lA9QCo6Q`Noa4V7_lS@E;oEfMBoa4L2_lS70[o6Q8Do`T95?nEC2Wo
`K>]ombn]`02ooKoo`0NonC@c?nEGS?o`J64ongIc?oLhn3og;jgong]j_of
m_GokNgZooKfmOofooookOKeong]j_ooooooARl:ojJQV?n3NecoAUDYo`TL
5?lJ4QCo4A`:oa4V5?l/9QCo8a`:oeMWD_mbSCgoH44Yohf=Koo1al7o/;k1
0_o1al`2ol77`@03ok2c]oo1al7oYZZ]00;okOKe013ob]3FoiFHXon`_/7o
`LO1ol77c?nV/l7oi=3<oiFZ[OmGSHko;5hmodI<?OlJ9QCo2A8:oiFQS_o:
d<7og>?P1?ofool2ooooo`03ooKoooo:XCgodh@000;odh@00ooTZP02om>4
0005onBZ0?oCQ03odh@0om>40?niI`000on`E@001_o1Q03oYT`0oh=10?nE
E@3oARH:ob<L2P;o4A`:00Oo6PT:o`T92_lA70[o4A`:oaX92_l92@[o4A`:
00;o2@T:01Wo2A8:o`T92_l92ACo4A`:o`T92_l94P[o2@T:oa4L2_l92@[o
4A`:o`T92_lA70[o6Q8Dob`B0?m69P[oLRH0of0_5?m69QCoH2l:og8V0?n3
;`3oH2lDof0_2_mb9P3oEa`000;oH2l:00GoPbl0odHV2_mG703oARH:of0_
5003of0_2P0>oeLL0?mP;aCoARH:oeLL0?m69P[oEa`0odH_2_lm4P[o?A`:
ob`V5?lm70[oAT4Noh=N5?o:d=IOonKViP04oifMWOng]kOob<S8om?Cd`7o
f][J0002onk^kP04onc/k?oLg=coO7alom[JfP;oh>3P00Koe=CDolS8b?o<
c<coc/k>om3@d?oBd]8<omCDe01booonnOoooo_onoonooGlooo?fnWo_<kV
of9lWOmZRkKoK9K8og6Pe_ml[NGoQkKZohnkj_nG_^OoXL?VojG8j?nVcNko
YLg`ojK<l?nWco;o[=?dojkGmon`eoSo[mShojoFmOn^eoGo[mKeojkGmOn_
e_?o[]OcojoFlon^eo?o[mKcojkGlon_e_?o[]OcojoFlon^eo?o[mKcojkG
lon_e_?o[]OcojoFlon^eo?o[mKcojkGlon_e_?o[]OcojoFlon^eo?o[mKc
ojkGlon_e_?o[]OcojoFlon^eo?o[mKcojkGlon_e_?o[]OcojoFlon^eo?o
[mKcojkGlon_e_?o[]OcojoFlon^eo?o[mKcojkGlon_e_?o[]OcojoFlon^
eo?o[mKcojkGlon_e_?o[]OcojoFlon^eo?o[mKeojkGmOn_e_Go[]OeojoF
mOn^eoGo[mKeojkGmOn^eOCo[MKdojkEm?n/eO?o[=?boj[ClOnYd>ooZ<kb
ojO:m?nVb?GoX<G_oiK0j?n?_>GoR;OSogf]gOmdX]KoJiC:ofF9_OmUPZko
]/[[om;Ol_ocnokoo_ohoo_kkooooo_ojNWY1?oZj^X01Ola<C7o0P82o`00
0?l0003o/K6a00Cojn_[00Sok>c/on[Zj_n8R8So7QhNong]kOo;bl_o0000
ohN7Q`?ol?3`00SolO7aolk>c_l0003oXZ:RolC4a?nl_;co0P82omWIf@Go
l_;b00_oe]KFo`820_oBd];om?CdoiJFU_l410Coh>3PooGemOofm_KoBTY:
ofe]K@07ooKfmP03oc@d=?m`L73omoOg00ComoOg00Ko?Shnog]kNoohn?So
n?Shochn?_mJFUX2ooWin@03oiVIVOlL71conOWi00?onOWi00?o`L71o`P8
2?nQXJ400_ojn_X3ooclo0;oo_kn>oooool01?lAEjooYLCVokWCkomg[^/2
ojWLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^0olS70X01olA70[o6Q8DoaXL
7_l92@[o4A`:o`T92_lA70X00_lJ2@X01_l94P[o?Blmob`B0?l/4P3o4A`:
ob`B00;o6PT:00Ko8a`:oa4L2_l92@[o;180oaX92_l92@X2ob`B0006oa4L
2_l/4P3o6PT:oaX92_l/4P3o6PT:0_l/4P000olA70[o;180ob`B0002ob`B
000ZoaX92_lA70[o6Q8Dob`B0?l92@[o2A8:o`T92_lA70[o2A8:oa4L2_l9
4P[o4A`:oc@_<omZNfooLXf4oc@_<om6IecoEfMBodIWG?m6C3go2A`Doa4V
5?nEV:?o`LO<oh>HS_lA9P[o0000o`TB2_lm;cgoUJZ]odmWG?l0003o8blN
oa4V2_l92ACo;4`Yob<_:Ol92@[o2A8:o`T92_l92ACo4A`:0_l94PX05_l9
2@[o4A`:o`T92_lJ9QCo4Blcob<_<olA;c?oAVMLoh>H[Ol92@[o8blNo`TL
5?l94P[oEa`0ol6QQ?o:_ZgokOKeooKooooooooo/7]Vol6QQ?o1al`2onC@
c004ongIc?o]m_Gom^gZongfm@?om_Ke00Gooooook24NomkSFKoSHe_odmW
A`02o`TB2P06oa4L2_lA9QCo6Q8DoaXV5?lA70[oH5hc0_n`/kL06_n`_/7o
`LO<ol[@`Oo1al7o/;>gojJZ[OnVV8Co/;>gol[@e_o]kN[ooooool77`On`
_/7odmWFoh>H[OmkSHCoCfMLol77`Oo1alcoLUEBojJQV?nEZZgoUJ6>odI1
7_l0003oAT`m0_ofool01oo]m_Gom_oooooooooooooodn?eonBc:OoTZP00
0ooCQ002onBZ0004om>40?oTZP3o^FL0onBZ00;odh@000Ko^FL0om>40?ni
I`3o`H@0ok1<0?niI`02ol640006oiEE0?mb9P3o?A`:ob`B0?lJ2@[o2A8:
0olA70X2o`T92P07oa4L2_l94P[o2@T:o`T92_lA70[o2@T:o`TB2P04o`T9
2P0<o`TB2_l92@[o2@T:o`000?lS70[o;180ob`L5?mG703oH2l:oeLL0?mb
9P3oH2l:0_mb9P02of0_2P06oh<_0?mP;`[oARH:of0_5?mb9P3o;1`D0_mG
70001_m69P[oH2l:oeLL0?mP;`[oEa`0of0_2P?oARH:00Go8a`:odHV5?lm
70[o?A8:oiik<`02oij=<`03ojK7h?o^k^kok^k^05gok^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN4000;ooooo00cooOgmonc/k?mkNg_ofMWIomoOgooQ
hN7oe=CDolO7aoo<c<coc/k>om3@d?oEeMD<omCDe00AooonkoooooCoo_om
ooOkoooAg?;o_M3`odUTSomTR;SoHY32ofRLc_meZMWoO[;QohNfh_n@^^Co
VkkVoj73jOnNa>P00_nMaNP01OnOan[oX/_[ojC=kOnVcnooYm3`00CoY/o]
=?nVcn/8ojK?k@;oYm3^01SoY/o]ojC=jonRbnWoX<WWoik7iOnNaNKoWl;Z
oik0kOnI_^[oSk[TohRghon0/n;oMZ[LoffOe?mST<WoH8Rloda[VOngc_3o
d]obooGjo_ooooSoo?c`oooonooZj^X3on_[j`07onc/k?la<C7oKVi^om;B
d_n>SXko1`L7oj^[Z`02onc/k005ojJVY_o:b/[oj^[ZoeYJF_m>CTh00_o]
kNd01Olj>S[o92@Tok:b/_o^k^kod=3@00;okno_00Go>c/kofATI?oXj>So
U9BDobPX:006oo3`l006oo7alOm5ADGoLW9boo;bl_le=CGoCdm?0_odm?@0
1Oo_knooATI6ofQXJ?oZj^[olO7a00GomOGe00?o=3@dofm_Koofm_H00_of
m_H2ooOgm`0:ocdm?OmkNg_on?ShooShn?ln?Sko4a<Cog=cLooHf=SoE5AD
od];B`;onOWi0oo^k^h01?nHV9So1PH6ol71`Oojn_X3ooclo0;oo_kn>ooo
ool01?l=E[7oY<CVokWCkomf[NX2oj_Po`04ogIfM_o1`L7ol?3`oogmoE_o
oooo01So6RHDoa4L2_lA70[o6Q8Do`T95?lJ2@[o4A`:oaX92_lA70[o6PT:
o`T92_lA70[o8a`:oaX92_l/4P3o6Q8Dob<L2_lJ2@[o;180oa4L2_l92@[o
;180o`T92_lS70X2ob`B0009oa4L2_l92@[o;180o`T92_lA70[o2@T:oaX9
2_l/4P3o8a`:00;o6PT:00Oo6Q8DoaX92_l92@[o6PT:ob<L2_l/4P3o2@T:
00;o4A`:00co2A8:oa4L2_l94P[o2@T:oaXV5?lS;bWoJW]_odmWAolmGSgo
8blNoba<:Om6C3d2ob<_7P05o`TB2_l/71CoUJ6>ojJc`On=V8h00_l00000
3Ol94P[o4BHDoiFZ[OnV/l7oJW]_o`000?l/C2Wo8blNo`000?m6C3go4BHD
o`TB2_l92@X01_l94PX05Ol92ACo4BHDoaXL7_ldECgo8blYodINAon3Q8ko
Ehf>oc@_7_lS9P[o6RHDoaXB5?l/71CoWXAVol6c[OoL_[OokOKeooKooooL
_[OoYZZSonC7`@02onC@c00IongfmOofooookNgZooKfmOo]m_Gom_Keongf
mOofoooog;jgoh=kG?n=V8koCfM7ob`h:OlA70[o6Q8Do`T95?lJ2@[o4BHD
oa4L2_m6C3gob]31ol77c?o1al7o`LO<ok2c]`02ojJZ[@0>ojJQV?nVZZgo
`LO1ong]j_o]m_Godn?eol[@`Oo1/jgog>?Pol77`OnEXHkoYZZ]ok2c]ooC
hoD2ongfm@05ong]j_oLhn3og>?Pol6c[OnVZZd01?o]m_D00ooLhn3oUK?<
onBZV004onBZ0003om>40?oTZP3oi:X000;oi:X000?og:XconBZ0?oCQ000
0_oCQ003okUW0009ok1E0?o1Q03o^FL0ok1b0?nEE@3oH2l:oeLL0?lS9P[o
4A`:00;o6PT:00?o2A8:oaX92_lA70X00_l92@X01ol/4P3o2@TDo`T92_l9
2@[o4A`:o`T92_lA70X00_l92@X00olA70[o2@T:o`TB2P02o`TB2P07oaX9
2_lm70[o?A8:og8V0?mP;`[oEa`0og8h5002og8V0005of0_2_mb9P3oPbl0
og8V0?lm4PX00_mb9P001olm4P[oARH:ocdB2_mb9P3oH2l:oeLL0?mP;`X0
1Om69PX01Olm70[oARHDob`B0?mP@BWoYZ5V00;oSHe700?oJVLcol[@e_oo
ool0G_ooool01?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h03?o/k>co
g=cLog]kNooIfMWogmoOon7QhOoDe=Coa/K6olc<c?o>c/kod=3@omCDe0co
eMGE01SooooWooookooooo_on?coomSQo_o0dogo>eZ9oeR0]?mJS;ooH9S7
offVdomh[][oPK;MohZeh_nF^>KoV[cYoiNnionF`>KoUl7WoiS2j?nIa>Oo
V/GXoic7j_nMb>/4oic7j@CoW<OW>?nLanT3oig8jP0Goic7jOnKa^SoVLCV
oiS3iOnI`NGoV[_ToiVjionB^NCoRKCQoh2ch_mi[^3oKZGMofNKeOmJRlGo
Eh2foceMS?njdO?oeN;eooGjo_ooooSoooocoooonooZj^X00oo[jn/00oo/
k>co<C4aofi^KP02onc/k009od=3@om<C4cok>c/onc/k?moOgoo;Rh^o`h>
3_ld=3Co][Jf00;okNg]00Gof=SHoe5ADOl>3Pko2PX:ob<S8`02ono_k`05
omSHf?m2@T;o30`<oaXJ6_n/[:`01_o`l?001_oalO7oYJFUoaHF5_o3`l?o
0000ojn_[`;om?Cd00GoNWYjo`L71ol;2`_o6ATIojNWY`05ooGem@03oc@d
=?m_Kfoom_Kf00;om_Kf0_ohn?P03?mADE7oRHV9ooWinOoinOWoDU9BohR8
R?mfMWKo4a<Cobd];Oo0`<3on_[jooGem@Go6QXJ00GoMgMgoo_knoolo?co
o?cloogmo@02ooknoS_ooooo00Co3EF^ojG4i_ned>koNJk/0_nWg?l01?m^
KVko];Bdon3Ph?o/k>aKonk^kP09oaXB5?lJ2@[oARHDob`L5?lJ4QCo4A`:
o`T92_lA70[o6PT:00;o4A`:00Go;180oa4L2_l/4P3o6PT:ob<L2P02oaX9
2P05ob<L2_lJ2@[o;180oaX92_l94PX00_l/4P003?lA70[o;180ocdB2_lJ
2@[o;180oa4L2_l/4P3o4A`:oaX92_lS70[o6PT:ob<L2P;o;18000?o6Q8D
ob<L2_lJ2@X00_lA70X03?l92@[o6PT:oa4L2_l94P[o2@T:odI<?OmZLUco
=5Dmoa4V2_l92@[o4BHDoba<:@;o;3PY01Co6RHDo`T92_n3Q8koUJ6>ojJc
`Om?IdOo4BH:oa4V5?l92ACo8blNoh>HS_nV/l7o/;k1og^=I_l0003o;4`Y
ob<_7_lA9QkoJXeLo`0000Co2A8:00Ko4A`:o`T95?lJ4QCo2@TDo`TB2_ld
EBT2ob=1?@0?odIED_mPLW_o/;>gobaEG?n`/kOo0000ob<_7_lJ9QCo4A`:
oh=N<onVQ8Cog;jgongfmOo]kN[oi=3<00;og;jg1oo]m_D2ooKfm@0?ooKo
oooTd<co=5DYoh>=Q?nEXHkoAUDYoa4V2_lA9QCo2A8:oa4V5?l92ACo2A8:
of1N<oo1alco`LO100;oYZZ]01;oYZZSol77`OnVZZgo/;k1ojJQV?o]kN[o
m_ooongfmOofoooob]31olZn[Oo]kN[om_oook2n`Oo1al7ob]3Fol[@`OoC
fMH2ong]jP0;om?SmOo]kN[odn?eongfmOoChoGokOKeooKoooo]aecoUEhc
oh>4Nooo/`000_oTZP002Oof/`3oi:X0onBZ0?oTZP3om[<0onBZ0?of/`3o
dh@0onBZ0004om>40005okUW0?oCQ03o`H@0okUW0?oCQ0000_nEE@000omb
9P3oARH:ocdL2P02ob`B0003oa4L2_lJ2@[o4A`:00;o2@T:00Ko4A`:oaX9
2_l92@[o4A`:o`T92_l94PX4o`T92P0:o`TB2_l92@[o4A`:o`TB2_l92@[o
8a`:ocdL2_m69QCoH2l:of0_50?oLRH000[oLSPDoeLL0?mb9P3oLRH0of0_
5?mb>1CoLRH0of0_5?mP;`[oLRH00om69PX00omP;`[oARH:ocdL2P02odHV
2P0;ob`V5?m69P[oARH:of115?nNLS?oSHeBoh=k<omZIc?oH5hcodH_2_o:
d=H0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H03?oTi>Co
e=CDogalO?oJf][ogmoOon7QhOoDe=Coa/K6olc<c?o>c/kod=3@om?Cd`co
eMGE01?ooooVooook?oooo_on_coon?/ooo5f?oo?UjAodQcZ?mDR;[oFI?3
of>Pc?m^ZM?oMj[Goh2/fon:[^3oTK?Soi6fhonB^NCoU;[W00;oUKcW00Ko
UKcUoiJmj?nG_^OoUKcUoiFlhonE_>D2oiFlh`04oiFmhOnE_>?oUKcSoiFl
hc3oUKcU00ooUKcSoiFliOnE_>?oUKcUoiFlhonE_>GoUKcSoiFliOnF_NCo
UkkWoiNniOnH_nSoUkkUoiNnionH_NL00_nB/mh04?n:/=goP:cKogNYf_m_
Y]coIIgFoebBc_m?PKcoBWF/ocaNRonoeoWog^_looKkooooooSoooodoooo
nooZj^X3on_[j`03onc/k?la<C7oKVi^00;ok>c/00?o<C4aodi>C_o/k>`0
0_o/k>`00oo]kNgojn_[ong]k@03ong]k@;ok^k^00?okno_onc/k?o_knl0
0_o_knl2oo3`l003ong]kOo`l?3ol?3`00Kol?3`00KolO7aong]kOlF5QKo
9bLWoa/K6oodm?@2ooGem@03ooKfm_m:BT[oKFe]00Oom_Kf00?o=3@dog1`
L?ogmoL00_ohn?P3ooWin@?on_[j0_okno/00oolo?cono_kooclo00:oocl
o0;ooOgm00?oo_knooooooooool0>oooool01?l=E[7oY<CVokSBk_mf[NX2
ojcOo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV0_lS70X2ob`L5007oa4L2_l9
4P[o2A8:o`TB2_l/71Co4A`:oaX92P02ob<L2P0AoaX92_lS70[o8a`:oa4L
2_l/4P3o4A`:ob`B0?lJ2@[o4A`:ob`B0?lA70[o8a`:oaX92_lS70[o2@T:
oa4L2_l92@X00olJ2@X02?l/4P3o8a`:oaX92_lA70[o8a`:oaX92_l/4P3o
6PT:0_l/4P03oa4L2P04oaXB5?l0003oCfM7oeN=G0;o000000Co4A`:oaX9
2_lA9QCo6Q8D0_l/C2T04ol94P[oUIRSol77`OnVZZgoJW]_oa4V2_lS;ako
;2HDog9WD_n3V8koUJ6goiFZ[OnVan3oJXeLo`000?ldEBWo4BHNofYbG?mG
SE`00_l94PX00ol0003o2A8:oa4L2P02o`TB2P0Ko`TL5?l92@[oCfM7oa4_
<olS;bWo=5DmoeMNKon3V:goPhB>of1bNonV/l7oAUDYoa4V2_lS;ako6Q8D
odI17_nVLU;o`LO1ongIc?o]kN[oi=3<ombn]ooTd<cokOKeong]j_o]m_Go
m^gZ00?okNgZ0_o]m_D02?oooooob[j]odIE:Oo1al7oYZZSocAE:Ol94P[o
4BHD0_lJ4Q@00olA9QCo6Q8Doa4L2P02ojJZ[@;o/;>g00Ko/;k1ol77c?n`
/kOo`LO1ok2c]ooChoD3ong]jP0;ongfmOoLhmKoYZZ]ooKoooo]m_GoYZ6H
ol[@e_o:d<7og>?Pom?SmOo]kNX01_o]m_D01Oo]fLcobZY7ojJZXooL_Zgo
m[<000Coi:X000Codh@0ooJc0?of/`3odiP:1OoTZP001?oCQ03o^FL0om>4
0?niI`02ok1<0009okUW0?mkC1CoSED:ojI<0?n3;`3oEa`0ocdL2_lA70[o
6PT:00;o4A`:00Co2@T:o`T95?l94P[o8a`:0ol92@X03Ol94P[o2@T:oa4L
2_l92@[o4A`:o`T92_lA70[o2@TDo`T92_lA70[o6Q8Dob`B0?m69PX00omb
9P000omP;`[oLRH0og8V0002of0_2P0:og8h5?mb9P3oLRH0og8V0?mb>1Co
H2lDog8V0?mP;`[oARHDoeLL00;oARH:00Ko?A`:odHV2_lm70[oEa`0of11
5?n3GS<2oh=k<`06ofYW<omPGS?oAT4Nob`h:Ol0003odmWFGooVi^H01?nM
WIgo]kNgolS8b?oCdm<1om[JfP000_o^k^h03?o/k>cog=cLogalO?oIfMWo
h>3Pon7QhOoEeMGob<S8ol_;boo>c/kod=3@om?Cd`coe=CD01_ooooXooom
kOoooo[on_goonkhooo8foooBFVHoc]VVOm7O;3oBhNkoeRDa_mSWLgoKJ3?
ogNSd_n1YMOoR:WLohVZgOn;[n7oSk?Woi:fj?nA]NOoTKGUoi6eionB]^Ko
TKGUoi6fhonA]ND00_nA]^<00onA]^;oTKKSoi6fh`0aoi6ei@0Qoi6fhonA
]NGoTKKSoi6eiOnA]^?oTKGUoi6fhon@]>CoT;GRoi6eiOnA]^?oTKGUoi2e
h_n?/n?oTK?QohZ[e_n9Z]GoP:KCogBSdOm/WmCoI9_CoeNBc?m?QlCo@gNa
ocYXW?m4Ii7ob>7oon[gooojoOooooojoooom_oooo_ojNWY00Coj^[Z00Ko
<C4aob/[:omBDU;o820Po`/;2onc/k<6on_[j`?ok>c/0_o]kNd3onk^kP[o
kno_0oo`l?02oo7al@03og=cLol0003oMgMg00?om?Cd00?omOGeomOGeooF
e]H01oofm_H00old=3CoL71`ooOgm`02ooOgm`;on?Sh00?oF5QHohj>S_oi
nOT00ooinOT;oo[jnP;ono_k0_olo?`00oomoOgoo_knooknoP0kooooo`04
o`mF[_nVa^Ko]]3^ogV_kP;oZmko00CoKVi^okBd]?oPh>3ok>c/Foo^k^h0
2Ol/71Co8a`:oa4L2_lS70[o2@T:o`TB2_lA70[o2@T:oa4L2P02oaX92P08
ob`B0?lA70[o8a`:oaX92_l/4P3o6PT:o`TB2_lJ2@X2ob<L2P0:ob`B0?l9
2@[o;180oaX92_l/4P3o8a`:o`T92_lA70[o;180oa4L2P;o;18000So4A`:
ob`B0?lS70[o6PT:ob`B0?l92@[o6PT:o`T92P;o8a`:00[o4A`:ob`B0?l9
71Co4A`:og9ED_lmGSgo2A8:o`T92_l94P[o2@TD0_lA70X05_l94P[o6Q`N
ob`L5?l/GSgo`LO<oiFQS_mZNfooAT4Noc@_7_m6C3goPhf4oiFZ[OnEXKOo
/;>gok2n`OoLhn3oCfM7o`000?m6EBWo?Ehmoh>4NolmGSd2o`TB2P0Loa4L
2_l92ACo2A8:oa4L2_l92ACo0000oba<:Om6EE;o;4`Yoa4V5?m?GVKoNhf4
ojJc`Om?IecoY[?1oiFQ]omkSFKo4BHDob`V5?lJ71ko=2lYof11:OnEQ7_o
kMW<onC@c?o]m_GokMW<omcSh0?okNgZ00?odn?eong]j_o]kNX00_o]kNX0
2Oofm_Gom_ooog9WD_mZNfoo/;k1ohfHS_mGIe;o4BH:o`TL5003oa4V500I
oaXB5?l92@[oNhf4ojJZXoo1al7o/;>gok2n`Oo:d<7o`LO<ol[@`Oo]kN[o
g>?Pom?Ie_ofooookNgZongfmOofoooog>?FojJZXoofooGoYZZ]ol77`Oo:
d=KodmWFomcSh003ongfm@0CooKoooo]m_GoooooooKomOoT/dOoUJZ]ong@
V?oTZP3om/L:onBZ0?of/`3oi:X0ooJc0?oCQ03om/L:onBZ0?ofacgoi;<Y
ooJc0002onBZ00Kodh@001?o^FL0ok1<0?n3GQCoPbl0ok1<0?n3@@3oLRH0
odHV2_l/71Co2@T:oaX92_lJ4QCo4A`:o`T92_lJ2@[o8a`:o`T92_lA70[o
2@T:00;o2A8:1?l92@X3o`TB2P08o`T92_lS70[o?A`:odHV5?mb9P3oH2l:
of0_5?mb9P02of0_2P06og8V0?mb>1CoPbl0og8V0?mP;`[oPbl00_mP;`X0
1?mb9P3oEa`0oeLL0?mP;`X2odHV2P05ocdL2_m69QCoLSPDoh=k<on=SDL0
0_n3Nc<01omZIc?oH5hcoc@_7_lA9QkoARH:oiEE0?o:d=H0Goo^k^h01?nS
Xj?o_Kfmolo?cooJf]X1on7Qh@000_ooool03?omoOgok>c/ogalO?oIfMWo
h>3Pon7QhOoEeMGoalO7ol[:b_o>c/kod=3@om?Cd`coe=CD01Koook_oook
l?oooo[ooOkoooGoooo:gocoDW>Loc9NSOlkKZ?o@WZcodj9`OmKU<_oIYS;
og6Mc?mmXm3oQJOEoh:Rdon8Z=_oSZkQoi6ai?nA/N;oT;3Q0_nA/N84oi:b
h@?oT[?P00?oT[;Qoi:bhonB/^<0;_nB/^<:oi:bh@0Hoi6ah?n?[mkoSJgL
oh^[f_n8Z=OoQjSEoh>Tcon1Y<koMj3<ofbJbomTUlkoFi;;oe28aOm6O[Wo
?6nXoc=OT?m<KYCocnOoooCooooloooooo_gooonn?oooogojNWY0ooZj^X0
1_o[jn_oXZ:Rohf=SOn>SXko[Jf]onKViPCok>c/1_o]kNd2onk^kPGokno_
2oo`l?02oo7al@03om[Jf_nBTY;ogMgM00?om_Kf2_ogmoL00on[Zj_o`/;2
ooShn002ooShn0;onOWi00?o[jn_olS8b?oinOT00ooinOT;oo[jnP;ono_k
0_olo?`00oomoOgoo_knooknoP0kooooo`04o`aC[_nT`nGo^=;_ogV^k0;o
[=oo00CoMWIfol71`Oo`l?3ooOgmFoooool05ol/71Co8a`:ob<L2_lJ4QCo
2@T:oa4L2_l92@[o6Q8Do`T92_lS9P[o;180oaX92_lS70[o6PT:ob<L2_lJ
2@[o;180oa4L2_lJ2@[o;180oaX92_lS70[o2@T:00;o8a`:00Wo6PT:ob<L
2_l/4P3o6PT:ob<L2_l/4P3o2@T:ob<L2_l/4P000_lJ2@X00ol/71Co;180
oaX92P02ob`B00;o6PT:00?o8a`:oa4L2_l/71@00_m?IdL02Ol0003o4A`:
oa4L2_lA70[o6Q8Doa4L2_l971Co4BH:oaXB5002ob<_7P08oh>4S_n3SHCo
JW]_oh>4Non3Q8koUJZ]oiFQ]onEZZd2ok2c]`04ok2n`OoChoGo4BH:oa4V
2P;oCfML00CoSIR>oba<:Ol0003o4A`:0_l92@X04?lA70[o2@T:o`T92_lJ
71koYZ6Hocd_?Ol/C2Wo2A8:oh>=Q?nEV:?oUJZ]of1bNoo1alcob]3Fo`TL
7_l/9Q@2odI17P09og8h5?ld;bWoH2lDomcSe_ofkN[om_ooong]j_o]fLco
i=3<00;og>?P00koi=3<omcSh?oTd<coi=3<ongIc?oLhn3om_Keo`000?n3
SHCo/;k1oiFZ[OldECgo4A`:o`TL50;o6Q8D00So6RHDoa4L2_l92@[oSHe_
ok2n`OnEV:?o/;k1omcSh0;ob]3F00_odn?eol[@e_o:d=Kob]31om?SmOof
ooookOKeom?SmOoooooob]31ojJZX`02ok2c]`03ol[@`Oo]kN[okNgZ00;o
kOKe1?ofool01_oTal7ob]31onC7`Oof/`3oi:X0ooK72P;om[<00ooTZP00
1_oT/bWom/LNonBZ0?of/`3oi:X0om>400;oi:X01?oCQ0003?niI`3o`H@0
ok1<0?n3>03o^FL0ok1E0?nVC03oPd40og8V0?lS9P[o;180oa4L2P;o2@T:
0_lA70X01?lJ2@[o4A`:o`TB2_lA70X2o`T92P03o`TB2_l92@[o2A8:00;o
2@T:00Ko6PT:oaXB5?l92@[o6PT:ob`B0?m69PX4og8V000:odHV2_mb9P3o
LRH0oh<_0?mb>1CoLRH0og8h5?mb9P3oEa`0of0_50;oH2l:00KoARHDodHV
2_lm70[o8a`:of115?mZEAh2oiik<`;oPg/c00SoAUDYof115?l971Co?A8:
oiiN5?nEE@3o2A8:om?SmEoooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_80
00;ok^k^00cok>c/omcLg?mkNg_of][JomoOgooQhN7oeMGEolK6a_o:b/[o
c/k>om3@d?oCdm<<omCDe00Coooln?oon??oookkooWjo?oeoooohOKoognN
^olXDW[o?FbRob]QWOlmM;CoGiGCofVJd_mlZ=OoR:oFoi>efonD/mooVkOV
oifjiP02oibii@03oijkionO_>KoW[_U00;oW[_U1_nN^n<00onN^nGoW[_W
oijki`0/oijki`03oijkiOnN^n?oW[_S00KoW[_S00GoWK[Roj6ni_nQ_^Ko
W[_SoifjhP02oijkh`0CoiZjhOn>[mSoWL;/ogVRd?miYMKoLjCLod]o^Om1
Mk?o=6RQob1?PoleGhWoKXn`ongoooogoooolO;fooonnoolm?7oooomon_[
j`03ong]k@[ok^k^1oo_knl6oo3`l0_olO7a0oobl_82ooCdm0?om_Kf2_og
moL=ooShn0_onOWi0_ojn_X3ooclo0;oo_kn>oooool01?l?EZkoYLCVokKB
k_mi[^T2oj[Po`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00?o;1`Dob<L2_lS
70X00_lS70X3oa4L2P03ob<L2_l/4P3o8a`:00;o8a`:0_l/4P001OlJ2@[o
8a`:oaX92_l/4P3o6PT:00;o;18000co2@T:ob<L2_lS70[o8a`:ob`B0?lJ
2@[o4A`:ob`B0?lJ2@[o;180ob<L2_lJ2@X2ob`B0005ob`V5?lJ2@[o;180
ob`B0?lJ2@X00_lS70X03?l/4P3o4A`:ob<_7_ldEBWo0000oaX92_lA70[o
2@TDoa4L2_lA9QCo4A`:oaX92P;o2A8:02Wo6RHDocAE?OlS@CgoUJZ]ol77
c?nE/lcoYZZSok2c]onEXKOoUJZ]ok2c]on`_/7o`LO<om?SmOl0003o4BH:
og^=Q?mZLUcoYZZSo`000?l971Co2A8:oa4L2_lA9QCo4A`:o`T92_lJ9QCo
UJZ]ocAE?OlmGSgo4A`:ocd_?OnEV:?oY[?1oh>HS_o1alcoY[?1oiFQS_l0
003oUIRSojJZ[@02ojJQV0;oUHAk00Wob[j]omcSh?ofkN[oi=3<omcSe_o1
alcog>?Pom?Ie_o:d=H00oo1al`03?n`_/7oJW]_oa4V2_m6C3gob]3FojJc
`OnEXKOo8blYoa4V5?lJ71ko4A`:oaXV50;o8blN00go4BHDodINAolmGSgo
UJ6>ongfmOo:d=KodmWFongfmOo:d=KoUJZ]om?Ie_o:d<7okNgZ00?okOKe
00Kodn?eongfmOo]kN[oYZ6HojJHQ?nEZZd4ongfm@Com_oo00Oo`LO<omcS
e_ofaakom[<0onBZ0?of/`3oi:X000;om[<00_oTZP000oof/`3om/LNonBZ
0002onBZ0003om>40?oTZP3odh@000Kodh@000?o^FL0ojI<0?niI`000_n`
E@001OnVC03oPcP0ocdL2_lS70[o6PT:00;o4A`:00?o2@T:oaX92_lS70X0
0_l92@X00ol94P[o2@T:oa4L2P02o`TB2P0=o`T92_l94P[o4A`:o`T95?l9
4P[o4A`:oaXB5?lS70[oEa`0of0_2_mG703oH2l:of0_5002og8V000Log8h
5?mb9P3oLSPDoh<_0?mP;aCoLRH0of0_2_mG703oH2lDodHV2_mG703oARH:
odHV5?nNLQCoYXABohf=D_n3Nc?oLXdmofYE7_m6EBWo2A`DoaXB5?n=E@[o
WW8:oa4V5?l94P[o0000om?SmEook^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN4000;oi^KV00coi>CTomCDe?mgMgOof][Jon3Ph?oQhN7oe=CDolO7aoo<
c<coclo?om3@d?oCdm<<omKFeP0Cooognoooo?goookkoooooOofoooolOoo
ojG0dolSAfWo8DYnob9BT?m1L[GoCGk0ogJUgOnC_^_oWL?WoiRkfonWaNWo
[LW^ok3=k`02ojk;k@03ok3=kon`cNgo[lc/00;o//o_1_nbcnd00onbcnoo
//oaok;?l@05ok;?lASo[lc^3onbco400onbcnoo//o]ok;?k@06ok;?k@0J
ojk;jOnac^co/Lk/ojk;jOn]b^So[lcZojk;jOnZb>[oZL_aoiNli_nG`>ko
V<?fof6@b?m2LjgoBGZbob5@Q?lcGX_o94Q/ojk9i?oVnOoomOkoookoooom
moOooogkoooooOoYjNT6on[ZjPOojn_[0oo/k>`3ong]k@03ono_koo^k^ko
l?3`00;ol?3`0_oalO4;oo;blPColo?c1?odm?@:ooGem@?om_Kf0_ogmoL2
ooWin@04ooShn?ojn_[on_[joo[jnP;ono_k3Oolo?`2oogmo@03ookno_oo
oooooooo03_ooooo00Co3EF^ojK6i_nidnkoNJk[0_n[gol01?mZJV[o[Zj^
omSHf?oTi>AKonKViP;o8a`:00[o6PT:oa4L2_lJ2@[o8blYo`T92_l/71Co
8a`:ob`B0?ld;c?o;1800_lS70X03?lJ2@[o;180oaX92_l/4P3o8a`:ob`B
0?lJ2@[o8a`:o`TB2_l/4P3o8a`:ob`B00;o6PT:00?o;180oa4L2_lJ2@X0
0_lJ2@X01?l/4P3o8a`:oaX92_l/4P02oaX92P04ob<L2_lJ2@[o;180o`T9
2P;o4A`:00?o6PT:oaXV5?lA70X00_lA70X04?lJ4QCo6RHDoaXB5?lA70[o
4BHDoa4L2_lA9Qko8blYoeMWD_m6GTOo8d4moba<:OmPLW_oY[?1oiFQ]onE
ZZd2ofYkQ00:oiFQ]oo1alcokOKeo`000?lS;akoUHB>ofYkKonEZZgo0000
oa4V2P;o2A8:01?o2@TDo`TB2_l0003oSIR>og:=Q?n=SFoo6RHDo`000?mZ
NhCoY[?1om?Ie_n3Q8ko/;k1ol77c?l/GSgo6Q8Dol77c?n`_/7oY/OP00;o
`LO<00?ob]3Fog^=Q?mbLW/00_mZNh@00omPLW_oPiRgom?Sm@02ojK7h008
oiFcc?n3V;OoUK?<og:=[On3V;OoPiR]ol77c?nVan02om?Sm@04of1bNolA
9P[o8blYoa4L2P;o;3PY01OoAUDYoc@_:OlS70[o2@T:og9bNoo]m_Godn?e
om?Ie_o]m_Go;5hmofYbG?o1al7o`LO<omcSh?o]kN[okOKeooKoooo]kN[o
dmWFongfmOoLhmKoUHAkoiFQSP03ongfm@;om_oo0_ooool01OoChoGokMW<
ong7G?ofaakom/L:00?om[<000?oi:X0ooJc0?of/`000_oTZP02ooJc00;o
i:X000?om[<0om>40?oTZP001ooCQ0004_niI`3o`H@0ol640?o1Q03o/780
ojI<0?mG703o8bH:oaX92_lA70[o6PT:oa4L2_l92@[o;180oa4L2_l94P[o
2@T:o`TB2P?o2@T:00So4A`:o`T92_l92@[o2@T:o`TB2_l92@[o6PT:ob`B
00;oARH:00?oH2l:og8h5?mb9P000omb9P001?n3;`3oH2l:og8V0?mb9P02
of0_2P0EodHV2_mG703o?A`:odHV5?mb>1CoWXdcoh=k<omZIc?oWW8DofYW
<om6@Ako;2HDoaXL7_n3>03oWW8:of115?l94P[o6Q8DoaX92_l0003okOKe
05ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;ok^k^00Cok>c/omcL
g?mfMWKofMWI0_oOgml01_oDe=CoalO7ol[:b_o>c/kod=3@om?Cd`coemOG
01Gooo_oooolooooo?_oooojoo?jl_oeooooi?[oog2>Z?lXBWSo8TZ5obYF
UomAOKcoQ:oVoi_4l?nJ`N;oZloYojc:i?nccnOo]];XokC@i_nccnD00_ne
dNL00onccnGo]M7VokGAiP06okGBi0So]M7V6?ndd>D@okGAiPSo]M;T01[o
]=7SokKCiOnfdnGo]=7Sok?@h_nddN?o/m3Rojg=i?n[co?oX<OboiBmjonG
`O?oQK3Wod]f[OlRBgoo8DYhoae0I_mZRJKoi?[oooCoooo`moooookoooom
oookl_?oookoonSXj0Koj^[Z2_o[jn/3onc/k0;okNg]0oo^k^h:ono_k`?o
l?3`0ooalO400oobl_;olO7aoo;blP02oo;blP;olo?c2?odm?@3ooGem@;o
m_Kf0oohn?P3oo[jnP;ono_k3Oolo?`2oogmo@03ookno_oooooooooo03_o
oooo00Co4EN_oj?2i?nhdnooMjk[0_nZgol01?m^KVko];Bdon3Ph?o/k>aK
onk^kP?o8a`:00?o6PT:ob`B0?l/4P001OlS70X2oaX92P;o8a`:00?o;180
oaX92_lS70X00_lS70X00olA70[o;180oa4L2P02ob`B0003ob<L2_l/4P3o
6PT:00;o;18000Ko6PT:ob<L2_l/4P3o6Q8Dob`B0?lJ4Q@2oaX92P07ob<L
2_lJ2@[o;180ob<L2_l94P[o;180oaX92P02oa4L2P0OoaXL7_l92@[o4A`:
oaXB5?lJ9QCo4BH:oa4V5?l/71Co8blYof1N<oldECgo8blYob<_7_l0003o
2A`Dol[@e_n3Q8koAUEBoba<:Ol/>2WoAUi7ojJc`Oo:d=Kob]31o`000?m6
C3goUIRSoh>H[OnEXHko0000o`TB2P02o`T9500Boa4L2_l92@[o6Q8Dok2c
]om?IecoAUi7ob<_7_lJ71koLW9kojK7h?o:d=Ko/;k1oiFHXooLhn3o0000
oiFHXon`_/7oY[?10_o:d=H02_o1alcokOKeoa4_?OlA;c?o2BHYoaXL7_l/
EFooCg9kom?SmOofool2ojK7h0;oUK?<00?oUJ6goiFcc?nVan000_nE/l`2
ojK7h005om?SmOn3Q8ko?Ehmob`V5?ld;ah00_l/>2T03_m6EE;oYZ6HojJQ
V?nEV:?oY/OPol[@e_oLhn3oEhf>oa4V2_lA70[o/;>gok2n`OoLhn3odn?e
0oo]m_D04_oLhn3odn?eooooooo:d<7oUHAkol[@e_ofooookOKeom?SmOof
oooob]3Fol77c?ofoooom[<0ooo@0?o]_Sgom/L:onBZ00;om[<000Goi:X0
ooJc0?oTZP3oi:X0om>40002onBZ0007ooJc0?oTZP3odh@0onBZ0?oCQ03o
i:X0om>40002onBZ00;odh@000[oi:X0om>40?oCQ03odh@0ol640?n`E@3o
YT`0ofY12_lm70[o8a`:0_lJ2@X02_l92@[o4A`:oaX92_lJ4QCo2@T:oa4L
2_l94P[o6PT:o`T92_lA70X2o`T92P07oa4L2_l94P[o2@T:o`T92_lA70[o
6PT:ocdB2P02oh<_00CoLRH000[oPbl0og8h5?n3;`3oH2l:og8V0?m69P[o
H2l:ocdB2_l/4P3oLSP00_nNSC<04?n3Nc?oWXdYofYW<om6EBWo8blYoaXB
5?n3;`3oYVL0of115?lJ9QCo2A8:o`T95?lA70[o2@T:o`000?oChoEOonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002ooooo`0<oogmoOo]kNgoLW9b
omOGeooOgmooh>3Pom;Bd_o7alOob/[:olc<c?o@d=3odm?C3?oDe=@04ooo
o?ooo_Wooochmooooo[omo[aooSoo?odoooog?7ood5MP_l@<V;o6cmiociU
X?mJP[KoX/Wdoio6ionVb^CoZLWPojo>h_ncd^H00_nad>@2ok;Ai@03ojo>
h?n`cn7o/=3O00ko/=3O6?nadN0Hok3@g`03ok;BhOnde>?o]=CS00;o/];Q
01Go/m?Rok7Ah?nYc>3oY<[^oj?=monZdoooRk?Voeb4^?m2Ii_o9dUgoa8b
FOm6Hh7ojoooonknoooco_ooo?oooo_io?oonooooocoooonoooYjNT00ooZ
j^X3on_[j`Ook>c/1_o]kNd00oo^k^kokno_oo3`l004oo3`l0_olO7a0oob
l_82oo?cl`?om?Cd2_oemOD5ooKfmP;omoOg00?om_KfooOgmoogmoL00oog
moL;ooShn0;onOWi0ookno/2oogmoA7oo_kn:_ooool01?lAEjooYLCVokWC
komg[^/2ojWLo`04ogIfM_o1`L7ol?3`oogmoE_ooooo00Go8a`:ob`L5?lS
70[o8a`:oa4L2P02ob<L2P;o;1`D0olS70X0;ol/4P3o6PT:oa4L2_lS70[o
;180oaX92_lS70[o;180oaX92_l/4P3o6PT:oa4L2_lJ2@[o;180ob<V2_l/
4P3o6PT:oa4L2_lS70[o;2HDo`T92_lJ2@[o8a`:ob`B0?lJ2@[o;180o`T9
2_lJ2@[o8a`:oaX92_lS70[o6PT:oa4L2_lJ2@[o4A`:ob`B0?lA70[o2@T:
ob<_:OldEBWo2@T:oaXB5?ldEBWo?EhmoaXL7_lA9P[o6Q`N00;o8blY02;o
=2lcoh>HS_o1alcoPg]Loa4V2_m6EE;oPhB>ol77c?oChoGoNhf4oa4V2_m?
IecoYZZSok2n`OmZSEco0000oa4V2_l971Co6Q8Do`TB2_l0003oUJ6>ob<_
:On3SHCoAUDYodI<?Ol/>2Wo`LO<ol[@e_n3Q8koY[?1ol77c?n=V8ko0000
0oo1al`03?o:d=KoY/OPomcSh?oCfMKo2D57ob=1?OlA;c?o8blcodIED_ld
Ig_oY/OPooKoo`?oY/OP00KoUK?<ojK7h?nE/lcoY[?1ojK7h?nEXKL2ojK7
h0?odn?e013o=6MkofYbG?n3Q8koLW9kof1N<ombSHCoUJZ]ojJZXoo1alco
b]3Fol77`On=V8koAUDYo`000?n=V8ko/;k11?oLhn03ongfm@?okNgZ00So
PhAkooKoooofooookOKeooKooonEV:?oYZZ]onBcA`;om[<000?om/LmooJc
0?of/`001_of/`000ooTZP3om/L:ooJc0008onBZ000CooJc0?oCV0[oi:X0
om>40?oTZP3odh@0om>H2_oCQ03o`H@0ok1E0?mb>03oARl:ob<L2_lA70[o
6PT:oa4L2_l94P[o4A`:oaX92P02o`T92P05o`TB2_l0003o2@T:oaXL7_l9
4PX00_l92@X02Ol94P[o4A`:o`TB2_l92@[oH2lDoh<_0?mb9P3oLSPDof0_
2P02og8V000<og8h5?mb9P3oLRH0og8V0?mb>1CoARHDof0_2_m69QCoNd`:
ok24:Oo:XCgoSHe70_n3Nc<03omP@BWo;4`YoaXB5?n3;`3o/7/DoiEE5?l9
71Co2@TDo`T92_l94P[o6PT:o`TB2_lS70[o0000ongfm@1Oooooo`04ojn_
[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP04onc/k?oOgmooLG5aolo?c`;o
gMgM00KodM7AolC4a?o8b<Sobl_;olo?cooBd]8<omCDe00Booomooojn?go
ookoooonnooooo_on_ciongdn_odooook_ooob4kH?lUA7;o<UB4of>8]Omo
Y=3oT;?IoiFifonL_][oX/CM0onVb>400onXb^?oYlWRojG8gP03ojW<hPgo
ZLcP6?nWb]hHojW<h003ojO:g_nYc>3oZ<_O00;oYl[N01GoZ<_OojG8g?nN
`]coW<CXoiFnj_n<]N?oLiW:odi_X_lP?fko52mJoc]CMOoWnoooioOoooOo
oookooookNk`ooonooooo?oooo_oooonoooWinL01_oYjNT:on[ZjP?ojn_[
00?ok>c/ong]kOo^k^h00_o^k^h:ono_k`?ol?3`0ooalO42oo;blP?olo?c
0_odm?@8ooGem@Gom_Kf0_ohn?P00oogmoOonOWiooWin@03ooWin@_on_[j
0_okno/3ooclo0;ooOgm4Oono_hZooooo`04o`eF/OnTa>Ko^M?_ogJ]jP;o
Zn3o00CoKVi^okBd]?oPh>3ok>c/Foo^k^h00olJ9QCo;1`DocdL2P02ob<L
2P09oaX92_lS70[o8a`:ob`B0?lS70[o?A8:ob<L2_l/4P3o8a`:00;o;180
00Co6PT:ob<L2_l/4P3o4A`:0_l/4P001_l92@[o;180ob`B0?lS70[o;180
ob<L2P;o;18000Oo6PT:ob<L2_lS70[o;180oaX92_l/4P3o4A`:00;o6PT:
01go4A`:ob`B0?lJ2@[o8a`:ob`B0?lJ2@[o4A`:oaX92_lA70[o6PT:o`TB
2_lJ71ko6RHDoaXB5?lA9QCo6Q8DoaXV5?l92ACo2A`Doa4V2_l/>2Wo8blN
oa4V5?l971Co`LO1og^=I_lS;akoPhf4oiFHX`02ol[@eP;o4BH:00CoPhB>
ok2n`Oo1alco6RHD0_l94PX04ol92ACo6PT:o`T92_lS@CgoSIR>odmNI_mZ
SEco8d4modI<?OmZNhCokOKeoh>4S_n`_/7oUJZ]ojJZXolJ9QCoJW]_ol[@
e_o1al`00_o:d=H03Oo1alcog>?PoiFQ]olAC5;o;4`Yob<_<olS;bWo8d5B
ocd_?OnVan3om_ooom?SmOnE/l`00_nVan001_nE/lcoY/OPojK7h?nEXKOo
PiRgoiFcc0?oY/OP00Wodn?eoa5<D_mbSJgo`LO<ojK7h?mGSHko;5hmofYb
G?n`_/400_oCfMH04_o:d=Ko/;>gog^=Q?lA9P[o8blNojJQV?o:d=Kog>?F
omcSh?o]kN[odn?eongfmOofoooob]3Fong]j_oChoGog>?PojJ4Q0;ooooo
00Com_oooh>=Q?oLhn3ook<00_of/`001?ood3gom/L:onBc:OoTZP02ooJc
0005ooK72_oTZP3oi:X0om>40?ofa`X00_oTZP02ooJc00;oi:X000Gom[<0
onBZ0?oTZP3oi:X0ooJc0004onBZ00;odh@000Go`H@0ok1b0?n3@@3oEa`0
ob<V2P03oaX92P06oa4L2_lJ2@[o6PT:oa4L2_l92@[o2A8:0_lA70X2o`T9
2P09o`T95?lA70[o2@T:o`T95?lm4P[oPbl0og8V0?n3;`3oLRH000;oLSPD
0_mb9P000omP;`[oPbl0of0_2P02of0_2P05oeLL0?mP;`[oUEDDok2=D_nE
SE800_n3Nc<03On3GQCo;2HDoaXV5?n3;`3o/5D0oh=N5?lA9P[o2@T:o`TB
2_lJ4QCo4A`:oaX92_lJ4Q@00_lS70X00olJ2@[okOKeonk^kP1Nonk^kP04
oj>SXonm_Kgoclo?om[JfP7ohN7Q0002onKViP0:onGUiOoIfMWoN7Qhokno
_ooHf=Sof][Jolc<c?o1`L7oaLG5ol[:bP;oc/k>3?oDe=@01?onoooooooo
ooonooohm?<2ooomo`0?onc[lOoiooooh>goonkooolaC6[o6SQLoba=M_mA
M9koNig:oh^^f?n7Z]3oSK7Eoi>fg?nD^=coU[WO00;oV;cP00KoU[[LoiVm
gonI_MooVKgOoiVmgOnI_Ml2oiVmg@WoVKkK6?nH_MX?oiVnf`?oVKgM023o
VKgOoiVmgOnI_MooVKgMoiVmgonI_MgoU[[LoiNkfonF^]coUKWIoiJjg?nG
^m_oT[KHohV_domgXLWoSKSSof^A`?m1IIGo;D]mo`dXEOmCJI3ol?ooooCo
ooohoooonoooon_]j_oooogoookoonoXl?ooo?ooookoonOWi`KojNWY2_oZ
j^X4on_[j`Cok>c/2_o]kNd6onk^kP03oo3`l?o_knoolO7a00ColO7a2?ob
l_83oo?cl`;om?Cd0_oemOD01?ofm_KomoOgooOgmoogmoL2ooShn0_onOWi
0_ojn_X3oo_kn`;oo?cl4?omoOd3ooknoRSooooo00Co3EF^ojG4i_ned>ko
NJk/0_nWg?l01?mZJV[o[Zj^omSHf?oTi>AKonKViP05ocdL2_lS9P[o8bH:
ocdL2_lS70X00_l/4P000olJ2@[o?A`:oaX92P02ob`B000Job<L2_l/4P3o
8a`:oaX92_lS70[o6PT:ob<L2_l/4P3o6PT:ob<L2_l94P[o;180ob<L2_l/
4P3o8a`:ob`B0?lS70[o6PT:ob`B0?lJ2@[o;180oaX92_l/4P3o6PT:ob`B
0?lJ2@X2ob`B0008ob<L2_lJ2@[o6PT:oaX92_l/4P3o4A`:o`TB2_l92@X2
oa4L2P05oa4V2_lA70[o2A8:oa4V5?l94PX00_lA70X04?lJ2@[o4BHNoaXL
7_lA70[o2@T:ob`h:On=V8ko4A`:obaN?OnVZZgoUJ6gooKoool/C2Wo4BH:
odI<?On=V8h2ol77c00Doa4V2_l971Co4A`:oa4V5?l92@[o2A`DojJHQ?mP
LW_oPiR>odINAol/9QCoCeiVofYkQ?o]m_GoYZZ]oh>H[Oo1al7o8blNo`00
0?o1al`3ol[@eP0>ojK7h?o:d=Kom_KeoeN=S_lA;c?o8d4moa4_?Olm;cgo
8d5BobaEG?n3V;Oodn?eooKooonE/l`5ojK7h00GoiFcc?mbSJgoUK?<oiFc
c?nVan3odn?eojK7h?lJ71koUK?<om?SmOnE/lco2A`Do`TV:Old;c?o/;k1
ol77c?o:d=Ko`LO<om?Ie_o1al7oAUDYo`TB2_lS;ah00_o:d=H00ooLhn3o
dn?eong]jP03ongfm@;odmWF013okOKeomcSe_n`/kOom_ooojK7h?n=V8ko
JW]_ooo@?OnEQ5;oUHAkohf=KonEQ7_ob]3FooJc0?ofa`[oi:X00oof/`00
1?oCQ03om/LNooJc0?oTZP04ooJc0007ooK72_oTZP3om[<0onBZ0?of/`3o
i:X0ooJc0003onBZ00;odh@000Co^FL0oh<_0?m69P[o;1800_lA70X01?l9
2@[o4A`:oaX92_l/4P02oa4L2PCo2@T:00Go2A8:oa4L2_l92@[o2@T:ocdB
2P03og8V0005oh<_0?mb9P3oLRH0og8V0?mP;`X00omb9P006om69QCoH2l:
odHV5?nNGQCoWXdcoiF4D_n3Nc?oJUDNoh=N5?mZEAko8blNodHV2_n`E@3o
PehDob`V5?l0003o2@T:oaX92_l92ACo4A`:oaX92_lJ4QCo;180ob<L2_lm
70[o0000om?Sm@1OonKViP04oifMWOng]kOob<S8om?Cd`7of][J0002onk^
kP0<ong]kOoUiNGoTI6AojBTY?oBd];oe=CDol;2`_nh^;So`<30olC4a?o9
bLWobl_;3?o@d=005ooloogoo_ooooonoooiloOooo[ooookooooo?ooo_ko
ooSoooo]oOookOooof9nU_lZB6[o5CIQobm?P?llGI;oEgZ`oef2]omTRL3o
Ihc1ofZ?a_m]T/OoKY?800CoK97500CoK9;3ofbAaOm/T/?oK9;32Om/T/4H
offC`Q3oK9;10_m/T/<08?m/TLGoK9;3ofbAaOm/T/?oK975ofbB`om/TLGo
KI?4ofbAaOm[TL;oKI;6offCa?mXSL7oGXJgoeAoZ_lcGXWo4SQWoa<eIOlV
@W7oN8fhon7aoooaoOoojO7loo_oooonoo_ono[eooonnoommoWooocooocg
o_ooo_oohn?S0ooUiND:onKViPOoinOW1_oXj>P;onWYj@?oj^[Z00?ok>c/
on_[joo]kNd00_o]kNd:onk^kPOokno_1_o`l?08oo7al@?ol_;b0_oclo<3
ooGem@;omoOg0oohn?P:ooWin@?on_[j0oolo?`2ooknoRKooooo00Co3EJa
ojC4i_nhd^koMZgZ0_n/gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP0Cob<V
2_l/71Co8a`:ob`L5?l/4P3o8a`:oa4L2_lm4P[o;180ob<V2_lS70[o;1`D
ob<L2_lA70[o;180oaXV5?lS70[o;180oaX92P02ob<L2P03ob`B0?lJ2@[o
8bH:00;o;1800_lS70X01ol/4P3o8a`:ob`B0?lJ2@[o;180ob<L2_l/4P00
0_lS70X01?lA70[o6PT:oaXB5?lJ2@X2ob`B0004oaX92_lJ4QCo;180o`TB
2P;o4A`:0_lJ2@X06OlA70[o6Q8Do`T95?lJ4QCo4BHDo`T95?lJ9QCo2A`D
oaXV5?l92ACo0000odmNI_mbEE;o;2HDoh>4S_n`/kOo`LO<ol[@e_l0003o
6RHDodmNI_nEZZgo`LO<ojJZXol000000_l971@06_l0003o8blcojJZXom?
IdOoYZZ]odINAolS;ako;4`YoiFHXon`_/7o`LO<oh>HS_n=V8koSHe_o`00
0?m6C3godn?eol77c?oLhn3ob]3Fol77`OoCfMKom_ooocAWNolS@Cgo2BHY
0_lS;c<01olS@Cgo8d5Bog:=[OoChoGom_ooom?SmOnE/l`00onVan009?o:
d=KoUK?<og:=[On3V;OoUK?<om?SmOnVan3o=6MkobaEG?nVan3om_ooojK7
h?lAC5;o8d4mo`TB2_mbLW_o`LO<ok2n`OoLhn3o`LO<omcSh?nEXHko2A`N
o`000?nVZZgob]3Fom?Ie_oLhn3odn?eongfmOofooookNgZomcSh?oCfMKo
b]31ooooo`;oYZZS00goAVMLof1N<omP@BWoUHAkohf=KonEXHkoWXAVofYW
<oo1alcook<0ooK7?OoTZP3om/L:00;om[<00_oTZP02ooJc0003onBc7_of
a`[om/L:00?om[<000Oom/L:ooJc0?of/`3oi:X0ooJc0?oTZP3om[<000;o
i:X000godh@0ol640?nEE@3oARl:ocdL2_l/4P3o4A`:oaX92_l92@[o4BH:
oaX92_lS9P[o2A8:00?o2@T:00Ko4A`:o`000?l94P[o2@T:oaX92_mP;a@2
og8V0003og8h5?mb9P3oLRH000?oLRH000GoPbl0of0_2_m69P[oLSP0og]<
2P02oij=<`0@oiik<on3Nc?oPehDofYE7_l/C2Wo6Q8DoeLL0?nNGQCo4BH:
o`T92_l92ACo6PT:o`T92_lA9Qko8a`:oaX92P;o;18000Go8bH:ob`L5?lS
70[o;180ongfm@1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0003oooo
o`05oo[jn_oCdm?oQhN7ojb/[?nl_;`00_n^[Zh01?nf][Ko_;blokno_oo4
a<@<olW9b@0HooSon?oloogooO_loooloooonoooo_CooookooojmooonOoo
oo;oooo^ooooj_ooonKoooo5iOooAVFKobA4Ool=<Foo4cUhoa]1P?lOAHCo
8dV8obM=S?lXCXco9df;1_lYD8/2obU@R@So:E276?lWCXD@obU@Q`Wo:E2;
01Wo:U6<obU@RolXCh[o:U6<ob]BSOlUC8Oo6dAjoa0jJ_lG@VgoCWBSolCT
oooWooooh??ooo7ooooeoooonoooooSjmooko?KoooohooKakOooo?koooco
oooiooooo_oogmoO00KohN7Q2_oRh^83on?Sh`;oi>CT0ooUiND:onKViPKo
inOW0_oXj>P5onWYj@_oj^[Z0_o[jn/2onc/k004ong]kOo^k^kok^k^onk^
kP[okno_1Oo`l?03oo7al@Gol_;b2?oclo<2ooCdm0?omOGe0oofm_H2ooOg
m`?on?Sh2_oinOT3oo[jnP;oo?cl0oono_hAooooo`04o`mF[_nVa^Ko]]3^
ogV_kP;oZmko00CoMWIfol71`Oo`l?3ooOgmFoooool4ob<L2P0Cob`B0?lS
70[o8a`:ob`B0?l/9QCo;180ob<L2_l/4P3o8a`:ob`B0?lS70[o;180ob<L
2_lJ2@[o;180ob<L2_lJ2@[o;180o`TB2P03ob<L2P0:ocdB2_l/4P3o8bH:
ob`B0?lS70[o;180ob<L2_l/4P3o8a`:ob`B00;o6PT:00So8a`:ob`B0?l/
4P3o8a`:oaX92_lS70[o;180ob<L2P;o2@T:00Co6PT:oa4L2_l92@[o6PT:
0_lA70X0=olJ4QCo4BHDoaXB5?l94P[o6Q8Do`TL5?lA9QCo2@T:oba<:Om6
C3goAUEBoiFHXoo1alcodn?eoceN?OlA9P[o8blNofYkKon`_/7o`LO<og:=
?Ol0003o2A`DoaXB5?l94P[oJW9Log^=I_mGIe;oUJZ]og^=I_m6EBWoJW9L
ol[@e_o1alcoYZZ]og^=Q?nVZZ?o4BH:o`TV:On`/kOo`LO<ol[@e_oCfMKo
/;>gol[@e_oLhn3odn?eobaWG?lS@Cgo?Blmoa4_<olS;c?o8d4mocd_?Om?
LW/00_oChoD00oofooooUK?<ojK7h003ojK7h00AoiFcc?mbSJgoPiRgojJc
`OoChoGoLXf]oa4V7_mGGVooY/OPom?SmOnVan3o=6MkocebQ?lA9Qko=5DY
ok2c]oo:d=H00_o1al`2ol[@eP05of1N<olA9P[oEfMBol[@e_oCfMH00_oL
hn02ongfm@0<ong]j_o1alcog>?PomcSh?oCfMKom_oeonC@c?n=SDOoH5hc
ofYW<onNQ6KoUIQV0_n`ZX@01OmZLUcodmWFooJc0?ofaakom/L:00?om[<0
00OodiP:ooK77_of/`3oi;<NooK72_ofaakom/Lm00?om/L:00?om[<0ooK7
2_of/`000oof/`03onBZ00;odh@000?oUED0oeLL0?lm70X00_lA70X01olJ
4QCo2A8:oaX92_l/4P3o;2HDoaXB5?lA70X00ol92@X01_lA70[o2@T:o`T9
2_l/4P3oH2l:oh<_00?oLRH000SoLSPDog8V0?mb9P3oLSPDof0_2_mP;aCo
Pbl0ok2=<`;oWXdc0_n3Nc<03OmZ@@[oAT4NoaXB5?lm70[oPd40ofY12_l0
003o6Q8Do`TB2_lA70[o2@T:ob<L2_l/4P001?lS70X01Ol/71CoARHDob<L
2_l/4P3odn?e05oooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000?ok^k^
00_ok>c/on?Shon[Zj_oMGEeoh20P?n?ShooW9bLojFUYOn/[:co/K6aokNg
]`0>ok^k^`?o_;bl0onm_Kd00onn_[ko_Kfmokjn_P02okjn_P;o_kno2oo0
`<02ol71`@;o`/;200Co`l?3olC4a?o4a<Coa<C42_o5aLD5olK6aP;oalO7
00?oa/K6olO7aoo7alL00oo7alL=olS8b003olW9bOo:b/[ob/[:00oobl_;
0oo<c<`00oo=cLgoc<c<olc<c002olg=c@_oc/k>0_o?cll3om3@d003om7A
dOoBd];odm?C00;odm?C0ooDe=@7omGEe@Koe]KF0_oGemL5omSHf0_ofMWI
0ooJf]X2om_Kf`?og=cL2_oMgMd5omkNgP;ogmoO00?og]kNomoOgooOgml0
0ooOgml8on3Ph0?ohN7Q0_oRh^82onCTi003onGUiOoWinOoinOW00?oj>SX
2_oYjNT3on[ZjP?ok>c/0_o^k^h;ono_k`;ol?3`0ooalO400oobl_;olO7a
oo;blP02oo;blP?olo?c3_odm?@01?l;DZgoY<?UokSBkomi[^`2ojcOo`04
ofi^K_nd];Coh>3Ponc/k5_ok^k^00Co8a`:ob<V2_lm70[o?A`:0olS70X0
1?l92@[o;180ob<L2_lm70X3ob<L2P06ob`B0?lS70[o6Q`Nob<L2_l/4P3o
8bH:0_lS70X01ol92@[o;180ob<L2_l/4P3o8bH:oaX92_l/4P000_lS70X0
3ol/4P3o2@T:ob<L2_l/4P3o8a`:oaX92_lS70[o;180oaX92_l/71Co4A`:
ob`B0?lJ2@[o;180ob<L2P02oa4L2P04o`T92_lA70[o4A`:oaX92P;o4A`:
00Co2A8:oaXB5?l94P[o4A`:0_l94PX03_lJ4QCo2@T:oceN?Om6C3goNhf4
oiFQ]oo:d=KoPiR>oa4V2_lA9Qko=5DYofYkQ?o:d=Ko/;>g0_lA9PX2o`TB
2P0Oob`h:OmZNfoo=2lcok2c]omkSHCoAUi7oeN=G?nEZZgob]3Fol77`On3
Q8koUJZ]oba<:Ol0003o/;>gojJZ[Oo1alcob]3Fok2n`OnV/l7odmWFom?S
mOo:d=Ko4Blmob=1?OlA;c?o8blYoa4_<olS@E;o;5ELoeMNK`02om?Sm@03
ooKooonVan3oY/OP00CoY/OP01SoLXf]oh>H]on`_/7odn?eobaEKol/>2Wo
LXf]om?SmOofooooUK?<og:=[On3V;Oo2A`Noa4V5?mbLW_o/;>gomcSh?oC
fMKoY[?1omcSh?nEZZgoCfM7o`000?o1al42om?IeP0;omcSh?o]m_Gom_oo
ong]j_n`_/7og>?FooKfmOo:d=Kog>?PooKoooo1/jd00_nESE802?nEXHko
`K>>ol77`OmbSCgoPehconC@c?of/`3om/L:0oof/`000oood03oi:X0ooK7
2P02ooK72P04oooI:Oofaakom/LmooK72P;om/Lm0_ofa`X01_ood03om/L:
ooK77_of/`3oi;<NooJc00;oi:X000codh@0oiEE0?mP;`[oARH:oaX92_lS
70[o2A8:oa4L2_lJ2@[o;1`DodHV2_lS9PX2oa4L2P07o`TB2_lA70[o2@T:
o`TB2_lA70[o;180og8h5005og8V0008of0_5?mP;`[oH2l:og8V0?nNLQCo
/8dcoiF4D_n3Nc<2ofYE7P08odI17_lS;ako8a`:of0_2_mZ@@[o2A8:o`T9
2_l94PX3oaX92P08ob<L2_lJ2@[o;180ob`L5?lS70[o?A`:ob<L2_l/9Q@2
ocdL2P03ob`B0?o]m_Gok^k^05kok^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN4000Coi^KV00[ohn?SomWIfOnb/[;oOWinofm_KomhN7SoRh^;oi:BT_nI
VIWoXJ6Q3_nVYZH6ojNWY`03ojRXZ?nYZJWoZZZZ00CoZZZZ2?n[Zj/3ojb/
[0;o[Jf]0_n^[Zh01?n][Jgo[Zj^ojj^[_n^[Zh2ojn_[`go/;2`0_na/K40
0onb/[;o/k>cok>c/`0;ok>c/`;o];Bd0one]KD00onf][Ko]KFeokFe]@02
okJf]P?o]kNg2_nh^;P3okVi^@03okZj^_nk^k_o^k^k00;o_;bl2onm_Kd5
okjn_P03ol30`?no_koo`L7100Go`L712_o2`/84ol?3``Coa<C42_o5aLD6
olK6aP03olO7aoo6a/KoalO700CoalO72?o8b<P3olW9b@;ob/[:0oo<c<`3
olk>cP;oclo?2oo@d=02om7Ad@?od];B0_oCdm<;omCDe0GoeMGE0ooGemL5
omWIf@Sof][J0_oKfm/3omcLg0;ogMgM0ooNg]h3omoOg`koh>3P00Co3UF]
ojG4i_nfd^koNJkY0_nZh?l01?mZJV[o[Zj^omSHf?oTi>AKonKViP04odHV
5?l/71Co8a`:oc@_7P;o;18000?o8a`:oa4L2_lS70X00_lS70X2ocdB2P0<
ob<V2_l/71Co;180oaXB5?l/4P3o8a`:oaX92_lS70[o6PT:ob`B0?lS70[o
?A`:0olS70X01ol/4P3o6Q8Dob`B0?lS70[o;1`Dob`B0?l/71@00_l/4P02
oaX92P04ob`B0?lJ2@[o8a`:ob`B00?o8a`:00Co6PT:oa4L2_l92ACo4A`:
0_l92@X05OlA70[o6PT:oa4L2_lJ2@[o6Q8Do`T92_lJ4QCo2A8:oa4L2_l9
4P[oEfMBoh>4S_nV/l7ob]3FofYbG?m?IdOoAUDYodI17_m6EBWo/;>gong]
jP02oa4V2P08o`TB2_l971Co0000ok2c]olJ2@[oJW]_ol77c?mkSH@2og9b
N`09ol77c?n`/kOoY[?1oiFZ[Ol/C2Wo0000odmNI_oCfMKoY[?100;ob]3F
013oUJ6gol77c?oLhn3odn?eojJc`Ol/GSgo8d4mocd_?OlS;c?o?BlmobaE
G?lm;cgoH79kojK7h?oChoGom_oo0onVan001Oo1alcoY/OPojJc`OmbSJgo
PiRg00;oY/OP0_lS@Cd02ombLW_odn?eooKooonE/lcoY/OPocAWNolS;bWo
6Q8DodI<?OmPLW_og>?P00Cob]3F00KoUJ6>o`000?mZNfoo`LO<ol[@e_oL
hn02ongfm@09ooKooon`/kOo`LO1oooooon`_/7ob[j]ong]j_ooooooAT4N
00;o`K>>00OoUJ6>ok2ZQ?mPGS?oPg]LooK]j_of/`3oomTY00;om[<000ko
m/L:ooK77_oTZP3om/LNooK7?Oo]_Sgom]UVooK77_offFKoomTYoooI?Oof
fFKoomTYoooI?@?om/L:00?om[<0ooK72_ofa`X00_oTZP001_oCQ03o/780
of0_2_m6;`[o8a`:oa4L2P;o6PT:00Oo4A`:ocdB2_mZ@@[o8blNoaXV5?lJ
2@[o6Q8D00;o2A8:00Co6Q8DoaX92_l/71CoPbl01?mb9P001_mb>1CoEa`0
of0_5?nVLQCo/8dcokV=<`;oPg/c00ooJUDNof115?lS9P[o6Q8DodHV5?mP
;`[o8bH:o`T92_lJ4QCo2@T:oaX92_lA70[o6PT:ob<L2_lm70X01OlS70X0
1_m69QCo?A8:odHV2_m69P[o;180ongfmEooi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X000Cok^k^00Sok>c/onSXj?oIfMWo`/;2ojFUYOn=SHgoOWin
ogIfM_ooLW9b3OmbLW802Om/K6coJ6QXof=SHomJFU[oCTi>o`UA[?nVa^Ko
^M?^ogV^j`02oj_Oo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00So;1`Dob`V
5?l/4P3o8bH:ob`L5?lS70[o6PT:ob`B00;o?A`:00Go8bH:ob<L2_lS70[o
;180ob<L2P02ob`B000Aob<L2_l/4P3o6PT:ob<L2_lS9P[o2@T:oaXB5?lS
70[o;180ocdB2_l/4P3o8a`:ob`B0?lS70[o6PT:ob`B0?lS70X00_l/4P00
1?lS70[o;180ob<L2_l/4P03ob<L2P07oaX92_l/4P3o8a`:ob`B0?lJ2@[o
4A`:o`T92P03oa4L2P03o`TB2_lJ4QCo2@T:00;o4A`:027o2@T:oaX92_lA
70[o2A`DodmNI_n`/kOob]31og:=Q?l/>2WoJW9LodIE:OmZNfooCfM7ojK7
h?o1alco0000oa4V2_l971Co6Q8DoeMWD_m?IecoNhf4ojJZXomPLW_oCg9k
ok2c]on`_/7ob]3FojJZ[On=V8koSHe_o`TB2_l000000_o:d=H2ol77c008
ok2n`Oo1alco`LO<om?Ie_o]m_GoPiRgocebQ?lS@E82ob=1?@04ocd_?OlS
@Cgo;5ELofYkQ0;oY/OP0_ofool05_nE/lcoY/OPojK7h?nVan3oUK?<og:=
[On3V;OoY[?1oiFcc?lS;c?o?Blmoh>H]ooChoGom_oooh>H]oofoooo=6Mk
obaEKolA9QCo=2lcodI<?On`_/42om?IeP05ok2c]oo]m_Gob]3Foa4V2_lJ
71h00_o1al`07OoLhn3okOKeongfmOofoooob]3Fog9bNoo]kN[og>?Fok2n
`OnVZZgog>?Pol[@`Oo1al7oNheVofYW<om6C3goH2lDonC7`OookLcom[<0
ooK77_ood03om[<0ooK72_of/`3oi:X0ooKII_oohhkoonf>00;oon>40oof
fFH02OoofCgom]UVoooI?Oofa`[okKhmooK72_of/`3om/LNooJc0003onBZ
000=ol640?mb9P3oARH:ob<L2_lJ2@[o4A`:oaX92_lA70[o;180og]<2_m6
;`[o=2lNob<V2P02o`T95005o`TB2_lJ4QCo2@T:ob`B0?mb>1@00_mb9P00
4_mP;`[oH2lDof0_5?n3@@3o/8@Yoij=<onNSBWoPg/coh=N5?mZ@@[oJUDN
oa4V5?m69QCoH2l:ob<V2_l92@[o6Q8Do`T92P;o4A`:00Go8a`:ob`B0?lS
70[o;1`Dob<L2P02ocdL2P04odHV5?lm70[o?A`:ob`V50;oARH:00?o?A`:
ocdB2_o]m_D0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@001?ooool0
2_olo?colO7aolG5aOn8R8SoKfm_ogEeMOn2PX;oQhN7ohf=SOnEUID>oiZJ
VPKoVi^K0_nLW9`5oifMW@_oWYjN0_nOWil2oj2PX004oinOWonPX:3oX:2P
oj2PX0goXJ6Q0_nRXZ82oj>SX`03ojBTY?nUYJGoYJFU00?oYZJV2?nWYjL5
ojRXZ003ojVYZOnXZ:SoZ:RX00GoZJVY2_nZZZX3oj^[Z`03ojb/[?n][Jgo
[Jf]00;o[Jf]2on^[Zh5ojn_[`;o/;2`1_na/K4:ok:b/P?o/k>c00?o]KFe
okBd]?nf][H00_nf][H:okNg]`go^;Rh2?ni^KT5okZj^P?o_;bl0onn_[h2
okno_`_o`<300_o1`L43ol;2`P;o`l?32oo4a<@5olG5a@03olK6a_o7alOo
alO700GobLW92?o:b/X2ol_;b`?oc<c<00?ocLg=olc<c?o=cLd00_o=cLd3
olk>cPkoclo?00Co45J^oj?2i?nhdnooMjk[0_nZgol01?mfMWKo`L71oo3`
l?omoOeKooooo`04ob<V2_lm70[o?A`:ob<L2P;o;18000Co8a`:ob`B0?lS
70[o;1800_lm70X00olS9P[o?A8:ob`B0002ob<L2P06oaX92_lS70[o8a`:
oaX92_l/4P3o6Q8D0_l/4P004olm70[o8bH:ob<L2_lS9P[o;180ob<L2_l/
4P3o;1`Dob`B0?lJ2@[o8a`:ob`B0?lS70[o;180oaXV5?lJ2@[o;180oaXB
5?l/4P000_lS70X01ol/4P3o8a`:oa4L2_lA70[o0000oa4L2_l92@X00_l9
4PX01?lA70[o2@T:o`T92_lA70X2oa4V500Foc@_:OnEV:?ob]3FoeN=S_l0
003oUJ6>og^=I_m6EE;oPiR>oh>4S_o]kN[o4BH:o`000?l971Co0000oc@_
7_nEXHko4BHDohfHS_o:d=KoSIR>o`TL50;o/;k100Oo`LO<oiFZ[On=V8ko
;4`Yo`000?n3Q8kob]3F00?o`LO<00[o/;k1ol77c?o1alcokOKeoh>H]ol/
EFoo;5ELocd_?Ol/EEco?Blm0_lS@E801?lS@Cgo=6Mkok2n`OnVan02ooKo
o`0=ojK7h?nE/lcoY/OPol77c?nE/lcoPiRgoiFQ]onVan3oPhB>ob<_<omP
LW_oPiRgooKoo`02om?Sm@0NojK7h?mbSJgoLXf]oa4_<olA9Qko=5Dmoh>4
S_oCfMKob]3Fom?Ie_o1alcom_ooofYkKol0003oYZ6Hol77c?oCfMKodn?e
ongfmOofooookNgZofYbG?o1alcokNgZol[@`On`/kOoi=3<ongfmOo1al7o
ARl:0_l971@01OmP@BWom_ooong7G?oo/`3om/Lm00Com/L:00?om[<0oooS
S_ookHh01?ookHh00ooohhCoomTmooKIIP02oooI?@03oooI:OoofCgom/L:
00?om/L:0ooTZP003oo1Q03oJT4:oeLL0?lS9P[o4A`:oa4V2_l92@[o6PT:
ob<L2_mkC0[oH44YodHV5?m6;`[o2A8:oa4L2P03o`T92P0FocdB2_mb9P3o
H2l:of0_2_lm4P[oLSP0oiib2_niQ2WoWXdcoiik<on3Nc?oWXdYoh=N5?lJ
4QCo8a`:odHV2_lS70[o4A`:o`T92_lA70[o6PT:oa4L2P?o6PT:0_lS70X0
0ol/4P3o?A`:odHV5006ocdL2P;oARH:00?o;180om?SmOooool0G_ooool0
1?n_[joobl_;omkNg_oZj^X1oo;blP000oo^k^h02oo/k>cohn?Soj^[Zomc
Lg?oOWinohb<S?nJVY[oXj>SojZZZ_nb/[;o][Jf00So^;Rh1?oloO/4oocm
o@03oo_loOoloOgon__m00;ol_?h00GojncaomkOi?oKfn?oe]KPomKFhP04
omGEh@Woe=CP<OoDe=h8omCDh0OoeMGQ00OoeMGOom;Bg?oGemoohN3XonWZ
kooal?GomoOi00?ooOgm0oomoO/5oogmo@?oclo?00?od=3@om7AdOoBd]80
0_oBd]8:om?Cd`Koe=CD0_oEeMD5omKFePkoemOG0_oHf=P=omWIf@?of][J
0_oKfm/3omcLg0?ogMgM0_oNg]h;omoOg`;oh>3P0ooRh^82onCTi0_oiNGU
0_oWinL3onSXj003on[Zj_oYjNWojNWY00;ojn_[0oo/k>`8onk^kP;okno_
0oo`l?02oo;blP?om?Cd0ooemOD>ooKfmP04oa1F[_nUa>Ko^M?_ogN^j`;o
ZMco00CoKVi^okBd]?oPh>3ok>c/Foo^k^h00olS70[o?A`:ob`L5003ob<L
2P06ob`B0?l/71Co;180ob<L2_lS9P[o?A`:0_l/4P001olS70[o;180ob<L
2_ld;ako;180ob<L2_l/4P000_lA70X03_l/4P3o;1`Dob`B0?lS9P[o8a`:
ob`B0?lS9P[o6PT:ob`B0?lS70[o6PT:ob<L2_l/4P3o8a`:0_lJ2@X2ob`B
0003ob<L2_l/4P3o8a`:00;o;18000?o8a`:ocdB2_lJ2@X00olA70X01?l9
2ACo6PT:o`T95?lA9Q@2oa4L2P0EoaX92_l92@[oAT`mojJZXoo1alco2A`D
odI17_l/>2WoUIRSog^=Q?mZNfooPhB>oiFZ[OnEXHko0000oa4V5?l92ACo
2@T:oiFQS_lS;akoAT`m00;ob]3F00ooAVMLo`TL5?o1alco/;>gol77c?n3
Q8koUJ6>o`000?m6C3go/;k1om?Ie_nV/l7o`LO<ok2n`Oo1al`00oo:d=H0
3?n3Q8koYZZ]ojJZXonEQ8koWXAVojIbD_nELTOoCeiVob=1D_mGGVooY/OP
om?Sm@;om_oo00codn?eoiFcc?nVan3oY/OPoiFcc?n3V;OoUK?<ojJc`Om?
LW_o?Blmog9bNon3V;L3om?Sm@07oh>H]onE/lcoUK?<oa4_<oldECgo8blc
odI17P02ol[@eP08om?Ie_o1alcob]3Fol77c?lS;ako=5DYojJQV?o1al`3
ongfm@0?ooKooon3V8koSHe_ongfmOn`/kOob]3Fok2c]ooLhn3okOKeol77
c?m6;`[oUG97ol77`OookHkom]UV00;om/L:00[om/LmooJc0?ofa`[om/L:
ooJc0?oohhkoong<ooKomOookHkoon>40_ookHh02ooohhCom]UVooKII_oo
fCgom]UVoooI?OoofBWom/LNooK72_oT/akom/L:00;oi:X000Go`H@0oh<_
0?mP;aCo8bH:oaX92P02oa4L2P0CoaX92_lS70[oNd`Dok24:On3GQCoH44D
o`TB2_l92ACo6PT:oaXB5?lA70[o;180of0_2_m69P[oLRH0oiiN5?oCXBWo
bZYVojJQIP03oij=:@07odH_2_lJ2@[o8bH:ob<V2_lJ2@[o4A`:o`TB2P04
oaX92P05ob<L2_l/4P3o8a`:odHV5?lm4PX01_lm70X01om69P[o?A`:odHV
2_lm70[oARH:ob`B0?o]m_D0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Q
h@000ooVi^H02ooQhN7o_[jnogMgMonPX:3o_Kfmok2`/?n^[Zko]KFeokbl
_?nn_[koaLG500Sob<S81?onoo/03?onoogoo_ooookoooonoooon_kooo_o
ooo^lOKog^7Xom[Mi?oDemkobLcEolO9e@;o^K_80onh^/L3okNiaPWo^K_8
;oni^lL8okVkb0So^[c900So^kg:ol;4d?o<c=SodMCMomWIhOoTiN[ol_?h
oogno`Coo_oo1?ooood01?oooooog]kNomkNg_oNg]h2omoOg`Koh>3P2_oQ
hN43on;RhP;ohn?S0ooTi>@:onGUi@Koi^KV0_oXj>P5on[ZjP_ojn_[0_o/
k>`2ong]k@04onc/k?o]kNgokNg]ong]k@[ok^k^1Oo_knl3oo3`l0GolO7a
2?obl_82oo?cl`?om?Cd00?omOGeooKfm_ofm_H00_ogmoL3ooShn0[onOWi
0oojn_X2ooclo0?oo_kn4Oooool01?l=E[7oY<CVokWCkomf[NX2oj_Po`04
ofYZJ_n^[Zkof=SHonCTi5_oi^KV00Oo?A`:ob`L5?l/4P3o;1`DocdL2_lS
70[o?A`:00;o8a`:00?o?A`:ob<V2_l/4P000_lm70X02olS70[o;180ob<L
2_l/4P3o8a`:oaX92_lS9P[o;180oaX92_l/9QCo;18000;o?A`:00[o;180
ob<L2_l/4P3o;180ob<V2_m69P[o8bH:ob`B0?lS70[o;1800_lS70X03?lJ
2@[o8a`:ob`B0?ld;ako;180oaX92_lS70[o6PT:ob<L2_lS9P[o6PT:o`TB
2P?o4A`:00?o6PT:oa4V5?lJ2@X00_lA70X03Ol0003oSIR>ojJZ[Ol0003o
EfMBojJZXomZNfooYZZSofYkKonEV:?oUJ6>om?SmOl000000_l971@05?l0
003oYYR4ob<_:OlA70[oPhB>ol77c?oLhn3o4BH:oeN=G?nEV:?o/;>goiFZ
[OnVZZ?o?Ehmo`000?n`_/7oUIRSomcSh?nEXKOo`LO<0_n`_/403Oo:d=Ko
g>?PojJZXonVZZ?oYYR4ojJ4Q?nEQ7_oWXAVoh=kG?nELTOoLUEBobaEG?n3
V;L00_nVan02om?Sm@0GooKooonVan3oY/OPojK7h?nE/lcoPiRgoiFQ]onV
/l7oAUEBodmWG?mbLW_oUJ6gom?SmOofooooUK?<oh>H]ooChoGoY/OPoa4_
<om?LW_o8d4moaXV5?mbLW/00_o:d=H01OoLhn3o/;>goooooonEXKOo4BH:
00;oUIRS01OokOKeom?SmOofoooom_oool77c?mZLUcodmWFol[@`Oo:d=Ko
kOKeok2n`OnV/l7o`LO<ong]j_ofooooonf>ooK@Q?offFKom[<0onfn?Ooo
fCgom/L:oooI:@02ooK72P03oooSS_ookHkoonf>00;oonf>0ooohh@02Oof
fFKoon>4oooI?OoffFKoomTmooK77_ofacgom/L:ooK7?@03onBZ0003om>H
2_mk@@3oLSP000;o8a`:00Wo6PT:o`T92_lA70[o8a`:of0_2_n`Q2WoWW/c
oheE2_lA9Q@00_lA70X03ol92@[o4A`:ob<L2_lm70[oEa`0okV=5?nNSBWo
^JY_ohf=AonNLQCoPg/codI17_l/71Co6PT:ob<V2P02o`T92P03oa4L2_lJ
2@[o4A`:00;o6PT:00So8a`:ob`B0?lJ2@[o4A`:ocdL2_lS9P[oARH:odHV
50?o?A`:00?oARH:ob`L5?m69PX01?m69PX00ol/4P3odn?eonKViP1NonKV
iP04oifMWOng]kOob<S8om?Cd`7of][J0002onk^kP0<ong]kOoUiNGoTI6A
oi6ATOo<c<coeMGEol;2`_ni^KWo`<30olC4a?o9bLWob/[:2?o@d=02ooko
nP;oo_ok06Coo_omookoooonooooo_oooo7en?o_l_Oof]gTolC7d?nk_LWo
/kO2ojZ/^OnVZKSoV9ZYoiNJZOnHVJ_oUYVXoiNHZ_nEV:OoUYNYoiFHYonE
UZSoU9NVoiFFZ?nDUjKoUIJXoiBGY_nEUZSoU9NVoiFGY_nDV:CoUINVoiBH
Y?nEUjKoU9RToiFGY_nDV:CoUINVoiBHY?nEUjKoU9RToiFGY_nDV:CoUINV
oiBHY?nEUjKoU9RToiFGY_nDV:CoUINVoiBHY?nEUjKoU9RToiFGY_nDV:Co
UINVoiBHY?nEUjKoU9RToiFGY_nDV:CoUINVoiBHY?nEUjKoU9RToiFGY_nD
V:CoUINVoiBHY?nEUjKoU9RToiFGY_nDV:CoUINVoiBHY?nEUjKoU9NVoiFG
Y_nDUjKoUIJXoiBGY_nEUZSoU9NVoiFFZ?nDUjKoUYNYoiFHYonFUjWoUIRW
oiJGZOnEV:OoUYNYoiFHYonOXK3oY:Nfojf__?nb]<7o^;[6olK9d_oKg^Go
kNkc1?onool2ooooo@;ooook00Koooooon;Rh_oRh^;oh^;RonCTi?oShn<3
onGUi@[oi^KV1_oWinL00ooXj>SojNWYon[ZjP04on[ZjP_ojn_[0oo/k>`2
ong]k@?ok^k^2_o_knl3oo3`l0;olO7a0_obl_801?oalO7ol_;boo;bl_ob
l_82oo?cl`Som?Cd1OoemOD3ooKfmPGomoOg2_ohn?P3ooWin@03oo_knool
o?coo?cl00;oo_kn9_ooool01?l=EJkoYLCVokG@k_mi[^`2ojOLo`04ofi^
K_nd];Coh>3Ponc/k5_ok^k^017o;2HDob`L5?l/4P3o4A`:ocdL2_l/71Co
8a`:ob`B0?lm70[o?A8:ob<V2_lm70[o8a`:ocdL2_lm4P[o;180ob<L2P02
ob`B000=ob<L2_lJ2@[o;180oaX92_l/4P3o8a`:ob`B0?lm70[o8a`:ocdL
2_lS9P[o;180ob<L2P02ob`B0003ob`L5?l/4P3o;18000?o;18000Co?A8:
ob<L2_l/4P3o8a`:0ol/4P001?lS70[o;180oa4L2_lJ71h2o`T92P0Woa4L
2_l94P[o6PT:oa4L2_lJ4QCo4A`:o`000?o1al7oAT4Noa4L2_o1al7oSIR>
oh>=Q?n=V8koLW9koiFZ[Oo1al7oSIR>o`000?lJ4QCo2@TDob<_7_mGSEco
EfMBofYkKonEXKOob]3Fok2c]ol971CoPiR>ohfHS_n`_/7oNhf4ohfHS_l0
003oLUEBofYkQ?nEXKOob]3F00;o/;k100GoY[?1ol77c?o:d=Ko/;k1ombn
]`02olZn[@08ok2ZQ?n`Q7_oWXAVok1kI_nNQ6KoUG97odI<?OmZNh@2ojK7
h00@om?SmOofoooom_ooom?SmOn3V;OoY/OPojJc`On3V;OoUJ6goiFcc?m?
GVKoH79koiFHXon`_/7odn?eooKoo`;oPiRg01?odn?eol[@e_l9@DOoPhB>
oh>H]ol94P[oEeEBofYkQ?o1alcodmWFomcSh?o:d=KokOKeocAE:Om6EBWo
`LO<ok2n`Oo:d=KokOKe00;om_oo00?oUIRSom?Ie_oChoD00_o]m_D01_oL
hmKokMW<ong@V?oohhkokKhmooK7?@;om]UV00Goom00ooJc0?ofacgom/L:
onfn?@02ooK72P04oooSS_ookLcoonf>oooSQ0;oonf>0_oohh@01ooffFKo
on>4oooI?OoofCgom]UVoooI?Oofaah00_ofa`X02oof/`3oi:X0om>40?oC
V0[oPcP0ofY12_lS9P[o;1`DoaX92_lJ4QCo2@TD00;o;18000kobZY7oij=
<on`Q2Wo2A8:oaX92_l92@[o4A`:oaX92_l92@[oSED:ojJQI_nNSBWoPg/c
ofYE7P;oAT4N00Co4BHNoaX92_lA9P[o6PT:0_l92@X01?lA70[o2@T:ob<L
2_lJ2@X2ob<L2P04ob`B0?l/71Co;180ob<L2PCo?A`:00?oARH:ocdL2_lm
70X00_lm70X00om69P[o?A8:ocdL2P02odHV2P03ob`B0?o]m_Gok^k^05ko
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo00coo_knoo7alOmn
OWko_;blomSHf?oKfm_oc/k>ol30`?o5aLGob/[:olc<c?o?cll8om?Cd`1Z
oooon_oloOOooOkioooonoomoocoo_oooocoooodn?_oh>?Zolc?f?nn`/go
ZJfioi^N[On@UZKoP8>Fogn4UomoPYGoO8:BogaoT_mfO8coMGR;og=iROmh
NhkoN7j>ogUlSomgOHgoNGb?ogMmSOmiO8ooMgf=ogUlSomgOHgoNGb=ogMm
RomiO8goMgf;ogUlSOmgOH_oNGb=ogMmRomiO8goMgf;ogUlSOmgOH_oNGb=
ogMmRomiO8goMgf;ogUlSOmgOH_oNGb=ogMmRomiO8goMgf;ogUlSOmgOH_o
NGb=ogMmRomiO8goMgf;ogUlSOmgOH_oNGb=ogMmRomiO8goMgf;ogUlSOmg
OH_oNGb=ogMmRomiO8goMgf;ogUlSOmgOH_oNGb=ogMmRomiO8goMgf;ogUl
SOmgOHgoN7^<ogIlS?mhNhkoMWb<ogQkS_mfO8coN7^>ogIlS?miO8ooN7j>
ogYmT?mfO8coMgZ=ogMmSOmnPICoP8FHogj1U?n0QISoR8^Noi2CY?nKWZgo
Zjnkokg1c?o;c]OohnK]oo;enP;oo_oo00Gonogjoocnnooooo_ooookoooo
o`03onKViP;oinOW1_oXj>P:onWYj@?oj^[Z0_o[jn/3onc/k0[okNg]0oo^
k^h3ono_k`03oo7alOo`l?3ol_;b00;ol_;b0_oclo<8ooCdm0GomOGe0oof
m_H5ooOgm`gon?Sh0ooinOT?oo[jnP?ono_k00?oo?cloogmoOomoOd00_on
o_hVooooo`04o`eF/OnTa>Ko^=;^ogJ]jP;o[=oo00CoMWIfol71`Oo`l?3o
oOgmFoooool09?m69QCo;1`DocdL2_l/4P3o;1`Dob`V5?l/4P3o8a`:ob`B
0?lS70[o?A`:ob`B0?lm70[o8a`:ob`L5?l/4P3o8a`:oaX92_l/4P3o?A8:
ob`B0?lS70[o4A`:ob<L2_l/4P3o;2HDocdL2_l/4P3o8a`:ob`B0?lS70[o
;180oa4V2_l/4P3o?A`:ob`B00?o8a`:00So6PT:ob<L2_lm70[o8a`:ob`B
0?lS70[o6PT:ob<L2P;o6PT:00Oo8a`:oa4L2_lA70[o2@T:oa4L2_lJ2@[o
2A8:00;o2@TD00Ko2A8:ob`h:OldEBWo4BHDojJZXoo1al`2og^=Q00KodmN
I_nVXISo/;>goeN=G?l0003o4BHDo`000?lS;akoPhAkodI17_lS;akoPiR>
ok2n`Oo:d=KoNhf4oa4V5?ldECgoYZZSoiFQS_o1al7o4BH:o`000?n`/kOo
AUEBomcSh?n`_/7o`LO<00;o/;k100So`LO<ol77`OoL/jgo`LO<onC7`OoL
_[Oob]31ojJ4Q0;o/8Ak00KoYXB4ojJQV?n`Q7_o=6MkoiFcc?nVan02om?S
m@;om_oo00[odn?eoiFcc?nE/lcoPiR]oiFQ]onV/l7oCg9kog9ED_n3V:go
Y/OP0_ofool01OmbSJgoUK?<om?SmOnVan3o;5EL00;oY/OP00oo0000oiFH
XombLW_oUJ6gom?SmOo]kN[oUIRSoooooonVZZgo=5DYok2c]oo1alcoY[?1
om?SmOo]m_D01?ofool03_o]m_GokM2HooK72_ofacgom]UVooK77_oofBWo
m/LmooK@Q?oohhCom/L:ooK77_offFKoom000_oofBT01Oood03om]UVooo]
c?ookLcoon>400?oonf>00Goon>4ooKII_offFKoomTmooKIIP02oooI?@04
ooK7?Oofaakom/L:onBc7P?oi:X000?oSED:og8V0?m6;`X00_lA70X02?lJ
2@[o4A`:ob<L2_lJ2@[o/7/YolZQD_n`SC?o8blN0_lA70X03?l92@[o2A8:
oaX92_nNSC?oJVLcodI17_ld;ako4BHDo`TB2_l0003o4A`:oaXB50?o2A8:
00_o4A`:o`T92_lS70[o6Q8Dob`B0?lS70[o;180ob<L2_lS9P[o?A`:ob<L
2P04ocdL2P04ob<V2_lm70[o?A`:ocdL2PKoARH:00?o?A8:om?SmOooool0
G_ooool01?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h01?o/k>cogmoO
og5aLOoAdM42omcLg006om3@d?o4a<CobLW9olc<c?o?clood];B2?oEeMD0
Jooooo[oo_oiookon_ono_conO_jooWjo?o`m?Oogn;Yom3Cg?nk_l_o[K2o
oi:GZ_n0QIWoMgb@of]`Q_m`MH_oIFYnofI]OomXKH3oIVeoofEZOOmTJggo
IFYmofE/O_mXKH3oIfj0ofQ]P?mWKX3oJ6f0ofM^P?mXKH3oIfj0ofQ]P?mW
KWkoJ6inofM^O_mXKWkoIfinofQ^O_mWKWkoJ6inofM^O_mXKWkoIfinofQ^
O_mWKWkoJ6inofM^O_mXKWkoIfinofQ^O_mWKWkoJ6inofM^O_mXKWkoIfin
ofQ^O_mWKWkoJ6inofM^O_mXKWkoIfinofQ^O_mWKWkoJ6inofM^O_mXKWko
IfinofQ^O_mWKWkoJ6inofM^O_mXKWkoIfinofQ^O_mWKWkoJ6inofM^O_mX
KWkoIfinofEZOOmTJggoIFYmofA[OOmUJWgoI6]mofEZOOmTJggoI6UlofE/
O_mWK7ooIVeoofEZOOmUK7koJ6f0ofYaQ?m`MH_oI6Z0ofAYOomdNHooQhbP
oiRK[_nY[;go^Kg9ol_=fOoPhn[omoSm00;oo_oo00CooOoloognnOoloOSo
oooo2ooWinL7onSXj0?ojNWY0ooZj^X2onc/k0?ok^k^0_o_knl>oo3`l003
oo7alOobl_;olo?c00oolo?c0_odm?@3ooGem@?om_Kf2_ogmoL3ooShn0;o
nOWi0oojn_X2oo_kn`?oo?cl3OomoOd3ooknoRSooooo00Co3eJ^ojK6i_nf
d>koNJo^0_n[g_l01?m^KVko];Bdon3Ph?o/k>aKonk^kPCo8a`:00Oo;180
odI<?Olm70[o?A`:ob<L2_l/4P3oARH:00;o8a`:00Co?A`:ob`B0?lS9P[o
;1800olS70X01olS9P[o6PT:ob<L2_lS70[o?A8:ob`B0?lS9PX01?lS70X0
1Ol/4P3o8a`:ocdB2_lS9P[o8a`:00;o;18000?o8a`:ob`B0?lS9PX00_lm
70X0=_lJ2@[o8bH:ob`B0?lS70[o;180oa4L2_lJ2@[o=2lNoaXB5?lA70[o
4BHDo`T92_lJ4QCo4BHDoaXB5?l0003o/:Z4o`TB2_lmGSgoUJZ]og9bNolm
GSgoSHe_oh>H[OnV/l7oUJ6>o`000?lA9QCo2A8:ob<_<omZNfoo0000ol77
`OlJ71koJW9Lol77c?o:d=KoAUDYo`000?mZLUcoYZZ]og:=Q?nVXISo0000
odI<?Om6EBWo`LO<ol[@e_mkSHCob]3Fok2n`Oo1alco`K>]ombn]`;oi=3<
0_oLhmH00ooL_[Oo`J64ojJQV002ojJHQ0;o`J6400CoYXB4oiFcc?nVan3o
dn?e0_ofool3om?Sm@;oPiRg01_oUJ6gojJc`OmbEE;oLW9koiFQ]ooChoGo
m_ooom?SmOmbSJgoPiRgom?SmOnEXKOoEei_om?SmOnE/lco2A`Nob=1?Oo1
al7oLUEBol77c?o:d=KokOKeoiFQ]oofooooUHB>ofYbG?oCfMH00_o:d=H0
5?o]m_Godn?eongfmOofm_GokM2HooKII_ofa`[oomTYooK7?OoofBWom/L:
ooJc0?o]_Sgoonf>oooSQ?ofa`[oomTYooK7?Oofa`[okKhm0_ofaah00oo]
aecoong<ooo]SP04ooo]SP03oooSQ?offFKoonf>00Com]UV00Com/L:oooI
:Oofacgom/L:0_oTZP002?oCQ03oPd40og]<2_lm70[o8a`:oaX92_lA70[o
8a`:0_lJ2@X01Oo:V2Wog;>4olZZAomZ@@[o2A`D00;o4A`:0_l/4P004_o:
XCgoPehDoh=N5?m6;`[o;3PYoaX92_lS70[o6Q8Do`TB2_l92@[o6Q8Do`T9
2_lJ2@[o2@T:oaX92_l/4P3o8a`:oaX92P;o?A`:00GoARH:ocdL2_lm4P[o
?A`:odHV5002ocdL2P04ocdB2_m69P[o?A`:odHV2P;o?A`:0_m69PX01?m6
9QCoARH:ocdB2_oCfMIOonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002
onKViP0<onCTi?oEeMGoLG5aomOGeooNg]kogmoOomCDe?o4a<CoalO7olc<
c?o@d=3od];B2?oFe]H0LOoooo_oo?ghookno?oooogoo?goooWjo_oXjo;o
d]GNokk2c_nQY;GoSY6Tog^0U_mnPY_oSI>]oiBI]_nRZ<;oalgSolWAi?o?
e^WodMW/om7Hjoo?en[oc]GXolgEj?o?e^Woc]KYoloFjOo>e^WocmKYolkF
jOo?e^Woc]OXoloFj?o>enSocmKXolkGj?o?e^Soc]OXoloFj?o>enSocmKX
olkGj?o?e^Soc]OXoloFj?o>enSocmKXolkGj?o?e^Soc]OXoloFj?o>enSo
cmKXolkGj?o?e^Soc]OXoloFj?o>enSocmKXolkGj?o?e^Soc]OXoloFj?o>
enSocmKXolkGj?o?e^Soc]OXoloFj?o>enSocmKXolkGj?o?e^Soc]OXoloF
j?o>enSocmKXolkGj?o?e^Soc]OXoloFjOo>e^WocmKYolkFjOo?e^Woc]KY
oloFjOo>e^WocMCWolgEj?o@en[od=S[oloFjOo=eNSoc]GXolgEj_o0a^3o
ZK3<oiNL^On;TJ_oO8:JogMlT_n<TJGo[;74okNjbOo>d]gojnkeoo_oooon
ooooo_omookonoomoo[ooooo00?ojNWY00?oj^[ZonWYjOoZj^X00_oZj^X3
on_[j`gok>c/00?okNg]onk^k_o_knl03?o_knl3oo3`l0?olO7a00?olo?c
oo;bl_odm?@00_odm?@2ooGem@Som_Kf1oogmoL6ooShn0_onOWi0_ojn_X2
ooclo003oo_knoomoOgooOgm017oo_kn:_ooool01?l<DjkoY<?UokSBkomi
[^`2ojcOo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00Ko?A`:ob<L2_l/4P3o
?A`:ob<V2_l/4P02ob<L2P0:ocdB2_lJ2@[o8a`:ocdB2_lS70[o?A`:ob<L
2_l/4P3o?A`:ob`B00?o8a`:00Wo;180oaX92_lS70[o?A`:ob<L2_m69P[o
;180ocdL2_l/4P000olJ2@X02ol/4P3o8a`:oeLL0?lS70[o;180ocdL2_l/
4P3o?A8:ob<V2_l/4P3o?A8:00;o8a`:03Wo4A`:ob<L2_lJ2@[o4A`:o`TB
2_lS9P[o4A`:oaX92_lA70[o;180o`T95?m6EBWo4A`:odmWAolJ71ko=5DY
ocd_?OlmGSgoEfMBoba<:On`_/7o/;>go`000?l94P[o2A`Do`T92_mZSEco
AT`mofYbG?n`/kOoNhf4ofYbG?o1alcoPhf4oa4V2_lmGSgoLW9kog^=Q?o1
al7o4BHDo`TB2_n=SFooCeiVomcSh?n`/kOoUJZ]ok2c]on`_/7oYYR4ombc
[OoTal7okMW<ooK]j_oLhn3okMW<onC@c?o:_Zd00ooL/j<3ombn]`03olZn
[On`/kOob]3F00;odn?e00[om_ooom?SmOoChoGoY/OPog9bNon3Q8koYZZ]
og9bNon3Q8koUIRS0_oChoD04oofooooLXf]oh>H]onVan3oPhB>oh>H]oof
ooooUK?<oa5<D_lm;cgoCeiVong]j_n3Q8ko`LO<ongfmOo1alcob]3Fom?S
mOmGEE800_oCfMH02?o1alcokOKeooooooo]fLcokKhmoooI:Oofacgom/LN
0oofacd04oofaakom[<0oooI?Oofd8Coon>4ooo@0?ofa`[om]UVooK72_oo
fBWom[<0oooI?Oof/`3oong<ooo]S_offFKoonf>ooKII_ookHh00_oohh@0
2OookHkoomTmoooSQ?oohhCoomTmooK7?Oood03okLMLooK77P03onBZ000?
oiEE0?mb>03oARH:oa4L2_lS70[o4A`:o`T92_lS70[o6PT:oiib2_o]d9So
bZYVoiib5?l971Co4A`:00;o6PT:00Oo0000onBcAonNSC?oPg/coh=N5?m6
;`[o8bH:00;o4A`:00Co2@TDoa4L2_l92@[o2@T:0_lA70X3ob<L2P03oeLL
0?lm70[o?A`:00?o?A`:00?o;1`DocdL2_lm70X00_m69PX00om69QCo?A`:
ocdL2P03ocdL2P05oeLL0?l/9QCoARHDob`B0?o]m_D0GooVi^H01?nMWIgo
]kNgolS8b?oCdm<1om[JfP000_o^k^h01?o/k>cog=cLogMgMooIfMT2on3P
h006omCDe?o7alOob/[:olk>c_oBd];oe=CD2?oFe]H04ooooo_onocgookn
o?oooooooOkoooGfnooMh>Wo`/CAojZ]__n;T:CoOhBJoh:8X_nNXl3o`<GS
ol[?kooEg?WocmO^om7Lk_oFhO<00_oJiOL00ooHhoGoen;domKQl`08omSS
mC3of>Cd2?oIi?H05_oGh_Cof>?eomSSmOoHhoGoen;domGPl_oDgo7oe=oe
om7HmOo?eOGoc=;bol36i_nTZLOoQX^Xoh24Won:SjGoZZg0oko2dOoLg^[o
l??hoo[kooomooh2ookoo@03oooooooXj>Soj>SX00Woj>SX1ooYjNT3on[Z
jP?ojn_[00?okNg]onc/k?o^k^h00_o^k^h2ono_k`_ol?3`0ooalO42oo?c
l`?omOGe2_ofm_H=ooOgm`_on?Sh0_oinOT2oo_kn`03ooclo?ono_koo_kn
03_ooooo00Co3eJ^ojG4i_nfd^koNJkY0_nZh?l01?m^KVko];Bdon3Ph?o/
k>aKonk^kP03ob`L5?lS70[o;1`D00;o;18000Wo8a`:ocdL2_lm4P[o;180
ob`L5?lm70[o8a`:ocdL2_l/4P000_lm70X00ol/4P3o?A`:oaX92P02ob`B
00?o8a`:00Co?A8:ob`B0?lm70[o?A`:0olS70X01ol/4P3o8a`:ob`L5?lS
9P[o;180ob<L2_l/4P000_lS70X0<Ol/4P3oEa`0ob<V2_l/4P3o8a`:ob`B
0?lm4P[o?A`:oaX92_l94P[o6Q8Do`T92_lS70[o6PT:o`T92_lA70[oAUDY
og^=I_l/>2Wo4BHDo`TB2_lA70[o4BHDodIE:Ol/9QCoPhAkojJZXolJ9QCo
2A8:oa4V5?l92ACo;3PYodIE:Ol/>2WoPhAkok2n`Oo1al7oUIRSol[@e_lA
9QCo4BH:oba<:Oo1al7oUJ6>ohfHS_l0003oNheVoa4V7_n`/kL00_o1al40
2onEV:?o/;k1ojJQV?o1XHCog;j]onC@c?oLhmKokMW<ooK]j_oLhmKog>?P
00;og;j]00?ob[j]ombn]ooLhmH00oo]fL`01ooL_[Oo`J64ojJ4Q?o1Ng_o
dn?eooKooooChoD00_nVan005OmGGVooLW9koiF4S_nEQ8koUJ6gom?SmOof
oooodn?eoiFQ]on3Q8koPiR]og:=[Oo1alcodn?eoiFcc?mbSJgo8d4modmN
I_o1alco`LO1oiFZ[@02ongfm@0:ojJZ[Oo:d=KoUJ6gok2c]ooChoGom_oo
ooK]j_oL_Zgom/LmooJc00?om/Lm00?om/LNooK7?OoffFH00_ofa`X03Oof
acgoonf>ooKII_ofaakom/L:ooKII_ofacgoomTYooJc0?oofCgoi:X0ooKo
mOookHh01Ooohh@01_offFKoon>4oooSQ?offFKoomTmooKIIP;oomTY00?o
m/LmooK77_oTZP000_oTZP000onEE@3oNd`:odH_2P02ob<L2P0?oaX92_lA
70[o;180o`T92_niQ1Cog<NSom>nS_niSBWo;1`DoaXB5?l92@[o4A`:ob`B
0?oL/eco/8eB00;oWW/c00KoAUDYoc@_7_lJ9QCo6PT:oaXB5?l92@X2oa4L
2P07oaX92_l92ACo;180ob`L5?l/4P3o6Q8Dob`V5002ocdL2P04ocdB2_m6
9P[o8bH:odHV50;o?A`:00?o8bH:ocdL2_lm70X00_lm70X01om69QCo?A`:
odI17_m69QCoARH:ojIb5?oChoD0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@000_ooool03?omoOgok>c/ogIfM_oJf][oh>3Pon7QhOoDe=CoalO7
ol_;boo>c/kod=3@om?Cd`SoeMGE01?oooomoocln_ooooooooooooKgnooV
i^kob<[FojRZ^On@TjKoQX^Qoi>G/_nTZLOo_L;RoloEmoo9co?oc=;domCP
m_oGi?Gof^Oh00;og>Wj0ooKj?T8on7^oc3ohNkn2?oNjo`01?oOk?gogN[k
om_XnOoJioP3omWVm`0BomWUnoo=e_Ooc=CiolWAmOo4c?3o_L?Uoj^adOnB
UkGoO82KoiJH[onY[;oob<[Gon;Uk?ocm?WonO[loocnnoonoogooooo0ooY
jNT2on[ZjP?ojn_[0oo/k>`7ong]k@Kok^k^00?ol?3`ono_kooalO401?oa
lO4;oo;blPColo?c1?odm?@:ooGem@Gom_Kf0_ogmoL00oofm_KomoOgooOg
m`03ooOgm`_on?Sh0_oinOT2oo_kn`03ooclo?ono_koo_kn03_ooooo00Co
3EF^ojK6i_nidnkoNJk[0_n[gol01?mfMWKo`L71oo3`l?omoOeKooooo`04
ob`V5?lm70[o8a`:ob<L2P;o?A`:0olS70X01?lm70[o8bH:ob`B0?lS9PX2
ocdL2P0Mob`B0?lS9P[o?A`:ob<V2_l/71Co8a`:ob`B0?lJ2@[o8bH:odHV
2_lm70[o8bH:ob`B0?lS70[o;180ob`L5?l/4P3o8a`:ob`B0?lm4P[oARl:
oaX92_lm70[o;180ocdL2_lS70[o?A`:ob<L2_l/4P001?lS70X02ol/4P3o
2A8:o`T92_l92@[o2A8:oc@_7_l/71Co2@T:odI<?OlA9QCoH5hc00;o4A`:
0_lJ4Q@09Om6C3goCeiVoiFQS_lA9P[o6RHDoa4V5?l92@[o4A`:of1N<olS
;akoPhAkoh>=Q?nEZZgo/;>gok2n`Oo:d<7o0000ocAE:On3SHCoLW9kojJZ
[OmGSEco0000ofZ=G?mbEE;oYZZSojJc`On`/kOoUJ6>ohf=KombIe;o/8Ak
ol6c[OoTd<coi<O1onC@c?oLhmH00_oTd<`02?oL_[Oob]31ombn]ooTal7o
kMW<ooK]j_ofm_GokOKe0_ofkNX04OoTal7og;jgol5kNooChoGom_oool77
c?nVan3oUJ6goeMNKon3SHCoUHB>ok2n`OoChoGom_ooom?SmOn3V;OoLW9k
00;oPiR]00[odn?eojK7h?nVan3oUK?<ocAWNom?LW_oAUEBooooooo1alco
dmWF0_o]m_D00on`_/7odn?eongfm@02ooKoo`03omc7Xoof/`3om/LN00?o
m/Lm00coi;<NoooI:Oofa`[om/LmoooI:Oofa`[om/LNoooSS_offFKom/Lm
ooo@0?oofCd3oooI:@03ooK7?Oof/`3oong<00;oonf>0_oohh@01?ookHko
m]UVooo]S_oohh@2ooKIIP04oooSQ?offFKoomTYoooI?@;om/Lm0_oTZP00
3ooCV0[oUED0oiEE0?m69P[o6RHDob<L2_l92@[o6PT:oa4L2_lJ4QCodj4Y
ongIc?offFKog;=LodH_2P02oa4L2P0>oaX92_l/4P3okLMLolZZI_nNSC?o
^HdcofYE7_ld;ako8bH:oa4L2_l94P[o4A`:o`T92_lJ2@X2o`T92P07oaX9
2_l/4P3o8a`:ocdB2_lm70[o;2HDodH_2P02odHV2P04ocdL2_m69P[o?A`:
odHV50;o?A`:0_m69PX02?m69QCo?A`:odHV5?mG703o`G]kombn]ooooooo
dmWFGoooool01?n_[joobl_;omkNg_oZj^X1oo;blP000_o^k^h01?o/k>co
g=cLogalO?oJf]X2on3Ph006om?Cdoo6a/Koc<c<olk>c_o@d=3odm?C2?oG
emL05?oooogoo?cjoooooooooooolO;gomgMionm_lcoVij_oh63V?n9SJKo
YZ_9okFjf_nna>SoaL[`olC9lOo>e_[oe>3homCTm?oFi_KoenOg0_oFi_H0
0ooGioOof>Shom_[n`07om_[nc3ofn_j2?oIjOT00ooKjo_ofNWiomKVmP04
omGUm@0BomCSn_oMiooofn?oolgEo?nla>Wo][_Qok:hg?nSYl[oTIJdohB8
XonHVZoo^K_:om_NioodmO[oo?gooogoo_omoocooooo0ooXj>P2onWYj@?o
j^[Z0oo[jn/6onc/k003om[Jf_oNg]kokNg]00CokNg]0_o_knl5oo7al@04
oo;bl_oOgmool?3`oo;blP;oinOW0_obl_800oo_knooh^;Roo;blP08oo?c
l`?om?Cd00?ofMWIolc<c?oclo<01?odm?@5ooGem@03ooCdm?oWinOomoOg
00GonOWi1?ojn_X2ong]k@Gon_[j00?ono_koo3`l?oUiND00_olo?`2oogm
oA7oo_kn:_ooool01?lAEjooXl;TokSCkomg[^/2oj[Oo`04ofi^K_nd];Co
h>3Ponc/k5_ok^k^00Co;1`Dob<L2_lm70[o8a`:0_lS9PX00olm70[o;1`D
oc@_7P02ocdL2P06ob`L5?lS9P[oARH:ocdL2_lS70[o?A`:1?l/4P002_lm
4P[o;180ob<L2_l/4P3oARH:ocdL2_l/4P3o?A`:ob<L2_lm70X4ob<L2P08
ob`B0?lm70[o;180ob<V2_lS70[o?A8:ocdL2_l/4P02ocdL2P06ob`B0?l/
71Co;180ob<L2_lm4P[o;1800_lA70X03Om6C3goEheLoiFHXon`/kOoARHD
ocAE:OlA70[o6Q8Doa4V2_lS;akoAUDYofYkKol94PX00_lA70X01ol92ACo
4BH:oaXB5?lA9QCoAT`moh>HS_nEZZd00_nEV:<06On`_/7oSIR>ocAE:OlS
;akoYZ6Hog9bNon=V8ko4BH:oeMWD_lm;cgoNhf4og:=Q?lmGSgo8blYoc@_
<omP@BWoPehcoij4I_nVQ8Co`J64ol6c[OoL_[Oo`LO<onC@c?o:d<400_o1
/jd01Oo1XHCog;>]ongIc?o]fLcom_oo00;om_Ke00_om^gZong]j_ofkN[o
kMW<ol5kNonVZZ?odn?eojK7h?n`_/7oY[?1oeMEDP02ok2c]`?odn?e00ko
LXf]oh>4NonEV:?oY[?1ooKooonVan3odn?eojK7h?mbSJgoJW^4ocd_?OnE
V:?okOKeol77c0;okOKe00Kodn?eomcSh?ofoooom_ooooooooo]ae`2ooK7
7P04onBc7_offFKom/LmooK77P;om/Lm00Wom]UVooK7?Oofaakom/LNoooS
Q?offFKom/LmooJc0?offFH00_ofacd00oofaakoomTmonBZ0003ooo]SP04
ooKII_oohhCoonf>oooSSP?oonf>00Ooon>4ooo]S_offFKom]UVoooI:Oof
fFKom/Lm00;oi:X0013odiP:oiEE0?mkC0[oARl:ob`B0?lJ4QCo4A`:oaXB
5?lS70[o6PT:ombZ<oo]d9SokMW<ooKII_ldEBWo4BH:0_lA70X02?mG703o
bZ5Boiik<on3GQCoWXdcojJ4D_l/9QCoAT4N0_lJ4Q@01?lA70[o6Q8Do`TB
2_lA70X3ob<L2P09ob`L5?m69P[o?A`:ocdB2_mG703oARH:odHV5?m69P[o
ARHD00;oARH:00SoARHDocdL2_m69P[o?A`:oc@_7_mG703o/7]VooK]jP?o
oooo00?ob]3Fonk^k_o^k^h0GOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Q
h@000_oVi^H01?oTi>Coe=CDogalO?oJf]X2on3Ph006om?Cdoo7alOoc<c<
olk>c_o@d=3od];B2?oFe]H05?omoOgono_kooooooomo?oojn_comGEhOne
]lKoUIR[ohJ8Won=TJcoYZ_;ok6ef?ng_>;o`lSbolW@o?oKiOoocmkeom7R
l_oDiOGoe^Og0ooEi_H00ooFioOoeNKfomGVmP06omGVmS3oeNOe2?oFioL0
6OoHjOWoe^OgomGVm_oEi_Koe^OgomGVm_oCi?CodN3gol7;koo8dO[oc=Gn
olK?n?nk`^co[[?IoijRaonCV;SoPhNTohnDZ_n]/<7od]KQonobnOokoooo
o_ooookooOooool00ooXj>P00ooYjNWoj^[Zoc4a<@02o`000004o`L71ol[
:b_oJVYZon7Qh@?okNg]00Kobl_;oc4a<Ol=3@go2`/;ocDe=Oo=cLd2onk^
kP06oc/k>omgMgOokno_oo3`l?nIVIWo6QXJ0_o`l?003_m<C4co1`L7oaPH
6?nCTi?o4A4Aoe9BD_oalO7o];BdoaTI6Ol61PKoCDe=ogmoOol];Bgol_;b
0_oclo<3ooCdm00;ooGemOnGUiOo4Q8Bo`P82?lU9BGo6ATIodU9BOo@d=3o
mOGeocdm?OmjNWX00oofm_H01_nh^;So6QXJo`H61_m?CdooPX:2obh^;P;o
nOWi00Wo?ShnogalO?ojn_[on_[job@T9?l?3`oo7alOod];BooalO400_oj
n_X01_oRh^;oB4Q8o`820_lR8R;o5QHFokno_`;oo_kn>oooool01?lAEjoo
YLCVokWCkomg[^/2ojWLo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00So;2HD
ocdL2_lS70[o?A`:ob<L2_lm70[o;180ocdL2P;o;18000Co8a`:ob<V2_l/
4P3oEa`00_lm70X01?l/4P3o8a`:ob<L2_l/4P02ob<V2P05ob<L2_l/4P3o
?A`:ob<L2_lm70X00_lS9PX00olm70[o;180ocdL2P02ob`B0005ocdL2_m6
;`[o;180ocdL2_l/4P000_lm70X04OlS9P[o?A`:ob<L2_lm70[oARl:ob`B
0?lm70[o8bH:ob<L2_lA70[o2@T:ob`L5?m?IdOoJW9LoiFHXooCfMKom_oo
00;o4BH:0_lA70X08_m6C3go=2lNo`000?lA9QCo2A8:o`T95?lJ71koAT`m
ob`h:Ol92ACoAT`modIED_n3Q8ko/;>godmNI_oLhn3o;4`Yo`TL7_mbEE;o
JW]_oiFZ[Ol/C2Wo2@T:ohf=D_nEQ7_oPhf4ohf=D_m69QCo6Q8Dob`L5?mP
@BWoJVLcoiEbAonVLU82oiF4N`0;ojJ4Q?mbIe;oLUEBoh=kG?mbIe;oLUEB
oiF4NonVQ8Cob]31ombn]oo]fL`01?ofm_D01_ofkN[om_KeomcSh?oL/jgo
dmWFom?Sm@;oY/OP00?oJW^4oh>4S_n`_/400ooChoD03on3V:goLW9koiFH
Xoo1alcodn?eojK7h?ofooooY/OPoh>H[OnEXKOoJW^4odI<?OnEV:?ooooo
om?Sm@03ongfm@;om_oo00GoooooonBcAooTZP3om/LmooJc0002ooK7?@0C
ooK72_ofaakom/Lmong7G?oofBWom/LmooK77_o]d9Soon>4ooo@?Oofa`[o
m/LmoooI:Oofaakom/L:ooK7?OoTZP3oong<ooo]SP02oooSQ003ooKII_oo
hhCoonf>00?oonf>00Com]UVoooSQ?offFKom]UV0_oofCd07_ofacgoi;<N
onBZ0?oCQ03oYW80og]<2_mP;`[o4BH:ob<L2_lA70[o6PT:ob<L2_l92@[o
dj4YooKomOo]d9Sog<NSoh=N5?lS9P[o2A`Nob`B0?mG703oWW8cokUb<old
;c?oJVLcolZH:OlJ9QCo8blNob<L2P;o4A`:00Go2@T:o`TB2_lJ2@[o8a`:
ocdL2P02ob<L2P06ob`L5?lm70[oARH:odHV2_m69QCoEa`00om69PX02Om6
9QCo8bH:ocdB2_ld;akoPbl0ol6QQ?ookLcoooooooKoo`03ooooo`03ol[@
e_oVi^Koi^KV05goi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;ok^k^
00Cok>c/omcLg?mlO7cof][J0_oPh>001_oDe=Cob<S8ol_;boo>c/kod=3@
om;BdPSoe]KF01?oookoooomo_ooo_oonOSmon7Qjoo5amCoY:Njoh:6Won=
T[3oSI6doj2Tb_n//MWo^KkXolC9loo2ao7ob=3eolOCkOo9f>goc]gb00;o
dN3e0_o@go@00oo@go;od=odom3OlP07om3OlP0>om3Pl?o@go;od>3`om3O
l_o@h?3od=obom3Pl?o@go;od>3`om3Ol_o@h?3od=obom3Pl?o@go8Com3P
l00<om3Ol_o@h?3od=obom3Pl?o@go;od>3`om3Ol_o@h?3od=obom3Pl?o@
go;od>3`0_o@go82oloNl@0OoloNloo?g_7ocmkcoloNlOo?g_?ocmkaoloN
loo?g_7ocmkcom7PlooCh_OodN3colcKl?o8e_3odm_oolK=nonma?3o_/G_
ok[1jonY/MSoUic2ohbB]_n8S:ooS96_oj6U__o4amSoi>KbooKgnoolo?co
oookooooo`03onSXj0;oj^[Z01Co<C4aof][Joo/k>cohn?Sokfm_Om0@43o
7QhNon3Ph?o^k^kokNg]oc0`<?m<C4cog]kNomoOgom?Cdoo<C4aonk^k_o_
knoo>c/kogMgM`;okno_00WoV9RHoaXJ6_o_knoo^KVio`<30oo@d=3of=SH
oeEEEOl@41000_o`l?002Om?CdooDe=ConSXj?nDU9Co3Ph>obd];OoalO7o
l_;boo?cl`03ooCdm00;oi:BT_l20P;oQHF5oo;bl_oemOGolo?coj^[Zoo?
cloomOGeocdm?OmjNWX00oofm_H01_mADE7oEUIFono_konIVIWo3Ph>obh^
;P;on?Sh00Wo?ShnogalO?oinOWonOWiok^k^ooemOGon?Shoc@d=?n>SXh0
0_oinOT01_m2@T;o?Shnom[Jf_olo?col?3`ono_k`;oo_kn>oooool01?l=
E[7oY<CVokWCkomf[NX2oj_Po`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Co
;1`DodH_2_lS70[o8a`:0_lm70X01OlS70[o?A`:ob`L5?lm70[o8bH:00;o
?A`:00CoARH:ob<L2_l/4P3o8a`:0_l/4P003?lS70[o;180ob`B0?lJ2@[o
8a`:ob`B0?lm70[o8bH:ocdL2_lS70[o?A`:ob`B00;o8a`:03_o;180ob<V
2_l/4P3o?A`:ob<V2_lm70[oARH:ob<V2_lm70[o8a`:ob`B0?lS9P[o;180
ob<V2_lm70[oARH:ob<V2_lJ2@[o8a`:oaX92_mGEE;oJW9LoiFQ]oo:d=Ko
dn?eof1N<olA9P[o8bH:ob`h:OlA9P[o2A`Doa4L2_l94P[o2@TDoaX92_mb
SEco2@T:og:=G?m?IecoH5hcoeMED_mZLUcoAVMLoba<:On`/kOo0000ob`L
5?mZIc?oJW9LojJZXol0003oYYQ_oc@_:On3Q7_oLXeLodI<?OlA9QCo4A`:
oa4V5002of11:@0Aog9WD_mbEE;oPg]Log9ED_mZIc?oUG97og9ED_mZIc?o
UEhcok1kI_o1XHCog;>Sombn]ooTal7oi=3<ong]j_ofm_D00oofool01?of
ooGom^gZooKfmOmbEE82om?Sm@04ok2n`Oo:d=KoPhB>oiFQ]`;o`LO<00Oo
Y/OPoiFHXon=SFooUJ6gom?SmOnE/lcoY/OP00;odn?e01GoPiRgom?SmOnE
/lco=5DYoeMWD_o:d=KokOKeom?SmOooooookOKeongIc?ofooooooooonfn
?OoTZP3om/L:onBc7_ofaakom/L:onBc:Oofaah01?ofacd01_ofa`[om]UV
ooKII_ofaakoomTYooKIIP;om/Lm00?om/L:ooK77_oTZP000_ookHh2ooKI
IP03oooSS_ookHkoonf>00?oonf>0ooohh@01?offFKoomTmong7G?ofacd2
onBZ0005om>H2_nVLP3oPd40of0_2_l/9Q@00_lA70X06olJ4QCo8a`:o`T9
5?nVLP3oong<ongIc?ookHkoNd40ob<V2_l94P[o8a`:ocdB2_o:XE;oi;=7
okUb<on3GS?o/8dcog]<5?lS9P[o6RHDoaXB5?l92@[o4A`:oaXB5?lJ2@[o
4A`:ob`B0002ocdL2P0:ocdB2_m69P[oARH:oeLL0?m69P[oH2l:odHV2_m6
9QCo;2HDoc@_7P;oARHD00Go/7/Yooo]c?ooooooooooooKoo`04ooooo`03
ol[@`Oo^k^kok^k^05gok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;o
oooo00cooOgmonc/k?mkNg_of][Jon3Ph?oQhN7oeMGEolS8b?o:b/[oc/k>
om3@d?oCdm<8omKFeP0AoooloooooOoooogoooKenooTi?3o_/7DoiRN^?m]
LiGoO8>]ohZA_onIWm7oYZ[JojjbhOnh^nKo`<;Yol;6jOo7d>l00_o5d>`0
1_o7d^kobmKbolcGloo;e_;ob=C^ol[El@Sob]K`00kob]K^ol[Fl?o:e^ko
b]K`ol[Fk_o:e_3ob]K^ol[Fl?o:e^kob]K`ol[Fk_o:e_3ob]K^ol[Fl1?o
b]K^00cob]K`ol[Fk_o:e_3ob]K^ol[Fl?o:e^kobmOaol_Gkoo;eo7obmO_
ol_GlOo;enl4ol_Gl@0Ool_Fl_o;eo7obmKbol_GlOo;e_;obmOaolWDl?o:
e_3obmKbolcHl_o<eo?ob]K`olSCkoo8dO;oa/WfolG7n?no`^oo][_Uojfe
g?nU[MCoV:7:ohbE__mnQK7oKW>MoiVM`_o0`Moogmk`ooCcnOomo?[ooooj
ooooo@03onSXj0;ojNWY00?o<C4aofYZJ_oZj^X00_o[jn/06_oVi^Ko71`L
ofQXJ?o/k>coalO7o`000?nYZJWok>c/ong]kOnZZZ[o0000olc<c?o]kNgo
>c/kogMgMoo_knoolO7aoiZJV_lJ6Q[olO7aolg=cOl20P;o/k>coo;bl_nF
UYKo7QhN0_obl_801_lY:BWoR8R8oo;bl_obl_;oM7Adobd];@Golo?c00?o
k>c/oa<C4omNGUh01oodm?@03olm?CgoNWYjooGemOoemOGom_KfobXZ:_n<
S8con?ShooWinOmhN7So;bl_oo_knoolo?co?clooginOP04oogmo@08ol?3
`olE5AGoTI6AoogmoOoKfm_o0000okJf]_omoOd3ooknoSgooooo00Co3EF^
ojG4i_ned>koNJk/0_nWg?l01?mfMWKo`L71oo3`l?omoOeKooooo`0;ob<L
2_l/71Co8a`:ob`L5?l/4P3o;1`Dob<V2_lS70[o;180ob<L2_m69PX00_lm
70X03?lS9P[o?A`:ocdL2_lm70[o8a`:ob`B0?lS9P[o?A`:ob<L2_l/4P3o
4BH:odHV2PGo?A`:00[o8a`:ob<V2_lm70[o8a`:ocdL2_m69QCo;180odHV
2_lm70[oARH:0_lm70X00olS70[o?A`:ocdL2P03ocdL2P;oARl:0_lS70X0
1OlJ71koCfM7og^=I_nEZZgo`LO<00;odmWF01Co0000oa4V5?lA9P[o2@T:
oaXB5?l92@[o6Q8DodIE:Ol/C2Wo6Q8DoaXL7_n3Q7_o8blNoh>HS_nEXHko
UIRSog:=?Ol/>2Wo6RHDob<_7P;oLXeL00_oJXeLob`h:OmkSFKoUJ6>o`TL
5?ldEBWoAUDYoaXL7_l94P[o6Q8DodHV5002of11:@04og9ED_n3GS?oJVLc
of11:@;oLUEB00OoJVLcoiE<:On`NfKo/8AVol5kNooTZYSoi=3<00;okMW<
00Gom^gZooKfmOofooooooooooKoo`02ooKfm@05ooK]j_o1XHCo/;k1om?S
mOo1al`00_nVan008OnE/lcoUJ6gom?SmOnVan3oUIRSoeMNKoo1alcom_oo
ojK7h?n3V;Oodn?eooKooonVan3odn?eojK7h?mbSJgo8blYooKooooChoGo
kOKeooKooonEV:?og>?FooKooooooooodiP:ooJc0?ofaakom[<0ooK77_o]
aecom/LmooK77P02ooK7?@0?ooKII_ofacgom/L:oooSS_ofd8CoomTmooK7
7_ood3goomTmooK7?Oofaakom]UVooJc0?offFKoon>400;om]UV0oookHh0
0ooohhCoonf>ooo]SP02oooSQ006ooo]S_oohhCoomTYooKII_ofa`[oi:X0
0_oCV0X00on`LP3oSED:odH_2P02ob`L50;o4A`:01_o6PT:oaXB5?niQ1Co
ong<ongIc?ookLcoLXdmoa4V2_l94P[o4A`:oeLL0?o:XE;oi;=7onBc<ooC
XBWoUEhcokV=:OmP;aCo;1`DoaXV5?lJ4QCo2A8:oa4L2_lJ2@[o?A8:oaXB
5?l/71@00_lm70X03_mP;aCoEa`0of0_5?mP;`[oARH:odHV5?m6@AkoARHD
oeLL0?nVLU;om^gZooKfmOooooookOKe1_ooool00oo:d=Koooooooooo`1M
ooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP04onc/k?oLg=co
Ng]kom[JfP;oh>3P00Koe=CDolS8b?o;bl_oc/k>om3@d?oBd]88omGEe@0I
oookooooo?oooogoooSeo_oOhNko_/?IohF;Zom/LigoNh>dohR?aOnGW=Co
X:GLojR/g?n`/mko]kWOokZmh?o0a^[o_LGYokg5j_o0b>co`l_`olK>l_o5
cO7oa<g^olC<l002olC=kP0DolC=k?o4cNkoa<g/olC=k_o4cNcoa<g^olC=
k?o4cNkoa<g/olC=k_o4cNcoa<g^olC=k?o4cNkoa<g/olC=k_o4cNcoa<g^
olC=k?o4cNh2olC=k00=olC=j_o4cNcoa<gZolC=k?o4cN[oa<g/olC=j_o4
cNcoa<gZolC=k?o4cN[oa<g/olC=jP04olC=k00<olC=k_o4cNcoa<g^olC=
k?o4cNkoa<g/olG>koo5c^goaLk_olG>kOo5c^ooaLk]1?o5c^l07oo5cO7o
aLk_olG=lOo5c^ooaLgaolG>koo4c?3oaLk_olG=lOo5c^ooa<c`ol;;k?o0
b>co`<G[ol30l_nn__3o^;_Xok2egonX/=OoWjSAoi:Nb?n7T/3oOhNhofY`
X?n0Pk3o_KgQon?Qmoomo?ooookkoocil_ooood00ooYjNT01OoZj^[ojNWY
oc4a<OmZJV[oj^[Z00?ojn_[01;oLW9boalO7oo/k>co[jn_o`000?oDe=Co
k>c/ong]kOoCdm?o0000ok>c/oo]kNgo>c/kogMgMoo_knoolO7aoiZJV_lJ
6QX2oo7al@05ojBTY?l_;boo<30`oc<c<olN7Qh00_obl_801_lY:BWoRh^;
oo;bl_obl_;oR8R8obd];@;olo?c0oodm?@00oo:b/[o0000okZj^P07ooGe
m@03ocdm?OmjNW[om_Kf00;om_Kf00Ko:RXZohj>S_ohn?Son?Shohb<S?l_
;bl2oo[jnP0=ochn?_mmOGgono_koo_knooPh>3oB4Q8o`820_m_Kfool_;b
oo_knonk^k_o0000oc`l?003ochn?P03ol;2`_ono_koo_kn03_ooooo00Co
3EJaojC4i_nhd^koMZgZ0_n/gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP05
ocdL2_m69QCo6Q8Dof11:Ol/71@00_lm70X00olS70[oARH:odHV2P02ob`B
0003odHV2_m6;`[o?A`:00;oARH:0_lm70X07?lS70[o;180odHV2_lm70[o
6PT:odHV2_mG703oARH:ob<L2_lS9P[o8a`:ocdL2_l/4P3o;1`Doc@_7_lm
70[o8bH:odHV5?l/4P3o?A`:ob<V2_m69P[o8bH:ocdL2_m6;`[o?A`:odH_
2_lm70X2odHV2P0AocdL2_lS9P[o6PT:ob<V2_mGIe;oJW]_oiFHXooCfMKo
kNgZooKoooo1XHCo0000oa4V2_lm70[o4BHDoaXV5?lmGSd00olS;ah04?l9
4P[o;3PYo`000?mZLUcoSIR>ojJZXol0003oUJ6>oiFHI_ldEBWo4BHDob<_
7_l/>2Wo0000odmWAolA9PX2oa4L2P0GoaXB5?l0003o6Q8Dob<_7_m6@Ako
H44Yog]<5?n3GS?oLUEBoh=N<omZIc?oPehcof11:OnEC2WoYYQ_ok24I_nE
LTOo`J64ombc[OoTd<coi<O1ongIc?ofool00_ofm_D3ooKoo`;om_Ke00oo
kMW<oij4I_oChoGo`LO<ojK7h?ofoooodn?eoiFcc?nV/l7o/;k1ojJc`On3
Necodn?eooKooooChoD00_n3V;L03?o]m_Gom_ooom?SmOofooooYZZ]oh=N
<onVZZgom_ooomcSh?nVXISo`K>>omcSh0;ooooo00GobYPDooK77_oT/c?o
m/L:ooK7?@02ooK77PGom/Lm00Goi:X0oooSS_ofd8CoomTmooK77P02ooKI
IP0<ooK72_ofacgom/LmooK77_oohhkoong<oooSQ?offFKoon>4ooo]S_oo
kLcoon>40_ookHh00ooohhCoonf>oooSQ002oooSQ00?ooK7?OoffFKoi:X0
om>H2_oTZP3o/780oh=10?mZ@@[o=2lNoaXV5?l/71Co4A`:ob`L5?l92@[o
/7/D00?oong<01SoWXdcodI17_lA70[o2A8:ob`B0?offFKom]24ong7G?oT
/dOo^G8colZQ?On`C03o;1`Dob<_7_lA70[o6Q8Do`TB2_lJ2@[o8a`:ob`L
5?lm70[o?A8:of0_5?mG7004of0_5004odHV2_nVC03og;>]ooo]c0Cooooo
00?okOKeooKoooooool01?ooool00oo1alcok^k^onk^kP1Monk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q0002onKViP04onCTi?oDe=CoO7alom[JfP;o
h>3P00Koe=CDolS8b?o<c<coc/k>om3@d?oBd]88omCDe00Ioooko?oooOgo
oogoooSgoooKgNco`LGNofY`T_m]M:3oMgjdoh:;a?nAUm7oVYoGoj6TeonX
ZmSo[k7Gok2dfOnd^N7o/KSRok:iiOnd^nGo^;o[ok_2k?nl`ngo_<C[ok_2
k002ok_3jP0Dok_3j?nk`n[o^l?Xok_3j_nk`nSo^l?Zok_3j?nk`n[o^l?X
ok_3j_nk`nSo^l?Zok_3j?nk`n[o^l?Xok_3j_nk`nSo^l?Zok_3j?nk`nX2
ok_3j00=ok_3ionk`nSo^l?Wok_3j?nk`nOo^l?Xok_3ionk`nSo^l?Wok_3
j?nk`nOo^l?Xok_3i`04ok_3j00<ok_3j_nk`nSo^l?Zok_3j?nk`n[o^l?X
ok_3j_nk`nSo^l?Zok_3j?nk`n[o^l?X1?nk`nX07onk`^co^l?Zok_2k?nk
`n[o^l;/ok_3j_nk`^co^l?Zok_2k?nk`n[o^L3ZokJniOnd^nGo];WSokFg
j?ne]NOo[k;OojR/fOnQZ=;oVJ;=ohbGaOn2S;ooNH2fofU_XomVJYOo_/7T
on3Qm_omo?ooookkoo_hlOooood00ooXj>P2onWYj@03oc4a<OmZJV[oj^[Z
00?oj^[Z01;oTI6Ao`820_oUiNGob/[:o`000?nUYJGojn_[onc/k?nTY:Co
0000om3@d?o]kNgo>c/koeMGEoo^k^kol?3`oi>CTolK6a/2oo7al@;ol_;b
00?ol?3`ohb<S?lO7al00_obl_801olY:BWoRh^;oo;bl_obl_;oR8R8obd]
;Ooclo<00_odm?@2ooGem@03oj^[Zol0003of][J00Oom_Kf00?o?CdmofEU
IOogmoL00_ogmoL01_lZ:R[oSXj>ooOgmoohn?SoRh^;obh^;P;on?Sh00Oo
?ShnogalO?oinOWonOWioclo?om0@43oeMGE00?onOWi00OoeMGEo`000?nW
YjOob/[:olC4a?l20P;oh^;R00;oo_kn>oooool01?l?EZkoY/KVokK@k_mi
[nh2oj_No`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00Co;2HDob`L5?lm70[o
4A`:0_lm70X02Om69P[o?A`:ob<V2_l/4P3o?A`:ob<V2_lm70[oNd`:oeLL
0002odH_2P04ocdL2_m69P[oARH:ocdL2P;o8bH:00[o8a`:ocdL2_lS9P[o
8bH:ocdL2_lS70[o?A`:ob`B0?lm70[o8bH:0_l/4P000olm70[oARl:ob<L
2P02ocdL2P06odHV2_lm70[o?A`:ocdL2_l/4P3o?A8:0_m69PX05Om6;`[o
ARH:odH_2_lm70[o6RHDoeMWD_n3Q7_oUJZ]ok2n`Oo:d=Kom_ooojJQI_mZ
@@[o4BHDoaXV5?lA9P[o6Q8Do`000?mGIe;oSHe_o`000003o`TB2P0HodmW
G?n=V8koCfM7o`000?nEXHkoCfM7ob<_:OmPGS?o=5DYo`T92_lA70[o6Q8D
o`T95?lJ4QCo2A8:oa4L2_l92ACo;3PYodHV5?mZEAkoPehcof11:On3GS?o
JUDN0_mZIc<02OmZEAkoPehcok24Noo1XHCoYYQ_ok1kI_o1Ng_og;jgonC7
`@02ongIc003ooK]j_ofm_Gooooo00;om_oo013om_KeooKoooofooookOKe
oh=N<ooChoGob]3FoiFQ]ooChoGom_ooom?SmOo1alco/;k1ol77c?nEV:?o
dn?e0oofool03?oLhn3okOKeongfmOo]m_Gom_ooooKomOoooooom^gZooKf
mOo]kN[om^gZol[@`@;om_oo00WoooooolZH5?oTZP3om/LmooJc0?offFKo
m/LNonBc:Oofa`X00_ofacd01oofaakom/LmooK77_ofd8Coon>4ooKII_of
aah00_offFH00ooofBWom/LmoooI?@02ooK7?@07oooSS_oohhCoon>4ooo]
S_ofd8Coonf>oooSQ002ooo]SP?oon>400koonf>ooKII_ofacgom/LNonBc
<ooTZP3o`H@0ok1b0?nEE@3oJT4:ob`L5?lS9P[o4A`:oaX92P;o4A`:00ko
Nd`DooKomOofooGoong<oij=:OldEBWo2@T:oa4L2_l/4P3oom0mooK@Q?o]
ahCom]UVom>ZA`;odj4Y00GoNd`Doc@_7_lA70[o6PT:o`TB2P03ob<L2P03
odHV2_lm4P[oH2l:00CoH2lD00?oLRH0ong@V?ooool01Oooool00oofoooo
kOKeooKoo`05ooooo`03ol[@`OoVi^Koi^KV05goi^KV00CoWIfMokNg]oo8
b<Sodm?C0OoJf]X000;ok^k^00cok>c/omcLg?mkNg_ofMWIomoOgooQhN7o
e=CDolO7aoo<c<coc/k>om3@d?oEeMD8omCDe00Aoookn?ooo__oookooo_j
oooJg>_oaLWRoe5FO?mYLJ3oLGNaogb4`_n;TLooTiWCoiZPe?nSYmKoZJgC
oj^_eOn//=d00_nZ/>001On//^;o[[CTok6gionc^^So];_Y00;o/k[X5_nc
^^H03_ne_>So]KcVokFlj?ne_>Ko]KcXokFli_ne_>So]KcVokFlj?ne_>Ko
]KcXokFli_ne_>So]KcV0_ne_>P8ok>jiPSo/[WU3?nb^NL01?n`]nGo[[GS
ojbchOn]/N02ojb^gP0?ojN[f_nOY];oVZ;@oiBLbon8T/GoOXNnofie[?mY
KZGoEe^:olG8jooJfo3olo?koooonoooooSoooom00?oj^[Z00Gojn_[on[Z
j_la<C7oJVYZon_[j`03onc/k006ohF5QOl410Coj>SXonc/k?ll?3co@T92
0_o=cLd02_m1@D7o?cloong]kOo]kNgo>c/koa8B4_m^KVkod=3@oe5ADOm8
B4P2ono_k`05ojVYZOo=cLgokNg]oe]KFom?Cdl00_o`l?002OlY:BWoRXZ:
oo3`l?o`l?3oQhN7obd];OoalO7ol_;boo?cl`02ooCdm003okjn__l0003o
bLW900OomOGe00Oo?Cdmoa8B4_n;Rh_ofm_KooCdm?lZ:R[oSXj>00;omoOg
00KoRh^;obh^;_ohn?Son?Shochn?_mlO7`2ooWin@05ocDe=OnBTY;onOWi
on;Rh_odm?@00_oinOT01_lm?CgoJ6QXoo;bl_nLW9co:RXZooclo0;oo_kn
>oooool01?l<DjkoY<?UokSBkomi[^`2ojcOo`04ofi^K_nd];Coh>3Ponc/
k5_ok^k^00?oARHDodHV2_lS70X00olm70X01_lS9P[oARH:ocdL2_l/71Co
ARH:ob`B00;o?A`:00KoARl:oeLL0?m69P[o?A`:ob<V2_m6;`X2ocdL2P08
ob`B0?l92@[oEa`0odHV2_l/4P3o?A`:odH_2_l/4P02ob<L2P08ocdL2_l/
4P3o?A`:ob<V2_lm70[o;180ocdL2_lS9PX4ocdL2P;oARH:017oARl:ocdL
2_lm70[oARH:ocdL2_lS70[o6Q`Nog^=I_n3Q7_oNhf4ol6c[OoLhn3ooooo
ocAE:OlS9P[oARl:ob<_:@02o`T92P0Aoa4V5?m6EBWoAUDYoa4V2_l/9QCo
2A8:o`T92_l/>2WoNheVo`T92_l94P[oCfM7odI17_l0003o2A8:o`T95?lA
70X00_l92@X01olJ4QCo4BHDoaXB5?l92ACo6RHDof0_5?mP@BT00_n3GS<2
oiEbA`0<oij4I_nELTOoPehcoh=N<onVQ5;oYZ6HojJ4Q?nVLU;o`G]kol6Q
Q?oL/j?oi<O10_o]fL`01?ofkN[om_KeooKfmOofm_D2ooKoo`04ol[@e_o1
alcoAUEBocdB2P;okOKe00?okNgZongfmOofool00oofool2omcSh005ooKo
ooo]m_GokNgZooKomOo]m_D00_oLhn000ooLhmKokOKeongfm@02ongfm@0;
ooooooo]kN[okNgZomcSh?oooooom_oooooooooCV0[oi:X0onBc<oof/`00
0_ofacd00ooTZP3om/LNooK7?@03ooK7?@05ooK77_ofd8Coon>>oooSQ?of
a`X00_offFH2oooI?@?om/Lm0ooohh@01OookHkoon>>ooo]S_oohhCoon>>
00Goon>400Coonf>ooK7?Oofacgoi;<Y0_oTZP002_n`LP3oWW8:ofY12_lm
70[o6RHDoaX92_lJ4QCo6Q`No`TB2_n3>003ooo]c00AoiF=D_mP@ACo2A`D
oa4L2_lJ2@[oi;=7ooo]c?offFKoon>>ong7G?o:XCgobYPDojIb5?m69QCo
2A8:oa4L2_l94PX00_lS70X02OlJ71koARHDodHV5?mP;aCoH44Yof0_5?mP
;`[o/8eBomc7X`07ooooo`03ooKoooo]kN[ooooo00Gooooo00?odmWFonk^
k_o^k^h0GOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool03?om
oOgok>c/og]kNooIfMWogmoOon7QhOoDe=Coa/K6olc<c?o>c/kod=3@omCD
e0SoeMGE01;ooocfoooon_ono?goo?coomgPkoo:d>[oA4Uaof1WVom/L[3o
Mgo0ohB<cOn>U=;oU9W@oifQdOnRYlooYJ[BojF[fonV[>02ojN]h@03ojR^
h_nZ/>CoZk7S00?o[;;T5_n//^82ojfch`0>ojfciOn]/n?o[K?Uojfchon]
/nGo[K?SojfciOn]/n?o[K?Uojfchon]/nGo[K?SojfciOn]/n<8ojbbhPSo
Zk7Q3?n[/N<01?nZ/>;oZJoQojR^h?nX[]h2ojFYf00?oj6Ue?nJXLooU9c=
ohfGc?n2RlCoN86lofY`[?mRIiooBTimolS<kooLg_?ol_;joooonoooooSo
ooom00?ojNWY0_oZj^X00ola<C7oJVYZon_[j`03onc/k006od];BolX:2So
k>c/onc/k?oFe]KoBd];0_l=3@d02_m>CTkof=SHong]kOo]kNgoCTi>oh:2
P_m`L73o4Q8Bob/[:ong]kL2ono_k`05oh61POl_;boo3`l?ocDe=Onh^;P0
0_o`l?002Olo?cooU9BDoo3`l?o`l?3oTY:Bod92@_oalO7ol_;boo?cl`02
ooCdm003on;Rh_l10@7oUYJF00OomOGe00_oD51@ohB4Q?mIFEWo20P8onOW
iom0@43oVIVIooShn?ogmoOoUiNGodA4A002ooWin@09oe9BD_n:RX[on_[j
oo[jn_nk^k_o>3Pho`l?3olB4Q;ohn?S00;on_[j00KohN7QodE5AOl<30co
6a/KokBd]?omoOd2ooknoS_ooooo00Co3eJ^ojG4i_nfd^koNJkY0_nZh?l0
1?mfMWKo`L71oo3`l?omoOeKooooo`05ocdL2_m69P[o8a`:ocdL2_l/4P00
0_lm70X08olS9P[o?A`:ob`B0?m6;`[o6PT:ob<L2_lS9P[o8a`:oeLL0?m6
;`[oEa`0odH_2_lm70[o;180ob<V2_mG703o2A8:ob<V2_m69P[o;180odH_
2_l/4P3o8a`:ocdL2_lS70[o;180ob<V2_lm70[o;180odHV2_lm70[o8a`:
oeLL0?l/4P3oARl:00CoARH:02koARl:oeLL0?mP;`[oARl:ocdL2_m6;`[o
6RHDodI17_mZLUcoEfMBok2c]ooCfMKokOKeoiib2_mkC0[oJUDNofY12_n3
GQCo2A8:oa4V5?m6EBWo;2HDob<_7_lJ9QCo2@TDob<_7_lJ71ko;4`Yo`TB
2_lA70[o6Q8Do`TB2_l92@[o0000o`TB2_l92ACo4A`:o`TB2_lA70[o2@T:
o`TB2_lA70[o=2lYog8h5?mkC1CoJUDN0_nELTL01?nVV8Cog;>SoiF=D_n3
GS<4oiEbA`04ok1kI_nVXISog;jgombn]`?okMW<0oofkNX2ooKoo`0:ongI
c?lS9P[o2A`NoaX92_o]m_GodmWFok2n`OoL_[Oo`LO<onC@c0;og;jg00Wo
i<O1ombcXoo]fLcokM2HongIc?o]ahCog>?FongIc?oohhh00_o]fL`05Oo]
d9Soi;j4om>nS_o1Ng_oY/OPoh>HS_n`_/7okNgZooKfmOofooGooooookUb
<ooCQ03om/LNonBc<oofacgom/LNooK7?Oofaakom/LmooK77P02ooK7?@0A
ooK72_o]aecoon>>ooK7?Oofa`[om]UVoooSQ?ofaakom]UVooK7?OoofBWo
om0mooK@Q?oohhCoon>>ooo]S_offFH00_oohhh3ooo]SP07oooSQ?offFKo
on>4ooKII_ofacgom]UVonBc7P02om>H2P05ol640?nEE@3oJT4:ob`V5?lS
9PX00_lA70X03OlS70[o4BHDoeLL0?ofooGoong<ooKomOnVXFKoARl:oa4V
2_l92@[o0000onBc:OookHh00_oohhh02?o]aecobZYVonBc:OnNGQCoNd`D
oaXB5?lA70[o2@T:0_lS70X01olJ71koEa`0odHV5?mP;aCoYVL0okVZKoof
kNX00_ooool00oofooGoooooooooo`05ooooo`03ongfmOofoooooooo00Co
oooo00?odmWFooooooooool0GOooool01?n_[joobl_;omkNg_oZj^X1oo;b
lP000_o^k^h03?o/k>cog=cLogalO?oJf][ogmoOon7QhOoDe=Coa/K6olc<
c?o>c/kod=3@om?Cd`SoeMGE01?oookeoooon?olo?[oo_ooonKYn?o?eNoo
AT]eoe=ISOmUJZ[oL7Nkogf4b?n4S<_oRY78oi6GbOnHWLOoVYo9oijTe?nP
Y][oXZSL00?oXjWM00CoY:[LojF[gOnUZmgoYJ_M5_nUZm/@oj>Yfa3oYJ_K
2_nUZmd3ojBZg0;oXjWK01;oXjWIoijRconKX/koUik<oi2HbOn:U<WoQ8g6
ogV1_om_MkGoIff[oeAKT_m2AWGob/kaonW/ooohnoooo_okoo_lm?ooood3
onWYj@;oj^[Z00?o<C4aofYZJ_o[jn/00_o/k>`00onCTi?o0000oiFEU@04
onc/k003on_[joo/k>cokNg]00CokNg]0oo^k^h4ono_k`;ol?3`00?ok^k^
oo3`l?o`l?001_o`l?03oo7al@;olo?c0ooemOD00omOGeoo8b<SonCTi007
ooKfmP;omoOg00?om?CdooShn?ohn?P00ooinOT3oo[jnP;ono_k1Oolo?`0
0ooinOWoo?clooclo004ooclo004ooWinOomoOgooOgmooknoSgooooo00Co
3EF^ojK6i_nidnkoNJk[0_n[gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP03
odHV5?m69P[o8a`:00?o8a`:0_lm70X2odHV2P04ocdL2_lS70[o6PT:o`TB
2P;o6PT:00coARH:ob`B0?l/4P3o?A`:ob`V5?l/4P3o8bH:oaX92_l/4P3o
8bH:ocdL2_l/4P02ob<L2P;o;18000Co;2HDob`B0?lm70[oARl:0_lm70X0
2?lS9P[o8a`:ocdL2_lm70[oARH:ocdL2_m6;`[oARH:0_mG70007_mb>03o
ARHDocdL2_l/4P3o=2lYog^=I_n3Q7_oUHAkol[@`OoCfMKoAT`mojJHKon`
ZXCoSHeBojJQV?o:d<7o8bH:oa4V2_l971Co0000oa4V5?l/9QCo4A`:ob<V
2_ld;ako2@T:oa4L2_l94P[o4A`:o`T92P;o2A8:00Wo4A`:o`T92_l94P[o
4A`:o`T95?lA70[o6Q8Dob<V2_mP@A@00_mP@BT01onEC2WoWW/cok24I_oL
/j?ob]31ojIbD_n3Nc<00_n3GS<02?mZIc?oPehcojIbD_n`Q7_o`J64ombn
]ooTd<cokMW<0_ofm_D2ooK]jP;om_oo00gooooool5kNon`SC?ob[j]om>n
S_oCQ03obYPDom>40?oTZP3odiP:onBc:OoT/dOom/Lm00?okLML013om]UV
ooK@Q?oohhkom]UVong7Q?offFKokKhmooK7?OofaakodiP:ooJc0?lm4P[o
JUDNoiEbAooTd<com_oo0_ooool02Oo:V2Woi:X0ooJc0?o]_Sgom/LmonBc
:Oofa`[oi;<Nooo@?@02ooK7?@;om/LN00_om/LmooK@Q?ood3gom/LmoooS
Q?ofd8CoomTYooKII_ofacgom]UVonBcA`03oooSQ003ooo]S_oohhCoonf>
00Coonf>0_oohh@06_offFKoon>4ooK7?Oo]aecoi;<colZH5?oCV0[o`H@0
oheE2_mZ@@[o=2lNob`V5?lA70[o6PT:oa4L2_lJ9QCo;180ooo]c?ofooGo
ong<okVZKoldEBWo6Q8DoaXV5?l92@[odj4Y0_ookL`03oookHkokLN4ong7
G?o]_Sgodj4Yog]<5?l/9QCo4A`:oa4V5?lJ4QCo;2HDob`L5?n3;`3o/7/:
ombc[@05ooooo`03ooKooooooooooooo00Gooooo00?okNgZongfmOooool0
1?ooool00ooCfMKok^k^onk^kP1Monk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q0002onKViP0<onCTi?oDe=CoO7alomWIfOoPh>3ohN7QomGEeOo8b<So
bl_;olk>c_o@d=3odm?C2?oDe=@04oooooCoooogoo_knOolooooko;oomCJ
m?m?E7koAD]ooeQMWOmUJZkoL7NmogR0`OmoQKooQXg1ohbC_on?U/3oUIW8
oiVMcOnMXM400_nOXm<00onNX];oWj?Boj2Td`02oj2TdaKoX:CA00?oWZ;A
oijRd_nNX]803?nNX]800onNX]7oX:CAoj2Td@0>oj2Td@SoX:CC0_nQYM@0
0onPY=?oWj?BoijRd@02oifQd00BoifQc_nCV/CoTYW3ohjDa?n6SL7oOhRo
ogR1_?m]MKCoHVZYoeYPW_m5C8?oBDejom7Fm_ocn?oonokooo_mn?olooKo
ooom0ooXj>P2onWYj@08oc4a<OlZ:R[oFe]KodQ8B?lY:BWo1PH6oh>3PooZ
j^X8on_[j`?ok>c/0_o]kNd3onk^kP[okno_0oo`l?03oo7al@03oo?cloob
l_;om?Cd00;om?Cd00SohN7Qochn?_lL71coMWIfoi6ATOm_Kfoo;Rh^okNg
]`;om_Kf1OogmoL3ooShn0ConOWi00?oF5QHohn?Soojn_X02Oojn_X2oo_k
n`;oo?cl00?ooOgmookno_ono_h0>oooool01?lAEjooXl;TokSCkomg[^/2
oj[Oo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00Go?A`:ob<V2_lm70[o8a`:
ocdB2P02ocdL2PGoARH:0_lA70X01ol92@[o;180ocdL2_lm4P[oARH:odH_
2_l/4P000_lm70X01?lA70[o;180odHV2_l/4P02ocdL2P07ob<V2_lm70[o
;180ob<V2_lS70[o?A`:ob`B0003ocdL2P04ob<V2_lm70[o?A`:odH_2P;o
Ea`00om6;`X05?m69QCoEa`0odHV2_l/4P3oAT`mog:=G?mbSHCo/;k1omcS
h?oCfMKokNgZok2c]oo:d=KodmWFongfmOo1al7o4A`:oa4V2_l92@[o4BHD
0_lA70X01olJ4QCo4A`:o`TB2_n`ZXCoARHDo`T92_l94PX00_lA70X00ol9
2ACo6Q8Doa4L2P02o`T92P0:oa4L2_l92@[o8blNoc@_7_mP@BWoLSPDoiE<
:OnEGS?o/8eBol6QQ0;oi<O100[oUG97oh=N5?n3GS?oNd`Dof11:On3GS?o
WXAVol5kNooL/j?oi<O10_o]fL`01?ofkN[om_KeooK]j_ofkNX2ooKoo`0D
ooooooo]fLco/780om>H2_niQ1Codh@0om>Q:Oo:V1Coi:X0olZH5?oT/c?o
i;=7onfn?OoT/dOoon>>ooK7?Oo]aecom]UVoooSS_ofd8@2ooKIIP09oooI
?Oo]aecom/LNonBc7_oTZP3oH44Dof1N<onVQ5;okNgZ00?om_oo00CokKhm
om>40?ood3goi;=70_ofacd00ooT/akom/L:onBc<`02ooK77P0=onBc:Oof
/`3om[<0ooK7?Oo]aecom/L:ooK7?OoffFKom/LmooKII_oT/dOom]UVooK7
7P02ooKIIP?oon>400Coong<ooo]S_oohhCoon>>0ooohh@07OoffFKoon>>
ooK7?Oofd8Coi;<Nom>Q:OoCV0[o^H@Doiib2_mkC0[oARHDob`V5?lS70[o
4A`:oaX92_lA70[o;180ooo]c?ofooGokMW<ol6cS_mZ@@[o4BHDo`T95?l9
2@[odh@0ooKomOookHkokM2H00;om]2400[om/Lmom>40?nEEACoH2lDoa4V
5?lJ4QCo;1`Do`T92_o:XCgoong<1oooool00oofooooooooooooo`04oooo
o`;om_oo00?om^gZooooooooool00oooool00ooCfMKoi^KVonKViP1MonKV
iP04oifMWOng]kOob<S8om?Cd`7of][J0002onk^kP0<onc/k?oLg=coO7al
omWIfOoPh>3ohN7QomGEeOo7alOob/[:olk>c_o@d=3odm?C2?oDe=@04ooo
ooCoo_ogoo[lmooloooomOSoomOKm_mHGHGo?49doda@SomIGZ3oIfb`ofmg
^?mhO[SoP8NkohR?^on;T[coS96koi6F`?nGW<H00_nKX<X00onJWlWoVYo7
oi^Pb002oiZOaaGoVYo500?oVYo7oibQbonLXL/03_nLXL/00onJWlOoVYo5
oiZOa@05oiZOa@SoVj362?nKX<P01OnMX/[oW:79oi^Pb?nIW/KoUic400;o
UY_301;oUI[2ohfE_?n<TkgoQXjmogj5^OmfOkSoKgNeofA/[OmKH:3oBU2<
oce3MomGG8Kofn3mooSnoooen_kom__eookon_ooood3onWYj@03on[Zj_oY
jNWoXJ6Q00;oSHf=00?oUIFEokBd]?oHf=P01oo/k>`6ong]k@;ok^k^1Oo_
knl;oo3`l0?olO7a00?olo?cooCdm?ofm_H00_ofm_H02?ogmoOom_Kfojb/
[?mkNg_oIFEUohB4Q?nWYjOoj>SX0_ogmoL5ooShn0;onOWi00?on?ShooWi
nOoinOT00_oinOT00on_[joob<S8oo[jnP09oo[jnP;ono_k0_olo?`00oom
oOgoo_knooknoP0kooooo`04oa5G[onUa>Ko^M?_ogN^j`;oZMco00CoKVi^
okBd]?oPh>3ok>c/Foo^k^h03omP;aCo8bH:ob<L2_l/4P3o8a`:ob`B0?lS
70[oARH:ob`B0?mP;`[oARH:ob`B0?lS70[o6PT:oa4L2P02ob<L2P07ob<V
2_l/4P3o?A`:ocdL2_lS9P[o;180oaX92P02ob<V2P05ob<L2_l/4P3o8a`:
ocdL2_lS9PX00_lS70X2odH_2P07ob`B0?m6;`[o?A`:ob<V2_lm70[oARl:
ocdL2P02odHV2P05ocdL2_mG703oARH:odH_2_mG70000_m6;`X01OlS9P[o
8blNofYkKon3Q7_oY[?100;ob]3F00?okOKeok2c]oo:d=H00_o:d=H02_oC
hoGob]31og^=I_nEV6Ko2@T:oa4V2_lA70[o2A8:o`T95?mP@BT2oh=k<`03
odH_2_lS70[o4A`:00Go4A`:0_l94PX03Ol92ACoARHDof0_5?mP;aCoH44Y
og]<5?nEGS?o/8Akol6QQ?o]fLcoi<O1oiik<omZEAh00omP@BT01Omb>1Co
YUEVok1kI_oL/j?og;jg00;okMW<0oofm_D00oofkN[om_ooooKoo`02ooKo
o`04ol6QQ?n`LP3obYPYolZQ?@;obYPD00[odj4Yom>H2_o:V1Coi;<conBc
7_o]aecoi:X0ong7G?offFKoon>>0ooffFH02oofacgokLN4ooK7?Oo]aeco
kKhmonBZ0?mP@ACoLVMBok2ZQ?ofkN[om_Ke00;ooooo00[og;>4onBc7_oT
/c?om]UVooK7?Oofaakoi;<YooJc0?oT/akom/Lm0oofaah03ooTZP3oom0m
ong7G?of/`3om/LmoooSS_ofa`[om]UVooK7?Oood3goi;=7ong7G?oohhko
m]UVooo]c003ooo]SP0PoooSS_ookHkom]UVoooSQ?ookHkoon>4ooKII_of
acgom]UVonfn?Oo:V1Codh@0ol640?nNLP[oNd`:odHV2_lJ9QCo8a`:oaX9
2_lJ9QCo6Q8Do`000?o]d9Som_oeooo]c?o1/hkoH44Doa4V5?l971Co2@TD
okUW0?ookL`2oooSSP;om]2400Wom]UVonBc:On=E@[oH44DoaXL7_l971Co
;1`DoaX92_o:ZVH02?ooool00oofooooooooooooo`05ooooo`03ongfmOof
m_Gooooo00Cooooo00?odmWFonk^k_o^k^h0GOo^k^h01?nSXj?o_Kfmolo?
cooJf]X1on7Qh@000_ooool03?omoOgok>c/og]kNooJf][ogmoOon7QhOoE
eMGoa/K6ol[:b_o>c/kod=3@om?Cd`Soe=CD01Kon_caoooon?onoo_omo_n
oo_oooo`mOooP8BYoca0Kom:ChWo@TR6oeYOWom`M[CoN7jhohV@a?nHX<ko
WJC>oijSbOnTZ/koZ:kBojJ/d?nUZlgoYjg?0_nZ/=84ojR^cPCoZ:o<2?nW
[Ld2ojJ/c0;oYjg=00OoZ:k>ojV_conZ/=3oZ[3@ojZ`d_nY[m7oYjg?00;o
YZc>00?oYjg?ojV_dOnZ/=802?nX[]08ojR^cPSoYjg=2?nW[Ll01OnUZlgo
Z:k@ojR^d?nUZlgoY:[<00;oYJ_=01;oXjW;oiJN`onY/=[oRY;1ohV@a?n2
R<;oH6JToeYOWom7Bh[o=S]codE9N?mdNYkom_coooWooooam_Woo?omooCg
l?ooood3onWYj@;ojn_[0oo]kNd:onk^kPOokno_1_o`l?0;oo7al@?ol_;b
0_odm?@3ooKfmP[omoOg3Oohn?P;ooWin@;on_[j0oolo?`2ooknoS_ooooo
00Co3EJaojC4i_nidnooMZgZ0_n[h?l01?mfMWKo`L71oo3`l?omoOeKoooo
o`06of115?mG703o6RHDoa4L2_lS70[o4A`:0_lm70X2odHV2P06oeLL0?m6
9P[o;180ob<V2_mG703o;2HD0_l/4P001_m6;`[o?A`:ob`B0?lS9P[o;180
o`TB2P;o;18000Oo?A`:odH_2_lS9P[o8bH:ocdL2_lS9P[o?A`:00;o;180
00?oARl:ocdL2_l/4P000_m6;`X01ol/4P3oARH:odHV2_m69P[oARl:odHV
2_mG70000_m6;`X01om69P[oEa`0odH_2_lS;akoUIRSoiFQS_nVZZd00_o:
d=H01_o]kN[oSIR>ojJHQ?mbSEcoJVLcog:=?@;oPg/c013oUED0og]<2_l9
2ACoARH:of115?mb>03oNd40og8h0?mP;`[oEa`0ocdL2_lA70[o6PT:oa4L
2_lJ2@[o4A`:0_l94PX01OlA70[o;1`DodH_2_m69QCoH2l:00;oLSPD017o
UD`Yol5kNooL/jgokMW<ol[@`OnEGS?oPehcog]<5?mP@BWoEa`0og8h5?nE
C2Wo/44col5kNooTZYSoong<ooK]jP06ooKfm@04ooKooooooooom^gZok1b
00;obYPD01;obYPYom>Q:OoCV0[obYPDonBZ0?oT/c?oi;<Yonfn?OoT/bWo
kKhmong7G?o]d9Soon>4ong7G?offFKokKhmooKII_o]ae`2ooK7?@05onBZ
0?nNLQCoH5hcojJQV?o]kNX00_ofool03?oooooo^Hdconfn?OofaakokKhm
ooKII_ofacgokKhmooJc0?ofaakom[<0onBcA`;oi;<Y00oook<0ooK7?Oo]
aecom/L:oooI:OoffFKoom0moooSQ?ofacgokLMLonBZ0?offFKoon>>oooS
Q?oohhh01OookHh01OoffFKoon>4ooo]S_o]aecoon>400;om/Lm00Soi;<c
onBc7_oCV0[odiP:ojIb0?mkC0[oARl:ob`V50;o4A`:00ko2@TDob<L2_l0
003og;>4ooKomOookLco`K>>ofYW<olA9QCo6Q8Do`TB2_n3;`3oong<ooo]
SP;oon>>0_offFH02?oT/akoWUhDog]<5?lS;ako4A`:oaXV5?lJ2@[o^G8c
4?ooool00oofoooog>?Pooooo`04ooooo`03om?Ie_oooooooooo05gooooo
00Co[jn_ol_;booNg]koj^[Z0Oobl_8000;ok^k^00cok>c/omcLg?mgMgOo
f][Jon3Ph?oQhN7oe=CDolO7aoo<c<coclo?om3@d?oCdm<8omKFeP0Goooo
n?ogn?;ooookookooooen?oomo[ookRkf_l]<5Wo;S5TocPmMOmBEY?oHVRR
oh68_onU[MkoYJgKoinWc_n_]MOo]KcIokVogong_]_o][gJokRog?ni`=d0
0_ni`=`00oni`=[o^L3LokW0fP04okW0fP;o^l;L00co^l;Nok_2g?nk`]ko
^l;Lok_2g_nk`]co]kkJokNnf?nh_m_o^L3JokW0g?nj`M/3ok_2gP0>ok[1
gOnh_mco]kkJokNnfonh_m_o^/7Nok_2g_ni`=go^L3LokW0gOni`=co^L3M
okW0g?ni`=d2okW0g00=okW0f_ni`=co^L3JokW0g?ni`=[o^L3LokW0f_nk
`]ko^l;Lok_2g_nk`]co^l;Nok_2g004ok_2gP0Ook_2gonk`]ko^l;Ook_2
g_nk`]oo^l;NokNnfonj`Mgo^/7NokNnf_nf_M[o^;oKokNnfone^m_o]koS
ojR`eonPZ=OoYZgQogQn^?m@E97oDeNDocm1N_m1A7Oo:BaEokg2h?ofnooo
l_Kooo_ooooloogoo_okooooo@03onOWi`03onSXj?oYjNWoj^[Z00Goj^[Z
1oo[jn/3onc/k0?okNg]00?okno_onk^k_o`l?000_o`l?02oo7al@_ol_;b
1?oclo<4ooCdm0[omOGe0oofm_H2ooOgm`;onOWi00Con?Shoo[jn_ojn_[o
n_[j0_okno/=ooclo0;ooOgm00?oo_knooooooooool0>oooool01?l=EJko
YLCVokG@k_mi[^`2ojOLo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00coH2lD
odH_2_n3>03o;2HDob<V2_lm70[oARH:oeLL0?mP;`[oLRH0odHV2_mb9P02
odHV2P03oa4L2_l/4P3o8bH:00;o?A`:00GoARH:ob`B0?m69P[o;180o`T9
2P02ocdL2P08ob<V2_lm70[o;180odH_2_lS9P[o;2HDocdL2_lS9PX2ocdL
2P03odHV2_m6;`[o?A`:00;o?A`:023oARH:ocdL2_m6;`[oEa`0odH_2_m6
9P[oARl:og8V0?m6;`[oH2l:ocdL2_l971koNheVoh>HS_n`_/7ob]3Fongf
mOn`ZXCoEa`0oh=N5?mb>03oNd40og8V0?mb>03oNd40oiEE0?nVLP3oPehD
oh=10?mkC0[oJT4:of0_2P;oARl:00Co8bH:ob<L2_lA70[o6Q8D0_lA70X0
4_lA9QCo4A`:o`TB2_l94P[oAT4Noc@_<omP@BWo=2lcog8h5?mZEAkoUD`Y
ol6QQ?oL_[Ooi<O1ol6c[On=SDOoJVLcob<L2P;oH2lD00WoH44YoiEbAonE
C2WoYUEVoh<_0?oL_[Ooong<ooooooofool00_ofm_D2ooK]jP0:ooKfmOof
oooooooook1b0?niSBWobYPDolZH:OoTZP3odh@0ombZ<`;oi;<c00Woi;<N
onfn?Oo]_Sgoi;<YooK77_oohhkom]UVong7G?ood3d00_o]ae`02?ofaako
kLMLooK7?OoT/bWoPehDofYW<oo:d<7og>?F0oooool01?nVLQCom]24onBc
<ooffFH2ooK7?@07onBc<oof/`3om/LmonBc<ooofBWoi;<YooJc0002onBZ
000Bong7G?of/`3okLMLooKII_ood3gom]UVooo@?OoffFKoi;<NooKII_oo
hhkom]24ooKII_oohhkom]24ooo]S_ofd8Coonf>0_oohh@03_ofd8Com]UV
ooKII_ofacgokKhmonBc<ooCXBWobYPDokV45?n`N`[oNd`:odHV5?l/9QCo
8bH:0_lJ4Q@06OlA9P[o0000okVHG?ookLcokMW<om>nS_mZEAko2A`Doa4V
5?l971CoLRH0ooo]c?oohhCom]24ooKII_ofd8Com]UVonBc:On`N`[oYT`0
oc@_7_lA9QCo;1`DoaXB5?nV@@002Oooool00oofooooooooooooo`04oooo
o`03ooKoooo]kN[ooooo00Cooooo00?og>?Fonk^k_o^k^h0GOo^k^h01?nS
Xj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H01?oTi>Coe=CDogIfM_oIfMT2
omoOg`06omCDe?o7alOob/[:olk>c_o@d=3odm?C2?oGemL06ooooo_omoSc
oooooOonoooomOKkoocnoookoOooNWfNocLiH_l_<F;o>Caaof5VWOnHW];o
[;;TojN^g?ne_NCo/kWIokZog?nn`n7o_L;Ook_0gOnl`Mko_L;Ookg3gOnn
a=ko_/CLokk4gP05okk4g0;o_L?K00co_L?Mokg3fonm`mgo_L?Kokg3gOnm
`m_o_<;Lokc2f_nm`mgo_/CLokk4g_noaMd3oko5g`0>okk4g_nm`]oo_<;L
okc1g_nm`mgo_/?Poko5gonn`n3o_/CNokk3h?nna=ko_/?Pokk4g_nn`n02
okk4gP0=okk4g?nna=ko_/CLokk4g_nna=co_/CNokk4g?nm`mgo_L?Kokg3
gOnm`m_o_L?Mokg3f`04okg3g@0Lokg2gonm`mgo_L;Ookg3gOnm`]oo_L?M
okg2goo0a^3o`<GRokg3gOnl`Mko_/CNokc1g_nh_mco]koSojngg_n^]>Co
YjgQohJ;`omOHI[o?d9iobHXFolP8dcoOh:Soo7foooho?oomocoooSlo@;o
o_om00CoooooonKVi_oVi^Koi^KV0_oXj>P6on[ZjP[ojn_[0oo/k>`2ong]
k@?ok^k^2_o_knl3oo3`l0?olO7a00?ol_;boo7alOobl_800_obl_82oo?c
l`Som?Cd0ooemOD2ooKfmP?on?Sh0oojn_X2oo_kn`goo?cl0_omoOd00oon
o_koooooooooo`0kooooo`04o`eF/OnTa>Ko^=;^ogJ]jP;o[=oo00CoJVYZ
ojj^[_oHf=Soi>CTFooVi^H00omkC1CoUEDDoa4L2P02ob`B00CoARH:00?o
H2l:ofY12_mP;`X00_mP;`X2ocdL2P08of0_2_m6;`[oEa`0odHV2_lm70[o
8a`:odHV2_l94PX2odHV2P03odH_2_mG703o?A`:00;o?A`:00go;180odH_
2_m69P[o?A`:odH_2_mG703o?A`:ob<V2_mG703o?A`:odHV2_m6;`[oEa`0
00;oH2l:01[oEa`0odH_2_m69QCoEa`0odH_2_lm70[oARHDoceN?OmPGS?o
YZ6HonC@c?oLhn3oWW8Dog]<2_nNGQCoPehDoiib2_n3GQCoPd40oh=N5?mk
@@3oWW8Doh=N5?n=E@[oLSP0oheE2P;oARl:0_lA70X08_lS70[o6PT:oa4L
2_lA70[o2A8:ob<L2_l/4P3o2A8:ob<V2_lm70[oEa`0odH_2_m6@AkoH44Y
og8h5?nEC2Wodkj>onC7`Oo1XHCoUG97oh=N<omb>1CoARHDof115?nNLQCo
^IQLolZn[Oo1/hkoooooombn[OnVLU;oYUEVooK]j_ooool2ooKoo`0:onC7
`Oo]fLcom_KeooKoooooooooWW8:oiik<on`Q2Wo/8eBok24:@;oPehD0_ni
V5`01onVQ5;oWW/coiik<oo:XCgoUHABoiik<on=SDL00_nEV6H06_niV5co
YXABoiFHI_n3Nc?oJVLcol6c[Oo]kN[oUHABol77`OoLhmKom_ooooooooof
oooo^H@YoooSS_ofacgom]UVooK7?Oo]_Sgom/LmonBc:Oofaakoi;<cooJc
0?ofaakoi;<Y0_of/`001Oofacgom[<0oooI:Oo]aecom/L:00;okLML00?o
om0monBZ0?offFH00_oohhh01OoohhCoonf>oooSS_oohhkom]UV00;oon>4
00Coon>>oooSQ?oohhkokLML0_ofacd01_oT/dOog:Xcom>H2_oCV0[o^HdD
og]<2P;oARl:01co8a`:oaX92_lA70[o6PT:o`T95?nNLS?om_oeongIc?oC
_XkoPg/co`TL5?lA70[o2@TDoeLL0?ookLcoonf>ooK@Q?offFKom]24ooKI
I_o]_Sgo^G8cokV45?mP;aCo4BHNoaXV5?lJ4QCoPbl04?ooool00oofoooo
g>?Fooooo`04ooooo`03om?Ie_oVi^Koi^KV05goi^KV00CoWIfMokNg]oo8
b<Sodm?C0OoJf]X000;ok^k^00cok>c/omgMgOmbLW;oemOGomoOgooPh>3o
d];BolO7aoo:b/[oc<c<om3@d?oCdm<8omCDe0;oooko01Kon_WgooShn?oo
oooooOgooocnooo/k_ooDU=boaLI@?l[;U_oBTinogIjZ_n//^;o/k[XokVn
j?nc]m[o^[oOokk3honm`^;o^l3Pokc1gonm`^3o_<7N1Onm`]l3okg3g@[o
_<7N0_nm`]l6okk3h004okg2gonl`Mko_<7Nokg2g`;o_/?P4?nm`]l:okc1
gP0Iokc1gonl`Mko_<7Ookc1g_nl`Moo_<7Nokg2h?noa>7o_/?Qokc1g_nl
`Moo_L;Ook_0g_nf^m_o/kWMokFli_nc^^SoWj;Eogj1]_m9BX3o7R1AobHW
DomNHH;oko7oooOko`02oocoo`04ooWkn_onoooon?[iooooo`?oj>SX0_oY
jNT3on[ZjP?ojn_[1oo/k>`6ong]k@03onk^k_o_knool?3`00Col?3`2ooa
lO43oo;blP;olo?c0oodm?@:ooGem@Gom_Kf0_ogmoL00oofm_KomoOgooOg
m`03ooOgm`_on?Sh0_oinOT3oo_kn`;ooOgm4Oono_hZooooo`04oaeO/onV
a^Ko]]3^ogV_kP;oZmko00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01OmZEAko
H2lDob<V2_lJ4QCo8bH:00;oEa`00_mP;`X01_mb9P3oNd`Dof0_5?mZ@@[o
H2l:odH_2P?oEa`00_m6;`X01?mG703oARH:ob<V2_l94PX4odH_2P0@ocdL
2_m6;`[oARl:ob`B0?m69P[o8bH:odH_2_lm70[oARH:ob<V2_m6;`[o;180
odH_2_lm70[oH2l:odHV2P;oARl:013oJT4:of0_5?mb>03oH2l:odH_2_m6
9P[o;3PYog:=G?n`ZXCoYYQ_ol[@`OoLhmKoUHd0ofYE7_nNLP[oSED:0onN
LPX05OnVI`3oSED:oiEE5?nNLP[oPehDog]<2_mZ@@[oARl:oaX92_m6;`[o
Ea`0ob<V2_lJ4QCo2@T:o`TL5?lJ2@[o8a`:ocdL2_lS70[o8bH:oc@_7P02
odHV500:oeLL0?mb>1CoH2lDoiE<:On`Q6Kog;j]ok24I_nEEACoLSPDof11
:@?oUD`Y02SoUEDDok2=D_nVLU;og>?PonC7`Oooooooi=3<ojIEI_ofkN[o
m_ooooKfmOoL/hCoi<O1ooKfmOofoooooooooiik<onNSBWo^IQLoiF=D_mP
GS?oPg/col6cS_oLhn3oUIQVohf=D_niZVooUHeVof115?niV5co/:Z4ombn
[OoTd<co^JY_ok2ZQ?nVV8CoWXAVoiF=D_oC_Xkoi<O10_o:d<400onVXISo
kOKeooKoo`02ooKoo`08ong7Q?ofd8Com]UVonBcAooffFKom/Lmonfn?Oof
aah2onBc:@0:onBc<oofaakoi;<com>H2_of/`3oi;<cooJc0?oT/bWoi;=7
ooK77P;oom0m00?om]24onBc<ooohh@01?oohhh01ooohhCoonf>ooK@Q?oo
hhkom]24ooKII_oohh@00_offFH02_oT/akom]UVonBcAooT/c?obYPDol64
0?niSACoNd`:of0_2_lS9PX3oa4L2P0;oaXB5?l92@[oPehDong@V?o]fLco
^JY_oij=:OlS;ako2@TDob<L2_lJ2@X00_ookL`03?ookHkoong<ooo]S_of
d8Com]UVolZH5?oCV0[oNd`Doa4V5?lJ4QCo;1`Dog8V00Wooooo00?om_oe
ooooooooool01?ooool00oofoooog>?Fooooo`04ooooo`03om?Ie_o^k^ko
k^k^05gok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo00CooOgm
ono_komcLg?oclo?0_oMgMd01_oAdM7oa<C4olS8b?o;bl_oclo?om;BdPSo
e=CD01;oo?Omooomooooo?goookooooooOooooooj^W_ookmoooloOoo<cAB
obDWCOm?DWgoI6NDoiFIb?nFV/Wo[[;OojV/eOn`]=X2okFig`03okBhg_ne
^Mko][[O00;o]KWN1?ne^M`3okFjfPSo]k_N1?ne^M`6okJjg@Co]KWL0_nf
^]d@okFig0[o]k_N01oo]k_PokNkg_ng^n3o]k_NokNkh?ng^mko];SMokJj
gOne^Mko/kOJokBhgOne^Mco/KGJojb`eOnX[M?oYJ[DojR/fon4Q[OoBTao
obl`H?l/;EWo=3AFooGeoookoOoonOgoookooooinoSoooomoo_koOomoOoo
oooo00?oi^KV00?oj>SXonOWiooYjNT01OoYjNT:on[ZjP?ojn_[00?ok>c/
ong]kOo^k^h00_o^k^h:ono_k`?ol?3`0ooalO42oo;blP?olo?c0_odm?@8
ooGem@Gom_Kf0_ohn?P00oogmoOonOWiooWin@03ooWin@_on_[j0_okno/3
ooclo0;ooOgm4Oono_hZooooo`04oaYL/onT`nGo^=;_ogV^k0;o[=oo00Co
MWIfol71`Oo`l?3ooOgmFoooool02?mP;`[o8a`:ob<V2_l/4P3oARHDof0_
5?mP;`[oH2lD0_mP;`X04?mb>03oJT4:og8h5?mP;`[oEa`0odHV2_mP;`[o
ARl:oeLL0?mP;`[oARl:odHV2_lm70[o2A8:og]<2_mG7002of0_2P03odHV
2_m6;`[o?A`:00;o8bH:00CoARH:ocdL2_lm70[oARl:0_lm70X08ol/4P3o
ARH:oeLL0?mP@ACoH2l:ofY12_mb>03oJT4:oeLL0?mb>03oARl:oeLL0?lS
9P[oAT4Nof1N<omZIc?oYYR4ol[@`Oo:ZVKoPehDog]10?n3GQCoNd`:oh=N
5?n=E@[oPd40og8h0?mZIc?oARH:og]<5?mZEAkoNd`:odH_2_l92@[o;1`D
00;oARHD00Ko4A`:ob`B0?l94P[o6PT:ob<L2_l92@X2ob<L2P0<ob`V5?m6
9QCoARl:odI17_mP;aCoLSP0og8h5?nEC2WoYW9Bol5kNooL/j?o/8eB0_mb
>1@04omP;aCoH44Yof11:OnVEFKo/7]Vol5kNooTZYSog;jgooKooooooooo
i<O1ok24Noofm_Goi=3<ok2=D_o]fLcom_KeooK]j_ooool00_o1/hh01_nE
V6KoPg/coiib<ooTal7odkj>ol77`@;o`K>]00So`K>>oiF=D_oC_Xko/:Z4
olZn[Oo:d<7o/:Z4omc7X`;o`K>>00SoPg/col[@`OoCfMKob]31ol6cS_o:
d<7oUJ6>ooK]jP;om_oo00Gom_oeooKII_o]d9Soon>>ooKIIP02ong7G005
ooJc0?ofaakokLMLonBc:Oof/`000_oT/bT03?of/`3oi:X0onBc:Oof/`3o
i;<NonBcAoofaakokLMLooo@?Oo]aecoi:X0ong@V0;oon>>00KokM2Hooo]
S_oohhkoon>>ooKII_oohh@2oooSSP0GooKII_ood3gom/LmooK7?OoffFKo
kLMLombZ<oo:V1Co`H@0okV=5?mkC0[oJT4:ob`V5?lA70[o8bH:oa4L2_lJ
2@[o4A`:og8h5?oTal7og<NSol6cS_niSBT00_lA9Q@00ol92ACo0000ong@
V004ooo]c009oooSQ?offFKoi;<NolZH5?n3GQCo;2HDoa4V7_lJ4QCoEa`0
00Wooooo00?om_oeooooooooool01?ooool00oofoooog>?PooKoo`04oooo
o`03omcSe_oooooooooo05gooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_80
00;ok^k^00[okNg]on3Ph?mjNW[o_knoomSHf?oJf][oc<c<ol71`Oo5aLGo
b/[:0_o>c/h8omCDe00Hoooloooon_oooogoooonoOoln?Gooookoo7_l?oo
o_ooknkloocmoom=CVgo4aDkodE7L?m7BWOoSY30oiNKb_nDU/KoW9k>oj>U
eOnTY]KoY:ODojJYe_nXZmSoYj[G1?nVZM@4ojJYdPSoYj[E1_nVZM@00onW
Z]GoYj[CojJYdP0?ojJYdPSoYZWD4?nWZ]D06OnUZ=?oYZWDojFXdonTYm;o
YJSCojJYe?nRYM3oVik9ohbA^OnRYm7oL7:Rod]=O_m1@G?o40lkodi>M?ol
o?ooo_goooSioOonoogol_?]oooonooooogom_Khooonooooool00ooUiND2
onOWi`KojNWY2_oZj^X4on_[j`Cok>c/2_o]kNd6onk^kP03oo3`l?o_knoo
lO7a00ColO7a2?obl_83oo?cl`;om?Cd0_oemOD01?ofm_KomoOgooOgmoog
moL2ooShn0_onOWi0_ojn_X3oo_kn`;oo?cl4?omoOd3ooknoRSooooo00Co
7EncojG4i_nfd^koNJkY0_nZh?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP;o
8bH:00Go?A8:ob<V2_mP;`[oARHDoheE2P02og8h0008og8h5?mb>03oLRH0
of115?mZ@@[oH2l:ofY12_mP;`X2oeLL0006of0_2_mG703oARl:odH_2_l9
4P[oNd400_mP;`X04_n3NecoARl:odH_2_l/4P3o?A`:oeLL0?lS9P[o?A`:
oc@_7_m69P[o?A`:ob`B0?l/9QCo8bH:odHV5?mb>03oEa`0ofYE7P;oH2l:
0om6;`X02_lm70[o8bH:odI17_mZIc?oPg/cohf=AonNSC?oUHd0oeLL0?mZ
@@X2og]<2P0Aoiib2_l92ACo4BH:ocdL2_mbSCgoPg/coh=N<om6;`[oH44D
ob<L2_l/71CoPg/cofYE7_m6;`[o8bH:oa4L2_lJ4Q@00_lA70X00olS70[o
2A8:ob<L2P03odHV500<of115?m69QCoH2lDof0_2_n`@C?o/8eBol6QQ?oL
/jgoYW9Bog]<5?mZEAkoH2l:0_mP;a@01?nELTOo`J64onC7`OoL/j<2ongI
c00;ooK]j_o]fLcoLRH0ojJ4Q?oL_[Oo^G8conC7`OookLcom_KeooKooooL
/jd00_nVV6l00onVQ5;o/:Z4ong]jP02ol6cSP0Dom>nS_o1/jgo^JY_ol6c
S_oTd<coYZ5VomcSe_o:ZVKodkj>ojJQI_n`ZXCoNd`:ojJHKoofkN[og<NS
ol6cS_oC_Xkog>?Fol6c[OoLhn02ooKoo`0;ongIc?o]ahCoon>4oooSS_o]
_Sgom/LmooK@Q?o]_Sgom/LmonBc:Oofaah00ooTZP001?oCV0[om/LNonBc
:OoT/bT3ooJc0006onBc<oofaakokLMLolZQ?OoffFKokM2H0ooohhh05_of
fFKoon>>oooSS_ofd8Coon>4ooKII_ofd8Com/Lmong7G?ofacgokLMLonBc
AooCZTOobYPDom>H2_n`N`[oSED:of115?m69QCo8a`:oaX92_lJ4Q@2oa4L
2P0=of0_5?oC_Xkob[j]ok2ZQ?nESE;o4BH:oa4V5?lJ4QCo2@T:ong7Q?of
ooGoong<ooKom@02ooo]SP08ooKII_oCXBWoi;<Noiib5?l/9QCo6RHDob<_
7_mG7009ooooo`03ooKomOoooooooooo00Gooooo00?og>?PooK]j_ooool0
0oooool00ooCfMKok^k^onk^kP1Monk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q0002onKViP0<onGUiOoMgMgoSXj>ojBTY?oBd];oe=CDol;2`_nh^;So
`<30olC4a?o9bLWobl_;2?o@d=005ooonooooo[ooooloooono[on_Oboooo
n?oooo[ooOgmooonooonoOoom?Coog]kWOlS9Dco;2mJoc4dHOm8BW_oHfBJ
ofa]YOmdMJ_oMWN]ogQi[omlOK?oOX2c00?oOGnb1_mmOk08og]m[PSoOGn`
00?oO7j_ogeo[ommOjl01?mmOjl00omlOZkoOGn_ogeo[`06ogeo[`SoOGn`
2?mkOJh8og]m/0;oOGnb01OoO7jaog]m/?mmOk;oOX2cogQj[OmaLjCoIFRE
odA7L_lW:5So7b1@obPVEon5Q:kom_GoooKdoooWinooooomoooon?oemN_o
ooojoocknOooo_oooogoooooo`03on;RhP03onCTi?oShn?oiNGU00;oiNGU
2_oVi^H7onOWi`Koj>SX2ooYjNT3on[ZjP03onc/k?o[jn_okNg]00;okNg]
2_o^k^h7ono_k`Kol?3`2?oalO43oo;blP;olo?c0ooemOD2ooOgm`?on?Sh
2_oinOT3oo[jnP?oo?cl0_ono_hVooooo`04oa]N/onVa^Ko^M?^ogV^j`;o
Zmoo00CoJVYZojj^[_oHf=Soi>CTFooVi^H00om69QCo?A`:odHV5002odHV
2P;oNd`:01CoPcP0og8h5?mk@@3oNd`:of0_2_mkC1CoLSP0of0_2_mb9P3o
LSP0odH_2_mP;`[oEa`0odH_2_mG703oARH:o`TB2_mZ@@[oLSP0ofY12P;o
ARl:00?oEa`0ob<V2_lS9PX00_lS9PX2ob`B0003ob<V2_l/4P3o8a`:00;o
;18000Wo?A`:odHV2_m6;`[oH2l:odH_2_mP;`[oEa`0ocdL2_m6;`X00_l/
4P002_l/9QCoAUDYocAE:OmZ@@[oNd40of0_2_lm70[oARl:ocdL2_mP;`X2
ob<L2P05oa4L2_m6EBWoJVLcog^=I_m6@Ah00_m6;`X08OlS70[oJUDNoij=
<omZEAkoAT4Noa4L2_l94P[o;180oaXB5?lJ2@[o8a`:ob`B0?l/71Co;2HD
odHV5?m69P[o?A`:odHV2_mP;aCoLSPDoiE<:OniLS?o`G]konBZV?oC_Xko
UEDDoiE<:OmP;aCoARH:oc@_:OmP;aCoUEhcojJ4Q002ongIc00QooKfmOof
oooom_KeooKfmOofkN[oi:ZHoiE<:OoL/j?okMW<ooKfmOoooooog;jgoij=
<onVV6oog>?Fol6c[OnVV8Co`K>>ong@V?oC_XkoWXdcok2ZQ?o:_Zgob]31
omc7XoniZVoog;j]olZn[OnNSC?o`K>>ol[@`OniZVoog>?P00;o^JY_00Co
`K>>ongIc?ofkN[oi=3<0_ooool01?ookLcoonf>ong@V?oohhh4ooK7?@05
onBc<oofacgoi;<YonBc7_of/`000ooCV0X03_o:V1Com[<0om>H2_oT/c?o
i;<NooK7?OoT/bWokLMLonBc7_o]aecoonf>oooSS_oohhCoon>>0_ookHh2
ooKIIP03oooSQ?offFKom/Lm00;om/Lm00CokLMLooK7?Oo]aecog:Xc0_o:
V1@04oniSACoSED:of115?m69QCo6RHDoa4L2_l94P[o4BHDo`T95?m6;`[o
^JY_om>nS_nVV6ooWXdcoa4V2_l971ko6Q8Do`000?oLZS<00_ookL`03?of
ooGoong<ooo]S_o]aecoi;<combZ<oo1Q03o=2lNoaXL7_lJ9QCo?A8:ooo]
c0Sooooo00?om^gZooooooooool01?ooool00oofooookOKeomcSh004oooo
o`03om?Ie_oVi^Koi^KV05goi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X0
00?ok^k^00GojNWYolG5aOn3Ph?o[:b/okbl_002ojj^[P04okJf]_nl_;co
_knoolC4a0SobLW901KoooSooookoooonOooo_Shoooon?ogm>_oooohoogl
n?ooo_oono_oooklooodmOoono_oomKGoomKGX_o;2iOoaPID_lQ8Ego:R]T
obh_J?la<V_o=CI_1?lg>706ocLhKP_o>3U_1Olg>6h2ocLiK0Co>3Y]2_lg
>F`8ocLhKPSo>3U_2?lh>G42ocTjLP0GocPiLOlg>73o>CYbocXkLold=Fgo
;2iQoa/MCOlW:UGoGf2@omSIoooknOook>_oookkooonoOooookooo[kmOok
no7oooodoo7ajOoooo_oookoooKdnOooool00ooMgMd2omoOg`KohN7Q2_oR
h^83on?Sh`;oi>CT0ooUiND:onKViPKoinOW0_oXj>P5onWYj@_oj^[Z0_o[
jn/2onc/k004ong]kOo^k^kok^k^onk^kP[okno_1Oo`l?03oo7al@Gol_;b
2?oclo<2ooCdm0?omOGe0oofm_H2ooOgm`?on?Sh2_oinOT3oo[jnP?oo?cl
0_ono_hAooooo`04oamQ]?nS`^Co^=?_ogN^j`;oZ]oo00CoKVi^okBd]?oP
h>3ok>c/Foo^k^h01Om69P[o?A`:odHV2_lm70[oPcP000;oNd`:017oPd40
og]10?mkC0[oNd40of0_2_mb>1CoLSP0of0_2_mkC0[oLRH0of0_2_mb>03o
H2l:oeLL0?m6;`[oEa`0o`TB2P02ofY12P05of0_2_mG703oARH:odH_2_lS
9PX00ol/4P003olS70[o6PT:ocdL2_l/4P3o6PT:ob<L2_lm70[o4A`:odH_
2_l/4P3oH2l:ob<V2_m6;`[o?A`:ob`B0002ob<L2P07oaX92_lS9P[o8blN
ob<_7_ldEBWo6Q8Do`TB2P02ob<L2P0BocdL2_m69P[o2A8:oaXB5?l94P[o
AT`moh=N<omZIc?oSHe7oc@_7_n3Nc?o0000ofYE7_n3Nc?o2A`Do`T92_lA
70[o6Q8D0_l/4P001?lA70[o2@T:oa4L2_m69PX4odHV50;oARH:013oH2lD
og]<5?niLS?o^G8col6QQ?oTZYSo/7/Yog8h5?mP;aCoARHDog8h5?mP;aCo
LSPDoiEE5?ookLcom^gZ0_ofm_D03Oofoooom_KeooKooooC_XkoYT40onBZ
V?o]fLcoong<ooKoooo]d9So`J64okVZKoo]kNX00ooC_Xh01Oo1/hkoSHeB
ok2ZQ?oC_XkodmWF00?odkj>017o`K>>okVZKonVV6oo`K>]ongfmOo1/hko
bZ5BombcQ?oLaj?okMW<ooKomOooooooUHAkol77c?ofoooom_oeong@V002
oooSSP;okLML01Oom]UVong7G?oT/akom/LmonBc<ooT/bWoi;<NooJc0?oC
V0[oi:X0om>40?oTZP3odiP:onBZ0?ofaakoi;<cooK7?Oo]aecoi;=7onBc
<oookHkoon>>ong@V002oooSSP04ong@V?oohhkom]UVong@V0;om]UV01_o
kLMLong7Q?ofacgokLMLombcG?oLZS?o^H@DolZH5?o1Q03oPehDofY12_m6
9QCo;2HDoaX92_lJ4QCo4A`:oaXB5?lm70[o/8eBomc7XonESE;oWXdcodI1
7_l92@[o4BHDoaX92_niLS<00oookL`00oookHkoon>4ooK@Q002onBc:@06
ok2=7_m6@Ako4BHDoaXB5?l/4P3oong<2?ooool00oo]kN[oooooooooo`04
ooooo`03ooKoooo]m_GokMW<00Cooooo00?odmWFonk^k_o^k^h0GOo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@000oooool02oomoOgom?CdokNg]omi
NGWoP820ohn?SonLW9coYJFUojb/[?na/K7o]kNg00ko^k^k0onl_;`3okfm
_@03okjn__nm_Kgo_[jn00;o_[jn0_no_kl;ol30`0;o`L710_o2`/801?o3
`l?oa<C4olC4a?o4a<@:olG5a@Goa/K60_o7alL00oo6a/KoalO7olO7a`03
olO7a`gob<S800?obLW9ol[:b_o:b/X03oo;bl/3olc<c003olg=cOo<c<co
c<c<00;ocLg=2oo>c/h2olo?c`?od=3@00?odM7Aom;Bd_oCdm<00_oCdm<3
omCDe0OoeMGE1_oFe]H2omOGe`Gof=SH2ooIfMT3om[JfP;ofm_K0ooLg=`:
omgMg@Gog]kN0_oOgml00ooNg]kogmoOomoOg`03omoOg`Soh>3P0ooQhN42
on;RhP;oi>CT00?oiNGUonOWiooWinL00ooXj>P:onWYj@?oj^[Z0oo/k>`2
onk^kP_okno_0_o`l?03oo7al@03oo;bl_oalO7olO7a00;ol_;b0ooclo<>
ooCdm004oaiO/_nUa>Ko^M?_ogN^j`;oZMco00CoMWIfol71`Oo`l?3ooOgm
Foooool01?m69P[oH2l:odHV5?mk@@02og]<5004oh<h0?mZ@@[oJT4:ofY1
2P;oNd`:00WoLSP0og]<2_mb>03oLSP0of0_2_mb9P3oH2l:og8h0?m6;`X0
0_mG70003?l92@[oLSP0og8V0?mG703oARl:odHV2_l/4P3o8bH:ob<L2_lA
70[o6PT:ob<L2P;o;18000[o6Q8Dob`B0?lA70[o6PT:ob<L2_l/4P3o;1`D
ob`B0?lS9P[o;1801?lS70X02?lJ2@[o8bH:oba<:Ol/9QCo;4`Yoa4L2_l0
003o6PT:0olS70X06_l94P[o4A`:oaXB5?mZIc?oWXdcoij=:OmP@ACoNd`:
oh=N5?l92@[oH44Dob`B0?l94P[o2@T:oaX92_l/4P3o8a`:oaX92_lA70[o
2A8:oa4L2_lm70[oARHDob<V2_m69P[o;2HD0_m69Q@02_mG703oPcP0ok11
<on`SE;og;>4ombcXonVLU;oPcP0ob`V5?m69PX2of0_5004oiE<:Oo1Ng_o
m^gZooKoo`;om^gZ00[om_KeooK]j_o]fLcoYW9BokUb<ooTZYSokMW<ooK]
j_ofm_Gog>?F0_niZVl02OoTd<co`K>>ol6cS_o1/hkoUIQVoiik<oo1al7o
b]31onC@c002om>nSP08omc7Xoo]d9SoYYQ_ok2ZQ?oLaj?og>?Pomc7Xoo]
d9P2ol[@`@04ol77`OoL_[Oom_oooiEbA`;ooooo00[okM2Hooo]c?ookHko
m]UVong7G?offFKokLMLooK7?OoT/dOom/Lm0_o]_Sd01?oT/c?oi:X0om>H
2_oTZP03om>40007om>H2_oTZP3oi;<NonBc7_ofd8CokLMLolZQ?@04oooS
SP03ooKII_oohhkoon>>00?om]UV00?okLMLooK7?Oofacd00_o]ae`02Oo]
_Sgog;=Lom>H2_o:V2Wo^H@Doiib5?mZ@@[oARl:oaXV5003oa4L2P0IoaX9
2_lA70[oWW/com>nS_n=SDOoWXdcodH_2_l971Co4BHDo`T92_nNGQCoong<
ooo]S_ookLcoon>4ooo]S_ofd8Coi;=7onBc<oniSBWoH44Do`T95?lJ9QCo
;180ombcX`08ooooo`03onC@c?oooooooooo00Cooooo00?om_ooongfmOoC
fMH01?ooool00ooCfMKoooooooooo`1Mooooo`04ojn_[oo;bl_og]kNon[Z
jP7ol_;b0004onk^kP0:on_[jooPh>3o^;Rhoh61POm`L73oN7Qhoh^;RonB
TY;oVIVIoj6QX@koYZJV1_nWYjL00onXZ:SoZJVYojZZZP04ojZZZPSoZj^[
0on/[:`2ojf][@;o[Zj^00Co[Jf]ojj^[_n^[Zko[Zj^0_n_[jl=ok2`/0;o
/K6a00?o/[:bok>c/onc/k<02onc/k<2okBd]0?o]KFe00?o][JfokFe]One
]KD00_nf][H3okNg]`[o^;Rh0oni^KT00onj^[[o^k^kok^k^`02okbl_0_o
_Kfm1Onn_[h00oo0`<3o_knool71`@05ol71`@[o`/;21?o3`l<4olC4a0[o
aLG51_o6a/H00oo7alOoa/K6olO7a`04olO7a`Sob<S80oo9bLT2ol[:bP?o
c<c<0oo>c/h2olo?c`_od=3@0_oAdM43om;BdP;odm?C2ooDe=@5omGEe@?o
emOG1OoIfMT8om[JfP;ofm_K0ooLg=`3omgMg@;og]kN0ooOgml>on3Ph004
oaQFYonTa>Ko^M?_ogJ]jP;oZn3o00CoKVi^okBd]?oPh>3ok>c/Foo^k^h0
1Om69P[oARl:og]<5?n=E@[oNd4000;oPd4000OoNd`:og8V0?n3@@3oNd`:
og8h0?mZ@@[oNd4000;oJT4:00GoLSP0of0_2_mb9P3oLRH0oeLL0002odH_
2P0;oa4V2_m6;`[oH2l:odH_2_m69P[o8bH:ob`B0?lS70[o;180ob<L2_l/
4P000_lJ2@X01OlA70[o6PT:oa4L2_lJ2@[o4A`:00;o6PT:00Co8a`:oaX9
2_lA70[o;1800_lS70X01?lJ2@[o2A8:oa4L2_lS9PX3ob`V5004o`TB2_lA
70[o4A`:ob<L2P;o6PT:00?o4A`:oaXB5?l000000_mZEAh04_n3Nc?oARH:
olZQD_mZ@@[o4BH:ob<L2_lJ2@[o2@T:oa4L2_l/4P3o6Q8Dob`B0?lA9Qko
6PT:o`TB2_lS70[o?A`:ob<V2P;o;1`D00go?A8:ocdL2_lm70[oARH:og8h
5?n`@C?oYW9BonBZV?oL/j?o`J64ok1k:OlS9P[o8blN00;o;1`D00goUD`Y
ol6QQ?o]fLcom_ooongIc?ofkN[okMW<ojJHQ?nEGS?o^G8conBZV?o]fLco
ong<00;om_Ke00?ooooookVZKoo1XH@00_oC_Xh03_oLaj?odkj>oh=N5?o1
/hkob[j]ol[@`Oo:_Zgog<NSol[@`OoC_Xkob[j]ojJHKooTd<cob]310_oT
al401ooLhmKokMW<ohf=D_oL_[Oog>?FooKooonNQ6H00_ofool02?ookLco
onf>ongIc?offFKom]24ooK7?OoohhkokLML0_offFH01?o]aecom/Lmong7
G?oT/ah2om>H2P?odh@00_niI`002?n`E@3odh@0onfn?OoCZTOo^Hdcooo]
S_ookLcom]240_offFH01_o]d9Som]UVooK@Q?o]d9Som]24ooKIIPCokKhm
0_oT/dL3olZH500Poiib2_mZ@@[oJT4:ob`L5?lA70[o6PT:oa4V5?lA70[o
2@T:oh=N<ooC_XkoUHeBohf=AoldEBWo4A`:oa4V5?lA70[oPbl0ooo]c?oo
kHkoong<ooK@Q?o]d9Som]24onBcAooT/ako/8dNofY12_l971Co8bH:oaX9
2_o]ah@8ooooo`03ong]j_ofooGooooo00Kooooo00?o`K>]ooooooooool0
0_ooool00ooLhmKok^k^onk^kP1Monk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q0004onKViP08onCTi?oPh>3od];Bokbl_?nPX:3oR8R8ogUiNOmbLW;o
ofi^KPgoKVi^00WoJ6QXofEUIOmOGeooF5QHodY:B_l6=gGoYLCVokG@k_mi
[^`00_nWg?l01?mZJV[o[Zj^omSHf?oTi>AKonKViP0BodHV2_lm4P[oPehD
oheE2_mkC0[oJT4:og]<2_mb>1CoPd40og]10?mkC0[oPcP0og]<2_mk@@3o
LSP0og]<5?mb9P3oLSP00_mP;`X01OmG703oH2l:oeLL0?lJ2@[oH2l:00;o
Ea`000goARl:odHV5?l/4P3o8a`:oa4L2_lJ2@[o4BHDoaX92_l92@[o8a`:
oa4L2_lJ2@[o2@T:00;o4A`:00?o6PT:oa4L2_l/4P000_lS70X02OlA70[o
6PT:o`TB2_l/4P3o4A`:ob<_7_ld;ako8blNoaXV5002o`TB2P04oa4L2_lJ
2@[o8a`:oaX92P;o4A`:00?o6Q8Doij=<om6;`X00_n3Nc<00on`ZXCoJUDN
ob<V2P02oa4L2P08ob<L2_lA9P[o2A8:ob`B0?lA70[o6PT:oaXB5?l92A@3
ob<L2P0Mob`L5?m6C3goARHDocdL2_mP;aCoARHDoh<_0?nEC2Wo/7/Yom>n
S_oL/j?o`J64ok1k:OmG703o6RHDob`L5?ld;akoUEhconBZV?ofkN[om_oo
ooo]c?oTd<co/7]Vok11<oniLS?oi:ZHonC7`Oo]fL`00_ofkNX01?ofm_Go
m_oeokVZKoniV5`3om>nSP0IokVZKoo1/jgodkj>om?Ie_oC_XkodmWFolZn
[OoLaj?ob[j]onC@c?o:d<7oi=3<ol[@`Oo1/jgodmWFol6c[OnEV6KoWXAV
ojJHKombIe;oYYR4ombn]ooooooom_ooong@V002ooo]SP04ooK@Q?offFKo
m]24ooK@Q0;om]UV00Gom]24ooKII_o]ahCoon>>ong7G002onBc:@05olZH
5?oCV0[odh@0okUW0?oTZP000_oT/bT00ooffFKokKhmokV45003ooo]SP09
ong7Q?oohhkom]UVong7Q?offFKoon>>ooK@Q?ofacgokLML00;okKhm00?o
kLMLonfn?OoL/e`00_o:V1@01_n`SAkoWW8Dog]<2_m6;`[o;2HDoa4L2P;o
6Q8D0_lA70X02on3GS?o^JY_ohf=Aon3Nc?o=2lNoa4V2_lJ4QCo4BHDog8V
0?ookLcokM2H00;om]240_offFH2om>Q:@06okV=<omP@ACo2@TDoaXL7_l9
2ACodjY72?ooool00oo]kN[om_oeooooo`04ooooo`03ooKooooooooo`K>]
00Cooooo00?og>?FonKVi_oVi^H0GOoVi^H01?nMWIgo]kNgolS8b?oCdm<1
om[JfP001?o^k^h02oo[jn_oh>3Pok>c_OmPH8ko9S9oo`T]Q_l0>Y?o0d:H
o`e=WOlEEJ?o7F2Z013o8VB^0_lSIJh3obAU[P?o9FJ_0olWIk03obQW/0So
:FR`0olZJK43ob]Z/P03obe//ol/K;;o;6bb00;o;Vjc0ol_Kk@9oc1_]@?o
<6nf0_l`L;H2oc5a]`04oc5`^?lbLKWo<W6ioc9a^@?o<W:i2?lbL[X3oc=c
^P?o=7>j00?o=WFlocIf_?lfM[`00olhN;h2ocUh_`Wo>WVo0olkN/03ocak
`@03ocel`_llNl7o?Gc200;o?Gc20olnO<<8ocima0?o?gg50oloO/D2od20
aP04od60aom2P/Wo@X;9od:2b@?o@X?92?m3PlX3od>4bP?oA8C;00?oAHC<
odB4bom4Q</00_m5Q<`3odJ4c@WoAXG=0_m7Q/h3odN7c`;oB8SA00CoBHSB
odZ:dom:R]?oBX[C0om:Rm@8odZ<e@?oBXcF0om:S=L00om:SMSoBXkGodZ>
e`03odZ?f0;oBXoI2Om:SmX3odZ@f`;oBi7K0_m=T]d01?m<TMkoCY;OodjB
gom>T]l3odnCg`SoCiCP0om@U>43oe2Eh`03oe2Ei_mAUNGoDIGU00?oDIKX
0omAUnX>oe:Gj`04oeNUoOnQ`^Go^=;^ogJ]jP;o[=oo00CoKVi^okBd]?oP
h>3ok>c/Foo^k^h2og8h500Boh=N5?n3@@3oJT4:ofY12_n3@@3oPcP0ofY1
2_n=E@[oNd40og]<2_n3@@3oLSPDog]<2_mb9P3oNd`:of0_2_mb>03oLRH0
0_mP;`X02_mG703o4A`:of0_2_mP;`[oEa`0of0_2_l/4P3oARHDob`B0?lS
70X2ob`B0007oaX92_lA70[o4A`:oaX92_l/9QCo4A`:oaX92P02oa4L2P0@
oaX92_lA70[o;180o`T92_lS70[o;180o`T92_l/4P3o4A`:oc@_7_l/9QCo
6RHDoa4L2_l94P[o4A`:oaX92P;o8a`:01Oo4BH:oaX92_lJ9QCo4A`:oiF=
D_mkC0[oJVLcol6cS_niV5coPg/cob<V2_lA70[o2A8:ob<L2_l92ACo8a`:
ob`B0?l94P[o4A`:o`TB2_lA70[o8a`:ob<V2P02ob<L2P05oa4L2_m69QCo
ARHDodHV2_mP;a@00_mb>1@03onNGQCo`J64onBZV?o1XHCo/8eBodH_2_l/
9QCo?A`:oeLL0?nVLU;oi<O1ooo]c?ofm_Goi:ZHol5kN`02okUb<`0HonBn
Q?oL/jgokMW<ooo]c?ofkN[om_KeooKooooTd<co`J64ok2=<oo1/hko`K>]
ojJHKoo1/hkom_ooom?Ie_o1alcog>?Pol[@`OoTd<cob[j]ol[@`OoLhmKo
kOKe0_o:d<404?o:_Zgog>?Fok2ZQ?n`Q6Ko/:Z4omc7Xoo:d<7og>?Poooo
ooofooGom_ooong@V?ookLcokMW<ooKII_o]d9P2ooKIIP0<ooK@Q?o]aeco
m]UVooK@Q?oohhkokM2HooK@Q?offFKoi;=7ooK7?Oo]d9Som/Lm0_o]ae`0
2_oT/dOokLMLom>Q:OniQ2WoWW8:oooSQ?o]fLcoonf>oooSQ?o]d9P2oooS
SP08ooK@Q?oohhCom]24ooKII_ofacgokLMLooK7?Oo]_Sd2onBcA`07olZH
:OniSACobYPDoiib5?mkC0[oH44Dob<L2P02oa4L2P0Joa4V5?lJ4QCo2A8:
ofYE7_niZVooYZ5VoiF=D_m6;`[o6RHDo`TL5?lJ4QCoLRH0oooSS_offFKo
m]24oooSS_o]aecoi;<com>Q:Oo:V2Wo/8dNof115?l92ACo4BH:o`T95?ni
LS<8ooooo`03ongfmOo]fLcooooo00Cooooo00Gom_oooooooonVZZ?om^gZ
ooKoo`02ooooo`03om?Ie_o^k^kok^k^05gok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN4000?ooooo00cooOgmooCdm?n[Zl3o>3f:o`L^Tol1@Iko3eBY
ob=T/OlaL;Oo?W^oodB0`Om:QL@=oe:;b0CooOcm00?ooOgkoogmnOomoOT0
0_omoOT01oomoO_oo?[kooCbmOodlOSokN[con7NiooNfnH00_oDdM`03OoD
d=koe=7LomC@g_oDdMcoe=3NomCAg?oEdMooeM;MomGAgooEd]goeM7OomGB
gOoEdMl00_oEd]d0;_oEd]_oem7MomGBfooGdMgoeM;KomOAgOoEd]_oem7M
omGBfooGdMgoeM;KomOAgOoEd]_oem7MomGBfooGdMgoeM;KomOAgOoEd]_o
em7MomGBfooGdMgoeM;KomOAgOoEd]_oem7MomGBfooGdMgoeM;KomOAgOoE
d]_oem7MomGBfooGdMgoeM;KomOAgOoEd]_oem7MomGBfooGdMgoeM;KomOA
gOoEd]_oem7MomGBfooGdMd3omGBg@0FomGAgooEd]goeM7OomGBgOoEdMoo
eM;MomC@g_oDdMcoe=3NomCAg?oDd=koe=7LomC@g_oFd=kod/WLon;Ij_oP
f^Sok>K`ooKdnOodm?Koo?cjoogmn@;ooOgh00OooOgioogmnoomo?gooOcm
oogkoOomo?gooOgm00;oKjGQ0om_Y^43og2WhP;oLJSS00CoLJOSog:Xi?mb
Z>CoLZST0omcZND8og>Zi@KoLj[V00?oM:_WogF[iomeZnL01Omf[>P9ogJ/
j@;oMjgZ0omh[^`2ogZ`kP04ogV`kOmk/^ooNk;_og^bk`?oO;?a2?mm]?86
ogjel`03ogjfm?mn]oGoO[Oe00GoO[Sf2Omn^OL3ognjm`;oP;ch0_n2_oX0
1?n3__[oQL7lohG1o?n5`O`3ohK3o@SoQlCm0on7aOd3ohO6o@?oR<Om0on9
b?d3ohW9o@koRL[m00CoR/gnoig3j_nfd>koNJo^0_n[g_l01?mfMWKo`L71
oo3`l?omoOeKooooo`0DofY12_mb>03oPehDoheE2_m69P[oLSP0oh=10?mb
9P3oPcP0oh=10?n=E@[oPd40og]<5?n3@@3oNd`:og8h0?mkC0[oLRH0og]<
2_mb9P03of0_2P0<oa4L2_mZ@@[oNd40og8h0?m69QCoEa`0ob`B0?lS70[o
;180oaX92_lS70[o4A`:0_lJ2@X02olA70[o2@T:o`T92_lJ2@[o2@T:ob`B
0?lA70[o6PT:oa4L2_lS70[o2@T:00;o8a`:0_lA70X00ol/9QCo4BH:oa4L
2P02o`T92P03o`TB2_lJ2@[o4A`:00;o;18001?o2A`Dob<L2_l0003oJVLc
oh=k<omPGS?ob]31ok2ZQ?nEV6KoNd`:o`TB2_lS70[o8bH:ob`B0?lA70[o
;180o`T95?l92@[o4A`:00;o;1800olS70X00olJ2@[o8bH:of0_5002of0_
500DoiE<:OnEGS?oUD`Yok2=D_o1XHCo/8eBoiE<:Olm70[o;2HDoaXV5?mP
;`[o`G]kooo]c?ofm_Gom_oool5kNoo:ZVKog;>4onBZV?oL/jd2ooo]c00:
ooK]j_ofm_Gom_KeooKomOo]fLcodkj>okV=<oo:ZVKoi=3<ol6cSP;okNgZ
00Oog<NSol6cS_oLaj?oi=3<ok2ZQ?o:d<7om_oe00;og>?F00Go`K>>olZn
[Oo:_Zgoi<O1ok2ZQ002olZn[@09ojJZXooL_[OokOKeooKoooofkN[om_oo
onBcAoookLcoonf>00Com]UV00?okKhmong7G?ofd8@00oofd8@01?o]ahCo
kKhmonfn?Oofd8@2ong7G00EooKII_oT/dOokLMLonBc:OniQ1CoYT40oiEE
5?ookLcokMW<ooo]S_o]d9Soong<ongIc?ookLcokLMLooK@Q?o]ahCom]UV
onBcAoo]aecoi;<c00;oi;=701Kog;=LolZH:OniSACo^H@YojIb0?mZEAko
JT4:ob<_7_lA70[o6PT:oa4L2_l94P[o6Q8DodH_2_o:ZVKoSHeBohf=AolS
;ako6RHDo`TL5?lJ4QCo?A8:0_oohhh03OoffFKokLMLooK7?OoT/dOog:Xc
ojIb5?n=E@[oPehDo`TL5?lJ4QCo4BHDoiiN5?ofool01oooool01OofooGo
i=3<oooooooooooom_oo00;ooooo00Som_ooooooooo1/jgog>?Pooooooof
ooooooooomcSh5oooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000?ok^k^
00cojNWYol30bOlj?hgo=ej/oeR<a_lkMKWo=W>hodF0`?mCRLCoFY36of:H
comYVm0=ofnPe006ooomooooo_ooookoooonoooooogooook0_ooooX02?oo
noSooogloo?^l_oTgnKoh=[VomWChOo?b=[oc<GG0_nm]/P03Onm]L[o_KK8
okfeb_nm]/So_KG:okffb?no]lco_kS:okngc?no^<[o_kO<oknhb_no]l`0
0_no^<X0;_no^<So`;O:oknhb?o0]l[o_kS8ol2gb_no^<So`;O:oknhb?o0
]l[o_kS8ol2gb_no^<So`;O:oknhb?o0]l[o_kS8ol2gb_no^<So`;O:oknh
b?o0]l[o_kS8ol2gb_no^<So`;O:oknhb?o0]l[o_kS8ol2gb_no^<So`;O:
oknhb?o0]l[o_kS8ol2gb_no^<So`;O:oknhb?o0]l[o_kS8ol2gb_no^<So
`;O:oknhb?o0]lX3oknhbP0<okngc?no^<[o_kO<oknhb_no]lco_kS:okng
c?no^<[o_kO<oknhb_no]lco_kS:0_no]l`02?nn]<coc/CLolc5eooFd=ko
h]cVon?Qi?odlo7ooOch0_ooooX01?oooo_oooomooonooooo_l2ooomo`03
oooooon:^^_oR[[[00?oR[[/0on;^nd2ohblkP04ohbmk_n=_^ooSKk_ohfn
k`?oS[o`2?n>_o43oho0lP?oT<7c00?oTL;eoi71m?nA`O@00_nB`_H3oi?3
m`WoU<Ch0_nDaOP3oiC5n@;oULKj00CoU/OkoiO8o?nGb?coUlSl0onGb?d8
oiO9o@?oV<Wm0onIb_d00onJc?koV/_noi[;oP03oi_=o`;oW<ko2OnMc_l3
oik@o`;oW]7o0onPdol3oj;Eo`?oX]Ko2?nSf?l3ojCIo`?oY][o00?oZ=co
ojSMoonXgOl00onZgol3ojcPo`ko[N7o00Co[NOooj78kOnhd^ooNJk/0_n/
gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP06oh=10?n=E@[oNd40og]<5?n3
@@3oNd400omkC0X00on3>03oNd`:oh=10002oheE2P05og]<2_n3@@3oNd`:
og8V0?mb>0000_mP;`X01omb9P3oPbl0oaXB5?mkC0[oPd40og8h5?mZ@@X0
0_m69PX00ol/4P3o8bH:ob<L2P02ob`B0009oaX92_l92@[o6PT:oa4L2_lJ
4QCo4A`:oaX92_lA70[o6PT:00;o2@T:0_l/4P001?lA70[o2@T:oaX92_lJ
2@X2oa4L2P0Eo`TB2_lA70[o2@T:o`T92_lJ2@[o;180oaXB5?l94P[o2@T:
oa4L2_lJ2@[oH44Yok24:OniV5coYYQ_ojJQI_n`SE;oWXdYo`TB2_lS70[o
;18000;o6PT:00Ko8a`:oa4L2_lA70[o4A`:oaX92_lS70X2ob`L5005ob<L
2_l/71Co4A`:odHV5?mZEAh00_mP@BT03onEGS?oPehcoiE<:OnVQ5;oWW/c
of11:OlS9P[o8blNob`L5?mb>1Cog;jgooKfmOofoooom_Keombc[@03onBZ
V003ombn]oookLcom_Ke00?om_Ke00kom_ooooK]j_o:_Zgo^JY_okVHG?o]
kN[o`K>]ooKooon`/kOob[j]ombn]oo]fLcoYZ6Hok2ZQ0;okOKe01Ko`LO1
ol[@`Oo:d<7oi<O1ok2ZQ?oLhmKog;jgol[@`Oo1al7oi=3<omcSe_ofm_Go
ooooooKoooooooooi;<Yooo]S_o]d9Som]UVong7Q?ofacgokLN40oo]_Sd3
ong7G0?okKhm00_om]UVonfn?Oo]aecom]UVong7G?o]_Sgodh@0ok1<0?n`
E@3oSED:ooo]c003oooSSP05ong@V?oohhkoon>>oooSS_o]ah@00_oohhh2
ong7G00Xonfn?OoT/dOoi;=7ombcG?o:ZTOo^H@DolZH5?nNSBWoLSP0of11
5?l/71Co4BHDoaXB5?l92ACo4A`:o`T92_lS9P[o`K>>ohf=D_n3Nc?o8blN
oaXV5?lJ2@[o4BHDob`B0?offFKom]24ooKII_oT/dOom/LmolZQ?OoCXBWo
^H@Doiib<omkC1Co2@TDoaXV5?lA9QCoLRH0ooK]jPOooooo00?om_oool[@
`Oofool01?ooool01?ofoooooooool77`OoLhmH2ooKoo`03oooooooLhmKo
k^k^05kok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;oi^KV00goiNGU
omgMgOm^KYgo:DVRog^UdonB]M[oIIG9odj6`omLTLOoJ9[=og2Nd_mcX];o
O:OF00goOjcH00Kooogoooonooooo_ooookooooooOoooo/2oooonP08ooKb
koodl?7ogm[PolW3coo0^LWo^K78ok2V_on/Xkh8oijE/0SoW9>^<?nMTj`8
oibC[PSoWIB_00SoXIJdok6Va?n^Y[ko]Zo1ol:lb_o:aLcohMcPong/jP?o
oook00?oooomooonooooo_l00_oooOl00oooooooVlKaoi_6l@03oic7lP?o
WLSc0_nNbOD01?nMbOCoW/[foik:m_nNb_H3oio;m`SoX<ch0onPcOP3oj7=
n@03oj;>n_nSc__oXlkk00;oY<ol0onUcod9ojG@o@;oY]3m0onVdOd2ojSB
oP04ojOCo_nYe?ooZMCoojWDo`?oZMGo2?nZeOl3oj[Fo`?oZmKo00?o[=So
ojgHoon]f?l00on^f_l2ojoJo`Wo[m_o0onag?l2ok;No`;o]>3o00Co/moo
okGQoonehOoo]N7o0onfhol8okSTo`Ko^>Go00?o^NOook[Xoonjj?l01_nk
j_l>ok_[o`04oko`oonXc_3o]];^ogV^j@;oZ^3o00CoJVYZojj^[_oHf=So
i>CTFooVi^H02OmkC0[oNd`Doh=10?mkC1CoPd40og]10?n3>03oNd`:oh<h
0003oh=1000>oheE2_n3GQCoPd40oh=10?n3>03oNd`:oh=10?mk@@3oLRH0
of0_2_n3;`3o8a`:ofY12_n=E@X2ofY12P06of0_2_m6;`[o;180ocdL2_l/
4P3o8a`:0olJ2@X00olA70[o6PT:o`T92P02o`T92P0;oaX92_lA70[o2@T:
oa4L2_l94P[o6PT:oaXB5?l92@[o4A`:oaX92_l/9Q@00olA70X2o`TB2P04
oa4L2_l92ACo2A8:o`TB2P;o4A`:00[o2@T:ob`h:On3Nc?oPg]LojJZXonE
V6KoUHABoh=k<ol94P[o4A`:0_lS70X01OlA70[o6PT:o`T92_l92@[o4A`:
00;o6PT:013o8a`:ob`V5?lm70[oARH:odH_2_l92@[o4BHDob<L2_mZEAko
WW/cok24I_n`NfKoUEhcog8h5?ld;ako6RHD0_l/71@02on3;`3okMW<ooKf
mOofm_Goooooombn]ooL/jgoi;j4ombc[OoTal7okMW<00;om_Ke01kom_oo
ooKfmOofm_GokMW<ol6cS_niV5cobZ5BongfmOoL_[Oob[j]ol6cS_oTd<co
b]31omcSe_mbIe;ob]31ol[@e_o:d<7ob[j]om?Ie_o:d<7o`K>]oiF=I_o]
m_GokNgZomcSe_nVXFKoLVMBojJHQ?nVZZ<2ooKoo`04ongfmOoT/bWoong<
oooSSP;om]2403cokKhmooK7?Oo]aecokKhmooK7?Oo]aecokKhmonBc<oo]
aecom/Lmong7G?offFKom/LmonBc<ooT/dOoi;<conBcAooT/ako/7/:ojI1
0?n3;`3oonf>oooSS_o]d9Som]24ooo]c?o]aecoon>>ong@V?oohhkokM2H
ong7Q?offFKokLMLonBc:OoT/akog:XcombcG?o:V1Co^H@DolZH5?nNLQCo
LSPDog]<2_lS9P[o8a`:o`T95?l/4P3o6Q8DoaX92_lS70[oYYQ_oh=k<onE
LTOoAT4NoaXV5?lA70[o8a`:oaX92_ood3d2ooKIIP08onBc<oo]aecoi;<N
om>Q:OniQ1CoWW8:oh=N5?l92A@2oaXB5003ocdB2_o]d9Sooooo00Oooooo
00?ob[j]ooK]j_ofool00_ofool00ooooooom_ooooooo`02ol[@`@04ongf
mOofooooooooom?IeUooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;o
k^k^00gokNg]on3Ph?lf?HkoI8_6oiRig?nO_mooP:[Eof2Baom/V/coLYo@
ogVUe_mmYmKoPjgI00goRKCO01CoookoooWhoOooo_oooooooooooOonoO_o
ookkooolnooXi>God/gColBlbOn`Yk[oXiVboiZ?[On8NYkoPgNMohAjWOn3
NIcoPGNJogmeV0;oOWBG00?oOgFHoh1fVOmnM9L01omnM9L`ogidUPSoOG>F
00?oOgFHogecU_mkLI@00_mjL9<00ommLiKoP7JIoh9hV`02oh=gV`08ohf2
X_nMTjkoYijcok2X]oo2^/GodlkDonGQh_oelO82ooono`05ooooooooo_oo
ookoooonooooool00_nRc?D3oj;=mP?oXlgf0_nTc_P01?nTc_OoYLoiojG?
nOnUcoT3ojK?n@SoY]3j0onWdOX3ojSBn`03ojWDo?nZe?goZ]Cm00;oZmKn
0on/eol9ojgHo`Go[]So0_n_fOl00on_f_oo/=_ook3Ko`04ok3Ko`So/M_o
0onag?l3ok;Mo`03ok?NooncgOoo/mgo00?o]=ko0_negol9okGPo`?o]n7o
0_nhh_l2ok_Uo`04ok[VoonmjOoo_NWookgYo`?o_^[o2?o0jol3ol3/o`?o
`Nko00?o`o7ool?`ooo3l?l00oo5lol3olKeo`koa_Ko00Cob?WoojcCl?ni
dnkoNJk[0_n[gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP09oh=10?n=E@[o
Pd40oh=10?n3>03oLSPDoh=10?n3>03oPbl000;oNd4000GoSED:og8h5?nE
E@3oPd40og]<2P02oh=100;oNd4000SoLSP0og8V0?mP;`[o;180og]<2_n3
@@3oNd40og8h00;oH2l:00?o8bH:odH_2_lS9PX00_l/4P001?lJ2@[o2@T:
ob<L2_l92@X2oa4L2P03oaX92_lA70[o2@T:00?o2@T:00co4A`:ob`B0?lA
70[o;180oa4L2_l/9QCo8bH:ob`L5?lA70[o2A8:o`T92_lJ4Q@2oaX92P09
oa4L2_lJ2@[o8a`:ob`B0?ld;akoSHe_ojJQV?o1/hkoYYQ_00;o`K>>00?o
;180ob<V2_lA9PX00olS70X01?lA70[o2@T:oa4L2_lA70X3ob<L2P0Kob<V
2_mP@ACoH2lDodHV5?lA70[o6Q8Dob`L5?mP@BWoPehcol6QQ?nVZZ?oH44D
oaXV5?lJ4QCo;1`Dob`B0?nVEFKokMW<ong]j_ofm_Goi=3<onBZV?o1Ng_o
g;>4onBZV?oL_[OokMW<00;om_Ke00Som_ooooKfmOofm_Gom_KeojJQI_o1
XHCodkj>ong]jP;o/:Z40_o:_Zd01OnVZZ?okOKeojJ4Q?o:_Zgo`K>>00;o
b[j]0_o1/jd08OoTd<coYZZ]ongfmOn`/kOoUJ6>oiF4D_n`ZXCog;j]ong]
j_ofooooooooooKomOoCXBWoong<ong@V?o]aecom]UVonfn?Oo]aecom/Lm
onBcAoo]_Sgom]24ong7G?offFKokLN4ong@V?ofd8Coon>>ong@V?oT/c?o
kLMLolZH5002onfn?@03ooKII_oCQ03oUED000;oon>>00Kom]24ong7Q?oo
hhkoon>>ong@V?ofd8@2oooSSP0[ooK7?Oo]ahCokKhmonfn?OoLZS?og;=L
om>ZAoo:XCgo/7/DolZQ?OnNSBWoPehDofY12_l/9QCo8a`:oaXB5?l99RWo
4A`:o`TB2_l/4P3oUIQVoh=k<omZIc?oAT4Noa4V5?lJ2@[o2@T:ob`B0?oT
/bWokLMLooK7?Oo]aecoi;<cokV=<oo:V2Wo/8dNoh=N5?mkC1Co4BHDo`T9
5?lS70[o6Q8DonBnQ008ooooo`05ol77`OoLhmKom_ooooKoooooool00_of
ool00ooooooob]3FolZn[@02ooKoo`03oooooooCfMKok^k^05kok^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo00gooOgmono_kolA9XSoRJgF
oj?2h?nS`^7oR:kEofVGb_mcWm3oNJCDogjWeOn4[]WoR[?J00goSKKL00Co
ookoookmoooooooooooo0_oknOX06OoflOGoi=oUom3:e?nn^<Ko/jZooibB
[On<OZ7oPgBKogMWU?mmKIcoKF:=ofeRS?m/HHcoK66;ofaQS?m]HXcoKV>>
ofiSSOm[H8_oJf2:of]PRom[H8[oJf2;of]PR_m[H8/00_m[H8X0;OmYHH[o
Jf2:ofUQR_m[H8[oJF6:of]PR_mYHH[oJf2:ofUQR_m[H8[oJF6:of]PR_mY
HH[oJf2:ofUQR_m[H8[oJF6:of]PR_mYHH[oJf2:ofUQR_m[H8[oJF6:of]P
R_mYHH[oJf2:ofUQR_m[H8[oJF6:of]PR_mYHH[oJf2:ofUQR_m[H8[oJF6:
of]PR_mYHH[oJf2:ofUQR_m[H8[oJF6:of]PR_mYHH[oJf2:ofUQRP04of]P
RP0<of]PRom[H8[oJf2;of]PR_m[H8_oJf2:ofeRSOm/HH_oK66<ofaQRom/
HHcoKF:<0_m^Hhh03?mdIi?oK5n:ofeQROmmLIGoShBRoj2F[_ncZ[go`k_:
omK>fOoXhn[onoKlooomo`;oo_go00?oookoookmooooool00_nUc?<3ojK=
m0?oY/ke0onXd?L3oj[Bn@?oZ]?j2?n[e?/3oj_En`?o[=Gl0on]e_d2ojkG
oP?o[mOo2On_f?l2ok3Ho`?o/MWo0_ncfol01?nbfooo]=gookCMoondgOl3
okGNo`So]]ko0onggol3okOPo`03okSQoonihOoo^N7o00?o^^;o0_njhol9
ok_To`?o_>Go0_nmiOl2okoWo`04okkXooo0j_oo`>[ool3Zo`?o`N[o2?o2
jol3ol?/o`?oa>ko00?oaO3oolK`ooo6l?l00oo7l_l3olSdo`kobOGo00Co
c_koojkCkonhdnooMjk[0_nZgol01?mfMWKo`L71oo3`l?omoOeKooooo`0C
og]<5?mb>1CoPcP0og]<2_n3@@3oNd`:oh<h0?mkC1CoPcP0og]<2_n=E@[o
Pd40oiEE0?n=E@[oNd`:oh=10?nEE@3oPd40oiEE0003og]10005oh<_0?lS
9P[oJT4:oiEE0?n3@@000_mkC0X2oeLL0006ocdL2_l/4P3o?A`:oa4V2_lS
70[o;1800_lJ2@X00ol/4P3o6PT:oa4L2P02o`T92P03o`TB2_lA70[o4A`:
00;o6PT:00Co4A`:oaX92_lJ2@[o;2HD0olJ9Q@00olJ4QCo2A`Doa4L2P02
ob<L2P07ob<V2_lS70[o8bH:ob<L2_m6EBWo/:Z4ojJHK`02ok2ZQ003oiF=
I_nVZZ?o;18000?o8bH:0_lS70X01Ol92ACo4A`:o`T92_lJ2@[o4A`:00;o
8a`:00Oo6Q8DodHV5?mP;aCoH2lDoaXL7_l/9QCo8blN00;o000000Sog>?P
ok24Non3GS?o;2HDoaXB5?l/9QCoEa`0om>nSP;om^gZ00OokMW<onC7`OoC
_Xkodkj>ombcQ?oL/jgog;jg00;oong<00Kom_KeooKoooofm_Gom_ooooo]
c?nVV8@2ol6cSP0XombcXooL_[Ooi<O1olZn[Oo1/jgog>?FongfmOo:d=Ko
YZZSol[@`OoLhmKo`K>]ofYbG?oLhmKokNgZol77`On`/kOoUIQVojJHKomZ
Ic?om^gZojJQV?oTd<com_oeooKooooTd<coi;<cooo]c?offFKoon>>ong7
G?o]_Sgom]24ong7G?offFKokLMLong7Q?ofd8CokLMLong7Q0?om]2400?o
on>>onfn?Oofacd00_oT/bT02ooTZP3om/Lmonfn?OoCXBWokMW<ooK@Q?oo
hhkokM2HoooSS_oL/ecoon>>00;okLN400CokM2HooKII_o]ahCokLML0_oT
/c<02ooLZS?obZ4molZH:On`NaCo^H@Yok2=7_mb>1CoJT4:odH_2_lS70[o
2@TD00?o4A`:00[o6PT:ohf=Aon3Nc?oPg/codIE:OlA70[o4BHDoa4L2_lJ
2@[odiP:0_oT/c<02OoT/dOom/LmolZH:OniQ2Wo/7/:oiEE5?mb>1Co2A`D
oa4V5002oaXB5003olZQD_ofooGooooo00Kooooo00?o`K>]om?Ie_o]m_D0
0_ofool02Ooooooom_ooooooooo:d=Ko`K>]ooK]j_o]kN[ooooool[@eP1O
ooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0002onk^kP0=onc/k?oMgMgo
0228oiJhg?nV`n7oZlKSohfaf?m/V<[oMIo=ogfUe?n0Z=KoQ:cJoh^cg00=
oi6jh`?ooooo01cooOgooocjoooooOool^cfom;<f_o3^/goZZ2ioiZ<[On7
N9ooQgJRoiB2]?nLRL3oZi[@olZnl?o9`>oob/3bolc3l_o=`oGoc/Gdolk4
m_o>aOCoc<;dolc3l_o<`_Coc<?bolc2m?o<`o;oc<;d0_o<`o80;Oo;`o;o
c<?bol_3l_o<`o;obl?bolc3l_o;`o;oc<?bol_3l_o<`o;obl?bolc3l_o;
`o;oc<?bol_3l_o<`o;obl?bolc3l_o;`o;oc<?bol_3l_o<`o;obl?bolc3
l_o;`o;oc<?bol_3l_o<`o;obl?bolc3l_o;`o;oc<?bol_3l_o<`o;obl?b
olc3l_o;`o;oc<?bol_3l_o<`o;obl?bolc3l_o;`o;oc<?bol_3lP02olc3
lP;ocLCc01[ocL?eolg4loo=`oGocLCcolg3mOo=a??oc<;dolg4loo>a?Ko
c/Gdolk4m_o=a??oc<;dolg1loo0/^Go]JCHoj>Ca?n@P:goPG:KohAfVOnM
T:ko]Zc4ol:ic?oHd^3olN_googjo`;oooko0_onool00oooooooZ<keojS>
m@03ojS?mP?oZLof0_nZd?P01?nZdOOoZm;ioj_BnOn[d_T3ojcBn@So[=?j
0on]e?X3ojgEn`03ojoGo?n`eogo/=Om00;o/]Wn0onbf_l9ok?Ko`;o]=_o
0oneg?l2okKMo`04okGMoonfg_oo]]kookKNo`?o]moo2?nhgol3okSPo`?o
^N3o0onjhOl3ok_Ro`;o_>;o2Onlhol3okgTo`;o_^Ko0oo1jOl3olC/o`?o
aNko2?o6kol3olOao`?ob?;o00?ob_Gool_dooo;m?l00oo=mol3olkho`ko
co[o00Cod?oook7El?nidnooMjk[0_nYg?l01?m^KVko];Bdon3Ph?o/k>aK
onk^kP05og]<5?mkC0[oNd`:oheE2_nEE@000_mk@@002_mkC0[oSED:oheE
2_n3@@3oNd`DoheE2_nEE@3oSED:oh=10?nEE@02oh=10007oheE2_n3@@3o
LSP0of0_2_mG703oJT4:oheE2P02oh=10004og8h0?mP;`[oARl:odHV2P;o
?A`:00Go;180odH_2_lS70[o;180o`T92P03oaX92P?o4A`:0_lJ2@X2oa4L
2P0LoaX92_lA70[o8bH:oc@_:OlA9Qko8blNob<_:OlA9P[o2@T:odI17_m6
;`[o;2HDodHV2_lS9P[o6RHDob`L5?lA70[oSHe_ol6c[OoLhn3oYYQ_ojJZ
[On=SDOoARl:ob<_7_lA70[o8a`:o`TB2P;o4A`:00?o2@T:o`TB2_lA70X0
0_lJ2@X05OlS70[o4A`:odHV5?mP;aCoAT4Noh<_0?m69QCo?A8:of0_5?l/
4P3om_oooh=kG?m6;`[o=2lNo`TL5?mG703oUD`Yombn]oofm_GokMW<onC@
c003ol6QQ004ombcQ?oL/jgoi:ZHonC7`@;om_Ke00Som_ooooKfmOofoooo
ong<oiib<oo1/hkoYZ5Vom>nSP;ob[j]00?oYZZSomcSh?o:d<400_o:d<40
0ooTd<cob]31om?IeP02ojJQV00>om?Ie_o1alco/;>gol6c[Oo:d<7oYZZS
of1N<ooooooo`LO<ong]j_o]m_Gom_ooongIc?oTZP02ong@V009ooK@Q?o]
aecokLN4ong7G?ofd8CokLMLonfn?OoffFKokLN400;okLML00Wom]24ong7
Q?ofd8CokM2Hong7G?offFKoi:X0onBc:Oo:V1@00_niI`000on`N`[okM2H
oooSSP02ong@V00OoooSS_o]ahCokM2Hong7Q?offFKoon>>ong7Q?o]aeco
kKhmonBcAooLZS?obYPDom>Q:OniSC?o/8@YokV45?n`SAkoNd`DofY12_m6
;`[o4A`:oaX92_lA70[o2@TDoaXB5?l0003oSHe7oh=k<omZIc?oAT4NoaXV
5003oaXB500@olZH5?oT/akokLMLonBc<ooT/bWo^H@YokV45?n`NaCoPehD
og]<5?l92ACo4A`:oaXB5?lA9QCoWW8cooKom@Gooooo00Kom_ooooooooo1
al7og;jgong]j_ofooD3ooKoo`07ooooooo]kN[oYZZSooK]j_o]kN[ooooo
om?IeP1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002onKViP0=onCT
i?oDe=Co02J;oiZkg_n/an?o[LSSoi6df?m`WLcoNjGBognXe_n4[MWoQjoJ
ohbdg00=oi2hh00OoooooOomoO_oooooooonooooo?oon_OoonGNk_o3^m;o
]:W7oiN;[on<OJSoSGf^ojREc?o6/^goc[[iomS6ooo=`?Koc<Cgom36n_oB
b_goe<[nom?;o_oDb_kod/[momC:o_oCbokoe<[nom?;o_oDb_kodl_nomC:
oP02om?;oRkod/_n0ooCboh06ooDb_kodl_nomC:o_oCbokoe<[nom?;o_oB
b?codLWlom?9oOoAbOcod/Slolo7n_o?aOWoc/Ciom31n_oE`ogoeLCkolJe
jonZV<[oTX6^ohimYonDQZWo[j;0olBjd_oRfngom_?nookmo`02ookoo`04
ookooOooooooZ<gcojS=l`?oZ<kd0onYcoD2oj_Am`04oj_@mon]d_Wo[M;i
ojgBn@?o[]?j2?n^e?/3ojoEn`?o/=Gl00?o/MOmok;HoOnbf?d00_ncf_h3
okCJo`Wo]M_o0_nffol3okKLo`?o]mgo0onhg_l3okSOo`So^Moo0onjhOl3
ok_Ro`?o_NCo0onoi_l2ol3Wo`co`NWo0_o2j_l3olC/o`?oa^ko2oo7kol3
olSao`?obO;o0oo;m?l3olgfo`?oc_Oo3_o?nOl01?o?nooo/=G`okWCkomf
[NX2oj_Po`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00KoNd`:oh=10?n=E@[o
LSP0oheE2_n3@@02oheE2P03oh=10?n=E@[oUED000CoUED000CoPd40oiEE
0?n3@@3oNd`:0_n3@@004?n3>03oPd40odHV2_mZ@@[oUED0oh=10?mk@@3o
Nd`:og8h0?mG703oARl:ocdL2_m69P[o?A`:ob`B0?lS9PX5ob<L2P?o6PT:
00Go2@T:oa4L2_lJ2@[o8a`:ob`B0002ob<L2P0;odmWAom6;`[o8bH:ob<V
2_m6C3goUJ6>odH_2_mP;`[oARl:ocdL2_lS9PX00_l/9Q@02_lA9P[o`K>>
oiFQS_nEXHkob]31ol77`On3GQCoARl:oaXV5?lS9PX2ob<L2P0Uo`TB2_lA
70[o4A`:o`TB2_lJ2@[o8a`:oa4V2_lA70[o8a`:oaXV5?m69QCoJUDNoh=N
<onNGQCoUHABok1kI_n`Q6KoYYQ_ojIbD_mkC1Co;2HDocdB2_nEC2Wo`G]k
ongIc?o]kN[om^gZojJQV?nNLS?o`G]kol6QQ?o]fLcoi<O1ombc[OoL_[Oo
kMW<ooo]c002ooKfm@0;ooKoooo]d9SoYXABombcXonVQ5;o`K>>ojJHQ?oL
hmKo`K>]ol77`Oo1/jd00_o:d<401?n`/kOo`LO<ol[@`Oo:d<43ol77c00=
onC@c?nEZZgoUJZ]ojJ4Q?nVV8Cog>?Pong]j_ofooookOKeooooooo]d9So
bYPDong7Q002ooK@Q009ooKII_o]aecom]24ong7Q?o]aecoi;=7ong7G?of
d8CokLN400?okLML00[om]UVomc7Xoo]aecokLN4onBc:Oo]_SgokLMLonfn
?Oo]aecog:Xc0_o]d9P02?oohhkokM2HoooSS_o]aecoon>>ong@V?o]aeco
kM2H0_o]ah@01ooT/dOoi;<combZ<ooCXBWog:XcolZQ?On`N`X00_n`SAh0
1?mZEAkoNd`:oc@_7_lS9PX4oa4L2P0:o`TB2_mZEAkoSHe7ofYW<om6@Ako
4BH:oa4L2_l971Co6PT:okUb<`;oi;<Y00oobZ4mombZ<oo:V1CoWW8coiiN
5?mb>1CoH44Doa4V7_lA70[o4BHDo`T95?n=E@[oong<ooKomOooool00_of
ool3ooooo`03ol77`Oo1/jgokNgZ00Gom_oo00KokOKeojJQV?oLhn3okNgZ
ooKooooLhn1OonKViP04oifMWOng]kOob<S8om?Cd`7of][J0002onk^kP0=
onc/k?oLg=co02N=oi^lg_n/b>?o[/WSoi:ff_mcW/koNZC@ogjXe?n3[=So
R:oJohbcf`0=oi2hh00Poooon_oko?OoooomooonooojmoooiN7bol[2f_n_
Y/GoUXZbohem[?nIQ[go[9SColVclooLaOooe;goom2moooCb?oodlcoomO>
oooHdOoof]7oomWBoooHcoooe/ooomcCoooKe?oog=?oom_DoooLdooofmCo
omcCoooKe?l`omWEo`;ofM;o01oof]7oomWBoooJdOoofM;oom[AoooId_oo
fm;oomWBoooHcoooe/ooomK=oooEc_ooe/goomO<ooo=_O_ocK[jolnkn_o@
_?_obK?aok>NeonIQK[oQgFUoi^</on^Xl?ocLGMonSTloogm_konocnoogo
o?onoo_oooom00;oZ/of0onZd?L3oj_An0;o[=?j00Co[=;jojgDo?n]e?co
[MCl0on^eOd8ojkFoPKo[mOn00?o/=Snok7Hoonaf?l01OnbfOl9ok?Jo`;o
]=[o0onefol2okKLo`04okGMoonfg_oo]]kookKNo`?o]moo2?nhgol3okWP
o`?o^^7o00?o_>?ookcRoonlh_l00onni?l2okoUo`Wo`>Ko0oo1j?l2ol;Y
o`;oa>_o00Coa>coolK^ooo6k_ooa^ko0oo7kol;olSao`?obO;o00?ob_Co
ol[cooo:lol00oo;mOlAolcfo`04olkjoon`eO3o]M3^ogV^k0;oYmco00Co
KVi^okBd]?oPh>3ok>c/Foo^k^h01?mkC0[oUEDDoh=10?mkC0X2oheE2P;o
Pd4000OoSED:oiEE0?nNLP[oUED0oiiN5?n=E@[oWW8:00GoUED000coPd40
og]<2_n3@@3oH2l:ofYE7_nNLP[oUED0oh=10?mkC0[oNd40of0_2_mG7002
odH_2P;oARH:00Oo8bH:ob<L2_l/4P3o6Q8Dob`B0?lS70[o8bH:00;o8a`:
00?o2A8:oa4L2_lm70X00_lS70X00olm70[o8bH:ocAE:@02oeMEDP0DoiF4
S_nVZZgog>?Po`000?l971Co2@T:o`TB2_lA70[o2A8:o`T95?ld;akoYYR4
ohf=Kom6;`[o`LO<oiF4NonNSC?oARl:ob<V2_lS70X2oa4L2P03oaX92_lA
70[o6PT:00;o2@T:0_lJ2@X2ob<L2P0IoaXB5?lA70[o?A`:oh=N<on`SE;o
/8Akol6QQ?oL/j?o`J64ol6cS_n3GS?o;2HDoheE2_o1XHCog;>]ooK]j_o]
m_Goi=3<ok24NomZEAkoH44Yoh=kG?o:_Zgom^gZooKfm@02ongIc008ooK]
j_ofm_Gom_KeooKooooL/j?oWW8coiik<oniLS<2ol[@`@Co`LO1017oYZZ]
ol77`OoLhn3okNgZolZn[OoL/j?odkj>olZZI_oCXBWobZYVolZQD_o]aeco
m]24oeN=S_nEXHkoi=3<ong]jP02ooKoo`05ong7Q?oCV0[okLN4ong7Q?of
d8@00_o]ae`01_ofd8Com]UVong7G?o]aecog;=LooK@Q0CokLML01?okKhm
ooKII_o]ahCom]UVonBcAoofacgoi;<cooKII_o]ahCokKhmonBnQ?oohhko
kM2HoooSS_o]ahCoon>>ong@V?oohhkom]UV00;om]240_o]ae`03OoT/ako
bYPDolZH:Oo:V2WobZY7ok24:On`SAko/8dcog]10?mkC1CoARl:oaX92_lA
70X00_lJ2@X01olJ4QCo2@T:oh=N<on=SE;oPg/codI17_lS;ah00_lJ4Q@0
5Ol92ACoYT`0onBc:OoT/akobYPDom>Q:Oo:V1Co/7/DojIb5?mb>1CoNd40
oa4V5?lJ4QCo4BHDoa4V7_mb9P3om_oeong]j_ofooooooooooKoo`03oooo
o`04ol77`Oo1/jgog>?Fongfm@?om_oo00OoooooooKooonVXISog>?Fong]
j_oooooodmWF05ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo
00gooOgmonc/k?l0:hkoWKgNojc8i?n_b^GoTKGJog:OcomkYM;oOjSDoh>/
f?n7[MWoRk?J00goT;SP01Soooofoo[klooooogoookoooKboooIe>[o_KCC
ojFJ`_n<O:goT7nfojZFeOnkY^WobkClom>kooo<]?oock_oom;7oooAb_ko
e<goomG>oooFcoooeLkoomC=oooBbol7omSAo`03omKBoooEdooodmCo02go
dmCo00?oeM?oomC@oooFcol01_oFcol00ooId_oof=7oomK?o`04omC=o`0B
omG<oooOcooof/Koom:mooo:]O[oa:gcokNPi?nXT];oW8O0oi>1/OnSU;_o
_kCBomgIj_oblOWonogloo_on_oloo[oo_om0_nZd?H3oj[@m`?oZm7h0_n/
d_T01?n]do[o[]CkojkDnon^e?/3ojoEo003ojoEoOnQaN[oY<O]00Go[mGm
0on`e_d3ok7Fo@;o/]Sn00?oY<O[ok7HoOncf_l00_n/d?@00ondf_oo]M_o
okGKo`07okGKo`;o]]co0onfgOl2okSNo`04ojgBl_n_do;o^MoookWOo`?o
^N3o00?o[=3/okSOoOnjhOl00_naeo@3ok[Qo`?o^n7o0onlh_l00onmi?oo
_N?ookgSo`03okkUo`;o_nKo2Oo0i_l5ol3Wo`?o`NSo1_o2jOl8ol;Zo`?o
`nco0oo5k_l3olSao`?oboCo0oo=m_l>olkho`04olonoon_e_3o^=;^ogJ]
jP;o[=oo00CoMWIfol71`Oo`l?3ooOgmFoooool2oheE2P05oh=10?mb>1Co
UED0oheE2_nNGQ@00_nEE@001?n=E@[oUED0oiEE0?nNGQ@3oiEE0004oiEE
5?nEE@3oSED:oiEE00?oPd4000OoH2l:og]<2_nVI`3oWW8:oiEE5?n3@@3o
LSP000?oH2l:00CoEa`0odH_2_m6;`[o?A`:0_lS9PX2ob<L2P0?ob`B0?m6
9QCo?A`:ob`B0?lS70[oEa`0ocdL2_m69P[o?A`:odHV2_lJ4QCoAT`mof1N
<omkSFKo/;k100;odmWF00?oARl:ofYE7_l/4P000_ld;ah04?l92ACo4A`:
ob<_7_n3Nc?oJW9Lok2ZQ?nEQ7_o/:Z4of115?m69QCo8bH:oaX92_m6;`[o
2A8:oa4L2_lJ2@X4oa4L2P0Mob<L2_lJ2@[o8a`:ob`L5?lJ9QCo;2HDoaXV
5?m6@AkoPehcohf=AonEQ5;oYYQ_oh=N<omkC1CoUD`Yok24NooL_[Ooi=3<
ongIc?ofoooog;jgokV=<on3GS?o2@TDob<_<ooLhn3odmWFomcSh?o]kNX0
0_ofkNX2ooKfm@0<ooooooo1XHCo^IQLolZZAoo1/hko/;>gonC@c?o1/jgo
YZZSok2n`OoLhn3o`LO<0_o:d=H2ongfm@0@ooKooooooooom_ooomcSe_o]
d9Soi:X0onBc<oood3go2@T:oiF4D_oLhn3om^gZooKoooo]kN[og;=LonBc
:@?okLN400[okKhmong7Q?o]aecokM2Honfn?Oo]aecoi;=7ong@V?o]ahCo
i;<c0_o]ae`02?oT/c?okLMLong7G?o]ahCokKhmonBc<oofacgokLN40_o]
_Sd01?o:ZVKoon>>ong@V?o]d9P2ooK@Q00Long7Q?o]d9Som]24ong7Q?of
d8Com]UVonfn?OoLZS?odj4YolZH5?oCXBWo^HdcokV=5?n`NaCoWXdcoij=
:OmP@ACoARHDob<V2_lJ2@[o;3PYo`T95?lA70[o2@T:ofYW<on=SDOoJVLc
odIE:@?o4A`:00Wo4BHDoh<_0?oT/c?obYPDonBc7_oCQ03odj4Yok1b0?nN
GQ@00_mkC1@01OlJ4QCo4BHDoa4L2_l/71Co?A8:00;oong<00?oooooooKo
ooofool00oooool01_o:d<7oYZZSomcSh?o]m_Gom_ooooooo`;om_oo00Ko
oooooiFHXoo]fLcom^gZooKooooLhn1Oooooo`04ojn_[oo;bl_og]kNon[Z
jP7ol_;b0002onk^kP0=onc/k?oLg=co02fAoifmg_n/b>Co[lWToi6dfom`
WLgoNZCBogjXdon3ZmSoR:oJohbcf`0=oi2fgP0Doooom?okoO;ooookookm
ooo_jo[oem7[okV_e?nISK_oTX6hoiJ3`on]V=go^:;[ol6YmOo<]?ood;Go
om_5ooo?a_oocLWkolo;oOo@c?h2om7=o`;od<cn1ooBc_l00ooAcooocm3o
olkAoP0]olkAoP03olo@o_o@c_oodLgo00SodLgo01Cod/koom7=oooAcOoo
d<cnolo;oOoAb?ooa;CeoljjoooE_ooodkgoolN_nOnfW^SoYi3Foij8b?nC
P;OoW8biokBYbooDcn?oknkfoo_mo0;oo?oh00?oo_omoj[=m?nZcO@00on[
coD02OlT;3CoKhJOojc@m_nQa>OoKHBLoio0iOn`eOgoPinmo`410@02ok7F
oP06oiRgf_lT;3Go2@/>o`P:3?lW<3WoVK[L0_nbf?l03_l/=T3oF6]ook;H
oonbf?ooLXZSoa<G7?ncf?oo/mWoocU5DOl51PSo4QHJofj5W?l=41?o?DYG
1Onefol00olV;SKo0000o`000002o`00000;obTb>_nfg?oo;CM0oe]^Oong
gOoo^MoooaXP9Ol;3A3o5a`PocQ3COncfOH00_nkh_l01_lkAe7o1@L8oa<G
6_mcRYco3Q0Cod1=E`?o_>?o0onmhol3okgTo`03okkUoonoiOoo_nGo00?o
`>Ko0_o0iol9ol7Wo`?o`NWo0_o2j_l2olC/o`04ol?[ooo5kOooaNgoolG]
o`?oa^ko2?o6l?l3olOao`?ob?;o00?ob_Gool_eooo;mOl00oo=n?l3olki
o`koco[o00Codooook7Gl?nfd>koNJo^0_n[g_l01?m^KVko];Bdon3Ph?o/
k>aKonk^kP07oheE2_nVI`3oNd`Dog8h5?nNLP[oPd40oheE2P02oiEE0007
oheE2_nNLP[oSED:oheE2_nVLP3oUED0oheE2P07oiEE000CofY12_mkC0[o
/7/Dok1k2_nNLP[oUED0og]<2_n3@@3oLSP0ofY12_mP;`[oARH:oeLL0?m6
9QCoARl:ob`B0?lS9P[o?A`:ob<V2P02ocdL2P0;odHV2_lS70[oARH:of0_
2_m69P[oH2l:odHV2_l/9QCoEfMBofYbG?mZNh@00_o:d<404OmbIe;oJVLc
ol6c[On`ZXCoUIQVojJHKomZ@@[o0000oh=k<onVZZ?o`K>>ol6c[On`ZXCo
YZ6HofYE7_m6;`[o8bH:00;o8a`:00So4A`:oaX92_lA70[o2@T:oa4L2_l9
4P[o2@T:oa4L2P?o8a`:01?o;2HDodHV5?lm70[o8bH:odHV5?mP;aCoLSPD
oiEN<onNLS?oYYQ_ol6cS_oL/j?og;jgonC@c?oTal7om^gZongIc?o1XHCo
/7/Y00;oLSPD00OoY/OPombn]oo1Ng_oi<O1ongIc?ofkN[om_Ke00;om_oo
02?o/7/Yoij4I_n`Q6Ko^IQLoiiN5?niSACoWW8Dog]10?nEC2WoPehDof11
5?n3GS?oH44DofYW<omb>1CoUHABojJHQ?o1alcokOKeooooooofkN[odiP:
ooK7?OlS9P[oYYR4ong]j_ofm_Gom_ooooK]j_oL/ecoi;<cong7Q?o]aeco
m]UVonBcA`02onfn?@04ooK@Q?o]aecokKhmonBcA`;okLML0ooT/dL01_o]
_Sgoi;=7ooK@Q?o]aecom]24onfn?@;okLML00OokKhmong7G?oCZTOokM2H
oooSS_o]ahCom]2400;okLN400Ooon>>ong7Q?offFKokLN4ong7G?oL/eco
i;=700;obYPD023obYPYolZQ?On`Q2Wo/7/:ok2=<on3GQCoNd`:odH_2_lA
9P[o4A`:oaX92_lA9QCo6PT:o`T92_mZEAko^IQLofYW<om6@Ako6Q`Noa4V
5?lJ4QCo4A`:og8h5?oT/bWoi;<Nom>H2_niSC?odh@0ok1k5?nVI`3oH44D
ofY12P;o4A`:00Go6Q8Doa4L2_lJ2@[oong<ongIc005ooKoo`05ooooooo:
d=KoUJ6>ong]j_o]m_D00oofool2ooooo`05ojJQV?oLhmKog>?PooKomOoL
hmH0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H03OoTi>Co
e=CDo`0]T_nN_Moo[<OSok7:iOnA]M[oLYo>og^We?moZ=CoPj_HohR_f_n;
/mX03On@]]h0;_onoogoo_okoooonoodm?;ohn3Yom79hOn^XLgoQG>aoiAn
aonDNlcoYhkOokJKj_o4ZOKockCool^`ooo@^_ooc<3nol_3o?o=a?goc/Ko
om37ooo?b?kodLSoom39ooo@aokoclSnom37o_o?b?kod<Onolo8o_o@aoko
clSnolc9o_o:b_cob/[nol[:o?o:b_kob/[lol[:o_o:b_cob/[nol[:o?o:
b_kob/[lol[:o_o:b_`Col[:oP0?ol[:o?o:b_kob/[lol[:o_o:b_cob/[n
ol[:o?o:b_kob/[lol[:o_o:b_cob/[nol[:o?o:b_koc<Wn00;oc/Om01oo
clKmolk7oOo?a_goc/Omolo6oOo>aogobl;kolc4oOo?a_ood<Soom37ooo=
aOkobl;kolZonooHa?oodkgoolbdooo7[ogoa:WjokZOk_nYS]_oUh36oi5k
^OnFQ;KoZYk4olc4g?oZio;on?SjoocnnOomooWoooom00;oYlgd0onXc_D0
3OlS:c?oKHFNojW?mOmOM8Wo0000oeQ/POn/d_[oP9fko`410On]do[o[=;i
ob<[<_lgA5000_nRaNX01_ljAU?o92`dojgCn_n^e?_o:cDnoeMZO@;o[mGk
00WoL8RQoa<G6on`eOcoRJK4o`830onJ^m_oXLCUocm=F_l<3Q400_ndf_l4
okGKo`03obH^=_mBHgCo]M_o00Co]M_o013o;CM0oeY]Ooneg?oo]]coohVU
`?nbeo_o]M[nobH^=_mXOI;o]]coohfZa_l20`CoWKkMojC6i_m0CU_o30hA
1?nfg?l3okSMo`?o^Mko0onkhOl3okgTo`;o_^Go2Oo0i_l3ol3Xo`;o`NWo
0oo3jol3olG]o`?oa^ko2?o6l?l3olOao`?ob?;o00?ob_Gool_eooo;mOl0
0oo=n?l3olkio`koco[o00CodoooojoCkonhd^ooNJk/0_n/gol01?mZJV[o
[Zj^omSHf?oTi>AKonKViP;oSED:00CoUEDDoheE2_nEE@3oYT`00_nEE@00
0onVC03oUED0oiEE0002ojIW0003oiib2_nEE@3oUED000;oUED000GoWUhD
oiEE0?nEE@3oPd40oiEE0002ofY12P0:ol640?n`N`[oYW80oiib2_n3@@3o
Nd`:og]10?mkC0[oLRH0ofY12P;oEa`00_lm70X2ob<V2P06ocdB2_m6;`[o
?A`:odH_2_lm70[oH2l:0_mZ@@X2of0_2P0@ob<V2_m6EBWoPhAkoiFQS_o:
d=Kodn?eongfmOmZNfoodn?eol[@e_n`/kOo`LO<ol77`OnESFKo/;>gol77
`@;oYZZS0_nVXIP00onVV6ooPg/coa4L2P02oa4L2P0:ob`B0?l92@[o4A`:
oaX92_lA70[o2@T:oa4L2_lJ2@[o4A`:ob`L50;o8a`:00Ko;2HDof0_5?mZ
EAkoUD`YojIbD_nVQ582ol6QQ0;og;>S013ob[j]ombn]ooL_[Ooi<O1omcS
e_o]kN[og;>]onBZV?o1XHCog;>4onC7`OofkN[om_KeomcSe_ofkN[om_Ke
0_ofool01?ofooGoWW8coiEbAon`NbT3ok1k500`oiEE0?nVC03oPcP0oiEE
5?n3;`3oSED:og]<2_mb>1CoNd`:oiib2_n`N`[o^FL0ok2=D_n`/kOom_oo
ongIc?oofBWoARl:ok2ZQ?o]kN[okOKeooooooo]kN[okLMLombZ<oo]aeco
m]24ong7Q?oT/c?okLN4onfn?Oo]d9SokKhmonBcAooL/ecoi;=7ong7G?oT
/bWokLMLonBcAooTZP3oY/OPol6QQ?o]aecoi;=7ooK7?OoT/dOokLML0_o]
_Sd02Oo:XCgoon>>ong7Q?ofd8CokLN4ong@V?offFKokM2HooK@Q002ong7
Q0;okLML00coi;<com>Q:Oo:V2Wo^Hdcok2=<on`SAkoWW8:okV=5?n3Nc?o
JT4:of0_5?lS70X2oa4L2P0?o`T92_lA70[o0000ofYW<onNSBWoJVLcodI1
7_lS9P[o6RHDoa4V5?lA70[oEa`0olZH5?oT/akodh@000;obYPD00co^H@D
ok1k5?mb>1CoJT4:oaXV5?lJ4QCo4BHDoaXB5?l92@[oonf>ombn[Oooool4
ooKoo`05oooooooCfMKoUJZ]onC@c?o]m_D01?ofool01_ooooooYZ6Hom?I
e_oLhn3om_ooom?IeUooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;o
k^k^00gok>c/omcLg?l0;I7oW[gNojc8i?ncc>GoT[GJog6NcomlZ=CoOZSD
oh>[f?n8/M[oSKGL00goTKSO023onOcooo_mooonooSom_SZonSUh?o8_Lko
YY79ogiQ]OnAK]KoW7SRoj^9ionhVNWo_j7WolBYk?o:/?WocKGooljiooo:
^_oobk[oolblooo@_oood<7oolnnooo<_Oooc[koolfnooo>__oocKkooljm
ooo=__oockkooljoo`Sobkoo0_o<`?lLol^oo`[oc<3o0_o=__l07oo>_Ooo
cKkooljmooo=__ooc[goolfnooo>_OoocKkooljmooo=__ooc[goolfnooo>
_Oood;coom2hoooA]Oooc:ooolBWnonmWoGo]IO]ojR;gonLPLkoS7>eogYU
WOnTTkoobkkLonONlOojm?kooo[nooomo_ooool00_nZd?H3oj[@m`0=ob@/
=?m^QiooZm7gob4Y<?l_>TGo6R0VojgCn_n1W[_o0@41ojkDn_nC/m?o0000
ogbH]002ojkDn`06ogbH]?l0003oU[KHojkDnol[=CkoEfYm0_n_eO/02Om`
R:7o4aLKok3Fo?nF]mOo0P82oh>P^oncf_koKhNNoaHK8002okCKo`Co]Mco
00?o9Rhfoe9TM?neg?l00_neg?l2okKMo`03obdg@?mJKWoo]]go00;o^=ko
00_o]mkoohj/aOl?4aKoJX2CokWOoonM_MWo0P83ohVV_Onjh?ooLh^OoaLL
8004ok[Po`?o^n3o0onlhOl3okgSo`?o_^Go0_noi_l9ol3Vo`?o`>Oo0_o1
j?l3ol?Zo`?oaNco0oo6kOl8olK^o`?oao3o0oo8lOl00oo:m?ooboCool_d
o`03olggo`?oc_So3_o?n_l01?o?nooo/MG`okKBk_mi[^T2oj[Po`04ofi^
K_nd];Coh>3Ponc/k5_ok^k^00CoWUhDoheE2_n=E@[oUED00_n=E@X4oiEE
0005oiiN5?n=E@[oUEDDojIW0?nNGQ@00_nVI`04oiEE000?oheE2_nEE@3o
Nd40ofY12_n`SAko/780ok1k2_nVLP3oUED0oh=10?mkC0[oPd40og]<2_mZ
@@[oEa`000;oH2l:00GoARl:ocdL2_lS9P[o?A`:odH_2P02oeLL000QodHV
2_mb>03oLSPDoh=10?n3>03oNd`:oc@_7_mbIe;oPhf4oiFQS_o1alcog>?P
ongfmOnEZZgog>?PojJZXonVXISoUHAkohf=D_nVV6ooUHeBodH_2_ld;ako
g>?Pol77`On`_/7o`LO1oiFHI_lA70[o4BH:oa4L2_lJ2@[o8a`:00;o4A`:
00Go6PT:oa4L2_l94P[o4A`:ob`L5002ob<L2P0Cob<V2_l/9QCoARHDof11
:On3GS?oWW/cojJ4Q?oTZYSo`K>]olZn[OoL/jgog;jgonC7`OoL_[Ooi<O1
ombn]ooC_Xkog;>Sombn]`03ongIc004ooK]j_o]fLcokNgZooK]jP?om_oo
00cokNgZoh=k<onNNc?o^HdYok1k2_n`NaCoYVL0oiiN5?nNLP[oPcP0oheE
2_nNGQ@2og]<2P0GofY12_mb>1CoSED:oiib2_n`SAko^HdYol640?nVV8Co
ooooolZn[Om6;`[oYZ6HongIc?ofm_Gom_ooongIc?oL/ecoi:X0ong7G?o]
ahCokLMLonBc<ooT/dL00_o]ae`07Oo]_Sgoi;=7onBc7_offFKog;=LonBc
7_oL/ecokLMLonBc<onVan3obZYVonBcAooT/bWokLMLonfn?OoT/bWokLN4
ooK7?OniQ1Coong<ooKII_o]d9Som]UVong@V?o]ahCoonf>ong7Q?offFKo
kLN400;okLML01gog:XconBc7_oCV0[obYPDolZQ?On`Q2Wo/7/:ok2=<omk
@@3oNd`:odI17_l/71Co4A`:o`TB2_lJ4QCo2A8:o`T92_n3GS?oUIQVoh=k
<om6@Ako6RHDoaXB5?l92@[o6PT:odHV5?oCQ03oi;<conBc7P02om>40004
okV45?nNLP[oPehDof0_2P?o4A`:00Ko4BHDo`000?oohhkog;>SooKoooo]
m_D3ooKoo`04ooooooo]kN[oYZ6Hol[@eP;okOKe0_ofool2ooooo`05ok2c
]ooTd<cog>?PooKomOoCfMH0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Q
h@000_ooool03OomoOgok>c/o`0]TOnO_mooZlOTojo9i?n@]=WoLIk>ogZV
domnZ=CoPj_HohR_f_n<]=h03OnA^>005OoioOoonoooookon?ohnn[oiN3J
olRkconDNKcoOUbmoi=Zh_nMM>[oZhKVokFBh_njVmoo_Z7Sol:VlOo5Z_Wo
b;7oolN`ooo7/?kobK?nolbfo`02oljho`03olfgooo<]ococ;Ol00;oc;Ol
0oo=]ol00oo<^?oocKWoolfio`06olfio`Coc;So1?o;]oh@ol^go`CobkOn
1?o<^?l8oljjo`Soc[So0_oA^ol2om2jo`0Eolniooo>^?oocKOooljfooo;
[_koc:coolNWn_o0X?Go^IS_ok:Aj?nVQMcoVg_>oiAh`omkHZ?oRgN/olBd
fooXfoGooo[oooomooonn_Woooko00;oZlof0on/dOL03OlT;3CoKhNPoi6a
dOl0003oTK3?oa`R:On:YlKoPinmo`410Onae_koPinmo`000?nP`^H00_nb
f?l01_nO`NCo0000ohJS`Onbf?oo;3I0oeQ[O`;o/]So00WoLHZSoa<G7?nb
f?oo/]WoogVC[OlS:S;o8b/cobD^=_lF6b001_ncf_l00olU;SKoDF=dok?J
o`02ok?Jo`;o]=_o00Wo;CM0oeY]Ooneg?oo]mgooj?5i?ld@4[o0P83oe5R
LOnae_H00_nigol01OmmUjgo92/bobD/<olW;cKo5a`P00Oo^^3o0onkhOl0
0onlh_oo_N?ookgSo`03okkTo`_o_nGo0oo1iol2ol;Xo`;oa>_o00Co`n_o
olG^ooo5k_ooaNko0oo6kol;olSao`?obO;o00?ob_Cool_cooo;lol00oo<
mOlAolgfo`04om3ooon`eO3o^M?^ogV^j`;oZmoo00CoMWIfol71`Oo`l?3o
oOgmFoooool01?n=E@[oUEDDoheE2_n=E@X2oiEE000?oheE2_nEE@3oUEDD
oheE2_nEE@3oYVL0oiib2_nVI`3oWW8:oheE2_nEE@3oYVL0oiEE0?nVI`3o
WUhD00;oUED000CoNd`:ofY12_o1Q03oYW8D0_nVLP004on=E@[oUED0og]1
0?mkC0[oPd40og]10?mP;`[oLSP0odHV2_mG703o?A`:odH_2_lS9P[oEa`0
ofY12_m6;`[oH2l:og]<2_mk@@000on=E@X06?m6@AkoJW]_ohfHS_nVZZgo
b]3Fom?SmOofooooWW8DojIb5?nVLP3o^FL0ojI<0?mP;`[oLSPDohf=Kon`
Q7_oJW]_ongfmOo1alco/;>goiF=I_mkC1Co2A8:oa4L2P;o6PT:0_lA70X0
1_lJ2@[o4A`:oa4L2_l92@[o6PT:ob`B00;o8a`:00So;2HDodHV5?m69QCo
H2lDofYE7_nVLU;o/8eBombc[@;og;>S00Wo`K>]ombn]ooL_[Oog;jgonC7
`OoL_[Oog;>Sok2=D_nVV8@00_o]fL`05_ofm_Gom^gZooKfmOofm_Gom^gZ
ooKfmOofoooom^gZol6c[OnVQ5;o/7/YokV4:OniI`3o^H@DokUW0?n`NaCo
YT`0oiiN5?nEEACoWW8:og]<2_mb>1@2ofY12P04ofYE7_nEEACoWW8Dok1k
50;o`H@0017oY/OPong]j_lA70[o/:Z4ooKfmOo]m_Gom_ooombcQ?o]aeco
g:XcombcG?o]d9SokKhmombcG?oT/dOoi;<YooKIIP02onBcA`03onBc<oo:
XCgog;=L00;oi;=703KokKhmonBcAooCZTOog;=LonBcAoo:XCgoi;<NonBc
Aoofacgoi;=7ooK7?On`SAkoon>>ong@V?ofd8CokM2Hooo]c?o]d9Soon>>
ong7Q?offFKokM2Honfn?Oo]aecoi;<combZ<oo:V1CobYPYokV=:On`Q2Wo
YW8Dok2=7_n3GQCoNd`DodH_2_lS9P[o2@TDob`B0?l94P[o4A`:o`T92_m6
@AkoUHABoh=k<om6EBWo;2HDob<V2_lJ4QCo4A`:ob`L5?n`N`[om/LNolZH
5?oLZS<3ok1k2P0:og]<5?m69QCo;2HDoaXB5?lA70[o6Q8Do`T92_o]d9So
g;>4ooKoo`;okOKe0_ofool01_ooooookOKeojJZXooTd<cokNgZongfm@?o
m_oo00Kooooook2c]oo:d<7og>?FooKfmOoLhn1Oooooo`04ojn_[oo;bl_o
g]kNon[ZjP7ol_;b0002onk^kP0=onc/k?oLg=co02bAoiflg_n/b>Co[lWT
oi6dfOmbX=3oNJG@ogjXe?n3ZmKoQZkJohbdf`0=oi6ih@0Hoo_noookoooo
o_ofoo[jl?oSf]ooc;_MogMKY_mnFl?oSVGKoiQ`h_nVPMko[hgIok>Df?nf
V=ko^Ic^okbPmOo1Y_Go_ZKboknWlOo1Z_;oa:geolN`m_o8/OGob;;c1?o6
/?42olJ_l`;oaZoe00?ob;7eolNbmOo7/_D01Oo7/_D8olF`la3oaK3e2?o5
/?<8olJam0Coak7b1?o7/?@2olRam`0GolN`m_o5[_Coa:geol>/m?o2Zo?o
`jWcol6Tm_o1Y?So_YkcokRHjoncTNGo[X[Qoj=oeonHM<coT6k4ogaMZomc
FYcoak?VonKImooonOooooojoo[jl?oooo/01On[d?T03OlT;3CoKhNQoe=U
NOlP9boo[M;joea`Q_m7EVOoPIjlo`410On^e?_oU[KHo`000?mjUK400_n^
e?/01_miTjoo0000oiRjg?n^e?_o:cDnocm=F`;o[mGk00?oK8>Koa@H7?n`
eO`00onaeod00on`eocoIgfCoaLL8@02ok?Io`Co]=[o00?o9Rhfoe5SM?nd
f_l00_ndf_l2okGKo`07obdg@?mJKGoo]McookKMool^>47o;cU2oijnf`02
okSNo`?o^=oo00Co^N3ookONoOm[PYCo5a`Q1onih?l3ok[Qo`03okcRoonl
hooo_>?o00?o_^Co2onoiOl3ol3Vo`;o`>Oo0_o1j_l01?o1jOoo`^cool;/
ooo2k?l3ol;]o`So`nko0oo4l?l3olKao`03olWcooo8looob??o00?oboGo
0oo=m_l>olkho`04olomoon^e>oo^=?_ogN^j`;oZ]oo00CoKVi^okBd]?oP
h>3ok>c/Foo^k^h02?n=E@[oWUhDoheE2_n3@@3oSED:oiEE0?n=E@[oUEDD
0onEE@001?nNGQCoWW8:oiib2_nNGQ@2oiib2P03oiiN5?nEE@3oUED000;o
UED000_oYVL0oh=10?mZ@@[o/7/Dok1k2_n`LP3o/8dNoiib2_nEE@3oSED:
oiEE0002oh=1000/og]<2_mb9P3oARH:of0_2_m69P[o?A`:ob<V2_lm70[o
H2l:odHV2_mG703oNd`:oheE2_nEE@3oUEDDojI<0?m6@AkoNheVoiFHXon`
/kOog>?PooKoooo]kN[oYW80okV=5?niI`3oPd40ofYbG?o:d<7og>?Pol[@
e_n=SFooWW8Doh=N<on3@@3o/8dNojIW0?mk@@3o4A`:o`TB2_l92@[o4A`:
o`T92_lA70X2o`T92P?o4A`:00Go8a`:oaX92_lS9P[o?A`:oc@_:@02of11
:@07oiE<:OnNLS?o/7]VojJ4Q?o1XHCog;>SolZn[@04ombn]`0AonC7`Oo]
fLcog;>Sok24I_n`Q7_ob[j]ongIc?o]m_Gog>?PongIc?o]kN[om_KeooKo
ooo]fLcoSHeBoiF4D_nNLS<00_o:V1@01?niQ2Wo`H@0ojIW0?n`N`X2ojIW
000=oiiN5?n3@@3oNd`:odHV5?mP;aCoNd`Doh=N5?nEEACoYW8Dok2=7_oC
V0[oJW9Lok2c]`02olZn[@03ongfmOofm_Gom_oo00;og;=L00ooi;<cong7
Q?o]aecokLMLonBc<ooT/dOoi;<cong7Q?o]aecoi;=7olZH5?oT/c?oi:X0
om>40?oL/e`00ooT/dL01_oT/akoi;<conBc7_ofacgoi;=7onBc:@;okLML
00?o^H@Dong@V?oohhh00_o]ah@00oookHkokLN4oooSSP02ong7Q00@ooK@
Q?o]ahCokLMLonfn?OoLZS?odj4YolZH:OniSBWo/8@YojIb5?nNSC?oPehD
og]<2_m6;`[o8bH:oaX92P;o2A8:0_l92A@01?m69QCoYZ5Voh=k<omPGS<2
oaXV5005oa4L2_lJ4QCo6Q8Dok1E0?oT/ah00_o:V1@01ooCQ03o/7/:ok1k
5?n3GQCoH2lDoa4V2_l/71@00_lJ4Q@01?l0003og;=LolZZI_o]kNX2ongf
m@?om_oo00GokOKeok2c]oo:d<7og>?Pongfm@03ooKoo`06oooooon`_/7o
`LO1omcSe_ofoooodmWFGoo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00
0_oVi^H03OoTi>Coe=CDo`0/T?nN_Moo[<STojo9i?nB]M_oLj3?ogNTcomn
Z=CoPZ_HohR_f_n<]=/03OnA^=l04Ooko_ooo?oooooom_onnoKohmSXom6n
k?mP@iOoOUS5ohMNe?nBJmSoWg_CojV7dOn_S]?o/Y;MokNFlOniV_Oo^ik`
00;o^ioZ00Go_:3ZokjSj_o1Y^_o`ZOZol>Xj`03ol:WjP05ol6VjOo1Y^_o
`JK[ol6VkOo1Y^/03Oo0Yn/3ol6Xk0oo`:K]00Co`:O[ol6Xk?o1Z>co`JS/
1Oo0Yn/8oknVjPCo`:GX1?o0YNX2oknTj`0GokjSj_nmX^Wo_:3Zok^OjOnj
W^So^Yk[okVKlOniVo?o]iO/ok:Ah_n_S=koZhGJoj9ieOnFK/koPe^logYG
/omVBIWodkgkonGGn_oilogoooodoo[nkOooooX00_nZcoD3oj_@mP09ob@/
=?m^QYko5AXNoeicR?n]do[oVk_No`d@4omnV;Go0@4100;o/=Gm00Ko;3I0
oc4lAonJ^]goVKWLoc4kA_l_>D<2ok7FoP0=ob`e?ol=41?oDF=eoiZkgOll
BEKo=D1<ok;Go_nceokoOIRdoiRhf_n`eOcoA59Qoc]7E002okCHo`Co]=Wo
00?o9Rdfoe5RM?ndfOl00_ndfOl2okGJo`09obdg@?mJKGoo]]cookSOoolW
<3OoK8:Fok_QoonZc>So]mcj00;o_>?o00GoQ:2doj72f_njhOcoAeIQoci;
E004okgTo`Ko_^Co00?o_nGookoVoonoi_l01Oo0iol9ol7Wo`?o`NWo0_o2
j_l2olC/o`04ol?[ooo5kOooaNgoolG]o`?oa^ko2?o6l?l3olOao`?ob?;o
0oo:m?l3olcfo`?ocOOo3_o>n?l01?oBoooo/MK`okWCkomg[^/2ojWLo`04
ofYZJ_n^[Zkof=SHonCTi5_oi^KV0_nNGQ@01on=E@[oPcP0oheE2_nVC03o
SED:oiEE0?nNGQ@00_n=E@X02OnVLP3oYW8Dok1b0?n=E@[o/7/:ojI<0?nV
LP3oWUhDojIW0004oiEE0007ofY12_niSACo`H@0ok1k2_nVLP3oWW8DoiEE
0002oh=10009og]<2_n=E@[oLSP0og]<2_mP;`[oJT4:of0_2_m6;`[o?A`:
00;oARl:00CoARH:odH_2_mZ@@[oUEDD0_n=E@X06?nVI`3oAT4NohfHS_nV
XISo/;k1omcSh?ofooookOKeojIb0?o1Q03oLUEBojJZXoo]m_GoYZ6Hok2=
<on`LP3oUED0og8V0?nEE@3o/7/:okV=<on`SAkoNd`:o`TB2P;o4A`:00Oo
2@T:oa4L2_lJ2@[o4A`:oaXB5?lA70[o;18000Co8a`:00So8bH:odHV5?m6
9QCoH44Dof11:OnEGS?oUG97ok1kIP;o`J6400Cog;>Sombn]ooL/jgog;jg
0_oTal407OoTd<cokMW<ooo]c?o1XHCo/8Akol6QQ?oC_Xkog;jgonC7`Oof
kN[om_Keoooooon`ZXCoJT4:og9WD_n`NbWobYPDok2=7_o1Q03o/7/Dok1b
0?n`E@3oSED:oiiN5?n`E@3oWUhDog]<2_mP@ACoH2lD00;oH44D01coPehD
oiiN5?o1Q03oPehDog^=I_o1/jgo`LO1om?Ie_ofkN[om_oooooooooLZS?o
kLMLonBcAoo]aecom]24onBcAooT/bWoi;=7onBc:OoT/dOokLMLonBcAooL
ZS?obZ4mombcG?o:V1Coi;<N0_o]_Sd05?oT/bWoi;<conBc<ooT/akokLML
onBcAooT/bWoi;=7onfn?Oo1Q03oong<oooSS_o]ahCoon>>ong@V?offFKo
kLN4ooK@Q?o]aecom]240_o]ah@03_o]aeco`H@0ok24:Oo:ZTOobYPYok24
:OniSACoWW8Doh=N5?mkC0[oARHDob<V2_lA70[o6Q8D0_lA70X06ol92@[o
8a`:oiFHI_n=SDOoJUDNoa4V2_lJ4QCo4BHDoaX92_l/71CoYT`0ooK77_oT
ZP3obYPDokV=<oniI`3oSED:oiib2_mP;`[o;1`DoaXV5?lJ4QCo4BHDo`00
0?o:XE;obZYVonC@c003ongfm@?om_oo00GoY[?1ol[@`Oo]m_GokNgZongf
m@02ooKoo`06ooooooo1alco`K>]omcSe_o]kN[og>?PGooVi^H01?nMWIgo
]kNgolS8b?oCdm<1om[JfP000_o^k^h03Oo/k>cog=cLo`0/TOnN_Mko[<ST
ojo9i?nB]M[oLYo?ogZVd_n0Z]GoPZ[FohR^fOn;/]/03On@^=l06?omoo[o
o_ojoooomoooo?koj=[domW2n_mF=9;oMDo0oh5Hc_n>I=3oW7K=ojB2c?nY
R<oo[8_Jok:>l?nfToWo]iK]okRIjOniV^[o^I[XokZKionkWNOo_9kVokfO
i`;o_IoU00?o_IoWokbNi_nlW^P00onkWNL00onlW^So_9kVokbNiP05okbN
iP?o^igU0_nlW^H3okfOia3o_9kX00?o_IoYokfOionmWnL00_nlW^HAok^M
i@;o^igW0_nlW^P01_nlWNWo^icXok^Lj?nkW>So^Y_YokZJk@;o/YK]00oo
[i;Vojb;g?n[QMSoZGoEoimadonDIlkoPE?0ogM>^?mL>IGof;ooonOIoOoe
l_Woo_o]ooWoioonooP00_nXcoH3ojWAm`09ob@/=?m6EfOo0@41oi^nh?n]
e?[o[M?koc0jAOm:FV_o0@4100;o/MKn00KoXL;WocU5D_l:30oo2P`?ocY7
E?nRaNT2ok;Ho`0=ocY7E?mQMXcoE6Iio`d@5?lP9bkoRJK4ok?Iooncf_oo
HGF:ob<Z<_l;3A3o:30ioh^Ya006okGLo`03obH^=_mBI7Co]Mco00;o]Mco
0_nfgOl02OlkB5CoI7Z=okKMoongg_ooRJJoobTb>_l;3A3o3A0CojO:j002
okSOo`05of=hR_lT:c;o2`h@obTb>On>[<@01?nih?l3ok[Po`?o^n7o00?o
_N?ookgToonmi?l00onoi_l2ol3Wo`Wo`NOo0oo2jOl2ol?Zo`;oaNco00Co
a>coolK^ooo6k_ooa^ko0oo7kol8olSao`?ob?;o0oo9lol3ol_eo`?ocOOo
0oo>n?l>olkio`04om3ooon`eO3o^M?_ogJ]jP;oZn3o00CoKVi^okBd]?oP
h>3ok>c/Foo^k^h01onNGQCoYVL0og]<5?n3@@3oSED:oiib2_n3>0000onE
E@001_nVI`3oYW8DojIW0?n`LP3o/7/:oiib2PCoYVL000ooWW8:ojIW0?nE
E@3oUED0ofY12_o:V1Co^H@Dok2=7_nVLQCoYW80ojIW0?nEE@3oYW80oh=1
0?nEE@000_n3@@02of0_2P05og8h0?lm70[o=2lNocdL2_m69PX00_m6;`X2
og]<2P0YojIb0?n=E@[oYVL0oc@_7_mZLUcoYZ6HojJZ[OoLhn3okNgZomcS
h?o1Q03oJT4:om?SmOo:d<7oYW80oiEE0?nVLP3o/780ojIb0?nNLP[oUED0
okV=5?n`Q2WobYPYoiEE0?l94P[o;180oa4L2_l92ACo6PT:oa4L2_l92@[o
2A8:oaX92_lS70[o8bH:oa4L2_lS70[o8bH:oaXV5?m69Q@00_mP;a@01onE
C2WoUEhcoiEbAoo1XHCoYXB4ombcXoo1XH@00ooL/jd01?oL_[Ooi=3<ongI
c?o]fL`2ooK]jP04ooo]c?oTal7oi<O1ongIc0?om_oo01;om^gZofYW<omZ
EAkoUEDDolZZI_niSACo/7/DolZH5?n`LP3o/7/:ojIb5?nVI`3oUED0oiiN
5?n=E@[oNd`Dog8h5?ld;ah2odHV5008og8h5?nNGQCo^H@DoaXB5?o1/hko
b[j]onC@c?oLhmH2ooooo`0Dol6c[OoT/dOog;=Long7G?oL/ecoi;j4ong7
Q?oT/c?oi;=7onBc:OoT/dOokKhmong7G?oTZP3obZ4mombcG?ofd8CobYPD
ombcG?oT/dL3onBc<`03onBc:Oo:XCgoi;<Y00?oi;<c00[o^HdcoooSS_o]
d9SokLMLong7Q?oohhkokM2HooKII_o]ahCokLML0_o]ah@0;?o]aecokKhm
ok2=7_n`E@3o`H@0ok2=7_n`Q2Wo/8dNojIb0?n3GS?oJT4:of0_2_lS9P[o
4A`:oaX92_l92@[o4A`:o`T92_l/4P3oYYQ_og:=?OmZEAko8bH:oaXV5?lJ
2@[o4BH:oaXB5?n3;`3oi;<YolZH5?oCQ03obYPDokV45?nVI`3oPehDof0_
2_lJ9QCo8a`:oa4L2_lJ4QCo0000okVHG?o]ahCog>?F0oo]m_D2ooKoo`05
ooKomOn`_/7o`K>]omcSh?o]kNX00_ofool2ooooo`05om?Ie_nVZZ?oi=3<
ongfmOoCfMH0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_ooool0
3OomoOgok>c/o`0/T?nL_=ko[<STojo9i?nA]=[oLIo>og^WdomoZ]GoPj_H
ohZafon;/]/03On@]]h05OonooKoooofoooomoooo?ool>7oomg5oomE<i7o
I3j]ogYBaOn6G<SoTfc5oiehaOnPO/[oY87EojV3j_n/Qo3o/HkZok>Aione
TnWo]YCXokFDi@02okFDh`03okJFh_nhV>Co^9ST00;o]iOS0_nfUN@2okFD
h`0>okRGi_nhV>Co^9OVokRHi?nhUnKo^9STokRGi_nhV>Co]ICSokFEhOnf
UNCo]YKRokNFiOngUn<2okRGiP;o]YGT01go]YGVokJEi?nfUNKo]YGTokJE
i_nfUNCo]YGVokJEi?nfUNKo]YGTokJEi_nfUNCo]YGVokJEi?nhUnKo^9ST
okNFiOngUn?o]YGTokJFh_neU>?o]IGQokRGi_nhV>Co^9OVokRHi?nhUnKo
^9STokRGiP05okRHi0Co^9OV1?ngU^L3okNEj@0BokJFjon[SnKoZXkSojN:
g?nTP]KoXg_Aoj5ddOnGI/ooSE_:ohEDb_m]@K;oDbj>omJlooo`h_oono[o
oocok?ohonGoo_oh0_nZcoD3oj[@mP03ob@/=?l=41?o;3I000;o[=;h00Co
[=7hofn7X?l<3a;o0@410on^doX00on^e?_o[M?jojgCnP05ojkDn`;o[mGk
00Go[]CjojoEo?n_eOco[mGlok3Go@02ok7Go@03ok3Go?nbfOko/]Wo00;o
/]Wo1?ncf_l00olU;SKoDF=dok?Jo`02ok?Jo`;o]=_o0oneg?l2okOMo`04
okKMoonefoco^=kookSNo`?o^Moo00?o^^3ookSNoOnjh?l01Onjh?l3ok_P
o`?o_>7o0onmhol3okkUo`;o_nKo2Oo0i_l3ol3Xo`;o`NWo0_o3jol01?o4
joooa^goolK]ooo6kOl3olO^o`Soao3o0oo8lOl3olWbo`03ol[dooo:mOoo
b_Go00?oboOo0oo<n?l>olgio`04om;ooon`e?3o]M3^ogV^k0;oYmco00Co
MWIfol71`Oo`l?3ooOgmFoooool03?n=E@[oWW8:oiEE0?n3>03oPd40oheE
2_nEE@3oSED:oiEE0?nNGQCoYW80oiib50CoWW8:00Co/780ojIb0?nVLP3o
YW800onVI`001_n=E@[oJT4:olZH:On`SAkobYPDokV=50;oYW8000CoPd40
ojIW0?nEE@3oYVL00_n3@@006?mb>03oH2lDof0_2_m69P[oEa`0odH_2_lS
9P[o?A`:ob<L2_mZ@@[oNd`:oiEE5?nNLQCo/7/Doa4L2_mbSCgoUJZ]ok2n
`OoLhn3om_ooomcSe_mb>03oY/OPolZZA`;o`H@000?o/780ok1k2_n`N`X0
0_n`N`X01onEE@3o/7/:okV=5?o:XCgoYW8Doa4L2_lS70X00olA70X01_l9
2@[o4A`:oa4L2_lS70[o4A`:odH_2P;o8a`:00Wo8bH:ob`V5?m69QCoARl:
of11:On3GS?oUEhcoiib<on`Q6H00_o1XH@2ombcX`07olZn[OoL_[Ooi<O1
ongIc?oTal7okMW<ooK]jP02ongfm@0[omcSh?ofkN[om_KeooKfmOo]m_Go
m^gZolZn[OmP@ACoH2lDok2=D_ofooooi<O1okVHG?o:V1CoSED:ok1k2_n3
GQCoYT`0og]<5?n3@@3oSED:og]<5?m6@Ako;2HDodHV5?l/9QCoH2lDog8h
5?lS;akoH44Dok2ZQ?n`/kOog>?Pong]j_ofoooooooooiib2_o]aecokLN4
onBcAooT_XCom]UVong7G002onBcA`09onBc:Oo]aecoi;=7ong7G?oCXBWo
bZ4mom>Q:Oofd8Cog;=L00;oi;=700[oi;<conBZ0?oT/c?oi:X0onBc7_oT
/c?okKhmonBc7_oT/dOodiP:0_o]d9P02?ofd8CokLN4ong@V?o]ahCom]24
ong7Q?oT/dOokLN40_o]ae`07_oLZS?o`H@0ojIb0?n=E@[oUED0oiib5?n`
SC?oWW8Doh=N5?mkC0[oARHDob`V5?l92@[o6Q8Doa4L2_l92@[o6PT:ob<L
2_nNQ6KoUG97of1N<ol/9QCo6RHDo`TB2_lJ2@[o6Q8Dog8V0?oT/c?oi;<Y
okV=<`;o/7/:00_oYVL0oh=N5?mP;`[o;2HDoaXB5?l92ACo6Q8Do`T92_n`
NbWokLN4ombn]`04ongfm@06ooKooooooooob]3Fok2c]ooLhmKokNgZ0oof
ool01_oooooodmWFol6c[Oo:d<7om^gZomcSh5oooooo00Co[jn_ol_;booN
g]koj^[Z0Oobl_8000;ok^k^00gok>c/omcLg?l0;I7oWKgNoj_7honbb^Co
TKGJog6NcOmlYmCoOZSDoh:Ze_n8[m[oS;?K00goT;SP0_ooooP04oonoOSo
oocoooWZoooRboooGT2HoePcWOm/A;KoMe2kohMP_OnAJl3oUg74oiUecOnO
NMkoXgkUojJ2h_nYR>?o[HcWojn>ion_S^D00_n^S^<01On^S^7o/Y;Uok6A
i?naTNCo/93S00;o[hoT0_n^S^<04?naTNKo/I7Tok6Ai_naTNCo/I7Vok6A
i?naTNKo/I7Tojj>hon^S^7o[hoTojn?h_n`T>Go/I7Tok6Ai_nbT^L2ok2@
i@0Nok2?i_n`T>Go/8oVok2@iOn`SnKo/93Uok2?i_n`T>Go/8oVok2@iOn`
SnKo/93Uok2?i_n`T>Go/Y;Wok6Ai?naTNKo/93Sojn?i?n_Sn;o[XkSojj>
hOnbT^Oo/Y;Uok:BionbT^Go/Y;Wok:BiOnbT^Oo/Y;U1?ncTnH4ok>Cj0?o
[hkU01Ko[XgTojj=i_n]S>Go[HcUojZ<h_nPQm[oWhKGoj20donKMlooVVk=
oiIVc?n=F<[oPdc3oga6`?mR<Z;oFcJComo4oookl?ooookooo[ok?okon[o
o_oh0_n[coD3ojc@mP03ob@/=?l0003oJh6I00?o[];i00?oZ<[ao`P92ol1
0@400on`e?`8ok7Eo@?o/MKm0onbe_d00oncf?ko/]Snok;HoP02ok?Jo`?o
]=[o1?ndfol00olV;SKoDF=dokCKo`02okCKo`;o]Mco00?o@4iKofMnT_ne
gOl00_ngg_l01?nhg_oo^]oook[Ooonjgol3ok[Po`So^n7o0onlhOl3okgR
o`03okkToonmhooo_N?o00?o_^Go0_noi_l9ol3Vo`?o`>Oo0_o0j?l2ol7Z
o`04ol;Zooo3k?oo`ncool?/o`?o`ngo2?o3k_l3olC`o`?oa_7o00?obO?o
olWdooo9m?l00oo<m_l3olkgo`kocoWo00Cod?ooojoDl?nhd^koMZgZ0_n/
gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP04oiib2_nEE@3oSED:og]100?o
UED000[oSED:oiEE0?nVI`3o/7/:ojIb5?nVI`3o/7/DojIb0?n`N`[o/780
0_nVLP002?nVI`3o/7/:oiEE0?nEE@3oWW8:ofYE7_o:V1Co^H@D0_n`SAh0
1?n`N`[oYW80ojIb0?nNLPX4oiEE0009og]<2_mb9P3oARH:of0_2_m69P[o
?A`:ob<V2_l/9QCo8a`:00;oJT4:00coSED:oiEE5?n`N`[oARHDoiFZ[OnV
ZZ?o`LO1onC@c?ofooooYZZSodmWAoofool2ol64000?ok2=7_niQ1Co/780
ol640?n`N`[o/780oiEE5?niQ1Co/780olZH:Oo1Q03o2A8:oa4V2_lS70[o
2@T:00;o2A8:00Ko4A`:o`T95?lS70[o8a`:ob`V5?lA70X3ob<L2P04odHV
5?mP;aCoJUDNog]<50;oUG9700Oo/8AVol6QQ?o1XHCog;>]ombn]ooL/j?o
g;jg00;oi<O100OokMW<ooK]j_o]kN[om^gZooKfmOofkN[om_Ke00;om_oo
01[om^gZongIc?nESE;oH44Doiib5?o:ZVKob]31ooKooooooooog>?Pol6Q
Q?n`Q2WoEa`0ocdL2_m6;`[oH2l:og8h5?mP;`[o?A`:oa4V5?l971ko4BHN
ob`L5?lA70[oWW8DojJQV0;o`K>]00[og>?FongfmOofoooog>?Pok1k2_of
d8Coi;j4onBcAoo]aecokM2H0_oT/dL01OoT/c?obZ4mooKII_oT/dOokLML
00;obYPD00oo^FL0onBcAooohhkog;=LonBcAooT/bWobYPDonBZ0?o:XCgo
i;<YooK7?OoT/dOoi;<cooK7?Oo:V1@00_o]d9P2ong7Q003ong@V?o]ahCo
kLN400CokLML01Wog;=LombZ<oniSACoLSPDoh<h0?n3GQCoUEDDok2=7_nN
LP[oPehDofY12_m6;`[o=2lNo`TB2_lJ4QCo4A`:o`T92_lA70[o2@T:ohf=
Aon3Nc?oJUDNoa4V2_lJ9QCo2A8:00;o4A`:01?oEa`0ooJc0?oT/akodh@0
olZH5?n`E@3o/7/:ojI<0?mZ@@[o;2HDob<V2_lJ4QCo4BHDo`T92_mkC1Co
on>>ojJQV?o]m_GokNgZ00?okOKe00Gom_oool77c?nVXISog>?FomcSh003
ooKoo`06ooooooo]kN[oUJ6>ol77c?ofkN[ob]3FGoo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@000_oVi^H03OoTi>Coe=CDo`0/TOnN_moo[<STojk8
i?nB]M[oLYo>ogZUdomnZ=CoPZ_FohN_f_n<]=`03On@^>004oonoo[oo_gi
oogjmOoooOoooo;oonGBoomZCY_oDS2AoehhYOmZ@k3oNe>fohMP_On?J<7o
UFk7oi]fe_nONm_oWG_Ioj22g?nVR>000_nYRn400onXRmooZ8_MojR;g@02
ojb?g`04oj^>g_nZSMgoZHcNojV<gP;oZ8_O2?nZSMl2ojR;g@;oZHcN00Co
ZXgOoj^>h?n/Sn7o[8oQ4?nZSN42ojb?h@04oj^>h?nZSMooZHcNojV<gP;o
Z8_M2?n[S^02ojb?g`Co[8oQ0_n/Sn<2oj^>hP03ojZ<h_nYRn7oZ8[P00;o
YXSN01;oYHSJoiV1bonJP<[oV7S;oi=^bonBILcoSE_:ohA=aOmj@[goIc:X
oeLXT?m/BI_ok]KooooioooloOooloo[ooWokoonooX2oj_Bn@?o[=?i00?o
Mi:/ofR0U_nTbNd00_n_eO`01?n^eOco/=KnogfH]OmZPYX3ok7Go`ko/]So
00?o/]Wook?IooncfOl02Oncf_l00omkU[3oS:[8ok?Jo`02ok?Jo`;o]=_o
00?oOi^doi6`cOneg?l00onfgOl3okONo`?o^=oo2?nih?l3ok[Po`?o^n7o
00?o_N?ookgToonmi?l00onoi_l2ol3Wo`Wo`NOo0oo1j?l2ol7Yo`;o`^_o
00Co`^[ool?/ooo3k?oo`nco0oo3kOl8ol?^o`?oa?3o0oo6lOl00oo9looo
bOCoolWdo`03olcfo`?oc_Oo3_o?nOl01?oBoooo/=K`okK@k_mi[nh2oj_N
o`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV0_nNLPX5oheE2P04oiEE0?nNLP[o
UED0oiib2P;oYW8D0_nNLPX2ojIb500OojIb0?nVLQCoYW80ojIW0?nNLP[o
YW80oheE2_mZ@@[oi;=7okV=5?niSBWo^HdDok1k5?n`N`[oYVL0ok1k2_n=
E@[oYW80oiEE0?nVI`3oPd40ofY12_mP;`[oNd`:of0_2_m6;`[o8bH:ob<L
2_lA9P[oARHDodH_2P02oh=N500HoiiN5?m6@AkoPhAkojJZXoo1al7okOKe
ooKooomPGS?oPhAkooKfmOo1Q03o^HdDok2=7_niSACo/7/Dok1k2_niSACo
/780oiEE0?n`NaCoYW8DokV=5?oCV0[o6Q8D0olA70X00ol92@[o6Q8Do`TB
2P02oaXB5006ob`L5?lJ9QCo4A`:oaX92_l/71Co6Q8D0_m69Q@01_mP;aCo
Pehcoh=N<onVLU;oYYQ_ojJ4Q0;o`J6400Coi:ZHombn]ooL_[Ooi<O10_o]
fL`3ooK]jP?om_Ke00com_ooooKomOo:d<7ob[j]oh=N<onEGS?o/7/YojJQ
I_nNSC?oYYR4ok2c]oofool2ooooo`0OonC@c?nVV6ooUHeVojJHKonNNc?o
Pg/cofYW<omZ@@[oJUDNoh=N5?n3Nc?oYYQ_okVZKoo1al7ob]31ombn]oo]
kN[om_ooongIc?o]aeco/8dNong7Q?o]aecokKhmonBnQ?o]ahCokLMLonBc
<oo]aecoi;=7ong@V002ong7G007onBc:OniQ1Co/7/Dok1k2_oLZS?okKhm
olZZIP03onBc:@03onBc<oo:XE;okLML00;oi;<Y00OokLMLolZH5?o]ahCo
kM2HombcG?o]ahCokLML00?okLN400gog;=Long7G?o]_Sgoi;=7om>Q:Oo:
V1CoPbl0oiiN5?n3@@3oWW8Doiib<onNLQCoPehD00;oJT4:017o;2HDob<L
2_l971Co2A8:o`TL5?lJ2@[o0000ohf=Aon3Nc?oH5hcoc@_7_lJ9QCo6Q8D
oa4V5?lJ2@[o?A8:onBc:@02olZH500?okV45?n`N`[oWW8:og]<5?mP;aCo
;2HDob<L2_l92ACo4A`:o`T92_mbEE;om]24ojJHQ?ofooookNgZ00;okOKe
0_ofool03OoChoGoUJ6>omcSh?oLhn3om_oeom?SmOo]m_GoooooooKooonV
XISob]31ongIc?oCfMH0GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00
0_o^k^h03Oo/k>cog=cLo`0[T?nN_mkoZlOSojo:iOn@]=WoLYo?ogZTd_mn
Z=CoPZ[FohN]fOn<]=`03On@^=l06?ooo_oooO_nooonnookmOGooo_oooof
oon:L:ooDC66oeXeW?mH<YooJdB^ohIPaOn:Hl3oYGkGojj7h?n]Rn7o[i;T
ok2Ei_ncV>Oo/YOTok6FhonaUn7o]9[SokNMi0;o]I_R00Co]9[Qok>Ih?nb
V>7o/YSQ0_naUn48ok>Li0;o[iSP0_n`VN401onaV^;o/Y_Sok>Li?ncW>Co
/i_Uok:Ji?n`V>800_n_Un400on`V>;o/Y[Tok>Ki@02ok>Ki@04ok:Ji?na
VN?o/9SRok2HhP;o[iOQ0_ncW>@01?nbVn?o/I[Rok2IhOn`VN42ojnHh0So
/icT0_neVn84okFKi0;o]I_U00Co]9[TokNMionfVnSo/YOT0_n_U>404on^
Tn3oZi7JojV@dOnfWMooY8CGoiageonRLn?oN4FnogY4`?mO:J7oDb:=oeX_
R?n5IjOooo;oooojooogn?[onOohoo3kkOonoo/00_nZcoD3oj[@mP?oZm7f
0_n/d_P01?n/dOSo[M;jojgBn_n]d_X3ojkCnPSo[]Ck0on_eO/3ok3Eo003
ok7FoOnaeogo/MOm00;o/]Sn0oncf?l9okCIo`;o]MWo0onef_l3okKLo`?o
]mko0onggol8okSOo`?o^>3o0onihOl00onjh_oo^n7ook_Qo`03okcRo`;o
_N?o2Onmi?l3okkVo`;o_nOo0_o2j_l01?o1j_ooa>goolC]ooo4kOl3olG^
o`Soa_3o0oo7lOl3olSbo`03ol[dooo;mOooboGo00?ocOOo0oo>n?l>oloi
o`04om3noon`e>oo^=;_ogV^k0;o[=oo00CoKVi^okBd]?oPh>3ok>c/Foo^
k^h2oiiN50?oSED:00_oYT`0oiEE0?nNGQCoWUhDoiib5?nNLP[oYVL0oiib
2_n`N`[oYVL0oiib2P02ok1b000<ojIb5?n`LP3oWW8:ojIb0?nVI`3oWW8:
ofY12_oLZS?obZ4molZH:OoCV0[o/8dN0_n`N`X01OnVLP3oWW8:ok1b0?n=
E@[oYW8000;oNd4001koNd`:ofY12_mb>1CoARl:ocdL2_lS9P[o8a`:ob`L
5?lJ9QCoJT4:of115?n3GQCo8bH:ofYbG?nEV:?ob]3Fong]j_n3Q8ko/;>g
ong]j_oLhmKo`H@0ombZ<oo1Q03o/8dNokV=5?n`N`[o^H@Dok1k2_n=E@X2
oiib2P04og8h5?o:V1CoARH:o`TB2PCo4A`:017o2A8:o`T92_lA70[oARl:
ob`L5?lA70[o8a`:ob`L5?l/4P3o=2lNodI17_mP@BWoLSPDoiEbAonVLU;o
/8AVok24N`03ol6QQ003ombc[OoL_[Ooi=3<00;okMW<1OofkNX2ong]jP0F
onC@c?o1XHCo^JY_oh=k<onNNc?oYXABolZQ?OmZIc?oPehDofY12_m69QCo
H79kog:=[OoChoGob]3Fol77c?ofkN[okNgZomcSe_oL_[Oog>?Fomc7X`Co
b]3100oo`K>]omcSe_oLhn3oooooongfmOoCZTOokLMLokV45?ofd8Cog;=L
onBnQ?o]aecokLN4ong7G?oT/dL00_o]ah@01_o]d9Soi;j4ong7Q?o]aeco
YVL0ojI<00;o/5D000?o^FL0onBc<ooT/c<01ooT/c<01_oT/dOoi;<NonBn
Q?offFKokLN4ong7G0;okLN400_okLMLong7Q?oT/dOokKhmonBcAoo]_Sgo
`H@0oh=N5?nEEACoYW8DokV45002ok2=7P0Ooiib5?n3GQCoH44DodH_2_lS
9P[o2A8:ob<L2_l94P[o6Q8Do`T95?l94P[oPehcoh=k<omZEAkoAT4Nob<L
2_l971Co6Q8Dob`L5?lJ4QCook<0olZH5?oCQ03o^FL0okV45?nVC03oSED:
of0_5?l/9QCo8a`:oa4V5002oa4L2P04oaX92_o]aeco/8AVooKoo`;okNgZ
1?o]m_D00onVV8Co`LO<omcSh002ongfm@07ooKoooooooooooooohf=KooL
_[Oog>?Fom?IeP1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0002oooo
o`0=oogmoOo/k>co02R=oiblg_n/an?o[/WSoi6ef_maWLooNZCBogjXeOn3
[=SoR:oJohbdg00=oi2fg`;oooco0_ooo_/05OoonOcooO3ooljhi_li7V?o
CBb7odLRRomZAJooLD^boj9mg?n]Q]oo^YCWok2@g?nmXn[o_ZO[ol6Zk_o1
Znco_jWYoknYioo2[>[oa:oZolRckP02olNbk@03olJak?o5[ngoaJo]00;o
a:k^2?o6/^l2ol>_k0;oa;3]00OoaK7^olJbkoo6/^ooak?`olNcl_o6/_7o
a;3_00;o`jo^00Coa;3_olJblOo7/o;oak?b0_o6/_400oo5/O3oa;3_olB`
k`02ol>_kP04olNcl?o6/^ooa[;_olFakP;oa;3]0_o3[n`8olJbk`;oak;]
1?o7/Nl2olNal@0IolB^k_o6/?3oa[3aol>]k_o1Znco`Zc]ol6[k?nnZ>So
bK7[ok>If_n/RmcobZCooh=Gb_md@[goLd6joe@TT_mL<HgoAb=Yoljdhoom
koooo_SoookoooobnoKonOokookoo`02oj[?mP?oZm3g0on/dOP2ojgCnP04
ojkBn_n_e?co[mClojoDo0?o/=Gm2?nae_h6ok7GoP03ok;Ho_nbf?oo/]So
00Go/mWo2Oncf_l2okCKo`?o]]co0_nhg_l01?nggooo^N7ookWQoonihOl3
ok_Ro`So_>?o0onmi?l3okgUo`03okoWoonoi_oo_nKo00?o`NSo0_o1jOl<
ol;Zo`;o`n_o0oo4k?l3olG]o`_oa^ko0oo7l?l3olSao`03olWcooo:looo
b_?o00?oboGo0oo<m_l>olgho`04olokoon`do3o]];^ogV^j@;oZ^3o00Co
MWIfol71`Oo`l?3ooOgmFoooool01OnVI`3oWUhDoh=10?n=E@[oPcP000;o
SED:0_nNGQ@02?nVI`3oYW8Dok1k:OnNLQCo/7/:oiiN5?nNLP[o/7800_nN
LPX03?n`LP3oWW8:ok1b0?nNLP[oWUhDofY12_oL/ecodjY7olZQ?Oo:V2Wo
^HdYok1b00;o/7/:0onVLP001On`N`[oUED0oiEE0?n=E@[oPd4000;oNd`:
00KoARl:ob`V5?lA70[o8bH:ob`L5?lJ9Q@2odHV500=odH_2_mbSCgoUIRS
ok2c]on`_/7og>?Fong]j_oChoGokOKeok1b0?n`SAko^HdDok2=7P02ok1k
2P05oiF=0?n`N`[oSED:oiib2_nVI`000_niSA@07OnNLQCo4A`:o`TB2_lA
70[o6PT:o`TB2_lA70[o6PT:o`TB2_lS9P[o8a`:ob`L5?lA70[o8bH:ob`V
5?m69QCoAT4Nof0_5?n3GS?oWW8coiEN<onNQ6KoYYR4ol6QQ?niZVoog;>S
ombc[OoL_[Ooi<O100;okMW<00Com^gZooKfmOofkN[om_Ke0_ofkNX01_oT
d<codkj>okVZKon`SE;o^IQLonBZV0;o`K>>00?o`J64ok2=D_n`ZX@00_oC
_Xh03_niZVooPehDo`000?n`/kOokOKeomcSe_o]kN[ob]3Fong]j_oLhmKo
i=3<omcSh?oLhmKodmWF0_oLhmH02OoLhn3om_KeombcG?oT/c?okLMLokV=
5?ofd8CokLMLonBcA`02ong7Q0;okLML00cokKhmong7Q?o]d9SokLN4ong@
V?oL/ecoUED0oh<_0?nVC03oWUhDojI10?o:V1@2onBcA`;oi;<c1?oT/bT0
1?oT/akog:Xcom>ZAoo]d9P2ong7Q00:ong7G?o]d9SokLMLong7Q?oT/dOo
kLMLombcG?oT/dOobYPDokUW00;o/7/D00?obZ4mok2=<onVLQ@00_nNLQ@0
9?mkC1CoH2lDob<V2_lJ4QCo6PT:o`TB2_l92ACo2A8:o`000?mZIc?oPehc
ofYE7_m6@Ako8blNoa4V5?lJ4QCo8a`:oaX92_ofaako^Hdcom>40?niQ1Co
/7/:oiiN5?n3GQCoJT4:ob`V5?l/71Co4A`:oaX92_lJ4QCo6PT:ooKII_nV
LU;om_ooomcSh0?okOKe00?om_ooongfmOn=V8h00_oLhmH02Oofm_Gom_oo
ooKoooofooooooooohfHS_o1al7og>?Fom?IeP1Oooooo`04ojn_[oo;bl_o
g]kNon[ZjP7ol_;b0002onk^kP0=onc/k?oLg=co02F;oiZkg_n[a>?o[<OS
oi2df?maW/goNZCBogjWeOn3ZmSoR:oJohfeg00=oi2hh00HooomooonoOoo
no[hoooon_onnOGoooGmooogoon2KZ7o>AmYodDVPom48HGoM52doiiif?oD
/?ooaZCaolf^l_o1ZNGo`ZoVolFbjOo6]>Soa;;Tol>ahOo5/n?ob;OT0oo9
^>D00oo8]nCoakGUolNei@02olJdiPSobKOW0_o6]>@2olNei@03olRfi_o9
]nOobKOW00;obKOW00Kob;KVolNeiOo6]>Coa[CTolNeiOo8]^H4olVgi`03
olRfi_o7]NGoakGU00;oa[CT0oo9]nL00oo8]^KoakGUolNei@02olJdi0So
bKOW1?o9^>D4olVgi`0IolNeioo:^>[ob[SZolNeioo7]NWob;KZolNejOo4
/>Go_ZGLolJXj?o5XoOo]i7doj1fi_m`@kSoDRJGodDKOOm07VSoSG:Uooob
oooonooomO?hooSjnOokoooon?knookoo`02oj[?m@?oZ]3f0on[dOH2ojcB
n004ojcAn?n]d_[o[M;jojgBnP?o[]?j2?n^e?/3ojoEn`?o/=Gl00?o/MKm
ok7GoOnaeod00_nbf?h3ok?Ho`Wo]=Wo0_nef_l3okKKo`?o^=ko0onjhOl3
ok_Ro`So_>?o0onmhol3okgTo`03okkUoonni?oo_^Co00?o_nGo0_noi_l9
ol3Vo`?o`>Oo0_o1j?l2ol?Zo`04ol?[ooo5kOooaNgoolG]o`?oa^ko2?o6
kol3olO`o`?ob?7o00?obO?ool[booo:l_l00oo;m?l3olceo`kocOKo00Co
co_ook3El?nidnkoNJk[0_n[gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP09
oiib2_nNNc?oPd40oiib2_n3>03oSED:oiEE0?nVLP3oWUhD00;oWW8:00Oo
YVL0oiiN5?n`N`[oWW8:ojIW0?nNLP[o/78000;o/7/:00KoYW80oiib2_nV
LP3oYW8DofYE7_oLZS<2om>ZA`03olZH:OniSBWo^HdD00?o/7/:0onVLP03
oiEE00;oSED:00CoWW8:of0_5?m69P[o4A`:0_lJ2@X2oa4L2P0=oaXV5?lA
70[oLVMBoiFQS_nVZZgo`LO1om?SmOoLhmKog>?PooKooonVLQCo/7/:ojIb
5002oiib500:ok1k2_nEE@3oYW80oheE2_nEE@3oWW8:oh=N5?n=E@[oJT4:
odHV50?o4A`:00?o6PT:oa4L2_lA70X00_lA70X02?lS9P[o4A`:ob<V2_l/
71CoARl:odI17_n3GS?oH2l:0_n3GS<01?nEQ5;o/7]Voij4I_n`Q7/2ol6Q
Q005ombc[OoL_[Ooi<O1onC7`Oo]fL`00_ofkNX01?ofm_Gom^gZomcSe_oT
al42ol6cSP03okVHG?nVV6oobZYV00;o^JY_00Cog;j]onC@c?o:d<7okNgZ
0_oLhn001?oLhmKoi=3<oh=k<onVXIP2onC@c00Dong]j_oCfMKokNgZomcS
h?oCfMKog>?FomcSh?o]kN[odmWFong]j_o]m_GobZ5Bonfn?OoT/c?oi;=7
okV=5?o]d9Sog;=Lonfn?Oo]d9P2ong7Q007onBcAooL/j?okLMLong7G?oL
/ecokLN4olZH5002oh<_0004ok1<0?oCQ03o/7/:oiEE00;og:Xc00Goi:X0
onBcAooT/c?oi;<conBcA`02onBc:@03ombZ<oo:XE;okLN400;okLN400Co
i;j4ong@V?o]_SgokLML0_oT/dL02?o]aecoi;=7onBZ0?oCXBWo`H@0ok1k
5?o:XCgo/8dN0onNLQ@01?mP@ACoARl:oc@_7_l92@X2oa4L2P;o6Q8D01go
0000ofYW<on3Nc?oJVLcodI17_lS;ako2A8:o`TL5?lS70[o2@TDonBc7_oC
Q03o/7/:okV45?n`N`[o/5D0og]<5?mb>1Co;1`Dob<V2_lA9QCo4A`:ob`L
5?l92@[oon>4ojIbD_ofoooodn?eomcSh002ongfm@05ooKoooo]m_GoPhB>
ol77c?oLhmH00_o]m_D2ooKoo`05oooooon3Q7_o`K>]onC@c?oCfMH0Goo^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000_oVi^H03OoTi>CoeMGEo`0P
R?nF^=coYl?Qojc6hon;[mGoKY_>ogNSd?mmYMCoP:SFohJ^f_n9/M/03On@
^>006_oooOoonOSoooonooofmO3oooohooomoOoon_oon>Soog5LUolT2EKo
>Qadof50VonBKlWo/XoSok^IiOo8Zngo`JWSol>_h_o8]>OobKGVolRdiOo7
]>;obKKSol^ihoo8]N;ob;KP0oo7]>43olJch@0>olRehoo8]N;ob;GSolRe
h_o8]N?ob;GRolRehoo8]N;oa[?QolJch?o6/n7oakCQolNdh_o7]>43olRe
h`03olNdh_o6/n7oa[?Q00;oa[?Q00CoakCRolRehoo8]N?ob;GS0oo7]>83
olJch@0?olRehoo8]N;oakCRolNdhOo7]>;oa[?PolJchOo6/n3ob;GSolRe
h_o8]N?ob;GRolRehoo8]N;ob;GS00Oob;GR0oo8]N<06?o:]nGob[KWolNc
i?o7/nCob;CUolJbiOo3[>3ocJo[okVHgOoA[_oo]I3`ohaUcomA:YCo@Qem
oc4@HOm[DX_oooCooooeoooon_coookooocnoOojoOooo?ooookoo`;oZ<oe
0onXd?H3ojWAm`?oZm;i0on]do/3ojkDo0So[]Gm1_n_e_d00on`f?ko/=On
ok3GoP05ok7Io`Wo/][o0_ncf_l3okCKo`;o]Mco00Co]MgookKNoonfg_oo
]]ko0onggol8okSOo`?o^>3o0onihOl00onjh_oo^n7ook_Qo`03okcRo`;o
_N?o2Onmi?l3okkUo`;o_nKo0_o2jOl01?o1jOooa>coolC/ooo4k?l3olG]
o`Soa^ko0oo7kol3olS`o`?obO;o0oo:m?l3ol_eo`koc?Ko00Coe?ooojkB
konhdnooMjk[0_nZgol01?mZJV[o[Zj^omSHf?oTi>AKonKViP0>oiib2_nV
LQCoSED:oh<_0?n=E@[oUED0oheE2_nNGQCoYVL0ojIb0?nVLQCo/7/DojIb
0?n`N`X2ojIb5006ojIb0?n`N`[o/7/:ok1b0?nNLP[o/7800_nNLPX02omZ
@@[og;=Lom>ZAoo:XE;obZY7okV=:On`Q2Wo^H@Dok1k2_n`LP3o/7/:00;o
/78000KoWW8:oiEE0?nNGQCoSED:oiib5?nEEA@2og8h5004ob<L2_lA70[o
8a`:oa4L2P;o6Q8D00go2@T:of1N<onVXISoYZZSok2n`OoCfMKodn?eol[@
`Oo]m_Godn?eoiF=I_nNSBWoLSP000;oPehD01;oH2l:og]<2_mP;`[oJT4:
oeLL0?mZ@@[oPhf4omcSh?n`ZXCo0000oa4V2_lJ2@[o4A`:oaX92_lA70[o
2A`Do`TB2_m6;`X2oa4L2P05ob<L2_ld;akoLSPDog:=?OnELTL00_n3GS<0
2_nNLS?oYXABok24I_n`Q7_o`J64onBZV?o:_Zgoi<O1ombn]ooTal42ongI
c0;om^gZ00?og>?FongIc?oLaj<00_o1XH@02On=SFoo`J64ojJHKooL/j?o
g;jgol[@`OoChoGog>?Pong]jP03omcSeP0;om?Ie_oTd<coYZ6Hol[@`Oo1
/jgokOKeomcSh?o]kN[og>?Pong]j_oLhn000_o:d<404?o]m_GokM2HolZZ
I_oT/akog;=Lonfn?OoT/dOodj4YonBnQ?o]aecog;=Long7G?oT_XCokLML
onBcAoo]ae`3onBcA`09om>ZAooCXBWoYT`0oiiN5?n3;`3o/5D0ok1k2_n`
C03odj4Y00;oi;<c0_oT/bT00ooT/akobZ4mombZ<`02onBc:@06okV=<oof
d8CokM2Hong7Q?o]aecokM2H0_o]ae`04?oL/ecokLMLombcG?o]aecoi;<Y
om>Q:Oo:V1Co^H@DolZH:On`NbWoWW8Doiib2_n3GQCoNd`:odH_2_m69Q@2
oaX92P0Po`T92_lJ4QCo2@T:o`T95?m6@AkoSHe7odIE:Old;ako8blNoa4L
2_l92ACo4A`:o`T95?oCQ03og:Xcom>40?niQ1Co/5D0ok1k:On3@@3oNd`:
ob`L5?lS70[o6PT:oa4V5?lJ4QCo0000ong7G?niSC?okOKeomcSh?o]kNX3
ongfm@04ooKooon=V8kob]31ol[@`@;okOKe0_ofool01OooooooUJ6>ok2c
]ooLhmKodmWF05ooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X000;ok^k^
00gok>c/omoOgol?98KoQ:_EojG2h?nU`n7oQZkEofRGb_mcWlooMjCCognX
e_n4[]WoRK;I00goSKKL01_onO[oooWjo_ooooooookjoooon_ooo__oin3X
oooioooolOoo?BQPocXPIomB=X?oMEJVok6@gongUn;o^YcRokNMg_nkXmoo
`JWUolB/i_o3[>Co`Z_Qol>/h?o5[n3oa:gQolB^goo4[N400_o3[>03ol>/
hP0>olB]hoo4[N7oa:gSolB]hOo4[N?oa:gQolB]hoo4[N7o`jcRol>/h?o3
[>;o`jcPol>/h_o4[N43olB]h`Ko`jcR1?o4[N<5ol>/hP0?olB]hoo4[N7o
a:gSol>/h?o3[>;o`jcPol>/h_o3[>3oa:gSolB]hOo4[N?oa:gQolB]hoo4
[N7oa:gS00Ooa:gQ0_o4[N<00oo2Zn7o`jcRol:[h`03ol2Yh@0?okbTg_ng
WM[o_YgRol>Njon[QMcoTFg7oehkUomA<8Oo<QIQod0XI?oom?oon^kooool
oooooogol_;`00;oo_oo00ConO[noooooonVc_GoY/ke0onWcoH3ojS?mP;o
ZM3h00CoZM7goj[BnOnZd_WoZ];i0on[d_T8ojcCnP?o[MCj0on]eO/00on_
eoco[mKmojoFo@02ok7HoP?o/MWo2Onbf_l2ok?Ko`?o]=co0_nfgOl01?nf
g_oo^=oookSOoonhgol3okWPo`_o^^7o0onkh_l00onkhooo_>?ookcSo`03
okcTo`_o_NGo1Onni_l3ol3Xo`Ko`^[o2?o3jol3olC/o`?oaNgo00?oa^oo
olG_ooo5kol00oo6lOl3olObo`kob??o00Coc_koojoDl?nidnooMjk[0_nY
g?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP03oiib2_nNGQCoSED:00;oSED:
00GoPd40ojI<0?n=E@[oUED0oiiN5002oiib2P04oiiN5?n`LP3oYVL0ok1k
2P;o/78000SoYW80ok1k2_n`LP3oWUhDok1k2_nNGQCoJT4:ombcG0?obZY7
00GobYPYok1b0?niSACo/780ojIb0003ok1b0004ojIW0?nNLP[o/7/:oiib
2P;oWUhD00CoNd`:oheE2_mP;`[o8a`:0_lA70X07OlA9QCo2A8:o`T92_lA
70[oUJZ]og9bNon`_/7og>?Pol[@e_o]kN[ob]31ooKooon`/kOokNgZohf=
Kon3NecoJUDNodHV5?mZIc?oSHeBojJ4Q?nVV8Cob]31ok2c]om6EBWoJT4:
ob`V5?lA70[o2A8:00;o4A`:01Go6PT:oaXB5?lJ4QCo=2lNoa4L2_lJ2@[o
4BH:o`TB2_lJ4QCoH44YofYE7_nEQ5;oUG97oij4I_nEQ5;oWXAVojJ4Q?o1
XHCog;>Sombn[Oo:_Zd00_oL_[L03ooTal7okMW<omcSe_oTal7og;j]onC7
`OniZVoo/8eBojJHKon`SC?o/8eBom>nS_o:_Zgog>?FolZn[@02onC@c00C
omcSh?oCfMKob]31ol77c?oCfMKokNgZol6c[On`_/7ob]31ong]j_oCfMKo
kNgZom?Ie_oLhn3ob]31om?Ie_oL/hCodjY7onBc<`02onBc:@0;onBc<ooT
/bWog:XcolZZAooT/dOog;=LonBc<oo]ahCoi;=7ong7G?o:XCd01?oT/c<0
5OoLZS?o^H@Doh<_0?mP;aCoPbl0ojI10?n`C03oWUhDom>40?oT/dOobZ4m
onBc:OoLZS?oi;<conBcAooT/c?og:XconBc:OniQ2WokLMLong7Q002ong7
G007ong@V?oL/ecom]UVonBcAoo]_SgokLMLombcG002ombZ<`05olZH5?o1
Q03obYPYoij=<on`N`X00_n=E@X01?mkC1CoARl:ob`V5?l94PX2oa4L2P08
o`T92_lA70[o0000odI17_mbSCgoJUDNodI<?OlA9Q@2oaXB5005ob<L2_lA
9Qkodh@0om>40?niI`000_n`N`X03onVC03oNd`Dog]<5?lS9P[o;1`Dob`V
5?lJ4QCo4BHDo`000?o:ZVKo^Hdcom?SmOoLhmKog>?Pom?Sm@02ongfm@07
oooooon=V8ko`LO1onC@c?o]kN[okOKeooKoo`02ooooo`04oiFQS_nVZZ?o
i=3<om?IeUook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN4000;ooooo00go
o_knoo7alOlj@I;oJi78oiZjg?nO_mooO:GCof6Caom/V/coLYo@og^Xf?ml
YMGoQ:gJ00goR;?N00Sonoglookoooolo?coooomoogln_oooogon_Gioook
o`;oooKo00koCc]`ocHMG_mC>7ooECJ2ohYY^?nSPlooXX??ojR:e?n`T]co
]9KNokFGgOndUm[o]ISJokNJfP?o]YWI0_nfVM/4okJIg0oo]YWK4OnfVM`E
okJIf`?o]YWL00?o]i[MokJHg_ndU]`00_ndU]`04on_TMWoZHWDojAmd?n]
QM_oQf6hof]8W?m59WCo7056ofIAR_oom_ooooWoooomooooo_ook>cZooko
oOonooookNk`ookoooooool00_nTc?D6ojC=mP;oY<kh00?oYLkgojG?nOnU
coT01?nUcoT8ojG@nP?oY]3j0onWdO/00onYd_coZ=?mojSCo@02oj[DoP?o
ZmGo2On/eOl2ojgFo`?o[]Oo0on`f_l3ok;Mo`?o/mko2?ndgol6okGPo`?o
]^7o1Ongh_l9okSSo`?o^>Co0_niiOl2ok_Wo`04okcVoonnj?oo_^SookkX
o`?o_nWo2?noj_l3ol3[o`?o`>co00?o`Ngool3^ooo0k_l00oo1kol3ol7`
o`ko`_7o00CobO[oojgCl?nidnooMZgZ0_n[h?l01?mfMWKo`L71oo3`l?om
oOeKooooo`06oiib2_nNGQCoSED:oiEE0?n3@@3oSED:0onEE@001onVI`3o
YW8Doiib2_nVI`3o/8dNoiib2_n`Na@00on`N`X01on`LP3o/7/DojIb0?n`
N`[oWW8:ofY12_offFH00_o:ZTL01_o:XCgobZY7okV=5?niSACo^H@Dok1k
2P;o/78000go^HdDok1b0?nVLP3o/780ojIb5?n`SAkoWW/coiEE0?n=E@[o
Nd`:oh<_0?m69P[o4A`:00;o6Q8D013o4BHDo`000?n=SFooYZZ]ol77`On`
/kOodmWFol[@`OoCfMKob]3FofYkKoofooGoi=3<omcSh?oTd<cob]3F0_o1
al402?o]kN[o`K>]oiF=I_n3GS?oYZ5Vol6cS_nNLQCo2A8:0_lA9PX2o`T9
2P0=oa4L2_lJ4QCo8a`:oa4L2_lJ2@[o2@TDo`T92_lJ2@[o;2HDodI17_nN
Nc?oWXAVoiEbA`02ojIbDP0[ok24I_o1XHCog;jgolZn[OoL/jgob[j]ombn
[OoL_[OokMW<onC7`OoL/j?o`J64ongIc?nVV6ooUHeBoij4I_niZVoo`J64
om?Ie_o1al7oi<O1ol77c?o:d<7o`LO<omcSe_o:d<7o`LO<ok2c]oo1alco
g>?Fol[@`OnVZZgo`LO1ol77c?o:d=Ko/;>gombcXooC_Xkoi;j4onBcAooT
/c?og:XcombcG002onBcA`08ombcG?oT/dOoi;=7ombZ<ooL/ecoi;j4onBc
7_oL/e`2ombZ<`05olZH5?oLZS?obYPDom>Q:OoCV0X00_o:V1@02Omb>1Co
Pbl0ok1<0?nV@@3oPbl0okV45?o:V1CodjY7ombcG002onBc<`0=om>ZAooT
/dOodjY7onBc<ooCZTOoWUhDooKII_o]ahCog;=Long7G?o]d9SokLMLong7
Q002onBcA`09ong7G?oT/dOog:XconBc:OoCV0[o`H@0olZH5?n`Q2WoWW8:
00;oSED:00?oNd`:odHV2_m6;`X00_lJ2@X02Ol94P[o4A`:o`T92_l92@[o
;1`Doh=k<omZEAko=2lNob<V2P02oaXB5003oaX92_l0003oWUhD00;obYPD
00_o/7/:ojI<0?nEEACoNd`Dof0_5?lS9P[o;1`DoaXV5?l92ACo6Q8Do`00
0002olZQDP;og>?P00[odn?eong]j_o]m_GokOKeoooooon=V8ko`LO1ol[@
`OoLhn3okOKe0_ofool01OooooooUIRSojJQV?oTd<cog>?P05oooooo00Co
[jn_ol_;booNg]koj^[Z0Oobl_8000;ok^k^00gokNg]onGUiOmaLJ3oB6>b
oh^af?n>/mWoHY?9odj6`OmLT<OoIiO<ofjMcomcXm;oOJOH00goP:cI00Go
o?ohoocon_ohn_Ooo_ooooWin`02ooono`0Aooojo_onm_ooooWoooofoomk
IIKo?29SochRKOmA<HCoEcF<ogE@[OmlEkCoQF2moh]W`On<J<3oS6RooheY
`?n?K<000on=J[h2oheY`0?oSFW14?n<J/03ohaZ`@;oSF_22_n<J/4AohaZ
`0KoSFW00_n=JL404On?Jl?oT6c4ohm[aOn>J/CoSf_5oi1/a_n:IL;oQEjk
og=7Z?mK;hkoCbMoobh<FOlo8VCoPVjSooocoooon_ooj^Sf00;oo_oo00Ko
n?[gookooOofn?Gooooooo_knoooool2oi_6l@?oVlOa0onLao82oig7l`04
oig8lonNb?CoW/Sdoik8m0?oWlSe2?nObOD3oj39mP?oXL[f00?oX/choj7<
n?nQc?P00_nRc_X3oj??nPWoY<ok0_nUd?/3ojGAo0;oY];m00CoY]7mojOB
o_nWd_koYm;n0onWdol8ojSDo`?oZMGo0onZe_l00on/f?oo[MSoojgHo`03
ojoJo`;o/=_o2Onag?l3ok7Mo`;o/]go0_ncg_l01?ncgooo]>3ookCPoond
h?l3okGPo`So]N7o0onfh_l3okKSo`03okSVoongi_oo]nKo00?o^NWo0oni
j_l>ok[[o`04ol3aoonXc_3o]M3^ogV^k0;oYmco00CoKVi^okBd]?oPh>3o
k>c/Foo^k^h01?nNLQCoWUhDoh=10?nNGQ@2oh=10009oheE2_nEE@3oSED:
oiiN5?nVLQCoYVL0ojIb5?n`LP3oYW8000;o/7/:01?oWW8:ok1k2_n`N`[o
UED0ok1k2_nVLP3o/780ofY12_oT/dOobZ5Bom>ZAooLZS?obZ4mok2=7_ni
SACo^HdYokV=5?niI`3o^H@D00?o/78000co/7/:ok1k5?n`NaCo/8@YoiEE
5?nNLP[oUED0og]<5?n3@@3oARHDoa4L2_lA9Q@2oaX92P0Joa4V5?n=V8ko
YZZSol[@`Oo1al7o/;k1ong]j_mZNfoo`K>]omcSh?o1alcog>?Fol77c?o:
d<7o`K>]ol77`Oo:_Zgo`K>]ol77`OoL_[Oo/;>gol6c[OnVZZ?oNd`:o`00
0?l971@2oa4L2P04oaX92_lA70[o4A`:oaX92PCo4A`:00go6Q8Dob`L5?m6
@AkoPehcoh=k<omZEAkoPehcoiF4D_nVLU;o`K>>ol6c[OoL/j?og;>]00?o
g;jg00godkj>okVHG?niZVoog;j]oiF4D_nELTOoWW/col6QQ?oC_Xkob[j]
ol6c[Oo1al7ob]3100;o`K>]0_o1al`02Oo:_Zgo`J64oiF4Noo1/jgoYYR4
ol6cS_oC_Xko`J64olZZIP05ombcG0;oi;=7023okLMLonBcAooL/ecokLML
onBc<ooT/dOobYPDolZQD_oT/dOog:XconBnQ?oT/dOoi;<com>Q:Oo:V1Co
dh@0ol640?oCQ03o`H@0ombZ<omG703oLRH0of0_2_mP;aCoLSPDok1E0?oT
/c?og;=LonBcAoo:XCgodj4YonBc:@?oi;<c00cobYPDojIW0?o]ahCog;=L
ong7Q?oT/dOokLN4ombcG?o]ahCokKhmonBcAooT_X@2onBcA`03ombZ<oo:
V1CobYPD00;o^HdY017oWW8cog]<2_n=E@[oPehDodI17_l/9QCo6PT:oa4L
2_lJ2@[o6Q8Doa4L2_lJ4QCo;2HDoiF4D_mPGS?o=2lNob<V2P02oa4L2P;o
6Q8D01CoYVL0olZH5?oCQ03o^H@DoiiN5?nEEACoNd`DodHV5?l/9QCo;1`D
oaXB5?lA70[o4BHDo`TL7_n`SC?og;=LomcSe_oChoGog>?Pong]jP;okOKe
00Kom_oeoiFZ[OnVXISoi=3<omcSh?o]m_D2ooKoo`05oooooonVZZ?oYZZS
onC@c?oCfMH0Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@000ooVi^H0
1OoQhN7o^KW2odA9Tom?L[KoEX[600;o=g>i00GoAH30oeB9a_mKTLOoHYS>
of^LdP0=og2Re@0HooSnl?okooOoo_omooSinoooo_oon_WnookloOoooogo
oogoooojoooon?oooo?oooo`ooo[coooJd^Pod<PO?l^26go>0mgod8IOom8
88?oBR:5od/SQ?m<98CoCBF50_m=9X<01om=9HGoCRJ6odhVQom>9XOoCRJ9
odhVQom<9hL03?m<9hH3od/VQ@;oBbJ61?m<9hL5od/VQPGoC2N70om;9XD=
od`WQPCoCRJ61?m>9XL06Om<98OoCBF8od`TQom<98OoCbJ<oe0WSOm;8XSo
A1Z0ocl@N_m04WGoKTJOooCBoooolOoooo;oooohoookn?ooo_koooOko_og
nocoo?ooonoak_onoogoooomooShm_ooool00_n;^n`3oh^kk@?oS;c]0_n=
_Nh01?n<_NooSKk`ohfnl?n=__03ohjol0SoS[oa0on?`?83oho1l`03oi32
mOnA`OCoTL7d00;oT/;f0onB`oL9oi?4n0;oU<Gh0onEaOT2oiO7n`04oiK7
nonHbOgoV<WmoiS9o@?oVLWn2onJb_h3oi_;oP03oic<o_nLcOooW<go00?o
WLko2onNcol3oio@o`;oX=7o0_nQdol01?nQd_ooX]Cooj;DoonRe?l3oj?E
o`SoY=Ko0onUeol3ojGHo`?oYm[o0onYg?l3ojWMo`koZ]ko00CoZnCooj78
k_nhd^koMZgZ0_n/gol01?mZJV[o[Zj^omSHf?oTi>AKonKViP0=ok1k2_nN
GQCoSED:oheE2_nEEACoUED0oheE2_nVC03oUED0ojIW0?nNLP[o/7/:ojIW
0002ok1k2P03ok1b0?n`N`[oYW8000?o/7/:00KoYW80ok1k2_nVLP3oH2l:
ong7G?oCZTL2olZQDP04olZH5?niSBWo^HdDok1b00?o^H@D017o^HdDokUW
0?n`N`[o/7/:okV45?n`NaCo^HdDojIW0?nNLP[oWUhDoiib2_nVC03oSED:
oh<_0?lS9P[o4A`:oa4V5002o`TB2P07om?Ie_o1al7oSIR>om?Ie_o1alco
JW9LolZn[@02ol[@eP07omcSe_o1al7o`LO<ol6c[Oo1alcob]31omcSeP02
ol[@`@0Dom?Ie_o1/hkoYYQ_ok2ZQ?n3Nc?o0000oa4V2_l92@[o4A`:oaX9
2_lA70[o8a`:oa4L2_l94P[o6PT:oa4L2_lA9P[o6PT:ob<L2_m6EBT2oh=N
<`;oUG9701OoJVLcoiik<on`SE;oYYQ_ol6QQ?o1/jgo`K>>ok2ZQ?nNQ6Ko
^IQLom>nS_niZVooWXAVoiEbAon`SC?oi;j4ombcQ?oLaj?o^JY_olZQD_oL
/ecoi;=7ombcG002olZH5006om>H2_o:V1CobYPDom>40?oT/c?og;=L0ooT
/dL01OoL/ecog<NSombcG?oT/dOokLML00?og;=L00?odjY7ombcG?oL/e`0
0_oT/dL02ooL/eco^HdconBcAooCZTOoi;<com>ZAooT/c?odj4Yom>40?o:
V1Co`H@000;odh@000So^H@Dog8h5?m69QCoARHDof0_2_mP;aCoYT`0onBc
A`;og;=L00CodjY7om>Q:OoCXBWobYPD0ooCXBT00on`NaCokLMLong7G002
ombcG008ong7Q?oL/ecokLMLom>ZAooT/dOog;=LonBcAooLZS<2om>Q:@0<
okV45?niQ2Wo/8dNoiib5?mkC0[oSED:og]<2_m6;`[o8bH:oaX92_lA70[o
6Q8D0_l92@X04_lJ4QCo8a`:og:=G?mZEAko=2lNob<_7_lA70[o6Q8Doa4L
2_lJ2@[oLSPDom>40?niQ1Co^HdDojI<0?nVI`3oNd`:of0_50;o8bH:0olJ
4Q@01ol0003oWW8combcG?o1alcokOKeomcSe_oChoD00_o]m_D03Oofoooo
/;>gojJZ[Oo:d<7og>?PongfmOofooGom_oooooooon`/kOoUJ6>ol77c?oL
hn00GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP000oo^k^h03?o/k>co
hn?SoinO/olf>hWo2c2Eo`=5X?lBEj[o96Fcoc5b^?llNKgoAH;2odZ7b13o
E8g<1OmES/d2oeJ@c`03oeN?comHTM7oF97A00CoF97A2omIT]83oeZCdP03
oebDd_mLU=?oG9CC00;oGYGC3?mOU]<3of2Gd`;oHISD0_mRVMD01?mQV]Co
HY_Eof:KeOmRVmD3of>LePSoI9gF1_mUW]L00omVWmSoIikHofNNf005ofRO
f@WoJJ3J0omZXM/3of^Rg003offTg_m/Y=ooKZKQ00;oKZKQ0om_Yn88og2X
h`?oL:ST0omaZND2og:ZiP04og>[i_md[>OoM:cWogB/i`?oMJgX2?me[NT3
ogJ^j@?oMZkZ0omg[n`2ogR`kP?oN;3_2Omi/Nl2ogVal0?oN[;`0omk/o43
ogbdlP?oOKGb2?mm]O<3ogjfm0?oO[Of00?oP;Whognin?mo^OP00on1^oX2
oh6lo0WoP[gm0on2__d2oh>no@;oQ<3n00CoQL3nohK2oon6`_ooQ/;o0on7
`_l8ohO3o`?oR<Co0on9aOl00on:a_ooRLKoohW6o`03oh[7o`?oRlSo3_n<
bOl01?n:c_ooW/?ZokK@k_mi[nh2oj_No`04ofi^K_nd];Coh>3Ponc/k5_o
k^k^00WoWW8:ojIW0?nEE@3oSED:og]10?n=E@[oUED0oheE2_nVI`000_nN
LPX02on`LP3oWW8:ok1k2_n`N`[o/7/Dok1b0?n`N`[oYW80ok1b0?nNLP[o
YW8000;o/7/:00_oJT4:om>ZAoo:XCgodjY7olZZAoo:V2WodiP:ok2=7_n`
N`[o^HdDok1k5002okV=500<ok1k2_o1Q03o^H@DokV45?niSACobYPDok1k
2_n`Q2WoYW80ok1k5?n`N`[o/7800_n=E@X03?n3;`3oH2lDoc@_7_lA70[o
=5Dmoh>=Q?oCfMKoUJ6>ol77`OnVV8Cob]31ol6c[@;ob]310_o1al402On`
/kOo`LO1ol6c[Oo:d=Kob]31ol6c[Oo1alcoYZ6HojJHQ002ok2ZQ003o`00
0?l94P[o4A`:00;o4A`:01Oo8a`:oa4L2_lS70[o4A`:o`T95?lJ4QCo6PT:
oa4L2_lJ9QCoARHDodI17_nVXFKoYYQ_og9WD_mZIc?oH2lDoiik<onNLS?o
^IQLojJHKonVQ5;o/8eBojJ4DP02ol6cSP03oij4I_nVQ5;obZ5B00;okM2H
00_okMW<ooo]S_oL/eco^Hdcong7G?oL/ecokLMLombZ<ooCXBWoi:X0om>H
2P03om>Q:@04onBcAooCZTOog;>4ombcG0;oi;j400GokLMLombcG?oL/hCo
g:Xcom>ZA`02onBcA`0Com>ZAooL/ecoi;=7onBcAooL/eco^Hdcong7G?oT
/dOoi;j4onBc<ooT/dOoi;<Yom>Q:OoTZP3obYPDonBZ0?oCV0[o^FL0ojI1
0002og8h5005of0_5?n3;`3o/780olZZI_oL/e`00ooT/c<04_oT/bWodiP:
om>H2_oCZTOodj4Yoiib2_o]ahCoi;j4onBcAooL/ecokLMLonBcAooT_XCo
i;=7ombZ<ooT_XCoi;=7onBZ00;odj4Y0_niQ1@08On`SAkoWW8Dog]<5?nN
LP[oH44Dof0_5?lS9P[o8a`:oaX92_l92@[o4A`:oaX92_l92@[o4A`:ohf=
D_n3GS?oAT4Nob`V5?lA70[o2A8:oaX92_l92@[oLSPDolZH5?niLS?o`H@0
oiiN5?nEEACoSED:odHV5?lS70[o6RHDob<L2P02oaXB500Fo`T95?nEEACo
g;=Lok2c]ooChoGog>?Pong]j_oChoGokOKeooKomOo1alcoYZ6Hol[@`OoL
hmKokNgZooKfmOofoooooooool77`OnEXHkob]31omcSh5ook^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN4000Cooooo00_oo?cloo7alOo2`/coJFVHob/i
R?l;<8ko03nLo`A:Y?l?E:[o6Ef^oaiU]P0@obE/_0;o9Vfm0olWKKd2obY_
_P04obU__ol/LL3o;770obaa`0?o;G702?l^L/43obmb`@?o;g?200?o<7C3
oc5d`_laM<800_lbML<3oc9fa0Wo<gK40oldMlD2ocEha@;o=WW600Co=W[7
ocMkb?lgNlSo=g_80olhO<P8ocUmb@?o>Gk90oljO/X00ollP<_o>go;oc]o
b`03ocf1c0;o?X7=2OlnP/d3ocn3cP?o?hC?00?o@8GAod66d?m2Qm800_m2
Qm83od:8d`So@hWD0om3RMD3odB9e@;oAH[F00CoA8[FodF;eom5RmOoAH_G
0om6RmL8odJ;f0?oAhcH0om8SMT00om9S]_oBHgKodV=f`02odZ>g@?oBhoN
2Om<T=h2odf@g`?oCI7P0_m?Tn401?m?U>;oDIKSoe6FhomAU^<3oe6Gi0So
DYOU1_mBV>H00omAVNSoDYWXoe:Ij005oe6JjPWoDI_[0omAW>`2oe:Mk@;o
E9k^00CoDig^oeFNkomEW^ooEIk_0omFWo08oeJPl@?oEj3b0omGXO@00omG
X_SoF:;goeRRm`03oeRSn`?oF:Cm3_mIY?h01?mHYoooXL7TokSBkomi[^`2
ojcOo`04ogIfM_o1`L7ol?3`oogmoE_ooooo00?oWW8:oiiN5?n=E@X00_n=
E@X03?n3@@3oUED0oiiN5?nNLP[oWUhDoiib2_n`N`[o/7/Dok1k2_nVLP3o
/7/:ok1b00;o/7/:00?o/780ojIb0?n`LP000_n`N`X05Omb>03okLMLombZ
<oo:XE;obZY7olZQ?On`SAkobYPDok1k5?n`SAko`H@0om>H2_n`N`[o^HdD
om>H2_n`N`[o^HdDolZH5?oLZS?o^HdDokV=:@02okV4500Cok1b0?niQ1Co
/7/:ojIW0?nNLP[o/780oheE2_nVC03o2@T:odHV5?mZLUcoUJZ]og9bNooL
hmKoYZZSojJZ[On`_/7o`K>]ol[@eP02ol77c00@ok2c]onEV:?o`LO1ol[@
`Oo1al7ob]3Fok2c]onEXHkoYZZ]om?SmOnEEACo2@TDoa4V2_l971Co4A`:
ob<L2P?o4A`:00Co6Q8Doa4L2_lA70[o6PT:0_l/71@04om6@AkoPg]LoiF=
I_nELTOoPg/cob`V5?mZIc?oLXdmoiF4D_niZVoo/8AkojJHKoo1XHCodkj>
ok2ZQ?n3GS?obZ4mombcQ?oT_X@00oo]d9P01_oC_Xko^HdYong7G?oL/eco
i;j4om>ZA`;odj4Y0_o:V1@01oo:ZVKoi;=7onBc:OoCZTOog:XconBcAoo:
ZVH00_oL/e`01_o:ZVKoi;=7ombcG?o:XCgoi;=7olZQ?@;oi;=700gog;=L
olZZI_o]d9SoWW/cooK7?Oo]aecokLN4ombcG?o]ahCog;=LonBc<oo]_Sgo
dj4Y00;odiP:00?odj4Yok1E0?n`E@000on3;`001onNGQCoi;=7onBnQ?oL
/ecoi;<YolZQD_o:V1@00ooCXBT01OoCQ03oWW8:ong7G?oL/ecoi;j400;o
g;=L00?oi;j4ong7G?o]_Sd00ooT/dL01ooT/c?obYPDom>Q:Oo:V1Co/7/:
ok2=<onNLPX00omkC1@01?m6;`[o?A`:oa4L2_lJ2@X2oa4L2P0Co`T92_lS
;c?o2@T:odI17_n3Nc?o=5DYoaXV5?lJ4QCo6PT:oa4L2_lJ2@[o?A8:onBZ
0?n`NaCo/7/:oiiN5?nVC03oLSPDof0_5002ob`L500Boa4V2_lJ4QCo4BHD
o`T92_mkC1CokLN4ol6QQ?o]m_Gob]3Fom?SmOo]kN[okOKeooKooonVan3o
YYR4ol77`OoLhmKokNgZ0_ofool01Ooooooob]31oiFQS_o:d<7okNgZ05oo
oooo00Co[jn_ol_;booNg]koj^[Z0Oobl_8000Cok^k^00SokNg]on_[jooS
hn?oemOGolK6a_ng]kOo[Jf]ojRXZ?ooYJFU3OnUYJD02OnLW9coUiNGohn?
Son3Ph?oLG5ao`TjN?nUa>Ko]];^ogV^j@02oj[Po`04ofi^K_nd];Coh>3P
onc/k5_ok^k^00SoWW8:oiiN5?n=E@[oYT`0og8h5?n3>03oUEDDok1k2P;o
YVL00_nVLQ@01?nNLP[o/7/:ok1k2_n`NbT3ok1b000Cok1k2_nVLQCo/780
ok1b0?n`N`[oJT4:ombcG?oCZTOobZY7om>ZAooLZS?o/7/:okV=<oniQ1Co
bYPDok1k5?o:V1Co/7/:om>H2P02ol640006om>H2_o:V1CobZ5BokV=5?o:
V2Wo^HdD0_niSC<2okV4500?okV=5?n`N`[o^H@Dok1k2_o:V1CoARHDokV=
5?nVC03oUED0oiEE5?nEXHkoYZ6HoiFQS_n`/kOo/;k100?o`LO<00goUJ6>
ojJQV?o1/jgo`K>]ojJQV?o:ZVKo^JY_ok2=D_niSBWo/8dcolZH5?n`E@3o
ARHD00;o2A8:00Go4A`:ob<L2_lJ2@[o4BH:o`TB2P02oaXB500NoaX92_lJ
9QCo=2lNof11:OnELTOoPg]Loh=N<omP@BWoAT4NofYE7_n3GS?oLUEBoiF=
D_nVV6oo^IQLol6cS_n3NecoUHeVonBnQ?oL/ecokM2HonBnQ?o]d9Soi;j4
omc7XooL/hCo/8dNombcG?oT/dOoi;j40_oLZS<09ooCXBWodiP:om>Q:Oo:
V1CodjY7olZQ?OoT/dOog:Xcom>ZAooLZS?odjY7ombcG?oLZS?og;=LonBc
AooCXBWoi;=7onBc<ooT/akodjY7onBcAooLZS?okLMLoiib5?ofd8Cog;=L
ong7Q?oT/dOoi;j4onfn?OoT/c?okLMLom>Q:OoCV0[oi;<Nol640?o:V1Co
/7/:ok1<0002om>40008olZZI_oT_XCoi;j4ong7Q?oT/c?obZ4molZH5?oL
ZS<2om>Q:@05olZH5?nVI`3oon>>ong7Q?oCZTL00_oL/e`04_oT_XCog;=L
ombcG?oLZS?odjY7onBcAooCZTOodj4YolZH5?n`SAko^H@Dok2=<onNLQCo
PehDog]<2_mkC1CoARHDoc@_7P;o4A`:01oo6Q8Do`T95?lA70[o6PT:oa4V
5?m6@AkoLUEBodI17_lS;ako4A`:o`TB2_lJ4QCo4A`:oaX92_oCV0[o/7/:
oiiN5?nVI`3oWXAVoh<_0?mP;aCo4A`:ob`V5?lJ2@[o4A`:oa4V5?l971Co
H2lDonBcAoo1XHCodn?e00;og>?P00ookNgZom?SmOo]m_Gob]3FohfHS_o1
/jgog>?FongfmOofooGom_oooooooooCfMKoSIR>ol[@`OoLhn00Goo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@001_oVi^H01_oTi>CohN7QomgMgOoI
fMWoemOGomGEeOooe=CD3OoDe=@02Oo9bLWo`l?3okVi^OnYZJWoTI6Ao`Y<
XOnVa^Ko^M?^ogV^j`02oj_Oo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00Oo
WW8:oiiN5?nEE@3oUED0oheE2_n3>03oWUhD00;oUED000GoYW80oiib2_n`
N`[o/7/Dok1k2P02ok1k5006ok1b0?n`N`[o/7/:ok1k2_n`LP3oYW800_n`
LP000omb>03og;=Lom>ZA`02om>ZA`07olZH:On`Q2WobYPDokV45?n`SAko
`H@0ombZ<`02ol64000=okV=5?o1Q03o^H@DolZH5?oCZTOo^HdDolZQ?Oni
Q1CobZ4mokV45?oCXBWo^HdDokV45002olZH500;ol640?oCXBWoH2l:ombZ
<ooL/ecog:XcolZH:Oo1Q03o^HdDok2=7_niQ1@00_niSC<03On`SC?o/7/D
ok2=7_oCXBWo`H@0olZH5?o1Q03oi;<combcG?o:V2Wodj4Yol640?oCV0X0
0_o:V1@01_m69QCo2A`DoaXB5?lA70[o8a`:oaX92P;o4A`:00Wo6Q8DoaX9
2_l/9QCoAT4Nof115?n3NecoWXAVoh=kG?m6EBT00_m6@Ah03?mP@BWoUG97
oiF4NonVV6oo`K>>ojJHQ?niSC?og;>4ong7Q?oL/hCokM2HombcQ0;okM2H
02;oon>>ombcQ?nNSBWokLN4ombcG?oT/dOog;=LombZ<ooCXBWog:XcolZH
5?o:XE;odjY7ombZ<ooT/dOog:XconBcAooLZS?oi;=7ombcG?oT/c?oi;=7
om>ZAooT/bWog;=Lom>ZAooT/dOog;=LonBnQ?oT/dOoi;<coiEE5?o]aeco
kLN40_o]ae`02_o]ahCog;=LonBc:Oo]aecoi;<YolZH5?oT/ako/5D0om>4
0?oT/c<2olZQ?@0EokV=<ooL/hCoi;j4ombcG?oT/dOoi;<conBcAoo:V1Co
i;=7ombZ<oo:XCgobYPDok1b0?o]d9Soi;j4ombZ<ooL/ecog:XconBnQ?oL
ZS?oi;j400;oi;=700WodjY7ombZ<oo:V1Co/8dNol640?n`NaCo/8dNojIb
5?n3GQ@00_mkC0X2odH_2P0BoaX92_lA70[o4A`:o`T92_lA70[o2@T:oaXB
5?ld;akoPg/codI17_l/9QCo4A`:oaXB5?l92@[o6Q8DoaX92_ofaako`H@0
0_nNGQ@01_nVI`3oNd`DofY12_lJ4QCo;1`Do`TB2P;o6PT:00So2@TDocdB
2_oT/dOoYYQ_ongfmOoLhn3okNgZomcSh0;okOKe00codmWFog^=Q?o1/jgo
dmWFong]j_o]m_Gom_KeoooooooLhn3oUIRSol77`OoLhn1OonKViP04oifM
WOng]kOob<S8om?Cd`7of][J0008onk^kP;okNg]ooo/k>`?onc/k009omoO
gooHf=SocLg=ok^k^onQXJ7o3UF]oj?2i?nhdnooMjk[00;oZ]oo00CoKVi^
okBd]?oPh>3ok>c/Foo^k^h01?nVLP3oWUhDoiEE5?nNLQ@2oheE2P;oWUhD
00GoYVL0ojIb5?n`NbWo/780ojIb5006ok1k2P0Ooiib2_n`N`[o/780oiib
2_n`N`[oJT4:onBcAoo:ZVKog:Xcom>nS_o:XCgo^HdDolZQ?OniSACobZ4m
ol640?o:ZTOo/8dNolZH5?o:V2Wo^H@DolZH5?n`SAkobZ4mokV45?o:V1Co
/7/:olZH5?n`SAkobYPDom>H2P02ok2=7P;obYPD00?odj4YofY12_o]ae`0
0_oL/e`01?oC_XkobZ4mombZ<oo:V2T2okV=:@04ombZ<oo:V1Co^HdYolZQ
?@;obYPY00?o^HdDolZQ?OoLZS<00_oCZTL02OoCV0[o/7/:om>H2_o1Q03o
bYPDombZ<omG703o2A8:oa4V5002ob<L2P0:o`TB2_l/4P3o4A`:ob<L2_lJ
9QCoARHDof11:OnESE;oSHeBodI17P;oARHD00goPehcofYE7_nNQ6Ko`K>]
ombcXon`ZXCoPehconBnQ?oL/hCokM2HombcG?o]d9Sog;=L00;okM2H00Co
kMW<ong@V?nVLP3okM2H0_oL/e`00ooLZS?odj4YonBc:@02om>Q:@07ombZ
<ooCZTOoi;=7om>ZAooL/ecoi;=7olZQ?@02ombcG004om>ZAooT/dOog:Xc
ombZ<`?oi;=700GodjY7onBc<ooLZS?okLMLoiEE0002ong7Q00KombcG?oT
_XCokLMLombcG?oT/dOoi;<NonBc<oo:V1Codj4YolZH5?niI`3o^H@DolZQ
?OoL/ecodjY7ombcQ?oL/ecoi;=7olZQ?OoT/c?okLMLolZQ?OoCXBWog:Xc
onBc<ooCXBWo^H@D00?og;=L02;oi;j4olZQ?OoT_XCoi;=7ombcG?o:XCgo
dj4YombcG?oLZS?odj4YolZH5?niQ1Co^FL0ok24:OnNLQCoPehDog8h0?mk
C0[oJT4:ob<V2_l/4P3o6PT:o`T92_lA70[o2@T:oa4L2_l92@[o?A`:og:=
?Om6;`[o=2lNo`TB2_l92@[o6Q8D0_l92@X02?o:V1Co^G8coiiN5?nNGQCo
/5D0oheE2_mP;aCo;1800_lS70X02_l92ACo4BHDo`T95?lS70[og:Xcok1k
I_ofoooob]3FomcSh?oChoD2ong]jP0<ongfmOn3Q7_o`K>]om?Ie_o]kN[o
kOKeooKoooooooookOKeoiFQS_n`/kOog>?PGoo^k^h01?nSXj?o_Kfmolo?
cooJf]X1on7Qh@00oooooolIooooo`09oo;bl_oZj^[og]kNol_;bon_[joo
3eF_ojG4i_nidnooMjk[00;oZMco00CoMWIfol71`Oo`l?3ooOgmFoooool0
1_nNLQCoWW8:oh=N5?nNGQCoUEDDog]100;oWUhD00_oYVL0oiib2_nVLQCo
/7/:ojIb0?nVLU;o/780ok1k2_n`LP3o/7/:ok1b0002ok1k2P0?ok1b0?n`
N`[oYW80og]10?oT/dOobZ4molZZAoo:ZVKog:Xcok2=<oo:V2Wo^HdDolZH
:On`SAkodj4Y00;obYPD0_niQ1@02oniSACobYPDolZZAon`SAkobYPDokV=
:Oo:V2Wo^HdYom>Q:Oo:V1Co^HdD00;obYPD01CobZ4mom>ZAon3GQCokLML
om>ZAooL/ecoi;=7ombZ<oo:XCgobYPDom>H2_o:V1CobYPYokV=:OniQ2Wo
bYPDom>Q:OoCZTOobYPDom>H2P;odjY701Kodj4YolZH5?oCV0[odiP:ol64
0?o:V1Cog:XcolZH5?mP;aCo6RHDoa4L2_l94P[o;180o`TB2_lA9P[o8a`:
ob`L5?m69P[oJVLcodI17_m6;`[o=2lN0_mP@BT02?mZIc?oUHABokVZKoo1
/hkoUHeBoh=N<oniSC?okLN40_oT_X@02_oL/ecog;j]ong@V?oT_XCokM2H
omc7Xoo]d9SoWW8Dong7G?oCZTL2ombcG0;odjY700WobZ4mom>H2_o:V1Co
g:XcolZQ?OoT/c?og;=LonBcAooT/bT00ooT/dL01OoL/ecoi;<conBc7_oL
/ecoi;<c00;og:Xc0_oT/c<02Oo]_SgoUED0onBcAoo]aecoi;<cong7Q?o]
_Sgoi;=7ombcG002onBcA`07om>H2_oCXBWodiP:ok1E0?niQ1Cog:XconBn
Q003ombcG0;oi;=700Goi;<NonBnQ?o:XCgoi;<YonBcA`03om>Q:@;oi;=7
0_oL/e`01_oCZTOokLMLom>ZAooT/dOog:XconBcA`;og:Xc01Sodj4Yol64
0?o1Q03o^H@Dok1k5?nVLQCoPehDog8h0?mb>1CoJT4:ocdL2_lA70[o2A8:
oa4L2_l92ACo4A`:o`T92_lJ2@[o8bH:oh=k<om6@Ako8bH:oa4L2_l92A@2
oa4L2P09o`T95?oCQ03obYPYokV45?nEEACoWUhDoh=10?m69QCo;2HD00;o
8a`:00So4A`:oaXB5?lJ2@[o2@T:ombcG?o:ZTOokOKeom?Sm@;og>?P00Wo
kNgZom?SmOo]m_GoNhf4ojJZXooTd<cog>?PongfmOofm_D00_ofool00onV
ZZ?oYZ6Hong]jP1Oooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b003oonk^
kQWok^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol;E;7oY<CVokWCkomf[NX0
0_n[h?l01?m^KVko];Bdon3Ph?o/k>aKonk^kP03oiib2_nEEACoSED:00;o
SED:00GoPcP0oiEE5?nVI`3oYT`0ojIb5002ok1k500>ok1b0?n`NaCo/7/:
ok2=7_n`N`[o/780okUW0?n`N`[oYW80ok1k2_nVLP3o/7/:og8h0?oT/dL2
olZQ?@0Fom>ZAooLZS?obYPYolZH5?n`SAkobYPYokV=5?o:V2WobYPDom>Q
:OnNLP[o^H@DokV=5?o:V1CobZ4mokV45?o:V2Wo`H@0olZH:On`SAkodj4Y
ok2=7P;obYPD00GobYPYolZH5?oLZS?oJUDNombcG002om>ZA`06olZH5?oC
XBWog:XcolZH5?o:V2WodiP:0_o:V2T09On`N`[o^Hdcom>Q:Oo:V1Co^H@D
olZQ?OoLZS?obYPYom>Q:Oo:V1Codj4Yom>40?o:V1CodiP:olZQ?OoCXBWo
/8dNoiEE5?mP;aCo;180oaXB5?lJ71ko6PT:oaXB5?lJ71koH5hcob<_7_m6
@Ako;1`DodI17_mZEAkoPg/cojJ4D_nVV6oo/:Z4ojIbD_n`SC<00_o:XE80
1_oT_XCoi<O1onBnQ?oL/ecokM2Hong7G0?okM2H00Goon>>og]<2_oT/dOo
g:XcombcG002om>ZA`03ombcG?oLZS?odj4Y00;odj4Y00Kog:XconBcAooT
_XCog;=Lom>Q:OoL/e`2onBcA`03onBc7_oT/c?odjY700;og;=L023oi;<c
ombZ<ooT/c?og:XconBc<on=E@[og;=LonBnQ?oT/c?om]UVombcG?o]ahCo
i;<conBc7_oT/dOobYPDonBc:OoT/c?obYPDok1E0?oCV0[obZYVonBcAoo:
ZVKog;=LonBcAooL/ecoi;<conBcAooCXBWobYPDonBc<`;odj4Y00oobYPD
ong7Q?oCZTOog;=LonBnQ?oT/dOog;>4om>ZAoo:ZVKoi;<colZQ?OoT/c?o
dj4YolZH5?n`SAh00_n`N`X03?n`NbWoYW80oh=N5?mkC0[oNd40ofY12_lS
9P[o8a`:oa4L2_l94P[o2@T:oa4V50;o4A`:01go6Q8Doh=k<om6@Ako=2lN
oa4V2_lA70[o2@T:oa4L2_l92@[odh@0olZH5?niI`3oYT`0ok1E0?n=E@[o
LSPDocdL2_lS70[o4A`:oaXV5?lJ4QCo4BHDo`T92_niSC?o/8eBooKoooo:
d=KokNgZom?Sm@02ong]jP07ooKooomkSFKoYZZ]ol[@`OoLhn3okNgZooKf
m@02ooKoo`03ok2c]onVXISog>?P05ook^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400?ooi^KV6OoVi^H02OoJf][odm?ColS8b?ng]kOoWIfMo`]C[_nU
a>Ko]M3^ogV^k002ojOLo`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00KoWW8D
ojIW0?nEC2WoPd40oheE2_nEE@02oheE2P03ojIb5?n`NaCoWW8:00;o/7/:
00WoYW8Dok1k5?n`NaCo/780ok1k2_nVLP3o/780ojIb0?n`N`X00_n`LP00
1_n3@@3okLMLom>ZAoo:XCgobZ5BolZZA`;obZ4m013o^H@DolZH5?niQ1Co
bYPYol640?niSBWo/7/:ol640?oCV0[obYPDom>H2_niQ1CobZY7okV45?o:
XCgo/8dN0_o:V1@2okV=50;obYPD00SobYPYog]<2_oCZTOoi;=7om>ZAooL
/ecodjY7olZZIP;og:Xc00?obYPDokV=:Oo:V2T00_n`SAh2olZH5006om>H
2_o:V1Cog:XcolZH:OoL/ecodj4Y0_o:V1@03ooCV0[obYPDolZH5?o:XCgo
bZY7olZH:OniSACoYW8DojIW0?mkC1Co;2HDoc@_7_m6@AkoH44YodI17P02
of11:@06ofYE7_mbEE;oUHABok24NonVQ5;o^Hdc0oo:V2T2om>ZA`?og;=L
00?og;>4ooKII_o]d9P00oo]d9P01_nNLQCokKhmombcG?oCZTOog;=Lom>Z
A`?odj4Y00?og:XcolZH5?oT/dL00ooL/e`00ooLZS?og;=LombcG003ombc
G00:ombZ<ooT/dOog:XcombZ<ooCXBWoi;<conBc7_o]_SgoWW8:om>ZA`;o
g;=L00KokLMLombcG?o]ahCoi;<combZ<ooT/dL2om>Q:@0>onBc:OoLZS?o
diP:ok1k2_oL/ecog:XconBcAooT_XCoi;<conBcAoo:XCgoi;<com>Q:Oo]
_Sd2om>Q:@04onBc7_o:V1Cog;=LonBcA`;og;=L013odjY7ombcG?oCZTOo
g;=Lom>ZAoo:XCgog;=LombZ<ooCV0[obYPYokV45?o1Q03o/7/:ok1k5?n3
GQCoLSP00_mZ@@X06_lm70[o4A`:oaX92_l92@[o4A`:o`T92_l94P[o2@T:
oaXB5?mZEAko=5DYob`V5?l92ACo=2lNoa4L2_lJ2@[o4A`:oiiN5?o:V1Co
^H@Dok1k:On`E@3oUEDDoh<_0?l/9QCo8bH:0_lJ2@X00ol92ACo4A`:o`T9
2P02okV=<`0<ongfmOoLhn3odmWFong]j_oLhn3okNgZongfmOn3V8koUJ6>
ol[@`Oo]kN[okOKe0oofool00oo1alcoUJ6>ong]jP1OonKViP04oifMWOng
]kOob<S8om?Cd`7of][J003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfm
oj>SXol;E;7oY<CVokSBk_mf[NX00_n/gol01?m^KVko];Bdon3Ph?o/k>aK
onk^kP04ok1k2_nNGQCoYVL0oheE2P;oPd4000SoSED:ojIW0?nEE@3oYW80
oiib2_n`NaCo/7/:ok1k50;o/7/:0_n`LP008on`N`[oYW80ok1k5?n`N`[o
/780ojIb0?n3@@3og;=LolZQD_oLZS?obZ4mok2=7_o:XCgobYPYokV=5?ni
SC?o^HdDolZH5?o1Q03o^H@Doh=N5?oCXBWo/8dNolZQ?Oo:V2Wo`H@0olZH
5?niSBWobYPDokV=<oo1Q03o^HdcolZH5?o:V2WobYPD00;obYPY01?oWW8D
olZQD_oCZTOodjY7ombcQ?oT/dOodjY7om>Q:OoCZTOobYPDom>ZAoo:ZTOo
bYPYokV=<ooCV0[odj4YolZH5?oCXBWog:Xc00;odjY700?odj4YolZH5?o:
V1@00_o:V1@05?oCXBWobYPYolZQ?Oo:XCgobZYVokV=5?o1Q03o^Hdcog8h
5?m6@Ako=2lYof11:Om6@AkoJVLcoh=N<onNLS?oYXABolZZI_niZVoo/7/Y
0_o:XCd2om>ZA`07onBcAooT_XCog<NSong@V?oL/ecokM2HombcQ002ong@
V00=ongIc?o]d9So^Hdconfn?OoT/dOoi;<com>ZAooL/ecodjY7onBcAooC
ZTOoi;j4olZQDP02ombcG005onBnQ?oL/ecoi;=7onBnQ?oL/e`00ooT/dL0
1OoLZS?oi;=7onBcAooT/akobYPD00;og:Xc00_okKhmok1k2_niSC?okKhm
ombcG?oT/dOokKhmonBnQ?oT/dOoi;<conBcA`02om>Q:@05onBc7_oCXBWo
diP:okUW0?o:V1@00_oL/e`05oo:ZVKodjY7om>Q:OoLZS?oi;=7onBc<omZ
EAkoi;<YolZQ?OoTZP3obYPDolZZI_oT/dOokLN4olZZAonVQ5;om]UVom>Z
AooT/dOodjY7ombZ<ooCZTOog:Xc00;obYPD00Ko^H@Dok1b0?n`NaCoWW8:
og]<5?mkC0X2of11500>odH_2_lA70[o4A`:oa4L2_l92@[o4A`:oaXB5?lA
70[o2A8:of1N<omP@ACo=2lNoa4L2_lJ9Q@3o`T92P05ojIW0?o:V1Co^FL0
oiiN5?nVLQ@00_n=E@X05?lm70[o4BH:oa4L2_lA70[o2A8:oaXB5?lA9QCo
JUDNolZQ?Oo]m_GodmWFom?SmOoLhn3odn?eong]j_ofooGoPiR]ojJHQ?o1
al7og>?F0_o]m_D01Oofoooooooool77c?nVV8CokNgZ05ook^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400?oooooo6Oooool02Oobl_;oj^[ZomkNg_o;
bl_o[jn_o`eD[_nVa^Ko]]3^ogV_kP02oj_No`04ogIfM_o1`L7ol?3`oogm
oE_ooooo00KoWUhDoiib5?nEE@3oSED:oh<h0?nEC2T2oiEE0009oiiN5?nV
LP3oWW8:ok1k2_nVLQCo/780ojIb5?n`N`[oWW8:00;o/78000?o/7/:ojIb
5?n`LP000_n`N`X05On3GQCog;=Lom>Q:Oo:XCgobZY7ombZ<oo:V1Co^HdY
okV45?o:V1Co^HdDol640?niSACoYW80og]10?oT/akobYPDolZH:Oo1Q03o
^HdDolZZA`02olZH:@0<okV45?niSBWodiP:olZH5?o1Q03o/8dNokV=:Oo:
V2WoPg/colZQ?OoLZS?obZ4m0_oL/e`01_oT_XCoi;=7om>ZAooT/dOobZ4m
olZH:@;obYPD00Godj4Yom>ZAoo:V1CobYPDolZH:@02ombZ<`03ombcG?oC
XBWodiP:00?obYPD00koi;<NolZH:OoLZS?obZY7okV4:Oo:V2WobYPDok1k
:OmkC1CoJUDNoh=N<on3Nc?oYXABok2=DP?obZ5B00CobZ4moiib<oo:V2Wo
bZ5B0ooL/e`03?o]ahCog;>4ong@V?o]aecokLN4onBnQ?o]d9Soon>>ombn
[OookHko^IQLombZ<`?og;=L00Woi;<NolZH5?oCXBWodh@0om>Q:Oo:V1Co
djY7ombcG?oT/dL00_oL/e`07_oT/dOog;=LonBcAooL/hCog:XconBZ0?oT
/dOog;=LonBZ0?oCZTOodj4YombZ<ooT/bWo/8@Yok2=7_oT/dOog:XcolZQ
?On`SC?om]24onBcAooL/ecoi;=7onBc<ooLZS?oi;<Yom>Q:OoT/bWo/7/:
om>Q:@;og:Xc01OokLMLonBcAooT/dOog:XcombcG?o:V2WoPehDonBc:OoC
XBWoi;<colZH5?oL/ecokLMLomc7XonNLP[oUG97ong7G?o:XCgoi;=7ombc
G?o:XCgog:Xcom>Q:@02olZH500=ol640?niQ1Co/7/Doiib2_n3GQCoNd40
og]<2_mZ@@[o?A`:oa4L2_l/4P3o2A8:oaXB5002o`T92P0DoaXB5?l0003o
JVLcodIE:OlS9P[o4BHDoa4L2_l92@[o2A8:oa4L2_n3;`3o/7/:olZH:OnN
GQCo/5D0oiEE5?mkC1Co;2HDob`L5?lS70X2oaXB500Aoa4L2_l92ACoLSPD
olZQ?OoLhmKog>?Pom?Ie_o]kN[og>?Fong]j_ofooooUJZ]ohf=Koo1/jgo
dn?eong]j_o]m_D00_ofool00ooLhn3oPhf4ong]jP1Oooooo`04ojn_[oo;
bl_og]kNon[ZjP7ol_;b003oonk^kQWok^k^00WohN7Qom[Jf_o?cloo_Kfm
oj>SXol:DJkoY<?UokSBkomi[^`00_n/gol01?m^KVko];Bdon3Ph?o/k>aK
onk^kP0@oiib5?nNGQCoSED:oheE2_nNGQCoUED0ojI<0?nNGQCoUED0oiiN
5?n`N`[o/8dNok1k5?n`N`[o/7/DojIb50;o/7/:00SoYW8DojIb0?n`N`[o
/7/:ojIb0?n`N`[oPd40ombcG0;obZY700GobZ5BolZH:Oo:XCgo^HdDolZH
5002ok2=7P04olZH5?niSACo/780og]<2P;obYPD00_obZY7olZH:OoCV0[o
djY7ok2=7_o:V2Wo^H@DolZH5?niSACo^H@Dok2=7P02olZH5009olZH:On=
E@[odjY7ombcG?oLZS?odj4Yom>ZAoo:ZVKodjY700;obZ4m0_oLZS<01ooC
V0[obYPDolZH5?oCV0[obYPDokV45?o:XCd00_oCZTL01?oLZS?odj4YolZH
5?niSA@2olZH500Gom>Q:Oo:V1CobZ4molZZI_niQ1CobZ4mom>ZAoniSBWo
^Hdcok2=D_niV5cobZ5Bol6QQ?o:XCgobZY7om>Q:Oo:XE;og;=LoiEE5?o:
V2Wog;=Lom>ZAooL/e`00_oT_X@2ong@V003ombcQ?oC_XkokM2H00CokM2H
01oo/8eBombcG?oT_XCoi;=7ong7G?mZEAkodj4YolZH5?o1Q03odj4YolZH
5?o:XE;oi;<conBcAooL/ecoi;<com>ZAooT/dOog;=LonBcAooT/akodjY7
onBc<oo]aecoWW8:oij=<oo]_Sgoi;<YonBc<oo1Q03oSED:00;okLML00Wo
/8dNok24Noo]aecokLMLonBcAoo]aecoi;<com>Q:OoT/c<00_oLZS<04_ni
LS?odj4YonBc<ooT/dOobZYVonBcAoo:XE;oi;=7ombcG?oT/akoi;<Yom>Q
:OoT/bWodj4YolZH5?oCZTOobZYVong7G0;oi;=700Oog;=LolZH5?oL/eco
dj4YolZQ?OoT/dOog:Xc00;obYPD0_n`N`X03?n`NaCoWW8DoiEE0?mk@@3o
Pd40ofY12_lm70[o4A`:oaX92_l94P[o4A`:o`T92P;o4A`:00Ko2@TDog9W
D_m6;`[o8blNoa4L2_lJ2@X2oa4L2P09o`TB2_mb>1Co^G8cok1k2_nVI`3o
WUhDoh<h0?mkC1Co?A`:00;o8a`:00[o6PT:oaXB5?lA70[o6Q8DocdB2_oC
ZTOo`LO<om?SmOoCfMKog>?P0_oChoD01oo]m_GoUJZ]og^=I_n`_/7og>?F
ong]j_o]m_D00_ofool00oo]m_GoPhf4omcSh01Oonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?Cdoo8b<So]kNgoifM
WOl=E:koYLCVokKBk_mi[^T00_nZh?l01?mZJV[o[Zj^omSHf?oTi>AKonKV
iP04ojIb5?nNLQCoUEDDoheE2P;oPcP000_oSED:ojI<0?nEEACoYVL0ojIb
5?n`NbWo^H@DojIb0?n`N`[o/780ok1k2P02ok1b000:oiib2_n`LP3o/7/D
ok1b0?n`N`[oSED:onBc:OoLZS?obZ4mombZ<`;obZ4m00So^HdYok2=7_o:
V1Co^HdcolZH5?o:V2Wo^FL0oiib50;obYPD00OobYPYokV=:On`SAko/8dN
okV=<oo:V2Wo/8dN00;obYPY00oo`H@0olZH:OniSBWo^HdDok2=7_n3Nc?o
^HdYom>ZAooCXBWodjY7ombZ<ooCXBWog:XconBc7_o:V2T00_oCZTL02OoC
XBWobYPYom>H2_oLZS?odj4YolZH:OoCXBWodjY7olZQ?@03olZH:@0;olZH
5?oLZS?odiP:om>Q:Oo:V2WobZ4mombZ<oniQ1CobYPDombcG?oLZS<00_oC
ZTL01?o:XCgobZ5Bom>Q:Oo:XCd2om>Q:@05onBnQ?oC_XkobZYVom>ZAoo:
V2T00_oLZS<02?oL/ecoi;j4ong@V?oT_XCokLMLodH_2_oL/hCokMW<0oo]
d9P01_o:ZTOokLMLombcG?oL/ecokLMLoh=N<`Godj4Y00Gog;=LonBnQ?oL
/ecog;=Lom>ZA`02onBc<`0@onBcAooCZTOoi;=7onBc7_oT/dOokKhmoiEE
5?niQ1CodjY7olZH5?oL/ecobYPYoiEE5?ofd8Coi;=7ombZ<`;okLML01Wo
i;=7ong7G?oT/dOokLMLom>Q:OoT/dOoi:X0olZH5?oCQ03o^H@Dom>Q:Oo:
XCgoi;<combcG?oCZTOoi;<com>ZAooCV0[odj4YonBc<oo:V1Coi;<NolZH
5?niSC?okLML00Cog;=L00Ko^HdconBc<oo:XCgodj4YolZQ?OoLZS<2om>Q
:@0>ol640?niQ1Co/8dNoiib2_n=E@[oJT4:oh=N5?mZ@@[oARH:ob`B0?lA
70[o;180o`T92_lA70X2oaX92P04o`000?mP@BWoAT4Nob`V50;o4A`:00Oo
6PT:oa4L2_l92ACoEa`0olZH5?n`N`[o/7/D00;oSED:00?oNd`:ob`L5?l/
9Q@01?lA70X01?lA9QCo6PT:onBcAoo1/jd3omcSh0;okNgZ00OokOKeok2n
`OmkSHCo/;>gol[@e_o]kN[okOKe00;om_oo00?okNgZoh>4Noo]kNX0GooV
i^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00ooo^k^hIonk^kP09on7QhOoJ
f][oclo?okfm_OnSXj?o2e>^ojK6i_nidnkoNJk[00;oZmoo00CoKVi^okBd
]?oPh>3ok>c/Foo^k^h00onVLQCoWW8DoiiN5002oheE2P04oh=10?mkC1Co
UED0oheE2P;oYW8D00?o/7/Doiib2_n`NbT00_n`N`X00onVLP3o/7/:ojIW
0002ok1b000BojIW0?n`N`[o/7/:oh=10?oC_Xkog:XcolZH:Oo:ZTOobYPD
olZQ?Oo:V1Co^HdcolZH:Oo:V1Co^Hdcom>ZAon`NaCo/7/:0_o:V2T02_oC
XBWo/8dNokV=:Oo:V2Wo/8dNolZZAoniSBWobYPYolZH5?niSA@4olZH5008
oh=N5?o:XCgog:Xcom>Q:Oo:V1CodjY7ombZ<oo:V1@2olZQ?@0=olZH:OoT
/dOodj4YolZQ?OoCV0[obYPYom>ZAoo:XCgo^HdYolZQ?OoLZS?obYPDom>Q
:@03olZH500?of11:OoCXBWobYPDolZH:Oo:XCgo^H@Dom>Q:Oo:V2Wodj4Y
onBc<on3GS?o^IQLolZQ?OoLZS?obYPD00?odjY700Goi;=7ombcG?oCZTOo
djY7ombZ<`02ombcG005onBnQ?o]ahCokM2HonBnQ?o]ae`01Oo]d9P00oo:
XCgobZYVombcG002ombcG008onBc<oo:V1Cog:XcombZ<ooCXBWog;=Lom>Z
AooL/e`2onBcA`0;ombcG?o:ZVKog:XcombZ<ooT/c?odjY7onBc<ooCZTOo
i;=7ong7G?oLZS<00_oCXBT03ooLZS?odj4Yoh=N5?o]_Sgoi;=7ombZ<oo]
ahCog;=LonBcAooT/c?oi;=7onfn?OoT/c?odj4YonBc7P02om>Q:@06om>4
0?oCXBWokKhmom>ZAooT/dOodjY70_oT/dL01ooCXBWodiP:ombZ<ooTZP3o
bZ4mom>Q:On`SC<00_o]ae`01_oCZTOog;=Long7G?o:XCgoi;=7olZQDP;o
g:Xc02?obZ4mom>H2_o:V1Co^HdDok1k2_nVLQCoWW8:oiEE0?mb>1CoLSP0
ofY12_m6;`[o4A`:ob<L2_l94P[o6Q8Do`T92_lA70[o2@TDoa4L2_mPGS?o
AT4Nob<_7_lJ2@[o4A`:oaX92_l92@[o4A`:ob`L5?nNGQCo^FL0ok1k2_nV
C03oUEDDog]<2P02ocdL2P03ob<L2_lA70[o6Q8D00;o6Q8D01Co6PT:ooKI
I_oL/j?okNgZom?Ie_oLhn3odn?eong]j_o]m_Go`LO<og^=I_o1/jgob]3F
ong]j_o]m_Gom_ooooKomOooooooJW]_ongfmEook^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN400?oooooo6Oooool02Oobl_;oj^[ZomkNg_o;bl_o[jn_
o`mF[onS`^Co^=?_ogN^j`02oj[Oo`04ogIfM_o1`L7ol?3`oogmoE_ooooo
0_nVLQ@05?nEEACoSED:oh<h0?n=E@[oPd40oiib2_nNGQCoYVL0oiib2_n`
NaCo/7/:ok1k5?n`N`[o/780ok1k2_nVLP3o/7/Dok1b0?nNLP[o/7800_nN
LPX02?n3@@3og:XcombcG?oLZS?obZ4mombZ<on`SAko^HdD0_niSBT02Oo:
V1Co`H@0olZQ?OniSACoYW8DolZQ?OoL/ecobYPYokV=:@02olZQ?@03okV=
5?o:XCgo^H@D00;obYPD00?odiP:ok2=7_o:V2T00_o1Q0003?nNLQCobZ5B
ombcG?o:XCgodjY7onBcAooL/hCodjY7ombZ<oo:ZTOog:Xcom>ZA`;obYPY
00GobYPDom>H2_o:V2WobYPYolZH5002olZQ?@;obYPY00Codj4Yom>H2_o:
V1CoUG970_o:V1@01Oo]_SgobYPDokV=5?oCXBWog:Xc00?odj4Y00CobYPD
om>Q:OoCV0[odj4Y0_oLZS<02_oCZTOog;=LonBnQ?oT/dOodjY7ombZ<ooT
/dOog;=Long@V?oLaj<2ong7Q00=onBnQ?o]d9SokM2Hong@V?o]fLcoonf>
olZZI_oCZTOoi;=7onfn?OoL/ecodjY7ombZ<`02ombcG00PonBnQ?oL/hCo
djY7onBc<ooL/ecoi;=7ombZ<ooT/bWog:XconBcAooT/akodj4YonBc<ooC
ZTOoi;<conBcAoo:V1Codj4YonBc:OoLZS?obYPDoiEE5?ofd8Coi;<com>Z
AooL/ecoi;=7onBc<ooT/dOoi;<conBcAoo:ZVH2onBc:@07olZH5?oCQ03o
bZ4monBc:Oo:XE;oi;=7om>ZA`02onBcA`05om>ZAooT/akobYPDonBc<ooC
XBT00_o:V1@00oniSC?okLMLomc7X`03ombcG0;odjY700Oog;=LolZH5?oL
ZS?odjY7olZH:Oo:V1Co`H@000;o/7/:00WoWW8:oh=N5?mb>03oNd`Dog8V
0?lm70[o8a`:oa4L2_lJ2@X00_lA70X01_l92@[o4BHDo`T92_m6@Ako=2lN
ob<V2P;o4A`:00So2@T:o`T95?lJ2@[o;1`DojIb5?o1Q03oYW8DoheE2P;o
Nd`D00coARH:ob`V5?lA70[o6PT:oa4V5?lJ4QCo2A8:o`000?oohhkog<NS
ongfmOo:d=H2omcSh009ong]j_oChoGo`LO<og^=Q?o1/jgob]3Fong]j_o]
m_Gom_oe00;om_oo00?oPg]Long]j_ooool0G_ooool01?n_[joobl_;omkN
g_oZj^X1oo;blP00ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o
3eF_ojG4i_nidnooMjk[00;oZMco00CoKVi^okBd]?oPh>3ok>c/Foo^k^h0
2?nVLQCoWW8DoiEE0?n=E@[oNd`:og]<5?nEE@3oSED:0_nEE@02ok1k2P06
oiib2_n`LP3oWW8:ok1k2_n`LP3o/7/:0on`LP001OnVLP3o/7/:ok1k5?n3
@@3og:Xc00;obZ4m01OobYPYolZQD_niSC?o/8@YolZH5?n`SAkobYPYokV4
5?o:V1Co^H@Dol640?o:XCgobYPYolZQ?Oo1Q03o^HdcolZQ?Oo:V2WobZY7
okV45?oCXBWoAUDYolZH:@03olZH5009ok2=7_nVLQCobZ5BonBnQ?oL/eco
i;j4olZQ?OldEBWokKhm00?og:Xc00OobZY7om>Q:OoCV0[obZ4molZH5?o:
V2WobZ4m00;obYPY00Cog:Xcom>Q:OoCXBWodiP:0oo:V1@04?oLZS?odiP:
olZH5?oT/bWo/7/DolZH5?oCZTOodj4YombZ<oo:XCgodj4YolZQ?OoCXBWo
diP:olZH:OoCXBT4ombcG005onBcAooLZS?og:XcombcG?oT_X@00_o]d9P0
0ooC_Xkoi;j4ong@V003ong@V00:ongIc?o:ZVKoi;=7ombcQ?oLZS?oi;j4
ombZ<ooL/ecog;>4ombcG0;odj4Y00KobYPDolZQD_oT/dOoi;<com>ZAoo:
XCd2onBc<`03olZQ?OoLZS?odj4Y00;oi;<c00?og:Xcom>Q:OoLZS<00_oL
ZS<01ooCXBWoPehDong7G?oLZS?og;=LonBcAooL/e`00_oT/c<05ooT/bWo
kLMLonBc<ooT/c?odj4YolZH5?oCV0[odh@0okV=<oo:XCgog;=LonBcAooL
/ecokLMLom>ZAooCXBWobYPDonBc:OoCXBWodiP:onBc7_nNGQCokLML00?o
g;=L00CodjY7ombZ<ooT/dOodjY70ooCXBT02oo:V1Co`H@0okV=5?n`LP3o
/7/:ojIb0?nNLP[oLSP0og]10?mZ@@[oARl:00?o4A`:00?o6PT:o`T95?lJ
4Q@00_l92@X00ol/9QCo;4`Yob`V5002oa4L2P0Fo`T92_lA70[o4A`:oaX9
2_n`E@3o/7/Doiib2_nVC03oNd`Doh<h0?m69QCo;1`Dob<L2_lA70[o6Q8D
o`TB2_lJ4QCo0000ong@V?oC_Xkog>?Pom?IeP?og>?P00cokOKeomcSh?mb
SHCoYZZSol[@`OoLhn3okOKeooKoooofooGom_ooog:=G?o]kNYOonk^kP04
oj>SXonm_Kgoclo?om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?Cdoo8
b<So]kNgoifMWOl;E;7oY<CVokWCkomf[NX00_n[h?l01?mZJV[o[Zj^omSH
f?oTi>AKonKViP;oYW8D00?oWUhDoheE2_nEC2T00_mkC0X2oiEE0008oiiN
5?nVLP3oYW8Dok1k2_nNLP[o/7/:ok1b0?nNLPX2ok1b0007oiib2_nVLP3o
YW80ojIb0?nVLQCoUED0olZH:@03olZQ?@0EombZ<oniSACo`H@0ok2=7_o1
Q03o/8dNokV=5?o:V1Co/7/:ok1b0?o:V1CobYPYolZQ?Oo1Q03o^HdcolZZ
Aoo:V2WobZY7ok2=7_o:XCgoH2lD00?obYPD00oodiP:olZH5?n`SAko^Hdc
omc7XooCZTOog;=Lom>ZAonNLQCodjY7ombZ<oo:ZTOoi;<Nom>Q:OoLZS<0
0oo:V1@01OoCXBWobYPYolZH5?o:V1CobZ5B00?odj4Y00WodiP:olZH5?o:
V1CodiP:om>ZAoo:V1CobZ4mok1k2_oLZS<00_oCXBT00ooLZS?odjY7olZH
5002om>Q:@;obYPD00?odiP:om>ZAooL/e`00_oL/e`02Oo:V1CodjY7onBc
AooL/ecoi;j4ong7Q?o]d9SokLMLonBnQ005ong@V009ombcQ?oLZS?odjY7
onBc7_oL/ecodjY7ombcG?oLZS?obYPD00;odj4Y00GodjY7onBc<oo:XCgo
bZ4monBc7P02ombZ<`05onBc<ooLZS?oi;=7onBc<ooCZTL00_oT/bT02ooL
ZS?odj4YombZ<ooT/c?oi:X0oheE2_o]aecoi;<conBcAoo]_SgodjY700;o
i;<c00[oi;=7olZQ?OoT/c?odj4YonBc7_o:V1Co/7/:om>40?o:V1Codj4Y
0ooT/dL02oo]ahCog:Xcom>Q:OoCV0[oi;<NolZH5?oTZP3obYPDojIW0?o]
aecoi;=700;og;=L0_oCZTL04_o:XCgodjY7om>Q:Oo:XCgodj4YolZH5?oC
V0[o^H@Dok1k2_nVLP3oWW8:oheE2_mb>03oNd`:ofY12_m6;`[o8a`:ob`B
00?o4A`:00Ko2@T:oa4L2_l92@[o=2lNodHV5?lS;ah3oa4L2P0Do`TB2_l9
2@[o6Q8DoheE2_n`NaCoYVL0oheE2_mk@@3oNd`:ocdB2_lS9P[o8a`:oaXB
5?l94P[o6Q8Doa4L2_l0003okLMLonBnQ?oLhn02om?IeP08omcSh?oChoGo
kNgZomcSh?n=V8koYZ6Hol[@e_oLhn02ongfm@04ooKomOooooooSHeBong]
jUooi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00?ook^k^6Oo^k^h02OoQ
hN7of][Jolo?conm_KgoXj>So`]C[_nUa>Ko]M3^ogV^k002ojOLo`04ofi^
K_nd];Coh>3Ponc/k5_ok^k^013oYW8Doiib5?n=E@[oSED:og]<2_n3@@3o
LSP0oheE2_nEEACoYT`0ojIb5?n`NaCo/7/:oiib2_n`LP3oWW8:0_n`LP00
1onVLP3o/7/:ojIb0?nVLQCo/780ojIb0?n=E@X00_o:V2T2ombZ<`04oh=N
5?mZIc?o/8dNok2=7P;o^HdD02_o`H@0okV=<oniQ1Co`H@0okV=5?oLZS?o
bYPYol640?o:XCgodjY7ok2=7_oLZS?o/7/:olZH:Oo1Q03o^HdDolZH5?o:
V2Wo^H@DolZQD_niQ2Wo/8dcong7G?oL/ecodjY7ombcG?oT/dOobZ4molZH
5?oCZTOobZ4mombZ<ooCZTOodiP:om>Q:Oo:V2WobYPDolZH:OniQ2Wodj4Y
olZH:OoLZS?odj4Y00;obYPD0ooCV0X2olZH:@06ombcG?niSBWobYPDom>Z
AooLZS?odjY70ooCXBT2olZH5003om>H2_o:V1Codj4Y00;og;=L00[odjY7
ombZ<ooT/dOoi;=7ombcG?oT_XCog<NSonBnQ?o]d9SokLML1Oo]d9P01_oL
/hCog:Xcom>ZAooCZTOog;=LombZ<`?odj4Y00CobYPDom>H2_niSC?odjY7
0_oLZS<01_oCXBWoi;<YombZ<ooT/akoi;<YolZQ?@;oi;<c00?oi;=7ombZ
<ooLZS<00_oT/ah02_o:XCgoi;<NojIb0?o]aecodjY7ombZ<ooT/dOoi;<Y
onBcAoo:V1@2onBc<`0>onfn?OoCV0[og:XcolZH5?oCQ03o/7/:om>Q:Oo:
XCgoi;=7olZZI_oL/ecokLMLombZ<ooCXBT2olZH500ConBc7_o:V1CobYPD
ojIb5?ofd8CokLN4onBcAooT_XCoi;=7ombcG?oCXBWoi;<cokV=:OoLZS?o
bYPYolZH5?o1Q03odiP:ok1b0002ok1k2P0:oiiN5?mkC0[oNd`DofY12_mP
;`[o4BH:ob<L2_lJ2@[o2@TDoaX92P;o4A`:00Go2@T:ob`V5?m6@Ako8blN
o`T95002oa4L2P0;o`TB2_lA70[o2A8:og8h5?nVI`3oSED:ojI10?mkC1Co
PcP0ob`V5?l/71@00_lA70X02Ol94P[o6Q8Doa4V5?l0003og;=LonBnQ?oL
hmKodn?eom?IeP02omcSh007ong]j_oLhn3oPhAkoiFQS_o:d=Kog>?Pooo]
c003ooKom@03ohf=D_o]kN[ok^k^05kok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400?oooooo6Oooool02Oobl_;oj^[ZomkNg_o;bl_o[jn_o`]D/OnT
a>Ko^=;^ogJ]jP02ojcOo`04ogIfM_o1`L7ol?3`oogmoE_ooooo027oWW8D
oiiN5?nEEACoUED0oh<h0?n3@@3oNd`DoheE2_nEE@3oSED:ok1k5?nVLQCo
/7/DojIW0?n`N`[oYW80oiib2_n`N`[oYW80oiEE0?l/>2WoYW8DojIb0?n`
N`[oPd40om>Q:Oo:ZTOobYPDolZH:On`SAkoWXdYokV45?o:V1@00_niSA@0
3oniQ1Co^HdDokV45?n`LP3o/7/Dom>H2_n`SAko^HdcolZH5?o:ZTOobYPY
olZQ?OniQ1CobYPYokV45002olZH:@06om>H2_n`SAkobYPDok2=<onNSC?o
i;j40_oL/e`03?oCZTOodj4Yom>ZAooLZS?obYPDolZQD_oCXBWog:XcolZH
5?oCZTOobYPDonBc:@;obYPD00?obYPYolZH5?oLZS<00_oCXBT00oo:V1Co
dj4Yom>Q:@03om>Q:@03om>ZAoniQ1Codj4Y00;og:Xc00Koi;=7ombZ<ooC
XBWodj4Yom>H2_n`SAh3olZH:@09om>ZAooL/hCog;=LombcG?oT_XCog;=L
onBcAooT_XCokM2H00?oi;j41Oo]d9P02OoC_XkodjY7ombZ<ooCZTOog;=L
ombZ<ooCXBWodjY7om>Q:@03olZH500<om>ZAooLZS?og:XcombZ<ooCXBWo
g:XconBc<oo:XE;oi;<conBc7_o:XCgokKhm0_oLZS<05ooCXBWog:XconBc
7_oT/akoSED:ombcG?oTZP3og:XconBc<ooLZS?oi;=7ombZ<ooT/c?obYPD
onBc:Oo:V1Coi;<Yom>40?o1Q03o^FL0olZH:Oo:XCgokLML00;oi;=700Go
g;=LolZQ?OoLZS?odiP:onBZ0002olZH5005om>H2_nNGQCokLN4ombcG?o:
ZVH00_oL/e`01?oT/dOobZ4mom>ZAoo:V1@2om>Q:@08olZH:OoCV0[o^H@D
ok1b0?n`N`[oYW8DoiEE5?mk@@02og8h0005odHV5?l/4P3o4BH:o`TB2_lA
70X00ol92@X01?l94P[o6RHDoc@_7_lS9PX2oa4L2P06o`T92_l94P[o6PT:
oaXB5?mG703oYW8D0_n=E@X03_mkC0[oLSP0ob`V5?lS9P[o8a`:oa4L2_lJ
2@[o4A`:oaXB5?l92@[obZY7olZZI_o:d<7odmWF0ooLhn001_o]m_Gog>?P
oh>=Q?n=SFoo`LO<omcSeP;om_oe00Cog>?Fol[@`OldEBWokNgZGoooool0
1?n_[joobl_;omkNg_oZj^X1oo;blP00ooo^k^hIonk^kP09on7QhOoJf][o
clo?okfm_OnSXj?o3EB^ojK6i_nfd>koNJo^00;oZmko00CoKVi^okBd]?oP
h>3ok>c/Foo^k^h01?nVLQCoWW8Doiib2_nVI`02og]<5004oiEE0?n3@@3o
Nd`DoiiN50;oYW8D00GoYW80oiiN5?nVLP3oWW8:ok1b0002ojIW000;ok1b
0?nEE@3oYW80ok1k2_nVLP3oPehDolZH:Oo:ZTOobZ4molZZAoo:XCd00oni
SBT04OniQ1Co^HdDokV45?o:V1Co^H@Dok1b0?niSACo/8@Yok2=7_o1Q03o
^HdcokVHG?n`SAkodj4YokV45?o:XCgo^H@D00?obYPD00Go`H@0ok2=7_n`
Q2WoYXABong7G002ombcG0;odjY700?odj4YolZH:Oo:XCd00_oLZS<03?o:
V2WobYPDolZH5?o:V1Coi;=7olZH5?n`SAkobYPDolZQ?OoCZTOog:Xcom>Q
:@?obYPD00OodiP:olZH5?o:V2WodjY7ok2=7_o:XCgobYPD00;odj4Y013o
bZ4mom>Q:Oo:V1Co^H@Dol640?nNLS?o^H@Yom>Q:OoCZTOog;=Lom>ZAooC
XBWobZ4mombcG?oT/dOodkj>0_oT_X@00oo]d9Sog;>4ong@V002ong@V00:
ong7Q?o]d9SokM2HolZH5?oT_XCog;=LolZZI_oCXBWog;=Lom>ZA`Godj4Y
00SobYPDonBcAooLZS?odj4YombZ<ooT/c?og:Xcom>ZA`?oi;<c00?oi;<Y
ombZ<ooLZS<00_oLZS<03?oT/bWo/7/:onBcAooT/dOog;=LonBc<ooCZTOo
i;=7onBc<ooT/bWodiP:onBc7P?obYPD00[o/7/:om>40?oCQ03og:Xcom>Z
AooL/ecoi;=7om>ZAooLZS?odiP:0oo:V1@01_oCQ03odiP:ojIW0?oT_XCo
kLMLonBnQ0Cog;=L00?odjY7olZH5?oCXBT00_oCXBT01oniI`3o^HdDok1b
0?n`N`[oYW8Doh=N5?mZ@@X00_mkC0X09?mG703o8bH:ob<L2_lJ2@[o4A`:
o`T92_l94P[o4A`:oaX92_lS70[o=2lNob<V2_lA70[o6PT:oa4L2_l92@[o
4A`:o`T92_lm4P[oYW8Doh=10?mkC1CoLSP0og8h5?lm4P[o8a`:oa4L2_lJ
2@[o2A8:oa4L2_lJ2@[o0000oiiN5?o]d9Sog;>Sol[@eP;odmWF0_oLhmH0
2?oTd<co`K>>ofYW<onEXHkoYZ6Hog^=Q?lmGSgo2A8:0_l000000oofoooo
k^k^onk^kP1Monk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003oonKViQWo
i^KV00Wof][Jom?Cdoo8b<So]kNgoifMWOl:DJkoY<?UokSBkomi[^`00_n/
gol01?mZJV[o[Zj^omSHf?oTi>AKonKViP06oiib5?nVC03oSED:oiiN5?mk
C1CoLSPD0on=E@X02onEE@3o/7/:oiib2_n`SC?oWW8:ok1b0?nNLP[oYW80
oiib2_nVI`3oWW8:00;oYVL000Go/780oiib2_nNLP[obZ4mom>Q:@04olZQ
?@;o^HdY0_niQ1@04?n`LP3o^HdDol640?n`LP3o/7/Dol640?n`SAko^H@D
om>H2_o:XE;obYPDolZQ?OniI`3obYPYolZH5?niSC<3olZH5007okV=<oni
Q1CoWXdYombcG?oT_XCog;=LonBcA`02om>ZA`;og:Xc00?obYPYom>ZAooC
XBT01Oo:V1@01OniSBWobYPYom>Q:OoCZTOog:Xc00;odj4Y00_oi:X0olZH
5?o:V2WobYPDom>H2_o:V1CoYW8DolZH5?n`N`[o^H@DolZH5002ol640007
ok2=7_n`LP3oYT`0oheE2_o1Q03obZ4mom>ZA`02om>Q:@03olZH5?oCXBWo
g;=L00;og;=L00CokM2HonBnQ?o]d9Som]UV0oo]d9P03oo]fLcokM2Hombc
Q?oCZTOobZYVom>Q:OoT/dOog:Xcom>Q:OoLZS?odj4YokV=<ooCQ03obYPD
om>H2P04ombZ<`0:onBc<ooL/ecog:XcombZ<oo:XCgodj4YonBc:OoLZS?o
i;<conBZ00;og:Xc013oi;<NojIb0?oL/ecog:XconBcAooCZTOoi;<conBc
Aoo:XCgoi;<com>Q:OoT/c?odj4YombZ<ooCQ03o`H@00_n`N`X01OoCXBWo
i;<com>ZAooL/ecodjY700;odj4Y0oo:V1@2om>H2P04ok1b0?oL/ecog;=L
onBc<`?oi;=700WodjY7ombcG?oCXBWobYPYom>Q:OoCZTOodiP:ol640?n`
LP000onNLPX01?mb>03oJT4:og8h5?m6;`X2ob<L2P03o`T92_lA70[o2A8:
00;o2@T:00Oo4A`:oaX92_m6@Ako8blNoa4L2_l92@[o4A`:00;o2@T:01Wo
6PT:oaXB5?nVC03oLSP0of0_2_m69P[oH2l:ocdL2_lA70[o6PT:oa4L2_lJ
4QCo2@T:oa4L2_l92@[oEa`0onBc:OnVXFKog>?Pol[@`OoLhmKodmWFol6c
[OnEXHko?Ehm00Go000000Co4A`:oaXB5?l0003om_KeGooVi^H01?nMWIgo
]kNgolS8b?oCdm<1om[JfP00ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm
_OnSXj?o3EB^ojG4i_nfd^koNJkY00;oZ^3o00CoKVi^okBd]?oPh>3ok>c/
Foo^k^h2oiib2P05og8h5?n3@@3oLSP0og]<5?nEE@000_n=E@X01_nEE@3o
WW8:ojIb0?n`NaCoUED0ojIb00;oYVL000?oYW80ojIW0?nVLP000_n`Na@0
2?nNLP[oWW8DoiEE0?oL/ecobZ4mom>ZAoo:XE;obZ4m0_o:V1@02?niSACo
/8dNokV=5?n`N`[o^HdDokV45?o1Q03o^H@D0oniSA@03_o:V2WobZ4mokV=
5?niV5co/8dNolZH:OniSBWobYPDolZH:Oo:V1CodiP:olZH5?niSBWoSHe7
0_oL/e`04OoL/hCobZYVom>ZAooL/ecobZ4monfn?Oo:XCgog:Xcom>Q:Oni
SACobYPDom>H2_o:V1CobYPYolZH5?o:V2WodjY700;og:Xc00CobYPDom>H
2_o:V1CodiP:0oo:V1@03_oLZS?obYPYolZH:Oo:V2Wo/8dNokV45?o1Q03o
^HdDol640?n`E@3oPcP0okV45?niSACobYPD0_oCXBT01?oCZTOobZ4mombZ
<ooT/dL2ombcG006ong7G?oT_XCokM2HonBnQ?o]d9Sog<NS0oo]d9P01_oL
aj?obYPYonBcAooCZTOoi;=7om>Q:@;og:Xc00Goi;<YolZH5?n`N`[obYPD
om>Q:@02ombZ<`0:ombcG?o:XCgog:XcombZ<ooTZP3og:XconBc7_oT/c?o
djY7onBZ00;og:Xc00Sog;=LonBc:OoLZS?o/7/:ombZ<ooCZTOoi;<colZQ
?@;oi;=700?odjY7onBc<oo:V1@00_oCXBT02?o:V1CobZ4mom>H2_niI`3o
`H@0olZH5?oCZTOog:Xc0_oT/dL01?oCV0[obYPDolZH5?oCV0X2om>40005
olZH5?n`N`[obZ4mombcG?o]ah@00_oL/e`04OoT/dOog:XcombZ<ooLZS?o
dj4Yom>H2_o:V1Co^H@DokV=5?niI`3oWW8:ok1k2_n=E@[oNd`:og8h0?mk
@@3oEa`000;o8a`:00Co4A`:oaX92_lA70[o2@T:0_l94PX00olA70[o;2HD
ob`V5002oa4L2P;o2@T:00So4A`:oaX92_l92@[oSED:oh<_0?mP;`[oH2lD
oeLL00;o8a`:00?o6Q8DoaX92_lA70X00_l92@X02?lA70[o2@T:ob`B0?ld
;akoSHe_og:=G?lA9QCo4BH:0_l000002_l92@[o4A`:o`T95?l94P[o6Q8D
oa4V5?lJ71ko6PT:o`000?ofoomOonk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q003ooooooaWooooo00Wol_;bon[Zj_oNg]kobl_;ojn_[ol;DjkoY/KV
okWCk_mi[^/00_n[gol01?mfMWKo`L71oo3`l?omoOeKooooo`;oYW8D00_o
SED:og]<2_n3@@3oPd40oiEE0?n3>03oUEhcoiEE0?n=E@[oYT`0ojIb5002
oiEE0006ojI<0?nVLP3oYVL0ojIW0?n`N`[oWW8:0_nVLP000onNLP[oWW8D
olZZA`02olZZA`09om>ZAoo:ZTOobYPYokV=:OniSACo`H@0okV45?n`N`[o
bYPD00;o^H@D01Co^FL0olZH5?niQ1Co^HdDokV=<oo:ZVKo`H@0ombZ<on`
SC?o/8dNolZH:Oo:V1Co^HdYolZH5?o1Q03o/8dNokV=:On3Nc?okLMLombc
Q0?og;=L0_oCZTL00ooCXBWog:XcombZ<`03olZH500:olZH:OoCXBWobYPD
okV=:On`SAkobZ4mom>Q:OoL/ecog:XconBZ00;obYPD00Kodj4YolZH5?o:
XCgodj4YokV4:Oo:XCd2olZH:@09olZH5?oCXBWobYPDol640?n`E@3oYW8D
oiEE5?nNLP[og:Xc00;odjY700[obYPYombZ<ooCZTOog:XcombcG?oT_XCo
g;>4onBnQ?o]d9Soi;j41_o]d9P03Oo:V1Cog;=Lom>Q:OoL/ecodj4YombZ
<ooCXBWobYPDolZQ?Oo:V1Codj4Yom>ZAooCXBT01ooLZS<00ooT/bWobZ4m
onBc<`05ombZ<`08om>Q:OniSACobYPYom>ZAooT/dOoi;<combcG?oT/dL2
ombZ<`06om>Q:OoT/bWodj4YonBZ0?oCV0[odj4Y0_o1Q0006OniQ1CobZ4m
onBc<oo:XE;og;=LolZQ?OoCXBWobYPDol640?oCXBWobYPDom>H2_o1Q03o
^HdconBcAooL/ecokLN4ong7G?o:ZVKoi;=7olZQD_oCXBWo/8dNom>Q:Oo:
V1@00_o1Q0007on`LP3oYW80oiib2_n=E@[oNd`:og8h0?mZ@@[oARl:ob<V
2_lS70[o6PT:o`T92_lJ2@[o2A8:o`T92_lA70[o2@T:odI17_lS;ako4A`:
o`TB2_lA70[o2@TDoa4L2_l92@[o4A`:ojI<0?mkC0[oLRH0oeLL0?mP;`X0
0_lS70X02Olm;cgo2@T:oaX92_l92@[o4A`:o`T92_lA70[o2A8:o`T95003
o`0000;o6Q8D00?o2@T:oa4V5?lJ2@X01?lJ4Q@01?lA70[o6Q8Do`000?of
oomOooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b003oonk^kQWok^k^00Wo
hN7Qom[Jf_o?cloo_Kfmoj>SXol?EZooXl;TokSCkomg[^/00_nZgol01?m^
KVko];Bdon3Ph?o/k>aKonk^kP04ok2=7_nVLQCoUED0oheE2P?oPd4000go
SED:oiEE0?n3@@3oUED0oheE2_nVI`3oSED:ok1E0?nEE@3oYW80oiEE0?nV
I`3o/78000;oYW800_nNLPX03?n=E@[obZ5BombZ<oo:XCgobZ5Bom>ZAoo:
V2WobYPDokV=5?niQ1Co^HdDokV450;o^HdD00ko`H@0ok1k2_niSACo^H@D
olZH5?o:V2WodjY7okV45?o:V2Wo/8@Yok2=7_o:V2Wo^HdDolZH50;o`H@0
00[o/8dNokV=:OnNSBWodkj>ombcQ?oC_Xkog;=Lom>ZAooL/ecodjY70_o:
XCd04?oLZS?obYPYolZH5?o:V1CodiP:olZH5?o:V2WodiP:olZH:Oo:ZTOo
i;=7om>ZAoo:V1Codj4YolZH5?oCV0X3olZH5004olZZAoniSBWobZ4molZH
50;odj4Y00WodjY7om>H2_oCXBWoYW8Dog]<5?nNGQCo/8@Yom>ZAooL/e`0
0_oCZTL2ombZ<`03onBcAooL/ecog;=L00?okM2H00?okLMLombn[Oo]d9P0
0_o]d9P02OoLaj?okM2HokV=:OoL/ecodj4YombZ<ooCZTOoi;<combZ<`02
om>Q:@06olZH5?oLZS?o^FL0ombcG?oT/c?og:Xc0_oCXBT04_oT/bWog:Xc
ombZ<ooT/dOodjY7onBc<ooLZS?oi;<combZ<ooL/ecog:XconBc7_oCV0[o
/8@YonBc<ooLZS?obZ4mombcG0;oi;=700Goi;<YombZ<ooCXBWodj4Yom>H
2P02olZH5009om>H2_niI`3obYPYolZQ?Oo:V1Coi;<combcG?oCZTOodj4Y
00;obYPD00_oi;=7onBc7_oCQ03obYPDolZH:OoL/ecog:XcolZQD_o:XCgo
kKhmonBcA`02ombZ<`;odj4Y00CobYPDom>H2_n`N`[o`H@00_nVLP001Omb
>1CoNd`:ofY12_mb>03oARl:00;o8a`:0_lA70X00ol0003o2@T:oa4L2P02
o`T92P0@odIE:Om6;`[o6Q8Doa4V5?l92@[o4A`:o`000?lJ4QCo2@T:ojI<
0?mP;aCoSED:ocdB2_mP;`[o6PT:ob`B00;o4A`:0_l92@X02_l94P[o2@T:
o`T92_l94P[o4A`:o`T95?l94P[o6Q8Do`T92_lJ9Q@2oaXB5004o`T92_l9
2ACo6Q8Doa4L2P;o4BHN00?o6Q8Do`000?ofool0Goo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@00oooVi^HIonKViP09om[Jf_oCdm?ob<S8okNg]onM
WIgo3eF_ojG4i_nidnooMjk[00;oZMco00CoJVYZojj^[_oHf=Soi>CTFooV
i^H01?nVLQCo/7/YoheE2_n=E@X2oh=10005oheE2_n3@@3oSED:oh<h0?n3
@@000on=E@X02?nEE@3oWUhDojIW0?nEE@3oYVL0ojIb0?n`N`[oYW800_n`
N`X01_nNLQCog:XcolZQ?Oo:V2WobYPDom>ZA`;o^Hdc0_n`SAh01OniSACo
/7/DolZH5?n`N`[o`H@000;o^H@D01?o^HdDok2=7_o:V2WobZ5Bok24:Oo:
V1Co^H@DokV=5?o1Q03obYPDokV=5?o:V1CodiP:okV=5?n`SAkoPehDonBn
Q?oL/ecodkj>00?og;=L00?odjY7olZH5?o:XE800_o:XCd2olZH5007om>Q
:Oo:V1CobYPDokV=:Oo:V1CobZ5BombcG002om>ZA`;odiP:00?odj4YolZH
5?o:V1@00_o:V1@03oniSACobYPYolZH:Oo:V2Wog:Xcom>ZAoo:V2Woi;<N
okV45?o:ZTOo/7/Yok24:OoT/dOog;=Lom>ZA`02ombZ<`03olZQ?OoL/eco
g;=L00?og;=L00GokM2HombcG?o]d9Soi;j4omc7X`03ong@V004ok2=7_oL
/ecobZ4molZQDP;obZ4m00Sodj4YonBc:Oo:V1CobYPDom>Q:Oo:XCgoi;<Y
ombcG0?og:Xc0ooCXBT01_oT/akodj4YombZ<ooT/dOog:XcombcG0?og:Xc
00kobYPDok2=7_oL/ecog;=LonBc7_oT/dOog:XconBcAoo:V1Coi:X0om>Q
:OoLZS?obYPDonBc7PCobYPD00?odj4Yom>ZAoo:XCd00_oCZTL2olZH500<
om>H2_o:XCgodj4YolZH5?o1Q03o^H@YombcG?o]ahCobZ4monBcAooCZTOo
g;>40_oL/e`2om>ZA`0;ombZ<oo:V1Co`H@0ok1b0?n`N`[oWW8:oh=10?n=
E@[oNd40ofY12_mP;`X00_lS70X2o`T92P03oa4L2_l94P[o6Q8D00;o2@T:
00[oARHDoc@_:OlJ9QCo6PT:oa4L2_l92@[o4A`:o`T92_l0003oUEDD0_n3
;`001_mP;`[oARH:ob<L2_lA70[o6PT:o`TB2P;o4A`:01Go2@T:oa4L2_lJ
2@[o6Q8Do`TB2_lJ4QCo2A8:oaXB5?lA9Qko2A8:oaXB5?l971Co4A`:oa4V
5?l92@[o2@TDo`T92_lJ2@[o6Q`Nof11:OoChoD0GooVi^H01?nMWIgo]kNg
olS8b?oCdm<1om[JfP00ooo^k^hIonk^kP09on7QhOoJf][oclo?okfm_OnS
Xj?o2eBaojC4i_nidnooMZgZ00;oZn3o00CoKVi^okBd]?oPh>3ok>c/Foo^
k^h01?nVLQCo/8dNog]<2_mkC1@5oh=1000@oheE2_n3;`3oLRH0og]<2_n3
@@3oSED:oiEE0?nNGQCoYVL0ok1b0?nVLP3o/780ok1k2_nVLP3oWW8:oiEE
00;obZY70_o:XCd04_oL/ecobYPYolZQ?On`SAko^HdDokV=:Oo1Q03obYPD
ol640?n`SAko/780ol640?n`N`[o^HdDokV45?o:ZTOo/7/DolZQ?@;o^HdD
00gobYPYok2=7_niSACo^Hdcol640?niQ1Co/8dNoh=k<oo]aecog;>4om>n
S_oL/hCog;=L00;odjY70ooLZS<01Oo:V2WobYPDokV=5?o:V1Co/8dN00;o
bYPD00SobYPYom>ZAooL/ecog;=LombZ<ooCXBWobYPDom>H2P;obYPD00Oo
diP:olZH5?niQ1CobYPYombZ<ooCZTOodj4Y00Cog:Xc00Co/8dcolZQD_oC
XBWodj4Y0_oCZTL00ooCXBWog:Xcom>ZA`04ombcG003ombcQ?oT_XCoi;=7
00;oi;j400SokLMLong@V?o]d9SokM2HokV=5?o:XCgodj4YolZH:@Codj4Y
0oo:V1@01OoLZS?odjY7onBc<ooL/ecodj4Y00;og:Xc00Coi;<YolZH5?oL
ZS?obZ5B0_oLZS<00ooT/dOog;=LombZ<`02ombZ<`0:onBZ0?n`N`[og;=L
ombZ<ooCXBWog;=LonBc:OoT/dOoi;<Yom>Q:@;oi;<Y00godj4YolZH5?o:
V1CobYPDolZH:OoCQ03obYPDonBc:OoCZTOog;>4ombcG?oLZS?obYPD00?o
`H@00_oCQ0000oniQ1CokKhmong@V002ombcG0;oi;=70_oL/e`01ooCXBWo
i;=7ombZ<ooLZS?odiP:okUW0?n`LP000_n=E@X01_mkC0[oH44Dog8h0?m6
;`[o8a`:ob`B00;o4A`:1Ol92@X03_m6EBWo=2lNob<V2_lJ71ko2@T:oaXB
5?l94P[o4A`:o`T95?n3;`3oPcP0og8V0?mP;aCoEa`00_lS70X2oaX92P09
o`T92_l94P[o2A8:o`TB2_lA70[o2@TDo`TB2_l92ACo6Q8D00;o2A`D00?o
2A`No`T95?l000000_l92@X00om69QCoPhAkojJZ[@02om?Sm@03ongfmOoL
hn3ok^k^05kok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400?oooooo6Ooo
ool02Oobl_;oj^[ZomkNg_o;bl_o[jn_o`]C[_nUa>Ko]M3^ogV^k002ojOL
o`04ogIfM_o1`L7ol?3`oogmoE_ooooo00Go/8@Yok1k:OnEE@3oWW8:og8h
0002oheE2P0GoiEE0?n=E@[oPcP0of0_2_mG703oH2lDoh=10?nNGQCoWW8:
ok1k2_nVLP3oWW8:ok1b0?niSACoYW80ok1k2_nVLQCoYW80olZZI_o:ZTOo
bYPYolZQ?Oo:ZVH00_o:V2T01oniSBWo^HdDolZH5?niQ1Co^HdDol640?ni
I`000_n`N`X02OniQ1Co^HdDokV=:OoCZTOo^H@DolZQ?OniQ1Co`H@0olZH
5002olZH:@09om>H2_n`SAko/8dNolZQ?OmZ@@[og;=LolZZI_oL/ecokLML
00;og;=L00godjY7ombZ<ooCZTOodj4YolZH:Oo1Q03odiP:olZH5?o:V2Wo
bYPDolZH:Oo:V1CobZY700;odjY700Ooi;<NolZH5?o:V1CobYPDom>Q:OoC
V0[obYPD00;obZ4m00?obYPDom>Q:OoCXBT00_oCXBT01ooCZTOog:XcombZ
<oo:V1Co^HdcolZH:Oo:V1@00_oCZTL2olZQ?@;og;=L017og:XcolZZAooL
/ecog;>4onBnQ?oCZTOokLN4onBnQ?oL/hCokM2HonBnQ?o]d9SoYW8DombZ
<oo:V1CobYPYolZH5005om>Q:@05olZH5?o:XCgog;=LombcG?oT/dL00ooL
ZS<01oo:V1Codj4YombZ<ooLZS?oi;<YombZ<ooT/c<00ooLZS<01?oT/ako
g;=LoiEE5?oT/dL2ombZ<`09onBcAooLZS?og;=Lom>Q:OoT/akobYPDonBc
<oo:V1Coi;<Y00;obYPD00[o^H@DolZH5?oCXBWobZ5BonBc<oo:ZVKog;=L
ombZ<ooCXBWodh@00_oCV0X2olZH500:ok1k2_ofd8Coi;=7om>ZAoo]aeco
kKhmombcG?oT/dOokKhmonBcA`;og;=L00cog:Xcol640?o1Q03oYVL0oiib
2_n3GQCoSED:og]<2_mb>03oH44Dob<V2_lm70X2oaX92P08oa4L2_l94P[o
4A`:oa4L2_l94P[oH44DodI17_lS;ah2oa4L2P06o`T92_l94P[o6PT:o`TB
2_n3;`3oSED:0_n3;`000omb>1Co;180ob`L5002oa4L2P0Gob`L5?l92@[o
2@T:oaXB5?l92ACo4BHDo`TL5?lA70[o2@TDo`T92_l92ACoARHDog9bNon3
SHCoAVMLol[@e_oChoGom_ooongfmOofooookOKeooKooooCfMH0Goooool0
1?n_[joobl_;omkNg_oZj^X1oo;blP00ooo^k^hIonk^kP09on7QhOoJf][o
clo?okfm_OnSXj?o2eBaojC4i_nhd^koMZgZ00;o[=oo00CoKVi^okBd]?oP
h>3ok>c/Foo^k^h01oniSBWo^Hdcoiib5?nVLQCoUEDDoheE2_nEE@000_n=
E@X01on3@@3oH2l:ocdB2_m69P[oPbl0oiiN5?nVI`000_nVLP02ok1k2P0<
ol640?n`LP3o/780ok1k2_nVLP3o^JY_ombZ<oo:XCgobYPYolZQ?OoLZS?o
^HdY0_n`SAh02?niSACo`H@0okV=5?n`SAko^HdDol640?n`LP3o`H@00_ni
SA@03_o:XCgo^H@DolZQ?OniSACo^HdcolZH:OniSBWo`H@0olZH5?oCV0[o
^HdDol640?mZEAkom]UV0ooL/e`01?oC_Xkog;=LombcG?oCZTL2olZH:@;o
bYPD00Oo`H@0olZH5?o:V1Co`H@0okV=<oo:V1CobZY700;og;=L00?obYPD
om>H2_oCV0X00_o:V1@2om>H2P0HolZQ?OniSC?obYPYolZH:OoCZTOodj4Y
om>ZAooLZS?obYPYom>Q:OniSBWobYPDol640?o:V1CobYPYom>Q:Oo:XE;o
g:Xcom>ZAooL/ecokM2HokV=:Oo:ZVKokM2H0ooCZTL02?oL/ecodjY7ombc
G?oT_XCokM2Hoiib5?o:XCgobYPD0ooCXBT02Oo:V1Codj4Yom>Q:Oo:V1Co
dj4YombZ<ooL/ecoi;=7onBc<`02ombZ<`?odj4Y00Goi;<Nom>Q:OoT/ako
g:XconBcA`02ombZ<`0:onBc:OoLZS?oi;<NoheE2_o]_Sgog:Xcom>Q:OoT
/c?og:XconBcA`?odj4Y00?oi;<colZH5?o:V1@00_oCXBT07oo:V1Codj4Y
olZH5?oT/c?oi;=7om>ZAoo]d9Sog;=LolZH5?oCV0[o`H@0om>40?oCV0[o
bYPDok1k2_o]d9SokLMLonBnQ?oL/ecoi;j4ong@V?oL/ecokLN4ombcG?oL
/hCo^HdcombcG?o:V1CoYW80ojIW0?nEE@000_n=E@X01Omk@@3oJT4:odH_
2_lm70[o8a`:00;o4A`:00So2@T:oaX92_lA70[o2@T:o`TB2_lS;akoH5hc
ob<V2P;o4A`:00Oo2@T:oaXB5?l94P[o2@T:og8h5?nVC03oLSPD00;oH2l:
00Co?A`:ob<L2_l/4P3o6PT:1?lA70X01Ol0003o?A`:oaX92_lA70[oWXAV
00;odmWF00com_ooongfmOofooooLXf]oiFQ]onVan3odmWFongfmOofoooo
kOKeooKooooLhn1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003oonKV
iQWoi^KV00Wof][Jom?Cdoo8b<So]kNgoifMWOl=E:koY/KVokK@k_mi[nh0
0_n[g_l01?mZJV[o[Zj^omSHf?oTi>AKonKViP0@ok2=7_o:XCgoYW8Doiib
5?nVI`3oWW8DojIb5?nNLQCoWW8:oh=10?mP;aCoH2l:odHV2_mkC0[oUED0
oiiN50;oYVL000ko/7/:ok1b0?n`N`[oYW8DojIb0?nVLQCoWW8:olZZAoo:
ZVKog:XcolZZAooCZTOobYPDolZQ?@;o/8dN0_niSA@06Oo:V1Co^HdDokV4
5?niQ1Co/7/:okUW0?niQ1CobYPYolZQ?OniSBWobZ4mokV4:On`SAkobYPY
olZH5?niSACobYPDom>H2_o1Q03o^HdDofY12_o]aecog;=LolZZI_offFH0
0ooL/e`00ooT/bWobZ4molZH5002olZH:@0?olZH5?o:V2WobYPDolZH5?ni
SACodiP:olZQD_oT/dOodjY7olZH:OoCXBWo/8dNonBc7_oCXBWobYPD00;o
bZ4m00?obYPYokV=5?oLZS<00ooCXBT02?o:V2WodiP:olZH:OniQ1CobYPD
okV45?o:V1CobYPY1OoCZTL01?o]d9SobZYVokV=:OniQ1@2ok1k5003okV=
5?oL/ecog;=L00;og;=L00?om]UVoiib5?oCXBT00_oCXBT01OniSC?og:Xc
olZH5?oCXBWobZ4m00;odj4Y00gobYPDom>ZAooCZTOodjY7om>Q:OoLZS?o
bZ4mom>H2_oCXBWobYPDonBc7_oCXBWoi;<c00Cog:Xc00coi;<YonBc7_mk
C0[om]UVombZ<ooCXBWog;=LonBc<ooL/ecog:XconBc:Oo:V1@2om>Q:@05
onBc:Oo:V1CodjY7okV45?o:XCd00ooCXBT02on`SAkog<NSom>nS_oCXBWo
`H@0om>H2_oCQ03obYPDom>40?n`N`[okM2H00;og;=L0_oT/dL02OoTZYSo
i;j4ong@V?oLaj?o^HdcokV45?oCZTOo^H@DoheE2P02ojIW0008ok1k2_n3
GQCoNd`Dog8V0?mP;`[o8bH:ob<L2_lJ2@X4o`T92P0>oa4L2_l94P[oARHD
of1N<olS;ako4A`:oa4V5?l92@[o4A`:oaX92_l92@[oARH:ojI10?n=E@X2
of0_2P03odHV2_lS70[o8a`:00;o4A`:00So2@T:oa4L2_l92@[o2@T:ombc
G?o]d9So0000ooKfm@Codn?e00GokOKeoh>H]omkSHCo`LO<ol[@eP03ongf
m@03ooKooooLhn3oi^KV05koi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X0
0?ook^k^6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`YA[_nT`nGo^=;_
ogV^k002ojcOo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Co/8dNokVHG?nN
LP[oYW8D0_nNLQ@03OnVLQCo^HdDojIb5?n=E@[oPd40oheE2_mP;`[oLSPD
ojIW0?nVLP3oYW8Dok1k2_n`LP001?n`N`X02OnNLP[oUED0olZQD_o:ZTOo
bZ4molZH:Oo:XE;o^HdYolZQ?@04okV=5004ok1k2_n`SAko^HdDojIb00;o
/7/:00So/8dNokV=:On`SAko/8@YolZH:OniQ2Wo/8dNokV=50;obYPY00Go
`H@0olZH5?o1Q03obYPDofYE7P02ombcG0;og;>40_oL/e`00ooCZTOobZ4m
ombZ<`03olZH:@0=ol640?o:V2WobYPDom>H2_o:V1CobYPYolZQ?OoCZTOo
bZ5BombZ<ooCXBWobYPDom>Q:@02olZH500?om>Q:Oo:V1Co^HdYolZH5?o:
V2Wodj4YolZH5?oLZS?obYPYom>H2_o:XCgodiP:olZH:Oo:V1Co^H@D00?o
bZ4m00[obYPYombZ<ooCZTOog;>4okV=<on=E@[oPcP0okV=<oo:XE;odjY7
0_oL/e`03OoC_Xkoi;j4ong@V?nVLP3odjY7olZH:Oo:V1Codj4YolZH5?oC
XBWobYPDom>Q:OoLZS<00_oCXBT01?oL/ecoi;=7ombcG?o:XCd2om>Q:@0?
ombZ<ooCXBWoi;<colZH5?oCXBWog;=LonBc:OoLZS?odjY7ombZ<ooT/bWo
i:X0og]<5?o]aecodj4Y00;og:Xc00SobZ4monfn?Oo:V1Codj4YolZH5?oT
/akobYPDom>Q:@;o^Hdc00Wodh@0om>Q:OoCXBWodj4YolZQ?OniLS?o^Hdc
onBnQ?o:V1@00_o1Q0006ooCV0[odh@0olZH5?niQ1CokLMLombcG?oT_XCo
i;=7om>ZAooL/ecokLMLomc7Xoo]d9SobYPYom>ZAonNSBWoWUhDoheE2_nE
E@3oWW8:ok1k2_n=E@[oNd`:of0_2_m6;`[o?A`:ob<V2P04oa4L2P0Bo`T9
2_lA70[o2@T:ob<V2_mPGS?o6RHDo`TB2_l92@[o4A`:o`T92_lA70[o2@T:
ocdB2_n=E@[oPcP0odHV5?mP;aCoEa`00_lS9PX02_lJ2@[o2@T:oa4L2_l9
2ACo6Q8Do`000?n`Q7_om^gZo`TB2_o]m_D4om?Sm@05ongfmOnE/lcoNhf4
ojJc`Oo:d=H00_o]m_D00oofooookOKeom?IeP1Oonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q003ooooooaWooooo00Wol_;bon[Zj_oNg]kobl_;ojn_
[ol=E:koYLCVokKBk_mi[^T00_nZh?l01?mfMWKo`L71oo3`l?omoOeKoooo
o`06ok24:OniV5co/7/:oiib5?nNLP[oWW8D0_n`N`X02OnNLP[oSED:ofY1
2_l/4P3o8bH:oh<_0?n=E@[o/7/:ojIb0002ok1k2P03ojIb0?n`NaCoYW80
00;o/7/:00?oYW80olZQD_o:XE800_oLZS<02Oo:XE;o^HdDokV=<oniSACo
^HdYokV=5?niQ1Co`H@0olZH5002ok1k2P0;ol640?n`N`[o/8@Yok2=7_o:
V2Wo^HdDokV=<on`SAko^H@DolZH5?o:V2T00oo:V1@01oniSACo^HdcoeLL
0?offFKodkj>onBcAooL/h@00_oL/e`03OoCZTOog:XcolZQ?Oo:V1CobZ5B
olZZAoo1Q03odiP:ok2=7_o1Q03o^HdcolZH:Oo:XCd00_oCZTL00ooCXBWo
bYPDom>H2P03olZH500:om>H2_o:V1CobYPDok2=7_oLZS?obZ4mol640?oC
XBWobYPYom>Q:@?obYPD00Ko^H@DolZH5?o:V2Wodj4Yom>ZAooLZS<2olZH
:@0>ombcG?nNNc?o/8dcoiEE5?o:V1CokLMLombcG?o]d9Soi;j4ong@V?oC
_XkokMW<oiEE0?oCXBT3olZH:@0:olZQ?OoCXBWobZ4molZH5?oLZS?odj4Y
ombZ<ooT/dOog;=LonBcA`;og:Xc0ooCXBT00oo:V1Coi;<Yom>H2P02ombZ
<`0Nom>Q:OoCZTOoi;<NombZ<ooT/akoPd40ooKII_oCZTOog:XconBcAooC
XBWog;=LolZH5?oT/akodiP:ombZ<oo:V1Coi:X0olZH5?oCQ03odj4YonBc
<oniSBWo`H@0om>40?niQ1CoYT`0olZH:Oo1Q03o/7/:0oo1Q0001?o:V1Co
/780ong7Q?oT/dL2ombcG0;oi;=700GobZ4mombcG?oL/ecobZ5Bog]<2P02
of0_5008okUW0?o1Q03o/780ok2=7_mkC0[oSED:of0_2_mZ@@X2ob<L2P03
ob`B0?lA70[o2@T:00;o2A8:017o4A`:o`T92_l/9QCoAUDYoaXV5?lS70[o
6PT:oa4L2_l92@[o4A`:o`T95?lS70[oUED0oh<h0?n3@@3oPcP0of0_5002
ocdL2P03o`T92_lA70[o2@T:00;o4A`:00Oo0000oiEbAoo]m_Go4BH:ooKo
oooChoGog>?P00;odn?e00GokOKeojJc`OmZNfoo/;k1om?IeP04ongfm@03
omcSh?oooooooooo05gooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800?oo
k^k^6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`]C[_nVa^Ko^M?^ogV^
j`02oj_Oo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00[o/8dNok24:OnNLP[o
WW8Doiib2_nVI`3oYW8Doiib2_nNGQCoUEDD0_lm70X01_m69QCo8a`:oiiN
5?nEE@3o^H@Dok1b00;o/7/:00ko/780ojIb5?nVLP3o/7/:oiEE0?oL/eco
bYPDolZQD_oCZTOobZ4molZH:Oo:XCgo`H@0ok2=7P?o^HdD00Ko/8dNol64
0?n`LP3o/7/:okV=5?o1Q002olZQ?@05okV45?o:V2Wo/8dNokV45?niSA@0
0oo:V1@2ol640008olZH5?mZ@@[og;=LombcQ?oL/ecog;>4ombcG?o:ZVH2
om>ZA`03olZH5?o:V2WobYPD00;obYPD00WobYPYolZH5?o:V1Co/8dNolZH
:Oo:XCgodjY7ombZ<oo:V2T00_o:V1@01ooCV0[obYPDolZH:OoCV0[obYPD
ok2=7_niSBT00_oCXBT00oo:V1CodjY7olZH5003olZH500=olZQ?Oo:V1Co
bYPYolZH:OoCZTOog;=LolZQ?Oo:V2WobZ4mol640?mP@BWoPehcolZZIP02
ombcG00>om>ZAoo]d9Sog<NSonBnQ?o]d9Soonf>oheE2_o:V2Wo^H@YolZQ
?Oo:V2Wodj4YolZH5?oLZS<2om>Q:@03onBc<ooT/dOodjY700;og;=L00?o
i;<YombZ<ooCZTL00ooCXBT02ooLZS?odj4YombZ<ooT/c?oi;<Nom>ZAooT
/c?og:XconBc7_mb>03om/Lm00;og:Xc00OodjY7ombZ<ooL/ecog:XcolZQ
?OoT/akoi;<c00?obYPD00co^H@DolZH5?niSC?odh@0olZH5?n`N`[obYPD
onBc7_nVC03oPbl0ok1E0?niI`02ol640009om>H2_n`N`[okLN4om>ZAooT
/dOodjY7olZQ?OoL/ecobYPD00;obZ4m00[obYPYoh<_0?mkC1CoPbl0olZQ
?On`SAko/780okV=5?mkC1CoNd400_mZ@@X01OlS70[o=2lYob<L2_lJ2@[o
4A`:00;o2@T:01Go2A8:o`T92_lJ9QCoAUDYob<_7_lA9P[o2@T:o`T95?lA
70[o2@T:oaXB5?lJ2@[oWUhDoiE<:On=E@[oPbl0of0_2_m69P[oAT4Noa4L
2_lJ2@X00_lA70X01Ol92ACo4A`:ocdL2_o:_ZgoAT4N00Codn?e00Kog>?P
ongfmOnVan3oH79kok2c]ooCfMH2ongfm@03ooKoooo]m_Gog>?P05ook^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400?ooi^KV6OoVi^H02OoJf][odm?C
olS8b?ng]kOoWIfMo`mF[onS`^Co^=?_ogN^j`02oj[Oo`04ofYZJ_n^[Zko
f=SHonCTi5_oi^KV00?o/7/Doiik<onNLPX00onNLPX04OnVI`3o/8dNoiib
2_n=E@[o?A`:ob<L2_lJ9QCo;1`Doh=10?nNLQCo/8dNok1b0?nVLQCo/7/:
ok1b0?n`N`[o/78000;oWW8:00OobZ4molZQD_o:V2WobYPYolZQ?OniSBWo
bYPY00Co^HdD00?o`H@0okV=5?niSA@00_n`LP002On`NaCo^HdYok2=7_o:
ZTOo/8@YokV=<on`NaCo/8dNokV=<`02ok2=7P07olZH5?niSACo^HdDolZH
5?m6;`[okLMLombcQ006ombcG0;og:Xc00GobZ4molZH5?niSACobYPDok2=
7P03olZH5003olZH:Oo:XCgobZ4m00;odj4Y00GobYPDom>Q:Oo:V1CobYPD
olZQ?@02olZH5006ok2=7_o:V2WodjY7olZH5?o:XCgobYPY0oo:V1@06?ni
SC?odiP:olZH5?o:XCgobZ5BombcG?o:V2Wog:Xcom>Q:OniSACo^H@Yoiib
5?nNNc?okLN4omc7XooLZS?oi;j4ombcG?o]d9Sog;>4oooSS_n3GQCo^H@D
okUW00;obYPD00So^HdcolZH5?o:V1Codj4YombZ<oo:XE;obZ4monBc<`;o
i;=700Oog:Xcom>ZAooLZS?og:Xcom>Q:OoT/akodj4Y00?og:Xc00Sodj4Y
olZZI_oLZS?og:XconBc7_n=E@[okLMLom>Q:@;og:Xc00Godj4YombZ<ooC
XBWoi:X0okV=<`04olZH5003okUW0?n`N`[o`H@000;o`H@000Oo/7/:ok1E
0?n=E@[oPbl0oh<h0?nVC03o/4`000;o`H@000cobYPDokUW0?oL/ecog:Xc
ombcG?oLZS?obYPDom>Q:OniSC?obYPYokV45?nNGQ@2ok1k2P09ombZ<oni
SBWo^HdDokV45?n`N`[oNd`Doh=N5?mP;`[oLRH000;o8a`:00?o4BH:oaXV
5?lJ4Q@00_lA70X01Ol92@[o2A8:ob`V5?mP@ACo8blN00?o4A`:00So2@T:
oa4L2_l92ACo4BHDojI<0?mkC1CoLSPDofY12P;oLSPD00goARH:ob<L2_lA
70[o6Q8Do`T92_lA70[o2@TDo`TB2_n3Nc?oH5hcooKooonVan3og>?P00;o
dn?e00Kog>?Pol[@e_mZNfooUJZ]om?Ie_oChoD2ongfm@03ooKfmOoLhn3o
i^KV05koi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00?ook^k^6Oo^k^h0
2OoQhN7of][Jolo?conm_KgoXj>So`mE[onUa>Ko^M?_ogN^j`02ojWLo`04
ofi^K_nd];Coh>3Ponc/k5_ok^k^00Go/8dNok2=<onVLP3oSED:oiEE0002
oiib2P;oYW8000koUEDDofY12_mP;`[o?A`:ob`B0?n3>03oWW8Dok2=7_n`
NaCo/780ok1k2_niSACo/7/:ok2=7P;o/7/:00WobZ4molZZAoo:XCgobZY7
olZQD_o:V1Co^HdYok2=7_n`N`X00_niSA@2ok1k2P0<ol640?niQ1Co/780
ok1b0?niSACo^HdYokV=<onVLQCo^Hdcoiib5?niQ2Wo/8dN0oo:V1@2ol64
0003olZH5?m6;`[og;=L00;og;=L00?og;>4om>nS_oL/e`00_oCZTL01?o:
V1CobYPYolZH:OoCV0X2ol64000AolZH:On`SAko/8dNolZH5?o:V2WobZ4m
om>ZAoo:V2Wodj4YolZQ?Oo:V1CobYPYom>H2_o:V1CodiP:olZH5?n`SAh0
0_oCZTL01Oo:V2Wog:XcolZQ?Oo:V1Co^HdY00;obYPD00Wo/8dNolZH5?o:
V2Woi;<Nom>ZAooLZS?odj4YolZQ?Oo:V1@00_o:ZTL02oo:ZVKoi;j4ong@
V?oT_XCokM2HombcQ?o]d9SokLN4ongIc?nNLQCo/7/:00?o^H@D0oo:V1@0
3ooCXBWoi;<colZQ?OoT/c?obZYVolZQD_oL/ecodj4Yom>ZAooLZS?oi;<c
olZH5?oCXBWog:Xcom>Q:@06ombZ<`0<onBc7_n3GQCokKhmom>Q:OoCZTOo
i;<Yom>Q:OoT/dOodiP:om>Q:OoCQ03oi;<N1?o:V1@04?oCQ03obYPDom>H
2_niI`3o/7/:ok1E0?lm4P[oH2lDoeLL0?n`C03o/7/:okUW0?niQ1Codh@0
ok1b0?oLZS<2ombcG009ombZ<oo:XCgodj4YolZH5?niQ2Wo^H@DojI<0?n3
;`3o/7/D00;odj4Y02co^HdDokV45?n`N`[oNd`:oheE2_mP;`[oJT4:ob<V
2_lS70[o6PT:o`T95?lJ4QCo6PT:oa4L2_l92@[o4A`:oaX92_m6EBWo;2HD
oaXB5?lA70[o2A8:oa4L2_lJ2@[o2@T:oaXB5?n`C03o/5D0oiEE5?n3>03o
Nd`DodHV5?lm70[o4A`:oaX92_l92@[o4A`:o`T95?l94P[o2@T:odI<?Old
;akom_ooomcSh0;odn?e00Sog>?Pom?SmOoLhn3oJW^4oiFHXoo:d=KokNgZ
ongfm@;om_oo00?og>?Ponk^k_o^k^h0GOo^k^h01?nSXj?o_Kfmolo?cooJ
f]X1on7Qh@00oooooolIooooo`09oo;bl_oZj^[og]kNol_;bon_[joo2eBa
ojC4i_nidnooMZgZ00;oZn3o00CoMWIfol71`Oo`l?3ooOgmFoooool03?nV
LQCo/8@YojIb0?n=E@[oWUhDoiEE0?nNLP[oYVL0oiiN5?nVI`3oLSPDofY1
2P;oH2lD00OoSED:oiib2_n`SC?o/8dNokV=5?n`N`[oYW8000;o/78000Co
/8dNojIb0?n`SE;odjY70_o:ZTL02oo:XE;o^HdYolZQD_niSACo/8dNok1k
5?nNLQCo/7/:ol640?n`N`[o/78000;o/7/:01_o/8dNokV=<ooLZS?o/8dN
okV=:On`SAko^HdDol640?o:V1Co^HdDok2=7_o:V1Co^HdDom>H2_m69QCo
djY7ombcG?oC_Xkog;=Long7G?o:ZVKog;=Lom>ZAooCXBWog:XcolZQ?OoC
V0X00_niSA@01?o1Q03o^HdDokV=5?niSBT2olZH:@04olZZAoo:XCgobYPD
om>H2P?obYPD00OodiP:olZH5?o:V2WobYPDolZQD_oL/ecobYPY00;og:Xc
00CobYPYol640?o:XCgo^Hdc0_o:V1@01?niSBWodjY7ombcQ?oCZTL2om>Q
:@08olZH5?o:ZVKodkj>ombcQ?oC_Xkog;j]ong7G?oC_Xh3ong@V007ongI
c?nEQ5;oUED0ok1k2_niQ1Co^H@YolZH:@02olZH5007om>Q:Oo:XCgobZ4m
om>ZAooL/ecoi;<combcQ004ombZ<`;odj4Y00?og:XconBc:OoT/ah00_oL
ZS<03_oCXBWodjY7ombZ<ooT/bWoUEDDombZ<ooT/dOog:XcombcG?oCXBWo
g;=Lom>Q:OoLZS?odj4Y0oo:V1@03OoCQ03obYPDolZH5?oCXBWobYPDok1k
2_nV@@3o/7/:og8V0?mP;aCoH2l:ojI10?n`Na@00_niI`003_niQ1Co^FL0
olZQ?OoCZTOoi;=7om>ZAoo:V2Wodj4YokV=:OoCXBWobYPDok1k2_o:V1Co
^H@D0_oCXBT00oniSACo^H@Dok1k5002og]<2P0?ob<L2_mG703o=2lNob<L
2_lA70[o6Q8Do`T95?l92@[o2A8:oa4L2_l92ACo4A`:ofYE7_ld;ako4BH:
00;o4A`:00co6Q8Doa4L2_lA70[o2@TDok1k2_nNGQCoYT`0oh=10?mb>1Co
H2l:ob`V5?lS70X2oa4L2P0:o`T95?lA70[o6Q8Do`TB2_nEC2WoPhAkom?S
mOnVan3ob]3FomcSh0;odn?e00WokNgZofYkQ?nEXHko`LO<om?SmOofoooo
kOKeooKooooLhn00Goooool01?n_[joobl_;omkNg_oZj^X1oo;blP00ooo^
k^hIonk^kP09on7QhOoJf][oclo?okfm_OnSXj?o2e>^ojG4i_ned>koNJk/
00;oYmco00CoKVi^okBd]?oPh>3ok>c/Foo^k^h2ok24:@05oiib5?nEEACo
WW8:oheE2_nVI`000_nNLPX2oheE2P03oh=10?mP;aCoPcP000;o/7/:00Ko
YXABok1k2_niSACo/7/DokV=5?nVLQ@2ok1k2P0AojIb0?o:ZTOobZYVolZQ
?Oo:ZTOobZYVolZH:Oo:ZTOo^HdYol640?niSACoWW8:ok1k2_niSACo/780
okV45?nVLP000_n`N`X04oo:V2WobZY7ok1k5?o:XCgo/8dNok1k5?niSC?o
bYPDolZH:Oo:V1Co^Hdcol640?o:V1CoARl:ombcG?oC_Xkoi;=7ombcG?oL
/h@00ooCZTL01_o:ZTOobZ4molZH5?o:V1CobYPYolZH50;o^HdD00Oo`H@0
olZH5?n`Q2WobZY7olZQ?OoCXBWobYPD00;odiP:00Sog:XcolZH5?o:V2Wo
diP:olZZAoo:V2WobZ4monfn?@?og:Xc00SobYPDolZH:Oo:V1CobYPYom>H
2_o:V2WobZ4mom>ZA`;og;=L0_o:XCd01?oCZTOobZYVom>nS_oT_X@2ong@
V00;ombcQ?o]d9SokM2Hong@V?oLaj?oonf>ohf=AonVI`3o/7/YokV4:OoC
XBT00_oLZS<00ooCZTOobYPDonBc<`02om>ZA`03onBcAooCZTOog;=L00;o
djY701Kog:XconBcAoo:XCgodj4YonBc<ooCXBWoi;=7ombZ<ooT/c?og:Xc
ombcG?oCXBWoi;<Noij=:OoLZS?odj4Yom>ZAooT/dOobYPYombZ<ooCXBWo
i:X01?o:V1@01OoCV0[obYPDolZH5?oCQ03oi;<N00;o^FL001Wo^H@DojI1
0?n3>03oWUhDojI<0?niQ1Co/4`0ol640?n`N`[o`H@0olZH:OoT/dOoi;j4
olZH5?oLZS?odj4YolZQ?OoCXBWobYPYokV45?niSC?o`H@0om>Q:Oo:V2Wo
/8dN00;o^H@D00OoJT4:og]<2_lS9P[oARH:ocdL2_lS9P[o8a`:00?o4A`:
01oo6Q8Doa4L2_lJ4QCo6PT:oc@_7_l/9QCo6RHDoaXB5?lA70[o2@TDo`T9
2_lJ2@[o2@T:ojI<0?nNGQCoSED:oh<h0?mkC0[oH2lDodHV5?lS70[o6PT:
o`T92_lA9QCo2@TDoa4L2_l92@[oAT4NojJQV?o:d=Kog>?P00;odn?e0_oL
hn001OoChoGoJW]_ohf=Koo1alcodn?e00;okOKe00?om_ooomcSh?o^k^h0
G_o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooVi^HIonKViP09om[J
f_oCdm?ob<S8okNg]onMWIgo2eBaojC4i_nhd^koMZgZ00;o[=oo00CoJVYZ
ojj^[_oHf=Soi>CTFooVi^H01?n`Q2Wo/8eBoiib5?nNLPX2oheE2P0JoiEE
0?nVI`3oWUhDoiEE0?n=E@[oYW80ok2=D_nNLP[oUEhcoiib<onVLQCo^HdD
ol640?niSACo/8dNokV=5?n`N`[o/8dNojIb0?o:ZTOodjY7olZQ?OoCZTOo
bZY7olZQ?Oo:ZTL2okV=:@0=okV=5?n=E@[o/7/:ol640?n`LP3oWW8:ok1k
2_niI`3o^HdDok2=7_o:V2Wo/8dNokV=:@02okV4500>ok2=7_niSC?o/8dN
okV=5?oCV0[o/8dNolZH5?mP;`[obZY7ombcQ?oL/ecobZYVombcG?o]_Sd2
om>ZA`0:ombZ<oo:XCgobYPYolZH5?niSBWo`H@0okV=5?o1Q03o/8dNokV=
<`;obZ4m00GobZ5BolZZAooCV0[obYPDom>Q:@03olZH5004olZH:Oo:V1Co
^HdYombZ<`?obYPY0oo:V1@03On`SAkobYPDol640?n`SAkobYPYolZQD_oL
/ecodjY7om>Q:Oo:V1Cog:Xcom>ZAooC_Xh00_o]d9P01OoL_ZgokM2Hong@
V?o]d9Sog;j]00;okM2H00CoYZ5VoiiN5?o:V1CodjY70ooL/e`02_oT/dOo
bZ4mom>ZAooLZS?odjY7ombcG?oCZTOog;=LombZ<ooCXBT2om>ZA`04om>Q
:OoLZS?og:Xcom>Q:@?og:Xc00Kodj4YonBcAooL/ecoi;<cok1k2_o:V2T2
om>ZA`05ombcG?oCXBWoi;<colZH5?o:XCd00_oCXBT00oo:V1Co`H@0olZH
5002ol640003olZH5?o:XCgobYPD00;o`H@000?oYVL0ok1E0?niSC<00_n`
Na@01On`N`[o`H@0ok1k2_n`N`[obYPY00;og;=L0_oCZTL2olZH:@07om>Q
:Oo:ZTOodiP:okV45?o:V1Codj4YolZH5002okV4500EokV=:OmZ@@[oARHD
ocdL2_mG703o?A`:ob<V2_lJ2@[o2@T:oaX92_lJ4QCo2@TDo`TB2_l92ACo
4A`:ob`h:Old;ako4BH:oaX92_lA70[o6Q8D00;o4A`:00Co0000oiiN5?n`
NaCo/7800_n=E@X03OmP;`[oARH:oa4L2_lS70[o4A`:o`T95?lJ4QCo4A`:
o`TL5?l/71CoYXB4om?SmOnVan000_o:d=H2om?Sm@09ongfmOmbSHCoNhf4
ol77c?oLhn3om_ooongfmOofoooog>?P05ooi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X00?ook^k^6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`eD
[_nVa^Ko]]3^ogV_kP02oj_No`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Go
/8@Yok2=<onVLQCoSED:oiib2P02oiEE0009oiiN5?nNLP[oYVL0ojIb5?nN
LQCo/8dNoheE2_n`N`[oYW8D00Go^HdD00Wo/7/:ok1b0?n`LP3oYW80okVH
G?o:ZTOobZ4molZZAoo:XE800oo:XCd2okV=<`03ofY12_o1Q03oYW8000;o
/78000WoYW80ok1k2_n`LP3o^HdYokV=<on`N`[o^Hdcok2=7_niSA@00_ni
SBT01oo:V1Co^HdDokV=5?niSACo`H@0of115?o:XCd00ooL/e`02oo:ZVKo
g;=LombcG?o:XCgobYPYolZZAooLZS?obYPDok2=7_o:V1Co`H@000;o^HdD
00?obZ5BolZQ?Oo:V2T00_oCZTL3olZH500>om>H2_oCXBWobYPDom>H2_o:
V1Co/7/:olZH:Oo:XCgodiP:olZH5?o:V2Wog:XcolZH5?oCV0X2olZH5005
ol640?niSACog;=LombcG?oCZTL00_o:XCd01ooLZS?obYPYom>nS_o]d9So
dkj>ong@V?oT_X@01Oo]d9P03onNSC?obZ4molZZAooL/ecog;>4ong@V?oT
_XCoi;=7om>ZAooLZS?odj4YombZ<ooT/dOodjY7okV=:@02ombZ<`0DonBc
<ooL/ecodj4Yom>Q:OoT/akodj4YonBc7_oLZS?oi;<Nom>ZAooT/dOodj4Y
ombcG?niSACobYPYonBc<ooCZTOog;=LolZH5?oL/e`2om>Q:@07olZH5?oL
ZS?obYPDolZH5?oCQ03obYPDom>40002olZH500=om>H2_o:V1Co/7/:oh<h
0?n=E@[odjY7ok1k5?n`N`[o^FL0olZH5?niI`3o`H@0ok24:@02ombcG004
om>ZAooLZS?odj4Yom>ZA`Codj4Y00?obYPDol640?o:V1@00_niQ1@01_ni
SACoJT4:of0_2_lA70[o8bH:ocdL2P;o8a`:00Go4A`:o`T92_lJ4QCo4A`:
o`T92P02oa4L2P03ob<V2_ld;ako6PT:00;o2A8:01So6PT:oaXB5?l92@[o
2@TDok1<0?niI`3o^H@Dog8h5?mkC1CoJT4:odHV2_l/71Co6PT:oa4L2_lJ
4QCo2@TDoaXB5?l92ACoARHDoij4I_nVan3og>?Pom?SmOo:d=H2omcSh005
ongfmOn3V8koLW9kok2n`OoCfMH00_o]m_D00oofm_Gob]3Fonk^kP1Nonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003ooooooaWooooo00Wol_;bon[Z
j_oNg]kobl_;ojn_[ol:DJkoY<?UokSBkomi[^`00_n/gol01?mfMWKo`L71
oo3`l?omoOeKooooo`04oiik<on`SC?oWW8:oiib2P;oPehD00GoSED:ojIW
0?nEE@3oWW8:oiib<`02oiib5007oiEE0?nVLP3o/7/:ok1k5?niSC?o^HdY
okV=5002ok1b000AokV=5?n`N`[oYVL0okV=<ooLZS?obZ4molZZAoo:XE;o
bYPYolZQD_o:V2Wo/8dNokV=:OmP;`[oWW8:ok1b0?nVLP000_nNLPX04OnV
LP3o/7/:okV=:Oo:V2Wo/8dNokV=<on`SAko/7/:olZH:Oo:V1Co^HdcokV=
5?o:V1Co^HdDom>H2_m6;`[obZ5B00;og;=L01?odjY7ombcG?oCZTOobZ4m
olZQD_oLZS?obYPDolZH:Oo:V1Co`H@0om>H2_n`NaCo^HdDol640?oCZTOo
^IQLolZH:Oo:XCgobZY700;obYPD01Codj4Yom>H2_o:V1CobYPDolZH:Oo1
Q03o/7/:olZQ?Oo:V2WobYPDolZH:Oo:XCgobYPDokV=5?o:V1Co^HdDolZH
5?nVLP3o^H@DolZQ?@;odjY70_o:XCd04?o:V2WobZYVolZQD_oLaj?og;=L
omc7XooL/hCog<NSombn[Oo]d9Sog<NSooo]c?nVXFKo^JY_om>ZAooT_X@3
ong@V003ombcG?oT/dOog;=L00?odjY700Ooi;=7om>Q:OoL/ecodjY7olZQ
?OoCZTOobYPD00;og:Xc0ooCXBT02?oLZS?odjY7onBcAooCXBWog:XcolZH
5?n`Q2WodjY70_oT/dL01_oCXBWog;=Lom>Q:OoLZS?o^Hdcom>H2P;obYPD
0_o1Q0001?o:V1Codh@0olZH5?oCXBT2olZH500=ojI10?nVC03o`H@0ok1b
0?niQ1Co`H@0om>40?n`N`[o`H@0okUb<oo]aecodjY7ombZ<`02om>ZA`03
ombcG?oCXBWodjY700;odj4Y03SobYPDokV=<oo:V1Co`H@0ok1k2_n`SAko
PehDofY12_lA70[o8bH:ocdL2_lS9P[o8a`:oaX92_lA70[o6PT:o`T95?l9
2@[o4A`:oaX92_lS9P[o=2lNoa4V2_lJ4QCo4A`:o`TB2_l92@[o4A`:o`T9
2_n=E@[o^H@Dok1k5?nEE@3oPcP0og]<2_m69P[o8bH:oa4L2_l94P[o6Q8D
oa4V5?lA70[o2A8:odHV5?n`SE;og>?Pom?SmOo:d=Kodn?eol[@e_oChoGo
kOKeoh>H[OmZNfoo/;k1ol[@eP?okOKe00?og>?Pooooooooool0GOooool0
1?n_[joobl_;omkNg_oZj^X1oo;blP00ooo^k^hIonk^kP09on7QhOoJf][o
clo?okfm_OnSXj?o3EB^ojG4i_nfd^koNJkY00;oZ^3o00CoKVi^okBd]?oP
h>3ok>c/Foo^k^h2ok24:@07oiib5?nEEACoWW8DoheE2_nNLQCoWW8:oheE
2P02ojIb5005ok2=7_n`NbWoYVL0ok1k2_n`Na@00_niSA@2ok1b0007ok1k
2_nES@3o/780ok1k2_nVLP3oWXdcom>ZA`02olZZA`07olZQ?On`SAkobZ4m
ok2=7_niSC?o^HdYof0_2P02ok1k2P?oYW8000co/7/:ok2=7_niSBWobYPY
ok2=7_o:V2Wo/8dcokUW0?n`SAko^HdYolZH5?niQ1@3ol640007odHV5?o:
XE;og;=Lom>nS_oL/ecodkj>ombZ<`02om>ZA`04olZQ?Oo:XE;obZ4molZH
50?o^HdD00CobYPDolZZAoniSBWobYPD0_o:XCd00ooLZS?odiP:olZQ?@04
olZH5006okV=<oo:V1Co^H@DolZQ?OoLZS?obYPD0_o:V2T04oniSC?o^FL0
ok2=7_o1Q03o/780ojIW0?nEEACo^HdDombcG?o:XE;obYPDolZH:OoCXBWo
bYPYombcG?o]d9Sodkj>ong@V?oL/e`00oo]d9P01_o]fLcokM2HokVZKooL
ZS?og;>4omc7X`;oi;j400gog;>4ombcG?oCZTOog;=Lom>Q:OoLZS?og;=L
om>ZAooLZS?odjY7ombZ<oo:XE;oi;=700?odj4Y0_oLZS<02?oT/akog:Xc
ombZ<oo:ZVKog:XcombcG?o:V2Wo/8@Y0_oT/dL01_oCZTOodj4YombcG?oL
ZS?odjY7olZH:@?obYPD00[odiP:ok1k2_o:V1CobYPDok1k2_o:V1CodiP:
olZH5?n`N`[o^FL00_n`N`X03?oCQ03o`H@0ol640?n`N`[o`H@0oiib2_o]
aecog:Xcom>ZAooL/ecodjY7ombcG0;odjY70_oCXBT01?o:V1CodiP:olZH
5?n`SAh2okV45004oiib5?mP;`[o;2HDoaX92P;o8bH:00Go8a`:oa4L2_l9
2ACo2A`Doa4V5003o`T92P0Aob<L2_l/>2Wo6RHDo`TB2_l971Co2A8:oa4L
2_l92@[o2@TDog]<5?n`E@3oWUhDoheE2_n3>03oNd`:odHV2_lS70X00_lA
70X2oaXB5007ob<_7_l0003o?A`:olZZI_o:d=KoY/OPol[@eP03omcSh005
ongfmOn3V:goJW]_ok2c]oo:d<400oo]m_D00ooLhn3ok^k^onk^kP1Monk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?C
doo8b<So]kNgoifMWOl;DjkoY/KVokWCk_mi[^/00_n[gol01?mZJV[o[Zj^
omSHf?oTi>AKonKViP0>oiik<on`SC?oWW8cojIb0?nEEACoWXdYoiib5?nN
GQCoSED:oiib5?nNNc?o/8@YojIb5?nNLPX2ok1k5004ok1k2_niSACo/7/D
ok1k2P?o/7800_n`N`X01on`SAko^IQLolZQ?Oo:XCgog;=Lok2=7_o:ZTL0
0_niSBT01?n`SAkoSED:og]10?nVLP02ok1b0007ok1k2_nVLP3o/7/DokV=
:OniSC?o^H@DokV=:@03ok2=7P08okV=<oniSBWo^HdDokV=5?o1Q03o^HdD
of0_5?o:XE84ombcG00AolZZI_oCZTOobZY7olZH:Oo:XCgobYPYolZH5?ni
SACo`H@0ok1b0?o:V1Co/8dNoiib5?n`NaCobZ4mom>ZAoo:ZTL00_o:V1@0
3OoCV0[obYPDolZH5?o:V1CodiP:olZH5?niQ1CobYPYolZH5?niQ1CobYPD
ok2=7_oCV0X00_niQ1@06_niI`3o^H@Doh=10?n=E@[obYPYom>ZAooL/eco
dj4YolZH5?o:V2WobZ4molZZI_o]d9Sog;>4ong@V?oT_XCokM2Hombn[Oo]
d9Sog<NSong@V?o:ZVKo^IQLong@V?oLaj?og;>40_oT_X@01_oL/ecodjY7
olZQD_oLZS?obZ4monBcA`?odjY700Kog:Xcom>ZAooL/ecobZ4mom>Q:OoL
ZS<3om>Q:@;og:Xc00Kog;=LombZ<ooCZTOodiP:oiik<ooLZS<2onBcA`09
om>Q:OoL/ecodjY7om>ZAoniQ1Co^HdcolZH5?n`N`[odiP:00;o`H@000So
bYPDok1k2_o:V2Wodh@0olZH5?o1Q03o^G8cokUW00?o/7/:00Oo^H@Dok1k
2_niI`3o/7/:onBnQ?oL/ecobZY700;odjY700Coi;=7om>ZAoo:ZTOog:Xc
0_oCXBT04Oo:V2WobYPDolZH5?niQ1Co/7/Doiib5?mkC1CoH2lDodH_2_lm
70[o;2HDob<L2_l/4P3o6PT:o`T95?lA70[o6Q8D00;o4A`:00?o6Q8Doc@_
7_lA9Q@00_lJ4Q@05?l92ACo4A`:o`TB2_l92ACoPbl0okV45?n`NbWoWUhD
oheE2_mkC0[oH2l:odHV5?l/71Co6PT:oa4L2_l92ACo6RHDo`TL5?lJ2@[o
^IQL0_o:d=H02_oLhn3ob]3Fom?SmOoLhn3okOKeoiFQ]omZNfooYZZ]ol[@
e_o]kNX2ongfm@03ong]j_oVi^Koi^KV05goi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X00?ook^k^6Oo^k^h02OoQhN7of][Jolo?conm_KgoXj>So`mF
[onS`^Co^=?_ogN^j`02oj[Oo`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00Co
/7/Yok2=<onNLQCoWXdY0_n=E@X02onNLP[oWUhDoiib2_nNLQCoYW8Dok2=
7_n`NaCoWW8Dok1k5?n`SAko/7/:00;o^HdD0on`LP02ojIb0003oiib2_nN
SC?og:Xc00;obZ4m01?obZ5BolZH5?niSC?o/780olZH:OnEEACoPehDofY1
2_nVI`3oWW8:ok1k2_nNLQCo`H@0ok1k5?n`SAko^Hdcok2=7_niSC?o^H@D
00;o/8dN0_o:V1@2okV=5006okV45?o:V1CoEa`0olZZAooL/ecobZYV0_oL
/e`01?o:ZVKobZY7olZQD_oLZS<2olZQ?@0>olZH5?niSACo/7/:ok1k2_o1
Q03oYW8DodH_2_mkC0[obYPYolZZI_oCZTOobYPYolZH5?o:XCd4olZH500Q
okV=:OniQ1Co^HdcolZH:Oo:V1Co/8dNolZH:Oo1Q03o^H@DokV=5?n`N`[o
WW8:oiE<:On`SC?o/8dNolZQD_o:ZTOobZ4molZH:Oo:V1CodjY7olZZI_o]
d9Sog;>4om>nS_oT_XCodkj>ong@V?o]fLcokM2HongIc?oC_XkobZ5B00;o
kM2H0_oT_X@02?oL/ecodjY7ombZ<ooT/c?obZ4mom>ZAoo:XE;og:Xc0_oC
ZTL01ooLZS?obZ4molZH:Oo:V2Wodj4YombZ<ooCZTL00_oCXBT01ooT/ako
g:XcombcG?oLZS?odjY7onBc7_nNLQ@01OoL/e`2om>ZA`?obYPD00?o`H@0
om>40?niI`000oo1Q003olZH5003ok1k2_o:V1Co^H@D00;o/7/:0oo1Q000
9_n`N`[oWW8:onBnQ?oL/ecoi;=7ombcG?oCZTOog;=LombZ<ooC_XkobYPY
olZQ?OoCXBWobYPDom>Q:Oo:V1Co^H@Yok1k5?n`SAkoPehDog8h0?m6;`[o
?A`:ob`V5?lS70[o6Q`Noa4L2_lJ4QCo2@T:oaXB5?l92@[o2A8:oaXB5?ld
;ako6RHDoa4V5?l92ACo6Q8D0_lA70X05?l92ACoEa`0ol640?n`NaCoYVL0
og8h5?n3@@3oARl:ob<V2_lJ9QCo6PT:o`TB2_lJ4QCo4BHDoaXB5?l0003o
g;=Lok2n`Oo1alcoY/OP0oo:d=H01_o]m_Go/;>godmWG?nVZZ?o`LO<ong]
jP;okOKe00?og>?Ponk^k_o^k^h0GOo^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@00oooooolIooooo`09oo;bl_oZj^[og]kNol_;bon_[joo3eF_ojG4
i_nidnooMjk[00;oZMco00CoMWIfol71`Oo`l?3ooOgmFoooool01OnNNc?o
WXdYoiib2_nNLP[oUED000;oSED:01OoYW80oheE2_n`SAko/8dNojIb5?nN
Nc?oYW80okV=5?n`N`[oYW8DokV=5?n`NaCo/7/:ojIb0?nVLQCo`H@0ok1k
2_nNLP[oWXdcom>Q:Oo:ZTOobZ4mokV=<`02okV=:@;o^HdD01SoWW8:of0_
5?m69QCoSED:oiib2_n`NaCo/780ok1k2_n`NaCo/8dNolZH:On`Q2Wo^Hdc
ok24:On`N`[o^Hdcol640?niSBWo/8dNol640?niSACobYPDof115?o:ZTL2
ombcG00;om>ZAoo:ZVKodjY7ombcG?oLZS?o^HdcolZH5?o:V2Wo^HdDolZH
5?o1Q0000_n`N`X01?mkC1Co6Q8Doh=N5?n`SAh2om>ZA`09olZH5?o:XCgo
diP:om>H2_o:V1CodiP:ol640?o:V1Co/7/:00;obYPD00go^HdDolZH5?ni
SACobYPDokV45?niSACo^H@DojIb5?nNLQCoJT4:ojIb5?oL/ecobZ4m00?o
bYPD00Kog;=LokVHG?oT_XCog;>4ong@V?oC_Xh2ong@V00>omc7Xoo]d9So
kM2HokVZKoo:ZVKoi;j4ong@V?oC_Xkog;=Lom>nS_oT_XCodjY7olZQD_o:
XCd2om>ZA`04olZQD_oCZTOoi;=7olZQ?@;odj4Y00CobYPYom>Q:OoCZTOo
g:Xc0_oCXBT02OoLZS?obYPDom>ZAooCXBWog:Xcom>Q:On3GQCokLMLonBc
A`02ombcG006ombcQ?oL/ecog;=Lom>ZAooCXBWo^H@D1?n`N`X01_niI`3o
`H@0ol640?o1Q03odiP:okV450;o/7/:00?o`H@0ok1k2_o1Q0000_n`N`X0
1OniI`3oYW80ong7G?oL/ecodjY700Gog;=L00?obYPYom>ZAooCXBT00_o:
V1@03on`SAko`H@0ok1k2_nNLQCoWW8:og]<5?mP;`[oARl:ob<V2_lS70[o
6PT:o`TB2_l92ACo4A`:o`T92P02oa4L2P07o`T92_m6@Ako6RHDo`TB2_lJ
4QCo2A8:oa4L2P02o`T92P0AocdB2_n`N`[oWUhDojIW0?mkC0[oLSPDodH_
2_lm70[o6PT:oa4L2_lA9QCo4A`:oaX92_lJ4QCo0000ong7Q?n`/kL00oo:
d=H2omcSh005ong]j_o1alcoJW]_oiFQS_n`_/400oo]m_D00oo]kN[ooooo
ooooo`1Mooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b003oonk^kQWok^k^
00WohN7Qom[Jf_o?cloo_Kfmoj>SXol;E;7oY<CVokWCkomf[NX00_n[h?l0
1?m^KVko];Bdon3Ph?o/k>aKonk^kP05oiib5?mZEAkoSED:oiEE5?mkC0X0
0_n=E@X2oiEE000EojIb5?nNLQCo/8dNojIb5?nVI`3o/8dNojIb5?n`N`[o
/8dNokV=5?n`N`[oWW8:ok1k2_n`LP3oYW80ojIW0?nNSC?obZ5BolZQ?Oo:
XE;obYPD00;o^HdY00?o/780ol640?nEE@000_m69Q@01_niQ1Co/7/:ojIb
5?n`LP3o/7/:ok1k50;o^Hdc00Co/8dNokV=:OniSBWo/7/D0_n`SAh00ooC
V0[o^HdYokV45002ol640005of0_5?nVXFKog;=LolZZI_oL/h@00ooCZTL0
4OoLZS?obZY7olZH:Oo:V1Co^H@Yol640?n`N`[o^HdDol640?n3>03oLSP0
oiEE5?niSC?obZ5Bom>ZAoo:V2WodiP:00;obYPY00KobYPDokV=5?o:V1Co
diP:ok1k5?o:V1@2ok2=7P;obYPY00Wo^HdDolZH5?o:V1Co^Hdcok1k5?n3
@@3oNd`DokV4:OoLZS<00oo:V2T01_o:V1CodjY7olZQD_oL_ZgokM2Hombc
Q0?okM2H00?oi<O1omc7Xoo]d9P00_oC_Xh03?oL/hCoi;j4ombcG?oCZTOo
bZYVombcG?o:XE;obYPDom>ZAoo:XCgobZ5BonBc<`?odjY700?og:Xcom>Z
AooCZTL00_oCXBT02oo:XCgodj4YombZ<ooLZS?odj4YombcG?oLZS?oi;=7
ombZ<omkC1CokLN400;oi;j400Oog;=Long@V?oT_XCoi;j4onBcAooLZS?o
YW8000;oSED:00SoWUhDojI<0?n`N`[o`H@0ok1k2_o1Q03o^H@Dol6400;o
/7/:00Wo`H@0okUW0?o1Q03o^FL0ok1k2_niI`3o/7/:ombcQ?o:XCd00ooL
/e`01_o]d9SodjY7ombcG?oCZTOodj4YolZH:@?obYPD00ko^H@Dok1k2_nN
LQCoWW8:of115?mG703oARl:oc@_7_lS70[o4A`:oaX92_lJ4QCo2@T:o`TB
2P?o2@T:00?oAUDYoaXV5?lJ2@X00_lA70X2o`T92P08oa4L2_lJ4QCoWUhD
ok1k5?n`N`[oPbl0oh=10?mP;a@2ob<L2P08oaX92_lA70[o2A8:o`T95?lA
70[o0000ooK@Q?n`_/42ol77c00<ol[@e_oChoGob]3Fom?SmOnVan3oLXf4
ojJHQ?n`_/7om_Keong]j_o]m_Gog>?PGoo^k^h01?nSXj?o_Kfmolo?cooJ
f]X1on7Qh@00oooVi^HIonKViP09om[Jf_oCdm?ob<S8okNg]onMWIgo2e>^
ojG4i_ned>koNJk/00;oYmco00CoJVYZojj^[_oHf=Soi>CTFooVi^H02?nN
LQCoUEDDoh=N5?n=E@[oNd`:ofY12_n3@@3oUEDD0_nNLPX01?nVLQCo/8dc
ojIb5?nNSBT2okV=5004ojIb5?niSACo/7/Dok1k2P;oWW8:00GoYW80ok1k
2_nVI`3oWXdYom>Q:@03olZQ?@0=okV=:OniSACoYW8Dok1k2_nVC03o;2HD
oh=N<oniQ1Co/7/Dok1k2_n`LP3o/7/:ok1k5003okV=:@03ok2=7_n`NaCo
/8dN00;o^HdY1?niSA@01Oo1Q03oJT4:olZQ?OoL/ecodkj>00?og;=L01;o
bZY7ombcG?o:V1Co^HdcolZQ?OniSACobYPDok1k2_niSC?o^H@Dom>H2_nV
LP3o^HdcolZZAooCZTOobZYVolZH5?o:V2T5olZH5003om>H2_nVLP3og:Xc
00;obYPD0oo:V2T01Oo1Q03obZY7om>Q:OniSBWoSED:00;obZYV00Oo^Hdc
olZH:Oo:V1Co^HdYom>H2_oL/hCodjY700;okM2H00[og<NSong@V?oLaj?o
kM2HonC7`OoT_XCokM2Homc7XoniZVooi;j40_oL/h@3olZZIP05om>ZAon`
SAkodj4YombZ<oo:XCd00_oCZTL2om>Q:@04om>ZAooLZS?odjY7olZH50?o
dj4Y0_oLZS<01ooCXBWog;=Lom>ZAooT/dOoi;<Nog]<2_ofd8@00_oT_X@2
ong@V004om>nS_oL_ZgokLMLok1k2P;oSED:00OoNd`:oh<h0?nEEACo^FL0
ok1k2_o1Q03obYPD00;o^H@D00CobYPDok1k2_niQ1Co`H@00_niI`002?o1
Q03o/7/:ok1b0?o]aecog;=LombcQ?oL/ecog;>40ooL/e`01?o:XCgodjY7
olZH:Oo:V2T2okV=500Eok2=7_n`N`[oYW8DoheE2_mP;aCoH2l:oeLL0?lS
9P[o8a`:oaX92_lA70[o6Q8Doa4L2_l92@[o6Q8Doa4L2_lA9QCoARHDob`V
5?lA70[o2@T:00?o4A`:00Go2@T:oa4L2_n`E@3oYW8DokV45002og]<2P0<
of0_5?lS70[o8a`:oa4L2_lJ2@[o4A`:oaXB5?lA9QCo0000olZZI_o1/jgo
Y/OP0oo:d=H3omcSh007oh>HS_n3SHCo/;>gomcSh?o]kN[om_ooomcSh01O
onKViP04oifMWOng]kOob<S8om?Cd`7of][J003oonk^kQWok^k^00WohN7Q
om[Jf_o?cloo_Kfmoj>SXol;E;7oY<CVokSBk_mf[NX00_n/gol01?m^KVko
];Bdon3Ph?o/k>aKonk^kP0Doiik<onNSC?oUED0ocdL2_m6;`[oLRH0og]<
2_n=E@[oUEDDok1k2_nVLQCo/8dNokV=5?nNLP[o/7/:ojIb5?n`NaCo^HdD
ojIb5?n`N`X3oiib2P07ojIb0?nVI`3oWXdYom>ZAoniSC?og:XcolZH:@02
ok2=7P0Cok1k2_nNLP[oSED:oeLL0?nNNc?o^H@Dok1k2_o1Q03o/7/DokV4
5?n`N`[o/8dNok24:On`SAko^IQLok24:On`NaCo/8dNolZH:@02okV=500K
ol640?niQ1Co/8dNog]<2_n`SE;og;=LolZZI_oL/ecobZYVombcG?oCZTOo
bZ5BombZ<oo:V1CobYPYokV=5?o:V1Co/7/DolZQ?On`SAko/7/DolZH5?oC
ZTOog;=Lom>nS_oCZTOog:Xc00;obYPY0oo:V1@02oniSACobYPDokV=5?o:
V2Wodj4Yok2=7_o:V2Wo/8dNolZH5?o:V2WobYPD00;obZ4m00Co/8dNolZQ
D_o:ZTOobYPD0_o:XCd01Oo:V1CobZ4mombcG?o:XCgog<NS00?okM2H00So
g<NSong@V?o]d9SokMW<onC7`Oo]d9So^JY_ong@V0;og;>400Sog;=Lom>Z
AooCZTOobZ5BolZH:Oo:XCgodj4Yom>ZA`;odj4Y00?odjY7om>Q:OoCXBT0
0_oLZS<5om>Q:@0@ombZ<ooCXBWobZY7om>Q:OoCZTOog:Xcoh=N5?oC_Xko
kLMLonBnQ?oL/hCoi;j4ombcG?o:ZTOo^HdYojIb00;oLSPD00CoPbl0og8h
5?n3>03oYVL00_n`N`X00oniQ1Co^G8colZH5002okV45008okUW0?niQ1Co
/780ol640?n`N`[o`H@0ok1b0?oT_X@3ombcG00CombcQ?o]ahCodjY7ombc
G?o:V1Codj4YolZQ?Oo:V1Co^H@Dok1k2_niQ1CoYW80oiib5?nEEACoH44D
of0_2_m69P[oARHDob<V2P02oaX92P0Po`T95?lA70[o2@T:oa4L2_lA9QCo
0000odIE:OlS;ako4A`:oaXB5?l94P[o6PT:o`TB2_lJ4QCo2@TDojI<0?ni
Q1Co/7/:og8h5?n3;`3oNd`:ob`L5?lS70[o6PT:o`T92_lA70[o2A8:oaXB
5?l0003obZ5BojJZXoo1al`2ol[@eP0;om?SmOo:d=Kodn?eomcSh?n3V8ko
PhAkojJZ[OoLhn3odn?eong]j_oLhn00Goo^k^h01?nSXj?o_Kfmolo?cooJ
f]X1on7Qh@00oooooolIooooo`09oo;bl_oZj^[og]kNol_;bon_[joo3EB^
ojK6i_nfd>koNJo^00;oZmko00CoMWIfol71`Oo`l?3ooOgmFoooool01?ni
V5co/8eBoiik<olm70X2odHV2P08og]<2_n=E@[oUED0ojIb0?nVLQCo/8dN
ojIb5?nNLQ@4ojIb50?oYW8000GoWW8Doiib2_nVLP3oYW80oiib5002olZQ
?@0=okVHG?o:XCgo/8dNokV45?n`N`[oYW80oiEE0?mZ@@[oYW8DokV=<oni
SACo/8dcok1b0002ok2=7P0?okV=5?niSBWo/7/:olZH:On`Q2Wo/7/DokV=
5?n`SAko^HdDok2=7_niSACo^H@Dol640?mkC0[o/8dc00;og;=L01Oog;>4
om>nS_oCZTOobYPYom>ZAoo:V1Co^HdcokV=:OoCV0[obYPDok1k2_o:V1Co
^H@Dom>H2_niSACobZYVom>ZAooL/ecodjY7olZH:Oo:XCgobYPDol640003
olZH500Nol640?n`LP3odj4YolZH:Oo:V1Cog:Xcom>H2_o:V2WobYPDolZH
:Oo:V1Cog:XcolZH:OniSC?o^H@DolZH:OniSC?odj4YolZH5?o:XCgog;>4
olZZAooC_Xkog;j]om>nS_oLaj?okM2Hombn[Oo]fLcog;j]0_o]d9P02?ni
V5coi;j4ombcG?oC_XkobZ5BolZZAoo:XE;odjY70oo:V2T01ooCXBWodjY7
om>Q:Oo:V2WobZ4molZH:OoCZTL00_o:V2T01?o:XCgog:Xcom>Q:Oo:XCd2
om>Q:@07om>ZAooLZS?oi;=7onBc:On3GQCog;=LombcQ002ombcG00>onBc
Aoo:XCgoYW80ojIb5?mP;`[oPbl0oh<h0?nVC03oSED:oh<_0?n`N`[o^FL0
okV45?o1Q002okV45005okV=<on`N`[o^FL0ok1k2_niI`000oo1Q0006_n`
LP3oi;j4om>ZAooT_XCobZYVonBnQ?oL/hCodjY7onBcAoo:XCgodj4YolZH
5?o:XCgo`H@0okUW0?o1Q03oWW8:ojIW0?nNGQCoARl:of0_2_m6;`[o8bH:
ob`B0?lJ2@[o4A`:0_l92@X01ol94P[o2@T:oaX92_l94P[o=5DYob<V2_l9
4PX00_lJ4Q@05?lA70[o6PT:oa4L2_l0003oPcP0okUW0?n`N`[oUED0oh=1
0?mkC0[o8a`:ob<V2_lA70[o2@T:oa4L2_lJ4QCo2@T:o`000?o:XE;oUHB>
0_o1al`3ol[@eP;og>?P00CoUJZ]ofYkKon`/kOog>?P0_o]kNX00ooLhn3o
ooooooooo`1Mooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b003oonk^kQWo
k^k^00WohN7Qom[Jf_o?cloo_Kfmoj>SXol:DJkoY<?UokSBkomi[^`00_n/
gol01?m^KVko];Bdon3Ph?o/k>aKonk^kP05okVZKon`SE;oWXdYoheE2_mb
>1@00_mZ@@X00onEE@3oSED:oiib2P03ojIb5008ok2=7_n`N`[o/7/:ojIb
5?nVLP3o/7/:ojIb0?nVLQ@2ok1k2P0>ojIb5?nVLP3oPg/colZZAoo:XCgo
bZY7okV=<oniSBWo/8dNok1k5?nVLP3o/7/:og8h0?nNSBT2ok2=7P04ok1k
5?nVLQCo^HdDol6400;o^HdD00So/7/DokV=<on`SAko/7/Dok2=7_niSC?o
^HdYokV450;o^HdD00Ko/8dNog]10?nESE;og;=Lom>nS_oL/e`2olZZIP04
olZQ?Oo:ZTOo^IQLolZH50;obZ4m00?o/8dNok1k2_o:V1@00_niQ1@00oni
SBWobYPYolZZA`02olZZIP03olZH:OoLZS?obYPY00?obYPD00_o^HdDol64
0?niQ1CobZ4mombZ<oo:V1CobYPYolZZAooCZTOobYPYolZQ?@02olZH500F
olZH:OniSC?o^HdYolZQ?Oo:ZTOodj4YolZQ?OoCXBWog<NSom>ZAoo]d9So
i<O1ong@V?oLaj?okM2Hombn[Oo]d9Sog<NSongIc?o]d9SoYXABonBnQ0;o
bZYV00KodjY7olZZAoniSC?obZ5BolZQ?Oo:V2T2om>Q:@03olZQ?Oo:V1Co
dj4Y00;odj4Y00_odjY7om>Q:Oo:V1CobYPDombZ<ooCXBWog:XconBc7_oL
ZS?obZYVom>ZA`02ombZ<`04oh=N5?o:ZVKoi;j4ombcQ0;oi;j400?og;=L
ong@V?oT/bT00_mb9P002_mP;aCoLSPDok1E0?mb>1Co/5D0okV=5?o1Q03o
^G8cokV45?o:V1@2okV45004ok1k2_niQ1Co^FL0ok1k2P;o`H@000Go/780
om>ZAooL/ecog;=Lom>ZA`02ombcG0;odjY70_o:XCd01Oo:V2WobZ4mol64
0?n`N`[o^H@D00;oWW8:00?oWUhDof0_2_mb>0000_m6;`X4oa4L2P03o`T9
2_lJ2@[o4A`:00;o2@T:00?oARHDob<_7_lA70X00_lA70X05_l92ACo4A`:
o`T92_lA70[oH2l:ok1k2_niLS?oUED0oheE2_mP;`[oARl:ob<L2_lJ2@[o
6Q8Do`TB2_lJ4QCo2A`Do`000?niSC?oUHAkol[@e_nVan02ol[@eP;og>?P
00Codn?eoiFZ[OmZNfooYZZS0_oLhn000oo]m_Gog>?Ponk^kP1Nonk^kP04
oj>SXonm_Kgoclo?om[JfP7ohN7Q003oonKViQWoi^KV00Wof][Jom?Cdoo8
b<So]kNgoifMWOl=E:koYLCVokKBk_mi[^T00_nZh?l01?mZJV[o[Zj^omSH
f?oTi>AKonKViP0<okVHG?n3GQCoPehDof115?mP;`[oJT4:oh=10?nNGQCo
SED:ok1k:OnVLQCo/8dN1?nVLQ@03on`N`[oYW80ok1k2_nVLP3oWW8:ok1k
2_nVLP3oWW8:ojIW0?nNSBWog;=LolZQD_o:XCgobZ5BokV=5002ok2=7P04
oiib2_nVLP3oSED:ok2=<`?o^HdD00_o`H@0ok2=7_n`LP3o/8dNokV=:On`
SAko^HdYok24:OnVLP3o/8dcok2=7P03okV=50;o^H@D00KoUED0ojJ4D_oL
/ecobZYVombcG?o:ZVH2ombcG004olZQD_o:XCgobYPYokV=<`;obYPD00[o
/8dNokV=<oniSACo^HdYolZQ?On`Q2Woi;=7olZZI_oL/ecobYPD0_o:V2T5
olZH5003okV45?o:V1CobZ4m00;obYPY00Oo^HdcolZH:Oo:V1Co/8dNol64
0?o:V2WobYPD00;obZ4m00kobZ5BolZQ?OoCXBWobZY7olZH:OoL/ecodj4Y
omc7Xoo]d9Sog;=Long@V?oL/hCog<NSong@V0?og<NS01?oWXdcombcQ?oL
/hCobZYVolZQD_o:ZTOobZ5Bom>ZAoo:V2WobYPDolZQ?Oo:V1CodjY7om>Q
:Oo:XE;obYPYolZQ?OoCXBWobYPY00;obYPD00?odj4YolZH5?oCXBT00_oC
XBT01_oLZS?odjY7om>ZAooT/bWoWW8DolZZIP;og;=L017og<NSonBnQ?oL
/hCoWXdcombcQ?nEE@3oNd`:og8h5?n3;`3oSED:oiiN5?nVI`3o^H@DolZH
5?o1Q03o^H@YokV=5002okV450?o/7/:00Go`H@0ok1k2_o:V1Co^FL0olZQ
DP02ombcG004olZH:Oo:ZVKodjY7olZH:@;odjY700Kodj4YolZQD_o:V1Co
^HdDokV45?o1Q002oiib2P06oh=N5?mZ@@[oH2l:of0_2_lm70[o8bH:0_lJ
2@X01?l92@[o4A`:o`T92_lA70X2o`T92P03oba<:Ol/9QCo4A`:00;o2@T:
00Oo2A8:o`T92_lA70[o2@T:oeLL0?o:V1Co/7/:00;oSED:00koLSPDoeLL
0?lS9P[o2@T:oaXB5?lJ2@[o2@T:oaXB5?l0003oWW8cojJHKooLhn3o/;k1
ol77c0?ob]3F00Sodn?eojJc`OmZNfooYZZSom?Ie_oLhn3okOKeomcSh5oo
i^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00?ook^k^6Oo^k^h02OoQhN7o
f][Jolo?conm_KgoXj>So`]C[_nVa^Ko^M?^ogV^j`02oj_Oo`04ofi^K_nd
];Coh>3Ponc/k5_ok^k^00?o/8eBoiE<:Om69Q@00_m69Q@02omP;aCoNd`:
oheE2_nNLP[oYW80oiik<oniQ1CoYW8Doiib2_nVLQCo/8dN00;o/7/:00?o
/7/Yoiib2_nNLPX00_nNLPX01_n`LP3oUED0oij=:Oo:XE;obZ4molZZIP;o
bZ4m00Wo^HdYokV=5?n`N`[o/780oh=N5?nNSC?o/780okV=<oniSA@00_n`
LP002On`SC?o/8dNokV=<on`SAkobZ4mok24:On`N`[o^HdYokV4:@02okV=
5005okV45?niSACo^HdDog]<5?nNSC<00_oL/e`04Oo:ZVKog;=Lom>nS_oL
/ecobZYVolZZAoo:V2WobZY7olZQ?Oo:V1Co^HdDok2=7_niSC?o/8dNolZH
5?o:V2Wo^Hdc00;obZYV01;og:XcolZQ?Oo:V1Co^HdYom>H2_niSC?o`H@0
olZH:OniQ1Co^HdcolZH5?niSC?odiP:okV=:Oo:V1Co/8dNolZQ?OniSA@3
okV=:@03okV45?oL/ecobZY700;obZY701codjY7olZZI_o:ZTOokM2Homc7
XooL/hCokM2HombcQ?oT_XCog;>4ong@V?oLaj?okM2Hoiik<ooT_XCog;=L
olZZI_o:XE;obZ4molZH:Oo:ZVKobZ5Bol640?niSC?obYPYolZQ?OoCXBWo
bZ5B0_o:XCd2om>Q:@;obYPD00Oodj4YolZH:OoCXBWodj4Yom>ZAooLZS?o
bZ5B00;og:Xc00WoWW8DokVHG?oL/ecog;=Lomc7XooT_XCodkj>ojIb5?oL
ZS<00_mb9P004?mkC1CoLSPDoh=10?nNGQCo^H@Dok1k5?oCXBWobYPYol64
0?niSBWo^HdcokV45?n`NaCo`H@0okV=5?o1Q002okV45004okUW0?o:XCgo
djY7olZZIP?odjY70oo:XCd01?oCZTOobYPDolZH:On`SAh2ok1k2P07ojIb
0?n=E@[oWUhDofY12_m69P[oH2l:ocdL2P02ob<L2P03oaX92_l92@[o4A`:
00;o2@T:00Wo6Q8Do`T92_lS;bWo;2HDoa4L2_lJ4QCo4A`:oaXB5?lA70X0
0_l92@X01_l/71Codh@0ok1k2_n3>03oNd`Doh=100;o8bH:00co6PT:oa4L
2_lJ4QCo2A8:oaXB5?l0003obZ5Bok24I_oChoGo`LO<ok2n`Oo1al`2ol[@
eP08omcSh?o1alcoCeiVoiFHXoo:d=Kog>?PongfmOoLhn1Oonk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q003ooooooaWooooo00Wol_;bon[Zj_oNg]ko
bl_;ojn_[ol?EZooXl;TokSCkomg[^/00_nZgol01?mfMWKo`L71oo3`l?om
oOeKooooo`08oij=<on`NbWo;1`DodH_2_mP;`[oLSP0of0_5?n=E@X3oiib
2P0;ok2=7_nNLP[oWW8coiib<onNLP[oYW8Doiib2_nVLP3o/7/:oiib2_nV
LP000_nNLPX04onVI`3oPg/com>ZAoo:ZTOobZ4molZZAon`SC?o^HdYok2=
7_n`NaCo/7/:oiEE0?n`SAko^Hdcol640?n`NaCo/7/:ok1k5?n`SAh00oni
SBT02?niSC?o/8@Yok24:On`Q2Wo/8dNokV=<oniQ1Co/8dN0_niQ1@05?n=
E@[oWW8DolZZI_o:ZVKog;>4olZZI_oL/ecobZ4molZZI_oL/ecobYPDolZQ
D_o:XCgobYPYolZH5?oCV0[obYPDokV45?niSACo^HdY0_o:XE801?oCZTOo
g:XcolZQ?Oo:V1@2om>H2P?obYPD00Go^H@DolZH5?o:V2Wo`H@0okV=5002
olZH:@07ok2=7_o:V1Co^H@Dom>H2_niSACo^HdYok2=7P02olZQ?@03om>Z
Aoo:XCgobZ4m00;odjY70_oL_Zd01?oT_XCokM2HolZZI_oLaj<4ong@V004
oiib2_oL/hCobZYVolZZIP;o^Hdc00[obZ4molZZAoo:V1CobZY7olZH5?o:
V2WobYPDolZH:OoLZS?obYPD0oo:V2T01oo:V1CobYPYolZH5?o:V1Codj4Y
om>H2_o:V1@01?oLZS<03?nNSBWo/8eBom>ZAooCZTOog;=LolZZI_oL/hCo
bZY7okV=<omP;aCoNd`:of0_2P;oPbl000coLSPDokV=<oniQ1Cog;=LolZH
:OniSBWo^HdcokUW0?niQ1Co/7/:ok1k:OniI`02okV45006okUW0?niQ1Co
/7/DolZQ?OoCZTOobZY70_oCZTL01?oC_XkobZY7olZQ?Oo:XCd2olZH:@0:
ol640?niQ1Co/7/:oiib2_nVI`3oSED:og]<2_m6;`[oEa`0odH_2P;o8a`:
00Go4A`:oaX92_lA70[o6PT:oa4L2P02o`T92P0Koc@_7_lS;ako4A`:o`T9
5?lA70[o2@T:oaX92_lA70[o6Q8Do`T92_oCV0[o/7/:oheE2_n3@@3oPcP0
odHV5?lS9P[o8a`:oaX92_l92ACo4A`:oaXB5?l0003oYXABojJQI_o:d=Ko
/;k100Cob]3F0_oLhn001_m6IecoYZ6Hol[@e_oLhn3okNgZomcSh5oooooo
00Co[jn_ol_;booNg]koj^[Z0Oobl_800?ook^k^6Oo^k^h02OoQhN7of][J
olo?conm_KgoXj>So`mE[onUa>Ko^M?_ogN^j`02ojWLo`04ofi^K_nd];Co
h>3Ponc/k5_ok^k^00?oUEDDojIb5?lA70X00_mP;`X02OmP;aCoSED:oiib
2_nEEACoSED:oiEE5?nNSBWoPehDoiib5005oiib2P04ojIb0?nEE@3oWW8:
oiib50;oYW8000KoPg/com>ZAoo:XCgobZ5BolZZAoo:XCd2ok24:@06ojIb
5?n`N`[oWW8Dok1k2_niSBWo/8dN0_n`Na@02?n`N`[o/8@YokV=:OniSBWo
/8@YokV=:On`NaCoYW8D0oniSA@02?niQ2Wo`H@0ok1k5?n`Q2WoYW80oh=k
<oo]aecog;>40_o:ZVH01?oL/ecobZ5BolZZAoo:XCd2olZH:@0<olZH5?n`
SAkobYPDokV=5?n`SAko^Hdcok2=7_niQ1Co^HdcolZQ?OoL/ecobZ4m1Oo:
V1@04?niSACobYPDok2=7_o:V1Co^HdcokV=5?o:V1CobZ4molZH:OniQ1Co
^Hdcok2=7_niQ1Co/7/:ok2=7_niQ1@4olZQ?@03om>H2_o:ZVKobZYV00;o
kM2H00[og<NSom>nS_oL/hCoi;j4om>nS_oL_[Oog<NSong@V?n3GQCog;=L
0_o:ZVH01?o:ZTOo^HdcolZQ?OoCXBT2olZH:@03olZH5?o:V2Wodj4Y00;o
bYPY00CobZ4molZH5?o:XCgobYPY0_o:V1@00ooCXBWobYPYom>Q:@02om>Q
:@0=olZH:Oo:ZTOog:Xcom>Q:On`SAkoWW8:om>ZAoo:ZTOodjY7olZH:OoL
ZS?og;=LolZZA`02of0_2P08og8V0?m69QCoLRH0oiEE0?o:ZTOobYPDolZZ
I_o:XCd3okV4500HokUb<oniI`3o/7/:okV4:OniQ1Co`H@0okUW0?niQ1Co
YW8Dom>Q:OoL/ecobZ4mom>ZAoo:XCgobZYVolZQ?OoCZTOobZ4molZH:Oo:
ZTOobYPDok2=7_n`N`[oWW8:0_n=E@X0:?mkC0[o?A`:of0_2_lm70[o8a`:
oa4L2_lJ2@[o4A`:o`T95?l92@[o6Q8Doa4L2_l92@[o8bH:oaXV5?lS70[o
4A`:o`T92_lJ4QCo2@TDo`T92_lA70[o2@TDol640?n`N`[oSED:oh=10?mk
C1CoARH:ob<V2_lS70[o4A`:oa4V5?l92@[o4A`:o`T92_n3GS?og;>4ol[@
e_n`_/42ol[@eP0:ol77c?o:d=Kob]3Fol[@e_nEV:?oSIR>ol77c?oCfMKo
dn?eomcSh5ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400?ooi^KV6OoV
i^H02OoJf][odm?ColS8b?ng]kOoWIfMo`]D/OnTa>Ko^M?_ogJ]jP02oj_P
o`04ofYZJ_n^[Zkof=SHonCTi5_oi^KV00CoPehDog]<5?lm70[oEa`00_m6
9Q@2oiib5006oiib2_n=E@[oWW8Doiib5?nVLP3oWW8D1?nNLPX05?n`N`[o
UED0oiib2_nNLP[oYW80oiib2_nVI`3oPehDom>ZAoniSC?obZ4mokV=<oo:
ZTOo^HdYokV=5?nVLQCoWW8:ojIb0?nNNc?o/8@Y0_niSA@2ok1k500<ok2=
7_niSBWo^HdYokV=:OniSC?o/8dNok1k2_niSC?o^HdDok2=7_n`NaCo^HdD
0_n`SAh04onEEACoPg/combcG?o:ZVKodkj>ombcG?oC_Xkog;=LolZZAoo:
XCgo/8dNolZH:OniSC?odiP:olZQ?OniSACodiP:okV=:On`SAh00_niSBT0
1?o:V2WobZ5BolZH:Oo:XCd2olZH500DokV=<oo:V1CobYPDol640?niQ1Co
bYPDolZH:Oo:V1Co/8dNolZQ?Oo:V1Co^HdDolZH5?niQ1Co/7/:ol640?n`
NaCo^HdDolZZI_o:XE82olZQ?@08okV=:OoL/ecodjY7om>nS_oL_Zgodkj>
ombcQ?o:XCd2om>nSP05ooKII_oC_XkokM2Hoh=N5?oL/e`00_o:ZVH01_o:
ZTOobZ5BolZH:Oo:XE;obYPYom>Q:@;obYPD01GobYPYolZH5?o:V2WobYPD
ok2=7_o:V2Wodj4Yok2=7_o:V1Codj4YolZH5?oCXBWobYPDom>Q:Oo:V1Co
g:XcolZH:OoCZTOo/8@Yoh=N5?oCZTL00oo:V1@01_niI`3obYPDol640?mP
;aCoH2l:of0_50;oH2l:00WoWUhDolZQ?Oo:V2WobZYVom>ZAon`SAko^H@D
ol640?o:V2T00_n`N`X01_n`NaCo^FL0ok1k2_o1Q03o/7/:oiib2P;odjY7
00KobZ4molZZI_oLZS?og;>4olZH:OoL/h@2olZZA`0=ombZ<oo:V2Wo/8dN
ok1k2_nNLP[oSED:oiib2_mkC1CoARl:oeLL0?m6;`[o8bH:oaX92P03oa4L
2P0:o`T92_l92ACo2A8:o`T92_ld;ako8blNoa4L2_l/71Co4A`:o`T92P;o
4A`:01?o6Q8Do`000?oCV0[o/780oiiN5?n=E@[oPd40odH_2_lm70[o4A`:
o`TB2_l92ACo6Q8Do`T95?l0003oAT4NombcQ?n`_/7o`LO<00;ob]3F00[o
Y/OPomcSh?nVan3og>?Poh>HS_n3SHCo`LO<ol[@e_o]kN[og>?PGooVi^H0
1?nMWIgo]kNgolS8b?oCdm<1om[JfP00ooo^k^hIonk^kP09on7QhOoJf][o
clo?okfm_OnSXj?o2e>^ojG4i_ned>koNJk/00;oYmco00CoKVi^okBd]?oP
h>3ok>c/Foo^k^h01On3GQCoNd`:ofY12_mb>03oNd`D00?oWW8D00?o/7/:
oiEE5?nNLQ@00_nNLQ@03_nNLP[oUED0oiib2_nEE@3oWW8:oiEE0?nNLP[o
YW80oheE2_nVLP3oWW8:ojIb0?mZIc?obZY70oniSC<04On`SAko/8@Yok2=
7_n`N`[oYW80oiib5?n`NbWo/8dNok1b0?niSBWo^HdDojIb5?n`NaCo/8dN
okV=:On`SAko^HdY00;o/7/D00?o/8@Yok1k5?n`SAh00_niSA@06Oo1Q03o
^H@DoiEE0?nNLQCodjY7olZZI_oL/ecobZYVombcG?oCZTOobZ5BolZZI_o:
V2WobZY7olZH5?niSACobYPDokV=5?o:V1Co^HdcokV45?niSACo/8dNokV=
:Oo:XE800_o:XCd02Oo:V2Wo^HdcolZH5?o:V1Co`H@0olZH:OniSACo/8dN
okV=:@03olZH:@04olZQ?OniSACo^HdDokV=50;o/7/:00oo^HdDok1b0?o:
XCgobZ5Bom>ZAooL/eco^HdYolZH:On`SAkobZ4molZQD_o:XCgobZY7olZQ
?OoL/h@00_oC_Xh2ombcQ00<oh=N5?oL/ecog;=LolZQ?Oo:XE;obZY7olZQ
?Oo:V1CobYPYok2=7_o:V2Wo^HdY0oo:V2T01_o:V1CobYPYolZH:OoCXBWo
bYPDokV450;obYPD01_obZ4molZH5?oCXBWobYPDolZQ?OoLZS?obZ4molZZ
Aon3GQCog:Xcok2=7_o:V1Co/8dNokUW0?n`LP3oWUhDog]<2_mP;aCoEa`0
of0_5?n3;`3oPehDolZZAooL/ecobZYVolZQ?On`SAh00_n`N`X00oo1Q03o
/7/:ok1k2P02ok1k2P04okV=5?niI`3obYPDoiiN50;og;=L0ooCZTL01ooC
_Xkog;=LombcG?o:XCgodjY7olZQ?Oo:V2T00_niQ1@03?nNLP[oSED:oheE
2_mkC0[o;180odHV2_mG703o4A`:ob`B0?lA70[o6PT:o`T92P;o4A`:01?o
2@T:oa4L2_lS;ako8bH:oaXV5?lA9P[o2A8:oa4L2_l94P[o6Q8Do`TB2_l9
2@[o^FL0ok1k2_nNGQCoSED:oh<h0?m69P[o;2HD00;o6PT:00Ko2@TDoaXB
5?lJ4QCo0000of0_5?ofd8@3ok2n`@09ol77c?o:d=Kob]3Fol[@e_o]kN[o
Eei_ohf=Koo1al7ob]3F00;og>?PGoo^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@00oooooolIooooo`09oo;bl_oZj^[og]kNol_;bon_[joo2eBaojC4
i_nhd^koMZgZ00;o[=oo00CoMWIfol71`Oo`l?3ooOgmFoooool03on3GQCo
LSPDoh=10?n3GQCoWXdYoiiN5?nNLP[oWW8Doiib2_nNGQCoWW8Dok2=7_nN
LQCoWW8:oiEE5004oiib2P0AoiEE0?nNLP[oWW8:oiEE0?nNLP[oUED0oh=N
5?oLZS?o/8dcolZZAon`Q2WobZ4mokV=<on`SAko/7/:oiib2_nNLQ@00_n`
SAh06On`N`[o/8@YojIb5?niSACo/8dNok24:OniSBWo/8dcok24:On`SAko
/7/DokV=5?o:V1Co^HdYok1k5?niSACo/7/DokV=5?nNLP[oJVLconBcAooC
ZTOobZYVombcG?o:ZVH00_o:XE802?o:ZTOobZ4molZH5?niSC?o^HdDom>H
2_nNSC?o`H@00_niSA@03_niQ1Co/8@YokV=:Oo:XCgobYPYok2=7_o:V2Wo
^HdDom>H2_niSBWobYPDok2=7_o1Q03obYPY0_o:V1@02?niSBWobYPYolZH
5?niSACo`H@0okV=5?n`LP3o/7/:0_niQ2T2olZQ?@03okV=<oo:ZVKobZY7
00;oUED000GoWW8:okV45?o:V1CobZ5BolZZA`02olZZIP0>ombcQ?oC_Xko
kM2Hog]10?oCZTOobZYVolZZAoo:ZVKobZY7om>Q:Oo:XCgobYPYolZH5?ni
SBT3olZH:@06olZH5?o:V2Wo^HdcolZH5?o:XCgo`H@00_o:V1@03?n`SAko
bYPYolZH5?o:V1CobZ4molZZAoo:XCgodjY7ombZ<omZ@@[og;=LolZH50;o
^H@D00ko/7/DokUW0?nNLQCoLSPDof0_5?mP;`[oLSPDoheE2_mkC1CobYPY
olZZI_o:ZTOobYPYok24:@?o/7/:0_niI`003oo1Q03o/7/Dol640?n`N`[o
/8dNoiib2_oL/hCog;=LolZZI_oL/ecodkj>ombcQ?oCZTOog;>4ombcG002
olZQDP0:olZH5?n`SAko/7/Doiib2_nNGQCoUEDDog]<2_m6;`[oARH:oeLL
00;o4A`:0_lJ2@X00olA70[o2@T:o`T92P02o`T92P04oaXV5?lS;ako6RHD
oa4L2P;o2@T:00_o2@TDo`TB2_lA70[o0000okV45?n`N`[oWUhDoh<h0?mk
C1CoARHDocdL2P04oa4L2P06oa4V5?l92ACo?A8:ong@V?nEZZgo/;k10_o1
al`2ol[@eP06omcSh?oChoGoLXf4oh>4Non`/kOo`LO<0_oLhn1Oooooo`04
ojn_[oo;bl_og]kNon[ZjP7ol_;b003oonk^kQWok^k^00WohN7Qom[Jf_o?
cloo_Kfmoj>SXol=E:koY/KVokK@k_mi[nh00_n[g_l01?m^KVko];Bdon3P
h?o/k>aKonk^kP04oh=N5?mZ@@[oPehcoiEE00;oWW8D00KoYW80oh=N5?nN
LQCoWUhDoiib5?nVLP02oiib2P08og]<2_nEE@3oUEDDoiEE0?n=E@[oUED0
ojIb0?n=E@X2oiib2P04ojIW0?mP@ACobZ4mok2=<`;o^HdY01Co^Hdcok2=
7_n`Q2Wo/8@Yoiib5?nVLP3o/8dNok1k5?nVLQCo/7/:okV=5?nVLQCo^HdD
ok24:On`NaCo^Hdcok2=<onNNc?oYW80okV=<`;o/8dN00ko`H@0okV=5?ni
SACo^HdDoiEE0?n3GQCoi;=7okVZKoo:ZTOog;=LolZZI_oCZTOobZY7ombZ
<`;o^Hdc00OobZ4mokV=5?o:V1Co/780ol640?niSACo^H@Y00;o^H@D00Oo
^HdYolZQ?Oo:XCgobZ4molZH:OoCV0[o^HdD00;obYPD00?o`H@0okV=5?ni
SBT00_niSC<05_o1Q03o^HdDokV=:OniSACo/8dNokV45?n`N`[o`H@0okV=
:On`SAko^HdcolZQ?Oo:XE;o/8dcok2=7_mkC1CoLSPDoiiN5?niSACobZYV
ombcQ?oT/dL2om>nSP;og;>400OokM2Hoh=N5?oCZTOobZYVolZQD_o:ZVKo
bZ5B00?obYPY00Go`H@0olZH5?niSBWodj4YolZH5002olZQ?@?obYPY0_ni
SA@3om>H2P?obYPD00kobZ4mombZ<ooCZTOog:XcofYE7_o]aecobYPYokV=
5?o:V1CoWUhDol640?nVLQCoLSP0oheE2P;oPcP000CoLSPDojIW0?n`SC?o
bZ5B0_o:V2T03?n`Q2Wo/780ol640?n`N`[o^FL0okV45?o1Q03o/7/:okUW
0?o1Q03odiP:oiEE00;og;=L00Codkj>ombcQ?oL/hCog;>40_oC_Xh04_oC
ZTOog;=LombcG?o:V1Co/8@Yok2=7_n`NaCoWW8:oh=N5?mkC1Co?A8:odHV
2_m6;`[o8a`:ob`B0?lA70[o2@T:oa4L2P;o2@T:00Go4A`:o`T92_lJ9QCo
8blNoaXV5004oa4L2P0Co`T95?lA70[o2@TDojI<0?o1Q03oWUhDoheE2_n3
@@3oH2lDob<V2_lJ2@[o2A8:oaX92_l94P[o2@TDo`000?lS70[oon>>oiFH
X`02ol77c00;ojK7h?o1alcob]3FojK7h?o]kN[oH79kofYkKoo1alco/;k1
ongfmOoLhn00Goo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00oooVi^HI
onKViP09om[Jf_oCdm?ob<S8okNg]onMWIgo2U6^ojC3iOnhd^ooNJk/00;o
[=oo00CoJVYZojj^[_oHf=Soi>CTFooVi^H01OnNLQCoWW8cog]<5?mkC0[o
WW8D00;oSED:00OoUED0oh=k<onEEACoWW8:oij=:OnEEACoUED000;oSED:
00OoUED0oh=N5?nEE@3oUED0oiEE5?n=E@[oWW8:00;oUED000koJUDNombZ
<on`SC?obZ4mokV=<oo:ZTOo^HdcokV=:On`N`[oYW8Doiib2_nNLQCo^HdD
ojIb00;o/7/:0_nVLQ@02oniSBWo/8@YokV=<oniSC?o/8dNok1k2_niSC?o
/8dNok24:OniSACo/78000;o^HdD0_n3GQ@03?o:ZVKog;=LolZZI_o:ZTOo
bZYVolZQD_o:XCgobZY7olZH5?o:V2Wo^Hdcol6400;o^HdD00?o^H@DokV=
5?niQ1@00_n`Q2T02?niSBWobZ4molZQ?Oo:V2Wo^HdDolZH5?o1Q03obYPD
0_n`SAh02?o1Q03o/8@YolZH5?niSBWo^H@DokV=5?o:V1Co/7/D0_niQ1@0
4_o1Q03o^HdcolZQ?OniQ1CobZY7okV=<on`SC?oYW80of0_5?nNGQCoUEDD
ok1k2_o:XCgoi;j4olZZI_oC_Xkog;>4omc7X`;odkj>00Coi;j4oh=k<oo:
ZTOobZY70_o:XE82olZQ?@;obYPY0_niQ1@00oo:V1Co^HdYolZH:@02olZH
:@07okV=:Oo:V2WobYPYolZH5?o1Q03obYPDokV=<`02olZH500?olZH:Oo:
V1CobYPYolZH5?o:XCgodj4Yog]<2_oCZTOobYPYol640?niSC?o/780okUW
0?niQ1CoPcP000;oLSPD00GoNd`Doh=10?nEE@3o/7/YolZQDP02olZQ?@03
ok2=7_o1Q03o^H@D00;o^H@D00Co/7/Dok1k2_n`N`[o/7/:0_niI`000onV
LP3odkj>onBnQ002ombcQ00?ombcG?o]d9Sog;=Lom>nS_oL/ecobZYVombc
G?o:ZVKobYPDok2=7_nVLQCoWUhDoiib5?nEEACo8bH:00;oARl:00co4A`:
ob<L2_lA70[o2@T:oa4L2_l92@[o4A`:o`T92_l94P[o2@TDodI17_lJ9Q@2
oa4L2P0GoaXB5?l0003o2A8:oaXB5?l0003oUD`Yol640?nVLQCoUEDDoh=1
0?m6;`[o?A`:ob<L2_lA70[o6Q8Do`T92_lJ4QCo2A8:o`T92_o:ZVKoYZZS
ol77c?n`_/400_o1al`2ol[@eP05omcSh?n3V:goLVMBok2n`Oo1al400_oL
hn1OonKViP04oifMWOng]kOob<S8om?Cd`7of][J003oonk^kQWok^k^00Wo
hN7Qom[Jf_o?cloo_Kfmoj>SXol=E:koYLCVokKBk_mi[^T00_nZh?l01?m^
KVko];Bdon3Ph?o/k>aKonk^kP09oiik<onNLQCoPehDog]<5?nNLQCoUEDD
oh=N5?mkC0[oSED:00;oPehD00GoWW8Doiib2_n=E@[oSED:og]<5003oh=1
000EoheE2_n3@@3oSED:oiEE0?n=E@[oUED0oh=N5?o:XE;o/8dcolZQD_n`
SAko^Hdcok2=7_n`Q2Wo/8dNojIb0?n=E@[oYW8Dok1k2_nVI`3oYW8000;o
/7/:013oYW8DokV=<on`NaCo/8@Yok2=<on`N`[o/8dNok24:On`SAko^HdY
okV45?n`SAko/780ok1k5?nVLP3oNd`D0_oL/e`01Oo:XE;og;=LolZZI_o:
ZVKobZY700;obZ4m00?o^HdDolZQ?On`SAh00oniSA@01_niSBWo^HdDok2=
7_niSC?o/8dNom>ZA`;o^Hdc017o`H@0okV=5?o:V1Co`H@0olZH5?niSACo
^H@DokV=<oniSBWobYPYokV=:Oo:V1Co^Hdcol640?n`SAko^HdDok1k5002
okV=:@0:okV4:OniSBWobZ4molZH5?nNGQCoARHDof11:OnVLQCo^IQLolZZ
IP;odkj>0_oL/h@01OoLaj?odkj>ong@V?o]d9SoPg/c00?obZ5B00?odjY7
olZZAoo:XCd00_o:V2T02oo:V1Co^HdDokUb<oo:V1Co^HdYolZH:Oo:XCgo
bYPYok2=7_o:V2Wo/8dN00;o^H@D00GobYPDolZH:Oo1Q03obYPYolZH5002
olZQ?@05ombZ<oo:V2WoPehDolZQ?OniSC<00_niQ1@05?n`LP3o/7/:okUW
0?n`N`[oYVL0ojIb5?n3>03oWUhDoiEE5?n`NbWobZ4molZH:OniSACo/7/D
okUW0?niQ1Co/7/DojIb5?n`N`[o^H@D1?n`N`X00onVI`3obZYVombcQ003
ombcQ00Aom>nS_oL/hCobZYVombcG?oCZTOodkj>olZZAoo:XCgo^HdYoheE
2_mZEAkoUEDDoh=N5?m69QCo?A`:of0_2_lA70X00_lJ2@X04olA70[o2@T:
o`T92_l92@[o4BHDo`TB2_l92ACo=5DYob<L2_lA9P[o2@TDo`TB2_lJ4QCo
4A`:o`T95?l94P[oPbl0ok1k2_nVLQ@00_n=E@X02omP;`[o?A`:ob<L2_lA
70[o2@T:oa4L2_l92ACo6Q8Do`000?n`SC?oPhAk00;oY[?100Wo`LO1ol77
c?o:d=KoY/OPomcSh?nEXKOoH5hcojJZ[On`_/400_oLhn1Oonk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q003ooooooaWooooo00Wol_;bon[Zj_oNg]ko
bl_;ojn_[ol;DjkoY/KVokWCk_mi[^/00_n[gol01?mfMWKo`L71oo3`l?om
oOeKooooo`;oWW8D00?oPehDoheE2_nEEA@00_n3GQ@00omkC1CoPehDog8h
5002oiEE5004oh=N5?nEEACoPcP0og8h00;oNd`:00?oLSPDoh=10?mkC0X0
0_nEE@001?nEEACoUED0of115?oLZS<2olZQ?@;o^Hdc0_n`Q2T01OnVLQCo
/7/Yog]10?n`SAkoYW8D00;oWW8:00go/7/DojIb5?n`SAko^HdYoij=<oni
SC?obZ4moiib5?nVLQCo^HdYolZH:OniQ1Co^H@Y00;o^HdD00Wo/7/Doiib
2_mZEAkog;=LolZQD_oL/ecobZY7okVZKoo:XE800oo:XCd04OniSBWobZ4m
ok2=7_o:V1Co^HdDok1b0?n`SAko/7/:ok2=7_n`N`[o^HdYok2=7_niSBWo
bYPDok1k5?niQ1Co/7/:00;o^HdD00So/7/:okV=5?niSBWobYPYokV=:Oni
SACo^HdcolZH50;o^H@D00co^H@Yok1k2_o:V1Co^HdYok2=7_o:XCgo^HdY
ok2=7_nVI`3oLSPDog]<2_n`NbT4ombcQ0;odkj>00Kog<NSong@V?oLaj?o
kM2Hoij=<oo:ZTL4olZZIP08olZQ?OoCXBWobZ4mok2=7_o:V1Co^G8cok2=
7_oCXBT2olZH:@0`ok1k5?o:V2WobYPYok2=7_niQ1CobYPDokV=:OniSACo
dj4YolZH5?niSC?obYPYolZH5?o:ZTOodjY7og]10?oCZTOo^H@YokV45?ni
SC?o/7/Dol640?niQ1Co/7/:okV45?o:V1Co^Hdcok24:OnEEACobYPDolZQ
?On`SAko^H@Dok1k2_niQ1Co/7/:oiib5?nNGQCoWW8:ol640?n`N`[o/780
ojIW0?n`N`[oYVL0okVZKooT_XCog<NS0_oC_Xh2ombcQ00<om>nS_oCZTOo
bZ5BolZQD_oCZTOobZ4mojIb5?mkC1CoARH:ofY12_mkC1CoH2l:0_m69PX2
ob<L2P04oa4L2_l92@[o4A`:o`TB2P;o2@T:0_lJ4Q@01Ol/9QCo8blNoa4L
2_lJ4QCo2A8:00;o2@TD01oo6Q8Do`T95?mP;aCobYPDojIW0?nNGQCoNd`D
ofY12_m69QCo6Q8DoaX92_lA70[o2@TDoaXB5?l92ACo0000oiEbAon`Q6Ko
`LO<ojJc`OnVan3o/;k1ol[@e_o1alcog>?PoiFZ[Om?IdOo/;>gok2n`OoC
hoGog>?P05oooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800?ook^k^6Oo^
k^h02OoQhN7of][Jolo?conm_KgoXj>So`mF[onS`^Co^=?_ogN^j`02oj[O
o`04ofi^K_nd];Coh>3Ponc/k5_ok^k^00?oWW/coiib5?nNLQ@00_n3GQ@0
9?nEEACoSED:oiib2_n=E@[oPehDoiEE5?nNLQCoWW8:oh=N5?n3@@3oJT4:
og8h0?mkC0[oLRH0oh<h0?n=E@[oPd40oiEE0?nNGQCoYT`0of115?oCZTOo
^HdcolZQ?OniSBWo^Hdcok2=7_n`Q2WoYW8Dok2=7_n=E@[oWW8Dok1k2_nE
E@3oYW80oiib2P;oYW8D00Oo^HdYok1k5?niSC?o^Hdcok1k:On`SAko/8@Y
00;o/8dN00?o^H@Dok1k2_n`Na@00_n`N`X04omP@ACog;=LombcG?o:ZVKo
g;>4ombcG?o:XE;obZY7olZQD_niSBWobYPYok2=7_o:V2Wo^HdDok1k5?n`
N`[o/7/DokV=5?n`Na@00_n`Q2T00oniV5cobYPYok2=7P02ok1k2P;oYW80
00ko/7/Dol640?n`N`[o/7/:ok2=7_o:XCgo/7/DolZH5?n`Q2Wo^HdDokV4
5?niSACo/7/DokV=<`;o^HdY00So^HdcolZH5?niSBWoYW8DoiEE0?n`NbWo
WW8DolZZIP?odkj>00?og;>4om>nS_o]d9P00_oL_Zd05?o]d9So^IQLolZQ
?Oo:XE;obZYVom>ZAoo:XE;obZ4mokV=<oo:V2WobYPDokV=:OniQ1Co`H@0
okV=<oniSBWo^HdcokUb<oo1Q03o/8dN0oniQ1@00oo:V1Co^H@YolZH5002
olZH500OolZH:Oo:V1Cog:XcolZH5?n3Nc?o/8dNolZH:OniSBWo/8dNokV4
5?niI`3o`H@0ok2=7_n`N`[o^H@DolZZAon`NbWoUEDDolZZAoo:XCgobYPY
okV45?n`N`[o^FL0ojIb0?nVI`3oYW8Doiib5?nVI`3oWW8:ok1k2P02ok1b
0003oiib2_n`SE;okM2H00;odkj>00oog;=Lom>nS_oC_Xkog;=Lom>ZAoo:
ZTOobZ5BombZ<on`Q2WoYW8Doh=N5?l/71Co4A`:of0_5?mZ@@X00_m6;`X0
1Ol/4P3o8a`:oaX92_lA70[o2@T:00;o2A8:00Ko4A`:o`T92_lJ71ko;3PY
oaXV5?lA9Q@2oa4L2P0<oaXB5?lA70[o4A`:o`T95?mG703o`H@0oiib2_nN
GQCoPd40og8h5?m69QCo;2HD0_lA9Q@02Ol94P[o4A`:o`TL5?l0003oUHAB
ok2=<on`_/7oY[?1ol77`@02ol77c008ojK7h?oLhn3oY[?1odINAonVZZgo
/;>gom?Ie_oLhn1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003oonKV
iQWoi^KV00Wof][Jom?Cdoo8b<So]kNgoifMWOl?EJooYLCVokWCkomg[^/0
0_nYg?l01?mZJV[o[Zj^omSHf?oTi>AKonKViP03ojJ4D_nNNc?oWW/c00;o
WW8D00coUEDDoheE2_n3GQCoUED0oheE2_nNLP[oUEDDoiib5?n3@@3oLSP0
og]<2_mG7002of0_2P03oeLL0?mkC0[oPd4000?oSED:00CoJT4:olZZI_ni
SBWobZ4m0_niSC<03?n`SAko/8dcok2=7_nVLQCoSED:ojIb0?nNLP[oYVL0
oiEE0?nVLP3oYW8Dok2=7P;o/8@Y0_n`SC<01on`Q2Wo/7/Dok24:Oo:V1Co
/8dNokV45?niSA@00_n`N`X00onNLP[oJT4:ombcG002ombcG00XolZZI_oL
/ecobZ5Bok2=<oo:ZTOobYPDok2=7_o:V1Co/8dNokV=5?n`LP3o/7/:ok1k
5?n`Q2WoYW80ok2=7_n`SC?o^HdcolZQ?On`SAko^HdDok1b0?n`N`[oYW80
ojIW0?n`N`[o/7/DojIb5?o:V2Wo^HdYokV45?o:V2Wo^HdcokV=5?n`NbWo
^H@Dok2=7_o1Q03o^Hdcok2=7P;o^Hdc00Ko^H@Yok2=7_nVI`3o^IQLokV4
5?o:ZVH2omc7X`;odkj>00?okM2Homc7XooC_Xh00_oLaj<06OnVXFKo^Hdc
olZZAoo:ZVKobZY7olZQ?OniSBWobZY7olZH5?niSC?obYPYokV45?n`N`[o
^H@YokV45?n`SAko/7/:okV45?n`LP3o^H@Yok1k2_o1Q03o^HdDokV45?o1
Q0000_o:V2T05oniSBWo^HdDolZQ?OoCXBWoWW8:okV=<oo:XCgo^HdYok2=
7_niSC?o`H@0ok1k2_n`LP3oUED0ok1b0?niSACo/7/YokV4:Oo:XE;obYPY
ok2=7_niQ1CoYW8000;o/7/:00goSED:oiEE0?nNGQCoWW8:ojIW0?nEE@3o
YW80ojIb5?nVI`3oYW8Dong@V?oL/ecodkj>00;og;>400?og;=Lom>nS_o:
XE800_o:XCd03oniSBWo^HdDok1k5?mG703o?A`:oaX92_m6;`[oEa`0odHV
2_m6;`[o8bH:ob<L2_lA70[o6PT:o`TB2P03o`T92P07oa4L2_l92ACo;2HD
ob<L2_lA70[o2@TDoaXB5003o`T95003o`TB2_lJ2@[obYPD00;oWUhD017o
Nd`Dog8h0?m6;`[o6Q8DoaX92_l92ACo6Q8Do`T95?lJ4QCo0000olZQD_nV
LU;o/;k1ojJc`On`/kOoY[?1ol77c003ol[@eP05odmWG?nEV:?o/;>gom?I
e_oLhn00GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00ooo^k^hIonk^
kP09on7QhOoJf][oclo?okfm_OnSXj?o2eBaojC4i_nidnooMZgZ00;oZn3o
00CoKVi^okBd]?oPh>3ok>c/Foo^k^h01?n`SC?oWW/cok2=<onNNc<2oiib
5005oh=N5?nNLP[oUED0oh=N5?n3Nc<00_nNLQ@06?n=E@[oNd40of0_2_mP
@BWoARH:oeLL0?mP;aCoLSP0oh=10?n=E@[oWW8:ojIb0?m6;`[obZ5Bok2=
<oo:XCgo^HdcolZQ?On`SAko/8dcok2=7_n`SC?oH44Doiib2P;oSED:00Oo
UED0oiib2_nNLP[o/8@Yok2=7_n`NaCo^HdY00;o/8@Y00coWW8DokV4:Oni
SBWo^HdYok2=7_niSACo/7/:okV=5?n`N`[oJT4:ombcQ?o:ZTL2olZZIP0;
ombcG?o:XE;obZY7olZQ?OniSBWobYPDokV=<on`SAko/7/Dok1k2_nNLPX0
0_niSA@02_n`N`[oYW8Dok24:On`SC?o^HdcokV=:On`N`[oYW80oiiN5?nV
I`03oiib2P0Fok1k5?o:XCgobZ4mokV=5?o:V2Wo/8dNokV=5?niQ1Co/8dN
ok1k5?n`SAko^HdDok24:Oo:ZTOobZ5BokV4:OniSBWoWW8:olZQD_oC_Xko
bZYVom>nSP;okM2H0_oC_Xh04?o]d9Sob[j]ong@V?o]d9SobZYVok2=D_o:
ZTOobZ5BokV=<oo:XCgobYPDok2=7_o:V2WobYPDolZH:OniQ2T2okV45003
okV=5?niQ1CoWW8:00;o^H@D00?o/7/Dok1k2_o1Q0000_niQ1@04Oo:V1Co
/8dNolZH5?o:V1Co`H@0olZH:OoCXBWoWW8DokV=<oniSBWobYPDolZH:Oni
SBWo^H@YolZH5?n`N`[oWUhD00;o/78000Ko^H@Dok2=7_o:V2WobYPYokV4
:On`N`X3oiib2P0@oiEE5?nVC03oWUhDojIW0?nNGQCoSED:ojI<0?nNLP[o
YW80ojIb5?o]d9Sog;>4olZZI_oL/hCobZYVomc7X`CobZ4m00Go`H@0ojIb
5?n`N`[oH2l:ob<V2P02odHV2P0=of0_2_m69P[oARH:ob<V2_lJ2@[o8a`:
o`T92_lA70[o2@T:oa4L2_l92@[o6Q8Do`TB2P02ob<_7P09oaXV5?l94P[o
2@TDo`TB2_l92ACo4A`:oaX92_l92ACodh@000;oYW8D00coNd`Dof115?lm
70[o;1`Doa4L2_lJ4QCo2A8:oaXB5?l92ACo0000ok2=<onNQ6H2ok2c]`03
ojJc`On`/kOo`LO100;o`LO<00Kob]3FodIWG?nEXHkoUJ6gom?Ie_oLhn1O
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q003ooooooaWooooo00Wol_;b
on[Zj_oNg]kobl_;ojn_[ol;DjkoYLCVokG@k_mi[^`00_nWg?l01?mfMWKo
`L71oo3`l?omoOeKooooo`03ojJ4D_nNSC?o/8dc00;oWW/c00Co/8dNoh=N
5?nEEACoUEDD0_nNLQ@05_nNLS?oWXdYog]<5?mkC0[oH2lDodHV2_mG703o
ARHDog8V0?mP;aCoH2l:oh=10?mkC1CoYT`0odH_2_oL/eco^HdcokV=:Oni
SC?o^HdYok1b0?nNSBT2ojIb5008of0_2_n3@@3oUED0oiEE0?n=E@[oYW80
ok2=7_n`SC<2ojIb500Bok2=<on`Q2Wo/8dNok2=7_niSBWo^Hdcok2=7_ni
Q1Co/7/DokV=5?n`LP3o/7/:of0_2_o:ZVKog;=Lol6cS_o:ZVKobZY70oo:
XE801Oo:V2Wo/8dNok2=7_niSACo/8dN00;o/7/:0_n`LP000onVLQCo/7/Y
ok24:@02olZZA`0>ok24:Oo1Q03o/7/:ojIb0?nNGQCoUED0oiib2_n`NaCo
/8dNokV=<oo:V2Wo^HdYok2=7_niSBT2okV4500:okV=:On`NaCo^HdDokV=
<oniQ1CobZ5BolZZAoo:XCgo^HdYok1k50;obZ5B013obZYVom>nS_oC_Xko
g;>4om>nS_oL/hCog<NSom>nS_o]d9Sob[j]om>nS_niSACobZ4molZQD_ni
SC?obZ5B0oo:V2T00oniSBWo/8dNokV45002okV45007ok1k2_n`LP3o/7/:
ojIb5?nVLP3o/780ok1k2P02okV45005ol640?niSC?o`H@0okV=:OniQ2T0
0_o:V1@04OoCXBWo^HdDoiik<oo:V2WobZ4mok2=7_o:XCgoYW8DokV45?n`
N`[oYW80ok1k2_n`LP3o^H@Dok2=7_niQ2Wo^HdD00;o/7/:00GoYVL0ok1k
2_nNGQCoWW8:oiEE0002oheE2P0:ok1k5?n=E@[oWUhDojIW0?nNLP[oSED:
ong@V?oL/hCodkj>ombcQ0;odkj>00Sog;=LolZQD_oLZS?obZY7okV45?n`
N`[oYVL0og]<50;o?A`:00ooLSPDofY12_lS9P[oH2l:ob<V2_lS70[o6PT:
o`T92_lJ4QCo2@T:oa4L2_l92@[o4A`:o`T92_lS;ah00_lJ4Q@05olA9QCo
6Q8Do`TB2_l94P[o2@T:o`TB2_l0003o/8dNoiiN5?nVLP3oNd`Dog8h0?m6
9QCo;1`Doa4L2_l92ACo4A`:oaXB5?l971Co2@T:oc@_7_n`SC?oYZZS00;o
/;>g00[oY[?1ojK7h?nVan3o`LO1omcSh?m6IecoUJ6>ojJZXoo1alcog>?P
Goooool01?n_[joobl_;omkNg_oZj^X1oo;blP00ooo^k^hIonk^kP09on7Q
hOoJf][oclo?okfm_OnSXj?o2eBaojC4i_nhd^koMZgZ00;o[=oo00CoKVi^
okBd]?oPh>3ok>c/Foo^k^h01on`SE;o/8@YoiF4D_nVLQCo/8@Yoij=:OnE
EA@01?nNLQ@03?nNLS?oWW/coh=10?mkC1CoJT4:oh<_0?lm70[oH2l:og8h
5?mb9P3oLSP0og]<50;oPd40013oH44DombcG?n`SC?o^HdYok2=<on`Q2Wo
/8dNok2=<on`N`[oWW8Dof0_2_mZEAkoSED:oiEE0?n=E@[o/7/:0_nVLQ@0
1onNLQCo/8@Yok24:OnNSC?o/8dNojIb5?n`SC<00_n`SAh3okV=5003ok1k
2_n`SAkoJT4:00;og;=L0oo:ZVH2olZQDP0:olZQ?OniSBWo^HdcokV=<oni
SACo/8dcok1k2_nVLP3o/7/:ojIb00;o/8dN02;oYW80olZQD_niSC?obYPD
ok2=7_n`LP3oWW8:oheE2_nNLP[oYW8Doij=:On`NaCo^HdcolZH:OniSBWo
bYPDokV=:OniSACo/7/Yok2=7_n`N`[o^HdYok24:OniSBWobZ5BolZZAoo:
XCgo/7/Dok2=7_o:ZVKobZY7olZZI_oC_Xkog<NS1?oC_Xh01_o]d9Sodkj>
ong@V?niZVoo/8dcokVHG0;obZ4m00CobZY7olZH5?niSC?obYPD0_niSBT0
2?niQ1Co/8dNok1b0?nVLQCo/780ojIW0?nVLQCoYVL00_n`N`X08On`LP3o
bYPDok1k5?o1Q03o^HdDolZH:Oo:V1Co/8dNolZH:OoCZTOo/8dNoij=:Oo:
V2Wo^HdcokV=:Oo:V2Wo/7/DolZH5?niQ1Co/7/:ok1b0?nNLP[o/7/:ojIb
0?niQ2Wo^H@Dok1b0?nNLP[oYVL0ojIb5?n=E@[oYW80oiEE0002oheE2P08
ojI<0?nEE@3oSED:oiib2_nVLQCoUEDDom>nS_oL/h@2om>nSP0CombcG?oC
_XkobZY7olZZI_o:XCgo^HdYok2=7_n`N`[oYVL0og]<2_lm70[oH44Dog8h
5?mkC0[o?A8:odHV2_m69QCo4A`:ob<L2P02oa4L2P03o`000?l92@[o4A`:
00;o2@T:0_lS;ah04?lA9QCo6PT:o`T95?lJ4QCo2@TDoa4L2_lJ2@[o2@TD
okUW0?nNGQCoWW8DoheE2_mP;`[oARH:oa4L2_lJ2@X2oaXB5007o`T95?l9
4P[o2@TDodI17_nVQ5;oUIRSojJc`@03ok2c]`08ol[@e_o1alcob]3FodmN
I_n=V8koYZ6Hol[@e_oLhn1Oonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
003oonKViQWoi^KV00Wof][Jom?Cdoo8b<So]kNgoifMWOl=E:koY/KVokK@
k_mi[nh00_n[g_l01?mZJV[o[Zj^omSHf?oTi>AKonKViP07oij=<onNNc?o
/8dNoiik<onNLP[o/8@Yoiib2P02oiib500Toh=N5?nNLQCoWXdYok24:On3
GQCoLSPDoh=N5?mkC1CoPbl0of0_2_mb9P3oLSPDog]<5?mk@@3oSED:oiEE
0?m69QCog:XcokV4:OniSBWo/8@Yok1b0?nVLQCo/8dNoiib5?nEE@3oLSPD
of0_2_mkC0[oUED0oiiN5?nVLP3oWW/cok2=7_nVLQCo/7/Y0_n`Q2T00on`
SAkoYW8DokV45002ok2=7P08okV=5?n`Q2Wo/7/:ok2=7_nNLQCoH44Dombc
G?o:XE83olZZIP04olZQD_o:XCgo/8eBolZQ?@;o/8dN00co`H@0ok1b0?n`
LP3o/7/:ok1b0?n`N`[oWW8Dok1k2_n`NbWobZY7okV=:OniSC<2ok1k2P0:
oiib2_n=E@[oPehDoh<_0?nVLP3oYW8DokV=<on`SAko^HdDokV=:@;o^H@D
00Oo/7/Yok1k5?n`N`[o/8dcok2=7_niSBWobZY700;obZ5B00Ko/8dNom>H
2_o:XE;obZ5BolZZI_oLaj<4om>nSP;og<NS00SokM2Hombn[OoC_Xko/8dc
olZH:Oo:ZTOo/8dNolZQ?@;o^HdY0_o:V1@05oo:V2WoYW80okV=<on`N`[o
YVL0oiib5?nVLP3oUEDDog]<5?nVI`3o/7/:okUW0?n`SAko/7/:ok2=7_ni
Q1CobYPDok2=7_niQ2WobYPDolZZAon`LP3oWW8c00;o^HdY0_o:V1@01?ni
Q2Wo/8dNok2=7_nVLQ@2ok1k2P;oWW8:0_n`N`X01?n`LP3oYW8DojIW0?nE
E@02oiiN5003oiEE0?nNGQCoSED:00;oSED:01?oYT`0oiiN5?nVI`3oPd40
onBnQ?o:ZVKodkj>ombcQ?o:ZVKodkj>olZZAoo:XE;obZ4molZH:On`SAko
/7/Doiib2_nEE@3oH2l:00;oNd`D00[oJT4:ob<V2_m69P[o8bH:oa4L2_lJ
2@[o2@TDoa4L2_l92@[o4A`:0_l92@X04_l94P[o;2HDob`V5?lJ9QCo2@TD
oaXB5?l92@[o4A`:o`T95?lA70[o0000ok1k2_nVI`3o/7/Doh=10?mP;`[o
ARHDoaXB50;o4A`:00[o2A8:oaXB5?lJ4QCo2@TDob`L5?o:XE;oUHAkojK7
h?nEZZgo/;>g0_nV/l401oo1alcodn?eofYkKon3Q8koUIRSol77c?oLhn00
GooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00ooo^k^hIonk^kP09on7Q
hOoJf][oclo?okfm_OnSXj?o2U6^ojC3iOnhd^ooNJk/00;o[=oo00CoKVi^
okBd]?oPh>3ok>c/Foo^k^h5oiik<`0<oij=<onEEACoNd40oh=N5?nNLQCo
UEDDoiik<onNLQCoWUhDof0_2_nEEACoNd`:0om69PX2odHV5007oeLL0?mb
>1CoPd40odH_2_o:ZVKo/8dNokV=:@02ok2=7P03oiib2_n`SAko/7/:00;o
Nd`D01WoARl:ofY12_mkC1CoSED:oiib5?nVLQCo/8dNok24:On`NaCoWXdc
ok24:OnNLP[oYW8DokV45?niSBWo^HdDok1k2_n`Q2Wo^HdDok1k2_niSACo
H44DolZZAoo:ZVKog;=L00;obZYV0oo:ZTL07Oo:XCgo^HdcokV=<oniSACo
/8@Yok1k5?nNLP[o/7/:ojIb0?n`N`[oWW8DojIb5?o:XE;obYPYok2=7_ni
Q1Co/780ok1k2_mkC1CoARHDog8h5?nNGQCo/7/Dok2=7_o:V2Wo^HdDokV=
:On`SAko/7/:00;o/8dN00KoWW8Dok1k5?niSBWo/8dNolZQD_niZVl2olZQ
?@04ok2=7_o:XE;obYPYokVZK`;odkj>00_okM2Hom>nS_oC_Xkog<NSom>n
S_oLaj?ob[j]om>nS_nNSBWobZY7okVHG002olZQ?@09olZH:OniSBWo^HdY
olZQ?Oo:V2Wo/7/DokV=5?n`N`[oYVL000;oWUhD0_n3;`001OnVLP3o/7/D
ok1k5?niQ1Co/8dN00?o^H@D00Ko^HdDok2=7_o:V2WobZ4molZH:On3GQ@2
okV=:@0?olZQ?OniSC?obYPYok2=7_niSC?o/780okV45?nVLP3o/7/:oiib
2_n`NaCo/7/Yok1k2_nNLP[oUED000;oWUhD0onEE@002?nVC03oUED0oiiN
5?nEE@3oSED:oiib2_nEE@3okM2H0oo:ZVH01oo:XCgobZYVom>ZAoo:ZVKo
^HdcolZH:On`SAh00_n`N`X01_nNLQCoSED:oh=N5?mkC1CoNd`:ob`L50;o
ARH:00Wo6PT:ob<L2_lJ4QCo2@T:oa4L2_l94P[o2@T:oa4L2_lJ2@X00_lJ
9Q@01OlJ4QCo4A`:o`T92_l92@[o4A`:00?o2@TD00Ko/5D0oiib2_nVLQCo
Nd`Dog8h0?m69Q@2oaXB500:o`T92_lJ4QCo4A`:o`TL5?l92ACo;180ojJ4
D_nELTOob]3FoiFZ[@;o/;>g0_o1al`01_o:d=KoLXf4oh>=Q?n=V8ko`LO<
omcSh5ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400?oooooo6Oooool0
2Oobl_;oj^[ZomkNg_o;bl_o[jn_o`eD[_nUa>Ko]];^ogV^j@02oj[Po`04
ogIfM_o1`L7ol?3`oogmoE_ooooo00CoWXdcok24:OnNSBWoWW/c0_nNLQ@2
oiEE500Cog]<5?nEEACoWW8Doij=:On`NbWoPehDofYE7_mkC1Co;1`DocdL
2_m69QCo?A`:odHV5?lm70[oARHDocdL2_mb>03oAT4NombZ<`02ok24:@03
ok2=<on`SAkoWW8D00;oYW8D013oNd`Dof11:OlA9QCoLSPDoh<_0?n=E@[o
WW8:oiib5?nVLQCoWW8Doij=<on`SC?o/8dNoiEE5?n`NbWo/8dc0oniSBT0
2OniSACo/780ok1k2_n`N`[oEa`0om>ZAooL/ecobZY7ol6cSP02olZZIP0;
olZQ?Oo:XE;o^HdcokV=:Oo:XCgo^HdDok2=7_n`N`[oYW8Dok1k2_nVLQ@0
0_nNLQ@05_n`Q2Wo^HdcolZQ?On`SAko^H@Dok1k5?n`LP3oYW80ocdL2_m6
@AkoNd`Doiib2_niQ2Wo^HdYok1k5?n`SAko^HdDokV45?n`SAko/7/DojIb
5?n`Na@2okV=:@0:olZZI_o:XE;obZ5BolZH:OniQ1CobZ5BokV=<oo:ZVKo
g;>Som>nSP;og;>40_oC_Xh05Oo]d9Sodkj>ong@V?oLaj?oWW/colZQ?Oo:
XE;obZY7okVHG?niSC?obYPDokV=:Oo:V2Wo^HdDokV=<oniQ1Co/7/Doiib
2_nVI`3oYW8DokV45002oiib2P0Jok1k2_nVLQCo/780ok1k5?n`N`[o`H@0
ok2=7_o:V2Wo/8dNolZH5?o:ZTOobYPDoh=N5?o:ZTOo^H@DokV=<oo:V1Co
bZ5BokV=:Oo:V2Wo/7/Dok1k2_n`LP3o/7/:oiEE5?n`SAh2ok1k2P03ojIb
0?nNLP[oUEDD00;oSED:00CoPd40oiiN5?nEE@3o/5D00_n=E@X01onEE@3o
YW80oiEE0?oL/hCobZ5BombcG?o:ZTL00_o:ZVH03?o:ZTOobZYVolZZAoni
SC?o^HdYokV=5?n`NaCoWW8DoheE2_mkC0[oNd`DofY12P;o?A`:00?o8bH:
ob<L2_lA70X00_lJ4Q@08Ol94P[o2@T:oa4L2_l92@[o2@TDoaXL7_lS;ako
4BHDo`T95?lJ4QCo4A`:o`TB2_lJ4QCo4A`:o`T92_n=E@[o/5D0oiEE5?n3
@@3oH2l:odHV5?lS70[o6Q8Doa4L2_l92ACo6Q8Do`T95?lJ4QCo2@TDokV=
<on3GS?oY/OPoiFZ[@02ok2c]`08ojJc`Oo1alcob]3Foh>HS_mbSHCoSIR>
ok2c]ooLhn1Oooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b003oonk^kQWo
k^k^00oohN7Qom[Jf_o?cloo_Kfmoj>SXol?E[7o<7;0oeNBeOmk/NcoVlko
okS/oom^KVko];Bdon3Ph?o/k>`0Foo^k^h3oiik<`0Aoiib<onEE@3oPehD
oh=N5?n=E@[oPehDoiEE5?nNSBWo/7/Yoiik<onEEACoNd`:og8h5?l/71Co
;2HDob`L5?lJ9Q@00_l/9Q@07?l/71CoARHDocdL2_ld;ako^Hdcok2=<on`
Q2Wo/8dNojIb5?n`N`[oWW8:og]<5?mb>1Co4A`:ob`V5?mb>1CoNd`DoiiN
5?nNLP[o/7/:ok2=7_n`NbWoYW8Dok2=<on`Q2Wo/7/Yok2=7_n`Q2T2okV=
:@09ok2=7_n`NaCo/8dcok1b0?n`NaCoARH:ombcG?o:ZVKobZ5B00?obZYV
00GobZ5BolZQ?Oo:ZTOo^HdcolZQ?@02okV=:@07ok2=7_n`NaCo/780ok24
:OnVLQCo/8@Yok2=<`03okV=<`08ok2=7_niQ1Co/7/DokV45?n=E@[oH44Y
oiEE5?nNLPX2okV=:@0=okV45?niSBWo^HdcokV=:OniSACo/7/Dok1k2_n`
SAko^H@YokV=<oniV5cobZY7olZQ?@02ok2=7P03olZQD_o:XCgobZYV00Go
dkj>00?og<NSom>nS_oLaj<00_oC_Xh00onNNc?obZYVolZZIP02olZZA`0>
olZQ?On`SAkobYPYok2=7_niSBWo^H@Yok2=7_niSC?oYW80ojIb5?nNGQCo
SED:oiEE5?n3@@02ojIb5003oiib2_nNGQCo/7/:00;o^H@D01Oo`H@0ok2=
7_niSACobYPYombZ<omP;`[obZ4mokV=:Oo:XCgo/8dNolZQD_n`SAkobYPY
ok1k5?niQ1Co/7/Dok1k2_nEEACo/7/:okV=:On`NaCo/7/:oiib2P02oiiN
5003ojIW0?nEE@3oUED000?oSED:0_nEE@000onNGQCoUED0om>ZA`02olZZ
IP03olZQD_o:ZVKobZYV00;obZYV01WobZY7olZQ?Oo:XCgo/8dNok1k2_nV
LQCoWW8:og]<5?n3GQCoH44DocdL2_l/9QCoARHDoa4L2_lJ2@[o2@TDoa4L
2_l92ACo6Q8Doa4L2_l92ACo6Q8Doa4L2_lS;ako4A`:00;o6Q8D00co2@T:
o`T95?l92ACo2A8:o`T95?mP;`[oWUhDoheE2_mkC0[oH2l:odHV5?lS9PX2
oaXB500<oa4L2_l92ACo6Q8DoaXB5?l0003obZY7ofYE7_nVan3oYZZSoiFZ
[On`/kOoY[?10_o1al`01On3V:goJW9LohfHS_n`/kOog>?P05ook^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN400?ooi^KV6OoVi^H01OoJf][odm?ColS8
b?ng]kOoNGUi0?oo`L71_Oo1`L401?n@T93o]kNgolS8b?oCdm<1om[JfP00
ooo^k^hLonk^kP03on7QhOoEeMGoeMGE0?ooeMGE_?oEeMD00ooQhN7ok^k^
onk^kP02onk^kP00oooooolKooooo`;omoOgooo_knnnono_k`;omoOg0ooo
ool00?ook^k^6_o^k^h3onWYjOooi>CT__oTi>@3onWYj@;ok^k^003oonKV
iQWoi^KV1?oShn?oon3Ph;koh>3P1?oShn<1onKViP00oomoOgooogmoOn3o
Ogmo00001_o[jn_oi^KVon;Rh_oNg]kogMgMomcLg0;ogMgM0ooNg]h00ooL
g=cog]kNomgMg@02omgMg@3oomkNg_oLg=cog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kN001IomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kog=cLomgMgOoK
fm/00_oLg=`0oooMgMgog=cMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomcLg?oNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNgP00JOoM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMg@03omkNgP03omgMgOoNg]kog]kN00?ogMgM0OoQhN41
onOWi`7oj^[Z00000oo/k>coi^KVon3Ph007omWIf@04omSHf?oFe]Kodm?C
om3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?C
doo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooC
dm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=SoomWIfAKofMWI0_oHf=P0
0ooIfMWof=SHomSHf003omWIf@;of=SH1OoIfMT00ooHf=Soe]KFom?Cd`02
om?Cd`03omKFe_oHf=Sof=SH00kofMWI00Cof=SHomWIfOoIfMWof=SH4?oI
fMT2omSHf?oofMWI@_oIfMT00ooHf=SofMWIomWIf@06omWIf@7og]kN0OoV
i^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoPh>3oh^;R00;ohN7Q
00gog]kNom_KfooCdm?oalO7ok^k^onb/[;o[Jf]ok:b/_nk^k_oalO7om?C
dooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?oalO7ok^k^onb/[;o[Zj^
ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?o
alO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO0?oohN7Q
1ooQhN4:on3Ph003omoOgooPh>3oh>3P00KogmoO0_oPh>03omoOg`Goh>3P
00OogmoOom_KfooGemOoe=CDomGEeOoIfMWogMgM00;oh>3P00?ogmoOon3P
h?oPh>000_oQhN47on3Ph0KogmoO00?oh>3PomoOgooPh>002ooPh>001?oO
gmoog]kNomkNg_oOgml2on3Ph3[ohN7Q00?oh>3Pon7QhOoQhN401OoQhN40
0ooPh>3ohN7Qon7Qh@0bon7Qh@03on3Ph?oQhN7ohN7Q0<KohN7Q00?oh^;R
on7QhOoRh^801?oQhN41onCTi07ojNWY0Oo]kNd00003oo3`l?o_knoolO7a
00?ol?3`0?ookno_oo3`l?o^k^kojNWYom_Kfoo1`L7oY:BTohb<S?mjNW[o
MgMgog]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7alOo_
knoolO7_ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_oNg]kogMg
MomkNg_oS8b<ojBTY?o2`/;of][Jon[Zj?o]kNgolO7aono_kooalO7okno_
oo7alOo_knoolO7_ong]kOoZj^[of][Jol;2`_nTY:CoS8b<og]kNomgMgKo
Ng]kohb<S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knl004?olO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a00;ok^k^
00Koj^[Zong]joo/k>cok^k^on_[joo^k^h2onc/k007onWYjOo]kN_ok>c/
on_[jooVi^Koj>SXonOWi`02onSXj004ong]joo[jn_oj^[ZonOWi`;ojn_[
00kok>c/on[Zj_o^k^cokNg]onc/k?oVi^KoiNGUon7QhOoPh>3ohN7Qon[Z
j?o[jn_ok>c/onWYj@;ok^k^00ColO7aonk^k_o_kngoj^[Z0_o/k>`03Oo`
l?3okNg]onc/k?oWinOoj>SVonKVi_oYjNWoinOWon_[jooZj^[ojn_[on[Z
j_o_knd00_o/k>`01_oZj^[ok^k^onc/k?o/k>coj^[Zonk^k0;okNg]0?oo
inOWonSXj?oVi^Koj^[Zon_[joo_kngok^k^oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knl004golO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7ol?3`ono_
koo`l?3okno_oo3`l?o_knool?3`ono_k`04oo3`l00000?ol_;bonk^k_oW
inL01?oUiND04?oTi>CogmoOom7AdOna/K7oRXZ:ofEUIOmADE7oADE5od92
@_m5ADGoDE5AofIVI_n:RXWo/K6aom7AdOoNg]h2onCTi003onGUiOoTi>Co
iNGT00;oi>CT00oog]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5
ADGoDE5AofIVI_n:RX[o/K6aom7Ad?oNg]h00_oTi>@0oooUiNGoi>CTonGU
iOoTi>Coi>CSomkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5
oe5ADOmVIVKoRXZ:ok6a/OoAdM7og]kNonCThooTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUi@007_oTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUon;Rh_oOgmoo
f][JomcLf`;ogMgM017of][JomgMgOoNg]kog=cLomSHf?oMgMcog=cLomSH
f?oDe=Coe]KFomCDe?oEeMGof=SHomkNgOoLg=cof=SHomKFeP02omcLg00K
om_KfooIfMWogmoNon3Ph?oLg=coemOGodI6A_l`<33oN7Qhol71`OoKfm[o
gMgMom_KfooHf=Sog]kNon7QhOoUiNGohn?Son3PgooKfm_of][JomkNg_oS
hn?oh>3PomcLg?oEeMGoeMGD00?oeMGE00Kog=cLom_KfooIfMWofm_Kon3P
gooNg]h2om[JfP07omoOgooNg]kofm_KomWIfOoNg]gogmoOomcLg003omKF
eP3oom[Jf_oNg]kohn?Ron?ShooUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoShn?oiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU0013onCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi004onGUi@06onCT
i?oUiNGoiNGUonGUiOoXj>SokNg]0Oobl_800003ooCdm?o]kNgoinOW00?o
h>3P01;ogmoOomkNg_oBd];o];BdohN7QomLG5coKC/eoii>@_o=KUkojH=_
ole_GonMCD?oKC/foeaLG?n7QhOo];Bdom;Bd_oNg]h5on3Ph00AomkNg_oB
d];o];BdohN7QomLG5coKF0/oijF;_o=cCoojNU=olg=?onNVRooKF<]oeaL
G?n7QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aL
odMW;_mXWS?oTLe7oj[YEOnAcDOoJYhdodUZ;omLG5coQhN7okBd]?oBd];o
g]kN0?ooh>3P1OoPh>00@ooNg]kof=SHom;Bd_oDe=Coe]KFom;Bd_o?cloo
d];BomKFe_oCdm?odM7AomGEeOoFe]Kod=3@olC4a?o;bl_oclo?olW9bOo4
a<Cof=SHomGEeOo@d=3oa<C4om3@d?oHf=Sod];Bom7AdOoHf=Sofm_KomKF
e_oAdM7oUIFEoj2PX?ln?SkoBd];omCDe?oHf=Sod];Bom7AdOoHf=Sog]kN
on3Ph?oOgmoof][Jom?CdooAdM7of=SHomgMgOoJf][odm?Colo?coo0`<3o
d=3@olg=cOno_kooe=CDomKFe_oAdM7oe=CDomWIfOoHf=SodM7Aom;Bd_oH
f=SofMWIom?CdooAdM400_oGemL02?oAdM7oclo?olS8b?o4a<Cof=SHom_K
fooNg]kogmoO>ooPh>000ooOgmooh>3Pon3Ph002on3Ph003omoOgooPh>3o
h>3P0?[oh>3P00?ogmoOon3Ph?oOgml00_oOgml3on3Ph003on7QhOoWinOo
k>c/007om?Cd00000oofm_Kol_;bon_[j`03onSXj00ConOWiooRh^;ocLg=
oinOWomZGUkoScH^ona`HOoiWI3ooK6Uoofl[oom]:OonInConedHonB=boo
JemOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWom^
IUooTg8RongAA?oilgCooOf=oogmUOomoHkonOQfongGAonCLb;oKVMOoinO
Woo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWomPJ5ooBg`S
oi;QBonmnG_od?fBomSmVooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=cLgo
h^;RonOWi`3oonSXj0Coj>SX02Woi^KVomoOgol`<33oShn?om_Kfoo7alOo
R8R8olG5aOoKfm_oYJFUo`410OoMgMgog]kNofe]KOl820So4A4Aog=cLol`
<33o92@TomgMgOoKfm_oBd];o``<3?mRHV;ohN7Qofe]KOlj>S[ogmoOon?S
hoo3`l?o0000ol71`OoQhN7oX:2Po`d=3OoGemOog]kNogemOOlG5aOogMgM
onCTi002onKViP0Don;Rh_moOgoo:2PXomoOgooUiNGohn?SokJf]_lO7aoo
2@T9ocHf=_mdM7Co20P8oiJFU_oMgMgo3`l?oiNGUooQhN7ogmoOod92@_mT
I6@2on3Ph00<ogEeMOlb<S;ogMgMom_Kfonn_[ko?3`lo`820_lO7aoo5ADE
okBd]?oVi^KoinOWoooXj>Q7onSXj07ok>c/0Oobl_81ooKfmP0000?omoOg
ooShn?ohn?P00oohn?P04oogmoOok^k^olk>c_n@T93oQBl[onUTE_okTXOo
oZJKoojaYOoo]j[oo[>VoojXW?ojU8WokVQIohTa:on@T93oc/k>onk^k_og
moL00oohn?P04oogmoOok^k^olk>c_n@T93oVFT[oo2m?Ookh6koo_B2ookn
R_oooi;oo_j<ookhPookiG3ol<8noiUZ:on@T93oc/k>onk^k_ogmoL00ooh
n?P04oogmoOok^k^olk>c_n@T93o@W<[ohC>@on]kg?o`_j8olknT?oFoiOo
d?jBolKnROnbmGCoR==3odAe:on@T93oc/k>onk^k_ogmoL0ooohn?P4ooSh
n00_ooKfm_o_knoo<c<coiVIVOoWinOoPh>3o`000?mlO7coj>SXok2`/?l1
0@7okNg]on?Shol61PKoXZ:RomgMgOmgMgOo0000olk>c_o`l?3o`/;2o`00
0?oAdM7om?Cdoo7alOmeMGGo?Shnonk^k_obl_;od=3@o`000?o?cloolO7a
olS8b?l0003o`l?3onk^k_n6QXKo6ATIonWYjOo_knool_;booCdm?oalO7o
R8R8ob/[:oo^k^h00_oemOD07?mTI6Co?cloonGUiOnc/k?o7alOofMWIoo_
knookNg]oa0@4?nRXZ;ol?3`ono_kom7AdOoJf][ono_koo`l?3oOWinocDe
=Oo[jn_oj>SXocLg=om4A4Coc/k>onOWiooMgMgoi>CTooGemOogmoLiooSh
n003ooOgmoohn?Son?Sh00Gon?Sh00?omoOgooShn?ohn?P0noohn?P00oog
moOon?ShooShn002ooShn004ooOgmooinOWomoOgooOgm`7on?Sh00000ooj
n_[omOGeonk^kP02onc/k03oon_[jooYjNWogmoOokZj^_miDU;o_c8TonIc
J?omRGkooiN;oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c9?miDU;o^[Zj
omoOgooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3o
oMYSoooZL_onlgkoooZ2ookfOoook7?oo]iToo[7DOoRTQcoRFICokZj^_oO
gmooj^[Zon_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]D_mAXacoTM9EojKW
J_nhnG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]D_nj^[[ogmoO
on[Zj_o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/002<onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_oj^[Zon;Rh_la<C7oT92@omWIfOl];Bgo@410ob<S8ooKfm_o
YJFUo`410OoPh>7oi>CToa0@4?mmOGgog]kNokFe]Ol0003od];Bon?Si?nI
VIWo3`l?on7QhOoVi^Koi>CTofm_Kolk>c_og]kOon;Rh_o3`l?o0000olC4
a?oUiNGo_[jno`000?ng]kSoh^;RogmoOolG5aOof=SHomkNg_oOgmooi^KV
on?Si?n1PH7o:2PXomoOgooUiNGojNWYogAdM?lP823of=SIomgMgOlk>c_o
Kfm_on?ShooQhN7o3`l?oiRHV?oPh>7oh>3Pod=3@omUIFGogmoOon7QhOmf
MWKo<S8bomoOh?ni^KWo0000ojVYZOoKfm/2om[JfP3oon;Rh_oXj>Wojn_[
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?oZj^_ok>c/on_[joo/k>cojn_[onc/
k?oZj^[ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/0010on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k0Oojn_[00Gok>c/on_[joo[jn_ok^k^ooKfmP01ooWin@0000?o
no_koo?cloo]kNd00_oUiND0oooVi^Koi>CTomWIfOnb/[;oNBh^olQ2<ooS
JUcom7Y]oof8O?onUh[ooY^>oojHRoonRWkom7]]onM[GOo:@SCoNbh^ok:b
/_oHf=Soi>CTonGUiOoVi^KoiNGVonCTi?oHf=So/[:boiIE;_oZW2_onka4
ook<Doomf6;oo^=bookYMOoniW?oo]]Uoog<Dook`DGokYh[oiUF;_nb/[;o
f=SHonCTi?oUiNGoi^KVonGUiOoTi>Cof=SIok:b/_l^HRkoHjd[ohO:B?nG
g5WoYNEYok;cMonhmW_o]?EiojOZJonHg5WoRLm;of>^:ol^Hbko/[:bomSH
fOoTi>CoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUiP00FooVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonCTi?oLg=co;bl_oh^;Ronb/[;o0000okRh^?lU9BGoZJVY
oinOWol10@7ofm_Lon7QhOna/K7o>CTiobDU9Oll?3co0000olk>c_oLg=go
U9BDoa0@4?oGemL00_oMgMd0;Om[Jf_o>CTiom?Ce?oGemOo^k^ko`000?o1
`L7oh>3PokZj^_l0003o/[:comcLg?mlO7co5aLGomGEeOoKfm_ogMgMon7Q
hOoNg]ooOWinobLW9ooFe]Kofm_KomoOgooJf][oIFEUob0P8?ll?3co4a<C
ofe]KOoOgmoog=cLo`l?3onDU9Coe]KGomKFe_m1@D7oHV9RomKFe_oGemOo
Lg=coc4a<OoLg=goVi^Ko`000004ocLg=`0nok>c/ooShnCoiNGUonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oTi>@2onGUi@3oonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV007o
iNGU0_oVi^H00ooUiNGoi^KVonKViP03onKViP03onGUiOo]kNgom?Cd007o
no_k00006Oolo?con?Shoo7alOo^k^kokNg]onk^k_o[jn_ohN7Qokbl_?mj
5aOo`clbom=FBOoTJ5[okgM/ooB3NOogQgcomHAjoo=iKOoUJE_ofEQ:ol@o
<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?nUAaOoiYLb
ooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlbonVK<_nUAQOo
_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOoGjPbogJm=on6
cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lGFAOo_;blon7Q
hOo/k>`0ooo^k^h4onk^kP0Wonc/k?oUiNGo<C4aohn?Som^KVko;2`/onSX
j?mmOGgoGUiNojBTY?l10@7ohn?SonWYjOoVi^Koh^;Ron3Ph?n][Jgo0000
omOGeooTi>CoV9RHoa0@4?oMgMgohn?SonCTi?m`L73o92@TomKFe_oOgmoo
_knoo`000?o;bl_ojNWYol71`Ol0003o^[ZjonCTi?n1PH7o1PH600?o?Shn
02;obl_;onWYjOn4Q8Co6QXJom[Jf_oRh^;oiNGUonOWiooShn?oh>3PomSH
f?lg=cOoLW9bon[Zj_oWinOo3`l?ohZ:R_oOgmoog]kNod=3@omFEUKoh>3P
omoOgomgMgOo<c<conWYjOnn_[ko0000oj2PX?nf][KoZZZZo`820_oIfMWo
kNg]Moo^k^h00oo]kNgok^k^onk^kP3<onk^kP03ong]kOobl_;on?Sh007o
o?cl0003oogmo@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Co
aclcom9@@ooJHUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooB
d];olo?cooclo0?ooOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWomJPY
ooRd?ooi_D[on;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?o
o?cl00?ooOgm01?oo?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:
cE3oSLeBoh[>D?n1adCoLKT_of:^8?m>VcCo1d87om;Bd_oclo?oo?cl0?oo
oOgm1?omoOd0:?okno_om?Cdoc@d=?nGUiOo7alOohN7Qoojn_[ogMgMoa<C
4onYZJWo0@41oo;bl_oinOWo`<30olC4a?oclo?oS8b<ob4Q8Oojn_[omOGe
oifMWOl@413oi^KVonk^k_odm?CoN7Qhoa4A4Om<C4cob/[:ohV9ROlD51Co
m_KfooWinOo>c/ko0000olK6a_oclo?oRHV9oa<C4onf][H2okVi^@0Rong]
kOoinOWoShn?o``<3?mGEeOodM7Aong]kOo/k>coYZJVonKVi_oTi>Co4Q8B
ojf][Ookno_on_[joa0@4?lN7QkoYJFUomcLg?lJ6Q[o820PogemOOoNg]ko
AdM7oemOGookno_on_[joc@d=?maLG7ok^k^ohj>S_le=CGono_kooclo?oo
oOgmAOomoOd00oolo?cooOgmooclo003oogmo@0000GooOgmoo[jn_oclo?o
k^k^oo3`l002onk^kP0conWYjOoCdm?oFadMoj8d=?nd:1go`CT/olM9??o?
ET[od5M;om1GB_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`
l?o_knool?3_onk^k_oZj^[odm?Coh`U7Oo8LCCofH@MonBD5OoWWBCokZPc
oo2Z=?o_ZS?ok:0UonNG5OoLR1gob74doh`U7OoCdm?oj^[Zonk^k_o`l?3o
kno_oo3`l?o^k^koj^[Yom?CdolM>1go=88dodNE7OmJYA_oJJdZ00;oM;Ph
0?ooMKThof^a:omKYacoB9XMocB2=?lM>1godm?Con[ZjOo^k^kol?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knl001?ol?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ong]
kOoXj>So<C4aof1PGol10@7odm?C00;okNg]01oo@410of5QHOl10@7oinOV
ong]kOnQXJ7o>3Phoa4A4OlV9RKoV9RHonk^k_o6a/Go410@o`410OlI6AWo
DU9BonSXj?mbLW;o?3`loiRHUolO7aoo61PHoi2@T?o_knook>c/olC4a?l0
003o_KflonOWion3Ph?o61PH00;oh>3P09goi>CTonKVi_o/k>_oTY:Boclo
?onATI7o5aLGoi>CTooPh>3oCdm?oalO7olA4A7oCdm?onOWioo_knook^k^
obLW9onOWiooCTi>o`T92Olf=SKogmoOofi^K_l>3Pko;2`/okfm_Oo_knko
k^k^om;Bd_ll?3co2`/;oadM7Onc/k?ok^k^oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`00?okno_0<;ol?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`;o
l?3`1_o_knl1oo?cl`7onOWi0Oono_h00003ookno_ogmoOol?3`00CojNWY
017oinOWom_KfomSBd_oPC8bojHe=Onf=2go`Te1ol=DBOo4ED[o`eA9ol9=
@Onf=2goYCDeoh4b<_mSBd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oRD];
ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;o
RD];om_KfooWinL01OoYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[
ZbooL:dhofn^>_m`[CSoJZX_oe>K;OliR3Go<V0bod];BooKfm_oinOW0?oo
jNWY1OoYjNT03OoXj>Soi>CToc0`<?lB4Q;o?3`lonKVi_oXj>SoinOWoi>C
TolA4A7o0@41on?ShooWinL00_oYjNT00ooWinOojNWYonWYj@02onSXj00D
oifMWOl@413oinOWonOWiooTi>CoKfm_oc/k>ooShn?oinOWonSXj?oYjNWo
j>SXonOWioo2`/;o0000okZj^_oTi>CoP820oaLG5ooMgMd2omkNgP03on7Q
hOoVi^Koj>SX00;ojNWY00?oj>SXonOWiooYjNT00_oYjNT00ooWinOojNWY
onWYj@05onWYj@05onSXj?oYjNWojNWYonWYjOoWinL01_oYjNT00ooVi^Ko
jNWYonWYj@3oonWYjD?ojNWY00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07o
moOg0Oono_h00005ookno_ojn_[om?Cdono_kooalO400_o`l?004Oo_knoo
jn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZNW?oIW9coe9FEok]cLonE
E5CoCb<SoiFDU?oZj^[okno_00Gol?3`017okno_on[Zj_nYU9CoPB<SokYZ
E?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S8onZU9Coj^[Z
ono_k`05oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCoLjEcoik6UOn/cYco
[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Zj_o_knl0ooo`l?05oo3`
l005ono_koo^k^ko<S8bo`000?nCTi<00oo_knl01OoTi>Co2`/;o`410Oo^
k^kokno_00Ool?3`00Wohn?Sokno_oo_knookno_onk^k_mdM7Co?Cdmong]
kOo_knl00oo`l?001oo_knoob/[:o`000?o3`l?ok^k^ohJ6Q_l92@T00omN
GUh00omiNGWok^k^ono_k`3ooo3`l6Gol?3`00ColO7aoo3`l?odm?Con_[j
0Oono_h00004onc^l?ooooooooooooknoP;ooooo0_ono_h0ooomoOgon?Sh
ofi^K_mJ?coo/I2@omk9bOo`i>ColnKVoo3Ti?oNbLWo/I2@oeXo?om]KFgo
n?Shooclo?ooooooo_knooooooono_koooonookno_ooooooo?clooShn?n=
KFgoRSloolVAT?oYd<Wom>WTooK[i_odjNCojM39olVAT?n9?cooSFe]ooSh
moolo?coooooookno_ooooooo_knooooooono_koooonooclo?ohn?SoKFe]
oclo?on@WI3obMG9onC/i?oVk^Koi>cTolWEbOn@WI3o?cloofe]KOohn?So
o?clooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooooknoP00@Oooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_kooooo00;oo_kn00?o[Zj^oiVIV?o`l?000_ono_h03ooo
oooooOgmokFe]OnIVIWoo_kmookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooo`02ooknoP3ooogmoOmlO7co@D51ooknoOomoOgooooo
ookno_oooooooOgmono_konHV9Sok>c[oogmoOoBd];oV9RHoiVIVOnHV9So
VIVIoj^[Zoono_goo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_kn001fooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooooooknoP;ooooo00?oo_knoooo
ooooool00oooool1ooknoP0000Co`LS>ookno_ojn_[om?Cd1OoalO403Oo_
knooe]KFof][Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?CgoJf][omKF
e_o_knl02OoalO403Oo_knooemKFoh=[Jomd?Cgo]Hb<omFj^_oQc<coe[Zj
okJ<S?mb?CgoPF][omOFe_o_knl02OoalO403Oo_knooe]KFof][Jolm?Cgo
S8b<okZj^_o<cLco^[Zjohb<S?lm?CgoJf][omKFe_o_knl0oooalO4Poo7a
l@03onk^k_o]kNgolO7a0?oolO7aKooalO401?o`l?3olO7aoo7alOo`l?04
oo7al@03ooCdm?ojn_[oo_kn007oh>7S00001On4SiWooOgmooShn?o`l?3o
jn_[00?oj^[Z00gojNWYon[Zj_oYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV
9RKoFEUIoi^KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V
9_l]2@Wo@RHVofUIFOnPVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^K
oeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT0oooZj^[oon[ZjY[o
j^[Z00Cojn_[oo3`l?ohn?SooOgm0Oo@e=H00004ocI6DOnh`<GonOWiooCd
m0SolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`l?0?oo7a
l@;ol?3`0oo_knl2oo3`l?oolO7aoooalO6Hoo7al@03oo3`l?oalO7olO7a
00;olO7a00?om?Cdoo[jn_o/k^l00OnQYJP00003oad_?om<FF?o^Ko50?oo
oooooooooooJooooo`7okNo`0On/[k81ojBY[@0000Ko72hmoaXY=Olb?4Ko
OXR@okg3b?o[k>koooooooooooooe?ooool01OoYjnco^[o3ogV1R?l/=Cko
4QhY007o524_0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{734, 424},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
To respond to the change of the tab, you should install \
ChangeListener to JTabbedPane. 
MathSwingChangeListener for J/Link is defined in JavaSwing.jar. The following \
is the source code.\
\>", "Text"],

Cell["MathSwingChangeListener.java", "Text"],

Cell["\<\
package JLinkProgramming.JavaSwing;
import com.wolfram.jlink.*;
import javax.swing.event.*;

public class MathSwingChangeListener extends MathListener implements \
ChangeListener {
\tpublic MathSwingChangeListener() {
\t\tsuper();
\t}

\tpublic MathSwingChangeListener(KernelLink ml) {
\t\tsuper(ml);
\t}

\tpublic MathSwingChangeListener(String func) {
\t\tthis();
\t\tsetHandler(\"stateChanged\", func);
\t}

\tpublic void stateChanged(ChangeEvent e) {
\t\tExpr result = callMathHandler(\"stateChanged\", new Object[]{e});
\t\tif (result != null)
\t\t\tresult.dispose();
\t}
}\
\>", "Text",
  FontFamily->"Courier New",
  Background->GrayLevel[0.900008]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleJTabbedPane",
        ButtonData:>{"SimpleJTabbedPane.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SimpleJTabbedPane[]\)], "Input"],

Cell[BoxData[
    \("Donau Cruise           "\)], "Print"],

Cell[BoxData[
    \("Race At Linz           "\)], "Print"],

Cell[BoxData[
    \("Toy Story Coffee       "\)], "Print"],

Cell[BoxData[
    \("Scull 3D               "\)], "Print"],

Cell[BoxData[
    \("Kumamoto Castle        "\)], "Print"],

Cell[BoxData[
    \("Sunset Of Kasado Island"\)], "Print"],

Cell[BoxData[
    \("From The Skylon Tower  "\)], "Print"],

Cell[BoxData[
    \("Mona Lisa              "\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> java.awt.FlowLayout <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;K0001VAP00`40o`00
0?l0003oo`000?l0003M000000000hS0^4R@R4R@R03oB928odR@R=U8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^=R8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;SHR<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0K<c<a9oooo1/c<c4Woool6c<c<BOoo
o`K<c<a9oooo1/c<c4Woooooc<c<BLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P5c<c<00=VIVK<c<aVIVH0AVIVIP03ooooc<c<c<c<00?<c<`0
0fIVI/c<c6IVIP16IVIV00?oooo<c<c<c<`00lc<c003IVIVc<c<IVIV04IV
IVH00oooolc<c<c<c003c<c<00=VIVK<c<aVIVH0AVIVIP03ooooc<c<c<c<
00?<c<`00fIVI/c<c6IVIP16IVIV00?oooo<c<c<c<`0olc<c4O<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<04G<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0ALc<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
04G<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0ALc<c003IVIVoooo
c<c<0?o<c<a8c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`0
0fIVI_ooolc<c015c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<04G<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0ALc<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<04G<c<`00fIVI_ooolc<c03oc<c<B<c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0ALc<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
04G<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0ALc<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`0olc<c4S<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<04G<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0ALc<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<04G<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0ALc<c003IVIV
ooooc<c<0?o<c<a8c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
04G<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0ALc<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<04G<c<`00fIVI_ooolc<c03oc<c<B<c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0ALc<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<04G<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0ALc<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`0olc<c4S<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<
013<c<`200000lc<c0800004c<c<1@0000;<c<`400000/c<c0800002c<c<
0P0000C<c<`200004Lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00@
c<c<0P0000?<c<`200001<c<c0D00002c<c<100000;<c<`200000/c<c080
00000lc<c0000000000400004<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c00@c<c<0P0000?<c<`200001<c<c0D00002c<c<100000;<c<`20000
0/c<c0800002c<c<1000017<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`04<c<c0800003c<c<0P0000C<c<`500000/c<c0@00002c<c<0P0000;<
c<`200001<c<c080000Ac<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
013<c<`200000lc<c0800004c<c<1@0000;<c<`400000/c<c0800002c<c<
0P0000;<c<`400004Lc<c003IVIVooooc<c<0?o<c<a8c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00@c<c<0P0000?<
c<`200000lc<c0800002c<c<0P000003c<c<0000000000;<c<`2000000?<
c<`0000000000/c<c0800004c<c<0P00017<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`04<c<c0800003c<c<0P0000?<c<`200000/c<c0800000
0lc<c00000000002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0
000000005<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00@c<c<0P00
00?<c<`200000lc<c0800002c<c<0P000003c<c<0000000000;<c<`20000
00?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P00013<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`04<c<c0800003c<c<0P0000?<
c<`200000/c<c08000000lc<c00000000002c<c<0P000003c<c<00000000
00;<c<`200001<c<c080000Ac<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<013<c<`200000lc<c0800003c<c<0P0000;<c<`2000000?<c<`00000
00000/c<c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<
c<`200004<c<c003IVIVooooc<c<0?o<c<a8c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00@c<c<0P0000?<c<`20000
0lc<c0800002c<c<0P000003c<c<0000000000G<c<`2000000?<c<`00000
00001Lc<c080000Ac<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<013<
c<`200000lc<c0800003c<c<0P0000;<c<`2000000?<c<`0000000001Lc<
c08000000lc<c00000000003c<c<0P0001?<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`04<c<c0800003c<c<0P0000?<c<`200000/c<c0800000
0lc<c00000000005c<c<0P000003c<c<0000000000K<c<`200004<c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c00@c<c<0P0000?<c<`200000lc<
c0800002c<c<0P000003c<c<0000000000G<c<`2000000?<c<`000000000
0/c<c0H0000@c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<013<c<`2
00000lc<c0800003c<c<0P0000;<c<`2000000?<c<`0000000001Lc<c080
00000lc<c00000000006c<c<0P00013<c<`00fIVI_ooolc<c03oc<c<B<c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0
4<c<c0800003c<c<0P0000C<c<`2000000C<c<`00000003<c<`200001Lc<
c0D00005c<c<0P00017<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
4<c<c0800003c<c<0P0000C<c<`2000000C<c<`00000003<c<`200001Lc<
c0D00004c<c<0P0001;<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
4<c<c0800003c<c<0P0000C<c<`2000000C<c<`00000003<c<`200001Lc<
c0D00006c<c<0P00013<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
4<c<c0800003c<c<0P0000C<c<`2000000C<c<`00000003<c<`200001Lc<
c0D00002c<c<00<0003<c<c<c<`00P00017<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`04<c<c0800003c<c<0P0000C<c<`2000000C<c<`00000
003<c<`200001Lc<c0D00006c<c<0P00013<c<`00fIVI_ooolc<c03oc<c<
B<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<
c<`04<c<c0800003c<c<0P0000G<c<`4000000?<c<`0000000001Lc<c0@0
0006c<c<0P00017<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`04<c<
c0800003c<c<0P0000G<c<`4000000?<c<`0000000001Lc<c0@00006c<c<
0P00017<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`04<c<c0800003
c<c<0P0000G<c<`4000000?<c<`0000000001Lc<c0@00007c<c<0P00013<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`04<c<c0800003c<c<0P00
00G<c<`4000000?<c<`0000000001Lc<c0@00004c<c<00@0003<c<`00000
000Ac<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<013<c<`200000lc<
c0800005c<c<10000003c<c<0000000000G<c<`400000lc<c0800002c<c<
0P00013<c<`00fIVI_ooolc<c03oc<c<B<c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`04<c<c0800003c<c<0P0000?<
c<`010000<c<c<c<c<c<c08000000lc<c00000000002c<c<0P000004c<c<
00000000c<c<0P0000?<c<`010000<c<c0000000017<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`04<c<c0800003c<c<0P0000?<c<`010000<c<
c<c<c<c<c08000000lc<c00000000002c<c<0P000004c<c<00000000c<c<
0P0000K<c<`200004<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00@
c<c<0P0000?<c<`200000lc<c0040000c<c<c<c<c<c<0P000003c<c<0000
000000;<c<`2000000C<c<`00000003<c<`200001<c<c0<0000Ac<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<013<c<`200000lc<c0800003c<c<
00@0003<c<c<c<c<c<`2000000?<c<`0000000000/c<c08000001<c<c000
00000<c<c0800003c<c<00@0003<c<`00000000Ac<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<013<c<`200000lc<c0800003c<c<00@0003<c<c<
c<c<c<`2000000?<c<`0000000000/c<c08000001<c<c00000000<c<c080
0002c<c<1@00017<c<`00fIVI_ooolc<c03oc<c<B<c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`04<c<c0800003c<c<
100000;<c<`400000lc<c0@00002c<c<0P0000;<c<`200000/c<c0@0000A
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<013<c<`200000lc<c0@0
0002c<c<100000?<c<`400000/c<c0800002c<c<0P0000G<c<`200004<c<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00@c<c<0P0000?<c<`40000
0/c<c0@00003c<c<100000;<c<`200000/c<c0800005c<c<0P00013<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`04<c<c0800003c<c<100000;<
c<`400000lc<c0@00002c<c<0P0000;<c<`200000lc<c0<0000Ac<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<013<c<`200000lc<c0@00002c<c<
100000?<c<`400000/c<c0800002c<c<0P000003c<c<0000000001C<c<`0
0fIVI_ooolc<c03oc<c<B<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P5c<c<00=VIVKoooo<c<`04<c<c080000Fc<c<0P0000O<c<`300004Lc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00@c<c<0P0001K<c<`20000
1Lc<c0800002c<c<0P00013<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`04<c<c080000Fc<c<0P0000G<c<`200000/c<c080000@c<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<013<c<`200005/c<c0800007c<c<0`00
017<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`04<c<c080000Fc<c<
0P0000K<c<`200004lc<c003IVIVooooc<c<0?o<c<a8c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<1P0001C<
c<`200002<c<c080000Ac<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
00k<c<`600005<c<c0800006c<c<1000017<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`03/c<c0H0000Dc<c<0P0000K<c<`400004Lc<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<1P0001C<c<`200002<c<c080
000Ac<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`600005<c<
c0800006c<c<1@00013<c<`00fIVI_ooolc<c03oc<c<B<c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0ALc<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<04G<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0ALc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`0
olc<c4S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
ooooc<c<04G<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0ALc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<04G<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
ALc<c003IVIVooooc<c<0?o<c<a8c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0G<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<04G<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0ALc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<04G<c<`00fIVI_ooolc<c03oc<c<B<c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0ALc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<04G<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
ALc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<
c<`0olc<c4S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVooooc<c<04G<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0ALc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<04G<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0ALc<c003IVIVooooc<c<0?o<c<a8c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<04G<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
ALc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<04G<c<`00fIVI_ooolc<c03oc<c<B<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0ALc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c015c<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<04G<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0ALc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c015c<c<00=VIVKo
ooo<c<`0olc<c4S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<
c003IVIVoooooooo04Goool00lc<c?ooolc<c004c<c<00=VIVKoooooool0
AOooo`03c<c<ooooc<c<00C<c<`00fIVI_ooooooo`15oooo00?<c<coooo<
c<`01<c<c003IVIVoooooooo04Goool00lc<c?ooolc<c004c<c<00=VIVKo
ooooool0AOooo`03c<c<ooooc<c<0?o<c<a8c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<a9IVIV1/c<c4UVIVH6c<c<BFIVIPK<c<a9IVIV
1/c<c4UVIVKoc<c<B/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c=G<c<`2R<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;SoR<2h
f8S0^058T8P10000000018S0^<SPf8S0^8S0^1H0080400600`02P0@00h44
00B10P05P@0300F200J200J200801X8200N200<11h81288128800P48P`@1
2H<30@Z300@12h<12h@12h@12h@40@b40`4=Q0@13XD30Pn5108@Q@@24HH3
0Q:60`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P010<I
R0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4
122;0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd5
9hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y03
1Rn@00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP03
1SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@4
1cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G
10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT4
2DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:
D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]G
W`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ
0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=
IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^
Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`me
Z@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l
[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61
[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`
0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>
/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe
4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL
]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<E
Y;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd0
0aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G
/klf6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0@008000i^WlC=3
YC=3Y@09<d>U1P00P0@00H0300:01003P@@0184200F100<01H801X801X80
0P06PP801h800`47PP48PP48PP020@R31049P`<12X<0104;P`4;Q04;Q04;
Q0@138@30@f4104>Q@<23hD40Q25108AQP<24XH30Q>600@24hL258L258L2
58L40QF70P8FQ`835XP30aN810<HR0040aV80aV90aV90aV90`<JR@@36hT3
0ab:10<MRP<47XX010@NR`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<
00<498d49Hd49Hd00PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>
1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A
0`HaT@<6<Y400`HbTPHcTPHcTP021S>B00<6=987=987=9800PLeTP87=I<3
1cJC10LgT`041cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010Pm
UPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH
0089A9P42DFH00<9AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK
10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd3
2e>M0P]DW@8;E9h42eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP
0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQ
XP8=HZ823F:S0`eSX`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU
0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?
L:P010maZ0<?LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ
0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd2
47n]00<AOjdAP:dAP:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164
[Q64[a64[a64[`<AQJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[44
4X^a0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@C
T;<44i6c0a>B]0@CTk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H3
59Vf0aBJ]P0359Zg59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^004
5J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/0
11JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^
_AN^_QN^_P045jnn11N`_P<G/Kl45k:o0aNc_cHH]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0`00P007VjOaooooSWZfYY_4/jWBZ9g8/jWB00:V
Vl@01KbhgNk^m>[YlOoooc=3Y@0500201001P0<00X0400>11004P@801H40
0`05PP06PP06PP0200J20P07PP030@N20@R20@R2008128<40@V30`4:P`04
0@^30@^40@^40@^4104<Q0<13H@40@j50`8?Q@@248D40Q660`8BQP<24hH0
108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT3
6HT30aZ910<KR@<378X40af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/4
12:<10@SS08498`00`@TS@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5
:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA
1S2A1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLd
TP021cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD3
23bE0`PmU@0423fF23jF23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G
00<9@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX4
2DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:
DId22U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil3
2eRO10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR
0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@4
3FNT0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>
KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mf
ZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@
OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh3
4H:^1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9
/A::/A::/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<C
Sk8CSk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@D
U[D359Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM
^0@EW[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<F
Y[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG
[;d011N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G/[l35k>o0QRd`200
00026;C04000008H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00
P004VjOaooooK5ZU[jG:0[bhg@0:oogo/jWBoooooooo_;SMUhZlZ9g8i^K/
oooo<d>U1000P0@00H0300:01003P@@0184200F100<01H801X801X800P06
PP801h800`47PP48PP48PP020@R31049P`<12X<0104;P`4;Q04;Q04;Q0@1
38@30@f4104>Q@<23hD40Q25108AQP<24XH30Q>600@24hL258L258L258L4
0QF70P8FQ`835XP30aN810<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:
10<MRP<47XX010@NR`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<00<4
98d49Hd49Hd00PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?
1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`Ha
T@<6<Y400`HbTPHcTPHcTP021S>B00<6=987=987=9800PLeTP87=I<31cJC
10LgT`041cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPn
UPPnUPPnUP@8?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089
A9P42DFH00<9AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=
V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M
0P]DW@8;E9h42eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aK
X0<<G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=
HZ823F:S0`eSX`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZ
Y@@>JjH43VbV0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P0
10maZ0<?LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1h
ZP@@NJ/347Z[0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]
00<AOjdAP:dAP:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64
[a64[a64[`<AQJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a
0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<4
4i6c0a>B]0@CTk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf
0aBJ]P0359Zg59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h
5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX
_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^
_QN^_P045jnn11N`_P<G/Kl45k:o0aNc_`8H]<000lSPf4R@R4R@R00<B928
00<00038h=Q8T8P03DR@R00400006;C06;C0b>3H3TR@R00300006;C06;C0
00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000^KYo7ooonXWLSo
ooncZM9PC9Z>N[IhIJjXWLSooooooOl00oooo`03<d>U0020002000<00804
00600`02P0@00h4400B10P05P@0300F200J200J200801X8200N200<11h81
288128800P48P`@12H<30@Z300@12h<12h@12h@12h@40@b40`4=Q0040@j5
oooooooooooo0`8?Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@2
5HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X4
0af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@T
S@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5
:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A
0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<4
1cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF
23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4
V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK
0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did2
2eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P
0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeR
XP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU
10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z004
3g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ
111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd0
0a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_
4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk42
4Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@C
TK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH3
59Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PE
X;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl
5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn
5jjn00@G[kh45k2n0aNa_`@G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P0
0dR@R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B9280000
6;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008003Y^WlOoo
ooooom_Lk61<VY>5^[>Yd[bhgF1<VYV?_ZJKa<S3gooooc=3Y@H00803oooo
00<00H000X000X001?ooo`0500>100B100B1oooo00B100801H400`05P_oo
ooooo`02oooo0P07PPCoool01@48P`49P`49Poooo`49P`020@Z300Ooool1
2h<12h@12hCoool138Coool00P4<Q0040@f4oooo0@f4oooo0`4>Q@03oooo
0Pn50Pn500@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ7
0P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:0`@N
RP0411j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@US@@U
S@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl4
1B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@03
1S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7
>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF
10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP0
0`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`03
2TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]D
WP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX004
35bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<3
3F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>
K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mb
Z08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@
NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60
[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_
0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<B
S;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d
11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<D
V[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TE
X;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl
5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G
[kh45k2n0aNa_`@G/[l35k>o0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P0
0dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00
P00>VjOaoooo_;SMVHnnooooe]7Mfmc/lokoYY_4k^kdQGJ`ThFjoooo<d>U
1000P008oooo006000600060oooo00:0oooo00:00P03P@06oooo00>100B1
00B1oooo00B10P05P@08oooo00J200J200J2oooo00N2oooo0@N20P48PP06
0@R3oooo0@V30@V3oooo0@V30P4:P`07oooo0@^30@^40@^4oooo0@b4oooo
008138@00`4=Q?ooo`4=Q004oooo0`8?Q@@248D40Q660`8BQP<24hH0108C
Q`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT3
0aZ910<KR@<378X40af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<
10@SS08498`00`@TS@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h3
1BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A
1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP02
1cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE
0`PmU@0423fF23jF23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9
@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ
0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId2
2U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO
10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aP
XP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT
0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL0
0`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmf
ZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`2
47j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^
1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::
/A::/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8C
Sk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D3
59Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@E
W[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/4
5ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d0
11N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G/[l35k>o0QRd`004b>3H
R<2hR<2hR<2h1P0000B8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P0
1HS0^0050000R<2hR<2hB9280000008H]<001<SPf8S0^8S0^8S0^0800004
R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3002000nKYo7ooonISkjGR[cDdnS_[;?oMW_^Wj]KF:FVVlBF
Wm9PC9Zl^=gooolc@jD00`00P008oooo006000600060oooo00:0oooo00:0
0P03P@06oooo00>100B1oooo00B1oooo0P05P@08oooo00J200J200J2oooo
00N2oooo0@N20P48PP0:0@R3oooo0@V3oooo0@V3oooo0@Z3oooo0@Z3oooo
0P4;Q003oooo0@b4oooo008138@0104=Q?ooo`4=Q?ooo`<13XD30Pn5108@
Q@@24HH30Q:60`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@3
68P010<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/4
7h/47h/4122;0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=
00<59hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]
T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i80
0PHcTP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0Lh
U0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88
@9L3246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI
00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`0
0PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh0
10]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<
GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=
IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]
Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT4
3gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k
[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d0
1161[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<B
Qk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P02
4Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]004
4iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`02
59^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i
11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[
_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o
11Nb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P0
0`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2h
R<2h00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOXZFjP
b<?OThFjFdJCVHnn0WQU[P04@RN5[jG:oooo<d>U1000P0<00H000oooo`02
P002P004oooo00D00h40187oool0187oool00P05P@0300F2oooooooo00;o
ool200N200d11h812881288128?oool12H?oool12H?oool12X?oool12X?o
ool00P4;Q003oooo0@b4oooo008138@00`4=Q?ooo`4=Q004oooo0`8?Q@@2
48D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP4
0aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:0`@NRP0411j;11n;
11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@US@@US@021BF=10DV
S@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6
;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B
0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7
>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF10PoUP88@9H2
242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6
V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL
008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN
00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ
35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`03
3FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>
KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y
10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@
Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]
00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl3
4XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<BS;8BSK8BSK80
0Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@0
11>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL0
0QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR
^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08F
Zk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa
_`@G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h
00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0
^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2002000>KYo7oooooool00_ooo`0:ojf`ogIknLgD
oNg^ooooYY_4QGJ`_;SMoooo<d>U1@00P0<00H001?ooo`02P002P002P080
0h400oooo`03POooo`0300B100?oool01H401H800`06PP04oooo00N200N2
0@N20oooo`090@R30@V3oooo0@V3oooo0@Z3oooo0@Z3oooo00812h@02Ooo
o`4<Q?ooooooo`4<Q04=Q?ooo`4=Q?ooo`020@j500Coool23hD23hD23hD4
0Q25108AQP<24XH30Q>600@24hL258L258L258L40QF70P8FQ`835XP30aN8
10<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX010@NR`@O
R`@OR`@OR`@488/3126;10@RS0@48h`212B<00<498d49Hd49Hd00PDUS@@5
9Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l4
1Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHcTPHc
TP021S>B00<6=987=987=9800PLeTP87=I<31cJC10LgT`041cRC1cRD1cRD
1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2242F
0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9AYT9
AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?
W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN0`]F
WP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aMX@aM
X@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=I:<0
0`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]YP03
3VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X0Pmc
Z@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`03
47^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d00Q60
[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<AQJl44HJ_
0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb
008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@34iBd
00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g59^g
008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@E
X[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`2
5Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`_P<G
/Kl45k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0
^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8
`;R8`;P018S0^0800005R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0`00P00:XJcbnLgDhRHlm;FohRHlm6emo>?Yoooo
oNg^ojf`0_ooo`03<d>U0020002000@00803006000?oool00X000X000ooo
o`800h401oooo`04P@04P@04POooo`05P@05PP03oooo00@01X801h801h;o
ool20@R20P48P`050@V3oooo0@V30@V3oooo00812X<01oooo`4;Q04;Q?oo
o`4<Q?ooo`4<Q002oooo0P4=Q0030@j5oooooooo00;oool20Pn5108@Q@@2
4HH30Q:60`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P0
10<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/4
7h/4122;0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<5
9hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6
;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHc
TP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7
>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3
246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9
AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?
W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]G
WP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ44
35jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=
IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^
Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY
0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l
[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161
[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk04
4XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb
0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd
4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g
0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS
^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08F
Zkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb
_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`00
08S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h
00>8`;P4000018S0^004B92800006;C06;C00XS0^058T8P10000000018S0
^<SPf8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_ARK_omoon]
/?cSjOoooc=3Y@0700200`01P004oooo00:000:000:01003P@@0184200F1
00<01H801X801X800P06PP0300N2oooo0@N2008128820@R31049P`<12X<0
104;P`4;Q04;Q04;Q0@138@30@f4104>Q@<23hD40Q25108AQP<24XH30Q>6
00@24hL258L258L258L40QF70P8FQ`835XP30aN810<HR0040aV80aV90aV9
0aV90`<JR@@36hT30ab:10<MRP<47XX010@NR`@OR`@OR`@OR`@488/3126;
10@RS0@48h`212B<00<498d49Hd49Hd00PDUS@@59Xd00`DWS@DWSPDWSP04
1BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i000`H_
T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHcTPHcTP021S>B00<6=987=987
=9800PLeTP87=I<31cJC10LgT`041cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E
0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8@IL424:G0PQ3
U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9AYT9AYT010U7V@@9B9T32DVJ
10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`2
2U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN0`]FWP042eNN2eNO2eNO2eNO
0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ0PaO
XP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=I:<00`eUX`eUY0eUY0043FJT
10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW3VjW008>KZL4
3VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?
MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/47b/008@O:`3
47f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d00Q60[@044H6]4H6^4H6^4H6^
0a62[P@APjh01164[Q64[a64[a64[`<AQJl44HJ_0a:7/0@BR;034XV`00@B
RK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P03
4hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@34iBd00@CUK@CUKDCUKDCUKD4
59Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g59^g008DVkL359bg0QBM]`8E
WKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX3
5ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm
5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`_P<G/Kl45k:o0aNc_`8H]<00
0lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8
`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002
R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2002000>KYo7fb<cR9S`00_n]/007gb@^ojBNm[c5ojf`kW^<
oooo<d>U00P00803006000Coool00X000X000X0400>11004P@801H400`05
PP06PP06PP0200J200<01h;oool11h800P48PP030@R3oooo0@V300<12H<3
0@Z300@12h<12h@12h@12h@40@b40`4=Q0@13XD30Pn5108@Q@@24HH30Q:6
0`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<I
R@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4122;
0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd59hh5
9hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@
00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB
1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD
10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2
U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI
0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`2
2U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]G
W`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaO
X@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@0
10eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`02
3VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@04
3gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[002
47b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61
[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9
/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8C
S[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe
4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8D
WKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X4
5ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/
_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/kl2
6;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P900000XS0^005
B92800006;C06;C0b>3H00>8`;P2000018S0^0800002R<2h00A8T8P0000H
]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOanLgD
mhVG00;oool01on]/>4F=?mfNonTW^8V??n9Oc=3Y@0800200`01P004oooo
00:000:000:01003P@@0184200F100<01H801X801X800P06PP801h84oooo
00<128<12H<12H<00P49P`<12X<0104;P`4;Q04;Q?ooo`@138@30@f4104>
Q@<23hD40Q25108AQP<24XH30Q>600@24hL258L258L258L40QF70P8FQ`83
5XP30aN810<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX0
10@NR`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<00<498d49Hd49Hd0
0PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[
S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`Hb
TPHcTPHcTP021S>B00<6=987=987=9800PLeTP87=I<31cJC10LgT`041cRC
1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8
?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9
AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>
W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h4
2eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aL
X@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eS
X`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV
0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP2
3g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[
0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dA
P:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<A
QJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb
4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@C
Tk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg
59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i
0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY
_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn
11N`_P<G/Kl45k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038
h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B9280000
6;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008001i^WlOoo
oo>P[_ARK_ooooN9UoW=e002oooo00?cX:kooolc@jD02000P0@00H0300:0
1003P@@0184200F100<01H801X801X800P06PP801h800`47PP48PP48PP02
0@R31049P`<12X<0104;P`4;Q04;Q04;Q0@138@30@f4104>Q@<23hD40Q25
108AQP<24XH30Q>600@24hL258L258L258L40QF70P8FQ`835XP30aN810<H
R0040aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX010@NR`@OR`@O
R`@OR`@488/3126;10@RS0@48h`212B<00<498d49Hd49Hd00PDUS@@59Xd0
0`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@
0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHcTPHcTP02
1S>B00<6=987=987=9800PLeTP87=I<31cJC10LgT`041cRC1cRD1cRD1cRD
0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2242F0PQ0
U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9AYT9AYT0
10U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W002
2TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN0`]FWP04
2eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aMX@aMX@aM
X@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=I:<00`eU
X`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]YP033VfW
3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?
M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/
47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d00Q60[@04
4H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<AQJl44HJ_0a:7
/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb008B
SK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@34iBd00@C
UK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g59^g008D
VkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T4
5J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l
0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`_P<G/Kl4
5k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P03HS0^005
B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P3002000^KYo7oooooRGooooocX:kaTj7ooooo
oOocX:kono`c@jD02000P0@00H0300:01003P@@0184200F100<01H801X80
1X800P06PP801h800`47PP48PP48PP020@R31049P`<12X<0104;P`4;Q04;
Q04;Q0@138@30@f4104>Q@<23hD40Q25108AQP<24XH30Q>600@24hL258L2
58L258L40QF70P8FQ`835XP30aN810<HR0040aV80aV90aV90aV90`<JR@@3
6hT30ab:10<MRP<47XX010@NR`@OR`@OR`@OR`@488/3126;10@RS0@48h`2
12B<00<498d49Hd49Hd00PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP04
1BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@02
1S2A0`HaT@<6<Y400`HbTPHcTPHcTP021S>B00<6=987=987=9800PLeTP87
=I<31cJC10LgT`041cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID0
10PmUPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH
2DBH0089A9P42DFH00<9AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX4
2TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;
DYd32e>M0P]DW@8;E9h42eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl4
35ZP0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R
0PeQXP8=HZ823F:S0`eSX`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D4
3VVU0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?
L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX4
3gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n[08@
OZd247n]00<AOjdAP:dAP:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh0
1164[Q64[a64[a64[`<AQJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4B
R[444X^a0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc
00@CT;<44i6c0a>B]0@CTk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@D
V;H359Vf0aBJ]P0359Zg59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO
^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<F
Z;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd0
0aN^_AN^_QN^_P045jnn11N`_P<G/Kl45k:o0aNc_`8H]<0?b>3H00<00038
h=S8h=P03LSPf00300006;C06;C000o8h=P00`0001Rd`1Rd`002R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h1000P0>KYo401_oooo>P[_Be_oJlaO_I
fS=3Y@T0080400600`02P0@00h4400B10P05P@0300F200J200J200801X82
00N200<11h81288128800P48P`@12H<30@Z300@12h<12h@12h@12h@40@b4
0`4=Q0@13XD30Pn5108@Q@@24HH30Q:60`8CQP040Q>70QB70QB70QB7108E
Q`825XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@3
7HX311j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@TS00312B=
12F=12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZ
S`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6<I43
1S:A00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC0`LfT`@7
=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8
?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH
10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/2
2TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;
E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj03
35bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R
0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD4
3V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?
LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X4
47V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o[@03
4Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lA
Q:lAQ:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8B
S;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A
/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<D
V[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP
^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`F
ZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG
[[h011N__P@G/;h35k6o11Nb_`<G/klf6;C00XS0^058T8P10000000018S0
^<SPf8S0^8S0^1H0080400600`02P0@00h4400B10P05P@0300F200J200J2
00801X8200N200<11h81288128800P48P`@12H<30@Z300@12h<12h@12h@1
2h@40@b40`4=Q0@13XD30Pn5108@Q@@24HH30Q:60`8CQP040Q>70QB70QB7
0QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^9
0`<LRP@37HX311j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@T
S00312B=12F=12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZ
SPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`
T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC
0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8
?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4
V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<
V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M
0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJ
X0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=
HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iY
Y@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X
3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mg
ZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]
0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@A
Q:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa
11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`04
4i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf
0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP0
11FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk
00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G
[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/klf6;C00XS0^058T8P10000
00000hS0^<SPf8S0^03oR<2hohS0^=R8`;P1B9280@00000000>8`;S8h=R8
`;P0ohS0^?n8`;SHR<2h0DR@R04000000003R<2hb>3Hb>3H0?o8h=Sob>3H
f<SPf058T8P10000003oR<2hohS0^=b8`;P100000000\
\>"], "Graphics",
  ImageSize->{731, 409},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;N0001Z2000`400?l0
0000o`00003oooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?000?oo
l?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`
l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?oo
l?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003o
oo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3o
l?3`003ooo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000oooooooo
ooooon3ooooo003oonk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00
ooo^k^koonk^k^3ok^k^003oooooooooooooh?ooool00?ook^k^ooo^k^kP
onk^kP00oooVi^KoonKVi^3oi^KV003oonk^k_ook^k^h?o^k^h00?oooooo
oooooooPooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H0
0?ook^k^ooo^k^kPonk^kP00ooooooooooooon3ooooo003oonk^k_ook^k^
h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^k^koonk^k^3ok^k^003ooooo
ooooooooh?ooool00?ook^k^ooo^k^kPonk^kP00oooVi^KoonKVi^3oi^KV
003oonk^k_ook^k^h?o^k^h00?oooooooooooooPooooo`00ooo^k^koonk^
k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00oooo
ooooooooon3ooooo003oonk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKV
iP00ooo^k^koonk^k^3ok^k^003oooooooooooooh?ooool00?ook^k^ooo^
k^kPonk^kP00oooVi^KoonKVi^3oi^KV003oonk^k_ook^k^h?o^k^h00?oo
oooooooooooPooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oV
i^H00?ook^k^ooo^k^kPonk^kP00ooooooooooooon3ooooo003oonk^k_oo
k^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^k^koonk^k^3ok^k^003o
ooooooooooooh?ooool00?ook^k^ooo^k^kPonk^kP00oooVi^KoonKVi^3o
i^KV003oonk^k_ook^k^h?o^k^h00?oooooooooooooPooooo`00ooo^k^ko
onk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00
ooooooooooooon3ooooo003oonk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KP
onKViP00ooo^k^koonk^k^3ok^k^003oooooooooooooh?ooool00?ook^k^
ooo^k^kPonk^kP00oooVi^KoonKVi^3oi^KV003oonk^k_ook^k^h?o^k^h0
0?oooooooooooooPooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KV
h?oVi^H00?ook^k^ooo^k^kPonk^kP00ooooooooooooon3ooooo003oonk^
k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^k^koonk^k^3ok^k^
003oooooooooooooh?ooool00?ook^k^ooo^k^kPonk^kP00oooVi^KoonKV
i^3oi^KV003oonk^k_ook^k^h?o^k^h00?oooooooooooooPooooo`00ooo^
k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^
kP00ooooooooooooon3ooooo003oonk^k_ook^k^h?o^k^h00?ooi^KVoooV
i^KPonKViP00ooo^k^koonk^k^3ok^k^003oooooooooooooh?ooool00?oo
k^k^ooo^k^kPonk^kP00oooVi^KoonKVi^3oi^KV003oonk^k_ook^k^h?o^
k^h00?oooooooooooooPooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_oo
i^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00ooooooooooooon3ooooo003o
onk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^k^koonk^k^3o
k^k^003oooooooooooooh?ooool00?ook^k^ooo^k^kPonk^kP00oooVi^Ko
onKVi^3oi^KV003oonk^k_ook^k^h?o^k^h00?oooooooooooooPooooo`00
ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kP
onk^kP00ooooooooooooon3ooooo003oonk^k_ook^k^h?o^k^h00?ooi^KV
oooVi^KPonKViP00ooo^k^koonk^k^3ok^k^003oooooooooooooh?ooool0
0?ook^k^ooo^k^kPonk^kP00oooVi^KoonKVi^3oi^KV003oonk^k_ook^k^
h?o^k^h00?oooooooooooooPooooo`00ooo^k^koonk^k^3ok^k^003oonKV
i_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00ooooooooooooon3ooooo
003oonk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^k^koonk^
k^3ok^k^003oooooooooooooh?ooool00?ook^k^ooo^k^kPonk^kP00oooV
i^KoonKVi^3oi^KV003oonk^k_ook^k^h?o^k^h00?oooooooooooooPoooo
o`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?ook^k^ooo^
k^kPonk^kP00ooooooooooooon3ooooo003oonk^k_ook^k^h?o^k^h00?oo
i^KVoooVi^KPonKViP00ooo^k^koonk^k^3ok^k^003oooooooooooooh?oo
ool00?ook^k^ooo^k^kPonk^kP00oooVi^KoonKVi^3oi^KV003oonk^k_oo
k^k^h?o^k^h00?oooooooooooooPooooo`00ooo^k^koonk^k^3ok^k^003o
onKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00ooooooooooooon3o
oooo003oonk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^k^ko
onk^k^3ok^k^003oooooooooooooh?ooool00?ook^k^ooo^k^kPonk^kP00
oooVi^KoonKVi^3oi^KV003oonk^k_ook^k^h?o^k^h00?oooooooooooooP
ooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?ook^k^
ooo^k^kPonk^kP00ooooooooooooon3ooooo003oonk^k_ook^k^h?o^k^h0
0?ooi^KVoooVi^KPonKViP00ooo^k^koonk^k^3ok^k^003ooooooooooooo
h?ooool00?ook^k^ooo^k^kPonk^kP00oooVi^KoonKVi^3oi^KV003oonk^
k_ook^k^h?o^k^h00?oooooooooooooPooooo`00ooo^k^koonk^k^3ok^k^
003oonKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00oooooooooooo
on3ooooo003oonk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^
k^koonk^k^3ok^k^003oooooooooooooh?ooool00?ook^k^ooo^k^kPonk^
kP00oooVi^KoonKVi^3oi^KV003oonk^k_ook^k^h?o^k^h00?oooooooooo
oooPooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?oo
k^k^ooo^k^kPonk^kP00ooooooooooooon3ooooo003oonk^k_ook^k^h?o^
k^h00?ooi^KVoooVi^KPonKViP00ooo^k^koonk^k^3ok^k^003ooooooooo
ooooh?ooool00?ook^k^ooo^k^kPonk^kP00oooVi^KoonKVi^3oi^KV003o
onk^k_ook^k^h?o^k^h00?oooooooooooooPooooo`00ooo^k^koonk^k^3o
k^k^003oonKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00oooooooo
ooooon3ooooo003oonk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00
ooo^k^koonk^k^3ok^k^003oooooooooooooh?ooool00?ook^k^ooo^k^kP
onk^kP00oooVi^KoonKVi^3oi^KV003oonk^k_ook^k^h?o^k^h00?oooooo
oooooooPooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H0
0?ook^k^ooo^k^kPonk^kP00ooooooooooooon3ooooo003oonk^k_ook^k^
h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^k^koonk^k^3ok^k^003ooooo
ooooooooh?ooool00?ook^k^ooo^k^kPonk^kP00oooVi^KoonKVi^3oi^KV
003oonk^k_ook^k^h?o^k^h00?oooooooooooooPooooo`00ooo^k^koonk^
k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00oooo
ooooooooon3ooooo003oonk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKV
iP00ooo^k^koonk^k^3ok^k^003oooooooooooooh?ooool00?ook^k^ooo^
k^kPonk^kP00oooVi^KoonKVi^3oi^KV003oonk^k_ook^k^h?o^k^h00?oo
oooooooooooPooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oV
i^H00?ook^k^ooo^k^kPonk^kP00ooooooooooooon3ooooo003oonk^k_oo
k^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^k^koonk^k^3ok^k^003o
ooooooooooooh?ooool00?ook^k^ooo^k^kPonk^kP00oooVi^KoonKVi^3o
i^KV003oonk^k_ook^k^h?o^k^h00?oooooooooooooPooooo`00ooo^k^ko
onk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00
ooooooooooooon3ooooo003oonk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KP
onKViP00ooo^k^koonk^k^3ok^k^003oooooooooooooh?ooool00?ook^k^
ooo^k^kPonk^kP00oooVi^KoonKVi^3oi^KV003oonk^k_ook^k^h?o^k^h0
0?oooooooooooooPooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KV
h?oVi^H00?ook^k^ooo^k^kPonk^kP00ooooooooooooon3ooooo003oonk^
k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^k^koonk^k^3ok^k^
003oooooooooooooh?ooool00?ook^k^ooo^k^kPonk^kP00oooVi^KoonKV
i^3oi^KV003oonk^k_ook^k^h?o^k^h00?oooooooooooooPooooo`00ooo^
k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^
kP00ooooooooooooon3ooooo003oonk^k_ook^k^h?o^k^h00?ooi^KVoooV
i^KPonKViP00ooo^k^koonk^k^3ok^k^003oooooooooooooh?ooool00?oo
k^k^ooo^k^kPonk^kP00oooVi^KoonKVi^3oi^KV003oonk^k_ook^k^h?o^
k^h00?oooooooooooooPooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_oo
i^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00ooooooooooooon3ooooo003o
onk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^k^koonk^k^3o
k^k^003oooooooooooooh?ooool00?ook^k^ooo^k^kPonk^kP00oooVi^Ko
onKVi^3oi^KV003oonk^k_ook^k^h?o^k^h00?oooooooooooooPooooo`00
ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kP
onk^kP00ooooooooooooon3ooooo003oonk^k_ook^k^h?o^k^h00?ooi^KV
oooVi^KPonKViP00ooo^k^koonk^k^3ok^k^003oooooooooooooh?ooool0
0?ook^k^ooo^k^kPonk^kP00oooVi^KoonKVi^3oi^KV003oonk^k_ook^k^
h?o^k^h00?oooooooooooooPooooo`00ooo^k^koonk^k^3ok^k^003oonKV
i_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00ooooooooooooon3ooooo
003oonk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^k^koonk^
k^3ok^k^003oooooooooooooh?ooool00?ook^k^ooo^k^kPonk^kP00oooV
i^KoonKVi^3oi^KV003oonk^k_ook^k^h?o^k^h00?oooooooooooooPoooo
o`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?ook^k^ooo^
k^kPonk^kP00ooooooooooooon3ooooo003oonk^k_ook^k^h?o^k^h00?oo
i^KVoooVi^KPonKViP00ooo^k^koonk^k^3ok^k^003oooooooooooooh?oo
ool00?ook^k^ooo^k^kPonk^kP00oooVi^KoonKVi^3oi^KV003oonk^k_oo
k^k^h?o^k^h00?oooooooooooooPooooo`00ooo^k^koonk^k^3ok^k^003o
onKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00ooooooooooooon3o
oooo003oonk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^k^ko
onk^k^3ok^k^003oooooooooooooh?ooool00?ook^k^ooo^k^kPonk^kP00
oooVi^KoonKVi^3oi^KV003oonk^k_ook^k^h?o^k^h00?oooooooooooooP
ooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?ook^k^
ooo^k^kPonk^kP00ooooooooooooon3ooooo003oonk^k_ook^k^h?o^k^h0
0?ooi^KVoooVi^KPonKViP00ooo^k^koonk^k^3ok^k^003ooooooooooooo
h?ooool00?ook^k^ooo^k^kPonk^kP00oooVi^KoonKVi^3oi^KV003oonk^
k_ook^k^h?o^k^h00?oooooooooooooPooooo`00ooo^k^koonk^k^3ok^k^
003oonKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00oooooooooooo
on3ooooo003oonk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^
k^koonk^k^3ok^k^003oooooooooooooh?ooool00?ook^k^ooo^k^kPonk^
kP00oooVi^KoonKVi^3oi^KV003oonk^k_ook^k^h?o^k^h00?oooooooooo
oooPooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?oo
k^k^ooo^k^kPonk^kP00ooooooooooooon3ooooo003oonk^k_ook^k^h?o^
k^h00?ooi^KVoooVi^KPonKViP001_o^k^h2ong]k@0:on_[jooXj>SoiNGU
on;Rh_oMgMgof=SHomCDe?oAdM7oc/k>olc<c0;obl_;=Oo:b/X2ol_;b`0:
olc<c?o>c/kodM7AomCDe?oHf=SogMgMon;Rh_oUiNGoj>SXon_[j`;okNg]
2?o^k^h2ong]k@0:on_[jooXj>SoiNGUon;Rh_oMgMgof=SHomCDe?oAdM7o
c/k>olc<c0;obl_;=Oo:b/X2ol_;b`0:olc<c?o>c/kodM7AomCDe?oHf=So
gMgMon;Rh_oUiNGoj>SXon_[j`;okNg]2?o^k^h2ong]k@0:on_[jooXj>So
iNGUon;Rh_oMgMgof=SHomCDe?oAdM7oc/k>olc<c0;obl_;=Oo:b/X2ol_;
b`0:olc<c?o>c/kodM7AomCDe?oHf=SogMgMon;Rh_oUiNGoj>SXon_[j`;o
kNg]2?o^k^h2ong]k@0:on_[jooXj>SoiNGUon;Rh_oMgMgof=SHomCDe?oA
dM7oc/k>olc<c0;obl_;=Oo:b/X2ol_;b`0:olc<c?o>c/kodM7AomCDe?oH
f=SogMgMon;Rh_oUiNGoj>SXon_[j`;okNg]2?o^k^h2ong]k@0:on_[jooX
j>SoiNGUon;Rh_oMgMgof=SHomCDe?oAdM7oc/k>olc<c0;obl_;=Oo:b/X2
ol_;b`0:olc<c?o>c/kodM7AomCDe?oHf=SogMgMon;Rh_oUiNGoj>SXon_[
j`;okNg]ooo^k^hTonk^kP001Oooool2ooknoP0:oo_knooinOWolo?cong]
kOoUiNGog=cLomCDe?o<c<coalO7ol?3``;o`<300_no_klcokjn_P;o_kno
0_o0`<002_o3`l?oalO7olc<c?oDe=Cog=cLonGUiOo]kNgolo?cooWinOok
no/2ooknoPKooooo0_ono_h02_okno_onOWioo?cloo]kNgoiNGUomcLg?oD
e=Coc<c<olO7aoo3`l<2ol30`0;o_kno<onn_[h2okno_`;o`<3000[o`l?3
olO7aoo<c<coe=CDomcLg?oUiNGokNg]oo?clooinOWono_k0_ono_h6oooo
o`;oo_kn00[ono_kooWinOoclo?okNg]onGUiOoLg=coe=CDolc<c?o7alOo
`l?30_o0`<02okno_c?o_[jn0_no_kl2ol30`00:ol?3`oo7alOoc<c<omCD
e?oLg=coiNGUong]kOoclo?onOWioo_kn`;oo_kn1_ooool2ooknoP0:oo_k
nooinOWolo?cong]kOoUiNGog=cLomCDe?o<c<coalO7ol?3``;o`<300_no
_klcokjn_P;o_kno0_o0`<002_o3`l?oalO7olc<c?oDe=Cog=cLonGUiOo]
kNgolo?cooWinOokno/2ooknoPKooooo0_ono_h02_okno_onOWioo?cloo]
kNgoiNGUomcLg?oDe=Coc<c<olO7aoo3`l<2ol30`0;o_kno<onn_[h2okno
_`;o`<3000[o`l?3olO7aoo<c<coe=CDomcLg?oUiNGokNg]oo?clooinOWo
no_k0_ono_koooooob?ooooo0005onk^kP0>ong]kOoZj^[oinOWon;Rh_oI
fMWoc/k>ol?3`onh^;So[Zj^ojJVY_nPX:3oW9bLoiVIVOnHV9PgoiNGU`0=
oiRHV?nIVIWoW9bLoj2PX?nVYZKo[Zj^okRh^?o3`l?oc/k>omWIfOoRh^;o
inOWon[ZjP02ong]k@Gok^k^00kokNg]on[Zj_oWinOoh^;RomWIfOo>c/ko
`l?3okRh^?n^[ZkoYZJVoj2PX?nLW9coVIVIoiRHV3OoUiNG00goV9RHoiVI
VOnLW9coX:2PojJVY_n^[Zko^;Rhol?3`oo>c/kofMWIon;Rh_oWinOoj^[Z
00;okNg]1Oo^k^h03_o]kNgoj^[ZonOWiooRh^;ofMWIolk>c_o3`l?o^;Rh
ojj^[_nVYZKoX:2PoibLW?nIVIWoV9RH=onGUiL03OnHV9SoVIVIoibLW?nP
X:3oYZJVojj^[_nh^;So`l?3olk>c_oIfMWoh^;RonOWiooZj^X00_o]kNd5
onk^kP0>ong]kOoZj^[oinOWon;Rh_oIfMWoc/k>ol?3`onh^;So[Zj^ojJV
Y_nPX:3oW9bLoiVIVOnHV9PgoiNGU`0=oiRHV?nIVIWoW9bLoj2PX?nVYZKo
[Zj^okRh^?o3`l?oc/k>omWIfOoRh^;oinOWon[ZjP02ong]k@Gok^k^00ko
kNg]on[Zj_oWinOoh^;RomWIfOo>c/ko`l?3okRh^?n^[ZkoYZJVoj2PX?nL
W9coVIVIoiRHV3OoUiNG00goV9RHoiVIVOnLW9coX:2PojJVY_n^[Zko^;Rh
ol?3`oo>c/kofMWIon;Rh_oWinOoj^[Z00;okNg]ooo^k^hRonk^kP001OoV
i^H03OoShn?oh>3Pom[Jf_oAdM7oaLG5okNg]onXZ:SoW9bLoi2@T?n8R8So
PH61oginO_mkNg/0>OmjNWX03_mkNg_oOWinoh61POn8R8SoT92@oibLW?nX
Z:So]kNgolG5aOoAdM7of][Jon3Ph?oShn?oiNGU1OoVi^H03OoShn?oh>3P
om[Jf_oAdM7oaLG5okNg]onXZ:SoW9bLoi2@T?n8R8SoPH61oginO_mkNg/0
>OmjNWX03_mkNg_oOWinoh61POn8R8SoT92@oibLW?nXZ:So]kNgolG5aOoA
dM7of][Jon3Ph?oShn?oiNGU1OoVi^H03OoShn?oh>3Pom[Jf_oAdM7oaLG5
okNg]onXZ:SoW9bLoi2@T?n8R8SoPH61oginO_mkNg/0>OmjNWX03_mkNg_o
OWinoh61POn8R8SoT92@oibLW?nXZ:So]kNgolG5aOoAdM7of][Jon3Ph?oS
hn?oiNGU1OoVi^H03OoShn?oh>3Pom[Jf_oAdM7oaLG5okNg]onXZ:SoW9bL
oi2@T?n8R8SoPH61oginO_mkNg/0>OmjNWX03_mkNg_oOWinoh61POn8R8So
T92@oibLW?nXZ:So]kNgolG5aOoAdM7of][Jon3Ph?oShn?oiNGU1OoVi^H0
3OoShn?oh>3Pom[Jf_oAdM7oaLG5okNg]onXZ:SoW9bLoi2@T?n8R8SoPH61
oginO_mkNg/0>OmjNWX03_mkNg_oOWinoh61POn8R8SoT92@oibLW?nXZ:So
]kNgolG5aOoAdM7of][Jon3Ph?oShn?oiNGUoooVi^HRonKViP001Oo^k^h0
5?oXj>Soh^;RomWIfOo:b/[o^[ZjojRXZ?nHV9SoTY:BojFUYOo0`<3oemOG
on_[joofm_KomoOgooWinOohn?SonOWioo[jn_oinOWomoOg0oohn?P2ooWi
n@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooSh
n0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg
00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi01?on_[jooWi
nOohn?SonOWiooShn?ogmoOokNg]omSHf?o1`L7oYJFUoi:BT_nHV9SoZ:RX
okZj^_o:b/[ofMWIon;Rh_oXj>Sok>c/00Gok^k^01Coj>SXon;Rh_oIfMWo
b/[:okZj^_nXZ:SoV9RHoi:BT_nUYJGo`<30omOGeoo[jn_om_KfooOgmooi
nOWon?ShooWinOojn_[onOWiooOgm`?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?o
n_[jooWinOogmoL00oohn?P2ooWin@0Coo[jn_oinOWon?ShooWinOohn?So
moOgong]kOoHf=So`L71ojFUYOnBTY;oV9RHojRXZ?nj^[[ob/[:omWIfOoR
h^;oj>SXonc/k005onk^kP0DonSXj?oRh^;ofMWIol[:b_nj^[[oZ:RXoiRH
V?nBTY;oYJFUol30`?oGemOojn_[ooKfm_ogmoOonOWiooShn?oinOWon_[j
ooWinOogmoL3ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03
oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;o
nOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?o
n?Sh0_oinOT04oojn_[onOWiooShn?oinOWon?ShooOgmoo]kNgof=SHol71
`OnUYJGoTY:BoiRHV?nXZ:So^[Zjol[:b_oIfMWoh^;RonSXj?o/k>`01Oo^
k^h05?oXj>Soh^;RomWIfOo:b/[o^[ZjojRXZ?nHV9SoTY:BojFUYOo0`<3o
emOGon_[joofm_KomoOgooWinOohn?SonOWioo[jn_oinOWomoOg0oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi01?on_[j
ooWinOohn?SonOWiooShn?ogmoOokNg]omSHf?o1`L7oYJFUoi:BT_nHV9So
Z:RXokZj^_o:b/[ofMWIon;Rh_oXj>Sok>c/00Gok^k^01Coj>SXon;Rh_oI
fMWob/[:okZj^_nXZ:SoV9RHoi:BT_nUYJGo`<30omOGeoo[jn_om_KfooOg
mooinOWon?ShooWinOojn_[onOWiooOgm`?on?Sh0_oinOT00oojn_[onOWi
ooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[j
n_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi
00?on_[jooWinOogmoL00oohn?P2ooWin@0Coo[jn_oinOWon?ShooWinOoh
n?SomoOgong]kOoHf=So`L71ojFUYOnBTY;oV9RHojRXZ?nj^[[ob/[:omWI
fOoRh^;oj>SXonc/k03oonk^kR;ok^k^0005ooooo`0<ooKfm_o]kNgogMgM
ol[:b_nd];CoWinOojZZZ_o>c/kok^k^ooKfm_olo?coo_kn>oooool03Oon
o_koo?clooOgmoo_knooclo?oj^[ZonOWioo];Bdol[:b_oMgMgokNg]ooKf
m_okno/01Oooool03?ofm_KokNg]omgMgOo:b/[o];BdoinOWonZZZ[oc/k>
onk^k_ofm_Koo?clooknoS_ooooo00goo_knooclo?ogmoOokno_olo?con[
Zj_oWinOokBd]?o:b/[ogMgMong]kOofm_Kono_k00Gooooo00com_Kfong]
kOoMgMgob/[:okBd]?nOWiooZZZZolk>c_o^k^kom_Kfooclo?ono_hkoooo
o`0=ookno_olo?comoOgono_koo?clooZj^[oinOWond];Cob/[:omgMgOo]
kNgom_Kfoo_kn`05ooooo`0<ooKfm_o]kNgogMgMol[:b_nd];CoWinOojZZ
Z_o>c/kok^k^ooKfm_olo?coo_kn>oooool03Oono_koo?clooOgmoo_knoo
clo?oj^[ZonOWioo];Bdol[:b_oMgMgokNg]ooKfm_okno/01Oooool03?of
m_KokNg]omgMgOo:b/[o];BdoinOWonZZZ[oc/k>onk^k_ofm_Koo?clookn
oS_ooooo00goo_knooclo?ogmoOokno_olo?con[Zj_oWinOokBd]?o:b/[o
gMgMong]kOofm_Kono_k0?oooooo8_ooool000Gok^k^00[oh^;RomKFe_o3
`l?o[Zj^oiZJV_n][Jgog]kNon_[joodm?Cono_k?oooool02ookno_olo?c
onc/k?oQhN7o/;2`oiZJV_n^[Zko`l?3omKFe_oRh^;oj>SX00Gok^k^00[o
h^;RomKFe_o3`l?o[Zj^oiZJV_n][Jgog]kNon_[joodm?Cono_k?oooool0
2ookno_olo?conc/k?oQhN7o/;2`oiZJV_n^[Zko`l?3omKFe_oRh^;oj>SX
00Gok^k^00[oh^;RomKFe_o3`l?o[Zj^oiZJV_n][Jgog]kNon_[joodm?Co
no_k?oooool02ookno_olo?conc/k?oQhN7o/;2`oiZJV_n^[Zko`l?3omKF
e_oRh^;oj>SX00Gok^k^00[oh^;RomKFe_o3`l?o[Zj^oiZJV_n][Jgog]kN
on_[joodm?Cono_k?oooool02ookno_olo?conc/k?oQhN7o/;2`oiZJV_n^
[Zko`l?3omKFe_oRh^;oj>SX00Gok^k^00[oh^;RomKFe_o3`l?o[Zj^oiZJ
V_n][Jgog]kNon_[joodm?Cono_k?oooool02ookno_olo?conc/k?oQhN7o
/;2`oiZJV_n^[Zko`l?3omKFe_oRh^;oj>SX0?ook^k^8_o^k^h000Goi^KV
00[oe]KFolO7aonb/[;oW9bLojNWYooDe=Coh>3Ponc/k?oemOGooOgm?ooo
ool02oono_kom_Kfonc/k?oRh^;ofMWIoj^[ZonLW9co/[:bolO7aooFe]Ko
gMgM00Goi^KV00[oe]KFolO7aonb/[;oW9bLojNWYooDe=Coh>3Ponc/k?oe
mOGooOgm?oooool02oono_kom_Kfonc/k?oRh^;ofMWIoj^[ZonLW9co/[:b
olO7aooFe]KogMgM00Goi^KV00[oe]KFolO7aonb/[;oW9bLojNWYooDe=Co
h>3Ponc/k?oemOGooOgm?oooool02oono_kom_Kfonc/k?oRh^;ofMWIoj^[
ZonLW9co/[:bolO7aooFe]KogMgM00Goi^KV00[oe]KFolO7aonb/[;oW9bL
ojNWYooDe=Coh>3Ponc/k?oemOGooOgm?oooool02oono_kom_Kfonc/k?oR
h^;ofMWIoj^[ZonLW9co/[:bolO7aooFe]KogMgM00Goi^KV00[oe]KFolO7
aonb/[;oW9bLojNWYooDe=Coh>3Ponc/k?oemOGooOgm?oooool02oono_ko
m_Kfonc/k?oRh^;ofMWIoj^[ZonLW9co/[:bolO7aooFe]KogMgM0?ooi^KV
8_oVi^H000Gok^k^00_of=SHolK6a_n^[ZkoXj>SolK6a_oDe=Coh>3Ponc/
k?obl_;oo?clooknoP0Hooooo`03onc/k?omoOgooooo00;om?Cd0oooool0
0oo]kNgokno_ooooo`0Kooooo`0;oo[jn_odm?Coj^[Zon?ShooGemOocLg=
ojJVY_n^[Zkoa/K6omSHf?oRh^801Oo^k^h02ooHf=Soa/K6ojj^[_nSXj?o
a/K6omCDe?oPh>3ok>c/oo;bl_olo?coo_kn01Sooooo00?ok>c/oogmoOoo
ool00_odm?@3ooooo`03ong]kOo_knoooooo01_ooooo00_on_[jooCdm?oZ
j^[ohn?SomOGeoo=cLgoYZJVojj^[_o6a/Kof=SHon;RhP05onk^kP0;omSH
f?o6a/Ko[Zj^oj>SXoo6a/Koe=CDon3Ph?o/k>col_;booclo?ono_h06?oo
ool00oo/k>cooOgmooooo`02ooCdm0?ooooo00?okNg]ono_koooool02ooo
ool00ooXj>Sod];Boogmo@0=ooooo`0;oo[jn_odm?Coj^[Zon?ShooGemOo
cLg=ojJVY_n^[Zkoa/K6omSHf?oRh^801Oo^k^h02ooHf=Soa/K6ojj^[_nS
Xj?oa/K6omCDe?oPh>3ok>c/oo;bl_olo?coo_kn01Sooooo00?ok>c/oogm
oOooool00_odm?@3ooooo`03ong]kOo_knoooooo01_ooooo00_on_[jooCd
m?oZj^[ohn?SomOGeoo=cLgoYZJVojj^[_o6a/Kof=SHon;RhP05onk^kP0;
omSHf?o6a/Ko[Zj^oj>SXoo6a/Koe=CDon3Ph?o/k>col_;booclo?ono_h0
6?ooool00oo/k>cooOgmooooo`02ooCdm0?ooooo00?okNg]ono_koooool0
2_ooool00ooinOWofMWIomgMg@0>ooooo`0;oo[jn_odm?Coj^[Zon?ShooG
emOocLg=ojJVY_n^[Zkoa/K6omSHf?oRh^80ooo^k^hRonk^kP001Oooool0
3ooShn?ocLg=ok2`/?n_[jooa/K6om;Bd_oLg=coi^KVonc/k?oemOGon?Sh
oo[jn_omoOgoooooooclo008ooooo`03og5aLOlh>3Sooooo00?ooooo00?o
@410ogmoOoomoOd00_ooool07_mADE7o20P8oaXJ6_nLW9co4a<CoeIFE_oo
ooooiNGUod10@?l0003o4Q8BoadM7Oohn?SooOgmod10@?moOgoooooooo_k
nom=CDgo;Bd]ono_koomoOgomOGeo`l?3ol<30co0000o`h>3_lF5QKooooo
oogmo@Cooooo013ooOgmooooooomoOgono_kooShn?odm?CokNg]onKVi_oO
gmooe]KFolc<c?ne]KGo/K6aolg=cOoShn?olo?c1Oooool03ooShn?ocLg=
ok2`/?n_[jooa/K6om;Bd_oLg=coi^KVonc/k?oemOGon?Shoo[jn_omoOgo
ooooooclo008ooooo`03og5aLOlh>3Sooooo00?ooooo00?o@410ogmoOoom
oOd00_ooool05omADE7o20P8oaXJ6_nLW9co4a<CoeIFE_ooooooiNGUod10
@?l0003o4Q8BoadM7Oohn?SooOgmod10@?moOgoooooooo_knom=CDgo;Bd]
ono_koomoOgo51@D00Co000000?oE5ADooooooomoOd01?ooool04?omoOgo
oooooogmoOokno_on?ShooCdm?o]kNgoi^KVomoOgooFe]Koc<c<okFe]Ona
/K7ocLg=on?Shooclo<5ooooo`0?on?Shoo=cLgo/;2`ojn_[oo6a/Kod];B
omcLg?oVi^Kok>c/ooGemOohn?Son_[joogmoOooooooo?cl00Sooooo00?o
LG5aocPh>?ooool00oooool00om0@43oOgmooogmo@02ooooo`0Noe5ADOl8
20So6QXJoibLW?lC4a?oEUIFoooooooUiNGo@410o`000?lB4Q;o7AdMooSh
n?omoOgo@410ogmoOooooooono_kode=COl];Bgokno_oogmoOmFEUKo4A4A
ocLg=olI6AWoI6AToo;bl_oooooooOgm1?ooool04?omoOgooooooogmoOok
no_on?ShooCdm?o]kNgoi^KVomoOgooFe]Koc<c<okFe]Ona/K7ocLg=on?S
hooclo<5ooooo`0?on?Shoo=cLgo/;2`ojn_[oo6a/Kod];BomcLg?oVi^Ko
k>c/ooGemOohn?Son_[joogmoOooooooo?cl00Sooooo00?oLG5aocPh>?oo
ool00oooool00om0@43oOgmooogmo@02ooooo`0Foe5ADOl820So6QXJoibL
W?lC4a?oEUIFoooooooUiNGo@410o`000?lB4Q;o7AdMooShn?omoOgo@410
ogmoOooooooono_kode=COl];Bgokno_oogmo@?ooooo00Goi>CTo`000?o^
k^kooooooogmo@04ooooo`0@oogmoOoooooooOgmoo_knoohn?Som?Cdong]
kOoVi^KogmoOomKFe_o<c<co]KFeok6a/Oo=cLgohn?Soo?cl`Gooooo00oo
hn?Solg=cOn`/;3o[jn_olK6a_oBd];og=cLonKVi_o/k>comOGeooShn?oj
n_[ooOgmooooooolo?`02?ooool00omaLG7o>3Phooooo`03ooooo`03od10
@?moOgoooOgm00;ooooo01koDE5Ao`P82?lJ6Q[oW9bLoa<C4omFEUKooooo
onGUiOm0@43o0000oa8B4_lM7Agon?ShoogmoOm0@43oOgmooooooookno_o
CDe=obd];Oo_knoooOgmoiBDU?lM7Ago=3@dobXZ:_moOgooo_knooooooom
oOd4ooooo`0@oogmoOoooooooOgmoo_knoohn?Som?Cdong]kOoVi^KogmoO
omKFe_o<c<co]KFeok6a/Oo=cLgohn?Soo?clooooooo8_ooool000Gok^k^
01?odM7Aok^k^onQXJ7o][Jfol?3`oo?clooe]KFomoOgooVi^Koj^[Zono_
kooclo?om?CdooGemOogmoOom_KfooOgmoofm_Kon?Sh00;omoOg0_ofm_H0
1?m^KVko=SHfooKfm_ohn?P2ooOgm`0:ocdm?OmjNW[omoOgooOgmono_koo
0`<3omKFe_oNg]koEeMGoa0@40;omoOg00ko?cloobXZ:_o4a<ComoOgom3@
d?odm?ComoOgocdm?OmjNW[omoOgoeaLG?lO7aoogMgMooKfmP;omoOg00Co
m_Kfolo?col0003oh>3P0_ofm_H2ooOgm`0CooKfm_ohn?Som_KfooOgmoof
m_Kom?Cdoo;bl_o`l?3ojn_[onKVi_oQhN7of][Jom?Cdoo9bLWo_knoojJV
Y_nk^k_odM7Aon7Qh@05onk^kP0Com7AdOnk^k_oXJ6QokJf]_o3`l?oclo?
omKFe_oOgmooi^KVon[Zj_o_knoolo?cooCdm?oemOGomoOgooKfm_ogmoOo
m_KfooShn002ooOgm`;om_Kf00CoKVi^ocHf=_ofm_Kon?Sh0_ogmoL02_lm
?CgoNWYjooOgmoogmoOo_knoo`<30ooFe]Kog]kNoeMGEol@4102ooOgm`0B
oclo?olZ:R[oa<C4ooOgmoo@d=3om?CdooOgmolm?CgoNWYjooOgmomLG5co
7alOomgMgOofm_KomoOgoe5ADOl/;2cogmoO0_oNg]h05ooVi^Kom_KfooOg
moogmoOom_KfooShn?ofm_KomoOgooKfm_odm?Col_;boo3`l?o[jn_oi^KV
on7QhOoJf][odm?ColW9bOno_kooYZJVok^k^ooAdM7ohN7Q00Gok^k^01?o
dM7Aok^k^onQXJ7o][Jfol?3`oo?clooe]KFomoOgooVi^Koj^[Zono_kooc
lo?om?CdooGemOogmoOom_KfooOgmoofm_Kon?Sh00;omoOg0_ofm_H01?m^
KVko=SHfooKfm_ohn?P2ooOgm`0:ocdm?OmjNW[omoOgooOgmono_koo0`<3
omKFe_oNg]koEeMGoa0@40;omoOg01Ko?cloobXZ:_o4a<ComoOgom3@d?od
m?ComoOgocdm?OmjNW[omoOgoeaLG?lO7aoogMgMooKfm_ogmoOogMgMooCd
m?ohn?Sog=cLo`d=3Om_Kfoom_Kf0_ogmoL04oofm_Kon?ShooKfm_ogmoOo
m_KfooCdm?obl_;ol?3`on_[jooVi^KohN7Qom[Jf_oCdm?obLW9okno_onV
YZKo^k^kom7AdOoQhN401Oo^k^h04ooAdM7o^k^koj6QXOnf][Ko`l?3olo?
cooFe]KogmoOonKVi_oZj^[okno_oo?cloodm?ComOGeooOgmoofm_KomoOg
ooKfm_ohn?P00_ogmoL2ooKfmP04ofi^K_lf=SKom_KfooShn0;omoOg00[o
?CdmogYjN_ogmoOomoOgokno_ol30`?oe]KFomkNg_mGEeOo410@0_ogmoL0
3_lo?coo:RXZolC4a?ogmoOod=3@ooCdm?ogmoOo?CdmogYjN_ogmoOoG5aL
oalO7ooMgMgom_Kf0_ogmoL01_ofm_Kon?ShomcLg?l0003oiNGUooKfmP;o
moOg01?om_KfooShn?ofm_KomoOgooKfm_odm?Col_;boo3`l?o[jn_oi^KV
on7QhOoJf][odm?ColW9bOno_kooYZJVok^k^ooAdM7ohN7Q00Gok^k^01?o
dM7Aok^k^onQXJ7o][Jfol?3`oo?clooe]KFomoOgooVi^Koj^[Zono_kooc
lo?om?CdooGemOogmoOom_KfooOgmoofm_Kon?Sh00;omoOg0_ofm_H01?m^
KVko=SHfooKfm_ohn?P2ooOgm`0:ocdm?OmjNW[omoOgooOgmono_koo0`<3
omKFe_oNg]koEeMGoa0@40;omoOg01Ko?cloobXZ:_o4a<ComoOgom3@d?od
m?ComoOgocdm?OmjNW[omoOgoeaLG?lO7aoogMgMooKfm_ogmoOom?CdooKf
m_ohn?Sobl_;o`410OnEUIGom_Kf0_ogmoL04oofm_Kon?ShooKfm_ogmoOo
m_KfooCdm?obl_;ol?3`on_[jooVi^KohN7Qom[Jf_oCdm?obLW9okno_onV
YZKo^k^kom7AdOoQhN40ooo^k^hRonk^kP001OoVi^H02oo9bLWo/[:boijN
W_nc/k?o`<30olW9bOoCdm?ofMWIomgMgOoRh^;oiNGU00;oj^[Z00?ok>c/
ong]kOo]kNd01oo^k^h00om[Jf_o=3@donk^kP03onk^kP0>oc/k>omfMWKo
l?3`onk^k_o:b/[o0P82ok2`/?o^k^koU9BDoadM7Oo`l?3ocLg=o`000?n;
Rh/4onk^kP06oo3`l?lk>c_oMWIfof][JolD51Coc<c<0_o^k^h01_o`l?3o
k^k^onk^k_o6a/Ko0000omSHf0;ok^k^00Col?3`onk^k_o^k^kok^k^0_o]
kNd2onc/k00=onWYjOoVi^Kohn?Son3Ph?oKfm_oeMGEolg=cOo5aLGo^k^k
ojFUYOnb/[;obLW9omSHf005onKViP0;olW9bOnb/[;oWYjNok>c/oo0`<3o
bLW9om?CdooIfMWogMgMon;Rh_oUiND00_oZj^X00oo/k>cokNg]ong]k@07
onk^kP03of][Jold=3Cok^k^00?ok^k^00ko>c/kogIfM_o`l?3ok^k^ol[:
b_l20P;o/;2`onk^k_nDU9Co7AdMoo3`l?o=cLgo0000oh^;R`Cok^k^00Ko
l?3`oc/k>omfMWKoJf][oa@D5?o<c<`2onk^kP04oo3`l?oEeMGo61PHoiNG
U`Cok^k^00Col?3`onk^k_o^k^kok^k^0_o]kNd2onc/k00=onWYjOoVi^Ko
hn?Son3Ph?oKfm_oeMGEolg=cOo5aLGo^k^kojFUYOnb/[;obLW9omSHf005
onKViP0;olW9bOnb/[;oWYjNok>c/oo0`<3obLW9om?CdooIfMWogMgMon;R
h_oUiND00_oZj^X00oo/k>cokNg]ong]k@07onk^kP03of][Jold=3Cok^k^
00?ok^k^00ko>c/kogIfM_o`l?3ok^k^ol[:b_l20P;o/;2`onk^k_nDU9Co
7AdMoo3`l?o=cLgo0000oh^;R`Cok^k^00Kol?3`oc/k>omfMWKoJf][oa@D
5?o<c<`2onk^kP03oo3`l?o^k^kok^k^00;ok^k^00CoDe=Cochn?_o^k^ko
l?3`0oo^k^h2ong]k@;ok>c/00gojNWYonKVi_oShn?oh>3Pom_KfooEeMGo
cLg=olG5aOnk^k_oYJFUok:b/_o9bLWof=SH00Goi^KV00_obLW9ok:b/_nN
WYko/k>col30`?o9bLWodm?ComWIfOoMgMgoh^;RonGUi@02on[ZjP03onc/
k?o]kNgokNg]00Ook^k^00?oJf][oc@d=?o^k^h00oo^k^h03_lk>c_oMWIf
oo3`l?o^k^kob/[:o`820_n`/;3ok^k^oiBDU?lM7Agol?3`olg=cOl0003o
Rh^;1?o^k^h01_o`l?3o>c/kogIfM_m[Jf_o51@Dolc<c0;ok^k^00Woe=CD
oibLW?nLW9coW9bLohb<S?l0003oTY:Bom?Cdoo`l?000oo^k^h2ong]k@;o
k>c/00gojNWYonKVi_oShn?oh>3Pom_KfooEeMGocLg=olG5aOnk^k_oYJFU
ok:b/_o9bLWof=SH00Goi^KV00_obLW9ok:b/_nNWYko/k>col30`?o9bLWo
dm?ComWIfOoMgMgoh^;RonGUi@02on[ZjP03onc/k?o]kNgokNg]00Ook^k^
00?oJf][oc@d=?o^k^h00oo^k^h03_lk>c_oMWIfoo3`l?o^k^kob/[:o`82
0_n`/;3ok^k^oiBDU?lM7Agol?3`olg=cOl0003oRh^;1?o^k^h01_o`l?3o
>c/kogIfM_m[Jf_o51@Dolc<c0;ok^k^00?ol?3`onk^k_o^k^h00_o^k^h0
1?lg=cOoFEUIonk^k_o`l?03onk^kP;okNg]0_o/k>`03OoYjNWoi^KVon?S
hooPh>3ofm_KomGEeOo=cLgoaLG5ok^k^onUYJGo/[:bolW9bOoHf=P0oooV
i^HRonKViP001Oo^k^h03Oo@d=3o^;RhoibLW?n/[:co^k^kolK6a_o=cLgo
dm?ComOGeooKfm_ogmoOon7QhOoRh^800_oShn<7onGUi@03onKVi_mVIVKo
<S8b00CoiNGU00?o>CTiog9bL_oVi^H00_oUiND02OnKVi_o;2`/obd];Ol`
<33o71`LonKVi_nZZZ[o0000okRh^003onGUi@;oi^KV00Co>CTioc8b<_l0
003o[jn_0_oUiND2onKViP;oiNGU00Co_knoo`000?o@d=3oiNGU0_oVi^H3
onGUi@;oi>CT0_oShn<03OoRh^;oh>3PomcLg?oIfMWoe]KFom3@d?o9bLWo
`L71okFe]OnUYJGo^;Rhom3@d?oPh>001Oo^k^h03Oo@d=3o^;RhoibLW?n/
[:co^k^kolK6a_o=cLgodm?ComOGeooKfm_ogmoOon7QhOoRh^800_oShn<7
onGUi@03onKVi_mVIVKo<S8b00CoiNGU00?o>CTiog9bL_oVi^H00_oUiND0
2OnKVi_o;2`/obd];Ol`<33o71`LonKVi_nZZZ[o0000okRh^003onGUi@;o
i^KV00Co>CTioc8b<_l0003o[jn_0_oUiND2onKViP04onGUiOo1`L7o5aLG
oiRHV0;oiNGU0_oVi^H3onGUi@;oi>CT0_oShn<03OoRh^;oh>3PomcLg?oI
fMWoe]KFom3@d?o9bLWo`L71okFe]OnUYJGo^;Rhom3@d?oPh>001Oo^k^h0
3Oo@d=3o^;RhoibLW?n/[:co^k^kolK6a_o=cLgodm?ComOGeooKfm_ogmoO
on7QhOoRh^800_oShn<7onGUi@03onKVi_mVIVKo<S8b00CoiNGU00?o>CTi
og9bL_oVi^H00_oUiND02OnKVi_o;2`/obd];Ol`<33o71`LonKVi_nZZZ[o
0000okRh^003onGUi@;oi^KV00Co>CTioc8b<_l0003o[jn_0_oUiND2onKV
iP?oiNGU00?ofm_Koa4A4OmgMgL00_oVi^H3onGUi@;oi>CT0_oShn<03OoR
h^;oh>3PomcLg?oIfMWoe]KFom3@d?o9bLWo`L71okFe]OnUYJGo^;Rhom3@
d?oPh>001Oo^k^h03Oo@d=3o^;RhoibLW?n/[:co^k^kolK6a_o=cLgodm?C
omOGeooKfm_ogmoOon7QhOoRh^800_oShn<7onGUi@03onKVi_mVIVKo<S8b
00CoiNGU00?o>CTiog9bL_oVi^H00_oUiND02OnKVi_o;2`/obd];Ol`<33o
71`LonKVi_nZZZ[o0000okRh^003onGUi@;oi^KV00Co>CTioc8b<_l0003o
[jn_0_oUiND02_oVi^KoYZJVo`410Om6ATKoB4Q8odI6A_l0003o@d=3ok>c
/ooVi^H3onGUi@;oi>CT0_oShn<03OoRh^;oh>3PomcLg?oIfMWoe]KFom3@
d?o9bLWo`L71okFe]OnUYJGo^;Rhom3@d?oPh>001Oo^k^h03Oo@d=3o^;Rh
oibLW?n/[:co^k^kolK6a_o=cLgodm?ComOGeooKfm_ogmoOon7QhOoRh^80
0_oShn<7onGUi@03onKVi_mVIVKo<S8b00CoiNGU00?o>CTiog9bL_oVi^H0
0_oUiND02OnKVi_o;2`/obd];Ol`<33o71`LonKVi_nZZZ[o0000okRh^003
onGUi@;oi^KV00Co>CTioc8b<_l0003o[jn_0_oUiND2onKViP?oiNGU00?o
f=SHo`d=3Om]KFd00_oVi^H3onGUi@;oi>CT0_oShn<03OoRh^;oh>3PomcL
g?oIfMWoe]KFom3@d?o9bLWo`L71okFe]OnUYJGo^;Rhom3@d?oPh>00ooo^
k^hRonk^kP001Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`2omkNgP?ogMgM00Gog]kN
omgMgOmRHV;o<30`omkNgP03omgMg@03ocLg=omKFe_ogMgM00;og]kN0_oM
gMd01ooKfm_oP820oa`L7?oMgMgo_[jno`000?mmOGd00_oMgMd02OoNg]ko
gMgMomgMgOlg=cOoKFe]odY:B_m5ADGofm_KomkNgP02omgMg@;og]kN00Co
^;Rho`000?o9bLWog]kN0_oMgMd2omkNgP;ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3o
lO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`2omkNgP?ogMgM00Gog]kNomgMgOmR
HV;o<30`omkNgP03omgMg@03ocLg=omKFe_ogMgM00;og]kN0_oMgMd01ooK
fm_oP820oa`L7?oMgMgo_[jno`000?mmOGd00_oMgMd02OoNg]kogMgMomgM
gOlg=cOoKFe]odY:B_m5ADGofm_KomkNgP02omgMg@;og]kN00Co_;bloaLG
5on@T93og]kN0_oMgMd2omkNgP;ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Ooo
ool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`2omkNgP?ogMgM00Gog]kNomgMgOmRHV;o<30`
omkNgP03omgMg@03ocLg=omKFe_ogMgM00;og]kN0_oMgMd01ooKfm_oP820
oa`L7?oMgMgo_[jno`000?mmOGd00_oMgMd02OoNg]kogMgMomgMgOlg=cOo
KFe]odY:B_m5ADGofm_KomkNgP02omgMg@06omkNg_n=SHgoDE5Aob0P8?mK
Fe_oclo?0_oMgMd2omkNgP;ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool0
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`2omkNgP?ogMgM00Gog]kNomgMgOmRHV;o<30`omkN
gP03omgMg@03ocLg=omKFe_ogMgM00;og]kN0_oMgMd01ooKfm_oP820oa`L
7?oMgMgo_[jno`000?mmOGd00_oMgMd02OoNg]kogMgMomgMgOlg=cOoKFe]
odY:B_m5ADGofm_KomkNgP02omgMg@06odM7Aom_KfoogMgMomSHf?l0003o
clo?0_oMgMd2omkNgP;ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`2omkNgP?ogMgM00Gog]kNomgMgOmRHV;o<30`omkNgP03
omgMg@03ocLg=omKFe_ogMgM00;og]kN0_oMgMd01ooKfm_oP820oa`L7?oM
gMgo_[jno`000?mmOGd00_oMgMd02OoNg]kogMgMomgMgOlg=cOoKFe]odY:
B_m5ADGofm_KomkNgP02omgMg@06omCDe?nf][KoQhN7ochn?_l@413o`l?3
0_oMgMd2omkNgP;ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7aoooooolRooooo`00
1Oo^k^h03OoDe=Co_knoohb<S?nNWYko[Jf]okVi^Oo2`/;oalO7olc<c?o@
d=3od];BomGEeOoFe]H00_oGemL00ooHf=SofMWIomWIf@05omWIf@03of5Q
HOl_;boofMWI00?ofMWI00[o=SHfoa0@4?mkNg_o`/;2omOGeonIVIWo^KVi
omKFe_mBDU;oAdM70_oIfMT01Ole=CGo8B4Qoj6QXOoHf=So_;bl00;ofMWI
00Go=SHfofa/K?oCdm?o<c<coemOG`05omWIf@03okFe]Ol0003oaLG500Ko
fMWI0_oHf=P2omOGe`0=omGEeOoCdm?od=3@olk>c_o:b/[oaLG5okno_one
]KGoZJVYoiRHV?no_kooe=CDon;RhP05onk^kP0=omCDe?no_kooS8b<oijN
W_n][Jgo^KViol;2`_o7alOoc<c<om3@d?oBd];oeMGEomKFeP02omOGe`03
omSHf?oIfMWofMWI00GofMWI00?oHF5Qobl_;ooIfMT00ooIfMT02_lf=SKo
410@og]kNoo2`/;oemOGoiVIVOni^KWoe]KFoe9BD_m7AdL2omWIf@05ocDe
=OlQ8B7oXJ6QomSHf?nl_;`00_oIfMT01Olf=SKoK6a/om?Cdolc<c?oGemO
00KofMWI00?oZj^[o`L71onXZ:P01OoIfMT2omSHf0;oemOG00goeMGEom?C
doo@d=3oc/k>ol[:b_o5aLGo_knookFe]OnYZJWoV9RHokno_ooDe=Coh^;R
00Gok^k^00goe=CDokno_on<S8coWYjNojf][Oni^KWo`/;2olO7aoo<c<co
d=3@om;Bd_oEeMGoe]KF00;oemOG00?of=SHomWIfOoIfMT01OoIfMT00omQ
HF7o;bl_omWIf@03omWIf@0:ocHf=_l@413oNg]kol;2`_oGemOoVIVIokVi
^OoFe]KoDU9BodM7A`;ofMWI00Go=CDeob4Q8OnQXJ7of=SHokbl_002omWI
f@05ocHf=_m/K6codm?Coc<c<omOGel01?oIfMT01?n=SHgoDU9Boc0`<?nJ
VYX6omWIf@;of=SH0_oGemL03OoEeMGodm?Com3@d?o>c/kob/[:olG5aOno
_koo]KFeojVYZOnHV9So_knoomCDe?oRh^801Oo^k^h03OoDe=Co_knoohb<
S?nNWYko[Jf]okVi^Oo2`/;oalO7olc<c?o@d=3od];BomGEeOoFe]H00_oG
emL00ooHf=SofMWIomWIf@05omWIf@03of5QHOl_;boofMWI00?ofMWI00[o
=SHfoa0@4?mkNg_o`/;2omOGeonIVIWo^KViomKFe_mBDU;oAdM70_oIfMT0
1Ole=CGo8B4Qoj6QXOoHf=So_;bl00;ofMWI00Go=SHfofa/K?oCdm?o<c<c
oemOG`03omWIf@06ol[:b_lL71coXj>SomCDe?l0003ob/[:1OoIfMT2omSH
f0;oemOG00goeMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo_knookFe]OnYZJWo
V9RHokno_ooDe=Coh^;R00Gok^k^00goe=CDokno_on<S8coWYjNojf][Oni
^KWo`/;2olO7aoo<c<cod=3@om;Bd_oEeMGoe]KF00;oemOG00?of=SHomWI
fOoIfMT01OoIfMT00omQHF7o;bl_omWIf@03omWIf@0:ocHf=_l@413oNg]k
ol;2`_oGemOoVIVIokVi^OoFe]KoDU9BodM7A`;ofMWI00Go=CDeob4Q8OnQ
XJ7of=SHokbl_002omWIf@05ocHf=_m/K6codm?Coc<c<omOGel00ooIfMT0
1OnPX:3o1@D5ocPh>?mQHF7o`L7100KofMWI0_oHf=P2omOGe`0=omGEeOoC
dm?od=3@olk>c_o:b/[oaLG5okno_one]KGoZJVYoiRHV?no_kooe=CDon;R
hP3oonk^kR;ok^k^0005onKViP0=om7AdOno_kooR8R8oi>CTonRXZ;o[jn_
okZj^_o1`L7oalO7ol_;boo>c/kod=3@om7Ad@02om?Cd`?oe=CD0_oEeMD0
1_oFe]KoeMGEomKFe_mOGeko;Rh^omCDe0;oeMGE01coe]KFodI6A_mbLW;o
CDe=o`L71oo7alOoLg=cobTY:Ol=3@go;bl_ojBTY?oEeMCoe=CDol30`?m8
B4So30`<o`T92OlO7aooe]KFomGEe?le=CGoJFUYomGEeOo5aLGo;2`/ohf=
SOoFe]KoeMGD0_oDe=@01_na/K7o0000ol;2`_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD04?oDe=Codm?Com?CdooAdM7od=3@olg=cOo:b/[o`l?3okjn__nf
][KoZj^[oifMWOnATI7o_knoom7AdOoKfm/5onKViP0=om7AdOno_kooR8R8
oi>CTonRXZ;o[jn_okZj^_o1`L7oalO7ol_;boo>c/kod=3@om7Ad@02om?C
d`?oe=CD0_oEeMD01_oFe]KoeMGEomKFe_mOGeko;Rh^omCDe0;oeMGE01co
e]KFodI6A_mbLW;oCDe=o`L71oo7alOoLg=cobTY:Ol=3@go;bl_ojBTY?oE
eMCoe=CDol30`?m8B4So30`<o`T92OlO7aooe]KFomGEe?le=CGoJFUYomGE
eOo5aLGo;2`/ohf=SOoFe]KoeMGD0_oDe=@2omGEe@04oc@d=?mKFe_oe]KF
omGEe0;oe=CD0_oEeMD04?oDe=Codm?Com?CdooAdM7od=3@olg=cOo:b/[o
`l?3okjn__nf][KoZj^[oifMWOnATI7o_knoom7AdOoKfm/5onKViP0=om7A
dOno_kooR8R8oi>CTonRXZ;o[jn_okZj^_o1`L7oalO7ol_;boo>c/kod=3@
om7Ad@02om?Cd`?oe=CD0_oEeMD01_oFe]KoeMGEomKFe_mOGeko;Rh^omCD
e0;oeMGE01coe]KFodI6A_mbLW;oCDe=o`L71oo7alOoLg=cobTY:Ol=3@go
;bl_ojBTY?oEeMCoe=CDol30`?m8B4So30`<o`T92OlO7aooe]KFomGEe?le
=CGoJFUYomGEeOo5aLGo;2`/ohf=SOoFe]KoeMGD0_oDe=@01_oEeMGo]kNg
o`820_nc/k?oe]KFomGEe0;oe=CD0_oEeMD04?oDe=Codm?Com?CdooAdM7o
d=3@olg=cOo:b/[o`l?3okjn__nf][KoZj^[oifMWOnATI7o_knoom7AdOoK
fm/5onKViP0=om7AdOno_kooR8R8oi>CTonRXZ;o[jn_okZj^_o1`L7oalO7
ol_;boo>c/kod=3@om7Ad@02om?Cd`?oe=CD0_oEeMD01_oFe]KoeMGEomKF
e_mOGeko;Rh^omCDe0;oeMGE02Coe]KFodI6A_mbLW;oCDe=o`L71oo7alOo
Lg=cobTY:Ol=3@go;bl_ojBTY?oEeMCoe=CDol30`?m8B4So30`<o`T92OlO
7aooe]KFomGEe?le=CGoJFUYomGEeOo5aLGo;2`/ohf=SOoFe]KoeMGDomCD
e?nRXZ;o6ATIokno_ol0003oa/K6omKFe_oEeM@2omCDe0;oeMGE013oe=CD
om?CdooCdm?odM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jfoj^[ZonMWIgo
TI6Aokno_ooAdM7ofm_K1OoVi^H03OoAdM7o_knoohR8R?nCTi?oXZ:Rojn_
[onj^[[o`L71olO7aoo;bl_oc/k>om3@d?oAdM400_oCdm<3omCDe0;oeMGE
00Koe]KFomGEeOoFe]KoGemNobh^;_oDe=@2omGEe@0NomKFe_m6ATKoLW9b
ode=COl71`OoalO7og=cLolY:BWo3@d=obl_;onTY:CoeMGDomCDe?o0`<3o
B4Q8o``<3?l92@Wo7alOomKFe_oEeMCo=CDeofUYJOoEeMGoaLG5ob`/;?n=
SHgoe]KFomGEe?nMWIgo8R8R0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE013oe=CDom?CdooCdm?odM7Aom3@d?o=cLgob/[:ol?3`onn_[ko
][Jfoj^[ZonMWIgoTI6Aokno_ooAdM7ofm_KoooVi^HRonKViP001Oo^k^h0
4_oMgMgocLg=oi2@T?n9RHWoUiNGojFUYOnb/[;o_knool_;booAdM7oeMGE
omOGeooIfMWof][Jom_KfooJf][ofm_KomcLg0Gofm_K00?oHF5Qoc0`<?oL
g=`01_oKfm/01OoHf=Sog=cLom_KfooKfm_ofMWI00Cofm_K00Cog=cLom_K
fooKfm_of=SH0ooKfm/00olf=SKoKFe]om_Kf`05om_Kf`05om[Jf_oGemOo
][Jfo`000?o7alL01?oKfm/04ooLg=cofm_Kom_KfooKfm_of][JomWIfOoH
f=Soe]KFom?Cdoo=cLgo`/;2okJf]_n/[:coWinOoi2@T?nFUYKocLg=omgM
gOoUiND01Oo^k^h04_oMgMgocLg=oi2@T?n9RHWoUiNGojFUYOnb/[;o_kno
ol_;booAdM7oeMGEomOGeooIfMWof][Jom_KfooJf][ofm_KomcLg0Gofm_K
00?oHF5Qoc0`<?oLg=`01_oKfm/01OoHf=Sog=cLom_KfooKfm_ofMWI00Co
fm_K00Cog=cLom_KfooKfm_of=SH0ooKfm/00olf=SKoKFe]om_Kf`05om_K
f`06om[Jf_oLg=cofm_Kom_KfolZ:R[oJFUY0ooKfm/04ooLg=cofm_Kom_K
fooKfm_of][JomWIfOoHf=Soe]KFom?Cdoo=cLgo`/;2okJf]_n/[:coWinO
oi2@T?nFUYKocLg=omgMgOoUiND01Oo^k^h04_oMgMgocLg=oi2@T?n9RHWo
UiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooIfMWof][Jom_KfooJ
f][ofm_KomcLg0Gofm_K00?oHF5Qoc0`<?oLg=`01_oKfm/01OoHf=Sog=cL
om_KfooKfm_ofMWI00Cofm_K00Cog=cLom_KfooKfm_of=SH0ooKfm/00olf
=SKoKFe]om_Kf`06om_Kf`05omcLg?oKfm_of][JoaLG5on7QhL00ooKfm/0
4ooLg=cofm_Kom_KfooKfm_of][JomWIfOoHf=Soe]KFom?Cdoo=cLgo`/;2
okJf]_n/[:coWinOoi2@T?nFUYKocLg=omgMgOoUiND01Oo^k^h04_oMgMgo
cLg=oi2@T?n9RHWoUiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooI
fMWof][Jom_KfooJf][ofm_KomcLg0Gofm_K00?oHF5Qoc0`<?oLg=`01_oK
fm/01OoHf=Sog=cLom_KfooKfm_ofMWI00Cofm_K00Cog=cLom_KfooKfm_o
f=SH0ooKfm/00olf=SKoKFe]om_Kf`06om_Kf`05omcLg?m_Kfoo>c/ko`00
0?o<c<`00ooKfm/04ooLg=cofm_Kom_KfooKfm_of][JomWIfOoHf=Soe]KF
om?Cdoo=cLgo`/;2okJf]_n/[:coWinOoi2@T?nFUYKocLg=omgMgOoUiND0
1Oo^k^h04_oMgMgocLg=oi2@T?n9RHWoUiNGojFUYOnb/[;o_knool_;booA
dM7oeMGEomOGeooIfMWof][Jom_KfooJf][ofm_KomcLg0Gofm_K00?oHF5Q
oc0`<?oLg=`01_oKfm/01OoHf=Sog=cLom_KfooKfm_ofMWI00Cofm_K00Co
g=cLom_KfooKfm_of=SH0ooKfm/00olf=SKoKFe]om_Kf`05om_Kf`03oj:R
X_lS8b?ofm_K00Kofm_K01?og=cLom_KfooKfm_ofm_Kom[Jf_oIfMWof=SH
omKFe_oCdm?ocLg=ol;2`_nf][Ko[:b/oinOWon@T93oUYJFolg=cOoMgMgo
iNGU0?ook^k^8_o^k^h000Gooooo00_ol_;bonGUiOnYZJWoNWYjohR8R?nF
UYKoZZZZolC4a?oEeMGofm_KomkNgP02on3Ph0?oh^;R00Goi>CTon?ShooS
hn?ohn?SofUYJ@02oeUIF@03obPX:?lC4a?oFEUI00;oFEUI00Godm?Con?S
hooShn?ohn?SonCTi007on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o>CTi
og5aLOoShn<01OoShn<01OoKfm_o4A4Aobl_;ol0003oc/k>00?ohn?S00Co
i>CTon?ShooShn?ohn?S0_oRh^803_oQhN7oh>3PomoOgooLg=coemOGolG5
aOn/[:coWYjNoi2@T?n2PX;o[Jf]onGUiOobl_;onOWi1Oooool02oobl_;o
iNGUojVYZOmjNW[oR8R8oiJFU_nZZZ[oa<C4omGEeOoKfm_og]kN00;oh>3P
0ooRh^801OoTi>Cohn?Son?ShooShn?oJFUY00;oFEUI00?o:2PXoa<C4omI
FET00_mIFET01OoCdm?ohn?Son?ShooShn?oi>CT00Oohn?S00?oi>CTon?S
hooShn<01OoShn<00oli>CWoLG5aon?Sh`05on?Sh`06oe1@D?m8B4SoRHV9
oeEEEOl51@Gob/[:0_oShn<01?oTi>Cohn?Son?ShooShn<2on;RhP0>on7Q
hOoPh>3ogmoOomcLg?oGemOoaLG5ojb/[?nNWYkoT92@oh:2P_n][JgoiNGU
oo;bl_oinOT5ooooo`0;oo;bl_oUiNGoZJVYogYjN_n8R8SoUYJFojZZZ_o4
a<CoeMGEom_KfooNg]h00_oPh>03on;RhP05onCTi?oShn?ohn?Son?ShomY
JFT00_mIFET00olX:2So4a<CoeUIF@02oeUIF@05om?CdooShn?ohn?Son?S
hooTi>@01ooShn<00ooTi>Cohn?Son?Sh`05on?Sh`03ocTi>OmaLG7ohn?S
00Gohn?S00KoPh>3of5QHOn=SHgoEEEEo``<3?oEeMD2on?Sh`04onCTi?oS
hn?ohn?Son?Sh`;oh^;R00kohN7Qon3Ph?oOgmoog=cLomOGeoo5aLGo[:b/
oijNW_n@T93oPX:2ojf][OoUiNGol_;booWin@Gooooo00_ol_;bonGUiOnY
ZJWoNWYjohR8R?nFUYKoZZZZolC4a?oEeMGofm_KomkNgP02on3Ph0?oh^;R
00Goi>CTon?ShooShn?ohn?SofUYJ@02oeUIF@03obPX:?lC4a?oFEUI00;o
FEUI00Godm?Con?ShooShn?ohn?SonCTi007on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?o>CTiog5aLOoShn<01OoShn<01_oTi>Cohn?Son7QhOlh>3So
0000om?Cd`;ohn?S00Coi>CTon?ShooShn?ohn?S0_oRh^803_oQhN7oh>3P
omoOgooLg=coemOGolG5aOn/[:coWYjNoi2@T?n2PX;o[Jf]onGUiOobl_;o
nOWi1Oooool02oobl_;oiNGUojVYZOmjNW[oR8R8oiJFU_nZZZ[oa<C4omGE
eOoKfm_og]kN00;oh>3P0ooRh^801OoTi>Cohn?Son?ShooShn?oJFUY00;o
FEUI00?o:2PXoa<C4omIFET00_mIFET01OoCdm?ohn?Son?ShooShn?oi>CT
00Oohn?S00?oi>CTon?ShooShn<01OoShn<00oli>CWoLG5aon?Sh`05on?S
h`03ojRXZ?l:2P[oA4A400;oA4A400CoU9BDon?ShooShn?oi>CT0ooShn<2
on;RhP0>on7QhOoPh>3ogmoOomcLg?oGemOoaLG5ojb/[?nNWYkoT92@oh:2
P_n][JgoiNGUoo;bl_oinOWoooooob;ooooo0005onk^kP0>onGUiOoMgMgo
`/;2og]kNomhN7SoQXJ6oinOWoo5aLGof=SHomgMgOoOgmoohN7Qon;Rh_oS
hn<3onCTi0?oiNGU00GoUIFEohV9ROn9RHWoRXZ:ohV9R@03ohZ:RP05om_K
fooTi>Coi>CTonGUiOoTi>@01?oUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGo>CTiog9bLP03onGUi@;oi>CT00KoiNGUonCTi?oO
gmoo/;2`ogIfM_oHf=P2onCTi004onGUiOoTi>CoiNGUonGUi@?oi>CT00ko
hn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4ol?3`ooM
gMgoiNGUon[ZjPGok^k^00koiNGUomgMgOo2`/;oNg]kogQhN?n6QXKoWinO
olG5aOoHf=SogMgMomoOgooQhN7oh^;Ron?Sh`?oi>CT0ooUiND01OnEUIGo
RHV9ohV9ROn:RX[oRHV900?oRXZ:00Gofm_KonCTi?oTi>CoiNGUonCTi004
onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOli>CWo
LW9b00?oiNGU0_oTi>@01_oUiNGodM7Aoi^KVomWIfOoRh^;om?Cd`;oi>CT
00CoiNGUonCTi?oUiNGoiNGU0ooTi>@03_oShn?ohN7Qon3Ph?oOgmoof][J
olK6a_nQXJ7oSHf=oh20P?n4Q8Co`l?3omgMgOoUiNGoj^[Z1Oo^k^h03_oU
iNGogMgMol;2`_mkNg_oN7QhohJ6Q_nOWiooaLG5omSHf?oMgMgogmoOon7Q
hOoRh^;ohn?S0ooTi>@3onGUi@05oiFEUOn9RHWoRHV9ohZ:R_n9RHT00on:
RXX01OoKfm_oi>CTonCTi?oUiNGoi>CT00CoiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUocTi>OmbLW800ooUiND2onCTi006onGU
iOnn_[koPH61of1PH?n;Rh_obLW90_oTi>@01?oUiNGoi>CTonGUiOoUiND3
onCTi00>on?ShooQhN7oh>3PomoOgooJf][oa/K6oj6QXOn=SHgoP820ohB4
Q?o3`l?ogMgMonGUiOoZj^X5onk^kP0>onGUiOoMgMgo`/;2og]kNomhN7So
QXJ6oinOWoo5aLGof=SHomgMgOoOgmoohN7Qon;Rh_oShn<3onCTi0?oiNGU
00GoUIFEohV9ROn9RHWoRXZ:ohV9R@03ohZ:RP05om_KfooTi>Coi>CTonGU
iOoTi>@01?oUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooU
iNGo>CTiog9bLP03onGUi@;oi>CT00[oiNGUonCTi?oUiNGoiNGUolk>c_n:
RX[og]kNonCTi?oUiNGoi>CT0_oUiND3onCTi00>on?ShooQhN7oh>3PomoO
gooJf][oa/K6oj6QXOn=SHgoP820ohB4Q?o3`l?ogMgMonGUiOoZj^X5onk^
kP0>onGUiOoMgMgo`/;2og]kNomhN7SoQXJ6oinOWoo5aLGof=SHomgMgOoO
gmoohN7Qon;Rh_oShn<3onCTi0?oiNGU00GoUIFEohV9ROn9RHWoRXZ:ohV9
R@03ohZ:RP05om_KfooTi>Coi>CTonGUiOoTi>@01?oUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo>CTiog9bLP03onGUi@;oi>CT
00?oiNGUolc<c?n:RXX00on:RXX01?nh^;Soi>CTonGUiOoTi>@2onGUi@?o
i>CT00kohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4
ol?3`ooMgMgoiNGUon[Zj_ook^k^8_o^k^h000Goi^KV00_oh>3Pom_KfooB
d];oVi^KofEUIOmcLg?oSHf=ok^k^ooDe=Cof][JomgMg@02omoOg`03on3P
h?oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00Goh^;Ron7QhOoQhN7o
gMgMomoOg`03on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQ
hN401_oQhN403_oPh>3ogmoOomgMgOoLg=coeMGEokVi^On>SXkoNg]kofi^
K_nNWYkod];Bom_KfooPh>3oi>CT1OoVi^H02ooPh>3ofm_Kom;Bd_nKVi_o
IFEUog=cLon=SHgo^k^komCDe?oJf][ogMgM00;ogmoO00?oh>3Pon7QhOoQ
hN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00Go
hN7Q00?oh^;Ron7QhOoQhN401OoQhN401OoRh^;ohN7Qon7QhOoMgMgogmoO
00?ohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@06on7Q
h@0>on3Ph?oOgmoogMgMomcLg?oEeMGo^KViohj>S_mkNg_oKVi^oijNW_oB
d];ofm_Kon3Ph?oTi>@5onKViP0;on3Ph?oKfm_od];Boi^KVomUIFGoLg=c
ohf=SOnk^k_oe=CDom[Jf_oMgMd00_oOgml00ooPh>3ohN7Qon7Qh@05on7Q
h@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@05on7Qh@05on;Rh_oQhN7ohN7QomgMgOoOgml00ooQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00KohN7Q00koh>3P
omoOgooMgMgog=cLomGEeOni^KWoSXj>og]kNom^KVkoWYjNom;Bd_oKfm_o
h>3PonCTi0Goi^KV00_oh>3Pom_KfooBd];oVi^KofEUIOmcLg?oSHf=ok^k
^ooDe=Cof][JomgMg@02omoOg`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00Goh^;Ron7QhOoQhN7ogMgMomoOg`03on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401_oQhN403_oPh>3ogmoOomgM
gOoLg=coeMGEokVi^On>SXkoNg]kofi^K_nNWYkod];Bom_KfooPh>3oi>CT
1OoVi^H02ooPh>3ofm_Kom;Bd_nKVi_oIFEUog=cLon=SHgo^k^komCDe?oJ
f][ogMgM00;ogmoO00?oh>3Pon7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN401OoRh^;ohN7Qon7QhOoMgMgogmoO00?ohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@06on7Qh@0>on3Ph?oOgmoogMgMomcLg?oE
eMGo^KViohj>S_mkNg_oKVi^oijNW_oBd];ofm_Kon3Ph?oTi>CoonKViR;o
i^KV0005onk^kP0<on_[jooXj>Soh^;RomOGeon=SHgoHV9RogIfM_nTY:Co
alO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg00Dom_K
fooLg=cog=cLom_KfooLg=cofm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGoW9bL
ogEeMOmWIfOoT92@omOGeooRh^;oj>SXon_[joo]kNd5onk^kP0<on_[jooX
j>Soh^;RomOGeon=SHgoHV9RogIfM_nTY:CoalO7om;Bd_oEeMGof=SH0_oJ
f]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcL
g005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoL
g=`00ooKfm_og=cLomcLg005omcLg00Dom_KfooLg=cog=cLom_KfooLg=co
fm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGoW9bLogEeMOmWIfOoT92@omOGeooR
h^;oj>SXon_[joo]kNd5onk^kP0<on_[jooXj>Soh^;RomOGeon=SHgoHV9R
ogIfM_nTY:CoalO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg00Dom_KfooLg=cog=cLom_KfooLg=cofm_Kom[Jf_oIfMWof=SHom?C
doo5aLGoW9bLogEeMOmWIfOoT92@omOGeooRh^;oj>SXon_[joo]kNd5onk^
kP0<on_[jooXj>Soh^;RomOGeon=SHgoHV9RogIfM_nTY:CoalO7om;Bd_oE
eMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg00Dom_KfooLg=cog=cL
om_KfooLg=cofm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGoW9bLogEeMOmWIfOo
T92@omOGeooRh^;oj>SXon_[joo]kNd5onk^kP0<on_[jooXj>Soh^;RomOG
eon=SHgoHV9RogIfM_nTY:CoalO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oo
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg00Dom_KfooLg=cog=cLom_KfooLg=cofm_Kom[Jf_oI
fMWof=SHom?Cdoo5aLGoW9bLogEeMOmWIfOoT92@omOGeooRh^;oj>SXon_[
joo]kNgoonk^kR;ok^k^0005ooooo`0>ookno_okno_on?Shoo;bl_oNg]ko
TI6AoeYJF_mkNg_oXj>Sokbl_?o6a/Kobl_;olg=cOo?cll2om7Ad@God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00?od];B0_oAdM403Oo@d=3oclo?
olc<c?o8b<So^k^koibLW?mbLW;oFe]KoiBDU?oNg]kol_;booShn?okno/0
0_ono_h5ooooo`0>ookno_okno_on?Shoo;bl_oNg]koTI6AoeYJF_mkNg_o
Xj>Sokbl_?o6a/Kobl_;olg=cOo?cll2om7Ad@God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03
om7AdOoBd];odM7A00?od];B0_oAdM403Oo@d=3oclo?olc<c?o8b<So^k^k
oibLW?mbLW;oFe]KoiBDU?oNg]kol_;booShn?okno/00_ono_h5ooooo`0>
ookno_okno_on?Shoo;bl_oNg]koTI6AoeYJF_mkNg_oXj>Sokbl_?o6a/Ko
bl_;olg=cOo?cll2om7Ad@God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00?od];B0_oAdM403Oo@d=3oclo?olc<c?o8b<So^k^koibLW?mbLW;oFe]K
oiBDU?oNg]kol_;booShn?okno/00_ono_h5ooooo`0>ookno_okno_on?Sh
oo;bl_oNg]koTI6AoeYJF_mkNg_oXj>Sokbl_?o6a/Kobl_;olg=cOo?cll2
om7Ad@God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05
om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]80
0ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00?od];B0_oAdM40
3Oo@d=3oclo?olc<c?o8b<So^k^koibLW?mbLW;oFe]KoiBDU?oNg]kol_;b
ooShn?okno/00_ono_h5ooooo`0>ookno_okno_on?Shoo;bl_oNg]koTI6A
oeYJF_mkNg_oXj>Sokbl_?o6a/Kobl_;olg=cOo?cll2om7Ad@God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoB
d];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7A
d@05om;BdP03om7AdOoBd];odM7A00?od];B0_oAdM403Oo@d=3oclo?olc<
c?o8b<So^k^koibLW?mbLW;oFe]KoiBDU?oNg]kol_;booShn?okno/00_on
o_koooooob;ooooo0005onk^kP;okNg]00koj^[ZonSXj?oRh^;og=cLoibL
W?m]KFgoJ6QXoh>3PonGUiOoXj>Sojb/[?n_[joo/K6aok:b/P;o];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd01?o]KFeokJf]?nd];Co];BdokJf]_nc/k?o/[:bok>c
/on_[jooZZZZoibLW?n2PX;oHV9Rofi^K_nOWioog=cLon;Rh_oXj>Soj^[Z
00;okNg]1_o^k^h2ong]k@0>on[Zj_oXj>Soh^;RomcLg?nLW9coKFe]ofQX
J?n3Ph?oUiNGoj>SXon/[:co[jn_ok6a/Onb/[82okBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]00CokFe]Onf][Co];BdokBd]?nf][Ko/k>cok:b/_nc/k?o[jn_ojZZ
Z_nLW9coPX:2of9RH_m^KVkoWinOomcLg?oRh^;oj>SXon[ZjP02ong]k@Ko
k^k^0_o]kNd03_oZj^[oj>SXon;Rh_oLg=coW9bLofe]KOmXJ6SoPh>3oiNG
UonSXj?o[:b/ojn_[ona/K7o/[:b0_nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@04one
]KGo][JdokBd]?nd];Co][Jfok>c/onb/[;o/k>cojn_[onZZZ[oW9bLoh:2
P_mRHV;oKVi^oinOWooLg=coh^;RonSXj?oZj^X00_o]kNd6onk^kP;okNg]
00koj^[ZonSXj?oRh^;og=cLoibLW?m]KFgoJ6QXoh>3PonGUiOoXj>Sojb/
[?n_[joo/K6aok:b/P;o];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd01?o]KFeokJf]?nd
];Co];BdokJf]_nc/k?o/[:bok>c/on_[jooZZZZoibLW?n2PX;oHV9Rofi^
K_nOWioog=cLon;Rh_oXj>Soj^[Z00;okNg]1_o^k^h2ong]k@0>on[Zj_oX
j>Soh^;RomcLg?nLW9coKFe]ofQXJ?n3Ph?oUiNGoj>SXon/[:co[jn_ok6a
/Onb/[82okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]00CokFe]Onf][Co];BdokBd]?nf
][Ko/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9RH_m^KVkoWinOomcL
g?oRh^;oj>SXon[ZjP02ong]kOook^k^8oo^k^h000Koi^KV0_oUiND03ooS
hn?oh>3PomgMgOoJf][oa<C4oiZJV_mjNW[oJFUYof=SHomYJFWoLW9bogAd
M?miNGWoO7alog]kN`02ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00OoO7al
og]kNomlO7coOGelogalO?mkNg_oOGem00;oNWYj00_oMgMgogAdM?m]KFgo
Kfm_ogalO?nJVY[oaLG5om[Jf_oMgMgoh>3Pon?Sh`02onGUi@Soi^KV0_oU
iND03ooShn?oh>3PomgMgOoJf][oa<C4oiZJV_mjNW[oJFUYof=SHomYJFWo
LW9bogAdM?miNGWoO7alog]kN`02ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00OoO7alog]kNomlO7coOGelogalO?mkNg_oOGem00;oNWYj00_oMgMgogAd
M?m]KFgoKfm_ogalO?nJVY[oaLG5om[Jf_oMgMgoh>3Pon?Sh`02onGUi@So
i^KV0_oUiND03ooShn?oh>3PomgMgOoJf][oa<C4oiZJV_mjNW[oJFUYof=S
HomYJFWoLW9bogAdM?miNGWoO7alog]kN`02ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00OoO7alog]kNomlO7coOGelogalO?mkNg_oOGem00;oNWYj00_o
MgMgogAdM?m]KFgoKfm_ogalO?nJVY[oaLG5om[Jf_oMgMgoh>3Pon?Sh`02
onGUi@Soi^KV0_oUiND03ooShn?oh>3PomgMgOoJf][oa<C4oiZJV_mjNW[o
JFUYof=SHomYJFWoLW9bogAdM?miNGWoO7alog]kN`02ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00OoO7alog]kNomlO7coOGelogalO?mkNg_oOGem00;o
NWYj00_oMgMgogAdM?m]KFgoKfm_ogalO?nJVY[oaLG5om[Jf_oMgMgoh>3P
on?Sh`02onGUi@Soi^KV0_oUiND03ooShn?oh>3PomgMgOoJf][oa<C4oiZJ
V_mjNW[oJFUYof=SHomYJFWoLW9bogAdM?miNGWoO7alog]kN`02ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00OoO7alog]kNomlO7coOGelogalO?mkNg_o
OGem00;oNWYj00_oMgMgogAdM?m]KFgoKfm_ogalO?nJVY[oaLG5om[Jf_oM
gMgoh>3Pon?Sh`02onGUiOooi^KV9?oVi^H000Ook^k^0_o]kNd01?o/k>co
j^[ZonSXj?oUiND2on;RhP03on3Ph?oOgmoog]kN03WogMgM00?og]kNomoO
gooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/k>`2ong]k@[ok^k^0_o]kNd0
1?o/k>coj^[ZonSXj?oUiND2on;RhP03on3Ph?oOgmoog]kN03WogMgM00?o
g]kNomoOgooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/k>`2ong]k@[ok^k^
0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;RhP03on3Ph?oOgmoog]kN03Wo
gMgM00?og]kNomoOgooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/k>`2ong]
k@[ok^k^0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;RhP03on3Ph?oOgmoo
g]kN03WogMgM00?og]kNomoOgooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/
k>`2ong]k@[ok^k^0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;RhP03on3P
h?oOgmoog]kN03WogMgM00?og]kNomoOgooPh>000_oRh^801?oUiNGoj>SX
on[Zj_o/k>`2ong]kOook^k^9Oo^k^h000Wooooo0_ono_h00oomoOgono_k
oo_kn`02ooWin@;on?Sh>OogmoL2ooShn0;onOWi0_okno/00oomoOgoo_kn
ooknoP0>ooooo`;oo_kn00?ooOgmoo_knookno/00_oinOT2ooShn3WomoOg
0_ohn?P2ooWin@;ono_k00?ooOgmookno_ono_h03_ooool2ooknoP03oogm
oOokno_ono_k00;onOWi0_ohn?PiooOgm`;on?Sh0_oinOT2oo_kn`03oogm
oOono_koo_kn00kooooo0_ono_h00oomoOgono_koo_kn`02ooWin@;on?Sh
>OogmoL2ooShn0;onOWi0_okno/00oomoOgoo_knooknoP0>ooooo`;oo_kn
00?ooOgmoo_knookno/00_oinOT2ooShn3WomoOg0_ohn?P2ooWin@;ono_k
00?ooOgmookno_ono_h0oooooolWooooo`00ooo^k^koonk^k^3ok^k^003o
onKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00ooooooooooooon3o
oooo003oonk^k_ook^k^h?o^k^h00?ooi^KVoooVi^KPonKViP00ooo^k^ko
onk^k^3ok^k^003oooooooooooooh?ooool00?ook^k^ooo^k^kPonk^kP00
oooVi^KoonKVi^3oi^KV003oogmoOhKoOgmo1omnOWkoogmoOe?oOgmo0000
1?o[jn_oi^KVon;Rh_oNg]h3omgMg@3oomcLg?oNg]kog]kNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgM0017omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oMgMd00_oLg=`0?OoKfm_ogMgMomcL
g?oNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kog=cMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomgMgOoKfm_of][JomOGeooHf=SoemOG
om[Jf_oKfm`00_oMgMd0oooNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
gP00AOoMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMg@03omkNgP03omgMgOoNg]kog]kN00?ogMgM0OoQhN41onOW
i`7oj^[Z00000oo/k>coi^KVon3Ph003omWIf@08omSHf?oIfMWofMWIomWI
fOoHf=Soe]KFom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI
00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWI
f@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SHoooI
fMT;omWIf@;of=SH00Koe]KFom?CdooCdm?oe=CDomOGeooHf=P2omWIf@03
omSHf?oIfMWofMWI00;of=SH2OoIfMT00ooHf=SofMWIomWIf@02omSHf003
omWIfOoHf=SoemOG00;of=SH5ooIfMT01?oHf=Soe]KFom;Bd_o?cll2olg=
c@04olo?cooCdm?oemOGomSHf?oofMWIAOoIfMT00ooHf=SofMWIomWIf@06
omWIf@7og]kN0OoVi^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoP
h>3oh^;R00;ohN7Q00gog]kNomcLg?oCdm?oalO7ok^k^onb/[;o[Zj^ok:b
/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?oalO7
ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00go
gmoOom_KfooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooK
fm_ogmoO0?oohN7Q2_oQhN402OoPh>3ogmoOom_KfooFe]Koe=CDomKFe_oJ
f][og]kNon3Ph006omoOg`?oh>3P00?ogmoOon3Ph?oPh>000_oPh>08omoO
g`;og]kN0_oOgml3on3Ph0;ogmoO0_oPh>02omoOg`goh>3P00GogmoOomgM
gOoIfMWoeMGEom?Cd`02om;BdP03omKFe_oLg=coh>3P0?oohN7QAooQhN40
0ooRh^;ohN7Qon;RhP04on7Qh@7oi>CT0OoYjNT1ong]k@0000?ol?3`ono_
kooalO400_o`l?02ono_k`3ooo3`l?o^k^koj>SXom_Kfoo1`L7oY:BTohb<
S?mkNg_oMgMgog]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_
oo7alOo_knoolO7_ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_o
Ng]kogMgMomkNg_oS8b<ojBTY?o2`/;of][Jon[Zj?o]kNgolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ong]kOoZj^[of][Jol;2`_nTY:CoS8b<og]k
NomgMgKoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7a001>ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo3`k_o]kNgok>c/onGUiOoRh^;ogmoOonGUiOoYjNWo
kNg[0_oXj>P01_oVi^KojNWYonOWioo[jn_ok>c/onk^k0?oj^[Z00Wokno_
onk^k_o^k^koj>SXonSXi_oVi^KojNWYonOWiooZj^X00_oYjNT03OoUiNGo
inOUonOWioo[jn_ok>c/ono_koo[jn_oj^[ZonWYjOo^k^cok>c/on_[jooX
j>P00_o]kNd05?o^k^koj^[Zonc/j_o/k>cok^k^on[Zj_o/k>cokNg]onk^
k_oZj^[ok>cZonc/k?o^k^ko[Jf]ogMgMomIFEWoKfm_okJf]_oQhN3oinOW
0_o_knl0oooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aonk^k_oalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7al@00C?o_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aoo3`
l?o_knool?3`ono_koo`l?3okno_oo3`l?o_knl4oo3`l00000?ol_;bonk^
k_oWinL01?oUiND04?oTi>CogmoOom7AdOna/K7oRXZ:ofEUIOmADE7oADE5
od92@_m5ADGoDE5AofIVI_n:RXWo/K6aom7AdOoNg]h2onCTi003onGUiOoT
i>CoiNGT00;oi>CT00oog]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92
@_m5ADGoDE5AofIVI_n:RX[o/K6aom7Ad?oNg]h00_oTi>@0oooUiNGoi>CT
onGUiOoTi>Coi>CSomkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;o
ADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM7og]kNonCThooTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUi@009ooTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oShn?oa/K6obPX:?m5ADGoShn?om;Bd_oKfm_og=cKomKF
eP03omGEe@0<omCDe?oJf][ogmoOomoOg_oIfMWoeMGEomSHf?oOgmoohN7Q
omgMgOoFe]KoeMGD0_oEeMD02ooDe=CofMWIom[Jf_oHf=SoeMGEomKFeOoF
e]KofMWIomgMgOoPh>3ofm_K00;oe]KF00WogMgLomcLg?oHf=SoeMGEomcL
g?oPh>3ogmoOom[Jf_oKfmX00_oMgMd0oooIfMWog=cLomoOgooPh>3ofm_K
om[JfOoMgMgoh>3Pog=cLomXJ6SoSHf=oeADE?l820SoXj>Rom_KfooShn?o
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUon?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGohn?SonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi000E_oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT1?oU
iND01_oTi>CoiNGUonGUiOoUiNGoj>SXonc/k07ol_;b00000oodm?CokNg]
onOWi`03on3Ph00BomoOgooNg]kod];BokBd]?n7QhOoFe]Kofdk=OnNCT;o
cFmOonV3Koo=KeooWTi3ofdk=_mLG5coQhN7okBd]?oBd];og]kN1OoPh>00
4OoNg]kod];BokBd]?n7QhOoG5aLofeP;?nNURkocLdoonWYCOo=cCooWYX_
ofeS;OmLG5coQhN7okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];Co
QhN7oeaLG?m7IbkoJ9hcoi7=AonZjEGoTLe7ofZN=?m9JRooG5aLohN7Qond
];Cod];BomkNgP3oon3Ph0Woh>3P00KogmoOolo?conIVIWoTY:BoaTI6On<
S8`2omGEe@0Oolo?coo2`/;oc/k>olk>c_o5aLGob/[:om[Jf_oHf=Sod=3@
ol_;boo?cloof=SHom[Jf_oEeMGoclo?ol71`Oo@d=3oc/k>olC4a?o;bl_o
f=SHomOGeonn_[ko^k^kom7AdOo@d=3oeMGEomSHf?oCdm?oc<c<olk>cP02
omGEe@05olk>c_o<c<codm?Com[Jf_oHf=P00_oBd]801?oHf=SoemOGom7A
dOoCdm<2omWIf@06om?CdooAdM7oemOGomSHf?oAdM7od=3@0_oAdM401?m6
ATKo@D51omOGeooNg]i1on3Ph003omoOgooPh>3oh>3P0?ooh>3P0OoPh>00
0ooOgmooh>3PomoOg`02omoOg`?oh>3P00?ohN7QonOWioo/k>`00Oodm?@0
0003ooKfm_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgoWinOof]OGon?
=RkokG5QooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=
cOoRh^;oinOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOofiVGonCLR;okM54
ooWcM?omoHgooOfEoogmS_oin7KokMM7oi=c8_m^IeooWinOolg=cOoRh^;o
inOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOof1XGom;O2?oT^5;okgiNoo@
oI;of?fKomCmUOo0nGkoV>Q=odf09?mPJEooWinOolg=cOoRh^;oinOW0?oo
j>SX2_oXj>P01?oVi^KohN7QoeeMGOm=CDd2omgMg@0Ooe1@D?l71`Oo5ADE
ohB4Q?lF5QKo@d=3on;Rh_oMgMgoW9bLo`000?n?ShoogMgMon7QhOoKfm_o
@410o`P82?lI6AWoR8R8o`/;2omHF5So]kNgo``<3?l71`Oo8b<SobLW9omm
OGgof][JomgMgOoDe=Co2`/;oeUIF@02omWIf@03oeeMGOl;2`_odm?C00;o
gmoO00KoFUYJodi>C_oNg]kog]kNob<S8on4Q8@2on7Qh@0<ogYjN_l^;Rko
gMgMomgMgOo2`/;oD51@oc<c<om^KVkoPh>3ob4Q8OoNg]koi^KVoooXj>Q>
onSXj07ok>c/0Oobl_81ooKfmP0001WomoOgooShn?ohn?Son?ShooOgmooh
n?SomoOgonk^k_o>c/koT92@ohD_:ooYI5KonY:7oojVVoon/JGookR[oojc
Y_onZ9coniB9oniXFOn9<B_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOg
onk^k_o>c/koT92@oiUY:oo`_Cgonn1^ookdP_onoX[ooonBooknS?onn8?o
nnE`oo32?_nIJR_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>
c/koT92@od9c:on4cT?o[Nmcol;nR?o>oY3oe_nGom3nT_o6oXWo/_EdohSC
@om4MB_oT92@olk>c_o^k^komoOg0?oon?Sh2_ohn?P09Oofm_KolO7aoh61
POlO7aookNg]olK6a_l0003o`l?3om?CdomLG5co20P8on[Zj_o`l?3oj^[Z
oe9BD_lD51Co?CdmonWYjOo`l?3o[jn_o`L71ooBd];ocLg=odi>C_lK6a_o
k^k^om_Kfon^[Zkoj>SXonc/k?n^[Zko0000okBd]?o/k>co/;2`o`/;2olJ
6QX00_oTi>@02olS8b?o3Ph>ojBTY?o]kNgok^k^of1PH?mDE5Cok^k^ong]
kOlV9RKoSHf=00;ol?3`00coPX:2oc4a<Oo/k>coj^[Zod=3@ol_;booW9bL
og=cLolZ:R[o6QXJonk^k_ofm_HjooShn003ooOgmoohn?Son?Sh00Gon?Sh
00?omoOgooShn?ohn?P0<_ohn?P00oogmoOon?ShooShn03<ooShn003ooOg
moohn?Son?Sh00;on?Sh00ComoOgooWinOogmoOom_Kf0Oohn?P00003oo[j
n_oemOGok^k^00;ok>c/0?oojn_[onWYjOoOgmoo^KViogUBD_no<RCoigAY
oof9O_ooV8cooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<TogUBD_nj^[[o
gmoOon[Zj_o[jn_ok>c/on_[k?oZj^[ogmoOokZj^_n8IE;ohY4LooW3D?om
fV?oonYbookcO_oonX;oo_Ioooo/LoongVCon/MAon:B7?n9IU?o^[ZjomoO
gooZj^[ojn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S7?nAdUGoY^MZ
okSiN_o0oX;oaon9ol?nQ?nioG_oYna/oiCFEomBYQcoDVeBokZj^_oOgmoo
j^[Zon_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jn`007Cok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[jooZj^[oi>CTogYjN_lL
71coh^;Rol_;c?l30`?oWinOomoOgonDU9Co4a<Con3Ph?oQhN7od=3@o`H6
1_nQXJ7o2@T9okjn__oRh^;o^KVio`820_na/K;og]kNoh20P?lY:BWoh^;R
onSXj?oTi>CogmoOom[JfooDe=Co20P8ohJ6Q_oOgmooJVYZodU9BOle=CGo
[:b]okjn__l71`OoN7QhoeEEE@;ogmoO00KoFe]Kodm?D?oRh^;oh>3Pob@T
9?n4Q8@2on3Ph03oog]kNol_;boohN7QomCDe?l51@GoYjNWonCTi?oRh^;o
OgmooaDE5_oRh^;ojNWYonc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/001@
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>`7on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT00003oo_k
nooclo?okNg]00;oiNGU0?ooi^KVon?ShooIfMWo/[:bogT^;_o8@SCohfYL
oo=iK?omR7cooYN:oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;o
f=SHonCTi?oUiNGoi^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^lA?on
c5?ooMQRookSL_onjGGoo^IcookKIOomc5?onl55onjN:onIERko/[:bomSH
f?oTi>CoiNGUonKVi_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on7bTSoUmaI
ojGUJOnblgOo^?IkokCeNOnWjV_oV=aIohW?BomS[R_o;V<^ok:b/_oHf=Wo
i>CTonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNH005Goi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoTi>Cog]kNogMgMolK
6a_og=cLon3PhOnNWYko;Rh^ob/[:olb<S;o4Q8B00;ofm_K02GoQ8B4ob4Q
8OoOgmooDe=CofMWIooKfm_ogMgMoi2@T?lY:B[o;bl_ob`/;?lX:2SogMgM
omoOgooHf=Sodm?Colo?d?mKFe_o0000okjn__oIfMWo:2PXohJ6Q_mhN7So
J6QXoh:2P_ll?3co`l?3o`l?3ooEeMGofMWIoeUIFOm>CTkogMgMomcLg?lS
8b?oPH6100;oe]KF08OoMgMgobh^;_oMgMgoXZ:Ro`000?o6a/KofMWIomSH
f?n>SXko5ADEomgMgOoShn?oi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^H00_oUiND0aooUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiND00_oVi^H00ooUiNGoi^KVonKViP03onKViP03onGUiOo]kNgo
lo?c007ono_k00000oolo?con?Shoo7al@03onk^kP0Con_[jooQhN7o_;bl
ogXG5oo3?c;odUE8onAXF_o_Mfcom8=iooR7O?oeQ7[olgU]onEYFooIF4[o
a3lbog`G5onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;blojE75ooV
Uc;omJ``oofl@OombE?ooM1Poo_CIOomdV3oo/eDoofm@_oj[c;ojI/bojE6
5onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;bloaMI5omOZ3;oM[dg
ohK=AonFeU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg_cOoGj/boaMI5onl_;co
hN7Qonc/k03oonk^kP[ok^k^02kok>c/onOWiomkNg_o71`LonCTi?oYjNWo
i^KVon7QhOoNg]koSHf=oa@D5?oVi^Koi>CTocDe=OmiNGWojn_[ok:b/_lE
5AGogmoOonKVi_oTi>CohN7QomgMgOmjNW[o:BTYonSXj?oUiNGogMgMok6a
/OlV9RKo2`/;oi^KVooYjNWoc<c<o`000?o>c/ko`l?3obDU9Om;Bd_oO7al
onSXj?la<C7oYJFUonCTi?mMGEgoDE5A0_oWinL02_lU9BGoJFUYomoOgooO
gmooMgMgoc4a<OoYjNWo`L71o`000?nWYjL2omoOg`04oi>CTolF5QKoinOW
onc/k3cok^k^00?okNg]onk^k_o^k^h00_o^k^h00oo]kNgok^k^onk^kP3o
onk^kPWok^k^00?okNg]oo;bl_ohn?P00Oolo?`000?ooOgm01Koo?cloogm
oOomoOgoo?cloo?clooAdM7oJ0L7okPd=?o7?c?odU13omYREOoSKV;oi79T
onA_H_oLI5Oode53ola1=?ni=3CoJ`L7om;Bd_oclo?oo?cl0oomoOd04ool
o?colo?com;Bd_nN:`OofXXdon^K6OoeZ2Won;@oooVmB_oh_dgon[m:ooVh
?oofZR[okihIom^;=?nR;@Ood];Boo?cloolo?`00oomoOd04oolo?colo?c
om;Bd_l7@0OoCIXdoen[8?m`^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^Boo
HZhPodjK=?l7@POod];Boo?cloolo?`0ooomoOd:oogmo@0Soo_knoogmoOo
Q8B4oahN7_oclo?onOWiok>c/oo@d=3olo?cofQXJ?m7AdOonOWiomCDe?l0
003ogMgMooclo?okno_o9bLWojRXZ?oinOWoZj^[omGEeOoalO7oE5ADoeiN
G_oinOWom?CdoiBDU?l51@Go@410om7AdOogmoOon?ShoiNGUol[:b/00_oj
n_X06olT92Co1`L7olS8b?okno_oQHF5of=SHoogmoOoHf=SoeMGEoohn?So
nOWiobLW9olE5AGoPh>3omOGeom2@T;oHf=Soo_knoojn_[o=3@dodU9BOoK
fm_oiNGUodm?ColG5aOon_[jooclo03ooogmoD_ooOgm00?oo?cloogmoOol
o?`00oomoOd0000joogmoOojn_[olo?conk^k_o`l?3okno_onk^k_oYjNWo
dm?CoeXL7?nR=3Co]2PMol4i;?o7BCcoceI:om1GBoo@Ed[obTXnol<k;_nf
:1goXS@doe`M7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`koo^k^koj^[Zom?C
don<9Agob74domV47OoTU1GoiidTonjX<oo`ZSCokjXconbP9OoWUaGog8PM
olQa=?n<9Agodm?Con[Zj_o^k^kol?3`ono_koo`l?3ok^k^on[ZjOoCdm?o
7CPMocB2=?m7UAgoFZDKofV]:P;oM;Ph0?ooMKThof^a:omKYacoB9XMocB2
=?lM>1godm?Con[ZjOo^k^kol?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knl003[ol?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
onk^k_o[jn_oOGemoa`L7?oWinOok^k]ohR8R?l`<33o3Ph>oc4a<On`/;3o
kno_ohB4Q?m=CDgok^k^ono_koo^k^koRXZ:oeUIFOo_knooN7Qhob`/:ol>
3Pko>3Phokjn__o^k^kohn?So`h>3_mYJFWoh>3Oon;Rh_oVi^Koj^[Zof5Q
HOmfMWKokno_onk^k_mgMgKo9RHV0_o^k^h05_o=cLgo;2`/on_[jom/K6co
Hf=Ron_[joo^k^ko>SXjoiBDU?mRHV;o3Ph>oc@d=?o4a<Cok^k^ono_kooA
dM7o?3`lo`X:2_lW9bOoK6a/ob`/;?o^k^h2ono_k`3ooo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`onk^k_o`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3ok^k^oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`0015ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_00;ol?3`1_o_knl1oo?cl`7o
n?Sh0Oono_h00003ookno_ogmoOol?3`00;ojNWY01?oj>SXonWYjOoVi^Ko
fm_Kof=;Bon1<S;oYS@dokHd;Oo2CD7o`eA9olAEB_o3E4Wo`Te1okHd;OnU
=CGoPC8bof=;BooKfm_oinOW00GojNWY017oinOWom_Kfon9Bd_o[d/boleg
=OoFRbgoh9`^on2P<_oQX3Coh:0bomnJ;_oFRbgobWDeojm;<_n9Bd_ofm_K
onOWi`05onWYj@0AonOWiooKfm_oBd];oc9P<_ljRCGoDi/]of^[;om`[CSo
Kjhjog2]>?mZZRooDi/]ocV8=OlbH3;oBd];om_KfooWinL0oooYjNT;onWY
j@06onSXj?oVi^KoNg]koa`L7?oTi>Coj>SX0_oYjNT00ooWinOojNWYonWY
j@0;onWYj@0<onOWiooYjNWojNWYonSXj?oHf=So2PX:ojj^[_oLg=cog]kN
on3Ph?oUiNGoj>SX2?oYjNT01_oXj>Soi^KVon?ShooShn?oi^KVonSXj0?o
jNWY00?oj>SXonWYjOoYjNT01?oYjNT00ooWinOojNWYonWYj@1jonWYj@03
onSXj?oYjNWojNWY00?ojNWY00?oj>SXonWYjOoYjNT0a_oYjNT00ooXj>So
jNWYonWYj@04onWYj@7ol?3`0OogmoL1ooknoP0000Coo_knoo[jn_odm?Co
kno_0oo`l?004Oo_knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZN
W?oIW9coe9FEok]cLonEE5CoCb<SoiFDU?oZj^[okno_00Gol?3`017okno_
on[Zj_nYU9CoPB<SokYZE?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o
^fYDoh4S8onZU9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oU9BDob<Z8omD
NUCoLjEcoik6UOn/cYco[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Z
j_o_knl0ooo`l?0;oo3`l0;okno_00CoP820oadM7Oo^k^kokno_1Oo`l?00
0oo_knool?3`oo3`l00;oo3`l0;okno_00OoI6ATobTY:On1PH7oHf=Soc/k
>oo^k^kokno_00Sol?3`00Kokno_onk^k_mcLg?oJFUYonk^k_o_knm;oo3`
l0;okno_ooo`l?0?oo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn00001?o]
ko;oooooooooooono_h2ooooo`;oo_kn0?oooOgmooOgmom^KVkoFSlook6@
T?oNbLWol>CToo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?cooooo
ookno_ooooooo_knooooo_ono_koooooooclo?ohn?SoSFe]ohXo?oo9TI3o
jM39ooCYi?ofjnKom>WTonW@bOo9TI3oRCloohe]KOohn?Ooo?clooooooon
o_koooooookno_ooooooo_knooooo_olo?con?Shofe]KOlo?cooT9f@olWE
bOoTk>Coi^kVonC/i?o9eLWoT9f@oclo?om]KFgon?Shooclo?ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_h004Ooooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooo`02ooknoP0Holo?conVYZKo
oOgmooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo0_on
o_h03_o0`<3oLG5aoh20P?n`/;3ooOgmooooooono_koooooookno_ooooko
o_knooooooono_kooooo0_ono_h0ooo1`L7o_KfloogmoOooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooooknoP00G?ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooooooo_kn0_ooool00oono_koooooooooo`03ooooo`7o
n_[k00001?o4c=?oo_knoo[jn_oclo<5oo7al@0=ono_kooFe]KoJf][od<m
?OnKS8coa[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7al@0=
ono_kooGe]KoPf][og@m?OneS8coeKZjon7<c?oF^[[o]Xb<og8m?On1Jf_o
emKFono_k`09oo7al@0=ono_kooFe]KoJf][ocdm?On<S8co^[Zjolc=c?nj
^[[oS8b<ocdm?Om[Jf_oe]KFono_k`3ooo7alAKolO7a00?ol?3`oo7alOoa
lO404OoalO400oo`l?3olO7aoo7al@2Moo7al@03oo3`l?oalO7olO7a0<Co
lO7a00Col?3`oo7alOoalO7ol?3`1?oalO400oodm?Con_[jooknoP01on_^
k`0001GoRYRSoogmoOohn?Sol?3`on_[jooZj^[ojNWYon[Zj_oYjNWoj^[Z
onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT0
2ooZj^X02ooYjNWoj>SXoj2KVomZFEWo@bHVobd92Om29RKoJEUIoj2KVooX
j>SojNWY00_oj^[Z00_ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUI
FOnKVi_oj>SXonWYj@3oon[ZjR[oj^[Z00?ojNWYon[Zj_oZj^X0W?oZj^X0
0ooYjNWoj^[Zon[ZjP3=on[ZjP04on_[joo`l?3on?Shoogmo@7ocm;F0000
1?m1D5ko_<K=oo[jn_oclo<8oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`
l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`l?3ooo7alOoolO7aV?oa
lO400oo`l?3olO7aoo7al@02oo7al@03ooGemOojn_[ojN_]007oVinR0000
0olU?4koDF=`ok_5c03ooooooooooooof_ooool1ong_l@7o[;2d0OnW[;00
0006obU0EolR>Dco>4YIohJAWOo1b<kok>k`ooooooooooooomCooooo00Go
n?Wjonc^kooAe=OoVinSoifSY`01ok>j_`00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{734, 424},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<java.awt.FlowLayout\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["java.awt.FlowLayout", 14]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(layoutConstants = {\[IndentingNewLine]java`awt`FlowLayout`LEFT, \
\[IndentingNewLine]java`awt`FlowLayout`CENTER, \
\[IndentingNewLine]java`awt`FlowLayout`RIGHT\[IndentingNewLine]}\)], "Input"],

Cell[BoxData[
    \({0, 1, 2}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(savedLayout = pane@getLayout[]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JRootPane$1"] \[RightGuillemet]\),
      JLink`Objects`JavaObject16598756753409]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]pane@
        setLayout[\[IndentingNewLine]JavaNew["\<java.awt.FlowLayout\>", 
            java`awt`FlowLayout`LEFT, 5, 
            10]\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[{
    \(\(buttons = 
        Table[\[IndentingNewLine]NewJButton[pane, 
            StringJoin["\<Track\>", ToString[i]]], \[IndentingNewLine]{i, 1, 
            5}\[IndentingNewLine]];\)\), "\[IndentingNewLine]", 
    \(\(JavaShow[frame];\)\), "\[IndentingNewLine]", 
    \(frame@repaint[]\)}], "Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(layout = pane@getLayout[]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.awt.FlowLayout"] \[RightGuillemet]\),
      JLink`Objects`JavaObject53547185995777]], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\(layout@
        setAlignment[
          java`awt`FlowLayout`CENTER];\)\), "\[IndentingNewLine]", 
    \(frame@repaint[]\), "\[IndentingNewLine]", 
    \(JavaShow[frame]\)}], "Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[BoxData[{
    \(\(layout@
        setAlignment[java`awt`FlowLayout`RIGHT];\)\), "\[IndentingNewLine]", 
    \(\(layout@setHgap[2];\)\), "\[IndentingNewLine]", 
    \(\(layout@setVgap[2];\)\), "\[IndentingNewLine]", 
    \(\(JavaShow[frame];\)\), "\[IndentingNewLine]", 
    \(\(frame@repaint[];\)\)}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(Do[\[IndentingNewLine]DeleteJObject[pane, 
        buttons[\([i]\)]], \[IndentingNewLine]{i, 1, 
        Length[buttons]}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(ReleaseObject[layout]\)], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> java.awt.GridLayout <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;K0001VAP00`40o`00
0?l0003oo`000?l0003M000000000hS0^4R@R4R@R03oB928odR@R=U8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^=R8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;SHR<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P1000000001HS0^<SPf8S0^8S0^<c<c03/oooo
1/c<c>coooodc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI/c<
c>YVIVH00oooolc<c<c<c003c<c<00=VIVK<c<aVIVH0jFIVIP03ooooc<c<
c<c<0?;<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0
llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<
0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h
0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B928
0@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P10000
00001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0
^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<
c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
IVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=V
IVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKo
oooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_oo
olc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<
0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<
c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0
^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@
R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P100000000
1XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2h
b>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<
c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0
^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003
IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIV
oooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKo
ooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooY
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<
c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<
c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058
T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R040
00000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0
^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3H
R<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03X
c<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8
`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`0
0fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IV
I_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIV
ooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo
jLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<
c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03c
c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2
R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1
000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R0400000
0006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8
`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SP
f8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2h
R<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<
00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QV
IVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIV
I_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_oo
onW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVoooo
c<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0
llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<
0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h
0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B928
0@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P10000
00001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0
^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<
c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
IVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=V
IVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKo
oooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_oo
olc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<
0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<
c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0
^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@
R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P100000000
1XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2h
b>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<
c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0
^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003
IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIV
oooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKo
ooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooY
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<
c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<
c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058
T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R040
00000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0
^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3H
R<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03X
c<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8
`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`0
0fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IV
I_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIV
ooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo
jLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<
c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03c
c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2
R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1
000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R0400000
0006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8
`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SP
f8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2h
R<2hIVIVooooH/c<c0800003c<c<0P0000C<c<`500000/c<c0@00002c<c<
0P0000;<c<`200001<c<c080001Sc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<067<c<`200000lc<c0800004c<c<1@0000;<c<`400000/c<c080
0002c<c<0P0000;<c<`40000Hlc<c003IVIVooooc<c<0??<c<`2R<2h0DR@
R04000000006R<2hb>3HR<2hR<2hIVIVooooH/c<c0800003c<c<0P0000?<
c<`200000/c<c08000000lc<c00000000002c<c<0P000003c<c<00000000
00;<c<`200001<c<c080001Sc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<067<c<`200000lc<c0800003c<c<0P0000;<c<`2000000?<c<`00000
00000/c<c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<
c<`20000H/c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2h
b>3HR<2hR<2hIVIVooooH/c<c0800003c<c<0P0000?<c<`200000/c<c080
00000lc<c00000000005c<c<0P000003c<c<0000000000;<c<`60000H/c<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c01Qc<c<0P0000?<c<`20000
0lc<c0800002c<c<0P000003c<c<0000000000G<c<`2000000?<c<`00000
00001/c<c080001Rc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVKooomRc<c<0P0000?<c<`200001<c<c0800000
1<c<c00000000<c<c0800005c<c<1@0000;<c<`00`000<c<c<c<c0020000
Hlc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c01Qc<c<0P0000?<c<`2
00001<c<c08000001<c<c00000000<c<c0800005c<c<1@0000K<c<`20000
H/c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2h
R<2hIVIVooooH/c<c0800003c<c<0P0000G<c<`4000000?<c<`000000000
1Lc<c0@00004c<c<00@0003<c<`00000001Sc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<067<c<`200000lc<c0800005c<c<10000003c<c<0000
000000G<c<`400000lc<c0800002c<c<0P0006;<c<`00fIVI_ooolc<c03c
c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooof;<c<`20000
0lc<c0800003c<c<00@0003<c<c<c<c<c<`2000000?<c<`0000000000/c<
c08000001<c<c00000000<c<c0800003c<c<00@0003<c<`00000001Sc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<067<c<`200000lc<c0800003
c<c<00@0003<c<c<c<c<c<`2000000?<c<`0000000000/c<c08000001<c<
c00000000<c<c0800002c<c<1@0006?<c<`00fIVI_ooolc<c03cc<c<0XS0
^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooof;<c<`200000lc<c0@0
0002c<c<100000?<c<`400000/c<c0800002c<c<0P0000?<c<`30000Hlc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c01Qc<c<0P0000?<c<`40000
0/c<c0@00003c<c<100000;<c<`200000/c<c08000000lc<c0000000001V
c<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8
`;QVIVKooomRc<c<0P0001K<c<`200001lc<c0<0001Sc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<067<c<`200005/c<c0800006c<c<0P0006G<
c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0
^6IVI_ooof3<c<`600005<c<c0800008c<c<0P0006?<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0Glc<c0H0000Dc<c<0P0000K<c<`50000H/c<
c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
IVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=V
IVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKo
oooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_oo
olc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<
0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<
c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0
^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@
R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P100000000
1XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2h
b>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<
c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0
^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003
IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIV
oooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKo
ooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooY
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<
c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<
c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058
T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R040
00000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0
^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3H
R<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03X
c<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8
`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`0
0fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IV
I_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIV
ooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo
jLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<
c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03c
c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2
R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1
000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R0400000
0006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8
`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SP
f8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2h
R<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<
00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QV
IVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIV
I_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_oo
onW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVoooo
c<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0
llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<
0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h
0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B928
0@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P10000
00001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0
^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<
c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
IVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=V
IVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKo
oooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_oo
olc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<
0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<
c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0
^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@
R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P100000000
1XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2h
b>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<
c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0
^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003
IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIV
oooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKo
ooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooY
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<
c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<
c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058
T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R040
00000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0
^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3H
R<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03X
c<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8
`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`0
0fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IV
I_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIV
ooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo
jLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<
c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03c
c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2
R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1
000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R0400000
0006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8
`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SP
f8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2h
R<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<
00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QV
IVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIV
I_ooolc<c03cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_oo
onW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVoooo
c<c<0??<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0
llc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<
0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h
0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B928
0@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c03cc<c<0XS0^058T8P10000
00001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0j<c<c003IVIVooooc<c<0??<c<`2R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03Xc<c<00=VIVKoooo<c<`0llc<c0:8`;P1B9280@00000000F8`;S8
h=R8`;R8`;QVIVH0j_ooo`03c<c<ooooc<c<00C<c<`00fIVI_ooooooo`3X
oooo00?<c<coooo<c<`0llc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;S/IVIV1/c<c>aVIVKec<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<
olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cE
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@
R04000000005R<2hb>3HR<2hR<2hc<c<0>coool6c<c<k?ooo`K<c<c/oooo
0/c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVK<c<cZIVIV00?o
ooo<c<c<c<`00lc<c003IVIVc<c<IVIV0>UVIVH00oooolc<c<c<c003c<c<
00=VIVK<c<aVIVH0jFIVIP03ooooc<c<c<c<00:8`;P1B9280@00000000J8
`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIV
ooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R040
00000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<
c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QV
IVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0
^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3H
R<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03X
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<
c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P100000000
1XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AV
IVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo
jLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B928
0@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0
^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2
R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVoooo
c<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R0400000
0006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`0
16IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKo
oooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058
T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2h
R<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<
c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0
^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKo
ooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<
c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IV
I_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h
0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<
c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IV
I_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooY
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1
000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03X
c<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
IVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SP
f8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<
c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004
IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_oo
onW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@
R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8
`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<
0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2h
b>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_oo
olc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P10000
00001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<
00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIV
oooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0
^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<
c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8
`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIV
ooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R040
00000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<
c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QV
IVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0
^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3H
R<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03X
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<
c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P100000000
1XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AV
IVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo
jLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B928
0@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0
^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2
R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVoooo
c<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R0400000
0006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`0
16IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKo
oooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058
T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2h
R<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<
c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0
^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKo
ooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<
c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IV
I_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h
0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<
c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IV
I_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooY
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1
000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03X
c<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
IVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SP
f8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<
c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004
IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_oo
onW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@
R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8
`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<
0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2h
b>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_oo
olc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P10000
00001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<
00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIV
oooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVKooomRc<c<0P0000?<c<`20000
1<c<c0D00002c<c<100000;<c<`200000/c<c0800004c<c<0P0006?<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0HLc<c0800003c<c<0P0000C<
c<`500000/c<c0@00002c<c<0P0000;<c<`2000000?<c<`0000000001000
06;<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0HLc<c0800003c<c<
0P0000C<c<`500000/c<c0@00002c<c<0P0000;<c<`200000/c<c0@0001S
c<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
IVIVooooH/c<c0800003c<c<0P0000?<c<`200000/c<c08000000lc<c000
00000002c<c<0P000003c<c<0000000000;<c<`200001<c<c080001Sc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<067<c<`200000lc<c0800003
c<c<0P0000;<c<`2000000?<c<`0000000000/c<c08000000lc<c0000000
0002c<c<0P000003c<c<0000000006K<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0HLc<c0800003c<c<0P0000?<c<`200000/c<c08000000lc<
c00000000002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`00000
00000/c<c080001Rc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hIVIVooooH/c<c0800003c<c<0P0000?<c<`200000/c<
c08000000lc<c00000000005c<c<0P000003c<c<0000000000G<c<`20000
Hlc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c01Qc<c<0P0000?<c<`2
00000lc<c0800002c<c<0P000003c<c<0000000000G<c<`2000000?<c<`0
000000000lc<c080001Uc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
067<c<`200000lc<c0800003c<c<0P0000;<c<`2000000?<c<`000000000
1Lc<c08000000lc<c00000000006c<c<0P0006;<c<`016IVI_ooolc<c<c<
c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooomRc<c<0P0000?<
c<`200001<c<c08000001<c<c00000000<c<c0800005c<c<1@0000G<c<`2
0000Hlc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c01Qc<c<0P0000?<
c<`200001<c<c08000001<c<c00000000<c<c0800005c<c<1@0000C<c<`2
0000I<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c01Qc<c<0P0000?<
c<`200001<c<c08000001<c<c00000000<c<c0800005c<c<1@0000K<c<`2
0000H/c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0
^8S0^6IVI_ooof;<c<`200000lc<c0800005c<c<10000003c<c<00000000
00G<c<`400001/c<c080001Sc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<067<c<`200000lc<c0800005c<c<10000003c<c<0000000000G<c<`4
00001/c<c080001Sc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<067<
c<`200000lc<c0800005c<c<10000003c<c<0000000000G<c<`400001lc<
c080001Rc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3H
R<2hR<2hIVIVooooH/c<c0800003c<c<0P0000?<c<`010000<c<c<c<c<c<
c08000000lc<c00000000002c<c<0P000004c<c<00000000c<c<0P0000?<
c<`010000<c<c000000006?<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0HLc<c0800003c<c<0P0000?<c<`010000<c<c<c<c<c<c08000000lc<
c00000000002c<c<0P000004c<c<00000000c<c<0P0000K<c<`20000H/c<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c01Qc<c<0P0000?<c<`20000
0lc<c0040000c<c<c<c<c<c<0P000003c<c<0000000000;<c<`2000000C<
c<`00000003<c<`200001<c<c0<0001Sc<c<00AVIVKoooo<c<c<c<`2R<2h
0DR@R04000000006R<2hb>3HR<2hR<2hIVIVooooH/c<c0800003c<c<1000
00;<c<`400000lc<c0@00002c<c<0P0000;<c<`200000/c<c0@0001Sc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<067<c<`200000lc<c0@00002
c<c<100000?<c<`400000/c<c0800002c<c<0P0000G<c<`20000H/c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c01Qc<c<0P0000?<c<`400000/c<
c0@00003c<c<100000;<c<`200000/c<c0800005c<c<0P0006;<c<`016IV
I_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooomR
c<c<0P0001K<c<`200001lc<c0<0001Sc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<067<c<`200005/c<c0800005c<c<0P0000;<c<`20000H/c<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c01Qc<c<0P0001K<c<`20000
1Lc<c0800002c<c<0P0006;<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVKooomPc<c<1P0001C<c<`200002<c<c080
001Sc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<05o<c<`600005<c<
c0800006c<c<100006?<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
Glc<c0H0000Dc<c<0P0000K<c<`40000Hlc<c004IVIVooooc<c<c<c<0XS0
^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3H
R<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03X
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<
c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P100000000
1XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AV
IVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo
jLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B928
0@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0
^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2
R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVoooo
c<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R0400000
0006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`0
16IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKo
oooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058
T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2h
R<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<
c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0
^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKo
ooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<
c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IV
I_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h
0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<
c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IV
I_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooY
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1
000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03X
c<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
IVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SP
f8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<
c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004
IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_oo
onW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@
R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8
`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<
0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2h
b>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_oo
olc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P10000
00001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<
00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIV
oooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0
^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<
c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8
`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIV
ooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R040
00000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<
c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QV
IVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0
^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3H
R<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03X
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<
c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P100000000
1XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AV
IVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo
jLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B928
0@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0
^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2
R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVoooo
c<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R0400000
0006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`0
16IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKo
oooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058
T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2h
R<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<
c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0
^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKo
ooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<
c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IV
I_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h
0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<
c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IV
I_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooY
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1
000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03X
c<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
IVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SP
f8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<
c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004
IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_oo
onW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@
R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8
`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<
0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2h
b>3HR<2hR<2hIVIVoooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03Xc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_oo
olc<c<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P10000
00001XS0^<SPf8S0^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0j<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<
00AVIVKoooo<c<c<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIV
oooojLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0j<c<c004IVIVooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0
^8S0^6IVI_ooonW<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<
c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooojLc<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03Xc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>S<c<`016IVI_ooolc<c<c<c0:8`;P1B9280@00000000J8
`;S8h=R8`;R8`;QVIVKooooYc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>S<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c004IVIV
ooooc<c<c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooonW<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0j<c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03Xc<c<00AVIVKoooo<c<c<c<`2R<2h0DR@R040
00000005R<2hb>3HR<2hR<2hIVIV0>[oool00lc<c?ooolc<c004c<c<00=V
IVKoooooool0j?ooo`03c<c<ooooc<c<00C<c<`00fIVI_ooooooo`3Xoooo
00C<c<coooo<c<c<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hk6IV
IPK<c<c/IVIV1/c<c>aVIVH3c<c<0XS0^058T8P1000000000hS0^<SPf8S0
^03oR<2hohS0^=R8`;P1B9280@00000000B8`;S8h=R8`;R8`;PF00201001
P0<00X0400>11004P@801H400`05PP06PP06PP0200J20P07PP030@N20@R2
0@R2008128<40@V30`4:P`040@^30@^40@^40@^4104<Q0<13H@40@j50`8?
Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<3
5hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:0`@NRP0411j;
11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@US@@US@021BF=
10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/
S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@031S:B1S>B
1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7
>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF10PoUP88
@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6
V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL
2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;EIh3
2eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ35fQ
35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S10eT
X`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H23VfV
00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP2
3g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/347^[
00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60[@02
4H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_0a65[`@A
QZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<BS;8BSK8B
SK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C]0<C
U;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LDVkLD
VkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T35J6i
11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ
_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh45k2n
0aNa_`@G/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P4
002000>KYo4c@jDc@jD02C=3Y@H0080400600`02P0@00h4400B10P05P@03
00F200J200J200801X8200N200<11h81288128800P48P`@12H<30@Z300@1
2h<12h@12h@12h@40@b40`4=Q0@13XD30Pn5108@Q@@24HH30Q:60`8CQP04
0Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<IR@<I
R@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4122;0`@QR`@4
8X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd59hh59hh010DX
SP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46
<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB
0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8
?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL0
0`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9
BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYA
W@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;
F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83
362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=
Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_
Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ
3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m
[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61[P<A
PZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/0044XVa
4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?
/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF
]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh
11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV
^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/
_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/klf6;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0<008001i^WlOooohij]ZJKa;>Y
dZRMb;>YdP02YY_400Fl^=g^k_CZjO7ooolc@jD01@00P0@00H0300:01003
P@@0184200F100<01H801X801X800P06PP801h800`47PP48PP48PP020@R3
1049P`<12X<0104;P`4;Q04;Q04;Q0@138@30@f4104>Q@<23hD40Q25108A
QP<24XH30Q>600@24hL258L258L258L40QF70P8FQ`835XP30aN810<HR004
0aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX010@NR`@OR`@OR`@O
R`@488/3126;10@RS0@48h`212B<00<498d49Hd49Hd00PDUS@@59Xd00`DW
S@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^
T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHcTPHcTP021S>B
00<6=987=987=9800PLeTP87=I<31cJC10LgT`041cRC1cRD1cRD1cRD0`Li
U0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8
@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9AYT9AYT010U7
V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL
0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN0`]FWP042eNN
2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<
GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=I:<00`eUX`eU
Y0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW
3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?M:T3
3gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/
47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d00Q60[@044H6]
4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<AQJl44HJ_0a:7/0@B
R;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb008BSK82
4Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@34iBd00@CUK@C
UKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g59^g008DVkL3
59bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j
0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[
_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`_P<G/Kl45k:o
0aNc_`8H]<0P00000QRd`10000026;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^080080019^WlOooofaJYJnUbP:l^=d02_omok>Yd_oooooookbh
gIN:_:RMb>KVk?oooc=3Y@@0080400600`02P0@00h4400B10P05P@0300F2
00J200J200801X8200N200<11h81288128800P48P`@12H<30@Z300@12h<1
2h@12h@12h@40@b40`4=Q0@13XD30Pn5108@Q@@24HH30Q:60`8CQP040Q>7
0QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<3
6XT40a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4122;0`@QR`@48X`4
12><0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5
:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946
<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087
=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D3
23fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3
V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX3
2T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:
DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l4
2eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R
0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@3
3FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`03
3W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ
3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@
OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh4
4H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa
4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?
/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<D
UkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN
^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@F
Yk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@04
5jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/kl26;C000?8h=Q8
T8Q8T8P034R@R0030000b>3HB92800e8T8P0100001Rd`1Rd`<SPf0i8T8P0
0`0001Rd`1Rd`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00;
VjOaooooZ9g8oooo/jWBH4bJSWZfN6F^Z9g8oooooogo00?oool00c=3Y@00
P000P00300201001P0<00X0400>11004P@801H400`05PP06PP06PP0200J2
0P07PP030@N20@R20@R2008128<40@V30`4:P`040@^30@^40@^40@^4104<
Q0<13H@0104>QOooooooooooo`<23hD40Q25108AQP<24XH30Q>600@24hL2
58L258L258L40QF70P8FQ`835XP30aN810<HR0040aV80aV90aV90aV90`<J
R@@36hT30ab:10<MRP<47XX010@NR`@OR`@OR`@OR`@488/3126;10@RS0@4
8h`212B<00<498d49Hd49Hd00PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DY
SP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`
T@021S2A0`HaT@<6<Y400`HbTPHcTPHcTP021S>B00<6=987=987=9800PLe
TP87=I<31cJC10LgT`041cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8
?ID010PmUPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H
2DBH2DBH0089A9P42DFH00<9AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:
BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYB
W@8;DYd32e>M0P]DW@8;E9h42eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;
FIl435ZP0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82
366R0PeQXP8=HZ823F:S0`eSX`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=
J:D43VVU0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>
L:L?L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?
MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n
[08@OZd247n]00<AOjdAP:dAP:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@A
Pjh01164[Q64[a64[a64[`<AQJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4B
R[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc
4hnc00@CT;<44i6c0a>B]0@CTk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG
]@@DV;H359Vf0aBJ]P0359Zg59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh
0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW
^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G
[Kd00aN^_AN^_QN^_P045jnn11N`_P<G/Kl45k:o0aNc_`8H]<000lSPf8S0
^8S0^00;R<2h00=8T8P00038h=P03HS0^005B92800006;C06;C0b>3H00f8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
002000jKYo7ooooooooKg>aPC9ZCQKZcZM:l^=ePC9ZISkjVVlC8`moooolc
@jD600200oooo`03006000:000:000Coool01@03P@04P@04POooo`04P@02
00F100<01H;oooooool00_ooo`801h84oooo00D128<12H<12H?oool12H<0
0P4:P`07oooo0@^30@^40@^4oooo0@b4oooo008138@0104=Q?ooo`4=Q?oo
o`<13XD00oooo`8?Q@8?Q@040Q25108AQP<24XH30Q>600@24hL258L258L2
58L40QF70P8FQ`835XP30aN810<HR0040aV80aV90aV90aV90`<JR@@36hT3
0ab:10<MRP<47XX010@NR`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<
00<498d49Hd49Hd00PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>
1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A
0`HaT@<6<Y400`HbTPHcTPHcTP021S>B00<6=987=987=9800PLeTP87=I<3
1cJC10LgT`041cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010Pm
UPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH
0089A9P42DFH00<9AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK
10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd3
2e>M0P]DW@8;E9h42eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP
0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQ
XP8=HZ823F:S0`eSX`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU
0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?
L:P010maZ0<?LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ
0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd2
47n]00<AOjdAP:dAP:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164
[Q64[a64[a64[`<AQJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[44
4X^a0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@C
T;<44i6c0a>B]0@CTk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H3
59Vf0aBJ]P0359Zg59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^004
5J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/0
11JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^
_AN^_QN^_P045jnn11N`_P<G/Kl45k:o0aNc_`8H]<001<SPf8S0^8S0^8S0
^0H00004R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H
]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0<008003Y^WlOoookbhgIV?__ooomKAgM_Lk??nojJKa>k^m8Ef
/9>5^_oooc=3Y@@008002?ooo`01P001P001P?ooo`02P?ooo`02P0800h40
1_ooo`03P@04P@04POooo`04P@801H402?ooo`06PP06PP06P_ooo`07P_oo
o`47PP8128801P48Poooo`49P`49Poooo`49P`812X<01oooo`4;P`4;Q04;
Q?ooo`4<Q?ooo`020@b400<13HCoool13H@01?ooo`<23hD40Q25108AQP<2
4XH30Q>600@24hL258L258L258L40QF70P8FQ`835XP30aN810<HR0040aV8
0aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX010@NR`@OR`@OR`@OR`@4
88/3126;10@RS0@48h`212B<00<498d49Hd49Hd00PDUS@@59Xd00`DWS@DW
SPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6
;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHcTPHcTP021S>B00<6
=987=987=9800PLeTP87=I<31cJC10LgT`041cRC1cRD1cRD1cRD0`LiU0@7
>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8@IL4
24:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9AYT9AYT010U7V@@9
B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@
W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN0`]FWP042eNN2eNO
2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<GZ42
35nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=I:<00`eUX`eUY0eU
Y0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW3VjW
008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?M:T33gFY
00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/47b/
008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d00Q60[@044H6]4H6^
4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<AQJl44HJ_0a:7/0@BR;03
4XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb
0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@34iBd00@CUK@CUKDC
UKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g59^g008DVkL359bg
0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT
^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@03
5Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`_P<G/Kl45k:o0aNc
_`8H]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P00038h=P00XS0^003
0000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000C8h=R8`;R8
`;R8`;P2000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0`00P00?VjOaooooVHnnUhZle=?XkjbcogIk
kYn[FeRUYY_4UYoBH4bJ_;SMoooo<d>U00<008002?ooo`01P001P001P?oo
o`02P?ooo`02P0800h401_ooo`03P@04POooo`04POooo`801H402?ooo`06
PP06PP06P_ooo`07P_ooo`47PP8128802P48Poooo`49Poooo`49Poooo`4:
Poooo`4:Poooo`812h@00oooo`4<Q?ooo`020@b400@13HCoool13HCoool3
0@j50`8?Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ7
0P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:0`@N
RP0411j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@US@@U
S@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl4
1B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@03
1S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7
>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF
10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP0
0`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`03
2TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]D
WP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX004
35bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<3
3F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>
K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mb
Z08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@
NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60
[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_
0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<B
S;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d
11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<D
V[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TE
X;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl
5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G
[kh45k2n0aNa_`@G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R000
0<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H
]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008002Y^WlOoooiN:
_7Y/Z[?7j:U^X<S3gi>5^U]6TiV?_P9hIJh0148WQJnUb_oooc=3Y@@00803
006000?oool00X000X001?ooo`0500>100B1oooo00B1oooo00801H400`05
P_ooooooo`02oooo0P07PP0=0@N20@R20@R20@R3oooo0@V3oooo0@V3oooo
0@Z3oooo0@Z3oooo00812h@00oooo`4<Q?ooo`020@b400<13HCoool13H@0
1?ooo`<23hD40Q25108AQP<24XH30Q>600@24hL258L258L258L40QF70P8F
Q`835XP30aN810<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<4
7XX010@NR`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<00<498d49Hd4
9Hd00PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?
10D[S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y40
0`HbTPHcTPHcTP021S>B00<6=987=987=9800PLeTP87=I<31cJC10LgT`04
1cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPn
UP@8?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH
00<9AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/0
0`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;
E9h42eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:00
10aLX@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S
0`eSX`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH4
3VbV0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?
LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/3
47Z[0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdA
P:dAP:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64
[`<AQJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@03
4Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B
]0@CTk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P03
59Zg59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i
5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY
_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P04
5jnn11N`_P<G/Kl45k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P0
0038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R0000002
6;C000?8h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOaoooooooo00;oool0
2_n]/?mfNoW=e?g]k_ooojJKa8Ef/;bhgOoooc=3Y@D00803006000Coool0
0X000X000X0200>100?oool00h7oool00`04P@03oooo00F100F200<01X80
1?ooo`07PP07PP47PP?oool02@48P`49Poooo`49Poooo`4:Poooo`4:Pooo
o`020@^400Woool138Coooooool138@13HCoool13HCoool00P4>Q@04oooo
0Pn50Pn50Pn5108@Q@@24HH30Q:60`8CQP040Q>70QB70QB70QB7108EQ`82
5XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX3
11j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@TS00312B=12F=
12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZ
S`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A
00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<0
10LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8
?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5
V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK
00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d2
2eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP
00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeR
X`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V
10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP3
3g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[
0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]
4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lA
Q:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;40
0a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<C
T[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H0
0aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP
^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`F
ZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h0
11N__P@G/;h35k6o11Nb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B928
0000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P00000
0QRd`003b>3HR<2hR<2h00B8`;P200001HS0^004B92800006;C06;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0<008002Z6/l_W=e>8V??Be_n8V
??A]OOcSjOoooog]k_n]/0;oool00c=3Y@00P000P00400200`01P003oooo
00:000:000?oool200>100Ooool018401840187oool01H401H800oooo`04
00J200N200N2oooo0P48PP8128<01@49Poooo`49P`49Poooo`020@Z300Oo
ool12h@12hCoool138Coool138@00_ooo`813H@00`4>QOooooooo`02oooo
0P8?Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<F
R0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:0`@NRP04
11j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@US@@US@02
1BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?
0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@031S:B
1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7
>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF10Po
UP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6
V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL
2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;
EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ
35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S
10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H2
3VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?
LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/3
47^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60
[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_0a65
[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<BS;8B
SK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C
]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LD
VkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T3
5J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl
11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh4
5k2n0aNa_`@G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SP
f002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<00
0lSPf8S0^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2002000fKYo7mkNkR9ScnmOSgRIOdHVkc
X:kdHVkooOoo[K3lhnWooolc@jD01`00P0<00H001?ooo`02P002P002P0@0
0h4400B10P05P@0300F200J200J200801X800`07P_ooo`47PP020@R20P48
P`@12H<30@Z300@12h<12h@12h@12h@40@b40`4=Q0@13XD30Pn5108@Q@@2
4HH30Q:60`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P0
10<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/4
7h/4122;0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<5
9hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6
;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHc
TP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7
>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3
246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9
AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?
W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]G
WP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ44
35jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=
IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^
Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY
0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l
[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161
[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk04
4XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb
0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd
4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g
0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS
^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08F
Zkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb
_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`00
08S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h
00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0P00P003VjOam/S<hRHl00;o[K001mlT;_nT
W_JlaOn]/>ikS?oooc=3Y@0800200`01P004oooo00:000:000:01003P@@0
184200F100<01H801X801X800P06PP0300N2oooo0@N2008128800`48Pooo
o`49P`030@V30`4:P`040@^30@^40@^40@^4104<Q0<13H@40@j50`8?Q@@2
48D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP4
0aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:0`@NRP0411j;11n;
11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@US@@US@021BF=10DV
S@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6
;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B
0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7
>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF10PoUP88@9H2
242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6
V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL
008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN
00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ
35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`03
3FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>
KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y
10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@
Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]
00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl3
4XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<BS;8BSK8BSK80
0Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@0
11>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL0
0QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR
^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08F
Zk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa
_`@G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h
2@0000:8`;P01DR@R00001Rd`1Rd`<SPf003R<2h0P0000B8`;P200000XS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08000i^WlOW=e?N9U`02oooo00Oo[K3Q5SCoMW_oY9kR9ScoRGlc@jD02000
P0<00H001?ooo`02P002P002P0@00h4400B10P05P@0300F200J200J20080
1X8200N21?ooo`030@R30@V30@V300812H<30@Z300@12h<12h@12hCoool4
0@b40`4=Q0@13XD30Pn5108@Q@@24HH30Q:60`8CQP040Q>70QB70QB70QB7
108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^90`<L
RP@37HX311j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@TS003
12B=12F=12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZSPDZ
S`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6
<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC0`Lf
T`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8
?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4V002
2DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:
CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]C
W@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<
Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ82
3F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>
JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X
00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@
N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o
[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@AQ:hA
Q:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;
/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c
11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI
]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP
^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@F
Z;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG
[[hG[[h011N__P@G/;h35k6o11Nb_`<G/kl26;C000?8h=R8`;R8`;P02hS0
^003B9280000b>3H00:8`;P900000XS0^005B92800006;C06;C0b>3H00f8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
002000NKYo7oooocX:kdHVkoooogRIOicM@00_ooo`03lj2^oooo<d>U00P0
080400600`02P0@00h4400B10P05P@0300F200J200J200801X8200N200<1
1h81288128800P48P`@12H<30@Z300@12h<12h@12h@12h@40@b40`4=Q0@1
3XD30Pn5108@Q@@24HH30Q:60`8CQP040Q>70QB70QB70QB7108EQ`825XL2
0aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX311j:
00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@TS00312B=12F=12F=
00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5
:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A00<6
<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<010Lh
T`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH4
23nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5V003
2DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:
CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN
10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<
G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=
Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/
YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X
0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1j
Z`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]
4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l3
4HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:<
/Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@4
4i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ
]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP
^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`F
ZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N_
_P@G/;h35k6o11Nb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000
b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00;VjOaooooohUooooo
lj2^lI>Qoooooogolj2^oo_l<d>U00P0080400600`02P0@00h4400B10P05
P@0300F200J200J200801X8200N200<11h81288128800P48P`@12H<30@Z3
00@12h<12h@12h@12h@40@b40`4=Q0@13XD30Pn5108@Q@@24HH30Q:60`8C
QP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<I
R@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4122;0`@Q
R`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd59hh59hh0
10DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6
;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB
1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10Lk
U@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88
@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9
VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L
0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]G
W`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<
Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eV
Y0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW
10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY
3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/
0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61
[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/004
4XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[80
0a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe
11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL2
5Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj
0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/
_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/kl26;C0
3lSPf0030000b>3Hb>3H00g8h=P00`0001Rd`1Rd`00?b>3H00<0000H]<0H
]<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0@00803VjOa00Kooooc
X:kd]Kof_<GkfMXc@jD900201001P0<00X0400>11004P@801H400`05PP06
PP06PP0200J20P07PP030@N20@R20@R2008128<40@V30`4:P`040@^30@^4
0@^40@^4104<Q0<13H@40@j50`8?Q@@248D40Q660`8BQP<24hH0108CQ`8D
Q`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ9
10<KR@<378X40af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<10@S
S08498`00`@TS@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>
00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A
0086<9431S6A0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB
0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`Pm
U@0423fF23jF23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9
A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;
VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M
0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]I
W`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<
HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eX
Y@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`
Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmf
ZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/
0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163
[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::
/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<C
Sk<011>@/`@CTK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne
11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P3
5Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk
0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]
_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G/[l35k>o=QRd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;PF00201001P0<00X0400>11004P@801H40
0`05PP06PP06PP0200J20P07PP030@N20@R20@R2008128<40@V30`4:P`04
0@^30@^40@^40@^4104<Q0<13H@40@j50`8?Q@@248D40Q660`8BQP<24hH0
108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT3
6HT30aZ910<KR@<378X40af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/4
12:<10@SS08498`00`@TS@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5
:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA
1S2A1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLd
TP021cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD3
23bE0`PmU@0423fF23jF23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G
00<9@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX4
2DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:
DId22U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil3
2eRO10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR
0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@4
3FNT0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>
KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mf
ZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@
OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh3
4H:^1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9
/A::/A::/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<C
Sk8CSk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@D
U[D359Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM
^0@EW[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<F
Y[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG
[;d011N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G/[l35k>o=QRd`0:8
`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;SHR<2h0DR@R0400000
0003R<2hb>3HR<2h0?n8`;SoR<2hf8S0^058T8P1000000000hS0^<SPf<SP
f03ob>3HolSPf=S8h=P1B9280@000000ohS0^?n8`;SLR<2h0@000000\
\>"], "Graphics",
  ImageSize->{731, 409},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;N0001Z2000`400?l0
0000o`00003oooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?000?oo
l?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`
l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?oo
l?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003o
oo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3o
l?3`003ooo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l00000gooooo
ookno_ono_koo?clooWinOofm_Kol_;bong]kOoXj>Sohn?Son3Ph?oMgMgo
fm_K00;of][Jd_oIfMT2om[JfP0:om_KfooMgMgoh>3Pon?ShooXj>SokNg]
oo;bl_ofm_KonOWiooclo0;oo_kn2?ooool2ooknoP0:ooclo?oinOWom_Kf
oo;bl_o]kNgoj>SXon?ShooPh>3ogMgMom_Kf`;of][Jd_oIfMT2om[JfP0:
om_KfooMgMgoh>3Pon?ShooXj>SokNg]oo;bl_ofm_KonOWiooclo0;oo_kn
nOooool000;okNg]00[oj^[ZonSXj?oRh^;ogMgMomKFe_o=cLgoa/K6okjn
__nj^[[o][Jf1?nc/k?@ok:b/PCo/k>c00[o][JfokZj^_nn_[koa/K6olg=
cOoFe]KogMgMon;Rh_oXj>Soj^[Z0_o]kNd6onk^kP;okNg]00[oj^[ZonSX
j?oRh^;ogMgMomKFe_o=cLgoa/K6okjn__nj^[[o][Jf1?nc/k?@ok:b/PCo
/k>c00[o][JfokZj^_nn_[koa/K6olg=cOoFe]KogMgMon;Rh_oXj>Soj^[Z
0_o]kNghonk^kP0000koiNGUon;Rh_oOgmoof][Jom;Bd_o7alOo_Kfmok:b
/_nXZ:SoX:2Poi^KVonHV9SoU9BDoi>CTmCoTY:B00goTi>CoiBDU?nHV9So
Vi^Koj2PX?nXZ:So/[:bokfm_Oo7alOod];Bom[Jf_oOgmooh^;R00;oiNGU
1OoVi^H03_oUiNGoh^;RomoOgooJf][od];BolO7aonm_Kgo/[:bojRXZ?nP
X:3oVi^KoiRHV?nDU9CoTi>Ce?nBTY803OnCTi?oU9BDoiRHV?nKVi_oX:2P
ojRXZ?nb/[;o_KfmolO7aooBd];of][JomoOgooRh^800_oUiNGgonKViP00
00kojn_[onSXj?oRh^;of=SHol_;bonn_[ko[Zj^oj6QXOnEUIGoS8b<ohF5
QOn2PX;oOgmooginO]CoOGem00ooOWinogmoOon2PX;oQHF5ohb<S?nEUIGo
XJ6Qojj^[_nn_[kobl_;omSHf?oRh^;oj>SXon_[joo]kNd01Oo^k^h03_o[
jn_oj>SXon;Rh_oHf=Sobl_;okjn__n^[ZkoXJ6QoiFEUOn<S8coQHF5oh:2
P_moOgooOWine?mmOGd03omnOWkoOgmooh:2P_n5QHGoS8b<oiFEUOnQXJ7o
[Zj^okjn__o;bl_of=SHon;Rh_oXj>Sojn_[ong]k@3gonk^kP0001ConOWi
oo?clooYjNWofMWIolO7aond];CoXZ:RoiZJV_nZZZ[o`l?3omWIfOo/k>co
m_KfooOgmooinOWon?ShooWinOojn_[onOWiooOgm`?on?Sh0_oinOT00ooj
n_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWi
n@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooSh
n0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg
00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWi
nOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00ooj
n_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWi
n@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooSh
n0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg
00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWi
nOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00ooj
n_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWi
n@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooSh
n0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg
00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn00BooWinOohn?SonOWi
ooShn?ogmoOok^k^om[Jf_o4a<CoZZZZoiZJV_nRXZ;o];BdolO7aooIfMWo
jNWYoo?clooinOWooOgm1Oooool05?oinOWolo?conWYjOoIfMWoalO7okBd
]?nRXZ;oVYZJojZZZ_o3`l?ofMWIonc/k?ofm_KomoOgooWinOohn?SonOWi
oo[jn_oinOWomoOg0oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oi
nOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?o
n_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oi
nOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?o
n_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oi
nOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh01;onOWiooShn?oinOWon?ShooOgmoo^k^kof][JolC4
a?nZZZ[oVYZJoj:RX_nd];CoalO7omWIfOoYjNWolo?cooWinOomoOggoooo
o`0000coiNGUomgMgOo>c/ko_KfmojRXZ?nEUIGoYJFUolc<c?o^k^kom_Kf
ooclo?ono_kHooooo`0=ookno_olo?comoOgono_koo=cLgoYZJVoiFEUOnX
Z:So_Kfmolk>c_oMgMgoiNGUon[ZjP05onk^kP0<onGUiOoMgMgoc/k>okfm
_OnXZ:SoUIFEojFUYOo<c<cok^k^ooKfm_olo?coo_knf?ooool03Oono_ko
o?clooOgmoo_knoocLg=ojJVY_nEUIGoZ:RXokfm_Oo>c/kogMgMonGUiOoZ
j^X0moo^k^h0000:om[Jf_o>c/ko_KfmojRXZ?nFUYKoZj^[omkNg_o[jn_o
m?Cdoo_knmcooooo00_ono_koo?cloo/k>cohN7Qojj^[_nFUYKoZ:RXokfm
_Oo>c/kof][Jon3Ph005onKViP0:om[Jf_o>c/ko_KfmojRXZ?nFUYKoZj^[
omkNg_o[jn_om?Cdoo_knmcooooo00_ono_koo?cloo/k>cohN7Qojj^[_nF
UYKoZ:RXokfm_Oo>c/kof][Jon3Ph03gonKViP0000[ogMgMolg=cOnh^;So
XJ6QojRXZ?oDe=Coh>3Ponc/k?oemOGooOgmg?ooool02oono_kom_Kfonc/
k?oRh^;ofMWIojb/[?nQXJ7o^;Rholg=cOoMgMgoiNGU00Gok^k^00[ogMgM
olg=cOnh^;SoXJ6QojRXZ?oDe=Coh>3Ponc/k?oemOGooOgmg?ooool02oon
o_kom_Kfonc/k?oRh^;ofMWIojb/[?nQXJ7o^;Rholg=cOoMgMgoiNGU0?Oo
k^k^00002ooXj>Soe=CDokZj^_nYZJWoa/K6omCDe?oPh>3ok>c/oo;bl_ol
o?coo_kn0=_ooooo00_on_[jooCdm?oZj^[ohn?SomOGeoo=cLgo[:b/okZj
^_oDe=Coj>SXoo?cl`05ooooo`0;onSXj?oDe=Co^[ZjojVYZOo6a/Koe=CD
on3Ph?o/k>col_;booclo?ono_h0foooool02oojn_[om?Cdon[Zj_oShn?o
emOGolg=cOn/[:co^[ZjomCDe?oXj>Solo?c0?Oooooo00003ooDe=Co_kno
ojJVY_n/[:coa/K6om;Bd_oLg=coi^KVonc/k?oemOGon?Shoo[jn_omoOgo
ooooooclo008ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooooooo
ool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Go
oooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03
oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgo
ooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooooooo
ool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Go
oooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03
oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgo
ooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooooooo
ool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Go
oooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03
oogmoOoooooooooo00Gooooo01;ooOgmooooooomoOgooooooogmoOokno_o
n?ShooCdm?o]kNgoi^KVomoOgooFe]Koc<c<ok:b/_nWYjOo_knoomCDe?oR
h^85onk^kP0?omCDe?no_kooYZJVojb/[?o6a/Kod];BomcLg?oVi^Kok>c/
ooGemOohn?Son_[joogmoOooooooo?cl00Sooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool04_omoOgooooo
oogmoOoooooooOgmoo_knoohn?Som?Cdong]kOoVi^KogmoOomKFe_o<c<co
/[:bojNWYono_kooe=CDon;Rh_Ook^k^00004oo:b/[o]KFeoijNW_nf][Ko
`l?3olo?cooFe]KogmoOonKVi_oZj^[okno_oo?cloodm?ComOGeooOgmoof
m_KomoOgooKfm_ohn?P00_ogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_Kf
ooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H04_ogmoOom_KfooOgmoofm_Kom?Cdoo;bl_o`l?3ojn_[onKVi_oQ
hN7of][Jom?Cdoo9bLWo_knooj>SXone]KGob/[:omWIf@Goi^KV01?ob/[:
okFe]OnNWYko][Jfol?3`oo?clooe]KFomoOgooVi^Koj^[Zono_kooclo?o
m?CdooGemOogmoOom_KfooOgmoofm_Kon?Sh00;omoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf01;omoOgooKfm_ogmoOom_KfooCdm?obl_;o
l?3`on_[jooVi^KohN7Qom[Jf_oCdm?obLW9okno_onSXj?o]KFeol[:b_oI
fMWgonKViP0000_od=3@okRh^?nPX:3o/k>col30`?o9bLWodm?ComWIfOoM
gMgoh^;RonGUi@02on[ZjP03onc/k?o]kNgokNg]00Ook^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3okNg]ong]k@02onc/k00=onWYjOoVi^Kohn?Son3Ph?oKfm_oeMGEolg=
cOo5aLGo^k^kojNWYonh^;Sod=3@on3Ph005onk^kP0;om3@d?nh^;SoX:2P
ok>c/oo0`<3obLW9om?CdooIfMWogMgMon;Rh_oUiND00_oZj^X00oo/k>co
kNg]ong]k@07onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`ong]kOo]kNd00_o/k>`03OoYjNWo
i^KVon?ShooPh>3ofm_KomGEeOo=cLgoaLG5ok^k^onWYjOo^;Rhom3@d?oP
h>00moo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3o
lO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7a
lOOooooo00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7g
onk^kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5
onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWImooV
i^H0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7gooooo`00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOOoi^KV00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7gonk^kP0000goh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7amoooool0000=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^00003Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWgonKViP0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOOooooo00003OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN7gonk^kP0000gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/[ofMWImooVi^H0000=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7QhOOok^k^00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph?oalO7gooooo`0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Qmoo^k^h0000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
okFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIfOOoi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN7gonk^kP0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>3olO7amoooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7QhOOok^k^00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMWgonKViP0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
moo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOOo
oooo00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Go
k^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7gonk^
kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKV
iP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWImooVi^H0
000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h0
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^0000
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7gooooo`0000go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=ol[:
b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOOoi^KV00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7gonk^kP0000goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7amoooool0000=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^00003Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWgonKViP0000godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=on3Ph?o8b<SoUIFEojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3Poo7alOOooooo00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN7gonk^kP0000gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2PokFe]Oo:b/[ofMWImooVi^H0000=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7QhOOok^k^00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7o
b<S8on3Ph?oalO7gooooo`0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Qmoo^k^h0000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:omWIfOOoi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oM
gMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN7gonk^kP0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oM
gMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3P
h?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3o
lO7amoooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
hOOok^k^00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWg
onKViP0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45
onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^
k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Ooo
ool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOOooooo
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7gonk^kP00
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWImooVi^H0000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^00003OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7gooooo`0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOOoi^KV00003OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7gonk^kP0000goh>3PolS8b?nE
UIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>3olO7amoooool0000=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^00003Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:b_oIfMWgonKViP0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7alOOooooo00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN7gonk^kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
okFe]Oo:b/[ofMWImooVi^H0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7QhOOok^k^00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO7gooooo`0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Qmoo^k^h0000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:
b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIfOOoi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN7gonk^kP0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oa
lO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
moooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOo
k^k^00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Go
i^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWgonKV
iP0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^
kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0
000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool0
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOOooooo0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7gonk^kP0000go
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:
b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWImooVi^H0000=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^00003OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7gooooo`0000godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgRcogMgM00?oc<c<om_KfooMgMd00_oCdm<3
omgMg@03olg=cOo?cloogMgM01?ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]h/omgMg@03olc<c?oKfm_ogMgM00;odm?C0ooM
gMd00oo=cLgoclo?omgMg@0:omgMg@03omOGeonl_;co_kno00KogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
mooVi^H0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgR3ogMgM00?o
HV9Roc0`<?oMgMd00ooMgMd00olg=cOoKVi^omgMg@02omgMg@0EodI6A_l6
1PKo5QHFohN7Qol@413oBd];omgMgOo6a/Ko=cLgo`000?l?3`oo6ATIomKF
e_oMgMgo=cLgofi^K_oMgMgofMWIod92@_lW9bOoclo?00CogMgM00?oaLG5
o`000?o>c/h00ooMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgR3ogMgM00?oHV9Roc0`<?oMgMd00ooMgMd00olg=cOoKVi^omgM
g@02omgMg@0LodI6A_l61PKo5QHFohN7Qol@413oBd];omgMgOo6a/Ko=cLg
o`000?l?3`oo6ATIomKFe_oMgMgo=cLgofi^K_oMgMgofMWIod92@_lW9bOo
clo?omgMgOn0P83o6ATIobd];OlT92CoKVi^omcLg0?ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0
000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgR3ogMgM00?oHV9Roc0`
<?oMgMd00ooMgMd02_lg=cOoKVi^omgMgOoMgMgoZj^[o`<30ono_kooalO7
odi>C_l>3Ph2omgMg@0=ocTi>OlV9RKo[jn_omgMgOnk^k_ofm_KomgMgOlg
=cOoKVi^omcLg?mBDU;o71`LolO7a`05omgMg@03olG5aOl0003oc/k>00?o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]hPomgM
g@03of9RH_l`<33ogMgM00?ogMgM00[o=cLgofi^K_oMgMgogMgMoj^[Zol3
0`?o_knoolO7aom>CTko3Ph>0_oMgMd03Oli>CWo9RHVojn_[ooMgMgo^k^k
om_KfooMgMgo=cLgofi^K_oLg=coDU9Boa`L7?o7alL00_oMgMd01_oJf][o
gMgMomgMgOnf][Ko0@41ohJ6QP?ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7amoooool0000=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgR3ogMgM00?oHV9Roc0`<?oMgMd00ooMgMd0
3_lg=cOoKVi^omgMgOoMgMgo_;blo`820_nSXj?ogMgMohV9ROlK6a_ogMgM
okjn__l0003oPH611OoMgMd01Olg=cOoKVi^of=SHolC4a?o_Kfm00;ogMgM
00So`l?3oi6ATOnATI7oTI6Aoh:2P_l0003oR8R8olC4a0;ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]hPomgMg@03of9RH_l`
<33ogMgM00?ogMgM00ko=cLgofi^K_oMgMgogMgMokbl_?l20P;oXj>SomgM
gOn9RHWo6a/KomgMgOnn_[ko0000oh61P@GogMgM00Go=cLgofi^K_mSHf?o
4a<Cokfm_@07omgMg@03oc<c<omCDe?ogMgM00;ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgR3ogMgM00?oHV9Roc0`<?oM
gMd00ooMgMd00olg=cOoKVi^omgMg@02omgMg@09oiFEUOl[:b_o;2`/obh^
;_lK6a_ogMgMojBTY?l0003o/[:b00GogMgM00Co=cLgoc0`<?l0003oZJVY
0ooMgMd02?nPX:3o0@41od=3@om6ATKoA4A4o`000?m1@D7o[:b/0_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgR3ogMgM00?o
HV9Roc0`<?oMgMd00ooMgMd00olg=cOoKVi^omgMg@02omgMg@09oiFEUOl[
:b_o;2`/obh^;_lK6a_ogMgMojBTY?l0003o/[:b00GogMgM00Co=cLgoc0`
<?l0003oZJVY1ooMgMd00oo@d=3o3@d=ofUYJ@03omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOOoi^KV0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]hPomgMg@03of9RH_l`<33o
gMgM00?ogMgM00?o=cLgoe]KFooMgMd01?oMgMd01ooKfm_oP820oa`L7?oM
gMgo_Kfmo`000?mmOGd01OoMgMd01Olg=cOoKFe]odY:B_m5ADGofm_K00?o
gMgM00KoAdM7ofi^K_oMgMgof=SHo`000?o>c/h3omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN8?oMgMd00omRHV;o<30`omgM
g@03omgMg@03ocLg=omKFe_ogMgM00CogMgM00Oofm_Koh20P?lL71cogMgM
okfm_Ol0003oOGem00GogMgM00Go=cLgofe]KOm:BT[oADE5om_Kf`03omgM
g@06om?Cdonf][KoQhN7ochn?_l@413o`l?30ooMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7gonk^kP0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN8?oMgMd00omRHV;o<30`omgM
g@03omgMg@0:ocLg=ol@413oOGemolG5aOoKfm_oW9bLokbl_?oJf][oE5AD
odQ8B0;ogMgM00Go=SHfob4Q8OnTY:Cog=cLol30`002omgMg@05ocLg=om^
KVkoe]KFoc@d=?mQHF400ooMgMd01_o>c/ko71`LojJVY_oHf=So0000olk>
cP?ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]hP
omgMg@03of9RH_l`<33ogMgM00?ogMgM00[o=cLgoa0@4?mmOGgoaLG5om_K
fonLW9co_;blom[Jf_mDE5CoB4Q80_oMgMd01Olf=SKo8B4QojBTY?oLg=co
`<3000;ogMgM00Go=cLgofi^K_oFe]Ko=3@dof5QH@03omgMg@05oj>SXol6
1PKo>CTiof9RH_o4a<@01?oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7gooooo`0000godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kN8?oMgMd00omRHV;o<30`omgMg@03omgMg@0:odQ8
B?mfMWKoD51@o`L71oo@d=3oMgMgob/[:ol=3@go<C4aojVYZ@;ogMgM00Go
bLW9od];Bol=3@go2@T9ob0P8002omgMg@06ocLg=om^KVkogMgMolg=cOl]
;BgoTY:B0ooMgMd01OnYZJWo6QXJolK6a_l0003oc/k>00?ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]hPomgMg@03of9RH_l`
<33ogMgM00?ogMgM00[oB4Q8ogIfM_m@D53o1`L7om3@d?mgMgOo:b/[o`d=
3Ola<C7oZJVY0_oMgMd01Oo9bLWoBd];o`d=3Ol92@Wo820P00;ogMgM00Ko
=cLgofi^K_oMgMgocLg=obd];OnBTY82omgMg@03oj>SXolS8b?ogMgM00Ko
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Qmoo^k^h0000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgR3o
gMgM00?oHV9Roc0`<?oMgMd01_oMgMd01OoJf][ogMgMomgMgOoMgMgofm_K
00OogMgM00Kof][JomgMgOoMgMgogMgMocLg=om^KVh8omgMg@04og1`L?lk
>c_o0000olk>cP?ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]hPomgMg@03of9RH_l`<33ogMgM00KogMgM00Gof][JomgMgOoM
gMgogMgMom_Kf`07omgMg@06om[Jf_oMgMgogMgMomgMgOlg=cOoKVi^1_oM
gMd00onSXj?o8b<SomgMg@06omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOOoi^KV00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]hMomgMg@05ofMWIomGEeOoEeMGobLW9olC4a<0
0omGEeL00oo>c/kogMgMomgMg@0AomgMg@03ocLg=om^KVkogMgM00OogMgM
00Cofm_KocLg=ol0003oc/k>0ooMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgQgogMgM00GoIfMWoeMGEomGEeOo9bLWoa<C4`03
oeMGE`03olk>c_oMgMgogMgM017ogMgM00?o=cLgofi^K_oMgMd01OoMgMd0
0onSXj?o2PX:od92@P02od92@P04oi2@T?oMgMgogMgMomgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]hMomgMg@03ohn?Son5
QHGoQHF500GoQHF500?odm?ComgMgOoMgMd04OoMgMd00olg=cOoKVi^omgM
g@08omgMg@03olO7aon5QHGoemOG00?ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]hMomgMg@03ohn?Son5QHGoQHF500GoQHF5
00?odm?ComgMgOoMgMd04OoMgMd00olg=cOoKVi^omgMg@05omgMg@03olK6
a_n5QHGoQHF500;oQHF500Co/[:bomgMgOoMgMgogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7amoooool0000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgSWogMgM00?ofMWIom_KfooM
gMd03_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gSWogMgM00?ofMWIom_KfooMgMd03_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7gonk^kP0000gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWImooVi^H0000=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^00003OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7gooooo`0000godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:omWIfOOoi^KV00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN7gonk^kP0000goh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
XJ6QolS8b?oPh>3olO7amoooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7QhOOok^k^00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:b_oIfMWgonKViP0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Qmoo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3Poo7alOOooooo00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oM
gMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN7gonk^kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oM
gMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[o
fMWImooVi^H0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
hOOok^k^00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7a
l@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7g
ooooo`0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45
onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^
k^h0000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoV
i^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOOoi^KV
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7gonk^kP00
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7amoooool0000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWgonKViP0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOOooooo00003OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7gonk^kP0000gob/[:okFe]OnD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2PokFe]Oo:b/[ofMWImooVi^H0000=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^00003OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nQXJ7ob<S8on3Ph?oalO7gooooo`0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?ne]KGob/[:omWIfOOoi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN7gonk^kP0000goh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6Q
olS8b?oPh>3olO7amoooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7QhOOok^k^00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMWgonKViP0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Qmoo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7alOOooooo00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN7gonk^kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
mooVi^H0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOo
k^k^00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Go
oooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7goooo
o`0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^
kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0
000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H0
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOOoi^KV0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7gonk^kP0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7amoooool0000=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^00003Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWgonKViP0000godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOOooooo00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7gonk^kP0000gob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2PokFe]Oo:b/[ofMWImooVi^H0000=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^00003OoPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO7gooooo`0000godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=ol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIfOOoi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN7gonk^kP0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7o
b<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>3olO7amoooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7QhOOok^k^00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oM
gMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
b_oIfMWgonKViP0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oM
gMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Qmoo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3o
lO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7a
lOOooooo00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7g
onk^kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5
onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWImooV
i^H0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7gooooo`00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOOoi^KV00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7gonk^kP0000goh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7amoooool0000=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOOok^k^00003Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWgonKViP0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qmoo^k^h0000=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOOooooo00003OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN7gonk^kP0000gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/[ofMWImooVi^H0000=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7QhOOok^k^00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph?oalO7gooooo`0000god=3@okRh^?nLW9co[:b/ok^k^oo6
a/KocLg=om?CdooGemOofm_KomoOgooQhN7oh^;R00;ohn?S1ooUiND2onKV
iPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGU
i@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKV
iPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGU
i@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKV
iPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGU
i@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H2onCTi0;ohn?S00goh^;Ron3P
h?oLg=cofMWIomKFe_o@d=3obLW9ol71`One]KGoYJFUokRh^?o@d=3oh>3P
00Gok^k^00god=3@okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooGemOo
fm_KomoOgooQhN7oh^;R00;ohn?S1ooUiND2onKViPKoiNGU0_oVi^H6onGU
i@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKV
iPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGU
i@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKV
iPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGU
i@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKV
iPKoiNGU0_oVi^H2onCTi0;ohn?S00goh^;Ron3Ph?oLg=cofMWIomKFe_o@
d=3obLW9ol71`One]KGoYJFUokRh^?o@d=3oh>3P0?Ook^k^00003Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`2omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03
omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]ko
gMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03
omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]ko
gMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03
omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h3omgMg@04omkNg_oMgMgogMgMomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL0_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd01?oNg]kogMgMomgMgOoM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:b_oIfMWgonKViP0000goe=CDokno_on<S8coWYjN
ojf][Oni^KWo`/;2olO7aoo<c<cod=3@om;Bd_oEeMGoe]KF00;oemOG00?o
f=SHomWIfOoIfMT0c_oIfMT2omSHf0;oemOG00goeMGEom?Cdoo@d=3oc/k>
ol[:b_o5aLGo_knookFe]OnYZJWoV9RHokno_ooDe=Coh^;R00Gok^k^00go
e=CDokno_on<S8coWYjNojf][Oni^KWo`/;2olO7aoo<c<cod=3@om;Bd_oE
eMGoe]KF00;oemOG00?of=SHomWIfOoIfMT0c_oIfMT2omSHf0;oemOG00go
eMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo_knookFe]OnYZJWoV9RHokno_ooD
e=Coh^;R0?Ook^k^00003OoXj>Soe=CDohb<S?nCTi?oXZ:Rojn_[onj^[[o
`L71olO7aoo;bl_oc/k>om3@d?oAdM400_oCdm<3omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGE
eOoFe]KoeMGD0_oDe=@2omGEe@06omKFe_oEeMGoe]KFomGEe?oEeMGoe=CD
0_oCdm<03OoAdM7od=3@olg=cOo:b/[o`l?3okjn__nf][KoZj^[oifMWOnE
UIGoe=CDonSXj?oclo<01Oooool03OoXj>Soe=CDohb<S?nCTi?oXZ:Rojn_
[onj^[[o`L71olO7aoo;bl_oc/k>om3@d?oAdM400_oCdm<3omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@06omKFe_oEeMGoe]KFomGEe?oE
eMGoe=CD0_oCdm<03OoAdM7od=3@olg=cOo:b/[o`l?3okjn__nf][KoZj^[
oifMWOnEUIGoe=CDonSXj?oclo<0moooool0000BomgMgOo=cLgoT92@ohV9
ROnGUiOoYJFUok:b/_no_koobl_;om7AdOoEeMGoemOGomWIfOoJf][ofm_K
om[Jf_oKfm_og=cL1ooKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oK
fm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_K
f`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o
g=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oK
fm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_K
f`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o
g=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oK
fm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_K
f`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoK
fm/00ooLg=cofm_Kom_Kf`06om_Kf`0?om[Jf_oIfMWof=SHomKFe_oCdm?o
cLg=ol;2`_nf][Ko[:b/oinOWon@T93oUYJFolg=cOoMgMgoiNGU00Gok^k^
01;ogMgMolg=cOn@T93oRHV9oiNGUonUYJGo/[:bokno_oo;bl_odM7AomGE
eOoGemOofMWIom[Jf_oKfm_of][Jom_KfooLg=`7om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Kofm_K00oof][J
omWIfOoHf=Soe]KFom?Cdoo=cLgo`/;2okJf]_n/[:coWinOoi2@T?nFUYKo
cLg=omgMgOoUiND0moo^k^h0000;om[Jf_o>c/koW9bLogYjN_n8R8SoUYJF
ojZZZ_o4a<CoeMGEom_KfooNg]h00_oPh>03on;RhP03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?S
h`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooT
i>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?S
hooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?S
h`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooT
i>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?S
hooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?S
h`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooT
i>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?S
hooShn<01_oShn<2on;RhP0>on7QhOoPh>3ogmoOomcLg?oGemOoaLG5ojb/
[?nNWYkoT92@oh:2P_nPX:3oc/k>om[Jf_oPh>05onKViP0;om[Jf_o>c/ko
W9bLogYjN_n8R8SoUYJFojZZZ_o4a<CoeMGEom_KfooNg]h00_oPh>03on;R
hP03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooT
i>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?S
hooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?S
h`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooT
i>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?S
hooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?S
h`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooT
i>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?S
hooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<01_oShn<2on;RhP0>on7QhOoPh>3ogmoO
omcLg?oGemOoaLG5ojb/[?nNWYkoT92@oh:2P_nPX:3oc/k>om[Jf_oPh>3g
onKViP0000koiNGUomgMgOo2`/;oNg]kogQhN?n6QXKoWinOolG5aOoHf=So
gMgMomoOgooQhN7oh^;Ron?Sh`?oi>CT1?oUiND2onCTi003onGUiOoTi>Co
iNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGU
onCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@0
0ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2
onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03
onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>Co
iNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGU
onCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@0
0ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2
onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03
onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>Co
iNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGU
onCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@0
0ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2
onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@04_oUiNGoi>CTonCTi?oT
i>Cohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4ol?3
`ooMgMgoiNGUon[ZjPGok^k^00koiNGUomgMgOo2`/;oNg]kogQhN?n6QXKo
WinOolG5aOoHf=SogMgMomoOgooQhN7oh^;Ron?Sh`?oi>CT1?oUiND2onCT
i003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGU
i@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU
00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCT
i?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooU
iNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCT
i003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGU
i@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU
00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCT
i?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooU
iNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCT
i003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGU
i@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU
00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCT
i?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@04_oU
iNGoi>CTonCTi?oTi>Cohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=
SOn0P83oQ8B4ol?3`ooMgMgoiNGUon[Zj_Ook^k^00002ooinOWolo?conWY
jOnXZ:SoIFEUog=cLon=SHgo^k^komCDe?oJf][ogMgM00;ogmoO00?oh>3P
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00?ohN7Q00koh>3P
omoOgooMgMgog=cLomGEeOni^KWoSXj>og]kNom^KVkoZj^[onWYjOoclo?o
nOWioogmo@Gooooo00_onOWioo?clooYjNWoZ:RXofEUIOmcLg?oSHf=ok^k
^ooDe=Cof][JomgMg@02omoOg`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@03on7Qh@0>on3Ph?oOgmoogMgMomcLg?oEeMGo^KVi
ohj>S_mkNg_oKVi^oj^[ZooYjNWolo?cooWinOomoOggooooo`0000cojn_[
onSXj?oRh^;oemOGohf=SOmRHV;oMWIfojBTY?o7alOod];BomGEeOoHf=P2
om[JfP?ofm_K1ooLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg00Aom_KfooLg=cofm_Kom[Jf_oIfMWof=SH
om?Cdoo5aLGoW9bLogEeMOmWIfOoT92@omOGeooRh^;oj>SXon_[joo]kNd0
1Oo^k^h03?o[jn_oj>SXon;Rh_oGemOoSHf=of9RH_mfMWKoY:BTolO7aooB
d];oeMGEomSHf0;of][J0ooKfm/7omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL017ofm_KomcLg?oKfm_o
f][JomWIfOoHf=Sodm?ColG5aOnLW9coMGEeofMWIon@T93oemOGon;Rh_oX
j>Sojn_[ong]k@3gonk^kP0000koiNGUon;Rh_oOgmoof][JolW9bOn7QhOo
FUYJog]kNonSXj?o_;blolK6a_o;bl_ocLg=olo?c`;odM7A1OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00;odM7A00god=3@olo?coo<c<cob<S8ok^k^onL
W9coLW9boe]KFon:RX[obLW9om[Jf_oOgmooh^;R00;oiNGU1OoVi^H03_oU
iNGoh^;RomoOgooJf][obLW9ohN7QomJFU[oNg]koj>SXonl_;coa/K6ol_;
boo=cLgoclo?0_oAdM45om;BdP03om7AdOoBd];odM7A00God];B00?odM7A
om;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];o
dM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05
om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]80
0ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7A
om;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];o
dM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05
om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]80
0ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7A
om;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];o
dM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05
om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM400_oAdM40
3Oo@d=3oclo?olc<c?o8b<So^k^koibLW?mbLW;oFe]KohZ:R_o9bLWof][J
omoOgooRh^800_oUiNGgonKViP000_o]kNd03_oZj^[oj>SXon;Rh_oLg=co
W9bLofe]KOmXJ6SoPh>3oiNGUonSXj?o[:b/ojn_[ona/K7o/[:b0_nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]00@okFe]Onf][Co
/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9RH_m^KVkoWinOomcLg?oR
h^;oj>SXon[ZjP;okNg]1_o^k^h2ong]k@0>on[Zj_oXj>Soh^;RomcLg?nL
W9coKFe]ofQXJ?n3Ph?oUiNGoj>SXon/[:co[jn_ok6a/Onb/[82okBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd013o]KFeokJf]?nc
/k?o/[:bok>c/on_[jooZZZZoibLW?n2PX;oHV9Rofi^K_nOWioog=cLon;R
h_oXj>Soj^[Z0_o]kNghonk^kP0001;oooooookno_ono_koo?clooWinOof
m_Kol_;bomWIfOnXZ:SoPh>3ofi^K_mUIFGoJFUYog9bL_mdM7CoNGUiogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01?mlO7coNg]kogalO?mmOG`2ogYjNP0;
ogMgMomdM7CoKfm_ogAdM?n5QHGoZ:RXom[Jf_obl_;om_KfooWinOolo?`0
0_ono_h8ooooo`;oo_kn00ooo?clooWinOofm_Kol_;bomWIfOnXZ:SoPh>3
ofi^K_mUIFGoJFUYog9bL_mdM7CoNGUiogalO?mkNg/00_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00CoO7alog]kNomlO7coOGel0_mjNWX02omgMgOoM7Adofm_KomdM7Co
QHF5ojRXZ?oJf][ol_;booKfm_oinOWoo?cl00;oo_knnOooool000;ok^k^
0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;RhP03on3Ph?oOgmoog]kN0=Ko
gMgM00?og]kNomoOgooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/k>`2ong]
k@[ok^k^0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;RhP03on3Ph?oOgmoo
g]kN0=KogMgM00?og]kNomoOgooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/
k>`2ong]kO[ok^k^0004onKViP;oiNGU00?oi>CTon;Rh_oRh^800_oPh>02
omoOgmKog]kN0_oOgml2on3Ph0;oh^;R00?oi>CTonGUiOoUiND03_oVi^H2
onGUi@03onCTi?oRh^;oh^;R00;oh>3P0_oOgmoFomkNgP;ogmoO0_oPh>02
on;RhP03onCTi?oUiNGoiNGU0?coi^KV003oonk^k_ook^k^h?o^k^h00?oo
oooooooooooPooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oV
i^H00?ook^k^ooo^k^kPonk^kP0000goooooookno_ono_koo?clooWinOof
m_Kol_;bong]kOoXj>Sohn?Son3Ph?oMgMgofm_K00;of][Jd_oIfMT2om[J
fP0:om_KfooMgMgoh>3Pon?ShooXj>SokNg]oo;bl_ofm_KonOWiooclo0;o
o_kn2?ooool2ooknoP0:ooclo?oinOWom_Kfoo;bl_o]kNgoj>SXon?ShooP
h>3ogMgMom_Kf`;of][Jd_oIfMT2om[JfP0:om_KfooMgMgoh>3Pon?ShooX
j>SokNg]oo;bl_ofm_KonOWiooclo0;oo_kn2?ooool2ooknoP0:ooclo?oi
nOWom_Kfoo;bl_o]kNgoj>SXon?ShooPh>3ogMgMom_Kf`;of][Jd_oIfMT2
om[JfP0:om_KfooMgMgoh>3Pon?ShooXj>SokNg]oo;bl_ofm_KonOWioocl
o0;oo_kn0oooool000;okNg]00[oj^[ZonSXj?oRh^;ogMgMomKFe_o=cLgo
a/K6okjn__nj^[[o][Jf1?nc/k?@ok:b/PCo/k>c00[o][JfokZj^_nn_[ko
a/K6olg=cOoFe]KogMgMon;Rh_oXj>Soj^[Z0_o]kNd6onk^kP;okNg]00[o
j^[ZonSXj?oRh^;ogMgMomKFe_o=cLgoa/K6okjn__nj^[[o][Jf1?nc/k?@
ok:b/PCo/k>c00[o][JfokZj^_nn_[koa/K6olg=cOoFe]KogMgMon;Rh_oX
j>Soj^[Z0_o]kNd6onk^kP;okNg]00[oj^[ZonSXj?oRh^;ogMgMomKFe_o=
cLgoa/K6okjn__nj^[[o][Jf1?nc/k?@ok:b/PCo/k>c00[o][JfokZj^_nn
_[koa/K6olg=cOoFe]KogMgMon;Rh_oXj>Soj^[Z0_o]kNd2onk^kP0000ko
iNGUon;Rh_oOgmoof][Jom;Bd_o7alOo_Kfmok:b/_nXZ:SoX:2Poi^KVonH
V9SoU9BDoi>CTmCoTY:B00goTi>CoiBDU?nHV9SoVi^Koj2PX?nXZ:So/[:b
okfm_Oo7alOod];Bom[Jf_oOgmooh^;R00;oiNGU1OoVi^H03_oUiNGoh^;R
omoOgooJf][od];BolO7aonm_Kgo/[:bojRXZ?nPX:3oVi^KoiRHV?nDU9Co
Ti>Ce?nBTY803OnCTi?oU9BDoiRHV?nKVi_oX:2PojRXZ?nb/[;o_KfmolO7
aooBd];of][JomoOgooRh^800_oUiND5onKViP0>onGUiOoRh^;ogmoOom[J
f_oBd];oalO7okfm_Onb/[;oZ:RXoj2PX?nKVi_oV9RHoiBDU?nCTi?Doi:B
TP0=oi>CTonDU9CoV9RHoi^KVonPX:3oZ:RXok:b/_nm_KgoalO7om;Bd_oJ
f][ogmoOon;RhP02onGUi@7oi^KV00003_o[jn_oj>SXon;Rh_oHf=Sobl_;
okjn__n^[ZkoXJ6QoiFEUOn<S8coQHF5oh:2P_moOgooOWine?mmOGd03omn
OWkoOgmooh:2P_n5QHGoS8b<oiFEUOnQXJ7o[Zj^okjn__o;bl_of=SHon;R
h_oXj>Sojn_[ong]k@05onk^kP0>on_[jooXj>Soh^;RomSHf?o;bl_o_[jn
ojj^[_nQXJ7oUIFEohb<S?n5QHGoPX:2ogmoOomnOWkDogemO@0?oginO_mo
OgooPX:2ohF5QOn<S8coUIFEoj6QXOn^[Zko_[jnol_;booHf=Soh^;RonSX
j?o[jn_okNg]00Gok^k^00kojn_[onSXj?oRh^;of=SHol_;bonn_[ko[Zj^
oj6QXOnEUIGoS8b<ohF5QOn2PX;oOgmooginO]CoOGem00ooOWinogmoOon2
PX;oQHF5ohb<S?nEUIGoXJ6Qojj^[_nn_[kobl_;omSHf?oRh^;oj>SXon_[
joo]kNd00Oo^k^h0000DooWinOoclo?ojNWYomWIfOo7alOo];Bdoj:RX_nJ
VY[oZZZZol?3`ooIfMWok>c/ooKfm_ogmoOonOWiooShn?oinOWon_[jooWi
nOogmoL3ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[j
n_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi
00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh
0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL0
0oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWi
ooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[j
n_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi
00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh
0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL0
0oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWi
ooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[j
n_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi
00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh
0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL0
0oohn?P04_oinOWon?ShooWinOohn?SomoOgonk^k_oJf][oa<C4ojZZZ_nJ
VY[oXZ:RokBd]?o7alOofMWIonWYjOoclo?onOWioogmo@Gooooo01ConOWi
oo?clooYjNWofMWIolO7aond];CoXZ:RoiZJV_nZZZ[o`l?3omWIfOo/k>co
m_KfooOgmooinOWon?ShooWinOojn_[onOWiooOgm`?on?Sh0_oinOT00ooj
n_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWi
n@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooSh
n0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg
00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWi
nOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00ooj
n_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWi
n@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooSh
n0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg
00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWi
nOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00ooj
n_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWi
n@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooSh
n0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg
00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn00BooWinOohn?SonOWi
ooShn?ogmoOok^k^om[Jf_o4a<CoZZZZoiZJV_nRXZ;o];BdolO7aooIfMWo
jNWYoo?clooinOWooOgm1Oooool05?oinOWolo?conWYjOoIfMWoalO7okBd
]?nRXZ;oVYZJojZZZ_o3`l?ofMWIonc/k?ofm_KomoOgooWinOohn?SonOWi
oo[jn_oinOWomoOg0oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oi
nOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?o
n_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oi
nOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?o
n_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oi
nOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh01;onOWiooShn?oinOWon?ShooOgmoo^k^kof][JolC4
a?nZZZ[oVYZJoj:RX_nd];CoalO7omWIfOoYjNWolo?cooWinOomoOd1oooo
o`0000coiNGUomgMgOo>c/ko_KfmojRXZ?nEUIGoYJFUolc<c?o^k^kom_Kf
ooclo?ono_kHooooo`0=ookno_olo?comoOgono_koo=cLgoYZJVoiFEUOnX
Z:So_Kfmolk>c_oMgMgoiNGUon[ZjP05onk^kP0<onGUiOoMgMgoc/k>okfm
_OnXZ:SoUIFEojFUYOo<c<cok^k^ooKfm_olo?coo_knf?ooool03Oono_ko
o?clooOgmoo_knoocLg=ojJVY_nEUIGoZ:RXokfm_Oo>c/kogMgMonGUiOoZ
j^X01Oo^k^h03?oUiNGogMgMolk>c_nm_KgoZ:RXoiFEUOnUYJGoc<c<onk^
k_ofm_Koo?clookno]Sooooo00goo_knooclo?ogmoOokno_olg=cOnVYZKo
UIFEojRXZ?nm_Kgoc/k>omgMgOoUiNGoj^[Z007ok^k^00002_oJf][oc/k>
okfm_OnXZ:SoUYJFoj^[ZooNg]kojn_[ooCdm?okno_Looooo`0;oo_knooc
lo?ok>c/on7QhOn^[ZkoUYJFojRXZ?nm_Kgoc/k>om[Jf_oPh>001OoVi^H0
2_oJf][oc/k>okfm_OnXZ:SoUYJFoj^[ZooNg]kojn_[ooCdm?okno_Loooo
o`0;oo_knooclo?ok>c/on7QhOn^[ZkoUYJFojRXZ?nm_Kgoc/k>om[Jf_oP
h>001OoVi^H02_oJf][oc/k>okfm_OnXZ:SoUYJFoj^[ZooNg]kojn_[ooCd
m?okno_Looooo`0;oo_knooclo?ok>c/on7QhOn^[ZkoUYJFojRXZ?nm_Kgo
c/k>om[Jf_oPh>000OoVi^H0000:omgMgOo=cLgo^;Rhoj6QXOnXZ:Soe=CD
on3Ph?o/k>comOGeoogmoMcooooo00_oo_knooKfm_o/k>coh^;RomWIfOn/
[:coXJ6QokRh^?o=cLgogMgMonGUi@05onk^kP0:omgMgOo=cLgo^;Rhoj6Q
XOnXZ:Soe=CDon3Ph?o/k>comOGeoogmoMcooooo00_oo_knooKfm_o/k>co
h^;RomWIfOn/[:coXJ6QokRh^?o=cLgogMgMonGUi@05onk^kP0:omgMgOo=
cLgo^;Rhoj6QXOnXZ:Soe=CDon3Ph?o/k>comOGeoogmoMcooooo00_oo_kn
ooKfm_o/k>coh^;RomWIfOn/[:coXJ6QokRh^?o=cLgogMgMonGUi@01onk^
kP0000_oj>SXomCDe?nj^[[oZJVYolK6a_oDe=Coh>3Ponc/k?obl_;oo?cl
ooknoP3Kooooo`0;oo[jn_odm?Coj^[Zon?ShooGemOocLg=ojb/[?nj^[[o
e=CDonSXj?oclo<01Oooool02ooXj>Soe=CDokZj^_nYZJWoa/K6omCDe?oP
h>3ok>c/oo;bl_olo?coo_kn0=_ooooo00_on_[jooCdm?oZj^[ohn?SomOG
eoo=cLgo[:b/okZj^_oDe=Coj>SXoo?cl`05ooooo`0;onSXj?oDe=Co^[Zj
ojVYZOo6a/Koe=CDon3Ph?o/k>col_;booclo?ono_h0foooool02oojn_[o
m?Cdon[Zj_oShn?oemOGolg=cOn/[:co^[ZjomCDe?oXj>Solo?c007ooooo
00003ooDe=Co_knoojJVY_n/[:coa/K6om;Bd_oLg=coi^KVonc/k?oemOGo
n?Shoo[jn_omoOgoooooooclo008ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo01;ooOgmooooooomoOgo
oooooogmoOokno_on?ShooCdm?o]kNgoi^KVomoOgooFe]Koc<c<ok:b/_nW
YjOo_knoomCDe?oRh^85onk^kP0?omCDe?no_kooYZJVojb/[?o6a/Kod];B
omcLg?oVi^Kok>c/ooGemOohn?Son_[joogmoOooooooo?cl00Sooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool04_omoOgooooooogmoOoooooooOgmoo_knoohn?Som?Cdong]kOoVi^Ko
gmoOomKFe_o<c<co/[:bojNWYono_kooe=CDon;RhPGok^k^00ooe=CDokno
_onVYZKo[:b/olK6a_oBd];og=cLonKVi_o/k>comOGeooShn?ojn_[ooOgm
ooooooolo?`02?ooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooo
oooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05
ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool0
0oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgm
ooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooo
oooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05
ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool0
0oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgm
ooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooo
oooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05
ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool0
0oomoOgoooooooooo`05ooooo`0BoogmoOoooooooOgmooooooomoOgono_k
ooShn?odm?CokNg]onKVi_oOgmooe]KFolc<c?nb/[;oYjNWokno_ooDe=Co
h^;R0Oo^k^h0000Col[:b_ne]KGoWYjNokJf]_o3`l?oclo?omKFe_oOgmoo
i^KVon[Zj_o_knoolo?cooCdm?oemOGomoOgooKfm_ogmoOom_KfooShn002
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP0BooOgmoofm_Ko
moOgooKfm_odm?Col_;boo3`l?o[jn_oi^KVon7QhOoJf][odm?ColW9bOno
_kooXj>SokFe]Oo:b/[ofMWI1OoVi^H04oo:b/[o]KFeoijNW_nf][Ko`l?3
olo?cooFe]KogmoOonKVi_oZj^[okno_oo?cloodm?ComOGeooOgmoofm_Ko
moOgooKfm_ohn?P00_ogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H04_ogmoOom_KfooOgmoofm_Kom?Cdoo;bl_o`l?3ojn_[onKVi_oQhN7o
f][Jom?Cdoo9bLWo_knooj>SXone]KGob/[:omWIf@Goi^KV01?ob/[:okFe
]OnNWYko][Jfol?3`oo?clooe]KFomoOgooVi^Koj^[Zono_kooclo?om?Cd
ooGemOogmoOom_KfooOgmoofm_Kon?Sh00;omoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_Kf
ooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf01;omoOgooKfm_ogmoOom_KfooCdm?obl_;ol?3`
on_[jooVi^KohN7Qom[Jf_oCdm?obLW9okno_onSXj?o]KFeol[:b_oIfMT1
onKViP0000_od=3@okRh^?nPX:3o/k>col30`?o9bLWodm?ComWIfOoMgMgo
h^;RonGUi@02on[ZjP03onc/k?o]kNgokNg]00Ook^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
kNg]ong]k@02onc/k00=onWYjOoVi^Kohn?Son3Ph?oKfm_oeMGEolg=cOo5
aLGo^k^kojNWYonh^;Sod=3@on3Ph005onk^kP0;om3@d?nh^;SoX:2Pok>c
/oo0`<3obLW9om?CdooIfMWogMgMon;Rh_oUiND00_oZj^X00oo/k>cokNg]
ong]k@07onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`ong]kOo]kNd00_o/k>`03OoYjNWoi^KV
on?ShooPh>3ofm_KomGEeOo=cLgoaLG5ok^k^onWYjOo^;Rhom3@d?oPh>00
1Oo^k^h02oo@d=3o^;Rhoj2PX?nc/k?o`<30olW9bOoCdm?ofMWIomgMgOoR
h^;oiNGU00;oj^[Z00?ok>c/ong]kOo]kNd01oo^k^h00oo`l?3ok^k^onk^
kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^
k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?o
l?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^
k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^
kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^
k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?o
l?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^
k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^
kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^
k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?o
l?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o]
kNgokNg]00;ok>c/00gojNWYonKVi_oShn?oh>3Pom_KfooEeMGocLg=olG5
aOnk^k_oYjNWokRh^?o@d=3oh>3P007ok^k^00003OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a0Oooool0000=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN41onk^kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
okFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIf@7oi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q0Oo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oa
lO41ooooo`0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7o
k^k^00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Go
i^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKV
iP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0OoVi^H0
000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h0
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP0000godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003OoPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
XJ6QolS8b?oPh>3olO7a0Oooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN41onk^kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:omWIf@7oi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oM
gMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q0Oo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3o
lO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7a
l@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41
ooooo`0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45
onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^
00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0OoVi^H0000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000goh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00003OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=ol[:b_ne]KGoU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6Q
olS8b?oPh>3olO7a0Oooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:
b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@7oi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
0Oo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Go
oooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41oooo
o`0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^
kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h0
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0000
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00go
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:
b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0OoVi^H0000=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMT1onKViP0000godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@7ok^k^00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7o
b<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>3olO7a0Oooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oM
gMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN41onk^kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oM
gMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[o
fMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@7oi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45
onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^
k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Ooo
ool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0OoVi^H0000=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000goh>3PolS8b?nE
UIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00003OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o]KFeol[:b_oIfMT1onKViP0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@7ok^k^00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>3olO7a0Oooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN41onk^kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7o
i^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Go
k^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^
kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0
000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool0
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`0000go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0OoVi^H0000=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=ol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:b_oIfMT1onKViP0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@7ok^k^00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oM
gMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3P
h?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3o
lO7a0Oooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41
onk^kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5
onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoV
i^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0OoVi^H0000=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@7ooooo00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q0Oo^k^h0000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
okFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT1onKViP0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@7ok^k^00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oa
lO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
0Oooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Go
k^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^
kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKV
iP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H0
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`0000godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]h/omgMg@03olc<c?oKfm_ogMgM00;odm?C0ooM
gMd00oo=cLgoclo?omgMg@0ComgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kN;?oMgMd00oo<c<cofm_KomgMg@02om?Cd`?ogMgM
00?ocLg=olo?cooMgMd04ooMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgRcogMgM00?oc<c<om_KfooMgMd00_oCdm<3omgMg@03
olg=cOo?cloogMgM00_ogMgM00?obLW9okJf]_oKfm/01OoMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKV
iP0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN8?oMgMd00omRHV;o
<30`omgMg@03omgMg@03ocLg=om^KVkogMgM00;ogMgM01coATI6o`H61_lF
5QKoQhN7oa0@4?m;Bd_ogMgMolK6a_lg=cOo0000o`l?3olI6AWoe]KFomgM
gOlg=cOoKVi^omgMgOoIfMWo@T92obLW9oo?cloogMgMomCDe?l=3@go2PX:
o`000?l<30co4a<C0ooMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgR3ogMgM00?oHV9Roc0`<?oMgMd00ooMgMd00olg=cOoKVi^
omgMg@02omgMg@0GodI6A_l61PKo5QHFohN7Qol@413oBd];omgMgOo6a/Ko
=cLgo`000?l?3`oo6ATIomKFe_oMgMgo=cLgofi^K_oMgMgofMWIod92@_lW
9bOoclo?omgMgOlA4A401?l000001?m8B4SogMgMomgMgOoMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^
kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgR3ogMgM00?oHV9Roc0`
<?oMgMd00ooMgMd00olg=cOoKVi^omgMg@02omgMg@0LodI6A_l61PKo5QHF
ohN7Qol@413oBd];omgMgOo6a/Ko=cLgo`000?l?3`oo6ATIomKFe_oMgMgo
=cLgofi^K_oMgMgofMWIod92@_lW9bOoclo?omgMgOm:BT[o3Ph>obl_;olE
5AGoEUIFom7Ad@?ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgR3ogMgM00?oHV9Roc0`<?oMgMd00ooMgMd02_lg=cOoKVi^
omgMgOoMgMgoZj^[o`<30ono_kooalO7odi>C_l>3Ph2omgMg@0=ocTi>OlV
9RKo[jn_omgMgOnk^k_ofm_KomgMgOlg=cOoKVi^omcLg?mBDU;o71`LolO7
a`04omgMg@03okRh^?l0003obLW900CogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]hPomgMg@03of9RH_l`<33ogMgM00?ogMgM
00[o=cLgofi^K_oMgMgogMgMoj^[Zol30`?o_knoolO7aom>CTko3Ph>0_oM
gMd03Oli>CWo9RHVojn_[ooMgMgo^k^kom_KfooMgMgo=cLgofi^K_oLg=co
DU9Boa`L7?o7alL00_oMgMd00om8B4So9bLWolO7a`02olO7a`04olo?cooM
gMgogMgMomgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kN8?oMgMd00omRHV;o<30`omgMg@03omgMg@0:ocLg=om^KVkogMgMomgM
gOn[Zj_o0`<3okno_oo7alOoCTi>o`h>3P;ogMgM00go>CTiobHV9_n_[joo
gMgMok^k^ooKfm_ogMgMocLg=om^KVkog=cLoe9BD_lL71coalO700;ogMgM
00Koa/K6om_KfooMgMgoaLG5o``<3?mTI6@3omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]hPomgMg@03of9RH_l`<33ogMgM
00?ogMgM00ko=cLgofi^K_oMgMgogMgMokbl_?l20P;oXj>SomgMgOn9RHWo
6a/KomgMgOnn_[ko0000oh61P@GogMgM00Go=cLgofi^K_mSHf?o4a<Cokfm
_@05omgMg@03okRh^?l0003obLW900CogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]hPomgMg@03of9RH_l`<33ogMgM00?ogMgM
00ko=cLgofi^K_oMgMgogMgMokbl_?l20P;oXj>SomgMgOn9RHWo6a/KomgM
gOnn_[ko0000oh61P@GogMgM00Go=cLgofi^K_mSHf?o4a<Cokfm_@03omgM
g@03olK6a_lF5QKoS8b<00KogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]hPomgMg@03of9RH_l`<33ogMgM00?ogMgM00ko=cLg
ofi^K_oMgMgogMgMokbl_?l20P;oXj>SomgMgOn9RHWo6a/KomgMgOnn_[ko
0000oh61P@GogMgM00Go=cLgofi^K_mSHf?o4a<Cokfm_@07omgMg@03ode=
COlj>S[ogMgM00;ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgR3ogMgM00?oHV9Roc0`<?oMgMd00ooMgMd00olg=cOoKVi^
omgMg@02omgMg@09oiFEUOl[:b_o;2`/obh^;_lK6a_ogMgMojBTY?l0003o
/[:b00GogMgM00Co=cLgoc0`<?l0003oZJVY1_oMgMd00onh^;So0000olW9
b@04omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
8?oMgMd00omRHV;o<30`omgMg@03omgMg@03ocLg=om^KVkogMgM00;ogMgM
00WoUIFEob/[:ol/;2co;Rh^oa/K6ooMgMgoY:BTo`000?nb/[801OoMgMd0
1?lg=cOo<30`o`000?nYZJT5omgMg@03okZj^_lF5QKoTi>C00GogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]hPomgMg@03of9R
H_l`<33ogMgM00?ogMgM00?o=cLgofi^K_oMgMd00_oMgMd02OnEUIGo:b/[
ob`/;?l^;Rko6a/KomgMgOnTY:Co0000ok:b/P05omgMg@04ocLg=ol`<33o
0000ojVYZ@OogMgM00?odm?Coa0@4?mcLg<00ooMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP0000go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN8?oMgMd00omRHV;o<30`omgM
g@03omgMg@03ocLg=omKFe_ogMgM00CogMgM00Oofm_Koh20P?lL71cogMgM
okfm_Ol0003oOGem00GogMgM00Go=cLgofe]KOm:BT[oADE5om_Kf`05omgM
g@03okRh^?l0003obLW900CogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]hPomgMg@03of9RH_l`<33ogMgM00?ogMgM00?o=cLg
oe]KFooMgMd01?oMgMd01ooKfm_oP820oa`L7?oMgMgo_Kfmo`000?mmOGd0
1OoMgMd01Olg=cOoKFe]odY:B_m5ADGofm_K00GogMgM00?o_;bloaLG5on@
T9001?oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gR3ogMgM00?oHV9Roc0`<?oMgMd00ooMgMd00olg=cOoFe]KomgMg@04omgM
g@07om_Kfon0P83o71`LomgMgOnm_Kgo0000ogemO@05omgMg@05ocLg=om]
KFgoBTY:odE5AOoKfm/01?oMgMd01On<S8coDE5Aob0P8?mKFe_oc/k>00?o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q0Oo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgR3o
gMgM00?oHV9Roc0`<?oMgMd00ooMgMd02_lg=cOo410@ogemOOo5aLGofm_K
oibLW?nl_;cof][JoeADE?m8B4P2omgMg@05ocHf=_lQ8B7oY:BTomcLg?o0
`<000_oMgMd01Olg=cOoKVi^omKFe_ld=3CoHF5Q00GogMgM00?o^;Rho`00
0?o9bLT01?oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgR3ogMgM00?oHV9Roc0`<?oMgMd00ooMgMd02_lg=cOo410@ogemOOo5
aLGofm_KoibLW?nl_;cof][JoeADE?m8B4P2omgMg@05ocHf=_lQ8B7oY:BT
omcLg?o0`<000_oMgMd01Olg=cOoKVi^omKFe_ld=3CoHF5Q00KogMgM00?o
[Zj^o`L71on[Zj/00ooMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgR3ogMgM00?oHV9Roc0`<?oMgMd00ooMgMd02_lg=cOo410@
ogemOOo5aLGofm_KoibLW?nl_;cof][JoeADE?m8B4P2omgMg@05ocHf=_lQ
8B7oY:BTomcLg?o0`<000_oMgMd01Olg=cOoKVi^omKFe_ld=3CoHF5Q00Co
gMgM00CoShn?oeADE?la<C7oWIfM1?oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`0000godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kN8?oMgMd00omRHV;o<30`omgMg@03omgM
g@0:odQ8B?mfMWKoD51@o`L71oo@d=3oMgMgob/[:ol=3@go<C4aojVYZ@;o
gMgM00GobLW9od];Bol=3@go2@T9ob0P8002omgMg@06ocLg=om^KVkogMgM
olg=cOl];BgoTY:B1?oMgMd00onh^;So0000olW9b@04omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN8?oMgMd00omRHV;o<30`
omgMg@03omgMg@0:odQ8B?mfMWKoD51@o`L71oo@d=3oMgMgob/[:ol=3@go
<C4aojVYZ@;ogMgM00GobLW9od];Bol=3@go2@T9ob0P8002omgMg@06ocLg
=om^KVkogMgMolg=cOl];BgoTY:B1_oMgMd00olf=SKoGUiNomgMg@02omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN8?oMgMd0
0omRHV;o<30`omgMg@03omgMg@0:odQ8B?mfMWKoD51@o`L71oo@d=3oMgMg
ob/[:ol=3@go<C4aojVYZ@;ogMgM00GobLW9od];Bol=3@go2@T9ob0P8002
omgMg@06ocLg=om^KVkogMgMolg=cOl];BgoTY:B1OoMgMd00onn_[ko0P82
okZj^P03omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@7ok^k^00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]hPomgMg@03of9RH_l`<33ogMgM00KogMgM00Gof][JomgMgOoMgMgo
gMgMom_Kf`07omgMg@06om[Jf_oMgMgogMgMomgMgOlg=cOoKVi^1_oMgMd0
1OoLg=cof=SHokRh^?l0003obLW900CogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]hPomgMg@03of9RH_l`<33ogMgM00KogMgM
00Gof][JomgMgOoMgMgogMgMom_Kf`07omgMg@06om[Jf_oMgMgogMgMomgM
gOlg=cOoKVi^1_oMgMd01_oLg=cogMgMomgMgOoMgMgo:b/[ofYZJP?ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[o
fMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]hPomgMg@03
of9RH_l`<33ogMgM00KogMgM00Gof][JomgMgOoMgMgogMgMom_Kf`07omgM
g@06om[Jf_oMgMgogMgMomgMgOlg=cOoKVi^2OoMgMd00ooLg=co5aLGohR8
R003omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIf@7oi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]hMomgMg@05ofMWIomGEeOoEeMGobLW9olC4a<00omGEeL00oo>c/kogMgM
omgMg@0AomgMg@03ocLg=om^KVkogMgM00GogMgM00GoeMGEoa4A4Ol];Bgo
0000olW9b@04omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kN7OoMgMd01OmWIfOoEeMGoeMGEolW9bOo4a<C00?oEeMG00?oc/k>
omgMgOoMgMd04OoMgMd00olg=cOoKVi^omgMg@05omgMg@06odi>C_m7AdOo
QHF5oe=CDol51@Goa<C40ooMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgQgogMgM00GoIfMWoeMGEomGEeOo9bLWoa<C4`03oeMG
E`03olk>c_oMgMgogMgM017ogMgM00?o=cLgofi^K_oMgMd01OoMgMd01_mo
OgooGemOohV9ROmCDe?o30`<om3@d0?ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgQgogMgM00?oShn?ohF5QOn5QHD01On5
QHD00ooCdm?ogMgMomgMg@0AomgMg@03ocLg=om^KVkogMgM00KogMgM00Co
emOGojVYZOmbLW;od=3@1?oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgQgogMgM00?oShn?ohF5QOn5QHD01On5QHD00ooCdm?o
gMgMomgMg@0AomgMg@03ocLg=om^KVkogMgM00GogMgM00Gob/[:oiFEUOmS
Hf?oQXJ6olc<c004omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kN7OoMgMd00on?ShooQHF5ohF5Q@05ohF5Q@03om?CdooMgMgo
gMgM017ogMgM00?o=cLgofi^K_oMgMd01OoMgMd01Onh^;SoO7aloeeMGOn6
QXKo`/;200CogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
XJ6QolS8b?oPh>3olO7a0Oooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgSWogMgM00?ofMWIom_KfooMgMd03_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgSWogMgM00?ofMWIom_KfooMgMd0
3_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgSWo
gMgM00?ofMWIom_KfooMgMd03_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000gob/[:okFe]OnD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV00003OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph?oalO41ooooo`0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@7ok^k^00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:
b/[ofMWI0OoVi^H0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN41onk^kP0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oa
lO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7o
oooo00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Go
k^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^
kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0
000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H0
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00go
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP0000go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0Oooool0000=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000gob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
XJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7o
b<S8on3Ph?oalO41ooooo`0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@7ok^k^00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oM
gMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[o
fMWI0OoVi^H0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41
onk^kP0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45
ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Ooo
ool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nE
UIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0Oooool0000=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?ne]KGob/[:omWIf@7oi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q0Oo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6Q
olS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO41ooooo`0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@7ok^k^00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
0OoVi^H0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Go
k^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^
kP0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45oooo
o`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool0
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=ol[:
b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP0000godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oXJ6QolS8b?oPh>3olO7a0Oooool0000=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN41onk^kP0000gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@7oi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q0Oo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oM
gMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3P
h?oalO41ooooo`0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oM
gMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@7ok^k^00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5
onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0OoV
i^H0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP00
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a0Oooool0000=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN41onk^kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
okFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIf@7oi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q0Oo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oa
lO41ooooo`0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7o
k^k^00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Go
i^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKV
iP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0OoVi^H0
000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgM
gAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h0
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdF
omkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oN
g]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN
0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;o
gMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgM
g@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2
omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oN
g]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP0000godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN
<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;o
g]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003OoPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkN
gP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2
omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
XJ6QolS8b?oPh>3olO7a0Oooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oM
gMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM
0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN41onk^kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;o
g]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkN
gT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:omWIf@7oi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:
omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oM
gMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q0Oo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM
0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3o
lO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;o
g]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7a
l@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41
ooooo`0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkN
gP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45
onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2
omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^
00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oM
gMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM
5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0OoVi^H0000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKo
g]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkN
gP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000goh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2
omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oM
gMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00003OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM
0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;o
g]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000=ol[:b_ne]KGoU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3;og]kN0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkN
gS?ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`b
omkNgP;ogMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hc
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oN
g]h2omgMg@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN
0_oMgMd2omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;o
gMgM0_oNg]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgM
g@;og]kNB_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6Q
olS8b?oPh>3olO7a0Oooool0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2
omkNgT[ogMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oN
g]i:omgMg@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kN
B_oMgMd2omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[o
gMgM0_oNg]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:
b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@7oi^KV00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgM
g@;og]kN0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2
omkNgP;ogMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN45onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
0Oo^k^h0000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3;og]kN0_oMgMd2omkNgT[ogMgM0_oN
g]h2omgMgAKog]kN0_oMgMd2omkNgS?ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`bomkNgP;ogMgM0_oNg]i:omgMg@;og]kN
0_oMgMdFomkNgP;ogMgM0_oNg]hcomgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Go
oooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL<_oNg]h2omgMg@;og]kNB_oMgMd2omkNgP;o
gMgM5_oNg]h2omgMg@;og]kN<ooMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41oooo
o`0000god=3@okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_K
omoOgooQhN7oh^;R00;ohn?S1ooUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H2onCTi0;ohn?S00goh^;Ron3Ph?oLg=cofMWIomKFe_o@d=3o
bLW9ol71`One]KGoYJFUokRh^?o@d=3oh>3P00Gok^k^00god=3@okRh^?nL
W9co[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoOgooQhN7oh^;R00;o
hn?S1ooUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H2onCTi0;o
hn?S00goh^;Ron3Ph?oLg=cofMWIomKFe_o@d=3obLW9ol71`One]KGoYJFU
okRh^?o@d=3oh>3P00Gok^k^00god=3@okRh^?nLW9co[:b/ok^k^oo6a/Ko
cLg=om?CdooGemOofm_KomoOgooQhN7oh^;R00;ohn?S1ooUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H2onCTi0;ohn?S00goh^;Ron3Ph?oL
g=cofMWIomKFe_o@d=3obLW9ol71`One]KGoYJFUokRh^?o@d=3oh>3P007o
k^k^00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`2omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@04omkNg_oMgMgogMgMomgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL0_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkN
gP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM
00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgM
gOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooN
g]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkN
gP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM
00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgM
gOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooN
g]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkN
gP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM
00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgM
gOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd01?oN
g]kogMgMomgMgOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT5onKViP0=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oM
gMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oM
gMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM00Cog]kNomgMgOoMgMgogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[o
fMWI0OoVi^H0000=omCDe?no_kooS8b<oijNW_n][Jgo^KViol;2`_o7alOo
c<c<om3@d?oBd];oeMGEomKFeP02omOGe`03omSHf?oIfMWofMWI0<kofMWI
0_oHf=P2omOGe`0=omGEeOoCdm?od=3@olk>c_o:b/[oaLG5okno_one]KGo
ZJVYoiRHV?no_kooe=CDon;RhP05onk^kP0=omCDe?no_kooS8b<oijNW_n]
[Jgo^KViol;2`_o7alOoc<c<om3@d?oBd];oeMGEomKFeP02omOGe`03omSH
f?oIfMWofMWI0<kofMWI0_oHf=P2omOGe`0=omGEeOoCdm?od=3@olk>c_o:
b/[oaLG5okno_one]KGoZJVYoiRHV?no_kooe=CDon;RhP05onk^kP0=omCD
e?no_kooS8b<oijNW_n][Jgo^KViol;2`_o7alOoc<c<om3@d?oBd];oeMGE
omKFeP02omOGe`03omSHf?oIfMWofMWI0<kofMWI0_oHf=P2omOGe`0=omGE
eOoCdm?od=3@olk>c_o:b/[oaLG5okno_one]KGoZJVYoiRHV?no_kooe=CD
on;RhP01onk^kP0000goj>SXomCDe?n<S8coTi>Coj:RX_n_[joo^[Zjol71
`Oo7alOobl_;olk>c_o@d=3odM7A00;odm?C0ooDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGE
eOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]Ko
eMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oF
e]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oD
e=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGE
e@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oE
eM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD01_oFe]KoeMGEomKFe_oEeMCoeMGEomCDe0;o
dm?C00godM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jfoj^[ZonMWIgoUIFE
omCDe?oXj>Solo?c00Gooooo00goj>SXomCDe?n<S8coTi>Coj:RX_n_[joo
^[Zjol71`Oo7alOobl_;olk>c_o@d=3odM7A00;odm?C0ooDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGE
eOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]Ko
eMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oF
e]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oD
e=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGE
e@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oE
eM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01_oFe]KoeMGEomKFe_oEeMCoeMGE
omCDe0;odm?C00godM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jfoj^[ZonM
WIgoUIFEomCDe?oXj>Solo?c00Gooooo00goj>SXomCDe?n<S8coTi>Coj:R
X_n_[joo^[Zjol71`Oo7alOobl_;olk>c_o@d=3odM7A00;odm?C0ooDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGE
eOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]Ko
eMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oF
e]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oD
e=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGE
e@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01_oFe]KoeMGEomKFe_oE
eMCoeMGEomCDe0;odm?C00godM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jf
oj^[ZonMWIgoUIFEomCDe?oXj>Solo?c007ooooo00004_oMgMgocLg=oi2@
T?n9RHWoUiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooIfMWof][J
om_KfooJf][ofm_KomcLg0Oofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01_oKfm/03ooJf][ofMWIomSHf?oFe]Ko
dm?Colg=cOo2`/;o][Jfojb/[?nOWiooT92@oiJFU_o=cLgogMgMonGUi@05
onk^kP0BomgMgOo=cLgoT92@ohV9ROnGUiOoYJFUok:b/_no_koobl_;om7A
dOoEeMGoemOGomWIfOoJf][ofm_Kom[Jf_oKfm_og=cL1ooKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`06om_Kf`0?
om[Jf_oIfMWof=SHomKFe_oCdm?ocLg=ol;2`_nf][Ko[:b/oinOWon@T93o
UYJFolg=cOoMgMgoiNGU00Gok^k^01;ogMgMolg=cOn@T93oRHV9oiNGUonU
YJGo/[:bokno_oo;bl_odM7AomGEeOoGemOofMWIom[Jf_oKfm_of][Jom_K
fooLg=`7om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/0
1OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K
00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcL
g?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_K
om_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/0
1OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K
00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcL
g?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_K
om_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/0
1OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K
00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcL
g?oKfm_ofm_K00Kofm_K00oof][JomWIfOoHf=Soe]KFom?Cdoo=cLgo`/;2
okJf]_n/[:coWinOoi2@T?nFUYKocLg=omgMgOoUiND00Oo^k^h0000;om[J
f_o>c/koW9bLogYjN_n8R8SoUYJFojZZZ_o4a<CoeMGEom_KfooNg]h00_oP
h>03on;RhP03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01_oShn<2on;RhP0>on7QhOoP
h>3ogmoOomcLg?oGemOoaLG5ojb/[?nNWYkoT92@oh:2P_nPX:3oc/k>om[J
f_oPh>05onKViP0;om[Jf_o>c/koW9bLogYjN_n8R8SoUYJFojZZZ_o4a<Co
eMGEom_KfooNg]h00_oPh>03on;RhP03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01_oS
hn<2on;RhP0>on7QhOoPh>3ogmoOomcLg?oGemOoaLG5ojb/[?nNWYkoT92@
oh:2P_nPX:3oc/k>om[Jf_oPh>05onKViP0;om[Jf_o>c/koW9bLogYjN_n8
R8SoUYJFojZZZ_o4a<CoeMGEom_KfooNg]h00_oPh>03on;RhP03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01_oShn<2on;RhP0>on7QhOoPh>3ogmoOomcLg?oGemOo
aLG5ojb/[?nNWYkoT92@oh:2P_nPX:3oc/k>om[Jf_oPh>01onKViP0000ko
iNGUomgMgOo2`/;oNg]kogQhN?n6QXKoWinOolG5aOoHf=SogMgMomoOgooQ
hN7oh^;Ron?Sh`?oi>CT1?oUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@04_oUiNGoi>CTonCTi?oTi>Cohn?Son7Q
hOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4ol?3`ooMgMgoiNGU
on[ZjPGok^k^00koiNGUomgMgOo2`/;oNg]kogQhN?n6QXKoWinOolG5aOoH
f=SogMgMomoOgooQhN7oh^;Ron?Sh`?oi>CT1?oUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@04_oUiNGoi>CTonCT
i?oTi>Cohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4
ol?3`ooMgMgoiNGUon[ZjPGok^k^00koiNGUomgMgOo2`/;oNg]kogQhN?n6
QXKoWinOolG5aOoHf=SogMgMomoOgooQhN7oh^;Ron?Sh`?oi>CT1?oUiND2
onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03
onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>Co
iNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGU
onCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@0
0ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2
onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03
onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>Co
iNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGU
onCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@0
0ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2
onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03
onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>Co
iNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGU
onCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@0
4_oUiNGoi>CTonCTi?oTi>Cohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Q
ohf=SOn0P83oQ8B4ol?3`ooMgMgoiNGUon[ZjP7ok^k^00002ooinOWolo?c
onWYjOnXZ:SoIFEUog=cLon=SHgo^k^komCDe?oJf][ogMgM00;ogmoO00?o
h>3Pon7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00?ohN7Q00ko
h>3PomoOgooMgMgog=cLomGEeOni^KWoSXj>og]kNom^KVkoZj^[onWYjOoc
lo?onOWioogmo@Gooooo00_onOWioo?clooYjNWoZ:RXofEUIOmcLg?oSHf=
ok^k^ooDe=Cof][JomgMg@02omoOg`03on3Ph?oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@03on7Qh@0>on3Ph?oOgmoogMgMomcLg?oEeMGo
^KViohj>S_mkNg_oKVi^oj^[ZooYjNWolo?cooWinOomoOd5ooooo`0;ooWi
nOoclo?ojNWYojRXZ?mUIFGoLg=cohf=SOnk^k_oe=CDom[Jf_oMgMd00_oO
gml00ooPh>3ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN400ooQ
hN403_oPh>3ogmoOomgMgOoLg=coeMGEokVi^On>SXkoNg]kofi^K_n[Zj_o
jNWYoo?clooinOWooOgm0Oooool0000<on_[jooXj>Soh^;RomOGeon=SHgo
HV9RogIfM_nTY:CoalO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?o
fm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooL
g=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcL
g005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoL
g=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?o
fm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooL
g=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcL
g005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoL
g=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?o
fm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooL
g=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcL
g005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoL
g=`04OoKfm_og=cLom_KfooJf][ofMWIomSHf?oCdm?oaLG5oibLW?meMGGo
IfMWoi2@T?oGemOoh^;RonSXj?o[jn_okNg]00Gok^k^00cojn_[onSXj?oR
h^;oemOGohf=SOmRHV;oMWIfojBTY?o7alOod];BomGEeOoHf=P2om[JfP?o
fm_K1ooLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Go
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oL
g=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Go
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oL
g=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Go
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg00Aom_KfooLg=cofm_Kom[Jf_oIfMWof=SHom?Cdoo5
aLGoW9bLogEeMOmWIfOoT92@omOGeooRh^;oj>SXon_[joo]kNd01Oo^k^h0
3?o[jn_oj>SXon;Rh_oGemOoSHf=of9RH_mfMWKoY:BTolO7aooBd];oeMGE
omSHf0;of][J0ooKfm/7omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL017ofm_KomcLg?oKfm_of][JomWI
fOoHf=Sodm?ColG5aOnLW9coMGEeofMWIon@T93oemOGon;Rh_oXj>Sojn_[
ong]k@01onk^kP0000koiNGUon;Rh_oOgmoof][JolW9bOn7QhOoFUYJog]k
NonSXj?o_;blolK6a_o;bl_ocLg=olo?c`;odM7A1OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00;odM7A00god=3@olo?coo<c<cob<S8ok^k^onLW9coLW9b
oe]KFon:RX[obLW9om[Jf_oOgmooh^;R00;oiNGU1OoVi^H03_oUiNGoh^;R
omoOgooJf][obLW9ohN7QomJFU[oNg]koj>SXonl_;coa/K6ol_;boo=cLgo
clo?0_oAdM45om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03
om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7o
d];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03
om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7o
d];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03
om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM400_oAdM403Oo@d=3o
clo?olc<c?o8b<So^k^koibLW?mbLW;oFe]KohZ:R_o9bLWof][JomoOgooR
h^800_oUiND5onKViP0>onGUiOoRh^;ogmoOom[Jf_o9bLWoQhN7oeYJF_mk
Ng_oXj>Sokbl_?o6a/Kobl_;olg=cOo?cll2om7Ad@God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@02om7Ad@0=om3@d?o?clooc<c<olS8b?nk^k_oW9bLog9b
L_mKFe_oRXZ:olW9bOoJf][ogmoOon;RhP02onGUi@7oi^KV0002ong]k@0>
on[Zj_oXj>Soh^;RomcLg?nLW9coKFe]ofQXJ?n3Ph?oUiNGoj>SXon/[:co
[jn_ok6a/Onb/[82okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd013o]KFeokJf]?nc/k?o/[:bok>c/on_[jooZZZZoibLW?n2PX;o
HV9Rofi^K_nOWioog=cLon;Rh_oXj>Soj^[Z0_o]kNd6onk^kP;okNg]00ko
j^[ZonSXj?oRh^;og=cLoibLW?m]KFgoJ6QXoh>3PonGUiOoXj>Sojb/[?n_
[joo/K6aok:b/P;o];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@04?ne]KGo][Jdok>c/onb/[;o/k>cojn_[onZZZ[oW9bLoh:2P_mR
HV;oKVi^oinOWooLg=coh^;RonSXj?oZj^X2ong]k@Kok^k^0_o]kNd03_oZ
j^[oj>SXon;Rh_oLg=coW9bLofe]KOmXJ6SoPh>3oiNGUonSXj?o[:b/ojn_
[ona/K7o/[:b0_nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]00@okFe]Onf][Co/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9R
H_m^KVkoWinOomcLg?oRh^;oj>SXon[ZjP;okNg]0_o^k^h0000Booooooon
o_koo_knooclo?oinOWom_Kfoo;bl_oIfMWoZ:RXoh>3Pom^KVkoIFEUofUY
JOmbLW;oM7AdogUiNOmlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00CoO7alog]k
NomlO7coOGel0_mjNWX02omgMgOoM7Adofm_KomdM7CoQHF5ojRXZ?oJf][o
l_;booKfm_oinOWoo?cl00;oo_kn2?ooool2ooknoP0?ooclo?oinOWom_Kf
oo;bl_oIfMWoZ:RXoh>3Pom^KVkoIFEUofUYJOmbLW;oM7AdogUiNOmlO7co
Ng]k00;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@04ogalO?mkNg_oO7alogemO0;oNWYj00_o
MgMgogAdM?m_KfooM7AdohF5QOnXZ:Sof][Joo;bl_ofm_KonOWiooclo002
ooknoPSooooo0_ono_h03oolo?conOWiooKfm_obl_;ofMWIojRXZ?n3Ph?o
KVi^ofEUIOmYJFWoLW9bogAdM?miNGWoO7alog]kN`02ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01?mlO7coNg]kogalO?mmOG`2ogYjNP0;ogMgMomdM7CoKfm_ogAdM?n5
QHGoZ:RXom[Jf_obl_;om_KfooWinOolo?`00_ono_h3ooooo`000_o^k^h2
ong]k@04onc/k?oZj^[oj>SXonGUi@;oh^;R00?oh>3PomoOgooNg]h0e_oM
gMd00ooNg]kogmoOon3Ph002on;RhP04onGUiOoXj>Soj^[Zonc/k0;okNg]
2_o^k^h2ong]k@04onc/k?oZj^[oj>SXonGUi@;oh^;R00?oh>3PomoOgooN
g]h0e_oMgMd00ooNg]kogmoOon3Ph002on;RhP04onGUiOoXj>Soj^[Zonc/
k0;okNg]2_o^k^h2ong]k@04onc/k?oZj^[oj>SXonGUi@;oh^;R00?oh>3P
omoOgooNg]h0e_oMgMd00ooNg]kogmoOon3Ph002on;RhP04onGUiOoXj>So
j^[Zonc/k0;okNg]1?o^k^h000Coi^KV0_oUiND00ooTi>Coh^;Ron;RhP02
on3Ph0;ogmoOe_oNg]h2omoOg`;oh>3P0_oRh^800ooTi>CoiNGUonGUi@0>
onKViP;oiNGU00?oi>CTon;Rh_oRh^800_oPh>02omoOgmKog]kN0_oOgml2
on3Ph0;oh^;R00?oi>CTonGUiOoUiND03_oVi^H2onGUi@03onCTi?oRh^;o
h^;R00;oh>3P0_oOgmoFomkNgP;ogmoO0_oPh>02on;RhP03onCTi?oUiNGo
iNGU00Koi^KV003oogmoOhKoOgmo1omnOWkoogmoOe?oOgmo00001?o[jn_o
i^KVon;Rh_oNg]h3omgMg@3oomcLg?oNg]kog]kNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgM0017omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oMgMd00_oLg=`0?OoKfm_ogMgMomcLg?oNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kog=cMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomgMgOoKfm_of][JomOGeooHf=SoemOGom[Jf_oK
fm`00_oMgMd0oooNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNgP00AOoM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMg@03omkNgP03omgMgOoNg]kog]kN00?ogMgM0OoQhN41onOWi`7oj^[Z
00000oo/k>coi^KVon3Ph003omWIf@08omSHf?oIfMWofMWIomWIfOoHf=So
e]KFom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SH
omOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSH
f?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SHoooIfMT;omWI
f@;of=SH00Koe]KFom?CdooCdm?oe=CDomOGeooHf=P2omWIf@03omSHf?oI
fMWofMWI00;of=SH2OoIfMT00ooHf=SofMWIomWIf@02omSHf003omWIfOoH
f=SoemOG00;of=SH5ooIfMT01?oHf=Soe]KFom;Bd_o?cll2olg=c@04olo?
cooCdm?oemOGomSHf?oofMWIAOoIfMT00ooHf=SofMWIomWIf@06omWIf@7o
g]kN0OoVi^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoPh>3oh^;R
00;ohN7Q00gog]kNomcLg?oCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_o
alO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?oalO7ok^k^onb
/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_K
fooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO
0?oohN7Q2_oQhN402OoPh>3ogmoOom_KfooFe]Koe=CDomKFe_oJf][og]kN
on3Ph006omoOg`?oh>3P00?ogmoOon3Ph?oPh>000_oPh>08omoOg`;og]kN
0_oOgml3on3Ph0;ogmoO0_oPh>02omoOg`goh>3P00GogmoOomgMgOoIfMWo
eMGEom?Cd`02om;BdP03omKFe_oLg=coh>3P0?oohN7QAooQhN400ooRh^;o
hN7Qon;RhP04on7Qh@7oi>CT0OoYjNT1ong]k@0000?ol?3`ono_kooalO40
0_o`l?02ono_k`3ooo3`l?o^k^koj>SXom_Kfoo1`L7oY:BTohb<S?mkNg_o
MgMgog]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7alOo_
knoolO7_ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_oNg]kogMg
MomkNg_oS8b<ojBTY?o2`/;of][Jon[Zj?o]kNgolO7aono_kooalO7okno_
oo7alOo_knoolO7_ong]kOoZj^[of][Jol;2`_nTY:CoS8b<og]kNomgMgKo
Ng]kohb<S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a001>
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo3`k_o]kNgok>c/onGUiOoRh^;ogmoOonGUiOoYjNWokNg[0_oX
j>P01_oVi^KojNWYonOWioo[jn_ok>c/onk^k0?oj^[Z00Wokno_onk^k_o^
k^koj>SXonSXi_oVi^KojNWYonOWiooZj^X00_oYjNT03OoUiNGoinOUonOW
ioo[jn_ok>c/ono_koo[jn_oj^[ZonWYjOo^k^cok>c/on_[jooXj>P00_o]
kNd05?o^k^koj^[Zonc/j_o/k>cok^k^on[Zj_o/k>cokNg]onk^k_oZj^[o
k>cZonc/k?o^k^ko[Jf]ogMgMomIFEWoKfm_okJf]_oQhN3oinOW0_o_knl0
oooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aonk^k_oalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7al@00C?o_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aoo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knl4oo3`l00000?ol_;bonk^k_oWinL0
1?oUiND04?oTi>CogmoOom7AdOna/K7oRXZ:ofEUIOmADE7oADE5od92@_m5
ADGoDE5AofIVI_n:RXWo/K6aom7AdOoNg]h2onCTi003onGUiOoTi>CoiNGT
00;oi>CT00oog]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGo
DE5AofIVI_n:RX[o/K6aom7Ad?oNg]h00_oTi>@0oooUiNGoi>CTonGUiOoT
i>Coi>CSomkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5A
DOmVIVKoRXZ:ok6a/OoAdM7og]kNonCThooTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUi@009ooTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oShn?oa/K6obPX:?m5ADGoShn?om;Bd_oKfm_og=cKomKFeP03omGE
e@0<omCDe?oJf][ogmoOomoOg_oIfMWoeMGEomSHf?oOgmoohN7QomgMgOoF
e]KoeMGD0_oEeMD02ooDe=CofMWIom[Jf_oHf=SoeMGEomKFeOoFe]KofMWI
omgMgOoPh>3ofm_K00;oe]KF00WogMgLomcLg?oHf=SoeMGEomcLg?oPh>3o
gmoOom[Jf_oKfmX00_oMgMd0oooIfMWog=cLomoOgooPh>3ofm_Kom[JfOoM
gMgoh>3Pog=cLomXJ6SoSHf=oeADE?l820SoXj>Rom_KfooShn?oi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
on?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGohn?SonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi000E_oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT1?oUiND01_oT
i>CoiNGUonGUiOoUiNGoj>SXonc/k07ol_;b00000oodm?CokNg]onOWi`03
on3Ph00BomoOgooNg]kod];BokBd]?n7QhOoFe]Kofdk=OnNCT;ocFmOonV3
Koo=KeooWTi3ofdk=_mLG5coQhN7okBd]?oBd];og]kN1OoPh>004OoNg]ko
d];BokBd]?n7QhOoG5aLofeP;?nNURkocLdoonWYCOo=cCooWYX_ofeS;OmL
G5coQhN7okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaL
G?m7IbkoJ9hcoi7=AonZjEGoTLe7ofZN=?m9JRooG5aLohN7Qond];Cod];B
omkNgP3oon3Ph0Woh>3P00KogmoOolo?conIVIWoTY:BoaTI6On<S8`2omGE
e@0Oolo?coo2`/;oc/k>olk>c_o5aLGob/[:om[Jf_oHf=Sod=3@ol_;boo?
cloof=SHom[Jf_oEeMGoclo?ol71`Oo@d=3oc/k>olC4a?o;bl_of=SHomOG
eonn_[ko^k^kom7AdOo@d=3oeMGEomSHf?oCdm?oc<c<olk>cP02omGEe@05
olk>c_o<c<codm?Com[Jf_oHf=P00_oBd]801?oHf=SoemOGom7AdOoCdm<2
omWIf@06om?CdooAdM7oemOGomSHf?oAdM7od=3@0_oAdM401?m6ATKo@D51
omOGeooNg]i1on3Ph003omoOgooPh>3oh>3P0?ooh>3P0OoPh>000ooOgmoo
h>3PomoOg`02omoOg`?oh>3P00?ohN7QonOWioo/k>`00Oodm?@00003ooKf
m_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgoWinOof]OGon?=RkokG5Q
ooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=cOoRh^;o
inOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOofiVGonCLR;okM54ooWcM?om
oHgooOfEoogmS_oin7KokMM7oi=c8_m^IeooWinOolg=cOoRh^;oinOW00?o
j>SX01?oinOWon;Rh_o=cLgoWinOof1XGom;O2?oT^5;okgiNoo@oI;of?fK
omCmUOo0nGkoV>Q=odf09?mPJEooWinOolg=cOoRh^;oinOW0?ooj>SX2_oX
j>P01?oVi^KohN7QoeeMGOm=CDd2omgMg@0Ooe1@D?l71`Oo5ADEohB4Q?lF
5QKo@d=3on;Rh_oMgMgoW9bLo`000?n?ShoogMgMon7QhOoKfm_o@410o`P8
2?lI6AWoR8R8o`/;2omHF5So]kNgo``<3?l71`Oo8b<SobLW9ommOGgof][J
omgMgOoDe=Co2`/;oeUIF@02omWIf@03oeeMGOl;2`_odm?C00;ogmoO00Ko
FUYJodi>C_oNg]kog]kNob<S8on4Q8@2on7Qh@0<ogYjN_l^;RkogMgMomgM
gOo2`/;oD51@oc<c<om^KVkoPh>3ob4Q8OoNg]koi^KVoooXj>Q>onSXj07o
k>c/0Oobl_81ooKfmP0001WomoOgooShn?ohn?Son?ShooOgmoohn?SomoOg
onk^k_o>c/koT92@ohD_:ooYI5KonY:7oojVVoon/JGookR[oojcY_onZ9co
niB9oniXFOn9<B_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>
c/koT92@oiUY:oo`_Cgonn1^ookdP_onoX[ooonBooknS?onn8?onnE`oo32
?_nIJR_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@
od9c:on4cT?o[Nmcol;nR?o>oY3oe_nGom3nT_o6oXWo/_EdohSC@om4MB_o
T92@olk>c_o^k^komoOg0?oon?Sh2_ohn?P09Oofm_KolO7aoh61POlO7aoo
kNg]olK6a_l0003o`l?3om?CdomLG5co20P8on[Zj_o`l?3oj^[Zoe9BD_lD
51Co?CdmonWYjOo`l?3o[jn_o`L71ooBd];ocLg=odi>C_lK6a_ok^k^om_K
fon^[Zkoj>SXonc/k?n^[Zko0000okBd]?o/k>co/;2`o`/;2olJ6QX00_oT
i>@02olS8b?o3Ph>ojBTY?o]kNgok^k^of1PH?mDE5Cok^k^ong]kOlV9RKo
SHf=00;ol?3`00coPX:2oc4a<Oo/k>coj^[Zod=3@ol_;booW9bLog=cLolZ
:R[o6QXJonk^k_ofm_HjooShn003ooOgmoohn?Son?Sh00Gon?Sh00?omoOg
ooShn?ohn?P0<_ohn?P00oogmoOon?ShooShn03<ooShn003ooOgmoohn?So
n?Sh00;on?Sh00ComoOgooWinOogmoOom_Kf0Oohn?P00003oo[jn_oemOGo
k^k^00;ok>c/0?oojn_[onWYjOoOgmoo^KViogUBD_no<RCoigAYoof9O_oo
V8cooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<TogUBD_nj^[[ogmoOon[Z
j_o[jn_ok>c/on_[k?oZj^[ogmoOokZj^_n8IE;ohY4LooW3D?omfV?oonYb
ookcO_oonX;oo_Ioooo/LoongVCon/MAon:B7?n9IU?o^[ZjomoOgooZj^[o
jn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S7?nAdUGoY^MZokSiN_o0
oX;oaon9ol?nQ?nioG_oYna/oiCFEomBYQcoDVeBokZj^_oOgmooj^[Zon_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jn`007Co
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[jooZj^[oi>CTogYjN_lL71coh^;R
ol_;c?l30`?oWinOomoOgonDU9Co4a<Con3Ph?oQhN7od=3@o`H61_nQXJ7o
2@T9okjn__oRh^;o^KVio`820_na/K;og]kNoh20P?lY:BWoh^;RonSXj?oT
i>CogmoOom[JfooDe=Co20P8ohJ6Q_oOgmooJVYZodU9BOle=CGo[:b]okjn
__l71`OoN7QhoeEEE@;ogmoO00KoFe]Kodm?D?oRh^;oh>3Pob@T9?n4Q8@2
on3Ph03oog]kNol_;boohN7QomCDe?l51@GoYjNWonCTi?oRh^;oOgmooaDE
5_oRh^;ojNWYonc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/001@on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>`7
on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT00003oo_knooclo?o
kNg]00;oiNGU0?ooi^KVon?ShooIfMWo/[:bogT^;_o8@SCohfYLoo=iK?om
R7cooYN:oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;of=SHonCT
i?oUiNGoi^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^lA?onc5?ooMQR
ookSL_onjGGoo^IcookKIOomc5?onl55onjN:onIERko/[:bomSHf?oTi>Co
iNGUonKVi_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on7bTSoUmaIojGUJOnb
lgOo^?IkokCeNOnWjV_oV=aIohW?BomS[R_o;V<^ok:b/_oHf=Woi>CTonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNH005Go
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoTi>Cog]kNogMgMolK6a_og=cL
on3PhOnNWYko;Rh^ob/[:olb<S;o4Q8B00;ofm_K02GoQ8B4ob4Q8OoOgmoo
De=CofMWIooKfm_ogMgMoi2@T?lY:B[o;bl_ob`/;?lX:2SogMgMomoOgooH
f=Sodm?Colo?d?mKFe_o0000okjn__oIfMWo:2PXohJ6Q_mhN7SoJ6QXoh:2
P_ll?3co`l?3o`l?3ooEeMGofMWIoeUIFOm>CTkogMgMomcLg?lS8b?oPH61
00;oe]KF08OoMgMgobh^;_oMgMgoXZ:Ro`000?o6a/KofMWIomSHf?n>SXko
5ADEomgMgOoShn?oi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^H00_oUiND0aooUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iND00_oVi^H00ooUiNGoi^KVonKViP03onKViP03onGUiOo]kNgolo?c007o
no_k00000oolo?con?Shoo7al@03onk^kP0Con_[jooQhN7o_;blogXG5oo3
?c;odUE8onAXF_o_Mfcom8=iooR7O?oeQ7[olgU]onEYFooIF4[oa3lbog`G
5onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;blojE75ooVUc;omJ``
oofl@OombE?ooM1Poo_CIOomdV3oo/eDoofm@_oj[c;ojI/bojE65onl_;co
hN7Qonc/k003onk^kP0Conc/k?oQhN7o_;bloaMI5omOZ3;oM[dgohK=AonF
eU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg_cOoGj/boaMI5onl_;cohN7Qonc/
k03oonk^kP[ok^k^02kok>c/onOWiomkNg_o71`LonCTi?oYjNWoi^KVon7Q
hOoNg]koSHf=oa@D5?oVi^Koi>CTocDe=OmiNGWojn_[ok:b/_lE5AGogmoO
onKVi_oTi>CohN7QomgMgOmjNW[o:BTYonSXj?oUiNGogMgMok6a/OlV9RKo
2`/;oi^KVooYjNWoc<c<o`000?o>c/ko`l?3obDU9Om;Bd_oO7alonSXj?la
<C7oYJFUonCTi?mMGEgoDE5A0_oWinL02_lU9BGoJFUYomoOgooOgmooMgMg
oc4a<OoYjNWo`L71o`000?nWYjL2omoOg`04oi>CTolF5QKoinOWonc/k3co
k^k^00?okNg]onk^k_o^k^h00_o^k^h00oo]kNgok^k^onk^kP3oonk^kPWo
k^k^00?okNg]oo;bl_ohn?P00Oolo?`000?ooOgm01Koo?cloogmoOomoOgo
o?cloo?clooAdM7oJ0L7okPd=?o7?c?odU13omYREOoSKV;oi79TonA_H_oL
I5Oode53ola1=?ni=3CoJ`L7om;Bd_oclo?oo?cl0oomoOd04oolo?colo?c
om;Bd_nN:`OofXXdon^K6OoeZ2Won;@oooVmB_oh_dgon[m:ooVh?oofZR[o
kihIom^;=?nR;@Ood];Boo?cloolo?`00oomoOd04oolo?colo?com;Bd_l7
@0OoCIXdoen[8?m`^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^BooHZhPodjK
=?l7@POod];Boo?cloolo?`0ooomoOd:oogmo@0Soo_knoogmoOoQ8B4oahN
7_oclo?onOWiok>c/oo@d=3olo?cofQXJ?m7AdOonOWiomCDe?l0003ogMgM
ooclo?okno_o9bLWojRXZ?oinOWoZj^[omGEeOoalO7oE5ADoeiNG_oinOWo
m?CdoiBDU?l51@Go@410om7AdOogmoOon?ShoiNGUol[:b/00_ojn_X06olT
92Co1`L7olS8b?okno_oQHF5of=SHoogmoOoHf=SoeMGEoohn?SonOWiobLW
9olE5AGoPh>3omOGeom2@T;oHf=Soo_knoojn_[o=3@dodU9BOoKfm_oiNGU
odm?ColG5aOon_[jooclo03ooogmoD_ooOgm00?oo?cloogmoOolo?`00oom
oOd0000joogmoOojn_[olo?conk^k_o`l?3okno_onk^k_oYjNWodm?CoeXL
7?nR=3Co]2PMol4i;?o7BCcoceI:om1GBoo@Ed[obTXnol<k;_nf:1goXS@d
oe`M7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`koo^k^koj^[Zom?Cdon<9Ago
b74domV47OoTU1GoiidTonjX<oo`ZSCokjXconbP9OoWUaGog8PMolQa=?n<
9Agodm?Con[Zj_o^k^kol?3`ono_koo`l?3ok^k^on[ZjOoCdm?o7CPMocB2
=?m7UAgoFZDKofV]:P;oM;Ph0?ooMKThof^a:omKYacoB9XMocB2=?lM>1go
dm?Con[ZjOo^k^kol?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knl003[ol?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`onk^k_o[
jn_oOGemoa`L7?oWinOok^k]ohR8R?l`<33o3Ph>oc4a<On`/;3okno_ohB4
Q?m=CDgok^k^ono_koo^k^koRXZ:oeUIFOo_knooN7Qhob`/:ol>3Pko>3Ph
okjn__o^k^kohn?So`h>3_mYJFWoh>3Oon;Rh_oVi^Koj^[Zof5QHOmfMWKo
kno_onk^k_mgMgKo9RHV0_o^k^h05_o=cLgo;2`/on_[jom/K6coHf=Ron_[
joo^k^ko>SXjoiBDU?mRHV;o3Ph>oc@d=?o4a<Cok^k^ono_kooAdM7o?3`l
o`X:2_lW9bOoK6a/ob`/;?o^k^h2ono_k`3ooo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`onk^k_o`l?3okno_oo3`
koo_knool?3`ono_koo`l?3ok^k^oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`0015ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_00;ol?3`1_o_knl1oo?cl`7on?Sh0Oon
o_h00003ookno_ogmoOol?3`00;ojNWY01?oj>SXonWYjOoVi^Kofm_Kof=;
Bon1<S;oYS@dokHd;Oo2CD7o`eA9olAEB_o3E4Wo`Te1okHd;OnU=CGoPC8b
of=;BooKfm_oinOW00GojNWY017oinOWom_Kfon9Bd_o[d/boleg=OoFRbgo
h9`^on2P<_oQX3Coh:0bomnJ;_oFRbgobWDeojm;<_n9Bd_ofm_KonOWi`05
onWYj@0AonOWiooKfm_oBd];oc9P<_ljRCGoDi/]of^[;om`[CSoKjhjog2]
>?mZZRooDi/]ocV8=OlbH3;oBd];om_KfooWinL0oooYjNT;onWYj@06onSX
j?oVi^KoNg]koa`L7?oTi>Coj>SX0_oYjNT00ooWinOojNWYonWYj@0;onWY
j@0<onOWiooYjNWojNWYonSXj?oHf=So2PX:ojj^[_oLg=cog]kNon3Ph?oU
iNGoj>SX2?oYjNT01_oXj>Soi^KVon?ShooShn?oi^KVonSXj0?ojNWY00?o
j>SXonWYjOoYjNT01?oYjNT00ooWinOojNWYonWYj@1jonWYj@03onSXj?oY
jNWojNWY00?ojNWY00?oj>SXonWYjOoYjNT0a_oYjNT00ooXj>SojNWYonWY
j@04onWYj@7ol?3`0OogmoL1ooknoP0000Coo_knoo[jn_odm?Cokno_0oo`
l?004Oo_knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZNW?oIW9co
e9FEok]cLonEE5CoCb<SoiFDU?oZj^[okno_00Gol?3`017okno_on[Zj_nY
U9CoPB<SokYZE?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S
8onZU9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCoLjEc
oik6UOn/cYco[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Zj_o_knl0
ooo`l?0;oo3`l0;okno_00CoP820oadM7Oo^k^kokno_1Oo`l?000oo_knoo
l?3`oo3`l00;oo3`l0;okno_00OoI6ATobTY:On1PH7oHf=Soc/k>oo^k^ko
kno_00Sol?3`00Kokno_onk^k_mcLg?oJFUYonk^k_o_knm;oo3`l0;okno_
ooo`l?0?oo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn00001?o]ko;ooooo
ooooooono_h2ooooo`;oo_kn0?oooOgmooOgmom^KVkoFSlook6@T?oNbLWo
l>CToo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?coooooookno_oo
ooooo_knooooo_ono_koooooooclo?ohn?SoSFe]ohXo?oo9TI3ojM39ooCY
i?ofjnKom>WTonW@bOo9TI3oRCloohe]KOohn?Ooo?clooooooono_kooooo
ookno_ooooooo_knooooo_olo?con?Shofe]KOlo?cooT9f@olWEbOoTk>Co
i^kVonC/i?o9eLWoT9f@oclo?om]KFgon?Shooclo?ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_h004Ooooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooo`02ooknoP0Holo?conVYZKooOgmoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_kooooo0_ono_h03_o0
`<3oLG5aoh20P?n`/;3ooOgmooooooono_koooooookno_ooookoo_knoooo
ooono_kooooo0_ono_h0ooo1`L7o_KfloogmoOooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
oP00G?ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooooooo_kn0_ooool00oono_koooooooooo`03ooooo`7on_[k0000
1?o4c=?oo_knoo[jn_oclo<5oo7al@0=ono_kooFe]KoJf][od<m?OnKS8co
a[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7al@0=ono_kooG
e]KoPf][og@m?OneS8coeKZjon7<c?oF^[[o]Xb<og8m?On1Jf_oemKFono_
k`09oo7al@0=ono_kooFe]KoJf][ocdm?On<S8co^[Zjolc=c?nj^[[oS8b<
ocdm?Om[Jf_oe]KFono_k`3ooo7alAKolO7a00?ol?3`oo7alOoalO404Ooa
lO400oo`l?3olO7aoo7al@2Moo7al@03oo3`l?oalO7olO7a0<ColO7a00Co
l?3`oo7alOoalO7ol?3`1?oalO400oodm?Con_[jooknoP01on_^k`0001Go
RYRSoogmoOohn?Sol?3`on_[jooZj^[ojNWYon[Zj_oYjNWoj^[ZonWYjOoX
j>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT02ooZj^X0
2ooYjNWoj>SXoj2KVomZFEWo@bHVobd92Om29RKoJEUIoj2KVooXj>SojNWY
00_oj^[Z00_ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_o
j>SXonWYj@3oon[ZjR[oj^[Z00?ojNWYon[Zj_oZj^X0W?oZj^X00ooYjNWo
j^[Zon[ZjP3=on[ZjP04on_[joo`l?3on?Shoogmo@7ocm;F00001?m1D5ko
_<K=oo[jn_oclo<8oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_
k`;ol?3`3ooalO42oo3`l0?okno_0_o`l?3ooo7alOoolO7aV?oalO400oo`
l?3olO7aoo7al@02oo7al@03ooGemOojn_[ojN_]007oVinR00000olU?4ko
DF=`ok_5c03ooooooooooooof_ooool1ong_l@7o[;2d0OnW[;000006obU0
EolR>Dco>4YIohJAWOo1b<kok>k`ooooooooooooomCooooo00Gon?Wjonc^
kooAe=OoVinSoifSY`01ok>j_`00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{734, 424},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(savedLayout = pane@getLayout[]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JRootPane$1"] \[RightGuillemet]\),
      JLink`Objects`JavaObject16598756753409]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]pane@
        setLayout[\[IndentingNewLine]JavaNew["\<java.awt.GridLayout\>", 2, 3, 
            5, 5]\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[{
    \(\(buttons = 
        Table[\[IndentingNewLine]NewJButton[pane, 
            StringJoin["\<Track\>", ToString[i]]], \[IndentingNewLine]{i, 1, 
            5}\[IndentingNewLine]];\)\), "\[IndentingNewLine]", 
    \(\(JavaShow[frame];\)\), "\[IndentingNewLine]", 
    \(frame@repaint[]\)}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(Do[\[IndentingNewLine]DeleteJObject[pane, 
        buttons[\([i]\)]], \[IndentingNewLine]{i, 1, 
        Length[buttons]}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> java.awt.BorderLayout <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000005R<2hb>3HR<2hR<2hc<c<
0?ooooooooooNOooo`:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVK<
c<coIVIVofIVIWMVIVH01?ooohS0^8S0^4R@R04000000006R<2hb>3HR<2h
R<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c2c<c<`500000lc<
c0@00003c<c<0P000003c<c<0000000000;<c<`2000000?<c<`000000000
0/c<c080003oc<c<:lc<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c2_<c<`200000lc<c08000000lc<c0000000
0002c<c<0P000004c<c<00000000c<c<0`000003c<c<0000000000;<c<`2
00000/c<c080003oc<c<:lc<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooolc<c33<c<`2000000?<c<`0000000000/c<
c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`20000
0/c<c080003oc<c<:lc<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c2k<c<`4000000?<c<`0000000000/c<c080
00000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`200000/c<
c080003oc<c<:lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooolc<c2c<c<`500000/c<c0800002c<c<0P000003c<c<
0000000000;<c<`2000000?<c<`0000000000/c<c0800002c<c<0P000?o<
c<`[c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVKoooooc<c<:lc<c0@00005c<c<00<0003<c<c<c<`00P000003c<c<0000
000000;<c<`2000000?<c<`0000000000/c<c0<000000lc<c0000000003o
c<c<:lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooooolc<c2_<c<`200001lc<c0@00002c<c<0P0000;<c<`6000000C<
c<`00000003<c<`20000olc<c2c<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`[c<c<0P0000?<c<`200003lc<
c0800002c<c<0P000?o<c<`_c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<;<c<c0D0000Ac<c<00<0003<c<c<
c<`00P000?o<c<`_c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
ooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooogOoool01Lc<c?ooohS0^8S0^4R@R0010000000018S0^<SPf8S0
^8S0^?mVIVKoIVIVNFIVIP04c<c<R<2hR<2hB9280@00000000B8`;S8h=R8
`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
olc<c?o<c<ajc<c<0XS0^058T8P1000000001HS0^<SPf8S0^8S0^<c<c00o
oooo0lc<c?oooooioooo0lc<c3[oool2R<2h0DR@R04000000006R<2hb>3H
R<2hR<2hIVIVc<c<?FIVIP05ooooc<c<c<c<IVIVc<c<0?mVIVKgIVIV00Go
ooo<c<c<c<aVIVK<c<`0>6IVIP04ooooR<2hR<2hB9280@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooll
c<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<
IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIV
I_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<
c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<
c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006
IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_oo
ocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<
c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<
c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIV
ooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_oo
olc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool@
c<c<0`0000?<c<`300000lc<c0@00003c<c<100000?<c<`200004<c<c006
IVIVooooc<c<c<c<IVIVoooojLc<c0@00003c<c<100000;<c<`200000/c<
c0800002c<c<0P0000;<c<`400000/c<c080003[c<c<00IVIVKoooo<c<c<
c<aVIVKoool?c<c<1P0000;<c<`500000/c<c0@00003c<c<0P00013<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oooa3<
c<`300000lc<c0<00002c<c<0P0000;<c<`2000000?<c<`0000000000/c<
c08000000lc<c0000000000Ac<c<00IVIVKoooo<c<c<c<aVIVKooooXc<c<
0P0000;<c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002
c<c<0P000003c<c<0000000000;<c<`200000/c<c08000000lc<c0000000
003[c<c<00IVIVKoooo<c<c<c<aVIVKoool?c<c<0P0000G<c<`200000/c<
c08000000lc<c00000000002c<c<0P000003c<c<00000000017<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oooa3<c<`3
00000lc<c0<00002c<c<0P0000S<c<`3000000?<c<`0000000004Lc<c006
IVIVooooc<c<c<c<IVIVooooilc<c0800006c<c<0P0000G<c<`200000/c<
c08000000lc<c00000000002c<c<0P0000G<c<`20000jlc<c006IVIVoooo
c<c<c<c<IVIVoooo3lc<c0800005c<c<0P0000;<c<`200001<c<c0<00000
0lc<c0000000000Ac<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoool?c<c<0P000004c<c<00000000c<c<0P000004c<c<
00000000c<c<1P0000;<c<`400000/c<c080000Ac<c<00IVIVKoooo<c<c<
c<aVIVKooooWc<c<0P0000K<c<`6000000?<c<`0000000000/c<c0800000
0lc<c00000000002c<c<1P000003c<c<000000000>_<c<`01VIVI_ooolc<
c<c<c6IVI_ooo`o<c<`200001/c<c08000000lc<c00000000002c<c<1000
00;<c<`200004Lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo3lc<c08000001<c<c00000000<c<c08000001<c<c000
00000<c<c0800002c<c<0P000004c<c<0000000000001<c<c080000Ac<c<
00IVIVKoooo<c<c<c<aVIVKooooWc<c<0P0000K<c<`200000/c<c0800000
0lc<c00000000002c<c<0P000003c<c<0000000000;<c<`200000/c<c080
00000lc<c0000000003[c<c<00IVIVKoooo<c<c<c<aVIVKoool?c<c<1P00
00?<c<`4000000C<c<`0000000000004c<c<0P00017<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooo`o<c<`2000000C<
c<`00000003<c<`2000000C<c<`00000003<c<`200000/c<c08000000lc<
c00000000002c<c<0P000003c<c<00000000017<c<`01VIVI_ooolc<c<c<
c6IVI_ooonO<c<`200001/c<c0800002c<c<0P000005c<c<000000000000
c<c<008000000lc<c00000000002c<c<0P0000;<c<`2000000?<c<`00000
0000jlc<c006IVIVooooc<c<c<c<IVIVoooo3lc<c0800005c<c<00@0003<
c<c<c<c<c<`2000000?<c<`0000000000/c<c08000000lc<c0000000000A
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
ool?c<c<0P000003c<c<0000000000800002c<c<0P0000;<c<`400000lc<
c0@000000lc<c0000000000200004<c<c006IVIVooooc<c<c<c<IVIVoooo
ilc<c0800007c<c<100000;<c<`2000000C<c<`00000003<c<`400000/c<
c0@00002c<c<10000>W<c<`01VIVI_ooolc<c<c<c6IVI_ooo`o<c<`20000
1/c<c0@00003c<c<10000003c<c<000000000080000@c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool>c<c<0P0000?<
c<`300000lc<c080000>c<c<0P00017<c<`01VIVI_ooolc<c<c<c6IVI_oo
onS<c<`200000/c<c080000?c<c<0P000?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooo`o<c<`200004lc<c080000Ac<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoool>c<c<0P0000?<c<`300000lc<c080
000?c<c<00<0003<c<c<c<`03lc<c006IVIVooooc<c<c<c<IVIVoooojLc<
c0@0000Ac<c<00<0003<c<c<c<`0m<c<c006IVIVooooc<c<c<c<IVIVoooo
3lc<c0H0000@c<c<00<0003<c<c<c<`03lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`0
1VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_oo
ooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<
c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<
c006IVIVooooc<c<c<c<IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IV
I_ooocO<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooocc<c<`01VIVI_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKo
ooo<c<c<c<aVIVKooolgc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKooollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<
m/c<c006IVIVooooc<c<c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo?<c<c006IVIVooooc<c<c<c<
IVIVooooolc<c?K<c<`01VIVI_ooolc<c<c<c6IVI_ooocO<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooocc<c<`01VIV
I_ooolc<c<c<c6IVI_ooooo<c<cfc<c<00IVIVKoooo<c<c<c<aVIVKooolg
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
oollc<c<00IVIVKoooo<c<c<c<aVIVKoooooc<c<m/c<c006IVIVooooc<c<
c<c<IVIVoooo=lc<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV03goool01Lc<c?ooolc<c<c<c6IVIP3ooooomoooo`05c<c<
ooooc<c<c<c<IVIV03Soool01Lc<c?ooohS0^8S0^4R@R0010000000018S0
^<SPf8S0^8S0^3mVIVH3c<c<ofIVI_UVIVH3c<c<>VIVIP04c<c<R<2hR<2h
B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P100000000
1HS0^<SPf8S0^8S0^<c<c03oooooooooogWoool2R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hIVIVc<c<ofIVI_mVIVIgIVIV00Cooon8`;R8`;Q8T8P1
000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
ooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ooo<c<`/c<c<0P0000?<c<`200000/c<c0@00002c<c<0P0000C<c<`20000
00?<c<`0000000000/c<c080003oc<c<;<c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c2c<c<`200000/c<c0<0
00000lc<c00000000002c<c<0P000003c<c<0000000000?<c<`200000/c<
c0800002c<c<0P000?o<c<`/c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<;<c<c0800002c<c<0`000003c<c<
0000000000;<c<`2000000?<c<`0000000000lc<c0800002c<c<0P0000;<
c<`20000olc<c2c<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooooo<c<`/c<c<0P000003c<c<00000000008000000lc<
c00000000002c<c<0P000003c<c<0000000000?<c<`200000/c<c0800002
c<c<0P000?o<c<`/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<;<c<c08000000lc<c0000<c<c002000000?<
c<`0000000000/c<c08000000lc<c00000000003c<c<0P0000;<c<`20000
0/c<c080003oc<c<;<c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c2c<c<`4000000?<c<`0000000000/c<c003
0000c<c<c<c<008000000lc<c00000000003c<c<0P0000;<c<`3000000?<
c<`000000000olc<c2c<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI_ooooo<c<`/c<c<0`0000;<c<`200000/c<c0@00002
c<c<20000004c<c<00000000c<c<0P000?o<c<`]c<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<;<c<c0<00002
c<c<0P0000g<c<`200000/c<c080003oc<c<<<c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c2c<c<`200000lc<
c080000>c<c<00<0003<c<c<c<`00P000?o<c<``c<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01Lc<c?ooohS0^8S0^4R@
R0010000000018S0^<SPf8S0^8S0^?mVIVKoIVIVNFIVIP04c<c<R<2hR<2h
B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004
R<2hb>3HR<2hR<2h5P00P0<00H0200:000@00X400h400h400h4300B10P05
P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V30`4:P`03
0@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@2
4hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV9
0aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`0
10@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZ
SPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`Ha
T@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7
=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0
UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6
V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`4
2U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN
00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aM
X@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=
Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/
YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X
00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/3
47b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^
0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4B
R[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008C
Sk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH
]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh
0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/3
5ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1000P003VjOa<d>U<d>U00Tc@jD600200`01P080
0X001002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<1
1h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j5
0`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<4
7XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd0
0`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6
;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHd
TP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD
0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3
U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9
BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd3
2e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<
FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaP
XP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT
0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_
Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?
MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd2
4Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@A
QZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8B
SK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@0
0a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK
]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<E
X[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m
5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000NK
Yo7ooon>N[JVVlBcZM:XWLRcZM800ZJKa005_;SMk^kdj^Waoooo<d>U00D0
080300600P02P00400:100>100>100>10`04P@801H401005PP06PP06PP06
PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b4
0`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8E
Q`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<3
78X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd2
1BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5
;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86
<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@0
0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1
U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9
B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M
2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;
F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR
362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT
3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>
KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?
M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n
[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64
[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;40
11:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B
/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg
59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP
^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@F
Zk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG
/KlG/Kl00aNb_`<G/kl26;C08000008H]<0@00000QRd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000BKYo7ooom/FZF_YLX2_;SM00[ooOnc
ZM;ooooooonl^=fGR[bXWLSVi^cooolc@jD400200`01P0800X001002P@03
P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h8128812880
0P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D4
0Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP3
5hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@P
R`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDW
SP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6
;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB
1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D3
23fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH
2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<
V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;
E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaL
X00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQ
XPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D3
3VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`
Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1h
ZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@03
4H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8
/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb
00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@3
4iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg
00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT
^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G
[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd
`003b>3HB928B92800a8T8P00`000<SPf4R@R00=B92800@0000H]<0H]<38
h=P>B92800<0000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0^8S0
^08008002i^WlOooojRMb?oook>YdV1<VXij]WQU[ZRMb?ooooomo`03oooo
00<c@jD0080008000`00P0<00H0200:000@00X400h400h400h4300B10P05
P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V30`4:P`03
0@^30@^40@^400<138@30@f40`4>Q@<23hD20Q250oooo`824HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00
P00>VjOaoooooooofmc/H4bJThFj/jWB_;SMH4bJVHnnYY_4b<?Ooooo<d>U
1P00P0?oool200:000<00X7oooooool00_ooo`8018400`05POooo`05PP03
00J21?ooo`030@R20@R3oooo00?oool30@Z300Koool12h@12h@138Coool1
38@20@f400Coool13XGoool13XD20Pn500Coool248Goool248D20Q6600?o
ool24HH24XH00P8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP3
5hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX3
11n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DW
S@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y02
1Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP03
1cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`Lk
U@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`04
2D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX3
2T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M
00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ03
35^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<
HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eW
Y0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>
L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX3
3gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]
0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl3
4XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8B
SK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C
]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<D
W;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T3
5J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm
0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l3
5k>o0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P00dR@R0000<SPf002R<2h
2@0000:8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00>VjOaoooo_;SMVHnn
ooooe]7Mfmc/lokoYY_4k^kdQGJ`ThFjoooo<d>U1000P007oooo00600060
0060oooo00:0oooo00<00h401_ooo`04P@04P@05POooo`05PP801X802?oo
o`07PP07PP47P_ooo`48P_ooo`48P`<12H<01?ooo`4:P`4:Poooo`812h@0
0`4<Q?ooo`4<Q0020@f400Coool13XGoool13XD20Pn500?oool248Goool0
0oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<4
7h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=
1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086
;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7
=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9
@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:
BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<
Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`
Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?
MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd3
4H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<B
Qk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d
0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL
]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d2
5jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G
/kl26;C000C8h=R8`;R8`;R8`;P6000018S0^003B9280000b>3H00:8`;P0
0`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`004b>3HR<2h
R<2hR<2h0P0000B8`;P200000XS0^004B92800006;C06;C00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0<008003i^WlOoooiV?_YN:_=CCj>n//omf
NnjOZe]HYJJKa9JOdV1<V[bhgOoooc=3Y@03002000Ooool00H000H000H3o
ool00X3oool00`03P@06oooo00B100B1oooo00F1oooo0P06PP08oooo00N2
00N20@N2oooo0@R2oooo0@R30`49P`09oooo0@Z3oooo0@^3oooo0@^4oooo
0@b4oooo00813H@01?ooo`4>QOooo`4>Q@823hD01?ooo`8@QOooo`8@Q@@2
4HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<G
R0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;
0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>
00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_
T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87
=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8
?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9
A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK
0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]D
WP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP
00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R
3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>
JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X
3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ
0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<A
PJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`
0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[80
0a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<C
UKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL0
11FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj
0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]
_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C0
00?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005
R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8`;P20000
0XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOXZFjPb<?OThFjFdJCVHnn
0WQU[P04@RN5[jG:oooo<d>U1000P0<00H000oooo`02P002P@04oooo0P04
P@03oooo00F1oooo00<01X84oooo00<1288128<128<00`49P`09oooo0@Z3
oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?ooo`4>QOooo`4>Q@823hD0
0oooo`8@QOooo`03oooo0P8AQP<24XH20Q>600@24hL258L258L258L30QF7
0P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<L
RP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@85
9Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/
S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHc
TPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU003
1cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G
0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8
V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:
DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]H
W`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<
H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=
IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^
Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010md
Z@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]
47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_
00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@04
4Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c
4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LD
VkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i
00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[
_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa
_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P0
0XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8
h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0P00P003VjOaoooooooo00;oool02_n]/?mf
NoW=e?g]k_ooojJKa8Ef/;bhgOoooc=3Y@D00803006000?oool00X000X40
0`03P@03oooo00B1oooo00801H401005P_ooo`06PP06PP801h800`47P_oo
o`48PP020@R30oooo`812X<01oooo`4;Poooo`4;Q?ooo`4<Q?ooo`020@f4
00Coool13XGoooooool20Pn500Koool248Goool248D24HKoool20Q660`8B
QP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR8
00<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/3
12:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>
0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946
<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087
=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10Pn
UP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH
0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/3
2TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h0
0`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ
35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeR
XP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZ
Y@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0ma
Z0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/3
47Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^
4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK00
11:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8C
Sk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF
]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPE
W[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX3
5ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^
_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3H
R<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^005
0000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^004R<2h0P0000F8`;P0
14R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P30020
00ZQ[?;icMCR9Scd]KoR9ScdKGglhnWoooomkNko[K02oooo00<c@jD00800
08001000P0<00H000oooo`02P002P@03oooo0P04P@05oooo00F100F100F2
oooo00801X83oooo0P48PP030@R3oooo0@V300812H<20@Z300Coool12h<1
2hCoool20@b400Ooool13H@13HCoool13XGoool13XD00_ooo`030Pn50Q25
0Q2500Coool0108AQP8BQP8BQP8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL2
0QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:
0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDU
S@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?
0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B
1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7
>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL3
24:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI
0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YB
W@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO
10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaP
XPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eU
Y0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW
3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY
0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@
OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l0
0a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@B
S;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<C
T[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK
]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T0
11FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l
5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o
5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002
R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSP
f8S0^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000fKYo7mkNkR9ScnmOSgRIOdHVkcX:kd
HVkooOoo[K3lhnWooolc@jD01`00P0<00H000oooo`02P002P@0300>10`04
P@801H401005PP06PP06PP06PP801h801@47PP48PP48P_ooo`48P`030@V3
0`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR003
0aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A
1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC
0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH3
23nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9
AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>
V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aM
X@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ80
0PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD4
3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?
LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1j
Z`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61
[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@B
RK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb
4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D3
59Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh
5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0
^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@00
08S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h0P00
00>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2002000>KYo7fb<cR9S`00_n]/007gb@^ojBNm[c5ojf`kW^<oooo<d>U
00P00803006000?oool00X000X400`03P@<0184200F100@01H801X801X80
1X8200N200D11h81288128;oool128<00`49P`04oooo0@Z30@Z30@^30P4;
Q0<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L2
58L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT3
0a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@T
S@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`03
1B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010Hb
TPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`Lh
U0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G
246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@04
2DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:
DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;
Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ
00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=
IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]
Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?
LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[004
47j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^
4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a
0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A
/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf
00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h
5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@F
Z[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h0
0aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P0
0038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P00hS0^0800004
R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2002000>KYo7icMCgRIL00_ooo`07ojf`hAHdogIkojBNhRHl
ohUo<d>U00P00803006000?oool00X000X400`03P@<0184200F100@01H80
1X801X801X8200N200@11h812881288128<4oooo0`4:P`030@^30@^40@^4
00<138@20@f400Coool13XD13XD13XD30Pn50`8@Q@@24HH30Q:60P8CQP04
0Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<I
R@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><
00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5
:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6
<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<3
1cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88
@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9
AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL
10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]F
WP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<
GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<3
3F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>
K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mb
Z0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[
0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62
[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa
4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P02
4hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@D
V;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN
^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk
0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn
00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P0
2hS0^003B9280000b>3H00:8`;P900000XS0^005B92800006;C06;C0b>3H
00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2002000NKYo7oooocX:kdHVkoooogRIOicM@00_ooo`03lj2^oooo<d>U
00P0080300600P02P00400:100>100>100>10`04P@801H401005PP06PP06
PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q003
0@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<K
R@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d4
9Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[
S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO
00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y
00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n
[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64
[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P04
59Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl
00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G
/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000
b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00;VjOaooooohUooooo
lj2^lI>Qoooooogolj2^oo_l<d>U00P0080300600P02P00400:100>100>1
00>10`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R3
0`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH3
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C03lSP
f0030000b>3Hb>3H00g8h=P00`0001Rd`1Rd`00?b>3H00<0000H]<0H]<00
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0@00803VjOa00KoooocX:kd
]Kof_<GkfMXc@jD900200`01P0800X001002P@03P@03P@03P@<0184200F1
00@01H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<1
2h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108C
Q`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT3
6HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS004
12B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>
1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A
0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`Lg
T`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F
00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH
2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:
D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh0
0`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ
0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eS
X`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP0
0`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@
O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh3
4H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::
/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?
/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf
0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P3
5Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<F
Z;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P03
5jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;PF00200`01P0800X001002P@03P@03P@03P@<01842
00F100@01H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z3
00<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0
108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP3
6HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@S
S00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP03
1BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<943
1S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC
0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2
242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V003
2DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?
W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;
EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ
35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S
0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH3
3VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?
LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1k
Z`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<A
PZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::
/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk80
0Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD4
59Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PE
W[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW
^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^
_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00
000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000003R<2hb>3H
R<2h0?n8`;SoR<2hOHS0^058T8P1000000000hS0^<SPf<SPf03ob>3HolSP
f7g8h=P1B9280@000000ohS0^?n8`;R1R<2h0@000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;N0001Z2000`400?l0
0000o`00003oooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?000?oo
l?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`
l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?oo
l?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003o
oo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3o
l?3`003ooo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l00000gooooo
ookno_ono_koo?clooWinOofm_Kol_;bong]kOoXj>Sohn?Son3Ph?oMgMgo
fm_K00;of][JoooIfMWoomWIfL7ofMWI0_oJf]X02_oKfm_ogMgMon3Ph?oS
hn?oj>SXong]kOobl_;om_KfooWinOolo?`2ooknoP;ooooo0002ong]k@0:
on[Zj_oXj>Soh^;RomgMgOoFe]KocLg=olK6a_nn_[ko^[ZjokJf]PCo/k>c
oonb/[;ook:b/[oo/[:b1?nc/k<02_nf][Ko^[Zjokjn__o6a/KocLg=omKF
e_oMgMgoh^;RonSXj?oZj^X2ong]k@7ok^k^00003_oUiNGoh^;RomoOgooJ
f][od];BolO7aonm_Kgo/[:bojRXZ?nPX:3oVi^KoiRHV?nDU9CoTi>CoonB
TY;ooi:BT/?oTY:B00goTi>CoiBDU?nHV9SoVi^Koj2PX?nXZ:So/[:bokfm
_Oo7alOod];Bom[Jf_oOgmooh^;R00;oiNGU00003_o[jn_oj>SXon;Rh_oH
f=Sobl_;okjn__n^[ZkoXJ6QoiFEUOn<S8coQHF5oh:2P_moOgooOWinoomm
OGgoogemOL?oOGem00koOWinogmoOon2PX;oQHF5ohb<S?nEUIGoXJ6Qojj^
[_nn_[kobl_;omSHf?oRh^;oj>SXon_[j`7okNg]00005?oinOWolo?conWY
jOoIfMWoalO7okBd]?nRXZ;oVYZJojZZZ_o3`l?ofMWIonc/k?ofm_KomoOg
ooWinOohn?SonOWioo[jn_oinOWomoOg0oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00_ohn?P0
3ooinOWon?ShooOgmoo^k^kof][JolC4a?nZZZ[oVYZJoj:RX_nd];CoalO7
omWIfOoYjNWolo?cooWin@01oogmo@0000coiNGUomgMgOo>c/ko_KfmojRX
Z?nEUIGoYJFUolc<c?o^k^kom_Kfooclo?ono_koooooooooooooaoooool0
3?ono_koo?clooOgmoo_knoocLg=ojJVY_nEUIGoZ:RXokfm_Oo>c/kogMgM
onGUi@7oj^[Z00002_oJf][oc/k>okfm_OnXZ:SoUYJFoj^[ZooNg]kojn_[
ooCdm?okno_oooooooooooooboooool02_okno_olo?conc/k?oQhN7o[Zj^
oiJFU_nXZ:So_Kfmolk>c_oJf]X1on3Ph00000[ogMgMolg=cOnh^;SoXJ6Q
ojRXZ?oDe=Coh>3Ponc/k?oemOGooOgmoooooooooooool_ooooo00[oo_kn
ooKfm_o/k>coh^;RomWIfOn/[:coXJ6QokRh^?o=cLgogMgM0OoUiND0000;
onSXj?oDe=Co^[ZjojVYZOo6a/Koe=CDon3Ph?o/k>col_;booclo?ono_h0
oooooomCooooo`03oogmoOoLg=coi^KV00Kooooo00?ok>c/ono_koooool0
1?ooool00oolo?cokno_ooooo`06ooooo`03onGUiOomoOgooooo0?oooooo
Foooool02_ojn_[om?Cdon[Zj_oShn?oemOGolg=cOn/[:co^[ZjomCDe?oX
j>P1oo?cl`0000ooe=CDokno_onVYZKo[:b/olK6a_oBd];og=cLonKVi_o/
k>comOGeooShn?ojn_[ooOgmooooooolo?`02?ooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00;ooooo00Ko
/;2`o`X:2_l=3@go8b<SocHf=_nWYjL2ooooo`06om_Kfole=CGo3Ph>o`/;
2oli>CWog=cL0_ooool01_no_koo6a/Ko`L71omADE7oQXJ6oc0`<0;ooooo
00Oodm?CobDU9OlN7Qko^;Rhoooooom0@43oOgmo00;ooooo00?oXj>Soa`L
7?omoOd01oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo
00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05oooo
o`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oom
oOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooo
ooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo
00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05oooo
o`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oom
oOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooo
ooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo
00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05oooo
o`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oom
oOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooo
ooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo
00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05oooo
o`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oom
oOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooo
ooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo
00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05oooo
o`03oogmoOoooooooooo00Cooooo00oooOgmooooooomoOgono_kooShn?od
m?CokNg]onKVi_oOgmooe]KFolc<c?nb/[;oYjNWokno_ooDe=@00OoRh^80
000Col[:b_ne]KGoWYjNokJf]_o3`l?oclo?omKFe_oOgmooi^KVon[Zj_o_
knoolo?cooCdm?oemOGomoOgooKfm_ogmoOom_KfooShn002ooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
017om_KfooShn?ogmoOoclo?okRh^?oalO7omoOgoiRHV?l30`?oemOGooKf
m_lb<S;oCdm?onGUiOoVi^KoDU9Boc<c<`02ooOgm`0;oe5ADOmEEEGok^k^
oiVIVOl>3Pko;Rh^ooShn?ogmoOoKFe]ochn?_oemOD00_ogmoL01_lm?Cgo
Ng]kooOgmoogmoOoWIfMoa/K6`;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_Kf
ooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL05?ofm_Kon?ShooOgmoogmoOom_KfooOgmoofm_Kom?Cdoo;bl_o`l?3o
jn_[onKVi_oQhN7of][Jom?Cdoo9bLWo_knooj>SXone]KGob/[:0OoIfMT0
000;om3@d?nh^;SoX:2Pok>c/oo0`<3obLW9om?CdooIfMWogMgMon;Rh_oU
iND00_oZj^X00oo/k>cokNg]ong]k@07onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h04oo`l?3o
d];Bo`000?nYZJWobLW9o`000?nZZZ[ok^k^oo3`l?nZZZ[o0000olg=cOo^
k^ko:BTYohJ6Q_o^k^kol?3`og5aLOl/;2`00_o^k^h01om7AdOoJVYZonk^
k_o`l?3ok^k^oc/k>omfMWH00_o^k^h00onHV9So6QXJoo3`l007onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h00oo^k^h2ong]k@;ok>c/00cojNWYonKVi_oShn?oh>3Pom_KfooEeMGo
cLg=olG5aOnk^k_oYjNWokRh^?o@d=01on3Ph00000gogmoOolG5aOnNWYko
[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoOgooQhN7oh^;R00;ohn?S
1ooUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@08onKVi_oHf=SoATI6o`L71ooIfMWoZZZZo`000?o>c/h2
onKViP06olc<c?l0003o[Jf]onGUiOlW9bOoQ8B40_oVi^H01_n0P83o:b/[
onGUiOoUiNGoADE5ofIVIP;oi^KV00?oiNGUocTi>OmbLW800_oUiND00onB
TY;o6ATIonKViP06onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGU
i@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKV
iPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGU
i@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKV
iPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGU
i@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKV
iPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGU
i@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKV
iPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGU
i@;oi^KV1_oUiND2onKViPGoiNGU0_oTi>@2on?Sh`0<on;Rh_oPh>3og=cL
omWIfOoFe]Kod=3@olW9bOo1`L7o]KFeojNWYoo5aLGogmoO0Oo`l?00000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg0;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]ko
gMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03
omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]ko
gMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03
omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]ko
gMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03
omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]ko
gMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03
omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h3omgMg@09omkNg_nMWIgo61PHoa@D5?nUYJGogMgMokjn__l0
003oW9bL00;ogMgM00KoVYZJo`000?o2`/;ogMgMobHV9_moOgl2omgMg@06
ogalO?lY:BWogMgMomgMgOm2@T;oHf=S0_oMgMd00ooNg]ko=cLgoe1@D002
omgMg@03ohR8R?lI6AWogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h4omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo=
cLgo^KViohb<S?nNWYko[Jf]okVi^Oo2`/;oalO7olc<c?o@d=3od];BomGE
eOoFe]H00_oGemL00ooHf=SofMWIomWIf@3oomWIfDcofMWI00CoKFe]o`00
0?m9BDWo`l?30ooIfMT01_lg=cOo?Cdmokbl_?nl_;co?3`locTi>@;ofMWI
01?o9BDUogemOOoIfMWofMWIogUiNOlX:2SofMWIom?Cdoln?SkoG5aLolo?
cooEeMGofMWIocHf=_lA4A7oI6ATokbl_?m:BT[o@D510?oofMWICooIfMT2
omSHf0;oemOG00coeMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo_knookFe]OnY
ZJWoV9RHokVi^Oo=cLd1om_Kf`0000gof=SHolK6a_n9RHWoTi>Coj:RX_n_
[joo^[Zjol71`Oo7alOobl_;olk>c_o@d=3odM7A00;odm?C0ooDe=@2omGE
e@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oE
eM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGE
eOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]Ko
eMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oF
e]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co`L71o`410OmkNg_oeMGD0_oD
e=@2omGEe@06ol;2`_m4A4Co30`<o``<3?m5ADGo`L710_oEeMD05?lh>3So
Ph>3omKFe_oEeMCoP820ocXj>_oEeMGoJVYZo`H61_l:2P[o5QHFoi6AT?oD
e=Co=CDeofUYJOmUIFGo410@obHV9_nTY:CoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGE
eOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]Ko
eMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oF
e]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oD
e=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00?oe]KFomGEeOoDe=@00_oCdm<03?oAdM7o
d=3@olg=cOo:b/[o`l?3okjn__nf][KoZj^[oifMWOnBTY;oa/K6omSHf07o
h^;R00004_o]kNgog=cLoiFEUOn9RHWoUiNGojFUYOnb/[;o_knool_;booA
dM7oeMGEomOGeooIfMWof][Jom_KfooJf][ofm_KomcLg0Oofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/01_oLg=cofm_Kom_Kfoni
^KWo0@41olK6aP;ofm_K00?og=cLom_KfooKfm/00_oKfm/2om[JfP03om_K
fooLg=cofm_K00Kofm_K00Gog=cLom_KfooKfm_o@T92of5QH@03om_Kf`04
ocLg=om]KFgofm_Kom[JfPCofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00?ofm_K00kof][JomWIfOoHf=Soe]KFom?Cdoo=cLgo`/;2okJf]_n/[:co
WinOoi2@T?nKVi_og=cLong]k@7om_Kf00002ooRh^;oe]KFoj2PX?mjNW[o
R8R8oiJFU_nZZZ[oa<C4omGEeOoKfm_og]kN00;oh>3P0ooRh^800ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<00_oShn<01Om1@D7o<c<coginO_mGEeOoCTi>
00Kohn?S00?oi>CTon?ShooShn<01OoShn<01_oTi>Cohn?Son?ShooShn?o
alO7olG5a@;ohn?S00?oi>CTocPh>?maLG401OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<00ooShn<2on;RhP0=on7QhOoPh>3ogmoOomcLg?oGemOo
aLG5ojb/[?nNWYkoT92@oh:2P_nTY:Coe]KFon;RhP01onSXj00000kogMgM
omKFe_nl_;coNWYjogQhN?n6QXKoWinOolG5aOoHf=SogMgMomoOgooQhN7o
h^;Ron?Sh`?oi>CT1?oUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@05on3Ph?nRXZ;oHV9RogUiNOn[Zj/00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00CoiNGUonCTi?li>CWoLW9b0_oUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND3onCTi00=
on?ShooQhN7oh>3PomoOgooJf][oa/K6oj6QXOn=SHgoP820oh>3Ponm_Kgo
e]KFomgMg@01on;RhP0000_oj>SXon;Rh_oIfMWoWinOofEUIOmcLg?oSHf=
ok^k^ooDe=Cof][JomgMg@02omoOg`03on3Ph?oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@06on;Rh_oQhN7ohN7Qon7QhOoMgMgo
gmoO0_oQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00Go
hN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03
on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;o
hN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQ
hN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00Go
hN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03
on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;o
hN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQ
hN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00Go
hN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03
on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;o
hN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQ
hN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00Go
hN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03
on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;o
hN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQ
hN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00Go
hN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03
on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN402?oQhN403OoPh>3o
gmoOomgMgOoLg=coeMGEokVi^On>SXkoNg]kofi^K_nRXZ;ofMWIon;Rh_oX
j>P00Oo/k>`0000<ooclo?oinOWol_;bonOWionDU9CoHV9RogIfM_nTY:Co
alO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00;og=cL013ofm_KomcLg?oKfm_of][JomWIfOoHf=Sodm?C
olG5aOnLW9coMGEeofMWIonGUiOoinOWoo;bl_oinOWoo?cl0Oono_h0000>
ong]kOoZj^[oinOWon;Rh_o?clooRXZ:oeYJF_mkNg_oXj>Sokbl_?o6a/Ko
bl_;olg=cOo?cll2om7Ad@God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B0_oAdM403Oo@d=3oclo?olc<c?o8b<So^k^koibLW?mbLW;oFe]K
ohf=SOo?clooh^;RonOWiooZj^X00_o]kNd000;oiNGU00koh^;Ron3Ph?oK
fm_oeMGEoiRHV?m/K6coJ6QXoh>3PonGUiOoXj>Sojb/[?n_[joo/K6aok:b
/P;o];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd
]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd
]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H03ond];Co/k>cok:b/_nc/k?o[jn_ojZZZ_nL
W9coPX:2of9RH_m]KFgoVi^KomGEeOoKfm_oh>3Pon;RhP02onGUi@7oi^KV
00004_o^k^kokNg]ong]kOo[jn_oj>SXonGUiOoRh^;obl_;oijNW_mmOGgo
Jf][ofATI?mYJFWoLW9bogAdM?miNGWoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00koO7alogYjN_mj
NW[oMgMgogAdM?m^KVkoLG5aogmoOonNWYkoc<c<on;Rh_oUiNGoj>SXon_[
j`;okNg]0_o^k^h000;ooooo0_ono_h02OomoOgono_kooWinOofm_Kolo?c
oo;bl_o`l?3okno_onk^kP3oong]kOookNg]aOo]kNd02Oo^k^kokno_oo3`
l?obl_;olo?cooKfm_oinOWono_koogmo@02ooknoP?ooooo0004onk^kP;o
kNg]00?ok>c/on[Zj_oZj^X00_oXj>P2onOWioooi^KVoooVi^K5onKViP;o
inOW0_oXj>P2on[ZjP03onc/k?o]kNgokNg]00Gok^k^003oonKVi_ooi^KV
h?oVi^H00?ook^k^ooo^k^kPonk^kP0000goooooookno_ono_koo?clooWi
nOofm_Kol_;bong]kOoXj>Sohn?Son3Ph?oMgMgofm_K00;of][J=OoIfMT2
om[JfP0:om_KfooMgMgoh>3Pon?ShooXj>SokNg]oo;bl_ofm_KonOWioocl
o0;oo_kn1Oooool2ooknoP0:ooclo?oinOWom_Kfoo;bl_o]kNgoj>SXon?S
hooPh>3ogMgMom_Kf`;of][JoooIfMWoomWIfAGofMWI0_oJf]X02_oKfm_o
gMgMon3Ph?oShn?oj>SXong]kOobl_;om_KfooWinOolo?`2ooknoPGooooo
0_ono_h02_olo?conOWiooKfm_obl_;okNg]onSXj?oShn?oh>3PomgMgOoK
fm/2om[JfSGofMWI0_oJf]X02_oKfm_ogMgMon3Ph?oShn?oj>SXong]kOob
l_;om_KfooWinOolo?`2ooknoP;ooooo0002ong]k@0:on[Zj_oXj>Soh^;R
omgMgOoFe]KocLg=olK6a_nn_[ko^[ZjokJf]PCo/k>c<onb/[84ok>c/`0:
okJf]_nj^[[o_[jnolK6a_o=cLgoe]KFomgMgOoRh^;oj>SXon[ZjP;okNg]
0oo^k^h2ong]k@0:on[Zj_oXj>Soh^;RomgMgOoFe]KocLg=olK6a_nn_[ko
^[ZjokJf]PCo/k>coonb/[;ook:b/Q?o/[:b1?nc/k<02_nf][Ko^[Zjokjn
__o6a/KocLg=omKFe_oMgMgoh^;RonSXj?oZj^X2ong]k@?ok^k^0_o]kNd0
2_oZj^[oj>SXon;Rh_oMgMgoe]KFolg=cOo6a/Ko_[jnokZj^_nf][H4ok>c
/c?o/[:b1?nc/k<02_nf][Ko^[Zjokjn__o6a/KocLg=omKFe_oMgMgoh^;R
onSXj?oZj^X2ong]k@7ok^k^00003_oUiNGoh^;RomoOgooJf][od];BolO7
aonm_Kgo/[:bojRXZ?nPX:3oVi^KoiRHV?nDU9CoTi>C=onBTY803OnCTi?o
U9BDoiRHV?nKVi_oX:2PojRXZ?nb/[;o_KfmolO7aooBd];of][JomoOgooR
h^800_oUiND2onKViP0>onGUiOoRh^;ogmoOom[Jf_oBd];oalO7okfm_Onb
/[;oZ:RXoj2PX?nKVi_oV9RHoiBDU?nCTi?ooi:BT_ooTY:B5onBTY803OnC
Ti?oU9BDoiRHV?nKVi_oX:2PojRXZ?nb/[;o_KfmolO7aooBd];of][JomoO
gooRh^800_oUiND2onKViP0>onGUiOoRh^;ogmoOom[Jf_oBd];oalO7okfm
_Onb/[;oZ:RXoj2PX?nKVi_oV9RHoiBDU?nCTi<goi:BTP0=oi>CTonDU9Co
V9RHoi^KVonPX:3oZ:RXok:b/_nm_KgoalO7om;Bd_oJf][ogmoOon;RhP02
onGUi@0000kojn_[onSXj?oRh^;of=SHol_;bonn_[ko[Zj^oj6QXOnEUIGo
S8b<ohF5QOn2PX;oOgmooginOSOoOGem00ooOWinogmoOon2PX;oQHF5ohb<
S?nEUIGoXJ6Qojj^[_nn_[kobl_;omSHf?oRh^;oj>SXon_[joo]kNd00_o^
k^h03_o[jn_oj>SXon;Rh_oHf=Sobl_;okjn__n^[ZkoXJ6QoiFEUOn<S8co
QHF5oh:2P_moOgooOWinoommOGgoogemOAOoOGem00ooOWinogmoOon2PX;o
QHF5ohb<S?nEUIGoXJ6Qojj^[_nn_[kobl_;omSHf?oRh^;oj>SXon_[joo]
kNd00_o^k^h03_o[jn_oj>SXon;Rh_oHf=Sobl_;okjn__n^[ZkoXJ6QoiFE
UOn<S8coQHF5oh:2P_moOgooOWin=ommOGd03_mnOWkoOgmooh:2P_n5QHGo
S8b<oiFEUOnQXJ7o[Zj^okjn__o;bl_of=SHon;Rh_oXj>Sojn_[0Oo]kNd0
000DooWinOoclo?ojNWYomWIfOo7alOo];Bdoj:RX_nJVY[oZZZZol?3`ooI
fMWok>c/ooKfm_ogmoOonOWiooShn?oinOWon_[jooWinOogmoL3ooShn0;o
nOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?o
n?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOog
moL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT04oojn_[o
nOWiooShn?oinOWon?ShooOgmoo^k^kof][JolC4a?nZZZ[oVYZJoj:RX_nd
];CoalO7omWIfOoYjNWolo?cooWinOomoOd00_ooool05?oinOWolo?conWY
jOoIfMWoalO7okBd]?nRXZ;oVYZJojZZZ_o3`l?ofMWIonc/k?ofm_KomoOg
ooWinOohn?SonOWioo[jn_oinOWomoOg0oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi017on?Sh
ooWinOohn?SomoOgonk^k_oJf][oa<C4ojZZZ_nJVY[oXZ:RokBd]?o7alOo
fMWIonWYjOoclo?onOWioogmo@02ooooo`0DooWinOoclo?ojNWYomWIfOo7
alOo];Bdoj:RX_nJVY[oZZZZol?3`ooIfMWok>c/ooKfm_ogmoOonOWiooSh
n?oinOWon_[jooWinOogmoL3ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh0_oinOT04_ojn_[onOWiooShn?oinOWon?ShooOgmoo^
k^kof][JolC4a?nZZZ[oVYZJoj:RX_nd];CoalO7omWIfOoYjNWolo?cooWi
n@7ooOgm00003?oUiNGogMgMolk>c_nm_KgoZ:RXoiFEUOnUYJGoc<c<onk^
k_ofm_Koo?clooknoS_ooooo00goo_knooclo?ogmoOokno_olg=cOnVYZKo
UIFEojRXZ?nm_Kgoc/k>omgMgOoUiNGoj^[Z00;ok^k^00coiNGUomgMgOo>
c/ko_KfmojRXZ?nEUIGoYJFUolc<c?o^k^kom_Kfooclo?ono_kooooooooo
oooo6oooool03Oono_koo?clooOgmoo_knoocLg=ojJVY_nEUIGoZ:RXokfm
_Oo>c/kogMgMonGUiOoZj^X00_o^k^h03?oUiNGogMgMolk>c_nm_KgoZ:RX
oiFEUOnUYJGoc<c<onk^k_ofm_Koo?clooknoS_ooooo00coo_knooclo?og
moOokno_olg=cOnVYZKoUIFEojRXZ?nm_Kgoc/k>omgMgOoUiND1on[ZjP00
00[of][Jolk>c_nm_KgoZ:RXoiJFU_n[Zj_og]kNon_[joodm?Cono_k?ooo
ool02ookno_olo?conc/k?oQhN7o[Zj^oiJFU_nXZ:So_Kfmolk>c_oJf][o
h>3P00;oi^KV00[of][Jolk>c_nm_KgoZ:RXoiJFU_n[Zj_og]kNon_[jood
m?Cono_koooooooooooooaoooooo00_ono_koo?cloo/k>cohN7Qojj^[_nF
UYKoZ:RXokfm_Oo>c/kof][Jon3Ph002onKViP0:om[Jf_o>c/ko_KfmojRX
Z?nFUYKoZj^[omkNg_o[jn_om?Cdoo_kncoooooo00[ono_koo?cloo/k>co
hN7Qojj^[_nFUYKoZ:RXokfm_Oo>c/kof][J0OoPh>00000:omgMgOo=cLgo
^;Rhoj6QXOnXZ:Soe=CDon3Ph?o/k>comOGeoogmoCoooooo00_oo_knooKf
m_o/k>coh^;RomWIfOn/[:coXJ6QokRh^?o=cLgogMgMonGUi@02onk^kP0:
omgMgOo=cLgo^;Rhoj6QXOnXZ:Soe=CDon3Ph?o/k>comOGeoogmoOoooooo
oooooolOooooo`0;ookno_ofm_Kok>c/on;Rh_oIfMWo[:b/oj6QXOnh^;So
cLg=omgMgOoUiND00_o^k^h02_oMgMgocLg=okRh^?nQXJ7oZ:RXomCDe?oP
h>3ok>c/ooGemOomoOdoooooo`0:ookno_ofm_Kok>c/on;Rh_oIfMWo[:b/
oj6QXOnh^;SocLg=omgMg@7oiNGU00002ooXj>Soe=CDokZj^_nYZJWoa/K6
omCDe?oPh>3ok>c/oo;bl_olo?coo_kn03kooooo00_on_[jooCdm?oZj^[o
hn?SomOGeoo=cLgo[:b/okZj^_oDe=Coj>SXoo?cl`02ooooo`0;onSXj?oD
e=Co^[ZjojVYZOo6a/Koe=CDon3Ph?o/k>col_;booclo?ono_h0oooooooo
oooooakooooo00_on_[jooCdm?oZj^[ohn?SomOGeoo=cLgo[:b/okZj^_oD
e=Coj>SXoo?cl`02ooooo`0;onSXj?oDe=Co^[ZjojVYZOo6a/Koe=CDon3P
h?o/k>col_;booclo?ono_h0?_ooool02_ojn_[om?Cdon[Zj_oShn?oemOG
olg=cOn/[:co^[ZjomCDe?oXj>P1oo?cl`0000ooe=CDokno_onVYZKo[:b/
olK6a_oBd];og=cLonKVi_o/k>comOGeooShn?ojn_[ooOgmooooooolo?`0
2?ooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool00_ooool04?omoOgooooo
oogmoOokno_on?ShooCdm?o]kNgoi^KVomoOgooFe]Koc<c<ok:b/_nWYjOo
_knoomCDe?oRh^82onk^kP0?omCDe?no_kooYZJVojb/[?o6a/Kod];BomcL
g?oVi^Kok>c/ooGemOohn?Son_[joogmoOooooooo?cl00Sooooo00?ooOgm
ooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooo
oooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05
ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool0
0oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgm
ooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooo
oooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05
ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool0
0oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgm
ooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooo
oooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05
ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool0
0oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgm
ooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooo
oooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05
ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool0
0oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgm
ooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooo
oooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05
ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool0
0oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgm
ooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooo
oooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05
ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool0
0oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgm
ooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooo
oooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05
ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool0
0oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgm
ooooooooool01Oooool00oomoOgoooooooooo`05ooooo`0CoogmoOoooooo
oooooogmoOoooooooOgmoo_knoohn?Som?Cdong]kOoVi^KogmoOomKFe_o<
c<co/[:bojNWYono_kooe=CDon;RhP02onk^kP0?omCDe?no_kooYZJVojb/
[?o6a/Kod];BomcLg?oVi^Kok>c/ooGemOohn?Son_[joogmoOooooooo?cl
00Sooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05oooo
o`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oom
oOgoooooooooo`05ooooo`03oogmoOoooooooooo00;ooooo00oooOgmoooo
ooomoOgono_kooShn?odm?CokNg]onKVi_oOgmooe]KFolc<c?nb/[;oYjNW
okno_ooDe=@00OoRh^80000Col[:b_ne]KGoWYjNokJf]_o3`l?oclo?omKF
e_oOgmooi^KVon[Zj_o_knoolo?cooCdm?oemOGomoOgooKfm_ogmoOom_Kf
ooShn002ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`0CooKfm_ohn?Som_KfooOgmoof
m_Kom?Cdoo;bl_o`l?3ojn_[onKVi_oQhN7of][Jom?Cdoo9bLWo_knooj>S
Xone]KGob/[:omWIf@02onKViP0Col[:b_ne]KGoWYjNokJf]_o3`l?oclo?
omKFe_oOgmooi^KVon[Zj_o_knoolo?cooCdm?oemOGomoOgooKfm_ogmoOo
m_KfooShn002ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_Kf
ooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_Kf
ooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`0A
ooKfm_ogmoOom_KfooCdm?obl_;ol?3`on_[jooVi^KohN7Qom[Jf_oCdm?o
bLW9okno_onSXj?o]KFeol[:b_oIfMT00_oVi^H04oo:b/[o]KFeoijNW_nf
][Ko`l?3olo?cooFe]KogmoOonKVi_oZj^[okno_oo?cloodm?ComOGeooOg
moofm_KomoOgooKfm_ohn?P00_ogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL04_ofm_Ko
n?ShooKfm_ogmoOom_KfooCdm?obl_;ol?3`on_[jooVi^KohN7Qom[Jf_oC
dm?obLW9okno_onSXj?o]KFeol[:bP7ofMWI00002oo@d=3o^;Rhoj2PX?nc
/k?o`<30olW9bOoCdm?ofMWIomgMgOoRh^;oiNGU00;oj^[Z00?ok>c/ong]
kOo]kNd01oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00Col?3`onk^k_o^k^kok^k^0_o]kNd2
onc/k00=onWYjOoVi^Kohn?Son3Ph?oKfm_oeMGEolg=cOo5aLGo^k^kojNW
Yonh^;Sod=3@on3Ph002onk^kP0;om3@d?nh^;SoX:2Pok>c/oo0`<3obLW9
om?CdooIfMWogMgMon;Rh_oUiND00_oZj^X00oo/k>cokNg]ong]k@07onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h01?o`
l?3ok^k^ong]kOo]kNd2onc/k00=onWYjOoVi^Kohn?Son3Ph?oKfm_oeMGE
olg=cOo5aLGo^k^kojNWYonh^;Sod=3@on3Ph002onk^kP0;om3@d?nh^;So
X:2Pok>c/oo0`<3obLW9om?CdooIfMWogMgMon;Rh_oUiND00_oZj^X00oo/
k>cokNg]ong]k@07onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h01?o`l?3ok^k^onk^k_o^k^h2
ong]k@;ok>c/00cojNWYonKVi_oShn?oh>3Pom_KfooEeMGocLg=olG5aOnk
^k_oYjNWokRh^?o@d=01on3Ph00000goh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgM
g@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4
omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooM
gMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooM
gMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM
1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oo
gMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?o
gMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgM
g@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40
000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]jo
omgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hC
omgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oM
gMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN
_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgo
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN
4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCo
gMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7a
l@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkN
g[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkN
gQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4
omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoI
fMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oN
g]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN
3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oN
g]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN
1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007o
lO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Co
g]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkN
gPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0co
g]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkN
gPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01
omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4
omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oN
g]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<
omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oN
g]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>00
0OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM
1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@So
g]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[o
g]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgM
g@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8
omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool0
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdj
omkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3P
h001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oM
gMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM
2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM
>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:
b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCo
gMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgM
g@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nE
UIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42oooo
o`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgM
gC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool0
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4
omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooM
gMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oV
i^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oM
gMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN
1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?o
gMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;o
oooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCo
gMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42oooo
o`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgo
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkN
gPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hC
omgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2
onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4
omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oV
i^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oN
g]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN
4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN
1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;o
oooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7o
b<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN
3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83o
g]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkN
gQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkN
gPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2
onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
okFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkN
gPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0
omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oN
g]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oa
lO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oN
g]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oN
g]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
P?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kN
POoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0co
g]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:
b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[o
fMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Co
g]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@So
g]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkN
gX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<
omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4
omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oa
lO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
XJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8
omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oN
g]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000go
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM
1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[o
fMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM
2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Co
g]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgM
g@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgM
g@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4
omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q0000
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooM
gMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooM
gMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM
1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@00
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oo
gMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?o
gMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgM
g@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40
000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]jo
omgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hC
omgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oM
gMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN
_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgo
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN
4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCo
gMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Q
h@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkN
g[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkN
gQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4
omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQ
hN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6Q
olS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oN
g]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN
3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oN
g]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN
1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007o
hN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Co
g]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkN
gPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0co
g]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkN
gPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01
on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4
omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6Q
olS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oN
g]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<
omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oN
g]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM40
0OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM
1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@So
g]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[o
g]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgM
g@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8
omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h0
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdj
omkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
d@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oM
gMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM
2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM
>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCo
gMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgM
g@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^
kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgM
gC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h0
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4
omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooM
gMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oM
gMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN
1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?o
gMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;o
k^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCo
gMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^
kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgo
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkN
gPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hC
omgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42
onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4
omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oN
g]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN
4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN
1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;o
k^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN
3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83o
g]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkN
gQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkN
gPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42
onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkN
gPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0
omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oN
g]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oN
g]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oN
g]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
P?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kN
POoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0co
g]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Co
g]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@So
g]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkN
gX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<
omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4
omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8
omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oN
g]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM
1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM
2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nE
UIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Co
g]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgM
g@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgM
g@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4
omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooM
gMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooM
gMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM
1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nE
UIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oo
gMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?o
gMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgM
g@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0
000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]jo
omgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hC
omgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oM
gMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN
_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgo
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN
4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCo
gMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWI
f@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkN
g[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkN
gQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4
omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000Ooa
lO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oN
g]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN
3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oN
g]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:
b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN
1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Co
g]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkN
gPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0co
g]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkN
gPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001
oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4
omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oN
g]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<
omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00go
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oN
g]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:
b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X0
0OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM
1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@So
g]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[o
g]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgM
g@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8
omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H0
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdj
omkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00go
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oM
gMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM
2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM
>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCo
gMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgM
g@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKV
iP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgM
gC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H0
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4
omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooM
gMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_oo
ool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oM
gMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN
1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?o
gMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;o
i^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCo
gMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKV
iP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgo
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkN
gPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hC
omgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42
ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4
omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_oo
ool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oN
g]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN
4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN
1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;o
i^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN
3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83o
g]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkN
gQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7a
l@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkN
gPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42
ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6Q
olS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkN
gPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0
omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oN
g]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oN
g]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oN
g]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
P?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kN
POoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0co
g]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3o
lO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Co
g]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7a
l@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@So
g]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkN
gX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<
omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4
omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8
omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oN
g]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3P
h?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM
1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3o
lO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM
2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Co
g]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:
b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgM
g@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgM
g@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4
omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q0000
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooM
gMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3P
h?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooM
gMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM
1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@00
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oo
gMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:
b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?o
gMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgM
g@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40
000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]jo
omgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hC
omgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oM
gMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN
_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgo
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN
4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCo
gMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Q
h@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7o
b<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkN
g[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkN
gQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4
omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQ
hN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
okFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oN
g]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN
3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oN
g]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN
1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007o
hN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgPcogMgM00?odm?ColW9bOoMgMd0
0ooMgMd00ooAdM7od];BomkNgP05omkNgP03olO7aooKfm_ogMgM00_ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCo
gMgM1?oNg]i`omgMg@03olC4a?ni^KWog=cL00GogMgM00?odm?ColW9bOoM
gMd03?oMgMd00oo6a/Kofm_KomgMg@02omgMg@03om?Cdoo9bLWogMgM033o
gMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgPWogMgM00?oc<c<om_K
fooMgMd00_oCdm<2omgMg@;odM7A00?ogMgMomkNg_oNg]h00ooNg]h00oo7
alOog=cLomkNgP0=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgP07od92@_lK6a_ogMgMomgMgOoIfMWo1`L7oeIFEP03
omgMg@0<olS8b?m0@43o0P82oahN7_lC4a?oYjNWomgMgOlP823o3@d=oa/K
6om3@d?oe]KF0_oNg]h01?ng]kOo820PoaXJ6_nQXJ4<omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN
K_oMgMd04On8R8So410@o`L71olQ8B7o5aLGod51@Onl_;cogMgMolS8b?m0
@43o0P82oahN7_lC4a?oYjNWomgMgOlg=cOoKVi^00;ogMgM01;oSHf=oaPH
6?oMgMgogMgMokJf]_lP823o6QXJoj6QXOoMgMgob<S8od10@?l20P;o7QhN
oa<C4onWYjOogMgMocLg=om^KVh/omgMg@Cog]kN1?oMgMdjomkNgPCogMgM
1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL3?oNg]h00ooMgMgo;Rh^o`000003o`00000>ocXj>_oMgMgoATI6o`H6
1_lF5QKoQhN7oa0@4?m;Bd_ogMgMob0P8?l=3@go6a/Kod92@_oFe]H2omkN
gP05okNg]olP823o6QXJoj6QXOoNg]h03OoMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01
on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL2ooNg]h02?oKfm_o2`/;o`000?o4a<Co
gMgMok2`/?l0003o61PH0ooMgMd03?lj>S[o=cLgol71`OoMgMgod];Bom7A
dOoMgMgoYZJVomWIfOoMgMgo;bl_ogmoO`;og]kN00?oHV9RocPh>?oMgMd0
3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83o
g]kN1?oMgMd4omkNgVgogMgM01;oPh>3o`820_mhN7Sof][JomgMgOoKfm_o
VYZJok^k^ooMgMgo>SXjocLg=oo1`L7ogMgMom;Bd_oAdM7ogMgMocLg=om^
KVh2omgMg@07ohf=SOlH61SogMgMomgMgOmQHF7o>3PhomcLg002omgMg@09
ocXj>_lg=cOo`L71omgMgOoBd];odM7AomgMgOlg=cOoKVi^02cogMgM1?oN
g]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgP03omgMgOl^;RkoI6AT00CogMgM
00KoZj^[o`<30ono_kooalO7odi>C_l>3Ph2omgMg@05ojJVY_oIfMWog=cL
obh^;_moOgl00_oNg]h00omRHV;o>3PhomgMg@02omkNgPgogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
okFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0_og]kN00go[Zj^o`00
0?lj>S[oShn?omgMgOmmOGgo7alOoa0@4?ng]kOogMgMokno_ol0003oWinO
00OogMgM00?oZj^[oa<C4omoOgl00_oNg]h00om3@d?oHf=SomkNgP0=omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4
omgMg@Cog]kNK?oMgMd00ooFe]Ko4A4AoeEEE@06omgMg@03okno_ol0003o
WinO00GogMgM00Ko=cLgofi^K_oMgMgogMgMohf=SOlH61P2omgMg@07od92
@_mRHV;ogMgMomgMgOno_koo0000oinOW`05omgMg@03ocLg=om^KVkogMgM
02_ogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgP03omgMgOl^;Rko
I6AT00CogMgM00Ko_;blo`820_nSXj?ogMgMohV9ROlK6a/4omgMg@03ojZZ
Z_lC4a?oOgmo00;og]kN00?o@d=3of=SHooNg]h00_oNg]h=omgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`;omkNgP0=ogEeMOlW
9bOoPH61oe]KFooMgMgoBd];oeADE?m=CDgoNGUiomgMgOnTY:Co0000oc@d
=003ocHf=P07ojVYZOoMgMgoaLG5od10@?l20P;oHV9RomKFeP02omkNgP03
od=3@omSHf?og]kN00gogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]i/omgMg@03okNg]ol0003oZ:RX
00KogMgM00?oY:BTo`000?ld=3@00olf=SH01?nYZJWogMgMocLg=om^KVh2
omgMg@06ohf=SOlH61SogMgMomgMgOm2@T;oHV9R0_oMgMd00onTY:Co0000
oc@d=003ocHf=P04ojVYZOoMgMgo=cLgofi^KRcogMgM1?oNg]h4omgMgC[o
g]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`<omkNgP03omgMgOl^;RkoI6AT00GogMgM00GoUIFEob/[
:ol/;2co;Rh^oa/K6`02omgMg@05olG5aOm0@43o0P82of5QHOoFe]H00_oN
g]h00om3@d?oHf=SomkNgP02omkNgPgogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000Ooa
lO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0_og]kN01Go?3`lof1PH?nf][Ko9BDUomgM
gOlG5aOoQXJ6oh^;Rolk>c_ogMgMokfm_Ol0003oU9BDok>c/on/[:co0P82
olK6a_oMgMgo>3PhocTi>Onn_[h01?oNg]h00om3@d?oHf=SomkNgP0=omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4
omgMg@Cog]kNK?oMgMd00onKVi_o0000ol?3``06omgMg@0:okfm_Ol0003o
U9BDok>c/on/[:co0P82olK6a_oMgMgo=cLgoe1@D0;ogMgM00KoR8R8oaTI
6OoMgMgogMgMod92@_mRHV82omgMg@0:okfm_Ol0003oU9BDok>c/on/[:co
0P82olK6a_oMgMgo=cLgoe]KFbcogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4
omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`<omkNgP03omgMgOl^;Rko9bLW00;oF5QH00?oKVi^omgMgOoMgMd00_oM
gMd00ooKfm_oP820oa`L7002omgMg@04ocPh>?li>CWo_KfmomgMg@?og]kN
00?o@d=3of=SHooNg]h00_oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`:omkNgP0AomSHf?l71`OoVYZJomcLg?l>3Pko
/k>co`000?ni^KWobLW9o`L71ooEeMGogMgMocHf=_mLG5coe]KFohR8R?lU
9BD00_oMgMd02ol_;booPX:2omkNg_o9bLWofMWIomkNg_oHf=So?clooeiN
G_oDe=CofMWI00cogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=b0omkNgPCogMgM1?oNg]i/omgMg@03ojb/[?l0003o][Jf00Oo
gMgM00Go=SHfoeaLG?oFe]KoR8R8obDU9@02omgMg@0BocLg=olA4A7oIVIV
ol30`?m;Bd_o@T92omgMgOoGemOo?clooeiNG_oCdm?ofMWIomgMgOlf=SKo
G5aLomKFe_n8R8So9BDU0_oMgMd01Olg=cOo410@ogemOOo5aLGofm_K02Wo
gMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:
b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgP03omgMgOl^;Rko?Cdm
00;oR8R800SoUYJFomgMgOoMgMgoW9bLokbl_?oJf][oE5ADodQ8B0;ogMgM
00co;bl_oh:2P_oMgMgobLW9omWIfOoNg]kof=SHoclo?omNGUkoe=CDom[J
f_oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`:omkNgP07ojRXZ?l20P;od=3@omgMgOm1@D7oCDe=o`l?3`02omgMg@08
ob/[:onLW9cogMgMolO7aolm?Cgo2`/;oaPH6?nNWYh2omgMg@0;ojFUYOlb
<S;o3@d=oa0@4?o9bLWog]kNofi^K_l61PKo2PX:oaLG5onFUYH03?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oM
gMd4omkNgVcogMgM00?ocLg=o`410On8R8P01ooMgMd01Oo7alOo?Cdmo`/;
2olH61SoWYjN00;ogMgM01;oB4Q8ogUiNOmXJ6So4A4AobLW9onYZJWogMgM
ofi^K_l61PKo2PX:oaLG5onFUYKogMgMolO7aolm?Cgo2`/;oaPH6?nNWYh2
omgMg@05odQ8B?mfMWKoD51@o`L71oo@d=00:OoMgMd4omkNgPCogMgM>_oN
g]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0cog]kN00?ogMgMobh^;_mTI6@01OoMgMd01OmgMgOo:b/[
o`d=3Ola<C7oZJVY00;ogMgM00coYJFUoc8b<_l=3@go410@olW9bOoNg]ko
KVi^o`H61_l:2P[o5aLGoiNGUooNg]h=omgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007o
hN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`:omkNgP07ofm_Kol_;boogMgMomgMgOmf
MWKo0P82od51@@02omgMg@03ofYZJ_mNGUkogMgM00;ogMgM00?of][JomgM
gOoMgMd01?oMgMd00ooKfm_og]kNomkNgP02omkNgP03od=3@omSHf?og]kN
00gogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0
omkNgPCogMgM1?oNg]i]omgMg@03oeEEEOlP823ocLg=00SogMgM00?of][J
omgMgOoMgMd01OoMgMd00ooLg=cogMgMomgMg@02omgMg@03od92@_mRHV;o
gMgM00CogMgM00?of][JomgMgOoMgMd01OoMgMd00ooJf][ogMgMomgMg@0X
omgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]h00ooMgMgo;Rh^ofAT
I007omgMg@03om_KfooMgMgogMgM00CogMgM00?of][JomgMgOoNg]h00_oN
g]h00om3@d?oHf=SomkNgP02omkNgPgogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000Ooa
lO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0[og]kN00Oo=CDeofUYJOoMgMgogMgMoj^[
Zol0003oLg=c00;ogMgM00?oZJVYob0P8?oMgMd02OoMgMd5omkNgP03ol?3
`oo1`L7og]kN00gogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=b0omkNgPCogMgM1?oNg]i]omgMg@08ol_;bolh>3So6QXJofYZ
J_n2PX;oI6ATobTY:OnTY:@@omgMg@03ol;2`_o0`<3ogMgM03OogMgM1?oN
g]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgP03omgMgOl^;Rko9bLW00?oEeMG
00?oWinOomgMgOoMgMd02_oMgMd3omkNgP03ol?3`oo1`L7og]kN00;og]kN
3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL2_oN
g]h01on<S8co_knoomgMgOoMgMgof=SHohF5QOo1`L400_oMgMd00ooIfMWo
QHF5om[JfP09omgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKV
iP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNgVkogMgM00Oog=cLoiZJ
V_m^KVkoFe]KogIfM_nEUIGod=3@04[ogMgM1?oNg]h4omgMgC[og]kN1?oM
gMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`<omkNgP03omgMgOnHV9SoQHF500?oQHF500?o]KFeomgMgOoMgMd0
2_oMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN
1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;o
k^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN
3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83o
g]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkN
gQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkN
gPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42
onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkN
gPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0
omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oN
g]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oN
g]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oN
g]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
P?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kN
POoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0co
g]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Co
g]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@So
g]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkN
gX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<
omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4
omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8
omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oN
g]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM
1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM
2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Co
g]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgM
g@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgM
g@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4
omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooM
gMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooM
gMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM
1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oo
gMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?o
gMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgM
g@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40
000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]jo
omgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hC
omgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oM
gMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN
_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgo
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN
4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCo
gMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7a
l@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkN
g[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkN
gQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4
omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoI
fMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oN
g]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN
3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oN
g]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN
1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007o
lO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Co
g]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkN
gPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0co
g]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkN
gPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01
omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4
omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oN
g]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<
omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oN
g]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>00
0OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM
1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@So
g]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[o
g]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgM
g@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8
omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool0
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdj
omkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3P
h001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oM
gMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM
2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM
>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:
b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCo
gMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgM
g@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nE
UIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42oooo
o`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgM
gC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool0
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4
omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooM
gMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oV
i^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oM
gMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN
1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?o
gMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;o
oooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCo
gMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42oooo
o`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgo
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkN
gPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hC
omgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2
onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4
omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oV
i^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oN
g]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN
4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN
1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;o
oooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7o
b<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN
3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83o
g]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkN
gQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkN
gPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2
onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
okFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkN
gPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0
omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oN
g]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oa
lO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oN
g]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oN
g]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
P?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kN
POoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0co
g]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:
b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[o
fMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Co
g]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@So
g]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkN
gX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<
omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4
omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oa
lO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
XJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8
omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oN
g]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000go
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM
1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[o
fMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM
2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Co
g]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgM
g@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgM
g@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4
omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q0000
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooM
gMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooM
gMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM
1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@00
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oo
gMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?o
gMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgM
g@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40
000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]jo
omgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hC
omgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oM
gMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN
_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgo
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN
4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCo
gMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Q
h@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkN
g[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkN
gQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4
omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQ
hN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6Q
olS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oN
g]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN
3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oN
g]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN
1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007o
hN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Co
g]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkN
gPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0co
g]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkN
gPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01
on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4
omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6Q
olS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oN
g]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<
omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oN
g]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM40
0OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM
1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@So
g]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[o
g]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgM
g@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8
omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h0
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdj
omkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
d@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oM
gMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM
2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM
>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCo
gMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgM
g@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^
kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgM
gC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h0
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4
omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooM
gMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oM
gMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN
1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?o
gMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;o
k^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCo
gMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^
kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgo
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkN
gPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hC
omgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42
onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4
omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oN
g]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN
4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN
1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;o
k^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN
3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83o
g]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkN
gQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkN
gPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42
onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkN
gPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0
omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oN
g]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oN
g]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oN
g]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
P?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kN
POoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0co
g]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Co
g]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@So
g]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkN
gX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<
omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4
omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8
omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oN
g]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM
1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM
2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nE
UIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Co
g]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgM
g@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgM
g@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4
omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooM
gMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooM
gMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM
1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3PolS8b?nE
UIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oo
gMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?o
gMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgM
g@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0
000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]jo
omgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hC
omgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oM
gMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN
_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgo
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN
4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCo
gMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWI
f@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkN
g[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkN
gQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4
omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000Ooa
lO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oN
g]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN
3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oN
g]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:
b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN
1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Co
g]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkN
gPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0co
g]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkN
gPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo00goh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001
oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4
omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oN
g]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<
omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00go
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oN
g]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKViP0=ol[:
b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X0
0OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM
1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@So
g]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[o
g]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_ooool03OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgM
g@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8
omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H0
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdj
omkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;oi^KV00go
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oM
gMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM
2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM
>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42ooooo`0=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCo
gMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgM
g@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKV
iP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgM
gC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H0
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4
omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooM
gMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_oo
ool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oM
gMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@;ooooo
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN
1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?o
gMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;o
i^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCo
gMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT2onKV
iP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgo
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkN
gPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hC
omgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42
ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4
omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0_oo
ool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLP?oN
g]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN
4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN
1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@;o
i^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN
3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg83o
g]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkN
gQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7a
l@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4omkN
gPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO42
ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6Q
olS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkN
gPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=b0
omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oNg]j1
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oN
g]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM1?oN
g]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
0_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oN
g]h=omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
P?oNg]h4omgMg@Cog]kN_ooMgMd4omkNgPCogMgM>_oNg]h4omgMg@Cog]kN
POoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0co
g]kN4ooMgMd8omkNgPgogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3o
lO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=b0omkNgPCogMgM1?oNg]joomgMg@Co
g]kN1?oMgMdjomkNgPCogMgM1?oNg]j1omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7a
l@;ooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL3?oNg]hComgMg@So
g]kN3OoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN42onk^kP0=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g83og]kN1?oMgMd4omkNg[oogMgM1?oNg]h4omgMgC[og]kN1?oMgMd4omkN
gX7ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`<
omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@;oi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLP?oNg]h4omgMg@Cog]kN_ooMgMd4
omkNgPCogMgM>_oNg]h4omgMg@Cog]kNPOoMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8omkNgPgogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0cog]kN4ooMgMd8
omkNgPgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0_o^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=b0omkNgPCogMgM1?oNg]joomgMg@Cog]kN1?oMgMdjomkNgPCogMgM1?oN
g]j1omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@;ok^k^00godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL3?oNg]hComgMg@Sog]kN3OoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3P
h?oalO42ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg83og]kN1?oMgMd4omkNg[oogMgM
1?oNg]h4omgMgC[og]kN1?oMgMd4omkNgX7ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3o
lO7a0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`<omkNgQ?ogMgM2?oNg]h=omgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3P007olO7a00003Oo@d=3o^;RhoibLW?n/[:co^k^kolK6
a_o=cLgodm?ComOGeooKfm_ogmoOon7QhOoRh^800_oShn<7onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H3onGUi@;oi>CT0_oShn<03OoRh^;oh>3PomcLg?oIfMWoe]KFom3@
d?o9bLWo`L71okFe]OnUYJGo^;Rhom3@d?oPh>000_o^k^h03Oo@d=3o^;Rh
oibLW?n/[:co^k^kolK6a_o=cLgodm?ComOGeooKfm_ogmoOon7QhOoRh^80
0_oShn<7onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H00ooUiNGoi>CT
onCTi002on?Sh`0=on;Rh_oPh>3og=cLomWIfOoFe]Kod=3@olW9bOo1`L7o
]KFeojFUYOnh^;Sod=3@on3Ph002onk^kP0=om3@d?nh^;SoW9bLojb/[?nk
^k_oa/K6olg=cOoCdm?oemOGom_KfooOgmoohN7Qon;RhP02on?Sh`OoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViP?oiNGU0_oTi>@2on?Sh`0<on;Rh_oPh>3og=cLomWIfOoF
e]Kod=3@olW9bOo1`L7o]KFeojFUYOnh^;Sod=3@0OoPh>00000=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0_oMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
b_oIfMT2onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@05omkN
g_oMgMgogMgMomkNg_oMgMd00_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0_oVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`2omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkN
gP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM
00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP;ogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/X00OoIfMT0000=omCDe?no_kooS8b<oijNW_n][Jgo^KViol;2`_o7
alOoc<c<om3@d?oBd];oeMGEomKFeP02omOGe`03omSHf?oIfMWofMWI037o
fMWI0_oHf=P2omOGe`0=omGEeOoCdm?od=3@olk>c_o:b/[oaLG5okno_one
]KGoZJVYoiRHV?no_kooe=CDon;RhP02onk^kP0=omCDe?no_kooS8b<oijN
W_n][Jgo^KViol;2`_o7alOoc<c<om3@d?oBd];oeMGEomKFeP02omOGe`03
omSHf?oIfMWofMWI0?oofMWIoooIfMTAomWIf@;of=SH0_oGemL03OoEeMGo
dm?Com3@d?o>c/kob/[:olG5aOno_koo]KFeojVYZOnHV9So_knoomCDe?oR
h^800_o^k^h03OoDe=Co_knoohb<S?nNWYko[Jf]okVi^Oo2`/;oalO7olc<
c?o@d=3od];BomGEeOoFe]H00_oGemL00ooHf=SofMWIomWIf@0aomWIf@;o
f=SH0_oGemL03?oEeMGodm?Com3@d?o>c/kob/[:olG5aOno_koo]KFeojVY
ZOnHV9So_knoomCDe07oh^;R00003OoXj>Soe=CDohb<S?nCTi?oXZ:Rojn_
[onj^[[o`L71olO7aoo;bl_oc/k>om3@d?oAdM400_oCdm<3omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE013oe=CDom?CdooC
dm?odM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jfoj^[ZonMWIgoUIFEomCD
e?oXj>Solo?c0_ooool03OoXj>Soe=CDohb<S?nCTi?oXZ:Rojn_[onj^[[o
`L71olO7aoo;bl_oc/k>om3@d?oAdM400_oCdm<3omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGE
eOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]Ko
eMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oF
e]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oD
e=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGE
e@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oE
eM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01ooFe]KoeMGEomKFe_oEeMCoe=CDomGEeOoDe=@0
0_oCdm<03OoAdM7od=3@olg=cOo:b/[o`l?3okjn__nf][KoZj^[oifMWOnE
UIGoe=CDonSXj?oclo<00_ooool03OoXj>Soe=CDohb<S?nCTi?oXZ:Rojn_
[onj^[[o`L71olO7aoo;bl_oc/k>om3@d?oAdM400_oCdm<3omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00ooe=CDom?CdooC
dm?odM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jfoj^[ZonMWIgoUIFEomCD
e?oXj>P00Ooclo<0000BomgMgOo=cLgoT92@ohV9ROnGUiOoYJFUok:b/_no
_koobl_;om7AdOoEeMGoemOGomWIfOoJf][ofm_Kom[Jf_oKfm_og=cL1ooK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o
g=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oK
fm_ofm_K00Gofm_K01?og=cLom_KfooKfm_ofm_Kom[Jf_oIfMWof=SHomKF
e_oCdm?ocLg=ol;2`_nf][Ko[:b/oinOWon@T93oUYJFolg=cOoMgMgoiNGU
00;ok^k^01;ogMgMolg=cOn@T93oRHV9oiNGUonUYJGo/[:bokno_oo;bl_o
dM7AomGEeOoGemOofMWIom[Jf_oKfm_of][Jom_KfooLg=`7om_Kf`03omcL
g?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_K
om_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/0
1OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K
00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcL
g?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_K
om_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/0
1OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K
00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcL
g?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_K
om_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/0
1OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K
00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcL
g?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_K
om_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/0
1OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K
00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcL
g?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_K
om_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/0
1OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K
00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcL
g?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_K
om_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/0
1OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K
00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcL
g?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_K
om_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/0
1OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K
00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcL
g?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01ooKfm/03ooJf][ofMWI
omSHf?oFe]Kodm?Colg=cOo2`/;o][Jfojb/[?nOWiooT92@oiJFU_o=cLgo
gMgMonGUi@02onk^kP0BomgMgOo=cLgoT92@ohV9ROnGUiOoYJFUok:b/_no
_koobl_;om7AdOoEeMGoemOGomWIfOoJf][ofm_Kom[Jf_oKfm_og=cL1ooK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o
g=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oK
fm_ofm_K00Gofm_K01;og=cLom_KfooKfm_ofm_Kom[Jf_oIfMWof=SHomKF
e_oCdm?ocLg=ol;2`_nf][Ko[:b/oinOWon@T93oUYJFolg=cOoMgMd1onGU
i@0000_of][Jolk>c_nLW9coNWYjohR8R?nFUYKoZZZZolC4a?oEeMGofm_K
omkNgP02on3Ph0?oh^;R00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<0
1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00Coi>CTon?ShooShn?ohn?S0_oRh^803_oQhN7oh>3PomoOgooLg=coemOG
olG5aOn/[:coWYjNoi2@T?n2PX;oX:2Polk>c_oJf][oh>3P0_oVi^H02ooJ
f][oc/k>oibLW?mjNW[oR8R8oiJFU_nZZZ[oa<C4omGEeOoKfm_og]kN00;o
h>3P0ooRh^800ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<04_oTi>Cohn?Son;Rh_oRh^;ohN7Q
on3Ph?oOgmoog=cLomOGeoo5aLGo[:b/oijNW_n@T93oPX:2oj2PX?o>c/ko
f][Jon3Ph0;oi^KV00_of][Jolk>c_nLW9coNWYjohR8R?nFUYKoZZZZolC4
a?oEeMGofm_KomkNgP02on3Ph0?oh^;R00?oi>CTon?ShooShn<01OoShn<0
0ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CT
on?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?o
hn?S00Gohn?S00Coi>CTon?ShooShn?ohn?S0_oRh^803OoQhN7oh>3PomoO
gooLg=coemOGolG5aOn/[:coWYjNoi2@T?n2PX;oX:2Polk>c_oJf]X00OoP
h>00000>onGUiOoMgMgo`/;2og]kNomhN7SoQXJ6oinOWoo5aLGof=SHomgM
gOoOgmoohN7Qon;Rh_oShn<3onCTi0CoiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi004onGUiOoTi>CoiNGUonGUi@?oi>CT
00kohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4ol?3
`ooMgMgoiNGUon[ZjP;ok^k^00koiNGUomgMgOo2`/;oNg]kogQhN?n6QXKo
WinOolG5aOoHf=SogMgMomoOgooQhN7oh^;Ron?Sh`?oi>CT1?oUiND2onCT
i003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGU
i@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU
00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCT
i?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooU
iNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCT
i003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGU
i@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU
00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCT
i?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooU
iNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCT
i003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGU
i@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU
00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCT
i?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooU
iNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCT
i003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGU
i@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU
00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCT
i?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooU
iNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCT
i003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGU
i@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU
00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCT
i?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooU
iNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCT
i003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGU
i@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU
00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCT
i?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooU
iNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCT
i003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGU
i@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU
00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCT
i?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooU
iNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCT
i003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGU
i@;oi>CT00?oiNGUonCTi?oTi>@00_oTi>@03_oShn?ohN7Qon3Ph?oOgmoo
f][JolK6a_nQXJ7oSHf=oh20P?n4Q8Co`l?3omgMgOoUiNGoj^[Z0_o^k^h0
3_oUiNGogMgMol;2`_mkNg_oN7QhohJ6Q_nOWiooaLG5omSHf?oMgMgogmoO
on7QhOoRh^;ohn?S0ooTi>@4onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@01?oUiNGoi>CTonGUiOoUiND3onCTi00=on?S
hooQhN7oh>3PomoOgooJf][oa/K6oj6QXOn=SHgoP820ohB4Q?o3`l?ogMgM
onGUi@01on[ZjP0000_onOWioo?clooYjNWoZ:RXofEUIOmcLg?oSHf=ok^k
^ooDe=Cof][JomgMg@02omoOg`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00KohN7Q00koh>3PomoOgooMgMgog=cLomGE
eOni^KWoSXj>og]kNom^KVkoZj^[onWYjOoclo?onOWioogmo@;ooooo00_o
nOWioo?clooYjNWoZ:RXofEUIOmcLg?oSHf=ok^k^ooDe=Cof][JomgMg@02
omoOg`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00CohN7Q00koh>3P
omoOgooMgMgog=cLomGEeOni^KWoSXj>og]kNom^KVkoZj^[onWYjOoclo?o
nOWioogmo@;ooooo00_onOWioo?clooYjNWoZ:RXofEUIOmcLg?oSHf=ok^k
^ooDe=Cof][JomgMg@02omoOg`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00KohN7Q00goh>3PomoOgooMgMgog=cLomGE
eOni^KWoSXj>og]kNom^KVkoZj^[onWYjOoclo?onOWi007ooOgm00003?o[
jn_oj>SXon;Rh_oGemOoSHf=of9RH_mfMWKoY:BTolO7aooBd];oeMGEomSH
f0;of][J0ooKfm/7omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL
00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`05?oKfm_og=cLomcLg?oKfm_o
g=cLom_KfooJf][ofMWIomSHf?oCdm?oaLG5oibLW?meMGGoIfMWoi2@T?oG
emOoh^;RonSXj?o[jn_okNg]0_o^k^h03?o[jn_oj>SXon;Rh_oGemOoSHf=
of9RH_mfMWKoY:BTolO7aooBd];oeMGEomSHf0;of][J0ooKfm/7omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oL
g=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Go
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oL
g=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Go
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oL
g=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Go
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oL
g=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Go
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oL
g=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Go
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oL
g=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Go
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oL
g=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Go
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`2om_Kf`0@
omcLg?oKfm_of][JomWIfOoHf=Sodm?ColG5aOnLW9coMGEeofMWIon@T93o
emOGon;Rh_oXj>Sojn_[ong]k@;ok^k^00cojn_[onSXj?oRh^;oemOGohf=
SOmRHV;oMWIfojBTY?o7alOod];BomGEeOoHf=P2om[JfP?ofm_K1ooLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL01?ofm_KomcLg?oLg=cofm_KomcLg?oKfm_of][JomWIfOoH
f=Sodm?ColG5aOnLW9coMGEeofMWIon@T93oemOGon;Rh_oXj>Sojn_[007o
kNg]00003_oUiNGoh^;RomoOgooJf][obLW9ohN7QomJFU[oNg]koj>SXonl
_;coa/K6ol_;boo=cLgoclo?0_oAdM45om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03
om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7o
d];Bom7Ad@03om;BdP;odM7A00god=3@olo?coo<c<cob<S8ok^k^onLW9co
LW9boe]KFon:RX[obLW9om[Jf_oOgmooh^;R00;oiNGU0_oVi^H03_oUiNGo
h^;RomoOgooJf][obLW9ohN7QomJFU[oNg]koj>SXonl_;coa/K6ol_;boo=
cLgoclo?0_oAdM45om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]801?oAdM7od];Bom7AdOoBd]82om7Ad@0=om3@d?o?cloo
c<c<olS8b?nk^k_oW9bLog9bL_mKFe_oRXZ:olW9bOoJf][ogmoOon;RhP02
onGUi@;oi^KV00koiNGUon;Rh_oOgmoof][JolW9bOn7QhOoFUYJog]kNonS
Xj?o_;blolK6a_o;bl_ocLg=olo?c`;odM7A1OoBd]800ooAdM7od];Bom7A
d@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM400ooBd]82om7Ad@0=om3@d?o?clooc<c<olS8b?nk^k_o
W9bLog9bL_mKFe_oRXZ:olW9bOoJf][ogmoOon;RhP02onGUi@000_o]kNd0
3_oZj^[oj>SXon;Rh_oLg=coW9bLofe]KOmXJ6SoPh>3oiNGUonSXj?o[:b/
ojn_[ona/K7o/[:b0_nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@04one]KGo][JdokBd
]?nd];Co][Jfok>c/onb/[;o/k>cojn_[onZZZ[oW9bLoh:2P_mRHV;oKVi^
oinOWooLg=coh^;RonSXj?oZj^X00_o]kNd3onk^kP;okNg]00koj^[ZonSX
j?oRh^;og=cLoibLW?m]KFgoJ6QXoh>3PonGUiOoXj>Sojb/[?n_[joo/K6a
ok:b/P;o];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd
]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd017o]KFe
okJf]?nd];Co/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9RH_m^KVko
WinOomcLg?oRh^;oj>SXon[ZjP02ong]k@?ok^k^0_o]kNd03_oZj^[oj>SX
on;Rh_oLg=coW9bLofe]KOmXJ6SoPh>3oiNGUonSXj?o[:b/ojn_[ona/K7o
/[:b0_nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@04one]KGo][JdokBd]?nd];Co][Jf
ok>c/onb/[;o/k>cojn_[onZZZ[oW9bLoh:2P_mRHV;oKVi^oinOWooLg=co
h^;RonSXj?oZj^X00_o]kNd1onk^kP0001;oooooookno_ono_koo?clooWi
nOofm_Kol_;bomWIfOnXZ:SoPh>3ofi^K_mUIFGoJFUYog9bL_mdM7CoNGUi
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00OoO7alog]kNoml
O7coOGelogalO?mkNg_oOGem00;oNWYj00_oMgMgogAdM?m_KfooM7AdohF5
QOnXZ:Sof][Joo;bl_ofm_KonOWiooclo002ooknoPGooooo0_ono_h03ool
o?conOWiooKfm_obl_;ofMWIojRXZ?n3Ph?oKVi^ofEUIOmYJFWoLW9bogAd
M?miNGWoO7alog]kN`02ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00GoO7alog]kNomlO7coOGelogalO002ogYjNP0;ogMgMomd
M7CoKfm_ogAdM?n5QHGoZ:RXom[Jf_obl_;om_KfooWinOolo?`00_ono_h5
ooooo`;oo_kn00ooo?clooWinOofm_Kol_;bomWIfOnXZ:SoPh>3ofi^K_mU
IFGoJFUYog9bL_mdM7CoNGUiogalO?mkNg/00_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@07ogalO?mkNg_oO7alogemO?mlO7coNg]kogemO@02ogYjNP0;
ogMgMomdM7CoKfm_ogAdM?n5QHGoZ:RXom[Jf_obl_;om_KfooWinOolo?`0
0_ono_h2ooooo`000_o^k^h2ong]k@04onc/k?oZj^[oj>SXonGUi@;oh^;R
00?oh>3PomoOgooNg]h0>OoMgMd00ooNg]kogmoOon3Ph002on;RhP04onGU
iOoXj>Soj^[Zonc/k0;okNg]1oo^k^h2ong]k@04onc/k?oZj^[oj>SXonGU
i@;oh^;R00?oh>3PomoOgooNg]h0oooMgMgoomgMgAWogMgM00?og]kNomoO
gooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/k>`2ong]k@Ook^k^0_o]kNd0
1?o/k>coj^[ZonSXj?oUiND2on;RhP03on3Ph?oOgmoog]kN03WogMgM00?o
g]kNomoOgooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/k>`2ong]k@?ok^k^
0004onKViP;oiNGU00?oi>CTon;Rh_oRh^800_oPh>02omoOgcWog]kN0_oO
gml2on3Ph0;oh^;R00?oi>CTonGUiOoUiND02ooVi^H2onGUi@03onCTi?oR
h^;oh^;R00;oh>3P0_oOgmooomkNg_oog]kN6OoNg]h2omoOg`;oh>3P0_oR
h^800ooTi>CoiNGUonGUi@0;onKViP;oiNGU00?oi>CTon;Rh_oRh^800_oP
h>02omoOgcWog]kN0_oOgml2on3Ph0;oh^;R00?oi>CTonGUiOoUiND01OoV
i^H00?ook^k^ooo^k^kPonk^kP00ooooooooooooon3ooooo00003Oo^k^ko
kNg]ong]kOo[jn_oj>SXonGUiOoRh^;ogMgMomSHf?oDe=CodM7Aolk>c_o<
c<`00_o;bl_ool[:b_oob/[:`Oo:b/X2ol_;b`0:olc<c?o>c/kodM7AomCD
e?oHf=SogMgMon;Rh_oUiNGoj>SXon_[j`;okNg]0_o^k^h000;oiNGU00[o
h^;Ron3Ph?oKfm_oe]KFolk>c_o7alOo_knookRh^?nd];Co/;2`0_n^[Zh2
ojf][Ooo[:b/oon/[:boojb/[0;o[Jf]0_n^[Zh02_n`/;3o];BdokRh^?no
_kooalO7olk>c_oFe]Kofm_Kon3Ph?oRh^82onGUi@7oi^KV00003_o]kNgo
j^[ZonOWiooRh^;ofMWIolk>c_o3`l?o^;Rhojj^[_nVYZKoX:2PoibLW?nI
VIWoV9RHoonGUiOooiNGUl?oUiNG00goV9RHoiVIVOnLW9coX:2PojJVY_n^
[Zko^;Rhol?3`oo>c/kofMWIon;Rh_oWinOoj^[Z00;okNg]00003_olo?co
nOWioo;bl_oXj>Sof][Jol_;bonj^[[o[:b/oinOWonEUIGoSXj>ohZ:R_n7
QhOoQXJ6oon5QHGoohF5QL?oQHF500koQXJ6ohN7Qon:RX[oSXj>oiFEUOnO
Wioo[:b/okZj^_o;bl_of][JonSXj?obl_;onOWiooclo07oo_kn00005?oX
j>Soh^;RomWIfOo:b/[o^[ZjojRXZ?nHV9SoTY:BojFUYOo0`<3oemOGon_[
joofm_KomoOgooWinOohn?SonOWioo[jn_oinOWomoOg0oohn?P2ooWin@03
oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;o
nOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?o
n?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOog
moL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[o
nOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03
oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;o
nOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?o
n?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOog
moL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[o
nOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03
oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;o
nOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?o
n?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOog
moL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[o
nOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03
oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;o
nOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?o
n?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOog
moL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[o
nOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03
oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;o
nOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?o
n?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOog
moL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[o
nOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03
oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;o
nOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?o
n?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOog
moL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[o
nOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03
oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;o
nOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?o
n?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOog
moL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[o
nOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03
oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;o
nOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?o
n?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOog
moL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[o
nOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03
oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;o
nOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?o
n?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOog
moL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[o
nOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03
oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;o
nOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?o
n?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOog
moL00_ohn?P03ooinOWon?ShooOgmoo]kNgof=SHol71`OnUYJGoTY:BoiRH
V?nXZ:So^[Zjol[:b_oIfMWoh^;RonSXj001onc/k00000cogMgMomKFe_o7
alOo]kNgoj>SXonATI7oXZ:Rol_;boo^k^kom_Kfooclo?ono_kooooooooo
ooooaoooool03?ono_koo?clooOgmoo_knooc<c<oj>SXonATI7oXj>SokNg
]oo7alOoe]KFomgMg@7oh^;R00002_oRh^;oe]KFol?3`on^[ZkoVYZJojf]
[OoNg]kojn_[ooCdm?okno_oooooooooooooboooool02_okno_olo?conc/
k?oQhN7o/;2`oiZJV_n^[Zko`l?3omKFe_oRh^81onSXj00000[okNg]omcL
g?o5aLGo[:b/ojf][OoDe=Coh>3Ponc/k?oemOGooOgmoooooooooooool_o
oooo00[oo_knooKfm_o/k>coh^;RomWIfOna/K7o[:b/olG5aOoLg=cokNg]
0Oofm_H0000;omSHf?o6a/Ko[Zj^oj>SXoo6a/Koe=CDon3Ph?o/k>col_;b
ooclo?ono_h0oooooomOooooo`03onc/k?o_knoooooo00[ooooo00?oiNGU
oogmoOooool0oooooomKooooo`0:oo[jn_odm?Coj^[Zon?ShooGemOocLg=
ojJVY_n^[Zkoa/K6omSHf07oh^;R00003oo=cLgo^KVioj6QXOn[Zj_oa/K6
om;Bd_oLg=coi^KVonc/k?oemOGon?Shoo[jn_omoOgoooooooclo008oooo
o`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oom
oOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooo
ooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo
00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05oooo
o`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oom
oOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooo
ooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo
00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05oooo
o`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oom
oOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooo
ooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo
00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05oooo
o`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oom
oOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooo
ooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo
00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05oooo
o`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oom
oOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooo
ooooool00oooool00olf=SKoYJFUoogmo@02ooooo`03ol71`Ol10@7oVi^K
00;ooooo00KofMWIocDe=Ol>3Pko30`<ocTi>OoLg=`2ooooo`03oclo?omo
Ogoooooo00;ooooo00Oodm?CobDU9OlN7Qko^;Rhoooooom0@43oOgmo00;o
oooo00?oXj>Soa`L7?omoOd01oooool00oomoOgoooooooooo`05ooooo`03
oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgo
ooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooooooo
ool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Go
oooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03
oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgo
ooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooooooo
ool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Go
oooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03
oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgo
ooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooooooo
ool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Go
oooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03
oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgo
ooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooooooo
ool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Go
oooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03
oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgo
ooooooooo`05ooooo`03oogmoOoooooooooo00Cooooo00oooOgmooooooom
oOgono_kooShn?odm?CokNg]onKVi_oOgmooe]KFolc<c?na/K7oXZ:RokVi
^Oo=cLd00OoKfm/0000Com7AdOnk^k_oXJ6QokJf]_o3`l?oclo?omKFe_oO
gmooi^KVon[Zj_o_knoolo?cooCdm?oemOGomoOgooKfm_ogmoOom_KfooSh
n002ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_Kf
ooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Kom_KfooShn?ogmoOomoOgoc@d=?nOWil2ooOgm`0F
ong]kOlS8b?o0000oiJFU_ofm_KomOGeoc8b<_m?CdooiNGUonOWiomBDU;o
<c<cooGemOofm_Ko?Cdmog]kNoofm_Kon?ShooOgmom]KFgo?ShnooGem@;o
moOg00Ko?Cdmog]kNoogmoOomoOgoifMWOlK6a/2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_Kf
ooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg01Com_KfooShn?ogmoOomoOgooKfm_ogmoOom_KfooCd
m?obl_;ol?3`on_[jooVi^KohN7Qom[Jf_oCdm?obLW9okno_onVYZKo^k^k
om7Ad@7ohN7Q00002ooOgmooaLG5ojBTY?nc/k?o`<30olW9bOoCdm?ofMWI
omgMgOoRh^;oiNGU00;oj^[Z00?ok>c/ong]kOo]kNd01oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00?o
k^k^00co<S8boiZJV_o`l?3ok^k^ofe]KOlA4A7o:2PXoi2@T?o^k^kobLW9
o`000?nZZZX2onk^kP06ojZZZ_l0003ocLg=onk^k_ll?3coMWIf0oo^k^h0
1om7AdOoJVYZonk^k_o`l?3ok^k^oc/k>omfMWH00_o^k^h00onHV9So6QXJ
oo3`l007onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h00oo^k^h2ong]k@;ok>c/00cojNWYonKVi_oShn?o
h>3Pom_KfooEeMGocLg=olG5aOnk^k_oZj^[olG5aOoOgml1oo3`l00000go
d=3@okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoOgooQ
hN7oh^;R00;ohn?S1ooUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oU
iND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oV
i^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oU
iND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oV
i^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oU
iND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oV
i^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oU
iND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oV
i^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oU
iND2onKViPKoiNGU0_oVi^H5onGUi@0<oc0`<?nDU9Coi^KVokFe]Ol20P;o
TY:BocPh>?n;Rh_oiNGUoj^[Zol0003oc/k>0_oUiND01_o<c<co0000ojf]
[OoVi^Ko>CTiog9bLP?oiNGU00OoADE5ofIVI_oVi^Koi^KVonGUiOli>CWo
LW9b00;oiNGU00?oTY:BoaTI6OoVi^H01_oUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2
onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2
onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2
onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2
onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H5onGUi@;oi>CT0_oShn<0
3?oRh^;oh>3PomcLg?oIfMWoe]KFom3@d?o9bLWo`L71okFe]OnUYJGo^;Rh
om3@d07oh>3P00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`2omkNgP?ogMgM00?og]kNomgM
gOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooN
g]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkN
gP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM
00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgM
gOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooN
g]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkN
gP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM
00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgM
gOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooN
g]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkN
gP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM
00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgM
gOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooN
g]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkN
gP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM
00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgM
gOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooN
g]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd05Ol_;booShn?omSHf?lV9RKo
@410omgMgOlf=SKoQXJ6omkNg_nn_[ko0000oibLW?oNg]kogMgMoiZJV_l0
003o`l?3omgMgOlg=cOoFe]KomkNgP02omgMg@07od92@_mSHf?ogMgMomgM
gOoNg]ko=cLgoe1@D002omgMg@03ohR8R?lI6AWogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h4omgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:007ofMWI00003OoDe=Co_knoohb<S?nNWYko[Jf]okVi^Oo2`/;oalO7
olc<c?o@d=3od];BomGEeOoFe]H00_oGemL00ooHf=SofMWIomWIf@3oomWI
fDcofMWI00So;Bd]ohb<S?m/K6co2`/;ol71`OoIfMWo=CDeoh>3P`;ofMWI
00Ko=cLgocdm?Onl_;co_;bloc`l??li>CT2omWIf@0@ocHf=_l@413oNg]k
ol;2`_oAdM7o?ShnoeaLG?o?clooeMGEomWIfOlf=SKo4A4AofATI?nl_;co
BTY:od51@OoofMWICooIfMT2omSHf0;oemOG00coeMGEom?Cdoo@d=3oc/k>
ol[:b_o5aLGo_knookFe]OnYZJWoV9RHokno_ooDe=@1on;RhP0000goj>SX
omCDe?n<S8coTi>Coj:RX_n_[joo^[Zjol71`Oo7alOobl_;olk>c_o@d=3o
dM7A00;odm?C0ooDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]Ko
eMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oF
e]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oD
e=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGE
e@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oE
eM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00go
e]KFobd];OmTI6Co10@4ogemOOoDe=CoeMGEoc@d=?n2PX;oeMGEomKFe_o1
`L3oA4A400;o30`<01GoATI6ol?3`ooEeMGoe]KFodI6AOmaLG7oCDe=o`L7
1omSHf?o1PH6o`X:2_lF5QKoTI6@omCDe?le=CGoJFUYofEUIOl@413o9RHV
ojBTY?oEeM@00_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]Ko
eMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oF
e]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oD
e=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGE
e@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oE
eM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00?o
e]KFomGEeOoDe=@00_oCdm<03?oAdM7od=3@olg=cOo:b/[o`l?3okjn__nf
][KoZj^[oifMWOnEUIGoe=CDonSXj07olo?c00004_oMgMgocLg=oi2@T?n9
RHWoUiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooIfMWof][Jom_K
fooJf][ofm_KomcLg0Oofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/03?oLg=cofm_Kom_KfooKfm_o;Rh^o`@41?lf=SKofm_KomcL
g?oKfm_o=SHfohF5Q@Gofm_K00?of][Jom_KfooKfm/01?oKfm/01OoLg=co
f=SHom_Kfom2@T;oHF5Q00?ofm_K00Co=cLgofe]KOoKfm_of][J1?oKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/00ooKfm/03_oJf][ofMWIomSHf?oF
e]Kodm?Colg=cOo2`/;o][Jfojb/[?nOWiooT92@oiJFU_o=cLgogMgM0OoU
iND0000;om[Jf_o>c/koW9bLogYjN_n8R8SoUYJFojZZZ_o4a<CoeMGEom_K
fooNg]h00_oPh>03on;RhP03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?S
hooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?S
h`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooT
i>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?S
hooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?S
h`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooT
i>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?S
hooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?S
h`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooT
i>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?S
hooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?S
h`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooT
i>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?S
hooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`02on?S
h`04oc0`<?l820So`l?3onCTi0;ohn?S00?o>3PhohV9ROoShn<00_oShn<0
0ooTi>Cohn?Son?Sh`05on?Sh`06onCTi?oShn?ohn?Son?Shoo7alOoaLG5
0_oShn<00ooTi>Co>3Phog5aL@05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<0
1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<0
1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<0
1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<0
1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`03on?Sh`;oh^;R00gohN7Qon3Ph?oOgmoog=cLomOGeoo5aLGo[:b/
oijNW_n@T93oPX:2oj2PX?o>c/kof][J007oh>3P00003_oUiNGogMgMol;2
`_mkNg_oN7QhohJ6Q_nOWiooaLG5omSHf?oMgMgogmoOon7QhOoRh^;ohn?S
0ooTi>@4onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
00CoWIfMojVYZOoUiNGoi>CT0_oUiND01_nQXJ7o`L71onCTi?oTi>CoiNGU
onCTi0CoiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00CoiNGU
onCTi?li>CWoLW9b0_oUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND3onCTi00=on?ShooQ
hN7oh>3PomoOgooJf][oa/K6oj6QXOn=SHgoP820ohB4Q?o3`l?ogMgMonGU
i@01on[ZjP0000_onOWioo?clooYjNWoZ:RXofEUIOmcLg?oSHf=ok^k^ooD
e=Cof][JomgMg@02omoOg`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Q
h@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Q
h@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Q
h@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Q
h@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Q
h@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@05on7Qh@06on;Rh_oQhN7ohN7Qon7QhOoMgMgogmoO0_oQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN402?oQhN403OoPh>3ogmoOomgM
gOoLg=coeMGEokVi^On>SXkoNg]kofi^K_n[Zj_ojNWYoo?clooinOT00Oom
oOd0000<on_[jooXj>Soh^;RomOGeon=SHgoHV9RogIfM_nTY:CoalO7om;B
d_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00;og=cL013ofm_KomcLg?oKfm_of][JomWIfOoHf=Sodm?ColG5aOnL
W9coMGEeofMWIon@T93oemOGon;Rh_oXj>Sojn_[0Oo]kNd0000>onGUiOoR
h^;ogmoOom[Jf_o9bLWoQhN7oeYJF_mkNg_oXj>Sokbl_?o6a/Kobl_;olg=
cOo?cll2om7Ad@God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
0_oAdM403Oo@d=3oclo?olc<c?o8b<So^k^koibLW?mbLW;oFe]KohZ:R_o9
bLWof][JomoOgooRh^800_oUiND000;okNg]00koj^[ZonSXj?oRh^;og=cL
oibLW?m]KFgoJ6QXoh>3PonGUiOoXj>Sojb/[?n_[joo/K6aok:b/P;o];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd
]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd
]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H03ond];Co/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2
of9RH_m^KVkoWinOomcLg?oRh^;oj>SXon[ZjP02ong]k@7ok^k^00004_oo
ooooo_knookno_olo?conOWiooKfm_obl_;ofMWIojRXZ?n3Ph?oKVi^ofEU
IOmYJFWoLW9bogAdM?miNGWoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00koO7alogYjN_mjNW[oMgMg
ogAdM?m_KfooM7AdohF5QOnXZ:Sof][Joo;bl_ofm_KonOWiooclo0;oo_kn
0_ooool000;ok^k^0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;RhP03on3P
h?oOgmoog]kN0?oogMgMoooMgMg5omgMg@03omkNg_oOgmooh>3P00;oh^;R
00CoiNGUonSXj?oZj^[ok>c/0_o]kNd3onk^kP001?oVi^H2onGUi@03onCT
i?oRh^;oh^;R00;oh>3P0_oOgmooomkNg_oog]kNaOoNg]h2omoOg`;oh>3P
0_oRh^800ooTi>CoiNGUonGUi@05onKViP00oomoOgn6ogmoO`OoOWinoomo
OgmCogmoO`0000Cojn_[onKVi_oRh^;og]kN0ooMgMd0oooLg=cog]kNomkN
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMg@00AooNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkogMgM00;og=cL03go
fm_KomgMgOoLg=cog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomcLgOoNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oMgMgofm_Kom[Jf_oG
emOof=SHomOGeooJf][ofm_L00;ogMgM0?oog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]h004GogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMd00ooNg]h00ooMgMgog]kNomkNgP03omgM
g@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>000ooIfMT02?oHf=So
fMWIomWIfOoIfMWof=SHomKFe_oCdm?od=3@0oo=cLd01?o@d=3odm?ComOG
eooHf=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooG
emOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?o
emOGomSHf?oofMWI2ooIfMT2omSHf006omKFe_oCdm?odm?ComCDe?oGemOo
f=SH0_oIfMT00ooHf=SofMWIomWIf@02omSHf0WofMWI00?of=SHomWIfOoI
fMT00_oHf=P00ooIfMWof=SHomOGe`02omSHf1OofMWI00Cof=SHomKFe_oB
d];oclo?0_o=cLd01?o?cloodm?ComOGeooHf=SoomWIfDGofMWI00?of=SH
omWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWoi>CT
on3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=codm?ColO7aonk^k_o
/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooK
fm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoO
g`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^k
olO7aooCdm?ofm_KomoOg`3oon7Qh@[ohN7Q00Woh>3PomoOgooKfm_oe]KF
omCDe?oFe]Kof][JomkNg_oPh>001_oOgml3on3Ph003omoOgooPh>3oh>3P
00;oh>3P2?oOgml2omkNgP;ogmoO0ooPh>02omoOg`;oh>3P0_oOgml=on3P
h005omoOgooMgMgofMWIomGEeOoCdm<00_oBd]800ooFe]Kog=cLon3Ph03o
on7QhDOohN7Q00?oh^;Ron7QhOoRh^801?oQhN41onCTi07ojNWY0Oo]kNd0
0003oo3`l?o_knoolO7a00;ol?3`0_o_knl0ooo`l?3ok^k^onSXj?oKfm_o
`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]
kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2
`_nTY:CoS8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;o
Y:BTohb<S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]kOoa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7al@00C_o_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_koo`l>kokNg]onc/k?oUiNGoh^;RomoO
gooUiNGojNWYong]j`;oj>SX00Koi^KVonWYjOoWinOojn_[onc/k?o^k^`3
on[ZjP09ono_koo^k^kok^k^onSXj?oXj>Koi^KVonWYjOoWinOoj^[Z00;o
jNWY00goiNGUonOWiOoWinOojn_[onc/k?o_knoojn_[on[Zj_oYjNWok^k/
onc/k?o[jn_oj>SX00;okNg]01Cok^k^on[Zj_o/k>[ok>c/onk^k_oZj^[o
k>c/ong]kOo^k^koj^[Zonc/j_o/k>cok^k^ojf][OmgMgOoFEUIofm_Konf
][KohN7PonOWi`;okno_0?oolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo^k^kolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO4004cokno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo`l?3okno_oo3`l?o_knool?3`ono_koo`l?3okno_1?o`l?00
0003oo;bl_o^k^koinOW00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mU
IFGoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oT
i>@00ooUiNGoi>CTonGUi002onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKo
DE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT
0?ooiNGUonCTi?oUiNGoi>CTonCThooNg]kodM7Aok6a/On:RX[oIVIVoe5A
DOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7AomkNg_oTi>?oi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiND002Ooi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCohn?SolK6a_lX:2SoADE5ohn?SooBd];o
fm_KomcLfooFe]H00ooEeMD03?oDe=Cof][JomoOgooOgmkofMWIomGEeOoH
f=SogmoOon7QhOoMgMgoe]KFomGEe0;oeMGE00_oe=CDomWIfOoJf][of=SH
omGEeOoFe]Goe]KFomWIfOoMgMgoh>3Pom_Kf`02omKFeP09omgMg?oLg=co
f=SHomGEeOoLg=coh>3PomoOgooJf][ofm_J00;ogMgM0?oofMWIomcLg?oO
gmooh>3Pom_KfooJf]WogMgMon3Ph?mcLg?oJ6QXohf=SOmDE5Co20P8oj>S
X_oKfm_ohn?SonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoShn?oiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUon?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>@005KoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi0CoiNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o/k>`1oo;blP00
00?om?Cdong]kOoWinL00ooPh>004_oOgmoog]kNom;Bd_nd];CoQhN7oe]K
Fom]>cGoWTi2ole_GooYPfoocFmOoii>@om]>cKoG5aLohN7Qond];Cod];B
omkNgPGoh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m]H2coWYH^olg=?ooY
jDgocLdooijJ;om]HbgoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomkN
g_oBd];o];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=AomZWSCoBFX_
oeaLG?n7QhOo];Bdom;Bd_oNg]h0oooPh>09on3Ph006omoOgoo?clooVIVI
oi:BT_lI6AWoS8b<0_oEeMD07oo?cloo`/;2olk>c_o>c/koaLG5ol[:b_oJ
f][of=SHom3@d?o;bl_oclo?omSHf?oJf][oeMGEolo?coo1`L7od=3@olk>
c_o4a<Cobl_;omSHf?oGemOo_[jnok^k^ooAdM7od=3@omGEeOoHf=Sodm?C
olc<c?o>c/h00_oEeMD01Oo>c/koc<c<om?CdooJf][of=SH00;od];B00Co
f=SHomOGeooAdM7odm?C0_oIfMT01_oCdm?odM7AomOGeooHf=SodM7Aom3@
d0;odM7A00CoATI6od51@OoGemOog]kN@OoPh>000ooOgmooh>3Pon3Ph03o
on3Ph07oh>3P00?ogmoOon3Ph?oOgml00_oOgml3on3Ph003on7QhOoWinOo
k>c/007om?Cd00000oofm_Kol_;bon_[j`03onSXj00ConOWiooRh^;ocLg=
oinOWom[GeooScH^oneaHOoiWI3ooK6Uoofl[oom]:OonInConedHonB=boo
JemOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWom^
IUooTg8RongAA?oilgCooOf=oogmUOomoHkonOQfongGAonCLb;oKVMOoinO
Woo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWomPJ5ooBg`S
oi;QBonmnG_od?fBomSmVooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=cLgo
h^;RonOWi`3oonSXj0[oj>SX00Coi^KVon7QhOmMGEgoCDe=0_oMgMd07om@
D53o1`L7oaDE5On4Q8Co5QHFod=3@ooRh^;ogMgMoibLW?l0003oShn?omgM
gOoQhN7ofm_Kod10@?l820So6ATIohR8R?l;2`_oF5QHokNg]ol<30co1`L7
ob<S8olW9bOoOGemom[Jf_oMgMgoe=CDo`/;2omIFET00_oIfMT00omMGEgo
2`/;om?Cd`02omoOg`06oeYJF_m>CTkog]kNomkNg_lS8b?oQ8B40_oQhN40
3?mjNW[o;Rh^omgMgOoMgMgo`/;2oe1@D?lc<c?oKVi^oh>3PolQ8B7og]kN
onKVi_ooj>SXC_oXj>P1onc/k07ol_;b0Oofm_H0000IooOgmoohn?Son?Sh
ooShn?ogmoOon?ShooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFooZBQoonYY_o
o[6UoonhZoon/jKooZRLoo^DROo^J5WoRC4[oi2@T?o>c/kok^k^ooOgm`03
ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_PK_onm8;oo_j:oooo
T_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^ooOgm`03ooShn00C
ooOgmoo^k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSoc_j@omKoUoo@oY;o
a_j9ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^ooOgm`3oooShn0[on?Sh02Go
m_Kfoo7alOn1PH7o7alOong]kOo6a/Ko0000ol?3`ooCdm?oG5aLo`P82?oZ
j^[ol?3`on[Zj_mBDU;o51@Docdm?OoYjNWol?3`ojn_[ol71`Ood];Bolg=
cOm>CTko6a/Konk^k_oKfm_o[Zj^onSXj?o/k>co[Zj^o`000?nd];Cok>c/
ok2`/?l;2`_o6QXJ00;oi>CT00_o8b<So`h>3_nTY:CokNg]onk^k_mPH63o
E5ADonk^k_o]kNgo9RHVohf=S@02oo3`l00<oh:2P_la<C7ok>c/on[Zj_m3
@d?o;bl_oibLW?mcLg?o:RXZoaXJ6_o^k^kom_Kf>_ohn?P00oogmoOon?Sh
ooShn005ooShn003ooOgmoohn?Son?Sh03;on?Sh00?omoOgooShn?ohn?P0
c?ohn?P00oogmoOon?ShooShn002ooShn004ooOgmooinOWomoOgooKfmP7o
n?Sh00000oojn_[omOGeonk^kP02onc/k03oon_[jooYjNWogmoOokVi^Omi
DU;o_c8TonMdJOomRGkooiR<oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c
9?miDU;o^[ZjomoOgooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EB
on:A7?oi`e3ooMYSoooZL_onlgkoooZ2ookfOoook7?oo]iToo[7DOoRTQco
RFICokZj^_oOgmooj^[Zon_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]D_mA
XacoTM9EojKWJ_nhnG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]
D_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/001donc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_oj^[Z
onCTi?mjNW[o71`Lon;Rh_o;blco0`<3oinOWooOgmooU9BDoa<C4ooPh>3o
hN7Qom3@d?l61PKoXJ6Qo`T92Onn_[koh^;RokVi^Ol20P;o/K6bomkNg_n0
P83o:BTYon;Rh_oXj>Soi>CTomoOgooJf]_oe=CDo`P82?n6QXKogmoOofYZ
J_m9BDWo=CDeojb/[Onn_[ko1`L7ogQhN?mEEED2omoOg`06oe]KFom?Ce3o
h^;Ron3Ph?lT92CoQ8B40_oPh>00oomkNg_o;bl_on7QhOoDe=Co1@D5ojNW
YooTi>Coh^;RogmoOolE5AKoh^;RonWYjOo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k000D?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/1oo[jn/01Oo/k>cojn_[on_[joo^k^kom_Kf007o
nOWi00000ookno_olo?cong]k@02onGUi@3oonKVi_oShn?ofMWIok:b/_mi
;Rkob48don=ZG?ocNFcooHQloojGR_onVhkooYR;ooj:O_odNfgoif]MolY2
=?mk;Rko/[:bomSHf?oTi>CoiNGUonKVi_oUiNKoi>CTomSHf?nb/[;oUUD^
onZL:ook_4Coo/aCoogHH_onhg;oo^UeookVLoonffGooLaCoo_1AOo^WR_o
VEH^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGUonCTi?oHf=Wo/[:bobiR;_mS
[B_oQlY8oiOLFOnUiFWo/_=gokSfNondmGWoYnY[oiSLFOn9cd_oHjh[obiS
;_nb/[;of=SIonCTi?oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGV001EonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi>CT
omkNg_mgMgOo6a/KomcLg?oPh>7oWYjNobh^;_l[:b_o<S8boa8B4P02om_K
f`0UohB4Q?lQ8B7ogmoOoe=CDomWIfOofm_KomgMgOn@T93o:BTZobl_;ol/
;2co:2PXomgMgOoOgmoof=SHom?Cdoo?cm3oFe]Ko`000?nn_[kofMWIobPX
:?n6QXKoN7QhofQXJ?n2PX;o?3`lol?3`ol?3`ooeMGEomWIfOmIFEWoCTi>
omgMgOoLg=co8b<Soh61P@02omKFeP27ogMgMol^;RkogMgMoj:RX_l0003o
a/K6omWIfOoHf=SoSXj>oaDE5OoMgMgohn?SonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KV00;oiNGU0<OoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGU00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H0
0ooUiNGokNg]oo?cl`01oo_kn`0000?oo?clooShn?oalO400oo^k^h04oo[
jn_ohN7Qokbl_?mj5aOo`clbom9EB?oTJ5[okgM/ooB3NOohQgcomHAjoo=i
KOoUJE_ofEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Q
okbl_?nUAaOoiYLbooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;o
nZlbonVK<_nUAQOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lG
FAOoGjPbogJm=on6cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[
<_lGFAOo_;blon7QhOo/k>`0ooo^k^h:onk^kP0^onc/k?oWinOoNg]koa`L
7?oTi>CojNWYonKVi_oQhN7og]kNohf=SOlD51Coi^KVonCTi?le=CGoNGUi
on_[jonb/[;o5ADEomoOgooVi^Koi>CTon7QhOoMgMgoNWYjobTY:OoXj>So
iNGUomgMgOna/K7o9RHVo`/;2onKVi_ojNWYolc<c?l0003oc/k>ol?3`olU
9BGoBd];ogalO?oXj>So<C4aojFUYOoTi>CoGEeMoe5AD@;oinOW00[o9BDU
ofUYJOoOgmoogmoOogMgMola<C7ojNWYol71`Ol0003oYjNW0_oOgml01?nC
Ti?o5QHFonOWioo/k>`lonk^kP03ong]kOo^k^kok^k^00;ok^k^00?okNg]
onk^k_o^k^h0ooo^k^h9onk^kP03ong]kOobl_;on?Sh007oo?cl0003oogm
o@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@@ooJ
HUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];olo?coocl
o0?ooOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWomJPYooRd?ooi_D[o
n;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?oo?cl00?ooOgm
01?oo?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:cE3oSLeBoh[>
D?n1adCoLKT_of:^8?m>VcCo1d87om;Bd_oclo?oo?cl0?oooOgm2_omoOd0
8ookno_omoOgohB4Q?lN7Qkolo?cooWinOnc/k?od=3@oo?clomXJ6SoAdM7
ooWinOoDe=Co0000omgMgOolo?cono_kobLW9onXZ:SonOWioj^[ZooEeMGo
lO7aoeADE?mNGUkonOWiooCdm?nDU9Co1@D5od10@?oAdM7omoOgooShn?nG
UiOo:b/[00;on_[j01_o92@To`L71oo8b<Sono_kohF5QOmSHf?omoOgof=S
HomGEeOon?ShooWinOlW9bOo5ADEoh>3PooGemOo@T92of=SHookno_on_[j
oc@d=?m9BDWofm_KonGUiOm?Cdoo5aLGoo[jn_olo?`0ooomoOe;oogmo@03
ooclo?omoOgoo?cl00?ooOgm0000>_omoOgon_[joo?cloo^k^kol?3`ono_
koo^k^kojNWYom?CdomJ71coXS@dok@X7Oo1>BcoadTlolmFB_o@Ed_od5M:
olY:?_o3>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>oo
k^k^on[Zj_oCdm?oS2DMolQa=?oIQ1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/
X2GoiiLEomb87Oo8LCCoS2DMom?CdooZj^[ok^k^oo3`l?o_knool?3`onk^
k_oZj^Wodm?Coadh7OldPSCoAiDMoeZU6omY[BX2ogBh>03oogFi>?m[/B_o
FjLLodRJ7OldPSCo7CPMom?CdooZj^Wok^k^oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_000joo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o^k^kojn_[ogemOOlL71coinOWonk^kOn8R8So<30`o`h>
3_la<C7o/;2`ono_kon4Q8CoCDe=onk^k_o_knook^k^ohZ:R_mIFEWokno_
ogQhN?l/;2_o3Ph>ocPh>?nn_[kok^k^on?Shol>3PkoJFUYon3PgooRh^;o
i^KVon[Zj_mQHF7oMWIfono_koo^k^koMgMfobHV9P;ok^k^01KocLg=ob`/
;?o[jn_oK6a/of=SH_o[jn_ok^k^ocXj>_nDU9CoHV9Ro`h>3_ld=3Coa<C4
onk^k_o_knoodM7Aoc`l??l:2P[o9bLWofa/K?l/;2cok^k^0_o_knl0ooo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o^k^kol?3`ono_koo`l>ookno_oo3`l?o_knool?3`onk^k_o`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l000AOo_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`02oo3`l0Ko
kno_0Ooclo<1ooShn07oo_kn00000oono_komoOgoo3`l002onWYj@0ConSX
j?oYjNWoi^KVom_KfomSBd_oPC8bojHd=?nf=2go`Te1ol=DBOo4ED[o`eA9
ol9=@Onf=2goYCDeoh4b<_mSBd_ofm_KonOWi`05onWYj@0AonOWiooKfm_o
RD];ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_
Bc;oRD];om_KfooWinL01OoYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K
;Om[ZbooL:dhofn^>_m`[CSoJZX_oe>K;OliR3Go<V0bod];BooKfm_oinOW
0?oojNWY2ooYjNT01_oXj>Soi^KVog]kNolL71coi>CTonSXj0;ojNWY00?o
inOWonWYjOoYjNT02ooYjNT03?oWinOojNWYonWYjOoXj>Sof=SHo`X:2_n^
[Zkog=cLomkNg_oPh>3oiNGUonSXj0SojNWY00Koj>SXonKVi_oShn?ohn?S
onKVi_oXj>P3onWYj@03onSXj?oYjNWojNWY00CojNWY00?oinOWonWYjOoY
jNT0N_oYjNT00ooXj>SojNWYonWYj@03onWYj@03onSXj?oYjNWojNWY0<Ko
jNWY00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07omoOg0Oono_h00004ookn
o_ojn_[om?Cdono_k`?ol?3`017okno_on_[jonEU9CoCb<SoiEDE?nkLg?o
diFEomZLW?oJWYcofIbLomBEUOnkLg?oUEADodlS8onEU9Coj^[Zono_k`05
oo3`l00Aono_kooZj^[oZIBDoh4S8onjJUCoe9YconBlUOoZaicojLNLon[7
W?oU_9Goe9Ycok]ZE?n18b?oZYBDon[Zj_o_knl01Oo`l?004Oo_knooj^[Z
oiBDU?lS:R?oE7YDog>ULonNaYGo[<jLojg>W?n/cYcoW/JEog>ULomDNUCo
8bXSoiBDU?oZj^[okno_0?ool?3`2oo`l?02ono_k`04oh20P?lM7Agok^k^
ono_k`Gol?3`00?okno_oo3`l?o`l?002oo`l?02ono_k`07ofATI?lY:BWo
PH61of=SHolk>c_ok^k^ono_k`08oo3`l006ono_koo^k^koLg=cofUYJOo^
k^kokno_Boo`l?02ono_koool?3`3oo`l?001?oalO7ol?3`ooCdm?ojn_X1
ooknoP0000CokNobooooooooooooo_kn0_ooool2ooknoP3ooogmoOogmoOo
KVi^oeXo?onaT93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSloofe]KOoh
n?Soo?clooooooono_koooooookno_ooookoo_knooooooolo?con?Shohe]
KOn:?coobI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo?on=KFgon?Sg
ooclo?ooooooo_knooooooono_koooooookno_ooookoo?clooShn?m]KFgo
?clooi2MT?o9eLWoi>cTonK^i_oTk>CobMG9oi2MT?lo?cooKFe]ooShn?ol
o?coooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_kn0017ooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooool00_ono_h0
6?o?clooYZJVoogmoOooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooo`;oo_kn00ko`<30og5aLOn0P83o/;2`oogmoOooooooo_knoooo
ooono_koooonookno_ooooooo_knooooo`;oo_kn0?oo`L71okfm_?omoOgo
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_h005coooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooooooknoP;ooooo00?oo_knoooooooo
ool00oooool1oo[jn`0000Coa<cCookno_ojn_[olo?c1OoalO403Oo_knoo
e]KFof][Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?CgoJf][omKFe_o_
knl02OoalO403Oo_knooemKFoh=[Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<
S?mb?CgoPF][omOFe_o_knl02OoalO403Oo_knooe]KFof][Jolm?CgoS8b<
okZj^_o<cLco^[Zjohb<S?lm?CgoJf][omKFe_o_knl0oooalO4Foo7al@03
oo3`l?oalO7olO7a017olO7a00?ol?3`oo7alOoalO40WOoalO400oo`l?3o
lO7aoo7al@34oo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00?om?Cdoo[j
n_ono_h00Oo[k^l0000EohZHXoomoOgon?Shoo3`l?o[jn_oj^[ZonWYjOoZ
j^[ojNWYon[Zj_oYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^K
VooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo@RHV
ofUIFOnPVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo
2@T9obHV9_mIFEWoVi^KonSXj?oYjNT0oooZj^XZon[ZjP03onWYjOoZj^[o
j^[Z09coj^[Z00?ojNWYon[Zj_oZj^X0cOoZj^X01?o[jn_ol?3`ooShn?om
oOd1oloBeP0000Co@E1Nokc6cOojn_[olo?c2?oalO42oo3`l0?okno_0_o`
l?0?oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`oooa
lO7ooo7alISolO7a00?ol?3`oo7alOoalO400_oalO400ooemOGon_[jonW[
k@01oi^OXP0000?o9Ca>oe5SL?nkaL`0ooooooooooooom[ooooo0Oo]ko41
ojb`]07oYjb`00001_lY@5Oo8SU<ocQ:FOn6TIgo`LS>onc^l?oooooooooo
oooDooooo`05ooSin_o/k^oodMCGoi^OXonMXjL00Onc^[l00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{734, 424},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<java.awt.BorderLayout\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["java.awt.BorderLayout", 13]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(savedLayout = pane@getLayout[]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JRootPane$1"] \[RightGuillemet]\),
      JLink`Objects`JavaObject82054511329281]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]\(pane@
          setLayout[\[IndentingNewLine]JavaNew["\<java.awt.BorderLayout\>", 
              2, 2]\[IndentingNewLine]];\)\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(btnPos = {\[IndentingNewLine]java`awt`BorderLayout`NORTH, \
\[IndentingNewLine]java`awt`BorderLayout`EAST, \
\[IndentingNewLine]java`awt`BorderLayout`SOUTH, \
\[IndentingNewLine]java`awt`BorderLayout`WEST, \
\[IndentingNewLine]java`awt`BorderLayout`CENTER\[IndentingNewLine]}\)], \
"Input"],

Cell[BoxData[
    \({"North", "East", "South", "West", "Center"}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(btnName = {"\<North\>", "\<East\>", "\<South\>", "\<West\>", \
"\<Center\>"}\)], "Input"],

Cell[BoxData[
    \({"North", "East", "South", "West", "Center"}\)], "Output"]
}, Open  ]],

Cell["\<\
Because we pass the string object to the add( ) method of the \
container pane, the java.lang.String object is created temporally.\
\>", \
"Text"],

Cell[BoxData[{
    \(Do[\[IndentingNewLine]JavaBlock[\[IndentingNewLine]pane@
          add[\[IndentingNewLine]JavaNew["\<javax.swing.JButton\>", 
              btnName[\([i]\)]], 
            JavaNew["\<java.lang.String\>", 
              btnPos[\([i]\)]]\[IndentingNewLine]]\[IndentingNewLine]], \
\[IndentingNewLine]{i, 1, 5}\[IndentingNewLine]]\), "\n", 
    \(JavaShow[frame]\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(components = pane@getComponents[]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.JButton"] \[RightGuillemet]\),
          JLink`Objects`JavaObject225436525133825], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.JButton"] \[RightGuillemet]\),
          JLink`Objects`JavaObject172336821043201], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.JButton"] \[RightGuillemet]\),
          JLink`Objects`JavaObject149695498289153], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.JButton"] \[RightGuillemet]\),
          JLink`Objects`JavaObject256574199169025], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.JButton"] \[RightGuillemet]\),
          JLink`Objects`JavaObject13900393218049]}], "}"}]], "Output"]
}, Open  ]],

Cell["Change widths of west and east buttons.", "Text"],

Cell[BoxData[{
    \(JavaBlock[\[IndentingNewLine]Do[\[IndentingNewLine]cmp = 
          components[\([i]\)]; \[IndentingNewLine]If[
          ClassName[cmp] === "\<javax.swing.JButton\>", \[IndentingNewLine]If[
            cmp@getLabel[] === "\<West\>" || 
              cmp@getLabel[] === "\<East\>", \[IndentingNewLine]cmp@
              setPreferredSize[
                JavaNew["\<java.awt.Dimension\>", 160, 
                  20]\[IndentingNewLine]]\[IndentingNewLine]]\
\[IndentingNewLine]], \[IndentingNewLine]{i, 1, 
          Length[components]}\[IndentingNewLine]]\[IndentingNewLine]]\), "\
\[IndentingNewLine]", 
    \(JavaShow[frame]\)}], "Input"],

Cell["Change heights of north and south buttons.", "Text"],

Cell[BoxData[{
    \(JavaBlock[\[IndentingNewLine]Do[\[IndentingNewLine]cmp = 
          components[\([i]\)]; \[IndentingNewLine]If[
          ClassName[cmp] === "\<javax.swing.JButton\>", \[IndentingNewLine]If[
            cmp@getLabel[] === "\<North\>" || \[IndentingNewLine]cmp@
                  getLabel[] === "\<South\>", \[IndentingNewLine]cmp@
              setPreferredSize[
                JavaNew["\<java.awt.Dimension\>", 20, 
                  40]\[IndentingNewLine]]\[IndentingNewLine]]\
\[IndentingNewLine]], \[IndentingNewLine]{i, 1, 
          Length[components]}\[IndentingNewLine]]\[IndentingNewLine]]\), "\
\[IndentingNewLine]", 
    \(JavaShow[frame]\)}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]Do[\[IndentingNewLine]cmp = 
          components[\([i]\)]; \[IndentingNewLine]If[
          ClassName[
              cmp] === "\<javax.swing.JButton\>", \
\[IndentingNewLine]DeleteJObject[pane, 
            cmp]\[IndentingNewLine]], \[IndentingNewLine]{i, 1, 
          Length[components]}\[IndentingNewLine]]\[IndentingNewLine]]\)], \
"Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> java.awt.CardLayout <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell["See <<< SimpleCardLayout >>>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["<<< SimpleCardLayout >>>",
  FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008@00026QP00`40o`00
0?l0003oo`000?l0000B000000000hS0^4R@R4R@R03oB928odR@R0i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^0f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;P=R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<`:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?n>SXkoSXj>
2Xj>SP:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooo`Woool0
18j>SXS0^8S0^4R@R04000000007R<2hb>3HR<2hR<2hooooSXj>c<c<0?co
ool;c<c<oOooo`04SXj>R<2hR<2hB9280@00000000R8`;S8h=R8`;R8`;So
oon>SXiVIVK<c<cjIVIV00?oooo<c<c<c<`02<c<c003IVIVc<c<IVIV0?UV
IVH2oooo00B>SXj8`;R8`;Q8T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0n<c<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0B<c<c35V
IYUoc<c<00AVIVKooooooon>SXh2R<2h0DR@R04000000008R<2hb>3HR<2h
R<2hooooSXj>IVIVoooonLc<c003IVIVooooc<c<00W<c<`00fIVI_ooolc<
c018c<c<00=VIYW<c?o<c?l0;Lc<o`03IVJIc<c<c<c<07g<c<`016IVI_oo
ooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>SXiVIVKo
oooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<04S<c<`00fIVVLc<
olc<o`0]c<co00=VIYW<c<c<c<`0OLc<c004IVIVooooooooSXj>0XS0^058
T8P10000000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_oo
olc<c009c<c<00=VIVKoooo<c<`0B<c<c003IVJIc<coc<co02g<c?l00fIV
VLc<c<c<c01mc<c<00AVIVKooooooon>SXh2R<2h0DR@R04000000008R<2h
b>3HR<2hR<2hooooSXj>IVIVoooonLc<c003IVIVooooc<c<00W<c<`00fIV
I_ooolc<c018c<c<00=VIYW<c?o<c?l00/c<o`<00003c<co1@0000C<c?l2
000000C<c?l0003<c?o<c?l2000000?<c?l0000000000/c<o`<00003c<co
00D0003<c?o<c?o<c?l000001<c<o`03IVJIc<c<c<c<07g<c<`016IVI_oo
ooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>SXiVIVKo
oooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<04S<c<`01FIVVLc<
olc<olc<o`000003c<co00@0003<c?o<c?l00004c<co00@0003<c?o<c?l0
0002c<co0P0000;<c?l010000<c<olc<o`0000;<c?l01@000<c<olc<olc<
o`000002c<co00D0003<c?o<c?o<c?l000001<c<o`03IVJIc<c<c<c<07g<
c<`016IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;So
oon>SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<04S<
c<`01FIVVLc<olc<olc<o`000003c<co00@0003<c?o<c?l00004c<co00@0
003<c?o<c?l00003c<co00@0003<c?o<c?l00002c<co00@0003<c?o<c?l0
0003c<co00@0003<c?o<c?l00003c<co00<0003<c?o<c?l00/c<o`03IVJI
c<c<c<c<07g<c<`016IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8
h=R8`;R8`;Sooon>SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIV
ooooc<c<04S<c<`00fIVVLc<olc<o`05c<co00@0003<c?o<c?l00004c<co
00@0003<c?o<c?l00003c<co00@0003<c?o<c?l00002c<co00@0003<c?o<
c?l00003c<co00@0003<c?o<c?l00003c<co00<0003<c?o<c?l00/c<o`03
IVJIc<c<c<c<07g<c<`016IVI_ooooooohj>SP:8`;P1B9280@00000000R8
`;S8h=R8`;R8`;Sooon>SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003
IVIVooooc<c<04S<c<`00fIVVLc<olc<o`05c<co00<0003<c?o<c?l01@00
00?<c?l01@000<c<olc<olc<o`000002c<co00@0003<c?o<c?l00002c<co
00D0003<c?o<c?o<c?l000000/c<o`050000c<coc<coc<co000000C<c?l0
0fIVVLc<c<c<c01mc<c<00AVIVKooooooon>SXh2R<2h0DR@R04000000008
R<2hb>3HR<2hR<2hooooSXj>IVIVoooonLc<c003IVIVooooc<c<00W<c<`0
0fIVI_ooolc<c018c<c<00=VIYW<c?o<c?l01Lc<o`040000c<coc<co0000
1<c<o`040000c<coc<co00000lc<o`040000c<coc<co00000/c<o`040000
c<coc<co00000lc<o`030000c<coc<co00800002c<co00<0003<c?o<c?l0
0/c<o`03IVJIc<c<c<c<07g<c<`016IVI_ooooooohj>SP:8`;P1B9280@00
000000R8`;S8h=R8`;R8`;Sooon>SXiVIVKooooic<c<00=VIVKoooo<c<`0
2Lc<c003IVIVooooc<c<04S<c<`00fIVVLc<olc<o`05c<co00@0003<c?o<
c?l00004c<co00@0003<c?o<c?l00003c<co00<0003<c?l000001@0000;<
c?l300000lc<o`040000c<co000000001Lc<o`03IVJIc<c<c<c<07g<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<04S<c<`0
0fIVVLc<olc<o`05c<co00@0003<c?o<c?l00004c<co00<0003<c?o<c?l0
1lc<o`040000c<coc<co00004/c<o`03IVJIc<c<c<c<07g<c<`016IVI_oo
ooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>SXiVIVKo
oooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<04S<c<`00fIVVLc<
olc<o`05c<co00<0003<c?o<c?l01@0000[<c?l010000<c<olc<o`0001;<
c?l00fIVVLc<c<c<c01mc<c<00AVIVKooooooon>SXh2R<2h0DR@R0400000
0008R<2hb>3HR<2hR<2hooooSXj>IVIVoooonLc<c003IVIVooooc<c<00W<
c<`00fIVI_ooolc<c018c<c<00=VIYW<c?o<c?l0;Lc<o`03IVJIc<c<c<c<
07g<c<`016IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8
`;Sooon>SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<
04S<c<`00fIVVLc<olc<o`0]c<co00=VIYW<c<c<c<`0OLc<c004IVIVoooo
ooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>SVIVI_oo
ooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0B<c<c003IVJIc<co
c<co02g<c?l00fIVVLc<c<c<c01mc<c<00AVIVKooooooon>SXh2R<2h0DR@
R04000000008R<2hb>3HR<2hR<2hooooSXj>IVIVoooonLc<c003IVIVoooo
c<c<00W<c<`00fIVI_ooolc<c018c<c<00=VIYW<c?o<c?l0;Lc<o`03IVJI
c<c<c<c<07g<c<`016IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8
h=R8`;R8`;Sooon>SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIV
ooooc<c<04S<c<`aIVJIOlc<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0n<c<c004IVIVooooooooSXj>0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0KLc<c1bIVLa_c<c<00AVIVKooooooon>SXh2R<2h
0DR@R04000000008R<2hb>3HR<2hR<2hooooSXj>IVIVoooonLc<c003IVIV
ooooc<c<00W<c<`00fIVI_ooolc<c01]c<c<00>IVLc<c<c<c<`06<c<c003
VIW<c<c<c<c<06g<c<`016IVI_ooooooohj>SP:8`;P1B9280@00000000R8
`;S8h=R8`;R8`;Sooon>SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003
IVIVooooc<c<06g<c<`00iVIc<c<c<c<c00Hc<c<00>IVLc<c<c<c<`0KLc<
c004IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?oo
ohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0KLc<
c003VIW<c<c<c<c<01S<c<`00iVIc<c<c<c<c01]c<c<00AVIVKooooooon>
SXh2R<2h0DR@R04000000008R<2hb>3HR<2hR<2hooooSXj>IVIVooooHlc<
c0800006c<c<0P0000C<c<`400000lc<c0<00002c<c<0P0000;<c<`40000
0lc<c08000000lc<c00000000002c<c<100006K<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0KLc<c003VIW<0000000000?<c<`200000/c<c0@0
0002c<c<0P0000;<c<`200000/c<c08000000lc<c9VIc<c<c01^c<c<00AV
IVKooooooon>SXh2R<2h0DR@R04000000008R<2hb>3HR<2hR<2hooooSXj>
IVIVooooHlc<c0800006c<c<0P0000?<c<`200000/c<c0800002c<c<0`00
00;<c<`2000000?<c<`0000000000/c<c08000001<c<c00000000<c<c0<0
00000lc<c00000000002c<c<0P0006G<c<`00fIVI_ooolc<c009c<c<00=V
IVKoooo<c<`0KLc<c003VIW<0000000000;<c<`3000000?<c<`000000000
0/c<c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`0
0iVIc<c<c<c<c01]c<c<00AVIVKooooooon>SXh2R<2h0DR@R04000000008
R<2hb>3HR<2hR<2hooooSXj>IVIVooooHlc<c0800006c<c<0P0000?<c<`2
00001Lc<c08000001<c<c00000000<c<c08000000lc<c00000000002c<c<
0P000003c<c<0000000000;<c<`200001<c<c0<0001Uc<c<00=VIVKoooo<
c<`02Lc<c003IVIVooooc<c<06g<c<`00iVIc00000000002c<c<0`000003
c<c<0000000000K<c<`400000/c<c0800002c<c<00>IVLc<c<c<c<`0KLc<
c004IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?oo
ohj>SVIVI_ooof?<c<`600000/c<c0800003c<c<1P000004c<c<00000000
c<c<0P000004c<c<00000000c<c<0P0000;<c<`2000000?<c<`000000000
0/c<c0800002c<c<100006K<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<
c<`0KLc<c004VIW<00000000c<c<10000003c<c<0000000000@00003c<c<
0P0000?<c<`200000/c<c003VIW<c<c<c<c<06g<c<`016IVI_ooooooohj>
SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>SXiVIVKooomSc<c<
0P0000?<c<`2000000?<c<`0000000000lc<c0800002c<c<0P000004c<c<
00000000c<c<0P000004c<c<00000000c<c<0P0000;<c<`2000000?<c<`0
000000000/c<c08000001<c<c0000000000006S<c<`00fIVI_ooolc<c009
c<c<00=VIVKoooo<c<`0KLc<c006VIW<00000000c<c<0000c<c<0P000003
c<c<0000000000;<c<`200000/c<c0@00002c<c<0P0000;<c<`00iVIc<c<
c<c<c01]c<c<00AVIVKooooooon>SXh2R<2h0DR@R04000000008R<2hb>3H
R<2hR<2hooooSXj>IVIVooooHlc<c0800003c<c<0P000003c<c<00000000
00?<c<`200000/c<c0@00003c<c<100000;<c<`00`000<c<c<c<c0020000
00?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P0006G<c<`0
0fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0KLc<c003VIW<000000000080
00001<c<c00000000<c<c0800002c<c<0P000003c<c<0000000000;<c<`2
000000?<c<`0000000000/c<c003VIW<c<c<c<c<06g<c<`016IVI_oooooo
ohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>SXiVIVKooomS
c<c<0P0000?<c<`2000000?<c<`0000000000P0000;<c<`4000000?<c<`0
000000000lc<c0@00002c<c<100000;<c<`200000/c<c0800002c<c<1000
06K<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0KLc<c004VIW<0000
000000000/c<c0800002c<c<100000;<c<`200000/c<c0H000000lc<c9VI
c<c<c01^c<c<00AVIVKooooooon>SXh2R<2h0DR@R04000000008R<2hb>3H
R<2hR<2hooooSXj>IVIVooooHlc<c0800003c<c<0P0008o<c<`00fIVI_oo
olc<c009c<c<00=VIVKoooo<c<`0KLc<c004VIW<0000000000000/c<c080
000?c<c<0P0000;<c<`00iVIc<c<c<c<c01]c<c<00AVIVKooooooon>SXh2
R<2h0DR@R04000000008R<2hb>3HR<2hR<2hooooSXj>IVIVooooHlc<c0H0
000Dc<c<0P0007[<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0KLc<
c003VIW<0000000000?<c<`200004<c<c0040000c<c<c<c<VIW<Klc<c004
IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0^?ooohj>
SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0KLc<c003
VIW<c<c<c<c<01S<c<`00iVIc<c<c<c<c01]c<c<00AVIVKooooooon>SXh2
R<2h0DR@R04000000008R<2hb>3HR<2hR<2hooooSXj>IVIVoooonLc<c003
IVIVooooc<c<00W<c<`00fIVI_ooolc<c01]c<c<00>IVLc<c<c<c<`06<c<
c003VIW<c<c<c<c<06g<c<`016IVI_ooooooohj>SP:8`;P1B9280@000000
00R8`;S8h=R8`;R8`;Sooon>SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<
c003IVIVooooc<c<06g<c<`00iVIc<c<c<c<c00Hc<c<00>IVLc<c<c<c<`0
KLc<c004IVIVooooooooSXj>0XS0^058T8P10000000028S0^<SPf8S0^8S0
^?ooohj>SVIVI_ooooW<c<`00fIVI_ooolc<c009c<c<00=VIVKoooo<c<`0
KLc<c003VIW<c<c<c<c<01S<c<`00iVIc<c<c<c<c01]c<c<00AVIVKooooo
oon>SXh2R<2h0DR@R04000000008R<2hb>3HR<2hR<2hooooSXj>IVIVoooo
nLc<c003IVIVooooc<c<00W<c<`00fIVI_ooolc<c01]c<c<79VIc6o<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000R8`;S8h=R8`;R8`;Sooon>
SXiVIVKooooic<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<0?S<c<`0
16IVI_ooooooohj>SP:8`;P1B9280@00000000N8`;S8h=R8`;R8`;Sooon>
SXiVIVH0n_ooo`03c<c<ooooc<c<00W<c<`00fIVI_ooooooo`3hoooo00C<
c<cooooooon>SXh2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hooooSXj>
o6IVIP_<c<clIVIV00?<c<cooon>SXh00XS0^058T8P1000000001HS0^<SP
f8S0^8S0^?ooo`3oSXj>ohj>SPN>SXh01Oooohj>SXS0^8S0^4R@R0010000
000018S0^<SPf8S0^8S0^?oooooooooo2Oooo`04SXj>R<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c0[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<`:c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<2/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c0[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<`:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
2/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c0[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<`:c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<2/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Pcc<c<4A4A4@0500004A4A4A4A00004A4A00<0
00094A4A00<0000A4A4A4A40114A4@0500004A4A4A4A4A4A8RXZ008R<T@4
<SY400/R<T@R:RXR<T@R<T@b>T@R<T@R>S8R:RXI8S8R<T@R:RX00R8bA00:
8RXZ8S948S948S948SXb8RXZ8S948RXZ8S948S8Z0S8jA0038T@j<SY48RXZ
00PR:RX01ATR<R8Z:QTR<S8jA28Z:P028S940S8jA08jA4`00b94>QTR:Q4A
4@0L4A4A00<I6ATI6A4A4A404A4A4@076ATI4A4A6ATA4A4A6B8R<RXR8S94
00@b>T@034A4C3Y4C3Y4C38jA4A4C3Y4C294>TA4<S8jA3Xj<S8jA3Y4<PDj
A4`00c8jA3Xj<S8jA002>TA<00=4A4`jA4`jA4`00SY4C003>T@b>TA<>TA<
009<C4@2>TA<0S8jA0<jA4`01da<A38jA4a<A1TR8QTI4A4A4ATI6@024A4A
00DI6A4A4A4I6A4A4A4I6AT00Q4A4@046ATA4A4A4A4A6ATA0Q4A4@046ATA
4A4A4A4A6ATA0Q4A4@036ATA4A4A4A4A00<A4A401ATR8Q4A4ATI4A4A4ATI
4@024A4A00<I6A4I6ATA4A40114A4@0:6ATA4A4A6ATI4A4A6B8R<RXRA4A<
>UALC4a4>TA<0Ta<A003<SY4>TA<>TA<008b>T@01CY4<S8jA3Y4<SY4C38j
A005>SXb00Tb>T@jA4`jA38jA4a<C3XjA38jA4a<C4@jA4`00dA4C003>TA<
A4A<>SXb008b>T@02SXj<S8jA38jA3Xj<S8jA3Xj<Ta<A38jA1TR:Q4A4@8I
6A401B8R4ATI4A4A4ATI6ATI4@034A4A00@I6A4A4A4I6A4I6A424A4A00@I
6A4A4A4A4A4I6A434A4A00DI6A4A4A4A4A4I6A4A4A400QTI4@034A4A:Q48
4A4A008I6A402A4A4ATI4A4A4ATI4ATI6B8Z:SXj<S8jA4A4<P03>SXb00=n
MVG<c<c<c<`0MLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<
0a4A4@0300004A4A4A4A01dA4A400`00014A4A4A4@064A4A00/0000R<T@R
<T@b>T@R<T@RA3XR<T@R<RXI8S8I8R8R:RX00b8bA0048RXZ6B8Z:R8I:R8I
0b8Z:P038S948RXZ8RXZ008R<T@02B8Z:R8j<S8jA3Y4C1TR:R8Z:R8bA28Z
:QTRC0038RXZ00hR<T@R:RXR<RXb>T@I8S8RC5@R<T@R>S8R<T@R:RXI8S8R
<T@Z8QTR<T@2<SY400<R<T@R<RXA4A40514A4@036ATI4A4A4A4A00DA4A40
11TI6A4A4A4A4ATI6@8A4A401ATI6A4A4A4A4A4A4ATI6@074A4A00<I6ATA
4A4A4A40114A4@03A4A<C4a4<SY400<b>T@01R94>S8jA38jA3Y4C4A4C294
>P8jA4`01294>S8jA38jA38jA08jA4`01C8jA3Y4C3Y4C4A4<R94>P02<SY4
00HjA4a4A4`RA3XjA4`b>T@jA382A4A<00<jE5a4A4a4A4`00SY4C009>UAL
>TA<>UALC4`j>TA<>UAL<SY48TaD6B8R00/A4A400aTI4A4A4A4A4@074A4A
00<I6A4A4A4A4A400a4A4@046ATI4A4A8R8A6ATA1Q4A4@036ATI4A4A4A4A
00<A4A400aTI6A4A4A4A4@024A4A00TI6AU<C4@jE5`jE5`jA39<C4@jA4`b
>T@j>S80238jA08j>S82<SY401m4A38RA3XjA4`jA39<C3Y<C4@jA4a4A4`j
A4a<C4@b>TA<C3XjA4`b>TA<C4@b:R8RA3XR<RY4>RXj>S8b>TA4A4`b>TA<
C3XjE5`jA4`I6AT0000Z4@PA4A4I6AT00Q4A4@096ATA4A4A4A4A4A4A6ATA
4A4A6ATA4A4A6ATA008A4A403QTI4A4A4ATI4A4A4ATI4A4A4ATI4A4A4ATI
4ATI6B8R4BXR6A4A4ATI4@8A4A4011TI4A4A4ATI4ATI6@<A4A401B8R4B8Z
:Ta<A4A4C3Y4C002<SY400@j>S8jA4`j>S9nKFEgc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^3?<c<`B4A4A00<0000A4A4A4A401A4A4@030000
4A4A000000@A4A402@00014A4A4A4A4A4@00014A4@00014A4@0000034A4A
00`b>T@R<T@RC5@R<T@R:RXI8S8R:RXI8R8R:RXI8S8R:RXR<T@38RXZ00DI
8S8R:RXI8S8R:RXZ8QT0128Z:P078S94<SY48RXZ6ATI00004A4A6ATA008R
:RX00aTR8R8Z:QTR<P028RXZ00<R<T@I8S8R:RX00b8Z:P036B8b8T@j8S94
008b>T@01QTR<S8jA28Z:R8j<SY4C00000LA4A400aTI6ATI4A4A4@094A4A
00DI6A4A4A4A4A4A4A4I6A40214A4@036ATI4A4A6ATI00LA4A400aTI4A4A
4A4A4@054A4A00XI6A4I6ATI6AU4A4`RA3XbA7I4A4`RA3Xb>T@jA4`3<SY4
00<jA4`b>T@b>T@00SY4C004>SXb>TA<>SXbC4a40TA4C006<SY4>T@b<SY4
<SY48T@j>T@b0cY4C08b>T@02SY4C28b:S8jA28j<SXj<Ta<A29<E3Y4<Ta<
A4A4C08jA4`01DA4C38jA4a<>S8jA00000054A4A00<Z4@PA4A4A4A400a4A
4@036ATI4A4A4A4A00@A4A400bXA214A4A4A4@034A4A00<I6A4A4A4A4A40
0Q4A4@036ATA4A4A4A4A008A4A426ATI0a4A4@076ATA4A4A4A4A4A4A6ATI
6ATA6ATI008A4A40238jA4A4C3Y4C38jA3Y4<SY4C38jA3Xj<P<b>T@01TA4
<SY4<S8jA4A4<R94>S8jA08jA4`01CXj<TA4C3Y4<SY4C4a<A003A4A<00e4
A38j>S8jA4a<C4A4A4`jA38jA4a<C4@jA38b>T@jA4a4>RXjA4`00c8jA00;
>T@bC4`j8TaD:Q4800006ATA4A4A6ATI6ATA4A4A6ATA008A4A401ATI4A4A
4ATI4A4A4B8R4@034A4A00DZ4@PA4A4I6A4I6A4A4A400aTI4@034A4A6ATA
4A4A008I8R800aTI4A4A4A4A4@024A4A00<I6A4A4A4I6A400a4A4@066ATA
<SY4>TA<>SXb>TA<>SXb0TA4<P04<SY4>SXb<SY4OVEDMlc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Pcc<c<00<A4A4I6ATA4A401a4A4@030000
4A4A4A4A00<A4A401ATI6A4A4A4A4A4A4@0000064A4A00<0000A4A4A4A40
3A4A4@0400008RXZ>SXb8S940R8Z:P046B8b8RXZ8RXZ6B8b0R8Z:P03<SY4
8S8Z8S94008R<T@00dA4C38jA28bA0028RXZ00<R<T@I8T`b>T@00b8Z:P03
6B9<>SXb<SY4008R<T@0128Z:QTR:R8Z:RXR6@DR:RX38S9400<jA4`I8S8R
<T@00R8bA0066B8b8S94<SY48T@j8S946B8R1A4A4@0400004A4A4A4A0000
1a4A4@0300004A4A4A4A01LA4A40128R4ATI6ATI6ATI4@8A4A401P00038Z
8Q4A4A4A4@0004a<A08b>T@023Y4C294>SY4<SY4C3Y4<S8jA28b:SXj<P<b
>T@02294>SXj<S8jA38jA4a<A294>R9<E3Xj<P8b>T@02294>SXj<S8jA3Xj
<SY4C3Xj<SY4C28j<P@b>T@01B94>S8jA3Y4C4a<>SYDG002>TA<0TA4C004
>T@b>TA<8TaD00001Q4A4@066ATI4A4A4A4A8R8A4A4A6ATI0a4A4@076ATA
:R8I6ATA6ATI8R8A4A4A6ATA00@A4A400aTI6BXA214A4@024A4A00<I6A4A
4A4I6AT0214A4@076ATA4A4A6ATI00004A4A:R8IA4A<00<jA4`03cXj<S8j
A38jA38jA3Xj<R8bA38jA28b:R8Z:R8bA4a<>S8jA3Xj<S8jA3Xj<P03<SY4
00<jA38b>TA<C4@00SY4C0<b>T@2A4A<0c8jA0096B8R8S948S8Z<SY4A3XR
>SXb>SXRC4a4A3XZ008I8R824A4A00@I6ATA4A4I6A4I6A444A4A00<I6ATI
6A4Z4@P00a4A4@056ATA6ATI6ATI4A4A6ATI00@A4A436ATA0Q4A4@06:Q48
4A4A4A4A6ATA4A4A:Q480a4A4@0@6ATA6ATI8R8A:R8I>SXb<SY4<RXR>SXb
<SY4A4@bA4A<>TA<A4@b>TA<8SXbOVEDMlc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Pcc<c<614A4@0300004A4A000000TA4A400`00014A4@00
00054A4A00DI8T`RC5@I8T`b:R8R:RX00R8bA005<RXR8S94<SY48S8Z<SY4
008R<T@01B8j<R8bA28j<QTR<R8j<P038RXZ0R8j<P0;>TA<8RXZ8S946B8R
6B8b8SYL<SY44A4A8RXZ8S94:R8I008R<T@38RXZ00Hb>T@R:RXR:RXR<RXR
:RXb:R848RXZ00@R<T@I6A4I8T`R>U`2000000<I6A4A4A4A4A401Q4A4@06
00006ATA00004A4A0000:Q481Q4A4@046ATA4A4A4A4A00001Q4A4@040000
4A4A4A4A6ATA0Q4A4@036ATA4A4A4A4A00DA4A4021TI4A4A4A4A4ATR8P00
01TI4DA4C3Y4<P8b>T@2>TA<01U4A4`b>T@b>T@jA4`b>T@RA3Y4A38b>T@I
8RXb>TA4A4`jA4`j>S8b>TA4A4`jA4`RA3Y4>RXR>S94A4`RA3XjA4`jE5`j
A4`jE5`00cY4C009C4a48SXb>T@b<SY4>TA<C4`jC4a4>TA<A4A<008jE5`0
13Y4C3YDG28Z:P00008A4A400bXA214A4A4A4@064A4A00DI6ATA4A4A4A4A
4A4I6A400a4A4@058R8A4A4A6ATA4A4A6ATA008A4A401R8R4A4A4A4A4ATI
4A4A4ATI4@8A4A400aTI6A4A4A4A4@024A4A00DI6A4A4A4A4A4A4A4I6A40
0Q4A4@08:R8IC4`j<SY4<SY4A3XZ8S94>SXb8S941C8jA0068T@j>SXb<SY4
>SXb8RXZ8SXb0S8jA00=8SXb>SXb<SY48SXb8S94A4@b8S948S8Z8SXb8S8Z
<RXR>SXb8SXb008R:RX03bXR6B8Z:S8Z8T@j:SY4C38jA3Xj<S8jA4a<A38j
A1TI6A4A4BXA214A4BXA20064A4A00@I6A4A4A4A4A4I6A434A4A00HI6A4I
6ATA4A4I6A4Z4@PI6A424A4A0aTI4@8A4A401ATI4A4A4ATI6A4A4ATI4@05
4A4A00DZ8QTR:RY4A4`b>TA<C4@00SXj<P0:>TA<A4A<>T@bA4A<<SY4A3XZ
>T@bA4A<C4`jOWIDMlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pc
c<c<00<A4A40000A4A400Q4A4@0300004A4A0000008A4A400`00014A4A4A
4@034A4A00@0000A4A4A4A4I6A484A4A00L0000A4A40000A4A40000A4A40
00001A4A4@0G00004A4A00004A4A8S8Z6ATI6B8R8RXZ8S948RXZ8S946B8R
8S948SXb6B8b6B8Z8S8Z8S94<SY48S948S8Z8S948S8Z00<R:RX00aTR8QTR
:R8Z:P028RXZ00hb>T@RA3XR:RXR>S8b>T@I8R8I8S8R:RXR<T@jA4`I8S8R
:RXR<RXRC5@2<SY40R8bA0086B9<8S8Z<RXR8RXZ8S94<SY48RXZ<SY41A4A
4@0400004A4A4A4A6ATA2a4A4@03:Q484A4A4A4A00HA4A401ATI6@00014A
4A4A4ATI4@024A4A00<I6A4A4A4A4A401Q4A4@036ATA4A4A6ATA00DA4A42
A4A<0cY4C006>T@b>TA<>TA<>TA<<SY4>T@b0SY4C0038SXb<SY4>SXb008R
A3X0238jA294>TA4C3YDG4a<>SYDG3Y4C294>P8b>T@02SY4C4a<A4A4C3Y4
<SY4C3Y4<SY4C4A4C3Y4C4a<A08jA4`014A4C3YDG4a<A3YDG08jA4`014a<
A28b:P0002XA20@A4A400bXA214A4A4A4@044A4A00<I6ATA4A4A4A400a4A
4@036ATA:Q486ATA008A4A400aTI4A4A4B8R4@034A4A00/I6A4A4A4I6A4A
4A4R8Q4A4A4I6ATA4A4I6A4A4A4I6A40114A4@0>00008R8A8RXZ>TA<<SY4
8T@j>SXb8SXb<SY4>SXb<SY4>SXb>T@b<SY40SXj<P06<SY4>SXb>SXb<SY4
A4A<A3XZ0SXj<P03<SY48SXb<RXR008j>S801R8bA3Xj<S8Z8S8jA4a<A38j
A08j>S826ATI0SXj<P03<SY4>TA<>TA<009<C3X00b94>RXA200000064A4A
00@Z4@PI6A4A4A4Z4@P24A4A00DI6A4A4A4A4A4A4A4I6A400Q4A4@<I6A40
214A4ATI4A4A4A4A4BXA214A4ATI4B8R4@8A4A401ATI4A4A4ATI4A4A4ATI
6@024A4A00TZ8QTb>TA<C3XjA4`b>T@j>R8jA4a4A4`jA4`00SY4<P03A4@b
>SXbC4a40094A4`00da<A3Y4<Wi]I@1gc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^3?<c<`34A4A00<0000A4A4A4A400a4A4@0300004A4A4A4A
00TA4A401P00014A4A4A4@00014A4@0000TA4A401000014A4A4A4@0000LA
4A400`00014A4A4A4@054A4A00@I6ATA4A4A4A4I6AT24A4A00HZ8QTA4A4I
8R8A4A4I8R8I6AT24A4A018I8R8R:RXR:RXR:RXR<RXI8RXR:RXR<RXj>S8R
<T@b>T@R<T@R>S8R>U`Z8QTI8S8RC5@jE5`28TaD00PjA4`R<T@jE5`RA3XR
C5@R<RXb>T@000094A4A00<0000A4A4000001A4A4@0300004A4A4A4A00DA
4A400aTI4A4A4A4A4@074A4A00@I6A4A4A4A4A4000024A4A00DI6A4A4A4A
4A4A4A400000114A4@036ATA4A4AA4A<008jE5`00cY4<TA4C38jA002>TA<
00Db>TA4A4`b>T@jE5`jA4`00S8jA007>SXb<SY4<SY4A3XZ<SY4>T@b>UAL
008jA4`02DA4C3Y4C3Y4C38jA4a<>SYDG4a<>SYDG3Y4C002C4a400hjE5`j
A4a4A4`jE5`jA4`jE5aLG4`jA4`jE5a<C4ALG4`jE5`A4A4000054A4A00@I
6ATA4A4A4A4Z4@P34A4A00<I6AT0000I6AT00Q4A4@0?6ATA4A4A6ATA6ATA
4A4A6ATA4A4A6ATA4A4A6ATI4A4A6B8R4A4A6ATI6ATA00`A4A401RXA21TI
6Da<A3Y4C38jA3Xj<P<b>T@01b8bA3Xj<SXj<S8jA3Xj<S8jA28bA002>SXb
00Db>T@RA3Xj>S8b>T@RA3X01S8jA0038T@j>TA<>SXb00<b>T@04cXj<S8j
A3YDG3Xj<TA4<SY4C38jA3Xj<SXj8TA4C294>QTR8P00014A4ATI4A4A4ATI
4A4A4ATI4@064A4A00<I6A4A4A4A4A400Q4A4@056ATA4A4A4A4A:Q486ATA
00<A4A401ATI4A4A4A4A4A4A4B8R4@044A4A00TI6ATR8Q4I6A4I6A4A4A4b
:R8jA4a<C4A4A4`00S8jA00<>T@bA4@b>SXbC4`j>TA<A4A<C4a4A4A<G5a<
>UALC4`j>TA<0Ta<A003OVeUc<c<c<c<07G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h<lc<c0<A4A400`00014A4A4A4@054A4A00XI6A4A4A4A
4A4A4A40000A4A40000A4A40000I6AT34A4A00<0000A4A4A4A400Q4A4@07
00004A4A4A4A4A4A00004A4A0000008A4A401000014A4A4A4@00008A4A40
1000014A4A4A4@00008A4A400`00014A4A4A4@024A4A00<0000I6ATA4A40
0a4A4@0500004A4A4A4A4A4A000000@A4A402P00014A4@00000002XA2000
014A4@00014A4@0000<A4A42000000@A4A40000A4A4000024A4A00<0000I
6ATI6AT00QTI6@`A4A400aTI4A4A4A4A4@0;4A4A00<0000A4A4A4A400Q4A
4@0500004A4A4A4A4A4A000000/A4A404ATI4A4A4A4A4A4A4@0005aLC38j
A4a<A38jA3YDG4a<A29<E4a<A3Y4C3YDG294>SXj<P02<SY400@R>S8b>T@b
>T@jA4`2<SY400@jA38jA4`jA4`b>T@2C4a40SY4C00>>T@bC5A]C4a4A4A<
>UALG5a<>UAL>TA<8T@jA4A<>TA<A4A<>TA<C4a40dA4C006C4a48SXb0000
6ATA4A4A6ATA314A4@036ATA4A4A:Q48008A4A4021TI4A4A4@0001TI4@00
01TI4A4A4B8R4@<A4A4011TI4A4A4A4A4ATI4@8A4A401ATI4ATI6ATI6A4A
4ATI4@044A4A0154A38jE5`jE5aLG4`jA4`b>T@j>S8R<T@b>T@j>S8b>T@R
>S8j>S8jA4`j>S8R>S94A3800R8bA003>SXb8S94<SY4008b>T@01B8bA4@j
:S8jA3Xj<SY4C003<SY400I4>RXb>TA4>RXb>T@j>S8RA3X2>TA<00Hb:R8b
>TA<C4@RA3XA4A4000044A4A00DI6A40000I6ATA4A4I6A400a4A4@03:Q48
4A4A6ATA008I6A424A4A00@Z4@PA4A4A4A4I6A424A4A00<Z4@PA4A4A4A40
1a4A4@096ATI4A4A4A4A6ATA8RXZC4a4<SY4>SXb>TA<00<j>S801dA4<Ta<
A4A4C4A4C4a<>Ta<A3YDG002C4a400HjA4`jE5a<C4A<C4A4A4b7OUAgc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`94A4A00<0000A4A40
0000214A4@0300004A4A4A4A01HA4A401000014A4A4A4ATI6@<A4A400`00
01TI6A4A4@024A4A00@0000A4A4A4A4000044A4A00DI6A4A4A4Z4@P0000Z
8QT0214A4@0500004A4A4A4A4A4A000000LA4A401000014A4A4A4@0000DA
4A401@00014A4A4A4A4A4@0000024A4A00DI6A40000A4A4A4A4000000a4A
4@0300004A4A4A4A008A4A400aTI4@00014A4@044A4A00<Z4@PA4A4A4A40
1A4A4@066ATA4A4A4A4A4A4A6B8R6ATA1Q4A4@06:Q48>UALA4A<>UAL>TA<
>UAL0SY4C003C4a4>TA<<SY4008b>T@02dA4C38jA4A4<S8jA3Y4C4A4C294
>SXj<TA4C3YDG4a<A002>TA<00Tb>T@jA4`b>TA<C4@jA4a<C4@jA4a<C4@b
>T@00cY4C00=>SXb8SXb>SXb>TA<>T@b<SY48T@jA4A<>UAL6B8R00004A4A
0000010A4A400`00014A4A4A4@034A4A0aTI4@<A4A400bXA214A4A4A4@06
4A4A00<I6A4A4A4A4A400Q4A4@06:Q48A4@bC4a4>UALC4a4G5a<0S8jA005
>SXR8T@j<SY48S948RXZ008b>T@00b94>R8b:R8j<P03<SY400Lj>S8b>T@b
>T@b:R8j>S8b>T@j>S800S8jA0058S8ZA4@bC4`j>SXb>TA<00Db>T@2C4a4
00Q4A4a<C4@R<RXI6AT0000I6A4A4A4Z4@P84A4A00<I6A4A4A4A4A400Q4A
4@056ATA4A4A00004A4A:Q4800@A4A426ATA0Q4A4@03:Q484A4A:Q48008A
4A40428R4ATI6BXA200001TR8S8jA4a<>SXj<S8jA38Z8SXj<QTR8R8b:SXj
<S8jA4@j:P8b>T@01CXj<TA4C4a<A4A4C4a<A002C4`j0da<A003A4A<OVeU
c<c<07K<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c08A4A40
0`00014A4A4A4@074A4A00D0000A4A4A4A4A4A4000001Q4A4@0800004A4A
4A4A00006ATI00004A4A00000Q4A4@0300004A4A000000HA4A400`00014A
4A4A4@034A4A00<0000A4A4A4A400Q4A4@0300004A4A4A4A008A4A402@00
014A4A4A4A4A4@00014A4@00014A4ATI4@024A4A00<R8Q4A4A4A4A403Q4A
4@0300004A4A000000HA4A420000114A4@0600004A4A4A4A00004A4A0000
114A4@0300004A4A4A4A00<A4A400`00014A4A4A4@024A4A00<0000A4A4A
4A400a4A4@0300004A4A4A4A00@A4A400`00014A4ATI4@054A4A00X0000A
4A4A4A40000I6AT0000A4A40000A4A4000024A4A0QTR8P076B8Z8RXZ6B8b
8RXZ6B8b8T@j8RXZ008I8S805B8bA294>R8bA3Y4C28j<S8jA28j<S8jA1UD
<TA4C29<E4a<A29<E3Y4C29<E4a<A28j<SY4C38jA28j<SYDG002>TA<00<R
<TA<C4@R:RX00Q4A4@03:Q484A4A4A4A00XA4A4011TI4A4A4A4A4ATI4@LA
4A401ATI4@0001TI6ATI4A4A4@026ATA0a4A4@046ATA4A4A4A4A6ATI1Q4A
4@05:R8IC4a4>UALC4a4G5a<008jE5`014a<A3Y4C38jA28bA08j>S800b8Z
:SXj<S8jA002>SXb0S8jA0038T@j>SXb8T@j008j>S805S8jA3Y4C4A4<S8j
A3Xj<S8jA3Xj8R8b:R8bA294>S8jA3Xj<SY4<Ta<>SY4C4a<A3Y4C4a<A28b
:Q4A4@0002XA20@A4A400aTI4A4A4A4A4@024A4A00<Z4@PA4A4A4A400Q4A
4@03:Q484A4A4A4A008A4A400bXA214A4A4A4@034A4A00@I6A4A4A4I6A4I
6AT24A4A00TI6A4A4A4A4A4I6A4A4A40000I8R94>RY4A4`00cXj<P03<SY4
>SXbA4A<008b>T@014a<>R8bA38Z8R8b:P<j>S801S8jA3Y4<TA4C4A4C38j
A3Y4C08b>T@00b8j<WiUE<c<c01fc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^3?<c<`94A4A00<0000A4A4A4A402A4A4@076ATI4A4A4A4A4A4A
00004A4A000000<A4A400`00014A4A4A4@024A4A1@0000<A4A43000000DA
4A4I8R80000A4A4000000a4A4@0400004A4A4A4A6ATA0a4A4@056ATA4A4A
00004A4A0000008A4A401@00014A4ATR8R8R4@0000024A4A00P0000A4A4A
4A40000A4A40000A4A4000064A4A00@0000A4A4A4A4000054A4A00@0000A
4A4A4A4000034A4A00<Z4@PA4A4000001Q4A4@0600004A4A8R8A00004A4A
00003A4A4@036ATA4A4A4A4A00<A4A400`00014A4A4A4@034A4A00<Z4@P0
000A4A400Q4A4@05:Q484A4A4A4A6ATA0000008A4A401000014A4A4A4BXA
20DA4A401000014A4@00000000<A4A42000000DA4A40000A4A4A4A400000
0Q4A4@0400004A4A6ATI0000114A4@0300004A4A000001<A4A401RXA214A
4A4A4A4A4ATI4A4A4@8I6A444A4A0QTI4@<A4A403QTI6A4A4ATI4A4A4ATI
4A4A4C8Z8UaLC4aDKDa<A5a]MVf7OUa]QdA4C08b>T@03CXj<SY4C3Y4C3Y4
<R8j<S8jA294>SXj<S8jA38Z8S8jA4a<>SXj<P03<SY400=4A38jA4`b>T@0
1C8jA003A3XZ<SY4A4@Z00@jA4`014a<A4A4C1TR8P0000DA4A4012XA21TI
4A4A4BXA208A4A401BXA214A4A4A4BXA214A4@026ATA00<A4A4R8Q4R8Q40
1a4A4@08:Q486ATA4A4A4A4A6ATA4A4A6ATA4A4A0QTI4@064A4A:R8IA4A<
A4A<>SXbA3XZ0TA4C0<j>S8014A4<S8jA3Xj<S8jA08j>S801Ta<A3Xj<TA4
<S8jA4A4<TA4C0@j>S80138jA4A4<R8bA7ifE7O<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h<lc<c00900004A4A00004A4A6ATI4A4A6ATA0000
6ATI00PA4A401QTI4A4A4A4A4ATI4@0008m400:aK@000hLZ014A4A4A4@06
4A4A00h0002OC03:MP2iQ`2aK@2iQ`2aK@0A4A40002iQ`3:MP2iQ`3:MP0j
A1T;4A4A00PI6A4A4A4I6A4A4A40002?A03SW`3:MP044A4A00C:MP3/Z@1U
6@00000A4A4A00<0000A4A4000000a4A4@0300004A4A4A4A00<A4A400`00
014A4A4A4@034A4A00@0000A4A4A4A4I6A444A4A00<I6A4A4A400000214A
4@0300004A4A000000LA4A401@00014A4A4A4A4A4BXA200=4A4A00@Z4@PA
4A4A4A4000024A4A00@I6ATA4A4A4A4I6A444A4A00<Z4@P0000A4A401Q4A
4@036ATA4A4A4A4A00<A4A401@0001TI4A4A4A4A4ATI4@054A4A00<0000A
4A4A4A406a4A4@0E8R8A:Q48:R8I8R8A00006ATA4A4A0000A2XRC4a4G6ef
>UALC4a4>UALC4a4>UAL>TA<<SY44A4A6B8R>TA<00<b>T@2>SXb00DjA4`j
>S8b>T@R<T@RA3X00S8jA005>SXb<SY48T@j<SY48S94008j>S801S8jA294
>R8b:R94>S8jA3Y4<P=<C4@014A4C4a<A28j<P0000@A4A400bXA214A4A4A
4@064A4A00<Z4@PA4A4I6A400Q4A4@096ATI4A4A4A4A4A4A00006ATA6ATI
4A4A:Q4800DA4A406R8R4BXA214A4A4A4ATI6A4A4ATI6B8Z:Ta<A4a<>S8j
A4A4C4A4<S8jA4A4C38jA4A4<S8jA38Z8QTR<SXj<R8bA38jA28b:SXj<R8b
A08b>T@02cXj<T@j:SY4C4A4<SXj<SY4C4A4<SXj<TA4C3Xj<WiUE01gc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`34A4A00<I6ATA4A4A
4A400Q4A4@0300004A4A4A4A00<A4A400aTI6A4A4A4A4@024A4A00<I6A40
001U<PP00m:?0003^HL0QbX0000000DA4A401000014A4KV70>>O00:iQ`00
2m:?0;V7014A4@000=:?0<Yf0>>O0;V7028R4A4A4@0000064A4A0QTI4@DA
4A401P0008m40;V709m<0=:?028R4@8000001[5]09N70<Yf0;U<014A4@00
00@A4A401000014A4A4A4@00008A4A401000014A4A4A4@0000XA4A400`00
01TI4A4A4@094A4A00H0000A4A4A4A4I6A4A4A4000034A4A00<I6A40000A
4A405A4A4@0300006ATA4A4A00<A4A401ATI4A4A4A4A4A4A4@0000026ATA
1Q4A4@0500004A4A4A4A4A4A6ATA00<A4A400aTI4ATI6ATI6@074A4A00<Z
4@PA4A4I6A400Q4A4@05:Q4800004A4A4A4A6ATA00@A4A401BXA214A4A4A
4A4A4BXA200;4A4A00@I6A4A4A4A4A4Z4@P24A4A00DI6A4I6ATA4A4A4A4Z
4@P00Q4A4@056ATI4A4A4A4A4A4A6ATA008A4A402bXR6B9<E28j<SY4C4A4
<S8jA5aLC3YDG38jA3Y4<SY4C002C4a400Dj>S8b>TA4A38b>TA<C3X00S8j
A0098S8Z>SXb>SXb<SY4>TA<A4A<<SY4A4A<>SXb008jA4`02294>SY4C294
>S8Z8R8bA4@j:TA4C3Y4C0=4A4`00b94>Q4A4@0000024A4A00DZ4@PA4A4A
4A4A4A4I6A400a4A4@04:Q484A4A4A4A:Q48114A4@056ATA4A4A6ATA4A4A
:Q48008A4A400bXA214A4A4A4@044A4A00<I6A4A4A4A4A400Q4A4@056ATA
<RXRA4@b>SXbA3XZ008b>T@023Y4<SY4C4a<>R8bA3Xj<R8j<SXj<S8jA0@j
>S800c8jA4@j:S8jA005>SXb0S8jA006>T@bA4A<A4A<A4A<>T@bOVeUMlc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<1A4A4@8000034A4A
00<0000A4A4000000a4A4@036ATA4A4A4A4A008A4A401/Yf0;5]00000000
06Db2>bY008A4A402P0001TI4A4A4A4A4BXA214A4@000;V708LZ04`R2080
00024A4A00@0001U<PS/Z@00000;4A4A00@0000I6A4A4A4I6A434A4A00D0
000R8Q6iQ`2OC01<8PP00Q4A4@040000UhL0UhL0/Fd00a4A4@03:Q484A4A
4A4A01/A4A400aTI4A4A4ATI4@024A4A00<Z4@PI6A4000001A4A4@040000
4A4A4A4A00000a4A4@0500004A4A4A4A4A4A000000@A4A401@00014A4A4A
4@0001TI4@064A4A00<I6ATA4A4R8Q401A4A4@0600006ATA4A4A4A4A6ATA
00001A4A4@046ATA00004A4A6ATA0a4A4@03:Q484A4A:R8I00dA4A400`00
01TI4@0000044A4A0QTI6@@A4A401@00014A4BXA214A4ATI4@044A4A00<b
:R8I6A4I6A400Q4A4@036ATA4A4A4A4A00@A4A400aTI4A4A4A4A4@034A4A
00@Z4@P0000A4A4Z4@P2000000@A4A400000000000024A4A01<b:R8R<RXR
<RXR:RXR>S8R<T@RA3Xb>T@R>S8RA3Xb>T@RC5A4A4`j>S8RC5@jA4a4A38R
<T@jA4`00S8jA00<>SXb<SY4>SXb<SY4A3XZ<SY4A4A<>TA<A4A<8RXZ6ATA
00000aTI4@dA4A401QTI6BXA21TI6A4A4ATI4B8R4@PA4A43:Q48114A4@05
<RXRC4`jC4a4C4`j>SXb008b>T@034A4<SXj<SXj<SXj<S8jA4@j:S8jA4A4
<S8jA3Xj<R8bA4A4<P8b>T@01CXj<S8jA4A4<SXj8TA4C002A4@b00=4A4`j
A38jA4`00SY4C004>T@bA4A<A4@bOVEDMlc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Pcc<c<1a4A4@0300004A4A4A4A00HA4A4200000Q4A4@08
0000^HL0^HL000004A4AIAT0o<4000000a4A4@0900004A4A4A4A6ATA4A4A
0000k:T0hil0:Q4800<A4A400`0004@A0?c100024A4A00<I6ATA4A4A4A40
0Q4A4@036ATI4A4A4A4A008A4A401FDb2000014A4ATI6ATI4@024A4A00b7
:P1U<PQ44@3BS`2OC00A4A4R8Q67:P1U6@2?A03/Z@0000084A4A00<0000A
4A4A4A400Q4A4@036ATI4A4A4A4A00HA4A400`00014A4@0000044A4A00<I
6A40000A4A400P0000036ATA00006ATA008A4A400aTI4A4A4A4A4@084A4A
00<Z4@PA4A4A4A400a4A4@046ATA4A4A4A4A00000Q4A4@046ATA4A4A6ATA
00001A4A4@036ATA00004A4A00HA4A401aTI4A4A4A4A4A4A4@00014A4BXA
20034A4A00<Z4@PA4A4I6A400Q4A4@036ATA4A4A4A4A00XA4A400`00014A
4ATI4@054A4A00<I6A4I6ATA4A401a4A4@036ATA4A4A4A4A00DA4A400aTI
4A4A4A4A4@034A4A00DI6A4A4A4A4A4A4A4Z4@P02A4A4@8I6A434A4A0QTI
4@034A4A6ATA0000008A4A4200000a4A4@0500004A4A4A4A0000:Q480080
00034A4A0QTR8P<R:RX00b8b:R8Z:R94>P028T@j00PjA38jA4`jA4`RA3XA
4A40000A4A4I6A434A4A00<I6A4A4A4R8Q40114A4@07:Q484A4A4A4A:Q48
4A4A6ATA0000008A4A400aTI4A4A4A4A4@034A4A00PZ4@PA4A4A4A4I6A4A
4A4I6A4R8Q4I6A424A4A00DZ4@Q<C4@jE5`jA39<C4@00TA4C003A4@bA4A<
A4A<00<j>S802b8b:S8jA3Xj<T@j:S8jA3Xj<S8Z8S8jA3Xj<S8jA3Xj<P02
<SY400Lj>S9<C3Xb>TA4A38j>S9<C4A4A4`00TA4<P04C4a4A4A<8T@jIFDj
Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<0QTI6@056B8Z
4A4A6B8R4A4A6B8R00`A4A4011TI4A4A4BXA29m<00;SW`000m:?04@A014A
4@034A4A00XI6A4A4A4A4A40000I6A4A4A4Z4@QU<PSl`@0000034A4A00@b
:R;l`@0Z4@P000024A4A00<I6ATA4A4A4A400QTI6@8A4A4014`R2?oB22XA
21TI6@<A4A4038LZ0?c10>>O0>bY0>>O0;5]00000;V70?c10>bY0>>O0>bY
00<A4A400aTI4A4A4A4A4@084A4A00<0000A4A4A4A402a4A4@0300004A4A
4A4A00dA4A400`00014A4A4A4@064A4A00<Z4@PA4A4A4A400a4A4@036ATA
4A4A6ATA00HA4A400bXA214A4BXA20024A4A00<I6A4A4A4A4A401a4A4@03
6ATA4A4A4A4A00<A4A400aTI4A4A4A4A4@024A4A00DI6A4A4A4A4A4A4A4Z
4@P0114A4@046ATI4A4A4A4A6ATA1A4A4@036ATA4A4A0000008A4A401P00
014A4A4A4ATI4A4A4BXA20DA4A400b8R4ATI6A4A4@084A4A00<I6A4A4A4A
4A400Q4A4@05:Q484A4A4A4A4A4A6ATA00<A4A401BXA214A4A4A4A4A4ATI
6@044A4A00<0000I6A4A4A400Q4A4@03:Q484A4A4A4A00<A4A401RXA214A
4A4A4A4A4@0001TI4@@A4A401@0001TI4@0001TI4@0000024A4A00<0000Z
4@PA4A400Q4A4@0300004A4A:Q4800<A4A400aTI4A4A4ATI4@054A4A00<Z
4@PA4A4I6A40114A4@046ATA4A4A4A4A6ATI0Q4A4@036ATA4A4A:Q4800<A
4A402BXA214A4A4A4A4A4@00014A4ATR<TA4C5aLC002C4a400<jE5aLG4a4
A4`014a<A00<A4A<<SY4A4@b<SY4C4`j<SY4A4@b<SY4A4@bC4a48T@jC4a4
0SXj<P0?<SY4C4`jA4@b<SY4C4`j<SY4A4A<C4a4A4A<G5a<C4a4A4A<6ATA
4A4AIE@b07O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c004
6B8R6ATA6B8R6B8Z0Q4A4@046B8R4A4A6B8R00002Q4A4@040000ID`IdXl0
Qd`A0XmU4@03hil06ATA6ATI00LA4A42000000/A4A6?A03SW`2OC00I6ATA
4A40003l`@0Z4@PA4A4I6AT00Q4A4@056ATI4A4A4A4A4A4A6ATI008A4A40
2Xm40?c1000001TI6A4A4K5]0>bY04`R26Db22XA20:iQ`001P000>bY04@A
04`R26Db2?c10080000G4A4A00@0000A4A40000I6A4>4A4A00<I6A4A4A4A
4A400a4A4@036ATA8RXZ4A4A00@A4A400aTI4A4A4A4A4@054A4A00LI6A4Z
4@PA4A4A4A4I6A4A4A4I6A40114A4@056ATA4A4A6ATA4A4A6ATA00DA4A40
12XA214A4A4A4ATI4@@A4A400aTI4A4A4ATI4@024A4A00@I6A4A4A4A4A4Z
4@P64A4A0QTI4@@A4A400aTI4A4A4BXA20034A4A00<0000A4A4A4A40114A
4@036ATI4A4A4A4A00DA4A400b8R4A4A4A4A4@024A4A00<I6A4A4A4A4A40
0a4A4@056ATA4A4A4A4A6ATA:Q4800@A4A401ATI4A4A4A4A4ATI6BXA2003
4A4A00<R8Q4I6A4A4A401a4A4@046ATA4A4A4A4A6ATA0Q4A4@03:Q484A4A
4A4A00HA4A401bXA214A4A4A4A4A4@00014A4ATI4@064A4A00<0000I6A4Z
8QT00RXR6@03:Q484A4A4A4A00<A4A400bXA214A4A4A4@024A4A00<Z4@PA
4A4Z4@P01a4A4@06:Q484A4A:Q48A3XRC4`jOVeU0UaLC004C4a4G5a<C5A]
G5a<0da<A007>UALC4a4A4A<<SY4C4`j<SY4C4a400<j>S803CY4C4@j:S8j
A3Y4C28b:TA4<TA4C3Y4<TA4C3Y4<TA4C4A4<TA4C002G5a<00M<C4@RA3XI
6ATI6A4R8Q4A4A5UE380Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Pcc<c<0QTR<P038S946ATI8S94008R<T@0128jG3YDG1TR8P0000@A4A40
0`00014A4A4A4@034A4A00>?A03/Z@0000000P000006o<40:Q484A4A4A4A
6ATI6B8R0a4A4@03:Q48hil04A4A008A4A401oc10;5]000004`R2=:?0?c1
04`R20054A4A0QTI6@0<4A4A6ATA4A4A4A4A6ATIk:T0dXl0:Q486B8RWd`0
o<404A4A0P000004Wd`0dXl04A4Aom880P0000034A4Ao<404A4A00XA4A40
0aTI4A4A4ATI4@034A4A00H0000A4A4A4A40000A4A4I6AT64A4A00<I6A4A
4A4A4A400Q4A4@036ATI4A4A4A4A008I6A474A4A00<I6A4I6ATA4A400QTI
6@TA4A4012XA214A4A4A4ATI4@<A4A400bXA214A4A4A4@024A4A00DI6A4A
4A4I6A4A4A4I6A40114A4@066ATA4A4A4A4A6ATA4A4A6ATI0a4A4@046ATA
4A4A6ATA6ATA0a4A4@048R8A6ATI:Q488RXZ0Q4A4@046ATI4A4A4A4A6ATI
1a4A4@8I6A401Q4A4ATI4A4A4A4A4BXA21TI4@DA4A400bXA214A4A4A4@03
4A4A00<I6A4A4A4A4A400Q4A4@056ATA4A4A4A4A4A4A6ATA008A4A400aTI
4@00014A4@064A4A00@I6A40000A4A4I6A434A4A00<I6A4A4A4A4A401Q4A
4@03:Q484A4A4A4A00@A4A400aTI4A4A4A4A4@034A4A00<I6A4A4A4A4A40
0a4A4@036ATI0000:Q48008A4A400`00014A4A4A4@024A4A00`Z4@PA4A4A
4A4I6A4I8R8I6A4A4A4I6A4A4A4I6A4A4A4I6A424A4A00<Z4@PA4A4A4A40
0Q4A4@036ATA4A4A4A4A00PA4A401R8Z:S8jA29<E38jA4A4C3YDG09LG4`0
0dA4C4a<A4a<>P06C4a400Lb>TA4>RXjA4`j>S8b>T@j>S8b>T@00cXj<P0B
A4@b<SY4A4@bA4A<A4@bA4A<C4a4C4`jC4a4A3XZ6B8R4A4A:Q486ATI6ATA
6ATI4A4AIFDjMlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<
0R8bA08R>U`01R9<E28jG38jA1UDOS94MSYDG0PA4A401@0001TI4@0004`R
2>>O0002QbX000>?A03/Z@0R8Q401a4A4@0<C288dXl0Sd@0Wd`0Sd@0dXl0
Sd@04A4AIC88dXl0k:T0IC880a4A4@036ATI4A4A4A4A00<A4A402QTI4@00
014A4NbY0>>O06Db200005`j8YN70;5]00>iQ`0028mU4@000;V70;V70=:?
0<Yf0;V7000000<A4A400bXA214A4A4A4@026ATA0a4A4@0400004A4A4A4A
6ATI2A4A4@056ATA4A4A4A4A4A4A0000008A4A402ATI4ATI6A4A4ATI4@00
01TI4@00014A4BXA20044A4A00LI6A4A4A4A4A4A4A4Z4@PA4A4Z4@P00Q4A
4@06:Q484A4A4A4A:Q484A4A6ATA0Q4A4@056ATA4A4A4A4A4A4A:Q4800<A
4A4011TI4A4A4ATI4A4A4@8I6AT34A4A00@I6A4A4A4A4A4I6AT64A4A00XR
8Q4I6ATI6A4I6A4A4A4I6ATA4A4I6A40000I6AT24A4A00DI6A4A4A4I6ATA
4A4I6AT00Q4A4@056ATI6ATA4A4A4A4A8R8A008I6AT01Q4A4ATI6C8Z8Q4A
4B8R4A4A4@8I6AT00a4A4BXA214A4@044A4A00<I6A4Z4@PA4A400Q4A4@03
6ATA4A4A4A4A00lA4A4011TI4@00014A4ATI6@XA4A4022XA214A4A4A4A4A
4ATI4@00014A4ATI4@DA4A4011TI4A4A4@0001TI4@8A4A426ATA00<I6AT0
000I6A401Q4A4@03:Q484A4A4A4A008A4A401QTI4@0002XA21TI4A4A4ATI
4@8A4A400bXA21TI4A4A4@024A4A00HZ4@PA4A4A4A4A4A4Z4@P000024A4A
00<Z4@PA4A4Z4@P0114A4@030000:Q484A4A008000034A4A010I6ATR:RXb
>T@jA4a4A4a<C4@jE5a4A39<C3Y4A4a4>RY<C3Y<C4ALG4a<C4A<C3X2C4a4
00A4A4a<C4A<C4A4A382A4A<00<j>S8I8R8A4A400aTI4@064A4A6ATA6ATI
6ATI4A4AIE@bMlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<
00XI8R8A4A40000I8RXI8S8I8T`R>U`bA7HI>WHjG7H54A4A00<I6ATA4A4A
4A40114A4@05:Q48o<40k:T0o<40:Q4800PA4A40300002XA2?c10>>O0>bY
02XA214A4@00014A4@000>>O06Db208A4A456ATI0a4A4@056ATI4A4AfhL8
fl48C288008A4A400`000>>O0=:?0002^HL000<0000A4A4R8Q400m:?0003
6ATA4A4A4A4A00@A4A400aTI4A4A4A4A4@054A4A00<I6A4I8S8000003Q4A
4@04:Q484A4A6B8R00000QTI4@XA4A400aTI4A4A4A4A4@034A4A00@I6ATA
4A4A4A4I6A444A4A00DI6A4A4A4I6A4A4A4Z4@P00Q4A4@04:Q484A4A4A4A
6ATA114A4@8I6AT00a4A4BXA214A4@024A4A00LI6A4A4A4I6A4I6ATA4A4Z
4@PI6AT00a4A4@056ATA4A4A6ATA4A4A:Q4800@A4A400aTI6A4A4A4A4@04
4A4A00<I6A4A4A4I6A400Q4A4@036ATA4A4A4A4A008A4A400aTI4A4A4A4A
4@024A4A0QTI4@044A4A:Q484A4A:Q480Q4A4@058R8A4A4A6ATA4A4A6ATA
008A4A400aTI4A4A4ATI4@026ATA00@A4A4I6A4A4A4Z4@P44A4A00<I6A4A
4A4A4A40114A4@036ATI4A4A4A4A008A4A4011TI4A4A4A4A4A4A4@8I6A43
4A4A00<I6A4A4A4A4A400Q4A4@076ATA4A4A4A4A6ATA4A4A00006ATA008A
4A4011TI4@0001TI4ATI4@8A4A4012XA214A4A4A4BXA208I6A494A4A00LZ
4@PA4A4A4A40000I6A4A4A4I6A400Q4A4@05:Q484A4A4A4A4A4A:Q4800HA
4A400bXA214A4BXA20024A4A00TZ4@PI6A4A4A4A4A4I6A4Z4@PA4A40000I
6A400P00000G:Q484A4A4A4A4A4A6B8R6B8Z8RXZ6B8Z8SXb>TA<<SY4A4A<
C4a4G5a<C4a4G5a<8RXZ6ATA:Q484A4A6ATA6ATI6ATA00<I6AT011TI4ATR
8Q4A4FEL:WO<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c003
6B8R0000000000D0000011TI6ATR8P000000008A4A400aTI6A4A4A4A4@06
4A4A00DZ4@PI6ATR8Q4A4A4I6AT00Q4A4@8I6AT54A4A00<0000A4A4A4A40
0a4A4@036ATI4A4A4A4A00<A4A400aTI6A4A4A4A4@044A4A00<I6ATA4A4A
4A400P0000044A4A6ATI4A4A4A4A1000008I6A40114A4@000000000002`A
4A400aTI6A4A4A4A4@024A4A00<0000A4A4I6A400QTI4@HA4A400bXA214A
4A4A4@044A4A00DZ4@PA4A4A4A4A4A4Z4@P00Q4A4@036ATA4A4A6ATA00@I
6A424A4A00<I6A4A4A4I6A401a4A4@036ATI4A4A6ATI008A4A400b8R4A4A
4BXA20044A4A00@Z4@PA4A4A4A4Z4@P54A4A0QTI4@DA4A401ATI4ATI6A4A
4ATI4ATI6@024A4A11TI4@HA4A402ATI6A4A4ATI6ATI4ATI6ATI4A4A4ATI
4ATI6@036ATA00@Z4@PI6A4I6A4I6AT36ATA00DI6ATA4A4I6A4A4A4R8Q40
0Q4A4@03:Q4800006ATA00<A4A400`0001TI4A4A4@034A4A00<Z4@PA4A4A
4A400a4A4@0300004A4A6ATA00HA4A400`0001TI4ATI4@064A4A00@I6A4A
4A4A4A4Z4@P34A4A00<Z4@PA4A4Z4@P01Q4A4@086ATA:Q484A4A6ATA4A4A
6ATA4A4A6ATA0Q4A4@03:Q484A4A4A4A008I6A454A4A00<I6A4A4A4Z4@P0
0Q4A4@8I6A428R8A00HA4A4I6A4Z4@PI6ATI8R8A4A426ATA00<R8Q40000I
6A400Q4A4@0500006ATA00008R8A4A4A008I6AT00a4A4BXA21TI6@036ATA
00@I6ATZ8QTA4A5UE39gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^3?<c<`00b8jG3YDQaTR<P054A4A00<0000A4A4A4A401Q4A4@036ATI4A4A
4A4A00<A4A401000014A4A4A4ATI6@8A4A401ATI4A4A4ATI6A4A4ATI4@05
4A4A00<0000A4A4A4A400Q4A4@056ATA4A4A4A4A4A4A6ATI008A4A401ATI
6A4A4ATI6A4A4ATI6@024A4A00<I6A4A4A4A4A400Q4A4@03:Q484A4A4A4A
008A4A4012XA21TI4A4A4ATI4@/A4A401@00014A4A4A4A4A4@00000E4A4A
00<0000A4A4A4A400Q4A4@036ATA4A4A6ATA00HA4A401QTI4A4A4A4A4A4A
4@0002XR6AHA4A400aTI4A4A4A4A4@0>4A4A00@Z4@PA4A4I6ATI6A474A4A
00<I6A4A4A4I6A401Q4A4@036ATA4A4A4A4A008A4A400bXA214A4ATI4@06
4A4A00<I6A4I6ATA4A400a4A4@038R8A4A4A6ATI008A4A400aTI6A4A4ATI
6@024A4A0QTI4@0=4A4A6ATI4A4A6ATI4A4A6ATA4A4A6ATA6ATI4A4A6ATI
4A4A6ATI008A4A4011TI6A4A4ATI4ATI4@8A4A401B8Z:Q4A4A4A4A4A4ATI
4@024A4A00<Z4@PA4A4I6A401Q4A4@0<6ATA4A4A4A4A4A4A00008R8A4A4A
6ATA4A4A6ATA4A4A00000a4A4@036ATA4A4A6ATA00@A4A400bXA214A4A4A
4@044A4A00<Z4@PA4A4Z4@P00Q4A4@0300006ATA4A4A00PA4A400aTI4B8R
4ATI6@034A4A00<Z4@PA4A4A4A400a4A4@0<6ATA4A4A6ATA6ATA6ATI0000
6ATA4A4A6ATI4A4A:Q486ATI0Q4A4@066ATA4A4A4A4A6ATI:Q486ATI11TI
4@044A4A6ATA4A4A6ATI0Q4A4@8I6AT0128R4ATI4A4A4FEL:WO<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c0046B8R4A4AMYO10000214A
4@056ATI4A4A6ATI4A4A6ATI00/A4A400aTI4A4A4A4A4@044A4A00<I6A4A
4A4A4A40114A4@8I6A40114A4ATI4ATI4ATI6@<A4A4021TI6A4A4A4A4ATI
6A4A4ATI6ATI4A4A4@8I6AT=4A4A00<R8Q4A4A4A4A400a4A4@036ATI4A4A
4A4A01HA4A401000014A4ATI4ATI6@TA4A400aTI4A4A4A4A4@024A4A00<I
6A4A4A4A4A400a4A4@036ATA4A4A4A4A00PA4A401BXA214A4ATI4@0002XA
20024A4A00<Z4@PA4A4I6A401A4A4@036ATA4A4A:Q4800@A4A400aTI4A4A
4BXA20044A4A00@I6A40000A4A4I6A474A4A00<I6A4A4A4A4A400a4A4@03
:Q486ATA4A4A008A4A400bXA214A4A4A4@024A4A00<I6A4A4A4A4A400Q4A
4@056ATA6ATI4A4A6ATA4A4A008I6A401Q4A4ATI4A4A4ATI6ATI4A4A4@<I
6A401Q4A4ATI4A4A4ATI6A4A4ATI6@LA4A4021TI6ATI4ATI6A4A4ATI6ATI
4A4A4ATI6@DA4A401BXA214A4A4A4A4A4ATI4@024A4A0QTI4@046ATI6ATA
6ATI:Q481Q4A4@046ATA4A4A4A4A6ATA0a4A4@03:Q486ATA8R8A00@A4A40
11TI4A4A4ATI4A4A4@8R8Q401@00014A4A4A4A4A4ATI4@034A4A00<Z4@PR
8Q4A4A400Q4A4@05:Q484A4A4A4A4A4A:Q48008A4A401BXA21TI4ATI4A4A
4BXA20024A4A01<I6A4Z4@PA4A4A4A4I6A4A4A4Z4@PA4A4I6A4I6ATI6A4I
6ATA4A4Z4@PA4A4I6A4R8Q4A4A4Z4@P00QTI6@09:Q486ATI8R8A6ATA4A4A
6ATA6ATI6ATA6ATI008I6A400aTI6A4A4ATI4@026ATA00@I6ATZ8QTA4A5U
G2Ygc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`01ATR:P00
0000014A4@0000024A4A00D0000A4A4A4A4A4A4I6AT01a4A4@0300004A4A
4A4A01HA4A4031TI4A4A4A4A4A4A4ATI4A4A4ATI4A4A4ATI4ATI6A4A4ATI
6@XA4A400aTI6A4A4A4A4@0;4A4A00<0000A4A4A4A401Q4A4@036ATA4A4A
4A4A00<A4A400`00014A4A4A4@034A4A00<I6A4A4A4A4A40114A4@030000
4A4A:Q4800DA4A401@00014A4A4A4A4A4@0000024A4A00<0000A4A4A4A40
1Q4A4@076ATA4A4A6ATA4A4A6ATA4A4A:Q4800/A4A400`00014A4A4A4@02
4A4A00<0000A4A4A4A40214A4@03:Q484A4A4A4A00DA4A401BXA214A4BXA
22XA21TI4@034A4A00@R8Q4Z4@PA4A4A4A426ATA00@A4A4I6ATZ4@PA4A42
6ATA0RXA20054A4A6ATA:Q484A4A:Q48008A4A400bXA214A4BXA20024A4A
00@I6A4A4A4I6A4A4A436ATA00DI6ATI6A4I6A4I6ATA4A400QTI4@0:4A4A
6ATA6ATI6ATA4A4A:Q484A4A6ATA8R8A6ATI114A4@056ATA4A4A4A4A:Q48
6ATA00@A4A400aTI4BXA214A4@046ATA00@A4A4I6A40000I6AT24A4A00HI
6A4A4A4I6A4R8Q4A4A4I6A424A4A00<I6A4A4A4A4A400Q4A4@0500006ATA
4A4A:Q484A4A008I6A424A4A00HI6A40000I6A4I6A4A4A4Z4@P54A4A00<0
000I6A4A4A400a4A4@03:Q484A4A:Q4800@A4A400`0001TI4A4A4@034A4A
00<I6A4A4A4Z4@P00a4A4@03:Q484A4A6ATA00<I6A402Q4A4ATI4ATI4ATI
6BXA21TI6ATI4ATR8QTI6A4A4@DI6A401a4A4ATI6ATI6ATI4ATI6ATI4ATI
6@036ATA00<I8R8A4A5UE380Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Pcc<c<00<I8S8I8RX000001a4A4@0300004A4A0000008A4A401000
014A4A4A4CXj<P<A4A400aTI4A4A4A4A4@0:4A4A00<0000A4A4A4A402A4A
4@036ATI4A4A4A4A018A4A400aTI4A4A4A4A4@024A4A00<I6A4A4A4A4A40
0Q4A4@036ATA4A4A4A4A00@A4A401RXA214A4A4A4@00014A4@0000lA4A40
0aTI4A4A4A4A4@044A4A00<I6A4A4A4A4A404A4A4@0500004A4A4A4A4A4A
6ATA00LA4A400bXA214A4A4A4@034A4A00<Z4@PA4A4A4A401a4A4@03:Q48
4A4A6ATA00@A4A42:Q480Q4A4@036ATA4A4A:Q4800PA4A400aTI4A4A4BXA
20054A4A0QTI4@8A4A4031TI4A4A4ATI4A4A4ATI4A4A4ATI4A4A4ATI4A4A
4ATI4BXA208A4A403bXA214A4ATI4A4A4ATI4ATI6A4A4ATI6@00028R4ATI
4ATI6A4A4ATI6A4A4@036ATA00dZ4@PA4A4I6A4A4A40000R8Q4Z4@PI6ATA
4A4R8Q4A4A4I6A4A4A400aTI4@034A4A:Q484A4A008A4A401B8R4ATI4ATI
4A4A4ATI4@034A4A00PI6A4Z4@PA4A4A4A4I6A4A4A4I6ATA4A436ATA00<A
4A4Z4@PI6A400QTI6@038R8A6ATA6ATA008A4A403`0001TI4A4A4ATI4B8R
4ATI4BXA214A4@0001TI6BXA214A4ATI4A4A4ATI4@024A4A00<Z4@PA4A4I
6A40214A4@046ATA:Q486ATA:Q480Q4A4@09:Q484A4A4A4A4A4A6ATA4A4A
6ATA6ATI6ATA008A4A402ATI4A4A4ATI4ATI6ATI4B8R4ATI4A4A4ATI4@03
8R8A00<A4A4I6A4A4A400QTI4@0;4A4A6ATA:Q486ATI:Q486ATI6ATA:R8I
6ATA4A4AID`I07O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<
c08I6AT00`00014A4@0000034A4A00@0000A4A4A4A4000064A4A00T0000A
4A4A4A4A4A40000A4A40000A4A4000000Q4A4@0300004A4A4A4A01@A4A40
0aTI6A4A4A4A4@0<4A4A00<0000A4A4A4A400a4A4@0500006B8R4A4A:Q48
000001PA4A401@00014A4A4A4A4A4@0000044A4A00@I6A4A4A4I6A400006
4A4A00<I6A4A4A4I6A401A4A4@03:Q484A4A4A4A00<A4A400aTI4A4A4A4A
4@064A4A00<I6A4A4A4000001A4A4@056ATA4A4A4A4A4A4A:Q4800@A4A40
2QTI4@00014A4BXA214A4ATI4A4A4ATI4A4A4ATI4@@A4A401aTI4A4A4BXA
21TI4A4A4BXA21TI4@064A4A00@Z4@PA4A4Z4@PI6A424A4A00DR8Q4I6A4A
4A4A4A4Z4@P00Q4A4@046ATA:Q486ATA6ATA0Q4A4@@I6A401aTI6BXA21TI
6BXA21TI6A4A4ATI4@044A4A0aTI4@<A4A4011TI4A4A4B8R4B8R4@8A4A40
1aTI4A4A4ATI4ATI4BXR6ATI4A4A4@026ATA00DZ4@PI6A4I6A4A4A4Z4@P0
0QTI4@034A4A:Q486ATA00<I6A401A4A4B8R4B8R4ATI4A4A4@026ATA00@I
6ATR8Q4I6ATR8Q424A4A00@I6ATI6A4I6A4I6A428R8A00DI6A4R8Q4R8Q4I
6ATR8Q400QTI4@068R8A4A4A:Q486ATA:Q484A4A0aTI4@036ATI6ATA:Q48
008R8Q4011TI4A4A4A4A4BXA20<A4A400bXA214A4A4A4@044A4A00@I6A4A
4A4I6A4A4A426ATA0Q4A4@8I6A400a4A4BXA21TI4@056ATA00<I6ATZ4@PI
6A400QTI4@076ATI6ATA6ATA8R8A6ATA4A4A8R8A008I6AT021TI4ATI6ATI
4A4A4ATI4BXR6A4A4E`j8WO<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h<lc<c0XA4A401P00014A4A4A4@00014A4@00008A4A400`00014A4@00
000B4A4A00<0000A4A4000004Q4A4@0400004A4A4A4A00001A4A4@030000
4A4A4A4A00DA4A400aTI6@00014A4@044A4A00<0000A4A4A4A404A4A4@04
00004A4A:Q480000114A4@0500004A4A4A4A4A4A0000008A4A40128R4A4A
4A4A4@0000DA4A400aTI4A4A4A4A4@064A4A00<0000A4A4A4A400a4A4@04
00004A4A4A4A:Q480a4A4@036ATI00006ATA00`A4A400aTI4A4A4ATI4@03
4A4A00XZ4@PA4A4A4A4Z4@PA4A4I6A4A4A4I6ATZ4@PI6A424A4A00@Z4@PA
4A4A4A4Z4@P24A4A00PI6A4A4A4A4A4Z4@PA4A4I6ATA4A4I6A424A4A00PZ
4@PA4A4A4A4I6A4I6ATI6A4A4A4I6A426ATI00`A4A4I6ATA4A4I6ATI6A4A
4A4I8R8I6A4I6ATZ4@PI6A4I6AT24A4A00@I6A4A4A4A4A4Z4@P24A4A00<I
6A40000I6A4011TI4@046ATI6ATA6ATI6ATA0Q4A4@038R8A6ATA6ATA00@I
6A401ATI6BXA21TI6ATI6ATI4@026ATI00@Z4@PA4A4A4A4I6AT26ATA00DI
6ATI6A4I6A4I6ATR8Q400aTI4@036ATI6ATA6ATA008I6A401ATI6ATI4B8R
4B8R4ATI4@048R8A00HI6A4R8Q4I6ATI6A4Z4@PR8Q426ATA00HR8Q4I6ATZ
8QTI6ATA4A4Z4@P48R8A00HI6A4A4A4I6A4R8Q4I6A4Z8QT24A4A00<I6A4A
4A4Z4@P00a4A4@8I6A428R8A00<I6A4R8Q4I6A400R8R4@8I6A400b8R4ATI
4ATI6@066ATA00@A4A4I6A4I6A4R8Q446ATA00HI6ATA4A4I6A4I6ATI6A5U
E39gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`24A4A00<0
000A4A4A4A400a4A4@0500004A4A4A4A4A4A000000@A4A400`00014A4A4A
4@024A4A00<0000A4A4A4A40114A4@0700004A4A00004A4A00004A4A0000
008A4A400`00014A4A4A4@0;4A4A00<0000I6ATA4A402Q4A4@0300004A4A
4A4A00<A4A400`00014A4@0000034A4A00D0000A4A4A4A4A4A400000114A
4@0300004A4A000000<A4A400`00014A4A4A4@0=4A4A00<Z4@PA4A4A4A40
2A4A4@036ATA4A4A4A4A00TA4A400aTI4A4A4A4A4@084A4A00<Z4@PA4A4I
6A400a4A4@076ATA4A4A4A4A4A4A6ATA4A4A:Q48008A4A4012XA214A4A4A
4BXA208A4A4011TI6A4A4A4A4A4A4@8I6A434A4A00<I6A4A4A4A4A40114A
4@8I6A40114A4ATI4ATI4A4A4@8I6A401a4A4BXA214A4BXA214A4ATI4BXA
20036ATA00lZ4@PR8Q4A4A4I6ATI6A4R8Q4I6A4Z8QTI6A4I6ATR8Q4Z4@PI
6A4R8Q4I6AT00QTI4@084A4A6ATA6ATI8R8A4A4A6ATA4A4A6ATA0QTI6@07
:Q484A4A6ATA8R8A4A4A6ATI6ATA00<A4A426ATA114A4@06:Q486ATA6ATA
6ATA8R8A6ATI0QTI4@8I6AT76ATA00<A4A4I6A4I6A400QTI4@036ATI8R8A
6ATA008I6A402B8R4ATI4B8R4B8R4ATI4BXA21TI4ATI6B8R4@026ATI00DZ
4@PI6ATI6ATR8Q4I6A400R8R4@034A4A6ATI6ATA008I6AT0128R4ATI6B8R
4ATI6@@R8Q400aTR8R8R4ATI6@048R8A00DI6ATR:RXR8Q4I6A4R8Q400QTI
6@086ATA8R8A6ATI:R8I8R8A6ATI8R8A6ATI0R8R4@0;4A4A8R8A6ATI4A4A
8R8A6ATI8R8A6ATA6ATI6ATA6ATI008I6A403QTI6B8R4BXR6ATI6ATI4ATI
6ATI4BXR6ATI6BXA21TI6BXR6A4A4D@j:WO<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h<lc<c0DA4A400`00014A4@0000024A4A00<0000A4A4A
4A400Q4A4@0300004A4A4A4A008A4A400`00014A4A4A4@024A4A00<0000A
4A4A4A40514A4@03:Q484A4A4A4A00`A4A400`00014A4A4A4@044A4A00<0
000A4A4A4A401a4A4@0300004A4A000000XA4A400`00014A4A4A4@044A4A
00P0000A4A4A4A40000A4A40000A4A4000024A4A00<0000A4A4A4A404a4A
4@0300004A4A4A4A00@A4A400`0002XA214A4@024A4A00<0000A4A4A4A40
114A4@036ATA4A4A4A4A00@A4A400aTI4A4A4ATI4@024A4A00<Z4@PA4A4A
4A400QTI4@8A4A401BXA21TI4ATI4ATI4A4A4@026ATA00<Z4@PA4A4A4A40
11TI4@8A4A426ATA00<R8Q4A4A4I6A400R8R4@<I6A438R8A00TI6A4I6ATR
8Q4I6A4I6ATR8Q4A4A4I6ATZ4@P00QTI6@08:R8I8R8A8R8A6ATI6ATA6B8R
4A4A6ATA0QTI6@036ATA6ATI4A4A00DI6A402B8R4ATI4ATI4B8R4ATI6BXA
21TI4A4A4BXR6@046ATA00<I6ATR8Q4Z4@P00QTI4@048R8A6ATA6ATI6ATA
0R8R4@056ATA6ATI6ATA6ATI8R8A00<I6A400aTI6ATI4ATI6@026ATA0R8R
4@046ATI6ATA8R8A8R8A0QTI6@096ATA4A4A:R8I4A4A6ATI8R8A6ATI8R8A
6ATA00@R8Q400aTI6BXA21TI4@028R8A00LI6A4I6ATR8Q4R8Q4I6ATR8Q4I
6A40128R4@8I6AT02b8R4BXR6ATI4ATR8RXA21TR8RXR6B8R4ATI6B8R4BXR
6@028R8A00lZ8QTI6ATZ4@PZ8QTR8Q4I6ATZ8QTR8Q4I6ATZ4@PR8Q4I6ATI
6A4I6ATR8Q400QTI6@03:Q486ATI8R8A008I6AT02aTI4B8R4ATI4ATI6B8R
4ATI4ATI6BXR6ATI6ATR8VEL:P1gc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^3?<c<`01QTI6A4A4A4A4@00014A4@0000<A4A400`00014A4A4A
4@0B4A4A00@0000A4A4A4A4000024A4A00@0000A4A4A4A40000=4A4A00<I
6ATA4A4A4A402a4A4@0300004A4A4A4A008A4A400`00014A4@0000024A4A
00<0000A4A4A4A401Q4A4@0500004A4A4A4A4A4A000001LA4A401000014A
4A4A4@00008A4A400`00014A4A4A4@064A4A00<0000A4A4A4A400a4A4@03
6ATA4A4A4A4A00`A4A4011TI4@00014A4@0000@A4A400`00014A4@000003
4A4A0QTI4@HA4A400`00014A4A4A4@044A4A00<Z4@PA4A4A4A400QTI4@04
4A4A6ATA8R8A6ATI0b8R4@034A4A6ATA6ATA008I6A401aTI6ATI4ATI4B8R
4ATR8QTI4ATI6@026ATA00<Z8QTI6A4I6AT00aTI4@038R8A6B8R6ATA008I
6A436ATI00@I6A4A4A4I6ATR8Q426ATA00<Z8QTI6A4I6AT00R8R4@074A4A
6ATI6ATA4A4A6ATI8R8A6ATI008I6A438R8A00DA4A4R8Q4I6A4I6ATI6A40
0QTI6@096ATA6ATI6ATI6ATI8R8A6ATA6ATI6ATA4A4A008I6A402ATI6ATI
4ATI4B8R4A4A4ATI4B8R4ATI4A4A4@026ATI00DA4A4Z4@PI6ATZ4@PI6AT0
0R8R4@086ATI8R8A6ATA6ATA6ATI4A4A6ATA8R8A0QTI6@058R8A6ATI4A4A
8R8A6ATI008R8Q403aTI6ATI4B8R4ATI6A4A4B8R4ATI6ATI4B8R4ATI6BXA
22XR6ATI6ATI4BXA20026ATI00@Z4@PI6ATR8Q4I8R826ATI00@R:RXZ8QTI
6ATZ8QT28R8A00<I8R8Z8QTb:R800RXR6@086ATI8RXZ:R8I6ATI8R8A6ATI
:R8I6ATI0R8R4@036ATI6B8R6ATI00DI6AT00bXR6A4A4E`j8P1gc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`00a4A4ATI6A4A4@044A4A
00<0000A4A4A4A401A4A4@0300004A4A4A4A00TA4A400`00014A4A4A4@03
4A4A00<0000A4A4A4A401A4A4@0300004A4A4A4A00<A4A426ATI0Q4A4@<I
6ATA4A4A00<0000A4A4A4A400Q4A4@0300004A4A4A4A00@A4A400`00014A
4A4A4@054A4A00<0000A4A4A4A400a4A4@0800004A4A4A4A00004A4A0000
4A4A00000Q4A4@0300004A4A000000dA4A401@00014A4@00014A4@000005
4A4A00P0000A4A40000A4A40000A4A4I6A40000G4A4A00<0000A4A4A4A40
0Q4A4@036ATA00004A4A00TA4A401ATI4A4A4A4A4ATI4@0000044A4A00<0
000Z4@PA4A400Q4A4@03:Q484A4A4A4A00DA4A404aTI6ATI4ATI6A4A4ATI
4ATI6A4A4ATI6ATI4ATI6ATR8QTI4ATI6BXA21TI6ATI4A4A4BXR6A4A4@02
6ATA00<I6ATA4A4I6A400QTI4@094A4A6ATA8R8A4A4A8R8A<RXR8R8A4A4A
8R8A008I6A424A4A00@I6A4R8Q4I6ATA4A426ATA00DA4A4I6A4I6A4I6A4Z
4@P00QTI6@04:Q486ATI4A4A4A4A0QTI4@034A4A6ATA6ATA00<A4A4031TI
6ATI4ATI4A4A4B8R4ATI4B8R4ATI6B8R4A4A4ATI4ATI6@8I6A426ATI00<Z
4@PI6ATR8Q400aTI4@046ATI8R8A:Q488R8A0QTI6@058R8A6ATA6ATA:Q48
6ATI008R8Q400aTI4A4A4BXR6@024A4A00PI6A4R8Q4R8Q4A4A4R8Q4I6ATZ
4@PI6A438R8A018I6ATZ8QTZ8QTR:RXZ4@PI8R8Z8QTR8Q4I6ATZ8QTI6ATZ
4@PR:RXR8Q4R:RXI6ATZ8QTR8Q42:R8I00@I6ATZ8QTI6ATI8R84:R8I00@I
8R8Z8QTA4A5UG2Ygc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<
c<`01QTR8Q4A4ATR8QTR:Q4A4ATR8PlA4A400`0001TI4@0000044A4A00<0
000A4A4A4A40114A4@8000000a4A4@00014A4@024A4A00<I6A4I6ATA4A40
5a4A4@036ATI4A4A4A4A00@A4A400aTR8Q4A4A4A4@034A4A00<0000A4A4A
4A400Q4A4@0300004A4A4A4A00@A4A401000014A4@000000008A4A401P00
014A4A4A4@00014A4@0000`A4A401P00014A4A4A4@00014A4@0000hA4A40
0`00014A4A4A4@024A4A00@0000A4A4A4A4I6A424A4A00<0000A4A400000
0a4A4@0300004A4A4A4A00@A4A400aTI4A4A4A4A4@024A4A00<I6A4A4A4A
4A40114A4@036ATA4A4A4A4A008A4A400bXA214A4A4A4@034A4A00<I6A4A
4A4A4A402A4A4@06:Q484A4A4A4A4A4A6ATI:Q48114A4@036ATA4A4A4A4A
008A4A400aTI4A4A4A4A4@024A4A00<I6ATA4A4A4A401Q4A4@8I6A434A4A
0aTI4@04:R8I6ATI4A4A:R8I0R8R4@0>:Q484A4A4A4A:R8I6ATA6ATI8R8A
6ATA6ATI:Q486ATI:Q486ATA4A4A0QTI4@078R8A6ATA8R8A6ATA8R8A6ATI
6ATA008R8Q401QTI4BXA22XA214A4B8R4ATI4@8R8Q4011TI4B8R4ATI4ATI
4@8R8Q402aTI4ATI6BXA21TI6ATI4BXR6ATI6@00028R4BXA21TI4@028R8A
00PI6AT0000Z8QTI6ATR8Q4I6A4Z4@PI6AT26ATA00DI6ATR8Q4R8Q4I6A4I
6AT00RXA20068R8A6ATA8R8A6ATA8R8A6ATI0R8R4@036ATA8R8A:Q48008R
8Q403bXA21TI6ATI6BXA21TI6B8R4ATI4B8R4ATR8R8R4ATI6BXR6ATI6B8R
4ATR8P026ATI0R8R4@@Z8QT01QTR8QTI6BXR6ATR8RXR6Da48WO<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c0046B8Z6B8R6ATI6B8R0aTI
6@dA4A400`00014A4A4A4@024A4A00@0000A4A4A4A4000024A4A00@0000A
4A40000000064A4A00<0000A4A4A4A40214A4@8I6AT64A4A00<0000A4A4I
6AT00a4A4@036ATI4A4A4A4A00<A4A400`00014A4A4A4@024A4A00<0000A
4A4A4A401a4A4@8000000a4A4@00014A4@024A4A00<0000A4A4A4A403A4A
4@0300004A4A0000008A4A400`00014A4A4A4@0:4A4A00<0000A4A400000
3A4A4@0300004A4A4A4A00DA4A400`00014A4BXA20044A4A00<0000A4A4A
4A40114A4@0300006ATA4A4A010A4A400aTI4A4A4A4A4@054A4A00TZ4@PA
4A4A4A4A4A4I6A4A4A4I6A4A4A4I8R800a4A4@036ATI4A4A4A4A01DA4A40
0`00014A4A4A4@024A4A00@0000A4A4A4A4000034A4A00LI6ATA4A4A4A4I
6ATA4A4I6ATI6A400Q4A4@046ATA4A4A4A4A:Q48114A4@@I6A40128R4ATI
4ATI4A4A4@@I6A400b8R4ATI6BXA20026ATI00DZ4@PI6ATI6A4R8Q4I6A40
0QTI6@03:Q486ATA6ATA008R8Q401ATI4ATI6ATI4@0001TI6@026ATA0R8R
4@046ATA8R8A6ATA8R8A0QTI4@036ATI6ATA6ATA008R8Q4031TI4ATI6B8R
4ATI6BXA21TI6B8R4A4A4ATI6B8R4BXR6ATR8P8Z8QT03QTI4B8R4B8R4B8R
4ATI4B8R4ATI4B8R4ATI6B8R4ATI6BXA228R4BXR6@8R8Q426ATI00HZ8QTR
8Q4I6ATI6ATZ8QTI8R82:R8I0QTR8P03G3XRc<c<c<c<07G<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h<lc<c0036B8Z6B8R6B8b008R<T@00b8Z
:QTR8Q4A4@0?4A4A00@0000A4A4A4A40000?4A4A00<I8R8A4A4I6AT0514A
4@0300004A4A000000TA4A401ATI6@00014A4A4A4@0000064A4A00<I6ATA
4A4A4A402a4A4@0300004A4A4A4A00TA4A400`00014A4A4A4@034A4A00H0
000A4A4A4A40000A4A4000044A4A00DI6ATA4A4A4A4A4A4000001A4A4@03
00004A4A4A4A01TA4A400aTI4A4A4A4A4@0B4A4A00<I6AT0000A4A401A4A
4@066ATA6ATI4A4A6ATI4A4A6ATI0a4A4@066ATA4A4A4A4A6ATI4A4A6ATI
114A4@066ATI4A4A4A4A6ATI4A4A6ATA1A4A4@0300004A4A4A4A00LA4A40
0bXA214A4@00000;4A4A00<Z4@PA4A4A4A400a4A4@036ATA4A4A4A4A00@A
4A400aTI4A4A4ATI6@034A4A01TI6ATA4A4A4A4A4A4I6A4I6ATI6A4I6ATA
4A4I6ATI6A4R8Q4I6A4I6ATA4A4R8Q4I6ATA4A4Z4@PI6A4R8Q4I6ATR8Q4I
6A4I6AT00QTI4@044A4A8R8A6ATA8R8A0QTI4@8R8Q426ATA00@Z8QTI6ATA
4A4R8Q426ATI00<R8Q4I6ATR8Q400QTI6@8R8Q4011TI6B8R4B8R4ATI6@8R
8Q404QTI6B8R4ATI6B8R4ATI6B8R4ATR8QTI6BXR6ATI6ATR8RXR6ATI6B8Z
:QTI6BXR6B8R4B8Z:P8Z8QT0128Z:RXR6ATI6FEL:WO<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h<lc<c0048S946B8b8SXb8TaD0S94MP03>UB7
8T@j0000008A4A400`00014A4A4A4@0;4A4A00<0000A4A4A4A400Q4A4@03
00004A4A4A4A00DA4A401@00014A4A4A4A4A4@00000;4A4A00H0000A4A4A
4A4A4A4I6A4000034A4A00<0000A4A4A4A400Q4A4@0400004A4A4A4A0000
1A4A4@0300004A4A4A4A00<A4A402P00014A4A4A4@0001TI4A4A4ATI4A4A
4ATI6@0000`A4A400`00014A4@0000024A4A00<I6A4A4A4A4A40114A4@03
00006ATA4A4A00<A4A400aTI4A4A4A4A4@0:4A4A00<I6A4A4A4A4A401Q4A
4@076ATA4A4A4A4A6ATA4A4A8R8A000000@A4A401@00014A4A4A4A4A4ATI
4@024A4A00<Z4@PA4A4I6A400Q4A4@8I6A401Q4A4ATI4A4A4@00014A4BXA
208A4A400bXA214A4ATI4@054A4A00HZ4@PA4A4A4A4Z4@PA4A4Z4@P24A4A
00@Z4@PA4A4I6A4I6AT54A4A00@R8Q4A4A4I6ATA4A426ATI00DA4A4I6ATA
4A4A4A4I6AT01Q4A4@036ATA4A4A6ATA00@A4A402ATI4A4A4A4A4@00014A
4ATI4@0002XA21TI4@064A4A00<I6A4A4A4I6A400a4A4@036ATA4A4A4A4A
008A4A400aTI4A4A4ATI4@054A4A00<Z4@PA4A4A4A401Q4A4@036ATA4A4A
6ATA00DA4A400bXA214A4A4A4@024A4A00<Z4@PA4A4A4A40114A4@066ATA
8R8A6ATI4A4A8R8A6ATI128R4@0>6ATI:Q486ATI8R8A6ATI:R8I6ATA:R8I
:Q488R8A:Q488R8A6B8R:R8I0R8R4@04:R8I6ATI:R8I6ATI0RXR6@056ATI
8R8A:R8I6ATI:Q48008R8Q401BXR6BXA21TI6B8R4ATR8P02:R8I00HR8Q4I
8R8Z8QTR8Q4I8R8R8Q42:R8I00HR8Q4I8R8Z8QTZ8QTI6AU<A29gc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`02ATR<P00014A4@0005A]
MTa]QcYLMR8j<QTI6@054A4A00<I6ATA4A4A4A400a4A4@036ATI4A4A4A4A
00@A4A400`00014A4A4A4@064A4A00<0000A4A4A4A400a4A4@036ATI4A4A
4A4A010A4A400aTI4A4A4A4A4@0F4A4A00<I6A4A4A4000000Q4A4@050000
4A4A4A4A4A4A6ATI00lA4A400`0001TI4A4A4@0:4A4A00<0000A4A4A4A40
1A4A4@036ATI:Q484A4A00DA4A400aTI4A4A4ATI4@074A4A00<0000A4A4A
4A401Q4A4@036ATA4A4A4A4A00LA4A400`0001TI4A4A4@044A4A00<I6A4A
4A4A4A400Q4A4@076ATI6ATA6ATA6ATA8R8A4A4A6ATA008A4A400aTI6A4A
4ATI4@024A4A00DI6A4A4A4R8Q4A4A4I6A401ATI6@046ATA6ATI4A4A6ATA
0Q4A4@036ATI4A4A6ATA008A4A402QTI4BXA21TI4ATI6A4A4ATI6A4A4ATI
4A4A4ATI4@@A4A4011TI4A4A4ATI4ATI4@<A4A4011TI4A4A4A4A4BXA20DA
4A401QTI4ATI6A4A4A4A4ATI4ATI6@DA4A400aTI4BXA214A4@024A4A00DR
8Q4A4A4A4A4A4A4I6A400Q4A4@056ATA4A4A4A4A4A4A6ATA008A4A436ATA
00LA4A4Z4@PA4A4I6A4A4A4I6A4I6AT00RXA20064A4A:Q484A4A6ATA8R8A
:Q480Q4A4@086ATA4A4A6ATA6ATI6ATA6ATI6ATA4A4A0QTI4@03:Q486ATA
6ATI008I6AT01ATI4B8R4ATR8RXA21TI6@068R8A00<Z8QTR8Q4I6AT00QTI
6@068R8A6ATI8R8A:R8I6ATI:R8I0R8R4@0<6B8R:R8I:R8I:R8I6B8R8R8A
:R8I6B8R:R8I6B8R8R8A:R8I0QTR8P03G3XRc<c<c<c<07G<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h<lc<c0086B8R6B8Z4A4A6ATI4A4A8TaD
8S9400000Q4A4@0300004A4A4A4A00HA4A401ATI6A4A4@00014A4@00000A
4A4A00D0000A4A4A4A4A4A400000414A4@0300004A4A4A4A00DA4A400`00
014A4A4A4@0@4A4A00<0000A4A4A4A400a4A4@0700004A4A00004A4A0000
4A4A000000`A4A401@00014A4A4A4A4A4@0000024A4A00<0000A4A4A4A40
114A4@0300004A4A000000DA4A401@00014A4@0001TI6@0000024A4A00<I
6A40000A4A40114A4@056ATI4A4A4A4A4A4A000000LA4A400bXA214A4A4A
4@0;4A4A00<0000I6A4A4A40114A4@0300006ATI4A4A00<A4A4011TI4A4A
4ATI4A4A4@8I6A401RXA214A4ATR8Q4A4ATI6BXA20<A4A4021TI4A4A4ATI
4ATI6A4A4ATI4A4A4ATI6@<A4A400aTI4A4A4ATI4@044A4A00DI6A4A4A4I
6A4A4A4I6AT00a4A4@0300006ATA0000008A4A4011TI4A4A4A4A4ATI4@PA
4A400`0001TI4A4A4@034A4A00<I6A4A4A4Z4@P0114A4@056ATI4A4A4A4A
4A4A:Q48008A4A400bXA2000014A4@034A4A00LI6A4Z4@PA4A4I6ATI6A4A
4A4I6A400Q4A4@046ATI6ATA4A4A6ATI0Q4A4@8I6A401QTI6ATI4ATI6A4A
4ATI4BXA208A4A401aTI4B8R4A4A4ATI6B8R4ATI6ATI4@044A4A00LZ4@PA
4A4I6A4A4A4I6A4I6ATI6A40214A4@0>6ATA8R8A6ATI8R8A6ATA6ATI8R8A
6ATI8R8A6B8R<RXR4A4A:R8I6B8R0bXR6@046B8R:R8I:R8I8R8A0RXR6@03
8RXZ:R8IG3XR07O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<
c0046B8R6B8Z4A4A4A4A0`0000054A4A00004A4A4A4A000000DA4A400`00
014A4@00000:4A4A00<0000A4A4A4A401A4A4@0300004A4A4A4A01HA4A40
1000014A4A4A4@0000HA4A401@00014A4A4A4A4A4@0000084A4A00<0000A
4A4A4A400a4A4@038RXZ00004A4A00PA4A400`00014A4ATI4@094A4A00D0
000A4A4A4A4A4A4000000Q4A4@0500004A4A4A4A4A4A000000LA4A400`00
014A4A4A4@0:4A4A00<I6ATA4A4I6A402A4A4@0300004A4A4A4A00@A4A40
0bXA214A4ATI4@024A4A00@Z4@PA4A4A4A4Z4@P24A4A00<I6A4A4A4A4A40
214A4@0:6ATA4A4A6ATA4A4A6ATA00004A4A6ATA4A4A:R8I0QTI4@056B8R
6ATA6ATA4A4A6ATI008I6A474A4A00<I6A4A4A4A4A40114A4@056ATI4A4A
4A4A4A4A6ATI00<A4A400bXA214A4A4A4@064A4A00<I6A4A4A4A4A400Q4A
4@03:Q484A4A6ATA00<A4A400aTI4A4A4A4A4@0=4A4A00@I6ATA4A4A4A4Z
4@P24A4A00@Z4@PA4A4I6A4I6A434A4A00@I6A4A4A4A4A4Z4@P24A4A0QTI
4@044A4A:Q486ATA4A4A0QTI4@09<RXR6ATA6ATA4A4A:Q486ATA6ATI6B8R
4A4A00DI6A4012XA228R4ATI4A4A4@<I6A400a4A4B8R4A4A4@044A4A0RXA
20034A4A6ATA6ATA008A4A403ATI4A4A4ATI4ATI6ATI4B8R4A4A4BXA21TI
6BXA21TI4ATI6ATI4@026ATI0RXR6@066B8R:R8I8R8A6B8R6ATI>T@IMlc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00<A4A4I6ATb>T@0
514A4@0300004A4A4A4A008A4A400`00014A4A4A4@0B4A4A00<0000A4A4A
4A400Q4A4@0300004A4A4A4A008A4A401@00014A4A4A4A4A4@0000044A4A
00<0000A4A4A4A400a4A4@0300004A4A4A4A00lA4A400aTI4A4A4@000009
4A4A00<0000A4A4I6A401A4A4@0300004A4A4A4A00TA4A400`00014A4A4A
4@0<4A4A0QTI4@086ATI4A4A4A4A6ATA4A4A6ATA4A4A6ATA0Q4A4@030000
:Q484A4A00TA4A400aTI4A4A4A4A4@044A4A00<I6A4A4A4A4A400Q4A4@03
6ATA4A4A4A4A00<A4A400bXA214A4A4A4@034A4A00@I6A4A4A4A4A4I6AT4
4A4A00DI6A4I6ATI6A4A4A4I6AT00QTI4@034A4A6ATI4A4A008A4A400aTI
6A4A4A4A4@026ATI114A4@096ATI4A4A4A4A4A4A6ATI4A4A6ATA6ATI6ATA
008A4A426ATA114A4@04:Q484A4A4A4A:Q480a4A4@086ATI4A4A4A4A6ATA
4A4A6ATA4A4A6ATI114A4@056ATA4A4A6ATI4A4A:Q4800<A4A4011TI6A4A
4A4A4ATI4@8A4A400aTI4A4A4A4A4@024A4A00PI6A4A4A4A4A4A4A4Z4@PA
4A4I6A4A4A426ATA00PI6ATA4A4A4A4I6A4A4A4I6ATI6A4R8Q426ATA00DR
8Q4I6ATb:R8Z4@PI6AT00aTI4@098R8A4A4A6ATI6ATA:R8I8R8A6ATI:Q48
4A4A00<I6A400a4A4ATI4ATI4@034A4A0RXA20<A4A401ATI4A4A4A4A4BXA
214A4@046ATA00PR8Q4I6ATI6A4I6ATI6A4R8Q4I8R8R8Q426ATI00TZ8QTI
6ATI6A4R8Q4I6ATI8R8Z8QTI6AUL>R80Mlc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Pcc<c<00@I8R8I6AT0000I6AT44A4A00<I6ATA4A400000
0Q4A4@0500004A4A4A4A6ATA000000<A4A401@00014A4A4A4A4A4@000004
4A4A00<0000A4A4A4A400a4A4@0400004A4A4A4A00000Q4A4@0300004A4A
4A4A00@A4A400`00014A4A4A4@024A4A00<0000A4A4000002A4A4@030000
4A4A4A4A008A4A400`00014A4BXA20024A4A00@0000A4A40000I6AT<4A4A
00<0000A4A4A4A400Q4A4@0400004A4A4A4A00000Q4A4@0500004A4A4A4A
4A4A000000<A4A400`00014A4A4A4@074A4A00<0000A4A4A4A400Q4A4@03
00004A4A0000008A4A400aTI6A4A4A4A4@024A4A00<Z4@PA4A4A4A401Q4A
4@036ATI4A4A4A4A008A4A400aTI4A4A4A4A4@034A4A00<Z4@PA4A4A4A40
2A4A4@03:Q484A4A4A4A00/A4A401ATI4A4A4BXA214A4ATI6@036ATA0a4A
4@05:Q486ATA4A4A4A4A6ATA008A4A4011TI4ATI6ATI4ATI4@8I6AT00a4A
4ATI4ATI4@044A4A00<I6ATA4A4I6AT00Q4A4@8I6AT26ATA114A4@046ATA
4A4A4A4A6ATA2a4A4@03:R8I4A4A4A4A008A4A400aTI4A4A4BXA20054A4A
00PI6A4A4A4I6ATA4A4I6A4A4A4I6ATZ4@P24A4A00LI6A4A4A4A4A4A4A4Z
4@PA4A4Z4@P00Q4A4@06:Q484A4A4A4A4A4A8R8A6ATA0a4A4@03:Q484A4A
4A4A008I6A401a4A4ATI6ATI4ATI4A4A4B8R4A4A4@026ATA00PR8Q4A4A4R
8Q4I6A4A4A4I6A4R8Q4I6A424A4A00<I6A4Z4@PA4A400Q4A4@046ATA4A4A
4A4A6ATA0a4A4@056ATA4A4A4A4A4A4A6ATA008A4A426ATA00DA4A4I6ATI
6A4R8Q4I6AT00b8R4@8I6AT03BXR6ATI6B8R4ATI6BXR6ATI4BXR6ATR8R8R
4ATI6BXR6ATR8Ta48P1gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^3?<c<`24A4A00<0000I6ATA4A401a4A4@0500004A4A4A4A4A4A000000XA
4A400`00014A4A4A4@054A4A00@0000A4A4A4A4000054A4A00<0000A4A40
0000214A4@036ATI4A4A4A4A00@A4A400`00014A4A4A4@044A4A00<0000A
4A4A4A401A4A4@0500004A4A4A4A4A4A000000<A4A401@00014A4A4A4A4A
4@0000044A4A00<0000A4A4A4A401A4A4@0300004A4A4A4A00TA4A400`00
014A4A4A4@024A4A00<0000A4A4A4A401a4A4@036ATA4A4A4A4A00PA4A40
1ATI4A4A4ATI4ATI4ATI6@024A4A00<I6A4A4A4A4A402A4A4@03:Q484A4A
4A4A008A4A400aTI6A4A4ATI4@024A4A00<I6A4A4A4R8Q401Q4A4@03:Q48
4A4A4A4A00@A4A401QTI4A4A4ATI4A4A4ATI4A4A4@8I6A4011TI6ATI4ATI
4ATI4@<I6AT00b8R4ATI4ATI6@024A4A0QTI6@044A4A6ATA:Q486ATI0Q4A
4@046ATI4A4A4A4A6ATA0Q4A4@076ATA4A4A4A4A6ATA4A4A6ATA6ATI008A
4A4011TI4A4A4A4A4BXA20DA4A401QTI4BXA214A4ATI4ATI6ATI4@8Z4@P0
1ATI6A4A4A4A4A4A4B8R4@064A4A00DI6ATZ4@PA4A4A4A4I6A400Q4A4@05
6ATI6ATA6ATI6ATA8R8A008I6AT01R8R4ATI4ATI4ATI6BXA214A4@<I6A40
1R8R4A4A4B8R4ATI4A4A4BXA208I6A400aTI6BXA21TI4@026ATA00<I6ATR
8Q4R8Q400QTI6@048R8A6ATA4A4A:Q480a4A4@066ATA4A4A6ATA4A4A:Q48
6ATI114A4@04:Q484A4A4A4A:Q480Q4A4@05:Q486ATA6ATI:R8I8R8A00DI
6A402QTI6B8R4B8R4ATI6ATI4B8R4ATI4ATI6ATR8R8R4@<I6AT01bXR6ATI
6B8R4ATR8QTI6ATR8T@j8P1gc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^3?<c<`24A4A00<I6ATA4A4A4A400Q4A4@0400004A4A4A4A0000214A
4@056B8R00004A4A4A4A000001<A4A400`00014A4A4A4@0H4A4A00@0000A
4A4A4A40000D4A4A00<I6AT0000A4A401a4A4@0400004A4A4A4A00000Q4A
4@0300004A4A4A4A00<A4A400`00014A4A4A4@044A4A00<I6AT0000A4A40
1a4A4@0300004A4A4A4A008A4A400aTI4A4A4A4A4@054A4A00<I6ATA4A4A
4A40114A4@036ATA4A4A4A4A00HA4A400bXA21TI4A4A4@026ATA0Q4A4@05
6ATA4A4A4A4A4A4A:Q48008A4A401QTI4A4A4A4A4ATI6A4A4ATI4@8A4A40
1ATI4ATI6A4A4ATI4A4A4@026ATA00DZ4@PR:RXA4A4I6ATA4A400QTI6@03
:Q486ATA6ATA008I6A401ATI6A4A4A4A4A4A4ATI4@024A4A00@I6ATA4A4I
6A4I6A444A4A00@I6A4A4A4A4A4I6AT26ATA00<A4A4I6A4I6A40114A4@04
6ATA4A4A4A4A:Q480a4A4@03:Q484A4A4A4A00LA4A401ATI4A4A4A4A4A4A
4BXA20036ATA00LA4A4I6A4Z4@PA4A4R8Q4I6A4I6AT00QTI4@0;4A4A6ATA
6ATA6ATA4A4A6ATA4A4A8R8A4A4A6ATI6ATA008R8Q4011TI4B8R4B8R4ATI
6@8I6A426ATI014I6A4Z8QTI6ATR8Q4I6ATI6A4R8Q4I6A4I6ATR8Q4I6A4R
8Q4A4A4Z4@PA4A4Z4@PI6A400a4A4@8I6A400a4A4BXA214A4@044A4A00LZ
4@PI6A4I6A4A4A4Z4@PI6A4I6AT00QTI4@036ATI8R8A6ATI008I6A428R8A
00LI6ATR8Q4R8Q4R8Q4I8R8I6ATZ4@P00QTI6@058R8A6B8R8R8A6ATI6B8R
008Z8QT00aTR8RXR6D@j8P1gc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^3?<c<`?4A4A00D0000A4A4A4A4A4A400000114A4@056ATI00004A4A
4A4A000000HA4A401000014A4A4A4@00008A4A400`00014A4A4A4@034A4A
00<0000A4A4A4A401a4A4@0300004A4A4A4A008A4A401P00014A4A4A4@00
014A4@0000PA4A400`0001TI6A4A4@044A4A00<0000A4A4A4A401Q4A4@08
00004A4A00004A4A00006B8Z4A4A00004Q4A4@0300004A4A4A4A008A4A40
0`00014A4A4A4@024A4A00<0000A4A4A4A401A4A4@046ATI4A4A4A4A6ATA
2A4A4@066ATI4A4A4A4A00004A4A0000314A4@096ATA4A4A00004A4A:Q48
4A4A6ATA4A4A6ATI00DA4A401B8R4A4A4A4A4A4A4ATI6@044A4A00DI6A4A
4A4I6A4A4A4I6AT00a4A4@036ATI4A4A6ATI008I6AT26ATA00@I6ATA4A4I
6A4I6A424A4A00<I6AT0000A4A400a4A4@8I6A4A4A4A00<I6A4A4A4A4A40
1A4A4@036ATA4A4A6ATA008A4A426ATA00HA4A4I6A4I6A4A4A4I6ATI6A42
4A4A00<I6A4A4A4I6AT00QTI4@084A4A6ATA4A4A6ATA4A4A:Q488R8A6ATI
0QTI4@0:4A4A8R8A6ATI6ATA6ATI8R8A00006ATI6ATA8R8A0QTI4@066ATI
8R8A6ATI8R8A6ATA6ATI0QTI4@046ATI6ATA6ATA4A4A0QTI4@@A4A401BXA
214A4A4A4A4A4BXA20026ATA00@Z4@PI6A4I6A4Z4@P54A4A00HI6A4A4A4I
6A4I6A4R8Q4I6AT46ATA00/I6ATZ4@PI6ATR8Q4I6ATZ4@PI8R8I6ATR8Q4I
8R8I6AT00RXR6@076B8R:R8I:R8I6B8R:R8I6ATI>T@I07O<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h<lc<c0DA4A402@00014A4A4A4A4A4@00
014A4@00014A4@00000:4A4A00<0000A4A4A4A400Q4A4@0500004A4A0000
4A4A000000/A4A401@00014A4A4A4A4A4@0000024A4A00<0000A4A4A4A40
1A4A4@0300004A4A4A4A00HA4A400`00014A4@0000034A4A00<0000A4A4I
8RX01A4A4@0300004A4A4A4A00@A4A400`00014A4A4A4@054A4A00H0000A
4A4A4A40000A4A4000034A4A00@0000A4A4A4A4000044A4A00<0000A4A4A
4A400Q4A4@0300004A4A4A4A00@A4A401000014A4A4A4@0000LA4A400aTI
4A4A4A4A4@024A4A00<I6ATA4A4A4A400a4A4@036ATI4A4A:Q4800PA4A42
6ATA2Q4A4@086ATI4A4A4A4A00004A4A6ATA4A4A6ATA1A4A4@0400006ATI
4A4A6ATI1Q4A4@046ATA6ATI6ATA6ATA0Q4A4@8I6A4031TI6ATI4A4A4ATI
4A4A4ATI4A4A4BXA200004a<>R8Z:RXA208A4A401aTI4A4A4A4A4A4A4ATI
4A4A4BXA20034A4A00<Z4@PA4A4A4A400Q4A4@0@00006ATA4A4A6ATA4A4A
6ATA4A4A6ATA4A4A:Q484A4A6ATA4A4A6ATA4A4A6ATA114A4@036ATI4A4A
6ATA00@A4A402aTI4BXA214A4A4A4ATI4A4A4ATI4A4A4ATI4ATI6A4A4@02
6ATA0Q4A4@066ATA6ATI8R8A8R8A6ATI6ATA0QTI6@06:Q486ATI6ATI6ATA
6B8R8R8A0QTI4@034A4A:R8I:Q48008A4A402aTI4A4A4BXA214A4ATI4A4A
4BXA214A4ATI4A4A4BXA20034A4A00<I6A4A4A4I6A400QTI4@0<4A4A8R8A
8R8A6ATA8R8A4A4A:Q488R8A6ATI:Q486ATI8R8A0QTI6@068R8A6ATI8R8A
6ATI8R8A6B8R0R8R4@036ATI8R8A6B8R008I6AT01RXR6ATR8QTR8RXR6B8R
4BXR6@8I8R800da48/c<c<c<c01ec<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^3?<c<`>4A4A00<I6A4A4A4A4A402Q4A4@0300004A4A4A4A00PA
4A400`00014A4A4A4@054A4A00D0000A4A4A4A4A4A4000001Q4A4@030000
4A4A0000008A4A401000014A4A4A4@00008A4A401@00014A4A4A4A4A4@00
00054A4A00<0000A4A4A4A401a4A4@0300004A4A4A4A00<A4A400`00014A
4A4A4@054A4A00@0000A4A4A4A4000024A4A00D0000A4A4A4A4A4A400000
114A4@0300004A4A4A4A008A4A401@00014A4A4A4A4A4@00000B4A4A00<I
6A4A4A4A4A400Q4A4@036ATI4A4A4A4A00<A4A400`00014A4A4A4@024A4A
00<0000A4A4A4A400Q4A4@0::Q484A4A4A4A6ATA4A4A6ATI4A4A6ATA4A4A
A3XZ114A4@086ATA4A4A4A4A4A4A:Q484A4A6ATA4A4A0QTI4@034A4A:Q48
4A4A00@A4A400aTI6A4A4A4A4@034A4A00<I6A4I6ATI6AT01Q4A4@036B8Z
4A4A4A4A00DA4A401BXA214A4A4A4A4A4ATI4@044A4A00@R8Q4Z8QTb:R8I
6AT34A4A00<I6A4A4A4I6A400Q4A4@8I6A401a4A4ATI4A4A4ATI4A4A4B8R
4ATI4@044A4A0QTI4@038R8A4A4A4A4A00@A4A400aTI4BXA214A4@026ATA
00@A4A4Z4@PI6A4I6A42:Q4800DA4A4I6A4A4A4I6ATI6A400R8R4@056ATA
6ATI8R8A8R8A6ATI00<R8Q401ATI6BXR6ATI4ATI4A4A4@026ATA00<I6ATI
6A4Z4@P00Q4A4@046ATA4A4A6ATI4A4A0QTI4@03:Q486ATA4A4A008A4A40
1ATI4ATI6ATI6B8R4ATI6@03:R8I00HI6A4R8Q4I6ATZ8QTR8Q4A4A428R8A
00<Z8QTA4A4I6A400QTI6@056B8R:Q486B8R8R8A6ATI008R8Q400bXR6B8R
4ATI6@03:R8I00@I8R8R8Q4I8R9L>R9gc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^3?<c<`54A4A00<0000A4A4A4A40214A4@036ATI4A4A4A4A
00HA4A400`00014A4A4A4@034A4A00@0000A4A4A4A4I6AT64A4A00<I6ATA
4A4A4A402a4A4@0300004A4A4A4A01LA4A400`00014A4@0000074A4A00<0
000A4A4A4A400Q4A4@0400004A4A4A4A00001a4A4@0300004A4A4A4A00@A
4A400`00014A4A4A4@034A4A00D0000A4A4A4A4I6A4000000a4A4@040000
4A4A6ATA00000a4A4@05:Q484A4A4A4A4A4A6ATA00<A4A401ATI4A4A4ATI
4A4A4ATI4@024A4A00<I6A4A4A4A4A400Q4A4@04:Q486ATA6ATA8R8A2A4A
4@056ATA4A4A4A4A4A4A6ATA00PA4A400aTI4A4A4A4A4@034A4A00<I6ATA
4A4A4A400Q4A4@076ATA:Q484A4A6ATA6ATI6ATA4A4A00<I6AT00a4A4ATI
4A4A4@024A4A00<b:R8A4A4I6A400QTI4@034A4A6ATI6ATA00<A4A400aTI
6BXA21TI4@044A4A00<Z4@PA4A4A4A400Q4A4@038R8A4A4A:Q4800@A4A40
0aTI4A4A4A4A4@044A4A0QTI6@046ATA6ATI4A4A6ATA0Q4A4@8I6A401Ta<
>P00014A4B8R4A4A4ATI6@8I6A428R8A00TI6A4I6ATI6A4I6A4I6ATR8Q4I
6A4I6ATI6A400a4A4@<I6A400b8R4ATI4ATI4@028R8A00TI6ATI6A4I6ATI
6A4I6ATZ8QTI6A4R8Q4A4A400QTI4@<A4A446ATA1a4A4@096ATA8R8A:Q48
6ATI8R8A6ATA6ATI:Q486ATI008I6A436ATI00PI6A4I6ATR8Q4Z8QTR8Q4I
6ATI6A4Z8QT38R8A00/A4A4R8Q4Z8QTI6ATR8Q4I8R8I6A4I8R8Z8QTI8R8Z
8QT00QTR8P03<RXR6B8RC4@R07O<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h<lc<c0046ATI4A4A4A4A00000Q4A4@0300004A4A4A4A00@A4A40
1ATI4A4A4ATI6BXR6@0000044A4A00@0000A4A4A4A4000084A4A00<0000A
4A4A4A400Q4A4@036ATA4A4A4A4A00<A4A400`00014A4A4A4@064A4A00<0
000A4A4A4A40114A4@0300004A4A000000<A4A400`00014A4A4A4@034A4A
00<0000A4A4A4A40114A4@066ATI4A4A4A4A4A4A6ATI00000a4A4@050000
4A4A4A4A4A4A000000LA4A401000014A4A4A4@0000dA4A401000014A4A4A
4ATI4@XA4A400aTI4@00014A4@064A4A00<Z8QTI6ATA4A40214A4@056ATA
4A4A4A4A4A4A000000HA4A400bXA214A4BXA20054A4A00`Z8QTA4A4I6A4A
4A4Z8QTR8Q4A4A4R<RXA4A4Z8QTA4A4I6A424A4A00/I6A4A4A4A4A4A4A4Z
4@PA4A4I6A4b>T@R<RXA4A4I6A401A4A4@04:Q484A4A6ATI6ATA0QTI6@06
6ATA6ATI4A4A4A4A6ATI6ATA0Q4A4@086ATA4A4A4A4A6ATA4A4A6ATA4A4A
6ATA1A4A4@036ATA4A4A<RXR008I6A464A4A00LZ4@PA4A4I6A4A4A4Z4@PA
4A4I6A400Q4A4@046ATA4A4A4A4A:Q480a4A4@056ATA4A4A4A4A6ATI6ATA
008A4A426ATA00PA4A4I6ATA4A4Z4@PI6A4R8Q4I6ATI6A424A4A00@R8Q4I
6ATI6A4A4A426ATI00PI6A4R8Q4I6A4I6ATR8Q4A4A4I6ATI6A424A4A00DI
6A4A4A4A4A4I6A4A4A400QTI4@8A4A426ATA00XA4A4Z4@PA4A4Z4@PA4A4I
6A4A4A4Z4@PI6A4R8Q426ATA00@R8Q4A4A4R8Q4I6A454A4A00HI6ATA4A4R
8Q4I6ATR8Q4I6AT28R8A00@I6ATA4A4I6ATR8Q426ATI00PA4A4R8Q4I6ATI
6A4Z8QTR8Q4I8R8R8Q44:R8I00<I6ATjA1W<c<`0M/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Pcc<c<00<A4A40000A4A401Q4A4@0300004A4A
4A4A00@A4A400`00014A4A4A4@044A4A00T0000A4A4A4A4A4A40000A4A4I
6A40000I8R801a4A4@0300004A4A4A4A010A4A400`00014A4A4A4@044A4A
00<0000A4A4A4A400a4A4@0500004A4A4A4A4A4A000000@A4A401ATR8RXA
214A4A4A4@0000024A4A00<0000A4A4A4A401Q4A4@0300004A4A4A4A00@A
4A401000014A4A4A4@00008A4A401`00014A4@00014A4ATI4A4A4@000006
4A4A00@0000A4A4A4A4Z4@P?4A4A00D0000I6ATI6ATA4A4I6AT00Q4A4@03
6ATA4A4A4A4A00PA4A400aTI4A4A4BXA20044A4A00<I6A4A4A4A4A40114A
4@036ATA4A4A6ATA008A4A4012XA214A4ATI6A4A4@8I6A4011TI6A4A4ATI
4A4A4@<I6A444A4A00<I6A4A4A4I6A400QTI4@056ATI4A4A6ATI:Q484A4A
008I6A402QTI6A4A4ATI4A4A4ATI4A4A4ATI6A4A4ATI6BXA20HA4A401ATI
6A4A4A4A4A4A4ATI4@034A4A00<I6ATA4A4R8Q400Q4A4@03:R8I6ATA6ATA
00LA4A401ATI4A4A4ATI4ATI4A4A4@026ATA00<A4A4Z4@PI6AT00Q4A4@05
6ATI4A4A6ATA4A4A6ATA00<A4A401ATI4A4A4B8R4ATI6A4A4@026ATA00HZ
4@PI6ATA4A4I6A4A4A4I6A434A4A0QTI4@040000<RXR4A4A6ATA0a4A4@03
6ATA4A4A6ATA00@A4A400aTI4A4A4ATI4@026ATA00HI6ATR8Q4I6ATI6A4I
6ATR8Q424A4A00hI6A4I6ATI6A4Z4@PR8Q4I6A4A4A4Z8QTA4A4I6ATZ4@PI
6A4A4A4I6A438R8A00TI8R8I6ATZ4@PI6ATA4A4I6ATZ4@PZ8QTI6A400RXR
6@036ATI:R8I:R8I00@Z8QT011TR8Q4A4ATR8T@j8WO<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h<lc<c0DA4A400aTI6A4A4A4A4@034A4A00<0
000A4A4A4A401A4A4@0500004A4A4A4A00006ATI00`A4A401`00014A4@00
014A4ATI4A4A4@0000054A4A00<0000A4A4A4A403A4A4@03:R8I4A4A4A4A
008A4A400`00014A4A4A4@0C4A4A00<0000A4A4A4A401A4A4@0300004A4A
4A4A00/A4A400`00014A4A4A4@034A4A00<0000A4A4A4A401a4A4@036ATI
4A4A4A4A00<A4A400aTI6A4A4A4A4@024A4A00LI6ATA4A4Z4@PA4A4I6A4A
4A4R8Q401Q4A4@8I6A400a4A4BXA214A4@094A4A00DI6ATA4A4A4A4A4A4Z
4@P00Q4A4@096ATA4A4A6ATA6ATI4A4A6ATA4A4A6ATI4A4A008I6A424A4A
00@I6A4A4A4I6ATA4A426ATA00<R8Q4I6A4I6A400QTI6@048R8A6ATI8R8A
6ATA0QTI6@038R8A6B8R6ATI008A4A426ATA00`A4A4I6ATA4A4A4A4I6A4A
4A4I6A4I6ATA4A4I6A4A4A4I6AT24A4A00TZ4@PA4A4A4A4I6ATA4A4I6A4A
4A4I6A4A4A400QTI4@084A4A00006ATA4A4A6ATA4A4A6ATA:Q480Q4A4@8I
6A40214A4ATI4ATI4ATI4A4A4ATI6A4A4ATI4@DA4A4011TI4A4A4A4A4BXA
20<I6A444A4A0QTI4@03:Q484A4A6ATA008I6A400a4A4BXA214A4@036ATA
00/Z4@PA4A4A4A4A4A4I6A4A4A4Z4@PA4A4I6A4R8Q4I6A400Q4A4@03:Q48
6ATA4A4A008A4A446ATA00@Z4@PA4A4A4A4Z4@P26ATA00LR8Q40000I8R80
000R8Q4I6ATI6A400QTI6@058R8A6ATI8R8A8R8A6ATI00<R8Q402QTI6BXR
6BXR6B8R4ATI6B8R4BXR6B8R4ATI6B8R4@8Z8QT01ATI6ATR8QTI6ATI4B8R
4@026ATI00=<8PS<c<c<c<`0MLc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Pcc<c<1A4A4@0300004A4A000000@A4A401000014A4A4A4@0000@A
4A402000014A4A4A4@00014A4@00014A4@0000DA4A400`00014A4A4A4@09
4A4A0P0000<A4A400`00014A4A4A4@084A4A0P0000@A4A400`00014A4A4A
4@054A4A00<0000A4A4000001Q4A4@0300004A4A4A4A00DA4A401000014A
4A4A4@0000<A4A400`00014A4@0000044A4A00<0000A4A4A4A401Q4A4@05
8RXZ4A4A00004A4A6B8R00/A4A401@0001TI4A4A4A4A4ATI4@024A4A00<Z
4@PA4A4A4A402Q4A4@04:R8I4A4A4A4A6ATA0a4A4@056ATI:R8I4A4A4A4A
6ATA00DA4A400bXA214A4A4A4@026ATA0a4A4@056ATA4A4A4A4A4A4A6ATA
008A4A436ATA0Q4A4@0=6ATA6ATI6ATA6ATA6ATI6ATA8R8A6ATI:Q488R8A
4A4A:R8I8R8A00<I6A40128R4A4A4BXA22XR6@<I6A400aTI6A4A4B8R4@05
4A4A00DI6ATA4A4I6A4I6A4A4A400QTI4@8A4A4022XA21TI4A4A4ATI4A4A
4ATI4A4A4ATI4@8A4A401ATI6B8R4A4A4B8R4ATI4@034A4A00@R8Q4I6A4A
4A4I6A454A4A00@I6A4Z4@PA4A4Z4@P44A4A00@I6A4A4A4I6A4I6A424A4A
0RXA208A4A401ATI4A4A4A4A4ATI4A4A4@026ATA00PA4A4I6A4I6A4A4A4I
6A4A4A4I6A4A4A426ATA01LI6ATA4A4Z4@P0000A4A4I6A4Z4@PI6A4A4A4I
6A4A4A4Z4@PA4A4I6A4R8Q4I6A4A4A4I6A4A4A4I6A4R8Q40000R8Q400QTI
4@048R8A6ATA6ATI8R8A0QTI6@0=:R8I4A4A6ATI8R8A6B8R8R8A6ATA:R8I
6ATI:R8I8R8A:R8I8R8A008I6AT2:R8I00LR8Q4I6ATA4A4I6A4A4A4Z4@PR
8Q400QTI6@038R8A4A4A>T@I07O<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h<lc<c2@A4A401P00014A4A4A4@00014A4@0000XA4A401@00014A
4A4A4A4A4@0000024A4A00<0000A4A4A4A400Q4A4@0300004A4A4A4A00DA
4A400`00014A4A4A4@034A4A00@0000I6A4A4A4000044A4A00@0000A4A4A
4A4000034A4A00<0000A4A4A4A401a4A4@0800004A4A4A4A6ATA4A4A:Q48
4A4A00003Q4A4@03:R8I6ATA4A4A008A4A401ATI4A4A4A4A4A4A4@000009
4A4A00<R8Q4A4A4I6A403Q4A4@0300004A4A4A4A00PA4A426ATA00<Z4@PA
4A4I6A400Q4A4@046ATA4A4A4A4A:R8I0a4A4@066ATI4A4A4A4A6ATA4A4A
:Q480aTI4@054A4A6ATI8R8A6ATI4A4A008I6AT01A4A4BXR6A4A4ATI4A4A
4@026ATA0a4A4@096ATA4A4A6ATA6ATI6ATA6ATI4A4A6ATA6ATI00<A4A42
6ATA00HI6ATA4A4I6A4R8Q4A4A4I6A444A4A00<I6ATA4A4I6AT00Q4A4@03
6ATA4A4A6ATI008I6A401a4A4BXA214A4ATI4ATI6ATI4ATI6@026ATA0Q4A
4@076ATA4A4A4A4A6ATI4A4A:Q486ATA008A4A401ATI4ATR8QTI6A4A4B8R
4@026ATA00DA4A4I6ATZ4@PI6ATI6A400Q4A4@036ATA8R8A6ATA008I6A40
0a4A4ATI4A4A4@046ATA0R8R4@046ATI6ATA6ATA4A4A0aTI4@034A4A6ATA
4A4A008A4A401RXA228R4A4A4BXA214A4BXR6@8I6AT01ATI4ATR8QTI6BXA
21TI6@028R8A00<I6ATZ8QTZ8QT00RXR6@0=8RXZ:R8I:R8I8R8A6ATI6B8R
8R8A:R8I8R8A6ATA8R8A4A4A6ATA008R8Q402ATI6B8R4ATI6ATI6BXA21TI
6ATI4ATI6D@Z8P1gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<
c<`84A4A00<I6A4I6ATA4A400Q4A4@036ATI4A4A4A4A00dA4A400aTI6A4A
4A4A4@024A4A00<I6ATA4A4A4A406Q4A4@0500004A4A4A4A4A4A000000lA
4A400`0001TI4A4A4@0<4A4A00<I6A4A4A4A4A401A4A4@0300004A4A4A4A
00LA4A401000014A4A4A4ATI6@HA4A4041TI6A4A4ATI6ATI4A4A4ATI6A4A
4ATI4A4A4BXA214A4ATI4A4A4ATI4A4A4BXA20DA4A4011TI6A4A4B8R4ATI
6@TA4A4012XA214A4A4A4A4A4@8I6A400aTI6A4A4A4A4@024A4A00@I6A4A
4A4A4A4A4A426ATA00XA4A4I6A4A4A4A4A4I6ATb>T@0000I6ATA4A4I6A42
4A4A0QTI4@034A4A6ATA6ATA00@I6A40114A4ATI4A4A4A4A4@8I6AT24A4A
00DR8Q4I6ATA4A4I6A4I6AT00a4A4@0;6ATA4A4A4A4A4A4A6ATI6ATA4A4A
6ATI8R8A4A4A6ATA008A4A401ATI4A4A4A4A4A4A4ATI4@024A4A00@I6A4A
4A4A4A4I6AT34A4A00HI6A4A4A4I6A4A4A4I6A4Z4@P34A4A00<I6A4A4A4A
4A400Q4A4@036ATA4A4A:Q48008A4A401RXA214A4A4A4BXA21TI4B8R4@<I
6A402bXA21TI4B8R4ATI4A4A4BXA21TI6A4A4BXA214A4BXA20026ATA00`I
6ATI6A4A4A4R8Q4I6A4A4A4I6A4I6ATI6A4R8Q4I6ATI6A426ATI00HI6A4A
4A4I6A4R8Q4A4A4Z4@P24A4A00<I6A4A4A4R8Q400aTI4@066ATI8R8A8R8A
8R8A6ATI:Q480QTI6@03:Q486ATI:R8I00<Z8QT00aTI6B8R4BXR6@03:R8I
00<R8Q4Z8QTZ8QT011TI4@0=4A4A:Q484A4A8R8A6ATA6ATI8R8A6ATI6ATA
8R8A:R8I4A4A>T@I07O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
<lc<c0HA4A42000000<A4A40000A4A401Q4A4@036ATI4A4A4A4A008A4A40
1@00014A4A4A4A4A4@00000<4A4A00<I6A4A4A4A4A40214A4@0300004A4A
4A4A010A4A400`00014A4ATI4@074A4A00<I6ATA4A4A4A402A4A4@066ATA
4A4A4A4A00004A4A00000Q4A4@0400004A4A4A4A:Q482Q4A4@05:Q480000
6ATA4A4A:Q48008A4A400aTI4A4A4A4A4@034A4A00<I6A4A4A4I6AT00a4A
4@036ATI6ATA6ATI00<A4A456ATA00HR8Q4A4A4A4A4I6ATI6A4I6AT34A4A
00PZ4@PI6A4A4A4I6A4Z8QTI6ATA4A4I6A424A4A00HZ8QTZ4@PI6ATR8Q4Z
8QTI6A436ATI00hA4A4I6ATR8Q4I6ATI6A4I6ATR8Q4I6ATR8Q4Z4@PR:RXZ
8QTI6A4Z8QT26ATA00Q4A38R8Q4I6ATZ8QTI6ATZ8QTI6A4I6AT26ATA00hZ
8QTI6ATI6ATR8Q4I6ATR8Q4Z4@PI6A4R8Q4I6ATZ8QTI6ATI6A4I6AT38R8A
014I6ATR8Q4I6ATI6A4I6ATA4A4I6ATR8Q4I6ATR8Q4A4A4Z4@PI6ATR8Q40
000I6ATZ8QT00Q4A4@06:Q486ATA4A4A6ATI4A4A6ATA0a4A4@046ATA:Q48
4A4A6ATA0Q4A4@05:Q484A4A4A4A4A4A:Q4800<A4A400aTI4A4A4A4A4@02
4A4A00DZ4@PA4A4I6A4I6A4A4A400QTI4@046ATI6ATA4A4A8R8A0a4A4@07
6ATA4A4A4A4A4A4A6ATA4A4A6ATA00@A4A401aTI6BXR6A4A4ATI6B8R4ATI
6B8R4@056ATA00HA4A4I6A4A4A4R8Q4A4A4Z4@P24A4A00<Z4@PA4A4I6A40
0QTI4@<I6AT02R8R4BXR6BXA22XR6B8R4BXR6B8R4BXR6ATI4B8R4@@Z8QT0
21TI6ATI4ATI4ATI4@0001TI4BXA214A4@8I6A40114A4ATI4ATI4ATI6@8I
6A401Q4A4B8R4ATI6B8R4ATI6CY46GO<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h<lc<c0054A4A00004A4A4A4A0000014A4A401QTI4A4A4A4A
4BXA214A4@0000<A4A400aTI6A4A4A4A4@044A4A00<0000A4A4A4A400Q4A
4@036ATA4A4A000000LA4A401P00014A4A4A4ATI4A4A4@0000LA4A400`00
014A4A4A4@024A4A0P0000PA4A400aTI4A4A4A4A4@044A4A00<0000A4A40
00002A4A4@0300004A4A4A4A00<A4A401ATI4@00014A4A4A4ATI4@054A4A
00/I8RXA4A4A4A4A4A4Z8QTA4A4I6ATI6A4A4A4I6A4I6AT00QTI4@036ATI
4A4A8R8A008A4A4011TI6A4A4ATI6A4A4@8I6A402A4A4ATI4ATI6ATI6BXR
6B8R4ATI4BXR6ATR8P034A4A014I6A4A4A4Z4@PI6A4A4A4Z4@PA4A4Z4@PI
6A4I6ATI8R8Z8QTZ4@PI6ATI6A4Z8QTZ4@P00RXR6@0D:Q486ATI:R8I6ATA
:R8I:Q48<RXR8S8Z8RXZ:R8I6ATA:R8I6ATI:R8I6ATI:R8I6B8R:R8I8R8A
6ATI0R8R4@@Z8QT02QTR8R8R4ATI6ATR8R8R4BXR6ATR8RXR6ATR8R8R4@8Z
8QT0228R4ATI4BXR6B8R4ATR8R8R4BXR6B8R4@8Z8QT01S8Z8R8R4BXR6ATI
4ATI6ATI4@DR8Q426ATA0R8R4@046ATI6ATA:Q486ATI0R8R4@046ATA8R8A
6ATI6ATA0RXR6@038R8A6ATA6ATA00<R8Q4012XR6B8R4B8R4ATI6@8I6A44
8R8A00LZ8QTR8Q4R8Q4I6ATR8Q4I6A4R8Q400QTI4@044A4A8R8A6ATA8R8A
0QTI4@8R8Q426ATA00@A4A4I6A4R8Q4I6A426ATI00TI6A4A4A4I6A4I6ATR
8Q4I6ATI6A4R8Q4I6AT00QTI4@078R8A6ATI4A4A4A4A6ATA8R8A:Q48008I
6A400bXA228R4ATI4@028R8A00<Z4@PZ8QTI8S800RXR6@068R8A6ATI8R8A
6ATI8R8A:R8I0R8R4@056ATA8R8A6ATA:Q486ATA008Z4@P36ATA00DA4A4Z
4@PA4A4Z4@PA4A400RXA20<I6A426ATI0Q4A4@03C4@Rc<c<c<c<07G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c1hA4A436ATI0a4A4@03
6ATI4A4A4A4A008A4A400aTI4A4A4@0000044A4A00<0000A4A4A4A401A4A
4@0300004A4A4A4A014A4A401000014A4A4A4@00008A4A401P00014A4ATI
4@00014A4BXA20LA4A400`00014A4A4A4@044A4A00<0000A4A4A4A400a4A
4@06:Q486ATA00006ATA4A4A6ATI11TI4@8A4A404bXA21TR8QTI6C8Z8Q4A
4ATI6ATI4ATI6ATI4A4A4B8R4ATR8QTI6ATI4A4A4BXR6ATI4BXA214A4@04
6ATA00XI8R8I6A4I6A4I6A4I6ATZ4@PI6A4I6ATZ4@PA4A436ATA00<Z8QTA
4A4A4A400b8R4@0@:Q486B8R6ATI8R8A6B8R8R8A6B8R:R8I6ATI8R8A6ATA
<SY46ATA8R8A:R8I8R8A0QTI6@098R8A6B8R6ATI:R8I8R8A6ATI:R8I8R8A
6ATI008Z8QT01ATR8RXR6B8R4B8R4ATI6@02:R8I00HR:RXZ8QTZ8QTI8R8Z
8QTI6A42:R8I00XI8R8Z8QTR8Q4R:RXZ8QTI6A4Z8QTI8R8Z8QTR:RX2:R8I
00PI6ATR8Q4I6ATI6A4Z8QTZ4@PZ8QTR8Q426ATI0R8R4@04:R8I8R8A6ATI
6ATI0R8R4@0F6ATI8R8A8R8A:R8I8R8A6B8R8R8A:R8I8R8A:R8I6ATA<RXR
:R8I8R8A:R8I8R8A6B8R:R8I6B8R:R8I8R8A:R8I0R8R4@046B8R8R8A8R8A
6B8R0RXR6@0N8R8A:R8I8RXZ:Q48:R8I6ATI8R8A:R8I8R8A:R8I<RXR6ATI
8RXZ8R8A:R8I<RXR8R8A6ATI:R8I<RXR8R8A6B8R8R8A6B8R8R8A6ATI8R8A
6ATA6B8R6ATI0QTI4@08:Q486ATI8R8A6ATI8R8A6ATI6ATA4A4A1ATI4@8I
6AT02R8R4BXR6BXA21TI6B8R4ATI4BXR6B8R4BXR6B8R4@8I6A401bXA21TI
4A4A4ATI4B8R4ATI6ATI4@054A4A11TI4@048R8A6ATI8R8A6ATI0R8R4@03
:R8I6ATA>T@I07O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<
c0<A4A400aTI6A4A4B8Z:P044A4A00<0000A4A4A4A400Q4A4@0300004A4A
4A4A00hA4A400aTI6A4A4A4A4@0Q4A4A00<0000A4A4000004A4A4@060000
4A4A4A4A00004A4A00000a4A4@0300004A4A4A4A00<A4A400aTI4A4A4ATI
4@034A4A00<I6A4A4A4A4A40214A4@036B8R6ATA6ATA008A4A401aTI4A4A
4ATI6A4A4ATI6ATI4ATI6@024A4A00HI6ATZ8QTA4A4A4A4I6A4A4A426ATA
00DA4A4I6A4I6A4I6A4I6AT011TI4@038R8A6ATA6ATA00<A4A404aTI6BXA
21TI6B8R4ATI6ATI4ATI6B8R4ATI6BXR6A4A4ATI4ATI6B8R4ATI6BXR6B8R
4BXR6ATI6@028R8A00@I8R8Z8QTZ8QTR8Q42:R8I00PI6ATZ8QTI6ATI8R8R
8Q4I6ATR8Q4Z8QT26ATI00HR:RXZ8QTZ8QTI6ATR8Q4R<RX26ATI0R8R4@8I
8R800aTI6B8R4BXR6@036ATI00/R:RXZ8QTZ8QTI8R8R8Q4R:RXR8Q4I6ATR
8Q4Z8QTR8Q400QTI6@<R8Q401QTI6ATI4B8R4ATI6BXR6ATR8P<Z8QT01aTR
8QTI6B8R4ATR8RXR6ATR8RXA20028R8A0bXR6@036B8R8R8A6B8R00HZ8QT0
21TI4B8Z:RXR6ATR8RXR6ATR8RXR6ATI4@8Z8QT01ATI4BXR6B8R4BXR6ATI
6@06:R8I00@R:RXR8Q4Z8QTI6A426ATI00HI8R8I6ATR8Q4I6ATZ4@PA4A42
8R8A00<I6ATI6A4Z4@P00QTI6@04<RXR:R8I6ATA6ATI0aTI4@08:Q484A4A
4A4A4A4A:Q486ATA:Q484A4A0aTI4@088R8A6ATA6ATA:Q484A4A:Q484A4A
:Q480a4A4@03:Q484A4A4A4A008A4A4011TI4A4A4ATI4ATI4@8Z4@P01A4A
4ATI4A4A4ATI4A4A4@026ATA0QTI6@034A4A6B8R<RXR07O<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h<lc<c0@A4A400`00014A4A4A4@0A4A4A
00<I6A4A4A4A4A400a4A4@036ATI4A4A4A4A01PA4A400aTI4A4A4A4A4@08
4A4A00<I6A4A4A4A4A405Q4A4@036ATA4A4A:Q4800HA4A400aTI4A4A4ATI
4@0=4A4A00<I6A4Z8QTA4A400Q4A4@066ATA4A4A6ATA6ATI8R8A6ATI0Q4A
4@8Z4@P011TI4BXA21TI6BXR6@<I6A438R8A00dA4A4I6ATR8Q4Z4@PI6ATI
6A4R8Q4A4A4I8R8R8Q4A4A4Z4@PA4A400R8R4@086B8R8R8A6ATI8R8A6ATI
:R8I6ATA:R8I0R8R4@096ATA6ATI8R8A6ATI8R8A6ATA6ATI8R8A6ATA008R
8Q401bXR6ATI6ATR8R8R4ATR8QTI4ATR8P03:R8I00@R8Q4Z8QTZ8QTZ8QT2
8R8A00hI6A4I8R8Z4@PI6A4Z8QTZ4@PZ8QTI8R8Z8QU<C3Xj>S8Z8QTI8R8I
6AT3:R8I00TI6ATb:R8I8R8Z8QTI8R8R8Q4I6ATR8Q4I6AT00R8R4@086ATI
8R8A:R8I8R8A6ATI8R8A:R8I6ATI0RXR6@0=8R8A:R8I8R8A6ATI8R8A:R8I
6B8R:R8I6ATA:R8I6B8R8R8A6B8R008Z8QT00b8Z:R8R4BXR6@02:R8I00DR
8Q4Z8QTI8R8R8Q4I8R800RXR6@056ATA:R8I8R8A8R8A6ATA008Z8QT00b8R
4BXR6B8R4@02:R8I00/R8Q4Z8QTZ8QTZ8QTI6ATZ8QTR8Q4I6ATZ8QTI6ATI
8R800R8R4@0?8RXZ6ATI6B8R8R8A6ATI8R8A6ATI8R8A6B8R:R8I6B8R:R8I
8R8A6ATI:Q48008I6A424A4A00dI6A4A4A4A4A4A4A4Z4@PA4A40000Z4@PR
8Q4Z4@P0000Z4@P00000114A4@0400006ATA6ATA:Q480Q4A4@04:Q486ATA
4A4A6ATA0Q4A4@05:Q486ATA6ATA6ATA:Q48008A4A402RXA214A4A4A4A4A
4B8R4ATI4A4A4BXR6ATI6ATI4GO<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h<lc<c0LA4A400aTI6ATI4A4A4@024A4A00<0000A4A4A4A400Q4A
4@036ATA4A4A4A4A00<A4A400`00014A4A4A4@054A4A00<I6ATA4A4A4A40
5a4A4@036ATA4A4A4A4A014A4A400aTI4A4A4A4A4@054A4A00<0000A4A4A
4A400Q4A4@03:Q484A4A4A4A00@A4A401ATI4A4A4BXA214A4ATI4@094A4A
00<0000A4A4Z4@P00Q4A4@036ATA4A4A4A4A008A4A402QTI4A4A4BXR6ATI
4A4A4ATI4ATI6ATI4ATI6B8R4@8A4A404R8R4BXR6ATI4ATI4ATI6BXR6B8R
4A4A4ATI6BXR6ATI6B8R4ATR8QTI6BXA21TI6ATR8RXA208I6A403BXA228R
4B8R4ATI6B8R4ATR8R8R4A4A4ATI6B8Z:QTI4BXR6ATI6@024A4A00HI6ATR
8Q4I6ATR8Q4I6ATI6A448R8A00DI6ATR8Q4R8Q4A4A4I6A400RXR6@076ATA
:R8I6ATI:R8I8R8A6ATI6B8R008R8Q401ATI6BXR6B8R4ATR8QTI4@028R8A
00TI6ATR8Q4I6ATb:R8I8R8I6A4R8Q4Z8QTR8Q400RXR6@056ATI8R8A:R8I
6ATI6ATA008R8Q401aTI6B8R4ATR8R8R4BXA21TR8QTI6@02:R8I014R8Q4I
6ATR8Q4I8R8R8Q4Z8QTI6ATR8Q4Z8QTR8Q4I6ATR8Q4I6A4Z4@PZ8QTI8R8Z
8QT00R8R4@0<6ATI:R8I:R8I:R8I8R8A6B8R8R8A:R8I8R8A6ATI:Q488R8A
0RXR6@068R8A6ATA:R8I:R8I8R8A6ATI0R8R4@056ATI6B8R8R8A:R8I8R8A
008Z8QT04b8R4ATR8R8R4ATR8QTI4ATI6B8R4ATI4A4A4B8R4ATI6ATI4B8R
4ATI4BXR6ATI4ATI6BXA21TI6@028R8A00<I6ATI6A4I6A400Q4A4@8Z4@P0
0a4A4BXA22XA2002:Q4800@I6A4A4A4A4A4000026ATA114A4@05:Q484A4A
4A4A4A4A:Q48008A4A40128R4A4A4A4A4A4A4@8Z4@P00aTI4@0001TI4@05
4A4A00LI6A4A4A4Z4@PI6ATR8Q4A4A4R8Q400QTI6@03:Q48c<c<c<c<07G<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c0HA4A400aTI6A4A
4@00000M4A4A00<I6A4A4A4A4A40414A4@0300004A4A4A4A00DA4A400`00
014A4A4A4@034A4A00@0000A4A40000I6A424A4A00@0000A4A4A4A400006
4A4A0QTI4@<A4A400`00014A4A4A4@054A4A00D0000A4A4A4A4A4A400000
0Q4A4@0400004A4A0000:Q48214A4@076ATA4A4A4A4A4A4A8RXZ4A4A6ATA
008A4A42:R8I0Q4A4@8I6AT02Q4A4BXR6B8R4ATI4A4A4ATI6A4A4ATI4BXR
6B8R4@<A4A428R8A0QTI4@8R8Q4011TI4B8R4ATR8QTI4@8R8Q402Q4A4BXA
228R4ATI4ATI6A4A4BXA21TI6B8R4ATI4@8R8Q401aTI6ATI4B8R4C8jA14A
4B8R4ATI6@036ATA00TZ8QTI6ATI6ATjA38Z8QTA4A4R8Q4I8R8Z8QT00b8R
4@0:6ATI6ATA:Q486ATI:R8I6ATA6ATI6ATA8R8A6ATI0b8R4@056ATI:R8I
6B8R6ATA:Q48008R8Q401aTI4BXA21TR8RXR6ATI6B8R4ATI6@028R8A00TI
6ATR8Q4Z8QTR8Q4I6ATR8Q4Z8QTR8Q4I6AT00b8R4@03:R8I6ATI:R8I00<R
8Q401RXR6C8Z8RXA228R4C8Z8QTI4@8Z8QT0128R4ATI4B8R4ATI6@<R8Q40
0bXR6B8R4ATI6@028R8A00PI6A4R8Q4I6ATZ4@PI6A4Z8QTR8Q4I6AT28R8A
010Z4@PR8Q4I6ATI6A4A4A4I6ATI6A4A4A4Z8QTI6A4I6ATZ4@PI6A4A4A4R
8Q4A4A426ATI00<R8Q4I6ATR8Q400R8R4@046ATA:Q486ATA4A4A0RXA2003
4A4A:Q484A4A008A4A401@00014A4BXA21TI4@0000024A4A00<Z4@PA4A4A
4A400a4A4@03:Q4800004A4A008A4A401ATI4@0002XA21TI4@000002:Q48
0a4A4@04:Q484A4A4A4A:Q480Q4A4@8Z4@P0114A4ATI4A4A4ATI6@8R8Q40
11TI6ATI4ATI4BXA27O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
<lc<c08A4A400aTI6A4A4A4A4@084A4A00<0000A4A4A4A40314A4@050000
6ATI4A4A4A4A6ATI00HA4A400`0001TI4A4A4@074A4A00D0000A4A4A4A4I
6A4000000a4A4@036ATA4A4A4A4A00HA4A400`00014A4A4A4@0=4A4A00<0
000A4A4A4A400a4A4@0300004A4A4A4A00<A4A401@00014A4A4A4@0001TI
4@034A4A00D0000A4A4A4A4A4A4Z4@P01A4A4@046ATA4A4A6ATA:Q480a4A
4@0:00006ATA4A4A6ATI4A4A:R8I6ATA4A4A6ATA00000aTI4@048R8A6ATI
6ATA4A4A0QTI6@096ATA:R8I6ATA6B8R4A4A6ATA4A4A:Q484A4A008I6AT2
6ATA0Q4A4@048R8A6ATA6ATA8R8A0Q4A4@036ATA8R8A6ATA008I6A402B8Z
:QTI4B8R4ATI4B8R4ATI4ATI6B8R4ATI6@026ATA00TA4A4R8Q4R:RXR8Q4I
8R8R8Q4I6ATI6A4I6AT00Q4A4@058R8A6ATI8R8A8R8A6B8R008R8Q401RXR
6ATI6BXR6ATI4B8R4ATI6@8R8Q4021TI6B8R4ATI6ATI6ATR8R8R4ATR8R8R
4@<I6AT02QTR8R8R4ATI6B8R4BXA21TI4BXR6ATI4B8R4ATI6@<R8Q401ATI
6BXR6B8R4BXR6B8R4@02:R8I00LR<RXZ8QTZ8QTZ8QTI6ATR8Q4I6AT00R8R
4@0D:R8I6ATI8R8A6ATI:R8I:Q48:R8I8R8A:R8I6ATA:R8I6ATA8R8A:R8I
6ATA8R8A6ATA:R8I8SXb:Q480RXR6@036B8R:R8I6ATA00@R8Q402aTI6ATI
4B8R4A4A4BXA214A4ATI4ATI6ATI4ATI6B8R4@036ATI00PR8Q4I6ATZ4@PA
4A4R8Q4I6ATI6A4Z8QT26ATA2A4A4@05:Q484A4A4A4A4A4A:Q4800<A4A40
1BXA214A4A4A4A4A4BXA20034A4A0RXA208A4A400bXA214A4BXA20024A4A
00<I6A4A4A4A4A400Q4A4@05:Q484A4A6ATA6ATA4A4A008I6A401a4A4ATI
6BXA238Z8QTI4ATI6B8R4@026ATI00<jA1W<c<c<c<`0MLc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Pcc<c<2A4A4@0300004A4A4A4A00<A4A40
0`00014A4A4A4@0;4A4A00<0000A4A400000114A4@0300006ATA4A4A008A
4A400`00014A4A4A4@084A4A00<0000A4A4A4A40114A4@0300004A4A0000
00PA4A400`00014A4A4A4@024A4A00<0000I6A4A4A40214A4@0300004A4A
4A4A00lA4A400`00014A4A4A4@024A4A00@Z4@PA4A4A4A4Z4@P54A4A00DZ
4@PA4A4A4A4A4A4I6AT00a4A4@036ATA6ATI6ATA00<A4A401QTI6A4A4ATI
6ATI4A4A4ATI4@<A4A4011TI6A4A4ATI4ATI4@8I6AT01QTI4A4A4A4A4A4A
4ATI4BXA208I6A424A4A00<R8Q4Z4@PI6A400aTI4@03:Q486ATA8R8A008I
6A40128R4ATI4BXA21TI6@8I6A4011TI6BXR6ATI4B8j<P8R8Q402aTI4ATI
6BXA21TR8R8R4BXR6ATI6ATR8Q4A4ATI6B8R4@026ATI0R8R4@056ATI8R8A
8R8A6ATI8R8A008I6AT00aTI4BXR6BXA20038R8A00TR:RXZ4@PR8Q4R8Q4Z
8QTI6ATR8Q4Z8QTI6AT00R8R4@036ATI:R8I6ATA008Z8QT02QTI4B8R4B8R
4ATI6B8R4BXR6B8R4B8Z:RXA22XR6@8I6A40128R4ATI6B8R4ATI6@8R8Q40
1aTI6B8R4B8R4B8R4ATI4BXR6A4A4@02:R8I01<R8Q4Z8QTI6ATZ8QTZ4@PI
6ATR8Q4I6ATZ4@PZ8QTR8Q4I6ATZ8QTI6A4Z8QTI6ATR8Q4R:RXA4A400QTI
4@0:4A4A6ATA4A4A4A4A6ATA4A4A6B8R6ATA4A4A:R8I0QTI4@036ATI8R8A
6ATI00@I6A424A4A00@I6A4A4A4Z4@PZ4@P44A4A00@Z4@PA4A4A4A4I6A42
:Q480Q4A4@06:Q484A4A6ATA:Q484A4A:Q480QTI4@8Z4@P01A4A4BXA22XA
214A4ATI4@044A4A00<I6A4A4A4Z4@P00QTI4@034A4A:Q484A4A00@A4A40
2RXA214A4A4A4A4A4@00028R4ATI6B8R4BXR6A4A4GO<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h<lc<c0034A4A00004A4A008A4A400aTI6A4A
4@0000024A4A00<0000A4A4A4A402A4A4@046ATI4A4A6ATI00002a4A4@03
00004A4A4A4A00LA4A400`00014A4A4A4@044A4A00<I6ATA4A4A4A401A4A
4@0300004A4A4A4A00/A4A400`00014A4A4A4@0=4A4A00<0000A4A4A4A40
0Q4A4@05:Q484A4A4A4A4A4A000000DA4A400`00014A4A4A4@034A4A00<I
6A4A4A4I6A401Q4A4@8I6A424A4A00Hb:R8A4A4A4A4I6ATA4A4I6AT36ATA
00XA4A4I6ATI6ATA4A4I8R8I6A4A4A4R8Q4A4A4I6AT24A4A00<Z8QTA4A4I
6A400QTI4@8A4A426ATA00@Z4@PI6A4I6A4A4A436ATA0QTR8P0M4A4A6ATI
6ATA6ATI6ATA6ATI6B8R:Q486ATI:R8I6ATI6ATA4A4A6ATA6ATI8R8A6ATA
8R8A6B8R6ATA4A4A6ATA:Q488R8A6B8R4A4A8R8A4A4A6ATI008R8Q426ATI
00HA4A4I6A4R8Q4I6A4I6ATR8Q426ATI01dR8Q4I8R8R8Q4I6ATR8Q4I8R8R
8Q4I6ATR8Q4I8R8R8Q4I6ATR8Q4I6A4Z4@PI8R8A4A4I6A4I6ATR8Q4I8R8R
8Q4I6ATR8Q4I6ATZ4@PI6A4R8Q4I6AT00R8R4@046ATI8R8A:R8I8R8A0QTI
4@8R8Q402aTI4B8R4B8R4ATI6BXR6ATI6B8R4BXR6B8R4ATI4BXR6@028R8A
0RXR6@0::Q486ATI8R8A6ATI:R8I6ATI8R8A4A4A6ATI4A4A0QTI6@<I6A40
128R4ATR8RXR6ATI6@8Z8QT01R8R4ATI4ATI6B8R4ATI6ATI4@8R8Q401bXR
6A4A4BXA214A4@00014A4@0000024A4A00<Z4@PA4A4A4A400Q4A4@03:Q48
00006ATA00<A4A436ATA00/Z4@PI6A4A4A4Z4@PI6A4A4A4Z4@PA4A4R8Q4A
4A4I6A400a4A4@03:Q484A4A4A4A00<A4A42:Q480Q4A4@05:Q486ATA4A4A
:Q486ATA00<A4A401QTI4A4A4ATI4ATI4A4A4C8Z8WO<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h<lc<c0DA4A401@00014A4A4A4A4A4@000005
4A4A00<0000R8Q4A4A40314A4@0400004A4A4A4A00001a4A4@8000094A4A
00DZ4@P00000000A4A4000000Q4A4@0300004A4A4A4A014A4A400`00014A
4ATI6@074A4A00H0000A4A4A4A4I6A4A4A40000E4A4A0QTI4@074A4A6ATI
6ATI6ATA6ATI>SXb6ATI008I6A401ATI6ATI4A4A4B8R4ATI4@024A4A00HI
6ATA4A4A4A4I6ATA4A4Z8QT24A4A00DI6A4I6ATA4A4I6A4A4A4011TI4@8I
6AT24A4A00<I6A4A4A4I6A400Q4A4@046ATI6ATA4A4A:R8I0QTI6@8I6A40
0a4A4ATI4ATI4@036ATA00dI8R8Z4@PI6A4Z8QTI6A4R8Q4A4A4Z8QTI6A4R
8Q4I6A4A4A4I6A400QTI6@068R8A4A4A8R8A8R8A6ATA6ATI0QTI4@8R8Q40
1ATI4ATI6BXA22XR6ATI6@038R8A00DI6ATR8Q4R8Q4Z8QTR8Q400bXR6@05
6B8R8R8A6ATA6ATA:R8I008I6AT2:R8I00@R8Q4I6ATZ4@PI6AT38R8A00TZ
8QTI6ATI6A4R8Q4I6A4Z8QTI6A4R8Q4I8R800R8R4@066ATA:R8I8R8A:R8I
8R8A6ATI1B8R4@0:6ATI8R8A:R8I6ATI:R8I8R8A6ATI6ATA8R8A:R8I11TI
4@03:R8I6ATI8R8A008I6A401RXR6B8R4ATI4BXR6ATI4BXR6@8R8Q402aTI
6BXR6BXR6ATI4B8R4BXA228R4ATI4@00014A4BXA20024A4A0RXA208A4A42
6ATA00DZ4@PA4A4A4A4Z4@PI6A400Q4A4@03:Q484A4A:Q4800@A4A401RXA
214A4A4A4BXA214A4BXA208A4A4012XA214A4A4A4BXA20<A4A400bXA214A
4ATI4@034A4A00<Z4@PA4A4A4A400Q4A4@DI6A428R8A00@I6ATZ8QTI6ATZ
4@Qgc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`64A4A00<0
000A4A4A4A401a4A4@0400004A4A6ATA6ATI1A4A4@036ATI4A4A4A4A00HA
4A426ATI00<A4A40000A4A400Q4A4@036ATA4A4A4A4A00DA4A400`00014A
4A4A4@044A4A00<I6ATA4A4A4A403A4A4@036ATA4A4A4A4A00HA4A400`00
01TI4A4A4@026ATI00<A4A4R8Q4A4A402a4A4@03:Q484A4A4A4A008A4A40
0`0001TI4A4A4@024A4A00<Z4@PA4A4A4A40114A4@0600004A4A4A4A:R8I
4A4A6ATA114A4@046ATI4A4A:R8I4A4A0QTI6@036ATA4A4A6ATA00@A4A40
3QTI6BXR6ATI4B8Z:QTI4ATI6A4A4ATR8QTI4A4A4B8R4A4A4ATI4BXA208A
4A401QTI4ATI6ATI4A4A4B8R4A4A4@<I6A401A4A4ATI4A4A4ATI6BXR6@03
6ATA00TI6ATI6A4I6ATI6ATR8Q4I6ATI6A4R8Q4I6AT00QTI4@036ATI4A4A
6ATI008I6A426ATI01TI6A4I6ATb:R8I6A4Z8QTI6ATR8Q4I6ATZ8QTI6A4I
6ATR8Q4I6A4Z8QTI6ATI6A4R8Q4I6ATR8Q4I6A4I6ATR8Q4I6ATI6A4R8Q40
0QTI4@04:R8I4A4A6ATA8R8A0QTI6@07:Q486ATA6ATI8R8A6ATI8R8A6ATI
008R8Q42:R8I00`R8Q4Z8QTI6A4Z8QTI6A4I6ATR8Q4Z8QTI6A4Z8QTR8Q4I
6AT2:R8I02@I8R8Z8QTI6ATZ8QTR8Q4Z8QTR8Q4Z8QTR8Q4I8R8R8Q4Z8QTI
6ATI6A4A4A4I6A4A4A4I6A4A4A4I6ATR8Q4I6A4Z8QTI6A4I6ATI6A4R8Q4A
4A4I6ATI6A4I6ATR8Q4I6A4I6ATA4A4I6AT24A4A00<0000A4A4A4A400a4A
4@8I6A401BXA214A4A4A4@0002XA20044A4A00<Z4@PA4A4Z4@P00a4A4@06
:Q484A4A4A4A6ATA4A4A:Q481A4A4@06:Q484A4A4A4A6ATA4A4A:Q481Q4A
4@066ATA4A4A4A4A4A4A:Q484A4A0aTI4@088R8A6ATA6ATA4A4A:R8I6ATA
6ATI:Q48Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00D0
000A4A4A4A4A4A4000000a4A4@0300004A4A4A4A00HA4A400aTI6A4A4A4A
4@026ATI1Q4A4@0300004A4A4A4A00@A4A400`00014A4A4A4@024A4A00<0
000A4A4A4A403Q4A4@0400004A4A4A4A00002a4A4@0300004A4A4A4A00PA
4A400`0001TI4A4A4@084A4A00<0000A4A4A4A400a4A4@0400004A4A4A4A
00000a4A4@0500004A4A4A4A6ATA000000hA4A400aTI6A4A4A4A4@024A4A
00@I6A4A4A4A4A4I8R834A4A0QTI6@044A4A6ATA4A4A8RXZ0QTI4@05:Q48
4A4A6ATA:Q484A4A008I6A400a4A4ATI4BXA20024A4A00HI6A4A4A4Z8QTI
6A4A4A4Z8QT26ATA00PA4A4Z8QTI6ATI6ATR8Q4I6A4I6ATb:R826ATA00HR
8Q4I6ATA4A4I6A4I6ATI6A426ATI00TZ8QTZ4@PI6ATI8R8Z8QTI8R8R8Q4I
6ATZ8QT00QTI4@066ATI:Q488R8A6ATA8R8A6ATI0R8R4@0C:R8I6ATA8R8A
6ATI8R8A6ATI8R8A:R8I6ATI8R8A6ATI6ATA8R8A6ATA6ATI8R8A6ATI8R8A
6ATI008R8Q402ATR8QTI6B8R4ATI4B8R4BXR6ATI4BXR6ATI6@028R8A00<I
6ATA4A4R8Q400aTI4@076B8R6ATI8R8A6ATI8R8A:R8I6ATI008Z8QT01R8R
4ATI6BXR6BXR6B8R4ATR8P8R8Q401QTR8Q4A4ATI4A4A4ATI6B8R4@8A4A40
1ATI4BXA21TI4ATI6B8R4@036ATA0QTI6@8R8Q401ATI6BXA21TI4BXA214A
4@026ATA00@Z4@PA4A4I6A4Z4@P54A4A00X0000Z4@PA4A4Z4@PI6A4A4A4Z
4@P0000Z4@PA4A436ATA00DA4A4I6A4Z4@PA4A4Z4@P01A4A4@04:Q484A4A
6ATA:Q480a4A4@0500006ATA4A4A4A4A:Q4800@A4A402RXA21TI4A4A4BXA
214A4BXA214A4ATI4A4A4ATI4@8A4A426ATA0QTI6@038R8Ac<c<c<c<07G<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c0DA4A400aTI6@00
014A4@044A4A00<0000A4A4A4A40114A4@036ATI4A4A4A4A010A4A400aTI
4A4A4A4A4@0:4A4A00D0000A4A40000Z4@P000003Q4A4@0300004A4A4A4A
00@A4A400`00014A4A4A4@0;4A4A00<0000A4A4A4A40114A4@0300004A4A
4A4A00<A4A400`00014A4A4A4@024A4A00<0000A4A4A4A400Q4A4@03:Q48
4A4A4A4A00PA4A401ATI6ATI4ATI6A4A4ATI4@044A4A00DI6ATI6A4A4A4I
6A4A4A400QTI4@074A4A6ATA4A4A4A4A6ATA4A4A6ATA008A4A400aTI4A4A
4A4A4@024A4A0QTI4@074A4A6ATA6ATA6ATA6ATI6ATA4A4A008I6AT042XR
6ATI6ATI6B8Z:Q4A4BXR6B8Z:Q4A4ATI4A4A4B8R4ATI4BXR6ATI6A4A4ATI
6@8I6A402R8R4ATI6ATI4B8R4ATI6B8R4ATI6B8R4ATI6ATI4@<R8Q4041TR
8RXR6CXj<RXR6ATR8QTI6A4A4ATI4ATI6B8R4ATI6ATI4ATI6ATI4B8R4ATI
6@8R8Q400aTI6B8R4B8R4@028R8A00`I6A4R8Q4R8Q4I6ATR8Q4I6ATR8Q4Z
8QTR8Q4I6A4Z8QTR8Q426ATA00<Z8QTA4A4R8Q400QTI6@0A8R8A6ATI8R8A
:Q486ATI8R8A6ATA6ATI:R8I8R8A6B8R:R8I8R8A6ATI8R8A6B8R:R8I00/A
4A428R8A0a4A4@056ATA:R8I6ATA:Q488R8A008I6A400b8R4ATI4ATI4@02
4A4A00@0000A4A4I6A4000024A4A00@Z4@PA4A4A4A4I6A424A4A00<I6A40
000A4A400Q4A4@0:6ATA4A4A:Q4800004A4A:Q4800006ATA4A4A:Q480a4A
4@04:Q486ATA4A4A6ATA0Q4A4@056ATA4A4A4A4A4A4A:Q4800<A4A426ATA
00<Z4@PA4A4I6A400a4A4@8I6A400b8R4ATR8QTI4@048R8A00DI6A4R8Q4R
8Q4I6A4b:R80Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<
00<0000A4A4A4A400Q4A4@0500004A4A4A4A4A4A000000TA4A401ATI4A4A
4A4A4A4A4ATI6@074A4A00<I6A4A4A400000114A4@0300004A4A4A4A00LA
4A400`00014A4A4A4@054A4A00<Z4@PA4A4A4A400a4A4@0300004A4A4A4A
00XA4A400`00014A4A4A4@064A4A00<0000A4A4A4A40114A4@036ATA4A4A
4A4A00LA4A400`00014A4A4A4@024A4A00<Z4@PA4A4A4A401A4A4@030000
4A4A:Q4800<A4A400aTI4A4A4ATI4@024A4A00<I6A4A4A4A4A400a4A4@8I
6AT24A4A00<Z8QTA4A4I6AT00aTI4@8A4A401ATI6ATI4A4A4A4A4B8Z:P03
6ATA00<A4A4Z4@PA4A400QTI4@0=4A4A6ATI6ATA4A4A6ATI6ATA8R8A6ATI
8R8A6ATA8R8A6ATA8R8A00<I6A4012XR6A4A4ATI6B8R4@8I6A400a4A4B8R
4ATI4@026ATA00HI6ATR8Q4I6A4R8Q4I6ATI8R82:R8I00@I8R8I6A4I6ATI
6A426ATI00<R8Q4A4A4I6A400R8R4@03:R8I8R8A:Q4800<I6A400aTI6BXA
21TI6@026ATA00@Z8QTI6A4Z8QTZ8QT26ATA00dI6ATZ8QTI6A4R8Q4Z8QTR
8Q4Z8QTI8R8R8Q4I8R8R8Q4Z8QTI8R800RXR6@038R8A:R8I6ATI008R8Q40
2BXR6B8R4B8R4B8R4ATI6ATI4BXR6BXA22XR6@038R8A00HI6ATR8Q4Z8QTR
8Q4Z4@PI6AT58R8A00<Z8QTR8Q4R8Q400b8R4@056B8R:R8I:R8I:R8I8R8A
008Z8QT00b8b:S8Z8S8Z8P02:Q4800@I6A4A4A4Z4@P000064A4A00HZ4@PA
4A4Z4@P0000A4A4Z4@P64A4A00dI6A4A4A4Z4@PA4A4I6A4Z4@PA4A4Z4@PI
6A4Z4@PA4A4Z4@PI6A400RXA20044A4A:Q48:Q484A4A0bXA208A4A4012XA
21TI4ATI4@0000@A4A426ATA00@A4A4Z8QTZ8QTR8Q42:R8I00PZ4@PR8Q4R
8Q4R8Q4b:R8Z8QTR:RXI6A5gc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^3?<c<`00a4A4@00000000034A4A00<0000A4A4A4A400Q4A4@030000
4A4A4A4A00<A4A400`00014A4A4A4@054A4A00<I6ATA4A4I6A400a4A4@03
00004A4A4A4A00TA4A401000014A4A4A4BXA20DA4A400`00014A4A4A4@02
4A4A00@0000A4A4A4A4000044A4A00<I6ATA4A4A4A40114A4@0300004A4A
000000LA4A400`00014A4A4A4@024A4A00<I6A4A4A4A4A400Q4A4@050000
4A4A00004A4A0000008A4A400`00014A4A4A4@024A4A00@0000A4A4A4A40
000;4A4A00LZ4@P0000A4A40000A4A4I6A4A4A400QTI4@<A4A401ATI6BXR
6A4A4ATI4A4A4@026ATA00<A4A4I6ATI6AT00QTI4@05:Q484A4A4A4A4A4A
:Q48008A4A4011TI4A4A4B8R4BXA20<A4A4021TI6ATI4ATI4A4A4ATI4A4A
4ATI4ATI6@<I6A404b8R4ATI4A4A4ATI6A4A4ATI6BXA228Z:QTR8Q4A4ATI
6BXR6ATI4ATI6ATI4B8R4ATI6ATI4ATI6@028R8A00lI6ATI6A4R8Q4R8Q4Z
4@PZ8QTR8Q4Z8QTI6A4Z8QTI6ATZ8QTI6ATR8Q4I8R800R8R4@04:R8I6ATA
:R8I6ATA12XR6@066ATI8R8A:R8I6ATI:R8I6ATI0R8R4@06<RXR8R8A6B8R
8R8A:R8I<RXR0bXR6@088R8A:R8I:R8I:R8I8R8A:R8I6ATA6ATI1b8R4@03
6ATI8R8A8R8A008Z8QT01B8R4BXR6B8R4BXR6ATR8P028R8A00XI6ATR8Q4I
6ATR8Q4I6ATZ8QTI6ATZ8QTI8R8R8Q43:R8I00HR8Q4b:R8R8Q4b:R8Z8QTI
6A424A4A00<0000A4A4A4A40114A4@05:Q484A4A4A4A:Q480000008I6A40
114A4BXA214A4BXA208A4A42:Q4800<A4A4Z4@PA4A40114A4@07:Q480000
6ATA0000:Q486ATA000000@A4A426ATA0a4A4@0::Q484A4A<RXR8R8A:Q48
4A4A6ATA:Q484A4A:Q480QTI4@05:Q486ATA8R8A:R8I6ATI008Z8QT2<RXR
00DR8Q4Z8QTZ8QTj>R9<8PP0Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Pcc<c<00<0000A4A4A4A400Q4A4@036B8R4A4A4A4A00DA4A400`00
014A4A4A4@0<4A4A00<0000A4A4A4A401A4A4@0300004A4A0000008A4A40
0`00014A4A4A4@034A4A00@0000A4A4A4A40000A4A4A00<0000A4A4A4A40
1Q4A4@0300004A4A4A4A00LA4A400`00014A4A4A4@084A4A00H0000A4A4A
4A40000A4A4000054A4A00D0000Z4@PA4A4A4A4Z4@P01A4A4@038RXZ4A4A
:Q4800@A4A4011TI4A4A4A4A4ATI4@<A4A402QTI4ATI6ATI4ATI4A4A4ATI
4@0002XR6A4A4ATI4@8A4A400aTI4ATI6ATI4@024A4A00TI6ATZ4@PA4A4I
6A4Z4@PA4A4Z4@PA4A4I6AT00QTI4@8A4A400aTI4A4A4A4A4@036ATA00HI
6ATI6A4I6A4I6A4R8Q4I6AT2<RXR00Pj>S8Z4@PI6A4Z8QTI6A4Z8QTI6A4I
8R828R8A00`I6A4Z8QTI8R8Z8QTI6A4I6ATR8Q4I8R8R8Q4I6ATZ8QTI6A43
8R8A00TI8R8Z4@PI8R8R8Q4Z8QTR8Q4Z8QTI6ATR8Q400RXR6@058R8A<RXR
:R8I8R8A6B8R00<Z8QT01c8Z8R8R4BXR6BXR6ATI6C8Z8QTR8P02:R8I00PR
8Q4Z8QTZ8QTI6A4Z8QTR8Q4I8R8R8Q42:R8I00<R8Q4Z8QTZ8QT00RXR6@04
8R8A:R8I8R8A:R8I0R8R4@03:R8I8R8A:R8I00<Z8QT00b8R4BXR6C8Z8P02
8R8A00@b:R8Z8QTb:R8I6A428R8A00TZ8QTI8R8I6A4Z8QTR8Q4I6ATI6A40
000Z4@P01A4A4@03:Q484A4A:Q4800<A4A400`0002XA214A4@024A4A00DZ
4@PI6A4A4A4I6A4Z4@P00Q4A4@056ATA4A4A4A4A4A4A:Q4800<A4A400bXA
21TI4ATI4@024A4A00D0000I6A4Z4@P0000Z4@P01a4A4@080000:R8I6ATA
4A4A:Q484A4A6ATA4A4A0QTI4@064A4A6ATA6ATA4A4A6ATA8R8A0QTI6@07
8R8A6ATA:Q486B8R<RXR8RXZ8R8A07O<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h<lc<c0064A4A000000004A4A8RXZ8S8Z0Q4A4@0300004A4A
000000@A4A400`00014A4A4A4@024A4A00<0000A4A4A4A400Q4A4@040000
4A4A4A4A0000114A4@0300004A4A4A4A020A4A400aTI4A4A4A4A4@0;4A4A
00@I6A4A4A4A4A4000034A4A00<0000A4A4A4A40114A4@0300004A4A4A4A
00LA4A400`00014A4A4A4@064A4A00HI6A4A4A4A4A4I6A40000I6A444A4A
00<I6ATA4A4A4A400Q4A4@066ATA4A4A8R8A4A4A6ATI00000aTI4@038R8A
6ATI8R8A008A4A401aTI4ATI6ATI4ATI6A4A4ATI4A4A4@026ATA0Q4A4@8I
6A400a4A4ATI4ATI4@026ATA0QTI6@0C6ATA8R8A6ATA6ATA8R8A6ATA:R8I
4A4A8R8A6ATI8R8A6ATI6ATA8R8A6ATA6ATI:R8I6ATI8R8A00<Z8QT00aTR
8RXR6ATI6@02:R8I00LI6ATR8Q4I8R8I6ATI8R8I6ATZ8QT011TI6@068R8A
6ATI8R8A6ATI8R8A6ATI0bXR6@078RXZ:R8I:R8I:R8I6B8R:R8I8R8A008Z
8QT0138Z8QTI6C8Z8R8b:P@Z8QT00c8Z8RXR6ATI6@02:R8I00Db:R8R8Q4R
8Q4Z8QTb:R800b8R4@07:R8I8R8A8R8A8R8A6ATA8R8A:R8I008R8Q400aTR
8RXR6ATI6@026ATA00<Z4@PI6A4I6A400aTI4@048R8A6ATA4A4A:Q480Q4A
4@80000022XA214A4@00014A4BXA2000014A4ATI4@TA4A401BXA214A4A4A
4A4A4BXA20026ATA0Q4A4@09:Q484A4A6ATA:Q4800004A4A:Q484A4A:Q48
008A4A42:Q4800H0000I6A40000Z4@PA4A4Z4@P24A4A00<Z4@PA4A4A4A40
0a4A4@8Z4@P00a4A4BXA21TI4@034A4A00HZ4@PA4A4Z4@PI6A4A4A4Z4@P2
6ATA00`Z4@PR8Q4R8Q4I8R8Z4@PI6A4R8Q4I6ATR8Q4I6A4Z8QTI6A5gc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`01@00014A4@00014A
4B8R4@0<4A4A00<0000A4A4A4A40;Q4A4@036ATA4A4A4A4A00TA4A401ATI
4A4A4A4A4A4A4@0000074A4A00D0000A4A40000A4A4000000a4A4@030000
4A4A0000008A4A400`00014A4A4A4@064A4A00@I6A4A4A4A4A4000064A4A
00<Z4@PI6A4A4A40214A4@036ATA4A4A6ATA00<I6A403Q4A4B8R4ATI4A4A
4BXA214A4ATI4A4A4ATI6A4A4ATI4A4A4ATI4A4A4@<I6A402A4A4ATI4ATI
6ATI6B8R4BXR6B8R4ATI6ATI4@028R8A018I6ATR8Q4Z8QTI6A4R8Q4Z8QTI
6ATZ8QTI6A4Z8QTI6A4Z8QTR8Q4I6ATR8Q4I8R8I6ATZ8QT26ATI00@Z8QTR
8Q4I6ATI6AT38R8A00`Z8QTR8Q4Z8QTR8Q4Z8QTA4A4R8Q4I8R8Z8QTI8R8R
8Q4R:RX38R8A0RXR6@056ATI:R8I6B8R:R8I8R8A008Z8QT01ATR8RXR6BXR
6BXR6ATR8P03:R8I00LR8Q4Z8QTZ8QTZ8QTj>R8Z8QTj>R800S8Z8P068R8A
6ATA8R8A00004A4A6ATI114A4@03:Q4800004A4A008A4A4012XA2000014A
4BXA20<A4A403BXA214A4BXA21TI4@00014A4@00014A4BXA214A4BXA21TI
4@0000074A4A00TI6A4A4A4Z4@PA4A4Z4@P0000A4A4Z4@P000000Q4A4@04
6ATA4A4A8R8A4A4A0QTI4@DA4A401RXA21TI4@00014A4BXA21TI4@@A4A40
12XA21TI4ATI4BXA208A4A401RXA21TI4A4A4BXA214A4BXA20HA4A4012XA
21TI4A4A4ATI4@@A4A436ATA00DZ4@PI6A4R8Q4R8Q4I6A400R8R4@056ATI
6ATA8R8A8RXZ8R8A07O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
<lc<c0044A4A00004A4A0000114A4@0300004A4A0000008A4A400`00014A
4A4A4@024A4A00<0000A4A4A4A401Q4A4@056ATA4A4A4A4A4A4A0000008A
4A400`00014A4A4A4@044A4A00<I6A4A4A4A4A403A4A4@0500004A4A4A4A
4A4A6ATA00HA4A400`00038Z8QTR8P024A4A00@I6ATA4A4A4A4000054A4A
00@0000A4A4A4A4000064A4A00<I6ATA4A4A4A401a4A4@0300004A4A4A4A
00<A4A400`00014A4ATI4@034A4A00DZ4@PA4A4A4A4Z4@P000000Q4A4@0>
6ATA4A4A4A4A6ATI6ATA4A4A8R8A4A4A6ATA4A4A:Q486ATA4A4A6ATA0QTI
6@0300008R8A6ATA008A4A406BXA214A4ATI4A4A4ATI4B8R4ATI4B8R4ATI
4A4A4BXA214A4B8R4ATI6ATI4BXR6ATI4B8R4ATI6ATI4ATI6B8R4ATI6B8R
4ATR8P028R8A00<I6ATZ4@PI6AT00R8R4@086ATI:R8I6ATA6ATA:R8I6B8R
8R8A6B8R0R8R4@06:R8I6B8R8R8A:R8I6ATI:R8I0b8R4@06:R8I6ATI6ATA
6ATI6B8R6ATI1BXR6@048R8A:R8I:R8I6ATI0bXR6@03<RXR:R8I:R8I00<Z
8QT00b8b:RXR6BXR6@04:R8I00<R:RXR8Q4Z8QT00R8R4@05:R8I<RXR<RXR
8R8A6ATA00HA4A42000000DZ4@PA4A4Z4@PA4A4000000QTI4@hA4A400aTI
4A4A4A4A4@0200000a4A4@036ATA4A4A4A4A008A4A401BXA214A4A4A4@00
01TI4@064A4A00<Z4@PA4A4Z4@P00Q4A4@046ATA00006ATA:Q481Q4A4@0?
6ATA4A4A0000:Q486ATA:Q4800006ATA4A4A00006ATA4A4A:Q484A4A0000
00@A4A401BXA214A4A4A4ATI4B8R4@026ATA0RXA20084A4A:Q484A4A8R8A
4A4A6ATA:Q486ATA0R8R4@056ATA8R8A8R8A6ATA8R8A00<I6A400aTI6B8R
4Lc<c01fc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`01000
014A4@00000000HA4A400aTI6ATR8Q4A4@074A4A00<0000I6ATA4A401A4A
4@0300004A4A4A4A00/A4A400aTI4A4A4A4A4@044A4A00D0000A4A4A4A4A
4A400000414A4@8000000a4A4@00014A4@0A4A4A0P0000044A4A00004A4A
00000QTI4@<A4A401@00014A4@00014A4@0000024A4A00<0000A4A4A4A40
1a4A4@03:Q484A4A4A4A008I6A444A4A00@0000A4A4A4A4A4A436ATA00DA
4A4R8Q4A4A4Z8QTZ4@P00QTI6@8I6A4011TI6A4A4ATI6B8Z:P8I6A438R8A
00LI6ATI6A4I6ATR8Q4I6A4R8Q4I6AT011TI4@0D4A4A8R8A:R8I6ATI6ATA
6ATI8R8A6ATI8R8A:R8I6ATA:R8I8RXZ:Q488R8A6ATI:R8I6B8R:R8I6ATI
0R8R4@076B8R:R8I6ATA:R8I8R8A6B8R8R8A008Z8QT00b8R4BXR6BXR6@04
:R8I00<R8Q4I8R8R8Q400bXR6@046B8R:R8I<RXR:R8I0S8Z8P0::R8I8RXZ
:R8I:R8I8RXZ8R8A:R8I8R8A<RXR6B8R0bXR6@0;<RXR:R8I:R8I<RXR0000
4A4A0000:Q484A4A:Q480000008A4A404bXA214A4A4A4@00014A4BXA214A
4@0001TI4A4A4BXA21TI4A4A4BXA214A4BXA200002XA200000044A4A00<0
000I6A4A4A400Q4A4@08:Q484A4A4A4A0000:Q480000:Q4800001A4A4@04
:Q484A4A6ATA4A4A0RXA20030000A3XZ000000DA4A400`0002XA214A4@03
4A4A00@0000I6A4A4A4000024A4A00<I6A4A4A4A4A400RXA20034A4A:Q48
4A4A008A4A401RXA214A4A4A4BXA214A4BXA20<A4A436ATA00LZ4@PI6A4Z
4@PI6A4Z4@PI6A4Z4@P00aTI4@8R8Q400a4A4ATI4B8R4@026ATA00<Z8QTI
6ATZ4@P0Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00HA
4A40000A4A40000A4A40000<4A4A00<0000A4A4A4A402a4A4@0300004A4A
4A4A00DA4A400aTI4@00014A4@0:4A4A00@I6A4A4A4A4A4I6AT94A4A00<0
000A4A4A4A401a4A4@0300004A4A4A4A008A4A401000014A4A4A4@00008A
4A401000014A4A4A4@0000TA4A400`00014A4A4A4@084A4A00H0000A4A4A
4A4A4A40000A4A436ATA00<0000A4A4A4A400a4A4@056ATI4A4A:Q486ATA
4A4A008I6A403ATI6A4A4BXA214A4B8R4BXR6ATI4ATI6ATI4ATI6ATI4B8R
4A4A4@026ATI00DI6A4I6ATI6A4I6A4I6AT011TI4@<A4A4021TI6B8R4B8R
4B8R4ATI6BXR6B8R4ATI6@@R8Q402QTI6ATI4ATI4B8R4BXR6B8R4ATR8R8R
4BXR6ATI6@8Z8QT05aTI6ATR8RXR6ATI6B8R4ATI6B8R4BXR6B8R4ATR8RXR
6ATI6B8R4BXR6ATR8R8R4BXR6ATR8R8R4ATR8RXR6ATR8R8R4@03:R8I00<R
8Q4Z8QTR<RX00bXR6@076ATA:Q486ATI8R8A:R8I8R8A6B8R00<Z8QT01c8Z
8QTI4A4A4B8R4@00014A4ATI4@054A4A0QTI4@@A4A400bXA214A4A4A4@04
4A4A00H0000A4A4A4A40000I6A4000034A4A00LZ4@PA4A4I6A4Z4@PR8Q40
000Z4@P0214A4@03:Q486ATA:Q4800DA4A4011TI4@00014A4ATI4@@A4A42
:Q48114A4@0500006ATA:Q484A4A:Q48008A4A401QTI4A4A4BXA214A4@00
02XA20<A4A4012XA2000014A4BXA208A4A426ATA00<A4A4Z4@PA4A400Q4A
4@05:Q484A4A6ATA4A4A6ATA008R8Q4011TI6B8R4B8R4ATI4@<R8Q400aTI
4B8R4B8R4@026ATI00DR8Q4I6ATI6A4I6A4A4A40Mlc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Pcc<c<0Q4A4@0500004A4A4A4A4A4A6ATI00TA
4A401@00014A4A4A4A4A4ATI6@034A4A00<I6ATA4A4A4A403Q4A4@06<RXR
4A4A4A4A4A4A6ATA0000314A4@036ATA00006ATI00<A4A400aTI4A4A4A4A
4@0:4A4A0P0000HA4A402000014A4@000000014A4@00014A4@0000DA4A40
0`00014A4@0000024A4A00D0000A4A40000Z4@P00000114A4@0500004A4A
4A4A4A4A000000<A4A401BXA214A4A4A4BXA214A4@036ATA00@Z4@PA4A4Z
4@PI6A424A4A00@I6A4A4A4I6A4A4A426ATA0R8R4@036ATA8R8A4A4A008Z
4@P24A4A0aTI4@034A4A6ATI4A4A00@A4A400b8R4@0001TI4@026ATI00d0
000I6A4A4A4I6A4R8Q4I6ATA4A4I6A4Z8QTR8Q4I6A4R:RXI6A400R8R4@05
6B8R8R8A8R8A6B8R:R8I008R8Q400aTI6BXA22XR6@036ATA00/Z8QTI6ATR
8Q4Z8QTI6A4R8Q4Z8QTI8R8R8Q4Z8QTI6A400bXR6@048R8A:R8I8R8A8RXZ
0bXR6@8I6A438R8A00/R:RXZ8QTZ8QTjA1TZ4@Pj>R8R<RXI6A4Z4@PI6A40
00000Q4A4@0800004A4A6ATA00004A4A6ATA00006ATA0a4A4@0;00004A4A
4A4A4A4A0000:Q480000:Q486ATA:Q488R8A008Z8QT05B8R4CY46B8R4ATI
4CXj8RXR6C8Z8R8R4ATI6BXR6B8R4CXj8R8R4BXR6A4A4@0002XA214A4@00
014A4@0000034A4A00HZ4@PI6A4A4A4A4A4I6A4000024A4A00<Z4@PA4A4A
4A40114A4@09:Q486ATA6ATA00006ATA4A4A6ATA4A4A6ATA008A4A400bXA
21TI4A4A4@034A4A00DZ4@PI6A4A4A4Z4@PI6A400RXA200>6ATA4A4A:Q48
6ATA:Q484A4A:Q484A4A:Q484A4A:Q488R8A00006ATA0R8R4@036ATI8R8A
4A4A008I6A400b8R4A4A4ATI6@028R8A00<A4A4R8Q4Z8QT00S8Z8WO<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c00400004A4A4A4A0000
214A4@036ATI4A4A4A4A00DA4A402000014A4A4A4A4A4ATI6A4A4@0001TI
6@DA4A400aTI6A4A4ATI6@0<4A4A00@I6A4A4A4A4A4I6AT24A4A00@0000I
6A4A4A4I6A4:4A4A00<0000A4A4A4A400Q4A4@0400004A4A4A4A00000a4A
4@0300006ATA0000008A4A400`00014A4A4A4@064A4A00@0000A4A4A4A40
00024A4A00D0000A4A40000A4A4000000Q4A4@0600004A4A4A4A00004A4A
00001Q4A4@08:Q484A4A4A4A6ATA4A4A6ATA:Q484A4A0QTI6@0=4A4A6ATA
4A4A6ATA6ATI6ATA8R8A6ATI8R8A6ATA:R8I6ATI8R8A00<A4A400bXA214A
4ATI4@024A4A00DZ4@PA4A4I6A4I6A4Z8QT00RXA20044A4A6ATA6ATA8R8A
0aTI4@058R8A6ATA6ATA6ATA8R8A008I6AT01RXR6B8R4ATI6B8R4BXR6ATI
6@8Z8QT051TI4BXA23Xj<QTI4B8R4BXR6ATI4BXR6B8R4ATI6B8R4ATI6BXR
6B8R4ATI6B8R4ATI4ATR8RXR6ATI4@8R8Q400bXR6ATR8R8R4@02:R8I00TR
8Q4I8R8Z8QTI8R8R8Q4b:R8I6A4R:RXR8Q400bXR6@09<RXR:R8I:R8I:R8I
8R8A<RXR4A4A00006ATA00TA4A401BXA2000014A4A4A4@0000024A4A00HZ
4@PI6A4R8Q54>RXb:R8R:RX3<RXR00<I6A4R8Q4I6AT00b8R4@07:R8I8R8A
8R8A:Q48:R8I8R8A<RXR008R8Q40138Z8RXA228R4BXA208A4A426ATA00@Z
4@PA4A4A4A4Z4@P24A4A00D0000Z4@P0000A4A4Z4@P00Q4A4@05:Q484A4A
:Q484A4A:Q4800<A4A402@0002XA214A4ATI4BXA2000014A4ATI4BXA2003
4A4A014Z4@PA4A4R8Q4Z4@PI6A4A4A4Z4@PA4A4R8Q4A4A4I6A4A4A4Z4@PA
4A4I6A4R8Q4Z4@P00QTI4@058R8A6ATA:Q486ATA6ATI008R8Q426ATA00PR
8Q4I6A4Z8QTA4A4R8Q4A4A4Z4@PI6A44<RXR00<j>R8jA1W<c<`0M/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00@0000A4A400000000<
4A4A00@I8R8A4A4A4A4A4A426B8R00<I6ATA4A4A4A400QTI6@<A4A400aTI
6A4A4A4A4@034A4A00<I6ATA4A4A4A401a4A4@036ATI4A4A4A4A008I6AT0
0a4A4ATI6A4A4@054A4A00<I6A4A4A4A4A403A4A4@0300004A4A4A4A00<A
4A401000014A4A4A4@0000<A4A402@00014A4@00014A4@00014A4@00014A
4@0000024A4A00@0000A4A4A4A4Z4@P44A4A00<0000A4A4000000a4A4@03
:Q4800006ATA00XA4A400aTI4@0001TI4@036ATA00DI6ATI6A4I6ATA4A4I
6A400Q4A4@<I6A4011TI6BXA214A4A4A4@<I6A4011TI6B8R4BXA21TI4@8R
8Q401ATI6ATI4ATI4BXR6ATI4@026ATI0QTI4@048R8A:R8I6ATI8R8A0QTI
6@0>8R8A:R8I8R8A6ATI8R8A:R8I:Q486ATA8R8A6ATI8R8A8S8Z:R8I6ATI
0b8R4@036B8R6ATI8R8A008Z8QT00aTR8QTI4BXR6@04:R8I00@R<RXZ8QTI
6ATR8Q43:R8I00<R:RXR8Q4R8Q401RXR6@<b:R800cY46BXR6B8Z:P024A4A
00<0000A4A4A4A40114A4@056ATA:Q484A4A4A4A:Q4800HA4A4012XA21TI
4C8Z8TA4<P<b:R80128Z:QTI4ATI4B8R4@8I6A458R8A00DZ8QTb:R8b:R8Z
4@PI6A400R8R4@8A4A401`0001TI4A4A4A4A4BXA214A4@0000024A4A00<Z
4@PA4A4A4A400Q4A4@036ATA:Q484A4A008I6A4012XA200001TI4BXA20<A
4A401QTI4A4A4ATI4ATI4A4A4ATI4@8A4A400bXA214A4A4A4@02:Q4800<A
4A4I6A4Z4@P00QTI4@038R8A:Q484A4A008I6A400bXA21TI4BXR6@024A4A
00DZ4@PA4A4I6A4Z4@PI6A400R8R4@056ATI8R8A:Q48:Q486ATI008R8Q40
2A4A4B8R4BXA22XR6C8Z8RXR6C8Z8T@j:S8Z8P02:R8I00<b:R8j>R8Z4@P0
Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00@A4A40000A
4A4000094A4A00HI6ATA4A4A4A4R:RXA4A4I8R824A4A00<I6ATA4A4I6AT0
114A4@046ATI4A4A4A4A6ATI0a4A4@036ATI4A4A4A4A008A4A400aTI6A4A
4A4A4@044A4A00<I6A4A4A4A4A400a4A4@036ATI4A4A4A4A008I6A424A4A
0QTI4@/A4A400`00014A4A4A4@034A4A00D0000A4A4A4A4A4A4000000a4A
4@0300004A4A4A4A00LA4A401000014A4A4A4@00008A4A401P00014A4A4A
4BXA214A4ATI4@<A4A42000000@A4A40000Z4@PI6AT34A4A00@Z4@PI6A4A
4A4Z4@P24A4A00HZ4@PA4A4R8Q4I6A4A4A4I6A426ATI00PI6A4A4A4A4A4I
6A4R8Q4I6A4R8Q4Z4@P26ATA00<R8Q4A4A4R8Q400QTI4@0@8R8A6ATA6ATA
6ATA6ATI6ATA8R8A6ATI6ATA:R8I6ATA:R8I6ATA:R8I6ATI6ATA0R8R4@03
6ATI8R8A6ATI00<R8Q4011TI6B8R4ATI6BXR6@8R8Q402bXR6B8Z:QTR8RXR
6ATR8RXR6ATR8RXR6B8R4ATI6B8R4@03:R8I00@I8R8Z8QTR8Q4I6AT2:R8I
00DI8R8Z8QTZ8QTZ8QTR8Q400RXR6@04<RXR8R8A:R8I8S8Z0RXR6@088RXZ
:R8I:R8I8R8A:Q488R8A4A4A:Q480a4A4@0<:Q484A4A4A4A:Q484A4A6ATA
00004A4A:Q4800004A4A00000a4A4@07:Q48:R8IA4@b>T@I:Q488R8A:R8I
008R8Q401aTI4B8R4B8R4ATI6BXR6BXA21TI4@028R8A00@I6A4Z8QTZ4@PR
8Q426ATA0Q4A4@03:Q484A4A:Q48008I6A400bXA21TI4ATI4@024A4A0RXA
20036ATA4A4A:Q4800@A4A403RXA200002XA21TI4A4A4ATI4A4A4BXA214A
4BXA214A4BXA21TI4BXA208A4A403bXA214A4BXA228R4ATI4BXA214A4BXA
21TI4A4A4BXA21TI4BXA21TI4BXA20028R8A00HA4A4Z4@PZ4@PR8Q4I6A4R
8Q426ATA0b8R4@036ATA8R8A6ATI00<I6A40228R4ATI4B8R4BXR6ATR8RXR
6B8R4BXR6@8I6A426ATI00@R8Q4Z8QTI6A4A4A5gc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^3?<c<`01@00014A4@00014A4@0000064A4A00@I
6AT0000I6ATA4A466ATI2A4A4@056ATI4A4A4A4A4A4A6ATI00XA4A400aTI
4A4A4A4A4@034A4A00HI6ATA4A4A4A4A4A4I6AT000034A4A00<0000A4A40
00000Q4A4@0300004A4A4A4A00LA4A400`00014A4@0000024A4A00@0000A
4A4A4A4A4A4200000Q4A4@0700004A4A4A4A4A4A00004A4A000000<A4A40
1000014A4A4A4@00008A4A401`00014A4@0001TI4@00014A4@0000034A4A
0P00008A4A400bXA214A4ATI4@024A4A00<I6A4A4A4A4A401A4A4@076ATI
4A4A8RXZ00006ATI8R8A4A4A008I6A434A4A00LZ4@PA4A4A4A4A4A4I6A4A
4A4I6AT00QTI4@0::Q486ATA8R8A8R8A6ATI6ATA4A4A6ATA6ATI4A4A0QTI
4@07:Q486ATA:R8I6ATI8R8A6ATI8R8A008I6AT00b8R4BXR6ATI6@028R8A
00@Z8QTI8R8R8Q4R8Q43:R8I00<R8Q4Z8QTR8Q400RXR6@088RXZ8R8A:R8I
8R8A<RXR6B8R:R8I<RXR0RXR6@8j>R802C8Z8RXR6B8R4C8Z8R8R4BXR6C8Z
8RXR6ATI4@028R8A0QTI4@@A4A400`00014A4BXA20026ATA00DA4A4I6A4A
4A4A4A4Z4@P01a4A4@076ATA6ATI<RXR:R8I0000<RXR8R8A00<Z8QT28R8A
00/Z8QTI8R8Z8QTZ4@PR8Q4A4A4Z4@PR8Q4I6A4Z4@PI6A400Q4A4@09:Q48
4A4A:Q4800004A4A6ATA00006ATA000000<A4A400bXA214A4A4A4@024A4A
00<Z4@PA4A4Z4@P00RXA20034A4A6ATA6ATA008A4A400bXA21TI4ATI4@03
6ATA00DA4A4I6A4A4A4A4A4Z4@P00aTI4@074A4A6ATA6ATA:Q486ATA4A4A
:Q48008R8Q40114A4BXA228R4BXA208I6A4012XA228R4ATI4B8R4@8I6A40
1bXA214A4ATI4ATI4B8R4ATI4B8R4@036ATA00lR8Q4I6A4R8Q4I6A4R8Q4I
6A4R8Q4I6A4R8Q4I6A4A4A4Z4@PA4A4I6A4I6AT00QTI4GO<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h<lc<c0<A4A401@00014A4A4A4ATI6ATI
4@044A4A00<I6ATA4A4I6AT00Q4A4@036ATI00004A4A008A4A4011TI6A4A
4A4A4ATI6@<A4A4011TI6A4A4A4A4ATI6@DA4A400aTI6A4A4ATI6@064A4A
00<I6A4A4A4A4A402A4A4@0300004A4A4A4A00HA4A400`00014A4@000002
4A4A00<0000A4A4A4A400Q4A4@0500004A4A4A4A4A4A000000<A4A401000
014A4@00014A4@<00000114A4@00014A4@00008A4A401P00014A4A4A4@00
014A4@00008A4A400`00014A4A4A4@024A4A0`0000@A4A400aTI4A4A4A4A
4@034A4A00XI6A4Z4@PA4A4I6A4Z4@PA4A4I6ATI6A4A4A4Z4@P64A4A0QTI
4@084A4A6ATA:Q48:Q484A4A6ATA:Q484A4A0QTI4@8A4A4021TI4B8R4ATI
4BXA21TI4BXA21TI4BXA20<I6A401B8R4ATI4BXR6B8R4ATR8P028R8A00PI
6ATR8Q4R8Q4R8Q4I6ATR8Q4Z8QTI8R868R8A00DZ8QTR8Q4b:R94>RXI6A40
0R8R4@046ATA6ATI:R8I8RXZ0R8R4@0?6ATA8R8A4A4A4A4A6ATA4A4A:Q48
00004A4A0000:Q484A4A00006ATA000000@A4A402ATI4A4A4A4A4A4A4@00
014A4@0001TI4@0000024A4A00<0000I6A4A4A400a4A4@036ATA:Q488R8A
008R8Q436ATA00<R8Q54A38b:R800R8R4@05:Q488R8A4A4A8R8A6ATA00<A
4A400aTI4A4A4BXA20024A4A00l0000A4A4A4A4A4A4Z4@PA4A4I6A4A4A4I
6A4A4A4Z4@PZ8QTA4A4I6A4Z4@P00Q4A4@036ATA4A4A4A4A00@A4A403QTI
4A4A4A4A4ATI4A4A4ATI4A4A4BXA238Z8QTI4BXA21TI4A4A4ATI4@8A4A42
:Q480Q4A4@066ATA:Q48:Q484A4A0000:Q480a4A4@0<6ATA:Q486ATA:Q48
4A4A:Q484A4A:Q484A4A:Q486ATA8R8A11TI4@0:8R8A:Q486ATA:Q486ATA
:Q484A4A8R8A6ATA8R8A0aTI4@068R8A6ATA6ATI6ATA:R8I8R8AMlc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00PA4A4000000000000A
4A40000I6ATZ8QT54A4A00<I6ATA4A4A4A400Q4A4@036ATI4A4A4A4A008A
4A4021TI6A4A4@0001TI6A4A4ATI6A4A4ATI6@@A4A400aTI6A4A4A4A4@02
4A4A00@I6ATA4A4A4A4I6AT;4A4A00<0000A4A4A4A40214A4@036ATI4A4A
4A4A00XA4A400`00014A4@0000034A4A00<0000Z4@PA4A40114A4@060000
4A4A4A4A00004A4A00000a4A4@0300004A4A4A4A00<A4A401000014A4A4A
4A4A4@8000024A4A0P0000054A4A6ATA4A4A4A4A:Q4800<A4A426ATA0a4A
4@0:6ATI4A4A4A4A4A4A6ATA:Q484A4A6ATA8R8A:Q480a4A4@03:Q484A4A
6ATA00<A4A401ATI4BXA21TI4A4A4BXA20034A4A00<Z4@PA4A4A4A400a4A
4@08:Q484A4A:Q486ATA:R8I6ATA8R8A:Q480QTI4@0;:Q486ATA4A4A6ATA
:Q4800006ATA:Q486ATA4A4A6ATA00TA4A400`0001TI4BXA20044A4A0QTI
4@034A4A:Q484A4A008A4A400aTI4A4A4BXA20054A4A00DZ4@PA4A4A4A4Z
4@P000001A4A4@03:Q484A4A4A4A00@A4A401@0002XA214A4@0002XA2003
4A4A00<0000I6A4Z4@P00Q4A4@0<00004A4A00004A4A:Q484A4A6ATA4A4A
00006ATA4A4A:Q480a4A4@04:Q484A4A6ATA:Q48114A4@0300006ATA:Q48
008A4A400aTI6BXA214A4@024A4A00DZ4@PA4A4A4A4I6A4A4A400RXA208A
4A42:Q4800<I6A4Z4@PA4A400a4A4@036ATA00004A4A008I6A42:Q480a4A
4@8Z4@P0100001TI4A4A4A4A4@8Z4@P00a4A4BXA214A4@084A4A0QTI4@08
8R8A6ATA6ATA:Q484A4A8R8A6ATI8R8A1QTI4@056ATI6ATA6ATA8R8A4A4A
008R8Q400bXR6C8Z8QTI4@1gc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^3?<c<`0114A4@00014A4@0000HA4A426ATI00<A4A4I6ATI6AT02Q4A
4@036ATI4A4A6ATI00DA4A400aTI4A4A4A4A4@074A4A00<I6A4A4A4I6A40
0Q4A4@036ATI00004A4A00HA4A400`00014A4A4A4@034A4A00@0000Z4@PA
4A4Z4@P24A4A00@0000A4A4A4A4000034A4A00<0000A4A4A4A40114A4@03
00004A4A4A4A00<000001A4A4@00014A4A4A4@0000024A4A00@0000A4A40
000A4A42000000@A4A40000I8R8000044A4A00D0000A4A4A4A40000A4A40
0`0000DA4A400bXA21TI4A4A4@044A4A00DI6A4A4A4I6A4A4A4000000Q4A
4@0300004A4A000000<A4A401ATI4@00014A4A4A4BXA20094A4A00@0000A
4A40000Z4@P64A4A00D0000A4A4I6A4A4A4000000Q4A4@0900004A4A0000
4A4A6ATA00006ATA4A4A000000TA4A401ATI4A4A4ATI4@0002XA20044A4A
00DI6A4A4A4A4A4Z4@PI6A402A4A4@036ATA0000:Q4800@A4A400bXA214A
4A4A4@024A4A00DZ4@PA4A4A4A4Z4@PI6A402A4A4@0500004A4A6ATA:Q48
6ATA008A4A426ATA00<A4A4Z4@PA4A401Q4A4@096ATA4A4A6ATA6ATA4A4A
:Q486ATA:Q484A4A008I6A4012XA214A4A4A4B8R4@8I6A434A4A00TZ4@PA
4A4Z4@PR8Q4I6A4R8Q40000Z4@PI6A400a4A4@03:Q484A4A4A4A008A4A40
2BXA21TI4A4A4BXA21TI4A4A4BXA214A4BXA20034A4A00DZ4@PA4A4Z4@PI
6A4A4A400QTI4@8A4A401RXA21TI4BXA21TI4B8R4ATI4@<R8Q4011TI4B8R
4ATI6ATI4@8R8Q400bXA21TI4BXA20026ATA00@A4A4Z4@PI6A4I6A428R8A
00LI6A4b:R8R8Q4Z8QTR8Q4I6ATR8Q40Mlc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Pcc<c<00@A4A40000A4A4000024A4A00<I6ATA4A4A4A40
0a4A4@046ATI4A4A4A4A4A4A0QTI6@<A4A446ATI2a4A4@036ATA4A4A4A4A
00<A4A400`00014A4@0000074A4A00<I6A40000A4A401A4A4@0300004A4A
4A4A00`A4A401`00014A4A4A4A4A4@00014A4@0000024A4A00P0000A4A4A
4A40000A4A40000A4A4000024A4A00<0000A4A4000000Q4A4@040000:Q48
00004A4A0RXR6@0500004A4A4A4A0000:Q48008A4A400`00014A4ATI4@03
4A4A00<0000A4A4A4A400Q4A4@0300006ATA000000<A4A400`00014A4@00
00034A4A00<0000A4A4A4A400a4A4@0500004A4A00004A4A000000<A4A40
1@00014A4@0002XA200000064A4A00D0000A4A4A4A4A4A4000000Q4A4@03
:Q484A4A000000<A4A400`00014A4BXA20024A4A00<I6A4A4A4A4A400a4A
4@03:Q484A4A:Q4800LA4A402bXA21TI4ATI4A4A4BXA214A4ATI4A4A4ATI
4A4A4@0000034A4A00TZ4@PI6A4A4A4A4A4Z4@PI6A4Z4@PI6A4A4A400QTI
4@064A4A:Q484A4A4A4A6ATA4A4A0QTI4@8A4A400aTI4A4A4A4A4@044A4A
00@I6A4A4A4A4A4I6A444A4A00D0000I6A4A4A4I6A4Z4@P00a4A4@096ATA
4A4A:Q48:Q486ATA:Q484A4A6ATA:Q4800@A4A4011TI4A4A4ATI4ATI4@8A
4A42:Q480a4A4@03:Q484A4A6ATA008I6A424A4A0QTI4@034A4A:Q484A4A
00<I6A401A4A4ATI4BXA21TI4BXA20024A4A00DZ4@PI6A4I6A4A4A4R8Q40
0RXA20@A4A403BXA21TI4A4A4BXA22XR6A4A4BXA21TI4B8R4ATI4BXA21TI
4B8R4@026ATA00LR8Q4I6A4I6ATI6A4Z4@PR8Q4I6AT01ATI4@04:Q486ATA
4A4A8R8A0RXR6@04<RXR8S8Z:R8I6ATI0R8R4@038S8Z6ATAc<c<07K<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c00500004A4A4A4A4A4A
000000LA4A4011TI6A4A4A4A4ATI6@@A4A400aTI6A4A4A4A4@024A4A00DI
6ATA4A4A4A4A4A4I6AT01a4A4@036ATI4A4A4A4A00/A4A426ATA1Q4A4@03
00004A4A4A4A00HA4A401ATI4A4A4A4A4A4A4@00000:4A4A00D0000A4A40
0000000Z4@P01A4A4@0300004A4A4A4A00<A4A400`00014A4@0000024A4A
00Db:R8A4A4A4A4A4A4Z4@P0114A4@04>SXb00004A4A00001Q4A4@056ATA
4A4A4A4A4A4A000000DA4A402@00014A4A4A4A4A4@00014A4@00014A4@00
00034A4A00<Z4@PA4A400000114A4@0300004A4A4A4A008A4A400`00014A
4A4A4@024A4A00@I6A4A4A4A4A4Z4@P54A4A00<Z4@PA4A4Z4@P01a4A4@03
:Q484A4A:Q4800<A4A401QTI4A4A4ATI4BXA214A4ATI4@<A4A426ATA114A
4@06:Q486ATA:Q48:Q484A4A:Q480Q4A4@046ATA4A4A4A4A6ATA1A4A4@04
:Q484A4A:Q48:Q480Q4A4@04:Q484A4A6ATA:Q480a4A4@03:Q486ATA4A4A
00@A4A400bXA214A4A4A4@024A4A00<Z4@PA4A4Z4@P00a4A4@038R8A4A4A
4A4A008I6A402Q4A4ATI4A4A4BXA214A4ATI4BXA214A4ATI4BXA208A4A40
0aTI4A4A4A4A4@036ATA0Q4A4@036ATA:Q484A4A008A4A426ATA00PZ4@PA
4A4A4A4I6A4A4A4I6A4A4A4Z4@P24A4A11TI4@03:Q484A4A4A4A00LA4A42
:Q4800<A4A4Z4@PA4A400QTI4@054A4A6ATA8R8A:Q484A4A008I6A401BXR
6ATI4B8R4A4A4ATI4@034A4A0aTI4@038R8A:Q486ATA00DI6A401RXR6ATR
8RXR6ATR8RXA214A4@8I6A424A4A00<0003<c<c<c<`0MLc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Pcc<c<00D0000A4A4A4A4A4A4000001Q4A
4@066B8R4A4A4A4A6ATI4A4A6ATI0Q4A4@046ATI4A4A6ATI4A4A0QTI6@DA
4A400`00014A4A4A4@034A4A00@0000A4A4A4A4I6AT:4A4A00D0000A4A40
000A4A4000000Q4A4@0700004A4A4A4A:Q4800004A4A0000008A4A400`00
014A4@0000064A4A00P0000A4A400000000A4A40000Z4@P000034A4A00@0
000A4A40000A4A4300000Q4A4@D000024A4A00@0000A4A4A4A4000034A4A
00D0000Z4@P0000b:R8R<RX00a4A4@8000000bXA21TI4BXA20054A4A0P00
008A4A400`00014A4A4A4@024A4A00D0000A4A4A4A4Z4@P000000Q4A4@03
00004A4A000000<A4A400`00014A4@0000044A4A00L0000A4A4A4A40000Z
4@PA4A4000000a4A4@0300004A4A4A4A00HA4A400aTI4A4A4BXA20034A4A
00<I6A4Z4@PA4A400Q4A4@036ATA4A4A:Q48008A4A4012XA214A4ATI4B8R
4@<A4A4032XA214A4ATI4ATI4A4A4ATI4A4A4ATI4A4A4ATI4A4A4ATI4@8A
4A400bXA214A4A4A4@024A4A00TZ4@PA4A4A4A4I6A40000I6A4A4A4Z4@PI
6A400a4A4@08:Q484A4A4A4A4A4A0000:Q484A4A6ATA0a4A4@03:Q486ATA
:Q4800DA4A4042XA214A4BXA21TI4BXA214A4ATI4BXA214A4ATI4A4A4BXA
214A4ATI4BXA214A4@8R8Q4012XA214A4ATI4A4A4@8I6A401`0002XA214A
4ATI4@0001TI4BXA20034A4A00L0000A4A4Z4@PA4A4Z4@PA4A4I6A401a4A
4@0:6ATA4A4A4A4A6ATA:Q484A4A:Q484A4A:Q484A4A0R8R4@0A:Q484A4A
4A4A4A4A:Q484A4A:Q486ATA4A4A:Q484A4A:Q484A4A6ATA6ATI4A4A:Q48
008A4A401BXA214A4A4A4BXA21TI4@024A4A00@Z4@PA4A4A4A4I6A434A4A
00@I6A4R8Q4I6A4R8Q426ATA00<R8Q4Z8QTI6A40Mlc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Pcc<c<0a4A4@0400004A4A4A4A6ATI0Q4A4@<I
6AT01Q4A4ATR8QTI6ATI6A4A4ATR8P@A4A400aTI6A4A4A4A4@024A4A00<I
6A4A4A4A4A400a4A4@0300004A4A4A4A00@A4A400`00014A4A4A4@0E4A4A
00<0000A4A4A4A400a4A4@0300004A4A4A4A008A4A401`00014A4A4A4@00
014A4@00014A4@0200000Q4A4@0300004A4A0000008A4A401000014A4BXA
200000DA4A42000000DA4A40000A4A4A4A4I6A40114A4@070000C4a46B8R
00006ATA4A4A000000@A4A401000014A4ATI6@0000<A4A401@00014A4A4A
4A4A4@0000024A4A00DZ8QT0000A4A40000Z4@P01Q4A4@0400004A4A4A4A
:Q481a4A4@036ATA4A4A4A4A008A4A401BXA214A4A4A4A4A4BXA20024A4A
00@Z4@PA4A4A4A4Z4@P24A4A0QTI4@034A4A:Q48:Q4800@I6A40214A4BXA
22XA214A4BXA21TI4A4A4B8R4@8A4A401RXA214A4BXA21TI4A4A4ATI4@8A
4A426ATA00DA4A4I6A4A4A4Z4@PA4A400QTI4@034A4A:Q486ATA008A4A40
0aTI4A4A4A4A4@024A4A010Z4@PR8Q40000A4A4Z4@PI6A4A4A4I6A4A4A4Z
4@PA4A4I6A4A4A4Z4@PA4A4Z4@P26ATA00<A4A4I6A4A4A400Q4A4@05:Q48
4A4A6ATA4A4A:Q48008I6A40114A4ATI4A4A4BXA208I6A401a4A4B8R4B8R
4A4A4ATI4BXA200000026ATA00@0000Z4@PA4A4Z4@P24A4A00lI6A4Z4@PR
8Q4A4A4I6A4A4A4Z4@PA4A4Z4@PA4A4Z4@PA4A4Z4@PA4A4I6A400Q4A4@07
:Q484A4A:Q484A4A:Q486ATA:Q48008A4A4042XA21TI4A4A4A4A4BXA214A
4B8R4@0001TI4ATI6ATI4A4A4BXA214A4BXA214A4@8Z4@P46ATA00/I6ATZ
4@PZ8QTR8Q4Z8QTI6ATR8Q4I6ATR8Q4I8R8I6AT00R8R4@046ATI:R8I:R8I
6B8R0RXR6@0:8R8A<RXR8RXZ:R8I6ATI8RXZ8R8A8S8Z6B8R8R8AMlc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<0P00008A4A401@00014A
4A4A4A4A4ATI6@054A4A00HI6ATA4A4A4A4I6ATA4A4I6AT74A4A00D0000A
4A40000A4A4000000a4A4@0400004A4A4A4A0000114A4@0400004A4A4A4A
00000Q4A4@0900004A4A00004A4A00004A4A00004A4A0000008A4A402000
014A4A4A4@00014A4@00014A4@0000<A4A401P00014A4@00014A4ATI4@00
00<A4A401000014A4A4A4A4A4@8000003a4A4@0000000000014A4@00014A
4@00014A4@00014A4@0002XA2000014A4@02000000@A4A40000A4A400003
4A4A00L0000A4A4jA4`Z4@P0000I6A4A4A400P0000DA4A42000000TA4A40
000A4A4A4A40000A4A40000Z4@P000001A4A4@0500004A4A00004A4A0000
00HA4A401@00014A4A4A4A4A4ATI4@024A4A00<0000A4A4Z4@P00QTI4@8A
4A400bXA214A4A4A4@044A4A00<Z4@P0000A4A40114A4@046ATA4A4A4A4A
6ATA0a4A4@046ATA4A4A6ATA6ATA0Q4A4@03:Q484A4A:Q4800XA4A401QTI
4A4A4A4A4A4A4ATI4B8R4@8I6A424A4A00<Z4@PA4A4A4A400Q4A4@04:Q48
4A4A4A4A4A4A0QTI4@084A4A6ATA6ATA4A4A6ATA4A4A:Q484A4A0aTI4@03
4A4A6ATA4A4A00<A4A42:Q4800<I6A4A4A4Z4@P00QTI4@06:Q484A4A:Q48
6ATA4A4A6ATA0Q4A4@04:Q484A4A6ATA:Q480a4A4@06:Q486ATA:Q484A4A
6ATA4A4A0RXA20044A4A6ATA4A4A:Q480a4A4@03:Q486ATA6ATA00<A4A40
0bXA214A4BXA20036ATA00LZ4@PA4A4A4A4A4A4I6A4Z4@PA4A400QTI4@03
:Q488R8A8R8A008I6AT00aTI4ATR8RXR6@02:R8I00<A4A4Z4@PI6A401R8R
4@056ATI8R8A6ATI6ATI6B8R008R8Q403ATI6ATR8QTI4BXR6ATI6ATR8QTI
6BXR6ATI6BXR6B8R4ATI6BXR6@026ATI00@A4A4Z8QTZ8QTI6AT2:R8I00<R
8Q4I6A7<c<`0M/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<
0Q4A4@800000114A4@00014A4ATI6@@A4A400aTI6A4A4A4A4@0B4A4A00D0
000A4A4A4A4A4A4000000Q4A4@0300004A4A0000008A4A400`00014A4A4A
4@024A4A00@0000A4A40000000044A4A0P00008A4A400`00014A4A4A4@03
4A4A00H0000A4A4A4A4A4A40000A4A42000000<A4A40000000000Q4A4@<0
00001A4A4@000000014A4@0000024A4A00<0000A4A4A4A400P00008A4A40
2P00014A4@000000014A4@00014A4@00014A4BXA20<A4A400aTR8R8b:P00
00024A4A00<I6AT000000000114A4@040000:Q484A4A4A4A0P0000@A4A40
1000014A4A4A4@0000TA4A401P00014A4A4A4@00028R4BXA20XA4A401@00
014A4A4A4@0001TI4@024A4A00<Z4@PA4A4A4A400Q4A4@036ATA:Q484A4A
00LA4A42:Q4800HA4A4I6A4I6A4Z4@PA4A4I6A444A4A00<I6A4A4A4Z4@P0
0a4A4@04:Q484A4A6ATA4A4A1ATI4@8A4A401ATI4BXA214A4A4A4BXA2003
4A4A00<I6A4A4A4Z4@P0114A4@8I6A454A4A00DI6A4A4A4I6A4Z4@PA4A40
0aTI4@038R8A4A4A8R8A00LA4A4011TI4BXA214A4BXA20<A4A401BXA214A
4A4A4ATI4BXA20024A4A00D0000Z4@PA4A4A4A4I6A40114A4@056ATA4A4A
:Q484A4A6ATA008A4A402ATI4A4A4BXA214A4BXA214A4BXA214A4B8R4@02
6ATA0bXA20086ATA4A4A8R8A8R8A6ATI:R8I8RXZ8R8A0RXR6@068R8A6B8R
:Q486ATA:R8I6ATA0R8R4@066ATI8R8A:R8I6B8R:R8I6ATI0R8R4@04:R8I
8R8A6B8R6ATI0R8R4@8I6AT2:R8I00HI6ATR8Q4I6ATR8Q4I8R8R8Q44:R8I
00LI6ATI8R8I6A4Z8QTI6ATR:RX00000Mlc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Pcc<c<0`00008A4A400`00014A4A4A4@044A4A00<I6ATA
4A4A4A401A4A4@0500004A4A4A4A4A4A000000<A4A400`00014A4A4A4@05
4A4A00<0000A4A4A4A400a4A4@0300004A4A4A4A00<A4A400`00014A4A4A
4@054A4A00<0000A4A4A4A400Q4A4@0500004A4A:Q4800004A4A00800003
4A4A00<0000A4A4000000a4A4@0600004A4A000000004A4A00000Q4A4@04
00004A4A00004A4A100000064A4A00004A4A4A4A00004A4A100000034A4A
0000000000@A4A40100003Xj<QTI4@00008A4A400aTI6@00014A4@024A4A
0P0000044A4A00004A4A00000Q4A4@0600004A4A4A4A00004A4A00000a4A
4@0500004A4A4A4A4A4A:Q4800PA4A40100001TI4A4A4BXA20<A4A400bXA
214A4A4A4@0:4A4A00PZ4@PA4A4Z4@PA4A40000I6A4A4A4Z4@P24A4A00HZ
4@PR8Q4Z4@PI6A4A4A4I6A424A4A00PI6A4A4A4Z4@PI6A4A4A4Z4@PA4A4Z
4@P34A4A00HZ4@PI6A4I6A4Z4@PI6A4Z4@P24A4A0QTI4@0<4A4A:Q484A4A
4A4A6ATA4A4A:Q484A4A:Q484A4A6ATA4A4A0QTI4@05:Q484A4A:Q484A4A
6ATA008A4A4011TI4A4A4A4A4ATI4@8A4A406RXA21TI4ATI4A4A4ATI4BXA
214A4B8R4ATI4BXA228R4BXA214A4ATI4A4A4BXA214A4ATI4BXA21TI4A4A
4ATI4A4A4ATI4A4A4BXA20@A4A426ATA00@Z4@PA4A4A4A4I6A424A4A00DZ
4@PA4A4A4A4A4A4Z4@P00a4A4@8I6A424A4A00DI6A4A4A4I6A4Z4@PA4A40
11TI4@096ATI8R8A8R8A6B8b:R8I8R8A8RXZ6ATI:R8I008I6AT011TR8R8R
4ATI6BXR6@8R8Q426ATI00<R8Q4I8R8I6AT00R8R4@036B8R6ATI6ATI008I
6AT0128R4BXR6B8R4ATR8P8Z8QT03ATR8QTI6BXR6B8R4ATR8R8R4ATI6B8R
4ATR8QTI4B8R4A4A4BXR6@026ATA0QTI6@036ATA4A4Ac<c<07K<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c0<A4A4200001Q4A4@8I6AT0
0a4A4ATI6A4A4@074A4A00@0000A4A4A4A40000:4A4A00@0000I6A4A4A40
00034A4A00<0000A4A4A4A400Q4A4@0300004A4A0000008A4A400`00014A
4A4A4@024A4A00<0000A4A4A4A401Q4A4@0600004A4A00004A4A00004A4A
0P00008A4A400`00014A4@0000024A4A00H0000A4A4A4A40000Z4@P00004
4A4A00<0000A4A4A4A400P0000<A4A403P00014A4@00014A4@0002XA214A
4ATI4A4A4@0003Y4C00002XA214A4@8I6A400a4A4@00014A4@054A4A00@I
6ATA4A4A4A4Z4@P24A4A00<0000A4A4A4A400Q4A4@0500004A4A4A4A4A4A
000000HA4A400`00014A4A4A4@034A4A00<I6A40000A4A400a4A4@070000
4A4A:Q484A4A6ATA0000:Q4800@A4A4011TI4A4A4A4A4ATI4@DA4A446ATA
00<A4A4I6A4A4A400Q4A4@03:Q484A4A:Q48008A4A401R8R4@0001TI4ATI
4BXA214A4@8I6A400a4A4ATI4ATI4@026ATA00hA4A4I6A4A4A4Z4@PI6A4A
4A4I6A4Z4@PI6A4Z4@PI6A4R8Q4Z4@PI6A42:Q4811TI4@8R8Q400a4A4BXA
22XA20024A4A00<Z4@PA4A4Z4@P00Q4A4@04:Q484A4A4A4A:Q480Q4A4@08
:Q486ATA6ATA6ATA4A4A6ATA4A4A:Q480aTI4@8A4A401ATI4ATR8RXA214A
4BXA20024A4A00DZ4@PI6A4I6A4A4A4000000QTI4@<A4A4022XA214A4A4A
4BXA228R4ATI4A4A4BXA20<A4A4022XA21TI4A4A4BXA214A4B8R4BXA228R
4@8b:R802R8R4ATR8RXR6BXR6B8R4BXR6B8R4ATI6BXR6ATI6@@Z8QT051TI
6BXR6B8R4ATI6BXR6BXA21TR8RXR6B8R4ATI6BXR6ATI6BXR6ATI6BXR6B8R
4ATI6BXR6B8Z:RXR6@8R8Q404aTI6B8R4ATI6B8R4ATI4ATI6B8R4ATR8QTI
4ATI6ATR8R8R4ATI6ATR8RXR6ATI4ATI6B8b:Q4A4@1gc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^3?<c<`0114A4@000000014A4@80000:4A4A
00D0000A4A40000A4A4000001Q4A4@0300004A4A000000<A4A400`00014A
4@00000:4A4A00L0000A4A4A4A4A4A40000A4A400000114A4@0300004A4A
4A4A008A4A401@00014A4@00014A4@0000084A4A00<0000A4A4A4A400a4A
4@0900004A4A4A4A00004A4A00004A4A00004A4A008000024A4A00@0000A
4A4Z4@PA4A42000000HA4A4000000000000A4A4000034A4A00@0000A4A4b
>T@000034A4A00LI6A400000000A4A40000A4A4000000Q4A4@0:00004A4A
00004A4A:Q4800004A4A00004A4A00000a4A4@0500004A4A4A4A6ATA0000
008A4A400`00014A4A4A4@0;4A4A00<Z4@PA4A4A4A401A4A4@056ATA4A4A
4A4A4A4A6ATA00@A4A401bXA214A4ATI4ATI4A4A4ATI4A4A4@026ATA00<R
8Q4I6A4Z4@P00a4A4@038R8A:Q484A4A008A4A401RXA21TI4BXA21TI4A4A
4ATI4@<A4A400aTI6A4A4ATI4@024A4A0aTI4@068R8A4A4A4A4A6ATA4A4A
6ATA0Q4A4@066ATA4A4A4A4A4A4A:Q486ATA114A4@036ATA:Q484A4A008I
6A4012XA214A4A4A4BXA208A4A400bXA214A4A4A4@034A4A0RXA200;6ATA
4A4A4A4A8R8A4A4A:Q486ATA4A4A:Q484A4A6ATA008A4A401QTI4BXA21TI
4A4A4BXA21TI4@<A4A42:Q4800TA4A4Z4@PI6A4I6A4Z4@P0000I6A4A4A4Z
4@P00QTI4@074A4A6ATA:Q486ATA:R8I8R8A8S8Z008Z8QT04aTI6BXR6B8R
4ATI4BXR6B8R4ATR8RXR6BXA22XR6B8R4BXR6BXA21TI6B8R4BXR6B8R4BXR
6B8R4@026ATI00<R8Q4I6ATR8Q400QTI6@0<:R8I8R8A6B8R8R8A8RXZ:R8I
6ATI8R8A6ATI6ATA6ATI:R8I0R8R4@064A4A:R8I8R8A6ATI8R8A6ATI0QTI
4@086ATI4A4A6ATA6ATA:R8I6ATA6ATI4A4AMlc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Pcc<c<00@A4A40000A4A4000044A4A00<0000A4A4A
4A40114A4@0300004A4A4A4A00DA4A400`00014A4A4A4@054A4A00H0000A
4A4A4A4A4A40000I6A454A4A00<0000A4A4A4A402A4A4@0300004A4A4A4A
00<A4A400`00014A4A4A4@054A4A00<0000A4A4000000Q4A4@0300004A4A
4A4A008A4A400`00014A4A4A4@024A4A0P0000@A4A401@00014A4@0001TI
4BXA20024A4A00<0000A4A4A4A400Q4A4@030000:Q48:Q4800<000044A4A
00LRA3XA4A4A4A4A4A40000I6A4000000Q4A4@8I6A401A4A4ATI4A4A4A4A
4BXA20024A4A00<0000A4A4A4A401a4A4@07:Q484A4A4A4A4A4A:Q484A4A
:Q4800PA4A4012XA214A4A4A4BXA208A4A400aTI4A4A4A4A4@026ATA00<A
4A4I6A4A4A400QTI4@0B8R8A6ATI8R8A6ATA:R8I6B8R6ATI:R8I6ATA:R8I
8R8A6B8R6ATI6ATA6B8R8R8A:R8I6ATA0Q4A4@05:Q484A4A:Q484A4A6ATA
00@A4A4011TI4A4A4ATI4B8R4@8A4A401ATI4BXA214A4BXA214A4@026ATA
00PZ4@PI6A4Z4@PI6A4A4A4Z4@PA4A4I6A424A4A00DI6A4Z4@PA4A4A4A4I
6A400RXA20084A4A6ATA4A4A6ATA:Q486ATA4A4A8R8A0Q4A4@@I6A401RXA
21TI4ATI4BXA21TI4A4A4@<I6A401BXA214A4A4A4A4A4ATI4@02:Q4800<A
4A4I6A4Z4@P00QTI4@0400006ATA6ATA:Q480Q4A4@03:Q484A4A4A4A008I
6A401A4A4BXA21TI4A4A4B8R4@024A4A00DZ4@PR8Q4I6A4Z8QU4>RX00S8Z
8P05:R8I8R8A:R8I:R8I8R8A008Z8QT03ATI6BXR6ATI4ATI6B8R4ATR8RXR
6ATI6B8R4ATI6B8R4ATI6BXA20026ATI00LZ4@PI6ATR8Q4R8Q4I6ATR8Q4I
6AT00RXR6@046B8R6ATI:R8I:R8I0QTI6@8R8Q4012XR6ATR8Q4A4B8R4@8I
6AT01B8R4ATI4ATI6A4A4ATI4@024A4A00@I6A4A4A4I6A4I6AT26ATA00<I
6ATR8Q400000Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<
0Q4A4@046ATI4A4A000000001a4A4@036ATI4A4A4A4A00@A4A400`00014A
4A4A4@034A4A00@0000A4A4A4A4000094A4A00<0000A4A4A4A400Q4A4@04
00004A4A4A4A00000Q4A4@0300004A4A000000HA4A400`00014A4A4A4@05
4A4A00<0000A4A4A4A401A4A4@0600004A4A00006ATA00004A4A0`000005
4A4A00004A4A00004A4A008000034A4A00D0000A4A4A4A4A4A4000000RXA
200><RXR:Q48<RXR00004A4A00004A4A00004A4A0000:R8I00004A4A0000
0Q4A4@0700004A4A000000004A4A00004A4A008000084A4A00<Z4@PA4A4A
4A40114A4@076ATA4A4A4A4A6ATA4A4A:Q486ATA008A4A400aTI4BXA214A
4@026ATA010A4A4I6A4I6A4I6A4A4A4I6A4A4A4I6A4I6ATI6A4A4A4Z8QTI
6A4I6ATZ4@PI6AT28R8A00PZ8QTI6A4I6A4Z8QTA4A4R8Q4Z8QTI6A42:R8I
00@I6ATZ8QTI6A4000064A4A00DI6A4A4A4A4A4A4A4Z4@P00Q4A4@056ATA
4A4A6ATA8R8A:Q4800<A4A401bXA214A4A4A4A4A4ATI4@0001TI4@034A4A
0QTI4@@A4A401BXA214A4ATI4@0001TI4@034A4A00<I6A4A4A4Z4@P00Q4A
4@048R8A:Q484A4A6ATA0Q4A4@056ATA:Q484A4A:Q484A4A008I6A402BXA
214A4ATI4A4A4B8R4BXA214A4ATI4A4A4@036ATA00HR8Q4I6A4Z4@PZ4@P0
000I6A42:Q4800<I6A4Z4@PZ4@P00QTI4@0?6ATI6ATA8R8A6ATI:Q48<RXR
A3XRA4@ZG3XRC4`j<RXR6B8R:R8I8R8A6ATI008Z8QT01aTR8R8R4ATI4ATI
4BXA21TI4BXR6@026ATA00PZ4@PI6A4R8Q4I6ATI6A4I6ATR8Q4I6AT48R8A
00XI6ATR8Q4Z8QTR8Q4I8R8R8Q4Z8QTR8Q4Z8QTR8Q426ATI00<R8Q4I6ATI
6A400QTI4@04:R8I6ATI6ATA8R8A0aTI4@06:Q486ATA6ATA:Q486ATA6ATI
0Q4A4@056ATA4A4A4A4A6ATA4A4A07O<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h<lc<c0034A4A6ATI6ATI008A4A400`00014A4A4A4@034A4A
00<I6ATA4A4I6AT00a4A4@0300006B8R000000dA4A401000014A4A4A4@00
00@A4A400`00014A4@00000;4A4A00<0000A4A4000000Q4A4@8000024A4A
00<0000A4A4Z4@P00Q4A4@0300004A4A4A4A008A4A401@00014A4@00014A
4@0000054A4A00D0000A4A40000A4A4000000a4A4@0600004A4A00004A4A
00004A4A0P0000036ATA00004A4A00@000001Q4A4@00014A4A4A4ATI6@00
00@A4A4200000a4A4@036ATA4A4A4A4A00@A4A4011TI4A4A4A4A4ATI4@8A
4A4012XA214A4ATI4A4A4@8I6A402A4A4ATI4ATI4A4A4ATI6A4A4ATI6ATI
4BXR6@026ATA00@Z4@PI6ATI6A4Z4@P24A4A01TR8Q4A4A4R8Q4I6A4Z8QTI
6ATR8Q4I6A4R8Q4I6A4Z8QTI6ATI6A4I6ATA4A4I6ATI6A4I6ATI6A4Z8QTI
8R8I6ATI6A4I8R8R8Q40114A4@03:Q484A4A4A4A00DA4A403BXA214A4BXA
21TI4A4A4ATI4A4A4BXA214A4BXA214A4BXA21TI4@034A4A00TZ4@PI6A4R
8Q4I6A4R8Q4I6A4A4A4I6A4000000RXA20<I6A402@00014A4BXA214A4BXA
214A4BXA214A4ATI4@024A4A00<Z4@PI6A4Z4@P00Q4A4@06:Q484A4A4A4A
6ATA4A4A6ATA0Q4A4@0;6ATA4A4A6ATA4A4A:Q484A4A:Q486ATA6ATI:R8I
8R8A008Z8QT031TI4BXR6B8R4ATR8R8R4ATI6BXR6ATI6BXR6ATI6BXR6C8Z
8P@R8Q42C4@R00i<C3Xj>R8b:R8I6ATI6A4R8Q4Z8QTR8Q4I8R8R8Q4I6A4Z
4@PI6ATI6A42:R8I0QTI6@06:Q48:R8I8R8A:R8I8R8A6ATI0RXR6@03:Q48
6B8R8R8A008I6AT05RXR6ATR8R8R4BXR6ATI6ATR8RXR6ATI6ATR8QTI6B8R
4ATR8QTI4B8R4ATI6B8R4ATI4BXR6ATI6ATI4BXR6ATI4@HA4A400aTI4A4A
4ATI4@024A4A00HI6A4A4A4I6ATI6A4I6AT0001gc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^3?<c<`01a4A4ATR8P00014A4@00014A4@000004
4A4A00<I6ATA4A4I6AT0214A4@076ATA00004A4A4A4A00004A4A0000008A
4A401000014A4A4A4@00008A4A400`00014A4@0000054A4A00@0000A4A4A
4A4000034A4A0P0000@A4A401@00014A4A4A4A4A4@0000024A4A0`0000@A
4A400`00014A4A4A4@034A4A00P0000A4A40000A4A40000A4A40000A4A43
000000@A4A40000A4A4000024A4A00H0000A4A4A4A4I6A4A4A4Z4@P20000
00DA4A40000A4A4A4A4000000a4A4@036ATA4A4A6ATA008A4A40128R4ATI
4@00028R4@@A4A400bXA214A4BXA20026ATA00<A4A4R8Q4I6A401A4A4@05
6ATA4A4A6ATA4A4A6ATA008R8Q402ATI4BXA228R4ATI4A4A4ATI6ATI4A4A
4ATI4@024A4A11TI4@03:Q486ATI6ATI008I6A400aTI6BXA21TI6@026ATI
00DZ4@PI6ATZ8QTZ4@PR:RX00R8R4@056ATI8R8A6ATI:R8I6ATI008A4A40
12XA21TI4A4A4A4A4@<I6A401A4A4BXA21TI4A4A4ATI4@054A4A00@I6A4I
6ATI6A4A4A426ATA00@R8Q4A4A4Z4@PR8Q436ATA00@Z8QTR8Q4R8Q4A4A42
:Q4800<I6A4A4A4I6A400Q4A4@05:Q484A4A4A4A4A4A:Q4800@I6A424A4A
00lR8Q4I6A4A4A4Z4@PA4A4Z4@PI6A4A4A4Z4@PI6A4Z4@PI6A4A4A4Z4@PI
6A400RXA20<I6A401R8R4BXR6ATI4C8Z8QTI6BXR6@<R8Q401QTI6ATR8RXR
6BXR6B8R4BXR6@8R8Q402BXR6BXA238Z8RXR6D@j:S8Z8T@j:S8Z8Q4A4@03
8R8A00<Z8QTI6A4I6AT00R8R4@07:R8I6ATI8R8A8R8A:R8I8R8A6ATA008R
8Q401BXR6B8R4ATI6B8R4ATI6@028R8A00HZ8QTR8Q4R8Q4I6ATR8Q4I6AT2
8R8A00PI6ATR8Q4Z8QTI6A4Z8QTR8Q4I6A4R8Q426ATA00@R8Q4I8R8R8Q4I
6AT26ATA00DA4A4I6A4I6A4A4A4I6A401A4A4@036ATA4A4A4A4A00@A4A40
11TI4A4A4ATI4@0007O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
<lc<c0044A4A00004A4A00000Q4A4@0300004A4A4A4A00@A4A400aTI6@00
014A4@0J4A4A00<0000A4A4000000Q4A4@0400004A4A4A4A00000a4A4@03
00004A4A000000<A4A401P00014A4A4A4@00014A4@0000<A4A402@00014A
4@00014A4@00014A4@00014A4@0000024A4A0P0000044A4A00004A4A0000
0a4A4@0900006ATA00004A4A00006ATA00004A4A0000008A4A4012XA228R
4BXA2000008A4A401@00014A4A4A4@0001TR:P034A4A00<0000I6A4A4A40
0P00008A4A400aTI6A4A4A4A4@024A4A0QTI4@03:Q484A4A4A4A008A4A40
12XA214A4ATI4ATI6@8A4A401ATI6A4A4A4A4ATI4A4A4@026ATA00@A4A4I
6ATI6A4I6A434A4A0aTI4@076ATI6ATA6ATA6ATI8R8A6ATI4A4A008I6A40
1ATI6BXA21TI6BXA21TI6@026ATA00HI6ATR8Q4I6A4I6A4I8R8I6AT26ATA
1Q4A4@066ATA4A4A6ATA6ATA00006ATA0Q4A4@8R8Q401ATI4A4A4ATI6ATI
4ATI6@028R8A00/I6ATZ8QTR8Q4I8R8Z8QTR8Q4I6ATI6A4Z8QTI6A4I6AT0
1Q4A4@046ATA4A4A4A4A4A4A0QTI4@038R8A:Q486ATA008A4A403RXA214A
4B8R4BXA21TI4BXA214A4@00028R4ATI4A4A4BXA214A4ATI4@8A4A400bXA
21TI4A4A4@046ATA00@R8Q4Z8QTR8Q4Z8QT38R8A00DZ8QTI6ATZ8QTI6ATR
8Q4011TI6@<b:R801DA4<S8Z8R8Z:R8R4ATI6@028R8A00DZ8QTI8R8R8Q4R
8Q4I6A400RXR6@078R8A6ATI8R8A6ATI8R8A:R8I8R8A008Z8QT38R8A00`I
8R8R8Q4R8Q4Z8QTR8Q4I6A4I6ATZ4@PI6ATI6A4A4A4R8Q426ATI00@A4A4I
6A4Z4@PI6AT24A4A0aTI4@048R8A6ATI:Q486ATA0Q4A4@0=6ATI4A4A6ATA
6ATA4A4A6ATA:Q488R8A:R8I6ATA8R8A:R8I8R8A00PA4A400`000<c<c<c<
c01ec<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`24A4A00<0
000A4A4A4A400P0000/A4A400`00014A4A4A4@024A4A00<0000A4A400000
0Q4A4@0=00004A4A4A4A4A4A00004A4A00004A4A00004A4A00004A4A0000
00DA4A401@00014A4A4A4@00014A4@03000000HA4A40000A4A40000A4A40
00024A4A00<0000A4A4000000Q4A4@8000024A4A00@0000A4A4A4A400002
4A4A00<0000A4A4A4A400a4A4@8000001A4A4@0000000000014A4@020000
0Q4A4@0300006ATA0000008A4A4022XA21TI4BXA214A4BXA2000014A4@00
008I6A434A4A00<0000A4A4A4A400Q4A4@8000084A4A01<I6A4A4A4I6ATA
4A4I6A4A4A4I6A4A4A4I6A4A4A4I6A4A4A4I6A4Z4@PA4A4I6A4A4A4I6A4A
4A4011TI4@078R8A6ATI6ATA6B8R4A4A6ATA8R8A008I6AT011TI4ATI6ATI
4B8R4@8I6AT03bXR6ATR8Q4A4ATI4B8R4ATI4ATI6B8R4ATR8QTI4BXR6A4A
4BXA21TI6BXA20026ATA00DZ4@PA4A4I6ATI6A4R8Q40138Z8P94:R800d@j
:RXR6B8Z:P02:R8I00lI6ATI8R8Z4@PI6A4R8Q4I6ATZ8QTI6ATR8Q4I8R8Z
8QTI6A4Z8QTI6A4R8Q400RXA20066ATA:Q48:Q486ATA4A4A:Q480Q4A4@08
:Q484A4A:Q484A4A6ATA4A4A8R8A:Q480a4A4@056ATA4A4A4A4A4A4A:Q48
008A4A42:Q480Q4A4@046ATA:Q484A4A00000R8R4@0<6ATI:R8I:R8I:R8I
6ATA6B8R:Q486ATI6ATA6ATI:R8I8R8A0QTI6@078R8A<RXRC4@RA3XRA4@b
A2XR>SXb00<R8Q4011TR8R8R4BXA21TI6@<Z8QT03aTI6BXR6A4A4B8R4BXR
6ATI6BXR6ATR8QTI4ATI6B8R4ATI4BXR6ATI4B8R4@026ATA00DZ8QTI6ATI
6A4I6A4R8Q400RXA208I6AT012XR6B8R4B8R4B8R4@<Z8QT03C8Z8QTI4BXR
6BXR6B8R4C8Z8QTI6ATI4B8R4ATI6ATI4ATI6ATI4@034A4A00HI6A4A4A4R
8Q54>R8jA1TZ4@P36ATA1A4A4@0500004A4A4A4A4A4A000007O<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c00600004A4A4A4A00004A4A
0000114A4@0300004A4A4A4A014A4A400`00014A4A4A4@0:4A4A00D0000A
4A40000A4A4000002A4A4@056ATI00004A4A4A4A000000<A4A402`0001TI
4@00014A4@00014A4@00014A4@00014A4@0000024A4A00@0000A4A4A4A40
00034A4A00T0000A4A400000000A4A40000A4A40000Z4@P00P0000@A4A40
0c8Z8QTI6@0000034A4A0P0000054A4A00004A4A4A4A6B8b008R>U`01aTR
:Q4A4A4A4A4A4BXA214A4ATI6@024A4A00<Z4@PI6A4A4A400Q4A4@036ATA
4A4A4A4A008A4A401aTI4A4A4ATI6ATI4A4A4ATI4A4A4@066ATA00@A4A4I
6ATR8Q4A4A426ATI0QTI4@048R8A6ATI6ATA8R8A0QTI4@8I6AT00bXR6ATI
4ATI6@02:R8I1QTI6@0?6B8R6ATI:R8I6B8R8R8A6B8R6ATI<RXR6B8R6ATI
>SXRA3XZ>SXRA3XZ8S8Z009<A2800b8j<R8Z:RXR6@026B8R12XR6@046B8R
:R8I6B8R8R8A12XR6@036ATI8R8A6ATI008I6A4032XA214A4B8R4ATI4A4A
4ATI4BXA21TI4A4A4BXA214A4BXA208A4A401BXA21TI4A4A4ATI4A4A4@02
:Q4800LA4A4Z4@PA4A4Z4@PR8Q4I6A4A4A400QTI4@8A4A401B8R4ATI6BXR
6B8Z:RXR6@028R8A0bXR6@038R8A6B8R:R8I00@Z8QT03R8Z:Ta48TA4:TA4
:T@j8T@j:S8Z8QTI6BXR6B8R4ATI4BXR6ATI6BXR6@8I8R801BXR6B8R4ATI
6BXR6ATI6@02:R8I00<I6ATZ8QTI6AT00RXR6@08<RXR:R8I8RXZ:Q488RXZ
A2XR<RXRA3XZ1C8Z8P8R<RX02R8Z:S8Z8S8Z8RXR6B8b:RXR6B8Z:QTR8QTI
4BXR6@8I6A400b8R4ATR8QTI4@024A4A00LI6ATR8Q54A394A38R8Q4A4A4Z
4@P00R8R4@03C288:Q484A4A00<A4A400`00014A4@0000094A4A00<0003<
c<c<c<`0MLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00@A
4A400000000A4A42000000<A4A40000A4A403a4A4@0500004A4A00004A4A
000000TA4A401000014A4A4A4@00008A4A400`00014A4A4A4@024A4A00<0
000A4A4A4A400Q4A4@0600004A4A000000004A4A00001Q4A4@0300004A4A
4A4A00@A4A400`00014A4A4A4@034A4A00P0000A4A4A4A40000A4A40000A
4A4000024A4A0P00000B4A4A00004A4A4A4A6B8R4A4A6ATA4A4A6ATA8RXZ
4A4A:Q484A4A6ATA00004A4A0000:Q480Q4A4@096B8R6ATI4A4A6ATA4A4A
6B8Z00004A4A6ATA008A4A400bXA214A4ATI4@024A4A00DZ4@PA4A4A4A4I
6A4I6AT00a4A4@036ATA4A4A4A4A00<A4A426ATA00LA4A4I6A4Z4@PI6A4I
6ATI6A4I6AT00aTI4@066ATI6ATA6ATI6ATA8R8A6ATI0aTI4@036ATI:R8I
6B8R008I6AT01R8Z:RXR6B8R4B8R4B8Z:R8R4@8Z8QT02R8Z:RXR6ATI6B8Z
:RXR6ATR8S8Z8Ta48TA4<TA4:P94>RX01TA4:T@j:S8jA1TI4ATR8R8R4@8Z
8QT011TR8R8Z:QTR8QTR8P8Z8QT03b8R4BXR6ATR8R8Z:RXR6ATI6B8R4ATI
4A4A4BXA228R4@00028R4ATI4A4A4@036ATA00<Z4@PA4A4I6A400QTI4@0:
4A4A:Q486ATA6ATA4A4A8R8A6ATA8R8A0000:Q480R8R4@8I6A401aTI6B8R
4ATI6ATI6B8R4BXA228R4@05:R8I0QTR8P<b:R82A2XR00lb:R9<A294:R8b
:R8j>R8jA394>R8b:R8I8R8I6ATI6A4I6ATZ8QTA4A4I6AT00RXR6@0H8R8A
:R8I<RXRA2XR>SXRA2XR>SXRA2XRA3XZ>SXR<RXRA3XZA4@ZC4a4C4`jA3XZ
A4A<A3XZA4@Z<RXR>SXR8S8Z<RXR8RXZ0c8Z8P048RXZ:R8I6ATI<RXR0R8R
4@066B8R8R8A8R8A6ATI:R8I6ATI128R4@8I6A40114A4ATI6A4A4B8R4@8I
6A4012XR6ATI6A4A4ATI4@@A4A401000014A4ATI4BXA20HA4A401`00014A
4A4A4A4A4FEL:Q4A4@00001gc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^3?<c<`64A4A0P0000084A4A00006ATI4A4A00006ATA4A4A00000Q4A
4@0500004A4A4A4A4A4A000000XA4A401@00014A4@00014A4@0000024A4A
00<0000A4A4A4A401Q4A4@0400004A4A6ATA00001a4A4@0>00004A4A4A4A
00004A4A00004A4A00004A4A00004A4A00004A4A00000Q4A4@8000034A4A
0P0000034A4A00004A4A00<000024A4A00H0000A4A40000I6A4A4A400002
4A4A0P0000036ATA4A4A4A4A00<A4A40100002XA214A4@00008A4A401000
014A4A4A4A4A4@8000044A4A00<I6A4A4A4I6A400Q4A4@066ATA4A4A6ATA
4A4A<RXR6ATA0a4A4@046ATA4A4A6ATA:Q480Q4A4@066ATA4A4A4A4A4A4A
6ATI4A4A0QTI4@034A4A6ATI:Q48008I6A401B8R4ATI6ATI4ATI4ATI6@03
6ATA00<Z8QTI6A4I8R800R8R4@036ATI6B8R8R8A00<I6AT00b8R4ATI6BXR
6@026B8R00XjA1U<C3Y4>RXj>R94:R9<A294A2XR:RXR8Q4I6AT2:R8I0QTR
8P038RXZ:R8I:R8I008Z8QT01A4A4BXR6ATR8QTR8RXR6@026ATI00<A4A4I
6A4Z8QT00b8R4@036ATI6ATA6ATA00@R8Q400a4A4B8R4BXR6@028R8A00<I
6ATR8Q4I6AT012XR6@<b:R8032XR6C8Z8S8Z8T@j8RXR6C8Z8SXj8Ta48T@j
:S8Z8SXj8S8Z8P8j>R80338Z8SXj8T@j:SXj8T@j:S8Z8SXj8S8Z8R8b:S8Z
8R8Z:R8b:P8j>R802D@j:S8Z8S8Z8Ta48T@j:SXj8TA4<Ta<>VED<P02C4`j
00M<C4A4>RXj>S94>RY4A394>RXb:R800T@j:P08C4`jA3XZ<RXRA3XZ<RXR
>SXR>T@IA3XZ0SXj8P94>RX03aTR8S8Z8S8Z8SY46CXj8TA4:SY4<S8Z8T@j
:RXR6B8Z:R8R4BXR6ATI6BXR6@026ATA00DI8R8R8Q4I6A4A4A4I6A401a4A
4@036ATI:Q48:Q4800800000114A4@00014A4@00008A4A402BXA2000038Z
8P00014A4FEU>VEL:T`R214A4@0200000Q4A4@03C4`j8S8ZC4a407O<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c0044A4A000000004A4A
0`0000<A4A401@00014A4A4A4A4A4@0000024A4A00<0000A4A4A4A401Q4A
4@0800004A4A4A4A00004A4A00004A4A6ATA114A4@0900004A4A4A4A4A4A
00004A4A00004A4A000000@A4A402@00014A4@00014A4@00014A4@00014A
4@00000<4A4A00T0000A4A40000A4A40000A4A40000A4A4000000Q4A4@03
00004A4A0000008A4A401000014A4@000000008A4A420000214A4@<00000
3bXA214A4@000000014A4ATI4A4A4ATI4@00014A4@00014A4B8R4A4A4BXA
20024A4A00hI6A4A4A4I6A4R8Q4A4A4I6ATA4A4I6A4I8R8A4A4Z4@PA4A4I
6A4A4A426ATA00<A4A4I6ATI6A401ATI4@0:4A4A6ATA6ATI6ATI6ATA6ATI
4A4A6ATA6ATI8R8A0QTI4@096ATI6ATA6ATA:R8I6ATA8R8A6ATA:R8I6ATA
008R8Q426ATA00Lb:R8Z8QTA4A4I8R8Z8QU<A294>RX00TA4:P94A3800da4
8RXR6ATR8P02:R8I00TI8R8Z8QTZ8QTZ8QTR:RXR8Q4I6ATR8Q4I6AT00bXR
6@03<RXR:R8I:R8I00HZ8QT0128Z:RXR6BXR6CXj8P8b:R8034a48T@Z8T@Z
8Ta<>VE<6CXj8TA4:Ta48TA4:Ta48TA4<Ta48P94>R801SY46D@j:R8b:SXj
8S8Z8SXj8P<b:R80128Z:R8R4BXR6BXR6@@b:R800cXj8S8Z8Ta48P02A3XZ
00=4A2Y<A294>RX01TA4<P05A4A<>SXR8S8ZA3XRA4@b0094>RX024a48SXj
<T@j8S8Z8Ta<A4A4<TA4:TA4<P94>RX01d@j8TA4<Ta<>TA4<TA4:Ta<>SY4
<P03A4@Z01Pj>S9<C3Y4>R94A394A2Y4>R8b:R94A2Y4>RXb:R8Z8QTb:R8R
:RXZ8QTR8Q4I6A4A4A4R8Q40000R8Q4A4A4Z4@PI6A4Z4@P64A4A00@I6A4A
4A4A4A4Z4@P:4A4A00dZ4@P00014:R:7E2Z?MT@Z4@P0001]IB9UC1UUICY4
>RXb:R8jA4`00Ta<A003E7inG6f7E6ef07O<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h<lc<c0<A4A401`00014A4A4A4A4A4@00014A4ATI4@06
4A4A00<0000A4A4A4A400a4A4@0300004A4A4A4A00PA4A400`00014A4A4A
4@0<4A4A00<0000A4A4A4A402A4A4@0300004A4A4A4A00HA4A401`00014A
4@00014A4@00014A4@0000034A4A00L0000A4A400000000A4A40000A4A40
0P0000048R8A4A4A4A4A00001Q4A4@0400004A4A:Q4800000RXA20800000
1BXA20000000014A4@0000064A4A00D0000A4A4A4A4A4A4I6A400Q4A4@06
6ATI4A4A4A4A4A4A6ATI4A4A0QTI4@044A4A6ATA6ATI4A4A0QTI4@054A4A
:Q484A4A4A4A6ATI008A4A4011TI4ATI6B8R4ATI6@8R8Q401ATI4A4A4A4A
4ATI4ATI6@026ATA00<I6ATI6A4I6A400aTI4@066ATI6ATA8R8A6B8R6ATA
:R8I0QTI6@08:R8I6ATI8R8AA2XRC4a4G5a<A4@bA4@Z0T@j:P06>SXR6B8R
6B8R6ATI8R8A6B8R0RXR6@066B8R>SXR<RXR:R8I<RXRA2XR0S8Z8P94A2X0
3T@j8T@j:TA4:TA4:Ta48Ta<>TA4<T@j8TA4<TA4:S8Z8SXj8T@j8SXj8P94
>RX023Xj8R8b:R8b:SXj8QTI4C8Z8R8R4ATR8P8Z8QT4<RXR00@j>R94>RY4
>RY4>RX3A4@b00U4>RYL>R9<C4A4A4a<C3Y<C4@jA1Tj>R94>RX00TA4<P06
A3XZC4`jC4`jA4@Z>SXbA4@b0Ta<>P94A383C4`j00M4A2Y<C4AUICY<C4AL
G4a]KEA<C3X00UaLC005A4@bC4`jA4@bC4a4A3XR00=4A2X014A4C4A4<TA4
:SXj8P94A2X00d@j:SXj8SY4<P02>SXR0S8Z8P0;6ATI<RXR6ATI:R8I8R8A
4A4A6ATA6ATI:R8IA2XR:R8I00<I6A401ATI6A4A4ATI6A4A4ATI4@034A4A
00XZ4@PA4A4A4A4I6A4A4A40000A4A40000A4A4000024A4A00<0000A4A40
0000114A4@08<RXR>T@I>T@IQgiDIFDjG5a<<RXRG6ef0UA]MP08C6f7E6ef
E6efC5A]>Uaf>UAL>VF7>UALMlc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Pcc<c<00@A4A400000000A4A43000000@A4A40000A4A4000024A4A
00<0000A4A4A4A40114A4@0700004A4A00004A4A00004A4A000000`A4A40
0`00014A4A4A4@054A4A00D0000A4A4A4A4A4A400000114A4@0400004A4A
4A4A00000Q4A4@066ATA4A4A4A4A00004A4A00000a4A4@0400004A4A0000
00000Q4A4@0300004A4A4A4A00<A4A401P00014A4A4A4@00014A4B8R4@8A
4A4300000Q4A4@0300004A4A4A4A008A4A4200000a4A4@8000000a4A4@00
000000034A4A00@I6A40000A4A4000024A4A00<I6A4A4A4A4A400QTI4@8A
4A402bXA21TI4A4A4ATI4A4A4ATI6A4A4ATI6ATI4ATI6A4A4@036ATA00LA
4A4I6A4I6A4I6A4I6ATA4A4I6A400Q4A4@036ATI6ATA6ATI008I6A4041TI
6A4A4ATI4A4A4BXR6A4A4ATI4ATI6BXR6ATI4BXR6ATI6BXR6ATI6ATI4B8R
4@<I6AT07QTI4D@j:VED<TA4<VED<Ta<A3Xj8T@Z8SXj8T@j8TA4:SY46Da<
>S8Z8TA4:T@j:T@j8SXj8S8Z8SXj<R8b:R8Z:T@j:SXj<R8b:QTI6C8Z8QTI
6B8R4ATR8P8Z8QT02b8R4C8Z8QTR8RXR6C8Z8RXR6B8b:S8Z8TA4:SY4<Ta4
8P02A3XR00E4A39LG4a4A39<C3YUE3800eaLC006C4`jA4@ZC4`jA4@bA4@Z
C4@R0dA4<P07C4a4A4@bA4@bG5a<IE`ZC4`jA4@Z00A<C3X00fEU>UaLC4a<
>P02C4a400M4A39UE39<C4ALG4a<C3Y<C4ALG4`00da<>P9<C4@023Y4<TA4
<T@j:T@j:TA4<SY46DA4C4A4:P94A3800cXj8S8Z8S8Z8P03>SXR00Db:R94
>RY4:R8b:R94:R800RXR6@@b:R801B8Z:S8Z8R8R4BXR6ATI6@02:R8I0R8R
4@036ATI:R8I6ATA00HA4A400`00014A4BXA20044A4A00<0000A4A4A4A40
114A4@0500006ATIG3XRIFDjC4@R00@000003Ta<A6e]E28jG4a]QdaDKDa<
A5A]MSYDG3YLMTaDKCYDG4aDKCYDG4aDK@8jG7H00cYDG3YLM/c<c01fc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`24A4A00@0000A4A40
000A4A420000514A4@0300004A4A4A4A00HA4A400`00014A4A4A4@034A4A
00@0000A4A4A4A4000054A4A00<0000A4A4A4A401A4A4@0300004A4A0000
00PA4A400aTI4A4A4A4A4@024A4A00<0000A4A4A4A401000000<4A4A0000
000000004A4A6ATI4A4A6ATA4A4A00004A4A00000a4A4@0300004A4A4A4A
00<000001Q4A4@0002XA22XA2000014A4@8000001aTR8Q4A4A4A4@0002XA
200001TI4@054A4A00<I6A4A4A4I6A400Q4A4@036ATA4A4A6ATA00HI6A40
1a4A4ATI4A4A4ATI4ATI6ATI4ATI6@026ATA00@A4A4I6A4A4A4R8Q426ATI
0QTI4@066ATI6ATA:R8I6ATI6ATA:R8I0QTI6@0A8R8A6ATI6ATI:R8I8RXZ
6ATI:R8I6ATI8R8A6ATA:R8I6ATI8RXZ6B8R>SXR8S8ZA4@Z00=4>RX0238Z
8RXR6CXj8R8Z:T@j:S8Z8R8b:R8Z:P8b:R83>SXR02=4>RY4>R94>RY4A38j
A394>RXj>S9<C3Y<C4A4A4a<C4ALG4a<C4A4A38jA394>RY4A2Y<C3YLG4a4
A39<C4@j>R94A2XjA38j>S94A2Y4>R8jA39<C3Y<A29<C3YUE39LG4aUICYL
G4`00Ta<>P05C4a4C4`jA4@ZC4`jA4@b009<C3X01TA4:Ta<>Ta<>Ta<>VEU
>Ta<>P9<C4@01dA4:UaLC4a<A4a<A4a<>Ta<A4a<>P02A3XZ00<b:R8j>R94
A3800T@j:P<j>R802d@j:TA4<TA4<Ta<A4A4:TA4<TA4:TA4<SXj<T@j:Ta<
>P02A3XZ00hjA4a4>RY4>RY4>RXjA1TR<RXjA1TI6ATZ8QTZ4@Pj>R8b:R8R
8Q4b:R83:R8I00@R8Q4Z8QTZ8QTI6AT2:R8I00@R8Q4I6ATA4A4Z4@P24A4A
00@Z4@PA4A4A4A4A4A42000000DA4A40000A4A4A4A4000000Q4A4@0@0000
4A4A00000000<RXRQfDbIFDj<RXR8S8ZG5a<G6efE6ef>UALC5A]>UALC4a4
0SYDG004A4A<>Uaf>UAL>UAL0TaDK@<jE5`2E6ef00<jE5c<c<c<c<`0MLc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00DA4A40000A4A40
000A4A400P0000044A4A00004A4A00000a4A4@036ATA4A4A4A4A00LA4A40
0`00014A4A4A4@044A4A00<0000A4A4A4A401Q4A4@0300004A4A0000008A
4A400`00014A4A4A4@024A4A00P0000A4A4A4A40000A4A40000A4A400007
4A4A00@0000A4A4A4A4000034A4A00@0000A4A4A4A4000034A4A00D0000A
4A40000A4A4000000a4A4@036ATA4A4A4A4A00<000034A4A00@0000A4A4A
4A4A4A42000000XA4A4Z4@PI8R8I6A40000Z4@PA4A40000A4A4Z4@P74A4A
00<Z4@PA4A4A4A401A4A4@036ATA4A4A4A4A008A4A401QTI4A4A4ATI4A4A
4ATI4A4A4@DI6A4011TI6BXR6ATI6ATI6@<I6A402QTI6ATI4ATI4ATI6ATI
4B8R4A4A4ATI6ATI4A4A4@8I6A402B8R4ATI6ATI4BXR6ATI6ATI4BXA21TR
8RXR6@03<RXR01A4>RXR<RY4>R8b:R94>RXj>S8jA1U4A394>RXb:R94>RXb
:R94A2Y<C4A4A38jA39<C3XjA394>RXj>S82A3XZ0R8b:P03C4`jA4@ZA3XZ
00E4>RX02cY46D@j:SXj8Ta48VED<VEU>UaLC6ED<VEU>UaLC4a<>P02A3XR
00A4A2Y4A39LG4aLG4`2C4a400Q<C3Y<C4A4>RY4A38j>R94>R9<C3Y4A2X2
C4`j00A<C4A<C3Y4A2YUE382C4a400eLG4`jA1U<C4A4>R9UE394>RY4A38R
<RY4A2Y<C3Y4A38j>S8j>R800TA4<P05A3XZC4a4C4a4C4a4A4@b00=<C3X0
63Xj8TA4<TA4<TA4:TA4C4A4:SXj8T@j8T@Z8TA4:SY46B8Z:T@j8SXj8Ta4
8TA4<T@j:TA4:S8Z8SXj8RXR6D@Z8S8Z8R8b:P8b:R801B8b:S8Z8R8R4BXR
6ATR8P026ATA1R8R4@8A4A401P00014A4A4A4@00014A4@0000@A4A4012XR
6A4A4B8R4BXA208000001ATI4DA4C3YDG5b7SeA]MP02C7In00ADKGI<E6e<
E6e<E6d2E6ef00<jE5`RC5A4A4`00SYDG007>TA<A4A<>UALC5A]>UALC5A]
>Uaf009<E6d00eA]MSYDG<c<c01fc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^3?<c<`0114A4@00014A4@00008A4A420000114A4@80000;4A4A
00D0000A4A40000A4A4I6A400a4A4@0400004A4A4A4A00001a4A4@040000
4A4A4A4A00000a4A4@0300004A4A4A4A00@A4A401@00014A4@00014A4@00
00054A4A00<I6AT0000A4A40114A4@0500004A4A000000004A4A00<00000
114A4@0000000000008I6A400`00014A4A4A4@0200001A4A4@0300004A4A
:Q48008000000bXA214A4BXA2002:Q480`0000038R8A4A4A000000<00004
4A4A00HZ4@PI6A4A4A4I6A4A4A4I6A424A4A00DZ4@PA4A4A4A4I6ATA4A40
0QTI4@064A4A6ATA6ATA6ATA4A4A6ATI0Q4A4@036ATA4A4A4A4A00<I6A40
1BXR6ATI6B8R4BXR6ATR8P02:R8I0c8Z8P0?A3XZ<RXRA4@ZC4@R<RXRA4@b
C4`j>SXRA4@ZA3XZC4`j>SXbA3XZ>T@bA3XZ0094A3803cXj8T@j:TA4:SXj
8TA4:SXj<SXj8S8Z8TA4<SY4<SXj8T@j:S8Z8SXj<T@j:P02>SXR00=4>R94
A394>RX00Ta<A00A>TA<A4@bA4@b>T@IA3XRA4@ZC4@RC4`jC4a4C4`jG5a<
C4`jIE@bC4`jA4@Z>T@bC4`j0094A3801Ta<>Ta<A4a<A4a<A3Y4<TA4<P8j
A1T00da48T@j8Ta<A002C4`j00E4A2Y<A29<A28j>S9LG4`01Da<>P9UE382
C4a40TA4<P04A3XZA4@bA4@bA4@b0TA4:P94A38014@j:TA4<T@j:SY46@=4
A3801da<>Ta<A4A4:TA4<Ta<>TA4:T@j8P02A4@b0114A2Y4A4a4A2Y4A2Xj
>S8b:R94A38jA1Tj>R94>R8R<RXj>R8R:RY4>RXb:R8Z8QT26ATA00<R8Q4Z
8QTI6A40114A4@07:R8I6ATA6ATA6ATA4A4A6ATA000000<A4A401ATI4A4A
4B8R4A4A4@0000024A4A0P000009A2XRA4@bKHMnOXn?KHMnMYNaKHnGKGj?
C7In009]OXl02Ea]QeafOUafOUafOUa]MUA]MSYDG5a]MUAnOP02E6ef0TaD
K@03>TA<>UAL>UAL008jE5`01DaDKCYDG4afOSYLMUA]MP1gc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^3?<c<`01A4A4@000000014A4@000002
4A4A0`0000DA4A400aTI4A4A4A4A4@024A4A00@0000A4A40000000064A4A
00<0000A4A4A4A401A4A4@8000000a4A4@00014A4@0:4A4A00@0000A4A4A
4A4000064A4A00L0000A4A40000A4A40000A4A4Z4@P00a4A4@0900004A4A
4A4A00004A4A00004A4A00004A4A008000024A4A00T0000R8Q4A4A40000A
4A4R8Q4A4A40000Z4@P0114A4@0;:Q48000000004A4A00006ATA4A4A:Q48
00004A4A:Q4800<000001Q4A4@00014A4A4A4@0002XA208A4A4011TI4A4A
4A4A4A4A4@8I6A400b8R4ATI4ATI4@036ATA0Q4A4@056ATI8R8A8R8A6ATI
8R8A008Z8QT3<RXR00]4>RXj>S8b:R8b:R94:R8R<RXj>S9<A294A2XjA39<
A2800dA4:P058S8Z>T@bA4@ZA3XZ>SXb0094>RX05DA4:QTI6C8Z8RXR6E`j
8SY46C8Z8T@j8SXj<Ta48TA4:TA4<TA4:Ta<>SY4<T@j:TA4<UaLC4@j:TA4
:TA4<P02C4`j00e<C4A4A38jA39<C4@j>R9<C4@jA39<C4ALG4`jA39<C3Y4
A2Y<C3X00TA4<P0;A3XRC4a4A4A<A4@bA4@Z>SXRA4@ZC4`jA4@ZC4@RA3XR
0094A3801cXj8SXj<TA4<TA4:VED<UaLC6EU>P02C4`j0UaLC004IFDjC4`j
C4a4IE@b0Ta<>P04A4@bIE@bC4a4A4@Z0Ta<>P09A4A<A2XRC4`j>SXRC4@R
A3XZC4`jA4@ZA3XR00=4A3801Ta48TA4<VEU>Ta<>TA4<VED<P94A3800da<
>TA4:TA4C002A4@Z0SY4<P07>SXRA4@Z8S8ZA3XZ>SXRA2XRA4@Z00=4>RX0
1S8Z8R8b:S8Z8S8Z8RXR6C8Z8P@R8Q40214A4BXA21TI4ATI4A4A4BXA228R
4ATI4@@A4A400aTI4BXA21TR<P024A4A00L0000I6A4A4A40000I6A4Z8QTj
>S800P00000>KFeDShM]WjVYUkW:WjVYQiNYMYNaKHnGKGj?G8NGSiN?Qina
Qgj?KHnG0XNGZ@03SiN?QiNYQiNY00:7UjT01FenSeafOVenSeb7SfenS`02
G8NG00UDKGI<E6e<E6dRC5A<E6djIHLA4A40000jG7H0Mlc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Pcc<c<00@0000A4A40000A4A4400000Q4A
4@0300004A4A4A4A008A4A400`00014A4@00000;4A4A00<0000A4A4A4A40
3Q4A4@0700004A4A00004A4A00004A4A000000DA4A4300000a4A4@030000
4A4A4A4A00TA4A400`00014A4A4A4@024A4A0P0000094A4A00004A4A0000
6ATI4A4A0000:Q484A4A008000054A4A00<0000A4A4000000P0000038R8A
6ATA000000D000024A4A00P0000Z4@PA4A40000I6A4A4A4I6A4R8Q446ATA
00PI6ATR8Q4I6ATR:RXI8R8b:R8R:RXZ8QT3<RXR00dR>S8b:R8j>R8b:R94
A38jA394>RXR>S8R:RXb:R8Z8QTR>S8j>S800SXj8P8R<RX0228Z:R8b:R8b
:T@Z8T@j:SY46CXj<S8Z8P<j>R800d@j:SXj8TA4:P02A3XZ01DjA4a<C4A<
C4@jA394>RY4A39<C3Y4A394A2XjA39<C3YLG4a4A2Y4>R9<C4@jA394A2Y4
>RY4A2Xj>R8jA38014A4<P0?C4`jA4@Z<RXRA4@b>T@bC4`jA4@ZC4`jC4a4
G5a<C4a4>SXRA4@ZA4@b>SXR0094A2X2C4`j0dA4<P03A3XZC4a4IE@b00=<
C3X01CY4<Ta<A4a<A4a<>VED<P02C4`j00eUG2Y<C3Y<C3YLG4a4A394>RY<
C3YUE394A39<A29<C3YUICY4A3800UaLC008C4`j>TA<A4@bA4A<C4a4C4`j
A4@bC4`j0Ta<A003C4`jC4a4C4`j00=4A3800dA4:T@j:TA4:P05A3XZ00=4
A2Xb:R8R<RX0138Z8P8R8Q402S8Z8RXR6B8R4BXR6ATR8RXA22XR6ATI4A4A
4BXA208A4A400`00014A4A4A4@024A4A00<I8S8Z4@PA4A400Q4A4@048RXZ
A4@Z4A4A00000Q4A4@8000001aTI6ATI4A4A4A4A4@0008na`HNGZ@02KHnG
00=<OXm]SiM]SiL00XNGZ@04KGj?G6f7E7inKGj?0Vf?U`9]OXl00ff?Ueb7
Sff?U`02KGj?00Q]SiMLQiM<MWiLQhlRC5@R>S9<KHM]OXl2000000ELKHMD
OWhI6A40000RA3X0Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pc
c<c<00L0000A4A4A4A40000I6A40000A4A400P00014A4A400`00014A4A4A
4@044A4A00@0000A4A4A4A4000024A4A00<0000A4A4000001a4A4@030000
4A4A0000008A4A401@00014A4@00014A4@0000034A4A00<0000A4A400000
0a4A4@<000024A4A00<0000A4A4000000a4A4@0400004A4A00004A4A0P00
008A4A4011TR8Q4A4@000000008A4A401000014A4ATI4ATI4@8A4A401RXA
20000000014A4@0002XA20800002:Q480P0000054A4A:Q484A4A0000C288
008I6A402SXj<R8b:S8Z8R8b:QTR8R8Z:R8b:RXR6C8Z8QTR8P<b:R801B8Z
:S8Z8R8b:SXj<R8b:P028RXZ010Z8QTR:RXb:R8Z8QTR<RXb:R94>RXb:R8j
>R8R<RXj>R8b:R8R>S8R<RXb:R94>RX28S8Z00a4>RXb:R94A2XjA4a4>RY4
A2XR<RXj>S8jA394A2Xj>S8j>R82>T@b0TA4:P0=>SXbA3XZ>T@bA4@bC4`j
A3XZ>T@IC4`jC4@RA4@ZA3XRA4@ZC4@R0094A2X014A4<Ta<>TA4<TA4:PA<
C3X01Da<A4a<>UaLC4a<A6EL:P02C4a401i<C3Y4A394>R94>RXb:R94A2Xj
A394>RXjA1U4>RY4A39<C4A4A39<C4A<C3Y4A38jA39<C3Y<C4AUE39<C3Y<
A294A39<C3Xj>S8jA1U<C3YLG4a4A2YLG4`2C4`j0UaLC008C4@RC4`jG5a<
G5a<C4a4C4`jA4@bC4`j0TA4<P94>RX2A4@b00Q4>RXj>S94A4a4A38j>S94
A2Xj>R94A2X2>SXR00A4A2Y<A294>RY4>RX2>SXR00<b:R8j>R8R<RX00S8Z
8P038R8A6ATI8RXZ00<R8Q400bXA214A4ATI4@058R8A00<Z4@PA4A4A4A40
0a4A4@8I6A424A4A00DR>S80000A4A40000A4A400R8R4@03:R8I4A4A4A4A
00<A4A40300001TI4ATI6A4A4ATI6ATR<Vf?/Gj?SeafOUa]QeA]MTafOP9<
KHL00ff?UfenSeb7S`02E7in00=LQhmDOWi<KHL00SYLMP0B8T@jC7InIINa
0000<SY46ATA00008S8Z0000>UALG7In<SY40000A9n?KGj?C6f700006E@b
Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00TA4A400000
000A4A40000A4A40000A4A4000001A4A4@0300004A4A4A4A00LA4A400aTI
4ATI6@0000074A4A00<0000A4A4A4A403A4A4@03:Q484A4A000000HA4A42
00000a4A4@03:Q484A4A000000dA4A4011TI4@000000014A4@8000003a4A
4ATI4A4A4A4A4@0002XA214A4@0001TI4B8R4ATR8RXR6B8R4@00014A4@02
000000@A4A4Z4@PR8Q4Z4@P2000000lZ4@P000000000000Z4@P0000A4A40
000R8Q4Z8QTI6ATZ8QTI8R8Z8QTI6AT00c8Z8P03:R8I<RXR8R8A008b:R80
128b:S8Z8S8Z8R8R4@8Z8QT0228Z:S8Z8S8Z8T@j:SXj8S8Z8R8b:TA4:P8b
:R804CXj8TA4<SXj8TA4<SY4<SXj<T@j:SXj8R8b:T@j:R8b:SXj8R8b:RXR
6DA4:SXj8S8Z8P02A3XZ0TA4:P05A4@bC4`jA4@bIE`ZA4@b009<C3X02TA4
<Ta<>Ta<>UaLC4a<A6EU>Ta<A4a<>Ta<A4a48P9<C3X03Da<A4a<>SY4<Ta<
A4A4<Ta<>UaLC4a<>UaLC4a<A4a<>SXj<Ta<>P03A4@b00/j>R94A394>RY4
A2Xb:R9<A294A4a4A2Xj>S8j>R9UE3800TA4<P07IE@bC4`jC4`jC4`jG5a<
C4`jG5a<009UICX036ED<SY4<T@j:TA4:S8Z8TA4:TA4<T@j:Ta48TA4:Ta<
>T@j:P8jA1T01dA4:T@Z8SY46DA4:R8b:SXj8Ta<A003C4`j00AUE39<C3Y4
A394>RX2A4@b00Xj>S94>RXb:R8j>R8b>T@R8Q4I8R8Z8QTb:R8I6AT2:R8I
0QTI4@044A4A:Q48:Q4800000Q4A4@8I6A444A4A00X0000I6A4A4A4R8Q4Z
4@PI6A4Z4@PA4A4Z4@PA4A42:Q4800<I6A4A4A4000000P0000084A4A:R8I
:R8I8R8A6ATA00004A4A00000Q4A4@8I6AT05@00038Z8P0001TR8WJG/Ff?
Ugj?SinYZHnGSdanUfefMTafOUA]MR9<E4anUcY4C00004anSaTI4@0006e]
E0020000010jE5`A4A4I6ATjA4`0000I6AT0000jE5aDMYMLQiL0000I8R9L
QiMfUk4A4A40001gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<
c<`24A4A00<0000A4A4A4A400Q4A4@0300004A4A4A4A00LA4A400`00014A
4@0000024A4A00@0000A4A4A4A4000024A4A00D0000A4A4A4A4A4A400000
1Q4A4@0300004A4A4A4A00@A4A400`00014A4@0000044A4A00`0000A4A4A
4A4A4A40000A4A4Z4@P0000A4A40000A4A4000024A4A00H0000A4A4A4A40
000Z4@P000024A4A00<0000I6A4000000Q4A4@040000:Q484A4A00000Q4A
4@08:Q484A4A00004A4A00004A4A00004A4A0R8Z:P07:R8I<RXR8S8Z0000
4A4A0000:Q48008000000aTI6@0002XA2002000000<A4A4000000000114A
4@05:R8I8RXZ:R8I:R8I8RXZ00<Z8QT06b8Z:S8Z8RXR6C8Z8QTR8S8Z8RXR
6C8Z8RXR6B8b:RXR6B8Z:RXR6B8R4C8Z8R8b:QTI6C8Z8R8Z:SXj8S8Z8SXj
8S8Z8R8b:S8Z8T@j:RXR6@02>SXR0T@j:P06>SXRA4@ZA2XR>SXRA3XZC4`j
0TA4:P05C4a4A4A<>T@bA4@ZC4a4009<C3X3A4@b00lj>R94A39<C3Y<C4AU
ICY<C3Y<C4A<C3YLG4a<C4A<A29<C3Y<C4@j>R8R<RX00T@j:P03<RXRC4`j
C4a4009<C4@3C4`j00ALG4a<C4ALG4aUICX3C4`j00iLG4a<C3YLG4a4A394
A2Y4A39UE394A394A2Y<C4A4A39<C3Y<C4A4A382A3XZ00Q4A2Xj>S94>RXj
>R94A2Y4:R94>RY4A2X2A4@b0TA4:P08C4a4A4@ZA4@bA3XZA4@bC4`jA3XR
A4@b0T@j:P0HG5a<C4a4A4@bA4A<A4@ZA3XZA4@ZA4@bA4@Z>T@bA3XZA4@b
>T@I<RXRC4@R<RXR:R8I>T@IA3XZ:R8I6ATA8RXZ6ATI6ATA0Q4A4@03:Q48
00004A4A00<A4A42000000hZ4@PR8Q4Z8QTR8Q4j>R8Z8QTI6AT0000A4A40
000A4A40000A4A4j>R838R8A00HZ4@P0000A4A4A4A40000R8Q42<RXR00<R
8Q4A4A4A4A400Q4A4@0?00004A4A4A4A6B8R:R8I6B8R0000C7jGKGj?G7In
6GIf>TA<E7inKHnGOXn?008000006B8b:Ua]Q`00028bA4afOP00029<E1TI
4A4A4@00014A4ATR8UaLC00001TI4@0001UfMXNGZFF7ZDa<>P00029<E6f?
UeA]MP00001gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`2
000000<A4A40000000000P0000046ATA000000000000114A4@0300004A4A
4A4A00TA4A401@00014A4ATI4A4A4@0000044A4A00<I6A40000A4A400Q4A
4@0300004A4A4A4A00DA4A400`00014A4A4A4@094A4A00<Z4@PA4A4A4A40
0Q4A4@076ATA:Q486ATI6ATI:R8I6ATA8R8A008Z8QT01RXA21TI4BXA21TI
4BXR6A4A4@800000114A4@00028R4BXA208A4A401BXA228R4A4A4A4A4@00
0002A3XZ00=4A2Xj>R9<A2800P000006:Q48000000004A4A0000:Q480P00
0003:Q480000000000<A4A42000000<b:R8R:RXR:RX00S8Z8P0@8RXZ:R8I
<RXR<RXR>SXR8S8Z8SXb8S8Z<RXR8RXZ<RXR8RXZ<RXR>SXR8RXZ8R8A0S8Z
8P05A2XRA3XRA4@ZC4`jA4@Z00=<C3X01D@j:SY4<SXj8SY4<TA4<P02A3XZ
00dj>S8jA394>R9<C3XjA394>RXR<RXj>R94>RXR8Q54>RXj>R8jA1T00T@j
:P05A4@ZC4a4C4a4A4@bA4A<0094A3802D@j8Ta<>Ta<>Ta<>SY4<T@j:TA4
:T@j:TA4:P03C4`j00=UICYLG4aLG4`00Ta<>P9LG4`02VEU>Ta<A5aLC4a<
A4a<>Ta<A4a<>TA4<T@j8Ta<A09<C3X2A4@Z00E<C4A4A2Y<C4A4A2Y4>R80
0cXj8P0@<RXR>SXR>SXRC4`jA4@bA4@ZA4@bA4A<A4@ZC4`jC4@RA4@b>T@I
A4@bC4`jC4a40TA4:P09C4a4A4@ZC4@RA4@bC4a4C4`jA4@ZA4@bC4a400<j
>R800d@j:SXj8S8Z8P02<RXR00DZ8QTI6ATZ8QTR8Q4Z4@P00aTI4@080000
4A4A0000:Q484A4A00004A4A0000114A4@068R8A6ATA6ATA>TA<6ATA:R8I
0Q4A4@04:Q486ATA:Q488R8A0RXA20064A4A000000000000>SXb8R8A0S8Z
8P03:Q484A4A000000800000214A4BXR6ATI4B8R4ATR8P00014A4@00008A
4A402000028Z:QTI4BXA2000014A4Eb7UhNGZ@<00000629<E6f?Ua4A4A4A
4@0005b7Sc8Z8P0006f?UbXR6@0004a<A000014A4@00014A4FFG/ATI4A4A
4ATI4@0001UfMUb7Uff?U`8000000ff?UgJG/@00001gc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^3?<c<`74A4A00<0000A4A4A4A401Q4A4@03
00004A4A4A4A008A4A401`00014A4A4A4A4A4ATR8P00028R4@044A4A00<I
6ATI6A4I6A401A4A4@066ATA4A4A6ATA6ATI4A4A6ATI0QTI4@04:Q48:R8I
6ATA6ATA0QTI6@0:6ATA6ATI<RXR6ATA6B8R:R8I6ATA6ATI6ATA4A4A0QTI
4@034A4A6ATA6B8Z008Z8QT02d@Z8S8Z8T@j:T@j:Ta48Ta<>T@j:T@j8R8R
4ATI4@0000024A4A0`000005:Q484A4A8SXb6E@bA4@Z008000001Da<>QTR
8QTR8RXR6B8Z:P02:Q480P00008Z4@P0214A4D@A02XA22XA2000014A4@00
014A4@<0000011TI4B8Z:S8Z8S8Z8P8I8R828R8A0S8Z8P05:R8I<RXR8S8Z
<RXR>SXR00<b:R802T@j:S8Z8R8b:TA4<SXj<R8b:R8Z:S8Z8R8b:TA4<P94
>RX01SXj8TA4:SXj<T@j:S8jA4a<>P8j>S8023Xj8R8j<T@j:QTI6CXj8R94
>TA4<Ta<>P94A2X00da<>T@j:SXj<P02A4@b00a4A4a4A394A2Y<C3Y<C4A<
C3Y4>RY4A39UICY4A4a4>R94A2X2<RXR00I<C4A<C3Y<C3Y<C3YLG4a<C4@2
C4`j00M4A39<C3YUE39<C4A4A39<C3Y<C4@00TA4<P06A3XZC4`jA4@ZC4`j
C4a4A4A<0Ta<>P08A4@ZC4`jA4@bA3XZ>T@bA4@bA3XZ>SXR0T@j:P04A4@Z
C4@RA4@bC4`j0VED<P94A2X01CY4<TA4:Ta<A6EL:Ta<A003A4@Z00Q4>RY4
A2XjA394>RXR<RXj>R8b:R8R<RX3:R8I00PI6ATZ8QTI6A4Z8QTI6A4A4A4I
6A4Z4@P26ATA00@R8Q4A4A4A4A4I6A434A4A0QTI4@0400004A4A:Q48:Q48
0R8R4@036ATI4A4A4A4A00<A4A400aTR8P00014A4@02000000<R>S8R8Q4R
8Q400RXR6@088R8A:Q4800004A4A00008R8A8T@j:Q480Q4A4@8000024A4A
0`0000064A4A6ATA4A4A6ATI4A4A00000QTI6@084A4AG5a<:R8I4A4A0000
>VFGKHnGG5a<0`00000B>UAL00004A4A0000C6f7E6ef0000G8N?>TA<0000
E6ef4A4A0000G6ef00006GIfKHnG00000Q4A4@0800008S8ZKHnG8SXb0000
C7jGKGj?>UALMlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<
0Q4A4@066ATI4A4A000000004A4A0000114A4@036ATA4A4A4A4A00@A4A40
1aTI4@0001TI4A4A4@0001TI4@0000024A4A00LI6A4A4A4Z4@PI6A4I6ATI
8R8I6AT00RXR6@0<<RXR6B8b<RXR<RXR8RXZ6B8R:R8I>SXb8RXZ:R8I8RXZ
:R8I0QTR8P08:R8I<RXR6B8R:Q488R8A6ATA6ATI:R8I0QTI4@03:R8I6ATA
:Q4800<A4A406BXA21TI4B8R4B8Z:RXR6CXj8R8b:RXR6B8b:S8Z8QTI6C8Z
8RXR6ATI4@00014A4B8R4@00014A4BXA200001TI4B8R4CY46B8R4@020000
00Q<C4@j>S94A38j>S94>R80000A4A4Z4@P2000000DI6A40000Z4@PZ4@Q4
4@000RXA200=8RXZ00004A4A4A4A6ATA8RXZ>SXR8S8Z>SXbA3XZ8SXbA4@b
8T@j008R<RX00dA4<T@j:S8Z8P04<RXR00LR:RXb:R8b:R8b:R8I8R8b:R8I
8R800S8Z8P04A3XZ>SXR<RXRA3XZ0S8Z8P09>SXbA3XZA4@b>SXb>SXRA3XZ
>T@b:R8I8S8Z00=4>RX03dA4<TA4:TA4:TA4C3Y46CXj<TA4<Ta<A4A4:TA4
<Ta<>Ta<A4a<>T@j:Ta<>P02A4@b00Y4:R8jA1U4>RY4:R94>RXjA1U<C3Y4
A4a4>RY<C3X3C4a400]4A39<C3Y<C3Y<C3YLG4a<C4A<C3YLG4`jA394A394
A2X00TA4<P07C4`jA3XZA2XRA4@bA4@Z8S8Z>SXR0094>RX00d@j8T@j:TA4
<P03A4@Z0T@j:P03>SXbA3XZA3XZ008b:R801TA4:RXR6C8Z8S8Z8R8Z:S8Z
8P8Z8QT0238Z8RXR6BXR6BXR6B8R4ATI4BXR6ATI4@8Z8QT02ATI4BXA21TI
6BXA228R4BXA21TI4BXA21TI4@024A4A00DZ4@PA4A4A4A4A4A4000000Q4A
4@<000001BXA24A4<T@j8P0001TI4@03000000HI6AT00000000A4A40000Z
4@P24A4A00@0000A4A4I6A4I6A424A4A00<I6A4Z4@P000000P0000044A4A
>TA<00004A4A0QTI4@@000001dA4<T@j8TA4<R8Z:P0002XR6@0000034A4A
00@0001<C4@I6ATI6AT24A4A00]LQhn7UjTA4A5DKGHI6A4I8R80000jE5a<
KHM<E6e<KHL010000004E7inG5a<0000C7jG0P00000<MYNa4A4A0000G8N?
6ATA0000C7j?G8N?6ATA8T@jG8N?G7InMlc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Pcc<c<00@I6ATA4A4A4A4000034A4A00D0000A4A4A4A4A
4A4I6AT00Q4A4@05:Q484A4A6ATI8RXZ4A4A008I8R800b8Z:QTI4B8Z:P02
6B8R00PR:RXI6ATI6ATR:RXI8R8R8Q4R:RXI6AT26B8R00@I6A4Z8QTI6ATI
8R82:R8I02LI8R8b:R8I6ATI8R8Z8QTI6ATZ8QTI6ATR8Q4I6A4Z4@Pb:R8I
8R8Z8QTR:RXZ8QTI8R8Z8QTR8Q40000A4A4Z4@PA4A4Z4@PI6A4A4A4I6ATA
4A4I6A4Z4@PR:RY4:R8R<RXb:R94>RXjA1TI6ATZ8QTI6A400P000004:R8I
0000000000000a4A4@0;>T@I<RXR4A4A0000C4a4A4@bC4a4A4@bA4@Z:R8I
4A4A008000002BXA228R4@0004@A028R4B8Z:RXR6@0001TI6@03000000HZ
8QTj>S8R<RXI8R8Z8QTI6AT2<RXR00LI8R8b:R8R:RXR:RXb:R8R:RY4:R80
0R8Z:P04<RXR>SXb8S8Z:R8I0S8Z8P0AC4`jA4@Z<RXR>T@IC4`j>SXbA4@Z
A4@b>SXbA4@bA4@Z>T@bA4A<A4@Z>TA<C4`jA3XR00=4>RX00dA4C3Xj<TA4
<P02>SXb0T@j:P07A4@ZA4@bIE@bA3XZ>SXbA4@bA4@Z009<C3X024A4<Ta<
A4a<A4a<A4A4:TA4C5aLC4a<A09<C3X01TA4<Ta<>SY4<SY46DA4<SY46@8b
:R82A3XZ00<b:R8j>R94>RX014A4<P0<A4@Z>SXb>T@I8S8ZC4a4<SY4>SXR
A4@ZA3XZ>SXR<RXR8S8Z0S8Z8P058RXZ:R8I:R8I<RXR6B8R00<Z8QT00b8R
4BXR6BXR6@038R8A00@Z4@PZ8QTI6A4Z4@P2:R8I00XI6A4I6ATR8Q4R8Q4I
6A4I6ATZ4@PR8Q4A4A4R8Q426ATA00<A4A4I6A4Z4@P00a4A4@03:Q484A4A
4A4A008A4A43:Q4800@A4A4I6A4A4A4000034A4A00Db:R8A4A4A4A40000b
:R800Q4A4@<000000b8bA000014A4@03000000<A4A40000I6A400a4A4@80
00001CXj<RXR6C8Z8S8Z8P0000034A4A00L00014A394>RXR<RXR:RX0000I
8RX00Q4A4@0<6B9<4A4A4A4A00006ATI4A4A6ATI6B8Z6B8bG8N?KGj?KHnG
0a4A4@0J8T@jG6f7E6efE7in6ATA00004A4A00008TaDQiNY00004A4A:R8I
0000E7inA4A<00008T@jG7In00004A4AC7jG8SXb00008TaDE6efMlc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<0QTI6@<A4A4200000Q4A
4@08:Q488R8A6ATA6ATI8R8A6B8R8R8A6ATI0b8Z:P078SXb6ATI6B8R:R8I
8RXZ6B8R:R8I008R8Q405QTI6BXR6BXR6ATR8R8R4C8Z8RXR6C8Z8RXR6ATR
8SXj<QTR8R8R4B8Z:QTR8R8R4ATI6BXR6C8Z8QTR8QTI4ATR8P8Z8QT02QTI
4B8R4ATI6B8R4BXR6ATI4BXR6ATI6B8R4BXA208I6A403RXA214A4A4A4ATI
4BXA228R4BXR6ATI6B8R4D@Z8Ta48T@Z8T@j8U`j8P8R<RX0200002XA214A
4@0002XA200002XA214A4@8Z4@P02aTI6@000000038Z8TA4<TA4C28b:SXj
<RXR6BXA214A4@03000000@A4A544@14:R94>RX26ATI00LR<T@I8RXjA4a4
>RXI8R8Z8QTb:R800R8Z:P04A3XZ8RXZ<RXR8S8Z0RXR6@0?8S8Z8SXb<RXR
8S94A2XR8SXb>SXbA3XZ8RXZC4`j8SXb<SY48S8Z8RXZ<RXR008R<RX00bXR
6CXj<R8b:P02>SXR00db:R8Z8QTj>R8j>R8j>S94>RXZ8QTR<RY4>RXj>R94
>R8j>R94A2X00TA4<P0JC4`jA4A<C4`jA4@b>TA<A3XRG5a<C4`jC4a4G5a<
>T@bA3XZ<RXRA3XZ8S8Z>SXR>T@b>T@I>T@bA3XR>T@bIE@bG5a<A4@ZA3XR
A4@b0Ta<>P08A4@ZC4`jA4@Z>SXbA3XR8SXb>SXRA2XR0S8Z8P038RXZ<RXR
<RXR008b:R8022XR6C8Z8QTI6B8R4BXR6B8R4BXR6ATI6@8R8Q4012XR6ATI
6ATI6BXR6@8R8Q404RXR6B8R4B8R4B8R4BXR6B8R4ATR8R8R4ATI4BXR6B8R
4BXA21TR8R8R4BXA214A4ATI4BXA20<A4A400bXA214A4A4A4@024A4A00D0
000A4A4A4A4A4A4I6A40114A4@0400004A4A000000000Q4A4@8000024A4A
00<0000R8Q4A4A400P00008I6A402000014A4A4A4@0002XR6A4A4@00014A
4@<b:R800d@j:S8Z8P000002000000LA4A40000Z4@PjA38R<RXZ8QTA4A40
100000066B8R8R8A8R8A6ATI0000<RXR0P00000<6B8b6B8Z4A4A8R8A6ATA
4A4A00004A4A0000E7inKHnGC7In0P00000KC4a40000C7j?E6efG6f7<SY4
00004A4A00004A4AG8NGKHnG00006B8R0000>UafC5A]00004A4A6B8R6ATI
0000<RXR00004A4A0000>UAL07O<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h<lc<c08A4A402000014A4@000000014A4@00014A4@0000<R:RX0
4C8Z8TA4C4A4<SY4C4a<A4A4<Ta<>S8Z8R8b:SXj<S8Z8R8j<QTR<S8Z8QTR
8R8Z:QTR8P038RXZ00dZ4@PA4A4R:RXI8R8I6ATI8R94:R8I6ATI8S8Z8QTI
8S8R8Q4I6AT00QTR8P0>6ATI:Q48:R8I6B8R6ATA8RXZ6ATI6B8R6ATI6ATA
6ATI:Q484A4A6ATA0Q4A4@0300004A4A0000008A4A402d@j:Ta<>VED<Xmf
IFEL:VED<Ta<A4@j:S8Z8TA4<QTI6@024A4A00d0000R8Q4A4A40000A4A40
000Z4@P0000Z4@PI6A4A4A40001<C4@00SXj<P94A380128b:RXA20000000
008A4A401`0004@A03Y46B8j<S8Z8Q4A4CXj8P02G5a<00Dj>R8b:R8j>S8R
A3XR:RX00S8Z8P8Z8QT06c8Z8R8Z:S8Z8RXR6C8Z8R8Z:R8b:RXR6B8b:S8Z
8R8b:RXR6A4A4B8R4BXR6B8R4C8Z8T@j:S8Z8RXR6CXj<SXj8T@j:SXj<TA4
:TA4<Ta<>P02>SXb00=4>RY4A2Y4>RX00TA4:P03>SXRA4@ZA3XZ0094A380
0dA4C4A4<Ta<>P02>T@b00A4A2Y<C3Y4A2XjA382A4@Z00Q<C3Y4>RY4A2Y4
>RXjA394>RXj>S94>RX2>SXR00A4>RY4A2Xb:R8j>R82<RXR0R8b:P08<RXR
:R8I<RXR8S8Z6ATI:R8I8RXZ<RXR0RXR6@8R8Q4011TI6B8R4BXR6B8R4@<Z
8QT00bXA22XR6ATI4@028R8A0RXR6@<R8Q401QTI6B8R4ATI4ATI6B8R4A4A
4@8I6A428R8A00PZ4@PA4A4A4A4I6A4A4A4I6A4A4A4I6A424A4A00P0000A
4A4A4A40000R8Q4Z8QTZ4@Pj>R824A4A00<I6A4I8R8I6A400Q4A4@070000
4A4A:Q4800004A4A00004A4A008I6A401a4A4BXA214A4B8R4BXR6@00014A
4@02000000<b>T@A4A4I6A400P000003A4@b000000000080000014@j:R8b
:SXj<Q4A4@800000214A4@00014A4B8R4ATR8R8R4ATI4A4A4@8000000a4A
4@00014A4@044A4A00@I8R8A4A40000I8RX34A4A02D0000A4A40000R8Q40
000jE5a<MWhb>T@0000I6AULMWh0001<OXm<KHMLMWi<KHL0000I8R9<C4@0
000RA3YfUk40000I6A40000RA3Y<KHLA4A4I6A4A4A40000A4A4jE5`Z4@P0
000A4A4IE3801<c<c0800004c<c<0P000003c<c<0000000000<00002c<c<
100000?<c<`400000/c<c0800003c<c<0P0000;<c<`2000000?<c<`00000
000010000004c<c<00000000c<c<0P0000;<c<`2000000?<c<`000000000
0`0003C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c0074A4A
0000000000004A4A00004A4A00800000114A4C8Z8QTR8QTR<P8b:R802B8b
A28Z:QTI6B8Z:QTR8Q4A4ATR8R8Z:QTR<P028RXZ00TI6A4I8R8R:RXR>S8R
:RXR<T@I8R8Z8QTI8R800R8Z:P0=6B8R<RXR6B8R6B8R:R8I6ATI6ATA8RXZ
:R8I8RXZ<RXR8RXZ8S8Z008b:R8032XR6C8Z8T@j:T@Z8S8Z8T@Z8S8Z8R8Z
:RXR6ATI4BXR6ATI4@<A4A401P0002XA21TI6ATI4C8Z8RXR6@<I8R803CXj
8TA4:Q4A4B8Z:RXA214A4@00014A4@0002XA2000014A4@000002:Q480Q4A
4@050000A4A<A4@bA4@b<SY4008b:R800bXR6@0002XA20020000020Z4@Q4
4@0b:R94A38b:R8R<RXZ4@Pb:R8Z4@Pb:R8R:RXI6A4I8R8b:R8Z8QTI8R8R
8Q4b:R8R<RXR:RXR<RXI6A4b:R94>R8R:RXZ8QTj>S94A2Xb>T@j>S8b:R8R
<RX2>SXb00<b:R8R<RXb:R800SXj<P0<>SXRA3XZA4@ZA4A<A4@ZA3XZ>SXR
A3XZ>SXRA3XZ>SXRA3XZ0S8Z8P08A4@bA4@ZA4@Z:R8I>SXR>T@b>SXRA3XZ
138Z8P03:R8I8RXZ8S8Z008b:R800aTI6C8Z8QTR8P02:R8I00<b:R8R8Q4j
>S800QTI6@04:R8I6ATI:R8I6B8R0RXR6@036B8R8RXZ6ATI00<Z8QT00b8R
4B8Z:QTI4@03:R8I00HR8Q4I8R8Z8QTI8R8R8Q4Z8QT28R8A00TZ8QTR8Q4Z
8QTI6ATI6A4Z4@PI6A4R8Q4I6A40128R4@046ATA:Q486ATA:Q480a4A4@06
00004A4A00004A4A00004A4A0P00000;4A4A00004A4A6ATA00006ATI4A4A
00008RXZ00004A4A00@000001Q4A4ATI4@0001TI4A4A4@00008A4A4013Xj
<R8R4@0002XA208R<RX00bXR6A4A4@000002000000HR<RXR8Q4A4A4A4A40
000I6AT44A4A00HI6ATI6A4I6ATA4A40000A4A42000000<A4A4R<RXI6AT0
0QTI6@0300004A4A0000008A4A426ATA00<A4A40000A4A40114A4@046ATA
8R8A00006ATA0a4A4@0?0000C5A]>Uaf8S8Z0000KHMnIINa00006ATI>UAL
6B8bG5a<00006ATIOYni0080000027JG/B94>P00014A4ATI6FenSc8jA000
008A4A400aTI4DaDKB8Z:P024A4A00<0003<c<c<c<`00/c<c0800003c<c<
0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c0800000
0lc<c00000000002c<c<0P000003c<c<0000000000?<c<`2000000?<c<`0
000000000/c<c0800005c<c<0P000003c<c<0000000000;<c<`2000000?<
c<`000000000=lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<
114A4@0J00004A4A4A4A4A4A<RXR0000<SY48S948RXZ6B8R6B8b>TA<8SXb
<SY48S94<SY4:Q488RXZ8SXb6B8R8RXZ6B8R4A4A8RXZ<RXR6B8b0S8Z8P<I
8R80128j<S8Z8R8Z:S8Z8P8R:RX024a<A38Z8S8jA38Z8TA4C38Z8R8Z:SY4
6@8b:R800b8Z:S8Z8S8Z8P02<RXR0R8Z:P036B8R:R8I8R8A00DA4A400bXA
2000000000036ATA00@I6ATb:R8b:R8Z8QT2<RXR00A4>RY4A38jA1T00002
4A4A0RXA20034A4A00004A4A008Z4@P04Q4A4BXA200004a<>R8b:S8Z8R8b
:SXj<T@j:R8R4A4A4@00014A4BXA200004`R22XR6ATR8P8Z8QT3:Q4800DI
6A4Z8QTb:R8b:R8R>S800S8Z8P068SXb8TaD8S8ZA3XZ<RXRA4@Z0R8b:P8b
:R80128Z:S8Z8RXR6B8b:P8b:R80328b:S8Z8R8j<TA4:SY4<SXj8SY46DA4
:Ta<>SXj8S8Z8TA4:P8j>R800b8b:S8Z8S8Z8P03<RXR00<Z8QTI6ATI6AT0
0QTR8P03:R8I6ATA8RXZ008b:R800aTR8RXR6BXR6@03:R8I00TR:RXI8R8Z
8QTZ8QTR8Q4Z8QTI8R8Z8QTb:R800bXR6@038RXZ:R8I:R8I008Z8QT01ATR
8RXR6BXR6B8R4ATR8P02:R8I00<R8Q4Z8QTI6AT00RXR6@038R8A:R8I:R8I
00@R8Q426ATA00TR8Q4I6ATI6A4R8Q4I8R8A4A4R8Q4A4A4I6A40114A4@05
00004A4A000000004A4A008000000a4A4@00000000024A4A00<0000A4A4A
4A40114A4@0F:Q4800004A4A4A4A6B8R6B8b00006B8R<RXR4A4A00006B8R
>T@b00004A4AA3XZ4A4A00004A4A<RXR6ATA00000Q4A4@046ATI:R8I4A4A
4A4A0P0000034A4A<SY44A4A008000000aTI4@000000000200000a4A4@D0
00001A4A4B8R4BXA2000014A4@02000000@A4A40000A4A4000024A4A00<Z
4@PI6A4I6A400RXR6@0=8RXZ<SY46ATA:Q486ATI0000:Q484A4A0000>Uaf
E6ef<SY40000008jE5`01DA4<P000000000004afOP02000000EUUk5<C3X0
000RC5A]SiL00`000003A4A<8T@j0000008A4A401S8jA3YDG3Xj<R8Z:SXj
8R8b:PC<c<`200000lc<c08000000lc<c00000000002c<c<0P000003c<c<
0000000000G<c<`200001Lc<c0L000000lc<c00000000002c<c<0P0000G<
c<`2000000?<c<`0000000000/c<c0800002c<c<0P0003K<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h<lc<c0DA4A401@00014A4@00014A4@00
00048RXZ00@b:R8R:RXjA4`R:RX2<SY400E4A38RC5@b>T@R<RXj>R800S8j
A0048RXZ6B8RC4a46B8Z0R8Z:P0B<RXR8RXZ<RXR<RXRA4@b>SXbA3XZA2XR
C4a4<RXRC4a4C4`jA3XZA4@bC4a4<RXRA4@ZC4a40TA4<P94>RX02dA4<T@j
:TA4<RXR6CXj8QTI4ATI6BXR6ATI4A4A4BXA20034A4A00PR8Q4Z4@PI8R94
>RXb:R8R:RXR8Q4R:RX3>SXb00<R8Q40000000000a4A4@8000000a4A4@00
02XA20024A4A00P0001<C3XZ8QU<C3Y4A38j>S8j>R8Z4@P2000000@R:RXb
:R80001<8PP2<RXR00@R<RXI6A4A4A4R8Q42:Q4800HR<RXb:R8R:RXR:RXb
:R8R:RX2:R8I00@Z4@PA4A4A4A400006<RXR00M4:R8R:RXb:R8b:R8Z8QTZ
4@Pb:R800RXR6@08<RXR6ATI6ATI8R8A8RXZ8R8A6ATI4A4A0RXR6@056ATA
8S8Z:R8I:R8I8R8A008Z8QT00aTR8RXR6B8R4@03:R8I00HI8R8Z8QTR8Q4R
8Q4Z8QTI6AT28R8A00DZ8QTI6ATI6ATZ8QTR8Q400RXR6@05<RXR:R8I:R8I
:R8I8R8A008Z8QT0128Z:RXR6C8Z8SXj8P8Z8QT0228Z:S8Z8RXR6ATI6C8Z
8Q4A4ATI4BXR6@8I6A494A4A0P0000074A4A0000000000004A4A00004A4A
008000084A4A018Z4@PA4A4A4A4A4A4Z4@PA4A4Z4@PA4A4Z4@PA4A40000R
<T@0000I6A4Z4@PR8Q4R<RXb:R824A4A00<I6ATA4A4A4A400QTI6@030000
4A4A6B8R00<A4A402QTR:Q4A4A4A4@0002XA200001TI6A4A4@00014A4@80
00001cXj<Q4A4@00000001TI6@00014A4@02000000<I6A4A4A4I6A400Q4A
4@0700004A4A4A4A00006ATA:R8I8R8A00<A4A40400001TI4A4A4B8j<S8Z
8S8jA1TR8Q4A4BXA214A4@0002XA200002XA228R4BXA20<R8Q4012XA238j
A4afOUA]MP<000002Ff?/@00014A4A4A4B8b:RXR6@00028bA7JG/@024A4A
00A]MWHI6A4Z4@PR:RX2>UAL0TaDK@07G6efE7inKHMnKGIfKHMn>UAL>Uaf
00C<c<`200000/c<c0800003c<c<0P000004c<c<00000000c<c<0P0000G<
c<`600000/c<c08000000lc<c00000000002c<c<0P0000;<c<`200001Lc<
c08000000lc<c00000000002c<c<0P0000;<c<`20000=/c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Pcc<c<00hA4A40000A4A4A4A40000A4A40
000Z4@P0000A4A4R8Q4j>S8jA4`R<T@28RXZ00m4A4`R>S8R:RXR:RXR>S8I
6ATZ8QTR:RXI8RXb:R8R<RY4>RXI8RXA4A4b:R800R8Z:P0I>SXb8S8ZC4a4
C4a4A4@bC4`jG5a<A4@b>T@IG5a<KFeDIFDjKFeDOWi]KFDRKGIfKFeDIFDj
OWIDG5a<KFeDOVe<G5a<IFDjIE@b0094A3800da48TA4:R8R4@02000000@I
6A4Z4@PA4A400002:R8I00@b:R8Z8QTj>S94>RX2A4@b00U4>RXb>TA4>R8Z
4@P0000A4A4Z8QTZ4@P000000RXA20030000:Q484A4A00<A4A42A4@b00A4
A4a4A38b:R8I6AT2000000/Z4@QLKHLI6A4Z4@Pb:R8j>R8I8R8R>S8Z4@PI
6ATjA4`00P000009>T@I6B8R:R8I:R8I6B8R8RXZ>SXb6ATI4A4A00800000
11TI6Ff?^B8R4ATR8P<Z8QT03ATR8RXR6ATI4ATI4B8R4ATR8R8R4ATR8R8R
4BXR6B8R4BXR6B8Z:P028R8A0bXR6@066ATI:R8I6ATI8R8A8RXZ6B8R0bXR
6@086B8R8R8AA4@b6ATA8R8A:R8I8R8A<RXR0bXR6@05<RXR6B8R<RXR:R8I
8R8A008Z8QT00b8Z:R8b:R8R4@026B8R00LI6A4Z8QTI6ATI8R8Z8QTI6ATI
8RX00QTI4@036ATI6B8R4A4A008A4A401aTI6A4A4A4A4A4A4@00014A4@00
00024A4A00D0000A4A40000A4A4000001a4A4@046ATA4A4A:Q48:Q480QTI
4@098R8A:Q488R8A8R8A:R8I8R8A:R8I4A4A0000008A4A401ATI4@00014A
4A4A4ATI4@02000000=4>RX0000R>S800Q4A4@036ATI8T@j000000@A4A40
11TR:P00014A4@0000<A4A402P00028j<RXA214A4BXA21TI6A4A4ATI4BXA
214A4@800000114A4@00014A4@00008A4A4200000a4A4@0>00004A4A0000
00004A4A00006ATA8R8AA3XZ00008R8A:Q4800004A4A0`0000056B8R4A4A
4A4A00004A4A008000000a4A4BXA22XA2002:Q480P000007:Q486ATA:Q48
:R8IC7j?E6ef8S94008000003SYLMUA]MP00000001TR8Ua]Qb8j<SYDG5b7
SdafOTA4C3YDG5a]MUA]MP=]OXl3OXn?00I]OXn7OXm]OXm4A4`b:R8RA3X4
c<c<1P0000C<c<`4000000?<c<`0000000001Lc<c0800002c<c<0P0000;<
c<`2000000?<c<`0000000000/c<c0800002c<c<0P0000G<c<`2000000?<
c<`0000000000/c<c0800003c<c<0P0003G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h<lc<c08A4A400`00014A4@000002000000<R8Q4A4A40
00000P00008Z8QT01QTR8QTI6B8Z:T@j:R8R4ATR8P8b:R800dA4<RXR6D@Z
8P02C4a401ELG4aUICXb:R8b>T@j>S9<C4A]KEAnOVe4>RY]MWI]QginOVe]
Qgi]KEAnKDa]QgjGSgJ7OXnGShM]KEALG4`00YN?Q`0EKHMnOWi]OVEDOWi]
ShM]ShmUOWi]KFeDOVe<MWiL4A4A8R8A6ATI:Q4800008R8A4A4A:Q484A4A
:Q488RXZ0094A3803B8b:T@j:QTR8SXj<S8Z8TA4:RXR6@00014A4@0002XR
6BXA21TI4@03000000`A4A4000000000000Z4@Q<C3Xb>TA<C3YUE39<C4A<
8PPZ4@P2000000<I8R8A4A4Z4@P00RXR6@0E8RXZ:R8I:Q486ATA8TaD:Q48
00006ATA:R8I6ATA:R8I8R8A6ATA8R8A00004A4A0000:Q488RXZA2XR6ATI
008Z8QT011TI6B8R4BXR6ATI6@8R8Q400aTI6B8R4ATI6@028R8A00<Z8QTI
6ATZ8QT00R8R4@LZ8QT02C8Z8RXR6BXR6ATR8S8Z8QTR8RXR6B8R4C8Z8P02
:R8I00/I8R8Z8QTR:RXZ8QTb:R8I6ATR<RXR8Q4Z8QTI6ATI8R800QTI6@03
4A4A6ATI4A4A00/A4A42000000<A4A40000000000Q4A4@8000001A4A4BXA
214A4BXA20000002:Q4811TI4@8A4A400bXA21TR8QTI4@054A4A00<I6A4A
4A4A4A400Q4A4@036ATA4A4A4A4A008A4A4200000a4A4@<000001A4A4@00
03Xj<P00028j<P024A4A00D0000bA7H0000A4A4000001A4A4@0700004A4A
6ATI4A4A00008SXb4A4A00@000026ATA0`0000034A4A0000:Q4800<00000
7Q4A4@00014A4@0002XA22XR6CY4C28b:S8Z8RXR6B8b:QTR8QTI6ATI4CY4
6Da<>Q4A4@0001TI6@00014A4@00014A4@00014A4@00014A4@00014A4@00
008Z4@P00`0001TI6BXA20024A4A00@Z8QT0000Z4@QLQhl2C5A]00@R<RXI
6AU<C4ALMWh2E6ef00ELKHM<KHMUQjUDOWi<E6d00UaLC00?E6efKGj?IHNY
QiNYOXn?KHnGOXn?KGj?E6efC6f78TaD6ATI6ATA:Q48000000C<c<`20000
0lc<c08000000lc<c0000<c<c002c<c<0P000003c<c<0000000000;<c<`2
000000?<c<`0000000000/c<c0800002c<c<0P000003c<c<0000000000;<
c<`200000/c<c0800005c<c<0P000005c<c<000000000000c<c<00800004
c<c<0P0003C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c004
<RXR00004A4A00000a4A4@0<00004A4A00006B8R00006ATAA4A<C4`jG5a<
C4`j<RXRC4a40fe]E004MWiLG3XRKFeDOWIU0fefMP0?KFeDG5a<>UALC4a4
OVEDKGIfKFeDOVeUShM]UhmfOWi]OVeUOWi]UhmfSiN?00:GSgH01HmfIIN?
MYnOOXn7KIn?K@02Uhmf00VOWgj?MVFGSgJOSff?SfFOSffOWghA4A4I6AT0
0aTI4@0:8R8A00006ATA00008R8AA2XR<RXR8R8A<RXRA2XR0TA4<P03IE`Z
C4`j6ATI00<0000025aLC28R4D@A000002XA200001TI4BXA208A4A402BXA
24a<>TA4:R8b:S8Z8QTR8P0002XA214A4@02000000LA4A544@0Z4@PI6A4R
8Q4I6A4A4A400RXA20034A4A00004A4A008Z8QT28RXZ00<Z8QTI6AT00000
0P0000084A4A0000:Q48:Q486B8R8R8A6ATI6B8R0aTI6@058R8A:R8I6B8R
<RXR8RXZ00@Z8QT02R8Z:R8R4BXR6C8Z8R8Z:RXR6B8Z:S8Z8QTR8R8Z:P<Z
8QT01ATI6BXR6BXR6BXR6B8Z:P02<RXR00HR:RXj>S8R<RXR<RXI6ATR:RX2
6ATI0Q4A4@046ATI4A4A4A4A00000Q4A4@0500004A4A4A4A4A4A0000008A
4A42000000TA4A4Z4@PZ4@PZ8QTI6ATb:R8R<RXZ8QU4>RX0128b:P09<RXR
8S8Z8SXb8RXZ8SXb<RXR6B8R8RXZ6ATA008A4A400`00014A4@0000030000
0Q4A4@0400004A4A4A4A4A4A0P0000DA4A400`00014A4A4A4@054A4A00D0
000R>S80000A4A4R>S800P0000038TaD00004A4A008A4A4011TR:P00014A
4@00008A4A401ATR8Q4A4@00028Z:QTI6@034A4A0P0000068RXZ00004A4A
00004A4A00000Q4A4@0:00006ATA00004A4A6ATA4A4A8RXZ<SY48T@j4A4A
1000008A4A401@0001TI4ATI6@0002XA2003000000<R<T@0000000000Q4A
4@0400004A4A00004A4A0bXA200F4A4A:Q484A4A6ATA:Q480000C7jGE6ef
>UALE7inG7InE6efC7InE6efC5A]C7InC6f7C7In>UALG5a<C5A]KGj?0Vf?
U`05KGj?G7InC6f7E6ef>Uaf008jE5`00cXj<P0002XA2002:R8I00<Z4@S<
c<c<c<`00/c<c0800003c<c<0P0000;<c<`400000lc<c0@00003c<c<1000
00?<c<`2000000C<c<`00000003<c<`4000000?<c<`0000000001Lc<c080
00001<c<c00000000<c<c0800002c<c<1@0003C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h<lc<c004IAT0Qa40A140:Q480`0000@A4A404@00
014A4A4A4EaLC6efMXMnShmfA8n7KIN?QhMnShn7KFf7OWinKHn7KIN?QiN?
MYnOS`02Uhmf00UnOVe]KEA]KEA]KEAnMVFOWgjOUhNOSfenOVd00iN?MP04
Win?OWIUSgIUZJV?0YN?Q`0@UhmfShmUWin?Uhn7Win?Whm]ShmU^ImnWiN7
ZJV?Whm]IFDj8R8A<RXRG3XR4A4A0QTI4@0@:Q48<RXR:Q488R8AG5a<QgiD
OWi]MWiLOWIUMWiLC4a4A4@ZC4`j:R8I00004A4A0P0000044A4A00000000
:Q480`0000054A4A00006ATA6B8R6ATI008R8Q401aTI6BXA200002XA2000
01TI6B8R4@04:Q481@0000044A4A:Q488R8A8R8A0RXR6@048R8A:Q480000
4A4A0P0000054A4AA1406ATI8R8A6B8R00@R8Q400aTI6B8R4ATI6@048R8A
00<I8R8R8Q4Z8QT00RXR6@0@8R8A6ATI:R8I:R8I6ATA6ATI8R8A<RXR8RXZ
<RXR8T@jC4a4>TA<>T@b<SY48S940R8Z:P056B8R:R8I4A4A00004A4A0080
00000a4A4@00014A4@0200000a4A4@<R8Q400bXR6C8Z8R8b:P02A3XZ00A<
C3Y4A38j>S8RA3X48SXb00DR:RXI6ATI8R8I8R8I6AT00a4A4@0;00004A4A
8SXb4A4A6ATA0000MYNa8S8Z00004A4A0000008A4A401000014A4@000000
00DA4A400aTR:R8Z:Q4A4@034A4A1000008A4A401@00014A4@00014A4B8b
:P02000000@R<RX00000000RA3X44A4A00@I8RXI6ATI6AT000024A4A00DI
8R8I6AT0000b:R8R<RX00Q4A4@0E00004A4A4A4A8R8A6ATA:Q4800006ATA
00004A4A00004A4A00004A4A00004A4A00006B8b<TAf>UALC6f700800000
0a4A4@0000000002000000HA4A400000000A4A40000A4A42000000<A4A40
000000000P000003:Q4800000000008Z4@P02@0002XR6BXA214A4B8R4BXA
200003YDG3YLMP03C5A]00ADKGHjA4`jE5`jE8L2C7In01@jE5a<E6eLQhm]
OXmLQhmLOYMLMWiDKGILKGI<E6djE5a4A4`jA4a4A4`R<RY<8PPb:R80000R
:RXjA1T4c<c<0P0000?<c<`200006<c<c0<00003c<c<0P0000;<c<`20000
B<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00N?MVFOKDb?
<Tb7C4C1/KVa^JTb>T@00P00000<4A4A00004A4A4A4A6B9<>UALQgj?UgiD
A140IAT0UgiDZJV?0YnGQ`03WimnUhn7Wimn00BOUhL02HnGSginKCXj8VEL
:WinKInGQinOOXn7KGinK@02WiN70YnOOP08UhmfWimnZJV?ZJV?WiN7^Imn
Wimn/K6?0inOOP:GSgH02YnGQk6iUhn7KBXR6DA4:T@j:RXR6A4A4BXA2000
008I6A40214A4@0004@j:UaLC4a<>T@j8SXj<RXR6@8R8Q400aTI6A4A4BXA
20034A4A00D0000Z4@PZ4@PZ4@P000000Q4A4@0:0000:Q486ATI:R8I8R8A
6B8R6ATI:Q480000:Q480P000004:Q488S9400004A4A0P000005IC88C4@R
:Q484A4A0000008Z4@P26ATA01DA4A4R8Q4I6A4A4A4Z4@PA4A40000I6A4j
E5`j>S8I6A4Z8QTR8Q4I6A4I6ATI6A4R8Q4I6ATR8Q4A4A4Z8QT00aTI4@<R
8Q403BXR6ATI6BXR6B8R4BXR6ATR8R8bA3Y4<Ta<A28bA294>R8b:R8Z:P02
6ATI0P0000034A4A00004A4A00<000000a4A4@00014A4@026ATA01@R:RXZ
8QTR<RXj>S8R<RXj>S8j>R8R>S8R<RXjA38RA3Xb>T@R<T@b:R8R<RXR:RXI
6ATI6A4A4A4I6A454A4A00<0000A4A4000000a4A4@09C7In>TA<8TaD0000
4A4A0000C7In6B8Z000000@A4A430000114A4@800000128j<QTI6A4A4@00
008A4A43000000<A4A4I6A4I6AT0114A4@088S944A4A000000006ATA0000
8S9400000Q4A4@036B8b6B8R6ATI008A4A40200001TI6ATR:S8jA000028b
:QTR<Q4A4@8000001Q4A4@00028R4ATI6ATI4A4A4@8000024A4A00@0000A
4A40000A4A42000000DI8S8R>UaLQiLIE7hA4A400`0000044A4A00004A4A
00000a4A4@@000001A4A4@00014A4@00014A4@02000002TA4A4Z4@PZ4@PZ
4@P0000I6A40000R8Q4A4A40000RA3Y]OXljE5`jG7I<MWi<C4@0000b:R9<
C3Y<KHLjA4a<E6eLQhmLKHMLQhm<MWi<E6djE5`jA4`RA3XR:RXZ8QTA4A40
000A4A40001<A28Z8QTZ4@PI6A4Z4@P01<c<c0H0000Ic<c<0`0000C<c<`0
0`000<c<c<c<c00200001Lc<c0800011c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^3?<c<`02bXR6FED<]:aSlc<c9nYZK6a^Lc<c9nOSe`j8Q4A
4@0000024A4A00TR<T@jE8M<E6e<8PQ44@0Z4@Q44@2a^INGShL00inOS`0?
/KVGZJV?^KVG^KVYb[6Y^KVY/KVOSiN?KFeDWimn/KVG/KVYb/6O^KVG/KVY
00:a^Il01k6iZK6iUinGQinOOYnGQiN?MXnGS`02ShM]00f?SfFGSgJ?UhnO
WgjGSgJ?QfenMVD0000R8Q4A4A4Z4@PI6A4R8Q400P00000A4A4A6ATA4A4A
0000KFeDOUa<KFeDIFDjIE@bG5a<C4`jC4a4A3XR:R8I00004A4A:Q480080
00001BXA200002XA214A4BXA2002000000M4:R8Z8QTZ8QTZ8QTb:R8R8Q4b
:R800RXA20046ATA0000000000000RXA2009ID`IWgi<A4@b6ATA4A4A0000
4A4A00004A4A00@I6A401Q4A4BXA200002XA214A4@00008A4A400bXR6ATI
4ATI6@028R8A00<I6ATI6A4R8Q400R8R4@044A4A:R8I8RXZ<RXR0QTR8PDR
:RX00aTR8RXR6ATI6@08000000LA4A40000A4A4R8Q40000R8Q4Z8QT00R8Z
:P09:R8I>SXb8S94A4@Z8S8Z<SY48S8Z>SXb8S8Z00<R:RX011TR8Q4A4ATI
4ATI4@<A4A43000000DA4A400000000I6A4000000Q4A4@0300004A4A4A4A
008A4A401@00029<E6f?^B8j<P0000024A4A00T0000A4A4A4A40000A4A40
000A4A40000A4A400P0000036ATA4A4A4A4A008A4A400b8bA1TR8Q4A4@02
4A4A00DI8R80000A4A40000A4A400QTI6@056B8Z6ATI4A4A:Q486ATI00<0
0000128j<P00028j<P0000<A4A426ATI014A4A40000A4A4A4A4I8R8b>T@A
4A4I6A4I6ATI6A4A4A4R8Q4I6A4b:R8A4A40000A4A400P0000074A4A0000
4A4A00004A4A00004A4A008000001C8jA14A4Dan/A4A4@0000024A4A0P00
00044A4A0000>T@I00000Q4A4@0700004A4A000000004A4A00004A4A0080
0000114A4@0000000000008Z4@P01ATI4@0002XA22XR6ATI6@02000000E<
MWhjE5a<E6e<E6eLG4`00P00000=6ATA8SXb8SXbA4A<>UAL<SY48S946B8b
6B8ZIC88m>?:C2880000008R8Q44:Q480bXR6@034A4Ac<c<c<c<07G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c0094A4A0000<RXR/KVG
/K6ic<c<WjVYSd@ASc9<00:OKD`03FED<TaDKC8jA4aDKBXA24@A02XA24@A
08m44M;:`LZaZKViZL6iW`02^KVY00W:`JVi/Ini/Ina^InOWhn?UhmfOUaL
G4aUICX00Xn7K@09SiN?UhmfUhmfUhmfShM]OWIUShmUSgi]OVe<009nOVd2
SgID0WifI@:7OU@05ginKGInG8n?IHMnE000014A4B8R4ATI6A4A4B8R4D`R
29m<000001TI4BXR6@00038jA9N?MWifIGifE7InG6e]E6EU>P02G5a<015<
C3XR8Q4R8Q4I6A4Z4@P0000Z4@PR8Q4I6A4I8S8bA7HR:RYL>R9<8PPI6A4R
8Q4I8R800aTI4@09:Q480000:Q484A4A:Q48<SY48RXZ8R8A4A4A00800000
0a4A4@00014A4@04000000<I6A4A4A4I6A40114A4@0;00006B8b<SY4<RXR
4A4A6ATI:Q486ATI6B8R<RXR6B8b00<R:RX02SXj8R8b:QTR8RXR6B8R4ATI
4BXR6ATI6BXR6ATI6@8A4A400aTI4@00014A4@044A4A00hI6ATA4A4A4A4I
6ATZ8QTI6ATZ8QTR<RXI8R8Z8QTI6ATR:RXI6ATI8R836ATI0Q4A4@070000
4A4A4A4A4A4A00006ATI0000008I6AT34A4A00@0000A4A40000000044A4A
00<0000A4A4A4A401A4A4@8000000bXA214A4A4A4@024A4A00DZ4@PA4A4I
6ATA4A4I6A400a4A4@0800004A4A4A4A4A4A6B8Z6B8R6ATA6B9<0QTR:P03
6B8R8RXZ8RXZ008000002A4A4@0001TR<QTR8QTR:P00014A4@0004A4<P02
4A4A00D0000b>T@0000R<RX000000Q4A4@096B8ZG8N?C7jG>UAL00004A4A
8R8A>TA<<RXR008R8Q401cY4C29<E38Z8QTI6A4A4@0001TI6@03000000DA
4A40000A4A4A4A4000000Q4A4@8000001CYDG2XA200005B?/A4A4@030000
00<A4A40000A4A400P000003^IM]00008R8A00<A4A42000000<A4A40000A
4A400P000008:Q484A4A4A4A0000:Q480000:Q4800000QTI4@044A4A0000
8RXZ>TA<0SXj<P056B8R:Q48:Q480000:Q4800@000002RXA214A4K5]06DI
0;6iUfDI02XA22XR6D@Z8S8Z8P8R8Q400aTI6C8Z8S8Z8P024A4AMlc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<0Q4A4@<000001C8Z8XMU
</ZaZKVOOVDb2002/K6i00Z7OXn7Wk5U<PQ<8PP0000Z4@QU6@27C4BOWhm]
Qgh2Uhmf00V?Uhn?QfefOUa]QgjOSffGSgInOVenMUAUE3800RXR6@07IE@b
OVeUOWIDOWIDQgiDOVeUMWiL009nMVD2OWi]0hMnE003KHMnUgiDShmU00:?
SfD01HmfA8MnE8mfA7ifE2XR6@026ATA00DZ4@QU6@27C16?MTAU<PP00P00
008Z4@P03@0009N?MXn7KGinKGInG7ifIFe]E6EU>Ve]E6ED<SY46ATI4BXA
2002000000LZ4@PR8Q4Z8QT00014A3:7C4@000000R8R4@044A4A8R8A6ATA
:Q480Q4A4@@Z4@P5000000PA4A4RA3XI8S8A4A40000I8S9<E6dR>U`40000
01<A4A40000A4A4R8Q4I8T`b>T@A4A4R8Q4I8R8Z8QTR:RXZ8QTb:R8R>S8R
:RXb:R8R:RXI6ATI6A401A4A4@096ATA4A4A8R8A6ATA8RXZ8R8A6B8R6ATI
6B8R00<A4A401@00014A4A4A4A4A4@0000034A4A00<I6A4A4A4A4A40214A
4@8I6AT74A4A00/0000A4A4A4A4A4A40000A4A40000A4A40000A4A400000
0a4A4@0500006ATI4A4A6B8b0000008I6AT02Q4A4@00028R4ATR8S8Z8P00
038Z8QTI6ATR:QTR8PD000026ATA0aTR8P<R:RX00aTR8QTR:QTR8P040000
00PI8R800000000I6A4A4A40000I6ATA4A42000000<I6ATA4A4I6A400Q4A
4@056ATA8RXZ>UAL>UALC7In008R>S8021TR8QTI6@0001TI4ATR8R9<E3YL
MQTR8P<00000228R4A4A4@000000014A4ATR8QTR<QTI6@8A4A401000014A
4@0004afU`80000014anU`000000014A4@8000001Q4A4@00014A4@000;6i
U`00008A4A402ATI4@00014A4@00014A4@00014A4@00014A4@020000114A
4@0400004A4A4A4A00000Q4A4@0800004A4A00004A4A0000IE@bQe@Z:R8I
0a4A4@0C:Q484A4A00000000/HlIWd`0A140QbX04A4A8RXZC4a4>TA<<RXR
0000:Q48:R8I8SYL6B8R4A4A07O<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h<lc<c0<A4A4011TRC2XA20000394MP9<KIL026enSfF7ZInYZHmn
KIn7KKUnE;VGKHM<A0944@000iN?MXMnE8MnE002OWIU01InOVenIEAnMUAn
MUAfOUanOVenMUAnOVe]KEA4A394>RY4A2YnKDb?SfF7OUA]MWJ?MVF?SfEn
OVenMVEnOVf7OU@2OWIU00AfOUaUE38jA1TR<RX34A4A0P0000086ATA6ATI
6ATI8R8AWhm]k>cS/KVYG3XR0P00000A4A4AA3XZ8R8A6ATIWhM]OWIUOVe<
KFeDIFDjIE@bG5a<C4@RA2XR>T@I8R8A4A4A000000<Z4@P03P00028Z:T@A
000002XA238Z8QTR8RXR6ATI6BXR6B8R4A4A4BXA2000008Z4@P01d@A06DI
0000038Z8R8R4BXR6A4A4@02000000TA4A4Z4@PZ4@PA4A4Z4@PI6A4A4A4Z
4@PA4A400RXA200>C2886B8b8RXZ6B8R:R8I6B8R6ATI:R8I8SXb>UAL8TaD
8S94:R8I6ATI2A4A4@8I6A424A4A00<I6ATA4A4A4A400a4A4@0400004A4A
4A4A00000Q4A4@0400004A4A4A4A00001a4A4@0300004A4A4A4A00hA4A40
0`00014A4@0000024A4A00<I6ATA4A4I8R800Q4A4@0?6B8Z4A4A4A4A6B8Z
4A4A6B8R4A4A:Q4800008SYL>Uaf0000:Q486B8Z6ATI008A4A40:000014A
4A4A4@0001TI4@00028Z:R8bA1TR8QTI4ATR8R8bA1TI6B8Z:R8bA00002XA
200002XA24A4<UA]MTa]QdanUa4A4@0002XA22XR6BXA22XR6ATI4C8jA1TI
4B8Z:QTR8QTR<QTRC4anSeAfUdanUb9<E0<000024A4A00@I6A4R<T@jG7HI
8R8200000Q4A4@0900004A4A00006ATI6B9<8SYL6B9<4A4A0000008A4A40
1@00039f/@00014A4CYUQ`024A4A0P0000054A4A00004A4A00004A4A0080
00002A4A4ATI6A4A4A4A4@00014A4@00014A4@0000034A4A00<0000A4A40
00000Q4A4@07:Q484A4A:Q48:Q486ATA00006ATA008Z4@P01ATR<P0001TR
8QTR<QTR:P034A4A00dI6ATA4A4I8RXI8Tb?MTC:MP14:R;:MP0b>T@j>S8j
E5a<MWi4A4`00Ta]Q`048SYLOWi]6B8b0000Mlc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Pcc<c<00TI8R8I6ATb>T@R:RXIA7i<KILjIHLIA7hb
A7H00TafU`0>G7jGOYniQa40Wfe</KVO/K6i`K6iSiN?ID`IOWi]OWIDOVeU
OWi]OWIU0WinK@9nMVD04WinKGifIGi]IGInG4a<>T@Z8T@j:UaLC6efMWif
IHMnE6efMWifIGiUE7InG7i]IGifE7ifI@9nMU@04HmfA6EU>XM<A6EL:R8R
4@0002XA21TI6BXA21TI6BXA21TI4FDI0=^aWhm44BXA2;VGE0024A4A00f7
4@144@0Z8QVGSgInKDafOUanIEAUICYUE39<C4AUE39<C4AL>R800P000006
8R8A:Q480000:Q480000<RXR0RXA2006A140A2XR:R8I4A4A6ATI8R8A0Q4A
4@DZ4@P02D@A02XR6D@j:QTI4BXA21TI6BXR6B8Z:RXA2002000000@Z4@P0
000I6ATb>T@2:Q4800d0000Z8QU<8PPb:R8Z4@PI8R8Z8QTR:RXjA4`R<RXR
:RXI8R8000001Q4A4@@000000c8Z8Q4A4@0000024A4A00HI6A4A4A4A4A40
000A4A4000024A4A00L0000A4A40000A4A40000A4A4000000Q4A4@066ATI
4A4A000000004A4A00000Q4A4@036ATI4A4A4A4A008A4A426ATI0a4A4@05
6ATI4A4A4A4A6B8R6ATI008000000a4A4@00014A4@026ATI0QTR8P034A4A
00006ATI008A4A4021TR8R8R4A4A4A4A4BXA200001TI4BXA208000001B8Z
:SY4C3YLMP00014A4@02000000PA4A4I6AT0000I8RYUUk4R>U`0000I8RX2
<SY400=4:R9LG4`I8R800Q4A4@0300006ATI00000080000011TR:P000000
028bA0<000003c8jA000028Z:P00014A4ATR<QUfMTanScYUUdanS`00014A
4@00014A4@0000024A4A00<I8S80000A4A400P0000<A4A401@00028Z:R8j
G1TRC1TR:P034A4A0P000004C7JG00004A4A8TaD0P0000034A4A00004A4A
008000002a4A4@00014A4@00014A4BXA2000014A4@00014A4@0000024A4A
00H0000A4A40000I6A4Z4@Q44@03:Q4800i44@0R8Q4R8Q4A4A4I6A40001<
C4@jIHLjIIL0000I8R9LG4`b>T@I8R834A4A00`I8R8I8RXI8Ta<C3[l`@2O
C03l`@1]MWHb>TA4A4a<E6djG7H2C5A]00@I>WInOVf?MVDI6AUgc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`01R8Z:QTRC1U4QcYDQb8j
G1TRC08jE8L01Dan/DanUcYUQcYUUc94MP02000000TZ4@Q4:R9UE39nG4a4
4@2?Qfe]MWInKFEnMVD00WifE00@KGIfMWiLOWIUOWi]MWiLOWIDKGIfKFeD
C4a4<RXRC4`jOWIUOVeUQgiDOWIUMWiL0XMnE005OWIDQgiDQgiDQgiDOWIU
00:?Qe@06HMnE28R4BXR6Da48Q4A4E`j8YN?MXn?IIn?KIN?MYn7KM^aZK67
IHM<4N?B/BXA21TR8Xmf:T@Z8P0009N?MWifIGinKFe]E7i]I@02KFeD0fEU
>P0B6ATA:R8I8S948R8A6ATAA2XRA4@b>SXb00006ATI:Q48:R8IA2XRC4`j
G5a<C4`j>T@I00001BXA2004A1408R8A<SY4<SY40cY4C008>SXb0000:Q48
00004A4A:Q48>TA<>UAL0bXA2006C288A2XR8RXZ8RXZ6B8R6B8Z0Q4A4@80
00001a4A4BXA214A4A4A4@00014A4@0000034A4A00<0000A4A400000114A
4@0300004A4A4A4A00@A4A400`00014A4A4A4@044A4A00<0000A4A400000
0P00008A4A400`00014A4ATI6@046ATI00<A4A4I6ATA4A400QTI6@034A4A
6ATI6ATI008I6AT01ATR8Q4A4A4A4@00014A4@02000000<I8R8I6ATA4A40
0Q4A4@0<0000>SXb000000008TaD6EAn>UafC6f7:R8I0000>VF7C7ja0P00
0004>VF78TaD8TaD00000Q4A4@8000002aTR8R8R4BXA24a<A5a]MVe]E5a]
QbXR6Da<A3Y4C3YLMP06000000HA4A40000I8R80000A4A4R:RX2000000/A
4A4I8R8I8RXI8RXA4A40000I8S8jE5a<OYM<OXm<OYL00Q4A4@0300004A4A
0000008A4A400aTI6A4A4@000002000000XA4A40000A4A4A4A40000R<T@I
6ATA4A4jA4`000024A4A00@0000bA7HA4A4I6AT3000000DA4A4000000000
000Z4@P00P0000034A4A00000000008A4A400bXA200001TI4@02000000dA
4A4Z4@PA4A5<8PPZ4@PA4A4Z4@Q<8PP0001L>R9<KHLA4A4000000Q4A4@0;
0000>UALC6f7<TAf6B8bIFDjooooWhM]6B9<6B8b6B8R008I8RX04ATI6ATR
C1TR<_oB2>cK/Oclm;VGKCYDG4A4C00003Xj<SYDG3YLMSYDQhnGSgiUE8Mn
S`1gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`01R8bA1TR
C1TRC28Z:QTRC28jG0<jE8L01394MSYDQcYUU`0000<Z4@P034@A02XA2000
02XA24@A08MnE7inKFefMWinKGifIHmfIGifI@9nOVd2OWIU00QnOVenIEAf
OUa4>RYUE39nKFEnMUAnOVd2OWID01]nOVenMUB7OUB7OUAnKFF?Qff?MSX0
000Z4@P00027IC8R8Q5LG4`0002?Qfdj>S9nIEB7OXn?MUAnOVfiWgkK/Io1
/KTZ4@R74@0I6A5L>R800RXA200C`K6OWiN7WiN7^Imn/KVG/K6?^Imn/K6?
ZJV?^KVG:Q488R8A:Q48C288:Q48OUa<Wimn6ATA8R8A008Z4@P0238Z8XMU
</[1WlZaZN?B/Hmf>P00028R4@@Z4@P02b8R4@0008n7KCYDG38jA2XR6ATI
6BXA2000028R4@000002:Q4800<I8RXI8R8000000bXA2004A3XZ6ATA4A4A
4A4A0P00008A4A401bXA214A4ATI6A4A4@0001TI4@0000024A4A0P000004
4A4A00004A4A0000114A4@0600004A4A4A4A00004A4A00000Q4A4@040000
4A4A4A4A00001a4A4@0300004A4A4A4A00@A4A400aTR8QTR:QTI6@036ATI
00<A4A4I6ATI6AT00aTR8P076ATI4A4A000000004A4A:Q486ATI008I8R80
14anS`00000001UUOP8000038SYL00HI8T`A4A40000I6A4Z4@P00002:Q48
00Pb>T@R<T@jA38Z4@Q44@0I6A5DMYMLG4`2A14000Pb:R9<KHL0000I8S8R
<T@RC5@IE7hjG7H2000000@A4A400000000A4A42000000HRA3X00000000I
6ATA4A4000024A4A0QTI6@0:00004A4A6B8R8SYLE7JGC7j?C7jG8S8Z4A4A
00000Q4A4@0:0000:R8I6B8R00004A4A00004A4A00004A4A00000Q4A4@<0
000034aDK@000000014A4@00014A4ATI6A4A4@00014A4BXA2000008A4A40
3BXA214A4@00014A4@00014A4BXA214A4BXA214A4@0002XA228R4@02:Q48
00/0000A4A40000Z4@QU6@0A4A5<8PPZ4@PA4A5LKGHI8T`00Q4A4@0<6ATA
:R8I8S94IHNYC6f78SYLm>cKm?C/G3XR6B8b8RXZ6B8b0Q4A4@0A6B8Z6B9<
6B9<om88m>cKooook;U]Qda4<SY46ATA4A4AA4A<>VF76EAn`K6?SgHjIE@b
07O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c0098RXZ6ATI
6ATI6B9<>VFGC6f7>VFG>UB76DAn008bA7H033YDQaTRC14A4A4A4BXA24aD
KATRC3Y4C2XR6D@A07iLC7inK@9nMVD00ginKGi]IGifI@02MWiL00=nKFEn
MVE]KE@00WInG09]KE@04VED<VEU>VEU>WiLC6e]E5aLC6e]E6EU>Ve]E6EU
>Wi]C4@j8P0001TI4BXR6HMU<RXR6EaLC08R8Q4016Db29nOSin7KInGQ`:O
Wgh02NbYC8mU4A4A4Im<08m408mfE2XA20000=;:Z@03/KVG00fYZHna/HnY
ZHnOUhNYZHo1/HljA1TA4A40000A4A40002GOUBOWgh00bXA2008<RXR8R8A
^Imnhm_Khm;1c<c<QgiD4A4A1BXA20080000C288WiN7OWIDIE`Z00004A4A
00001BXA2008>T@IID`I:Q488R8A:Q48A2XR8R8A0000114A4@06:Q480000
4A4A4A4A00004A4A0`0000046B8R4A4A00004A4A0P0000<A4A401@00014A
4@00014A4@0000024A4A00<I8RXA4A4000001A4A4@0600004A4A4A4A0000
4A4A00001A4A4@0:6ATA6B8R6ATI6B8R4A4A6ATA6B8R6ATI6ATA:R8I0QTR
8P05:R8I8RXZ8T@j4A4A0000008A4A42000000/bA7Hb>T@R<T@jE8L0000Z
4@P0000Z4@PjA4a<E6e<C4@00bXA209<E6d023Xj<RXA22XA214A4B8j<R8b
A1TI4BXA208A4A402ATR<QTRC1TR8QTI6@0001UDOP00028j<R8bA002>UAL
00<jIHL0000000000P0000094A4A0000000000006B8b00004A4A<RXR0000
00<A4A402`00028j<P00014A4@0002XR6DanUeAnOTanUb94>R8b:P030000
00@A4A4I8R8I8S8I8S8200000Q4A4@03:Q486ATA:Q48008Z4@P00d@A04@Z
8P000003:Q48114A4@8Z4@P01000014A4@000000008A4A401RXA214A4@00
014A4@00014A4@8Z4@P0114A4@000000000000<A4A400`00014A4@000002
:Q4800LR8Q40000Z8QU<E6d0000A4A4jA4`00P000005C7jaE8Na8S94o?cd
Uhmf008I8S803ATR:QTR8R8Z:QTR8QTR:QTR<QTRC?c10?C1A=_1WnbY0;Un
E1TR<P02:Q4800HR8Q5LQiNa/KViWgj7OUAUC1Ugc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^3?<c<`06B8bA1TR<QU4OSYDQc94MQTjMR8jG394
MR8jG1U4OQU4Qb8jG1TR8P0002XR6@00028bA38jA394MTA4C8NGZHMnSgIn
G7ifIGi]I@03OWi]00AnMVE]MWInOVenOVd2OWIU0Wi]I@9nOVd01XMnE8mn
KHmnKHmnKIN?MYn7K@:GSgH00k6iUfe]E1TI4@024A4A01Lb:R9UG2XZ8QV7
OU@0002OQffi^INa^INa/Hna^IO1/KU]IB;BQaVOC00R>S:Y20274@1nKD`Z
4@P0003/fk7Sd[7Bb/400ZVYS`0:b/6O/K6?/KVG^K6Ohm;1IE`I4A4A>TA<
:R8IIC880P0000<Z4@P01aTR<T@Z8Xn7KN?B`K7:bYN?MP000005:Q480`00
0004d/[1Whm]000000001RXA2009/HMUhm;1b[V?<RXR0000:Q48A2XRC288
6ATA00<A4A4041TI4A4A4@00000001TI6@0002XR6B94>S8jA3Y4C3YDG14A
4@00014A4@00014A4@800000114A4@00014A4@0000TA4A401@00014A4A4A
4A4A4@0000024A4A00<0000A4A4A4A400Q4A4@03:Q486B8R6B8R008I8S80
328Z:R8bA28jG294>R8jG28bA29<E38jA1TRC38jA28jG38jA0<Z4@P00c8j
A3YDG28R4@02:Q4800Xj>S8jE8LRC5@0000Z4@PA4A4bA7HIA8LI>WHI8RX2
6B8b00/A4A40000A4A4A4A40000A4A40000A4A4I6A4Z4@PI6A400P00000;
6B8b6ATI6ATA4A4A:Q486ATA8RXZ8S94>UAL8SYL>UAL00<000000a4A4@00
014A4@02000000@b:R800000000R:RX200000Q4A4@046B8Z:R8I6B9<6B9<
0RXA2005E8naC7jGC7jG8T@j6ATI008Z4@P01R8R4ATI6C8Z8P0001TI4@00
008Z4@P031TI4@0001TI6B8Z:SYUQaUDOR8bA28R4BXA25`j8T@A04`R208Z
4@P00d`R22XA21TI4@03:Q4800P0000A4A40000Z4@P0000I6A40000A4A42
:Q4800<A4A40000000000a4A4@0700004A4A00004A4A00004A4AA14000<Z
4@P04000029<E000014A4B9<E1TI4@0003YUQc9f/FE<6OooohmnKATR8QTR
<QTR8Q4A4@8I8R802ATI6ATR<R8jG>bY0=^72>>O0>bY0?oB2:Uf<P038R8A
00DZ4@Sdm>biWgj7IC:7C140Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Pcc<c<00<R<T@I8T`R<T@00aTRC0088SYL6B9<8SYL8SYL8S8Z0000
4A4A6ATA0Q4A4@0700006B9<>UAL6B8bE6efOVeUOWIU009nOVd01gifIGin
KGinKGinKGi]IGifIGInG002OWIU00Ja^Ini^JW1/Ini^INi^JVa^Il2/KVG
02jYZHna/Hna/Hni^Hm]IB9UG2XI6A4Z4@R?G4aL>R:GSgI44@1<C4AUC1Wd
k=_Sd/7Bb/7/hl[:/JVa^IM44@3SWb:iC01]KEBiC01U6@0jA1TZ4@P0002i
Wgk<c<bOUhNa^INi/Ini^INYZHo:/JW/hl[/fl4IE38R8Q40000R8Q40001U
E38Z8QT24A4A00LI6A4Z4@PA4A4b:R9nOVenMUAUICX01RXA20044A4A0000
0000ID`I0P0000DZ4@P02Q4A4FDb29n?KFDb24`R22XA21TI4D`R24a48Q4A
4@D000003c8Z8Ta<A4a<>R9<E3Y4C38jA1TR8R94>SY4C294>QTI6A4A4@00
014A4@0000024A4A00<0000A4A4A4A400Q4A4@0300004A4A4A4A008A4A40
0`00014A4A4A4@034A4A00<0000A4A4A4A401A4A4@0=00004A4A>TA<8SYL
>UALA4A<<SY4A2XR<RXRC4`jE6efG6efC28800944@003TA4C4aDKB8bA2XA
2000028Z:R8bA294>P00038jA28bA294>TanS`00008A4A401ATR<P000000
01TRC28bA0026B9<00<I8S8jA1TR8Q400QTI4@06<RXR4A4A8R8A8R8A:Q48
4A4A0P00000=6B9<6ATI6B8Z6ATA00006ATA6B9<<SY48S8Z8SXb8T@j0000
4A4A00800000214A4@00014A4@0001TR:Q4A4BXA24`R208000024A4A00dZ
4@PR8Q4R8Q4R:RY<8PP0000A4A40000Z4@PR8Q4I6ATA4A4I8R800Q4A4@05
6B8Z00000000:Q486ATA008000003A4A4B94>P00014A4@0003YDG00002XA
21TI4Ea]QcY4C4@j:T`R2002000000<A4A4Z4@P000000Q4A4@0600004A4A
4A4A6ATA00004A4A0bXA20@A4A401@00014A4@000000014A4@026ATA00/0
000b:R80000Z4@PI6A4Z4@PI6ATI8R94>RXZ4@PR>U`00P0000064A4Am?C/
m?Cdm>cKQe@Z6B8Z0Q4A4@056B8b6ATI6B8Z6B9<^Imn00;ddWh03>?BWn?1
A?CSbXLZ01TI6B8R4C8Z8Q4A4N?BWfE<6FeU8VE<6GO<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h<lc<c00>6B8b8S948SYL8SYL<TAf6CYf<TAf
6CYf<TAf4A4A00006ATI8RXZ6B8Z0a4A4@0:6B8b<TAf6DAnC5A]KGIfOWi]
OWIUMWiLSgi]OWi]0YN?MP03ZJV?Uhn7Wimn00:GSgH09kVOO[67IInOOYnG
QinOO/6iUm_1Wm;:ZN?B/NcSb];:`L[KffEL:SXj8P000<6iUoCSb/6iUnc1
Qk5]0<[1WfED<Xn?IK6aSncSb/ZaZK6iUiN?MT`R2>bY0;5]0;6iUnbY0;V7
0000028R4D`R24@A0=;:Z@02^KVG00fi/Io:/JWSd/7/hl[Sd[7dk=]UG2X0
000R>S8I6ATZ4@PI6A4Z4@P00P0000096ATA:Q486ATA0000IAT0C288ID`I
A3XR8R8A00DZ4@P01`0005`j8P0002XA200002XA20000003:Q4800E4:R:?
MUBOSffaSaTR8Q400RXA200HQe@Z:Q48A140IE@bOVEDG5a<KGIfG6ef>UAL
A4A<C4`j<SY48SXb8RXZ<RXR>SXbA4A<8TaD6B8R00004A4A00004A4A0000
0Q4A4@04:Q484A4A6ATA0000114A4@0300004A4A4A4A00<A4A400`00014A
4A4A4@026ATI010I6A4A4A4b:R8I8S8R:RXR8Q4Z4@Q44@1<KHMDOWi<C3Y4
4@1<8PPb>TADKGHjE5`3<SY400LR>U`RC5@RC5@0000A4A40000A4A400P00
0005>UAL8TaD8S94>VFG000000@A4A400aTR<R8jG28jG0026B9<00@A4A4j
A1TI6A4I6A42:Q4800<A4A4R8Q4Z4@P00QTI4@0;4A4A0000:Q48:Q488RXZ
:Q484A4A6ATI6B8b8SYL8T@j008jG7H200000Q4A4@0B8RXZ8R8A:Q484A4A
00006ATA4A4A0000:Q488R8A:Q480000:Q4800006B8b8RXZIC886ATA0R8R
4@03:Q4800000000008A4A401000014A4ATI4A4A4@8Z4@P02@00014A4@00
000001TRC000038Z8Q4A4ATI4@02:Q4801<0001]SiLjE8LZ4@PZ8QT0000A
4A40000Z4@P0000A4A40000A4A40000Z4@PR8Q4I8R8RA3X000000Q4A4@<0
0000114A4@00014A4BXA20@A4A401ATI4BXA214A4ATI4B8R4@020000026a
^JT0000Z4@PZ4@PR<TBOKDcdhl[Sd[7/k>?dm>cdhlY<8PPI6A4Z4@PR:RXI
8T`b>TC/fk7/k>?dm>c/k>?dm?B?SfGdm>`Z4@PI6A4I6ATA4A544@3dm>a<
8PQ<A29<8PP0Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<
00@I8T`R>U`R>U`IA8L2<TAf00PIA8LR>U`A4A40000A4A4I8S8A4A4I8RX3
4A4A00`0000R:RXbA7J7OXnGShN?Qff?Uhn?Qfg/hl[Sd/7/hl[Bb/42k>?:
04?dk=^?UhnGSgJGSgJOWgjOSffOWgjGSgKSfm_Bb/7Sd[7Bb/6?Uhn?QfeU
G2YUC1Tb:R94:R;Sd[71/InOSffa/HniQ`2a/Ho:`JViUeBYZHo:/JVa^INi
/Ini^JU44@3KQ`SKMPR?IA6iC03:MP2OKD`Z8QUU<PQU6@2i^IO1/Io:/JWS
d[7Sd/7Bb/7BbZW:/JW:`JV?MSX0000A4A40000A4A40000Z4@P0000A4A40
000Z4@P0001L>R;dhl[Sd/7Bb/5]IB800R8R4@0=:Q48A1408R8A:Q484A4A
00006ATI00008R8A:Q480000:Q480000008R8Q403;VGKIn?KHmU4@00028R
4BXA28mfA<c<c;6a^Io1/HnGSgInG09LG4`023Xj<Ta<A5aLC3YDG4a<A3Xj
<SY4C4aDK@8jA4`00a4A4BXA200000020000114A4@8000000aTI4BXA214A
4@044A4A00@0000I6A4R:RXI8T`2:Q4800=4A4a<E6dZ8QT00Q4A4@0:0000
6ATA6ATI4A4A8S94<SY48SYL8TaD8SYL8TaD0b8jG00;<SY48TaD8TaD8SYL
8TaD>UAL8TaD00004A4A00004A4A008000001aTRC28bA38jA4a]U`00014A
4@0000034A4A0QTRC0068S946B8b6B8Z8R8A>T@I:Q480QTI4@8A4A401B8R
4BXA228R4BXA214A4@028R8A01TI6AT00000000I6A4I6ATZ8QTb>TADKGIL
Qhm44@0Z4@Q44@0R<RXjA1T0000A4A40000A4A4I8RX0000A4A40000I6A4Z
4@Q<8PP00RXA20038SYL<SY40000008000000b8bA1TR<P0000024A4A00@0
000A4A4A4A4R<RX60000018A4A40000A4A4A4A4I6A4A4A4Z4@PI6A4Z4@Q<
KHMLOYLjE5a<8PPA4A40000A4A40000A4A42000000lI6A4A4A4Z4@PR8Q5D
KGHjG7HR>S94>RX0000Z4@P0002OUhN?KD`0000Z4@P0114A4@046B8R:Q48
8R8A00000RXA20044A4AZGHbIC8800000R8R4@04:Q48k>cSo?cdk=_10_Cd
k003o?cdm>?:0000008Z4@P04YMnE?C/foclm?Cdk>c/hoCdk?clm;VGE>?K
fhm44A4A4ATI6@0009mnC?oood`R25`j8T@j8WO<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h<lc<c0038S948RXZ8S94008R>U`011U4OR8bA000
014A4@8I8R801000014A4ATI6ATR:P8A4A403aTI6@0006DI09n7KInGQhnG
SiN?QhMnSoCSb];:`N?B`N?B/Lc<c>?B/M;:`@02Uhmf01V?UhnGSgJGSgJG
SgKK`IoSd[7/hl[Bb/7dk=/I6A4R8Q5UE39UG2YUE38A4A6aKAWBbZWSWcZ7
OUCl`@2iUe@jA1V?MRZ7IC:i/Il00[ViU`0A^K6O6ATAfhL8dXLI/Fd0^D`0
/Fd0oooo^IMDIC88IAT0^Imnd/ZY`K6Ob/6O`KVG^KVY00;1/Il01<[1ZL6a
SaTI4@00008Z4@P00aTI4A4A4@0000024A4A0P000005Qe@Zhm_Khm:a`KV7
>T@I00@Z4@P01T@A028R4@0002XA214A4BXA208000006A4A4BXA22XA22XA
28mLC9nOOTa48_CSbT@A028R4D@Z8Wi]C=;:`K6iUinOSinOOYnGQhnGSff7
OWi]IEA]MUAnOUa]MSYDG4A4<P03>UAL00<b>T@R:RX000000a4A4@090000
4A4A00006ATISgI4QfDbIE@b8RXZ0000008A4A402b8Z:RXR6A4A4B8R4DA4
C1TR<QTI4ATI6BXA2000028Z:P054A4A014jA4a<E6djA4a4:R8b>T@jE5a<
MWi4A4`b>TA<C4@b>T@jE8M<E6e4A4`b>T@R<T@jA4`00Q4A4@0::Q480000
:Q48:Q48:R8I>SXb6B8R>VF700004A4A0QTR8P0:4A4A00006B8Z6B8R6B9<
8S944A4A>T@I8R8A>T@I0R8R4@030000:Q480000008R8Q404QTI4@000000
04`R24aDKEanUda]QfDI04@Z8TA4C4a]QcYLMSYDG1UD<R8R4@0001TI4B8R
4@8I6A42000000`R>S800000000A4A40000Z4@Q4A38R<TA44@0R<T@R>U`j
A4`3000000HI8S80000A4A40000A4A400002>UAL00@0000A4A4A4A400003
4A4A014R:RXA4A4Z8QTR8Q400014A2Y<8PQ4:R8jE5`RC5@R:RYnShlI6A4A
4A40000A4A4000000Q4A4@0>0000:Q48:R8I:R8IMWiL>UafKFeD>UAL0000
:Q480000o?cdk=^aIAT00P0000064A4A00006B8Z:R8I0000C2880Q4A4@0=
0000A140SfDA^IM]:Q486ATA:R8I0000/K6?o?cdk>cSm?C/k>cS00;lo?@0
1T@A04@Z8P000;VOO_clm?Cdk0;/k><03OC/foclm9n?KM;:`Oclm8m4028R
4D`R2?Cdk?oood`R24a48T@j8P1gc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^3?<c<`0100002XA2000014A4@<000003Q4A4BXA21TR<QTR8Q4A
4@0002XR6A4A4ATI4A4A4@0002XA20000:VYS`:GShL0:YN?MWinKN?Kfm;:
`N?B`Lc<c>?B/N?Kfk6iUin?KInOOYn?KIN?MXn?IM;:`NcSb^?B`N?B/IMn
E<[1ZDa<>R8R4FEU>T`R28M<A00008m]C?C/fnbiKKVaWnc1<^?1A4A4:^>Y
SlZaZL6aWl6iUkViUn?B`Da<>Ym<0=^?<P;:MP003;V70>?B`N>O08LA09m<
09N?M/ZaZKViUk6aSl[1ZKViUl6iU`:i^IL01=;:ZB8R4E`j8R8R4@8Z4@P0
114A4@000000014A4@<000001FE<6C8Z8RXA23Y46D@A0003:Q4800<R8Q54
4@0000000`00000A4A4A:Q4800008R8A0000:Q48KFDRSgHZID`I^IMDA140
:R8IA140Wimn`K6iWjVYUhn7009]Qgh026EU>Xn7KFf7OVe]E1TR8Ta<>R94
>Ua]MP8jA4`00da<A294>R8Z:P03000001LA4A40000A4A4Z4@PA4A4b:R:?
MSX0000I8S8I6ATZ4@PI6A4I6ATI8RXI8R8A4A40000R:RXR>U`R:RXZ4@PA
4A4I8RX00QTI6@054A4A00004A4A8RXZ>Uaf008b>T@0138Z8SYUQcYDG3Xj
<P8Z4@P012XR6CY4C29<E38jA08Z8QT03DaDKB8bA28j<Q4A4BXA2000028j
<R9<E4a]UcXj<T@Z8RXA21TRC0028SYL0Q4A4@050000:R8I<SY48S944A4A
009<8PP02QUfA4a<>RXR6C8Z8TA4:R8R4A4A4BXR6ATI4B8Z:P8Z4@P033YL
MR8bA1TR<Ta]Ub8jG3YUUaUDOSYLMSYDG1TI4B8R4AUD<P<I6A401000014A
4A4A4ATI6@8000004Q4A4@0002XA22XA22XR6B8R4BXR6B8Z:SYDG000014A
4@0001TRC14A4@00014A4@00028bA08jG7H01294>P000000028R4@800000
BC8jA4anS`00038jA000014A4@00028b:U`j8RXA21TR8R8R4D`R200002XA
2000014A4@00014A4@0005`j8RXR6C8Z8Ta48R8j<WiUE9nGQd`R22XA228R
4@000?C/foCBO[V701TI4BXA228R4Hm40;UnC8mf>P0004`R24@A02XA28MD
:_Cdk<[1ZK6aSd@A02XR6D@Z8P000<6aSoclm>c/hoCdk>c/hoCdk?CSbP00
01TR8R8R4FE<6OC/fnc/hoC/foCSb^cSb_Cdk;VGKL[1ZOooom^aW`02^IM]
00Glo?CooomU<PQL>R8jA1T0Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Pcc<c<114A4@0300006ATA4A4A008A4A403QTR8P00038Z8R8j<QTR
8P00014A4ATR<Q4A4B8Z:YN?MXnGSinOOXn7K@:GSgH01^cSb^?B`N?B/N?B
`N?B/KViZ@:OWgh0=fEU>XMnE9nOO[VOO^cSbXnGSbXA24a48Xmf:YN?Qhmf
A8MnE8MU<XM<4Hmf:[5]07iLC?C/foCSbVE<6KU<0>?1A7i]INcK/M;:ZL6a
Wl6iUl6aWm;:ZFEU>T@A0>>O>/Yf0;5]08LZ09N70;5]0;U<0>>O8ZUf<[Vi
ZM;:ZFE<6Gi]C9nOO];:ZL6iUm;:ZIn?KBXA25`j8R8R4BXA24@Z8RXA2002
4A4A00T0000A4A40002GOUCdk=_1^HL0001<8PQ44@001BXA20034A4A6ATA
4A4A00<000001ATI4@0002XA24@A0>>O>P02>T@I00L0000R8Q4Z8QU<8PQL
G4anMVFGSgH00YnOOP08MWiLSiN?OWi]Win?OWi]KGIfKFeDOWIU0SYDG005
A4A<C4a4<SY48S940000008A4A401000014A4A4A4@00008I6AT01R8R4BXA
228Z:QTR8Q4A4ATR:PDA4A401ATR<Q4A4A4A4A4A4@0000024A4A00H0000A
4A4A4A4A4A4I6ATR:RX28S9400HR>S8R<T@RA3XR>U`RC5A<E6d28TaD00E<
E6dRC5@bA7HRC5@jG7H00P00008A4A43000000<jA4`jE5`jG7H00P0000<A
4A42000000DA4A4000000000000R8Q400SY46@068R8A00008R8A:Q48>T@I
6ATA0Q4A4@0800004A4A:Q486B8b4A4A6B8b>UB78SYL0SYDQ`068SYL8T@j
:Q488R8A4A4A6ATA0Q4A4@0500004A4A:Q48:Q484A4A00<000001a4A4@00
000002XA24`R24@Z8S8jA00200000Q4A4@0500004A4A0000>TA<>Uaf00@j
E5`2:Q4800PR8Q4A4A4R<TA<OXl0000R<RXR8Q4A4A42000000F?MRX00014
4@00000j>R800QTI4@<Z4@P07a4A4@0009MnE6E<6BXA27ifIInOSk7:b/[1
ZE`j8P0002XR6@000?clm?CBOYm<014A4B8R4D`R2>biKHmf>VEL:RXA228R
4D@Z8VDb2<[KfncSb_CSb]^aWd`R20024A4A00<Z4@Sdk=_dm>`00^c/h`?d
k=/05FDI038Z8QTR8YN?M_Cdk>c/hoCdk>c/hoCdm?clm<6iUl6iWoclm?oo
ooclm?ooooCdm?ooohM<4Da48T`R201gc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^3?<c<`00bXA214A4A4A4@034A4A00PZ4@PI8RXI8S8I6A4R
<T@I8R8Z4@PbA7H24A4A00DR>Ua]OXmnWkW1/KWBbZT00/ZaZ@05^K6O^KVY
`KVG`KVO^KVY00;1^IL0>/6aWin?KDa48XMU<VED<T`R2;VaWhn?IKVGE>>O
>VEL:ZUf<XmU4DA4<U`j8_C1A>bYM/Z?<_CSbVeU8Ym<08LZ09N70=9<0>bY
0;6a^LYf0<Z?</6aWl6iUkViSlZaZFED<XLZ0=:76K5]6K5]09N708mfIHlb
C9m<08M<4FDI0>?B`M;:`D`R238Z8T@A0=;:`L6aWm;:`FE<6B8R4E`j8T`R
22XR6D@Z8U`j8P8000002Q4A4@0001TI4Da48VDb24@A01TI4D`R24@A028R
4@8Z4@P00bXR6BXA20000003000001`I6A4Z4@P0000Z4@QU<PR?IA7dm>a4
4@2iUe@0000R8Q5<8PQ44@2YZHoBb/6a^JUfOUa]QgiUICYLG4aUICZa^JVO
WhmnOVe4A2YLG4`A4A5<C4@2>UAL00LjA4`b>T@0000Z4@P0000A4A400000
0a4A4@030000IE`Z6ATI00<A4A400aTR<Q4A4A4A4@024A4A00<I8RXA4A4I
8S800Q4A4@036ATA4A4A4A4A00@A4A406ATR8R8jG3YLMSYDG3YDQcYDG4aD
KCYDG394MTaDKC94MTaDKB9<E3YDG29<E3YDG4aDK@00014A4ATR8QTR<R8j
G28bA28Z:R8jG002>UAL00<A4A4I6ATI6AT00Q4A4@0E00004A4A00000000
4A4A00004A4A8R8A>T@I>T@b6ATA>T@I4A4AC4@R8R8A:Q484A4A00004A4A
:Q480000008A4A40200001TR8SYDQcYUUb8Z:P0005a]QaTR8PHA4A400bXA
24@Z8P0000034A4A00LZ4@P0000A4A400014:R9<C4@I6A400Q4A4@08:Q48
6ATA6B8b00006B8RC5A]>UAL>Uaf0SYDG00BE6ef00008R8A8R8A4A4A8T@j
C7j?6B8R4A4A6ATI00006ATAIAT0Wimn:Q488R8A6ATA<RXR0bXA208I6A42
4A4A00R7UjVGSgJ?SfFOWhna/KVi/Io:`JUUG2X24A4A00L0003oooodk=^?
MRXZ4@PR8Q4000000/Z?<P036ATI0000<RXR009<8PP041TjM];:`N?BWn>Y
ShMU</6aWk67IFEL6OooooC/fnc/hoCdk>c/hoCdk?clm=:aS`:7E2X00oCS
b_Cdm?Cdk003m?C/00?dm?CSd[6i^IL01?Cdm005k?cdooooSfDAA2XRC4@R
07O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c0@A4A400bXA
200002XA20028SYL00`IA8M<E6dA4A40001LKHLbA7HjE8MnWkUfUk67UjWB
bZW:/JT2^KVY01K1^IO:/JW1^IO1/Io1^INi^IO:`Io1^INOWghjA1U]IB:?
IA7SWcYUE3:iWgkSWeCodPQnKDaUG1V?MRZ7E2[/ZGH2`Fe400baK@3/^Ffa
K@0Z4@RiC02OC02a003SW`2id]^OC03:Sc;1/KT2`KVG01fi^JVaKAW/k>?B
S`3d`DBOC00Z4@ROOTcBS`1U6@3:Sc;KMPROUhNiUff74@14:R:7C17K`IoB
bZWSd[4Z4@Pb:R9UG2Y<8PPZ4@QUC1U<A280000A4A400`000005G3XRb/6O
C2888R8AIAT000DZ4@P00b8R4A4A4BXA20024A4A00T0000A4A4A4A544@2?
IA5U<PSlo?AU<PRiUe@00R8R4@0BA2XRC288b[6Yb/6Yd/[1>T@IUhmfWin?
SiN?C4@Rc<c<WjVYOWi]OVeUKFeDG5a<>UALG5a<0SYDG004A4A<00000000
00000Q4A4@8000000a4A4B8bA00000026ATI0Q4A4@036B8b4A4A6ATI008A
4A400aTR<QTR:Q4A4@024A4A00<0000A4A4A4A400Q4A4@0;00004A4A<RXR
:Q48<SY4C5A]>UAL6EAnC5A]>UAL8TaD008jE5`02C94MSYDG29<E3YDG394
MSYDG28bA1TR<QTI6@026B9<00<I>WHbA7HjE5`00SYDG00600004A4A0000
4A4A6ATI00000Q4A4@0300004A4A0000008A4A401aTI4CY46B8R4A4A4BXA
200004`R2002:Q4801LA4A40000Z4@PI6A40000Z4@Q<8PPZ8QTIA8LIE7hZ
8QT0000jE5`IE38R8Q4I6A4IE38R8Q40000A4A4R8Q4I6ATA4A400`000008
6ATA:Q48:Q484A4AQda4G5a<4A4A6ATI0RXA2004:R8I8T@j8SXb6ATI0SYD
G004>TA<8TaD8T@j<SY40P00000B4A4A6B8RC4`jE7JGSiN?8TaD6EAnA140
/Fd0Wd`0SfDA:Q486ATI4A4AA4@Z6ATA:Q486ATA0Q4A4@060000A4A<b/6Y
hm:ac<c<b/6Y0[ViZ@0?^K6O^KV?Qd`ASgHjA4@booooG7jGIC884A4A6ATI
0000Wfe<hm:O00004A4A008R8Q402d`R228jG<6iWoCdk>?Kffe]E?clm?CS
bS8Z8_ooooCdm002k>cS0oCdk0?lo?@00oCdm?Cdk?Cdk003m?C/00Odm?C/
fl6iWgklo?CSk?Cdk=_B/Hl00_ooo`03Wgi<IC88C28807O<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h<lc<c08A4A400bXA214A4A4A4@02:Q48
00hZ8QULOYLjE8M<MWiDMYMLOYMUQjU<KHM]OXm]SiN7UjV7Wk7:/JW1/Il2
`KVO00G1/Io:`Io1/Io:`Ini^JT00m;:Z@0chm:a>T@I>SXRQbX0`Fe4>T@I
Wimnd[6?k=^ab[6Y^KVG/HMU/FdIQbX0m>?:hjV?^IM]A140hil0:R8IIAT0
IC88/AT0fgH8ID`IfhL8fhlb^KVG`KVG^KVG`K6?fgH8fk6O`Fe4Qd`AA140
Sd@0/HlIom88hil0k:UfdXLIbWH0m?C/QbX04A4AWhM]hm:ad/ZYQgiDA140
0094:R800b8R4D`R22XA20020000114A4@06ID`IG3XR0000:Q48C2888R8A
0bXA2003:R8IA1400000008A4A405bXA21TI4BXA228R4BXA28mU4@000<[1
WimnC;VGE2XA22XR6D@Z8U`j8[ViZK6a^Ho:UiN?MWInG6e]E6f7OVEU>UaL
C002WjVY00YfOUa]MWI]OXm]KEALKGHjA4`jE5`jA4`0000A4A4200000Q4A
4@080000:Q488S944A4A<RXR:Q484A4A6B8Z0QTR8P0300006ATI6B8R008A
4A401ATR:QTR8Q4A4A4A4ATI6@024A4A00`0000A4A40000A4A4RA3XZ4@Pj
G7I<E6djG7HjE5a<E6dRC5@4>UAL00/bA7HRC5@jE5a<E6dRC5@I8R8I6A4I
8RXR>U`bA7HIA7h00R9<E0078T@j6B8R8RXZ8S94<TAf8SYL000000<A4A42
000001/Z4@P0000R8Q4R8Q4jA1U<A28R<RXZ4@Q<8PQUG1U<8PP0000A4A4Z
4@PI6A4Z4@Pb:R8R8Q4A4A4I6A4I6ATjE8M4A380000A4A4I6A4R8Q400Q4A
4@0A00006ATA6B8Z8SXb6B8Z8SXb8TaD>UAL0000:Q488R8A<RXR8R8A0000
4A4A6ATA:Q48008R8Q402eB?/DafOQ4A4B8j<TA4C28j<S8jA29<E3YDG28j
<P0000024A4A00fOUhLjG7K:/JTAQiLIIGi44@3BS`2iQ`3BS`3SWb9U<PR7
E2XjA1T00RXA20074A4A00000000IE`Z0000d/[1hm;100?BbZT02;ViZL[1
ZL[1ZM^aWnbYMYMnE?clm6F7Z@9U<PP04D`R28m44JUf<[UnE6DI08m44ATI
4BXR6D`R228bA8nGSoooon?/m7ifINcSb_clm38Z8P02k>?:00Coooodm>cd
m>c/k><2m?C/0_Cdm0?lo?@01_ooooCdk?Cdm?Cdm?CSbYnOOP;dm?@01oCd
k>cK/OCdm?oool6iQd`R23Y46@1gc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^3?<c<`02QTI4BXA21TI4ATI4B8R4BXR6B8R4@00038Z8UAfU`8j
E8L00eb7Uc94MUanU`02IHNY00V7UjVOZJWBbZW1/Io:`Io:/JW:`JWBbZW1
^Il00/[1W`09d/ZY`KVGQgiDQgiD/HlIIFDj^IM]c<c<:Q4800:7IC805Ooo
om^aZN?B/OC/ffeU8^>O08mU4NbiKHmU4E`j8^?1A6EL6BXA2;4I0;V70?CB
O[6a^M^72>>O>/6aWl6iU`02b[6Y00KBQaW:^HoK/InaK@3SWeC/Z@02C288
00jOC03/^FgKSc:iUeB7IC80000R8Q6OQfgBbZW:`JUUG1Tb:R9<8PPR8Q42
:Q4800<A4A40000A4A4010000006G3XR<RXR:Q488R8A6ATI6ATA0T`R2003
A2XR>UB7<TAf008A4A4012XA200002XA214A4@8000004Q4A4@000;UnC;Vi
ZHM<4CXj<S8jA6DI09n7KK6a^IN?MTa48YN?QfEL:XMnSfEU>Xn7KInOS`9]
KE@02D@j8VED<XMnSfefMUa]MUaLC3YLMR9<E00000034A4A00<0000A4A4A
4A400a4A4@046B8R4A4A4A4A6B8R0aTI6@<A4A400bXA200001TI4@034A4A
00XI8RXI6ATI8S8R<T@I8S8R>U`IE7hZ4@Pb>T@jE5`2<SY40cYDG009>Uaf
>UAL>Uaf8TaD<TAf8T@j8SYL8S946B9<008A4A403R8jG394MQTR<Q4A4CY4
C28jG2XA200002XA214A4ATR:Q4A4ATR:P0000<A4A404P0004`R21TI4CY4
6Da48SY46B8R4@0002XA24`R26EL6A4A4@00014A4BXA228R4D@A02XR6@9<
8PP02c8jA3YUUcYUQcY46A4A4B8R4BXA228R4A4A4B8R4DA4:P028SYL00Tj
E5`I8T`R<T@R<T@b:R8R8Q5<8PPR8Q4Z4@P00Q4A4@086ATA:Q48:Q486ATA
C5A]>TA<6ATA>TA<1SYDG00kE6ef6B8Z0000d/[18T@jb/6Y4HNG6EAnUhL0
k:T0dXl0/HlIZL[Bk:T0/Fd000008R8AC2888R8A:Q48^GiDb/6Y0000b[6Y
k>cShm;1hm:ab/6O`KVGhm:ad/[1hm:ak<67fhMUm?C/Sini`Fe4WimnShmU
KFDRSgI4^M_dk:UfhjV?00008R8A<RXR0000ShM]oooohm_KOXn?`K6ioooo
G5a<Whm]0000Uhmfoooo00;lo?@03_ooooclm?clm>c/hncSb];:`K6iZInG
Qoclm?C/fnc/hoC/fk67IOCdk0Cdm?@01?ooom^aWd`R24`R27O<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c00J6ATA8R8A6ATA:Q486B8R
0000:Q48<TAf>UB7E7JG>Uaf<TAf6B9<<TAfOYniIHNYKHnGQina/K6i`K6O
b[6Y`K6Ob[6Y`K6Ob/6Ob/6Y0/ZaZ@0CWiN7:Q48>T@IA140k<67C288^IMD
himDWhm]hm:ab/6Yk;U]b/6Oc<c<fl6ObXlbSgHZQfDbm=9n00:aKAT06RXA
28LZ04@A0=]f28LZ0;VGE?CBO]]f2>bYC<6iUl6aWk67IM;:`JUf<WiLC;VG
E?C1A>biKN?1A6DI028R4Hmf:]:aSd`R238Z8R8R4@:iC0001k67IGi]C8mU
4@0004`R24@Z8RXA20024A4A0`0000044A4A00004A4A4A4A0P00000::Q48
6B8R:Q484A4AA4A<<TAfC6f7>VF7>UB76ATI114A4@8Z4@P07a4A4BXA22XA
200007i]C28R4C8jA3YDQfefMYN?Qlc<c6e]E;6iUhnGSfEU>YnOSk6iZHnG
SinOO/6a^Ea]MVe]E5A]MWinKEa]MVEL:Ua]MUaLC294>P00014A4@030000
0a4A4@0700008RXZ<RXR6ATI>UAL<SY46B8R008A4A401B8bA3YUUaTjMQTj
MR8Z:P026ATA0a4A4@0R6CYf6DAn6EAn6DB76EAn8TaD4A4A8R8A8SYLC5A]
C6fG8SXb8T@j8SXb8T@j8SXb8T@j<SY48T@j>TA<8TaD4A4A8S9400006B8R
6DAn6CYf8S940000<SY4>TA<0000:Q4800000RXA20034A4A8SYL0000008A
4A401000014A4BXA23Y46@8Z4@P2>T@I00h0000A4A4Z4@PZ4@PA4A40000A
4A4R<T@I6ATA4A4R8Q5LG4aDMYM<O[42>VF701<RC5A4>R8jA1T0000Z4@Pj
>R8IE38R<T@jE5a<E6dRC5@jG7HA4A4R:RXjE5aU<PQ4:R9<8PP000000Q4A
4@08:R8I6ATA4A4A6B8b:Q48C4a400008T@j0SYDG00<>TA<>UAL>UAL>TA<
C6f76ATA0000QlZa8TaDE6ef00008SYL0Xm40007/Fd0hl54k<4bfl48UhL0
00008R8A008Z4@P01Ua]M^c/hn?/m0000;6iUoclm0?/hlX01>cK`OC/fncS
b^c/h`;<c<`00nc/hk6a^@000003000001i<C3ZG^L[SZHo/ZGH0000I6A5L
G4cB/HoBbZWlo?C/k>>?UhnYZHoooomnIE@R:RXI8R80003Bb/6i^JVYZHn?
SfEUICYUC1U<8PQ44@0b:R9<8PPjA1Woool2k>cS00?lo?BiWgk/hlX00_Cd
m0;lo?@01?ooooCSbT`R23Y46GO<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h<lc<c006:Q480000:Q488R8A<RXR<TAf0SYUU`06C6fG6CYf<SY4
8SYL>UB7IHNY0WJG/@0;KHnaWjVY`KVO`K6O^K6O^KVG^KV?/KVG/K6?^Imn
d/ZY00;:`JT0:FeU8SY46@000?CSbVE<6InGQoCBORXA28mfA<ZaZNbYMXmf
:^?B`L6iQn?BWfDI0<Yf0>c/hm^aZJUf<VDI0;5]0=;:`K5]6Im<0;V70=;:
ZK5]0<Z?<Yn7KIMnE=^7IM:aSm:?0;5]6Gi]IHM<4FDb28LZ07InG6EU>P02
KFeD00ZO`K67E2Z?MTCBS`2aKAV?MSZi^INa/HlA4A4Z4@P28R8A0P00008A
4A400`00014A4@000002000000U44@0Z4@PR8Q4R:RXZ4@PR8Q5]OXm<KHLj
E8L00SYLMP078SYL4A4A:Q484A4A:Q484A4A6ATA008A4A40;00001TI6ATI
6BXR6CYDG3YDQea]QhnO^N?B`Fe]E3Y46CXj8Wj?SgInG;6a^KViZHnGSkVi
ZHnGScY46Fe]E6f7OYnOSgj?SginKHMnSda<A00002XA21TRC28Z:QTRC000
028Z:QTR8P00028j<SXj<QTI4EAfUda]U`00014A4ATI4@8jE8L01CYUUcYD
QaUDOR8Z:P0000024A4A00<Z4@PI8R8IE7h00QTjMP0<6DAn8SYL6B9<6DAn
C6f7C7jG6EAn6B9<C5A]>UALC5A]>Uaf0SYDG005>Uaf8TaD0000:R8I8S94
008I8S801394MR8jG3YDQeaLC080000024`R22XR6C8Z8T`R228R4C94MR8b
A1TI6@8A4A400`00014A4BXA2002>T@I0100000R8Q5UG2X0000A4A40000Z
4@PA4A40000Z4@Q4:R9]MWI4A39fUl5UUk4IA7h2>VF700U<OXlA4A4RA3Y<
OXlZ4@PI6A5<OXlI8T`R8Q400b9<E0078SYL6ATI8RXZ6E@b00004A4A0000
00<A4A426ATA01LR>U`A4A4b:R8Z4@PI6A4R<RXb>T@jA4a<C4A4A4`jE5`R
>S9<MWhjA38I8RZid]]fOUbG^LXIMWH0000A4A5U6@3:MP000_c1000?dXl0
SfDA0000:Q488R8AA140>UB7hm:am?Cd4A4AUhmfo?cdm>cKhm_Km>cK00;S
fm/07>cSb_Cdm<c<c;WBfl[1ZNc/hfDI028R4ATR<R8jG1TR:ZW:d]_1Wn>O
>QTRC39UZFenSkVaWhn?IOCdm9n?KFeU8[VGE;6iWfe]E1TI6B8R4ATI4@<0
00002C8Z8RXA24`R238Z8T@Z8S8Z8SY46BXA2?ooo`02m?C/00Wlo?C1^HO/
hl[lo?CooomnKDc<c<coooo/hlX00T`R27O<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h<lc<c0076B8b8S94>TA<>UB7<VFYC6fG>UB7008R>U`0
2aTR<SYDQeAfUff?/HNO/GJG/FF7ZEanUk6a^IN?MYnOOP02/KVG03ni/Io1
/Io1/Io:/JWK`Io:`InOWgjiUff?A03S`DBaQfF7E2ZGOUCddWhZ4@RiWgjG
SgK/^FgSZHoSfm_/^FgK`@QU6@2iC03/fk7lo?BOWgkdhl[:8P3K/IoKMPSK
Sc;:Sc;l`@2aKAVOC03Sd/7KWfg:/JWK`IoKMPS/`C;BQaWSWc[/ZDcd`D@j
A1TIMT@0000IMTBY`L[KOTc1KDC:MR;:MP3SWb;KMPPZ4@PA4A4R8Q5<8PPR
8Q4I6A400P0000076ATA00004A4A4A4A:Q488R8A6ATA008Z4@P02aTR<QTI
4@0003YDQeafOSYDQdaDKCYDQc94MP0002XA20044A4A0RXA200Q6ATA:Q48
8S94>TA<C5A]C6f7IHNYSiN?hm;1Win?hm:a8R8AC4`jG5a<C4a4Uhn7/KVO
/KVYb/6YKHMnC4`jA3XZG3XRIFDjG5a<d/[1MWiL0000<SY4>UB7<TAf>VFG
8SYL008R<T@05P00014A4B8Z:P0005anUcYLMQ4A4ATI6@0003YUUcYDQb9<
E3YDQaTRC1TR<S8jA00001TI4B8R4A4A4B8jG1U4OP8I>WH00aTR<QU4OQUU
OP02>VF701dI>WHjE5`jG7HjG7HjE5`jG7HjE5`bA7HjG7HI8R8Z8QTI6ATR
>U`I8T`R<T@bA7IDMYLIA7hR>U`b>T@0001LG4`R<T@jG7HjA4a<KHLjE8LR
C5@jE5`00P00008A4A400aTI4FEL6@000002:Q4804@Z8QT0000A4A4A4A4Z
4@P0000A4A4I6A400014A4`Z4@Q<E6d0000jIIM<MYMUQjTjE5`b>T@jA4`I
6ATZ4@Q44@0jA4`R<RXI6ATI6A4A4A4I6A4A4A4I6AT0001UE38I6A40000A
4A40000Z4@PA4A4I6A4Z4@PR>U`A4A4Z4@Q4A38A4A4j>S8jE5`jA4`RC5@j
E5aLG4aDKGJ?UhmLKHLIE7iLQhnGSgJid]]<MWjYb]8RA3X0002aK@3/Z@2i
UfgKOTaL>R800002:Q4800P0000RIJW:`Ioooolb>TAUIC[lo?Cdk=/2k>cS
0oC/f`0=o?cdb]_Khncd^KVYm>cKk>?:`K6i6DB7C5A]C4`jIFDjQe@ZIE@b
00:?MSX02FEU>SXj8QTI4D`R228R4A4A4@00028R4C8Z8P054A4A00LI6A4b
:R8b:R8b:R9<8PPb:R8jA1T00S8Z8P0>o?cdm?C/k>cSm?C/`KVGd/[1o?cd
m?C/0000:Q48KFeDIE`ZA2XR>T@IMlc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Pcc<c<01HbA7HjE8LjE8LjE8LbA7HR>U`I8S8R<T@bA7IUQjU]
SkUfUk5]Sk5DQk4jIHLbA7J?/L6GSgJYZHo:`IoBbZWK`Il4d/ZY02C:`JW1
^INi^Hodk=_SWeC/ZGKBS`2GQ`2?IA7/fk5U<PRa^INa/HoSWc[KWfgdm?CB
/HoKQfG/fl6aK@3/fk7/fl6iC03Sfm_:MP27C17/fk7/ZDbab/Z?MR[K`Io/
ZGJOWgiUICZiWgkBbZT2fhlb00GKQ`SSWb;l`@2?IA4I6A400aUfA00?Wl6a
k:U<bXlbhimDbWHRbWH0Qd`A6ATA8R8A:Q48C288<RXR:Q4800004A4A00<0
00004A4A4@0008LZ08LZ0000028R4C8Z8QTI4CY4C5a]QdaDKDa]QcYLMSYD
QcYDG1TI6BXA20034A4A00L0000A4A40000R8Q4R:RXjE5`bA7H00Ta]Q`0M
KHnGG6efhm;1WjVYG5a<IE`ZIE@bIE`ZWhM]C288IFDjOWi]WjVYOUa<`Fe4
SgHjID`I>SXb<RXRShM]0000:Q486ATI<TAf6B9<8SYL6B8b6B9<<TAf0080
00026ATI0RXR6@0C4A4A00004A4A>UB7<TAf>VF76CYf8S94>UB7E8na8S94
6B8R6B9<A1406B9<8SYL6DAn6EAn6CYf008IE7h01b9<E3YLMQTjMSYLMTaD
KCYDG3YLMP05>UAL01<jG7HI6ATR<T@A4A4R>U`I8T`IA7hbA7HI8T`R>U`b
A7HjE5a4A4`jE8M<E6dR>U`jE8LbA7HI8T`0114A4@0:6ATI4A4A:Q48:Q48
00008R8A:Q4800004A4A:Q480Q4A4@0@00006ATA0000A140A2XR:Q48:R8I
>Uaf8SXb8S948T@j8TaD0000:Q486ATA<RXR0Q4A4@086ATA4A4AA4@b8S8Z
ShmUOVe<A4@Z00001A4A4@0@6ATA0000>UALKGIfSiN?Win?A4@Z>SXR8S8Z
A3XZIFDjOWIUUhmfWimnd/ZY^KVY0XNGZ@0;SiN?k>?:6CYf8T@j00004A4A
0000Sk71`K6ihiljSd@0008000001bXA20000=;:`KVOO_oooea]MVE<6@07
o?cd00_ooomnOVdjA4b?SfG:`JTZ4@Pb:R8jA1U4A2XI8R8A4A401`000006
8R8A6ATA:Q480000:R8I6ATA0a4A4@0800004A4A0000:R8I<RXR8R8A:R8I
<RXR0T@Z8P038R8Aooooo?cd00;oool02];:`KVaWoCdk?CSbP00014A4CXj
8VEL:T@Z8T`R27O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<
c08bA7H01aU4Qb8jG1TR8RXR6CYDQfF7ZGJG/@03E7JG00HjIILjG7HjG7I]
OXnY`LYnMVD2ShmU00>?UhnOWgji^JT00/ZaZ@0jb/6Ofk6Yhm:a/K6?hm:a
Wd`0/FdIhilRQa40QfDbm<54IC88/K6?d/[1Qa40bXlbd/[1hjV?d[6?^IMD
hiljhjV?/Fd0dXLI^KVG^D`0ZGHb/FdIWd`0IAT0SfDAbXlbk:UfUgiDdXLI
k:UfShmUfhL8k:U<ZGHbSgHZKFDR0000C4`j6E@b6GI4A9n?G6efk:U<fhlb
k;U]/FdIWd`000004A4AA2XR8R8AC2880bXA208A4A400`0002XA214A4@02
00000bXA2006>SXR>UAL:R8IC5A]G6f7C6f70SYDQ`068SYL8SXb4A4A0000
:Q4800000bXA200Q00006ATI>UAL<TAf>UB7G7jGIHNYSgIDd/[1KFeD^Imn
QfDbA3XRA4@ZC4a4IE`ZG3XRQe@ZID`IhimDk=^ahm:Ofim]ZGHbbWH00000
Wfe<00006ATI8SYL<SY48SYL8RXZ008R>U`0114A4@0002XR6BXA20800000
1BXA228bA28Z:S94MSYUU`02>UB70SYUU`0><WJa00006ATA6EAn6B8b6ATA
8S946DB76FEn6Ffa6FEn6CYfE7JG>VF70QTjMP0N>UAL>UafC5A]>Uaf>UAL
>Uaf>UALC5A]>UAL8SYL<TAf6B8b>VFG6B8b>VFG6CYf8SYLG7jG>UB7G8N?
8RXZA4A<<RXR8S948SYLG8NG8T@j6ATI4A4A6ATI0Q4A4@066ATIG3XR6ATA
8R8AG3XR00000Q4A4@8Z4@P01@00014A4B8R4A4A4ATI4@03:Q4800<jA38R
A3Xb>T@00S8jA00>6B8Z0000:Q48>TA<00006ATA8R8AA140QgiD0000hm_K
hm:a00004A4A0P0000<A4A405QTI4@0007inKK6iWlZaZM;:`IN?MWi]C8n?
IInOO[ViUkVaWl[1Wl6a^N?B/Lc<c;7:bUA]MVEU>_Cdk000014A4@<00000
5HNGZINib]^OKN>O>QTjMQUDOQ5DZOCSb^?KfkVGKOooob8b:RXA2>cSb/c<
c=;:ZKViZIN?Qhn?IFe]E5`j8P026ATA00<0000I6A40000010000003:Q48
4A4A6ATA008Z4@P24A4A00<Z4@PI6A4R8Q400Q4A4@038R8A00006ATA00LA
4A403aTI6B8R4BXR6ATI4ATI6@000<[1ZKVOOYn?KKVGE8mfA;VOO/6iUl6a
Sin7K@02Uhn700=]MWIU<PPjA1T0Mlc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Pcc<c<0R8jG00^6ATA:R8I>UB7C6fGE8NaE7JG>VFGC6fGE7JG
C7jG>UB7<TAfQgj?Sk71QiNY4A4A6ATA8RXZQda4OVEDUhmf^KVG`KVG`KV7
/K6?`KVGID`IIAT0G3XRIAT0k>cSk=^ab/6YhiljIAT0^GiDd/[1SgI4^D`0
fk6Om?C/Sd@0hiljhjV?fk6Ohm_K0]^OK@0DdXLIhiljhm:O/@00Wd`0dT`0
m<54k:U<himDbXlbk<67Sfe<fhL8k;U]k:U<QlZa00006E@b00004A4A0QTI
6@0=Sd@Ak:U<fgi<himD/Fd0Wd`04A4A6ATAIE`Z:Q48A140>T@I8R8A0080
00001A4A4@000000014A4BXA20024A4A0bXA200:G6efA4A<G6efG6f7E7JG
C6f7C7In>UB78SXb:Q480Q4A4@0A:Q486ATA00004A4A:Q48:R8I>UafC7In
C6f7G7jGQiNYSgIU^Gi<bXlb^Gi<00004A4A008000004QTI4Hm44NcK/HLZ
08mU4D@j8XLA0>biKN>OE>cK/KVOO_oooa4A4D@Z8S94MTaDKB8jG1TR<P8R
>U`03000014A4ATI6BXA23Xj<S8jA3YDG28bA1TR<TaDKCYUUdanU`8jIIL0
54an/BXA214A4A4A4ATR<QU]/BXR6B8R4ATR<QUDOQUfMTaDKAU4QaUUOSYU
UaTjMR8jG3YLMSYDG4aDK@8jG7H05SYDG29<E29<E28bA29<E3YDQb8bA28R
4ATI4CYDQcYLMTafUdafOT@j:TanUaTI6BXA214A4BXA25A]MQTR8R8bA08A
4A402@00014A4ATI6ATI6ATI4FE<6FEU>Ta48Q4A4@02000000<R8Q4Z4@P0
0000114A4@04:Q488R8A6ATI6ATI0S8jA0038S948T@j<SY400<jE5`01@00
02XA228R4@000>c1Q`0400001A4A4@0;:Q486ATA0000WiN7hm:ac<c<k>?:
b/6OUhmf^KVGd/ZY00;Bb/406n?B/NcSb^cK`N?/m<c<c8nGSfE<6Oclm>cK
`L6iQaU4Qa5DZAU4QhnGShNO/LZ?<VDb21TRC1TR8QTI4B8R4BXA238Z8YN?
MQ4A4ATI6BXA2004000000<A4A40000A4A401a4A4@0400004A4A4A4A6ATA
0Q4A4@0:6ATA00004A4A4A4A6ATA8R8A0000:Q48:R8I00000a4A4@0>0000
4A4A4A4A4A4A00006ATA8R8AIC88ID`IQfDbWgi<^Imn`KVO^KVY0YnYZ@05
QiNYIHNYKHnGKHniKHna009]SkT2C288Mlc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Pcc<c<00HR<T@Z4@PR>U`bIJUDQk5<MYL2>VF70SYUU`0h
>VF7<TAf>UAL>UB7WjVYZL7:C7In6ATA>SXRA3XZA4@bG3XRA3XZ>T@IG3XR
IE`ZWimn/K6?^Imnfk6YQbX00000^Imnm=9nfim]k:UfSgHjk<67c<c<himD
k<67himDd/[1fgH8himDk=^afim]bWHRdT`0k<67bWH0k:UfdXl0bR80Z@P0
/@00bWH0hl54k;U]k:Ufk;U]IFDjfgH8k<67k;U]KFeD0P000008A140Qa40
C2880000QbX0himDhiljk;U]0Ym<0007^ImnA2XRID`IIE`IC4@R:Q486ATA
00@A4A401bXA2000014A4@0002XA200001TI4@028R8A00AUQjULMWi]OXmL
OYL2C6f700DR>U`bA7HZ4@PA4A4000001BXA200L0000<TAf>UB7G7jGQina
G5a<QfDbZGHb/HMUIE@b0000<SY4:R8I0000A140^IMD^IM]KFDRQgiDQa40
k;U]Whm]OVe<KFDRSiN?k?cdIFDjQgiD0Ua]Q`0E>UB78RXZ8S946B9<0000
4A4A:Q48>UAL>UB7IHNY4A4A>UAL8S948SYL6B8b6B8ZC7jaMYNaC7jG0000
6ATA008Z4@P00b9<E1TR8T@Z8P026ATA00E4A4`jG7HjG7I<OXlIE7h00QU4
OP088T@j8SXb8SXb8S8Z>T@b8T@j<SY48T@j0cYDG005G5a<0000:Q48E7JG
E6ef00<jE5`02Da]Qb8b:T@A02XA24@A05a]Qa4A4C8jA00000054A4A00P0
000I6A4A4A4A4A40000A4A4Z4@P000024A4A00`0000A4A4A4A4A4A4Z4@PI
6A4Z4@Pb:R8I8T`RA3XI8R8I6AT3>Uaf00=LG4`0000A4A400P000008QgiD
00004A4A00004A4A00004A4A00000a4A4@096ATA0000^KVGm>cKk>?:k>cS
k>?:/KVGhm:a00?/fl43k>?:00Sdm>b?/L5]Qgi44@3ooonGSgK1/HnOQfd2
^IM]00YUICYUC1TI8R8A4A4Z4@PA4A4R8Q40000A4A4000024A4A00@0000A
4A4A4A4I6A428R8A00TA4A4I6A4Z4@PI6A40000Z4@PI6A4A4A400000114A
4@0400004A4A4A4A4A4A0RXA208R8Q40128b:R8R4ATI6B8R4@HA4A401000
06E<6KVOOYnOOP:?Uhl018NGZHnO^GJG/Ff?^@=]Sk402VF7ZGJG/FF7ZFF7
ZGJG/FF7ZFf?^GjO^D`R23Y46GO<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h<lc<c0046B8b6B9<E8Na>UB71C94MP0;8SYL8S948SYL>UB7IHNY
/K6iZL[B6ATI8SXb8S8Z<RXR008R:RX04cXj8QTI4D`R2;VGKLYf8T@A06DI
09mnC?CSb^c/hkU<06DI0;5]05B?/Gk1UncK`KVGKN>YSoC/f`02fk6O02CB
QaWSWeCSWeC/^FfaK@3:8P3/`HOSWeC/^Fg:MR:a6@3:8P2a6@2a003KMPSB
QaW/ZGKKWfefOUbaK@3/ZDc/`HM44@27:P2iWgkooooKOTba002?A1674@3/
`HO<c<cSfm^OWgiU6@2OOT`2IE@b00QUG1UUC1T0000R8Q4Z4@PI6A4A4A40
00024A4A014Z4@PA4A4A4A4R8Q4Z4@P0000I6A6GQ`1UQjU]OXmDKGI<KHML
OYLjE8LjA4`I6ATA4A400RXA20030000:Q48:Q48008Z4@P2C6fG00N7UjWd
k=^aKAViOTbiOUBiOTb?MRX00P00000E4A4A0000bWHRk=^a^IM]0000^IM]
`KVG^Imn^KVYSgI4C288IC88A1408T@jWiN7C4a4Qgj?KGIfC6f7E7JG008I
6AT0228R4@0003Y4<R8jG6FG/CYLMR8bA28jG08b>T@01RXA23YDQdanUb8R
4BXR6ATR8P8I6AT24A4A00A4A4`Z4@PZ4@PI8R82>UAL00TbA7HI>WHIA8LI
A7hI8S80000b>T@jG7HjE5`00SYLMP09>VF7<TAf>UAL>UAL8T@j:Q480000
A4A<8TaD008jE5`00b9<E4a]QcY4C002000000DR8Q4Z8QTI8S8I8T`00000
2Q4A4@0500004A4A00004A4A0000008A4A402`00014A4BXR6DA4<R8R4ATR
8R8R4ATR8R8Z:RXR6B9<E003>UAL0Q4A4@0;00004A4A00004A4A00004A4A
0000:Q4800004A4A000000<A4A4020000;ViSoclm?clm?Cdm?Cdk;ViUoCS
bP?dm>`2o?cd00[dk=_lo?BiUeBiWgk1^HNa^ImnKDa<C3Y4A2XA4A440000
114A4@0500004A4A00006ATA000000<I6A400bXA214A4BXA20026ATA00DZ
4@PA4A4A4A4A4A4I6A400a4A4@03:Q484A4A8R8A008I6AT44A4A00L0000Z
4@Q44@1U<PR7E2Z?KD`000001Q4A4@07MYO1KHniKHniMYNaKHnaMYNaIHNY
00=fUk4027jO^GJG/GJG/GJG/GJG`Ff?/GjO^Ff?^@9fUl42C288Mlc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00TR:RXR>U`b>T@I8T`b
>T@I8S8I8R8R:RXI8T`00R8jG0084A4A6ATI>UALC7InE7in8R8AA4@Z8RXZ
0S8Z8P0S<SY46ATIA4@bC288d[6?b[6YSd@A^ImnA140^D`0k=_1bWHR^IM]
hm_K/L[:MWiLSgI4^IMDQe@Z^K6O/HMUb/6YfgHbk:UfhilRbWH0bR80/AT0
k<67k:Ufk<67fim]Z@P0/AT0Z@P000:74@0079N70>c1Qn>OE4@A0;5]0>bY
C>c1Qim<0;4I0=^7IK5]6K4I0>>YSlXR0;400;4I0>bYM]^aWhLZ04@A028R
4A4A4IMnE:Uf<VEL6ATI4A4A4B8R4@<Z4@P00a4A4BXA20000002:Q4800<R
8Q4jA1U<A2800YN70003KGj?QinaKGj?009DMYL01Ub7Uda]QbXR6@0002XA
21TI4@8A4A403000014A4@0003YDQeAfUn?Kfn?/m6EL6M:76M:aSkVGE:Uf
<P<A4A406@000>bYC=^OKHm40;5]6@0008n7KM^OKM_1WncSbZVYSk5]6D`R
28LA0>bYMYm]C8mfILc<c8MnSdA4C2XA2;5]6BXR6A4A4D@j:P02<SY400]D
KGHR>U`jG7HR>S80000b:R8Z8QTI6A4A4A4I6ATI6A400a4A4@0<6ATA0000
A2XR:Q488S948TaD>Uaf>TA<8TaD6CYf8TaD8T@j0QTR<P05C5A]>Uaf>UAL
>UALC5A]00<jE5`021TI4B8R4BXA238jA3YLMSYDG29<E3Y4C08jE5`01RXA
25`j8VED<RXR6B9<E1TR:PPA4A401000014A4A4A4@0000PA4A401P0003YD
G1TR8R94>QTR<R8j<P8R:RX01C8jA3Y4C29<E4a<>Q4A4@03000000<A4A40
000A4A400P0000044A4A00004A4A00000a4A4@070000IE@b/K6iWimnUhmf
IE@bOVe<00:i^JT01ZVYSiN?QgInG6ED<QTI4B8R4@T000034A4A00<0000A
4A400000114A4@04:Q484A4A4A4A00000aTI4@<A4A400aTI4B8R4A4A4@02
6ATA00<I6ATA4A4000000Q4A4@0=0000:Q48A140IC88Qe@ZSgIDUhmfZJV?
Win?WjVYQinaOYniUkW:00HA4A400`0007JG`GJG/@05KHni0ff?/@0:KGj?
IHNYQiNYKHnGSiN?KGj?G6efC5A]C4a4A3XZ0S8Z8WO<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h<lc<c00_8SYL6CYf8RXZ8S946B9<8SYL<TAf
C6fGE7JGC6fG6B8Z8SYLOYniSiniWjVY6E@b6ATA8RXZ<RXR6B8b>SXb<RXR
4A4AIC88A2XRSd@AKHnaSd@0m>?:bWH0ID`IWhm]dXLIfl6O^IMD4InGA9n?
fgH8bWHR/Fd00000:Q48Sd@0k=^ahimDfgi<Qa4000:Y20005^?BWnbYM^bi
KNbiKHLA0;4I0<Yf8]^7IIm]C;5]6Nc1QnbYC4`R28LA0?CSb^?Kfl6iUjT8
0=]nC<Yf8P000:Uf<P:a00001]9<0?C/foclm<6iUkU<0=9<009<8PP01nbi
KFeU8VE<6CY46BXA228R4ATI4@02:Q4800<0000Z4@PI6A400RXA2006>T@I
IE`IUhL0Sd@0SgHjQgiD0WJG/@05C6f7>Uaf>UB7:R8I:Q48008A4A400`00
014A4BXA2002:Q4804LR8Q6OQfgddWiUICYU6@2?MR[/ZGJaSaV7C167:P00
000A4A4Z4@S1KDBOC02?IA54>R8000274@3/ZGJiWgja/HlA4A6aKAViOTb?
A17/ZGJiUeB?A031/KV?A16OC00A4A6iC0274@0I6ATR<RX0000b>T@0000Z
8QTR>U`Z4@PZ8QU<8PPb:R80000I6ATZ8QTj>S8A4A4I6A4Z4@P0000j>S8I
6A40000R>S8RC5A<MWhR>S8jA4`R>S8RC5@b>T@0000I8RXjG7HjE5`jG7I<
E6d013YDG0048S8ZC288G3XR<SY40SY4C009>UAL>TA<A4A<E6ef00008R8A
00006B8Z>UAL008A4A400aTI6@0002XA20034A4A00DI6ATA4A4A4A4A4A40
00000a4A4@8000001ATI6A4A4A4A4@0005aLC0038RXZ00`R<RXR:RXR:RXR
:RXj>S9]KEBa/Hn?Qe@0000A4A40000A4A42000000<A4A40000A4A400P00
00054A4A00004A4A4A4A:Q48008000034A4A1P0000074A4A0000:R8I0000
:Q4800006ATA00TA4A400`00014A4@0000024A4A00<0000I6A4A4A400Q4A
4@03:R8I4A4A4A4A00<A4A43000000PR8Q5<8PQL>R9UC1V?MTB?MUB?OVfY
ZHl2WjVY00j?/L5nWkUfUk5]SkUfUk5]SkU]Sk5UUk5]Sk5nWkTZ8QTZ4@R7
4@0I6A444A4A01EfUl5]Sk5]OXn7UjVGShNa^JVGShOSd[7Sd/7Sd[7/fl7d
hlZ?MTC:`JUL>R9<A2;BS`0A4A54A2Z?MRYUG1T0Mlc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Pcc<c<00@bA7I<KILR>U`bA7H2>VFG03`jE8Lb
A7HR>U`jE8LR<TALKHN?/L6ab/XIMT@A4A4Z8QTI8R8I6ATZ8QTR8Q5nG4`R
<RYU6@2GOUBOC02?WkV?A03KSc;/^FfaK@3SWc[BQaW/`HNaSaTAWhM]KEC/
^Fg:MR;/ZD`0000A4A674@3SWb;BQaWSZHn74@2a6@2Y203:Sc;KOTcSZHoK
OTb7IC;/fk6ab/Z7OXnYb]:7OXoKMPSBS`2?A027:P3SZHoKQfGKOT`2/@00
01:7:P2?A167C16a003/ZGKK/JWSZHodm?BaKAV74@3SWeCBQaVGOUCK/JV?
IA5UG1U<A28jA1T2:Q4800<A4A4Z4@PA4A400RXA200300008R8AC4@R00:G
Q`002XLA02XA214A4@0007inKGJG/Gj?SfefMRXA214A4@8I6A42:Q480a4A
4@0;0000A140QbX00000hiljWd`0bXlb/FdIbWHRm<540000008A4A402^bY
0?CBOT`R214A4B8R4LYf8^>O>RXA2000028R4@944@003[5]6NcK`Im<0=]f
<[5]6N>OE8m4014A4K5]6KU<000004a<>P0002XR6@8Z4@P01RXR6B8R4B8R
4BXR6B8R4A4A4@<Z8QT02`00028R4BXA22XA24@Z8Ta<>QTR8QTI6C8jA3YD
G3Y4C002>UAL00@jA4`jE5`jE5aDKGH2>UAL00LjE8LjE5`jE5`jE5a4A4`j
G7I4A4`00R8b:P088TaD<SY48S948S948RXZ8SXbC7j?6ATI0Q4A4@03:R8I
C5A]4A4A00@A4A401BXA214A4ATR:QTI6BXA20024A4A00<0000A4A400000
0Q4A4@0700004A4A4A4A4A4A0000>UAL6ATA00<R:RX01aTR8R8R4B8b:Ve]
E9nOOYN?QgInG0020000114A4@0400004A4A00004A4A0P0000034A4A:Q48
0000008A4A428R8A0QTI4@8A4A402RXA214A4BXA214A4B8R4A4A4BXA2000
014A4ATI4@<A4A401@00014A4A4A4A4A4@0000054A4A00<Z4@PI6A4I6A40
0a4A4@8000001Q4A4BXA24`R28MD:XMU<YMnE0:YZHl0128R4JW1bXnO^HNO
/@9fUl402Vf?^GjO^GjO^GjO^Ff?^GJG/Ff?^GJG/Ff?/GJG/@9]SkT01ff?
/GJG`CYDG0000=9<04@A01TI6@024A4A00<0003/hl[/fl400_C/f`;lo?@0
3oCSb_C/foCdk?clm?Cdk?clm7i]C=;:`HMU<Q4A4OoB24`R214A4M_128m4
001gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`3>UB700/b
A7HR>U`R>Ua<KILjIILjE8MDMYLRC5AnWkV?UhnYb]800Q4A4@0`6ATAA3XZ
Qda4OVEDZJV?k>?:C4@RC288^IMD/FdIfk6YhimDbXlbSfDAWd`0k;U]QfDb
UhL0E7inC4`jIFDjk:Ufk:U<hm:OA1408R8AC288IAT0dT`0oooo/@00QbX0
Qa40fgHboooofhMUo<40^IMDhm;1<VFY0000Win?m>?:hilRm=9UKFDRZ@P0
m>?:0_Cdk00Afgi<bWHRQa40bWHRWd`0Z@P0k=^ao?cdhm_Kfgi<^D`0hilj
fl6OfgHb^Imnd[6?UkW:009UG1T013Y46C8Z8R8R4@00008A4A404@00014A
4@0004`R29N706EL6ATI4BXA2000014A4@0006E<6@00014A4L6iU`00014A
4@02000000PA4A40000Z4@P0000I6A4b:R9U<PQUC1T2:Q4800CKSc;/`HOd
dWj?MRX20000024A4A400027:P1U6@00000A4A400027:P00001<8PPb:R94
:R8b:R8R8Q5UC1ViUfd000144@0Z4@R?A14Z4@PA4A67E2Z?MSX0001nIE@0
000b:R8I6ATA4A4I6A4b:R8Z4@P00a4A4@8Z8QT02T@j:P0001TI4BXA228R
4ATI6B8j<QTR8Q4A4DafOP@jG7H01DafOSYLMSYLMSYDG4aDK@02>UAL00<R
C5@RA3XR>S800R8b:P0@6B8R8SXb8RXZ<RXR8S8Z>SXb8SXb<SY48S8ZC7In
4A4A6B8Z4A4A0000E6ef00001A4A4@046ATA00006ATI:Q480Q4A4@<00000
0aTI4@00014A4@034A4A00@0000jA4`A4A4R<RX48R8A00@Z4@PI6A40000A
4A45000000TA4A40000A4A40000A4A40000Z4@PA4A4000001A4A4@046ATA
:Q486ATA:Q480Q4A4@05:Q484A4A:Q484A4A:Q4800<A4A40100001TI4A4A
4@0000@A4A401QTI6A4A4A4A4A4A4@00014A4@800000214A4D@A06E<6IMn
E8n7KInGQjVYSinYZ@:?/L402GjO^Ff?^Ff?^GjO^@0007JG`Ff?^GJG/Ff?
/@03MYNa00F?WkUfUl5fUk5]SkU]Sk400fF7Z@07SiN?Uhn7WjVY`K6i/HMU
0000:R8I008A4A401aTR:Q4A4@000?CSb_clm?Cdk>c/h`04m?C/00g/k>?d
m>c/k>?lo?BiWgkBb/6GOU@0003odPR7C14I8RZaSaViQ`00Mlc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00HbA7HjIILjE8LjIIM<MYLj
E8L28SYL02=DMYMfUk5LQhm]Sk5]Qgi<MWhb:R8A4A4Z4@SK/IniUfgB/HoB
bZW/fl5nKFF?MRYU<PSddVFiC03/`HOSWcZ7:P3BS`3ddWiU<PQ<C3Zi^JV7
C15U6@3SdYoK/JW/`HNaKAW1KDC/fl400/5]A00]fk6Ok>cSbR80hiljZ@P0
m?C/m=9nk<67m=9Uhm_K/Fd0fim]Wd`0`K6ihm:Om=9UIE`IIAT0fk6Ym?C/
k>?:k=_1fk6YQbX0fgH8k;U]/AT0hm:ahjV?fhMUfgHbhjV?hiljfgi<Sd@A
KFDRm>?:ZL[BShMDUhL0IE`I>T@IA1406ATA:Q4800800000514A4ATI4BXA
23Y46@0002XA214A4@00014A4@0004`R22XA20000=_:WbXA200002XA24@A
04`R26E<6@@jA1T02fEL6Hmf:VE<6@0004@A0>biKDa48P0001TI4@0002XA
200200000Q4A4@0400006ATA4A4A:Q480S8Z8P08C288A2XR<RXR<RXR6ATA
IC88hil04A4A0S8Z8P07A2XR:R8IC288<RXROUa<4A4A<RXR009<8PP01bXA
24@j:RXR6C8Z8T@j:P0003Xj<P02<RXR00P0000A4A4R8Q40000Z4@PR:RXI
8S8Z8QT2>VF70SYDG0038TaD<SY4<SY4008R>S801294>S8Z8QTR<R94>P8b
>T@00b94>SY4C38jA005<SY400DjA4`RA3XR:RYDKGHI6AT00Q4A4@030000
C5A]0000008A4A42000000LA4A40000A4A4A4A4Z4@PA4A4000001A4A4@03
00004A4A0000008A4A400bXR6ATI4@0000024A4A00D0000I6A4A4A4I6A4R
8Q400QTI4@034A4A00004A4A008A4A4400000Q4A4@0400004A4A4A4A0000
0Q4A4@05:Q486ATA8R8A6ATA000000<A4A401ATI4A4A4A4A4A4A4ATI4@03
4A4A00@I6A4R8Q4I6ATA4A42000000XA4A40000Z4@Q44@1L>R:?MTB?MVE]
QgjOWhnOZJT2Sk7100=fUl5nWkUfUl400WJG/@03MYO1OYniOYni009fUk40
28na`@0007jO^GjO^Ff?^GJG/Ff?^Ff?/@9nWkT05HNGZIN?Qk6a^M;:ZM;:
`NcK`OCSb_C/foCdk?clm?oooncK/@00028Z:Q4A4NbYMXM<4KVGKNcK/OCd
k?Cdm008m?C/00_/k>?lo?BiWgja^JVGSgH0003K`@RaKAT0002?MR[SW`00
Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00@jG7HjE8Lj
E8MUQjT2C7JG02iDMYMLOYMfUk5LQiMfUk4IE39]OXlIMT@b>T@I8R:7IC;d
m>clo?C/fl7K/JW/fk6i/IlZ4@PA4A7SW`2Y203SW`3/^FfGQ`2iQ`3/ZDb7
E2Z74@31KDCKMS:Y203K/JV?WkWK/JWlo?CKQfF74@3KQfGooooKMS;:MR:a
6@3SZHn74@3:8P3/Z@02k=^a00i]SkVaK@3SWeCSWcXbA7K:fm^aSaTR8Q5U
6@3KMS;K/JWKQfGooona^Il3Sd@001>74@2?A17KMS;:8P3KQfGSd/7KWfgd
hlZOWgiUC1WooomU<PS/`HM<8PPjA1UUC1U44@0A4A4000000a4A4@060000
4A4A00000000:Q4800000a4A4@0<ID`IC4@R0000hm:O:Q48IC88IE`IID`I
C288<RXR>T@IID`I0SY46@04A140SgHZ:Q484A4A0`0000036ATA:Q480000
008A4A402ATI4BXA214A4A4A4ATI4@00028R4D`R22XR6@02<RXR0T@Z8P04
A140<RXR<RXR6ATA0RXR6@07C288A140A2XRA2XR:R8I4A4A:R8I008R8Q40
1S8Z8SXj8T@j8S8Z8SY4<P00008Z8QT28R8A00<Z8QTI6A4jE5`00cYDG003
>TA<<SY4>T@b008jA4`014aDKCYDG3YDG4aDK@@jE5`00cY4C4a<A3Y4C002
<SY400<jA38jA4`j>S800R94>P0<<SY4<RXR8SXb:R8I>UAL00004A4A6ATI
0000>UAL4A4A6ATA1Q4A4@096ATA4A4A4A4A4A4A:Q486ATI8R8A:R8I4A4A
008000024A4A0QTI4@044A4A:Q484A4A6ATA0a4A4@@I6A400`00014A4@00
000200000Q4A4@0700004A4A000000006ATA00004A4A008I6A424A4A1aTI
4@0I4A4A6ATA4A4A4A4A0000:Q480000:Q480000:Q48A140IE`ZQda4OVeU
Sgi]SiN?QiNYSiniOYniMYO1UkW:MYO1OYniMYO1MYNa009nWkT2MYNa0WjO
^@0?MYNaKHniMYO1IINaKHnaOYni0000QiNYIHNYQgj?Uhn7^KVGWiN7hm:a
m>?:00;dk=/00oclm?Cdk?clm002m?C/00c/k>?dm>c/k>?dm?CoooniOT`0
003dk=_dhl[dm>coooolo?@;m?C/00[lo?BiWgja^IO1^IL0002iQ`3K`@P0
002?IA7l`@1gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`0
7CYDQc9UZCYUUeanUeAfUff?/EB7/FF7ZGjO^CYUQcYDG1UfA5AnOSYDG3Xj
<QTR<ZT80>cK`Nc/hm^aWn>YSm_1Wl[KfkU<0;V70<Yf8[4I0>?1A>>O0002
o<4001kSZHodk=_K/JW1KDB7:P3K/JWooonid]_K/IoSZHoooonaKAWKMS;B
C03KQfGBC03:MR;K/JW/hl[:MR:OKDcBb/5fUl4bM[6OC02aSaViQ`27C15]
Sk6YZHl24A4A01fY203KMS;:8P3KMS:7:P2a003:MR;/^Fg:8P2a003:8P3B
C03SZHoSfm_K`Iodm>bOSfeUC1W/k>?Sd[6?IA4b:R80000A4A40000A4A4Z
8QTA4A4000000Q4A4@0G:R8IKFeDQd`Ak=^a:Q4800004A4A0000G3XRIE`Z
0000d/ZYIC886ATA4A4A8R8A0000IC884A4A>T@I8R8A<RXRIE`I008jA1T0
0aTI4@0001TI4@024A4A00<I6A40000A4A400P00000::Q484A4A4A4A0000
:Q488R8A<RXR8R8A:R8I<RXR0b8R4@04:Q486B8R0000A2XR0RXA208Z8QT0
1d@Z8T@j:P0002XR6Da48RXR6B8R4@03<RXR00XZ8QT0000R8Q4R8Q4I6A4b
:R8j>S8Z8QTjE5aDKGH3>Uaf00M<MWhjIHLjE5`jG7IDKGHjE5`jG7H013YD
G008C4a4<SY4>TA<>TA<8S94<SY48S8Z8RXZ0R8b:P06<RXR8S8Z8S8Z8SXb
6ATIC4a40a4A4@030000<SY46ATA008A4A426ATA00TI6ATR8Q4Z8QTI6ATI
6A4Z8QTR<RXI6ATI6A401Q4A4@03:Q4800004A4A008I6A4:4A4A00D0000A
4A40000A4A4000001A4A4@0500004A4A4A4A00006ATA008A4A400b8R4@00
01TI4@03000000@Z4@PI6A4Z4@PZ4@P2IE@b00I]KEB7OXm]MWJ7OXmfUk5]
SiL2KHni00A]Sk5]SkU]SkU]SkT6MYNa0WjO^@05MYNaKHnaQinaOYniMYNa
009]SkT02YnYZJVYSk6a^JVYSm^aZM:aSoCdk<6iQncK/OC/f`;dm>`01OC/
fnc/hoC/foCdk>c/h`07m?C/0^c/h`07^Imn`KV7ooooo?cdm?Cdm?C/m?Cd
00?dm>`00oclm?Cdk?Cdk005m?C/00[lo?C1^HNOWhoSd[40001L>R;odPP0
002?MR[/Z@1gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`0
1TaDKEB7/Da]UeanUfF7ZDafU`9UQjT035b7Uda]QhNO/EA]MSYDG28b:T@j
:UaLC>cK/Oclm?Cdm?CSbP;dm>`0:n?/m9m<0?C/fnbYMXMD:^>O8^?1A?c1
09N70>>YSoCSb_C/fm]f<^biKLZiSm^7IM^aZOCdm=]nC<Yf8[5]6Hm40;Un
C;4I0>>YSn?B`K4I0=^aZN>O>[5]0>?/m:VYShlbC=:?0>>O8^biKM:?0;Vi
Sn?B/GinKDA4:XMnE8M<4@02bR800[40000EbWHR^D`0^D`0/@00fk6OhjV?
d[6?oooohncdooooShMD>T@Im>cKk=^a0000>T@I0000A4@b<RXR8R8A<RXR
00<A4A42000000ELG4b?MR[/k><Z4@P000000Q4A4@0?C288C4@R0000d/ZY
IE`IKFDR<RXR4A4A:Q48>T@I:Q48C4@RID`ISfDAWgi<008Z4@P021TI4A4A
4A4A4ATI4A4A4BXA214A4@00008A4A402BXA21TI4A4A4A4A4CY46@00028R
4BXA238Z8P02:R8I00M4:R8R8Q54:R94>RXA4A4Z8QTZ4@P00T`R2007A140
A2XR:R8I6ATA0000IFDjA4@b009<C3X024A4:VED<Ta<>P0002XR6D@Z8S8Z
8TA4:P8j>S8034afOSYLMSYLMTafOSYLMSYDG3YLMUA]MSYDG3YLMSYDG4aD
K@@jE5`00dA4C3Y4C38jA0028SXb00<j>S8R<RXR:RX00b8b:P04:R8I8RXZ
:R8I:R8I0R8Z:P0:8R8A:R8I8RXZ<RXR8S8Z8R8A:R8I6ATI4A4A:Q480Q4A
4@0400004A4A00004A4A0P00008A4A400`00014A4@0000024A4A00@0000Z
4@PA4A4000034A4A00<Z4@PA4A4A4A400QTI4@03:Q4800004A4A00DA4A40
0`00014A4A4A4@024A4A00`0000I6A4A4A40000A4A40001<8PQ4:R9L>R9U
ICYnIEAnOVd2KGIf00Z7OXm]Sk5fUk5UQjU]SkUUQjU]SkUUQjU]Sk5]SkT2
KHna00E]SkUfUk5fUk5]Sk5fUk400Vf?/@03MYNaKHniMYO1009nWkT01hNO
/InYZHNGZEa]QlZaZNcK`GinK@02o?cd00W/fl7lo?Clo?Cdm>cdk=_Sd[7B
b/7lo?C/k><03?Cdk007k?cdk>?:OVe<ID`IC4@RShMDo?cd00Cdm>`00oC/
foCdk?Cdk006m?C/00_/k>?lo?C:`InGSgKSd[40000Z8QWK`@P0002?MRZG
Q`00Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00DjE8MU
QjTjIIM<KIMLOYL00VF7Z@03KGj?C7ja8S8Z009]Qgh0=hO:/A4A4ATI4Da<
A9mnC;67IOCdk;6iUimnC6eU8[67IM9<08MD:^c/hc94M]^aZNc/hlZ?<RXA
29n?KK400<XR0;U<0>>OE;4I0<6aWn?B/Oclm?ooon?KffDb2?ooohM<4N>O
E?ooom;:ZM^7ILYf0>cK/Oc10>c1Qm^aZM9<0?c10>c1<];:ZOc10<[1Wk6i
ZFEL:VED<XmnKB8R4BXR6LXR0002/AT001CBC02iC03BC03:8P2iOTb?SfG/
fl7Sk?C/hl[ooon?SfDZ4@Sdk=_/fk5<A29UC1ViQ`2?IA5<A28000054A4A
01400027OUB?MR[dm>a44@0Z4@QU6@1U<PQUE3:?KDbGSgJi^IM<8PQ]KEB7
OUB?IA5]IB800fEL6@07SgHZk=^ahm;1hm_K^IMD4A4A000000<A4A405B8R
4A4A4A4A4@00014A4B8R4@00014A4@00028R4BXA24@Z8S8Z8RXR6D@Z8SY4
6C8Z8R8R4C8Z8R8R4@000003:R8I00M4:R8Z4@Q4:R8R8Q4I6A4A4A5<8PP0
0k4I0005G3XR8S8Z6ATI8S94A4A<008b:R801SXj8SXj<SXj<TaDKCYLMUA]
MP8jG7H01EA]MSYLMUA]MSYDG3YLMP02>UAL010jG7HjE5`jA4`jA4`b>T@R
A3XR>S8R<RXb:R8I8R8R:RXI8R8Z8QTI6ATI6A4R8Q436ATA0R8R4@8A4A40
4@00028R4ATI4@00014A4@00014A4@00014A4@0002XA214A4@00014A4@00
02XA2000000;4A4A00<0000Z4@P00000114A4@06:Q484A4A4A4A00004A4A
0000114A4@8000002BXR6B8R4C8Z8T@j8T@j:VED<XMnSfenSff?U`02IHNY
00EDMYMUQjUUQjUUQjUDMYL00VF7Z@A]Sk400ff?^GJG/Ff?/@02KHni00MU
QjU]SkU]SkUnWkUfUl5]SiNa/KT00];:`@0=OWi]Win?m>?:k=^ak=_1WiN7
C4a4m?C/o?cdOVeUoooom?C/m?Cd00?dm>`01>cK/CY46L6iUoclm0?dm>`0
1Oclm?Cdk?Cdk?Cdk?Cdm006m?C/00KdhlZ?QffOWgiLG4bOWgklo?@2m?C/
00Sdm?Cdm>cdm>cdm?Cdm>clo?Cdm>clo?@2m?Cd00cdm>clo?Cdm?C/fl6?
Qfg/fl4I6A4j>R:?IA54:R:aSaUUC1Ugc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^3?<c<`01da]QeAfUda]Uda]UfF7ZFf?UgJG/@02E8Na00]n
WkUnShn7UjTRA3X0000Z8QTR8Q4Z4@P0003B/HmUC1T00P00000IA140^Gi<
Sd@0bXlbo?cd/KVGSgHZ^KVGG5a<0000WiN7hjV?/@00bWHRbR80d/[1fl6O
o?cdm?Cdhm_KIE`Zk>?:WhM]k>cSk?cd00;oool01>?BWm_12>>O0>c/h`;d
m?@03^>O0?c10>bY0?CBO_C/f`00028R4Fe]E7InG4a48P0008LZ0<XR0;40
00;:8P003;4I0<XR0:Uf<Yn?KM^aWoooooCdm?ooohmU4C8Z8_C/fhmf:P:Y
MS801_CBIOCBO[6?6ATI6A4A4ATI6@<A4A4078n?IFEU>P000;VOO^c/hoC/
foclm>?B`K6aSlc<c>?B`KVaWfEL6FEL:QTI4InOO[6iUfEU>Xmf:]:aScY4
6NcK`N?/m?Cdm>?B/AUD<P00014A4@8I6AT00bXA2000014A4@024A4A00DZ
8QTR8Q4Z8QTR8Q4000000R8R4@8b:R804SXj8T@Z8T@Z8R8R4BXA22XR6ATI
6BXR6D@Z8T`R22XR6B8R4BXA24@Z8Q4A4ATI6LXR0;4I00>a00003XLZ06EL
:T@j:TA4<T@j8RXR6CXj8T@j:SXj8TaDKEA]MSYLMTaDKDafOP@jG7H00fe]
E3YLMSYDG002>UAL00E4A4`jA4`RA3Xj>R8I8R800QTI4@03:Q484A4A:Q48
008I6A40114A4ATI4ATI4A4A4@<I6A40114A4BXA214A4ATI4@DA4A4011TI
4A4A4ATI4@0000@A4A401@00014A4@00014A4@0000024A4A00H0000A4A4A
4A4Z4@PA4A4Z4@P24A4A00@Z4@PA4A4A4A4Z4@P26ATA00<0000A4A4I6A40
0Q4A4@04:Q488R8A8R8A<RXR0dA4C0078SYL<TAf<TAf<TAf>UB7C7JGG7jG
00IUQjT017JG/FF7ZGJG/FF7Z@9]SkT2IHNY01U]SkUfUk67UjVGShNa/KVi
^JV?Uhodk=^?QfeLG4cdhl[/hlZOUhOoooni^Hm]KEBOZJUfOUcSfm^?Uhm]
KECoooolo?A]KEClo?@00oC/f`08^Imnhm_Km?C/G3XRo?cdm?Cdm?C/k>cS
2?Cdk00:o?cdm?C/m?C/m?C/o?cdShMD^KV?IFDj^Imno?cd0oCdm008o?cd
m?Cdm?Cdo?cdm?Cdm?C/m?Cdo?cd0oCdk00:m?Cdm>cKOWi]k>?:C2886ATI
<RXRUhL0dXLI8R8AMlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pc
c<c<00I<KHLjIIMDMYM<KIN7UjU]Sk43IHNY00UnWkV?/L6id]/I8R8b:R8I
6A4R8Q4R<RXI6AT00Q4A4@8Z4@P02RXR6A4A4@000;VGE?oooinYZA4A4L6i
Unc/hjVYS`;/hlX03=]f<[U<0=]f<Ta<>[VGKOclm?Cdm?clm<6aWn?B/OCd
k?ooo`;dm?@02_C/foooooooom;:`OC/fncK/Nc/hn?KfncK/OCdk0;/hlX0
1ATI4CY46FED<WifIDa<>P024A4A01Va/Hn?A16OC01<A29UICZiUe@0001U
C1W:/JWdhl[K`IodhlXjA1TI6A7Sd[6OWgjOWhn?QfgBbZWdm?BOWghIE38I
6A40000A4A400QTR8P0F^IMD0000:Q48fk6Yo?cdhm_Km>cKhm_KWhm]hm:a
d/ZY^ImnID`IKFDR4A4A>T@IZJV?^KVG`KV7oooo8R8Ak=_10_Cdm007k>?:
>T@I4A4A4A4A:Q488R8A:Q48008A4A400`0002XA21TR8P03:R8I00PZ4@P0
000b:R8Z8QTb:R94:R8b:R9<A285:R8I00Q4:R8Z8QU4:R94>RY4:R9<8PPA
4A6a6@03/@000k4I0005MWiL8S8Z>SXbC4@R<RXR008j>R800d@j8SYDG5A]
MP02C7In00HjG7I<MWi<E6djG7HjE5`RC5@28T@j00@R>S8R<RXR<RXI8R82
:R8I00`I6A4R8Q4I6A4I6A4R8Q4I6A4Z4@PA4A4Z4@PI6A4A4A4Z4@P34A4A
00H0000A4A4A4A4A4A4I6A4000024A4A00<0000A4A4000000Q4A4@030000
4A4A0000008A4A401RXA214A4BXA214A4@0002XA20HA4A4011TI4A4A4@00
014A4@8I6A403000014A4ATI6A4A4ATR8Q4A4ATI6B8bA1TRC1TjMQU4Qc94
MPDjE8L014a]UeAfUfF7ZGJG/@9]Sk42MYNa0Vf?^@03IINaIHNYIHNY00:O
ZJT01HMnSk6a^N?B`FefM^cK`@02o?cd01Gdm>cooomUIC[oooo:`Im]KEBO
`K5LG4b?SfGooooSfm]nMUBGShMLG4b7IC;1^IOdk=_Sfm_dhlYUG2[oool0
0oCdm009k>?:hm_Kd/ZY^KVGoooom?Cdm?C/k>cSm?C/00;dm?@01?Cdk?cl
m?Cdm?clm0Cdm?@04OCdk?ooohmfE;6iUfEU>YnOO_Cdk?clm?Cdk?Cdm?Cd
k?clm?Cdk?Cdm?clm?Cdm?clm002m?Cd00clo?Cdm>clo?Clo?B7OUC:`JWS
dYn?IA6OOTbiUeC/`C:iWgigc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^3?<c<`01UAfUda]UeanUeAfUfF7ZHNGZ@9UQjT01fenShnO^InYZKWB
f`000=:aSbXR6@02000000djA1TI6A4R8Q4A4A4I6A4R8Q4A4A40002?IA7o
ooo:^HnYZHljA1T00[6aS`08k=^ad[6?d/ZYfhMUID`Iooook>cSo?cd0_Cd
m00Goooohm:ak=_1k=_1m>?:k=^am?Cdm?C/k?cdk>?:`KVGb[V?m>?:k=_1
hm_Kc<c<m>?:SgI48R8A:R8IMWiLOWIDIFDj008000002;VOO[6iWhNGZFe]
E;6iWgj?SiN?M/6aW`:i^IL05VEL6FeU8RXA24`R24@j8XmfA<ZaZK6aSkVO
O_ooolZaZ@0009N?M[6iUk6iWfE<6Da48Xmf:RXR6BXA2<6aWoclm0?/k><0
3KVGKNc/hoCdk?C/fda48Xmf:Q4A4FE<6M;:`OCdk>?B/OCdk1TI4@03o?cd
00?BbZTZ4@P000000QTI4@068SXb8R8A6ATA4A4A00004A4A0RXR6@066ATI
8R8A:Q484A4A8R8A:Q480RXR6@03<RXR8R8A8R8A008Z8QT00cXj8S8Z8T@Z
8P05A2XR00BaQfGKWfgdk=_dk=/2k>cS0_Cdk00CA1404A4A0000A2XR6ATA
:Q486ATI:R8I>TA<6EAn>TA<8TaD>SXb<SY48T@j>T@b>TA<>UALC4a4008j
E5`01TA4C3YDG4a<>R8j<R8b:RXR6@8I6A400bXA21TI4A4A4@026ATA00XZ
4@PA4A4Z4@PA4A4Z4@PA4A4Z4@P0000Z4@P00002:Q4800@0000A4A4A4A4Z
4@P44A4A00<Z4@PA4A4Z4@P0414A4@036ATI6B8R4A4A008I8RX011TR8QTR
<QTRC1TR<P8R>U`011TjMS94MSYDQcYDQ`9<KIL2E7JG0eanU`04IHNYKHni
KHniOYni0WJG/@0MWjVY/KVOfk6Yfl6Ok>cSWiN7k>cSooooWimnb/6Ooooo
^ImnUhmfWin?OWi]d/[1ooooOVe<o?cdhm_KWhm]WiN7b[6Yk>?:m>cKIFDj
b[6YooooShmU00;oool02m;:`Oclm?ooogiLC?ooooCdk?Cdm?Cdk>c/hm;:
`L6aW`02m?C/0_Cdm00Co?cdm?Cdm?Cdo?cdm?C/m?Cdm?C/m?Cdm?C/o?cd
m?Cdo?cdm?CdooooWgi<^KVGOVe<^KV?o?cd00?dm?@01_clm?Cdm?Cdm?cl
m?Cdk?clm0;dm>`02?clm?Cdk?Cdm?Cdk?clm8n7E<[1ZOC/f`;dhlX00oC/
foCSb_ooo`1gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`2
G7jG00=DQk5<KIMUQjT00fF7Z@09KHnaQinaSini`K6i0000QfDboooom>?:
KFeD008A4A4011TI4ATI6A4A4BXA20:OKD`04[VGKOclm?oook6iWhMnSbXA
2;67IOoooinOOXmf:/6iQiMnE=_1Wn?B/OCSb_Cdk?C/foCSbP;dk=/01?CS
b^cK/OCSb^cK`@;/fk400m_:Wm;:`N?B`@02m?C/00W:fm^?UhodhlZi/IlI
6A4jA1UUICYnG4b7OU@00Q4A4@09ZGHboooo/KVGMWiLoooohm:am>?:m?Cd
^KVG00:OWgh05IN?M[VOOYnOOXmnKFEL:];:`LZaZM;:`L[1ZK6iUaTI4Da4
8R8R4KVOORXA24a48RXA238Z8T@Z8[VGKOclm003k>cS00Cdm?CSk?Cdm?Co
ool2>T@I00aL>R:7IC:GOUBGOUBa/Ho:`In?MRZaQfFOSff7OUAUC1Tb:R84
:Q4800<R8Q4A4A4000000Q4A4@0;8RXZ8R8A8R8A8R8A6ATA4A4A:R8IA2XR
A4@bA3XR<RXR00@Z8QT00aTI6BXR6ATI6@02A3XZ00m4A38Z8QTR8Q7:^HoK
WfgSk?CSfm_Sd/7Bb/7:`Io:^Hm]IB94A3800014:R80138Z8P0:A3XZ>UAL
C5A]C5A]C7In>UALE6efC7In>UafC5A]13YDG00?A4A<<SY4<RXR6ATI:R8I
6ATA:Q484A4A6ATA:Q484A4A:Q4800006ATA:Q4800@A4A402ATI4A4A4A4A
4A4A4ATI4A4A4BXA200001TI4@0<4A4A00DI6A4A4A4A4A4I6A4I8RX00Q4A
4@076B8Z4A4A6B8Z6B8b6B8Z6B9<8S94008I8T`38SYL00<IA7hbA7HbA7H0
0SYDQ`03>VFGIHNYE7JG009LOYL09fenShMnSeanUhNGZN?B/M_1WncSbYn7
KDaDKFe]E>?B/OC/foCdk>c/hoclm>cK`Fe]E7InG5aLC>?B`Oclm<[1ZFe]
E5aLC7i]INcK/NcK`FEU>_oooiMnE;6iUoooooclm?Cdm?oooinOOZVYSooo
oim]C002oooo00JOQfgBb/7ooon?KDcoooodm?@2m?C/00gdm?Bi/Iodk=_o
ooniWgkoooodm?Cdm>cdm?Clo?Cdm>cdm?Clo?@00_Cdm00<o?cdm?Cdm?C/
m?Cdm?C/ooooUgiD`KVOKFDRWin?m>cKm?Cd0_clm0;dm?@00oclm?Cdm?cl
m002m?Cd00Wlo?Cdm?Cdm>clo?Cdm>cooon?QeBa^IOdk=/00_CSbP03m>cK
o?cdm?Cd07O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c006
G7jGKGj?E7JG>VFGQiNYMYNa0VF7Z@0LQiNYSiniZL7:6ATI^Imnc<c<Whm]
/KVGIFDj8R8A<RXRA2XRG3XRA3XZQfDbm>?:k=^a^Imnm?C/`KVG`K6Om>cK
Uhn7WhM]ooooSgI4Wgi<Whm]0[VGE003UgiDd/ZYk=^a00?/fk400n?BWm;:
ZNcK`@02hm:O013Sd[7SdYniUeBi^JW:/JWSfm_lo?C/k>=]SiO/`HOlo?@R
8Q4Z4@QLG4aUE39LG4`2000000IU<PSBb/5fOUb7IC;/hlZi^JT2hm;101_1
^INi/Io:/JW:`JW:/JVi^IO1/Ina^IN?SfEnKDaUG1U4>R8jA1Tb:R94>RXZ
8QViUeB?MTBiUeA]IB9L>R8R8Q6?MS[oooo/hl[Sfm_/hlX00nc/h`0=oooo
KFDRIE`IOVe<hm;1hm:ad/[1b/6Od/ZYb/6YWhm]/HMUID`I00HR8Q400aTI
4A4A4A4A4@02000000LR:RXZ8QTb:R8I6ATZ4@PA4A54:R800SXj8P05:R8I
8R8A8R8A8R8A6ATI00<Z8QT021TI4D@Z8S8Z8T@Z8S8Z8P000?CSb_Cdk0:Y
2003/@0000>Y2031^HM<A2800P0000058RXZ<RXRA3XZ>SXbC4`j009<MWh0
1eA]MSYLMTafOSYLMTaDKCYDG5A]MP02>Uaf0cYDG006>TA<<RXR:R8I:Q48
4A4A:Q481Q4A4@08:Q484A4A4A4A:Q484A4A:Q484A4A:Q480QTI4@<A4A40
0bXA214A4A4A4@034A4A00<I6A4A4A4A4A40114A4@056B8Z4A4A4A4A6ATA
000000DI8RX01ATRC1TR<QTRC28jG1TjMP026DAn00<bA7HIA7hjE8L00SYD
Q`07G6f7E7JGQgj?ZJV?G6f7^K6Od/[100;dhlX03?Cdk6EU>/[1ZOclm>cS
b_clm?CSbTa<>Xn7KM;:`OC/fnc/h`;dm>`01oCSbWi]C8mfE6e]E?clm>?B
/N?B`@02m>cK00fOWgkooooooomnG4coooo:/JVGSgKoooodm?Cdm>coooo:
`ImnKFD00_ooo`07d/[1hm:am>?:m?CdooooWhM]o?cd00;dm?@2o?cd00NY
ZHooooodm>b7IC;oooodm?Clo?@00_Cdm004o?cdm?C/m?Cdo?cd0_Cdk00;
o?cdm?Cdo?cdm?CdooooUgiDC4`jIE`ZG5a<m>cKo?cd00;dm?@01_clm?Cd
m?Cdm?clm?Cdk?clm0;dm?@01oclm?Cdk?Cdm?Cdm?oooimnC9nOS`03m>cK
00?lo?Cdm>clo?@0Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pc
c<c<01iDMYLjE8MDMYMDMYN7UjU]SiMfUk5UQjV7Wk6?WkU]SiLZ4@SK/JW/
k>>OSffOOTb?SfEL>R:iWgkBb/7Sd/7Sd[7lo?C/hl[/k>?dm>c/k>?/hl[/
k>?dm?@2o?cd00W/hl[Bb/7Sd/7/fl7Sd[71^IO1^HOB/Ho/fk401N?BW`0a
k=_1k=^ak>?:m>cKhm_Ko?cdShmU^Imnhm_Km>?:c<c<OWIU`KV7QgiD>SXR
8R8AIE@bA4@ZG5a<SgI4UgiDSfe</HMUSgI4OUa<SgIDQfDbQd`AID`I^KVY
b/6Y`KVO`K6O/K6?^KVGd/ZYhm;1ShM]hm:aQgiDKFeDIE@bC4`jA4@b<RXR
IE`ZKFDRWgi<<RXR008R8Q400hmf>_ooonc/h`02k>cS00gdk=_dm?Cdm>co
oonOOTc1^HNaQfFa/Ho1^Ini^HnOWgjGOUB?Qe@00da48P8Z8QT01B8R4BXR
6B8R4B8R4BXA20034A4A00<0000R8Q4I6AT00R8R4@0C4A4A8R8A:R8I:R8I
8R8A:R8I:Q48:R8I6ATA:R8I8R8A6B8R:Q486ATI<RXRG3XR:Q48/HMUk=^a
00;/hlX04>>YSk4I0;4I0;400;4I08mf:YnOOP00014A4BXR6ATI6Da48S8Z
8T@j:Ta<>SYLMP=DKGH03CYLMUA]MUA]MTafOSYLMSYDG5A]MTA4C3YDG3Y4
C4A4<R8b:QTI4@034A4A00HZ4@PI6A4A4A4A4A4Z4@P000024A4A00<Z4@PI
6A4A4A40114A4@0500004A4A6ATA4A4A0000008A4A4011TR:Q4A4ATR:Q4A
4@<I8RX26B8b00HI8RXI8S8Z8QT0000Z8QTR8Q426B8b0QTRC0048SYL6B9<
6CYf6CYf0S94MP0EG5a<C7InE6ef/K6?Uhn7C5A]`KVGm>cKIFDjm>?:o?cd
ID`I^KVYk>?:/K6id/ZYooooShmUOWIUG5a<IE@b00;dm>`03HmfE6e]E8n7
KOC/fn?B/NcK/HmnKOclm?Cdk?C/fhmfIOooooclm002oooo017lo?B?MVGo
ooodm?BOQfgooooBb/5nG4coooodk=_dm>clo?CSd/5UE3;ooooSk?C1/Hl0
0_ooo`04m?CdooooWiN7k>cS0_Cdm00:m?C/ooooShM]ooooo?cdOVe<oooo
m?Cdm?C/o?cd0_Cdm0;lo?@04OCdm?clm?Cdm?clm?Cdk?clm?Cdm?oookVG
KHmfE8n?IFEL:/ZaZOooooCdk?clm?Cdm003o?cd00_dm?Clo?Cdm?Clo?Cd
m?Clo?Cdm>cdm?CoooniUffOUhL01?C/f`03m?C/o?cdc<c<07K<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c00VC6fGG7jGE7JGE7JGQina
IHNYQiNYIHNYQinaUkW:fim]KFDRm?C/k>cS00004A4A00008R8A:Q48ZJV?
WiN7`K6O`K6?`KVGb/6OUgiDm?C/m?Cdm?C/m>cKm?C/m?Cdm?C/hm;1/KVG
/K6?hm;1d/[10^cK`@03hm_Kk>cSm?C/00?dm?@00oCdk?Cdm?Cdm002m?C/
01?lo?BiUfgSdYodk=_/fk7K`Io:`IniUe@jA1TA4A4Z8QTR8Q4Z8QTA4A7B
bZW1^IO1^HOdm>cSd[400^?B`@;/hlX03YMnE=;:ZL[1ZL6iWl[1Wl6aWocl
m?Cdk?clm<6iUncSbWInG7i]C6EU>P9<C4@02bXR6D@j8VEL:U`j8T@j8U`j
8TA4:VEL6NcK/OCdk>cSbP02k>cS00OSfm_/k>?dm?BOSffi/IniWgk1^HL0
0Yn?K@07Sfe<SgHjSgI4C288>T@IC4@R<RXR008R8Q401RXR6B8R4B8R4ATI
4BXA2000008A4A401QTI4@0001TI4@0001TI4A4A4@8Z8QT00b8R4BXR6BXR
6@026ATI01<Z8QTI6ATZ8QTI6A4Z8QTI8R9<8PQ]IB;dk=_/k>?dm>c/k>?o
ooodhl[KWffiWgjOSfe]IB8R8Q400Q4A4@096ATI<RXRA3XRC4@RA3XZC4a4
E6efC7InE6ef009<MWh01eA]MSYLMUA]MTaDKEA]MSYDG3YUQ`02>UAL00@R
C5@R8Q4Z4@PZ4@P24A4A00<I6A4A4A4Z4@P00Q4A4@8I6AT00a4A4ATI4@00
00034A4A00<I6ATA4A4I8R8011TR:P036B8b6B8Z4A4A008I8RX01QTR8QTR
<QTR:QTR:QTR<Q4A4@8I8S806QTR:Q4A4D@Z8RXR6ATR<QTRC28bA5aLC7i]
IHmfIKVOO];:ZEA]M];:ZOclm<6iUfe]E?ooom;:ZFED<[ViZOooofEL:^?B
/Oclm7InG09]KE@04GiUE9nOO_clm;VOOYN?MYnOSoCSb_Cdk>c/hooooncS
bWiLC?ooooCdm?ooooCSb/[1Z@02o?cd00koooodm?Ba^INOWhmnOVg/hlZ?
MVGoooodm>coooodm?CdhlY]IB;oool3m?Cd01o/k>=UC1WooooSd[7/k>?l
o?CSfm_BbZWoooo1/IoSd/7oooodm>cdm?CooonaQfGoooodm?Cdhl[dm?Cd
m>cdm?Clo?Cdm?Clo?Cdm?Cdm>clo?Cdm?Clo?Cdm>`00oCdm007oooo^Imn
b/6Ob/6Y`KVGhm:aoooo00;dm?@01Oclm?Cdm?Cdm?Cdm?clm002m?Cd00cl
o?Cdm?Cdm>cdm>clo?Coooo:^HnGSgK/fk7dk=_lo?Cdk=/2o?cdMlc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00m<KHM]OXmDMYMDMYMf
Uk67UjUfUk5UQjVOZJVG^LYU<PQ44@3/k>?dm>anIE@00YN?MP05WhM]OVeU
Uhmfhm_Kk=_100;Sd/404Nc/hgifIN?B/N?B/L[1Wm_1Wl[1WlZiSm;:ZKVi
ZDa<>VE<6M;:`NcK/N?B/NcK/OCdm006m?C/00W/k>?dm>cdm>cdm?CooonO
Wgk1^HOKbYoSd/400/6iQ`03IE`Z8R8A8R8A00<Z8QT032XA29MnE9nOOXm]
C<6iUm^aZM;:`N?B`L[1WoCSbYN?M^cSbP;1^Il02[ViZKVaWoCdk?Cdk?Cd
m<[1ZN?B/HMnE7i]C6EU>P9UE38033Xj8T@j:XM<A6EL:U`j8WiLC6eU8R8R
4L6iQoooooCSb_Cdm0;dm>`02Oclm?Cdm<6iQin?KHn7KHn?IHmf>VEU>VE<
6@02C4@R0c8Z8P038R8A:Q488R8A008R8Q400bXA21TI4BXA20024A4A00<0
000I6A4I6A400Q4A4@0500008R8A>T@I:R8I<RXR008Z8QT02aTI6B8R4BXA
21TI6BXR6D@j:RXR6D`R2>?B/M^aWoC/f`02k>cS00K/o?C/hlXA4A7:`IoS
d[6OSfd200000Q4A4@03:R8I<RXRIE`Z0094>RX01eaLC4afOUa]MUafOUA]
MUAnOUafOP02E6ef00LjG7HjE5`jE5`jA4`jA38j>S94>R800Q4A4@046ATA
4A4A:Q486ATI0aTI4@@A4A426B8Z00DI8S8I8RXI8RXI8RXA4A400QTR<P8I
8RX00a4A4ATR<QTR<P026B8Z11TR<P0;6B8Z6B8b6B8b6B8bC288IE@b0000
UgiD^Imnfk6Ohm:a00;dhlX05?Cdk?clm?clm?clm7i]C:VYSm;:`GinKGi]
C?clm>cSbVe]E9nOO_ooogiUE;ViZOCdk<6aShmnKGiUE0;lo?@01_Cdm?Cd
k?oook6aSoooon?/m0?dm>`09HmfE?oool6iUjVYSiN?MWifIOooojVYSoCd
k>?B`Fe]E6efMWinKM;:`IMnE?ooooCdm<[1ZOooooCdk6E<6OooooCdm?Cd
k?Cdm?clm6E<6OooooCdk<6a^OoooncK`OCdk?oooncK`N?B`Oclm002m?Cd
0_clm00:m?Cdo?cdm?Cdo?cdm?Cdo?cdm?C/o?cdm?Cdm?C/0_clm003m?C/
o?cdm?Cd00;lo?@02?Cdk?oool6iUl[1Wm:aSlZiSm^aWoclm0;dm?@01?cl
m?Cdm?clm?clm0;dm?@00oclm?Cdm?Cdk002o?cd00Kdm>clo?CK`In?Qfgd
hl[lo?@2m>cK0_clm7O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
<lc<c005C6f7G7jGE7JGKGj?Qina00:7UjT01hNO/Hna`Gj?S`0002XA2?Cd
k>c/h`04o?cd00Bab/XjA1WK/Iodm?@2m?C/00Gdm?Cdm>cSd[7Sfm_/hlX0
0^?Kf`07m>cKk>cSm?C/o?cdG5a<>T@Ioooo00?dm>`2m?Cd0_Cdk0;dm?@0
3?clm?Cdm?Cdm?Cdk?oookViUl6iQlZiShmf>Xn?IKVGE6EL:P8I6A40428R
4BXR6B8R4@000=;:ZM^aZLZaZL6aWncSb]_1Wn?B`M_1Wn?B/ImnC>?Kfk6i
U`;1^Il01[VOO^cK/NcK`OCSb]^aWn?B`@9fOU`04FEU>UaLC4a<>T@j:TA4
:VEU>YMnE6EU>S8Z8TA4:R8R4L6iQncSb^?B`M_:Wl6iWl6iU`02`KV700JG
OUAUG1V7IC9L>R9UG2Y<A282<RXR00<R8Q4Z4@PI6A400QTI4@044A4A:Q48
6ATA4A4A0QTI6@074A4A6ATA00004A4A6ATA:R8I6ATA008Z8QT00d@Z8S8Z
8SY4<P02:R8I0b8R4@096ATI8R8A6ATI:R8I<RXRIC88o?cdhm;1m?Cd00?/
k><04?C/fhmfA<6iQn?B/M;:ZHn?IHMU<VEL:Q4A4C8Z8R8R4DA4:T@Z8S8Z
8Ta<>TA4C08jE5`00dA4C29<E4A4C002G5a<00Q]MWInOVfGSgJGSgJ?UhnO
Whni^ILA4A45<RXR00<Z8QTI8RXA4A4011TR:P036B8b6B8Z6B8R008I8RX0
11TR<QTR:QTR:QTR:P<I8S804ATR:QTR<QTR:QTR8S8Z8T@Z8XMD:XmLC;VO
O/6iQm^aWncK`OC/fooood`R2<c<c?clm002m?C/01;dk=_/k>?dk=_dk=_/
k>?lo?B?QfenMVEnMUB?MVGSd[7dm?C/k>?K/InGSgKlo?CBb/5]IB82oooo
01Ri^IOdm>cdm?C/k>?Sd/7dm?Clo?BOQfgoooo/k>?dm>coooniWgi]KECo
ooo/fl7/hl[ooomnMVGoooo1/Hodm>bi^JUfOU`2KHMn00Vi^JVOQfgooooo
oomUC1Woooolo?AUE3;oool00oCdk008o?cdWgi<o?cdo?cdk>?:k>cSoooo
o?cd0_Cdm008o?cdm?Cdo?cdo?cdm?Cdo?cdm?Cdo?cd0_Cdm007o?cdm?C/
m?Cdo?cdm?C/o?cdm?C/00;dm?@2m?C/0oCdm007oooofl6O`K6?b/6O`KVG
b/6Ooooo00;lo?@00oCdm?clm?Cdm003o?cd00gdm?Clo?Clo?Cdm?Clo?Cd
m?Clo?C/fk6a/Holo?Cdk=_lo?Cdk=/00_clm7O<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h<lc<c005E7JGIHNYKGj?IHNYQiNY00>7Wk4018na
`B8R4HmLC9N?MP;dm>`2k>cS00_dm?CBbZWBbZV?MVFOSfgdk=_Sfm_/k>?/
hl[/k>?dk=/00_Cdk003k>cSm?C/k>cS00;dm>`01OCdm>?Kfda<A9MnE?C/
f`02m?C/1?Cdm003o?cdm?Cdm?Cd00?dm?@01ooool6iUoCSb^cK/NcK`M;:
ZM_1W`02^Imn00`Z4@Pb:R8Z8QTb:R8I6A6iWgk1^HNi^INiWgklo?Cdk=_d
m>`2m?Cd01[/hl[dk=^i^Hni/Io1^InOWgkdhl[/k>?dk=_Bb/7/fl6?SfEf
OUaUICYLG4a<C3Y<A294>RXj>R8b:R8R8Q6?SfEUE38jA1V7OUAnMU@2IFDj
01=]IB9<A294>R8j>R8jA1U4>R9]KEAfOUanMVF?SfF?MUAnKDb?KDbOQff?
QeB7OUB7C4AnKDaUICX00VED<P04G3XRA2XR<RXR6ATA0Q4A4@098R8A:R8I
:R8I:R8I6ATAA2XR>SXR<RXR:R8I00<R8Q402ATI4B8R4BXA228R4C8Z8R8R
4KVOO_clm>cSbP03k>cS00Gdm>c/k>?lo?C/fk7BbZT00/[1W`03^K6OOVe<
0000008b:R803FEU>VEL:Ta<>Ta<>Ta<A5A]MUa]MUafOVefMWj?SinOShnG
Sk6iU`03^KVY0/[1Z@08k>?:>T@IA3XZA3XZA4@b>SXbC4@R>SXb11TR:PLI
8S803ATR:Q4A4ATR<R8Z:S8Z8U`j8XMD:[67IKVOO]^aWm;:ZOCSb_C/f`02
o?cd1?Cdk005m>cKooooID`I^Imno?cd00;/k><01?Cdk>c/hoCdk?Cdk0;d
m?@00ncSb^cK`OCdk002o?cd00kdm>cSk?Clo?C1/Iooooodm?B?MUCooool
o?BOQfglo?CSk?CooonGOU@2oooo01b?SfGoooodm>cdm>clo?BOWginKFGl
o?C/k>?<c<cBb/5LG4cdm>clo?CooonOWgifOUa]Qgi]MWJYZHni^IOlo?Cd
m?Cdhl[dm?Clo?BiUeCdm>`2m?Cd00Glo?Cdm?Clo?Clo?Cdm?@00_clm0;d
m?@02Oclm?Cdm?Cdm?clm?Cdm?clm?Cdm?clm?Cdm002o?cd00Cdm?Cdm>cd
m?Clo?@2m?C/1?C/f`03m>?:m>cKo?cd00;dm?@02OoooncK`L6iQm;:ZL6i
Ul6iQoclm?Cdk?Cdm002o?cd00?dm?Clo?Cdm?@00_clm009m?C/o?cdm?Cd
o?cdm?C/o?cdm>cKWhm]o?cd00;dk=/00oclm?C/foclm01gc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^3?<c<`01UAfUfenSeanUhNGZGJG/HNG
Z@:7Wk400k6a^NcK/NcSbP02hm_K00S/k>?Sk?Cdm>cdm?C1^IOdk=^YZHna
QfD2m?C/00?dm?C/hl[dm?@00^c/h`06m>cKm?C/m?C/m>cKm?C/k>cS0_Cd
k004/K6id/[1Sfe<m>cK0_Cdm006o?cdm?Cdm?Cdm?C/m?Cdm?C/0oCdm00@
o?cdd/[1hm:ahm:ak=_1hm:ahm:Ok=^aWgi<KFDR>SXR<RXR>SXR8R8A/HMU
b[6Y0/6iU`0Qo?cdhm_Km?C/k>cSm?C/hm_Kk>cS`KVGhm:a^KVY`KV7hm_K
k=_1hm:ad/[1k>?:UhmfIFDjKFeDIE@bC4`jA4@bA3XRA3XZA2XR8R8AOUa<
ShM]MWiL<RXR:Q48<RXR:Q48008R8Q4022XR6@0009mnC9mnC6EU>SY46B8R
4@0000<A4A42000000HZ4@PI6ATR<RXI6A4j>R94>R83IFDj00AUE3800000
000I6AT3:R8I00@Z4@Pb:R94>RXZ8QT28R8A0aTI4@098R8A6ATA6ATI6ATI
IC88b[6Ym?C/m>?:k>cS00;dm>`01>c/hoCdk?oooncK/@;Sd[4039nGQhmf
>P0001TI4D@j8WInG4a48UaLC6EU>Ve]E7i]IFenS`:?Uhl01ZVYSk6iWkVi
ZL[1ZN?B/M;:Z@?Sd/402NcSb_C/ffEL6Da<A5aLC4a<A4A4<SXj<TA4:P02
6B8b00lI8T`I8S8A4A4I8S8A4A4b:R9L>R8Z8QViOUBGSgKB/HoSd[7/fk7d
hl[dm>`00oclm0;dm>`00nc/hoC/fnc/h`02k>cS00Sdm>c/k>?dm>c/k>?o
oon?QeBOWgklo?@8m?C/0oCdm0Cdm>`03?Cdm9N?M_ooon?B/KVOO_ooooCd
m;VOO_clm>c/hooooin7K@;oool03In7KOooooCdk?Cdk?oooiN?MVe]E?cl
m=;:ZFED<UaLC6EL:[ViZ@02oooo00afOUa]MWInOVe]Qgj?QfgSd[7/k>?d
m>clo?Cdm>cdm?Coool2m?C/00Clo?Cdm?Cdm?Clo?@2m?Cd00Klo?Cdm?Cl
o?Clo?Cdm?Clo?@2m?Cd00Clo?Cdm?Clo?Cdm?@2o?cd00?dm?Clo?Cdm>`0
0_C/f`?dm>`3oooo00_dm>cdk=_dm?Cdm?Cdm>clo?Cdk=^GSgK:`Io1^Io1
^HL00oclm004m?Cdo?cdm?Cdm?C/0_clm003m?Cdo?cdm?Cd00;lo?@01_Cd
m?clm?Cdk;VOO_C/foclm0;dk=/2o?cdMlc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Pcc<c<00ADMYMUQjV7OXn7UjT2Qina00J7UjVOZJWSd/7d
m>c/hl[dm?@2k>cS00Gdm>c/k>?dm?Bi^JVY`LX00[WBf`08m>cKm?C/m?C/
k>cSm?Cdk>?:m?C/m?Cd0_Cdk003m?Cdm?C/m?Cd00?oool2o?cd00?K`Iod
m?Clo?@00_Cdm004o?cdm?Cdm?Cdm?C/0oCdm003k?cdhm;1hm:a00;/fk40
0m_:Wn?BWn?B/@02>T@I02@R<RXZ8QU<A294>RZ?MUBi^Hni/Ini^IOB/Ho/
hl[dm?C/k>?dm?Cdm>cdhlYUICY]KEAnMVEnIEBi^INa^INi^JW:`Iodhl[:
`JUUICY]KEA<C3Y<C4A4A394>R94A394>R8j>R8b:R8R8Q45<RXR00U4>RY4
:R8jA1Tb:R:OSffi^INOUhMUICY4A2X00cXj8P07A2XR>T@I<RXR<RXR:R8I
4A4A:Q4800<A4A42000000PI6A4Z4@PA4A4R8Q4R:RXI6A4I6ATI6A42<RXR
00LZ8QTI6A4I6A4A4A4Z4@PA4A4I6A400b8R4@0PIFDjhm:am?C/hm_Km?C/
k>cSm>cKk>?:m>cKIE`ZSfe<m>cKk=^aQfDb0000:R8I>SXRC4@RZJV?IE`Z
C4`jA4@ZMWiLOVED/KVY`K6i^KVYd/ZYd/[1k=_1hm;1m>?:0^cSbP07hm:a
d/ZYd/ZYb/6OShMDIE`ZQfDb00:?MSX2QfDb00]UC1UUG2Z?MTBaQfFiWgkK
/Io/fk7dk=_lo?B?Qfgoool01?Cdk0C/k><00oCdk>c/hoCdm002m?C/00?d
m?Cdm>cdm>`00_Cdk007m?Cdm?C/ooooWimnSgIDo?cdm?Cd00?dm>`00oCd
m?Cdk?Cdm002m?Cd1?Cdk00>m?Cdm?C/ooooWhM]oooom?Cdoooom?Cdo?cd
`KVGk>cSm?CdooooUhmf0_ooo`07WhM]oooom?Cdm?Cdo?cdWimnKFeD00;/
k><03>cK`OCdk>c/heaLC<[Kfoclm5aLC7inKEa]MVf7OWinKOooo`;dm?@0
1OCdk?Cdm?Cdk?Cdm?clm003m?Cd00Clo?Cdm?Cdm?Clo?@2m?Cd00_lo?Cd
m?Cdm?Clo?Cdm?Clo?Cdm?Clo?Cdm?Clo?Cdm?@00_clm003m?Cdo?cdoooo
00?oool03oclm>cSb/[1ZOCSb_clm>cSb_ooooCdm?clm?Cdk?clm;VGKKVO
O[67IIn?K@02o?cd00?dm>cdm?Clo?@00oclm00@m?Cdo?cdm?C/m?Cdo?cd
m?Cdo?cdm?Cdm?C/^Imnk>?:m?C/m>cKo?cdm>cKo?cdMlc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Pcc<c<00=LOYN7UjV7UjT00hNGZ@06Qina
/K6i^KVGd/ZYfl6Om?C/1>c/h`0=m?C/b/6Y^M_doooob]_Khm_Km?Cdk>cS
m?C/m?Cdm>cKk>cSm?Cd00Cdm>`01?C/foCBO_CBO_CBOP;dm>`00nc/hoCd
k?Cdm004m?Cd017/hl[dhl[dm?Cdm?Cdm>coooo/hl[SdYoSd[7SdYoKbYoS
dYoK`Io1^HNOQfeUC1TA4A400R8R4@06QfDbd/[1hm;1WiN7^KVGfk6O0^cS
bP03hm_Ko?cd^K6O008jA1T046E<6L6iUl[1Wl6iQkVOOXn?IDa48^?KfiN?
Qda<>VED<UaLC4A4<T@Z8T@j:T@Z8P8j>R805C8Z8SXj8T@Z8S8Z8SY46D@Z
8T@j8TA4<SXj8T@j:U`j8YnGQiN?MVEU>TA4:U`j8T@j:VEL:TA4:T@j:TA4
:P02A3XZ00=4:R8Z8QTZ8QT00R8R4@08:R8I8R8A8R8A:R8I8R8A6B8R:R8I
<RXR0R8R4@06<RXR:R8I:Q486ATA:Q486ATA0b8R4@086ATI:R8I6ATIID`I
hm:am?C/m>cKk>cS0^cSbP0Bm>cKo?cdSfe<Wgi<o?cdhm:a>T@IIC88A3XR
<RXRIE`Zhm:aKFDRA3XRA4A<IE@bKFeDk=_11=;:Z@07b/6Ofl6O`KVGhm:O
fl6Ohm:Ohm;100;/hlX00oCSb_Cdk?clm004o?cd00?dm>clo?Clo?@00_cl
m00;m?Cdm?C/m?C/o?cdShM]o?cdk>cSm?C/k>cSm?C/k?cd00Kdm>`01_Cd
m?Cdk?Cdk?Cdm?Cdk?Cdm0;dm>`01OCdm?clm<[1ZHMU<_clm002m?Cd00?d
m>cdm?Cdm>`00_Cdm003m?C/m?Cdm?Cd00;dm?@02?Cdk?Cdm>clm?oook67
IOooooCdm<[1W`;dm?@02M;:`NcSb_Cdm?oookViSoCdm?oooinOO_clm002
m?C/00Slo?CSfm]]KEBab/[dm>cSfm^ab/ZOWhl3IFDj00ELKGInMVEnMVE]
QginOVd00_clm003m?Cdo?cdm?Cd00;lo?@01?Cdk?clm?clm?Cdk0Clo?@0
1?Cdm?clm?clm?Cdm0Clo?@01?Cdm?clm?Cdm?clm0?dm?@3o?cd00BGSgJO
WgkooooSdYl2>T@I00>i/Iooooo/fk400oCdm006o?cdm?Cdooooooooo?cd
m?C/0_Cdm0?lo?@01OCdm?clm?Cdm?clm?Cdm002o?cd00?dm?Clo?Cdm?@0
0_clm007^Imnk>?:o?cdo?cdm>cKo?cdm>cK07O<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h<lc<c003KGj?IHNYQiNY00B7Wk401HNGZD@A06E<
6KVGKOCdk002k>cS00odm?C/k>?dm?C:`JVY`LZid]^a/KWdhl[KbYolo?C1
^IOdm>c/fl7dm>cdm?@01?Cdk005m>?:k<67hm:Om?Cdk>cS00?dm>`2m?Cd
00Cdm>cdm?Cdm>c/k><5m?Cd00GSfm_SdYoSdYoSd[6OSfd00/[1W`0Dk=_1
m?C/d/[1KFeDIFDj>SXRG3XR`K6Oc<c<d/ZYhm;1k>cSm?C/k=^am?C/`KVG
hm:aC4@RC288>T@I0RXA208b:R801CY46C8Z8Xmf>Xn7KEaLC002C4a400M4
A2Y4>RY4>RY4>R94:R94A2Y4:R800cXj8P0<A2XR<RXRA3XZA3XRA3XZ>T@I
G5a<IFDjUhmfIFDjA4@ZA3XZ0TA4:P06A4@bIE`ZA4@ZC4`jA3XZA3XR0S8Z
8P8Z8QT00b8Z:RXR6C8Z8P03:R8I00DR8Q4R:RXZ8QTI6ATZ4@P00R8R4@8I
6A400aTI6BXR6B8R4@028R8A00DZ8QTb:R8A4A6iWgklo?@00_Cdm007k?cd
hm_Khm;1d/[1d/ZY`KV7`K6?008jA1T04<6aSinGQhmf>T@j8XMU<VED<XMU
<VE<6E`j8VeU8/6aWl[1Wm_1Wn?BWn?B`NcSbP;dk=/01^c/hnclm?Cdk>c/
hoC/foCdk0Kdk=/2k>cS00Cdm>c/k>?dm>c/k><3m?C/00Clo?B?Qfglo?C/
o?@7m?C/00Odm?Cdm>cdm?Cdm>cdm?Cdm>cdm?@00_Cdk007m?Cdm?C/m?Cd
o?cdhm;1IC88o?cd00;dm?@01?clm?Cdm?Cdm?Cdk0Cdm?@05?clm?Cdm?Cd
k?Cdm>clm?oooinOO_ooooclm;VOO^?Kfoooon?B`M;:`OCdm?clm<6iUn?K
foooom;:Z@?dm>`03OoooinOSgifIFe]E6EU>VEL:VE<6Da48Ve]E6EU>Ve]
E7InG6e]E002KGIf00EnMVGlo?Cdm?Cdm?Cdm>`00_Cdm0Gdm>`00oC/foCS
b_Cdk002o?cd00Kdm?Clo?Clo?Cdm?Clo?Cdm?@2o?cd00?dm?Clo?Cdm?@0
0_clm00@m?Cdo?cdo?cdb/6Y0000KFDRoooom>?:4A4AIFDjZJV?ooook=^a
m?C/o?cdm?Cd0_clm004m?Cdo?cdm?Cdm?Cd0_clm004m?Cdo?cdo?cdm?Cd
0oclm005m?Cdo?cdo?cdo?cdm?Cd00?lo?@01l[1Wn?B`OC/foC/foclm?C/
foclm01gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`00fen
SfF7ZHNO/@03Qina00F?/L5]MWI]KEAUC1W/fk401Nc/h`0=m?Cdk>?:hm_K
m>cKhm;1m?C/d/[1m?C/d/ZYhm_Kk=_1m?C/m?Cd00Cdm>`01?Cdm>cSb];:
ZOooo`Cdm>`4m?Cd00Coooo/`HO/fl7dm>`3m?Cd02?dm>c1^HO1^HO/fk5f
OUb?MRZaQfGSdYo/k>?dhlYnOVf?UhmUICYLG4cBbZW/hl[K`Io/hl[Sd/7d
m?C1^IOlo?Cdm?Cdk=_Bb/7Sd[7Sd/6iWgjGSgIUC1Tb:R8Z4@PjA1TZ4@Q4
>R800Ta<>P09IE`ZA4@ZA3XRA2XRA3XR>SXRA2XR>T@IA3XR008j>R802SY4
6D@Z8T@j8T@j8Ta48SXj8VED<YnGQgifE6e]E0=4A2X014A4<U`j8TA4:Ta<
>P94A2X014A4<SY46C8Z8SY46@@b:R8012XR6B8R4ATI6A4A4@8I6A403CY4
6DA4<T@Z8T@j8T@j:T@Z8T@j:SXj8S8Z8SXj8S8Z8T@Z8T`R2002A14001V?
MSZaQfFiUeBiUfg/ZGJiWgk:`IoSd[7Sd/7dk=_/fl6?SfGBb/7Sd/6iWgj?
MUC:`JVa^INa/Ho1^INGOUB?SfGBbZWdm>c/k><00_Cdk003m>cKk>cSm?C/
00?dk=/2m?C/00?dk=_dm>c/k><00oCdk005m?Cdm?C/m?C/m?C/m?Cd00Gd
m>`00oclm9nOO_Cdk002m?C/00?dm?Cdm>cdm?@01?Cdk009o?cdm?C/m?Cd
m?C/m?Cdm?C/m?Cdo?cdm?C/00?dm?@01OC/fd@A0?Cdk?Cdm?clm002m?Cd
00?dm>cdm?Clo?@00_Cdm00Bo?cdm?C/m?Cdo?cdm?C/k?cdoooo^Imno?cd
m?C/k>cSm?Cdm?C/k>cSk=_1o?cdm?C/o?cd0_Cdk009o?cdm?Cdm?Cdm?Cd
ooooShmUOWIUKFeDKFDR00=]KE@02fEU>Ve]E6e]E7InG5a]MWInG6f7OWIn
G?C/foclm?Cdk002m>cK00G/hl[dk=_dk=_/k>?dm>`00_Cdm003m>cKm?C/
o?cd00;dm?@01_clm?Cdm?clm?Cdm?clm?Cdm0?lo?@00oCdm?clm?Cdm002
m?Cd00Clo?B?MRXA4A5UC1T2o?cd0SY46@04Uhmfooook=^am?C/0_Cdm009
o?cdm?Cdo?cdo?cdm?Cdo?cdm?Cdo?cdm?C/00?lo?@01?Cdm?clm?Cdm?cl
m0?dm?@01?clm?Cdm?Cdm?clm0;Sd[400oclm?C/foC/f`02o?cdMlc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<029UQjV7UjV7Wk67UjV7
Wk67UjUnWkULG4ba/KW1^Ini/Iodm>c/k>?dm>c/k>?dm>c/k>?/hl[dm>cd
m?Cdm>c/k>?dm?C/k>?dm?Cdm>c/k>?dm>c/hl[dm>c/fk7dm>c/fk7/k><2
m>cK00Gdm?Cdm>cdm>cSdYolo?@00_Cdm003o?cdm?Cdm?Cd00?dm?@05?cl
m?Cdm?Cdm?Cdm<ZiSm_:Wl[1WfEU>SY46D@j8]_:WncK/Nc/hk6iUgInG6e]
E7i]IM;:ZNcSb];:`@;Sd/401NcSb]^OKOooon?/m?CSbP02oooo00cdm?Co
ooooooodm>c/hlZGSgIUICYUG2Y4:R9<8PPjA1Tb:R82A2XR00E<A28b:R94
:R94:R8jA1T00T@Z8P0HA3XR>SXRA3XR<RXRA2XR8R8A:R8IG3XRShmUID`I
SgHZC4@R>SXRA3XRC4@RIE`ZA4@bIE@bA3XZA4@ZA4@b>SXR<RXRA4@Z0S8Z
8P05C288>SXR:R8I<RXR6B8R008A4A400aTR8Q4A4ATR8P02:R8I0S8Z8P0=
A2XRA3XZC4`jA4@ZA3XRA4@Zhm:ad/ZY`K6?o?cdm?C/o?cdoooo00;dm?@0
0oclm?ooooCdm002m?Cd013dhl[Sd[7:^Ho1^IOdk=_1^IO1^HNi^Ho:/JUU
ICZOWho1^HOlo?C/k>?dk=_/k><3m?C/00?/k>?dm>cdm>`00oCdk005m?Cd
m?C/m?C/m?C/m?Cd00Cdm>`2m?Cd00Odm>cdm?Cdm?Cdm>cooona^IOdk=/0
0_Cdm005m?C/m?Cdm?Cdm?Cdm?C/00Kdm?@03?clm?Cdm?Cdm?Cdk?Cdm?cl
m?Cdk?Cdm?clm38Z8^cK`Oooo`[dm?@01_clm?Cdm?clm>clm?clm>cK/@;d
m?@01?Cdk?clm?Cdm?clm0?dm?@01?clm?Cdk?Cdm?clm0?dm?@01Oclm9nO
OWInG7ifE6e]E003IFDj0fe]E00:OWIUOWi]KHMnKHMnOWi]k>?:oooom>cK
o?cdm?Cd0_ooo`05m?Cdoooooooom?Cdoooo00;dm>`:o?cd00?dm?Clo?Cd
m?@01?clm00=oooo^IM]4A4A>T@Ik>?:ooooA3XR4A4ASgHjooook=_1m>cK
oooo00?dm?@2o?cd00Cdm?Clo?Clo?Cdm?@2o?cd00?dm?Clo?Clo?@02Ocl
m003m?Cdk=_1b/6Y00Clo?@00oC/flc<c<c<c01ec<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^3?<c<`036F7ZHNGZHNO/GJG/HNGZHNO/DafOUan
UhmfIL[1ZKVOO_CSbPC/k><01?Cdk>?Kfnc/hnc/h`Kdm>`00nc/hoC/foCd
k00<m?C/0oCdm003o?cdm?Cdm?Cd00Gdm?@06Nclm=_:Wm;:ZN?BWl6iWda4
8SY46InOOXn7KL6aWnc/hfe]E7InG6efM]_1Wm;:`NcSb^?B`L[1Wn?B`NcK
/OCdm?Cdk>cSb^c/h`02m?C/00oSk?Cdm>cdm>coooo/hlYLKGJ?UhniWgjG
SgI4A394:R8R8Q4A4A4I6A4R8Q400S8Z8P05A2XR>SXR>T@IA2XR>T@I0094
:R801S8Z8SY46BXR6D`R2;67IK6aS`9UC1T02bXA24@Z8R8R4C8Z8T@j8T@Z
8Ta48TA4:T@j8Ta48SXj8P02<RXR00LjA1Tb:R94:R8b:R8R:RXA4A4I8S80
0a4A4@076ATI:Q4800004A4A:Q488R8A:R8I008R8Q401c8Z8QTI6FEL:/6i
Ul6iQoooooCdk002k>cS00?dm>c/k>?dm>`00^cSbP04k>cSm>cKk>?:d/ZY
0/[1W`0:hm:a`KVGZJV?`K6?^KV?ZJV?UhmfWhM]o?cdk>cS2_Cdk003m?Cd
m?C/m?Cd00Cdm>`3m?Cd0oCdk008m?Cdm?C/m?Cdo?cd^K6Ok>?:m?Cdm?C/
1?Cdm006o?cdm?C/m?Cdo?cdm?Cdo?cd0oCdm003o?cdm?Cdm?Cd00;dm?@0
1OCdk?ooobXA2>?B/Oclm003m?Cd00Wlo?Cdm?Cdm?Clo?Cdm?Clo?Cdm>cd
m?Clo?@01OCdm003o?cdm?Cdm?Cd00;dm?@01Oclm?Cdm?clm?Cdm?clm003
m?Cd00Kdm>cdm?Coooo1/HmnOVefOU`2IFDj0Ve]E003IFDjKFeDMWiL009]
KE@2KHMn00AnMVGBb/7oooodm?@2m?C/01;dk=_dm>cdk=_dk=_/fk7SdYod
m>c/k>?dk=_dm?Clo?Cdm?Clo?Cdm?Clo?Cdm?Clo?Cdm?@2o?cd00?dm?Cl
o?Clo?@00oCdm00=o?cdfk6O4A4AC288d/[1ooooUhL06ATIKFDRooook=^a
k>?:oooo00Clo?@01?Cdm?clm?clm?Cdm0Clo?@01?Cdm?clm?clm?clm0;d
m?@02Oclm?Cdm?Cdm?clm?Cdm?clm?C/fk6aSoclm003m>cK00?lo?C<c<c<
c<`0MLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<01=UQjUf
Uk67UjV7UjUfUk5nWkU<C4@b:R9<8PQUC1U44@3K/JWdm?C/k>?dm>c/k>?d
m>c/k>?dk=/01>c/h`05m?C/k>cSm?C/m?C/m>cK00gdm>`01oclm?Cdm?Cd
m?Cdm?clm?Cdm?clm004m?Cd00Soooo:^HoKbYoKbYoSdYn7OU@jA1UL>R82
IFDj00_ooomLG4a]QgjGSgKBb/7K`Ini^HoSd/71/Io/hl[K/Il00_Cdm00a
k>?:m?C/m?Cdm?Cdm?C/m?Cdk>cSoooo^KVYKHMn>UALIFDjKGIfE7inC6f7
>UAL>TA<<RXR:R8I4A4A:Q484A4A:Q48<RXR:Q48<RXRA2XR<RXRA2XR<RXR
A2XR<RXRUgiDC4@R6ATAG3XR8R8A<RXR>T@IA2XR<RXR>T@I<RXRA2XR:R8I
>SXRA2XR>SXRA3XR00@b:R803bXR6A4A4A4A4A4A4B8bA1TR<TA4C4a<>QTR
<QTR:S8jA14A4B8Z:RXA21TI6@026ATA00HR8Q40002OQfg/fk7dm>c/k><2
m?C/00?dk=_dm>cdk=/00oCdk006m>cKd[6?b/6O`KVG^KVGb/6O0[6aS`05
`KVG/K6?^Imn`KV7o?cd00Cdm>`00oclm?Cdk?Cdk003m?C/00Cdm?Cdm>cd
m?Cdm>`2m?Cd00[lo?Cdm?Cdm>cdm?Cdm>clo?Cdm?Cdm>cdm?Clo?@2m?Cd
00?Bb/7Sd/7dm?@01?Cdm005m?C/m?Cdo?cdm?Cdm?C/00;dm?@03oclm?Cd
m?Cdm?Cdm?clm?Cdm?clm?Cdm?clm?oooc8Z8/6iUoooooCdm?clm002m?Cd
00?lo?Cdm?Cdm?@00_Cdm005o?cdm?Cdm?C/o?cdk?cd00;lo?@02?Cdk?Cd
m?clm?Cdm?clm?Cdk?clm?Cdk0?dm?@00oclm?Cdm?clm002m?Cd00CooooB
bZV?SfEnMVD3IFDj00MUE39LG4aUICYUG2XR<RXjA39<C3X00UaLC006Wimn
o?cdm>cKm>?:k=_1m>cK0_CSbP;dk=/2m?C/00Clo?Cdm?Clo?Cdm?@7o?cd
00Cdm?Clo?Clo?Cdm?@3o?cd00gdm?Coooo/fk40000jA1Vi/Ioooom]IB8A
4A5]IB;oooodk=_/fl400oCdm0;lo?@01OCdm?clm?clm?clm?Cdm003o?cd
00?dm?Clo?Clo?@00_clm006m?Cdo?cdo?cdo?cdm?Cdo?cd0_Cdk006`KV7
m>cKo?cdo?cdm>cKo?cdMlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Pcc<c<0XNGZ@05IHNYMYNaKHna>VF7C288008b:R801a4A4BXA2<ZiSooo
onc/hn?/m?Cdk002k>cS00CSfm_dm>c/k>?dk=/2k>cS0_Cdk003m>?:m>cK
k>cS00gdm>`;m?Cd00GBbZWKbYoSdYo:`Ini^Hl00R8R4@0@ShM]OWi]Uhmf
IFDjMWiLUhmffl6Od/[1b/6Ohm:aZJV?d/[1k=^am?Cdm>cKhm:a0oCdk005
k?cdm?C/m?C/o?cd^K6O009LKGH01YnOO[6iZEA]MTafOTa]QeA]MP9<MWh0
1EaLC3YDG4A4C3Xj<QTR8P026ATA00d00014:R8b:R94:R8jA1TZ8QV?SfEU
C1TI6A4R8Q4jA1TZ4@Pb:R800T@Z8P8jA1T2<RXR00A4:R8j>R8j>R8b:R82
A2XR00<b:R8Z8QTZ8QT00RXR6@0F6B8R>TA<C4`j8SYL6B9<6ATI>T@I>VFG
0000C5A]8S8Z<SY4:R8IG5a<6B8R<TAfG7Infk6Ym?C/k>cSm?C/k>cS0_Cd
k00:k>cSm?C/m?C/k>cSm?C/d[6?b/6O^ImnShmU`KV70YnOOP05/K6?Uhmf
`KV7ShMDo?cd00_dm>`00oCdm?Cdk?Cdm003m?C/00Kdm?Clo?Cdm>clo?Cd
m?Cdm>`3m?Cd00Odm>cdm?CSd/7Bb/7lo?Cdm?Cdm>`00oCdm004o?cdm?Cd
m?Cdo?cd0_Cdm003o?cdm?C/o?cd00?dm?@01oCdk?clm?Cdm?ooofDb29nO
O_ooo`02m?Cd00Klo?Cdm?Cdm?Clo?Cdm?Clo?@2m?Cd00Clo?Cdm?Cdm?C/
o?@2m?Cd00?lo?Cdm>clo?@00_Cdk0;dm?@2m?C/1OC/f`0;m?Cdo?cdo?cd
hm;1OWIDKFeD<RXR8R8AIFDj/K6?^Imn00:GSgH02XmfIHMnE8mfE7ifIGif
E8mfE?C/foCSb^cSb^c/h`;dm>`3m?Cd00?lo?Cdm?Cdm?@01?clm003m?Cd
o?cdm?Cd00;lo?@00oCdm?clm?clm002m?Cd01Clo?Cdm?Clo?Cdm?Cooood
hlXI6A4jA1VOSfgooon?IA4I6AU4>R;oooodk=_Sd[7oooodm?Clo?Cdm?@2
o?cd00?dm?Cdm>clo?@00_clm003m?C/o?cdo?cd00;lo?@01OCdm?clm?cl
m?Cdk?Cdm002o?cd00Kdm?Cdm>clo?BGSgKlo?Cdk=/3o?cdMlc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<0fF7Z@05Qina>VF7:Q48>T@I
:R8I0094:R800a4A4KVOO_clm002k>cS00Kdm>c/k>?/k>?/hl[dm>c/k><3
m?C/00K/k>?dm>cSfm_dk=_dm>c/k><2m?C/00?dk=_dm>cdm>`01oCdk003
o?cdm?Cdo?cd00Sdm?@02M;:ZK67IL[1Wl[1Wm;:ZCXj8SY46Fe]E7inK@02
OVeU00eLG4b?Qfg1/KWK`Io:`JWBb/6i^HmUIC[K`Iolo?CSfm_dk=_/k><0
0_Cdm0?dm>`01oclm9nYZEAnOUa]MVefM[ViZDaDK@02E6ef00=LMWiDKGID
KGH00TafOP03>UafE6efE6ef009<E6d073YDG4A4<S8Z8Ta48SXj<RXA28MU
<^?B/GiUE9mnC28R4C8Z8SY46D@j8SY46D@j:T@Z8S8Z8SY46C8Z8T@j8T@Z
8SY46BXR6C8Z8SXj8S8Z8SY46@<b:R804cY4<SYDG28jG4a<A1TRC4A4C3YU
U`0003YDG14A4ATR<SY4C28bA38jA4a]Udan/M^aZOCdk>c/h`03m?C/0_C/
f`0Am?C/m>cKm?C/k>cSflZOb/6O^Imn`KV7/K6?WimnWhm]/K6?WimnWiN7
Whm]m?C/k>cS00Odm>`00oclm?Cdk?clm003m?C/00Gdm?Clo?Cdm?Cdm?Cd
m>`00_Cdm0;dm>`02?clm?Cdm?clm?Cdm?clm?C/fl6aWoclm0?dm?@2o?cd
00Kdm>cdm?Cdm>clo?Cdm>clo?@3m?Cd00[dm>clo?Cdm?Clo?Cdm>cdm?Co
oomUG1VGOUCoool2o?cd00?dm?Clo?Clo?@00oCdm0;lo?@00oCdm?clm?cl
m002m?Cd0_clm003m?Cdm?C/m?C/00?dk=/3m?C/00Cdm?Clo?Cdm?CdhlX3
m?Cd00Odk=^?SfEUICY4>R:?MTAfOUc/fl400/c<c003^KVYd/[1/K6i00?B
b/401];:ZNc/hoclm?Cdm?clm?Cdm0;lo?@00oCdm?clm?Cdm003o?cd0_Cd
m0Slo?@01_Cdm?clm?clm?Cdm?clm?Cdm0?lo?@24A4A00V?MTCooonOOTaU
<PR?MR[lo?Cdm>c/fk7oool00_Cdm0;lo?@01oCdm?clm?clm?clm?Cdm?cl
m?Cdm002o?cd00Gdm?Clo?Clo?Clo?Cdm?@00_clm008m?Cdo?cdm?Cdo?cd
ooooWhm]m>cKo?cd0oC/fgO<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h<lc<c09UQjT017JG/EB7/D@A038Z8P94:R801BXR6D`R228R4Im]C?cl
m003k>cS00Cdm>c/k>?/hl[dm?@3m?C/00c/k>?dm>c/k>?/k>?/hl[dk=_d
m>cdhl[dm>cdk=_dm>cdk=/2m?C/00?dk=_dm>cdm>`00_Cdk0Gdm?@00ocl
m?ooooclm002m?Cd01SooooSd[7dk=_BbZUUC1W1^HMUG2XZ8QTb:R8jA1U4
A2Y]KEAfOUbOWhni^JWBbZUnMVF?Qfg:/JV?SfGK`Iolo?Cdm>cdk=/2m?C/
1?Cdm008o?cd/KVGKHMnG8N?OWi]b/6Y>UafG6ef0eA]MP03C7InKGIfE7in
00ADKGH2C7In00ljE5`jA1UL>R94A38R8Q5nKDcSd[6i/ImUC1TR<RXZ8QTb
:R:7E2Y<C3XjA1T00T@Z8P8Z8QT0138Z8T@j8S8Z8SY46@@b:R8062XR6C8Z
8S8Z8T@j:Ta<A3YDQaTRC1TI4@0005B7/Dan/ATR8UaLC38Z8SY4C4a<A3Xj
<Ta]UcYUUm^aWoCdk>c/hoCdk?C/f`Odm>`01n?B/M;:ZL6aSl6iUl6iQkVa
WinGQ`02^KVG00?1^INiWgkdm>`00oCdk0;dm?@00oCdk?clm?Cdm003m?Cd
00Clo?Cdm?Cdm?Clo?@4m?Cd00?lo?Cdm?Clo?@01_Cdm006m?C//KVGo?cd
m?Cdo?cdm?C/0_Cdm0;lo?@4m?Cd00glo?Cdm?Clo?Clo?Cdm?Clo?Cdm?Cl
o?Cdm?Cooon?QeAUC1Woool00_Cdm004o?cdm?Cdm?Cdm?Cd0_clm0;dm?@0
0oclm?Cdm?Cdm007m?Cd00Coooodm?Coooodm?@4oooo00Sdm?Cdk=_dm?Cd
m?Clo?C/k>>?SfE]KE@2C4`j00eUIC[/hlZ7Wk6a/KV?UhnOZJVGShM]OXo1
/KVOWhnGShO/k>?oool00_Cdm005o?cdm?Cdm?Cdo?cdm?Cd00;lo?@2m?Cd
00Goooolo?Clo?Clo?Cdm?@00_clm005m?Cdo?cdo?cdo?cdm?Cd00?lo?@2
m?Cd00clo?Cooon7:P2GOUBiWgkoooodhl[BbZW1^IO/k>?dm?C/fk42m?Cd
00Glo?Cdm?Clo?Clo?Cdm?@01Oclm005m?Cdo?cdo?cdo?cdm?Cd00Olo?@0
1OCdm?oookVGKOC/foclm002m>cK00?lo?C<c<c<c<`0MLc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Pcc<c<00=UQjU]Sk5UUk400S8Z8P0BC288
:R8I:R8IA2XR<RXRG3XRSea<ooook>cSm?Cdk>cSm?C/k?cdk>?:m?C/k>cS
m?C/k>cS0_Cdk004k>?:hm:ahm:am>?:0_Cdm004m?C/m?Cdm?C/m?Cd0_Cd
k005o?cdm?C/m?C/m?C/o?cd00?dm?@01OoooncSb]:aSl6iQoooo`02m?Cd
01G/o?CSd[7/fk7dk=_/hl[Sd[6?MT@jA1TI6A4I8R8R8Q4Z8QU4A39UE39n
MVF?Qfe<C3YnOVg1/IniWgkSd/400_Cdk0;/k><00oCdm?Cdk?Cdm002m?C/
00Slo?B?Uhm]QgiLMWi]MWK:/JU<KHMLMWh2E6ef00ADOWiDKGIDKGILMWh2
E6ef00ELKGILMWiDKGI<MWhjE5`00R8R4@0@C4`jA140ID`I^ImnWimnIC88
SfDA>T@I:Q48G5a<C4a4G5a<:R8I>SXR>T@I<RXR0cXj8P07A2XRA3XRA3XZ
A2XR:R8I6ATA:R8I008b:R804R8b:XMnShnGSginKEaLC6f?^GJG`B8bA1TR
8SYDG14A4C8jA4A4C3YDQc9UZL[1WoCdk>c/h`Sdm>`01OCdm=;:ZM_:Wl[1
Wk6aS`02^Imn00JOSffi^Hni^INi^HnGSgKdhlX2m?Cd0_Cdk005o?cdm?Cd
m?Cdm?C/o?cd00?dm?@3m?C/0_Cdm0?lo?@2m?Cd0_clm006m?Cdo?cdm?Cd
m?Cdo?cdWiN70_clm003m?Cdm?C/o?cd00?dm?@01Oclm?Cdm?clm?Cdm?cl
m003m?Cd00?lo?Cdm?Clo?@00_Cdm005ooooWimnID`Iooooo?cd00;dm?@2
o?cd00Gdm?Clo?Cdm?Clo?Cdm?@00_clm0;dm?@4o?cd0_ooo`0<o?cdm?Cd
o?cdo?cdhm:a^KV?/K6?UgiDooook>?:oooom?Cd0_clm00CWhm]KFeDIFDj
IFDjIE`Zhm;1QiNY/K6iZJV?WjVYKGj?WjVY/K6iWjVYG6f7m?C/m?Cdo?cd
m?Cd00;lo?@02_Cdm?clm?clm?clm?Cdm?ooooclm?Cdm?clm?Cdm0[lo?@0
0oCdm?clm?clm002m?Cd00coooo:`InYZHn7OUCoooo1^IL0000jA1WSd/7o
ooo/fk7oool2o?cd00?dm?Clo?Clo?@01?clm003m?Cdo?cdo?cd00Clo?@0
3oCdm?clm?clm?Cdm?clm?Cdm?clm?Cdm?oookVGKNcSb_C/foclm?C/focl
m01gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`00eanUgJG
`A4A4@028R8A00PZ8QTR8Q54:R8Z8QTb:R9U<PROKDcoool5k>cS00g/hl[1
/Holo?BiWgklo?CB/Hodm?C/fk7BbZWSfm_dm>cdm?Cdm>`00_Cdm004m?C/
o?cdm?C/o?cd0_Cdm0;dm>`2m?Cd00Olo?Cdm?Cdm?C/k>>?MRZ?MTCoool0
0oCdm009k>?:hm:ak=^ak>?:m>?:m>cK>T@IA4@ZA3XR008I6AT0314A4ATI
4Gi]C8n7KHMnSfeU8YnOO^?B/N?Kfn?B`OCdk?C/f`;dm>`4m?Cd00[lo?B?
Uhm]QgiLMWinOVgBbZUDKGI<MWiDOWiLMWh3E6ef00<jG7ILKGIDKGH00eA]
MP05OVeU/KVG/HMU`KVGfk6O00;Sd/404^cK`OCSb_clm?ooofeU8R8R4FEU
>UaLC4A4<SY46CXj8TA4<R8Z:T@Z8T@j:TA4<QTjMQTRC0DI6AT05C8Z8T@j
:SY46CY46DA4C4a<>ZVYSfEU>UaLC9nOOWinKFenSea]MUaLC28jG1U4QaUL
/KVGKOCdm?Cdk>c/h`07m?C/01Sdm?CSdYoSd[7:`Io1^HO1^INa/HniWgjO
Wgji/Io1^IN7OUC/fk7dm?Cdm>clo?Cdm>cdm?Cdm>clo?Cdm?Clo?Cdm>cl
o?@3oooo00Gdm?Cdm>c/hl[/hlZi^JT00_clm0Cdm?@02?clm?Cdm?Cdm?oo
oiN?M_clm?Cdm?clm0;dm?@2o?cd0_Cdm008o?cdm?Cdm?C/m?Cdo?cdm?Cd
o?cdm?Cd0_clm007m?Cdo?cdoooo^KV?A140oooom?Cd00;lo?@01OCdm?cl
m?Cdm?clm?Cdm002o?cd00Cdm?Clo?Clo?C/o?@4m?Cd00gBbZV?QeC:`Ini
Ufglo?Cdm?C1^IMfOUbOWgjiUeCoooo/fk7lo?@00_Cdm00>o?cd/K6?OWi]
KFeDOWIDIFDjd/[1b/6Yhm_KUhn7^KVYZJV?/KVYZJV?0[ViZ@04k>?:m?Cd
o?cdo?cd0_Cdm003o?cdm?Cdm?Cd00;dm?@2o?cd00?oooodm?Clo?@01ocl
m003m?Cdo?cdo?cd00Glo?@01_ooofDb200003Y46OoooncK/@8Z4@P00l[1
ZOoooncK/@02m?Cd1oclm005m?Cdo?cdo?cdo?cdm?Cd00[lo?@01?Cdm?oo
ol6iQn?B`@;lo?@00oC/foclm<c<c01fc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^3?<c<`014a]Qb8j<RXA228R4@<Z8QT0228R4C8Z8R8R4D@Z
8VDI0=:aSoooooCdk0;/k><01OCdm>?Kfoclm?Cdk?Cdm003k>cS00Gdm>cB
bZWdk=_/k>?lo?@00_Cdk004o?cdm?C/m?C/m?C/0oCdm00;o?cdm?C/m?C/
o?cdm?Cdo?cdm?Cdm?C/^Imnhm:aoooo00;dm?@06?oooncSb^?B/NcK`NcK
/N?B/OCSbTA4:QTI4CXj8VED<SXj8Xmf>Q4A4GiLC9N?MVED<WInG9nGQk67
IKViUhmnKIN?M^cSbP;dm>`2m?Cd00_dm>cdm?Clo?AnOVe]QgiLQhmLKGK1
^IMLMWi]MWIDKGH00UafOP05G6efE7inG6efE6efE7in009LKGH01EA]MUa]
M_ooooclm?ooo`03m?Cd01?/o?Cdm?C/o?Cooon?MRXIE39UICYDKGI<C4@j
A1U4:R8b:R8A4A4j>R8jA1ULG4`IG;4IA8L000000Q4A4@8I6AT0538Z8SXj
8SXj8SXj8T@j:SXj<U`j8YN?MS8Z8Ta<>TA4<[ViSkVOOXn7E9nOSiN?QhnG
SkVOO^cSb_Cdm0Sdm>`03OCdm>cK/M_:Wl6iWhn?IInGQiN?M[ViSk6aSl6a
SkViUiN?M^cK/@02m?C/00Kdm?Cdm>clo?Clo?Cdm?Clo?@2m?C/00WSd/7B
bZVi^HnOWgjaQfFOSfg/ZGK1^IMUG2X01_clm006m?Cdo?cdo?cdooooUhmf
m?C/0oCdm0;lo?@2m?Cd00_lo?Cdm>clo?Cdm?Clo?Cdm>clo?Cdm>clo?Cd
k=_dm>`00_C/f`08oooohm:a8R8Aooooo?cdm?Cdo?cdm?Cd0_clm004m?Cd
o?cdo?cdm?Cd0oclm00Ak?cdo?cdo?cdo?cdooood/ZYKFeD`KVG`K6?m?C/
ooooflZOShmUWimnWhm]oooom>?:00;dm?@2o?cd01G1^IMnMVEnMVE]KEAU
IC[1^InOZJWSd/5nShoBb/67OXni^JW/hl[1/KWBb/7/fl7lo?Cdm?Clo?Cd
m?Clo?@00_Cdm0;lo?@01?ooooCdm?Cdm?Cdm0Clo?@00oCdm?clm?Cdm006
o?cd013dm?Clo?Cdm?Clo?Cooon7IC8R<RXjA1Woooodk=/I6A4jA1Va/Hoo
ooo/fl7dm>`5o?cd00?dm?Clo?Clo?@02Oclm004m?Cdo?cdo?cdm?Cd0_cl
m004m?Cdo?cdd/ZYd/[10_C/f`03o?cdm>cKc<c<07K<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h<lc<c004:R8I:Q48:R8IA2XR12XR6@0>:Q48
:R8IC288A2XRA140k>cSm?C/k>cSo?cdk>cSb/6Yhm;1m>cKm?C/1?clm005
oooom?C/k>cSk>cSm?Cd00?dm>`01OCdm?Cdk?Cdm?clm?Cdm003m?C/00Sl
o?Cdm?Clo?Cdm?CooooSd[6iWgkoool3m?Cd00?/hl[Sd[7/fl400^cK/@0<
m>?:IE`Z>T@I>SXR6B8RIC88hm:O8R8AIE@bWiN7ZJV?SgIU0Yn?K@0;k=_1
hm:a^Imn^Imnk>cSm?C/m?Cdm?C/m?Cdm?C/oooo009]Qgh01FefMUafOYnO
OVenSfefMP03G7In00ADKGI]MWIDOWiLMWh2E6ef00ALKGILMWinKFGoool5
m?C/00O/o?C/k>?/o?CooonGOU@0001UICX00UaLC08j>R801bXR6A4A4D@j
:TA4<Ta<A29UZNc/h`02KHMn00B?bYLjE5`A4A4R:RX2A3XZ014RA3Xj>R94
>RY4>RY4A2Y4A39<C4A4>RYUE3:YZHniWgja/Hni^INGSgJOWgk/fl7dm?@0
2?Cdk00Am?Cdhm;1flZOb/6OKFeDSgHjKFDR>T@I`K6?`KVOb/6OShmUfl6O
k>cSo?cdm?Cdo?cd00Cdm?@2o?cd00Z?QeC:`IoSd[7:`IoSd[7:`Io1^IO1
^HNGOUC/k><2m?Cd00Clo?Cdm?Cdm?Clo?@2m?Cd00[ooonGShO/hl[lo?Cd
m?Clo?Cdm?Clo?Cdm?Clo?@2m?C/00Glo?Cdk=_dm>cdm>cdk=/00_Cdm007
o?cdm?Cdoooom>cKm?Cdk>?:A14000?lo?@00oCdm?clm?Cdm002o?cd0oCd
m0;lo?@5m?Cd00Woooo/fk6?SfFi^IO:`Io/hl[oooo/fk6?SfD00Yn?K@0F
oooom>?:m?C/o?cdm?Cdo?cdhm:aMWiLOWi]MWiLKFeD^KV?Qina`K6i/K6i
WjVYKGj?^KVYWjVYb/6YC6f7k=_10_Cdm0Slo?@01OCdm?ooooooooclm?Cd
m008o?cd00?dm?Clo?Clo?@00oclm003m?Cdoooo^IMD008R8Q42o?cd00HA
4A4R8Q6OSfgoooodhl[dm>`2m?Cd00?lo?Cdm?Clo?@00_clm003m?Cdo?cd
o?cd00_lo?@02_Cdm?clm?Cdm?oooncK/L[1ZOC/foclm?C/foclm7O<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c0058R8A:R8I:Q48:R8I
:Q48008Z8QT2:Q48024Z8QU<8PPb:R9<8PQU<PS/hl[1^IO1/Ini/In?Qfen
IEAUICYUE39UICYnMUB7OUBOWgji^JW/fl7/k>?dhl[dm>c/fk7/k>?dk=_/
hl[dm>cSd[7dm?C/fk7dm?Cdk=_dm>`00oCdm004o?cdm?Cdd/ZYm>cK0_Cd
m004o?cdm?Cdk>cShm:O0^?B/@05k=^am>?:Wimn8R8AA4@Z008b:R828R8A
00=UE3;1/KWSd[400^?B`@07OWIDWhm]`K6O^KVY^Imnm>cKk>cS00?dm?@0
3_Cdk?oooff7OWj?Sff7OUa]QinOOWj?Seb7SeafOUA]MUafOUAnOTa]Q`9D
KGH025AnOUA]MUa]MUa]MUaLC?clm?Cdk?Cdm0;/k><0:?Cdk?Cdm>c/hnc/
hooool6iQ`0004a<>Ve]E5aLC3Y46D@j8R8Z:QTI6D@j:T@j8Ta<>R9UZOCd
k8nGSff7OSYLMR94>Q4A4C8Z8T@j:SXj<XM<A4`R23Y46D@j8T@Z8SXj8TA4
:TA4<T@j:TA4<Ta<>YnOOXmnK@:OWgh00n?B/Oclm?Cdk004m?C/01Slo?Cd
m>cdm>cdm?Cdhl[1^IOSd[67IC:aQfFOWgj?MTC1/HnYZHo:`JVOSfg1/Iol
o?Cdm>clo?Cdm?Clo?Cdm?Clo?Cdm?@2o?cd00VOSffiWgjaQfFiWgkBbZWS
d[7/hl[dk=_oool01Oclm00=m?Cdo?cdo?cdm?Cdoooo/K6?d/[1oooom?Cd
o?cdm?Cdo?cdm?Cd00?lo?@2m?Cd0_ooo`03k?cdoooooooo00;oool02ocl
m?Cdk?Cdk?C/fcY46Nc/hoCdm?clm?Cdm?clm?Cdm002o?cd0oCdm0?lo?@0
0nclm?clm?clm002o?cd00kdhlY]IB:a/Ho1^IoSd[7oooodhlZ?QffGSgJ?
SfGoooodk=_lo?Cdm?@2o?cd01;dhlYfOUanOVenMVEfOUbOSffa/KVa^JVa
/KVOZJV7OXna/KVOZJWBb/5]OXo/fl7dm?Clo?@2m?Cd0_clm009oooom?Cd
m?Cdm?Cdooook=_1hjV?m?C/oooo00[lo?@00oCdm?clm?Cdm002o?cd00oo
ooniWghI6A4I6A7dhl[ooolA4A4Z8QV7OUCoooodk=_/hl[oooolo?Cdm?@0
3Oclm004m?Cdo?cdo?cdm?Cd0oclm005m?Cdo?cdm>?:`KVGm>?:00?lo?Ag
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`3:Q4800<R8Q4Z
4@PZ4@P00RXA20038R8A:Q48:R8I008Z8QT02T@A0?ooooCdm?ooon?B`Hn7
KInGQl[1ZM;:`N?B/@:i^JT02:VYSgifIIn7KNc/hoclm>c/hoCdm?Cdk0;d
m?@3m?C/00K/k>?dm>cdk=_dm>cdm?Clo?@2m?Cd00?lo?Coooodm?@01?Cd
m003m?C/d/ZYflZO00;KbYl01NcK/OC/f`0003Y46DA4:P02<RXR00Y4A2Y4
:R:i^IO/k>?Sd[7/hl[Sd[7:/JVOSffaQfD2hm;11OCdm00UooooG6efOXn?
KHMnG6f7OWi]SiN?G6f7G7InE7inE6efG6efE7in>UALG5a<>TA<>SXb<SY4
8S8Z:Q48k>cSo?cdk>?:k>cSm>cKk>cSk=^am?C/k=^ao?cdb/6O4A4AKFDR
G5a<MWiL>SXRA3XR008Z8QT0228b:TA4:T@j:R9UZN?KfhnGSb9<E000008A
4A402aTI6D@j:SXj<YnGQl6aWfEU>R8R4D@Z8SY46E`j8S8Z8P02A4@Z00M4
A394>RXjA1UUICZi^IOK`Iolo?@02?Cdk00?m?Cdk>?:flZOb/6O/K6?Whm]
Wgi<SgHZWhm]`KV7^K6OIFDj`K6?hm_Ko?cd00;dm?@01_Cdk?clm?Cdm?cl
m?Cdm?Cdk0;lo?@02?ooooclm?ooooooooCdm?clm?Cdm?clm0Cdm?@2o?cd
00Kdm?Clo?Coooni/Io:`JWoool2m?Cd0_clm003m?Cdo?cdm?Cd00?oool2
m?Cd00gooooSd[7BbZV?SfE]IB;oooolo?Cdm>clo?AU<PS/hl[oooodm?@0
0_clm004m?Cdo?cdm?Cdm?Cd0_clm004m?Cdo?cdo?cdk?cd0_clm009m?Cd
oooom?C/Sd@0Wimnd/ZYfk6Ooooom>cK00:?SfD049n?KOooooC/foC/foCd
m?clm?Cdk>c/hgInG8n7KGinKFe]E8n?INcSb^?B`NcSbP;:`JT03KViZM;:
ZL6a^N?B`N?B/OCdk?Cdm?clm?ooooclm;WKm9Nib^?Kf`02oooo00CSd/7:
8P3BC03oool2o?cd00Gdm?Clo?Clo?Clo?Cdm?@00_clm003m?Cdo?cdm?Cd
00?lo?@03oCdm?ooom_1WbXA214A4M;:ZOooo`00028R4FeU8_ooooCdk>?B
/OooooCdm004o?cd00?dm?Clo?Clo?@03?clm008m?Cdo?cdo?cdo?cdm?C/
/K6?m>?:o?cd0_C/fgO<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
<lc<c08R8Q401BXA228R4BXA22XR6ATI6@038R8A01DZ4@PZ8QTb:R944@3d
m>cdm?C/k>?Sk?Clo?Ba^IMnMVEfOUb?SfF?Qff?SfFOSffOWgkdk=_/k>?l
o?Cdm?@00oCdk005m>cKm>?:m>cKo?cdm?Cd00?dm>`01?clm?Cdm?Cdm?cl
m0;dm?@00oclm?Cdm?clm002m?Cd00_/o?CBbZW/fl7Sd[6iWgk:^HniUe@A
4A4jA1U4:R8j>R800T@j:P;Sd[402nc/hoC/fncSb_CSb_Cdk?clm>cSb]_1
WncK/OCdm?clm003m?Cd00clo?AfOUa]SiLjE5a]QginShnOWhmLMWiLKGHj
A394>RXR<RX2:Q4800@0000R8Q4R8Q4R8Q42:Q4800gdk=_dm?C/ZGKdm?CS
fm_lo?C/ZGK/fk7/ZGKooooBb/4I6A4jA1T00Ve]E094>R803C8Z8QTI6D@j
:SXj<T@j:S9UZOCdk=;:`AUfA14A4ATR<QTR8RXR6@03A3XZ00Vi^Hna^INi
WgiUE38R8Q7K`ImUG2Y4A2Y4>R800da48P04<RXRG3XRb/6Oo?cd1?Cdk0;d
k=/01?Cdk?C/foCdk?Cdk0;KbYl02L6iQl6iUkViZKViUkViSiN?MYnOOXMn
E;VOOP02o?cd00Cdm?Clo?Clo?Clo?@2m?Cd0_clm003m?Cdo?cdo?cd00;l
o?@01OCdm?clm?Cdm?clm?Cdm005o?cd00Wdm?Clo?Cdm?Clo?C1/KVa^IOo
ooolo?Cdm?@00oclm00Em?Cdo?cd`K6?ShmUUgiD^IMDk>?:oooofim]`KV7
C4@RID`Ioooom?Cdk>?:ooooSgHZb[6Yooooo?cdm?Cd00;lo?@01OCdm?cl
m?clm?clm?Cdm003o?cd0_Cdm0;lo?@02OCdm?clm8mf:Xmf:[ViUlZiSooo
ooC/fhMnE002Whm]0_clm003m>cKo?cdm?Cd00;lo?@047InG7inKGinKGIn
G7ifE>cSb^?B/K6a^ATRC3YDQncK`N?B`KUnC=^7IM^aWoCdk0?lo?@03iNi
bWJG`JW:d_clm?ooon?Kfm9<0<XR0?C/foooooclm?Cdm?clm?ooooCdm005
o?cd00Sdm?Clo?Clo?Clo?Cdm?Clo?Coooo/fl426ATA00Zi^IOooom]IB9n
KDafOUcoooodm>c/fk7oooodm?@2o?cd00?dm?Clo?Clo?@00_clm003m?Cd
o?cdo?cd00Klo?@01?Cdm?clm?clm?clm0;dm?@2o?cd00FiWgkdk=_lo?Cd
k=_lo?@0Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00PR
8Q4Z4@PR8Q4R8Q4I6A4Z8QTR8Q4I6AT28R8A00dZ8QTI6ATZ8QTZ4@SK/Iod
m>cdm?Cdm>cSk?CooooSfm_:`JVa^IL00ZVYS`0;WimnWhm]Sfe<fl6Ob[V?
`K6O^KV?`KVO^Imnhm;1m?C/00Clo?@4m?Cd00?lo?Cdm?Clo?@01_Cdm009
k?cdb/6Ohm:ahm:am>?:ShmUIE`I4A4A8S8Z008b:R8013Xj8VDb2?oooocl
m0Odm?@00nc/hncK/OCdk004m?Cd00[lo?A<MWi]QginKFE]OXmLMWja^JUL
KHMLMWh00002:Q48010R8Q4j>S8Z8QU4:R94A4aLG4a<C3XjE5c/fl7oooo/
`HOdm>cdhl[BbZWdm?Cdk=/2m?Cd02WSd/4jA1TjA1UfOUaLG4a4A394A2Y4
:R8I6ATb:R94>RY4:R8bIJWSfm_/k><jG7HI8R8A4A4I8R8R:RY4>RY<C4@b
:R;1^IN?QeCdk=_Bb/5fOUcdm>c:/JUUICY]IB8b:R9UG2[B/Ho1^HMfOUba
QfGlo?Cdm>cdk=/00_Cdk00Do?cdm?C/o?cdm?Cdm?C/o?cd`KV7ShmUWimn
UhmfWimnWhm]/K6?/KVG`KVOZJV?^Imnk>cSm?Cdo?cd1?Cdm005o?cdm?Cd
m?Cdm?Cdo?cd00?dm?@3o?cd00Kdm?Clo?Clo?Cdm?Clo?Cdm?@2o?cd0_Cd
m006oooohm;1Win?oooom?Cdo?cd0_Cdm00=o?cdm?CdooooShMD>T@IQfDb
^IM]hm:aoooo`KV7b[V?IE`IC4@R00;oool02>cK`OooohmfE;VOO_ooooCd
m?clm?Cdm0?lo?@00oCdm?clm?clm002o?cd0_Cdm0Clo?@04oooohmf:XmU
4L6iUl6iQoooooclm8n?IIN?MXn?IOC/foCdm>cSb_Cdm?clm?Cdm?ooohMn
E6f7OP03MWiL01?/hl[Sd/67OXlbA7Ja/KWSd/7B/Hna6@3BC03/hl[Sfm_l
o?CooonifoAnWkUfUl7oooodm?Coool00]9<0004himDooooo?cdm?Cd1?cl
m004m?Cdo?cdo?cdm?Cd0_clm003m?Cdo?cdm?Cd00?lo?@03OC/fcY46Da4
8Xn?IOoooin?KKVGE;VGKOclm?ooon?BWoooooCdm004o?cd00?dm?Clo?Cl
o?@00_clm003m?Cdo?cdo?cd00;lo?@00oCdm?clm?clm005o?cd00Odm?Co
ooniWgk/hl[lo?Cdk=_lo?@0Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Pcc<c<00PR8Q4I6A4R8Q4I6A4A4A4I6A4A4A4R8Q426ATI00dZ4@PI
6ATZ8QTZ8QVOKDcdm>cdm?Clo?C/k>?dm?C/o?CooooSfm/00/[1W`03hm:a
^KVY`KVG00;Sd/401_C/fncSb^?B`M;:`LZaZL6aW`;1^IL01<[1Wl[1ZN?B
/N?B`@;lo?@01OCdk?clm?Cdm?Cdm?clm002m?C/013dm?Cdm>cooooSd[7/
fl7Sd/7/fk71^Im<A28R8Q4b:R8Z8QTI6ATb:R944@3lo?@7m?Cd00Cdm>cd
k=_Sd[7dm>`4m?Cd017lo?ALKGI]Qgi]OXm]Qgi]MWJi^JUDKGI<MWi44@1L
KGHR8Q5DKGILG4`R8Q54A39LOYL00da<A005fk6Oo?cdhncdm?C/m>cK00;/
o?@01_Cdm>clm?Cdm>c/hfEL6B8b:P9]KE@05TA4:SXj8SXj8QTI6C8Z8Ta<
>T@Z8Ta]Ul6a^OC/fea]MQ4A4ATR:Q4A4BXR6D@j:TA4:S8Z8[6aSiN?M^?B
/N?B`@9fOU`02kVOO_CSb_ooogi]C9n?KNc/hkViSkViZM_1WoooooCdm004
m?C/00?lo?Cdm>cdm>`00_Cdk005d/ZY^IM]SgHZID`IIC8800AUE3801KVi
UiN?M^cK`Oclm?Cdm002o?cd00?dm?Clo?Cdm?@02?clm004m?Cdo?cdo?cd
m?Cd1?clm00@m?Cdo?cdm?Cdo?cdm?Cdm>cKUhmfooooo?cdm?Cdo?cdm?C/
o?cdm?Cdoooo`KV70VEU>P0>`KV7`KVGooooflZOd[6?KFDRA140o?cdoooo
k=^aoooo/K6?SgIUoooo1?clm004m?Cdo?cdo?cdm?Cd1?clm003k?cdo?cd
m?Cd00;dm?@02?ooojUf<XMU</6iQkVOO_ooooclm8n7E0:?SfD02^?B/Ooo
ooCSb_clm?Cdm?clm?ooohn7KGinKIN?MP9fOU`02NcSbYnYZEAfUinOSncS
b];:`M]f<[4I0>>YS`02k>?:00CooooSk?AfUl5fUl42o?cd00OooooK/JW:
8P3:8P3SZHoSfm_oool03_clm00?m?C/o?cdo?cdoooo/HMU`KV7^Imnoooo
m>?:m?C/m>cKk>?:d/ZYfl6Ooooo00?lo?@00oCdm?clm?clm002o?cd00?d
m?Clo?Clo?@02Oclm007m?Cdo?cdo?cdo?cdoooo^IM]hm:a00?lo?Agc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`02ATI6B8R4BXA21TI
4BXA214A4BXA21TI6BXA20038R8A00LZ8QTI6AUU6@2OWho:/JWSd/7dm>`0
0_Cdm005m?C/m?Cdm?Cdhm_K`KV700;BbZT01];:`NcSb^?B`N?B/NcSb^cK
/@;/hlX01_C/fn?KfoC/fncSb^?B`N?B/@;dm>`01oclm?Cdk?clm?Cdm?cl
m?Cdm?clm002m?C/00k/k>?:`JWSd[7Sd/7/fl7/fk7/hlXZ4@PI6A4jA1TZ
8QTI8R8Z4@Sdm>`3o?cd1?Cdm005k>cShm_K`KV7m?Cdm?C/00?dm?@01?cl
m5AnOVf7OVf?U`9]OXl01[7:bUa]MVenSbXA25a]MTa<>P94A4`08D@A04@j
:R8R4Da<A38Z8R8R4M:aSoooooCdk?Cdm?Cdk>c/hoCdk>?KfoC/fnc/hocl
m8mU4A4A4GInG6EU>Ta<>T@j8T@Z8RXR6B8R4CXj<SY46Da]UjW:d_clm6f7
OQ4A4@026B8Z01DI8R8b:R9<C3XR<RZGSgJOWgkK/JW/hlYfOUaLG4bOUhO:
`Ioooon?SfF?UhnOWgja/Hni^HnOWgklo?C/k><02?Cdk00=o?cdflZOd/ZY
^IM]WimnWgi<SgHZQfDbIE`ZID`IUhmf/KVGhm;100;lo?@2m?Cd00Clo?Cd
m?Clo?Clo?@2m?Cd00Clo?Cdm?Cdm?Cdm?@3o?cd00Kdm?Clo?Clo?Cdm?Cl
o?Cdm?@2o?cd0_Cdm0;lo?@018n7KOooooclm?clm0?oool05OCdm?oool6i
UfEL:VEU>/6iWkVOO_ooon?B/L6iQfEL6CY46OC/fooooncK/Ooool[1Whmf
A?ooooclm?Cdm004o?cd00?dm?Clo?Clo?@00oclm008m?Cdo?cdo?cdo?cd
m?CdooooUgiDQfDb0/6iQ`04oooom?Cdk=^ak=_10_CSbP07ooook=^am?Cd
o?cdm?CdooooWhm]00:GSgH02gInG7ifINcSbSYLMVenSl[1ZL[Kfl5]A=]f
<]9<0>?/m002hm:a00GooomnWkV?/L5fUl6ifo@00_ooo`;BC0001=]f</XR
0<XR0?ooo`[lo?@01OCdm?clm?clm?clm?Cdm003o?cd00Cdm>c/k>?/hlZi
^IL2^Imn00?1^HOSd[7/fl400oclm003m?Cdo?cdo?cd00klo?@00oCdm?cl
m?clm002o?cd00Gdm?CoooniWgkSd/7lo?@00_C/fgO<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h<lc<c0068R8A6ATA4A4A4A4A6ATA:Q480QTI
4@8I8R802R8R4ATI6BXR6ATR8T`R28MD:Ve]E5aLC9MnE?ooo`Gdm?@03oCd
k<[1ZL[1Wn?B/Oclm?Cdm?Cdk>c/hoCdk>c/hncSb^?KfncSb^?B/NcSbP02
k=_100Gdm?Cdm>cdm>cdm>c/k><00_Cdk006m?Cdm?C/m?Cdm?C/m?Cdhm;1
0^?B/@06hm;1hm:ak=^ahm;1^KVG4A4A0SY46@0<:Q48m>cKk>cSm>cKm>?:
m>cKm>?:k=^am>?:oooob[6Y`K6?0_clm0?dm?@03_C/feAnOVf?Uff7OVf?
Uea]Ql6a^Eb7SfenSbXA23Xj<Ta<A4A4C4A4<P9LKGH2G7In039]MWILMWji
Wgklo?CSd/7Sfm_dk=_Sfm_/k>?/hl[Sfm_dk=_dm?B?MT@0002?SfEUICY4
A2Y4>R8j>R8R:RXI6A5<C3Y4>RYLKHN?WkWlo?AnShl0000I8RXA4A4R:RXj
>S94A38R<RZOQffOUhO:`Iodm>b?SfEUICZa^IO1/HoooonOSff?UhljA1W1
/HnOUhN?Qe@2o?cd1_Cdk008o?cdm?C/m?Cdd/ZYflZOb/6O`KVO/K6?0/6i
U`:OSfd01;VOO[6aSm_1Woooo`;dm?@3o?cd00?dm?Clo?Clo?@00_clm003
m?Cdo?cdo?cd00;lo?@01?Cdm?clm?Cdm?Cdm0;lo?@00oCdm?clm?Cdm002
o?cd00Gdm?Clo?BOWgkSfm^a^Il00YnYZ@05Win?/KVOoooooooob/6O009U
ICX03k6iUkVOO_oooncK`L6iQfEL6BXA2?CSb_oooncK/Oooon?B`Fe]E?oo
ooCdm002o?cd0_Cdm004o?cdm?Cdo?cdm?Cd0oclm00:k?cdo?cdm?Cdo?cd
m?Cdooook=^ak>?:m>cKhm:a0_ooo`06`KV7ShM]ShMD`KV7ooook=^a0_cl
m005m?CdooooWimnKHMnUhmf009fOU`01NcSbSYLMVenShnGSgj?S`02fgHb
00Ja6@3B/Ho/hl[Sd[7ooomfUl42Sk7100AfUl5nWkWSk?CKOT`2dT`000KK
OTcBC03KQfGoooolo?Cdm?@2o?cd00?dm?Clo?Clo?@01Oclm009m?Cdo?cd
o?cdm?Cdoooo^Imn`KV7k=^am>?:00Coool00oCdm?clm?Cdm005o?cd00?d
m?Clo?Clo?@02?clm003m?Cdo?cdo?cd00?lo?@01OCdm?clm?ooom:aSm;:
Z@03o?cdMlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00HI
6ATZ4@PA4A4Z4@PA4A4Z4@P28R8A00hZ4@PR8Q4R8Q4I6ATR8Q4I6AU4:R9L
>R9]MWJ?MVG<c<coooodm?C/o?@4m?Cd00?oooo/hl[BbZT01?Cdk003o?cd
m?C/o?cd00;dm>`01?Cdm?Cdk>c/hoC/f`?dm>`03Oclm?Cdm?Cdm?Cdm>cS
b_Cdm?Cdk?clm>clm>cSb/[1Wn?B/NcK/@02hm:a00_/fk7lo?CSd[5<A28I
6A6?A03lo?Cdk=_KWfgdm>cKOT`00_CSbP05k=^aooook>?:^Imnm?C/00Cd
m?@0;oCdk6f7OUafOVenSff7OVefM[VaWeafOVenSgj?Sff7OUb7SfefMVe]
E3YDG38jA4@j:QTI4B8R4@0008MD:_clm>cSb^c/hoC/fnc/hncSb^c/hoCd
k>?Kfoclm9nOOP0007ifE4a<>Ta<A4@j8SXj8S8Z8QTR8T@j:T@j8TaDKGjO
^Oclm7j?Sa4A4@026B8Z01<Z8QU4>RY4A4a4:R:OQffa/HniWgklo?AfOUaL
G4ba^INaQfGooonOWgj?Uhlj>R;1^HNYZHn7OU@01OCdk003o?cdm?C/m?C/
00;dm>`01OCdm>?BWinOOXn7E9nGQ`02^KVG00W:`Ini^JVa/Hni^Hna^IOB
/Holo?Cdm?Clo?@00oCdm004o?cdm?Cdm?Cdm?Cd0_clm005m?Cdo?cdm?Cd
o?cdm?Cd00?lo?@00oCdm?clm?clm002o?cd0_Cdm00Nooood/[1OXn?KHMn
G6f7KHMnG6f7KGj?E6efk=^aooooflZOKFeDIFDjShmUSgI4ooook>?:^IM]
KFDR:Q48k=^aooook=_1oooom>cKIFDjooooo?cdm?Cd2?clm003m?Cdo?cd
m?Cd00;lo?@02_Cdm?clm?ooom:aSgInG9nGQkVGKOclm?oool6iQ`:?SfD0
5KVOO_oooncK/OCdk?Cdm?clm?oookViUgifIHnGSff7OWInG?C/fhMnSfen
ShNO/EAfUkU<0=]f<[U<0<XR0002hm:a00?ooom]SkV?WkT00YNibP9nWkT0
2?CSb^c/hoclm?ooom^aWm9<0>c/hoooo`Clo?@01?Cdm?clm?clm?Cdm0Cl
o?@01?Cdm?clm?clm?Cdm0;oool2o?cd00?dm?Clo?Cdm?@01?clm003m?Cd
o?cdo?cd017lo?@00oCdm?clm?clm002o?cd00?SdYni^JWlo?@00_clm7O<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c0038R8A6ATI6ATA
00<I6A401b8R4ATI6ATI6B8R4BXR6ATI6BXR6@03<RXR00FiOUCKMS;KWfgS
d[7lo?@00_Cdm003hncdm?Cdm?Cd00?dm?@00oC/foCdm?Cdk003m?C/00?l
o?Cdm>cdm>`00_Cdk003o?cdm?C/m?C/00;dm>`2m?Cd00C/o?C/fk6aQfGo
ool3m?Cd00G/hl[dk=_BbZW1^IO/fk400^?B/@08m>cKo?cdm>cK^Imnfl6O
ooooo?cdk>cS0_Cdk007m?Cdo?cdm?Cdm?Cdm>cKhm;1m?C/00?dm?@03Ocl
m?Cdm?C/fn?B/InOSeb7SfenSinYZFf7OVf?UaUD<QTI6ATI4@0200000bXA
200:<RXRA3XZA4@bSea<m?C/k>cShm_Km?C/k>?:hm_K0^c/h`07k>?:m?Cd
^KVG0000OVe<IFDjA4@Z0094>RX02RXR6B8R4DA4<S8Z8TaDKFf?^Oclm7k1
UaTR8Q4A4@8I8R80538Z8TA4<S8jA9N?MYnGQkVOO_oooin?KFe]E;VOOYn?
KOclm9nOOWj?SfEL:YnOO[6aShMnE?Cdk?Cdm0Cdm>`05?clm?Cdk?Cdk?Cd
k?Cdm>?B/LZiShmf:VeU8WiLC7InG6EU>WifIFe]E;6aSkViUl6iQooooocl
m?Cdm0;lo?@01?Cdm?clm?clm?clm0;dm?@00oclm?Cdm?clm003o?cd00Od
m?Clo?Clo?Clo?Cdm?Clo?Cdm?@00_clm00Im?Cdm>cKE6efOXn?KHnGKGj?
KHnGKHMnOXn?KHMno?cdooooflZOShmUC4@R`KV7Whm]oooom?C/d[6?OWID
:R8I`KVGoooom>?:00;lo?@01FEU>_ooooclm?clm?Cdm002o?cd00Cdm?Cl
o?Clo?Cdm?@3o?cd0_Cdm0;lo?@02OCdm?oool[1Whmf:ZUf<[6aSoclm?oo
olZiS`02ShmU00BaQfGoooo/fk7dk=/2m?Cd01Woooo:`Im]MWJGSgInOVfG
SgK/fl7Bb/7Sd/7Sd[67UjV7OXoK`IoK/IoBC03KOTcSd[7oooo/k>?dm>cl
o?CooonG^LYfUl7Sk?@00oooo`05hm_KdT`0m>cKoooom?Cd00Wlo?@01OCd
m?clm?clm?clm?Cdm003o?cd00Cdm?Clo?Clo?Cdm?@2o?cd00?dm?Clo?Cd
m?@00_clm005m?Cdm?C/o?cdo?cdm?Cd00Olo?@01?Cdm?clm?clm?Cdm0Cl
o?@01_Cdm?clm?ooon?B/L6iQoclm0;dk=]gc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^3?<c<`011TI6B8R4ATI4ATI4@8R8Q404Q4A4ATI6BXR
6ATI6B8R4BXA21TI4B8R4BXR6D@Z8XMD:^>YSkUnE=]nC;UnE>biKOCdk?oo
o`Gdm?@01>c/hoCdk?Cdk?Cdk0;dm?@4m?C/013dm?Cdm>cdm>cdm>cdm?Cl
o?Cdm?Clo?C/o?CK`InOOTcoooolo?Cdm?Clo?C1/KT2m>?:00KSd/6iWgkB
bZW/fk7/hl[dk=/2o?cd00>GShOdhl[dm?@01_Cdm004o?cdhm_Kk>?:k>cS
1_Cdm005oooom?C/^KVYb/6YZJV?009]SiL033Xj8S8Z8Ta<>UaLC5afOVef
MUb7Sff?UfenSgj?Sff?UhnGS`;/k><04N?KfncSb^?KfncSb^?Kfnc/hn?K
foclm>?B/@0006e]E4A4<U`j8TA4:SXj8TA4<QTI6@02A4@b00E]MWHbIJWl
o?BOWhlA4A400aTR8P0DA3XZC4`jC4`jIE@bWin?^Imno?cdWiN7G5a<Uhmf
Wimnk>cS`KVGUhmfA4A<WiN7^K6OShmUm>cKo?cd0oCdk003o?cdm?C/m?C/
00;dm>`04OCdm>?B/L[1Whn?IFE<6HmfA6E<6ImnC7ifIDa48[VOO/6aWkVO
O_ooooclm?Cdm?clm003m?Cd00?lo?Cdm?Clo?@00_clm005m?Cdo?cdo?cd
o?cdm?Cd00?lo?@00oCdm?clm?clm002o?cd00Cdm?Clo?Clo?B?Uhl2KHMn
00E]SiM]QginShmLQhnYZHl00_ooo`0Ak=^aWimnC4`jZJV?Whm]ooooo?cd
flZOOWID8R8A^IM]oooom>cKm?C/ooooIFDjoooo00;dm?@2o?cd00Cdm?Cl
o?Clo?Cdm?@3o?cd0_Cdm0;lo?@2m?Cd01coooodhlYnKDb?MR[1^IOdk=_o
ooo:`ImfOUb?SfFOOTcoooodhl[/hl[oooodm?CooooSfm_/fk7dk=^iWgko
ooodhl[BbZWSd[7/hlZ?Uhn7OXl2k>?:00_K`IoBC03K/JWoooolo?Cdm?Cl
o?CooonifoAfUl7Sk?@00_ooo`03hm_Kfgi<fgHb00[lo?@01OCdm?Cdk?cl
m?clm?Cdm004o?cd00Cdm?Clo?Clo?Cdm>`7o?cd00Cdm?Clo?Coooodm?@6
o?cd00?dm?Clo?Clo?@01oclm006m?Cdo?cdm?Cdo?cdm>?:^Imn0_clm003
m>cKc<c<c<c<07G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<
c08R8Q406ATI6BXA21TI4@00028R4BXA200001TR<SY4C3YDG394MTaDKFen
ShMnSbXR6M:aSm^7IM]nC;VGE=]nC;UnC>?BWnc/hoooon?/m002m?Cd00gd
k=_/fk7dm>cSd[7dm>c/fl7dm>c/k>?dm?Cdm>clo?Cdm>cdm?@00_Cdk00R
m?Cdm?C/m?C/m?Cdd/ZYSgHZoooom?Cdm?C/o?cd/L[:hm:ak>?:m>?:k>?:
/K6?k=^am?C/m>cKm>?:o?cdSiN?WiN7oooom?Cdo?cdm?Cdo?cdm?Cdo?cd
m?Cdk>cSm>cKk>?:2?Cdm0?lo?@029nYZFf?Uda<A4a<>XNGZEb7SfenSeaf
OP=]OXl01EafOVefMWj?SoC/foCdk002k>cS0_Cdk00Dk?cdm?Cdhncdo?cd
k=_10000KFeDID`IIE@b>T@I>SXR<RXR4A4AA4@Z>SXRG5a<6EbahncdG6ef
4A4A0QTI6@056B8R>SXR<SY4C4`jIE@b00:iWgh04?clm;6iUfEU>Yn?KInO
O_CSb/[1ZFf7OWInG8n7KKVaWhn?INcK`OCdm?Cdk?clm0Cdm>`02Oclm?Cd
k?Cdm>?B/M;:ZHmf:XMU<[VGE5`j8P02SgI400A<A2;1^HNi^JViWgh2o?cd
00?dm?Clo?Cdm?@00oclm005m?Cdo?cdm?Cdo?cdm?Cd00Glo?@01OCdm?cl
m?clm?clm?Cdm002o?cd00_dm?Clo?Clo?Cooona^ImLQhm]SiM]OXmLQhm]
Qgk1/Il00_ooo`0<k=_1/K6?>T@IWimnWhm]oooom?CdflZO^IMD^Imnk=^a
o?cd0_Cdk003ooooIFDjoooo00?lo?@00oCdm?clm?clm006o?cd00?dm?Cl
o?Clo?@00_clm00?oooom>cKMWiLUhmfflZOk=^aoooohm:aOVe<OWIUWgi<
oooom>cKm>?:oooo00;dm?@01?clm?ooooclm;VOOP;dm>`03;VaWhNGZK6a
^InYZEafO^cSb^?/m<6a^M9<0=^OKOooooclm0;oool01>?/m8na`Hna`OCS
bP?BC0001<XR0?CSb_ooooCdm0?lo?@00oCdm?clm?clm008o?cd00Cdm?Cl
o?Clo?Cdm>`5o?cd00?dm?Clo?Clo?@02oclm0;dm?@3o?cd00Cdm?Clo?Cl
o?Cdm?@5o?cd00Kdm?Cdk=^iUfglo?Cdk=_lo?Agc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^3?<c<`011TI6BXR6ATI6ATI4@8Z4@P00aTR<TaD
KFF7Z@02KHni00QfUk5UQjUfUk6?WkVG^LZ?WkWdm>cKWfd3fhMU00GKOTcK
WffiUeCdk=_oool00_Cdm0?lo?@00oCdk>c/hoC/f`02m>cK00?K`Iolo?CB
bZT00oCdk00Co?cdm?C/m?Cdm?Cdoooo^IM]b/6Oo?cdm?C/m?Cdo?cdWjVY
hm:am>?:k=_1k>?:k=_1^Imnk>?:00;dk=/01_oooinYZIN?Qoclm?Cdm?cl
m0Gdm?@01?Cdk>?KfncSb_clm0;dm?@00oclm?Cdm?Cdm003m?Cd00O/o?Co
ooni^JUnShmDOWhZ8QU]Qgh00VenS`09KHnGKHMnKGj?KHMnKGj?G8N?OWi]
hm;1oooo00;dm?@2m?C/01?dm?Cdm>c/o?Clo?Cdk=/0001UICZ?QeAnKD`j
>S94>RXj>R8A4A54A2Y4>R9LG4`IG;4AE:TI8RX00aTI6@0E<RXR>T@bA4@b
C4a4G3XR^KV?Wimnm>cKd/[1G5a<QgiD^Imnhm;1k>?:OWi]MWiLOVe<`KVG
Uhmfhm:am?Cd00Cdm>`03?clm?Cdk?Cdk?Cdk?Cdm>cK`N?B/L[1WkViSkVO
OYn?KKVOOP9UG2X00k67IK6iWin?K@02o?cd00?dm?Clo?Clo?@00_Cdm0;l
o?@01?Cdm?clm?clm?Cdm0;lo?@00oCdm?clm?clm002o?cd00Cdm?Clo?Cl
o?Cdm?@2o?cd0_Cdm003ooook=_1G8NG00=]SiL06IN?M_C/foCdm?ooooCS
b/6iQin?KM;:ZN?B/OCdm?ooooC/fn?B`InGQin?KOCdk?Cdm?C/foooofe]
E?Cdk?clm?Cdm?clm?Cdm002o?cd00Odm?Clo?Cdm?Clo?Cdm?Clo?C/o?@0
0oclm00Om?Cdoooom>cKIE`IIFDjWhm]d/[1oooohm:aMWiLWimnShmUoooo
m?C/k=^aooooo?cdm?Cdo?cdm?C/o?cdk=_1`KV7hm:ab/6Y6B9<QinaSiN?
Qgj?dT`0^D`000;:MR800n>YSooookWBf`03Sk7100=nWkVG^L[/k><00m9<
0003fgi<ooooo?cd00Klo?@00oCdm?clm?Cdm002o?cd00?dm?Clo?Cdm?@0
2Oclm0;oool00oclm>cK`Oclm004o?cd00?dm?Clo?Clo?@03?clm004m?Cd
o?cdo?cdm?Cd0oclm004^Imno?cdo?cdm>cKMlc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Pcc<c<00/I8R8R8Q4R:RY4A4a<KIMUQjU]OXljE8M<
KIM<E6djE8L00da]Q`0CKGIfQgj?Qgj?ZGHbfim]fgi<himD^IMDfhMUfgi<
fhMU^Gi<k<67m?C/ooooWin?b/6Yc<c<m>cK00Clo?@01OCdm?Cdk>cSb_Cd
k=^aW`02m?C/00Klo?Cdm>clo?Cdm?Cdm>clo?@2m?C/00Gdm?Clo?B?Uho:
`JWSd[400^cK`@09k=^ak=_1k>?:m>cKk>cSoooo/KVOOWi]o?cd00Odm?@0
1^c/hoCdk>?B`Oclm?Cdm?clm0Odm?@04OoooinOSff?Uff?UbXA24A4:Ven
Sgj?Sea]QfenSff7OVenSff?Ugj?Sff7O]^aZOooo`02m?Cd0_Cdk0;dm?@0
1OCdk?Cdm?clm14A4CY46@02OVe<00e4>RXjA1U4>RXI6AU4>RXj>S94A38j
G7HbA7I<C3Y<C4@Z8QTb:R800dA4<P0BC4a4A3XZWimn/KVGm>cKk>?:G5a<
QgiD/KVGfk6Yk>cSKFeDOXn?IFDj^K6OWimnfk6Ooooo0oCdk003o?cdm?C/
o?cd00;dm>`03OCdm?CSb]_:Wk6aSkViSl6iQk6aSkViZL6iQinGQkVOO[Vi
UiN?MP02o?cd0_Cdm0Clo?@00oCdm?clm?Cdm002o?cd00Gdm?Clo?Clo?Cl
o?Cdm?@02Oclm009m?Cdo?cdo?cdG7InKHMnKHnGKGj?m?C/o?cd00;dm?@0
4oclm>cSb[6iUjVYSl6iUoCSb_ooon?BWinOOSY46Hn?IOC/foCdm?CSb_oo
ofeU8^cSb_clm?Cdm003o?cd00?dm?Clo?Clo?@01?clm0;dm?@00oclm?Cd
m?clm002o?cd00m<A28jA1U44@3:`Iooooo/fl4jA1U<A29UG1Wlo?Cdm>c/
fk7dm?Clo?Cdm?@00_clm005m?C/o?cdo?cdo?cdhm;1009LKHL00ff?Ulc<
c<XR0002dT`000CKMS;K/JWooonid]/2OYni00RG^LZid]_lo?Clo?CK/Iod
hl[dm>coool2o?cd00?dm?Clo?Clo?@01_clm003m?Cdo?cdo?cd00Klo?@0
2_ooooclm?CSb^c/hncK`K6aSn?B`JVYSginKGjO^@Klo?@00oCdm?clm?cl
m005o?cd00?dm?Clo?Clo?@02Oclm004^Imno?cdm>cKo?cdMlc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00E4A4aLKHMLOYMLKHM<E6d0
0S94MP0;C5A]A4A<<SY4A4A<<TAf4A4A6ATA6ATI0000KGIfSc9<00;KOT`0
4L5]A=]nC=]nC=^7IN>OE=^7IL5]A=]nC=:aSinOOT@j:Ta<A5aLC8n7KIN?
QkViZN?B`@02m?C/0oclm007k>cSm?C/m?C/m?Cdm?C/m?Cdo?cd00Cdm?@0
3oclm8nGSlZaZN?B`M;:ZOCSb^?B`N?B/NcK`OC/foCdk?clm;7:bVenSoCS
bP03m?Cd00Clo?Cdm?Clo?Cdm?@2m?C/00?Bb/7lo?Cdm?@00_Cdm003o?cd
m?Cdm?Cd00?dm?@03?clm;6aSff?Uff?Uff7ORXA228R4EafOVenSff7OVen
Sff7OP=]OXl01LZaZOclm?Cdm?Cdm?Cdk004m?Cd00O/o?Clo?@A4A4jA1UU
ICY4A2Y<A2800SXj8P046ATA<RXRA4@bA3XR0TA4<P05C4`j>SXb:R8I6ATI
A4@Z0094A3804Ta<>T@j8YN?QkVOO^cSb_C/ffEU>VEL:/[1WlZiSoclm7In
G9nOOTa<>/[1ZIN?M/6iUoclm0Sdm>`02OCdm?C/fl6iQhMnE9nOOZVYSl6i
UkViUl6iU`02^KV?00>a/HnOSfgdm>`00_clm004m?Cdo?cdm?Cdm?Cd0_cl
m004m?Cdo?cdo?cdm?Cd0_clm0;dm?@02?clm?Cdm?clm?clm?Cdm?clm?Cd
m?clm0;dm?@07_clm?Cdm?clm9nOSncSbUb7SiN?Qoooooclm?Cdm?ooooC/
fm:aScXj8XmfA9nOO^cK`OoooncK/KViSdA4:XMU<^cK`OoooncK`OooohMn
E=;:`OooooCdm0;lo?@01?Cdm?clm?clm?Cdm0;lo?@01OCdm?clm>clm?cl
m?Cdm002o?cd013dm?Cooom<A29<A28b:R:iWgkoooodk=/jA1TZ8QU]IB;d
m>clo?CSdYooooodm?@2o?cd00Kdm?Clo?Cdm?Cdm>clo?CSd[42b/6Y00SB
bZW/hl[B/HoSZHoKQfGSd[7:`Iolo?@2hm_K00?/k>?dm>clo?@00_clm007
oooom?Cdo?cdo?cdm?C/o?cdm?C/00Olo?@00oCdk?clm?clm002o?cd00oo
ooo/hl[/hl[lo?Cdm>biWgiUE38jE5aLKHMUQjV7OXlRIJVOUhLjG7IDQk40
1?clm005m?Cdo?cdo?cdo?cdm?Cd00Wlo?@01?Cdm?clm?clm?Cdm0;lo?@0
1?Cdm?clm<6iQoC/f`;lo?Agc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^3?<c<`01DaDKC94MTA4C38jA394MP02A4A<00<jE8LbA7I<E6d00S94
MP8I6A42Sini01:G^LZid]^Yb];<c<ba/KW1/KW:^HoKQfFiWgkKQfGKMS;K
QfF?Qfe]MWJ?QfenOVenG4a<C4@2C4`j00a<C4AnKFF?QffYZHoBb/7/hl[/
k>?lo?Cdm?C/k>?dm?Cdm>`3m?Cd0oclm005MWiL^KV?m>?:k=_1b/6O00;/
fk402NcK`OCdk?Cdk?clm>?Kfea]M^cK/Oooooclm006m?Cd00?/k>?Sd[7d
m?@00_Cdm005o?cdm?Cdm?Cdm?Cdo?cd00;dm?@01?clm;ViUff7OVf7OP9]
SiL014a<>P0006efMVf?U`9]OXl01Vf7OWj?Sff7O[VaWoooonc/h`?dm>`0
:nc/hoCdk>c/hnc/hoooob8R4CY46FED<TA4:T@j:T@j8SXj8QTR8SXj8T@j
:TA4:TA4<Ta<>TA4<T@j:RXA22XR6CXj<TA4<Ta<>Ta<A4@Z8Xn7KK6aSn?B
/OCdk4a<A6E<6KViUkVOO_ooogInG9N?QfEL:/6iWhn7KL6iQoclm00:m?C/
00?1^HN?MSZ7OU@00VEU>P07IE`ZKFeDMWiLWin?b/6YWimnk>cS00;lo?@0
0oCdm?clm?Cdm002o?cd00Cdm?Clo?Clo?Cdm?@:o?cd00Gdm?Clo?Clo?Cd
m?Clo?@00_Cdm003ooooWimnm?C/009]Qgh5o?cd013KbYm<A29UICZOWgkS
d[7oooodk=_1^HMUG1UfOUcK/JWoooo/fk7ooonGSgKBb/44o?cd00Gdm?Cl
o?Cdm?Clo?Cdm?@00oclm003m?Cdo?cdo?cd00;lo?@04oCdm?ooofE<6CY4
6FEL6In?KOooooclm9MnE;VGE<6iQoC/foooon?BWoooooclm?Cdm?clm?Cd
m002o?cd00Gdm>clo?Cdk=_/fl7/hlX00^?B/@06hm;1hm:ahm;1d/ZY`KVG
m?C/0_clm003m?C/k>cSm?C/00?dm>`00oclm?Cdm?clm005o?cd00?dm>cl
o?Clo?@00_clm00Eooooo?cdo?cdd/ZYo?cd`K6?OUa<C5A]E7JGWjVYhm:a
8VFY<WJaKHniIHNYKHnG8VFYA3XZ<TAfKHnim?C/00Wlo?@00oCdm?clm?cl
m002o?cd00?dm?Clo?Clo?@02?clm004fk6Om>cKo?cdm>cKMlc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00A4A4a<E6db>T@b>T@2<TAf
00Q4A4aLOYLjE8LbA7I<KIMDMYLI8S8jE5`2<RXR00>7UjVYb]:a/KT00ZW1
bP03UkW:ZL[BZL[B00:Yb]801lc<c;VOO/6aWfEL:WinKHn7KInOS`02Uhn7
00^OWginMVELG4aUICY<C4A<C3YLG4c1/Iooooolo?Cdm>`00_clm009k>?:
hm;1hm:Od/ZYb/6O^K6OMWiLUhmfm>?:00;Sd[404l[1WncSb^cK/OCdk?Cd
m?clm?C/fdafO^?B/OooooCdk?clm?ooooclm?ooooclm?Cdk>c/hn?B`@02
m?Cd00Clo?Cdm?Cdm?Clo?@5m?Cd00CSd/7Sfm_dk=_Sd/42k>?:00[Bb/54
>R9]Qgi]OXm]SiMnShm]SiMnShnYZHooool5m?C/013dm?Cdm>cdm>cooolj
A1TI6A5UICYUE38j>R94>RY<A28I8R8R8Q4jA38j>S94A2X2A4@b00E4A2Y4
>RY<A294A394A4`00TA4<P0A<RXRSgIDZJV?fl6OooooIE`ZA3XR`KVG^Imn
ooooQgiDSiN?IFDj^KV?ZJV?Uhmfo?cd00;dm>`01?clm?Cdk?Cdk?clm0Cd
m>`03<[1WhmfA8MU<Xmf>VE<6HMU<VED<XMU<XMD:YN?MYnOO^cK`@;dm?@0
1Oclm?Cdm?clm?Cdm?clm002m?Cd00Glo?Cdm?Cdm?Cdm?Clo?@00oCdm006
o?cdm?Cdo?cdm?Cdo?cdm?Cd0_clm009m?Cdo?cdm?CdooooUhmfo?cdKHMn
KGIfo?cd00Cdm?@04N?BWfEU>VEU>YnOO]^aZOooooC/fm_:WdA4:Ve]E<6i
UooooncK/Ooook6aSk6iUoooo`02m?Cd00Clo?Cdm?Clo?Cdm?@4o?cd0oCd
m009o?cdm?Cdo?cdm?Cdoooo`KV7/HMUflZO`KV700;oool01oCSb_C/fncS
b];:`LZiSl6iQoclm002k?cd00Wdm?Clo?Cdm?Cdm?Cdm>cdm?Clo?Cdm?Cl
o?@00_Cdm006o?cdm?C/m?C/m>cKk=_1k>?:0_Cdk003o?cdm?C/m?Cd00;d
m?@3o?cd00?dm>clo?Clo?@00_clm0;oool2m>cK01[ooooB/Hn?Qfg/k>>i
WginMVE]SkU<C4A]SkUDQk7<c<`AE:VOZJTjIIM]SiNG^LZOWhn7OXlAE:TR
IJUDQk5UUk7/k>?lo?Cdm?Clo?@2m?Cd0_clm004m?Cdo?cdo?cdm?Cd1?cl
m006m?Cdo?cdm?Cdo?cdm?Cdo?cd0_Cdm0;lo?@01=_1WncSb_C/foclm7O<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c00:C5A]<TAfA4A<
G7jG<TAfA4A<<TAfG7jG>UB7C6fG0VF7Z@0;C6f7>UafC6f7C5A]QiNYZL7:
UkW:ZL7:UkW:ZL7:UkW:00>Y`LX04ZW:d/ZaZM^OKNcK/L6a^JVYSgiUE6e]
E6EU>Vf7OYN?MZVYSiN?MYN?QgifIFe]E6ED<];:Z@;:`Il00l6iUl[1Wn?B
/@02d/[100S/hl[Sd/7<c<b?Uhna^IO/hl[Sd/7/hlX2hm:a01;SdYodm>cd
m>clo?Ba^Im4A4c1/Iooooolo?Cdk=_dm>c/hl[Bb/7/hl[oooo/k>?Sd/7l
o?@2m?Cd00Glo?Cdm?Cdm?Cdm?Clo?@00oCdm005m?C/m?Cdo?cdoooom?Cd
00;oool02K5]6OC/fgj?Sff7OVf?Ugj?Sff?UinOSoooo`07m?Cd00W/o?Co
oomUG1TjA1UUE39<C3Y4A2Y4>RY<A2800RXR6@94>RX014A4:T@j:TA4<SXj
<P94A2X05CXj<SY4<T@j:Ta<>SY46FED<[VOO/6aWoooocY46B8R4L[1WiN?
M_ooogInG9nOSdA4:ZVYSinGQin7KOooo`03m?C/00?lo?Cdm>cdm>`00oCd
k00Bm?Cdm>?:UgiD^IMDSgHjIE@bWgi<OVe<G3XRUhmfSgHjWiN7hm:aoooo
o?cdm?Cdo?cdm?Cd0oclm005m?Cdo?cdo?cdo?cdm?Cd00?lo?@01?Cdm?cl
m?clm?Cdm0Clo?@02_Cdm?clm?Cdm?clm?ooohn7KOooom;:`KViZOooo`;l
o?@04oCdm?ooon?BWgInG5aLC9nOSl6aSoooooclm9n?KDA4:VEU>[VOO_oo
oncK/Ooool[1ZInOSoooo`03o?cd00Kdm?Clo?Clo?Cdm?Clo?Cdm?@2o?cd
00?dm?Clo?Clo?@00_clm00@m?Cdoooom>?:m>cKk>?:d/[1^K6O`KV7^Imn
/HMU`KV7fl6Om>?:k>cSk?cdo?cd0_Cdm0?lo?@01OCdm?clm?Cdm?clm?Cd
k004o?cd0_Cdm005ooooo?cdo?cdo?cdm?Cd00Olo?@08Oooooclm?ooom;:
`Oclm<6iUgiLC3YDG5b7ShnO^OCdk>cSbTan/D@j:Ta]QaUL/Ea]MQU]/HNG
ZM;:ZA5DZHNGZFenSa5DZAUDOS9UZHnGSb9f^HNO/KViUaUL/Lc<c?ooo`0H
o?cd00C/fl7/hl[lo?Clo?Agc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^3?<c<`01TaDKCYDQea]QfF7ZCYDQda]Q`9DMYL02S94MUa]QgJG/FF7
ZFf?/GjO^FF7ZFenSjW:dXna`@BG^LX059o1/INibYNibZW1bYNibYo1/KVG
KNcK`M_1Woclm>c/hoC/flc<c;6iZGi]IFEL:VEU>Xn7KInYZIN?Q`;Bb/42
hm;100cSfm_<c<c1/KVa^JVOWhnOUhNOWgjOSffiUeCKWfg:`JWSd/42hm:a
00CBb/7KbYo/hl[dk=/2m>?:00=<E6g1^IN7b[401A6OQ`04A9n?o?cdhm:a
hm;10_Cdm004o?cdm?Cdm?Cdo?cd1OCdm003m>cKm?C/m?Cd00?dm?@03Ooo
om]f<_ooooclm9nYZFf7OVf?Ugj?Shn7KOooooCdm?CSb_Cdk004m?Cd013d
m>cooom]IB8I6A5UICYUG2Y4A2Y4>RXj>R8R<RXR8Q4jA38j>S94A38j>S94
A382A3XZ01Hj>S8j>R94>RXj>S94A394>RYUE3:a^INi^Holo?@jA1TR8Q71
^HNGSgKooonGOUB?UhmUG2ZOWhnOUhNGOUCoool5m?C/01;lo?Cdm>clo?Cd
m>cdm?C/fk7:`Ini^INGSgJa/Ho1^HMUC1V7IC:GSgJ7C16iWgkK`Iooool2
m?Cd00Klo?Cdm?Clo?Clo?Cdm?Clo?@3m?Cd0_clm005m?Cdo?cdo?cdo?cd
m?Cd00;lo?@2m?Cd0_clm005m?Cdo?cdm?CdooooSiN?00;lo?@02n?B/Ooo
ooCdm?clm?Cdm?clm>?B/D@j8Ta<>TA4:YMnE002oooo00TjA1U4:R94A2ZO
Sfgoooo/fk7lo?CSd/6GSgH00_clm0?dm?@00oclm?Cdm?clm003o?cd0oCd
m0;lo?@02_Cdm?clm?oool6iQkVGKKVOO]_1Wn?B/OC/foclm0?oool02OCd
m?clm?Cdm?clm?Cdm?clm?Cdm?clm?Cdm003o?cd0_Cdm004o?cdm?Cdo?cd
m?Cd0_clm003m?Cdo?cdm?Cd00?lo?@3oooo013dk=_/fl7lo?B?SfGSfm^a
^IMnKDafUk6OWhmDQk4bM[6?WkUfUk5fUl7ooolRIJT3<WJa01>GShLRM[Uf
Uk6YZHlbM[5]Sk5]OXlRIJV?/L6OZJVGSgHIG;4I>WHjE5`bM[6a/KWooool
o?Cdm?@00_clm004m?Cdo?cdo?cdm?Cd3?clm008m?C/o?cdm?C/m>cKk=^a
b[6Ym>?:d/ZYMlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<
00E<KHLjE8MUQjTjG7IUQjT00eAfU`07C6fGE8NaIHNYG7jGIHNYG7jGOYni
00>?/L400iNibXna`INibP05UkW:0ZW1bP09ZL[BZL7:c<c<o?cdk>?:k>cS
k>?:m>cKo?cd00;Bb/402inGQfDb24a48WInG;6iZIN?QiN?MYn7KIMnE;VG
KLZ?<P02himD00[KSc;SWc[SWc[K/Io/hl[:`Io/hl[Sd/7/fk7Sd/42m>cK
00kdm>cdk=/IMTBOUhNG^L[/hl[:fm]4Whoooon?bYLAWhOoooo1^HO1/Il2
o?cd0_Cdm004o?cdm?Cdm?Cdo?cd0oCdm0;dm>`01_Cdm?ooooclm?ooon?B
`M^OK@;dm?@01Oclm>?KfhnGSff?UiN?MP02oooo00?SdYolo?Cdm?@01?Cd
m006ooooShMD0000IE`ZC4a4C4@R0SXj8P8I6AT2A3XZ00E4A2XjA394>RY4
A38b:R800T@j:P0D>T@bA4@Z>SXbA4@bIE@b/K6?^Imno?cd>T@I6ATA^Imn
WimnooooWhm]UhmfIFDjUhmfZJV?ShMDo?cd0_Cdk003o?cdm?C/o?cd00Gd
m>`04_CSb/6iQm_:Wk6iUkVOO[ViZKVOO[6iUkVOOYN?MYnOO/6iUooooocl
m?Cdm?clm?Cdm?clm0;dm?@6o?cd00?dm?Clo?Cdm?@01oclm0?dm?@01ocl
m?ooojVYSoCdm?oooncSb_clm002m?Cd00Olo?CooooSd[4jA1U4>R8j>R:?
MSX00_ooo`06IE`I>SXRA4@ZSgHjooook>?:0_C/f`04Uhmfm?C/o?cdm?Cd
1oclm003m?Cdo?cdk?cd00;lo?@01OCdm?clm?Cdm?Cdm?clm004oooo00?d
m?Clo?Cdm?@00oclm005m?Cdo?cdo?cdo?cdm?Cd00;lo?@01?Cdm?clm?Cd
m?Cdm0;lo?@01OCdm?clm?Cdm?clm?Cdm002o?cd01odm?Clo?Clo?Coooo1
^INOWgjGOUAnMVFYZHm<E6enWkVGShM<O[5]KEALOYLRM[V7Wk5UQjUnWkWd
m?Clo?@AE:WSd/6G^LY<KHLbIJUDQk6OUhLIG;5]Sk6YZHl00UB7/@06Qgj?
8VFY6DAn<VFYSiN?IHNY0XnO^@;dm>`Ao?cd00?dk=_dm>cdk=/00oCdk0;l
o?@01>c/hm;:`M_1WjUf<WO<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h<lc<c005G6f7C5A]E8NaC6fGG7jG009UQjT02eAfUfF7ZFF7ZFf?/GJG
/Ff?/GjO^HnO^Hna`INibXna`@06UkW:1JW1bP0QZL[B/L[:^KVYhm;1m?Cd
hm;1m?Cdm?C/m>cKm?C/m>cKm>?:himD^Gi<fhlbhimDfhlbhiljhimDfhlb
hiljdXLIhiljfhlbfgi<fhL8b[6Ym>cKm>?:`KVGk>?:hm:ahm;100;dk=/0
1OCdk<[1Wda<A8nGSjW1bP02o?cd00Y4WhoooooSd[4AWhOoooniWgk/hl[/
k>?dm?Clo?@2m?Cd00Glo?Cdm?Cdm?Cdm?C/o?@00_ooo`07k>cShm_Khm:a
b[6Y^GiDdT`0oooo00?dm?@2o?cd00BOZJU]Qgklo?Cdm?@2m>?:1OCdm00=
ooooWhm]4A4AIE`IIE@bC4`jA4@Z>SXR<RXR6ATIA3XR>T@bA3XZ0094A380
13Y4<T@j:SXj8SXj8P94>RX04CY4<T@j:T@j8[ViSkVOO_CSbR8R4C8Z8YnO
O[VOO_clm8n7E6f7OUaLC8mnKInOOXmfI@02o?cd2?Cdk00@o?cdm>cKShmU
OWIDWiN7/KVGb/6Y^KVG/KVGb/6O^KVGWimn^Imnoooom?Cdo?cd0_Cdm0?l
o?@01?Cdm?clm?Cdm?Cdm0;lo?@2m?Cd00Glo?Cdm?Clo?Cdm?Clo?@00_Cd
m0;lo?@02?Cdm?clm?Cdm?ooohnGSncSb_oooncSbP?lo?@01?Cdm?ooooCS
bSY46@94A2X03FE<6OooooooofEL6Da48WInG8mfA?ooooCSb^cSb_clm6ef
M_C/f`04m?Cd00Clo?Cdm?Clo?Cdm?@3o?cd00?dm?Clo?Clo?@01?clm0?d
m?@00oclm?Cdm?clm002o?cd0_Cdm005o?cdm?Cdm?Cdo?cdm?Cd00Clo?@0
2OCdm?clm?clm?clm?Cdm?clm?Cdm?clm?Cdm003o?cd01odm>c/k>?:fm_B
b/6?SfDAE:TRIJTIG;5<O[5nShlIKK6a^IlRM[TR<RXRM[TbM[5nWkU]SiMf
Ul6O`K6OUhLIKK6Y`L[dm>`AE:TbIJUUQjVa^ILRM[UUQjVOWgh00Tan/@05
WimnKHni/K6i/K6im?C/00?oool2o?cd00?dm?Clo?Clo?@02?clm0?dm>`0
1?C/foCdk?Cdk?Cdm0Clo?@01?Cdm?clm?Cdk?clm0?BbZUgc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^3?<c<`01Ua]QcYDQfF7ZDa]UfF7ZEAf
U`AUQjT2KHni0WjO^@03/K6iUkW:UkW:00FG^LX07JW1bYNibYNibZW1bYNi
bZW:dZW1bYo1/Hna`Ff7OYnYZIn?KL6a^M;:ZOC/fncSb_clm>?B`OCdm>?K
fn>YSm:76N>O8^>OE>>O>]:76N>O>^>OE=]nC002himD00?SWc[KSc;1/KT0
0^cSbP04hm:ab/6Ok>?:hm:a0oC/f`0>o?cdG5a<OWi]b]_KA9n?4In74InG
/KVY4InG4In7ooooWhm]hm;1hm_K0_Cdm00Bo?cdm?Cdm?Cdm?Cdk?cdoooo
o?cdfim]/FdIfim]fgHbfhMUfim]k=_1o?cdoooom?Cdo?cd0oCdm007o?cd
hm:am?C/ooood/ZYWhm]o?cd00?dm?@01^clm?oookViSa4A4DA4:VED<P94
A2X024@j:TA4:Q4A4C8Z8SXj<T@j:SXj<TA4<P94>RX02SXj<T@j:SXj<T@j
:SXj<T@j:S8Z8ZVYSl6iQm;:Z@8R8Q402iMnE;VOO_Cdk7InG6e]E6EU>XMn
E9nOOYN?M^c/hoCdm003m?C/00Slo?Cdm>cdm>cdm>clo?Cdm>clo?B?Qe@2
QfDb00Za/HmUG2Y]KEAnMUBa/Hni/InOUhNiWgkoooodm?@2o?cd00Gdm?Cl
o?Cdm?Clo?Cdm?@00_clm0;dm?@2o?cd00Gdm?Clo?Cdm?Clo?Cdm?@00_cl
m004m?Cdo?cdo?cdo?cd0_Cdm005oooohm:am>cKm?Cdk=_100;dm?@02?cl
m?Cdm?clm?C/fcY46FEL:Wi]C6eU8P;oool2`KV700WSd[7KbYooooolo?C/
fk7ooomfOUc/hl[oool00_clm003m?Cdo?cdm?Cd00?lo?@01OCdm?clm>cl
m?Cdm?clm002m?Cd00Clo?Cdm?Clo?Cdm?@2o?cd00?dm?Clo?Cdm?@00_cl
m004m?Cdo?cdo?cdm?Cd0oclm0;dm>`3o?cd00Soooolo?Cdk=_dhl[ooood
m>cdk=_Sfm/5b]_K01ba/KVi^JTAE:V?/L7:fm^a^JV?UhlIKK7:/JTRM[TR
<TADQk5<O[5]SkV7Wk4bM[6OZJTR8Q4RM[UnWkWlo?ADQk4RIJUfUk6OUhMD
Qk5]SkWSd[42c<c<0_clm003ooooo?cdo?cd00?dm?@5o?cd00?dm>clo?Cd
m>`00_Cdk003m>cKm?C/m?C/00?lo?@00oCdm?clm?clm002o?cd00?dm?Cl
o?Clo?@00oclm004m?C//K6?fl6O`KV7Mlc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Pcc<c<00=<E6e]OXmUQjT016F7Z@9]SkT01fF7ZFf?/GJG
/GjO^Hna`INibXna`@02UkW:0jW1bP:G^LX01ZW1bYNibZW1bYNibYo1/JW1
bPBG^LX03JW:dXNGZKViZEaLC;ViZJVYSm;:`OCdk>c/hnclm>?B`NbYM]^?
<P04himD00WSWc[SWeCSWc[KSc;KWfg:/JW/hl[/fl7dhlX00^?B/@0Chm;1
k>?:m?C/m>cKo?cdUhmfKHnGo?cdWjVY/L[:m>cKKHnGO/6G^KVYoooohm_K
flZOk=^aoooo00?dm?@02?clm?Cdm?oooncSb[5]6M^aWoclm?C/f`Coool5
m?Cd00Clo?Cdm?Cdm?Clo?@2m?Cd00?dm>b7IC;dk=/01?Cdm00:ooooflZO
0000>T@IIFDjG3XRA4@bA3XZ>SXR4A4A0T@j:P04>T@bA4@Z>SXb>SXb0T@j
:P0@>SXRA3XZ>SXRA3XZA4@Z>SXb:R8I>SXRIFDj:Q486ATISgID^KV?m>cK
G5a<KFeD0VEU>P04^KVGWin?m>?:m?Cd0_Cdk003o?cdm?C/m?C/00?dm>`0
4?Cdm?Cdk<6iQkViSimnC;ViUfeU8XMU<T@j8XMU<Wi]IJVYSin?KOoooocl
m?Cdm0;lo?@01?Cdm?clm?clm?Cdm0;lo?@01_Cdm?clm?clm?Cdm?clm?Cd
m0;lo?@00oCdm?clm?Cdm002o?cd0oCdm0;lo?@02?C/foCdk?oooncK`Ooo
ooCdm?clm?Cdm0;lo?@01<6iQkVGKL6iQlZiS`;oool04_C/foclm>?KfncS
b/[1ZKVOO]_1WoooogInG>?B/OooooCdm?clm?Cdm?clm?Cdm?clm?Cdm0?l
o?@00oCdm?clm?Cdm002o?cd00Odm?Clo?Cdm?Clo?Cdm?Clo?Cdm?@00ocl
m0;dm?@00oclm?Cdm?clm003o?cd0_ooo`08m?C/m>?:hm:O^ImnShmUOVeU
E6efOYni1L[Kf`0Nhncdb]_Kb]_K/L[:^K6O6EbaSk71b]_KWjVYWin?6Ffa
^KVY8WJi8VFYMYNaKHniC7jaUhn78WJi8SYL6CYfC7jaUkW:o?cd`K6iSini
k>cSm?C/m>cKk>cS0oclm003m?Cdo?cdm?C/00Glo?@01_Cdk?clm?Cdk?Cd
k>c/hoclm0;dm>`>o?cd1OCdk004o?cd/K6?m?C/o?cdMlc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Pcc<c<00`b:R9<E6e]SkUUQjUDMYMUQjU]
SkU]Sk5UQjUfUl5nWkULQhl5UkW:00>Y`LZG^LZG^LX00YNibP03ZL[BUkW:
ZL7:00JG^LX00jW1bYNibYNibP02UkW:00NYb]:OWhniUffGShNOUhOdm>c/
k><00_Cdm005fk6YfhlbhiljhimDhilj00CSWe@03lZiSl6a^N?B/N?B`NcS
b_CSb[ViSn?B/OC/foCdk?C/foclm9nYZFf7O_clm003oooo00Olo?Cooooo
ooodm?Cdk=_lo?C/hlX00_Cdm0;lo?@2m?Cd00KooonaKAW/fl7oooodm?Cd
k=/2m?Cd00Klo?Cdm?Cdm?Clo?Cdm?Clo?@4m?Cd00Olo?Cdm?Cdm?Coooo1
^HOdhl[oool01?Cdm00?k=_100006E@bOUa<C4`jA4@ZA4@b>SXR6ATI<RXR
A3XZ>T@b<SY4A3XZ>SXb00=4>RX01cY4<T@j:SXj<T@j:TA4:XMD:Q4A4@02
6ATA00`Z8QUL>R:a/HodhlYUG2YUICY<C3YUICZi^INOWgk/fk7dm?@4m?C/
00?lo?Cdm>clo?@00_Cdk00=o?cdflZOhm:aWimnb[6Y^KV?WimnShMDQfDb
OUa<^KVG^IM]oooo00;dm?@01Oclm?Cdm?Cdm?clm?Cdm002o?cd0_Cdm005
o?cdm?Cdo?cdo?cdm?Cd00;lo?@00oCdm?clm?clm002o?cd00Cdm?Clo?Cl
o?Clo?@2m?Cd00[dm>cdm?C/hl[lo?Cdm?Clo?Cdm?Clo?Cdm?Cdk=/2m?C/
013:fm_:`Ini^HniWgjaQfG1^HOB/HoSd/7dk=_dm>cooom]KEC:`JWooool
o?Cdm?@6o?cd00Cdm?Clo?C/o?Cdm?@2o?cd00_dm?Clo?Cdm?Clo?Cdm?Cl
o?Cdm?Clo?Cdm?Clo?Cdm?@00_clm003ooooo?cdk>?:00;lo?@03?Cdk8Mn
E7i]C7inKEA]MXNGZFenSaUL/Dan/EB7/GjO^N?/m0?:fm/03N?/m<[Kfl[K
fl[Kfk7:b[6aSb9f^GJG/KWBfinYZIN?QaU]/M;:Z@028WJi00ZOWhmDQk4b
M[6a^ILbM[5]SkVG^L[/k>?dm>cdm?@2oooo0oclm003m?Cdo?cdm?Cd00?l
o?@01_Cdk?clm?Cdk?C/foCdk?C/f`?dm>`3o?cd00Cdm?Clo?Clo?Cdm?@2
o?cd00?dm?Clo?Clo?@00_clm004m?C/o?cdm?C/m?C/0oclm005m?Cdo?cd
o?cdoooo^Imn00;lo?Agc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^3?<c<`03S8Z8P0008NGZGJG`EB7/FF7ZHna`GJG`HNO/EAnOR8R4@000;WB
fhna`@:G^LX018na`JW1bYNibYo1/@:Y`LX00io1/JW1bZW1bP06UkW:0Xna
`@>G^LX038na`JW1bZW1b^>YSkVGKM:aSn>YSn?B/NcK`N?KfncK`M^OK@KS
We@02/ZaZM^aWn?B`N?B/N?B`NcK`OC/fl6iQoC/fncSbP;dk=/016f7OUA]
M_clm7k1U`94Whl02A6OQgk1Uk6iZOooon?KfoCdm>cSb_Cdm?clm002m?Cd
00Glo?Cdm?Cdm>cSZHooool00_Cdm005m>cKo?cdo?cdm?Cdo?cd00?dm?@0
0oclm?Cdm?clm004m?Cd00Glo?Cdm?Clo?BO`K7lo?@01?Cdm004o?cd>T@I
8R8AIFDj0TA4<P0;A3XZA3XR6ATI<RXRA3XZA4@Z>SXbA3XZA4@Z>SXbA3XZ
008j>S8034@j:SXj<T@j8RXR6OC/fl6iUinOOS8Z8RXA23Xj8TA4:WInG09<
A2801TA4:T@Z8YnOOYnGQm;:ZOooo`;dm>`00oclm?Cdk?Cdk004m?C/00cl
o?CB/HoSd[6OWgja^Io:`JVi/InOWgji^INiWgji^JVOUhL3o?cd0_Cdm0;l
o?@3m?Cd00?lo?Cdm?Clo?@00_clm00Bm?Cdo?cdm?Cdo?cdm?Cdo?cdm?Cd
o?cdm?Cdo?cdm?Cdo?cdm?Cdo?cdm?Cdk>?:ooook=_10_clm00;m?Cdo?cd
m?Cdoooo^IMD/HMU^IM]b[V?hm:am>?:o?cd00Goool01Oclm?ooogInG;6i
Woooo`02o?cd00Cdm?Clo?Cdm?Cdm?@4o?cd00G/o?Cdm?Cdm?Clo?Cdm?@0
0_clm005m?C/o?cdo?cdm?Cdoooo00;lo?@04oCdk?C/foclm;ViZHmf:TaD
KFF7ZHna`L[1ZHnGSc9UZA5DZEB7/GJG/HNO/B9UZNc/hl[KfoCdm004b]_K
01Kdm>c/k>?:fm_/k>?:fm^a^ILbM[5]SkVid]^a^JVOUhLRM[VOZJTbM[5D
Qk7/fl6i^JVa/KW/k>?dm>clo?Coool2o?cd0_Cdm0;lo?@00oCdk?clm?cl
m003m?C/00?dk=_dm>cdm>`00_Cdk004o?cdm?C/o?cdm?Cd0oclm003m?Cd
o?cdo?cd00Olo?@2m?C/0oclm004m?Cdo?cdo?cdm?Cd0_clm004m?Cdo?cd
oooo^Imn0_clm7O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<
c004:R8I8R8A0000A4@b0VenS`08C5A]>SXR:Q484A4A:Q48Qgj?ZL7:Sk71
0YNibP03/K6iUkW:UkW:00ZG^LX00hna`INibYNibP08UkW:00_:/JVa^ING
OUC:Sc:aKAW/ZGKKWfgKOTcSWeCSWc[/ZD`01>>OE008hiljk=^ak>?:b/6O
k>?:k=_1hm;1k>?:0_CSbP0>o?cdMWiLE6efo?cdSlZGWl6a/L[:c<c<QlZa
4In7d/[1m>cKhm_Kk>?:0_Cdm00<o?cdm?Cdm?Cdk?cdm>cKfk6Ooooom?Cd
o?cdm?C/m?Cdo?cd0_Cdm003o?cdm?Cdm?Cd00Gdm?@00oclm?Cdm?Cdm002
m?Cd00=n`IOlo?Cdm?@00_Cdm00Ao?cdm>cK6E@b>T@IShMDIFDj>SXRA4@Z
>T@b6ATI:R8IA4@ZA3XZ>SXbA4@Z>SXR>SXb0094>RX05CXj8T@j:T@j:TA4
:S8Z8XmfIKViUm;:`N?B`KVOOVeU8RXA21TI6B8b:S8Z8T@j8SXj8[VOO[Va
Wl[1Woclm003m?C/00?lo?Cdm>cdm>`00oCdk005o?cdd/ZYUgiDWiN7QgiD
00:GSgH01ZVYSlZaZKViSk6iUkVOO_clm0;dm?@2o?cd00?dm?Clo?Clo?@0
1?clm005m?Cdo?cdo?cdo?cdm?Cd00;lo?@00oCdm?clm?Cdm004o?cd00Sd
m?Clo?Cdm?Cdm?C/hl[oooo/fl7dm?@2o?cd00Cdm?Clo?Cdm?Clo?@4oooo
00clo?Cdm?Clo?Cdm?Clo?Cdm?Clo?Cdm?Cooon7OUBOWhooool3m?Cd0_cl
m0;dm?@01?clm?Cdm?Cdm?Cdk0?lo?@00oCdm?clm?ooo`03o?cd01C/hlZO
Sfgdm>c/hl[1/Hm]OXna/KU<8PQnWkTbIJW1/KTbIJUfUk6a^ILRIJVG^L[/
o?BOZJVOWhlIG;426EAn00A]SkWdm>c:fm_/k><2hncd00Olo?BYb]:id]_:
fm_/fl5<KILbM[400[7:bP05^KVYQiNYc<c<hm_Km?C/00?oool8o?cd0oCd
k006m>cKm?C/m>cKhm:ao?cdm?Cd0_clm003m?Cdo?cdm?Cd00;lo?@00oC/
foCdk?Cdk003o?cd00Odm?Clo?Cdm>clo?Cdm>clo?Cdm>`00oclm005m?Cd
o?cdo?cdo?cdm?Cd00Klo?@01?oookVGKOclm>c1QgO<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h<lc<c00<:R8I<RXR8R8A:Q48C5A]C4a4A4@b
6ATA4A4A8R8ASiniZL[B6YNibP0<ZL7:UkW:UkW:/L[:d/[1Whm]/HMUbXlb
fk6Om>?:fim]hilj1>>OE003k:U<hiljfl6O00;/hlX02l6iQoCSb^cK`NcK
/NcSb_C/foclm;6iUcY4C>cSb_Cdm004oooo00FO`K5n`IOooooSd[7:`JT0
0_clm0Cdm?@00oooom^OKOooo`02m?Cd00Wdm>cdm?Clo?Cdm?Clo?Cdm?Cl
o?Cdm?Clo?@00_Cdm004o?cdm?Cdm?Cdo?cd0_Cdm003ooooO/6Ghm_K00?d
m?@01nclm?oooaTI4BXA29n?KHMU<Ta<>P02A4@Z00DI8R8A4A54A2Xj>S94
A2X014@j:P07>SXRA3XZA3XZ>T@b>SXR8S8ZOVe<00:OUhL03InOO];:ZNcS
b];:`In?KFE<6CY46D@j8U`j8VEU>YnOSkVOO_ooo`09m?C/00glo?CBbZVY
ZHo1^In?QfeUC1U]IB:OQffOUhO1/Ina/HnGSgKdk=/00_clm0?dm?@01?cl
m?Cdm?Cdm?clm0;dm?@2o?cd00[dm?Clo?Cdm?Clo?Cdm?Clo?Cdm?Clo?Cd
m?Clo?@3m?Cd00Olo?Cdm?Clo?C/fl7oooo/fl7oool00_Cdm005o?cdm?Cd
o?cdm?Cdo?cd00;dm?@05_clm?Cdm?clm?Cdm?clm?Cdm?clm?Cdm?clm?oo
oin?KHnGSoooooclm?Cdm?clm?Cdk?Cdm?clm?Cdk?clm?Cdk0?oool3o?cd
023dm>b?MTALG4a]MWKdm>c/fl6GShLbIJW1/KWBbZTAE:U]SiMDKGHAE:VY
b];dhlZab/XAE:Va^IlbIJUnWkW:fm^OZJVOWhlRM[UnWkV?/L6Y`L[dm?CS
k?C:fm_/k><2b]_K0ZW:dP05^M;Khm:aWjVY/K6im?C/00;lo?@2oooo0_cl
m003m?Cdo?cdo?cd00?lo?@2m?C/00Cdk=_dm>cdk=_lo?@2m?Cd00Glo?Cd
m?Clo?CSd[7dm?@00_clm003m?C/m>cKm>cK00;dk=/01OCdk?clm?CSb_Cd
m?clm002m?C/0oclm003m?Cdo?cdo?cd00?lo?@00oCdm?clm?clm004o?cd
00?dm?Clo?Cdm?@00_clm004oooo^Imnk>cSo?cdMlc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Pcc<c<00DR:RXZ8QTR8Q54A4a<MWh00TA4C008
C5A]OVeUUgiDZL7:UkW:Sk71UkW:/K6i4iNibP03ZL7:UkW:ZL7:00:G^LX0
39o1/INibYNibZW1b]_1Wm^OKM^?<[VOO^?/m?C/fm]nC>>O>PCSWe@06N>O
>]_1WncK`NcSb];:`N?B/NcK`N?B`OC/fncSb_Cdk>cSbUA]M]^aZK6iWocl
m?ooooCdm?oooio1/Gk1UoooooCdk;VOO_ooo`02m?Cd00Glo?Cdm?Cdm?Co
ooo:MR800oCdm0;lo?@2m?Cd00?lo?Cdm?Cdm?@00oCdm004o?cdm?Cdm?Cd
o?cd0oCdm004ooooWl6ad/[1o?cd0oCdm006oooo8R8A6E@bOWIUKHMnC4`j
0T@j8P0P<RXR:R8IA3XZ>SXbA4@ZA3XZ>SXb>T@b>SXbA3XZA4@ZA3XZ>SXb
>T@b<RXROVe<WiN7ShM]Whm]OWIU/KVG`K6Ok>?:hm:ad/ZYShM]ID`I:R8I
A4@Z^Imnoooom?Cd0oCdk00?o?cdm?C/m>cKm>cKm?C/m>cKd/ZYhm:a^K6O
^ImnZJV?Whm]ShmUC4`jUhmf00:a^IL01>cK`OCdm?Cdm?Cdm0?lo?@02?Cd
m?clm?clm?Cdm?clm?Cdm?clm?Cdm0;lo?@01OCdm?clm?Cdm?clm?Cdm002
o?cd00Cdm?Clo?Clo?Cdm?@2o?cd00?/fl7dm?CdhlX00_Cdm005o?cdm?Cd
o?cdm?Cdo?cd00;dm?@04_clm?Cdm?clm?Cdm?clm?Cdm?clm?Cdm?clm?Cd
m?oook6aSff7O_ooooCdk?clm?Cdm?ooo`Clo?@09oooooclm8mfE7iLC7i]
IN?Kfm;:`HmfA5AfUc9UZGJG/B9UZM;:`K6iWa5DZL[Kfm;:ZA5DZFenSinY
ZA5DZK7:b[6iUea]QaUL/K6iWfF7ZDan/N?/m9nYZInOSaU]/HnGSgj?Shna
`Nclm>?/m>c/hn?/m003k>cS00?dm>clo?Clo?@00_ooo`;dm?@6o?cd1?Cd
k003m>cKm?C/o?cd00;dm?@4o?cd00Cdm?Clo?Clo?C/fk43m>cK0_Cdk0?o
ool2o?cd00?/fk7dm>cdm?@00oclm005m?Cdo?cdo?cdo?cdm?Cd00Klo?@0
1?Cdm?clm?clm?Cdm0Clo?@01OCdm?oookVOO^c/hoclm01gc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^3?<c<`03S8Z8RXR6ATI6DA4C8lbC4aD
KDa<A5aLC7InG5`j8VED<XNGZJW:dXna`@BG^LX00jW:dYNibYNibP02ZL7:
0YNibP03ZL7:UkW:ZL7:00:G^LX00jW1bYNibYNibP03UkW:00>Y`LZYb]:Y
`LX00jW1bP06UkW:ZL[B^M;KhjV?fim]k>cS0_Cdm004k:UfhiljhimDk:U<
0^>OE008hjV?hm:ak>?:k>?:hm:ab/6Yhm:ak>?:0_C/f`05o?cd/KVG^KV?
oooohm_K00;/hlX028O:/A6OQkViZOooooC/fn?B`OCdm?clm0?dm?@01?oo
om^OKM^aZOooo`;lo?@01_Cdm?Cdk?clm?clm?Cdm?clm0;dm?@01?clm?Cd
m?Cdm?clm0?dm?@01_clm?Cdm?Cdm>c/hhO:/OC/f`?dm?@03oooocY46B8R
4GInG5a]MTa<>Ta48SY4<QTR8Q4A4D@j:TA4<SY4C4@j:SY4<P03A3XZ00Xj
A4`j>S94>RY4>RXR<RYL>R:i^INYZHn?QffOSfd2Wimn00ViWgja^IO:`JW/
hl[Bb/6i^IMUG2YUC1Woool00oC/f`03m?C/m>cKm?C/00?dm>`03_ooon?B
Wm;:ZL6iUkViUk6iWl6aWkViShn?IKVOO[6iUjVYSn?B`Oooo`;lo?@2m?Cd
0_clm0;dm?@00oclm?Cdm?clm002o?cd0_Cdm004o?cdm?Cdo?cdo?cd0_Cd
m0;lo?@2m?Cd00glo?Cdm?Cdm?C/hl[dm>c/hl[oooolo?Cdm?Clo?Cdm?Cl
o?Cdm?@00_clm0;dm?@02oclm?Cdm?Cdm?clm?Cdm?clm?Cdm?clm?oool[1
ZGInG003oooo037dm>cSd[7lo?Cdm>c1^HN?OVg/k>>?SfE]OXlIG;6?WkTI
G;6?Qfe]MWHAE:Wdm>cooon?WkUDQk7:`JTIG;4jG7HI8S8AE:UUQjVi^JTA
E:VYb];1/KU]QghAE:VOWhm]Sk5<O[7:fm^?UhnOWhlIKK4IG;4bIJU<KIOS
fm_/k>?dm>clo?Cdm?Clo?Cdm?Clo?@00_Cdm004o?cdm?Cdo?cdo?cd0_Cd
k008m>cKm?C/m?C/m?C/o?cdm?Cdo?cdm?Cd1Oclm00;m?Cdo?cdm?Cdm?Cd
o?cdm?Cdo?cdm>?:m?C/o?cdoooo00;lo?@02?C/fk6a^InOShn?IOooooCS
b_Cdk?clm0;dm?@:o?cd00Cdm?Clo?Clo?Cdm?@3o?cd00Sdm?Clo?Cdm?Cl
o?Coooo:^HoSd/7lo?Agc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^3?<c<`0538Z8QTI6BXA26efMUaLC4A4C4a<>TaDKGi]IE`j8Ta<A;6a^K7:
bYNibZW1bYNibZW1bYNibYo1/JW1bP>G^LX01JW:dYNibYNibZW1bYNibP02
ZL[B1jW1bP03ZL[BZL7:ZL[B00:Y`LX02JW:dZW1bYNibZW:d/6iUm;:`L[1
ZM;:`KViZ@02b[V?00Fa/HoKWfg/ZDcKWfgBbZT00n?B`@03b/6Yb/6Om>cK
00?/hlX00l[1ZKVOOXO:/@034In700I4WhnO`K7oooodm?C/k>?Sd/42m?Cd
00Klo?Cdm?Clo?C/o?CKOTcoool3m?Cd00Olo?Cdk=_dm?Cdm?Clo?Cdm?Cl
o?@01_Cdm003o?cdm?Cdm?Cd00;dm?@03?clm7k1Ul[Kfoclm?Cdk>clm?oo
ofEL6@0007ifIGinKDa<>P94A2X02C8Z8QTI6DA4:T@j:SXj<TA4:SXj<T@j
:SXj<P02A3XZ00Tj>S94>RXj>S94>RY4>R;1^InOUhNOWgj?Qfd00[6aS`09
WimnUhmf^Imn/KVGb[6Yhm:ak>?:`KVGo?cd00?dm>`3m?Cd0oCdk00>oooo
hm:Od/ZY^KV?b/6OShmUWimn^KVG/KVGShM]/K6?Win?hm:ao?cd0_Cdm004
o?cdm?Cdo?cdm?Cd0_clm0?dm?@01oclm?Cdm?clm?clm?Cdm?clm?Cdm002
o?cd00?dm?Clo?Cdm?@00_clm007m?Cdo?cdo?cdm?C/d/ZYo?cdm?Cd00;l
o?@01oCdm?clm?Cdm?Cdm?clm?Cdm?clm002m?Cd0oclm003m?C/o?cdoooo
00;lo?@05;VaWgInG?ooohm]C8n?IOC/fcYDG<[KfoCdk?CSbS9UZFf?^GIn
G1UL/JW:d^cSbSYUUc94MSYUUeB7/@?:fm/05[6a^M;:ZB9UZB9UZB9f^Dan
/C9UZL[1ZB9UZHna`L[1ZGj?SaU]/InOSff?UaU]/KWBflc<c>?B/K6a^N?K
fnc/h`;lo?@00oCdm?clm?Cdm005o?cd0_Cdk0;dk=/2m?C/00Clo?Cdm?Cl
o?Cdm?@3o?cd00?dm?Clo?Cdm?@00_clm004m?Cdo?cdm?Cdm?Cd1Oclm00>
hm:Om>cKk>?:SiN?^K6Ooooom>cKIINaKHnaMWiLoooom>cKk>?:oooo0_cl
m005m?Cdo?cdo?cdo?cdm?Cd00;lo?@00oCdm?clm?clm002o?cd00Cdm?Cl
o?Clo?Cdm?@6o?cd00?SdYoSd/7lo?@0Mlc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Pcc<c<00HZ8QTb:R8I6AU4:R8bA7ILG4`2C5A]0VED<P04
KFeDOVeU/KVY/K6i3INibP05ZL7:UkW:Wl6aZL7:UkW:00ZY`LX01:W:dYN?
QkViUm_1W`;Bb/403M;:ZNcSb^c/hncSb]^aWnbYM^>OE>bYC=^OKIN?M^?B
`NcSb^?B`@04k>?:00KKbYoSd[7Sd[6GSgKdm?Cdk=/2o?cd0oooo`06m?Cd
k>cSm>cKm?C/m?Cdo?cd0oCdm00:fhMUoooom?Cdm?Cdo?cdm?Cdm>cKo?cd
m?Cdo?cd0oCdm004o?cdm?Cdm?Cdo?cd0_Cdm00Jo?cdm?Cdm?Cdm?Cdoooo
QlZaUkW:o?cdm?Cdm?C/ooooSgHZ6E@bMWiLG6efC4a4A3XRA4@Z8S8Z6ATA
>SXbA3XZ>SXbA3XZ>SXb>SXR0T@j:P0=>SXbA3XZ>T@b>T@bA3XZA3XR`KVO
ZJV?/K6?WimnWhm]WiN7Wimn00:YZHl01inOOZVYSk6aSinOO/[1Woclm?Cd
m008m?C/01Clo?CKbYoBbZVYZHni/InOWgjiUffa/HnOUhNi^INYZHna/HoK
/JWoooodm?Clo?Cdm?Clo?Cdm?Cdm>`2m?Cd00?lo?Cdm?Clo?@00_clm00:
m?Cdo?cdm?Cdo?cdm?Cdo?cdm?Cdo?cdm?Cdo?cd0_Cdm0;lo?@01?Cdm?cl
m?Cdm?Cdm0;lo?@2m?Cd00?lo?Cdm?Clo?@00oCdm0;lo?@00oCdm?Cdk?cl
m002o?cd01MnKDcSd[7K/Im<C4ADOWk/hl[Bb/4bIJWBb/5UQjUDQk7lo?BO
WghIKK5]SkWSd/4AE:TjE5`b>T@IG;6a^ImUQjUDQk400/c<c00AQiNY/K6i
d/[18VFYUkW:k>?:KGj?6Ebab/6Y<WJaKHni`K6iZJV?E8Nafl6Od/[1`K6i
00?lo?@01?ooooclm?ooooCdk0;lo?@01?Cdm?clm?Cdk?Cdk0;dk=/2m?C/
00Glo?Cdm?Clo?Clo?Cdm?@01Oclm003m?Cdo?cdo?cd00Glo?@00oCdm?cl
m?clm004m?C/013lo?CBbZWlo?CBb/5<OXnYZHooooodm>`j>R8Z8QUfOUco
ooodm>c/fl7oooodm?@2o?cd00?dm?Clo?Cdm?@00_clm005m?Cdo?cdo?cd
o?cdm?Cd00Klo?@2m?Cd00Klo?Cdm?Coooo/fl7:`JWlo?Agc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^3?<c<`03ATR8RXR6ATI6Da<>UaLC4aD
KEa]MTaDKHMD:U`j8[67IOC/finOS`02Sk7100>G^LZ?/L6G^LX029NibP03
ZL7:UkW:UkW:00:G^LX00hna`INibXna`@02UkW:00B?/L6G^LZG^LZG^LX2
Sk710YNibP05ZL[BUkW:Sk71hm;1d/[100;Sfm/00n?B/M^aWn>OE003hilj
00B?OVfYZHoBb/7/fl42hm;100?/hl[/k>?dk=/00^cSbP05hm:am?Cdm>cK
b]_Kd/[100:O`K401Ho:Uoclm?Cdk>?KfoCdk002m?Cd00Olo?Cdm?Coooo:
MR;oooo/o?Clo?@00_Cdm006o?cdm?Cdm?Cdo?cdm?Cdo?cd0_Cdm005o?cd
m?Cdm?Cdm?Cdo?cd00Cdm?@01?clm<c<c8O:/Oclm0;dm?@02oooohmfA000
07InG6efMVED<Ta<A4A4:S8Z8QTR8SXj8P02A4@b0TA4:P0A>SXR>T@I>SXR
A4@bA3XZ>SXbA3XZ<RXR:R8Ib[6YWiN7/K6?WiN7/K6?WiN7/K6?ZJV?00:O
Wgh01KViUjVYShn7KHn?IOclm009m?C/00?lo?CSd[7BbZT00/6aS`09`KVO
Whm]/KVG/K6?ZJV?/KVO^K6O`KV7oooo00;dm?@01_clm?Cdm?clm?clm?Cd
m?clm0;dm?@2o?cd00[dm?Clo?Cdm?Clo?Cdm?Clo?Cdm?Clo?Cdm?Clo?@2
m?Cd00?lo?Cdm?Cdm?@00_Cdm0;lo?@3m?Cd00_lo?Cdm?Clo?Cdm?Clo?Cd
k=_/hl[dm>cdk=_dhlYUG2X00_Cdk006m>?:OXn?<VFYk>cSE8NaE6ef0^cS
bP0MC7jac<c<Qina4EBY>UAL6B9<6FfaUkW:WjVYOVeU>UB76Eba<WJao?cd
c<c<<VFY/K6iMWiL8SYL<WJab/6Y<VFYMYO1d/[1KGj?>VFGk=_1WjVYc<c<
00?lo?@00oooooclm?clm003o?cd00?dm>clo?Cdm>`00_Cdk0;dk=/02?cl
m?Cdk?clm?Cdm?clm?Cdm?clm?Cdm0;lo?@01_Cdm?clm?clm?Cdm?clm?Cd
k0Clo?@02OCdm?clm?clm?Cdk?Cdm?clm?Cdk?clm?Cdm003o?cd00Kdm>c/
fk7dk=_dhlYDMYNOZJT2oooo00YLG4a4:R9]KECoooodm?CSd[7oooodm?Cl
o?Cdm?@<o?cd00Cdm?Clo?Clo?Cdm?@5o?cd00?dhl[1^IOlo?@0Mlc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<0S8Z8P0;8R8AG5a<A4A<
C4a4KGIfA4A<A4@bID`IQgj?ZL7:UkW:00:?/L400iNibZW1bYNibP02UkW:
00>Yb]:G^LZG^LX00YNibP06ZL7:UkW:UkW:ZL7:UkW:Sk712INibP04Sk71
UkW:Sk71UkW:0Xna`@0?QiNYZJV?k>?:hm;1k>?:d/[1m?C/ZL7:UkW:`K6i
hjV?WimnOWIUd/ZYc<c<00;Sd/43k>?:0^?B`@03m>cKhm;14In7008AWhL2
A9n?00I]Qgklo?C/k>?dk=_dm>clo?@3m?Cd00?/o?CKQfGoool00_Cdm004
o?cdm?Cdm?Cdo?cd0_Cdm004o?cdm?Cdm?Cdo?cd0_Cdm004o?cdm?Cdm?Cd
o?cd1?Cdm003o?cdSlZGhm;100;/o?@01_oooin?KAUD<WifE5a]MUaLC094
A2X07d@j:R8b:S8Z8T@j:SY4C4@j:SXj<UaLC4@Z8R8R4CXj8T@j:SXj<T@j
:SXj8SY46KViUinGQinOOXn?IInOO[ViSinGQinOOYnGQk6aSinOOYnGQinO
OYn?KOclm009m?C/013dm?CSd[7Sd[7:`IoBbZW1^INa^INa/Hni/Ina^INa
/Hna^INiWgkoooodm?Clo?@4m?Cd00?lo?Cdm?Clo?@00_Cdm003o?cdm?Cd
o?cd00;dm?@00oclm?Cdm?clm002m?Cd00Clo?Cdm?Clo?Cdm?@2o?cd02Gd
m?Clo?Cdm?Cdm?Clo?Cdm?Clo?Cdm?Clo?Cdm?Clo?Cdk=_B/HmnKFG:fm_S
fm_lo?CooolbIJU]MWI4A38jIILRIJW/hlYUUk4jE5bOZJUUICXI>WJab/ZO
ZJTRIJTIG;71/KU]Sk5]SkUnKD`00R9f^@0=G8NGC5A]o?cdooooUkW:6DB7
8SYL8WJiSinihm;1Qinac<c<o?cd00;dm>`01oclm?ooooclm?clm?Cdm?cl
m?Cdm002o?cd0_Cdk004m>cKm?C/m>cKm?C/0_clm003m?Cdo?cdm?Cd00;d
m?@01Oclm?Cdm?clm?Cdm?clm002m?C/00Glo?Cdk=_dk=_lo?Cdm?@00_Cd
k006o?cdm?Cdm?C/o?cdm?C/m?Cd0_clm005m?Cdo?cdo?cdm?Cdo?cd00;d
m>`04?clm>cSb_Cdk?clm5anUhnGSoclm?oooeafOSXj8VEU>_clm?ooon?B
/Oclm?Cdm0Clo?@00oCdm?clm?clm002m?Cd0_clm005m?Cdo?cdo?cdo?cd
m?Cd00;lo?@00oCdm?clm?Cdm002o?cd00?dm>ba/Holo?@0Mlc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00Q4>RXZ8QTI6AV7C4A<E6e4
A4aLKHM<E6d2IE@b00F?WkVYb]:G^LZYb]:Y`LX00YNibP03ZL7:ZL[B/K6i
00FY`LX019NibZW:dZW1bYNibP:Y`LX7UkW:0Xna`@:G^LX038na`INibYNi
bYNibXna`K7:bZW:dYNibYnYZK6iZKWBfjW1bP:G^LX02ZW:dXNGZFefMYN?
M];:ZN?B`NcSb^cK`NcSb/[1W`;Sd[405ncK`Nclm5b7Sooooa6OQk6iZOcl
m?ooooCdm?Cdk>c/hn?KfoCdm?clm?Cdm>clm?ooom]f<_ooooCdm?clm?Cd
m?clm002m?Cd00Clo?Cdm?Cdm?Clo?@6m?Cd00?lo?Cdm?Cdm?@00oCdm00J
k?cdm=9nm=9noooom?C/oooo`KVG4A4AIFDjKHMnG5a<C4`jA4@bA3XR6ATI
8RXZA4@bA3XZ>SXRA4@ZC4`j>UALG5a<8S8ZA3XZ>SXb0T@j:P06<RXR^Imn
/K6?ZJV?WimnWiN70inOOP06ZJV?/KVGZJV?ZJV?ShM]Uhmf2_Cdk005m?Cd
m>?:hm:ab/6O`KVO00:i^IL01jVYSinOO[6iUk6aSjVYSkVOO_ooo`03m?Cd
0_clm0?dm?@02Oclm?Cdm?clm?Cdm?clm?Cdm?clm?Cdm?clm002m?Cd00Gl
o?Cdm?Clo?Cdm?Clo?@00oCdm004o?cdm?Cdo?cdm?Cd0_clm0;dm?@01ocl
m?Cdm?Cdm?Cdk?clm39UZJW1bP02m?C/00[ooolbIJTRIJTbM[4IG;5UQjW/
hlYfUl4jE5aLQhl24EBY01N?WkVa^JTIG;7<c<cBbZVOZJTRIJW/k>>Y`LXb
IJTb>TA<O[6Y`L[/k>?lo?BY`LZG^L[Sfm_oooolo?Coooolo?Cdm?@01?cl
m004m?Cdm?C/m?C/m?C/0oC/f`04m?C/m?Cdm?Cdo?cd0oCdm007o?cdm?Cd
m?Cdo?cdm?Cdo?cdm?Cd00;lo?@00oC/foCdk?clm002m?Cd1?ooo`03m>?:
k>?:m?Cd00Glo?@01OCdm?clm?Cdm?clm?Cdm002o?cd00_dm?Clo?Cdm?Cd
hl[dk=_ooonOZJV?Uhodk=_ooon?Uhl00Ta<>P05k>cSooood/ZYooooo?cd
00;dm?@4o?cd00?dm?Clo?Clo?@00_clm003m?Cdo?cdm?Cd00;lo?@01OCd
m?clm?Cdm?clm?Cdm003o?cd00>iWgklo?C<c<`0M/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Pcc<c<00<I8R8b:R94:R800TaDK@06G5a<KGj?
A4A<A2XRID`I/K6i0ZW:dP04/K6iZL[BZL[BZL7:0jW:dP03/L[:ZL[BZL[B
00:Yb]801;7:bZW:dZW1bZW1bPjG^LX01jW1bYNibYNibYNibZW1bYNibXna
`@04UkW:0ZW1bP06ZL[BSk71MWiLE6efhm;1fl6O0ncSbP0?WiN7m>cKm>cK
k>?:m?CdO/6GooooA9n?4In7A9n?/L[:oooom?Cdm?C/k>?:00Cdm?@00ooo
on?B/NcK/@02m?Cd00?lo?Cdm?Clo?@00_Cdm007o?cdm?Cdm?Cdm?Cdo?cd
m?Cdo?cd00?dm?@00oclm?Cdm?Cdm003m?Cd00Wdk=_/fk7dm?C/o?CooooS
d[4I6A5UICY]MWH00UaLC005>T@bA4@b8RXZ<RXR>T@b00=4A38014A4C3Y4
C3YDG4a<>P94>RX01CY4<SXj<RXR6K6aSjVYS`02WiN700bOWgjOSffa/HnG
SgJOWhna/HnGSgJYZHnOWgjOUhOdk=_dm?@8m?C/00odm?C/hl[BbZW1^INi
/Io1^INa^INOUhNa/Hni^INYZHna/HnGSgKoooolo?@01?Cdm003o?cdm?Cd
m?Cd00;dm?@01_clm?Cdm?Cdm?clm?Cdm?clm0;dm?@01Oclm?Cdm?Cdm?Cd
m?clm002m?Cd0oclm0;dm?@01Oclm?Cdm?Cdm?Cdm?clm002m?Cd01[lo?C/
k>?/hlYUUk5DQk6GShN7UjWooona/KTbM[6YZHlRIJV?WkWdhlYfUl4jE5b7
UjVab/YfUk5UQjVa^JTRM[TRIJTR<T@RIJTbIJT2o?cd00F?WkUnWkVa/KWl
o?Cdm?@00_clm007ooooo?cdo?cdm?Cdo?cdm?Cdo?cd00;dm>`03Nc/hoC/
foC/foclm?Cdk?Cdm?clm?Cdk?Cdm?clm?Cdm?clm?Cdm003o?cd0_Cdm004
o?cdm?Cdo?cdm?Cd0_clm004m?Cdoooooooooooo0_clm00:hm;1/K6iKHMn
oooom?C/m>cKoooom?Cdo?cdm?Cd1?clm003m?Cdo?cdo?cd00;dm?@00ocl
m?Cdm?clm002m?C/00goooo:`JU]OXo/k>?ooon7Wk5<E6e4A2[/hl[ooooS
dYooooodm?@00_clm004m?Cdo?cdo?cdm?Cd0_clm007m?Cdo?cdo?cdo?cd
m?Cdo?cdm?Cd00Clo?@00oCdm?clm?clm002o?cd00>OWgklo?C<c<`0M/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<0S8Z8P0<C4@RC4a4
G5a<C5A]KGIfC5A]C4@R:R8I^M;KZL[B/K6iZL[B1;7:bPJYb]800jW1bYNi
bZW1bP02UkW:0jW1bP03UkW:ZL[BUkW:00>G^LX01jW1bYNibYNibYNibXna
`INibYo1/@04UkW:012Y`LZ?/L6G^LZG^LZO`K6G^LZY`LZYb]:7b[5]QgiL
KGJ?SfGBb/7BbZWSd/7Sd[42k>?:01GSd/7/fl7lo?ALQhm4WhlAWhOdk=^O
`K4AWhOSd[7/o?CSfm_/fl7dm?Clo?Cdm?Cdm>cooooKbYoSZHooool01?Cd
m005o?cdm?Cdm?Cdm?Cdo?cd00Kdm?@00oclm?Cdm?Cdk002m?Cd0_Cdk003
k?cdk=^ahm_K00;dm?@02ncSbSY46CY46FefMUaLC4a<A4A4<T@j:QTR8S8Z
8T@j:P03>SXb0TA4C00AG5a<>TA<<SY4>SXRA3XZA4@Z8R8AWhm]WimnWiN7
^KV?WimnWhm]/KVGWiN7WimnWiN700:OWgh019nGQhn7KOCSb^?/m0Wdm>`0
0ncSb];:ZL6iU`02`KVG0k6aS`0?ZJV?/KVG/KVGUhmfoooom?C/o?cdm?C/
m?Cdo?cdm?Cdo?cdm?Cdo?cdm?C/00;dm?@00oclm?Cdm?Cdk002m?Cd00Sl
o?Cdm?Clo?Cdm?Clo?Cdm?Cdm>clo?@4m?Cd00?lo?Cdm?Cdm>`00_clm008
m?Cdo?cdm?Cdo?cdhm_Khm;1OYni8VFY0QU4Q`0Fhm_Ko?cdMYO18T@j4EBY
/L[:hm_KWjVY>UafWjVYd/[1WjVY<WJa`K6OC7jaE8NaOYni/K6ihm_Km?C/
k?cdm?C/0_clm003m?Cdm?C/m?Cd00?dm?@01OCdk>c/hoC/foC/fnc/h`02
m?C/00Glo?Cdm?Cdm?Cdm?Cdm>`00_clm006m?Cdo?cdm?Cdo?cdm?Cdo?cd
1?Cdm005o?cdm?Cdo?cdm?Cdo?cd00;dm>`03_clm=;:`Io1/InOSoCdk?cl
m8NGZFFG/Ea]Qoooooclm>?B`Oclm?Cdm0Clo?@2m?Cd00Clo?Cdm?Clo?Cd
m?@4o?cd00gdm>cdhl[lo?C/hlY]Qgkdk=_lo?BOZJULOYMLG4bi^JWooooB
bZT00oclm003m?Cdo?cdm?Cd00Klo?@2m?C/00Clo?Cdm?Clo?Clo?@3m?Cd
00Olo?Cdm?Cdm>clo?CoooniUfglo?@0Mlc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Pcc<c<00db:R8I8R94>RY<C4A4A4aLKHM]OXm<C4@R8Q4Z
4@S:fm^a/KVab/X00ZW:dP05/L[:ZL7:ZL[B/L[:ZL7:00>ab/X01:W:d[7:
bZW:dYNibP:Yb]800jW1bYNibZW1bP02UkW:00>Yb]:G^LZY`LX00iNibP04
ZL7:UkW:UkW:Sk711iNibP0;Sk71UkW:UkW:UkW:ZL[BC7In:Q48KFDROXn?
G6ef^KVG00;Sd/402NcK`N?B/NcSb_C/fncK`OCdk<[Kfgk1UncSbP02oooo
00G<c<c/k>?/k>?Sfm_Sd/401?Cdm005oooo^D`0oooom?Cdo?cd00;dm?@0
1Oclm?Cdm?clm?Cdm?clm00;m?Cd01;dm>c/o?Cdm?Cdm?C/fk7Bb/7dm?C/
o?Cdk=]UG1Tj>R9fOUaLG4a<C4A<C3Y4A2XR<RXI8R82A4@b00Dj>S94A2Y4
A39<C3XjE5`00SY4<P8j>S800cY4<Ta<A8mfE002Uhmf00NOWhnOSffYZHnO
UhNYZHnOUhNGSgH00ZVYS`:OWgh00n?B`OCdk?Cdk009m?C/00CKbYoBbZW1
^INi^IL3/K6?00Ji^INOUhNa/HnGSgKlo?Cdm>`4m?Cd00?dm>cdm?Cdm>`0
0oCdm006o?cdm?C/m?Cdo?cdm?Cdo?cd1?Cdm007o?cdm?Cdm?Cdm?Cdo?cd
m?C/o?cd00;dm?@2o?cd1?Cdm00Fm?C/m?Cdk>cShm;1Sini8VFY/L[:ZL[B
c<c<oooohm;14EBYE8Nab]_Km>cKSk71>UafE6efk>?:^KVY/K6io?cd0^c/
h`?lo?@00oCdm>?/m?Cdm002m?Cd0oCdk0?dk=/2m?C/0_Cdm004o?cdm?Cd
m?Cdm?Cd0_Cdk005o?cdm?Cdm?Cdm?Cdo?cd00;dm?@02oCdk?clm?Cdm?Cd
m?clm?Cdk?clm?Cdk?clm?Cdk?C/f`02m?C/00klo?Cooom]SiMUUk5UQjW/
k>?ooonO`K5UUk5LOYOlo?CooooSd[7oool2o?cd00?dm?Clo?Clo?@00_cl
m004m?Cdo?cdm?Cdo?cd0_Cdm00?o?cdm?Cdm?Cdk=_1oooob/6YKGIfk>?:
o?cd^KVYQina/L[:hm;1ooook=^a00?dm?@01?clm?Cdm?clm?Cdm0;lo?@0
1OCdm?clm?clm?clm?Cdm002o?cd00?dm>clo?Clo?@01oclm003/HMUhm;1
c<c<07K<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c00A<RXR
:R8IG3XRA4@bC4a4E6efKGIfA2XR<RXR:Q48b]_KZL[B/K6iZL[B/L[:ZL7:
/K6i00>ab/X00kWBfjW:dZW:dP02ZL[B00FG^LZYb]:Y`LZY`LZYb]801ZW1
bP03UkW:ZL7:UkW:00FG^LX00hna`INibYNibP03Sk7100>G^LZ?/L6?/L40
0iNibP0>QlZa8R8A:Q48SgI4G6efKGIfm>?:hm:ahm;1b/6Ok=_1k>?:hm:a
m>cK0_ooo`09hm_Kk>?:m?C/ooooo?cdk>cSd/ZY`K6io?cd00?dm?@00m^O
KN?B/Oooo`03m?Cd00?lo?Cdm?Cdm?@01oCdm003o?cdm?Cdm?Cd00Sdm?@0
6>cK`N?B`N?KfoCdm?clm6eU8R8R4FefMVe]E5aLC4A4<SXj<TA4:Q4A4DA4
<SXj<TA4C4A4<TA4C4a<A4a<>SY4C4A4:SXj<P94>RX00b94>Ve]E;6aS`02
Wimn00fGSgJGShNGSgJYZHnOUhNOSffYZHnOUhNOWgjOWhoK`Iodm?C/k><0
0oCdk003k>cSm?C/m?C/00?dm>`2d/ZY00[1^INi^Hni/Ini^JVOUhNa^INa
/Hni^INOWgklo?@2m?C/00?dm?Clo?Cdm?@00_Cdk006o?cdm?C/m?Cdm?C/
m?Cdo?cd0_Cdm00:m?C/m?Cdm?C/o?cdm?C/o?cdm?Cdm?C/o?cdm?C/0_Cd
m003m?C/o?cdm?Cd00;dm?@01?clm?Cdk?Cdm?clm0;dm?@01nc/hn?B`K6a
^B9UZFenScYDG6f?U`02oooo00`jIIN?WkWSfm_/k>?/hl[1/KU<8PSooool
o?Coooodm>cdm?@2m?C/00?dm?Cdm>cdm>`00_Cdk0?dk=/4m?C/00Cdm?Cl
o?Cdm>clo?@4m?C/00?dm?Cdm>cdm>`00_Cdk003o?cdm?Cdm?C/00;lo?@0
0oCdm?clm?clm002m?C/01Glo?Cdk=_dm>cdm>clo?Cdm?Clo?Cdm>cdm?Co
oon7UjU]Sk5UUk7Sd/7ooooBb/5UQjULQiOdm>cdm?C/fk400oCdm004o?cd
m?Cdo?cdm?Cd1?clm00:m?Cdo?cdo?cdm?Cdo?cdm?Cdk=_1oooo^KVYd/ZY
0_C/f`09k>cSc<c</K6iWimnooook=^am?C/o?cdm?Cd00?lo?@2m?Cd0_cl
m004m?C/o?cdo?cdm?Cd1?clm00:m?C/o?cdm?C/m?C/k=^am>cKk>cSo?cd
^Imnm>cKMlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<0S8Z
8P0<A3XZ>T@IG6f7G6efG7In>T@I:R8IG3XR^M;K/K6iZL[B/K6i1jW:dP04
/L[:ZL[BZL[BZL7:0jW:dP05UkW:ZL7:UkW:UkW:ZL[B00fG^LX01hna`INi
bYNibYNibXna`JW1bXna`@03UkW:00nYb]:?/L4R8Q4jA1VGShMLG4cBb/7S
d/7/hl[BbZWSd/7/hl[BbZWdk=_lo?@0116OQ`05O/6Go?cdoooob[V?`K6?
00;lo?@01?Cdm>clm=]f<_ooo`Kdm?@01?clm?Cdm?clm?clm0Sdm?@00ocl
m?Cdm?Cdm002m?Cd02cdm>cdm?C/k>?Sd[7/hl[/o?Cooon?SfDI6A5fOUa<
C3Y<C4@jA394A38j>S8A4A54A4a4A38j>S94A394A4`jA4`jE5a<C4@jA4a4
>R8jA394>RXjA38b>TALG4ba/HnOUhNGSgJ?Qffa/HnOUhNYZHnOWhnOUhNO
WhnGSgJGShO:`Il;m?C/00?SdYoSd[7:`JT00/6iU`0;^Imn/K6?^KVGZJV?
^K6OWhm]o?cdm?Cdm?C/m?Cdm?C/00Gdm?@01?Cdk?Cdm?clm?Cdk0;dm?@0
0oclm?Cdm?clm003m?Cd00Glo?Cdm?Cdm?Cdm?Clo?@01?Cdm004o?cdm?Cd
m?Cdo?cd1?Cdm004m?C/b]_KWl6a4EBY0S9UZ@03IHNYm?C/o?cd00;/k><0
1oclm?Cdk?clm?clm38Z8_clm?Cdk002m?Cd0oCdk0?dk=/2m?C/00?dm?Cl
o?Cdm?@01?Cdm003m?C/m?Cdm?Cd00?dm?@2m?C/00?dk=_dm>cdm>`00_Cd
k0;dm?@00oclm?Cdk?Cdk002m?C/00Gdk=_dm>clo?Cdm?Clo?@00_Cdm007
o?cdm?Cdo?cdm?Cdo?cdooooWjVY009UUk403=;:ZOooolc<c6f?/EB7/OCS
b_oooncK/OooooCdm?clm?Cdm0Clo?@00oCdm?clm?clm002o?cd01?dm?Cl
o?Clo?Clo?C/fl7ooooBb/7:`IoSd/7/fl7<c<aUQjUDSk6GSgKoooo/hl[d
m>cdm?Clo?@00_Cdm0Clo?@01?Cdm?clm?clm?Cdk0?lo?@3m?C/00Wdk=_d
m>cdm>cdk=_dm>clo?Coooo1^HOSfm/0Mlc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Pcc<c<00/b:R94A2Y4>RY4:R9]OXm]MWILKHM<8PPZ8QUU
E3:ifo@01ZW:dP04/L[:ZL[B/L[:ZL7:0ZW:dP03UkW:ZL7:ZL7:00:G^LX0
1:W1bZW:dYNibZW1bP:G^LX00jW1bYNibZW1bP09UkW:00B?/L6G^LZG^LZ?
/L43UkW:01>?/L6O`K6G^LZO`K6ifo@jE5`Z4@R?SfE]MWK:`Io/hl[Sd/7S
d[7:`JW1^IOSd/7dk=^ab/Yn`IL00_Cdk008hm_K4In7SlZGoooo`K6?b/6O
k>cSm?C/0_Cdm004fgi<k?cdk?cdk?cd0oCdm003o?cdm?Cdm?Cd00Cdm?@0
0oclm?Cdm?Cdm00:m?Cd00S/o?C/fk7/hl[/o?Clo?BOWghA4A5fOU`2C4`j
00ILG4a4A394>RXA4A54A38j>S83A4@b00E<C4ALG4`jA4a<C3Xb>T@00T@j
:P8jA4`0438Z8R8b:[VOOXn7KJVYSiN?MYnOOZVYSinGQinOOXn?IInGQinO
O[ViSoclm>c/h`Cdm>`00nc/hoCdk?Cdk002m?C/00_KbYo:`Io:`Ini^INa
^INi^Hna/Hna^INa/Hni^INOWgh00_Cdk0Gdm?@00oCdk?Cdm?Cdm004m?Cd
00?lo?Cdm?Cdm?@00oCdm0;lo?@2m?Cd00Clo?Cdm?Cdm?Clo?@5m?Cd00Cl
o?Cdm?Cdm?Clo?@2m?Cd00[dm>cSfm_/hl[<c<c/k>?lo?Coooodm>cdm?Cl
o?@4m?Cd00CooolR8Q7oooodm>`2m>cK0oCdk003m?Cdo?cdm?Cd00Odm?@0
4Oclm?Cdm?Cdm?Cdk>cSb_C/fncSb_C/foCdk?Cdm?ooooclm?oooncSb^cK
`OCdm?clm003m?C/00Cdm?Clo?Cdm?Clo?@2m?Cd00[lo?Cdm?Clo?Cdm?Cl
o?Cdm?Clo?Cdm?CooonOZJT2KHna00>i^JWooooSfm/00VF7Z@03k=^aoooo
hm:a00;lo?@01?Cdm?clm?clm?Cdm0?lo?@00oCdm?clm?Cdm004o?cd00od
m?C/fl7ooona^JW:`JWSd/7BbZWSfm]]SiMUUk67OUClo?C/hl[dk=_lo?@0
0_Cdm0?lo?@02?Cdm?clm?clm?clm?Cdk?clm?Cdk?C/f`?dm>`01?clm?Cd
m?clm?clm0;dm?@01?clm?Cdm=_1WncSbWO<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h<lc<c00><RXRA3XZA3XZ>SXRG5a<G6efC5A]A2XR:R8I
OVeU^M;K/K6iZL[B^M;K0ZW:dP03/L[:ZL[BZL[B00BYb]802YNibZW:dZW1
bZW1bZW:dZW1bYNibZW:dYNibZW1bPJG^LX01:W1bYNibYNibZW1bP>G^LX0
0jW1bYNibYNibP05UkW:00^?/L6G^LZG^LZG^LZid]/A4A4jA1U]Qgj?Qfgd
hl[Sfm/00n?B/@03hm:Om>cKb]_K00?lo?@01oooonc/ha6OQn?KfncK`L[1
ZOC/f`03m?Cd00Cdm>cKMS;oooooool6m?Cd00?lo?Cdm?Cdm?@03OCdm004
k?cdm?Cdk=^a`KV70_Cdm003flZO0000MWiL009<A2804Ta<>TA4<Ta<>QTI
6CXj<TA4:SY4C3Y4<TA4C4a<>Ta<A3YDG38jA3Xj<SY4<T@j:Ta<A38jA08b
:R803UaLC8n7KEaLC7i]C;ViUjVYSiN?MZVYSinGQiN?QinOO[VOO_Cdk>c/
h`Sdm>`03oCdm>?B/L6iUl[1ZKViSk6aSkViUk6iUkViUk6aSlZaZInGQoC/
foCdm?Cdk002m?Cd00?dm>cdm?Cdm?@01?Cdm003o?cdm?Cdm?C/00;lo?@0
1_Cdm?clm?Cdm?Cdk?Cdm?clm0?dm?@01_clm?Cdm?Cdm?clm?Cdm?clm0;d
m?@01Oclm?Cdm?Cdm?Cdm?clm003m?Cd0_clm0;dm?@00oCdk?Cdm?Cdk002
m?C/00C/k>?dk=_lo?@jA1T2m?C/2?Cdm006k?cdm?Cdm?Cdm?C/m?Cdo?cd
0oCdm0?dm>`02^clm?ooooooooclm?Cdm?C/fm;:`Oclm?C/fncK/@Cdm?@0
1?clm?Cdm?Cdm?clm0;dm?@05Oclm?Cdm?clm?Cdm?clm?Cdm?clm?Cdm?cl
m?oook6a^FFG/Ff?/JVYSoooooC/ffF7ZEB?/L[1WooooncK/@02m?Cd00?l
o?Cdm?Clo?@01?Cdm005o?cdm?Cdo?cdo?cdm?Cd00;lo?@03oCdm?CSb_oo
ol6a^M;:`OCSb]^aWoCdk8NGZEB?/GInG>c/hoCdk>cSb_Cdm004o?cd00?d
m?Clo?Clo?@00_C/f`?dm>`2o?cd00Gdm?Clo?Cdm?Clo?Cdm?@00oclm004
m?Cdoooohm:Od/[1Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pc
c<c<00@R<RYL>R94>RY4:R82KGj?00ALG4`jA1TZ4@RYZHl2^M;K0/c<c003
^M;Kc<c<ZL[B00:Yb]800kWBfjW:dZW:dP06ZL[B00>ab/ZYb]:Yb]800ZW:
dP08ZL7:ZL[BZL7:ZL7:ZL[BZL7:UkW:ZL7:0YNibP:Y`LX3UkW:00BY`LZG
^LZG^LZY`LX6UkW:00Rid]]]Qghb:R8jA1V?UhoK`Io/hl[Sd/44k>?:00?S
fm_dm?Cdm?@00oCdm006`K6ik>?:m>?:b[6Yhm;1o?cd0_Cdm005k?cdhm;1
fgi<k>cSoooo00?dm?@00oclm?Cdm?clm00=m?Cd01?/o?Cdm>cdm?Cdm?CS
fm_Sd[7/o?Clo?CSd/40001fOUa<8PQUE39<C3Y4A38jA38I8R94>RXjA4`0
0SY4<P05A4@ZA4A<A4A<G5a<<SY400=4>RX04TA4<Ve]E6ED<RXR6C8Z8SXj
<T@j:R8j<Ta<A8n7KIN?M[6iUjVYSinOOYnGQin?KOC/foCdm0;dm>`01>c/
hoCdk?Cdk>c/h`;dm>`03oCdm>cK/L[1Wl[1WkViUkViSkViUinOSkViUjVY
SkVOOYnGQncSb_Cdm?Cdk003m?Cd00?dm>cdm?Cdm>`00_Cdk003o?cdm?Cd
m?Cd00Gdm?@00oclm?Cdm?Cdm00:m?Cd00?lo?Cdm?Cdm?@01_Cdm005m?C/
m?Cdm?Cdk?cdm?C/00?dk=/3m?C/00Cdm?Cooom44@3dm>`2m?Cd00?dm>cd
m?Cdm?@00_Cdm003o?cdm?Cdk?cd00Wdm?@2oooo00_dm>cSfm_oooo1/KV7
UjUfUk5]SiOdm>cdm?CSd/7oool00_Cdm003o?cdm?Cdo?cd00;dm?@2o?cd
00?dm?Clo?Cdm?@00oCdm00Ao?cdm?Cdm?Cdooood/[1IINaKHniSiN?oooo
o?cdIHNYE8Na^KVGooook>?:m?C/o?cd00;dm?@4o?cd00Gdm?Clo?Clo?Cd
m?Clo?@00_Cdm00@o?cdm?Cdm>cKo?cdhm;1Win?o?cdWhm]o?cdQiNYIINa
OWi]k>?:o?cdm>?:o?cd0oCdk005m>cKm?C/m>cKm?C/m?Cd00;lo?@01?Cd
m?clm?Cdm?clm0;dm?@2o?cd00?dm?Clo?Cdm?@00_clm003m?Cdm>?:b/6Y
07O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c004A2XRA3XZ
A3XZ>T@I0Ua]Q`04C4a4A2XR:Q48`K6i1/[Kf`07^M;Kb]_K^M;Kc<c<^M;K
ZL[Bc<c<00:id]/8ZL[B00>id]^Yb]:Yb]802jW:dP03ZL7:UkW:ZL7:00:Y
`LX03INibZW1bYNibYNibZW1bYNibZW1b[WKm14A4CY46FEU>];:`OCSbP02
k>?:00C/fk7dm>cdk=_dk=/2m?Cd00Sdm>c/k>?dm?C/fl7:`IoSfm_/k>?S
d[44m?Cd00CooooSd[7KOTc/o?@2m?Cd00?lo?Cdm?Cdm?@03?Cdm0;dm>`0
3_Cdm?Cdk>c/hoCdk>c/hnclm>c/hn?KfoC/f`0007i]C9N?MWInG4a<>P94
A3801QTI6CXj8SXj<T@j:SY4<TA4<P9<C4@02cYDG3Y4<SXj<TA4:SXj<R94
>Yn7KN?KfaTI4CY46CXj8P03>SXb00XR<RZ?Qffi/InOUhNOWgj?UhnOSfg/
hl[dm>c/k><7m?C/00Wdm?CSd[7BbZWSd[6YZHo:`JVi^INa^INi^IL00[6i
U`03Wimnk=^am?Cd00;dm>`6m?Cd00?dm>cdm?Cdm?@00_Cdm004m?C/m?Cd
m?Cdm?C/1OCdm003m?C/m?Cdm?C/00Odm?@01OCdk?Cdm>clm>clm?Cdm002
m?C/1?C/f`;dm>`5m?Cd00G/o?CooomUIC[Bb/7lo?@00oCdm006m?C/m?Cd
m?Cdm?Cdo?cdk?cd0oCdm003m?C/k?cdm?C/00;dm>`03Nc/hk6iZInYZGJG
/K6iUoooolc<c6FG/GjO^FFG/OCSb_Cdm>?B/@02m?Cd00Glo?Cdm?Cdm?Cd
m?Clo?@00oCdm005o?cdm?Cdo?cdm?Cdo?cd00;dm?@04?clm?Cdk?clm>?K
ffFG/Ff?/HnGSoooooclm5b7UhNGZM;:ZOoooncSb_Cdk?Cdm0;lo?@2m?Cd
00?lo?Cdm?Clo?@00_Cdm00Co?cdm?Cdo?cdm?Cdo?cdm?Cdm?C/m?Cdm>cK
G6efm?Cd^IMDooooWjVYE8NaOWi]b/6Yo?cdb/6O00Gdm>`01?clm?Cdm?cl
m?Cdm0?lo?@00oCdm?clm?Cdm003o?cd00Gdm?Clo?Cdm?Clo?Cdm?@00_cl
m003m>?:^K6Oc<c<07K<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
<lc<c0=4A38034@Z8Ua]MUa]QcXj<SXj8QTI4NcSb^?Kfl[Kfn?Kfl[Kfn?K
f`K:fm/3^M;K00?<c<bid]^id]/00ZW:dP08^M;Kc<c<^M;KZL[Bc<c<^M;K
ZL[B/L[:2ZW:dP05/L[:^M;KZL[BZL7:ZL[B00>Y`LX049NibYo1/JW1bZW:
d[WBfcYLMR8R4BXA2<[1ZOC/fncK`N?KfncSb^?KfncSb^c/h`;dm?@00oCd
k>c/hoCdk002k>?:00?Sd/7Sk?CSd[400oCdm006m?C/m?Cdoooohm_Kfgi<
oooo4?Cdm003m?C/m>cKk?cd00;/hlX08^?KfoCdk?Cdk>cSb^c/hoclm000
06EU>WInG8MnE4a<A4a<>TA4<QTR8S8Z8TA4C3Xj<TA4<SY4<TA4C3YDG4a<
A3Y4<SXj<T@j:SXj8Ta<A3Xj<ZVYShn7KA4A4D@j:SY46CXj8P8j>S8024A4
</6iWjVYSk6aShn7KInOO^?B`OCdm0Cdm>`02^c/hoCdk?Cdk>c/hnclm>?B
`L[1Wl[1ZKViUlZaZ@:i^IL2/KVG00Ja/HnYZHoBbZWlo?Cdm>cSk?@2m?Cd
00Gdm>cdm?Cdm>cdm?Cdm>`00oCdm003m?C/m?Cdm?C/00?dm?@01?Cdk?Cd
m?Cdm?Cdk0Cdm?@00oCdk?Cdm?Cdm003m?Cd0_Cdk0;/hlX2m>cK00?dm>cd
m?Cdm?@00_Cdm004m?C/m?Cdm?Cdm?Cd1?Cdk003ooooMWiLb/6Y00Kdm?@0
1_clm?Cdk<[1ZM;:`OC/foclm0Gdm>`03oCdm?clm6f?/GJG/Ff?^InYZOoo
on?B`FFG/GJG/FFG/NcK`Oooon?B/Oooo`04m?Cd00Glo?Cdm?Clo?Cdm?Cd
m>`00_Cdm005m?C/m?Cdm?Cdm?Cdo?cd00?dm?@02^?Kfeb7Uff?/HnGSooo
ooclm>?B`N?/m;VOO_clm0;dk=/00oCdm?clm?Cdm002o?cd0_Cdm009o?cd
m?Cdo?cdm?Cdm?C/o?cdm?Cdo?cdm?Cd00;dm>`02oclm6e]E=;:`HmfA?oo
oinYZEAfUeA]MYnGQoooom_:W`02m?Cd0oclm004m?Cdo?cdo?cdm?Cd0_cl
m0;dm?@2o?cd00Odm>clo?Clo?Clo?Cdm?Clo?Cdm?@01?clm003/KVGc<c<
c<c<07G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c00:C4`j
A4@ZA3XZ<RXRKGIfG6f7C288>SXR:Q48m?C/0^?Kf`04k>cSb]_Khm_Kk>cS
1l[Kf`Fid]/00l[KfkWBfkWBf`09^M;K00>Yb]:id]^id]/00jW:dP03^M;K
ZL[BZL[B00>Yb]807JW1bZW:dZW1bZW1bXna`JW1bYNibZW1b[WBfcYDG3Y4
6FeU8^cK`N?B`OC/fncK`OC/fncK`N?B/OCdm>c/hoCdk>c/hoCdk>?KfoCd
m>?KfoC/fn?B/@04m?Cd00Gdm>c/o?CooooK`IoSZHl02OCdm004k?cdm?Cd
m?Cdm?C/0_Cdm0;dm>`03>c/hoCdm>?KfoC/fn?Kfnclm>?/m>cSb_Cdk?oo
o`0004a<>P9LG4`01dA4:Ta<A4a<>RXR6ATR:TA4<S8jA002>SXb00A4A39<
C4@jE5a4A2X5>SXb01EnIEC:`Io1/Im<A28I6A5UE38I6AU4>RXjA394A38b
>TA4A3:YZHnGSgKK/JWdm?C/k>?dm>c/k>?dm>c/k><00oCdk006m?Cdk>?:
d/ZYd/ZY^KV?d/ZY0[6iU`06^KVG`K6OWin?^KV?`K6Oo?cd0_Cdk0?dm?@0
1OCdk?Cdm?Cdk>clm?Cdm002m?C/00?dm?Cdm>cdm?@00_Cdk005m?Cdm?C/
m?Cdm?C/k?cd00;dm>`2m?Cd00?/o?Cdm>c/k><01?C/f`;dm>`3m?Cd2?Cd
k0;dm?@01nclm?Cdk?C/fooooinOO[6iUoC/f`02m?Cd0_clm003ooooWin?
QfDb009UICX05FE<6KViZNcSb^cSb_Cdk?Cdm?Cdk?Cdm?clm7JG/Ff?^GJG
`HnGSoCdk>c/hfFG/GjO^FFG/M_1Woooon?B/@03m?Cd00?dm>cdm?Cdm?@0
0_Cdk009o?cdm?Cdo?cdm?Cdo?cdm?Cdo?cdm?Cdm?C/00?dm?@03?Cdk>?B
`N?Kfm;:`Oclm?ooogj?SeB?/GifIOCdk>c/hncSbP;dm?@07Oclm?Cdm?Cd
m?Cdm?clm?Cdm?Cdk?clm?Cdm?clm?Cdm?clm?Cdk?clm?Cdk?C/fooooc8j
A8n7KHmf>_oook6iUeB7/HnGSinOO_ooon?B/OCdm?clm002m?Cd0_clm003
m?Cdo?cdm?C/00;lo?@01_Cdm?clm?Cdm?Cdm?clm?Cdk0;dm?@02?clm?Cd
m?clm?Cdm?clm?Cdk?clm;VOOWO<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h<lc<c006A4@bA2XRC4@RA2XRG5a<C6f70S8Z8P07IC88hncdhm_K
hm_Kc<c<hm_Kb]_K00;Sfm/00l[Kfn?Kfl[Kf`09b]_K00>id]_:fm_:fm/0
3KWBf`03c<c<ZL[BZL[B00:Yb]801K7:bZW:dZW1bZW1bZW:dP02ZL7:00n?
/L6Yb]:Y`LZYb]:id]/000144@2OQfgSd/7/hl[Sd[7/hl[Sd/7Sd[7/hlX0
0_Cdk003m>cKm?Cdk>?:00;dm?@03>?B/KVaWoclm?Cdk?Cdm?Cdk?Cdm?Cd
k>clm?ooonbYM]^aW`;dm?@01OCdk?Cdm?Cdm?Cdm>clm003m?Cd00?/o?Cd
m?Cdm>`00_Cdm00=k?cdk>?:hm_Km>cKhm_Km>cKhm_Kk>?:k>cSm>cKoooo
0000>T@b009LG4`01Ta<>TA4<TA4<R8b:S8Z8SXj<P94A3805C8jA3Y4C4a<
A4a<>SY4C3Y46CY4C3Xj8SY4C4A4<VEU>Xn7KOclm;6iZGInG<6aWiN?MSXj
8S8Z8SXj8SXj<P02C4`j00BOUhO1^IOlo?C/k><3m?C/0^c/h`0@m?C/k>cS
k?cdk>?:b/6Od/ZY`KVG`KVO/K6?^K6O/KVGZJV?/KVYWimn`K6?k>cS1?Cd
k005k?cdm?C/m?C/m?Cdm?C/00;dm?@00oCdk?Cdm?Cdk002m?C/00Cdm?Cd
m>cdm>cdm?@4m?C/00C/hl[dk=_dk=_dk=/2m?C/1?Cdm003m?C/m?Cdm?C/
00;dm?@05oCdk?Cdm?Cdm>clm?Cdk>c/hoCdk>c/hncSb_C/fnc/hoCdk?cl
m:VYSk6iUnc/hoCdk>c/hm;:ZK6aSkVaWfEL6FEU>P02KFeD01IUICYUG1Un
KDcSd[7/hl[dm>cdm?C/k>?ooon7UjV7b[5]SkUfUk7dhl[dm>aUUk5fUk5]
SkVi^IOooooSd/7dm>`8m?Cd00Cdm>cdm?Cdm?Cdm>`2m?Cd00?lo?Cdm>cd
m>`00_Cdm00=o?cdMYNaKHnaG7jGm?C/ooooQiNYIINaOWi]m>cKo?cdhm;1
o?cd00;dm?@01_clm?Cdk?clm?Cdm?Cdk?clm0Cdm?@03?clm?Cdk?Cdk?Cd
k?C/foooohMnE;ViUl[1Woclm>cSb[7:bP;Bb/401Oooom_:WoCdk?Cdm?cl
m002m?Cd0_clm003m?Cdo?cdm?Cd00;lo?@01?Cdm?clm?clm?Cdm0;lo?@0
0oCdm?clm?Cdm002o?cd00Cdm?Clo?CoooniWgigc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^3?<c<`03dA4:T@Z8Ta<>S8Z8Ta<>VefMT@A01TI
6HMD:^?/m>?Kfl[Kfn?Kfl[Kfn?Kf`0?b]_K00>id]_:fm^id]/01kWBf`:Y
b]800kWBfjW:dZW:dP0<ZL[B00VY`LZYb]:ab/ZYb]:id]]]QgjGOUCSd/7/
hlX00_C/f`;/hlX02n?B`NcK`NcSb_Cdm>c/hoCdm>cSb_Cdm?Cdk>c/hm_1
W`03m?Cd00?dm>cdm?Cdm>`00oCdm003fgi<oooom?Cd00Kdm?@00oCdk?Cd
m?Cdk004m?Cd013dm>c/hl[/k>?/k>?/o?CSfm_Sd/7/hl[Sk?CSfm_oool0
0014A39LG4aUE39<C4@2C4`j00Db:R8Z8QU4A38jA394A4`00SXj<P03A4A<
>T@b>SXb00<j>S8033Y4<SY4C6ED<YnGQncSb/6iWgInG;6iWl[1ZGifE1TI
4D@j:P8b:R801CXj<YnOSkVOO_clm?Cdk002k>cS1_Cdk007k>?:b/6Yd/ZY
b/6O^KVY`K6O^KVG00:YZHl2/K6?00^iWgk/k>?dm>c/o?C/k>?dm?Cdm>c/
o?Cdm?Cdm>c/o?@01OCdk005m?Cdm?C/m?Cdm?C/k>cS00Cdk=/2m?C/0oCd
m009m?C/m?Cdm?C/m?C/m?Cdm?C/m?Cdm?C/m?Cd00;dm>`00nc/hoC/foC/
f`02m>cK0_Cdk00Qm?Cdoooooooom?Cdhm:Oo?cd`K6?Win?k>?:m?Cdm>cK
`KV7IFDjMWiLKFDRC4`jIE`Z>UALOWIU>UALOWi]ooook?cdm?Cdm?C/m?Cd
ooooQinaKHniKHnaQinahm;1o?cd00=UUk401[6aSooooncSb^c/hoCdm?Cd
k0;dm?@00oCdk?Cdm?Cdk002m?Cd00?dm>cdm?Cdm>`01_Cdm0;lo?@02ff?
UgJG/FF7ZOC/fooooinYZFFG/FenSm;:`Oclm>?B/@02m?Cd00?lo?Cdm?Cl
o?@00_Cdm003o?cdm?Cdm?Cd00;dm>`3m>cK0_Cdk005m?CdooooIE`IIFDj
hm:a00;lo?@01_C/fn?B/L[1ZKVOO/6iQncSbP;dm?@02Oclm?Cdk?Cdm?Cd
k?clm?Cdm?clm?Cdm?Cdk002o?cd0_Cdk0;dm?@01^c/hoclm?Cdm?Cdm?cl
m?Cdm0;lo?@00kVOO/c<c<c<c01ec<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^3?<c<`2A3XZ00Q4A394>RXI6AU<A294:R8R:RZOQfgSk?@2b]_K
00?<c<c:fm_:fm/00/[Kf`03hm_Kb]_Khm_K00W:fm/00kWBfl[KfkWBf`06
^M;K00>Yb]:id]^Yb]800[WBf`06ZL[B^M;KZL[BZL[B^M;K/L[:2JW:dP03
ZL7:ZL[BZL[B00:Yb]804[ViUoclm>c/hoclm>c/hn?/m?Cdk?Cdm>cK/N?B
/Nc/hoC/foCdm?C/foCdk?Cdm>?Kfnc/h`;dm>`2m?Cd0_Cdk006k?cdm?Cd
m?Cdfl6Om>?:o?cd1?Cdm00;m?C/m?Cdm?Cdm?C/m?Cdm?C/k?cdm?C/m?Cd
hncdm?C/00;/k><00oCdk>c/hoC/f`03k>cS00?ooolA4A4jA1T00UaLC00;
A4@ZC4`jA4A<8S8Z6B8RA3XZ>SXb<SY4A4@b>SXb>UAL008j>R84>SXb0Ta<
A008^Imnfl6Oc<c<KHMnC4`jUhmfb/6OWiN70SY46@09KFeD:R8IC4`j^Imn
m?C/k>cSm>cKk>cSk?cd00?/k><04NcSb_C/foC/fn?B/M;:ZL[1Wk6aSk6i
UjVYSk6aSk6iUkVaWinOSiN?M_CSb_Cdk>c/h`08m?C/00?dm?Cdm>cdm>`0
0oC/f`05k>?:k>cSm?C/m?C/m?Cd00?dm>`01_Cdm?Cdk>clm?Cdk?Cdm>c/
h`;dm?@02?Cdk?Cdm?Cdk?Cdk>clm?Cdk?C/foCdk0;dm?@09Oooonclm?Cd
m?clm?C/flc<c<[1ZOooom;:ZOCdk=;:`IN?QncSb_Cdm>clm?clm?C/ffe]
E1UfMSYDG4afOUb7Sff7OQ67UdafO_ooooCdk>c/hoCdm>clm?clm9nYZGjO
^Ff?^Ff?/M;:`Oooo`02KHna00EfUl6OWgkoooo/hl[/k><00_Cdm0;dm>`0
1?Cdm?Cdk?Cdm?Cdm0;dm>`00oCdm?Cdk?Cdm002m?Cd013dm>cdm?Cdm>cd
m>clo?AnShm]Sk5]SiOSfm_ooona/KUUQjU]QgkBbZWooooSd[43m?Cd00Gd
m>cdm?Cdm>cdm>c/k><00oC/f`05m?C/m?Cdm?Cdm?Cdo?cd00;dm>`03_oo
oin7KK6aSlZaZL6aSinOO[VGKL6iUn?B/Nc/hoclm?Cdm?Cdk?clm0;dm?@2
o?cd0_Cdm003o?cdm?C/o?cd00?dm?@01Oclm?Cdm?clm?Cdk?Cdm002o?cd
00Gdm?Clo?Clo?CoooniWgh0Mlc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Pcc<c<00YL>R94>R94A394A2XZ8QTI6ATb:R9<8PS1/KWSk?@2hm_K
00C:fm_Sfm_Sfm_Sfm/4b]_K00?Sfm_:fm_:fm/01<[Kf`04^M;Kb]_Kb]_K
^M;K1<[Kf`Nid]/01:W:d[WBfjW:d[WBf`:Yb]800kWBfjW:dZW:dP03ZL[B
00>id]_<c<bYb]801JW:dP:id]/01Lc<c<[Kflc<c<[KfncSbP02hm_K00Gd
m>c/fk7/fk7Sfm_dm?@00^c/h`0>m?Cdk>?:m?C/m?C/hncdm?C/k?cdm?Cd
m?C/m?Cdm?C/k?cdm>cKfl6O0_Cdm00;m?C/m?Cdm?C/m?Cdk?cdm?C/m?Cd
k?cdm?Cdm?C/m?Cd00;dm>`2k?cd00?/k>?Sd[7Sfm/01>c/h`04oooo8R8A
>SXROVED0Ta<A00<>T@bC4`j8S8Z:R8I>SXbC4`j>T@b<SY4A4@Z>TA<<RXR
8R8A0cXj<P0CA2XRC4`j>SXbZJV?`K6Ohm;1OWIDE6efShmUShM]o?cd^KVY
G5a<SgI4d/ZYC4@RID`Im?C/m>cK00;/hlX01>cK/NcK`OC/foC/f`;dm>`0
2>clm=_:Wm;:ZL6iWjVYSl6iUjVYSk6iU`:i^IL01;6iWjVYSm;:`Nclm0Kd
m>`2k>cS00Sdk=_/hl[dk=_Sfm_dm>c/k>?dm>c/o?@5m?C/0^clm008m?C/
m?Cdm?C/k?cdm?C/m?Cdm?C/m?Cd0_Cdk003k?cdm?C/m?C/00;dm?@01_cl
m?Cdk>c/hn?B/Ooool[1Z@:7UjT03GJG/Gj?SooooncSb^c/hn?B`InOSoC/
fnc/hncSb^clm?clm2XA20028TaD00HIMTC/hl[lo?@IMWI<MWkoool2m?C/
00[dm?Cdm>clo?BO`K5]SkU]Sk5nWkVi^JWooom]Sk42IINa00I]Qgkoooo/
k>?/hl[dm?Cdm>`2m?Cd00Cdm>cdm?Cdm>cdm?@3m?C/0_Cdm00Cm?C/m?Cd
m?Cdm?C/m?Cdm?C/ooooQiNYIINaG8NGd/[1oooo/K6iIHNYG8NG^KVGoooo
hm:am?Cd00;dm>`3m>cK0_Cdk003o?cdm?Cdm?C/00;dm?@01_clm?Cdk?Cd
m?Cdm?Cdk?ooo`:iWgh00m_1Wn?B`OCdk003o?cd00odm?Cdm>clo?Cdm?Cl
o?Cdm>clo?Cdm>cdm?Clo?Cdm?Clo?Cdm?Clo?Cdm>`00_clm003m?Cdo?cd
m?Cd00;lo?@00oCdm?clm?Cdk003o?cd00?1^HO<c<c<c<`0MLc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Pcc<c<00E<A294:R94:R8b:R8Z8QT0
0S8Z8P03G3XRfk6Yhm_K00;Sfm/01>c/hl[Kfn?/m>?Kf`;/k><02^?Kfn?/
m<[Kfl[Kfnc/hl[Kfn?Kfnc/hl[Kfnc/h`;:fm/00nc/hl[Kfl[Kf`03b]_K
00>id]_:fm_:fm/02KWBf`03ZL[B^M;K^M;K00>id]/01/[KfkWBfl[KfkWB
fjW:d[7:bP>id]/01/[KfkWBfkWBfl[Kflc<c;WBf`;:fm/01N?B/OCdk>?B
/N?B/N?/m002k>cS00Sdm?Cdhl[/k>?dm>cdm?Cdm>cdm?Cdm>`3m?Cd00Gd
m>cdk=_K/Iodm?Cdm>`00_Cdm003k?cdm?C/m?Cd00;dm>`01OCdm>c/hoCd
m?Cdk>clm003m?C/00C/k>?dm?C/k>?dm>`2k>cS00CSk?CooomUG1TI8R82
G5a<025<C3Y4A4`jA38jA4`I6ATR<RXjA4a4A38jA38j>S8jA4`I6A4R8Q54
A38jA38j>S8RA3Y<C4A4>RZa/Hni^IOdm>afOUaLKGInOVfGSgK/hl[1^Im]
Qgji/IoSd[6OWho1/Il00^c/h`06m?C/k>cSk?cdm?C/k>cSm?C/0^c/h`05
m>cKflZOd/ZYb/6O`K6O00:i^IL01jVYSk6iWk6iUk6iUjVYSm;:ZOCdm003
k>cS00_dk=_Sfm_dk=_dk=_/k>?dm>cdm?Cdm>c/o?Cdm>c/o?@01?Cdk003
m?Cdk>cSm?C/00?dm>`01OCdm?Cdk?Cdk?Cdk?Cdm008m?C/00cSfm^OZJV7
UjUfUk67UjWlo?C:fm]fUk5nWkUfUk67UjWlo?@2k>?:00?dm>bGShOSd/40
0oCdk003ooooWimn6E@b008IMWH026f7OXNGZAUfM[VaWoclm?Cdm>c/hoCd
k0;dm?@03M;:`Ff?^HNO/Ff?^InOSoooogJG/HNO/Io1/L6aWoclm>c/hncK
`@02m?Cd00Kdm>cdm?Cdm>cdm>cdm?Cdm>`2m?Cd0_Cdk0;dm?@2m?C/013d
m?Cdm>cdm?Clo?BOZJUfUk5UUk6i^JWoooo<c<aDSk5]SiNOWgkoooo:^Ho/
hlX3m?C/00Cdm?Cdm>cdm?Cdm>`2m?Cd0oCdk0;dm?@01?Cdk?Cdm?Cdk?Cd
m0?lo?@00oCdk?Cdm?Cdk005m?C/0_Cdm009o?cdm?Cdo?cdm?C/m?Cdm?C/
o?cdm?C/o?cd00;dm?@01_clm?Cdm?clm?Cdm?Cdk?clm0;dm?@01Oclm?Cd
m?Cdk?ooom_1W`1gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<
c<`024@Z8T@j:Ta<>S8Z8R8Z:SXj8S8Z8XM<A0;/k><04N?Kfnc/hn?Kfnc/
hn?Kfnc/hl[Kfn?Kfnc/hn?Kfnc/hn?Kfnc/hn?Kfnc/hn?Kfnc/h`02b]_K
00?/k>?:fm_:fm/02<[Kf`:id]/2b]_K00Jid]_:fm_:fm_:fm^id]_:fm/2
^M;K2<[Kf`04^M;Kb]_K^M;Kc<c<1l[Kf`0;KGIfm>cKm>?:hm_Khm:am?Cd
m>cKk>cShm_Km?Cdk>cS00;dm>`02_Cdm?Cdk>c/hoCdm?Cdk?Cdm?C/fn>Y
Soooon?/m0;dm>`4m?Cd00c/o?Cdm>c/o?Cdm>c/o?Cdm?Cdm>c/o?CSk?Cd
m>c/k>?/o?@4k>cS00CooonOWghjA1ULG4`3C4a4020jA394A38Z8QTj>S8b
>TA4A4`jA4a4>RY4A4a<C4@j>R94>RXj>S8jA38j>S9<C4@R>S:i^INiUfgl
o?B?SfDjE5anOVfOWgkSd[7Bb/5nOVeDKGInMVFa/Ho1/Iolo?@3k>cS00?d
m>c/k>?/k><00^c/h`0>m?C/k>cSflZOb/6Ob/6Yb/6O`KVO/KVG^KVG^K6O
/KVGZJV?OWi]^Imn0oC/f`;/k><00oCdk>c/hoCdk002m?C/00?/k>?/o?C/
k><01_Cdk003m?Cdm?C/m?C/00?dm>`00nclm>c/hnclm002m?C/01W/k>?d
m>c/k>?/k>?dk=_/k>?dm>c/k>?dm?AfUk5nWkV7b[67UjWlo?CSfm^7Wk5n
WkV7Wk5fUk7dm>cdk=_/hl[dm>a]KEC:`JT00oCdk004hncdo?cdWiN7MWiL
0QUfMP036FEnWin?o?cd00?dm>`01>clm>c/hoclm<c<c09]Sk402XNO/K6i
ZOooon?B`N?Kfl[KfinYZOclm>c/hn?B`@;dm?@2m?C/00?Sk?Cdm>cdm>`0
0oCdk007m?Cdm?C/m?Cdm?C/m?Cdm?C/m?Cd00;dm>`03OoooinYZGJG/FFG
/K6iZOclm<c<c4a]Qea]Qhn7E?ooon?B/Nc/h`02m?Cd00Kdm>cdm?Cdm?Cd
m>cdm?Cdm>`4m?Cd0_Cdk003m?Cdm?C/m?C/00Sdm>`01OCdm?Cdk?Cdm?cl
m?Cdk002m?Cd0_Cdk00<o?cdm?Cdo?cdm?C/m?Cdm?C/o?cdm?C/m?Cdo?cd
m?Cdo?cd0_Cdm007o?cdm?Cdm?C/o?cdm?Cdooood/ZY07O<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h<lc<c004A2XRA4@bA3XZA3XZ0T@Z8P08
:R8IWhM]m?C/k>cShm_Khncdk>cShm_K1^c/h`06hncdk>cSk>cShncdk>cS
hncd0nc/h`06hm_Khncdhm_Kk>cSb]_Kk>cS4<[Kf`03k>cSb]_Kb]_K00K:
fm/00lc<c<[Kfl[Kf`04b]_K00gSfm_:fm_:fm_/k>>YZHn?OVgoooodhl[S
d/7/k>?Sfm_dm?C/hlX01OCdk008m?Cdm?C/hncdk?cdm?Cdk>cSk:Ufk?cd
0_Cdm004m?C/m?Cdk>cSm?Cd0_Cdk008m?Cdm?C/m?Cdm?Cdk>cSm?Cdk>cS
k?cd0^c/h`0Am?C/k?cdm?Cdm?C/o?cdooooUhmf8S8ZG5a<C4`jC4a4A4@b
C4a4>TA<6ATI:R8IA4@b00<j>S84A4@b01@jA4`jA38jA4a4A4`b:R:i^JVO
Sfglo?B?QfeLG4a]KEBOWho1/IoSfm]fOUa]Qgi]KEBOUhNGSgKSfm/7k>cS
00?dm>c/k>?dm>`00^?B/@0;b/6O`KVO/KVGUhn7UhmfWimnUhmfZJV?Uhn7
`K6?o?cd00;/k><@m?C/00?/k>?dm>cdm>`01OCdk003k>cSm>cKk>cS00;d
m>`02?Cdm?Cdk>?/m?Cdm?Cdk>clm?Cdk8NO/@9nWkT017JG/OCdk>c/hhNO
/@9nWkT027JG/OC/foCdk>cK/OooogInG;6iZOclm0?dm>`02>c/hoclm?C/
fgInG;6iUjVYSoclm?Cdm0;dm>`03^?/m?Cdk?Cdm>clm>?Kflc<c?C/fl[K
fm;:`OoooinYZFFG/Ff?/Eb7S`;lo?@01^?B/OCdm?Cdm?Cdk?Cdm?Cdk0;d
m?@01>clm?Cdk>clm?Cdm0;dm>`06?Cdm>clm?Cdk?Cdk?Cdm?Cdk?clm9nY
ZEb7Uda]Qhn7KOclm>?B`GJG/K7:bYn?KOooon?B/OC/fnclm?Cdm?Cdk?Cd
m?Cdk0;dm?@00oCdk?Cdm?Cdk003m?C/0_Cdm003m?C/m?Cdm?Cd00;dm>`2
m?Cd0oCdk008m?Cdm?C/m?C/m?Cdm?C/o?cdm?Cdo?cd0_Cdm003o?cdm?Cd
m?Cd00;lo?@00oCdm?clm?clm002m?Cd00[lo?Cdm>clo?Cdm?Clo?Cdm?Cl
o?Cdm?Clo?C/fk5gc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<
c<`02Da48T@j:T@Z8S8Z8R8Z:QTI6B8R4LZaZN?/m003hm_K0^c/h`05hncd
k>cSk>cSk>cShncd00C/k><01>?/m>c/hnc/hn?/m0G/k><01n?/m>c/hn?/
m<[Kfnc/hl[Kfn?/m005b]_K00?Sfm_:fm_Sfm/00nc/h`[:fm/01KWBfl[K
fl[Kfl[Kfnc/h`04b]_K00oSfm_:fm_ooomUE3;:`JWdm>c/hl[Sd/7Sd[7d
m?C/k>?dm>c/k>?dm>c/o?@00_Cdk00>k?cdm?C/m?C/m?C/k>cShjV?oooo
m?Cdm?C/m?Cdm?C/k?cdm?C/hncd0_Cdk00fm?Cdk>cSm?Cdm?Cdk?cdk>cS
m>cKk>?:m?C/`K6ihm:ad/ZY/K6?/KVG^ImnOVe<A4@bC4a4A3XZC4`jA4A<
>T@b>SXb6B8R8RXZA4@b>SXbA4@b<SY4>SXb>T@b>TA<A4@b<SY4>T@b>SXb
A4A<8RXZb/6YShmUo?cdWimn>UALC4`j^K6O`K6Ok>cSOWIUKGIfIFDj/KVG
Uhmfk=_1m?C/1>c/h`03m?C/k>cSk>cS00;/k><01L6aSjVYSiN?MZVYSkVO
OP03/K6?00JYZHni^JVOWhnOWgklo?C/k><2m?C/00CSk?Cdm>cdm>cSk?@2
m?C/00?/k>?dm>cdm>`01_Cdk003k?cdm?C/k>cS00C/k><2m?C/00c/o?Cd
m>cdm?C/k>?dm>c/o?C/k>?/o?C/k>?dm>clo?B7UjT3OYni00?dk=_dm?B?
WkT00WjO^@09MYNak>?:m?Cdd/ZYoooo/K6?WiN7m?C/hncd00?dm>`06^?/
m?Cdm?CSb_clm?ooooCdm>?/m>c/hnclm?Cdk>clm>c/hoCdm>c/hhna`Ff?
^Ff?/Ff?Uooook7:bVf?^GJG/Ff?Unc/hn?/m>?B/@;dm?@01>clm?Cdk?Cd
m>c/h`Kdm>`04?Cdm?Cdk?Cdk?Cdk>c/hoC/fncSb_clm<[1ZGJG/INibYnY
ZOCdm?Cdk=;:`Nc/h`;lo?@00n?B/NcSb_Cdm002m?Cd1?Cdk007m?Cdm?C/
m?Cdm?Cdm?C/m?Cdm?C/00;dm?@4m?C/00?dm?Cdm>cdm>`00oCdk0;dm?@0
2?Cdk?Cdm?Cdk?Cdk?Cdm?Cdk?clm?Cdm0;lo?@5m?Cd00Sdm>clo?Cdm>cl
o?Cdm?Clo?Cdm?Clo?@2m?Cd00?lo?Cdk=_<c<`0M/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Pcc<c<00e4A394>RY4>RXZ8QTb:R94A38R8Q7S
d/7/k>?Sfm_/k>?Sfm_/k><00^?Kf`07hncdk>cShncdk>cShncdk>cShncd
00;/k><01^?/m>c/hnc/hn?/m>c/hn?/m0?/k><00l[Kfnc/hn?/m004b]_K
00cSfm_:fm_:fm_Sk?C:fm_Sk?CSfm_/k>?Sk?C/k>?Sk?CSfm/2k>cS00K:
fm_Sfm_:fm_/k>?:fm_Sfm/6b]_K00?Sfm_:fm_/k><00/[Kf`0;m?Cdoooo
IE`Zm>cKm?C/k>?:b/6Ok>?:k>cSm?C/k>cS00;dm>`2k?cd01g/k>?/o?Cd
m>cSk?C/o?CKWfg/o?CSk?Cdm>cSk?C/o?Cdm>c/o?Cdm>cSk?C/o?CSk?Cd
m>c/o?C/k>?/o?Cdm?C1^IO1^HOlo?A<C4A4A2Xj>R9LG4`00UA]MP0AA4@b
C4a4C4`j>SXb<SY4C4`jA4A<C4`j8RXZ6ATIA4@bA4A<<SY4>SXb<SY4>SXb
<SY400@j>S804DA4C2XR6L6aWhmfIOclm;6iZFe]E4a<>YnOO[VOO_clm8n?
IGj?Sda<>[6iUiN?M^?B`@04k>cS00?dk=_/hl[/hlX00^cSbP0>hm_Khm:a
hm:ab/6O`KVO`KVG/K6?/KVG^KVY/K6?ZJV?/K6?Uhmfo?cd0^c/h`;dm>`0
0nc/hoCdk?Cdk008m?C/1>c/h`0Dm?C/k>cSk?cdm?C/k?cdm?C/k>cSm?C/
k>cSk?cdk>cSk?cdk>cSk?cdm?C/k>cSk?cdm?C/o?cdSk710WjO^@04KHni
hm;1o?cdWl6a0WjO^@0CKHnifl6Om?Cdhm:aoooob[6YWin?o?cdk>cSm?Cd
hncdm?C/k>cSo?cd/K6?b]_Kd/[1hm;1m?Cd00;dm>`01^c/hoCdm?Cdk?Cd
k>c/hhNO/@9]SkT03GJG/Oooolc<c6f?/GJG/FF7ZNcSb_ooon?BWn?/m?Cd
k?Cdm>c/h`02m?C/00?dm?Cdm>cdm>`00oCdk005k>cSm>cKm>cKk>cSm?C/
00;dm?@01Nclm>cSb];:`N?B`NcSbP02o?cd00O/k>?:`JW1^INiWgk:^HoS
d[7/o?@00_Cdk006m?Cdk?cdm?C/m?Cdm?C/k?cd0oCdk00;m?Cdm?C/m?Cd
m?Cdm?C/m?Cdk?cdm?C/m?Cdm?C/m?Cd00;dm>`01OCdm?Cdk?Cdk?Cdm?Cd
k002m?Cd00?dm>cdm?Cdm>`00oCdk007o?cdm?C/m?Cdo?cdm?Cdo?cdm?C/
00Cdm?@01_clm?Cdk?clm?Cdm?clm?C/fgO<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h<lc<c00:C4`jG3XR<RXRA2XR:R8IC288c<c<o?cdhm_K
hncd0^c/h`03hm_Khncdk>cS00S/k><01n?/m>c/hnc/hn?/m>c/hn?/m>c/
h`02hncd0nc/h`03b]_Kk>cSk>cS00G/k><00l[Kfnc/hl[Kf`04k>cS00GS
fm_/k>?:fm_Sk?C/k><03/[Kf`0;hm_Kb]_Kk>cSoooob[6YIFDjm?C/m>cK
fk6Yhm;1k?cd00;/k><5m?C/00S/k>?dm>cdm>c/o?CKOTcoooodm>c/o?@4
m?C/01;/o?Cdm>cdm>cdm>c/o?C/k>?dm>c/k>?/o?CBb/6a/Holo?BGSgI<
C3Y<C4A4A4aLKGI]MWH2C4`j00i<C4A4A2Y4A394A4a4A39<C4@R:RXI6AU<
C3XjA38b>TA<C3Y4>RY4A4`2>SXb01XjA394A38j>S9<C4@b:R:i^INOWgk/
k>?K`Im]KEA4A2ZYZHn?Qfglo?BGSgI]Qgi<C3Za^INGShO1/Iodhl[/hl[/
fl7/hl[/fl7Sfm/4k>cS00K/hl[BbZWBbZW1^Ini/InYZHl2^KVG00F?Uhna
^INYZHnGSgKlo?@00nc/h`06m?C/k>cSk>cSm?C/k>cSm?C/0nc/h`04m>cK
k>cSk>cSk>cS0_Cdk0?/k><2m?C/00?/k>?/o?C/k><00_Cdk0;/k><2m?C/
00?/k>?dm>cdm>`00^c/h`08o?cdSk71MYNaOYniKHnahm;1m?CdWl6a0WjO
^@0XMYNa`KVGoooohm:am?Cdk>?:^KVGo?cdk>cSm?C/k>cSk?cdm?C/oooo
IFDj>UAL/KVY^KVYo?cdk?cdhncdm?Cdk>cShncdm?C/m?CdSiniOYniKHna
KHnGooooc<c<IINaKHnaIINahm:am?Cdd/ZYm?Cdhncd1?Cdk003k>cSm>cK
k>cS00;dk=/01>c/hoCdk?Cdm>?/m0?dm>`01nc/hoCdm?Cdk?Cdk>?Kfm;:
ZL6iU`02^Imn00?Sd[7Sd/7dm>`01OCdm0?dm>`01OCdm?Cdk?Cdm?Cdm?Cd
k002m?Cd00?dm>c/k>?dm?@00_Cdk003m?Cdm?C/m?C/00Gdm?@01OCdk?Cd
m?Cdm?Cdk?Cdm002m?C/1?Cdm004o?cdm?Cdm?Cdo?cd0oCdm005o?cdm?C/
o?cdm?Cdo?cd00;dm>`01?clm?Cdk?clm?clm7O<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h<lc<c009C4`jA3XZA3XR>T@I8R8Ad/[1o?cdk>cS
hm_K00?/k><02n?/m>c/hnc/hnc/hn?/m>c/hn?/m>c/hn?/m>c/hn?/m009
k>cS00_Sk?C/k>?Sk?C/k>?Sk?C/k>?Sk?C/k>?Sk?C/k>?Sk?@00nc/h`06
b]_Khncdk>cShncdk>cShncd0^c/h`07b]_Khncdk>cSb]_Kk>cSb]_Kk>cS
00?:fm/01Nc/hl[Kfnc/hl[Kfnc/h`02b]_K00G/k>?Sfm_oooo:/JVOUhL0
0_Cdk003hm;1k>?:k>?:00?dm>`2m?Cd00Kdm>c/o?Cdm?Cdm?Coooo/ZGH2
m?Cd00?dm>cdm?Cdm?@00_Cdm003m?C/m?Cdm?Cd00;dm>`2m?Cd00odm>cd
m?C/hl[1^HOdm>bGSgHjA39LG4a4A4aDKGILKGI4A2Y<C3Y<C4A<C3X00TA4
<P07<SY4A4@b8RXZ6ATI>TA<C4`j8T@j008b>T@02SY4<SXj<R94>SXj<S8j
A28j<TA4<R8j<[6aSinGQ`;/hlX03SYDG38Z8Xn7KInOO_clm;6iUfefMR8j
<YnGQhn7KL6aSoclm?Cdk?Cdm0?dm>`01Nc/hoCdk>c/hoclm>cSbP02d/ZY
00_:`Ini/Ini/Ina^Ina^INYZHo:`JVa^INOUhOlo?Cdm>`00_clm003m?Cd
m?C/o?cd00?dm>`01>c/hoclm?Cdm?clm0;dm?@2o?cd0_Cdm007o?cdm?C/
o?cdm?Cdo?cdm?Cdo?cd00;dm?@3o?cd00?dm?Clo?Cdm?@00oclm00Coooo
/K6iKHniOYniKHnid/[1ooooc<c<KHniOYniKHni^Imnoooom>?:o?cdm>cK
`KVGooook>cS00?lo?@01OCdm?clm>c/hgInG6f?U`08o?cd00Oooona/KUU
Uk5]SkUUUk7oooo/k><00Vf?^@05IINad/ZYooook=_1oooo00;lo?@4m?C/
0oclm003ooooo?cdo?cd00;lo?@01?ooooclm?clm?ooo`;lo?@01KVOO]:a
Sn?B/OC/foclm003oooo0oclm004oooom?Cdo?cdo?cd0_ooo`03m?Cdo?cd
oooo00Glo?@01?ooooclm?clm?ooo`;lo?@00oooooCdm?clm002o?cd00_o
ooodm?Coooolo?Coooodm?Coooodm?Coooodm?Coool00_Cdm003o?cdm?Cd
m?Cd00?dm?@;k?cdMlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c0[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<`:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<2/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c0[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<`:c<c<0XS0^058T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^0f8`;P1B9280@00000000B8`;S8
h=R8`;R8`;PE00200P01P0<00X0200>10`04P@801H4300J200D01h811h81
2881288128<00P49P`<12X<00`4;P`4;Q04<Q0020@b40P4=Q0030@j40@j5
0@j500823hD30Q250P8AQP<24XH20Q>60`8DQ`825HL20QJ700<35XP35hP3
5hP00`<HR0030aV80aV90aZ900836XT20a^900<378T378X378X00P<MRP<4
7XX211n;0`@PR`848H/312:<0P@SS08498`00`@TS@@US@DUS@031BJ=00<5
9hd59hh5:8h00PDXSP85:Hh00`DZSPDZS`DZS`021B^?0`D/S`86;I021Rj@
0`H_T086<9431S6A0PHbT@<6<i801@HdTPLdTPLeTPLeTPLeT`021cJC0`Lg
T`031cRC1cRD1cVD0087>I@21cZD00<7>i@7>iD7>iD00PPlU@<8?ID223jF
0`PoUP88@9H3246G0PQ2U`88@iL00`U3V0U4V0U4V0032DFH00<9AYP9AYT9
AiT00PU7V@89B9T00`U9V@U9VPU9VP022DZJ0`Y;VP8:C9/32TfK0PY>V`<:
Ci`22U2L0PYAW0032U6M2U:M2e:M00<;Did00`]DW@]DWP]EWP022eFN0P]F
WP032eNN2eNO2eNO008;F9l32eVO0PaJX08<Fj0335bP0PaMX@<<GZ4235nQ
0`aPXP05366R3F6R3F:R3F:R3F:S008=Hj<33FBS00<=IJ<=IJ@=IZ@00PeV
Y08=Ij@00`eXY0eXY@eXY@023VVU0`iZY@8>JjH33VbV0Pi]YP<>KZL23VnW
0Pi`Y`033g2X3g6X3g6X00<?LZP00`mcZ0mcZ@mdZ@023gBY0PmeZ@033gJY
3gJZ3gJZ008?MjX347RZ0Q1iZ`<@NZ/247^[0a1l[08@OJ`247j/00<@OZd@
OjdAOjd00a60[@034H6]4H6^4H:^008APZh24H>^00<AQ:hAQ:lAQ:l00Q65
[`<AQZl24XN`0Q:8/0<BRK024XZa0a:;/@8BS;434Xfb00DBS[8CS[8CSk8C
Sk8CSk<00Q>@/`<CTK<00a>B/a>B]1>C]0024i>d0Q>D]0034iFd4iFe4iFe
008DU[D359Ne0QBH]P<DVKH259Zf0aBK]`8DW;L259fg00<EWKPEW[PEW[P0
0aFO^0035J2h5J2i5J6i008EXKT25J:i00<EXkTEXkXEXkX00QFT^P<FYKX2
5ZJk0aJW^`8FZ;/35ZVl0QJZ_08FZk`00aJ[_AJ/_AN/_@035jfm00<G[[dG
[[hG[kh00QN__P8G/;h00aNa_QNa_aNa_`025k:o0QNc_cHH]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h1000P003VjOa<d>U<d>U00Tc@jD50020
0P01P0<00X0200>10`04P@801H4300J200D01h811h812881288128<00P49
P`<12X<00`4;P`4;Q04<Q0020@b40P4=Q0030@j40@j50@j500823hD30Q25
0P8AQP<24XH20Q>60`8DQ`825HL20QJ700<35XP35hP35hP00`<HR0030aV8
0aV90aZ900836XT20a^900<378T378X378X00P<MRP<47XX211n;0`@PR`84
8H/312:<0P@SS08498`00`@TS@@US@DUS@031BJ=00<59hd59hh5:8h00PDX
SP85:Hh00`DZSPDZS`DZS`021B^?0`D/S`86;I021Rj@0`H_T086<9431S6A
0PHbT@<6<i801@HdTPLdTPLeTPLeTPLeT`021cJC0`LgT`031cRC1cRD1cVD
0087>I@21cZD00<7>i@7>iD7>iD00PPlU@<8?ID223jF0`PoUP88@9H3246G
0PQ2U`88@iL00`U3V0U4V0U4V0032DFH00<9AYP9AYT9AiT00PU7V@89B9T0
0`U9V@U9VPU9VP022DZJ0`Y;VP8:C9/32TfK0PY>V`<:Ci`22U2L0PYAW003
2U6M2U:M2e:M00<;Did00`]DW@]DWP]EWP022eFN0P]FWP032eNN2eNO2eNO
008;F9l32eVO0PaJX08<Fj0335bP0PaMX@<<GZ4235nQ0`aPXP05366R3F6R
3F:R3F:R3F:S008=Hj<33FBS00<=IJ<=IJ@=IZ@00PeVY08=Ij@00`eXY0eX
Y@eXY@023VVU0`iZY@8>JjH33VbV0Pi]YP<>KZL23VnW0Pi`Y`033g2X3g6X
3g6X00<?LZP00`mcZ0mcZ@mdZ@023gBY0PmeZ@033gJY3gJZ3gJZ008?MjX3
47RZ0Q1iZ`<@NZ/247^[0a1l[08@OJ`247j/00<@OZd@OjdAOjd00a60[@03
4H6]4H6^4H:^008APZh24H>^00<AQ:hAQ:lAQ:l00Q65[`<AQZl24XN`0Q:8
/0<BRK024XZa0a:;/@8BS;434Xfb00DBS[8CS[8CSk8CSk8CSk<00Q>@/`<C
TK<00a>B/a>B]1>C]0024i>d0Q>D]0034iFd4iFe4iFe008DU[D359Ne0QBH
]P<DVKH259Zf0aBK]`8DW;L259fg00<EWKPEW[PEW[P00aFO^0035J2h5J2i
5J6i008EXKT25J:i00<EXkTEXkXEXkX00QFT^P<FYKX25ZJk0aJW^`8FZ;/3
5ZVl0QJZ_08FZk`00aJ[_AJ/_AN/_@035jfm00<G[[dG[[hG[kh00QN__P8G
/;h00aNa_QNa_aNa_`025k:o0QNc_cHH]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0`00P007VjOaooooSWZfYY_4/jWBZ9g8/jWB00:VVl@01Kbh
gNk^m>[YlOoooc=3Y@0400200P01P0<00X0200>10`04P@801H4300J200D0
1h811h812881288128<00P49P`<12X<00`4;P`4;Q04<Q0020@b40P4=Q003
0@j40@j50@j500823hD30Q250P8AQP<24XH20Q>60`8DQ`825HL20QJ700<3
5XP35hP35hP00`<HR0030aV80aV90aZ900836XT20a^900<378T378X378X0
0P<MRP<47XX211n;0`@PR`848H/312:<0P@SS08498`00`@TS@@US@DUS@03
1BJ=00<59hd59hh5:8h00PDXSP85:Hh00`DZSPDZS`DZS`021B^?0`D/S`86
;I021Rj@0`H_T086<9431S6A0PHbT@<6<i801@HdTPLdTPLeTPLeTPLeT`02
1cJC0`LgT`031cRC1cRD1cVD0087>I@21cZD00<7>i@7>iD7>iD00PPlU@<8
?ID223jF0`PoUP88@9H3246G0PQ2U`88@iL00`U3V0U4V0U4V0032DFH00<9
AYP9AYT9AiT00PU7V@89B9T00`U9V@U9VPU9VP022DZJ0`Y;VP8:C9/32TfK
0PY>V`<:Ci`22U2L0PYAW0032U6M2U:M2e:M00<;Did00`]DW@]DWP]EWP02
2eFN0P]FWP032eNN2eNO2eNO008;F9l32eVO0PaJX08<Fj0335bP0PaMX@<<
GZ4235nQ0`aPXP05366R3F6R3F:R3F:R3F:S008=Hj<33FBS00<=IJ<=IJ@=
IZ@00PeVY08=Ij@00`eXY0eXY@eXY@023VVU0`iZY@8>JjH33VbV0Pi]YP<>
KZL23VnW0Pi`Y`033g2X3g6X3g6X00<?LZP00`mcZ0mcZ@mdZ@023gBY0Pme
Z@033gJY3gJZ3gJZ008?MjX347RZ0Q1iZ`<@NZ/247^[0a1l[08@OJ`247j/
00<@OZd@OjdAOjd00a60[@034H6]4H6^4H:^008APZh24H>^00<AQ:hAQ:lA
Q:l00Q65[`<AQZl24XN`0Q:8/0<BRK024XZa0a:;/@8BS;434Xfb00DBS[8C
S[8CSk8CSk8CSk<00Q>@/`<CTK<00a>B/a>B]1>C]0024i>d0Q>D]0034iFd
4iFe4iFe008DU[D359Ne0QBH]P<DVKH259Zf0aBK]`8DW;L259fg00<EWKPE
W[PEW[P00aFO^0035J2h5J2i5J6i008EXKT25J:i00<EXkTEXkXEXkX00QFT
^P<FYKX25ZJk0aJW^`8FZ;/35ZVl0QJZ_08FZk`00aJ[_AJ/_AN/_@035jfm
00<G[[dG[[hG[kh00QN__P8G/;h00aNa_QNa_aNa_`025k:o0QNc_`8H]<0P
00000QRd`10000026;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
080019^WlOooofaJYJnUbP:l^=d02_omok>Yd_oooooookbhgIN:_:RMb>KV
k?oooc=3Y@<0080200600`02P0800h4300B10P05P@<01X801@07PP47PP48
PP48PP48P`020@V30`4:P`030@^30@^40@b4008138@20@f400<13X@13XD1
3XD00P8?Q@<248D20Q660`8BQP824hH30QB70P8EQ`825XL00`<FR0<GR0<G
R0030aR800<36HP36HT36XT00P<JR@836hT00`<LR@<LRP<LRP020af:0`@N
RP847h/3122;0P@QR`<48X`212><0P@TS00312B=12F=1BF=00<59Xd00`DW
S@DWSPDXSP021BR>0PDYSP031BZ>1BZ?1BZ?0085:hl31Bb?0PH]T086;Y03
1Rn@0PH`T@<6<I421S:A0`HcTP051SBB1cBB1cFB1cFB1cFC0087=Y<31cNC
00<7>9<7>9@7>I@00PLiU087>Y@00`LkU0LkU@LkU@0223bE0`PmU@88?YH3
23nF0PQ0UP<8@IL224:G0PQ3U`032D>H2DBH2DBH00<9AIP00`U6V0U6V@U7
V@022DNI0PU8V@032DVI2DVJ2DVJ0089BYX32T^J0PY<V`<:CI/22TjK0`Y?
W08:D9`22U6L00<:DId:DYd;DYd00`]CW@032eBM2eBN2eFN008;EIh22eJN
00<;Eih;Eil;Eil00P]HW`<;FIl235ZP0PaKX0<<G:0235fQ0`aNX@8<Gj43
362R00D<HJ8=HJ8=HZ8=HZ8=HZ<00PeSX`<=I:<00`eUX`eUY0eVY0023FJT
0PeWY0033FRT3FRU3FRU008>JJD33VZU0Pi[YP<>K:H23VfV0`i^Y`8>KjL2
3W2W00<?L:P?LJP?LJP00`mbZ0033g>X3g>Y3gBY008?M:T23gFY00<?MZT?
MZX?MZX00PmgZP<@N:X247V[0a1jZ`8@Nj/347b/0Q1m[08@OZ`00a1n[A1o
[A5o[@034H2]00<APJdAPJhAPZh00Q62[P8APjh00a64[Q64[a64[`024HF_
0a66[`8BQk024XR`0a:9/08BR[434X^a0Q:</@<BSK801A:>/Q>>/Q>?/Q>?
/Q>?/`024i2c0a>A/`034i:c4i:d4i>d008CTk@24iBd00<CUK@CUKDCUKD0
0QBF]@<DUkD259Rf0aBI]P8DV[H359^g0QBL]`8DWKL00aFM^1FN^1FN^003
5Inh00<EX;PEX;TEXKT00QFQ^@8EX[T00aFS^AFS^QFS^P025JBj0aJU^P8F
Y[/35ZNk0QJX^`<FZK`25ZZl0QJ[_0035Z^m5Zbm5jbm00<G[Kd00aN^_AN^
_QN__P025jnn0QN`_P035k6n5k6o5k6o008G/[l25k>o0QRd`003b>3HB928
B92800a8T8P00`000<SPf4R@R00=B92800@0000H]<0H]<38h=P>B92800<0
000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0^8S0^08008002i^W
lOooojRMb?oook>YdV1<VXij]WQU[ZRMb?ooooomo`03oooo00<c@jD00800
08000P00P0800H0300:00P03P@<0184200F10`06PP0500N20@N20@R20@R2
0@R300812H<30@Z300<12h<12h@138@00P4<Q0813H@00`4>Q04>Q@4>Q@02
0Pn50`8@Q@824HH30Q:60P8CQP<258L20QF70P8FQ`030aJ80aN80aN800<3
68P00`<IR0<IR@<JR@020aZ90P<KR@030ab90ab:0ab:00837HX311j:0P@O
R`<488/2126;0`@RS0848h`212B<00<498d49Hd59Hd00`DVS@031BN=1BN>
1BR>0085:8h21BV>00<5:Xh5:Xl5:Xl00PD[S`<5;8l21Rf@0PH^T0<6;i02
1S2A0`HaT@86<Y431S>B00D6=987=987=I87=I87=I<00PLfT`<7=i<00`Lh
T`LhU0LiU0021cVD0PLjU0031c^D1c^E1c^E0088?9D323fE0PPnUP<8?iH2
242F0`Q1U`88@YL224>G00<9@iP9A9P9A9P00`U5V0032DJH2DJI2DNI0089
AiT22DRI00<9BIT9BIX9BIX00PU:VP<:BiX22TbK0`Y=V`8:CY/32TnL0PY@
W08:DI`00`YAW@YBW@]BW@032e>M00<;E9d;E9h;EIh00P]EWP8;EYh00`]G
WP]GW`]GW`022eRO0`]IW`8<FZ0235^P0`aLX08<GJ4335jQ0PaOX@<<H:80
1@aQXPeQXPeRXPeRXPeRX`023F>S0`eTX`033FFS3FFT3FJT008=IZ@23FNT
00<=J:@=J:D=J:D00PiYY@<>JZD23V^V0`i/YP8>KJH33VjW0Pi_Y`8>L:L0
0`m`Z0maZ0maZ0033g:X00<?LjP?LjT?M:T00PmdZ@8?MJT00`mfZ@mfZPmf
ZP023gNZ0a1hZP8@NJ/347Z[0Q1kZ`<@O:`247f/0Q1n[00347j]47n]4Gn]
00<AP:d00a61[A61[Q62[P024H:^0Q63[P034HB^4HB_4HB_008AQJl34HJ_
0Q:7/08BR;034XV`0Q::/@<BRk424Xba0a:=/P054Xjb4hjb4hnb4hnb4hnc
008CT;<34i6c00<CT[<CT[@CTk@00Q>C]08CU;@00a>E]1>E]A>E]@0259Je
0aBG]@8DV;H359Vf0QBJ]P<DVkL259bg0QBM]`035Ifh5Ijh5Ijh00<EWkP0
0aFP^1FP^AFQ^@025J6i0QFR^@035J>i5J>j5J>j008EY;X35ZFj0QJV^`<F
Yk/25ZRk0aJY_08FZ[`25Z^l00<FZkdF[;dG[;d00aN]_@035jjm5jjn5jnn
008G[kh25k2n00<G/KhG/KlG/Kl00QNb_`8G/kl26;C000?8h=R8`;R8`;P0
2hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8
T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00>
VjOaoooooooofmc/H4bJThFj/jWB_;SMH4bJVHnnYY_4b<?Ooooo<d>U1@00
P003oooo006000:000800X001003POooo`04P@04P@Coool200J200D01h;o
ool128;oool128<00P49P`04oooo0@Z30@Z30@^30oooo`040@b40@f40@f4
oooo0P4>Q@823hD00`8@QOooo`8@Q@020Q6600<24XKoooooool00_ooo`82
58L02Oooo`8EQ`8EQoooo`8FQ`<FR?ooo`<GR0<HR003oooo00@36HT36XT3
6XT36XT20a^900<378T378X378X00P<MRP<47XX211n;0`@PR`848H/312:<
0P@SS08498`00`@TS@@US@DUS@031BJ=00<59hd59hh5:8h00PDXSP85:Hh0
0`DZSPDZS`DZS`021B^?0`D/S`86;I021Rj@0`H_T086<9431S6A0PHbT@<6
<i801@HdTPLdTPLeTPLeTPLeT`021cJC0`LgT`031cRC1cRD1cVD0087>I@2
1cZD00<7>i@7>iD7>iD00PPlU@<8?ID223jF0`PoUP88@9H3246G0PQ2U`88
@iL00`U3V0U4V0U4V0032DFH00<9AYP9AYT9AiT00PU7V@89B9T00`U9V@U9
VPU9VP022DZJ0`Y;VP8:C9/32TfK0PY>V`<:Ci`22U2L0PYAW0032U6M2U:M
2e:M00<;Did00`]DW@]DWP]EWP022eFN0P]FWP032eNN2eNO2eNO008;F9l3
2eVO0PaJX08<Fj0335bP0PaMX@<<GZ4235nQ0`aPXP05366R3F6R3F:R3F:R
3F:S008=Hj<33FBS00<=IJ<=IJ@=IZ@00PeVY08=Ij@00`eXY0eXY@eXY@02
3VVU0`iZY@8>JjH33VbV0Pi]YP<>KZL23VnW0Pi`Y`033g2X3g6X3g6X00<?
LZP00`mcZ0mcZ@mdZ@023gBY0PmeZ@033gJY3gJZ3gJZ008?MjX347RZ0Q1i
Z`<@NZ/247^[0a1l[08@OJ`247j/00<@OZd@OjdAOjd00a60[@034H6]4H6^
4H:^008APZh24H>^00<AQ:hAQ:lAQ:l00Q65[`<AQZl24XN`0Q:8/0<BRK02
4XZa0a:;/@8BS;434Xfb00DBS[8CS[8CSk8CSk8CSk<00Q>@/`<CTK<00a>B
/a>B]1>C]0024i>d0Q>D]0034iFd4iFe4iFe008DU[D359Ne0QBH]P<DVKH2
59Zf0aBK]`8DW;L259fg00<EWKPEW[PEW[P00aFO^0035J2h5J2i5J6i008E
XKT25J:i00<EXkTEXkXEXkX00QFT^P<FYKX25ZJk0aJW^`8FZ;/35ZVl0QJZ
_08FZk`00aJ[_AJ/_AN/_@035jfm00<G[[dG[[hG[kh00QN__P8G/;h00aNa
_QNa_aNa_`025k:o0QNc_`8H]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8
T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004
B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<00800
3Y^WlOoookbhgIV?__ooomKAgM_Lk??nojJKa>k^m8Ef/9>5^_oooc=3Y@@0
08002_ooo`01P002P?ooo`02P003POooo`04POooo`04P@801H402?ooo`06
PP06P_ooo`47PP48P_ooo`48P`812H<01Oooo`4:P`4:Poooo`4;Q0020@b4
00Coool13H@13HCoool20@j50P8?Q@030Q25oooo0Q2500824HH01Oooo`8B
QP8BQP8CQ_ooo`020QB700Woool25HL25HOoool25XL35XSoool35hSoool0
0P<HR0030aV8oooo0aZ900836XT20a^900<378T378X378X00P<MRP<47XX2
11n;0`@PR`848H/312:<0P@SS08498`00`@TS@@US@DUS@031BJ=00<59hd5
9hh5:8h00PDXSP85:Hh00`DZSPDZS`DZS`021B^?0`D/S`86;I021Rj@0`H_
T086<9431S6A0PHbT@<6<i801@HdTPLdTPLeTPLeTPLeT`021cJC0`LgT`03
1cRC1cRD1cVD0087>I@21cZD00<7>i@7>iD7>iD00PPlU@<8?ID223jF0`Po
UP88@9H3246G0PQ2U`88@iL00`U3V0U4V0U4V0032DFH00<9AYP9AYT9AiT0
0PU7V@89B9T00`U9V@U9VPU9VP022DZJ0`Y;VP8:C9/32TfK0PY>V`<:Ci`2
2U2L0PYAW0032U6M2U:M2e:M00<;Did00`]DW@]DWP]EWP022eFN0P]FWP03
2eNN2eNO2eNO008;F9l32eVO0PaJX08<Fj0335bP0PaMX@<<GZ4235nQ0`aP
XP05366R3F6R3F:R3F:R3F:S008=Hj<33FBS00<=IJ<=IJ@=IZ@00PeVY08=
Ij@00`eXY0eXY@eXY@023VVU0`iZY@8>JjH33VbV0Pi]YP<>KZL23VnW0Pi`
Y`033g2X3g6X3g6X00<?LZP00`mcZ0mcZ@mdZ@023gBY0PmeZ@033gJY3gJZ
3gJZ008?MjX347RZ0Q1iZ`<@NZ/247^[0a1l[08@OJ`247j/00<@OZd@OjdA
Ojd00a60[@034H6]4H6^4H:^008APZh24H>^00<AQ:hAQ:lAQ:l00Q65[`<A
QZl24XN`0Q:8/0<BRK024XZa0a:;/@8BS;434Xfb00DBS[8CS[8CSk8CSk8C
Sk<00Q>@/`<CTK<00a>B/a>B]1>C]0024i>d0Q>D]0034iFd4iFe4iFe008D
U[D359Ne0QBH]P<DVKH259Zf0aBK]`8DW;L259fg00<EWKPEW[PEW[P00aFO
^0035J2h5J2i5J6i008EXKT25J:i00<EXkTEXkXEXkX00QFT^P<FYKX25ZJk
0aJW^`8FZ;/35ZVl0QJZ_08FZk`00aJ[_AJ/_AN/_@035jfm00<G[[dG[[hG
[kh00QN__P8G/;h00aNa_QNa_aNa_`025k:o0QNc_`8H]<001<SPf8S0^8S0
^8S0^0H00004R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P0
1@0008S0^8S0^4R@R00000026;C000C8h=R8`;R8`;R8`;P2000018S0^080
0002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0`00P00?VjOaooooVHnnUhZle=?XkjbcogIkkYn[FeRUYY_4UYoBH4bJ
_;SMoooo<d>U00<008002_ooo`01P002P?ooo`02P003POooo`04POooo`04
P@801H402?ooo`06PP06P_ooo`47PP48P_ooo`48P`812H<01Oooo`4:P`4:
Poooo`4;Q0020@b400Coool13H@13HCoool20@j50P8?Q@030Q25oooo0Q25
00824HH01Oooo`8BQP8BQP8CQ_ooo`020QB700Woool25HL25HOoool25XL3
5XSoool35hSoool00P<HR0030aV80aV90aZ900836XT20a^900<378T378X3
78X00P<MRP<47XX211n;0`@PR`848H/312:<0P@SS08498`00`@TS@@US@DU
S@031BJ=00<59hd59hh5:8h00PDXSP85:Hh00`DZSPDZS`DZS`021B^?0`D/
S`86;I021Rj@0`H_T086<9431S6A0PHbT@<6<i801@HdTPLdTPLeTPLeTPLe
T`021cJC0`LgT`031cRC1cRD1cVD0087>I@21cZD00<7>i@7>iD7>iD00PPl
U@<8?ID223jF0`PoUP88@9H3246G0PQ2U`88@iL00`U3V0U4V0U4V0032DFH
00<9AYP9AYT9AiT00PU7V@89B9T00`U9V@U9VPU9VP022DZJ0`Y;VP8:C9/3
2TfK0PY>V`<:Ci`22U2L0PYAW0032U6M2U:M2e:M00<;Did00`]DW@]DWP]E
WP022eFN0P]FWP032eNN2eNO2eNO008;F9l32eVO0PaJX08<Fj0335bP0PaM
X@<<GZ4235nQ0`aPXP05366R3F6R3F:R3F:R3F:S008=Hj<33FBS00<=IJ<=
IJ@=IZ@00PeVY08=Ij@00`eXY0eXY@eXY@023VVU0`iZY@8>JjH33VbV0Pi]
YP<>KZL23VnW0Pi`Y`033g2X3g6X3g6X00<?LZP00`mcZ0mcZ@mdZ@023gBY
0PmeZ@033gJY3gJZ3gJZ008?MjX347RZ0Q1iZ`<@NZ/247^[0a1l[08@OJ`2
47j/00<@OZd@OjdAOjd00a60[@034H6]4H6^4H:^008APZh24H>^00<AQ:hA
Q:lAQ:l00Q65[`<AQZl24XN`0Q:8/0<BRK024XZa0a:;/@8BS;434Xfb00DB
S[8CS[8CSk8CSk8CSk<00Q>@/`<CTK<00a>B/a>B]1>C]0024i>d0Q>D]003
4iFd4iFe4iFe008DU[D359Ne0QBH]P<DVKH259Zf0aBK]`8DW;L259fg00<E
WKPEW[PEW[P00aFO^0035J2h5J2i5J6i008EXKT25J:i00<EXkTEXkXEXkX0
0QFT^P<FYKX25ZJk0aJW^`8FZ;/35ZVl0QJZ_08FZk`00aJ[_AJ/_AN/_@03
5jfm00<G[[dG[[hG[kh00QN__P8G/;h00aNa_QNa_aNa_`025k:o0QNc_`8H
]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h
00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^080
0002R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2002000ZKYo7ooonGR[ajK:ZcanRYKZ38`mnCQKYKAY>I
Skh2N6F^00A29hF_YL[ooolc@jD3002000Ooool00H3oool00X3oool00h7o
ool00P04P@Coool200J200Goool11h8128;oool128<00P49P`05oooo0@Z3
0@Z30@^30@^4008138@01?ooo`4=Q04=Q?ooo`813XD20Pn500<248Goool2
48D00P8AQP030Q:6oooooooo00;oool20QB700Soool25HL25HOoool25XL3
5XSoool35hP5oooo0`<JR@836hT00`<LR@<LRP<LRP020af:0`@NRP847h/3
122;0P@QR`<48X`212><0P@TS00312B=12F=1BF=00<59Xd00`DWS@DWSPDX
SP021BR>0PDYSP031BZ>1BZ?1BZ?0085:hl31Bb?0PH]T086;Y031Rn@0PH`
T@<6<I421S:A0`HcTP051SBB1cBB1cFB1cFB1cFC0087=Y<31cNC00<7>9<7
>9@7>I@00PLiU087>Y@00`LkU0LkU@LkU@0223bE0`PmU@88?YH323nF0PQ0
UP<8@IL224:G0PQ3U`032D>H2DBH2DBH00<9AIP00`U6V0U6V@U7V@022DNI
0PU8V@032DVI2DVJ2DVJ0089BYX32T^J0PY<V`<:CI/22TjK0`Y?W08:D9`2
2U6L00<:DId:DYd;DYd00`]CW@032eBM2eBN2eFN008;EIh22eJN00<;Eih;
Eil;Eil00P]HW`<;FIl235ZP0PaKX0<<G:0235fQ0`aNX@8<Gj43362R00D<
HJ8=HJ8=HZ8=HZ8=HZ<00PeSX`<=I:<00`eUX`eUY0eVY0023FJT0PeWY003
3FRT3FRU3FRU008>JJD33VZU0Pi[YP<>K:H23VfV0`i^Y`8>KjL23W2W00<?
L:P?LJP?LJP00`mbZ0033g>X3g>Y3gBY008?M:T23gFY00<?MZT?MZX?MZX0
0PmgZP<@N:X247V[0a1jZ`8@Nj/347b/0Q1m[08@OZ`00a1n[A1o[A5o[@03
4H2]00<APJdAPJhAPZh00Q62[P8APjh00a64[Q64[a64[`024HF_0a66[`8B
Qk024XR`0a:9/08BR[434X^a0Q:</@<BSK801A:>/Q>>/Q>?/Q>?/Q>?/`02
4i2c0a>A/`034i:c4i:d4i>d008CTk@24iBd00<CUK@CUKDCUKD00QBF]@<D
UkD259Rf0aBI]P8DV[H359^g0QBL]`8DWKL00aFM^1FN^1FN^0035Inh00<E
X;PEX;TEXKT00QFQ^@8EX[T00aFS^AFS^QFS^P025JBj0aJU^P8FY[/35ZNk
0QJX^`<FZK`25ZZl0QJ[_0035Z^m5Zbm5jbm00<G[Kd00aN^_AN^_QN__P02
5jnn0QN`_P035k6n5k6o5k6o008G/[l25k>o0QRd`003b>3HR<2hR<2h00^8
`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2h
B9280000008H]<000lSPf8S0^8S0^003R<2h100000B8`;P014R@R00001Rd
`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7ooooo
ool00_ooo`0:ojf`ogIknLgDoNg^ooooYY_4QGJ`_;SMoooo<d>U1000P007
oooo0060oooo00:0oooo00>1oooo00<0184200F100Koool01X801X;oool1
1h812882oooo0P49P`05oooo0@Z30@Z30@^30@^4008138@00oooo`4=Q04=
Q004oooo00@23hD248Goooooool20Q660`8BQP040Q>6oooo0QB70QB70_oo
o`070QF7oooooooo0aJ8oooo0aN8oooo008368P00`<IR?ooo`<JR@020aZ9
0P<KR@030ab90ab:0ab:00837HX311j:0P@OR`<488/2126;0`@RS0848h`2
12B<00<498d49Hd59Hd00`DVS@031BN=1BN>1BR>0085:8h21BV>00<5:Xh5
:Xl5:Xl00PD[S`<5;8l21Rf@0PH^T0<6;i021S2A0`HaT@86<Y431S>B00D6
=987=987=I87=I87=I<00PLfT`<7=i<00`LhT`LhU0LiU0021cVD0PLjU003
1c^D1c^E1c^E0088?9D323fE0PPnUP<8?iH2242F0`Q1U`88@YL224>G00<9
@iP9A9P9A9P00`U5V0032DJH2DJI2DNI0089AiT22DRI00<9BIT9BIX9BIX0
0PU:VP<:BiX22TbK0`Y=V`8:CY/32TnL0PY@W08:DI`00`YAW@YBW@]BW@03
2e>M00<;E9d;E9h;EIh00P]EWP8;EYh00`]GWP]GW`]GW`022eRO0`]IW`8<
FZ0235^P0`aLX08<GJ4335jQ0PaOX@<<H:801@aQXPeQXPeRXPeRXPeRX`02
3F>S0`eTX`033FFS3FFT3FJT008=IZ@23FNT00<=J:@=J:D=J:D00PiYY@<>
JZD23V^V0`i/YP8>KJH33VjW0Pi_Y`8>L:L00`m`Z0maZ0maZ0033g:X00<?
LjP?LjT?M:T00PmdZ@8?MJT00`mfZ@mfZPmfZP023gNZ0a1hZP8@NJ/347Z[
0Q1kZ`<@O:`247f/0Q1n[00347j]47n]4Gn]00<AP:d00a61[A61[Q62[P02
4H:^0Q63[P034HB^4HB_4HB_008AQJl34HJ_0Q:7/08BR;034XV`0Q::/@<B
Rk424Xba0a:=/P054Xjb4hjb4hnb4hnb4hnc008CT;<34i6c00<CT[<CT[@C
Tk@00Q>C]08CU;@00a>E]1>E]A>E]@0259Je0aBG]@8DV;H359Vf0QBJ]P<D
VkL259bg0QBM]`035Ifh5Ijh5Ijh00<EWkP00aFP^1FP^AFQ^@025J6i0QFR
^@035J>i5J>j5J>j008EY;X35ZFj0QJV^`<FYk/25ZRk0aJY_08FZ[`25Z^l
00<FZkdF[;dG[;d00aN]_@035jjm5jjn5jnn008G[kh25k2n00<G/KhG/KlG
/Kl00QNb_`8G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8
`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3H
R<2hR<2h00B8`;P200001HS0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0<008002Z6/l_W=e>8V??Be_n8V??A]OOcSjOoo
oog]k_n]/0;oool00c=3Y@00P000P003002000Ooool00H3oool00X3oool0
0h7oool00P04P@?oool200J20oooo`030@R2oooo0@R300;oool30@Z300D1
2h<12h@138@138Coool00P4=Q003oooo0@j50@j500823hD01P8@QOooo`8@
QOooo`8AQP8BQP?oool01@8CQP8DQ`8DQoooo`8EQ`02oooo00D25XOoool3
5hP35hP368P00oooo`040aV90aZ90aZ90aZ90P<KR@030ab90ab:0ab:0083
7HX311j:0P@OR`<488/2126;0`@RS0848h`212B<00<498d49Hd59Hd00`DV
S@031BN=1BN>1BR>0085:8h21BV>00<5:Xh5:Xl5:Xl00PD[S`<5;8l21Rf@
0PH^T0<6;i021S2A0`HaT@86<Y431S>B00D6=987=987=I87=I87=I<00PLf
T`<7=i<00`LhT`LhU0LiU0021cVD0PLjU0031c^D1c^E1c^E0088?9D323fE
0PPnUP<8?iH2242F0`Q1U`88@YL224>G00<9@iP9A9P9A9P00`U5V0032DJH
2DJI2DNI0089AiT22DRI00<9BIT9BIX9BIX00PU:VP<:BiX22TbK0`Y=V`8:
CY/32TnL0PY@W08:DI`00`YAW@YBW@]BW@032e>M00<;E9d;E9h;EIh00P]E
WP8;EYh00`]GWP]GW`]GW`022eRO0`]IW`8<FZ0235^P0`aLX08<GJ4335jQ
0PaOX@<<H:801@aQXPeQXPeRXPeRXPeRX`023F>S0`eTX`033FFS3FFT3FJT
008=IZ@23FNT00<=J:@=J:D=J:D00PiYY@<>JZD23V^V0`i/YP8>KJH33VjW
0Pi_Y`8>L:L00`m`Z0maZ0maZ0033g:X00<?LjP?LjT?M:T00PmdZ@8?MJT0
0`mfZ@mfZPmfZP023gNZ0a1hZP8@NJ/347Z[0Q1kZ`<@O:`247f/0Q1n[003
47j]47n]4Gn]00<AP:d00a61[A61[Q62[P024H:^0Q63[P034HB^4HB_4HB_
008AQJl34HJ_0Q:7/08BR;034XV`0Q::/@<BRk424Xba0a:=/P054Xjb4hjb
4hnb4hnb4hnc008CT;<34i6c00<CT[<CT[@CTk@00Q>C]08CU;@00a>E]1>E
]A>E]@0259Je0aBG]@8DV;H359Vf0QBJ]P<DVkL259bg0QBM]`035Ifh5Ijh
5Ijh00<EWkP00aFP^1FP^AFQ^@025J6i0QFR^@035J>i5J>j5J>j008EY;X3
5ZFj0QJV^`<FYk/25ZRk0aJY_08FZ[`25Z^l00<FZkdF[;dG[;d00aN]_@03
5jjm5jjn5jnn008G[kh25k2n00<G/KhG/KlG/Kl00QNb_`8G/kl26;C000?8
h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h
00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8`;P4000018S0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08003I^WlOg]k^8V??ken?N9UoARK_>P[_ARK_omoon]/?cSjOoooc=3Y@06
00200_ooo`<00X02oooo0`04P@801H4300J200Goool11h8128;oool128<0
0P49P`<12X<01@4;P`4;Q04<Q04<Q?ooo`020@f400?oool13XD13XD00P8?
Q@<248D20Q660`8BQP824hH30QB70P8EQ`825XL00`<FR0<GR0<GR0030aR8
00<36HP36HT36XT00P<JR@836hT00`<LR@<LRP<LRP020af:0`@NRP847h/3
122;0P@QR`<48X`212><0P@TS00312B=12F=1BF=00<59Xd00`DWS@DWSPDX
SP021BR>0PDYSP031BZ>1BZ?1BZ?0085:hl31Bb?0PH]T086;Y031Rn@0PH`
T@<6<I421S:A0`HcTP051SBB1cBB1cFB1cFB1cFC0087=Y<31cNC00<7>9<7
>9@7>I@00PLiU087>Y@00`LkU0LkU@LkU@0223bE0`PmU@88?YH323nF0PQ0
UP<8@IL224:G0PQ3U`032D>H2DBH2DBH00<9AIP00`U6V0U6V@U7V@022DNI
0PU8V@032DVI2DVJ2DVJ0089BYX32T^J0PY<V`<:CI/22TjK0`Y?W08:D9`2
2U6L00<:DId:DYd;DYd00`]CW@032eBM2eBN2eFN008;EIh22eJN00<;Eih;
Eil;Eil00P]HW`<;FIl235ZP0PaKX0<<G:0235fQ0`aNX@8<Gj43362R00D<
HJ8=HJ8=HZ8=HZ8=HZ<00PeSX`<=I:<00`eUX`eUY0eVY0023FJT0PeWY003
3FRT3FRU3FRU008>JJD33VZU0Pi[YP<>K:H23VfV0`i^Y`8>KjL23W2W00<?
L:P?LJP?LJP00`mbZ0033g>X3g>Y3gBY008?M:T23gFY00<?MZT?MZX?MZX0
0PmgZP<@N:X247V[0a1jZ`8@Nj/347b/0Q1m[08@OZ`00a1n[A1o[A5o[@03
4H2]00<APJdAPJhAPZh00Q62[P8APjh00a64[Q64[a64[`024HF_0a66[`8B
Qk024XR`0a:9/08BR[434X^a0Q:</@<BSK801A:>/Q>>/Q>?/Q>?/Q>?/`02
4i2c0a>A/`034i:c4i:d4i>d008CTk@24iBd00<CUK@CUKDCUKD00QBF]@<D
UkD259Rf0aBI]P8DV[H359^g0QBL]`8DWKL00aFM^1FN^1FN^0035Inh00<E
X;PEX;TEXKT00QFQ^@8EX[T00aFS^AFS^QFS^P025JBj0aJU^P8FY[/35ZNk
0QJX^`<FZK`25ZZl0QJ[_0035Z^m5Zbm5jbm00<G[Kd00aN^_AN^_QN__P02
5jnn0QN`_P035k6n5k6o5k6o008G/[l25k>o0QRd`003b>3HR<2hR<2h00^8
`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2h
B9280000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0^004
B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0800800
0i^WlOK8c>8V?002ojf`00OO92koY9kf_<Go[K3^Nhcooolc@jD01`00P0;o
ool300:00_ooo`<0184200F10`06PP05oooo0@N20@R2oooo0@R300812H<3
0@Z300D12h<12h@138@138Coool00P4=Q003oooo0@j50@j500823hD30Q25
0P8AQP<24XH20Q>60`8DQ`825HL20QJ700<35XP35hP35hP00`<HR0030aV8
0aV90aZ900836XT20a^900<378T378X378X00P<MRP<47XX211n;0`@PR`84
8H/312:<0P@SS08498`00`@TS@@US@DUS@031BJ=00<59hd59hh5:8h00PDX
SP85:Hh00`DZSPDZS`DZS`021B^?0`D/S`86;I021Rj@0`H_T086<9431S6A
0PHbT@<6<i801@HdTPLdTPLeTPLeTPLeT`021cJC0`LgT`031cRC1cRD1cVD
0087>I@21cZD00<7>i@7>iD7>iD00PPlU@<8?ID223jF0`PoUP88@9H3246G
0PQ2U`88@iL00`U3V0U4V0U4V0032DFH00<9AYP9AYT9AiT00PU7V@89B9T0
0`U9V@U9VPU9VP022DZJ0`Y;VP8:C9/32TfK0PY>V`<:Ci`22U2L0PYAW003
2U6M2U:M2e:M00<;Did00`]DW@]DWP]EWP022eFN0P]FWP032eNN2eNO2eNO
008;F9l32eVO0PaJX08<Fj0335bP0PaMX@<<GZ4235nQ0`aPXP05366R3F6R
3F:R3F:R3F:S008=Hj<33FBS00<=IJ<=IJ@=IZ@00PeVY08=Ij@00`eXY0eX
Y@eXY@023VVU0`iZY@8>JjH33VbV0Pi]YP<>KZL23VnW0Pi`Y`033g2X3g6X
3g6X00<?LZP00`mcZ0mcZ@mdZ@023gBY0PmeZ@033gJY3gJZ3gJZ008?MjX3
47RZ0Q1iZ`<@NZ/247^[0a1l[08@OJ`247j/00<@OZd@OjdAOjd00a60[@03
4H6]4H6^4H:^008APZh24H>^00<AQ:hAQ:lAQ:l00Q65[`<AQZl24XN`0Q:8
/0<BRK024XZa0a:;/@8BS;434Xfb00DBS[8CS[8CSk8CSk8CSk<00Q>@/`<C
TK<00a>B/a>B]1>C]0024i>d0Q>D]0034iFd4iFe4iFe008DU[D359Ne0QBH
]P<DVKH259Zf0aBK]`8DW;L259fg00<EWKPEW[PEW[P00aFO^0035J2h5J2i
5J6i008EXKT25J:i00<EXkTEXkXEXkX00QFT^P<FYKX25ZJk0aJW^`8FZ;/3
5ZVl0QJZ_08FZk`00aJ[_AJ/_AN/_@035jfm00<G[[dG[[hG[kh00QN__P8G
/;h00aNa_QNa_aNa_`025k:o0QNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8
T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P00hS0^080
0004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2002000>KYo7icMCgRIL00_ooo`07ojf`hAHdogIkojBN
hRHlohUo<d>U00L008000oooo`01P002P00200:000<00h7oool018400P04
P@801H4300J200D01h811h8128;oool128<00P49P`<12X<01@4;P`4;Q04<
Q04<Q?ooo`020@f41Oooo`<248D20Q660`8BQP824hH30QB70P8EQ`825XL0
0`<FR0<GR0<GR0030aR800<36HP36HT36XT00P<JR@836hT00`<LR@<LRP<L
RP020af:0`@NRP847h/3122;0P@QR`<48X`212><0P@TS00312B=12F=1BF=
00<59Xd00`DWS@DWSPDXSP021BR>0PDYSP031BZ>1BZ?1BZ?0085:hl31Bb?
0PH]T086;Y031Rn@0PH`T@<6<I421S:A0`HcTP051SBB1cBB1cFB1cFB1cFC
0087=Y<31cNC00<7>9<7>9@7>I@00PLiU087>Y@00`LkU0LkU@LkU@0223bE
0`PmU@88?YH323nF0PQ0UP<8@IL224:G0PQ3U`032D>H2DBH2DBH00<9AIP0
0`U6V0U6V@U7V@022DNI0PU8V@032DVI2DVJ2DVJ0089BYX32T^J0PY<V`<:
CI/22TjK0`Y?W08:D9`22U6L00<:DId:DYd;DYd00`]CW@032eBM2eBN2eFN
008;EIh22eJN00<;Eih;Eil;Eil00P]HW`<;FIl235ZP0PaKX0<<G:0235fQ
0`aNX@8<Gj43362R00D<HJ8=HJ8=HZ8=HZ8=HZ<00PeSX`<=I:<00`eUX`eU
Y0eVY0023FJT0PeWY0033FRT3FRU3FRU008>JJD33VZU0Pi[YP<>K:H23VfV
0`i^Y`8>KjL23W2W00<?L:P?LJP?LJP00`mbZ0033g>X3g>Y3gBY008?M:T2
3gFY00<?MZT?MZX?MZX00PmgZP<@N:X247V[0a1jZ`8@Nj/347b/0Q1m[08@
OZ`00a1n[A1o[A5o[@034H2]00<APJdAPJhAPZh00Q62[P8APjh00a64[Q64
[a64[`024HF_0a66[`8BQk024XR`0a:9/08BR[434X^a0Q:</@<BSK801A:>
/Q>>/Q>?/Q>?/Q>?/`024i2c0a>A/`034i:c4i:d4i>d008CTk@24iBd00<C
UK@CUKDCUKD00QBF]@<DUkD259Rf0aBI]P8DV[H359^g0QBL]`8DWKL00aFM
^1FN^1FN^0035Inh00<EX;PEX;TEXKT00QFQ^@8EX[T00aFS^AFS^QFS^P02
5JBj0aJU^P8FY[/35ZNk0QJX^`<FZK`25ZZl0QJ[_0035Z^m5Zbm5jbm00<G
[Kd00aN^_AN^_QN__P025jnn0QN`_P035k6n5k6o5k6o008G/[l25k>o0QRd
`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@
R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0P00P007VjOaoooolj2^m69^oooomhVGnLgD00;o
ool00o>P[_oooc=3Y@0700200P01P0<00X0200>10`04P@801H4300J200D0
1h811h812881288128<00P49P`<12X<00`4;P`4;Q04<Q0020@b40P4=Q003
0@j40@j50@j500823hD30Q250P8AQP<24XH20Q>60`8DQ`825HL20QJ700<3
5XP35hP35hP00`<HR0030aV80aV90aZ900836XT20a^900<378T378X378X0
0P<MRP<47XX211n;0`@PR`848H/312:<0P@SS08498`00`@TS@@US@DUS@03
1BJ=00<59hd59hh5:8h00PDXSP85:Hh00`DZSPDZS`DZS`021B^?0`D/S`86
;I021Rj@0`H_T086<9431S6A0PHbT@<6<i801@HdTPLdTPLeTPLeTPLeT`02
1cJC0`LgT`031cRC1cRD1cVD0087>I@21cZD00<7>i@7>iD7>iD00PPlU@<8
?ID223jF0`PoUP88@9H3246G0PQ2U`88@iL00`U3V0U4V0U4V0032DFH00<9
AYP9AYT9AiT00PU7V@89B9T00`U9V@U9VPU9VP022DZJ0`Y;VP8:C9/32TfK
0PY>V`<:Ci`22U2L0PYAW0032U6M2U:M2e:M00<;Did00`]DW@]DWP]EWP02
2eFN0P]FWP032eNN2eNO2eNO008;F9l32eVO0PaJX08<Fj0335bP0PaMX@<<
GZ4235nQ0`aPXP05366R3F6R3F:R3F:R3F:S008=Hj<33FBS00<=IJ<=IJ@=
IZ@00PeVY08=Ij@00`eXY0eXY@eXY@023VVU0`iZY@8>JjH33VbV0Pi]YP<>
KZL23VnW0Pi`Y`033g2X3g6X3g6X00<?LZP00`mcZ0mcZ@mdZ@023gBY0Pme
Z@033gJY3gJZ3gJZ008?MjX347RZ0Q1iZ`<@NZ/247^[0a1l[08@OJ`247j/
00<@OZd@OjdAOjd00a60[@034H6]4H6^4H:^008APZh24H>^00<AQ:hAQ:lA
Q:l00Q65[`<AQZl24XN`0Q:8/0<BRK024XZa0a:;/@8BS;434Xfb00DBS[8C
S[8CSk8CSk8CSk<00Q>@/`<CTK<00a>B/a>B]1>C]0024i>d0Q>D]0034iFd
4iFe4iFe008DU[D359Ne0QBH]P<DVKH259Zf0aBK]`8DW;L259fg00<EWKPE
W[PEW[P00aFO^0035J2h5J2i5J6i008EXKT25J:i00<EXkTEXkXEXkX00QFT
^P<FYKX25ZJk0aJW^`8FZ;/35ZVl0QJZ_08FZk`00aJ[_AJ/_AN/_@035jfm
00<G[[dG[[hG[kh00QN__P8G/;h00aNa_QNa_aNa_`025k:o0QNc_`8H]<00
0lSPf8S0^8S0^00;R<2h00=8T8P00038h=P03HS0^005B92800006;C06;C0
b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P3002000^KYo7oooooRGooooocX:kaTj7ooooooOocX:kono`c@jD0
1`00P0800H0300:00P03P@<0184200F10`06PP0500N20@N20@R20@R20@R3
00812H<30@Z300<12h<12h@138@00P4<Q0813H@00`4>Q04>Q@4>Q@020Pn5
0`8@Q@824HH30Q:60P8CQP<258L20QF70P8FQ`030aJ80aN80aN800<368P0
0`<IR0<IR@<JR@020aZ90P<KR@030ab90ab:0ab:00837HX311j:0P@OR`<4
88/2126;0`@RS0848h`212B<00<498d49Hd59Hd00`DVS@031BN=1BN>1BR>
0085:8h21BV>00<5:Xh5:Xl5:Xl00PD[S`<5;8l21Rf@0PH^T0<6;i021S2A
0`HaT@86<Y431S>B00D6=987=987=I87=I87=I<00PLfT`<7=i<00`LhT`Lh
U0LiU0021cVD0PLjU0031c^D1c^E1c^E0088?9D323fE0PPnUP<8?iH2242F
0`Q1U`88@YL224>G00<9@iP9A9P9A9P00`U5V0032DJH2DJI2DNI0089AiT2
2DRI00<9BIT9BIX9BIX00PU:VP<:BiX22TbK0`Y=V`8:CY/32TnL0PY@W08:
DI`00`YAW@YBW@]BW@032e>M00<;E9d;E9h;EIh00P]EWP8;EYh00`]GWP]G
W`]GW`022eRO0`]IW`8<FZ0235^P0`aLX08<GJ4335jQ0PaOX@<<H:801@aQ
XPeQXPeRXPeRXPeRX`023F>S0`eTX`033FFS3FFT3FJT008=IZ@23FNT00<=
J:@=J:D=J:D00PiYY@<>JZD23V^V0`i/YP8>KJH33VjW0Pi_Y`8>L:L00`m`
Z0maZ0maZ0033g:X00<?LjP?LjT?M:T00PmdZ@8?MJT00`mfZ@mfZPmfZP02
3gNZ0a1hZP8@NJ/347Z[0Q1kZ`<@O:`247f/0Q1n[00347j]47n]4Gn]00<A
P:d00a61[A61[Q62[P024H:^0Q63[P034HB^4HB_4HB_008AQJl34HJ_0Q:7
/08BR;034XV`0Q::/@<BRk424Xba0a:=/P054Xjb4hjb4hnb4hnb4hnc008C
T;<34i6c00<CT[<CT[@CTk@00Q>C]08CU;@00a>E]1>E]A>E]@0259Je0aBG
]@8DV;H359Vf0QBJ]P<DVkL259bg0QBM]`035Ifh5Ijh5Ijh00<EWkP00aFP
^1FP^AFQ^@025J6i0QFR^@035J>i5J>j5J>j008EY;X35ZFj0QJV^`<FYk/2
5ZRk0aJY_08FZ[`25Z^l00<FZkdF[;dG[;d00aN]_@035jjm5jjn5jnn008G
[kh25k2n00<G/KhG/KlG/Kl00QNb_`8G/kl26;C03lSPf0030000b>3Hb>3H
00g8h=P00`0001Rd`1Rd`00?b>3H00<0000H]<0H]<000XS0^058T8P10000
000018S0^<SPf8S0^8S0^0@00803VjOa00KoooocX:kd]Kof_<GkfMXc@jD8
00200P01P0<00X0200>10`04P@801H4300J200D01h811h812881288128<0
0P49P`<12X<00`4;P`4;Q04<Q0020@b40P4=Q0030@j40@j50@j500823hD3
0Q250P8AQP<24XH20Q>60`8DQ`825HL20QJ700<35XP35hP35hP00`<HR003
0aV80aV90aZ900836XT20a^900<378T378X378X00P<MRP<47XX211n;0`@P
R`848H/312:<0P@SS08498`00`@TS@@US@DUS@031BJ=00<59hd59hh5:8h0
0PDXSP85:Hh00`DZSPDZS`DZS`021B^?0`D/S`86;I021Rj@0`H_T086<943
1S6A0PHbT@<6<i801@HdTPLdTPLeTPLeTPLeT`021cJC0`LgT`031cRC1cRD
1cVD0087>I@21cZD00<7>i@7>iD7>iD00PPlU@<8?ID223jF0`PoUP88@9H3
246G0PQ2U`88@iL00`U3V0U4V0U4V0032DFH00<9AYP9AYT9AiT00PU7V@89
B9T00`U9V@U9VPU9VP022DZJ0`Y;VP8:C9/32TfK0PY>V`<:Ci`22U2L0PYA
W0032U6M2U:M2e:M00<;Did00`]DW@]DWP]EWP022eFN0P]FWP032eNN2eNO
2eNO008;F9l32eVO0PaJX08<Fj0335bP0PaMX@<<GZ4235nQ0`aPXP05366R
3F6R3F:R3F:R3F:S008=Hj<33FBS00<=IJ<=IJ@=IZ@00PeVY08=Ij@00`eX
Y0eXY@eXY@023VVU0`iZY@8>JjH33VbV0Pi]YP<>KZL23VnW0Pi`Y`033g2X
3g6X3g6X00<?LZP00`mcZ0mcZ@mdZ@023gBY0PmeZ@033gJY3gJZ3gJZ008?
MjX347RZ0Q1iZ`<@NZ/247^[0a1l[08@OJ`247j/00<@OZd@OjdAOjd00a60
[@034H6]4H6^4H:^008APZh24H>^00<AQ:hAQ:lAQ:l00Q65[`<AQZl24XN`
0Q:8/0<BRK024XZa0a:;/@8BS;434Xfb00DBS[8CS[8CSk8CSk8CSk<00Q>@
/`<CTK<00a>B/a>B]1>C]0024i>d0Q>D]0034iFd4iFe4iFe008DU[D359Ne
0QBH]P<DVKH259Zf0aBK]`8DW;L259fg00<EWKPEW[PEW[P00aFO^0035J2h
5J2i5J6i008EXKT25J:i00<EXkTEXkXEXkX00QFT^P<FYKX25ZJk0aJW^`8F
Z;/35ZVl0QJZ_08FZk`00aJ[_AJ/_AN/_@035jfm00<G[[dG[[hG[kh00QN_
_P8G/;h00aNa_QNa_aNa_`025k:o0QNc_cHH]<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h5@00P0800H0300:00P03P@<0184200F10`06PP0500N2
0@N20@R20@R20@R300812H<30@Z300<12h<12h@138@00P4<Q0813H@00`4>
Q04>Q@4>Q@020Pn50`8@Q@824HH30Q:60P8CQP<258L20QF70P8FQ`030aJ8
0aN80aN800<368P00`<IR0<IR@<JR@020aZ90P<KR@030ab90ab:0ab:0083
7HX311j:0P@OR`<488/2126;0`@RS0848h`212B<00<498d49Hd59Hd00`DV
S@031BN=1BN>1BR>0085:8h21BV>00<5:Xh5:Xl5:Xl00PD[S`<5;8l21Rf@
0PH^T0<6;i021S2A0`HaT@86<Y431S>B00D6=987=987=I87=I87=I<00PLf
T`<7=i<00`LhT`LhU0LiU0021cVD0PLjU0031c^D1c^E1c^E0088?9D323fE
0PPnUP<8?iH2242F0`Q1U`88@YL224>G00<9@iP9A9P9A9P00`U5V0032DJH
2DJI2DNI0089AiT22DRI00<9BIT9BIX9BIX00PU:VP<:BiX22TbK0`Y=V`8:
CY/32TnL0PY@W08:DI`00`YAW@YBW@]BW@032e>M00<;E9d;E9h;EIh00P]E
WP8;EYh00`]GWP]GW`]GW`022eRO0`]IW`8<FZ0235^P0`aLX08<GJ4335jQ
0PaOX@<<H:801@aQXPeQXPeRXPeRXPeRX`023F>S0`eTX`033FFS3FFT3FJT
008=IZ@23FNT00<=J:@=J:D=J:D00PiYY@<>JZD23V^V0`i/YP8>KJH33VjW
0Pi_Y`8>L:L00`m`Z0maZ0maZ0033g:X00<?LjP?LjT?M:T00PmdZ@8?MJT0
0`mfZ@mfZPmfZP023gNZ0a1hZP8@NJ/347Z[0Q1kZ`<@O:`247f/0Q1n[003
47j]47n]4Gn]00<AP:d00a61[A61[Q62[P024H:^0Q63[P034HB^4HB_4HB_
008AQJl34HJ_0Q:7/08BR;034XV`0Q::/@<BRk424Xba0a:=/P054Xjb4hjb
4hnb4hnb4hnc008CT;<34i6c00<CT[<CT[@CTk@00Q>C]08CU;@00a>E]1>E
]A>E]@0259Je0aBG]@8DV;H359Vf0QBJ]P<DVkL259bg0QBM]`035Ifh5Ijh
5Ijh00<EWkP00aFP^1FP^AFQ^@025J6i0QFR^@035J>i5J>j5J>j008EY;X3
5ZFj0QJV^`<FYk/25ZRk0aJY_08FZ[`25Z^l00<FZkdF[;dG[;d00aN]_@03
5jjm5jjn5jnn008G[kh25k2n00<G/KhG/KlG/Kl00QNb_`8G/klf6;C00XS0
^058T8P1000000000hS0^<SPf8S0^03oR<2hohS0^0f8`;P1B9280@000000
00>8`;S8h=R8`;P0ohS0^?n8`;P=R<2h0DR@R04000000003R<2hb>3Hb>3H
0?o8h=Sob>3H3LSPf058T8P10000003oR<2hohS0^168`;P100000000\
\>"], "Graphics",
  ImageSize->{528, 538},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009L0001db000`400?l0
0000o`00003oooo`l?3ooo3`l5kol?3`003ooo3`l?ool?3`G_o`l?000?oo
l?3`ooo`l?1Noo3`l000ooo`l?3ooo3`l5kol?3`003ooo3`l?ool?3`G_o`
l?000?ool?3`ooo`l?1Noo3`l000ooo`l?3ooo3`l5kol?3`003ooo3`l?oo
l?3`G_o`l?000?ool?3`ooo`l?1Noo3`l000ooo`l?3ooo3`l5kol?3`003o
oo3`l?ool?3`G_o`l?000?ool?3`ooo`l?1Noo3`l000ooo`l?3ooo3`l5ko
l?3`003ooo3`l?ool?3`G_o`l?000?ool?3`ooo`l?1Noo3`l000oonb/[;o
ok:b/Uko/[:b003oooooooooooooGOooool1ok:b/P0000?ooooook:b/_oV
i^H00_oUiND02_oShn?oh>3PomgMgOoJf][oe]KFom7AdOo=cLgob/[:olO7
aoo6a/H2olG5aOooa<C42Oo4a<@2olG5a@0:olK6a_o7alOob/[:olg=cOoA
dM7oe]KFom[Jf_oMgMgoh>3Pon?Sh`;oiNGU3OoVi^H2onGUi@0:on?ShooP
h>3og=cLomSHf?oCdm?oalS8okZk_?nYZjgoWj:UoiVMX@;oV9fP00?oUibO
ojBVZ?nLX:<01?nGW9l01?nLX:?oY:JXojBVZ?nLX:<4oiNLW`04oibPXonT
YZSoY:JXoibPX`CoUibO00CoW:2SojBVZ?nTYZSoW:2S1?nGW9l01?nLX:?o
Y:JXojBVZ?nLX:<4oiNLW`04oibPXonTYZSoY:JXoibPX`CoUibO00CoW:2S
ojBVZ?nTYZSoW:2S1?nGW9l01?nLX:?oY:JXojBVZ?nLX:<4oiNLW`04oibP
XonTYZSoY:JXoibPX`CoUibO00CoW:2SojBVZ?nTYZSoW:2S1?nGW9l01?nL
X:?oY:JXojBVZ?nLX:<4oiNLW`04oibPXonTYZSoY:JXoibPX`CoUibO00Co
W:2SojBVZ?nTYZSoW:2S1?nGW9l01?nLX:?oY:JXojBVZ?nLX:<4oiNLW`04
oibPXonTYZSoY:JXoibPX`CoUibO00CoW:2SojBVZ?nTYZSoW:2S1?nGW9l0
1?nLX:?oY:JXojBVZ?nLX:<4oiNLW`04oibPXonTYZSoY:JXoibPX`CoUibO
00CoW:2SojBVZ?nTYZSoW:2S1?nGW9l01?nLX:?oY:JXojBVZ?nLX:<4oiNL
W`04oibPXonTYZSoY:JXoibPX`CoUibO00CoW:2SojBVZ?nTYZSoW:2S1?nG
W9l01?nLX:?oY:JXojBVZ?nLX:<4oiNLW`04oibPXonTYZSoY:JXoibPX`Co
UibO00CoW:2SojBVZ?nTYZSoW:2S1?nGW9l01?nLX:?oY:JXojBVZ?nLX:<4
oiNLW`04oibPXonTYZSoY:JXoibPX`CoUibO00CoW:2SojBVZ?nTYZSoW:2S
1?nGW9l01?nLX:?oY:JXojBVZ?nLX:<4oiNLW`04oibPXonTYZSoY:JXoibP
X`CoUibO00CoW:2SojBVZ?nTYZSoW:2S1?nGW9l01?nLX:?oY:JXojBVZ?nL
X:<4oiNLW`04oibPXonTYZSoY:JXoibPX`GoUibO0_nHWJ002_nIWJ7oWj:U
ojV[[Onj^kcoalS8om?CdooHf=Sog=cLon3Ph?oShn<2onGUi@;oi^KV0Ooo
ool1ok:b/P0000kooooook:b/_o]kNgokNg]on[Zj_oXj>Soh^;RomgMgOoF
e]KocLg=olK6a_nn_[ko^[ZjokJf]PCo/k>coonb/[87ok:b/PCo/k>c00[o
][JfokZj^_nn_[koa/K6olg=cOoFe]KogMgMon;Rh_oXj>Soj^[Z0_o]kNd;
onk^kP;okNg]00coj^[ZonOWiooQhN7odm?Col;3`on[[JooVIfQohZAU_mo
R93oN8>=ogF2SOmePHd2ogF1S003ogf5SOmfPH_oM82;00?oM82;00CoMX6;
ogf5SOmmQHgoMX6;1?mdP8/01?mfPH_oOHF=ogf5SOmfPH/4ogB0R`04ogJ1
RommQHgoOHF=ogJ1R`CoM82;00CoMX6;ogf5SOmmQHgoMX6;1?mdP8/01?mf
PH_oOHF=ogf5SOmfPH/4ogB0R`04ogJ1RommQHgoOHF=ogJ1R`CoM82;00Co
MX6;ogf5SOmmQHgoMX6;1?mdP8/01?mfPH_oOHF=ogf5SOmfPH/4ogB0R`04
ogJ1RommQHgoOHF=ogJ1R`CoM82;00CoMX6;ogf5SOmmQHgoMX6;1?mdP8/0
1?mfPH_oOHF=ogf5SOmfPH/4ogB0R`04ogJ1RommQHgoOHF=ogJ1R`CoM82;
00CoMX6;ogf5SOmmQHgoMX6;1?mdP8/01?mfPH_oOHF=ogf5SOmfPH/4ogB0
R`04ogJ1RommQHgoOHF=ogJ1R`CoM82;00CoMX6;ogf5SOmmQHgoMX6;1?md
P8/01?mfPH_oOHF=ogf5SOmfPH/4ogB0R`04ogJ1RommQHgoOHF=ogJ1R`Co
M82;00CoMX6;ogf5SOmmQHgoMX6;1?mdP8/01?mfPH_oOHF=ogf5SOmfPH/4
ogB0R`04ogJ1RommQHgoOHF=ogJ1R`CoM82;00CoMX6;ogf5SOmmQHgoMX6;
1?mdP8/01?mfPH_oOHF=ogf5SOmfPH/4ogB0R`04ogJ1RommQHgoOHF=ogJ1
R`CoM82;00CoMX6;ogf5SOmmQHgoMX6;1?mdP8/01?mfPH_oOHF=ogf5SOmf
PH/4ogB0R`04ogJ1RommQHgoOHF=ogJ1R`CoM82;00CoMX6;ogf5SOmmQHgo
MX6;1?mdP8/01?mfPH_oOHF=ogf5SOmfPH/4ogB0R`04ogJ1RommQHgoOHF=
ogJ1R`CoM82;00CoMX6;ogf5SOmmQHgoMX6;1?mdP8/01?mfPH_oOHF=ogf5
SOmfPH/4ogB0R`;oMH6<00coMH6=ogF2SOmhPhgoOhR@ohZAU_nIWJ7oZjf_
ol;3`ooCdm?ohN7QonOWiooZj^X2ong]k@7ok^k^0Oooool1ok:b/P00013o
oooook:b/_ono_kono_kooShn?obl_;ojNWYomgMgOoAdM7oaLG5okZj^_na
/K7oZj^[ojNWYonSXj?oXZ:RoonQXJ4;oj6QX@0=oj:RX_nSXj?oYjNWoj^[
Zona/K7o^[ZjolG5aOoAdM7ogMgMonWYjOobl_;on?Shoo_kn`02ooknoP[o
oooo00coo_knoo_knoogmoOol?3`omoOh?o1`/?oXZJZohVAVOmgQ8ooK7b9
ofEgQ_mQM8D2oeiaP`;oG76200?oHG:0oeaaP_mLLH801?mLLH82of5bP0Ko
G7620_mQLX06oeaaPP;oHG:01_mLLH82of5bP0KoG7620_mQLX06oeaaPP;o
HG:01_mLLH82of5bP0KoG7620_mQLX06oeaaPP;oHG:01_mLLH82of5bP0Ko
G7620_mQLX06oeaaPP;oHG:01_mLLH82of5bP0KoG7620_mQLX06oeaaPP;o
HG:01_mLLH82of5bP0KoG7620_mQLX06oeaaPP;oHG:01_mLLH82of5bP0Ko
G7620_mQLX06oeaaPP;oHG:01_mLLH82of5bP0KoG7620_mQLX06oeaaPP;o
HG:01_mLLH82of5bP0KoG7620_mQLX06oeaaPP;oHG:01_mLLH82of5bP0Ko
G7620_mQLX06oeaaPP;oHG:01_mLLH82of5bP0KoG7620_mQLX07oeaaPP;o
GW6300_oHGB5ofEgQ_m/O8WoMhB?ohVAVOnRYZ[o`L;3omoOh?o`l?3omoOg
oo_kn`02ooknoP7ooooo0Onb/[80000@oooooonb/[;ojn_[onSXj?oRh^;o
f=SHol_;bonn_[ko[Zj^oj6QXOnEUIGoS8b<ohF5QOn2PX;oOgmooginO_oo
OGem2ommOGd03omnOWkoOgmooh:2P_n5QHGoS8b<oiFEUOnQXJ7o[Zj^okjn
__o;bl_of=SHon;Rh_oXj>Sojn_[ong]k@0:onk^kP0<on_[jooWinOoh>3P
olk?conb/kCoSiBIogAoROmSM8?oG6eloeQXM?mHIFooFF=/0_mIHVX2oeMQ
J@03oe5NJ_mDH6[oEf5Y00?oEf5Y00CoE61Zoe5NJ_mAGV[oE61Z1?mGHFT0
1?mDH6[oDEiZoe5NJ_mDH6X4oeMQJ@04oeAPJ_mAGV[oDEiZoeAPJPCoEf5Y
00CoE61Zoe5NJ_mAGV[oE61Z1?mGHFT01?mDH6[oDEiZoe5NJ_mDH6X4oeMQ
J@04oeAPJ_mAGV[oDEiZoeAPJPCoEf5Y00CoE61Zoe5NJ_mAGV[oE61Z1?mG
HFT01?mDH6[oDEiZoe5NJ_mDH6X4oeMQJ@04oeAPJ_mAGV[oDEiZoeAPJPCo
Ef5Y00CoE61Zoe5NJ_mAGV[oE61Z1?mGHFT01?mDH6[oDEiZoe5NJ_mDH6X4
oeMQJ@04oeAPJ_mAGV[oDEiZoeAPJPCoEf5Y00CoE61Zoe5NJ_mAGV[oE61Z
1?mGHFT01?mDH6[oDEiZoe5NJ_mDH6X4oeMQJ@04oeAPJ_mAGV[oDEiZoeAP
JPCoEf5Y00CoE61Zoe5NJ_mAGV[oE61Z1?mGHFT01?mDH6[oDEiZoe5NJ_mD
H6X4oeMQJ@04oeAPJ_mAGV[oDEiZoeAPJPCoEf5Y00CoE61Zoe5NJ_mAGV[o
E61Z1?mGHFT01?mDH6[oDEiZoe5NJ_mDH6X4oeMQJ@04oeAPJ_mAGV[oDEiZ
oeAPJPCoEf5Y00CoE61Zoe5NJ_mAGV[oE61Z1?mGHFT01?mDH6[oDEiZoe5N
J_mDH6X4oeMQJ@04oeAPJ_mAGV[oDEiZoeAPJPCoEf5Y00CoE61Zoe5NJ_mA
GV[oE61Z1?mGHFT01?mDH6[oDEiZoe5NJ_mDH6X4oeMQJ@04oeAPJ_mAGV[o
DEiZoeAPJPCoEf5Y00CoE61Zoe5NJ_mAGV[oE61Z1?mGHFT01?mDH6[oDEiZ
oe5NJ_mDH6X4oeMQJ@04oeAPJ_mAGV[oDEiZoeAPJPCoEf5Y00CoE61Zoe5N
J_mAGV[oE61Z1?mGHFT01?mDH6[oDEiZoe5NJ_mDH6X6oeMQJ@;oFF9Z00ko
FF=/oeQUKomHJ7CoG6elof=dPomdOhWoSiBIok:c]?o>clooh>3PonOWioo[
jn_okNg]ooooo`7o/[:b00005_oooooo/[:bon3Ph?oKfm_od];BolC4a?nd
];CoXj>Soi>CTon>SXkoXj>Sokjn__oGemOojn_[ooKfm_ogmoOonOWiooSh
n?oinOWon_[jooWinOogmoL3ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?o
n_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oi
nOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?o
n_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oi
nOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?o
n_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oi
nOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh013onOWiooShn?ogmoOokNg]omSHf?no_kooXj>Sohj>
S_nCTi?oXj>SokBd]?o4a<Cod];Bom_KfooPh>3oi>CT2_oVi^H05?oPh>3o
f][JolW9b_n[[:goR8fBofmjP_mQKWWoIG1ioh>9SonXZjgobL[;onOWj?of
m_KomoOgooWinOohn?SonOWioo[jn_oinOWomoOg0oohn?P2ooWin@03oo[j
n_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi
00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh
0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL0
0oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWi
ooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[j
n_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi
00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh
0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL0
0oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWi
ooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[j
n_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi
00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh
0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL0
0oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWi
ooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[j
n_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi
00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh
0_oinOT00oojn_[onOWiooOgm`03ooShn00AooWinOohn?SomoOgonWYj_o:
blcoZJ^^oh>9SomUL7WoHFiiofmjP_n8SI;oZjb]olW9b_oJf][oh>3PonCT
i?ooool00Onb/[80000>oooooonb/[;oiNGUomgMgOo>c/ko_KfmojRXZ?nE
UIGoYJFUolc<c?o^k^kom_Kfooclo?ono_koooooo`oooooo00goo_knoocl
o?ogmoOokno_olg=cOnVYZKoUIFEojRXZ?nm_Kgoc/k>omgMgOoUiNGoj^[Z
00[ok^k^00coi>CTom?Cdond]KKoSiFIog9mQOmSKgWoPhV>ok^m_oo^k^ko
m_Kfooclo?ono_koooooo`oooooo00koo_knooclo?ogmoOokno_okbn`?n4
RXooHfmiog9mQOn?UIWo];Ffom?CdooTi>Coj^[Zooooo`7o/[:b00003?oo
oooo/[:boo;bl_oUiNGodM7AokZj^_nTY:Co/K6aomkNg_o[jn_om?Cdoo_k
nooooooo4oooool02ookno_olo?conc/k?oQhN7o];BdojBTY?nj^[[odM7A
onGUiOobl_;onOWi00[ooooo00[ojNWYolW:bonNXjSoO8N?ofeiPonBV9_o
g]kNon_[joodm?Cono_koooooolCooooo`0<oo_knooclo?ok>c/on7QhOnE
VYkoKGV3ogb7SonNXjSobL[;onWYjOohn?Sooooo0Onb/[80000<oooooonb
/[;ogMgMolg=cOnh^;SoXJ6QojRXZ?oDe=Coh>3Ponc/k?oemOGooOgmoooo
oolCooooo`0;ookno_ofm_Kok>c/on;Rh_oIfMWo[:b/oj6QXOnh^;SocLg=
omgMgOoUiND02_o^k^h02_o9bL[oWZ:VogR4S_mXMX7oS96EomCDe?oPh>3o
k>c/ooGemOomoOgooooooa?ooooo00coo_knooKfm_o/k>coh^;RomWIfOn?
U9WoJ7J1ogR4S_nNXZKobLW:onCTi?ooool1ok:b/P0000gooooook:b/_oA
dM7o_knoojRXZ?nPX:3oa/K6omCDe?oPh>3ok>c/oo;bl_olo?coo_kn0?oo
oooo4_ooool02oojn_[om?Cdon[Zj_oShn?oemOGolg=cOnSXj?oZ:RXokno
_ooAdM7ofm_K00[oi^KV00_oZZf_oh><UOmYNXWoNhB;olK6a_oDe=Coh>3P
onc/k?obl_;oo?clooknoP3ooooooa;ooooo00con_[jooCdm?oZj^[ohn?S
omOGeoo=cLgoOXJ=ofUjROn3S9GoZZf_om?Cdoooool1ok:b/P00017ooooo
ok:b/_oDe=Co_knoojJVY_n/[:coa/K6om;Bd_oLg=coi^KVonc/k?oemOGo
n?Shoo[jn_omoOgoooooooclo008ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool04?omoOgooooo
oogmoOokno_on?ShooCdm?o]kNgoi^KVomoOgooFe]Koc<c<ok:b/_nWYjOo
_knoomCDe?oRh^8:onk^kP0?oibRYomfQY?oJGZ7oi^MX?o6a/Kod];BomcL
g?oVi^Kok>c/ooGemOohn?Son_[joogmoOooooooo?cl00Sooooo00?ooOgm
ooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooo
oooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05
ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool0
0oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgm
ooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooo
oooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05
ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool0
0oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgm
ooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooo
oooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05
ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool0
0oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgm
ooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooo
oooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05
ooooo`0AoogmoOoooooooOgmoo_knoohn?Som?Cdong]kOoVi^KogmoOomKF
e_o<c<coXJ>VofYkR?mfQY?oW::Wolo@d?ooool00Onb/[80000Eoooooonb
/[;oh>3PolS8b?nXZ:So][Jfol?3`oo?clooe]KFomoOgooVi^Koj^[Zono_
kooclo?om?CdooGemOogmoOom_KfooOgmoofm_Kon?Sh00;omoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP0@ooOg
moofm_Kom?Cdoo;bl_o`l?3ojn_[onKVi_oQhN7of][Jom?Cdoo9bLWo_kno
ojf][Oo8b<Soh>3Poo7al@[ooooo01?oUInWog66V?miPhco][Jfol?3`oo?
clooe]KFomoOgooVi^Koj^[Zono_kooclo?om?CdooGemOogmoOom_KfooOg
moofm_Kon?Sh00;omoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_Kf
ooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP0AooOgmoofm_Kom?Cdoo;bl_o`l?3ojn_[onKV
i_oQhN7of][Jom?Cdoo9bLWo_knoogf8T?maQYSoUInWolW;c?ooool00Onb
/[80000=oooooonb/[;od=3@okRh^?nPX:3o/k>col30`?o9bLWodm?ComWI
fOoMgMgoh^;RonGUi@02on[ZjP03onc/k?o]kNgokNg]00Ook^k^00?ol?3`
onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^ko
k^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05
onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h0
0oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`
onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^ko
k^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05
onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h0
0oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`
onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^ko
k^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05
onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h0
0oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`
onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^ko
k^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP04
onk^kP;okNg]0_o/k>`03OoYjNWoi^KVon?ShooPh>3ofm_KomGEeOo=cLgo
aLG5ok^k^onWYjOo^;Rhom3@d?oPh>002_o^k^h02on5TYcoJX6EohB:Sonc
/k?o`<30olW9bOoCdm?ofMWIomgMgOoRh^;oiNGU00;oj^[Z00?ok>c/ong]
kOo]kNd01oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Cok^k^0_o]kNd2onc/k00>onWYjOoVi^Kohn?S
on3Ph?oKfm_oeMGEolg=cOo5aLGo^k^kohZ@UOmZPIGoQI:Lok6d]oooool1
ok:b/P0000oooooook:b/_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iN
omgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:omWIf@[oi^KV00goV9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oM
gMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLH6@oiRN
X_o4aLKooooo007o/[:b00003ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN
0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?o
gMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;o
g=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oi^LWOmcPi;oW::Vol_<cOooool00Onb/[80000?oooooonb/[;oh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgM
g@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO4:ooooo`0=ojN]/OmhR9Oo
T96BojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2
omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oW9fNogR8UonW[K7of]_Looooo`01ok:b/P0000oooooo
ok:b/_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oM
gMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^
00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM
7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo007o
/[:b00003ooooooo/[:bol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUko
gMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:
b/[ofMWI2_oVi^H03OnHWZ;oLH6@ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgM
g@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3oV9jR
olC5a_ooool00Onb/[80000?oooooonb/[;odM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3
omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooM
gMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oL
g=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
VibMog>3T_nLXZKoblc=ooooo`01ok:b/P0000oooooook:b/_oPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM
0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@[ooooo00goYjfaogR8Uon@
TI;oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;o
g]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nLWIkoN8RGojN]/OoJfmcooooo007o/[:b00003ooooooo
/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgM
gAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h0
3OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdL
omkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb
/[80000?oooooonb/[;ob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oM
gMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
b_oIfMT:onKViP0=oiRNX_maPI3oSi2AojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM
0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog61T?nHWZ;o
a<G6ooooo`01ok:b/P0000oooooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?o
gMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgM
g@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcL
g00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nK
W9goLh>BoibRY_o;c<gooooo007o/[:b00003ooooooo/[:bon3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2
omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a2_ooool03OnW[K7oN8RGoi2A
T_nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oN
g]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oibMW_mhR9OoYjfaom[Kg?ooool00Onb/[80000?oooooonb
/[;odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM
7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=
oibRY_mcPi;oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAco
g]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b
/P0000oooooook:b/_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgM
g@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@[oi^KV00goV9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2
omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLH6@oiRNX_o4
aLKooooo007o/[:b00003ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooM
gMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM
0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL
00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^L
WOmcPi;oW::Vol_<cOooool00Onb/[80000?oooooonb/[;oh>3PolS8b?nE
UIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;o
g]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO4:ooooo`0=ojN]/OmhR9OoT96B
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkN
gT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oW9fNogR8UonW[K7of]_Looooo`01ok:b/P0000oooooook:b
/_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdL
omkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^00go
W::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oN
g]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b
00003ooooooo/[:bol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM
0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[o
fMWI2_oVi^H03OnHWZ;oLH6@ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;o
g]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3oV9jRolC5
a_ooool00Onb/[80000?oooooonb/[;odM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgM
g@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2
omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`0
3ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibM
og>3T_nLXZKoblc=ooooo`01ok:b/P0000oooooook:b/_oPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oN
g]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@[ooooo00goYjfaogR8Uon@TI;o
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN
@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nLWIkoN8RGojN]/OoJfmcooooo007o/[:b00003ooooooo/[:b
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAco
g]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnL
XZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkN
gP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb/[80
000?oooooonb/[;ob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2
omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMT:onKViP0=oiRNX_maPI3oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oN
g]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog61T?nHWZ;oa<G6
ooooo`01ok:b/P0000oooooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM
0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;o
g]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9go
Lh>BoibRY_o;c<gooooo007o/[:b00003ooooooo/[:bon3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkN
gT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>3olO7a2_ooool03OnW[K7oN8RGoi2AT_nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`o
omkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0
omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oibMW_mhR9OoYjfaom[Kg?ooool00Onb/[80000?oooooonb/[;o
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oN
g]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=oibR
Y_mcPi;oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN
0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b/P00
00oooooook:b/_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;o
g]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@[oi^KV00goV9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkN
gP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLH6@oiRNX_o4aLKo
oooo007o/[:b00003ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2
omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oN
g]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oo
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmc
Pi;oW::Vol_<cOooool00Onb/[80000?oooooonb/[;oh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN
@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO4:ooooo`0=ojN]/OmhR9OoT96BojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oo
g]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3o
gMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oW9fNogR8UonW[K7of]_Looooo`01ok:b/P0000oooooook:b/_oA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkN
gP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^00goW::V
og>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3
omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b0000
3ooooooo/[:bol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oN
g]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
2_oVi^H03OnHWZ;oLH6@ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN
0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3oV9jRolC5a_oo
ool00Onb/[80000?oooooonb/[;odM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;o
g]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkN
gUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog>3
T_nLXZKoblc=ooooo`01ok:b/P0000oooooook:b/_oPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`o
omkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@[ooooo00goYjfaogR8Uon@TI;oYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooN
g]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oM
gMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nLWIkoN8RGojN]/OoJfmcooooo007o/[:b00003ooooooo/[:bom7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN
0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKo
Lh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?o
gMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb/[80000?
oooooonb/[;ob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkN
gP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT:
onKViP0=oiRNX_maPI3oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2
omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog61T?nHWZ;oa<G6oooo
o`01ok:b/P0000oooooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oN
g]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN
G_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>B
oibRY_o;c<gooooo007o/[:b00003ooooooo/[:bon3Ph?o8b<SoUIFEojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oo
g]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oXJ6QolS8b?oPh>3olO7a2_ooool03OnW[K7oN8RGoi2AT_nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkN
gP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgM
g@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oibMW_mhR9OoYjfaom[Kg?ooool00Onb/[80000?oooooonb/[;odM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3
omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=oibRY_mc
Pi;oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooM
gMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b/P0000oo
oooook:b/_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN
0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@[o
i^KV00goV9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;o
gMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLH6@oiRNX_o4aLKooooo
007o/[:b00003ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkN
gUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iN
omgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;o
W::Vol_<cOooool00Onb/[80000?oooooonb/[;oh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooN
g]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nQXJ7ob<S8on3Ph?oalO4:ooooo`0=ojN]/OmhR9OoT96BojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN
0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM
0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oW9fNogR8UonW[K7of]_Looooo`01ok:b/P0000oooooook:b/_oAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?o
gMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^00goW::Vog>3
T_n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgM
g@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b00003ooo
oooo/[:bol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2
omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI2_oV
i^H03OnHWZ;oLH6@ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oM
gMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3oV9jRolC5a_ooool0
0Onb/[80000?oooooonb/[;odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN
G_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUko
gMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog>3T_nL
XZKoblc=ooooo`01ok:b/P0000oooooook:b/_oPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkN
gP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3Poo7al@[ooooo00goYjfaogR8Uon@TI;oYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3
omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2
omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nLWIkoN8RGojN]/OoJfmcooooo007o/[:b00003ooooooo/[:bom7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooM
gMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>B
ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM
0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb/[80000?oooo
oonb/[;ob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;o
gMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT:onKV
iP0=oiRNX_maPI3oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgM
gAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog61T?nHWZ;oa<G6ooooo`01
ok:b/P0000oooooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iN
omgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oM
gMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibR
Y_o;c<gooooo007o/[:b00003ooooooo/[:bon3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN
0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a2_ooool03OnW[K7oN8RGoi2AT_nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?o
gMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;o
g=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oibMW_mhR9OoYjfaom[Kg?ooool00Onb/[80000?oooooonb/[;odM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgM
g@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;o
Si2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2
omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b/P0000oooooo
ok:b/_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oM
gMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@[oi^KV
00goV9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM
7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLH6@oiRNX_o4aLKooooo007o
/[:b00003ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUko
gMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgM
g@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::V
ol_<cOooool00Onb/[80000?oooooonb/[;oh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3
omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO4:ooooo`0=ojN]/OmhR9OoT96BojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooM
gMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oL
g=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
W9fNogR8UonW[K7of]_Looooo`01ok:b/P0000oooooook:b/_oAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM
0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?
T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;o
g]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b00003ooooooo
/[:bol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgM
gAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI2_oVi^H0
3OnHWZ;oLH6@ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdL
omkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3oV9jRolC5a_ooool00Onb
/[80000?oooooonb/[;odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oM
gMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM
0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog>3T_nLXZKo
blc=ooooo`01ok:b/P0000oooooook:b/_oPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?o
gMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@[ooooo00goYjfaogR8Uon@TI;oYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgM
g@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcL
g00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nL
WIkoN8RGojN]/OoJfmcooooo007o/[:b00003ooooooo/[:bom7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2
omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@
TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oN
g]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb/[80000?oooooonb
/[;ob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM
7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT:onKViP0=
oiRNX_maPI3oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAco
g]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oVibMog61T?nHWZ;oa<G6ooooo`01ok:b
/P0000oooooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgM
g@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2
omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;
c<gooooo007o/[:b00003ooooooo/[:bon3Ph?o8b<SoUIFEojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooM
gMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
XJ6QolS8b?oPh>3olO7a2_ooool03OnW[K7oN8RGoi2AT_nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM
0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL
00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oibM
W_mhR9OoYjfaom[Kg?ooool00Onb/[80000?oooooonb/[;odM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;o
g]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2A
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkN
gT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b/P0000oooooook:b
/_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdL
omkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@[oi^KV00go
V9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oN
g]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLH6@oiRNX_o4aLKooooo007o/[:b
00003ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM
0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;o
g]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<
cOooool00Onb/[80000?oooooonb/[;oh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgM
g@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph?oalO4:ooooo`0=ojN]/OmhR9OoT96BojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2
omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`0
3ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oW9fN
ogR8UonW[K7of]_Looooo`01ok:b/P0000oooooook:b/_oAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oN
g]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97o
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN
@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b00003ooooooo/[:b
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAco
g]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI2_oVi^H03OnH
WZ;oLH6@ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkN
gP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3oV9jRolC5a_ooool00Onb/[80
000?oooooonb/[;odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2
omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN4:onk^kP0=oibRY_mcPi;oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oN
g]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog>3T_nLXZKoblc=
ooooo`01ok:b/P0000oooooook:b/_oPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM
0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@[ooooo00goYjfaogR8Uon@TI;oYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;o
g]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nLWIko
N8RGojN]/OoJfmcooooo007o/[:b00003ooooooo/[:bom7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkN
gT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`o
omkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0
omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb/[80000?oooooonb/[;o
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oN
g]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT:onKViP0=oiRN
X_maPI3oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN
0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oVibMog61T?nHWZ;oa<G6ooooo`01ok:b/P00
00oooooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;o
g]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkN
gP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<go
oooo007o/[:b00003ooooooo/[:bon3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2
omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6Q
olS8b?oPh>3olO7a2_ooool03OnW[K7oN8RGoi2AT_nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oN
g]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oo
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oibMW_mh
R9OoYjfaom[Kg?ooool00Onb/[80000?oooooonb/[;odM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN
@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oo
g]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3o
gMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b/P0000oooooook:b/_o:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkN
gP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@[oi^KV00goV9jR
og61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3
omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nKW9goLH6@oiRNX_o4aLKooooo007o/[:b0000
3ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oN
g]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN
0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOoo
ool00Onb/[80000?oooooonb/[;oh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;o
g]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7o
b<S8on3Ph?oalO4:ooooo`0=ojN]/OmhR9OoT96BojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkN
gUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oW9fNogR8
UonW[K7of]_Looooo`01ok:b/P0000oooooook:b/_oAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`o
omkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooN
g]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oM
gMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b00003ooooooo/[:bol[:
b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN
0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI2_oVi^H03OnHWZ;o
LH6@ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?o
gMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3oV9jRolC5a_ooool00Onb/[80000?
oooooonb/[;odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkN
gP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:
onk^kP0=oibRY_mcPi;oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2
omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog>3T_nLXZKoblc=oooo
o`01ok:b/P0000oooooook:b/_oPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oN
g]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3Poo7al@[ooooo00goYjfaogR8Uon@TI;oYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN
G_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nLWIkoN8RG
ojN]/OoJfmcooooo007o/[:b00003ooooooo/[:bom7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oo
g]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkN
gP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgM
g@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb/[80000?oooooonb/[;ob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3
omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT:onKViP0=oiRNX_ma
PI3oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooM
gMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oVibMog61T?nHWZ;oa<G6ooooo`01ok:b/P0000oo
oooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN
0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[o
k^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;o
gMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo
007o/[:b00003ooooooo/[:bon3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkN
gUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>3olO7a2_ooool03OnW[K7oN8RGoi2AT_nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iN
omgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oibMW_mhR9Oo
Yjfaom[Kg?ooool00Onb/[80000?oooooonb/[;odM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooN
g]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN
0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM
0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b/P0000oooooook:b/_o:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?o
gMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@[oi^KV00goV9jRog61
T?n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgM
g@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nKW9goLH6@oiRNX_o4aLKooooo007o/[:b00003ooo
oooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2
omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^
k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oM
gMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOooool0
0Onb/[80000?oooooonb/[;oh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN
G_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO4:ooooo`0=ojN]/OmhR9OoT96BojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUko
gMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oW9fNogR8UonW
[K7of]_Looooo`01ok:b/P0000oooooook:b/_oAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkN
gP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3
omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2
omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b00003ooooooo/[:bol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3oog]kN0ooMgMd2omkNgSCogMgM00?odm?ColW9bOoMgMd03ooM
gMd00oo<c<coclo?omgMg@04omgMg@03om[Jf_o?cloogMgM00GogMgM0_oA
dM47omgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIf@[oi^KV00goV9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN
?OoMgMd00ooCdm?obLW9omgMg@0<omgMg@03olK6a_oKfm_ogMgM00oogMgM
0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog61T?nHWZ;o
a<G6ooooo`01ok:b/P0000oooooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?o
gMgM0_oNg]hVomgMg@03obh^;_mWIfOogMgM00CogMgM00?o=cLgofi^K_oM
gMd00_oMgMd01_o8b<So@410o`820_lN7Qko4a<CojNWY`;ogMgM00?oK6a/
o`000?no_kl00ooMgMd02_lg=cOoKVi^omgMgOoMgMgo_Kfmobd];Ol<30co
2PX:oc4a<Onn_[h2omgMg@06ojFUYOlG5aOo1PH6odM7AomdM7Co:BTY0_oM
gMd01OlP823o3@d=oa/K6om2@T;oeMGE00GogMgM0_oNg]h2omgMgAcog]kN
0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKo
Lh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`oomkNgP?ogMgM0_oNg]haomgMg@03obh^;_n?ShoogMgM00;o
gMgM00?oYjNWo`000?n6QXH00_oMgMd02Oo8b<So@410o`820_lN7Qko4a<C
ojNWYoo0`<3o4Q8Bojn_[`02omgMg@08og9bL_lD51Cob<S8omgMgOnf][Ko
820PoaXJ6_nQXJ4@omgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgM
g@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb/[80000?oooooonb/[;oh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL?ooNg]h3omgMg@;og]kN9_oMgMd00ol^;RkoIfMWomgMg@04
omgMg@03ocLg=om^KVkogMgM00;ogMgM00_o>SXjocLg=oo1`L7ogMgMom;B
d_oAdM7ogMgMomcLg?lJ6Q[o4Q8BofUYJ@03omgMg@06ocLg=om^KVkogMgM
omcLg?l];BgoAdM70_o>c/h02_m9BDWo;Bd]omcLg?oMgMgoB4Q8ode=COoF
e]KoR8R8o`d=3OlY:BT2omgMg@05ojJVY_oIfMWog=cLobh^;_mnOWh01OoM
gMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3P
h?oalO4:ooooo`0=ojN]/OmhR9OoT96BojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgS7ogMgM
00So;Rh^ohn?SooMgMgogMgMomGEeOlP823o0000ohJ6QP;ogMgM00go>SXj
ocLg=oo1`L7ogMgMom;Bd_oAdM7ogMgMoi:BT_lN7Qkod=3@ojBTY?l51@Go
YZJV00;ogMgM00?oHF5QocPh>?oLg=`04OoMgMd2omkNgP;ogMgM7?oNg]h3
omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nLWIkoN8RGojN]/OoJfmcooooo007o/[:b0000
3ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgRKogMgM00?o
;Rh^ofMWIooMgMd01?oMgMd01olg=cOoKVi^omgMgOoMgMgo_knoo`000?nO
Wil01OoMgMd01OnUYJGo2@T9oibLW?lE5AGofMWI00;ogMgM00Ko=cLgofi^
K_oMgMgo^k^ko`000?nNWYh2omgMg@06oijNW_l0003o_[jnomgMgOlV9RKo
O7al0_oMgMd00omYJFWo:BTYomgMg@03omgMg@03ojZZZ_lC4a?oOgmo00Go
gMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]haomgM
g@0<obh^;_n?ShoogMgMomgMgOmUIFGo410@obDU9On6QXKogMgMokno_ol0
003oWinO1_oMgMd01?mHF5So@d=3oa<C4omeMGD3omgMg@03od92@_mRHV;o
gMgM017ogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`0
3ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibM
og>3T_nLXZKoblc=ooooo`01ok:b/P0000oooooook:b/_o:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`oomkNgP?ogMgM0_oNg]hVomgMg@04obh^;_m;Bd_o[Jf]olc<c0?ogMgM
00Oo=cLgofi^K_oMgMgogMgMojBTY?l0003o=3@d00?o=SHf00OoZJVYomgM
gOmCDe?oD51@omgMgOlP823oV9RH00;ogMgM00Ko=cLgofi^K_oMgMgoY:BT
o`000?o7alL2omgMg@06olG5aOl0003oYjNWomgMgOlV9RKoOgmo0_oMgMd0
2OmkNg_o:BTYomgMgOoMgMgoaLG5od10@?l20P;oHF5QomGEe@05omgMg@;o
g]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@[oi^KV00goV9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN<OoMgMd03?l^
;RkoShn?omgMgOn_[joo0P82ohf=SOlf=SKoQXJ6omgMgOnTY:Co0000oc@d
=0?o=SHf00OoZJVYomgMgOoMgMgodM7Ao`P82?l=3@goe]KF00?ogMgM00?o
@T92of9RH_oMgMd04OoMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oM
gMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nKW9goLH6@oiRNX_o4aLKooooo007o/[:b00003ooooooo/[:bom7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3oog]kN0ooMgMd2omkNgRKogMgM00Wo;Rh^oaXJ6_lL71co
0000odi>C_oCdm?ogMgMocLg=omKFe/00_oMgMd03Onm_Kgo0000oiBDU?nc
/k?o[:b/o`820_o6a/Kodm?Co`T92OnSXj?ogMgMogMgMom1@D400_oMgMd0
1_lg=cOoKVi^omgMgOnn_[ko0000oibLW0;ogMgM00KoVYZJo`000?o2`/;o
gMgMobHV9_moOgl2omgMg@07og]kNolY:BWogMgMomgMgOlh>3So>CTiokfm
_@07omgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN
<OoMgMd04?l^;RkoShn?omSHf?lV9RKo@410omgMgOlf=SKoQXJ6omgMgOnm
_Kgo0000oiBDU?nc/k?o[:b/o`820_o6a/H2omgMg@04ofIVI_lL71co?clo
ofEUI@?ogMgM00?o@T92of9RH_oMgMd04OoMgMd2omkNgP;ogMgM7?oNg]h3
omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b0000
3ooooooo/[:bon3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgRKogMgM01co
;Rh^ofMWIooMgMgo][Jfo`X:2_mKFe_ogMgMocLg=ol@413oOGemolG5aOoK
fm_o=SHfoeaLG?oFe]KoR8R8obDU9OoMgMgoS8b<oaXJ6_oLg=cogMgMolW9
bOl61PKo`l?3omgMgOlg=cOoKVi^0_oMgMd01_lh>3So?Shnol30`?no_koo
?CdmocXj>P;ogMgM00Ko9RHVogmoOooMgMgogMgMog]kNolY:BT2omgMg@05
obl_;on2PX;ogMgMolW9bOoHf=P01OoMgMd2omkNgP;ogMgM7?oNg]h3omgM
g@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO4:ooooo`0=ojN]/OmhR9Oo
T96BojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3oog]kN0ooMgMd2omkNgS7ogMgM00So;Rh^ohn?Som^KVko30`<olC4
a?oMgMgo=SHfohJ6QP;ogMgM00Go=SHfoeaLG?oFe]KoR8R8obDU9@02omgM
g@0<oiVIVOl61PKo[jn_olW9bOlD51CoZJVYomgMgOoGemOo?clooeiNG_oC
dm?ofMWI4?oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcL
g00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nL
WIkoN8RGojN]/OoJfmcooooo007o/[:b00003ooooooo/[:bom7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3oog]kN0ooMgMd2omkNgRKogMgM01Co;Rh^ofMWIooMgMgogMgMoeUI
FOlK6a_ogMgModQ8B?mfMWKoD51@o`L71oo@d=3oalO7ocdm?Ol;2`_o61PH
oijNW_oMgMgoCTi>ogAdM0?ogMgM00GoE5ADogmoOooMgMgoB4Q8ogYjNP02
omgMg@06olW9bOm7AdOo3@d=o`d=3Om8B4SobLW90_oMgMd01_lj>S[oR8R8
omgMgOoMgMgoQXJ6oc`l?0;ogMgM00GoYJFUoc8b<_l=3@go410@olW9b@05
omgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN<OoM
gMd01?l^;RkoJ6QXo`@41?n2PX82omgMg@0=ocHf=_n6QXKogMgMomgMgOo7
alOo?Cdmo`/;2olH61SoWYjNomgMgOo9bLWo9RHVoh:2PP02omgMg@08oiNG
Uolf=SKof=SHofi^K_l61PKo2PX:oaLG5onFUYH@omgMg@;og]kN0_oMgMdL
omkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb
/[80000?oooooonb/[;ob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN9_oM
gMd01_l^;RkoIfMWomgMgOoMgMgo>c/kocXj>PCogMgM00Gof][JomgMgOoM
gMgogMgMom[JfP0AomgMg@;og=cL3_oMgMd00ooJf][ogMgMomgMg@05omgM
g@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@[oi^KV00goV9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN<OoMgMd0
0ol^;Rko10@4ocLg=`03omgMg@03ocHf=_n6QXKogMgM00?ogMgM00?of][J
omgMgOoMgMd02_oMgMd00om2@T;oHV9RomgMg@0AomgMg@;og]kN0_oMgMdL
omkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3oV9jRolC5a_ooool00Onb
/[80000?oooooonb/[;odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN9_oM
gMd01_l^;Rko:2PXodi>C_lQ8B7o0@41oiJFUQCogMgM00?oCTi>oginO_oM
gMd06ooMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkN
gS7ogMgM00?o;Rh^o`L71onn_[h00ooMgMd00olf=SKoQXJ6omgMg@0@omgM
g@03ol;2`_o0`<3ogMgM017ogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkN
gT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b/P0000oooooook:b
/_oPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]hVomgMg@05oiRHV?n5QHGo
QXJ6oiFEUOo0`<005OoMgMd00onLW9co/K6aomgMg@0KomgMg@;og]kN0_oM
gMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@[ooooo
00goYjfaogR8Uon@TI;oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN<OoMgMd00onHV9SoY:BT
omgMg@03omgMg@03oibLW?nk^k_ogMgM02CogMgM0_oNg]h2omgMgAcog]kN
0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oW9fNogR8UonW[K7of]_Looooo`01ok:b/P00
00oooooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;o
g]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkN
gP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<go
oooo007o/[:b00003ooooooo/[:bol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2
omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
okFe]Oo:b/[ofMWI2_oVi^H03OnHWZ;oLH6@ohn@TOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oN
g]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oo
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOma
PI3oV9jRolC5a_ooool00Onb/[80000?oooooonb/[;odM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN
@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oo
g]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3o
gMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b/P0000oooooook:b/_oP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkN
gP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@[ooooo00goYjfa
ogR8Uon@TI;oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3
omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nLWIkoN8RGojN]/OoJfmcooooo007o/[:b0000
3ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oN
g]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN
0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOoo
ool00Onb/[80000?oooooonb/[;ob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;o
g]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:b_oIfMT:onKViP0=oiRNX_maPI3oSi2AojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkN
gUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog61
T?nHWZ;oa<G6ooooo`01ok:b/P0000oooooook:b/_oAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`o
omkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooN
g]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oM
gMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b00003ooooooo/[:bon3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN
0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a2_ooool03OnW[K7o
N8RGoi2AT_nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?o
gMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oibMW_mhR9OoYjfaom[Kg?ooool00Onb/[80000?
oooooonb/[;odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkN
gP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:
onk^kP0=oibRY_mcPi;oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2
omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog>3T_nLXZKoblc=oooo
o`01ok:b/P0000oooooook:b/_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oN
g]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIf@[oi^KV00goV9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN
G_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLH6@
oiRNX_o4aLKooooo007o/[:b00003ooooooo/[:bom7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oo
g]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkN
gP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgM
g@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb/[80000?oooooonb/[;oh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3
omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO4:ooooo`0=ojN]/Omh
R9OoT96BojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooM
gMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oW9fNogR8UonW[K7of]_Looooo`01ok:b/P0000oo
oooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN
0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[o
k^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;o
gMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo
007o/[:b00003ooooooo/[:bol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkN
gUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/[ofMWI2_oVi^H03OnHWZ;oLH6@ohn@TOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iN
omgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3o
V9jRolC5a_ooool00Onb/[80000?oooooonb/[;odM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooN
g]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN
0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM
0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b/P0000oooooook:b/_oPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?o
gMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@[ooooo00goYjfaogR8
Uon@TI;oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgM
g@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nLWIkoN8RGojN]/OoJfmcooooo007o/[:b00003ooo
oooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2
omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^
k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oM
gMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOooool0
0Onb/[80000?oooooonb/[;ob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN
G_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT:onKViP0=oiRNX_maPI3oSi2AojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUko
gMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog61T?nH
WZ;oa<G6ooooo`01ok:b/P0000oooooook:b/_oAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkN
gP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3
omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2
omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b00003ooooooo/[:bon3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooM
gMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a2_ooool03OnW[K7oN8RG
oi2AT_nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM
0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oibMW_mhR9OoYjfaom[Kg?ooool00Onb/[80000?oooo
oonb/[;odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;o
gMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:onk^
kP0=oibRY_mcPi;oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgM
gAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog>3T_nLXZKoblc=ooooo`01
ok:b/P0000oooooook:b/_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iN
omgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:omWIf@[oi^KV00goV9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oM
gMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLH6@oiRN
X_o4aLKooooo007o/[:b00003ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN
0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?o
gMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;o
g=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oi^LWOmcPi;oW::Vol_<cOooool00Onb/[80000?oooooonb/[;oh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgM
g@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO4:ooooo`0=ojN]/OmhR9Oo
T96BojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2
omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oW9fNogR8UonW[K7of]_Looooo`01ok:b/P0000oooooo
ok:b/_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oM
gMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^
00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM
7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo007o
/[:b00003ooooooo/[:bol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUko
gMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:
b/[ofMWI2_oVi^H03OnHWZ;oLH6@ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgM
g@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3oV9jR
olC5a_ooool00Onb/[80000?oooooonb/[;odM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3
omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooM
gMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oL
g=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
VibMog>3T_nLXZKoblc=ooooo`01ok:b/P0000oooooook:b/_oPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM
0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@[ooooo00goYjfaogR8Uon@
TI;oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;o
g]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nLWIkoN8RGojN]/OoJfmcooooo007o/[:b00003ooooooo
/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgM
gAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h0
3OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdL
omkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb
/[80000?oooooonb/[;ob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oM
gMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
b_oIfMT:onKViP0=oiRNX_maPI3oSi2AojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM
0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog61T?nHWZ;o
a<G6ooooo`01ok:b/P0000oooooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?o
gMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgM
g@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcL
g00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nK
W9goLh>BoibRY_o;c<gooooo007o/[:b00003ooooooo/[:bon3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2
omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a2_ooool03OnW[K7oN8RGoi2A
T_nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oN
g]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oibMW_mhR9OoYjfaom[Kg?ooool00Onb/[80000?oooooonb
/[;odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM
7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=
oibRY_mcPi;oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAco
g]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b
/P0000oooooook:b/_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgM
g@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@[oi^KV00goV9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2
omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLH6@oiRNX_o4
aLKooooo007o/[:b00003ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooM
gMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM
0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL
00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^L
WOmcPi;oW::Vol_<cOooool00Onb/[80000?oooooonb/[;oh>3PolS8b?nE
UIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;o
g]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO4:ooooo`0=ojN]/OmhR9OoT96B
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkN
gT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oW9fNogR8UonW[K7of]_Looooo`01ok:b/P0000oooooook:b
/_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdL
omkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^00go
W::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oN
g]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b
00003ooooooo/[:bol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM
0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[o
fMWI2_oVi^H03OnHWZ;oLH6@ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;o
g]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3oV9jRolC5
a_ooool00Onb/[80000?oooooonb/[;odM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgM
g@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2
omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`0
3ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibM
og>3T_nLXZKoblc=ooooo`01ok:b/P0000oooooook:b/_oPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oN
g]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@[ooooo00goYjfaogR8Uon@TI;o
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN
@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nLWIkoN8RGojN]/OoJfmcooooo007o/[:b00003ooooooo/[:b
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAco
g]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnL
XZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkN
gP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb/[80
000?oooooonb/[;ob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2
omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMT:onKViP0=oiRNX_maPI3oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oN
g]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog61T?nHWZ;oa<G6
ooooo`01ok:b/P0000oooooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM
0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;o
g]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9go
Lh>BoibRY_o;c<gooooo007o/[:b00003ooooooo/[:bon3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkN
gT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>3olO7a2_ooool03OnW[K7oN8RGoi2AT_nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`o
omkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0
omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oibMW_mhR9OoYjfaom[Kg?ooool00Onb/[80000?oooooonb/[;o
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oN
g]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=oibR
Y_mcPi;oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN
0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b/P00
00oooooook:b/_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;o
g]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@[oi^KV00goV9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkN
gP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLH6@oiRNX_o4aLKo
oooo007o/[:b00003ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2
omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oN
g]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oo
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmc
Pi;oW::Vol_<cOooool00Onb/[80000?oooooonb/[;oh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN
@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO4:ooooo`0=ojN]/OmhR9OoT96BojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oo
g]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3o
gMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oW9fNogR8UonW[K7of]_Looooo`01ok:b/P0000oooooook:b/_oA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkN
gP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^00goW::V
og>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3
omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b0000
3ooooooo/[:bol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oN
g]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
2_oVi^H03OnHWZ;oLH6@ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN
0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3oV9jRolC5a_oo
ool00Onb/[80000?oooooonb/[;odM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;o
g]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkN
gUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog>3
T_nLXZKoblc=ooooo`01ok:b/P0000oooooook:b/_oPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`o
omkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@[ooooo00goYjfaogR8Uon@TI;oYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooN
g]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oM
gMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nLWIkoN8RGojN]/OoJfmcooooo007o/[:b00003ooooooo/[:bom7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN
0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKo
Lh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?o
gMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb/[80000?
oooooonb/[;ob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkN
gP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT:
onKViP0=oiRNX_maPI3oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2
omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog61T?nHWZ;oa<G6oooo
o`01ok:b/P0000oooooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oN
g]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN
G_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>B
oibRY_o;c<gooooo007o/[:b00003ooooooo/[:bon3Ph?o8b<SoUIFEojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oo
g]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oXJ6QolS8b?oPh>3olO7a2_ooool03OnW[K7oN8RGoi2AT_nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkN
gP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgM
g@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oibMW_mhR9OoYjfaom[Kg?ooool00Onb/[80000?oooooonb/[;odM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3
omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=oibRY_mc
Pi;oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooM
gMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b/P0000oo
oooook:b/_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN
0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@[o
i^KV00goV9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;o
gMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLH6@oiRNX_o4aLKooooo
007o/[:b00003ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkN
gUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iN
omgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;o
W::Vol_<cOooool00Onb/[80000?oooooonb/[;oh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooN
g]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nQXJ7ob<S8on3Ph?oalO4:ooooo`0=ojN]/OmhR9OoT96BojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN
0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM
0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oW9fNogR8UonW[K7of]_Looooo`01ok:b/P0000oooooook:b/_oAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?o
gMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^00goW::Vog>3
T_n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgM
g@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b00003ooo
oooo/[:bol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2
omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI2_oV
i^H03OnHWZ;oLH6@ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oM
gMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3oV9jRolC5a_ooool0
0Onb/[80000?oooooonb/[;odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kN
G_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUko
gMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog>3T_nL
XZKoblc=ooooo`01ok:b/P0000oooooook:b/_oPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkN
gP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3Poo7al@[ooooo00goYjfaogR8Uon@TI;oYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3
omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2
omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nLWIkoN8RGojN]/OoJfmcooooo007o/[:b00003ooooooo/[:bom7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooM
gMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>B
ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM
0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb/[80000?oooo
oonb/[;ob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;o
gMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT:onKV
iP0=oiRNX_maPI3oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgM
gAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog61T?nHWZ;oa<G6ooooo`01
ok:b/P0000oooooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iN
omgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oM
gMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibR
Y_o;c<gooooo007o/[:b00003ooooooo/[:bon3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN
0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a2_ooool03OnW[K7oN8RGoi2AT_nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?o
gMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;o
g=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oibMW_mhR9OoYjfaom[Kg?ooool00Onb/[80000?oooooonb/[;odM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgM
g@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;o
Si2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2
omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b/P0000oooooo
ok:b/_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oM
gMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@[oi^KV
00goV9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM
7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLH6@oiRNX_o4aLKooooo007o
/[:b00003ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUko
gMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgM
g@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::V
ol_<cOooool00Onb/[80000?oooooonb/[;oh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3
omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO4:ooooo`0=ojN]/OmhR9OoT96BojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooM
gMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oL
g=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
W9fNogR8UonW[K7of]_Looooo`01ok:b/P0000oooooook:b/_oAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM
0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?
T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;o
g]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b00003ooooooo
/[:bol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgM
gAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI2_oVi^H0
3OnHWZ;oLH6@ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdL
omkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3oV9jRolC5a_ooool00Onb
/[80000?oooooonb/[;odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oM
gMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN4:onk^kP0=oibRY_mcPi;oSi2AojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM
0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oVibMog>3T_nLXZKo
blc=ooooo`01ok:b/P0000oooooook:b/_oPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?o
gMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@[ooooo00goYjfaogR8Uon@TI;oYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgM
g@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcL
g00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nL
WIkoN8RGojN]/OoJfmcooooo007o/[:b00003ooooooo/[:bom7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2
omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q2_o^k^h03OnLXZKoLh>Bohn@
TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oN
g]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<cOooool00Onb/[80000?oooooonb
/[;ob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM
7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT:onKViP0=
oiRNX_maPI3oSi2AojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAco
g]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oVibMog61T?nHWZ;oa<G6ooooo`01ok:b
/P0000oooooook:b/_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgM
g@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@[ok^k^00goW::Vog>3T_n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2
omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLh>BoibRY_o;
c<gooooo007o/[:b00003ooooooo/[:bon3Ph?o8b<SoUIFEojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooM
gMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
XJ6QolS8b?oPh>3olO7a2_ooool03OnW[K7oN8RGoi2AT_nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM
0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL
00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oibM
W_mhR9OoYjfaom[Kg?ooool00Onb/[80000?oooooonb/[;odM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;o
g]kN@?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN4:onk^kP0=oibRY_mcPi;oSi2A
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkN
gT3ogMgM0_oLg=`03ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oVibMog>3T_nLXZKoblc=ooooo`01ok:b/P0000oooooook:b
/_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdL
omkNgP?ogMgM0_oNg]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@[oi^KV00go
V9jRog61T?n?T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oN
g]h3omgMg@;og]kN@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nKW9goLH6@oiRNX_o4aLKooooo007o/[:b
00003ooooooo/[:bom7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM
0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q2_o^k^h03OnLXZKoLh>Bohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;o
g]kN0_oMgMdLomkNgP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmcPi;oW::Vol_<
cOooool00Onb/[80000?oooooonb/[;oh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL?ooNg]h3omgM
g@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN@?oMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph?oalO4:ooooo`0=ojN]/OmhR9OoT96BojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3oog]kN0ooMgMd2
omkNgUkogMgM0_oNg]h2omgMgAcog]kN0ooMgMd2omkNgT3ogMgM0_oLg=`0
3ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oW9fN
ogR8UonW[K7of]_Looooo`01ok:b/P0000oooooook:b/_oAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkNgP?ogMgM0_oN
g]i0omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@[ok^k^00goW::Vog>3T_n?T97o
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
?ooNg]h3omgMg@;og]kNG_oMgMd2omkNgP;ogMgM7?oNg]h3omgMg@;og]kN
@?oMgMd2omcLg00?om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nKW9goLh>BoibRY_o;c<gooooo007o/[:b00003ooooooo/[:b
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3oog]kN0ooMgMd2omkNgUkogMgM0_oNg]h2omgMgAco
g]kN0ooMgMd2omkNgT3ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI2_oVi^H03OnH
WZ;oLH6@ohn@TOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`oomkNgP?ogMgM0_oNg]iNomgMg@;og]kN0_oMgMdLomkN
gP?ogMgM0_oNg]i0omgMg@;og=cL00oofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oi^LWOmaPI3oV9jRolC5a_ooool00Onb/[80
000?oooooonb/[;od=3@okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooG
emOofm_KomoOgooQhN7oh^;R00;ohn?S1ooUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2
onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2
onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2
onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi>CT0_oShn<0
3OoRh^;oh>3PomcLg?oIfMWoe]KFom3@d?o9bLWo`L71okFe]OnUYJGo^;Rh
om3@d?oPh>002_o^k^h03On4TIgoJ86Fohf@Ton/[:co^k^kolK6a_o=cLgo
dm?ComOGeooKfm_ogmoOon7QhOoRh^800_oShn<7onGUi@;oi^KV1_oUiND2
onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2
onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2
onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2
onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oTi>@2
on?Sh`0>on;Rh_oPh>3og=cLomWIfOoFe]Kod=3@olW9bOo1`L7o]KFeoiJH
VomXPIKoQ96Mojf`]?ooool1ok:b/P0000oooooook:b/_oPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`2omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oM
gMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oM
gMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oM
gMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oM
gMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd04_oNg]kogMgMomcLg?oLg=cofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@[ooooo00goRiVUoff6
Von@T97oYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooN
g]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkN
gP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM
00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgM
gOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooN
g]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkN
gP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM
00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgM
gOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooN
g]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkN
gP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM
00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgM
gOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooN
g]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkN
gP?ogMgM01?og]kNomgMgOoLg=cog=cLom_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nLW9goKHJKoh^IYOni_L7ooooo007o/[:b
00003ooooooo/[:bomCDe?no_kooS8b<oijNW_n][Jgo^KViol;2`_o7alOo
c<c<om3@d?oBd];oeMGEomKFeP02omOGe`03omSHf?oIfMWofMWI0?oofMWI
1OoIfMT2omSHf0;oemOG00goeMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo_kno
okFe]OnYZJWoV9RHokno_ooDe=Coh^;R00[ok^k^00goQY>Oofb5Von7R8Wo
WYjNojf][Oni^KWo`/;2olO7aoo<c<cod=3@om;Bd_oEeMGoe]KF00;oemOG
00?of=SHomWIfOoIfMT0oooIfMT5omWIf@;of=SH0_oGemL03_oEeMGodm?C
om3@d?o>c/kob/[:olG5aOno_koo]KFeojVYZOnCU9GoK8FKohJCWon_/[Go
oooo0Onb/[80000?oooooonb/[;odM7Aokno_on8R8SoTi>Coj:RX_n_[joo
^[Zjol71`Oo7alOobl_;olk>c_o@d=3odM7A00;odm?C0ooDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGE
eOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]Ko
eMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oF
e]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oD
e=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGE
e@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oE
eM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoEeMGoe=CD0_oCdm<03OoAdM7od=3@olg=cOo:b/[o`l?3okjn__nf
][KoZj^[oifMWOnATI7o_knoom7AdOoKfm/02_oVi^H03On4TYkoKHNNogUm
P?nCTi?oXZ:Rojn_[onj^[[o`L71olO7aoo;bl_oc/k>om3@d?oAdM400_oC
dm<3omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomGEeOoDe=@2om?Cd`0>om7AdOo@d=3ocLg=
ol[:b_o3`l?o_[jnokJf]_n[Zj_oWIfMoh:5R?m]QikoQ9:NojV]/?ooool1
ok:b/P0001Cooooook:b/_oMgMgocLg=oi2@T?n9RHWoUiNGojFUYOnb/[;o
_knool_;booAdM7oeMGEomOGeooIfMWof][Jom_KfooJf][ofm_KomcLg0Oo
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`04om_Kf`0?om[Jf_oIfMWof=SHomKFe_oCdm?ocLg=ol;2`_nf
][Ko[:b/oinOWon@T93oUYJFolg=cOoMgMgoiNGU00[ok^k^01;oS9VSog>=
X_maMgkoRHV9oiNGUonUYJGo/[:bokno_oo;bl_odM7AomGEeOoGemOofMWI
om[Jf_oKfm_of][Jom_KfooLg=`7om_Kf`03omcLg?oKfm_ofm_K00Gofm_K
00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcL
g?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_K
om_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/0
1OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K
00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcL
g?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_K
om_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/0
1OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K
00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcL
g?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_K
om_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/0
1OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K
00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcL
g?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01?oKfm/04?oJf][ofMWI
omSHf?oFe]Kodm?Colg=cOo2`/;o][Jfojb/[?nOWiooT92@ogMmPomcSJ;o
S9VSokJi_?ooool1ok:b/P0000gooooook:b/_obl_;oiNGUojVYZOmjNW[o
R8R8oiJFU_nZZZ[oa<C4omGEeOoKfm_og]kN00;oh>3P0ooRh^800ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01?oShn<2on;RhP0>on7QhOoPh>3ogmoOomcL
g?oGemOoaLG5ojb/[?nNWYkoT92@oh:2P_n][JgoiNGUoo;bl_oinOT:oooo
o`0;oj>[/omoUJOoLgj8ogYjN_n8R8SoUYJFojZZZ_o4a<CoeMGEom_KfooN
g]h00_oPh>03on;RhP03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`04on?Sh`;o
h^;R00oohN7Qon3Ph?oOgmoog=cLomOGeoo5aLGo[:b/oijNW_n@T93oPX:2
ogJ1RomoUJOoXj^com3Bdoooool00Onb/[80000@oooooonb/[;oiNGUomgM
gOo2`/;oNg]kogQhN?n6QXKoWinOolG5aOoHf=SogMgMomoOgooQhN7oh^;R
on?Sh`?oi>CT1?oUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@0
0ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2
onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03
onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>Co
iNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGU
onCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@0
0ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2
onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03
onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>Co
iNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGU
onCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@0
0ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2
onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03
onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>Co
iNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGU
onCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@0
0ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2
onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03
onGUi@Coi>CT00kohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0
P83oQ8B4ol?3`ooMgMgoiNGUon[ZjP[ok^k^00ko/;BgohZGXomgR9KoJ6aa
ogQhN?n6QXKoWinOolG5aOoHf=SogMgMomoOgooQhN7oh^;Ron?Sh`?oi>CT
1?oUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@Coi>CT
00oohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oLGAiogR9
Uon:Uj?o/;BgomKGeoooool00Onb/[80000=oooooonb/[;oh>3Pom_KfooB
d];oVi^KofEUIOmcLg?oSHf=ok^k^ooDe=Cof][JomgMg@02omoOg`03on3P
h?oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q
00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;R
h_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q
00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;R
h_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q
00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;R
h_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@0Bon;Rh_oQhN7ohN7Qon7QhOoP
h>3ogmoOomgMgOoLg=coeMGEokVi^On>SXkoNg]kofi^K_nNWYkod];Bom_K
fooPh>3oi>CT2_oVi^H02oo6alOoVj:Xoh>BWomYMh;oIFEUog=cLon=SHgo
^k^komCDe?oJf][ogMgM00;ogmoO00?oh>3Pon7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Q
h@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Q
h@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Q
h@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q01?oh^;Ron7QhOoQhN7ohN7Qon3Ph?oOgmoogMgMomcLg?oEeMGo
^KViohj>S_mkNg_oKVi^ofaiQOn3TYooVj:XolK7aooMgMgooooo007o/[:b
00003_oooooo/[:bon_[jooXj>Soh^;RomOGeon=SHgoHV9RogIfM_nTY:Co
alO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg003omcLg00Aom_K
fooLg=cofm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGoW9bLogEeMOmWIfOoT92@
omOGeooRh^;oj>SXon_[joo]kNd02_o^k^h03?oTi>Co_;o1oiJPZ?mmTJ;o
IFmhof9RH_mfMWKoY:BTolO7aooBd];oeMGEomSHf0;of][J0ooKfm/7omcL
g003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL
00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcL
g003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL
00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcL
g003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL
00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcL
g003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`00ooLg=`04_oKfm_og=cLom_KfooJf][ofMWIomSHf?oCdm?oaLG5
oibLW?meMGGoIfMWofQbN_mmTJ;oUZ2Xokbo`OoTi>CokNg]ooooo`7o/[:b
00004?oooooo/[:bookno_okno_on?Shoo;bl_oNg]koTI6AoeYJF_mkNg_o
Xj>Sokbl_?o6a/Kobl_;olg=cOo?cll2om7Ad@God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03
om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7o
d];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03
om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7o
d];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03
om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7o
d];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP?o
dM7A00god=3@olo?coo<c<cob<S8ok^k^onLW9coLW9boe]KFonDU9Cog]kN
oo;bl_ohn?Sono_k00;oo_kn2_ooool03_ono_koi^OWokk1aOnGXjkoPYBS
ofI`N?mJFU[oNg]koj>SXonl_;coa/K6ol_;boo=cLgoclo?0_oAdM45om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]83om7Ad@0=om3@d?o?clooc<c<olS8b?nk^k_oW9bLog9b
L_mKFe_oJG9koh:DXonGXjko_/75onKWi`02ooknoP7ooooo0Onb/[80000B
oooooonb/[;okNg]ong]kOoZj^[oj>SXon;Rh_oLg=coW9bLofe]KOmXJ6So
Ph>3oiNGUonSXj?o[:b/ojn_[ona/K7o/[:b0_nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@03_nc/k?o
/[:bok>c/on_[jooZZZZoibLW?n2PX;oHV9Rofi^K_nOWioog=cLon;Rh_oX
j>Soj^[Z0_o]kNd;onk^kP0@ong]kOoVi^Koclo@ojfb]_n?W:OoOiBUofEd
POmIGV;oJ6QXoh>3PonGUiOoXj>Sojb/[?n_[joo/K6aok:b/P;o];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd
]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd01;o/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9RH_mJGf?oJ7J4
ognDYOn?W:Oo[K:folo?d?oVi^KokNg]onk^k_ooool1ok:b/P0000?ooooo
ok:b/_oVi^H00_oUiND03ooShn?oh>3PomgMgOoJf][oa<C4oiZJV_mjNW[o
JFUYof=SHomYJFWoLW9bogAdM?miNGWoO7alog]kN`02ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00ooO7al
og]kNomjNW[oNWYjogMgMomdM7CoKFe]ofm_KomlO7coVYZJolG5aOoJf][o
gMgMon3Ph?oShn<00_oUiND=onKViP0AonGUiOoNg]kobLW:ojja]?nBW:Go
PiBSogB8V_mSLh3oFV=[oeYNH_mNGf3oJFUYog9bL_mdM7CoNGUiogalO?mk
Ng/00_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@0AogalO?mkNg_oNWYjogYjN_mgMgOoM7AdofQYJ_mOI6Oo
FfE]of=cP?mdRI_oPiBSoi:LYOn^/KCobLW:omkNg_oUiND00_oVi^H1oooo
o`7o/[:b00001?oooooo/[:bonk^k_o^k^h2ong]k@04onc/k?oZj^[oj>SX
onGUi@;oh^;R00?oh>3PomoOgooNg]h0oooMgMd=omgMg@03omkNg_oOgmoo
h>3P00;oh^;R00CoiNGUonSXj?oZj^[ok>c/0_o]kNd?onk^kP0;ong]kOoV
i^Kof=WIokk0`_nY[[?oTijXohNGY_mnUZ[oNiN^ogRF[omhUJl00omgUJh0
0omlU:SoMiF^ogNE[P04ogNE[P;oO9BX1_mgUJh2ogbDZ0KoMiF^0_mlU:P6
ogNE[P;oO9BX1_mgUJh2ogbDZ0KoMiF^0_mlU:P6ogNE[P;oO9BX1_mgUJh2
ogbDZ0KoMiF^0_mlU:P6ogNE[P;oO9BX1_mgUJh2ogbDZ0KoMiF^0_mlU:P6
ogNE[P;oO9BX1_mgUJh2ogbDZ0KoMiF^0_mlU:P6ogNE[P;oO9BX1_mgUJh2
ogbDZ0KoMiF^0_mlU:P6ogNE[P;oO9BX1_mgUJh2ogbDZ0KoMiF^0_mlU:P6
ogNE[P;oO9BX1_mgUJh2ogbDZ0KoMiF^0_mlU:P6ogNE[P;oO9BX1_mgUJh2
ogbDZ0KoMiF^0_mlU:P6ogNE[P;oO9BX1_mgUJh2ogbDZ0KoMiF^0_mlU:P6
ogNE[P;oO9BX1_mgUJh2ogbDZ0SoMiF^00_oN9F_ogRF[omkUjkoOYJZohNG
Y_nCWZSoZJjcokk0`_oHfMWoi^KVong]k@03onk^kP7ooooo0Onb/[800003
oooooonb/[;ooooo00?ooooo0_ono_h00oomoOgono_koo_kn`02ooWin@;o
n?ShooogmoL=ooOgm`;on?Sh0_oinOT2oo_kn`03oogmoOono_koo_kn01?o
oooo00Ooo_knooOgmooXjNWoc<k@okJl`?nS[KGoVZNa00;oUjFa0onFY;00
0onV[[GoVJJaoiJT/003oiJT/004oiVV/OnV[[GoYZjeoiVV/@CoUZB`00Co
VJJaojJ^]OnV[[GoVJJa1?nFY;001?nIY[7oYZjeojJ^]OnIY[44oiJT/004
oiVV/OnV[[GoYZjeoiVV/@CoUZB`00CoVJJaojJ^]OnV[[GoVJJa1?nFY;00
1?nIY[7oYZjeojJ^]OnIY[44oiJT/004oiVV/OnV[[GoYZjeoiVV/@CoUZB`
00CoVJJaojJ^]OnV[[GoVJJa1?nFY;001?nIY[7oYZjeojJ^]OnIY[44oiJT
/004oiVV/OnV[[GoYZjeoiVV/@CoUZB`00CoVJJaojJ^]OnV[[GoVJJa1?nF
Y;001?nIY[7oYZjeojJ^]OnIY[44oiJT/004oiVV/OnV[[GoYZjeoiVV/@Co
UZB`00CoVJJaojJ^]OnV[[GoVJJa1?nFY;001?nIY[7oYZjeojJ^]OnIY[44
oiJT/004oiVV/OnV[[GoYZjeoiVV/@CoUZB`00CoVJJaojJ^]OnV[[GoVJJa
1?nFY;001?nIY[7oYZjeojJ^]OnIY[44oiJT/004oiVV/OnV[[GoYZjeoiVV
/@CoUZB`00CoVJJaojJ^]OnV[[GoVJJa1?nFY;001?nIY[7oYZjeojJ^]OnI
Y[44oiJT/004oiVV/OnV[[GoYZjeoiVV/@CoUZB`00CoVJJaojJ^]OnV[[Go
VJJa1?nFY;001?nIY[7oYZjeojJ^]OnIY[44oiJT/004oiVV/OnV[[GoYZje
oiVV/@CoUZB`00CoVJJaojJ^]OnV[[GoVJJa1?nFY;001?nIY[7oYZjeojJ^
]OnIY[44oiJT/004oiVV/OnV[[GoYZjeoiVV/@CoUZB`00CoVJJaojJ^]OnV
[[GoVJJa1?nFY;001?nIY[7oYZjeojJ^]OnIY[44oiJT/004oiVV/OnV[[Go
YZjeoiVV/@CoUZB`00CoVJJaojJ^]OnV[[GoVJJa1onFY;02oiNU/@07oiZW
/OnS[KGo][c0olc>d?oXjNWomoOgooknoP06ooooo`7o/[:b00000ooooooo
/[:bok:b/P3ook:b/_oo/[:bFOnb/[81ooooo`7o/[:b003ooooooooooooo
GOooool1ok:b/P00F_o^k^h01_lI8R;o4A4AoaTR8_lI8R[o4A4AoaTR8Poo
4A4A00?o0000oaTI4Ol000001?lA4A400ol0003o4A4Aoa4A4@04oa4A4@;o
000000?o4A4Ao`000?lA4A400_lA4A400olI6A7o6ATIoa4A4@0Goa4A4@03
oaTI6OlA4A7o4A4A00Co4A4A00?o6B8Roa4A4OlA4A400olA4A400ol0003o
4A4Aoa4A4@02oa4A4@03o`000?lA4A7o4A4A00Co4A4A00Co0000oa4A4Ol0
003o00000_lA4A401_l0003o4A4Aoa4A4Ol0003o4A4Ao`0000co4A4A00Ko
0000oa4A4OlA4A7o0000oa4A4Ol0000>oa4A4@03o`000?lA4A7o4A4A00;o
4A4A00Co0000oa4A4OlA4A7o6ATA0_lA4A400ol0003o4A4Ao`000003oa4A
4@03o`000?lA4A7o4A4A00Co4A4A00?o6ATAoa4A4OlA4A400_lA4A400olI
6A7o4A4Aoa4A4@04oa4A4@03oaTI4OlA4A7o4A4A00;o4A4A00?o:Q48oa4A
4OlA4A400olA4A400olI6A7o4A4Aoa4A4@09oa4A4@06obXA2?lA4A7o4A4A
oa4A4OlI6AWo:Q481?lA4A400olI6A7o4A4Aoa4A4@02oa4A4@03oaTI4OlA
4A7o4A4A00;o4A4A00?o6ATIoa4A4OlA4A401_lA4A42oaTI4@?o4A4A0olI
6A401?lZ8QWo6ATIoa4A4OlZ8QT2ob8R4@0>obXA2?lA4A7o4A4AobXR6OlI
6A7o6ATIob8R4OlI6A7o6ATIobXA2?lI6AWo:Q48oaTI4OlA4A42oaTI4@07
ob8R4OlI6A7o8R8AoaTI4OlR8Q7o6ATIoaTI4@02ob8R4@06oaTI4OlZ4@So
:Q48oa4A4OlR8Q7o6ATA0_lR8Q401?lI6A7o8R8AoaTI4OlI6A42ob8R4@0;
oaTI4OlI6AWo:Q48oaTI6OlI6A7o:R8IoaTI6Ol0003o8R8AobXA2?lI6A40
0_lR8Q402?lI6AWo0000obXR6OlI6AWo8R8AoaTI4OlZ4@So6ATI0_lI6A40
1OlI6AWo8R8Aob8R4OlI6A7o6ATI00;o:Q4800Ko8R8AoaTI4OlR8Q7o6ATA
ob8R4OlI6AT2ob8R4@03oaTI4OlR8Q7o:Q4800;o8R8A00oo:Q48oaTI6OlI
6AWo:Q48oaTI6OlR8Q7o6ATAob8R4OlI8R;o8R8AoaTI6OlZ8QWo6ATIob8R
4OlI8R800_lI6AT2ob8R4@Co:R8I00Ko6B8RoaTI6OlZ8QWo6B8RobXR6Om<
A2:Tonk^kP00F_ooool01?lI8R[o6B8RoaTI6OlI8R83oaTI6@go4A4A00?o
0000oa4A4OlA4A400_lA4A401?l0003o4A4Aoa4A4Ol00002oa4A4@04o`00
0?lA4A7o0000o`0000Ko4A4A00?o0000oa4A4OlA4A402?lA4A42oaTI6@Ko
4A4A00?o0000oa4A4OlI6AT00olA4A400olI6AWo4A4Aoa4A4@03oa4A4@03
o`000?lA4A7o4A4A00;o4A4A00?o0000oa4A4OlA4A401olA4A42o`000003
oa4A4Ol0003o4A4A00;o4A4A00?o0000oa4A4OlA4A403OlA4A400ol0003o
4A4Ao`000002oa4A4@03o`000?lA4A7o4A4A00[o4A4A00?o0000oa4A4Ol0
00003OlA4A400ol0003o4A4Aoa4A4@05oa4A4@03o`000?lA4A7o:Q4800Co
4A4A00?o0000oa4A4OlA4A401?lA4A400ol0003o6ATAoa4A4@0@oa4A4@03
oaTI4OlA4A7o4A4A00Go4A4A00Wo:Q48oa4A4OlA4A7o4A4AoaTI4OlA4A7o
6ATAoa4A4OlI8R800olA4A400olI6AWo4A4Aoa4A4@0Eoa4A4@03o`000?lA
4A7o4A4A00;o4A4A00Co0000oa4A4OlA4A7o00000olA4A401olI6AWo4A4A
oa4A4OlI6AWo4A4AoaTI6OlI6A400_lA4A401?lI6A7o4A4Aoa4A4OlZ4@P4
oa4A4@Co6ATA00Co8R8AoaTI4OlI6A7o4A4A1?lI6A400olR8Q7o6ATIobXA
2002oaTI6@05obXA2?lI6AWo6ATAob8R4OlI6A400_lI6AT00olZ4@So6ATA
oaTI4@02ob8R4@05oaTI4OlI6AWo6ATAo`000?lI6AT00_lI6A42ob8R4@04
oaTI4OlR8Q7o6ATAob8R4@;o6ATA00?o6ATIoaTI4OlI6A400_lR8Q403?lI
6A7o6ATIob8R4OlI6AWo:Q48oaTI6OlR8Q7o4A4AoaTI6OlR8Q7o:R8IoaTR
8P;o:R8I00ko6ATAob8R4OlR8Q7o8R8AoaTI4OlR8Q7o6ATAob8R4OlI6AWo
8R8AoaTI6OlZ4@So8R8AobXR6@;o8R8A0_lI6AT01_lZ8QWo8R8AoaTI6OlI
6AWo:R8IoaTR8P;o:R8I0_lI8R800omL>R;oooooooooo`2Rooooo`00F_o^
k^h00olI8R[o6B8RoaTR<P02ob8bA003ob8Z:_lI8R;o4A4A00oo4A4A00Co
0000oa4A4OlA4A7o00003olA4A400olI8R;o4A4AoaTI6@0Doa4A4@03o`00
0?lA4A7o000000Wo4A4A00Go6ATIo`000?lA4A7o4A4Ao`000006oa4A4@03
oaTI6OlA4A7o4A4A00_o4A4A00?o0000oa4A4OlA4A402OlA4A400ol0003o
4A4Aoa4A4@03oa4A4@06o`000?lA4A7o4A4Ao`000?lA4A7o00001?lA4A40
1OlI6AWo4A4Aoa4A4OlA4A7o000000Go4A4A00?o0000oa4A4OlA4A406OlA
4A400olI6A7o4A4Aoa4A4@0Boa4A4@03oaTI6Ol0003o4A4A00Go4A4A00Ko
6ATAoaTI6OlA4A7o6ATIoa4A4OlI6AT3oa4A4@06oaTI4OlA4A7o4A4AoaTI
6OlA4A7o6ATI1?lA4A401_lI6AWo4A4Aoa4A4OlI6AWo4A4AoaTI4@Go4A4A
00?o0000oa4A4OlA4A401olA4A400olZ4@So4A4Ao`00000;oa4A4@03obXA
2?lA4A7o4A4A00?o4A4A00?o6ATAoa4A4OlA4A401?lA4A400olI6A7o4A4A
oaTI6@03oa4A4@0IoaTI6OlA4A7o4A4Aoa4A4OlI6A7o6ATIoaTI4OlI6AWo
4A4AoaTI6OlI6A7o8R8AoaTI4OlI6AWo4A4Aob8R4OlI6AWo4A4AobXA2?lI
6A7o8R8AoaTI6OlR8Q7o6ATAoaTI6@02oaTI4@04oa4A4OlR8Q7o6ATAob8R
4@;o6ATA0_lR8Q42oaTI4@04obXR6OlI6AWo4A4Aob8R4@;o6ATI00?o8R8A
oaTI6OlR8Q400_lI6AT2ob8R4@04oaTI6OlR8Q7o8R8AoaTI6@;o8R8A01;o
6ATIob8R4OlI6AWo8R8AoaTI6OlR8Q7o6B8RoaTI6OlZ8QWo6ATIoaTR8_lZ
8QWo6ATIob8Z:_lI6AWo:R8Iob8R4OlR:RX2obXR6@04ob8Z:_lZ8QWo6ATI
ofEL:ZCok^k^001JonKViP04ob8bA?lI8S;o8SXbob9<E0;o<TAf00?o>UB7
ob94>_l000000_lA4A400ol0003o4A4Aoa4A4@0;oa4A4@03o`000?lA4A7o
4A4A00;o4A4A00?o0000oa4A4OlA4A401OlA4A401Ol0003o4A4Aoa4A4OlA
4A7o000000_o4A4A00Ko0000oa4A4OlA4A7o4A4AoaTI4Ol00003oa4A4@03
o`000?lA4A7o4A4A00;o4A4A00Co0000oa4A4OlA4A7o00001OlA4A400ol0
003o4A4Aoa4A4@03oa4A4@0:o`000?lA4A7o4A4Ao`000?lI6A7o4A4AoaTI
4OlA4A7o6ATIo`0000co4A4A00?o0000oa4A4Ol000000_lA4A400olI6A7o
4A4Aoa4A4@04oa4A4@03o`000?lI6A7o4A4A00?o4A4A00?o6ATAoa4A4OlA
4A402_lA4A400olI6A7o4A4Aoa4A4@06oa4A4@07oaTI4OlA4A7o4A4AoaTI
4OlA4A7o8R8Ao`000004oa4A4@05o`000?lA4A7o4A4Aoa4A4OlI6A400_lA
4A400olZ4@So4A4AoaTI4@02oa4A4@;o6ATA00Ko4A4AoaTI4OlA4A7o0000
oa4A4OlZ4@P2oa4A4@03obXA2?lA4A7o6ATA00Go4A4A00Ko:Q48oa4A4OlA
4A7o:Q48oa4A4OlZ4@P2oa4A4@04obXA2?lA4A7o6ATAoaTI6@Go4A4A00Co
8R8Aoa4A4OlI6AWo4A4A0_lI6AT01OlA4A7o6ATIoa4A4OlA4A7o6ATI00Ko
4A4A00?o6ATAoa4A4OlI6A401?lA4A402OlI6A7o4A4Aoa4A4Ol0003o4A4A
oaTI4Ol0003o:Q48oaTI4@06oa4A4@03oaTI4OlA4A7o6ATA00?o4A4A00?o
6ATAoa4A4OlA4A400_lA4A400olI6A7o4A4AoaTI4@05oa4A4@03obXA2?lA
4A7o4A4A00Ko4A4A00?o6ATAoa4A4OlI6A401OlA4A400olZ4@So4A4Aoa4A
4@02oa4A4@03obXA2?lA4A7o4A4A00Co4A4A00Ko6ATAob8R4OlI6AWo4A4A
ob8R4OlI6AT4ob8R4@0>oaTI6OlZ4@So6ATIob8R4OlI6AWo:R8IoaTI4OlZ
8QWo:Q48ob8R4OlZ4@So8R8AoaTR8_lZ8QT2ob8R4@04obXR6OlI6AWo:R8I
oaTI6@;o:R8I00Go6ATIob8R4OlZ8QWo6ATIobXA2002ob8R4@05obXR6OlZ
4@So6ATIob8R4OlI8R800_lZ8QT01_lR8Q7o6B8RobXR6OlR8Q7o6B8Rob8R
4@;o:R8I00Ko8R8AoaTR8_lZ8QWo:R8IoaTI6Om<A2:TonKViP00F_o^k^h0
2OlI8S;o0000oa4A4Ol0003oE6efoda]QoljG7Ko8SXboaTI6@05oa4A4@03
oaTI6OlA4A7o4A4A00?o4A4A00?o6ATIoa4A4OlA4A401?lA4A400ol0003o
4A4Aoa4A4@06oa4A4@03o`000?lA4A7o4A4A00?o4A4A00?o6ATIoa4A4OlA
4A404?lA4A400olI6A7o4A4Aoa4A4@0Foa4A4@03oaTI4OlA4A7o000000;o
4A4A00Go0000oa4A4OlA4A7o4A4AoaTI6@0?oa4A4@03o`000?lI6A7o4A4A
00[o4A4A00?o0000oa4A4OlA4A401OlA4A400olI6AWo:Q48oa4A4@05oa4A
4@03oaTI4OlA4A7o6ATA00Oo4A4A00?o0000oa4A4OlA4A401_lA4A400olI
6A7o4A4Aoa4A4@07oa4A4@03o`000?lI6A7o4A4A00Co4A4A00?o6ATAoa4A
4OlA4A400_lA4A401olI6AWo6ATAoaTI4OlI6A7o8R8Aoa4A4OlI6A400_lA
4A400olI6AWo4A4AoaTI4@02oa4A4@05oaTI4OlA4A7o8R8Aoa4A4OlI6A40
1OlI6AT01?lI6A7o6ATIoa4A4OlI6A42oa4A4@03oaTI6OlA4A7o6ATA00;o
4A4A00[o6ATAobXA2?lI6A7o6ATIoa4A4OlI6AWo4A4AoaTI4OlA4A7o6ATA
1?lA4A401?lI6A7o4A4AoaTI4OlI6A43oa4A4@04oaTI4OlA4A7o4A4AobXA
20Go4A4A00Ko6ATAoaTI6OlA4A7o4A4AoaTI4OlI6AT5oa4A4@03oaTI4OlZ
4@So4A4A00;o4A4A00Go8R8Aoa4A4OlA4A7o4A4AoaTI4@02oa4A4@05oaTI
4OlA4A7o4A4Aoa4A4OlI6A400_lA4A43oaTI4@07oa4A4OlZ4@So4A4AoaTI
4OlA4A7o6ATAoaTI6@02obXA2006oa4A4OlZ4@So4A4AoaTI4OlR8Q7o:Q48
0_lA4A402?lI6A7o4A4AoaTI4OlI6AWo6ATAoaTI6OlI6A7o4A4A0_lI6A40
0olZ4@So6ATAoaTI6@02oaTI6@05oaTI4OlR8Q7o6B8RobXA2?lI6AT01_lR
8Q400olZ8QWo8R8AoaTI6@02oaTI6@06ob8R4OlI6AWo8R8AobXR6OlI6AWo
:R8I0_lR8Q403?lI8R;o:R8IobXR6OlZ8QWo6B8Rob8R4OlZ8QWo6B8RobXR
6OlI8R;o8R8AobXR6@;o6B8R00?oG3XRonk^k_o^k^h0X_o^k^h005[ooooo
00So6B8RoaTR:_lA4A7o6ATIoa4A4OlRC5Co8S94o`0000;o4A4A00?o0000
oa4A4OlA4A401_lA4A401OlI6AWo4A4Ao`000?lA4A7o0000017o4A4A00Go
0000oa4A4OlA4A7o4A4Ao`00000@oa4A4@03o`000?lA4A7o4A4A00Go4A4A
00?o0000oa4A4OlA4A404?lA4A400ol0003o4A4Aoa4A4@03oa4A4@07o`00
0?lA4A7o0000oa4A4Ol0003o4A4Ao`00000<oa4A4@05o`000?lA4A7o4A4A
oa4A4Ol000000_lA4A400ol0003o4A4Aoa4A4@04oa4A4@03o`000?lA4A7o
000000Go4A4A00Go0000oa4A4Ol0003o6ATIo`000002oa4A4@03oaTI4Ol0
003o4A4A00Co4A4A00Go6ATIoa4A4OlA4A7o4A4Ao`000007oa4A4@03obXA
2?lA4A7o4A4A00_o4A4A00?o0000oaTI4OlA4A401?lA4A400ol0003o6ATI
oa4A4@03oa4A4@04oaTI4OlA4A7o6ATAoa4A4@;o6ATA00Ko:Q48oa4A4OlI
8R;o4A4AoaTI6OlZ4@P3oa4A4@08oaTI4OlA4A7o6ATAoaTI6OlA4A7o6ATA
oa4A4OlI6AT3oa4A4@03oaTI4OlA4A7o6ATA00Co4A4A00Go6ATAoa4A4OlI
6A7o4A4AoaTI6@03oa4A4@03o`000?lI6A7o000000;o4A4A00Co6ATAoa4A
4OlA4A7o6ATA2?lA4A400ol0003o6ATAoa4A4@03oa4A4@03oaTI4OlA4A7o
:Q4800Co4A4A00Go6ATIoa4A4OlA4A7o4A4AobXA2002oa4A4@03obXA2?l0
003o4A4A00?o4A4A00Oo6ATAobXA2?lA4A7o6ATIoaTI4OlA4A7o6ATA00;o
4A4A00Co6ATIoaTI4OlA4A7o6ATI0_lA4A42oaTI4@06oaTI6OlI6A7o6ATI
oa4A4OlI6A7o:Q480_lA4A401olI6A7o8R8Aoa4A4OlI6AWo8R8AoaTI6OlI
6A401?lA4A401olZ4@So4A4AoaTI4OlA4A7o6ATAoaTI6OlI6A402?lA4A40
3_lI6A7o8R8AoaTI6OlR8Q7o6ATAoaTI6OlR8Q7o6ATIob8R4OlI8R;o<RXR
oa4A4OlZ8QWo6B8R0olZ8QT01?lI8R;o:R8IobXR6OlR8Q42obXR6@03ob8Z
:_lZ8QWoG3XR0:Cooooo001Jonk^kP04oaTR8_lI8R[o4A4Aoa4A4@?o0000
00Go4A4Ao`000?lA4A7o4A4Ao`000005oa4A4@03o`000?lA4A7o000000[o
4A4A00?o0000oa4A4OlA4A401OlA4A400ol0003o4A4Aoa4A4@0Foa4A4@04
o`000?lA4A7o4A4Ao`0000Ko4A4A00Go0000oa4A4OlA4A7o4A4Ao`000008
oa4A4@03o`000?lA4A7o4A4A00?o4A4A00?o8RXZo`000?lA4A402?lA4A40
0ol0003o4A4AoaTI4@09oa4A4@05o`000?lA4A7o4A4Aoa4A4Ol000000_lA
4A401Ol0003o4A4Aoa4A4OlA4A7o000000Oo4A4A00?o0000oa4A4OlA4A40
2_lA4A400olI6AWo4A4AoaTI4@09oa4A4@03o`000?lA4A7o4A4A00Co4A4A
00?o:Q48oa4A4OlI6A400_lA4A401?lZ4@So4A4Aoa4A4OlZ4@P2oa4A4@03
oaTI4OlA4A7o4A4A00So4A4A00[o6ATAoa4A4OlI6A7o4A4AoaTI4Ol0003o
4A4AoaTI4OlA4A7o:R8I0_lI6A401OlI8R;o6ATAoaTI4OlA4A7o6ATI00;o
6ATA1olA4A400olI6A7o4A4Aoa4A4@04oa4A4@05oaTI6OlA4A7o4A4Aoa4A
4OlI6AT00olA4A400olZ4@So4A4Aoa4A4@06oa4A4@03oaTI4OlA4A7o4A4A
00;o4A4A00?o:Q48oa4A4OlI6A400olA4A400olI6A7o4A4Aoa4A4@0=oa4A
4@04oaTI6OlA4A7o4A4AobXA20;o4A4A00Co:Q48oa4A4OlI6A7o6ATA0olA
4A401?lI6A7o4A4Aoa4A4OlZ4@P2oa4A4@;o6ATA00Co4A4AobXA2?lI6A7o
4A4A0_lI6A402Olb:R;o6ATAoaTI4OlA4A7o:Q48oaTI4OlI6AWo6B8Roa4A
4@05oaTI4@04obXA2?lR8Q7o6ATAoa4A4@?o6ATA00?o4A4Aob8R4OlA4A40
1?lA4A42obXA2003oa4A4OlI6A7o6ATA00;o4A4A00go6ATAoa4A4OlI6A7o
6ATIoaTI4OlR8Q7o4A4AobXA2?lI6AWo:Q48oaTI4OlI6AWo6ATA00;o6ATI
0_lZ8QT01_lI8R;o:R8Iob8R4OlI8R;o6ATIocY46JCok^k^001JonKViP03
oa4A4OlI6AWo<SY401Co4A4A00?o0000oa4A4OlA4A400_lA4A400ol0003o
4A4Aoa4A4@0Boa4A4@03o`000?lA4A7o4A4A00;o4A4A00?o0000oa4A4OlA
4A400_lA4A401Ol0003o4A4Aoa4A4OlA4A7o000000Co4A4A00?o0000oa4A
4OlA4A400olA4A400ol0003o4A4Aoa4A4@0?oa4A4@03oaTI4OlA4A7o0000
00Wo4A4A00?o0000oa4A4OlI6A401OlA4A400ol0003o4A4Aoa4A4@09oa4A
4@03o`000?lA4A7o4A4A00co4A4A0_lI6A402?lI6AWo4A4Aoa4A4OlI6A7o
4A4AoaTI4OlA4A7o6ATA0_lA4A400ol0003o:Q48oa4A4@09oa4A4@03oaTI
4OlA4A7o4A4A00Co4A4A00?o6ATAoa4A4OlA4A400_lA4A400olI6A7o4A4A
oa4A4@03oa4A4@03obXA2?lA4A7o4A4A00?o4A4A00Co6ATAoa4A4OlA4A7o
6ATI1?lA4A401OlI6A7o6ATIoaTI4OlA4A7o6ATI00;o6ATA00?o4A4AoaTI
6OlA4A400_lA4A400olI6AWo4A4Aoa4A4@02oaTI6@Co4A4A00Wo6ATIoa4A
4OlA4A7o4A4AoaTI6OlA4A7o6ATAoaTI6OlI6A400_lA4A42oaTI4@Co4A4A
00Co:Q48oa4A4OlA4A7o:Q480olA4A402?lI6AWo4A4Aoa4A4OlI6A7o4A4A
oaTI4OlA4A7o6ATI1?lA4A401OlI6A7o4A4AoaTI6OlA4A7o:Q4800?o4A4A
00Co6ATIoa4A4OlA4A7o6ATA0_lA4A400olI6A7o4A4Aoa4A4@02oa4A4@08
oaTI4OlA4A7o4A4Aoa4A4OlZ4@So4A4AoaTI4OlA4A42oaTI4@08oaTI6OlA
4A7o4A4AoaTI4OlA4A7o6ATIoaTI4OlR8Q42oaTI4@05ob8R4OlI6AWo<RXR
obXA2?lI6AT00olI6A402OlR8Q7o4A4AoaTI6OlI6A7o:R8Iob8R4OlI6AWo
:Q48oa4A4@03oaTI4@03oa4A4OlI6A7o6ATA00?o4A4A0_lZ4@P3oa4A4@05
oaTI4OlA4A7o4A4AobXA2?lA4A401?lI6A402?lR8Q7o6ATIoaTI4OlI6AWo
6ATAob8R4OlI8R;o8R8A0_lI6AT02OlZ8QWo6ATIoaTI4OlR8Q7o6ATIoaTR
8_lZ8QWo6ATIoe`j8P2TonKViP00F_o^k^h01?lI8R;o6ATIo`000?lI6AT4
oa4A4@03oaTI6OlA4A7o000000;o4A4A00Go0000oa4A4OlA4A7o6ATAo`00
0003oa4A4@05o`000?lA4A7o4A4Aoa4A4Ol000001?lA4A400ol0003o4A4A
oa4A4@03oa4A4@04o`000?lA4A7o4A4Ao`0000;o4A4A00?o0000oa4A4OlA
4A401?lA4A400ol0003o4A4Aoa4A4@02oa4A4@03o`000?lA4A7o000000Wo
4A4A00?o0000oa4A4OlA4A400_lA4A400ol0003o4A4AobXA2002oa4A4@04
o`000?lA4A7o0000oaTI6@co4A4A00?o0000oa4A4OlA4A400_lA4A401?l0
003o4A4Aoa4A4Ol00002oa4A4@05o`000?lA4A7o4A4Aoa4A4Ol000000olA
4A400ol0003o4A4Aoa4A4@07oa4A4@03o`000?lA4A7o4A4A00;o4A4A00?o
0000oa4A4Ol000000_lA4A400olI6AWo4A4Aoa4A4@02oa4A4@03obXA2?lA
4A7o4A4A00Ko4A4A00?o6ATIoa4A4OlA4A400_lA4A400olI6A7o4A4Aoa4A
4@03oa4A4@03obXA2?lA4A7o4A4A00Wo4A4A00?o:Q48oa4A4OlA4A402olA
4A401OlI6A7o4A4AobXA2?lA4A7o6ATI00?o6ATA0olA4A401OlZ4@So6ATA
oa4A4OlA4A7o6ATA00;o4A4A00Co6ATAoaTI6OlI6A7o6ATA0_lI6AT00olA
4A7o6ATAoaTI4@04oa4A4@03oaTI6OlA4A7o6ATI00;o4A4A0_lI6AT2oaTI
4@Co4A4A00Co6ATAoa4A4OlA4A7o6ATA2olA4A400olZ8QWo4A4Aoa4A4@02
oa4A4@03oaTI4OlA4A7o:Q4800Go4A4A00So6ATAoa4A4OlI6AWo4A4AoaTI
4OlA4A7o6ATIobXA20;o4A4A00Oo6ATAoa4A4OlA4A7o4A4AobXA2?lA4A7o
:Q4800;o4A4A00Ko:Q48oa4A4OlA4A7o4A4Aob8R4OlI6A43oa4A4@03obXA
2?lA4A7o4A4A00;o6ATA00Oo4A4AoaTI6OlI6A7o6ATAoa4A4OlR8Q7o4A4A
00;o6ATA00So8R8Aoa4A4OlR8Q7o6ATAoa4A4OlI6A7o8R8AoaTI4@;o4A4A
00?o6ATAobXA2?lA4A400_lA4A401?lI6A7o4A4Aoa4A4OlI6A43oa4A4@05
oaTI4OlA4A7o4A4Aoa4A4OlI6A400_lA4A42oaTI4@05oa4A4OlI6AWo6ATA
ob8R4OlI6AT00olR8Q42oaTI6@0=obXR6OlI6AWo8R8AoaTI6OlZ8QWo6ATA
obXR6OlI8R;o8R8AoaTI6OlZ8QWo6B8Roda48P2Tonk^kP00F_ooool2oa4A
4@03o`000?lI6AWo4A4A00Oo4A4A00Go0000oa4A4OlA4A7o4A4Ao`00000:
oa4A4@03o`000?lA4A7o4A4A00Go4A4A00Co0000oa4A4OlA4A7o00001OlA
4A400ol0003o4A4Ao`000008oa4A4@03oaTI6OlA4A7o4A4A00Co4A4A00?o
0000oa4A4OlA4A401?lA4A400ol0003o4A4Aoa4A4@05oa4A4@05o`000?lA
4A7o4A4Aoa4A4Ol000000olA4A401Ol0003o4A4Aoa4A4OlA4A7o000000Co
4A4A00?o0000oa4A4OlA4A401OlA4A400ol0003o4A4Aoa4A4@09oa4A4@03
o`000?lA4A7o4A4A00;o4A4A00?o0000oa4A4OlA4A401olA4A400olI6A7o
4A4Aoa4A4@08oa4A4@05oaTI4OlA4A7o6ATAoaTI4OlI6AT00_lA4A400olI
6A7o4A4Aoa4A4@09oa4A4@03obXA2?lA4A7o4A4A00;o4A4A00?o6ATIoa4A
4OlI6A400_lA4A400olI6A7o4A4Aob8R4@06oa4A4@03obXA2?lA4A7o4A4A
00Co4A4A00Ko6ATAoa4A4OlI6A7o4A4AoaTI4OlA4A42oaTI4@04oaTI6OlI
6A7o6ATAoaTI4@?o6ATI00?o8R8AoaTI4OlI6AT00_lA4A42oaTI6@04oa4A
4OlI6A7o:Q48oaTI6@;o4A4A00Co6ATIoa4A4OlA4A7o6ATA0_lA4A401olI
6A7o4A4Aoa4A4OlI6A7o4A4AoaTI4OlI6AT00_lA4A401?lI6A7o4A4Aoa4A
4OlZ4@P5oa4A4@06oaTI4OlZ4@So4A4AoaTI4OlI6AWo6ATA0_lZ4@P01OlI
6AWo4A4Aoa4A4OlA4A7o8R8A00Ko4A4A00Go6ATIobXA2?lA4A7o4A4AoaTI
4@02oa4A4@05oaTI6OlI6A7o6ATIoaTI4OlR8Q400_lI6AT01_lR8Q7o6ATA
oaTI4OlI6AWo:Q48oa4A4@?o6ATA00Ko8R8Aoa4A4OlR8Q7o6ATAoa4A4OlZ
4@P2oaTI4@03oaTI6OlZ4@So6ATA00;o6ATA00?o6ATIob8R4OlR8Q400_lI
6AT01?lR8Q7o6ATAoa4A4OlZ4@P3oa4A4@06oaTI4OlA4A7o6ATAoa4A4OlZ
4@So6ATI1?lA4A401?lZ4@So4A4Aoa4A4OlZ4@P2oa4A4@05obXA2?lI6A7o
6ATIobXR6OlR8Q401OlI6A402_lI6AWo8R8Aob8R4OlI6AWo6ATAob8R4OlI
6A7o6ATIoaTR8_lR8Q43oaTI6@07obXR6OlI6AWo8R8AoaTR8_lI6AWo6B8R
od@j8P2Tooooo`00F_o^k^h2oa4A4@03oaTI6OlA4A7o4A4A00;o4A4A00Co
0000oa4A4OlA4A7o00002?lA4A401OlI8R;o0000oa4A4OlA4A7o000001?o
4A4A00?o0000oa4A4OlA4A406?lA4A401?l0003o4A4Aoa4A4Ol0000Doa4A
4@03oaTI6Ol0003o4A4A00Oo4A4A00Co0000oa4A4OlA4A7o00000_lA4A40
0ol0003o4A4Aoa4A4@03oa4A4@03o`000?lA4A7o4A4A00Co4A4A00?o6ATI
o`000?lA4A401olA4A400ol0003o4A4Aoa4A4@02oa4A4@03oaTI4OlA4A7o
4A4A00Go4A4A00?o6ATIoa4A4OlA4A401?lA4A400olI6A7o4A4Aoa4A4@06
oa4A4@03obXA2?lI6A7o4A4A00;o6ATA0_lA4A401OlI6A7o4A4Aoa4A4OlA
4A7o:Q4800;o4A4A00Ko6ATAoa4A4OlA4A7o6ATIoa4A4OlI6A42oa4A4@05
oaTI4OlI6AWo4A4AoaTI4OlA4A400_lI6A401OlZ4@So8RXZoa4A4OlI6AWo
4A4A00;o6ATI00?o:Q48oaTI4OlI6A400_lI6A401OlI6AWo4A4Aoa4A4OlA
4A7o6ATA00;o4A4A00Co6ATIoa4A4OlI6A7o6ATA1?lA4A401?lI6A7o4A4A
oa4A4OlI6AT2oaTI4@03oa4A4OlI6A7o6ATA00Co4A4A00Co6ATAoa4A4OlA
4A7o:Q480olA4A400olZ4@So4A4Aoa4A4@07oa4A4@05oaTI4OlA4A7o4A4A
oa4A4OlZ4@P00olI6A401olA4A7o6ATAobXA2?lA4A7o8R8AoaTI4OlI6AT0
0_lI6A402olA4A7o6ATAoaTI4OlI6A7o4A4AoaTI4OlA4A7o8R8Aoa4A4OlI
6AWo6ATA00;o8R8A00Co6ATAob8R4OlR8Q7o6ATI0_lI6A42oaTI6@0AoaTI
4OlZ8QWo6ATIob8R4OlI6AWo6ATAob8R4OlI6A7o6ATIob8R4OlI6A7o8R8A
oa4A4OlZ4@So4A4AobXA2?lI6A400olA4A42oaTI4@03oa4A4OlZ4@So4A4A
00Co4A4A00Oo:Q48oaTI4OlI6A7o4A4AobXA2?lI6A7o6ATI00;o6ATA00?o
6ATIob8R4OlI6AT00_lI6A42ob8R4@07oaTI6OlR8Q7o8R8Aob8R4OlI8R;o
6ATIobXA2002oaTI6@05ob8R4OlI8R;o8R8AoaTI6OlI8R800_lZ8QT00olI
8R;o:R8Iod@j8P2Tonk^kP00F_oVi^H?oa4A4@05o`000?lA4A7o4A4Aoa4A
4Ol000001?lA4A401OlI6AWo0000oa4A4OlA4A7o000000Ko4A4A00Co0000
oa4A4OlA4A7o00000_lA4A400ol0003o4A4Aoa4A4@03oa4A4@03o`000?lA
4A7o4A4A00Oo4A4A00?o0000oa4A4OlA4A400_lA4A401_l0003o4A4Aoa4A
4Ol0003o4A4Ao`0000So4A4A00?o0000oaTI6OlA4A401?lA4A400ol0003o
4A4Aoa4A4@06oa4A4@08o`000?lA4A7o0000oa4A4Ol0003o6B8Zoa4A4Ol0
000Boa4A4@03o`000?lA4A7o4A4A00;o4A4A00?o0000oa4A4OlA4A400_lA
4A400ol0003o4A4Aoa4A4@05oa4A4@04oaTI6OlA4A7o4A4AoaTI4@Wo4A4A
00Ko6ATIoa4A4OlA4A7o0000oa4A4Ol0000<oa4A4@09oaTI4OlA4A7o0000
oa4A4OlZ4@So4A4AoaTI4OlA4A7o6ATI00Go4A4A00Go8R8Aoa4A4OlA4A7o
4A4AoaTI6@04oa4A4@05oaTI4OlA4A7o6ATAoa4A4OlI6AT00olA4A400olI
6AWo4A4AoaTI6@02oaTI6@;o6ATA00Co6ATIoa4A4OlI6A7o6ATA0_lA4A40
0olI6AWo0000oa4A4@03oa4A4@;o6ATA4OlA4A400olI6A7o4A4Aoa4A4@05
oa4A4@03oaTI4OlA4A7o6ATA00;o4A4A0_lI6A401_lA4A7o6ATAoaTI4OlA
4A7o6ATIoaTI4@;o4A4A00?o6ATAoa4A4OlI6AT00_lI6A402?lA4A7o6ATA
oa4A4OlI6A7o4A4AobXA2?lR8Q7o6ATI0_lI6A402_lA4A7o8R8AoaTI6OlI
6A7o6ATIob8R4Ol0003o6ATIoaTI4OlR8Q42oaTI4@06oaTI6OlR8Q7o6ATI
ob8R4OlI6A7o6ATI0_lI6A401?lI6AWo6ATAoaTI4OlA4A42oaTI4@Co4A4A
00Go:Q48oa4A4OlA4A7o4A4AobXA2002oaTI4@04obXA2?lI6A7o6ATAobXA
20Go4A4A00Ko6ATAoa4A4OlI6A7o6ATAob8R4OlI6AT4oaTI4@0;oaTI6OlZ
4@So6ATIob8R4OlI6AWo:Q48oaTR8_lI6AWo8R8AoaTR8_lI6AT00_lZ8QT0
1olI8R;o:R8IobXR6OlI8R;o:R8IoaTI6OljA1T0Y?oVi^H005[ok^k^1OlA
4A402Ol0003o4A4Aoa4A4OlA4A7o0000oa4A4Ol0003o4A4Ao`00000:oa4A
4@03o`000?lA4A7o4A4A00;o4A4A00Go0000oa4A4Ol0003o4A4Ao`00000;
oa4A4@05o`000?lA4A7o4A4Aoa4A4Ol000000_lA4A400ol0003o4A4Aoa4A
4@05oa4A4@03o`000?lA4A7o4A4A00Ko4A4A00?o0000oa4A4Ol000000olA
4A400ol0003o4A4AoaTR:P05oa4A4@03o`000?lA4A7o4A4A00Co4A4A00?o
0000oa4A4OlA4A401OlA4A401_l0003o4A4Aoa4A4Ol0003o4A4Ao`0000?o
4A4A00Co0000oa4A4OlA4A7o00001?lA4A400ol0003o4A4Aoa4A4@02oa4A
4@03o`000?lA4A7o4A4A00Co4A4A00Co0000oa4A4OlA4A7o00001olA4A40
0olI6A7o4A4Aoa4A4@02oa4A4@03oaTI6OlA4A7o4A4A00?o4A4A00?o6ATI
oa4A4OlZ4@P02?lA4A42oaTI4@[o4A4A00So6ATIoa4A4OlA4A7o0000oa4A
4OlI6A7o4A4AoaTI4@Go4A4A00Co0000oaTI6OlA4A7o6ATI1_lA4A401?lI
6A7o6ATIoaTI4OlI6A42oa4A4@;o6ATA00co6ATIoaTI4OlA4A7o6ATAoa4A
4OlI6A7o4A4AobXA2?l0003oC4`job8Z:_lZ4@P2oa4A4@07oaTI4OlA4A7o
4A4Aoa4A4OlI6A7o4A4AobXA2003oa4A4@03obXA2?lA4A7o4A4A00;o4A4A
013o0000oaTI4OlA4A7o6ATAoa4A4OlI6A7o4A4AoaTI4OlA4A7o:Q48oa4A
4OlI6A7o4A4AoaTI4OlA4A7o6ATA1?lA4A400olI6AWo4A4AoaTI4@04oa4A
4@0;oaTI4OlZ4@So4A4Aoa4A4OlI6A7o4A4AoaTI4OlA4A7o6ATAoaTI6OlA
4A400_lI6A42oa4A4@06oaTI4OlI6AWo8R8Aob8R4OlI6AWo6ATA0_lI6AT0
1_lZ4@So6ATIoaTI6OlI6A7o6B8Rob8R4@;o6ATA00?o4A4AobXR6OlZ4@P0
0_lA4A402olI6A7o4A4AobXA2?lA4A7o6ATAoa4A4OlZ4@So4A4AoaTI4OlA
4A7o:Q4800?o4A4A00?o6ATAoa4A4OlI6A400_lI6A403?lA4A7o8R8Aob8R
4OlI6A7o8R8Aoa4A4OlZ4@So8R8AoaTI6OlZ4@So6ATIob8R4@;o6ATI00Ko
8R8AoaTI6OlR8Q7o6ATIob8R4OlI8R82ob8R4@03oaTI6OlR8Q7o6B8R00;o
6ATI00Ko:R8IoaTR8_lI8R;o:R8Iob8R4OlZ8QT2oaTR8P03oda48_o^k^ko
k^k^0:;ok^k^001Jooooo`ko4A4A00?o6ATAoa4A4OlA4A402_lA4A400ol0
003o4A4Aoa4A4@08oa4A4@03o`000?lA4A7o4A4A00Go4A4A00Go0000oa4A
4OlA4A7o4A4Ao`000006oa4A4@03o`000?lA4A7o000000;o4A4A00Co0000
oa4A4OlA4A7o00000_lA4A401Ol0003o4A4Aoa4A4OlA4A7o000000Go4A4A
00?o0000oa4A4OlA4A401olA4A400ol0003o4A4Aoa4A4@03oa4A4@03o`00
0?lA4A7o4A4A00Go4A4A00Co0000oa4A4OlA4A7o00000_lA4A401Ol0003o
4A4Aoa4A4OlA4A7o000000Co4A4A00?o0000oa4A4OlA4A400_lA4A401Ol0
003o4A4Aoa4A4OlA4A7o000001;o4A4A00?o6ATAoa4A4OlA4A400_lA4A40
0olI6AWo4A4Aoa4A4@03oa4A4@03o`000?lA4A7o4A4A00;o4A4A00?o0000
oa4A4OlA4A400_lA4A402_lZ4@So4A4Aoa4A4OlI6A7o4A4AoaTI6OlA4A7o
6ATAoa4A4Om4>RX4oa4A4@08oaTI4OlA4A7o4A4Aoa4A4OlZ4@So4A4AoaTI
4OlA4A42oaTI4@03oa4A4OlZ4@So4A4A00Co4A4A00?o6ATIoa4A4OlA4A40
0olA4A400olI6A7o6ATIoaTI6@06oa4A4@03oaTR:_lA4A7o4A4A00Go4A4A
00Go:Q48oa4A4OlA4A7o4A4AoaTI4@04oa4A4@04ob8R4OlZ8QWo<RXRoaTI
6@?o4A4A00?o6ATAoa4A4OlI6A400_lA4A42oaTI4@07oa4A4OlI6A7o4A4A
oaTI4OlA4A7o8R8AoaTI4@04oa4A4@;o6ATA00?o8R8Aoa4A4OlA4A401?lA
4A400olI6A7o:Q48oa4A4@02oaTI4@04oa4A4OlZ4@So6ATAoaTI4@;o:Q48
00Go4A4AoaTI4OlA4A7o6ATIoaTI4@02ob8R4@05oaTI4OlI6AWo8R8Aob8R
4OlI6AT00olR8Q401OlI6AWo:R8IoaTI4OlI6A7o4A4A00;o6ATA00?o6ATI
oaTI4OlZ4@P00_lA4A401?lI6A7o4A4AoaTI6OlA4A42oaTI4@03obXA2?lI
6A7o4A4A00;o4A4A00Go6ATAoaTI6OlI6AWo8R8AoaTI6@03obXR6@06oaTI
4OlR8Q7o6ATIobXR6OlR8Q7o4A4A0_lR8Q400olZ8QWo4A4AoaTI4@02oaTI
6@05oaTR8_lZ4@So6B8Rob8R4OlI6AT00_lR8Q400olZ8QWo8R8AoaTI6@03
obXR6@04oaTR8_lR8Q7o6B8Roe`j8ZCooooo001Jonk^kPGo4A4A00?o0000
oa4A4OlA4A402?lA4A400olI6AWo4A4Aoa4A4@06oa4A4@03o`000?lA4A7o
4A4A00?o4A4A00Co0000oa4A4OlA4A7o6ATI1_lA4A400olI6AWo4A4Aoa4A
4@0;oa4A4@03o`000?lA4A7o4A4A01Oo4A4A00?o0000oa4A4Ol000001olA
4A400ol0003o4A4Aoa4A4@02oa4A4@04o`000?lA4A7o4A4Ao`0000Oo4A4A
00?o0000oa4A4OlA4A401?lA4A400ol0003o4A4Aoa4A4@03oa4A4@05o`00
0?lA4A7o4A4AoaTI4Ol000000olA4A401?l0003o4A4AoaTI4Ol00003oa4A
4@05obXA2?lA4A7o4A4Aoa4A4OlI6A400olA4A401OlI6A7o4A4AoaTI4OlA
4A7o6ATA00;o4A4A00?o6ATAoa4A4OlA4A400_lA4A401?lZ4@So6ATAoaTI
4OlR8Q49oa4A4@05oaTI4OlA4A7o4A4Aoa4A4OlI6A402?lA4A400olI6A7o
4A4Aoa4A4@03oa4A4@03oaTI6OlA4A7o4A4A00;o4A4A00Oo6ATAobXA2?lA
4A7o6ATAoaTI6OlI6A7o4A4A00?o6ATI00?o4A4AoaTI4OlA4A400_lA4A40
0olb:R;o4A4AoaTI4@02oaTI4@03oa4A4OlI6AWo6ATA00?o4A4A00?o6ATI
obXA2?lI6A401?lA4A400olZ4@So4A4Aoa4A4@02oa4A4@03ob8R4OlA4A7o
:Q4800Co4A4A00?o6ATAoa4A4OlA4A401?lA4A42oaTI6@04oaTI4OlI6AWo
4A4AoaTI4@;o4A4A0_lI6A401_m<C3[o0000oa4A4OlR8Q7o4A4AoaTI6@;o
6ATA0_lR8Q402OlI6A7o6ATIoaTI4OlI6A7o6ATIob8R4OlI6A7o6ATIoaTI
4@03oa4A4@?o6ATA00?o8R8AoaTI4OlI6A400_lR8Q402OlI6AWo6ATAoaTI
6OlI6A7o6ATIobXR6OlI6A7o8R8Aoa4A4@02oaTI4@?o4A4A1?lI6A47oa4A
4@09oaTI4OlR8Q7o:Q48oaTI6OlR8Q7o6ATAoaTI6OlZ4@So6ATI00;o6ATA
0olI6AT02?lI6A7o6ATIob8R4OlZ8QWo8R8AoaTI6OlI6A7o:R8I0olR8Q40
2olA4A7o8R8AobXR6OlI6AWo8R8AoaTR8_lI6A7o6B8RobXR6OlI8R;o:R8I
00;o6B8R00?o<RXRoaTR8_m<A280Y?o^k^h005[oi^KV00Co6ATIoa4A4OlA
4A7o00000_lA4A400ol0003o4A4Aoa4A4@04oa4A4@05oaTI4OlA4A7o6ATI
obXR6Ol000001?lA4A401?l0003o4A4Aoa4A4Ol00008oa4A4@03o`000?lA
4A7o4A4A00;o4A4A00?o6ATAoa4A4OlA4A400olA4A400ol0003o4A4Aoa4A
4@06oa4A4@03o`000?lA4A7o4A4A00Co4A4A00?o0000oa4A4Ol000000olA
4A400ol0003o4A4Aoa4A4@03oa4A4@03o`000?lA4A7o4A4A00Co4A4A00Ko
6ATIoa4A4OlA4A7o4A4AoaTI6Ol00003oa4A4@05o`000?lA4A7o4A4Aoa4A
4Ol000001olA4A401?l0003o4A4Aoa4A4Ol0000=oa4A4@04o`000?lA4A7o
4A4AoaTI4@[o4A4A00?o6ATAo`000?lA4A401_lA4A400olZ8QWo6ATIoa4A
4@08oa4A4@05oaTI4OlA4A7o4A4Aoa4A4Ol000001_lA4A400olZ4@So4A4A
obXA2005oa4A4@0<obXR6OlA4A7o6ATAoa4A4OlZ8QWo8R8Aoa4A4OlR<R[o
4A4AobXR6OlA4A7o6ATA0_lA4A402olI6A7o4A4Aoa4A4OlA4A7o:Q48oa4A
4OlI6A7o<SY4ob8b:_lA4A7o6ATA00Go4A4A00Co:Q48oa4A4OlI6AWo6ATA
0_lI6AT01_lI6A7o6ATIoa4A4OlA4A7o6ATIoaTI4@;o4A4A00So6ATAoa4A
4OlA4A7o6ATAoa4A4OlI6A7o4A4AoaTI4@Go4A4A00?o6ATAoa4A4Olb:R80
0_lI6A46oa4A4@07obXA2?lA4A7o6ATAoa4A4OlZ4@So4A4AoaTI4@02oa4A
4@04oaTI4OlA4A7o4A4AobXA20?o4A4A00Go6ATAoa4A4OlA4A7o6ATIoaTI
4@02oa4A4@;o6ATA00So4A4AoaTI6OlA4A7o:Q48oaTI4OlR8Q7o6ATIoaTI
4@;o4A4A00Co8R8AoaTI6OlI6A7o4A4A0_lI6AT02?lI6A7o8R8AoaTI4OlI
6AWo8R8Aoa4A4OlI6AWo6ATA0_lA4A401OlI6A7o4A4Aoa4A4OlI6A7o4A4A
00;o6ATA0_lA4A42oaTI4@0:oa4A4OlZ4@So4A4AobXA2?lA4A7o6ATAoa4A
4OlZ4@So6ATAob8R4@;o6ATA00Co8R8Aoa4A4OlR8Q7o6ATA1OlA4A401_lI
6AWo4A4Aob8R4OlI6AWo8R8AoaTI6@;o8R8A00Co6ATIoa4A4OlI6AWo8R8A
0_lI6AT02?lA4A7o8R8AoaTI6OlI6A7o:R8Iob8R4OlI8R;o8R8A1?lZ8QT0
0olI6AWo>T@IonKViP2SonKViP00F_o^k^h00olA4A7o0000oa4A4@06oa4A
4@03o`000?lA4A7o4A4A00Co4A4A00?o0000oa4A4OlA4A401?lA4A402Ol0
003o4A4Aoa4A4OlA4A7o0000oa4A4OlI6A7o0000oaTR8P07oa4A4@03o`00
0?lA4A7o4A4A013o4A4A00?o0000oa4A4OlA4A401?lA4A400ol0003o4A4A
oa4A4@03oa4A4@05o`000?lA4A7o4A4Aoa4A4Ol000001?lA4A401OlI8R;o
:Q48oa4A4OlA4A7o000000;o4A4A00?o0000oa4A4OlA4A401_lA4A400ol0
003o4A4Aoa4A4@04oa4A4@04o`000?lA4A7o4A4Ao`0000;o4A4A00Oo0000
oa4A4Ol0003o4A4AoaTI4OlA4A7o000000Ko4A4A00Co0000oa4A4OlA4A7o
:Q483olA4A401Ol0003o6ATIoaTI6OlA4A7o6ATI00;o4A4A00?o6ATAoa4A
4OlA4A402?lA4A400olI6A7o4A4AobXA2004oa4A4@03oaTI4OlA4A7o4A4A
00Co4A4A00?o6ATAoa4A4OlI6A400_lA4A401?lZ4@So4A4AoaTI6OlA4A42
oaTI4@04oaTI6OlA4A7o6ATAoa4A4@?o6ATA1?lA4A400olI6A7o4A4AoaTI
4@02oaTI4@05oaTI6OlA4A7o6ATIobXA2?lA4A400_lI6A402_lI6AWo4A4A
oaTI4OlA4A7o6ATAoa4A4OlI6AWo4A4AoaTI6OlZ4@P6oa4A4@05oaTI6OlA
4A7o4A4Aoa4A4OlI6A400olA4A400olI6AWo4A4Aob8R4@02oa4A4@03obXR
6OlI6A7o6ATA00Oo4A4A00Go6ATAoa4A4OlI6A7o6ATAoa4A4@02oaTI4@03
oa4A4OlZ4@So6ATI00;o4A4A00Go6ATIoa4A4OlI6A7o4A4AoaTI4@03oa4A
4@05oaTI4OlA4A7o8R8AoaTI6OlA4A400_lI6A401_lZ4@So6ATIoa4A4OlI
6A7o4A4AoaTI4@?o4A4A0_lI6A401?l0003o<RXRoa4A4OlI6A43oa4A4@03
oaTI4OlA4A7o6ATA00Co4A4A00?o6ATAoa4A4OlI6A400_lI6A401_lI6AWo
8R8AoaTI6OlI6A7o6ATIob8R4@;o4A4A00ko6ATAoaTI6OlI6A7o:Q48ob8R
4OlI6A7o4A4AobXR6OlA4A7o6ATIobXA2?lI6A7o4A4AoaTI4@?o8R8A00Wo
6B8RoaTI6OlZ4@So6ATIoa4A4OlI6AWo:Q48obXR6OlI6A400_lZ8QT00olI
6AWo:R8IobXR6@04obXR6@04oaTR8_lA4A7o6B8Rod@j8ZCok^k^001Joooo
o`Go4A4A00?o6ATIoa4A4OlA4A400olA4A400ol0003o4A4Aoa4A4@05oa4A
4@05o`000?lA4A7o4A4Ao`000?lI6AT03?lA4A401ol0003o4A4Ao`000?lA
4A7o6ATAoa4A4Ol000001OlA4A400ol0003o4A4Aoa4A4@0=oa4A4@03obXR
6OlA4A7o4A4A00;o4A4A00?o0000oa4A4OlA4A404olA4A400ol0003o4A4A
oa4A4@05oa4A4@03o`000?lA4A7o4A4A00_o4A4A00?o0000oa4A4OlA4A40
0olA4A400ol0003o4A4Aoa4A4@07oa4A4@03oaTI6OlA4A7o4A4A00?o4A4A
00?o6ATIoa4A4OlA4A400_lA4A401olI6AWo4A4AobXA2?lA4A7o6ATAoa4A
4OlR8Q401_lA4A42oaTI4@03oa4A4OlZ4@So4A4A00Wo4A4A00Go6ATIoa4A
4OlA4A7o4A4AobXA2002oa4A4@09oaTI4OlA4A7o6ATAoaTI6OlA4A7o6ATA
oa4A4OlI6AWo4A4A00;o6ATA0_lA4A401?lI6A7o4A4AoaTI6OlA4A42oaTI
4@03ob8R4OlI6A7o6ATA00;o6ATI00Co8R8AoaTI6OlR8Q7o6ATA0_lI6AT0
0olR8Q7o6B8RoaTI6@02oa4A4@;o6ATA00co4A4AoaTI6OlA4A7o4A4AoaTI
4OlA4A7o6ATAoaTI6OlA4A7o6ATAoa4A4OlI6AT2oa4A4@09obXA2?lA4A7o
4A4AoaTI6OlA4A7o6ATAoa4A4OlI6A7o4A4A00;o6ATA00So4A4Ao`000?lI
6A7o4A4AoaTI4OlA4A7o6ATAobXA20;o4A4A0_lI6A402?lA4A7o6ATAoaTI
4OlI6A7o4A4AoaTI6OlA4A7o6ATA1OlA4A401?lI6A7o4A4Aoa4A4OlZ4@P3
oaTI4@Co4A4A0_lI6A400olZ4@So4A4AoaTI4@02oaTI4@03oa4A4OlZ4@So
4A4A00?o6ATA00_o:Q48oa4A4OlA4A7o4A4AoaTI4OlA4A7o:Q48oa4A4OlI
6A7o8R8AoaTI4@02oa4A4@03obXA2?lI6A7o4A4A00;o4A4A1?lI6A401?lZ
4@So4A4Aoa4A4OlZ4@P2oaTI4@07ob8R4Ol0003o6B8Ro`000?lR8Q7o6ATI
oaTI4@02oaTI6@05ob8R4OlI6AWo8R8Aob8R4OlI6AT00olR8Q402_lI6AWo
:R8IobXR6OlR8Q7o6ATIob8R4OlZ8QWo8R8AoaTI6OlR8Q42obXR6@05oaTI
6OlI8R;o6ATIoaTI4OlR8Q400_lI6AT00om<8PSoooooooooo`2Rooooo`00
F_o^k^h5oa4A4@03o`000?lA4A7o000000Co4A4A00Co0000oa4A4OlA4A7o
00001?lA4A402?l0003o4A4Aoa4A4Ol0003o4A4Ao`000?lA4A7o00001OlA
4A400ol0003o4A4Aoa4A4@09oa4A4@;o00000olA4A400ol0003o4A4Aoa4A
4@08oa4A4@;o00001?lA4A400ol0003o4A4Aoa4A4@05oa4A4@03o`000?lA
4A7o000000Ko4A4A00?o0000oa4A4OlA4A401OlA4A401?l0003o4A4Aoa4A
4Ol00003oa4A4@03o`000?lA4A7o000000Co4A4A00?o0000oa4A4OlA4A40
1_lA4A401OlR:R[o4A4Ao`000?lA4A7o6B8R00_o4A4A00Go0000oaTI4OlA
4A7o4A4AoaTI4@02oa4A4@03obXA2?lA4A7o4A4A00[o4A4A00Co:R8Ioa4A
4OlA4A7o6ATA0olA4A401OlI6AWo:R8Ioa4A4OlA4A7o6ATA00Go4A4A00?o
:Q48oa4A4OlA4A400_lI6A43oa4A4@05oaTI4OlA4A7o4A4Aoa4A4OlI6A40
0_lA4A43oaTI4@;o4A4A00go6ATAoaTI6OlI6A7o6ATAoaTI6OlI6A7o8R8A
oaTI6OlZ4@So8R8Aoa4A4OlZ8QWo8R8A00?o6ATA00Co8R8Aoa4A4OlZ4@So
:R8I0olI6A400olI6AWo4A4Aob8R4@05oa4A4@05oaTI6OlA4A7o6ATAoaTI
4OlA4A400_lI6A42oa4A4@08obXA2?lI6A7o4A4AoaTI4OlA4A7o6ATAoa4A
4OlI6A42oa4A4@05oaTI6OlR8Q7o4A4Aob8R4OlI6A400olA4A401?lR8Q7o
6ATAoa4A4OlI6A45oa4A4@04oaTI4OlZ4@So4A4AobXA20Co4A4A00Co6ATA
oa4A4OlI6A7o6ATA0_lA4A42obXA20;o4A4A00Go6ATAoa4A4OlA4A7o6ATA
oa4A4@02oaTI4@08oa4A4OlI6A7o6ATAoa4A4OlI6A7o4A4AoaTI4OlA4A42
oaTI4@0GoaTI6OlA4A7o:Q48o`000?lA4A7o6ATAobXA2?lI6A7o4A4AoaTI
4OlA4A7o:Q48oa4A4OlI6A7o8R8AoaTI4OlA4A7o6ATAoa4A4OlI6A7o8R8A
o`000?lR8Q400_lI6A401?lR8Q7o6ATAoaTI6OlR8Q42oaTI6@0=obXR6OlA
4A7o6ATIob8R4OlI8R;o8R8AoaTI4OlZ8QWo6ATIobXR6OlR8Q7o:R8Iob8R
4@02oaTI6@;o:R8I00Oo8R8AoaTI6OlA4A7o6ATAoa4A4OlZ4@So8R8A00;o
6ATI00?o8R8Aoa4A4OljA1T0Y?o^k^h005[oi^KV9?lA4A401_l0003o4A4A
oa4A4Ol0003o4A4Ao`0000[o4A4A00Go0000oa4A4OlA4A7o4A4Ao`000002
oa4A4@03o`000?lA4A7o4A4A00;o4A4A00?o0000oa4A4OlA4A401OlA4A40
0ol0003o4A4Aoa4A4@03oa4A4@04o`000?lI6A7o4A4Ao`0000Co4A4A00Co
0000oa4A4OlA4A7o00000olA4A400ol0003o4A4Aoa4A4@07oa4A4@08o`00
0?lA4A7o4A4AoaTI4OlA4A7o:Q48oa4A4Ol0000>oa4A4@03obXR6OlI6A7o
4A4A00;o4A4A00Go6ATAoa4A4OlA4A7o4A4Ao`000009oa4A4@03ob8R4OlA
4A7o6ATA00ko4A4A00?o0000oa4A4OlA4A402?lA4A42oaTI4@03obXA2?lA
4A7o6ATA00;o4A4A00Co6ATAoa4A4OlA4A7o:R8I0olA4A401_lI6AWo4A4A
oa4A4OlI6A7o4A4AobXA20?o6ATA00Go4A4AoaTI6OlR8Q7o6ATIoa4A4@02
oaTI6@05oa4A4OlZ8QWo4A4AoaTI4OlA4A400_lI6A43oa4A4@09oaTI4OlA
4A7o6ATAoaTI6OlI6A7o6ATIoa4A4OlI6A7o6ATI00?o4A4A0_lI6A401_lI
6AWo4A4AoaTI4OlR8Q7o4A4AoaTI4@Co4A4A00?o6ATIoa4A4OlI6AT00_lA
4A400olI6A7o4A4AoaTI6@02oaTI4@07oa4A4OlZ4@So4A4AoaTI4OlI6AWo
6ATAoaTI6@02oaTI4@;o4A4A00Oo6ATAoa4A4OlA4A7o6ATIoa4A4OlZ4@So
6ATA00;o4A4A00Go6ATAoaTR8_lI6AWo4A4Aob8R4@02oaTI4@05oa4A4OlI
6AWo:Q48oaTI6OlI6A400_lA4A400olI6A7o8R8AoaTI4@02oaTI4@03oa4A
4OlI6A7o4A4A00Co6ATA0_lR8Q401?lI6AWo6ATAoaTI4OlA4A43oaTI4@03
oa4A4OlI6A7o4A4A00;o4A4A00Ko:Q48ob8R4OlA4A7o:Q48oa4A4OlZ8QT2
oaTI6@05oaTI4OlI8R;o6ATIobXA2?lI6AT00_lR8Q400olI6AWo:R8IobXR
6@02obXR6@0=ob8Z:_lZ8QWo:R8Iob8R4OlI6AWo6B8Rob8R4OlZ8QWo8R8A
oaTI4OlR8Q7o4A4AoaTI4@02ob8R4@09oaTI6OlR8Q7o6ATIoaTI6OlZ4@So
6ATIoaTI4OlI6AWoA2XR0:Coi^KV001Jonk^kPSo4A4A00?o6ATAoaTI6OlA
4A400_lA4A400olI6AWo4A4Aoa4A4@0=oa4A4@03oaTI6OlA4A7o4A4A00;o
4A4A00?o6ATIoa4A4OlA4A406_lA4A401Ol0003o4A4Aoa4A4OlA4A7o0000
00oo4A4A00?o0000oaTI4OlA4A403?lA4A400olI6A7o4A4Aoa4A4@05oa4A
4@03o`000?lA4A7o4A4A00Oo4A4A00Co0000oa4A4OlA4A7o6ATI1_lA4A40
4?lI6AWo4A4AoaTI6OlI6A7o4A4AoaTI6OlA4A7o6ATAoa4A4OlZ4@So4A4A
oaTI4OlA4A7o6ATAoa4A4OlZ4@P5oa4A4@04oaTI6OlA4A7o8R8AoaTI6@Wo
4A4A00Co:Q48oa4A4OlA4A7o4A4A0_lI6A400olI6AWo4A4Aoa4A4@02oa4A
4@04oaTI4OlA4A7o4A4Aoa4A4@;o6ATA00[o4A4AoaTI4OlA4A7o4A4AoaTI
6Olb>TCo0000oaTI6OlA4A7o6ATA0_lA4A42oaTI4@03oa4A4OlI6A7o6ATA
00Co6ATA00Co4A4AoaTI4OlA4A7o4A4A0_lI6AT2oa4A4@05ob8R4OlI6AWo
4A4AoaTI4OlI6AT00olA4A402olI6A7o4A4Aoa4A4OlA4A7o6ATIoaTI4OlA
4A7o6ATIob8R4OlA4A7o6ATA00;o4A4A00Go6ATAoa4A4OlA4A7o4A4AoaTI
4@02oa4A4@04oaTI4OlA4A7o4A4AoaTI6@?o4A4A00Ko6ATAoa4A4OlI6A7o
4A4AoaTI4OlZ4@P3oa4A4@03oaTI4OlA4A7o4A4A00;o4A4A00?o6ATAoa4A
4OlZ4@P00_lA4A401_lZ4@So4A4Aoa4A4OlZ4@So6ATAob8R4@?o6ATA00_o
:Q48oaTI4OlR8Q7o6ATAoa4A4OlZ4@So6ATIoa4A4OlZ4@So4A4AobXA2002
oaTI4@0<oaTI6OlI6A7o4A4Aob8R4OlI6A7o4A4AoaTI4OlI6AWo6ATAob8R
4OlI6AWo6ATA0_lI6AT01_lI6A7o4A4AoaTI4OlR8Q7o4A4AobXA20;o4A4A
00?o6ATAoa4A4OlR8Q400olI6A401_lI6AWo8R8Aob8R4OlR8Q7o6ATIobXA
20;o6ATI00?o:Q48oaTI6OlZ8QT00olZ8QT00olI6AWo8R8AobXR6@03obXR
6@03ob8R4OlZ8QWo:R8I00Co6ATA00go4A4AobXA2?lA4A7o8R8AoaTI4OlI
6AWo8R8AoaTI6OlI6A7o8R8AobXR6OlA4A7o>T@I0:Cok^k^001Jooooo`Ko
4A4A0_l000000olA4A7o0000oa4A4@06oa4A4@03oaTI6OlA4A7o4A4A00;o
4A4A00Go0000oa4A4OlA4A7o4A4Ao`00000<oa4A4@03oaTI4OlA4A7o4A4A
00So4A4A00?o0000oa4A4OlA4A404?lA4A400ol0003o4A4AoaTI4@07oa4A
4@03oaTI6OlA4A7o4A4A00Wo4A4A00Ko6ATAoa4A4OlA4A7o0000oa4A4Ol0
0002oa4A4@04o`000?lA4A7o4A4AobXA20[o4A4A00Go:Q48o`000?lI6A7o
4A4AobXA2002oa4A4@03oaTI4OlA4A7o4A4A00?o4A4A00?o6ATAoa4A4OlI
6AT00olA4A400olI6AWo6ATAoaTI6@03oa4A4@Go6ATA00Ko8R8Aoa4A4OlA
4A7o6ATIoaTI4OlI6AT3oa4A4@08obXA2?lI6A7o4A4AoaTI4OlZ8QWo6ATI
oa4A4OlI6A42oa4A4@06obXR6OlZ4@So6ATIob8R4OlZ8QWo6ATA0olI6AT0
3_lA4A7o6ATIob8R4OlI6AWo6ATAoaTI6OlR8Q7o6ATIob8R4OlZ4@So8RXZ
obXR6OlI6A7o:R8I0_lI6A402?m4A3;o8R8AoaTI6OlZ8QWo6ATIobXR6OlI
6A7o6ATI0_lI6A403_lZ8QWo6ATIoaTI6OlR8Q7o6ATIob8R4OlZ4@So6ATA
ob8R4OlI6AWo:R8IoaTI6OlI6A7o6ATI0olR8Q404OlI6AWo8R8AoaTI6OlI
6A7o6ATIoa4A4OlI6AWo8R8AoaTI6OlR8Q7o4A4AobXA2?lI6AWo8R8Ao`00
0?lI6AWo:R8I00;o4A4A00Ko:Q48oaTI4OlA4A7o6ATIoa4A4OlI6A43oa4A
4@04oaTI4OlZ4@So4A4AoaTI4@;o4A4A00Go:Q48oa4A4OlA4A7o4A4AobXA
2003oa4A4@03oaTI4OlA4A7o4A4A00;o4A4A00Go:Q48oa4A4OlI6A7o6ATA
oa4A4@02oaTI4@04oaTI6OlI6A7o4A4Aob8R4@?o4A4A00Oo6ATAoa4A4OlA
4A7o4A4AoaTI4OlA4A7o6ATA00Co4A4A00Oo6ATIobXR6OlA4A7o6ATIob8R
4OlI6AWo8R8A00Go6ATA00Ko4A4AoaTI4OlA4A7o8R8Aoa4A4OlZ4@P2oa4A
4@03obXA2?lA4A7o6ATA00;o6ATA0olI6AT02_lR8Q7o:R8IobXA2?lZ8QWo
8R8AobXR6OlR8Q7o:R8IoaTI4OlR8Q44obXR6@08oaTI6OlI6A7o6ATAoaTI
4Ol0003o6ATAobXA2?lA4A42oaTI4@04oa4A4OlI6A7o6ATAoaTI6@;o6ATA
00Ko4A4Aob8R4OlI6AWo8R8AoaTI6OljA1VTooooo`00F_o^k^h01OlA4A7o
0000oa4A4OlA4A7o0000017o4A4A00Ko6ATAoa4A4OlA4A7o:Q48oa4A4Ol0
0003oa4A4@03oaTI6OlA4A7o4A4A00Co4A4A00?o0000oa4A4OlA4A400_lA
4A400olI6A7o4A4Ao`000007oa4A4@06o`000?lA4A7o4A4AoaTI4OlA4A7o
00001olA4A400ol0003o4A4Aoa4A4@02oa4A4@;o00002?lA4A400olI6A7o
4A4Aoa4A4@04oa4A4@03o`000?lA4A7o000000Wo4A4A00?o0000oa4A4OlA
4A400olA4A401OlI6A7o0000oa4A4OlA4A7o6ATA00Go4A4A00_o6B8Zoa4A
4OlA4A7o4A4AobXR6OlA4A7o6ATIoaTI4OlA4A7o6ATAoaTI6@02oaTI4@03
oaTI6OlA4A7o8R8A00;o4A4A00Co6ATIoa4A4OlI6AWo4A4A0_lI6A402OlA
4A7o6ATAoaTI6OlI6AWo:R8Iob8R4OlI6A7o:R8IoaTR8P03oa4A4@0AoaTI
4OlA4A7o:Q48oaTI4OlA4A7o:Q48oa4A4OlZ4@So6ATAoaTI6OlI8R;o:R8I
obXA2?lI6AWo6ATAobXR6OlZ4@P00_lZ8QT05?lZ4@So6ATIobXR6OlI6A7o
:R8IobXA2?lb:R;o8S8Zob8Z:_lZ8QWo6ATAobXR6OlI6AWo:R8IoaTI6OlZ
8QWo6B8RobXR6OlR8Q7o6ATI0_lR8Q44obXR6@0:oaTR8_lR8Q7o6ATIoaTR
8_lR8Q7o:R8IoaTR8_lZ8QWo6B8Rob8R4@;o:R8I00So8R8AoaTI4OlZ8QWo
8R8AoaTR8_lR8Q7o:R8Iob8R4@;o:R8I00Ko<RXRob8R4OlZ8QWo6ATAoaTI
6OlI6A45ob8R4@;o6ATA0_lR8Q401?lI6AWo6ATAobXA2?lI6AT2ob8R4@04
oaTI4OlR8Q7o6ATIoaTI4@;o:R8I00?o8R8AoaTI4OlI6A400olR8Q401?lZ
8QWo8R8Aob8R4OlI6AT2oaTI4@Co8R8A00Oo:R8Iob8R4OlR8Q7o6ATIob8R
4OlI6A7o8R8A00;o6ATA00Co4A4Aob8R4OlI6A7o8R8A0_lI6A42ob8R4@;o
6ATA00Co4A4AoaTI4OlR8Q7o6ATA0_lI6AT02OlI6A7o4A4AoaTI4OlI6AWo
8R8AoaTI6OlI6A7o8R8AoaTI6@02oaTI4@07ob8R4OlI6AWo4A4Aoa4A4OlI
6A7o8R8AobXA2002oaTI4@03obXA2?lR8Q7o6ATA00;o8R8A00?o:Q48obXR
6OlI8S800_lZ8QT01_lR8Q7o6ATIob8R4OlI6AWo8R8AobXR6@;o8R8A00Go
6ATAob8R4OlI6A7o:Q48oaTI4@02obXA20?o6ATA00Go4A4AobXA2?lA4A7o
:Q48oa4A4@02obXA20?o6ATA0_lI6AT2oa4A4@03oda48_o^k^kok^k^0:;o
k^k^001JonKViQko4A4A0olI6AT3oa4A4@03oaTI6OlA4A7o4A4A00;o4A4A
00?o6ATAoa4A4Ol000001?lA4A400ol0003o4A4Aoa4A4@05oa4A4@03o`00
0?lA4A7o4A4A017o4A4A00Co0000oa4A4OlA4A7o00000_lA4A401_l0003o
4A4AoaTI4Ol0003o4A4AobXA20Oo4A4A00?o0000oa4A4OlA4A401?lA4A40
0ol0003o4A4Aoa4A4@03oa4A4@06obXA2?lI6A7o0000oaTI4OlA4A7o6ATI
1?lI6A42oa4A4@0CobXA2?lI8R;o6ATIoc8Z8_lA4A7o6ATIoaTI4OlI6AWo
6ATAoa4A4OlR8Q7o6B8RoaTI6OlI6A7o4A4AobXR6OlI6A7o:Q48oa4A4@04
oaTI4@0:oaTR8_lI6A7o6ATAoaTI4OlI6AWo:Q48oaTI4OlI6AWo:Q48oa4A
4@?o6ATA00?o:R8Ioa4A4OlA4A400olR8Q404?lZ4@So6B8RoaTI6OlR8Q7o
6B8Rob8R4OlI8R;o:R8IoaTI6OlR8Q7o6ATAoc8jA?lI6A7o8R8AobXR6OlR
8Q42oaTI6@09ob8R4OlI8R;o6ATIobXR6OlR8Q7o6ATIobXR6OlR8Q7o6ATI
00;o:R8I00Go6B8RobXR6OlR8Q7o8R8AoaTI6@02obXR6@06ob8Z:_lZ8QWo
:R8IoaTR8_lZ8QWo6ATA0_lZ8QT02_lI8R;o:R8Iob8R4OlR:R[o:R8IoaTI
4OlZ8QWo6B8RobXR6OlR:RX2obXR6@08oaTI6OlR8Q7o6ATIoaTI4OlZ8QWo
:Q48obXR6OlR8Q42oaTI6@;o8R8A00Co:R8Iob8R4OlI6AWo6ATI0_lR8Q40
5_lI6AWo8R8Aob8R4OlZ8QWo8R8AoaTR8_lR8Q7o:R8Iob8R4OlZ8QWo6ATA
oc8Z8_lZ8QWo8R8AobXR6OlR8Q7o6B8RobXR6OlI8R;o:R8Iob8R4OlZ8QT2
ob8R4@04oaTR8_lR8Q7o8R8AoaTR8P;o:R8I01ko8R8AobXR6OlR:R[o:Q48
obXR6OlI6AWo8R8AobXR6OlR8Q7o:R8Ioc8Z8_lI6AWo8RXZob8R4OlZ8QWo
<RXRob8R4OlI6AWo:R8Ioc8Z8_lR8Q7o6B8Rob8R4OlI8R;o8R8AoaTI6OlR
8Q7o6ATAoaTR8_lI6AT2oaTI4@08obXA2?lI6AWo8R8AoaTI6OlR8Q7o6ATI
oaTI4OlA4A45oaTI4@;o6ATI00[o8R8AobXR6OlZ4@So6ATIob8R4OlI6A7o
:R8Iob8R4OlZ8QWo8R8A0_lI6A401olZ4@So6ATAoa4A4OlI6A7o8R8AoaTI
6OlI6A401OlA4A44oaTI4@04ob8R4OlI6AWo8R8AoaTI6@;o8R8A00?o:R8I
oaTI4OljA1T0Y?oVi^H005[ok^k^0olA4A400olI6AWo4A4Aob8Z:P04oa4A
4@03o`000?lA4A7o4A4A00;o4A4A00?o0000oa4A4OlA4A403_lA4A400olI
6AWo4A4Aoa4A4@0Qoa4A4@03o`000?lA4A7o0000017o4A4A00Ko0000oa4A
4OlA4A7o0000oa4A4Ol00003oa4A4@03o`000?lA4A7o4A4A00?o4A4A00?o
6ATAoa4A4OlI6A400olA4A400olI6A7o4A4Aoa4A4@08oa4A4@03oaTR8_lI
6A7o6ATA00;o4A4A00Oo6ATAoa4A4OlI6AWo4A4AoaTI6OlI6A7o6ATI00;o
4A4A00Ko6ATIobXR6OlA4A7o4A4AoaTI4OlA4A42oaTI4@05oa4A4OlI6A7o
6ATAoaTI4OlI6AT01?lI6A400olR8Q7o6ATAoaTI4@03oa4A4@0CoaTI6OlZ
4@So6ATIob8R4OlI6AWo6ATAoaTI6OlR8Q7o6ATIobXR6OlA4A7o6ATAoaTI
6OlR8Q7o6ATIobXR6OlR8Q7o:R8IoaTI6@02ob8R4@04oaTR8_lZ8QWo:R8I
ob8R4@;o:R8I00So6ATIobXR6OlI6AWo6B8Rob8R4OlI6AWo8R8AobXR6@;o
6ATI00Ko8RXZobXR6OlZ8QWo6ATIob8R4OlR<RX2oaTI6@;o8R8A0_lI8R80
0olI6AWo8R8AobXR6@03oaTI6@0;ob8Z:_lZ8QWo:R8IoaTR8_lR8Q7o8RXZ
ob8R4OlI6AWo8R8AobXR6OlR8Q400_lI6AT3ob8R4@06oaTI6OlI6A7o8R8A
oaTI6OlZ8QWo6B8R0olZ8QT01olI8R;o6ATIob8R4OlI8R;o:R8IoaTR8_lZ
4@P00_lR8Q43obXR6@03oaTR8_lR8Q7o6B8R00Ko:R8I00So6ATAob8Z:_lZ
8QWo6B8RobXR6OlI8R;o:R8IoaTI4@;o:R8I00Go6ATAobXR6OlR8Q7o:R8I
oaTI6@06obXR6@04ob8Z:_lR8Q7o:R8IoaTI4@;o6ATI00Ko6B8RoaTI6OlR
8Q7o6ATIobXA2?lA4A42ob8R4@03oaTI6OlI6A7o:Q4800;o6ATI00Co<RXR
obXR6OlI6A7o6ATI0olI6A402?lZ4@So4A4Aoa4A4OlA4A7o:Q48oaTI4OlZ
4@So4A4A0olI6A402?lR8Q7o6ATAoaTI4OlZ4@So4A4AobXA2?lA4A7o:Q48
0olA4A400olZ4@So4A4Aoa4A4@02oa4A4@04oaTI4OlA4A7o6ATAoaTI4@;o
:Q4800Go4A4AoaTI4OlA4A7o6ATAoa4A4@02oaTI4@;o6ATI00?o4A4AoaTR
8_lb:R80Y?o^k^h005[ooooo1?lA4A400ol0003o4A4Aoa4A4@0Aoa4A4@03
oaTI4OlA4A7o4A4A00?o4A4A00?o6ATIoa4A4OlA4A406?lA4A400olI6A7o
4A4Aoa4A4@08oa4A4@03oaTI4OlA4A7o4A4A01Ko4A4A00?o6ATAoa4A4OlZ
4@P01_lA4A400olI6A7o4A4AoaTI4@0=oa4A4@03oaTI4OlZ8QWo4A4A00;o
4A4A00Ko6ATAoa4A4OlI6A7o6ATIob8R4OlI6AT2oa4A4@;o:Q4800Co6ATA
obXA2?lI6AWo:R8I0olI6A43ob8R4@0=oa4A4OlI6AWo8R8AobXA2?lI6AWo
6ATAob8R4OlA4A7o6B8Rob8R4OlA4A7o:Q48oa4A4@02ob8R4@08oaTR8_lR
8Q7o6ATIob8R4OlI6AWo:R8IoaTI4OlZ8QT2ob8R4@09oaTI4OlI6AWo8R8A
oaTI6OlR8Q7o6ATAoaTI6OlR8Q7o6ATA00;o8R8A00Oo:R8IoaTI6OlI8R;o
8R8AoaTR8_lI6A7o6B8R00?o:R8I00Co8R8AobXR6OlZ8QWo:R8I0_lR8Q40
3_lI6A7o6B8RobXA2?lI6A7o:R8IobXA2?lZ8QWo6B8RobXR6Om<C3[o>SXb
obXR6OlI8R;o6ATI0olZ8QT02OlI6AWo<RXRoaTR8_lZ8QWo6B8Rob8R4OlI
6AWo8R8AoaTI6@02ob8R4@08oaTI6OlR8Q7o:R8Iob8R4OlI6AWo8R8AobXR
6OlI6AT2obXR6@0=ob8R4OlZ8QWo8R8AoaTI6OlR8Q7o:R8IoaTR8_lZ8QWo
6ATAobXR6OlI8R;o8R8AoaTR8P02obXR6@03ob8Z:_lR8Q7o:R8I00;o:R8I
00Go8R8AobXR6OlI8R;o8R8AoaTR8P02obXR6@05oaTI4OlZ8QWo8R8Aob8R
4OlI6A400_lZ8QT00olR8Q7o:R8Iob8R4@02obXR6@0;ob8R4OlZ8QWo:R8I
obXR6OlI6AWo:R8Iob8R4OlI6AWo:R8IoaTI6OlI8R800_lR8Q403olR:R[o
6ATIoaTR8_lR8Q7o6ATIob8R4OlI6AWo8R8AoaTR8_lZ8QWo6B8RobXR6OlR
8Q7o6ATIobXA2002oaTI4@;o4A4A00go6ATAoa4A4OlA4A7o4A4AobXA2?lA
4A7o0000obXA2?lR8Q7o:Q48o`000?lZ4@So000000Co4A4A00Co0000oaTI
4OlI6A7o:Q480_lA4A401?lZ4@So6ATAoa4A4OlI6A42oa4A4@05obXA2?lI
6A7o6ATAoaTI4OlZ4@P00_lA4A402_lZ4@So4A4Aoa4A4OlA4A7o8R8AoaTI
4OlA4A7o:R8IoaTI6OlI6A6Tooooo`00F_o^k^h7oa4A4@03oaTI6OlI6A7o
4A4A00;o4A4A00?o0000oa4A4OlA4A400_lA4A400olI6A7o4A4Aoa4A4@03
oa4A4@03o`000?lA4A7o4A4A00Go4A4A00?o6ATIoa4A4OlA4A405olA4A40
0olI6A7o4A4Aoa4A4@0Aoa4A4@03oaTI4OlA4A7o4A4A00Go4A4A00?o0000
oa4A4OlA4A400_lA4A400olZ4@So4A4Aoa4A4@04oa4A4@05oaTI4OlA4A7o
:Q48oa4A4OlI6A402OlA4A400ol0003o4A4AobXA2002oa4A4@03oaTI4OlA
4A7o4A4A00;o4A4A00[o6ATAoa4A4OlZ8QWo6ATAoa4A4OlI6A7o6ATIoaTI
4OlI6AWo8R8A0_lA4A404_lR8Q7o:R8IoaTI4OlI6A7o6ATIobXR6OlR8Q7o
4A4AoaTI6OlZ8QWo6ATIob8R4OlI8R;o6ATIobXA2?lI6AWo6B8RobXA20;o
6ATA00go:Q48ob8R4OlR8Q7o6ATIob8R4OlI8R;o8R8Aoa4A4OlI6AWo8RXZ
oaTI4OlZ8QWo6ATI00;o4A4A00Ko6ATIob8R4OlI6AWo8R8AoaTI6OlI6A44
ob8R4@05oaTI6OlR8Q7o8R8Aoa4A4OlI6A400_lZ8QT01olI6A7o:R8IoaTI
6OlZ8QWo8R8AoaTI6OlI8R800_lR8Q401OlI6AWo:R8Iob8R4OlI8R;o6ATA
00;o8R8A00Wo6ATIob8R4OlI6AWo<RXRoaTR8_lI6A7o8R8AobXR6OlR8Q40
0_lZ8QT01OlI6AWo8R8AobXR6OlI6AWo6ATA00;o8R8A00Oo6ATIob8R4OlI
8R;o8R8AobXA2?lI8R;o6ATI00;o:R8I017o8R8AoaTI6OlR8Q7o6B8Rob8R
4OlZ8QWo6ATIob8R4OlZ8QWo8R8AoaTI6OlR8Q7o6ATAobXA2?lZ8QWo6B8R
obXR6@02ob8R4@0<oaTI6OlZ8QWo:R8IobXR6OlR8Q7o6B8Rob8R4OlZ8QWo
8R8AoaTI6OlZ4@So8R8A0_lZ8QT01_lR8Q7o6ATAobXR6OlZ8QWo8R8AoaTI
6@;o8R8A00Go6ATIoaTR8_lR8Q7o:R8Iob8R4@02obXR6@0Cob8R4OlI8R;o
8R8AoaTR8_lI6A7o6ATIob8R4OlI6A7o4A4Aob8R4OlI6AWo6ATAob8R4OlI
6A7o:R8IoaTI4OlI6AWo:Q48oaTI6@02ob8R4@03oaTI6OlI6A7o6ATA00;o
4A4A0_lZ4@P00olA4A7o:Q48obXA2002obXA2004oaTI4OlA4A7o4A4Ao`00
00;o6ATA1?lA4A401OlZ4@So4A4Aoa4A4OlA4A7o:Q4800;o4A4A00Co8R8A
oa4A4OlA4A7o4A4A0_lZ4@P00olI6A7o0000oaTI4@05oa4A4@07oaTI4OlA
4A7o:Q48oaTI6OlR8Q7o4A4Aob8R4@02oaTI6@03obXA2?o^k^kok^k^0:;o
k^k^001JonKViPKo4A4A00?o6ATIoa4A4Ol000007OlA4A400olI6A7o4A4A
oa4A4@0@oa4A4@03o`000?lA4A7o4A4A00Go4A4A00?o0000oa4A4OlA4A40
0olA4A401?l0003o4A4Ao`000?lI6A42oa4A4@04o`000?lA4A7o4A4Ao`00
00Ko4A4A0_lI6A43oa4A4@03o`000?lA4A7o4A4A00Go4A4A00Go0000oa4A
4OlA4A7o4A4Ao`000002oa4A4@04o`000?lA4A7o0000obXA20So4A4A00Oo
6ATAoa4A4OlA4A7o4A4Aob8Z:_lA4A7o6ATA00;o4A4A0_lZ8QT2oa4A4@;o
6ATI00[o4A4AobXR6OlR8Q7o6ATAoa4A4OlI6AWo4A4AoaTI4OlZ8QWo8R8A
0olA4A42ob8R4@;o6ATA0_lR8Q401?lI6A7o8R8AoaTR8_lI6A42ob8R4@0:
oa4A4OlZ4@So8R8AoaTI4OlI6AWo4A4AobXA2?lI6AWo8R8AoaTI4@;o8R8A
00Oo6ATIoaTI4OlR8Q7o<SY4oa4A4OlR8Q7o6ATI00?o6ATA00Wo:R8IoaTI
6OlI6AWo>T@bobXR6OlA4A7o8R8AoaTR8_lZ8QT00olR8Q402_lI6AWo6ATA
obXA2?lI6AWo:R8IoaTI4OlI6AWo6ATAob8R4OlI6AT3ob8R4@05oaTI6OlZ
8QWo6B8RoaTI4OlZ4@P00_lR8Q401olI6A7o:Q48oaTR8_lZ8QWo6ATIob8R
4OlI6AT00_lR8Q402OlI6AWo8R8AobXR6OlR8Q7o6ATIob8R4OlZ8QWo8R8A
oaTI6@03ob8R4@03obXR6OlI6AWo:R8I00?o8R8A00Ko:R8Ioc8Z8_lZ4@So
8R8Aoc8Z8_lI6A42obXR6@04ob8R4OlI6A7o8R8AoaTI6@?o8R8A00?o:R8I
ob8R4OlI6AT00_lR8Q402?lI6A7o8R8AoaTI6OlZ4@So6ATAobXR6OlR8Q7o
6ATI0_lR8Q404?lZ4@So8R8AoaTI6OlI6A7o4A4AoaTI6OlI6A7o4A4AobXR
6OlI6A7o6ATIobXA2?lI6A7o4A4Aob8R4OlA4A42oaTI6@03ob8R4OlI6AWo
8R8A00;o8R8A00Co6ATAobXA2?lI6A7o4A4A0_lZ4@P00olA4A7o:Q48oa4A
4@02oa4A4@05o`000?lA4A7o:Q48oaTI4Ol000000_lA4A400olZ4@So4A4A
oa4A4@03oa4A4@03obXA2?l0003o4A4A00;o4A4A00Go6ATAo`000?lZ4@So
6ATAo`000002obXA20?o4A4A00Co:Q48oa4A4OlA4A7o:Q480_lA4A42obXA
2004oa4A4OlI6A7o4A4AoaTI6@;o8R8A00Co6ATIoaTI4OlI6A7o:Q48Y?oV
i^H005[ok^k^0_lA4A400olI6AWo4A4Aoa4A4@08oa4A4@03o`000?lA4A7o
4A4A00co4A4A00Go0000oaTI6OlA4A7o4A4AoaTI6@06oa4A4@03o`000?lI
6A7o4A4A00Oo4A4A00Go0000oa4A4OlA4A7o6ATAo`000003oa4A4@03oaTI
4OlA4A7o4A4A00Ko4A4A00?o0000oa4A4OlA4A403OlA4A400ol0003o4A4A
oa4A4@03oa4A4@03o`000?lA4A7o4A4A00?o4A4A00Go0000oa4A4OlA4A7o
0000oaTI4@03oa4A4@05o`000?lA4A7o4A4Aoa4A4OlZ4@P01OlA4A401?lI
6A7o4A4AoaTI4OlZ4@P3oa4A4@0:o`000?lI6A7o4A4AoaTI6OlA4A7o:R8I
oaTI4OlA4A7o6ATAo`0000?o6ATA00Co8R8AoaTI6OlI6A7o4A4A0_lI6AT0
2OlI6A7o:R8IoaTI4OlI8R;o4A4AoaTI4OlA4A7o:Q48oa4A4@02oaTI6@;o
6ATA0_lA4A401?lR8Q7o6ATAoaTI4OlR8Q42oa4A4@03oaTI4OlR8Q7o6ATA
00;o6ATA00Wo8RXZoaTI4OlR8Q7o6ATAob8R4OlI6A7o6ATIob8R4OlI6AT0
0_lI6A402OlA4A7o8R8Aob8Z:_lR8Q7o6B8Rob8R4OlI6AWo6ATAoaTI6@02
oa4A4@05ob8R4OlI6AWo8R8Aob8R4OlI8R800_lR8Q401_lZ8QWo6ATIobXR
6OlI6A7o8R8AoaTI6@;o8R8A00So6ATIob8R4OlI6AWo6ATIoaTR8_lR8Q7o
6B8Rob8R4@?o6ATI00[o6B8Rob8R4OlI6AWo8R8AobXA2?lI6A7o:R8IoaTI
4OlR8Q7o6ATI0olR8Q401OlI6AWo:R8Iob8R4OlZ8QWo8R8A00;o:R8I00Oo
8S8ZobXR6OlZ8QWo:R8IoaTI6OlR8Q7o6ATI00;o8R8A01Co:R8IoaTI6OlR
8Q7o6ATIobXR6OlZ4@So:R8Iob8R4OlZ8QWo6ATAobXR6OlI6A7o8R8AobXR
6OlI6A7o8R8AoaTI4OlZ8QWo8SXbobXA20;o:R8I00?o6B8RobXR6OlI6A40
1?lR8Q402olI6AWo6ATAob8R4OlA4A7o:Q48oa4A4OlI6A7o6ATIoaTI4OlI
6AWo8R8A00?o6ATI00So8R8AoaTI6OlZ4@So4A4Aob8R4OlI6AWo6ATAobXR
6@;o6ATA2OlA4A401OlZ4@So4A4Aoa4A4OlA4A7o:Q4800?o4A4A00Go:Q48
oa4A4OlA4A7o4A4AobXA2003oa4A4@;o:Q480_lA4A400olZ4@So4A4AobXA
2002oa4A4@03oaTI4OlA4A7o4A4A00;o4A4A00Go:Q48oa4A4OlI6A7o6ATA
oa4A4@02oaTI4@07oa4A4OlI6AWo:Q48oc8Z8_lI6A7o6ATIob8R4@02oaTI
6@03ocY46Oo^k^kok^k^0:;ok^k^001Jooooo`Wo4A4A00?o0000oa4A4OlA
4A400olA4A400ol0003o4A4Aoa4A4@0;oa4A4@03o`000?lA4A7o000000Co
4A4A00?o0000oaTI4OlA4A400_lA4A400ol0003o4A4Aoa4A4@08oa4A4@03
o`000?lA4A7o4A4A00Co4A4A00?o0000oa4A4Ol000002?lA4A400ol0003o
4A4Aoa4A4@02oa4A4@03o`000?lI6A7o4A4A00So4A4A00?o0000oa4A4OlA
4A403olA4A400ol0003o4A4Aoa4A4@02oa4A4@04obXA2?lA4A7o4A4AobXA
20Go4A4A00Go:Q48oa4A4OlA4A7o4A4AoaTI6@03oa4A4@03oaTI4OlI6AWo
6ATA00?o4A4A00Ko6ATIoa4A4OlI6AWo6ATAoa4A4OlI6A43oa4A4@04oaTI
6OlA4A7o6ATAoaTI4@;o6ATI00Ko6ATAoa4A4OlA4A7o4A4AoaTI4OlZ4@P2
oaTI4@;o4A4A00?o8R8AobXA2?lI6A400olI6A400olZ4@So6ATAob8R4@02
oaTI4@04ob8R4OlI6A7o:Q48oaTI6@;o6ATA00Co6ATIobXR6OlI6A7o8SXb
0_lR8Q402olI6A7o6ATIobXA2?lI8R;o8R8AobXR6OlI6AWo6B8Roa4A4OlI
6AWo8R8A00;o6ATI0_lR8Q401OlI6AWo8R8Aob8R4OlI6AWo8R8A00;o6ATI
00?o6ATAobXR6OlZ4@P00olR8Q402OlR:R[o:Q48ob8R4OlR8Q7o:R8IoaTI
6OlR8Q7o:R8IoaTI6@02ob8R4@03oaTI6OlZ8QWo6ATA00;o:R8I00[o6ATA
ob8R4OlR8Q7o6ATIob8R4OlZ8QWo8R8Aob8Z:_lZ4@So:R8I0_lI6A401?lR
8Q7o6ATIob8R4OlI6AT2ob8R4@07oaTI6OlR8Q7o8R8Aob8R4OlI6A7o:R8I
oa4A4@02obXR6@0Cob8R4OlZ8QWo6ATIobXR6OlZ4@So6ATIob8R4OlI6AWo
:Q48obXR6OlR8Q7o6ATIobXR6OlI6A7o:R8IoaTI6OlR8Q7o8RXZoa4A4@02
oaTI4@0:oa4A4OlI6A7o4A4Aoa4A4OlI6A7o4A4AoaTR8_lI6A7o4A4AobXR
6@;o6ATA00?o6ATIob8R4OlI6AT01?lI6A42oa4A4@04oaTI4OlA4A7o:Q48
obXA20Co4A4A00Co:Q48oa4A4OlA4A7o6ATA0_lZ4@P2oa4A4@06obXA2?lA
4A7o6ATAobXA2?lA4A7o:Q480_lI6A42obXA2005oa4A4OlZ4@So:Q48oa4A
4OlI6A401?lA4A400olI6A7o4A4AobXA2002oaTI4@03oa4A4OlZ4@So4A4A
00Co4A4A00[o:Q48oa4A4OlA4A7o4A4Ao`000?lR8Q7o6ATIob8R4OlZ8QWo
4A4AY?ooool005[ok^k^00?o4A4Ao`000?lA4A400_lA4A400olI6AWo4A4A
o`000002oa4A4@03o`000?lA4A7o4A4A00Wo4A4A00Co6ATIoa4A4OlI6AWo
00002olA4A400ol0003o4A4Aoa4A4@07oa4A4@03o`000?lA4A7o4A4A00Co
4A4A00?o6ATIoa4A4OlA4A401OlA4A400ol0003o4A4Aoa4A4@0;oa4A4@03
o`000?lA4A7o4A4A00go4A4A00?o0000oa4A4OlA4A400_lA4A401OlZ4@So
4A4Aoa4A4OlA4A7o000000Go4A4A00?o0000oa4A4OlA4A400olA4A400olI
6A7o4A4AoaTI4@06oa4A4@;o6ATA0_lA4A401_lb:R;o4A4Aoa4A4OlI6AWo
4A4AoaTI6@?o6ATA00[o4A4AoaTI6OlI6AWo4A4AoaTR8_lI6A7o4A4Aob8R
4OlA4A7o6ATI0_lA4A400olZ8QWo4A4AoaTI4@02oaTI4@;o4A4A0_lI6A40
1?lZ4@So6ATAoaTI4OlA4A43oaTI4@;o6B8R01go4A4AoaTI6OlI6A7o6ATI
oaTI4OlI6AWo6B8RobXA2?lI6AWo:R8IoaTI6OlI6A7o4A4AoaTI4OlI6AWo
8R8AoaTI4OlR8Q7o6B8RoaTI4OlA4A7o6ATAobXA2?lR8Q7o6B8Roa4A4OlR
8Q7o4A4AoaTI6@02ob8R4@;o6ATI00Ko4A4AoaTI4OlR8Q7o6ATAoaTI6OlR
8Q42oaTI6@0Mob8R4OlI8R;o8R8AoaTI6OlR8Q7o6B8Rob8R4OlI6AWo8R8A
oaTR8_lR8Q7o6ATIob8R4OlI6A7o:Q48oaTR8_lA4A7o6ATAoaTI6OlR8Q7o
6B8Rob8R4OlI6AWo8R8AoaTI6OlZ4@So6ATAob8R4OlI6AT00_lR8Q401?lI
6AWo8R8AobXR6OlR8Q42oaTI4@;o8R8A00_o6ATAob8R4OlR8Q7o6ATIobXR
6OlI6AWo8R8AobXR6OlR8Q7o6ATAobXR6@02ob8R4@;o:R8I00[o:Q48oaTI
6OlR8Q7o6ATIobXR6OlI6AWo8R8Aoa4A4OlI6AWo4A4A0_lI6AT3oaTI4@04
ob8R4OlI8R;o:R8IoaTI6@;o:R8I00Ko8R8AoaTI4OlI6AWo8R8AoaTI6OlI
6A42ob8R4@07obXR6OlA4A7o:Q48oa4A4Ol0003o4A4Ao`000002oa4A4@03
obXA2?lA4A7o4A4A00;o4A4A00?o:Q48o`000?lI6A400olA4A43oaTI4@0;
obXA2?lI6A7o4A4AobXA2?lI6A7o4A4AobXA2?lA4A7o8R8Aoa4A4OlI6A40
0olA4A400olZ4@So4A4Aoa4A4@03oa4A4@;o:Q480_lA4A401OlZ4@So6ATA
oa4A4OlZ4@So6ATA00?o4A4A00Ko6ATAoa4A4OlI6A7o6ATAoa4A4Olb:R:T
onk^kP00F_oVi^H5oa4A4@05o`000?lA4A7o4A4Aoa4A4Ol000001OlA4A40
0ol0003o8R8Aoa4A4@0<oa4A4@04o`000?lA4A7o4A4Ao`0000Oo4A4A0_l0
0009oa4A4@05obXA2?l0003o0000oa4A4Ol000000_lA4A400ol0003o4A4A
oa4A4@0Aoa4A4@03o`000?lA4A7o6ATI00Oo4A4A00Ko0000oa4A4OlA4A7o
6ATAoa4A4Ol0000Eoa4A4@;o6ATA00Oo4A4AoaTI6OlI6AWo6ATAoaTI6Olj
>S;o6ATI00;o6ATA00Go6ATIoaTI4OlA4A7o8R8AoaTI4@02oa4A4@06oaTI
6OlA4A7o4A4AoaTI6OlA4A7o:R8I0_lA4A401OlI6A7o6ATIoa4A4OlI6A7o
4A4A00Co6ATA0_lI6AT2oa4A4@03oaTI4OlA4A7o6ATA00;o4A4A00Co6ATI
oaTI4OlA4A7o:R8I0_lI6AT2oaTI4@03oa4A4OlI6A7o6ATA00?o6ATA00go
6B8RobXA2?lI6A7o:R8IoaTI4OlR8Q7o4A4AobXR6OlI6A7o8R8AoaTI4OlA
4A7o6ATA00;o6ATI00Ko8R8Aoa4A4OlR8Q7o8R8AoaTI4OlI6AT2oaTI4@;o
8R8A00Go6ATAoaTI6OlZ4@So:R8IoaTI6@03ob8R4@05oaTI6OlR8Q7o8R8A
obXR6OlR8Q400olZ8QT01OlI8R;o8R8AoaTI4OlI6A7o:R8I00;o6ATI0_lZ
8QT01?lR8Q7o6ATIobXA2?lI6AT3ob8R4@09obXR6OlI6AWo6ATAob8R4OlI
6A7o:R8IoaTI4OlR8Q7o6B8R00;o8R8A00Ko6ATAobXR6OlR8Q7o:R8Iob8R
4OlI6AT5ob8R4@0:oaTI6OlR8Q7o:R8IoaTI6OlZ8QWo8R8AoaTI6OlI6A7o
8R8AobXR6@Co6ATA00?o:R8IoaTI6OlR8Q400_lI6A401_lZ8QWo8R8AoaTI
4OlZ8QWo6ATAobXR6@;o8R8A00_o6ATIobXR6OlZ8QWo6ATAob8R4OlZ4@So
8R8AoaTI4Ol0003o4A4AobXA2002oa4A4@;o:Q480_lA4A42oaTI4@05obXA
2?lA4A7o4A4AobXA2?lI6A400_lA4A400olZ4@So4A4AobXA2004oa4A4@06
obXA2?lA4A7o4A4AobXA2?lA4A7o:Q480_lA4A401?lZ4@So4A4Aoa4A4OlZ
4@P3oa4A4@03obXA2?lA4A7o6ATA00?o4A4A00?o:Q48oa4A4OlA4A400_lA
4A45oaTI4@;o8R8A00Co6ATIobXR6OlI6AWo:Q48Y?oVi^H005[ok^k^1_lA
4A400ol0003o4A4Aoa4A4@07oa4A4@04o`000?lA4A7o6ATAoaTI6@Go4A4A
00?o6ATIoa4A4OlA4A401_lA4A42oaTI6@03oa4A4Ol0003o4A4A00;o4A4A
00?o6ATAoa4A4OlA4A401OlA4A400ol0003o4A4Aoa4A4@04oa4A4@03oaTI
6OlA4A7o4A4A00go4A4A00?o6ATAoa4A4OlA4A401_lA4A400ol0003o6ATA
oa4A4@02oaTI6@03oa4A4OlR8Q7o4A4A00_o4A4A00?o:Q48oa4A4OlA4A40
0_lA4A400ol0003o6ATAoa4A4@02oa4A4@03obXA2?lA4A7o4A4A00Co4A4A
00Ko0000oa4A4OlA4A7o:R8Ioa4A4OlI6A44oa4A4@04oaTI6OlA4A7o:R8I
oa4A4@;o6ATI00?o6ATAoa4A4OlI6A401?lA4A403_lI6AWo:R8IoaTI4OlR
:R[o6ATAoaTI6OlA4A7o6B8RoaTI4OlA4A7o8R8Aoa4A4OlI6A7o:Q480_lA
4A401_lI6A7o6ATIoaTI4OlA4A7o8R8Aoa4A4@?o6ATA00Go4A4AoaTI4OlA
4A7o6ATIobXR6@03oaTI4@09oaTI6OlI6A7o6ATIoaTI6OlR8Q7o6ATIoaTI
4OlR8Q7o6ATI00;o6ATA00?o6ATIoa4A4OlI6AT00_lI6A42oaTI6@0IoaTI
4OlI6AWo<RXRoaTI4OlZ8QWo6ATIob8R4OlI6AWo:R8IoaTI4OlI6AWo8R8A
oaTI4OlZ8QWo6ATIoaTI4OlR8Q7o6ATIob8R4OlI6A7o6ATIob8R4OlI6AWo
6ATAob8R4@02oaTI4@04obXR6OlA4A7o6ATAob8R4@;o6ATI00Oo:Q48oaTI
4OlI6AWo8R8AoaTI6OlR8Q7o6ATI00;o8R8A0_lZ8QT03?lR8Q7o:R8IoaTI
4OlZ8QWo6ATAoaTI6OlR8Q7o:R8IoaTI4OlZ8QWo8R8AoaTI6@;o:R8I02Co
6B8RobXR6OlI6AWo:R8Iob8R4OlZ8QWo8R8AobXR6OlR8Q7o6B8Rob8R4OlZ
8QWo6ATIoaTI4OlA4A7o6ATAoa4A4OlI6A7o4A4AoaTI6OlR8Q7o6ATAobXR
6OlI6A7o6ATIoaTI4OlR8Q7o4A4AoaTI6OlI6A7o6ATIob8R4OlI6A7o6ATI
oa4A4OlI6AT2oa4A4@03o`000?lA4A7o4A4A00?o4A4A0_lI6A401OlZ4@So
4A4Aoa4A4Ol0003o:Q4800Co4A4A00?o:Q48oa4A4OlZ4@P00olA4A401_lZ
4@So4A4Aoa4A4OlI6A7o4A4AobXA20Go4A4A00Ko:Q48oa4A4OlA4A7o6ATA
oa4A4OlZ4@P6oa4A4@06oaTI4OlA4A7o4A4Aoa4A4OlZ4@So4A4A0olI6A40
2?lR8Q7o6ATAoaTI4OlA4A7o:R8IoaTI4OlI6AWo:Q48Y?o^k^h005[ooooo
00Go0000oa4A4OlA4A7o4A4Ao`000003oa4A4@03o`000?lA4A7o4A4A00Ko
4A4A00?o6ATIoa4A4OlA4A400_lI6AT6oa4A4@03o`000?lA4A7o4A4A00Co
4A4A00?o0000oa4A4OlA4A400_lA4A400ol0003o4A4Aoa4A4@0>oa4A4@04
o`000?lA4A7o4A4Ao`0000_o4A4A00?o0000oa4A4OlA4A402?lA4A400ol0
003o6ATAoa4A4@08oa4A4@03o`000?lA4A7o4A4A00?o4A4A00Co0000oa4A
4OlA4A7o00000olA4A401Ol0003o4A4Aoa4A4OlI6A7o000000ko4A4A00?o
6ATIoa4A4OlA4A400_lA4A401?lI6A7o4A4Aoa4A4OlI8R83oa4A4@;o6ATI
00Co4A4AoaTI4OlA4A7o8RXZ0_lI6A401OlZ4@So4A4AoaTI4OlZ4@So4A4A
00;o6ATA00?o4A4AoaTI4OlZ4@P00_lA4A401_lI6A7o4A4AobXR6OlI6A7o
4A4AobXR6@;o6ATA00So4A4AobXR6OlI6AWo6ATIob8R4OlI6A7o6ATIoc8Z
8P;o6ATA00Ko8R8AoaTI6OlA4A7o6ATAoaTI6OlI6A42oaTI6@09obXR6OlZ
4@So6ATIoaTR8_lZ8QWo6B8Rob8R4OlI6AWo:R8I00;o6ATA00Ko6ATIobXA
2?lR8Q7o6ATAob8R4OlI6AT2ob8R4@0CobXR6OlI6A7o8R8AoaTI6OlR8Q7o
6ATIob8R4OlZ8QWo6ATIob8R4OlI6AWo6ATAob8R4OlI6A7o6ATIob8R4OlI
6AWo8R8AoaTI6@02ob8R4@09oaTR8_lI6AWo8R8AoaTI4OlR8Q7o:R8IoaTI
4OlZ8QWo6ATI00;o8R8A00?o6ATIoa4A4OlR8Q400olI6A401olI8R;o6ATI
ob8R4OlI6AWo8R8AobXR6OlI6AT00_lZ8QT01_lR8Q7o6ATIobXR6OlZ8QWo
8R8AoaTR8P;o8R8A00Ko6B8Roa4A4OlI6A7o4A4AoaTI6OlR8Q42oa4A4@05
oaTI4OlZ4@So6ATAoaTI6OlR8Q400olI6A42oaTI6@;o8R8A00Go6ATIobXA
2?lI6A7o:Q48oa4A4@02oaTI4@04obXA2?lA4A7o6ATAobXA20Go4A4A00[o
0000obXA2?lA4A7o:Q48oaTI4OlA4A7o:Q48o`000?lZ4@So4A4A0olI6A40
1OlA4A7o6ATAobXA2?lA4A7o:Q4800Go4A4A00Co:Q48oa4A4OlI6A7o:Q48
0olA4A401Ol0003o6ATAoa4A4OlA4A7o:Q4800Co4A4A00[o:Q48oaTI4OlA
4A7o:Q48oa4A4OlZ4@So4A4AoaTI4OlA4A7o6ATA0_lA4A42oaTI4@;o6ATI
00?o8R8Aooooooooool0X_ooool005[ok^k^1OlA4A400olI6AWo0000oa4A
4@04oa4A4@03o`000?lA4A7o4A4A00Co4A4A00?o6ATIoa4A4OlA4A404?lA
4A400olI6A7o4A4Aoa4A4@0:oa4A4@05o`000?lA4A7o0000obXA2?l00000
3_lA4A400ol0003o4A4Aoa4A4@04oa4A4@03o`000?lA4A7o4A4A00_o4A4A
00?o0000oa4A4OlA4A401?lA4A400ol0003o4A4Aoa4A4@03oa4A4@03o`00
0?lA4A7o4A4A00;o4A4A00?o0000oa4A4OlA4A400_lA4A400olZ4@So4A4A
oa4A4@08oa4A4@05oaTI6OlI6A7o6ATIoa4A4OlI6A401?lA4A401OlI6AWo
6ATAoa4A4OlI6A7o4A4A00;o6ATA00Oo4A4AoaTI4OlA4A7o4A4AoaTI4OlA
4A7o6ATA00;o4A4A00?o6ATAoa4A4OlA4A400_lA4A42oaTI4@07oa4A4OlI
6A7o6ATAoaTI4OlI6AWo6ATAoa4A4@02oaTI6@0@obXR6OlI6AWo6ATIob8Z
:_lA4A7o:R8Iob8Z:_lA4A7o6ATAoa4A4OlR8Q7o6ATAobXR6OlI6AWo4A4A
oaTI6@;o6ATA00[o8R8AoaTI6OlI6A7o8R8AoaTI6OlR8Q7o6ATIob8R4OlI
6AWo6ATA0olR8Q404?lI8R;o:R8IocXj<_lZ8QWo6B8RoaTI6OlA4A7o6ATA
oaTI6OlR8Q7o6ATIoaTI4OlI6AWo6ATAob8R4OlI6AT2ob8R4@03oaTI6OlR
8Q7o8R8A00;o8R8A00co6ATAob8R4OlR8Q7o6ATIob8R4OlI6AWo8R8AobXR
6OlR8Q7o6ATAobXR6OlR8Q42oaTI4@03obXR6OlA4A7o8R8A00;o6ATI017o
8R8AoaTI6OlR8Q7o:Q48oaTI6OlR8Q7o6ATAoaTI6OlZ8QWo8R8AoaTR8_lZ
8QWo8R8AoaTI6OlR8Q7o6B8RobXR6@0;oa4A4@;o8R8A0olA4A401OlI6A7o
:R8IoaTI4OlZ4@So8R8A00;o6ATA00?o8R8AoaTI4OlI6A400_lA4A401?l0
003o4A4AoaTI4Ol00002oa4A4@04obXA2?lA4A7o4A4AoaTI4@;o4A4A00?o
6ATAo`000?lA4A400_lA4A402_lI6A7o4A4AobXA2?l0003o4A4AobXA2?l0
003o6ATAoa4A4OlZ4@P3oa4A4@04obXA2?lI6A7o4A4AoaTI4@;o4A4A00Go
6ATAoa4A4OlA4A7o4A4AobXA2003oa4A4@;o6ATA00?o:Q48oa4A4OlI6A40
0olA4A42oaTI4@03ob8R4OlI8R;o6ATA00Co8R8A00Go6ATAob8R4OlR8Q7o
6ATAoc8Z8P2Tonk^kP00F_oVi^H00ol0003o4A4Aoa4A4@02oa4A4@05o`00
0?lA4A7o4A4Aoa4A4Ol000002OlA4A401OlI6A7o4A4Aoa4A4OlA4A7o6ATI
00Oo4A4A00?o6ATAoa4A4Ol000001?lA4A400ol0003o4A4Aoa4A4@07oa4A
4@03o`000?lA4A7o4A4A00Go4A4A00?o:Q48oa4A4OlA4A400olA4A400ol0
003o4A4Aoa4A4@0:oa4A4@03o`000?lA4A7o4A4A00Ko4A4A00?o0000oa4A
4OlA4A401?lA4A400olI6A7o4A4Aoa4A4@07oa4A4@03o`000?lA4A7o4A4A
00;o4A4A00?o:Q48oa4A4OlA4A401OlA4A400ol0003o4A4AobXA2003oa4A
4@03oaTI4OlA4A7o6ATA00;o4A4A00?o6ATAoa4A4OlA4A400olA4A42oaTI
6@;o4A4A00?o:R8Ioa4A4OlI6AT00olI6A42oa4A4@05oaTI6OlI6A7o4A4A
oa4A4OlR:RX00olI6A400olA4A7o:Q48oa4A4@02oaTI4@0=oa4A4OlI6AWo
6ATAoa4A4OlI6AWo6ATAob8R4OlI6AWo8R8AoaTI4OlR8Q7o6ATAob8R4@03
oaTI4@04obXR6OlA4A7o6ATIob8R4@;o6ATA00?o4A4Aob8R4OlI6A400_lI
6A401_lI6AWo8R8AoaTI4OlR8Q7o6ATIoaTR8P;o:R8I00Co6B8RoaTI4OlI
6AWo6ATA0_lI6AT00olR8Q7o4A4AoaTI4@02ob8R4@03obXR6OlR8Q7o:Q48
00?o6ATA00?o6ATIobXA2?lI6AT00_lI6A401?lZ8QWo6ATAobXR6OlZ8QT2
oaTI4@0=oaTI6OlZ8QWo6ATAob8R4OlZ8QWo8R8AobXR6OlI8R;o8R8AoaTR
8_lR8Q7o:R8IoaTR8P02obXR6@03ob8R4OlZ8QWo6ATI00;o8R8A00Wo:R8I
ob8R4OlR8Q7o8R8AoaTI6OlI6A7o:R8IobXA2?lZ8QT00olR8Q401_lI6AWo
8R8AobXR6OlR8Q7o:Q48oaTI6@Go8R8A00?o:R8Iob8R4OlR8Q400olR8Q40
1OlI8R;o:R8IobXR6OlZ8QWo8R8A00;o:R8I00?o8S8Zoc8Z8_lb:R800_lZ
4@P01?lI6A7o4A4AobXA2?l00006oa4A4@06obXA2?lA4A7o:Q48o`000?lA
4A7o:Q481_lA4A403OlI6A7o4A4AobXA2?lA4A7o6ATAobXA2?lA4A7o:Q48
oaTI4OlZ4@So4A4AobXA2?lI6A400_lZ4@P01?lA4A7o:Q48obXA2?lA4A43
obXA20;o4A4A00Co:Q48oaTI4OlI6A7o00001?lA4A42oaTI4@04oa4A4OlZ
8QWo:R8Iob8R4@;o:R8I00So:Q48ob8R4OlR8Q7o8R8Aoc8Z8_lZ8QWo8RXZ
oaTI4JCoi^KV001Jonk^kP03oa4A4Ol0003o000000?o4A4A00?o0000oa4A
4OlA4A400_lA4A400ol0003o4A4Aoa4A4@03oa4A4@03o`000?lA4A7o4A4A
00Go4A4A00?o6ATIoa4A4OlI6A400olA4A400ol0003o4A4Aoa4A4@09oa4A
4@04o`000?lA4A7o4A4AobXA20Go4A4A00?o0000oa4A4OlA4A400_lA4A40
1?l0003o4A4Aoa4A4Ol00004oa4A4@03oaTI6OlA4A7o4A4A00Co4A4A00?o
0000oa4A4Ol000001olA4A400ol0003o4A4Aoa4A4@02oa4A4@03oaTI4OlA
4A7o4A4A00;o4A4A00Go0000oa4A4Ol0003o4A4Ao`000002oa4A4@03o`00
0?lA4A7o4A4A00;o4A4A00Co0000oa4A4OlA4A7o00002olA4A401olZ4@So
0000oa4A4Ol0003o4A4AoaTI4OlA4A400_lI6A43oa4A4@05oaTI6OlZ8QWo
4A4AoaTI4OlA4A400_lI6A400olA4A7o6ATIoaTI6@02oaTI4@05obXA2?lA
4A7o4A4Aoa4A4OlZ4@P00_lA4A401?lI6A7o4A4Aob8R4OlZ4@P3oa4A4@08
oaTI6OlI6A7o6ATAoa4A4OlI6A7o4A4AoaTI4OlI6AT3oaTI4@0Cob8R4OlI
6A7o4A4AoaTI6OlA4A7o6ATIobXA2?lR:R[o6B8Roa4A4OlI6AWo:R8IoaTI
4OlI6AWo6ATAob8R4OlI6AWo6ATAoaTI6@02ob8R4@0?oaTI6OlI6A7o8R8A
ob8R4OlZ4@So:R8Iob8R4OlZ8QWo6ATAobXR6OlI6AWo:R8IoaTI6OlR8Q7o
6B8R00;o8R8A00Co:R8IoaTI4OlZ8QWo6ATA1?lZ8QT01_lI6AWo8R8AobXR
6OlI6AWo:R8IoaTI6@;o8R8A00Ko<RXRob8R4OlI8R;o8R8AobXR6Olb:R83
obXR6@08ob8R4OlZ8QWo:R8IobXR6OlR8Q7o:R8IoaTI4OlI6AT7ob8R4@03
oaTI6OlR8Q7o8R8A00;o:R8I00Go8R8AobXR6OlR8Q7o:R8IoaTR8P02ob8R
4@0:oaTI6OlR8Q7o6ATIob8R4OlI6AWo:R8IoaTI6OlZ8QWo6B8Rob8R4@?o
:R8I00Ko8R8Aoc8Z8_lR8Q7o<RXRobXR6OlI6A42oa4A4@03o`000?lA4A7o
4A4A00Co4A4A00Go:Q48oa4A4OlA4A7o:Q48o`000002oaTI4@04oa4A4OlZ
4@So4A4AobXA20;o4A4A0_lZ4@P00olA4A7o:Q48oa4A4@04oa4A4@07obXA
2?l0003o6ATAo`000?lZ4@So6ATAo`000004oa4A4@;o6ATA0olA4A402_lZ
4@So4A4Aoc8Z8_lR8Q7o:Q48oa4A4OlI6A7o:Q48oa4A4OlZ4@P2oaTI4@05
obXA2?lI6A7o8R8AobXR6OlI6AT00_lZ8QT2oc8Z8P05ob8R4OlZ8QWo:R8I
ocXj8_m<8PP0Y?o^k^h005[ooooo00?o0000oa4A4OlA4A400_lA4A400olI
8R;o4A4Aoa4A4@05oa4A4@03o`000?lA4A7o4A4A00co4A4A00?o0000oa4A
4OlA4A401OlA4A400ol0003o4A4Ao`000002oa4A4@03o`000?lA4A7o4A4A
00?o4A4A00Co0000oa4A4OlA4A7o00004OlA4A400ol0003o4A4Aoa4A4@06
oa4A4@03o`000?lA4A7o4A4A00Oo4A4A00?o0000oa4A4OlA4A402?lA4A40
1_l0003o4A4Aoa4A4Ol0003o4A4Ao`0000Go4A4A00Go0000obXA2?lA4A7o
4A4AobXA2005oa4A4@03ob8Z:_lA4A7o:Q4800Co4A4A00Co6ATAoa4A4OlA
4A7o6ATA0olA4A402_lI6A7o6ATIoaTI4OlI6A7o4A4AoaTI4Ol0003o:R8I
oa4A4OlI6A42oa4A4@03oaTI4OlI6AWo6ATA00;o4A4A00Wo6ATIobXA2?lA
4A7o6ATAobXA2?lA4A7o:Q48oa4A4OlI6AT00_lI6A42oa4A4@03oaTI4OlA
4A7o4A4A00?o6ATA00Ko6ATIoaTI4OlI6A7o6ATAob8R4OlI6AT2oc8Z8P08
ocXj<_lZ4@So6ATAobXR6OlI6A7o:R8IoaTI4OlI8R82ob8R4@0<oaTI4OlZ
8QWo6B8RobXR6OlI6A7o6ATIob8R4OlI8R;o8R8AoaTI6OlZ8QWo6ATA0olR
8Q402OlI8R;o:Q48oaTR8_lR8Q7o:R8Iob8R4OlZ8QWo6ATIob8R4@02obXR
6@05ob8R4Olb:R;o:R8Iob8R4OlI8R800olZ8QT01olb:R;o8R8AobXR6OlZ
8QWo6ATIoc8Z8_lI8R800_lZ8QT02?lR8Q7o:R8IobXR6OlI6A7o:R8Iob8R
4OlI8R;o8R8A0_lZ8QT00olR8Q7o:R8IobXR6@02obXR6@04ob8R4OlZ8QWo
8R8AobXR6@;o8R8A00?o:R8Iob8R4OlZ8QT00olZ8QT00olR8Q7o:R8Ioc8Z
8P02ob8R4@04oc8Z8_lZ8QWo<RXRoaTI4@;o8R8A00Wo:R8IoaTR8_lI6A7o
:R8Iob8R4OlI6AWo6ATAo`000?lZ4@P01OlA4A400olZ4@So4A4AobXA2003
oa4A4@03o`000?lZ4@So4A4A00;o4A4A00Go:Q48oaTI4OlA4A7o6ATAobXA
2002oa4A4@05oaTI4OlA4A7o4A4Aoa4A4OlZ4@P00olA4A400olZ4@So6ATA
oaTI4@02oa4A4@05o`000?lI6A7o:Q48o`000?lZ4@P01olA4A402?l0003o
:R8IoaTI4OlA4A7o:Q48oa4A4OlI6A7o4A4A0_lI6A401_lA4A7o6ATAoaTI
4OlA4A7o6ATAob8R4@;o6ATI00Oo8R8AoaTI4OlZ4@So6B8Roc8Z8_lR:R[o
8R8A0:Cooooo001Jonk^kP06oa4A4Ol0003o0000oa4A4OlR:R[o8S8Z0_lA
4A400ol0003o4A4Ao`000004oa4A4@03o`000?lA4A7o4A4A00;o4A4A00?o
0000oa4A4OlA4A400_lA4A401?l0003o4A4Aoa4A4Ol00004oa4A4@03o`00
0?lA4A7o4A4A023o4A4A00?o6ATAoa4A4OlA4A402olA4A401?lI6A7o4A4A
oa4A4Ol00003oa4A4@03o`000?lA4A7o4A4A00Co4A4A00?o0000oa4A4OlA
4A401olA4A400ol0003o4A4Aoa4A4@06oa4A4@06oaTI4OlA4A7o4A4AoaTI
4Ol0003o6ATA1?lA4A400olI6AWo4A4Aoa4A4@02oa4A4@06oaTI4OlA4A7o
8R8Aoa4A4OlI6AWo00000olI6A400olR8Q7o6ATIob8R4@02oa4A4@07oaTI
4OlI6AWo6ATAoaTI6OlA4A7o6ATAoa4A4@02oaTI4@;o4A4A0_lI6A400olA
4A7o6ATAoaTI4@02oaTI4@;o6ATI01?o6ATAob8R4OlI6A7o6ATAob8R4OlI
6A7o:R8Ioa4A4OlR8Q7o6ATIob8R4OlI6AWo6ATAob8R4OlI6A7o6ATIobXR
6OlI6AWo8R8A00?o:R8I00?o6B8RobXR6OlI6AT00_lZ8QT01olI6AWo8R8A
oaTR8_lI6AWo6B8RoaTI6OlZ8QT01?lI6AT01_lR8Q7o6ATIob8R4OlI6AWo
8R8AoaTI6@?o:R8I00Oo8RXZobXR6OlZ8QWo:R8IoaTR8_lZ8QWo8R8A00;o
:R8I00Co<RXRoaTI6Olb:R;o8S8Z1?lZ8QT00olb:R;o:R8IoaTI6@02obXR
6@05oc8Z8_lR8Q7o8R8AobXR6Olb:R800olR8Q401olZ8QWo8R8Aob8R4OlR
8Q7o6ATAob8R4OlZ8QT00_lR8Q400olI8R;o:R8IoaTI6@02oaTI4@03obXA
2?lI6A7o6ATA00?o6ATA00Co8R8AoaTI4OlA4A7o:Q480_lA4A42o`000008
obXA2?lA4A7o0000oa4A4OlZ4@So0000oa4A4OlI6A49oa4A4@05obXA2?lA
4A7o4A4Aoa4A4OlZ4@P00_lI6A42oa4A4@09obXA2?lA4A7o6ATAobXA2?l0
003o4A4AobXA2?lA4A7o:Q4800;o4A4A0_lZ4@P01_l0003o6ATAo`000?lZ
4@So4A4AobXA20;o4A4A00?o:Q48oa4A4OlA4A400olA4A42obXA2003oa4A
4OlZ4@So6ATA00?o4A4A00Ko:Q48oa4A4OlZ4@So6ATAoa4A4OlZ4@P2oaTI
4@0<obXA2?lR8Q7o8R8AoaTR8_lZ4@So6ATAob8R4OlI6AWo8R8AoaTI4OlZ
8QWo6ATAY?o^k^h005[oi^KV00Go0000oa4A4Ol0003o4A4Aob8R4@0<oa4A
4@03o`000?lA4A7o4A4A02ko4A4A00?o6ATAoa4A4OlA4A402OlA4A401OlI
6A7o4A4Aoa4A4OlA4A7o000000Oo4A4A00Go0000oa4A4Ol0003o4A4Ao`00
0003oa4A4@03o`000?lA4A7o000000;o4A4A00?o0000oa4A4OlA4A401_lA
4A401?lI6A7o4A4Aoa4A4Ol00006oa4A4@03obXA2?lI6A7o4A4A00So4A4A
00?o6ATAoa4A4OlI6A400olI6A403_lA4A7o8R8AoaTI4OlA4A7o:Q48oa4A
4OlI6A7o4A4AoaTI6OlA4A7o6ATAoa4A4OlI6A7o4A4A0olI6A402OlA4A7o
6ATAoaTI6OlI6AWo8R8AobXR6OlR8Q7o6ATIoaTI4@02ob8R4@0BoaTI6OlR
8Q7o:R8IoaTI4OlR8Q7o:R8IoaTI6OlZ8QWo6ATAobXR6OlI6A7o:R8Iob8R
4OlI6AWo8R8AoaTR8_lI6AWo:R8I0_lI6AT01?lZ8QWo8R8AoaTI6OlI6AT3
ob8R4@0<obXR6OlR8Q7o:R8Iob8R4OlZ8QWo4A4Aob8R4OlI8R;o:R8IoaTR
8_lR8Q7o8RXZ0olR8Q42obXR6@05oaTI6OlZ8QWo6B8RobXR6OlR8Q400_lZ
8QT01OlI8R;o:R8IobXR6OlZ8QWo6B8R00?o:R8I00Oo8R8AobXR6OlZ8QWo
:R8IocXj8_lZ8QWo>SXR00;o<RXR00Ko8R8AoaTI4OlR8Q7o0000oa4A4OlI
6AT4oa4A4@03obXA2?l0003o4A4A00;o4A4A00Co:Q48o`000?lA4A7o:Q48
0olA4A403OlZ4@So4A4AobXA2?lI6A7o0000oa4A4Ol0003o4A4AobXA2?lA
4A7o:Q48oaTI4Ol000001olA4A402OlI6A7o4A4AobXA2?lA4A7o:Q48o`00
0?lA4A7o:Q48o`000002oa4A4@04oaTI4OlA4A7o8R8Aoa4A4@;o6ATA1OlA
4A401_lZ4@So6ATAo`000?lA4A7o:Q48oaTI4@Co4A4A00Co:Q48oaTI4OlI
6A7o:Q480_lA4A401_lZ4@So6ATAoa4A4OlZ4@So4A4AobXA20Ko4A4A00Co
:Q48oaTI4OlA4A7o6ATA1?lA4A43oaTI4@05obXA2?lI6A7o8R8Aob8R4OlI
6A400_lR8Q401OlI6AWo6ATAob8R4OlR:R[o8R8A0:Coi^KV001Jonk^kP04
oa4A4Ol0003o4A4Ao`0000Co4A4A00?o0000oa4A4Ol000000_lA4A400ol0
003o4A4Aoa4A4@02oa4A4@03o`000?lA4A7o4A4A00Ko4A4A00Go6ATAoa4A
4OlA4A7o4A4Ao`000002oa4A4@03o`000?lA4A7o4A4A00Co4A4A00?o6ATA
oa4A4OlA4A403OlA4A401Ol0003o4A4Aoa4A4OlA4A7o6ATA00Ko4A4A00?o
0000oc8Z8_lI8R800_lA4A401?lI6AWo4A4Aoa4A4Ol00005oa4A4@04o`00
0?lA4A7o4A4Ao`0000Ko4A4A00?o6ATIoa4A4OlA4A401olA4A400ol0003o
4A4Aoa4A4@03oa4A4@03o`000?lA4A7o6ATA00?o4A4A00Go:Q48oa4A4OlA
4A7o:Q48o`000002oa4A4@0>oaTI4OlA4A7o4A4AoaTI6OlI6A7o4A4Aob8R
4OlA4A7o6ATAoa4A4OlZ4@So6ATAoa4A4OlI6A42oaTI6@03o`000?lR8Q7o
6ATA00;o4A4A01Wo:Q48oa4A4OlI6A7o4A4AoaTI4OlR8Q7o6ATAob8R4OlI
6A7o4A4AobXA2?lA4A7o8R8AoaTI6OlI6A7o:R8IoaTI4OlR8Q7o6ATIoaTI
4OlI6AWo8R8AoaTI6OlR8Q7o6B8R00;o8R8A00?o6ATIobXA2?lI6AT00_lR
8Q402?lI6AWo:R8IoaTI4OlI6A7o:R8IoaTR8_lR8Q7o6B8R0_lR8Q401_lZ
8QWo6B8Rob8R4OlZ8QWo6ATIobXR6@?o8R8A00Ko:R8IoaTI6OlI6A7o6ATI
oaTR8_lI6AT5obXR6@04ob8R4OlZ8QWo:R8IoaTI6@?o:R8I00?o<RXRobXR
6OlZ8QT00olZ8QT00olR<R[o:R8IobXR6@04obXR6@03ob8Z:_lR8Q7o:R8I
00;o8R8A00Go:R8Ioc8Z8_lb:R;o8R8AoaTI4@06oa4A4@;o000000Go:Q48
oa4A4OlZ4@So4A4Ao`000002oaTI4@ko4A4A00?o6ATAoa4A4OlA4A400_l0
0003oa4A4@03oaTI4OlA4A7o4A4A00;o4A4A00Go:Q48oa4A4OlA4A7o0000
oaTI4@06oa4A4@03obXA2?lA4A7o:Q4800;o4A4A00Co6ATAo`000?lI6A7o
:Q481_lA4A403olI6A7o4A4Ao`000?lZ4@So6ATAobXA2?l0003o6ATAoa4A
4Ol0003o6ATAoa4A4OlZ4@So4A4Ao`000004oa4A4@05obXA2?lA4A7o4A4A
oaTI4OlR8Q400_lI6A42obXA2008oa4A4OlZ4@So4A4Aob8R4OlA4A7o6ATA
obXA2?lI6A42ob8R4@05oaTI4OlR8Q7o8R8AoaTI4OlR8Q400olI6A400olI
6AWo8R8Aonk^kP2Sonk^kP00F_ooool01?l0003o4A4Ao`000?l00006oa4A
4@03oaTI6OlI8R;o4A4A00Oo4A4A00?o0000oaTI6OlA4A401OlA4A400ol0
003o4A4Aoa4A4@0;oa4A4@03oaTI4OlA4A7o4A4A00Co4A4A00Go0000oa4A
4OlA4A7o4A4Ao`00000@oa4A4@;o000000?o4A4Ao`000?lA4A404OlA4A42
o`000004oa4A4Ol0003o4A4Ao`0000;o6ATA0olA4A401Ol0003o4A4Ao`00
0?lA4A7o000000;o4A4A00?o0000oa4A4OlA4A401olA4A400olZ4@So4A4A
oa4A4@02oaTI4@Co4A4A00Co0000oa4A4OlA4A7o4A4A0olI6A401OlA4A7o
8R8Aoa4A4OlZ8QWo:Q4800;o6ATI0_lI6A401?lI6AWo4A4AoaTI6OlR:RX2
oaTI4@?o8R8A00Oo6ATIoaTI4OlI6AWo8R8AoaTI4OlR8Q7o6ATI00Co6ATA
01Co4A4Aob8R4OlZ8QWo6ATIoaTI4OlI6AWo8R8AoaTI6OlR8Q7o:R8IoaTI
4OlZ8QWo8RXZobXA2?lR8Q7o6ATIobXR6OlI8R;o:R8IoaTI6@;o8R8A00Oo
6B8RobXR6OlI6A7o:R8Iob8R4OlI8R;o8R8A00;o:R8I00?o8R8AobXR6OlZ
8QT01?lZ8QT00olR8Q7o6B8Rob8R4@03obXR6@04oaTR8_lZ8QWo<RXRobXR
6@;o<RXR00[o:R8Iob8Z:_lZ8QWo:R8Iob8Z:_lR8Q7o:R8Iob8R4Olb:R;o
6B8R0olZ8QT02olb:R;o:R8IobXR6Olb:R;o0000oa4A4Ol0003o:Q48oa4A
4OlZ4@So000000;o4A4A01?o:Q48oa4A4OlA4A7o0000oa4A4OlZ4@So4A4A
o`000?lI6A7o4A4AobXA2?lI6A7o4A4AobXA2?lA4A7o:Q48o`000?lZ4@So
000000Co4A4A00?o0000oaTI4OlA4A400_lA4A402?lZ4@So4A4Aoa4A4Ol0
003o:Q48o`000?lZ4@So00001OlA4A401?lZ4@So4A4AoaTI4OlA4A42obXA
2003o`000?m4>R[o000000Go4A4A00?o0000obXA2?lA4A400olA4A401?l0
003o6ATAoa4A4Ol00002oa4A4@03oaTI4OlA4A7o4A4A00;o:Q4800?o4A4A
obXA2?lA4A400_lA4A401_lZ4@So4A4Aoa4A4OlZ4@So4A4AobXA20?o4A4A
0olI6A401olZ4@So6ATAobXA2?lI6A7o:Q48oaTI4OlZ4@P00olI6A42ob8R
4@03oa4A4OlI6A7o8R8A00;o6ATA00?o:R8IoaTI6OlZ4@P0Y?ooool005[o
k^k^00Ko4A4Ao`000?lA4A7o0000oa4A4Ol0000<oa4A4@03o`000?lA4A7o
4A4A00_o4A4A00?o0000oa4A4OlA4A401OlA4A400olI6A7o0000oa4A4@0:
oa4A4@04oaTI4OlA4A7o4A4AoaTI6@Wo4A4A00?o0000oa4A4OlA4A401olA
4A400ol0003o4A4Aoa4A4@02oa4A4@04o`000?lA4A7o4A4Ao`0000;o4A4A
00Co0000oa4A4OlA4A7o00002OlA4A400ol0003o4A4Aoa4A4@08oa4A4@06
o`000?lA4A7o4A4Aoa4A4Ol0003o4A4A0olI6A400ol0003o4A4Aoa4A4@03
oa4A4@05oaTI6OlA4A7o:Q48oaTI4OlA4A400_lI6A403OlI6AWo4A4AobXA
2?lA4A7o8R8AobXR6OlI6A7o6ATIoaTI4OlI6AWo6ATAob8R4OlA4A400_lI
6AT01OlI6A7o6ATIoaTI4OlI6A7o6ATI00Co6ATA0olA4A402?lI6AWo8R8A
ob8R4OlR8Q7o6ATIobXR6OlR8Q7o6ATI1?lR8Q402_lI6AWo6ATAoaTI4OlR
8Q7o:R8Iob8R4OlI8R;o8R8AobXR6OlI6AT2obXR6@0GoaTI6OlI8R;o:R8I
oaTI6OlR8Q7o6ATIob8R4OlZ8QWo8R8AoaTR8_lZ8QWo6ATIob8R4OlZ8QWo
6B8Rob8R4OlZ8QWo6B8Rob8R4OlI8R;o:R8IoaTR8_lR8Q400olZ8QT00olR
8Q7o:R8Iob8b:P03obXR6@07oaTI4OlZ4@So6ATIob8R4OlZ8QWo8R8AoaTR
8P03obXR6@07oc8Z8_lI6A7o4A4Aob8R4Ol0003o4A4AoaTI4@05oa4A4@;o
6ATA1?lA4A400olZ4@So4A4Aoa4A4@04oa4A4@06o`000?lA4A7o4A4Ao`00
0?lI6A7o00000olA4A401olZ4@So4A4AoaTI4OlZ4@So8R8Ao`000?lZ4@P0
2?lA4A400olZ4@So6ATAobXA2005oa4A4@04oaTI4Ol0003o4A4AoaTI4@Co
4A4A0_lZ4@P4oa4A4@05o`000?lI6A7o:Q48oa4A4OlZ4@P00_lA4A401_lI
6A7o4A4AobXA2?lA4A7o0000obXA20?o4A4A00Co:Q48o`000?lA4A7o:Q48
0_lA4A42oaTI4@03oa4A4OlZ4@So4A4A00;o4A4A00Go:Q48oa4A4OlI6A7o
4A4AoaTI4@02ob8R4@04oaTI6OlR8Q7o8R8AoaTI4@?o8R8A00?o6ATAob8R
4OlR8Q400_lI6AT01OlR8Q7o6ATIoaTI4OlI6A7o4A4A0:Cok^k^001JonKV
iP;o4A4A00Go0000oa4A4OlA4A7o4A4AoaTI6@09oa4A4@05o`000?lA4A7o
4A4Aoa4A4OlI6AT00olA4A400olI6AWo4A4Aoa4A4@0>oa4A4@06oc8Z8_lA
4A7o4A4Aoa4A4OlI6A7o00003?lA4A400olI6A7o0000oaTI6@03oa4A4@03
oaTI4OlA4A7o4A4A00[o4A4A0_l00006oa4A4@08o`000?lA4A7o0000o`00
0?lA4A7o0000oa4A4Ol00005oa4A4@03o`000?lA4A7o000000;o4A4A00Go
0000oa4A4Ol0003o:Q48o`000004oa4A4@05o`000?lA4A7o4A4Aoa4A4Ol0
00000olA4A401OlZ4@So4A4Aoa4A4OlZ4@So4A4A00?o6ATA00Co:Q48oa4A
4OlZ4@So6ATA0_lA4A401?lI6A7o4A4AoaTI4OlA4A42oaTI4@;o8R8A00?o
6ATAob8R4OlA4A400_lZ4@P2oa4A4@?o6ATA00?o4A4AoaTI6OlA4A401?lA
4A400olR8Q7o0000oaTI4@02oaTI6@0=o`000?lI6A7o4A4AoaTI4OlR8Q7o
6ATIoa4A4OlI6A7o:R8Iob8R4OlI6A7o8RXZoaTI4@02ob8R4@05oaTR8_lR
8Q7o8R8AoaTR8_lZ8QT00_lR8Q400olI6AWo:Q48obXR6@03oaTI4@0;obXR
6OlI6AWo8R8AobXR6OlI6A7o8R8AobXR6OlI8R;o8R8AobXR6OlI6A400olZ
8QT01?lR8Q7o:R8Iob8R4OlR:RX3obXR6@;o6ATA0olR8Q402olR:R[o:R8I
obXR6OljA1Wo:Q48ocXj8_lR<R[o6ATAobXA2?lI6A7o000000;o4A4A00So
0000oa4A4OlI6A7o0000oa4A4OlI6A7o0000oaTI4@?o4A4A00_o0000oa4A
4OlA4A7o4A4Ao`000?lZ4@So0000obXA2?lI6A7o:Q48ob8R4@02obXR6@0E
ob8R4OljA1Wo8R8AoaTI4Olj>R;o:R8Ioc8Z8_lR8Q7o6ATIobXR6OlR8Q7o
>SXRob8R4OlZ8QWo4A4Ao`000?lZ4@So4A4Ao`000?lA4A7o000000?o4A4A
00Ko:Q48oaTI4OlA4A7o4A4AoaTI4Ol00002oa4A4@03obXA2?lA4A7o4A4A
00Co4A4A00Wo:Q48oaTI4OlI6A7o0000oaTI4OlA4A7o6ATAoa4A4OlI6A40
0_lA4A400olZ4@So6ATAoa4A4@03oa4A4@05obXA2?lI6A7o4A4AobXA2?lI
6A400_lZ4@P03_lI6A7o4A4AobXA2?lI6A7o:Q48oa4A4OlZ4@So4A4AobXA
2?lA4A7o:Q48ob8R4Ol0003o6ATA0_lR8Q400olI6AWo8R8Aoa4A4@02oaTI
4@03ob8R4OlA4A7o6ATI00;o8R8A00?o4A4Aob8R4OlZ8QT00_lb:R:TonKV
iP00F_o^k^h01?l0003o4A4Aoa4A4Ol00008oa4A4@03oaTI6OlA4A7o4A4A
00Go4A4A00So0000oa4A4OlA4A7o4A4AoaTI6OlA4A7o0000oaTI6@Go4A4A
00?o6ATIoa4A4OlI6AT03?lA4A401?lI6A7o4A4Aoa4A4OlI6AT2oa4A4@04
o`000?lI6A7o4A4AoaTI4@[o4A4A00?o0000oa4A4OlA4A400_lA4A401?l0
003o4A4Aoa4A4Ol00003oa4A4@03o`000?lI6A7o000000;o4A4A00?o0000
oa4A4OlA4A401_lA4A401?l0003o4A4Aoa4A4Ol00002oa4A4@05o`000?lA
4A7o0000oa4A4Ol000000_lA4A401_l0003o4A4Aoa4A4Ol0003o4A4Ao`00
00Ko4A4A00So:Q48oa4A4OlA4A7o6ATAoa4A4OlI6A7o:Q48oa4A4@;o6ATI
00go4A4AoaTI4OlA4A7o6ATAoaTI6OlI6A7o8R8AoaTI6OlR8Q7o6ATAobXR
6OlI6AWo8R8A00?o4A4A00?o:Q48oa4A4OlI6A400_lA4A401OlZ4@So4A4A
oaTI4OlI6A7o:R8I00;o:Q4800Co4A4AoaTI4OlI6A7o8R8A0olI6A401OlR
8Q7o6ATAoaTI4OlI6A7o8R8A00;o6ATI00Ko:R8Iob8R4OlI6AWo8R8AobXR
6OlI6AT2obXR6@0DoaTI4OlZ4@So>SXboaTI4OlR8Q7o:R8IoaTI4OlZ8QWo
8R8AoaTI6OlR8Q7o6ATIobXR6OlR8Q7o6ATIob8R4OlI6A7o6B8RobXR6OlI
6A42ob8R4@03obXR6OlI8R;o8R8A00;o:R8I00Wo8R8AoaTR8_lZ8QWo6B8R
ob8R4Olb:R;o6ATAob8Z:_lR8Q400olZ8QT02Olb:R;o:R8IobXR6OlZ8QWo
8R8Aoc8Z8_lA4A7o0000oaTI4@09oa4A4@05obXA2?l0003o4A4Aoa4A4Ol0
00000_lA4A401_lZ4@So6ATAob8R4Om4>R[o<RXRob8Z:P?o<RXR00?o6ATA
ob8R4OlI6AT00olR8Q401olZ8QWo8R8Aob8R4OlZ4@So:R8Iob8R4Olb:R80
0_lR8Q401?lb:R;o:Q48ob8R4OlZ4@P2oa4A4@;o6ATA00Co:Q48oa4A4OlA
4A7o:Q480_lA4A401Ol0003o:Q48o`000?lA4A7o:Q4800;o4A4A00Go:Q48
oa4A4OlZ4@So4A4AobXA2003oa4A4@09o`000?lZ4@So4A4AoaTI4OlZ4@So
0000oa4A4OlI6A7o:Q4800?o4A4A017o:Q48oa4A4OlR8Q7o:Q48oaTI4OlA
4A7o:Q48oa4A4OlR8Q7o4A4AoaTI4OlA4A7o:Q48oa4A4OlI6A7o8R8AobXA
2002oaTI4@05ob8R4OlI6A7o:Q48oaTI4OlI6AT00_lR8Q42oaTI4@08ob8R
4OlI6A7o:R8Ioa4A4OlR8Q7o4A4AobXA2?lI6A44oc8Z8P03ocXj8_ljA1Wo
k^k^0:?ok^k^001Jooooo`04o`000?lA4A7o0000o`0000co4A4A00Co6B8R
oa4A4OlA4A7o4A4A0_lI8R800olI6AWo4A4Aoa4A4@02oaTI6@?o4A4A00?o
6ATIoa4A4OlA4A400olA4A400olI6AWo4A4Aoa4A4@07oa4A4@03oaTI6OlA
4A7o4A4A00;o6ATI00?o4A4AoaTI6OlA4A401OlA4A400olI6A7o4A4Aoa4A
4@0=oa4A4@03o`000?lA4A7o4A4A00?o4A4A00Co0000oa4A4OlA4A7o0000
0olA4A402Ol0003o4A4Ao`000?lA4A7o0000oa4A4Ol0003o4A4Ao`000002
oa4A4@04o`000?lA4A7o4A4AobXA20Co4A4A00?o0000oa4A4Ol000000olA
4A400olZ4@So0000oaTI4@0:oa4A4@03oaTI4Ol0003o6ATA00?o6ATA00Go
6ATIoaTI4OlI6AWo4A4AoaTI4@02oa4A4@?o6ATA00Co6ATIobXA2?lA4A7o
4A4A0olI6A401?lI6AWo8R8AobXA2?lI6A42ob8R4@05oaTI6OlI6A7o6ATA
obXR6OlI6A400_lI6AT2oaTI4@04ob8R4OlZ8QWo6ATIob8R4@;o6ATI00ko
8R8AobXR6OlR8Q7o6ATIob8R4OlZ8QWo:Q48oaTI4OlR8Q7o6ATIob8R4OlR
<R[o:R8IoaTI6@?o8R8A00?o6B8RoaTI6OlR8Q400_lZ8QT00olI8R;o6ATA
obXR6@04obXR6@04ob8b:_lZ8QWo6ATIob8R4@?o:R8I00?o8RXZob8R4OlR
8Q401_lZ8QT3oc8Z8P03ocY46OlZ8QWo8RXZ00;o4A4A00?o0000oa4A4OlA
4A401?lA4A401OlI6A7o:Q48oa4A4OlA4A7o:Q4800Ko4A4A00Co:Q48oaTI
4Olb:R;oA4@b0olb:R801?lR:R[o6ATAoaTI4OlR8Q42oaTI4@Go8R8A00Go
:R8Ioc8Z8_lb:R;o:Q48oaTI4@02ob8R4@;o4A4A00Oo0000oaTI4OlA4A7o
4A4AobXA2?lA4A7o000000;o4A4A00?o:Q48oa4A4OlA4A400_lA4A400olI
6A7o:Q48oa4A4@02oaTI4@04obXA2?l0003o6ATAobXA20?o4A4A00Ko6ATA
oa4A4OlI6A7o6ATAoa4A4OlI6A42oa4A4@03obXA2?lA4A7o4A4A00;o:Q48
00?o4A4AoaTI4OlZ4@P00_lI6A400olR8Q7o:Q48oa4A4@02oaTI4@03obXA
2?lI6A7o:R8I00;o4A4A00Go:Q48oa4A4OlI6A7o:Q48oaTI4@02ob8R4@05
oaTI6OlR8Q7o:Q48obXA2?lI6AT00_lR8Q402OlA4A7o8R8AobXA2?lZ8QWo
<RXRobXR6Olb:R;oA3XZoc8Z8P02obXR6@03oc8Z8_lj>R;o:Q480:Cooooo
001Jonk^kP04oa4A4Ol0003o4A4Ao`0000Wo4A4A00Ko6ATIoa4A4OlA4A7o
8RXZoa4A4OlI8R82oa4A4@03oaTI6OlA4A7o6ATI00Co4A4A00Co6ATIoa4A
4OlA4A7o6ATI0olA4A400olI6AWo4A4Aoa4A4@02oa4A4@03oaTI6OlA4A7o
4A4A00Co4A4A00?o6ATAoa4A4OlA4A400olA4A400olI6AWo4A4Aoa4A4@02
oaTI4@;o4A4A0_lI6A4;oa4A4@03o`000?lA4A7o4A4A00?o4A4A00Go0000
oa4A4OlA4A7o4A4Ao`000003oa4A4@03o`000?lA4A7o4A4A00Oo4A4A00Co
0000oa4A4OlA4A7o00000_lA4A401_l0003o4A4Aoa4A4OlZ4@So4A4AoaTI
4@?o4A4A0_l000001?lA4A7o0000obXA2?lI6AT3oa4A4@04obXA2?lI6A7o
4A4AobXA20;o4A4A00Ko:Q48oa4A4OlR8Q7o6ATAoa4A4OlI6A42oaTI6@08
oaTI4OlA4A7o4A4AoaTI4OlR8Q7o6ATAob8R4OlZ4@P2oaTI4@03ob8R4OlA
4A7o8R8A00;o6ATA013o8R8AoaTI4OlI6A7o6ATAoaTI6OlI6A7o8R8AoaTI
6OlI6A7o:R8IoaTI4OlZ8QWo6ATAobXR6OlI6AWo6ATA0_lR8Q400olI6AWo
8R8AoaTI6@03ob8R4@04oaTI6OlR8Q7o6ATIobXR6@;o8R8A00_o:R8Iob8Z
:_lI8R;o:R8IoaTR8_lZ8QWo6B8RobXR6OlR8Q7o6ATIob8R4@03obXR6@04
oaTR8_lZ8QWo8R8AoaTI6@;o:R8I00Go6B8RobXR6OlZ8QWo:R8Iob8R4@02
obXR6@04oc8Z8_lR8Q7o:R8Iob8b:P;o:R8I00So8RXZobXR6OlZ8QWo8R8A
obXA2?lR8Q7o4A4AobXA20?o4A4A00co:Q48oa4A4OlA4A7o:Q48oa4A4OlI
6A7o0000oa4A4OlZ4@So0000oa4A4Ol00003oa4A4@07obXA2?lZ8QWoA4@b
ocY46OlZ4@So8R8AobXR6@02ob8R4@07oaTI4OlR8Q7o8R8AoaTI6OlZ8QWo
:Q48oaTI4@02ob8R4@04oaTI4OlZ8QWo:Q48ob8R4@;o6ATA0_lA4A400olZ
4@So4A4AobXA2002oaTI4@03obXA2?lI6A7o6ATA00;o4A4A0_lZ4@P00olI
6A7o4A4AobXA2004oa4A4@0>obXA2?l0003o:Q48oaTI4OlA4A7o6ATAoa4A
4OlZ4@So4A4AobXA2?lA4A7o:Q48oaTI4OlZ4@P2oa4A4@0?obXA2?lA4A7o
:Q48ob8R4OlI6A7o:Q48oa4A4OlZ4@So6ATAoa4A4OlZ4@So6ATAobXA2?lI
6A7o:Q4800;o8R8A00Ko4A4AobXA2?lZ4@So8R8AoaTI4OlR8Q42oaTI4@?o
8R8A00?o6ATAob8R4OlI6AT00olI6A402?lR8Q7o6ATAob8R4OlZ8QWo6B8R
obXR6OlR8Q7o:R8I0_lI6A42oaTI6@04ob8R4OlZ8QWo6ATAoa4A4JCok^k^
001JonKViP05o`000?lA4A7o0000oa4A4Ol000001_lA4A401?lI6AWo0000
oaTI6OlA4A46oaTI6@Wo4A4A00Go6ATIoa4A4OlA4A7o4A4AoaTI6@0:oa4A
4@03oaTI4OlA4A7o4A4A00?o4A4A00Ko6ATIoa4A4OlA4A7o4A4AoaTI6Ol0
0003oa4A4@03o`000?lA4A7o000000;o4A4A00?o0000oa4A4OlA4A401olA
4A400ol0003o4A4Ao`000002oa4A4@04o`000?lA4A7o4A4Aoa4A4@;o0000
0_lA4A401ol0003o4A4Aoa4A4OlA4A7o0000oa4A4Ol000000olA4A401?l0
003o4A4Aoa4A4Ol00002oa4A4@07o`000?lA4A7o0000oaTI4Ol0003o4A4A
o`000003oa4A4@;o00000_lA4A400olZ4@So4A4AoaTI4@02oa4A4@03oaTI
4OlA4A7o4A4A00Go4A4A00Oo6ATIoa4A4OlR:R[o0000oaTI6OlR8Q7o4A4A
00;o6ATA0olA4A401olZ4@So4A4Aoa4A4OlA4A7o6ATAoa4A4OlI6AT00_lI
6A402_lZ4@So6ATAob8R4OlR8Q7o6ATIoaTI4OlA4A7o6ATAoaTI6OlA4A42
oaTI4@07obXA2?lI6A7o:R8IoaTI6OlR8Q7o6ATIob8R4@02oaTI6@03ob8R
4OlZ8QWo6ATI00;o8R8A00Co:R8IoaTR8_lR8Q7o8R8A0olZ8QT00olR8Q7o
:R8Iob8R4@02obXR6@08ob8Z:_lR8Q7o:R8Iob8R4Olb:R;o6B8RobXR6Olb
:R82obXR6@;o>SXR00Wo<RXRobXR6OlR8Q7o<RXRob8R4OlZ8QWo<RXRobXR
6OlI6A400_lR8Q42oaTI4@Co4A4A00?o0000oa4A4OlZ4@P00_lI6A401OlA
4A7o6ATAoa4A4OlA4A7o:Q4800Oo4A4A00Oo6ATAoaTI6Olb:R;o:R8Io`00
0?lb:R;o8R8A00?o:R8I0_lR8Q402olZ8QWo6B8RobXR6OlZ4@So8R8Aoa4A
4OlZ4@So8R8AoaTI4OlZ4@So6ATA00;o4A4A00Wo:Q48oa4A4OlZ4@So0000
oa4A4OlI6A7o0000oaTI4Ol000000olA4A400olZ4@So4A4Aoa4A4@02oa4A
4@03obXA2?lA4A7o:Q4800;o:Q4800?o4A4AoaTI4OlI6A400_lA4A400olZ
4@So6ATAoaTI4@03oaTI4@05oa4A4OlI6A7o4A4Aoa4A4OlZ4@P00olI6A40
1olA4A7o6ATAoaTI4OlZ4@So6ATAoa4A4OlZ4@P00_lR8Q401?lA4A7o:Q48
ob8R4OlZ4@P2oaTI4@04obXA2?lR8Q7o6ATAob8R4@;o6ATA00Oo:Q48oa4A
4OlI6A7o6ATAob8R4OlI6A7o8R8A00?o6ATA00oo8R8AoaTI4OlR8Q7o6ATA
ob8R4OlI6A7o8R8AoaTI4OlR8Q7o6ATAoa4A4OlZ4@So4A4AoaTI4OlI6AT0
0_lI6A6TonKViP00F_o^k^h3oa4A4@05o`000?lA4A7o4A4AoaTI6OlI6A40
1?lA4A400olI6AWo4A4AoaTI6@02oa4A4@03oaTI6Ol0003o4A4A00;o4A4A
00Co6ATIoa4A4OlA4A7o6ATI0olA4A401?lI6AWo4A4Aoa4A4OlI6AT5oa4A
4@03oaTI6OlA4A7o6ATI00Ko4A4A00?o6ATAoa4A4OlA4A402OlA4A400ol0
003o4A4Aoa4A4@06oa4A4@03o`000?lA4A7o000000;o4A4A00?o0000oa4A
4OlA4A400_lA4A401Ol0003o4A4Aoa4A4OlA4A7o000000?o4A4A00Co0000
oa4A4Ol0003o4A4A0ol000001?lA4A7o0000oa4A4Ol00002oa4A4@06o`00
0?lA4A7o4A4Ao`000?lA4A7o00000_lA4A400ol0003o4A4Aoa4A4@02oa4A
4@?o00001?lA4A400olI6A7o4A4Aoa4A4@03oa4A4@0:oaTI4OlZ4@So4A4A
oaTI4OlZ4@So4A4AoaTI6OlI6A7o4A4AobXA20Ko4A4A0_lI6A402?lA4A7o
6ATAobXA2?lZ4@So4A4AoaTI4OlZ4@So4A4A0_lI6A42oa4A4@08oaTI4OlR
8Q7o6ATAobXA2?lI6A7o:Q48oaTI4OlZ4@P3oaTI4@05ob8R4OlI6A7o:R8I
ob8R4OlI8R800_lR8Q402?lI6AWo8R8Aob8R4OlR8Q7o6ATIob8R4OlZ8QWo
6B8R1_lR8Q401OlZ8QWo8R8Aoc8Z8_m4>R[o6ATA00;o8R8A00Co6ATAoaTI
6OlZ8QWo8RXZ0_lR8Q403olI6A7o8R8Aoa4A4OlA4A7o6ATAoa4A4OlZ4@So
0000oa4A4Ol0003o:Q48oa4A4Ol0003o6ATAo`000004oa4A4@09oaTI4OlA
4A7o4A4Aoa4A4Ol0003o4A4Ao`000?lI6A7o000000;o4A4A00?o0000oaTI
4OlA4A400olA4A400olI6A7o:Q48ob8R4@02ob8R4@?o6ATA00?o8R8AodA4
<_lb:R800_lR8Q401OlZ4@So8R8Aoa4A4OlR8Q7o6ATA00?o4A4A00?o6ATA
oa4A4OlZ4@P00_lA4A403ol0003o4A4Aoa4A4OlA4A7o:Q48oa4A4OlI6A7o
4A4AoaTI4OlA4A7o:Q48obXR6OlA4A7o6ATAobXA2002oa4A4@03oaTI4OlA
4A7o4A4A00Co4A4A00ko6ATAoa4A4OlA4A7o6ATAoa4A4OlI6A7o4A4AobXA
2?lb:R;o6ATAobXA2?lI6A7o4A4AoaTI4@;o4A4A0_lZ4@P2oa4A4@06oaTI
4OlZ4@So:Q48oa4A4Ol0003o:Q480olA4A403?lI6A7o:Q48oaTI4OlZ4@So
4A4AobXA2?lA4A7o:Q48oa4A4OlZ4@So6ATAob8R4@Co6ATA00[o8R8AobXA
2?lI6A7o:Q48oaTI4OlZ4@So4A4Aob8R4OlI6A7o8R8A0olI6A401_lR8Q7o
6ATAoaTI6OlI6A7o:R8Iob8R4JCok^k^001Jooooo`08oa4A4Ol0003o0000
o`000?lA4A7o0000oaTI6OlZ8QT5oa4A4@03oaTI6OlA4A7o4A4A00;o4A4A
00?o6ATIoa4A4OlA4A400_lA4A402?lI6AWo4A4Ao`000?lI6AWo4A4AoaTI
6OlA4A7o6ATI1?lA4A400olI6AWo4A4Aoa4A4@02oa4A4@04oaTI6OlA4A7o
4A4AoaTI6@_o4A4A00?o0000oa4A4OlA4A402?lA4A400olI6AWo4A4Aoa4A
4@0:oa4A4@03o`000?lA4A7o000000?o4A4A00?o0000obXA2?lA4A401?lA
4A401_l0003o4A4Aoa4A4Ol0003o4A4Ao`0000?o4A4A00?o0000oa4A4OlA
4A400olA4A401?l0003o4A4Aoa4A4OlA4A42o`0000;o4A4A0_l000001OlA
4A7o6ATAoa4A4OlA4A7o:Q4800?o4A4A0_lI6A43oa4A4@0:oaTI6OlA4A7o
4A4Aoa4A4OlI6A7o:Q48oa4A4OlI6A7o8R8AobXA20?o4A4A00?o:Q48oa4A
4OlI6A400olA4A401OlI6A7o:Q48oaTI4OlA4A7o:Q4800?o4A4A00?o:Q48
oa4A4OlA4A400olA4A402?lZ4@So4A4AobXA2?lI6A7o:R8IoaTI4OlR8Q7o
:Q480_lI6A402olZ4@So6ATAoa4A4OlI6A7o:Q48o`000?lI6A7o:Q48oaTI
4OlA4A7o6ATA00Wo4A4A00?o0000oaTI4OlZ4@P01?lA4A42oaTI4@03oa4A
4OlZ4@So4A4A00;o4A4A00?o6ATAoa4A4OlZ4@P01OlA4A401OlZ4@So4A4A
oa4A4OlZ4@So000000Go4A4A00?o:Q48oa4A4OlA4A401?lA4A401Ol0003o
:Q48oa4A4Ol0003o:Q4800?o4A4A00?o0000oaTI4OlZ4@P00_lA4A403?l0
003o4A4Ao`000?lA4A7o:Q48oa4A4OlI6A7o4A4Ao`000?lI6A7o4A4AobXA
20?o4A4A00Co:Q48oa4A4OlI6A7o:Q481?lA4A400ol0003o6ATAobXA2002
oa4A4@03oaTI6OlZ4@So4A4A00;o4A4A00Go:Q48oa4A4OlA4A7o6ATAoa4A
4@02obXA20;o4A4A0_lZ4@P00olI6A7o:Q48oa4A4@03oa4A4@03oaTI4Ol0
003o4A4A00;o6ATA0_lZ4@P3oa4A4@;o:Q4800Co0000oaTI4OlA4A7o4A4A
0_lZ4@P00olA4A7o:Q48oa4A4@08oa4A4@;o6ATA00So8R8AoaTI4OlI6A7o
:Q48oa4A4OlR8Q7o6ATIob8R4@Ko6ATA00Go6ATIoaTI4OlI6A7o8R8Aoa4A
4@02ob8R4@03obXR6Olb:R;o6ATA0:Cooooo001Jonk^kP04oa4A4Ol0003o
4A4Ao`0000Ko4A4A0_lI6AT00olA4A7o6ATIoaTI6@0:oa4A4@03oaTI6OlA
4A7o6ATI00Go4A4A00?o6ATAoa4A4OlA4A401olA4A400olI6A7o4A4AoaTI
4@02oa4A4@03oaTI6Ol0003o4A4A00Ko4A4A00?o0000oa4A4OlA4A400olA
4A401?l0003o:Q48oa4A4OlZ4@P2oa4A4@04o`000?lA4A7o4A4Ao`0000?o
4A4A00?o0000oa4A4OlA4A401?lA4A400ol0003o4A4Aoa4A4@03o`000005
oa4A4Ol0003o4A4Aoa4A4Ol000000_lA4A401?l0003o4A4Ao`000?lA4A42
o`000004oa4A4Ol0003o6B8Ro`0000Co4A4A00Go0000oa4A4OlA4A7o0000
oa4A4@03o`0000Go4A4A00?o:Q48oaTI4OlA4A401?lA4A401OlI6A7o4A4A
oaTI4OlA4A7o000000;o4A4A00?o0000oa4A4Ol000000olA4A401OlI6A7o
0000oa4A4OlA4A7o:Q4800Wo4A4A00Co0000oa4A4Ol0003o:Q481_lA4A40
1Ol0003o4A4AoaTI4OlA4A7o000000;o4A4A00Wo0000oa4A4Ol0003o4A4A
oaTI4Ol0003o6ATAoa4A4Ol000002OlA4A401OlI6A7o4A4AoaTI4Ol0003o
:Q4800Co4A4A00Go6ATAoa4A4OlA4A7o:Q48oaTI4@09oa4A4@03oaTI4Ol0
003o:Q4800Co4A4A00?o:Q48oa4A4OlA4A400_lA4A401OlZ4@So4A4Aoa4A
4OlZ4@So6ATA00Wo4A4A00Go0000oa4A4OlI6A7o:Q48oaTI4@02oa4A4@;o
6ATA00?o4A4AobXA2?lA4A401_lA4A402OlI6A7o4A4AoaTI4OlI6A7o4A4A
obXA2?lI6A7o:Q48oa4A4@02oaTI4@04obXA2?lA4A7o4A4Aob8R4@;o6ATA
0olA4A402OlZ4@So4A4AobXA2?lR8Q7o6ATAob8R4Ol0003o:Q48oaTI4@03
oa4A4@03obXA2?lA4A7o4A4A00;o4A4A00Wo:Q48oaTI4OlA4A7o:Q48oaTI
4OlA4A7o:Q48oa4A4OlZ4@P00olA4A401OlZ4@So4A4AobXA2?lI6A7o4A4A
00;o6ATA0_lA4A401_lZ4@So6ATAobXA2?lI6A7o8R8AoaTI4@?o8R8A00Co
6ATAob8R4OlI6AWo6ATA0_lR8Q400olZ4@So6ATAobXA2002oaTI4@04oa4A
4OlZ4@So6ATAoaTI4@;o8R8A00Oo6ATAoc8Z8_lR8Q7o:R8Iob8R4OlI6AWo
8R8A0:Cok^k^001JonKViP04oa4A4Ol0003o4A4Ao`0000;o4A4A00?o6ATI
oa4A4OlA4A400olA4A401?lI6AWo4A4Aoa4A4OlA4A42oaTI6@?o4A4A1?lI
6AT;oa4A4@03oaTI4OlA4A7o4A4A00?o4A4A00?o0000oa4A4Ol000001olA
4A400olI6A7o0000oa4A4@05oa4A4@03o`000?lA4A7o4A4A00co4A4A00Oo
0000oa4A4OlA4A7o4A4Ao`000?lA4A7o000000;o4A4A00So0000oa4A4OlA
4A7o0000oa4A4Ol0003o4A4Ao`0000;o4A4A00?o0000oa4A4Ol000000_lA
4A401?l0003o:Q48o`000?lA4A42obXR6@05o`000?lA4A7o4A4Ao`000?lZ
4@P00_lA4A400ol0003o4A4AoaTI4@03oa4A4@03o`000?lA4A7o4A4A00;o
4A4A00?o0000oaTI4Ol000000olA4A400ol0003o4A4Ao`000003oa4A4@03
o`000?lA4A7o4A4A00?o4A4A00Go0000oa4A4Ol0003o4A4Ao`000003oa4A
4@05o`000?lA4A7o0000obXA2?l000001_lA4A401Ol0003o4A4Aoa4A4OlA
4A7o000000;o4A4A00?o:Q48oa4A4Ol000000olA4A400ol0003o4A4AobXA
2002oa4A4@03oaTI4OlA4A7o4A4A00?o4A4A00?o:Q48oa4A4OlZ4@P01olA
4A402olZ4@So6ATAoaTI4OlA4A7o:Q48oa4A4OlI6A7o4A4AoaTI4OlA4A7o
000000?o4A4A00Wo:Q48oaTI4OlA4A7o4A4AobXA2?lI6A7o:Q48oaTI4OlA
4A400_lI6A401_lA4A7o:Q48oa4A4OlA4A7o6ATAoa4A4@;o6ATA0_lA4A40
0olI6A7o4A4Aoa4A4@04oa4A4@04oaTI4OlA4A7o4A4AoaTI4@Co4A4A00Go
0000oaTI4OlA4A7o6ATAobXA2003oa4A4@09oaTI4OlA4A7o:Q48obXA2?lI
6A7o:Q48oa4A4OlI6A7o:Q4800Co4A4A00Co6ATAoa4A4OlI6A7o6ATA0_lA
4A42obXA20?o4A4A00?o:Q48oa4A4OlI6A400_lI6A42oa4A4@;o6ATA00?o
4A4AobXA2?lA4A400olI6A401OlA4A7o6ATAobXA2?lI6A7o:Q4800;o4A4A
00Go:Q48oaTI4OlI6A7o4A4Aob8R4@02obXA20Co4A4A00go:Q48oaTI4OlA
4A7o:Q48obXR6OlA4A7o:Q48oaTI4OlR8Q7o6ATAobXA2?lI6A7o8R8A00;o
6ATA00Oo8R8AoaTI4OlI6AWo6ATAobXA2?lR8Q7o6ATI00Go6ATA00Co:Q48
oaTI4OlA4A7o8R8A0_lZ8QT01?lb:R;o8S8ZobXR6OlI6AT2ob8R4@03ob8b
:_lI6A7oi^KV0:?oi^KV001Jonk^kP05o`000?lA4A7o4A4Aoa4A4Ol00000
1olA4A401?lI6AWo4A4Aoa4A4OlI6AT4oa4A4@03oaTI6OlA4A7o4A4A00;o
4A4A00Go6ATIoa4A4OlA4A7o4A4AoaTI6@07oa4A4@03oaTI6OlA4A7o4A4A
00_o4A4A0_lI6A46oa4A4@03o`000?lA4A7o4A4A00Ko4A4A00Go6ATAoa4A
4OlA4A7o4A4Ao`00000:oa4A4@05o`000?lA4A7o0000o`000?lZ4@P01OlA
4A400ol0003o4A4Aoa4A4@03oa4A4@03o`000?lA4A7o000000;o4A4A00Go
<RXRoa4A4OlA4A7o4A4AobXA2004oa4A4@04ocXj<_l0003o4A4Ao`0000Ko
4A4A00Go6ATAoa4A4OlA4A7o4A4Ao`000005oa4A4@09o`000?lA4A7o4A4A
oa4A4Ol0003o4A4Ao`000?lA4A7o000000?o4A4A00?o:Q48oa4A4Ol00000
1?lA4A400ol0003o4A4Aoa4A4@02oa4A4@03o`000?lA4A7o4A4A00;o4A4A
00Co6ATAoa4A4OlA4A7o:Q481OlA4A400olZ4@So4A4AobXA2007oa4A4@03
obXA2?lA4A7o:Q4800?o4A4A00Ko6ATAoa4A4OlI6A7o:Q48oa4A4OlI6A43
oa4A4@;o6ATA1?lA4A401_lZ4@So6ATAobXA2?lZ4@So4A4AobXA20;o4A4A
00Co6ATAoa4A4OlA4A7o6ATA1OlA4A401?lZ4@So4A4AobXA2?lZ4@P2oa4A
4@04obXA2?lA4A7o6ATAobXA20?o4A4A00?o:Q48oaTI4OlA4A401?lA4A40
0olZ4@So4A4Aoa4A4@02oa4A4@03obXA2?lA4A7o:Q4800?o4A4A00?o8R8A
oa4A4OlA4A400_lI6A402_lA4A7o6ATAoa4A4OlZ4@So4A4AoaTI4OlZ4@So
4A4AoaTI4OlZ4@P2oa4A4@03oaTI4OlA4A7o4A4A00?o6ATA0_lA4A400olI
6A7o:Q48oa4A4@02oa4A4@;o6ATA00So:Q48oa4A4OlA4A7o6ATAoa4A4OlI
6A7o4A4AobXA20;o4A4A1?lI6A400olZ4@So4A4Aoa4A4@07oa4A4@;o:Q48
00?o4A4AobXA2?lA4A400_lI6A401OlA4A7o6ATAob8R4OlZ4@So4A4A00;o
6ATA00Go:R8IoaTI4OlR8Q7o4A4AoaTI4@03oa4A4@?o6ATA00?o8R8AobXA
2?lI6A401OlI6A401_lZ8QWo6B8RobXR6OlI8R;o:Q48oa4A4@;o6ATA0_lA
4A400ol0003ok^k^onk^kP2Ronk^kP00F_ooool01Ol0003o4A4Aoa4A4OlA
4A7o000000Ko4A4A00Ko6B8Roa4A4OlA4A7o6ATIoa4A4OlI6AT2oa4A4@04
oaTI6OlA4A7o6ATIoa4A4@;o6ATI1OlA4A400ol0003o4A4Aoa4A4@03oa4A
4@04o`000?lA4A7o4A4AoaTI6@[o4A4A00Go0000oa4A4Ol0003o4A4Ao`00
0002oa4A4@07o`000?lA4A7o4A4AobXA2?l0003o4A4Ao`000002oa4A4@03
o`000?lA4A7o000000Ko4A4A00So0000oa4A4Ol0003o0000oa4A4Ol0003o
:Q48o`0000?o4A4A00Co0000oa4A4Ol0003o4A4A0ol00002oa4A4@Go0000
0_lA4A401?l0003o4A4Aoa4A4Ol00003oa4A4@05o`000?lZ4@So0000oc8Z
8_lR<RX00olA4A42o`000003obXA2?lI6A7o:Q4800Go4A4A0_l00002oa4A
4@03o`000?lA4A7o4A4A00;o4A4A00Go0000oa4A4OlA4A7o:Q48o`000002
oa4A4@03o`000?lA4A7o000000?o4A4A00?o0000oa4A4Ol000001?lA4A40
1ol0003o4A4Aoa4A4Ol0003o:Q48oa4A4Ol000000olA4A400ol0003o4A4A
oa4A4@06oa4A4@03oaTI4OlA4A7o:Q4800?o4A4A00?o6ATAobXA2?lA4A40
0_lA4A400olI6A7o4A4AobXA2002oa4A4@04obXA2?lA4A7o6ATAob8R4@?o
4A4A00co:Q48oa4A4OlI6A7o6ATAoa4A4OlI6A7o4A4AoaTI4OlA4A7o6ATA
oa4A4OlI6A42oa4A4@03obXA2?lA4A7o4A4A00;o4A4A00Wo:Q48oa4A4OlA
4A7o6ATAo`000?lI6A7o4A4AobXA2?lI6A400olA4A402?lZ4@So4A4Aoa4A
4OlA4A7o0000obXA2?lA4A7o6ATA0olA4A400olZ4@So6ATAobXA2005oa4A
4@0@obXA2?lA4A7o:Q48oaTI4OlZ4@So4A4AoaTI4OlZ4@So4A4AoaTI4OlA
4A7o:Q48oa4A4OlI6A7o:Q48oa4A4@;o8R8A00Co:Q48oa4A4OlI6A7o4A4A
0_lI6A401ol0003o:Q48oa4A4OlI6A7o0000oaTI4OlZ4@P00olA4A401ol0
003o4A4AobXA2?lA4A7o:Q48oa4A4OlI6A401olA4A402_lI6A7o4A4Aoa4A
4OlI6A7o:Q48oa4A4OlZ4@So4A4AobXA2?lA4A42ob8R4@0AobXA2?lA4A7o
4A4Aoa4A4OlZ4@So4A4AobXA2?lI6A7o4A4AobXA2?lA4A7o:Q48oa4A4OlI
6A7o6ATIoa4A4OlZ4@P00_lA4A401OlZ4@So4A4Aoa4A4OlZ4@So6ATA00;o
4A4A00Co:Q48oa4A4OlA4A7o6ATA0olA4A401?lI6A7o8R8AoaTI4OlR8Q42
oaTI4@03ob8R4OlZ8QWo6ATA0:Cooooo001Jonk^kP?o4A4A00Co0000oa4A
4OlA4A7o6ATI0_lA4A43oaTI6@06oa4A4OlI8R;o6ATIoaTI6OlA4A7o6B8R
1?lA4A400olI6AWo4A4Aoa4A4@02oa4A4@03oaTI4OlA4A7o4A4A00?o4A4A
00?o0000oa4A4OlA4A401?lA4A400ol0003o4A4Aoa4A4@0Eoa4A4@03o`00
0?lA4A7o4A4A00?o4A4A00?o0000oa4A4OlA4A400_lA4A401ol0003o4A4A
oa4A4Ol0003o4A4Ao`000?lA4A400_l00002oa4A4@03o`000?lA4A7o0000
00;o4A4A00Co0000oa4A4OlZ4@So00001OlA4A42o`000005oa4A4Ol0003o
4A4Aoa4A4OlI6A401?lA4A401ol0003oC4a4oaTR8_l0003o6ATAoa4A4Ol0
00001?lA4A401?l0003o4A4AoaTI6Ol00003oa4A4@05o`000?lA4A7o4A4A
oa4A4Ol000000_lA4A401OlZ8QWo0000oa4A4Ol0003o:Q4800Ko4A4A00Co
0000oa4A4OlA4A7o:Q481olA4A400olI6A7o4A4Aoa4A4@02oa4A4@05obXA
2?lA4A7o4A4Aoa4A4OlZ4@P00_lA4A401?lZ4@So4A4Aoa4A4OlZ4@P2oa4A
4@;o6ATA00?o4A4AobXA2?lZ4@P01?lI6A402?lA4A7o:Q48obXA2?lA4A7o
:Q48oaTI4OlA4A7o8R8A0_lA4A401_lZ4@So4A4AobXA2?lI6A7o4A4AoaTI
4@;o4A4A0_lI6A401OlA4A7o6ATAoa4A4OlZ4@So4A4A00;o6ATA00?o4A4A
obXA2?lI6A400_lA4A400olI6A7o4A4Aoa4A4@02oa4A4@0@obXA2?lR8Q7o
0000oa4A4OlZ4@So6ATAoa4A4OlI6A7o4A4AobXA2?lA4A7o6ATAoa4A4OlZ
4@So4A4AobXA20;o6ATA00?o4A4AoaTI4OlA4A400_lA4A401OlZ4@So4A4A
oaTI4OlA4A7o:Q4800;o6ATA00Co4A4AoaTI4OlA4A7o:Q480_lI6A401olA
4A7o8R8Aob8R4OlA4A7o6ATAobXA2?l000000_lI6A401?l0003o:Q48oa4A
4OlZ4@P2oa4A4@0?oaTI4OlZ4@So8R8Aoa4A4OlI6A7o4A4AobXA2?lA4A7o
:Q48oa4A4OlZ4@So4A4AobXA2?lA4A7o6ATA00;o4A4A00Oo:Q48oa4A4OlZ
4@So4A4AobXA2?lI6A7o:Q4800;o4A4A013o:Q48oaTI4OlA4A7o4A4AobXA
2?lA4A7o8R8Ao`000?lI6A7o6ATIoaTI4OlA4A7o:Q48oa4A4OlZ4@So4A4A
0_lZ4@P4oaTI4@0;oaTI6OlZ4@So:R8Iob8R4OlZ8QWo6ATIob8R4OlI6AWo
8R8AoaTR8_lI6AT00_lR8Q401?lI6AWo:R8IobXR6OlI8R82obXR6@0:ob8R
4Olb:R;o8RXZobXR6OlI6AWo8RXZob8R4OlR<R[o6B8Rob8R4JCok^k^001J
onKViP;o00000_lA4A401Ol0003o4A4Aoa4A4OlA4A7o6ATI00Go4A4A00Ko
6ATIoa4A4OlA4A7o6ATIoa4A4OlI6AT7oa4A4@05o`000?lA4A7o0000oa4A
4Ol000000olA4A401?l0003o4A4Aoa4A4Ol00004oa4A4@04o`000?lA4A7o
4A4Ao`0000;o4A4A00Wo0000oa4A4Ol0003o4A4Ao`000?lA4A7o0000oa4A
4Ol000000_lA4A402?l0003o4A4Aoa4A4Ol0003o4A4Ao`000?lA4A7o0000
0olA4A401_l0003o4A4Ao`000?lA4A7o6ATAo`0000?o4A4A00Co0000oa4A
4OlA4A7o4A4A0_l000003olA4A7o0000o`000?l0003o4A4Ao`000?lA4A7o
0000oa4A4Ol0003o4A4Ao`000?lZ4@So0000oa4A4@02o`000004oa4A4Ol0
003o4A4Ao`0000?o4A4A00Oo0000oa4A4OljA4co:Q48o`000?lI6A7o4A4A
00;o00001OlA4A42o`000009oa4A4Ol0003o4A4Aoa4A4Ol0003o4A4Ao`00
0?lZ4@So000000Go4A4A00Go0000oa4A4Ol0003o4A4Ao`000006oa4A4@05
o`000?lA4A7o4A4Aoa4A4OlI6A400_lA4A400ol0003o4A4AobXA2002oaTI
4@;o4A4A00?o:Q48oa4A4OlA4A401?lA4A400olZ4@So0000oa4A4@04oa4A
4@04oaTI4OlA4A7o4A4AoaTI4@?o4A4A00Co6ATAoa4A4OlI6A7o6ATA0_lA
4A400olZ4@So4A4AobXA200:oa4A4@06oaTI4OlA4A7o4A4Aoa4A4OlI6A7o
8R8A0_lI6A42oa4A4@03obXA2?lA4A7o4A4A00;o4A4A00Co:Q48oa4A4OlA
4A7o4A4A0_lI6A402?lA4A7o6ATAoaTI4OlA4A7o6ATAoa4A4OlZ4@So4A4A
0olI6A400olA4A7o6ATAoa4A4@03oa4A4@;o:Q4800?o6ATAoa4A4OlZ4@P0
0_lI6A401_lZ4@So4A4AobXA2?lI6A7o4A4AoaTI4@;o4A4A00Co:Q48oa4A
4OlI6A7o:Q480olA4A401_lZ4@So6ATAobXA2?lA4A7o6ATAoa4A4@;o:Q48
00Co4A4AoaTI4OlA4A7o:Q480olA4A400olZ4@So6ATAoaTI4@03oa4A4@03
obXA2?lA4A7o:Q4800?o6ATA00Oo:Q48oa4A4OlA4A7o4A4AoaTI4OlZ4@So
4A4A00;o6ATA00?o:Q48ob8R4OlR8Q400_lI6AT00olI6A7o6B8RobXR6@02
obXR6@03oa4A4OlZ4@So6ATA00Ko8R8A00Go6ATIob8R4OlI6AWo6ATIoaTR
8P02ob8R4@0=oaTI6OlI8R;o6ATAobXR6OlI6AWo6B8RoaTI6OlZ8QWo6ATI
obXR6OlR8Q7o6ATIobXR6@02oaTI6@04oa4A4OlZ8QWo:R8IoaTI6@;o:R8I
00?o8R8AoaTI4OoVi^H0XooVi^H005[ok^k^0_lA4A42o`000004oa4A4Ol0
003o4A4AoaTI6@Co4A4A00?o6ATIoa4A4OlA4A404_lA4A401Ol0003o4A4A
oa4A4OlA4A7o000000;o4A4A00?o0000oa4A4Ol000000_lA4A400ol0003o
4A4Aoa4A4@02oa4A4@04o`000?lA4A7o0000o`0000Co4A4A0_l00002oa4A
4@03o`000?lA4A7o4A4A00?o4A4A00Ko0000oa4A4OlA4A7o4A4Ao`000?lA
4A42o`000003oa4A4Ol0003o000000;o4A4A0ol000001OlA4A7o0000o`00
0?lA4A7o000000;o4A4A00?o0000oa4A4OlA4A400_l00002oa4A4@0:o`00
0?lA4A7o0000o`000?lA4A7o0000oa4A4Ol0003o4A4AobXA20?o4A4A00?o
6B8Rob8b:_l000000_lA4A400olI6AWo0000o`000004oa4A4@04o`000?lZ
4@So4A4Aoa4A4@;o00001?lA4A401?l0003o4A4Aoa4A4Ol00009oa4A4@06
o`000?lA4A7o4A4Ao`000?lR8Q7o:Q482_lA4A401Ol0003o4A4Aoa4A4Ol0
003o6ATA00;o4A4A00?o:Q48oa4A4OlA4A400_lA4A400olI6A7o:Q48oa4A
4@07oa4A4@;o:Q4800Ko4A4AoaTI4OlI6A7o:Q48oa4A4OlI6A44oa4A4@03
oaTI4OlA4A7o:Q4800?o4A4A00Co:Q48oa4A4OlI6A7o4A4A1OlI6A42oa4A
4@05oaTI4OlZ4@So4A4Aoa4A4OlZ4@P00olA4A400olI6A7o4A4AobXA2004
oa4A4@;o6ATA1OlA4A401OlI6A7o4A4AoaTI4OlZ4@So4A4A00?o6ATA00?o
8R8Aoa4A4OlR8Q401olA4A401?lI6A7o:Q48oa4A4OlZ4@P3oa4A4@05obXA
2?lA4A7o4A4AoaTI4OlZ4@P00_lA4A401Ol0003o:Q48oa4A4OlA4A7o6ATA
00Co4A4A00Go6ATAoa4A4OlZ4@So4A4AoaTI4@02oa4A4@09oaTI4OlA4A7o
:Q48oa4A4OlZ4@So4A4AobXA2?lA4A7o8R8A00;o6ATA0olZ4@P02?lI6A7o
4A4Aob8R4OlR8Q7o6ATIobXR6OlR:R[o8R8A0_lZ8QT01_lR8Q7o6B8RobXA
2?lI6A7o:R8IoaTI4@;o8R8A00Ko6ATIob8R4OlZ8QWo6B8RobXR6OlI6AT2
ob8R4@04obXR6OlR8Q7o6B8RoaTI6@;o8R8A0_lI6AT2obXR6@06oaTI6OlR
8Q7o6ATIob8R4OlI8R;o8R8A1?lZ8QT01olI6AWo6B8RoaTI4OlZ8QWo6ATI
ob8Z:_l00000Y?o^k^h005[ooooo0ol00002oa4A4@03o`000?lA4A7o4A4A
00Co4A4A00?o6ATIoa4A4OlA4A401OlA4A401Ol0003o4A4Aoa4A4OlA4A7o
000000?o4A4A00?o0000oa4A4OlA4A401OlA4A400ol0003o4A4Aoa4A4@03
oa4A4@03o`000?lA4A7o4A4A00?o4A4A00?o0000oa4A4OlA4A401OlA4A40
0ol0003o4A4Aoa4A4@02oa4A4@05o`000?lA4A7o:Q48o`000?lA4A400_l0
0003oa4A4@03o`000?lA4A7o000000?o4A4A00Ko0000oa4A4Ol0003o0000
oa4A4Ol00002oa4A4@04o`000?lA4A7o0000oa4A4@Co000000Ko4A4Ao`00
0?lA4A7o4A4Ao`000?lA4A44o`000003oa4A4Ol0003o000000Co4A4A00Co
0000ocXj<_lI6A7o00000_lA4A400olI6AWo0000oa4A4@02oa4A4@;o0000
00Co4A4Ao`000?lA4A7o00000_lA4A401_l0003o4A4Aoa4A4Ol0003o4A4A
o`0000?o4A4A00Go0000oa4A4OlA4A7o4A4AobXA2008oa4A4@04o`000?lI
6A7o4A4AobXA20?o4A4A00?o:Q48oa4A4OlA4A402_lA4A402?lZ4@So4A4A
obXA2?lA4A7o0000oaTI4OlA4A7o:Q480_lA4A401_lZ4@So8R8AobXA2?lI
6A7o4A4AoaTI4@;o4A4A00So6ATAoa4A4OlZ4@So6ATAoa4A4OlZ4@So4A4A
obXA20?o4A4A00Ko:Q48oaTI4OlI6A7o:Q48oaTI4OlZ4@P2oa4A4@;o6ATA
00co4A4AobXA2?lA4A7o4A4AoaTI4OlA4A7o:Q48oa4A4OlZ4@So4A4AoaTI
4OlA4A42oaTI4@05obXA2?lA4A7o:Q48oa4A4OlI6A400_lA4A401?lI6A7o
4A4Aoa4A4OlI6A42oa4A4@0JobXA2?lI6A7o6ATAoa4A4OlI6A7o:Q48oa4A
4OlR8Q7o6ATAobXA2?lR8Q7o:Q48oa4A4OlI6A7o4A4AobXA2?lA4A7o6ATA
obXA2?lI6A7o4A4AoaTI4OlA4A7o6ATAoa4A4OlZ4@P4oa4A4@;o6ATA00Co
:Q48oa4A4OlA4A7o6ATA0_lA4A401OlZ4@So4A4Aoa4A4OlA4A7o:Q4800?o
4A4A0_lI6A42oa4A4@05oaTI4OlA4A7o6ATAobXA2?lA4A401?lI6A402OlI
6AWo8R8Aob8R4OlI8S;o:R8Iob8R4OlR:R[o6ATIobXR6@02oaTI6@04oaTR
8_lR8Q7o6ATIobXR6@;o8R8A0_lI6AT00olR8Q7o6B8RoaTI6@02ob8R4@03
oaTR8_lI6AWo6ATI00;o6ATI00Co8R8AobXR6OlR8Q7o6B8R0_lZ8QT03OlI
8R;o6ATIobXR6OlR8Q7o6B8Rob8R4OlI6AWo8R8AoaTR8_lI6A7o8R8Aoa4A
4OlZ8QT00_lI6A42oaTI6@03oaTI4OlA4A7ooooo0:?ooooo001Jonk^kP?o
4A4A0_l00006oa4A4@;o6ATI00?o4A4AoaTI6OlA4A401olA4A401?l0003o
4A4Aoa4A4Ol0000:oa4A4@04o`000?lI6A7o4A4Ao`0000?o4A4A00?o0000
oa4A4OlA4A400_lA4A400ol0003o4A4Ao`000002oa4A4@03o`000?lA4A7o
4A4A00;o4A4A00?o0000oa4A4OlA4A401_lA4A401_l0003o4A4Ao`000?lA
4A7o0000oa4A4@;o00000_lA4A400ol0003o4A4Ao`000002oa4A4@06o`00
0?lA4A7o4A4Ao`000?lZ4@So00001?lA4A400ol0003o4A4Aoa4A4@02o`00
00?o4A4A00ko0000oa4A4Ol0003o4A4Ao`000?lZ4@So4A4AoaTI4OlA4A7o
0000ocY4C?l0003o:Q48oa4A4@;o6ATA00?o4A4Ao`000?lA4A401OlA4A40
1?lI6AWo4A4Aoa4A4OlZ4@P2oa4A4@03o`000?lA4A7o4A4A00;o4A4A00Go
0000oa4A4OlA4A7o4A4Ao`000006oa4A4@03o`000?lA4A7o4A4A00?o4A4A
00?o6ATAo`000?lA4A400olA4A401ol0003o4A4AobXA2?lA4A7o6ATAo`00
0?lZ4@P01?lA4A401?lI6A7o4A4Aoa4A4OlI6A45oa4A4@Co6ATA00?o4A4A
oaTI4OlA4A400_lA4A400olZ4@So4A4AobXA2002oa4A4@06ob8R4Ol0003o
6ATAoaTI4OlZ4@So4A4A0_lI6A400olA4A7o6ATAoaTI4@02oaTI4@0>oa4A
4OlI6A7o4A4AobXA2?lI6A7o4A4AoaTI4OlZ4@So6ATAobXA2?lI6A7o8R8A
obXA2?lI6A42obXA20Co6ATA0_lR8Q400olA4A7o:Q48obXA2002oa4A4@03
obXA2?lA4A7o:Q4800;o4A4A00Co:Q48oa4A4OlA4A7o:Q480_lA4A402?lZ
4@So6ATAoaTI4OlI6A7o4A4AoaTI4OlA4A7o:Q480olI6A42oa4A4@05oaTI
4OlI8R;o:Q48oa4A4OlZ4@P00_lA4A401OlZ4@So6ATAoaTI4OlA4A7o0000
00;o6ATA0olA4A402?lZ4@So4A4Aoa4A4OlZ4@So8R8AoaTI4OlA4A7o:Q48
0olA4A402?lZ4@So6ATAoa4A4OlZ4@So4A4Aob8R4OlZ4@So8R8A0_lb:R80
2_lR8Q7o6B8RobXR6OlZ8QWo8R8AobXR6OlR8Q7o6ATIobXR6OlI6AT4obXR
6@0DoaTI6OlZ8QWo8R8AoaTI6OlZ8QWo:Q48oaTR8_lZ8QWo8R8AoaTI6OlZ
8QWo6ATIobXR6OlI6AWo:R8Iob8R4OlI6AWo:R8Iob8Z:_lZ8QT2ob8R4@0C
oaTI6OlR8Q7o6ATIob8R4OlI6A7o6ATIob8R4OlI8R;o6ATAoaTI6OlI8R;o
8R8AoaTI6OlI8R;o:R8IoaTI4OlI6AWo8S8Zoa4A4@2Tonk^kP00F_oVi^H0
1?lA4A7o0000o`000?lA4A42o`0000[o4A4A00Go0000oa4A4Ol0003o4A4A
o`000006oa4A4@03o`000?lA4A7o000000?o4A4A00?o0000oa4A4Ol00000
2_lA4A401ol0003o4A4Aoa4A4OlA4A7o0000oa4A4Ol000001?lA4A400ol0
003o4A4Aoa4A4@02oa4A4@05o`000?lA4A7o0000oa4A4Ol000002?lA4A40
0ol0003o4A4Aoa4A4@03oa4A4@09o`000?lA4A7o4A4Ao`000?lA4A7o0000
oa4A4Ol0003o4A4A00;o00000_lA4A401?l0003o4A4AobXA2?lA4A42o`00
0006oa4A4Ol0003o0000o`000?lA4A7o00000olA4A401?l0003o4A4Aoc8j
A?l00003oa4A4@07oaTI4Ol0003o0000oa4A4Ol0003o4A4Ao`000002oa4A
4@0:o`000?lA4A7o0000oa4A4OlZ4@So0000oa4A4Ol0003o4A4Ao`0000?o
4A4A00Go0000oa4A4OlA4A7o6ATAo`000002oa4A4@03o`000?lA4A7o4A4A
00_o4A4A00?o:Q48oa4A4OlA4A401OlA4A401OlI6A7o4A4Aoa4A4OlA4A7o
6ATA00Co4A4A00Oo:Q48oa4A4OlI6A7o6ATAoa4A4OlI6A7o4A4A00;o6ATA
00?o8R8AoaTI4OlZ4@P00olA4A400olR8Q7o:Q48oa4A4@02oa4A4@06obXA
2?lI6A7o:Q48oaTI4OlA4A7o6ATA0olA4A400olI6AWo4A4AoaTI4@02oa4A
4@?o6ATA00Ko8R8Aoa4A4OlA4A7o6ATAoa4A4OlI6A42oa4A4@06oaTI4OlA
4A7o4A4Aoa4A4OlZ4@So6ATA1?lA4A400olI6A7o:Q48oa4A4@02oaTI4@04
obXA2?lA4A7o4A4AobXA20;o4A4A00?o:Q48oa4A4OlA4A400olA4A42obXA
200;oaTI4OlA4A7o4A4Aob8R4OlA4A7o:Q48oaTI4OlA4A7o:Q48oa4A4OlI
6A400_lA4A401_lI6A7o:Q48oaTI4OlA4A7o:Q48oaTI4@?o4A4A0_lZ4@P0
2OlA4A7o:Q48oaTI4OlI6A7o:Q48o`000?lI6A7o4A4AobXA2002oaTI4@07
oa4A4OlI6A7o:Q48oaTI4OlZ8QWo8R8Aob8b:P02obXR6@0CoaTI6OlZ8QWo
8R8AoaTI4OlZ8QWo8R8AoaTR8_lZ8QWo:Q48obXR6OlR8Q7o:R8IobXA2?lI
6AWo8R8AobXR6OlR8Q7o:R8Iob8R4@02oaTI6@03ob8R4OlI6AWo8R8A00;o
6ATI00co:R8Iob8R4OlI8R;o8R8Aob8Z:_lZ8QWo6ATIob8R4OlI6AWo6ATA
oaTI6OlZ8QT2ob8R4@06oa4A4OlZ8QWo8R8AoaTI6OlR8Q7o6ATI0_lI6A40
2?lI6AWo4A4AoaTI4OlI6A7o:R8IoaTI4OlI6AWo4A4AY?oVi^H005[ok^k^
00Co4A4Ao`000?lA4A7o00001?lA4A400ol0003o4A4Aoa4A4@04oa4A4@03
o`000?lA4A7o4A4A00Go4A4A00?o0000oa4A4OlA4A401OlA4A401_l0003o
4A4Aoa4A4OlA4A7o0000oaTI4@Go4A4A00?o0000oa4A4OlA4A402OlA4A40
0ol0003o4A4Aoa4A4@03oa4A4@03o`000?lA4A7o4A4A00Go4A4A00?o0000
oa4A4Ol000000_lA4A400ol0003o4A4Aoa4A4@02oa4A4@03o`000?lA4A7o
4A4A00;o4A4A0_l00004oa4A4@05o`000?lA4A7o0000oaTI4OlZ4@P00_lA
4A400ol0003o4A4Aoa4A4@02oa4A4@03o`000?lZ4@So:Q4800?o00001?lA
4A401olRA3[o4A4Aoa4A4OlA4A7o0000oaTI4Ol000000_lA4A42oaTI4@05
oa4A4OlI6A7o4A4Aoa4A4OlZ4@P00_lA4A400ol0003o4A4Aoa4A4@07oa4A
4@07obXA2?lA4A7o4A4Aoa4A4OlZ4@So4A4AobXA2008oa4A4@04obXA2?lA
4A7o4A4AobXA20;o4A4A00?o6ATAoa4A4OlA4A400_lI6A400olA4A7o6ATA
oa4A4@02oaTI4@0Bob8R4OlI6AWo8R8AoaTI4OlZ8QWo6B8RoaTI6OlZ8QWo
6ATAobXR6OlR8Q7o6B8RoaTI6OlI6A7o6B8Rob8R4OlZ8QWo6ATA0_lA4A40
1OlZ4@So4A4AobXA2?lA4A7o6ATA00Co4A4A00Co6ATAoa4A4OlI6A7o8R8A
0_lA4A401OlI6A7o:Q48oa4A4OlZ4@So4A4A00;o6ATA00So:Q48oaTI4OlZ
4@So6ATAoa4A4OlZ4@So4A4AoaTI4@;o4A4A00Go6ATAobXA2?lA4A7o4A4A
oaTI4@02obXA2008oa4A4OlI6A7o4A4AoaTI4OlZ4@So6ATAoa4A4OlR8Q42
oa4A4@Co6ATA00Ko:Q48oaTI4OlI6A7o:Q48oaTI4OlA4A43oaTI4@05obXA
2?lA4A7o4A4Aoa4A4OlI6A400_lZ4@P00olA4A7o6ATAobXA2002oaTI4@04
o`000?lI6A7o6ATAobXA20;o4A4A00?o:Q48oa4A4OlA4A400_lI6A401OlA
4A7o:Q48oaTI4OlA4A7o8R8A00;o4A4A00Go:Q48ob8R4OlI6A7o:R8Iod@j
:P02oc8Z8P05obXR6OlR8Q7o:R8IobXR6OlR8Q400_lZ8QT03OlI6AWo:R8I
oaTI4OlI6AWo8R8AoaTR8_lZ8QWo6ATIob8R4OlI6AWo8R8AoaTI6OlZ4@P0
0_lI6AT01olZ4@So6ATIob8R4OlR8Q7o6ATIob8R4OlI6AT00_lZ8QT01?lI
8R;o6ATIobXR6OlZ8QT2oaTI6@;o8R8A00Co:R8IoaTR8_lA4A7o8R8A0_lI
6AT01OlR8Q7o6ATAoaTI6OlA4A7o6ATA00;o4A4A00Co6ATAoa4A4OlI6A7o
6ATI0_lI6A400olI6AWo8R8Ao`00002Tonk^kP00F_ooool2oa4A4@04oaTI
6OlA4A7o0000o`0000Oo4A4A00?o6ATIoa4A4OlA4A401?lA4A400ol0003o
4A4Aoa4A4@03oa4A4@04o`000?lA4A7o4A4Ao`0000Wo4A4A00?o0000oa4A
4OlA4A400_lA4A401?l0003o4A4Aoa4A4Ol00002oa4A4@03o`000?lA4A7o
000000Ko4A4A00?o0000oa4A4OlA4A401OlA4A400ol0003o4A4Aoa4A4@05
oa4A4@06o`000?lA4A7o0000oaTI4Ol0003o4A4A0ol000001OlA4A7o0000
oa4A4Ol0003o4A4A00;o00000olA4A401Ol0003o4A4Aoa4A4OlA4A7o0000
00;o:Q4800ko<RXRobXA2?lb:R;o0000oa4A4Ol0003o4A4Ao`000?lA4A7o
0000obXR6Ol0003o4A4Ao`0000;o4A4A00Oo0000oa4A4Ol0003o0000oa4A
4Ol0003o4A4A00;o00002?lA4A400olZ4@So4A4Aoa4A4@04oa4A4@07oaTI
4OlA4A7o4A4AoaTI4OlA4A7o:Q48oaTI4@02oa4A4@03oaTI4OlZ4@So4A4A
00;o6ATA013o4A4AoaTI4OlI6A7o6ATAoa4A4OlI6A7o4A4AoaTI4OlI6AWo
6ATAoa4A4OlZ8QWo6ATAoaTI6OlZ4@So6ATI0_lR8Q402?lZ8QWo6ATAoaTI
4OlZ8QWo4A4Aob8R4OlZ8QWo6ATA0_lZ8QT01?lI6AWo:R8IoaTI4Ol00006
oa4A4@05oaTI4OlA4A7o4A4Aoa4A4OlZ4@P00_lA4A401OlI6A7o4A4AoaTI
4OlR8Q7o:Q4800?o4A4A00Oo:Q48oa4A4OlA4A7o4A4AoaTI4Ol0003o6ATA
00?o4A4A0_lI6A44oa4A4@05obXA2?lA4A7o6ATAo`000?lI6A400olA4A40
0olI6A7o4A4AobXA2002oa4A4@04ob8R4OlZ4@So4A4AoaTI4@;o4A4A00Go
6ATAobXA2?lA4A7o:Q48oa4A4@02oaTI4@09obXA2?lA4A7o6ATAoa4A4OlR
8Q7o:Q48oa4A4OlI6A7o4A4A00?o6ATA00Ko8R8AoaTI4OlZ4@So:Q48o`00
0?lI6A42obXA2003oaTI4OlZ4@So:Q4800;o6ATA00oo6ATIoaTI4OlR8Q7o
6ATIobXA2?lb:R;oA3XRodA4:_mL>R;oC4`joc8Z8_lI8R;o:R8Iob8R4OlI
6AT00_lZ8QT01olI8R;o8R8AoaTI4OlI6A7o:Q48oaTI4OlZ8QT00_lI6A40
2?lZ4@So6ATAob8R4OlI6AWo6ATAoaTI6OlR8Q7o6ATI1?lR8Q402_lI6AWo
8R8AobXR6OlR8Q7o6B8Rob8R4OlZ8QWo8R8AobXR6OlR8Q42oaTI6@03ob8R
4OlI6AWo6ATA00;o6ATA00Co:R8IoaTI6OlI6A7o8R8A0olI6A401_lZ4@So
6ATAoaTI4OlZ4@So6ATAoaTI6@;o4A4A00Go6ATAoa4A4OlA4A7o6ATAoa4A
4@2Tooooo`00F_o^k^h00olA4A7o6ATIoaTI6@02oa4A4@03o`000?lA4A7o
4A4A00?o4A4A00?o6ATIoa4A4OlI6AT00olA4A400ol0003o6B8Ro`00000=
oa4A4@04o`000?lA4A7o4A4Ao`0000Co4A4A00?o0000oa4A4Ol000002olA
4A400ol0003o4A4Ao`000002oa4A4@;o00000_lA4A400ol0003o4A4AobXA
2002oa4A4@03o`000?lA4A7o4A4A00;o4A4A00Go0000oa4A4Ol0003o4A4A
o`000005oa4A4@05o`000?lA4A7o0000oa4A4Ol000000olA4A401_l0003o
4A4Ao`000?lA4A7o0000oa4A4@;o000000?o6ATAo`000?lA4A401?l00000
1_lA4A7o0000oa4A4OlA4A7o6ATIo`0000Co4A4A0_l00003oa4A4@03oaTI
4OlA4A7o4A4A00Co4A4A00Co6ATAoa4A4OlA4A7o6ATA0_lA4A401?lZ4@So
4A4AoaTI4OlA4A42oaTI4@09oa4A4OlI6A7o6ATAoa4A4OlI6AWo4A4AoaTI
6OlI6A7o:R8I00;o6ATA00Co:Q48oaTI6OlI6A7o:Q480_lA4A406OlR8Q7o
4A4Aob8R4OlI6A7o:R8IoaTI6OlR8Q7o6ATAob8R4OlI6A7o:R8IoaTI6OlI
6A7o6ATIoa4A4OlI6AWo6ATAoaTI6OlI6A7o:R8IoaTR8_lI6AWo6ATAoaTR
8_lR8Q401?lA4A400olZ4@So4A4Aoa4A4@05oa4A4@0=obXA2?lA4A7o:Q48
oaTI4OlA4A7o6ATAoa4A4OlZ4@So4A4AobXA2?lA4A7o:Q48oaTI4@03oa4A
4@09obXA2?lI6A7o8R8AoaTI4OlR8Q7o6ATAoa4A4OlI6A7o000000;o:Q48
0olI6A402Ol0003o4A4AobXA2?lA4A7o:Q48oa4A4OlZ4@So4A4AoaTI4@02
oa4A4@03obXA2?lI6A7o:Q4800;o4A4A00Ko:Q48oa4A4OlA4A7o6ATAoa4A
4OlI6A42oa4A4@0;oaTI4OlA4A7o6ATAoa4A4OlZ4@So4A4AobXA2?lI6A7o
6ATIobXR6OlR8Q400_lZ8QT03?lI6A7o:R8Iob8R4OlI8R;o8R8AoaTI6OlZ
8QWo6ATIobXR6OlI6AWo:R8Ioc8Z8PCo8R8A0_m<A2803_m<C3[o>SXRoc8Z
8_lI6AWo6ATAob8R4OlZ8QWo8R8AoaTR8_lR8Q7o6ATAobXA2?lI6AWo6ATA
0_lZ8QT2oaTI6@06obXA2?lZ8QWo8R8AobXR6OlR8Q7o6ATI0_lZ8QT00olZ
4@So6B8Rob8R4@02oaTI6@0FobXR6OlI8R;o8R8AobXR6OlI6AWo6B8RobXR
6OlI6AWo6B8RoaTI6OlR8Q7o6B8RoaTI4OlR8Q7o6ATIob8R4OlI6A7o:R8I
oaTI6OlI6A7o:R8IoaTI4@Ko4A4A00?o6ATAoa4A4OlI6A400_lA4A401_lI
6A7o4A4AoaTI6OlI6A7o6ATIo`000:Cok^k^001JonKViP07oa4A4OlI8R;o
0000oa4A4Ol0003o4A4Ao`000004oa4A4@03oaTI6OlA4A7o6ATI00So4A4A
00Oo6ATAo`000?lA4A7o4A4Ao`000?lA4A7o000000;o4A4A00Co0000oa4A
4OlA4A7o00000_lA4A400ol0003o4A4Ao`000005oa4A4@04o`000?lA4A7o
4A4Ao`0000?o4A4A0_l00004oa4A4@05o`000?lA4A7o4A4Aoa4A4Ol00000
0_lA4A43o`0000Co4A4A00?o0000oa4A4OlA4A400olA4A402?l0003o4A4A
o`000?lA4A7o0000oa4A4Ol0003o4A4A0ol000001?lA4A7o0000oa4A4Ol0
0002oa4A4@06o`000?lA4A7o4A4AoaTI4OlA4A7o:Q480_l000001OlA4A7o
0000oa4A4OlA4A7o000000?o4A4A00?o6ATAoa4A4OlI6A400_lA4A401?lR
8Q7o6ATAo`000?lR8Q44oa4A4@03obXA2?lA4A7o:Q4800;o6ATA00?o4A4A
ob8R4OlI6A401OlA4A401OlI6A7o4A4AoaTI4OlA4A7o6ATA00;o8R8A00Wo
6ATAobXA2?lR8Q7o6ATAoa4A4OlI6AWo6ATAoa4A4OlI6A400_lA4A44oaTI
4@03obXA2?lI6AWo6ATI00;o6ATA00?o6ATIobXA2?lI6AT00_lI6AT01OlZ
4@So6ATIobXR6OlZ4@So8RXZ00;o8R8A00Go6ATIob8R4OlI6AWo:R8IoaTI
6@02oa4A4@04obXA2?lI6A7o4A4Aoa4A4@?o6ATA00Go4A4AobXA2?lI6A7o
4A4AoaTI4@05oa4A4@04oaTI4OlI6AWo6ATAoa4A4@;o6ATA00Co8R8Aoa4A
4OlZ4@So8R8A0olI6A401?lZ8QWo8R8Aob8R4OlA4A42obXA2003oaTI4OlA
4A7o6ATA00;o4A4A00Go:Q48oa4A4OlA4A7o4A4AobXA2004oaTI4@;o4A4A
00oo8R8AoaTI4OlA4A7o:Q48oa4A4OlZ4@So6ATAoa4A4OlZ4@So6ATAobXA
2?lI6A7o4A4AobXA2?lI6A400_lZ4@P3oaTI4@06ob8R4OlZ8QWo6ATAoc8Z
8_lI6AWo:R8I0olR8Q401_lI6AWo6B8RobXR6OlZ8QWo8R8AobXR6@;o8R8A
00Wo:R8IobXA2?lb:R;o:R8Iod@j:_lb:R;oA3XZoc8Z8_lA4A400olR8Q40
0olZ8QWo6ATAoaTI6@02ob8R4@07obXR6OlI6AWo8R8Aob8R4OlZ8QWo8R8A
oaTI4@02ob8R4@05obXR6OlR8Q7o6ATIob8R4OlI6AT00_lR8Q401_lZ8QWo
8R8Aob8R4OlI6AWo8R8AoaTI6@;o8R8A00So6ATIob8R4OlZ8QWo6ATAobXR
6OlR8Q7o6ATAob8R4@;o6ATA00Co8R8AoaTR8_lR8Q7o6ATI0_lI6A401OlA
4A7o6ATAoaTI4OlA4A7o6ATA00Go4A4A00?o6ATAoa4A4OlA4A401?lA4A40
1?lI6A7o4A4AoaTI4Ol0002TonKViP00F_o^k^h01?lA4A7o0000oa4A4Ol0
0002oa4A4@03o`000?lA4A7o4A4A00Co4A4A00?o6ATIo`000?lA4A406_lA
4A400ol0003o4A4Ao`000002oa4A4@04o`000?lA4A7o4A4Ao`0000?o4A4A
00?o0000oa4A4Ol000000olA4A401_l0003o4A4Aoa4A4Ol0003o4A4Ao`00
00?o4A4A00Wo0000oa4A4Ol0003o4A4Ao`000?lA4A7o0000oa4A4Ol00000
0_lA4A42o`000004oa4A4Ol0003o4A4Ao`0000?o4A4A00Wo0000oaTI4Ol0
003o4A4Ao`000?lI6A7o0000oa4A4Ol000000_lA4A401?lZ4@So8R8AobXA
2?l00002oa4A4@05o`000?lA4A7o4A4Ao`000?lI8RX00olA4A400ol0003o
6ATAoa4A4@02o`0000;o4A4A00?o6ATIoa4A4OlA4A400_lA4A42oaTI4@03
obXA2?lA4A7o4A4A00;o4A4A00Co:Q48oa4A4OlI6A7o6ATI0_lA4A401OlI
6AWo4A4Aoa4A4OlI6A7o4A4A00;o6ATA00Co4A4AoaTI6OlI6A7o6ATA0olA
4A43oaTI4@07oaTI6OlI6A7o6ATAoaTI6OlR8Q7o6ATIoa4A4@02oaTI4@05
oaTI6OlZ4@So6ATIobXA2?lI6AT00_lI6A401_lI6AWo8R8AoaTI4OlI6A7o
6B8RoaTI6@;o6ATA1_lA4A401_lI6A7o4A4AoaTI4OlI6A7o0000oaTI4@;o
4A4A0_lR8Q401OlI6A7o4A4AoaTI6OlI6A7o6ATI00;o8R8A00_o6ATIobXR
6OlR8Q7o6B8RobXR6OlR8Q7o6ATIoaTI4OlZ8QWo6ATAoaTI6@06oa4A4@04
oaTI4OlA4A7o4A4Aoa4A4@;o6ATA00?o8R8AobXA2?lI6A400_lA4A403_lZ
4@So4A4Aob8R4OlZ4@So6ATAobXA2?lA4A7o0000ob8R4OlI6A7o4A4AobXA
2?lA4A7o6ATA0_lA4A400olZ4@So6ATAoa4A4@04oaTI4@04ob8R4OlZ8QWo
8R8AobXR6@?o8R8A00Go:R8IoaTI6OlZ8QWo6ATIob8R4@04oaTI6@?o<RXR
00GoA4@boc8Z8_lR:R[o8R8AoaTI6@02ob8R4@05obXR6OlI8R;o8R8Aob8R
4OlI6A400_lZ8QT01olR8Q7o6ATIob8R4OlI6AWo8R8AobXR6OlR8Q400_lZ
8QT3ob8R4@0<oaTR8_lR8Q7o8R8AobXR6OlR8Q7o6ATAoaTI6OlZ4@So6ATI
oaTI4OlA4A7o8R8A0_lI6AT01?lA4A7o6ATAobXA2?lI6AT2oa4A4@?o6ATA
00Co8R8AoaTI6OlZ4@So6ATA0_lA4A403OlI6AWo4A4AoaTI4OlI6A7o4A4A
oaTI4OlZ4@So8R8AobXR6OlI6A7o8R8AobXR6OlR8Q402?lA4A400ol0003o
k^k^onk^kP2Ronk^kP00F_ooool2oa4A4@03o`000?lA4A7o4A4A00;o0000
2olA4A400ol0003o4A4Aoa4A4@02oa4A4@03o`000?lA4A7o000000;o4A4A
00go0000oa4A4OlA4A7o4A4Ao`000?lA4A7o0000oa4A4Ol0003o4A4Ao`00
0?lA4A7o000000Go4A4A00Go0000oa4A4OlA4A7o0000oa4A4@03o`000006
oa4A4Ol0003o4A4Ao`000?lA4A7o00000_lA4A400ol0003o4A4Ao`000002
oa4A4@;o00000_lA4A401?l0003o4A4Aoa4A4Ol00002oa4A4@03o`000?lA
4A7o4A4A00?o4A4A0_l000001OlA4A7o0000o`000?l0003o4A4A00;o0000
0_lA4A400ol0003o6ATAo`000002oa4A4@08obXA2?lI6A7o:Q48oa4A4OlZ
4@So0000oa4A4Ol00002oaTI4@?o4A4A00?o0000oa4A4OlA4A400_lA4A42
o`0000So4A4A01?o6ATAoa4A4OlI6AWo4A4AoaTI4OlA4A7o6ATAoa4A4OlI
6A7o4A4AoaTI4OlA4A7o6ATAobXA2?lA4A7o6ATAoa4A4OlI6A7o4A4A00Co
6ATA00Oo8R8AoaTI6OlI6A7o6B8Roa4A4OlI6A7o8R8A00;o6ATI00Co6ATA
oaTI6OlI6A7o8R8A0_lI6AT03olZ8QWo6B8Roa4A4OlI6A7o8R8AoaTI4OlI
6AWo8R8AoaTR8_lI6A7o:R8Ioa4A4OlZ4@So6ATIobXA2002oaTI4@05obXA
2?lA4A7o6ATIoaTI4OlR8Q401?lb:R82od@Z8P03od@j:_lZ8QWo8RXZ00;o
:R8I00oo6ATIoaTR8_lZ4@So6ATAob8R4OlI6AWo:R8IoaTI6OlR8Q7o6B8R
obXR6OlI6A7o:R8IoaTI4OlR8Q400_lZ4@P01_lI6A7o:Q48obXA2?lI6A7o
4A4AobXA20;o4A4A00So:Q48oa4A4OlZ4@So4A4AoaTI4OlA4A7o8R8AobXA
20?o4A4A00Go6ATAoa4A4OlA4A7o4A4AobXA2002oa4A4@;o:Q480_lA4A40
1?lI6A7o:Q48oa4A4Ol00002ob8R4@0<oaTI6OlZ8QWo:R8IobXR6OlI6A7o
6B8RobXA2?lI6AWo6ATAoaTI6OlZ8QWo8R8A0_lI6AT01olR8Q7o<RXRoda4
8_m4>R;oA4@bod@Z8_lj>S800olR8Q401?lI8R;o8R8AobXA2?lI6AT3obXR
6@0?oaTI6OlZ8QWo4A4Aob8R4OlZ8QWo6ATIobXR6OlI8R;o6ATAoaTI6OlR
8Q7o6ATAobXR6OlI6A7o8R8A00;o6ATA00Go:R8IoaTI6OlI6A7o6ATAob8R
4@02obXA20;o6ATI00Co:R8Iob8R4OlR8Q7o8R8A0olZ8QT03Olb:R;o6ATA
obXR6OlZ8QWo8R8Aoc8Z8_lI6AWo6ATAob8R4OlI6AWo6ATAoaTI6OlI6A40
0olA4A401_lI6A7o4A4Aob8R4Om4>R;o>T@IobXA20?o6ATA1OlA4A401Ol0
003o4A4Aoa4A4OlA4A7o00000:Cooooo001Jonk^kP06o`000?lA4A7o4A4A
o`000?lA4A7o00001?lA4A400ol0003o4A4Aoa4A4@0Aoa4A4@03o`000?lA
4A7o4A4A00[o4A4A00Go0000oa4A4Ol0003o4A4Ao`000009oa4A4@05oaTI
6Ol0003o4A4Aoa4A4Ol000000olA4A402ol0003o6ATAo`000?lA4A7o0000
oa4A4Ol0003o4A4Ao`000?lA4A7o000000;o4A4A00Co0000oa4A4OlA4A7o
00000olA4A402Ol0003o4A4Ao`000?l0003o4A4Ao`000?lA4A7o0000obXA
2002o`0000Co4A4A00?o<RXRoaTI6Ol000000olA4A42o`000005oa4A4Ol0
003o4A4Aoa4A4OlI8S800_lR>U`01olI8R[o4A4Aoa4A4OlA4A7o:Q48oa4A
4OlI6AT00_lA4A400olZ4@So6ATAoa4A4@02oa4A4@03oaTI4OlA4A7o4A4A
00;o4A4A00Oo6ATAoa4A4OlI6AWo6ATAoa4A4OlI6A7o4A4A00Ko6ATA00Co
4A4AoaTI6OlR8Q7o4A4A0_lI6AT2oaTI4@04ob8R4OlI6AWo6ATAob8R4@;o
6ATA0_lI6AT00olZ8QWo6ATAoaTI6@02obXR6@Ko6ATI00oo6B8RoaTI6OlZ
8QWo6B8Rob8R4OlI8R;o6ATIoc8Z8_lI8R;o6ATIocXj8_m4>R[o>SXRod@j
:_lR<RX00_m<A2800olR>S;o8RXZobXR6@02oaTR8PCo:R8I00Co6B8RobXR
6OlI8R;o8R8A1?lZ8QT00olI6AWo8R8AoaTI6@02oaTI4@0<obXA2?lA4A7o
8R8AoaTI4OlA4A7o6ATAobXA2?lI6A7o4A4AobXA2?lA4A7o:Q480_lA4A40
1OlZ4@So6ATAoa4A4OlI6A7o4A4A00;o:Q4800Oo4A4AobXA2?lA4A7o:Q48
ob8R4OlI6A7o4A4A00;o6ATA0_lA4A401OlR8Q7o6ATIobXR6OlR:R[o:R8I
00;o8R8A0olZ8QT00olR8Q7o6B8RobXR6@04obXR6@0>ob8Z:_m<A2;oA4@Z
odA4:_m4>R;oA3XZoc8Z8_lI6AWo:R8Iob8R4OlI6A7o:R8IoaTI6OlZ8QT2
oaTR8P05obXR6OlR8Q7o6ATIobXR6OlI6AT00_lZ8QT00olI6AWo:R8IoaTI
6@02obXR6@08oc8Z8_lZ8QWo8RXZobXA2?lR:R[oA2XRoc8Z8_m4>RX5oc8Z
8P;o8S8Z00[o8RXZoc8Z8_lb:R;o:R8Iob8b:_lZ8QWo8RXZoaTR8_lI6A7o
:R8I0_lI6A400olR8Q7o6B8RoaTI4@02oa4A4@07oaTI6OlR8Q7oA4@bodA4
<_lR8Q7o4A4AobXA2002ob8R4@03od`R2?lZ4@So4A4A00?o4A4A00?o0000
oa4A4Ol000002OlA4A400ol0003ok^k^onk^kP2Ronk^kP00F_oVi^H01?lA
4A7o0000o`000?lA4A42o`000003oa4A4Ol0003o4A4A00oo4A4A00Go0000
oa4A4Ol0003o4A4Ao`000009oa4A4@04o`000?lA4A7o4A4Ao`0000;o4A4A
00?o0000oa4A4OlA4A400_lA4A400ol0003o4A4Aoa4A4@02oa4A4@06o`00
0?lA4A7o0000o`000?lA4A7o00001_lA4A400ol0003o4A4Aoa4A4@04oa4A
4@03o`000?lA4A7o4A4A00?o4A4A00So0000oa4A4OlA4A7o0000oa4A4Ol0
003o4A4Ao`0000;o4A4A0_l000004_lA4A7o0000oa4A4OlA4A7o6B8Roa4A
4OlI6A7o4A4AoaTI4OlR:R[o4A4AobXA2?lA4A7o6ATAo`000?lA4A7o0000
obXA20;o4A4A00Wo6B8RoaTI6OlA4A7o6ATAoa4A4OlI8R[o0000oa4A4OlI
6A400_lA4A400olZ4@So4A4AoaTI4@02oa4A4@05obXA2?lA4A7o4A4AoaTI
4OlI6AT00olA4A400olI6A7o4A4Aoa4A4@03oa4A4@;o6ATA00Oo4A4AoaTI
4OlZ4@So6ATAoaTI6OlI6A7o6ATI00?o6ATA00Ko6ATIoaTI4OlI6AWo6ATA
ob8R4OlI6AT3oaTI4@03oaTI6OlZ8QWo6B8R00;o6ATI00Ko8RXZobXR6OlR
8Q7o8R8Aob8Z:_lR8Q42obXR6@0:ob8Z:_lZ8QWo6ATIob8Z:_lZ8QWo6B8R
oc8Z8_m<A2;oA4@bodA4:P;oA3XZ00KoA4@Zod@j:_lb>TCo6ATAoaTR8_lR
8Q42obXR6@04oaTR8_lR:R[o6B8RoaTR8P;o:R8I00oo8R8AobXR6OlI8R;o
8RXZobXR6OlI6AWo8R8AoaTI4OlA4A7o:Q48ob8R4Ol0003o8R8AoaTI4OlA
4A400olI6A400olZ4@So4A4AoaTI4@02oaTI4@0:oa4A4OlZ4@So6ATAoaTI
4OlA4A7o8R8AoaTI4OlR8Q7o0000obXA20;o8R8A0_lI6A401olI6AWo8R8A
oaTI6OlI6AWo8R8AobXA2?lR8Q401OlZ8QT2oaTR8P?o<RXR0_m4:R803olb
:R;oC4@Rod@Z8_lb:R;o>SXRocY4<_m4>R;o<RXRoaTR8_lI6AWo6ATAoaTI
6OlZ8QWo4A4AoaTI6@02obXR6@0Hob8R4OlZ8QWo<RXRod@Z8_lj>R;oA2XR
ocXj8_m4:R;oA3XZocXj8_lb:R;oA3XZodA4:_m<C4CoC4`jod@j:_m4A4co
A3XZodA4:_lb:R;o>SXRob8b:_lb:R;o8RXZ0olb:R801?lR:R[o:R8IoaTI
6Olb:R82ob8R4@06oaTR8_lR8Q7o8R8AoaTI6OlZ8QWo6ATI1?lR8Q42oaTI
4@04oa4A4OlI6AWo4A4Aob8R4@;o6ATA00Co:R8IoaTI6OlA4A7o6ATA1?lA
4A401?l0003o4A4AoaTI4OlZ4@P6oa4A4@07o`000?lA4A7o4A4Aoa4A4OmU
G2[o4A4Ao`00002TonKViP00F_o^k^h6oa4A4@;o000000So4A4Ao`000?lI
6AWo4A4Ao`000?lI6A7o4A4Ao`0000;o4A4A00Go0000oa4A4OlA4A7o4A4A
o`00000:oa4A4@05o`000?lA4A7o0000oa4A4Ol000000_lA4A400ol0003o
4A4Aoa4A4@06oa4A4@04o`000?lA4A7o6ATAo`0000Oo4A4A00ko0000oa4A
4OlA4A7o0000oa4A4Ol0003o4A4Ao`000?lA4A7o0000oa4A4Ol0003o4A4A
o`0000;o4A4A0_l00003oa4A4@;o000000?o4A4Ao`000?lA4A400ol00002
oa4A4@06o`000?lA4A7o0000oaTI4OlA4A7o00000_lA4A42o`000003oaTI
4OlA4A7o4A4A00?o4A4A00Co0000obXA2?lA4A7o00000_lA4A401?l0003o
4A4Aoa4A4OlA4A42o`0000Co4A4A00?o6ATAoa4A4OlI6A400_lA4A401_lI
6A7o4A4AoaTI4OlA4A7o<RXRoaTI4@?o4A4A00Co6ATAoa4A4OlI6A7o:Q48
0_lA4A401_lI6A7o4A4Aoa4A4OlA4A7o6ATIoa4A4@;o6ATA00?o4A4AoaTI
6OlZ4@P00_lI6A401OlR8Q7o6ATIoaTI4OlI6A7o6ATI00?o6ATA00?o:R8I
oaTI4OlI8R800_lR8Q400olI6AWo6B8Rob8R4@03oaTI6@03ob8R4OlI6AWo
:R8I00;o6B8R00[o>T@Ioda<>_m4>R[o>SXRod@Z8_m<A2;oA4@Zob8Z:_lR
8Q7o6ATI0_lZ8QT2oaTR8P03ob8Z:_lZ8QWo:R8I00;o:R8I00Go4A4AobXR
6OlI8R;o6B8RobXR6@02oaTI6@03oa4A4OlI6A7o:R8I00?o8R8A00?o6ATI
oaTI4OlI6A401?lR8Q400olA4A7o8R8AobXR6@02ob8R4@03oaTI6OlR8Q7o
6ATI00Co:R8I0olb:R803?lZ8QWo<RXRoc8Z8_m4>R;o:R8Ioc8Z8_lj>R;o
C4@Rod@j:_lb:R;o>SXRoc8Z8P;o>SXR00co<RXRocXj8_m4>R[o>SXRod@j
:_lb:R;o>SXRoc8Z8_lR<R[o<RXRob8Z:_lR<RX2ocXj8P09od@j:_lb:R;o
<RXRoda48_m4>R[o>SXRodA4<_m<C3[oIE@b00;oC4`j00OoC4a4od@j:_lj
>S;oA3XZodA4<_m4>R[o<RXR00;oA3XZ00SoC4`jod@j:_lb:R;oA3XZoc8Z
8_lj>R;o>T@Iod@j:P;o>SXR0_m4>RX03olI8R;o<RXRoc8Z8_ljA1Wo>SXR
odA4:_ljA3;o<RXRod@j:_lZ8QWo8RXZob8R4OlZ8QWo6ATIobXR6@02oaTI
4@05oaTR8_lR8Q7o6ATAoa4A4OlI6A401olA4A400olI6AWo:Q48obXA2002
o`000004oa4A4Ol0003o4A4Ao`0000;o4A4A00Wo:Q48o`000?lb:R;o0000
oa4A4OmUIC[oIE`Zod`R2?lA4A400_l00002oa4A4@03oda<>_lR<R[oC4a4
0:Cok^k^001Jooooo`04oa4A4Ol0003o0000oa4A4@?o00000olA4A401Ol0
003o4A4Aoa4A4OlA4A7o000000;o4A4A00?o0000oa4A4OlA4A401_lA4A40
2?l0003o4A4Aoa4A4Ol0003o4A4Ao`000?lA4A7o6ATA1?lA4A402Ol0003o
4A4Aoa4A4OlA4A7o0000oa4A4Ol0003o4A4Ao`000004oa4A4@09o`000?lA
4A7o0000oa4A4Ol0003o4A4Ao`000?lA4A7o000000co4A4A00Wo0000oa4A
4Ol0003o4A4Ao`000?lA4A7o0000oa4A4Ol000000_lA4A400ol0003o4A4A
o`000002oa4A4@04o`000?lA4A7o0000o`0000;o4A4A0_l00008oa4A4@?o
000000oo:Q48oa4A4Ol0003o0000oa4A4OlI6A7o4A4AoaTI4Ol0003o4A4A
o`000?lA4A7o8R8Aoa4A4OlZ4@P00_lA4A403_lI6A7o4A4AoaTI4OlR8Q7o
4A4AoaTI6OlA4A7o6ATAoaTR8_lA4A7o:Q48oa4A4OlI6A7o4A4A0_lI6A40
0olA4A7o6ATIoaTI4@05oaTI4@0:oa4A4OlI6A7o6ATIoaTI6OlI6A7o6ATI
oa4A4OlI6A7o6ATIob8R4@;o6ATA00Wo6ATIoaTI4OlI6A7o:R8IoaTI4OlR
8Q7o6ATAobXR6OlI6A400_lR8Q42oaTI4@07oc8Z8_lZ8QWo4A4AoaTR8_lZ
8QWoC4@Rod@j:P02odA4:P;oA4@b00?oC4@RobXR6OlI8R800_lZ8QT02OlI
8R;o:R8IobXR6OlZ8QWo8RXZob8R4OlI6AWo8R8AoaTI6@03obXR6@03oc8Z
8_lZ8QWo:R8I00Ko:R8I00Co8RXZobXR6OlZ8QWo>SXR0_lb:R803?m<A2;o
A2XRod@Z8_m<C3[oID`IocXj8_m4A2[oC4@RodA4:_m<A2;oA4@boda48P;o
A3XR00Ko>T@Iod@j:_lR<R[o>SXRoc8Z8_lj>R83oc8Z8P04ob8Z:_lR8Q7o
:R8IobXR6@Co<RXR00?o>SXRoc8Z8_m<A2800_m4>RX00om4A2[oC4@Rod@j
:P06odA4<P05odA4C?lj>R;o8S8Zod@j8_m4A3800_m4>RX02?m<A2;o>SXb
od@j8_lb:R;oC4a4odA4<_m4A2[oA4@b0_m4>RX01om4>R;oA4@boda<>_m4
A3;oA4@Zoda<>_ljA3800om4A2X06?lj>S;oC4`jod@j8_m4A3;oA4@Zod@j
8_lb:R;oA4@Zod@j:_lb:R;o:R8Ioc8Z8_lR:R[o:R8Iob8R4OlI6A7o4A4A
ob8R4Ol0003o8R8Aoa4A4OlZ4@So6ATAobXA20Ko4A4A00Co6ATAoa4A4OlA
4A7o:Q482_lA4A403OlZ4@So0000od@Z8_n7E2[oSgI4obXA2?l0003oKFDR
ofE<6OmUIC[oA3XZoc8Z8_ljA4`00_m<C4@00omDOWkoG6f7oeA]MP2Toooo
o`00F_o^k^h3oa4A4@07o`000?lA4A7o4A4Aoa4A4Ol0003o4A4AoaTI4@06
oa4A4@03o`000?lA4A7o4A4A00?o4A4A00?o0000oa4A4OlA4A402?lA4A40
0ol0003o4A4Aoa4A4@0<oa4A4@03o`000?lA4A7o4A4A00Wo4A4A00?o0000
oa4A4OlA4A401_lA4A401ol0003o4A4Ao`000?lA4A7o0000oa4A4Ol00000
0olA4A401ol0003o4A4Ao`000?l0003o4A4Ao`000?lA4A400_l000001?lR
8Q7o4A4Aoa4A4Ol00006oa4A4@04o`000?lA4A7o:Q48o`0000;o:Q480_l0
00001OlZ4@So0000o`000?lA4A7o000000Ko4A4A00Go0000oa4A4OlA4A7o
4A4AoaTI4@02oa4A4@06oaTI6OlA4A7o4A4Aoa4A4OlI6AWo4A4A0_lI6A40
1?lA4A7o6ATAoaTI6OlA4A42oaTI4@05oa4A4OlZ4@So4A4Aoa4A4OlI6AT0
0_lA4A401?lI6A7o6ATIob8R4OlI6AT2ob8R4@05oaTI4OlA4A7o4A4AoaTI
4OlI6AT00_lI6A400olI6AWo6ATAoaTI4@03oaTI4@06oaTI6OlI6A7o8R8A
oaTR8_lI6A7o:R8I0_lI6AT02?lZ8QWo6ATIob8R4Om4:R;oC4a4oeaLC?m4
A3;oA4@Z0_m4>RX01_lj>R;o6B8RoaTR8_lI6AWo8R8AoaTR8P;o:R8I00Ko
6B8RocXj8_lb:R;o:R8Ioc8Z8_m4:R82oc8Z8P;oA4@Z00koA3XRod@j:_m4
A2[oA4@Zoda48_m<C3[oA4@bod@j8_m4A3;oA4@Zoc8Z8_lj>R;oA3XRocXj
8P;oA3XZ00So>SXRob8b:_lR<R[o>SXRoaTI4Olb:R;o8R8AoaTR8P;o:R8I
1?lb:R801?lj>R;oA3XZod@j:_m4>RX3odA4<P09od@j:_mL>R;oC4a4odA4
C?m<C3[oC4a4ocY46Olj>R;oA3XZ00;oA4@b00KoA3XZoda<>_m<C3[oA4@Z
ocXj<_m4A382oda<>P;oA4@b0om<C3X01om4A2[oC4a4ofEU>_m<C4CoG5a<
ofe]E?m<C3X00_mLG4`01Om4A3;oC4`jodA4<_m<C4CoA3XR00?oA4@Z00Co
A4A<odA4<_m4A2[o>SXR0_m4A2X00om4>R[o>SXRocY4<P02ocXj8P;o<RXR
00_o6ATIoc8Z8_lI6AWo:R8Iob8R4OlA4A7o6ATAoaTI6OlZ8QWoA2XRobXR
6@03oaTI4@05oaTI6OlA4A7o6ATIoa4A4OlI6A400olA4A402_lZ4@So4A4A
oa4A4OlI6A7o4A4Ao`000?lA4A7o0000oa4A4Ol00002oa4A4@03o`000?lA
4A7o000000Co4A4A00So<RXRocY46OljA1WoQgiDofEU>_mLG4co<RXRoea]
MP;oE6ef00SoC6f7oeA]M_mDKGKoC5A]ocYLM_ljE5co>VF7ocYDG:Cok^k^
001JonKViP04oa4A4Ol0003o0000oa4A4@?o000000Co4A4Ao`000?lA4A7o
00000_lA4A400ol0003o4A4Aoa4A4@04oa4A4@07o`000?lA4A7o0000oa4A
4Ol0003o4A4Ao`00000<oa4A4@03o`000?lA4A7o4A4A00Go4A4A00Go0000
oa4A4OlA4A7o4A4Ao`000004oa4A4@04o`000?lA4A7o4A4Ao`0000;o4A4A
00Ko6ATAoa4A4OlA4A7o0000oa4A4Ol00003oa4A4@04o`000?lA4A7o0000
o`0000;o4A4A00?o0000oa4A4OlA4A400olA4A401_l0003o4A4Aoa4A4Ol0
003o4A4Aob8R4@;o4A4A0ol00002oa4A4@03o`000?lA4A7o4A4A00;o4A4A
0_l00003oa4A4@;o000000?o4A4Ao`000?l000000olA4A401?lI6A7o0000
oa4A4Ol00002oa4A4@03oaTI4OlA4A7o4A4A00;o6ATA0_lA4A402olZ4@So
6ATAoa4A4OlI6A7o4A4AoaTI6OlA4A7o6ATIoaTI4OlI6AWo4A4A00?o6ATA
00Oo4A4AoaTI4OlI6A7o6ATAoaTI6OlA4A7o6ATA00;o4A4A00?o6ATIoaTI
4OlI6AT00_lI6A404?lI6AWo4A4AoaTI4OlA4A7o:R8Ioa4A4OlI6A7o6ATI
obXR6OlI6A7o:R8IoaTI6OlZ8QWo6ATIoaTI4OlR8Q43oaTI6@0NoaTI4Om4
>R[oIE@bodA4<_mUE3;oC4a4ocXj8_m4:R;o>SXRod@j8_m4A2[o>T@Ioda<
>_lb:R;oA4@Zod@j:_m4>R;o>SXRoc8Z8_lj>S;o8S8Zob8Z:_m4>R[o>SXb
ob8b:_lI6AWo<RXRoaTI6OlR8Q7o6B8R0_lZ8QT02olR8Q7o<RXRoaTR8_lZ
8QWo<RXRobXR6OlR<R[o<RXRodA4:_ljA3;oC4@R00;oA3XR00GoA4@boeaL
C?m4A3;oC4`jofED<P03oeaLC006oda<>_m4A2[oC4`jodA4<_m4A2[oC4@R
0om4A3801om<C4CoA4@bodA4<_mLG4coIE`Zoda<>_m4A2X01?m<C3X00omU
IC[oG5a<oda<>P02oda<A007odA4<_mUE3;oC4a4oeaLC?m<C3[oC4a4oeaL
C003oda<>P;oC4a400So>T@bodA4<_m4>R[oA3XZodA4<_ljA1WoA4A<odA4
:P;oA4@b00?o>SXRoc8Z8_lb:R800olj>R801Olb:R;oA3XZod@Z8_lb:R;o
A2XR00;o:R8I1?lb:R801OlR:R[o<RXRob8R4OlZ8QWo6ATI00;o:R8I0_lR
8Q400olI6AWo:R8IoaTI4@06oa4A4@03o`000?lA4A7o:Q4800Co4A4A00?o
0000oa4A4OlA4A401?lA4A401Ol0003o6ATIoe`j8_mUIC[oC4@R00Co0000
00koC4a4ofe]E?lR>UcoC6f7odaDKOm<C4CoE6efocYDG?ljG7KoC5A]ocYD
G?m<E6go>UALodaDK@;o>Uaf00?o>UALocYLM_oVi^H0XooVi^H005[ok^k^
0_lA4A401?l0003o4A4Ao`000?lA4A42o`0001Co4A4A00?o0000oa4A4OlA
4A401_lA4A400ol0003o4A4Aoa4A4@03oa4A4@04o`000?lA4A7o4A4Ao`00
00Go4A4A00?o0000oa4A4OlA4A401OlA4A400ol0003o4A4Ao`000008oa4A
4@03oaTI4OlA4A7o4A4A00;o4A4A00?o0000oa4A4OlA4A401?l000003?lA
4A7o0000o`000?l0003o4A4AoaTI6OlA4A7o6ATAoa4A4Ol0003o4A4Ao`00
00?o4A4A00?o0000oa4A4OlA4A400ol000001_lA4A7o0000obXA2?lZ4@So
0000oa4A4@;o000000Oo6B8Roa4A4OlA4A7o0000obXA2?l0003o6ATA00Go
4A4A00?o6ATAoa4A4OlI6A400_lA4A400olI6A7o4A4AoaTI4@06oaTI4@07
oa4A4OlI6A7o4A4AoaTI4OlI6AWo6ATAoaTI6@02oaTI4@04oa4A4OlI6A7o
4A4Aob8R4@;o6ATI0_lI6A401_lI6AWo6ATAobXR6OlI6AWo6ATAobXR6@;o
6ATI017o8R8AoaTI6OlI6AWo:R8Iob8Z:_lI6AWo:R8IoaTI6OlR8Q7o6ATA
obXR6OlI6AWo8RXZoaTR8_lj>R;o8S8ZodA4:P03od@j:P08oc8Z8_lZ8QWo
>SXRob8Z:_m4>R[o<RXRob8b:_lR:RX2oc8Z8P?o>SXR02?oA3XZod@j8_m4
>R[oA4@bocY4<_m4>R[o>SXboda<>_m<C4CoA4A<oda<A?mLG4coC4a4odA4
<_ljA3;oA3XZodA4:_m<C3[oG5a<odA4<_m<C4Co>SXRodA4:_ljA3;o>SXb
odA4:_m4>R;o>T@boda<>_m<A2;oC4`jofED<_mLG4coIFDjoeaLC002oda<
>P05oda<A?m<C3[oA4@Zoda<>_m4A3800_m<C3X01_m4A2[oC4`joda<>_m<
C3[oIFDjoda<>P;oC4a400OoA4@ZoeaLC?m<C4CoC4a4oda<>_m<C4CoC4`j
00;oA3XZ00?o<RXRocXj8_m4A3800_m4>RX3ocXj8P0;od@j:_m4A3;oA4@b
oda<A?m4A2[oA4@bodA4:_m4A3;o>SXbod@j:_m<C3X00_m4>RX03_ljA4co
A3XZod@j:_m4>R[o>T@Iob8b:_ljA1Wo6ATIobXR6OlZ4@So>SXRoc8Z8_lR
8Q7o<RXR0olZ8QT01?lR8Q7o:R8IobXR6OlI6AT2obXR6@04ob8R4OlI6AWo
4A4AobXA20;o4A4A00Co:Q48oa4A4OlA4A7o4A4A0_l000001OlA4A7o0000
oa4A4OlA4A7o000000;o4A4A013o0000oa4A4Ol0003o0000oc8Z8_n7IC;o
IFDjoc8Z8_lR<R[oG5a<oea]M_mDKGKo>UALodaDKOljE5coC4a40_ljE5`0
1?m4A4co>UafocYDG?ljE5`2odaDK@?o>UAL0_mDKGH00oljE5cok^k^onk^
kP2Ronk^kP00F_ooool01OlA4A7o0000oa4A4Ol0003o4A4A00;o000000Co
4A4Ao`000?lA4A7o00000olA4A400olI6A7o4A4Aoa4A4@07oa4A4@03o`00
0?lA4A7o4A4A00Co4A4A00?o0000oa4A4OlA4A401_lA4A400ol0003o4A4A
o`000002oa4A4@03o`000?lA4A7o4A4A00;o4A4A00So0000oa4A4OlA4A7o
0000oa4A4Ol0003o4A4Ao`0000Oo4A4A00Co0000oa4A4OlA4A7o00000olA
4A401?l0003o4A4Aoa4A4Ol00003oa4A4@05o`000?lA4A7o0000oa4A4Ol0
00000olA4A400olI6A7o4A4Aoa4A4@03o`0000?o4A4A00Co0000oa4A4OlA
4A7o4A4A0_l000002_lA4A7o:Q48oaTR8_lI6A7o0000obXA2?lA4A7o0000
oa4A4OlZ4@P7oa4A4@03obXA2?lA4A7o4A4A00Go4A4A00?o6ATAoa4A4OlA
4A400_lA4A401_lI6A7o4A4AoaTI4OlA4A7o6ATAoa4A4@Go6ATA00Co6ATI
obXR6OlI6AWo6ATI0olI6A402_lI6AWo6ATAoaTI4OlI6AWo6ATAob8R4OlA
4A7o6ATIoaTI4OlA4A42oaTI4@09ob8R4OlI6AWo6ATAobXR6OlI6AWo6ATA
obXA2?lI8R;o:R8I00?o<RXR01CoA3XZob8b:_m4>R;o<RXRod@j:_lj>S;o
>T@IodA4<_m4>R[o<RXRod@j:_lb:R;oA4@Zoda<A?m4A3;o>T@boda<>_lj
A3;oA3XZocXj<P;oA3XZ0_lR<RX00om<C3[oA4@Zod@j:P05od@j:P0;ocY4
6Om4>R[o>SXRoda48_mUE3;oIFDjoeaLC?mUE3;oIFDjoeaLC?m<C3X00_m4
>R801?m4A2[oA4@boeaLC?mLG4`2oda<A008oda<>_m<C4CoA3XZodA4<_lj
>R;oA3XRoda<>_m4A2X2oda<>P04oda<A?m<C3[oA4@ZofED<P;oC4a400go
G5a<ocY46Om<C4CoA3XRofED<_m4>R[oA4@bob8b:_m4A2[oC4`jodA4<_lj
>S;o>SXR00;oA4@b00GoA3XZoda<A?m<C4CoC4a4odA4<P03oda<>P0HocXj
8_m4A3;oA4@bodA4:_m4A4coA4@ZocXj8_m4>R;oA2XRodA4:_ljA1Wo8RXZ
od@j8_lj>R;oC4@RodA4<_m4>R[oA4@Zoc8Z8_lj>R;o:R8Iod@Z8_lb:R;o
8S8Z0_lb:R801OlR<R[o<RXRob8R4OlZ8QWo6B8R00;o6ATA1_lR8Q42oa4A
4@06o`000?lA4A7o4A4Ao`000?lA4A7o00001?lA4A401?lZ8QWo4A4Aob8R
4OlZ4@P2o`000005oaTI4Om4A4co>UALoeb7SomDKGH00_m<MWh01?mDKGKo
C5A]odaDKOm<E6d2oeA]MP03ocYDG?lRC5CoA4A<00;o>UAL00Oo>TA<odA4
C?ljE5coC5A]ocYDG?m<E6go>Uaf00;oC5A]00?oE6efocYDG?ooool0Xooo
ool005[ok^k^00Co4A4Ao`000?lA4A7o00000_lA4A42o`0000Co4A4A0_l0
000;oa4A4@05o`000?lA4A7o0000oa4A4OlI6A400olA4A401?l0003o4A4A
oa4A4Ol00007oa4A4@04o`000?lA4A7o4A4Ao`0000?o4A4A00?o0000oa4A
4OlA4A401?lA4A401Ol0003o4A4Ao`000?lA4A7o000000Go4A4A00?o6ATI
o`000?lA4A401?lA4A401Ol0003o4A4Ao`000?l0003o4A4A00?o000000Co
4A4Ao`000?l0003o00000_lI6A400ol0003o4A4Aoa4A4@02o`0000Go4A4A
00?o0000oa4A4OlZ4@P00_l000000olZ4@So4A4AobXA2002obXA20?o0000
00?o8R8Aoa4A4Ol000000ol00004oa4A4@06obXA2?lI6A7o4A4AoaTI4OlA
4A7o6ATA0_lA4A401OlZ4@So4A4Aoa4A4OlI6AWo4A4A00;o6ATA00Ko4A4A
oaTI4OlI6A7o6ATAoa4A4OlI6AT2oa4A4@03oaTI4OlA4A7o4A4A00?o6ATA
00Go:R8IoaTI6OlR8Q7o:R8IoaTR8P02obXR6@?o<RXR00ooA3XZoc8Z8_m4
A2[oC4@Roc8Z8_m4A3;oC4`jocXj8_m4A2[oA3XZoda<>_lj>S;oA3XZocY4
<_m4>RX00_m4A3803olj>R;oA3XZodA4:_lj>R;oA4@ZocXj<_lj>R;o<RXR
odA4<_ljA3;o>SXRod@j:_lb:R;o>SXbod@j:P02ocXj8P03od@j8_m4A3;o
A3XZ00;oC4a4017o>TA<odA4<_m4A3;o>T@Iod@j8_m4A2[oC4@Roda<>_m<
C4CoC4`joeaLC?m<C3[oIE@boda<>_m4A2[o>T@boda<>P02odA4<P06oda<
>_m<C4CoC4a4oda<A?ljA3;oA4@b0_ljA1T00om<A2;oA3XRoda<A002oda<
>P05odA4:_m<A2;oC4@RocXj<_mLG4`01Om<C3X2ofED<P;oC4a40_m4A380
1?m4>R[oA4@bodA4<_m4A382odA4:P;oA4@b00CoA3XZodA4<_m4>R[o>T@I
0om4A3801om<C3[oC4a4odA4:_m4A3;oC4`jodA4:_m4>R800_m4A3804?m4
A2[oA4A<odA4:_m4A2[o>SXboc8Z8_m4A3;o>T@IocXj8_m4>R;o8S8ZocXj
8_lR:R[oA3XZoc8Z8_lZ8QT2oaTI4@03ob8R4OlZ8QWo6ATA00Co4A4A00Oo
:R8IoaTI4OlI6A7o6ATAoa4A4OlI6A7o000000?o4A4A00Go6ATAoa4A4OlR
8Q7o4A4Ao`000002oa4A4@;o000000WoA2XRodA4<_m]QgkoOXn?off7O_mf
Uk7oKHnGofenSom<MWh00_m]OXl02OmLKHOoG7InoeafO_mLMWkoG6efoeA]
M_ljE5coG6efoeAnOP02oeA]MP;oC5A]00?o>TA<ocYDG?ljE5`00_ljE5`0
1Om<E6go>UALodafO_ljG7KoE6ef0:Cok^k^001JonKViP05oa4A4Ol0003o
0000oa4A4Ol000000_lA4A43o`0000Go4A4A00?o6ATAoa4A4OlA4A400_lA
4A401?l0003o4A4Ao`000?l00006oa4A4@03o`000?lA4A7o4A4A00Go4A4A
0_l000000olA4A7o0000oa4A4@0:oa4A4@04o`000?lA4A7o4A4Ao`0000Ko
4A4A00Oo0000oa4A4Ol0003o4A4Ao`000?lA4A7o:Q4800?o4A4A00Wo0000
oa4A4OlA4A7o0000oa4A4Ol0003o4A4Ao`000?lA4A400_l00002oa4A4@09
o`000?lR8Q7o4A4Ao`000?lA4A7o8R8Aoa4A4Ol0003o:Q4800Co4A4A00_o
:Q48o`000?l0003o4A4Ao`000?lI6A7o4A4AobXA2?l0003o4A4AobXA2003
o`000006oa4A4Ol0003o4A4Aoa4A4Ol0003o:Q480_lA4A401?lI6A7o4A4A
oa4A4OlA4A42oaTI4@03ob8R4OlI6A7o6ATA00?o6ATA0_lA4A401OlI6AWo
8R8Aob8R4OlI6AWo8R8A00;o:R8I0olb:R802om4>R[o>SXboc8Z8_lb:R;o
A2XRob8b:_lj>S;oC4@RodA4:_ljA3;oC4@R00?oA4@Z00Go8S8ZocY4<_m4
A2[oA3XZocXj<P02od@j:P0EodA4:_lI6AWo<RXRobXR6OmL>R;o>T@Ioc8Z
8_m4>R;o>SXboda48_m4A2[oA4@bodA4:_m<C3[o>T@bod@j:_m4A3;oG5a<
od@j:_m4A2[oA4@b00;oC4`j00goC4a4odA4<_ljA3;oC4a4ocXj8_m<C4Co
>T@boda<A?mLG4co>T@boda<>_m4A2[oC4`j00;oA4@b00_oA3XRoda<A?m4
A4coA4@bodA4:_lj>R;oA4@Zoda<>_m4A2[oC4@Rod@j8P02odA4<P07ocXj
8_lj>S;oA4@bodA4:_mUE3;oG5a<ofEU>P02oda<>P;oG5a<00CoIFDjoda<
>_m<C4CoIE@b0_m<C3X01?m4A3;oIE@boda<A?m4A2X2oda<>P09odA4C?m4
:R;oC4`jocXj8_m<A2;oA3XZoda<>_m4A2[oA3XR00?oA4@b00KoC4@RodA4
<_mUIC[oC4`jodA4<_mUE382odA4<P03oda<>_m4A2[oA4A<00;oA4@Z0_lj
A3801olj>R;oA4@Zob8b:_m4>R[o>SXRod@Z8_m4A2X00om4>RX01_lb:R;o
8S8Zoc8Z8_lb:R;o:R8Ioc8Z8PCo8R8A00So4A4AobXA2?lI6A7o6ATAoa4A
4OlZ4@So8R8AoaTI4@Co4A4A00?o6ATAobXA2?lI8S800_lA4A401ol0003o
6ATAoa4A4Ol0003o6ATAobXR6Olj>S800_l000003_m]KECoShM]oinYZOnG
^L[oWjVYohNGZOmfUk7oKHnGofenSomLQiOoSiN?ohNO/On7OXooKHnG0_n7
UjT00on?UhooQiNYohNGZ@02ohNGZ@05ofenSomLMWkoKGj?oeb7Som]OXl0
0_mLQiL02OmDKGKoC5A]odaDKOlRC5CoC5A]ocYUQolA4A7o0000ocYLMP2T
onKViP00F_o^k^h01?l0003o4A4Ao`000?lA4A44o`0000;o4A4A00?o0000
oa4A4OlA4A400_lA4A400ol0003o4A4Ao`00000;oa4A4@03o`000?lA4A7o
4A4A00ko4A4A00Oo0000oa4A4Ol0003o4A4Ao`000?lA4A7o000000Go4A4A
0ol00003oa4A4@03o`000?lA4A7o4A4A00Wo4A4A00?o0000oa4A4OlA4A40
0_lA4A42o`000009oa4A4Ol0003o4A4Ao`000?lI6AWo4A4Ao`000?lZ4@So
4A4A00;o00001OlA4A400ol0003o4A4Ao`000002o`000003ob8R4OlI6A7o
000000Go00000_lA4A402?l0003o:Q48oa4A4Ol0003o6ATAoa4A4OlI6A7o
8R8A1?lI6A402?lI6AWo8R8AoaTI6OlR:R[o6B8Roc8Z8_lR:R[o:R8I0olb
:R803OlR>S;o<RXRocXj8_lb:R;oA4@bocY4<_m4>R[o8SXbob8Z:_lb:R;o
:R8Iob8j<_lj>S800_lj>R82ob8b:P08ob8Z:_lR<R[o8S8Zod@Z8_m4>R[o
>T@IocXj<_lb:R83ocXj8P03od@j:_lj>R;oA4@Z00;oA3XZ01Go>TA<oda<
A?m<C4Co>T@bod@j:_m4A3;oC4`jodA4<_m4A2[o>T@boda<>_mLG4coA4@Z
od@j8_m<C4Co>T@bodA4:_m4>R[oA4@ZocXj8_ljA3801?m4A3803om<C3[o
A4@Zoc8Z8_m4A3;o>T@boda<>_m4A2[oC4`joda<A?mLG4coC4a4ocXj8_m4
A2[oA4@bocXj8P02odA4:P;oC4`j0om4A3800om4>R[oC4a4ofED<P03oda<
>P05ocY4<_m<C4CoC4a4oda<>_mUE3800_m<C3X03OmUG2[oC4`joda<>_mL
G4coA4@bod@j:_m<C3[oIE@bodA4<_m<A2;oC4`jofEU>_m4A3800_mLG4`0
2?m<C3[o>TA<odA4<_m4A4coC4a4oda<>_m4A3;oC4`j0_m<C4@00om<C3[o
C4a4oda<>P03odA4<P03odA4:_m4>R[oA4@Z00GoA3XZ00?oA4@Zoc8Z8_lR
<RX01?lb:R82ob8R4@0:oc8Z8_lZ8QWo8R8AobXR6OlI8R;o:Q48obXR6OlI
6A7o4A4AobXA20;o4A4A00?o0000oa4A4OlA4A400_lA4A400olI8S;o:Q48
oa4A4@02oa4A4@04ob8Z:_m4A2[o4A4Ao`0000;o4A4A0_l000001olI6AWo
6ATAoa4A4OlA4A7o0000ohna`On7UjT00_m]SiL00om<OXooKHnGoff?U`02
ohNGZ@04ofenSomLKHOoE7inofenS`;oKHnG0_m]OXl00om]SiOoG8N?off?
U`02ofenS`08off?UomLQiOoC7Inoeb7SolRC5Co8SXboda]Qom]OXl2o`00
0005oea]QomDOWko6ATAo`000?lRA3X0Y?o^k^h005[ooooo00Oo0000oa4A
4OlA4A7o0000oaTI4Ol0003o4A4A00;o00004OlA4A400ol0003o4A4Aoa4A
4@04oa4A4@04o`000?lA4A7o4A4Ao`0000;o4A4A00?o0000oa4A4Ol00000
1olA4A400ol0003o4A4Ao`000002oa4A4@05o`000?lA4A7o0000oa4A4Ol0
00000olA4A400ol0003o4A4Ao`000003oa4A4@?o00000_lA4A400ol0003o
4A4Ao`000003oa4A4@04o`000?lA4A7o0000oa4A4@;o00000_lA4A401?lI
8R;o4A4Ao`000?l00002oa4A4@04o`000?lA4A7o6ATAoaTI4@;o4A4A00Ko
:Q48o`000?l0003o4A4Ao`000?lZ4@P2o`0000;o:Q480_l000001OlA4A7o
:Q48oa4A4Ol0003oC28800;o6ATA00[o>SXbob8b:_lb:R;o8S8ZoaTR8_lR
:R[o8S8ZobXR6Olb:R;o6B8R0olb:R801OlR:R[o<RXRob8b:_lj>S;o8S8Z
00;o8RXZ013o:R8Iob8Z:_lb:R;o:R8Iob8b:_lb:R;oA3XZoc8Z8_lj>R;o
8S8ZocXj8_lb:R;o8SXbob8b:_lb:R;oA3XZ0_lR<RX03?m4>R[o<RXRodA4
:_ljA4coA3XZodA4:_lR<R[o>SXbocY4<_m4A2[o>SXbocXj8P;o>T@b0_m4
A2X03Olj>S;oA3XZocY4<_m4A3;oC4`jod@j:_ljA1WoC4`joda48_m4A2[o
A3XRodA4:_m<A2800_m4A2X01?m4A3;oC4`jodA4<_m4A2X4oda<>P05oda<
A?m<C3[oG5a<oda<A?mUG2X00_m<C4@07_m<C3[oA4@bod@j8_m4>R[o<RXR
odA4:_ljA3;oA3XZocY46Om4>R[oA4@boda<A?m4A3;oC4a4oda<>_m4A3;o
>T@boda<>_m<C4CoIE@boda<>_m<A2;oA4@boda<>_lj>S;o>T@Ioda<>_mL
G4coA4@ZoeaLC0;oC4`j0_mLG4`02?m<A2;oC4`joeaLC?mLG4coC4a4oda<
>_m4A3;oC4`j0_m4A382od@j:P;oA4@b00SoA3XZocXj<_m4A4coA4@bocXj
<_m4A2[o>SXRodA4:P;o>SXR00CoA4@Zoda48_m4>R[oA3XZ0_lj>R800olb
:R;o>SXRob8b:P02oc8Z8P03ob8R4OlI6AWo8RXZ00?o8R8A00?o:Q48oa4A
4OlI6A401OlR8Q400olZ4@So4A4Aoa4A4@03oa4A4@;o6ATA0_lA4A401OlR
>S;o0000oa4A4Ol0003o4A4A00;o8R8A00?o:R8Ioa4A4OlA4A400olA4A40
3?l0003o6ATAoaTI6OlA4A7o6ATIoaTR<_m]Sk7oOXn?oeafO_mLKHOoE6ef
odafOP;oC6f700?oKHnGofenSomLQhl00_mDOWh00omLQhooE7inoda]Q`02
ocYLMP0Bob94>_m<MWkoIINao`000?lb>TCo6ATAo`000?lR<R[o0000ocYD
G?mLMWko<SY4o`000?m4WhooKGj?oda]Qol0003o6E@bY?ooool005[ok^k^
00Wo4A4Ao`000?l0003o4A4Ao`000?lA4A7o0000oa4A4Ol000001OlA4A40
0ol0003o4A4Aoa4A4@07oa4A4@03oaTI4OlI6AWo000000Oo4A4A00?o0000
oa4A4OlA4A403OlA4A400olZ4@So4A4Ao`000006oa4A4@;o00000olA4A40
0olZ4@So4A4Ao`00000=oa4A4@04oaTI4Ol0003o0000oa4A4@;o000000oo
4A4AoaTI4OlA4A7o4A4Ao`000?lZ4@So4A4Ao`000?lI6A7o8R8AoaTR8_lZ
8QWo8R8Ao`000?lA4A400_l000001?lA4A7o:Q48ob8R4OlZ4@P2o`00000?
obXA2?l0003o0000o`000?lZ4@So0000oa4A4Ol0003o8R8AobXR6OlI6AWo
:R8IoaTR8_lZ8QWo6ATI00?o<RXR00?o:R8Ioc8Z8_lR8Q400_lb:R801?lR
<R[o<RXRoc8Z8_lR8Q42obXR6@08ob8Z:_lb:R;o<RXRod@j:_lj>R;o<RXR
ob8b:_m4A2X2oc8Z8P0AocXj8_m4A3;o>SXRodA4<_ljA3;o>SXbod@j:_lj
>R;o8S8Zod@j:_lR<R[o>SXRob8b:_lZ8QWoA4@ZocXj8_lb:R800_m4>RX2
odA4:P05odA4<_m<C3[oA4@bofEL:_m4A3800_m<C3X02_m4A3;oC4`joda<
>_mLG4coC4a4ofEU>_m<C4CoC4`joda<A?m<A282oda<>P0=oda<A?m<C3[o
>T@boda<A?m4A3;oC4`joeaLC?m<C3[oG5a<oda<A?m<C3[o>SXboda<>P03
odA4<P0;ocXj8_m4A3;oA3XZodA4:_lb:R;oC4@RodA4C?m4A2[o>SXbocXj
8_mUE3800_m4A3801omUE3;oC4`joda<>_m<C3[oG5a<oda<>_mLG4`00_mU
ICX03?mUE3;o>T@bod@j:_m4A2[o<RXRodA4:_m4A3;oA3XZoda48_m4A2[o
C4`jod@j:P;o>T@I00OoA4@Zod@Z8_ljA1WoA4@Zob8b:_lj>R;oC4a400?o
C4`j00CoIE@boda<>_m4A3;oA3XZ0_m4A3802_lj>S;oA3XZoc8Z8_lj>R;o
<SY4ob8R4OlI8R;o:R8Ioc8Z8_lI6AT2obXR6@;o6ATA00Co4A4AobXA2?lZ
4@So00000_lA4A42oaTI4@Co4A4A00[o0000oaTI4OlA4A7o8R8AobXA2?lI
6A7o:Q48oa4A4OlZ4@So4A4A0_lZ4@P00olI6A7o4A4Ao`000002o`000008
oa4A4OlZ8QWo:R8Iob8R4OlI6A7o0000oa4A4Ol00002oa4A4@;o6ATI01Go
0000oc8Z8_l0003o6B8RogJG/Om]SiOoOXn?oinYZOn?UhooC7jGofefM_m<
MWkoE6efob9<E?m<OYOo>TA<o`000?m<OXoo6ATAo`000?m]KE@00_l00000
4?ljE5co4A4AoaTI6OljA4co0000oaTI6Ol0003o>UALoeAfUomLQiOo0000
oaTR8_mLQiOoMYNaoa4A4Ol0002Tonk^kP00F_oVi^H2oa4A4@03o`000?lA
4A7o4A4A00;o4A4A00?o0000oa4A4OlA4A401olA4A400ol0003o4A4Ao`00
0002oa4A4@04o`000?lA4A7o4A4Ao`0000;o4A4A00Go0000oa4A4OlA4A7o
4A4Ao`000006oa4A4@03o`000?lA4A7o4A4A00Co4A4A00?o0000oa4A4Ol0
00001?lA4A403?l0003o4A4Aoa4A4OlA4A7o0000oa4A4OlZ4@So0000oa4A
4Ol0003o4A4Ao`0000;o4A4A00Ko0000oa4A4OlA4A7o0000obXA2?l00002
oa4A4@03o`000?lI6A7o000000;o4A4A00Co0000obXA2?lA4A7o00000_lA
4A402?lZ4@So4A4Ao`000?lA4A7o0000oa4A4Ol0003o4A4A0_lR:RX01olZ
8QWo<RXRob8b:_l0003o4A4Ao`000?lZ4@P00_l000000olI6AWo0000obXA
2002o`000003oa4A4Ol0003o000000Co4A4A00Go:R8Iob8Z:_lZ8QWo:R8I
ob8Z:P03obXR6@0Kob8Z:_lb:R;o:R8Ioc8Z8_lI8R;o<RXRobXR6Olb:R;o
:R8Iob8b:_lZ8QWo8RXZobXR6OlR8Q7o<RXRob8b:_lI6AWo<RXRob8Z:_lj
>R;o<RXRocXj8_lb:R;o8S8Zoc8Z8_m4>R[o:R8I00;o>SXR0_m4>RX01_lj
>R;oA4@Zod@Z8_lj>R;oA3XZoda<>P;oA4@Z00GoC4a4odA4C?ljA3;oA4@Z
oda<A002oda<>P?oA4@b00oo>SXRodA4<_m<C3[oC4a4ofEU>_m<C3[oC4a4
oda<>_mLG4coC4a4oda48_m<C3[oC4a4ocXj8_lR<RX00_m4>RX00olb:R;o
C4`joda<A002oda<A0?oC4`j00CoG5a<oda<A?mLG4coIFDj0om<C3X03_mL
G4coC4`joeaLC?m4A3;oA4@ZodA4<_mUE3;oA4@bodA4:_m<C4CoA4@boda<
>_m<C4CoA4@b0_m4>RX02?m4A2[o>SXbod@j:_lj>R;oA4@Zod@Z8_m4>R[o
A4@Z0_m4A382odA4:P08oda<A?m4A2[oA4@bod@j:_m4A3;oC4`jod@j8_m4
A382od@j:P0HoeaLC?m<C4CoA4@bodA4C?m4A2[oA3XZodA4:_m4A3;oA4@Z
ocY4<_m4>R[oA4@bocY46Olb:R;oC4@Roc8Z8_lZ8QWo>T@Iod@j:_lZ8QWo
6ATAob8Z:_lI6AWo6ATA0_lA4A400olZ4@So0000oa4A4@03oa4A4@;o0000
00ko:Q48ob8R4OlZ8QWo8R8AocXj8_lZ8QWo6ATIo`000?lA4A7o0000oa4A
4Ol0003o4A4AocXj8P?o8R8A00Ko:Q48o`000?lA4A7o4A4Ao`000?lR8Q42
oc8Z8P03ob8R4OlA4A7o4A4A00;o4A4A00oo0000oa4A4OlA4A7o6B8RobXR
6OlI8R;o0000odanUom]OXooG7InoaUfM_ljA4coE7inoff?UomnShl00_l0
00006OlR<R[oG6f7o`000?lR<TCoC7Ino`000?lRC5Co6ATAoa4A4Ol0003o
4A4AoaTR8_mLG4co0000oaTI4Ol0003o6GIfohNGZOmUQjWoC4`jo`000?lR
C5CoKHnGoeA]M_l00000Y?oVi^H005[ok^k^0_l000000olA4A7o0000o`00
0002o`000004oaTI4Ol0003o0000o`0000Co4A4A00?o0000oa4A4OlA4A40
2OlA4A401Ol0003o4A4AoaTI4OlA4A7o000000Co4A4A00?o6ATAo`000?lA
4A400_lA4A400ol0003o4A4Aoa4A4@05oa4A4@03o`000?lA4A7o4A4A00Wo
4A4A00?o:Q48oa4A4OlA4A400_lA4A401olI6A7o:Q48oaTI6OlI6AWo:R8I
oaTI4OlR8Q400_lZ8QT01_lZ4@So6ATAobXA2?lI6A7o:R8Ioa4A4@;o0000
00Co4A4Ao`000?lR8Q7o:Q480_lA4A401OlZ4@So8R8Aoa4A4OlA4A7o0000
00;oA3XZ00?oA4@ZocXj8_m<A2800_l000001_lZ4@So0000o`000?lA4A7o
0000obXA20;o000000?o:Q48o`000?l000000olA4A42o`000003oc8Z8_lR
:R[o8RXZ00;o<RXR013o8RXZobXR6Olb:R;o<RXRocXj8_lR<R[o8SXbob8b
:_lb:R;o8RXZoc8Z8_lR:R[o<RXRocXj8_lR:R[o8R8A0_lb:R801Om4:R;o
A3XRodA4:_m<C3[oA4@Z00?oC4`j00GoA3XZocY4<_lj>R;o>T@bodA4<P02
od@j:P0=ocXj<_ljA3;oA3XRoda<>_ljA3;oA3XZob8b:_lj>R;oA3XZob8R
4Om4>R[o>SXRocY46@02od@j:P05odA4:_m<C4CoC4a4odA4<_m4A4`00_m4
A3802Om4>R;oC4`joda<>_m<C3[o>T@bod@j:_m4A2[oA3XZodA4:P03oda<
>P03ofEU>_mLG4coG5a<00;oC4`j0_mLG4`02_mUIC[oC4a4oeaLC?m<C4Co
C4`joda<A?m<C3[oA4@bod@j8_m<C4@2oda<>P;oA4@Z00GoC4a4odA4:_m<
C4CoA4@Zod@j8P03ocXj8P0@oc8Z8_lj>R;o>SXRoda<>_m4A3;oA4@ZodA4
<_m4A4coA4@Zoda<>_m<A2;oA4@bocY46Om4A3;oC4`joda<A0;oA4@Z00Wo
C4a4odA4:_m<A2;oA4@boda<A?m<C3[oA4@ZodA4<_m<C4@00olj>R800om4
>R[o>SXRoc8Z8P02oc8Z8P05obXR6OlI6AWo:R8Iob8R4OlZ4@P00olI6A40
2?l0003o4A4Ao`000?lZ4@So4A4Ao`000?lA4A7o00001?lA4A401_lR8Q7o
6ATAoaTI4OljA4co6ATAobXR6@;o4A4A00Co:Q48oaTI4OlZ4@So8R8A0_lZ
4@P01_lA4A7o0000o`000?l0003o>SXbob8R4@;o<RXR00?o:Q48oa4A4Ol0
00000_l000002?lA4A7o:R8IoaTI4OlR8Q7o6B8Ro`000?lA4A7o00000_lA
4A402?l0003o8RXZoaTI4OlZ4@So0000oa4A4OmLQiOoQiNY0ol000006?lR
C5CoKHnGoa4A4OlA4A7o0000oeb7Solb:R;o0000off?UolZ8QWo0000oda<
A?l0003o4A4Ao`000?lA4A7oIINaoaTI4OlA4A7o6ATAo`000?lIMWKoG8NG
off?U`;o000000?oKHnGogJG/Ol00000Y?o^k^h005[ooooo1olA4A400ol0
003o4A4Aoa4A4@06oa4A4@03o`000?lA4A7o4A4A00;o4A4A00Oo0000oa4A
4OlA4A7o4A4AoaTR8_l0003o8R8A00Co4A4A00?o6ATIoaTI4OlI6A401OlA
4A401_lI6A7o4A4AoaTI4OlI6AWo4A4AoaTI6@;o6ATA00Co:Q48obXR6OlI
6A7o6ATA0_lI6AT02_lI6A7o6ATIoc8Z8_lI6A7o6B8RobXR6OlI6A7o6ATI
oaTI4OlA4A42oaTI4@03oa4A4OlI6A7o6B8Z00;o:R8I00_oA2XRoc8Z8_m4
>R[oA3XZoda48_m<C3[oA3XZod@j8_lR8Q7o6ATAo`000002oa4A4@?o0000
00Go:Q48oa4A4OlR>S;o6E@bodA4:P02o`000005oda<>_lI8R;o6B8RobXR
6OlR:RX00_lZ4@P2o`0000;o:Q4800So4A4Aod@A0?lZ4@So:Q48o`000?lA
4A7o0000oa4A4@?o000000Co6ATAob8Z:_lb:R;o<RXR0_lI8R82ob8R4@;o
<RXR00Go:R8Ioc8Z8_lR<R[o<RXRocXj8P03oc8Z8P0:od@j:_lb:R;o8S8Z
odA4<_lj>S;o8S8Zob8Z:_lb:R;o8S8ZodA4<P;oA3XZ00Ko>SXRodA4:_lj
>S;oA3XZoc8jA?m<C3X2ocXj<P08ocXj8_lR>S;oA3XZoaTI6Olj>R;o8T@j
odA4<_m<C3X2odA4:P03oda<>_m4>R[o>SXb00;oA4@b00coA4A<odA4<_m4
A2[oC4`joda<A?m<C3[oA3XZodA4<_mUIC[oA4A<od@j8_m4A2X2oc8Z8P06
oda<A?m<C3[oC4`joda<>_mLG4coC4a40_m<C3X01om4A3;oC4`jofED<_m<
C4CoA4@boda<>_m<C4@00_m4A3801_m4>R[oC4`jodA4:_m<C3[oC4a4odA4
C0;oC4`j00SoA4@Zoda<>_m4A3;oA3XZocY4<_m4A3;oA3XZocXj8P;oA3XZ
00CoA4@Zoda48_m4A3;oC4`j0_mUE382odA4:P05ocY4<_m4A2[oC4a4ofEL
:_m<C4@00om4A2X02?m4>R[oA4@ZocY4<_m4>R[o8S8ZocXj8_lb:R;o8S8Z
0olZ8QT02?lI6AWo:R8IoaTI4OlZ8QWo6ATAoa4A4OlI6A7o:Q480_lI6A40
1?lR8Q7o4A4Aoa4A4OlI6A43oa4A4@;o6ATA00Co0000oa4A4OlZ4@So:Q48
0_lR8Q400olI6AWo4A4Aoa4A4@03oa4A4@03oaTR8_l0003o4A4A00;o0000
00?o8SXbob8R4OlR8Q400_lZ8QT02?lR8Q7o:Q48o`000?lA4A7o0000ob8R
4OlRA3[o:Q480_lA4A42o`0000;o4A4A0ol000001_lA4A7o6ATAoa4A4OlI
6AWo4A4Ao`0000;o6ATI00So4A4AoeaLC?lZ8QWo4A4Ao`000?ljIIOoKHnG
oeaLC0?o000001;o>UALo`000?lA4A7o0000oda]QomDKGKo0000oeb7Solj
A4co0000oeA]M_lA4A7o0000oea]M_l0003o6GIfoff?Uol00002oa4A4@08
o`000?lR<R[oKHnGob8j<_l0003oC7jGofenSoljE5bTooooo`00F_o^k^h2
oa4A4@06oaTI6OlA4A7o0000o`000?lA4A7o00001?lA4A400olI6A7o4A4A
oa4A4@04oa4A4@07oaTI4Ol0003o6ATAoa4A4Ol0003o6ATAo`000002oa4A
4@07oaTI4OlA4A7o:Q48oaTI4OlI6AWo6B8RoaTI6@02obXR6@0<oc8Z8_lI
8S;o<RXRoc8Z8_lR:R[o6B8RobXR6Olj>S;o8RXZobXR6OlR:R[o:R8I0_lI
8R802?lZ8QWo<RXRoaTR8_lZ4@So8R8AoaTI4OlI6AWo:R8I0_lI6A400olZ
8QWo6ATAobXA2003oa4A4@0IobXA2?lI6A7o8R8Aob8Z:_lZ8QWo>SXRob8b
:_lZ8QWo8S8Zoc8Z8_lI6AWo<RXRobXR6OlI6A7o0000oa4A4OlR8Q7o0000
oa4A4OlZ4@So0000oaTI4OlR8Q7o>T@Iob8R4@02o`000008oda<A?lj>S;o
A4@bocXj<_m4>R;o0000oa4A4OlZ4@P2o`000005oaTI4Ol0003o:Q48obXA
2?m44@000_lZ4@P03OlR:R[o0000oa4A4OlA4A7o6ATAob8Z:_lj>R;o8S8Z
ocXj<_m4>R[o8SXbodA4<_lRA3X00_lR<RX00om4A3;oA3XZoc8Z8P04oc8Z
8P07ob8Z:_lb:R;o<RXRoc8Z8_lI8R;o<RXRoaTR8P02oc8Z8P04od@j:_lj
>R;o<RXRod@j:P;o<RXR00Wo>SXbod@j:_m4A3;o>SXbocXj8_m4>R[o>T@b
obXR6OlR<RX00om4>RX03om4A3;oA4@ZodA4:_m4A4co>T@IocXj<_m4A3;o
C4a4odA4:_m4A3;oC4`joda<A?m<C3[oA3XZoda<>P02odA4<P0:od@Z8_lj
A1WoA3XZod@Z8_m4>R[o>T@Ioda<>_m4A4coA3XZoda<>P?oC4a400_oA4@b
oda<>_m<C3[oC4`joeaLC?m<C4CoC4`joeaLC?ljA3;oA4@bodA4:P02odA4
<P07oda<>_m4>R[oA2XRodA4<_m4A2[o8S8ZocXj8P02od@j:P03od@j8_m4
>R[oA4@b00?oA4@Z0_m4>RX00olj>S;oA3XZod@j:P02oc8Z8P06odA4:_lZ
8QWo<RXRoc8Z8_lR:R[o<RXR0_lZ8QT02?lb:R;o:R8IobXR6OlZ8QWo8R8A
oaTI4OlZ8QWo6ATA0_lZ8QT02OlI6A7o:Q48oaTI6OlZ4@So8R8AobXA2?lI
6A7o:Q48oaTI4@02oa4A4@05obXA2?lA4A7o4A4Aoa4A4Ol000000_lA4A43
o`000005obXA2?m4A3;oA3XRo`000?lI6A400ol000001_lI6AWo0000o`00
0?lA4A7o0000obXA20;o4A4A00Co0000oa4A4OlI6A7o6ATA0_lA4A400olI
6A7o:Q48o`000002o`000004oa4A4OljA4co0000oa4A4@;o6ATA1?l00000
1om4A3;oA3XRodA4<_lR:R[o0000obXR6Ol000000olA4A401?l0003oC4a4
oaTI6OlI6AT2oa4A4@0;oeb7Son7UjWo4A4AoeA]M_lI6A7o6B8Ro`000?lj
E5coC6f7odaDKOm<KHL01?l000001?mDOWkoG5a<o`000?m<OYL2o`00000<
ogJG/OlA4A7o0000oeb7SolI6A7o0000odanSomLQhoo6ATAob94>_mLQhoo
G7InY?o^k^h005[oi^KV00Co6ATIoa4A4OlA4A7o00000olA4A401Ol0003o
4A4Aoa4A4OlA4A7o6ATI00;o4A4A00Go:Q48oa4A4OlI6AWo8RXZoa4A4@02
oaTR8P03ob8Z:_lI6A7o8RXZ00;o6B8R00So8RXZoaTI6OlI6AWo8RXZoaTR
8_lR8Q7o8RXZoaTI6@;o6B8R00Co6ATAobXR6OlI6AWo6B8R0_lZ8QT09olI
8R;o<RXRoaTI6OlI8R;o:R8IoaTI6OlZ8QWo6ATIob8R4OlI6A7o:Q48oc8Z
8_lI8R;o:R8Iob8Z:_lZ8QWo6B8RobXR6OlR8Q7o0000oa4A4OlZ4@So4A4A
obXA2?lI6A7o4A4AoaTI6OlA4A7o6ATAobXA2?lR:R[oA2XRob8b:_lb:R;o
A3XZocY46OlI6AWo:R8IoaTI4@02o`000004obXR6Ol0003o0000o`0000?o
4A4A00_o>T@Ioc8Z8_lA4A7o0000oda<A?m4A3;oC4a4odA4<_m4A2[o:R8I
oa4A4@02o`000009obXA2?lR8Q7o0000od@A0?lR8Q7o8RXZobXR6Ol0003o
6ATI00?o000000Ko:R8IocXj<_lR<R[o6B8RobXR6OlI6AT2oc8Z8P07oaTR
8_lb:R;o8RXZob8Z:_lb:R;o8RXZod@Z8P02ob8Z:P04oc8Z8_lj>S;o8S8Z
obXR6@;o<RXR017oC4`jodA4:_lb:R;o>T@Ioda<>_lj>S;oA4@ZodA4<_lj
>S;oA4@bodA4:_ljA3;oA4A<odA4:_ljA4coC4`jod@j8P03od@j:P03odA4
C?lj>S;oA4@b00;o>SXb0_m4>RX01om4A2[oA4@bofED<_m4>R[o>SXbodA4
<_m4A2X00_m<C3X02?m4A3;oC4a4oda<A?m<C4CoA4@ZodA4C?mLG4coC4a4
0_m<C3X01_m4A3;oC4`jocY4<_ljA1WoA4@bocY46@;o<RXR0_m4>RX00olb
:R;o>SXRod@j:P04odA4<P0<odA4:_lj>S;o>T@Iob8b:_m<C4Co<SY4ocXj
8_m4A2[oA3XZocXj8_lb:R;o8S8Z0_lb:R801OlR:R[o:R8IobXR6Olb:R;o
6B8R00?o:R8I00?o8R8AobXR6OlZ8QT00olR8Q401?lZ4@So:R8IoaTI4OlZ
4@P2obXR6@0:oaTI4OlI6AWo8R8Aob8R4OlI6A7o6ATIobXA2?lR8Q7o4A4A
ob8R4@;o6ATA00?o4A4AoaTI4OlZ4@P00olA4A400olZ4@So4A4Aoa4A4@02
oa4A4@?o:Q4800Co4A4AoaTI4OlA4A7o00000olA4A401Olb:R;o4A4Aoa4A
4Ol0003o<RXR00;o4A4A0ol000000olR<TCo0000oa4A4@03o`000003oa4A
4Ol0003o6ATA00?o4A4A0_l000001Olj>S;o:R8Ioc8Z8_lb:R;o000000?o
4A4A00Oo0000odA4<_m4>R[o8S8Zob8Z:_l0003o6B8Z00;o4A4A00co6B9<
oa4A4OlA4A7o0000oaTI6OlA4A7o6ATIoaTR:_lI8S;oG8N?ofenSom]SiL3
oa4A4@0Job94>_mLKHOoE6efoeAnO_lI6A7o0000oa4A4Ol0003o8TaDohNG
ZOl0003o4A4AobXR6Ol0003oE7inodA4C?l0003o8T@joeafO_l0003o4A4A
odanUolR>S;o0000ob9<E?mDKGJTonKViP00F_o^k^h2oaTI6@?o4A4A0_l0
0002oa4A4@08obXA2?lR8Q7o6ATAoaTI6OlR8Q7o6B8Rob8R4OlI6AT3ob8Z
:P07ob8j<_lI6AWo6B8RobXR6OlR:R[o6B8RobXR6@02ob8R4@0FoaTI6OlZ
8QWo:R8IoaTR8_lR8Q7o<RXRobXR6Olb:R;o:R8IoaTR8_lj>S;o6B8Rob8R
4OlR:R[o6B8Rob8R4OlI6AWo:R8Ioc8Z8_lI8R;o6ATAoaTR8P;o:R8I00[o
6ATAob8R4OlI6AWo8R8AobXR6OlI6A7o:R8IoaTI6OlR8Q7o:Q480_lI6A40
3_lZ4@So4A4Aoa4A4OlI6A7o:Q48ob8R4OlZ8QWo6ATIob8R4Om4:R;oC4@R
od@Z8_m4>R;oG3XR0_lR<RX02?l0003o:Q48oa4A4Ol0003o:Q48o`000?lZ
4@So4A4A0_lZ4@P02olI6AWo0000o`000?lb:R;oA4@bodA4C?lR<R[o>SXb
obXR6OlZ4@So4A4A00?o000000Co4A4Aod@A0?m4:R;oA3XZ0_lI6AT01olR
<TCo6B8ZocY4C?m4>R[o6B8RobXR6Olb:R800_lR:RX01?m4>R[o8RXZoc8Z
8_lR<RX2obXR6@0?ob8b:_lR>S;o<RXRob8bA?m4:R;o8SXbocXj<_m4>R[o
8RXZoda<>_lR>S;o<SY4ob8b:_lR:R[o<RXR00;o8S8Z00?o:R8IocXj<_lR
<RX00_lj>R803Olb:R;o:R8IocXj8_lj>R;o>SXbod@j:_lZ8QWo8S8Zod@j
:_lj>R;oA3XRocXj8_m4A2X00_m4A3806_m<C3[oA4A<oda<>_m4A3;o>TA<
od@j8_mLG4coC4`joda<A?mLG4co>T@bod@j:_lb:R;oA3XZob8b:_lj>R;o
>T@bocY46OljA3;oA3XRocY4<_mUE3;oG5a<odA4:_m4>R;oA4@b0_m<C3X0
2?m4A2[oC4`jodA4:_lj>S;oA3XRob8j<_lj>R;oA2XR0_lb:R800olR:R[o
<RXRoc8Z8P02oc8Z8P08obXR6Olb:R;o6ATIob8R4OlZ8QWo8R8AobXR6OlI
6AT2ob8R4@04obXR6OlI6AWo6ATIobXR6@;o8R8A01;o:R8Iob8R4OlR8Q7o
8R8AobXR6OlR8Q7o6B8Rob8R4OlI6A7o:R8Iob8R4OlZ4@So6B8Rob8R4OlZ
4@So4A4AoaTI4OlZ4@P3oa4A4@03obXA2?lA4A7o4A4A00;o4A4A00Go0000
oa4A4OlA4A7o4A4AoaTI4@04oa4A4@04o`000?lA4A7o0000o`0000;o4A4A
0_l00002oa4A4@03o`000?lR8Q7o4A4A00;o00000_lI6A402?l0003o4A4A
oa4A4Ol0003o:R8Ioa4A4Ol0003o4A4A0olb:R800om4>R[o<RXRo`000002
o`000007oa4A4Ol0003o:Q48ocY4<_lR<R[o:R8Ioa4A4@04o`000006oaTR
8_lR8Q7o8R8AoaTI6Ol0003o<RXR0_l000003?lI8S;o6B8Zoa4A4OlR8Q7o
6ATAoa4A4Ol0003o4A4Ao`000?mDOWkoKHnGodafOP;o000001_oC4a4o`00
0?m<OXooE6efoea]Qolb>TCo0000oa4A4Ol0003o4A4Aoeb7Uom]SiOo0000
oaTR8_l0003o>UafodaDKOl0003o4A4AoaTR8_lI6AWo0000oc8Z8_l0003o
4A4Ao`000?ljE5`03_o^k^h00ooLg=cok>c/onk^kP02on?Sh`?ok^k^00?o
gMgMomoOgoo^k^h01?o^k^h00ooShn?of=SHonk^kP0=onk^kP03omGEeOo/
k>cok^k^07Cok^k^001Jooooo`;o4A4A00So0000oa4A4Ol0003o0000oa4A
4Ol0003o4A4Ao`0000?o8RXZ017o<RXRodA4C?m4A3;o>TA<oda<A?m4A3;o
C4`joc8Z8_lR<R[o>SXboc8Z8_lR>S;o6B8boc8Z8_lI8R;o8RXZoaTR8P03
ob8Z:P0=obXA2?lA4A7o8RXZoaTR8_lI6AWo6B8Rod@Z8_lI6AWo6B8bobXR
6OlI8S;o8R8AoaTI6@02oaTR8P0>oaTI6OlZ4@So:R8IoaTR8_lI6A7o8RXZ
oaTI6OlI8R;o6ATIoaTI4OlI6AWo:Q48oa4A4OlI6A42oa4A4@03o`000?lA
4A7o000000;o4A4A00_oA3XZoda<>_mUE3;oSgIUofEL:_mUE3;oC4a4od@j
:_lb:R;oA4@boaTI6@02oa4A4@0=o`000?lR8Q7o4A4Ao`000?lA4A7o0000
obXA2?l0003o:Q48oaTI4OlA4A7o0000oda<A002ocXj<P;oA4@b00Co8S8Z
obXA2?l0003o00000_lA4A401ol0003oA140ocY46OlR>S;o<RXRoa4A4Olj
>R800_mLG4`01Olj>R;o<RXRocXj<_lRA3[o8RXZ00;o<RXR0_lZ8QT06olb
:R;o8RXZoc8Z8_lZ8QWo<RXRob8Z:_lR<R[o:R8Iob8b:_lb:R;o8S8ZobXR
6OlA4A7o8R8AobXR6OlR8Q7o<RXRod@j:_lb:R;o:R8IocXj<_lj>R;oA3XZ
ocXj<_m4A2[oA4@boda<>P02ocXj<P03od@j:_m4A2[oA3XZ00;oA4@Z00?o
>SXRodA4:_m4>RX00_m4A3800om4A4coA4@boda<>P02ocY4<P04odA4:_m<
C3[oA4@ZocY4<P;oA4@Z00SoC4`jod@j:_m4A2[oA3XZocY4<_m4>R[o>SXb
od@j:P;o>SXR00CoA3XZodA4:_lb:R;o>SXR0_lb:R82ob8b:P08oc8Z8_lZ
8QWo<RXRob8b:_lI6AWo:R8Iob8Z:_lb:R82obXR6@;o8R8A00Co6ATIob8R
4OlZ8QWo8R8A0olZ8QT00olZ4@So:R8IoaTI4@02ob8R4@;o:R8I0olR8Q40
1_lI6AWo8R8AoaTI4OlI6AWo8R8Aoa4A4@;o6ATA0_lR8Q402?lZ4@So4A4A
oa4A4OlI6A7o4A4AoaTI4OlA4A7o6ATA0_lA4A402?l0003o4A4Aoa4A4Ol0
003o8R8AobXR6OlZ4@So>SXR0_lA4A400olI6A7o6B8RoaTI4@02oa4A4@07
o`000?lA4A7o:Q48o`000?lA4A7o0000oa4A4@02oaTI4@07oa4A4OlZ4@So
4A4Aob8R4OlZ8QWo0000oa4A4@02o`000003oc8jA?lA4A7o6ATA00;o0000
00?oA4@bo`000?l000000_l000001?m4>R[o8S8ZocXj<_lA4A42o`000008
oa4A4Ol0003o4A4Aob8R4OlI8R;o8R8AoaTI4OlA4A42o`000003oa4A4Ol0
003o4A4A00Co4A4A00Co6B8Roa4A4Ol0003o6B8Z0olA4A409Ol0003o4A4A
o`000?lR8Q7o0000ocYDG?m<MWko<SY4o`000?lI6AWoG7Ino`000?m<OXoo
C6f7oeafO_m<KHOo0000oaTR8_m<C4Co0000ob94>_mfUk7o0000oaTI4Ol0
003o8T@joda]QolA4A7o6ATAoa4A4Ol0003o4A4AocYDG?lZ4@So0000oa4A
4OlIE3801Oooool07_lf=SKoMgMgoooooooooooom_KfobHV9_m6ATKoo_kn
oe5ADOl820So6QXJoibLW?lC4a?oEeMGoooooooUiNGo@410o`000?lB4Q;o
7AdMooShn?ooooooinOWodY:B_l30`?o8b<SoaLG5oo1`L7oCTi>ogAdM0Go
oooo00Wo;bl_oemOGooooooodm?CobDU9OlN7Qko^[Zjoooooolf=SH01?l0
00001?lj>S[ooooood10@?moOgl2ooooo`0:od10@?moOgoooooooooooonS
Xj?o71`Looooooo8b<So0000o`X:2P?o3`l?00?oGUiNooooooooool0FOoo
ool005[ok^k^00Oo4A4Ao`000?l0003o0000oa4A4Ol0003o4A4A00;o0000
00Co4A4Aoc8Z8_lI8R;o6B8b0_lb:R802OlR<TCo8RXZoaTI6OlR:R[o6B8R
oa4A4OlI8R;o8RXZoaTR<P02ob8Z:P09oaTI4OlI8R;o8RXZob8j<_lR:R[o
8S94oaTR8_lZ8QWo6B8R00;o8RXZ00go6B8Roc8Z8_lI8R;o6B8RobXR6OlI
6AWo6ATAob8Z:_lZ8QWo8RXZoc8Z8_lR:R[o8S8Z00;o<RXR00co:R8Ioc8Z
8_m4>R[oA2XRoc8Z8_m4:R;o<RXRob8Z:_lZ8QWo6ATAobXR6OlI6A43oa4A
4@06o`000?lZ4@So6ATIoaTI4Olb:R;o:R8I0olI8R803Olj>R;oA4@Zoa4A
4OlR:R[o:Q48oa4A4Ol0003o4A4Ao`000?lZ4@So0000oa4A4Ol000000_lZ
4@P2oa4A4@05o`000?m4A4coA4@bodA4<_lb>T@00_lb:R800olZ8QWo0000
obXA2002o`00000PobXA2?m44@3o<RXRodA4<_lb:R;o8S8ZobXA2?lb:R;o
:Q48oc8Z8_lR:R[o6ATAoaTR8_lb:R;o:R8IoaTR8_lR8Q7o<RXRob8b:_lR
:R[o8S8ZoaTI4Olb:R;oA3XRob8Z:_lZ8QWo>SXbodA4:_lb>TCo>SXboc8Z
8_lR<RX2ocXj<P03oc8Z8_lR<R[o<RXR00;o>SXb00co>SXRod@j:_m4A2[o
A4A<odA4:_m4>R[o>SXRod@j:_lj>R;oA3XZocXj8_m4>RX2oc8Z8P08odA4
<_m4A2[oA4@ZobXR6Olj>R;o>T@bocXj8_m4>RX4oc8Z8P03obXR6OlR:R[o
8S8Z00;o<RXR00?o6ATIoc8Z8_lI8R800_lZ8QT00olb:R;o8R8AocXj<P02
oaTI6@04obXR6OlI6AWo:R8IoaTR8P;o:R8I00?o6B8Rob8Z:_lI6AT00olZ
8QT00olR8Q7o8RXZoaTI4@03obXR6@06ob8R4OlI8R;o:R8IoaTR8_lR8Q7o
:R8I0_lR8Q402OlZ8QWo8R8AobXR6OlI6AWo6ATAobXA2?lI6A7o8R8AoaTI
4@04ob8R4@04oaTI4OlZ4@So6ATAobXA20?o4A4A00Ko0000oa4A4Ol0003o
4A4Ao`000?lA4A42o`00000;oa4A4Ol0003o4A4AoaTI4Ol0003o6ATIoa4A
4Ol0003o8RXZo`000?lA4A401?l000001_lA4A7o6ATAo`000?lI6A7o4A4A
o`0000;o4A4A00Co>SXbob8R4Ol0003o:Q480_lR<RX00olZ8QWo4A4Ao`00
0002o`000006ob8b:_lR8Q7o4A4Aoa4A4Ol0003o6ATI1?lA4A401_lI6AWo
6ATAoaTI6OlA4A7o0000oa4A4@;o000000?o4A4Aob8b:_lI6AT00_lI6AT0
0ol0003o4A4Ao`000002oa4A4@;o6ATA00?o4A4Ao`000?lA4A401?lA4A40
1?lI6A7o8R8Ao`000?lI6A43oa4A4@0?o`000?m<E6go>Uafob8b:_l0003o
KHMnofFG/Ol0003o6ATIocYDG?lI8S;oG5a<o`000?lI6AWoOYni00;o0000
00SoMYNaob94>_l0003o4A4AoaTI6Om]OXoo<SY4o`0000;o4A4A00?o6ATA
odaDKOlR:RX00_lA4A400ol0003ok^k^onk^kP03onk^kP0=oc8b<_m_Kfoo
k^k^onk^k_mXJ6So4Q8BomOGeonh^;So0`<3olk>c_oFe]KoE5ADo`l?3`02
onk^kP0@ocdm?OlY:BWo_Kfmonk^k_o9bLWok>c/onk^k_lo?coo>c/kom3@
d?o^k^koh^;Ron7QhOnXZ:So4a<ConSXj0?ok^k^00Oo_Kfmo`000?nf][Ko
k^k^ofUYJOll?3cokNg]00;ok^k^00?o<S8bofa/K?o^k^h01?o^k^h01_lk
>c_oMWIfonk^k_o^k^ko>c/kogIfMP;ok^k^00OoV9RHoaXJ6_o^k^koj^[Z
od51@Olf=SKoinOW05kok^k^001JonKViPCo4A4A01[o0000oa4A4OlA4A7o
4A4Aoc8Z8_l0003o<SY4ob8bA?lR:R[o6B8RoaTR<_ljA4co8SXboc8jA?lR
<TCo<SY4obXA2?lR:R[o8SXboaTR8_lR:R[o6B8Roa4A4OlR:R[o<RXRoaTR
<P;o<RXR0olI8R801?lR>S;o<RXRob8Z:_lb:R82ob8Z:P08oda<A?lb:R;o
<SY4oc8Z8_m4A4co<RXRob8Z:_ljA1T2oc8Z8P03ob8Z:_lb:R;o<RXR00;o
<RXR0_lR:RX00olI8R;o:R8Iob8R4@05oa4A4@03obXA2?l0003o000000?o
6ATA00Co6ATIoc8Z8_lb:R;o:R8I0_lb:R801?m4>R[oA4@bocY46Ol00002
oa4A4@;o:Q4800?o4A4Ao`000?lA4A400_lZ4@P04_lA4A7o:Q48o`000?m<
C3[o8S8Zoc8Z8_lR<R[o>SXbod@j:_lR8Q7o4A4Ao`000?lA4A7o:Q48o`00
0?m<8PSo:R8IoaTR8P;o:R8I0olZ4@P01OlI6A7o:R8Ioc8Z8_lb:R;o8SXb
00;o<RXR00Ko8SXbob9<E?lR<R[oA3XZoc8Z8_m4A2X2ob8b:P;o<RXR00Co
8RXZoc8Z8_lZ8QWo8S8Z0_lb:R803?lR<R[o<RXRob8j<_m4A2[o>T@bocXj
8_ljA1WoA4@Zoda<>_lj>R;o<RXRodA4:P;o>SXR00?o8S8Zoc8Z8_lb:R80
0olb:R800olZ8QWo6ATIoaTI6@02oaTR8P03obXR6OlI6A7o8RXZ00;o<RXR
00?o6B8RobXR6OlZ8QT00olZ8QT02OlR:R[o6B8RobXR6OlZ8QWo8R8AobXR
6OlI8R;o:R8Ioc8Z8P03obXR6@03ob8Z:_lZ8QWo:R8I00;o:R8I00Go6B8R
obXR6OlZ8QWo8R8AoaTR8P02obXR6@03ob8R4OlZ8QWo6ATI00;o:R8I00?o
8R8AobXR6OlZ8QT01?lR8Q42oaTI4@09ob8R4OlI6AWo6ATAob8R4OlI8R;o
4A4Aob8R4OlA4A7o6ATA00Co4A4A00Go0000oa4A4Ol0003o0000oa4A4@02
o`000003oa4A4Ol0003o000000;o4A4A00?o0000oa4A4OlA4A401?lA4A40
5_lZ4@So0000oa4A4OlA4A7o6B8RoaTR<_l0003o6B8Roc8Z8_lA4A7o0000
oaTR8_ljA3;o0000oa4A4Om4>R[o4A4Ao`000?lA4A7o<RXRoaTI4Ol00002
oa4A4@04oaTI6OlZ8QWo4A4Aoa4A4@;o000000?o4A4Aoc8jA?lA4A400_l0
00000olI6A7o0000o`000002o`0000?o4A4A1Ol000001OlA4A7o8R8AobXA
2?l0003o4A4A00;o000000Co4A4Ao`000?lA4A7o00000_lA4A400olZ4@So
6ATAoaTI4@02obXR6@0=ob8Z:_lb>TCo6ATAobXA2?lI6AWo0000obXA2?lA
4A7o0000ocYLM_mDKGKo<SY4o`000002ocYDG005odA4<_l0003o0000o`00
0?m<MWh00_l000001OmUUk7oC4`jo`000?lRC5CoKHnG00?o000000?oA4A<
ob94>_l000000_lA4A401_lb>TCo>UALocXj<_lR:R[o>SXRob8b:PGoi^KV
017o<30`of][JooVi^Ko[Zj^o`410OnOWiooi^KVol?3`ol20P;oZZZZonKV
i_n?Shoo71`LonKVi_o6a/Ko0000ohJ6QP04onKViP03olO7aol0003oYJFU
00Coi^KV00?ohn?SoaTI6OmVIVH00on:RXX01_m1@D7o92@TonKVi_oVi^Ko
ADE5ofIVIP?oi^KV00?o<30`ofQXJ?oVi^H01?oVi^H01_li>CWoLW9bonKV
i_oVi^Ko>CTiog9bLP;oi^KV00OoTi>CoaTI6OoVi^Koi^KVomSHf?lU9BGo
DE5A05koi^KV001Jonk^kPGo4A4A00Go0000oa4A4Ol0003o4A4Ao`000004
ob8Z:P04oc8Z8_lR:R[o>TA<ob8Z:P;o<SY400GoA4@bob9<E?lb>TCo8S8Z
ocXj8P02oc8jA004ob8Z:_lI8R;oC4a4oaTR:P;o8RXZ01;o<RXRob8Z:_lb
:R;o<RXRodA4<_lj>S;oA3XZod@Z8_m<C4Co<RXRoda<A?m<C3[oA3XZodA4
<_m<C4Co<RXRodA4:_m<C4@2odA4<P;oA3XZ00_oA4@bod@j:_m4A3;o:R8I
ocXj8_lI6A7o6ATIobXR6OlI6A7o4A4AobXA2003oa4A4@08ob8R4OlZ4@So
6B8Rod@j:_lb:R;o8RXZob8R4OlR:RX3ocXj<P03ob8R4Ol0003o000000?o
4A4A0_l000000olA4A7o0000obXA2002oa4A4@08o`000?m<C3[o:R8Ioda<
>_m4A3;o>SXbocXj8_lZ4@P2o`000004ob8Z:_lb:R;o0000od`R20;o<RXR
00Co8S8ZoaTI4OlA4A7o8R8A0_lZ4@P01_lR<R[o<RXRob8Z:_lR:R[o<RXR
ob8Z:P;o:R8I00Co:Q48oa4A4OlA4A7o00001_lb:R801om4:R;o8RXZoc8Z
8_lb:R;o:R8IobXA2?lb:R800_lZ8QT02?lb:R;o6ATIoaTI6OlR8Q7o8RXZ
ob8R4OlI6AWo4A4A0_lZ8QT01OlI6A7o8S8ZobXR6OlZ8QWo8R8A00;o:R8I
00?o6B8RobXR6OlR8Q400olZ8QT01_lI8R;o:R8Iob8R4OlR8Q7o:R8IoaTI
6@;o8R8A00Go:R8IoaTI6OlI6AWo:R8Iob8R4@02obXR6@05oc8Z8_lZ8QWo
:R8IobXR6OlR8Q400_lZ8QT01?lR:R[o:R8Ioc8Z8_lj>R82obXR6@08ob8Z
:_lb:R;o:R8IoaTI6Olb:R;o4A4AoaTI4OlZ8QT2oaTI4@Wo4A4A0_l00000
1olA4A7o0000o`000?l0003o4A4Ao`000?lA4A400_l00008oa4A4@0BobXA
2?lA4A7o4A4Aoa4A4OlZ4@So4A4AobXA2?lA4A7o:Q48oa4A4Ol0003o8S94
o`000?lI6A7o:Q48ob8R4OlR<R[o<RXR0_lA4A400olI6AWo4A4Aoa4A4@02
oaTI6@03o`000?lA4A7o6B8R00?o4A4A00[o6B8Zoa4A4OlA4A7o0000obXA
2?l0003o6ATIoa4A4Ol0003o4A4A0_l000001olj>S;o4A4Ao`000?l0003o
6ATIo`000?lA4A400_l000000olI6A7o4A4AoaTI4@02oa4A4@07o`000?lA
4A7o4A4Ao`000?lI6A7o:R8Iob8R4@03oa4A4@0@o`000?lI6A7o4A4Aob8j
<_lb:R;o<SY4oaTR8_lA4A7o:Q48oa4A4Ol0003o:Q48o`000?lZ4@So8R8A
obXA20?o8R8A00Co:Q48oc8jA?m<MWkoE6ef0ol000002Om]Sk7o0000oa4A
4OlA4A7o8S8ZobXR6Ol0003o8S94ogJG/@02oa4A4@04ofefM_lI6A7o:Q48
ob8Z:P;o>UAL0_m<E6d01omLKGKoE7inoff7O_m]MWKoKHMnocYDG?ljG7H0
1Oo^k^h01Olb<S;oK6a/omoOgolP823oHF5Q00?ok^k^00WoXJ6Qobh^;_l_
;boo<S8boadM7Oo^k^ko/K6ao`000?o0`<001?o^k^h00ona/K7o0000ocPh
>003ocXj>P04okJf]_o^k^koMWIfo`h>3P;oHF5Q00?oEUIFo`000?n1PH40
0_o^k^h00om7AdOoJVYZonk^kP02onk^kP03oc8b<_m/K6cok^k^00Cok^k^
00Ko>c/kogIfM_o^k^kok^k^oc/k>omfMWH2onk^kP03oiRHV?lJ6Q[ok^k^
00;ok^k^00?od=3@oa@D5?mfMWH0GOo^k^h005[ooooo00ko4A4Ao`000?lA
4A7o4A4Ao`000?lA4A7o0000obXA2?l0003o4A4Aob8R4Olj>S;o>TA<ob8b
A0;o8RXZ00ooA4A<ob8j<_lR:R[o8RXZob8j<_lI6AWo:R8Iob8Z:_lI8R[o
<RXRob8b:_m4>R[o6B8Zoa4A4Olb:R800_lR:RX06Olj>S;o8S8Zoda<A?m<
C4CoA4@boda<>_mLG4coA4@bocY46OmLG4coKFeDofEU>_m]KECoOWi]ofeU
8_m]MWKoKFeDofEU>_mnMUCoG5a<ofe]E?mnKDcoG5a<ofEU>_mUE3800_m4
A3800om<A2;oA4@Zob8R4@02o`000004oaTI4OlZ4@So4A4Ao`0000;o:R8I
00Co<RXRobXR6Olj>S;oA3XZ0_m4A3802Om4>R[o<SY4od@j8_lZ4@So0000
oa4A4OlZ8QWo:Q48o`000002obXA2003o`000?lZ4@So4A4A00?o4A4A0_m4
A3801?m4A4coA4@boc8Z8_lI6AT2o`00000;obXA2?mLKHOo6ATAobXA2?lb
:R;o>SXRoaTR8_lR>S;o:Q48oaTI6OljA4`00_l000002OljA1Wo6B8RobXR
6OlZ8QWo6B8Rob8Z:_lj>S;o6ATIoa4A4@02o`000004oaTI6Om]SkWo8R8A
oaTR8P?o:R8I00go6B8RobXR6OlI6A7o6ATAob8R4OlI8R;o8R8AoaTR8_lR
8Q7o:R8Iob8R4OlZ8QWo8RXZ00;o8R8A0olZ8QT01_lI6AWo:R8IoaTI6OlR
8Q7o8RXZoaTR8P?o:R8I00So6B8Rob8R4Om4A3;o6ATAob8R4OlZ8QWo8R8A
oc8Z8P?o:R8I00Go<RXRoaTR8_lb:R;o:R8Iob8R4@02obXR6@03ob8Z:_lR
<R[o8R8A00;o6B8R00Oo6ATAobXR6OlI6AWo6B8RobXR6OlI6AWo6B8Z00;o
6ATA00?o6ATIoaTR8_lA4A400_lA4A401olI6AWo4A4Aoa4A4OlA4A7o0000
oa4A4Ol000000_lA4A401Ol0003o4A4Ao`000?lA4A7o000000Oo4A4A00Co
6ATAoa4A4OlZ4@So:Q480_lI6A402OlR8Q7o:Q48ob8R4OlR8Q7o:R8Iob8R
4OlZ8QWo4A4Ao`000002oa4A4@05oaTI4Ol0003o4A4Aoa4A4OlI6A400_l0
00000om4>R[o0000ob8j<P02oa4A4@03oaTI6OlRA3[o000000Co4A4A00Co
6B8Zo`000?lA4A7o00000olA4A402_l0003o8SXbobXA2?lA4A7o:Q48oaTI
6OlA4A7o6ATAobXA2?lA4A42o`000004oa4A4Ol0003o4A4Ao`0000;o4A4A
0_l00003oa4A4@0>o`000?lA4A7o0000o`000?lA4A7o0000oaTI4OlR8Q7o
A3XZo`000?lR8Q7o:Q48o`000?lA4A43o`000005oaTR8_lA4A7o4A4Ao`00
0?lA4A400_l000000olA4A7o:Q48obXA2002obXA20;o000000Oo:Q48oaTI
4OlZ4@So:R8IodanSomDKGKo8S9400;o000000ko>UafoeA]M_l0003o0000
oaTR8_mLKHOo8SXbocYDG?mLQhooC7InodA4C?ljE5coG6efoeA]MP?oKGj?
0omnShl01_m]OXooQgj?ofenSom4A4co<RXRob94>PGooooo00Go=SHfo`<3
0ol0003o0000ol71`@05ooooo`07oogmoOnDU9Co8B4QoooooooKfm_o0000
oi6AT@04ooooo`0?om_Kfol0003oZj^[olo?coo7alOo0`<3onGUiOoooooo
hN7Qo`<30ooMgMgooooooifMWOl51@Goj^[Z00;ooooo00?oCDe=og9bL_oo
ool00_ooool00olf=SKoM7Adooooo`04ooooo`06od10@?moOgoooooooooo
oom0@43oGEeM0_ooool00onMWIgo7AdMooooo`03ooooo`03olK6a_l92@Wo
YJFU05cooooo001Jonk^kP;o4A4A00?o0000oa4A4Ol000000_l000000olR
8Q7o4A4Ao`000002o`0000;o:R8I00Ko6B8RoaTI6OlR:R[oA3XZob8R4OlI
8R82oc8Z8P03odA4<_lZ8QWoA2XR00;oC4a401GoG5a<ofEU>_lb:R;o<SY4
ocXj<_m<C4CoKFeDoginKOm4>R[oKGIfoff7O_mnOVgoKHMnofe]E?mnKDco
KHMnoiN?M_n7OXooUhn7ofe]E?mLG4`00_nGShL05Om]QgkoOWi]ogiUE?mn
OVgoShM]ohn?IOmnOVgoKFeDogi]C?mfOUco4A4Aob8R4OlI6AWo:Q48o`00
0?lR8Q7o4A4AobXA2?lA4A7o:Q48ob8Z:P02odA4<P0=ob8b:_m4>R[o6B8R
ocXj<_lb:R;oA4@ZobXR6Ol0003o4A4Ao`000?lZ8QWo:Q48oaTI4@03o`00
000<oa4A4Ol0003o0000o`000?lZ4@SoC4`joc8jA?m<C3[oIE@boda<A?m<
8PSo:Q480_l000000olI8R;o4A4AobXA2002obXR6@0Eob8Z:_lZ8QWo:Q48
oaTI4OlRC5Co:Q48o`000?lI6A7o:R8IoaTI4OlZ8QWo8R8AoaTI4OlR8Q7o
0000oa4A4Ol0003o:Q48ob8Z:_m4:R;o6ATI00;o:R8I00Co6ATIob8R4OlZ
8QWo6ATI0_lR8Q400olI6AWo8R8AoaTI6@02ob8R4@03obXR6OlI6AWo:R8I
00;o8R8A1olZ8QT02Olb:R;o:R8IobXR6OlI8R;o<RXRoaTR8_lZ8QWo8R8A
oc8Z8P02obXR6@0;oaTR8_lZ8QWo8RXZobXR6Olb:R;o6ATIob8b:_lR8Q7o
:R8IoaTI6OlI8R800_lI6AT00olA4A7o6ATIoa4A4@0;oa4A4@;o000000?o
4A4Ao`000?l000000_lA4A42o`000005oa4A4OlZ4@So4A4AobXA2?l00000
0_lZ4@P4oaTI4@;o4A4A00?o:Q48oaTR8_lI6A401OlA4A400olI6A7o4A4A
oa4A4@02oa4A4@03oaTI4OlA4A7o4A4A00;o4A4A0_l00003oa4A4@?o0000
00Go4A4Ao`000?lj>S;o0000ob8j<P02oa4A4@05o`000?lbA7Ko0000oa4A
4Ol000001OlA4A401ol0003o4A4AoaTI6OlA4A7o0000ob8j<_lA4A401?l0
0002oaTI4@?o000000?o4A4Ao`000?lZ4@P00ol000007_lA4A7o0000oa4A
4Ol0003o:Q48obXR6OljA4co8S8Zoc8Z8_lZ8QWo8S8ZoaTR8_lI6AWo6ATA
ocY46Om<C3[o4A4Ao`000?lI6AWo0000oa4A4Ol0003o4A4Ao`000?lA4A7o
0000oa4A4Ol0003o4A4Ao`0000;o:Q4800?o0000oaTI6OlZ4@P00_lA4A40
1?lZ8QWo0000obXA2?mLQhl2odaDK@04ob8b:_lI6AWoC4a4oeafOP;oE6ef
00GoG6f7oda]QomUQjWoE7inodaDK@02oeaLC00?oeA]M_m]OXooIHNYohNG
ZOmnShooKHnGogj?Som]OXooE6efoda]QolRC5Co6ATIoaTI4OlZ4@So0000
00Gok^k^00Ko<S8bofm_KooCdm?oShn?o`L71on/[:`2onk^kP05ojRXZ?o;
bl_ojn_[oeYJF_m>CTh00_o^k^h01Olj>S[o92@Tok6a/Oo]kNgoclo?00;o
k^k^00Go>SXjof=SHooVi^KoTi>CobPX:003onk^kP05odE5AOm`L73ok^k^
oc@d=?m=CDd00_o^k^h02?oXj>SoA4A4ofEUIOoShn?oj^[Zonk^k_lb<S;o
K6a/1Oo^k^h02_lk>c_oMWIfonk^k_o^k^ko>c/koa8B4_m^KVkoclo?oe5A
DOm7AdL2onk^kP?ohn?S00?oTI6Ao`H61_ng]kL0Foo^k^h005[oi^KV00Co
<RXRo`000?lA4A7o00000olA4A403?l0003o4A4Ao`000?lI8R;o0000oaTI
4Om4A4coC4`joeaLC?m<C3[o<RXRoda<A0?oKFeD00CoMWiLoe`j8_m]KECo
OWIU0om]MWH03om]KECoG5a<ocYDG?m<C4CoOVEDofefM_m]KECoOVeUohn7
KOnGSgKoOWi]ogi]IOmnOVgoUhmfohnGS`02oiN?MP05ohmfIOnGSgKoWimn
ohn7KOnOSfd00_nGSgH02OnOWgkoSgIUoiN?M_nOSfgoShmUoin?KOnOWgko
4A4AoaTI6@03oaTI4@0:ob8R4Ol0003o6ATAo`000?lR8Q7oA2XRoc8Z8_lR
8Q7o<RXRod@Z8P;oA4@b00?oIE`Zoda<>_lI6AT00ol000002?mLG4co8R8A
od@A0?l0003o:Q48o`000?lI6A7o:Q480_lA4A402OlZ4@SoC4`jodA4:_lR
<R[o<RXRoaTR8_l0003o:Q48oa4A4@02o`000007oa4A4Om44@3o:Q48oaTI
4OlR8Q7o6ATAoa4A4@02obXA2003oa4A4Ol0003o4A4A00;o:R8I0_lR:RX0
0olZ8QWo6ATIo`000002o`000008oa4A4Ol0003o:Q48obXA2?lI8R;o8R8A
oaTI6OlI8R83oaTI6@05ob8R4OlZ8QWo6B8Roc8Z8_lR:RX01?lZ8QT02_lR
:R[o8R8AobXR6Olb:R;o8RXZobXR6OlR:R[o<RXRoaTR8_lR:RX3obXR6@05
oaTI6OlZ8QWo:R8IobXR6OlR:RX00_lb:R801_lR:R[o>SXbob8b:_lR<R[o
6ATIob8Z:P;o6ATI0_lA4A401?lI6AWo4A4Aoa4A4Ol00002oa4A4@05o`00
0?lA4A7o4A4Aoa4A4Ol000000_lA4A42o`000009oa4A4OlZ4@So:Q48obXR
6OlI6AWo<RXRob8b:_lZ8QWoA3XZ00Co8S8Z00Wo<RXRob8b:_lR>S;o8RXZ
ob8j<_lb:R;o6B8Rob8Z:_lI6A400_lA4A400ol0003o4A4Ao`000003o`00
00;o4A4A00Co0000oa4A4OlA4A7o4A4A0_l00005oa4A4@03o`000?lA4A7o
4A4A00Go4A4A00Go0000ob8j<_l0003o4A4Aob8j<P02o`000003ob9<E?l0
003o4A4A00;o4A4A00Co6B8Zo`000?lA4A7o00000_lA4A401OlI8R;o4A4A
o`000?lR:R[o6ATI00?o4A4A0_l000001_lR:R[o0000oa4A4Ol0003o4A4A
o`0000;o4A4A00[o0000oaTI4Ol0003o4A4AoaTI4OlA4A7o8RXZoc8jA?lR
A3[o4A4A1?l00002oa4A4@05o`000?lI6A7o6ATIo`000?lZ4@P00ol00000
0olR<TCo0000o`000002oa4A4@04o`000?lA4A7o0000oa4A4@?o:Q4801Ko
4A4AobXA2?lA4A7o6ATAobXA2?l0003oC7jGoeA]M_ljE5coE7inoeafO_mD
KGKoC7InoeA]M_m<E6goC7Inoda]Qom<MWko>UALoeaLC?m<E6goKGj?0_m]
SiL01Om]OXooG7Inoda]QomDKGKo>Uaf00;o>UAL00?o>SXbo`000?lZ4@P0
0_lZ8QT00olZ4@Soi^KVonKViP03onKViP06oc0`<?m[Jf_oi^KVonKVi_m1
@D7oBTY:0_oVi^H01OmlO7co;Bd]o`h>3_lc<c?o/;2`00;oi^KV00GodM7A
odi>C_l=3@go2@T9ob8R8P02onKViP05olo?com0@43o2`/;oaTI6OnUYJD0
0ooVi^H01OnMWIgo5ADEokVi^Ol0003oYJFU00;oi^KV00SoLW9bo`L71ol:
2P[o61PHoibLW?oVi^Ko<30`ofQXJ0Goi^KV00coBd];ogmoOooVi^Koi^KV
od];BomnOWkoKFe]oa8B4_lY:BWo/;2`onKVi_oQhN45oaPH6003ofe]KOoV
i^Koi^KV05Woi^KV001Jonk^kP04ofDI0?n74@3oA140obXA20?o00001?lA
4A404Ol0003o4A4Aoa4A4OmLG4coKGIfohMnSon?MTCoShM]oiN?Qon7OXoo
ShM]off7O_mnOVgoShM]oiN?QonGSgKoWin?00;oUhmf00WoOWi]ofe]E?m]
KECoKFeDogifIOnOWgkoWiN7oin?KOmnOVd00onGSgH01?nOWhooOWIUohmf
IOnYZHl2oiN?Q`0@oiN?M_n?SfGoWin?oiN?QonOWhooWhm]ohn?IOniWgko
WiN7ojVYSonOSfgoIFDjob8R4Olb:R;oG3XRoa4A4@;o6ATA013o:Q48oc8Z
8_lZ4@So8R8AoeaLC?n7OUCoOWi]ogInG?mnMVGoMWiLoda<A?m4A2[oC4`j
obXR6Ol0003o4A4A0_l000001?lA4A7o0000o`000?lZ4@P3o`000005oa4A
4Ol0003o6ATAoaTR8_lI6AT00_lR8Q401olI6AWo:Q48o`000?lZ4@So0000
oaTI6OlR8Q401?lZ4@P5o`000004oa4A4OlZ4@So8R8Aob8R4@;o:R8I00Co
8R8AobXA2?l0003o4A4A0_l000001OlA4A7oA140oaTI6OlR8Q7o6B8R00Co
8R8A00?o6ATIob8R4OlI6AT01?lR8Q400olI8R;o8R8AobXR6@02obXR6@0@
ob8R4OlI6AWo:R8IobXR6OlI6A7o6ATIob8R4Olb:R;o8RXZoc8Z8_lRA3[o
C4a4ocY4C?ljA3;o<SY4ob8bA0;o8RXZ00Go6B8RobXR6OlA4A7o0000oa4A
4@02o`000003oa4A4Ol0003o4A4A00;o00000olA4A43ob8R4@03obXR6Olb
:R;o8S8Z00;oA3XZ00CoC4`jodA4<_lj>S;o8T@j1?lR>S801OlR:R[o6ATI
oaTR8_lI8R;o6ATI00?o4A4A00_o0000oa4A4OlR>S;o4A4AoaTI4Ol0003o
MYNaob8b:_l0003o4A4Ao`000002oa4A4@04o`000?lA4A7o0000o`0000Go
4A4A00?o6B8Zob8Z:_lA4A400olA4A44o`0000;o4A4A00Go0000oa4A4Ol0
003o4A4Aob8b:P02o`000004ob8b:_l0003o0000ob94>PCo4A4A00Co6B8Z
oaTI6OlI6AWo00000_lA4A401OlI8R;o6ATIo`000?lb:R;o8S8Z00;o4A4A
01Go0000oa4A4OlA4A7o8R8AoaTI4OlZ4@So0000oaTI4Ol0003o4A4Ao`00
0?lA4A7o0000oa4A4Ol0003o4A4Ao`000?lI8S;o<TAfocYDG?m<KHL00_l0
00000olA4A7o0000o`000002o`000006oa4A4Ol0003o0000oa4A4Ol0003o
4A4A0_l000000olA4A7o0000o`000002o`000003obXA2?l0003o000000;o
:Q4800Wo0000obXR6OlZ4@So4A4Aob8R4OlZ4@So0000ocYDG?ljG7H00om<
E6d01?mDKGKo>TA<ocYDG?ljE8L2odafOP0DocYDG?m<E6goG8N?ofenSomL
QhooG7jGoeafO_mDKGKoG6efodaDKOljE5coA4A<ocY4C?m4A4co8S8Zod`R
2?lb:R;o0000ob8Z:_ljA1T5onk^kP06oc8b<_m_Kfook^k^onk^k_la<C7o
Cdm?1?o^k^h00oo/k>cok^k^onk^kP05onk^kP03on_[joo^k^kok^k^00?o
k^k^00?ojn_[onk^k_o^k^h00oo^k^h01OoZj^[o5QHFobHV9_lK6a_okNg]
00?ok^k^00?oAdM7ofYZJ_o^k^h00_o^k^h00olb<S;oK6a/onk^kP0;onk^
kP03ong]kOo^k^kok^k^06?ok^k^001Jooooo`07ohmfIOnOKDcoSc9<ohM<
A?o1/KWo/KVYoc8jA002o`00000<oa4A4Ol0003o4A4Aoa4A4OlI8Tco>UAL
ohMnSonGOUCoA140ofDI0?nGOUCoZJV?0_nOUhL00onOWgkoUhn7oinOOP04
oinGQ`09ohnGSomnOVgo>SXRofEL:_mnOVgoWiN7oinOO_n?QfgoOWi]00;o
WiN70_nOWgh02?nGSgKoWimnojVYSonYZHooWiN7okVOO_nOWgko/K6?0onO
Wgh2oiN?MP0:oinGQona^IOoShM]obXR6Om4A2[oA3XZobXR6OlA4A7o:Q48
o`0000;o6ATA00So4A4Ao`000?m4>R[oG5a<oda<>_m4>R;o>SXbobXR6@;o
8R8A00?o6ATIoa4A4OlZ4@P00olA4A401Ol0003o:Q48obXA2?lZ4@So0000
00;o4A4A00[o0000obXA2?lI6AWo:R8Iob8R4OlI8R;o6ATIobXA2?l0003o
:Q480_l000001?lZ4@So8S94o`000?lA4A42o`000005ofDb2?m<A2;o:Q48
oa4A4Ol000000_lZ4@P2oaTI4@0Eoa4A4OlR8Q7o6ATAoa4A4OlZ4@So4A4A
o`000?lI6A7o>UALocXj<_lI6A7o:R8Iob8R4OlI6A7o6ATIoaTI4OlR8Q7o
6ATIob8R4OlA4A7o:R8I00?o6ATA0olR8Q403OlZ8QWo6ATIobXR6OlR8Q7o
:R8IoaTR8_lR<TCo>T@boda<A?lR<TCo8T@job8b:_lR:RX00_lI6AT2o`00
0003oa4A4Ol0003o4A4A00?o000000?o4A4Ao`000?lA4A400_lI6A405?lR
:R[o:R8Iob8b:_lj>S;o8S8ZocXj<_lj>R;o8SXbob8b:_ljA3;o8T@joc8j
A?lR<TCo<RXRob8b:_lR:R[o6ATIoaTI4OlA4A7o6ATA1OlA4A400ol0003o
4A4Ao`000003oa4A4@09odafO_ljA4co8TaDo`000?lA4A7o0000odafO_lI
8R[o000000Co4A4A0ol00004oa4A4@;o000000Co8SXboaTI6OlA4A7o0000
0_lA4A43o`000003oa4A4OlI6A7o6ATI00Co4A4A00So8S94oa4A4Ol0003o
0000oaTI4Ol0003o8S94o`0000;o4A4A00?o6B8boaTR8_lI6AT00_lA4A40
2?l0003o6ATIoaTR:_lb>TCo0000ob8b:_lI8S;o4A4A0_l000001_lA4A7o
0000ob8R4OlI6AWo6ATAoa4A4@;o00000_lA4A401?l0003o4A4Ao`000?lA
4A42o`000005oaTR<_lR>UcoG8NGoaUDO_lA4A400ol000001?lA4A7o0000
oa4A4Ol00003oa4A4@Co000000Go4A4Ao`000?lA4A7o0000oa4A4@02o`00
000Yoa4A4OlZ4@So:Q48obXA2?l0003o6ATAo`000?lR8Q7o4A4Ao`000?lR
A3[oKGj?ocYDG?ljG7KoC7Inoda<A?l0003o<RXRoda<>_m<KHOo>TA<odaD
KOmLQhooG6f7oeb7Som<MWkoC5A]ocYDG?ljA4co8T@job8Z:_lZ8QWo4A4A
o`000?lA4A7o0000oda48_lZ8QWo:Q48oaTI4OlZ4@P01Oooool01_lf=SKo
;bl_oeYJF_lS8b?o30`<ol?3`aWooooo00?oNWYjo`000?mnOWh01?ooool0
0ooPh>3og]kNooooo`02ooooo`03ocHf=_mdM7Cooooo00Cooooo00?oFe]K
oi:BT_ooool0J_ooool005[ok^k^00_o:R8IofED<_oB/Hook^k^oinYZOna
/KWok^k^oinOSomL>R;o4A4Ao`000002oa4A4@09ob8bA?ljE8OoC5A]od`R
2?m44@3o:Q48od@A0?na^IOoUhn700?oWin?00oo/KVGojVYSoni^IOo^KVY
olZaZOni^JWo/KVOohnGSom]KECoWimnok6iUona^JWob/6OokViUona^JT0
0_na^Il01ona^JWo/KVGoinGQonOWgkoWiN7oiN?M_n?Uhl00_n?Qfd03On?
SfGoUhmfohnGSonOWgkoUhmfohn7KOmnMVGo0000ob8R4OlA4A7o:Q48oaTI
4OlR8Q400_l000004OlA4A7o6ATAoa4A4Ol0003oKFeDogiLC?m]KECoIFDj
ofED<_mLG4coC4`joda<A?m4>R;o:R8Io`000?lA4A7o:Q4800;o000000Go
:Q48o`000?lZ4@So4A4AobXA2002o`000007od@Z8_lZ8QWo:R8IobXR6Olb
:R;o8R8Aoc8Z8P02obXA2004oaTI4Ol0003o0000o`0000;o:Q4800WoID`I
oimnC?m4A3;o6ATAoa4A4Ol0003o4A4Ao`000?lA4A401?lI6A401_lA4A7o
:Q48o`000?lZ4@So4A4Ao`0000;o4A4A00?o:R8IoaTI4OlI6AT00_lR8Q40
0olI6AWo6ATAob8R4@02ob8R4@04oa4A4OlZ8QWo8RXZoc8Z8P;o6B8R1OlR
:RX00olI8R;o:R8IoaTI6@08o`000007oa4A4Ol0003o4A4Aob8R4Ol0003o
8R8AobXR6@02ob8Z:P09obXR6Olj>S;o8S94odA4:_lR<R[o<SY4ob8b:_lj
>S;o8S8Z00?o8RXZ00Co6B8Roa4A4OlI6A7o6ATA0olA4A43o`000005oa4A
4Ol0003o0000oaTI4Ol000000_lA4A400ol0003o4A4Aoa4A4@02oa4A4@05
o`000?lRC5CoKHniob8j<_l000000_lA4A402Ol0003o4A4Aoa4A4Ol0003o
4A4Ao`000?lA4A7o0000oa4A4@02o`000003oaTI4OlA4A7o4A4A00;o4A4A
00?o8S94oaTR8_lA4A400_lA4A401OlI8R;o0000oa4A4Ol0003o4A4A00;o
6ATI00Go6B8ZoaTI6OlA4A7o:Q48oaTI6@03o`000004ob8j<_l0003o8SXb
o`0000?o4A4A0_lI6AT04OlA4A7o0000oa4A4OlA4A7o6B8Roc8jA?lA4A7o
6ATAoaTI6OlI6A7o4A4Aob8R4OlI6A7o<RXRoa4A4Ol0003o4A4A00;o0000
00Oo4A4Ao`000?lA4A7o0000oa4A4Ol0003o4A4A00;o000000Go<SY4oa4A
4Om<O[7o4A4Ao`000002oa4A4@;o000000Co4A4Ao`000?ljA1Wo00000_lA
4A401ol0003o4A4Ao`000?l0003o4A4Ao`000?lA4A400_l000001?lA4A7o
0000o`000?l00002obXA2005oaTI4Ol0003o:Q48obXR6OlI6AT00_l00000
1Om<MWko>UALodaDKOm<E6goG5a<00;o000000go6ATAob8j<_lR>S;oA4A<
ocYDG?lb>TCo8S94oaTR<_lI8R[oIC88ooCSb_m<8PSo000000;o8R8A1?lZ
4@P3obXR6@03oa4A4Oo^k^kok^k^00?ok^k^00GoY:BTohn?Son?Shoo[Zj^
onSXj00Jonk^kP03omOGeon?Shoof=SH00Wok^k^00?oY:BTokZj^_o^k^h0
1?o^k^h00onXZ:So_knoonk^kP1Zonk^kP00F_oVi^H02OlA4A7o0000oc8Z
8_na^IOo/K6ionKVi_nOZJWoSd@AohlbC002oim]C00=ofED<_m<E6go<SY4
odaDKOlZ4@SoA140obXA2?m44@3oSd@Aom;:`Oo:/JWo^KVYol6iW`02okVi
Z@09ol[1ZOni/Ioo^K6Ook6iWonOWhooSiN?ogInG?mLG4coIFDj00;oShM]
00WoSiN?oiN?M_nGSgKoUhmfohn7KOmnMVGoShmUohmnKOmnKD`00_mnOVd2
ohmfE0;oOWIU0_n7OU@05omnOVgoMWiLohn?IOn7OUCo0000oa4A4OlR8Q7o
6ATIoa4A4OlR8Q7oC288oim<0?l0003o6ATAobXR6Ol0003o<SY4oiN?M_mn
MVGoOWIDogInG?m]KECoIFDj00;oG5a<017oC4`job8R4OlR8Q7o6ATAobXA
2?l0003o:Q48ob8R4OlI6A7o6B8boc94M_lR:R[oG3XRod`R2?lI6A7o8R8A
oaTR8P03oaTI4@09obXA2?l0003o:Q48oa4A4OlZ4@So<SY4ob8Z:_lR8Q7o
4A4A00;o000000?o4A4Ao`000?lA4A401?l000000olI6A7o4A4AoaTI4@04
oa4A4@0;o`000?lI8S;o<SY4oc8Z8_lA4A7o6ATIobXA2?lI6AWo6B8Roc8Z
8_lI8S800olR:RX02_lj>R;o8S8ZoaTR8_lZ8QWo8R8AoaTI4OlZ8QWo6ATI
obXR6OlI6AT2oa4A4@03oaTI4Ol0003o4A4A00Co4A4A00ko6ATIoa4A4OlA
4A7o6ATIobXR6OlI6AWo:R8Iob8b:_lI8R;o:R8IoaTI6OlR:R[o6ATIoaTR
8P?o6ATI0_lA4A401ol0003o4A4Aoa4A4OlA4A7o0000oaTI6Ol000000_lI
6AT3oa4A4@04o`000?lA4A7o0000o`0000Co4A4A00?o0000oa4A4OlA4A40
1OlA4A42o`000003obXA2?lA4A7o4A4A00;o4A4A00Go:Q48oa4A4OlI6AWo
4A4AoaTI4@03oa4A4@08o`000?lA4A7o4A4Aoa4A4OlI8R[o6B8RoaTI4OlI
8T`2oaTR:P03oaTR8_lR:R[o8RXZ00;o000000Wo4A4Ao`000?lI8S;o6B8R
oaTR:_l0003o4A4Ao`000?m4A3800_lA4A401Ol0003o<SY4o`000?lR<R[o
000000;o4A4A00Wo6B8Zoeb7Som<OYOo>UALo`000?lA4A7o8R8AocY4C?lb
:R800_lR8Q401oljA4co8TaDoc8Z8_lI6AWo4A4Ao`000?lI6AT00ol00000
1OlA4A7o0000oa4A4OlA4A7o000000;o4A4A0_l000001OljE5co:Q48o`00
0?mDSk7o4A4A00?o000000?o4A4Ao`000?lA4A400_l000000oniUfgo0000
ob8R4@03oa4A4@;o000000?o4A4Ao`000?lA4A400_l000002?lZ4@So4A4A
oa4A4Ol0003o:Q48o`000?lZ4@So00000_lI6A401?lA4A7o0000ob8Z:_lj
A4`2ocXj<P05oaTR8_lZ4@So:Q48o`000?lZ4@P01?l000002_lZ4@So4A4A
ok5]0?mU6@3o/KVGofDI0?lZ4@So:R8Iod@Z8_lb:R82ob8R4@03oaTI6Olb
:R;o<RXR00;o4A4AY?oVi^H005[ok^k^0_lA4A43o`000005oc8Z8_n7IC;o
b[6YokVOO_mU<PP00_na/KT02_n7OXooQinaofDb2?m<8PSo0000obXA2?mU
6@3oQda4oinOSom]Qgh2oiN?MP09ohnGSon?QfgoMWiLoff7O_nOSfgoUhmf
oginKOmnMUCoIE@b00;o:R8I00OoIE@bogi]IOmnMUCoOWIDohMnE?mnKFGo
MWiL00;oOWIU0_mnOVd3ohMnE003off7O_nGOUCoShmU00;oShmU00GoSgI4
ohMnE?n?MTCoOWIDobXR6@02oaTI4@05obXA2?mU6@3oQd`AohmfA?mU<PP0
0_l00002obXA200=o`000?nGSgKoShM]oginKOmfOUcoOWIUofe]E?mUIC[o
KFeDofED<_ljA1Wo6ATAobXA2002o`000007obXA2?lR8Q7o:R8Io`000?m4
A3;oQda4o`000002ob8R4@04oa4A4OlR8Q7o6ATAobXA20;o4A4A1?lZ4@P5
o`000008oa4A4OlRA3[o6B8boa4A4Ol0003o6B8bodaDKOlR>U`4o`00000C
oa4A4Ol0003o4A4Aob8R4OlI8Tco<SY4oa4A4OlR8Q7o6B8RobXR6OlR:R[o
:R8Ioc8Z8_lR>S;o8RXZoc8Z8_lR:R[o6ATIoaTI4@05oa4A4@09oaTI4OlA
4A7o8R8AoaTI4OlR:R[o8R8AoaTR8_lI6AWo6B8R00?o4A4A00Go0000oa4A
4OlA4A7o4A4Ao`000003oa4A4@03oaTI4OlA4A7o4A4A00So4A4A0_lI6AT7
oa4A4@0;o`000?lA4A7o4A4Aoa4A4Ol0003o4A4Ao`000?lA4A7o0000oa4A
4Ol000000olA4A401Ol0003o6ATIoa4A4OlI8S;o000000;o6ATI00[o4A4A
o`000?lR8Q7o6B8Roc8Z8_l0003o<RXRoaTI6OlI8R[o6B8R1Ol00002oaTI
4@?o6B8R0olR:RX00olI8R;o6B8ZoaTR8P04o`000008oaTR8_l0003o0000
oaTI4OlA4A7o0000oaTI6OlA4A42o`000003oaTI6OlA4A7o6ATA00;o4A4A
00Go6ATAob8Z:_ljE5co>UALodafOP02ob8j<P08oaTR8_lI6AWo0000oaTI
4OlI8R;o8TaDocYLM_lI8R83o`000008ob8R4OlA4A7o0000o`000?lA4A7o
6B8RoaTR<_lI6AT2oa4A4@04o`000?lA4A7o0000odafU`;o000000CoC7jG
o`000?l0003o4A4A0_l000001_lA4A7o0000oa4A4Ol0003o/KVGo`0000;o
4A4A00Wo6ATAo`000?lA4A7o0000oa4A4Ol0003o4A4Ao`000?lA4A400_l0
0004oa4A4@04o`000?lA4A7o4A4Ao`0000;o4A4A00So0000oa4A4Ol0003o
4A4Ao`000?mUE3;oQe@ZobXR6@?o4A4A01?o:Q48oa4A4Ol0003o0000ok6?
6OnOC03oA140ohLZ0?lA4A7o8RXZoda<A?ljA4co<RXRo`000?lZ4@So:R8I
ob8jG?lI8R;o4A4A0:Cok^k^001Jooooo`?o4A4A00Co6B9<obXA2?l0003o
<TAf0_m<KIL02?m]OXooIHNYoinYZOn?OVgoWhM]okUnE?niUfgoQda40_m4
4@000onGSgKoQgiDohMnE002ogifI@0FoginKOmnIECoOWIDogifE?mfOUco
OWi]ogifE?mnOVgoKFeDodA4<_m4>R[oA4@Zogi]C?n?SfGoQgiDofefM_n?
MVGoShmUoginKOmnMVGoOWi]ohMnE0;oOWIU00CoMWiLofED<_ljA1Wo8S8Z
0olA4A42o`000008oaTI4OlI6AWo6ATIob8R4OnOSfgok>cSok6iZOmL>R82
o`00000Aoa4A4Om4>R[o8R8AoaTI6OnOQfgoOWIUogi]C?m]KECoIFDjofED
<_mLG4coC4@Rod@Z8_ljA1Wo8R8Aoa4A4Ol000000olZ4@P03_l0003o8RXZ
od@A0?l0003o:Q48oc8Z8_lI8R;o:R8IoaTI6OlZ8QWo8R8Aoa4A4OlZ4@So
00000_lZ4@P01om44@3oIAT0o`000?lb:R;o8R8AobXR6OlA4A400_l00000
2OlA4A7o:Q48obXA2?lA4A7o:Q48oaTI4OlA4A7o:Q48oa4A4@02obXA200>
od`R2?lI8S;o8RXZoaTR8_lZ8QWo6B8RoaTI6OlZ8QWo8SXbocYDG?lRC5Co
8S94obXR6OlI6AT9oa4A4@;o6ATA0_lA4A400olI6AWo4A4Aoa4A4@03oa4A
4@04o`000?lA4A7o4A4Ao`0000;o4A4A00Co0000oa4A4OlA4A7o00001olA
4A400ol0003o4A4Aoa4A4@0>oa4A4@03o`000?lA4A7o000000;o4A4A00?o
6ATIoa4A4OlI8R800_lA4A403olI8R[o4A4Aoa4A4OlI8R[o4A4AoaTR8_lA
4A7o:Q48o`000?lR>Uco>Uafo`000?lZ4@So6B8ZoaTI6@02oa4A4@0Xo`00
0?lA4A7o4A4Ao`000?lI6A7o0000ob8Z:_lR<TCo6B8RoaTI4OlI8R;o8S94
oaTI6OlR:R[o8S94o`000?lZ4@So0000obXA2?m4A3;oE6efoda]Qom<OYOo
4A4Ao`000?lZ4@So:R8IobXA2?lZ8QWo6ATAoc8jA?lI6A7o8RXZoaTR8_lI
8S;o6B9<odanSomDMYOoC7jGob9<E0?o00000_lA4A401?lI6A7o8S94ocYL
M_lI8R82o`0000;o4A4A00Wo0000oa4A4Ol0003o6ATIoaTRC?lR>Uco6B9<
oa4A4Ol000000_lA4A401Ol0003o<WJao`000?lA4A7o>VF700;o4A4A0_l0
00001OlA4A7o0000oa4A4Ol0003o4A4A00;o000000Wo4A4AoaTI6OlA4A7o
4A4Ao`000?lA4A7o0000oa4A4Ol000000olA4A400ol0003o4A4Ao`000002
oa4A4@07obXA2?lA4A7o:Q48obXA2?lI6A7o0000oaTI4@02obXA2005oaTR
<_l0003o6B8RoaTR<_lI8RX00olA4A403OlI6AWo4A4AoaTR:_lI8TcoSgI4
olYf0?m4:R;obWH0oc8jA?lj>S;o>UALodafO_m4A4`00_m<KHL01?lR>Uco
OWi]oaTR<_l0002Tooooo`00F_o^k^h02OlI8R;o6ATIoc8jA?lR:R[o6DAn
oda]UoljIHOo6DAnoc94MP02odafU`0>oeanUomnWkWoQa40oim]C?na^Ioo
/K6iol6a^On?UhooID`IoginKOmnMUCoOVeUoginKOmnMVD2oginK@;oOWIU
01;oOWi]ogifIOmnKFGoMWiLoda<>_m4:R;oA3XZoeaLC?m]MWKoOWIUohMn
E?m]MWKoOWIUogiUE?mfOUcoOVeUogifE?mnMVD2ogifE00AohmfA?mUIC[o
Qda4ofEL:_lR8Q7o0000obXA2?lI6AWo:Q48oaTI6OlZ4@So6ATAofDI0?oK
/IooSd@AobXA2?niUe@00_lA4A403On74@3oA140obXR6OnGSgKoOVe<ogIn
G?mnIECoIFDjofED<_m<C4CoIE@boda<A?mL>R800_l000001_lR8Q7o:Q48
o`000?lZ4@So0000oc8Z8P;o:Q4800KoA140od@Z8_lZ8QWo4A4AoaTI6OlR
8Q42oa4A4@Go:Q4800WoA140obXR6Om4>R[o6ATAobXA2?lI6AWo:R8Iob8Z
:_lZ4@P00_l000001?lZ4@So0000oaTI6Olb>T@2obXA200=o`000?lZ8QWo
C288oc8Z8_lZ4@So6B8RobXR6OlR:R[o>TA<ob8b:_lR:R[o6B8Ro`000006
oa4A4@Co000000?o<RXRoa4A4Ol000000_lA4A401_lI6A7o4A4Aoa4A4Ol0
003o4A4Ao`0000;o4A4A00Oo0000oa4A4Ol0003o4A4Ao`000?lA4A7o0000
00;o4A4A00Ko6ATIoa4A4Ol0003o0000oa4A4Ol00002oa4A4@03oaTI6OlA
4A7o4A4A00;o4A4A0_lI6AT3oa4A4@05oaTI6OlA4A7o4A4AoaTR8_lI6AT0
0_l000000olA4A7o0000oa4A4@02oaTI6@;o6B8R00?o4A4Ao`000?lI6AT0
0_lA4A402?lI8R;o8R8Aoa4A4OlA4A7o:Q48o`000?lI6A7o:Q480_l00000
1OlR:R[o>TA<ocYLM_l0003o4A4A00;o000000So4A4AoaTI6Ol0003o6B8Z
ofFG/OlR>Uco0000oaTR:P;o<SY400?oA2XRoeaLC?lI8R800_lA4A400ol0
003o6ATIo`000002o`000004oaTR:_l0003o0000ob8bA0?o000000oo<SY4
o`000?lR:R[o0000oa4A4OlI8S;o6GIfodanSoljIIOoC7j?o`000?lA4A7o
0000oa4A4Ol000000_lA4A400olI8S;o0000oa4A4@02o`0000?o4A4A00Go
0000ob8Z:_lR>Uco6B9<oaTR:P03oa4A4@;o000000CoC7JGo`000?lA4A7o
8TaD0_l000000olA4A7o0000oa4A4@02o`00000;oa4A4Ol0003o4A4Ao`00
0?lA4A7o:Q48o`000?lA4A7o0000oa4A4Ol000000_lA4A401_l0003o4A4A
o`000?lI6A7o:Q48od@A00?o:Q4800koA140ob8R4OlR8Q7o4A4AoaTI4Ol0
003oC4a4ocYUQoljIIOo0000oaTR8_mLG4co<SY4oaTR8P?o4A4A00co6B8R
oaTR:_lI8TcoC4`jooc10?nOC03oo<40ofefM_lb>TCoA4A<odaDKOljG7H2
odaDK@04oaTjM_mnOVgoSgIUoaTI6JCok^k^001JonKViP06ob8Z:_lI8Tco
6DB7ocYDQolR>Uco6B9<0_ljE8L01Om<O[7oC7jGocYUQoljIIOo<TAf00;o
000000Wo:Q48od@Z8_mUE3;oOUa<od@A0?n?QfgoKGIfogi]IOmnMVD00_mn
MU@04?m]MWKoMWiLogifIOmnOVgoMWiLogifE?m]MWKoKFeDoda<A?lb:R;o
C4`jogifIOmnKFGoQgiDogifIOmfOU`2ohMnE005ogifE?n7OUCoQgiDohMn
E?mnMVD00_n?Qe@06On7OUCo8R8AobXR6Om<A2;o4A4Aoe`j8_nGSgKoShmU
oin?KOnGSgKoWhM]om^aZOnaQfGoQd`Aon?B/OlZ4@So6B8Rohmf:_m4:R;o
0000oiN?M_mnMVGoOWi]ofe]E?mnKFD00_m]KE@3ofEU>P0BoaTI4OlZ8QWo
8S94ob8R4OlI6A7oA2XRodA4<_lj>S;o0000oaTI6OlZ4@So:R8Iod@Z8_m<
C3[oG5a<oda<>_ljA1Wo00001OlZ4@P01?m44@3o8R8Aoc8jA?lb>T@3ocY4
C008ocXj<_l0003o:Q48o`000?lA4A7o:Q48ocY4C?ljE5`3obXA2006od`R
2?m4:R;o8RXZob8Z:_lI8R;o6B8Z0_lA4A42o`000007oa4A4OlZ4@So4A4A
oa4A4Ol0003o4A4Ao`000003oa4A4@03o`000?lA4A7o000000Co4A4A00?o
0000oa4A4OlA4A401?lA4A400ol0003o4A4Aoa4A4@04oa4A4@03o`000?lA
4A7o000000;o00000_lA4A400ol0003o4A4AoaTI6@04oaTI6@03oa4A4OlI
6AWo4A4A00;o6ATI00?o4A4AoaTI6OlI6AT00_lI6AT01OlI8R;o4A4Aoa4A
4Ol0003o4A4A00;o000000?o6B8RoaTI6OlA4A400_lA4A403?l0003o>SXb
o`000?l0003o8TaDoaUDO_ljG7KoC6f7obXR6Ol0003o>VF7odan/@;o0000
00Co>VF7ob9<E?lRC5Co00000_lA4A42o`00000;oaTR8_lR8Q7o:Q48oda<
A?mLKGKoKFeDoea]QolZ8QWoC4a4ocY4C?ljG7H01_l000001_lA4A7o0000
oaTR8_l0003o4A4Aob8Z:P;o000000_o4A4AoaTR8_lI8R[o6B8Zoa4A4Ol0
003o6B8bocYDG?m<OYOoC7j?odanU`02oa4A4@03o`000?lA4A7o000000;o
4A4A00?o6ATIoa4A4Ol000000_l000002_lA4A7o0000oa4A4OlA4A7o0000
ob8bA?lI6AWo4A4AocY4C?l00002oa4A4@04o`000?lbA7Ko4A4AoaTI6@?o
000000Go4A4Ao`000?l0003o0000obXA2002o`000003oa4A4Ol0003o0000
00;o4A4A00?o:Q48o`000?lI6A400_l000003OlA4A7o:Q48oa4A4Om<8PSo
:Q48oa4A4OlZ4@SoC288o`000?mL>R;oC6f7oa4A4Ol000000_lA4A402ol0
003o>UALoda]QolbA7Ko6B8bofEU>_ooooooWhM]oaTRC?lI8S;o6B8R00;o
6B8Z017o6ATIoaTRC?lI8S;oom88oncK/Oolo?Co^IM]ocYDG?m4A4co0000
ocXj<_ljE5co>UafocYDQon?UhooOVEDohMnS`2TonKViP00F_o^k^h01_lR
<TCo6B9<oaTRC?lR:R[o6B9<ob8jG0?o>UB700Co<TAfocYDQoljIIOo0000
0olZ4@P03?m44@3o:Q48o`000?lZ4@SoA140ohMnE?mnOVgoKGIfoginKOmn
MVGoSgIUogifI@;oOWi]0_mnMVD02?mnOVgoOVEDogInG?m4>R[oIE@bogi]
IOmnMUCoOWi]0_mnMU@06omnOVgoOWIDohMnE?n7OUCoOVeUohn7KOn?MS[o
0000obXA2?l0003oQfDbob8R4OmLG4co0000ohn7KOlj>S;oOVEDohMnSon?
MUCoOWi]okVOO_oK/Ioo`K6iobXA2?n74@3o6ATAoe`j8P02obXA200Col6a
WonOUhOoWiN7okVOO_na^IOo/K6?okVOO_na/HooZJV?okViUolZ4@So8R8A
obXA2?m<8PSo:Q48ogiLC?nOWgko6ATAob8R4@02obXA2008oc8Z8_n7IC;o
b/6OolZaZOoSd[7oSgHjo`000?lR8Q44obXA200;ob8R4Ol0003oShM]ocYD
G?lb>TCo:R8IoaTI6OlZ4@So0000ob8R4Ol000000_lZ4@P00olI8R[o6B8R
o`000003obXA2004od@j:_lI6A7o4A4Aoa4A4@;o00000_lA4A401olZ4@So
4A4AoaTI6OlA4A7o0000oaTI4Ol000000_lA4A42o`000004oa4A4Ol0003o
4A4Ao`0000Co4A4A00Ko0000oa4A4OlA4A7o0000oa4A4Ol00002oa4A4@04
o`000?lA4A7o4A4Ao`0000Oo4A4A00?o0000oa4A4OlA4A401?lA4A400olI
8R;o6B8ZoaTI6@03oaTI6@03oa4A4OlI6AWo6ATI00?o6B8R00Oo6ATIoa4A
4Ol0003o0000oa4A4OlZ4@So6ATI00;o6B8R00CoC7j?o`000?l0003o6FEn
0_l00003ob8jG006oaTRC?lA4A7o0000oaTI4OlZ4@So00000_lZ4@P02?lb
>TCo8S94ocY4<_lZ4@SoA140oaTI4OmDMYOoG5a<0_m44@002?lb:R;oC6f7
o`000?lI8S;o8S94ob9<E?lIE7ko>Uaf0_l000001?lA4A7o0000o`000?lA
4A42o`000006ob94>_l0003o0000oaTI6OlA4A7o00000_lA4A42oaTI6@0:
o`000?lA4A7o6B8Rob8jG?mDMYOoC7j?odanUolR<R[o4A4Ao`0000;o4A4A
00[o0000obXR6OlI8R;o0000oa4A4Ol0003o4A4Ao`000?lA4A7o00000_lA
4A43o`00000<odaDKOl0003o0000oa4A4Ol0003o4A4AoaTI6OlA4A7o0000
oa4A4OlZ4@So00000_lA4A403OlZ4@So4A4Ao`000?lA4A7o0000oa4A4OlZ
4@So4A4AobXA2?lA4A7o0000obXA2?lR8Q400_lZ4@P02ol0003o4A4Ao`00
0?lZ4@SoIAT0oa4A4Om<8PSo:Q48oa4A4OmLKGKo6B9<00;o4A4A00co6ATA
obXR6OlR<TCoIHNYoda]QolR>Ucom>cKooCdk?mL>R;o6B8bob8Z:_lI8S82
oa4A4@0AoaTR:_lI8Tco6B9<oooB2?odk=_oooooonbiKOn7C4Co<SY4oaTI
4OlA4A7oA4A<ocYUQolIE7ko`K6?ohmf>_mUE380Y?o^k^h005[ooooo00Wo
8RXZoaTI6OlI6AWo6B9<ocYUUom<KHOo>VFGocYDQolIA7h00_lbA7H03?lj
E8Oo6B9<oa4A4OlA4A7o:Q48odaDKOlI8Tco>TA<obXR6Om44@3oOUa<ogin
K@;oOWIU00?oOWi]ogi]IOmnMVD00_mfOU`00omnKFGoOWIUofe]E002ogIn
G0;oKFeD01;oIE@bofEU>_mUIC[oOUa<ofe]E?mLG4coKFeDofEU>_m]KECo
IFDjogi]C?m4>R;o0000oaTI4OlZ8QWoQfDbobXR6OmLG4`2ob8R4@04ofDb
2?nOWhooWhM]oinGQ`;oWimn00Wok:U<ohmU4OlA4A7oWd`0ohm40?n?MUCo
:Q48o`000?oBbZT00ona^IL03OnYZHoo/K6?ojVYSonOUhOoZJV?ol6aSolj
A1Wo4A4Ao`000?lA4A7o0000oiMnE?nOWgh00olZ4@P02?lb:R;o8R8AokVO
O_oSfm_ohm;1oooooon7OUCo4A4A1OlZ4@P02?l0003oC288oinGQomnMUCo
IE`Zo`000?lA4A7o00001OlZ4@P02?ljA1WoID`IobXA2?lR8Q7o:Q48od@Z
8_lR8Q7o00001?lA4A401_lZ4@So0000oa4A4OlA4A7o0000oa4A4@?o0000
00Co6B8Roa4A4Ol0003o4A4A0_l00003oa4A4@05o`000?lA4A7o0000oa4A
4Ol000000_lA4A400olI8R[o4A4Ao`000005oa4A4@06o`000?lA4A7o4A4A
o`000?lA4A7o00001OlA4A402_lI6A7o6B8RoaTI6OlI8R;o4A4AoaTI4OlI
8R;o6ATIoaTI4OlZ8QT2oaTR8P05obXR6OlR:R[o8T@joa4A4Ol000000_lA
4A42o`00000;oc94M_lb>TCo8S94ocYDQol0003o:Q48o`000?lZ4@So>TA<
odaDKOm<C4@00olZ4@P2odaDK@08ocXj<_lZ4@So:Q48oa4A4OlR>S;o8S94
oaTI4OlZ4@P2oa4A4@09oaTR<_lI8Tco6B8RoaTI6Ol0003o6EAno`000?lR
>S;o8S9400;o>UAL00?o>VF7o`000?l000000_l000002OlA4A7o0000o`00
0?l0003o6B8bo`000?lA4A7o<RXRo`000003oa4A4@0;o`000?lR>S;o0000
oa4A4Ol0003o:R8IodanUomDOWkoC7jGob94>_lR<RX00ol000001?lA4A7o
6B8RoaTR<_lI8S82o`0000;o4A4A00?o:Q48oaTI4OlZ4@P00_lZ4@P00om4
4@3oA2XRo`000003obXA20Co4A4A0_lZ4@P01?l0003o4A4Ao`000?l00002
oa4A4@06obXA2?lA4A7o0000oa4A4Ol0003o4A4A0_lZ4@P01?lA4A7o0000
o`000?l00003oa4A4@03o`000?lA4A7o000000;o:Q4800Oo8R8Ao`000?lZ
8QWoC5A]o`000?lA4A7o>TA<00;o000000GoC7jaoeB7/OlR<TCoo?cdoiN?
MP02oaTR<P0=oaTR:_lI8R;o8RXZoaTR8_lI8R[o6B8boaTRC?ol`@3om<54
om_1Woo/Z@3o^GiDoaTR<P02obXA2006ob8R4OmLQiOo/K6iokVOO_n7OUCo
ID`IY?ooool005[ok^k^01Wo8S94oaTR<_lIA7ko>UB7oc94M_lI>WKo8SYL
oc94M_lR>Uco6DAnoaU4QolR>Uco6B8Ro`000?lZ8QWo0000ob8bA?lb>TCo
<TAfodA4C?n7UjWoQgj?ogInG?mnMVGoOVeU00?oOWi]00CoOWIUofefM_mn
OVgoOWi]0_mnMVD2ogi]I@;oOWi]00KoQgiDohmnKOn?OVgoSgi]oiN?M_nO
Qfd2oiN?MP03ok6iUom]KECo6ATA00;o4A4A01Oo<RXRofEL:_lZ8QWoQgiD
o`000?nOQfgo^KVGok6iUona/Hoo/KVGol6a^Om]IB;odXLIoim<0?lR>S;o
Z@P0ohLA0?mnKDco:Q48o`000?o/fk7ohm:aom;:`@02ojVYS`0:ol[1Wona
/Hoo/KVGokVaWooSd/7oIE`Ioa4A4OljA4co:R8IofDb20;o00000olZ4@P0
1olI8S;oA2XRohn7KOoSd/7o/L[:oiN?M_l000001OlZ4@P3o`000004om;:
`OnOSfgo0000o`0000Ko:Q4800Wo/HMUon?B`Oo:^Hoo<RXRo`000?lZ4@So
A2XRod`R2?lI6A400olA4A404?lI6A7o4A4Ao`000?l0003o6ATIo`000?lZ
8QWo8T@joc8jA?ljA4co>UALoa4A4Ol0003o4A4Ao`000?lA4A42o`000004
oa4A4Ol0003o4A4Ao`0000Wo4A4A00Go0000oa4A4OlA4A7o4A4Ao`000002
oa4A4@03o`000?lA4A7o4A4A00;o4A4A00?o:Q48oaTR8_lI8R800_lI8S80
3?lR:R[o8S94ob8jG?lRA3[o8SYLob8bA?lRC5Co<SY4oaTRC?lb>TCo8SYL
oc8jA0?o:Q4800?o<SY4ocYDG?lR8Q400_lZ4@P02_lj>S;o>UB7ob9<E?l0
003o:Q48oa4A4OlbA7Ko6DB7oaTjM_lI8RX2oaTR<P0;oa4A4Ol0003o4A4A
oa4A4Ol0003o4A4Ao`000?lA4A7o6ATAobXA2?lI6A400_l000002olI8S;o
6ATIoaTI4OlA4A7o:Q48oaTI4OlR:R[o8S94ocYDG?lR>Uco>UAL00?o0000
00?o4A4Ao`000?lA4A400_l000001?lb:R;o0000o`000?lR:RX2o`0000;o
4A4A00Co6B8ZobXR6OlI8Tco6B9<0_lZ4@P01OmDSk7oC7jGodanUolRA3[o
6ATI00;o:Q4800Ko8R8AoaTI6Olb:R;o0000oaTI4Ol00002obXA200<oaTI
4Ol0003o6ATIob8Z:_ljIHOo6EAnob8bA?lR8Q7o:Q48oe`j8_m44@3oC288
0_lZ4@P00om<8PSo:Q48oaTI4@03obXA2008o`000?lA4A7o0000obXA2?l0
003o6ATAo`000?lA4A42obXA2003oa4A4Ol0003o000000?o4A4A00Oo0000
oa4A4Ol0003o4A4Ao`000?lA4A7oA14000?o:Q48013o0000ob9<E?l0003o
4A4Aob9<E?lI6A7o0000ocYUQolbM[7oID`Ioooooon?OVgo6B8RoaTR<_lI
8R;o4A4A0_lI8R802OlI6AWo6B8bob8jG?o/Z@3ofhL8on>O0?o/Z@3oom88
ojUf<P03ob8R4@05obXA2?odm>co^ImnohMU<_n7C140Y?o^k^h005[oi^KV
00?o8S94oaTRC?lR<T@00olI8T`02?lR>Uco6B9<ob8jG?lR>Uco8S8Zo`00
0?lA4A7o6ATA0_lA4A401ol0003o6B9<ocYDG?lI8S;oE6efogi]IOmnMVD0
0_mnOVd01omnMVGoOWi]oginKOmnOVgoOVeUogifIOmfOU`00_mnMVD01_na
^Ioo^KVYol6aWoni^IOo^KVYok6iW`;o/KVG02koZJV?ok6aSona/Hoo^KV?
ofeU8_mUG2[o6ATAobXA2?n?G4coG3XRoiN?M_m44@3oC4a4ofE<6Oodk=_o
hm;1om;:`Oo/hl[ob[6Yok6iUom44@3ohilRokU<0?m]KECo^D`0ofDI0?lj
A1Wo:Q48o`000?niWgkoi^KVoinGQona^IOo^K6OokViUonYZHoob[6YoncS
b_o/fl7o6E@bob8R4Ol0003o8R8Ao`000?mUE3;o:R8I0_lA4A401olI6A7o
:Q48oa4A4Olb:R;oOWi]ogifE?mUICX01_lZ4@P01?lA4A7o0000o`000?mU
C1T2o`0000Go:Q4800[o4A4AofDb2?nOSfgoIC88od`R2?lZ4@So6ATAod`R
2?m<A2;o4A4A1Ol000003olb:R;oC4a4oda<>_lRC5Co>TA<oc8jA?lI8R;o
8T@jocY4C?lRA3[o6ATIoa4A4Ol0003o4A4Ao`000002oa4A4@03o`000?lA
4A7o4A4A00;o4A4A00?o0000oa4A4OlA4A400_lA4A400ol0003o4A4Aoa4A
4@03oa4A4@03o`000?lA4A7o4A4A00Go4A4A00go0000oa4A4OljA4co8SYL
ocYDG?m4A4co<SY4od@Z8_lb:R;oC4`joeA]M_mLKGKoC28800;oA14000ko
A4A<odaDKOlR<TCo:Q48o`000?lR:R[o8S94ob94>_l0003o<SY4ob8bA?lR
A3[oC7j?o`0000;o4A4A00Go6B8bo`000?l0003o6B9<ob8bA002oaTRC003
oaTR<_ljA1Wo8R8A00;o6ATA00Ko<RXRoa4A4OlR8Q7o8R8AobXA2?lA4A42
o`00000=oaTRC?lI6AWo6B8ZoaTI4Ol0003o6ATAoaTRC?lb>TCo8S8Zob8j
<_lRA3[o0000oa4A4@02o`000008oa4A4Ol0003o4A4Ao`000?lI8R[o4A4A
obXA2?m<8PP2o`0000;o4A4A00go:Q48ob8R4OlR8Q7o8RXZod`R2?l0003o
4A4Ao`000?lZ4@So8R8AoaTI6OlA4A7o6B8R00;o4A4A00Go6B8Zo`000?l0
003o:Q48oaTI4@02o`00000=oa4A4OlRA3[o0000oa4A4Ol0003o>UALo`00
0?lZ4@So6ATAoea]QoljA4coA3XZod`R2002o`000003oa4A4OlZ4@So0000
00;o4A4A00Ko0000oa4A4OlA4A7o6ATAo`000?lA4A43obXA20Co4A4A00Go
0000oa4A4Ol0003o0000oa4A4@02oaTI4@0;o`000?lb:R;o0000obXA2?lI
6A7o:Q48oaTI6OlI8R;oA3XZobXA2?lR>U`00_l000001_lA4A7om?C/ooCd
m?odk=_oQe@ZoaTR:P;o4A4A00Go6B8boaTI6OlI8R[o6B9<okVOOP02ooCB
OP0<on?BWooS`DCom>?:ohLZ0?lI6AWo8R8Aoc8Z8_lA4A7ohm:OofE<6Om]
IB;oID`IY?oVi^H005[ok^k^00ko6B8bob8bA?lR>Uco8SYLoc94M_lI>WKo
<TAfoaTjM_lbA7Ko4A4Ao`000?lI6AWo8RXZoaTR:P?o4A4A00[o6B8boc94
M_lIA7koC5A]ofefM_mnOVgoOWIUogInG?n?OVgoOWi]0_nGSgH00onYZHoo
Uhn7oinOOP02oiN?MP0WokVOO_naQfGoWimnoinGQonOWgko`KVGom_1WooB
bZWohm:aoncSb_oBb/7ob]_KofEL:_lj>R;o0000ol6iUoodhl[o`KVGonc1
QonaK@3ob/6OofED<_n?SfGo/K6?oncSb_o:/JWo/KVGoiN?M_m<8PSok:T0
ok5]0?na^IOok:T0okV70?l0003o8R8Aod`R2?m44@3od/ZY00;o^KVG00go
^K6OolZaZOoSd/7ok>?:on?B/Oodk=_oIE`Zo`000?lR>S;o6ATIobXA2?lI
6A7o:Q4800;o000000Wo6ATAobXA2?lI6A7o0000ofDI0?m<8PSoID`Iod@j
8_lR8Q401OlZ4@P01ol0003oG3XRo`000?lZ4@So0000obXA2?l000000olZ
4@P01Om4:R;oSgIDoin?KOnaSaWo8R8A00;o:Q4801SoQe@ZobXA2?m44@3o
IE@bogiUE?mLG4coKGIfoea]M_ljE5coA4A<oda<>_lb>TCo8SXbob8Z:_lb
:R;o>SXbodA4C?lRC5Co6B8Ro`000?lA4A7o0000oa4A4Ol00002oa4A4@04
obXA2?lA4A7o6ATAo`0000Co4A4A00?o0000oa4A4OlA4A400olA4A400ol0
003o4A4Aoa4A4@02oaTI6@0@oaTI4OlA4A7o<RXRoaTR<_lR:R[o8R8AobXA
2?m44@3oC6f7oeAnO_m<C3[oA140od`R2?lb>TCoE6efocYDG0?o<SY400Oo
8SYLob9<E?lRC5Co0000oa4A4Ol0003o4A4A00;o000000Go>UALob9<E?lR
<TCo>VFGo`000004oa4A4@03oaTR<_lR>Uco8SYL00;o6B9<00Co4A4AocY4
6OlI6A7o6ATA0_lZ4@P00olA4A7o8R8AobXA2002oaTI4@0;oa4A4Ol0003o
:Q48obXA2?lR:R[o:Q48oa4A4OlI6AWo6B8bob8jG?lRA3X00_ljG7H2o`00
00;o4A4A01;o8RXZob8R4OlZ4@So4A4Ao`000?lI6A7o4A4Ao`000?lZ4@So
8R8AobXA2?l0003o:Q48o`000?lI8S;o8RXZofDb2?lI6A42ob8R4@03obXA
2?l0003o000000;o4A4A00Co0000oa4A4OlI6A7o4A4A0_lZ4@P02Ol0003o
4A4Ao`000?l0003o6B9<o`000?lb:R;o4A4AoaTI4@02obXA200Co`000?m]
SiOo>UB7obXA2?lZ8QWo0000oa4A4Ol0003o:Q48o`000?lA4A7o0000oa4A
4Ol0003o:Q48ob8R4OlI8R;o8T@jo`000002oa4A4@?o000000Co4A4Ao`00
0?lA4A7o:Q481?lA4A401OlI6A7o:Q48oa4A4OlI6A7o8R8A00;o0000027o
/KVYo`000?lZ4@So:Q48ob8bA?nOKDcom>?:on?B/Oo/k>?om?C/ooCSb_m<
8PSo6ATAobXA2?lR:R[o6B9<oc8jA?o/fk7ok>cSooCdk?o/k>?om?Cdohn?
IOodm>co:Q48oaTI4OlI6AWo4A4Aod@A0?odm>coC288oda48_m<8PP0Y?o^
k^h005[ooooo00Co6B9<ob8jG?lR>Uco6DB70_lbA7H02?lIA8Oo8SYLoa4A
4Ol0003o4A4AoaTR<_lA4A7o6B8Z0olA4A403?l0003o8RXZoc94M_n7OXoo
Uhn7ohn7KOn?UhooShM]oncSb_oSd/7ok>?:om;:`@;ok>?:04?om>cKohnG
SonGSgKoUhmfoinOO_nOSfgoWimnoiN?M_oSfm_od/[1on?B/OoBb/7oSiN?
ohn7KOmUG2[oID`Ioc8Z8_m4:R;ohm:aol6aWonOSfgo/K6?okV70?na/Hoo
b/6YokVGE?nYZHoob[6Yok6iUoni/Ioo^KVYod@A0?oKQ`SofgH8ohmU4Oni
C03obWH0oim]C?lZ8QWoIC88ofDI0?ni^IOo`K6OolZaZOoSd[7ohm;1om;:
`OoBbZWob[6Yol[1ZOn?MS[o0000oa4A4Ol0003o4A4Ao`000?lZ4@So0000
oa4A4Ol0003o:Q48o`000?mL>R;om>?:on?B`OoBb/7oKFDR00;o8R8A00go
:Q48od@A0?lR8Q7o:Q48oa4A4Ol0003o6ATIo`000?lR8Q7o:Q48o`000?lZ
4@So000000;o8R8A00co^IM]oin?KOn?IA7o0000ob8R4OlZ4@SoSgI4oooo
oona/KWoWl6aohnGSomfOU`2oeaLC008ocXj<_m<C4CoG5a<ocYDG?m<C4Co
>SXbocY4C?m<E6d2ocY4C003oa4A4OlZ4@So000000;o00001?lA4A42o`00
0003oaTI4OlZ4@So4A4A00Co4A4A00Co0000oaTI4OlR:R[o6B9<0_lZ4@P0
0om4A4coC5A]obXR6@02oa4A4@0:o`000?lI6A7o6ATIoa4A4OlR<TCo<SY4
ob8jG?lRC5Co8SYLob9<E0?o8SYL00_o<SY4ob9<E?lRC5Co8SYLob9<E?lj
E5co8TaDo`000?lA4A7o0000oa4A4@02o`000007oaTRC?lR<TCo<SY4oda]
Uol0003o4A4Ao`000003oa4A4@;o6B9<00Ko8S94oaTR<_lI8R[o8R8AocY4
6OlZ4@P2oaTI4@;o4A4A00Go8R8AobXA2?lR8Q7o:Q48oa4A4@02ob8R4@0I
oaTI6Ol0003o0000oaTI4OlI6AWo:R8Ioc8jA?mDKGKoG8N?od@A0?lZ4@So
A140ob8b:_ljA1Wo0000oa4A4Ol0003o4A4AoaTR:_l0003o4A4Ao`000?lI
6A7o:Q48od`R2002obXA2003ob8jG?lb>TCo000000;o000000?o8S94oaTR
<_l000000_lA4A401?l0003o4A4Aoa4A4OlR<RX6o`00000Boa4A4Ol0003o
4A4Aoa4A4OlI6A7o4A4AobXA2?lI6A7o:Q48oda]QomLOYOo>UALod`R2?lA
4A7o0000oa4A4Ol0003o4A4A0_l000003olI6A7o4A4AobXA2?lR8Q7oE6ef
ocYLM_lR>S;oA3XZo`000?lZ4@So0000oinGQon?KDco0000obXA2004oa4A
4@04oaTR8_lZ4@So8R8Ao`0000;o:Q4800Co4A4AojUf<_mU<PSo00000_lR
8Q401?lZ4@Sok>cSooclm?o/fl42ooCdk003ooclm?odhl[o000000;o:Q48
01;oUgiDooC/foolo?Com?C/onc/hoodm>coo?cdokVGE?oSfm_oSd@Aoa4A
4OlI6AWo0000oimnC?ooooooC288oe`j8_m4>R:Tooooo`00F_o^k^h00olR
<TCo8RXZob8bA002ob8jG004oaU4O_lR<TCo0000oa4A4@;o6B8R00Co0000
oa4A4OlI6AWo6B8Z0_lA4A403olI6AWo0000ofDI0?nOQfgoWiN7ohnGSonG
ShOoQgj?ooCSb_oBb/7ohm;1on?B/Oo^k^kohm:aom;:`@02oiN?MP0IohnG
SonGSgKoUhmfoiN?M_oK`Ioohm:aoncSb_oBb/7om>cKoaTI4OlR8Q7oIE@b
ofEL:_mUE3;o4A4Aok5]6OoBbZWohiljohMnE?ol`@3o^IMDocY46On?MR[o
QfDbokVaW`02okViU`0AokVaWolI6A7ofhL8om:76OnaK@3o^D`0ok5]0?oo
oooo^IMDofDb2?mU6@3o^Imnom;:ZOo1/Ioob/6Ool6iUoni^JT00_o1/Il0
1?o:`JWo`K6?oaTI4Ol00002obXA2003oaTI4OlA4A7o000000;o4A4A0_l0
00001On7E2[ohm_Kon?B/Oo1^HOo>T@I00Co:Q4800KoA140ob8R4Ol0003o
:Q48oa4A4OlZ4@P2o`00000Ioa4A4OlZ4@So:Q48obXA2?n?G4coWimnoda4
8_odhl[oA140ob8R4Om4:R;oOVe<om;:`Ona^IOoWin?oinOO_nOUhOoSiN?
off7O_mnKFGoE6efoeAnO_mLKGKo>UALodA4<P03ocYDG003oc8jA?lR:R[o
000000?o4A4A00Wo0000oa4A4Ol0003o6ATIohmfA?n7IC;oIE@bob8Z:_l0
00000_lA4A402olR:R[o:R8Ioa4A4OlR8Q7oA4A<oaTR<_lI6A7o6ATIobXA
2?l0003o8RXZ00Go4A4A017o>TA<odaDKOljA4coA2XRoc8jA?ljE5coC7In
odA4C?lb>TCoC4a4oc8jA?ljE8OoC5A]odA4C?lb>TCo8S94ocY4C002oa4A
4@0:obXA2?l0003o:Q48obXA2?lZ8QWo>SXboaTR8_ljIHOo0000oa4A4@;o
6B8R00[o4A4Ao`000?lI8R[o6B8RoaTRC?lR<TCo4A4AocY46OlR8Q7o>T@I
0_lR8Q400ol0003o:Q48o`000002ob8R4@0BoaTI4Ol0003o0000od`R2?m<
E6goG7jGoda]QomU6@3oA2XRodA4C?m<KHOo>UafocYDG?lIE3;o8R8Ao`00
0?lI6A7o8R8A0_lI6A42o`00000<ob8j<_l0003o0000oa4A4Ol0003o:Q48
odA4<_lR<TCoA140ob8bA?lR>Uco>TA<0ol000001_lI8S;o0000oa4A4Ol0
003o4A4Ao`0000;o>UAL00Co0000oa4A4OlA4A7o00000olA4A404OlR:R[o
4A4AobXR6OlR8Q7o0000odA4:_m<8PSoA2XRocYDG?lRC5Co8RXZogj?SolI
6A7o4A4Ao`000?lA4A7o000000;o4A4A00ko0000obXA2?lZ8QWo:R8IogIn
G?ljG7KoKFeDocYDG?l0003o:Q48o`000?olo?Cok=^aofDI00;o000000Ko
4A4Ao`000?lI8R[o:R8Io`000?m<8PP2oa4A4@0=o`000?m44@3oSfDAokVG
KOlZ4@So6ATAobXR6Ol0003o/K6?ooclm?o/k>?om?C/onc/h`02ooclm006
od@A0?m4:R;o0000okVOO_olo?Com?C/0_o/k><03Oodk=_oo?cdoin?KOoB
b/7oo?cdohm40?lR8Q7oC288ooCdk?ooooooC288oda48_m4>R80Y?o^k^h0
05[oi^KV00Co0000obXA2?l0003o4A4A0ol000003_lA4A7o:Q48oaTR<_lI
8R;o4A4Ao`000?lZ8QWo4A4AoaTI4OlA4A7o0000obXA2?l0003oZJV?0_nG
ShL0:_nGSgKoOWi]on?KfooBb/7ohm;1onKVi_oSd[7ohm_Kok6iUonOSfgo
Wimnoin?KOnGSgKoShmUom;:`Oo/hl[ohm;1on?B/OnGOUCob/6Yoda<>_lR
8Q7oIFDjod`R2?n7C4Co0000ohm]C?odk=_ok;U]okVaWoo/`C;ohl54odA4
:_oSZHoob[6Yol6aWoo1^IOo^KVGon?B`Om<C3[oWd`0om^?<P;obWH000co
^HL0on?B`OoSW`3oQa40oim<0?nGSgKob[6YokViUona/Hoob/6YokViUoo1
^IL2okViU`04om;:ZOlR8Q7oG3XRob8R4@;o:Q4800Co4A4Ao`000?l0003o
4A4A0ol000001OmUC1Wo<RXRobXA2?ljA1WoA14000?o:Q4800?o8R8Aod@A
0?l000000ol000004OlA4A7o:Q48o`000?lR8Q7o0000obXA2?m]IB;oSgHZ
ofE<6OniUeCoA140obXR6Om44@3oWimnol6a^OnOZJWoUhn700;oKHMn00So
IFDjohn7KOm]QgkoKFeDoaTR8_m<C3[o8T@joea]MP;o>TA<00?oC4a4ob94
>_lR:RX00ol000005olA4A7o0000oa4A4OlZ4@So4A4Aoc8Z8_n?MS[o0000
oaTR<_lI6AWo:Q48oaTI4OlI6AWo6B8ZoaTR8_lA4A7o0000ob8Z:_lR>Uco
8RXZobXA2?lA4A7o6B8Z00;o6ATI00Go4A4Ao`000?lA4A7o8RXZocYLMP02
oc8jA004oc8Z8_ljIHOo>UALocXj<P;o:Q4800Co:R8IocY4C?lRC5Co<SY4
0_lZ8QT03Om<E6go8S94ob8j<_lA4A7o:Q48o`000?lR>S;o8TaDoda]Uolj
>S;oA2XRobXA2?lI8T`00_lR>U`2oa4A4@05o`000?lZ8QWo<SY4ob8bA?lA
4A400_m<8PP02_lIMTCoC4`jobXR6Olb:R;oA4@Zob8R4OlA4A7o:R8IoaTI
4OlR:RX2obXA200<ocYLM_lR<TCo6B8boda]UolR>Uco>VFGoaUDO_ljG7Ko
>UALoaTI4OlR8Q7o6E@b0olI6A401?l0003o4A4Aoa4A4OlI6AT2o`00000B
oa4A4Ol0003o:Q48obXA2?lZ8QWo8R8AobXR6OlR:R[o>UALo`000?lA4A7o
0000oaTRC?lA4A7o0000oa4A4Ol0003o8S940_ljG7H01?lRA3[o0000o`00
0?lR8Q42o`000019oc8jA?m<OXoo0000oc8jA?l0003o4A4Ao`000?lR<R[o
G3XRobXA2?lI8R;o8R8Aod`R2?l0003o:Q48o`000?lA4A7o0000oa4A4Ol0
003oG3XRobXR6Olb:R;oC4@Rob8j<_mnIECoWiN7od`R2?lZ4@So8R8Ao`00
0?odk=_om=9nokV70?lI6A7o:Q48ob8R4On?A03o^Gi<ohmf>_l0003oC288
od@A0?lZ4@SoQe@ZooCdk?o:`JWo/K6?od@A0?lZ8QWoA2XRo`000?o1/Hoo
o?cdonc/hoodm>cok>cSooCdk?odhl[o0000oaTR8_lR8Q7oID`IooC/foo/
k>?om>cKooCSb_o/hl[om?C/okVGKOo:`JWoooooom^aW`02okVGK@05oocl
m?ooooooIC88oe`j8_ljA1T0Y?oVi^H005[ok^k^1?lA4A400ol0003o6ATA
oa4A4@02oa4A4@0>oaTR8_l0003o<RXRob8j<_lI8R;o0000oa4A4OlI8S;o
4A4Aob8Z:_nGSgKoSiN?oinOO_n?Qfd2oiN?MP06oncSb_oSd/7ohm:aon?B
`OoSd[7o^KVY0_nOWgh0=omUIC[oQgiDoinOO_niWgkok>?:ohnGSolZ4@So
C4@Rohmf:_nGShOoSgI4ohMnE?n7IC;oQd`Aohmf:_naK@3oOUa<ooC/food
hl[oID`IokU<0?oS`DCoOVeUoncK/OoBbZWo`K6Ool6iUoo1/Iood/ZYofEU
>_m44@3ohiljolYf0?naK@3oQbX0oiN70?naK@3o^D`0on>O8_nYMS;o^KVY
om;:ZOmUC1WoOVe<oinOO_oBbZWo`KVGom;:ZOnOSfgo:Q48oe`j8_lR8Q7o
:Q48od@Z8_lZ4@P00_lA4A402Ol0003o4A4Ao`000?nGOUCom>cKol6iQol0
003oC288od@A0005obXA2003oa4A4OlI6A7o4A4A00?o000000Go6ATAo`00
0?lZ4@SoA140on>O>P02ocY46@07o`000?lR8Q7o:R8Iod`R2?mLG4coOWIU
oiN?MP02oinOOP08ogInG?n?UhooOWi]oinOSomnOVgoKGIfofe]E?mnMVD2
ocYDG005odA4C?m<C4Co<SY4ob8bA?l000000_lA4A401?l0003o4A4Aoa4A
4Ol00002oaTI6@06ob8R4OlZ4@So8RXZoaTR8_lA4A7o6B8Z1OlA4A401OlI
8S;o4A4Aoa4A4OlA4A7o000000;o4A4A00Ko0000oa4A4OlA4A7o4A4AoaTI
6OlR:RX2ob8bA006ob8j<_lR<TCo8T@job8jG?lRC5CoC5A]0_lRC5@01Om<
E6go8TaDoc94M_lRC5Co>Uaf00;o00000_lA4A43o`000003ocY4C?ljE5co
>Uaf00;o00000olA4A42o`000005oa4A4Ol0003o0000o`000?lR8Q400_lj
A1T01_lR8Q7o0000ob8R4OlZ4@So>T@IoaTI4@;o4A4A00So0000oa4A4OlZ
4@So6B8boa4A4OlI8S;o>UB7ob8jG0;o>UB700Ko8SYLob94>_lZ4@So8R8A
oa4A4OlI6A42oa4A4@05o`000?lA4A7o:Q48obXA2?lA4A400ol000001olA
4A7o0000o`000?lZ4@SoC288od@Z8_lb>T@00_l00002oa4A4@05o`000?lA
4A7o0000ocY4C?ljG7H01?ljE5`2obXA2008ob8R4OlA4A7o8S94odanSol0
003o8S8Zob8R4OlA4A42o`000005ohmf:_l0003oA140o`000?lj>R800_lI
6A43obXA200Ooa4A4Ol0003oUgiDofE<6OlZ4@SoOWIUoinOSonab/[ob/6Y
oe`j8_l0003o:R8Io`000?olo?Com=9noim<0?lA4A7o8R8Aod`R2?o/^Fgo
SgHjofEL:_lZ4@So8R8Aod@Z8_mU<PSob]_KoncSb_odhl[ofk6Ood`R2002
oa4A4@03obXA2?odk=_om?C/00;ok>cS0oodk=/05OmU6@3o<RXRoaTR8_nG
SgKom?C/onc/hoodm>cok>cSooCdm?olo?Co`KVGol6iWoolo?Cooooooocl
m?oooooom?Cdoooooon7C17oC4@Rod`R202Tonk^kP00F_ooool00olZ4@So
4A4Aoa4A4@03oa4A4@08obXA2?lI8R[o6B8boaTI4OlR<TCo6B8RobXA2?lb
A7H2oa4A4@05ob8jG?m]OXooOYniol6a^OoBbZT00_o:/JT01Oni/Ioo^KVY
ol6iUoo1^Ioo^KVY00;o`KVG03[o`K6Ooin?KOm<A2;oQfDbofED<_m<8PSo
^K6Oohn?IOniUeCohiljofEL:_nYMS;oSfDAodA4<_mL>R;om<54onbYM_o:
Sc;om>?:ofeU8_nOC03oQbX0oiN70?oBC03ok:T0ok6a^Oo:MP3obXlbol6a
Woo1^IOo^KV?olZaZOmUE3;oQbX0om:76OnaKAWo/Fd0oiN70?n?MVGoSc9<
oim<0?n7C17oIAT0on?B`OoBb/7oC288oc8Z8_m44@3od/[1ol6aWooBb/7o
ID`Iob8R4OmL>R;oC288obXR6Om4:R;oG3XR0_l000002_lA4A7o0000oaTI
4Om<A2;oIC88od@A0?lI6A7oC288od@A0?lR8Q42obXA2003obXR6OlZ4@So
000000?o000001co6ATAobXA2?l0003o:Q48ofDb2?n?IA7om?C/od@A0?ni
UeCo0000ob8R4Om<8PSoA140ojVYSooBb/7o/KVYogInG?m]QgkoIFDjoeaL
C?mUIC[o/KVYoinOSomnOVgoA4@ZoeaLC?lA4A7oC4a40_ljE5`01oljA4co
<SY4o`000?lZ4@So0000oa4A4Ol000000olA4A400ol0003oIE`ZoaTI6@03
oa4A4@03oaTR<_lA4A7o4A4A00;o4A4A00?o6B8Zoa4A4OlI8S800_lA4A40
0olI6A7o4A4Aoa4A4@04oa4A4@0IoaTR8_lR>Uco>UafocYDG?ljE8Oo>UAL
odaDKOljE5co<TAfodaDKOlbA7KoC5A]ob9<E?ljE5co8TaDocYDG?m<E6go
0000oa4A4OlI8R;o6B8bob8jG?lR<TCo8RXZob8jG002ocYDG003oa4A4OlI
6AWo6ATI00;o4A4A01Go0000oa4A4Ol0003o0000oa4A4Ol0003o4A4Aob8R
4OljA1Wo>T@boaTI4OljA1Wo4A4Aoda48_lR8Q7o:Q48oa4A4Ol0003o4A4A
obXA2?l000000_lA4A402?l0003o6B8RocYDQoljIIOo8RXZo`000?mLKHOo
6B8R1_lA4A400olZ4@SoA2XRo`000003oa4A4@07obXA2?l0003o4A4Ao`00
0?m4:R;oC4a4oaTI4@02oa4A4@08obXA2?lI6A7o6B8bo`000?lI8R;oC5A]
ocYDG?ljG7H2ocYDG00BoeA]M_l0003o8R8Aob8R4OlA4A7o8T@jodanSolI
8R;o4A4AoaTI6Ol0003o6ATAofDI0?nOWgko:Q48ob8R4OlI6A7o<RXR0olZ
4@P2oaTI4@;o4A4A00SoQiNYoiN?M_n?SfGoWin?ok6a^Oni/Ioob/6YofEL
:P;o4A4A00Oo0000ooooooodk=_oSgHZobXA2?lR8Q7o000000;obXlb00?o
6ATIo`000?lb:R800_m<8PP04?lI>WKod/[1on?BWooSZHooQfDbol6aWona
QfGoIE`Iooooooodk=_ok>cSooCdk?o/k>?om?C/ooclm?oB/Hl2ohMD:P03
ooCSb_odm?Com?C/00?om?C/00?om?Cdon?B/Oni^IL01?odm?@01Oo/o?Co
ooooohmU4Om4:R;oC4@R0:Cooooo001Jonk^kPCo4A4A00?o:Q48o`000?lZ
4@P00_lR>U`03?lIA8OoC5A]oa4A4Ol0003oG6f7oc94M_ljE8OoOYniogJG
/On7UjWod/ZYolZaZ@;o^KVY01Ko`KVGolZaZOo1^IOo`K6Ool6iUoni^IOo
b/6Ool6iUonOWgko>T@IofeU8_n?IA7ohiljofED<_niWgkohimDoooB2?mn
KDcoIE`Iohmf:_n7E2[ok:Uf0_o1KD@03?naK@3ok;U]ok5]0?lZ4@So^D`0
oim<0?na003ohil0okWBfonOC03obXlbol6a^@;o`KVG01go^KVYok5]6Oo/
k>?odXl0ooC1A?nOC03o:Q48oimnC?oBS`3oIAT0olZ?<_oKMPSoWiN7okVG
KOn74@3oA2XRohM<4OoK`Iood/ZYon?B/OlZ4@So<RXRofEL:_m<8PSo:Q48
ofE<6Om<A2;o0000oa4A4@03o`000005oe`j8_o:`IooC288ob8R4OmU6@00
1OlZ4@P00olR8Q7o4A4AobXA2002oa4A4@09o`000?lA4A7o4A4Aod@A0?n?
IA7oIC88ooclm?mU<PSo^IMD00;o8R8A01;oA2XRod`R2?o:/JWob/6Yom;:
`OljA1WoUhmfoinOSon?UhooC4@Ronk^k_nOZJWoOWi]ogi]IOm]KECoG5a<
ocYDG?mLG4`2ocYDG004odA4C?l0003o0000o`0000;o4A4A0_l000000olA
4A7o8S94o`000002oaTI6@;o4A4A00?o6B8boa4A4OlI6AT00_lA4A400olI
8S;o6B8Zoa4A4@02oa4A4@03o`000?lA4A7o4A4A00;o4A4A00_o0000oa4A
4Olb:R;o:Q48oc8jA?m<E6go>UALoaUDO_m<E6go>UALob9<E002ocYDG009
oc94M_ljE5co8TaDocYDG?lbA7Ko>UALob8bA?lI8S;o6ATI00;o6B9<00?o
6CYfoc94M_ljE5`00_ljE5`01_l0003o4A4Ao`000?lA4A7o6ATIo`0000;o
4A4A00?o0000oa4A4Ol000000_lA4A401olI6A7o>T@Iob8R4OlA4A7o:Q48
o`000?m<8PP00_lZ4@P05olA4A7o0000obXA2?lI6A7o0000obXA2?m<8PSo
:R8IoaU4QolIE7ko:R8Io`000?ljE5co6E@bob8R4OlI6A7o6E@bob8R4Ol0
003o4A4Aob8R4OlI6AWo4A4A00?o000000So6ATAobXA2?lZ4@So4A4AohM<
A?mLG4co4A4AoaTI6@;o:Q4800Co:R8Iob94>_lR>S;o6ATI0_ljE5`01?lj
A4co8TaDob94>_lb>T@2o`00000Boa4A4OlI8R;oC4`joeAfUon?Uhoo8TaD
oaUDO_m44@3o/Fd0oim<0?n?IA7o:Q48oaTI6OlA4A7oA4@ZoaTI4OlZ4@So
6ATA0_lA4A401_l0003oA4A<ol[1ZOoSd[7ok^k^ol[1Z@;o^KVY00oo^K6O
okViSon7C17oSgHjodA4<_ooooooG7jGofDb2?lA4A7o6ATIo`000?nOKDco
hm:Oo`000?lA4A400_lR8Q402om<8PSo8SYLol6iWoodm>cohm_Kofe]E?ol
o?Com>?:oc8Z8_oooooom?Cd00;ok>cS0oodm>`3ooclm003ooCdm?odm>co
m?C/00?om?C/00Oom?CdoncK`OniWgkoo?cdon?/m?odk=_od[6?00;ooooo
00?oWgi<ofDb2?m<8PP0Y?o^k^h005[oi^KV0_lA4A400olZ4@So4A4Aoa4A
4@02obXA200>obXR6OmLOYOo>UB7odafO_mDMYOoG7jGofF7ZOm<KHOoKGj?
off?Uon7UjWoQinaolZaZOo1/Il2ol6iW`05ol6aWoo:`Ioo`K6Ool[1Woni
^JT00ooBbZT0<ooSd[7o>T@IocXj8_n7:P3o`Fe4ocY46OnOWgkod[6?oncK
/Oo:/JWo^KVGok67IOnaKAWoQbX0ooCSb_oSZHoo^IM]od@A0?oSW`3o:R8I
ofDI0?mU<PSo/AT0om]f2?mUC1WofhL8om^?<_ni^IOo`KVGokViUoo1/Hoo
fgH8om^aWoo1KDCoQd`Aod@A0?n?A03o/HlIoooB2?oSW`3ok:Ufom:76Oo:
MP3om?C/ohLZ0?lA4A7oWhM]on?B/OoBbZWoQgiDod@A0002od@Z8P03ob8R
4Om<8PSo:Q4800;o00001?lA4A401_mUC1WoG3XRo`000?lZ4@SoC288ob8R
4@?o:Q4800?o:R8Iod@A0?l000000_lA4A405olZ4@So6ATAobXA2?lR8Q7o
:Q48ohmU4Ol0003ob/6OoimnC?niUeCo:Q48obXR6Om4:R;oG3XRokViZOna
/KWoSlZGoiN?M_mfOUcoKFeDoff7O_mUIC[oG5a<00;oWjVY00[oMWiLofef
M_m]OXooKFeDoea]M_ljA4co>UALocY4C?l0003o4A4A0_l00002oa4A4@08
o`000?lZ4@So8S94oa4A4Olb:R;o:Q48oa4A4OlI8RX2oaTR8P03o`000?lI
6AWo6B8R00;o4A4A00Go6B8ZoaTR8_lA4A7o4A4AoaTI6@02oa4A4@0<o`00
0?lA4A7o0000oa4A4OlRA3[o:Q48ocYLM_m<E6go>UafocYDG?m<E6go8TaD
1?ljE5`02olbA7Ko8TaDocYDG?m<E6go8TaDoaTR8_lI6A7o6B8Zob8jG?lb
A7Ko6DAn00;o8TaD00Oo8T@joaTR8_lR:R[o8S94oc94M_lR>Uco000000?o
4A4A0_l000006olZ4@So0000ob8R4OlR8Q7o>T@Ioda48_lR<R[o:Q48od`R
2?mUG1WoC288o`000?lA4A7o:Q48oaTI4OlZ4@So<RXRob8R4OlA4A7o6ATA
oaTI6OljE8OoA4@bo`000?lA4A7o6ATAob8R4@02oa4A4@0Ao`000?lI6A7o
6B8Zob8j<_lI8R[o8SXbob9<E?ljE5co0000obXA2?lR8Q7o<RXRob8R4Ol0
003o4A4AoaTI4OlZ4@P00_lR8Q402omDSk7oC7Inoa4A4OlR>S;oA4A<ob8j
<_lb>TCo8TaDocYDG?lR>S;o000000;o4A4A00goWiN7ocYLM_o:/JWo4HNG
oaUUO_m44@3odXl0okV70?oBS`3ohilRofDb2?n7E2[o>T@I00;o:Q4800Oo
4A4Ao`000?l0003oIE`Zo`000?oBb/7ohm;100?od/ZY00So^KVYol[1ZOo:
`JWofk6OonbYM_nGOUCoo?cdofF7Z@;oIC88017oC288ohm44OnYMS;o^GiD
ofDI0?n?A17o6ATAobXR6Om<8PSo8S94ohnGSooooooohncdogifIOo/hl[o
o?cdoc8Z8P02oncSbP04ooooooodm>com?C/onc/h`;om?C/0_odm?@3oocl
m006ooooooodm>com?CdooCdm?odhl[oWimn0_odm?@01oodm>cok=^aooCd
m?oooooo`KV7od`R2?ljA1T0Y?oVi^H005[ok^k^00[o6ATAobXA2?lI6A7o
6ATAob8R4OlZ8QWo8R8Ao`000?lb:R;oE7JG0_ljE8L00omLQiOo<TAfoean
U`02ofF7Z@09ohNGZOnOZJWod/ZYol6aWoo:`Ioob[6Yol[1ZOoBbZWo`KVO
00;ob/6O00Wod/ZYol6iUon7OUCoQgiDok6?6OmUIC[o^IM]onk^k_lZ4@P0
0_n7IC805Ooooooofk6Yon?B/Oodk=_oKFDRon>O0?n?IA7ok;U]ohmU4OmL
>R;ohl54ofEL6OlZ4@So/AT0okV70?oddWko/K6iom^72?oSWc[o`K6Ool6i
U`02olZaZ@06om:76Oo:^Hoofk6Ook5]0?oSWeCok:T00_m<8PP03_nOC03o
k;U]om^?<_niUeCoQfDbo`000?lR8Q7oWhM]om;:ZOo:`JWoIE`Ioc8Z8_m<
8PSo8R8A0_lZ4@P00olA4A7o0000oa4A4@04o`000006oe`j8_lb:R;o:Q48
ob8R4OlI6AWo6ATA0_m<8PP00om4:R;o>UB7oc94MP02oa4A4@04obXA2?l0
003o:Q48oa4A4@;o000001;o4A4Ao`000?niOTco^KVYohM<4Olj>S;o<SY4
ofDI0?nOQfgo/K6ioiN?M_m<A2;oUhn7ofEL:_n7OXooIFDjohn7KOnOWhl2
ofe]E009od@j8_mUE3;oQgj?ofefM_mLKGKoG5a<ocYLM_lRC5Co000000?o
4A4A00?o0000oa4A4OlA4A400olA4A401?lI8R;o4A4Aoa4A4OlI8R83oaTI
6@?o4A4A00?o:Q48o`000?lI6A400olA4A402_lI8R[o6ATIoaTR<_lR<TCo
6B8bob8jG?lIE7ko:Q48oc8jA?ljE5`2oc8jA0?o>UAL00Wo>UafocYDG?lj
G7Ko8TaDoc94M_lRA3[o8SYLob8bA?lI8T`00_lA4A403_lR>Uco<TAfoaTR
<_lA4A7o>TA<ob8jG?lZ4@So0000obXA2?lA4A7o6B8Zoa4A4OlI8R[o0000
0olA4A404_l0003oC288oaTI4OljA1WoC4@RocY46OlR8Q7o0000obXA2?m<
8PSoIE`Ioa4A4Ol0003o4A4AobXA2?lR8Q7oA140obXR6@;oC28800_o<SY4
ocYUUoljIHOo>T@Ioa4A4OlR8Q7o:Q48ob8R4OlA4A7o8R8AodA4:P02ob8j
G009ocYDG?lI8Tco8S94ob8bA?lb:R;o8R8Aod`R2?lR8Q7o:Q4800;o4A4A
00So6ATAobXA2?lZ4@So6ATAodaDKOljA4co6ATAocY4C0Ko>UAL03_oE6ef
oaTR:_l0003od/[1ob94>_o:`JWo4HNGoaUDO_nGQ`3ok:T0om:?0?naSaWo
ZL[BonbY0?naK@3o0000ob8R4Om<8PSo8R8AobXA2?niOUCob/6Yo`000?o:
/JWok>cSon?B`OoSd[7ob/6Ool6iUooSd[7od/[1on?B/Oo/`HOofhMUooCd
k?n?WkWo`Fe4oinOO_n?SfGoKFDRohmfA?nifoCok:Ufon>YSol0003o8R8A
oc8Z8_l0003oShM]oooooooSfm_oOXn?ol6a^OooooooG5a<oin?KOl0003o
Uhmfooooo`02ooclm00>ooooooolo?Coo?cdonc/hoo/hl[od/[1ok6iZOnO
UhOoo?cdooC/foo/k>?om>cKok67IOodm>`4ooCdm004oooooooK/IooC288
od`R2:Cok^k^001Jooooo`0JoaTI4OlR8Q7o6ATAobXA2?lI8R;o0000obXA
2?lbA7Ko>UB7oeAfUoljG7Ko<TAfoaTRC?lbA7KoOYniofF7ZOm]SiOoQina
ok6a^Oo1/Ioob[6Yol6aWoo:/JWo`K6Ool[1Woo:`JT2olZaZ@0CoinGQolZ
4@So>T@Iod@A0?o/`HOoC288okVGE?oSWeCoWhm]on?B/Oo:`JWok;U]ol[1
Wooooooofl6OolZ?<_n?MR[oQfDbooCBOP02ok5]6@0JobXA2?n7:P3oA140
om]f2?n7:P3o^IMDooCBO_oKMPSok:U<ol6iUoo1/Ioo/HMUom;:`OnYMS;o
OUa<okVGE?od`DCok;U]on?1A?mU6@3o8R8Aohmf:_oB/HooC288oc8Z8_lR
8Q42okU<0007ok67IOmnKDcoSfDAo`000?m<8PSoA2XRobXA2002oa4A4@?o
000000Co4A4Ao`000?lA4A7o4A4A0_l000002_lZ4@So6B8RobXA2?lA4A7o
A4A<oc94M_m<KHOo>VF7ocYDQolI6AT4oa4A4@;o:Q4801oo4A4AobXA2?lZ
4@So0000ogi]C?lR8Q7o<SY4ocYDQom]MWKoUhn7oooooom]KECo/KVGohnG
SomUIC[oWin?ok6iZOn?UhooWimnol6a^OmLKGKoKFeDoeA]M_mnOVgoG6ef
ofEL:_mLKGKoG5a<ob94>_l0003o4A4A00?o00000olA4A401ol0003o8RXZ
oc8Z8_lI6AWo>UALoc8jA?lI8R800_lA4A401OlR<TCo>VFGoaTjM_lI>WKo
8RXZ00;o6ATA0olA4A408_lI>WKo6DAnoaUDO_lIA8Oo6EAnob9<E?lA4A7o
8R8Aob8jG?m<E6goC6fGob8j<_lRA3[o8SXbob94>_lR>S;o8T@joc8jA?lR
A3[o>TA<ob9<E?lA4A7o8S94o`000?lI8R;o6DAnoaTjM_lR<TCo0000oc8j
A?ljA4co0000obXA2?l00002obXA2003oa4A4OlR>Uco000000;o4A4A00Co
0000oa4A4OlZ4@So>T@I0_lZ4@P2ocY46@0>o`000?lA4A7o:Q48obXA2?lA
4A7o0000oa4A4OlR<TCo6ATIoa4A4OlR8Q7oG5a<oeAfUom<O[42ocYUQ`0C
ob9<E?m4>R;o>T@Io`000?lZ4@So>SXRoaUD<_lR<TCo>UALodaDKOlRC5Co
>Uafoa4A4OlR:R[o>UALofDb2?m4:R;oC288o`000002oa4A4@08obXR6OlI
6A7o4A4AoaTR<_lZ4@SoC4a4o`000?lRA3X2ocYDG00<ocY4C?ljE5co>UAL
ocY4C?m<KHOo6ATAo`000?n7b[7o8TaDoeA]M_l0003o8SYL0_n?A0001ona
K@3ohl54onc1<_oK`@SoUhL0o`000?lR8Q400_lZ4@P01_mLKGKok>cSon?/
m?l0003o/KVGooclm0?ok>?:00Cok=_1ooC/foo/hl[ok>cS0_ooool00oo/
k>?o/K6io`000003o`00000Noda<>_nG^L[ohjV?onbYM_l0003o6ATAoeaL
C?oB/Hood/ZYooclm?o/k>?oSiN?ojVYSoooooooOVEDob8Z:_lI8R;o0000
om;:`Oni^JWoZJV?ohn?IOmUIC[oID`Iod`R2?m44@3o<RXRod`R2?ljA1Wo
oooo0_o/k><00oolo?Co^ImnoncSbP02ooCdm0;oo?cd00CoooooooCSb_m<
8PSo>T@IY?ooool005[ok^k^00Ko:Q48o`000?lZ4@So8R8Aoc8Z8_lbA7H2
ocYUU`06oda]UolI>WKo<SY4ob8jG?ljE8OoIHNY0_mfUk402om]Sk7oWjVY
ol6iWoo1/Ioo^K6OokViUoni^Hoo/KVGok6aSoniWgkod/ZY00;ob/6Y02Wo
KFDRocY46Ol0003om>?:ofE<6OnOUhOom=9nobXA2?n?MTCob[6YonbYM_n?
MR[ohm;1ol6iQooSdYooIAT0olYf0?o/k>?ofk6YojUf<_mU6@3o/Fd0om;:
`OnaKAWoWd`0okV70?oBbZWo/Fd0olZ?<_nOQfgoUgiDom^7IOoB/HoodXl0
ok5]6OmnKFGoQd`AofDb2?n7:P3oMWiLofEU>P02ofe]E00:oio1/On7E2[o
SgI4om:?0?naKAWoSgHjokViUona/Hoo4A4AobXA20;o8R8A0_l00002oa4A
4@03o`000?lA4A7o000000;o000000WoA140obXA2?lR8Q7o8RXZobXA2?lR
8Q7oKGj?oda]QoljE8L00_ljG7H01olR>Uco4A4AobXA2?lA4A7o:Q48oa4A
4OlI6A400_lA4A40;?l0003o6ATIoaTI6OlZ8QWo>UALocYDQomLKHOoSini
on?B`Om]KECo>T@IocXj8_mnShooMWiLok6a^Oni^JWoSiN?okViZOn?Uhoo
>T@Iofe]E?m]QgkoWin?ogj?SomnOVgoQgj?oda<A?l0003o:Q48oaTRC?lR
:R[o6B9<o`000?lR:R[o6B8Ro`000?lR>S;o>SXboaTI4OmDMYOoC6fGo`00
0?lA4A7o6ATA0_ljE8L01OljIIOo>UB7oaUDO_lR:R[o000000;o4A4A00?o
:Q48oaTR8_lIE7h00_lI>WH03?lIA7ko8SYLoaTRC?lIA7koC6f7odanUolI
E7ko6B9<odaDKOljE5coC5A]ocYLMP;o>UAL00Go>Uafob9<E?l0003o:R8I
ob8bA002oaTR<P04oc94M_lR>Uco>UB7oeaLC0;o000000SoC288obXR6Olb
:R;oC288ob8R4OlbA7Ko8S94oaTI6@;o4A4A00?o0000oa4A4OlZ4@P00_lj
A1T04?l0003o8R8AofEL:_l0003o4A4Ao`000?lZ4@So4A4Ao`000?lZ4@So
A2XRofefM_m4A3;oMYO1ofFG/OlIA7h2ocYUQ`09odanSolA4A7o8T@jodan
SolZ4@So6ATAodanSolI8Tco8R8A00?o8TaD00Oo8SYLoaTI6OlR:R[o6E@b
o`000?lA4A7o000000?o4A4A0_lI6A405olR>Uco4A4Aoc8Z8_lZ4@So6ATA
ob8b:_lb>TCo>TA<oda<A?m4A4co>UALob8j<_m<MWko>T@boaTR:_nid]_o
MWiLoiNib_lIMWKo0000oa4A4OmU6@3obWH000;oo<4000oodXl0ohmU4Ol0
003o:Q48ob8R4Om44@3o>UB7on?B/Oodm?Co4A4AoiN?M_olo?Com>cKon?K
foodk=/00_oSfm/07?o/hl[om?Cdonk^k_nid]_ob/6Yonc/homU6@3o8R8A
oaTR<_lR>Uco6B8ZojW:d_oK`IoohiljoaTRC?lbIJWoKGj?okVaWon?SfGo
m?Cdoin?KOm]IB;o^IMDok6iWom]KECo6ATIob8R4OlI6A43o`000009oc8Z
8_lZ4@SoC288oc8Z8_m4:R;o<RXRocY46OlZ4@Sooooo00;om?C/00Woo?cd
ol6iQoo/hl[oo?cdoooooomnKDcok^k^ooooooo/hlX00_m<8PRTonk^kP00
F_oVi^H01olI8S;o8S94ocY4C?ljE8Oo<VFYoda]UoljE8L00_lR>U`02olI
8S;o>UB7oeAfUom]Sk7oQinaogJG/OmUQjWoG7jGok6a^OnGSgKoWimn00;o
/KVG03oo^K6Ool6aWoo1/Ioob[6Yom_1Woo:`IooWimnokVGKOn?A03ohl54
ok67IOn7E2[oUgiDooCBO_lZ4@So^ImnoiN?M_o/^FgohjV?on?Kfoo/^Fgo
fl48ofDI0?niC03ok=^aooclm?nOWgkom>?:olXR0?oK/IoofgH8om^?<_o:
Sc;oo<40ok5]6OnOC03ohm;1om^OKOo:/JWofl6Oom]f2?o/`C;odXLIon>O
>_o/ZDcom<54ocY46OlIMTCo0000oaUfA?nY`L[ofgi<ol5]A?o:MR;obWH0
on>O8_oKMPSo:Q48oa4A4OlR8Q7oC288ob8R4OlI6A400_l000001olI6A7o
0000oa4A4OlA4A7o:Q48ob8R4OlI6A400_lZ4@P02olI8S;o6ATAo`000?lj
E8OoG7InocYDQom<E6go>UB7oc94M_l0003o:Q4800Co4A4A0_lZ4@P08OlI
6A7o:Q48ob8bA?ljA4coC5A]oda]QomUQjWoSiN?on?B`OnOWhoohm:aob8R
4Om<C3[oG5a<oda<A?nGShOo/KVOok6iZOo:`JWoKHMnoda<>_m4>R[oG3XR
ofEU>_mLG4cod/[1ogInG?l0003o<SY4ocYDQolbA7Ko>VFGob8jG002ob8b
A00Fo`000?lA4A7o8RXZo`000?mLOYOo>Uafoa4A4OlI6AWo0000ocYUUolj
E8Oo8TaDocYDQolI8Tco6B8boc8jA?l0003o6ATAob8R4OlA4A7o8SYLoaU4
OP;o6CYf00?o6B8boaU4O_lIIGh00_ljIHL07OlI>WKo>UALocYLM_ljG7Ko
>UALocYLM_ljE5co<TAfocYLM_lI8R;o:R8IoaTI6OlR>Uco6B9<ob8bA?lb
A7KoE7JGoaU4O_lR>Uco<SY4o`000?mLG4co8S94ocYLM_ljA4coC6f7ocYD
QolRC5Co>UAL00;o00000_lA4A400olI6A7oIE`Io`000002obXA2014obXR
6Ol0003o4A4Aoa4A4OlZ4@So0000oa4A4OlI6A7o0000odA4C?lZ4@SoC5A]
o`000?ljIIOoC7JGofF7ZOljE5co<SY4ocY4C?lI6AWo:Q48od@A0?ljA4co
8S8ZoaTI6OlI6A7o4A4AoaTI4OlA4A7o6ATIo`000?mUE3;o6ATAo`000?lA
4A7o0000obXA2?lA4A7o6ATAobXA2?lR>Uco4A4AobXA2?m4A3;o4A4AocXj
<_ljE5co>TA<ob9<E?ljE5coG5a<oeA]M_n?UhooG6f7oaUDO_mLQhooUhmf
okWBfom<MWkoZL[Bob94>_l0003o/Fd0onbY0?niUfgofgi<oe`j8_l00002
obXA2008o`000?lRIJWob/6Ooooooolb>TCoIFDjooclm?odk=/2onc/h`?o
m>cK00goo?cdol[KfooSk?Co^KVYooC/foo/hl[o`K6ioaU4Qom<E6goC4`j
ofEU>_n7E2[oIE@b00;oSgHj00WoIFDjocXj8_lI6A7oC288ob8R4OlA4A7o
0000ob8R4Olb:R801OlA4A401olI6A7o<RXRoc8Z8_lb:R;oC288oc8Z8_lj
A1T00_lb:R803_olo?Com?C/onc/hoodm>co`KVGom;:`Oolo?Com?C/o`00
0?lZ4@SoKFeDofEL:_m4:R;o>T@IY?oVi^H005[ok^k^01Ko<TAfocYDQolj
E8Oo>UB7oc94M_lR>Uco6B8bob8bA?lbA7KoIHNYoff?^OmfUk7oKHnaoeB7
/OljIHOo<TAfohna`OnGSgKoZJV?ol[1WooBbZWofl6O1?oBbZT09?o:`JWo
`KVGokViSoodk=_ohimDonbYM_oBS`3oUhL0ohmU4Oo/fk7oIC88ok6iUona
/Hoohiljom^OKOodm?Cod[6?om^7IOo/fl7o/Fd0oncK/Oo/fl7o^D`0on?K
foo:MP3oQd`AoncK/Oo/ZDco/L[:ohmf:_oK`Iook:UfoinOO_mUIC[o^Imn
om;:Z@;ofhlb00GofhL8on>O8_ol`@3oSfDAoaTI4@03oaUfA00?oio1/Oo/
ZDcobXlbon>OE?o:MR;obWH0ohM<4OlI6A7o8R8AobXA2?m<8PSo<RXRobXA
2?l0003o4A4A00?o0000017o4A4Ao`000?n7:P3oQbX0o`000?lR8Q7o<RXR
oaTI4OljA4coG6f7odaDKOm<KHOo>UafocYDQoljE5co6ATIobXA2003oa4A
4@07o`000?lA4A7o0000ob8R4OlR:R[o>UALoc94MP02oda]Q`0Moff?UomL
KGKohm;1oinYZOmLG4coIE`ZofED<_mUG2[oWhM]od`R2?mUIC[oOWi]oinY
ZOmnG4co`Fe4ohmf>_mUC1Wo>SXboc8Z8_n?Qfgo0000obXA2?lI6AWo<TAf
oaTRC?lR>Uco6B8boaTRC?lbA7H00_l00002oaTI6@;o:R8I01?o4A4Ao`00
0?lA4A7o>UB7oc94M_ljIHOo6CYfob8bA?ljE8OoE8naob8bA?lI8R;o6B9<
od@A0?lI8Tco8SYLoaU4O_lIE7ko6CYf00;o6EAn00Oo8TaDocYLM_lI>WKo
>UafodaDKOljE5co>Uaf00Go>UAL01?o>UafoaTI6OlR<TCo4A4Aob8jG?lI
8Tco6DAnoc94M_lI8Tco8SYLoc94M_ljE5coA4A<ocYDQom<E6go8SYLocYD
QolbA7Ko6B9<00Co4A4A00[o6ATIoa4A4OlZ4@So:Q48o`000?lR8Q7o:Q48
o`000?lA4A7o:Q480_lA4A404?l0003o6ATAo`000?m44@3oA2XRobXA2?lZ
8QWo>Uafob8j<_lR<TCo8T@job9<E?l0003o:Q48oaTI4Olb:R82oa4A4@08
oaTI4OlA4A7oA4@bob8b:_n?SfGoOVe<odA4:_l00005oa4A4@0@oaTI4Ol0
003o>UALofefM_n?UhooWin?odA4:_lj>R;o8S8Zod@j:_mUIC[oOWIUoiN?
M_nOWgkod/ZYokViZ@;oQiNY00_oSiN?oncSb_lI>WKo8T@jo`000?lA4A7o
0000ohna`Oo1/KWohiljohm40002o`000007obXA2?l0003od/[1okVOO_oo
ooooG6efofE<6@07ooclm00;oooooomnOVgo>TA<ohn?IOo:`JWo:Q48oc8Z
8_ljA1WoA4@ZoaTR8_lA4A401ol000001_lR8Q7o6ATAobXA2?l0003o:R8I
oaTI4@?o4A4A00So0000oa4A4Ol0003o:R8Ioc8Z8_lR8Q7o:R8Ioc8Z8P;o
A2XR00?o8R8Aooooooolo?@00_ooool02_oBb/7o^K6OooCdk?odhl[o0000
oa4A4Olj>R;oIE`Zod@Z8_m<8PRTonk^kP00F_ooool2oc94MP07oaU4QolR
>Uco6B8RobXR6OljE8OoIHNYogJG/@03oeAfU`06ocYUUoljG7Ko>Uafofen
SonY`L[oOWIU0_n?SfD00on?UhooWimnokViZ@02olZaZ@0jol[1WooK/JWo
hm:aok6aSooSd[7oWd`0ok5]6OoSWb;oQa40ohMU<_od`DCoIC88ok6aSooB
b/7oQa40olZ?<_oBb/7ohjV?om:aSoniUeCohiljon>YSonaK@3odXLIokVi
UoniC03oZGHbok5]6OnOC03oIAT0ohmU4Oo:Sc;ok:UfoiMnE?oBQaWok:Uf
ohn?IOoKQ`Sok:U<ojUf<_n?MR[oKFDRo`000?m<C3[o6E@boaUfA?m4Whoo
G6efonbYC?oKSc;ok;U]ok5]6OnOC03o0000oa4A4Om4:R;o8R8Aod`R20?o
:Q480_lA4A400ol0003o:Q48oa4A4@02o`0000?o:Q4800Ko>SXRocYDG?lZ
8QWoC5A]oea]Qom<KHL2ocYDQ`06ob8jG?lR>S;o4A4Ao`000?lZ4@So0000
0olZ4@P08Ol0003o6ATIocYDG?lbA7Ko>UB7oeanUomUQjWoSgIDom;:`Om]
KECo^ImnohMU<_m4>R;oA4@Zoda<A?mUG2[oG3XRohMD:_mUC1WohimDoncK
/OoSdYoofim]ojUf<_o:MP3o0000oim]C?l0003o6ATIob8jG?lb>TCo8SYL
ob8Z:P02ob8jG004oa4A4Ol0003o:R8IobXA20;o000000Go:Q48ob8bA?lR
:R[o<TAfocYUU`02ocYDQ`;o>VFG00ko<WJao`000?lI6A7o6EAnoaTR<_lI
6A7o8S94oaU4QolIIGko6FfaoaUUO_lI>WKoE7JGocYUQ`;o6CYf01ko>UAL
ocYLM_m<E6go>UafocYDG?ljG7Ko>UALodaDKOljE5co8SYLoc94M_lI8S;o
>VFGoaTR<_ljIIOo6CYfob8jG?mLOYOo>UB7oeb7SolR:R[oA4A<oc8Z8_lR
<TCo8SYLoeb7UolRA3[o6ATIoa4A4OlI6AT2oa4A4@06oaTI6OmL>R;o6ATA
ob8R4OmL>R;o00000_lA4A42obXA2005o`000?lA4A7o8R8Aoa4A4OlI6A40
0olZ4@P00oljA3;o8T@joc8jA002oc8jA00>oaTR:_l0003o:Q48ocY4C?l0
003o6ATAob8R4Om44@3oQgiDo`000?oSfm_ohm:ao`000?lA4A42o`0000?o
4A4A01Ko6ATAo`000?mnOVgo/KVOolZaZOoBb/7oUhmfogi]C?n?SfGoWimn
okViUoni/Ioob/6Ool6a^OoSd[7ooooook7:b_mDKGKoIFDjooCdk?l0003o
4A4A0ol000005On7UjWoUkW:om^OKOoSWc[o6CYfoaUDO_lAE:Wom>?:on?K
foniUfgoooooob8b:_lZ4@Sok>?:oooooooBbZWo^KVYoiN?Qon?SfGoKFeD
oe`j8P02oaTI4@03o`000?lI6A7o000000Co000000?o:Q48oa4A4OlI6A40
0_lZ4@P2oa4A4@03obXA2?lI6A7o8R8A00;o4A4A00?o8R8Ao`000?lI6A40
1olA4A403olI6AWo8R8AobXR6OlI6A7o6ATIo`000?o:`JWo^Imnoin?KOni
UeCoSgI4okVOO_o1^IOo`K6?oin7K@02oiN?Q`03ofefM_mU<PSo>T@I0:Co
oooo001Jonk^kP;o8SYL02ko6ATAobXR6OljE8OoC6fGoeB7/OmDMYOo>VFG
oda]UomDMYOoC7jGocYDQolbA7KoQgj?ohna`On7UjWo4A4AoaTI4OlR:R[o
Qda4ogiUE?nGSgKo^KVGol6iUoo1^HOo/K6?ol6iUomUC1WoIAT0oe`j8_mU
6@3ok>cSoncK/Oo:`JWohiljofDI0?niOUCod/[1ohmfA?niC03ofk6OooCd
k?n?A03ohiljon>YSooK/Ioohm_K0_oKWfd05?oBQaWohiljon?BWona003o
Wd`0om9<0?od`DCok:U<on>OE?o:Sc;ok<67ohm]C?oKQ`Sok;U]onbYC?n7
b[7o0000oaUD<_l0003o4A4A0_lI6AT03On?A17ok:U<om]nC?oSWeCo/Fd0
oim<0?lA4A7o6ATAofEL:_lZ4@SoA140ocY46OlR8Q400_l000001OlA4A7o
0000o`000?lA4A7o:Q4800;o4A4A0olZ4@P02_mLKGKoA4A<oea]M_mLKHOo
E7JGoda]Qom<MWko>UB7ob8j<_lZ4@P2oa4A4@0AobXA2?lI6A7o0000oa4A
4OlZ4@So:R8IocYLM_m<MWkoC6f7oeanUon7UjWoSgIUokUnC?o:Sc;o^Gi<
o`000?lA4A400_l000004_lI6A7oSd@AoncK/On7:P3oSfDAod@j8_n74@3o
k;U]on>OE?o/fk7o^ImnoooooolA4A7oA2XRoc94M_m<E6go8SYLoaTR<P;o
8SYL00co0000oa4A4OlI6AWo:Q48ocXj<_lb>TCo>UALob8bA?lI8S;oC5A]
ocYUUom<OYL2ocYUU`0Dodan/OlZ4@So4A4Aoa4A4OlI8S;o6FfaobXR6OlR
8Q7o6B8boaUDO_lIMWKoC5A]oaU4QolIIGko>VFGoaTjM_lR>Uco>UafocYD
G?m<E6d2ocYLMP0FocYDG?lRC5Co8TaDob8bA?lRC5Co>UB7ob8bA?lR8Q7o
6ATAocYDQoljG7KoC7JGodafO_m4>R[oC7jGoaTI6OlZ4@So4A4AobXA2?mD
KGKo6B8Rob8bA0;o4A4A00Wo0000oa4A4OlI6AWo6ATIoaTI4OmUC1WoIFDj
oda48_lA4A400_l000000olR8Q7o:Q48o`000004oa4A4@04obXA2?lR8Q7o
6ATIoaTI6@;o<SY400?o8S94ob94>_lb>T@00oljE5`01Ol0003o:Q48ob8R
4Ol0003ok<6700Co00001OlA4A402olZ4@So6ATAo`000?nOUhOohm:aonk^
k_o/hl[ob/6OoiN?M_ni^IOod/ZY00;od/[101_ohm:aoncSb_o/fl7ohncd
onk^k_n?UhooID`Iooclm?o/fl7o`KV7oaU4QolAE:Wo6DB7ohnGSon7Wk7o
bXlbofDb2?lI8Tco6B8RoaTI4OlR8Q7o:Q48oc8Z8_nGSgKo4A4AoaTI6OlZ
4@P01?l000000olA4A7o0000oa4A4@07oa4A4@04o`000?lA4A7o4A4AoaTI
4@;o4A4A00[o6ATAo`000?lA4A7o4A4AoaTI4OlR8Q7o0000obXA2?lZ8QWo
00000olA4A403_l0003o4A4Aoa4A4OlA4A7o0000oaTI4OlR8Q7oIC88ofE<
6On7IC;oWgi<okVOO_o1^Ioo^KVY0_nOZJT01On7UjWoIHNYoff?Uom]SkWo
KHna00;oKHni0_m<8PRTonk^kP00F_oVi^H01_lR<TCo:Q48ob8jG?lbIJWo
E8NaodafU`;o>VF70_ljIIL0>?ljIHOo<TAfocYDG?ljE8OoWjVYojW1b_m<
MWko6ATAocXj8_m4>R[oA4@boe`j8_m4>R[o>T@Ioe`j8_mUG2[oWimnok6a
SoniWgkofk6YohLZ0?l0003o^ImnooCBO_oKWfgok:Ufohmf>_o/`HOoi^KV
on>OE?o/`HOohimDom;:`OoKMPSohimDoncK/OoKWfgobWHRom9<0?o/`HOo
bWH0onbYM_oBS`3obR80ojT80?na003obWH0on?1A?o/^Fgok:UfonbiKOmU
IC[ofgH8onc1Qoo/^FgoKFeD0_l000002?m44@3oQa40od`R2?l0003oQbX0
on>OE?oSWc[ok;U]0_nOC0001oniWgkoA2XRofE<6OmUG1WoC4@RobXA2?lI
6A401?lA4A401olZ4@So0000oa4A4Ol0003o:Q48o`000?lI6A400_lR8Q40
1?mUQjWoG7InofenSomLOYL2oda]Q`05ob8jG?lbA7Ko:Q48oa4A4Ol00000
1OlZ4@P07?l0003o<TAfocYDQomLOYOoQinaoeaLC?n7IC;oZGHbok67IOmU
E3;o0000oc8jA?lZ8QWo0000od@A0?niUeCo^IM]ofeU8_n7OUCoQa40onbi
KOnOSfgoOVe<ofeU8_n?Uhook?cdofEU>_n7OU@2oea]Q`0EocYDQolR:R[o
8S94oaTRC?l0003o4A4AobXA2?ljE5co>UB7ofF7ZOlA4A7o>UALob8bA?lR
>Uco6B8boaTR:_m<O[7oMYNaodanUol0003o6ATA00;o:Q4800?o8TaDoaTR
8_m4:R800_lI6A401Om4A4co>UafocYLM_m<OXoo6EAn00;o6DAn00So8T@j
ob8j<_lR>S;o8S8ZocY4<_lRA3[o<SY4ob94>P?o>UAL00GoG5a<o`000?lZ
4@SoE7JGoeA]MP03ocYDG009oda]QolR<R[oA140obXA2?m44@3oG6f7oa4A
4Olb>TCo000000Go4A4A00So0000oaTI4OlA4A7o4A4Ao`000?lA4A7o:Q48
o`0000;o4A4A00co0000oa4A4OlA4A7o4A4AobXA2?lI6A7o:Q48oc8Z8_lI
8Tco8T@joaTR8_lI6AT3ocYLMP03oeaLC?l0003o4A4A00;o000000SoQgiD
o`000?lA4A7o0000oa4A4Ol0003o4A4Ao`0000?o4A4A00Wo6ATAo`000?ni
^IOom>cKoncSb_o/k>?ok>?:ok6iUooSd[400oo/fl43oncSbP08ooCdk?n?
/L7oKHMnod@A0?ooooooUhmfol6aSonOQfd2okVGK@0:ofEU>_mUC1Wo6B8R
oa4A4OlZ4@So4A4Aob8R4Ol0003o4A4Ao`0000;o4A4A00Co0000oa4A4OlA
4A7o6ATA0_lR8Q402OlA4A7o6ATAobXA2?lI6A7o0000obXA2?lI6A7o4A4A
o`000004oa4A4@04o`000?lA4A7o4A4Aoa4A4@;o:Q480_lR8Q401?lR<R[o
8R8AoaTI6OlR8Q46oa4A4@04o`000?mUC1Wo^ImnoinOOP;oSiN?00CoQiNY
ohnO^OmfUk7oKHni0om]Sk402_mUQjWoMYNaofF7ZOmUQjWoMYNaofF7ZOm]
SkWoOYniod`R2?ljA1VTonKViP00F_o^k^h01?lI8S;o6B9<oeB7/OljE8L5
oc94MP0;ob8jG?lR<TCo8SYLocYDQomUQjWo/K6iojW:d_lI6AWo8SXbob8b
:_lb:R800_lR:RX04olj>R;o6ATAod`R2?niUfgobWHRod@A0?mU6@3oWgi<
ooCSb_o/k>?o^D`0ofDI0?naK@3oE8naogk1Uoo/fl7o^IM]on>YSoodk=/0
0_oK/Il09?oBQaWohimDon>OE?o/^Fgo/Fd0olXR0?o/`HOohimDonbiKOo:
MR;o/AT0olXR0?na6@3o/@00om]f2?oBQaWok:Ufom^OKOmfOUco/Fd0onbY
C?o/`HOoA140ohLZ0?niWgkoooooom]nC?na003oSd@AohLA0?o/`HOok^k^
on?KfonOWgkoIAT0oimnC0;oIE@b00SoIE`IofE<6Ol0003o8R8AobXA2?lI
6A7o4A4Ao`0000;o4A4A017o:Q48oa4A4OlA4A7o8R8AobXA2?l0003o6ATA
oiN70?mUQjWoKGj?oeA]M_m<KHOoG7jGocYDQoljA4co6ATIoa4A4@02obXA
2003o`000?lZ4@So:Q4800;o:Q480_m<KIL01on7UjWom>cKok5]6OniOTco
^GiDokUnC?n?MRX00_l000005OlA4A7o0000olYf8_o/fk7o^IM]o`000?ni
Ufgo`KVGokVOO_ni^JWoSgI4od`R2?mU<PSoA140ob94>_nOUhOoC4a4ohMn
Som]MWKoC6f7oeAfU`02oaTI6@08ob8R4Ol0003o>T@bob8jG?mUUk7o>Uaf
ob8bA?lR>U`2oc8jA006obXA2?ljE8OoC7jGob8R4OlZ8QWo6B8R0_lI6AT2
oa4A4@04odA4C?lZ4@So:Q48oaTR8P;o>UAL00Wo<TAfoaTjM_lIA8Oo6DAn
oaTR<_l0003o<SY4ocYLM_ljE5`00_ljG7H02OljIHOo<TAfocYDG?ljE5co
8T@jobXA2?l0003oA4A<ob9<E002ocYDG003ob9<E?m<KHOo>TA<00;o0000
00Go8R8AobXR6OlI8S;o6B9<o`00000:oa4A4@05o`000?lA4A7o0000oa4A
4Ol000000_lA4A402ol0003o4A4AobXR6Om4A3;o8R8AoaTR8_lR8Q7o6B8R
ob8Z:_lZ8QWo8TaD00?o>UAL0_lA4A402ol0003o4A4Ao`000?lA4A7o0000
oa4A4Ol0003o:Q48o`000?lA4A7o000000?o4A4A00So0000okViSoolo?Co
o?cdooCdm?odm>co^KVGooCSbP?om?C/0_olo?@02_odk=_oo?cdokVGE?ni
Wgko`KV7ok6iWomnKDcoC4`jodA4:_lA4A44o`0000Co4A4A00Go0000oa4A
4Ol0003o6ATAo`000003oaTI4@03obXA2?lA4A7o:Q4800;o6ATA00Go:Q48
oa4A4OlA4A7o4A4AoaTI4@03oa4A4@03obXA2?lA4A7o8R8A00;o6ATI1?lA
4A401ol0003o:Q48od@A0?mU<PSoQe@Zohm]C?l000001_lA4A401omfUl7o
KHnioff?^OmfUk7oKHnaogJG/OmUQjT00omfUk402?mnWkWoMYNaogJG/Omf
Uk7oMYO1off?/OmnWkWoKHni0_mfUl42od`R2:Cok^k^001Jooooo`09ob8Z
:_lR>Uco<SY4oaTRC?lb>TCo6B8boaTR8_lR:R[o6B9<00;o8SYL00So4A4A
oaTI6OljE5coC7InoeAnO_lR8Q7oA4@Zob8Z:P;o<RXR02?o<SY4oaTI6Om4
A3;oC288om:aSoo:/JWoSd@AokVOO_m44@3o^D`0oncK`Oo:MR;o^IM]on?K
fonab/[oMWiLohmfA?niUeCoQe@ZokVaWonaQfGob/6Yom]f<_o/ZGKohilR
olYf0?o:8P3o/AT0onc1Qoo/ZGKok<67om^OKOnY203o/AT0ojT80002ohLA
000LoiN70?o/`HOohimDod@A0?naK@3ok:U<onc1QonOC03o/AT0om^7IOna
KAWo/AT0on>YSoo:8P3o/@00ok4I0?o/ZGKofk6OohLZ0?m44@3o8R8Aoa4A
4OnGOUCoZGHbofEL6OlI6A7o4A4Aob8R4@?o:Q4800?o4A4AobXA2?l00000
0_lZ4@P00olR8Q7o>T@Ioda48P02oiN70003ofenSon7Wk7oKGj?00;oE7JG
00KoG8NGoda]QolZ8QWo0000obXA2?lI6A42oa4A4@0<o`000?lA4A7o0000
ocYDQomDMYOohm_Kon?/m?mUG1WodXLIom:aSoniUeCoZGHb0olA4A406Ol0
003ok:U<om^OKOn?A03o/FdIo`000?n?Qfgofim]om_1Woo/hl[oZJV?ok5]
6Om<8PSoQa40onbYM_nOKDcoSgIUoooooon7OXooA4A<obXA2?naKAWo:R8I
oa4A4Om4>RX00_lb>T@02omDKGKo8SYLocYLM_lR>S;o0000oc8Z8_lZ8QWo
6ATAoa4A4OlI6AWo6ATA00?o4A4A00co6ATAo`000?m4:R;o:Q48ob8bA?lR
C5Co>UafocY4C?lRC5Co6CYfob9<E?lRA3X2oaTR<P05odaDKOljG7Ko>UAL
ocYDG?m<E6d00oljE5`02?lI6A7o8R8AobXA2?lb>TCo>UafocYDG?lRC5Co
>TA<0_ljE5`01_lZ4@SoG3XRofED<_lZ8QWo8TaDoaTR:PSo4A4A00Co0000
oa4A4OlA4A7o00002?lA4A401_l0003o>UALoaTR8_lRA3[o6B8bob8j<P;o
8RXZ00Go<SY4ocY4C?lRC5CoC4`joa4A4@03o`000003oa4A4Ol0003o4A4A
00;o000000Co4A4Ao`000?lA4A7o00000olA4A401ol0003oIE@bok6a^OnO
WgkoUhmfofED<_mnKD`00_ni^JT01_nYZHooUhn7ogInG?mUE3;o6ATAob8R
4@Wo00000olA4A400ol0003o4A4Ao`000004oa4A4@04obXA2?lA4A7o4A4A
o`0000?o6ATA0olA4A400olI6A7o8R8Aoa4A4@02oaTI4@03oaTI6OlA4A7o
000000;o4A4A00go0000obXA2?m44@3oIC88ohMD:_n?MUCoUhmfojVYSonO
WhooWjVYohNO/OmnWkWoUkW:00Ko4A4A00?o0000ogJG`OmfUk401Om]SkT3
off?/@0:ofenSomUQjWoQiNYoff?Uon?UhooKGj?oea]M_m<E6goC4a4od@j
:P;o<RXRY?ooool005[ok^k^02oo8SYLoaTjM_lR:R[o8S94oaTRC?lR>Uco
<TAfoda]UomDMYOoC6fGoaTR:_lR>UcoOYniohnO^OnOZJWo6E@boaTI4OlR
:R[o<RXRoaTR<_lj>S;o<RXRoa4A4OmU<PSoA2XRohm44Om]Sk7oSd@0ooCS
b_o:MP3oID`Ioin?KOoBQaWofl6OokVGE?lAWiOoA9n?om]f2?o:MR;o/Fd0
o`000?lZ4@SoSd@0oncK/OoSWeCofgi<ohLA0002ojT8000Fon?BWoo/ZGKo
k;U]onbiKOn74@3o/AT0olYf8_oKQfGoWfe<ok5]6Oo/`HOok:U<od`R2?n7
4@3om>?:on?Kfoo1^IOoZ@P0om]nC?o:MR;o0000ojUf<P;o/@0000KodT`0
ooC/foolo?Co`KVGokU<0?oBC002od`R2007onbiKOm]IB;oID`IocY46OlZ
4@So8R8AoaTI4@02obXA2003o`000?lZ4@So6ATA00;o:Q4800Ko>T@IofEL
6OnGQ`3oSd@0ohmf>_n7OU@2ogJG/@05oda]QoljG7Ko>UB7obXR6OlZ4@P0
0_lA4A400ol0003o4A4AobXA2002obXA2017ob8R4OnOQfgom=9nofEU>_mU
6@3oSgHZonbYM_naSaWoQd`AohLZ0?l0003o4A4AobXA2?o1KDCoWd`0ohmU
4Om4>R;o0000ohLA0?o/ZGKo^Imnok6aSolA4A7o/FdIokUnC?n?A17ok:Uf
okVGE?n?A03o`K6iohm44OnOC03o4A4AokU<0?n74@3o6ATIob8b:_l0003o
<SY4o`000?lZ8QWo8SYLobXA2?lZ8QWoC288oc8Z8_l0003o6ATIobXR6Olj
>S;o4A4AoaTI4OlZ4@So0000ocXj<_lI6A7o0000ob8j<_lRC5CoC7Inob8j
<_ljA4co8SXbob9<E?lb>TCo0000oaTR:_ljG7Ko>UALocYLM_m<E6d01?lj
E5`01?lR<R[oC288oe`j8_lb>T@2ocY4C009ocYDG?ljA4coA4A<oeA]M_l0
003o8R8Ao`000?lI8R[o>UAL00;o4A4A00?o6ATIo`000?lZ4@P00olA4A40
1OlI6AWo4A4Aoa4A4OlA4A7o000000?o4A4A0_l000001OlI6AWo4A4Aoa4A
4Ol0003oG5a<00?o8RXZ00co8S8Zob8Z:_lR:R[o8RXZocXj<_m]KECo/K6?
ohn7E?l0003o4A4Ao`000?lA4A42o`000003oa4A4Ol0003o4A4A00;o0000
00Go4A4Ao`000?lA4A7o4A4AobXA2002o`0000?o4A4A1_l000001olA4A7o
0000obXR6Ol0003o:Q48o`000?lI6A402OlA4A400ol0003o4A4Ao`000002
oa4A4@03o`000?lI6A7o4A4A00;o4A4A00?o:R8Ioa4A4OlA4A400olA4A43
o`000008ob8R4Om<8PSoG3XRofE<6On?MTCoSgIDohmnKOnYZHl2oinYZ@0>
ohna`OmnWkWoMYNaoff?^OmfUk7oKHnioff?/OmUUk7oKHnaogjO^OlZ8QWo
:Q48ohLA0?lI6A44oa4A4@0EogJG`Om]Sk7oKGj?ohNGZOnGShOo/KVYoiN?
QooSd[7ohm;1on?B/Oo/fl7om>?:ohmfA?o:`JWoG3XRoda48_oBS`3o4A4A
odA4:_n?MR[oIE`I0:Cok^k^001JonKViP04oc94M_m<KIOo8SYLoc94MP;o
>VFG03co>UB7oc94M_lR>Uco>UB7ob8bA?mLKHOoSk71ok7:b_lIMTCo4A4A
obXR6OlI8R;o6ATIobXR6OlR8Q7oOUa<ob8b:_mU6@3oUgiDoim<0?n?WkWo
Sd@0om^?<_o/^Fgo/Fd0on>O>_oBQaWok<67ok6?6OlAWhOoKFeDonbiKOo:
MR;ok:U<o`000?lA4A7oQa40on>O8_oBQaWohjV?ohLA0?na6@3oZ@P0olZ?
<_oKOTcohjV?om]nC?n7IC;ok=^aok7:b_n7OXooZL[BohMnSooKMPSodXl0
ohm40?n7:P3ohjV?om^7IOoKOT`2ok40000BohLZ0?n?A17oQd`Aok400?o/
ZGKofk6Yon>YSoodm?Co/FdIohLA0?oSWeCodXLIoiMnE?oK/JWoSfDAofEL
6Om<A2;o>T@I0_lZ4@P00olA4A7o:Q48oa4A4@02obXA2003o`000?lR8Q7o
C4@R00;oUhL000[oQa40obXA2?lA4A7o0000oginKOmfUk7oOXn?ofefM_lZ
4@So4A4A0_lI6A42obXA20?o4A4A00_o0000od@A0?n7:P3o0000on>O>_nO
C03obXlbok5]6Oo:MR;om<54o`000002oa4A4@0:onbY0?oddWkoC288oa4A
4OlR8Q7obWHRon>O>_lZ4@So0000ob8R4@;oA14000ko/FdIoncK`OnOC03o
fgHbok5]6OoSWeCoSd@0oa4A4OnaKAWo^D`0o`000?m<C3[o0000obXR6@;o
:Q4800Ko:R8Iob8R4OlR8Q7o:R8Iob8R4OlA4A43obXR6@0;o`000?lR8Q7o
:Q48obXA2?m4:R;oC4`joaTR8_lI6AWo<SY4ocYDG?ljA4`00_ljE5`01?lj
A4co>UALocYDG?mDKGH2ocYDG007ocYDQoljE5co>UALocYDG?m4A4co>Uaf
odA4C002ob8b:P08ob9<E?lb>TCo8S94ob8bA?lR:R[o8SXbodanSolI6AT2
oa4A4@03obXR6Om<E6go4A4A00Co4A4A00Go:Q48oa4A4OlI8R[o6ATIobXA
2002oa4A4@03o`000?lA4A7o000000;o4A4A00Oo0000oa4A4OlA4A7o4A4A
o`000?ljE5co6ATA00?o8RXZ00Oo6B8Rob8R4OlR<R[oKFeDoinOO_nGShOo
MWiL00;o00001?lA4A401?l0003o4A4Ao`000?lA4A42o`000003oa4A4OlZ
4@So000000;o4A4A0_lR8Q42oaTI4@;o4A4A00[o:Q48oa4A4OlZ4@So4A4A
ob8R4OlA4A7o:Q48o`000?lA4A7o6ATA0olA4A401Ol0003o4A4Aoa4A4OlA
4A7o000000Go4A4A00?o:Q48oaTI4OlI6A400olA4A42o`000006oa4A4OlZ
4@SoC288ohMD:_n7IC;oUgiD0_nYZHl01?lR8Q7oZL7:ohnO^On7Wk42ogJG
`@0:off?^OmnWkWoOYniogjO^Om]SkWoMYNaoff?^OmfUk7oKHnaogJG/@;o
KHni00OoKHnaogJG`OljE5co0000om9<0?m44@3o6ATI00;o4A4A00?o0000
oncSb_o/fl400_odk=/2ooclm00?ooCSb_odk=_om?C/ooclm?odm>coo?cd
ogi]C?oBb/7oQfDboa4A4OoodPSoC288oa4A4OoK`@SoSd@00:Coi^KV001J
onk^kP?o>UB700_o<TAfob8jG?lR>UcoC6fGocYUUoljE8OoE7JGob9<E?mn
WkWoSiN?ojW:dP02oa4A4@0`oaTI4Om4>R[oQda4ogiUE?nYZHook>?:oda4
8_m<8PSo^IMDok5]6OoK/JWohimDolZ?<_n?IA7oWd`0onbiKOn7IC;oUhL0
oeAnO_m<C3[oIFDjonbYM_o/ZDcohm:Ood@A0?lR8Q7oC288ofDI0?oBC03o
oooook400?n7:P3oQa40om]f<_oooooofhMUooc10?niUeCohm;1oc9UZOl0
003oWin?ooCSb_oSWb;om=9UofeU8_nY203om>?:0_odm>`04OoKOTcobWHR
ohLA0?o:MR;oWd`0ojT80?o/fk7oo?cdon?KfooKOTco^D`0on>O>_oK`Ioo
fgHbokVOO_oB/HooUkW:00;oIE`I00Co>T@Ioc8Z8_lR8Q7o00000_lA4A40
4Ol0003o4A4Ao`000?m<8PSoUhL0ofEL6OlI6A7o:Q48o`000?lA4A7o0000
ofE<6Ol0003o4A4Aol6iUol0003o4A4A00;o000000So4A4Ao`000?lZ4@So
0000oaTI4Olb:R;oIC88ofE<6@;o:Q4800Cofhlbonc1QooddWkoSgHZ0_l0
00008OlA4A7o0000ohLZ0?mU6@3o0000oa4A4Ol0003oQbX0o`000?m<8PSo
<RXRod@Z8_lb:R;o8R8AofE<6OniUfgo0000od@A0?lZ4@SoSd@AobXA2?lA
4A7oQe@Zohmf>_l0003oOVEDo`000?lb:R;o6ATIoa4A4OlI6A7o<RXRobXA
2003oa4A4@;o:R8I00[oA3XZo`000?lI6A7o:Q48ob8R4OlI6AWo8SXboaTR
8_lA4A7oC7In1?ljG7H01Om<MWko>UafocYLM_ljE5coC5A]00;o>UAL00?o
8TaDob94>_lR>S800_lR<RX04?lI8R;o8SXbob8Z:_lb:R;o8S8ZocXj<_lR
>S;o<SY4ob8b:_m<MWko4A4AoaTR:_lA4A7o0000oeA]M_l00005oa4A4@04
oaTI4Ol0003o6ATIobXA20;o4A4A0ol000000olI6A7o0000oa4A4@03oa4A
4@04o`000?ljA4co4A4Aob8b:PCo8R8A00Co:Q48oaTI4Ol0003o4A4A1Ol0
00002OlA4A7o0000oa4A4Ol0003o4A4Ao`000?lZ4@So4A4Ao`000005oa4A
4@04oaTI4OlZ4@So6ATAobXA20;o4A4A00Go:Q48oa4A4OlZ4@So4A4AobXA
2003oa4A4@04o`000?lI6A7o4A4Ao`0000Co4A4A00Ko6ATIoa4A4OlA4A7o
4A4Ao`000?lA4A42o`000008oa4A4Om44@3oID`IoiMnE?n?QfgoWiN7ojVY
SonOZJT2ohna`@09ogjO^Om]SkWoKHniogjO^Ol0003oMYO1off?^OmfUk7o
KHna00?oMYNa00GoSiniogJG`OmfUk7oKHnioff?/@03ofF7Z@07ohnGSonG
ShOoWjVYol6a^OnaQfGo0000obXR6@02oa4A4@07oaTR:_lA4A7o0000ooCS
b_olo?Com?C/onc/h`04ooCdk00=onc/hoodm>cok>cSooclm?niWgkod/[1
oiMnE?l0003oom88ohM<4OlI8R[o/HlIokV7002Tonk^kP00F_ooool01_lb
A7Ko>VFGocYDQoljIIOoC7JGocYDQ`;o8SYL02?oE7JGogJG/OmLQhooKHna
off7O_m<MWko<RXRoa4A4OlZ4@Sofk6OokVGKOoB/Hood/ZYoncK`OmnKFGo
SgHZofDb2?oddVGo^D`0onc1QooSWc[oQbX0om:?0?oddWkoIC88oda<>_ni
^JWoQd`AofDI0?oSdYoofk6Yonc1QonaKAWo`Fe4oncK`@02ol5]A00]om^a
Woo/k>?obR80on>O>_nY203om?C/ooCBO_o/`HOom=9Uon?KfonaK@3ofim]
oim<0?o1/KWohm:OooCBIOmUG1WoIAT0om^aZOodm>cok>?:oncK`OoK/JWo
QbX0om]f2?o/^Fgo/AT0on?B/OoSZHoofhMUom]f<_oSZHoohiljom]nC?n?
A17oKFDRooCSb_nYb];oShMDoiN70?mUG1Wo>T@Iod@A0?lI6A7o:Q4800;o
000001Co4A4AoaTI4OlZ4@So>T@Io`000?lZ4@So4A4Ao`000?lA4A7o0000
od`R2?lZ4@So0000om_:WolZ4@So0000obXA2?m44@3oC288ofE<6@Co>T@I
00_oIE`Iohmf:_mUC1Wo0000od@A0?o/^FgoC4@Ro`000?lI6A7o0000obXA
2002o`0000;o4A4A00Co0000oaTI4OlA4A7o:Q480_lb:R802?m<8PSoA2XR
oc8Z8_lb:R;o6ATAofDb2?oSW`3o4A4A0_lb:R801om4:R;o:R8Iod`R2?lb
:R;oOUa<oa4A4Olb:R800_m<8PP01olZ4@SoA3XZobXR6Olb:R;oA3XZo`00
0?lj>S800_lb:R802?l0003o4A4Aob8R4Ol0003o:Q48ob8Z:_lI8S;o:R8I
0_ljIHL2ocYDG003ob9<E?lb>TCo<SY400;o8SXb00Co8T@joc8Z8_lI8S;o
8T@j0_lb>T@00olRA3[o>TA<oc8jA005oc8jA005ocY4C?lRA3[o8RXZoeA]
M_lI6AT00_lA4A400ol0003oC5A]o`000002oa4A4@;o000000Oo4A4Ao`00
0?lA4A7o4A4AobXA2?lA4A7o000000Go4A4A00?o0000oa4A4Ol000000_lA
4A400olZ8QWo6ATAo`000002oa4A4@05o`000?lI6A7o4A4AoaTI4OlR8Q40
0_lI6A400olA4A7o0000oa4A4@02oa4A4@Co00000_lA4A401?l0003o4A4A
oa4A4Ol00002oa4A4@05obXA2?lI6A7o8R8AoaTI4Ol000000olA4A401OlI
6A7o4A4Aoa4A4OlA4A7o6ATA00?o4A4A00Co6ATAob8R4OlI6AWo4A4A0_l0
00002_lA4A7o0000obXA2?m44@3oG3XRohmfA?n?MVGoKHMnoinOSonOZJT2
ohna`@03ogJG`OmnWkWoMYO100;oMYNa00?oMYO1ogjO^OmnWkT00_mfUk40
2?n?/L7o0000ogjO^OmnWkWoKHniogJG/Om]SkWoKHna0_mnWkT05On7UjWo
Uhn7ok6a^OoBbZWod/[1oncK`Oodhl[om>cKooCdk?olo?CooooooncK/Ol0
003o8RXZoa4A4Oo/ZGKoQd`AokVGKOo/fk7om?C/ooCdm008ooCdk00;onc/
hoolo?Co^Imnok6iZOnGSgKo0000om_12?naKAWo0000ohmf:_oSW`00Y?oo
ool005[ok^k^00Co>UafocYDQoljE8OoIHNY0_m<MYL0;_mDMYOoG7jGogJG
/OmLQiOoMYNaoaUD<_m]OXoo6GI4oc8jA?lI8R;oQfDbooCdk?olo?Cok=_1
om^aZOo/fk7o^K6OobXA2?lA4A7ohil0ojT80?oSW`3ok;U]oiN70?niQ`3o
k:U<ohMD:_n74@3o`Fe4om]f<_nY203ofk6YohnO^OoK/JWoo?cdom^7IOn7
4@3ofhMUoooooooKMS;obWHRok4I0?oSZHooQa40olXR0?o/Z@02oncK/@0>
off?^OnaK@3ohimDon>O>_lbA7Kob]_Kok6?6OlR8Q7oIAT0om]f<_oK/JWo
fhMUoooooona^Il3ohm4000CohLA0?n?A17ofgHbolXR0?oKQfGohm;1om^O
KOodhl[oWimnofE<6OooooooIC88onc1Qom<8PSo>T@IofE<6Om44@3o4A4A
o`000003oa4A4@06o`000?lA4A7o0000o`000?lZ4@So00000olA4A403?mU
C1WoC4@Ro`000?oSdYoo:Q48ofDb2?mUG1WoID`Iod`R2?lb:R;o>T@IofE<
6@;o>T@I00CoA140ohmf:_lZ4@So4A4A0ol000000olI6A7o:Q48o`000002
oa4A4@09oaTI4OlZ4@So4A4Aoa4A4OlI6A7o0000ob8R4Om<8PSo:R8I00;o
<RXR0_m4:R801?m44@3o<RXRoc8Z8_lI6A42obXR6@07od`R2?m44@3oA2XR
od@Z8_lZ8QWo4A4AobXR6@02ob8R4@06oc8Z8_lj>R;oA3XRoc8Z8_ljA3;o
00000_lZ8QT2ob8R4@03obXR6OlI6A7o>UAL00?o>UAL00?o>TA<oc8jA?lj
A3800_ljA4`01?m<E6go>UALocYDG?m<E6d4ocYDG003ocY4C?m<C4Co>TA<
00;o<SY400?o>T@bocY4C?lj>S800_lRA3X03?lb>TCo<RXRob8j<_lZ8QWo
>UALo`000?lA4A7o6ATIo`000?ljE5co4A4AoaTI4@Ko4A4A00Wo6ATAoa4A
4OlA4A7o4A4AobXA2?lI6AWo8R8AobXR6OlA4A400_l00002oa4A4@;o6ATA
00Co4A4AobXA2?lA4A7o6ATA0olA4A44oaTI4@03o`000?lA4A7o000000;o
00000_lA4A401ol0003o4A4Ao`000?l0003o6ATAo`000?lA4A400_lI6A42
oa4A4@Oo6ATA01Wo4A4AoaTI4OlA4A7o4A4Ao`000?lZ4@So0000obXA2?l0
003o:Q48od@A0?mUG2[oQda4ogi]IOn?OVgoSiN?ohNGZOn?WkWoOYniogJG
`OnG^L[oMYO1ogjO^OmfUl7oMYNa00;oOYni0_mfUk42ogjO^@0?ogJG/Om]
SkWoMYO1ofFG/Om]Sk7oOYnio`000?n7UjWoIHNYohMnSonGShOo^KVGoinG
QooSd[7om>?:00;om>cK00?oo?cdooCdk?olo?@00_odm>`03?o/k>?om?C/
onc/hoodm?CooooookUnC?l0003om>cKooCSb_odm>coooooooclm0_om?C/
00[oo?cdokVOO_na^IOo`KVGo`000?niQ`3ofl48o`000?n?IA7oo<40Y?o^
k^h005[oi^KV01go>UB7oc9UZOljIIOoG7jGoeAfUom]Sk7oE8NaofF7ZOmn
WkWo>VF7ocYDG?lIMTCoE7inocYDG?lj>S;o6B8bojT80?o/fl7ok>cSom^a
WooSZHoofl6Ool[KfoniC03o^HL0olYf8_na6@3ohl54on>O0002ooc1000N
on>YSoodk=_ofk6Yol5]A?n7:P3ofk6Yoooooonid]_ofk6Oon>YSooooooo
/FdIom]f<_oBC03ofhMUom9<0?o:MR;ofk6YoncSb_o:MR;oWfe<om;:`Omf
Ul7o<WJaoim<0?naSaWo^HL0ohM<4Om]Sk7oZJV?0_lA4A407OnY203ofgHb
olXR0?oKMS;oQbX0ok400?o:MR;ok;U]olXR0?na003obR80om9<0?oSZHoo
hm_Kom_1Woodm>coWhm]ofE<6Oo/k>?ohm:aohmU4Olb:R;o0000oa4A4Ol0
003o4A4AobXR6OlA4A7o000000;o4A4A01Oo:R8Iofe]E?n7C17ok=^aobXA
2?l0003o4A4Ao`000?mL>R;oIE`Zo`000?oBbZWoIC88oaTI4OlA4A7o8R8A
o`000?mU<PSo4A4AocY46OlR8Q7o<RXRofEL6@02ocY46@03oaTI4Ol0003o
6ATA00;o4A4A00?o6ATAo`000?lA4A400_l000002_lZ4@So4A4Aoa4A4Ol0
003o:Q48ob8R4Olb:R;o8R8AobXR6Olb:R83ob8R4@04obXA2?lI8R;o0000
od@Z8P;o:Q480_lZ8QT01om4:R;oA3XZo`000?lZ8QWoC4@RobXR6OlR8Q40
0olb:R802_lZ8QWo0000ob8R4OlR8Q7o6ATAoc8Z8_lj>S;o:R8IocYDG?mD
KGH3ocYLMP07odafO_ljIHOo>UALocYLM_mDKGKo>UALocYLMP04ocYDG008
oda<A?lb>TCo>TA<ocY4C?lR<TCo<SY4ob8b:_lR:RX2ob8b:P06oc8Z8_lR
<R[o8S8Zob8j<_lI6AWoC4a40olA4A400ol0003o<SY4oaTI4@02oa4A4@;o
6ATA00Wo6ATIob8R4OlZ8QWo6ATIoaTI4OlZ8QWo8S8ZoaTI6OlI6A401_lA
4A400olZ4@So0000oa4A4@02oaTI4@[o4A4A00Go0000oa4A4Ol0003o4A4A
o`000005oa4A4@05o`000?lA4A7o4A4Ao`000?lI6A400_lA4A400olR8Q7o
0000oaTI4@03o`000004obXA2?lI6A7o:Q48obXA20;oIE@b00KoKFeDohMn
Som]MWKoQgj?ogJG/Om]SiL2off?^@04off?/Om]SkWoKHnioff?^@KoMYNa
0_mnWkT01OmfUk7oKHnaohNO/OmnWkWoMYNa00;oKHni00[oWjVYojVYSona
/KWoZJV?om^aZOoB/Hoom?C/ol6iQoo/fk7om>cK0_odm>`01Oodk=_ok>cS
ooC/foodm>cok>cS00Oom?C/0_o/k><01oniWgko`KV7ooooooolo?Com?Cd
ooCdk?odm?@00oodm>`00oolo?Com?C/ooCdk005ooCdk00:ooclm?o1^HOo
Win?on?B/Ol0003oG3XRoooB2?l0003oSgHZonbY0:Coi^KV001Jonk^kP06
odaDKOmDQk7oC6fGoeanUomUQjWoC7JG0_mUQjT03?mLQiOoC6f7ohNO/OmD
KGKo>UALob8b:_m4>R[oG5a<oncK/Oolo?Com?CdooCSbP;om?C/02_ohncd
oim<0?odk=_ok:UfohMD:_oSWb;ohl54ooc10?nGQ`3ohjV?ooCSb_odk=_o
fgHbonbiKOo:^HoofhMUom^aZOodm?Cofgi<olYf8_naKAWoSd@0okUnC?na
6@3ohjV?on?B`Ona6@3ofk6Yon>O>_naK@3ohncdojVYSon?<TcodXl0on>O
8_o/^FgodXl0okViSooSd[7oOWi]odA4:_n7OUCoQd`A00;obR800_na0000
5Oo:MR;o^D`0okU<0?na003ofk6Oon>YSooB/Hooooooon?/m?ooooooShMD
ocY46Oodk=_ok=^ao`000?ljA1Wo0000odA4<_lb:R;o8R8Aoc8Z8P03oa4A
4@;o000000GoG5a<ohmf:_o/k>?o:Q48o`000002oa4A4@0?od`R2?m<A2;o
0000om;:ZOmUG1WoKFDRoc8Z8_lA4A7o:Q48ocY46OlZ4@SoC4@RofE<6On?
IA7oWgi<00;o:Q4800So6ATAoa4A4OlA4A7o6ATAoa4A4OlZ4@So4A4Ao`00
00;o4A4A00Wo:Q48oaTI4OlA4A7o4A4AocY46Ol0003o8R8AobXA2?lb:R80
0_lZ8QT01om4:R;o8R8Aod@Z8_m4>R[o4A4AobXR6OlZ4@P00_m<8PP01om4
4@3oA2XRobXR6OlI6A7o0000ofEU>_m4A3800_m<C3X02?m4A2[oIE@boda<
>_l0003o:R8Iod@Z8_lb:R;oA4@Z0_lj>S803?m<MWko>UafocYLM_m<MWko
>UafocYDG?ljG7KoE6efocYDG?ljG7Ko>UALodaDK@Co>UAL00?oA4A<ocY4
C?lb>T@00_lR>S800olj>S;o8S8Zob8Z:P03ob8b:P04obXR6OlR:R[o:R8I
obXR6@;o8RXZ00[o8R8AobXR6OlR:R[o<RXRob8b:_lR8Q7o:R8IoaTI6OlA
4A7o:Q480_lA4A401?l0003o4A4Ao`000?lA4A42o`0000;o4A4A00?o0000
oa4A4Ol000000_lA4A401?l0003o:Q48oa4A4Ol00003oa4A4@03obXA2?lA
4A7o4A4A00;o6ATA00?o:Q48o`000?lA4A401OlA4A400ol0003o4A4Aoa4A
4@02oa4A4@0<o`000?lI6A7o4A4Ao`000?lA4A7o0000od`R2?m4:R;oG3XR
ofEU>_mnIECoOWi]0_m]MWH02_n7OXooKHnaogJG/OmUQjWoKHniofF7ZOm]
SkWoIHNYoff?/Om]SkT2off?/@05off?^OmfUk7oMYNaoff?/OmfUk400_m]
Sk400omfUk7oKHniogJG`@02ogjO^@07ohNO/OnOZJWoQiNYoea]Qoo:/JWo
k=_1oginK@02ooclm009oncK`Oolo?Coo?cdooCdk?odk=_ohm:aom;:`Ool
o?Cok>cS00com?C/00Ook?cdoncSb_mnKDcoID`Ioda48_n?QeCoo?cd00Co
m?C/00?om>cKooCdk?odm>`01_odm>`02oo/k>?oo?cdol[1WonGSgKohm:a
o`000?lZ8QWofl48o`000?n?MR[oUhL00:Cok^k^001Jooooo`05ocYDQomU
QjWo>VFGoda]UomLOYL00_mUQjT00om]OXooC7jaob8b:P02off7OP0gohO:
/OlA4A7o6ATAoda<A?nOOTco/HMUooCdk?na^IOoWgi<ofeU8_naQfGodT`0
ohMD:_o/k>?o<TAfom^aZOo/k>?obXlbobXA2?nOSfgo/@00olXR0?niC03o
himDok4I0?o1/Ioohm:aooclm?oooooohm_KofDb2?ooooooQd`Aon>OE?oo
ooood/ZYom^7IOo:MP3ok=^aooc10?o/`HOofk6Yom9<0?ol`@3ok<4bom;:
ZOol`@3ob/6Ook6iZOmUG2[oIE@bohmnKOlR8Q7o:R8IolXR0002ok4I000D
om9<0?niC03odT`0olXR0?niOTcoShmUoncK`OoSk?Cok>?:oooooon?SfGo
:Q48ooC/foo/fk7oC4@RofE<6OniQ`3oSfDAoda48_l00005oa4A4@0Ao`00
0?n7OUCoSgHZooCdk?m44@3o:Q48ofDI0?mU<PSoIE@bohm]C?nGSgKo^KVG
od`R2?m]KECoQgiDohmU4Om]IB800omUG1T01on?MR[ok=^aon?B`OoSfm_o
^IMDoa4A4Ol000000olA4A405OlR8Q7o4A4Aoa4A4Ol0003o4A4Aob8R4Ol0
003o4A4Ao`000?lR8Q7o:Q48od@Z8_lb:R;o:R8Iod@Z8_ljA1Wo<RXRob8R
4Olb:R;o8R8Ao`000003obXR6@07od@Z8_lZ4@SoA2XRob8R4OlI6A7o4A4A
od`R2003ok4I0005oe`j8_lR<R[o6ATIob8bA?m4A4`00_lb:R801_lj>R;o
>SXbocXj<_m<E6go>UafoeA]MP;o>Uaf00GoE6efocYLM_mDKGKo>UALocYL
MP02ocYDG00@ocYLM_ljE5co>TA<ocY4C?lb>TCo8T@job8j<_lR<R[o<RXR
oaTR8_lR:R[o6B8RobXR6OlI6AWo6ATAob8R4@?o6ATA0_lR8Q42oa4A4@0A
o`000?lR8Q7o6ATAo`000?lA4A7o0000oa4A4Ol0003o4A4Ao`000?lZ4@So
4A4Ao`000?lA4A7o0000obXA2?l000002olA4A400ol0003o:Q48o`000004
oa4A4@06obXA2?lA4A7o4A4Ao`000?lA4A7o00001?lA4A42o`000009obXR
6OlR8Q7o<RXRod@j8_m4>R[oIE@bohMnSom]OXooKHnG00;oIHNY00GoE7JG
ofF7ZOmUQjWoIHNYoeAfU`02ofF7Z@CoKHna00?oKHniogJG/Om]Sk400_m]
SkT01omUQjWoKHnioff?^OmnWkWoMYO1off?Uona/KT00_oBb/403OmnOVgo
Win?ooCSb_o/fk7ok=_1oinGQom<C4Com?C/ooclm?mnKFGoooooooCdk?od
m?@00oodm>`01?o/fk7o>T@Iol6iUoolo?@3ooCdk005ooclm?odm>com?C/
ooCdk?odm?@01_odm>`01_odhl[oShM]oinOO_mLG4coWimnooclm0;om?C/
00Som?CdooCdk?odm>com?CdooCdk?olo?Com?C/ooclm0;om?Cd00com?C/
ooclm?odm?Cok=_1ohn7KOo/fl7o6ATAocXj8_n?IA7oA2XRok6?6OmUC1VT
ooooo`00F_o^k^h01om<KHOoE7JGoda]Uom<KIOoIHNYoff?UomfUk400_mD
Qk402omnWkWoOXn?ohNGZOlRA3[o0000obXR6OlR8Q7o:Q48o`000?oB/Hoo
ID`I00;o000001WoA140okUnC?n?A03obXlbooclm?na^IOoSgHZokViUomL
G4co0000oinGQooSZHoo/@00olYf8_o:8P3od/[1om_1Woolo?Com?Cdon?K
fomUG2[ok>?:oin7KOo/k>?ok?cd00;ooooo00Cohm:Oom_12?oSW`3ok>cS
0_odm?@03_oSW`3oo<40onbY0?oddWkom>cKo`000?lR8Q7oKFeDogInG?m<
A2;o0000ohLZ0?o:8P3o/@000_o:8P003?na6@3obR80ojUf<_nOSfgofk6O
ooooooodm?CoooooohmU4Olb:R;om>cKohmf:P;oZGHb00Kom=9UooCBO_na
SaWo6ATIoa4A4OlI6AT3oa4A4@0Lohn?IOmUIC[o0000okVOO_o/k>?om>cK
ooclm?oSd/7o/K6?onk^k_oSd/7o^K6OofEL6OmUG2[o6ATAoinOO_na^IOo
IFDjohmf:_oB/Hoo>T@IoncK`OoSk?Com?Cdon?B/OlIE3;o0000oa4A4@;o
6ATI00?o:Q48o`000?lA4A400_lA4A401OlZ8QWo8R8AobXR6OlR8Q7o0000
00;o8R8A0_lb:R804_lj>R;oA2XRod@Z8_lR8Q7o:Q48obXR6OlI6AWo:R8I
od@Z8_m<8PSo:R8Iob8R4OlZ4@SoA2XRoa4A4OlI6AWobR80ok4I00?o/@00
00koQbX0ofEL:_m4>R[oA4@bod@j8_lZ8QWo>SXRod@j:_lj>R;oC5A]oeA]
M_ljG7KoC5A]odafOPCo>Uaf00?oKFeDocYLM_ljE5`00_ljE5`01Om4A4co
>TA<ob94>_lj>R;o6B8R00;o6ATA00?o:Q48oa4A4OlZ4@P00_lI6A401?lA
4A7o6ATAoaTI4OlA4A43oaTI4@04oa4A4OlZ4@So4A4AoaTI4@Go4A4A00Co
6ATAoa4A4OlI6A7o00001?lA4A401Ol0003o4A4Ao`000?lA4A7o000000;o
4A4A00Ko0000oa4A4OlA4A7o:Q48oa4A4OlZ4@P2oa4A4@04obXA2?lA4A7o
4A4AobXA20;o6ATA00?o0000oa4A4OlI6A400_lA4A401?lZ4@So8R8Aob8R
4Olb:R83odA4C007ob8jG?lbA7Ko<TAfoc94M_ljE8OoC7JGoeanU`06ofF7
Z@04ogJG/OmUQjWoMYNaofF7Z@;oKHni0_mUQjT06Om]SkWoMYNaohNGZOnG
ShOo/K6iokViZOn?Uhoom>cKohn7KOmLG4com>?:oncSb_nOUhOooooookVi
Som]KECoWjVYogInG?oSfm_oSiN?ofe]E?ooooooo?cdofe]E?olo?@00ood
k=/02?niWgkohm_KooCdk?mL>R;oo?cdooCdm?odm>cok>cS2?odm>`02_ol
o?Com?C/ooCdk?odm>coo?cdohn7E?ni^HooIFDjokVOO_olo?@3ooCdm008
ooclm?odm?Com?Cdooclm?odm?Com?C/ooCdm?olo?@3ooCdk00:ooCdm?od
k=_oOWi]oncSb_m<8PSo6ATIoc8Z8_nGQ`3odXLIob8R4JCok^k^001JonKV
iP06oda]QoljIIOoE7JGoda]Uon7UjWoKHna0omUQjT02OmnWkWoSk71okWB
folI8R;o<RXRoaTI4OlR8Q7o8S8ZoaTI6@02oa4A4@;o:Q4800[o:R8Ioa4A
4Ol0003o^IMDoooooonOZJWo4A4Aol6iUoo/k>?oZJV?0_o/hlX03?oKMS;o
^D`0om]f<_m<C3[o^IM]ooclm?odm?Coo?cdol6aWooSd[7om?C/ooooo`;o
m?Cd00[om>cKooooooooooood/[1ooC/foo/fk7ok>cSon?Kfoo/fk7om?C/
0_o/hlX01OlI6A7o>T@IofED<_mnMVGoC4`j00;o4A4A01Wo/K6?ohm44OnO
C03oC4@RofEU>_niUeCo0000ofE<6Oo:/JWom>?:om_1Woodhl[o>T@IoaTI
4OoSd[7oWimnoinOSon?Qfgod/ZYooCdm?nOWgko6E@boaTI4Ol0003o4A4A
00;o6B8R01Ko^IMDo`000?lZ4@Sofk6Yooclm?oSfm_om>cKon?KfonOSfgo
hm:aom;:ZOniWgkoID`IofeU8_lA4A7o>T@IojVYSoni^IOo`KV7oooooolR
8Q7ok=_10_odm?@01oo/hl[o>T@Ioa4A4OlA4A7o:Q48ob8R4OlZ4@P00_lA
4A400ol0003o:Q48oaTR8P03obXR6@08obXA2?l0003o<RXRobXR6Olb:R;o
A2XRoc8Z8_m<A285obXR6@08od@Z8_lZ8QWoA2XRod@j:_m4:R;oC288oa4A
4Ona6@03ok4000?o/AT000GoMWiLob8b:_lj>S;oC4@Roc8Z8P02ocXj8P03
od@j8_ljE5coE6ef00;oC7In00Ko>UafodafO_m<E6go>UafocYDG?lRC5@2
ob94>P04ob8j<_lR<R[o8S8ZoaTR8P;o:R8I00co6ATAob8R4OlI6A7o6ATA
ob8R4OlI6A7o:Q48oa4A4OlZ4@So6ATAoa4A4OlZ4@P3oa4A4@06o`000?lA
4A7o4A4Aoa4A4OlI6A7o00000_lA4A400ol0003o4A4Ao`000002oa4A4@03
o`000?lA4A7o000000;o4A4A00Ko:Q48oa4A4OlZ4@So4A4Ao`000?lZ4@P6
oa4A4@04oaTI4OlA4A7o0000oa4A4@;o6ATA00co0000oa4A4OlI6AWo4A4A
oaTR8_lA4A7o6ATIob8bA?lI8Tco6CYfoaU4QolbA7H5ocYDQ`04oda]UomD
MYOoIHNYogJG/@;oKHna0_mfUk42off?^@03ofFG/OmUQjWoIHNY00;oWjVY
00GoQgj?ok6a^OoSd/7oKGIfoncK`@02ooclm00EooCdk?ooooooIFDjoooo
ooo:`IooKFeDoio1/OmLG4coShmUoooooooSfm_oOWIDoiN?QomLG4coQfDb
ol6iUoodk=_ohm_KooCSb_mUG2[ooooo00?om?Cd00Wok>?:on?KfooBbZWo
^KVGooooooodm?Com?C/onc/hoodm>`00_odm?@01?odm>coo?cdooCdm?ol
o?@4ooCdm00AooCdk?ooooooSgIDok6iUomUIC[oWimnooCdk?olo?Com?C/
ooCdm?odm>coo?cdooCdk?odm?Coo?cdooCdm?olo?@00_odm?@03?olo?Co
m?C/ooclm?olo?CoQgiDol[1ZOoSdYooSfDAoimnC?niUeCok<4bokVOOZCo
i^KV001Jonk^kP06oeAfUom<KIOoG7jGoeAfUomUQjWoQiNY0_mUQjT01om]
OXooSinioinYZOnid]_o0000om:aSolZ8QT00_l000003OljA1Wo6ATAob8R
4OlA4A7o6ATAob8R4OlA4A7o0000ohmU4Ooooooob[V?ojVYSoljA1T00_na
/Hl02?o/fk7od[6?om;:ZOoKQfGoID`Iooooooo/k>?oo?cd0_odm?@05ooo
oooohm:aoncK`Oo/fl7om>?:oncK/Oodm?Com?C/onclm?o/hl[o`KVGolZi
Soodhl[ok=_1on?Kfoo^k^kom>?:ohmfA?lR8Q7o:R8IogInG?mnMUCoIFDj
00;o000000So^Imnok6iWon7UjWoKFeDok6iWomnShooUhmfol6aW`;o^KVG
01KoIE`IofeU8_lZ4@SoC288od@j8_n?MTCob[6Yok6aSoniWgkoooooolZa
ZOl0003oUhmfok6iUona^IooID`Ioda48_n?MR[o:R8IobXA2?o1/Iooo?cd
0oo/k><03OniUfgok>cSooCdk?odk=_oC4@Rohmf:_lA4A7oID`Iom;:`Ood
m>cohm:aooCdk?lI6A400oolo?@00ooBbZWo:Q48o`000002oaTI4@06ob8j
<_lR8Q7o6ATAoa4A4Ol0003o4A4A0_lZ8QT01_lI6AWo8R8AobXA2?lA4A7o
8R8AobXA20;o:R8I00?o<RXRob8R4OlR8Q400_lZ8QT00olj>R;o<RXRod@Z
8P05od@Z8P04ok67IOoKWfgom>cKooC/f`;ok>cS0_odm>`04om44@3o4A4A
o`000?m4:R;o6ATAobXA2?lI6AWo:R8IocY4C?lIE7ko>TA<ob9<E?lj>S;o
<SY4ob94>_ljA3;o>TA<ocYDG?m<C4@00_ljE5`01_m4A4co>UALoda<>_lR
>S;o8S8ZobXR6@;o6ATA00?o:Q48oaTI4OlA4A400_lI6A402_lZ4@So4A4A
obXA2?lA4A7o:Q48oa4A4OlZ4@So0000obXA2?l00002obXA2004o`000?lA
4A7o4A4AobXA20Co4A4A00?o:Q48oa4A4OlZ4@P04?lA4A400olI6AWo6B8R
oa4A4@02oaTR:P04oaTR8_lI8S;o6B9<oaTR<P;o8SYL00Co6CYfoc94M_lj
E8Oo>UB70_m<KIL2oeAfU`?oG7jG00CoIHNYoff?^Om]SkWoOYni0_mfUk40
7OnOZJWo/KVOom^aZOoK`Iook>cSoinGQoo/k>?ooooooinOO_o:`Ioooooo
okVOO_nGSgKoWin?oginKOoBb/7oooooogi]C?olo?Cohm_Koin?KOnOUhOo
b[6YoncSb_odk=_oIFDjolZaZOooooooShmU00;ooooo00_od/[1ooclm?oo
ooooOUa<ooooooodm>com?CdooCdk?o/k>?od/[1ol6aW`02ooCdk0;om?Cd
01?oo?cdooCdm?odm?Coo?cdooCdk?odm?Com?C/ooCdm?odm>coo?cdooCd
m?olo?Com?CdoooooonOOTco^KVGogi]C?ni^Hooo?cd00?om?Cd00Koo?cd
ooCdm?odm?Coo?cdooCdk?olo?@2ooCdk008ooclm?odm>com?CdooCdk?ol
o?CoShMDol[1ZOodk=/2ooCSbP03ooC/foodhl[ooooo0:Cok^k^001Joooo
o`;oG7jG00?oE8Naoda]UomUQjT00omUQjT02Om]Sk7oQinaohnO^Oo1/KWo
0000ohMU<_oooooom>?:ofe]E002oa4A4@04oaTI4OlI6AWo4A4AobXA20;o
Wfe<01;o^IM]ooclm?oooooo/KVOohMnSolZ4@So/HMUoooooonOWgkoSgHZ
ol6iQonGOUCofl6Oon?B/Oodhl[om?C/ooC/foodhlX2ooC/f`04ooCSb_o/
fk7om>?:oncK`@;ok=^a00?oflZOom;:`OoSd/400_odm>`02Oo:fm_oSiN?
ooCSb_ni/Ioo6ATAocY46OmUIC[oOUa<ohMnE002oa4A4@09ojUf<_oooooo
/KVGogInG?oooooohm:aooCSb_odm?Co^KVG00;oWimn01GoUhmfokVOO_nO
WgkoSgi]ofEL:_oBb/7ob[6Yom;:`Oo:`JWo/KVGoaTI4Om<A2;o8R8AokVO
O_lZ4@SoC4@RobXA2?lb:R;oA2XRokVGKOolo?@00oo/k><01?odm?Cohncd
ooCdm?ooool2ocY46@0<oe`j8_n7IC;oUgiDoiMnE?na/Hoob/6Oohmf:_na
QfGoWhm]ohMnE?mUC1Wo<RXR1?lZ4@P00olR8Q7o4A4Ao`000002oa4A4@0;
ob8Z:_lR8Q7o8R8Aob8R4OlI6A7o4A4AobXR6Om4:R;oA4@bod@j8_lb:R80
1?lZ8QT00olI6AWo:R8IoaTI6@02od@j:P0?odA4<_lZ8QWo8R8AolZiSooK
Wfgohncdon?KfooSd/7od/[1ol[1Woo:^HooKFDRodA4<_l0003oA2XR00Co
<RXR00[oA3XZocYDG?m<E6goC5A]odafO_ljE5coE6efodafO_ljG7KoC5A]
1?ljE5`03om4A4co<SY4oc8Z8_lI6AWo:R8IoaTI4OlZ4@So4A4AoaTI4OlZ
4@So4A4AobXA2?l0003o6ATAobXA2004oa4A4@09oaTI4OlA4A7o4A4Aoa4A
4OlI6A7o4A4AobXA2?l0003o6ATA00co4A4A00Go6ATAoa4A4OlA4A7o6ATA
oaTR:P02oa4A4@07oaTR:_lA4A7o6B8ZoaTR<_lI8R[o6B9<ob8bA002oaTR
C0?o8SYL00?o6DAnoc94M_lbA7H00_ljE8L00oljIIOoIHNYoeAfU`02oean
U`0WofenSon7OXooG7jGohNGZOoSd[7ofl6OoncSb_nOQfgoC5A]ofe]E?oS
d[7om>cKooCdk?o/k>?oo?cdoncK`Om]KECoMWiLoeaLC?oSd/7oo?cdol[1
ZOm]KECoG5a<ogi]IOo/fk7ok=_1ofEU>_ooooooUgiDok6iUoooooooo?cd
ooCdm?ooooooWimnojVYSoooooooWfe<00;ooooo00KoWhM]om;:`Ooooooo
Sfe<ooooooodm?@2ooCdk00=ooCdm?ni/Ioom>cKooooooniWgkoooooooCd
m?odm>com?Cdooclm?odm>com?Cdooclm002ooCdm00<ooclm?odm?Com?C/
ooCdm?odm>cooooooiMnE?o1^IooKFDRoinOSoodk=_om?Cd0_olo?@2ooCd
m003ooclm?odm?Coo?cd00;om?Cd00Woo?cdooCdm?odm>coo?cdooCdk?oo
ooooShMDok6iUoodk=/00_odhlX00oodk=_oo?cdooCdm02Tooooo`00F_o^
k^h01_mLOYOoKGj?oeAfUoljIIOoQiNYogJG/@;oIHNY01coQiNYohnO^OnY
`L[o6ATIokVOO_o^k^koWhm]ok6iUomUIC[o8R8Aoc8Z8_m4:R;oG3XRod@j
:_n7IC;om>?:oncK/OniWgkom?C/ol6iUoo1/Ioom>cKoiN?QonOQfgooooo
ohmfA?nOOTcoWhm]0_niUe@00onGOUCod/ZYoncK/@03oncK/@03on?BWooB
bZWok=_100;ohm:O013ohm:aon?BWoniUeCo^KVYolZaZOoSfm_oo?cdonc/
hom]SiOok<67ooclm?lR8Q7o:Q48oeaLC?mUE3;oG5a<0_l000001_mU<PSo
d/[1ogInG?n7IC;ok>?:okViZ@;ohm;101_o`KVGokVaWoo:/JWob/6YolZa
ZOni^IOo`K6Ook6iUon?SfGoOVe<ofEL6Om4>R;o>T@Ioc8Z8_m4>R[o:R8I
okVGE?n?MTCo^IMDofeU8_mL>R;o8R8Aohmf>_ooooook>?:on?Kfoo/hlX0
0oo/k><03OooooooKFDRofEL6OmnKDcohm;1on?B/OoBb/7ob/6Oom;:ZOo:
`JWoWhm]ok67IOmUC1T01_lR8Q400olI6A7o4A4Aoa4A4@02o`000007ob8Z
:_lZ8QWo<RXRoaTI6OlZ4@So4A4Aod@Z8P02ocXj8P05obXR6OlR8Q7o8R8A
ob8R4OlI6AT00olZ8QT02?lI6A7oA2XRoc8Z8_m4:R;o<RXRo`000?odhl[o
m?C/0_nY2003ok400003ojT80?o1^HOoC4@R00;o000000Go8RXZoc8Z8_m4
>R[o>SXboda<>P02odafOP07oeA]M_ljG7KoC7InocYLM_m<E6go>UALoeA]
MP02ocYLMP?o>UAL00Ko>TA<oc8Z8_lZ8QWo:Q48oa4A4OlZ4@P6oa4A4@08
obXA2?lA4A7o4A4AobXA2?lA4A7o:Q48oa4A4OlZ4@P2oaTI4@?o4A4A00?o
:Q48oa4A4OlA4A400olA4A400olI6A7o4A4Aoa4A4@04oa4A4@05oaTR:_lA
4A7o4A4AoaTI4Ol000001OlI8RX01OlI8Tco6B8boaTRC?lR>Uco6CYf00;o
6DAn00?o<TAfoaU4O_ljE8L00_ljE8L01omLKHOoE7JGohMnSonYZHooG6f7
okVaWooBb/400_odhlX03?odm>coIFDjol[1ZOolo?Cok>?:ooclm?odhl[o
C4`john7KOoBb/7om>cKonc/h`;om?C/00Oom>?:ogi]C?n?MUCoKFeDoocl
m?oSd[7ohm;100;om>cK00goWimnooooooooooooOUa<ooooooo:/JWoUhmf
ooooooodm?Com?C/ooooooo:`IooOVeU00;ooooo00Ood/[1on?B/Oodhl[o
m?CdoooooonOQfgoo?cd00;om?Cd0_olo?@01onYZHooooooooCdk?n7IC;o
ooooooCdm?olo?@00_odm?@01?olo?Com?C/ooCdm?olo?@2ooCdk00;oocl
m?odm?Coo?cdooCdm?ooooooUgiDoda<>_mUG2[oG5a<ooC/foolo?@00_od
m?@01_olo?Com?CdooCdm?olo?Com?C/ooclm0;om?Cd00Ooo?cdooCdk?od
m?Com?CdoooooonOOTcoWin?00?om>cK00?oo?cdooCdk?olo?@0Y?o^k^h0
05[oi^KV01koE7JGocYDQomDMYOoE7JGohNGZOm]SiOoMYNaofF7ZOn7Wk7o
Sinioff?UolZ4@Sofk6Yonc/honOSfgoWgi<ohn?IOmL>R;o^Imnom;:`OoS
d/7ohm:aooclm?o/hl[ok>cSooCdk?o/k>?ok>?:onc/hoodm?@2ooclm009
oncSb_oBb/7ohm;1oncK`OoSd[7o`KVGol6iQooB/Hook=^a00Gohm:O037o
k=_1oncK/Oo/hl[om>cKon?Kfoolo?CoShmUokVOO_oSfm_om>?:onKVi_mn
MVGo`KV7ohMnE?lj>R;o8R8AofED<_m4A2[oG5a<ohmfA?nGOUCoSfe<ok67
IOn?MTCoOUa<ohmfE?n7IC;oQd`AofE<6Oni^JWob/6Yol6iWoo1/Ioo/K6?
okViUooBbZWohm;1ohn7KOoSd[7oQgiDofe]E?mUE3;oC4`jodA4<_lb:R;o
IE`ZofeU8_nOOTco<RXR00;o8R8A00?oSgHjooooooo/k><00_o/k><03Ood
k=_om?CdooCdk?ooooooWgi<ol6iQonaQfGo/K6?ol6iWoni^HooWimnoiMn
E?n?Qe@00om<A282obXR6@05ob8R4OlZ8QWo8R8Aob8R4OlZ4@P00olA4A40
0ol0003o8R8AoaTI6@02ob8R4@0Coa4A4OlR8Q7o:R8IobXR6OlR8Q7o:R8I
obXA2?lZ8QWo6ATAobXR6OlR8Q7o6B8RobXA2?lI6AWo<RXRoe`j8_lZ4@So
/HMUoncK/@02oncSbP0@on>YSona6@3o/AT0ok400?na6@3oSgHZoinOO_l0
003o4A4AobXR6OlI6AWoC4@Roc8Z8_m4>R[oC4`jocYLMP?oE6ef00go>Uaf
oeA]M_mDKGKoC7InocYLM_ljE5coE6efodA4C?ljE5co>TA<odA4<_lR<R[o
6ATA00?o4A4A00Ko:Q48oaTI4OlA4A7o4A4AobXA2?l00002oa4A4@03obXA
2?lI6A7o4A4A00Co4A4A00Go0000oa4A4OlI6A7o4A4Ao`000002oa4A4@04
oaTR:_lA4A7o6B8Zoa4A4@?o6B8Z0_lI8S801_lI8R[o6B8bobXR6Ol0003o
:R8Iob8R4@;o6B8b0_lI8T`01?lR>Uco6B9<oaTjM_lI>WH2oc94MP0EoeaL
C?m<MWkoE6efok6aSonGShOoC5A]ol6iUoodk=_oIFDjooCSb_olo?CoID`I
okViZOo/hl[o/K6iom;:ZOooooooShmUogifIOmLG4coIE@b00;om?C/00go
SgIDofe]E?n?Qfgom>cKon?B/Oo/fk7oSgi]ooclm?odm>com>cKohmfIOoo
ooooo?cd00;ooooo017oo?cdohmfIOoooooom?Cdoin7KOooooood/[1ogiL
C?oooooom>cKooCdk?olo?Cohm;1ofED<_oooooohncdol6aS`02ooooo`04
ooCdm?ooooooWiN7onc/h`;om?Cd00[om?C/oooooon?Qfgoooooooclm?mn
KDcoooooooCdm?odm>coo?cd0_odm?@2ooclm00AooCdm?olo?Com?Cdoocl
m?odm>coo?cdooCdm?oooooo^IM]ohmfE?n?SfGoIE`ZolZaZOoooooom?C/
ooclm?odm?@00oolo?@02oodm?Coo?cdooCdm?olo?Com?Cdooclm?odm>co
m?CdooooooniUfgoWiN700Com>cK00?om?C/ooclm?oVi^H0XooVi^H005[o
k^k^02KoC6fGoeanUomDMYOoE7JGohNO/OmUQjWoQiNYofF7ZOn7Wk7oUkW:
om^OKOm]IB;om?C/onc/hol0003o4A4Ao`000?lR8Q7o:Q48ojVYSonOUhOo
`K6Ool6aSoo1^IOob/6OoiMnE?odm>com?CdooCdk?odk=_om?C/ooCdm?od
m>cohm;1ok6iUona/Hoohm;1om;:`@;ok=_100?ohm_Konc/hoodm>`00ood
m?@00oodm>com?CdooCdm002ooCdk00Cooclm?niUfgohm:OooC/foo/fk7o
fl6Ool[1WoniUeCo>T@Ioa4A4OlZ8QWo8R8AobXR6OlA4A7od/ZYol6iUoo1
^HOom?C/on?B/@02on?B`@;ok>?:00koUgiDom;:ZOo:`JWo`KVOol[1Woo1
/Iooo?cdooCdk?olo?Co`KVGoncSb_mfOUcoOVe<ofEU>P;oC4a400_o:R8I
od@j8_mUG2[oG3XRod@j8_mL>R;oA4@ZofEL6Oo/fk7om?C/oncSbP02onc/
h`07on?Kfoo/k>?om?Cdoin?KOni/Ioo^Imnol6iQ`02oin?K@07ohm]C?n?
MS[oSgI4od`R2?ljA1WoC4@Roc8Z8P02ob8R4@06obXR6OlR8Q7o8R8AoaTI
4OlZ4@So00000_lA4A401_lI6A7o0000oaTI4Ol0003o6ATAoa4A4@;o:R8I
00?o8R8AobXR6OlZ8QT00_lI6AT04olZ8QWo6ATIobXR6OlI6A7o:R8IoaTR
8_m<8PSoKFDRooC/foo/k>?om?C/onc/hooooooom>?:om^OKOniWgkoWhm]
ofeU8_lR8Q400_lA4A402OlI6AWo<RXRod@j8_m<A2;oA3XZoda<A?mDKGKo
C7InoeA]MP02odafOP07oeA]M_ljG7KoE6efodaDKOmDKGKo>UALocYUQ`02
ocYDG004ob9<E?lR8Q7o:Q48obXA20;o4A4A00?o6ATAoa4A4OlZ4@P00_lA
4A42oaTI6@03oa4A4OlI6A7o000000?o4A4A00?o6ATIoa4A4OlI8R801?lI
8RX00olI8S;o6B8Zoa4A4@02oaTR:P06oaTR8_lI8S;o6B8ZoaTR:_lI8S;o
4A4A0_lI8S806_lI8R[o4A4Aod@Z8_lZ8QWo6B8boaTRC?lR<TCoG5a<ogi]
IOn?MVGo^Imnom;:ZOmDKGKod/ZYooclm?o1^IOoKFeDoooooooBbZWoIE@b
okViZOooooooIE`Zon?B/Oolo?CoMWiL0_m]KE@04OmnIECoWimnooclm?ni
WgkoUhmfoinOSoodhl[om?C/onc/hoooooook>?:ogiLC?oooooom?Cdoooo
ooodhl[ob/6Y00;oo?cd00koooooooCdm?na^IOoWin?oginKOo/hl[oSgIU
ooooooodm>coooooooCdm?odhl[oKFDRooooo`?om?Cd01ook>cSofE<6Ooo
oooohm:aonc/hoolo?Cohm_Kom;:ZOoooooo`K6Oon?B`Ooooooom?C/ooCd
m?oooooo/HMUooooooodm?Com>?:ooCdm?odm>com?Cdooclm?odm?Coo?cd
ooCdm?odm>coo?cdooCdm?olo?Com?C/00?om?Cd00OooooookVOO_o:`Ioo
b/6Yol6iUooSd[7ooooo00;om?Cd00Goo?cdooCdm?odm?Com?Cdooclm002
ooCdm00<ooclm?odm?Com?C/ooCdk?olo?CoooooolZiSonGSgKok=^aooC/
foolo?Com>cK0_olo?BTonk^kP00F_ooool03om<KHOoKGj?oeAfUomDMYOo
MYNaohNGZOmfUk7oIHNYoinYZOnG^L[oIC88od@A0?o/k>?om?C/ogiUE002
oiN?MP05oin7KOmnKFGoUhmfon?Kfoo/fl400_oSd/404Oo/k>?oOWIUon?B
/OoSd[7ob/6Oom_1Woo:`Ioob[V?om;:ZOni^JWoC4`jofE<6OoBb/7ok=^a
on?B/Oo/fk7om?Cd00Kom?C/00Wok>cSooCdk?odm>com?CdoooooonOWgko
`KV7om_:WooSd/400_o1^HL00omUG2[o8R8Aob8R4@03obXR6@0<obXA2?nG
OUCoWimnohm]C?o1^IOofk6Yom;:`OoSd/7ob/6OooCSb_nGSgKok>?:0_o1
^Il02_ni^JWo^K6OooCdk?odm>com?Cdol[1ZOoSd[7oQgiDogi]C?mUICX2
ofED<P0<ocXj8_m4>R[oQda4ofEL:_mL>R;oOUa<ofeU8_lR8Q7o`KV7oooo
ooodhl[om?Cd0_odm>`02Oolo?Com?Cdol6iQonOSfgoShM]ohn?IOn?MS[o
IFDjofE<6@02oda48P?o<RXR00?o8R8AobXA2?lR8Q400_lR8Q400olZ4@So
6ATAobXA2002oa4A4@03o`000?lI6A7o6ATA00;o4A4A00Go0000ob8R4Olj
A1Wo:R8Ioc8Z8P02obXR6@0;oaTI6OlR8Q7o:Q48oaTI6OlZ8QWoA3XZobXR
6Om<8PSohm:aom^aWoodk=/00_o/k><01_o/o?Cok>?:oa4A4Oo:`Ioohm:a
oin?K@;o00000_lA4A400olZ8QWo<RXRofEL:P02od@j:P07oeaLC?m<MWko
G6efoeafO_mDKGKoE7inoeafOP02oeA]MP07ocYLM_ljE5co>UALocY4C?lj
A3;o>SXbod@j8P02oa4A4@04oaTI4OlA4A7o:Q48oaTI6@?o6ATA1?lA4A42
oaTR:P05oaTR<_lI8R[o6B8ZoaTR:_lA4A400_lI8S82oaTR:P03oa4A4OlI
8S;o6B8b00;o6B8Z1?lI8S802olI8R[o6B8boaTR<_lI8S;oC288ofED<_l0
003oUgiDokVOO_oK/Ioohm:a00;om>?:01Com?C/ooclm?olo?Coo?cdogi]
C?nYZHood/[1oginKOmnKDcoo?cdoncSb_m]KECoWimnoooooomnIECo^KVY
ooCdk?o1/HooSgi]ogiUE0;oo?cd00Kom?CdooCdk?oooooo/K6?oooooooS
k?@3ooCdk00UohmfE?oooooo`KVGojVYSonGSgKoOWIUoooooonYZHoom?C/
on?B`Om]KECoKGIfoginKOoBb/7oUgiDooooooodm?Cob/6Yooooooodm>co
ID`Iooooooodm?Com?C/ooCdm?olo?CoID`Iooooooodm>co`K6iooooooo/
fl7om?C/ooooooo/fl7ohm;1ooclm002ooCdm0;oo?cd00[om?Cdooclm?od
m?Coo?cdooCdm?olo?Com?C/ooclm?odm?Com?C/0_olo?@00oodm>coo?cd
ooCdm002ooclm008ooCdk?oooooo`KVGol[1WooB/Hoob[V?om^aWoolo?@2
ooCdm004ooclm?odm?Coo?cdooclm0;om?Cd00?oo?cdooCdm?odm>`00_ol
o?@01_odm>coo?cdom_1Won?Qfgom>?:ooclm0;om>cK0_olo?BTooooo`00
F_o^k^h01Om<KHOoG7jGoeAfUom]OXooQina00;oQiNY00OoQinaohna`Omn
Shoo0000obXA2?odm>cok>cS00Coo?cd00Co/L[:ocY46OoK/Ioom?Cd0_od
m>`01Oodm?Com?C/on?B/OoSfm_ok>?:00;ohm_K00Oom>cKonc/hoodm>co
o?cdoeaLC?ljA1Wooooo00?om?C/0_odm?@2ooCdk0;om?Cd00coo?cdooCd
m?odm?Com?C/ooooooni^IOo`KV7olZiSon?MS[oShmUokVGE?mUG2X2oaTI
4@0@ob8R4OlZ8QWo8R8Ao`000?oBbZWofk6YolZaZOo1/Iook>?:om_1WooS
d/7ofl6Oon?B/OnOOTcohm_Kok6iU`;o`KVO00Ko^ImnoncK/Oo/fl7om>?:
om^aWooSd/42ogInG00AofEU>_mLG4coC4`jod@j:_m4A2[oIFDjoiMnE?mU
IC[o<RXRodA4:_lR8Q7o`KV7oncSb_oSd/7oflZOol6iWoo1^IL00_o1^HL0
1_nGOUCoIE`IohMU<_mL>R;oIE`Zoda48P;o<RXR00?o8R8AobXA2?lI6A40
0_lI6A401?lA4A7o:Q48oaTI4OlA4A42oaTI6@07oa4A4OlI6A7o0000oa4A
4OlI6A7o:R8IoaTI4@02obXR6@03od@Z8_lb:R;o>T@b00;o:R8I0olR8Q40
2OlI6AWo8R8AoaTI6OlZ8QWo<RXRofDb2?olo?Cohm;1ooCdm003onc/h`0@
ooC/fon?MTCo`KV7on?B/OoBbZWoShmUohMU<_mUG2[o4A4Aoc8Z8_lR8Q7o
A4@Zod@Z8_lb:R;oC4`jodA4C0;o>UAL00?oA4A<ob9<E?m4A4`00_mLG4`0
2?m]MWKoOWi]oiN?M_nGSgKoSiN?oinOSoni^IOo4A4A1Olb:R800olZ8QWo
6B8Zoa4A4@04oaTR:P03oaTR<_lI8R[o6B8R00;o6B8Z00Co6B8boaTR:_lI
8R[o6B8Z0olI8S804OlI8R[o6B8boaTR:_lI8R;o<RXRod@Z8_n7E2[oSea<
okVOO_o1^HOofk6OoncK`Oodk=_ooooood`R2?o^k^koo?cd00;om?C/01;o
m>cKonc/hoodk=_om>cKonc/hoolo?CoShM]ogifIOmnMUCoSgIUon?B/Ood
m?Cok>cSom^aWonGSgKoo?cdom;:`Om]IB82ooooo`0HokViUoodm>com?Cd
onc/hooSd/7om?Cdooclm?nOQfgoooooonc/hoodm>cooooookVOO_m]KECo
oooooncK`Oo/hl[oooooogifIOoooooo`K6?ooCdk?ni^JWoMWiL0_m]Qgh0
2Oni^JWoWhM]ooooooooooooID`Iooooooolo?CoIE@booooo`03ooCdk008
ooclm?nOOTcoo?cdooclm?o/hl[ok>cSooooooolo?@2ooCdm008ooclm?od
m?Coo?cdooclm?odm?Coo?cdooCdm?olo?@2ooCdm007ooclm?odm>com?Cd
ooclm?odm>coo?cdooCdk002ooCdm0;om?C/0oodm?@01ooooooofl6Ool6a
Soo:`Ioo`KVGol[1Woooool00_olo?@00oodm?Coo?cdooCdm003ooclm00=
ooCdm?olo?Coo?cdooCdm?olo?Com?Cdooclm?o/fk7o/K6?ooclm?odk=_o
o?cdooC/f`02ooclm:Cok^k^001JonKViP05oeAfUomUQjWoKGj?ofF7ZOn7
UjT00on7Wk401?n?/L7o8R8AohmLC?nGSgH2ooCdk0;ok>cS00_om?Cdom;:
ZOoBbZWoSgIUoin?KOodk=_ohm_Konc/hoo/hl[ok>cSooC/f`02ooCdk003
onc/hoodm>cok>cS00;om?C/00Gom?Cdon?Kfom<C4CoUgiDooC/f`02ooCd
k0Com?Cd00?oo?cdooCdm?odm?@00oodm?@01ooooooo`KVGooCSb_o/fk7o
k=_1om;:ZOoK`Il00_niWgh03?lZ4@So<RXRobXR6Olb:R;o6ATAokVOO_o1
^HOo^KVGokVOO_olo?Com>cKooCdk0;om?Cd01[ok>?:ooC/foni^Hoo^K6O
ol6iWonOWgkom>?:onc/hoodk=_od/[1oncK`On?SfGoMWiLofEU>_mLG4co
C4`joda48_m4>R[o>SXRoc8Z8_lR8Q7oShmUofED<_ljA1WoQgiDogifE0;o
IFDj01?oKFDRoda48_m4>R;o>SXRocY46Om4>R;oKFeDogInG?mnMVGoShmU
ohmfE?mnKDcoSfe<oin7KOn?QeCoQgiDohM<A?mnKDcoIFDj00;oIE@b00Co
G3XRod@Z8_lb:R;o6ATA0_lA4A402OlR8Q7o:R8IobXR6OlZ8QWo6ATAod@Z
8_lj>R;o<RXRobXR6@03ob8R4@09oaTI4OlR8Q7o:Q48ob8R4Olb:R;o8R8A
okVOO_olo?Cok>?:00?ok>cS00Gom?C/onc/hoolo?Cok=^aom;:Z@02ol[1
W`03okVaWomnKDco000000;o<RXR00goIFDjofEL:_m<C3[oC4`joda<A?mD
KGKoG6efoeafO_m]MWKoOXn?oinOSon?Uhoo/KVG00?o^KVY0_o:`JT02?o/
hl[o>T@Iod@j:_m4>R[oA4@bocXj<_m<A2;o>SXb1?lI8RX7oaTR<P0=oaTR
:_lA4A7o6B8bob8Z:_lb:R;oG3XRohMD:_naQfGo^Imnom^aWooBbZWom>?:
ooC/f`02ooclm0Com?C/00Gom>cKoooooomUC1Wo^Imnooclm002onc/h`04
ooCdk?o/k>?om?C/ooCdk0;om?Cd00?ok>?:oncK`Oodm>`00_olo?@03_od
m>cohncdooclm?o1/IooooooooCdm?n?MUCoooooooclm?nOQfgoo?cdon?/
m?ooooooUgiD0_ooool07?n?SfGoooooooCdk?odm>coo?cdoinOO_mnKFGo
o?cdonc/hooVi^Kod/[1oeaLC?odm>coo?cdoooooonOWgkoMWiLoff7O_m]
MWKoZJV?okViUoolo?Com?CdooCSb_odm?Coo?cdokVGE?odm>`2ooCdm005
ooclm?odm?Coo?cdooclm?odm?@00_olo?@2ooCdm009ooclm?odm?Com?Cd
ooclm?odm?Coo?cdooCdm?olo?Com?Cd00;oo?cd00Com?CdooCdk?odm?Co
o?cd0_odm>`4ooC/f`03ooCSb_odk=_oo?cd00;om?Cd00WooooooncK`Oo1
^HOod/ZYol6iUoo1^HOoo?cdooCdk?odm?@00_olo?@00oodm?Coo?cdooCd
m002ooclm009ooCdk?olo?Com?Cdooclm?odm>coo?cdooC/fonOSfgoo?cd
00;om>cK00?oo?cdooC/foolo?@0Y?oVi^H005[ok^k^00KoE7JGofenSomL
OYOoQiNYogJG/On7UjT2ohNO/@03ok6a^Oo/fk7ok>?:00;ohm_K00Sok>cS
on?/m?odm>com?Cdol6iUoodk=_oZJV?ok67I@;om?C/00?om?CdoncSb_od
m?@00_o/k><01_odk=_om?C/ooCdk?odk=_om?C/onc/h`;om?C/00Co/K6i
om;:`On?KDcom>cK0_odm?@01_olo?Com?CdooCdm?odm>com?CdooCdk0?o
m?Cd013oo?cdom;:`OoSd[7ohm:aoncK`OoSd[7ohm:OoncK/OnOOTcoKFDR
ocXj8_lb:R;o>SXRob8R4OnaQfGob[6Y0_o1^IL08Oolo?Cohm_KooCdk?o/
k>?om?C/on?Kfoo/k>?o`KVGon?B/Oni^JWo`KV7on?Kfoo/fl7ohm:aom;:
`Oo/hl[oUhmfofEU>_m]KECoIE@boda<>_m4A3;oA3XRod@j:_m4:R;o8R8A
ogiLC?n?QfgoMWiLoc8Z8_lZ4@So<RXRobXA2002ob8R4@08obXR6Ol0003o
Wgi<oimnC?mUIC[o>T@Iob8R4Ol00003oa4A4@;o000000Ko:Q48oaTI6OlR
<R[o6ATAocXj8_m4>R83ofEU>P04ofED<_l0003o0000oaTI6@?o:R8I00Co
:Q48oc8Z8_m4>R[o:R8I0_lR8Q43oaTI4@09ob8R4OlI6A7o6ATIoaTI6OmU
<PSob[6YooCdk?odhl[ok>cS00;om?C/00Cok>cSooCdk?ooooook=^a0_oS
d[403?nOUhOoSgHjo`000?lI6A7oA3XRogInG?m<A2;oG5a<ofEU>_m]KECo
OVeUofenS`;oSiN?00KoZJV?ok6iWoni^JWob/6Yon?B/OoBbZT3on?B`@09
oncSb_odk=_oIE`Ioda<A?mLG4coC4a4odA4<_lj>S;oA4@Z00;o6B8b00oo
6B9<oaTR<_lA4A7o6B8boa4A4Olb:R;oG3XRobXR6OniOUCoUhmfom:aSooS
d[7ok=^aooCSb_odm>`00oolo?@2ooCdk003onc/hoodk=_ok>cS00;ok>cS
00Som?C/onc/hoodm>cok>cSoooooon?QeCoWimnooclm0Som?C/0oodm?@4
ooCdk00<ooCdm?nGSgKoooooon?B/OniWgkoooooooCdm?niWgkoo?cdonc/
hoooooooWhM]0_ooool03OnOQfgoooooooCdk?odm>cooooooiN?M_m]KECo
o?cdom;:ZOmUE3;oG5a<ofEL:_ni^JT00_ooool03?mfOUcoKGIfoginKOm]
QgkoShM]on?B/Oo/k>?om?C/ooclm?odm>com?Cdooooo`;om?C/00Coo?cd
ooCdm?odm?Coo?cd0_odm?@01_olo?Com?Cdooclm?olo?Com?Cdooclm0;o
m?Cd00Coo?cdooCdm?olo?Com?Cd0_olo?@00oodm?Coo?cdooCdk002ooC/
f`?om?C/0oooool02oodm>com>cKooCdm?odm?Com?C/ooclm?odk=_oUhmf
ol[1Woo1^Ioo`KV700?oo?cd00Com?Cdooclm?odm?Com?C/0_olo?@00ood
m?Coo?cdooCdm002ooclm006ooCdm?olo?Com?C/okVOO_odk=_oo?cd0_od
k=/2ooclm:Cok^k^001Jooooo`04oeAfUomUQjWoQgj?ohNGZ@;oQina00Ko
QiNYoinYZOoSd/7om?C/oncSb_odm?@2onc/h`05ooCdk?o/k>?om?CdokVi
ZOnY`LX00_nid]/02?odk=_om?C/ooCdk?o/k>?om?CdoncSb_odm>com?Cd
0_odm>`00oodm?Com?C/ooCdm003ooooo`;oo?cd00?ofl6OooCdm?olo?@0
0_odm?@01?olo?Com?CdooCdm?odm>`3ooCdm003onclm?oSd/7ohm:a00;o
k=^a00?oflZOon?BWooSd[400_ljA1T09?lR<R[o:R8Ioda48_m4>R[oSgID
okViSoni/Ioo^KVGom:aSoo/hl[om?Cdonc/hoodm?Com?C/ooCSb_mUIC[o
KFeDogifIOmnIECo^KVGok6iUoni^JWob/6OooCSb_o:`JWoIFDjofe]E?m<
C3[oC4a4odA4<_m4>R;oA4@bod@j8_lj>R;o<RXRob8R4@Go<RXR00WoA3XZ
od@Z8_ljA1Wo<RXRoin?KOni^IOoWiN7ofEU>_m4A2X00olj>R801om4:R;o
>T@Ioc8Z8_lb:R;o:R8Ioa4A4OlZ4@P00olA4A42o`000008oaTI4OlZ4@So
4A4Aob8R4OlR:R[o6ATAoaTI6OlI6A42oc8Z8P07obXR6OlI6A7o6ATAoa4A
4OlZ4@So4A4AoaTI4@03ob8R4@0PofEU>_oSd[7om?C/on?Kfoodm>cok>cS
ooC/foo/hl[om>cKofEL:_n?KDcom>cKoncK/On7IC;o0000obXR6Olj>R;o
C4@RojVYSomUG2[oC4`jodA4:_mfOUcoOVEDok6iZOo1/KWo^KVYom;:ZOoB
b/7ok=_1on?B`OodhlX2oncSbP07on?B/OoBbZWod/ZYol[1Won?QeCoIE`Z
ohMU<P02ohmf>P;oQfDb00_oID`IofEL:_n?MTCo/HMUokVOO_oK/Iook=^a
ooC/foolo?CoShM]ooooo`04ooCdk0Cok>cS00?om?C/onc/hoodm?@00_od
m>`00oodm?Com?C/ooCdk002ooCdk007ooCdm?odm>cooooooinOO_n?MUCo
o?cdooCdm003ooCdk003ooCdm?odm>com?Cd00;om?Cd1?odm>`03_odm?Co
m?C/oooooonOQfgoooooooCdm?oooooom?Cdooclm?o1^IOok>cSooCdm?oo
ooooUhmf0_ooool01onOQfgoooooooCdm?odm?Coo?cdoinOO_m]KE@00_o/
k><03?o/fl7om?C/onc/homLG4cob]_Kooclm?mLG4coOWi]oea]M_m]Qgko
OWi]ooooo`;om?Cd00Gom?C/ooCdm?odm>com?Cdooclm003ooCdm004oocl
m?odm?Com?Cdooclm0;om?Cd00_oo?cdooCdm?odm?Coo?cdooCdm?olo?Co
m?Cdooclm?odm?Coo?cdooCdm002ooclm003ooCdm?olo?Cooooo00?ooooo
00ooo?cdoncSb_o:`JWom>?:ooclm?o/hl[oooooooCdm?olo?Com?C/oocl
m?niUfgo^Imnok67IOnOSfd00_olo?@00oodm>com?Cdooclm003ooclm00@
ooCdm?olo?Com?C/ooCdm?olo?Com?Cdooclm?odm?Com?C/okVOO_o/hl[o
m?C/ooC/foolo?Com>cKooclm:Cooooo001Jonk^kP03oeanUon7UjWoQiNY
00?oQiNY00KoQinaok6a^Oni^IOod/ZYom_1Woodm>`4onc/h`0=ooCdk?o:
`JWo^M_dooooooo:fm_ohm_KooCdm?o/k>?om?C/ooCdm?odk=_ok>cSooCd
m004ooCdk004ooC/fooddWkom=9nooCBOP;om?C/00?ok>cSooCdk?odm?@0
1?odm?@04Oo/hl[om>?:ooCdm?odm?Com?C/ooooooo/hl[ohm:Oon?B/OoS
dYooflZOon?BWooK`Ioo`KV7oin7KOmUC1Wo4A4A00;o8R8A00KoQfDbom;:
`OoSd/7oWiN7okViUooK/Il2oncSbP03on?Kfoolo?Co^K6O00;o>T@I013o
ID`Iol6iUoo:`Ioo`KV7okVOO_n?SfGoC4@Ron?KfonGShOoC4`jofED<_mL
G4coA4@bod@Z8_m4>R[oA2XR0_lj>R805Olb:R;o>SXRod@Z8_lb:R;o>T@I
od@Z8_m4>R;oA4@bocXj8_m4>R[oG3XRoinGQonGSgKoIFDjodA4:_mL>R;o
A3XZofEL:_m4A2[oA3XZodA4:P02od@j:P03od@Z8_lZ8QWo:R8I00;o8R8A
00So:R8Iob8R4OlR8Q7o:R8Iob8R4OlI8R;o:R8Ioc8Z8P;o8R8A00Ko<RXR
obXR6OlZ4@So6ATAobXA2?lI6A43ob8R4@08oaTI6OlZ8QWo6ATIofE<6OoS
d[7om?C/ooC/foo/k><2oncSbP0BooC/foolo?CoSfe<oimnC?olo?Cohm:a
ocY46OmU<PSoA3XRoc8Z8_mUG2[ohm:aofeU8_m4>R;oA4A<ofED<_m]KECo
k=_11?oBbZT01oo:`Ioofl6Ool6iUooSdYoofl6Oon?BWooSd/400_o/hlX0
0oodhl[om?C/ooclm004ooclm003ooCdk?olo?Coo?cd00;oo?cd00_om?Cd
ooCdk?odm>coo?cdohn7KOolo?Cok>cSooCdk?o/k>?om?C/onclm006ooCd
k006ooCdm?odm>com?C/ooCdm?odm>com?Cd0_odm>`01Oodm?Coo?cdol[1
ZOn7IC;oo?cd00;om?Cd00?om?C/ooCdm?odm>`00_odm?@00oodm>com?Cd
ooCdm002ooCdm008ooCdk?odm?Cok?cdoooooonaQfGoooooooCdm?o:`Il2
ooCdm009om;:`Oo/hl[om?Cdooooooni^Hoom?CdoooooonOWgkoo?cd00;o
m?C/00Soo?cdon?Kfom]KECo/L[:ooCdk?oSfm_o/L[:oinOS`?oIFDj00Go
G6efogifIOmnMVGoKHMnoginK@02ooclm003ooCdm?olo?Com?Cd00;oo?cd
00Com?C/ooclm?olo?Com?C/1?olo?@01?odm?Coo?cdooclm?odm?@4oocl
m004ooCdm?olo?Com?Cdooclm0?om?Cd0oolo?@01?nGSgKoWimnoooooooS
dYl2ocY46@03okVaWoooooook=^a00?om?Cd00Koo?cdooCdm?oooooooooo
ooclm?odm>`2ooCdm0?oo?cd00Gom?Cdooclm?odm?Coo?cdooCdm002oocl
m003ooCdm?olo?Com?Cd00;oo?cd00Oo^ImnoncSb_olo?Coo?cdooC/fool
o?Com>cK0:Cok^k^001JonKViP03ofenSomUQjWoQiNY00CoQina00GoQiNY
od@A0?mUC1Wo^IM]ooCdk002onc/h`0?ooCdm?o/k>?om?Cdol[1ZOnY`L[o
^M;Kok6a^Oodhl[oflZOooclm?o1^IOom?C/oncK`Oodm>com?Cd00Com?C/
00Gom>?:onc1QooSdYoom?Cdonc/h`03ooCdk0;om?Cd00Com?C/ooCdm?od
m>cok>cS1Oodm?@01OoSfm_ohm:Oon?BWooSd[7oWhm]00;ob/6O01Cok=_1
ooCdk?oBb/7oKFeDofEU>_lj>R;oG3XRol6aWooVi^Kod/ZYon?B`Oo/k>?o
m?C/oncK/Oodm>co`KVGon?B/Om<A2;oC288ocY46@;o:Q480_lb:R801Olj
A1Wo<RXRohmf>_n?QfgoG5a<00;oC4a400OoA4@Zod@j:_m4>R[oA3XRod@Z
8_m4A2[oA2XR00?o>SXR00coA2XRoc8Z8_m4>R[oA3XRod@j:_ljA1WoG5a<
ofEU>_nGSgKoIFDjodA4:_m4>RX2odA4:P06odA4<_mUG2[oA4@Zoda<>_m4
>R[oA3XR0_lb:R82obXR6@03ob8Z:_lZ8QWo<RXR00?o:R8I00Go8R8Aob8Z
:_lZ8QWo6ATIobXA2002ob8R4@;o6ATA00?o6ATIobXR6OlR8Q400_lR8Q40
1OlZ8QWo<RXRoa4A4OniWgkoo?cd00;om?Cd00Ook?cdon?KfooSd/7od/[1
om;:ZOo1^HOo`K6?00;o>T@I013o`K6?oinGQon?MS[oA3XRohMU<_mUE3;o
QfDbofE<6OmL>R;oKFDRol6aWoo:`Ioofl6Oon?BWooSd/7ok>?:0_odk=/0
1_o/k>?ok?cdooCdk?o/k>?om>cKooCdk0Kom>cK0_o/k><01?odm>cok>cS
ooCdk?o/k><3ooCdk004ooclm?n?Qfgoo?cdonclm0Oom?C/00Oom?CdooCd
k?odm?Com?C/ooCdm?odm>com?Cd00;om?C/00Oom?CdooCdk?odm?Coo?cd
on?B`OmU<PSoo?cd00;om?Cd00Coo?cdooCdm?odm?Com?C/1?odm?@05?ol
o?Com?CdooCdk?odm?Cok?cdoooooonOWgkoooooooclm?niWgkohm_Koooo
oooSd/7od/[1ooCdm?olo?Co`KVGon?Kfoooooood/ZY0oodm>`03Ooooooo
Win?ogifIOm]KECoIFDjofEL:_mUC1WoC4@Rofe]E?mUIC[oKFeDogInG?m]
KE@00_m]MWH01OmnMVGoo?cdooCdm?odm?Com?C/00;om?Cd1Oodm>`00ood
k=_om>?:ooCdk002ooclm006ooCdm?olo?Coo?cdooCdm?olo?Com?Cd0_ol
o?@00oodm?Coo?cdooCdm002ooclm00@ooCdm?olo?Coo?cdol[1ZOl0003o
KFDRooooooodhl[o4A4AofEU>_nYZHoooooooncK/Oodm>coo?cdooCdm0;o
o?cd00Com?Cdooclm?odm?Com?Cd0_olo?@01?odm?Coo?cdooclm?odm?@3
ooclm005ooCdm?olo?Coo?cdooclm?odm?@00oolo?@01oo:`Ioohm;1ooC/
foodk=_oo?cdooC/foolo?@0Y?oVi^H005[ok^k^00?oKGj?ofF7ZOn7Wk40
0on7Wk401On?/L7oKGIfofe]E?mUC1Wok=^a00Gok>cS00gom?CdoncSb_oS
fm_om>cKon?B`Oodm>cod/[1ooCdk?oBbZWohm_KoncK`Oodm>com?Cd00Co
m?C/00Com?CdoncSb_oBbZWooooo1?odm>`4ooCdm004ooooooo/`HOok=_1
ooCdk0?om?Cd02?om?C/ol6iQoo1^HOok=^aogInG?n?MR[o/HMUon?BWoo/
k>?om>?:oginKOn?UhooIFDjoeaLC?oBbZWok>?:om_1Woo/hl[ohm;1ooCd
m?o1^IOoo?cdooCdm?odk=_od/[1on?B/OoSd/7o^ImnoiN?M_mUC1Wo<RXR
obXA2?ljA1Wo:Q48od@j8P02oda<>P09ofEL:_m4A2[oA3XRod@Z8_m4>R;o
>SXRod@Z8_ljA1WoA3XR00;o>SXR00[o>T@Iod@Z8_m4>R;oA3XRoda48_lj
>R;oIE@boinGQomnMUCoKFeD0om4A2X01?m4A3;oG3XRodA4:_m<C3X2odA4
:P04odA4<_ljA1Wo<RXRocY46@Co<RXR00Co:R8Iob8R4OlI6AWo4A4A0_lI
6A403OljA1WoA4@bod@Z8_m4>R;oA3XZod@Z8_m4>R[o>SXRoc8Z8_lj>R;o
<RXRod@Z8_m<8PP00_m44@006On?MS[o/HMUokVGE?niUfgok:UfokVOO_o:
`Ioohm:aon?B`Oodk=_ok=_1ohn?IOoBb/7ohm;1okVOO_n?MUCob/6Yok6i
Uona/Hoo`KVGoiMnE?n?SfGod/ZYooCdk?o/k><00_odm>`00oodk=_ok>cS
ooCdk003ooC/f`;om?C/00?om>cKooCdk?o/k><00oodm>`01Oodm?Com?C/
ooCdk?odm>com?Cd00Gom?C/00?oo?cdoinOO_odm>`00_odm>`00oodm?Co
m?C/ooCdm004ooCdk009ooclm?odm>com?CdooCdk?odm?Com?C/ooCdm?ol
o?Com?C/00?om?Cd00Gom>cKod@A0?odm>com?Cdooclm002ooCdm003ooCd
k?odm?Coo?cd00;om?Cd01;oo?cdooCdk?odm?Coo?cdooCdk?o/o?Cooooo
okVOO_olo?Com?C/onc/hoodm?Com?C/onc/hoo/fl7oo?cdooCdk?olo?@2
ooCdk009ooclm?odm?Com?CdooCdm?ooooooShmUogifIOm]KECoKFDR00?o
KFeD00_oIFDjofe]E?m]KECoMWiLoea]M_mfOUcoKHMnogInG?odk=_oo?cd
ooCdk002ooC/f`05oncSb_odk=_om>cKonc/hoodm>`00_odm?@00oodk=_o
m?C/ooclm002ooCdm006ooclm?odm?Coo?cdooCdm?olo?Com?Cd0oolo?@0
0oodm?Coo?cdooCdm002ooCdm004ooclm?n?MR[o4A4AofE<6@;oo?cd0_lj
A1T01?nGSgKooooooncK/Oodm>`2ooCdm009ooclm?odm?Coo?cdooclm?od
m?Coo?cdooCdm?olo?Com?C/00?oo?cd00Com?Cdooclm?odm?Coo?cd0ood
m?@01?olo?Com?CdooCdm?olo?@2on?B/@03ooclm?odk=_om>cK00;oo?cd
Y?o^k^h005[ooooo02;oIHNYohNGZOn7Wk7oQiNYohNO/On7UjWoOYnioeaL
C?na/KWo`KVOokVaWoodm>cok>cSooCdk?o/k>?om?C/onc/hoo/hl[om?C/
ooCdm?odm>cok>cSooCdm?o/k>?om?CdooCdk?o/k>?om?C/oncSb_odm>co
k=^aooCdk?o/fk7ok>cS0_odk=/01Oodm?Com?C/ooCdk?oSdYooo?cd00;o
m?Cd00?oo?cdooCdm?odm?@00oodm?@05?olo?Com?CdooCdm?odm?Cob[V?
om_:Woo:`IooIFDjocY46Om4>R;oflZOoncK/Oo/k>?o/KVGogInG?m]KECo
OVeUom;:ZOo/hl[od/[10_oSd/401Oo/hl[ofim]oooooooSk?Com>?:00;o
oooo00com?Cdoooooooooooom?C/oncSb_nGSgKoIFDjofEL:_m4:R;oC288
ocY46Olb:R82od@Z8P05oda48_lb:R;oA2XRod@Z8_ljA1T00_m4:R806?m4
>R;o>SXRod@j8_lb:R;oA2XRob8R4OlZ8QWoG3XRohn?IOmUC1WoSgHZoda4
8_lj>R;oA3XRoda48_mUG2[oA4@bofED<_m4>R[oA4@ZodA4<_lj>R;o<RXR
odA4:P;o<RXR00GoC288ocXj8_lZ8QWo<RXRoaTR8P02oa4A4@03oaTR8_lA
4A7o6B8R00;o:R8I0_lb:R803Om4:R;oA3XZoda<>_m4A2[oA3XRodA4:_oS
d[7od/ZYol6aSoolo?Com?C/ooclm?ooool00_odm?@00oolo?CoooooooCd
m002ooCdm00@ooCSb_oSd[7ob[V?ol6iUoodk=_o`KVGol6iQoni^Hoob[6Y
ofEU>_nOWhoo`KV7ooclm?o/k>?om>cKonc/h`?om?C/00?ok>cSooCdk?od
m>`00oodm>`01Oodm?Com?C/ooCdk?odm>com?Cd00Com?C/0_odm?@01ood
m>com?CdooCdm?odm>cooooook6iUoodk=/00_odm?@01Oodm>com?CdooCd
m?odm?Com?C/00Kom?Cd00coo?cdooCdm?odm?Com?C/ooCdm?olo?Com?C/
ooCdm?olo?Co<RXRoncK`Oooool:ooCdm006ooclm?odm?Coo?cdonclm?ol
o?Cok=^a0_odm?@01?odm>coo?cdooCdm?olo?@3ooCdm004ooclm?odm>co
m?Cdooclm0?om?Cd00Goo?cdoinOO_mfOUcoOWIDofe]E003ofEU>P?oKFeD
00[oOWIUoginKOm]QgkoKHMnoginKOo/hl[oooooooC/foolo?Com?Cd0_oo
ool01Oodm?Coooooooooooodm?Cooooo00;om?C/2_olo?@00oodm?Coo?cd
ooCdm004ooclm00=ooooooniUfgo4A4AocY46Oo/hl[ooooood@j8_lA4A7o
SgHjooooooo/fl7om>cKooooo`03ooCdm0;oo?cd00Com?Cdooclm?olo?Co
m?Cd0_olo?@00oodm?Coo?cdooclm009ooclm003ooCdm?o/fl7ob/6Y00Co
o?cd00?om>cKooooooooool0X_ooool005[ok^k^00coIHNYohNGZOn7Wk7o
MYNaohNGZOn7Wk7oC7InoeanUon?MVGob/6YokVOO_odhlX4onc/h`04ooCd
k?oSfm_ok>cSonc/h`Kom?C/00?ok>cSooC/foodm>`03?odm>`3ooCdm003
ooclm?odm?Com?Cd00Gom?Cd01Wok?cdom_:WooBbZWohm:Ool6iWom<A2;o
>T@IoinOO_n?Qfgo`K6Oonc/hom]KECoMWiLofefM_oK`Iood/[1oncSb_oS
d/7ob/6Oon?B`Oo/fk7om?CdooCdk?o/hl[ok>cS00;om?C/00oohncdooCd
k?odm>cooooooncSb_mLKGKoSiN?okVOO_nGSgKoA4@bod@Z8_lR8Q7o4A4A
oaTI4OlR8Q400_lb:R801Om4:R;o>SXRocY46Om4:R;o>T@I00;oA2XR00Ko
<RXRocY46OlZ8QWoC288ok67IOna/Hl2ofE<6@0;obXA2?m4:R;o8R8Aoc8Z
8_m4>R;oA2XRoda48_m4A2[oA3XRoda48_lj>R800_lb:R801oljA1Wo<RXR
od@Z8_lb:R;o8RXZoa4A4OlI8S800olA4A401olI6AWo:Q48o`000?lA4A7o
:Q48ob8R4OlZ8QT00_lR8Q401olb:R;o6ATIofEL:_o1^IOo`KV7oooooood
m>`00_o/k><00oodm>cok>cSooCdk002oncSbP04onc/hoodk=_ok>?:om;:
Z@;ob/6O00[ohm:aol6iUonYZHoo`K6?okViSonYZHooUhmfoin7KOolo?Co
k>cS2_odm>`00oodm?Com?C/ooCdm004ooCdk0?om?Cd0oodm>`02?odm?Co
m?C/ooCdm?olo?Co^K6OoncSb_odm?Com?C/1?odm?@01_olo?Com?C/ooCd
m?olo?Com?Cdooclm0?om?Cd00?oo?cdooCdm?odm?@00_odm?@01Oodm>co
ooooobXA2?oSd[7oo?cd00?om?Cd00Woo?cdooCdm?odm?Coo?cdooCdm?ol
o?Com?C/ooCdm?olo?@01Oodm?@00oolo?Com?CdooCdm002ooCdm005oocl
m?odm?Coo?cdooCdm?olo?@00oodm?@01_odm>com?Cdooooooo1/HooOWi]
ogInG0;oIFDj0_m]KE@00omUIC[oKFeDogInG002ofe]E0;oKHMn00CoOWIU
om;:`Ooooooom?Cd0_odm>`04_odk=_om?C/ooC/foodk=_ok=^aon?BWood
m>cok>cSooC/foodm?Coo?cdooCdm?olo?Com?Cdooclm?odm?Coo?cdooCd
m0;oo?cd00?om?Cdooclm?olo?@00oodm?@03Oolo?Cofk6Ooa4A4Om<8PSo
d/[1oooooonGQ`3o6ATIofeU8_ooooook=^aoncSb_ooool01?olo?@01?od
m?Coo?cdooclm?odm?@4ooclm004ooCdm?olo?Coo?cdooclm0;om?Cd00Wo
o?cdooCdm?odm?Coo?cdooCdm?olo?Com>cKok6aSoolo?@00oodk=/00ool
o?Cok^k^onk^kP2Ronk^kP00F_oVi^H04omUQjWoMYNaohNGZOn7UjWoMYNa
ogjO^Om<C4Co<RXRod`R2?mUC1WoA140om^aZOodm?Cok>cSooCdk?o/k>?o
m?C/onc/hoodk=/01?o/k><01Oodm>cok>cSooCdk?odm>com>cK00gom?C/
00Ooo?cdooCdm?odm?Com?Cdooclm?odm?Coo?cd00Com?Cd00SoooooolZi
SooKbYooflZOon?BWon7OUCo>T@Ioe`j8P;oIFDj00_ooooooeaLC?m]Qgko
Uhmfom;:`OoK`Ioo^KV?on?B`Oo1/Iook>?:om^aW`02ooCdm00aoncSb_od
m>com?CdooCdm?odm>com?Cdonc/hooooooo^KVYoff7O_ljE5coIFDjofef
M_mDOWkoC6f7ocYDG?ljA4co<RXRobXR6OlA4A7o:Q48oa4A4OlZ4@So<RXR
obXA2?lb:R;oA2XRoc8Z8_m4:R;o<RXRod@Z8_lb:R;oUgiDoda48_lI6A7o
G3XRob8R4Olb:R;o>T@Iod@Z8_lb:R;o>T@Ioc8Z8_m4:R;o:R8IocXj8_m4
:R;o>SXRod@j8P04oc8Z8P0?obXR6OlA4A7o4A4Aoa4A4OlR<TCo6B8bodA4
C?m<C3[o6B8boaTR:_lb>TCo4A4Aob8Z:_lZ4@So6ATI00;o6ATA00Ko8R8A
o`000?nOQfgok=^aooCdk?o/k><2ooCdk003ooC/foodm>com>cK00?om?C/
00Kom>cKom:aSoo:`Ioo`KVGokViUoo:`Il2ok6aS`05ol6iUona/Hoo^Imn
ol6iQoolo?@01?odm>`00oolo?Com?C/ooCdk003ooCdk004ooCdm?odm>co
m?CdooCdk0;om?Cd00[oo?cdooCdm?odm>com?CdooCdk?olo?Com?CdooCd
k?odm?Coo?cd0_odm?@00ooBb/7ohm;1ooCdm004ooCdm005ooCdk?odm?Co
o?cdooCdm?odm>`00_odm?@03oolo?Com?CdooCdm?odm?Coo?cdooCdm?ol
o?Com?Cdooclm?oooooo<RXRol6iUooooooom?Cdooclm002ooCdm003oocl
m?odm?Com?Cd00;om?Cd00Goo?cdooCdm?odm>coo?cdonclm002ooclm008
ooCdk?odm?Coo?cdooCdm?olo?Com?C/ooclm?odm>`3ooCdm003ooclm?od
m?Coo?cd00;om?Cd00Coooooom;:ZOn?SfGoOWIU0omUICX01omUE3;oG5a<
ofEU>_mUG2[o8S8ZocY4<_m<C3X00_mLG4`01_nOWgkoo?cdooC/foodhl[o
k=_1ooC/f`;om>?:0_odk=/2ooCdk004ooclm?odm?Coo?cdooCdm0Ooo?cd
00Com?Cdooclm?olo?Com?Cd0oolo?@03Oodm?CooooooncK/Ol0003o>T@I
okVaWoooooooKFDRoa4A4Om]IB;oooooooC/foo/fl400oodm?@2ooclm005
ooCdm?olo?Coo?cdooclm?odm?@00oolo?@00oodm?Coo?cdooclm002oocl
m006ooCdm?olo?Coo?cdooclm?odm?Coo?cd0_odm>`01_o1^HOom>cKoocl
m?olo?Com>cKooclm:Coi^KV001Jonk^kP;oQiNY00GoIHNYogJG/Om]Sk7o
>VF7od`R2002oc8Z8P07oa4A4OlZ4@Sob[V?ooooooo/k>?ohncdooCdk002
onc/h`04on?Kfoodm>cok>cSooC/f`;ok>cS0_odm>`00oodhl[om>cKonc/
h`0=ooCdk0_om?Cd00God/ZYom_:WooSdYoob/6OokViS`02ob8R4@0@ohn7
KOmnOVgoUhmfofEU>_mfOUcoUhmfom_1WooBb/7ob/6Oon?B/OnYZHood/[1
oncK/Oodm?Com>cKon?B/@?om?C/00Gok?cdooCdk?odm>coo?cdokVaW`02
oea]MP06oinOO_na^JWoE6efodafO_m<KHOoE6ef0_m<MWh01OmLG4co>UAL
odA4C?lj>S;o6B8R00;o6ATA00go0000od@Z8_lb:R;oA2XRocY46OlZ8QWo
ShmUofE<6OlI6A7o8R8AocY46OlZ4@So<RXR00;oA2XR0_ljA1T2oc8Z8P04
od@Z8_lj>R;o>SXRoc8Z8P;oA2XR00?o<RXRobXR6OlZ8QT00_lZ8QT05_lI
8R;o>TA<oda<>_lR>Uco6B9<oaTI6OljA1Wo>VFGo`000?m<E6go8S8Zoc8j
A?lZ8QWoG5a<oaTR8_lbA7KoG7Inom^aZOodm>cok>cSooCdk?o/k><2ooCd
k00:onc/hoodm>com?C/onc/hoodm>cod[6?ol[1WoniWgkoShmUol6iQ`;o
Wimn00Go/K6?oiN?M_o1^HOoShMDooclm00;ooCdk003ooCdm?odm>com?Cd
00?om?C/00Kom?Cdooclm?odm>coo?cdooCdm?odm>`3ooCdm007ooCdk?od
m?Cohm;1om;:`Oolo?Com?CdooCdk003ooCdm004ooclm?odm?Com?Cdoocl
m0;om?Cd00?oo?cdooCdk?olo?@00oodm?@01oodm>coo?cdooCdm?oooooo
IC88oinOO_ooool00_odm?@01_olo?Com?CdooCdm?olo?Com?Cdooclm0;o
m?Cd00Coo?cdooCdm?odm?Cok?cd0_odm?@00oolo?Com?C/ooclm002ooCd
k0;om?Cd0_odm>`5ooC/f`0;ooCdm?olo?Coo?cdon?B`OmnMUCoKFeDoc8Z
8_lR8Q7oIFDjok6aSoniWgh00_nGSgH02_n?MVGoQgiDohmfE?mnMVGoOWID
ohmfE?odk=_om>?:oncSb_o/k><2ooCdk0?om?Cd00?oo?cdooCdm?odm?@0
1?olo?@00oodm?Coo?cdooCdm002ooclm003ooCdm?olo?Coo?cd00;om?Cd
01Coo?cdooCdm?olo?Com?Cdooooooodhl[o6ATAocY46OnOSfgoooooohmU
4OlI6AWoA3XRooooooodk=_ohm:aooooooodm?Coo?cdooCdm0;oo?cd00?o
m?CdooCdk?olo?@00_olo?@00oodm>coo?cdooclm002ooclm005ooCdm?ol
o?Coo?cdooCdk?odm?@00_olo?@01_odm?Com?C/ooclm?nGSgKoo?cdooC/
f`?oo?cdY?o^k^h005[ooooo0omUQjT01On7Wk7o>VF7obXA2?ljA1Wo:R8I
00;oA2XR00?o4A4AokVOO_olo?@00_o/k><01_odm>cok>cSonc/hoo/hl[o
m?C/onc/h`?om?C/00Kok>cSooCdk?oSfm_om>cKooCdk?o/k><2ooCdk003
ooC/foodm>com?C/00Oom?C/00?oo?cdooCdm?olo?@02?odm?@02OoBbZWo
/HMUol[1Woo:`Iood/ZYocXj8_ljA1WoKFeDoginK@02ogi]I@0=oeaLC?n?
Qfgo`K6iom_1Woo:`JWod/[1okViSomUIC[ofl6Oooclm?oSfm_om>cKonc/
h`02ooCdm0?om?C/00Ooo?cdoinYZOmDOWkoG6efofefM_ni^JWoC5A]00;o
E6ef00?oG7InoeA]M_mDKGH00_m<MWh00oljG7KoE6efoeA]MP02odaDK@0L
ocYDG?m4A3;o<RXRoda48_lj>S;o:Q48ohMU<_oSd[7oOVEDoimnC?lR8Q7o
<RXRocY46Om4>R;o>T@Iod@j:_m4:R;o<RXRocY46Olb:R;oA3XRod@Z8_lj
A1Wo:R8Ioc8Z8_lj>R;o<RXRocY46@?o<RXR01?o>T@bocYDG?lR>UcoC4a4
oaTRC?m4A4co>VFGo`000?ljE5co4A4AoaTR<_ljA4co8S94oc8jA?m<KIOo
C7jaom^aZOodm>cok>cS00?om?C/0_odk=/04Oodm>com>cKooCdk?o/k>?o
flZOol[1WoniWgko`KV7ok6aSonOWgkoWhm]ok6aSonOWgkoWiN7oin?KOod
m>cok>cS00Oom?C/00?oo?cdooCdk?olo?@00oodm>`01Oodm?Coo?cdooCd
m?odm?Com?C/00;om?Cd0_odm>`02?olo?Com?Cdooclm?odm?Coo?cdooC/
foo1/Iooo?cd0oodm?@2ooclm006ooCdk?odm?Com?C/ooclm?odm>coo?cd
0oodm?@02_odm>coo?cdooCdm?olo?Com?C/ooCdm?ooooooIE`IoiMnE?oo
ool2ooclm003ooCdm?olo?Coo?cd00?om?Cd0_olo?@00oodm?Coo?cdoocl
m002ooCdm0;oo?cd00?om?CdooCdk?odm>`00oodk=/3ooCdk004ooCdm?ol
o?Com?CdooCSbP?om?Cd00Oom>cKohn?IOmUIC[oA3XRohmfA?mfOUcok=_1
00;ooooo00?o^KVYom;:`Ona/KT00ooBb/401_oBbZWok>cSooclm?odm?Co
o?cdooCdm0;oo?cd00?om?Cdooclm?odm?@00oolo?@2ooCdm0Soo?cd00Ko
m?Cdooclm?olo?Com?Cdooclm?odm?@3ooclm0;o4A4A00WoSgI4oooooonO
OTcoIC88ohmf:_olo?Com?C/oncK/Oooool00_odm?@2ooclm007ooCdm?ol
o?Coo?cdooclm?odm?Coo?cdooCdm002ooclm005ooCdm?olo?Coo?cdoocl
m?odm?@00_olo?@02?odm?Coo?cdooCdm?olo?Cooooooin?KOodk=_oo?cd
0oodk=^Tooooo`00F_o^k^h2ofF7Z@04ogJG/OmDQk7oA140oc8Z8P;oA2XR
00Go:R8Iod`R2?lR8Q7oWfe<ooclm003onc/h`04ooCdk?o/k>?ok>?:ooCd
m0?om?C/00cok>cSooCdk?o/k>?ok>cSoncSb_odk=_om?C/ooCSb_odm>co
m>cKooCdk?odk=/2ooCdk003ooC/foodm>com?C/00;om?C/1Oodm?@00ool
o?Coooooooclm002ooCdm00HoooooooSd[7om>cKom;:ZOmUC1Wo`KV7ofEL
:_lZ8QWo<RXRocY46Om4A2[oKFeDogInG?nOWhoo^KVYom;:ZOmnMVGoShM]
olZaZOn?SfGofl6Oooclm?odm>com>cK0_odm>`4ooCdm008ooclm?na^IOo
KHMnoeb7SomnOVgob/6YocYLM_mLKGH3oeA]MP03odafO_m]MWKoE7in00Co
E6ef0_m<MWh03oljE5co>T@Ioe`j8_m4A3;o8R8Aogi]C?oSd[7o^K6OofE<
6OlR<R[o:R8Ioc8Z8_n7E2[oC4`jocY46@02od@Z8P;o:R8I00Co<RXRod@j
8_lb:R;o>T@I1?lb:R806?lZ8QWo<RXRoc8Z8_m4>R[oC4a4ocYDQolI8Tco
6ATAo`000?mDQk7oC7jaoaTR8_mLG4co<RXRocY4C?m<C4Co>SXboda]Uolj
IIOofk6OooCdk?o/k>?om?C/ooC/f`Oom?C/00Oohm:aom;:ZOo1/Hoo`KVG
ol6iQoni/IooWiN700;o^KVG00?o`KVGokVOO_odm>`00oodm>`2ooCdm003
ooCdk?olo?Com?Cd00?om?Cd00Coo?cdooCdm?odm?Coo?cd1?odm?@00ool
o?Com?Cdooclm006ooCdm006ooCdk?na^IOoo?cdooCdm?olo?Com?C/0_od
m?@2ooclm0Com?Cd00goo?cdooCdm?olo?Coo?cdooCdm?olo?Com?Cdoocl
m?odm?Coooooohn7E?mUC1Wooooo00;om?Cd00Coo?cdooCdm?odm?Com?Cd
0_olo?@2ooCdm003ooclm?odm?Com?Cd00Oom?Cd00CoooooooCdm?oooooo
m?Cd1?ooool02?odm?Com>cKooCdm?odm?Coo?cdonc/hon?SfGoKFeD0_m<
C3X03OmUIC[ok>?:ohNO/Ona/KWoSiN?oinYZOnGShOoKGj?ol6a^OnOWhoo
Uhn7onc/hoooool00_odm?@01Oolo?Com?CdooCdm?olo?Com?Cd00;oo?cd
0_odm?@01Oooooooo?cdooclm?olo?Com?Cd00;oo?cd00Gom?Cdooclm?ol
o?Coo?cdooCdm003ooclm0;om?Cd00coo?cdoooooon7:P3oUgiDokVOO_oo
oooom>?:om;:ZOo1^IOok>cSooCdm?o/fk42ooCdm005ooclm?odm?Coo?cd
ooclm?odm?@01Oolo?@01Oodm?Coo?cdooclm?olo?Com?Cd00Ooo?cd00Go
m?CdooooooniUfgom>cKooclm002ooC/f`03ooclm?o^k^kok^k^0:;ok^k^
001JonKViP03ofF7ZOm]Sk7oIINa00;o<RXR01;oC288obXR6OlZ8QWoA2XR
oc8Z8_mL>R;oSea<ooooooo/k>?om?Cdonc/hoodm>cok?cdoncSb_odm>co
k>cSooCdk?o/k><2ooCdk004oncSb_oSd[7ohm:aooCSbP;om?Cd00Com?C/
ooCdm?odm>com?Cd0_odm>`01Oolo?Com?C/ooCdk?odm>coo?cd00?om?Cd
00GooooooncSb_oB/Hoo`KV7ooooo`02ooCdm00Eonclm?oSd[7ok=^aooC/
foo/hl[ohm:aohmfA?ljA1Wo6ATAoaTR8_lR8Q7o:R8IodA4<_mUE3;oOWIU
ohn7KOm<C3[oOWi]ol6aWoniWgkohm;100;om?C/0_o/k><00oodm?Com?C/
ooCdm002ooCdk008ooclm?n?UhooKHMnoeafO_m]MWKob[6Yoda]QomLMWh2
oeA]MP04oeAnO_mDKGKoE6efoeafOP;oE6ef00GoG6efoeafO_mDKGKoC7In
ocYDG002ob8R4@0@oda<>_m44@3oID`IokVOO_nOWgkoIC88ohmU4OljA1Wo
:Q48oeaLC?m<C4CoG5a<obXR6Olj>R;o>T@Ioc8Z8P?o>SXR00OoA2XRod@j
8_m4>R[oA2XRobXR6OlI6A7o:R8I00;o<RXR01;o8S8ZohMnSon?UhooOWi]
oeaLC?m]SkWoMYO1ob8bA?lI8R;o>UALoa4A4Olb>TCoA4A<ocYDQolbIJWo
b/6OooCdk?o/k><8ooCdk005ooCdm?oBbZWoflZOol[1Wona/Hl00_niWgh0
1_nOSfgo^KV?okViUoni^HooUhmfooCSbP;om?Cd0_odm>`01Oolo?Com?Cd
ooCdm?odm>coo?cd00?om?Cd0oodm>`2ooCdm0?oo?cd0_odm?@2ooclm006
ooCdm?olo?Com?CdooCdm?olo?CoWiN70_olo?@00oodm?Com?C/ooclm003
ooCdm005ooclm?odm?Coo?cdooCdm?olo?@00oodm?@00oolo?Com?Cdoocl
m002ooCdm005oooooonOWgkoID`Iooooooolo?@00_odm?@2ooclm005ooCd
m?olo?Com?Cdooclm?odm?@00_olo?@2ooCdm0Coo?cd0_ooool03?olo?Co
m?Cdooclm?olo?Cohm:aokViSona/HooUgiDooooooo/hl[oooooooCdm0;o
o?cd01?oWhm]ofe]E?mUIC[oIFDjofEL:_oSd/7oQiNYok6a^OnYZHooWjVY
ofenSonOZJWo/K6ioinYZOmLKHOom?C/ooCdm?olo?Com?Cd00;oo?cd00[o
m?Cdooclm?olo?Coo?cdooCdm?ooooooo?cdooCdm?olo?Com?Cd2_olo?@0
0oodm?Coo?cdooclm002ooCdm00<ooooooo:`IooZJV?ohMnE?oooooo`KVG
o`000?ljA1Wohm;1ooooooo/fk7ooooo0_olo?@00oodm?Coo?cdooclm004
ooclm003ooCdm?olo?Coo?cd00Coo?cd00oom?Cdooclm?olo?Com?Cdoocl
m?odm?Coo?cdooCdm?oooooo^IM]oncSb_odk=_oo?cdooC/foolo?@0Y?oV
i^H005[ok^k^00?oG7jGogJG`OlA4A400_lR8Q402?lZ8QWo8R8Aod@Z8_lZ
8QWo<RXRofDb2?nOKDcooooo1Oo/k><03Oo/hl[o`K6?ooclm?niWgkoo?cd
om:aSoodm?Cok=^aom;:ZOoSfm_om?C/ooCdm?odm>`00_odm?@01?odm>co
o?cdooCdk?olo?@2ooCdm0;om?C/0_odm?@01oolo?Com?CdooCdm?o/k>?o
SgHZohmfA?ooool00oodm?@02Oo/hl[ohm:aoncK/Oo/hl[om>?:ooC/folj
A1WoA4@Zod@j8P02oaTI6@0<oa4A4OlI6A7oOVe<ohn7KOn7OXooKFDRoinO
O_oSd[7ohm_Kon?B`Oodm>com>cK0_odm>`4ooCdm00:ooclm?n?UhooKHMn
oeafO_mnOVgod/ZYoeA]M_m<MWkoE7inoeafOP?oE6ef00?o>Uafoea]M_mD
KGH00omDKGH01OmnKFGo/KVGok67IOo1^IOofk6O00;ohm;101;ok=_1ooCS
b_olo?CoooooofeU8_lR8Q7oIFDjoeaLC?m4A3;o>T@IocXj8_m4A3;o8RXZ
od@Z8_m4>R[oA4@boaTjM_lI8T`5oaTI6@0Eoc8Z8_m4>R[o>T@IocY46Om4
A4coC4`jojVYSomUIC[oG5a<oinOO_mnOVgoKGj?oea]M_mLG4co8SYLoaU4
QolIG;7o^IM]ooCdm?odm>cok>cS00Oom?C/01Som?Cdon?BWooSd[7ob/6O
ol6iQoo1^IOo/K6?okVOO_nOWgko^K6Ool6iUon7OUCok=^aooCdm?odm>co
o?cdooCdk?odm?Com?C/ooclm?odm?Coo?cdooCdk?olo?@3ooooo`05ooCd
m?odm>cok>?:oncSb_ni^JT00_olo?@4ooCdm008ooclm?odm?Com?Cdoooo
oonGSgKoo?cdooCdm?olo?@2ooCdm0;oo?cd0_odm?@02?olo?Com?CdooCd
k?odm?Coo?cdooCdm?olo?Com?Cd0_olo?@01oodm?Coo?cdooooooni^Hoo
A140ooooooodm?@00_olo?@01Oodm?Coo?cdooCdm?olo?Com?Cd00;oo?cd
00Com?Cdooclm?olo?Cok?cd1?odm?@03OoBbZWoShMDol[1WoniUfgoo?cd
ooCdm?o1^IOoMWiLoinOO_niUeCooooooncK/Oolo?@00_odm?@03_olo?Co
/K6?oginKOm]KECoOWIDofEU>_oBb/7ob/6Yon?KfonGShOo^KVYojVYSona
^JWoZJV?0_ni^JT01?o/hl[om?Cdooclm?olo?@2ooCdm003ooclm?odm?Co
m?Cd00;om?Cd0_olo?@00ooooooom?Cdooclm007ooclm003ooCdm?olo?Co
o?cd00Goo?cd00KoooooofDb2?l0003o>T@Iooooooo/fk42obXA2003ol[1
ZOooooook=^a00;om?Cd1oolo?@01Oodm?Coo?cdooclm?olo?Com?Cd00[o
o?cd00Com?Cdooooooo1^HOohm;10_olo?@00oodk=_oo?cdonk^kP2Sonk^
kP00F_ooool01?m<KHOo8SXbobXA2?lR8Q43obXR6@08ob8R4Olb:R;o8R8A
od@Z8_mU6@3od[6?ooooooodm>`2onc/h`05ooCdm?oSfm_oo?cdooCdk?od
m?@00oo/k><01Oodm>cod/ZYooC/foo/k>?oo?cd00;om?C/00Coo?cdooCd
k?odm>com?C/0oodm?@02oolo?Com?C/ooCdk?olo?Com?Cdooclm?odm?Co
m?C/okVOO_oSd[7ooooo00;om?Cd01SooooooncSb_oSd[7ok=_1oncK/OoS
d[7om>?:odA4:_lI6A7o>SXRofED<_lj>R;oSgHjoa4A4OmnG4coUhmfofED
<_mfOUcoWiN7ok67IOni^IOoSgi]oiN?M_o/hlX2ooCdk0;om?Cd00_om?C/
ooCdm?olo?CoOWi]off7O_mLQhooG6efol6iUomLMWkoKGIfoeA]MP02oeaf
OP05oea]M_mDOWkoG6efoeA]M_mDOWh00_mLKGH01OmDKGKoG6efoooooool
o?Cooooo00?om?Cd01?ok?cdooCdm?o/o?Coooooohmf:_lIE3;oIFDjoeA]
M_m<C4Co>T@Iod@Z8_lb:R;o4A4AocXj8_ljA1WoG5a<oaUL/OlIA8Oo0000
00;o4A4A0_lI6AT05?lb:R;o>SXRocXj8_lj>R;oA3XZocXj<_mL>R;oUhmf
oc8Z8_m<C3[oA4@bokViSoniWgkoShMDoinOSonGShOoSiN?okVOO_o/hl[o
m?Cd2?odm>`03Oodm?Cok=^aom_:Woo1^IooShmUoinGQonGSgKo^KV?ok6a
Soo1/Hoo^KVGoiN?M_o/fk400_odm>`01_odm?Com?C/ooclm?olo?Com?Cd
ooclm0;om?C/00Wohm;1om;:ZOni^HooWimnok67IOnOSfgok:Ufol6iUomU
G2X01_olo?@01_odm?Coo?cdooclm?ooooooUhmfooCdk0?om?Cd0_olo?@2
ooCdm00;ooclm?odm>coo?cdooCdm?olo?Com?C/ooclm?odm>coo?cdooC/
foodm>`00_odk=/02?oooooohm:aob8R4Oooooooo?cdooCdm?olo?Com?Cd
0_olo?@01?odm?Coo?cdooclm?odm?@3ooclm00Aonclm?olo?Coo?cdoocl
m?ooooood/ZYofe]E?o1^IOo`K6?ooCdk?ooooooflZOohn?IOnOWgkoWhm]
ooooooodhlX00_odm?@2ooclm00Eol6iUomnMVGoOWIUofe]E?mUIC[o`KVO
oinYZOoSd/7oOXn?om;:`On7OXoo^KVYoncSb_o1/KWod/[1oncK`Oolo?Co
m?Cdooclm?odm?Coo?cd00;om?Cd0_olo?@01?oooooom?CdooCdm?odm?@4
ooclm003ooCdm?olo?Com?Cd00Koo?cd013om?Cdooclm?odm?Coo?cdoooo
oon7IC;o8S8ZocY46Ooooooom>cKoaTI4OljA1Wo/K6?ooooooo/fl7om?C/
1Oolo?@00oodm?Coo?cdooclm009ooclm004ooCdm?olo?Coo?cdooCdm0;o
o?cd00Com?Cdooclm?oBbZWod/[10_odk=/00oolo?Com>cKooooo`2Soooo
o`00F_o^k^h01?lZ8QWo:Q48obXR6Om4:R84obXR6@0>obXA2?lZ8QWoC288
od@Z8_m44@3ok>cSooCdk?o/k>?oo?cdonc/hoo:`JWohm;1ooC/foodm>`4
ooclm005ooooooodm>cok>cSonc/hoodm?@00oodm>`01Oodm?Com?C/ooCd
m?olo?Com?Cd00?om?C/00Soo?cdooCdm?olo?Com?CdoooooooSd[7o^Imn
ooooo`?om?Cd00?ok>?:on?B/Oo/fl400_o/fk403?odhl[oIE`ZocY46Olj
>R;o6B8RofDb2?oSdYoo8R8AofED<_nOUhOoZJV?ohmfI@;oWhm]00_ok=_1
on?B/OniWgko^Imnonc/hoodm>com?CdooCdk?odm?Com?C/ooooo`02off7
OP05ofefM_mLMWkoWimnofenSom]MWH00omLMWh01?mDKGKoKGIfoeAnO_mL
MWh2oeA]MP04oea]M_mLMWkoOVeUooooo`Gom?C/00Ook?cdonc/hoo/o?Co
oooooiMnE?l0003oIFDj00;oG5a<0_lj>R801olZ8QWo4A4Aod@j:_m4A3;o
C4a4ob9UZOo/k><00_m]Qgh01?n?bYOo>UALoa4A4OlR:RX2od@j:P0Aob94
>_lj>R;oA3XZod@j:_m4A2[oA4@boda<A?m4>R[oIE@bojVYSoniWgko/K6?
okViUonGSgKoWimnoncK`Oodm?@02?odm>`04Oodm?Cohm;1om_:Woo:`Ioo
KFeDohmf>_m]IB;o>T@Iol6aSoo1^Ioob/6Oohn?IOoK`Iook>cSooclm?od
m?Coo?cd00Com?Cd0_olo?@02_n?QeCob/6Oon?B/Oo:`Ioohm:aol[1Woo1
^IOo`KV7oiMnE?o/k><2ooCdm004ooclm?odm?Com?Cdooclm0;om?Cd00[o
oooooiN?Qoo/hl[oo?cdooCdm?olo?Com?Cdooclm?odm?Coo?cd0_odm>`0
1Oolo?Com>cKooCdk?odm>com>cK00;om?Cd00Ooo?cdooCdm?oooooom>cK
ooCdm?o/hl[oA14000?oo?cd00?om?Cdooclm?odm?@00_olo?@3ooCdm0;o
o?cd1Oodm?@02Oooooook=^aohn?IOni^IOob/6OoncSb_ooooook=^aohn?
I@02oin?K@0Fooooooodhl[om?C/ooclm?odm?Coo?cdon?B/OmfOUcoOWi]
ogInG?m]KECo^KV?ohNO/Oo1/KWo/K6ioinYZOm]OXoo^KVYoinYZOo:`JWo
C6f7oncK`@;om?Cd2?olo?@01Oodm?Coooooooooooolo?Com?Cd00Soo?cd
00?om?Cdooclm?olo?@00oolo?@00oodm?CooooookVGE002ob8R4@;oo?cd
00Ko4A4Aob8R4OnOSfgoooooooCSb_odm>`2ooCdm003ooclm?odm?Coo?cd
00;oo?cd00?om?Cdooclm?olo?@02oolo?@02_odm?Coo?cdooCdm?oooooo
k=^aol[1ZOodk=_oo?cdooC/foolo?BTonk^kP00F_oVi^H01OlR8Q7o:R8I
obXA2?lZ8QWo:Q4800;o:R8I0_lZ4@P08OlZ8QWoC288oc8Z8_m<8PSoIC88
oncSb_o1^IOo`K6OokVaWon?QfgoOVEDofEU>_mUE3;oIFDjogifE?n7OUCo
WimnokViZOo/fl7ok>cSooCSb_odm>cok=^aonc/hoodk=_ok>?:ooCdk?oS
d[7om?CdoncK/Oodm?Com>cKooCdk003ooCdm004ooclm?odm?Cod/ZYooC/
f`;om?Cd00Coo?cdooCdm?o/k>?ohm:O0_oSd[401Oo/fk7om>?:oinOO_lR
8Q7oA4@Z00;o<RXR0_lR8Q400omUE3;o`K6ion?B/@02on?B`@07ogifE?nO
Sfgo`K6OokViZOniWgkom>cKonc/h`03ooCdm00>ooCdk?ooooooKHMnogj?
Som]QgkoG6f7oinOO_mnShooG8N?oeafO_mDKGKoG7InoeAnO_m<KHL2oeA]
MP08oeAnO_mDKGKoG6efoea]M_mLG4coo?cdooCdk?odm?@2onc/h`0XooCd
k?odm?Cok>cSonc/hooooooo`KV7o`000?m<C3[oKFeDoeaLC?ljA1WoA3XR
ob8Z:_lI6AWoA3XZod@j8_m<C3[o8VFYooCdk?n?UhooKHMnocYLM_lRA3[o
4A4Aoc8Z8_m4>R[o>SXbohM<A?m<8PSo>T@Iod@j8_m4:R;o>SXRodA4:_m4
A3;oA3XZodA4<_m<C3[oWimnohmnK@;oWimn00?ohm:aooclm?odm>`01?od
m>`06?olo?Com?C/ooCdk?odm?Com>?:ol6iUooSd[7oQfDbok67IOnOWgko
SgI4ol6aSonYZHoob/6Yoin?KOo1/Iooo?cdooCdk?olo?Com?Cdooclm?od
m?Coo?cdooCdm0;oo?cd00WoWhm]okVOO_naQfGo^Imnom;:ZOoSd[7ok>?:
ooC/foooool01Oolo?@03Oodm?Coo?cdooclm?odm?Cooooook6aSooBb/7o
ooooooCdm?olo?Com?Cdooclm?odm?@00oolo?@2ooCdm0;ooooo00?ok?cd
ooooooooool00_ooool02oolo?Com?C/ooCdk?odk=_o>T@Ionc/hoodm?Co
o?cdooCdm?olo?Com?Cd00;oo?cd0oodm?@3ooclm003onclm?olo?Coo?cd
00;oo?cd00kom>?:ofeU8_na/Hoo`KVOon?B/Ooooooom>?:ohn7KOnGSgKo
ShmUooooooodk=_oo?cdooCdm0;oo?cd01;om>?:ogInG?mnOVgoOWIUogIn
G?nOSfgo/K6iok6iZOna/KWoWjVYohMnSona/KWoWjVYom;:`Om]OXook=_1
ooCdm?olo?@2ooCdm0;oo?cd00WoooooooCdm?odm?Com?Cdooooooo/fl7o
hjV?ooCdk?ooool02_olo?@00oodm?Coo?cdooCdm002ooclm00?ooooooni
Wgko6ATAoaTI4Oodhl[ooooooa4A4OlZ8QWoQgiDooooooodk=_ok>?:oooo
ooolo?Com?Cd00goo?cd00Com?Cdooclm?olo?Com?Cd0oolo?@01Oodm?Co
o?cdooCSb_o1^IOom>?:00?oo?cdY?oVi^H005[ok^k^0olZ4@P00olR8Q7o
:Q48obXA2002obXA2003ob8R4OlZ4@So:R8I00;o:R8I00[oA140oooooood
m?Coooooon?B`On?QfgoWiN7ol[1ZOoBb/7ohm:a0_ni^JT02?nYZHooOWIU
oin7KOo/k>?oo?cdonc/hoodm?Com?C/0_odm?@3ooCdk006onc/hoodm>co
m>cKooCdk?odm?Coo?cd0_odm?@00oolo?CoooooooCdm004ooCdm003ooCd
k?oBbZWoflZO00;oflZO00Gok=^aooC/fol0003o>T@IodA4:P02oc8Z8P0:
odA4:_m4:R;o^KVGonc/hooSd[7ok>?:on?B/Oo:/JWoWhm]ok67I@;ohm;1
1Oodm?@09OooooooG6efogj?Som]QgkoG6f7oginKOn?UhooG6f7oeafO_mD
OWkoE6efoea]M_mDOWko>UALoeaLC?ljA4co>SXboc8jA?lR<R[o:Q48onc/
hoolo?Cok>?:onc/hoodk=_ok>cSoncK/Oodm>cok=^aooclm?o:`Ioo4A4A
ofeU8_mLG4coMWiLocXj8_m4>R800_lZ8QT02?lR<R[oA4@Zod@j:_lRIJWo
hm_KohnGSolRC5Co00000_lA4A402olI6AWoA3XZocXj<_nOUhOo`K6OofEU
>_lR8Q7oA2XRocY46OmL>R;o<RXR00;oA4@Z00OoA4@bod@j:_ljA1WoIFDj
okViUooK`Iooo?cd00Som?C/00oom?CdoncSb_oKbYoob/6Ook6aSonOSfgo
Wgi<ohmf:_nOSfgo`KV7okVaWomUIC[o`K6?on?Kfoolo?@00_odm?@01_od
m>coo?cdooCdm?olo?Com?CdooCdk0;oo?cd00Soooooooclm?oooooooooo
ooCdm?olo?Com?Cdooclm0Com?Cd0_olo?@01_odm?Coo?cdooooooni/Ioo
b/6Yooooo`;om?Cd0_olo?@00oodm?Coo?cdooCdm003ooooo`;om?Cd00go
ooooon?B/OoBbZWoShmUofeU8_ooooooo?cdooCdk?olo?CoIC88oncSb_oo
oooom?Cd00;oo?cd00Com?Cdooclm?odm?Com?Cd0_olo?@01?odm?Coo?cd
ooclm?o/o?@2ooclm009ooCdm?oooooom?C/ohm40?nOWgkod/ZYom^aWooo
oooom>cK00;oShmU013oWhm]ooooooodk=_om>cKooCdm?olo?Com?C/onc/
homfOUcoShM]oginKOm]KECoShmUoncSb_oSd/7ok>?:0_o:`JT03Oni^JWo
d/ZYol6a^OoSd/7ohm:aooCdk?odm?Coo?cdooooooolo?Co^M_doiNib_oS
fm/00_ooool01?oSd/7obR80om9<0?ooool2ooclm005ooCdm?olo?Coo?cd
ooclm?odm?@00_olo?@00oodm?Coo?cdooCdm003ooclm00?ooCdm?oooooo
fl6OobXA2?lA4A7od/ZYooooool0003o8R8AofeU8_oooooom?C/on?B/Ooo
oooom?Cd00Coo?cd00?om?Cdooclm?olo?@03?olo?@02?odm?Coo?cdoocl
m?olo?Com?C/ok6aSoodhl[oo?cd0_odk=^Tonk^kP00F_ooool2ob8R4@05
obXA2?lR8Q7o:Q48obXR6OlI6AT00olR8Q405OlZ4@So:R8Ioc8Z8_m44@3o
m?C/ooCdm?o/k>?ohncdooclm?na^IOoOWIUogInG?n?SfGoShM]ohn?IOnO
SfgoWimnooC/foo/k>?oo?cdooCdm003ooCdk005ooC/foodhl[om>cKoocl
m?odm?@00oodm>`01?olo?Com?CdooCdm?olo?@2ooCdm003ooclm?odm?Co
o?cd00;om?Cd00_ok?cdom;:ZOo/fl7ohm:aokVOO_o:^Hoo^IMDoa4A4Olj
A1WoA2XRocXj8P02od@j:P;ohm:a00_ok>cSooC/foo/hl[om>?:ooCdk?ol
o?Cok>?:om_1Woo/fk7om?Cdooclm003ooCdm00<ooclm?mfOUcoKHnGocYD
G?m]QgkoOXn?oinOSomLMWkoG6efocY4<_m4>R[o8S8Z0_lZ4@P01?l0003o
8R8Aob8R4OlR8Q42obXA200=ooC/foodm?Cok:UfooCdm?oSfm_oo?cdonbY
M_o/fk7ok:UfoooooooBb/7o6ATAocY46@02ofe]E0;oA3XR00go<RXRoaTI
6Om4>R[o>SXbod@j:_lbIJWom?C/om;:`OlIMTCo4A4AoaTR<_lI8R;o:R8I
00?oA3XZ00Wo^KV?ok6iUoniWgkoIE@bob8R4OoK`IooIE`ZodA4:_m4>R80
0om<A2801?lb:R;oG3XRol[1Woolo?@4ooCdk0;om>cK00Com?C/ooC/food
m>com?C/0_oKbYl02Oo1^HOo`KVGokViZOni^IOo^KV?oiN?M_nOWgkoQgiD
okVOOP02ooclm004ooCdm?olo?Coo?cdooclm0;om?Cd0_olo?@00oodm?Co
o?cdooclm002ooclm005ooCdm?olo?Com?Cdooclm?odm?@01Oolo?@02Ood
m?Coo?cdooCdm?olo?Co`K6iok6iUoooooooo?cdooCdm003ooclm00EooCd
m?olo?Co`K6?ohn?IOnGOUCo^IMDoncSb_oooooofim]ol6iQom<A2;oID`I
ooooooodm?Cok>?:oooooon?MR[ob[6Yooooooolo?Com?Cd00;oo?cd00Go
m?Cdooclm?olo?Coo?cdooCdm003ooclm0;om?Cd0_olo?@02Oodm?Coo?cd
ohmf:_n?MR[o^KVGolZiSooooooom>cKohMnE002oin?K@;oo?cd00?om>cK
ooclm?odm?@00_olo?@04?mfOUcoOWi]oginKOmfOUcoOWIDoncSb_oSd[7o
/K6ioaTRC?ljE8Ook=_1on?B`OniOTcofhMUom^aWoodm>`3ooclm00?oiNi
b_mfUl7oZL[Booclm?oooooohm_Kom9<0?o:8P3om>cKooooooolo?Com?Cd
ooclm?oooooom?Cd00Goo?cd00Som?Cdooclm?olo?Coo?cdooCdm?olo?Co
oooooncK`@;o6ATA00[o^KVGoooooom]IB;oOVe<ogInG?oooooom?C/oncK
/Ooooooom?Cd0_olo?@00oodm?Coo?cdooclm002ooclm003ooCdm?olo?Co
o?cd00Koo?cd00Com?Cdooclm?olo?Coo?cd0_odm?@2ooclm005okVOO_od
k=_oo?cdooC/foolo?@0Y?ooool005[ok^k^00So8R8AobXA2?lR8Q7o8R8A
oaTI4OlZ8QWo8R8AoaTI6@;o8R8A00go:R8IoaTI6OlZ8QWo:Q48om^aWood
m>com?CdooCdk?oSk?Coooooon?Kfoo:`JWo/KVG00;oZJV?00_oWimnoin?
KOn?KDcofl6OolZiSoo1/Ioo^KV?ol6iWoniWgkohm;1ooCdk004ooclm0Co
m?Cd00?oo?cdooCdm?olo?@01_odm?@02Oo/o?Cob/6Oon?B/OoSd[7om>?:
ohn?IOmUG1Wo4A4Aob8b:P02oc8Z8P04ocXj8_mU<PSoooooooclm0Oom?Cd
00?ok>cSoncK/Oodm>`01?odm?@02_olo?CoC7Inoff7O_mnKFGoKGj?oeaf
O_na^JWoG6f7oeafO_l00002obXA200@ob8R4Olj>S;o:R8Iod@Z8_m4A4co
G5a<oda<>_ljE5cok=_1ooooooo/`HOom?C/ooCSb_oBbZWom?CdooC/f`;o
m?Cd02Wohm;1ocY46OljA1WoMWiLoeaLC?m4A3;oA4@Zod@Z8_lI6AWo<RXR
od@j:_m4:R;o<VFYon?Kfoo/k>?o>UafoaTR8_lA4A7o6B8Rob8Z:_m4>R[o
C4a4oc8Z8_o1^IOoShMDooC/fooBb/7oMWiLooCdk?o:/JWoIFDjofeU8_lb
:R;oIE`Zom:aSoo1^HOoMWiLok67IOolo?Com?C/ooC/f`02ooCdk00Doocl
m?odm>coo?cdooCdm?odm>coo?cdol6iQon?SfGoWimnoiN?M_nOWgkoWhm]
ok6aSona^IOo`KVOojVYSoniWgkok>cSooCdm?olo?@4ooCdm005ooclm?od
m?Com?CdooCdm?olo?@00oodm?@3ooclm006ooCdm?olo?Coo?cdooCdm?ol
o?Com?Cd0_olo?@2ooCdm006oooooooSd/7oWin?ooooooodm?Coo?cd0_od
m?@03Oolo?Com?Cdoooooon?QeCo>T@IohMU<_niUfgohm:aooooooo1^HOo
b[V?ofEL6Om<A2800_ooool02?o/fl7oooooohmfE?niWgkoooooooCdm?ol
o?Com?Cd0oolo?@00oodm?Coo?cdooclm002ooclm0;om?Cd1?olo?@04ooo
ooooSgHZohmU4Oo1^IOo`KV7ooooooolo?CoShmUoiN?M_n?SfGom>cKooCd
m?o/hl[om?Cdooclm?odm?CoooooohMnE?m]Qgh00omfOU`04oo/hl[ohm;1
ohMnSolbA7Ko/K6ion?B`OoB/Hoo/AT0om9<0?o/hl[ohm_Kooclm?oooooo
^M_dogjO^OmfUl7oooooooCdm?ooool00_oBC0001?oSWeCoooooooclm?od
m?@4ooclm004ooCdm?olo?Coo?cdooCdm0;oo?cd00?om?Cdooclm?odm?@0
0oolo?@03Oodk=_o>T@Ioda48_n?SfGooooooin?KOniUeCo^IM]ooclm?oo
oooohm:Oooooooodm?@01?olo?@00oodm?Coo?cdooclm002ooclm003ooCd
m?olo?Coo?cd00;oo?cd00?om?Cdooclm?olo?@01Oolo?@01oodm?Cooooo
okVOO_o/hl[oo?cdooC/foolo?@0Y?o^k^h005[oi^KV00So8R8AoaTI4OlR
8Q7o6ATAoa4A4OlI6A7o4A4Aob8R4@;o6ATI00go:Q48oaTI6OlZ8QWo:R8I
oim]C?odm>com?Cdooclm?o/k>?om?Cdonclm?oooooohm_K00;ob/6O00?o
hm:aokViZOo1^IL00_oSd/401_odk=_ok>?:on?B`OoBb/7ob[6Yol6aW`;o
`KVG00Cob/6Ool[1ZOoSd[7ohm;10_olo?@01Oodm>coo?cdooCdm?odm?Co
o?cd00;om?C/013om?CdooCdk?oooooohm:aoncK`OoSd/7ok=^aol6iWom<
A2;o8R8Aoc8Z8_lZ8QWo6ATIoc8Z8_m44@3oo?cd1oodm?@01?odm>com>cK
on?B/Oodm>`4ooCdm00Aooclm?mLKGKoKHMnofenSom]QgkoKGIfokViZOmD
KGKoC7Inod@A0?mLKGKo8R8AoeA]M_mLG4co8R8AodA4<_mLOYL00om<C4@0
1OoK/Iooo?cdon?/m?odm>com>cK00;ok?cd00Kom?Cdonclm?odm?Cok>cS
ofEL6OlR<RX2ofe]E00FodA4:_lj>R;o>SXRoaTI6Olb:R;oC4`jod@Z8_m<
KIOo`K6iooC/fomLKGKo4A4AoaTR:_lA4A7o:R8Iod@j:_m4A2[o<RXRok6a
SonGSgKohm:aon?B`@;oMWiL00_o^ImnooCSb_ooooooOVe<oin?KOo/k>?o
^KV?okViZOoK`IooooooooCdm004ooCdk003ooclm?odm>com?C/00;om?C/
00God/ZYokVGKOn?MR[oID`IofDb2004ofED<P05okViUonGSgKok=_1oocl
m?odm?@00_olo?@00oodm?Coo?cdooCdm008ooclm004ooCdm?olo?Coo?cd
ooCdm0Coo?cd013om?Cdooclm?odm?Coo?cdooCdm?odk=_oUhmfoooooool
o?Com?Cdooclm?odm>coo?cdooCdm?oooooo`KV70_mUICX03_o1^HOo`KVG
oooooooKbYood[6?ofeU8_m44@3oo?cdooooooo/fk7ooooook6aSon?MVGo
oooo1?olo?@01?odm?Coo?cdooclm?odm?@4ooclm003onclm?olo?Com?Cd
00;om?Cd00SoooooojUf<_n7IC;o`KV7okVOO_ooooooo?cdohn7E0;oShmU
00[ohm:aooooooodhl[oo?cdooCdm?olo?Coooooohn7KOmnOVgoUhmf0_mf
OU`02Oo/hl[oWjVYoeAfUonOWhook>?:om;:`OoKMS;o/AT0on>YS`02oncS
bP04oooooooSk?CoMYO1ogJG`@;oo?cd00Ooooooom^aZOo:8P3obR80on>Y
SooSfm_ooooo00koo?cd00oom?C/ooclm?olo?Cooooook67IOo1^HOo^Imn
ooooooodhl[om?C/ooC/foo/hl[od/ZYom_1Woooool00oolo?@00oodm?Co
o?cdooclm002ooclm003ooCdm?olo?Coo?cd00Woo?cd00Oom?Cdooclm?ol
o?Coo?cdooooooniUfgohm:a00?oo?cdY?oVi^H005[ok^k^00Wo6ATIob8R
4OlZ4@So6ATAobXA2?lA4A7o:Q48oaTI6OlZ4@P00olR8Q401olZ8QWo6ATI
ofDI0?nOWhoob[6Yon?B`Oodm>`00_odm?@01Oodm>com?CdooCdm?oSfm_o
`KV700;od/ZY00Kod/[1oncSb_oSd/7ohm:aoncSb_o/fk42oncSbP06ooC/
fooSfm_om>cKoncSb_oSd/7ohm:a0_odm>`01oolo?Com?C/ooclm?odm?Co
o?cdooCdm?olo?@00_odm>`03_o/k>?ob/6Yon?B/OoSd/7ok=_1oncK/Oo/
hl[o:Q48oaTI4OljA1Wo:R8IoaTR8_lZ4@Som?C/0oolo?@4ooCdm005onc/
hooSfm_o`KV7ooCdm?odm>`00oodm?@01?olo?CoE7inoff7O_m]SiL2ofen
S`06ok7:b_mLKGKoKGj?obXA2?mLKGKoC4`j0_m4A4`08Om44@3oA3XZob8R
4Om<C4Co<RXRob8R4OoB/HooooooooCdk?odm?Com?C/onc/hoodm>cohm_K
ooC/foo/k>?oo?cdohmU4OlA4A7oMWiLofEU>_m<C3[oA3XRod@Z8_lZ8QWo
8R8AocXj<_ljA1WoC6fGojW:d_olo?CoKHMnoa4A4@02oaTR:P0EoaTR8_lb
:R;oC4`job8b:_nGSgKoWimnom^aZOo/hl[oMWiLoeaLC?nOUhOob/6Ooooo
oon?SfGoSiN?oinOO_na/Hoo^KV?oinOO_olo?Cok>cS00Som?C/00goo?cd
om_:WooBbZWo^IM]oinOO_nOOTcoSgHZohMU<_mUG2[oID`IoiN?M_na^IOo
hm;100;oo?cd0_odm?@01?olo?Com?Cdooclm?olo?@2ooCdm004ooclm?od
m?Com?CdooCdm0?oo?cd00Kom?Cdooclm?olo?Com?Cdooclm?odm?@2oocl
m0;om?Cd0_olo?@01?n?Qfgoooooooclm?olo?@3ooooo`0EooCdm?oooooo
`KVGofEL:_mUIC[o`KVOokVOO_oooooohm:aol6iQomUG1Wo>T@IooC/fooo
ooook=^aooooooo:`IooSgI4ooooooolo?Com?Cd00Coo?cd00?om?Cdoocl
m?olo?@00oolo?@02?odm?Coo?cdooclm?olo?Com?CdoooooonGOUCoQfDb
0_o1^HL01?oooooom?CdoncK/Oo/fl42ooCSbP07ooooooo/fk7om?Cdoocl
m?odm?Cooooooin?K@02oiN?MP0;ogInG?mnMVGok>?:ocYLM_m]OXoob/6Y
ol[Kfoo1KDCofgHbom9<0?oSk?@00_oSd[401OooooooOYniohna`OmfUl7o
^M_d00;ooooo0_oBC0001?oKMS;obR80olXR0?ooool:ooclm005ooCdm?ol
o?Coo?cdooclm?odm?@00oolo?@01?odm>cok>cSoncSb_ni^IL2okVOOP03
ol6iQooSd[7ok=_100?oo?cd00?om?Cdooclm?olo?@03_olo?@00oodm?Co
o?cdooclm002ooclm005ooCdm?oooooo^Imnon?B`Oolo?@00_odk=^Tonk^
kP00F_ooool01_lR8Q7o6ATAoa4A4OlA4A7o6ATAobXA20;o6ATA0_lI8R80
2_lR8Q7o6ATIobXR6OlI8R;oC288ohMD:_m]KECoG5a<oiMnE?ooool5ooCd
m00?ooCdk?o:`JWob/6Oon?B/Oolo?Com?CdooCdk?o/k>?om?C/onc/hoo/
hl[ohm_KoncSb_oSd[7ok>?:00;ok=_100Gom?CdooCdk?odm>com?C/onc/
h`02ooCdk006ooCdm?odm>com?CdooCdk?odm?Cohm;10_oSd[401_oSd/7o
hm:aoncK/OoSd/7o^KVGoa4A4@;o>T@I00co:Q48ooC/foo/k>?om>cKooCS
b_odk=_om>?:oncK/Oodhl[oooooolZaZOo1/Hl2ooclm0?om?Cd00kom>cK
oeAnO_m]SiOoKHMnoff?UomLKHOo`K6ioeb7Som]OXoo:Q48ocXj<_m<C4Co
A4A<odA4<P;oG6ef0_mLMWh0<_m]MWKoG7InokVOO_olo?Cohm;1on?Kfood
k=_ohm_Konc/hoo/hl[ohm_KooC/foodm?CoSgI4o`000?n?SfGoIFDjodA4
:_m4>R;o>SXRob8Z:_lI6A7oC4`jod@j:_mLKHOoSiniooclm?mnShoo0000
oaTR:_lA4A7o8RXZocXj<_m4A3;o8S8Zoin7KOnOUhOob/6OooCdk?n?SfGo
IFDjok6iUoo1/Hoooooooin?KOn?Uhoo>T@Iol6aSonOUhOoShMD0_olo?@6
ooCdk008ooclm?odm>com?Cdom;:ZOoKbYoob/6Ool6iWona/Hl2ol6iU`;o
Whm]00Co^Imnok6aSooK`Ioooooo0_odm?@3ooclm003ooCdm?olo?Coo?cd
00;oo?cd00?om?Cdooclm?olo?@00_olo?@01?odm?Coo?cdooCdm?odm?@2
ooclm003ooCdm?olo?Com?Cd00;oo?cd00Gom?Cdooclm?nOWgkohm_Kok6i
W`02oinYZ@05oinOSona^Iooooooooooooo:`Il00_mUICX03ona^IOo^Imn
ooooooo/fl7o`KV7ofEL6OlZ4@Som>?:ooooooo/fk7oooooon?B`Om]KECo
ooooooCdm002ooclm0;om?Cd00Coo?cdooCdm?olo?Com?Cd0oolo?@02_o/
o?Coo?cdooCdm?olo?Com?Cdooooooo/fk7ok>?:ooC/fooSd[42ooooo`06
ol6iQon?QfgoShMDol6iQoooooook=^a0_olo?@01Oodm?CooooooinOO_m]
QgkoUhmf00;oMWiL00Gok>?:ocYLM_m]OXooSiN?ogj?S`02om]f<P06ok4I
0?oB/Hook>?:on?B/OooooooMYO10_n?/L401?mfUl7oOYnion?/m?oKOT`2
om9<0006om]nC?oBC03ofhMUooooooolo?Com?Cd0_olo?@00oodm?Coo?cd
ooclm005ooclm009ooCdm?olo?Coo?cdooCdm?oooooo^Imnol6iQoo/fk7o
m>?:00Cooooo00?om?Cdooclm?odm?@01Oolo?@00oodm?Coo?cdooclm008
ooclm003ooCdm?olo?Coo?cd00?oo?cd00Gom?Cdooclm?ooooood[6?om;:
Z@03ooclm:Cooooo001Jonk^kP06oaTI6OlZ4@So4A4AobXA2?lA4A7o:Q48
0_lR8Q403_lZ4@So8R8Aob8R4OlI6AWo8R8AoaTI6Om4:R;oG3XRofefM_n?
MVGok^k^ooooooodm?Cok?cd1?odm?@00oooooook>?:om;:Z@04ooCdk003
ooclm?odm>coo?cd00;om?C/00Com?CdooCdk?o/k>?om>cK0oodm>`03Ool
o?Com?CdooCdm?odm?Cok>?:ooCdm?odm>coo?cdonclm?o/hl[ob/6Oon?B
/Oo/fk400_oSd[402oo/fk7oo?cdon?B/Om<A2;o6ATAohm40?olo?Com>cK
om^OKOodm>cofgi<00;om>?:00Gok=^aooooooo/hl[o^ImnooCdk004ooCd
m00_ooCdk?m]QgkoG7InofenSom]QgkoKGIfokVaWomLMWkoKGj?ogj?Som]
QgkoG8N?ofefM_m]KECo>UALoc8jA?m4>R[o6ATAob8R4Ol0003oQe@Zoocl
m?o/hl[ok>cSooC/foo/k>?ok>?:onc/hoodm>cohm_Kooclm?nOWgko0000
ogifE?m<C3[oC4a4od@j8_lj>R;o<RXRoaTR8_m4>R[oA3XRodaDKOmnWkWo
o?cdogj?SolA4A400_lI8RX04olZ8QWoA3XZodA4C?m4:R;oWhM]ok6aSoni
Wgkoo?cdogInG?mLG4co/KVGok67IOooooooWimnohnGSolj>R;o`KV7ojVY
Son7OU@01Oodm>`00oolo?Com?C/ooCdk002ooCdk005ooCdm?oSdYooWimn
ohn7E?nOUhL00_ni^IL02Oo:`Ioo^KVYok6aSoni^Hoo/KVGom:aSoolo?Co
m?Cdooclm003ooCdm004ooclm?odm?Com?CdooCdm0;oo?cd00Gom?Cdoocl
m?odm?Coo?cdooCdm003ooclm003ooCdm?olo?Coo?cd00;oo?cd0_odm?@0
7_ooooood/[1ogj?Som]QgkoG6f7off7O_mLKHOoKGj?oeA]M_o/fk7ooooo
om_:Wom]KECoIFDjohn?IOn?MTCooooooncSb_niUfgoKFDRobXA2?o/fk7o
oooooncK`Ooooooom>cKofEU>_ooooooo?cdooCdm0Soo?cd00?om?Cdoocl
m?odm?@00_olo?@02_odm?Coo?cdoooooooB/HooMWiLoinGQoniUfgoo?cd
ooooooo1^HL2ohn?I@0EokVOO_ooooook=^aooCdk?odm?Coo?cdooooooni
^IOoOWIUohnGSom]QgkoMWiLooC/fon7OXooKGj?ohNO/OmDMYOo^D`0om]f
<_niC03obR8000;ohm:a00?ooooooff?^On?WkT00_nG^LX2ogjO^@08ooCS
b_o/k>?oo?cdoooooooK/IoodT`0onc/hoooool4ooclm004ooCdm?olo?Co
o?cdooCdm0Coo?cd00Com?Cdooclm?olo?Com?Cd0_ooool2ooclm003ooCd
m?olo?Com?Cd00Coo?cd00?om?Cdooclm?olo?@04Oolo?@00oodm?Coo?cd
ooclm002ooclm003on?BWoni^JWoo?cd00;oo?cdY?o^k^h005[oi^KV00?o
8R8AoaTI6OlI6A400olI6A401olR8Q7o6ATIoaTI6OlR8Q7o:R8IoaTI6OlZ
8QT00olb:R801OniOUCofgHbom^OKOoSd[7oo?cd00;om?Cd00?ohncdooCd
m?odm?@00oodm?@00oodk=_om?CdooCdk003ooCdk003ooclm?odm>com?C/
00;om?C/00?oo?cdooCdk?odm>`00_odm>`2ooCdm004onclm?o/fk7o/HMU
ooooo`?om?Cd00Gok>?:ooC/fooBbZWo`KVGoncK/@02on?B/@08ooC/fool
o?Com>cKokVOO_oK`Iooooooooclm?o/k><2ooCdk007ooCdm?olo?Com?Cd
ooCdm?odk=_ohm;1ooCdk003ooCdm00=ooclm?odm?Com>cKon?B/OnOWhoo
G8N?ofenSonOZJWoKHMnoff?UolIE3;o6ATIoaTI4@02o`0000?o:Q4800[o
<RXRod@j:_m4A3;oSea<ooCdk?o/k>?ohm_KooCdk?o/hl[ohm_K0_o/k><0
1oo/hl[om?CdokViUol0003oOVe<ofEU>_m4A2X00_m4>RX02_lZ8QWo8R8A
odA4<_lb:R;oC5A]off?^Oolo?CoO/6GoaTR8_lA4A42oaTR8P0Doc8Z8_m4
A3;o<SY4oiN?M_nOUhOo^ImnoooooonOSfgoKFeDokVOO_nOSfgoo?cdoinO
O_mnShooIE`ZoinOO_na/HooQgiDooCdk?odm?@4ooCdk00Dooclm?odm>co
m?C/ooCdk?odm?Cohm:aolZiSon?MR[oKFDRogiLC?mfOUcoIFDjogifIOm]
KECo/K6?okViUoo1^HOoooooooclm?odm?@2ooclm004ooCdm?olo?Coo?cd
ooclm0;om?Cd00?oo?cdooCdm?olo?@00oolo?@01oodm?Coo?cdooclm?ol
o?Com?Cdooclm?odm?@00_olo?@06Oodm?Com>cKoeA]M_mnShooKHnGofen
Som]SiOoKHMnogj?Som]Qgkoo?cdoooooooKbYooShmUoda48_o1^HOoWhm]
ooooooodm>cod[6?ogifE?lZ8QWo`KVGooooooodhlX00_olo?@01OmUIC[o
ooooooclm?olo?Com?Cd00;oo?cd00Com?Cdooclm?olo?Com?Cd0oolo?@2
ooCdm0;oo?cd00Wom?Cdooooooo:`IooSgHZojUf<_na/Hooo?cdooooooo:
^Hl00_n?SfD01?naQfGooooooncK/Oodk=/2ooCdm00Iooooooo:`IooKGIf
oiN?M_mnOVgoUhmfoncK`OoBb/7ohm;1on?B/On7UjWoQgj?om_1WooK/Ioo
dT`0om]nC?oSd[7oooooonc/hoodm>coo?cdoooooonG^L[oMYO1on?/m003
ooooo`05on?KfooBC03om>cKooooooodm?@02Oolo?@01Oodm?Coo?cdoocl
m?olo?Com?Cd00?oo?cd00Com?Cdooclm?olo?Com?Cd0_olo?@00oodm?Co
o?cdooCdm002ooclm005ooCdm?odm>coo?cdooclm?odm?@01oolo?@01?od
m?Coo?cdooclm?odm?@4ooclm006ooCdm?olo?Coooooon?B/Oo1^HOoo?cd
0_odk=^TonKViP00F_o^k^h01?lI6AWo8R8AoaTI4OlI6A42ob8R4@0Boa4A
4OlI6AWo:R8IoaTI6OlR8Q7o:Q48oaTI4OlR8Q7o:R8Iod@Z8_n7E2[ohjV?
okUnE?oKOTco^GiDonbiKOodm>cooooo1Oodm?@01?o/k>?om?C/ooCdk?od
m>`2ooCdm0Com?C/013om?CdooCdk?odm>com?C/ooCdm?olo?Com?Cdoocl
m?o/o?Cofl6OoimnC?ooooooo?cdooCdm?olo?Co`K6i0_odhlX01_oSd/7o
^Imnom;:ZOo/fk7ok>?:ooC/f`;oo?cd00?oUhn7ooCSb_odm?@01_odm?@0
1?olo?Cohm_KoncSb_o/k><6ooCdm005ooooooodm>co^KVYol[1ZOnYZHl0
0_m]SiL03?lj>R;o<RXRoda<>_mLG4coG7InofefM_mLQhooKHnGofenSomn
ShooKHnGohnGS`;ok>cS017ohm_KoncSb_oSfm_ok>?:on?Kfoo/k>?ohm_K
ooclm?oSd[7o0000ofe]E?m4A3;oG3XRodA4:_lj>R;oA4@boaTI6@02odA4
<P05ofefM_lbIJWoo?cdoinOSolA4A400olI8R805?m4>R[oC4`joda<>_mU
E3;oWin?okVOO_olo?CoWiN7oeaLC?nGSgKoWimnonc/hoo1^IOoUhmfodA4
C?nOUhOo^K6Oohn?IOodk=_oo?cd0oodm>`00oolo?Com?C/ooCdk002ooCd
k00AooCdm?oSd[7ob/6Oohn?IOmUC1WoSgI4ofE<6OnOOTcoOWIUoda48_ni
Wgko`K6OokVOO_ooooooo?cdooCdm?olo?@00oodm?@00oolo?Com?Cdoocl
m002ooclm005ooCdm?olo?Coo?cdooclm?odm?@00oolo?@00oodm?Coo?cd
ooclm002ooclm004ooCdm?olo?Coo?cdohnGS`;oKHMn00GoKHnGoff7O_mn
ShooG8N?ojVYS`02ooooo`0AoncK/OnOWgkoC4`jojVYSonOSfgooooooocl
m?oKbYooOWIDob8R4OniUfgoooooooC/foodm>coooooofEU>_ooool00_od
m?@2ooclm004ooCdm?olo?Coo?cdooCdm0?oo?cd0_odm?@2ooclm0;om?Cd
01coooooooCSb_mnKDcoSgHZol6iUoodk=_ooooool[1WomfOUcoShmUoimn
C?oooooom>?:oncSb_oooooom?CdoooooooSfm_ok=^aooC/foniWgkooooo
ooCSb_oBbZWohm:aoncSb_n?UhooQgj?0_o/hlX02ooK`IoodT`0om^aZOoo
ooooo?cdooCdm?olo?CooooookWKm?mfUl7ohncd00;ooooo00?ohm_Kom]n
C?oKMS802_olo?@01Oodm?Com?C/ooclm?olo?Com?Cd00Coo?cd00Com?Cd
ooclm?olo?Com?C/1oolo?@01?odm?Coo?cdooooooodm?@6ooclm003ooCd
m?olo?Coo?cd00Ooo?cd00Kom?Cdooclm?odm?Coo?cdooCSb_niWgh2oocl
m003ooC/foo^k^kok^k^0:;ok^k^001Jooooo`;o8R8A01Wo6ATIobXA2?lI
6A7o0000ob8R4OlZ4@So0000oaTR<_ljA4co>UALoc94M_m<E6goKGj?ohMn
SolZ8QWod[6?om^7IOoKOTco^IMDom]nC?niOTcohm:Oonc/hooooooohncd
00;om?Cd00gom>cKoncK/Oodm>cohm:aooCdk?o/fl7om?C/onc/hoodm?Co
m?C/ooclm?odm>com?Cd00;om?C/02;om?CdooCdk?odm>com?Cdom;:ZOn?
MR[oooooooCdm?odm>coo?cdok7:b_oSd[7ok>?:ooCSb_o/hl[o/K6?oncK
/Oodm>com>cKooCSb_olo?CoSiN?oinGQooooooom?Cdooclm?odm?Coo?cd
ooCdm?olo?Com?Cdonc/hoodk=_ok>?:2?odm?@3ooclm008oinYZOm]SiOo
C4a4oda<>_n7UjWoG8N?ofenSomLMWh3ofenS`05oeafO_m]MWKoOXn?ooC/
foodm>`00_o/k><2ooCdk00Donclm?odm?Cohncdooclm?o/fl7o0000ofe]
E?mUC1WoIE@bocY46Olj>R;o<RXRoa4A4Om4A2[o>SXRoeaLC?lIG;7ohncd
oea]M_lA4A42oaTI6@05oaTR8_lj>R;o<SY4oda<>_mUE3800_niWgh04?ol
o?Co/KVGofEU>_nOSfgoWimnooCSb_o:`JWoKHMnogInG?n?Qfgo^K6Oohn?
IOo/fl7om?CdooCdk?olo?@4ooCdk009ooclm?odm>com?Cdon?B/OoBbZWo
SgHZohMU<_niUeCoG3XR00;oSgI400CoC4@Rol6iQoni^JWo^Imn0_olo?@0
0oodm?Coo?cdooCdm003ooclm005ooCdm?olo?Com?Cdooclm?odm?@01Ool
o?@01Oodm?Coo?cdooclm?olo?Com?Cd00;oo?cd00_om?Cdooclm?olo?Co
oooook6iWomLQhooKHnGofenSomLQhooKHMnol6aW`02ooooo`0<oncK`Ona
/Hoo>T@IoinOO_nOSfgoooooooCdm?oKbYoo^IMDokVOO_o/fk7oo?cd0_od
m>`00oooooooIFDjooooo`03ooclm003ooCdm?olo?Coo?cd00Koo?cd00?o
m?Cdooclm?olo?@00_olo?@03ooooooom>cKogInG?nGSgKoflZOoncK/Ooo
oooohm:aogi]C?mnMVGoWgi<ooooooodk=_om>?:ooooo`02ooCdm004oocl
m?ooooooo?cdokVOOP;om?C/00co^K6OohNGZOna/KWoWjVYoeafO_o/hl[o
hncdol6a^OoBC03ofim]ooooooolo?@2ooooo`04on?/m?n?/L7oSk71ooCS
bP?odT`000CobR80ooCSb_oooooom?Cd0oolo?@00oodm?Coo?cdooclm008
ooclm004ooCdm?olo?Coo?cdooCdk0Goo?cd00?om?Cdooclm?olo?@02ool
o?@2ooCdm0?oo?cd00Com?Cdooclm?olo?Com?Cd1Oolo?@01_odm?Com>cK
okVGKOolo?Com>cKooclm:Cooooo001Jonk^kP04oaTI6OlZ8QWo6ATIoaTI
4@;o:Q4800?o6B8bodaDKOmUQjT00_m]SkT02?mfUk7oIHNYogJG/On?WkWo
UkW:ohnO^Oodm>cofim]0ooKQfD01OoKOTcofim]okVGE?odk=_ooooo00;o
m?Cd0oolo?@00oodm>cok>cSooC/f`02ooC/f`03om_1Woolo?Cod/ZY00?o
m?C/01?oo?cdooCdk?odm?Com?CdooooooniUfgob/6Oooclm?odm>com?Cd
ooclm?nOZJWohm:aooCSb_o/fl7ok>?:oncK`OniWgkok>?:00;om>cK00Ko
oooooinYZOnGShOoo?cdooCdm?olo?@5ooCdm004ooCdk?oSfm_ok>?:oocl
m0;om?Cd00?oo?cdooCdm?odm?@00oodm?@01oo/o?CooooookViZOmnShoo
E7inobXR6Om]Qgh00_m]OXl02Om]SiOoKHMnofenSom]QgkoKGj?oeb7Somn
OVgohm;1ooooo`02ooCdm0;om?C/01?om?CdooCdk?o/o?Coo?cdooC/fol0
003oIFDjohn7E?mnKDco>SXbod@j:_lj>R;o4A4AodA4:_m4>R;oG5a<oaUL
/OlAE:Wo6B8Z00?o6ATI01Go<RXRocY4<_m4A3;oC4a4oe`j8_ni^HooWimn
ooC/fooBb/7oG5a<ohMnE?niWgkohm;1oncSb_mnOVgoMWiLogi]C?o1^IOo
Uhmfon?B/Oodm?@01?odm>`03?olo?Com?C/ooCdk?odm>com?CdoncK`OoS
d[7ob/6OokViSoniWgkoWhm]okVOOP;oIE`Z00?o/HMUok6iWonOSfd00_ol
o?@00oodm?Coo?cdooclm002ooCdm0;oo?cd00Com?Cdooclm?olo?Com?Cd
0_olo?@00oodm?Coo?cdooclm002ooclm004ooCdm?olo?Coo?cdooCdm0;o
o?cd0_odm?@00oooooook=_1oeb7U`03off?U`0IoiN?M_odk=_om?Cdoooo
ooodhl[o`KV7oin?KOoBbZWohm:aooCdm?oooooom>cKon?B`OnOUhOoWhm]
ooCdk?odm?Com>cKoooooom]KECom?C/ooclm?odm?Coo?cdooCdm002oocl
m007ooCdm?olo?Com?Cdooclm?odm?Coo?cdonclm003ooclm00OooCdm?oo
oooom>cKofEL6OmUIC[oWhm]om;:`Ooooooohm:aogInG?nOWgkoShmUoooo
ooodm>cok=^aooooooolo?Com?Cdooclm?odm>coo?cdoncK`Oo1^HOohm:a
ol[1ZOlI8TcoQinaohnGSon7OXoodT`0okU<0002olYf8P03on>YSooooooo
^M;K00?oSk7100?oOYnioiNib_o/k><00ooBC0000ooKOTcoooooooclm006
ooclm003ooCdm?olo?Com?Cd00;oo?cd00?om?Cdooclm?odm?@02Oolo?@2
ooooo`03ooclm?o/fl7oo?cd00Coo?cd00?om?Cdooclm?olo?@03?olo?@0
1?odm?Coo?cdooclm?odm?@3ooclm004okVOO_olo?Coo?cdooC/fjCok^k^
001JonKViP0;oaTR8_lR8Q7o8RXZodA4C?m<KIOoIHNYofenSoljE8OoC6fG
odaDKOljE8L00om<KHL04om]MWKoQgj?ohMnSonYMS;ofim]om]nC?oSWeCo
^IMDom^7IOoKOTcofhMUokUnC?o/`HOom?C/oooooonOWhoob/6YonKVi_od
k=/01?olo?@01Oodm?Com?C/oncSb_odm>cofk6O00;om?C/00Koo?cdooCd
k?olo?Com?CdooCdk?olo?@2ooCdk005ooCdm?olo?CoSiN?ol[1ZOoSd[40
0_o/fl402Oo/fk7ok=_1oncSb_odk=_ok>cSoooooona^IooOWi]ooclm007
ooCdm006onc/hoodm>cohm;1ooclm?odm?Coo?cd1oodm?@04OooooooWin?
off?Uom]SiOo:Q48odA4:_m]OXooOXn?oea]Qom]OXooKHMnofenSom]SiOo
OXn?off7O_oK/JWooooo00;om?Cd0_odm>`2ooCdm005ooCdk?odm?Coo?cd
oa4A4OljA1T00_mnKD`03Om4>R[o>T@Iod@j:_lI6AWoA3XZocXj<_m4A3;o
>Uafoc94M_m<C3[oC4a4obXR6Olb:R800om4A3804_m<C4CoA3XZoinOO_na
^IOom>cKoncSb_mLG4coQgiDok6iUooK/JWok>cSofe]E?mnShooIFDjokVa
WonOWgkofk6Oooooo`?om?C/00?oo?cdooCdk?olo?@00_odm>`03Oodm?Co
m>?:om_:Wona/Hoo^KV?ol6iQona/Hoo^KVYol6iQonOUhOo^ImnokViUonG
SgH00_olo?@2ooCdm0Coo?cd00?om?Cdooclm?odm?@00_olo?@01Oodm?Co
o?cdooclm?olo?Com?Cd00Woo?cd00Wom?Cdooclm?olo?CoG7Inoff7O_m]
SiOoKGj?ooCdk?olo?@00_odm?@04oolo?Cok>?:ok6iUonYZHoo`KVGooCS
b_oooooohm:OoinOO_ljA1WoShmUooC/foodm?Com>?:oooooom]IB;ok>?:
ooclm?odm?@00oolo?@00oodm?Coo?cdooclm004ooclm0;om?Cd00?oo?cd
ooCdm?olo?@00_olo?@03om<A2;o>T@Iod@A0?o:`IoooooooncK`OljA1Wo
C4@RofEL6Oolo?Com?C/oncK/Oodm?Coo?cdooCdm002ooclm005ooCdk?ol
o?Coo?cdooclm?oSd/400_mLKHL00om]SiOoi^KVolXR0002om9<0004om]f
<_oK/JWooooookWBf`;oOYni00SoUkW:okWBfoolo?Coo?cdom^aWoodhl[o
m?C/ooooo`;oo?cd00?om?Cdooclm?olo?@01_olo?@00oodm?Coo?cdoocl
m006ooclm00:ooooooolo?Com>?:onc/hoo/fl7o/K6?on?B`OnYZHooOWi]
ogjO^@Koo?cd00?om?Cdooclm?olo?@01Oolo?@00oodm?Coo?cdooclm009
ooclm004okVOO_olo?Com>cKooclm:Coi^KV001Jonk^kP05odA4C?mLKHOo
G7jGoea]Qom<E6d00_lbA7H02om<E6goA4A<oc8jA?m4A4co<TAfoa4A4OlI
6A7o6ATIo`000?m]MWKoSc9<00;ofgi<017o`Fe4om]nC?oKOTcofhMUon>O
E?oKQfGo`Fe4om]nC?oB/HooWimnod@j:_m<C4CoG5a<ohn7KOnGShOo^KVY
on?B`@02ooCdk0?oo?cd00Ook>cSooCdk?odm>com?CdooCdk?odm?Coo?cd
00Com?Cd00ooo?cdohnGSoo:/JWohm;1om;:ZOodhl[ohm;1on?B/Oo/fl7o
m>cKooCdk?olo?Co/L[:ofenSoodhlX00oodm?@01?olo?Com?Cdooclm?od
m?@2ooCdk003om;:`Oolo?Com?Cd00;om?Cd00?oo?cdooCdm?odm?@00ood
m?@03?olo?Co/K6?off?Uom]SiOoKHMnobXA2?lR8Q7oG7InofenSom]Qgko
KGj?off7OP?oKGj?00Gob[6Yooclm?odm?Com?CdooCdk004ooCdm007oncl
m?olo?Co4A4AocY46OmUIC[oA4@Zoda48P02ocXj8P04oaTI4Olb:R;oA4@b
od@j8P;oA4@b00GoC4`jocXj<_lZ8QWo6ATIodA4:P02odA4<P0Boda<>_m4
>R;oUhn7okVOO_o/hl[om>cKofEU>_mUG2[ob/6OolZiSoolo?CoMWiLoinO
O_m<C3[ob/6YoiN?M_o1^IOoo?cd2?odm>`02Oodm?Com>cKol6iQon7OUCo
WimnojVYSoo1^IOo^KVGol6iU`02okViS`03ok6aSonOSfgom?C/00;oo?cd
00Com?Cdooclm?odm?Com?Cd0_olo?@01?odm?Coo?cdooclm?odm?@2oocl
m0;om?Cd00Soo?cdooCdm?olo?Coo?cdooCdm?olo?Com?Cdooclm0;om?Cd
01koo?cdooCdm?olo?CoWin?oncSb_mLQhooUhn7ooooooolo?Com?Cdoooo
ooodk=_od[6?ocXj8_n?MTCoWimnoncK`Oooooook=^aokViSom4A2[oQfDb
oncK`Oooooook=_1oooooon7OUCod/[1ooooooodm?@2ooclm004ooCdm?ol
o?Coo?cdooCdm0;oo?cd00Gom?Cdooclm?o/o?Coo?cdooCdm002ooclm00@
ooCdm?ooooooC4@Roda48_lb:R;o^Imnooooooodk=_o>T@IobXR6Om]IB;o
m?C/ooclm?oSdYooooooooCdm0;oo?cd00Kom?Cdooclm?odm?Com?C/oocl
m?oSd[42ol[1Z@08om;:ZOo/hl[od[6?on>YSooKQfGohm:aol[1Woolo?@2
on?Kf`03onc/hoodm>coo?cd00;oo?cd00OoooooooCdm?olo?Coo?cdooCd
k?olo?Com?C/00Ooo?cd00?om?C/ooclm?olo?@00_olo?@03oooooook>?:
oncSb_olo?Com?C/okVOO_mUE3;o>UALoea]QomUQjWoQgj?ob9UZOnOUhOo
>UafoeB7/@04ooclm005ooCdm?olo?Coo?cdooclm?odm?@02Oolo?@01?od
m?Coo?cdooclm?odm?@2ooclm004ooCdm?olo?Co`KV7ooC/f`;oo?cdY?o^
k^h005[ooooo00GoC5A]oc94M_m4A4co<SY4oc94MP02odA4C003ocYDQolb
A7KoC5A]00;o<TAf0_lI6A42ohnO^@0BoiNib_nid]_oZL[Boooooona/KWo
`K6iolZiSooKQfGo^Imnom^7IOoKMS;ofhMUohn7KOm]MWKoShM]oginKOmn
G4coC4a40_m<C3X03?m<C4CoOVeUohn7KOnYZHood/[1oncSb_o/k>?oo?cd
ooCdm?o/k>?om?CdooCdk0?om?Cd0oolo?@01OmfOUco^KV?ooCSb_o/fl7o
b/6O00;ok=^a00Wok=_1ooCdk?odm>coo?cdon?KfomLKGKok=^aoooooool
o?@01_odm?@00oo/k>?ohm:aooCdm002ooCdm005ooclm?odm?Com?CdooCd
m?olo?@00_odm?@01?olo?Co^KVGoff7O_m]Qgh2off?U`04oda<>_l0003o
KGIfoff?U`;oKGj?00KoKHMnogj?Som]Qgko^K6Oooooooo/k><3ooCdk00[
onc/hoodm>cok>cSonc/hooooooo8R8AocY46OmUE3;oA4@Zod@j:_m4>R;o
>SXRoaTR8_lj>R;oA3XZodA4:_m4A3;oC4`jodA4<_m4>R[o:Q48obXR6Olj
>S;oA4@boda<>_m<C4CoA2XRohn7KOna/Hoohm:aooCdk?m<C4CoID`IokVi
UoniWgkoooooogInG?nGShOoIE`Zol6iWon?Qfgo`KV7ooclm00:ooCdk003
ol6iQon?MS[oQgiD00;oIFDj00OoIE`Zofe]E?mfOUcoWin?ol[1ZOnOWgko
k>cS00;oo?cd00?om?Cdooclm?odm?@00_olo?@01?odm?Coo?cdooclm?od
m?@:ooclm005ooCdm?olo?Coo?cdooCdm?olo?@00_odm?@00oooooooWimn
ooCdk002off7OPGoo?cd013oflZOoda48_mUIC[oWimnon?B/Ooooooom>cK
ol6iQomUG1WoMWiLom^aZOooooook=^aoooooonGSgKod/[11?olo?@01Ood
m?Coo?cdooCdm?olo?Com?Cd00?oo?cd00?om?Cdooclm?olo?@00_olo?@0
4oodm?CoooooofE<6OljA1WoIE`Ioin?KOooooooo?cdoiMnE?niUeCo`KV7
ooC/fooooooohm:Oooooooolo?Com?Cdooclm?odm?@00_olo?@01Oodm>co
o?cdooC/foo/fl7ok>?:00;ohm:a00Kohm;1on?B/OoSd/7od/ZYol6iUood
m>`2ooclm003ooCdk?o/k>?om?C/00?om?C/00?oo?cdooCdm?olo?@01Ool
o?@00oodm>coo?cdooclm002ooclm00Eooooooolo?Coo?cdom;:ZOolo?Co
`K6?ogiLC?m<E6goE7JGoinYZOoSd[7o8VFYoc9f/Om]SkWoIHNYoff?UolR
IJWoA3XZoc94M_m]SkWom?C/00Woo?cd00?om?Cdooclm?olo?@00_olo?@0
0oodm?Coo?cdooclm008ooclm004om^aWoodk=_oo?cdooC/fjCooooo001J
onk^kP04odA4C?m<E6go<SY4oc8jA0;o<TAf00SoA4A<oeanUoljE8Oo<TAf
oda]UomDMYOo6B8bocYDG0;o<RXR00?oQiNYojW:d_na/KT00_nY`LX00onG
^L[oZL[BojW:dP02ojW:dP07onk^k_niWgko`K6OofEL:_mnOVgoShM]oinO
S`02oiN?Q`0;oinOO_mnMVGoG5a<ofEU>_m<C4CoC4`joeaLC?o1/Ioooooo
ooclm?odm>`00_olo?@02Oo/hl[ohm;1on?BWooBbZWob/6OokVaWomfOUco
UhmfooCSbP02on?B/@0Col[1Woo/hl[ok=^aooCdk?odm?Coo?cdooC/fom<
MWkohm:aooooooodm>coo?cdooooooolo?Coooooooclm?odm>cok>cSon?B
`@02ooCdm004ooclm?odm?Com?Cdooclm0Gom?Cd00Cohm;1on?Kfoodk=_o
hm;10_o/hlX02_oBb/7oA3XRoff7O_m]OXooKHnGogj?Som]SiOoOXn?ojVY
Soooool5ooCdk00@ooCdm?odm>com?C/ooooooljA1Wo6ATAofEU>_mUE3;o
>SXRod@j:_m<A2;o6B8Rob8R4OljA3;o>SXbodA4:P;oA4@b00GoA4@Zod@j
:_m<A2;oA4@bodA4C002odA4<P0Aoc8Z8_n?MUCoZJV?om_1WoooooooIE`Z
od@j8_o1^IOo^Imnoooooon7OUCoSiN?ofEU>_ni^HooZJV?oiN?M_olo?@0
0_odm>`01?olo?Com?C/ooCdk?olo?@4ooCdk00<ol[1Won?MTCoQfDbohmf
>_mUC1WoQfDbofED<_n7IC;oQe@ZoiN?M_nOWgkok=_10_odm?@01Oolo?Co
m?Cdooclm?odm?Coo?cd00;om?Cd00Goo?cdooCdm?odm?Com?Cdooclm003
ooCdm006ooclm?odm?Coo?cdooCdm?olo?Com?Cd0_olo?@02Oodm?Coo?cd
ooCdm?ooooooUhmfooclm?m]QgkoKGIfooclm004ooCdm00Aon?BWomUIC[o
IFDjoinOO_oK/JWoooooooC/fooKbYooA4@Zofe]E?o1^IOooooooncK/Ooo
oooo/K6?ok6iUoooool00_odm?@01?olo?Com?Cdooclm?odm?@4ooclm0?o
m?Cd00Woo?cdooCdm?olo?Com?Cdooooooo1^HOo/HMUom_:Woo1^HL00_oo
ool01oodhl[om>cKoncSb_oBb/7ob[V?ol6iQoolo?@00_o/o?@02Oodm?Co
o?cdooCdm?odm?Com?C/ooCdm?olo?Com?Cdooclm002ooCdm006ooclm?od
m>com?C/ooC/foo/fl7ok>?:0_odm>`00oolo?Com?C/ooCdm002ooCdm0?o
o?cd00?om?C/ooclm?olo?@00_olo?@2ooooo`;om>cK01[oooooom:aSon?
Qfgok>cSokVOO_mnMVGoKHnioda<A?m]SkWoE8Naonk^k_lAE:WoWjVYocYU
Uom]SiOoUkW:oinOSon7OXoo4EBYob9UZOmDQk7oIINaonc/hoolo?Com?Cd
ooclm0;om?Cd0_olo?@01?odm?Coo?cdooclm?odm?@4ooclm006ooCdm?ol
o?Com?Cdooclm?odm?Coo?cd0_odm?@2ooclm004om_1Woo/hl[om>cKoocl
m:Cok^k^001JonKViP0:odaDKOlbA7KoA4A<oeanUolbA7KoA4A<oc94M_mL
OYOo>UB7oda]U`;oIHNY00_oC6f7ocYLM_m<KHOoC5A]ohNGZOnY`L[oUkW:
ojW1b_nG^L[oZL7:oiNibP03ojW1bP0BojW:d_o:/JWofim]oncK/Oo1/KWo
ZJV?ogiUE?m]KECoIFDjoff7O_nGSgKoZJV?oiN?M_nGShOoOWIUofe]E?mU
E3;od/ZY0_o:`Il00oo1^IOob/6Oon?B/@02om;:`@08oncSb_oSd/7oi^KV
ohnGSona^IOok>?:on?B`Oo/hlX2on?B/@0Bon?BWoodm>com?C/ooclm?na
^IooA4A<ol6aWoooooooo?cdooC/foodm>cok>?:om;:`Oo/hl[oooooonc/
hooSd/7oo?cd0_odm?@01Oolo?Com?CdooCdm?odm?Coo?cd00?om?Cd00Go
m?C/ooCdm?olo?CoooooooCdm002ooooo`09ok5]6Oodk=_oOXn?off7O_m]
SiOoOXn?off?UonOWhoooooo00Oom?Cd00Wok?cdoooooomUG1Wo>T@IofED
<_m<C3[oA4@Zod@j:_m<A2800_lZ8QT2od@j:P04odA4:_m4>R[oA4@bocXj
<P;oA4@Z01Go>SXbocY4<_m4>R[oC4`jocY46OmUE3;o^Imnol6aWooooooo
>T@Iob8R4Oo:`IooUhmfoooooomfOUcoWin?odA4:_nYZHooWiN7oin7KOoo
ool00oodm>`00oolo?Com?C/ooCdk003ooCdk00BooCdm?odhl[oUgiDokVG
E?n?MS[oIE@boimnC?mnKDcoG3XRoiN?M_n?MS[oWiN7on?B/Oooooooo?cd
ooCdm?olo?Com?Cd0oolo?@01Oodm?Coo?cdooclm?olo?Com?Cd00?oo?cd
00Com?Cdooclm?olo?Com?Cd1?olo?@02_odm?Coo?cdooCdm?olo?Cooooo
ohn7KOooooood/[1okViZOooool2ooclm00CooCdm?oooooohm:OogInG?mL
G4coWin?ol6aSoooooooo?cdoin?KOm4A2[oIFDjokVOO_ooooook=^aoooo
ooo:`JWoWin?ooooo`03ooclm006ooCdm?olo?Coo?cdooCdm?olo?Com?Cd
0_olo?@00oodm?Coo?cdooclm002ooclm00@ooCdm?oooooom>?:ooC/foo/
hl[od/[1okVaWoo1^HOo^Imnok67IOo1^HOofl6OooCSb_o/k>?ok?cdoocl
m0;om?Cd0oolo?@01Oodm?Coo?cdooCdm?olo?Com?C/00Coo?cd0_odm?@0
1Oooooooo?cdooclm?olo?Com?Cd00Ooo?cd027oooooooclm?ooooood/[1
ooclm?o1^IOoOUa<ocYDG?mLQhooSiniooCdk?o/hl[oC7jaod@j:_m<KHOo
6Ebaoea]M_lIKK7oQiNYom;:ZOlAE:WoQiNYofenSolAE:Wo6EAnoc9UZOn?
Uhoo8WJiohNO/Oni^IOo6EbaonKVi_ooool06?olo?@01?o/fl7ok>?:oocl
m?olo?BTonKViP00F_o^k^h01_m<E6go>UB7oea]QomUQjWo>UB7oda]Q`;o
E7JG00[o<TAfoea]QomfUk7oIHNYoff?/OmnWkWoIHNYofenSonYb];oSk71
1?nG^LX05?nO`K7oUkW:oiNib_nY`L[oUkW:oio1/OniUfgok=_1om_1Wool
o?Cok>cSooC/foo^k^ko/KVYogi]IOmUG2[oIFDjohn7KOnOZJWoUhn70_oB
b/42on?B`@0<on?Kfoo^k^ko`K6iok6iZOnOWhooWiN7oinOO_nOSfgo^IMD
om^OKOo:`JWohm;10_oSd[401?oBb/7oflZOoncSb_odk=/2ooCSbP03odaD
KOo1^IOoQlZa00Go4In700CoA9n?ooclm?oSd[7ohm;10_odm?@01?olo?Co
m?CdooCdm?olo?@5ooCdm003ooC/foodm>com?Cd00?om?Cd00goooooom]f
<_ooooooo?cdoinYZOm]QgkoKHnGogj?Son?QfgoooooooCdm?odhl[om?C/
00Com?Cd013om?C/oooooom]IB;o6ATAofEU>_mUG2[oA4@Zod@j:_lj>R;o
8S8Zob8R4OljA3;o>SXbodA4<_lj>S;oA4@b0_m4>RX05_lj>S;o>SXRod@j
:_lj>S;oA4@bod@j:_mUE3;o/KVGokViSoolo?Co>T@Iob8R4Oo1^HOoUhmf
oooooonGOUCoSiN?ofEL:_nOWhooWiN7oiMnE?ooool5ooCdk00Booclm?od
m>coo?cdooCdk?odm?Cok=^aol[1Woni^IOoUhmfok6aSoo1^HOoID`IohMU
<_nGSgKoQd`AokVOO_oK`Ioooooo0_odm?@01_olo?Com?Cdooclm?olo?Co
m?Cdooclm0?om?Cd0_olo?@01Oodm?Coo?cdooclm?olo?Com?Cd00;oo?cd
0_odm?@2ooclm005ooCdm?olo?Com?Cdoooooon?Uhl00_olo?@02ooSd[7o
ooooooCdm?olo?Com?Cdooclm?oSd[7oA3XRoda<>_m4A2[oUgiD00;ooooo
00Wo>T@Iod@Z8_m4A2[oWhm]ooooooo/fk7oo?cdon?B`OnGSgH00_olo?@3
ooCdm003ooclm?odm?Coo?cd00?oo?cd0oodm?@2ooclm00:ooCdm?olo?Co
oooool6iQoniUfgo^Imnom_1WooSd[7om>cKooclm0?ooooo00Wom?Cdoocl
m?odm?Coo?cdooCdm?olo?Com?Cdooclm?odm?@00oolo?@2ooCdm004oocl
m?odm?Coo?cdooCdm0;oo?cd00?om?Cdooclm?odm?@00oolo?@3ooooo`0@
ooC/foo/fl7oo?cdohn?IOoSfm_o/KVGogi]C?mfUk7oWin?oeB7/OlbM[7o
SiniogJG/OmfUl7oooooob9UZ@?o<WJa01?oUhn7ob9f^OmfUk7oZJV?oc9f
/Om]Sk7oKGj?ob9UZOn?/L7oWjVYoiN?M_lIG;7o6CYfocYDG?lbM[7o/K6i
ooooooolo?Com?Cd00;oo?cd00Com?Cdooclm?olo?Com?Cd3?olo?@02?od
m>coo?cdooCdk?odk=_ok=^aolZaZOodhl[od/ZYY?o^k^h005[ooooo00Go
C6f7ocYDQomUQjWo>UafofF7Z@03oeAfU`07oda]UomDQk7oIHNYoeanUomU
QjWoG7jGogjO^@03ohna`@03oiNib_n?/L7oUkW:00GoUkW:0_nY`LX02OnY
b];oZL7:ooooooolo?Cok>?:onc/hoo/hl[om>cKooclm002om;:`@0;oinG
QomU<PSoC4@RogInG?na^JWoUhn7oiN?M_nOQfgoUgiDokVGKOo:Sc800_oS
We@02_oKSc;ohiljon>O>_oK/Iook>?:ol[1Woo/hl[ohm;1oncK/OoSd/42
ooC/f`0>ooCdk?odk=_o6GI4oinGQonG^L[ok>?:ol[Kfom4Whoooooooho:
UolAWhOooooool6iQoo1/Il2ooclm0;om?Cd00Coo?cdooCdm?odm?Coo?cd
0oodm?@2ooCdk006ooCdm?ooooooo?cdoooooooSd/7ofim]0_odm?@01Ool
o?Cohm_KohnGSom]SiOoUhmf00;ooooo00?ohm:Oooclm?odm?@01?odm?@0
1_ooooooShMDo`000?mUG2[oC4a4oda48P;o>SXR0_lI6AT2od@j:P05odA4
:_ljA3;oA3XZodA4<_lb:R800_m4>RX05?ljA3;oA4@ZocXj<_m4A3;oIE@b
ok6aSoniWgkoo?cdocY46OlI6A7o^ImnoinOO_ooooooWhm]oiN?M_mUIC[o
UhmfojVYSon?QeCoo?cd0_odm>`00oolo?Com?C/ooclm005ooCdk00BooCS
b_o1^HOoflZOok6iUoniWgko^KVYokVOO_na^IOo^ImnoiN?M_nOWgko`KVG
ooooooolo?Com?Cdooclm?odm?Coo?cd0_odm?@6ooclm003ooCdm?olo?Co
m?Cd00Ooo?cd0oodm?@01oolo?CoooooojVYSoodm?CooooooncSb_olo?@0
0_odm?@01oolo?Coooooon?B/OljA1WoA3XRocXj8_n?MSX00_ooool01_mU
G1Wo>SXRodA4:_n?MS[ooooooncSbP;om>cK00CoUhmfooCdk?olo?Com?Cd
1oolo?@00oodm?Coo?cdonclm002ooclm005ooCdm?olo?Com?CdooCdm?ol
o?@01?ooool00oodm?Coo?cdooCdm003ooclm005ooCdm?olo?Coo?cdoocl
m?odm?@00_olo?@01?odm?Coo?cdooCdm?odm?@2ooclm005ooCdm?olo?Co
m?Cdooclm?odm?@00_olo?@07oodm?Coo?cdooclm?oooooo`KVGoinOO_nG
OUCoOWIUojVYSom<E6goOYnioiN?Qom<O[7oKFeDoeanUolRM[WoQinaofF7
ZOmnWkWom?Cdooclm?lAE:Wohm;1oiNib_m<KHOo<VFYoeB7/OnOUhOo6Eba
off?/OnYZHl00_mDQk401_n7OXoo8VFYoaU4O_lbIJWoSiN?ofF7Z@;oSini
0_odm>`Aooclm003ooC/foodm>com>cK00?om?C/0_olo?@01?o/k>?od/[1
om_1WonYMS:Tooooo`00F_o^k^h01OmLKHOoC5A]oeB7/Om<KIOoG7jG00;o
IHNY00_oE7JGofF7ZOmUQjWoKHnaogJG/Om]Sk7oOYniohnO^On?/L7oUkW:
ohna`@06oiNibPGoZL7:027oZL[Bok7:b_ni^JWohm;1ooCdm?oSd/7om?Cd
ooCdk?odk=_om?C/ooC/foodhl[ohimDokUnC?oKSc;ohimDom^?<_oSWc[o
himDom^?<_oSWc[odXLIon>O>_oKSc;ofgi<om^72?o:/JWom>cKooCSb_o1
^IOok>?:on?B/OoSd/400_odk=/01Oodm>cob/6Ooda<A?n?UhooZL7:00;o
o?cd00[oA9n?oooooooSd[7o4In7ooooooniWgkok>?:onc/hoodm?Coo?cd
0_odm?@01Oolo?Com?CdooCdm?odm?Cok?cd00;ooooo00Ook>cSon?KfooS
d[7ob[6YokUnE?oBC03ooooo00?om?Cd0_olo?@01?nOZJWoKHMnooclm?od
m?@2ooCSbPGom?Cd00gooooooin?KOlA4A7oIE`IofED<_m<C3[oA4@ZocXj
8_lb:R;o6ATIod@j8_ljA3;oA3XZ00;oA4@b00Co>T@bod@j:_lj>R;o>SXR
0_m4>RX04OljA3;oA3XZod@j8_ni^Hoo^ImnooCSb_lR8Q7o<RXRoinOO_ni
Wgkoo?cdohn7E?m]QgkoG5a<ohmnKOnOWgkoSgIU00;oo?cd2?odm>`04?ol
o?Com>cKohn?IOmnMUCoWiN7ok6iUoo:`JWo^KVGok6iUoo:`Ioo^KVGoinO
O_niWgkoooooooCdm?olo?@2ooCdm0?oo?cd00Com?Cdooclm?odm?Com?Cd
0_olo?@2ooCdm005ooclm?odm?Coo?cdooCdm?olo?@00_odm?@2ooclm008
ooCdm?olo?Com?Cdoooooon?Uhook>?:ooooooo/hlX3ooclm004ooCdm?oo
oooom>?:ocY46@;oA4@Z00goID`IooooooooooooIE`Ioda48_mfOUcoSgI4
ooooooodhl[ok>?:ooclm?m]MWKom>cK00Com?Cd00Coo?cdooCdm?olo?Co
m?Cd0oolo?@00oodm?Coo?cdooclm004ooclm0?om?Cd00?oo?cdooCdm?ol
o?@00_olo?@2ooCdm005ooclm?odm?Com?Cdooclm?odm?@01?olo?@02Ood
m?Coo?cdooclm?olo?Com?Cdooclm?odm?Coo?cdooCdm003ooclm00OooCd
k?o/k>?ob]_Kom;:`On?SfGo4EBYob9UZOlIG;7oC7jaogj?SolIKK7o/KVO
ob9f^OlR<R[o8WJioc9f/OmnWkWoKHnGogJG`OnO`K7oWiN7oaU]/OnY`L[o
m?C/oa5DZOlbIJWoIHNYok6iUolRM[WoIHNYoinOOP02odan/@05oinOO_m]
SkWo/K6iok6a^Oodm>`00oooool2ooclm003ooCdm?olo?Coo?cd00Soo?cd
0oodm>`01?odk=_om?C/ooCdk?odm?@4ooclm004ooCdm?olo?Com?C/oocl
m0?od/ZYY?o^k^h005[oi^KV00KoG6f7ocYDQomUQjWoC6fGofF7ZOmDMYL4
ofF7Z@;oKHni0_mnWkT00ona/KWoUkW:oiNibP05oiNibP0MojW1b_nG^L[o
UkW:ojW1b_nG^L[oZL[BojW1b_nO`K7oSk71off7O_nOZJWoWhm]ol6a^OoB
bZWom>cKoncSb_olo?Cohm;1ooCdm?oSfm_ohjV?om:76OoSWb;ohimDon>O
>_oBQaWohiljon>OE?oKOT`00_oSWe@00ooSWc[ofhlbol6a^@02oncSbP04
on?B/Oo:`Iook>?:on?B/@?om>cK00koo?cdoeaLC?mnOVgob]_KodBOSolA
WhOo4InGok6iZOlAWiOo4In7oooooonOSfgohm;1on?Kf`;om?Cd01;oo?cd
ooCdm?odm?Com?Cdonclm?ooooooo?cdom^OKOnaKAWofim]om]f<_oKQfGo
fim]oncK`Oolo?CoooooooCdm?olo?@3ooCdm007ooclm?oSd[7om?C/oooo
oooBbZWoWhm]ooclm003ooCdm006onclm?oooooo^KV?oa4A4Om4A2[oIE@b
0_m4A2X02?m4>R[oA4@Zoa4A4Olb:R;o>SXbod@j:_lj>S;oA4@b0_m4>RX0
2_lj>S;oA3XZocXj<_m4>R[o>SXbod@j:_lb:R;oZJV?ol6iQooBbZT2ob8R
4@0;oiMnE?niWgkom?C/ogInG?m]KECoIFDjohMnE?nOWgkoUhmfonc/hood
m?@00oodm>`02?olo?Com?C/ooCdk?odm>coo?cdooCdk?olo?CoShMD0_n7
IC802_na/HooIE`Zofe]E?mnMUCo/K6?okVaWonOUhOo^Imnooooooodm?@2
ooclm005ooCdm?olo?Com?Cdooclm?odm?@00_olo?@2ooCdm0;oo?cd00Go
m?Cdooclm?odm?Coo?cdooCdm002ooclm004ooCdm?olo?Coo?cdooclm0;o
m?Cd00Goooooon?B/Oodk=_om?CdoncK`@02ooCdm008ooclm?odm?Coo?cd
ooC/foljA1WoIE`Zogi]C?m]IB82ooooo`;o`KV700Wohm:aom_:Wooooooo
o?cdoncK/OooooooMWiLoncSb_ooool00_olo?@00oodm?Coo?cdooCdm003
ooclm005ooCdm?olo?Cok?cdooCdm?olo?@00_odm?@01?olo?Com?Cdoocl
m?odm?@2ooclm003ooCdm?olo?Com?Cd00;oo?cd00Com?Cdooclm?olo?Co
m?Cd0oolo?@2ooCdk0?oo?cd00Soooooooclm?odk=_om>?:ooooooodm>co
m>cKon?Kf`Gob]_K01co/K6iokViZOlAE:WoSk71ol[Kfona^JWoSiN?oaU]
/Oo:/JWo8WJiob8bA?mDQk7oC7jaoff?^On7Wk7o<WJaoinYZOlR8Q7o8WJi
ogjO^Oolo?CoE8Naob9UZOmfUk7oWiN7oeB7/Om]SkWohm:a0_oVi^H2oocl
m003ooooooolo?Coo?cd00?om?Cd1Oolo?@00oodm>coo?cdooCdk002ooCd
k003ooC/foodm>com?C/00?oo?cd00?om?Cdooclm?olo?@00_olo?@00ood
m?Coo?cdooclm003ooclm004ooCdk?na/Hoofl6Ool6iQjCoi^KV001Jonk^
kP03odaDKOm]OXooIHNY00CoIHNY0_m]SkT01omUQjWoKHnaogJG/OmnWkWo
Sk71oiNib_n?/L400_nG^LX3ojW1bP;oUkW:00KoZL7:oiNib_nY`L[oUkW:
oio1/OnY`LX4oiNibP0=ojW:d_n7UjWo^KVYoeaLC?ni^JWoZJV?om;:`Ood
m>cok>cSonclm?oSd/7ok:Ufom^?<P04on>OE009on>O>_oSWeCohiljom^?
<_oKWfgob[6YoncSb_o/fl7om>?:00;ohm:a01?ohm;1oncSb_odm>com>cK
ooclm?nGSgKoKHnGooclm?nOZJWo/L[:ooC/fom]SiOoO/6GokViZOoooooo
hm_Kom_:Woo/fk7ooooo00?om?Cd00Soo?cdooCdm?ooooook>?:ok5]6OoK
/Iooo?cdooC/f`Cooooo1Oodm?@01?olo?Com?CdooCdm?olo?@2ooCdm003
ooCdk?n7IC;om>cK00Com?Cd00[oooooom_:Wol0003o>T@IofEU>_mL>R;o
A4@bod@j:_lj>R;o4A4A0_m4>RX01?ljA3;oA4@ZocXj<_lj>S82od@j:P0@
ocXj8_m4>R[o>SXRod@j:_m4A2[o>SXbobXR6Olj>R;oIFDjobXA2?lI6AWo
SgIDokViSoodk=_oG5a<ofe]E0;oIFDj00Co^KVGoinOSoodhl[om?Cd0_od
m>`00oolo?Com?C/ooCdk003ooCdk00@ooCdm?odm>co`KV7okViSonOOTco
^KVGofeU8_n7IC;oA3XRohMU<_mnKFGoZJV?oin?KOooooooo?cdooCdm0;o
o?cd00Com?Cdooclm?olo?Com?Cd0_olo?@01_odm?Coo?cdooclm?odm?Co
o?cdooCdm0;oo?cd00?om?Cdooclm?odm?@00_olo?@3ooCdm0;oo?cd00So
m>cKooCdk?ooooook=_1ooooooodm?Coo?cdooCdm0;oo?cd00Co`KV7okVG
KOo1^HOob[V?0_ooool04_odk=_oo?cdon?Kfoo/hl[ob/6YokVOO_oK`Ioo
ooooogInG?oSd[7oooooooCdm?olo?Com?Cdooclm?odm?Coo?cdooCdm0?o
o?cd00?om?Cdooclm?odm?@00_olo?@01oodm?Coo?cdooCdm?olo?Com?Cd
ooclm?odm?@00oolo?@2ooCdm003ooclm?odm?Coo?cd00?oo?cd0_ooool0
2?odm>com>?:on?BWoniWgkoShmUogi]IOmDKGKoOYni1Oo:fm/07_oSk?Co
b]_Kol[Kfonab/[o^K6OoaUL/On?/L7ob]_KoinYZOnOWhoo6FfaokViZOlR
M[Wo8VFYogJG/Om]SkWoC7jaoiN?QolRM[Wo8SYLoaTjM_m<O[7oUkW:oocl
m?o1/KWoSinionc/hoodm>com>cKonc/h`?oo?cd00?om?Cdooclm?odm>`0
1Oolo?@01_odm>coo?cdooCdk?odm>cok>cSooclm0;om?C/3_olo?@5ooCd
k004ooclm?na/Hoom?C/ooclm:Cok^k^001Jooooo`0<oc8Z8_m<E6goKHni
ofF7ZOmDMYOoIHNYoff?^Om]Sk7oIHNYogJG`OmnWkWoG8N?1OnG^LX00onY
`L[oUkW:oiNibP02oiNibP03ojW:d_nG^L[oZL7:00KoUkW:00?oZL7:oiNi
b_nG^LX00_nG^LX01onYb];oWin?okVGKOnGShOoWiN7ooCdk?o/k><00_od
m?@01OoK/JWofhlbon>O>_oSWeCohilj00CohimD00oob[V?ol6a^OoSd[7o
hm;1oncSb_odhl[o^KV?on?B/Oodk=_om?C/ooC/foolo?CoWjVYoff7O_ol
o?@00oooool01oolo?Coooooooooooodm?Com>cKooclm?o/hlX00_odm?@2
ooclm0;om?Cd00Kooooook5]6Oo/fl7oooooooCdm?odk=/2ooCdm006oocl
m?odm?Com?Cdooclm?odm?Coo?cd1?odm?@01oolo?Com?CdooCdm?oooooo
`KV7ooCSb_ooool01?odm?@03oo/fl7o0000oaUD<_mnG4coC4`jodA4:_m4
A3;o>SXRoaTI6Olb:R;oA3XZocY4<_lb>TCoA3XZocXj<P03od@j:P07ocY4
<_m4>R[o>SXbod@j:_m4A2[oQe@Zoa4A4@02oaTI4@0<obXR6OmL>R;o/K6?
ooCSb_mUG2[oIFDjoda<>_mUIC[o^KVGoinOO_o/fk7om?Cd1?odm>`00ool
o?Com?C/ooclm002ooCdk00=ooclm?oKbYoohm:aoinOO_o:/JWo^KV?oinO
O_n?QeCoQfDbogiLC?ni^IOo^IM]ooooo`02ooCdm005ooclm?odm?Com?Cd
ooclm?odm?@00_olo?@2ooCdm005ooclm?odm?Coo?cdooclm?odm?@00_ol
o?@00oodm?Coo?cdooclm002ooclm004ooCdm?olo?Coo?cdooclm0;om?Cd
00[om?C/ooCdm?o/hl[oo?cdooCdm?olo?Com?Cdooclm?odm?Com>cK0_od
m>`04?o:fm_ob/6OokViSoniWgko/HMUol6iQooB/Hoohm;1ooC/foodm>co
ooooofe]E?o:`JWoooooooclm?odm?@6ooclm004ooCdm?olo?Cok?cdooCd
m0;oo?cd00_om?Cdooclm?odm?Coo?cdooCdm?olo?Com?Cdooclm?odm?Co
o?cdooCdm002ooclm003ooooooolo?Cok>?:00;oo?cd00com?C/ohMnE?mn
KDcoOWi]oeA]M_n7UjWoKGj?oaUL/Om<O[7oE8NaogjO^OoSk?@3ol[Kf`0=
on?/m?o:fm_ob]_Kol[Kfonab/[o/K6?ob9f^OmfUk7o^M;KoinYZOnGShOo
6Ffaom;:Z@02ob9f^@0:oinOSomDQk7o<WJaok6iUolbM[7oKHnioiNib_o/
k>?om?C/ooCdm0;ooooo0oolo?@00oodm?Coo?cdooCdm003ooclm006ooCd
k?olo?Com?C/ooC/foodm>com>cK0oodm>`3ooclm004ooCdm?olo?Coo?cd
ooCdm0;oo?cd00?om?Cdooclm?olo?@00_olo?@01?odm>coo?cdooCdk?od
m>`3ooclm005ooCdm?olo?Coo?cdooooooniWgh00_olo?BTooooo`00F_o^
k^h03_lb:R;o0000ohNGZOmfUl7oE8NaofF7ZOn?/L7oMYO1ohNO/OmDOWko
8R8Ao`000?nid]_oSk710_nG^LX01?n?/L7oZL7:oiNib_nO`K42ojW1bP03
oio1/OnY`L[oZL7:00KoUkW:0_n?/L43oiNibP0<ohna`OnY`L[oZL7:on>Y
SoniUfgod[6?on>YSooSd[7ok=_1on?Kfoo/fl7ofim]1_oSWe@02_o:/JWo
fk6Oon?B`OoSd[7ohm;1oncK`Oodk=_o`KV7ooC/foo/hlX2ooC/f`04off7
O_mDKGKoo?cdogk1U`;oA9n?00Wo4In7ogk1Uona^JWoooooon?Kfoodm?Co
k>?:ooCdm?olo?@00_odm?@01Oolo?Com?CdooCdk?oSZHoooooo00;om?Cd
00Gom>cKooclm?olo?Com?Cdooclm003ooCdm003ooclm?odm?Coo?cd00Co
m?Cd00Goo?cdooCdm?olo?CoWl6aooclm004ooCdm004ooclm?ljA1Wo8R8A
ofEU>P;oA4@b00_oA3XZod@j8_lI6AWo<RXRod@j:_m4A2[o>SXbod@j:_m4
A2[o>SXbod@j:P02ocXj<P0<od@j:_lj>S;oA3XRobXR6Oodk=_o`KVGoinO
O_lb:R;o:Q48ocXj8_m4A2[oMWiL0_m<A2801_m4A2[oA2XRoinOO_nOUhOo
d/ZYooooo`;om?C/00?oo?cdooCdk?odm>`01?odm>`03?olo?Cod[6?on?B
/OnOWgko/KVOol[1ZOni/IooWimnokViUoniWgko^KVYoinGQ`?oo?cd0_od
m?@2ooclm0?om?Cd00?oo?cdooCdm?olo?@00_olo?@04_odm?Coo?cdooCd
m?olo?Com?Cdooclm?odm?Coo?cdooCdm?olo?Com?Cdooclm?odm?Coo?cd
ooCdm?o/hl[ooooooncK`@;oo?cd00_om?Cdooclm?odm?CooooookVGE?na
QfGo^IM]olZiSooSd[7om>?:ooclm005ooooo`05ooclm?ooooooMWiLok6i
Woooool00_olo?@01?odm?Coo?cdooCdm?odm?@4ooclm005onclm?odm?Co
m?Cdooclm?odm?@00_olo?@01Oodm>coo?cdooclm?odm?Cooooo00;oo?cd
01?om?C/ooC/foolo?Co^KVYohmf:_m<E6goIHNYohna`Oo:`JWoSiN?oc9U
ZOlAE:WoE8NaogJG/On7Wk7o8VFYonc/hoo:fm_om?Cd00Cob]_K01Kom?C/
onc/hoo:fm_ok>cSol[Kfona^IOo<WJaoff?^Onid]_o/KVYoinGQolRM[Wo
WjVYoc9f/OmDQk7ok=_1okViZOna/KWok>cSooCdk?olo?Cooooo0_olo?@2
ooCdm0;oo?cd00?om?C/ooclm?olo?@00oodm>`00oodk=_om?C/ooCdk002
ooCdk004ooclm?odm>coo?cdooCdm0?oo?cd00?om?Cdooclm?olo?@01ool
o?@2ooCdk0?oo?cd00Com?Cdooclm?olo?Com?Cd0_olo?@01?odm?Coo?cd
ooooooniWgh2ooclm:Cok^k^001JonKViP04obXR6OlR8Q7o0000odA4<P;o
KGj?00SoC5A]ocXj8_lZ4@So4A4AobXA2?n7OXooZL7:ohna`@;oUkW:00?o
/K6ioiNib_nG^LX02_nG^LX00on?/L7oUkW:oiNibP08oiNibP0;olZaZOna
^IOoUgiDolZ?<_naKAWok:Ufom^OKOoKOTcohimDon>O>_o/ZD`01?oSWe@0
2?oSWc[ok=^aoncSb_o:`Iook>?:oncK`OoSd/7ok>?:0_odhlX03_olo?Co
MWiLoeA]M_olo?CoSlZGoio1/Onab/[oi^KVohO:/OlAWhOod/[1ooC/fooS
fm_ok>?:0_odm?@03?olo?Com?CdooCdm?o/o?Com>cKom^aWooooooom?Cd
ooclm?odm>com?Cdooclm0;om?Cd00?oo?cdooCdm?odm?@01Oodm?@00ool
o?Com?CdooCdm002ooCdm003ogk1Uoolo?Com?Cd00;om?Cd017oo?cdooC/
folIE3;o>T@Iohn7E?mUIC[o>SXRodA4:_ljA3;o6ATIobXR6Om4A2[oA3XZ
ocXj<_m4A2[o>SXRocXj<P02od@j:P0EocXj8_m4>R[oA3XZodA4:_lb:R;o
SgIUokViUooBb/7ohm;1okVOO_m]IB;o:Q48oaTI6OlR<R[o<RXRod@j8_lj
>R;o^ImnokVaWoo:`Iooo?cd00?om?C/00?oo?cdooCdk?odm>`00oodm>`0
1Oolo?Cod/ZYoiMnE?nOUhOoQgiD00;oUhmf00KoZJV?olZaZOni^Hoo/KVG
okVOO_olo?@2ooCdm0;oo?cd00?om?Cdooclm?olo?@01?olo?@01Oodm?Co
o?cdooclm?olo?Com?Cd00;oo?cd00?om?Cdooclm?odm?@01?olo?@02?od
m?Coo?cdooCdm?odm?Cok>?:ooooooo/fl7om?Cd0_olo?@01?odm?Coo?cd
ooCdm?olo?@4ooooo`0<ooclm?odm?Coo?cdooCdm?olo?Com?Cdooclm?od
m?CoooooohMnE?nOWhoooooo0oodm?@2ooclm0;om?Cd00Coo?cdooCdm?od
m?Com?C/0oolo?@00oodm?Coo?cdooooo`03ooclm00DoncSb_nOSfgom?C/
oncSb_o1/HooKGj?ok6a^Om<8PSoOYnioc9UZOo1/KWo<VFYogJG/Ona^IOo
8VFYoiNib_o/o?CoWjVYoinOSolIG;42oaUDOP04off?^Oodm>cob]_Konc/
h`;ohncd00Ooo?cdojW:d_nid]_ob]_KoncK`Om<KIOo<WJa00;o/L[:00Go
^KVYohNGZOoVi^Kohm_KooCdk003ooooo`Soo?cd0oodm>`01_odk=_om?C/
ooC/fooSd[7oo?cdooCdm0;oo?cd00?om?Cdooclm?odm?@00_olo?@00ood
k=_om?C/ooCdk003ooclm007ooCdm?olo?Com?C/ooclm?odm>coo?cdooCd
k003ooclm005ooCdm?olo?Coo?cdooclm?odm?@01_olo?@01?oooooo^IM]
ooclm?o/`HNTonKViP00F_o^k^h03?lZ8QWo<RXRob8R4OlZ4@SoC5A]oda<
A?m4A3;o6ATAoa4A4OlR8Q7oSiniojW:dQ[oUkW:00coZL7:oiNib_nG^L[o
/L[:om;:`OnOSfgo/HMUolZ?<_oK/Ioom>?:om^OKOoSWcX4on>OE003onbY
C?oSWc[ofl6O00;ok>?:00_o`KV7ooCSb_o/fl7ok=^aoncSb_odk=_oo?cd
ok6iUoljA4cok>?:ooCdm004ooooo`05oio1/Omn`IOoooooon?B/Oo:`JT0
0_olo?@4ooCdm003oooooooKWfgooooo00;om?Cd00Wom?C/ooCdm?olo?Co
m?Cdooclm?odm?Coo?cdooCdm?olo?@00_odm?@01?olo?Com?CdooCdm?ol
o?@2ooCdm003oooooomn`IOohm_K00?om?Cd00Ook?cdoooooolI6A7o:Q48
oin?KOn7IC;oC4`j00;oA4@Z00Go6B8Roa4A4Om4A2[o>SXbodA4:P04od@j
:P07ocXj8_m4>R[oA3XZocY4<_lj>R;o8S8Zogi]C002oinGQ`0=oinOO_oB
bZWok>?:om;:`OnOSfgoID`IocY46Om4>R;oG3XRofEU>_nOWhoo^Imnoooo
o`09ooCdk00=ooclm?oBbZWoZJV?ol6iWon?QfgoID`IofeU8_nOQfgoWiN7
ol6aWona/HooUhmfooC/f`02ooclm0?om?Cd00Coo?cdooCdm?odm?Coo?cd
0_odm?@2ooclm00:ooCdm?olo?Com?Cdooclm?odm?Coo?cdooCdm?olo?Co
m?Cdooclm0?om?Cd00Ooo?cdooCdm?olo?Cok=_1ooooooo/fl7ooooo00;o
m?Cd00Goo?cdooCdm?olo?Com?Cdooclm002ooCdm00Fooclm?odm?Coo?cd
ooCdm?olo?Com?Cdooclm?odm?Coo?cdoooooonOSfgoSiN?ooooooolo?Co
m?Cdooclm?odm>com?Cdooclm?odm>coo?cdooCdk0?ooooo0oolo?@08?od
m>coSgI4oeaLC?m]MWKom?C/oncK`OnGShOo<VFYol6a^OoBbZWo4EBYoff?
UomDKGKo4EBYojW:d_odhl[o/L[:oa5DZOna^Ioo<VFYogjO^Oo:fm_oWjVY
oinOSolRM[WoOYniohna`OnY`L[om?Cdon?/m?o:fm_ok>cS0_o:fm/2ojW:
dP05okWBfooSd[7oWjVYok6a^Oodm>`00_olo?@2ooooo`;oo?cd00?om?Cd
ooclm?olo?@00oolo?@2ooCdk004ooC/foodm>com>cKooclm0;om?Cd00Go
o?cdooCdm?olo?Cohm:aooCdm002ooclm003ooCdk?odk=_om>cK00;om>cK
00Gom?C/ooclm?odhl[om?Cdooclm002ooCdk0?oo?cd00?om?Cdooclm?ol
o?@00oolo?@00oodm?Coo?cdooclm004ooclm003ooCdm?olo?Com?Cd00;o
o?cd00CooooookVOO_o/k>?oo?cdY?o^k^h005[ooooo00Go8RXZobXR6OlR
8Q7oA4A<odafOP02odA4C008odaDKOmnKFGoUgiDojW1b_nG^L[oSk71oiNi
b_na/KTCoiNibP03ojW1b_nG^L[oZL7:00;oUkW:00coWl6aoiNib_nG^L[o
ZL7:om_1WooKWfgofhlbokVOO_oSk?Com>cKom]nC?oSWcX4on>OE00Ion>O
>_oK`Iook=_1oncSb_oBb/7ohm:aoncK`OoSd/7om>cKoncSb_odm>cok>?:
oeA]M_oK/JWo/KVOooclm?oooooom?CdoooooonO`K7oO/6Gooooooodm>co
^Imnooooo`02ooCdm005ooclm?odm?Com?Cdooooooo:MR800oodm?@2oocl
m0;om?Cd00?oo?cdooCdm?odm?@00oodm?@01?olo?Com?CdooCdm?olo?@3
ooCdm004oooooonO`K7od/[1ooclm0?om?Cd00Koooooob8R4OlIE3;oOWIU
off7O_m<C3X2od@j8P0Poc8Z8_lZ8QWoA3XZocXj<_m4A2[oA3XZocXj<_lj
A3;o>SXbod@j:_m4A2[oA3XZocXj<_ljA3;o<RXRogi]C?nOUhOoShM]oin?
KOmnMVGo/KVGol6aWoo/hl[ohm:aom;:ZOn?QfgoID`IobXR6Om4A2[o^Imn
ooooooodm?@3ooCdk00?ooclm?odm>com>cKooC/foodm>com>cKom;:ZOoS
d[7o^K6OokVOO_nYZHooWhm]ohn?IOm<C3[oUhmf00;o/KVG00Cok=_1ooCd
m?odm?Com?Cd0oolo?@02?odm?Coo?cdooclm?odm?Coo?cdooCdm?olo?Co
m?Cd0_olo?@01Oodm?Coo?cdooCdm?olo?Com?Cd00;oo?cd00Com?Cdoocl
m?olo?Com?Cd0_olo?@00oo/fl7om?CdooCSbP02ooCdm005ooclm?odm?Co
o?cdooCdm?olo?@00_odm?@04_olo?Com?Cdooclm?odm?Coo?cdooCdm?ol
o?Com?Cdooclm?odm?Cooooook6aSom]QgkoooooooCdk?olo?Com?Cdoooo
o`Coo?cd02Ooooooooclm?n?MUCoOUa<ogi]IOoSfm_od/[1ohmfA?mDMYOo
<VFYogJG/OlRIJWod/[1ok6iWolAE:Wob]_Kom;:ZOlAE:WoKGj?oinYZOlA
E:Wo/L[:ok6iUomLKHOo6Ebaok6iWomUQjWoC7jaon?/m?nOZJWoWin?oaU]
/On?UhooOXn?ohna`Oo/o?Cohncdonc/hooSk?@00oo/k><00oodm>coo?cd
ooclm002ooooo`;om?Cd1_olo?@4ooCdk003ooC/foodm>coo?cd00;om?Cd
1?olo?@01?odm?Coo?cdooclm?o/fk43ooC/f`;om?C/0oooool2ooclm003
oncK/Oodm>com?Cd00?oo?cd00Gom?Cdooclm?olo?Coo?cdooCdm006oocl
m004ooCdm?olo?Coo?cdooCdm0Coo?cd00Gom?CdooooooniWgkok>cSoocl
m02Tooooo`00F_o^k^h03_lb:R;o:R8IoaTI6Om4A4coSc9<odaDKOm<C4Co
G5a<ogInG?mL>R;oIE@bohNGZOnYb];oSk711?nG^LX00onYb];oUkW:oiNi
bP02ojW1bP;oUkW:00?oZL7:oiNib_nY`LX00_nG^LX00onY`L[oUkW:oiNi
bP03oiNibP03ojW1b_nYb];oZL7:00?oZL7:00KoUkW:ojW:d_nid]_ohjV?
om^OKOo/k><2ooCdm004onbYM_oSWc[ohimDonbYC0;ohimD00SohjV?on?B
/Oo/hl[ok>?:on?B/Oo:`JWohm:aoncSbP;om>cK00Goo?cdok6iUoni^Hoo
ooooon?Kf`02oncSbP08ohO:/OlAWhOo^KVYooooooodk=_ohm;1ooCdm?ol
o?@3ooCdm004oooooooKWfgofk6Yooooo`;oo?cd00Kom?CdooCdk?olo?Co
o?cdooCdm?olo?@2ooCdm004ooclm?odm?Com?Cdooclm0?om?Cd00Koo?cd
ooCdm?odm?Cok>cSohO:/Oodk=/3ooCdm00?ooooooljA1Wo8R8AogInG?mL
KGKoC4`joda48_ljA3;o6B8Roa4A4Om4>R[oA4@bocY4C?m4>R[o>T@b00?o
A3XZ00[o>TA<ocXj<_m4>R[oA3XZob8b:_mL>R;o^KVGojVYSon?QfgoWhm]
0_nOWgh02OniWgko/KVGol[1ZOo/hl[od/[1okViUomUG2[oID`Iooooo`03
ooC/f`03ooCdk?odk=_om?C/00?om?C/00koooooon?BWooBbZWo`KVGokVi
Uona^Ioo`K6OokViSon?SfGo^Imnok6iUonYZHoohm;1ooooo`;oo?cd0_od
m?@2ooclm0;om?Cd00?oo?cdooCdm?olo?@00_olo?@2ooCdm004ooclm?od
m?Coo?cdooclm0;om?Cd0_olo?@2ooCdm00=ooclm?odm?Com?CdoncSb_od
m>cok>?:ooooooolo?Com?Cdooclm?odm?Coo?cdooCdm002ooclm0;om?Cd
00_oo?cdooCdm?odm?Coo?cdooCdm?olo?Com?Cdooclm?oooooob/6YogIn
G003ooooo`0aooCdk?oSd[7oo?cdooCdk?o1^HOoSgi]onc/hon?SfGoKGj?
oaUL/On?WkWo6Ebaohn7KOm]MWKo4EBYooCdk?ooooooSinioeB7/Oo:`JWo
6EbaocYLM_lI8S;o4EBYofF7ZOni^JWo4EBYojW:d_o1/KWoKHMnoa5DZOnO
WhooKHnaodan/Oo:fm_oSiN?oinOSolIKK7o6Ebaoc9UZOm<KIOohm_Konc/
hoodm>coo?cdooCdm?olo?Com?Cdooclm002ooCdm004ooclm?odm?Coo?cd
ooclm0;om?C/00Som>cKooCdk?odm>com?C/ooclm?odm?Coo?cdooCdm0Go
o?cd00_om?Cdooclm?odm?Com?Cdooclm?odm?Coo?cdooCSb_odm>coo?cd
ooooo`02ooclm008ooC/fona/KWoWin?ohn?IOoooooom>?:ooCdk?olo?@2
ooCdm0[oo?cd00Com?Cdooclm?olo?Com?Cd0oolo?@02?odm?Coo?cdooCd
m?olo?CoooooolZiSooSd/7oo?cdY?o^k^h005[oi^KV01Co<RXRoaTI6OlZ
4@SoKGIfoeaLC?m4A4coC4`jodaDKOmnKFGoG3XRoda<A?na/KWo/L[:oiNi
b_nY`L[oUkW:ojW1b_nG^L[oWl6aojW1bP?oUkW:00GoZL[BoiNib_nG^L[o
ZL7:oiNibP02ojW:dPOoZL7:00?oZL[BojW1b_nYb]800_nY`LX02OnYb];o
ZL7:oiNib_nYb];o`KVGom;:`Oo:`JWod/[1okViZ@02olZiS`05ok6aSooK
Wfgok:U<om^OKOoBbZT00ooSd/400oo:`JWob/6OooC/f`03oncSbP03ol[1
ZOniWgkoQlZa00?o4In700KoA9n?oio1/Ooooooom?Cdonc/hooSd/42ooCd
m006ooclm?odm?Coo?cdonclm?oKOTcooooo0oodm?@01oolo?Com>cKooCd
m?odm?Coo?cdooCdm?olo?@01_odm?@00oolo?Com?CdooCdm002ooCdm00<
ooclm?mn`IOob]_Kooclm?odm>cok?cdoooooomUG1Wo0000ogifIOmnOVgo
C4`j0_m4A2X02Olb:R;o6ATIodA4:_m4>R[o>SXbodA4:_lj>S;oA3XZocXj
<P02od@j:P09ocXj<_m4>R[o>SXbod@j:_m4>R;o`KVOoinGQonOWgkoShM]
00;o/K6?00WoWimnoiN?M_niWgko/KVGolZaZOoSd[7ok>?:ol6iUoolo?@0
0oodm>`3ooCdm0?om?C/00koooooon?BWooBbZWo^KV?ol[1Won?SfGoWimn
okViUona^IOoShM]ok6aSonOWhoohm:aooclm0;om?Cd00Coo?cdooCdm?ol
o?Com?Cd0_olo?@3ooCdm007ooclm?odm?Coo?cdooclm?odm?Coo?cdooCd
m002ooclm003ooCdm?olo?Com?Cd00;oo?cd00Oom?Cdooclm?olo?Com?C/
om;:ZOolo?Com?Cd00;oo?cd00Oom?Cdooclm?odm?Com?Cdooclm?odm?Co
o?cd00;om?Cd0oolo?@00oodm>coo?cdooooo`02ooclm00DokVaWomfOUco
ooooohm]C?n?SfGom>cKocYDG?o:fm_om?C/ooCSb_lbIJWoKHniogInG?lI
G;7oZL[BoncSb_ljIIOo<TAfocYUUomDQk43ol[Kf`0Fok6a^OoBbZWo8VFY
ob9UZOlRM[WoC7jaoc9UZOo:`JWo8VFYohna`Oo:`JWoOXn?oaU]/OnOWhoo
KHnGoaU]/Onid]_oi^KVon?B/Ona/KWohm_Konc/h`;oo?cd00?om?Cdoocl
m?odm?@01Oolo?@2ooCdk0;om>cK0_odm>`01?olo?Com?Cdooclm?odm?@3
ooclm003ooCdm?olo?Com?Cd00;oo?cd00Com?Cdooclm?odm?Com?Cd1Ool
o?@03_oSdYoom>cKoncSb_n?Uhoo^K6Oooooooodk=_oIINaoff?/OmfOUco
ooooooC/foo/hl[ooooo0_olo?@01Oodm?Coo?cdooclm?olo?Com?Cd00;o
o?cd00?om?Cdooclm?olo?@00_olo?@01?odm?Coo?cdooclm?odm?@6oocl
m003on?BWooSd/7oo?cd0:Coi^KV001Jonk^kP06obXR6Olb:R;o6ATIod@Z
8_lbA7KoG5a<0_m<E6d2ofED<P04ofe]E?mnKFGo/KVYok6a^@goUkW:00Go
ZL7:oiNib_nO`K7oZL7:oiNibP0:ojW1bP04ojW:d_nGShOo^KVGom_1W`;o
d/[100god/ZYoncSb_o/k>?ok>?:om^aWoo/ZGKohimDonbYC?oKWfgoUhmf
on?B`Oo/hl[ohm;100Cok>?:00KoflZOon?B/OoSd[7oUhmfooCdm?odk=/2
ooclm0?ooooo00Kom?Cdonc/hoodk=_om?C/ooCdm?olo?@3ooCdm00:om^7
IOoooooom?CdooCdm?olo?Com?CdooC/foolo?Com?Cdooclm0?om?Cd00Co
o?cdooCdm?odm?Coo?cd0_odm?@06_olo?Com?CdooCdm?odm?CoooooohO:
/OnG^L[oo?cdooCdm?odm>coooooohmf:_lIE3;oMWiLoea]M_m<C4CoA3XR
odA4:_lR<R[o6ATAocXj<_m4>R[o>SXbod@j:_lj>S;o>SXR0_m4>RX03Olj
>S;oA3XZocY4<_ljA3;oA3XZod@j8_o1^IooZJV?ok6aSonOWgkoWhm]oinG
QonOWgh00_nYZHl01onOWgkoZJV?ok6aSonOWgkob/6Oooclm?odm?@02?od
m>`05?olo?CoflZOom;:ZOnYZHoo^K6OoinOO_niUfgo/K6?oinGQoni^IOo
ZJV?ok6aSooK/JWoooooooCdm?olo?Com?Cdooclm?odm?Com?C/0_odm?@0
0oolo?Com?Cdooclm002ooclm00:ooCdm?olo?Com?Cdooclm?odm?Coo?cd
ooCdm?olo?Com?Cdooclm0;om?Cd0_olo?@01?odm?Coo?cdooCdm?odm?@2
ooclm0;om?Cd00?oo?cdooCdm?olo?@00oodm?@2ooclm003ooCdm?odm>co
o?cd00;oo?cd01OoOVe<on?B/OoK/IooC4a4oeAnO_o/hl[od/[1oc9UZOoB
b/7oIHNYoeB7/Oolo?CoWimnoaU]/Om]SkWohm;1oa5DZOljE5co<SY4oaUL
/Ona^IooIHNYoeB7/@02onk^kP0AohNGZOna/KWod/[1ob9UZOnG^L[ok>?:
ofenSolIG;7ob/6Yoc9f/Om]SkWo`K6iojVYSomDQk7ofl6Oom;:`Oo1/KT0
0oolo?@01?ooooooo?cdooooooodm>`2ooclm004ooCdm?olo?Com?C/ooCd
k0;om>cK0_odm>`01Oolo?Com?Cdooclm?olo?Com?Cd00Goo?cd00?om?Cd
ooclm?olo?@01Oolo?@00oodm?Coo?cdooclm004ooCdk00@ooclm?oBbZWo
o?cdom;:`Om<OXooZJV?ooooooodm>co>SXRobXR6OmfOUcoooooooCdk?o/
fl7oooooooCdm0;oo?cd00?om?Cdooclm?odm?@00_olo?@01Oodm?Coo?cd
ooclm?olo?Com?Cd00Koo?cd0_odm?@01_olo?Com?Cdooooooo/fl7ob/6Y
ooclm:Cok^k^001Jooooo`0=oaTR8_lZ8QWo6ATIoda<>_mLG4coC5A]oea]
M_m<E6goQe@Zoe`j8_naQfGom>cKoinOS`02ohna`@03oiNib_n?/L7oUkW:
00SoUkW:00?oZL7:oiNib_nG^LX00_nG^LX00on?/L7oUkW:ohna`@02oiNi
bP04ohna`OnG^L[oUkW:oiNibP;oSk710_nG^LX01OnYb];oUkW:ohna`OoS
d/7od/[100;ohm_K00?ohm:aom^aWooSWe@00ooSWcX01?n?OVgoZJV?om;:
`Oo/fl42on?B`@03oncSb_o/k>?om>cK00;ok>?:00Gohm:aooCdm?odk=_o
b]_Kom;:`@02oio1/@05oho:Uoolo?Com?C/on?Kfoodm>`00_odm?@01ool
o?Com?Cdooooooo:MR;oooooonclm?olo?@00_odm?@01_olo?Com?CdooCd
m?olo?Com?Cdooclm0;om?Cd00Goo?cdooCdm?odm?Com?Cdooclm004ooCd
m004ooclm?ooooooQlZaooclm0;om?Cd00_oooooohmfA?l0003oMWiLofef
M_mUE3;oC4a4odA4:_lb:R;o6B8RocXj8P02odA4<P;oA4@Z017o>SXRocY4
6Olj>R;oA4@bod@j:_lj>S;oA3XZoc8Z8_lZ8QWob[6YoinGQona/HooWiN7
ok6aSonOUhOo/K6?ojVYS`02oinOOP05okViUonYZHooShM]ohn?IOolo?@0
2Oodm>`00oolo?Cohm:aom;:Z@02ol6aS`09ol6iWonOSfgo/KVGok6aSonY
ZHoo/KVOokVaWoo1^HOooooo00;om?Cd00Koo?cdooCdm?olo?Coo?cdooCd
m?olo?@2ooCdm0;oo?cd00[om?Cdooclm?odm?Coo?cdooCdm?olo?Com?Cd
ooclm?odm?Coo?cd0_odm?@00oolo?Com?CdooCdm002ooCdm0;oo?cd0ood
m?@02oolo?Com?Cdooclm?odm?Coo?cdooC/foo/hl[om?C/ooC/foodhl[o
IE`Z00;om?C/00Kom>?:ogj?SolbIJWok>cSoeB7/OmDKGH2oncSbP0Modan
/OooooooQinaoa5DZOljE5co6B9<oaU]/OnG^L[oWjVYogi]IOljE8Oo6Eba
oc9f/Oolo?Cooooooc9UZOna/KWoMWiLob8jG?lbM[7ob/6Yoc9UZOmfUl7o
d/[1ofenSoljIIOok=_1oinYZOooool00oolo?@00oooooooo?cdooclm003
ooclm003ooCdk?olo?Com?C/00;om?C/0_odk=/02?olo?Com?C/ooclm?od
m?Coo?cdooCdm?olo?Com?Cd0_olo?@01_odm?Coo?cdooclm?odm?Coo?cd
ooCdk0Coo?cd00Wom?Cdooclm?olo?Com?C/ooCdm?olo?Com?C/ooclm?od
m?@00oolo?@01_odm>cok=^aooC/foodhl[oE7JGoinYZ@;ooooo00[oG5a<
od@Z8_m]KECoooooooCdm?oSd[7oooooooCdm?olo?Com?Cd3?olo?@01?od
m?Coo?cdooclm?odm?@5ooclm003ooCSb_o1^IOoo?cd0:Cooooo001Jonk^
kP;o<RXR00_o8R8AoeaLC?m4A4coC4a4ofefM_m4A4coA4@bofE<6On7OXoo
ZL7:oiNibP02ohna`@03oiNib_nY`L[oUkW:00;oUkW:00?oZL[BoiNib_nG
^LX00_nG^LX01_nY`L[oUkW:oiNib_nY`L[oUkW:ohna`@WoUkW:00CoSk71
oiNib_n?/L7oUkW:0_n?/L403on7UjWoZJV?oncSb_oSd/7ok>?:om;:`Ood
m>coZL7:oiNib_o1/KWohjV?oinOO_mnMVGod/ZYonk^kP02on?B`@?ok>?:
0_oSd/400oodk=_ohm;1oa6OQ`02oa6OQ`;oA9n?00KoKHMnooclm?o/k>?o
m>cKooCdk?olo?@3ooCdm003onclm?oKQfGooooo00;om?Cd00Coo?cdooCd
m?odm?Coo?cd0_odm?@01?olo?Com?CdooCdm?olo?@2ooCdm004ooclm?od
m?Com?Cdooclm0Com?Cd00?oo?cdoho:UooSd/400_o/o?@01_ooooooWhm]
oaUD<_mnMUCoG6efoeaLC0;oA4@Z01ooA3XZob8b:_lb:R;oA3XZocY4C?m4
>R[o>SXboeaLC?m4:R;o8R8AocXj8_m4>R[o>SXbod@j:_lj>R;o>T@IokVi
UonOUhOoWimnohn?IOnOWgko^KV?oinGQonOWgkoWiN7ok6aSonOWgkoWiN7
oinOO_nOSfgoo?cd00Wom?C/013om?Cdon?B/OoSd[7ob/6Oom;:ZOo1^IOo
/KVGok6aSoni/Ioo/KVGok6aSona^IOo^Imnooooooodm?Coo?cd1?odm?@0
0oolo?Com?Cdooclm002ooCdm003ooclm?odm?Coo?cd00;om?Cd00?oo?cd
ooCdm?olo?@00_odm?@01?olo?Com?Cdooclm?odm?@2ooclm00UooCdm?ol
o?Com?CdooCdm?olo?Com?Cdooclm?odm?Coo?cdooCdm?olo?Com>cKom:a
SomnKFGob]_Kon?Kfoolo?Cooooooc9UZOm]MWKoA4@bocYUUolRIJWok>?:
ofFG/OljE5coWjVYofEU>_lI>WKo/L[:oinYZOlRIJWo6Ebaol6a^Om]Sk7o
KHniogi]C002ob9f^@0=oeb7Uom<E6goo?cdoooooonG^L[o6DB7ob8jG?lR
M[WoSinion?B`On7Wk7ok^k^ooclm002ooCdk007ooclm?ooooooo?cdoocl
m?odm?Coo?cdooCdm002ooclm0;om?C/00Com>cKooCdk?odk=_om?C/0_ol
o?@00oodm?Coo?cdooCdm002ooCdm005ooclm?odm?Coo?cdooCdm?olo?@0
0_odm>`01Oolo?Com>cKooC/foolo?Com?Cd00;om?C/00Koo?cdooCdm?od
m>coo?cdooCdk?odm?@2ooclm005ooCdm?olo?Coo?cdooCdm?olo?@00_od
m>`04?olo?Cok>?:ooCdk?olo?CoG7jGohnGSoolo?CooooooeafO_lj>R;o
IFDjooclm?oooooohm:aooclm?odm?@4ooclm003ooCdm?olo?Coo?cd00;o
m?Cd0_olo?@01Oodm?Coo?cdooclm?olo?Com?Cd00;oo?cd00?om?Cdoocl
m?odm?@00_olo?@00oodm>co/K6?ooclm02Tonk^kP00F_oVi^H02?m4>R[o
:R8IoaTI6On7C4CoC5A]odA4C?mLKHOoC5A]0_mUE3801On?WkWoZL[BoiNi
b_nYb];oZL7:00;oUkW:00?oZL7:ojW:d_na/KT01OnY`LX01?nG^L[oZL[B
ojW1b_nG^LX2ojW1bPOoUkW:0_n?/L42oiNibP0<ohna`OnG^L[oUkW:oiNi
b_n?/L7o/L[:ojW:d_nG^L[oWjVYok6iZOnid]_oZL7:0_nG^LX02_nYb];o
QiNYofefM_nGSgKod/ZYon?B`Oo/hl[ok=_1oncSb_o:`Il2on?B/@0GoncK
`Oo/o?CoG8N?oooooolAWhOo/KVYooclm?oooooom?CdooCdk?o/k>?ohm_K
ooCdm?olo?Com?Cdonclm?oooooofgHbooooooodm?Coo?cdooCdm?olo?@0
0_odm?@01?olo?Com?CdooCdm?olo?@6ooCdm003ooclm?odm?Com?Cd00?o
m?Cd01[ok?cdooCBO_oddWkoooooooCdk?oooooo`KVGoa4A4OmUIC[oKHMn
oeaLC?m<C3[oA4@bod@j8_lI6AWo8RXZodA4<_m4>R[o>SXRodA4:_m<C3[o
>UALoeaLC?lR<R[oA3XZocXj<P;oA3XZ00Ko<RXRokVOO_na/HooZJV?oinO
O_nOUhL3oinOOP06ojVYSona^IOoZJV?ojVYSon?QfgoUhmf2_odm>`01Ood
m?Com>?:on?B/Oo:`Ioo`KVO00;o^KVG00OoZJV?oinOO_na^IOo/K6?ojVY
SoniWgkooooo00?om?Cd0_olo?@3ooCdm009ooclm?odm?Coo?cdooCdm?ol
o?Com?Cdooclm?odm?Coo?cd00;om?Cd00Goo?cdooCdm?olo?Com?Cdoocl
m003ooCdm004ooclm?odm?Coo?cdooCdm0;oo?cd0_odm?@01oolo?Com?Cd
ooCdm?odm>coo?cdoc9UZOnY`LX00_odm>`02_oooooo<VFYob9UZOlbM[7o
6EbaofF7ZOo/hl[oMYO1ocYDG?mLQhl2oa5DZ@0GohnO^Ona^JWo6EbaonKV
i_oBbZWoWjVYob9UZOo/k>?oZL7:oc9UZOlb>TCoC7jaojW1b_o/k>?oo?cd
ojW1b_nG^L[ohm_Kooooooolo?Coooooooclm?odm?@01?olo?@01?odm?Co
m?C/ooCdk?odm>`3ooC/f`04ooCdk?odm?Com?Cdooclm0?om?Cd00Ooo?cd
ooCdm?odm?Coo?cdooCdm?olo?Com?Cd00;oo?cd00?om>cKooCdk?olo?@0
0_odm?@4ooooo`03ooCSb_o/hl[om?Cd00Goo?cd00Gom?Cdooclm?odm?Co
o?cdooCdm002ooclm00;ooCdm?olo?Com?CdooCSb_odk=_ooooooinYZOn?
Uhoom>cKoooooon?Uhl00_m<C3X01Oo/k>?oooooom;:ZOooooooo?cd00;o
m?Cd1?olo?@00oodm?Coo?cdooclm002ooclm003ooCdm?olo?Com?Cd00;o
o?cd00Gom?Cdooclm?odm?Coo?cdooCdm003ooclm003okVOO_olo?Coi^KV
0:?oi^KV001Jonk^kP03oaTR8_lb:R;oA2XR00;oC5A]00KoG5a<ofenSom4
A4coA2XRofE<6Ona/KT2ojW:dP04ok6a^OnYb];oZL[BojW1bP?oZL[B00?o
/L[:ojW:d_nYb]800_nYb]801?nab/[oZL[BojW1b_nY`LX>oiNibP07ojW1
b_nG^L[oUkW:oiNib_nY`L[oUkW:ohna`@04oiNibP;oZL7:00KoZL[Bohna
`OmfOUcoE6efon?B`OoK`Il3oncSbP0?oinGQoodk=_om>cKoncSb_odm?Co
O/6Goooooom4Whoo4In7odBOSonab/[oooooooCdm?odm>cok>?:00Com?Cd
00?oooooon?B/Oo/fk400_odm?@00oolo?Com?Cdooclm002ooCdm007oocl
m?odm?Com?CdooCdm?olo?Com?Cdooclm003ooCdm003ooclm?odm?Com?Cd
00?om?Cd00Wom>cKoncK/Oodm?Cok?cdoooooooSd[7o6ATAofEU>_m]MWH0
0_mLG4`01OljA3;oA4@bob8Z:_lb:R;o>T@b00?oA4@b00CoA4A<ocY4C?lj
E5coC4`j0_m4>RX01OljA3;o>SXbobXR6Ona/HooZJV?00;oWiN700coWimn
oin?KOna/HooUhmfoinOSona/HooUhmfojVYSonOWgkoWiN7ooC/foodm?@8
ooCdk00?ooCdm?o/hl[od/ZYol6iUoni/Ioo`KVGok6iUonOUhOo/K6?okVi
UonYZHoo/K6?oiN?M_ooooooo?cd00Com?Cd00?oo?cdooCdm?odm?@00_od
m?@01_olo?Com?CdooCdm?olo?Com?Cdooclm0;om?Cd00Goo?cdooCdm?od
m?Com?Cdooclm002ooCdm0?oo?cd0_odm?@01Oolo?Com?CdooCdm?odm?Co
o?cd00;om?Cd01[oo?cdonc/hoo/hl[oIINaoeB7/OnGShOoQiNYoooooona
/KWo<WJaojVYSolRIJWoSiniooCSb_mfUl7o>UALohNGZOnab/[oMYNaofF7
ZOna^JWo8WJiob9UZOlR<TCo8VFYoc9UZ@;oo?cd00GoSiniogjO^Ona/KWo
o?cdooCdm002ooclm007ooooooolo?Coo?cdooCdm?olo?Com?Cdooclm002
ooCdk00=onc/hoodk=_om>cKooclm?odm>com?Cdooclm?odm>com?Cdoocl
m?odm?Coo?cdooCdm003ooclm0;om?Cd00Coo?cdooCdm?olo?Com?Cd0_ol
o?@01?odm?Coooooooooooooool2ooclm00:on?B`Ona/KWoKHMnoooooood
m>com>cKooooooodm?Coo?cdooCdm0Coo?cd00?om?Cdooclm?olo?@00_od
m?@00oolo?Com?Cdooclm002ooCdk00=ooooooo:`JWoKGj?onc/hooooooo
QinaodaDKOm4A2[ok>?:oooooooSdYooooooooCdm002ooclm004ooCdm?ol
o?Coo?cdooCdm0;oo?cd00Oom?Cdooclm?olo?Coo?cdooCdm?olo?Com?Cd
00Coo?cd00?om?Cdooclm?olo?@00_olo?@00onOWgkoo?cdonk^kP2Sonk^
kP00F_ooool2oc8Z8P0<oda48_m<C4CoG5a<odaDKOm]MWKoC5A]oda48_lZ
8QWo^M;KojW:d_na/KWoZL[B1?nab/X6ojW:dP03ojW1b_nG^L[oZL7:00;o
UkW:0onY`LX00onG^L[oZL[BoiNibP03oiNibP07ojW1b_nG^L[oUkW:oiNi
b_n?/L7oUkW:oio1/@04oiNibP0@ojW1b_n?/L7oUkW:oiNib_nO`K7oUkW:
ojW1b_nYb];oQlZaoff7O_mLKGKoShmUom;:`OoBbZWohm;1on?B/@;ok>?:
01Gohm;1oncK`Oolo?CoG8N?odBOSolAWhOom>cKoio1/OlAWhOohm:aoncl
m?oSfm_ok=_1ooCdm?olo?Com?CdooCdk?ooooooflZOon>YSoooool01?od
m?@01Oolo?Com?CdooCdm?odm?Coo?cd00Kom?Cd00?oo?cdooCdm?odm>`0
0_odm?@2ooCdk003onclm?o/fk7ohm_K00;om?Cd00_ok>?:ocY46OljA1Wo
KGIfoeaLC?m<C4CoA4@bod@j:_lI8R;o<RXRod@j:P03ocXj<P;oA4A<017o
G5a<ocY4C?lb>TCo>SXRod@j:_m4A2[o8R8Aoin?KOnOWgkoWiN7okViSonO
WgkoWhm]ok6iUonOUhOoWimnoinGQ`02oinOOP04oinGQon?Qfgom>?:on?/
m0Wom?C/00?ok>?:om;:ZOo1^IL00_o1^IL3ok6aS`0?ojVYSona^IOo/KVG
oiN?M_oooooom?C/ooclm?odm>com?Cdooclm?odm?Coo?cdooCdm?olo?Co
m?C/00;om?Cd00?oo?cdooCdm?odm>`00_odm?@02?olo?Com?Cdooclm?od
m?Coo?cdooCdm?odm>coo?cd1?odm?@00oolo?Com?CdooCdk002ooclm008
ooCdm?olo?Com?Cdooclm?oSfm_ohm;1ogjO^OlRIJT2oaU4Q`0Fon?Kfool
o?CoMYO1ob94>_lAE:Wo/L[:on?KfonOZJWo>UafoinYZOoBb/7oWjVYoc9f
/Oo1/IooC7jaoeB7/OmnWkWo/K6ion?Kfoodm>cok?cdooCdk0;oo?cd00?o
m?CdooCdk?odm?@00oodm?@01Oodm>cok>cSooC/foodk=_ok>cS00;om?C/
00Goo?cdooCdm?odm?Com?CdooCdk002ooclm006ooCdm?olo?Com?Cdoocl
m?odm?Coo?cd1?odm?@01Oolo?Com?Cdooclm?odm?Coo?cd00;om?C/00ko
o?cdom;:`OnO`K7oWin?ooCdk?olo?CoQiNYofFG/OmLKHOoooooooclm?oS
d/7oo?cdooCdm0Coo?cd0_odm?@01?olo?Com?Cdooclm?odm?@4ooclm00=
ooCdk?odhl[oo?cdoncSb_m]Qgkom>cKooclm?nOZJWoG7jGoeaLC?ni^JWo
ooooom;:Z@03ooclm003ooCdm?olo?Com?Cd00Koo?cd0_odm>`01?olo?Co
m?Cdooclm?olo?@3ooCdm007ooclm?odm?Com?C/ooclm?oooooo^IM]oocl
m02Tooooo`00F_o^k^h03Olb:R;o6B8Rod@j:_m<C4CoA4A<oea]Qom]OXoo
C4a4ob8R4OlZ4@Sob]_Kok6a^Onab/X00_nYb]801Onab/[oZL7:ojW:d_na
b/[oZL7:00?o/L[:00CoZL[Bok7:b_nYb];oUkW:0_nYb]800onY`L[oUkW:
ojW1bP02oiNibP03ojW:d_nG^L[oZL7:00?oUkW:00CoZL7:oiNib_nG^L[o
Sk711onG^LX02on?/L7oUkW:oiNib_nG^L[oZL[BodafO_lZ4@SoKFDRogj?
SomLKGKo^KVG00;ohm;100Wok=_1on?B/Oo/hl[om>cKoncK`Oodm>cob]_K
ogk1Uoo/hlX00_ooool01Oo^k^kok>cSonc/hooSfm_ohm;100Com?Cd00Go
oooookU<0?oooooom?Cdooclm002ooCdm005ooclm?odm?Coo?cdooCdm?ol
o?@02oodm?@04_odm>cok?cdooCdm?odm?Cok=^aom;:`Oodm?Cok?cdooC/
fomUG1Wo>SXRogInG?mLG4coC4a4oda<>_m4A2[o8S8ZoaTR8P;oA4@b00Go
>SXbodA4:_m4A3;oC4`jocYDG002ocY4<P;o>SXb00?o>T@boda<A?n?MU@0
0_nGSgH01onOWhooWhm]ojVYSonOUhOoZJV?oinGQonGSgH00_nYZHl2oinO
OP03on?B`Oodm>com?C/00Wom?C/00CoflZOom;:ZOo1^IOo^KVG0ona/Hl0
1_ni^IOoWiN7ok6aSonGSgKoo?cdooCdk0Com?Cd00?om?C/ooCdm?odm>`0
0oodm?@01_olo?Com?C/ooCdm?olo?Com?Cdooclm0Com?Cd00Ooo?cdooCd
m?odm?Com?Cdooclm?odm>coo?cd00;om?Cd0_olo?@4ooCdm00FooCdk?od
m?Cok>cSon?B`On?WkWo8VFYok7:b_nYb];ok^k^oooooooSd/7o4EBYoeB7
/Oo:fm_om>cKohna`OljG7KoE6efoncSb_ni^JWo/K6iooclm0;ok>cS0ool
o?@00oodm?CohncdooCdm002ooCdm0?om?C/0oodk=/2ooCdk0;om?Cd00Co
o?cdooCdm?odm?Com?Cd0_odm>`01Oolo?Com?CdooCdm?odm?Coo?cd00;o
m?Cd00_om?C/ooclm?odm?Com?Cdooclm?odm>coo?cdooCdk?olo?Com?C/
ooC/f`02ooCdk00>ooclm?ooooooKHnGofFG/OmUQjWok>cSoooooonO`K7o
IINaoeanUoolo?Coooooon?B/Oooool2ooclm003ooCdm?olo?Coo?cd00;o
o?cd00Com?Cdooclm?odm?Coo?cd0_odm?@03oolo?Com?CdooCdm?o/fl7o
oooool[1ZOm]MWKok>?:ooclm?ni^JWoQinaok7:b_oSd/7ooooooncK/@03
ooCdm004ooclm?odm?Coo?cdooCdm0;oo?cd00Gom?Cdooclm?olo?Coo?cd
ooCdm002ooclm003ooCdk?olo?Coo?cd00Ooo?cd00?o/HMUon?B`Oo^k^h0
Xoo^k^h005[oi^KV017o<RXRobXR6OmL>R;oA4@boda<A?mDKGKoKGIfod@Z
8_lb:R;o:Q48ol[KfonYb];o/K6iojW:d_nab/[oZL7:ok6a^@03ok7:bP03
okWBfonYb];oZL[B00;oZL[B00GoUkW:ojW:d_nY`L[oZL7:ojW:dP06ojW1
bP03oiNib_nY`L[oUkW:00GoUkW:00?oSk71oiNib_nG^LX00on?/L400onG
^L[oSk71ohna`@03oiNibP0>ohO:/OlR8Q7o:Q48ohmfA?mLKGKoKGIfooCS
b_oSd[7ohm;1ol[1Woo/fl7ok>?:on?B/Oodk=/2ooooo`09on?Kfoo/hl[o
m?C/ooooooolo?Cok>cSom;:ZOo1/KWoo?cd00?om?Cd00?ofim]on?B/Ooo
ool00oodm?@00oolo?Com?CdooCdm007ooCdm003ooclm?odm?Com?Cd00So
m?Cd01Sok=_1on?B`OoSfm_om?Cdooclm?m]IB;o8R8AofefM_m]KECoG5a<
odA4<_lj>S;oA4@Zoa4A4Om4A3;o>SXbodA4C?m4A3;oA4A<oda<A?m<C3[o
>TA<odA4:_lj>S82od@j:P03ob94>_m]KECo/K6?00;oWimn00goUhmfoiN?
QonGSgKoZJV?oinGQonOSfgoZJV?oinGQonOWgkoWin?om_1Woodm?Cok>cS
00?om?C/00?ok>cSooCdk?odm>`00oodm>`2om;:Z@0:ol6iUoni^Hoo^K6O
okViZOnOUhOo/KVGok6aSoni^IOoWimnooclm0;om?C/00?om?Cdooclm?od
m?@00_odm>`01_olo?Com?C/ooCdm?odm>com?Cdooclm0;om?Cd00[om?C/
ooCdm?odm>coo?cdooCdk?olo?Com?CdooCdk?olo?Com?C/0_odm?@00ood
m>coo?cdooCdm002ooCdm004ooclm?odm>com?Cdooclm0;om?Cd00Ook>cS
on?B`Ona/KWo8VFYofenSoljE5coKHnG00;ooooo00co>VFGohnO^OoSfm_o
k>cSoncSb_o1/KWoC288ooooooolo?CoooooooCdk?odm?@2ooCdk003ooCd
m?odm>com?C/00;om?C/0oodk=/4ooCdk004ooCdm?olo?Com?C/ooclm0Co
m?C/00?om?CdooCdk?odm>`00_odm>`00oolo?Com?CdooCdk002ooclm003
ooCdm?olo?Coo?cd00;om?C/01Goo?cdooC/foodm>com?C/ooclm?odm?Co
o?cdooCdk?odm?CoooooohNGZOm]Sk7oIINaon?B`Oooooood/[1ofF7ZOmL
QiOom?C/ooCdm?o/fk400oodm?@01?olo?Com?Cdooclm?odm?@4ooclm00:
ooCdm?olo?Coo?cdooCdm?olo?Com?CdoncK`Ooooooo^KVYom;:Z@;om>cK
00Wok>cSonKVi_na/KWoWimnooooooo/fk7om?C/ooclm?odm?@00oolo?@2
ooCdm0;oo?cd00Com?C/ooclm?olo?Com?Cd1?olo?@02_odm>coo?cdooCd
k?odm>cok=^aooC/foo/k>?oo?cdokVOO_odk=^TonKViP00F_o^k^h2oc8Z
8P0<od@j:_ljA1WoG6f7oea]M_mLMWko>T@IobXR6OmL>R;o^M;Kok6a^OnY
b];o/K6i1onYb]801?nab/[oZL[BojW:d_nY`LX3ojW:dP05oiNib_nY`L[o
UkW:oiNib_nYb]803OnG^LX01on?/L7oUkW:oiNib_nG^L[oSk71ojW1b_n?
/L400onG^LX03onYb];oSk71ob8R4OljA1WoUhn7oeaLC?oBb/7ohm;1oncS
b_oBbZWohm;1oncSb_oBbZWom>cKooclm004oa6OQ`05ogk1Uoolo?Cooooo
olZiSoo1/Hl00_olo?@01?odm?Cok?cdom]f<_ooool6ooCdm004ooclm?od
m?Coo?cdooclm0Som?Cd00?oo?cdooCdm?odm?@00_odm?@0;?odm>com?Cd
onc/hooSd[7ok>?:onclm?ooooooShmUoaTI4OmfOUcoC4`joda<A?ljA3;o
A4@bocXj<_lA4A7oA4A<odA4<_lj>S;oA4@bodA4C?ljA4co>UALoda<A?lj
A4coA3XRocY4<_m4>R[o>T@boc8jA?mLG4co/K6?oinGQonGSgKoShM]ok6a
SonOUhOoZJV?oinOSonOUhOoWin?oiN?M_nGShOob/6O2oodm>`00ooSdYoo
hm:aol[1Z@02ol6iU`0;okVOO_na/Hoo^KVGojVYSoni/IooWhm]ooclm?od
m?Com?C/ooCdm?odm>`01Oodm?@01?odm>com?Cdooclm?odm>`2ooCdm003
ooclm?odm?Coo?cd00?om?Cd00Goo?cdooCdm?odm?Com?Cdooclm004ooCd
m004ooclm?odm?Com?Cdooclm0Com?Cd00Com?C/ol[KfonO`K7o4EBY0_lb
IJT00omUQjWom?C/ooclm002onc/h`07ooclm?odm>coo?cdooclm?lb:R;o
o?cdooCdk002ooCdm0?om?C/0oodk=/2ooCdk003ooCdm?olo?Com?Cd00Co
m?Cd00?om?C/ooCdm?odm?@00oodm?@2ooCdk003ooC/foodm>com?C/00;o
m?C/0_odm?@00oolo?Com?C/ooCdk002ooCdk005ooC/foodm>coo?cdooCd
m?olo?@00_odm?@01oolo?Com?Cdooclm?odm?Coo?cdoooooonOZJT00_mU
Uk403?oBbZWoooooonk^k_m]Sk7oE8NaooCSb_ooooook=^aooooooodm?Co
o?cdooCdm0Coo?cd00?om?Cdooclm?olo?@00_olo?@04oodm?Coo?cdoocl
m?olo?Cok=_1oooooooBb/7ob/6Oon?B`Oo/fl7ok^k^ofF7ZOmDSk7oUhmf
ooooooo/hl[om?C/ooCdm?olo?@00_odm?@4ooclm004ooCdm?olo?Coo?cd
ooCdk0?oo?cd0oodm>`02Oodk=_om?C/ooCdk?odk=_om?C/ooclm?oooooo
`KV7on?Kf`2Tonk^kP00F_ooool02olb:R;oA4@Zod@j:_m4:R;oKGj?ofef
M_mLKHOoC288obXR6OmUE3;o^M_d00KoZL[B00Co/L[:ojW:d_nab/[oZL7:
0_nYb]800onG^L[oZL7:ojW1bP02oiNibP04ojW1b_nYb];oUkW:ojW1bP;o
UkW:00?oZL7:oiNib_nY`LX02OnG^LX01?n?/L7oUkW:oiNib_n?/L43oiNi
bP0Cohna`OnO`K7oUkW:oio1/OnifoCo>UALobXA2?n?SfGoKGIfol[1Woo/
hl[ohm;1on?B/Oo:`JWo`KVGon?B`Oodk=_o/L[:ogk1U`02ooCdk008on?K
folAWhOoSlZGooooooo1/Hoob/6Oonc/hoodm>`2ooCdm004om]nC?o/o?Co
k?cdonclm0?om?Cd00?oo?cdooCdm?odm?@01?odm?@00oolo?Com?CdooCd
m00:ooCdm008onclm?o/fk7ok>?:onclm?olo?CoWimnoa4A4OmfOU`2oda<
>P06oeaLC?m4A3;oA3XZoa4A4Om4A3;o>SXb0om4A3801Om<C4CoG5a<ocY4
C?m<C3[o<SY400;oA3XZ0_ljA4`04?lb:R;o8S8ZokVOO_n?QfgoZJV?oiN?
M_nOWgkoZJV?oinGQonOWgkoShmUoinGQonOWgko^KV?ooclm?o/k><4ooCd
k003onc/hoodm>com?C/00;om?C/00_oflZOol[1Woo:`Ioo^KVGok6iUoni
^Hoo/K6?ok6iUona/Hoo^KVGoinOOP02ooCdk0Gom?Cd00?om?C/ooCdm?od
m?@01?odm?@00oolo?Com?CdooCdm003ooCdm0;oo?cd0_odm?@01?olo?Co
m?CdooCdm?olo?@5ooCdm004ooclm?odm?Com?Cdooclm0;om?Cd00[om?C/
on?Kfoo/hl[oooooonc/hoolo?CoooooooCdk?odm?Coo?cd1?odm?@01?oo
oooo8R8Aooooooodm>`2ooC/f`?om?C/00?om?Cdooclm?odm?@01oodm?@0
4Oolo?Com?CdooCdm?odm>cok>?:ooC/foo/hl[om>cKooCdk?odm?Cooooo
ooclm?ooooook>?:oncK`Oodm?Coo?cd00?om?C/00Com?Cdooclm?odm?Co
o?cd0_odm?@02_olo?Com?Cdooclm?odm?Coo?cdooCdm?olo?Com?Cdoooo
oonOZJT2off?/@03okViZOoooooohm_K00;oIHNY00?ok=^aoooooooSd[40
0_olo?@01?odm?Coo?cdooclm?odm?@3ooclm003ooCdm?olo?Com?Cd00Co
o?cd00oom?CdoncK`Ooooooo/KVYol[1ZOoSd/7od/ZYon?Kfom]SiOoIINa
ohMnE?olo?Cok>?:ooC/foolo?@00_odm?@3ooclm008ooCdm?olo?Coo?cd
ooclm?odm>coo?cdooCdk?odk=/3ooCdk004ooclm?odm?Coo?cdooclm0;o
m?Cd00Coo?cdooCdm?oK`Iook>?:Y?ooool005[ok^k^00ko<RXRod@j:_m4
>R[o>SXRoeaLC?mLKGKoC5A]od@Z8_lZ8QWoOVeUokWBfona/KWoZL[BokWB
f`;oZL[B00?o/L[:ojW:d_nYb]801?nYb]802_nG^L[oZL[BojW1b_nY`L[o
ZL[BojW1b_nG^L[oZL[BoiNib_nY`LX6oiNibP04ojW1b_nG^L[oUkW:ojW1
bP?oUkW:00?oZL7:oiNib_nG^LX01OnG^LX02on?/L7oUkW:oiNib_nG^L[o
^M;Koa4A4OljA1WoKHMnohn7KOodhl[ohm_K00?ohm:a00?ohm:OooC/foo:
fm/00oolo?@01oooooook>cSoa6OQooSfm_ok=_1ol[1ZOodk=/00oodm?@0
1?odm>cofgHbooooooooool6ooCdm003ooclm?odm?Com?Cd00gom?Cd00Co
k?cdooCdm?o/fk7o`KV70_odm?@00ooKbYoo0000ogInG002oda48P0Boda<
>_m4A3;oC4`joaTI6Olj>S;oA4@ZocY4C?ljA3;oA4A<oda<>_m<C4Co>UAL
oc8jA?lj>S;o>T@bod@j:_m<C4Co<SY40_lb:R803_mLG4coShM]oeaLC?mn
KDco^KVGojVYSonGSgKoZJV?oinGQonGShOoWimnokVOO_odm>cok>cS2?od
m>`03oodm?Cohm:aol6iUoo:`JWo^KV?ok6aSoni^IOo/KVGokViUona/Hoo
b[6YoinGQoodk=_om?CdooCdk002ooCdm003ooCdk?odm?Com?Cd00Com?Cd
00?oo?cdooCdm?odm>`00_olo?@01_odm?Coo?cdooCdm?odm>com?Cdoocl
m0?om?Cd00Koo?cdooCdm?odm?Coo?cdooCdm?olo?@2ooCdm005ooclm?od
m?Com?CdooCdm?olo?@00oodm?@2ooclm0;om?Cd00?om?C/ooCdm?odm>`0
0_odm>`01?o/k>?om>cKooclm?ljA1T2ooCdk0Som?Cd00Kok?cdooCdm?od
m?Com?C/ooCdm?olo?@3ooCdm0?om?C/00[ok?cdooooooooooooo?cdooCd
m?odk=_od/[1ooclm?odk=_ok=^a1?odm?@01?olo?Com?CdooCdm?olo?@2
ooCdm00Eooclm?odm?Coo?cdooCdm?olo?Com?Cdooclm?odm?Coo?cdoooo
oona/KWoIINaoff?/OnYZHooooooooC/fomUQjWoE8naol[1Woooooook=^a
00;om?Cd00?oo?cdooCdm?olo?@01?odm?@01Oolo?Com?Cdooclm?olo?Co
m?Cd00;oo?cd00oom?CdooCSb_oooooo`K6iom;:`Oodhl[ofk6OooCdk?n7
UjWoE8naogInG?o/k>?om?C/oncSb_odm?@01?olo?@00oodm?Coo?cdoocl
m002ooC/f`?om?C/0_olo?@01Oodm?Coo?cdooCdm?olo?Com?Cd00?oo?cd
00Com?CdoooooooSdYood/[1Y?o^k^h005[oi^KV00Co8S8Zoe`j8_m4>R[o
A2XR0_m]OXl01?mLG4co>T@IobXA2?nYZHl2okWBf`;oi^KV00?o^M;KonKV
i_nYb]800_nYb]800onid]_oZL[BojW:dP06ojW:dP03ok7:b_nYb];oZL[B
00;oZL[B00SoZL7:ojW:d_nY`L[oZL7:ojW:d_nY`L[oUkW:ojW1bP;oUkW:
0_nY`LX3oiNibP04ojW1b_nG^L[oUkW:ojW1bPKoUkW:00So^M;Koff7O_lb
:R;o>T@IohnGSooK`Iook>?:on?B`@Cok>?:00?ohm_KooCdm?odm?@00ood
m?@01_o1/KWok>?:ooCSb_o:/JWohm;1ooclm0;om?Cd00Gok?cdon?B`OoK
OTcok>cSooooo`03ooCdm003ooclm?odm?Coo?cd00gom?Cd01?ok?cdooCd
k?odm?Com?Cdon?KfooSd[7ok?cdooclm?oSd/7o0000ogInG?m<8PSoIE@b
oda<>_m4A3;o>T@boaTR8_m4>R[o>TA<00;o>T@b00GoA4@ZodA4C?m4A4co
G5a<oc8jA003od@j:P0BodA4<_m]KECoIE@bobXR6Olb:R;o>SXbod@j:_lR
>S;oC4a4ohn7KOnGSgKo/KVGojVYSonOWgkoWiN7oin?KOodk=_om?Cd0_od
m>`01?o/k>?om?C/ooCdk?o/k><2ooCdk00?ooCdm?o/fk7ob/6Ool[1Woni
^IOo^KV?okViUonOWhoo^KVGojVYSoniWgkoWiN7oncSb_odm?Com?C/00?o
m?Cd00?om?C/ooCdm?odm>`00_odm>`00oolo?Com?CdooCdm005ooCdm003
ooclm?odm?Com?Cd00[om?Cd00?oo?cdooCdm?odm?@01_odm?@01Oodm>co
m?CdooCdm?o/o?Com?C/00?om>cK0oodm>`01?odm?Cooooood@A0?odm>`2
ooCdm003ooCdk?odm?Com?Cd00;om?Cd00?oo?cdooCdm?o/o?@02Oodm?@2
ooooo`0;ooCdk?oSfm_ooooool6a^On7UjWoMYNaoff?Uoodm>com?Cdon?B
`Oooool00_odm?@00oolo?Com?Cdooclm002ooCdm0;oo?cd00?om?Cdoocl
m?odm?@00oodm?@04Oolo?Com?CdooCdm?ooooood/[1ofFG/Om]SkWoSiN?
ooooooolo?CoIHNYoeB7/Oni^IOooooooncSb_odm>coo?cd00;om?Cd1?ol
o?@01Oodm?Coo?cdooclm?odm?Coo?cd00;om?Cd013oo?cdooCdm?odk=_o
o?cdon?B`OnOWhooo?cdoin?KOolo?CoQiNYofFG/OmnOVgok>?:ooclm?od
hl[oo?cd0oodm>`01Oodk=_om?C/ooC/foodm>com?Cd00;oo?cd00Com?Cd
ooclm?odm?Coo?cd0_odm?@2ooclm003ooCdm?olo?Com?Cd00;oo?cd00?o
m?CdooCSb_o:`JT0Y?oVi^H005[ok^k^00CoA2XRod@j:_m4>R[o>T@I0_mL
KHL01?m<C4CoA2XRobXA2?o1/KT6ol[Kf`07okWBfoo:fm_o^M;Konk^k_ni
d]_oZL[Bonk^kP02okWBf`SoZL[B00?o^M;KojW:d_nYb]802onYb]800onY
`L[oUkW:ojW1bP02ojW1bP0=oiNib_nY`L[oUkW:oiNib_nY`L[oUkW:ojW1
b_nifoCo4A4AocY46OmUIC[od/[1ooCSbP02oncSbP04oncK/Oodm>com>cK
ooC/f`;om?Cd00Som?C/onc/hoodm?Cok=_1ol[1WooSfm_ok>cSon?B/@Co
m?Cd00Coooooon?B/OoKOTcok?cd0_odm?@00oolo?Com?CdooCdm00<ooCd
m0;om?C/00kom?CdooCdk?o/k>?om?C/onc/hoo/o?Cok>cSon?Kfoodk=_o
0000ogi]C?nGSgKoMWiLoda<>P;oA4@b00Ko6ATIocXj8_lj>S;oA3XZocY4
<_m4A382oda<A00;ocYDG?ljA3;o>SXbodA4:_lj>S;o8T@join7KOoSfm_o
6ATAocY46Olj>R800olj>S802_lR<R[oShM]okVaWonOUhOoWimnohnGSonO
Sfgok>?:ooCdk?o/k><7ooCdk009ooCdm?oSd[7od/ZYon?B/OnYZHoob/6Y
okViUona^IOo^KVG00;o/KVG00?oWimnoncK/Oodm?@00_odm>`6ooCdm003
ooCdk?odm?Com?Cd00;om?Cd00Com?C/ooCdm?odm?Com?C/1Oodm?@00ood
m>com?CdooCdk007ooCdm005ooCdk?odm?Cok?cdonclm?odm?@00_odm>`4
ooC/f`;om?C/1Oodm?@01Oo/o?CoooooofEU>_oBb/7oo?cd00?om?Cd00Ko
m?C/ooCdm?odm?Com?Cdooclm?o/o?@3ooCdm003ooCdk?o/o?Com?C/00;o
m?C/00gok>cSok6iZOnOZJWoMYNaok6iUoooooook^k^ofFG/OmnWkWoIINa
ooCSb_odm?Cohm:a00;om?Cd00Goo?cdooCdm?odm?Com?Cdooclm003ooCd
m005ooclm?odm?Coo?cdooCdm?olo?@00_odm?@04?olo?Com?C/ooclm?oS
fm_oIINaoff?/On?Uhooooooooclm?mLQiOoQiNYom;:ZOooooook>?:ooCd
k?odm?@2ooclm0;om?Cd00?oo?cdooCdm?olo?@00_odm?@04oolo?Com?Cd
ooclm?odm?Coo?cdooCdm?odm>com?CdooC/fomLKGKom?CdokVGE?oooooo
WjVYoeB7/OmnOVgob/6Yooclm?o:`Il01Oodm>`01?olo?Com?Cdooclm?od
m?@3ooclm003ooCdm?olo?Com?Cd00?oo?cd00Gom?Cdooclm?odm?Coo?cd
ooCdm002ooclm003ooCSb_ni/Iook^k^0:?ok^k^001Jooooo`?oA4@b00co
A2XRoea]M_mLKHOo>SXbocXj8_lI6A7ok>?:on?Kfoo:fm_ohm_Kol[KfooS
fm/6ol[Kf`?o^M;K00?ooooookWBfonid]/00_nYb]802?nid]_ooooookWB
fonYb];ooooookWBfonYb];o/L[:2_nYb]801Onab/[o^M;KojW:d_nY`L[o
ZL[B00?oZL7:013oUkW:oio1/OnY`L[oZL[BokWBfoljG7Ko8R8AobXA2?o:
`JWom>cKoncK`OoSfm_ok>?:on?Kfoo/hl[ok>cS0_odm?@00oodm>cok>cS
ooCdk002oncSbP03on?B`OoSk?Cohm:a00?om?Cd00Kom?C/ooCdm?oooooo
hm_Kom]nC?ooool@ooCdm003ooCdk?odk=_ok?cd00;ok>?:02;ohm_KooCd
k?odm>cok>?:onc/hoolo?Co0000ofEU>_mfOUcoQgiDoda<A?m<C3[oA4@b
oaTR8_lb:R;oA4A<ocXj<_m4A3;o>T@bodA4C?ljE5coC4a4ocY4<_lj>S;o
A3XZocXj8_m<C4Co>SXbojVYSon?Qfgo4A4Aod@j:_ljA1Wo>SXR0_lj>S80
2?m4A3;o`KVOojVYSona/HooShM]oinOO_oSd/7om?Cd1?odm>`02_o/k>?o
m?C/ooCdk?o/k>?ok?cdon?B`Oo:`Ioob/6YokViUoo:/JT2okViU`;o/KVG
00Ko/K6?ojVYSooBbZWoo?cdooCdk?oSk?@2ooCdm005ooCdk?odm?Com?C/
ooCdm?odm>`00oodm?@00oodm>com?CdooCdk003ooCdm004ooCdk?odm?Co
m?CdooCdk0Com?Cd00?om?C/ooCdm?odm?@00oodm?@2ooCdk0;ok>?:0_od
k=/00oodm>com?CdooCdm002ooCdm004ooCdk?odm?Com?CdooCdm0Com?C/
00?oooooogInG?o:`JT01_odm?@01_olo?Com?C/ol[1ZOoBb/7om>cKoocl
m0Gom?C/00oom?Cdooclm?m]Sk7oMYNaoff?^OnOZJWoooooon?B`OmUUk7o
MYNaofFG/Oo/fl7oooooon?B/Oooool01?odm?@01Oolo?Com?Cdooclm?od
m?Com?C/00;om?Cd00Gom?C/ooCdm?odm?Com?Cdooclm003ooCdm00:on?K
fomLQiOoKHnaohnGSoooooooo?cdon?B`OoSk?Co^Imnooclm0;om>cK00?o
m?Cdooclm?odm?@00_olo?@2ooCdm009ooclm?odm?Coo?cdooCdm?odm>co
o?cdooCdm?olo?Com?Cd00;om?C/00_oo?cdofe]E?oBb/7oSgI4oooooonO
ZJWoE7JGoeA]M_nOUhOoooooom_:W`02ooCdm0?oo?cd00Com?Cdooclm?ol
o?Com?Cd0_olo?@2ooCdm0;oo?cd00Oom?C/ooclm?olo?Coo?cdooCdm?ol
o?Com?Cd00Coo?cd00?o/KVGooooooooool0X_ooool005[ok^k^00[oC4`j
odA4:_m4>R[o<RXRofefM_mLKHOoC288ocXj8_lZ4@Som?C/0_oSfm/01?o/
k>?ob]_Kon?Kfoo/k><7ol[Kf`Go^M;K00?ob]_KokWBfonid]/02Onid]/0
0onYb];o^M;KokWBf`03ojW:dP03okWBfonYb];oZL[B00?oZL[B01goZL7:
ojW:d_nY`L[oZL7:ohna`OnY`L[oUkW:ojW1b_nid]_o>UALocY46Om]IB;o
k=_1on?B`Oodk=_ok=_1ooC/foo/fl7ohm:aooCdm?o/k>?om?C/onc/hood
m>cohm_KooCdm?oSfm_om>cKon?B/@04ooCdm005ooCdk?o/o?Coooooom_1
WooSZHl02Oodm?@01?o/o?Com?CdooCdm?odm>`2ooCdm0;om?C/00cok>cS
ooCdm?oSfm_om>cKon?Kfoo/o?CohncdoncSb_odm>coooooo`000?m<C3X2
oeaLC007odA4:_m<C4CoC4`jobXR6OlI8R[oA4@boc8jA002ocXj<P04odA4
<_m<C4Co>UALodA4:PGo>SXb01GoOVEDol[1Woo1/IooC4@RoaTI4OmUE3;o
6ATIod@j:_ljA3;oA4@boc8jA?m4A3;oZJV?oiN?M_oK/JWom?Cdonc/hood
m>cok>cSooCdk?o/k><00oodm>`01_odm?Cok>?:om;:ZOoBbZWo^KV?om;:
Z@;o/KVG00Ko^KVGol6aWonOWhoo^KV?ol6aWoolo?@2ooCdk0?om?Cd00Go
m?C/ooCdm?odm>cok?cdooCdm002ooCdk003ooCdm?odm>com?Cd00;om?C/
00Gom?CdooCdk?odm?Com?C/onclm002ooCdk0;om?Cd00?ok?cdooCdk?o/
k><01?odk=/2ooCdk0?om?Cd2?odm>`2ooCdm007onclm?odm>com>cKoooo
oonOWgko/KVGooC/f`02ooCdm0;oo?cd00?ooooooinOSon7IC800_mUICX0
5OmUC1Wo^KVYoncSb_o/hl[om?C/ooCdm?odm>com?Cdooclm?mfUk7oKHni
ogJG`On?Uhoom?C/onc/homUUk7oOYniofFG/OoK`Iooooooon?B/@03ooCd
m003ooCdk?odm?Com?Cd00;om?C/00Woo?cdooCdm?olo?Com?Cdooclm?od
m?Coo?cdooCdm?odm>`00oodm?@03?odm>cohm;1on?KfooBb/7oo?cdoooo
oomnShooE8naogifIOodm>cok>cSoncSbP;om?Cd01goo?cdooCdm?odm?Co
m?Cdooclm?odm?Com?C/ooclm?odm?Coo?cdooCdm?olo?Com?C/ooclm?od
m>com>cKoooooolb>TCoShM]ohmf>_oooooo/KVGoeB7/On?UhooWimnoooo
oooSd[7om?Cdooclm002ooCdm0;oo?cd00?om?Cdooclm?odm>`00_olo?@0
1_odm?Coo?cdooCdm?odm?Coo?cdooCdk0;om?Cd00Soo?cdooCdm?olo?Co
m?Cdooclm?odm>coo?cdokVOOZCok^k^001JonKViP06odA4<_m4:R;oC4@R
od@Z8_mLG4coC6f70_lb:R801omU<PSohncdon?KfooSfm_oi^KVon?Kfoo:
fm/00_oSfm/00oo:fm_ohm_Kol[Kf`09ol[Kf`03okWBfoo:fm_ob]_K00go
^M;K00?oi^KVojW:d_nYb]800_nYb]801Onab/[oZL[BojW1b_nY`L[oZL[B
00;oZL7:00ooSk71ojW:d_nY`L[oZL[BokWBfol0003oA140oin7KOoSd/7o
k>?:on?B/Oo/hl[ohm;1on?B/Oo/hlX00_odm>`00oodk=_om?CdoncSbP02
ooCdm00<on?B/Oni/Iooo?cdooCdk?odm?Com?C/ooCdm?odm>cok?cdoooo
ooo/ZGKofk6O0_odm?@01Oodm>com?CdooCdm?odm?Cok?cd00?om?Cd00?o
k?cdooCdm?odm>`00_odm?@03Oo/o?Cok>?:on?Kfoodk=_ohm_KooC/fooS
fm_ok>?:onc/hoodk=_oooooo`000?ljA3800_mLG4`01_m<C3[oA4@bodA4
<_lR<R[o<RXRocXj<P;oA4@b01Go<SY4ocY4C?m<C4CoC4`jocY4C?ljA1Wo
>TA<ocXj8_ljA4coA4@bofEU>_n?Qfgoo?cdok6iZOmfOUco`K6OoiN?M_lj
>R;o<RXRocXj8_lj>S800_m<C3X01?nOUhOo`KVGooclm?o/k><3ooCdk0;o
k>cS013om?C/onc/hoo/o?Cok>?:ol[1WooBbZWo`KVGol6iWona/Hoo^K6O
ok6iUonYZHoo/KVYoinOO_o1/Hook>cS1?odm>`01Oo/o?Com?C/ooCdk?od
m?Com?C/00;om?Cd00?om?C/ooCdm?odm>`00_odm>`01?odm?Com?C/ooCd
k?odm?@4ooCdk004oncSb_odk=_om>cKooC/f`;om?C/1?odm?@00oodm>co
m?CdooCdk002ooCdm00GooCdk?odm?Com?Cdonclm?odm>cok>cSooCdk?o/
k>?ok>?:ooC/foo/k>?om?C/ooclm?nYZHoo/KVGonc/hoodm>cok>cSom;:
ZOna/Hoo^K6OofEL6OmUICX00_m]KE@05_mUIC[oIE`Iogi]C?oSd[7ok>?:
ooCdk?odm?Cok>cSoooooon7UjWoQlZaoff?^OmfUk7om>?:ooCdk?mUUk7o
MYNaoff?^Oni^IOoooooon?B`Oodm>`8ooCdm004ooCdk?odm?Com?CdooCd
k0;om?Cd00?oo?cdooCdk?odm>`00_odm?@03Oolo?CoMYNaoff?/OmLOYOo
m?C/oooooon7UjWoIINaoginKOodk=_oo?cdon?B`Oolo?@00_odm?@01_ol
o?Com?C/ooclm?odm?Com?C/ooclm0Com?Cd00coo?cdooCdk?odm>com?C/
ooC/foooooooQgiDokViUoo:`Iooo?cdoncSb_nab/X2om;:`@05oooooooK
bYoom?C/ooCdm?olo?@00_odm?@2ooclm003ooCdm?olo?Com?Cd00;oo?cd
00Com?Cdooclm?olo?Com?Cd0_olo?@00oodm?Coo?cdooCdm002ooclm004
ooCdm?olo?CooooookVOOZCoi^KV001Jonk^kP0?odA4:_m4:R;oC4`joc8Z
8_m<C3[oKGIfod@A0?lI6AWoQe@Zon?/m?oSfm_ob]_Kon?Kfoo:fm_ohm_K
00oob]_K00?o^M;Kol[Kfonid]/01onid]/2ojW:dP03okWBfonYb];oZL[B
00coZL[B00WoZL7:ojW:d_nab/[oZL[BokWBfom]QgkoUgiDon?B`Oo/hlX0
0_odk=/2oncSbP0;on?B`Oo/fl7ok>?:ooCdm?o/k>?om?CdoncSb_odm?Co
m?C/onc/hooK`Il00oodm?@00oodm>com?CdooCdk003ooCdm003om]nC?oo
oooom?Cd00Kom?Cd00?om?C/ooCdm?odm>`01?odm?@04?odm>cok>?:onc/
hoo/k>?ok?cdon?KfooSd/7ok>?:on?/m?oSfm_oooooo`000?m4A3;oG5a<
ofED<_m<C4@2oda<>P05oc8Z8_lZ8QWoA4@bocY4<_m4A4`00_lj>S800om4
A4co>T@bocXj<P03ocXj<P0<ocY4<_ljA4coIE@boinGQoo/hl[o`KVOogIn
G?na^Ioob/6YogifE?lI6A7oA3XZ0_lb:R801Olj>S;oWin?okVOO_olo?Co
m?C/00;ok>cS1_odm>`01oo/hl[ob/6Yom;:ZOo:`Ioo^KVYol6aWoni^IL0
0_nYZHl2ok6aS`0;okVOO_o/k>?om?C/onclm?o/k>?om?CdooCdk?o/o?Co
m?CdooCdk?o/o?@01Oodm>`01Oodm?Com?C/ooCdm?odm>cok>cS00Com>cK
0_odm>`3ooCdm009ooCdk?odm?Com?C/ooCdk?odm?Com?C/ooCdm?odm>co
m?Cd00;om?C/00?ok>cSooC/foodk=/00_odk=/2ooCdk00QooCdm?oooooo
ooooooCdm?oSdYooo?cdol6aSonOWhook>?:ooCdm?odk=_o`KV7ofEU>_mf
OUcoKFDRoda<>_mUG2[o>UALogifIOljE5coOWi]ooooooo/o?Com?CdooCd
k?odm?CoooooohNO/Om]SkWoKHnaohNO/OoSd/7oo?cd00?oIINa00Ko/K6?
ooooooo/hl[ok>cSooCdm?odm>`2ooCdm003ooCdk?odm?Com?C/00;om?Cd
00?om?C/ooCdm?odm>`01_odm?@2ooclm00;off?UomfUk7oIHNYooC/fooo
ooooWjVYofFG/Om]OXood/[1ooclm?oSd[400_odm?@00oolo?Com?Cdoocl
m002ooCdm003ooclm?odm?Com?Cd00;om?C/0oodk=/2ooCdk005ooCdm?oo
ooooIE`IofEU>_oSd[400_olo?@01_odk=_ohm:aol[1ZOniWgko`KV7oncS
bP;om?Cd00Woo?cdooCdk?odm?Com?C/ooclm?odm?Coo?cdooCdm?odm>`0
0_olo?@2ooCdk0;om?Cd00Kok>cSooclm?odm?Com?Cdooclm?odm?@2oocl
m003okVOO_o^k^kok^k^0:;ok^k^001Jooooo`;oA3XZ00SoA4@bod@j:_lI
6AWoC4@Rod@Z8_lR:R[oWhM]on?/m0;ob]_K00?ooooool[Kfoo:fm/00_o:
fm/00ooSfm_ob]_Kon?Kf`09ol[Kf`03okWBfoo:fm_o^M;K00Ko^M;K00?o
ZL[BokWBfonYb]800_nid]/01_nYb];o^M;KojW:d_nYb];o^M;Kok7:bPWo
ZL[B00?oZL7:ojW:d_nYb]800_nYb]804_ni^IOoo?cdonc/hoolo?Cok>cS
on?/m?odm>com?CdoncK/OoSd[7ok>cSooC/foodm?Com>cKooCdk?odm?Co
hm_Konc/h`;om?C/0_odm?@2ooCdk006onclm?odm?Com?Cdom_1Woodhl[o
o?cd1?odm?@02oodm>com?CdooCdm?odm>com?CdooCdk?o/o?Com?C/ooCd
m?oSk?Com?C/00;ok>cS00?om?C/onc/hoodk=/00oo/k><00ooooooo4A4A
ocY46@02oeaLC00;odA4:_m<C3[oA4A<ob8b:_lI8R;oA3XZocXj<_lb>TCo
A4@bocXj<_ljE5`00_lj>R84ocXj<P;oC4a400So^Imnom_1WoooooooKHMn
oda<>_nGSgKob/6OoinGQ`;o>T@I00WoKFeDobXR6Om<C3[o^ImnooCdk?o/
k>?om>cKonc/hoo/o?@00oo/k><04Oo/hl[om>cKooC/fooSd[7od/ZYol[1
Wona/Hoo/KVGojVYSona/Hoo/KVGokVaWonOWhooUhmfooCSb_odm>cok>cS
00Som?C/00?om?CdooCdk?odm>`00oodk=/01Oo/hl[ok>cSooCdk?odm>co
m?Cd00?om?C/00Kom?CdooCdk?o/o?Com?C/ooCdm?o/k><2ooCdm008ooCd
k?odm?Com?C/ooCdk?o/o?Com?C/ooC/foodm>`2ooCdm00Uooooooo/o?Co
m?Cdooclm?odk=_ooooool[1ZOooooood/ZYooCdk?oBb/7oUhn7oncSb_od
m?Cok?cdooclm?odk=_oKFeDoaUfM_ljE5coC7Inoeb7Som]Qgko4HNGodaf
O_oooooom?C/onc/hoodm?Cok?cdooclm?nOZJWoOYnioff?^Om]Sk7od/[1
ooooo`02off?/@05ogJG`OnOWgkooooooncSb_o/k><00_odm?@2ooCdk004
ooCdm?odm>com?CdooCdm0;om?C/00?om?CdooCdk?odm?@00_odm?@04?od
m>com?CdooCdk?odm>coo?cdogj?Som]Sk7oKHnGon?Kfooooooo/K6iofF7
ZOm]Qgkod/ZYoooooooSd[43ooCdm005ooCdk?odm?Com?C/ooCdk?o/k><0
0oodk=/01Oodm>com?CdooCdm?odm?Coo?cd00;om?C/00kooooooin7KOna
/Hoob[6Yol6aSonOWgko^IM]ol6iUooSd[7ok>cSooclm?odm?Com?C/oocl
m0;om?Cd0_olo?@2ooCdm003ooclm?odm>coo?cd00?om?Cd00Goo?cdooCd
m?olo?Com?C/ooCdm002ooclm005ooCdm?olo?Coo?cdooooooniWgh0Y?oo
ool005[ok^k^00[oG3XRod@j8_m4A3;oA4@ZobXR6OlI6AWo<RXRod`R2?o1
/KWohncd0_oSfm/01?o:fm_ohm_Kon?KfooSfm/4ol[Kf`03on?Kfoo:fm_o
b]_K00Cob]_K00Co^M;Kol[Kfoo:fm_o^M;K1?o:fm/7okWBf`04ojW:d_ni
d]_oZL[BokWBf`;oZL[B00?o^M;KojW:d_nYb]800onYb]800onid]_ok^k^
ojW:dP05ojW:dP;o^M;K00Gok^k^ol[Kfoo^k^kob]_KoncSbP02on?Kf`05
ooCdk?o/fk7ok=^aon?Kfoodm?@00_o/k><03_odm?Cok>?:ooCdk?odm>co
hncdooCdk?o/o?Com?CdooCdk?odm?Com?C/onclm?odk=_ofl6O0_odm?@0
2oodm>com?CdooCdk?odm?Cok?cdooCdk?odm?Cok?cdooCdm?odm>com?Cd
00;om?C/0_o/o?@00oo/k>?ohm:aon?Kf`04onc/h`04oooooolR8Q7o>SXR
ogiUE0;oC4a400co>T@boda<>_lR<R[o:R8IocXj<_m<C3[o>T@boc8jA?m4
A2[o>TA<oc8Z8_lR8Q43ocXj<P0Cod@Z8_m<C3[o>SXbojVYSoo1/Ioohm;1
ogifE?mDKGKoShmUohn7KOolo?Co^KVYoeaLC?n?MTCod/ZYoda48_mUC1Wo
m?C/ooC/f`02oncSbP04oncK/Oo/fl7om>cKooC/f`;om?C/00Sok?cdom_:
WooBbZWo`KVOojVYSoo1^IOoZJV?ok6iU`;o^KVG00Co/KVOojVYSooBb/7o
k?cd1_odm>`2onc/h`08ooC/foo/hl[om>cKon?Kfoodm>cok>cSooCdk?o/
o?@5ooCdk0;ok?cd00Som?C/ooCdm?odm>cok?cdooCdk?odm?Com?C/ooCd
m0;om?C/00?ok?cdooCdk?odm>`00_odm?@01_olo?Com?C/onc/hooSd[7o
oooool[1Z@;oQiNY00goMYNaogj?Soooooook>?:onc/hooSd/7oWin?ooC/
foo/k>?ok>?:onclm?olo?Co:Q4800;o8TaD00Ko6GI4oncSb_olo?Co6GIf
odafO_ooool2ooCdk00:ooCdm?odm>coo?cdoio1/Om]SkWoKHnaogjO^Oni
^JWooooooff?/@;oIINa00KoKHMnooooooo/k>?ok>?:ooCdm?odm>`2ooCd
m004ooCdk?odm?Com?C/ooCdm0?om?C/0_odm?@04oodm>com?CdooCdm?od
m>com?CdooCdk?ooooooQiNYofFG/OmLQiOod/[1oooooona/KWoIHNYoeb7
Uoni^IOoooooon?B/Oodm?@00_odm>`3ooC/f`;om?C/00?oo?cdooCdm?od
m>`00_odm?@01_olo?Com?C/ooCdm?odm?Com?C/ooooo`;o^Imn00?ofl6O
on?B`Oodm>`00oolo?@03oodm?Com?C/ooclm?odm?Coo?cdooCdk?olo?Co
m?C/ooCdm?olo?Com?Cdooclm?odm?Coo?cdooCdk002ooclm003ooCdm?ol
o?Com?Cd00;oo?cd00?om?Cdooclm?odm>`00oolo?@00oo1^HOok^k^onk^
kP2Ronk^kP00F_oVi^H01Om<A2;oA2XRod@Z8_lb:R;o:R8I00;o<RXR00?o
G3XRom^aZOoSfm/00_oSfm/01?o/k>?ob]_Kon?/m?oSfm/2onc/h`0:on?K
fooSk?Cob]_Kol[Kfoo/k>?ob]_Kon?Kfoo/k>?ob]_Konc/h`;ob]_K00?o
k>cSol[Kfoo:fm/00oo:fm/00onid]_ob]_Kol[Kf`09okWBf`03ojW:d_ni
d]_o^M;K00?o^M;K00Kob]_KokWBfoo:fm_o^M;KojW:d_nab/X3okWBf`06
ol[Kfonid]_o^M;Kol[KfooVi^Ko^M;K0_o:fm/01OoSd[7om?C/on?B/OoS
d[7ohncd00;ok>cS00Som?CdooCSb_o/k>?om?C/ooCdm?odm>com?CdooCd
k0?om?Cd00Gom?C/ooC/fooK/Ioom?CdooCdk002ooCdm003onclm?odm>co
m?Cd00;om?C/00Gom?Cdonc/hoodm?Com?C/onclm003ooCdk004onc/hood
m?Cok>cSooCdk0;ok>cS00CohncdoooooomUG1Wo6B8R0_mLG4`08Om<C3[o
A4A<ocY4<_ljA4co6ATIob8b:_ljA4coA4@bocY4<_lj>S;o>TA<oaTI4OlR
8Q7oA4@bocY4<_lj>S;o8T@joda<A?m4>R[o/K6?okViUoodm>coMWiLoea]
M_mnOVgoUhmfoncSb_o1^IooKHMnokVaWooSd[7oWin?ol6aW`02onc/h`06
ooCdk?o/k>?ok?cdooCdk?o/k>?om?C/0_o/k><01Oodk=_oflZOom;:ZOo:
`Ioo`K6O00;o^KVG00OoZJV?ok6iWona^IOo/KVGojVYSooBbZWom?Cd00?o
k>cS00_om>cKon?Kfoodk=_om>cKonc/hoodm>com?CdooCdk?o/o?Com?C/
onclm004ooCdk003ooCdm?o/k>?om?C/00?om?C/00Gom?CdooCdk?odm>co
m?C/ooCdm008ooCdk00<on?KfonOZJWoQiNYogJG/On7UjWoo?cdol[Kfomf
Uk7oOYniogJG/On7UjWoo?cd0_o/hlX00oodm>coUhn7on?B`@03ooCdk003
oooooonOWgko6E@b00;o6GIf00SoKHMnohNGZOlIMWKo^K6Oooclm?odm?Co
k>cSooCdk0;om?Cd00god/[1off?^On7Wk7oKHnioinOSoooooooMYNaohNO
/OnO`K7o`K6Oooclm?o/k>?ok=_100;om?Cd00Kom?C/ooCdm?odm>com?C/
ooCdm?odm>`2ooCdm0;om?C/0_odm?@2ooCdk00@ooCdm?odm>com?Cdoocl
m?nOZJWoMYNaofFG/Oni^JWoooooonKVi_mDSk7oKHnGoinOO_oooooob[V?
oncSbP?om?C/00Com?CdooCdk?odm?Com?C/0_odm?@3ooCdk0;om?Cd00Co
m?C/ooCdm?odm>com?Cd0oolo?@00oodm>com?CdooCdk005ooCdk0;om?Cd
00Woo?cdooCdm?olo?Com?C/ooCdm?odm>coo?cdooCdk?olo?@00_odm?@0
1_olo?Com?Cdooclm?odm?Com?C/ooclm0;om?Cd00Goo?cdooCdm?odm>co
ooooom_1W`2TonKViP00F_o^k^h02?m4:R;oA3XZoda<>_lb:R;o8RXZocXj
8_lb:R;oQda40_o/k><04OoSfm_ok>cSon?Kfoo/k>?ohm_Konc/hoo:fm_o
hm_Konc/hooSfm_ok>cSon?Kfoo/k>?ohm_Konc/hooSfm_ok>cS00;ob]_K
00?ok>cSol[Kfoo:fm/02?o:fm/2okWBf`;ob]_K00Ko^M;Kol[Kfoo:fm_o
b]_KokWBfoo:fm/2okWBf`Sob]_K00Co^M;Kol[Kfonid]_ok^k^1oo:fm/0
2om]MWKom>cKooCSb_oSfm_ohm:aooCdm?odk=_ok>cSon?Kfoodm?Cok>cS
00;om?C/00[om?CdooCdk?o/k>?om?CdooCdk?odm?Com>cKon>YSooooooo
hncd0_odm>`4ooCdm00<onclm?odm>cok?cdooCdk?o/o?Com?CdooCdk?o/
o?CohncdooCdk?o/k>?ok?cd1?o/k><01?ooooooWimnocY46OmLG4`3oda<
A00PocY4<_m4A3;o:R8IocXj<_lb>TCoA4A<ocY4C?m4>R[oA4A<oda<A?lj
>R;oA3XZocXj<_ljA3;o>SXboda<A?lR>S;o^KVGokVGKOolo?CoShmUocYD
G?mnOVgoWimnon?B/OoBb/7oOWi]oeA]M_mnMVGo/K6?ol6aWoolo?@3onc/
h`03ooCdk?o/k>?ok>cS00;ok>cS00kom?C/onc/hooKbYoob/6Ool[1ZOo:
`Ioo`KVOok6iUoni^IOo^K6Ook6iUonYZHooOWi]okVOOP?om>cK0_o/k><0
0oodm>cok>cSooCdk002ooCdk003onc/hoo/o?Cok>cS00Kom?C/00?om?Cd
ooCdk?odm>`00oodm>`00oo/o?Cok>cSonclm002ooCdk00Ionc/hoodm>co
k>cSonc/hoodk=_ok>cSooCdk?o/k>?om?CdogJG/OmnWkWoQlZaohNGZOol
o?Cohm_KohNO/OmnWkWoQinaogJG/Oodm>com>cKoncSb_odm>coKFeDol[1
Z@03ooCdk004on?/m?olo?CoWiN7ogInG0;o6GIf00?o6FEnoinOSoolo?@0
0oodm>`01?o/o?Cok>cSooclm?o^k^h2off?/@0:ohNO/Ona^JWoooooon?B
`OoSfm_ob]_KoinYZOolo?Cok>cSon?B`@;om?Cd0_odm>`00ooSk?Com?C/
ooCdk003ooCdk007ooCdm?odm>com?CdooCdk?odm?Com?C/ooCdm002ooCd
k00=oooooonOZJWoMYNaofFG/Ona^JWoo?cdonk^k_m<KHOoG6f7ohn7E?oo
oooohm:aonc/h`02ooCdm006ooCdk?odm?Com?CdooCdk?odm?Com?C/1?od
m?@2ooCdk003ooCdm?odm>com?C/00Som?C/00Gom?CdooCdk?odm?Coo?cd
ooCdk002ooCdm0;om?C/00coo?cdooCdm?olo?Com?C/ooCdm?odm>coo?cd
ooCdk?odm?Coo?cdooCdm?olo?@2ooCdm007ooclm?odm?Com?C/ooclm?od
m?Coooooom;:Z@2Tonk^kP00F_ooool01?m4:R;oA4@bod@j:_m4>RX2od@Z
8P08obXR6OnOQfgom?C/onc/hooSfm_ohncdonc/hooSfm/6onc/h`06on?/
m?o/k>?ok>cSon?/m?o/k>?ohncd0oo/k><01_oSfm_ohncdon?Kfoo/k>?o
b]_Konc/ha3ob]_K00?ok>cSol[Kfoo:fm/01_o:fm/00ooooooob]_Kol[K
f`04ol[Kf`0=on?Kfoo:fm_ob]_Konc/honYZHooSgi]ooooooodhl[ohm;1
onc/hooSfm_om?CdoncSbP05ooCdk008ooCdm?odm>cohncdonclm?odm?Co
k>cSonbYM_o/o?@2ooCdm004ooCdk?odm?Cok>cSooCdm0;om?C/00Som?Cd
ooCdk?odm?Com?Cdonc/hoodm?Cok>cSonclm0;ok>cS017om?C/onclm?od
m?Com?C/ooclm?ooooooUhmfob8b:_mLG4coC4`joda<A?m4A3;oC4a4ocY4
C?lI6AWo:R8IodA4<P03ocXj<PCoA4@b01Co>TA<ocY4<_ljA4coA4A<oc8Z
8_ni^JWoWhm]ooclm?n?QfgoG5a<ofe]E?nOWhoo`K6Oon?KfomfOUcoKHMn
ofe]E?nOUhOoUhmfon?Kf`Ook>cS00?om?C/onc/hoodm>`00_oSd[402oo:
`Ioo`KVOok6iUonGShOoUhmfoinOO_nGSgKoZJV?oiN?Qoo1/Hooo?cd00;o
k>cS4?odm>`00oo/k>?om?C/ooCdk005ooCdk003onc/hoodk=_ok>cS00;o
m?C/00Som?CdooCdk?oSk?Com?CdooCdk?o/o?Com?C/ohNO/@;oOYni00Co
MYNaooCdk?o/k>?oQina0_mnWkT02?mfUk7om>cKooCdk?o/fk7oooooogIn
G?na^JWoo?cd0oodm>`02?o/k>?oo?cdooC/fomfOUco/KVGojVYSoolo?Co
m?Cd0_odm>`03_oSk?Com?C/ooCdm?o/o?Cohm_Kooooooodk=_ob]_Kom;:
`OooooooWjVYofFG/Om]Sk7oG8N?0_olo?@01_oSd[7om?CdooCdm?odm>co
m?CdooCdk0;om?Cd00Cok?cdooCdk?o/o?Com?Cd0_odm>`06?odm?Cok?cd
ooCdk?odm>com?CdooCdk?olo?CoWjVYoeb7Uom<KHOoShM]ooclm?oSd/7o
MYNaok7:b_nOSfgoooooon?B/Oodk=_ok?cdooCdm?odm>com?CdooCdk0;o
m?Cd00?om?C/ooCdm?odm>`00oodm>`2ooCdm003ooCdk?odm?Com?Cd00;o
m?C/0_odm?@3ooCdk008ooCdm?odm>com?C/ooCdm?odm>coo?cdooCdm?ol
o?@2ooCdm003ooclm?odm?Com?Cd00;oo?cd00?om?Cdooclm?olo?@00_od
m?@02_olo?Com?C/ooclm?odm?Coo?cdooCdm?olo?Com?Cdooclm?o/fk6T
ooooo`00F_o^k^h02Om<A2;oA3XZod@Z8_lb:R;o8RXZoaTI6OlR8Q7ob[6Y
on?/m003on?Kf`;ok>cS00Gohncdonc/hoo/k>?ok>cSon?/m004onc/h`04
on?/m?o/k>?ok>cSon?/m0Gok>cS00Oohncdonc/hooSk?Cob]_Konc/hoo:
fm_ohncd00Gob]_K00?ohm_Kol[KfooSfm/00oo/k><:ol[Kf`05okWBfoo:
fm_ob]_Kol[Kfoo/k><01?o:fm/03ooSfm_ob]_KoooooomUE3;ob/6YooCd
k?o/hl[ohm;1on?B/Oodm?Cok>cSooCdk?o/k>?om?C/onclm002ooCdk00>
onclm?odm>com?C/ooCdk?o/k>?ohjV?ooooooodm?Com?C/ooCdm?odm>co
k?cdooCdk?oSk?@2ooCdk00fooCdm?o/k>?om?CdooCdm?o/o?Cok>cSooC/
foo/hl[om?C/ol6a^OoSd[7od/ZYok6aSona^IOo^Imnogi]C?m4A3;oC4a4
od@j:_m<C3[oA4A<ocY4<_lj>S;o6B8Rob8Z:_m4A3;o>SXbodA4<_lb>TCo
>SXbocY4<_ljA4coA4@boc8jA?ljA3;o>SXbodA4C?lR:R[ob/6Yohn?IOol
o?CoWimnocYDG?m<C3[o^K6Ool6aWoo/k>?oOWIUofefM_mUIC[o/KVGoiN?
M_o/fl7om?C/1?o/k><00oodm>cok>cSonc/h`02onc/h`05ol6aSonYZHoo
UhmfojVYSoniWgh00ona/Hl01_nYZHoo^KVYoinOSonOWgkoo?cdonc/h`;o
m?C/00CohncdooCdk?odm>cohncd0_odm>`00oo/k>?om?C/ooCdk006ooCd
k003onclm?odm>cok>cS00Cok>cS0_odm>`03?o/o?Com?C/ooCdm?o/k>?o
m?C/onclm?o/k>?ok?cdonc/hoodm>coo?cdohNGZ@?oOYni00?om>cKooCd
m?n?WkT00_mnWkT02OmfUk7ok>?:ooCdm?oBbZWooooook6aSonOUhOom?C/
on?/m003ooCdk00Jon?/m?odm?Com>?:ooclm?oooooom?Cdon?/m?o/k>?o
k?cdooCdk?o/o?Cok>cSooCdm?o/k>?oSk71off?^Om]Sk7oKHnGoooooona
b/[oKHniogJG/Om]SiOok>cSon?/m?oSd[42ooCdm004onclm?odm>com?Cd
onc/h`Kom?C/013om?CdooCdk?odm>com?C/onc/hoodk=_ok>?:ooclm?o:
`JWoMYNaoiNib_nOZJWom?CdooCdk?oBb/7ok>cS0_olo?@00ooSd[7ok>?:
ooCdm002ooCdm0Com?C/00Oom?CdooCdk?odm?Com?CdooCdk?odm?Com?C/
00;om?Cd1?odm>`00oodm?Com?C/ooCdk003ooCdk0;om?Cd00Som?C/ooCd
m?odm>com?C/ooCdm?odm>coo?cdooCdm0;oo?cd1Oodm?@02?odm>coo?cd
ooCdk?olo?Com?Cdooclm?odm?Coo?cd0_odm?@00oolo?Com>cKonk^kP2S
onk^kP00F_oVi^H03Om4A3;oA3XZod@j:_lZ8QWo<RXRodA4<_lR8Q7ohm;1
onc/hooSfm_ok>cSon?Kfoo/k><00_oSfm/01ooSk?Cok>cSon?/m?o/k>?o
hncdonc/hooSk?@00_o/k><01_oSk?Cok>cSonc/hooSk?Cok>cSon?/m0?o
k>cS00?ob]_Konc/hooSk?@01?o:fm/03?oSfm_ob]_Kol[KfooSk?Cob]_K
on?/m?oSfm_ok>cSon?/m?o/k>?ohncdon?Kf`;ok>cS00Kob]_Kon?Kfoo:
fm_ok>cSol[KfooSfm/6ol[Kf`03on?Kfoo:fm_ok>cS00;ob]_K00_om?Cd
oooooomUG2[om>cKooCdk?o/hl[ob/6OoncSb_o/k>?om?C/onc/h`02ooCd
k0;ok?cd01gok>cSonclm?odm>cohncdonclm?oKWfgok?cdon?/m?odm>co
hncdonclm?odm>cok?cdooCdk?oSk?Cok?cdon?/m?odm>cok?cdonc/hoo/
o?Com?Cdol6iUoo1^HOoo?cdoda<A?m4A2[o>SXRoeaLC002oeA]MP0AodA4
<_m<C4CoC4`jocXj<_lb>TCoC4`jodA4C?m<C3[o8RXZoaTI6Om4A3;oA4A<
oc8jA?lj>S;o<SY4ocXj<_lb>T@01?lj>S804Om4A4co:R8Iol6aWon?MVGo
o?cdok6iZOm]KECoC4`joinOO_niWgkoo?cdohn?IOmnShooC4`jok6iUonG
SgKohm;100Cok>cS00?om>cKoncSb_o/hlX00_o/hlX03_oSfm_ohm:aon?B
/Oo:`Ioo`KVOol6iUona/Hoo/KVGokViZOna/HooZJV?ok6aSonGSgKoo?cd
0_o/k><2ooCdk003onc/hoodm>com?C/00Som?C/1?o/k><05?odm>cok>cS
onclm?odm>cok?cdooCdk?o/k>?om?C/onc/hoo/o?Cok>cSonclm?o/k>?o
k?cdooCdk?o/k>?ok?cdooCdk?olo?CoSk710_mnWkT01?m]SkWohm;1oocl
m?nO`K42ogjO^@0Coff?^OoK`Ioom?Cdon?B/Ooooooob[6YoinOSoolo?Co
k>cSooCdm?oSk?Com?C/onc/hoolo?Co/K6?ol[KfooBb/7ohm;1ooCdm002
ooCdk006onc/hoodm?Com?C/ooCdk?o/k>?oQina0_m]SkT03OmfUk7ooooo
onKVi_m]Sk7oMYNaofF7ZOo/hl[oooooon?BWooSk?Com?C/ooCdm?o/k><0
0_odm>`00oodm?Com?C/ooCdk003ooCdk005onc/hoodk=_om>cKonc/hood
m>`00_odm?@01Oo/o?Cok>?:om;:`OoSd/7ok>?:00;oo?cd00Ook>cSol[1
ZOo1^IOo^ImnolZiSooSd[7ok?cd00;om?C/00Kom?Cdonclm?odm>com?Cd
ooCdk?o/o?@3ooCdk00;ooCdm?odm>com?CdooCdm?odm>com?Cdonclm?od
m>com?CdooCdk?odm?@00_odm>`01Oodm?Com?C/ooCdk?odm?Com?C/00;o
m?Cd00?om?C/ooCdm?odm>`00oodm>`01oolo?Com?C/ooCdm?olo?Com?Cd
ooclm?odm>`01?odm?@01_olo?Com?C/ooclm?odm?Coo?cdooC/fjCoi^KV
001Jonk^kP0:oda<>_mL>R;o<RXRod@Z8_lZ8QWoC288onk^k_olo?Cohm_K
on?/m0;ok>cS00?ohm_Kon?/m?o/k><02?o/k><01ooSk?Cok>cSonc/hooS
k?Cok>cSon?/m?o/k><00_oSk?@3onc/h`03ol[Kfoo/k>?ok>cS00Gok>cS
00?ob]_Konc/hoo:fm/01?o/k><01OoSfm_ok>cSol[KfooSk?Cok>cS00ko
b]_K00_ohm_Kol[Kfoo/k>?oooooolZaZOmUIC[om?C/ooC/fooK/JWohm;1
onclm002onc/h`Gom?C/00Sok>cSooCdk?odm>cok?cdom]nC?oooooom?C/
onclm0Com?C/01;ok?cdooCdk?odm>com?C/onclm?o/k>?om?C/onc/hoo/
o?Cod/[1ok6aSoolo?CoUhmfoda<>_m<C4CoA4A<oea]M_m]MWH2oda<>P0>
oda<A?m4A2[oA4@bodA4C?m4A3;oC4a4ob8Z:_lI6AWoC4`jocY4<_lb>TCo
C4`jod@j:_m4A4`2ocXj<P0JocY4<_m4A3;o>SXboda<A?lb:R;o^KVGoinO
O_o/k>?ofl6Oofe]E?m4A2[oZJV?ohn7KOolo?CoUhmfoff7O_m<C3[o/KVG
oiN?Qoo1/Ioom>?:oncSb_o/fl7ok>?:oncK`OoSfm/4onc/h`06oncSb_oB
bZWod/ZYol6iWoni/IooZJV?0_ni^IL01On?Uhoo/KVGojVYSonGSgKoo?cd
00?ok>cS00Kom?C/onc/hoo/k>?om?C/onc/hoodm>`3onc/h`04ooC/foo/
k>?ok>cSonc/h`;om?C/0oo/k><2ooCdk003onc/hoo/o?Cok>cS00;om?C/
0_o/k><2ooCdk003onc/hoodm>com?C/00;ok>cS00Soo?cdohna`OmfUk7o
OYnioff?/OoSd/7om?Cdoio1/@;oOYni02SoMYNaol6iUooooooohm:aooCd
m?o/hl[o^KVGooclm?o/k>?om?C/onc/hoo/o?Com?C/oooooomUIC[o>UAL
ok6iZOni^JWoo?cdonclm?oSk?Com?Cdonc/hooSk?Com?C/ooCdm?n?WkWo
OYnioff?/Om]SiOoooooonk^k_mUUk7oKHnaofFG/OoSd[7om?Cdom;:ZOod
m?Cohncd1?odm>`00oo/k>?om>cKonc/h`02ooC/f`04onc/hoodm>com?Cd
on?/m0?om?C/00Ook>cSooCdm?odm>com?C/on?KfooBbZWo`KVG00;o^Imn
00?ohm:aon?B`Oodm>`01Oodm?@3ooCdk005ooCdm?odm>com?CdooCdm?od
m>`00_odm?@00oodm>cok>cSooCdm002ooCdk003ooCdm?odm>com?C/00Go
m?Cd00Gom?C/ooCdm?odm?Com?C/ooCdm002ooCdk0Com?Cd00Coo?cdooCd
m?odm?Coo?cd0oodm?@01Oolo?Com?C/ooclm?odm?Coo?cd00;om?C/00Co
o?cdooCdk?olo?Coo?cdY?o^k^h005[ooooo00WoC4`jod@j:_m4>R;o>T@I
ob8R4OoBb/7oo?cdonc/hooSfm/00oo/k><02ooSk?Cok>cSonc/hoo/k>?o
hncdonc/hooSk?Cok>cSon?/m?o/k>?ohncd00Wok>cS00_ohncdonc/hooS
k?Cok>cSon?/m?o/k>?ohncdonc/hooSk?Cok>cSon?/m003onc/h`06ol[K
fooSk?Cok>cSon?/m?o/k>?ohncd0_o/k><01oo:fm_ohncdonc/hoo:fm_o
k>cSol[Kfoo/k><00oo:fm/01Oo/k>?ob]_Konc/hoo:fm_ok>cS00;ob]_K
00Gok>cSon?Kfooooooob[6YoinGQ`02ooCdk003on?B`Oo/hl[ok>?:00?o
m?C/0_odm?@01_odm>cok?cdooCdm?odm?CoooooonbYMP;om?Cd00?om?C/
ooCdm?odm?@00_odm?@00oodm>com?CdooCdm002ooCdk0;om?Cd00oom?C/
ooCdm?o/hl[o`KV7ooCdk?nGSgKo>T@boeaLC?m4A4coE6efoea]M_m4A2[o
C4`joda<A?m<C3X00_m4A3801olb>TCoA4@bob8Z:_lI6AWo>TA<oda<>_lR
A3X00_lb>T@02_ljA3;o>SXbob94>_lj>S;o<SY4ob8j<_m4A3;o8SXbok6a
SonOUhL2oncSbP0>ocYDG?lb:R;oShM]oinOO_olo?Co/KVGofefM_lR>S;o
WiN7ohn7KOo1/Hooo?cdooCdk?odm?@3ooCdk005onc/hoodm>cok>cSoocl
m?o/hlX00_oBbZT02oo:`Ioo^K6OokVaWona^Ioo/KVGojVYSoo:`JWo/KVG
oinGQoolo?Com?C/00;oo?cd00?om?CdooCdk?olo?@00oodm>`01?o/k>?o
o?cdooCdm?olo?@2ooCdm0;oo?cd0_odm?@01oolo?Com?C/ooclm?odm?Co
o?cdooCdm?olo?@00_odm?@3ooclm003ooCdm?olo?Com?Cd00?oo?cd00Ko
oooook6a^Om]SkWoOYnioff?^OoBb/42ooooo`0;off?^OmnWkWoKHniokVO
O_oooooom>?:ooclm?odk=_o`KVGooooooo/k><00oolo?@01Oodm?Coo?cd
onc/homfOUcoKHnG00Soo?cd00Oooooook6a^OmUUk7oKHniofFG/Ooooooo
k>cS00;oKHni00GoIINaom;:ZOooooook=_1ooooo`02ooclm0Com?C/0ool
o?@00oooooooo?cdooclm002ooclm004ooooooolo?Coo?cdooooo`;oo?cd
00Go^Imnom:aSooSd[7om>cKooclm003ooooo`?oo?cd00CoooooooCdm?ol
o?Coo?cd0_ooool00oodm?Coo?cdooooo`05ooclm004ooooooolo?Coo?cd
ooooo`;oo?cd00?oooooooCdm?olo?@00_olo?@02ooooooom?Cdoooooool
o?CoooooooCdm?oooooom?Cdooooooodm?Cooooo00;om?Cd00?oo?cdooCd
m?odm?@00oodm?@;onclm:Cooooo003oonk^k_ook^k^G_o^k^h00?ooi^KV
oooVi^INonKViP00ooo^k^koonk^kUkok^k^003oooooooooooooG_ooool0
0?ook^k^ooo^k^iNonk^kP00oomoOgooogmoOekoOgmo00001_o[jn_oi^KV
on;Rh_oNg]kogMgMomcLg0;ogMgM0ooNg]h00ooLg=cog]kNomgMg@02omgM
g@3oomkNg_oLg=cog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN000FomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomgMg@;og=cL0?oofm_K
omgMgOoLg=cogMgMomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kog=cLomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMd002[og]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMd3omkNgP03omgMgOoNg]kog]kN00?ogMgM0OoQ
hN41onOWi`7oj^[Z00000oo/k>coi^KVon3Ph007omWIf@04omSHf?oFe]Ko
dm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOG
om?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOG
eooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=SDomWIf@;of=SH00?o
fMWIomSHf?oHf=P00ooIfMT2omSHf0GofMWI00?of=SHomKFe_oCdm<00_oC
dm<00ooFe]Kof=SHomSHf00>omWIf@04omSHf?oIfMWofMWIomSHf13ofMWI
0_oHf=SoomWIf@7ofMWI00?of=SHomWIfOoIfMT01_oIfMT1omkNgP7oi^KV
0Oo/k>`00007onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=
omkNg_oKfm_odm?ColO7aonk^k_o/[:bojf][Onb/[;o^k^kolO7aooCdm?o
fm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb
/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7
aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`35on7Qh@[o
h>3P00?ogmoOon3Ph?oPh>001_oOgml2on3Ph0?ogmoO1OoPh>001ooOgmoo
fm_KomOGeooDe=CoeMGEomWIfOoMgMd00_oPh>000ooOgmooh>3Pon3Ph002
on7Qh@Ooh>3P1_oOgml00ooPh>3ogmoOon3Ph00;on3Ph004omoOgooNg]ko
g]kNomoOg`;oh>3PNooQhN400ooPh>3ohN7Qon7Qh@05on7Qh@03on3Ph?oQ
hN7ohN7Q03;ohN7Q00?oh>3Pon7QhOoQhN40A?oQhN400ooRh^;ohN7Qon;R
hP04on7Qh@7oi>CT0OoXj>P1ong]k@0000?ol?3`ono_kooalO400oo`l?00
ooo_knool?3`onk^k_oYjNWofm_Kol71`OnTY:CoS8b<ogYjN_mgMgOoNg]k
ohb<S?nTY:Co`/;1om[Jf_oZj^[okNg]oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<RomkNg_oMgMgog]kNon<
S8coY:BTol;2`_oJf][oj^[Xong]kOoalO7okno_oo7alOo_knoolO7aono_
kooalNookNg]on[Zj_oJf][o`/;2ojBTY?n<S8coNg]kogMgM_mkNg_oS8b<
ojBTY?o2`/;of][Jon[Zj_o]kNgolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_k`000ooalO7okno_oo3`
l002onc/k007on_[joo^k^cok>c/ong]kOo/k>cok^k^on[ZjP02on_[j`0:
onk^k?oYjNWoj>SXonKVi_oYjNWoi^KVon[Zj_o[jn_okNg[onSXj0;ojNWY
00OokNg]on[Zj_o/k>cok>c/ono_kOoZj^[oj>SX00;ohn?S00gogmoOon?S
hooXj>SokNg[on[Zj_o[jn_ok>c/oo3`l?o_knool?3`ong]kOo/k>[oj^[Z
00;ok^k^00Kokno_on[Zj_oYjNWoi^KVonSXi_oWinL2onWYj@06onc/k?oY
jNWok>c/ong]kOo^k^coj^[Z0_o/k>`02?o^k^koj^[Zonc/k?o/k>cokno]
on_[jooYjNWoi^KV0_oXj>P2ong]k@3ooo3`k_o_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo`l?3okno_0006oo3`l?o_knool?3`ono_koo`l?3okno_1?o`l?000003
oo;bl_o^k^koinOW00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mUIFGo
DE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@0
0ooUiNGoi>CTonGUi002onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5A
odE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT0=[o
iNGUonCTi?oUiNGoi>CTonCThooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5
ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7AomkNg_oTi>?oi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>Cohn?SomkNgP;ofm_K00[og]kMomcLg?oKfm_og=cLomoOgooK
fm_ofMWIomcLg?oMgMcoemOG0ooEeMD01?oDe=CofMWIomgMgOoMgM`2omOG
e`0Bom_KfooMgMgof][Jom[Jf_oNg]kohN7Pom_KfooHf=SoATI6oc0`<?mh
N7So`/;2om[Jf_oNg]gof][JomWIfOoMgMgohn?S0_oTi>@05_oOgmoog=cK
omWIfOoOgmooh^;Ron7QhOoKfm_oe]KFomCDe?oFe]Goe=CDomKFe_oKfm_o
g=cLomSHf?oLg=cogmoOomoOg_oIfMWofm_KomkNg_oOgml2om[JfP3oomgM
gOoPh=oofm_KomOGeooEeMGoemOGomWIfOoOgmooh^;RonCThooTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGohn?SonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUon?ShooUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT0008onGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>@4onGUi@06onCTi?oUiNGoiNGUonGUiOoXj>So
k>c/0Oobl_800003ooCdm?o]kNgoinOW00?oh>3P01;ogmoOomkNg_oBd];o
];BdohN7QomLG5coKC/eoii>@_o=KUkojH=_ole_GonMCD?oKC/foeaLG?n7
QhOo];Bdom;Bd_oNg]h5on3Ph00AomkNg_oBd];o];BdohN7QomLG5coKF0/
oijF;_o=cCoojNU=olg=?onNVRooKF<]oeaLG?n7QhOo];Bdom;Bd_oNg]h0
1OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLodMW;_mXWS?oTLe7oj[YEOnA
cDOoJYhdodUZ;omLG5coQhN7okBd]?oBd];og]kN0<?oh>3P04?og]kNomSH
f?oBd];oe=CDomKFe_oBd];oclo?om;Bd_oFe]Kodm?Com7AdOoEeMGoe]KF
om3@d?o4a<Cobl_;olo?coo9bLWoa<C4omSHf?oEeMGod=3@olC4a?o@d=3o
f=SHom;Bd_oAdM7of=SHom_KfooFe]KodM7AoiFEUOnPX:3o?Shnod];BooD
e=Cof=SHom;Bd_oAdM7of=SHomkNg_oPh>3ogmoOom[Jf_oCdm?odM7AomSH
f?oMgMgof][Jom?Cdoo?cloo`<30om3@d?o=cLgo_knoomCDe?oFe]KodM7A
omCDe?oIfMWof=SHom7AdOoBd];of=SHomWIfOoCdm?odM7A00;oemOG00So
dM7Aolo?coo8b<Soa<C4omSHf?oKfm_og]kNomoOggcoh>3P00?ogmoOon3P
h?oPh>000_oPh>000ooOgmooh>3Pon3Ph01hon3Ph003omoOgooPh>3ogmoO
00;ogmoO0ooPh>000ooQhN7oinOWonc/k001ooCdm00000?om_Kfoo;bl_o[
jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWiooJUiNohlf;_o/L67onIf@oofa
YOom_:oooKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;Rh_oWinL00ooX
j>P04ooWinOoh^;Rolg=cOnOWiooKVIOoi=b8_o]dDConO=doogmSOomoIGo
oOf>ooWhM_o]edOoTg<RofiWGonOWioocLg=on;Rh_oWinL00ooXj>P04ooW
inOoh^;Rolg=cOnOWiooH6QOod]l8onBhD_o_OUkom3mT_oHoI_oe?fEol3i
O_nHj4goCH0Tof1YGonOWioocLg=on;Rh_oWinL0`_oXj>P0:OoVi^KogmoO
oc0`<?n?Shoofm_KolO7aon8R8SoaLG5om_KfonUYJGo0@41omgMgOoNg]ko
KFe]o`P82?lA4A7oLg=coc0`<?lT92CogMgMom_Kfom;Bd_o30`<of9RH_oQ
hN7oKFe]ocXj>_oOgmoohn?Sol?3`ol0003o`L71on7QhOnPX:3o3@d=omOG
eooNg]koOGemoaLG5ooMgMgoi>CT00;oi^KV01Coh^;RogmoOolX:2SogmoO
onGUiOoShn?o][JfoalO7ol92@Wo=SHfogAdM?l820SoUYJFomgMgOl?3`oo
UiNGon7QhOoOgmoo@T92ofATI0;oh>3P00coMGEeoc8b<_oMgMgofm_Kokjn
__ll?3co0P82oalO7olE5AGo];BdonKVi_oWinOoonSXj0Koj>SX0Oo/k>`1
oo;blP7om_Kf00000oogmoOon?ShooShn003ooShn00CooOgmoo^k^koc/k>
oi2@T?n5;b_ojFAFoo^BQoonYY_oo[6UoongZ_on/jKooZRLooZDROo^J5Wo
RC4[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nI
JB_ol;dmoo_PK_onm8;oo_j:ooooT_onoXcoo_R3oo_UL?o``SkoVFX[oi2@
T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?m2Lb_oQ<i3
ojg_Loo2oXSoc_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[oi2@T?o>c/ko
k^k^ooOgm`32ooShn00_ooKfm_o_knoo<c<coiVIVOoWinOoPh>3o`000?ml
O7coj>SXok2`/?l10@7okNg]on?Shol61PKoXZ:RomgMgOmgMgOo0000olk>
c_o`l?3o`/;2o`000?oAdM7om?Cdoo7alOmeMGGo?Shnonk^k_obl_;od=3@
o`000?o?cloolO7aolS8b?l0003o`l?3onk^k_n6QXKo6ATIonWYjOo_knoo
l_;booCdm?oalO7oR8R8ob/[:oo^k^h00_oemOD07?mTI6Co?cloonGUiOnc
/k?o7alOofMWIoo_knookNg]oa0@4?nRXZ;ol?3`ono_kom7AdOoJf][ono_
koo`l?3oOWinocDe=Oo[jn_oj>SXocLg=om4A4Coc/k>onOWiooMgMgoi>CT
ooGemOogmoMjooShn003ooOgmoohn?Son?Sh00Gon?Sh00?omoOgooShn?oh
n?P0NOohn?P00oogmoOon?ShooShn002ooShn004ooOgmooinOWomoOgooKf
mP7on?Sh00000oojn_[omOGeonk^kP02onc/k03oon_[jooYjNWogmoOokZj
^_miDU;o_c8TonIcJ?omRGkooiN;oojRU_ooZ9cooZBHoonJSOonRWookWIZ
ol<c9?miDU;o^[ZjomoOgooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[o
R6EBon:A7?oi`e3ooMYSoooZL_onlgkoooZ2ookfOoook7?oo]iToo[7DOoR
TQcoRFICokZj^_oOgmooj^[Zon_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]
D_mAXacoTM9EojKWJ_nhnG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHL
oe9]D_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/0012onc/k?o[jn_ok>c/onWYjOoShn?o<30`oi2@
T?oHf=Wo;Bd]od10@?lS8b?of][JojJVY_l10@7ohN7Qon?Si?l@413oO7al
omoOgond];Co0000om7AdOoTi>CoV9RIo`l?3ooPh>3oinOWon?Shom_Kfoo
>c/komoOgooQhN;o`l?3o`000?o5aLGoi>CTokno_ol0003o^;Rhon7Qh_mo
Ogoo5aLGomWIfOoMgMgohN7QonGUiOoTi>CoPH61obPX:?oOgmooi^KVonSX
j?mdM7Co7alOomWIfOoLg=go>c/kofm_KooTi>Coh>3Po`l?3onHV9SohN7Q
omoOh?m3@d?oIFEU0_oPh>00oomgMgOo<S8bon3Ph?nh^;Wo0000ojRXZ?oL
g=cofMWIom_KfooQhN7ojNWYon[Zjoo/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on[Zj_o/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?oZj^_ok>c/on_[
joo/k>cojn_[onc/k?oZj^[ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k0002?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/1oo[jn/0
1Oo/k>cojn_[on_[joo^k^kom_Kf007onOWi00000ookno_olo?cong]k@02
onGUi@3oonKVi_oTi>CofMWIok:b/_mi;Rkob48con=ZG?odNVgooHQloojG
R_onVhkooYR;ooj:O_odNfgoif]MolY2=?mk;Rko/[:bomSHf?oTi>CoiNGU
onKVi_oUiNKoi>CTomSHf?nb/[;oUUD^onZL:ook_4Coo/aCoogHH_onhg;o
o^UeookVLoonffGooLaCoo_1AOo^WR_oVEH^ok:b/_oHf=Soi>CTonGUiOoV
i^KoiNGUonCTi?oHf=Wo/[:bobiR;_mS[B_oQlY8oiOLFOnUiFWo/_=gokSf
NondmGWoYnY[oiSLFOn9cd_oHjh[obiS;_nb/[;of=SIonCTi?oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV0019onKVi_oU
iNGoi^KVon?ShooMgMgo;bl_oh^;Rona/K;o0000okNg]olU9BGoZ:RXoj2P
X?l10@7og=cLon3PhOnb/[;o>CTiobDU9Olk>c_o0000olg=cOoMgMgoTi>D
oa0@4?oFe]Kog]kNomcLg?m/K6co>CTiomCDe?oFe]Oo_;blo`000?o2`/;o
gmoOok^k^ol0003o];BdomcLg?mlO7co5aLGomKFe_oJf][og]kNon3Ph?oO
gmooOGenobLW9ooEeMGog=cLomkNg_oKfm_oI6ATob0P8?ll?3co4a<Cofe]
KOoPh>3og=cLo`l?3onCTi?oemOGomGEe_m1@D7oHV9RomOGeooFe]KoLg=c
oc4a<OoMgMgoVYZKo`000004ocLg=`1ook:b/_oTi>Coi>CUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Koi>CUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonCTi002onGUi@1n
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGU0_oVi^H00ooUiNGoi^KVonKViP03onKViP03onGUiOo]kNgo
m?Cd007on_[j00006Oolo?con?Shoo7alOo^k^kokNg]onk^k_o[jn_ohN7Q
okbl_?mj5aOo`clbom=FBOoTJ5[okgM/ooB3NOogQgcomHAjoo=iKOoUJE_o
fEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?nU
AaOoiYLbooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlbonVK
<_nUAQOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOoGjPb
ogJm=on6cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lGFAOo
_;blon7QhOo/k>`0`_o^k^h09oo/k>coiNGUoc4a<On?ShooKVi^ob`/;?oX
j>SoOGemoeiNG_nTY:Co0@41on?ShooYjNWoi^KVon;Rh_oPh>3o[Jf]o`00
0?oGemOoi>CToiRHV?l@413ogMgMon?ShooTi>CoL71`ob@T9?oFe]KogmoO
okno_ol0003obl_;onWYjOo1`L7o0000okZj^_oTi>CoPH61o`H61P03ochn
?P0Rol_;booYjNWoQ8B4oaXJ6_oJf][oh^;RonGUiOoWinOohn?Son3Ph?oH
f=So=cLgog9bL_oZj^[oinOWo`l?3on:RX[ogmoOomkNg_m3@d?oEUIFon3P
h?oOgmooMgMgoc<c<ooYjNWo_[jno`000?nPX:3o][JfojZZZ_l20P;ofMWI
ong]kKSok^k^00?okNg]onk^k_o^k^h0B_o^k^h00oo]kNgol_;booShn001
ooclo0000oomoOd05_olo?cooOgmoogmoOolo?colo?com7AdOmX1`Oo^3@d
olLo<ooBD4?ofV9Eon=^H_oTLVCoi6mRomaTEooCDD?oc44dokTd=?m[1`Oo
d];Boo?cloolo?`3oogmo@0Cooclo?oclo?od];Boih[1ooJRSCoji/IooFX
:Ooh]3oonKe:ooRoCOoj_d[onKPoooJZ:_o_WQWofh/doj8]1ooBd];olo?c
ooclo003oogmo@0Cooclo?oclo?od];Bo`M01om=VSCoGj/Pog2h;omo`d?o
R/e@ohg=D_n:cU3oPLM4og6i;omR[R3oCY/do`M21ooBd];olo?cooclo032
oogmo@1<oo_knoodm?Co=3@doiNGUolO7aooQhN7oo[jn_oMgMgo4a<CojVY
ZOl10@7ol_;booWinOo0`<3oa<C4oo?clon<S8co8B4Qoo[jn_oemOGoWIfM
oa0@4?oVi^Kok^k^ooCdm?mhN7So4A4Aoda<C?o:b/[oRHV9oa@D5?ofm_Ko
nOWiolk>c_l0003oa/K6oo?clon9RHWo4a<CokJf]_ni^KWo^[Zjong]kOoi
nOWoShn?o``<3?mGEeOodM7Aong]kOo/k>coYZJVonKVi_oTi>Co4Q8Bojf]
[Ookno_on_[joa0@4?lN7QkoYJFUomcLg?lJ6Q[o820PogemOOoNg]koAdM7
oemOGookno_on_[joc@d=?maLG7ok^k^ohj>S_le=CGono_kooclo?oooOgm
1?omoOd00oolo?cooOgmooclo003oogmo@0000GooOgmoo[jn_oclo?ok^k^
oo3`l002onk^kP0conWYjOoCdm?oFadMoj8d=?nd:1go`CT/olM9??o?ET[o
d5M;om1GB_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_
knool?3_onk^k_oZj^[odm?Coh`U7Oo8LCCofH@MonBD5OoWWBCokZPcoo2Z
=?o_ZS?ok:0UonNG5OoLR1gob74doh`U7OoCdm?oj^[Zonk^k_o`l?3okno_
oo3`l?o^k^koj^[Yom?CdolM>1go=88dodNE7OmJYA_oJJdZ00;oM;Ph0?oo
MKThof^a:omKYacoB9XMocB2=?lM>1godm?Con[ZjOo^k^kol?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo^k^koinOWoc4a<OmOGeoo0@41om;Bd_o^k^kok>c/od51@OmQHF7o0@41
onKVi_o^k^goX:2PocTi>OlA4A7o9RHVoiRHV?o_knooaLG5oa0@4?l10@7o
6ATIoe9BD_oYjNWoLG5aocdm?OnGUiOo7alOoaPH6?nATI7ok^k^ong]kOo3
`l?o0000okbl_?oXj>OoPX:2oaPH6?oOgmooh^;Ron?ShooWinOojn_[oi>C
T_lo?cooTY:BoaLG5onDU9Coh>3Podm?ColO7al001Ko4A4Aodm?CooXj>So
k^k^ono_kolW9bOoX:2Podi>C_l92@Wo=SHfon3Ph?m^KVko3`l?ob`/;?nn
_[kok^k^ono_k_oBd];o?3`lo`/;2olM7Ago/[:b0_o_knl0^oo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`onk^k_o`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?000oo_knl0@?o`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knl2oo3`l0Kokno_0Ooclo<1ooWin@7oo_kn00000oon
o_komoOgoo3`l004onWYj@0AonOWiooKfm_oHd];oh4b<_nV=CGo]S@]ol9=
@Oo3E4Woa5E:ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooWinL01OoY
jNT04OoWinOofm_KohU;Bon_Bc;ocGLeomJ;;OoPW2koh:0bon6P=?oPX3;o
giX^omJ;;Oo:MCGo[d/bohU;BooKfm_oinOW00GojNWY017oinOWom_Kfom;
Bd_o<V0bocZ9=OmCVbgoJj/_og2]>?m_[S[oL:dhofZZ;omCVbgo>HPeoc9P
<_m;Bd_ofm_KonOWi`33onWYj@0=onSXj?oTi>Co<30`oa8B4_ll?3coi^KV
onSXj?oWinOoTi>Coa4A4Ol10@7ohn?SonOWi`02onWYj@03onOWiooYjNWo
jNWY00;oj>SX01CoWIfMoa0@4?oWinOoinOWonCTi?m_Kfoo>c/kon?ShooW
inOoj>SXonWYjOoXj>SoinOWol;2`_l0003o^[ZjonCTi?n0P83o5aLGomgM
g@;og]kN00?ohN7QonKVi_oXj>P00_oYjNT00ooXj>SoinOWonWYj@02onWY
j@03onOWiooYjNWojNWY00GojNWY00Goj>SXonWYjOoYjNWojNWYonOWi`06
onWYj@03onKVi_oYjNWojNWY0?oojNWY0_oYjNT00ooXj>SojNWYonWYj@04
onWYj@7ol?3`0OogmoL1ooknoP0000Goo_knoo[jn_odm?Cokno_oo7al@02
oo3`l00Aono_koo[jn_oUIBDodlS8onEE5Co^g=com>EUOoJW9cofYjLomVL
W?oDUIGo^g=coiEDE?m?8b?oUIBDon[Zj_o_knl01Oo`l?004Oo_knooj^[Z
ojVDU?n18b?o^VYDomBJLooT_9Goj/NLonW7W?oZaicoiKbEomBJLonkJUCo
PB<SojZDU?oZj^[okno_00Gol?3`017okno_on[Zj_nDU9Co8bXSoeAjE?mc
YG?oW/JEojc>W?n]cYco[<jLoik6UOmcYG?oE7YDob<Z8onDU9Coj^[Zono_
k`33oo3`l005ono_koo^k^ko<S8bo`000?nCTi<00oo_knl01OoTi>Co2`/;
o`410Oo^k^kokno_00Ool?3`00Wohn?Sokno_oo_knookno_onk^k_mdM7Co
?Cdmong]kOo_knl00oo`l?001oo_knoob/[:o`000?o3`l?ok^k^ohJ6Q_l9
2@T00omNGUh00omiNGWok^k^ono_k`0foo3`l003ono_koo`l?3ol?3`0>[o
l?3`00ColO7aoo3`l?odm?Con_[j0Oono_h00004onc^l?ooooooooooookn
oP;ooooo0_ono_h0ooomoOgon?Shofi^K_mJ?coo/I2@omk9bOo`i>ColnKV
oo3Ti?oNbLWo/I2@oeXo?om]KFgon?Shooclo?ooooooo_knooooooono_ko
ooonookno_ooooooo?clooShn?n=KFgoRSloolVAT?oYd<Wom>WTooK[i_od
jNCojM39olVAT?n9?cooSFe]ooShmoolo?coooooookno_ooooooo_knoooo
ooono_koooonooclo?ohn?SoKFe]oclo?on@WI3obMG9onC/i?oVk^Koi>cT
olWEbOn@WI3o?cloofe]KOohn?Soo?clooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooooknoP00
1ooooooooOgmojn_[onHV9SolO7`oogmoOooool00_ono_h05_nd];CoVYZJ
oogmoOooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
oooooogmoOono_koO7alod51@OomoOgoo_kmookno_ooool2ooknoP3oonk^
k_nIVIWojn_[ooknoOoAdM7oVIVIoiRHV?nIVIWoV9RHojb/[?omoOgoooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_kn000/ooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_h2ooooo`03ookno_oooooooooo
00?ooooo0OomoOh00004ol78c_ono_kon_[jooCdm0GolO7a00gokno_omKF
e_m[Jf_o@cdmoi^<S?o6^[[oe/c<olNj^_nKS8co@cdmof][JooFe]Kokno_
00WolO7a00gokno_omOFe_n3Jf_oM3dmokF<S?oE^[[ohLc<omJj^_nfS8co
LSdmoh5[JooGe]Kokno_00WolO7a00gokno_omKFe_m[Jf_o?Cdmohb<S?nj
^[[oc<g<okZj^_n<S8co?Cdmof][JooFe]Kokno_0=kolO7a00?ok^k^ong]
kOoalO40oooalO4^oo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00?om?Cd
oo[jn_ono_h00Oo^k^l00005ohB?VOomoOgon?Shoo3`l?o[jn/00ooZj^X0
3OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^K
onSXj?oYjNT02ooZj^X02ooYjNWoj>SXoj2KVomZFEWo@bHVobd92Om29RKo
JEUIoj2KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nKVi_oFEUIobHV9_l9
2@Wo9RHVoeUIFOnKVi_oj>SXonWYj@3oon[Zj_ooj^[Z6?oZj^X01?o[jn_o
l?3`ooShn?omoOd1om_LgP0000Co=TIAokS0aOoinOWom?Cd2?oalO42oo3`
l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_
k`;ol?3`oooalO7ooo7alAKolO7a00?ol?3`oo7alOoalO400_oalO400ooe
mOGon_[joo3al`01oj^^/00000?o7BloodaIHoni_lD0oooooooooooooeSo
oooo0Ooal_<1okFg^@7o/;>f00001_lL;Sgo6RTeoc8lA_mnR93o_L?8on_/
k_oooooooooooomBooooo`05ong^koo7bL_oSY:FodE;DOla>T000Oli@DT0
0001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{604, 467},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    ButtonBox["SimpleCardLayout",
      ButtonData:>{"SimpleCardLayout.nb", None},
      ButtonStyle->"Hyperlink"]], "Input"],

Cell[BoxData[
    \(SimpleCardLayout[]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> java.awt.GridBagLayout <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;K0001VAP00`40o`00
0?l0003oo`000?l0003M000000000hS0^4R@R4R@R03oB928odR@R=U8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^=R8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;SHR<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P1000000001HS0^<SPf8S0^8S0^<c<c03`oooo
00?<c<coooooool0k_ooo`03c<c<oooooooo0>koool2R<2h0DR@R0400000
0006R<2hb>3HR<2hR<2hIVIVc<c<kVIVIP03ooooIVIVc<c<0>iVIVH00ooo
ofIVI/c<c03^IVIV00Cooon8`;R8`;Q8T8P1000000001XS0^<SPf8S0^8S0
^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`0
16IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_oo
ofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_oo
ong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`0
16IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_oo
ofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_oo
ong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<
c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IV
I_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIV
I_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<
c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IV
I_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIV
I_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`0
16IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_oo
ofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_oo
ong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`0
16IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_oo
ofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_oo
ong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<
c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IV
I_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIV
I_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<
c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IV
I_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIV
I_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`0
16IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_oo
ofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_oo
ong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`0
16IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_oo
ofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_oo
ong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<
c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IV
I_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIV
I_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<
c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IV
I_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIV
I_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`0
16IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_oo
ofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_oo
ong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`0
16IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_oo
ofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_oo
ong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooong<c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<
c<`016IVI_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IV
I_ooofIVI_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIV
I_ooong<c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<
c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooong<c<`016IVI_ooofIVI_ooong<c<`016IV
I_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooofo<c<`600000lc<c0@0001ac<c<00AVIVKooomVIVKo
oom_c<c<1P0000G<c<`20000LLc<c004IVIVooooIVIVooookLc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooKlc<c080
0003c<c<0P000003c<c<0000000000;<c<`20000L<c<c004IVIVooooIVIV
ooooKlc<c0800003c<c<0P0000C<c<`20000LLc<c004IVIVooooIVIVoooo
kLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooKlc<c0800003c<c<0P0000G<c<`20000L<c<c004IVIVooooIVIVoooo
Klc<c0800003c<c<0P000003c<c<0000000000@0001`c<c<00AVIVKooomV
IVKoooo]c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKooom_c<c<0P0000?<c<`200001Lc<c080001`c<c<00AVIVKooomV
IVKooom_c<c<0P0000?<c<`2000000C<c<`0003<c<c<c<`20000LLc<c004
IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooKlc<c0H00006c<c<0P00073<c<`016IVI_ooofIV
I_ooofo<c<`600000lc<c0040000c<c<00000000LLc<c004IVIVooooIVIV
ooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooooKlc<c0800003c<c<0P0000?<c<`30000LLc<c004IVIVooooIVIV
ooooKlc<c0800003c<c<0P0000;<c<`010000<c<c0000000077<c<`016IV
I_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooofo<c<`200000lc<c0800005c<c<0P00073<c<`016IV
I_ooofIVI_ooofo<c<`200000lc<c0800003c<c<0`00077<c<`016IVI_oo
ofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooofo<c<`200000lc<c08000000lc<c00000000002c<c<0P00
073<c<`016IVI_ooofIVI_ooofo<c<`200000lc<c0800003c<c<0`00077<
c<`016IVI_ooofIVI_ooong<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooofo<c<`600000lc<c0@0001ac<c<00AVIVKo
oomVIVKooom_c<c<1P0000G<c<`20000LLc<c004IVIVooooIVIVooookLc<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
kLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004
IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVoooo
IVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVoooo
kLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004
IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVoooo
IVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVoooo
kLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<
c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIV
ooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIV
ooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<
c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIV
ooooIVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIV
ooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
kLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004
IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVoooo
IVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVoooo
kLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004
IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVoooo
IVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVoooo
kLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<
c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIV
ooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIV
ooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<
c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIV
ooooIVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIV
ooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
kLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004
IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVoooo
IVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVoooo
kLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004
IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVoooo
IVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVoooo
kLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<
c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIV
ooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIV
ooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<
c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIV
ooooIVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIV
ooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
kLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004
IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVoooo
IVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVoooo
kLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004
IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVoooo
IVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVoooo
kLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<
c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIV
ooooIVIVooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIV
ooookLc<c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<
c004IVIVooooIVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIV
ooooIVIVooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIV
ooookLc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooookLc<c004IVIVooooIVIVooookLc<c004IVIVooooIVIVooookLc<
c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0>ko
ool00lc<c?ooofIVIP3^oooo00C<c<cooomVIVKoooo]c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;S`IVIV00?<c<aVIVIVIVH0
kVIVIP03c<c<IVIVoooo0>g<c<`01FIVI_ooohS0^8S0^4R@R00100000000
18S0^<SPf8S0^8S0^?o<c<cSc<c<00=VIVKoooo<c<`0k<c<c005IVIVoooo
R<2hR<2hB928004000000004R<2hb>3HR<2hR<2holc<c>?<c<`00fIVI_oo
olc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8
`;Soc<c<hlc<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R001
0000000018S0^<SPf8S0^8S0^?o<c<cSc<c<00=VIVKoooo<c<`0k<c<c005
IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2holc<c>?<c<`0
0fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8
h=R8`;R8`;P6c<c<ooooomSoool5c<c<00=VIVKoooo<c<`0k<c<c005IVIV
ooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVc<c<
IVIV0?mVIVKEIVIV00?oooo<c<c<c<`00lc<c003IVIVooooc<c<0>c<c<`0
1FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIV
I_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<
00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0
^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8
h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004
R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000
000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2h
B928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cD
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0
^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03o
c<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<
c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005
IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
ooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<
c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`0
0fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2h
R<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SP
f8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB92800400000
0004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R001
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2h
R<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<
c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_oo
ohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<
c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKo
ooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<
c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<
c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8
`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3H
R<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0
^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB9280040
00000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@
R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<
c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVoooo
R<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<
0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIV
I_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_oo
olc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<
c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0
^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R00100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928
004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0
^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<
e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0
olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIV
ooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVoooo
c<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`0
1FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIV
I_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<
00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<06k<c<`600000/c<c0H0001`c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0K/c<c0800003c<c<0P000003
c<c<0000000007C<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SP
f8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c01^c<c<0P0000?<c<`200000/c<c080001cc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKo
ooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0K/c<
c0800003c<c<0P0000?<c<`20000L/c<c005IVIVooooR<2hR<2hB9280040
00000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<06k<c<`600001Lc<c080001ac<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
K/c<c0800003c<c<0P0000G<c<`20000L<c<c005IVIVooooR<2hR<2hB928
004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<06k<c<`200000lc<c0800005
c<c<0P00073<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0
^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c01^c<c<0P0000?<c<`2000000?<c<`0000000000/c<c080
001`c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0K/c<c0H00003c<c<1000077<c<`01FIVI_ooohS0^8S0^4R@R001
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2h
R<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<
c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_oo
ohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<
c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKo
ooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<
c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<
c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8
`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3H
R<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0
^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB9280040
00000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@
R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<
c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVoooo
R<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<
0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIV
I_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_oo
olc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<
c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0
^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R00100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928
004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0
^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<
e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0
olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIV
ooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVoooo
c<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`0
1FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIV
I_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<
00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0
^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8
h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004
R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000
000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2h
B928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cD
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0
^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03o
c<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<
c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005
IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
ooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<
c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`0
0fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2h
R<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SP
f8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB92800400000
0004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R001
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2h
R<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<
c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_oo
ohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<
c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKo
ooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<
c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<
c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8
`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3H
R<2hR<2h1Lc<c003IVIVooooc<c<0>7<c<`AVIW<hLc<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0hLc<c003VIW<c<c<c<c<
00g<c<`00iVIc<c<c<c<c03Oc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0
^0G<c<`00fIVI_ooolc<c03Qc<c<00>IVLc<c<c<c<`03Lc<c003VIW<c<c<
c<c<0=o<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIV
ooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVoooo
c<c<0>7<c<`00iVIc<c<c<c<c00=c<c<00>IVLc<c<c<c<`0glc<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0hLc<c003VIW<
0000000000@00005c<c<0P0000;<c<`00iVIc<c<c<c<c03Oc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R001
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03Qc<c<00>IVL`0
000000000lc<c0800004c<c<0P0000;<c<`00iVIc<c<c<c<c03Oc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@
R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03Qc<c<00>I
VL`0000000000lc<c0800004c<c<0P0000;<c<`00iVIc<c<c<c<c03Oc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0
^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03Qc<c<
00>IVL`0000000000lc<c0800004c<c<0P0000;<c<`00iVIc<c<c<c<c03O
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0
^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03Q
c<c<00>IVL`000000000100000G<c<`200000/c<c003VIW<c<c<c<c<0=o<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2h
R<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0>7<
c<`00iVIc00000000003c<c<0P0000;<c<`010000<c<c000000000;<c<`0
0iVIc<c<c<c<c03Oc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<
c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`0
0fIVI_ooolc<c03Qc<c<00>IVL`0000000000lc<c0800002c<c<100000;<
c<`00iVIc<c<c<c<c03Oc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<
c<`00fIVI_ooolc<c03Qc<c<00>IVL`0000000000lc<c0800003c<c<0`00
00;<c<`00iVIc<c<c<c<c03Oc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0
^0G<c<`00fIVI_ooolc<c03Qc<c<00>IVL`000000000100000G<c<`20000
0/c<c003VIW<c<c<c<c<0=o<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVooooc<c<0>7<c<`00iVIc<c<c<c<c00=c<c<00>IVLc<c<c<
c<`0glc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<
c<`0hLc<c003VIW<c<c<c<c<00g<c<`00iVIc<c<c<c<c03Oc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R001
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03Qc<c<00>IVLc<
c<c<c<`03Lc<c003VIW<c<c<c<c<0=o<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3H
R<2hR<2h1Lc<c003IVIVooooc<c<0>7<c<`00iVIc<c<c<c<c00=c<c<00>I
VLc<c<c<c<`0glc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVKoooo<c<`0hLc<c16IVLcQc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0
^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R00100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928
004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0
^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<
e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0
olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIV
ooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVoooo
c<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`0
1FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIV
I_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<
00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0
^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8
h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004
R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000
000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2h
B928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cD
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0
^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03o
c<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<
c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005
IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
ooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<
c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`0
0fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2h
R<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SP
f8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB92800400000
0004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R001
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2h
R<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<
c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_oo
ohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<
c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKo
ooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<
c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<
c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8
`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3H
R<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0
^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB9280040
00000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@
R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<
c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVoooo
R<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<
0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIV
I_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_oo
olc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<
c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0
^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R00100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928
004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0
^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<
e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0
olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIV
ooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVoooo
c<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`0
1FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIV
I_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<
00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0
^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8
h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004
R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000
000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2h
B928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cD
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0
^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03o
c<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<
c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005
IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
ooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<
c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`0
0fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2h
R<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SP
f8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB92800400000
0004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R001
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2h
R<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<
c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_oo
ohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<
c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKo
ooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<
c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<
c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8
`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3H
R<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0
^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB9280040
00000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@
R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<
c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVoooo
R<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<
0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIV
I_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_oo
olc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<
c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0
^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R00100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928
004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0
^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<
e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0
olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIV
ooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVoooo
c<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`0
1FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIV
I_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c03/
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<
00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0
^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000B8`;S8
h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004
R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cDc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000
000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c03oc<c<e<c<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0olc<c=C<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2h
B928004000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<0?o<c<cD
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0>c<c<`01FIVI_ooohS0
^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooooooo`3o
ooooe?ooo`03c<c<ooooc<c<00C<c<`00fIVI_ooolc<c03/c<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P5c<c<ofIVI]QVIVH6
c<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB928004000000004
R<2hb>3HR<2hR<2holc<c>?<c<`00fIVI_ooolc<c03/c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;Soc<c<hlc<c003IVIVoooo
c<c<0>c<c<`01FIVI_ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0
^?o<c<cSc<c<00=VIVKoooo<c<`0k<c<c005IVIVooooR<2hR<2hB9280040
00000004R<2hb>3HR<2hR<2holc<c>?<c<`00fIVI_ooooooo`3/oooo00G<
c<cooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;Soc<c<hlc<c?1V
IVH01<c<c8S0^8S0^4R@R04000000003R<2hb>3HR<2h0?n8`;SoR<2hf8S0
^058T8P10000000018S0^<SPf8S0^8S0^1H0080400600`02P0@00h4400B1
0P05P@0300F200J200J200801X8200N200<11h81288128800P48P`@12H<3
0@Z300@12h<12h@12h@12h@40@b40`4=Q0@13XD30Pn5108@Q@@24HH30Q:6
0`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<I
R@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4122;
0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd59hh5
9hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@
00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB
1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD
10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2
U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI
0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`2
2U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]G
W`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaO
X@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@0
10eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`02
3VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@04
3gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[002
47b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61
[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9
/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8C
S[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe
4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8D
WKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X4
5ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/
_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/klf
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0@008000i^WlC=3YC=3
Y@09<d>U1P00P0@00H0300:01003P@@0184200F100<01H801X801X800P06
PP801h800`47PP48PP48PP020@R31049P`<12X<0104;P`4;Q04;Q04;Q0@1
38@30@f4104>Q@<23hD40Q25108AQP<24XH30Q>600@24hL258L258L258L4
0QF70P8FQ`835XP30aN810<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:
10<MRP<47XX010@NR`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<00<4
98d49Hd49Hd00PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?
1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`Ha
T@<6<Y400`HbTPHcTPHcTP021S>B00<6=987=987=9800PLeTP87=I<31cJC
10LgT`041cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPn
UPPnUPPnUP@8?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089
A9P42DFH00<9AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=
V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M
0P]DW@8;E9h42eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aK
X0<<G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=
HZ823F:S0`eSX`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZ
Y@@>JjH43VbV0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P0
10maZ0<?LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1h
ZP@@NJ/347Z[0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]
00<AOjdAP:dAP:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64
[a64[a64[`<AQJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a
0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<4
4i6c0a>B]0@CTk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf
0aBJ]P0359Zg59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h
5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX
_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^
_QN^_P045jnn11N`_P<G/Kl45k:o0aNc_cHH]<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0`00P007VjOaooooSWZfYY_4/jWBZ9g8/jWB00:VVl@0
1KbhgNk^m>[YlOoooc=3Y@0500201001P0<00X0400>11004P@801H400`05
PP06PP06PP0200J20P07PP030@N20@R20@R2008128<40@V30`4:P`040@^3
0@^40@^40@^4104<Q0<13H@40@j50`8?Q@@248D40Q660`8BQP<24hH0108C
Q`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT3
0aZ910<KR@<378X40af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<
10@SS08498`00`@TS@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h3
1BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A
1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP02
1cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE
0`PmU@0423fF23jF23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9
@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ
0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId2
2U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO
10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aP
XP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT
0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL0
0`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmf
ZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`2
47j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^
1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::
/A::/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8C
Sk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D3
59Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@E
W[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/4
5ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d0
11N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G/[l35k>o0QRd`2000002
6;C04000008H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P004
VjOaooooK5ZU[jG:0[bhg@0:oogo/jWBoooooooo_;SMUhZlZ9g8i^K/oooo
<d>U1000P0@00H0300:01003P@@0184200F100<01H801X801X800P06PP80
1h800`47PP48PP48PP020@R31049P`<12X<0104;P`4;Q04;Q04;Q0@138@3
0@f4104>Q@<23hD40Q25108AQP<24XH30Q>600@24hL258L258L258L40QF7
0P8FQ`835XP30aN810<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:10<M
RP<47XX010@NR`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<00<498d4
9Hd49Hd00PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?
1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6
<Y400`HbTPHcTPHcTP021S>B00<6=987=987=9800PLeTP87=I<31cJC10Lg
T`041cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPn
UPPnUP@8?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P4
2DFH00<9AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:
CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]D
W@8;E9h42eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<
G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ82
3F:S0`eSX`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>
JjH43VbV0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010ma
Z0<?LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@
NJ/347Z[0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<A
OjdAP:dAP:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64
[a64[`<AQJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:<
/@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c
0a>B]0@CTk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ
]P0359Zg59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i
5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY
_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^
_P045jnn11N`_P<G/Kl45k:o0aNc_`8H]<000lSPf4R@R4R@R00<B92800<0
0038h=Q8T8P03DR@R00400006;C06;C0b>3H3TR@R00300006;C06;C000:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000^KYo7ooonXWLSooonc
ZM9PC9Z>N[IhIJjXWLSooooooOl00oooo`03<d>U0020002000<008040060
0`02P0@00h4400B10P05P@0300F200J200J200801X8200N200<11h812881
28800P48P`@12H<30@Z300@12h<12h@12h@12h@40@b40`4=Q0040@j5oooo
oooooooo0`8?Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL2
0QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:
0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@U
S@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5
:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`Hb
T@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC
00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF
23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9
AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>
V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM
0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aL
X00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=
HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[
YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X
0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111i
Z`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o
[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_
4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba
00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<3
4i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf
00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TE
X;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl
5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn
00@G[kh45k2n0aNa_`@G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@
R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008003Y^WlOoooooo
om_Lk61<VY>5^[>Yd[bhgF1<VYV?_ZJKa<S3gooooc=3Y@H00803oooo00<0
0H000X000X001?ooo`0500>100B100B1oooo00B100801H400`05P_oooooo
o`02oooo0P07PPCoool01@48P`49P`49Poooo`49P`020@Z300Ooool12h<1
2h@12hCoool138Coool00P4<Q0040@f4oooo0@f4oooo0`4>Q@03oooo0Pn5
0Pn500@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<F
R0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:0`@NRP04
11j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@US@@US@02
1BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?
0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@031S:B
1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7
>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF10Po
UP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6
V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL
2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;
EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ
35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S
10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H2
3VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?
LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/3
47^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60
[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_0a65
[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<BS;8B
SK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C
]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LD
VkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T3
5J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl
11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh4
5k2n0aNa_`@G/[l35k>o0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P00dR@
R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8
T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00>
VjOaoooo_;SMVHnnooooe]7Mfmc/lokoYY_4k^kdQGJ`ThFjoooo<d>U1000
P008oooo006000600060oooo00:0oooo00:00P03P@06oooo00>100B100B1
oooo00B10P05P@08oooo00J200J200J2oooo00N2oooo0@N20P48PP060@R3
oooo0@V30@V3oooo0@V30P4:P`07oooo0@^30@^40@^4oooo0@b4oooo0081
38@00`4=Q?ooo`4=Q004oooo0`8?Q@@248D40Q660`8BQP<24hH0108CQ`8D
Q`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ9
10<KR@<378X40af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<10@S
S08498`00`@TS@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>
00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A
0086<9431S6A0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB
0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`Pm
U@0423fF23jF23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9
A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;
VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M
0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]I
W`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<
HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eX
Y@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`
Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmf
ZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/
0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163
[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::
/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<C
Sk<011>@/`@CTK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne
11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P3
5Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk
0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]
_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G/[l35k>o0QRd`004b>3HR<2h
R<2hR<2h1P0000B8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0
^0050000R<2hR<2hB9280000008H]<001<SPf8S0^8S0^8S0^0800004R<2h
0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P3002000nKYo7ooonISkjGR[cDdnS_[;?oMW_^Wj]KF:FVVlBFWm9P
C9Zl^=gooolc@jD00`00P008oooo006000600060oooo00:0oooo00:00P03
P@06oooo00>100B1oooo00B1oooo0P05P@08oooo00J200J200J2oooo00N2
oooo0@N20P48PP0:0@R3oooo0@V3oooo0@V3oooo0@Z3oooo0@Z3oooo0P4;
Q003oooo0@b4oooo008138@0104=Q?ooo`4=Q?ooo`<13XD30Pn5108@Q@@2
4HH30Q:60`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P0
10<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/4
7h/4122;0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<5
9hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6
;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHc
TP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7
>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3
246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9
AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?
W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]G
WP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ44
35jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=
IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^
Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY
0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l
[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161
[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk04
4XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb
0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd
4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g
0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS
^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08F
Zkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb
_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`00
08S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h
00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOXZFjPb<?O
ThFjFdJCVHnn0WQU[P04@RN5[jG:oooo<d>U1000P0<00H000oooo`02P002
P004oooo00D00h40187oool0187oool00P05P@0300F2oooooooo00;oool2
00N200d11h812881288128?oool12H?oool12H?oool12X?oool12X?oool0
0P4;Q003oooo0@b4oooo008138@00`4=Q?ooo`4=Q004oooo0`8?Q@@248D4
0Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR8
00@36HP36HT36HT36HT30aZ910<KR@<378X40af:0`@NRP0411j;11n;11n;
11n;10@PR`<48H/412:<10@SS08498`00`@TS@@US@@US@021BF=10DVS@03
1BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I03
1Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B0086
<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@3
1cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF10PoUP88@9H2242G
0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@04
2DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:
Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;
Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ
10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS
3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>
KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10md
Z@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@
O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@A
PJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`
11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=
/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@011>E
]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK
]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@E
XkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`2
5Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G
/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<0
0028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0
^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2002000>KYo7oooooool00_ooo`0:ojf`ogIknLgDoNg^
ooooYY_4QGJ`_;SMoooo<d>U1@00P0<00H001?ooo`02P002P002P0800h40
0oooo`03POooo`0300B100?oool01H401H800`06PP04oooo00N200N20@N2
0oooo`090@R30@V3oooo0@V3oooo0@Z3oooo0@Z3oooo00812h@02Oooo`4<
Q?ooooooo`4<Q04=Q?ooo`4=Q?ooo`020@j500Coool23hD23hD23hD40Q25
108AQP<24XH30Q>600@24hL258L258L258L40QF70P8FQ`835XP30aN810<H
R0040aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX010@NR`@OR`@O
R`@OR`@488/3126;10@RS0@48h`212B<00<498d49Hd49Hd00PDUS@@59Xd0
0`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@
0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHcTPHcTP02
1S>B00<6=987=987=9800PLeTP87=I<31cJC10LgT`041cRC1cRD1cRD1cRD
0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2242F0PQ0
U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9AYT9AYT0
10U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W002
2TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN0`]FWP04
2eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aMX@aMX@aM
X@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=I:<00`eU
X`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]YP033VfW
3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?
M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/
47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d00Q60[@04
4H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<AQJl44HJ_0a:7
/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb008B
SK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@34iBd00@C
UK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g59^g008D
VkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T4
5J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l
0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`_P<G/Kl4
5k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^003
0000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8
`;P018S0^0800005R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0`00P00:XJcbnLgDhRHlm;FohRHlm6emo>?YoooooNg^
ojf`0_ooo`03<d>U0020002000@00803006000?oool00X000X000oooo`80
0h401oooo`04P@04P@04POooo`05P@05PP03oooo00@01X801h801h;oool2
0@R20P48P`050@V3oooo0@V30@V3oooo00812X<01oooo`4;Q04;Q?ooo`4<
Q?ooo`4<Q002oooo0P4=Q0030@j5oooooooo00;oool20Pn5108@Q@@24HH3
0Q:60`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P010<I
R0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4
122;0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd5
9hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y03
1Rn@00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP03
1SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@4
1cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G
10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT4
2DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:
D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]G
W`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ
0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=
IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^
Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`me
Z@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l
[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61
[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`
0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>
/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe
4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL
]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<E
Y;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd0
0aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G
/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0
^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8
`;P4000018S0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_ARK_omoon]/?cS
jOoooc=3Y@0700200`01P004oooo00:000:000:01003P@@0184200F100<0
1H801X801X800P06PP0300N2oooo0@N2008128820@R31049P`<12X<0104;
P`4;Q04;Q04;Q0@138@30@f4104>Q@<23hD40Q25108AQP<24XH30Q>600@2
4hL258L258L258L40QF70P8FQ`835XP30aN810<HR0040aV80aV90aV90aV9
0`<JR@@36hT30ab:10<MRP<47XX010@NR`@OR`@OR`@OR`@488/3126;10@R
S0@48h`212B<00<498d49Hd49Hd00PDUS@@59Xd00`DWS@DWSPDWSP041BR>
0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`
T@H`T@021S2A0`HaT@<6<Y400`HbTPHcTPHcTP021S>B00<6=987=987=980
0PLeTP87=I<31cJC10LgT`041cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`Pl
U@<8?ID010PmUPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8@IL424:G0PQ3U`03
2D>H2DBH2DBH0089A9P42DFH00<9AYP9AYT9AYT010U7V@@9B9T32DVJ10U:
VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M
0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN0`]FWP042eNN2eNO2eNO2eNO0`]H
W`@;FIl435ZP0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<
H:82366R0PeQXP8=HZ823F:S0`eSX`@=I:<00`eUX`eUY0eUY0043FJT10eW
Y0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW3VjW008>KZL43VnW
00<>L:L?L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?
MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/47b/008@O:`347f/
0Q1n[08@OZd247n]00<AOjdAP:dAP:d00Q60[@044H6]4H6^4H6^4H6^0a62
[P@APjh01164[Q64[a64[a64[`<AQJl44HJ_0a:7/0@BR;034XV`00@BRK4B
R[4BR[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb
4hnc4hnc00@CT;<44i6c0a>B]0@CTk@34iBd00@CUK@CUKDCUKDCUKD459Je
0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g59^g008DVkL359bg0QBM]`8EWKP4
5Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk
11JW^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm
00@G[Kd00aN^_AN^_QN^_P045jnn11N`_P<G/Kl45k:o0aNc_`8H]<000lSP
f8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P0
1@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h
0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000>KYo7fb<cR9S`00_n]/007gb@^ojBNm[c5ojf`kW^<oooo
<d>U00P00803006000Coool00X000X000X0400>11004P@801H400`05PP06
PP06PP0200J200<01h;oool11h800P48PP030@R3oooo0@V300<12H<30@Z3
00@12h<12h@12h@12h@40@b40`4=Q0@13XD30Pn5108@Q@@24HH30Q:60`8C
QP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<I
R@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4122;0`@Q
R`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd59hh59hh0
10DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6
;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB
1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10Lk
U@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88
@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9
VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L
0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]G
W`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<
Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eV
Y0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW
10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY
3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/
0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61
[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/004
4XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[80
0a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe
11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL2
5Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj
0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/
_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/kl26;C0
00?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P900000XS0^005B928
00006;C06;C0b>3H00>8`;P2000018S0^0800002R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOanLgDmhVG
00;oool01on]/>4F=?mfNonTW^8V??n9Oc=3Y@0800200`01P004oooo00:0
00:000:01003P@@0184200F100<01H801X801X800P06PP801h84oooo00<1
28<12H<12H<00P49P`<12X<0104;P`4;Q04;Q?ooo`@138@30@f4104>Q@<2
3hD40Q25108AQP<24XH30Q>600@24hL258L258L258L40QF70P8FQ`835XP3
0aN810<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX010@N
R`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<00<498d49Hd49Hd00PDU
S@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5
;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHc
TPHcTP021S>B00<6=987=987=9800PLeTP87=I<31cJC10LgT`041cRC1cRD
1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2
242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9
AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?
W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN
0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aM
X@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=
I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]
YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X
0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1k
Z`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d0
0Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<AQJl4
4HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb
4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@3
4iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g
59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ
^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@F
Z[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`
_P<G/Kl45k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P0
0XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008001i^WlOoooo>P
[_ARK_ooooN9UoW=e002oooo00?cX:kooolc@jD02000P0@00H0300:01003
P@@0184200F100<01H801X801X800P06PP801h800`47PP48PP48PP020@R3
1049P`<12X<0104;P`4;Q04;Q04;Q0@138@30@f4104>Q@<23hD40Q25108A
QP<24XH30Q>600@24hL258L258L258L40QF70P8FQ`835XP30aN810<HR004
0aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX010@NR`@OR`@OR`@O
R`@488/3126;10@RS0@48h`212B<00<498d49Hd49Hd00PDUS@@59Xd00`DW
S@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^
T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHcTPHcTP021S>B
00<6=987=987=9800PLeTP87=I<31cJC10LgT`041cRC1cRD1cRD1cRD0`Li
U0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8
@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9AYT9AYT010U7
V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL
0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN0`]FWP042eNN
2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<
GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=I:<00`eUX`eU
Y0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW
3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?M:T3
3gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/
47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d00Q60[@044H6]
4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<AQJl44HJ_0a:7/0@B
R;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb008BSK82
4Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@34iBd00@CUK@C
UKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g59^g008DVkL3
59bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j
0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[
_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`_P<G/Kl45k:o
0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P03HS0^005B928
00006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P3002000^KYo7oooooRGooooocX:kaTj7ooooooOoc
X:kono`c@jD02000P0@00H0300:01003P@@0184200F100<01H801X801X80
0P06PP801h800`47PP48PP48PP020@R31049P`<12X<0104;P`4;Q04;Q04;
Q0@138@30@f4104>Q@<23hD40Q25108AQP<24XH30Q>600@24hL258L258L2
58L40QF70P8FQ`835XP30aN810<HR0040aV80aV90aV90aV90`<JR@@36hT3
0ab:10<MRP<47XX010@NR`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<
00<498d49Hd49Hd00PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>
1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A
0`HaT@<6<Y400`HbTPHcTPHcTP021S>B00<6=987=987=9800PLeTP87=I<3
1cJC10LgT`041cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010Pm
UPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH
0089A9P42DFH00<9AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK
10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd3
2e>M0P]DW@8;E9h42eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP
0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQ
XP8=HZ823F:S0`eSX`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU
0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?
L:P010maZ0<?LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ
0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd2
47n]00<AOjdAP:dAP:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164
[Q64[a64[a64[`<AQJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[44
4X^a0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@C
T;<44i6c0a>B]0@CTk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H3
59Vf0aBJ]P0359Zg59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^004
5J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/0
11JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^
_AN^_QN^_P045jnn11N`_P<G/Kl45k:o0aNc_`8H]<0?b>3H00<00038h=S8
h=P03LSPf00300006;C06;C000o8h=P00`0001Rd`1Rd`002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h1000P0>KYo401_oooo>P[_Be_oJlaO_IfS=3
Y@T0080400600`02P0@00h4400B10P05P@0300F200J200J200801X8200N2
00<11h81288128800P48P`@12H<30@Z300@12h<12h@12h@12h@40@b40`4=
Q0@13XD30Pn5108@Q@@24HH30Q:60`8CQP040Q>70QB70QB70QB7108EQ`82
5XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX3
11j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@TS00312B=12F=
12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZ
S`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A
00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<0
10LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8
?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5
V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK
00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d2
2eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP
00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeR
X`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V
10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP3
3g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[
0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]
4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lA
Q:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;40
0a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<C
T[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H0
0aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP
^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`F
ZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h0
11N__P@G/;h35k6o11Nb_`<G/klf6;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^1H0080400600`02P0@00h4400B10P05P@0300F200J200J20080
1X8200N200<11h81288128800P48P`@12H<30@Z300@12h<12h@12h@12h@4
0@b40`4=Q0@13XD30Pn5108@Q@@24HH30Q:60`8CQP040Q>70QB70QB70QB7
108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^90`<L
RP@37HX311j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@TS003
12B=12F=12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZSPDZ
S`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6
<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC0`Lf
T`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8
?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4V002
2DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:
CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]C
W@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<
Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ82
3F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>
JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X
00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@
N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o
[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@AQ:hA
Q:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;
/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c
11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI
]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP
^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@F
Z;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG
[[hG[[h011N__P@G/;h35k6o11Nb_`<G/klf6;C00XS0^058T8P100000000
0hS0^<SPf8S0^03oR<2hohS0^=R8`;P1B9280@00000000>8`;S8h=R8`;P0
ohS0^?n8`;SHR<2h0DR@R04000000003R<2hb>3Hb>3H0?o8h=Sob>3Hf<SP
f058T8P10000003oR<2hohS0^=b8`;P100000000\
\>"], "Graphics",
  ImageSize->{731, 409},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;N0001Z2000`400?l0
0000o`00003oooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?000?oo
l?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`
l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?oo
l?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003o
oo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3o
l?3`003ooo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000oooooooo
ooooon3ooooo0002onk^kP;okNg]00[ojn_[onSXj?oUiNGoh^;RomgMgOoH
f=Soe=CDom7AdOo>c/koc<c<0_o;bl_Eol[:bP;obl_;00[oc<c<olk>c_oA
dM7oe=CDomSHf?oMgMgoh^;RonGUiOoXj>Sojn_[0_o]kNd3onk^kP;okNg]
00[ojn_[onSXj?oUiNGoh^;RomgMgOoHf=Soe=CDom7AdOo>c/koc<c<0_o;
bl_Eol[:bP;obl_;00[oc<c<olk>c_oAdM7oe=CDomSHf?oMgMgoh^;RonGU
iOoXj>Sojn_[0_o]kNd3onk^kP;okNg]00[ojn_[onSXj?oUiNGoh^;RomgM
gOoHf=Soe=CDom7AdOo>c/koc<c<0_o;bl_Eol[:bP;obl_;00[oc<c<olk>
c_oAdM7oe=CDomSHf?oMgMgoh^;RonGUiOoXj>Sojn_[0_o]kNd3onk^kP00
00goi^KVonGUiOoUiNGoh^;Ron3Ph?oKfm_oe]KFolk>c_o7alOo_knookRh
^?nd];Co/;2`00;o[Zj^0_n][JgCojb/[0;o[Jf]0_n^[Zh02_n`/;3o];Bd
okRh^?no_kooalO7olk>c_oFe]Kofm_Kon3Ph?oRh^82onGUi@0=onKVi_oU
iNGoiNGUon;Rh_oPh>3ofm_KomKFe_o>c/koalO7okno_onh^;So];Bdok2`
/002ojj^[P;o[Jf]don/[:`2ojf][@;o[Zj^00[o/;2`okBd]?nh^;So_kno
olO7aoo>c/koe]KFom_KfooPh>3oh^;R0_oUiND03OoVi^KoiNGUonGUiOoR
h^;oh>3Pom_KfooFe]Koc/k>olO7aono_koo^;RhokBd]?n`/;000_n^[Zh2
ojf][M?o[:b/0_n][Jd2ojj^[P0:ok2`/?nd];Co^;Rhokno_oo7alOoc/k>
omKFe_oKfm_oh>3Pon;RhP;oiNGU0_oVi^H0000?onk^k_o]kNgoj^[ZonOW
iooRh^;ofMWIolk>c_o3`l?o^;Rhojj^[_nVYZKoX:2PoibLW?nIVIWoV9RH
0=OoUiNG00goV9RHoiVIVOnLW9coX:2PojJVY_n^[Zko^;Rhol?3`oo>c/ko
fMWIon;Rh_oWinOoj^[Z00?okNg]00goj^[ZonOWiooRh^;ofMWIolk>c_o3
`l?o^;Rhojj^[_nVYZKoX:2PoibLW?nIVIWoV9RH0=OoUiNG00goV9RHoiVI
VOnLW9coX:2PojJVY_n^[Zko^;Rhol?3`oo>c/kofMWIon;Rh_oWinOoj^[Z
00?okNg]00goj^[ZonOWiooRh^;ofMWIolk>c_o3`l?o^;Rhojj^[_nVYZKo
X:2PoibLW?nIVIWoV9RH0=OoUiNG00goV9RHoiVIVOnLW9coX:2PojJVY_n^
[Zko^;Rhol?3`oo>c/kofMWIon;Rh_oWinOoj^[Z00;okNg]0Oo^k^h0000?
ooooooolo?conOWioo;bl_oXj>Sof][Jol_;bonj^[[o[:b/oinOWonEUIGo
SXj>ohZ:R_n7QhOoQXJ60=OoQHF501goQXJ6ohN7Qon:RX[oSXj>oiFEUOnO
Wioo[:b/okZj^_o;bl_of][JonSXj?obl_;onOWiooclo?ono_koo?clooWi
nOobl_;oj>SXom[Jf_o;bl_o^[Zjojb/[?nOWiooUIFEohj>S_n:RX[oQhN7
ohJ6QP3GohF5Q@0MohJ6Q_n7QhOoRXZ:ohj>S_nEUIGoWinOojb/[?nj^[[o
bl_;om[Jf_oXj>Sol_;booWinOolo?coo_knooclo?oinOWol_;bonSXj?oJ
f][obl_;okZj^_n/[:coWinOoiFEUOn>SXkoRXZ:ohN7Qon6QXH0eon5QHD0
3on6QXKoQhN7ohZ:R_n>SXkoUIFEoinOWon/[:co^[Zjol_;booJf][oj>SX
oo;bl_oinOWoo?clooknoP01ooooo`0001Gok^k^onSXj?oRh^;ofMWIol[:
b_nj^[[oZ:RXoiRHV?nBTY;oYJFUol30`?oGemOojn_[ooKfm_ogmoOonOWi
ooShn?oinOWon_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg
00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWi
nOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00ooj
n_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWi
n@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooSh
n0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg
00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWi
nOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00ooj
n_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWi
n@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooSh
n0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg
00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWi
nOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00ooj
n_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWi
n@03oo[jn_oinOWomoOg00?on?Sh0_oinOT09oojn_[onOWiooShn?oinOWo
n?ShooOgmoo]kNgof=SHol71`OnUYJGoTY:BoiRHV?nXZ:So^[Zjol[:b_oI
fMWoh^;RonSXj?o/k>coj>SXon;Rh_oIfMWob/[:okZj^_nXZ:SoV9RHoi:B
T_nUYJGo`<30omOGeoo[jn_om_KfooOgmooinOWon?ShooWinOojn_[onOWi
ooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[j
n_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi
00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh
0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL0
0oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWi
ooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[j
n_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi
00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh
0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL0
0oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWi
ooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[j
n_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi
00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh
0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL0
0oohn?P2ooWin@0Woo[jn_oinOWon?ShooWinOohn?SomoOgong]kOoHf=So
`L71ojFUYOnBTY;oV9RHojRXZ?nj^[[ob/[:omWIfOoRh^;oj>SXonc/k?oX
j>Soh^;RomWIfOo:b/[o^[ZjojRXZ?nHV9SoTY:BojFUYOo0`<3oemOGon_[
joofm_KomoOgooWinOohn?SonOWioo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi01?on_[j
ooWinOohn?SonOWiooShn?ogmoOokNg]omSHf?o1`L7oYJFUoi:BT_nHV9So
Z:RXokZj^_o:b/[ofMWIon;Rh_oXj>Sok>c/007ok^k^00003OoVi^KogMgM
omKFe_o7alOo]kNgoj>SXonATI7oXZ:Rol_;boo^k^kom_Kfooclo?ono_h0
foooool06Oono_koo?clooOgmoo_knooc<c<oj>SXonATI7oXj>SokNg]oo7
alOoe]KFomgMgOoRh^;ogMgMomKFe_o7alOo]kNgoj>SXonATI7oXZ:Rol_;
boo^k^kom_Kfooclo?ono_h0foooool06Oono_koo?clooOgmoo_knooc<c<
oj>SXonATI7oXj>SokNg]oo7alOoe]KFomgMgOoRh^;ogMgMomKFe_o7alOo
]kNgoj>SXonATI7oXZ:Rol_;boo^k^kom_Kfooclo?ono_h0foooool03Oon
o_koo?clooOgmoo_knooc<c<oj>SXonATI7oXj>SokNg]oo7alOoe]KFomgM
gOoRh^800OoVi^H0000;onk^k_oRh^;oe]KFol?3`on^[ZkoVYZJojf][OoN
g]kojn_[ooCdm?okno/0goooool05Ookno_olo?conc/k?oQhN7o/;2`oiZJ
V_n^[Zko`l?3omKFe_oRh^;oj>SXon;Rh_oFe]Ko`l?3ojj^[_nJVY[o[Jf]
omkNg_o[jn_om?Cdoo_kn`3Oooooo`0Eoo_knooclo?ok>c/on7QhOn`/;3o
VYZJojj^[_o3`l?oe]KFon;Rh_oXj>Soh^;RomKFe_o3`l?o[Zj^oiZJV_n]
[Jgog]kNon_[joodm?Cono_k0=oooooo00_ono_koo?cloo/k>cohN7Qok2`
/?nJVY[o[Zj^ol?3`ooFe]Koh^;RonSXj001onk^kP0000_oooooong]kOoL
g=coaLG5ojb/[?n][Jgoe=CDon3Ph?o/k>comOGeoogmo@3Oooooo`0Eookn
o_ofm_Kok>c/on;Rh_oIfMWo/K6aojb/[?o5aLGog=cLong]kOofm_KokNg]
omcLg?o5aLGo[:b/ojf][OoDe=Coh>3Ponc/k?oemOGooOgm0=oooooo01Go
o_knooKfm_o/k>coh^;RomWIfOna/K7o[:b/olG5aOoLg=cokNg]ooKfm_o]
kNgog=cLolG5aOn/[:co[Jf]omCDe?oPh>3ok>c/ooGemOomoOd0goooool0
2oono_kom_Kfonc/k?oRh^;ofMWIok6a/On/[:coaLG5omcLg?o]kNgom_Kf
007ooooo00003?o^k^kof=SHolK6a_n^[ZkoXj>SolK6a_oDe=Coh>3Ponc/
k?obl_;oo?clookno]kooooo01Kon_[jooCdm?oZj^[ohn?SomOGeoo=cLgo
YZJVojj^[_o6a/Kof=SHon;Rh_oHf=Soa/K6ojj^[_nSXj?oa/K6omCDe?oP
h>3ok>c/oo;bl_olo?coo_kng_ooool05_ojn_[om?Cdon[Zj_oShn?oemOG
olg=cOnVYZKo[Zj^olK6a_oHf=Soh^;RomSHf?o6a/Ko[Zj^oj>SXoo6a/Ko
e=CDon3Ph?o/k>col_;booclo?ono_kNooooo`0;oo[jn_odm?Coj^[Zon?S
hooGemOocLg=ojJVY_n^[Zkoa/K6omSHf?oRh^800Oo^k^h0000@onKVi_o=
cLgo^KVioj6QXOn[Zj_oa/K6om;Bd_oLg=coi^KVonc/k?oemOGon?Shoo[j
n_omoOgoooooooclo0Sooooo00?ooOgmooooooooool01Oooool00oomoOgo
ooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooooooo
ool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Go
oooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03
oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgo
ooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooooooo
ool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Go
oooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03
oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgo
ooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooooooo
ool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Go
oooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`02ooooo`0O
oogmoOoooooooOgmoo_knoohn?Som?Cdong]kOoVi^KogmoOomKFe_o<c<co
/K6aoj:RX_ni^KWocLg=om_Kfoo=cLgo^KVioj6QXOn[Zj_oa/K6om;Bd_oL
g=coi^KVonc/k?oemOGon?Shoo[jn_omoOgoooooooclo008ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool00_ooool07oomoOgooooooogmoOokno_on?ShooCd
m?o]kNgoi^KVomoOgooFe]Koc<c<ok6a/OnRXZ;o^KViolg=cOoKfm_ocLg=
okVi^OnQXJ7oZj^[olK6a_oBd];og=cLonKVi_o/k>comOGeooShn?ojn_[o
oOgmooooooolo?`02?ooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00;ooooo013o
oOgmooooooomoOgono_kooShn?odm?CokNg]onKVi_oOgmooe]KFolc<c?na
/K7oXZ:RokVi^Oo=cLgofm_K0OoVi^H0000Donk^k_oAdM7o^k^koj6QXOnf
][Ko`l?3olo?cooFe]KogmoOonKVi_oZj^[okno_oo?cloodm?ComOGeooOg
moofm_KomoOgooKfm_ohn?P2ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg02Kom_KfooShn?ofm_KomoOgooKfm_odm?Col_;boo3`
l?o[jn_oi^KVon7QhOoJf][odm?ColW9bOno_kooYZJVok^k^ooAdM7ohN7Q
om7AdOnk^k_oXJ6QokJf]_o3`l?oclo?omKFe_oOgmooi^KVon[Zj_o_knoo
lo?cooCdm?oemOGomoOgooKfm_ogmoOom_KfooShn0;omoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_Kf
ooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL09_ofm_Kon?ShooKfm_ogmoOo
m_KfooCdm?obl_;ol?3`on_[jooVi^KohN7Qom[Jf_oCdm?obLW9okno_onV
YZKo^k^kom7AdOoQhN7odM7Aok^k^onQXJ7o][Jfol?3`oo?clooe]KFomoO
gooVi^Koj^[Zono_kooclo?om?CdooGemOogmoOom_KfooOgmoofm_Kon?Sh
0_ogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`0CooKf
m_ohn?Som_KfooOgmoofm_Kom?Cdoo;bl_o`l?3ojn_[onKVi_oQhN7of][J
om?Cdoo9bLWo_knoojJVY_nk^k_odM7Aon7Qh@01onk^kP0000coooooomoO
goo5aLGoY:BTok>c/oo0`<3obLW9om?CdooIfMWogMgMon;Rh_oUiND2on[Z
jP03onc/k?o]kNgokNg]00Ook^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h01?o`l?3ok^k^onk^k_o^k^h2
ong]k@;ok>c/01SojNWYonKVi_oShn?oh>3Pom_KfooEeMGocLg=olG5aOnk
^k_oZj^[olG5aOoOgmool?3`omoOgoo5aLGoY:BTok>c/oo0`<3obLW9om?C
dooIfMWogMgMon;Rh_oUiND2on[ZjP03onc/k?o]kNgokNg]00Ook^k^00?o
l?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^
k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^
kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^
k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?o
l?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^
k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^
kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^
k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?o
l?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^
k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^
kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^
k^h01?o`l?3ok^k^onk^k_o^k^h2ong]k@;ok>c/01SojNWYonKVi_oShn?o
h>3Pom_KfooEeMGocLg=olG5aOnk^k_oZj^[olG5aOoOgmool?3`omoOgoo5
aLGoY:BTok>c/oo0`<3obLW9om?CdooIfMWogMgMon;Rh_oUiND2on[ZjP03
onc/k?o]kNgokNg]00Ook^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h01?o`l?3ok^k^onk^k_o^k^h2ong]
k@;ok>c/00gojNWYonKVi_oShn?oh>3Pom_KfooEeMGocLg=olG5aOnk^k_o
Zj^[olG5aOoOgmool?3`007ooooo00003_o^k^kodM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@7ok^k^00003_oVi^Kob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV00003_o^k^ko
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_ooooooh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7a
l@7ooooo00003_o^k^kodM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_oVi^Ko
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?ne]KGob/[:omWIf@7oi^KV00003_o^k^kodM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@7ok^k^00003_ooooooh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00003_o^k^ko
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_oVi^Kob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@7oi^KV00003_o^k^kodM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_oooooo
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7alOoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3Poo7alOoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@7ooooo00003_o^k^kodM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@7ok^k^00003_oVi^Kob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV00003_o^k^ko
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_ooooooh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7a
l@7ooooo00003_o^k^kodM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_oVi^Ko
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?ne]KGob/[:omWIf@7oi^KV00003_o^k^kodM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@7ok^k^00003_ooooooh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00003_o^k^ko
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_oVi^Kob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@7oi^KV00003_o^k^kodM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_oooooo
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7alOoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3Poo7alOoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@7ooooo00003_o^k^kodM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@7ok^k^00003_oVi^Kob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV00003_o^k^ko
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_ooooooh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7a
l@7ooooo00003_o^k^kodM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_oVi^Ko
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?ne]KGob/[:omWIf@7oi^KV00003_o^k^kodM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@7ok^k^00003_ooooooh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00003_o^k^ko
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_oVi^Kob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@7oi^KV00003_o^k^kodM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_oooooo
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7alOoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3Poo7alOoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@7ooooo00003_o^k^kodM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@7ok^k^00003_oVi^Kob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV00003_o^k^ko
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_ooooooh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7a
l@7ooooo00003_o^k^kodM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_oVi^Ko
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?ne]KGob/[:omWIf@7oi^KV00003_o^k^kodM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@7ok^k^00003_ooooooh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00003_o^k^ko
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_oVi^Kob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@7oi^KV00003_o^k^kodM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^00003_oooooo
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7alOoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_o
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3Poo7alOoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7al@7ooooo00003_o^k^kodM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@7ok^k^00003_oVi^Kob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV00003_o^k^ko
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0<ooMgMd00oo9
bLWo][Jfom_Kf`0DomgMg@;og]kN0_oMgMdGomkNgP03omgMgOoNg]kog]kN
03CogMgM0_oLg=`06ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qom7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3?og]kN0_oM
gMd00ooNg]kogMgMomgMg@1:omgMg@;og]kN0_oMgMdGomkNgP03omgMgOoN
g]kog]kN03CogMgM0_oLg=`06ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qom7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3?o
g]kN0_oMgMd00ooNg]kogMgMomgMg@1:omgMg@;og]kN0_oMgMdGomkNgP03
omgMgOoNg]kog]kN03CogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h0000>
oooooooPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/3omcLg3?og]kN0_oMgMd00ooNg]kogMgMomgMg@0[omgM
g@0=obh^;_l0003o0000o`h>3_ll?3co`l?3omgMgOm:BT[o3Ph>obl_;olE
5AGoEUIFom7Ad@0BomgMg@;og]kN0_oMgMdGomkNgP03omgMgOoNg]kog]kN
03CogMgM0_oLg=`06ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>3olO7aon3Ph?o8b<SoUIFEojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3?og]kN0_oM
gMd00ooNg]kogMgMomgMg@0[omgMg@06obh^;_l0003o0000o`h>3_ll?3co
`l?31?oMgMd00oo5aLGo0000olk>cP0BomgMg@;og]kN0_oMgMdGomkNgP03
omgMgOoNg]kog]kN03CogMgM0_oLg=`06ooKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7aon3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3?og]kN0_oMgMd00ooNg]kogMgMomgMg@1:omgMg@;og]kN0_oMgMdG
omkNgP03omgMgOoNg]kog]kN03CogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0Ooo
ool0000>onk^k_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/3omcLg3?og]kN0_oMgMd00ooNg]kogMgMomgM
g@0[omgMg@0=obh^;_mWIfOof=SHokRh^?lR8R;oCTi>omgMgOo6a/Kofm_K
omgMgOo5aLGo30`<ofATI00BomgMg@;og]kN0_oMgMdGomkNgP03omgMgOoN
g]kog]kN03CogMgM0_oLg=`06ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qom7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3?o
g]kN0_oMgMd00ooNg]kogMgMomgMg@0[omgMg@06obh^;_mWIfOof=SHokRh
^?lR8R;oCTi>1?oMgMd00oo5aLGo0000olk>cP0BomgMg@;og]kN0_oMgMdG
omkNgP03omgMgOoNg]kog]kN03CogMgM0_oLg=`06ooKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qom7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3?og]kN0_oMgMd00ooNg]kogMgMomgMg@1:omgMg@;og]kN
0_oMgMdGomkNgP03omgMgOoNg]kog]kN03CogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q0Oo^k^h0000>onKVi_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/3omcLg3?og]kN0_oMgMd00ooNg]ko
gMgMomgMg@0[omgMg@06obh^;_mWIfOogMgMomgMgOmMGEgo8b<S1OoMgMd0
0om=CDgo>SXjomgMg@0AomgMg@;og]kN0_oMgMdGomkNgP03omgMgOoNg]ko
g]kN03CogMgM0_oLg=`06ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWIol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3?og]kN
0_oMgMd00ooNg]kogMgMomgMg@0[omgMg@07obh^;_mWIfOogMgMomgMgOmM
GEgo8b<Sol?3``03oi6AT@04oh:2P_l0003oR8R8olC4a17ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMWob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT1onKViP0000kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM02_ogMgM00Ko;Rh^ofMWIooMgMgoa/K6o``<3?m]KFd4
omgMg@03om?Cdol@413oLg=c01;ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM02_ogMgM00ko;Rh^ofMWIooMgMgo
a/K6o``<3?m]KFgoX:2Po`410Om3@d?oATI6odA4A?l0003o@D51ojb/[17o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN41onk^kP0000koooooon3Ph?o8b<SoUIFEojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM02_ogMgM00Ko;Rh^ob/[:olf=SKo4a<C
ohB4Q?oKfm/2omgMg@05ohb<S?mADE7o820Poe]KFoo>c/h04_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7alOoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0:ooM
gMd03Ol^;Rko:b/[ocHf=_lC4a?oQ8B4om_KfooMgMgoAdM7ofi^K_oMgMgo
f=SHo`000?o>c/h04_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alOoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00003_o^k^ko
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0:ooMgMd01_l^
;RkoBd];oh20P?lg=cOoJ6QXomWIf@;ogMgM00CoShn?oeADE?la<C7oWIfM
4ooMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7QhOoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0:ooMgMd03Ol^;RkoBd];oh20P?lg=cOoJ6QXomWIfOoMgMgoc/k>
oa`L7?nVYZKof=SHo`000?o>c/h04_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7QhOoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^
00003_oVi^Kob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
:ooMgMd01_l^;RkoIfMWomgMgOo<c<co20P8oibLW0CogMgM00?o_[jno`82
0_nj^[X04_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0:ooMgMd01_l^;RkoIfMWomgMgOo<c<co20P8oibLW0;o
gMgM00GoZJVYoaXJ6_o6a/Ko0000olk>cP0BomgMg@;og]kN0_oMgMdGomkN
gP03omgMgOoNg]kog]kN03CogMgM0_oLg=`06ooKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWIol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3?og]kN0_oMgMd00ooNg]kogMgMomgMg@1:omgMg@;og]kN0_oM
gMdGomkNgP03omgMgOoNg]kog]kN03CogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
0OoVi^H0000>onk^k_oAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/3omcLg3?og]kN0_oMgMd00ooNg]kogMgM
omgMg@0[omgMg@06obh^;_mWIfOogMgMolW9bOl820SoO7al1?oMgMd00ooL
g=co5aLGohR8R00BomgMg@;og]kN0_oMgMdGomkNgP03omgMgOoNg]kog]kN
03CogMgM0_oLg=`06ooKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qom7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3?og]kN0_oM
gMd00ooNg]kogMgMomgMg@0[omgMg@06obh^;_mWIfOogMgMolW9bOl820So
O7al0ooMgMd01?m`L73o>c/ko`000?o>c/hBomgMg@;og]kN0_oMgMdGomkN
gP03omgMgOoNg]kog]kN03CogMgM0_oLg=`06ooKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Qom7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg3?og]kN0_oMgMd00ooNg]kogMgMomgMg@1:omgMg@;og]kN0_oM
gMdGomkNgP03omgMgOoNg]kog]kN03CogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
0Oo^k^h0000>oooooooPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/3omcLg3?og]kN0_oMgMd00ooNg]kogMgM
omgMg@0[omgMg@0=obh^;_lX:2So@T92oa8B4_lF5QKod=3@omgMgOmoOgoo
GemOohV9ROmCDe?o30`<om3@d00BomgMg@;og]kN0_oMgMdGomkNgP03omgM
gOoNg]kog]kN03CogMgM0_oLg=`06ooKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7aon3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g3?og]kN0_oMgMd00ooNg]kogMgMomgMg@0[omgMg@06obh^;_lX:2So@T92
oa8B4_lF5QKod=3@0ooMgMd01?oKfm_o=cLgo`000?o>c/hBomgMg@;og]kN
0_oMgMdGomkNgP03omgMgOoNg]kog]kN03CogMgM0_oLg=`06ooKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3o
lO7aon3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg3?og]kN0_oMgMd00ooNg]kogMgMomgMg@1:omgM
g@;og]kN0_oMgMdGomkNgP03omgMgOoNg]kog]kN03CogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>3olO7a0Oooool0000>onk^k_oAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/3omcLg3?og]kN0_oMgMd0
0ooNg]kogMgMomgMg@0[omgMg@05oiRHV?n5QHGoR8R8okBd]?oKfm/00_oM
gMd01Onh^;SoO7aloeeMGOn6QXKo`/;201?ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM02_ogMgM00GoV9RHohF5
QOn8R8So];Bdom_Kf`05omgMg@03olO7aon5QHGoemOG01;ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP0000koi^KVol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP00
00kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000koooooon3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7oh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oa
lO7oh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO41ooooo`0000kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP00
00koi^KVol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:b_oIfMWob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMWob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP0000kok^k^om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP0000koooooon3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7oh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7oh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`00
00kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000koi^KVol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMWob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT1onKViP0000kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP00
00koooooon3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7o
b<S8on3Ph?oalO7oh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO7oh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`0000kok^k^om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP0000koi^KVol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP00
00kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000koooooon3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7oh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oa
lO7oh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO41ooooo`0000kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP00
00koi^KVol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:b_oIfMWob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMWob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP0000kok^k^om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP0000koooooon3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7oh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7oh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`00
00kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000koi^KVol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMWob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT1onKViP0000kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP00
00koooooon3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7o
b<S8on3Ph?oalO7oh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO7oh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`0000kok^k^om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP0000koi^KVol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP00
00kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000koooooon3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7oh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oa
lO7oh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO41ooooo`0000kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP00
00koi^KVol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:b_oIfMWob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMWob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP0000kok^k^om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP0000koooooon3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7oh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7oh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`00
00kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000koi^KVol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMWob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT1onKViP0000kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP00
00koooooon3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7o
b<S8on3Ph?oalO7oh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO7oh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`0000kok^k^om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP0000koi^KVol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP00
00kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000koooooon3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7oh>3P
olS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oa
lO7oh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO41ooooo`0000kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP00
00koi^KVol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:b_oIfMWob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMWob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP0000kok^k^om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP0000koooooon3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7oh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO7oh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`00
00kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000koi^KVol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMWob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMWob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT1onKViP0000kok^k^om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2
omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN7odM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP00
00koooooon3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[o
gMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00K
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7o
b<S8on3Ph?oalO7oh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00Kom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO7oh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`0000kok^k^om3@d?nh^;So
W9bLojb/[?nk^k_oa/K6olg=cOoCdm?oemOGom_KfooOgmoohN7Qon;RhP;o
hn?S1ooUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H3onGUi@;o
i>CT0_oShn<06_oRh^;oh>3PomcLg?oIfMWoe]KFom3@d?o9bLWo`L71okFe
]OnUYJGo^;Rhom3@d?oPh>3od=3@okRh^?nLW9co[:b/ok^k^oo6a/KocLg=
om?CdooGemOofm_KomoOgooQhN7oh^;R0_oShn<7onGUi@;oi^KV1_oUiND2
onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2
onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2
onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6
onGUi@;oi^KV1_oUiND2onKViP?oiNGU0_oTi>@2on?Sh`0Jon;Rh_oPh>3o
g=cLomWIfOoFe]Kod=3@olW9bOo1`L7o]KFeojFUYOnh^;Sod=3@on3Ph?oA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/3omcLg3?og]kN0_oMgMd00ooNg]kogMgMomgMg@1:omgMg@;og]kN
0_oMgMdGomkNgP03omgMgOoNg]kog]kN03CogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q0Oo^k^h0000>onKVi_o:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/3omcLg0;og]kN0ooMgMd00ooNg]ko
gMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03
omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]ko
gMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03
omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]ko
gMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03
omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h2omgMg@;og=cL01_ofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfOo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`2
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0_oMgMd2omcLg00Kom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oI
fMWob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT1onKViP0000kok^k^omCDe?no_kooS8b<oijNW_n][Jgo^KVi
ol;2`_o7alOoc<c<om3@d?oBd];oeMGEomKFeP;oemOG00?of=SHomWIfOoI
fMT0dOoIfMT2omSHf0;oemOG01[oeMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo
_knookFe]OnYZJWoV9RHokno_ooDe=Coh^;RomCDe?no_kooS8b<oijNW_n]
[Jgo^KViol;2`_o7alOoc<c<om3@d?oBd];oeMGEomKFeP;oemOG00?of=SH
omWIfOoIfMT0dOoIfMT2omSHf0;oemOG01[oeMGEom?Cdoo@d=3oc/k>ol[:
b_o5aLGo_knookFe]OnYZJWoV9RHokno_ooDe=Coh^;Rom7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP00
00koooooonSXj?oDe=CoS8b<oi>CTonRXZ;o[jn_okZj^_o1`L7oalO7ol_;
boo>c/kod=3@om7Ad@;odm?C0ooDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE01goe=CDom?C
dooCdm?odM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jfoj^[ZonMWIgoUIFE
omCDe?oXj>Solo?conSXj?oDe=CoS8b<oi>CTonRXZ;o[jn_okZj^_o1`L7o
alO7ol_;boo>c/kod=3@om7Ad@02om?Cd`?oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGE
e@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oE
eM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@0M
omCDe?oCdm?odm?Com7AdOo@d=3ocLg=ol[:b_o3`l?o_[jnokJf]_n[Zj_o
WIfMoiFEUOoDe=Coj>SXoo?clooPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkN
gP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo00004oo^k^kogMgMolg=
cOn@T93oRHV9oiNGUonUYJGo/[:bokno_oo;bl_odM7AomGEeOoGemOofMWI
om[Jf_oKfm_of][Jom_KfooLg=`01ooKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`0UomcLg?oKfm_ofm_K
om_KfooJf][ofMWIomSHf?oFe]Kodm?Colg=cOo2`/;o][Jfojb/[?nOWioo
T92@oiJFU_o=cLgogMgMonGUiOoMgMgocLg=oi2@T?n9RHWoUiNGojFUYOnb
/[;o_knool_;booAdM7oeMGEomOGeooIfMWof][Jom_KfooJf][ofm_KomcL
g007om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o
g=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oK
fm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_K
f`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o
g=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oK
fm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_K
f`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o
g=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oK
fm_ofm_K00Gofm_K023og=cLom_KfooKfm_ofm_Kom[Jf_oIfMWof=SHomKF
e_oCdm?ocLg=ol;2`_nf][Ko[:b/oinOWon@T93oUYJFolg=cOoMgMgoiNGU
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oN
g]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN41onk^kP0000coi^KVom[Jf_o>c/koW9bLogYjN_n8R8SoUYJFojZZ
Z_o4a<CoeMGEom_KfooNg]h2on3Ph0?oh^;R00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`04onCTi?oShn?ohn?Son?Sh`;oh^;R01WohN7Qon3Ph?oOgmoo
g=cLomOGeoo5aLGo[:b/oijNW_n@T93oPX:2oj2PX?o>c/kof][Jon3Ph?oJ
f][oc/k>oibLW?mjNW[oR8R8oiJFU_nZZZ[oa<C4omGEeOoKfm_og]kN00;o
h>3P0ooRh^800ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00Coi>CTon?ShooS
hn?ohn?S0_oRh^806ooQhN7oh>3PomoOgooLg=coemOGolG5aOn/[:coWYjN
oi2@T?n2PX;oX:2Polk>c_oJf][oh>3Pol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3?og]kN0_oM
gMd00ooNg]kogMgMomgMg@1:omgMg@;og]kN0_oMgMdGomkNgP03omgMgOoN
g]kog]kN03CogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0OoVi^H0000?onk^k_oU
iNGogMgMol;2`_mkNg_oN7QhohJ6Q_nOWiooaLG5omSHf?oMgMgogmoOon7Q
hOoRh^;ohn?S00?oi>CT1?oUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@01?oUiNGoi>CTonGUiOoUiND3onCTi00L
on?ShooQhN7oh>3PomoOgooJf][oa/K6oj6QXOn=SHgoP820ohB4Q?o3`l?o
gMgMonGUiOoZj^[oiNGUomgMgOo2`/;oNg]kogQhN?n6QXKoWinOolG5aOoH
f=SogMgMomoOgooQhN7oh^;Ron?Sh`?oi>CT1?oUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@01?oUiNGoi>CTonGU
iOoUiND3onCTi00Kon?ShooQhN7oh>3PomoOgooJf][oa/K6oj6QXOn=SHgo
P820ohB4Q?o3`l?ogMgMonGUiOoZj^[odM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgM
g@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkN
g_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP0000coooooooWi
nOoclo?ojNWYojRXZ?mUIFGoLg=cohf=SOnk^k_oe=CDom[Jf_oMgMd2omoO
g`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Q
h@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Q
h@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@06on7Q
h@0Ion3Ph?oOgmoogMgMomcLg?oEeMGo^KViohj>S_mkNg_oKVi^oj^[ZooY
jNWolo?cooWinOomoOgonOWioo?clooYjNWoZ:RXofEUIOmcLg?oSHf=ok^k
^ooDe=Cof][JomgMg@02omoOg`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@06on7Qh@0Kon3Ph?oOgmoogMgMomcLg?oEeMGo^KVi
ohj>S_mkNg_oKVi^oj^[ZooYjNWolo?cooWinOomoOgoh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN
00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`00
00gok^k^on_[jooXj>Soh^;RomOGeon=SHgoHV9RogIfM_nTY:CoalO7om;B
d_oEeMGof=SH00;of][J0ooKfm/7omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL023ofm_KomcLg?oLg=co
fm_KomcLg?oKfm_of][JomWIfOoHf=Sodm?ColG5aOnLW9coMGEeofMWIon@
T93oemOGon;Rh_oXj>Sojn_[ong]kOo[jn_oj>SXon;Rh_oGemOoSHf=of9R
H_mfMWKoY:BTolO7aooBd];oeMGEomSHf0;of][J0ooKfm/7omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
027ofm_KomcLg?oLg=cofm_KomcLg?oKfm_of][JomWIfOoHf=Sodm?ColG5
aOnLW9coMGEeofMWIon@T93oemOGon;Rh_oXj>Sojn_[ong]kOoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM
5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7o
k^k^00003ooVi^KoiNGUon;Rh_oOgmoof][JolW9bOn7QhOoFUYJog]kNonS
Xj?o_;blolK6a_o;bl_ocLg=olo?c`02om7Ad@God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03
om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7o
d];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03
om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7o
d];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03
om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7o
d];Bom7Ad@03om;BdP;odM7A00god=3@olo?coo<c<cob<S8ok^k^onLW9co
LW9boe]KFon:RX[obLW9om[Jf_oOgmooh^;R00?oiNGU00goh^;RomoOgooJ
f][obLW9ohN7QomJFU[oNg]koj>SXonl_;coa/K6ol_;boo=cLgoclo?00;o
dM7A1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03
om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7o
d];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03
om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7o
d];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03
om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7o
d];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00?od];B0_oAdM403Oo@d=3o
clo?olc<c?o8b<So^k^koibLW?mbLW;oFe]KohZ:R_o9bLWof][JomoOgooR
h^800_oUiND03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?ne]KGob/[:omWIf@7oi^KV00004Oo^k^kokNg]ong]kOoZj^[oj>SX
on;Rh_oLg=coW9bLofe]KOmXJ6SoPh>3oiNGUonSXj?o[:b/ojn_[ona/K7o
/[:b00;o];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
4one]KGo][JdokBd]?nd];Co][Jfok>c/onb/[;o/k>cojn_[onZZZ[oW9bL
oh:2P_mRHV;oKVi^oinOWooLg=coh^;RonSXj?oZj^X00_o]kNd04Oo^k^ko
kNg]ong]kOoZj^[oj>SXon;Rh_oLg=coW9bLofe]KOmXJ6SoPh>3oiNGUonS
Xj?o[:b/ojn_[ona/K7o/[:b00;o];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd
]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@04one]KGo][JdokBd]?nd];Co][Jfok>c/onb/[;o
/k>cojn_[onZZZ[oW9bLoh:2P_mRHV;oKVi^oinOWooLg=coh^;RonSXj?oZ
j^X00_o]kNd03_o^k^kodM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K0ooLg=`comkNgP;ogMgM00?og]kNomgM
gOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgM
g@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0002ooooo`;oo_kn00ooo?clooWi
nOofm_Kol_;bomWIfOnXZ:SoPh>3ofi^K_mUIFGoJFUYog9bL_mdM7CoNGUi
ogalO?mkNg/00_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00OoO7alog]kNomlO7coOGelogal
O?mkNg_oOGem00;oNWYj00_oMgMgogAdM?m_KfooM7AdohF5QOnXZ:Sof][J
oo;bl_ofm_KonOWiooclo002ooknoP?ooooo0_ono_h03oolo?conOWiooKf
m_obl_;ofMWIojRXZ?n3Ph?oKVi^ofEUIOmYJFWoLW9bogAdM?miNGWoO7al
og]kN`02ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01omlO7coNg]kogalO?mmOGcoO7alog]k
NommOGd00_mjNWX02omgMgOoM7Adofm_KomdM7CoQHF5ojRXZ?oJf][ol_;b
ooKfm_oinOWoo?cl00;oo_kn0_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo0003onk^kP;o
kNg]00Cok>c/on[Zj_oXj>SoiNGU0_oRh^800ooPh>3ogmoOomkNgP3IomgM
g@03omkNg_oOgmooh>3P00;oh^;R00CoiNGUonSXj?oZj^[ok>c/0_o]kNd5
onk^kP;okNg]00Cok>c/on[Zj_oXj>SoiNGU0_oRh^800ooPh>3ogmoOomkN
gP3IomgMg@03omkNg_oOgmooh>3P00;oh^;R00CoiNGUonSXj?oZj^[ok>c/
0_o]kNd3onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3?og]kN0_oMgMd00ooNg]kogMgM
omgMg@1:omgMg@;og]kN0_oMgMdGomkNgP03omgMgOoNg]kog]kN03CogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h000Goi^KV0_oUiND00ooTi>Coh^;R
on;RhP02on3Ph0;ogmoOfOoNg]h2omoOg`;oh>3P0_oRh^800ooTi>CoiNGU
onGUi@09onKViP;oiNGU00?oi>CTon;Rh_oRh^800_oPh>02omoOgmWog]kN
0_oOgml2on3Ph0;oh^;R00?oi>CTonGUiOoUiND01OoVi^H03Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM
5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7o
i^KV003oonk^k^[ok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP00oooooooZooooo`0=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3?og]kN0_oMgMd00ooNg]kogMgMomgMg@1:omgMg@;og]kN
0_oMgMdGomkNgP03omgMgOoNg]kog]kN03CogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3o
lO7a0Oooool00?ook^k^j_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM
00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kN
omkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^003oonKVi^[oi^KV
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT1onKViP00ooo^k^kZonk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3?og]kN
0_oMgMd00ooNg]kogMgMomgMg@1:omgMg@;og]kN0_oMgMdGomkNgP03omgM
gOoNg]kog]kN03CogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h000Oooooo
0_ono_h02_olo?conOWiooKfm_obl_;okNg]onSXj?oShn?oh>3PomgMgOoK
fm/2om[Jf_oofMWI`?oIfMT2om[JfP0:om_KfooMgMgoh>3Pon?ShooXj>So
kNg]oo;bl_ofm_KonOWiooclo0;oo_kn1oooool03OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`c
omkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h0
0ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo0006
onk^kP;okNg]00[oj^[ZonSXj?oRh^;ogMgMomKFe_o=cLgoa/K6okjn__nj
^[[o][Jf1?nc/k?ook:b/[ko/[:b1?nc/k<02_nf][Ko^[Zjokjn__o6a/Ko
cLg=omKFe_oMgMgoh^;RonSXj?oZj^X2ong]k@Kok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^
kP001_oVi^H03_oUiNGoh^;RomoOgooJf][od];BolO7aonm_Kgo/[:bojRX
Z?nPX:3oVi^KoiRHV?nDU9CoTi>CoonBTY;2oi:BTP0=oi>CTonDU9CoV9RH
oi^KVonPX:3oZ:RXok:b/_nm_KgoalO7om;Bd_oJf][ogmoOon;RhP02onGU
i@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM
04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcL
g00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o]KFeol[:b_oIfMT1onKViP001_o^k^h03_o[jn_oj>SXon;Rh_oHf=So
bl_;okjn__n^[ZkoXJ6QoiFEUOn<S8coQHF5oh:2P_moOgooOWinoommOGg2
ogemO@0?oginO_moOgooPX:2ohF5QOn<S8coUIFEoj6QXOn^[Zko_[jnol_;
booHf=Soh^;RonSXj?o[jn_okNg]00Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oo
ool05?oinOWolo?conWYjOoIfMWoalO7okBd]?nRXZ;oVYZJojZZZ_o3`l?o
fMWIonc/k?ofm_KomoOgooWinOohn?SonOWioo[jn_oinOWomoOg0oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00;on?Sh013onOWiooShn?ogmoOok^k^om[J
f_o4a<CoZZZZoiZJV_nRXZ;o];BdolO7aooIfMWojNWYoo?clooinOWooOgm
1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@7ooooo0006onk^kP0<onGUiOoMgMgoc/k>okfm_OnX
Z:SoUIFEojFUYOo<c<cok^k^ooKfm_olo?coo_knooooooo6ooooo`0=ookn
o_olo?comoOgono_koo=cLgoYZJVoiFEUOnXZ:So_Kfmolk>c_oMgMgoiNGU
on[ZjP05onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3?og]kN0_oMgMd00ooNg]kogMgM
omgMg@1:omgMg@;og]kN0_oMgMdGomkNgP03omgMgOoNg]kog]kN03CogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q0Oo^k^h000Koi^KV00[of][Jolk>c_nm_Kgo
Z:RXoiJFU_n[Zj_og]kNon_[joodm?Cono_kooooooo:ooooo`0;oo_knooc
lo?ok>c/on7QhOn^[ZkoUYJFojRXZ?nm_Kgoc/k>om[Jf_oPh>001OoVi^H0
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2
omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:omWIf@7oi^KV0006onk^kP0:omgMgOo=cLgo^;Rhoj6QXOnXZ:Soe=CD
on3Ph?o/k>comOGeoogmoOoooooob_ooool02oono_kom_Kfonc/k?oRh^;o
fMWIojb/[?nQXJ7o^;Rholg=cOoMgMgoiNGU00Gok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^
kP001_ooool02ooXj>Soe=CDokZj^_nYZJWoa/K6omCDe?oPh>3ok>c/oo;b
l_olo?coo_kn0?oooooobOooool02oojn_[om?Cdon[Zj_oShn?oemOGolg=
cOn/[:co^[ZjomCDe?oXj>Solo?c00Gooooo00goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^
k^h03ooDe=Co_knoojJVY_n/[:coa/K6om;Bd_oLg=coi^KVonc/k?oemOGo
n?Shoo[jn_omoOgoooooooclo008ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool0
1Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Cooooo
013ooOgmooooooomoOgono_kooShn?odm?CokNg]onKVi_oOgmooe]KFolc<
c?nb/[;oYjNWokno_ooDe=Coh^;R1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkN
gP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006onKV
iP0Col[:b_ne]KGoWYjNokJf]_o3`l?oclo?omKFe_oOgmooi^KVon[Zj_o_
knoolo?cooCdm?oemOGomoOgooKfm_ogmoOom_KfooShn002ooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_Kf
ooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL05Oofm_Kon?ShooOg
moogmoOom_KfooOgmoofm_Kom?Cdoo;bl_o`l?3ojn_[onKVi_oQhN7of][J
om?Cdoo9bLWo_knooj>SXone]KGob/[:omWIf@05onKViP0=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg3?og]kN0_oMgMd00ooNg]kogMgMomgMg@1:omgMg@;og]kN0_oMgMdG
omkNgP03omgMgOoNg]kog]kN03CogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0OoV
i^H000Kok^k^00_od=3@okRh^?nPX:3o/k>col30`?o9bLWodm?ComWIfOoM
gMgoh^;RonGUi@02on[ZjP03onc/k?o]kNgokNg]00Ook^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^
kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`
l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^
k_o^k^h00oo^k^h2ong]k@;ok>c/00gojNWYonKVi_oShn?oh>3Pom_KfooE
eMGocLg=olG5aOnk^k_oYjNWokRh^?o@d=3oh>3P00Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41
onk^kP001_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oV
i^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_ooool03OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41
ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP001_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41
onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oo
ool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oVi^H03Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1
onKViP001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN41onk^kP001_ooool03OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41
onk^kP001_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oV
i^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_ooool03OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41
ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP001_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41
onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oo
ool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oVi^H03Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1
onKViP001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN41onk^kP001_ooool03OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM02_ogMgM00So;Rh^o`000?l0003o3Ph>oc`l??o3`l?o
gMgMoa4A4@Co000000?oB4Q8omgMgOoMgMd04?oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV
0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
:ooMgMd02Ol^;RkoIfMWomSHf?nh^;So8R8Rodi>C_oMgMgoB4Q8obLW9`03
olO7a`03olo?cooMgMgogMgM013ogMgM0_oNg]h2omgMgAOog]kN00?ogMgM
omkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_ooool0
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`
omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM02_ogMgM00[o
;Rh^ofMWIooMgMgogMgMoeeMGOlS8b?ogMgMolK6a_lF5QKoS8b<5OoMgMd2
omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3Poo7al@7ooooo0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4
omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?o
g]kNomgMgOoMgMd0:ooMgMd01_l^;RkoIfMWomgMgOo6a/Ko30`<ofe]K@;o
gMgM00?o^[ZjoaHF5_nCTi<05?oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0:ooMgMd01_l^
;Rko:b/[ocHf=_lC4a?oQ8B4om_Kf`?ogMgM00?o_;bloaLG5on@T9004ooM
gMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooM
gMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oL
g=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM
00?og]kNomgMgOoMgMd0:ooMgMd01_l^;RkoBd];oh20P?lg=cOoJ6QXomWI
f@CogMgM00?o[Zj^o`L71on[Zj/04_oMgMd2omkNgP;ogMgM5ooNg]h00ooM
gMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006oooo
o`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgM
gC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool0
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0:ooMgMd0
1_l^;RkoIfMWomgMgOo<c<co20P8oibLW0GogMgM00?o=SHfoeiNG_oMgMd0
4OoMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0:ooMgMd02?l^;RkoIfMWomgMgOo9bLWo20P8
ogalO?oMgMgog=cL0ooMgMd00ol[:b_oJVYZomgMg@0AomgMg@;og]kN0_oM
gMdGomkNgP03omgMgOoNg]kog]kN03CogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
0Oo^k^h000Koi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLK?oNg]h3omgMg@Cog]kNX?oM
gMd3omkNgPCogMgM<?oNg]h4omgMg@?og]kNKOoMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
b_oIfMT5onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg3?og]kN0_oMgMd00ooNg]kogMgM
omgMg@0[omgMg@0=obh^;_lX:2So@T92oa8B4_lF5QKod=3@omgMgOm>CTko
AdM7ohF5QOmCDe?o1@D5olC4a00BomgMg@;og]kN0_oMgMdGomkNgP03omgM
gOoNg]kog]kN03CogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI0OoVi^H000Kok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLK?oNg]h3omgMg@Cog]kNX?oMgMd3omkNgPCogMgM
<?oNg]h4omgMg@?og]kNKOoMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN45onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg3?og]kN0_oMgMd00ooNg]kogMgMomgMg@0[omgMg@05
oiRHV?n5QHGoR8R8okBd]?oKfm/00_oMgMd01Oo:b/[oUIFEof=SHon6QXKo
c<c<01?ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN41onk^kP001_ooool03OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41
onk^kP001_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oV
i^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_ooool03OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41
ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP001_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41
onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oo
ool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oVi^H03Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1
onKViP001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN41onk^kP001_ooool03OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41
onk^kP001_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oV
i^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_ooool03OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41
ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP001_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41
onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oo
ool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oVi^H03Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1
onKViP001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN41onk^kP001_ooool03OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41
onk^kP001_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oV
i^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_ooool03OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41
ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7AdOoQhN41onk^kP001_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41
onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgM
g@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgo
gMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/
omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooN
g]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?o
gMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^kP001_oo
ool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]jPomgMg@?og]kN1?oM
gMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@Gooooo
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM
0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM
1?oNg]iUomgMg@0=obh^;_l0003o0000o`h>3_ll?3co`l?3omgMgOoDe=Co
3@d=o`X:2_l0003o30`<oa<C4`0^omgMg@?og]kN1?oMgMd`omkNgPCogMgM
0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^
kP001_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]iUomgMg@06
obh^;_mWIfOof=SHokRh^?lR8R;oCTi>0ooMgMd00onh^;So0000olW9b@0_
omgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oM
gMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=a/omkNgP?ogMgM1?oNg]iUomgMg@06obh^;_mWIfOogMgMomgMgOmMGEgo
8b<S0ooMgMd00onh^;So0000olW9b@0_omgMg@?og]kN1?oMgMd`omkNgPCo
gMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgM
gAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41
onk^kP001_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]iUomgM
g@06obh^;_mWIfOogMgMolK6a_l<30coKFe]0ooMgMd00onh^;So0000olW9
b@0_omgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3Poo7al@Gooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03omkN
g_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0
=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO41ooooo`001_o^k^h03OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=a/omkNgP?ogMgM1?oNg]iUomgMg@06obh^;_l[:b_o=SHfoa<C4on4
Q8Cofm_K0ooMgMd00onh^;So0000olW9b@0_omgMg@?og]kN1?oMgMd`omkN
gPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2
omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN41onk^kP001_oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oNg]iU
omgMg@06obh^;_m;Bd_oP820ocLg=omXJ6SofMWI0ooMgMd00onh^;So0000
olW9b@0_omgMg@?og]kN1?oMgMd`omkNgPCogMgM0ooNg]i]omgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@Goi^KV00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL<ooNg]h2omgMg@03
omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOog]kN00?ogMgMomkNg_oN
g]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKViP001_o^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=a/omkNgP?ogMgM1?oNg]iUomgMg@06obh^;_mWIfOogMgMolc<
c?l820SoW9bL0ooMgMd00onh^;So0000olW9b@0_omgMg@?og]kN1?oMgMd`
omkNgPCogMgM0ooNg]i]omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oN
g]h2omgMgAOog]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
dOoQhN41onk^kP001_ooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=a/omkNgP?ogMgM1?oN
g]iUomgMg@0<obh^;_mWIfOogMgMolW9bOl820SoO7alomgMgOoLg=cof=SH
okRh^?l0003obLW9;ooMgMd3omkNgPCogMgM<?oNg]h4omgMg@?og]kNKOoM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nQXJ7ob<S8on3Ph?oalO45ooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg3?og]kN
0_oMgMd00ooNg]kogMgMomgMg@1:omgMg@;og]kN0_oMgMdGomkNgP03omgM
gOoNg]kog]kN03CogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a0Oooool000Kok^k^
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLK?oNg]h3omgMg@Cog]kNIOoMgMd03?l^;Rko:2PX
od92@_lB4Q;o5QHFom3@d?oMgMgoeMGEoa4A4Ol];Bgo0000olW9bBoogMgM
0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7o
hN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoM
gMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6co
g]kN0ooMgMd4omkNgVGogMgM00GoV9RHohF5QOn8R8So];Bdom_Kf`03omgM
g@04omOGeonYZJWoLW9bom3@d2oogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV
0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^
0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo
0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^
0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@7ooooo0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV
0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^
0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo
0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^
0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@7ooooo0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV
0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^
0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo
0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^
0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@7ooooo0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV
0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^
0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo
0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^
0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@7ooooo0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV
0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^
0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a
1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo
0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
on7Qh@7ok^k^0006ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>3olO7a1Oooool03OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7ooooo0006onk^kP0=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^
0006onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI
1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:omWIf@7oi^KV0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN
0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM
0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;o
gMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgo
g]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3o
g]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool03OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkN
gP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
oo7al@7ooooo0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkN
gZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kN
omgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0d
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@7ok^k^0006onKViP0=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooNg]h4omgMgC3og]kN1?oMgMd3
omkNgVgogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/[ofMWI1OoVi^H03Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM5ooN
g]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@7oi^KV
0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg6cog]kN0ooMgMd4omkNgZ3ogMgM0ooN
g]h4omgMgC3og]kN1?oMgMd3omkNgVgogMgM0_oLg=`03_oKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q
1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0
B_oMgMd2omkNgP;ogMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL
00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7Aon7Qh@7ok^k^0006ooooo`0=omoOgoo5aLGoWYjNojb/[?nk
^k_oa/K6olg=cOoCdm?oemOGom_KfooOgmoohN7Qon;RhP02on?Sh`OoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H5onGUi@;oi>CT0_oShn<03OoRh^;oh>3PomcLg?oIfMWoe]KFom3@
d?o9bLWo`L71okFe]OnWYjOoaLG5omoOgoo`l?001Oooool03OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;ogMgM
5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7al@7o
oooo0006onk^kP0=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg0;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgPCogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=`comkNgP;ogMgM00?og]kNomgMgOoMgMd0B_oMgMd2omkNgP;o
gMgM5ooNg]h00ooMgMgog]kNomkNgP0domgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Q
h@7ok^k^0006onKViP0=olg=cOni^KWoS8b<oijNW_n][Jgo^KViol;2`_o7
alOoc<c<om3@d?oBd];oeMGEomKFeP02omOGe`03omSHf?oIfMWofMWI0?oo
fMWI_?oIfMT2omSHf0;oemOG00goeMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo
_knookFe]OnYZJWoV9RHokVi^Oo=cLgofm_K00Goi^KV00gob/[:okFe]OnD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKV
iP001_o^k^h03OoHf=Soa/K6ohV9ROnCTi?oXZ:Rojn_[onj^[[o`L71olO7
aoo;bl_oc/k>om3@d?oAdM400_oCdm<3omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGE
eOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]Ko
eMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oF
e]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oD
e=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGE
e@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oE
eM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@03
omKFe_oEeMGoe=CD00;odm?C00godM7Aom3@d?o=cLgob/[:ol?3`onn_[ko
][Jfoj^[ZonMWIgoTY:BolK6a_oHf=Soh^;R00Gok^k^00godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cL<ooNg]h2omgMg@03omkNg_oMgMgogMgM04[ogMgM0_oNg]h2omgMgAOo
g]kN00?ogMgMomkNg_oNg]h0=?oMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQhN41onk^
kP001_ooool04_o]kNgog=cLoiFEUOn9RHWoUiNGojFUYOnb/[;o_knool_;
booAdM7oeMGEomOGeooIfMWof][Jom_KfooJf][ofm_KomcLg0Oofm_K00?o
g=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oK
fm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_K
f`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o
g=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oK
fm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_K
f`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o
g=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oK
fm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_K
f`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o
g=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oK
fm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_K
f`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o
g=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oK
fm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_K
f`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o
g=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oK
fm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_K
f`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o
g=cLom_KfooKfm/00ooKfm/03ooJf][ofMWIomSHf?oFe]Kodm?Colg=cOo2
`/;o][Jfojb/[?nOWiooT92@oi^KVooLg=cokNg]ooKfmP05ooooo`0=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg3?og]kN0_oMgMd00ooNg]kogMgMomgMg@1:omgMg@;og]kN
0_oMgMdGomkNgP03omgMgOoNg]kog]kN03CogMgM0_oLg=`03_oKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3o
lO7a0Oooool000Kok^k^00_oh^;RomKFe_nPX:3oNWYjohR8R?nFUYKoZZZZ
olC4a?oEeMGofm_KomkNgP02on3Ph0?oh^;R00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oS
hn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`03on?Sh`;oh^;R00kohN7Qon3Ph?oOgmoog=cL
omOGeoo5aLGo[:b/oijNW_n@T93oPX:2ojBTY?oFe]Koh^;RonSXj0Gok^k^
00god=3@okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoO
gooQhN7oh^;R00;ohn?S1ooUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H3onGUi@;oi>CT0_oShn<03OoRh^;oh>3PomcLg?oIfMWoe]KFom3@
d?o9bLWo`L71okFe]OnUYJGo^;Rhom3@d?oPh>000Oo^k^h000Koi^KV00ko
gMgMomKFe_nl_;coNWYjogQhN?n6QXKoWinOolG5aOoHf=SogMgMomoOgooQ
hN7oh^;Ron?Sh`?oi>CT1?oUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0ooTi>@03_oShn?ohN7Qon3Ph?oOgmoof][JolK6a_nQXJ7oSHf=oh20P?n3
Ph?o_KfmomKFe_oMgMgoh^;R1OoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`2omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]ko
gMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03
omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]ko
gMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03
omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?o
gMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]ko
gMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03
omkNg_oMgMgogMgM00;og]kN0_oMgMd2omcLg00>om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT1onKV
iP001_o^k^h02ooXj>Soh^;RomWIfOnOWiooIFEUog=cLon=SHgo^k^komCD
e?oJf][ogMgM00;ogmoO00?oh>3Pon7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q
00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;R
h_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q
00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;R
h_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q
00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;R
h_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q
00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;R
h_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q
00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;R
h_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q
00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;R
h_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@08on7Qh@0>on3Ph?oOgmoogMgMomcLg?oEeMGo^KViohj>S_mkNg_o
KVi^oj:RX_oIfMWoh^;RonSXj?o/k>`5onk^kP0=omCDe?no_kooS8b<oijN
W_n][Jgo^KViol;2`_o7alOoc<c<om3@d?oBd];oeMGEomKFeP02omOGe`03
omSHf?oIfMWofMWI0=7ofMWI0_oHf=P2omOGe`0=omGEeOoCdm?od=3@olk>
c_o:b/[oaLG5okno_one]KGoZJVYoiRHV?no_kooe=CDon;RhP01onk^kP00
1_ooool03?olo?conOWioo;bl_oWinOoU9BDof9RH_mfMWKoY:BTolO7aooB
d];oeMGEomSHf0;of][J0ooKfm/7omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00;og=cL
017ofm_KomcLg?oKfm_of][JomWIfOoHf=Sodm?ColG5aOnLW9coMGEeofMW
IonGUiOoinOWoo;bl_oinOWoo?clooknoP05ooooo`0=onSXj?oDe=CoS8b<
oi>CTonRXZ;o[jn_okZj^_o1`L7oalO7ol_;boo>c/kod=3@om7Ad@02om?C
d`?oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGE
eOoFe]KoeMGD0_oDe=@2omGEe@0@omCDe?oCdm?odm?Com7AdOo@d=3ocLg=
ol[:b_o3`l?o_[jnokJf]_n[Zj_oWIfMoiFEUOoDe=Coj>SXoo?cl`7ooooo
0006onk^kP0>ong]kOoZj^[oinOWon;Rh_o?clooRXZ:oeYJF_mkNg_oXj>S
okbl_?o6a/Kobl_;olg=cOo?cll2om7Ad@God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]82om7Ad@0=om3@d?o?clooc<c<olS8b?nk^k_oW9bLog9bL_mKFe_o
SHf=olo?cooRh^;oinOWon[ZjP02ong]k@Gok^k^01;ogMgMolg=cOn@T93o
RHV9oiNGUonUYJGo/[:bokno_oo;bl_odM7AomGEeOoGemOofMWIom[Jf_oK
fm_of][Jom_KfooLg=`7om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cL
om_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K01?og=cLom_KfooKfm_ofm_Kom[J
f_oIfMWof=SHomKFe_oCdm?ocLg=ol;2`_nf][Ko[:b/oinOWon@T93oUYJF
olg=cOoMgMgoiNGU007ok^k^0006onKViP;oiNGU00koh^;Ron3Ph?oKfm_o
eMGEoiRHV?m/K6coJ6QXoh>3PonGUiOoXj>Sojb/[?n_[joo/K6aok:b/P;o
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd
]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf00oo];Bdok>c/onb/[;o/k>cojn_[onZZZ[o
W9bLoh:2P_mRHV;oKFe]oi^KVooEeMGofm_Kon3Ph?oRh^800_oUiND6onKV
iP0;om[Jf_o>c/koW9bLogYjN_n8R8SoUYJFojZZZ_o4a<CoeMGEom_KfooN
g]h00_oPh>03on;RhP03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<01?oTi>Co
hn?Son?ShooShn<2on;RhP0>on7QhOoPh>3ogmoOomcLg?oGemOoaLG5ojb/
[?nNWYkoT92@oh:2P_nPX:3oc/k>om[Jf_oPh>01onKViP001oo^k^h2ong]
k@0?on_[jooXj>SoiNGUon;Rh_o;bl_oWYjNogemOOm[Jf_oI6ATofUYJOmb
LW;oM7AdogUiNOmlO7coNg]k00;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@0>ogalO?mjNW[oNWYjogMgMomdM7CoKVi^
og5aLOmoOgooWYjNolc<c?oRh^;oiNGUonSXj?o[jn/2ong]k@Ook^k^00ko
iNGUomgMgOo2`/;oNg]kogQhN?n6QXKoWinOolG5aOoHf=SogMgMomoOgooQ
hN7oh^;Ron?Sh`?oi>CT1?oUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@01?oUiNGoi>CTonGUiOoUiND3onCTi00>
on?ShooQhN7oh>3PomoOgooJf][oa/K6oj6QXOn=SHgoP820ohB4Q?o3`l?o
gMgMonGUiOoZj^X1onk^kP002?ooool2ooknoP09oogmoOokno_onOWiooKf
m_oclo?ol_;boo3`l?o_knook^k^0?ookNg]a?o]kNd02Oo^k^kokno_oo3`
l?obl_;olo?cooKfm_oinOWono_koogmo@02ooknoPSooooo00_onOWioo?c
looYjNWoZ:RXofEUIOmcLg?oSHf=ok^k^ooDe=Cof][JomgMg@02omoOg`03
on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;o
hN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQ
hN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00Go
hN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03
on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;o
hN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQ
hN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00Go
hN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03
on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;o
hN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQ
hN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00Go
hN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@06on7Qh@0>
on3Ph?oOgmoogMgMomcLg?oEeMGo^KViohj>S_mkNg_oKVi^oj^[ZooYjNWo
lo?cooWinOomoOd1ooooo`002_o^k^h2ong]k@03onc/k?oZj^[oj^[Z00;o
j>SX0_oWinOoonKVi/Coi^KV0_oWinL2onSXj0;oj^[Z00?ok>c/ong]kOo]
kNd02_o^k^h03?o[jn_oj>SXon;Rh_oGemOoSHf=of9RH_mfMWKoY:BTolO7
aooBd];oeMGEomSHf0;of][J0ooKfm/7omcLg003om_KfooLg=cog=cL00Go
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oL
g=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Go
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oL
g=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Go
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL01Cofm_KomcLg?oL
g=cofm_KomcLg?oKfm_of][JomWIfOoHf=Sodm?ColG5aOnLW9coMGEeofMW
Ion@T93oemOGon;Rh_oXj>Sojn_[ong]k@7ok^k^003oonKVi^[oi^KV00ko
iNGUon;Rh_oOgmoof][JolW9bOn7QhOoFUYJog]kNonSXj?o_;blolK6a_o;
bl_ocLg=olo?c`;odM7A1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00?od];B
0_oAdM403Oo@d=3oclo?olc<c?o8b<So^k^koibLW?mbLW;oFe]KohZ:R_o9
bLWof][JomoOgooRh^800_oUiND1onKViP00ooo^k^kZonk^kP;okNg]00ko
j^[ZonSXj?oRh^;og=cLoibLW?m]KFgoJ6QXoh>3PonGUiOoXj>Sojb/[?n_
[joo/K6aok:b/P;o];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@04one]KGo][JdokBd]?nd];Co][Jfok>c/onb/[;o/k>cojn_[onZ
ZZ[oW9bLoh:2P_mRHV;oKVi^oinOWooLg=coh^;RonSXj?oZj^X00_o]kNd2
onk^kP00ooooooo[ooooo`;oo_kn00ooo?clooWinOofm_Kol_;bomWIfOnX
Z:SoPh>3ofi^K_mUIFGoJFUYog9bL_mdM7CoNGUiogalO?mkNg/00_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00OoO7alog]kNomlO7coOGelogalO?mkNg_oOGem00;oNWYj
00_oMgMgogAdM?m_KfooM7AdohF5QOnXZ:Sof][Joo;bl_ofm_KonOWioocl
o002ooknoP?ooooo003oonk^k^cok^k^0_o]kNd01?o/k>coj^[ZonSXj?oU
iND2on;RhP03on3Ph?oOgmoog]kN0=WogMgM00?og]kNomoOgooPh>000_oR
h^801?oUiNGoj>SXon[Zj_o/k>`2ong]k@Cok^k^003oonKVi^koi^KV0_oU
iND00ooTi>Coh^;Ron;RhP02on3Ph0;ogmoOfOoNg]h2omoOg`;oh>3P0_oR
h^800ooTi>CoiNGUonGUi@06onKViP00oomoOgn6ogmoO`OoOWinoomoOgmC
ogmoO`0000Cojn_[onKVi_oRh^;og]kN0ooMgMd0oooLg=cog]kNomkNg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMg@00AooNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkogMgM00;og=cL03gofm_K
omgMgOoLg=cog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomcLgOoNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oMgMgofm_Kom[Jf_oGemOo
f=SHomOGeooJf][ofm_L00;ogMgM0?oog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]h004GogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMd00ooNg]h00ooMgMgog]kNomkNgP03omgMg@7o
hN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>000ooIfMT02?oHf=SofMWI
omWIfOoIfMWof=SHomKFe_oCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooH
f=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOo
f=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOG
omSHf?oofMWI2ooIfMT2omSHf006omKFe_oCdm?odm?ComCDe?oGemOof=SH
0_oIfMT00ooHf=SofMWIomWIf@02omSHf0WofMWI00?of=SHomWIfOoIfMT0
0_oHf=P00ooIfMWof=SHomOGe`02omSHf1OofMWI00Cof=SHomKFe_oBd];o
clo?0_o=cLd01?o?cloodm?ComOGeooHf=SoomWIfDGofMWI00?of=SHomWI
fOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWoi>CTon3P
h?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=codm?ColO7aonk^k_o/[:b
ojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_o
dm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09
on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7
aooCdm?ofm_KomoOg`3oon7Qh@[ohN7Q00Woh>3PomoOgooKfm_oe]KFomCD
e?oFe]Kof][JomkNg_oPh>001_oOgml3on3Ph003omoOgooPh>3oh>3P00;o
h>3P2?oOgml2omkNgP;ogmoO0ooPh>02omoOg`;oh>3P0_oOgml=on3Ph005
omoOgooMgMgofMWIomGEeOoCdm<00_oBd]800ooFe]Kog=cLon3Ph03oon7Q
hDOohN7Q00?oh^;Ron7QhOoRh^801?oQhN41onCTi07ojNWY0Oo]kNd00003
oo3`l?o_knoolO7a00;ol?3`0_o_knl0ooo`l?3ok^k^onSXj?oKfm_o`L71
ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgo
lO7aono_kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2`_nT
Y:CoS8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;oY:BT
ohb<S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]kOoalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7al@00C_o_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_koo`l>kokNg]onc/k?oUiNGoh^;RomoOgooU
iNGojNWYong]j`;oj>SX00Koi^KVonWYjOoWinOojn_[onc/k?o^k^`3on[Z
jP09ono_koo^k^kok^k^onSXj?oXj>Koi^KVonWYjOoWinOoj^[Z00;ojNWY
00goiNGUonOWiOoWinOojn_[onc/k?o_knoojn_[on[Zj_oYjNWok^k/onc/
k?o[jn_oj>SX00;okNg]01Cok^k^on[Zj_o/k>[ok>c/onk^k_oZj^[ok>c/
ong]kOo^k^koj^[Zonc/j_o/k>cok^k^ojf][OmgMgOoFEUIofm_Konf][Ko
hN7PonOWi`;okno_0?oolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo^k^kolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO40
04cokno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo`l?3okno_oo3`l?o_knool?3`ono_koo`l?3okno_1?o`l?000003
oo;bl_o^k^koinOW00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mUIFGo
DE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@0
0ooUiNGoi>CTonGUi002onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5A
odE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT0?oo
iNGUonCTi?oUiNGoi>CTonCThooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5
ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7AomkNg_oTi>?oi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiND002Ooi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCohn?SolK6a_lX:2SoADE5ohn?SooBd];ofm_K
omcLfooFe]H00ooEeMD03?oDe=Cof][JomoOgooOgmkofMWIomGEeOoHf=So
gmoOon7QhOoMgMgoe]KFomGEe0;oeMGE00_oe=CDomWIfOoJf][of=SHomGE
eOoFe]Goe]KFomWIfOoMgMgoh>3Pom_Kf`02omKFeP09omgMg?oLg=cof=SH
omGEeOoLg=coh>3PomoOgooJf][ofm_J00;ogMgM0?oofMWIomcLg?oOgmoo
h>3Pom_KfooJf]WogMgMon3Ph?mcLg?oJ6QXohf=SOmDE5Co20P8oj>SX_oK
fm_ohn?SonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoShn?oiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
on?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>@005KoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi0CoiNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o/k>`1oo;blP0000?o
m?Cdong]kOoWinL00ooPh>004_oOgmoog]kNom;Bd_nd];CoQhN7oe]KFom]
>cGoWTi2ole_GooYPfoocFmOoii>@om]>cKoG5aLohN7Qond];Cod];BomkN
gPGoh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m]H2coWYH^olg=?ooYjDgo
cLdooijJ;om]HbgoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomkNg_oB
d];o];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=AomZWSCoBFX_oeaL
G?n7QhOo];Bdom;Bd_oNg]h0oooPh>09on3Ph006omoOgoo?clooVIVIoi:B
T_lI6AWoS8b<0_oEeMD07oo?cloo`/;2olk>c_o>c/koaLG5ol[:b_oJf][o
f=SHom3@d?o;bl_oclo?omSHf?oJf][oeMGEolo?coo1`L7od=3@olk>c_o4
a<Cobl_;omSHf?oGemOo_[jnok^k^ooAdM7od=3@omGEeOoHf=Sodm?Colc<
c?o>c/h00_oEeMD01Oo>c/koc<c<om?CdooJf][of=SH00;od];B00Cof=SH
omOGeooAdM7odm?C0_oIfMT01_oCdm?odM7AomOGeooHf=SodM7Aom3@d0;o
dM7A00CoATI6od51@OoGemOog]kN@OoPh>000ooOgmooh>3Pon3Ph03oon3P
h07oh>3P00?ogmoOon3Ph?oOgml00_oOgml3on3Ph003on7QhOoWinOok>c/
007om?Cd00000oofm_Kol_;bon_[j`03onSXj00ConOWiooRh^;ocLg=oinO
Wom[GeooScH^oneaHOoiWI3ooK6Uoofl[oom]:OonInConedHonB=booJemO
oinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWom^IUoo
Tg8RongAA?oilgCooOf=oogmUOomoHkonOQfongGAonCLb;oKVMOoinOWoo=
cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWomPJ5ooBg`Soi;Q
BonmnG_od?fBomSmVooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=cLgoh^;R
onOWi`3oonSXj0[oj>SX00Coi^KVon7QhOmMGEgoCDe=0_oMgMd07om@D53o
1`L7oaDE5On4Q8Co5QHFod=3@ooRh^;ogMgMoibLW?l0003oShn?omgMgOoQ
hN7ofm_Kod10@?l820So6ATIohR8R?l;2`_oF5QHokNg]ol<30co1`L7ob<S
8olW9bOoOGemom[Jf_oMgMgoe=CDo`/;2omIFET00_oIfMT00omMGEgo2`/;
om?Cd`02omoOg`06oeYJF_m>CTkog]kNomkNg_lS8b?oQ8B40_oQhN403?mj
NW[o;Rh^omgMgOoMgMgo`/;2oe1@D?lc<c?oKVi^oh>3PolQ8B7og]kNonKV
i_ooj>SXC_oXj>P1onc/k07ol_;b0Oofm_H0000IooOgmoohn?Son?ShooSh
n?ogmoOon?ShooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFooZBQoonYY_oo[6U
oonhZoon/jKooZRLoo^DROo^J5WoRC4[oi2@T?o>c/kok^k^ooOgm`03ooSh
n00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_PK_onm8;oo_j:ooooT_on
oXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOg
moo^k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSoc_j@omKoUoo@oY;oa_j9
ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^ooOgm`3oooShn0[on?Sh02Gom_Kf
oo7alOn1PH7o7alOong]kOo6a/Ko0000ol?3`ooCdm?oG5aLo`P82?oZj^[o
l?3`on[Zj_mBDU;o51@Docdm?OoYjNWol?3`ojn_[ol71`Ood];Bolg=cOm>
CTko6a/Konk^k_oKfm_o[Zj^onSXj?o/k>co[Zj^o`000?nd];Cok>c/ok2`
/?l;2`_o6QXJ00;oi>CT00_o8b<So`h>3_nTY:CokNg]onk^k_mPH63oE5AD
onk^k_o]kNgo9RHVohf=S@02oo3`l00<oh:2P_la<C7ok>c/on[Zj_m3@d?o
;bl_oibLW?mcLg?o:RXZoaXJ6_o^k^kom_Kf>_ohn?P00oogmoOon?ShooSh
n005ooShn003ooOgmoohn?Son?Sh03;on?Sh00?omoOgooShn?ohn?P0c?oh
n?P00oogmoOon?ShooShn002ooShn004ooOgmooinOWomoOgooKfmP7on?Sh
00000oojn_[omOGeonk^kP02onc/k03oon_[jooYjNWogmoOokVi^OmiDU;o
_c8TonMdJOomRGkooiR<oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c9?mi
DU;o^[ZjomoOgooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EBon:A
7?oi`e3ooMYSoooZL_onlgkoooZ2ookfOoook7?oo]iToo[7DOoRTQcoRFIC
okZj^_oOgmooj^[Zon_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]D_mAXaco
TM9EojKWJ_nhnG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]D_nj
^[[ogmoOon[Zj_o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/001donc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_oj^[ZonCT
i?mjNW[o71`Lon;Rh_o;blco0`<3oinOWooOgmooU9BDoa<C4ooPh>3ohN7Q
om3@d?l61PKoXJ6Qo`T92Onn_[koh^;RokVi^Ol20P;o/K6bomkNg_n0P83o
:BTYon;Rh_oXj>Soi>CTomoOgooJf]_oe=CDo`P82?n6QXKogmoOofYZJ_m9
BDWo=CDeojb/[Onn_[ko1`L7ogQhN?mEEED2omoOg`06oe]KFom?Ce3oh^;R
on3Ph?lT92CoQ8B40_oPh>00oomkNg_o;bl_on7QhOoDe=Co1@D5ojNWYooT
i>Coh^;RogmoOolE5AKoh^;RonWYjOo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k000D?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/1oo[jn/01Oo/k>cojn_[on_[joo^k^kom_Kf007onOWi
00000ookno_olo?cong]k@02onGUi@3oonKVi_oShn?ofMWIok:b/_mi;Rko
b48don=ZG?ocNFcooHQloojGR_onVhkooYR;ooj:O_odNfgoif]MolY2=?mk
;Rko/[:bomSHf?oTi>CoiNGUonKVi_oUiNKoi>CTomSHf?nb/[;oUUD^onZL
:ook_4Coo/aCoogHH_onhg;oo^UeookVLoonffGooLaCoo_1AOo^WR_oVEH^
ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGUonCTi?oHf=Wo/[:bobiR;_mS[B_o
QlY8oiOLFOnUiFWo/_=gokSfNondmGWoYnY[oiSLFOn9cd_oHjh[obiS;_nb
/[;of=SIonCTi?oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGV001EonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi>CTomkN
g_mgMgOo6a/KomcLg?oPh>7oWYjNobh^;_l[:b_o<S8boa8B4P02om_Kf`0U
ohB4Q?lQ8B7ogmoOoe=CDomWIfOofm_KomgMgOn@T93o:BTZobl_;ol/;2co
:2PXomgMgOoOgmoof=SHom?Cdoo?cm3oFe]Ko`000?nn_[kofMWIobPX:?n6
QXKoN7QhofQXJ?n2PX;o?3`lol?3`ol?3`ooeMGEomWIfOmIFEWoCTi>omgM
gOoLg=co8b<Soh61P@02omKFeP27ogMgMol^;RkogMgMoj:RX_l0003oa/K6
omWIfOoHf=SoSXj>oaDE5OoMgMgohn?SonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KV00;oiNGU0<OoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGU00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooU
iNGokNg]oo?cl`01oo_kn`0000?oo?clooShn?oalO400oo^k^h04oo[jn_o
hN7Qokbl_?mj5aOo`clbom9EB?oTJ5[okgM/ooB3NOohQgcomHAjoo=iKOoU
JE_ofEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl
_?nUAaOoiYLbooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlb
onVK<_nUAQOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOo
GjPbogJm=on6cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lG
FAOo_;blon7QhOo/k>`0ooo^k^h:onk^kP0^onc/k?oWinOoNg]koa`L7?oT
i>CojNWYonKVi_oQhN7og]kNohf=SOlD51Coi^KVonCTi?le=CGoNGUion_[
jonb/[;o5ADEomoOgooVi^Koi>CTon7QhOoMgMgoNWYjobTY:OoXj>SoiNGU
omgMgOna/K7o9RHVo`/;2onKVi_ojNWYolc<c?l0003oc/k>ol?3`olU9BGo
Bd];ogalO?oXj>So<C4aojFUYOoTi>CoGEeMoe5AD@;oinOW00[o9BDUofUY
JOoOgmoogmoOogMgMola<C7ojNWYol71`Ol0003oYjNW0_oOgml01?nCTi?o
5QHFonOWioo/k>`lonk^kP03ong]kOo^k^kok^k^00;ok^k^00?okNg]onk^
k_o^k^h0ooo^k^h9onk^kP03ong]kOobl_;on?Sh007oo?cl0003oogmo@0F
ooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@@ooJHUGo
hfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];olo?cooclo0?o
oOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWomJPYooRd?ooi_D[on;m=
ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?oo?cl00?ooOgm01?o
o?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:cE3oSLeBoh[>D?n1
adCoLKT_of:^8?m>VcCo1d87om;Bd_oclo?oo?cl0?oooOgm2_omoOd08ook
no_omoOgohB4Q?lN7Qkolo?cooWinOnc/k?od=3@oo?clomXJ6SoAdM7ooWi
nOoDe=Co0000omgMgOolo?cono_kobLW9onXZ:SonOWioj^[ZooEeMGolO7a
oeADE?mNGUkonOWiooCdm?nDU9Co1@D5od10@?oAdM7omoOgooShn?nGUiOo
:b/[00;on_[j01_o92@To`L71oo8b<Sono_kohF5QOmSHf?omoOgof=SHomG
EeOon?ShooWinOlW9bOo5ADEoh>3PooGemOo@T92of=SHookno_on_[joc@d
=?m9BDWofm_KonGUiOm?Cdoo5aLGoo[jn_olo?`0ooomoOe;oogmo@03oocl
o?omoOgoo?cl00?ooOgm0000>_omoOgon_[joo?cloo^k^kol?3`ono_koo^
k^kojNWYom?CdomJ71coXS@dok@X7Oo1>BcoadTlolmFB_o@Ed_od5M:olY:
?_o3>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>ook^k^
on[Zj_oCdm?oS2DMolQa=?oIQ1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/X2Go
iiLEomb87Oo8LCCoS2DMom?CdooZj^[ok^k^oo3`l?o_knool?3`onk^k_oZ
j^Wodm?Coadh7OldPSCoAiDMoeZU6omY[BX2ogBh>03oogFi>?m[/B_oFjLL
odRJ7OldPSCo7CPMom?CdooZj^Wok^k^oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_000joo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o^k^kojn_[ogemOOlL71coinOWonk^kOn8R8So<30`o`h>3_la
<C7o/;2`ono_kon4Q8CoCDe=onk^k_o_knook^k^ohZ:R_mIFEWokno_ogQh
N?l/;2_o3Ph>ocPh>?nn_[kok^k^on?Shol>3PkoJFUYon3PgooRh^;oi^KV
on[Zj_mQHF7oMWIfono_koo^k^koMgMfobHV9P;ok^k^01KocLg=ob`/;?o[
jn_oK6a/of=SH_o[jn_ok^k^ocXj>_nDU9CoHV9Ro`h>3_ld=3Coa<C4onk^
k_o_knoodM7Aoc`l??l:2P[o9bLWofa/K?l/;2cok^k^0_o_knl0ooo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o^
k^kol?3`ono_koo`l>ookno_oo3`l?o_knool?3`onk^k_o`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l000AOo_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`02oo3`l0Kokno_
0Ooclo<1ooShn07oo_kn00000oono_komoOgoo3`l002onWYj@0ConSXj?oY
jNWoi^KVom_KfomSBd_oPC8bojHd=?nf=2go`Te1ol=DBOo4ED[o`eA9ol9=
@Onf=2goYCDeoh4b<_mSBd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oRD];
ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;o
RD];om_KfooWinL01OoYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[
ZbooL:dhofn^>_m`[CSoJZX_oe>K;OliR3Go<V0bod];BooKfm_oinOW0?oo
jNWY2ooYjNT01_oXj>Soi^KVog]kNolL71coi>CTonSXj0;ojNWY00?oinOW
onWYjOoYjNT02ooYjNT03?oWinOojNWYonWYjOoXj>Sof=SHo`X:2_n^[Zko
g=cLomkNg_oPh>3oiNGUonSXj0SojNWY00Koj>SXonKVi_oShn?ohn?SonKV
i_oXj>P3onWYj@03onSXj?oYjNWojNWY00CojNWY00?oinOWonWYjOoYjNT0
N_oYjNT00ooXj>SojNWYonWYj@03onWYj@03onSXj?oYjNWojNWY0<KojNWY
00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07omoOg0Oono_h00004ookno_oj
n_[om?Cdono_k`?ol?3`017okno_on_[jonEU9CoCb<SoiEDE?nkLg?odiFE
omZLW?oJWYcofIbLomBEUOnkLg?oUEADodlS8onEU9Coj^[Zono_k`05oo3`
l00Aono_kooZj^[oZIBDoh4S8onjJUCoe9YconBlUOoZaicojLNLon[7W?oU
_9Goe9Ycok]ZE?n18b?oZYBDon[Zj_o_knl01Oo`l?004Oo_knooj^[ZoiBD
U?lS:R?oE7YDog>ULonNaYGo[<jLojg>W?n/cYcoW/JEog>ULomDNUCo8bXS
oiBDU?oZj^[okno_0?ool?3`2oo`l?02ono_k`04oh20P?lM7Agok^k^ono_
k`Gol?3`00?okno_oo3`l?o`l?002oo`l?02ono_k`07ofATI?lY:BWoPH61
of=SHolk>c_ok^k^ono_k`08oo3`l006ono_koo^k^koLg=cofUYJOo^k^ko
kno_Boo`l?02ono_koool?3`3oo`l?001?oalO7ol?3`ooCdm?ojn_X1ookn
oP0000CokNobooooooooooooo_kn0_ooool2ooknoP3ooogmoOogmoOoKVi^
oeXo?onaT93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSloofe]KOohn?So
o?clooooooono_koooooookno_ooookoo_knooooooolo?con?Shohe]KOn:
?coobI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo?on=KFgon?Sgoocl
o?ooooooo_knooooooono_koooooookno_ooookoo?clooShn?m]KFgo?clo
oi2MT?o9eLWoi>cTonK^i_oTk>CobMG9oi2MT?lo?cooKFe]ooShn?olo?co
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_kn0017ooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooool00_ono_h06?o?
clooYZJVoogmoOooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooo`;oo_kn00ko`<30og5aLOn0P83o/;2`oogmoOooooooo_knooooooon
o_koooonookno_ooooooo_knooooo`;oo_kn0?oo`L71okfm_?omoOgooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_h005coooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooooooknoP;ooooo00?oo_knooooooooool0
0oooool1oo[jn`0000Coa<cCookno_ojn_[olo?c1OoalO403Oo_knooe]KF
of][Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?CgoJf][omKFe_o_knl0
2OoalO403Oo_knooemKFoh=[Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<S?mb
?CgoPF][omOFe_o_knl02OoalO403Oo_knooe]KFof][Jolm?CgoS8b<okZj
^_o<cLco^[Zjohb<S?lm?CgoJf][omKFe_o_knl0oooalO4Foo7al@03oo3`
l?oalO7olO7a017olO7a00?ol?3`oo7alOoalO40WOoalO400oo`l?3olO7a
oo7al@34oo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_on
o_h00Oo[k^l0000EohZHXoomoOgon?Shoo3`l?o[jn_oj^[ZonWYjOoZj^[o
jNWYon[Zj_oYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooX
j>SojNWY00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo@RHVofUI
FOnPVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9
obHV9_mIFEWoVi^KonSXj?oYjNT0oooZj^XZon[ZjP03onWYjOoZj^[oj^[Z
09coj^[Z00?ojNWYon[Zj_oZj^X0cOoZj^X01?o[jn_ol?3`ooShn?omoOd1
oloBeP0000Co@E1Nokc6cOojn_[olo?c2?oalO42oo3`l0?okno_0_o`l?0?
oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`oooalO7o
oo7alISolO7a00?ol?3`oo7alOoalO400_oalO400ooemOGon_[jonW[k@01
oi^OXP0000?o9Ca>oe5SL?nkaL`0ooooooooooooom[ooooo0Oo]ko41ojb`
]07oYjb`00001_lY@5Oo8SU<ocQ:FOn6TIgo`LS>onc^l?oooooooooooooD
ooooo`05ooSin_o/k^oodMCGoi^OXonMXjL00Onc^[l00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{734, 424},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(gridBag = JavaNew["\<java.awt.GridBagLayout\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.awt.GridBagLayout"] \[RightGuillemet]\),
      JLink`Objects`JavaObject30441352462337]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(savedLayout = pane@getLayout[]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JRootPane$1"] \[RightGuillemet]\),
      JLink`Objects`JavaObject16598756753409]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaBlock[pane@setLayout[gridBag]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(constraints = JavaNew["\<java.awt.GridBagConstraints\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.awt.GridBagConstraints"] \[RightGuillemet]\),
      JLink`Objects`JavaObject95456554123265]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(constraints@fill = java`awt`GridBagConstraints`BOTH\)], "Input"],

Cell[BoxData[
    \(1\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]constraints@insets = 
        JavaNew["\<java.awt.Insets\>", 5, 5, 5, 
          5]; \[IndentingNewLine]constraints@gridx = 
        0; \[IndentingNewLine]constraints@gridy = 
        0; \[IndentingNewLine]constraints@gridwidth = 
        2; \[IndentingNewLine]constraints@gridheight = 
        2; \[IndentingNewLine]constraints@weightx = 
        1.0; \[IndentingNewLine]constraints@weighty = 
        1.0;\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(b1 = JavaNew["\<javax.swing.JButton\>", "\<B1\>"]\), "\n", 
    \(gridBag@setConstraints[b1, constraints]\), "\n", 
    \(pane@add[b1]\), "\[IndentingNewLine]", 
    \(JavaShow[frame]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject20665654575105]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject20665654575105]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]constraints@insets = 
        JavaNew["\<java.awt.Insets\>", 0, 0, 0, 0]; 
      constraints@gridx = 2; \[IndentingNewLine]constraints@gridy = 
        0; \[IndentingNewLine]constraints@gridwidth = 
        1; \[IndentingNewLine]constraints@gridheight = 
        3; \[IndentingNewLine]constraints@weightx = 
        1.0; \[IndentingNewLine]constraints@weighty = 
        1.0;\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(b2 = JavaNew["\<javax.swing.JButton\>", "\<B2\>"]\), "\n", 
    \(gridBag@setConstraints[b2, constraints]\), "\n", 
    \(pane@add[b2]\), "\[IndentingNewLine]", 
    \(JavaShow[frame]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject42353377148929]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject42353377148929]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(constraints@gridx = 0\), "\n", 
    \(constraints@gridy = 2\), "\n", 
    \(constraints@gridwidth = 1\), "\n", 
    \(constraints@gridheight = 1\), "\n", 
    \(constraints@weightx = 1.0\), "\n", 
    \(constraints@weighty = 0.5\)}], "Input"],

Cell[BoxData[
    \(0\)], "Output"],

Cell[BoxData[
    \(2\)], "Output"],

Cell[BoxData[
    \(1\)], "Output"],

Cell[BoxData[
    \(1\)], "Output"],

Cell[BoxData[
    \(1.`\)], "Output"],

Cell[BoxData[
    \(0.5`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(b3 = JavaNew["\<javax.swing.JButton\>", "\<B3\>"]\), "\n", 
    \(gridBag@setConstraints[b3, constraints]\), "\n", 
    \(pane@add[b3]\), "\[IndentingNewLine]", 
    \(JavaShow[frame]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject13299819216897]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject13299819216897]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(constraints@gridx = 1\), "\[IndentingNewLine]", 
    \(constraints@gridy = 2\)}], "Input"],

Cell[BoxData[
    \(1\)], "Output"],

Cell[BoxData[
    \(2\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(b4 = JavaNew["\<javax.swing.JButton\>", "\<B4\>"]\), "\n", 
    \(gridBag@setConstraints[b4, constraints]\), "\n", 
    \(pane@add[b4]\), "\[IndentingNewLine]", 
    \(JavaShow[frame]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject54799655501825]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject54799655501825]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(DeleteJObject[pane, b1]\), "\[IndentingNewLine]", 
    \(DeleteJObject[pane, b2]\), "\[IndentingNewLine]", 
    \(DeleteJObject[pane, b3]\), "\[IndentingNewLine]", 
    \(DeleteJObject[pane, b4]\)}], "Input"],

Cell[BoxData[{
    \(ReleaseObject[constraints]\), "\[IndentingNewLine]", 
    \(ReleaseObject[gridBag]\)}], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]pane@
        setLayout[\[IndentingNewLine]JavaNew["\<java.awt.FlowLayout\>"]\
\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> java.awt.BoxLayout <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;K0001VAP00`40o`00
0?l0003oo`000?l0003M000000000hS0^4R@R4R@R03oB928odR@R=U8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^=R8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;SHR<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<oiVIVOnIVIWA
VIVI0/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<
c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVI
VLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>I
VIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003
VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>I
VIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`0
0iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<
00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<
c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<
c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=
c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<
cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<
c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<
c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<co
c<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<
olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<
c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<
c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03o
c<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<
00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0
olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<
c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<
0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<
c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<
c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<
c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<
c<`0olc<c<c<c<``ooooUlc<c3Ooool2c<c<00>IVIW<c<c<c<`00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<blc<
c003IVIVc<c<IVIV02eVIVH00oooolc<c<c<c02Dc<c<00=VIVK<c<aVIVH0
=6IVIP04ooooc<c<c<c<VIVI0/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c<_<c<`00fIVI_ooolc<c00/c<c<
00=VIVKoooo<c<`0ULc<c003IVIVooooc<c<03?<c<`01FIVI_ooolc<c<c<
c9VIV@02c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c03oc<c<blc<c003IVIVooooc<c<02c<c<`00fIVI_ooolc<c02E
c<c<00=VIVKoooo<c<`0<lc<c005IVIVooooc<c<c<c<VIVI00;<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<c;
c<c<00=VIVKoooo<c<`0;<c<c003IVIVooooc<c<09G<c<`00fIVI_ooolc<
c00cc<c<00EVIVKoooo<c<c<c<bIVIT00/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c<_<c<`00fIVI_ooolc<
c00/c<c<00=VIVKoooo<c<`0ULc<c003IVIVooooc<c<03?<c<`01FIVI_oo
olc<c<c<c9VIV@02c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c03oc<c<blc<c003IVIVooooc<c<02c<c<`00fIVI_oo
olc<c02Ec<c<00=VIVKoooo<c<`0<lc<c005IVIVooooc<c<c<c<VIVI00;<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<
0?o<c<c;c<c<00=VIVKoooo<c<`0;<c<c003IVIVooooc<c<09G<c<`00fIV
I_ooolc<c00cc<c<00EVIVKoooo<c<c<c<bIVIT00/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c<_<c<`00fIV
I_ooolc<c00>c<c<1P0000?<c<`300004/c<c003IVIVooooc<c<09G<c<`0
0fIVI_ooolc<c00>c<c<1P0000G<c<`200000lc<c0@0000Ac<c<00EVIVKo
ooo<c<c<c<bIVIT00/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00>IVIW<c<c<c<`0olc<c<_<c<`00fIVI_ooolc<c00>c<c<0P0000?<
c<`2000000?<c<`0000000000/c<c0030000c<c<c<c<00o<c<`00fIVI_oo
olc<c02Ec<c<00=VIVKoooo<c<`03/c<c0800003c<c<0P0000C<c<`20000
0/c<c0800002c<c<0P00013<c<`01FIVI_ooolc<c<c<c9VIV@02c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<
blc<c003IVIVooooc<c<00k<c<`200000lc<c0800005c<c<0P00013<c<`0
0fIVI_ooolc<c02Ec<c<00=VIVKoooo<c<`03/c<c0800003c<c<0P0000C<
c<`200000/c<c0800002c<c<0P00013<c<`01FIVI_ooolc<c<c<c9VIV@02
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<
c03oc<c<blc<c003IVIVooooc<c<00k<c<`200000lc<c0800002c<c<1@00
013<c<`00fIVI_ooolc<c02Ec<c<00=VIVKoooo<c<`03/c<c0800003c<c<
0P0000C<c<`200000/c<c0800002c<c<0P00013<c<`01FIVI_ooolc<c<c<
c9VIV@02c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c03oc<c<blc<c003IVIVooooc<c<00k<c<`600000/c<c0800002
c<c<0P00013<c<`00fIVI_ooolc<c02Ec<c<00=VIVKoooo<c<`03/c<c0H0
0005c<c<0P0000;<c<`200000/c<c080000@c<c<00EVIVKoooo<c<c<c<bI
VIT00/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<
c<c<c<`0olc<c<_<c<`00fIVI_ooolc<c00>c<c<0P0000?<c<`2000000?<
c<`0000000000/c<c080000@c<c<00=VIVKoooo<c<`0ULc<c003IVIVoooo
c<c<00k<c<`200000lc<c0800002c<c<00@0003<c<`000000002c<c<0P00
00;<c<`200004<c<c005IVIVooooc<c<c<c<VIVI00;<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<c;c<c<00=V
IVKoooo<c<`03/c<c0800003c<c<0P000003c<c<0000000000;<c<`20000
4<c<c003IVIVooooc<c<09G<c<`00fIVI_ooolc<c00>c<c<0P0000?<c<`2
00000/c<c0@00002c<c<0P0000;<c<`200004<c<c005IVIVooooc<c<c<c<
VIVI00;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<0?o<c<c;c<c<00=VIVKoooo<c<`03/c<c0800003c<c<0P000003
c<c<0000000000;<c<`200004<c<c003IVIVooooc<c<09G<c<`00fIVI_oo
olc<c00>c<c<0P0000?<c<`200000lc<c0<00002c<c<0P0000;<c<`20000
4<c<c005IVIVooooc<c<c<c<VIVI00;<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<c;c<c<00=VIVKoooo<c<`0
3/c<c0H00003c<c<1000017<c<`00fIVI_ooolc<c02Ec<c<00=VIVKoooo<
c<`03/c<c0H00005c<c<0P0000?<c<`400004Lc<c005IVIVooooc<c<c<c<
VIVI00;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<0?o<c<c;c<c<00=VIVKoooo<c<`0;<c<c003IVIVooooc<c<09G<
c<`00fIVI_ooolc<c00cc<c<00EVIVKoooo<c<c<c<bIVIT00/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c<_<
c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0ULc<c003IVIVooooc<c<
03?<c<`01FIVI_ooolc<c<c<c9VIV@02c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<blc<c003IVIVooooc<c<
02c<c<`00fIVI_ooolc<c02Ec<c<00=VIVKoooo<c<`0<lc<c005IVIVoooo
c<c<c<c<VIVI00;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<0?o<c<c;c<c<00=VIVKoooo<c<`0;<c<c003IVIVoooo
c<c<09G<c<`00fIVI_ooolc<c00cc<c<00EVIVKoooo<c<c<c<bIVIT00/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0
olc<c<_<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0ULc<c003IVIV
ooooc<c<03?<c<`01FIVI_ooolc<c<c<c9VIV@02c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<blc<c003IVIV
ooooc<c<02c<c<`00fIVI_ooolc<c02Ec<c<00=VIVKoooo<c<`0<lc<c005
IVIVooooc<c<c<c<VIVI00;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<0?o<c<c;c<c<00=VIVKoooo<c<`0;<c<c003
IVIVooooc<c<09G<c<`00fIVI_ooolc<c00cc<c<00EVIVKoooo<c<c<c<bI
VIT00/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<
c<c<c<`0olc<c<_<c<`00fIVI_ooooooo`0/oooo00?<c<coooo<c<`0ULc<
c003IVIVoooooooo03?oool01Lc<c?ooolc<c<c<c9VIV@02c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<blc<
c31VIVJGc<c<=fIVIP?<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVI
c<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<
c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVI
VLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>I
VIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003
VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>I
VIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`0
0iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<
00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<
c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<
c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=
c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<
cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<
c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<
c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<co
c<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<
olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<
c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<
c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03o
c<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<
00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0
olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<
c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<
0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<
c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<
c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<
c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<
c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<
c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<
c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<
c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<
c<c<c004c<c<1@0000?<c<`2000000?<c<`0000000001<c<c08000000lc<
c00000000002c<c<0P000?o<c<coc<c<[lc<c003VIVIc<c<c<c<00:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`00lc<c080
0003c<c<0P000003c<c<0000000000;<c<`200000lc<c08000001Lc<c000
000000000<c<c0020000olc<c?o<c<b`c<c<00>IVIW<c<c<c<`00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c008c<c<0P00
0003c<c<0000000000;<c<`200000lc<c0800002c<c<0P000003c<c<0000
00000?o<c<coc<c</<c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`01/c<c0@000000lc<c0000000
0002c<c<0P0000?<c<`200000/c<c08000000lc<c0000000003oc<c<olc<
c;3<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c0FIVIT2c<c<1@0000;<c<`200000/c<c0800003c<c<0P0000;<c<`2
000000?<c<`0000000000lc<c?nIVIWoVIVI[YVIV@;<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h2<c<c0@00004c<c<0P0000;<c<`200000lc<
c0800002c<c<0P000003c<c<000000000?o<c<coc<c</lc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P8c<c<0P0000G<c<`4000000?<c<`00000
00000P000003c<c<0000000000;<c<`60000olc<c?o<c<bbc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0S<c<`200000lc<c08000000lc<c000
0000000>c<c<0P000?o<c<coc<c</lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P9c<c<1@0000?<c<`00`000<c<c<c<c00=c<c<00<0003<c<c<
c<`0olc<c?o<c<bac<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<
c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<
c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<coVIVIoiVIVM6IVIT2c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`0
0iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c=?<c<``oooo
Ulc<c33oool2c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<d/c<c003IVIVc<c<IVIV02eV
IVH00oooolc<c<c<c02Dc<c<00=VIVK<c<aVIVH0;FIVIP04ooooc<c<c<c<
VIVI0/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<
c<c<c<`0olc<c=;<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0ULc<
c003IVIVooooc<c<02c<c<`01FIVI_ooolc<c<c<c9VIV@02c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<d/c<
c003IVIVooooc<c<02c<c<`00fIVI_ooolc<c02Ec<c<00=VIVKoooo<c<`0
;<c<c005IVIVooooc<c<c<c<VIVI00;<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<cBc<c<00=VIVKoooo<c<`0
;<c<c003IVIVooooc<c<09G<c<`00fIVI_ooolc<c00/c<c<00EVIVKoooo<
c<c<c<bIVIT00/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00>IVIW<c<c<c<`0olc<c=;<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<
c<`0ULc<c003IVIVooooc<c<02c<c<`01FIVI_ooolc<c<c<c9VIV@02c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03o
c<c<d/c<c003IVIVooooc<c<02c<c<`00fIVI_ooolc<c02Ec<c<00=VIVKo
ooo<c<`0;<c<c005IVIVooooc<c<c<c<VIVI00;<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<cBc<c<00=VIVKo
ooo<c<`0;<c<c003IVIVooooc<c<09G<c<`00fIVI_ooolc<c00/c<c<00EV
IVKoooo<c<c<c<bIVIT00/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00>IVIW<c<c<c<`0olc<c=;<c<`00fIVI_ooolc<c00>c<c<1P00
00?<c<`200004lc<c003IVIVooooc<c<09G<c<`00fIVI_ooolc<c00>c<c<
1P0000?<c<`400004Lc<c005IVIVooooc<c<c<c<VIVI00;<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<cBc<c<
00=VIVKoooo<c<`03/c<c0800003c<c<0P0000;<c<`200004lc<c003IVIV
ooooc<c<09G<c<`00fIVI_ooolc<c00>c<c<0P0000?<c<`2000000?<c<`0
000000000/c<c080000@c<c<00EVIVKoooo<c<c<c<bIVIT00/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c=;<
c<`00fIVI_ooolc<c00>c<c<0P0000?<c<`200000/c<c080000Cc<c<00=V
IVKoooo<c<`0ULc<c003IVIVooooc<c<00k<c<`200000lc<c08000000lc<
c00000000002c<c<0P00013<c<`01FIVI_ooolc<c<c<c9VIV@02c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<
d/c<c003IVIVooooc<c<00k<c<`200000lc<c0800003c<c<0P0001;<c<`0
0fIVI_ooolc<c02Ec<c<00=VIVKoooo<c<`03/c<c0800003c<c<0P000003
c<c<0000000000;<c<`200004<c<c005IVIVooooc<c<c<c<VIVI00;<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<
c<cBc<c<00=VIVKoooo<c<`03/c<c0H00004c<c<0P0001;<c<`00fIVI_oo
olc<c02Ec<c<00=VIVKoooo<c<`03/c<c0H00003c<c<1000017<c<`01FIV
I_ooolc<c<c<c9VIV@02c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00iVIVLc<c<c<c03oc<c<d/c<c003IVIVooooc<c<00k<c<`20000
0lc<c0800004c<c<0P00017<c<`00fIVI_ooolc<c02Ec<c<00=VIVKoooo<
c<`03/c<c0800003c<c<0P000003c<c<0000000000;<c<`200004<c<c005
IVIVooooc<c<c<c<VIVI00;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<0?o<c<cBc<c<00=VIVKoooo<c<`03/c<c080
0003c<c<0P0000C<c<`200004Lc<c003IVIVooooc<c<09G<c<`00fIVI_oo
olc<c00>c<c<0P0000?<c<`2000000?<c<`0000000000/c<c080000@c<c<
00EVIVKoooo<c<c<c<bIVIT00/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c=;<c<`00fIVI_ooolc<c00>c<c<
0P0000?<c<`200001Lc<c080000@c<c<00=VIVKoooo<c<`0ULc<c003IVIV
ooooc<c<00k<c<`200000lc<c08000000lc<c00000000002c<c<0P00013<
c<`01FIVI_ooolc<c<c<c9VIV@02c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<d/c<c003IVIVooooc<c<00k<
c<`600000/c<c0H0000@c<c<00=VIVKoooo<c<`0ULc<c003IVIVooooc<c<
00k<c<`600000lc<c0@0000Ac<c<00EVIVKoooo<c<c<c<bIVIT00/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<
c=;<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0ULc<c003IVIVoooo
c<c<02c<c<`01FIVI_ooolc<c<c<c9VIV@02c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<d/c<c003IVIVoooo
c<c<02c<c<`00fIVI_ooolc<c02Ec<c<00=VIVKoooo<c<`0;<c<c005IVIV
ooooc<c<c<c<VIVI00;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<0?o<c<cBc<c<00=VIVKoooo<c<`0;<c<c003IVIV
ooooc<c<09G<c<`00fIVI_ooolc<c00/c<c<00EVIVKoooo<c<c<c<bIVIT0
0/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<
c<`0olc<c=;<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0ULc<c003
IVIVooooc<c<02c<c<`01FIVI_ooolc<c<c<c9VIV@02c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<d/c<c003
IVIVooooc<c<02c<c<`00fIVI_ooolc<c02Ec<c<00=VIVKoooo<c<`0;<c<
c005IVIVooooc<c<c<c<VIVI00;<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<cBc<c<00=VIVKoooo<c<`0;<c<
c003IVIVooooc<c<09G<c<`00fIVI_ooolc<c00/c<c<00EVIVKoooo<c<c<
c<bIVIT00/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>I
VIW<c<c<c<`0olc<c=;<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0
ULc<c003IVIVooooc<c<02c<c<`01FIVI_ooolc<c<c<c9VIV@02c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<
d/c<c003IVIVoooooooo02coool00lc<c?ooolc<c02Ec<c<00=VIVKooooo
ool0;?ooo`05c<c<ooooc<c<c<c<VIVI00;<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<cBc<c<<6IVIYO<c<``
IVIV0lc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<
olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<
c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<
c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00>IVIW<c<c<c<`03lc<c0@0003oc<c<olc<c;[<c<`00iVI
VLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<00k<c<`010000<c<c<c<c<c<c080003oc<c<olc<c;W<c<`00iVI
VLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<00?<c<`200001<c<c0@00002c<c<0P000004c<c<00000000c<c<
0P0000;<c<`2000000?<c<`0000000001<c<c0800003c<c<0P000003c<c<
0000000000C<c<`400000lc<c0D0003oc<c<olc<c97<c<`00iVIVLc<c<c<
c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<
00?<c<`200000lc<c08000001<c<c00000000<c<c08000001Lc<c0000000
00000<c<c002000000C<c<`00000003<c<`300001<c<c0800003c<c<0P00
0003c<c<0000000000?<c<`200000/c<c08000000lc<c00000000002c<c<
0P000?o<c<coc<c<TLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`00lc<c0800003c<c<0P000004
c<c<00000000c<c<0P0000;<c<`2000000C<c<`00000003<c<`200000/c<
c0800004c<c<1`000003c<c<0000000000?<c<`200001Lc<c0800002c<c<
0P000?o<c<coc<c<TLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`00lc<c0800002c<c<0P0000;<
c<`2000000?<c<`0000000000/c<c08000001<c<c00000000<c<c0800002
c<c<0P0000G<c<`2000000?<c<`0000000000/c<c0800003c<c<1P0000;<
c<`2000000?<c<`000000000olc<c?o<c<bAc<c<00>IVIW<c<c<c<`00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`5VIVI00?<c<`000000000
100000;<c<`2000000?<c<`0000000000/c<c08000001<c<c00000000<c<
c0800002c<c<0P0000G<c<`2000000?<c<`0000000000/c<c0800003c<c<
0P0000;<c<`200000lc<c0@00002c<c<oiVIVOnIVIV@VIVI0/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P8c<c<0P0000?<c<`2000000C<c<`0
0000003<c<`2000000G<c<`000000000003<c<`00P000004c<c<00000000
c<c<0`0000G<c<`2000000?<c<`0000000000/c<c0800003c<c<0P0000;<
c<`2000000?<c<`0003<c<`00/c<c080003oc<c<olc<c9C<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h2<c<c0800003c<c<0P000003c<c<0000
000000;<c<`2000000C<c<`00000003<c<`200000/c<c08000000lc<c000
00000005c<c<0P000003c<c<0000000000;<c<`400000/c<c0@00003c<c<
10000?o<c<coc<c<ULc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P8
c<c<0P0000?<c<`200004/c<c0800006c<c<0`000?o<c<coc<c<ZLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P8c<c<1P0000;<c<`200002<c<
c0800005c<c<0P0000K<c<`30000olc<c?o<c<bYc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<
olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<cE
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<coVIVIoiVIVM6I
VIT2c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<
c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVI
c<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<
c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVI
VLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>I
VIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003
VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>I
VIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`0
0iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<
00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<
c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<
c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=
c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<
cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<
c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<
c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<co
c<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<
7<c<c33oooooc<c<C/c<c33oool3c<c<00>IVIW<c<c<c<`00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<6lc<c003
IVIVc<c<IVIV02eVIVH00oooolc<c<c<c03oc<c<Blc<c003IVIVc<c<IVIV
02eVIVH01Oooolc<c<c<c<c<c9VIV@02c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<6lc<c003IVIVooooc<c<
02c<c<`00fIVI_ooolc<c03oc<c<C<c<c003IVIVooooc<c<02c<c<`00fIV
I_ooolc<c002c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<6lc<c003IVIVooooc<c<02c<
c<`00fIVI_ooolc<c03oc<c<C<c<c003IVIVooooc<c<02c<c<`00fIVI_oo
olc<c002c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<6lc<c003IVIVooooc<c<02c<c<`0
0fIVI_ooolc<c03oc<c<C<c<c003IVIVooooc<c<02c<c<`00fIVI_ooolc<
c002c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00iVIVLc<c<c<c03oc<c<6lc<c003IVIVooooc<c<02c<c<`00fIV
I_ooolc<c03oc<c<C<c<c003IVIVooooc<c<02c<c<`00fIVI_ooolc<c002
c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c03oc<c<6lc<c003IVIVooooc<c<02c<c<`00fIVI_oo
olc<c03oc<c<C<c<c003IVIVooooc<c<02c<c<`00fIVI_ooolc<c002c<c<
00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0iVIVLc<c<c<c03oc<c<6lc<c003IVIVooooc<c<02c<c<`00fIVI_ooolc<
c03oc<c<C<c<c003IVIVooooc<c<02c<c<`00fIVI_ooolc<c002c<c<00>I
VIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c03oc<c<6lc<c003IVIVooooc<c<00k<c<`600000lc<c0@0000A
c<c<00=VIVKoooo<c<`0olc<c4c<c<`00fIVI_ooolc<c00>c<c<1P0000?<
c<`400004Lc<c003IVIVooooc<c<00;<c<`00iVIVLc<c<c<c002R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<`Kc<c<
00=VIVKoooo<c<`03/c<c0800003c<c<0P000003c<c<0000000000;<c<`2
00004<c<c003IVIVooooc<c<0?o<c<a<c<c<00=VIVKoooo<c<`03/c<c080
0003c<c<0P000003c<c<0000000000;<c<`200004<c<c003IVIVooooc<c<
00;<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<0?o<c<`Kc<c<00=VIVKoooo<c<`03/c<c0800003
c<c<0P0000G<c<`200004<c<c003IVIVooooc<c<0?o<c<a<c<c<00=VIVKo
ooo<c<`03/c<c0800003c<c<0P000003c<c<0000000000;<c<`200004<c<
c003IVIVooooc<c<00;<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<`Kc<c<00=VIVKoooo<
c<`03/c<c0800003c<c<0P0000G<c<`200004<c<c003IVIVooooc<c<0?o<
c<a<c<c<00=VIVKoooo<c<`03/c<c0800003c<c<0P000003c<c<00000000
00;<c<`200004<c<c003IVIVooooc<c<00;<c<`00iVIVLc<c<c<c002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<`K
c<c<00=VIVKoooo<c<`03/c<c0H00002c<c<0P0000;<c<`200004<c<c003
IVIVooooc<c<0?o<c<a<c<c<00=VIVKoooo<c<`03/c<c0H00002c<c<0P00
00;<c<`200004<c<c003IVIVooooc<c<00;<c<`00iVIVLc<c<c<c002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<`K
c<c<00=VIVKoooo<c<`03/c<c0800003c<c<0P000003c<c<0000000000<0
000Ac<c<00=VIVKoooo<c<`0olc<c4c<c<`00fIVI_ooolc<c00>c<c<0P00
00?<c<`2000000?<c<`0000000000`00017<c<`00fIVI_ooolc<c002c<c<
00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0iVIVLc<c<c<c03oc<c<6lc<c003IVIVooooc<c<00k<c<`200000lc<c080
00000lc<c0000000000Dc<c<00=VIVKoooo<c<`0olc<c4c<c<`00fIVI_oo
olc<c00>c<c<0P0000?<c<`2000000?<c<`0000000005<c<c003IVIVoooo
c<c<00;<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<0?o<c<`Kc<c<00=VIVKoooo<c<`03/c<c080
0003c<c<0P0000;<c<`200004lc<c003IVIVooooc<c<0?o<c<a<c<c<00=V
IVKoooo<c<`03/c<c0800003c<c<0P0000;<c<`00`000<c<c<c<c0020000
4<c<c003IVIVooooc<c<00;<c<`00iVIVLc<c<c<c002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<`Kc<c<00=VIVKo
ooo<c<`03/c<c0H00003c<c<1@00013<c<`00fIVI_ooolc<c03oc<c<C<c<
c003IVIVooooc<c<00k<c<`600001<c<c0<0000Ac<c<00=VIVKoooo<c<`0
0/c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00>IVIW<c<c<c<`0olc<c1_<c<`00fIVI_ooolc<c00/c<c<00=VIVKo
ooo<c<`0olc<c4c<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`00/c<
c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00>IVIW<c<c<c<`0olc<c1_<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<
c<`0olc<c4c<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`00/c<c003
VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>I
VIW<c<c<c<`0olc<c1_<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0
olc<c4c<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`00/c<c003VIVI
c<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<
c<c<c<`0olc<c1_<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0olc<
c4c<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`00/c<c003VIVIc<c<
c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<
c<`0olc<c1_<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0olc<c4c<
c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`00/c<c003VIVIc<c<c<c<
00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0
olc<c1_<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0olc<c4c<c<`0
0fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`00/c<c003VIVIc<c<c<c<00:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<
c1_<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0olc<c4c<c<`00fIV
I_ooolc<c00/c<c<00=VIVKoooo<c<`00/c<c003VIVIc<c<c<c<00:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c1_<
c<`00fIVI_ooooooo`0/oooo00?<c<coooo<c<`0olc<c4c<c<`00fIVI_oo
ooooo`0/oooo00?<c<coooo<c<`00/c<c003VIVIc<c<c<c<00:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c1_<c<``
IVIVolc<c4k<c<``IVIV1<c<c003VIVIc<c<c<c<00:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>I
VIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003
VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>I
VIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`0
0iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<
00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<
c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<
c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=
c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<
cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<
c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<
c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<co
c<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<
olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<
c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<
c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03o
c<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<
00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0
olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<
c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<
00?<c<`200001<c<c08000001<c<c00000000<c<c0800002c<c<100000;<
c<`20000olc<c?o<c<bbc<c<00>IVIW<c<c<c<`00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c003c<c<0P0000C<c<`20000
00C<c<`00000003<c<`2000000?<c<`0000000000/c<c08000000lc<c000
0000003oc<c<olc<c;;<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<00?<c<`200001<c<c0800000
1<c<c00000000<c<c08000000lc<c00000000005c<c<0P000?o<c<coc<c<
//c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00>IVIW<c<c<c<`00lc<c0800004c<c<0P000004c<c<00000000c<c<
0P000003c<c<0000000000@000000lc<c0000000003oc<c<olc<c;;<c<`0
0iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c0FI
VIT00lc<c00000000003000000C<c<`00000003<c<`2000000C<c<`00000
003<c<`200000/c<c08000000lc<c00000000004c<c<oiVIVOnIVIV_VIVI
0/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P8c<c<0P0000C<c<`2
000000C<c<`00000003<c<`2000000?<c<`0000000000/c<c08000000lc<
c0000000003oc<c<olc<c;G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h2<c<c0800004c<c<0P000004c<c<00000000c<c<0P0000;<c<`40000
0/c<c0@0003oc<c<olc<c;?<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h2<c<c0800007c<c<0P000003c<c<000000000?o<c<coc<c<_lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P8c<c<1@000004c<c<00000000
c<c<0P000003c<c<000000000?o<c<coc<c<_lc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<oiVIVOnIVIWAVIVI
0/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<
c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<
c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<
c<c<0<k<c<``ooooc/c<c33oooo?c<c<00>IVIW<c<c<c<`00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03=c<c<00=VIVK<
c<aVIVH0;FIVIP03ooooc<c<c<c<0<_<c<`00fIVI/c<c6IVIP0]IVIV00?o
ooo<c<c<c<`0cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0cLc<c003IVIVooooc<c<02c<c<`0
0fIVI_ooolc<c03<c<c<00=VIVKoooo<c<`0;<c<c003IVIVooooc<c<0<k<
c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<0<g<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0
c<c<c003IVIVooooc<c<02c<c<`00fIVI_ooolc<c03>c<c<00>IVIW<c<c<
c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<
c03=c<c<00=VIVKoooo<c<`0;<c<c003IVIVooooc<c<0<c<c<`00fIVI_oo
olc<c00/c<c<00=VIVKoooo<c<`0c/c<c003VIVIc<c<c<c<00:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0cLc<c003IVIV
ooooc<c<02c<c<`00fIVI_ooolc<c03<c<c<00=VIVKoooo<c<`0;<c<c003
IVIVooooc<c<0<k<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0<g<c<`00fIVI_ooolc<c00/c<c<
00=VIVKoooo<c<`0c<c<c003IVIVooooc<c<02c<c<`00fIVI_ooolc<c03>
c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c03=c<c<00=VIVKoooo<c<`0;<c<c003IVIVooooc<c<
0<c<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0c/c<c003VIVIc<c<
c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<
c<`0cLc<c003IVIVooooc<c<00k<c<`600000lc<c0@0000Ac<c<00=VIVKo
ooo<c<`0c<c<c003IVIVooooc<c<00k<c<`600001Lc<c080000Ac<c<00=V
IVKoooo<c<`0c/c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0cLc<c003IVIVooooc<c<00k<c<`2
00000lc<c08000000lc<c00000000002c<c<0P00013<c<`00fIVI_ooolc<
c03<c<c<00=VIVKoooo<c<`03/c<c0800003c<c<0P0000C<c<`200004Lc<
c003IVIVooooc<c<0<k<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0<g<c<`00fIVI_ooolc<c00>
c<c<0P0000?<c<`200001Lc<c080000@c<c<00=VIVKoooo<c<`0c<c<c003
IVIVooooc<c<00k<c<`200000lc<c08000000lc<c0000000000400004<c<
c003IVIVooooc<c<0<k<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0<g<c<`00fIVI_ooolc<c00>
c<c<0P0000?<c<`200001Lc<c080000@c<c<00=VIVKoooo<c<`0c<c<c003
IVIVooooc<c<00k<c<`200000lc<c08000001<c<c0000<c<c<c<c080000A
c<c<00=VIVKoooo<c<`0c/c<c003VIVIc<c<c<c<00:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0cLc<c003IVIVooooc<c<
00k<c<`600001/c<c080000@c<c<00=VIVKoooo<c<`0c<c<c003IVIVoooo
c<c<00k<c<`600000lc<c0040000c<c<000000004Lc<c003IVIVooooc<c<
0<k<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<0<g<c<`00fIVI_ooolc<c00>c<c<0P0000?<c<`2
00000lc<c0<0000Ac<c<00=VIVKoooo<c<`0c<c<c003IVIVooooc<c<00k<
c<`200000lc<c0800002c<c<00@0003<c<`00000000Ac<c<00=VIVKoooo<
c<`0c/c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00>IVIW<c<c<c<`0cLc<c003IVIVooooc<c<00k<c<`200000lc<
c0800005c<c<0P00013<c<`00fIVI_ooolc<c03<c<c<00=VIVKoooo<c<`0
3/c<c0800003c<c<0P0000?<c<`300004Lc<c003IVIVooooc<c<0<k<c<`0
0iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
VIVIc<c<c<c<0<g<c<`00fIVI_ooolc<c00>c<c<0P0000?<c<`2000000?<
c<`0000000000/c<c080000@c<c<00=VIVKoooo<c<`0c<c<c003IVIVoooo
c<c<00k<c<`200000lc<c0800003c<c<0`00017<c<`00fIVI_ooolc<c03>
c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c03=c<c<00=VIVKoooo<c<`03/c<c0H00003c<c<1000
017<c<`00fIVI_ooolc<c03<c<c<00=VIVKoooo<c<`03/c<c0H00005c<c<
0P00017<c<`00fIVI_ooolc<c03>c<c<00>IVIW<c<c<c<`00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03=c<c<00=VIVKo
ooo<c<`0;<c<c003IVIVooooc<c<0<c<c<`00fIVI_ooolc<c00/c<c<00=V
IVKoooo<c<`0c/c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0cLc<c003IVIVooooc<c<02c<c<`0
0fIVI_ooolc<c03<c<c<00=VIVKoooo<c<`0;<c<c003IVIVooooc<c<0<k<
c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<0<g<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0
c<c<c003IVIVooooc<c<02c<c<`00fIVI_ooolc<c03>c<c<00>IVIW<c<c<
c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<
c03=c<c<00=VIVKoooo<c<`0;<c<c003IVIVooooc<c<0<c<c<`00fIVI_oo
olc<c00/c<c<00=VIVKoooo<c<`0c/c<c003VIVIc<c<c<c<00:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0cLc<c003IVIV
ooooc<c<02c<c<`00fIVI_ooolc<c03<c<c<00=VIVKoooo<c<`0;<c<c003
IVIVooooc<c<0<k<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0<g<c<`00fIVI_ooolc<c00/c<c<
00=VIVKoooo<c<`0c<c<c003IVIVooooc<c<02c<c<`00fIVI_ooolc<c03>
c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c03=c<c<00=VIVKoooo<c<`0;<c<c003IVIVooooc<c<
0<c<c<`00fIVI_ooolc<c00/c<c<00=VIVKoooo<c<`0c/c<c003VIVIc<c<
c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<
c<`0cLc<c003IVIVoooooooo02coool00lc<c?ooolc<c03<c<c<00=VIVKo
ooooool0;?ooo`03c<c<ooooc<c<0<k<c<`00iVIVLc<c<c<c002R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0<g<c<``IVIV
c/c<c31VIVK@c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<
c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<
0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<
c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<
c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<
c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<
c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<
c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<
c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`01Lc<c0@00002c<c<0P0000;<
c<`2000000?<c<`0000000000/c<c0@00005c<c<1P000?o<c<coc<c<Z<c<
c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00>IVIW<c<c<c<`01<c<c0800002c<c<0P000004c<c<00000000c<c<0P00
0005c<c<000000000000c<c<00800002c<c<0P0000C<c<`20000olc<c?o<
c<b/c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00iVIVLc<c<c<c003c<c<0P0000?<c<`2000000C<c<`00000003<
c<`200000/c<c08000000lc<c00000000009c<c<0P000?o<c<coc<c<Zlc<
c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00>IVIW<c<c<c<`00lc<c0800003c<c<0P000004c<c<00000000c<c<0P00
00;<c<`2000000?<c<`000000000100000K<c<`20000olc<c?o<c<bZc<c<
00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`5
VIVI00?<c<`0000000000/c<c0<000001<c<c00000000<c<c0800002c<c<
0P000003c<c<0000000000;<c<`200001lc<c0800003c<c<oiVIVOnIVIVW
VIVI0/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P8c<c<0P0000K<
c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P00
00S<c<`20000olc<c?o<c<b[c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0S<c<`200001/c<c08000000lc<c00000000002c<c<0P0000;<c<`4
00002Lc<c080003oc<c<olc<c:_<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h2Lc<c0800002c<c<0P000003c<c<0000000001;<c<`200000/c<
c080003oc<c<olc<c:_<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
2/c<c0@00002c<c<0P0001?<c<`40000olc<c?o<c<b/c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c=G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<cEc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<coVIVIoiVI
VM6IVIT2c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003
VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00BI
VIW<c<c<c<c<c<``ooooolc<c?o<c<aZc<c<<?ooo`;<c<`00iVIVLc<c<c<
c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c005VIVIc<c<c<c<
IVIVc<c<02iVIVH00oooolc<c<c<c03oc<c<olc<c6O<c<`00fIVI/c<c6IV
IP0]IVIV00Coooo<c<c<c<bIVIT2c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`01IVIVLc<c<c<c6IVI_ooo`0]c<c<00=VIVKoooo<c<`0
olc<c?o<c<aXc<c<00=VIVKoooo<c<`0;<c<c005IVIVooooc<c<c<c<VIVI
00;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c005VIVIc<c<
c<c<IVIVoooo02g<c<`00fIVI_ooolc<c03oc<c<olc<c6S<c<`00fIVI_oo
olc<c00/c<c<00EVIVKoooo<c<c<c<bIVIT00/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00FIVIW<c<c<c<aVIVKoool0;Lc<c003IVIV
ooooc<c<0?o<c<coc<c<J<c<c003IVIVooooc<c<02c<c<`01FIVI_ooolc<
c<c<c9VIV@02c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
1IVIVLc<c<c<c6IVI_ooo`0]c<c<00=VIVKoooo<c<`0olc<c?o<c<aXc<c<
00=VIVKoooo<c<`0;<c<c005IVIVooooc<c<c<c<VIVI00;<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c005VIVIc<c<c<c<IVIVoooo02g<
c<`00fIVI_ooolc<c03oc<c<olc<c6S<c<`00fIVI_ooolc<c00/c<c<00EV
IVKoooo<c<c<c<bIVIT00/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00FIVIW<c<c<c<aVIVKoool0;Lc<c003IVIVooooc<c<0?o<c<co
c<c<J<c<c003IVIVooooc<c<02c<c<`01FIVI_ooolc<c<c<c9VIV@02c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`01IVIVLc<c<c<c6IV
I_ooo`0?c<c<1P0000G<c<`200004Lc<c003IVIVooooc<c<0?o<c<coc<c<
J<c<c003IVIVooooc<c<00k<c<`600000/c<c0H0000@c<c<00EVIVKoooo<
c<c<c<bIVIT00/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00FIVIW<c<c<c<aVIVKoool03lc<c0800003c<c<0P0000C<c<`200004Lc<
c003IVIVooooc<c<0?o<c<coc<c<J<c<c003IVIVooooc<c<00k<c<`20000
0lc<c08000000lc<c0000000000Dc<c<00EVIVKoooo<c<c<c<bIVIT00/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00FIVIW<c<c<c<aV
IVKoool03lc<c0800003c<c<0P0000C<c<`200004Lc<c003IVIVooooc<c<
0?o<c<coc<c<J<c<c003IVIVooooc<c<00k<c<`200000lc<c0800002c<c<
0P0001?<c<`01FIVI_ooolc<c<c<c9VIV@02c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`01IVIVLc<c<c<c6IVI_ooo`0?c<c<0P0000?<
c<`200001<c<c080000Ac<c<00=VIVKoooo<c<`0olc<c?o<c<aXc<c<00=V
IVKoooo<c<`03/c<c0800003c<c<0P0000?<c<`200004/c<c005IVIVoooo
c<c<c<c<VIVI00;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c005VIVIc<c<c<c<IVIVoooo00o<c<`600001Lc<c080000Ac<c<00=VIVKo
ooo<c<`0olc<c?o<c<aXc<c<00=VIVKoooo<c<`03/c<c0H00005c<c<0P00
017<c<`01FIVI_ooolc<c<c<c9VIV@02c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`01IVIVLc<c<c<c6IVI_ooo`0?c<c<0P0000?<c<`2
00000/c<c0040000c<c<000000004Lc<c003IVIVooooc<c<0?o<c<coc<c<
J<c<c003IVIVooooc<c<00k<c<`200000lc<c0800005c<c<0P00013<c<`0
1FIVI_ooolc<c<c<c9VIV@02c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`01IVIVLc<c<c<c6IVI_ooo`0?c<c<0P0000?<c<`200000/c<
c0@0000Ac<c<00=VIVKoooo<c<`0olc<c?o<c<aXc<c<00=VIVKoooo<c<`0
3/c<c0800003c<c<0P0000G<c<`200004<c<c005IVIVooooc<c<c<c<VIVI
00;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c005VIVIc<c<
c<c<IVIVoooo00o<c<`200000lc<c0800003c<c<0`00017<c<`00fIVI_oo
olc<c03oc<c<olc<c6S<c<`00fIVI_ooolc<c00>c<c<0P0000?<c<`20000
00?<c<`0000000000/c<c080000@c<c<00EVIVKoooo<c<c<c<bIVIT00/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00FIVIW<c<c<c<aV
IVKoool03lc<c0H00005c<c<0P00017<c<`00fIVI_ooolc<c03oc<c<olc<
c6S<c<`00fIVI_ooolc<c00>c<c<1P0000?<c<`400004Lc<c005IVIVoooo
c<c<c<c<VIVI00;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c005VIVIc<c<c<c<IVIVoooo02g<c<`00fIVI_ooolc<c03oc<c<olc<c6S<
c<`00fIVI_ooolc<c00/c<c<00EVIVKoooo<c<c<c<bIVIT00/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00FIVIW<c<c<c<aVIVKoool0
;Lc<c003IVIVooooc<c<0?o<c<coc<c<J<c<c003IVIVooooc<c<02c<c<`0
1FIVI_ooolc<c<c<c9VIV@02c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`01IVIVLc<c<c<c6IVI_ooo`0]c<c<00=VIVKoooo<c<`0olc<
c?o<c<aXc<c<00=VIVKoooo<c<`0;<c<c005IVIVooooc<c<c<c<VIVI00;<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c005VIVIc<c<c<c<
IVIVoooo02g<c<`00fIVI_ooolc<c03oc<c<olc<c6S<c<`00fIVI_ooolc<
c00/c<c<00EVIVKoooo<c<c<c<bIVIT00/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00FIVIW<c<c<c<aVIVKoool0;Lc<c003IVIVoooo
c<c<0?o<c<coc<c<J<c<c003IVIVooooc<c<02c<c<`01FIVI_ooolc<c<c<
c9VIV@02c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`01IVI
VLc<c<c<c6IVI_ooo`0]c<c<00=VIVKoooo<c<`0olc<c?o<c<aXc<c<00=V
IVKoooo<c<`0;<c<c005IVIVooooc<c<c<c<VIVI00;<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0/c<c005VIVIc<c<c<c<IVIVoooo02g<c<`0
0fIVI_ooolc<c03oc<c<olc<c6S<c<`00fIVI_ooolc<c00/c<c<00EVIVKo
ooo<c<c<c<bIVIT00/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00BIVIW<c<c<c<aVIVH^oooo00?<c<coooo<c<`0olc<c?o<c<aXc<c<
00=VIVKoooooool0;?ooo`05c<c<ooooc<c<c<c<VIVI00;<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<031VIVKoc<c<
olc<c6[<c<``IVIV0lc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<
c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<
c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<cLc<c003VIVI
c<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<
c<c<c<`0olc<c?o<c<c=c<c<00>IVIW<c<c<c<`00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c<g<c<`00iVI
VLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<0?o<c<coc<c<cLc<c003VIVIc<c<c<c<00:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<c=c<c<00>I
VIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c03oc<c<olc<c<g<c<`00iVIVLc<c<c<c002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<00G<c<`400000/c<c080
0002c<c<0P000003c<c<0000000000;<c<`400002<c<c080003oc<c<olc<
c:W<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<00C<c<`200000/c<c08000001<c<c00000000<c<
c08000001Lc<c000000000000<c<c00200000/c<c0800007c<c<0P000?o<
c<coc<c<ZLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00>IVIW<c<c<c<`00lc<c0800003c<c<0P000004c<c<0000
0000c<c<0P0000;<c<`2000000?<c<`0000000002lc<c080003oc<c<olc<
c:W<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<00?<c<`200000lc<c08000001<c<c00000000<c<
c0800002c<c<0P000003c<c<0000000000@00007c<c<0P000?o<c<coc<c<
ZLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<1IVIV@03c<c<0000000000;<c<`3000000C<c<`00000003<c<`20000
0/c<c08000000lc<c00000000002c<c<0P0000O<c<`200000lc<c?nIVIWo
VIVIYiVIV@;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h2<c<c080
0006c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<
c0800005c<c<00@0003<c<`00000003oc<c<olc<c:c<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h2<c<c0800006c<c<0P000003c<c<00000000
00;<c<`200000/c<c0@00006c<c<10000?o<c<coc<c<[<c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P9c<c<0P0000;<c<`2000000?<c<`00000
00005<c<c0<0003oc<c<olc<c:c<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h2/c<c0@00002c<c<0P0001G<c<`20000olc<c?o<c<b/c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c=G<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2holc<c?o<c<cEc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<coc<c<eLc<c0:8`;P1B9280@00000000>8`;S8h=R8
`;P0ohS0^?n8`;SHR<2h0DR@R04000000004R<2hb>3HR<2hR<2h5P00P0@0
0H0300:01003P@@0184200F100<01H801X801X800P06PP801h800`47PP48
PP48PP020@R31049P`<12X<0104;P`4;Q04;Q04;Q0@138@30@f4104>Q@<2
3hD40Q25108AQP<24XH30Q>600@24hL258L258L258L40QF70P8FQ`835XP3
0aN810<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX010@N
R`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<00<498d49Hd49Hd00PDU
S@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5
;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHc
TPHcTP021S>B00<6=987=987=9800PLeTP87=I<31cJC10LgT`041cRC1cRD
1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2
242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9
AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?
W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN
0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aM
X@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=
I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]
YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X
0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1k
Z`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d0
0Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<AQJl4
4HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb
4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@3
4iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g
59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ
^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@F
Z[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`
_P<G/Kl45k:o0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1000P003VjOa<d>U<d>U00Tc@jD600201001P0<00X0400>11004P@801H40
0`05PP06PP06PP0200J20P07PP030@N20@R20@R2008128<40@V30`4:P`04
0@^30@^40@^40@^4104<Q0<13H@40@j50`8?Q@@248D40Q660`8BQP<24hH0
108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT3
6HT30aZ910<KR@<378X40af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/4
12:<10@SS08498`00`@TS@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5
:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA
1S2A1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLd
TP021cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD3
23bE0`PmU@0423fF23jF23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G
00<9@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX4
2DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:
DId22U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil3
2eRO10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR
0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@4
3FNT0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>
KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mf
ZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@
OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh3
4H:^1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9
/A::/A::/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<C
Sk8CSk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@D
U[D359Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM
^0@EW[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<F
Y[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG
[;d011N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G/[l35k>o=QRd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000NKYo7ooon>N[JVVlBc
ZM:XWLRcZM800ZJKa005_;SMk^kdj^Waoooo<d>U00D0080400600`02P0@0
0h4400B10P05P@0300F200J200J200801X8200N200<11h81288128800P48
P`@12H<30@Z300@12h<12h@12h@12h@40@b40`4=Q0@13XD30Pn5108@Q@@2
4HH30Q:60`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P0
10<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/4
7h/4122;0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<5
9hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6
;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHc
TP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7
>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3
246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9
AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?
W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]G
WP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ44
35jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=
IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^
Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY
0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l
[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161
[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk04
4XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb
0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd
4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g
0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS
^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08F
Zkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb
_`<G/kl26;C08000008H]<0@00000QRd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2002000BKYo7ooom/FZF_YLX2_;SM00[ooOncZM;ooooooonl
^=fGR[bXWLSVi^cooolc@jD400201001P0<00X0400>11004P@801H400`05
PP06PP06PP0200J20P07PP030@N20@R20@R2008128<40@V30`4:P`040@^3
0@^40@^40@^4104<Q0<13H@40@j50`8?Q@@248D40Q660`8BQP<24hH0108C
Q`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT3
0aZ910<KR@<378X40af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<
10@SS08498`00`@TS@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h3
1BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A
1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP02
1cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE
0`PmU@0423fF23jF23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9
@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ
0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId2
2U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO
10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aP
XP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT
0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL0
0`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmf
ZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`2
47j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^
1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::
/A::/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8C
Sk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D3
59Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@E
W[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/4
5ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d0
11N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G/[l35k>o0QRd`003b>3H
B928B92800a8T8P00`000<SPf4R@R00=B92800@0000H]<0H]<38h=P>B928
00<0000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0800800
2i^WlOooojRMb?oook>YdV1<VXij]WQU[ZRMb?ooooomo`03oooo00<c@jD0
080008000`00P0@00H0300:01003P@@0184200F100<01H801X801X800P06
PP801h800`47PP48PP48PP020@R31049P`<12X<0104;P`4;Q04;Q04;Q0@1
38@30@f400@13XGoooooooooool30Pn5108@Q@@24HH30Q:60`8CQP040Q>7
0QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<3
6XT40a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4122;0`@QR`@48X`4
12><0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5
:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946
<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087
=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D3
23fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3
V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX3
2T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:
DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l4
2eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R
0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@3
3FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`03
3W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ
3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@
OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh4
4H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa
4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?
/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<D
UkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN
^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@F
Yk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@04
5jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/kl26;C000?8h=R8
`;R8`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=
R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0P00P00>VjOaoooooooofmc/H4bJThFj/jWB_;SMH4bJVHnnYY_4b<?Ooooo
<d>U1P00P0?oool00`01P002P002P004oooo00D00h401840187oool01840
0P05P@0300F2oooooooo00;oool200N21?ooo`050@R30@V30@V3oooo0@V3
00812X<01oooo`4;P`4;Q04;Q?ooo`4<Q?ooo`020@b400@13HCoool13HCo
ool30@j500?oool23hD23hD0108@Q@@24HH30Q:60`8CQP040Q>70QB70QB7
0QB7108EQ`825XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^9
0`<LRP@37HX311j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@T
S00312B=12F=12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZ
SPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`
T@<6<I431S:A00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC
0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8
?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4
V0022DBH10U5V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<
V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M
0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJ
X0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=
HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iY
Y@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X
3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mg
ZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]
0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@A
Q:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa
11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`04
4i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf
0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP0
11FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk
00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G
[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G/kl26;C000C8h=R8`;R8`;R8
`;P6000018S0^003B9280000b>3H00:8`;P900000XS0^005B92800006;C0
6;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3002000jKYo7ooonl^=fISkkooooFdMgKg>cco_nVVlC^k_B5
M[2CQK[ooolc@jD4002000Soool00H000H000H3oool00X3oool00X0200>1
00Koool00h401840187oool0184200F100Soool01X801X801X;oool01h;o
ool11h820@R200H128?oool12H<12H?oool12H<20@Z300Ooool12h<12h@1
2hCoool138Coool00P4<Q0030@f4oooo0@f400Coool30Pn5108@Q@@24HH3
0Q:60`8CQP040Q>70QB70QB70QB7108EQ`825XL20aJ80`<GR0@368P010<I
R0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX311j:00@47X/47h/47h/47h/4
122;0`@QR`@48X`412><0P@TS00312B=12F=12F=00859Hd41BJ=00<59hd5
9hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZS`@5:hl31Bb?10H]T0<6;Y03
1Rn@00<6;i46<946<9400PH`T@<6<I431S:A00<6<Y86<i86<i800PHcTP03
1SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<010LhT`LhU0LhU0LhU0<7>I@4
1cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8?YH423nF0PQ0UP88@9L3246G
10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5V0032DJH2DJI2DJI00@9AiT4
2DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK00<:CY`:Ci`:Ci`00PY?W0<:
D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d22eBN10]EWP<;EYh010]GWP]G
W`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP00@<G:4<GJ4<GJ4<GJ4435jQ
0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeRX`<=Hj<43FBS00<=IJ<=IJ@=
IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V10i/YP8>KJH00`i]Y`i^Y`i^
Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP33g:X0PmcZ08?LjT43gBY0`me
Z@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[0a1jZ`<@Nj/00a1k[11l[11l
[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]4H2]4H2]008AP:d01161[A61
[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lAQ:l34HF_1166[`<BQk044XR`
0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;400a:</Q:=/Q:=/P024Xfb0Q:>
/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<CT[@44i>d0a>D]0044iFd4iFe
4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H00aBJ]aBK]aBK]`0259^g0aBL
]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP^AFP^@<EXKT45J:i11FS^P<E
Y;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`FZK`FZK`45ZZl0QJ[_08FZkd0
0aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h011N__P@G/;h35k6o11Nb_`<G
/kl26;C000C8h=R8`;R8`;R8`;P6000018S0^003B9280000b>3H00:8`;P0
0`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`004b>3HR<2h
R<2hR<2h0P0000B8`;P200000XS0^004B92800006;C06;C00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0<008003i^WlOoooiV?_YN:_=CCj>n//omf
NnjOZe]HYJJKa9JOdV1<V[bhgOoooc=3Y@03002000Soool00H000H000H3o
ool00X3oool00X0200>100Koool00h40187oool0187oool200F100Soool0
1X801X801X;oool01h;oool11h820@R200X128?oool12H?oool12H?oool1
2X?oool12X?oool20@^400?oool138Coool00P4<Q0040@f4oooo0@f4oooo
0`4>Q@<23hD40Q25108AQP<24XH30Q>600@24hL258L258L258L40QF70P8F
Q`835XP30aN810<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<4
7XX010@NR`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<00<498d49Hd4
9Hd00PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?
10D[S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y40
0`HbTPHcTPHcTP021S>B00<6=987=987=9800PLeTP87=I<31cJC10LgT`04
1cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPn
UP@8?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH
00<9AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/0
0`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;
E9h42eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:00
10aLX@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S
0`eSX`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH4
3VbV0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?
LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/3
47Z[0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdA
P:dAP:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64
[`<AQJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@03
4Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B
]0@CTk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P03
59Zg59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i
5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY
_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P04
5jnn11N`_P<G/Kl45k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P0
0038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R0000002
6;C000?8h=R8`;R8`;P00XS0^0800002R<2h0P0000>8`;P014R@R00001Rd
`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000ZKYo7ooonG
R[ajK:ZcanRYKZ38`mnCQKYKAY>ISkh2N6F^00A29hF_YL[ooolc@jD40020
0`01P003oooo00:000:000Coool01@03P@04POooo`04POooo`0200F100<0
1H;oooooool00_ooo`801h803@47PP48PP48PP48Poooo`49Poooo`49Pooo
o`4:Poooo`4:Poooo`020@^400?oool138Coool00P4<Q0030@f4oooo0@f4
00Coool30Pn5108@Q@@24HH30Q:60`8CQP040Q>70QB70QB70QB7108EQ`82
5XL20aJ80`<GR0@368P010<IR0<IR@<IR@<IR@<36XT40a^90`<LRP@37HX3
11j:00@47X/47h/47h/47h/4122;0`@QR`@48X`412><0P@TS00312B=12F=
12F=00859Hd41BJ=00<59hd59hh59hh010DXSP<5:Hh010DZSPDZS`DZS`DZ
S`@5:hl31Bb?10H]T0<6;Y031Rn@00<6;i46<946<9400PH`T@<6<I431S:A
00<6<Y86<i86<i800PHcTP031SBB1cBB1cBB0087=I821cFC0`LfT`@7=i<0
10LhT`LhU0LhU0LhU0<7>I@41cZD10LkU@<8?9D323fE00@8?IH8?YH8?YH8
?YH423nF0PQ0UP88@9L3246G10Q2U`88@iL00`U3V0U4V0U4V0022DBH10U5
V0032DJH2DJI2DJI00@9AiT42DRI0`U9VP@9BYX32T^J10Y<V`@:CI/22TjK
00<:CY`:Ci`:Ci`00PY?W0<:D9`22U6L0PYAW@8:DYd22e:M0`]CW@8;E9d2
2eBN10]EWP<;EYh010]GWP]GW`]GW`]GW`<;F9l42eVO10aJX0<<Fj0335bP
00@<G:4<GJ4<GJ4<GJ4435jQ0PaOX@8<Gj83362R0PaQXP8=HJ823F:R0PeR
X`<=Hj<43FBS00<=IJ<=IJ@=IJ@010eVY0@=Ij@33FRU10iYY@<>JZD43V^V
10i/YP8>KJH00`i]Y`i^Y`i^Y`023VjW10i_Y`033W2W3g2X3g2X00@?LJP3
3g:X0PmcZ08?LjT43gBY0`meZ@043gJY3gJZ3gJZ3gJZ10mgZP<@N:X447V[
0a1jZ`<@Nj/00a1k[11l[11l[00247b/0a1m[08@OZ`247j]0Q1o[@034Gn]
4H2]4H2]008AP:d01161[A61[Q61[Q61[P<APZh44H>^00@AQ:hAQ:lAQ:lA
Q:l34HF_1166[`<BQk044XR`0a:9/0044XVa4XZa4XZa4XZa11:;/@8BS;40
0a:</Q:=/Q:=/P024Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`044i2c11>A/`<C
T[@44i>d0a>D]0044iFd4iFe4iFe4iFe11BF]@<DUkD459Rf0aBI]P<DV[H0
0aBJ]aBK]aBK]`0259^g0aBL]`8DWKL25Ifh11FN^0<EWkP011FP^1FP^AFP
^AFP^@<EXKT45J:i11FS^P<EY;X45ZFj0aJV^`@FYk/35ZRk00@FZ;`FZK`F
ZK`FZK`45ZZl0QJ[_08FZkd00aJ/_AN/_AN/_@045jfm00<G[[dG[[hG[[h0
11N__P@G/;h35k6o11Nb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B928
0000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P00000
0QRd`003b>3HR<2hR<2h00>8`;P4000018S0^004B92800006;C06;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^08008000i^WlOooooooo`02oooo
00[o[K3oMW_icMCmkNkooonVVlB5M[2l^=gooolc@jD500200`01P004oooo
00:000:000:00P03P@03oooo00>1oooo00<018400oooo`05P@05PP0300J2
00Coool01h801h811h83oooo00T128<12H?oool12H?oool12X?oool12X?o
ool00P4;Q009oooo0@b4oooooooo0@b40@f4oooo0@f4oooo00813XD01?oo
o`8?Q@8?Q@8?Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL2
0QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:
0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@U
S@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5
:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`Hb
T@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC
00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF
23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9
AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>
V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM
0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aL
X00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=
HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[
YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X
0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111i
Z`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o
[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_
4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba
00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<3
4i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf
00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TE
X;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl
5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn
00@G[kh45k2n0aNa_`@G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@
R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000
008H]<000lSPf8S0^8S0^004R<2h0P0000F8`;P014R@R00001Rd`1Rd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000ZQ[?;icMCR9Scd]KoR
9ScdKGglhnWoooomkNko[K02oooo00<c@jD0080008001000P0<00H000ooo
o`02P002P003oooo0P03P@07oooo00B100B100B1oooo00F100F200?oool0
1006PP07PP07P_ooo`8128820@R300D12H?oool12H<12H?oool00P4:P`07
oooo0@^40@^4oooo0@b4oooo0@b400;oool20@f400<13XGoooooool00_oo
o`823hD40Q25108AQP<24XH30Q>600@24hL258L258L258L40QF70P8FQ`83
5XP30aN810<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX0
10@NR`@OR`@OR`@OR`@488/3126;10@RS0@48h`212B<00<498d49Hd49Hd0
0PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[
S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`Hb
TPHcTPHcTP021S>B00<6=987=987=9800PLeTP87=I<31cJC10LgT`041cRC
1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8
?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9
AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>
W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h4
2eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aL
X@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eS
X`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV
0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP2
3g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[
0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dA
P:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<A
QJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb
4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@C
Tk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg
59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i
0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY
_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn
11N`_P<G/Kl45k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038
h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C0
00?8h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P00=VjOaoNg^hRHlo_GhmhVGm69^
lj2^m69^oogoojf`o>?Yoooo<d>U00L00803006000Coool00X000X000X04
00>11004P@801H400`05PP06PP06PP0200J200<01h;oool11h800P48PP81
28<40@V30`4:P`040@^30@^40@^40@^4104<Q0<13H@40@j50`8?Q@@248D4
0Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR8
00@36HP36HT36HT36HT30aZ910<KR@<378X40af:0`@NRP0411j;11n;11n;
11n;10@PR`<48H/412:<10@SS08498`00`@TS@@US@@US@021BF=10DVS@03
1BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I03
1Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B0086
<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@3
1cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF10PoUP88@9H2242G
0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@04
2DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:
Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;
Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ
10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS
3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>
KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10md
Z@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@
O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@A
PJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`
11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=
/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@011>E
]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK
]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@E
XkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`2
5Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G
/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<0
0028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0
^002R<2h0P0000:8`;P200000hS0^004B92800006;C06;C00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^08008000i^WlOK8c>8V?002ojf`00OO92ko
Y9kf_<Go[K3^Nhcooolc@jD02000P0<00H001?ooo`02P002P002P0@00h44
00B10P05P@0300F200J200J200801X800`07P_ooo`47PP020@R200<128?o
ool12H<00`49P`<12X<0104;P`4;Q04;Q04;Q0@138@30@f4104>Q@<23hD4
0Q25108AQP<24XH30Q>600@24hL258L258L258L40QF70P8FQ`835XP30aN8
10<HR0040aV80aV90aV90aV90`<JR@@36hT30ab:10<MRP<47XX010@NR`@O
R`@OR`@OR`@488/3126;10@RS0@48h`212B<00<498d49Hd49Hd00PDUS@@5
9Xd00`DWS@DWSPDWSP041BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l4
1Rf@0`H^T0<6;i000`H_T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHcTPHc
TP021S>B00<6=987=987=9800PLeTP87=I<31cJC10LgT`041cRC1cRD1cRD
1cRD0`LiU0@7>Y@41c^E0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2242F
0PQ0U`<8@IL424:G0PQ3U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9AYT9
AYT010U7V@@9B9T32DVJ10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?
W0022TnL0`Y@W08:DI`22U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN0`]F
WP042eNN2eNO2eNO2eNO0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aMX@aM
X@aMX@@<GZ4235nQ0PaOXP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=I:<0
0`eUX`eUY0eUY0043FJT10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]YP03
3VfW3VjW3VjW008>KZL43VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X0Pmc
Z@@?M:T33gFY00@?MZT?MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`03
47^/47b/47b/008@O:`347f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d00Q60
[@044H6]4H6^4H6^4H6^0a62[P@APjh01164[Q64[a64[a64[`<AQJl44HJ_
0a:7/0@BR;034XV`00@BRK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb
008BSK824Xjb0Q>>/P034hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@34iBd
00@CUK@CUKDCUKDCUKD459Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g59^g
008DVkL359bg0QBM]`8EWKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@E
X[T45J>j0aFT^P@FYKX35ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`2
5Z^l0QJ[_@035Zbm5jbm5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`_P<G
/Kl45k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0
^0T00002R<2h00E8T8P0000H]<0H]<38h=P00hS0^0800004R<2h0P0000:8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
002000>KYo7icMCgRIL00_ooo`07ojf`hAHdogIkojBNhRHlohUo<d>U00P0
0803006000Coool00X000X000X0400>11004P@801H400`05PP06PP06PP02
00J20P07PPCoool00`48P`49P`49P`020@V30`4:P`040@^30@^40@^4oooo
104<Q0<13H@40@j50`8?Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8D
Q`@25HL20QJ70P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<3
78X40af:0`@NRP0411j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`0
0`@TS@@US@@US@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5
:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<943
1S6A0`HbT@031S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7
=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF
23jF23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P0
0PU4V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/4
2TfK0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;
Did22eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ03
35^P0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R
0PeRXP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD3
3VZU10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`
Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX3
47RZ111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@
Ojd00a5o[A60[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^
4HB_4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@B
Rk424Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@
/`@CTK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<D
VKH359Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@E
X;PEX;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`04
5ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm
5jjn5jjn00@G[kh45k2n0aNa_`@G/[l35k>o0QRd`003b>3HR<2hR<2h00^8
`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf00=
R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0P00P007VjOaoooolj2^m69^oooomhVGnLgD00;oool00o>P[_oooc=3Y@08
00201001P0<00X0400>11004P@801H400`05PP06PP06PP0200J20P07PP03
0@N20@R20@R2008128<40@V30`4:P`040@^30@^40@^40@^4104<Q0<13H@4
0@j50`8?Q@@248D40Q660`8BQP<24hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ7
0P<FR0<35hP40aR800@36HP36HT36HT36HT30aZ910<KR@<378X40af:0`@N
RP0411j;11n;11n;11n;10@PR`<48H/412:<10@SS08498`00`@TS@@US@@U
S@021BF=10DVS@031BN=1BN>1BN>00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl4
1B^?0`D/S`@6;I031Rj@0`H_T0031RnA1S2A1S2A0086<9431S6A0`HbT@03
1S:B1S>B1S>B0086<i800`HdTPLdTPLdTP021cFB0PLeT`<7=Y<41cNC00@7
>9<7>9@7>9@7>9@31cVD10LjU0@7>iD323bE0`PmU@0423fF23jF23jF23jF
10PoUP88@9H2242G0`Q1U`@8@YL224>G00<9@iP9A9P9A9P00PU4V0@9AIP0
0`U6V0U6V@U6V@042DNI10U8V@<9BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`03
2TjL2TnL2TnL008:Ci`32U2L0PYAW08:DId22U:M0P]BW@<;Did22eBM0P]D
WP@;EIh32eJN00@;Eih;Eil;Eil;Eil32eRO10]IW`@<FZ0335^P0`aLX004
35bQ35fQ35fQ35fQ10aNX@8<Gj4235nR0`aPXP8<HJ823F6R0PeRXP8=HZ<3
3F>S10eTX`033FFS3FFT3FFT00@=IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>
K:H23VfV00<>KJL>KZL>KZL00Pi^Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mb
Z08?LjP23g>Y10mdZ@<?MJT010mfZ@mfZPmfZPmfZP@?MjX347RZ111iZ`<@
NZ/347^[00<@Nj`@O:`@O:`00Q1l[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60
[A60[@024H2]00@APJdAPJhAPJhAPJh34H:^1163[P044HB^4HB_4HB_4HB_
0a65[`@AQZl34XN`11:8/0<BRK0011:9/A::/A::/A::/@@BRk424Xba00<B
S;8BSK8BSK800Q:=/P8BS[824hjb00<CSk8CSk<CSk<011>@/`@CTK<34i:d
11>C]0<CU;@011>E]1>E]A>E]A>E]@@DU[D359Ne11BH]P<DVKH359Zf00<D
V[LDVkLDVkL00QBK]`<DW;L259fg0QFM^0@EW[P35Inh00@EX;PEX;TEX;TE
X;T35J6i11FR^@@EXkX35JBj11JU^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl
5ZVl11JZ_08FZk`25Z^m00<F[;dG[;dG[;d011N]_@035jjm5jjn5jjn00@G
[kh45k2n0aNa_`@G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R000
0<SPf00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C06;C0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008002i^WlOoooon9Oooo
oo>P[_6CXOooooomoo>P[_oko3=3Y@0800201001P0<00X0400>11004P@80
1H400`05PP06PP06PP0200J20P07PP030@N20@R20@R2008128<40@V30`4:
P`040@^30@^40@^40@^4104<Q0<13H@40@j50`8?Q@@248D40Q660`8BQP<2
4hH0108CQ`8DQ`8DQ`8DQ`@25HL20QJ70P<FR0<35hP40aR800@36HP36HT3
6HT36HT30aZ910<KR@<378X40af:0`@NRP0411j;11n;11n;11n;10@PR`<4
8H/412:<10@SS08498`00`@TS@@US@@US@021BF=10DVS@031BN=1BN>1BN>
00@5:8h31BV>00@5:Xh5:Xl5:Xl5:Xl41B^?0`D/S`@6;I031Rj@0`H_T003
1RnA1S2A1S2A0086<9431S6A0`HbT@031S:B1S>B1S>B0086<i800`HdTPLd
TPLdTP021cFB0PLeT`<7=Y<41cNC00@7>9<7>9@7>9@7>9@31cVD10LjU0@7
>iD323bE0`PmU@0423fF23jF23jF23jF10PoUP88@9H2242G0`Q1U`@8@YL2
24>G00<9@iP9A9P9A9P00PU4V0@9AIP00`U6V0U6V@U6V@042DNI10U8V@<9
BIX42DZJ0`Y;VP@:C9/42TfK0PY>V`032TjL2TnL2TnL008:Ci`32U2L0PYA
W08:DId22U:M0P]BW@<;Did22eBM0P]DWP@;EIh32eJN00@;Eih;Eil;Eil;
Eil32eRO10]IW`@<FZ0335^P0`aLX00435bQ35fQ35fQ35fQ10aNX@8<Gj42
35nR0`aPXP8<HJ823F6R0PeRXP8=HZ<33F>S10eTX`033FFS3FFT3FFT00@=
IZ@43FNT0`eXY@@>JJD33VZU10i[YP@>K:H23VfV00<>KJL>KZL>KZL00Pi^
Y`@>KjL00`i`Y`m`Z0m`Z0043g6X0`mbZ08?LjP23g>Y10mdZ@<?MJT010mf
Z@mfZPmfZPmfZP@?MjX347RZ111iZ`<@NZ/347^[00<@Nj`@O:`@O:`00Q1l
[0<@OJ`247j/0Q1n[@8@Ojd00a5o[A60[A60[@024H2]00@APJdAPJhAPJhA
PJh34H:^1163[P044HB^4HB_4HB_4HB_0a65[`@AQZl34XN`11:8/0<BRK00
11:9/A::/A::/A::/@@BRk424Xba00<BS;8BSK8BSK800Q:=/P8BS[824hjb
00<CSk8CSk<CSk<011>@/`@CTK<34i:d11>C]0<CU;@011>E]1>E]A>E]A>E
]@@DU[D359Ne11BH]P<DVKH359Zf00<DV[LDVkLDVkL00QBK]`<DW;L259fg
0QFM^0@EW[P35Inh00@EX;PEX;TEX;TEX;T35J6i11FR^@@EXkX35JBj11JU
^P<FY[/45ZNk0aJX^`045ZRl5ZVl5ZVl5ZVl11JZ_08FZk`25Z^m00<F[;dG
[;dG[;d011N]_@035jjm5jjn5jjn00@G[kh45k2n0aNa_`@G/[l35k>o0QRd
`0o8h=P00`000<SPf<SPf00=b>3H00<0000H]<0H]<003lSPf00300006;C0
6;C000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P400200i^Wl@06oooo
lj2^m;Fom[c5nmWJ<d>U2@00P0@00H0300:01003P@@0184200F100<01H80
1X801X800P06PP801h800`47PP48PP48PP020@R31049P`<12X<0104;P`4;
Q04;Q04;Q0@138@30@f4104>Q@<23hD40Q25108AQP<24XH30Q>600@24hL2
58L258L258L40QF70P8FQ`835XP30aN810<HR0040aV80aV90aV90aV90`<J
R@@36hT30ab:10<MRP<47XX010@NR`@OR`@OR`@OR`@488/3126;10@RS0@4
8h`212B<00<498d49Hd49Hd00PDUS@@59Xd00`DWS@DWSPDWSP041BR>0`DY
SP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i000`H_T@H`T@H`
T@021S2A0`HaT@<6<Y400`HbTPHcTPHcTP021S>B00<6=987=987=9800PLe
TP87=I<31cJC10LgT`041cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E0`PlU@<8
?ID010PmUPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8@IL424:G0PQ3U`032D>H
2DBH2DBH0089A9P42DFH00<9AYP9AYT9AYT010U7V@@9B9T32DVJ10U:VP<:
BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`22U6M0PYB
W@8;DYd32e>M0P]DW@8;E9h42eFN0`]FWP042eNN2eNO2eNO2eNO0`]HW`@;
FIl435ZP0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ0PaOXP<<H:82
366R0PeQXP8=HZ823F:S0`eSX`@=I:<00`eUX`eUY0eUY0043FJT10eWY0<=
J:D43VVU0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW3VjW008>KZL43VnW00<>
L:L?L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?MZX?MZX?
MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/47b/008@O:`347f/0Q1n
[08@OZd247n]00<AOjdAP:dAP:d00Q60[@044H6]4H6^4H6^4H6^0a62[P@A
Pjh01164[Q64[a64[a64[`<AQJl44HJ_0a:7/0@BR;034XV`00@BRK4BR[4B
R[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P034hnb4hnc
4hnc00@CT;<44i6c0a>B]0@CTk@34iBd00@CUK@CUKDCUKDCUKD459Je0aBG
]@@DV;H359Vf0aBJ]P0359Zg59^g59^g008DVkL359bg0QBM]`8EWKP45Ijh
0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX35ZJk11JW
^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm5jbm00@G
[Kd00aN^_AN^_QN^_P045jnn11N`_P<G/Kl45k:o0aNc_cHH]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h5P00P0@00H0300:01003P@@0184200F1
00<01H801X801X800P06PP801h800`47PP48PP48PP020@R31049P`<12X<0
104;P`4;Q04;Q04;Q0@138@30@f4104>Q@<23hD40Q25108AQP<24XH30Q>6
00@24hL258L258L258L40QF70P8FQ`835XP30aN810<HR0040aV80aV90aV9
0aV90`<JR@@36hT30ab:10<MRP<47XX010@NR`@OR`@OR`@OR`@488/3126;
10@RS0@48h`212B<00<498d49Hd49Hd00PDUS@@59Xd00`DWS@DWSPDWSP04
1BR>0`DYSP041BZ>1BZ?1BZ?1BZ?10D[S`<5;8l41Rf@0`H^T0<6;i000`H_
T@H`T@H`T@021S2A0`HaT@<6<Y400`HbTPHcTPHcTP021S>B00<6=987=987
=9800PLeTP87=I<31cJC10LgT`041cRC1cRD1cRD1cRD0`LiU0@7>Y@41c^E
0`PlU@<8?ID010PmUPPnUPPnUPPnUP@8?iH2242F0PQ0U`<8@IL424:G0PQ3
U`032D>H2DBH2DBH0089A9P42DFH00<9AYP9AYT9AYT010U7V@@9B9T32DVJ
10U:VP<:BiX42TbK10Y=V`8:CY/00`Y>W0Y?W0Y?W0022TnL0`Y@W08:DI`2
2U6M0PYBW@8;DYd32e>M0P]DW@8;E9h42eFN0`]FWP042eNN2eNO2eNO2eNO
0`]HW`@;FIl435ZP0`aKX0<<G:0010aLX@aMX@aMX@aMX@@<GZ4235nQ0PaO
XP<<H:82366R0PeQXP8=HZ823F:S0`eSX`@=I:<00`eUX`eUY0eUY0043FJT
10eWY0<=J:D43VVU0`iZY@@>JjH43VbV0Pi]YP033VfW3VjW3VjW008>KZL4
3VnW00<>L:L?L:P?L:P010maZ0<?LZP23g>X0PmcZ@@?M:T33gFY00@?MZT?
MZX?MZX?MZX43gNZ0a1hZP@@NJ/347Z[0a1kZ`0347^/47b/47b/008@O:`3
47f/0Q1n[08@OZd247n]00<AOjdAP:dAP:d00Q60[@044H6]4H6^4H6^4H6^
0a62[P@APjh01164[Q64[a64[a64[`<AQJl44HJ_0a:7/0@BR;034XV`00@B
RK4BR[4BR[4BR[444X^a0Q:</@034Xbb4Xfb4Xfb008BSK824Xjb0Q>>/P03
4hnb4hnc4hnc00@CT;<44i6c0a>B]0@CTk@34iBd00@CUK@CUKDCUKDCUKD4
59Je0aBG]@@DV;H359Vf0aBJ]P0359Zg59^g59^g008DVkL359bg0QBM]`8E
WKP45Ijh0aFO^0045J2h5J2i5J2i5J2i0aFQ^@@EX[T45J>j0aFT^P@FYKX3
5ZJk11JW^`<FZ;/011JX_1JY_1JY_1JY_0@FZ[`25Z^l0QJ[_@035Zbm5jbm
5jbm00@G[Kd00aN^_AN^_QN^_P045jnn11N`_P<G/Kl45k:o0aNc_cHH]<02
R<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;SoR<2hf8S0^058T8P10000
00000hS0^<SPf8S0^03oR<2hohS0^=R8`;P1B9280@00000000>8`;S8h=S8
h=P0olSPf?o8h=SHb>3H0DR@R04000000?n8`;SoR<2hg8S0^04000000001
\
\>"], "Graphics",
  ImageSize->{731, 409},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;N0001Z2000`400?l00000o`00003oooo`l?3o
oo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`
003ooo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?oo
l?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?00
0?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?000?ool?3`ooo`
l?3Poo3`l000ooooooooooooon3ooooo0002onk^k_ooU9BDoonDU9CMoiBDU07ok^k^0002onKViP03
oiBDU?oVi^Koi^KV0?ooi^KVoooVi^KIonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0
ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3ooooooooooooofOoo
ool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h0
00;oi^KV00?oU9BDonKVi_oVi^H0oooVi^KoonKVi]Woi^KV0OnDU9@1onKViP000_o^k^h00onDU9Co
k^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oooooo
oooooooIooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnD
U9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP3oonKVi_ooi^KVfOoVi^H1oiBDU07oi^KV0002onk^
kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDoooooooo
ool0ooooooooooooomWooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^
fOo^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV0?ooi^KVoooVi^KIonKViP7oU9BD0OoV
i^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP000_ooool00onD
U9Coooooooooo`3ooooooooooooofOooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?oo
k^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^KoonKVi]Woi^KV
0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002
ooooo`03oiBDU?oooooooooo0?oooooooooooooIooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^
k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP3oonKVi_oo
i^KVfOoVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD
0Oo^k^h000;ooooo00?oU9BDooooooooool0ooooooooooooomWooooo0OnDU9@1ooooo`000_o^k^h0
0onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV
0?ooi^KVoooVi^KIonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wo
k^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3ooooooooooooofOooool1oiBDU07ooooo
0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BD
onKVi_oVi^H0oooVi^KoonKVi]Woi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^
k_ook^k^fOo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oooooooooooooIooooo`7o
U9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP000_oV
i^H00onDU9Coi^KVonKViP3oonKVi_ooi^KVfOoVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^ko
k^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0oooooooooooo
omWooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07o
k^k^0002onKViP03oiBDU?oVi^Koi^KV0?ooi^KVoooVi^KIonKViP7oU9BD0OoVi^H000;ok^k^00?o
U9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3o
oooooiOooooo0_ono_h02_olo?conOWiooKfm_obl_;okNg]onSXj?oShn?oh>3PomgMgOoKfm/2om[J
fSGofMWI0_oJf]X02_oKfm_ogMgMon3Ph?oShn?oj>SXong]kOobl_;om_KfooWinOolo?`2ooknoYWo
oooo0_ono_h02_olo?conOWiooKfm_obl_;okNg]onSXj?oShn?oh>3PomgMgOoKfm/2om[JfSGofMWI
0_oJf]X02_oKfm_ogMgMon3Ph?oShn?oj>SXong]kOobl_;om_KfooWinOolo?`2ooknoPKooooo0OnD
U9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP3oonk^kYKok^k^0_o]kNd02_oZj^[oj>SXon;Rh_oM
gMgoe]KFolg=cOo6a/Ko_[jnokZj^_nf][H4ok>c/c?o/[:b1?nc/k<02_nf][Ko^[Zjokjn__o6a/Ko
cLg=omKFe_oMgMgoh^;RonSXj?oZj^X2ong]kIOok^k^0_o]kNd02_oZj^[oj>SXon;Rh_oMgMgoe]KF
olg=cOo6a/Ko_[jnokZj^_nf][H4ok>c/c?o/[:b1?nc/k<02_nf][Ko^[Zjokjn__o6a/KocLg=omKF
e_oMgMgoh^;RonSXj?oZj^X2ong]k@Gok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP3o
onKViYKoi^KV00koiNGUon;Rh_oOgmoof][Jom;Bd_o7alOo_Kfmok:b/_nXZ:SoX:2Poi^KVonHV9So
U9BDoi>CTcOoTY:B00goTi>CoiBDU?nHV9SoVi^Koj2PX?nXZ:So/[:bokfm_Oo7alOod];Bom[Jf_oO
gmooh^;R00;oiNGUU_oVi^H03_oUiNGoh^;RomoOgooJf][od];BolO7aonm_Kgo/[:bojRXZ?nPX:3o
Vi^KoiRHV?nDU9CoTi>C=onBTY803OnCTi?oU9BDoiRHV?nKVi_oX:2PojRXZ?nb/[;o_KfmolO7aooB
d];of][JomoOgooRh^800_oUiND4onKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^
k^jFonk^kP0>on_[jooXj>Soh^;RomSHf?o;bl_o_[jnojj^[_nQXJ7oUIFEohb<S?n5QHGoPX:2ogmo
OomnOWhgogemO@0?oginO_moOgooPX:2ohF5QOn<S8coUIFEoj6QXOn^[Zko_[jnol_;booHf=Soh^;R
onSXj?o[jn_okNg]09Kok^k^00kojn_[onSXj?oRh^;of=SHol_;bonn_[ko[Zj^oj6QXOnEUIGoS8b<
ohF5QOn2PX;oOgmooginOSOoOGem00ooOWinogmoOon2PX;oQHF5ohb<S?nEUIGoXJ6Qojj^[_nn_[ko
bl_;omSHf?oRh^;oj>SXon_[joo]kNd01?o^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo
0?ooooooU_ooool05?oinOWolo?conWYjOoIfMWoalO7okBd]?nRXZ;oVYZJojZZZ_o3`l?ofMWIonc/
k?ofm_KomoOgooWinOohn?SonOWioo[jn_oinOWomoOg0oohn?P2ooWin@03oo[jn_oinOWomoOg00?o
n?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03
oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi01?on_[jooWinOoh
n?SonOWiooShn?ogmoOok^k^om[Jf_o4a<CoZZZZoiZJV_nRXZ;o];BdolO7aooIfMWojNWYoo?clooi
nOWooOgm09Kooooo01ConOWioo?clooYjNWofMWIolO7aond];CoXZ:RoiZJV_nZZZ[o`l?3omWIfOo/
k>com_KfooOgmooinOWon?ShooWinOojn_[onOWiooOgm`?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@0Coo[jn_oinOWo
n?ShooWinOohn?SomoOgonk^k_oJf][oa<C4ojZZZ_nJVY[oXZ:RokBd]?o7alOofMWIonWYjOoclo?o
nOWioogmo@04ooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^jFonk^kP0<onGU
iOoMgMgoc/k>okfm_OnXZ:SoUIFEojFUYOo<c<cok^k^ooKfm_olo?coo_kn>oooool03Oono_koo?cl
ooOgmoo_knoocLg=ojJVY_nEUIGoZ:RXokfm_Oo>c/kogMgMonGUiOoZj^X0U_o^k^h03?oUiNGogMgM
olk>c_nm_KgoZ:RXoiFEUOnUYJGoc<c<onk^k_ofm_Koo?clooknoS_ooooo00goo_knooclo?ogmoOo
kno_olg=cOnVYZKoUIFEojRXZ?nm_Kgoc/k>omgMgOoUiNGoj^[Z00Cok^k^0OnDU9@1onk^kP000_oV
i^H00onDU9Coi^KVonKViP3oonKViYKoi^KV00[of][Jolk>c_nm_KgoZ:RXoiJFU_n[Zj_og]kNon_[
joodm?Cono_k?oooool02ookno_olo?conc/k?oQhN7o[Zj^oiJFU_nXZ:So_Kfmolk>c_oJf][oh>3P
09Koi^KV00[of][Jolk>c_nm_KgoZ:RXoiJFU_n[Zj_og]kNon_[joodm?Cono_k?oooool02ookno_o
lo?conc/k?oQhN7o[Zj^oiJFU_nXZ:So_Kfmolk>c_oJf][oh>3P00Coi^KV0OnDU9@1onKViP000_o^
k^h00onDU9Cok^k^onk^kP3oonk^kYKok^k^00[ogMgMolg=cOnh^;SoXJ6QojRXZ?oDe=Coh>3Ponc/
k?oemOGooOgm?oooool02oono_kom_Kfonc/k?oRh^;ofMWIojb/[?nQXJ7o^;Rholg=cOoMgMgoiNGU
09Kok^k^00[ogMgMolg=cOnh^;SoXJ6QojRXZ?oDe=Coh>3Ponc/k?oemOGooOgm?oooool02oono_ko
m_Kfonc/k?oRh^;ofMWIojb/[?nQXJ7o^;Rholg=cOoMgMgoiNGU00Cok^k^0OnDU9@1onk^kP000_oo
ool00onDU9Coooooooooo`3ooooooiKooooo00_oj>SXomCDe?nj^[[oZJVYolK6a_oDe=Coh>3Ponc/
k?obl_;oo?clooknoP0Pooooo`03onKVi_oAdM7onOWi01_ooooo00_on_[jooCdm?oZj^[ohn?SomOG
eoo=cLgo[:b/okZj^_oDe=Coj>SXoo?cl`2Fooooo`0;onSXj?oDe=Co^[ZjojVYZOo6a/Koe=CDon3P
h?o/k>col_;booclo?ono_h09Oooool00ooYjNWogmoOooooo`0Fooooo`0;oo[jn_odm?Coj^[Zon?S
hooGemOocLg=ojb/[?nj^[[oe=CDonSXj?oclo<01?ooool1oiBDU07ooooo0002onk^kP03oiBDU?o^
k^kok^k^0?ook^k^U_o^k^h03ooDe=Co_knoojJVY_n/[:coa/K6om;Bd_oLg=coi^KVonc/k?oemOGo
n?Shoo[jn_omoOgoooooooclo008ooooo`03oogmoOoooooooooo00Gooooo00GooOgmoooooooooooo
ooooocHf=P02o`00000:oa4A4Om5ADGohN7QoooooommOGgo5aLGocdm?OlH61SoPh>3oogmo@Oooooo
00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`02ooooo`0@oogmoOoooooooOgmoo_knooh
n?Som?Cdong]kOoVi^KogmoOomKFe_o<c<co/[:bojNWYono_kooe=CDon;RhYKok^k^00ooe=CDokno
_onVYZKo[:b/olK6a_oBd];og=cLonKVi_o/k>comOGeooShn?ojn_[ooOgmooooooolo?`02?ooool0
0oomoOgoooooooooo`05ooooo`0=ocDe=Ol0003o0000oa4A4Om6ATKohN7QoooooooemOGo3Ph>o``<
3?l0003o3Ph>oaHF5P02ooooo`06oogmoOmQHF7o7alOob`/;?lj>S[ok^k^0oooool00oomoOgooooo
ooooo`05ooooo`03oogmoOoooooooooo00;ooooo013ooOgmooooooomoOgono_kooShn?odm?CokNg]
onKVi_oOgmooe]KFolc<c?nb/[;oYjNWokno_ooDe=Coh^;R1?o^k^h1oiBDU07ok^k^0002onKViP03
oiBDU?oVi^Koi^KV0?ooi^KVU_oVi^H04oo:b/[o]KFeoijNW_nf][Ko`l?3olo?cooFe]KogmoOonKV
i_oZj^[okno_oo?cloodm?ComOGeooOgmoofm_KomoOgooKfm_ohn?P00_ogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`0:ooKfm_ohn?So=3@dog=cLooalO7ocLg=obHV9_mHF5So
m_Kfoo3`l0;omoOg00Kohn?SobPX:?n;Rh_omoOgooKfm_ohn?P2ooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg01?om_KfooShn?ofm_KomoOgooKfm_odm?Col_;boo3`l?o[jn_o
i^KVon7QhOoJf][odm?ColW9bOno_kooXj>SokFe]Oo:b/[ofMWI09Koi^KV01?ob/[:okFe]OnNWYko
][Jfol?3`oo?clooe]KFomoOgooVi^Koj^[Zono_kooclo?om?CdooGemOogmoOom_KfooOgmoofm_Ko
n?Sh00;omoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf00Ko=3@dog=cLooalO7oclo?
obHV9_mHF5P2ooKfmP04ooOgmoo>c/ko0000on7Qh@;omoOg00Som_Kfohb<S?la<C7olO7aooKfm_mN
GUkoE5ADooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg01?om_KfooShn?of
m_KomoOgooKfm_odm?Col_;boo3`l?o[jn_oi^KVon7QhOoJf][odm?ColW9bOno_kooXj>SokFe]Oo:
b/[ofMWI00Coi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^kYKok^k^00_od=3@
okRh^?nPX:3o/k>col30`?o9bLWodm?ComWIfOoMgMgoh^;RonGUi@02on[ZjP03onc/k?o]kNgokNg]
00Ook^k^00?ol?3`onk^k_o^k^h01Oo^k^h01_o`l?3ok^k^onk^k_o^k^ko<S8bofm_K`;ok^k^00?o
IFEUobHV9_o^k^h01?o^k^h00ommOGgo5aLGonSXj006onk^kP03oo3`l?o^k^kok^k^00Gok^k^00Co
l?3`onk^k_o^k^kok^k^0_o]kNd2onc/k00=onWYjOoVi^Kohn?Son3Ph?oKfm_oeMGEolg=cOo5aLGo
^k^kojNWYonh^;Sod=3@on3Ph02Fonk^kP0;om3@d?nh^;SoX:2Pok>c/oo0`<3obLW9om?CdooIfMWo
gMgMon;Rh_oUiND00_oZj^X00oo/k>cokNg]ong]k@07onk^kP03oo3`l?o^k^kok^k^00Gok^k^00Ko
<S8bofm_Koo^k^kok^k^ofATI?lV9RH2onk^kP04oo3`l?o6a/Ko0000omSHf0?ok^k^00Oo92@Tohf=
SOo^k^kok^k^ol71`Ol30`?oemOG00;ok^k^00?ol?3`onk^k_o^k^h01Oo^k^h01?o`l?3ok^k^onk^
k_o^k^h2ong]k@;ok>c/00gojNWYonKVi_oShn?oh>3Pom_KfooEeMGocLg=olG5aOnk^k_oYjNWokRh
^?o@d=3oh>3P00Cok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3ooooooiKooooo00go
gmoOolG5aOnNWYko[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoOgooQhN7oh^;R00;ohn?S1ooU
iND2onKViPKoiNGU0_oVi^H3onGUi@06oc0`<?mZJV[oiNGUolk>c_l<30coLG5a0_oUiND01_nNWYko
DU9BofUYJOnKVi_o0000okZj^PGoiNGU0_oVi^H6onGUi@;oi^KV0ooUiND2onCTi0;ohn?S00goh^;R
on3Ph?oLg=cofMWIomKFe_o@d=3obLW9ol71`One]KGoYjNWolG5aOoOgmool?3`09Kooooo00gogmoO
olG5aOnNWYko[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoOgooQhN7oh^;R00;ohn?S1ooUiND2
onKViPKoiNGU00Soi^KVoc0`<?mZJV[oiNGUolg=cOl<30coLG5aonGUi@;oi^KV00?o_knoo`000?o@
d=000_oUiND00ooLg=co0000ojj^[P02onGUi@04on7QhOl0003oZ:RXonGUi@;oi^KV1_oUiND2onKV
iP?oiNGU0_oTi>@2on?Sh`0=on;Rh_oPh>3og=cLomWIfOoFe]Kod=3@olW9bOo1`L7o]KFeojNWYoo5
aLGogmoOoo3`l004ooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^jFonk^kP0=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h04?oMgMgo
;Rh^ob/[:olf=SKo4a<CohB4Q?oLg=cog]kNohJ6Q_l?3`ooNGUiohb<S?li>CWo0000oiVIVOoNg]h3
omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP;ogMgM0_oLg=`0
3_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7QU_o^
k^h03OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=`2omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@09omkNg_oMgMgo;Rh^ob/[:olf=SKo
4a<CohB4Q?oKfm_og]kN00;ogMgM00?o^KVio`000?o9bLT00_oMgMd00onn_[ko0000okJf]P02omkN
gP04omgMgOl;2`_oRh^;omkNgP;ogMgM0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0_oMgMd2
omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7AdOoQ
hN44onk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^JFonKViP0=olg=cOni^KWo
S8b<oijNW_n][Jgo^KViol;2`_o7alOoc<c<om3@d?oBd];oeMGEomKFeP02omOGe`03omSHf?oIfMWo
fMWI017ofMWI00Wo;Bd]odY:B_mmOGgo=SHfofIVI_oEeMGofMWIoa`L7?mUIFD00_oIfMT00onQXJ7o
0000oi>CT`0BomWIf@;of=SH0_oGemL03OoEeMGodm?Com3@d?o>c/kob/[:olG5aOno_koo]KFeojVY
ZOnHV9So^KViolg=cOoKfm/0U_oVi^H03Oo=cLgo^KViohb<S?nNWYko[Jf]okVi^Oo2`/;oalO7olc<
c?o@d=3od];BomGEeOoFe]H00_oGemL00ooHf=SofMWIomWIf@0=omWIf@06obd];Om:BT[oOGemocHf
=_mVIVKoeMGE0ooIfMT00one]KGo0000olG5a@02omWIf@03olO7aol0003oZj^[00?ofMWI00?o10@4
oiBDU?oIfMT03OoIfMT2omSHf0;oemOG00goeMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo_knookFe]OnY
ZJWoV9RHokVi^Oo=cLgofm_K00Coi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^
kYKok^k^00gof=SHolK6a_n9RHWoTi>Coj:RX_n_[joo^[Zjol71`Oo7alOobl_;olk>c_o@d=3odM7A
00;odm?C0ooDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oE
eM@2omCDe00@omGEeOl];BgoHf=SomGEeOo6a/Ko20P8oiJFU_oDe=Co1`L7oi:BT_oFe]KoeMGEokBd
]?l0003oZ:RXomCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD04?oDe=Codm?Com?CdooAdM7od=3@olg=cOo:b/[o`l?3okjn__nf][KoZj^[
oifMWOnBTY;oa/K6omSHf?oRh^:Fonk^kP0=omSHf?o6a/KoRHV9oi>CTonRXZ;o[jn_okZj^_o1`L7o
alO7ol_;boo>c/kod=3@om7Ad@02om?Cd`?oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE01Coe]KFomGEeOoFe]Ko;Bd/of9RH_oDe=CoaLG5o`P82?nGUiOoeMGEomKFe_oEeMCo/K6ao`00
0?o1`L7oeMGEomKFe_oEeMGo20P8oi6AT0;oe=CD00Koa<C4o`000?n^[ZkoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@0@omCDe?oCdm?odm?Com7AdOo@d=3ocLg=
ol[:b_o3`l?o_[jnokJf]_n[Zj_oWIfMoi:BT_o6a/Kof=SHon;RhPCok^k^0OnDU9@1onk^kP000_oo
ool00onDU9Coooooooooo`3ooooooiKooooo01;okNg]omcLg?nEUIGoRHV9oiNGUonUYJGo/[:bokno
_oo;bl_odM7AomGEeOoGemOofMWIom[Jf_oKfm_of][Jom_KfooLg=`7om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00_og=cLom_Kfol^;RkoIVIVom_Kfoo7alOo20P8og]kNooLg=co<30`ofMWI`02om_Kf`04
ogYjN_lH61SoemOGomcLg0Oofm_K00?og=cLom_KfooKfm/01OoKfm/04ooLg=cofm_Kom_KfooKfm_o
f][JomWIfOoHf=Soe]KFom?Cdoo=cLgo`/;2okJf]_n/[:coWinOoi2@T?nKVi_og=cLong]kOofm_H0
U_ooool04_o]kNgog=cLoiFEUOn9RHWoUiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooIfMWo
f][Jom_KfooJf][ofm_KomcLg0Oofm_K00?og=cLom_KfooKfm/00ooKfm/03?l^;RkoIVIVomcLg?o7
alOo20P8og]kNooKfm_of][JomKFe_nf][Ko0000olO7a`?ofm_K00KoEEEEoeADE?oKfm_og=cLohR8
R?lT92@5om_Kf`03omcLg?oKfm_ofm_K00Gofm_K01?og=cLom_KfooKfm_ofm_Kom[Jf_oIfMWof=SH
omKFe_oCdm?ocLg=ol;2`_nf][Ko[:b/oinOWon@T93oVi^KomcLg?o]kNgom_Kf00Cooooo0OnDU9@1
ooooo`000_o^k^h00onDU9Cok^k^onk^kP3oonk^kYKok^k^00_oh^;RomKFe_nPX:3oNWYjohR8R?nF
UYKoZZZZolC4a?oEeMGofm_KomkNgP02on3Ph0?oh^;R00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`0AonCTi?oShn?ohn?Soc0`<?lY:BWoA4A4oa8B4_lG5aOoemOGon?Shon][Jgo
4a<CofYZJ_mTI6Co2PX:oiFEUOoTi>@01ooShn<00ooTi>Cohn?Son?Sh`05on?Sh`04onCTi?oShn?o
hn?Son?Sh`;oh^;R00kohN7Qon3Ph?oOgmoog=cLomOGeoo5aLGo[:b/oijNW_n@T93oPX:2ojBTY?oF
e]Koh^;RonSXj9Kok^k^00_oh^;RomKFe_nPX:3oNWYjohR8R?nFUYKoZZZZolC4a?oEeMGofm_KomkN
gP02on3Ph0?oh^;R00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`04on?Sh`0<oc0`<?lZ
:R[oA4A4oa8B4_lG5aOoe]KFon?ShooJf][o4A4Aobl_;ol0003oc/k>0ooShn<01_o6a/Ko6ATIofe]
KOn2PX;o5QHFojBTY0Cohn?S00?oi>CTon?ShooShn<01OoShn<01?oTi>Cohn?Son?ShooShn<2on;R
hP0>on7QhOoPh>3ogmoOomcLg?oGemOoaLG5ojb/[?nNWYkoT92@oh:2P_nTY:Coe]KFon;Rh_oXj>P4
onk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^JFonKViP0>omgMgOoFe]Ko_;bl
ogYjN_mhN7SoQXJ6oinOWoo5aLGof=SHomgMgOoOgmoohN7Qon;Rh_oShn<3onCTi0CoiNGU0_oTi>@0
0ooUiNGoi>CTonGUi@03onGUi@;oi>CT00[oiNGUonCTi?oUiNGoiNGUoijNW_n:RX[oSHf=okVi^OoS
hn?oi>CT0_oUiND01_o0`<3oKVi^ofYZJ_na/K7oiNGUonCTi0CoiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00CoiNGUonCTi?oUiNGoiNGU0ooTi>@03_oShn?ohN7Qon3Ph?oOgmoof][JolK6
a_nQXJ7oSHf=oh20P?n3Ph?o_KfmomKFe_oMgMgoh^;RU_oVi^H03_oMgMgoe]KFokbl_?mjNW[oN7Qh
ohJ6Q_nOWiooaLG5omSHf?oMgMgogmoOon7QhOoRh^;ohn?S0ooTi>@4onGUi@;oi>CT00?oiNGUonCT
i?oUiND00ooUiND2onCTi006oijNW_n9RHWoSHf=okZj^_oShn?oiNGU0_oTi>@01?oOgmoo[jn_ogIf
M_oHf=P2onGUi@;oi>CT00Cob/[:ogMgMom[Jf_o]kNg0_oUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@01?oUiNGoi>CTonGUiOoUiND3onCTi00>on?ShooQhN7oh>3PomoOgooJf][oa/K6oj6Q
XOn=SHgoP820oh>3Ponm_Kgoe]KFomgMgOoRh^84onKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^
k_o^k^h0ooo^k^jFonk^kP0;onSXj?oRh^;ofMWIoinOWomUIFGoLg=cohf=SOnk^k_oe=CDom[Jf_oM
gMd00_oOgml00ooPh>3ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQ
hN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQ
hN401OoQhN400ooRh^;ohN7Qon7Qh@06on7Qh@0>on3Ph?oOgmoogMgMomcLg?oEeMGo^KViohj>S_mk
Ng_oKVi^oj:RX_oIfMWoh^;RonSXj?o/k>bFonk^kP0;onSXj?oRh^;ofMWIoinOWomUIFGoLg=cohf=
SOnk^k_oe=CDom[Jf_oMgMd00_oOgml00ooPh>3ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00Go
hN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00Go
hN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@06on7Qh@0>on3Ph?oOgmoogMgMomcL
g?oEeMGo^KViohj>S_mkNg_oKVi^oj:RX_oIfMWoh^;RonSXj?o/k>`4onk^kP7oU9BD0Oo^k^h000;o
oooo00?oU9BDooooooooool0oooooonFooooo`0<ooclo?oinOWol_;bonOWionDU9CoHV9RogIfM_nT
Y:CoalO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg00Dom_KfooLg=cog=cLom_KfooLg=cofm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGo
W9bLogEeMOmWIfOoUiNGonOWioobl_;onOWiooclo?ono_jFooooo`0<ooclo?oinOWol_;bonOWionD
U9CoHV9RogIfM_nTY:CoalO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg00Dom_KfooLg=cog=cLom_KfooLg=cofm_Kom[Jf_oIfMWo
f=SHom?Cdoo5aLGoW9bLogEeMOmWIfOoUiNGonOWioobl_;onOWiooclo?ono_h4ooooo`7oU9BD0Ooo
ool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^jFonk^kP0>ong]kOoZj^[oinOWon;Rh_o?clooRXZ:
oeYJF_mkNg_oXj>Sokbl_?o6a/Kobl_;olg=cOo?cll2om7Ad@God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00?od];B0_oAdM403Oo@d=3oclo?olc<
c?o8b<So^k^koibLW?mbLW;oFe]Kohf=SOo?clooh^;RonOWiooZj^X00_o]kNfFonk^kP0>ong]kOoZ
j^[oinOWon;Rh_o?clooRXZ:oeYJF_mkNg_oXj>Sokbl_?o6a/Kobl_;olg=cOo?cll2om7Ad@God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00?od];B
0_oAdM403Oo@d=3oclo?olc<c?o8b<So^k^koibLW?mbLW;oFe]Kohf=SOo?clooh^;RonOWiooZj^X0
0_o]kNd4onk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^JFonKViP;oiNGU00ko
h^;Ron3Ph?oKfm_oeMGEoiRHV?m/K6coJ6QXoh>3PonGUiOoXj>Sojb/[?n_[joo/K6aok:b/P;o];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd01?o]KFeokJf]?nd];Co];BdokJf]_nc/k?o/[:b
ok>c/on_[jooZZZZoibLW?n2PX;oHV9Rofe]KOnKVi_oeMGEom_KfooPh>3oh^;R00;oiNGUUooVi^H2
onGUi@0>on;Rh_oPh>3ofm_KomGEeOnHV9SoK6a/ofQXJ?n3Ph?oUiNGoj>SXon/[:co[jn_ok6a/Onb
/[82okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]00CokFe]Onf][Co];BdokBd]?nf][Ko
/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9RH_m]KFgoVi^KomGEeOoKfm_oh>3Pon;RhP02onGU
i@Goi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^kYOok^k^0_o]kNd03oo[jn_o
j>SXonGUiOoRh^;obl_;oijNW_mmOGgoJf][ofATI?mYJFWoLW9bogAdM?miNGWoO7alog]kN`02ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00OoO7alog]kNomlO7coOGelogalO?mk
Ng_oOGem00;oNWYj00_oMgMgogAdM?m^KVkoLG5aogmoOonNWYkoc<c<on;Rh_oUiNGoj>SXon_[j`02
ong]kIWok^k^0_o]kNd03oo[jn_oj>SXonGUiOoRh^;obl_;oijNW_mmOGgoJf][ofATI?mYJFWoLW9b
ogAdM?miNGWoO7alog]kN`02ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Oo
O7alog]kNomlO7coOGelogalO?mkNg_oOGem00;oNWYj00_oMgMgogAdM?m^KVkoLG5aogmoOonNWYko
c<c<on;Rh_oUiNGoj>SXon_[j`02ong]k@Kok^k^0OnDU9@1onk^kP000_ooool00onDU9Cooooooooo
o`3ooooooiSooooo0_ono_h02OomoOgono_kooWinOofm_Kolo?coo;bl_o`l?3okno_onk^kP0iong]
k@09onk^k_o_knool?3`oo;bl_oclo?om_KfooWinOokno_ooOgm00;oo_knVoooool2ooknoP09oogm
oOokno_onOWiooKfm_oclo?ol_;boo3`l?o_knook^k^03WokNg]00Wok^k^ono_koo`l?3ol_;boo?c
loofm_KonOWioo_knoomoOd00_ono_h7ooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0
ooo^k^jJonk^kP;okNg]00?ok>c/on[Zj_oZj^X00_oXj>P2onOWicWoi^KV0_oWinL2onSXj0;oj^[Z
00?ok>c/ong]kOo]kNd0Woo^k^h2ong]k@03onc/k?oZj^[oj^[Z00;oj>SX0_oWinLionKViP;oinOW
0_oXj>P2on[ZjP03onc/k?o]kNgokNg]00Wok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKV
iP3oonKVi_ooi^KVfOoVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kI
onk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0ooooooooooooomWooooo0OnDU9@1oooo
o`000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002onKViP03oiBD
U?oVi^Koi^KV0?ooi^KVoooVi^KIonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^
k^koonk^k]Wok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3ooooooooooooofOooool1
oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;o
i^KV00?oU9BDonKVi_oVi^H0oooVi^KoonKVi]Woi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^
onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oooooooooo
oooIooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1
onk^kP000_oVi^H00onDU9Coi^KVonKViP3oonKVi_ooi^KVfOoVi^H1oiBDU07oi^KV0002onk^kP03
oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0
ooooooooooooomWooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^
k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV0?ooi^KVoooVi^KIonKViP7oU9BD0OoVi^H0
00;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP000_ooool00onDU9Co
ooooooooo`3ooooooooooooofOooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^
ooo^k^kIonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^KoonKVi]Woi^KV0OnD
U9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002oooo
o`03oiBDU?oooooooooo0?oooooooooooooIooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^
k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP3oonKVi_ooi^KV
fOoVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^
k^h000;ooooo00?oU9BDooooooooool0ooooooooooooomWooooo0OnDU9@1ooooo`000_o^k^h00onD
U9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV0?oo
i^KVoooVi^KIonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^
0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3ooooooooooooofOooool1oiBDU07ooooo0002
onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKV
i_oVi^H0oooVi^KoonKVi]Woi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_oo
k^k^fOo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oooooooooooooIooooo`7oU9BD
0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP000_oVi^H0
0onDU9Coi^KVonKViP3oonKVi_ooi^KVfOoVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^
0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0ooooooooooooomWo
oooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^
0002onKViP03oiBDU?oVi^Koi^KV0?ooi^KVoooVi^KIonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BD
onk^k_o^k^h01Oo^k^h00oo/k>cocLg=omKFeP06onk^kP03omGEeOo/k>cok^k^00Kok^k^00?ojn_[
omoOgoo^k^h01_o^k^h00ooEeMGok>c/onk^kP3oonk^k_ook^k^]_o^k^h1oiBDU07ok^k^0002oooo
o`03oiBDU?oooooooooo00Cooooo00Ko/;2`o`X:2_l=3@go92@TocHf=_nWYjL2ooooo`07om?CdolU
9BGo7QhNokZj^_oooooo@410ogmoO`03ooooo`06okno_olK6a_o1`L7oe9BD_n6QXKo<30`0_ooool0
1?oCdm?o9BDUoahN7_nj^[[ooooooooooooo]oooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^ko
k^k^00Cok^k^00_oalO7ok:b/_oYjNWok^k^oi:BT_l30`?oclo?onk^k_mYJFWo?3`long]k@02onk^
kP03oc/k>omfMWKok^k^00;ok^k^00KoCTi>oe=CDooVi^KoTi>Co`h>3_l/;2`2onk^kP03ofUYJOll
?3cokNg]0?ook^k^ooo^k^jhonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H02?oVi^H0
1_o:b/[o0000ojBTY?oVi^KoADE5ofIVIP?oi^KV00?o>CTiog9bL_oVi^H00_oVi^H01_lW9bOoPH61
onKVi_oVi^KoKVi^ob/[:`;oi^KV00?oADE5ofIVI_oVi^H0oooVi^KoonKVi[Soi^KV0OnDU9@1onKV
iP000_o^k^h00onDU9Cok^k^onk^kP07onk^kP07on3Ph?m9BDWo1`L7on7QhOo^k^koAdM7ofYZJP03
onk^kP03oc/k>omfMWKok^k^00;ok^k^00Ko:BTYohV9ROo^k^kok^k^ohF5QOl/;2`2onk^kP03odM7
AomZJV[ok^k^0?ook^k^ooo^k^jhonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool01_oo
ool01?nf][Ko71`LoaLG5onn_[h2ooooo`03ode=COmbLW;ooooo00;ooooo00?o@410ofUYJOooool0
0_ooool01_l/;2coTi>CooooooooooooShn?oc0`<0;ooooo00?oCDe=og9bL_ooool0oooooooooooo
okSooooo0OnDU9@1ooooo`000_o^k^h7oiBDU005onk^k_mhN7So0000oe1@D?oFe]H00_o^k^h03OoX
j>SoA4A4ofEUIOoShn?oj^[Zonk^k_lk>c_o4A4AohN7QooDe=Cok>c/obTY:On9RHT00_o^k^h02?n5
QHGo;2`/onk^k_oXj>SoA4A4ofEUIOoShn?oj^[ZoonDU9CooiBDU;SoU9BD0Oo^k^h000Woi^KV00?o
clo?o`410On4Q8@01?oVi^H03OmbLW;o1`L7o`X:2_lH61SoW9bLonKVi_m;Bd_oNg]koe=CDol820So
f=SHoc`l??n>SXh00_oVi^H02?n;Rh_o?cloonKVi_mbLW;o1`L7o`X:2_lH61SoW9bLoooVi^KoonKV
i[Woi^KV0009onk^kP03olW9bOl10@7oemOG00Gok^k^00?oAdM7ofYZJ_o^k^h01Oo^k^h00oo[jn_o
k^k^onk^kP07onk^kP03odM7AomZJV[ok^k^0?ook^k^ooo^k^jjonk^kP002_ooool01Om:BT[o>SXj
ohj>S_mRHV;oF5QH00;ooooo00?oh>3PomkNg_ooool03oooool00ooPh>3og]kNooooo`3ooooooooo
oooo^_ooool000[ok^k^00Goj^[ZojVYZOmVIVKoOWinok:b/P3oonk^k_ook^k^dOo^k^h00?ooi^KV
oooVi^KPonKViP00ooo^k^koonk^k^3ok^k^003oooooooooooooh?ooool00?ook^k^ooo^k^kPonk^
kP00oooVi^KoonKVi^3oi^KV0002onk^k_ooU9BDoonDU9CMoiBDU07ok^k^0002ooooo`03oiBDU?oo
oooooooo0?oooooooooooooIooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^ko
onk^k]Wok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP3oonKVi_ooi^KVfOoVi^H1oiBD
U07oi^KV0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;ooooo
00?oU9BDooooooooool0oooooonGooooo`;oo_kn00[oo?clooWinOofm_Kol_;bong]kOoXj>Sohn?S
on3Ph?oMgMgofm_K0_oJf]XeomWIf@;of][J00[ofm_KomgMgOoPh>3ohn?SonSXj?o]kNgol_;booKf
m_oinOWoo?cl0_ono_jIooooo`;oo_kn00[oo?clooWinOofm_Kol_;bong]kOoXj>Sohn?Son3Ph?oM
gMgofm_K0_oJf]XeomWIf@;of][J00[ofm_KomgMgOoPh>3ohn?SonSXj?o]kNgol_;booKfm_oinOWo
o?cl0_ono_h6ooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^jFonk^kP;okNg]
00[oj^[ZonSXj?oRh^;ogMgMomKFe_o=cLgoa/K6okjn__nj^[[o][Jf1?nc/k<cok:b/PCo/k>c00[o
][JfokZj^_nn_[koa/K6olg=cOoFe]KogMgMon;Rh_oXj>Soj^[Z0_o]kNfGonk^kP;okNg]00[oj^[Z
onSXj?oRh^;ogMgMomKFe_o=cLgoa/K6okjn__nj^[[o][Jf1?nc/k<cok:b/PCo/k>c00[o][JfokZj
^_nn_[koa/K6olg=cOoFe]KogMgMon;Rh_oXj>Soj^[Z0_o]kNd5onk^kP7oU9BD0Oo^k^h000;oi^KV
00?oU9BDonKVi_oVi^H0oooVi^JFonKViP0>onGUiOoRh^;ogmoOom[Jf_oBd];oalO7okfm_Onb/[;o
Z:RXoj2PX?nKVi_oV9RHoiBDU?nCTi<goi:BTP0=oi>CTonDU9CoV9RHoi^KVonPX:3oZ:RXok:b/_nm
_KgoalO7om;Bd_oJf][ogmoOon;RhP02onGUiIKoi^KV00koiNGUon;Rh_oOgmoof][Jom;Bd_o7alOo
_Kfmok:b/_nXZ:SoX:2Poi^KVonHV9SoU9BDoi>CTcOoTY:B00goTi>CoiBDU?nHV9SoVi^Koj2PX?nX
Z:So/[:bokfm_Oo7alOod];Bom[Jf_oOgmooh^;R00;oiNGU1?oVi^H1oiBDU07oi^KV0002onk^kP03
oiBDU?o^k^kok^k^0?ook^k^U_o^k^h03_o[jn_oj>SXon;Rh_oHf=Sobl_;okjn__n^[ZkoXJ6QoiFE
UOn<S8coQHF5oh:2P_moOgooOWin=ommOGd03omnOWkoOgmooh:2P_n5QHGoS8b<oiFEUOnQXJ7o[Zj^
okjn__o;bl_of=SHon;Rh_oXj>Sojn_[ong]k@2Fonk^kP0>on_[jooXj>Soh^;RomSHf?o;bl_o_[jn
ojj^[_nQXJ7oUIFEohb<S?n5QHGoPX:2ogmoOomnOWhgogemO@0?oginO_moOgooPX:2ohF5QOn<S8co
UIFEoj6QXOn^[Zko_[jnol_;booHf=Soh^;RonSXj?o[jn_okNg]00Cok^k^0OnDU9@1onk^kP000_oo
ool00onDU9Coooooooooo`3ooooooiKooooo01ConOWioo?clooYjNWofMWIolO7aond];CoXZ:RoiZJ
V_nZZZ[o`l?3omWIfOo/k>com_KfooOgmooinOWon?ShooWinOojn_[onOWiooOgm`?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@0Coo[jn_oinOWon?ShooWinOohn?SomoOgonk^k_oJf][oa<C4ojZZZ_nJVY[oXZ:RokBd]?o7
alOofMWIonWYjOoclo?onOWioogmo@2Fooooo`0DooWinOoclo?ojNWYomWIfOo7alOo];Bdoj:RX_nJ
VY[oZZZZol?3`ooIfMWok>c/ooKfm_ogmoOonOWiooShn?oinOWon_[jooWinOogmoL3ooShn0;onOWi
00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWi
ooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh
0_oinOT04oojn_[onOWiooShn?oinOWon?ShooOgmoo^k^kof][JolC4a?nZZZ[oVYZJoj:RX_nd];Co
alO7omWIfOoYjNWolo?cooWinOomoOd01?ooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^
0?ook^k^U_o^k^h03?oUiNGogMgMolk>c_nm_KgoZ:RXoiFEUOnUYJGoc<c<onk^k_ofm_Koo?clookn
oS_ooooo00goo_knooclo?ogmoOokno_olg=cOnVYZKoUIFEojRXZ?nm_Kgoc/k>omgMgOoUiNGoj^[Z
09Kok^k^00coiNGUomgMgOo>c/ko_KfmojRXZ?nEUIGoYJFUolc<c?o^k^kom_Kfooclo?ono_hkoooo
o`0=ookno_olo?comoOgono_koo=cLgoYZJVoiFEUOnXZ:So_Kfmolk>c_oMgMgoiNGUon[ZjP04onk^
kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^JFonKViP0:om[Jf_o>c/ko_KfmojRX
Z?nFUYKoZj^[omkNg_o[jn_om?Cdoo_kncoooooo00_ono_koo?cloo/k>cohN7Qojj^[_nFUYKoZ:RX
okfm_Oo>c/kof][Jon3Ph02FonKViP0:om[Jf_o>c/ko_KfmojRXZ?nFUYKoZj^[omkNg_o[jn_om?Cd
oo_kncoooooo00_ono_koo?cloo/k>cohN7Qojj^[_nFUYKoZ:RXokfm_Oo>c/kof][Jon3Ph004onKV
iP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^jFonk^kP0:omgMgOo=cLgo^;Rhoj6Q
XOnXZ:Soe=CDon3Ph?o/k>comOGeoogmoCoooooo00_oo_knooKfm_o/k>coh^;RomWIfOn/[:coXJ6Q
okRh^?o=cLgogMgMonGUi@2Fonk^kP0:omgMgOo=cLgo^;Rhoj6QXOnXZ:Soe=CDon3Ph?o/k>comOGe
oogmoCoooooo00_oo_knooKfm_o/k>coh^;RomWIfOn/[:coXJ6QokRh^?o=cLgogMgMonGUi@04onk^
kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0oooooonFooooo`0;onSXj?oDe=Co^[ZjojVY
ZOo6a/Koe=CDon3Ph?o/k>col_;booclo?ono_h0?_ooool02oojn_[om?Cdon[Zj_oShn?oemOGolg=
cOn/[:co^[ZjomCDe?oXj>Solo?c09Kooooo00_oj>SXomCDe?nj^[[oZJVYolK6a_oDe=Coh>3Ponc/
k?obl_;oo?clooknoP0Qooooo`03ooCdm?oOgmoooooo01[ooooo00_on_[jooCdm?oZj^[ohn?SomOG
eoo=cLgo[:b/okZj^_oDe=Coj>SXoo?cl`04ooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^
k^h0ooo^k^jFonk^kP0?omCDe?no_kooYZJVojb/[?o6a/Kod];BomcLg?oVi^Kok>c/ooGemOohn?So
n_[joogmoOooooooo?cl00Sooooo00?ooOgmooooooooool01Oooool01OomoOgooooooooooooooooo
=SHf00;o000000?o4A4AodE5AOoQhN400_ooool01OlH61SoKFe]oooooooooooooOgm00Oooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`02ooooo`0@oogmoOoooooooOgmoo_knoohn?So
m?Cdong]kOoVi^KogmoOomKFe_o<c<co/[:bojNWYono_kooe=CDon;RhYKok^k^00ooe=CDokno_onV
YZKo[:b/olK6a_oBd];og=cLonKVi_o/k>comOGeooShn?ojn_[ooOgmooooooolo?`02?ooool00oom
oOgoooooooooo`05ooooo`05oogmoOoooooooooooooooolf=SH00_l000002_lA4A7oADE5on7QhOoo
ooooh>3Pode=COlF5QKo<S8bobl_;onIVIT7ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmoooo
ooooool00_ooool04?omoOgooooooogmoOokno_on?ShooCdm?o]kNgoi^KVomoOgooFe]Koc<c<ok:b
/_nWYjOo_knoomCDe?oRh^84onk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^JF
onKViP0Col[:b_ne]KGoWYjNokJf]_o3`l?oclo?omKFe_oOgmooi^KVon[Zj_o_knoolo?cooCdm?oe
mOGomoOgooKfm_ogmoOom_KfooShn002ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00kom_KfooShn?ld=3CoLg=coo7alOo=cLgo9RHVoeQHF?ofm_Kon?Shoe]KFolF5QKolo?c
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL04oofm_Kon?ShooKfm_ogmoOom_KfooCdm?obl_;ol?3`on_[jooVi^KohN7Qom[Jf_oCdm?o
bLW9okno_onSXj?o]KFeol[:b_oIfMT0U_oVi^H04oo:b/[o]KFeoijNW_nf][Ko`l?3olo?cooFe]Ko
gmoOonKVi_oZj^[okno_oo?cloodm?ComOGeooOgmoofm_KomoOgooKfm_ohn?P00_ogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`0BooKfm_ohn?So=3@dog=cLooalO7ocLg=obHV
9_mHF5Som_Kfode=COld=3Cok^k^ooKfm_ni^KWo0000ol[:b_ofm_Kon?Sh0_ogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`0CooKfm_ohn?Som_KfooOgmoofm_Kom?Cdoo;bl_o`
l?3ojn_[onKVi_oQhN7of][Jom?Cdoo9bLWo_knooj>SXone]KGob/[:omWIf@04onKViP7oU9BD0OoV
i^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^jFonk^kP0;om3@d?nh^;SoX:2Pok>c/oo0`<3obLW9
om?CdooIfMWogMgMon;Rh_oUiND00_oZj^X00oo/k>cokNg]ong]k@07onk^kP03oo3`l?o^k^kok^k^
00Gok^k^00Kol?3`onk^k_o^k^kok^k^oc8b<_m_Kfl2onk^kP09ofEUIOlV9RKok^k^onk^k_no_koo
0000ojf][Oo^k^kol?3`00Ook^k^00?ol?3`onk^k_o^k^h01Oo^k^h01?o`l?3ok^k^onk^k_o^k^h2
ong]k@;ok>c/00gojNWYonKVi_oShn?oh>3Pom_KfooEeMGocLg=olG5aOnk^k_oYjNWokRh^?o@d=3o
h>3P09Kok^k^00_od=3@okRh^?nPX:3o/k>col30`?o9bLWodm?ComWIfOoMgMgoh^;RonGUi@02on[Z
jP03onc/k?o]kNgokNg]00Ook^k^00?ol?3`onk^k_o^k^h01Oo^k^h01_o`l?3ok^k^onk^k_o^k^ko
<S8bofm_K`;ok^k^00GoIFEUobHV9_o^k^ko<30`oh61P@02onk^kP03onOWiol820SoWinO00Kok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h01?o`l?3ok^k^onk^k_o^k^h2ong]k@;ok>c/00gojNWYonKVi_oS
hn?oh>3Pom_KfooEeMGocLg=olG5aOnk^k_oYjNWokRh^?o@d=3oh>3P00Cok^k^0OnDU9@1onk^kP00
0_ooool00onDU9Coooooooooo`3ooooooiKooooo00gogmoOolG5aOnNWYko[:b/ok^k^oo6a/KocLg=
om?CdooGemOofm_KomoOgooQhN7oh^;R00;ohn?S1ooUiND2onKViPKoiNGU0_oVi^H3onGUi@06oc0`
<?mZJV[oiNGUolk>c_l<30coLG5a0ooUiND01?mADE7oCdm?onKVi_oVi^H6onGUi@;oi^KV1_oUiND2
onKViP?oiNGU0_oTi>@2on?Sh`0=on;Rh_oPh>3og=cLomWIfOoFe]Kod=3@olW9bOo1`L7o]KFeojNW
Yoo5aLGogmoOoo3`l02Fooooo`0=omoOgoo5aLGoWYjNojb/[?nk^k_oa/K6olg=cOoCdm?oemOGom_K
fooOgmoohN7Qon;RhP02on?Sh`OoiNGU0_oVi^H6onGUi@;oi^KV0ooUiND03_l`<33oJVYZonGUiOo>
c/ko30`<og5aLOoUiNGoL71`odQ8B?oUiNGog=cLoeADE?l71`OoemOG1OoUiND2onKViPKoiNGU0_oV
i^H3onGUi@;oi>CT0_oShn<03OoRh^;oh>3PomcLg?oIfMWoe]KFom3@d?o9bLWo`L71okFe]OnWYjOo
aLG5omoOgoo`l?001?ooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^U_o^k^h0
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`2
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN00SogMgM
obh^;_l[:b_o=SHfoa<C4on4Q8Cog=cLomkNgP;ogMgM00Co`l?3o`/;2on[Zj_ogMgM0_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP;ogMgM0_oLg=`03_oK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM7ohN7QU_o^k^h0
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`2
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN00kogMgM
obh^;_l[:b_o=SHfoa<C4on4Q8Cog=cLomkNg_oFe]KoBDU9odi>C_lO7aoo6QXJoj^[Z`;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h2omgMg@;og=cL00ko
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Cok^k^
0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP3oonKViYKoi^KV00gocLg=okVi^On<S8coWYjN
ojf][Oni^KWo`/;2olO7aoo<c<cod=3@om;Bd_oEeMGoe]KF00;oemOG00?of=SHomWIfOoIfMT04OoI
fMT01_l];BgoBTY:ogemOOlf=SKoIVIVomGEe@CofMWI00?oN7QhobXZ:_oGemL04ooIfMT2omSHf0;o
emOG00goeMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo_knookFe]OnYZJWoV9RHokVi^Oo=cLgofm_K09Ko
i^KV00gocLg=okVi^On<S8coWYjNojf][Oni^KWo`/;2olO7aoo<c<cod=3@om;Bd_oEeMGoe]KF00;o
emOG00?of=SHomWIfOoIfMT04OoIfMT01_l];BgoBTY:ogemOOlf=SKoIVIVomGEe@;ofMWI00GoNWYj
o`000?ln?SkoA4A4om;BdP0ComWIf@;of=SH0_oGemL03OoEeMGodm?Com3@d?o>c/kob/[:olG5aOno
_koo]KFeojVYZOnHV9So^KViolg=cOoKfm/01?oVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^ko
k^k^0?ook^k^U_o^k^h03OoHf=Soa/K6ohV9ROnCTi?oXZ:Rojn_[onj^[[o`L71olO7aoo;bl_oc/k>
om3@d?oAdM400_oCdm<3omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD00SoeMGEobd];OmSHf?oeMGEolK6a_l820SoUYJFomCDe0;oeMGE00Coe]KF
om;Bd_lX:2SoOGel0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE013oe=CDom?CdooCdm?odM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jf
oj^[ZonMWIgoTY:BolK6a_oHf=Soh^;RU_o^k^h03OoHf=Soa/K6ohV9ROnCTi?oXZ:Rojn_[onj^[[o
`L71olO7aoo;bl_oc/k>om3@d?oAdM400_oCdm<3omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oD
e=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD00koeMGEobd];OmSHf?oeMGEolK6a_l820SoUYJF
omCDe?n][Jgo0000oiNGUooEeMGoL71`odm?CP;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@0@omCDe?oCdm?odm?Com7AdOo@d=3ocLg=
ol[:b_o3`l?o_[jnokJf]_n[Zj_oWIfMoi:BT_o6a/Kof=SHon;RhPCok^k^0OnDU9@1onk^kP000_oo
ool00onDU9Coooooooooo`3ooooooiKooooo01;okNg]omcLg?nEUIGoRHV9oiNGUonUYJGo/[:bokno
_oo;bl_odM7AomGEeOoGemOofMWIom[Jf_oKfm_of][Jom_KfooLg=`7om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00Wog=cLom_Kfol^;RkoIVIVom_Kfoo7alOo20P8og]kNooLg=`01?oKfm/01?n/[:co4A4A
olW9bOoLg=`7om_Kf`03omcLg?oKfm_ofm_K00Gofm_K01?og=cLom_KfooKfm_ofm_Kom[Jf_oIfMWo
f=SHomKFe_oCdm?ocLg=ol;2`_nf][Ko[:b/oinOWon@T93oVi^KomcLg?o]kNgom_Kf09Kooooo01;o
kNg]omcLg?nEUIGoRHV9oiNGUonUYJGo/[:bokno_oo;bl_odM7AomGEeOoGemOofMWIom[Jf_oKfm_o
f][Jom_KfooLg=`7om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00_og=cLom_Kfol^;RkoIVIVom_Kfoo7
alOo20P8og]kNooLg=coY:BToahN7P02om_Kf`04ojf][Ol>3Pkofm_KomcLg0Oofm_K00?og=cLom_K
fooKfm/01OoKfm/04ooLg=cofm_Kom_KfooKfm_of][JomWIfOoHf=Soe]KFom?Cdoo=cLgo`/;2okJf
]_n/[:coWinOoi2@T?nKVi_og=cLong]kOofm_H01?ooool1oiBDU07ooooo0002onk^kP03oiBDU?o^
k^kok^k^0?ook^k^U_o^k^h02ooRh^;oe]KFoj2PX?mjNW[oR8R8oiJFU_nZZZ[oa<C4omGEeOoKfm_o
g]kN00;oh>3P0ooRh^800ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00_oi>CT
on?ShooShn?o<30`obTY:Om4A4Co4Q8BoaLG5ooGemOohn?SogYjNP04oc4a<@03o`P82?n3Ph?ohn?S
00Kohn?S00?oi>CTon?ShooShn<01OoShn<01?oTi>Cohn?Son?ShooShn<2on;RhP0>on7QhOoPh>3o
gmoOomcLg?oGemOoaLG5ojb/[?nNWYkoT92@oh:2P_nTY:Coe]KFon;Rh_oXj>RFonk^kP0;on;Rh_oF
e]KoX:2PogYjN_n8R8SoUYJFojZZZ_o4a<CoeMGEom_KfooNg]h00_oPh>03on;RhP03onCTi?oShn?o
hn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<02OoTi>Cohn?Son?Shol`<33o:BTYodA4A?lB4Q;o
5aLGomOGe`02on?Sh`06obTY:OmOGeooRHV9oc0`<?mLG5coi>CT1ooShn<00ooTi>Cohn?Son?Sh`05
on?Sh`04onCTi?oShn?ohn?Son?Sh`;oh^;R00kohN7Qon3Ph?oOgmoog=cLomOGeoo5aLGo[:b/oijN
W_n@T93oPX:2ojBTY?oFe]Koh^;RonSXj0Cok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKV
iP3oonKViYKoi^KV00kogMgMomKFe_nl_;coNWYjogQhN?n6QXKoWinOolG5aOoHf=SogMgMomoOgooQ
hN7oh^;Ron?Sh`?oi>CT1?oUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@03?oUiNGoi>CT
onGUiOoUiNGoWYjNohZ:R_n=SHgo^KVion?ShooTi>CoiNGUok2`/0;oRXZ:0_n9RHT00on:RX[o_;bl
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi004onGUiOoTi>CoiNGUonGUi@?o
i>CT00kohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oPh>3okfm_OoFe]KogMgMon;R
hYKoi^KV00kogMgMomKFe_nl_;coNWYjogQhN?n6QXKoWinOolG5aOoHf=SogMgMomoOgooQhN7oh^;R
on?Sh`?oi>CT1?oUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@02_oUiNGoi>CTonGUiOoU
iNGoWYjNohZ:R_n=SHgo^KVion?ShooTi>@2onGUi@06omcLg?nIVIWoIFEUoibLW?oLg=coi>CT1?oU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@01?oUiNGoi>CTonGUiOoUiND3onCTi00>on?S
hooQhN7oh>3PomoOgooJf][oa/K6oj6QXOn=SHgoP820oh>3Ponm_Kgoe]KFomgMgOoRh^84onKViP7o
U9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^jFonk^kP0;onSXj?oRh^;ofMWIoinOWomU
IFGoLg=cohf=SOnk^k_oe=CDom[Jf_oMgMd00_oOgml00ooPh>3ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@06on7Qh@0>on3Ph?oO
gmoogMgMomcLg?oEeMGo^KViohj>S_mkNg_oKVi^oj:RX_oIfMWoh^;RonSXj?o/k>bFonk^kP0;onSX
j?oRh^;ofMWIoinOWomUIFGoLg=cohf=SOnk^k_oe=CDom[Jf_oMgMd00_oOgml00ooPh>3ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@06on7Qh@0>on3Ph?oOgmoogMgMomcLg?oEeMGo^KViohj>S_mkNg_oKVi^oj:RX_oIfMWoh^;RonSX
j?o/k>`4onk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0oooooonFooooo`0<ooclo?oi
nOWol_;bonOWionDU9CoHV9RogIfM_nTY:CoalO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?o
fm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?o
fm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg00Dom_KfooLg=cog=cLom_KfooLg=co
fm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGoW9bLogEeMOmWIfOoUiNGonOWioobl_;onOWiooclo?ono_jF
ooooo`0<ooclo?oinOWol_;bonOWionDU9CoHV9RogIfM_nTY:CoalO7om;Bd_oEeMGof=SH0_oJf]X3
om_Kf`Oog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg00Dom_KfooLg=co
g=cLom_KfooLg=cofm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGoW9bLogEeMOmWIfOoUiNGonOWioobl_;o
nOWiooclo?ono_h4ooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^jFonk^kP0>
ong]kOoZj^[oinOWon;Rh_o?clooRXZ:oeYJF_mkNg_oXj>Sokbl_?o6a/Kobl_;olg=cOo?cll2om7A
d@God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00?od];B0_oAdM403Oo@d=3oclo?olc<c?o8b<So^k^koibLW?mbLW;oFe]Kohf=SOo?clooh^;RonOW
iooZj^X00_o]kNfFonk^kP0>ong]kOoZj^[oinOWon;Rh_o?clooRXZ:oeYJF_mkNg_oXj>Sokbl_?o6
a/Kobl_;olg=cOo?cll2om7Ad@God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05
om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05
om;BdP03om7AdOoBd];odM7A00?od];B0_oAdM403Oo@d=3oclo?olc<c?o8b<So^k^koibLW?mbLW;o
Fe]Kohf=SOo?clooh^;RonOWiooZj^X00_o]kNd4onk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKV
i_oVi^H0oooVi^JFonKViP;oiNGU00koh^;Ron3Ph?oKfm_oeMGEoiRHV?m/K6coJ6QXoh>3PonGUiOo
Xj>Sojb/[?n_[joo/K6aok:b/P;o];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd01?o]KFe
okJf]?nd];Co];BdokJf]_nc/k?o/[:bok>c/on_[jooZZZZoibLW?n2PX;oHV9Rofe]KOnKVi_oeMGE
om_KfooPh>3oh^;R00;oiNGUUooVi^H2onGUi@0>on;Rh_oPh>3ofm_KomGEeOnHV9SoK6a/ofQXJ?n3
Ph?oUiNGoj>SXon/[:co[jn_ok6a/Onb/[82okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]00CokFe]Onf][Co];BdokBd]?nf][Ko/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9RH_m]KFgo
Vi^KomGEeOoKfm_oh>3Pon;RhP02onGUi@Goi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^
kP3oonk^kYOok^k^0_o]kNd03oo[jn_oj>SXonGUiOoRh^;obl_;oijNW_mmOGgoJf][ofATI?mYJFWo
LW9bogAdM?miNGWoO7alog]kN`02ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00OoO7alog]kNomlO7coOGelogalO?mkNg_oOGem00;oNWYj00_oMgMgogAdM?m^KVkoLG5aogmoOonN
WYkoc<c<on;Rh_oUiNGoj>SXon_[j`02ong]kIWok^k^0_o]kNd03oo[jn_oj>SXonGUiOoRh^;obl_;
oijNW_mmOGgoJf][ofATI?mYJFWoLW9bogAdM?miNGWoO7alog]kN`02ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00OoO7alog]kNomlO7coOGelogalO?mkNg_oOGem00;oNWYj00_o
MgMgogAdM?m^KVkoLG5aogmoOonNWYkoc<c<on;Rh_oUiNGoj>SXon_[j`02ong]k@Kok^k^0OnDU9@1
onk^kP000_ooool00onDU9Coooooooooo`3ooooooiSooooo0_ono_h02OomoOgono_kooWinOofm_Ko
lo?coo;bl_o`l?3okno_onk^kP0iong]k@09onk^k_o_knool?3`oo;bl_oclo?om_KfooWinOokno_o
oOgm00;oo_knVoooool2ooknoP09oogmoOokno_onOWiooKfm_oclo?ol_;boo3`l?o_knook^k^03Wo
kNg]00Wok^k^ono_koo`l?3ol_;boo?cloofm_KonOWioo_knoomoOd00_ono_h7ooooo`7oU9BD0Ooo
ool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^jJonk^kP;okNg]00?ok>c/on[Zj_oZj^X00_oXj>P2
onOWicWoi^KV0_oWinL2onSXj0;oj^[Z00?ok>c/ong]kOo]kNd0Woo^k^h2ong]k@03onc/k?oZj^[o
j^[Z00;oj>SX0_oWinLionKViP;oinOW0_oXj>P2on[ZjP03onc/k?o]kNgokNg]00Wok^k^0OnDU9@1
onk^kP000_oVi^H00onDU9Coi^KVonKViP3oonKVi_ooi^KVfOoVi^H1oiBDU07oi^KV0002onk^kP03
oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0
ooooooooooooomWooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^
k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV0?ooi^KVoooVi^KIonKViP7oU9BD0OoVi^H0
00;ok^k^00?oU9BDonk^k_o^k^h04Oo^k^h01Onc/k?oNWYjoeYJF_m`L73o`<300?ook^k^ooo^k^k3
onk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool04Oooool01_n9RHWoMWIfojFUYOmSHf?o
2`/;okbl_?ooooooooooooo2ooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h05Oo^k^h0
0omDE5Co@T92onk^kP06onk^kP03on[Zj_oHf=Sok^k^01Sok^k^00?ohn?SomSHf?o^k^h00oo^k^h0
0ooLg=cok>c/onk^kP02on?Shoook^k^ooo^k^jEonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKV
i_oVi^H01OoVi^H02_l`<33oJf][onKVi_oVi^KogMgMob8R8_lo?cooiNGUocTi>OmbLW82onKViP06
om3@d?mCDe?o<c<cofi^K_n=SHgo6a/K0_oVi^H02_li>CWoLW9bonKVi_oVi^KoXj>So``<3?l10@7o
:2PXohB4Q?l?3`l5onKViP03odI6A_mXJ6Soi^KV00Coi^KV00Go:RXZoeEEEOoVi^Ko>CTiog9bLP03
onKViP0=om3@d?m2@T;o0P82oalO7olD51Co[Zj^onKVi_m9BDWo1`L7oaLG5on<S8co4A4Aodi>CP3o
onKVi_ooi^KVUOoVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^00Gok^k^00[o<S8bofm_
Koo^k^kok^k^ofQXJ?lB4Q;oemOGonk^k_lk>c_oMWIf0_o^k^h01_m7AdOo:RXZoiNGUomcLg?o:RXZ
oa8B4P;ok^k^00[o>c/kogIfM_o^k^kok^k^obl_;omDE5CogMgMokbl_?lZ:R[o3`l?1Oo^k^h00onX
Z:So4a<ConSXj003onk^kP06okfm_Ol0003o][Jfonk^k_lk>c_oMWIf0oo^k^h03?lo?coo>c/kom3@
d?o^k^koh^;Ron7QhOnh^;So0`<3olk>c_oFe]KoE5ADo`l?3oook^k^ooo^k^jFonk^kP7oU9BD0Oo^
k^h000;ooooo00?oU9BDooooooooool01Oooool01_lf=SKoMgMgooooooo2`/;o0P82ok6a/@;ooooo
00Ko@410ogmoOooooooom_Kfo`T92Oni^KT2ooooo`0:oiJFU_lA4A7ooooooooooom0@43oOgmooooo
oooXj>So0@41olG5a@;ooooo00?oZj^[oa4A4Oooool01?ooool00oolo?co71`Log9bLP03oiZJVP06
odU9BOlX:2Sooooooooooom0@43oOgmo0_ooool00ooMgMgo0000okRh^004ooooo`06omWIfOl30`?o
_KfmoooooonOWioo820PoooooooooooooiKooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^
kP05onk^kP05oc8b<_m/K6cogmoOob0P8?mQHF400oo^k^h01_lk>c_oMWIfonk^k_ne]KGo0000omKF
eP;ok^k^00[oX:2Po`l?3oo^k^kok^k^oc/k>omfMWKok^k^ok>c/ol0003oe]KF0_o^k^h00onPX:3o
3`l?onk^kP05onk^kP07ogIfM_l>3PkoHF5Qof5QHOmFEUKo0000oh61P@02onk^kP07oc/k>omfMWKo
k^k^onk^k_na/K7o0000ocPh>003ocXj>P07okJf]_o^k^koXJ6Qobh^;_l_;boo<S8boadM7@3oonk^
k_ook^k^U_o^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV00Goi^KV00Go<30`o`820_l0
003o0000ojj^[P03onKViP06ocTi>OmbLW;oi^KVolC4a?l0003oXj>S0_oVi^H02_nKVi_o3`l?onKV
i_oVi^Ko>CTiog9bL_oVi^Kob/[:o`000?nPX:02onKViP03oi^KVol?3`ooi^KV00Goi^KV00Oob/[:
o`820_o7alOoi^KVohf=SOl410Codm?C00;oi^KV00_o>CTioeiNG_oVi^Koi^KVolG5aOl0003oVYZJ
okZj^_nc/k?o0P82olk>cP03onKViP03onCTi?n5QHGo7AdM0?ooi^KVoooVi^JFonKViP7oU9BD0OoV
i^H000;ok^k^1onDU9@01oo^k^ko<S8bofm_KooCdm?oShn?o`L71on/[:`00_o^k^h02_lk>c_oMWIf
onk^k_o^k^ko=cLgod51@OoBd];oh>3Poe1@D?l?3`l2onk^kP0:oc/k>omfMWKok^k^onk^k_ln?Sko
@D51om?CdooKfm_oC4a<o`l?3`Ook^k^00GoADE5og1`L?o^k^ko=3@dode=C@03onk^kP0:oc/k>olA
4A7oQhN7omCDe?o/k>co>SXjof=SHooVi^KoTi>CobPX:0;ok^k^00KoZ:RXol_;boo[jn_oFUYJodi>
C_o^k^kooiBDU?ooU9BDU_nDU9@1onk^kP002_ooool01_lf=SKoMgMgooooooooooooBDU9oe=CD`;o
oooo00[oE5ADohf=SOooooooooooon?Shom4A4Co2`/;obTY:OmfMWKo:RXZ0_ooool02_mDE5CoSHf=
ooooooooooooi^KVodA4A?l<30co:2PXofe]KOlA4A47ooooo`05ojn_[olH61Soc/k>o`000?ng]kL0
0oooool02_mDE5CoRHV9oeeMGOl92@Wol?3`onKVi_m7AdOo3@d=oa`L7?ng]kL2ooooo`05ohZ:R_lb
<S;o410@ocTi>Oo4a<@0oooooooooooooiSooooo000:onk^kP06oc8b<_m_Kfook^k^onk^k_la<C7o
Cdm?2?o^k^h00oo/k>cok^k^onk^kP09onk^kP04onc/k?o^k^koX:2Po`l?3`Ook^k^00Goj^[ZoaHF
5_lV9RKo6a/Kong]k@06onk^kP05on_[joo^k^kok^k^onk^k_o[jn/01_o^k^h00oo/k>cok^k^onk^
kP3oonk^k_ook^k^V?o^k^h000[oi^KV00Ko<30`obXZ:_mADE7o7alOo`X:2_n_[jl2onKViP03oe9B
D_n3Ph?oi^KV00Woi^KV00?oDU9Boh>3PooVi^H01OoVi^H00onKVi_o3`l?onKViP07onKViP03ofi^
K_l0003oLG5a0?ooi^KVoooVi^J]onKViP002_o^k^h01OnTY:CoShn?ohn?Son^[Zkoj>SX00?ok^k^
00?oZ:RXokno_oo^k^h02Oo^k^h00onXZ:So_knoonk^kP05onk^kP03oj2PX?l?3`ook^k^00Ook^k^
00?oemOGohn?SooHf=P0ooo^k^koonk^kZgok^k^000Vooooo`03ookno_ojn_[ooooo0?oooooooooo
oongooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KVh?oVi^H00?ook^k^ooo^k^kPonk^kP00
ooooooooooooon3ooooo0002onk^k_ooU9BDoonDU9CMoiBDU07ok^k^0002onKViP03oiBDU?oVi^Ko
i^KV0?ooi^KVoooVi^KIonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^
k]Wok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3ooooooooooooofOooool1oiBDU07o
oooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;oi^KV00?o
U9BDonKVi_oVi^H0oooVi^KoonKVi]Woi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3o
onk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oooooooooooooIoooo
o`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP00
0_oVi^H00onDU9Coi^KVonKViP3oonKVi_ooi^KVfOoVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^
k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0oooooooo
ooooomWooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBD
U07ok^k^0002onKViP03oiBDU?oVi^Koi^KV0?ooi^KVoooVi^KIonKViP7oU9BD0OoVi^H000;ok^k^
00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP000_ooool00onDU9Cooooooooo
o`3ooooooooooooofOooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kI
onk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^KoonKVi]Woi^KV0OnDU9@1onKV
iP000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002ooooo`03oiBD
U?oooooooooo0?oooooooooooooIooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^
k^koonk^k]Wok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP3oonKVi_ooi^KVfOoVi^H1
oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;o
oooo00?oU9BDooooooooool0ooooooooooooomWooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^
onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV0?ooi^KVoooV
i^KIonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1
onk^kP000_ooool00onDU9Coooooooooo`3ooooooooooooofOooool1oiBDU07ooooo0002onk^kP03
oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0
oooVi^KoonKVi]Woi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3nonk^kP;okNg]00[o
jn_[onSXj?oUiNGoh^;RomgMgOoHf=Soe=CDom7AdOo>c/koc<c<0_o;bl/eol[:bP;obl_;00[oc<c<
olk>c_oAdM7oe=CDomSHf?oMgMgoh^;RonGUiOoXj>Sojn_[0_o]kNgoonk^kS7ok^k^0_o]kNd02_o[
jn_oj>SXonGUiOoRh^;ogMgMomSHf?oDe=CodM7Aolk>c_o<c<`2ol_;bcGob/[:0_o;bl/02_o<c<co
c/k>om7AdOoDe=Cof=SHomgMgOoRh^;oiNGUonSXj?o[jn/2ong]k@Ook^k^0OnDU9@1onk^kP000_oo
ool00onDU9Coooooooooo`3mooooo`;oo_kn00[ono_kooWinOoclo?okNg]onGUiOoLg=coe=CDolc<
c?o7alOo`l?30_o0`<02okno_c?o_[jn0_no_kl2ol30`00:ol?3`oo7alOoc<c<omCDe?oLg=coiNGU
ong]kOoclo?onOWioo_kn`;oo_knooooool_ooooo`;oo_kn00[ono_kooWinOoclo?okNg]onGUiOoL
g=coe=CDolc<c?o7alOo`l?30_o0`<02okno_c?o_[jn0_no_kl2ol30`00:ol?3`oo7alOoc<c<omCD
e?oLg=coiNGUong]kOoclo?onOWioo_kn`;oo_kn1_ooool1oiBDU07ooooo0002onk^kP03oiBDU?o^
k^kok^k^0?gok^k^00kokNg]on[Zj_oWinOoh^;RomWIfOo>c/ko`l?3okRh^?n^[ZkoYZJVoj2PX?nL
W9coVIVIoiRHV3OoUiNG00goV9RHoiVIVOnLW9coX:2PojJVY_n^[Zko^;Rhol?3`oo>c/kofMWIon;R
h_oWinOoj^[Z00;okNg]ooo^k^h^onk^kP0>ong]kOoZj^[oinOWon;Rh_oIfMWoc/k>ol?3`onh^;So
[Zj^ojJVY_nPX:3oW9bLoiVIVOnHV9PgoiNGU`0=oiRHV?nIVIWoW9bLoj2PX?nVYZKo[Zj^okRh^?o3
`l?oc/k>omWIfOoRh^;oinOWon[ZjP02ong]k@Gok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KV
onKViP3monKViP0=on?ShooPh>3of][Jom7AdOo5aLGo]kNgojRXZ?nLW9coT92@ohR8R?n1PH7oOWin
og]kN`0iogYjNP0>og]kNomnOWkoPH61ohR8R?n@T93oW9bLojRXZ?ng]kOoaLG5om7AdOoJf][oh>3P
on?ShooUiNGoonKViRkoi^KV00gohn?Son3Ph?oJf][odM7AolG5aOng]kOoZ:RXoibLW?n@T93oR8R8
oh61POmnOWkoNg]k03WoNWYj00koNg]koginO_n1PH7oR8R8oi2@T?nLW9coZ:RXokNg]oo5aLGodM7A
om[Jf_oPh>3ohn?SonGUi@Goi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3monk^kP0D
onSXj?oRh^;ofMWIol[:b_nj^[[oZ:RXoiRHV?nBTY;oYJFUol30`?oGemOojn_[ooKfm_ogmoOonOWi
ooShn?oinOWon_[jooWinOogmoL3ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[j
n_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL0
0oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT04oojn_[onOWiooShn?oinOWon?ShooOg
moo]kNgof=SHol71`OnUYJGoTY:BoiRHV?nXZ:So^[Zjol[:b_oIfMWoh^;RonSXj?o/k>`0ooo^k^h^
onk^kP0DonSXj?oRh^;ofMWIol[:b_nj^[[oZ:RXoiRHV?nBTY;oYJFUol30`?oGemOojn_[ooKfm_og
moOonOWiooShn?oinOWon_[jooWinOogmoL3ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWi
n@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWi
nOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT04oojn_[onOWiooShn?oinOWo
n?ShooOgmoo]kNgof=SHol71`OnUYJGoTY:BoiRHV?nXZ:So^[Zjol[:b_oIfMWoh^;RonSXj?o/k>`0
1Oo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?gooooo00com_Kfong]kOoMgMgob/[:
okBd]?nOWiooZZZZolk>c_o^k^kom_Kfooclo?ono_hkooooo`0=ookno_olo?comoOgono_koo?cloo
Zj^[oinOWond];Cob/[:omgMgOo]kNgom_Kfoo_kn`3oooooobkooooo00com_Kfong]kOoMgMgob/[:
okBd]?nOWiooZZZZolk>c_o^k^kom_Kfooclo?ono_hkooooo`0=ookno_olo?comoOgono_koo?cloo
Zj^[oinOWond];Cob/[:omgMgOo]kNgom_Kfoo_kn`05ooooo`7oU9BD0Oooool000;ok^k^00?oU9BD
onk^k_o^k^h0oOo^k^h02_oRh^;oe]KFol?3`on^[ZkoVYZJojf][OoNg]kojn_[ooCdm?okno/ooooo
o`0;oo_knooclo?ok>c/on7QhOn`/;3oVYZJojj^[_o3`l?oe]KFon;Rh_oXj>P0ooo^k^h^onk^kP0:
on;Rh_oFe]Ko`l?3ojj^[_nJVY[o[Jf]omkNg_o[jn_om?Cdoo_kncoooooo00_ono_koo?cloo/k>co
hN7Qok2`/?nJVY[o[Zj^ol?3`ooFe]Koh^;RonSXj005onk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BD
onKVi_oVi^H0oOoVi^H02_oFe]KoalO7ok:b/_nLW9coYjNWomCDe?oPh>3ok>c/ooGemOomoOdooooo
o`0;ookno_ofm_Kok>c/on;Rh_oIfMWoZj^[oibLW?nb/[;oalO7omKFe_oMgMd0oooVi^H^onKViP0:
omKFe_o7alOo/[:boibLW?nWYjOoe=CDon3Ph?o/k>comOGeoogmoCoooooo00_oo_knooKfm_o/k>co
h^;RomWIfOn[Zj_oW9bLok:b/_o7alOoe]KFomgMg@05onKViP7oU9BD0OoVi^H000;ok^k^00?oU9BD
onk^k_o^k^h0oOo^k^h02ooHf=Soa/K6ojj^[_nSXj?oa/K6omCDe?oPh>3ok>c/oo;bl_olo?coo_kn
01oooooo00?onOWiomWIfOoMgMd07?ooool02oojn_[om?Cdon[Zj_oShn?oemOGolg=cOnVYZKo[Zj^
olK6a_oHf=Soh^;R0?ook^k^;_o^k^h02ooHf=Soa/K6ojj^[_nSXj?oa/K6omCDe?oPh>3ok>c/oo;b
l_olo?coo_kn027ooooo00?oj^[ZomGEeOokno/06_ooool02oojn_[om?Cdon[Zj_oShn?oemOGolg=
cOnVYZKo[Zj^olK6a_oHf=Soh^;R00Gok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3m
ooooo`0?on?Shoo=cLgo/;2`ojn_[oo6a/Kod];BomcLg?oVi^Kok>c/ooGemOohn?Son_[joogmoOoo
ooooo?cl00Sooooo00?ooOgmooooooooool01Oooool01OomoOgooooooooooooooooo=SHf00;o0000
00[o4A4AodE5AOoQhN7ooooooiBDU?lM7Ago=3@dobXZ:_moOgooo?cl1oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00;ooooo013ooOgmooooooomoOgono_kooShn?odm?CokNg]onKV
i_oOgmooe]KFolc<c?ne]KGo/K6aolg=cOoShn?olo?cooooool^ooooo`0?on?Shoo=cLgo/;2`ojn_
[oo6a/Kod];BomcLg?oVi^Kok>c/ooGemOohn?Son_[joogmoOooooooo?cl00Sooooo00?ooOgmoooo
ooooool01Oooool01OomoOgooooooooooooooooo=SHf00;o000000[o4A4AodE5AOoQhN7oooooooWi
nOmJFU[o1`L7obPX:?lO7aoob/[:1oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo
00;ooooo013ooOgmooooooomoOgono_kooShn?odm?CokNg]onKVi_oOgmooe]KFolc<c?ne]KGo/K6a
olg=cOoShn?olo?c1Oooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?gok^k^01?odM7A
ok^k^onQXJ7o][Jfol?3`oo?clooe]KFomoOgooVi^Koj^[Zono_kooclo?om?CdooGemOogmoOom_Kf
ooOgmoofm_Kon?Sh00;omoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL02_of
m_Kon?Shoc@d=?mcLg?olO7aolg=cOlV9RKoF5QHooKfm_oemOD2ooOgm`06ol[:b_l10@7oUYJFooOg
moofm_Kon?Sh0_ogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`0CooKfm_oh
n?Som_KfooOgmoofm_Kom?Cdoo;bl_o`l?3ojn_[onKVi_oQhN7of][Jom?Cdoo9bLWo_knoojJVY_nk
^k_odM7Aon7Qh@3oonk^kRkok^k^01?odM7Aok^k^onQXJ7o][Jfol?3`oo?clooe]KFomoOgooVi^Ko
j^[Zono_kooclo?om?CdooGemOogmoOom_KfooOgmoofm_Kon?Sh00;omoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL04_ofm_Kon?Shoc@d=?mcLg?olO7aolg=cOlV9RKoF5QHooKf
m_n4Q8Co9BDUom_Kfoofm_KoQHF5ob4Q8Oobl_;om_KfooShn0;omoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL04oofm_Kon?ShooKfm_ogmoOom_KfooCdm?obl_;ol?3`on_[jooV
i^KohN7Qom[Jf_oCdm?obLW9okno_onVYZKo^k^kom7AdOoQhN401Oo^k^h1oiBDU07ok^k^0002onKV
iP03oiBDU?oVi^Koi^KV0?goi^KV00_obLW9ok:b/_nNWYko/k>col30`?o9bLWodm?ComWIfOoMgMgo
h^;RonGUi@02on[ZjP03onc/k?o]kNgokNg]00Ook^k^00?ol?3`onk^k_o^k^h01Oo^k^h01_o`l?3o
k^k^onk^k_o^k^ko<S8bofm_K`;ok^k^00?oIFEUobHV9_o^k^h01?o^k^h00olg=cOoFUYJonk^kP06
onk^kP03oo3`l?o^k^kok^k^00Gok^k^00Col?3`onk^k_o^k^kok^k^0_o]kNd2onc/k00=onWYjOoV
i^Kohn?Son3Ph?oKfm_oeMGEolg=cOo5aLGo^k^kojFUYOnb/[;obLW9omSHf03oonKViRkoi^KV00_o
bLW9ok:b/_nNWYko/k>col30`?o9bLWodm?ComWIfOoMgMgoh^;RonGUi@02on[ZjP03onc/k?o]kNgo
kNg]00Ook^k^00?ol?3`onk^k_o^k^h01Oo^k^h01_o`l?3ok^k^onk^k_o^k^ko<S8bofm_K`;ok^k^
00GoIFEUobHV9_o^k^ko7QhNog9bLP02onk^kP03om[Jf_l0003o`/;200Kok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h01?o`l?3ok^k^onk^k_o^k^h2ong]k@;ok>c/00gojNWYonKVi_oShn?oh>3Pom_KfooE
eMGocLg=olG5aOnk^k_oYJFUok:b/_o9bLWof=SH00Goi^KV0OnDU9@1onKViP000_o^k^h00onDU9Co
k^k^onk^kP3monk^kP0=om3@d?nh^;SoW9bLojb/[?nk^k_oa/K6olg=cOoCdm?oemOGom_KfooOgmoo
hN7Qon;RhP02on?Sh`OoiNGU0_oVi^H6onGUi@;oi^KV0ooUiND01_l`<33oJVYZonGUiOo>c/ko30`<
og5aL@CoiNGU00?of=SHo`d=3Om^KVh01_oUiND2onKViPKoiNGU0_oVi^H3onGUi@;oi>CT0_oShn<0
3OoRh^;oh>3PomcLg?oIfMWoe]KFom3@d?o9bLWo`L71okFe]OnUYJGo^;Rhom3@d?oPh>00ooo^k^h^
onk^kP0=om3@d?nh^;SoW9bLojb/[?nk^k_oa/K6olg=cOoCdm?oemOGom_KfooOgmoohN7Qon;RhP02
on?Sh`OoiNGU0_oVi^H6onGUi@;oi^KV0ooUiND02Ol`<33oJVYZonGUiOo>c/ko30`<og5aLOoOgmoo
0000ohR8R002onGUi@03ol71`Ol0003oa<C400GoiNGU0_oVi^H6onGUi@;oi^KV0ooUiND2onCTi0;o
hn?S00goh^;Ron3Ph?oLg=cofMWIomKFe_o@d=3obLW9ol71`One]KGoYJFUokRh^?o@d=3oh>3P00Go
k^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3mooooo`0=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h03_oMgMgo;Rh^ob/[:olf=SKo4a<CohB4
Q?oLg=cog]kNom?Cdonf][KoQhN7ochn?_l@413o`l?30_oNg]h3omgMg@03omkNg_oMgMgogMgM00;o
g]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP;ogMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7aooooool^ooooo`0=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0;og]kN0ooMgMd00ooN
g]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h03_oMgMgo;Rh^ob/[:olf=SKo
4a<CohB4Q?oLg=coalO7o`000?lW9bOo^k^kom7AdOmGEeOo<S8b0_oNg]h3omgMg@03omkNg_oMgMgo
gMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP;ogMgM0_oLg=`03_oKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>3olO7a1Oooool1oiBDU07ooooo0002
onk^kP03oiBDU?o^k^kok^k^0?gok^k^00goe=CDokno_on<S8coWYjNojf][Oni^KWo`/;2olO7aoo<
c<cod=3@om;Bd_oEeMGoe]KF00;oemOG00?of=SHomWIfOoIfMT04OoIfMT03?l];BgoBTY:ogemOOlf
=SKoIVIVomGEeOoIfMWoX:2Po`D51Olh>3SoHF5Qol71`ACofMWI0_oHf=P2omOGe`0=omGEeOoCdm?o
d=3@olk>c_o:b/[oaLG5okno_one]KGoZJVYoiRHV?no_kooe=CDon;RhP3oonk^kRkok^k^00goe=CD
okno_on<S8coWYjNojf][Oni^KWo`/;2olO7aoo<c<cod=3@om;Bd_oEeMGoe]KF00;oemOG00?of=SH
omWIfOoIfMT04OoIfMT03Ol];BgoBTY:ogemOOlf=SKoIVIVomGEeOoDe=Co0000ogMgMol_;boo3@d=
obTY:On][Jd04ooIfMT2omSHf0;oemOG00goeMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo_knookFe]OnY
ZJWoV9RHokno_ooDe=Coh^;R00Gok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP3monKV
iP0=om7AdOno_kooR8R8oi>CTonRXZ;o[jn_okZj^_o1`L7oalO7ol_;boo>c/kod=3@om7Ad@02om?C
d`?oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oD
e=@03_oEeMGo;Bd]of=SHooEeMGoa/K6o`P82?nFUYKoe=CDoifMWOlR8R;oe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE013oe=CDom?CdooCdm?odM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jfoj^[ZonMWIgoTI6A
okno_ooAdM7ofm_KoooVi^H^onKViP0=om7AdOno_kooR8R8oi>CTonRXZ;o[jn_okZj^_o1`L7oalO7
ol_;boo>c/kod=3@om7Ad@02om?Cd`?oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@03_oEeMGo;Bd]of=SHooEeMGoa/K6o`P82?nFUYKoe=CDoaTI
6OmnOWkoe]KFomCDe?oFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE013oe=CDom?CdooCdm?odM7Aom3@d?o=cLgob/[:ol?3
`onn_[ko][Jfoj^[ZonMWIgoTI6Aokno_ooAdM7ofm_K1OoVi^H1oiBDU07oi^KV0002onk^kP03oiBD
U?o^k^kok^k^0?gok^k^01;ogMgMolg=cOn@T93oRHV9oiNGUonUYJGo/[:bokno_oo;bl_odM7AomGE
eOoGemOofMWIom[Jf_oKfm_of][Jom_KfooLg=`7om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00_og=cL
om_Kfol^;RkoIVIVom_Kfoo7alOo20P8og]kNooLg=coXZ:Rob<S8`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/04ooLg=cofm_Kom_KfooKfm_of][JomWIfOoHf=Soe]KF
om?Cdoo=cLgo`/;2okJf]_n/[:coWinOoi2@T?nFUYKocLg=omgMgOoUiND0ooo^k^h^onk^kP0BomgM
gOo=cLgoT92@ohV9ROnGUiOoYJFUok:b/_no_koobl_;om7AdOoEeMGoemOGomWIfOoJf][ofm_Kom[J
f_oKfm_og=cL1ooKfm/00ooLg=cofm_Kom_Kf`05om_Kf`0<omcLg?oKfm_o;Rh^ofIVI_oKfm_oalO7
o`P82?mkNg_og=cLofm_Kold=3Cof][J1?oKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_o
fm_K00Gofm_K01?og=cLom_KfooKfm_ofm_Kom[Jf_oIfMWof=SHomKFe_oCdm?ocLg=ol;2`_nf][Ko
[:b/oinOWon@T93oUYJFolg=cOoMgMgoiNGU00Gok^k^0OnDU9@1onk^kP000_ooool00onDU9Cooooo
ooooo`3mooooo`0;oo;bl_oUiNGoZJVYogYjN_n8R8SoUYJFojZZZ_o4a<CoeMGEom_KfooNg]h00_oP
h>03on;RhP03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<03?oTi>Cohn?Son?S
hol`<33o:BTYodA4A?lB4Q;o5aLGomOGeooShn?oZ:RXo`X:2P?oA4A400?oU9BDonCTi?oShn<01_oS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`04onCTi?oShn?ohn?Son?Sh`;oh^;R00kohN7Qon3Ph?oOgmoo
g=cLomOGeoo5aLGo[:b/oijNW_n@T93oPX:2ojf][OoUiNGol_;booWinOoooooo;_ooool02oobl_;o
iNGUojVYZOmjNW[oR8R8oiJFU_nZZZ[oa<C4omGEeOoKfm_og]kN00;oh>3P0ooRh^800ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S017oi>CTon?ShooShn?o<30`obTY:Om4A4Co4Q8B
oaLG5ooGemOohn?SomGEeOlb<S;oB4Q8oi2@T?m`L73oH61PonCTi007on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00Coi>CTon?ShooShn?ohn?S0_oRh^803_oQhN7oh>3PomoOgooLg=coemOGolG5aOn/[:co
WYjNoi2@T?n2PX;o[Jf]onGUiOobl_;onOWi1Oooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^ko
k^k^0?gok^k^00koiNGUomgMgOo2`/;oNg]kogQhN?n6QXKoWinOolG5aOoHf=SogMgMomoOgooQhN7o
h^;Ron?Sh`?oi>CT1?oUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@03?oUiNGoi>CTonGU
iOoUiNGoWYjNohZ:R_n=SHgo^KVion?ShooTi>CoiNGUolg=c@;oRXZ:0_n9RHT00onh^;Soi>CTonGU
i@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi004onGUiOoTi>CoiNGUonGUi@?oi>CT
00kohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4ol?3`ooMgMgoiNGUon[Zj_oo
k^k^;_o^k^h03_oUiNGogMgMol;2`_mkNg_oN7QhohJ6Q_nOWiooaLG5omSHf?oMgMgogmoOon7QhOoR
h^;ohn?S0ooTi>@4onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi00:onGUiOoTi>CoiNGU
onGUiOnNWYkoRXZ:ohf=SOni^KWohn?SonCTi0;oiNGU00Kog]kNohf=SOmPH63oLG5aojFUYOoTi>@4
onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi004onGUiOoTi>CoiNGUonGUi@?oi>CT00ko
hn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4ol?3`ooMgMgoiNGUon[ZjPGok^k^
0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP3monKViP0;on3Ph?oKfm_od];Boi^KVomUIFGo
Lg=cohf=SOnk^k_oe=CDom[Jf_oMgMd00_oOgml00ooPh>3ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@06on7Qh@0>on3Ph?oOgmoo
gMgMomcLg?oEeMGo^KViohj>S_mkNg_oKVi^oijNW_oBd];ofm_Kon3Ph?oTi>CoonKViRkoi^KV00_o
h>3Pom_KfooBd];oVi^KofEUIOmcLg?oSHf=ok^k^ooDe=Cof][JomgMg@02omoOg`03on3Ph?oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00KohN7Q00koh>3PomoOgooMgMgog=cLomGEeOni^KWoSXj>og]kNom^KVkoWYjNom;Bd_oKfm_o
h>3PonCTi0Goi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3monk^kP0<on_[jooXj>So
h^;RomOGeon=SHgoHV9RogIfM_nTY:CoalO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg00Dom_KfooLg=cog=cLom_KfooLg=cofm_K
om[Jf_oIfMWof=SHom?Cdoo5aLGoW9bLogEeMOmWIfOoT92@omOGeooRh^;oj>SXon_[joo]kNgoonk^
kRkok^k^00cojn_[onSXj?oRh^;oemOGohf=SOmRHV;oMWIfojBTY?o7alOod];BomGEeOoHf=P2om[J
fP?ofm_K1ooLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL01Cofm_KomcL
g?oLg=cofm_KomcLg?oKfm_of][JomWIfOoHf=Sodm?ColG5aOnLW9coMGEeofMWIon@T93oemOGon;R
h_oXj>Sojn_[ong]k@Gok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3mooooo`0>ookn
o_okno_on?Shoo;bl_oNg]koTI6AoeYJF_mkNg_oXj>Sokbl_?o6a/Kobl_;olg=cOo?cll2om7Ad@Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00Go
d];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00?o
d];B0_oAdM403Oo@d=3oclo?olc<c?o8b<So^k^koibLW?mbLW;oFe]KoiBDU?oNg]kol_;booShn?ok
no/00_ono_koooooobkooooo00koo_knoo_knoohn?Sol_;bomkNg_nATI7oFUYJog]kNonSXj?o_;bl
olK6a_o;bl_ocLg=olo?c`;odM7A1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM400ooBd]82om7Ad@0=om3@d?o?clooc<c<olS8b?nk^k_oW9bLog9b
L_mKFe_oU9BDomkNg_obl_;on?Shoo_kn`02ooknoPGooooo0OnDU9@1ooooo`000_o^k^h00onDU9Co
k^k^onk^kP3monk^kP;okNg]00koj^[ZonSXj?oRh^;og=cLoibLW?m]KFgoJ6QXoh>3PonGUiOoXj>S
ojb/[?n_[joo/K6aok:b/P;o];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd01?o]KFeokJf
]?nd];Co];BdokJf]_nc/k?o/[:bok>c/on_[jooZZZZoibLW?n2PX;oHV9Rofi^K_nOWioog=cLon;R
h_oXj>Soj^[Z00;okNg]ooo^k^h_onk^kP;okNg]00koj^[ZonSXj?oRh^;og=cLoibLW?m]KFgoJ6QX
oh>3PonGUiOoXj>Sojb/[?n_[joo/K6aok:b/P;o];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd01?o]KFeokJf]?nd];Co];BdokJf]_nc/k?o/[:bok>c/on_[jooZZZZoibLW?n2PX;oHV9Rofi^
K_nOWioog=cLon;Rh_oXj>Soj^[Z00;okNg]1_o^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Ko
i^KV0?koi^KV0_oUiND03ooShn?oh>3PomgMgOoJf][oa<C4oiZJV_mjNW[oJFUYof=SHomYJFWoLW9b
ogAdM?miNGWoO7alog]kN`02ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Oo
O7alog]kNomlO7coOGelogalO?mkNg_oOGem00;oNWYj00_oMgMgogAdM?m]KFgoKfm_ogalO?nJVY[o
aLG5om[Jf_oMgMgoh>3Pon?Sh`02onGUiOooi^KV<OoVi^H2onGUi@0?on?ShooPh>3ogMgMom[Jf_o4
a<CoVYZJogYjN_mYJFWoHf=SofUYJOmbLW;oM7AdogUiNOmlO7coNg]k00;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01omlO7coNg]kogalO?mmOGcoO7alog]kNommOGd00_mjNWX0
2omgMgOoM7Adofe]KOm_KfooO7aloiZJV_o5aLGof][JomgMgOoPh>3ohn?S00;oiNGU1ooVi^H1oiBD
U07oi^KV0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;R
hP03on3Ph?oOgmoog]kN03WogMgM00?og]kNomoOgooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/k>`2
ong]kOook^k^<oo^k^h2ong]k@04onc/k?oZj^[oj>SXonGUi@;oh^;R00?oh>3PomoOgooNg]h0>OoM
gMd00ooNg]kogmoOon3Ph002on;RhP04onGUiOoXj>Soj^[Zonc/k0;okNg]2?o^k^h1oiBDU07ok^k^
0002ooooo`03oiBDU?oooooooooo0?oooooo0_ooool2ooknoP03oogmoOokno_ono_k00;onOWi0_oh
n?PiooOgm`;on?Sh0_oinOT2oo_kn`03oogmoOono_koo_kn0?oooooo=oooool2ooknoP03oogmoOok
no_ono_k00;onOWi0_ohn?PiooOgm`;on?Sh0_oinOT2oo_kn`03oogmoOono_koo_kn00[ooooo0OnD
U9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002onKV
iP03oiBDU?oVi^Koi^KV0?ooi^KVoooVi^KIonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^
k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3ooooooooooooo
fOooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^
k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^KoonKVi]Woi^KV0OnDU9@1onKViP000_o^k^h00onD
U9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oo
oooooooooooIooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^
0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP3oonKVi_ooi^KVfOoVi^H1oiBDU07oi^KV0002
onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDoooo
ooooool0ooooooooooooomWooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_oo
k^k^fOo^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV0?ooi^KVoooVi^KIonKViP7oU9BD
0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP000_ooool0
0onDU9Coooooooooo`3ooooooooooooofOooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^
0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^KoonKVi]Wo
i^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^
0002ooooo`03oiBDU?oooooooooo0?oooooooooooooIooooo`7oU9BD0Oooool000;ok^k^00?oU9BD
onk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP3oonKV
i_ooi^KVfOoVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7o
U9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0ooooooooooooomWooooo0OnDU9@1ooooo`000_o^
k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Ko
i^KV0?ooi^KVoooVi^KIonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^
k]Wok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3ooooooooooooofOooool1oiBDU07o
oooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;oi^KV00?o
U9BDonKVi_oVi^H0oooVi^KoonKVi]Woi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3o
onk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo01[ooooo00?om?CdonSX
j?ooool0oooooooooooookcooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP05onk^kP03
oc8b<_m/K6cok^k^00Cok^k^00Ko>c/kogIfM_o^k^kok^k^oc/k>omfMWH2onk^kP0=oc/k>omfMWKo
k^k^onk^k_oGemOoADE5o`820_lP823o5ADEokBd]?o^k^ko>c/kogIfMP3oonk^k_ook^k^^?o^k^h1
oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV00Goi^KV00?o<30`ofQXJ?oVi^H01?oVi^H01_li
>CWoLW9bonKVi_oVi^Ko>CTiog9bLP;oi^KV00go>CTiog9bL_oVi^Koi^KVocdm?Oli>CWobLW9onKV
i_oKfm_of][JonKVi_li>CWoLW9b0?ooi^KVoooVi^JhonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BD
onk^k_o^k^h01Oo^k^h00olb<S;oK6a/onk^kP04onk^kP06oc/k>omfMWKok^k^onk^k_lk>c_oMWIf
0_o^k^h01_lk>c_oMWIfonk^k_o>c/ko0000oj^[Z`Gok^k^00?o>c/kogIfM_o^k^h0ooo^k^koonk^
k[Ook^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`05ooooo`03ocHf=_mdM7Cooooo00Co
oooo00Ko@410ogmoOooooooooooood10@?moOgl2ooooo`06od10@?moOgoooooookjn__l0003o?Cdm
0olo?cl01?o4a<Cooooood10@?moOgoooooooooooooo^?ooool1oiBDU07ooooo0002onk^kP03oiBD
U?o^k^kok^k^00Gok^k^00Go<S8boa`L7?lo?coo?clooeaLG002onk^kP06oc/k>omfMWKok^k^onk^
k_lk>c_oMWIf0_o^k^h03Olk>c_oMWIfonk^k_o<c<co0000oinOWoo1`L7o^KVio`820_oEeMGok^k^
oc/k>omRHV80ooo^k^koonk^k[Sok^k^0OnDU9@1onk^kP000_oVi^H7oiBDU003onKVi_l`<33oCTi>
00;o[Jf]00Go][JfonKVi_oVi^Ko>CTiog9bLP02onKViP06ocTi>OmbLW;oi^KVonKVi_li>CWoLW9b
0_oVi^H01Olh>3SoH61PomkNg_n>SXko9RHV00;oi^KV00Go>CTioa4A4On2PX;ocLg=oi:BTP3ooiBD
U?ooU9BD]_nDU9@1onKViP002_o^k^h00olb<S;oK6a/onk^kP04onk^kP06odi>C_n3Ph?ok^k^onk^
k_lk>c_oMWIf0_o^k^h02Olk>c_oMWIfonk^k_o^k^koe]KFod92@_l<30co6QXJojZZZP02onk^kP05
odi>C_moOgooEUIFo`P82?oPh>00ooo^k^koonk^k[Ook^k^000:ooooo`03ocHf=_mdM7Cooooo00So
oooo00Ko@410ogmoOooooooooooood10@?moOgl4ooooo`03ooclo?oooooooooo00Gooooo00?oo?cl
ooooooooool0oooooooooooookKooooo000:onk^kP03oc8b<_lZ:R[oGUiN00;oGUiN00CoZj^[onk^
k_mDE5CoR8R80_o^k^h01_lk>c_oMWIfonk^k_o^k^ko>c/kogIfM_ook^k^ooo^k^k5onk^kP002_oV
i^H00onNWYkoRXZ:ohZ:RP02ohZ:RP04okbl_?oVi^KoXZ:RokRh^0;oi^KV00Ko>CTiog9bL_oVi^Ko
i^KVocTi>OmbLW;oonKVi_ooi^KVaOoVi^H001Gok^k^00Koj^[Zonc/k?o^k^kok^k^on[Zj_o/k>co
onk^k_ook^k^aOo^k^h00?oooooooooooooPooooo`00ooo^k^koonk^k^3ok^k^003oonKVi_ooi^KV
h?oVi^H00?ook^k^ooo^k^kPonk^kP000_oooooooiBDU?ooU9BDgOnDU9@1ooooo`000_o^k^h00onD
U9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV0?oo
i^KVoooVi^KIonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^
0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3ooooooooooooofOooool1oiBDU07ooooo0002
onk^kP03oiBDU?o^k^kok^k^0;[ok^k^0_o]kNd02_o[jn_oj>SXonGUiOoRh^;ogMgMomSHf?oDe=Co
dM7Aolk>c_o<c<`2ol_;bcGob/[:0_o;bl/02_o<c<coc/k>om7AdOoDe=Cof=SHomgMgOoRh^;oiNGU
onSXj?o[jn/2ong]kK_ok^k^0_o]kNd02_o[jn_oj>SXonGUiOoRh^;ogMgMomSHf?oDe=CodM7Aolk>
c_o<c<`2ol_;bcGob/[:0_o;bl/02_o<c<coc/k>om7AdOoDe=Cof=SHomgMgOoRh^;oiNGUonSXj?o[
jn/2ong]kL3ok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP2ionKViP;oiNGU00[oh^;R
on3Ph?oKfm_oe]KFolk>c_o7alOo_knookRh^?nd];Co/;2`0_n^[Zh2ojf][C?o[:b/0_n][Jd2ojj^
[P0:ok2`/?nd];Co^;Rhokno_oo7alOoc/k>omKFe_oKfm_oh>3Pon;RhP;oiNGU^OoVi^H2onGUi@0:
on;Rh_oPh>3ofm_KomKFe_o>c/koalO7okno_onh^;So];Bdok2`/0;o[Zj^0_n][Jdcojb/[0;o[Jf]
0_n^[Zh02_n`/;3o];BdokRh^?no_kooalO7olk>c_oFe]Kofm_Kon3Ph?oRh^82onGUiKooi^KV0OnD
U9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP2ionk^kP0>ong]kOoZj^[oinOWon;Rh_oIfMWoc/k>
ol?3`onh^;So[Zj^ojJVY_nPX:3oW9bLoiVIVOnHV9PgoiNGU`0=oiRHV?nIVIWoW9bLoj2PX?nVYZKo
[Zj^okRh^?o3`l?oc/k>omWIfOoRh^;oinOWon[ZjP02ong]kKSok^k^00kokNg]on[Zj_oWinOoh^;R
omWIfOo>c/ko`l?3okRh^?n^[ZkoYZJVoj2PX?nLW9coVIVIoiRHV3OoUiNG00goV9RHoiVIVOnLW9co
X:2PojJVY_n^[Zko^;Rhol?3`oo>c/kofMWIon;Rh_oWinOoj^[Z00;okNg]__o^k^h1oiBDU07ok^k^
0002ooooo`03oiBDU?oooooooooo0;Wooooo00koo?clooWinOobl_;oj>SXom[Jf_o;bl_o^[Zjojb/
[?nOWiooUIFEohj>S_n:RX[oQhN7ohJ6QSOoQHF500ooQXJ6ohN7Qon:RX[oSXj>oiFEUOnOWioo[:b/
okZj^_o;bl_of][JonSXj?obl_;onOWiooclo?ono_h0^?ooool03_olo?conOWioo;bl_oXj>Sof][J
ol_;bonj^[[o[:b/oinOWonEUIGoSXj>ohZ:R_n7QhOoQXJ6=on5QHD03on6QXKoQhN7ohZ:R_n>SXko
UIFEoinOWon/[:co^[Zjol_;booJf][oj>SXoo;bl_oinOWoo?clooknoP2nooooo`7oU9BD0Oooool0
00;ok^k^00?oU9BDonk^k_o^k^h0^Oo^k^h05?oXj>Soh^;RomWIfOo:b/[o^[ZjojRXZ?nHV9SoTY:B
ojFUYOo0`<3oemOGon_[joofm_KomoOgooWinOohn?SonOWioo[jn_oinOWomoOg0oohn?P2ooWin@03
oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOog
moL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;o
nOWi01?on_[jooWinOohn?SonOWiooShn?ogmoOokNg]omSHf?o1`L7oYJFUoi:BT_nHV9SoZ:RXokZj
^_o:b/[ofMWIon;Rh_oXj>Sok>c/0;Sok^k^01Coj>SXon;Rh_oIfMWob/[:okZj^_nXZ:SoV9RHoi:B
T_nUYJGo`<30omOGeoo[jn_om_KfooOgmooinOWon?ShooWinOojn_[onOWiooOgm`?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@0Coo[jn_oinOWon?ShooWinOohn?SomoOgong]kOoHf=So`L71ojFUYOnBTY;oV9RHojRXZ?nj
^[[ob/[:omWIfOoRh^;oj>SXonc/k02nonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0
^OoVi^H03?oMgMgoe]KFolO7aong]kOoXj>Soi6ATOnRXZ;obl_;onk^k_ofm_Koo?clooknoS_ooooo
00goo_knooclo?ogmoOokno_olc<c?nSXj?oTI6Aoj>SXong]kOoalO7omKFe_oMgMgoh^;R0;Soi^KV
00cogMgMomKFe_o7alOo]kNgoj>SXonATI7oXZ:Rol_;boo^k^kom_Kfooclo?ono_hkooooo`0=ookn
o_olo?comoOgono_koo<c<coXj>Soi6ATOnSXj?o]kNgolO7aooFe]KogMgMon;RhP2nonKViP7oU9BD
0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0^Oo^k^h02_oRh^;oe]KFol?3`on^[ZkoVYZJojf][OoN
g]kojn_[ooCdm?okno/oooooo`0;oo_knooclo?ok>c/on7QhOn`/;3oVYZJojj^[_o3`l?oe]KFon;R
h_oXj>P0^?o^k^h02_oRh^;oe]KFol?3`on^[ZkoVYZJojf][OoNg]kojn_[ooCdm?okno/oooooo`0;
oo_knooclo?ok>c/on7QhOn`/;3oVYZJojj^[_o3`l?oe]KFon;Rh_oXj>P0__o^k^h1oiBDU07ok^k^
0002ooooo`03oiBDU?oooooooooo0;Wooooo00[okNg]omcLg?o5aLGo[:b/ojf][OoDe=Coh>3Ponc/
k?oemOGooOgm?oooool02oono_kom_Kfonc/k?oRh^;ofMWIok6a/On/[:coaLG5omcLg?o]kNgom_Kf
0;Sooooo00[okNg]omcLg?o5aLGo[:b/ojf][OoDe=Coh>3Ponc/k?oemOGooOgm?oooool02oono_ko
m_Kfonc/k?oRh^;ofMWIok6a/On/[:coaLG5omcLg?o]kNgom_Kf0;kooooo0OnDU9@1ooooo`000_o^
k^h00onDU9Cok^k^onk^kP2ionk^kP0;omSHf?o6a/Ko[Zj^oj>SXoo6a/Koe=CDon3Ph?o/k>col_;b
ooclo?ono_h08?ooool00ooXj>Sod];Boogmo@0Kooooo`0;oo[jn_odm?Coj^[Zon?ShooGemOocLg=
ojJVY_n^[Zkoa/K6omSHf?oRh^80^?o^k^h02ooHf=Soa/K6ojj^[_nSXj?oa/K6omCDe?oPh>3ok>c/
oo;bl_olo?coo_kn03kooooo00_on_[jooCdm?oZj^[ohn?SomOGeoo=cLgoYZJVojj^[_o6a/Kof=SH
on;RhP2nonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0^OoVi^H03oo=cLgo^KVioj6Q
XOn[Zj_oa/K6om;Bd_oLg=coi^KVonc/k?oemOGon?Shoo[jn_omoOgoooooooclo008ooooo`03oogm
oOoooooooooo00Gooooo00GooOgmooooooooooooooooocHf=P02o`00000:oa4A4Om5ADGohN7Qoooo
oomFEUKo4A4AocLg=olI6AWoI6AToo3`l0Oooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`02ooooo`0@oogmoOoooooooOgmoo_knoohn?Som?Cdong]kOoVi^KogmoOomKFe_o<c<co/K6a
oj:RX_ni^KWocLg=om_KfkSoi^KV00oocLg=okVi^OnQXJ7oZj^[olK6a_oBd];og=cLonKVi_o/k>co
mOGeooShn?ojn_[ooOgmooooooolo?`02?ooool00oomoOgoooooooooo`05ooooo`05oogmoOoooooo
oooooooooolf=SH00_l000000olA4A7oADE5on7Qh@04ooooo`03onCTi?l0003ok>c/00Oooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`02ooooo`0@oogmoOoooooooOgmoo_knoohn?So
m?Cdong]kOoVi^KogmoOomKFe_o<c<co/K6aoj:RX_ni^KWocLg=om_Kfkkoi^KV0OnDU9@1onKViP00
0_o^k^h00onDU9Cok^k^onk^kP2ionk^kP0Com7AdOnk^k_oXJ6QokJf]_o3`l?oclo?omKFe_oOgmoo
i^KVon[Zj_o_knoolo?cooCdm?oemOGomoOgooKfm_ogmoOom_KfooShn002ooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg01;om_KfooShn?ld=3CoLg=coo7alOo=cLgo9RHVoeQH
F?ofm_Kog]kNooGemOogmoOofm_Ko`d=3Om`L73omoOgooKfm_ohn?P2ooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg01?om_KfooShn?ofm_KomoOgooKfm_odm?Col_;boo3`l?o[
jn_oi^KVon7QhOoJf][odm?ColW9bOno_kooYZJVok^k^ooAdM7ohN7Q0;Sok^k^01?odM7Aok^k^onQ
XJ7o][Jfol?3`oo?clooe]KFomoOgooVi^Koj^[Zono_kooclo?om?CdooGemOogmoOom_KfooOgmoof
m_Kon?Sh00;omoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL02_ofm_Kon?Sh
oc@d=?mcLg?olO7aolg=cOlV9RKoF5QHooKfm_ohn?P2ooOgm`06om_Kfol0003oi^KVooOgmoofm_Ko
n?Sh0_ogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`0CooKfm_ohn?Som_Kf
ooOgmoofm_Kom?Cdoo;bl_o`l?3ojn_[onKVi_oQhN7of][Jom?Cdoo9bLWo_knoojJVY_nk^k_odM7A
on7Qh@2nonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0^Oooool02ooOgmooaLG5ojBT
Y?nc/k?o`<30olW9bOoCdm?ofMWIomgMgOoRh^;oiNGU00;oj^[Z00?ok>c/ong]kOo]kNd01oo^k^h0
0oo`l?3ok^k^onk^kP05onk^kP06oo3`l?o^k^kok^k^onk^k_lb<S;oKfm_0_o^k^h00omUIFGo9RHV
onk^kP04onk^kP03oe=CDolo?cook^k^00Kok^k^00?ol?3`onk^k_o^k^h01Oo^k^h01?o`l?3ok^k^
onk^k_o^k^h2ong]k@;ok>c/00gojNWYonKVi_oShn?oh>3Pom_KfooEeMGocLg=olG5aOnk^k_oZj^[
olG5aOoOgmool?3`0;Sooooo00_ogmoOolG5aOnTY:Co/k>col30`?o9bLWodm?ComWIfOoMgMgoh^;R
onGUi@02on[ZjP03onc/k?o]kNgokNg]00Ook^k^00?ol?3`onk^k_o^k^h01Oo^k^h01_o`l?3ok^k^
onk^k_o^k^ko<S8bofm_K`;ok^k^00?oIFEUobHV9_oBd]800onLW9`01?n<S8co0000oi>CTooCdm<6
onk^kP03oo3`l?o^k^kok^k^00Gok^k^00Col?3`onk^k_o^k^kok^k^0_o]kNd2onc/k00=onWYjOoV
i^Kohn?Son3Ph?oKfm_oeMGEolg=cOo5aLGo^k^koj^[Zoo5aLGogmoOoo3`l02nooooo`7oU9BD0Ooo
ool000;ok^k^00?oU9BDonk^k_o^k^h0^Oo^k^h03Oo@d=3o^;RhoibLW?n/[:co^k^kolK6a_o=cLgo
dm?ComOGeooKfm_ogmoOon7QhOoRh^800_oShn<7onGUi@;oi^KV1_oUiND2onKViP?oiNGU00Ko<30`
ofYZJ_oUiNGoc/k>o``<3?maLG44onGUi@03om_KfolA4A7oMgMg00KoiNGU0_oVi^H6onGUi@;oi^KV
0ooUiND2onCTi0;ohn?S00goh^;Ron3Ph?oLg=cofMWIomKFe_o@d=3obLW9ol71`One]KGoYJFUokRh
^?o@d=3oh>3P0;Sok^k^00god=3@okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoO
gooQhN7oh^;R00;ohn?S1ooUiND2onKViPKoiNGU0_oVi^H3onGUi@0>oc0`<?mZJV[oiNGUolk>c_l<
30coLG5aojJVY_l10@7oATI6odQ8B?m6ATKo0000od=3@onb/[85onGUi@;oi^KV1_oUiND2onKViP?o
iNGU0_oTi>@2on?Sh`0=on;Rh_oPh>3og=cLomWIfOoFe]Kod=3@olW9bOo1`L7o]KFeojFUYOnh^;So
d=3@on3Ph02nonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0^OoVi^H03Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`2omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN00kogMgMobh^;_l[:b_o
=SHfoa<C4on4Q8Cog=cLomkNg_oMgMgoS8b<oe5ADOlP823oFe]Kolk>cP;og]kN0ooMgMd00ooNg]ko
gMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h2omgMg@;og=cL00kofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIfKSoi^KV00gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL0_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP0>omgMgOl^;Rko:b/[
ocHf=_lC4a?oQ8B4omcLg?oNg]koAdM7ofi^K_oMgMgofMWIo`000?o>c/h2omkNgP?ogMgM00?og]kN
omgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0_oMgMd2omcLg00>om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMVnonKViP7oU9BD0OoV
i^H000;ok^k^00?oU9BDonk^k_o^k^h0^Oo^k^h03OoDe=Co_knoohb<S?nNWYko[Jf]okVi^Oo2`/;o
alO7olc<c?o@d=3od];BomGEeOoFe]H00_oGemL00ooHf=SofMWIomWIf@0AomWIf@06obd];Om:BT[o
OGemocHf=_mVIVKoeMGE0_oIfMT01?n=SHgoDU9Boc0`<?nJVYXDomWIf@;of=SH0_oGemL03OoEeMGo
dm?Com3@d?o>c/kob/[:olG5aOno_koo]KFeojVYZOnHV9So_knoomCDe?oRh^80^?o^k^h03OoDe=Co
_knoohb<S?nNWYko[Jf]okVi^Oo2`/;oalO7olc<c?o@d=3od];BomGEeOoFe]H00_oGemL00ooHf=So
fMWIomWIf@0AomWIf@0=obd];Om:BT[oOGemocHf=_mVIVKoeMGEomWIfOo:b/[o71`Loj>SXooDe=Co
0000ol[:bP0ComWIf@;of=SH0_oGemL03OoEeMGodm?Com3@d?o>c/kob/[:olG5aOno_koo]KFeojVY
ZOnHV9So_knoomCDe?oRh^80__o^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0;Wooooo
00goj>SXomCDe?n<S8coTi>Coj:RX_n_[joo^[Zjol71`Oo7alOobl_;olk>c_o@d=3odM7A00;odm?C
0ooDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e008omGEeOl];BgoHf=SomGEeOo6a/Ko20P8oiJFU_oDe=@2omGEe@04omKFe_ng]kOo0P82ok>c/P;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@0@omCDe?oCdm?odm?Com7AdOo@d=3ocLg=ol[:b_o3`l?o_[jnokJf]_n[Zj_oWIfMoiFEUOoD
e=Coj>SXoo?clkSooooo00goj>SXomCDe?n<S8coTi>Coj:RX_n_[joo^[Zjol71`Oo7alOobl_;olk>
c_o@d=3odM7A00;odm?C0ooDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe00>omGEeOl];BgoHf=SomGEeOo6a/Ko20P8oiJFU_oDe=CoeMGEoj>SXolI
6AWo_knoo`000?o6a/D2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD04?oDe=Codm?Com?CdooAdM7od=3@olg=cOo:b/[o`l?3okjn__nf
][KoZj^[oifMWOnEUIGoe=CDonSXj?oclo>nooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^
k^h0^Oo^k^h04_oMgMgocLg=oi2@T?n9RHWoUiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooI
fMWof][Jom_KfooJf][ofm_KomcLg0Oofm_K00?og=cLom_KfooKfm/01OoKfm/02OoLg=cofm_Kobh^
;_mVIVKofm_KolO7aol820SoNg]komcLg003om_Kf`05om[Jf_lG5aOoQhN7om_KfooLg=`01ooKfm/0
0ooLg=cofm_Kom_Kf`05om_Kf`0ComcLg?oKfm_ofm_Kom_KfooJf][ofMWIomSHf?oFe]Kodm?Colg=
cOo2`/;o][Jfojb/[?nOWiooT92@oiJFU_o=cLgogMgMonGUi@2honk^kP0BomgMgOo=cLgoT92@ohV9
ROnGUiOoYJFUok:b/_no_koobl_;om7AdOoEeMGoemOGomWIfOoJf][ofm_Kom[Jf_oKfm_og=cL1ooK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`09omcLg?oKfm_o;Rh^ofIVI_oKfm_oalO7o`P82?mkNg_og=cL
00;ofm_K00KoKfm_oc/k>ol0003oc<c<om_KfooLg=`7om_Kf`03omcLg?oKfm_ofm_K00Gofm_K01?o
g=cLom_KfooKfm_ofm_Kom[Jf_oIfMWof=SHomKFe_oCdm?ocLg=ol;2`_nf][Ko[:b/oinOWon@T93o
UYJFolg=cOoMgMgoiNGU0;kok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP2ionKViP0;
om[Jf_o>c/koW9bLogYjN_n8R8SoUYJFojZZZ_o4a<CoeMGEom_KfooNg]h00_oPh>03on;RhP03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<04OoTi>Cohn?Son?Shol`<33o:BTYodA4
A?lB4Q;o5aLGomOGeooShn?oPX:2of5QHOn=SHgoEEEEo``<3?oEeMGoi>CT00Oohn?S00?oi>CTon?S
hooShn<01OoShn<01?oTi>Cohn?Son?ShooShn<2on;RhP0>on7QhOoPh>3ogmoOomcLg?oGemOoaLG5
ojb/[?nNWYkoT92@oh:2P_nPX:3oc/k>om[Jf_oPh>2honKViP0;om[Jf_o>c/koW9bLogYjN_n8R8So
UYJFojZZZ_o4a<CoeMGEom_KfooNg]h00_oPh>03on;RhP03onCTi?oShn?ohn?S00Gohn?S00?oi>CT
on?ShooShn<01OoShn<02OoTi>Cohn?Son?Shol`<33o:BTYodA4A?lB4Q;o5aLGomOGe`03on?Sh`05
on7QhOlh>3So0000om?CdooTi>@01ooShn<00ooTi>Cohn?Son?Sh`05on?Sh`04onCTi?oShn?ohn?S
on?Sh`;oh^;R00kohN7Qon3Ph?oOgmoog=cLomOGeoo5aLGo[:b/oijNW_n@T93oPX:2oj2PX?o>c/ko
f][Jon3Ph;koi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP2ionk^kP0>onGUiOoMgMgo
`/;2og]kNomhN7SoQXJ6oinOWoo5aLGof=SHomgMgOoOgmoohN7Qon;Rh_oShn<3onCTi0CoiNGU0_oT
i>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT01;oiNGUonCTi?oUiNGoiNGUoijNW_n:RX[oSHf=okVi
^OoShn?oi>CTonGUiOno_kooPH61of1PH?n:RX[ob<S8onGUiOoTi>@4onGUi@;oi>CT00?oiNGUonCT
i?oUiND00ooUiND2onCTi004onGUiOoTi>CoiNGUonGUi@?oi>CT00kohn?Son7QhOoPh>3ogmoOom[J
f_o6a/KoXJ6Qohf=SOn0P83oQ8B4ol?3`ooMgMgoiNGUon[Zj[Sok^k^00koiNGUomgMgOo2`/;oNg]k
ogQhN?n6QXKoWinOolG5aOoHf=SogMgMomoOgooQhN7oh^;Ron?Sh`?oi>CT1?oUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@02_oUiNGoi>CTonGUiOoUiNGoWYjNohZ:R_n=SHgo^KVion?ShooT
i>@4onGUi@04olg=cOn9RHWogmoOonCTi0CoiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00CoiNGUonCTi?oUiNGoiNGU0ooTi>@03_oShn?ohN7Qon3Ph?oOgmoof][JolK6a_nQXJ7oSHf=oh20
P?n4Q8Co`l?3omgMgOoUiNGoj^[Z__o^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0;Wo
oooo00_onOWioo?clooYjNWoZ:RXofEUIOmcLg?oSHf=ok^k^ooDe=Cof][JomgMg@02omoOg`03on3P
h?oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;R
h_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;R
h_oQhN7ohN7Q00KohN7Q00koh>3PomoOgooMgMgog=cLomGEeOni^KWoSXj>og]kNom^KVkoZj^[onWY
jOoclo?onOWioogmoKSooooo00_onOWioo?clooYjNWoZ:RXofEUIOmcLg?oSHf=ok^k^ooDe=Cof][J
omgMg@02omoOg`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00KohN7Q00koh>3PomoOgooMgMgog=cLomGEeOni^KWoSXj>
og]kNom^KVkoZj^[onWYjOoclo?onOWioogmoKkooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^
onk^kP2ionk^kP0<on_[jooXj>Soh^;RomOGeon=SHgoHV9RogIfM_nTY:CoalO7om;Bd_oEeMGof=SH
0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg00Dom_K
fooLg=cog=cLom_KfooLg=cofm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGoW9bLogEeMOmWIfOoT92@omOG
eooRh^;oj>SXon_[joo]kNfhonk^kP0<on_[jooXj>Soh^;RomOGeon=SHgoHV9RogIfM_nTY:CoalO7
om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcL
g005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcL
g005omcLg00Dom_KfooLg=cog=cLom_KfooLg=cofm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGoW9bLogEe
MOmWIfOoT92@omOGeooRh^;oj>SXon_[joo]kNfnonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKV
i_oVi^H0^OoVi^H03_oUiNGoh^;RomoOgooJf][obLW9ohN7QomJFU[oNg]koj>SXonl_;coa/K6ol_;
boo=cLgoclo?0_oAdM45om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]80
0ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]80
0ooAdM7od];Bom7Ad@03om;BdP;odM7A00god=3@olo?coo<c<cob<S8ok^k^onLW9coLW9boe]KFon:
RX[obLW9om[Jf_oOgmooh^;R00;oiNGU^?oVi^H03_oUiNGoh^;RomoOgooJf][obLW9ohN7QomJFU[o
Ng]koj>SXonl_;coa/K6ol_;boo=cLgoclo?0_oAdM45om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@03om;BdP;odM7A00god=3@olo?coo<c<cob<S8
ok^k^onLW9coLW9boe]KFon:RX[obLW9om[Jf_oOgmooh^;R00;oiNGU__oVi^H1oiBDU07oi^KV0002
onk^kP03oiBDU?o^k^kok^k^0;Wok^k^0_o]kNd03_oZj^[oj>SXon;Rh_oLg=coW9bLofe]KOmXJ6So
Ph>3oiNGUonSXj?o[:b/ojn_[ona/K7o/[:b0_nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@04one]KGo][JdokBd]?nd];Co][Jfok>c/onb/[;o/k>cojn_[onZZZ[oW9bLoh:2P_mRHV;oKVi^
oinOWooLg=coh^;RonSXj?oZj^X00_o]kNfionk^kP;okNg]00koj^[ZonSXj?oRh^;og=cLoibLW?m]
KFgoJ6QXoh>3PonGUiOoXj>Sojb/[?n_[joo/K6aok:b/P;o];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd01?o]KFeokJf]?nd];Co];BdokJf]_nc/k?o/[:bok>c/on_[jooZZZZoibLW?n2PX;o
HV9Rofi^K_nOWioog=cLon;Rh_oXj>Soj^[Z00;okNg]_oo^k^h1oiBDU07ok^k^0002ooooo`03oiBD
U?oooooooooo0;[ooooo0_ono_h03oolo?conOWiooKfm_obl_;ofMWIojRXZ?n3Ph?oKVi^ofEUIOmY
JFWoLW9bogAdM?miNGWoO7alog]kN`02ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00OoO7alog]kNomlO7coOGelogalO?mkNg_oOGem00;oNWYj00_oMgMgogAdM?m_KfooM7AdohF5
QOnXZ:Sof][Joo;bl_ofm_KonOWiooclo002ookno[_ooooo0_ono_h03oolo?conOWiooKfm_obl_;o
fMWIojRXZ?n3Ph?oKVi^ofEUIOmYJFWoLW9bogAdM?miNGWoO7alog]kN`02ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00OoO7alog]kNomlO7coOGelogalO?mkNg_oOGem00;oNWYj
00_oMgMgogAdM?m_KfooM7AdohF5QOnXZ:Sof][Joo;bl_ofm_KonOWiooclo002ookno/3ooooo0OnD
U9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP2konk^kP;okNg]00Cok>c/on[Zj_oXj>SoiNGU0_oR
h^800ooPh>3ogmoOomkNgP0iomgMg@03omkNg_oOgmooh>3P00;oh^;R00CoiNGUonSXj?oZj^[ok>c/
0_o]kNfmonk^kP;okNg]00Cok>c/on[Zj_oXj>SoiNGU0_oRh^800ooPh>3ogmoOomkNgP0iomgMg@03
omkNg_oOgmooh>3P00;oh^;R00CoiNGUonSXj?oZj^[ok>c/0_o]kNg1onk^kP7oU9BD0Oo^k^h000;o
i^KV00?oU9BDonKVi_oVi^H0_OoVi^H2onGUi@03onCTi?oRh^;oh^;R00;oh>3P0_oOgmliomkNgP;o
gmoO0_oPh>02on;RhP03onCTi?oUiNGoiNGU0<7oi^KV0_oUiND00ooTi>Coh^;Ron;RhP02on3Ph0;o
gmoO>OoNg]h2omoOg`;oh>3P0_oRh^800ooTi>CoiNGUonGUi@33onKViP7oU9BD0OoVi^H000;ok^k^
00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP000_ooool00onDU9Cooooooooo
o`3ooooooooooooofOooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kI
onk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^KoonKVi]Woi^KV0OnDU9@1onKV
iP000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002ooooo`03oiBD
U?oooooooooo0?oooooooooooooIooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^
k^koonk^k]Wok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP08onKViP03olg=cOnk^k_o
g=cL00Soi^KV00?ohn?SomOGeooVi^H01_oVi^H00ooLg=codM7AonKViP3oonKVi_ooi^KV^_oVi^H1
oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^00Kok^k^00[oTi>Coa8B4_l>3Pko;Rh^oa<C4olM
7Ago_;blonk^k_lk>c_oMWIf0_o^k^h01_nb/[;o6ATIo`H61_m<C4coOGemob`/;0;ok^k^00KoemOG
odE5AOl20P;o820PoaDE5Ond];@5onk^kP03oa8B4_l0003o000000;o000000?oCTi>onk^k_o^k^h0
ooo^k^koonk^kZcok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`05ooooo`03oiNGUol4
10CoU9BD00;ooooo00KolO7ao`000?nj^[[ooooood10@?moOgl2ooooo`06oeADE?mIFEWomoOgoijN
W_l?3`oo<30`0_ooool01_m4A4Co@410omoOgooooooolo?coo;blPGooooo00?oE5ADobh^;_oVi^H0
0_oVi^H00oo_knooooooooooo`3ooooooooooooo[?ooool1oiBDU07ooooo0002onk^kP03oiBDU?o^
k^kok^k^00Cok^k^00?oinOWoa8B4_mQHF400oo^k^h01_oPh>3o0000ojf][Oo^k^ko>c/kogIfMP;o
k^k^00[o:BTYohJ6Q_o^k^kok^k^og5aLOl/;2cok^k^olk>c_l0003oZj^[2Oo^k^h00ooEeMGo61PH
oiNGU`3oonk^k_ook^k^/Oo^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV00Coi^KV00?o
_knoo`000?n_[jl00ooVi^H01_oIfMWo0000ojNWYooVi^Ko>CTiog9bLP;oi^KV00[o9bLWohB4Q?oV
i^Koi^KVoh20P?l[:b_oi^KVoj^[Zol0003o=cLg0olh>3P00on`/;3oi^KVonKViP04onKViP03ol71
`OlG5aOoVIVI0?ooi^KVoooVi^J`onKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h01?o^
k^h00onWYjOo0000om;BdP04onk^kP05on3Ph?o[jn_ok^k^oc/k>omfMWH00_o^k^h03_lY:BWoRHV9
onk^k_o^k^koQHF5ob`/;?o^k^koc<c<o`000?nOWioo`L71okVi^Ol20P;oeMGE1oo^k^h00oo;bl_o
6ATIoi^KV`3oonk^k_ook^k^[oo^k^h1oiBDU07ok^k^0002ooooo`OoU9BD00?oa/K6o`000?oBd]80
1oooool01_m0@43oOgmooooooooooooo;2`/oi>CT`;ooooo00WoShn?oc0`<?oooooooooooclo?om[
Jf_omoOgoijNW_l[:b/02Oooool01?o9bLWo2@T9olK6a_oooooooiBDU?ooU9BD[_nDU9@1ooooo`00
2Oo^k^h00ooMgMgo0000oi:BTP07onk^kP06oc/k>omfMWKok^k^onk^k_ln?SkoTi>C0_o^k^h02On@
T93o@D51onk^k_o^k^koe]KFod92@_l<30co6QXJojZZZP0:onk^kP03ocXj>_mUIFGok^k^0?ook^k^
ooo^k^j_onk^kP002_oVi^H00omIFEWo820PomCDe006onKViP03ocTi>OmbLW;oi^KV00_oi^KV00?o
hn?SonKVi_oVi^H01_oVi^H01_oUiNGoi^KVonKVi_oVi^Ko;Bd]ofi^K_ooi^KVoooVi^J`onKViP00
2_o^k^h02ooKfm_o?3`loa`L7?mbLW;oS8b<ofe]KOl];Bgo/K6aonk^k_lk>c_oMWIf01Gok^k^00Ko
E5ADoda<C?n?ShooFEUIo`D51OoCdm?oonk^k_ook^k^/?o^k^h000_ooooo00[oo_knok6a/OmoOgoo
JVYZoh^;Ron_[joolO7aoooooom0@43oOgmo5Oooool01OoZj^[o[Jf]og=cLonKVi_ok>c/0?oooooo
oooooonaooooo`004oo^k^h00ooZj^[ok>c/onk^kP3oonk^k_ook^k^b_o^k^h00?ooi^KVoooVi^KP
onKViP00ooo^k^koonk^k^3ok^k^003oooooooooooooh?ooool00?ook^k^ooo^k^kPonk^kP000_oV
i^KooiBDU?ooU9BDgOnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^fOo^k^h1
oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oooooooooooooIooooo`7oU9BD0Oooool000;o
k^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KV
onKViP3oonKVi_ooi^KVfOoVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^00;ok^k^0_o]
kNd02_o[jn_oj>SXonGUiOoRh^;ogMgMomSHf?oDe=CodM7Aolk>c_o<c<`2ol_;bcGob/[:0_o;bl/0
2_o<c<coc/k>om7AdOoDe=Cof=SHomgMgOoRh^;oiNGUonSXj?o[jn/2ong]kOook^k^ooo^k^h_onk^
kP;okNg]00[ojn_[onSXj?oUiNGoh^;RomgMgOoHf=Soe=CDom7AdOo>c/koc<c<0_o;bl/eol[:bP;o
bl_;00[oc<c<olk>c_oAdM7oe=CDomSHf?oMgMgoh^;RonGUiOoXj>Sojn_[0_o]kNd6onk^kP7oU9BD
0Oo^k^h000;ooooo00CoU9BDoooooooooooooooo0_ono_h02_okno_onOWioo?cloo]kNgoiNGUomcL
g?oDe=Coc<c<olO7aoo3`l<2ol30`0;o_kno<onn_[h2okno_`;o`<3000[o`l?3olO7aoo<c<coe=CD
omcLg?oUiNGokNg]oo?clooinOWono_k0_ono_kooooooooooooo;Oooool2ooknoP0:oo_knooinOWo
lo?cong]kOoUiNGog=cLomCDe?o<c<coalO7ol?3``;o`<300_no_klcokjn_P;o_kno0_o0`<002_o3
`l?oalO7olc<c?oDe=Cog=cLonGUiOo]kNgolo?cooWinOokno/2ooknoPGooooo0OnDU9@1ooooo`00
0_o^k^h04_nDU9Cok^k^onk^k_o^k^kokNg]on[Zj_oWinOoh^;RomWIfOo>c/ko`l?3okRh^?n^[Zko
YZJVoj2PX?nLW9coVIVIoiRHV3OoUiNG00goV9RHoiVIVOnLW9coX:2PojJVY_n^[Zko^;Rhol?3`oo>
c/kofMWIon;Rh_oWinOoj^[Z00;okNg]ooo^k^koonk^kRcok^k^00kokNg]on[Zj_oWinOoh^;RomWI
fOo>c/ko`l?3okRh^?n^[ZkoYZJVoj2PX?nLW9coVIVIoiRHV3OoUiNG00goV9RHoiVIVOnLW9coX:2P
ojJVY_n^[Zko^;Rhol?3`oo>c/kofMWIon;Rh_oWinOoj^[Z00;okNg]1?o^k^h1oiBDU07ok^k^0002
onKViP0AoiBDU?oVi^Koi^KVonKVi_oShn?oh>3Pom[Jf_oAdM7oaLG5okNg]onXZ:SoW9bLoi2@T?n8
R8SoPH61oginO_mkNg/0>OmjNWX03_mkNg_oOWinoh61POn8R8SoT92@oibLW?nXZ:So]kNgolG5aOoA
dM7of][Jon3Ph?oShn?oiNGUoooVi^KoonKViRcoi^KV00gohn?Son3Ph?oJf][odM7AolG5aOng]kOo
Z:RXoibLW?n@T93oR8R8oh61POmnOWkoNg]k03WoNWYj00koNg]koginO_n1PH7oR8R8oi2@T?nLW9co
Z:RXokNg]oo5aLGodM7Aom[Jf_oPh>3ohn?SonGUi@Coi^KV0OnDU9@1onKViP000_o^k^h06?nDU9Co
k^k^onk^k_o^k^koj>SXon;Rh_oIfMWob/[:okZj^_nXZ:SoV9RHoi:BT_nUYJGo`<30omOGeoo[jn_o
m_KfooOgmooinOWon?ShooWinOojn_[onOWiooOgm`?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooSh
n0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00ooj
n_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@0Coo[jn_oinOWon?Sh
ooWinOohn?SomoOgong]kOoHf=So`L71ojFUYOnBTY;oV9RHojRXZ?nj^[[ob/[:omWIfOoRh^;oj>SX
onc/k03oonk^k_ook^k^;?o^k^h05?oXj>Soh^;RomWIfOo:b/[o^[ZjojRXZ?nHV9SoTY:BojFUYOo0
`<3oemOGon_[joofm_KomoOgooWinOohn?SonOWioo[jn_oinOWomoOg0oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi01?o
n_[jooWinOohn?SonOWiooShn?ogmoOokNg]omSHf?o1`L7oYJFUoi:BT_nHV9SoZ:RXokZj^_o:b/[o
fMWIon;Rh_oXj>Sok>c/00Cok^k^0OnDU9@1onk^kP000_ooool04?nDU9Cooooooooooooooooom_Kf
ong]kOoMgMgob/[:okBd]?nOWiooZZZZolk>c_o^k^kom_Kfooclo?ono_hkooooo`0=ookno_olo?co
moOgono_koo?clooZj^[oinOWond];Cob/[:omgMgOo]kNgom_Kfoo_kn`3ooooooooooooo;?ooool0
3?ofm_KokNg]omgMgOo:b/[o];BdoinOWonZZZ[oc/k>onk^k_ofm_Koo?clooknoS_ooooo00goo_kn
ooclo?ogmoOokno_olo?con[Zj_oWinOokBd]?o:b/[ogMgMong]kOofm_Kono_k00Cooooo0OnDU9@1
ooooo`000_o^k^h03_nDU9Cok^k^onk^k_o^k^koh^;RomKFe_o3`l?o[Zj^oiZJV_n][Jgog]kNon_[
joodm?Cono_k?oooool02ookno_olo?conc/k?oQhN7o/;2`oiZJV_n^[Zko`l?3omKFe_oRh^;oj>SX
0?ook^k^ooo^k^h/onk^kP0:on;Rh_oFe]Ko`l?3ojj^[_nJVY[o[Jf]omkNg_o[jn_om?Cdoo_kncoo
oooo00_ono_koo?cloo/k>cohN7Qok2`/?nJVY[o[Zj^ol?3`ooFe]Koh^;RonSXj004onk^kP7oU9BD
0Oo^k^h000;oi^KV00koU9BDonKVi_oVi^Koi^KVomKFe_o7alOo/[:boibLW?nWYjOoe=CDon3Ph?o/
k>comOGeoogmoCoooooo00_oo_knooKfm_o/k>coh^;RomWIfOn[Zj_oW9bLok:b/_o7alOoe]KFomgM
g@3oonKVi_ooi^KV;?oVi^H02_oFe]KoalO7ok:b/_nLW9coYjNWomCDe?oPh>3ok>c/ooGemOomoOdo
ooooo`0;ookno_ofm_Kok>c/on;Rh_oIfMWoZj^[oibLW?nb/[;oalO7omKFe_oMgMd01?oVi^H1oiBD
U07oi^KV0002onk^kP0?oiBDU?o^k^kok^k^onk^k_oHf=Soa/K6ojj^[_nSXj?oa/K6omCDe?oPh>3o
k>c/oo;bl_olo?coo_kn03kooooo00_on_[jooCdm?oZj^[ohn?SomOGeoo=cLgoYZJVojj^[_o6a/Ko
f=SHon;RhP3oonk^k_ook^k^;?o^k^h02ooHf=Soa/K6ojj^[_nSXj?oa/K6omCDe?oPh>3ok>c/oo;b
l_olo?coo_kn03kooooo00_on_[jooCdm?oZj^[ohn?SomOGeoo=cLgoYZJVojj^[_o6a/Kof=SHon;R
hP04onk^kP7oU9BD0Oo^k^h000;ooooo01?oU9BDooooooooooooooooon?Shoo=cLgo/;2`ojn_[oo6
a/Kod];BomcLg?oVi^Kok>c/ooGemOohn?Son_[joogmoOooooooo?cl00Sooooo00?ooOgmoooooooo
ool01Oooool01OomoOgooooooooooooooooo=SHf00;o000000[o4A4AodE5AOoQhN7oooooooGemOl?
3`oo30`<o`000?l>3Pko5ADE1oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00;o
oooo013ooOgmooooooomoOgono_kooShn?odm?CokNg]onKVi_oOgmooe]KFolc<c?ne]KGo/K6aolg=
cOoShn?olo?cooooooooooooobcooooo00oohn?Solg=cOn`/;3o[jn_olK6a_oBd];og=cLonKVi_o/
k>comOGeooShn?ojn_[ooOgmooooooolo?`02?ooool00oomoOgoooooooooo`05ooooo`05oogmoOoo
oooooooooooooolf=SH00_l000001OlA4A7oADE5on7QhOoooooo51@D00Co000000?oDe=Coooooooo
ool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00;ooooo013ooOgmooooooom
oOgono_kooShn?odm?CokNg]onKVi_oOgmooe]KFolc<c?ne]KGo/K6aolg=cOoShn?olo?c1?ooool1
oiBDU07ooooo0002onk^kP0GoiBDU?o^k^kok^k^onk^k_oAdM7o^k^koj6QXOnf][Ko`l?3olo?cooF
e]KogmoOonKVi_oZj^[okno_oo?cloodm?ComOGeooOgmoofm_KomoOgooKfm_ohn?P00_ogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`0>ooKfm_ohn?So=3@dog=cLooalO7ocLg=
obHV9_mHF5Som_KfooShn?ogmoOoc/k>o`000?oOgml2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg01?om_KfooShn?ofm_KomoOgooKfm_odm?Co
l_;boo3`l?o[jn_oi^KVon7QhOoJf][odm?ColW9bOno_kooYZJVok^k^ooAdM7ohN7Q0?ook^k^ooo^
k^h/onk^kP0Com7AdOnk^k_oXJ6QokJf]_o3`l?oclo?omKFe_oOgmooi^KVon[Zj_o_knoolo?cooCd
m?oemOGomoOgooKfm_ogmoOom_KfooShn002ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00com_KfooShn?ld=3CoLg=coo7alOo=cLgo9RHVoeQHF?ofm_KoDE5Aob`/;?oNg]h2
omgMg@04onOWioogmoOom_KfooShn0;omoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL04oofm_Kon?ShooKfm_ogmoOom_KfooCdm?obl_;ol?3`on_[jooVi^KohN7Qom[Jf_oCdm?o
bLW9okno_onVYZKo^k^kom7AdOoQhN401?o^k^h1oiBDU07ok^k^0002onKViP0?oiBDU?oVi^Koi^KV
onKVi_o9bLWo/[:boijNW_nc/k?o`<30olW9bOoCdm?ofMWIomgMgOoRh^;oiNGU00;oj^[Z00?ok>c/
ong]kOo]kNd01oo^k^h00oo`l?3ok^k^onk^kP05onk^kP06oo3`l?o^k^kok^k^onk^k_lb<S;oKfm_
0_o^k^h00omUIFGo9RHVonk^kP02onk^kP04olK6a_l0003of=SHoo3`l0Ook^k^00?ol?3`onk^k_o^
k^h01Oo^k^h01?o`l?3ok^k^onk^k_o^k^h2ong]k@;ok>c/00gojNWYonKVi_oShn?oh>3Pom_KfooE
eMGocLg=olG5aOnk^k_oYJFUok:b/_o9bLWof=SH0?ooi^KVoooVi^H/onKViP0;olW9bOnb/[;oWYjN
ok>c/oo0`<3obLW9om?CdooIfMWogMgMon;Rh_oUiND00_oZj^X00oo/k>cokNg]ong]k@07onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00Kol?3`onk^k_o^k^kok^k^oc8b<_m_Kfl2onk^kP06ofEUIOlV9RKo
k^k^omGEeOlH61SoUiNG0_o^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00Col?3`onk^k_o^k^kok^k^0_o]kNd2onc/k00=onWYjOoVi^Kohn?Son3Ph?oKfm_oeMGEolg=cOo5
aLGo^k^kojFUYOnb/[;obLW9omSHf004onKViP7oU9BD0OoVi^H000;ok^k^017oU9BDonk^k_o^k^ko
k^k^om3@d?nh^;SoW9bLojb/[?nk^k_oa/K6olg=cOoCdm?oemOGom_KfooOgmoohN7Qon;RhP02on?S
h`OoiNGU0_oVi^H6onGUi@;oi^KV0ooUiND01_l`<33oJVYZonGUiOo>c/ko30`<og5aL@?oiNGU00Co
_knoo`000?oAdM7oi^KV1_oUiND2onKViPKoiNGU0_oVi^H3onGUi@;oi>CT0_oShn<03OoRh^;oh>3P
omcLg?oIfMWoe]KFom3@d?o9bLWo`L71okFe]OnUYJGo^;Rhom3@d?oPh>00ooo^k^koonk^kRcok^k^
00god=3@okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoOgooQhN7oh^;R00;ohn?S
1ooUiND2onKViPKoiNGU0_oVi^H3onGUi@06oc0`<?mZJV[oiNGUolk>c_l<30coLG5a0_oUiND00oo1
`L7o5aLGoiRHV002onKViPKoiNGU0_oVi^H6onGUi@;oi^KV0ooUiND2onCTi0;ohn?S00goh^;Ron3P
h?oLg=cofMWIomKFe_o@d=3obLW9ol71`One]KGoYJFUokRh^?o@d=3oh>3P00Cok^k^0OnDU9@1onk^
kP000_ooool04OnDU9Coooooooooooooooooh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cL0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP08omgMgOl^;Rko:b/[ocHf=_lC4a?oQ8B4omcLg?oNg]h2omgMg@04
okRh^?l0003obLW9omgMg@;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgM
gOoMgMd00_oNg]h2omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3Poo7alOooooooooooool/ooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0;og]kN0ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h02?oMgMgo;Rh^ob/[:olf=SKo4a<CohB4Q?oLg=co
g]kN0_oMgMd01?nl_;co5aLGoi2@T?oMgMd2omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgM
g@03omkNg_oMgMgogMgM00;og]kN0_oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO44ooooo`7oU9BD0Oooool000;ok^k^017oU9BDonk^
k_o^k^kok^k^omCDe?no_kooS8b<oijNW_n][Jgo^KViol;2`_o7alOoc<c<om3@d?oBd];oeMGEomKF
eP02omOGe`03omSHf?oIfMWofMWI017ofMWI00Ko;Bd]odY:B_mmOGgo=SHfofIVI_oEeMD3omWIf@03
okFe]Ol0003oaLG501CofMWI0_oHf=P2omOGe`0=omGEeOoCdm?od=3@olk>c_o:b/[oaLG5okno_one
]KGoZJVYoiRHV?no_kooe=CDon;RhP3oonk^k_ook^k^;?o^k^h03OoDe=Co_knoohb<S?nNWYko[Jf]
okVi^Oo2`/;oalO7olc<c?o@d=3od];BomGEeOoFe]H00_oGemL00ooHf=SofMWIomWIf@0AomWIf@06
obd];Om:BT[oOGemocHf=_mVIVKoeMGE1?oIfMT00on[Zj_o1`L7ojRXZ00ComWIf@;of=SH0_oGemL0
3OoEeMGodm?Com3@d?o>c/kob/[:olG5aOno_koo]KFeojVYZOnHV9So_knoomCDe?oRh^801?o^k^h1
oiBDU07ok^k^0002onKViP0AoiBDU?oVi^Koi^KVonKVi_oAdM7o_knoohR8R?nCTi?oXZ:Rojn_[onj
^[[o`L71olO7aoo;bl_oc/k>om3@d?oAdM400_oCdm<3omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD00SoeMGEobd];OmSHf?oeMGEolK6a_l820So
UYJFomCDe0;oeMGE00Co/[:bo`000?o2`/;oeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE013oe=CDom?CdooCdm?odM7Aom3@d?o=
cLgob/[:ol?3`onn_[ko][Jfoj^[ZonMWIgoTI6Aokno_ooAdM7ofm_KoooVi^KoonKViRcoi^KV00go
dM7Aokno_on8R8SoTi>Coj:RX_n_[joo^[Zjol71`Oo7alOobl_;olk>c_o@d=3odM7A00;odm?C0ooD
e=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe008
omGEeOl];BgoHf=SomGEeOo6a/Ko20P8oiJFU_oDe=@2omGEe@04omKFe_oEeMGo=3@doe]KFP;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGE
e@0@omCDe?oCdm?odm?Com7AdOo@d=3ocLg=ol[:b_o3`l?o_[jnokJf]_n[Zj_oWIfMoi6ATOno_koo
dM7Aom_Kf`Coi^KV0OnDU9@1onKViP000_o^k^h05_nDU9Cok^k^onk^k_o^k^kogMgMolg=cOn@T93o
RHV9oiNGUonUYJGo/[:bokno_oo;bl_odM7AomGEeOoGemOofMWIom[Jf_oKfm_of][Jom_KfooLg=`7
om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00kog=cLom_Kfol^;RkoIVIVom_Kfoo7alOo20P8og]kNooL
g=cof][JomKFe_nf][Ko0000olO7a`;ofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_K
f`05om_Kf`0ComcLg?oKfm_ofm_Kom_KfooJf][ofMWIomSHf?oFe]Kodm?Colg=cOo2`/;o][Jfojb/
[?nOWiooT92@oiJFU_o=cLgogMgMonGUi@3oonk^k_ook^k^;?o^k^h04_oMgMgocLg=oi2@T?n9RHWo
UiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooIfMWof][Jom_KfooJf][ofm_KomcLg0Oofm_K
00?og=cLom_KfooKfm/01OoKfm/02_oLg=cofm_Kobh^;_mVIVKofm_KolO7aol820SoNg]komcLg?oJ
f]X3om_Kf`04obXZ:_mYJFWofm_KomcLg0Oofm_K00?og=cLom_KfooKfm/01OoKfm/04ooLg=cofm_K
om_KfooKfm_of][JomWIfOoHf=Soe]KFom?Cdoo=cLgo`/;2okJf]_n/[:coWinOoi2@T?nFUYKocLg=
omgMgOoUiND01?o^k^h1oiBDU07ok^k^0002ooooo`0?oiBDU?ooooooooooooooooobl_;oiNGUojVY
ZOmjNW[oR8R8oiJFU_nZZZ[oa<C4omGEeOoKfm_og]kN00;oh>3P0ooRh^800ooTi>Cohn?Son?Sh`05
on?Sh`03onCTi?oShn?ohn?S00Gohn?S017oi>CTon?ShooShn?o<30`obTY:Om4A4Co4Q8BoaLG5ooG
emOohn?Som[Jf_lA4A7o;bl_o`000?o>c/kohn?SonCTi007on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00Coi>CTon?ShooShn?ohn?S0_oRh^803_oQhN7oh>3PomoOgooLg=coemOGolG5aOn/[:coWYjNoi2@
T?n2PX;o[Jf]onGUiOobl_;onOWiooooooooooooobcooooo00_ol_;bonGUiOnYZJWoNWYjohR8R?nF
UYKoZZZZolC4a?oEeMGofm_KomkNgP02on3Ph0?oh^;R00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`0AonCTi?oShn?ohn?Soc0`<?lY:BWoA4A4oa8B4_lG5aOoemOGon?Shom@D53o
B4Q8ohV9ROmEEEGo1@D5ol[:b_oTi>@01ooShn<00ooTi>Cohn?Son?Sh`05on?Sh`04onCTi?oShn?o
hn?Son?Sh`;oh^;R00kohN7Qon3Ph?oOgmoog=cLomOGeoo5aLGo[:b/oijNW_n@T93oPX:2ojf][OoU
iNGol_;booWin@Cooooo0OnDU9@1ooooo`000_o^k^h04_nDU9Cok^k^onk^k_o^k^koiNGUomgMgOo2
`/;oNg]kogQhN?n6QXKoWinOolG5aOoHf=SogMgMomoOgooQhN7oh^;Ron?Sh`?oi>CT1?oUiND2onCT
i003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@02_oUiNGoi>CTonGUiOoUiNGoWYjNohZ:R_n=SHgo^KVi
on?ShooTi>@2onGUi@06omoOgon`/;3oMWIfomOGeooUiNGoi>CT1?oUiND2onCTi003onGUiOoTi>Co
iNGU00?oiNGU0_oTi>@01?oUiNGoi>CTonGUiOoUiND3onCTi00>on?ShooQhN7oh>3PomoOgooJf][o
a/K6oj6QXOn=SHgoP820ohB4Q?o3`l?ogMgMonGUiOoZj^[oonk^k_ook^k^;?o^k^h03_oUiNGogMgM
ol;2`_mkNg_oN7QhohJ6Q_nOWiooaLG5omSHf?oMgMgogmoOon7QhOoRh^;ohn?S0ooTi>@4onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi00BonGUiOoTi>CoiNGUonGUiOnNWYkoRXZ:ohf=SOni
^KWohn?SonCTi?oUiNGod];Boi^KVomWIfOoRXZ:om?CdooUiNGoi>CT1?oUiND2onCTi003onGUiOoT
i>CoiNGU00?oiNGU0_oTi>@01?oUiNGoi>CTonGUiOoUiND3onCTi00>on?ShooQhN7oh>3PomoOgooJ
f][oa/K6oj6QXOn=SHgoP820ohB4Q?o3`l?ogMgMonGUiOoZj^X4onk^kP7oU9BD0Oo^k^h000;oi^KV
00ooU9BDonKVi_oVi^Koi^KVon3Ph?oKfm_od];Boi^KVomUIFGoLg=cohf=SOnk^k_oe=CDom[Jf_oM
gMd00_oOgml00ooPh>3ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQ
hN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQ
hN401OoQhN400ooRh^;ohN7Qon7Qh@06on7Qh@0>on3Ph?oOgmoogMgMomcLg?oEeMGo^KViohj>S_mk
Ng_oKVi^oijNW_oBd];ofm_Kon3Ph?oTi>CoonKVi_ooi^KV;?oVi^H02ooPh>3ofm_Kom;Bd_nKVi_o
IFEUog=cLon=SHgo^k^komCDe?oJf][ogMgM00;ogmoO00?oh>3Pon7QhOoQhN401OoQhN400ooRh^;o
hN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;o
hN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401_oQhN403_oPh>3o
gmoOomgMgOoLg=coeMGEokVi^On>SXkoNg]kofi^K_nNWYkod];Bom_KfooPh>3oi>CT1?oVi^H1oiBD
U07oi^KV0002onk^kP0@oiBDU?o^k^kok^k^onk^k_o[jn_oj>SXon;Rh_oGemOoSHf=of9RH_mfMWKo
Y:BTolO7aooBd];oeMGEomSHf0;of][J0ooKfm/7omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`05?oKfm_og=cLomcLg?oKfm_og=cLom_KfooJf][ofMWIomSHf?oCdm?oaLG5
oibLW?meMGGoIfMWoi2@T?oGemOoh^;RonSXj?o[jn_okNg]ooo^k^koonk^kRcok^k^00cojn_[onSX
j?oRh^;oemOGohf=SOmRHV;oMWIfojBTY?o7alOod];BomGEeOoHf=P2om[JfP?ofm_K1ooLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL01Cofm_KomcLg?oLg=cofm_KomcLg?oK
fm_of][JomWIfOoHf=Sodm?ColG5aOnLW9coMGEeofMWIon@T93oemOGon;Rh_oXj>Sojn_[ong]k@Co
k^k^0OnDU9@1onk^kP000_ooool04_nDU9Coooooooooooooooooo_knoo_knoohn?Sol_;bomkNg_nA
TI7oFUYJog]kNonSXj?o_;blolK6a_o;bl_ocLg=olo?c`;odM7A1OoBd]800ooAdM7od];Bom7Ad@05
om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05
om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM400ooBd]82om7Ad@0=om3@d?o?cloo
c<c<olS8b?nk^k_oW9bLog9bL_mKFe_oU9BDomkNg_obl_;on?Shoo_kn`02ookno_ooooooooooool/
ooooo`0>ookno_okno_on?Shoo;bl_oNg]koTI6AoeYJF_mkNg_oXj>Sokbl_?o6a/Kobl_;olg=cOo?
cll2om7Ad@God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoB
d];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoB
d];odM7A00?od];B0_oAdM403Oo@d=3oclo?olc<c?o8b<So^k^koibLW?mbLW;oFe]KoiBDU?oNg]ko
l_;booShn?okno/00_ono_h4ooooo`7oU9BD0Oooool000;ok^k^00CoU9BDonk^k_o^k^kok^k^0_o]
kNd03_oZj^[oj>SXon;Rh_oLg=coW9bLofe]KOmXJ6SoPh>3oiNGUonSXj?o[:b/ojn_[ona/K7o/[:b
0_nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@04one]KGo][JdokBd]?nd];Co][Jfok>c
/onb/[;o/k>cojn_[onZZZ[oW9bLoh:2P_mRHV;oKVi^oinOWooLg=coh^;RonSXj?oZj^X00_o]kNgo
onk^k_ook^k^;Oo^k^h2ong]k@0>on[Zj_oXj>Soh^;RomcLg?nLW9coKFe]ofQXJ?n3Ph?oUiNGoj>S
Xon/[:co[jn_ok6a/Onb/[82okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]00CokFe]Onf
][Co];BdokBd]?nf][Ko/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9RH_m^KVkoWinOomcLg?oR
h^;oj>SXon[ZjP02ong]k@Gok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP02onKViP;o
iNGU00oohn?Son3Ph?oMgMgof][JolC4a?nJVY[oNWYjofUYJOmSHf?oJFUYog9bL_mdM7CoNGUiogal
O?mkNg/00_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@07ogalO?mkNg_oO7al
ogemO?mlO7coNg]kogemO@02ogYjNP0;ogMgMomdM7CoKFe]ofm_KomlO7coVYZJolG5aOoJf][ogMgM
on3Ph?oShn<00_oUiNGoonKVi_ooi^KV;ooVi^H2onGUi@0?on?ShooPh>3ogMgMom[Jf_o4a<CoVYZJ
ogYjN_mYJFWoHf=SofUYJOmbLW;oM7AdogUiNOmlO7coNg]k00;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01omlO7coNg]kogalO?mmOGcoO7alog]kNommOGd00_mjNWX02omgMgOo
M7Adofe]KOm_KfooO7aloiZJV_o5aLGof][JomgMgOoPh>3ohn?S00;oiNGU1_oVi^H1oiBDU07oi^KV
0002onk^kP03oiBDU?o^k^kok^k^00?ok^k^0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;RhP03on3P
h?oOgmoog]kN03WogMgM00?og]kNomoOgooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/k>`2ong]kOoo
k^k^ooo^k^haonk^kP;okNg]00Cok>c/on[Zj_oXj>SoiNGU0_oRh^800ooPh>3ogmoOomkNgP0iomgM
g@03omkNg_oOgmooh>3P00;oh^;R00CoiNGUonSXj?oZj^[ok>c/0_o]kNd7onk^kP7oU9BD0Oo^k^h0
00;ooooo00?oU9BDooooooooool01Oooool2ooknoP03oogmoOokno_ono_k00;onOWi0_ohn?PiooOg
m`;on?Sh0_oinOT2oo_kn`03oogmoOono_koo_kn0?ooooooooooooleooooo`;oo_kn00?ooOgmoo_k
nookno/00_oinOT2ooShn3WomoOg0_ohn?P2ooWin@;ono_k00?ooOgmookno_ono_h02Oooool1oiBD
U07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;oi^KV
00?oU9BDonKVi_oVi^H0oooVi^KoonKVi]Woi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^
kP3oonk^k_ook^k^fOo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oooooooooooooI
ooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^k]Wok^k^0OnDU9@1onk^
kP000_oVi^H00onDU9Coi^KVonKViP3oonKVi_ooi^KVfOoVi^H1oiBDU07oi^KV0002onk^kP03oiBD
U?o^k^kok^k^0?ook^k^ooo^k^kIonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool02?oo
ool00ooTi>Cod=3@ooCdm008ooooo`03ooclo?o_knoooooo00Kooooo00?om?CdonSXj?ooool0oooo
oooooooook[ooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP06onk^kP0:oi>CTolB4Q;o
3Ph>obh^;_lC4a?o7AdMokbl_?o^k^ko>c/kogIfMP;ok^k^00Ko/[:boaTI6Ol61PKoC4a<ogemOOl/
;2`2onk^kP06omOGeom5ADGo0P82ob0P8?lE5AGo];Bd1Oo^k^h01_oTi>Co3Ph>o`/;2ol0003o3@d=
oa@D5?ook^k^ooo^k^j^onk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H01OoVi^H00on8
R8So0`<3ohF5Q@02onKViP06omWIfOl0003oYjNWonKVi_li>CWoLW9b0_oVi^H01_m;Bd_oD51@omkN
g_n>SXko3@d=ob/[:`;oi^KV00Ko?CdmocTi>Oo9bLWoi^KVom_KfooJf]X7onKViP03ol30`?l0003o
dM7A0?ooi^KVoooVi^J_onKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h01?o^k^h00ooW
inOo4Q8Bof5QH@03onk^kP06on3Ph?l0003o[Jf]onk^k_lk>c_oMWIf0_o^k^h02_lY:BWoQXJ6onk^
k_o^k^koLG5aob`/;?o^k^koc/k>o`000?n[Zj/;onk^kP03olK6a_l0003of=SH0?ook^k^ooo^k^j_
onk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool01?ooool00ooDe=Co0000ol?3``03oooo
o`06oo7alOl0003o^[Zjoooooom0@43oOgmo0_ooool02_l/;2coTi>CooooooooooooShn?oc0`<?oo
oooo_[jno`000?lm?Cd3oclo?`03olC4a?oooooooooo00Gooooo00?oeMGEo`000?oXj>P0oooooooo
ooooojoooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP04onk^kP03ojNWYol0003od];B
00Cok^k^00Goh>3Pon_[joo^k^ko>c/kogIfMP02onk^kP0>obTY:On9RHWok^k^onk^k_n5QHGo;2`/
onk^k_o<c<co0000oinOWoo1`L7o^KVio`820_oEeMD7onk^kP03olK6a_l0003of=SH0?ook^k^ooo^
k^j_onk^kP7oU9BD0Oo^k^h000;oi^KV1onDU9@00onb/[;o0000okfm_@07onKViP06ocTi>OmbLW;o
i^KVonKVi_lW9bOoQ8B40_oVi^H02On0P83o:b/[onKVi_oVi^Ko>3Phof1PH?oNg]koSXj>obHV9P08
onKViP03ol30`?l0003odM7A00;oi^KVoonDU9CooiBDU:koU9BD0OoVi^H000Wok^k^00?ogMgMo`00
0?nBTY801oo^k^h01_lk>c_oMWIfonk^k_o^k^ko?Shnoi>CT`;ok^k^00WoT92@od51@Oo^k^kok^k^
omKFe_m2@T;o30`<oaXJ6_nZZZX02?o^k^h00oo6a/Ko0000omSHf03oonk^k_ook^k^/Oo^k^h000[o
oooo00?oHf=Sob@T9?o/k>`01_ooool00om0@43oOgmoooooo`0;ooooo`03ooclo?oooooooooo00Ko
oooo00Goo_knoo[jn_oEeMGo0000onSXj03ooooooooooooo/Oooool000[ok^k^00_ofm_Koc`l??lL
71coLW9bohb<S?m]KFgo;Bd]ok6a/Oo^k^ko>c/kogIfMP0Eonk^kP05onGUiOlB4Q;o<C4ao`000?oH
f=P0ooo^k^koonk^k[7ok^k^000;onKViP0:onGUiOnOWiooLW9boemOGommOGgoWIfMomWIfOoVi^Ko
>CTiog9bLQKoi^KV00Coh>3Pok2`/?mgMgOofMWIoooVi^KoonKVi[7oi^KV000Conk^kP03on[Zj_o/
k>cok^k^0?ook^k^ooo^k^k:onk^kP00ooooooooooooon3ooooo003oonk^k_ook^k^h?o^k^h00?oo
i^KVoooVi^KPonKViP00oomoOgn6ogmoO`OoOWinoomoOgmCogmoO`0000Cojn_[onKVi_oRh^;og]kN
0ooMgMd0oooLg=cog]kNomkNg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMg@00AooNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkogMgM00;og=cL
03gofm_KomgMgOoLg=cog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomcLgOoN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oMgMgofm_Kom[Jf_oGemOof=SHomOGeooJ
f][ofm_L00;ogMgM0?oog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]h004GogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMd00ooNg]h0
0ooMgMgog]kNomkNgP03omgMg@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>000ooIfMT02?oH
f=SofMWIomWIfOoIfMWof=SHomKFe_oCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04
omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@
d=03olg=c@04om3@d?oCdm?oemOGomSHf?oofMWI2ooIfMT2omSHf006omKFe_oCdm?odm?ComCDe?oG
emOof=SH0_oIfMT00ooHf=SofMWIomWIf@02omSHf0WofMWI00?of=SHomWIfOoIfMT00_oHf=P00ooI
fMWof=SHomOGe`02omSHf1OofMWI00Cof=SHomKFe_oBd];oclo?0_o=cLd01?o?cloodm?ComOGeooH
f=SoomWIfDGofMWI00?of=SHomWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWo
i>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=codm?ColO7aonk^k_o/[:bojj^[_nb/[;o
^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o
^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o
^k^kolO7aooCdm?ofm_KomoOg`3oon7Qh@[ohN7Q00Woh>3PomoOgooKfm_oe]KFomCDe?oFe]Kof][J
omkNg_oPh>001_oOgml3on3Ph003omoOgooPh>3oh>3P00;oh>3P2?oOgml2omkNgP;ogmoO0ooPh>02
omoOg`;oh>3P0_oOgml=on3Ph005omoOgooMgMgofMWIomGEeOoCdm<00_oBd]800ooFe]Kog=cLon3P
h03oon7QhDOohN7Q00?oh^;Ron7QhOoRh^801?oQhN41onCTi07ojNWY0Oo]kNd00003oo3`l?o_knoo
lO7a00;ol?3`0_o_knl0ooo`l?3ok^k^onSXj?oKfm_o`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<
ojBTY?o2`/7of][Jon[Zj_o]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][J
ol;2`_nTY:CoS8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<S?mkNg_oMgMfog]kNon<S8coY:BT
ol;2`_oJf][oj^[Zong]kOoalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7al@00C_o_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_koo`l>ko
kNg]onc/k?oUiNGoh^;RomoOgooUiNGojNWYong]j`;oj>SX00Koi^KVonWYjOoWinOojn_[onc/k?o^
k^`3on[ZjP09ono_koo^k^kok^k^onSXj?oXj>Koi^KVonWYjOoWinOoj^[Z00;ojNWY00goiNGUonOW
iOoWinOojn_[onc/k?o_knoojn_[on[Zj_oYjNWok^k/onc/k?o[jn_oj>SX00;okNg]01Cok^k^on[Z
j_o/k>[ok>c/onk^k_oZj^[ok>c/ong]kOo^k^koj^[Zonc/j_o/k>cok^k^ojf][OmgMgOoFEUIofm_
Konf][KohN7PonOWi`;okno_0?oolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo^k^kolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO4004cokno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l?3okno_1?o`l?000003oo;bl_o^k^koinOW00CoiNGU013oi>CT
omoOgooAdM7o/K6aohZ:R_mUIFGoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN
0_oTi>@00ooUiNGoi>CTonGUi002onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;o
ADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT0?ooiNGUonCTi?oUiNGoi>CTonCThooNg]ko
dM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7AomkNg_oTi>?o
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiND002Ooi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCohn?SolK6a_lX:2SoADE5ohn?SooB
d];ofm_KomcLfooFe]H00ooEeMD03?oDe=Cof][JomoOgooOgmkofMWIomGEeOoHf=SogmoOon7QhOoM
gMgoe]KFomGEe0;oeMGE00_oe=CDomWIfOoJf][of=SHomGEeOoFe]Goe]KFomWIfOoMgMgoh>3Pom_K
f`02omKFeP09omgMg?oLg=cof=SHomGEeOoLg=coh>3PomoOgooJf][ofm_J00;ogMgM0?oofMWIomcL
g?oOgmooh>3Pom_KfooJf]WogMgMon3Ph?mcLg?oJ6QXohf=SOmDE5Co20P8oj>SX_oKfm_ohn?SonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoShn?oiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUon?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>@005KoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi0CoiNGU00Koi>CTonGUiOoUiNGo
iNGUonSXj?o/k>`1oo;blP0000?om?Cdong]kOoWinL00ooPh>004_oOgmoog]kNom;Bd_nd];CoQhN7
oe]KFom]>cGoWTi2ole_GooYPfoocFmOoii>@om]>cKoG5aLohN7Qond];Cod];BomkNgPGoh>3P017o
g]kNom;Bd_nd];CoQhN7oeaLG?m]H2coWYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aLohN7Qond];Co
d];BomkNgP05on3Ph00AomkNg_oBd];o];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=AomZWSCo
BFX_oeaLG?n7QhOo];Bdom;Bd_oNg]h0oooPh>09on3Ph006omoOgoo?clooVIVIoi:BT_lI6AWoS8b<
0_oEeMD07oo?cloo`/;2olk>c_o>c/koaLG5ol[:b_oJf][of=SHom3@d?o;bl_oclo?omSHf?oJf][o
eMGEolo?coo1`L7od=3@olk>c_o4a<Cobl_;omSHf?oGemOo_[jnok^k^ooAdM7od=3@omGEeOoHf=So
dm?Colc<c?o>c/h00_oEeMD01Oo>c/koc<c<om?CdooJf][of=SH00;od];B00Cof=SHomOGeooAdM7o
dm?C0_oIfMT01_oCdm?odM7AomOGeooHf=SodM7Aom3@d0;odM7A00CoATI6od51@OoGemOog]kN@OoP
h>000ooOgmooh>3Pon3Ph03oon3Ph07oh>3P00?ogmoOon3Ph?oOgml00_oOgml3on3Ph003on7QhOoW
inOok>c/007om?Cd00000oofm_Kol_;bon_[j`03onSXj00ConOWiooRh^;ocLg=oinOWom[GeooScH^
oneaHOoiWI3ooK6Uoofl[oom]:OonInConedHonB=booJemOoinOWoo=cLgoh^;RonOWi`03onSXj00C
onOWiooRh^;ocLg=oinOWom^IUooTg8RongAA?oilgCooOf=oogmUOomoHkonOQfongGAonCLb;oKVMO
oinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWomPJ5ooBg`Soi;QBonmnG_od?fB
omSmVooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=cLgoh^;RonOWi`3oonSXj0[oj>SX00Coi^KVon7Q
hOmMGEgoCDe=0_oMgMd07om@D53o1`L7oaDE5On4Q8Co5QHFod=3@ooRh^;ogMgMoibLW?l0003oShn?
omgMgOoQhN7ofm_Kod10@?l820So6ATIohR8R?l;2`_oF5QHokNg]ol<30co1`L7ob<S8olW9bOoOGem
om[Jf_oMgMgoe=CDo`/;2omIFET00_oIfMT00omMGEgo2`/;om?Cd`02omoOg`06oeYJF_m>CTkog]kN
omkNg_lS8b?oQ8B40_oQhN403?mjNW[o;Rh^omgMgOoMgMgo`/;2oe1@D?lc<c?oKVi^oh>3PolQ8B7o
g]kNonKVi_ooj>SXC_oXj>P1onc/k07ol_;b0Oofm_H0000IooOgmoohn?Son?ShooShn?ogmoOon?Sh
ooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFooZBQoonYY_oo[6UoonhZoon/jKooZRLoo^DROo^J5WoRC4[
oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_PK_onm8;oo_j:
ooooT_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>
oi2@T?m2Lb_oQ<i3ojg_Loo2oXSoc_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^
ooOgm`3oooShn0[on?Sh02Gom_Kfoo7alOn1PH7o7alOong]kOo6a/Ko0000ol?3`ooCdm?oG5aLo`P8
2?oZj^[ol?3`on[Zj_mBDU;o51@Docdm?OoYjNWol?3`ojn_[ol71`Ood];Bolg=cOm>CTko6a/Konk^
k_oKfm_o[Zj^onSXj?o/k>co[Zj^o`000?nd];Cok>c/ok2`/?l;2`_o6QXJ00;oi>CT00_o8b<So`h>
3_nTY:CokNg]onk^k_mPH63oE5ADonk^k_o]kNgo9RHVohf=S@02oo3`l00<oh:2P_la<C7ok>c/on[Z
j_m3@d?o;bl_oibLW?mcLg?o:RXZoaXJ6_o^k^kom_Kf>_ohn?P00oogmoOon?ShooShn005ooShn003
ooOgmoohn?Son?Sh03;on?Sh00?omoOgooShn?ohn?P0c?ohn?P00oogmoOon?ShooShn002ooShn004
ooOgmooinOWomoOgooKfmP7on?Sh00000oojn_[omOGeonk^kP02onc/k03oon_[jooYjNWogmoOokVi
^OmiDU;o_c8TonMdJOomRGkooiR<oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c9?miDU;o^[ZjomoO
gooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3ooMYSoooZL_onlgkoooZ2ookf
Ooook7?oo]iToo[7DOoRTQcoRFICokZj^_oOgmooj^[Zon_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]
D_mAXacoTM9EojKWJ_nhnG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]D_nj^[[ogmoOon[Z
j_o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/001donc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_oj^[ZonCTi?mjNW[o71`L
on;Rh_o;blco0`<3oinOWooOgmooU9BDoa<C4ooPh>3ohN7Qom3@d?l61PKoXJ6Qo`T92Onn_[koh^;R
okVi^Ol20P;o/K6bomkNg_n0P83o:BTYon;Rh_oXj>Soi>CTomoOgooJf]_oe=CDo`P82?n6QXKogmoO
ofYZJ_m9BDWo=CDeojb/[Onn_[ko1`L7ogQhN?mEEED2omoOg`06oe]KFom?Ce3oh^;Ron3Ph?lT92Co
Q8B40_oPh>00oomkNg_o;bl_on7QhOoDe=Co1@D5ojNWYooTi>Coh^;RogmoOolE5AKoh^;RonWYjOo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k000D?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/1oo[jn/01Oo/k>cojn_[on_[joo^k^kom_Kf
007onOWi00000ookno_olo?cong]k@02onGUi@3oonKVi_oShn?ofMWIok:b/_mi;Rkob48don=ZG?oc
NFcooHQloojGR_onVhkooYR;ooj:O_odNfgoif]MolY2=?mk;Rko/[:bomSHf?oTi>CoiNGUonKVi_oU
iNKoi>CTomSHf?nb/[;oUUD^onZL:ook_4Coo/aCoogHH_onhg;oo^UeookVLoonffGooLaCoo_1AOo^
WR_oVEH^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGUonCTi?oHf=Wo/[:bobiR;_mS[B_oQlY8oiOLFOnU
iFWo/_=gokSfNondmGWoYnY[oiSLFOn9cd_oHjh[obiS;_nb/[;of=SIonCTi?oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV001EonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi>CTomkNg_mgMgOo6a/KomcLg?oPh>7oWYjNobh^
;_l[:b_o<S8boa8B4P02om_Kf`0UohB4Q?lQ8B7ogmoOoe=CDomWIfOofm_KomgMgOn@T93o:BTZobl_
;ol/;2co:2PXomgMgOoOgmoof=SHom?Cdoo?cm3oFe]Ko`000?nn_[kofMWIobPX:?n6QXKoN7QhofQX
J?n2PX;o?3`lol?3`ol?3`ooeMGEomWIfOmIFEWoCTi>omgMgOoLg=co8b<Soh61P@02omKFeP27ogMg
Mol^;RkogMgMoj:RX_l0003oa/K6omWIfOoHf=SoSXj>oaDE5OoMgMgohn?SonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV00;o
iNGU0<OoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGU00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGokNg]oo?c
l`01oo_kn`0000?oo?clooShn?oalO400oo^k^h04oo[jn_ohN7Qokbl_?mj5aOo`clbom9EB?oTJ5[o
kgM/ooB3NOohQgcomHAjoo=iKOoUJE_ofEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>co
hN7Qokbl_?nUAaOoiYLbooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlbonVK<_nUAQOo
_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOoGjPbogJm=on6cDOoU]IJoj;PIOnSh6Wo
Xn5WoiOJG?n6cTOoMklgoen[<_lGFAOo_;blon7QhOo/k>`0ooo^k^h:onk^kP0^onc/k?oWinOoNg]k
oa`L7?oTi>CojNWYonKVi_oQhN7og]kNohf=SOlD51Coi^KVonCTi?le=CGoNGUion_[jonb/[;o5ADE
omoOgooVi^Koi>CTon7QhOoMgMgoNWYjobTY:OoXj>SoiNGUomgMgOna/K7o9RHVo`/;2onKVi_ojNWY
olc<c?l0003oc/k>ol?3`olU9BGoBd];ogalO?oXj>So<C4aojFUYOoTi>CoGEeMoe5AD@;oinOW00[o
9BDUofUYJOoOgmoogmoOogMgMola<C7ojNWYol71`Ol0003oYjNW0_oOgml01?nCTi?o5QHFonOWioo/
k>`lonk^kP03ong]kOo^k^kok^k^00;ok^k^00?okNg]onk^k_o^k^h0ooo^k^h9onk^kP03ong]kOob
l_;on?Sh007oo?cl0003oogmo@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@
@ooJHUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];olo?cooclo0?ooOgm01?oo?cl
oo?clooBd];oWR/7omZ:=?o[VaWomJPYooRd?ooi_D[on;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7
om;Bd_oclo?oo?cl00?ooOgm01?oo?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:cE3oSLeB
oh[>D?n1adCoLKT_of:^8?m>VcCo1d87om;Bd_oclo?oo?cl0?oooOgm2_omoOd08ookno_omoOgohB4
Q?lN7Qkolo?cooWinOnc/k?od=3@oo?clomXJ6SoAdM7ooWinOoDe=Co0000omgMgOolo?cono_kobLW
9onXZ:SonOWioj^[ZooEeMGolO7aoeADE?mNGUkonOWiooCdm?nDU9Co1@D5od10@?oAdM7omoOgooSh
n?nGUiOo:b/[00;on_[j01_o92@To`L71oo8b<Sono_kohF5QOmSHf?omoOgof=SHomGEeOon?ShooWi
nOlW9bOo5ADEoh>3PooGemOo@T92of=SHookno_on_[joc@d=?m9BDWofm_KonGUiOm?Cdoo5aLGoo[j
n_olo?`0ooomoOe;oogmo@03ooclo?omoOgoo?cl00?ooOgm0000>_omoOgon_[joo?cloo^k^kol?3`
ono_koo^k^kojNWYom?CdomJ71coXS@dok@X7Oo1>BcoadTlolmFB_o@Ed_od5M:olY:?_o3>bko]RPM
oj8d=?mL7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>ook^k^on[Zj_oCdm?oS2DMolQa=?oIQ1goi9@E
onNM9?o^Z3?ol:XdonnZ<oo/X2GoiiLEomb87Oo8LCCoS2DMom?CdooZj^[ok^k^oo3`l?o_knool?3`
onk^k_oZj^Wodm?Coadh7OldPSCoAiDMoeZU6omY[BX2ogBh>03oogFi>?m[/B_oFjLLodRJ7OldPSCo
7CPMom?CdooZj^Wok^k^oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_000joo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o^
k^kojn_[ogemOOlL71coinOWonk^kOn8R8So<30`o`h>3_la<C7o/;2`ono_kon4Q8CoCDe=onk^k_o_
knook^k^ohZ:R_mIFEWokno_ogQhN?l/;2_o3Ph>ocPh>?nn_[kok^k^on?Shol>3PkoJFUYon3PgooR
h^;oi^KVon[Zj_mQHF7oMWIfono_koo^k^koMgMfobHV9P;ok^k^01KocLg=ob`/;?o[jn_oK6a/of=S
H_o[jn_ok^k^ocXj>_nDU9CoHV9Ro`h>3_ld=3Coa<C4onk^k_o_knoodM7Aoc`l??l:2P[o9bLWofa/
K?l/;2cok^k^0_o_knl0ooo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o^k^kol?3`ono_koo`l>ookno_oo3`l?o_knool?3`onk^k_o`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l000AOo_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`02oo3`
l0Kokno_0Ooclo<1ooShn07oo_kn00000oono_komoOgoo3`l002onWYj@0ConSXj?oYjNWoi^KVom_K
fomSBd_oPC8bojHd=?nf=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mSBd_ofm_KonOW
i`05onWYj@0AonOWiooKfm_oRD];ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe
=On_Bc;oRD];om_KfooWinL01OoYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[ZbooL:dhofn^
>_m`[CSoJZX_oe>K;OliR3Go<V0bod];BooKfm_oinOW0?oojNWY2ooYjNT01_oXj>Soi^KVog]kNolL
71coi>CTonSXj0;ojNWY00?oinOWonWYjOoYjNT02ooYjNT03?oWinOojNWYonWYjOoXj>Sof=SHo`X:
2_n^[Zkog=cLomkNg_oPh>3oiNGUonSXj0SojNWY00Koj>SXonKVi_oShn?ohn?SonKVi_oXj>P3onWY
j@03onSXj?oYjNWojNWY00CojNWY00?oinOWonWYjOoYjNT0N_oYjNT00ooXj>SojNWYonWYj@03onWY
j@03onSXj?oYjNWojNWY0<KojNWY00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07omoOg0Oono_h00004
ookno_ojn_[om?Cdono_k`?ol?3`017okno_on_[jonEU9CoCb<SoiEDE?nkLg?odiFEomZLW?oJWYco
fIbLomBEUOnkLg?oUEADodlS8onEU9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oZIBDoh4S8onjJUCo
e9YconBlUOoZaicojLNLon[7W?oU_9Goe9Ycok]ZE?n18b?oZYBDon[Zj_o_knl01Oo`l?004Oo_knoo
j^[ZoiBDU?lS:R?oE7YDog>ULonNaYGo[<jLojg>W?n/cYcoW/JEog>ULomDNUCo8bXSoiBDU?oZj^[o
kno_0?ool?3`2oo`l?02ono_k`04oh20P?lM7Agok^k^ono_k`Gol?3`00?okno_oo3`l?o`l?002oo`
l?02ono_k`07ofATI?lY:BWoPH61of=SHolk>c_ok^k^ono_k`08oo3`l006ono_koo^k^koLg=cofUY
JOo^k^kokno_Boo`l?02ono_koool?3`3oo`l?001?oalO7ol?3`ooCdm?ojn_X1ooknoP0000CokNob
ooooooooooooo_kn0_ooool2ooknoP3ooogmoOogmoOoKVi^oeXo?onaT93og/W9oo3Ti?oci^Kol>CT
omk9bOnaT93oFSloofe]KOohn?Soo?clooooooono_koooooookno_ooookoo_knooooooolo?con?Sh
ohe]KOn:?coobI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo?on=KFgon?Sgooclo?ooooooo_kn
ooooooono_koooooookno_ooookoo?clooShn?m]KFgo?clooi2MT?o9eLWoi>cTonK^i_oTk>CobMG9
oi2MT?lo?cooKFe]ooShn?olo?coooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_kn0017ooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooool00_ono_h06?o?clooYZJVoogmoOooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooo`;oo_kn
00ko`<30og5aLOn0P83o/;2`oogmoOooooooo_knooooooono_koooonookno_ooooooo_knooooo`;o
o_kn0?oo`L71okfm_?omoOgoooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_h005coooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooooooknoP;ooooo00?oo_knooooooooool00oooool1oo[jn`0000Coa<cCookno_oj
n_[olo?c1OoalO403Oo_knooe]KFof][Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?CgoJf][omKF
e_o_knl02OoalO403Oo_knooemKFoh=[Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<S?mb?CgoPF][omOF
e_o_knl02OoalO403Oo_knooe]KFof][Jolm?CgoS8b<okZj^_o<cLco^[Zjohb<S?lm?CgoJf][omKF
e_o_knl0oooalO4Foo7al@03oo3`l?oalO7olO7a017olO7a00?ol?3`oo7alOoalO40WOoalO400oo`
l?3olO7aoo7al@34oo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_ono_h00Oo[k^l0
000EohZHXoomoOgon?Shoo3`l?o[jn_oj^[ZonWYjOoZj^[ojNWYon[Zj_oYjNWoj>SXoi^KVomIFEWo
9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo
@RHVofUIFOnPVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWo
Vi^KonSXj?oYjNT0oooZj^XZon[ZjP03onWYjOoZj^[oj^[Z09coj^[Z00?ojNWYon[Zj_oZj^X0cOoZ
j^X01?o[jn_ol?3`ooShn?omoOd1oloBeP0000Co@E1Nokc6cOojn_[olo?c2?oalO42oo3`l0?okno_
0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`oooalO7ooo7alISolO7a
00?ol?3`oo7alOoalO400_oalO400ooemOGon_[jonW[k@01oi^OXP0000?o9Ca>oe5SL?nkaL`0oooo
ooooooooom[ooooo0Oo]ko41ojb`]07oYjb`00001_lY@5Oo8SU<ocQ:FOn6TIgo`LS>onc^l?oooooo
oooooooDooooo`05ooSin_o/k^oodMCGoi^OXonMXjL00Onc^[l00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{734, 424},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<javax.swing.Box\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["javax.swing.Box", 81]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<javax.swing.BoxLayout\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["javax.swing.BoxLayout", 82]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(base = javax`swing`Box`createVerticalBox[]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.Box"] \[RightGuillemet]\),
      JLink`Objects`JavaObject30025076178945]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(pane@add[base]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.Box"] \[RightGuillemet]\),
      JLink`Objects`JavaObject30025076178945]], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (*\ Glue\ *) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(panel1 = NewJPanelTitledBorder[base, "\<Glue 1\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JPanel"] \[RightGuillemet]\),
      JLink`Objects`JavaObject18111138889729]], "Output"]
}, Open  ]],

Cell["the panel shrinks", "Text"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]panel1@
        setLayout[\[IndentingNewLine]JavaNew["\<javax.swing.BoxLayout\>", 
            panel1, \[IndentingNewLine]javax`swing`BoxLayout`XUAXIS]\
\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(b1 = NewJButton[panel1, "\<B1\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject119961708134401]], "Output"]
}, Open  ]],

Cell["the panel is spread horizontally by the glue", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]panel1@
        add[javax`swing`Box`createHorizontalGlue[]]\[IndentingNewLine]]\)], \
"Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.Box$Filler"] \[RightGuillemet]\),
      JLink`Objects`JavaObject95354817085441]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(b2 = NewJButton[panel1, "\<B2\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject64735978455041]], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (*\ Glue\ 2\ *) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(panel2 = NewJPanelTitledBorder[base, "\<Glue 2\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JPanel"] \[RightGuillemet]\),
      JLink`Objects`JavaObject99966655660033]], "Output"]
}, Open  ]],

Cell["the panel shrinks", "Text"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]panel2@
        setLayout[\[IndentingNewLine]JavaNew["\<javax.swing.BoxLayout\>", 
            panel2, \[IndentingNewLine]javax`swing`BoxLayout`XUAXIS]\
\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input"],

Cell["the panel spreads itself", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]panel2@
        add[javax`swing`Box`createHorizontalGlue[]]\[IndentingNewLine]]\)], \
"Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.Box$Filler"] \[RightGuillemet]\),
      JLink`Objects`JavaObject138773715222529]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(b3 = NewJButton[panel2, "\<B3\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject108971960565761]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]panel2@
        add[javax`swing`Box`createHorizontalGlue[]]\[IndentingNewLine]]\)], \
"Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.Box$Filler"] \[RightGuillemet]\),
      JLink`Objects`JavaObject139779559653377]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(b4 = NewJButton[panel2, "\<B4\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject34831916335105]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]panel2@
        add[javax`swing`Box`createHorizontalGlue[]]\[IndentingNewLine]]\)], \
"Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.Box$Filler"] \[RightGuillemet]\),
      JLink`Objects`JavaObject70875684536321]], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (*\ Filler\ *) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(panel3 = NewJPanelTitledBorder[base, "\<Filler\>"]\), "\n", 
    \(JavaBlock[\[IndentingNewLine]panel3@
        setLayout[\[IndentingNewLine]JavaNew["\<javax.swing.BoxLayout\>", 
            panel3, \[IndentingNewLine]javax`swing`BoxLayout`XUAXIS]\
\[IndentingNewLine]]; \[IndentingNewLine]panel3@
        add[javax`swing`Box`createHorizontalGlue[]]\[IndentingNewLine]]\)}], \
"Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JPanel"] \[RightGuillemet]\),
      JLink`Objects`JavaObject95565622804481]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.Box$Filler"] \[RightGuillemet]\),
      JLink`Objects`JavaObject18965585723393]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(b5 = NewJButton[panel3, "\<B5\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject100590264778753]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<java.lang.Short\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["java.lang.Short", 84]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]panel3@
        add[\[IndentingNewLine]JavaNew["\<javax.swing.Box$Filler\>", \
\[IndentingNewLine]JavaNew["\<java.awt.Dimension\>", 50, 
              75], \[IndentingNewLine]JavaNew["\<java.awt.Dimension\>", 50, 
              75], \[IndentingNewLine]JavaNew["\<java.awt.Dimension\>", 
              java`lang`Short`MAXUVALUE, 
              75]\[IndentingNewLine]]\[IndentingNewLine]]\[IndentingNewLine]]\
\)], "Input",
  FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.Box$Filler"] \[RightGuillemet]\),
      JLink`Objects`JavaObject58622746820609]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(b6 = NewJButton[panel3, "\<B6\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject72263193853953]], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (*\ Rigid\ Area\ *) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(panel4 = NewJPanelTitledBorder[base, "\<Rigid Area\>"]\), "\n", 
    \(JavaBlock[\[IndentingNewLine]panel4@
        setLayout[\[IndentingNewLine]JavaNew["\<javax.swing.BoxLayout\>", 
            panel4, \[IndentingNewLine]javax`swing`BoxLayout`XUAXIS]\
\[IndentingNewLine]]; \[IndentingNewLine]panel4@
        add[javax`swing`Box`createHorizontalGlue[]]\[IndentingNewLine]]\)}], \
"Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JPanel"] \[RightGuillemet]\),
      JLink`Objects`JavaObject104223152799745]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.Box$Filler"] \[RightGuillemet]\),
      JLink`Objects`JavaObject33127334412289]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(b7 = NewJButton[panel4, "\<B7\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject74065301733377]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]panel4@
        add[\[IndentingNewLine]javax`swing`Box`createRigidArea[\
\[IndentingNewLine]JavaNew["\<java.awt.Dimension\>", 150, 
              0]\[IndentingNewLine]]\[IndentingNewLine]]\[IndentingNewLine]]\)\
], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.Box$Filler"] \[RightGuillemet]\),
      JLink`Objects`JavaObject37536604880897]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(b8 = NewJButton[panel4, "\<B8\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject138038839607297]], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (*\ Strut\ *) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(panel5 = NewJPanelTitledBorder[base, "\<Strut\>"]\), "\n", 
    \(JavaBlock[\[IndentingNewLine]panel5@
        setLayout[\[IndentingNewLine]JavaNew["\<javax.swing.BoxLayout\>", 
            panel5, \[IndentingNewLine]javax`swing`BoxLayout`XUAXIS]\
\[IndentingNewLine]]; \[IndentingNewLine]panel5@
        add[javax`swing`Box`createHorizontalGlue[]]\[IndentingNewLine]]\)}], \
"Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JPanel"] \[RightGuillemet]\),
      JLink`Objects`JavaObject131295053086721]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.Box$Filler"] \[RightGuillemet]\),
      JLink`Objects`JavaObject70254608777217]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(b9 = NewJButton[panel5, "\<B9\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject111169389985793]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]panel5@
        add[\[IndentingNewLine]javax`swing`Box`createHorizontalStrut[
            150]\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.Box$Filler"] \[RightGuillemet]\),
      JLink`Objects`JavaObject28943180627969]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(b10 = NewJButton[panel5, "\<B10\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject62243286810625]], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\(JavaShow[frame];\)\), "\[IndentingNewLine]", 
    \(frame@repaint[]\)}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(DeleteJObject[panel1, b1]\), "\[IndentingNewLine]", 
    \(\(\(DeleteJObject[panel1, b2]\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(DeleteJObject[panel2, b3]\), "\[IndentingNewLine]", 
    \(\(\(DeleteJObject[panel2, b4]\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(DeleteJObject[panel3, b5]\), "\[IndentingNewLine]", 
    \(\(\(DeleteJObject[panel3, b6]\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(DeleteJObject[panel4, b7]\), "\[IndentingNewLine]", 
    \(\(\(DeleteJObject[panel4, b8]\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(DeleteJObject[panel5, b9]\), "\[IndentingNewLine]", 
    \(DeleteJObject[panel5, b10]\)}], "Input"],

Cell[BoxData[{
    \(DeleteJObject[base, panel1]\), "\[IndentingNewLine]", 
    \(DeleteJObject[base, panel2]\), "\[IndentingNewLine]", 
    \(DeleteJObject[base, panel3]\), "\[IndentingNewLine]", 
    \(DeleteJObject[base, panel4]\), "\[IndentingNewLine]", 
    \(DeleteJObject[base, panel5]\)}], "Input"],

Cell[BoxData[
    \(DeleteJObject[pane, base]\)], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.UIManager <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(btn = NewJButton[pane]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject14718316052481]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<javax.swing.UIManager\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["javax.swing.UIManager", 73]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<javax.swing.UIManager$LookAndFeelInfo\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["javax.swing.UIManager$LookAndFeelInfo", 74]\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell["com.sun.java.swing.plaf.windows.WindowsLookAndFeel", "Text"],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l00000o`00003oo`00003o
00000880000000000`28`;P0B92804R@R03o04R@R?l0B928OP18T8P10000000000<0R<2h0<SPf028
`;P0o`28`;So08S0^7d0R<2h0@18T8P10000000000<0R<2h0<SPf028`;P0o`28`;So08S0^7d0R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`00003o000007X000000P28`;P104R@R0400000
00001@28`;P0b>3H08S0^028`;P0b>3H0?l0B928o`18T8Qh04R@R00400000028`;P0R<2h04R@R040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;PX08S0^005
00000028`;P0R<2h08S0^00000000`28`;P00`000000R<2h0000000308S0^00300000028`;P0R<2h
00@000000P28`;P3000000<0R<2h00D0000008S0^028`;P0R<2h0000000308S0^0<00000o`28`;PW
08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28
`;PX08S0^00500000028`;P0R<2h08S0^00000000`28`;P00`000000R<2h0000000308S0^0030000
0028`;P0000000<0R<2h00<0000008S0^00000000`28`;P010000000R<2h08S0^000000308S0^004
00000028`;P0R<2h000000<0R<2h00<0000008S0^028`;P0o`28`;PT08S0^00504R@R0000000R<2h
08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;PW08S0^00700000028`;P0
000008S0^0000000R<2h0000000208S0^00300000028`;P0000000<0R<2h00<0000008S0^0000000
0`28`;P00`000000R<2h0000000308S0^00900000028`;P0000008S0^0000000R<2h00000028`;P0
000000<0R<2h0P00003o08S0^2L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h
0<SPf028`;P0R<2h0<SPf03o08S0^2L0R<2h00L0000008S0^0000000R<2h00000028`;P000000080
R<2h00<0000008S0^00000000`28`;P00`000000R<2h0000000308S0^00300000028`;P0000000<0
R<2h00T0000008S0^0000000R<2h00000028`;P0000008S0^00000000P28`;P00`000000R<2h08S0
^03o08S0^2L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h
0<SPf03o08S0^2L0R<2h00L0000008S0^0000000R<2h00000028`;P000000080R<2h00@0000008S0
^000000000000P28`;P00`000000R<2h0000000308S0^00300000028`;P0000000<0R<2h00/00000
08S0^0000000R<2h00000028`;P0000008S0^0000000R<2h0000000308S0^00300000028`;P0R<2h
0?l0R<2h9028`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2h9`28`;P01`000000R<2h00000028`;P0000008S0^00000000P28`;P010000000R<2h
00000028`;P2000000<0R<2h1000000208S0^0<000000P28`;P010000000R<2h08S0^000000208S0
^00300000028`;P0R<2h00<00000o`28`;PW08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;PV08S0^00500000028`;P0R<2h08S0^00000000`28
`;P00`000000R<2h08S0^00;08S0^00300000028`;P0R<2h0?l0R<2h>028`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2h9P28`;P01@000000R<2h
08S0^028`;P0000000<0R<2h00<0000008S0^028`;P02`28`;P00`000000R<2h08S0^03o08S0^3P0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^2H0R<2h00D0000008S0^028`;P0R<2h0000000308S0^00300000028`;P0000000/0R<2h00<00000
08S0^028`;P0o`28`;Ph08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@
R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0
R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0
^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0
b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0
R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0
R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040
000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0
^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B9280000
0028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P0
1@18T8P0000008S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0b>3H0?l0R<2ho`28
`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000000508S0^038h=P0R<2h08S0^038h=P0
o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@R0010000000000D0R<2h0<SPf028`;P0
R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0^028`;P0B9280040000000001@28`;P0
b>3H08S0^028`;P0b>3H0?l0R<2ho`28`;Qg08S0^00504R@R0000000R<2h08S0^018T8P00@000000
000508S0^038h=P0R<2h08S0^038h=P0o`28`;So08S0^7L0R<2h00D0B92800000028`;P0R<2h04R@
R0010000000000D0R<2h0<SPf028`;P0R<2h0<SPf03o08S0^?l0R<2hM`28`;P01@18T8P0000008S0
^028`;P0B9280040000000001028`;P0b>3H08S0^028`;So0<SPf?l0b>3HN@38h=P010000000R<2h
08S0^018T8P10000000000<0R<2h0<SPf028`;P0o`28`;So08S0^7d0R<2h0@18T8P10000000000@0
R<2h0<SPf028`;P0R<2h5P0008030001P08000:000@000:10003P@000h4000>10`0018420005P@04
0005PP001X8000J20006PP8000N200<00@N20048PP0128800P0128<30049P`<00@Z300<00@^3004;
Q0012h@00`0138@3004=Q0<00@j50`023hD3008@Q@@00Q660`024XH2008CQP04008CQ`0258L00QB7
008DQ`<00QF70P025XL010035XP00aN800<GR0035hP300<HR00300<IR0036HT00aV900@00aZ90`03
6hT300<LRP<00af:0`047XX300@OR`<0122;0`048H/300@RS0@012><00@012B<00@TS@0498d012F=
0P059Hd300DVS@0300DWS@059hh01BN>00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?
0`06;I0300H^T0801Rn@00@01RnA00H`T@06<9401S2A0`06<I4200HbT@0400HbTP06<i801S>B00Hc
TP801SBB00<01cBB00LeTP07=I800P07=I<300LfT`<01cNC00<01cRC00LhU007>9@00`07>I@300Lj
U0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL0
1009@iP02DBH00U4V009A9P300U5V00300U6V009AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:
BiX300Y<V`<02TfK0`0:CY/300Y?W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]D
W@0;E9h02eBN00<02eFN0`0;EYh00`0;Eih02eNO00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP
00@035bQ00aMX@0<GJ4035fQ0`0<GZ4200aOX@0400aOXP0<H:80362R00aPXP80366R00<03F6R00eR
XP0=HZ800P0=HZ<300eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZ
Y@@03V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?
LJP300mbZ00300mcZ00?LjT03g>Y00@03gBY0`0?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@
Nj/3011l[0@047f/00@047j/011n[@0@OZd047n]0P0AOjd30160[@030161[@0APJh04H6^00<04H:^
0`0APjh00`0AQ:h04HB_0164[`030165[`@04HJ_0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[40
4XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@
/`<04i6c00<04i:c01>B]00CT[@00`0CTk@301>D]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ
]P0401BJ]`0DVkL059^g01BK]`<059bg0P0DWKL0100EWKP05Ijh01FN^00EW[P301FO^00301FP^00E
X;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0FYKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@0
5Z^l01J[_@0FZkd05Zbm0P0G[;d301N]_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o
01Na_`0301Nb_`<05k>o=P0H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0@00020
00<0VjOa03=3Y@0c@jD02@0c@jD60000P0<000600P000X0010000X4000>10003P@000h430004P@80
00F100@000F20006PP001X8000J20P001h800`011h800@R20048PP020048P`<00@V30`012X<00`01
2h<00@^4004;Q003004<Q0<00@f40`013XD3008?Q@<00Q2510024HH3008BQP800Q>600@00Q>7008D
Q`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<00aV800<IR@036HT01003
6XT300<KR@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<012:<10048h`0100498`012B=00@T
S@049Hd200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?
1005;8l300H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@801S:A00@01S:B00HcTP06
<i801S>B0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD00LhU00300Li
U0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL2
00Q3U`0400U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09
BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M
00<02eBM00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P
0P0<G:00100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=
HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iY
Y@<03VZU100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP0
3g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@
NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh0
0`0APZh30163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa
01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?
/`<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI
]P8059Zf00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<0
5J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100F
Z[`0100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na
_P0G/Kl05k6o00<05k:o0`0G/klf01Rd`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
0`0008001`2KYo40oooo08ij]P2VVl@0/jWB0:RMb02cZM800P2VVl@01@2l^=d0k^kd0>[Yl@3oool0
<d>U00D000200`000H020002P0040002P@000h4000>10003P@<000B10P001H4010001H8000J20006
PP001X820007PP030047PP0128800@R200800@R30`012H<3004:P`03004;P`012h@00@^400<00@b4
0`013H@3004>Q@<00Pn50`0248D4008AQP<00Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`80
0QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV900<IR@0400<JR@<00a^90`0378X300<M
RP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@TS00498d012B=00@US@801BF=0`059Xd0
0`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06;Y02
00H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06<i8200HdTP0300Ld
TP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07>Y@300LkU@<023bE
0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G00@02D>H00U4V009
A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/300Y=
V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP03
00]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aLX00400aLX@0<GJ40
35fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R00803F:S
0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<03VbV
0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?LZP00`0?
LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4011m
[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162[P<04H>^00<04HB^
0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa01::/@<04X^a0P0B
S;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc0`0CT;<301>A/`0301>B
/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L059^g
01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ
^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd05Z^m
01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l3
01Nc_`806;C08000000201Rd`10000000P0H]<0208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^080002000@0VjOa0?ooo`1/FZD0[jG:0P2l^=d02P3ooOl0/jWB0?ooo`3oool0_;SM09N:_02X
WLP0i^K/0?ooo`0c@jD40000P0<000600P000X0010000X4000>10003P@000h430004P@8000F100@0
00F20006PP001X8000J20P001h800`011h800@R20048PP020048P`<00@V30`012X<00`012h<00@^4
004;Q003004<Q0<00@f40`013XD3008?Q@<00Q2510024HH3008BQP800Q>600@00Q>7008DQ`0258L0
0QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<00aV800<IR@036HT010036XT300<K
R@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<012:<10048h`0100498`012B=00@TS@049Hd2
00DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?1005;8l3
00H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@801S:A00@01S:B00HcTP06<i801S>B
0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD00LhU00300LiU0<01cZD
0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL200Q3U`04
00U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09BYX300Y;
VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM
00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P0P0<G:00
100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=HJ803F:R
00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iYY@<03VZU
100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP03g6X00ma
Z0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011k
Z`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh00`0APZh3
0163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa01::/@0B
R[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?/`<04i2c
0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI]P8059Zf
00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<05J2h01FP
^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100FZ[`0100F
Zk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl0
5k6o00<05k:o0`0G/kl201Rd`0030<SPf018T8P0B92800`0B92800<000000<SPf018T8P03@18T8P0
100000006;C001Rd`038h=P>04R@R0030000000H]<006;C00080R<2h0@18T8P10000000000@0R<2h
0<SPf028`;P0R<2h0P0008002`2KYo40oooo0:RMb03oool0/jWB061<VP2>N[H0N6F^0:RMb03oool0
oogo00<0oooo00<0<d>U0000P00008000`0008030001P08000:000@000:10003P@000h4000>10`00
18420005P@040005PP001X8000J20006PP8000N200<00@N20048PP0128800P0128<30049P`<00@Z3
00<00@^3004;Q0012h@00`0138@3004=Q0<00@j50`023hD2008@Q@<0oooo0P024HH3008BQP800Q>6
00@00Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<00aV800<I
R@036HT010036XT300<KR@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<012:<10048h`01004
98`012B=00@TS@049Hd200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl0
1BZ?00<01B^?1005;8l300H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@801S:A00@0
1S:B00HcTP06<i801S>B0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD
00LhU00300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0
246G0`08@YL200Q3U`0400U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8
V@<02DVJ0`09BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd2
00]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl3
00aJX0<035^P0P0<G:00100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R
0P0<HJ800`0=HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT
0`0=J:D300iYY@<03VZU100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`04
00m`Z00?LJP03g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011h
ZP<047V[0`0@NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]
0161[P0APJh00`0APZh30163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00
100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb
01>?/P0201>?/`<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne
100DV;H301BI]P8059Zf00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN
^0<05Inh00<05J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX
^`<05ZVl100FZ[`0100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh3
01N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0030<SPf028`;P0R<2h00/0R<2h00<0B928
00000038h=P03@28`;P01@18T8P0000001Rd`00H]<00b>3H00d0R<2h00@0B9280000000H]<006;C0
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20000P00>09^Wl@3oool0oooo0=_Lk01P
C9X0ThFj0;>YdP2l^=d0H4bJ09V?_P2VVl@0b<?O0?ooo`0c@jD60000P0<0oooo0P000X000`000X40
oooo0?ooo`020?ooo`8000B100<000F10?ooo`001H800`001X840?ooo`030048PP0128<0oooo00<0
oooo0`012X<01P3oool00@^4004;Q00138@0oooo004<Q0800@f400@0oooo004>Q@3oool00@j50P02
3hD0103oool00Q250?ooo`0248D2008AQP030?ooo`024HH00Q:600800Q:60P024hH010024hL00QB7
008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV900<IR@0400<J
R@<00a^90`0378X300<MRP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@TS00498d012B=
00@US@801BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl4
00D/S`<01Rf@0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B00Hc
TP06<i8200HdTP0300LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD
0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`80
24>G00@02D>H00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:
VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did0
0`0;E9d02eBN00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj02
00aLX00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQ
XP0=HZ803F:R00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU
0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?
LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011j
Z`<047^[0`0@O:`4011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P03
0162[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0BR[40
4XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc
0`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf
0P0DV[H0100DV[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0E
X;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ
_00401J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n
01Na_`0G/Kl00`0G/[l301Nc_`806;C000@0b>3H08S0^028`;P0R<2h1P00000408S0^00304R@R000
0000b>3H0080R<2h2@00000208S0^00504R@R00000006;C001Rd`038h=P03@28`;P01018T8P00000
01Rd`00H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0<0002000h0VjOa0?ooo`2l
^=d0VHnn0?ooo`3FdMd0fmc/0??no`2VVl@0k^kd08Ef/02CQKX0oooo03=3Y@@0002000L0oooo0001
P0000H0000600?ooo`000X00oooo00<000>100H0oooo0004P@00184000F10?ooo`001H820006PP08
0?ooo`001h8000N20047PP3oool00@R20?ooo`0128<30049P`040?ooo`012X<00@Z30?ooo`800@^4
00<00@b40?ooo`0138@00P013H@0103oool00@j50?ooo`013XD2008?Q@030?ooo`0248D0oooo00<0
oooo0P024HH3008BQP800Q>600@00Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN8
00<GR0<00aR800<00aV800<IR@036HT010036XT300<KR@<00ab:0`037HX300@NRP<011n;0`0488/3
00@QR`<012:<10048h`0100498`012B=00@TS@049Hd200DUS@<01BJ=00<01BN=00DWSP059hh00`05
:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?1005;8l300H]T0<01Rj@0P06;i001006;i401S2A00H`
T@06<94300HaT@801S:A00@01S:B00HcTP06<i801S>B0P06=9800`07=9801cFB00LeTP0200LeT`<0
1cJC0`07=i<00`07>9<01cRD00LhU00300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80
242F00@0242G00Q1U`08@IL0246G0`08@YL200Q3U`0400U3V009A9P02DBH00U4V0<02DFH00<02DJH
00U6V@09AYT01009AiT300U8V@<02DVJ0`09BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0
100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;
Eil02eNO00<02eRO100;FIl300aJX0<035^P0P0<G:00100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ
00@035nR00aPXP0<H:80362R0P0<HJ800`0=HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<0
3FFT00eUY00300eVY0<03FNT0`0=J:D300iYY@<03VZU100>JjH300i/YP803VfV00@03VfW00i^Y`0>
KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP03g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?M:T3
00meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]011n[@0@
Ojd2015o[@<04H2]00<04H6]0161[P0APJh00`0APZh30163[P030164[P0AQ:l04HB_00<04HF_100A
QZl301:7/0<04XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK80
4Xfb0P0BS[800`0CS[804hnb01>?/P0201>?/`<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0<0
4iBd0`0CUKD301BF]@<059Ne100DV;H301BI]P8059Zf00@059Zg01BK]`0DVkL059^g0`0DW;L201BM
]`0401FM^00EW[P05Ijh01FN^0<05Inh00<05J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X3
01JU^P<05ZJk0`0FYk/301JX^`<05ZVl100FZ[`0100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm00<0
5jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0040<SPf028
`;P0R<2h08S0^0H000001028`;P00`18T8P000000<SPf00208S0^00300000028`;P0R<2h00D0R<2h
00D0000008S0^028`;P0B9280000000201Rd`0040<SPf028`;P0R<2h08S0^08000001028`;P20000
0080R<2h00@0B9280000000H]<006;C00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P3
0000P00?09^Wl@3oool0VHnn09N:_03DdnP0kjbc0?mfN`3^Wj/0FeRU0:JKa02FWm80H4bJ0;bhg@3o
ool0<d>U00<0002000L0oooo0001P0000H0000600?ooo`000X00oooo00<000>100H0oooo0004P@00
1840oooo0005P@3oool20006PP080?ooo`001h8000N20047PP3oool00@R20?ooo`0128<30049P`09
0?ooo`012X<0oooo004;P`3oool00@^40?ooo`0138@0oooo00800@f400@0oooo004>Q@3oool00@j5
0P023hD0103oool00Q250?ooo`0248D4008AQP<00Q:60P024hH010024hL00QB7008DQ`0258L3008E
Q`800QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV900<IR@0400<JR@<00a^90`0378X3
00<MRP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@TS00498d012B=00@US@801BF=0`05
9Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06
;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06<i8200HdTP03
00LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07>Y@300LkU@<0
23bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G00@02D>H00U4
V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/3
00Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]D
WP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aLX00400aLX@0<
GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R0080
3F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<0
3VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?LZP0
0`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4
011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162[P<04H>^00<0
4HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa01::/@<04X^a
0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc0`0CT;<301>A/`03
01>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L0
59^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@04
01FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd0
5Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G
/[l301Nc_`806;C000<0b>3H08S0^028`;P02`28`;P00`18T8P000000<SPf00208S0^00300000028
`;P0R<2h00D0R<2h00D0000008S0^028`;P0B9280000000201Rd`0030<SPf028`;P0R<2h0080R<2h
0P00000208S0^08000000`28`;P01018T8P0000001Rd`00H]<0208S0^040B9280@000000000408S0
^038h=P0R<2h08S0^080002000X0VjOa0?ooo`2GR[`0NVbZ0;?7j02YKZ00b<?O09>5^P1KAY<0VHnn
0P1hIJh010129hD0[jG:0?ooo`0c@jD40000P0<0006000<0oooo0002P0000X40103oool20004P@03
0?ooo`001H40oooo00<000J2103oool00`0128800@R30048P`030049P`090?ooo`012X<0oooo004;
P`3oool00@^40?ooo`0138@0oooo00800@f400@0oooo004>Q@3oool00@j50P023hD00`3oool00Q25
0?ooo`030?ooo`800Q660`024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP0
0aN800<GR0035hP300<HR00300<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:0`047XX300@O
R`<0122;0`048H/300@RS0@012><00@012B<00@TS@0498d012F=0P059Hd300DVS@0300DWS@059hh0
1BN>00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@00@01RnA
00H`T@06<9401S2A0`06<I4200HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB00LeTP07=I80
0P07=I<300LfT`<01cNC00<01cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D300PmU@@023jF
0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009A9P300U5
V00300U6V009AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:CY/300Y?
W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN0`0;EYh0
0`0;Eih02eNO00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ4035fQ0`0<
GZ4200aOX@0400aOXP0<H:80362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eSX`<03FBS
00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]YP0400i]
Y`0>KZL03VjW00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?LjT03g>Y
00@03gBY0`0?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@047j/011n
[@0@OZd047n]0P0AOjd30160[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_0164[`03
0165[`@04HJ_0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:</@0401:</P0B
SK804Xfb01:=/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B]00CT[@0
0`0CTk@301>D]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g01BK]`<0
59bg0P0DWKL0100EWKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS
^P<05JBj0`0FYKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm0P0G[;d3
01N]_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o0P0H]<00
0`38h=P0R<2h08S0^00;08S0^00304R@R0000000b>3H0080R<2h00<0000008S0^028`;P01@28`;P0
1@000000R<2h08S0^018T8P0000000806;C000<0b>3H08S0^028`;P00`28`;P4000000@0R<2h00@0
B9280000000H]<006;C00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20000P00309^W
l@3oool0oooo0080oooo00X0ojf`0?mfN`3icM@0oNg^0?ooo`2VVl@0QGJ`0;bhg@3oool0<d>U1@00
08030001P0030?ooo`000X0000:100<000>100<0oooo0004P@3oool00P001H4010001H80oooo0006
PP001X820007PP030047PP3oool00@R200800@R30`3oool2004:P`070?ooo`012h<0oooo004;Q03o
ool00@b40?ooo`02004=Q0040?ooo`013XD0oooo0?ooo`800Pn500H0oooo008@Q@3oool00Q25008A
QP3oool2008AQP<00Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR003
5hP00aN80`0368P00`036HP00aV900<IR@0400<JR@<00a^90`0378X300<MRP<011j:0`047h/300@P
R`<0126;0`048X`400@SS00400@TS00498d012B=00@US@801BF=0`059Xd00`059hd01BN>00DWSP03
00DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06;Y0200H_T00400H_T@06<940
1S2A00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06<i8200HdTP0300LdTP07=I801cFB00801cFC
0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF
0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G00@02D>H00U4V009A9P02DBH0`09AIP00`09
AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@
W00400YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP<02eJN00<02eNN
00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<
Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R00803F:S0`0=Hj<300eTX`0300eU
X`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW
00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400md
Z@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4011m[004011n[00@OZd047j]
011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl4
0166[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=
/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d
0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L059^g01BK]`0DVkL301BL]`80
59fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT
^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd0
0`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C000<0b>3H
08S0^028`;P02`28`;P00`18T8P000000<SPf00208S0^00300000028`;P0R<2h00D0R<2h00D00000
08S0^028`;P0B9280000000201Rd`0030<SPf028`;P0R<2h00@0R<2h0P00000508S0^00404R@R000
00006;C001Rd`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0`0008002P2Q[?80nLgD
0>8V?03d]Kl0hRHl0?A]O@3lhnT0oooo0?g]kP3o[K020?ooo`0303=3Y@000800002000@000200`00
0H000`3oool000:00002P@030?ooo`8000B100D0oooo0005P@001H4000F20?ooo`020006PP<0oooo
0P0128800`0128<0oooo0049P`020049P`800@Z300@0oooo004;P`012h@0oooo0P0138@01`3oool0
0@f4004=Q03oool00@j50?ooo`013XD00P3oool00`023hD00Q25008@Q@040?ooo`04008AQP024XH0
0Q:6008BQP800Q>600@00Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<0
0aR800<00aV800<IR@036HT010036XT300<KR@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<0
12:<10048h`0100498`012B=00@TS@049Hd200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DY
SP0300DZSP05:Xl01BZ?00<01B^?1005;8l300H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<943
00HaT@801S:A00@01S:B00HcTP06<i801S>B0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07
=i<00`07>9<01cRD00LhU00300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0
242G00Q1U`08@IL0246G0`08@YL200Q3U`0400U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09
AYT01009AiT300U8V@<02DVJ0`09BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`0
2U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO
00<02eRO100;FIl300aJX0<035^P0P0<G:00100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR
00aPXP0<H:80362R0P0<HJ800`0=HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eU
Y00300eVY0<03FNT0`0=J:D300iYY@<03VZU100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW
0`0>KjL200i`Y`0400m`Z00?LJP03g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<0
3gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o
[@<04H2]00<04H6]0161[P0APJh00`0APZh30163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7
/0<04XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0B
S[800`0CS[804hnb01>?/P0201>?/`<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0C
UKD301BF]@<059Ne100DV;H301BI]P8059Zf00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM
^00EW[P05Ijh01FN^0<05Inh00<05J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<0
5ZJk0`0FYk/301JX^`<05ZVl100FZ[`0100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^
_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0030<SPf028`;P0R<2h
00/0R<2h00<0B92800000038h=P00P28`;P00`000000R<2h08S0^00508S0^00500000028`;P0R<2h
04R@R00000000P0H]<000`38h=P0R<2h08S0^00308S0^0@000001028`;P01018T8P0000001Rd`00H
]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080002000d0VjOa0?g]kP3R9S`0o_Gh
0?N9U`3dHVh0lj2^0?ARKP3ooOl0ojf`0?cSj@3oool0<d>U00L000200`000H000`3oool000:00002
P@030003P@<000B10P001H4010001H8000J20006PP001X820007PP050047PP0128800@R20?ooo`01
28<00`012H<3004:P`03004;P`012h@00@^400<00@b40`013H@3004>Q@<00Pn50`0248D4008AQP<0
0Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN80`0368P0
0`036HP00aV900<IR@0400<JR@<00a^90`0378X300<MRP<011j:0`047h/300@PR`<0126;0`048X`4
00@SS00400@TS00498d012B=00@US@801BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<0
1BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A
0P06<Y401006<Y801S>B00HcTP06<i8200HdTP0300LdTP07=I801cFB00801cFC0`07=Y<300LgT`03
00LhT`07>9@01cRD00<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0
246G00Q1U`08@IL300Q2U`8024>G00@02D>H00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@04
00U7V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId0
2U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;
F9l400]IW`<035ZP0`0<Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R
00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<0
3FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_
Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX3
00mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4011m[004011n[00@OZd047j]011o[@804Gn]0`0A
P:d00`0APJd04H6^0161[P030162[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0B
R;0201:9/00401:9/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P03
01>>/P0CSk804hnb00804hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<0
59Je0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN
^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/3
01JW^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^
_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C000<0b>3H08S0^028`;P02`28
`;P00`18T8P000000<SPf00208S0^00300000028`;P0R<2h00D0R<2h00D0000008S0^028`;P0B928
0000000201Rd`0030<SPf028`;P0R<2h0080R<2h0P00000208S0^08000000`28`;P01018T8P00000
01Rd`00H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080002000<0VjOa0?K8c03R
9S`00P3o[K001`3O92h0ojBN0?Jla@3o[K00kW^<0?ooo`0c@jD0200008030001P0030?ooo`000X00
00:100<000>10`0018420005P@040005PP001X8000J20006PP8000N200D00@N20048PP012880oooo
0048P`030049P`040?ooo`012X<00@Z3004;P`800@^40`0138@3004=Q0<00@j50`023hD3008@Q@@0
0Q660`024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN800<GR0035hP3
00<HR00300<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:0`047XX300@OR`<0122;0`048H/3
00@RS0@012><00@012B<00@TS@0498d012F=0P059Hd300DVS@0300DWS@059hh01BN>00<01BR>0`05
:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@00@01RnA00H`T@06<9401S2A
0`06<I4200HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB00LeTP07=I800P07=I<300LfT`<0
1cNC00<01cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP04
00Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009A9P300U5V00300U6V009AYT0
2DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:CY/300Y?W0@02U2L00@02U6L
00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN0`0;EYh00`0;Eih02eNO00]G
W`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ4035fQ0`0<GZ4200aOX@0400aO
XP0<H:80362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eSX`<03FBS00<03FFS00eUY00=
IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW00i^
Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?LjT03g>Y00@03gBY0`0?MJT3
00mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@047j/011n[@0@OZd047n]0P0A
Ojd30160[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_0164[`030165[`@04HJ_0`0B
Qk0301:8/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P80
4Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@301>D]0<0
4iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g01BK]`<059bg0P0DWKL0100E
WKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0FYKX3
01JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm0P0G[;d301N]_@0301N^_@0G
[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o0P0H]<000`38h=P0R<2h08S0
^00;08S0^00304R@R0000000b>3H0080R<2h2@00000208S0^00504R@R00000006;C001Rd`038h=P0
0`28`;P2000000@0R<2h0P00000208S0^00404R@R00000006;C001Rd`080R<2h0@18T8P100000000
00@0R<2h0<SPf028`;P0R<2h0P0008000`2KYo40nLgD0?N9U`020?ooo`070?n]/03Q5S@0ogIk0?nT
WP3R9S`0ohUo03=3Y@080000P0<0006000<0oooo0002P0000X400`000h430004P@8000F100@000F2
0006PP001X8000J20P001h8010011h800@R20048PP0128<40?ooo`<00@Z300<00@^3004;Q0012h@0
0`0138@2004=Q0040?ooo`013XD00@j5004>Q@<00Pn50`0248D4008AQP<00Q:60P024hH010024hL0
0QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV900<IR@04
00<JR@<00a^90`0378X300<MRP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@TS00498d0
12B=00@US@801BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05
:hl400D/S`<01Rf@0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B
00HcTP06<i8200HdTP0300LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<0
1cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2
U`8024>G00@02D>H00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX3
00U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;
Did00`0;E9d02eBN00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<
Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP03
00eQXP0=HZ803F:R00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<0
3VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00ma
Z00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3
011jZ`<047^[0`0@O:`4011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161
[P030162[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0B
R[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb0080
4hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<0
59Vf0P0DV[H0100DV[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP0
0`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`4
01JZ_00401J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<0
5k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C000<0b>3H08S0^028`;P02`28`;P00`18T8P000000<SP
f00208S0^0T000000P28`;P01@18T8P0000001Rd`00H]<00b>3H00d0R<2h00@0B9280000000H]<00
6;C00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20000P00709^Wl@3oool0lj2^0?AR
KP3oool0mhVG0?W=e0020?ooo`030?>P[P3oool0<d>U00P000200`000H020002P0040002P@000h40
00>10003P@<000B10P001H4010001H8000J20006PP001X820007PP030047PP0128800@R200800@R3
0`012H<3004:P`03004;P`012h@00@^400<00@b40`013H@3004>Q@<00Pn50`0248D4008AQP<00Q:6
0P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN80`0368P00`03
6HP00aV900<IR@0400<JR@<00a^90`0378X300<MRP<011j:0`047h/300@PR`<0126;0`048X`400@S
S00400@TS00498d012B=00@US@801BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>
00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06
<Y401006<Y801S>B00HcTP06<i8200HdTP0300LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300Lh
T`07>9@01cRD00<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G
00Q1U`08@IL300Q2U`8024>G00@02D>H00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7
V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M
00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l4
00]IW`<035ZP0`0<Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aP
XP0<H:8200aQXP0300eQXP0=HZ803F:R00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT
0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`80
3W2W00@03g2X00maZ00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mg
ZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d0
0`0APJd04H6^0161[P030162[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;02
01:9/00401:9/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>
/P0CSk804hnb00804hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je
0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00E
W[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW
^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P03
01N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C000<0b>3H08S0^028`;P02`28`;P0
0`18T8P000000<SPf00=08S0^00504R@R00000006;C001Rd`038h=P03@28`;P01018T8P0000001Rd
`00H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0<0002000/0VjOa0?ooo`3oRGl0
oooo0?>P[P3aTj40oooo0?omo`3cX:h0oo_l03=3Y@080000P0<000600P000X0010000X4000>10003
P@000h430004P@8000F100@000F20006PP001X8000J20P001h800`011h800@R20048PP020048P`<0
0@V30`012X<00`012h<00@^4004;Q003004<Q0<00@f40`013XD3008?Q@<00Q2510024HH3008BQP80
0Q>600@00Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<00aV8
00<IR@036HT010036XT300<KR@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<012:<10048h`0
100498`012B=00@TS@049Hd200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05
:Xl01BZ?00<01B^?1005;8l300H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@801S:A
00@01S:B00HcTP06<i801S>B0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<0
1cRD00LhU00300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08
@IL0246G0`08@YL200Q3U`0400U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT3
00U8V@<02DVJ0`09BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:
DYd200]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;
FIl300aJX0<035^P0P0<G:00100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80
362R0P0<HJ800`0=HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<0
3FNT0`0=J:D300iYY@<03VZU100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`
Y`0400m`Z00?LJP03g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3
011hZP<047V[0`0@NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<0
4H6]0161[P0APJh00`0APZh30163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0B
RK00100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[80
4hnb01>?/P0201>?/`<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<0
59Ne100DV;H301BI]P8059Zf00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh
01FN^0<05Inh00<05J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/3
01JX^`<05ZVl100FZ[`0100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G
[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0l0b>3H00<000000<SPf038h=P03@38
h=P00`0000006;C001Rd`00?0<SPf0030000000H]<006;C00080R<2h0@18T8P10000000000@0R<2h
0<SPf028`;P0R<2h1000080309^Wl@060?ooo`3cX:h0m;Fo0?Jla@3kfMX0<d>U2@0008030001P080
00:000@000:10003P@000h4000>10`0018420005P@040005PP001X8000J20006PP8000N200<00@N2
0048PP0128800P0128<30049P`<00@Z300<00@^3004;Q0012h@00`0138@3004=Q0<00@j50`023hD3
008@Q@@00Q660`024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN800<G
R0035hP300<HR00300<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:0`047XX300@OR`<0122;
0`048H/300@RS0@012><00@012B<00@TS@0498d012F=0P059Hd300DVS@0300DWS@059hh01BN>00<0
1BR>0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@00@01RnA00H`T@06
<9401S2A0`06<I4200HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB00LeTP07=I800P07=I<3
00LfT`<01cNC00<01cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH2
00Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009A9P300U5V00300U6
V009AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:CY/300Y?W0@02U2L
00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN0`0;EYh00`0;Eih0
2eNO00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ4035fQ0`0<GZ4200aO
X@0400aOXP0<H:80362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eSX`<03FBS00<03FFS
00eUY00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]YP0400i]Y`0>KZL0
3VjW00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?LjT03g>Y00@03gBY
0`0?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@047j/011n[@0@OZd0
47n]0P0AOjd30160[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_0164[`030165[`@0
4HJ_0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb
01:=/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@3
01>D]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g01BK]`<059bg0P0D
WKL0100EWKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj
0`0FYKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm0P0G[;d301N]_@03
01N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o=P0H]<0208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^1H000200`000H020002P0040002P@000h4000>10003
P@<000B10P001H4010001H8000J20006PP001X820007PP030047PP0128800@R200800@R30`012H<3
004:P`03004;P`012h@00@^400<00@b40`013H@3004>Q@<00Pn50`0248D4008AQP<00Q:60P024hH0
10024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV9
00<IR@0400<JR@<00a^90`0378X300<MRP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@T
S00498d012B=00@US@801BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05
:Xl00`05:hl400D/S`<01Rf@0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006
<Y801S>B00HcTP06<i8200HdTP0300LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@0
1cRD00<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08
@IL300Q2U`8024>G00@02D>H00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI
0`09BIX300U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@80
2e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<0
35ZP0`0<Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:82
00aQXP0300eQXP0=HZ803F:R00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@3
00eXY@<03VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@0
3g2X00maZ00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ
0`0@NJ/3011jZ`<047^[0`0@O:`4011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd0
4H6^0161[P030162[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/004
01:9/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk80
4hnb00804hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD4
01BH]P<059Vf0P0DV[H0100DV[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh
0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk
0`0FZK`401JZ_00401J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<0
5k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_cH06;C00P28`;P104R@R040000000000`28`;P0b>3H
08S0^03o08S0^?l0R<2hO@28`;P104R@R040000000000`28`;P0b>3H08S0^03o08S0^?l0R<2hO@28
`;P104R@R040000000000`28`;P0b>3H0<SPf03o0<SPf?l0b>3HO@38h=P104R@R0400000003o08S0
^?l0R<2hP@28`;P100000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell["com.apple.mrj.swing.MacLookAndFeel", "Text"],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;N0001Z2000`400?l00000o`00003oooo`l?3o
oo3`l=7ol?3`00?ofMWIooooooooool03?ooool00?ool?3`ooo`l?3Aoo3`l004omWIfOoooooooooo
onGUi@?ooooo00GoiNGUooooooooooooooooonGUi@03ooooo`00ooo`l?3ooo3`l=7ol?3`00gofMWI
oooooooJf][oSHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003ooo3`
l?ool?3`dOo`l?003_oIfMWooooooooooooJf][oSHf=onGUiOoooooof][Johf=SOoUiNGoooooom[J
f_n=SHgoiNGU0Oooool00?ool?3`ooo`l?3Aoo3`l00=omWIfOoooooooooooooooooJf][oSHf=onGU
iOoooooof][Johf=SOoUiNGoooooom[JfP02ooooo`00ooo`l?3ooo3`l=7ol?3`00?ofMWIoooooooo
ool00_ooool01ooJf][oSHf=onGUiOoooooof][Johf=SOoUiND00oooool00?ool?3`ooo`l?3Aoo3`
l003omWIfOoooooooooo00?ooooo00Oof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003o
oo3`l?ool?3`dOo`l?000ooIfMWoooooooooo`04ooooo`07om[Jf_n=SHgoiNGUoooooooLg=coSHf=
onGUi@01ooooo`00ooo`l?3ooo3`l=7ol?3`00?ofMWIooooooooool01Oooool01OoJf][oSHf=onGU
iOoooooog=cL00;ooooo003ooo3`l?ool?3`dOo`l?000ooIfMWoooooooooo`06ooooo`03omcLg?n=
SHgoiNGU00?ooooo003ooo3`l?ool?3`dOo`l?000ooIfMWoooooooooo`07ooooo`03omcLg?n=SHgo
iNGU00;ooooo003ooo3`l?ool?3`dOo`l?000ooIfMWoooooooooo`08ooooo`03omcLg?n=SHgoiNGU
007ooooo003ooo3`l?ool?3`dOo`l?000ooIfMWoooooooooo`09ooooo`7og=cL0Oooool1ooooo`00
ooo`l?3ooo3`l=7ol?3`00?ofMWIooooooooool03?ooool00?ool?3`ooo`l?3Aoo3`l0oofMWI0000
3Oooooooo_knookno_olo?conOWiooKfm_obl_;okNg]onSXj?oShn?oh>3PomgMgOoKfm/00_oJf][o
omWIfOoofMWI`OoIfMT2om[JfP0:om_KfooMgMgoh>3Pon?ShooXj>SokNg]oo;bl_ofm_KonOWioocl
o0;oo_kn0_ooool000;okNg]00[oj^[ZonSXj?oRh^;ogMgMomKFe_o=cLgoa/K6okjn__nj^[[o][Jf
1?nc/k?ook:b/_oo/[:b_onb/[84ok>c/`0:okJf]_nj^[[o_[jnolK6a_o=cLgoe]KFomgMgOoRh^;o
j>SXon[ZjP;okNg]0Oo^k^h0000>onGUiOoRh^;ogmoOom[Jf_oBd];oalO7okfm_Onb/[;oZ:RXoj2P
X?nKVi_oV9RHoiBDU?nCTi?ooi:BT_ooTY:B`onBTY803OnCTi?oU9BDoiRHV?nKVi_oX:2PojRXZ?nb
/[;o_KfmolO7aooBd];of][JomoOgooRh^800_oUiND0000>on_[jooXj>Soh^;RomSHf?o;bl_o_[jn
ojj^[_nQXJ7oUIFEohb<S?n5QHGoPX:2ogmoOomnOWkoogemOOooOGem`ommOGd03_mnOWkoOgmooh:2
P_n5QHGoS8b<oiFEUOnQXJ7o[Zj^okjn__o;bl_of=SHon;Rh_oXj>Sojn_[0Oo]kNd0000DooWinOoc
lo?ojNWYomWIfOo7alOo];Bdoj:RX_nJVY[oZZZZol?3`ooIfMWok>c/ooKfm_ogmoOonOWiooShn?oi
nOWon_[jooWinOogmoL3ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`02ooShn00?ooWinOohn?SomoOgonk^k_oJf][oa<C4
ojZZZ_nJVY[oXZ:RokBd]?o7alOofMWIonWYjOoclo?onOWi007ooOgm00003?oUiNGogMgMolk>c_nm
_KgoZ:RXoiFEUOnUYJGoc<c<onk^k_ofm_Koo?clookno_ooooooooooooo7ooooo`0<ookno_olo?co
moOgono_koo=cLgoYZJVoiFEUOnXZ:So_Kfmolk>c_oMgMgoiNGU0OoZj^X0000:om[Jf_o>c/ko_Kfm
ojRXZ?nFUYKoZj^[omkNg_o[jn_om?Cdoo_knoooooooooooooo;ooooo`0:oo_knooclo?ok>c/on7Q
hOn^[ZkoUYJFojRXZ?nm_Kgoc/k>om[JfP7oh>3P00002_oMgMgocLg=okRh^?nQXJ7oZ:RXomCDe?oP
h>3ok>c/ooGemOomoOgoooooooooooooboooool02_ono_kom_Kfonc/k?oRh^;ofMWIojb/[?nQXJ7o
^;Rholg=cOoMgMd1onGUi@0000_oj>SXomCDe?nj^[[oZJVYolK6a_oDe=Coh>3Ponc/k?obl_;oo?cl
ooknoP3ooooooooooooob_ooool02_ojn_[om?Cdon[Zj_oShn?oemOGolg=cOn/[:co^[ZjomCDe?oX
j>P1oo?cl`0000ooe=CDokno_onVYZKo[:b/olK6a_oBd];og=cLonKVi_o/k>comOGeooShn?ojn_[o
oOgmooooooolo?`02?ooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01?ooool03oomoOgooooooogmoOokno_on?ShooCdm?o]kNgoi^KVomoOgooFe]Ko
c<c<ok:b/_nWYjOo_knoomCDe001on;RhP0001?ob/[:okFe]OnNWYko][Jfol?3`oo?clooe]KFomoO
gooVi^Koj^[Zono_kooclo?om?CdooGemOogmoOom_KfooOgmoofm_Kon?Sh00;omoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg01Com_KfooShn?ogmoOomoOgooKfm_ogmoOom_KfooCdm?obl_;ol?3`on_[jooVi^Ko
hN7Qom[Jf_oCdm?obLW9okno_onSXj?o]KFeol[:bP7ofMWI00002oo@d=3o^;Rhoj2PX?nc/k?o`<30
olW9bOoCdm?ofMWIomgMgOoRh^;oiNGU00;oj^[Z00?ok>c/ong]kOo]kNd01oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h00oo^k^h2ong]k@;ok>c/
00cojNWYonKVi_oShn?oh>3Pom_KfooEeMGocLg=olG5aOnk^k_oYjNWokRh^?o@d=01on3Ph00000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oN
g]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5
omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgM
g@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Ko
g]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kN
o?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oM
gMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6
omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkN
gPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGo
gMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgM
COoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoN
g]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5
omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgM
g@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Ko
g]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kN
Z_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
d@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001
oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Q
h@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
Z_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oN
g]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5
omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgM
g@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Ko
g]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kN
o?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oM
gMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6
omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkN
gPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGo
gMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgM
COoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoN
g]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5
omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgM
g@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Ko
g]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kN
Z_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
d@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001
oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Q
h@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
Z_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oN
g]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5
omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgM
g@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Ko
g]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kN
o?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oM
gMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6
omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkN
gPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGo
gMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgM
COoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoN
g]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5
omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgM
g@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Ko
g]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kN
Z_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
d@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001
oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Q
h@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
Z_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oN
g]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5
omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgM
g@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Ko
g]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kN
o?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oM
gMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6
omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkN
gPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGo
gMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgM
COoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoN
g]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5
omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgM
g@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Ko
g]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kN
Z_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
d@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001
oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Q
h@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
Z_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oN
g]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5
omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgM
g@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Ko
g]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kN
o?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oM
gMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6
omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkN
gPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGo
gMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgM
COoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoN
g]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5
omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgM
g@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Ko
g]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kN
Z_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
d@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001
oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Q
h@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
Z_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oN
g]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5
omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgM
g@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Ko
g]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kN
o?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oM
gMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6
omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkN
gPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGo
gMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgM
COoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoN
g]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5
omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgM
g@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Ko
g]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kN
Z_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
d@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001
oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Q
h@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
Z_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oN
g]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5
omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgM
g@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Ko
g]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kN
o?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oM
gMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6
omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkN
gPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGo
gMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgM
COoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoN
g]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5
omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgM
g@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Ko
g]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kN
Z_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
d@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001
oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Q
h@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
Z_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oN
g]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5
omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgM
g@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Ko
g]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kN
o?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oM
gMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6
omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkN
gPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGo
gMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgM
COoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoN
g]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5
omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgM
g@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Ko
g]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kN
Z_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
d@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001
oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Q
h@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
Z_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oN
g]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5
omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgM
g@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Ko
g]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kN
o?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oM
gMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6
omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkN
gPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGo
gMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgM
COoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoN
g]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5
omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgM
g@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Ko
g]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kN
Z_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNo?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
d@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLZ_oNg]h5omgMg@Kog]kNXOoMgMd00oo<c<cofm_KomgMg@02om?Cd`?ogMgM00?ocLg=
olo?cooMgMd01?oMgMd01?oLg=co_[jnokfm_OoLg=`4omgMg@03om_Kfonn_[koalO7047ogMgM1_oN
g]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNgYGogMgM00Wo;Rh^
ohn?SooMgMgocLg=ohZ:R_o:b/[ogMgMojFUYOl10@400_oMgMd03Om6ATKo1PH6oaHF5_n7QhOo410@
od];BooMgMgoa/K6ocLg=ol0003o3`l?oaTI6OoFe]H00_oMgMd03_n>SXko3`l?oa/K6olN7Qko30`<
oginO_oLg=cogMgMoiRHV?l820So2`/;oalO7ol^;RkoT92@?ooMgMd6omkNgPGogMgMCOoNg]h5omgM
g@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNUOoMgMd04?l^;RkoShn?omgMgOmkNg_o0000
og=cLooMgMgoYJFUo`410OoMgMgoZj^[o`<30ono_kooalO7odi>C_l>3Ph2omgMg@0:ocTi>OlV9RKo
[jn_omgMgOnk^k_ofm_KomgMgOn>SXko20P8oijNWP;ogMgM00_o[:b/oa8B4_meMGGogMgMokVi^OnU
YJGof=SHomgMgOn8R8So0`<3ol30`00nomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]jEomgMg@0Dobh^;_n?ShoogMgMob/[:olm?Cgo8B4QomgMgOnUYJGo
0@41omgMgOnl_;co0P82oj>SXooMgMgoRHV9oa/K6ooMgMgo_[jno`000?n1PH44omgMg@03omSHf?lG
5aOoB4Q800CogMgM00?oOWino`X:2_o=cLd01?oMgMd00oo3`l?o0000oifMW@0nomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]jEomgMg@09obh^;_n?Shoo
^[Zjo`000?ng]kOo92@Tojf][OnUYJGo0@4100;ogMgM00WoUIFEob/[:ol/;2co;Rh^oa/K6ooMgMgo
Y:BTo`000?nb/[801?oMgMd00oni^KWo0000ohB4Q004omgMg@03ol?3`ol0003oXZ:R00?ogMgM00Co
d=3@odA4A?l61PKodM7A?_oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oN
g]h5omgMg@Kog]kNUOoMgMd02Ol^;RkoShn?of][JolY:BWogMgMogIfM_mKFe_oYJFUo`410@04omgM
g@07om_Kfon0P83o71`LomgMgOnm_Kgo0000ogemO@04omgMg@03oibLW?l0003o_;bl00CogMgM00?o
fMWIo`000?n4Q8@00_oMgMd01?nMWIgo61PHoa<C4onTY:@oomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]jEomgMg@09obh^;_n>SXko6a/KogQhN?oMgMgo
aLG5oa4A4OnOWioo0@4100;ogMgM00GoW9bLokbl_?oJf][oE5ADodQ8B002omgMg@09ocHf=_lQ8B7o
Y:BTomcLg?o0`<3ogMgMojb/[?l0003o]kNg00CogMgM00So]KFeo`000?nDU9CogMgMofm_Kol0003o
BTY:olO7ad3ogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6
omkNgYGogMgM00Co;Rh^oe]KFol10@7oa/K60_oMgMd00oll?3coGEeMo`410@02omgMg@05ogMgMol[
:b_o3@d=oc4a<OnYZJT00_oMgMd02Oo9bLWoBd];o`d=3Ol92@Wo820PomgMgOo>c/ko0P82ohb<S004
omgMg@06ogMgMol0003o^KViolO7aol10@7oOgmo@_oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kN
Z_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNUOoMgMd00ol^;Rko4A4AocXj>P03omgMg@03ohj>S_l@
413o0@4100CogMgM00?ofm_KomgMgOoMgMd01OoMgMd01ooJf][ogMgMomgMgOoMgMgoFEUIobHV9_oA
dM400_oMgMd01ooGemOo;bl_od51@OoMgMgo^k^ko`410Oo8b<P0@_oMgMd6omkNgPGogMgMCOoNg]h5
omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNUOoMgMd00ol^;Rko0000ohR8R003omgM
g@03omCDe?l:2P[o0@41013ogMgM00SocLg=ocTi>OlS8b?oLW9bogMgMol];Bgo:b/[ol?3``;ogMgM
00Go@410oc8b<_mkNg_oE5ADoda<C00oomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007o
hN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]jEomgMg@03oiRHV?n5QHGodM7A00CogMgM00?oWIfMohJ6Q_oMgMd0
4?oMgMd01_oKfm_oUIFEofQXJ?mTI6CoShn?omOGe`?ogMgM00GofMWIoifMWOmOGeooMGEeojFUY@0o
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomoOg`Gog]kN1_oOgmolomkNgPKogmoO1OoNg]i=omoOg`Gog]kN1_oOgmnYomkNgP0@omgMgOoL
g=cog=cLom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph07o
lO7a00003Oo@d=3o^;RhoibLW?n/[:co^k^kolK6a_o=cLgodm?ComOGeooKfm_ogmoOon7QhOoRh^80
0_oShn<7onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H5onGUi@;oi>CT0_oShn<03?oRh^;oh>3P
omcLg?oIfMWoe]KFom3@d?o9bLWo`L71okFe]OnUYJGo^;Rhom3@d07oh>3P00003Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`2omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oM
gMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oM
gMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oM
gMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oM
gMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oM
gMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oM
gMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooM
gMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oM
gMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?o
g]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgPCogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2PokFe]Oo:b/X00OoIfMT0000=omCDe?no_kooS8b<oijNW_n][Jgo^KViol;2`_o7alOoc<c<om3@
d?oBd];oeMGEomKFeP02omOGe`03omSHf?oIfMWofMWI0?oofMWIoooIfMVmomWIf@;of=SH0_oGemL0
3?oEeMGodm?Com3@d?o>c/kob/[:olG5aOno_koo]KFeojVYZOnHV9So_knoomCDe07oh^;R00003OoX
j>Soe=CDohb<S?nCTi?oXZ:Rojn_[onj^[[o`L71olO7aoo;bl_oc/k>om3@d?oAdM400_oCdm<3omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00?oe]KFomGEeOoDe=@00_oC
dm<03?oAdM7od=3@olg=cOo:b/[o`l?3okjn__nf][KoZj^[oifMWOnEUIGoe=CDonSXj07olo?c0000
4_oMgMgocLg=oi2@T?n9RHWoUiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooIfMWof][Jom_K
fooJf][ofm_KomcLg0Oofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00?ofm_K00kof][JomWIfOoHf=Soe]KFom?Cdoo=cLgo`/;2okJf]_n/[:coWinO
oi2@T?nFUYKocLg=omgMg@7oiNGU00002ooJf][oc/k>oibLW?mjNW[oR8R8oiJFU_nZZZ[oa<C4omGE
eOoKfm_og]kN00;oh>3P0ooRh^800ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`03on?Sh`;oh^;R00gohN7Qon3Ph?oOgmoo
g=cLomOGeoo5aLGo[:b/oijNW_n@T93oPX:2oj2PX?o>c/kof][J007oh>3P00003_oUiNGogMgMol;2
`_mkNg_oN7QhohJ6Q_nOWiooaLG5omSHf?oMgMgogmoOon7QhOoRh^;ohn?S0ooTi>@4onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@?oi>CT00gohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4ol?3
`ooMgMgoiNGU007oj^[Z00002ooinOWolo?conWYjOnXZ:SoIFEUog=cLon=SHgo^k^komCDe?oJf][o
gMgM00;ogmoO00?oh>3Pon7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN402?oQhN403OoPh>3ogmoOomgMgOoLg=coeMGEokVi^On>SXko
Ng]kofi^K_n[Zj_ojNWYoo?clooinOT00OomoOd0000<on_[jooXj>Soh^;RomOGeon=SHgoHV9RogIf
M_nTY:CoalO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00;og=cL013ofm_KomcLg?oKfm_of][JomWIfOoH
f=Sodm?ColG5aOnLW9coMGEeofMWIon@T93oemOGon;Rh_oXj>Sojn_[0Oo]kNd0000>onGUiOoRh^;o
gmoOom[Jf_o9bLWoQhN7oeYJF_mkNg_oXj>Sokbl_?o6a/Kobl_;olg=cOo?cll2om7Ad@God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B0_oA
dM403Oo@d=3oclo?olc<c?o8b<So^k^koibLW?mbLW;oFe]KohZ:R_o9bLWof][JomoOgooRh^800_oU
iND000;okNg]00koj^[ZonSXj?oRh^;og=cLoibLW?m]KFgoJ6QXoh>3PonGUiOoXj>Sojb/[?n_[joo
/K6aok:b/P;o];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H03ond];Co
/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9RH_m^KVkoWinOomcLg?oRh^;oj>SXon[ZjP02ong]
k@7ok^k^00004_ooooooo_knookno_olo?conOWiooKfm_obl_;ofMWIojRXZ?n3Ph?oKVi^ofEUIOmY
JFWoLW9bogAdM?miNGWoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00koO7alogYjN_mjNW[oMgMgogAdM?m_KfooM7AdohF5QOnX
Z:Sof][Joo;bl_ofm_KonOWiooclo0;oo_kn0_ooool000;ok^k^0_o]kNd01?o/k>coj^[ZonSXj?oU
iND2on;RhP03on3Ph?oOgmoog]kN0?oogMgMoooMgMg5omgMg@03omkNg_oOgmooh>3P00;oh^;R00Co
iNGUonSXj?oZj^[ok>c/0_o]kNd3onk^kP001?oVi^H2onGUi@03onCTi?oRh^;oh^;R00;oh>3P0_oO
gmooomkNg_oog]kNaOoNg]h2omoOg`;oh>3P0_oRh^800ooTi>CoiNGUonGUi@05onKViP00oomoOgn6
ogmoO`OoOWinoomoOgmCogmoO`0000Cojn_[onKVi_oRh^;og]kN0ooMgMd0oooLg=cog]kNomkNg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMg@00AooNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkogMgM00;og=cL03gofm_KomgMgOoLg=cog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomcLgOoNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oMgMgofm_Kom[Jf_oGemOof=SHomOGeooJf][ofm_L00;ogMgM0?oog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]h004GogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMd00ooNg]h00ooMgMgog]kNomkNgP03omgMg@7o
hN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>000ooIfMT02?oHf=SofMWIomWIfOoIfMWof=SHomKF
e_oCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=
00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOG
omSHf?oofMWI2ooIfMT2omSHf006omKFe_oCdm?odm?ComCDe?oGemOof=SH0_oIfMT00ooHf=SofMWI
omWIf@02omSHf0WofMWI00?of=SHomWIfOoIfMT00_oHf=P00ooIfMWof=SHomOGe`02omSHf1OofMWI
00Cof=SHomKFe_oBd];oclo?0_o=cLd01?o?cloodm?ComOGeooHf=SoomWIfDGofMWI00?of=SHomWI
fOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02
on7Qh@0=omkNg_oLg=codm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09
on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09
on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`3o
on7Qh@[ohN7Q00Woh>3PomoOgooKfm_oe]KFomCDe?oFe]Kof][JomkNg_oPh>001_oOgml3on3Ph003
omoOgooPh>3oh>3P00;oh>3P2?oOgml2omkNgP;ogmoO0ooPh>02omoOg`;oh>3P0_oOgml=on3Ph005
omoOgooMgMgofMWIomGEeOoCdm<00_oBd]800ooFe]Kog=cLon3Ph03oon7QhDOohN7Q00?oh^;Ron7Q
hOoRh^801?oQhN41onCTi07ojNWY0Oo]kNd00003oo3`l?o_knoolO7a00;ol?3`0_o_knl0ooo`l?3o
k^k^onSXj?oKfm_o`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgo
lO7aono_kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2`_nTY:CoS8b;og]kNomgMgOo
Ng]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo7alOo_knoolO7aono_kooalO7okno_oo7akoo]kNgo
j^[Zom[Jf_o2`/;oY:BTohb<S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]kOoalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7al@00C_o_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_koo`l>kokNg]onc/k?oUiNGoh^;RomoOgooU
iNGojNWYong]j`;oj>SX00Koi^KVonWYjOoWinOojn_[onc/k?o^k^`3on[ZjP09ono_koo^k^kok^k^
onSXj?oXj>Koi^KVonWYjOoWinOoj^[Z00;ojNWY00goiNGUonOWiOoWinOojn_[onc/k?o_knoojn_[
on[Zj_oYjNWok^k/onc/k?o[jn_oj>SX00;okNg]01Cok^k^on[Zj_o/k>[ok>c/onk^k_oZj^[ok>c/
ong]kOo^k^koj^[Zonc/j_o/k>cok^k^ojf][OmgMgOoFEUIofm_Konf][KohN7PonOWi`;okno_0?oo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo^k^ko
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO40
04cokno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo`l?3okno_oo3`l?o_knool?3`ono_koo`
l?3okno_1?o`l?000003oo;bl_o^k^koinOW00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mUIFGo
DE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@00ooUiNGoi>CTonGUi002
onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoA
dM3og]kN00;oi>CT0?ooiNGUonCTi?oUiNGoi>CTonCThooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5
ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7AomkNg_oTi>?oi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiND002Ooi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCohn?SolK6a_lX:2SoADE5ohn?SooBd];ofm_KomcLfooFe]H00ooEeMD0
3?oDe=Cof][JomoOgooOgmkofMWIomGEeOoHf=SogmoOon7QhOoMgMgoe]KFomGEe0;oeMGE00_oe=CD
omWIfOoJf][of=SHomGEeOoFe]Goe]KFomWIfOoMgMgoh>3Pom_Kf`02omKFeP09omgMg?oLg=cof=SH
omGEeOoLg=coh>3PomoOgooJf][ofm_J00;ogMgM0?oofMWIomcLg?oOgmooh>3Pom_KfooJf]WogMgM
on3Ph?mcLg?oJ6QXohf=SOmDE5Co20P8oj>SX_oKfm_ohn?SonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoShn?oiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
on?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>@005KoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi0CoiNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o/k>`1oo;blP0000?o
m?Cdong]kOoWinL00ooPh>004_oOgmoog]kNom;Bd_nd];CoQhN7oe]KFom]>cGoWTi2ole_GooYPfoo
cFmOoii>@om]>cKoG5aLohN7Qond];Cod];BomkNgPGoh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m]
H2coWYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomkNg_oB
d];o];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=AomZWSCoBFX_oeaLG?n7QhOo];Bdom;Bd_oN
g]h0oooPh>09on3Ph006omoOgoo?clooVIVIoi:BT_lI6AWoS8b<0_oEeMD07oo?cloo`/;2olk>c_o>
c/koaLG5ol[:b_oJf][of=SHom3@d?o;bl_oclo?omSHf?oJf][oeMGEolo?coo1`L7od=3@olk>c_o4
a<Cobl_;omSHf?oGemOo_[jnok^k^ooAdM7od=3@omGEeOoHf=Sodm?Colc<c?o>c/h00_oEeMD01Oo>
c/koc<c<om?CdooJf][of=SH00;od];B00Cof=SHomOGeooAdM7odm?C0_oIfMT01_oCdm?odM7AomOG
eooHf=SodM7Aom3@d0;odM7A00CoATI6od51@OoGemOog]kN@OoPh>000ooOgmooh>3Pon3Ph03oon3P
h07oh>3P00?ogmoOon3Ph?oOgml00_oOgml3on3Ph003on7QhOoWinOok>c/007om?Cd00000oofm_Ko
l_;bon_[j`03onSXj00ConOWiooRh^;ocLg=oinOWom[GeooScH^oneaHOoiWI3ooK6Uoofl[oom]:Oo
nInConedHonB=booJemOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWom^IUoo
Tg8RongAA?oilgCooOf=oogmUOomoHkonOQfongGAonCLb;oKVMOoinOWoo=cLgoh^;RonOWi`03onSX
j00ConOWiooRh^;ocLg=oinOWomPJ5ooBg`Soi;QBonmnG_od?fBomSmVooDoIGo`?UnoiSXCOm=P2Co
H6UOoinOWoo=cLgoh^;RonOWi`3oonSXj0[oj>SX00Coi^KVon7QhOmMGEgoCDe=0_oMgMd07om@D53o
1`L7oaDE5On4Q8Co5QHFod=3@ooRh^;ogMgMoibLW?l0003oShn?omgMgOoQhN7ofm_Kod10@?l820So
6ATIohR8R?l;2`_oF5QHokNg]ol<30co1`L7ob<S8olW9bOoOGemom[Jf_oMgMgoe=CDo`/;2omIFET0
0_oIfMT00omMGEgo2`/;om?Cd`02omoOg`06oeYJF_m>CTkog]kNomkNg_lS8b?oQ8B40_oQhN403?mj
NW[o;Rh^omgMgOoMgMgo`/;2oe1@D?lc<c?oKVi^oh>3PolQ8B7og]kNonKVi_ooj>SXC_oXj>P1onc/
k07ol_;b0Oofm_H0000IooOgmoohn?Son?ShooShn?ogmoOon?ShooOgmoo^k^koc/k>oi2@T?n5;b_o
jFAFooZBQoonYY_oo[6UoonhZoon/jKooZRLoo^DROo^J5WoRC4[oi2@T?o>c/kok^k^ooOgm`03ooSh
n00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_PK_onm8;oo_j:ooooT_onoXcoo_R3oo_UL?o``Sko
VFX[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSo
c_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^ooOgm`3oooShn0[on?Sh02Gom_Kf
oo7alOn1PH7o7alOong]kOo6a/Ko0000ol?3`ooCdm?oG5aLo`P82?oZj^[ol?3`on[Zj_mBDU;o51@D
ocdm?OoYjNWol?3`ojn_[ol71`Ood];Bolg=cOm>CTko6a/Konk^k_oKfm_o[Zj^onSXj?o/k>co[Zj^
o`000?nd];Cok>c/ok2`/?l;2`_o6QXJ00;oi>CT00_o8b<So`h>3_nTY:CokNg]onk^k_mPH63oE5AD
onk^k_o]kNgo9RHVohf=S@02oo3`l00<oh:2P_la<C7ok>c/on[Zj_m3@d?o;bl_oibLW?mcLg?o:RXZ
oaXJ6_o^k^kom_Kf>_ohn?P00oogmoOon?ShooShn005ooShn003ooOgmoohn?Son?Sh03;on?Sh00?o
moOgooShn?ohn?P0c?ohn?P00oogmoOon?ShooShn002ooShn004ooOgmooinOWomoOgooKfmP7on?Sh
00000oojn_[omOGeonk^kP02onc/k03oon_[jooYjNWogmoOokVi^OmiDU;o_c8TonMdJOomRGkooiR<
oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c9?miDU;o^[ZjomoOgooZj^[ojn_[onc/k?o[jncoj^[Z
omoOgonj^[[oR6EBon:A7?oi`e3ooMYSoooZL_onlgkoooZ2ookfOoook7?oo]iToo[7DOoRTQcoRFIC
okZj^_oOgmooj^[Zon_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]D_mAXacoTM9EojKWJ_nhnG[o`?j2
olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]D_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/001donc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_oj^[ZonCTi?mjNW[o71`Lon;Rh_o;blco0`<3oinOWooOgmoo
U9BDoa<C4ooPh>3ohN7Qom3@d?l61PKoXJ6Qo`T92Onn_[koh^;RokVi^Ol20P;o/K6bomkNg_n0P83o
:BTYon;Rh_oXj>Soi>CTomoOgooJf]_oe=CDo`P82?n6QXKogmoOofYZJ_m9BDWo=CDeojb/[Onn_[ko
1`L7ogQhN?mEEED2omoOg`06oe]KFom?Ce3oh^;Ron3Ph?lT92CoQ8B40_oPh>00oomkNg_o;bl_on7Q
hOoDe=Co1@D5ojNWYooTi>Coh^;RogmoOolE5AKoh^;RonWYjOo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k000D?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/1oo[jn/01Oo/k>cojn_[on_[joo^k^kom_Kf007onOWi00000ookno_olo?cong]
k@02onGUi@3oonKVi_oShn?ofMWIok:b/_mi;Rkob48don=ZG?ocNFcooHQloojGR_onVhkooYR;ooj:
O_odNfgoif]MolY2=?mk;Rko/[:bomSHf?oTi>CoiNGUonKVi_oUiNKoi>CTomSHf?nb/[;oUUD^onZL
:ook_4Coo/aCoogHH_onhg;oo^UeookVLoonffGooLaCoo_1AOo^WR_oVEH^ok:b/_oHf=Soi>CTonGU
iOoVi^KoiNGUonCTi?oHf=Wo/[:bobiR;_mS[B_oQlY8oiOLFOnUiFWo/_=gokSfNondmGWoYnY[oiSL
FOn9cd_oHjh[obiS;_nb/[;of=SIonCTi?oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGV001EonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi>CTomkNg_mgMgOo6a/KomcLg?oPh>7oWYjNobh^;_l[:b_o<S8boa8B4P02om_Kf`0U
ohB4Q?lQ8B7ogmoOoe=CDomWIfOofm_KomgMgOn@T93o:BTZobl_;ol/;2co:2PXomgMgOoOgmoof=SH
om?Cdoo?cm3oFe]Ko`000?nn_[kofMWIobPX:?n6QXKoN7QhofQXJ?n2PX;o?3`lol?3`ol?3`ooeMGE
omWIfOmIFEWoCTi>omgMgOoLg=co8b<Soh61P@02omKFeP27ogMgMol^;RkogMgMoj:RX_l0003oa/K6
omWIfOoHf=SoSXj>oaDE5OoMgMgohn?SonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV00;oiNGU0<OoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGokNg]oo?cl`01oo_kn`0000?oo?clooShn?oa
lO400oo^k^h04oo[jn_ohN7Qokbl_?mj5aOo`clbom9EB?oTJ5[okgM/ooB3NOohQgcomHAjoo=iKOoU
JE_ofEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?nUAaOoiYLbooF/<?om
_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlbonVK<_nUAQOo_;blon7QhOo/k>`00oo^k^h04oo/
k>cohN7Qokbl_?lGFAOoGjPbogJm=on6cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lG
FAOo_;blon7QhOo/k>`0ooo^k^h:onk^kP0^onc/k?oWinOoNg]koa`L7?oTi>CojNWYonKVi_oQhN7o
g]kNohf=SOlD51Coi^KVonCTi?le=CGoNGUion_[jonb/[;o5ADEomoOgooVi^Koi>CTon7QhOoMgMgo
NWYjobTY:OoXj>SoiNGUomgMgOna/K7o9RHVo`/;2onKVi_ojNWYolc<c?l0003oc/k>ol?3`olU9BGo
Bd];ogalO?oXj>So<C4aojFUYOoTi>CoGEeMoe5AD@;oinOW00[o9BDUofUYJOoOgmoogmoOogMgMola
<C7ojNWYol71`Ol0003oYjNW0_oOgml01?nCTi?o5QHFonOWioo/k>`lonk^kP03ong]kOo^k^kok^k^
00;ok^k^00?okNg]onk^k_o^k^h0ooo^k^h9onk^kP03ong]kOobl_;on?Sh007oo?cl0003oogmo@0F
ooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@@ooJHUGohfiRonAbI?oTKf;og6AG
om=A@oo<@CCo^C@dof/71ooBd];olo?cooclo0?ooOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWo
mJPYooRd?ooi_D[on;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?oo?cl00?ooOgm01?o
o?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:cE3oSLeBoh[>D?n1adCoLKT_of:^8?m>VcCo
1d87om;Bd_oclo?oo?cl0?oooOgm2_omoOd08ookno_omoOgohB4Q?lN7Qkolo?cooWinOnc/k?od=3@
oo?clomXJ6SoAdM7ooWinOoDe=Co0000omgMgOolo?cono_kobLW9onXZ:SonOWioj^[ZooEeMGolO7a
oeADE?mNGUkonOWiooCdm?nDU9Co1@D5od10@?oAdM7omoOgooShn?nGUiOo:b/[00;on_[j01_o92@T
o`L71oo8b<Sono_kohF5QOmSHf?omoOgof=SHomGEeOon?ShooWinOlW9bOo5ADEoh>3PooGemOo@T92
of=SHookno_on_[joc@d=?m9BDWofm_KonGUiOm?Cdoo5aLGoo[jn_olo?`0ooomoOe;oogmo@03oocl
o?omoOgoo?cl00?ooOgm0000>_omoOgon_[joo?cloo^k^kol?3`ono_koo^k^kojNWYom?CdomJ71co
XS@dok@X7Oo1>BcoadTlolmFB_o@Ed_od5M:olY:?_o3>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^ko
l?3`ono_koo`l>ook^k^on[Zj_oCdm?oS2DMolQa=?oIQ1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/X2Go
iiLEomb87Oo8LCCoS2DMom?CdooZj^[ok^k^oo3`l?o_knool?3`onk^k_oZj^Wodm?Coadh7OldPSCo
AiDMoeZU6omY[BX2ogBh>03oogFi>?m[/B_oFjLLodRJ7OldPSCo7CPMom?CdooZj^Wok^k^oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_000joo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o^k^kojn_[ogemOOlL71coinOWonk^
kOn8R8So<30`o`h>3_la<C7o/;2`ono_kon4Q8CoCDe=onk^k_o_knook^k^ohZ:R_mIFEWokno_ogQh
N?l/;2_o3Ph>ocPh>?nn_[kok^k^on?Shol>3PkoJFUYon3PgooRh^;oi^KVon[Zj_mQHF7oMWIfono_
koo^k^koMgMfobHV9P;ok^k^01KocLg=ob`/;?o[jn_oK6a/of=SH_o[jn_ok^k^ocXj>_nDU9CoHV9R
o`h>3_ld=3Coa<C4onk^k_o_knoodM7Aoc`l??l:2P[o9bLWofa/K?l/;2cok^k^0_o_knl0ooo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o^k^kol?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`onk^k_o`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l000AOo_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`02oo3`l0Kokno_0Ooclo<1ooShn07oo_kn
00000oono_komoOgoo3`l002onWYj@0ConSXj?oYjNWoi^KVom_KfomSBd_oPC8bojHd=?nf=2go`Te1
ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mSBd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oRD];
ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;oRD];om_KfooWinL01OoY
jNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[ZbooL:dhofn^>_m`[CSoJZX_oe>K;OliR3Go<V0b
od];BooKfm_oinOW0?oojNWY2ooYjNT01_oXj>Soi^KVog]kNolL71coi>CTonSXj0;ojNWY00?oinOW
onWYjOoYjNT02ooYjNT03?oWinOojNWYonWYjOoXj>Sof=SHo`X:2_n^[Zkog=cLomkNg_oPh>3oiNGU
onSXj0SojNWY00Koj>SXonKVi_oShn?ohn?SonKVi_oXj>P3onWYj@03onSXj?oYjNWojNWY00CojNWY
00?oinOWonWYjOoYjNT0N_oYjNT00ooXj>SojNWYonWYj@03onWYj@03onSXj?oYjNWojNWY0<KojNWY
00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07omoOg0Oono_h00004ookno_ojn_[om?Cdono_k`?ol?3`
017okno_on_[jonEU9CoCb<SoiEDE?nkLg?odiFEomZLW?oJWYcofIbLomBEUOnkLg?oUEADodlS8onE
U9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oZIBDoh4S8onjJUCoe9YconBlUOoZaicojLNLon[7W?oU
_9Goe9Ycok]ZE?n18b?oZYBDon[Zj_o_knl01Oo`l?004Oo_knooj^[ZoiBDU?lS:R?oE7YDog>ULonN
aYGo[<jLojg>W?n/cYcoW/JEog>ULomDNUCo8bXSoiBDU?oZj^[okno_0?ool?3`2oo`l?02ono_k`04
oh20P?lM7Agok^k^ono_k`Gol?3`00?okno_oo3`l?o`l?002oo`l?02ono_k`07ofATI?lY:BWoPH61
of=SHolk>c_ok^k^ono_k`08oo3`l006ono_koo^k^koLg=cofUYJOo^k^kokno_Boo`l?02ono_kooo
l?3`3oo`l?001?oalO7ol?3`ooCdm?ojn_X1ooknoP0000CokNobooooooooooooo_kn0_ooool2ookn
oP3ooogmoOogmoOoKVi^oeXo?onaT93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSloofe]KOohn?So
o?clooooooono_koooooookno_ooookoo_knooooooolo?con?Shohe]KOn:?coobI6@onW@bOodjNCo
m^_VooCYi?oYd<WobI6@ohTo?on=KFgon?Sgooclo?ooooooo_knooooooono_koooooookno_ooooko
o?clooShn?m]KFgo?clooi2MT?o9eLWoi>cTonK^i_oTk>CobMG9oi2MT?lo?cooKFe]ooShn?olo?co
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_kn0017ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooool00_ono_h06?o?
clooYZJVoogmoOooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooo`;oo_kn00ko`<30og5aLOn0P83o/;2`oogm
oOooooooo_knooooooono_koooonookno_ooooooo_knooooo`;oo_kn0?oo`L71okfm_?omoOgooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_h005coooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooooooknoP;ooooo
00?oo_knooooooooool00oooool1oo[jn`0000Coa<cCookno_ojn_[olo?c1OoalO403Oo_knooe]KF
of][Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?CgoJf][omKFe_o_knl02OoalO403Oo_knooemKF
oh=[Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<S?mb?CgoPF][omOFe_o_knl02OoalO403Oo_knooe]KF
of][Jolm?CgoS8b<okZj^_o<cLco^[Zjohb<S?lm?CgoJf][omKFe_o_knl0oooalO4Foo7al@03oo3`
l?oalO7olO7a017olO7a00?ol?3`oo7alOoalO40WOoalO400oo`l?3olO7aoo7al@34oo7al@04oo3`
l?oalO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_ono_h00Oo[k^l0000EohZHXoomoOgon?Shoo3`l?o[
jn_oj^[ZonWYjOoZj^[ojNWYon[Zj_oYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooX
j>SojNWY00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo@RHVofUIFOnPVi_oj>SXonWYj@0;
on[ZjP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT0oooZj^XZon[Z
jP03onWYjOoZj^[oj^[Z09coj^[Z00?ojNWYon[Zj_oZj^X0cOoZj^X01?o[jn_ol?3`ooShn?omoOd1
oloBeP0000Co@E1Nokc6cOojn_[olo?c2?oalO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2
oo3`l0oolO7a0_o`l?03ono_k`;ol?3`oooalO7ooo7alISolO7a00?ol?3`oo7alOoalO400_oalO40
0ooemOGon_[jonW[k@01oi^OXP0000?o9Ca>oe5SL?nkaL`0ooooooooooooom[ooooo0Oo]ko41ojb`
]07oYjb`00001_lY@5Oo8SU<ocQ:FOn6TIgo`LS>onc^l?oooooooooooooDooooo`05ooSin_o/k^oo
dMCGoi^OXonMXjL00Onc^[l00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{734, 424},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(systemLF = 
      javax`swing`UIManager`getSystemLookAndFeelClassName[]\)], "Input"],

Cell[BoxData[
    \("com.apple.mrj.swing.MacLookAndFeel"\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]If[{} =!= \
\((javax`swing`UIManager`setLookAndFeel[systemLF]; $MessageList)\), 
        Abort[]]; \
\[IndentingNewLine]javax`swing`SwingUtilities`updateComponentTreeUI[
        frame]; \[IndentingNewLine]btn@
        setText[javax`swing`UIManager`getLookAndFeel[]@
            getName[]]; \[IndentingNewLine] (*\(frame@
            pack[];\)*) \[IndentingNewLine]JavaShow[
        frame]\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l00000o`00003oo`00003o
00000880000000000`28`;P0B92804R@R03o04R@R?l0B928OP18T8P10000000000<0R<2h0<SPf028
`;P0o`28`;So08S0^7d0R<2h0@18T8P10000000000<0R<2h0<SPf028`;P0o`28`;So08S0^7d0R<2h
0@18T8P10000000000D0R<2h0<SPf028`;P0R<2h0<c<c03o0?ooool0ooooN@3oool208S0^040B928
0@000000000608S0^038h=P0R<2h08S0^01VIVH0c<c<o`1VIVKo06IVIWL0IVIV00@0oooo08S0^028
`;P0B9280@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV
0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<
MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?oo
ool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h
08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0
R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928
0040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0
R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<
00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<
c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0
IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038
h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000
000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028
`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IV
IP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<
c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3o
oooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0
^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@0000000006
08S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@
R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo
08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<
c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<
c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h
06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0
b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@00
0000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0
R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1V
IVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<
c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0
ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028
`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928004000000000
1P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018
T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?oo
o`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<
c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0
c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0
^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h
0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040
000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h
08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0
IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0
c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV
0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0
R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R00100000000
00H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0
B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3o
ool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0
c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo
0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028
`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0
^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R001
0000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0
^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c005
06IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co
0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IV
IP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H
08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000
000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h
04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0
oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af
0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0oooo
o`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0
R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28
`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P0
0@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28
`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`0
1@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<
o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01V
IVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SP
f028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B92800400000
00001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0
^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV
0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<
MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?oo
ool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h
08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0
R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928
0040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0
R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<
00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<
c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0
IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038
h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000
000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028
`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IV
IP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<
c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3o
oooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0
^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@0000000006
08S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@
R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo
08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<
c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<
c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h
06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0
b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@00
0000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0
R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1V
IVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<
c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0
ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028
`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928004000000000
1P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018
T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?oo
o`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<
c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0
c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0
^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h
0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040
000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h
08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0
IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0
c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV
0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0
R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R00100000000
00H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0
B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3o
ool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0
c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo
0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028
`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0
^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R001
0000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0
^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c005
06IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co
0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IV
IP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H
08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000
000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h
04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0
oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af
0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0oooo
o`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0
R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28
`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P0
0@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28
`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`0
1@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<
o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01V
IVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SP
f028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B92800400000
00001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0
^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV
0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<
MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?oo
ool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h
08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0
R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928
0040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0
R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<
00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<
c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0
IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038
h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000
000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028
`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IV
IP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<
c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3o
oooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0
^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@0000000006
08S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@
R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo
08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<
c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<
c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h
06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0
b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@00
0000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0
R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1V
IVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<
c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0
ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028
`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928004000000000
1P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018
T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?oo
o`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<
c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0
c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0
^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h
0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040
000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h
08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0
IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0
c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV
0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0
R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R00100000000
00H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0
B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3o
ool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0
c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo
0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028
`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0
^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R001
0000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0
^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c005
06IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co
0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IV
IP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H
08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000
000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h
04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0
oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af
0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0oooo
o`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0
R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28
`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P0
0@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28
`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`0
1@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<
o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01V
IVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SP
f028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B92800400000
00001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0
^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV
0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<
MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?oo
ool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h
08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0
R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928
0040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0
R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<
00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<
c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0
IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038
h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000
000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028
`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IV
IP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<
c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3o
oooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0
^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@0000000006
08S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@
R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo
08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<
c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<
c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h
06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0
b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@00
0000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0
R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1V
IVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<
c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0
ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028
`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928004000000000
1P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018
T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?oo
o`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<
c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0
c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0
^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h
0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040
000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h
08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0
IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0
c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV
0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0
R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R00100000000
00H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0
B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3o
ool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0
c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo
0<c<c2`0c<c<0P0000020<c<c0030000003<c<`0c<c<008000000P3<c<`4000000<0c<c<0P000002
0<c<c0D0000000<0c<c<000000000000o`3<c<`/0<c<c00506IVIP3oool0R<2h08S0^018T8P00@00
0000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<`/0<c<c080000000D0c<c<000000000000
00000<c<c002000000030<c<c000000000000080c<c<0P0000000`3<c<`00000000000020<c<c080
00000P3<c<`2000000030<c<c000000000000?l0c<c<;03<c<`01@1VIVH0oooo08S0^028`;P0B928
0040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<;03<c<`2000000050<c<c0000000
00000000003<c<`00P0000000`3<c<`00000000000050<c<c08000000P3<c<`200000080c<c<0P00
00000`3<c<`000000000003o0<c<c2`0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0
R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c2`0c<c<0P0000001@3<c<`000000<c<c0000000c<c<
0080000000<0c<c<000000000000100000000`3<c<`00000000000030<c<c080000000@0c<c<0000
00000000c<c<0P00003o0<c<c2`0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h
0<SPf028`;P0R<2h06IVIP3ooooo0<c<c2`0c<c<0P0000001@3<c<`000000<c<c0000000c<c<0080
000000<0c<c<0000000000000P3<c<`2000000030<c<c0000000000000@0c<c<100000000`3<c<`0
00000000003o0<c<c2`0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028
`;P0R<2h06IVIP3ooooo0<c<c2`0c<c<100000000`3<c<`0000000000002000000030<c<c0000000
00000080c<c<0P0000000`3<c<`00000000000020<c<c0040000003<c<`0c<c<0<c<c080000000<0
c<c<000000000000o`3<c<`/0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038
h=P0R<2h08S0^01VIVH0ooooo`3<c<`/0<c<c0@0000000<0c<c<0000000000000P0000020<c<c0@0
000000<0c<c<0000000000000P0000020<c<c0@000000P3<c<`200000?l0c<c<;03<c<`01@1VIVH0
oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<;03<c<`3
000000<0c<c<0`0000080<c<c08000002@3<c<`200000?l0c<c<;03<c<`01@1VIVH0oooo08S0^028
`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<;03<c<`3000000<0c<c<
0`0000090<c<c0030000003<c<`0c<c<00L0c<c<0P00003o0<c<c2`0c<c<00D0IVIV0?ooo`28`;P0
R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1V
IVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<
c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0
ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028
`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928004000000000
1P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018
T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?oo
o`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<
c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0
c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0
^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h
0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040
000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h
08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0
IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0
c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV
0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0
R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R00100000000
00H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0
B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3o
ool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0
c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo
0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028
`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0
^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R001
0000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0
^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c005
06IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co
0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IV
IP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H
08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000
000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h
04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0
oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af
0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0oooo
o`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0
R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28
`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P0
0@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28
`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`0
1@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<
o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01V
IVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SP
f028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B92800400000
00001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0
^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV
0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<
MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?oo
ool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h
08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0
R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928
0040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0
R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<
00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<
c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0
IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038
h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000
000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028
`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IV
IP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<
c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3o
oooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0
^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@0000000006
08S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@
R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo
08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<
c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<
c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h
06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0
b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@00
0000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0
R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1V
IVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<
c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0
ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028
`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928004000000000
1P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018
T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?oo
o`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<
c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0
c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0
^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h
0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040
000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h
08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0
IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0
c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV
0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0
R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R00100000000
00H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0
B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3o
ool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0
c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo
0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028
`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0
^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R001
0000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0
^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c005
06IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co
0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IV
IP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H
08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000
000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h
04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0
oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af
0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0oooo
o`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0
R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28
`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P0
0@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28
`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`0
1@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<
o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01V
IVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SP
f028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B92800400000
00001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0
^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV
0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<
MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?oo
ool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h
08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0
R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928
0040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0
R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<
00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<
c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0
IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038
h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000
000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028
`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IV
IP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<
c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3o
oooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0
^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@0000000006
08S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@
R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo
08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<
c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<
c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h
06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0
b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@00
0000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0
R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1V
IVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<
c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0
ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028
`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928004000000000
1P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018
T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?oo
o`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<
c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0
c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0
^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h
0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040
000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h
08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0
IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0
c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV
0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0
R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R00100000000
00H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0
B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3o
ool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0
c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo
0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028
`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0
^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R001
0000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0
^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c005
06IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co
0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IV
IP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H
08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000
000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h
04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0
oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af
0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0oooo
o`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0
R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28
`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P0
0@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28
`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`0
1@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<
o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01V
IVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SP
f028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B92800400000
00001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0
^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV
0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<
MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?oo
ool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h
08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0
R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928
0040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0
R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<
00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<
c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0
IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038
h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000
000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028
`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IV
IP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<
c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3o
oooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0
^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@0000000006
08S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@
R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo
08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<
c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<
c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h
06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0
b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@00
0000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0
R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1V
IVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<
c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0
ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028
`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B928004000000000
1P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018
T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?oo
o`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<
c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0
c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0
^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h
0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040
000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h
08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0
IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0
c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV
0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0
R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R00100000000
00H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0
B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3o
ool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0
c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo
0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028
`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0
^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R001
0000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0
^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c005
06IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co
0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IV
IP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H
08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000
000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h
04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0
oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af
0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0oooo
o`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0
R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001P28
`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P0
0@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28
`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`0
1@1VIVH0oooo08S0^028`;P0B9280040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<
o`3<c<af0<c<c00506IVIP3oool0R<2h08S0^018T8P00@000000000608S0^038h=P0R<2h08S0^01V
IVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SP
f028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<MP3<c<`01@1VIVH0oooo08S0^028`;P0B92800400000
00001P28`;P0b>3H08S0^028`;P0IVIV0?ooool0c<c<o`3<c<af0<c<c00506IVIP3oool0R<2h08S0
^018T8P00@000000000608S0^038h=P0R<2h08S0^01VIVH0ooooo`3<c<co0<c<c7H0c<c<00D0IVIV
0?ooo`28`;P0R<2h04R@R0010000000000H0R<2h0<SPf028`;P0R<2h06IVIP3ooooo0<c<c?l0c<c<
MP3<c<`01@1VIVH0oooo08S0^028`;P0B9280040000000001@28`;P0b>3H08S0^028`;P0IVIV0?l0
ooooo`3ooomg0?ooo`050<c<c03oool0R<2h08S0^018T8P00@000000000408S0^038h=P0R<2h08S0
^?l0IVIVo`1VIVIi06IVIP040<c<c028`;P0R<2h04R@R040000000000`28`;P0b>3H08S0^03o08S0
^?l0R<2hO@28`;P104R@R040000000001028`;P0b>3H08S0^028`;PF0000P0<000600P000X001000
0X4000>10003P@000h430004P@8000F100@000F20006PP001X8000J20P001h800`011h800@R20048
PP020048P`<00@V30`012X<00`012h<00@^4004;Q003004<Q0<00@f40`013XD3008?Q@<00Q251002
4HH3008BQP800Q>600@00Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<0
0aR800<00aV800<IR@036HT010036XT300<KR@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<0
12:<10048h`0100498`012B=00@TS@049Hd200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DY
SP0300DZSP05:Xl01BZ?00<01B^?1005;8l300H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<943
00HaT@801S:A00@01S:B00HcTP06<i801S>B0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07
=i<00`07>9<01cRD00LhU00300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0
242G00Q1U`08@IL0246G0`08@YL200Q3U`0400U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09
AYT01009AiT300U8V@<02DVJ0`09BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`0
2U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO
00<02eRO100;FIl300aJX0<035^P0P0<G:00100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR
00aPXP0<H:80362R0P0<HJ800`0=HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eU
Y00300eVY0<03FNT0`0=J:D300iYY@<03VZU100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW
0`0>KjL200i`Y`0400m`Z00?LJP03g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<0
3gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o
[@<04H2]00<04H6]0161[P0APJh00`0APZh30163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7
/0<04XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0B
S[800`0CS[804hnb01>?/P0201>?/`<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0C
UKD301BF]@<059Ne100DV;H301BI]P8059Zf00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM
^00EW[P05Ijh01FN^0<05Inh00<05J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<0
5ZJk0`0FYk/301JX^`<05ZVl100FZ[`0100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^
_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/klf01Rd`080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2h100008000`2KYo40<d>U03=3Y@0903=3Y@H000200`000H020002
P0040002P@000h4000>10003P@<000B10P001H4010001H8000J20006PP001X820007PP030047PP01
28800@R200800@R30`012H<3004:P`03004;P`012h@00@^400<00@b40`013H@3004>Q@<00Pn50`02
48D4008AQP<00Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP0
0aN80`0368P00`036HP00aV900<IR@0400<JR@<00a^90`0378X300<MRP<011j:0`047h/300@PR`<0
126;0`048X`400@SS00400@TS00498d012B=00@US@801BF=0`059Xd00`059hd01BN>00DWSP0300DX
SP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06;Y0200H_T00400H_T@06<9401S2A
00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06<i8200HdTP0300LdTP07=I801cFB00801cFC0`07
=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08
@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G00@02D>H00U4V009A9P02DBH0`09AIP00`09AYP0
2DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W004
00YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP<02eJN00<02eNN00]G
W`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40
100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R00803F:S0`0=Hj<300eTX`0300eUX`0=
IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW00i^
Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<0
3gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4011m[004011n[00@OZd047j]011o
[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl40166
[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0B
SK8201:>/P0301>>/P0CSk804hnb00804hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d0`0C
U;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L059^g01BK]`0DVkL301BL]`8059fg
00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<0
5ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G
[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_cH06;C00P28`;P104R@
R040000000001028`;P0b>3H08S0^028`;P30000P00709^Wl@3oool0SWZf0:JKa02cZM80Z9g80;>Y
dP020:JKa0050;bhg@3^k_@0j^Wa0?ooo`0c@jD01@0008030001P08000:000@000:10003P@000h40
00>10`0018420005P@040005PP001X8000J20006PP8000N200<00@N20048PP0128800P0128<30049
P`<00@Z300<00@^3004;Q0012h@00`0138@3004=Q0<00@j50`023hD3008@Q@@00Q660`024XH2008C
QP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN800<GR0035hP300<HR00300<IR003
6HT00aV900@00aZ90`036hT300<LRP<00af:0`047XX300@OR`<0122;0`048H/300@RS0@012><00@0
12B<00@TS@0498d012F=0P059Hd300DVS@0300DWS@059hh01BN>00<01BR>0`05:Hh00`05:Xh01BZ?
00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@00@01RnA00H`T@06<9401S2A0`06<I4200HbT@04
00HbTP06<i801S>B00HcTP801SBB00<01cBB00LeTP07=I800P07=I<300LfT`<01cNC00<01cRC00Lh
U007>9@00`07>I@300LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G
00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009A9P300U5V00300U6V009AYT02DJI00@02DNI0`09
B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:CY/300Y?W0@02U2L00@02U6L00YAW@0:DId02U:M
0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN0`0;EYh00`0;Eih02eNO00]GW`0300]HW`@02eVO
0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ4035fQ0`0<GZ4200aOX@0400aOXP0<H:80362R00aP
XP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eW
Y0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW00i^Y`<03VnW0P0>L:L0
100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?LjT03g>Y00@03gBY0`0?MJT300mfZP<03gNZ0`0@
N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@047j/011n[@0@OZd047n]0P0AOjd30160[@030161
[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_0164[`030165[`@04HJ_0`0BQk0301:8/0804XV`
00@04XVa01::/@0BR[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb00<04hjb01>?
/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@301>D]0<04iFe0`0DU[D301BG
]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g01BK]`<059bg0P0DWKL0100EWKP05Ijh01FN^00E
W[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0FYKX301JV^`<05ZNk0`0F
Z;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm0P0G[;d301N]_@0301N^_@0G[[h05jjn00<05jnn
0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o0P0H]<0P000000806;C04000000201Rd`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P000800102KYo40oooo06aJY@2_YLX20;bhg@0:
0?omo`2cZM80oooo0?ooo`2l^=d0UhZl0:RMb03Vi^`0oooo03=3Y@@000200`000H020002P0040002
P@000h4000>10003P@<000B10P001H4010001H8000J20006PP001X820007PP030047PP0128800@R2
00800@R30`012H<3004:P`03004;P`012h@00@^400<00@b40`013H@3004>Q@<00Pn50`0248D4008A
QP<00Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN80`03
68P00`036HP00aV900<IR@0400<JR@<00a^90`0378X300<MRP<011j:0`047h/300@PR`<0126;0`04
8X`400@SS00400@TS00498d012B=00@US@801BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>
00<01BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<0
1S6A0P06<Y401006<Y801S>B00HcTP06<i8200HdTP0300LdTP07=I801cFB00801cFC0`07=Y<300Lg
T`0300LhT`07>9@01cRD00<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008
@9L0246G00Q1U`08@IL300Q2U`8024>G00@02D>H00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6
V@0400U7V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:
DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil0
0`0;F9l400]IW`<035ZP0`0<Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80
362R00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT
00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL3
00i_Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?
MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4011m[004011n[00@OZd047j]011o[@804Gn]
0`0AP:d00`0APJd04H6^0161[P030162[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`
0`0BR;0201:9/00401:9/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>
/P0301>>/P0CSk804hnb00804hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E
]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh
01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0F
Y[/301JW^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn
01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C000<0b>3H04R@R018T8P0
3018T8P00`000000b>3H04R@R00=04R@R0040000000H]<006;C00<SPf0h0B92800<0000001Rd`00H
]<000P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20000P00;09^Wl@3oool0Z9g80?oo
o`2cZM80H4bJ08ij]P1hIJh0Z9g80?ooo`3ooOl00`3oool00`0c@jD000200000P0030000P0<00060
0P000X0010000X4000>10003P@000h430004P@8000F100@000F20006PP001X8000J20P001h800`01
1h800@R20048PP020048P`<00@V30`012X<00`012h<00@^4004;Q003004<Q0<00@f40`013XD3008?
Q@800Q250`3oool2008AQP<00Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ8
00<GR0035hP00aN80`0368P00`036HP00aV900<IR@0400<JR@<00a^90`0378X300<MRP<011j:0`04
7h/300@PR`<0126;0`048X`400@SS00400@TS00498d012B=00@US@801BF=0`059Xd00`059hd01BN>
00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06;Y0200H_T00400H_
T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06<i8200HdTP0300LdTP07=I801cFB
00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07>Y@300LkU@<023bE0`08?ID400Pn
UP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G00@02D>H00U4V009A9P02DBH0`09
AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:
Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP<02eJN
00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<0
35jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R00803F:S0`0=Hj<300eT
X`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>
KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mc
Z@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4011m[004011n[00@
OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162[P<04H>^00<04HB^0164[`0AQ:l0
0`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;80
4Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d
00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L059^g01BK]`0DVkL3
01BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0E
XkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd05Z^m01J/_@805jbm
0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C0
00<0b>3H08S0^028`;P02`28`;P00`18T8P000000<SPf00=08S0^00504R@R00000006;C001Rd`038
h=P03@28`;P01018T8P0000001Rd`00H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^080002000h0VjOa0?ooo`3oool0fmc/061<VP2CQKX0/jWB0;bhg@1PC9X0VHnn0:JKa038`ml0oooo
03=3Y@H000200`3oool20002P0030002P@3oool0oooo0080oooo0P0018400`001H40oooo0005PP03
0006PP@0oooo00<00@R20048P`3oool00`3oool3004:P`060?ooo`012h@00@^4004<Q03oool00@b4
0P013H@0103oool00@j50?ooo`013XD2008?Q@040?ooo`0248D0oooo008@Q@800Q6600<0oooo008A
QP024XH00P024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN800<GR003
5hP300<HR00300<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:0`047XX300@OR`<0122;0`04
8H/300@RS0@012><00@012B<00@TS@0498d012F=0P059Hd300DVS@0300DWS@059hh01BN>00<01BR>
0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@00@01RnA00H`T@06<940
1S2A0`06<I4200HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB00LeTP07=I800P07=I<300Lf
T`<01cNC00<01cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0
UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009A9P300U5V00300U6V009
AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:CY/300Y?W0@02U2L00@0
2U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN0`0;EYh00`0;Eih02eNO
00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ4035fQ0`0<GZ4200aOX@04
00aOXP0<H:80362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eSX`<03FBS00<03FFS00eU
Y00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW
00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?LjT03g>Y00@03gBY0`0?
MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@047j/011n[@0@OZd047n]
0P0AOjd30160[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_0164[`030165[`@04HJ_
0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=
/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@301>D
]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g01BK]`<059bg0P0DWKL0
100EWKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0F
YKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm0P0G[;d301N]_@0301N^
_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o0P0H]<001038h=P0R<2h
08S0^028`;P6000000@0R<2h00<0B92800000038h=P00P28`;P900000080R<2h00D0B9280000000H
]<006;C00<SPf00=08S0^00404R@R00000006;C001Rd`080R<2h0@18T8P10000000000@0R<2h0<SP
f028`;P0R<2h0`0008003P2KYo40oooo0;bhg@2ISkh0oooo0=KAg@3Kg>`0loko0:JKa03^k_@0QGJ`
09>5^P3oool0<d>U100008001`3oool000600001P0000H00oooo0002P03oool00`000h401P3oool0
00B10004P@001H40oooo0005PP8000J200P0oooo0007PP001h800@N20?ooo`012880oooo0048P`<0
0@V300@0oooo004:P`012X<0oooo0P012h@00`0138@0oooo004<Q002004=Q0040?ooo`013XD0oooo
004>Q@800Pn500<0oooo008@Q@3oool00`3oool2008AQP<00Q:60P024hH010024hL00QB7008DQ`02
58L3008EQ`800QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV900<IR@0400<JR@<00a^9
0`0378X300<MRP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@TS00498d012B=00@US@80
1BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/S`<0
1Rf@0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06<i82
00HdTP0300LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07>Y@3
00LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G00@0
2D>H00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<02T^J
0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d0
2eBN00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aLX004
00aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=HZ80
3F:R00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD4
00i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP03g6X
0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[
0`0@O:`4011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162[P<0
4H>^00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa01::
/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc0`0CT;<3
01>A/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0
100DV[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i
01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_00401J[
_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G
/Kl00`0G/[l301Nc_`806;C000@0b>3H08S0^028`;P0R<2h1P00000408S0^00304R@R0000000b>3H
0080R<2h00<0000008S0^028`;P01@28`;P01@000000R<2h08S0^018T8P0000000806;C000@0b>3H
08S0^028`;P0R<2h0P00000408S0^08000000P28`;P01018T8P0000001Rd`00H]<0208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^0<0002000l0VjOa0?ooo`2ISkh0UhZl0=CCj03_[;<0ogIk
0>jOZ`1KF:D0YY_409JOdP1PC9X0_;SM0?ooo`0c@jD00`0008001`3oool000600001P0000H00oooo
0002P03oool00`000h401P3oool000B10004P@3oool000F10?ooo`8000J200P0oooo0007PP001h80
0@N20?ooo`012880oooo0048P`<00@V300T0oooo004:P`3oool00@^30?ooo`012h@0oooo004<Q03o
ool00P013H@0103oool00@j50?ooo`013XD2008?Q@040?ooo`0248D0oooo008@Q@@00Q660`024XH2
008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN800<GR0035hP300<HR00300<I
R0036HT00aV900@00aZ90`036hT300<LRP<00af:0`047XX300@OR`<0122;0`048H/300@RS0@012><
00@012B<00@TS@0498d012F=0P059Hd300DVS@0300DWS@059hh01BN>00<01BR>0`05:Hh00`05:Xh0
1BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@00@01RnA00H`T@06<9401S2A0`06<I4200Hb
T@0400HbTP06<i801S>B00HcTP801SBB00<01cBB00LeTP07=I800P07=I<300LfT`<01cNC00<01cRC
00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0
246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009A9P300U5V00300U6V009AYT02DJI00@02DNI
0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:CY/300Y?W0@02U2L00@02U6L00YAW@0:DId0
2U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN0`0;EYh00`0;Eih02eNO00]GW`0300]HW`@0
2eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ4035fQ0`0<GZ4200aOX@0400aOXP0<H:80362R
00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@3
00eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW00i^Y`<03VnW0P0>
L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?LjT03g>Y00@03gBY0`0?MJT300mfZP<03gNZ
0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@047j/011n[@0@OZd047n]0P0AOjd30160[@03
0161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_0164[`030165[`@04HJ_0`0BQk0301:8/080
4XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb00<04hjb
01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@301>D]0<04iFe0`0DU[D3
01BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g01BK]`<059bg0P0DWKL0100EWKP05Ijh01FN
^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0FYKX301JV^`<05ZNk
0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm0P0G[;d301N]_@0301N^_@0G[[h05jjn00<0
5jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o0P0H]<000`38h=P0R<2h08S0^00;08S0^003
04R@R0000000b>3H0080R<2h00<0000008S0^028`;P01@28`;P01@000000R<2h08S0^018T8P00000
00806;C000<0b>3H08S0^028`;P00P28`;P200000080R<2h0P00000308S0^00404R@R00000006;C0
01Rd`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P0008002P2KYo40oooo09N:_01j
K:X0/lOX0:U^X038`ml0ThFj05]6T`2ISkh207QU[P04048WQ@2_YLX0oooo03=3Y@@000200`000H00
0`3oool000:00002P@040?ooo`8000B100<0oooo0005P@3oool00`001X840?ooo`030048PP0128<0
0@R300<00@V300T0oooo004:P`3oool00@^30?ooo`012h@0oooo004<Q03oool00P013H@0103oool0
0@j50?ooo`013XD2008?Q@030?ooo`0248D0oooo00<0oooo0P024HH3008BQP800Q>600@00Q>7008D
Q`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<00aV800<IR@036HT01003
6XT300<KR@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<012:<10048h`0100498`012B=00@T
S@049Hd200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?
1005;8l300H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@801S:A00@01S:B00HcTP06
<i801S>B0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD00LhU00300Li
U0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL2
00Q3U`0400U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09
BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M
00<02eBM00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P
0P0<G:00100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=
HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iY
Y@<03VZU100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP0
3g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@
NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh0
0`0APZh30163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa
01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?
/`<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI
]P8059Zf00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<0
5J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100F
Z[`0100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na
_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0030<SPf028`;P0R<2h00/0R<2h00<0B92800000038h=P0
0P28`;P00`000000R<2h08S0^00508S0^00500000028`;P0R<2h04R@R00000000P0H]<000`38h=P0
R<2h08S0^00308S0^0@000001028`;P01018T8P0000001Rd`00H]<0208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^080002000<0VjOa0?ooo`3oool00P3oool02P3o[K00ogIk0?W=e03mkNh0
oooo0:JKa025M[00_;SM0?ooo`0c@jD50000P0<0006000<0oooo0002P0000X400`000h400`3oool0
00B10?ooo`020005P@040005PP3oool000J20006PP8000N200<00@N20?ooo`0128800P0128<30?oo
o`800@Z300L0oooo004;P`3oool00@^40?ooo`0138@0oooo00800@f400@0oooo004>Q@3oool0oooo
0P023hD01P3oool00Q250?ooo`0248D00Q660?ooo`800Q660`024XH2008CQP04008CQ`0258L00QB7
008DQ`<00QF70P025XL010035XP00aN800<GR0035hP300<HR00300<IR0036HT00aV900@00aZ90`03
6hT300<LRP<00af:0`047XX300@OR`<0122;0`048H/300@RS0@012><00@012B<00@TS@0498d012F=
0P059Hd300DVS@0300DWS@059hh01BN>00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?
0`06;I0300H^T0801Rn@00@01RnA00H`T@06<9401S2A0`06<I4200HbT@0400HbTP06<i801S>B00Hc
TP801SBB00<01cBB00LeTP07=I800P07=I<300LfT`<01cNC00<01cRC00LhU007>9@00`07>I@300Lj
U0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL0
1009@iP02DBH00U4V009A9P300U5V00300U6V009AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:
BiX300Y<V`<02TfK0`0:CY/300Y?W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]D
W@0;E9h02eBN00<02eFN0`0;EYh00`0;Eih02eNO00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP
00@035bQ00aMX@0<GJ4035fQ0`0<GZ4200aOX@0400aOXP0<H:80362R00aPXP80366R00<03F6R00eR
XP0=HZ800P0=HZ<300eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZ
Y@@03V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?
LJP300mbZ00300mcZ00?LjT03g>Y00@03gBY0`0?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@
Nj/3011l[0@047f/00@047j/011n[@0@OZd047n]0P0AOjd30160[@030161[@0APJh04H6^00<04H:^
0`0APjh00`0AQ:h04HB_0164[`030165[`@04HJ_0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[40
4XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@
/`<04i6c00<04i:c01>B]00CT[@00`0CTk@301>D]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ
]P0401BJ]`0DVkL059^g01BK]`<059bg0P0DWKL0100EWKP05Ijh01FN^00EW[P301FO^00301FP^00E
X;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0FYKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@0
5Z^l01J[_@0FZkd05Zbm0P0G[;d301N]_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o
01Na_`0301Nb_`<05k>o0P0H]<000`38h=P0R<2h08S0^00;08S0^00304R@R0000000b>3H0080R<2h
00<0000008S0^028`;P01@28`;P01@000000R<2h08S0^018T8P0000000806;C000<0b>3H08S0^028
`;P01028`;P2000000D0R<2h00@0B9280000000H]<006;C00P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;P30000P00:0:6/lP3icM@0hRHl0?Be_`3R9S`0m6em0?cSj@3oool0oNg^0?n]/080
oooo00<0<d>U0000P0000800100008030001P0030?ooo`000X0000:100<0oooo0P0018401@3oool0
00F10005P@001H80oooo008000J20`3oool20048PP030048P`3oool00@V300800@V30P012X<0103o
ool00@^3004;Q03oool2004<Q0070?ooo`013H@00@f40?ooo`013XD0oooo004>Q@020?ooo`03008?
Q@0248D00Q2500@0oooo00@00Q66008BQP024XH00Q:60P024hH010024hL00QB7008DQ`0258L3008E
Q`800QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV900<IR@0400<JR@<00a^90`0378X3
00<MRP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@TS00498d012B=00@US@801BF=0`05
9Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06
;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06<i8200HdTP03
00LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07>Y@300LkU@<0
23bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G00@02D>H00U4
V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/3
00Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]D
WP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aLX00400aLX@0<
GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R0080
3F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<0
3VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?LZP0
0`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4
011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162[P<04H>^00<0
4HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa01::/@<04X^a
0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc0`0CT;<301>A/`03
01>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L0
59^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@04
01FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd0
5Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G
/[l301Nc_`806;C000<0b>3H08S0^028`;P02`28`;P00`18T8P000000<SPf00208S0^00300000028
`;P0R<2h00D0R<2h00D0000008S0^028`;P0B9280000000201Rd`0030<SPf028`;P0R<2h00<0R<2h
1000000408S0^00404R@R00000006;C001Rd`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0
R<2h0P0008003@2KYo40oNg^0>8V?03nmOP0mhVG0?ARKP3cX:h0m69^0?omo`3o[K00o>?Y0?ooo`0c
@jD01`0008030001P0030?ooo`000X0000:100<000>10`0018420005P@040005PP001X8000J20006
PP8000N200D00@N20048PP012880oooo0048P`030049P`<00@Z300<00@^3004;Q0012h@00`0138@3
004=Q0<00@j50`023hD3008@Q@@00Q660`024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P02
5XL010035XP00aN800<GR0035hP300<HR00300<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:
0`047XX300@OR`<0122;0`048H/300@RS0@012><00@012B<00@TS@0498d012F=0P059Hd300DVS@03
00DWS@059hh01BN>00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T080
1Rn@00@01RnA00H`T@06<9401S2A0`06<I4200HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB
00LeTP07=I800P07=I<300LfT`<01cNC00<01cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D3
00PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4
V009A9P300U5V00300U6V009AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK
0`0:CY/300Y?W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<0
2eFN0`0;EYh00`0;Eih02eNO00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<
GJ4035fQ0`0<GZ4200aOX@0400aOXP0<H:80362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<3
00eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H2
00i]YP0400i]Y`0>KZL03VjW00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mc
Z00?LjT03g>Y00@03gBY0`0?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/
00@047j/011n[@0@OZd047n]0P0AOjd30160[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h0
4HB_0164[`030165[`@04HJ_0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:<
/@0401:</P0BSK804Xfb01:=/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c
01>B]00CT[@00`0CTk@301>D]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL0
59^g01BK]`<059bg0P0DWKL0100EWKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i
0`0EX[T301FS^P<05JBj0`0FYKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd0
5Zbm0P0G[;d301N]_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<0
5k>o0P0H]<000`38h=P0R<2h08S0^00;08S0^00304R@R0000000b>3H0080R<2h00<0000008S0^028
`;P01@28`;P01@000000R<2h08S0^018T8P0000000806;C000<0b>3H08S0^028`;P00P28`;P20000
0080R<2h0P00000308S0^00404R@R00000006;C001Rd`080R<2h0@18T8P10000000000@0R<2h0<SP
f028`;P0R<2h0P0008000`2KYo40m/S<0>8V?0020?n]/0070=lT;P3oY9h0m[c50?n]/03^Nh`0oooo
03=3Y@080000P0<0006000<0oooo0002P0000X400`000h430004P@8000F100@000F20006PP001X80
00J20P001h801@011h800@R20048PP3oool00@R300<00@V300@0oooo004:P`012X<00@^30P012h@3
004<Q0<00@f40`013XD3008?Q@<00Q2510024HH3008BQP800Q>600@00Q>7008DQ`0258L00QB70`02
5HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<00aV800<IR@036HT010036XT300<KR@<00ab:
0`037HX300@NRP<011n;0`0488/300@QR`<012:<10048h`0100498`012B=00@TS@049Hd200DUS@<0
1BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?1005;8l300H]T0<0
1Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@801S:A00@01S:B00HcTP06<i801S>B0P06=980
0`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD00LhU00300LiU0<01cZD0`07>iD3
00PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL200Q3U`0400U3V009
A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09BYX300Y;VP<02TbK
0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;
E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P0P0<G:00100<G:40
35fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=HJ803F:R00eRXP02
00eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iYY@<03VZU100>JjH3
00i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP03g6X00maZ0<03g:X
00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`<047b/
100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh00`0APZh30163[P03
0164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;
/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?/`<04i2c0`0CTK<0
0`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI]P8059Zf00@059Zg
01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<05J2h01FP^@0EX;T0
100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100FZ[`0100FZk`05Z^m
01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<0
5k:o0`0G/kl201Rd`0030<SPf028`;P0R<2h00/0R<2h00<0B92800000038h=P00P28`;P900000080
R<2h00D0B9280000000H]<006;C00<SPf00308S0^08000001028`;P200000080R<2h00@0B9280000
000H]<006;C00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20000P00309^Wl@3icM@0
mhVG0080oooo00L0ojf`0>4F=03oMW/0ojBN0>8V?03oRGl0<d>U00P000200`000H000`3oool000:0
0002P@030003P@<000B10P001H4010001H8000J20006PP001X820007PP040047PP0128800@R20048
P`@0oooo0`012X<00`012h<00@^4004;Q003004<Q0800@f400@0oooo004>Q@013XD00@j50`023hD3
008@Q@@00Q660`024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN800<G
R0035hP300<HR00300<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:0`047XX300@OR`<0122;
0`048H/300@RS0@012><00@012B<00@TS@0498d012F=0P059Hd300DVS@0300DWS@059hh01BN>00<0
1BR>0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@00@01RnA00H`T@06
<9401S2A0`06<I4200HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB00LeTP07=I800P07=I<3
00LfT`<01cNC00<01cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH2
00Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009A9P300U5V00300U6
V009AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:CY/300Y?W0@02U2L
00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN0`0;EYh00`0;Eih0
2eNO00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ4035fQ0`0<GZ4200aO
X@0400aOXP0<H:80362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eSX`<03FBS00<03FFS
00eUY00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]YP0400i]Y`0>KZL0
3VjW00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?LjT03g>Y00@03gBY
0`0?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@047j/011n[@0@OZd0
47n]0P0AOjd30160[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_0164[`030165[`@0
4HJ_0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb
01:=/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@3
01>D]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g01BK]`<059bg0P0D
WKL0100EWKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj
0`0FYKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm0P0G[;d301N]_@03
01N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o0P0H]<000`38h=P0
R<2h08S0^00;08S0^00304R@R0000000b>3H0080R<2h2@00000208S0^00504R@R00000006;C001Rd
`038h=P03@28`;P01018T8P0000001Rd`00H]<0208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^080002000L0VjOa0?ooo`3cX:h0m69^0?ooo`3gRIL0nLgD0080oooo00<0lj2^0?ooo`0c@jD0
200008030001P08000:000@000:10003P@000h4000>10`0018420005P@040005PP001X8000J20006
PP8000N200<00@N20048PP0128800P0128<30049P`<00@Z300<00@^3004;Q0012h@00`0138@3004=
Q0<00@j50`023hD3008@Q@@00Q660`024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL0
10035XP00aN800<GR0035hP300<HR00300<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:0`04
7XX300@OR`<0122;0`048H/300@RS0@012><00@012B<00@TS@0498d012F=0P059Hd300DVS@0300DW
S@059hh01BN>00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@
00@01RnA00H`T@06<9401S2A0`06<I4200HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB00Le
TP07=I800P07=I<300LfT`<01cNC00<01cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D300Pm
U@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009
A9P300U5V00300U6V009AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:
CY/300Y?W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN
0`0;EYh00`0;Eih02eNO00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ40
35fQ0`0<GZ4200aOX@0400aOXP0<H:80362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eS
X`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]
YP0400i]Y`0>KZL03VjW00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?
LjT03g>Y00@03gBY0`0?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@0
47j/011n[@0@OZd047n]0P0AOjd30160[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_
0164[`030165[`@04HJ_0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:</@04
01:</P0BSK804Xfb01:=/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B
]00CT[@00`0CTk@301>D]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g
01BK]`<059bg0P0DWKL0100EWKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0E
X[T301FS^P<05JBj0`0FYKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm
0P0G[;d301N]_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o
0P0H]<000`38h=P0R<2h08S0^00;08S0^00304R@R0000000b>3H00d0R<2h00D0B9280000000H]<00
6;C00<SPf00=08S0^00404R@R00000006;C001Rd`080R<2h0@18T8P10000000000@0R<2h0<SPf028
`;P0R<2h0`0008002`2KYo40oooo0?n9O`3oool0lj2^0?6CX@3oool0oogo0?>P[P3ono`0<d>U00P0
00200`000H020002P0040002P@000h4000>10003P@<000B10P001H4010001H8000J20006PP001X82
0007PP030047PP0128800@R200800@R30`012H<3004:P`03004;P`012h@00@^400<00@b40`013H@3
004>Q@<00Pn50`0248D4008AQP<00Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@0
0aJ800<GR0035hP00aN80`0368P00`036HP00aV900<IR@0400<JR@<00a^90`0378X300<MRP<011j:
0`047h/300@PR`<0126;0`048X`400@SS00400@TS00498d012B=00@US@801BF=0`059Xd00`059hd0
1BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06;Y0200H_T004
00H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06<i8200HdTP0300LdTP07=I80
1cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07>Y@300LkU@<023bE0`08?ID4
00PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G00@02D>H00U4V009A9P02DBH
0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/300Y=V`<02TjK
0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP<0
2eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aLX00400aLX@0<GJ4035fQ00aM
X@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R00803F:S0`0=Hj<3
00eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<03VbV0P0>KJH0
100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?LZP00`0?LjP03g>Y
00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4011m[004011n
[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162[P<04H>^00<04HB^0164[`0A
Q:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa01::/@<04X^a0P0BS;40100B
S;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc0`0CT;<301>A/`0301>B/`0CT[@0
4i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L059^g01BK]`0D
VkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i
0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd05Z^m01J/_@80
5jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_`80
6;C03`38h=P00`000000b>3H0<SPf00=0<SPf0030000000H]<006;C000l0b>3H00<0000001Rd`00H
]<000P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P40000P0<0VjOa00H0oooo0?>P[P3d
]Kl0m[c50?_IfP0c@jD90000P0<000600P000X0010000X4000>10003P@000h430004P@8000F100@0
00F20006PP001X8000J20P001h800`011h800@R20048PP020048P`<00@V30`012X<00`012h<00@^4
004;Q003004<Q0<00@f40`013XD3008?Q@<00Q2510024HH3008BQP800Q>600@00Q>7008DQ`0258L0
0QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<00aV800<IR@036HT010036XT300<K
R@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<012:<10048h`0100498`012B=00@TS@049Hd2
00DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?1005;8l3
00H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@801S:A00@01S:B00HcTP06<i801S>B
0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD00LhU00300LiU0<01cZD
0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL200Q3U`04
00U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09BYX300Y;
VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM
00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P0P0<G:00
100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=HJ803F:R
00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iYY@<03VZU
100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP03g6X00ma
Z0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011k
Z`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh00`0APZh3
0163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa01::/@0B
R[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?/`<04i2c
0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI]P8059Zf
00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<05J2h01FP
^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100FZ[`0100F
Zk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl0
5k6o00<05k:o0`0G/klf01Rd`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h5P000803
0001P08000:000@000:10003P@000h4000>10`0018420005P@040005PP001X8000J20006PP8000N2
00<00@N20048PP0128800P0128<30049P`<00@Z300<00@^3004;Q0012h@00`0138@3004=Q0<00@j5
0`023hD3008@Q@@00Q660`024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP0
0aN800<GR0035hP300<HR00300<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:0`047XX300@O
R`<0122;0`048H/300@RS0@012><00@012B<00@TS@0498d012F=0P059Hd300DVS@0300DWS@059hh0
1BN>00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@00@01RnA
00H`T@06<9401S2A0`06<I4200HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB00LeTP07=I80
0P07=I<300LfT`<01cNC00<01cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D300PmU@@023jF
0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009A9P300U5
V00300U6V009AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:CY/300Y?
W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN0`0;EYh0
0`0;Eih02eNO00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ4035fQ0`0<
GZ4200aOX@0400aOXP0<H:80362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eSX`<03FBS
00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]YP0400i]
Y`0>KZL03VjW00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?LjT03g>Y
00@03gBY0`0?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@047j/011n
[@0@OZd047n]0P0AOjd30160[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_0164[`03
0165[`@04HJ_0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:</@0401:</P0B
SK804Xfb01:=/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B]00CT[@0
0`0CTk@301>D]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g01BK]`<0
59bg0P0DWKL0100EWKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS
^P<05JBj0`0FYKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm0P0G[;d3
01N]_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o=P0H]<02
08S0^040B9280@000000000308S0^038h=P0R<2h0?l0R<2ho`28`;Qm08S0^040B9280@0000000003
08S0^038h=P0R<2h0?l0R<2ho`28`;Qm08S0^040B9280@000000000308S0^038h=P0b>3H0?l0b>3H
o`38h=Qm0<SPf040B9280@0000000?l0R<2ho`28`;R108S0^04000000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;N0001Z2000`400?l00000o`00003oooo`l?3o
oo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`
003ooo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?oo
l?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?00
0?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?000?ool?3`ooo`
l?3Poo3`l00000?oc<c<ooooooooool0ooooooooooooomgooooo00000oo3`l?on?ShofIVIP3oofIV
I_ooIVIVg?mVIVH1ooooo`0000?oLW9booooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIV
ooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<
c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`00
00?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<
c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1
ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<
c<`0ooo<c<coolc<c=_oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<coolc<c=_oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<a[olc<c0;o`<300oo<c<`01_o0`<3o_[jnol[:
b_o8b<Soa<C4olS8b0;oa<C4ooo<c<aSolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<
Goo<c<`07?nn_[ko8b<SobHV9_nXZ:SoGemOogAdM?nDU9Co;Rh^od10@?o<c<coP820oalO7ol@413o
61PHod];Boo<c<coF5QHoaDE5OlW9bOoRHV9oaLG5ol92@Wo8b<SoaHF5_lU9BGoZJVYo`h>3_l?3`oo
olc<c63oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<aOolc<c00=okjn__lS8b?o9RHV
ode=COl410Co2@T9oh:2P_l^;Rko@410ol30`?lG5aOo61PHolO7a`03olc<c00<o`/;2ol:2P[oa<C4
ohB4Q?le=CGoDU9BofQXJ?l`<33oH61PolC4a?l>3Pko3`l?ooo<c<aPolc<c07oIVIV0Oooool00003
ofIVI_ooooooc<c<0?ooc<c<Goo<c<`04?nn_[ko8b<SobDU9Ol?3`oo2@T9oclo?om<C4co;Rh^od10
@?n3Ph?o61PHoa<C4olb<S;o>CTiogAdM?o<c<`2o`L71`0:olc<c?o8b<SoATI6ob4Q8OlM7Ago7QhN
of9RH_o4a<Co3Ph>o`l?3oooc<c<H?o<c<`1ofIVIP7ooooo00000omVIVKoooooolc<c03oolc<c5oo
c<c<013o_[jnob<S8olI6AWo:RXZocdm?OlZ:R[o820Pobh^;_m0@43oYZJVobLW9olU9BGoHf=SobPX
:?m0@43oc<c<0_l71`L3olc<c007ol[:b_mQHF7o<30`ofATI?o4a<Co3Ph>o`l?3`3oolc<c63oc<c<
0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<aOolc<c00@okjn__lS8b?o2`/;obXZ:_n8R8So
E5ADobXZ:_lP823o@410olc<c?ll?3co8B4Qob@T9?lY:BWoPX:2oi>CT`;o0P8200[oI6ATojVYZOm:
BT[o;bl_oaPH6?lM7AgoU9BDolC4a?l>3Pko3`l?ooo<c<aPolc<c07oIVIV0Oooool00003ofIVI_oo
ooooc<c<0?ooc<c<Goo<c<`02Onn_[ko5QHFo`410Ol@413oa/K6oinOWolE5AGo2@T9od10@002olc<
c005oiVIVOn3Ph?o[jn_olc<c?nSXj<00_l30`<02_moOgoo][Jfojn_[ombLW;oJVYZoj>SXoo<c<co
a<C4o`h>3_l?3`ooolc<c63oc<c<0OmVIVH1ooooo`0000?oIVIVooooooo<c<`0ooo<c<aOolc<c004
okjn__l0003o0000odi>CP;oc<c<00?o7AdMo`T92Om0@4001oo<c<`2ohn?S`Ooc<c<00?oa<C4o`h>
3_l?3`l0ooo<c<aPolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<Goo<c<`01?o9bLWo
Vi^Kohn?Sonj^[X2olc<c003ojn_[onCTi?o[:b/013oc<c<00?oalO7odA4A?m6ATH0ooo<c<aPolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_oooooo
c<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<
c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIV
I_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<
c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool0
0003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?oo
c<c<ooo<c<cKolc<c07oIVIV0Oooool00003ofIVI_ooooooc<c<0?ooc<c<ooo<c<cKolc<c07oIVIV
0Oooool00003ofIVI_oooooooooo0?oooooooooooooKooooo`7on?Sh0Oooool00?ooIVIVoomVIVKM
ofIVIP7oLW9b0Oo3`l<1olc<c000oomoOgn6ogmoO`OoOWinoomoOgmCogmoO`0000Cojn_[onKVi_oR
h^;og]kN0ooMgMd0oooLg=cog]kNomkNg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMg@00AooNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkogMgM
00;og=cL03gofm_KomgMgOoLg=cog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omcLgOoNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oMgMgofm_Kom[Jf_oGemOof=SH
omOGeooJf][ofm_L00;ogMgM0?oog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]h004GogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMd0
0ooNg]h00ooMgMgog]kNomkNgP03omgMg@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>000ooI
fMT02?oHf=SofMWIomWIfOoIfMWof=SHomKFe_oCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;
omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOG
om?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf?oofMWI2ooIfMT2omSHf006omKFe_oCdm?odm?C
omCDe?oGemOof=SH0_oIfMT00ooHf=SofMWIomWIf@02omSHf0WofMWI00?of=SHomWIfOoIfMT00_oH
f=P00ooIfMWof=SHomOGe`02omSHf1OofMWI00Cof=SHomKFe_oBd];oclo?0_o=cLd01?o?cloodm?C
omOGeooHf=SoomWIfDGofMWI00?of=SHomWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^
k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=codm?ColO7aonk^k_o/[:bojj^
[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^
[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^
[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`3oon7Qh@[ohN7Q00Woh>3PomoOgooKfm_oe]KFomCDe?oF
e]Kof][JomkNg_oPh>001_oOgml3on3Ph003omoOgooPh>3oh>3P00;oh>3P2?oOgml2omkNgP;ogmoO
0ooPh>02omoOg`;oh>3P0_oOgml=on3Ph005omoOgooMgMgofMWIomGEeOoCdm<00_oBd]800ooFe]Ko
g=cLon3Ph03oon7QhDOohN7Q00?oh^;Ron7QhOoRh^801?oQhN41onCTi07ojNWY0Oo]kNd00003oo3`
l?o_knoolO7a00;ol?3`0_o_knl0ooo`l?3ok^k^onSXj?oKfm_o`L71ojBTY?n<S8coNg]kogMgMomk
Ng_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aong]kOoZ
j^[of][Jol;2`_nTY:CoS8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<S?mkNg_oMgMfog]kNon<
S8coY:BTol;2`_oJf][oj^[Zong]kOoalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7al@00C_o_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
koo`l>kokNg]onc/k?oUiNGoh^;RomoOgooUiNGojNWYong]j`;oj>SX00Koi^KVonWYjOoWinOojn_[
onc/k?o^k^`3on[ZjP09ono_koo^k^kok^k^onSXj?oXj>Koi^KVonWYjOoWinOoj^[Z00;ojNWY00go
iNGUonOWiOoWinOojn_[onc/k?o_knoojn_[on[Zj_oYjNWok^k/onc/k?o[jn_oj>SX00;okNg]01Co
k^k^on[Zj_o/k>[ok>c/onk^k_oZj^[ok>c/ong]kOo^k^koj^[Zonc/j_o/k>cok^k^ojf][OmgMgOo
FEUIofm_Konf][KohN7PonOWi`;okno_0?oolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo^k^kolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO4004cokno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo`l?3okno_oo3`l?o_knool?3`ono_koo`l?3okno_1?o`l?000003oo;bl_o^k^koinOW00CoiNGU
013oi>CTomoOgooAdM7o/K6aohZ:R_mUIFGoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoA
dM7og]kN0_oTi>@00ooUiNGoi>CTonGUi002onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5
AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT0?ooiNGUonCTi?oUiNGoi>CTonCT
hooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7AomkN
g_oTi>?oi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiND002Ooi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCohn?SolK6a_lX:2SoADE5
ohn?SooBd];ofm_KomcLfooFe]H00ooEeMD03?oDe=Cof][JomoOgooOgmkofMWIomGEeOoHf=SogmoO
on7QhOoMgMgoe]KFomGEe0;oeMGE00_oe=CDomWIfOoJf][of=SHomGEeOoFe]Goe]KFomWIfOoMgMgo
h>3Pom_Kf`02omKFeP09omgMg?oLg=cof=SHomGEeOoLg=coh>3PomoOgooJf][ofm_J00;ogMgM0?oo
fMWIomcLg?oOgmooh>3Pom_KfooJf]WogMgMon3Ph?mcLg?oJ6QXohf=SOmDE5Co20P8oj>SX_oKfm_o
hn?SonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoShn?o
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUon?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>@0
05KoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi0CoiNGU00Koi>CTonGU
iOoUiNGoiNGUonSXj?o/k>`1oo;blP0000?om?Cdong]kOoWinL00ooPh>004_oOgmoog]kNom;Bd_nd
];CoQhN7oe]KFom]>cGoWTi2ole_GooYPfoocFmOoii>@om]>cKoG5aLohN7Qond];Cod];BomkNgPGo
h>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m]H2coWYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aLohN7
Qond];Cod];BomkNgP05on3Ph00AomkNg_oBd];o];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=
AomZWSCoBFX_oeaLG?n7QhOo];Bdom;Bd_oNg]h0oooPh>09on3Ph006omoOgoo?clooVIVIoi:BT_lI
6AWoS8b<0_oEeMD07oo?cloo`/;2olk>c_o>c/koaLG5ol[:b_oJf][of=SHom3@d?o;bl_oclo?omSH
f?oJf][oeMGEolo?coo1`L7od=3@olk>c_o4a<Cobl_;omSHf?oGemOo_[jnok^k^ooAdM7od=3@omGE
eOoHf=Sodm?Colc<c?o>c/h00_oEeMD01Oo>c/koc<c<om?CdooJf][of=SH00;od];B00Cof=SHomOG
eooAdM7odm?C0_oIfMT01_oCdm?odM7AomOGeooHf=SodM7Aom3@d0;odM7A00CoATI6od51@OoGemOo
g]kN@OoPh>000ooOgmooh>3Pon3Ph03oon3Ph07oh>3P00?ogmoOon3Ph?oOgml00_oOgml3on3Ph003
on7QhOoWinOok>c/007om?Cd00000oofm_Kol_;bon_[j`03onSXj00ConOWiooRh^;ocLg=oinOWom[
GeooScH^oneaHOoiWI3ooK6Uoofl[oom]:OonInConedHonB=booJemOoinOWoo=cLgoh^;RonOWi`03
onSXj00ConOWiooRh^;ocLg=oinOWom^IUooTg8RongAA?oilgCooOf=oogmUOomoHkonOQfongGAonC
Lb;oKVMOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWomPJ5ooBg`Soi;QBonm
nG_od?fBomSmVooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=cLgoh^;RonOWi`3oonSXj0[oj>SX00Co
i^KVon7QhOmMGEgoCDe=0_oMgMd07om@D53o1`L7oaDE5On4Q8Co5QHFod=3@ooRh^;ogMgMoibLW?l0
003oShn?omgMgOoQhN7ofm_Kod10@?l820So6ATIohR8R?l;2`_oF5QHokNg]ol<30co1`L7ob<S8olW
9bOoOGemom[Jf_oMgMgoe=CDo`/;2omIFET00_oIfMT00omMGEgo2`/;om?Cd`02omoOg`06oeYJF_m>
CTkog]kNomkNg_lS8b?oQ8B40_oQhN403?mjNW[o;Rh^omgMgOoMgMgo`/;2oe1@D?lc<c?oKVi^oh>3
PolQ8B7og]kNonKVi_ooj>SXC_oXj>P1onc/k07ol_;b0Oofm_H0000IooOgmoohn?Son?ShooShn?og
moOon?ShooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFooZBQoonYY_oo[6UoonhZoon/jKooZRLoo^DROo^
J5WoRC4[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_PK_on
m8;oo_j:ooooT_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^
k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSoc_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[oi2@T?o>
c/kok^k^ooOgm`3oooShn0[on?Sh02Gom_Kfoo7alOn1PH7o7alOong]kOo6a/Ko0000ol?3`ooCdm?o
G5aLo`P82?oZj^[ol?3`on[Zj_mBDU;o51@Docdm?OoYjNWol?3`ojn_[ol71`Ood];Bolg=cOm>CTko
6a/Konk^k_oKfm_o[Zj^onSXj?o/k>co[Zj^o`000?nd];Cok>c/ok2`/?l;2`_o6QXJ00;oi>CT00_o
8b<So`h>3_nTY:CokNg]onk^k_mPH63oE5ADonk^k_o]kNgo9RHVohf=S@02oo3`l00<oh:2P_la<C7o
k>c/on[Zj_m3@d?o;bl_oibLW?mcLg?o:RXZoaXJ6_o^k^kom_Kf>_ohn?P00oogmoOon?ShooShn005
ooShn003ooOgmoohn?Son?Sh03;on?Sh00?omoOgooShn?ohn?P0c?ohn?P00oogmoOon?ShooShn002
ooShn004ooOgmooinOWomoOgooKfmP7on?Sh00000oojn_[omOGeonk^kP02onc/k03oon_[jooYjNWo
gmoOokVi^OmiDU;o_c8TonMdJOomRGkooiR<oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c9?miDU;o
^[ZjomoOgooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3ooMYSoooZL_onlgko
ooZ2ookfOoook7?oo]iToo[7DOoRTQcoRFICokZj^_oOgmooj^[Zon_[joo/k>cojn_[on[Zj_oOgmoo
^[Zjoe9]D_mAXacoTM9EojKWJ_nhnG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]D_nj^[[o
gmoOon[Zj_o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/001donc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_oj^[ZonCTi?mj
NW[o71`Lon;Rh_o;blco0`<3oinOWooOgmooU9BDoa<C4ooPh>3ohN7Qom3@d?l61PKoXJ6Qo`T92Onn
_[koh^;RokVi^Ol20P;o/K6bomkNg_n0P83o:BTYon;Rh_oXj>Soi>CTomoOgooJf]_oe=CDo`P82?n6
QXKogmoOofYZJ_m9BDWo=CDeojb/[Onn_[ko1`L7ogQhN?mEEED2omoOg`06oe]KFom?Ce3oh^;Ron3P
h?lT92CoQ8B40_oPh>00oomkNg_o;bl_on7QhOoDe=Co1@D5ojNWYooTi>Coh^;RogmoOolE5AKoh^;R
onWYjOo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k000D?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/1oo[jn/01Oo/k>cojn_[on_[joo^
k^kom_Kf007onOWi00000ookno_olo?cong]k@02onGUi@3oonKVi_oShn?ofMWIok:b/_mi;Rkob48d
on=ZG?ocNFcooHQloojGR_onVhkooYR;ooj:O_odNfgoif]MolY2=?mk;Rko/[:bomSHf?oTi>CoiNGU
onKVi_oUiNKoi>CTomSHf?nb/[;oUUD^onZL:ook_4Coo/aCoogHH_onhg;oo^UeookVLoonffGooLaC
oo_1AOo^WR_oVEH^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGUonCTi?oHf=Wo/[:bobiR;_mS[B_oQlY8
oiOLFOnUiFWo/_=gokSfNondmGWoYnY[oiSLFOn9cd_oHjh[obiS;_nb/[;of=SIonCTi?oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV001EonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi>CTomkNg_mgMgOo6a/KomcLg?oPh>7o
WYjNobh^;_l[:b_o<S8boa8B4P02om_Kf`0UohB4Q?lQ8B7ogmoOoe=CDomWIfOofm_KomgMgOn@T93o
:BTZobl_;ol/;2co:2PXomgMgOoOgmoof=SHom?Cdoo?cm3oFe]Ko`000?nn_[kofMWIobPX:?n6QXKo
N7QhofQXJ?n2PX;o?3`lol?3`ol?3`ooeMGEomWIfOmIFEWoCTi>omgMgOoLg=co8b<Soh61P@02omKF
eP27ogMgMol^;RkogMgMoj:RX_l0003oa/K6omWIfOoHf=SoSXj>oaDE5OoMgMgohn?SonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KV00;oiNGU0<OoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGo
kNg]oo?cl`01oo_kn`0000?oo?clooShn?oalO400oo^k^h04oo[jn_ohN7Qokbl_?mj5aOo`clbom9E
B?oTJ5[okgM/ooB3NOohQgcomHAjoo=iKOoUJE_ofEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h0
4oo/k>cohN7Qokbl_?nUAaOoiYLbooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlbonVK
<_nUAQOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOoGjPbogJm=on6cDOoU]IJoj;P
IOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lGFAOo_;blon7QhOo/k>`0ooo^k^h:onk^kP0^onc/k?oW
inOoNg]koa`L7?oTi>CojNWYonKVi_oQhN7og]kNohf=SOlD51Coi^KVonCTi?le=CGoNGUion_[jonb
/[;o5ADEomoOgooVi^Koi>CTon7QhOoMgMgoNWYjobTY:OoXj>SoiNGUomgMgOna/K7o9RHVo`/;2onK
Vi_ojNWYolc<c?l0003oc/k>ol?3`olU9BGoBd];ogalO?oXj>So<C4aojFUYOoTi>CoGEeMoe5AD@;o
inOW00[o9BDUofUYJOoOgmoogmoOogMgMola<C7ojNWYol71`Ol0003oYjNW0_oOgml01?nCTi?o5QHF
onOWioo/k>`lonk^kP03ong]kOo^k^kok^k^00;ok^k^00?okNg]onk^k_o^k^h0ooo^k^h9onk^kP03
ong]kOobl_;on?Sh007oo?cl0003oogmo@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Co
aclcom9@@ooJHUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];olo?cooclo0?ooOgm
01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWomJPYooRd?ooi_D[on;m=ooZoB_oi^3oomZXZonnN6OoK
RcCoXRd7om;Bd_oclo?oo?cl00?ooOgm01?oo?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:
cE3oSLeBoh[>D?n1adCoLKT_of:^8?m>VcCo1d87om;Bd_oclo?oo?cl0?oooOgm2_omoOd08ookno_o
moOgohB4Q?lN7Qkolo?cooWinOnc/k?od=3@oo?clomXJ6SoAdM7ooWinOoDe=Co0000omgMgOolo?co
no_kobLW9onXZ:SonOWioj^[ZooEeMGolO7aoeADE?mNGUkonOWiooCdm?nDU9Co1@D5od10@?oAdM7o
moOgooShn?nGUiOo:b/[00;on_[j01_o92@To`L71oo8b<Sono_kohF5QOmSHf?omoOgof=SHomGEeOo
n?ShooWinOlW9bOo5ADEoh>3PooGemOo@T92of=SHookno_on_[joc@d=?m9BDWofm_KonGUiOm?Cdoo
5aLGoo[jn_olo?`0ooomoOe;oogmo@03ooclo?omoOgoo?cl00?ooOgm0000>_omoOgon_[joo?cloo^
k^kol?3`ono_koo^k^kojNWYom?CdomJ71coXS@dok@X7Oo1>BcoadTlolmFB_o@Ed_od5M:olY:?_o3
>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>ook^k^on[Zj_oCdm?oS2DMolQa=?oI
Q1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/X2GoiiLEomb87Oo8LCCoS2DMom?CdooZj^[ok^k^oo3`l?o_
knool?3`onk^k_oZj^Wodm?Coadh7OldPSCoAiDMoeZU6omY[BX2ogBh>03oogFi>?m[/B_oFjLLodRJ
7OldPSCo7CPMom?CdooZj^Wok^k^oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_000joo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o^k^kojn_[ogemOOlL71coinOWonk^kOn8R8So<30`o`h>3_la<C7o/;2`ono_kon4Q8CoCDe=
onk^k_o_knook^k^ohZ:R_mIFEWokno_ogQhN?l/;2_o3Ph>ocPh>?nn_[kok^k^on?Shol>3PkoJFUY
on3PgooRh^;oi^KVon[Zj_mQHF7oMWIfono_koo^k^koMgMfobHV9P;ok^k^01KocLg=ob`/;?o[jn_o
K6a/of=SH_o[jn_ok^k^ocXj>_nDU9CoHV9Ro`h>3_ld=3Coa<C4onk^k_o_knoodM7Aoc`l??l:2P[o
9bLWofa/K?l/;2cok^k^0_o_knl0ooo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o^k^kol?3`ono_koo`l>ookno_oo3`l?o_knool?3`onk^k_o`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l000AOo_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
k`02oo3`l0Kokno_0Ooclo<1ooShn07oo_kn00000oono_komoOgoo3`l002onWYj@0ConSXj?oYjNWo
i^KVom_KfomSBd_oPC8bojHd=?nf=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mSBd_o
fm_KonOWi`05onWYj@0AonOWiooKfm_oRD];ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRko
eX/]olYe=On_Bc;oRD];om_KfooWinL01OoYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[Zboo
L:dhofn^>_m`[CSoJZX_oe>K;OliR3Go<V0bod];BooKfm_oinOW0?oojNWY2ooYjNT01_oXj>Soi^KV
og]kNolL71coi>CTonSXj0;ojNWY00?oinOWonWYjOoYjNT02ooYjNT03?oWinOojNWYonWYjOoXj>So
f=SHo`X:2_n^[Zkog=cLomkNg_oPh>3oiNGUonSXj0SojNWY00Koj>SXonKVi_oShn?ohn?SonKVi_oX
j>P3onWYj@03onSXj?oYjNWojNWY00CojNWY00?oinOWonWYjOoYjNT0N_oYjNT00ooXj>SojNWYonWY
j@03onWYj@03onSXj?oYjNWojNWY0<KojNWY00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07omoOg0Oon
o_h00004ookno_ojn_[om?Cdono_k`?ol?3`017okno_on_[jonEU9CoCb<SoiEDE?nkLg?odiFEomZL
W?oJWYcofIbLomBEUOnkLg?oUEADodlS8onEU9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oZIBDoh4S
8onjJUCoe9YconBlUOoZaicojLNLon[7W?oU_9Goe9Ycok]ZE?n18b?oZYBDon[Zj_o_knl01Oo`l?00
4Oo_knooj^[ZoiBDU?lS:R?oE7YDog>ULonNaYGo[<jLojg>W?n/cYcoW/JEog>ULomDNUCo8bXSoiBD
U?oZj^[okno_0?ool?3`2oo`l?02ono_k`04oh20P?lM7Agok^k^ono_k`Gol?3`00?okno_oo3`l?o`
l?002oo`l?02ono_k`07ofATI?lY:BWoPH61of=SHolk>c_ok^k^ono_k`08oo3`l006ono_koo^k^ko
Lg=cofUYJOo^k^kokno_Boo`l?02ono_koool?3`3oo`l?001?oalO7ol?3`ooCdm?ojn_X1ooknoP00
00CokNobooooooooooooo_kn0_ooool2ooknoP3ooogmoOogmoOoKVi^oeXo?onaT93og/W9oo3Ti?oc
i^Kol>CTomk9bOnaT93oFSloofe]KOohn?Soo?clooooooono_koooooookno_ooookoo_knoooooool
o?con?Shohe]KOn:?coobI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo?on=KFgon?Sgooclo?oo
ooooo_knooooooono_koooooookno_ooookoo?clooShn?m]KFgo?clooi2MT?o9eLWoi>cTonK^i_oT
k>CobMG9oi2MT?lo?cooKFe]ooShn?olo?coooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_kn0017ooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooool00_ono_h06?o?clooYZJVoogmoOooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
o`;oo_kn00ko`<30og5aLOn0P83o/;2`oogmoOooooooo_knooooooono_koooonookno_ooooooo_kn
ooooo`;oo_kn0?oo`L71okfm_?omoOgoooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_h005coooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooooooknoP;ooooo00?oo_knooooooooool00oooool1oo[jn`0000Coa<cC
ookno_ojn_[olo?c1OoalO403Oo_knooe]KFof][Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?Cgo
Jf][omKFe_o_knl02OoalO403Oo_knooemKFoh=[Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<S?mb?Cgo
PF][omOFe_o_knl02OoalO403Oo_knooe]KFof][Jolm?CgoS8b<okZj^_o<cLco^[Zjohb<S?lm?Cgo
Jf][omKFe_o_knl0oooalO4Foo7al@03oo3`l?oalO7olO7a017olO7a00?ol?3`oo7alOoalO40WOoa
lO400oo`l?3olO7aoo7al@34oo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_ono_h0
0Oo[k^l0000EohZHXoomoOgon?Shoo3`l?o[jn_oj^[ZonWYjOoZj^[ojNWYon[Zj_oYjNWoj>SXoi^K
VomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V
9_l]2@Wo@RHVofUIFOnPVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV
9_mIFEWoVi^KonSXj?oYjNT0oooZj^XZon[ZjP03onWYjOoZj^[oj^[Z09coj^[Z00?ojNWYon[Zj_oZ
j^X0cOoZj^X01?o[jn_ol?3`ooShn?omoOd1oloBeP0000Co@E1Nokc6cOojn_[olo?c2?oalO42oo3`
l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`oooalO7ooo7a
lISolO7a00?ol?3`oo7alOoalO400_oalO400ooemOGon_[jonW[k@01oi^OXP0000?o9Ca>oe5SL?nk
aL`0ooooooooooooom[ooooo0Oo]ko41ojb`]07oYjb`00001_lY@5Oo8SU<ocQ:FOn6TIgo`LS>onc^
l?oooooooooooooDooooo`05ooSin_o/k^oodMCGoi^OXonMXjL00Onc^[l00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{734, 424},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(defaultLF = 
      javax`swing`UIManager`getCrossPlatformLookAndFeelClassName[]\)], "Input"],

Cell[BoxData[
    \("javax.swing.plaf.metal.MetalLookAndFeel"\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]If[{} =!= \
\((javax`swing`UIManager`setLookAndFeel[defaultLF]; $MessageList)\), 
        Abort[]]; \
\[IndentingNewLine]javax`swing`SwingUtilities`updateComponentTreeUI[
        frame]; \[IndentingNewLine]btn@
        setText[javax`swing`UIManager`getLookAndFeel[]@
            getName[]]; \[IndentingNewLine] (*\(frame@
            pack[];\)*) \[IndentingNewLine]JavaShow[
        frame]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(feels = javax`swing`UIManager`getInstalledLookAndFeels[]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.UIManager$LookAndFeelInfo"] \[RightGuillemet]\),
          JLink`Objects`JavaObject68945465835521], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.UIManager$LookAndFeelInfo"] \[RightGuillemet]\),
          JLink`Objects`JavaObject74960936632321], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.UIManager$LookAndFeelInfo"] \[RightGuillemet]\),
          JLink`Objects`JavaObject127432300429313], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "javax.swing.UIManager$LookAndFeelInfo"] \[RightGuillemet]\),
          JLink`Objects`JavaObject67386208157697]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(lfNames = 
      Table[\[IndentingNewLine]{feels[\([i]\)]@getClassName[], 
          feels[\([i]\)]@getName[]}, \[IndentingNewLine]{i, 1, 
          Length[feels]}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \({{"javax.swing.plaf.metal.MetalLookAndFeel", 
        "Metal"}, {"com.apple.mrj.swing.MacLookAndFeel", 
        "MacOS Adaptive"}, {"com.sun.java.swing.plaf.motif.MotifLookAndFeel", 
        "CDE/Motif"}, {"com.sun.java.swing.plaf.windows.WindowsLookAndFeel", 
        "Windows"}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]If[Length[lfNames] < 1, 
        Return[]]; \[IndentingNewLine]If[{} =!= \
\((javax`swing`UIManager`setLookAndFeel[
              lfNames[\([1, 1]\)]]; $MessageList)\), 
        Abort[]]; \
\[IndentingNewLine]javax`swing`SwingUtilities`updateComponentTreeUI[
        frame]; \[IndentingNewLine]btn@
        setText[lfNames[\([1, 2]\)]]; \[IndentingNewLine] (*\(frame@
            pack[];\)*) \[IndentingNewLine]JavaShow[
        frame]\[IndentingNewLine]]\)], "Input"],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;N0001Z2000`400?l0
0000o`00003oooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?000?oo
l?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`
l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?oo
l?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003o
oo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3o
l?3`003ooo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l00000gooooo
ookno_ono_koo?clooWinOofm_Kol_;bong]kOoXj>Sohn?Son3Ph?oMgMgo
fm_K00;of][JoooIfMWoomWIfL7ofMWI0_oJf]X02_oKfm_ogMgMon3Ph?oS
hn?oj>SXong]kOobl_;om_KfooWinOolo?`2ooknoP;ooooo0002ong]k@0:
on[Zj_oXj>Soh^;RomgMgOoFe]KocLg=olK6a_nn_[ko^[ZjokJf]PCo/k>c
oonb/[;ook:b/[oo/[:b1?nc/k<02_nf][Ko^[Zjokjn__o6a/KocLg=omKF
e_oMgMgoh^;RonSXj?oZj^X2ong]k@7ok^k^00003_oUiNGoh^;RomoOgooJ
f][od];BolO7aonm_Kgo/[:bojRXZ?nPX:3oVi^KoiRHV?nDU9CoTi>CoonB
TY;ooi:BT/?oTY:B00goTi>CoiBDU?nHV9SoVi^Koj2PX?nXZ:So/[:bokfm
_Oo7alOod];Bom[Jf_oOgmooh^;R00;oiNGU00003_o[jn_oj>SXon;Rh_oH
f=Sobl_;okjn__n^[ZkoXJ6QoiFEUOn<S8coQHF5oh:2P_moOgooOWinoomm
OGgoogemOL?oOGem00koOWinogmoOon2PX;oQHF5ohb<S?nEUIGoXJ6Qojj^
[_nn_[kobl_;omSHf?oRh^;oj>SXon_[j`7okNg]00005?oinOWolo?conWY
jOoIfMWoalO7okBd]?nRXZ;oVYZJojZZZ_o3`l?ofMWIonc/k?ofm_KomoOg
ooWinOohn?SonOWioo[jn_oinOWomoOg0oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00_ohn?P0
3ooinOWon?ShooOgmoo^k^kof][JolC4a?nZZZ[oVYZJoj:RX_nd];CoalO7
omWIfOoYjNWolo?cooWin@01oogmo@0000coiNGUomgMgOo>c/ko_KfmojRX
Z?nEUIGoYJFUolc<c?o^k^kom_Kfooclo?ono_koooooooooooooaoooool0
3?ono_koo?clooOgmoo_knoocLg=ojJVY_nEUIGoZ:RXokfm_Oo>c/kogMgM
onGUi@7oj^[Z00002_oJf][oc/k>okfm_OnXZ:SoUYJFoj^[ZooNg]kojn_[
ooCdm?okno_oooooooooooooboooool02_okno_olo?conc/k?oQhN7o[Zj^
oiJFU_nXZ:So_Kfmolk>c_oJf]X1on3Ph00000[ogMgMolg=cOnh^;SoXJ6Q
ojRXZ?oDe=Coh>3Ponc/k?oemOGooOgmoooooooooooool_ooooo00[oo_kn
ooKfm_o/k>coh^;RomWIfOn/[:coXJ6QokRh^?o=cLgogMgM0OoUiND0000;
onSXj?oDe=Co^[ZjojVYZOo6a/Koe=CDon3Ph?o/k>col_;booclo?ono_h0
oooooooooooool[ooooo00[on_[jooCdm?oZj^[ohn?SomOGeoo=cLgo[:b/
okZj^_oDe=Coj>SX0Ooclo<0000?omCDe?no_kooYZJVojb/[?o6a/Kod];B
omcLg?oVi^Kok>c/ooGemOohn?Son_[joogmoOooooooo?cl00Sooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Cooooo00oooOgmooooooomoOgono_k
ooShn?odm?CokNg]onKVi_oOgmooe]KFolc<c?nb/[;oYjNWokno_ooDe=@0
0OoRh^80000Col[:b_ne]KGoWYjNokJf]_o3`l?oclo?omKFe_oOgmooi^KV
on[Zj_o_knoolo?cooCdm?oemOGomoOgooKfm_ogmoOom_KfooShn002ooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_Kf
ooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_Kf
ooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`0DooKfm_ohn?So
moOgooOgmoofm_KomoOgooKfm_odm?Col_;boo3`l?o[jn_oi^KVon7QhOoJ
f][odm?ColW9bOno_kooXj>SokFe]Oo:b/X1omWIf@0000_od=3@okRh^?nP
X:3o/k>col30`?o9bLWodm?ComWIfOoMgMgoh^;RonGUi@02on[ZjP03onc/
k?o]kNgokNg]00Ook^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^
00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`
l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^
onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h0
1Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00?ok^k^
0_o]kNd2onc/k00<onWYjOoVi^Kohn?Son3Ph?oKfm_oeMGEolg=cOo5aLGo
^k^kojNWYonh^;Sod=3@0OoPh>00000=on3Ph?o8b<SoUIFEojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoM
gMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
XJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6
omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkN
g_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_co
gMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM
1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>00
0OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oN
g]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQ
hN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5
omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0
000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgM
gDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgo
g]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN
1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoM
gMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6
omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkN
gZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[o
g]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[o
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN
1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoM
gMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6
omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6Q
olS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkN
g_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_co
gMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:
b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM
1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM40
0OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oN
g]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000Ooa
lO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5
omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40
000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgM
gDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgo
g]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN
1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoM
gMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6
omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkN
gZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[o
g]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[o
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN
1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoM
gMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6
omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkN
g_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_co
gMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM
1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X0
0OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oN
g]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQ
hN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5
omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40
000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgM
gDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgo
g]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN
1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoM
gMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6
omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkN
gZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[o
g]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[o
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN
1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoM
gMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6
omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
okFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkN
g_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_co
gMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM
1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM40
0OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oN
g]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoI
fMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5
omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40
000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgM
gDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgo
g]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:
b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN
1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoM
gMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6
omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkN
gZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[o
g]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[o
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN
1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoM
gMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
XJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6
omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkN
g_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_co
gMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM
1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>00
0OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oN
g]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQ
hN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5
omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0
000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgM
gDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgo
g]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN
1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoM
gMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6
omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkN
gZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[o
g]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[o
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN
1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoM
gMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6
omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6Q
olS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkN
g_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_co
gMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:
b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM
1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM40
0OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oN
g]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000Ooa
lO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5
omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40
000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgM
gDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgo
g]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN
1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoM
gMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6
omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkN
gZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[o
g]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[o
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN
1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoM
gMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6
omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkN
g_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_co
gMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM
1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X0
0OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oN
g]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQ
hN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5
omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40
000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgM
gDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgo
g]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN
1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoM
gMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6
omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkN
gZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[o
g]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[o
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN
1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoM
gMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6
omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
okFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkN
g_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_co
gMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM
1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM40
0OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oN
g]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoI
fMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5
omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40
000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgM
gDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgo
g]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:
b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN
1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoM
gMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<So
UIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6
omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkN
gZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[o
g]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[o
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN
1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoM
gMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
XJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6
omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkN
g_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe
]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_co
gMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM
1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>00
0OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oN
g]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQ
hN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5
omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0
000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgM
gDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=
on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgo
g]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN
1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoM
gMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6
omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFE
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkN
gZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[o
g]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[o
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN
1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoM
gMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6
omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6Q
olS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkN
g_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_co
gMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:
b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM
1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM40
0OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oN
g]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000Ooa
lO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5
omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40
000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgM
gDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgo
g]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN
1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk
^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoM
gMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGo
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6
omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkN
gZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[o
g]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[o
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN
1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoM
gMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6
omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
ok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkN
g_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8
b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_co
gMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooA
dM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM
1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X0
0OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oN
g]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQ
hN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5
omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40
000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgM
gDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=
ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgo
g]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN
1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@
d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8
b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoM
gMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:
b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_o
U9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03
omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6
omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[o
aLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BD
ojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcL
g:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkN
gZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5
okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNW
Yonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[o
g]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[o
gMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf
][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN
1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oXJ6QolS8b?oPh>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoM
gMd6omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oL
g=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM400OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30
olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6
omkNg_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`0
3OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2P
okFe]Oo:b/X00OoIfMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6
a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkN
g_cogMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoK
fm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k
^ooAdM400OoQhN40000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<
c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_co
gMgM1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_o
f][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oP
h>000OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<co
dM7AomCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM
1_oNg]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM40
0OoQhN40000=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oN
g]h5omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSH
f?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoI
fMT0000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCD
e?oGemOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5
omgMgDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oF
e]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40
000=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oG
emOof][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgM
gDgog]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Ko
d];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>000OoalO40000=
om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOo
f][Jom_Kf`03omcLg:[og]kN1OoMgMd6omkNg_cogMgM1_oNg]h5omgMgDgo
g]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=ol[:
b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg:[og]kN1OoMgMd6omkNg[kogMgM00?oR8R8ojBTY?oMgMd0
>ooMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kN__oM
gMd00olg=cOoKVi^omgMg@0komgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]j4omgMg@03olc<c?oKfm_ogMgM00;odm?C0ooMgMd0
0oo=cLgoclo?omgMg@04omgMg@04omcLg?nn_[ko_KfmomcLg0CogMgM00?o
fm_Kokjn__o7alL04_oMgMd00ooIfMWobLW9omgMg@05omgMg@03olc<c?oK
fm_ogMgM00;odm?C00KogMgMocLg=om^KVkog=cLolK6a_oLg=`5omgMg@03
olK6a_oKfm_ogMgM00gogMgM00?odm?ColW9bOoMgMd08OoMgMd6omkNgPGo
gMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kNN?oMgMd02Ol^;RkoShn?
omgMgOo=cLgoRXZ:ol[:b_oMgMgoYJFUo`410@02omgMg@0=odI6A_l61PKo
5QHFohN7Qol@413oBd];omgMgOo6a/Ko=cLgo`000?l?3`oo6ATIomKFeP02
omgMg@0>ohj>S_l?3`oo6a/KoahN7_l<30coOWinomcLg?oMgMgoV9RHo`P8
2?l;2`_o7alOobh^;_n@T905omgMg@03od=3@omTI6CogMgM00CogMgM00Wo
:2PXoe9BD_oMgMgoW9bLo``<3?l10@7o9bLWogmoOol>3Ph00_oMgMd03Om6
ATKo1PH6oaHF5_n7QhOo410@od];BooMgMgo=cLgod51@OlP823o5aLGoa8B
4_nRXZ800_oMgMd01onf][Ko820PoaXJ6_nQXJ7ogMgMocLg=om^KVh00ooM
gMd00om/K6co0000okno_`03omgMg@06olS8b?m0@43o0P82oahN7_lC4a?o
YjNW8?oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Kog]kN
N?oMgMd04?l^;RkoShn?omgMgOmkNg_o0000og=cLooMgMgoYJFUo`410OoM
gMgoZj^[o`<30ono_kooalO7odi>C_l>3Ph2omgMg@0:ocTi>OlV9RKo[jn_
omgMgOnk^k_ofm_KomgMgOn>SXko20P8oijNWP;ogMgM00_o[:b/oa8B4_me
MGGogMgMokVi^OnUYJGof=SHomgMgOn8R8So0`<3ol30`004omgMg@03oibL
W?lB4Q;oemOG00?ogMgM017o[jn_o`000?nYZJWogMgMob`/;?m>CTkocLg=
ojn_[olW9bOo3Ph>omgMgOn[Zj_o0`<3okno_oo7alOoCTi>o`h>3P02omgM
g@0;ocLg=olj>S[oclo?omWIfOm/K6co410@om;Bd_oMgMgoHF5QocPh>?oL
g=`00_oMgMd02?lg=cOoKVi^omgMgOoMgMgog=cLoaXJ6_lB4Q;oJFUY0ooM
gMd01_lj>S[o=cLgol71`OoMgMgod];Bom7AdB3ogMgM1_oNg]h5omgMgDgo
g]kN1OoMgMd6omkNgZ[ogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2PokFe]Oo:b/X00OoIfMT0000=om7A
dOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg:[og]kN1OoMgMd6omkNgWSogMgM01Co;Rh^ohn?SooMgMgo
:b/[ocdm?OlQ8B7ogMgMojFUYOl10@7ogMgMokbl_?l20P;oXj>SomgMgOn9
RHWo6a/KomgMgOnn_[ko0000oh61P@CogMgM00?of=SHoaLG5om8B4P01?oM
gMd00omnOWko2PX:olg=c@04omgMg@03ol?3`ol0003oWIfM00CogMgM00?o
f][JoaPH6?mRHV800on5QHD01_lo?coo8R8RomgMgOo9bLWo0000ojZZZP;o
gMgM00WoU9BDo`h>3_oMgMgo_;blo`820_nSXj?ogMgMohV9ROlK6a/00_oM
gMd02_lg=cOoKVi^omgMgOoMgMgob<S8o`000?nEUIGogMgMod92@_mRHV83
omgMg@0=ocLg=om^KVkogMgMomgMgOnUYJGo2@T9oibLW?lE5AGofMWIomgM
gOno_koo0000oinOW`0TomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]ihomgMg@09obh^;_n?Shoo^[Zjo`000?ng]kOo92@Tojf]
[OnUYJGo0@4100;ogMgM00WoUIFEob/[:ol/;2co;Rh^oa/K6ooMgMgoY:BT
o`000?nb/[801?oMgMd00oni^KWo0000ohB4Q004omgMg@03ol?3`ol0003o
XZ:R00?ogMgM00Cod=3@odA4A?l61PKodM7A1OoMgMd02om^KVko3@d=oeYJ
F_mJFU[oD51@o`000?mhN7SogMgMojJVY_l0003oalO700;ogMgM00WoUIFE
o`h>3_oMgMgogMgMoiFEUOl[:b_o;2`/obh^;_lK6a/00_oMgMd00olg=cOo
KVi^omgMg@02omgMg@05oa<C4ommOGgogMgMod92@_mRHV800ooMgMd03Olg
=cOoKVi^omgMgOoMgMgoDe=Coe1@D?oMgMgo820PoiRHV?oMgMgoY:BTo`00
0?ld=3@00olf=SH00onYZJWogMgMomgMg@0NomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]ihomgMg@09obh^;_n?ShooJf][obTY
:OoMgMgoMWIfoe]KFonUYJGo0@4100CogMgM00Oofm_Koh20P?lL71cogMgM
okfm_Ol0003oOGem00CogMgM00?oW9bLo`000?nl_;`01?oMgMd00ooIfMWo
0000ohB4Q002omgMg@04oifMWOlH61So4a<CojBTY0KogMgM00_o`l?3o`82
0_no_koogMgMohR8R?l410Cob/[:omgMgOo2`/;o0000oiZJVP02omgMg@03
oiFEUOl>3PkogMgM00?ogMgM00?ofm_Koh20P?lL71`00_oMgMd02_lg=cOo
JFUYomgMgOoMgMgocLg=o`000?nYZJWogMgMod92@_mRHV83omgMg@0AocLg
=om^KVkogMgMom?Cdol92@WoXj>SomgMgOmgMgOo@D51omgMgOnm_Kgo0000
oiBDU?nc/k?o[:b/o`820_o6a/H08?oMgMd6omkNgPGogMgMCOoNg]h5omgM
g@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLZ_oNg]h5omgMg@Kog]kNN?oMgMd02Ol^;RkoSXj>oa/K6omhN7SogMgM
olG5aOlA4A7oWinOo`410@02omgMg@05oibLW?nl_;cof][JoeADE?m8B4P0
0_oMgMd02Olf=SKo8B4QojBTY?oLg=co`<30omgMgOn/[:co0000okNg]`04
omgMg@08okFe]Ol0003oU9BDomgMgOm_Kfoo0000odY:B_o7alL8omgMg@05
od10@?mXJ6SogMgMoc0`<?m7AdL00ooMgMd01_lj>S[o?3`lolC4a?o;bl_o
AdM7o`h>3P;ogMgM00GoW9bLokbl_?oJf][oE5ADodQ8B002omgMg@0MocLg
=olG5aOoPX:2okjn__mKFe_o3Ph>om[Jf_oGemOo?clooeiNG_oCdm?ofMWI
omgMgOlg=cOoKVi^omgMgOn<S8co6QXJomcLg?oMgMgobLW9o`H61_o3`l?o
gMgMocHf=_mLG5coe]KFohR8R?lU9BD08OoMgMd6omkNgPGogMgMCOoNg]h5
omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLZ_oNg]h5omgMg@Kog]kNN?oMgMd01?l^;RkoFe]Ko`410Oo6a/H2
omgMg@03oc`l??mMGEgo0@4100;ogMgM00GoMgMgob/[:ol=3@go<C4aojVY
Z@02omgMg@09olW9bOm;Bd_o3@d=o`T92OlP823ogMgMolk>c_l20P;oS8b<
00CogMgM00KoMgMgo`000?ni^KWoalO7o`410OmoOgl:omgMg@05oiNGUolD
51Co/[:bo`000?nNWYh00ooMgMd01_o7alOo>SXjo`X:2_lR8R;oGUiNo`h>
3P;ogMgM00GoMgMgob/[:ol=3@go<C4aojVYZ@02omgMg@0BodQ8B?mgMgOo
EeMGo`/;2olE5AGoTI6AomgMgOm^KVko1PH6o`X:2_lG5aOoUYJFomgMgOm8
B4SoNWYjomgMgOm>CTkoM7Ad0ooMgMd02?mDE5CoOgmoomgMgOo7alOo?Cdm
o`/;2olH61SoWYjN8OoMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5
omgMg@Kog]kNN?oMgMd00ol^;Rko4A4AocXj>P03omgMg@03ohj>S_l@413o
0@4100CogMgM00?ofm_KomgMgOoMgMd01OoMgMd01ooJf][ogMgMomgMgOoM
gMgoFEUIobHV9_oAdM400_oMgMd01ooGemOo;bl_od51@OoMgMgo^k^ko`41
0Oo8b<P02_oMgMd01OoIfMWo51@Dob<S8olI6AWog=cL00GogMgM00Cofm_K
omgMgOnEUIGo3Ph>1?oMgMd00ooKfm_ogMgMomgMg@05omgMg@03om_KfooM
gMgogMgM00;ogMgM00?o@T92of9RH_oMgMd03ooMgMd00ooJf][ogMgMomgM
g@0QomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]ih
omgMg@03obh^;_l0003oR8R800?ogMgM00?oe=CDo`X:2_l10@404?oMgMd0
2?o=cLgo>CTiob<S8ombLW;oMgMgobd];Ol[:b_o`l?30_oMgMd01Om0@43o
<S8bog]kNomDE5CoC4a<00SogMgM00?oJFUYo`000?m]KFd02?oMgMd00onE
UIGo3Ph>omgMg@0@omgMg@03ol;2`_o0`<3ogMgM00;ogMgM00?oCTi>ogin
O_oMgMd0;_oMgMd6omkNgPGogMgMCOoNg]h5omgMg@Kog]kNZ_oMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLZ_oNg]h5omgMg@Ko
g]kNN?oMgMd00onHV9SoQHF5om7Ad@04omgMg@03oifMWOn6QXKogMgM013o
gMgM00Kofm_KoiFEUOmXJ6SoI6ATohn?SooGemL3omgMg@05omWIfOnMWIgo
GemOogEeMOnUYJD02?oMgMd00oo8b<SoQHF5olW9b@08omgMg@03oiFEUOl>
3PkogMgM01GogMgM00?oW9bLok6a/OoMgMd0;_oMgMd6omkNgPGogMgMCOoN
g]h5omgMg@Kog]kNZ_oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLZ_oNg]h5omgMg@Kog]kN/ooMgMd00ooLg=cof=SHomgMg@16
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007o
hN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q0000
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007o
lO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007o
hN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q0000
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007o
hN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q0000
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007o
lO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007o
hN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q0000
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007o
hN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q0000
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007o
lO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFe
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007o
hN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q0000
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM
1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oN
g]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZ
omkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZ
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkN
gPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGo
gMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM
1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oN
g]klomgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]kl
omgMg@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgM
g@Kog]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Ko
g]kN1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN
1OoMgMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoM
gMe=omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=
omkNgPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkN
gPGogMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bZomkNgPGogMgM1_oNg]klomgMg@Kog]kN1OoMgMe=omkNgPGo
gMgM1_oNg]jZomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bZomoOg`Gog]kN1_oOgmolomkNgPKogmoO1OoNg]i=omoOg`Gog]kN
1_oOgmnYomkNgP0@omgMgOoLg=cog=cLom_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph07olO7a00003Oo@d=3o
^;RhoibLW?n/[:co^k^kolK6a_o=cLgodm?ComOGeooKfm_ogmoOon7QhOoR
h^800_oShn<7onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H5onGUi@;oi>CT0_oShn<03?oRh^;o
h>3PomcLg?oIfMWoe]KFom3@d?o9bLWo`L71okFe]OnUYJGo^;Rhom3@d07o
h>3P00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=`2omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgPCogMgM
0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`
/;3oX:2PokFe]Oo:b/X00OoIfMT0000=omCDe?no_kooS8b<oijNW_n][Jgo
^KViol;2`_o7alOoc<c<om3@d?oBd];oeMGEomKFeP02omOGe`03omSHf?oI
fMWofMWI0?oofMWIoooIfMVmomWIf@;of=SH0_oGemL03?oEeMGodm?Com3@
d?o>c/kob/[:olG5aOno_koo]KFeojVYZOnHV9So_knoomCDe07oh^;R0000
3OoXj>Soe=CDohb<S?nCTi?oXZ:Rojn_[onj^[[o`L71olO7aoo;bl_oc/k>
om3@d?oAdM400_oCdm<3omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oD
e=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGE
e@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oE
eM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGE
eOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]Ko
eMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oF
e]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oD
e=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGE
e@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oE
eM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGE
eOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00?oe]KFomGEeOoDe=@0
0_oCdm<03?oAdM7od=3@olg=cOo:b/[o`l?3okjn__nf][KoZj^[oifMWOnE
UIGoe=CDonSXj07olo?c00004_oMgMgocLg=oi2@T?n9RHWoUiNGojFUYOnb
/[;o_knool_;booAdM7oeMGEomOGeooIfMWof][Jom_KfooJf][ofm_KomcL
g0Oofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_K
fooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooL
g=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00?ofm_K00kof][JomWI
fOoHf=Soe]KFom?Cdoo=cLgo`/;2okJf]_n/[:coWinOoi2@T?nFUYKocLg=
omgMg@7oiNGU00002ooJf][oc/k>oibLW?mjNW[oR8R8oiJFU_nZZZ[oa<C4
omGEeOoKfm_og]kN00;oh>3P0ooRh^800ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Go
hn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`03on?Sh`;oh^;R00gohN7Qon3Ph?oO
gmoog=cLomOGeoo5aLGo[:b/oijNW_n@T93oPX:2oj2PX?o>c/kof][J007o
h>3P00003_oUiNGogMgMol;2`_mkNg_oN7QhohJ6Q_nOWiooaLG5omSHf?oM
gMgogmoOon7QhOoRh^;ohn?S0ooTi>@4onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003
onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@?o
i>CT00gohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4
ol?3`ooMgMgoiNGU007oj^[Z00002ooinOWolo?conWYjOnXZ:SoIFEUog=c
Lon=SHgo^k^komCDe?oJf][ogMgM00;ogmoO00?oh>3Pon7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?o
h^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQ
hN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN402?oQhN403OoPh>3ogmoOomgM
gOoLg=coeMGEokVi^On>SXkoNg]kofi^K_n[Zj_ojNWYoo?clooinOT00Oom
oOd0000<on_[jooXj>Soh^;RomOGeon=SHgoHV9RogIfM_nTY:CoalO7om;B
d_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005
omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=co
g=cL00;og=cL013ofm_KomcLg?oKfm_of][JomWIfOoHf=Sodm?ColG5aOnL
W9coMGEeofMWIon@T93oemOGon;Rh_oXj>Sojn_[0Oo]kNd0000>onGUiOoR
h^;ogmoOom[Jf_o9bLWoQhN7oeYJF_mkNg_oXj>Sokbl_?o6a/Kobl_;olg=
cOo?cll2om7Ad@God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7A
dOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
0_oAdM403Oo@d=3oclo?olc<c?o8b<So^k^koibLW?mbLW;oFe]KohZ:R_o9
bLWof][JomoOgooRh^800_oUiND000;okNg]00koj^[ZonSXj?oRh^;og=cL
oibLW?m]KFgoJ6QXoh>3PonGUiOoXj>Sojb/[?n_[joo/K6aok:b/P;o];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd
]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd
]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H03ond];Co/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2
of9RH_m^KVkoWinOomcLg?oRh^;oj>SXon[ZjP02ong]k@7ok^k^00004_oo
ooooo_knookno_olo?conOWiooKfm_obl_;ofMWIojRXZ?n3Ph?oKVi^ofEU
IOmYJFWoLW9bogAdM?miNGWoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00koO7alogYjN_mjNW[oMgMg
ogAdM?m_KfooM7AdohF5QOnXZ:Sof][Joo;bl_ofm_KonOWiooclo0;oo_kn
0_ooool000;ok^k^0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;RhP03on3P
h?oOgmoog]kN0?oogMgMoooMgMg5omgMg@03omkNg_oOgmooh>3P00;oh^;R
00CoiNGUonSXj?oZj^[ok>c/0_o]kNd3onk^kP001?oVi^H2onGUi@03onCT
i?oRh^;oh^;R00;oh>3P0_oOgmooomkNg_oog]kNaOoNg]h2omoOg`;oh>3P
0_oRh^800ooTi>CoiNGUonGUi@05onKViP00oomoOgn6ogmoO`OoOWinoomo
OgmCogmoO`0000Cojn_[onKVi_oRh^;og]kN0ooMgMd0oooLg=cog]kNomkN
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMg@00AooNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkogMgM00;og=cL03go
fm_KomgMgOoLg=cog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomcLgOoNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oMgMgofm_Kom[Jf_oG
emOof=SHomOGeooJf][ofm_L00;ogMgM0?oog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]h004GogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMd00ooNg]h00ooMgMgog]kNomkNgP03omgM
g@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>000ooIfMT02?oHf=So
fMWIomWIfOoIfMWof=SHomKFe_oCdm?od=3@0oo=cLd01?o@d=3odm?ComOG
eooHf=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooG
emOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?o
emOGomSHf?oofMWI2ooIfMT2omSHf006omKFe_oCdm?odm?ComCDe?oGemOo
f=SH0_oIfMT00ooHf=SofMWIomWIf@02omSHf0WofMWI00?of=SHomWIfOoI
fMT00_oHf=P00ooIfMWof=SHomOGe`02omSHf1OofMWI00Cof=SHomKFe_oB
d];oclo?0_o=cLd01?o?cloodm?ComOGeooHf=SoomWIfDGofMWI00?of=SH
omWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWoi>CT
on3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=codm?ColO7aonk^k_o
/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooK
fm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoO
g`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^k
olO7aooCdm?ofm_KomoOg`3oon7Qh@[ohN7Q00Woh>3PomoOgooKfm_oe]KF
omCDe?oFe]Kof][JomkNg_oPh>001_oOgml3on3Ph003omoOgooPh>3oh>3P
00;oh>3P2?oOgml2omkNgP;ogmoO0ooPh>02omoOg`;oh>3P0_oOgml=on3P
h005omoOgooMgMgofMWIomGEeOoCdm<00_oBd]800ooFe]Kog=cLon3Ph03o
on7QhDOohN7Q00?oh^;Ron7QhOoRh^801?oQhN41onCTi07ojNWY0Oo]kNd0
0003oo3`l?o_knoolO7a00;ol?3`0_o_knl0ooo`l?3ok^k^onSXj?oKfm_o
`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]
kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2
`_nTY:CoS8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;o
Y:BTohb<S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]kOoa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7al@00C_o_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_koo`l>kokNg]onc/k?oUiNGoh^;RomoO
gooUiNGojNWYong]j`;oj>SX00Koi^KVonWYjOoWinOojn_[onc/k?o^k^`3
on[ZjP09ono_koo^k^kok^k^onSXj?oXj>Koi^KVonWYjOoWinOoj^[Z00;o
jNWY00goiNGUonOWiOoWinOojn_[onc/k?o_knoojn_[on[Zj_oYjNWok^k/
onc/k?o[jn_oj>SX00;okNg]01Cok^k^on[Zj_o/k>[ok>c/onk^k_oZj^[o
k>c/ong]kOo^k^koj^[Zonc/j_o/k>cok^k^ojf][OmgMgOoFEUIofm_Konf
][KohN7PonOWi`;okno_0?oolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo^k^kolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO4004cokno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo`l?3okno_oo3`l?o_knool?3`ono_koo`l?3okno_1?o`l?00
0003oo;bl_o^k^koinOW00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mU
IFGoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oT
i>@00ooUiNGoi>CTonGUi002onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKo
DE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT
0?ooiNGUonCTi?oUiNGoi>CTonCThooNg]kodM7Aok6a/On:RX[oIVIVoe5A
DOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7AomkNg_oTi>?oi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiND002Ooi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCohn?SolK6a_lX:2SoADE5ohn?SooBd];o
fm_KomcLfooFe]H00ooEeMD03?oDe=Cof][JomoOgooOgmkofMWIomGEeOoH
f=SogmoOon7QhOoMgMgoe]KFomGEe0;oeMGE00_oe=CDomWIfOoJf][of=SH
omGEeOoFe]Goe]KFomWIfOoMgMgoh>3Pom_Kf`02omKFeP09omgMg?oLg=co
f=SHomGEeOoLg=coh>3PomoOgooJf][ofm_J00;ogMgM0?oofMWIomcLg?oO
gmooh>3Pom_KfooJf]WogMgMon3Ph?mcLg?oJ6QXohf=SOmDE5Co20P8oj>S
X_oKfm_ohn?SonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoShn?oiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUon?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>@005KoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi0CoiNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o/k>`1oo;blP00
00?om?Cdong]kOoWinL00ooPh>004_oOgmoog]kNom;Bd_nd];CoQhN7oe]K
Fom]>cGoWTi2ole_GooYPfoocFmOoii>@om]>cKoG5aLohN7Qond];Cod];B
omkNgPGoh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m]H2coWYH^olg=?ooY
jDgocLdooijJ;om]HbgoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomkN
g_oBd];o];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=AomZWSCoBFX_
oeaLG?n7QhOo];Bdom;Bd_oNg]h0oooPh>09on3Ph006omoOgoo?clooVIVI
oi:BT_lI6AWoS8b<0_oEeMD07oo?cloo`/;2olk>c_o>c/koaLG5ol[:b_oJ
f][of=SHom3@d?o;bl_oclo?omSHf?oJf][oeMGEolo?coo1`L7od=3@olk>
c_o4a<Cobl_;omSHf?oGemOo_[jnok^k^ooAdM7od=3@omGEeOoHf=Sodm?C
olc<c?o>c/h00_oEeMD01Oo>c/koc<c<om?CdooJf][of=SH00;od];B00Co
f=SHomOGeooAdM7odm?C0_oIfMT01_oCdm?odM7AomOGeooHf=SodM7Aom3@
d0;odM7A00CoATI6od51@OoGemOog]kN@OoPh>000ooOgmooh>3Pon3Ph03o
on3Ph07oh>3P00?ogmoOon3Ph?oOgml00_oOgml3on3Ph003on7QhOoWinOo
k>c/007om?Cd00000oofm_Kol_;bon_[j`03onSXj00ConOWiooRh^;ocLg=
oinOWom[GeooScH^oneaHOoiWI3ooK6Uoofl[oom]:OonInConedHonB=boo
JemOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWom^
IUooTg8RongAA?oilgCooOf=oogmUOomoHkonOQfongGAonCLb;oKVMOoinO
Woo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWomPJ5ooBg`S
oi;QBonmnG_od?fBomSmVooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=cLgo
h^;RonOWi`3oonSXj0[oj>SX00Coi^KVon7QhOmMGEgoCDe=0_oMgMd07om@
D53o1`L7oaDE5On4Q8Co5QHFod=3@ooRh^;ogMgMoibLW?l0003oShn?omgM
gOoQhN7ofm_Kod10@?l820So6ATIohR8R?l;2`_oF5QHokNg]ol<30co1`L7
ob<S8olW9bOoOGemom[Jf_oMgMgoe=CDo`/;2omIFET00_oIfMT00omMGEgo
2`/;om?Cd`02omoOg`06oeYJF_m>CTkog]kNomkNg_lS8b?oQ8B40_oQhN40
3?mjNW[o;Rh^omgMgOoMgMgo`/;2oe1@D?lc<c?oKVi^oh>3PolQ8B7og]kN
onKVi_ooj>SXC_oXj>P1onc/k07ol_;b0Oofm_H0000IooOgmoohn?Son?Sh
ooShn?ogmoOon?ShooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFooZBQoonYY_o
o[6UoonhZoon/jKooZRLoo^DROo^J5WoRC4[oi2@T?o>c/kok^k^ooOgm`03
ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_PK_onm8;oo_j:oooo
T_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^ooOgm`03ooShn00C
ooOgmoo^k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSoc_j@omKoUoo@oY;o
a_j9ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^ooOgm`3oooShn0[on?Sh02Go
m_Kfoo7alOn1PH7o7alOong]kOo6a/Ko0000ol?3`ooCdm?oG5aLo`P82?oZ
j^[ol?3`on[Zj_mBDU;o51@Docdm?OoYjNWol?3`ojn_[ol71`Ood];Bolg=
cOm>CTko6a/Konk^k_oKfm_o[Zj^onSXj?o/k>co[Zj^o`000?nd];Cok>c/
ok2`/?l;2`_o6QXJ00;oi>CT00_o8b<So`h>3_nTY:CokNg]onk^k_mPH63o
E5ADonk^k_o]kNgo9RHVohf=S@02oo3`l00<oh:2P_la<C7ok>c/on[Zj_m3
@d?o;bl_oibLW?mcLg?o:RXZoaXJ6_o^k^kom_Kf>_ohn?P00oogmoOon?Sh
ooShn005ooShn003ooOgmoohn?Son?Sh03;on?Sh00?omoOgooShn?ohn?P0
c?ohn?P00oogmoOon?ShooShn002ooShn004ooOgmooinOWomoOgooKfmP7o
n?Sh00000oojn_[omOGeonk^kP02onc/k03oon_[jooYjNWogmoOokVi^Omi
DU;o_c8TonMdJOomRGkooiR<oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c
9?miDU;o^[ZjomoOgooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EB
on:A7?oi`e3ooMYSoooZL_onlgkoooZ2ookfOoook7?oo]iToo[7DOoRTQco
RFICokZj^_oOgmooj^[Zon_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]D_mA
XacoTM9EojKWJ_nhnG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]
D_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/001donc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_oj^[Z
onCTi?mjNW[o71`Lon;Rh_o;blco0`<3oinOWooOgmooU9BDoa<C4ooPh>3o
hN7Qom3@d?l61PKoXJ6Qo`T92Onn_[koh^;RokVi^Ol20P;o/K6bomkNg_n0
P83o:BTYon;Rh_oXj>Soi>CTomoOgooJf]_oe=CDo`P82?n6QXKogmoOofYZ
J_m9BDWo=CDeojb/[Onn_[ko1`L7ogQhN?mEEED2omoOg`06oe]KFom?Ce3o
h^;Ron3Ph?lT92CoQ8B40_oPh>00oomkNg_o;bl_on7QhOoDe=Co1@D5ojNW
YooTi>Coh^;RogmoOolE5AKoh^;RonWYjOo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k000D?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/1oo[jn/01Oo/k>cojn_[on_[joo^k^kom_Kf007o
nOWi00000ookno_olo?cong]k@02onGUi@3oonKVi_oShn?ofMWIok:b/_mi
;Rkob48don=ZG?ocNFcooHQloojGR_onVhkooYR;ooj:O_odNfgoif]MolY2
=?mk;Rko/[:bomSHf?oTi>CoiNGUonKVi_oUiNKoi>CTomSHf?nb/[;oUUD^
onZL:ook_4Coo/aCoogHH_onhg;oo^UeookVLoonffGooLaCoo_1AOo^WR_o
VEH^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGUonCTi?oHf=Wo/[:bobiR;_mS
[B_oQlY8oiOLFOnUiFWo/_=gokSfNondmGWoYnY[oiSLFOn9cd_oHjh[obiS
;_nb/[;of=SIonCTi?oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGV001EonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi>CT
omkNg_mgMgOo6a/KomcLg?oPh>7oWYjNobh^;_l[:b_o<S8boa8B4P02om_K
f`0UohB4Q?lQ8B7ogmoOoe=CDomWIfOofm_KomgMgOn@T93o:BTZobl_;ol/
;2co:2PXomgMgOoOgmoof=SHom?Cdoo?cm3oFe]Ko`000?nn_[kofMWIobPX
:?n6QXKoN7QhofQXJ?n2PX;o?3`lol?3`ol?3`ooeMGEomWIfOmIFEWoCTi>
omgMgOoLg=co8b<Soh61P@02omKFeP27ogMgMol^;RkogMgMoj:RX_l0003o
a/K6omWIfOoHf=SoSXj>oaDE5OoMgMgohn?SonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KV00;oiNGU0<OoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGU00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H0
0ooUiNGokNg]oo?cl`01oo_kn`0000?oo?clooShn?oalO400oo^k^h04oo[
jn_ohN7Qokbl_?mj5aOo`clbom9EB?oTJ5[okgM/ooB3NOohQgcomHAjoo=i
KOoUJE_ofEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Q
okbl_?nUAaOoiYLbooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;o
nZlbonVK<_nUAQOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lG
FAOoGjPbogJm=on6cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[
<_lGFAOo_;blon7QhOo/k>`0ooo^k^h:onk^kP0^onc/k?oWinOoNg]koa`L
7?oTi>CojNWYonKVi_oQhN7og]kNohf=SOlD51Coi^KVonCTi?le=CGoNGUi
on_[jonb/[;o5ADEomoOgooVi^Koi>CTon7QhOoMgMgoNWYjobTY:OoXj>So
iNGUomgMgOna/K7o9RHVo`/;2onKVi_ojNWYolc<c?l0003oc/k>ol?3`olU
9BGoBd];ogalO?oXj>So<C4aojFUYOoTi>CoGEeMoe5AD@;oinOW00[o9BDU
ofUYJOoOgmoogmoOogMgMola<C7ojNWYol71`Ol0003oYjNW0_oOgml01?nC
Ti?o5QHFonOWioo/k>`lonk^kP03ong]kOo^k^kok^k^00;ok^k^00?okNg]
onk^k_o^k^h0ooo^k^h9onk^kP03ong]kOobl_;on?Sh007oo?cl0003oogm
o@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@@ooJ
HUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];olo?coocl
o0?ooOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWomJPYooRd?ooi_D[o
n;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?oo?cl00?ooOgm
01?oo?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:cE3oSLeBoh[>
D?n1adCoLKT_of:^8?m>VcCo1d87om;Bd_oclo?oo?cl0?oooOgm2_omoOd0
8ookno_omoOgohB4Q?lN7Qkolo?cooWinOnc/k?od=3@oo?clomXJ6SoAdM7
ooWinOoDe=Co0000omgMgOolo?cono_kobLW9onXZ:SonOWioj^[ZooEeMGo
lO7aoeADE?mNGUkonOWiooCdm?nDU9Co1@D5od10@?oAdM7omoOgooShn?nG
UiOo:b/[00;on_[j01_o92@To`L71oo8b<Sono_kohF5QOmSHf?omoOgof=S
HomGEeOon?ShooWinOlW9bOo5ADEoh>3PooGemOo@T92of=SHookno_on_[j
oc@d=?m9BDWofm_KonGUiOm?Cdoo5aLGoo[jn_olo?`0ooomoOe;oogmo@03
ooclo?omoOgoo?cl00?ooOgm0000>_omoOgon_[joo?cloo^k^kol?3`ono_
koo^k^kojNWYom?CdomJ71coXS@dok@X7Oo1>BcoadTlolmFB_o@Ed_od5M:
olY:?_o3>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>oo
k^k^on[Zj_oCdm?oS2DMolQa=?oIQ1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/
X2GoiiLEomb87Oo8LCCoS2DMom?CdooZj^[ok^k^oo3`l?o_knool?3`onk^
k_oZj^Wodm?Coadh7OldPSCoAiDMoeZU6omY[BX2ogBh>03oogFi>?m[/B_o
FjLLodRJ7OldPSCo7CPMom?CdooZj^Wok^k^oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_000joo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o^k^kojn_[ogemOOlL71coinOWonk^kOn8R8So<30`o`h>
3_la<C7o/;2`ono_kon4Q8CoCDe=onk^k_o_knook^k^ohZ:R_mIFEWokno_
ogQhN?l/;2_o3Ph>ocPh>?nn_[kok^k^on?Shol>3PkoJFUYon3PgooRh^;o
i^KVon[Zj_mQHF7oMWIfono_koo^k^koMgMfobHV9P;ok^k^01KocLg=ob`/
;?o[jn_oK6a/of=SH_o[jn_ok^k^ocXj>_nDU9CoHV9Ro`h>3_ld=3Coa<C4
onk^k_o_knoodM7Aoc`l??l:2P[o9bLWofa/K?l/;2cok^k^0_o_knl0ooo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o^k^kol?3`ono_koo`l>ookno_oo3`l?o_knool?3`onk^k_o`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l000AOo_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`02oo3`l0Ko
kno_0Ooclo<1ooShn07oo_kn00000oono_komoOgoo3`l002onWYj@0ConSX
j?oYjNWoi^KVom_KfomSBd_oPC8bojHd=?nf=2go`Te1ol=DBOo4ED[o`eA9
ol9=@Onf=2goYCDeoh4b<_mSBd_ofm_KonOWi`05onWYj@0AonOWiooKfm_o
RD];ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_
Bc;oRD];om_KfooWinL01OoYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K
;Om[ZbooL:dhofn^>_m`[CSoJZX_oe>K;OliR3Go<V0bod];BooKfm_oinOW
0?oojNWY2ooYjNT01_oXj>Soi^KVog]kNolL71coi>CTonSXj0;ojNWY00?o
inOWonWYjOoYjNT02ooYjNT03?oWinOojNWYonWYjOoXj>Sof=SHo`X:2_n^
[Zkog=cLomkNg_oPh>3oiNGUonSXj0SojNWY00Koj>SXonKVi_oShn?ohn?S
onKVi_oXj>P3onWYj@03onSXj?oYjNWojNWY00CojNWY00?oinOWonWYjOoY
jNT0N_oYjNT00ooXj>SojNWYonWYj@03onWYj@03onSXj?oYjNWojNWY0<Ko
jNWY00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07omoOg0Oono_h00004ookn
o_ojn_[om?Cdono_k`?ol?3`017okno_on_[jonEU9CoCb<SoiEDE?nkLg?o
diFEomZLW?oJWYcofIbLomBEUOnkLg?oUEADodlS8onEU9Coj^[Zono_k`05
oo3`l00Aono_kooZj^[oZIBDoh4S8onjJUCoe9YconBlUOoZaicojLNLon[7
W?oU_9Goe9Ycok]ZE?n18b?oZYBDon[Zj_o_knl01Oo`l?004Oo_knooj^[Z
oiBDU?lS:R?oE7YDog>ULonNaYGo[<jLojg>W?n/cYcoW/JEog>ULomDNUCo
8bXSoiBDU?oZj^[okno_0?ool?3`2oo`l?02ono_k`04oh20P?lM7Agok^k^
ono_k`Gol?3`00?okno_oo3`l?o`l?002oo`l?02ono_k`07ofATI?lY:BWo
PH61of=SHolk>c_ok^k^ono_k`08oo3`l006ono_koo^k^koLg=cofUYJOo^
k^kokno_Boo`l?02ono_koool?3`3oo`l?001?oalO7ol?3`ooCdm?ojn_X1
ooknoP0000CokNobooooooooooooo_kn0_ooool2ooknoP3ooogmoOogmoOo
KVi^oeXo?onaT93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSloofe]KOoh
n?Soo?clooooooono_koooooookno_ooookoo_knooooooolo?con?Shohe]
KOn:?coobI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo?on=KFgon?Sg
ooclo?ooooooo_knooooooono_koooooookno_ooookoo?clooShn?m]KFgo
?clooi2MT?o9eLWoi>cTonK^i_oTk>CobMG9oi2MT?lo?cooKFe]ooShn?ol
o?coooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_kn0017ooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooool00_ono_h0
6?o?clooYZJVoogmoOooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooo`;oo_kn00ko`<30og5aLOn0P83o/;2`oogmoOooooooo_knoooo
ooono_koooonookno_ooooooo_knooooo`;oo_kn0?oo`L71okfm_?omoOgo
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_h005coooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooooooknoP;ooooo00?oo_knoooooooo
ool00oooool1oo[jn`0000Coa<cCookno_ojn_[olo?c1OoalO403Oo_knoo
e]KFof][Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?CgoJf][omKFe_o_
knl02OoalO403Oo_knooemKFoh=[Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<
S?mb?CgoPF][omOFe_o_knl02OoalO403Oo_knooe]KFof][Jolm?CgoS8b<
okZj^_o<cLco^[Zjohb<S?lm?CgoJf][omKFe_o_knl0oooalO4Foo7al@03
oo3`l?oalO7olO7a017olO7a00?ol?3`oo7alOoalO40WOoalO400oo`l?3o
lO7aoo7al@34oo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00?om?Cdoo[j
n_ono_h00Oo[k^l0000EohZHXoomoOgon?Shoo3`l?o[jn_oj^[ZonWYjOoZ
j^[ojNWYon[Zj_oYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^K
VooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo@RHV
ofUIFOnPVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo
2@T9obHV9_mIFEWoVi^KonSXj?oYjNT0oooZj^XZon[ZjP03onWYjOoZj^[o
j^[Z09coj^[Z00?ojNWYon[Zj_oZj^X0cOoZj^X01?o[jn_ol?3`ooShn?om
oOd1oloBeP0000Co@E1Nokc6cOojn_[olo?c2?oalO42oo3`l0?okno_0_o`
l?0?oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`oooa
lO7ooo7alISolO7a00?ol?3`oo7alOoalO400_oalO400ooemOGon_[jonW[
k@01oi^OXP0000?o9Ca>oe5SL?nkaL`0ooooooooooooom[ooooo0Oo]ko41
ojb`]07oYjb`00001_lY@5Oo8SU<ocQ:FOn6TIgo`LS>onc^l?oooooooooo
oooDooooo`05ooSin_o/k^oodMCGoi^OXonMXjL00Onc^[l00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{734, 424},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]If[Length[lfNames] < 2, 
        Return[]]; \[IndentingNewLine]If[{} =!= \
\((javax`swing`UIManager`setLookAndFeel[
              lfNames[\([2, 1]\)]]; $MessageList)\), 
        Abort[]]; \
\[IndentingNewLine]javax`swing`SwingUtilities`updateComponentTreeUI[
        frame]; \[IndentingNewLine]btn@
        setText[lfNames[\([2, 2]\)]]; \[IndentingNewLine] (*\(frame@
            pack[];\)*) \[IndentingNewLine]JavaShow[
        frame]\[IndentingNewLine]]\)], "Input"],

Cell["CDE/Motif", "Text"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l00000o`00003oo`00003o
00000880000000000`28`;P0B92804R@R03o04R@R?l0B928OP18T8P10000000000<0R<2h0<SPf028
`;P0o`28`;So08S0^7d0R<2h0@18T8P10000000000<0R<2h0<SPf028`;P0o`28`;So08S0^7d0R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`2^//?o0:jb`gX0[[;30P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0:jb`ol0[[;3NP2^//<208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0[[;3o`2^//=j0:jb``80R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`2^//?o0:jb`gX0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0:jb`ol0[[;3
NP2^//<208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0[[;3o`2^//=j0:jb``80R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`2^//?o0:jb`gX0[[;30P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;P70:jb``030=cNi@1SIFl0HfE_0?l0HfE_o`1SIFmY06=UK`L0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;3
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3
6`2^//<3000000@0[[;31@0000040:jb``H0000000<0[[;30000002^//<00P2^//<010000000[[;3
0:jb``0000020:jb``040000002^//<0[[;30:jb``<000000`2^//<2000000050:jb``000000[[;3
0:jb``000000o`2^//<K0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;36P2^//<01@000000[[;30:jb``2^
//<0000000<0[[;300<000000:jb``2^//<00P2^//<01@000000[[;30:jb``2^//<0000000H0[[;3
00D000000:jb``2^//<0[[;3000000020:jb``040000002^//<0[[;300000080[[;300D000000:jb
``2^//<0[[;3000000020:jb``040000002^//<0[[;300000080[[;300<000000:jb``2^//<0o`2^
//<I0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028
`;P70:jb``030=cNi@2^//<0[[;30?l0[[;36@2^//<00`000000[[;30:jb``030:jb``040000002^
//<0[[;3000000D0[[;300@000000:jb``2^//<000001`2^//<02P000000[[;30:jb``000000[[;3
0000002^//<000000:jb``0000020:jb``050000002^//<0[[;30:jb``0000000P2^//<010000000
[[;30:jb``0000020:jb``030000002^//<0[[;30?l0[[;36@2^//<00`1SIFl0[[;30:jb``050:jb
``80R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h1`2^//<00`3Lg^D0[[;30:jb``3o0:jb
`aT0[[;300<000000:jb``2^//<01P2^//<00`000000[[;30:jb``030:jb``040000002^//<0[[;3
000000L0[[;300X000000:jb``2^//<000000:jb``000000[[;30000002^//<000000P2^//<01@00
0000[[;30:jb``2^//<000000080[[;300@000000:jb``2^//<000000P2^//<00`000000[[;30:jb
``3o0:jb`aT0[[;300<0HfE_0:jb``2^//<01@2^//<208S0^040B9280@000000000408S0^038h=P0
R<2h08S0^0L0[[;300<0g=kU0:jb``2^//<0o`2^//<I0:jb``030000002^//<0[[;300H0[[;300<0
00000:jb``2^//<00`2^//<00`000000[[;30:jb``0600000080[[;300X000000:jb``2^//<00000
0:jb``000000[[;30000002^//<000000P2^//<01@000000[[;30:jb``2^//<000000080[[;300@0
00000:jb``2^//<000000P2^//<00`000000[[;30:jb``3o0:jb`aT0[[;300<0HfE_0:jb``2^//<0
1@2^//<208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0L0[[;300<0g=kU0:jb``2^//<0
o`2^//<I0:jb``030000002^//<0[[;300H0[[;300<000000:jb``2^//<00`2^//<010000000[[;3
0:jb``0000070:jb``0:0000002^//<0[[;30000002^//<000000:jb``000000[[;300000080[[;3
00D000000:jb``2^//<0[[;3000000020:jb``040000002^//<0[[;300000080[[;300<000000:jb
``2^//<0o`2^//<I0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;36@2^//<00`000000[[;30:jb``030:jb
``040000002^//<0[[;3000000D0[[;300@000000:jb``2^//<000001`2^//<00`000000[[;30:jb
``02000000<0[[;30P0000030:jb``<000000P2^//<3000000030:jb``000000[[;300<00000o`2^
//<J0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028
`;P70:jb``030=cNi@2^//<0[[;30?l0[[;36P2^//<01@000000[[;30:jb``2^//<0000000<0[[;3
00<000000:jb``2^//<00P2^//<01@000000[[;30:jb``2^//<0000000P0[[;300@000000:jb``00
000000000`2^//<2000000T0[[;300<000000:jb``2^//<00`2^//<00`000000[[;30:jb``3o0:jb
`aT0[[;300<0HfE_0:jb``2^//<01@2^//<208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^0L0[[;300<0g=kU0:jb``2^//<0o`2^//<K0:jb``<00000102^//<5000000@0[[;31P0000030:jb
``030000002^//<0000000D0[[;300<000000:jb``2^//<01`2^//<010000000[[;30:jb``000003
0:jb``800000o`2^//<I0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0
[[;300D0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P70:jb``030=cNi@2^//<0
[[;30?l0[[;3o`2^//=X0:jb``0306=UK`2^//<0[[;300D0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P70:jb`ol0g=kUo`3Lg^E/0=cNi@L0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;So0:jb`ol0[[;3NP2^//<208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^?l0[[;3o`2^//=j0:jb``80R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`2^//?o
0:jb`gX0[[;30P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0:jb`ol0[[;3NP2^//<2
08S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0[[;3o`2^//=j0:jb``80R<2h0@18T8P1
0000000000@0R<2h0<SPf028`;P0R<2ho`2^//?o0:jb`gX0[[;30P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;So0:jb`ol0[[;3NP2^//<208S0^040B9280@000000000308S0^038h=P0R<2h
0?l0R<2ho`28`;Qm08S0^040B9280@000000000408S0^038h=P0R<2h08S0^1H000200`000H020002
P0040002P@000h4000>10003P@<000B10P001H4010001H8000J20006PP001X820007PP030047PP01
28800@R200800@R30`012H<3004:P`03004;P`012h@00@^400<00@b40`013H@3004>Q@<00Pn50`02
48D4008AQP<00Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP0
0aN80`0368P00`036HP00aV900<IR@0400<JR@<00a^90`0378X300<MRP<011j:0`047h/300@PR`<0
126;0`048X`400@SS00400@TS00498d012B=00@US@801BF=0`059Xd00`059hd01BN>00DWSP0300DX
SP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06;Y0200H_T00400H_T@06<9401S2A
00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06<i8200HdTP0300LdTP07=I801cFB00801cFC0`07
=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08
@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G00@02D>H00U4V009A9P02DBH0`09AIP00`09AYP0
2DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W004
00YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP<02eJN00<02eNN00]G
W`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40
100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R00803F:S0`0=Hj<300eTX`0300eUX`0=
IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW00i^
Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<0
3gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4011m[004011n[00@OZd047j]011o
[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl40166
[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0B
SK8201:>/P0301>>/P0CSk804hnb00804hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d0`0C
U;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L059^g01BK]`0DVkL301BL]`8059fg
00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<0
5ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G
[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_cH06;C00P28`;P104R@
R040000000001028`;P0b>3H08S0^028`;P40000P00309^Wl@0c@jD0<d>U00T0<d>U1P0008030001
P08000:000@000:10003P@000h4000>10`0018420005P@040005PP001X8000J20006PP8000N200<0
0@N20048PP0128800P0128<30049P`<00@Z300<00@^3004;Q0012h@00`0138@3004=Q0<00@j50`02
3hD3008@Q@@00Q660`024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN8
00<GR0035hP300<HR00300<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:0`047XX300@OR`<0
122;0`048H/300@RS0@012><00@012B<00@TS@0498d012F=0P059Hd300DVS@0300DWS@059hh01BN>
00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@00@01RnA00H`
T@06<9401S2A0`06<I4200HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB00LeTP07=I800P07
=I<300LfT`<01cNC00<01cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D300PmU@@023jF0`08
?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009A9P300U5V003
00U6V009AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:CY/300Y?W0@0
2U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN0`0;EYh00`0;
Eih02eNO00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ4035fQ0`0<GZ42
00aOX@0400aOXP0<H:80362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eSX`<03FBS00<0
3FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]YP0400i]Y`0>
KZL03VjW00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?LjT03g>Y00@0
3gBY0`0?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@047j/011n[@0@
OZd047n]0P0AOjd30160[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_0164[`030165
[`@04HJ_0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:</@0401:</P0BSK80
4Xfb01:=/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B]00CT[@00`0C
Tk@301>D]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g01BK]`<059bg
0P0DWKL0100EWKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<0
5JBj0`0FYKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm0P0G[;d301N]
_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o=P0H]<0208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^0<0002000L0VjOa0?ooo`2>N[H0YY_40;>YdP2X
WLP0/jWB0080YY_400D0_;SM0>k^m03ZjO40oooo03=3Y@050000P0<000600P000X0010000X4000>1
0003P@000h430004P@8000F100@000F20006PP001X8000J20P001h800`011h800@R20048PP020048
P`<00@V30`012X<00`012h<00@^4004;Q003004<Q0<00@f40`013XD3008?Q@<00Q2510024HH3008B
QP800Q>600@00Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<0
0aV800<IR@036HT010036XT300<KR@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<012:<1004
8h`0100498`012B=00@TS@049Hd200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZ
SP05:Xl01BZ?00<01B^?1005;8l300H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@80
1S:A00@01S:B00HcTP06<i801S>B0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07
>9<01cRD00LhU00300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1
U`08@IL0246G0`08@YL200Q3U`0400U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009
AiT300U8V@<02DVJ0`09BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YA
W@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO
100;FIl300aJX0<035^P0P0<G:00100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<
H:80362R0P0<HJ800`0=HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eV
Y0<03FNT0`0=J:D300iYY@<03VZU100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL2
00i`Y`0400m`Z00?LJP03g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?
MjX3011hZP<047V[0`0@NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]
00<04H6]0161[P0APJh00`0APZh30163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`
0P0BRK00100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0C
S[804hnb01>?/P0201>?/`<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF
]@<059Ne100DV;H301BI]P8059Zf00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P0
5Ijh01FN^0<05Inh00<05J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0F
Yk/301JX^`<05ZVl100FZ[`0100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h0
0`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`20000000P0H]<0@000000806;C0
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20000P00409^Wl@3oool0K5ZU0:nUbP80
_;SM00X0oogo0;>YdP3oool0oooo0;bhg@2GR[`0Z9g80>KVk03oool0<d>U100008030001P08000:0
00@000:10003P@000h4000>10`0018420005P@040005PP001X8000J20006PP8000N200<00@N20048
PP0128800P0128<30049P`<00@Z300<00@^3004;Q0012h@00`0138@3004=Q0<00@j50`023hD3008@
Q@@00Q660`024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN800<GR003
5hP300<HR00300<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:0`047XX300@OR`<0122;0`04
8H/300@RS0@012><00@012B<00@TS@0498d012F=0P059Hd300DVS@0300DWS@059hh01BN>00<01BR>
0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@00@01RnA00H`T@06<940
1S2A0`06<I4200HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB00LeTP07=I800P07=I<300Lf
T`<01cNC00<01cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0
UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009A9P300U5V00300U6V009
AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:CY/300Y?W0@02U2L00@0
2U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN0`0;EYh00`0;Eih02eNO
00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ4035fQ0`0<GZ4200aOX@04
00aOXP0<H:80362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eSX`<03FBS00<03FFS00eU
Y00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW
00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?LjT03g>Y00@03gBY0`0?
MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@047j/011n[@0@OZd047n]
0P0AOjd30160[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_0164[`030165[`@04HJ_
0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=
/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@301>D
]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g01BK]`<059bg0P0DWKL0
100EWKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0F
YKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm0P0G[;d301N]_@0301N^
_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o0P0H]<000`38h=P0B928
04R@R00<04R@R00300000038h=P0B92800d0B92800@0000001Rd`00H]<00b>3H3P18T8P00`000000
6;C001Rd`00208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080002000/0VjOa0?ooo`2X
WLP0oooo0;>YdP1PC9X0SWZf07QU[P2XWLP0oooo0?omo`030?ooo`0303=3Y@000800002000<00020
0`000H020002P0040002P@000h4000>10003P@<000B10P001H4010001H8000J20006PP001X820007
PP030047PP0128800@R200800@R30`012H<3004:P`03004;P`012h@00@^400<00@b40`013H@3004>
Q@<00Pn50P0248D30?ooo`800Q660`024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL0
10035XP00aN800<GR0035hP300<HR00300<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:0`04
7XX300@OR`<0122;0`048H/300@RS0@012><00@012B<00@TS@0498d012F=0P059Hd300DVS@0300DW
S@059hh01BN>00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@
00@01RnA00H`T@06<9401S2A0`06<I4200HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB00Le
TP07=I800P07=I<300LfT`<01cNC00<01cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D300Pm
U@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009
A9P300U5V00300U6V009AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:
CY/300Y?W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN
0`0;EYh00`0;Eih02eNO00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ40
35fQ0`0<GZ4200aOX@0400aOXP0<H:80362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eS
X`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]
YP0400i]Y`0>KZL03VjW00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?
LjT03g>Y00@03gBY0`0?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@0
47j/011n[@0@OZd047n]0P0AOjd30160[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_
0164[`030165[`@04HJ_0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:</@04
01:</P0BSK804Xfb01:=/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B
]00CT[@00`0CTk@301>D]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g
01BK]`<059bg0P0DWKL0100EWKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0E
X[T301FS^P<05JBj0`0FYKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm
0P0G[;d301N]_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o
0P0H]<000`38h=P0R<2h08S0^00;08S0^00304R@R0000000b>3H00d0R<2h00D0B9280000000H]<00
6;C00<SPf00=08S0^00404R@R00000006;C001Rd`080R<2h0@18T8P10000000000@0R<2h0<SPf028
`;P0R<2h0P0008003P2KYo40oooo0?ooo`3Kg>`0H4bJ09>5^P2cZM80_;SM061<VP2ISkh0YY_40<S3
g`3oool0<d>U1P0008030?ooo`8000:000<000:10?ooo`3oool00P3oool20004P@030005P@3oool0
00F200<000J2103oool00`0128800@R30?ooo`030?ooo`<00@Z300H0oooo004;Q0012h@00@b40?oo
o`0138@2004=Q0040?ooo`013XD0oooo004>Q@800Pn500@0oooo008@Q@3oool00Q250P024HH00`3o
ool00Q66008BQP02008BQP800Q>600@00Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR0035hP0
0aN800<GR0<00aR800<00aV800<IR@036HT010036XT300<KR@<00ab:0`037HX300@NRP<011n;0`04
88/300@QR`<012:<10048h`0100498`012B=00@TS@049Hd200DUS@<01BJ=00<01BN=00DWSP059hh0
0`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?1005;8l300H]T0<01Rj@0P06;i001006;i401S2A
00H`T@06<94300HaT@801S:A00@01S:B00HcTP06<i801S>B0P06=9800`07=9801cFB00LeTP0200Le
T`<01cJC0`07=i<00`07>9<01cRD00LhU00300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300Po
UP80242F00@0242G00Q1U`08@IL0246G0`08@YL200Q3U`0400U3V009A9P02DBH00U4V0<02DFH00<0
2DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:
D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh300]FWP0300]G
WP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P0P0<G:00100<G:4035fQ00aMX@0<GJ4300aNX@80
35nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=
IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iYY@<03VZU100>JjH300i/YP803VfV00@03VfW00i^
Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP03g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?
M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]011n
[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh00`0APZh30163[P030164[P0AQ:l04HB_00<04HF_
100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0B
SK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?/`<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C
]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI]P8059Zf00@059Zg01BK]`0DVkL059^g0`0DW;L2
01BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<05J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0E
Y;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100FZ[`0100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm
00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0040<SP
f028`;P0R<2h08S0^0H000001028`;P00`18T8P000000<SPf00208S0^0T000000P28`;P01@18T8P0
000001Rd`00H]<00b>3H00d0R<2h00@0B9280000000H]<006;C00P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P30000P00>09^Wl@3oool0_;SM09V?_P3oool0e]7M0=_Lk03co_l0YY_40>k^
m025M[00ThFj0?ooo`0c@jD40000P0070?ooo`000H0000600001P03oool000:00?ooo`030003P@06
0?ooo`00184000B10005P@3oool000F20P001X80203oool000N20007PP011h80oooo0048PP3oool0
0@R30`012H<0103oool00@Z3004:P`3oool2004;Q003004<Q03oool00@b400800@f400@0oooo004>
Q@3oool00@j50P023hD00`3oool00Q250?ooo`030?ooo`800Q660`024XH2008CQP04008CQ`0258L0
0QB7008DQ`<00QF70P025XL010035XP00aN800<GR0035hP300<HR00300<IR0036HT00aV900@00aZ9
0`036hT300<LRP<00af:0`047XX300@OR`<0122;0`048H/300@RS0@012><00@012B<00@TS@0498d0
12F=0P059Hd300DVS@0300DWS@059hh01BN>00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@0
1Bb?0`06;I0300H^T0801Rn@00@01RnA00H`T@06<9401S2A0`06<I4200HbT@0400HbTP06<i801S>B
00HcTP801SBB00<01cBB00LeTP07=I800P07=I<300LfT`<01cNC00<01cRC00LhU007>9@00`07>I@3
00LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08
@iL01009@iP02DBH00U4V009A9P300U5V00300U6V009AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ
0`0:BiX300Y<V`<02TfK0`0:CY/300Y?W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@03
00]DW@0;E9h02eBN00<02eFN0`0;EYh00`0;Eih02eNO00]GW`0300]HW`@02eVO0`0<FZ0300aKX080
35bP00@035bQ00aMX@0<GJ4035fQ0`0<GZ4200aOX@0400aOXP0<H:80362R00aPXP80366R00<03F6R
00eRXP0=HZ800P0=HZ<300eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD3
00iZY@@03V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW00i^Y`<03VnW0P0>L:L0100?L:P03g6X00ma
Z00?LJP300mbZ00300mcZ00?LjT03g>Y00@03gBY0`0?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[
0`0@Nj/3011l[0@047f/00@047j/011n[@0@OZd047n]0P0AOjd30160[@030161[@0APJh04H6^00<0
4H:^0`0APjh00`0AQ:h04HB_0164[`030165[`@04HJ_0`0BQk0301:8/0804XV`00@04XVa01::/@0B
R[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb00<04hjb01>?/P0CSk800P0CSk<3
01>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@301>D]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH2
01BJ]P0401BJ]`0DVkL059^g01BK]`<059bg0P0DWKL0100EWKP05Ijh01FN^00EW[P301FO^00301FP
^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0FYKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl
00@05Z^l01J[_@0FZkd05Zbm0P0G[;d301N]_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh0
5k6o01Na_`0301Nb_`<05k>o0P0H]<001038h=P0R<2h08S0^028`;P6000000@0R<2h00<0B9280000
0038h=P00P28`;P00`000000R<2h08S0^00508S0^00500000028`;P0R<2h04R@R00000000P0H]<00
1038h=P0R<2h08S0^028`;P2000000@0R<2h0P00000208S0^00404R@R00000006;C001Rd`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0`0008003`2KYo40oooo09V?_P2GR[`0e=?X0>n/
/`3oMW/0kYn[05]HY@2VVl@0UYoB061<VP2l^=d0oooo03=3Y@030000P0070?ooo`000H0000600001
P03oool000:00?ooo`030003P@060?ooo`00184000B10?ooo`001H40oooo0P001X80203oool000N2
0007PP011h80oooo0048PP3oool00@R30`012H<02@3oool00@Z30?ooo`012h<0oooo004;Q03oool0
0@b40?ooo`02004=Q0040?ooo`013XD0oooo004>Q@800Pn500@0oooo008@Q@3oool00Q2510024HH3
008BQP800Q>600@00Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<00aR8
00<00aV800<IR@036HT010036XT300<KR@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<012:<
10048h`0100498`012B=00@TS@049Hd200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP03
00DZSP05:Xl01BZ?00<01B^?1005;8l300H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<94300Ha
T@801S:A00@01S:B00HcTP06<i801S>B0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<0
0`07>9<01cRD00LhU00300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G
00Q1U`08@IL0246G0`08@YL200Q3U`0400U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT0
1009AiT300U8V@<02DVJ0`09BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M
00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<0
2eRO100;FIl300aJX0<035^P0P0<G:00100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aP
XP0<H:80362R0P0<HJ800`0=HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY003
00eVY0<03FNT0`0=J:D300iYY@<03VZU100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>
KjL200i`Y`0400m`Z00?LJP03g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ
0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<0
4H2]00<04H6]0161[P0APJh00`0APZh30163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<0
4XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[80
0`0CS[804hnb01>?/P0201>?/`<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD3
01BF]@<059Ne100DV;H301BI]P8059Zf00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00E
W[P05Ijh01FN^0<05Inh00<05J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk
0`0FYk/301JX^`<05ZVl100FZ[`0100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G
[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0030<SPf028`;P0R<2h00/0
R<2h00<0B92800000038h=P00P28`;P00`000000R<2h08S0^00508S0^00500000028`;P0R<2h04R@
R00000000P0H]<000`38h=P0R<2h08S0^00208S0^08000000P28`;P2000000<0R<2h00@0B9280000
000H]<006;C00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20000P00:09^Wl@3oool0
UhZl07Y/ZP2canP0ZFjP0<S3g`2CQKX0FdJC09V?_P80N6F^00@0@RN50:nUbP3oool0<d>U10000803
0001P0030?ooo`000X0000:100@0oooo0P0018400`3oool000F10?ooo`030006PP@0oooo00<00@R2
0048P`0128<00`012H<02@3oool00@Z30?ooo`012h<0oooo004;Q03oool00@b40?ooo`02004=Q004
0?ooo`013XD0oooo004>Q@800Pn500<0oooo008@Q@3oool00`3oool2008AQP<00Q:60P024hH01002
4hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV900<I
R@0400<JR@<00a^90`0378X300<MRP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@TS004
98d012B=00@US@801BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl0
0`05:hl400D/S`<01Rf@0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y80
1S>B00HcTP06<i8200HdTP0300LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD
00<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL3
00Q2U`8024>G00@02D>H00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09
BIX300U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M
0`0;Did00`0;E9d02eBN00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP
0`0<Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQ
XP0300eQXP0=HZ803F:R00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eX
Y@<03VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X
00maZ00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@
NJ/3011jZ`<047^[0`0@O:`4011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^
0161[P030162[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9
/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb
00804hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH
]P<059Vf0P0DV[H0100DV[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0E
WkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0F
ZK`401JZ_00401J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n
00<05k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C000<0b>3H08S0^028`;P02`28`;P00`18T8P00000
0<SPf00208S0^00300000028`;P0R<2h00D0R<2h00D0000008S0^028`;P0B9280000000201Rd`003
0<SPf028`;P0R<2h00<0R<2h1000000408S0^00404R@R00000006;C001Rd`080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2h0P0008000`2KYo40oooo0?ooo`020?ooo`0:0?n]/03oMW/0nLgD
0?g]kP3oool0YY_408Ef/02l^=d0oooo03=3Y@D000200`000H000`3oool000:00002P@030003P@03
0?ooo`001840oooo008000F100@000F20?ooo`001X8000J20P001h800`011h80oooo0048PP020048
P`<0oooo0P012X<01`3oool00@^30?ooo`012h@0oooo004<Q03oool00P013H@0103oool00@j50?oo
o`3oool2008?Q@060?ooo`0248D0oooo008@Q@024HH0oooo0P024HH3008BQP800Q>600@00Q>7008D
Q`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<00aV800<IR@036HT01003
6XT300<KR@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<012:<10048h`0100498`012B=00@T
S@049Hd200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?
1005;8l300H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@801S:A00@01S:B00HcTP06
<i801S>B0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD00LhU00300Li
U0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL2
00Q3U`0400U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09
BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M
00<02eBM00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P
0P0<G:00100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=
HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iY
Y@<03VZU100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP0
3g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@
NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh0
0`0APZh30163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa
01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?
/`<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI
]P8059Zf00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<0
5J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100F
Z[`0100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na
_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0030<SPf028`;P0R<2h00/0R<2h00<0B92800000038h=P0
0P28`;P00`000000R<2h08S0^00508S0^00500000028`;P0R<2h04R@R00000000P0H]<000`38h=P0
R<2h08S0^00408S0^08000001@28`;P01018T8P0000001Rd`00H]<0208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^0<0002000X0XJcb0?W=e03R9S`0m;Fo0>8V?03dKGd0o>?Y0?ooo`3mkNh0
ojf`0P3oool00`0c@jD000200000P0040000P0<0006000<0oooo0002P0000X400`3oool20004P@05
0?ooo`001H4000F10005PP3oool00P001X830?ooo`800@R200<00@R30?ooo`012H<00P012H<2004:
P`040?ooo`012h<00@^40?ooo`800@b400L0oooo004=Q0013H@0oooo004>Q@3oool00@j50080oooo
00<00Pn5008@Q@0248D0103oool010024HH00Q:6008BQP024XH2008CQP04008CQ`0258L00QB7008D
Q`<00QF70P025XL010035XP00aN800<GR0035hP300<HR00300<IR0036HT00aV900@00aZ90`036hT3
00<LRP<00af:0`047XX300@OR`<0122;0`048H/300@RS0@012><00@012B<00@TS@0498d012F=0P05
9Hd300DVS@0300DWS@059hh01BN>00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06
;I0300H^T0801Rn@00@01RnA00H`T@06<9401S2A0`06<I4200HbT@0400HbTP06<i801S>B00HcTP80
1SBB00<01cBB00LeTP07=I800P07=I<300LfT`<01cNC00<01cRC00LhU007>9@00`07>I@300LjU0<0
1c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009
@iP02DBH00U4V009A9P300U5V00300U6V009AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX3
00Y<V`<02TfK0`0:CY/300Y?W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;
E9h02eBN00<02eFN0`0;EYh00`0;Eih02eNO00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@0
35bQ00aMX@0<GJ4035fQ0`0<GZ4200aOX@0400aOXP0<H:80362R00aPXP80366R00<03F6R00eRXP0=
HZ800P0=HZ<300eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@0
3V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP3
00mbZ00300mcZ00?LjT03g>Y00@03gBY0`0?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3
011l[0@047f/00@047j/011n[@0@OZd047n]0P0AOjd30160[@030161[@0APJh04H6^00<04H:^0`0A
Pjh00`0AQ:h04HB_0164[`030165[`@04HJ_0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[404XZa
0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<0
4i6c00<04i:c01>B]00CT[@00`0CTk@301>D]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P04
01BJ]`0DVkL059^g01BK]`<059bg0P0DWKL0100EWKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T0
5J2i00@05J6i0`0EX[T301FS^P<05JBj0`0FYKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l
01J[_@0FZkd05Zbm0P0G[;d301N]_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na
_`0301Nb_`<05k>o0P0H]<000`38h=P0R<2h08S0^00;08S0^00304R@R0000000b>3H0080R<2h00<0
000008S0^028`;P01@28`;P01@000000R<2h08S0^018T8P0000000806;C000<0b>3H08S0^028`;P0
0`28`;P4000000@0R<2h00@0B9280000000H]<006;C00P28`;P104R@R040000000001028`;P0b>3H
08S0^028`;P20000P00=09^Wl@3mkNh0hRHl0?ken03gRIL0m69^0?>P[P3dHVh0oogo0?n]/03lhnT0
oooo03=3Y@070000P0<0006000<0oooo0002P0000X400`000h430004P@8000F100@000F20006PP00
1X8000J20P001h801@011h800@R20048PP3oool00@R300<00@V30`012X<00`012h<00@^4004;Q003
004<Q0<00@f40`013XD3008?Q@<00Q2510024HH3008BQP800Q>600@00Q>7008DQ`0258L00QB70`02
5HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<00aV800<IR@036HT010036XT300<KR@<00ab:
0`037HX300@NRP<011n;0`0488/300@QR`<012:<10048h`0100498`012B=00@TS@049Hd200DUS@<0
1BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?1005;8l300H]T0<0
1Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@801S:A00@01S:B00HcTP06<i801S>B0P06=980
0`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD00LhU00300LiU0<01cZD0`07>iD3
00PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL200Q3U`0400U3V009
A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09BYX300Y;VP<02TbK
0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;
E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P0P0<G:00100<G:40
35fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=HJ803F:R00eRXP02
00eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iYY@<03VZU100>JjH3
00i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP03g6X00maZ0<03g:X
00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`<047b/
100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh00`0APZh30163[P03
0164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;
/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?/`<04i2c0`0CTK<0
0`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI]P8059Zf00@059Zg
01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<05J2h01FP^@0EX;T0
100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100FZ[`0100FZk`05Z^m
01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<0
5k:o0`0G/kl201Rd`0030<SPf028`;P0R<2h00/0R<2h00<0B92800000038h=P00P28`;P00`000000
R<2h08S0^00508S0^00500000028`;P0R<2h04R@R00000000P0H]<000`38h=P0R<2h08S0^00208S0
^08000000P28`;P2000000<0R<2h00@0B9280000000H]<006;C00P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P20000P00309^Wl@3fb<`0hRHl0080ojf`00L0gb@^0?nTWP3f_<D0ojf`0>ik
S03oool0<d>U00P000200`000H000`3oool000:00002P@030003P@<000B10P001H4010001H8000J2
0006PP001X820007PP050047PP0128800@R20?ooo`0128<00`012H<0103oool00@Z3004:P`012h<2
004;Q0<00@b40`013H@3004>Q@<00Pn50`0248D4008AQP<00Q:60P024hH010024hL00QB7008DQ`02
58L3008EQ`800QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV900<IR@0400<JR@<00a^9
0`0378X300<MRP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@TS00498d012B=00@US@80
1BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/S`<0
1Rf@0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06<i82
00HdTP0300LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07>Y@3
00LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G00@0
2D>H00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<02T^J
0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d0
2eBN00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aLX004
00aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=HZ80
3F:R00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD4
00i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP03g6X
0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[
0`0@O:`4011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162[P<0
4H>^00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa01::
/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc0`0CT;<3
01>A/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0
100DV[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i
01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_00401J[
_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G
/Kl00`0G/[l301Nc_`806;C000<0b>3H08S0^028`;P02`28`;P00`18T8P000000<SPf00208S0^0T0
00000P28`;P01@18T8P0000001Rd`00H]<00b>3H00<0R<2h0P00000408S0^08000000P28`;P01018
T8P0000001Rd`00H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080002000<0VjOa
0?W=e03gRIL00P3oool01`3o[K00hAHd0?mfN`3oY9h0hRHl0?n9O`0c@jD0200008030001P0030?oo
o`000X0000:100<000>10`0018420005P@040005PP001X8000J20006PP8000N200@00@N20048PP01
28800@R3103oool3004:P`03004;P`012h@00@^400<00@b40P013H@0103oool00@j5004>Q@013XD3
008?Q@<00Q2510024HH3008BQP800Q>600@00Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR003
5hP00aN800<GR0<00aR800<00aV800<IR@036HT010036XT300<KR@<00ab:0`037HX300@NRP<011n;
0`0488/300@QR`<012:<10048h`0100498`012B=00@TS@049Hd200DUS@<01BJ=00<01BN=00DWSP05
9hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?1005;8l300H]T0<01Rj@0P06;i001006;i40
1S2A00H`T@06<94300HaT@801S:A00@01S:B00HcTP06<i801S>B0P06=9800`07=9801cFB00LeTP02
00LeT`<01cJC0`07=i<00`07>9<01cRD00LhU00300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH3
00PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL200Q3U`0400U3V009A9P02DBH00U4V0<02DFH
00<02DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL
100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh300]FWP03
00]GWP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P0P0<G:00100<G:4035fQ00aMX@0<GJ4300aN
X@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<0
0`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iYY@<03VZU100>JjH300i/YP803VfV00@03VfW
00i^Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP03g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0
100?M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]
011n[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh00`0APZh30163[P030164[P0AQ:l04HB_00<0
4HF_100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=
/P0BSK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?/`<04i2c0`0CTK<00`0CT[<04i:d01>B]003
01>C]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI]P8059Zf00@059Zg01BK]`0DVkL059^g0`0D
W;L201BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<05J2h01FP^@0EX;T0100EXKT301FR^@<05J>j
0`0EY;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100FZ[`0100FZk`05Z^m01J[_@0F[;d201N/_@<0
5jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`003
0<SPf028`;P0R<2h00/0R<2h00<0B92800000038h=P00P28`;P900000080R<2h00D0B9280000000H
]<006;C00<SPf00=08S0^00404R@R00000006;C001Rd`080R<2h0@18T8P10000000000@0R<2h0<SP
f028`;P0R<2h0P0008001`2KYo40oooo0?>P[P3dHVh0oooo0?N9U`3icM@00P3oool00`3cX:h0oooo
03=3Y@080000P0<000600P000X0010000X4000>10003P@000h430004P@8000F100@000F20006PP00
1X8000J20P001h800`011h800@R20048PP020048P`<00@V30`012X<00`012h<00@^4004;Q003004<
Q0<00@f40`013XD3008?Q@<00Q2510024HH3008BQP800Q>600@00Q>7008DQ`0258L00QB70`025HL2
008FQ`0400<FR0035hP00aN800<GR0<00aR800<00aV800<IR@036HT010036XT300<KR@<00ab:0`03
7HX300@NRP<011n;0`0488/300@QR`<012:<10048h`0100498`012B=00@TS@049Hd200DUS@<01BJ=
00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?1005;8l300H]T0<01Rj@
0P06;i001006;i401S2A00H`T@06<94300HaT@801S:A00@01S:B00HcTP06<i801S>B0P06=9800`07
=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD00LhU00300LiU0<01cZD0`07>iD300Pl
U@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL200Q3U`0400U3V009A9P0
2DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09BYX300Y;VP<02TbK0`0:
CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h0
0`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P0P0<G:00100<G:4035fQ
00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=HJ803F:R00eRXP0200eR
X`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iYY@<03VZU100>JjH300i/
YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP03g6X00maZ0<03g:X00<0
3g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`<047b/100@
OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh00`0APZh30163[P030164
[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;/@80
4Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?/`<04i2c0`0CTK<00`0C
T[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI]P8059Zf00@059Zg01BK
]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<05J2h01FP^@0EX;T0100E
XKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100FZ[`0100FZk`05Z^m01J[
_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o
0`0G/kl201Rd`0030<SPf028`;P0R<2h00/0R<2h00<0B92800000038h=P03@28`;P01@18T8P00000
01Rd`00H]<00b>3H00d0R<2h00@0B9280000000H]<006;C00P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;P30000P00;09^Wl@3oool0ohUo0?ooo`3cX:h0lI>Q0?ooo`3ooOl0lj2^0?oko00c
@jD0200008030001P08000:000@000:10003P@000h4000>10`0018420005P@040005PP001X8000J2
0006PP8000N200<00@N20048PP0128800P0128<30049P`<00@Z300<00@^3004;Q0012h@00`0138@3
004=Q0<00@j50`023hD3008@Q@@00Q660`024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P02
5XL010035XP00aN800<GR0035hP300<HR00300<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:
0`047XX300@OR`<0122;0`048H/300@RS0@012><00@012B<00@TS@0498d012F=0P059Hd300DVS@03
00DWS@059hh01BN>00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T080
1Rn@00@01RnA00H`T@06<9401S2A0`06<I4200HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB
00LeTP07=I800P07=I<300LfT`<01cNC00<01cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D3
00PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4
V009A9P300U5V00300U6V009AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK
0`0:CY/300Y?W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<0
2eFN0`0;EYh00`0;Eih02eNO00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<
GJ4035fQ0`0<GZ4200aOX@0400aOXP0<H:80362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<3
00eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H2
00i]YP0400i]Y`0>KZL03VjW00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mc
Z00?LjT03g>Y00@03gBY0`0?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/
00@047j/011n[@0@OZd047n]0P0AOjd30160[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h0
4HB_0164[`030165[`@04HJ_0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:<
/@0401:</P0BSK804Xfb01:=/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c
01>B]00CT[@00`0CTk@301>D]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL0
59^g01BK]`<059bg0P0DWKL0100EWKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i
0`0EX[T301FS^P<05JBj0`0FYKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd0
5Zbm0P0G[;d301N]_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<0
5k>o0P0H]<0?0<SPf00300000038h=P0b>3H00d0b>3H00<0000001Rd`00H]<003`38h=P00`000000
6;C001Rd`00208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0@000200`2KYo401P3oool0
lj2^0?Be_`3f_<D0nmWJ03=3Y@T000200`000H020002P0040002P@000h4000>10003P@<000B10P00
1H4010001H8000J20006PP001X820007PP030047PP0128800@R200800@R30`012H<3004:P`03004;
P`012h@00@^400<00@b40`013H@3004>Q@<00Pn50`0248D4008AQP<00Q:60P024hH010024hL00QB7
008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV900<IR@0400<J
R@<00a^90`0378X300<MRP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@TS00498d012B=
00@US@801BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl4
00D/S`<01Rf@0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B00Hc
TP06<i8200HdTP0300LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD
0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`80
24>G00@02D>H00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:
VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did0
0`0;E9d02eBN00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj02
00aLX00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQ
XP0=HZ803F:R00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU
0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?
LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011j
Z`<047^[0`0@O:`4011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P03
0162[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0BR[40
4XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc
0`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf
0P0DV[H0100DV[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0E
X;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ
_00401J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n
01Na_`0G/Kl00`0G/[l301Nc_cH06;C00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;PF
0000P0<000600P000X0010000X4000>10003P@000h430004P@8000F100@000F20006PP001X8000J2
0P001h800`011h800@R20048PP020048P`<00@V30`012X<00`012h<00@^4004;Q003004<Q0<00@f4
0`013XD3008?Q@<00Q2510024HH3008BQP800Q>600@00Q>7008DQ`0258L00QB70`025HL2008FQ`04
00<FR0035hP00aN800<GR0<00aR800<00aV800<IR@036HT010036XT300<KR@<00ab:0`037HX300@N
RP<011n;0`0488/300@QR`<012:<10048h`0100498`012B=00@TS@049Hd200DUS@<01BJ=00<01BN=
00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?1005;8l300H]T0<01Rj@0P06;i00
1006;i401S2A00H`T@06<94300HaT@801S:A00@01S:B00HcTP06<i801S>B0P06=9800`07=9801cFB
00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD00LhU00300LiU0<01cZD0`07>iD300PlU@<023fE
1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL200Q3U`0400U3V009A9P02DBH00U4
V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09BYX300Y;VP<02TbK0`0:CI/300Y>
V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh3
00]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P0P0<G:00100<G:4035fQ00aMX@0<
GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=HJ803F:R00eRXP0200eRX`<03F>S
0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iYY@<03VZU100>JjH300i/YP803VfV
00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP03g6X00maZ0<03g:X00<03g>X00mc
Z@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`<047b/100@OJ`0100@
OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh00`0APZh30163[P030164[P0AQ:l0
4HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;/@804Xba00@0
4Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?/`<04i2c0`0CTK<00`0CT[<04i:d
01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI]P8059Zf00@059Zg01BK]`0DVkL0
59^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<05J2h01FP^@0EX;T0100EXKT301FR
^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100FZ[`0100FZk`05Z^m01J[_@0F[;d2
01N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/klf
01Rd`080R<2h0@18T8P10000000000<0R<2h0<SPf028`;P0o`28`;So08S0^7d0R<2h0@18T8P10000
000000<0R<2h0<SPf028`;P0o`28`;So08S0^7d0R<2h0@18T8P10000000000<0R<2h0<SPf038h=P0
o`38h=So0<SPf7d0b>3H0@18T8P100000000o`28`;So08S0^840R<2h0@0000000001\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;N0001Z2000`400?l0
0000o`00003oooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`l?000?oo
l?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?ool?3`h?o`
l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003ooo3`l?oo
l?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3ol?3`003o
oo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000ooo`l?3ooo3`l>3o
l?3`003ooo3`l?ool?3`h?o`l?000?ool?3`ooo`l?3Poo3`l000oon^//?o
ojjb`n3o[[;3003oojjb`ooo[[;3h?n^//<00?oo[[;3oon^//?Pojjb``00
oon^//?oojjb`n3o[[;3003oojjb`ooo[[;3h?n^//<00?oo[[;3oon^//?P
ojjb``00oon^//?oojjb`n3o[[;30007ojjb``03omcNiOmSIFooHfE_0?oo
HfE_oomSIFo?of=UK`Oo[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3
oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^
//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007
ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o
[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb
``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo
[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcN
iOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;3
0007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^
//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>
ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;3
0?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03
omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go
[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=U
Kon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^
//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o
[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb
``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;3
00Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03
of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3
oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^
//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007
ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o
[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb
``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo
[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcN
iOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;3
0007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^
//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>
ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;3
0?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03
omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go
[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=U
Kon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^
//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o
[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb
``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;3
00Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03
of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3
oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^
//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007
ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o
[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb
``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo
[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcN
iOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;3
0007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^
//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>
ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;3
0?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03
omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go
[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=U
Kon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^
//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o
[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb
``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;3
00Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03
of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3
oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^
//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007
ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o
[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb
``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo
[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcN
iOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;3
0007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^
//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>
ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;3
0?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03
omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go
[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=U
Kon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^
//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o
[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb
``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;3
00Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03
of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3
oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^
//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007
ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o
[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb
``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo
[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcN
iOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;3
0007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^
//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>
ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;3
0?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03
omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go
[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=U
Kon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^
//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o
[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb
``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;3
00Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03
of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3
oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^
//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007
ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o
[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb
``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo
[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcN
iOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;3
0007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^
//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>
ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;3
0?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03
omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go
[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=U
Kon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^
//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o
[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb
``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;3
00Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03
of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3
oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^
//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007
ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o
[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb
``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo
[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcN
iOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;3
0007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^
//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>
ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;3
0?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03
omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go
[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=U
Kon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^
//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o
[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb
``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;3
00Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03
of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3
oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^
//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007
ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o
[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb
``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo
[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcN
iOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;3
0007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^
//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>
ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;3
0?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03
omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go
[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=U
Kon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^
//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o
[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb
``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;3
00Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03
of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3
oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^
//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007
ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o
[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb
``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo
[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcN
iOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;3
0007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^
//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>
ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;3
0?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03
omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go
[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=U
Kon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^
//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o
[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb
``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;3
00Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03
of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3
oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^
//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007
ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o
[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb
``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo
[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcN
iOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;3
0007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^
//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>
ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;3
0?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03
omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go
[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=U
Kon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^
//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o
[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb
``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;3
00Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03
of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3
oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^
//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007
ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o
[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb
``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo
[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcN
iOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;3
0007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^
//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>
ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;3
0?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03
omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go
[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=U
Kon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^
//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o
[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb
``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;3
00Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03
of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3
oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^
//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007
ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o
[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb
``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo
[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcN
iOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;3
0007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^
//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>
ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;3
0?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03
omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go
[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=U
Kon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3oon^
//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcNiOn^//?o
[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb
``03omcNiOn^//?o[[;30?oo[[;3oon^//?>ojjb``03of=UKon^//?o[[;3
00Go[[;30007ojjb``03omcNiOn^//?o[[;30?oo[[;3H_n^//<00om=CUKo
VYj]ojjb``3oojjb`fWo[[;300?oHfE_ojjb`on^//<01On^//<000Oo[[;3
00?og=kUojjb`on^//<0oon^//=<ojjb``03oj^__onCUZGoXZJf01?o[[;3
00?oEeUQofMYLon^//<03on^//<00onMXK3oZZjoojjb``03ojjb``03ojZ^
_onQY;Co[[;30?oo[[;3DOn^//<00omSIFoo[[;3ojjb``05ojjb``001on^
//<00ooLg^Go[[;3ojjb``3oojjb`d[o[[;300koYj^lode>E_l61PKo6a`O
oaDE5olN7b;oJ6Yeojjb`olD51Ko20T9o`d=3ol?417o:R/_og]nRP?o[[;3
00?o51@Fo`P92Ol=3@l00_l=3@l01?n;SYco[[;3oh^?W?lb<cP4ojjb``05
oa@D5_n?Tj7o[[;3oh>6TomfNHD00_n^//<02?l<3@koQhZHojjb`on3QY;o
4a<EoaTI7?l61POoDUAL0_n^//<02OmlOh_o4A4CobLX;?n^//?o6Q/MogQk
Qon^//?o@498oe5CF`3oojjb`dco[[;300?oHfE_ojjb`on^//<01On^//<0
00Oo[[;300?og=kUojjb`on^//<0oon^//=:ojjb``03odI7C_lE5QSoSi:P
00;o[[;300[oSi>Qoh23T?n^//?o51@Fog5cO_n^//?oZJfnogf0S?l@41;o
IfYd0_n^//<00olD51KoLG=nojjb``04ojjb``03ojfa`_lG5a[oYj^k00?o
[[;301?o51@FohnCXOn^//?o6a`Oo`H61_nTZ;So[[;3o``=3_n7RYSoYJVi
o`l@4OmRIFko[[;3oiZM[?l=3@ooM7N2ojjb`old=C[oF5YS00;o[[;300Go
6Q/MogQkQon^//?o@498oe5CF`3oojjb`dco[[;300?oHfE_ojjb`on^//<0
1On^//<000Oo[[;300?og=kUojjb`on^//<0oon^//=9ojjb``03oi^O[_l1
0@7oN7Z600Ko[[;300?o51@Fog5cO_n^//<00_n^//<01_mIFfCo2P/<ojFX
^On^//?o51@Fog5cOPKo[[;300?oADM>ogQjQ_n^//<00_n^//<03?lD51Ko
Si>Qohb?WOl410Go?d17ofU/M_n^//?o30d>ohN:V?n3QY;o0@41oj:V]P;o
[[;300Go>3Tood93B_n^//?o8R<Wog1cOP02ojjb``05oaXK7OmhNhOo[[;3
od12B?mADe/0oon^//=<ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb
``03omcNiOn^//?o[[;30?oo[[;3BOn^//<00omnPHko0000ojR/_006ojjb
``03oa@D5_maLgko[[;300;o[[;300KoRhnLo`000?n7RYOo[[;3oa@D5_ma
Lgh6ojjb``03ogYlR?m3AD_o[[;300;o[[;300co51@FohnCXOm>D5Oo>3To
ohZ=VolY:Rko[[;3o``=3_n7RYSoNWb8o`L72?n[[l02ojjb``05odM9D?li
>T3o[[;3ob8S9om`Lgh00_n^//<01OlJ6agoN7^7ojjb`om0@TSoDE=K0?oo
[[;3C?n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3
ojjb``3oojjb`dWo[[;300?oLG=no`D51_nZ[[l01_n^//<00olD51KoLG=n
ojjb``02ojjb``06ojZ^_ol20P;oLWF0ojjb`olD51Ko2PX;0_l?41401oma
M7oo[[;3ojjb`on^//?oYj^loaHG6On]/L800_n^//<03?lD51KoSI6Ooa4A
4omfNHGo[[;3oa`M8?nFVZWo30d>ohN:V?nHW:_o0@41ohZ=V`;o[[;300Go
7QhQoeYLI?n^//?o8R<Wog1cOP02ojjb``05oaXK7OmhNhOo[[;3od12B?mA
De/0oon^//=<ojjb``03of=UKon^//?o[[;300Go[[;30007ojjb``03omcN
iOn^//?o[[;30?oo[[;3BOn^//<00on7RYSo0000oh64T@06ojjb``03oa@D
5_maLgko[[;300;o[[;300KoP8>@o`000?n4QiCo[[;3oa@D5_maLgh7ojjb
``0Poc@e>_n9SI[o[[;3ojjb`olD51KoHF=]o`/;3OnY[Kko[[;3oeaNIomG
FF7o30d>ohN:V?n^//?oDE=Koa@D5_mHFV?o;c0doa/K7_nTZ;SoNWb8oa4A
4olg>3goEUQQojb``OlJ6agoN7^7ogn2SolP82?o:2T]oeIHHOnSYkOoojjb
`d[o[[;300?oHfE_ojjb`on^//<01On^//<000Oo[[;300?og=kUojjb`on^
//<0oon^//=9ojjb``03ojJZ^_l?417oCe5I00Ko[[;300?o51@Fog5cO_n^
//<00_n^//<01_m7BE3o3a0AojJZ^_n^//?o51@Fog5cOPOo[[;300OoJF]e
oeEGGon^//?o[[;3oa@D5_lS92OoA4I=00;o[[;300CoVYj]oaPI6ol<30go
QhZH0_n^//<04On3QY?oGf5[ofmbOOnWZk_o[[;3ohR;V?lE5QSoAdU@ofia
Non]/L;oN7^7oiZN[On<Sigo:2T]oc<e>_m^LG_oYZZj0?oo[[;3B_n^//<0
0omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb
`d[o[[;300ooLG=no`P92OmWJWCoVin^oiZM[?mfNHGoLGAoojjb`olD51Ko
EEMOogn2Som^LG_o@457o`P92OmhNXH00_n^//<01OlD51KoEEMOoh>6T_n3
QY;oQ8ND00Co[[;300OoW9n_ob4R9On^//?o[[;3oa@D5_l0003oPhJC00?o
[[;300?o;Rldo`000?n7RYP02?n^//<02OmPHfcoR8^Hojjb`on^//?oIfUc
oiBGYOn^//?oE5INodM9D03oojjb`dco[[;300?oHfE_ojjb`on^//<01On^
//<000Oo[[;300?og=kUojjb`on^//<0oon^//=;ojjb``08ohR;V?lk?4;o
7QlRob8R9_lj>d7oLWF0ojjb`om6B4l2ocPi?`03odA6COmLGVSoUYVX00?o
[[;300GoATQ?ocPi?olh>Coo>3ToocdnA005ojjb``05od]=E?nWZk_o[[;3
odI8Com0@TP01?n^//<00omlOh_o>3TooiBGY@0<ojjb``07od]<E?n9SI[o
[[;3oh^?W?lB4QCoD59JoeUKI03oojjb`d[o[[;300?oHfE_ojjb`on^//<0
1On^//<000Oo[[;300?og=kUojjb`on^//<0oon^//>1ojjb``03oj6T]?mc
MH7oRhjL0?oo[[;3B_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<0
0ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05
ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omS
IFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo
[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3
ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^
//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb
``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<0
0omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb
`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go
[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``00
1on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3
ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^
//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3o
ojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooL
g^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb
``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo
[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3
c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb
``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<0
0ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05
ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omS
IFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo
[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3
ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^
//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb
``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<0
0omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb
`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go
[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``00
1on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3
ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^
//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3o
ojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooL
g^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb
``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo
[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3
c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb
``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<0
0ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05
ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omS
IFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo
[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3
ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^
//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb
``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<0
0omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb
`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go
[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``00
1on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3
ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^
//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3o
ojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooL
g^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb
``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo
[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3
c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb
``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<0
0ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05
ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omS
IFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo
[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3
ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^
//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb
``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<0
0omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb
`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go
[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``00
1on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3
ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^
//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3o
ojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooL
g^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb
``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo
[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3
c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb
``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<0
0ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05
ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omS
IFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo
[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3
ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^
//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb
``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<0
0omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb
`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go
[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``00
1on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3
ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^
//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3o
ojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooL
g^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb
``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo
[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3
c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb
``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<0
0ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05
ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omS
IFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo
[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3
ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^
//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb
``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<0
0omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb
`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go
[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``00
1on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3
ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^
//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3o
ojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooL
g^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb
``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo
[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3
c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb
``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<0
0ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05
ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omS
IFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo
[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3
ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^
//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb
``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<0
0omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb
`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go
[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``00
1on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3
ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^
//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3o
ojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooL
g^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb
``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo
[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3
c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb
``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<0
0ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05
ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omS
IFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo
[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3
ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^
//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb
``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<0
0omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb
`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go
[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``00
1on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3
ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^
//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3o
ojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooL
g^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb
``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo
[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3
c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb
``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<0
0ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05
ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omS
IFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo
[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3
ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^
//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb
``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<0
0omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb
`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go
[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``00
1on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3
ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^
//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3o
ojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooL
g^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb
``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo
[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3
c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb
``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<0
0ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05
ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omS
IFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo
[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3
ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^
//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb
``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<0
0omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb
`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go
[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``00
1on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3
ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^
//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3o
ojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooL
g^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb
``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo
[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3
c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb
``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<0
0ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05
ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omS
IFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo
[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3
ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^
//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb
``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<0
0omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb
`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go
[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``00
1on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3
ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^
//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3o
ojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooL
g^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb
``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo
[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3
c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb
``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<0
0ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05
ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omS
IFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo
[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3
ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^
//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb
``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<0
0omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb
`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go
[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``00
1on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3
ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^
//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3o
ojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooL
g^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb
``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3c_n^//<00omSIFoo
[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb``3oojjb`ooo[[;3
c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//<00ooLg^Go[[;3ojjb
``3oojjb`ooo[[;3c_n^//<00omSIFoo[[;3ojjb``05ojjb``001on^//?o
omcNiOoog=kUd_oLg^D7ojjb``00oon^//?oojjb`n3o[[;3003oojjb`ooo
[[;3h?n^//<00?oo[[;3oon^//?Pojjb``00oon^//?oojjb`n3o[[;3003o
ojjb`ooo[[;3h?n^//<00?oo[[;3oon^//?Pojjb``00oon^//?oojjb`n3o
[[;3003oogmoOhKoOgmo1omnOWkoogmoOe?oOgmo00001?o[jn_oi^KVon;R
h_oNg]h3omgMg@3oomcLg?oNg]kog]kNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM0017
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oMgMd00_oLg=`0?OoKfm_ogMgMomcLg?oNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
g=cMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomgMgOoKfm_of][JomOGeooHf=SoemOGom[Jf_oKfm`00_oM
gMd0oooNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNgP00AOoMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMg@03
omkNgP03omgMgOoNg]kog]kN00?ogMgM0OoQhN41onOWi`7oj^[Z00000oo/
k>coi^KVon3Ph003omWIf@08omSHf?oIfMWofMWIomWIfOoHf=Soe]KFom?C
doo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooC
dm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOo
dm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SHoooIfMT;omWIf@;of=SH
00Koe]KFom?CdooCdm?oe=CDomOGeooHf=P2omWIf@03omSHf?oIfMWofMWI
00;of=SH2OoIfMT00ooHf=SofMWIomWIf@02omSHf003omWIfOoHf=SoemOG
00;of=SH5ooIfMT01?oHf=Soe]KFom;Bd_o?cll2olg=c@04olo?cooCdm?o
emOGomSHf?oofMWIAOoIfMT00ooHf=SofMWIomWIf@06omWIf@7og]kN0OoV
i^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoPh>3oh^;R00;ohN7Q
00gog]kNomcLg?oCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?C
dooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?oalO7ok^k^onb/[;o[Zj^
ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?o
alO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO0?oohN7Q
2_oQhN402OoPh>3ogmoOom_KfooFe]Koe=CDomKFe_oJf][og]kNon3Ph006
omoOg`?oh>3P00?ogmoOon3Ph?oPh>000_oPh>08omoOg`;og]kN0_oOgml3
on3Ph0;ogmoO0_oPh>02omoOg`goh>3P00GogmoOomgMgOoIfMWoeMGEom?C
d`02om;BdP03omKFe_oLg=coh>3P0?oohN7QAooQhN400ooRh^;ohN7Qon;R
hP04on7Qh@7oi>CT0OoYjNT1ong]k@0000?ol?3`ono_kooalO400_o`l?02
ono_k`3ooo3`l?o^k^koj>SXom_Kfoo1`L7oY:BTohb<S?mkNg_oMgMgog]k
Non<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7alOo_knoolO7_
ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_oNg]kogMgMomkNg_o
S8b<ojBTY?o2`/;of][Jon[Zj?o]kNgolO7aono_kooalO7okno_oo7alOo_
knoolO7_ong]kOoZj^[of][Jol;2`_nTY:CoS8b<og]kNomgMgKoNg]kohb<
S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a001>ono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo3`k_o]kNgok>c/onGUiOoRh^;ogmoOonGUiOoYjNWokNg[0_oXj>P01_oV
i^KojNWYonOWioo[jn_ok>c/onk^k0?oj^[Z00Wokno_onk^k_o^k^koj>SX
onSXi_oVi^KojNWYonOWiooZj^X00_oYjNT03OoUiNGoinOUonOWioo[jn_o
k>c/ono_koo[jn_oj^[ZonWYjOo^k^cok>c/on_[jooXj>P00_o]kNd05?o^
k^koj^[Zonc/j_o/k>cok^k^on[Zj_o/k>cokNg]onk^k_oZj^[ok>cZonc/
k?o^k^ko[Jf]ogMgMomIFEWoKfm_okJf]_oQhN3oinOW0_o_knl0oooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aonk^k_oalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7al@00C?o_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aoo3`l?o_knool?3`ono_
koo`l?3okno_oo3`l?o_knl4oo3`l00000?ol_;bonk^k_oWinL01?oUiND0
4?oTi>CogmoOom7AdOna/K7oRXZ:ofEUIOmADE7oADE5od92@_m5ADGoDE5A
ofIVI_n:RXWo/K6aom7AdOoNg]h2onCTi003onGUiOoTi>CoiNGT00;oi>CT
00oog]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIV
I_n:RX[o/K6aom7Ad?oNg]h00_oTi>@0oooUiNGoi>CTonGUiOoTi>Coi>CS
omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKo
RXZ:ok6a/OoAdM7og]kNonCThooTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUi@009ooTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oS
hn?oa/K6obPX:?m5ADGoShn?om;Bd_oKfm_og=cKomKFeP03omGEe@0<omCD
e?oJf][ogmoOomoOg_oIfMWoeMGEomSHf?oOgmoohN7QomgMgOoFe]KoeMGD
0_oEeMD02ooDe=CofMWIom[Jf_oHf=SoeMGEomKFeOoFe]KofMWIomgMgOoP
h>3ofm_K00;oe]KF00WogMgLomcLg?oHf=SoeMGEomcLg?oPh>3ogmoOom[J
f_oKfmX00_oMgMd0oooIfMWog=cLomoOgooPh>3ofm_Kom[JfOoMgMgoh>3P
og=cLomXJ6SoSHf=oeADE?l820SoXj>Rom_KfooShn?oi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUon?ShooU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGohn?SonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi000
E_oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT1?oUiND01_oTi>CoiNGU
onGUiOoUiNGoj>SXonc/k07ol_;b00000oodm?CokNg]onOWi`03on3Ph00B
omoOgooNg]kod];BokBd]?n7QhOoFe]Kofdk=OnNCT;ocFmOonV3Koo=Keoo
WTi3ofdk=_mLG5coQhN7okBd]?oBd];og]kN1OoPh>004OoNg]kod];BokBd
]?n7QhOoG5aLofeP;?nNURkocLdoonWYCOo=cCooWYX_ofeS;OmLG5coQhN7
okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m7Ibko
J9hcoi7=AonZjEGoTLe7ofZN=?m9JRooG5aLohN7Qond];Cod];BomkNgP3o
on3Ph0Woh>3P00KogmoOolo?conIVIWoTY:BoaTI6On<S8`2omGEe@0Oolo?
coo2`/;oc/k>olk>c_o5aLGob/[:om[Jf_oHf=Sod=3@ol_;boo?cloof=SH
om[Jf_oEeMGoclo?ol71`Oo@d=3oc/k>olC4a?o;bl_of=SHomOGeonn_[ko
^k^kom7AdOo@d=3oeMGEomSHf?oCdm?oc<c<olk>cP02omGEe@05olk>c_o<
c<codm?Com[Jf_oHf=P00_oBd]801?oHf=SoemOGom7AdOoCdm<2omWIf@06
om?CdooAdM7oemOGomSHf?oAdM7od=3@0_oAdM401?m6ATKo@D51omOGeooN
g]i1on3Ph003omoOgooPh>3oh>3P0?ooh>3P0OoPh>000ooOgmooh>3PomoO
g`02omoOg`?oh>3P00?ohN7QonOWioo/k>`00Oodm?@00003ooKfm_obl_;o
jn_[00?oj>SX01?oinOWon;Rh_o=cLgoWinOof]OGon?=RkokG5QooVMT?om
/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=cOoRh^;oinOW00?o
j>SX01?oinOWon;Rh_o=cLgoWinOofiVGonCLR;okM54ooWcM?omoHgooOfE
oogmS_oin7KokMM7oi=c8_m^IeooWinOolg=cOoRh^;oinOW00?oj>SX01?o
inOWon;Rh_o=cLgoWinOof1XGom;O2?oT^5;okgiNoo@oI;of?fKomCmUOo0
nGkoV>Q=odf09?mPJEooWinOolg=cOoRh^;oinOW0?ooj>SX2_oXj>P01?oV
i^KohN7QoeeMGOm=CDd2omgMg@0Ooe1@D?l71`Oo5ADEohB4Q?lF5QKo@d=3
on;Rh_oMgMgoW9bLo`000?n?ShoogMgMon7QhOoKfm_o@410o`P82?lI6AWo
R8R8o`/;2omHF5So]kNgo``<3?l71`Oo8b<SobLW9ommOGgof][JomgMgOoD
e=Co2`/;oeUIF@02omWIf@03oeeMGOl;2`_odm?C00;ogmoO00KoFUYJodi>
C_oNg]kog]kNob<S8on4Q8@2on7Qh@0<ogYjN_l^;RkogMgMomgMgOo2`/;o
D51@oc<c<om^KVkoPh>3ob4Q8OoNg]koi^KVoooXj>Q>onSXj07ok>c/0Oob
l_81ooKfmP0001WomoOgooShn?ohn?Son?ShooOgmoohn?SomoOgonk^k_o>
c/koT92@ohD_:ooYI5KonY:7oojVVoon/JGookR[oojcY_onZ9coniB9oniX
FOn9<B_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@
oiUY:oo`_Cgonn1^ookdP_onoX[ooonBooknS?onn8?onnE`oo32?_nIJR_o
T92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@od9c:on4
cT?o[Nmcol;nR?o>oY3oe_nGom3nT_o6oXWo/_EdohSC@om4MB_oT92@olk>
c_o^k^komoOg0?oon?Sh2_ohn?P09Oofm_KolO7aoh61POlO7aookNg]olK6
a_l0003o`l?3om?CdomLG5co20P8on[Zj_o`l?3oj^[Zoe9BD_lD51Co?Cdm
onWYjOo`l?3o[jn_o`L71ooBd];ocLg=odi>C_lK6a_ok^k^om_Kfon^[Zko
j>SXonc/k?n^[Zko0000okBd]?o/k>co/;2`o`/;2olJ6QX00_oTi>@02olS
8b?o3Ph>ojBTY?o]kNgok^k^of1PH?mDE5Cok^k^ong]kOlV9RKoSHf=00;o
l?3`00coPX:2oc4a<Oo/k>coj^[Zod=3@ol_;booW9bLog=cLolZ:R[o6QXJ
onk^k_ofm_HjooShn003ooOgmoohn?Son?Sh00Gon?Sh00?omoOgooShn?oh
n?P0<_ohn?P00oogmoOon?ShooShn03<ooShn003ooOgmoohn?Son?Sh00;o
n?Sh00ComoOgooWinOogmoOom_Kf0Oohn?P00003oo[jn_oemOGok^k^00;o
k>c/0?oojn_[onWYjOoOgmoo^KViogUBD_no<RCoigAYoof9O_ooV8cooZ:F
oonXW?onY9SooiZ=ooj:Ooo^MV[o`c<TogUBD_nj^[[ogmoOon[Zj_o[jn_o
k>c/on_[k?oZj^[ogmoOokZj^_n8IE;ohY4LooW3D?omfV?oonYbookcO_oo
nX;oo_Ioooo/LoongVCon/MAon:B7?n9IU?o^[ZjomoOgooZj^[ojn_[onc/
k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S7?nAdUGoY^MZokSiN_o0oX;oaon9
ol?nQ?nioG_oYna/oiCFEomBYQcoDVeBokZj^_oOgmooj^[Zon_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jn`007Cok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[jooZj^[oi>CTogYjN_lL71coh^;Rol_;c?l3
0`?oWinOomoOgonDU9Co4a<Con3Ph?oQhN7od=3@o`H61_nQXJ7o2@T9okjn
__oRh^;o^KVio`820_na/K;og]kNoh20P?lY:BWoh^;RonSXj?oTi>CogmoO
om[JfooDe=Co20P8ohJ6Q_oOgmooJVYZodU9BOle=CGo[:b]okjn__l71`Oo
N7QhoeEEE@;ogmoO00KoFe]Kodm?D?oRh^;oh>3Pob@T9?n4Q8@2on3Ph03o
og]kNol_;boohN7QomCDe?l51@GoYjNWonCTi?oRh^;oOgmooaDE5_oRh^;o
jNWYonc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/001@on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>`7on_[j`05
onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT00003oo_knooclo?okNg]00;o
iNGU0?ooi^KVon?ShooIfMWo/[:bogT^;_o8@SCohfYLoo=iK?omR7cooYN:
oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;of=SHonCTi?oUiNGo
i^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^lA?onc5?ooMQRookSL_on
jGGoo^IcookKIOomc5?onl55onjN:onIERko/[:bomSHf?oTi>CoiNGUonKV
i_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on7bTSoUmaIojGUJOnblgOo^?Ik
okCeNOnWjV_oV=aIohW?BomS[R_o;V<^ok:b/_oHf=Woi>CTonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNH005Goi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoTi>Cog]kNogMgMolK6a_og=cLon3PhOnN
WYko;Rh^ob/[:olb<S;o4Q8B00;ofm_K02GoQ8B4ob4Q8OoOgmooDe=CofMW
IooKfm_ogMgMoi2@T?lY:B[o;bl_ob`/;?lX:2SogMgMomoOgooHf=Sodm?C
olo?d?mKFe_o0000okjn__oIfMWo:2PXohJ6Q_mhN7SoJ6QXoh:2P_ll?3co
`l?3o`l?3ooEeMGofMWIoeUIFOm>CTkogMgMomcLg?lS8b?oPH6100;oe]KF
08OoMgMgobh^;_oMgMgoXZ:Ro`000?o6a/KofMWIomSHf?n>SXko5ADEomgM
gOoShn?oi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^H00_oUiND0aooUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiND00_oV
i^H00ooUiNGoi^KVonKViP03onKViP03onGUiOo]kNgolo?c007ono_k0000
0oolo?con?Shoo7al@03onk^kP0Con_[jooQhN7o_;blogXG5oo3?c;odUE8
onAXF_o_Mfcom8=iooR7O?oeQ7[olgU]onEYFooIF4[oa3lbog`G5onl_;co
hN7Qonc/k003onk^kP0Conc/k?oQhN7o_;blojE75ooVUc;omJ``oofl@Oom
bE?ooM1Poo_CIOomdV3oo/eDoofm@_oj[c;ojI/bojE65onl_;cohN7Qonc/
k003onk^kP0Conc/k?oQhN7o_;bloaMI5omOZ3;oM[dgohK=AonFeU[oX^1U
oj?PJOnShFOoUmYLohK>Aomg_cOoGj/boaMI5onl_;cohN7Qonc/k03oonk^
kP[ok^k^02kok>c/onOWiomkNg_o71`LonCTi?oYjNWoi^KVon7QhOoNg]ko
SHf=oa@D5?oVi^Koi>CTocDe=OmiNGWojn_[ok:b/_lE5AGogmoOonKVi_oT
i>CohN7QomgMgOmjNW[o:BTYonSXj?oUiNGogMgMok6a/OlV9RKo2`/;oi^K
VooYjNWoc<c<o`000?o>c/ko`l?3obDU9Om;Bd_oO7alonSXj?la<C7oYJFU
onCTi?mMGEgoDE5A0_oWinL02_lU9BGoJFUYomoOgooOgmooMgMgoc4a<OoY
jNWo`L71o`000?nWYjL2omoOg`04oi>CTolF5QKoinOWonc/k3cok^k^00?o
kNg]onk^k_o^k^h00_o^k^h00oo]kNgok^k^onk^kP3oonk^kPWok^k^00?o
kNg]oo;bl_ohn?P00Oolo?`000?ooOgm01Koo?cloogmoOomoOgoo?cloo?c
looAdM7oJ0L7okPd=?o7?c?odU13omYREOoSKV;oi79TonA_H_oLI5Oode53
ola1=?ni=3CoJ`L7om;Bd_oclo?oo?cl0oomoOd04oolo?colo?com;Bd_nN
:`OofXXdon^K6OoeZ2Won;@oooVmB_oh_dgon[m:ooVh?oofZR[okihIom^;
=?nR;@Ood];Boo?cloolo?`00oomoOd04oolo?colo?com;Bd_l7@0OoCIXd
oen[8?m`^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^BooHZhPodjK=?l7@POo
d];Boo?cloolo?`0ooomoOd:oogmo@0Soo_knoogmoOoQ8B4oahN7_oclo?o
nOWiok>c/oo@d=3olo?cofQXJ?m7AdOonOWiomCDe?l0003ogMgMooclo?ok
no_o9bLWojRXZ?oinOWoZj^[omGEeOoalO7oE5ADoeiNG_oinOWom?CdoiBD
U?l51@Go@410om7AdOogmoOon?ShoiNGUol[:b/00_ojn_X06olT92Co1`L7
olS8b?okno_oQHF5of=SHoogmoOoHf=SoeMGEoohn?SonOWiobLW9olE5AGo
Ph>3omOGeom2@T;oHf=Soo_knoojn_[o=3@dodU9BOoKfm_oiNGUodm?ColG
5aOon_[jooclo03ooogmoD_ooOgm00?oo?cloogmoOolo?`00oomoOd0000j
oogmoOojn_[olo?conk^k_o`l?3okno_onk^k_oYjNWodm?CoeXL7?nR=3Co
]2PMol4i;?o7BCcoceI:om1GBoo@Ed[obTXnol<k;_nf:1goXS@doe`M7OoC
dm?oj^[Zonk^k_o`l?3okno_oo3`koo^k^koj^[Zom?Cdon<9Agob74domV4
7OoTU1GoiidTonjX<oo`ZSCokjXconbP9OoWUaGog8PMolQa=?n<9Agodm?C
on[Zj_o^k^kol?3`ono_koo`l?3ok^k^on[ZjOoCdm?o7CPMocB2=?m7UAgo
FZDKofV]:P;oM;Ph0?ooMKThof^a:omKYacoB9XMocB2=?lM>1godm?Con[Z
jOo^k^kol?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knl0
03[ol?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`onk^k_o[jn_oOGem
oa`L7?oWinOok^k]ohR8R?l`<33o3Ph>oc4a<On`/;3okno_ohB4Q?m=CDgo
k^k^ono_koo^k^koRXZ:oeUIFOo_knooN7Qhob`/:ol>3Pko>3Phokjn__o^
k^kohn?So`h>3_mYJFWoh>3Oon;Rh_oVi^Koj^[Zof5QHOmfMWKokno_onk^
k_mgMgKo9RHV0_o^k^h05_o=cLgo;2`/on_[jom/K6coHf=Ron_[joo^k^ko
>SXjoiBDU?mRHV;o3Ph>oc@d=?o4a<Cok^k^ono_kooAdM7o?3`lo`X:2_lW
9bOoK6a/ob`/;?o^k^h2ono_k`3ooo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`onk^k_o`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3ok^k^oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`0015ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_00;ol?3`1_o_knl1oo?cl`7on?Sh0Oono_h00003
ookno_ogmoOol?3`00;ojNWY01?oj>SXonWYjOoVi^Kofm_Kof=;Bon1<S;o
YS@dokHd;Oo2CD7o`eA9olAEB_o3E4Wo`Te1okHd;OnU=CGoPC8bof=;BooK
fm_oinOW00GojNWY017oinOWom_Kfon9Bd_o[d/boleg=OoFRbgoh9`^on2P
<_oQX3Coh:0bomnJ;_oFRbgobWDeojm;<_n9Bd_ofm_KonOWi`05onWYj@0A
onOWiooKfm_oBd];oc9P<_ljRCGoDi/]of^[;om`[CSoKjhjog2]>?mZZRoo
Di/]ocV8=OlbH3;oBd];om_KfooWinL0oooYjNT;onWYj@06onSXj?oVi^Ko
Ng]koa`L7?oTi>Coj>SX0_oYjNT00ooWinOojNWYonWYj@0;onWYj@0<onOW
iooYjNWojNWYonSXj?oHf=So2PX:ojj^[_oLg=cog]kNon3Ph?oUiNGoj>SX
2?oYjNT01_oXj>Soi^KVon?ShooShn?oi^KVonSXj0?ojNWY00?oj>SXonWY
jOoYjNT01?oYjNT00ooWinOojNWYonWYj@1jonWYj@03onSXj?oYjNWojNWY
00?ojNWY00?oj>SXonWYjOoYjNT0a_oYjNT00ooXj>SojNWYonWYj@04onWY
j@7ol?3`0OogmoL1ooknoP0000Coo_knoo[jn_odm?Cokno_0oo`l?004Oo_
knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZNW?oIW9coe9FEok]c
LonEE5CoCb<SoiFDU?oZj^[okno_00Gol?3`017okno_on[Zj_nYU9CoPB<S
okYZE?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S8onZU9Co
j^[Zono_k`05oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCoLjEcoik6UOn/
cYco[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Zj_o_knl0ooo`l?0;
oo3`l0;okno_00CoP820oadM7Oo^k^kokno_1Oo`l?000oo_knool?3`oo3`
l00;oo3`l0;okno_00OoI6ATobTY:On1PH7oHf=Soc/k>oo^k^kokno_00So
l?3`00Kokno_onk^k_mcLg?oJFUYonk^k_o_knm;oo3`l0;okno_ooo`l?0?
oo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn00001?o]ko;oooooooooooon
o_h2ooooo`;oo_kn0?oooOgmooOgmom^KVkoFSlook6@T?oNbLWol>CToo?V
i_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?coooooookno_ooooooo_kn
ooooo_ono_koooooooclo?ohn?SoSFe]ohXo?oo9TI3ojM39ooCYi?ofjnKo
m>WTonW@bOo9TI3oRCloohe]KOohn?Ooo?clooooooono_koooooookno_oo
ooooo_knooooo_olo?con?Shofe]KOlo?cooT9f@olWEbOoTk>Coi^kVonC/
i?o9eLWoT9f@oclo?om]KFgon?Shooclo?ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_h0
04Ooooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooo`02ooknoP0Holo?conVYZKooOgmooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_kooooo0_ono_h03_o0`<3oLG5a
oh20P?n`/;3ooOgmooooooono_koooooookno_ooookoo_knooooooono_ko
oooo0_ono_h0ooo1`L7o_KfloogmoOooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooooknoP00G?oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ooooo_kn0_ooool00oono_koooooooooo`03ooooo`7on_[k00001?o4c=?o
o_knoo[jn_oclo<5oo7al@0=ono_kooFe]KoJf][od<m?OnKS8coa[ZjomK<
c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7al@0=ono_kooGe]KoPf][
og@m?OneS8coeKZjon7<c?oF^[[o]Xb<og8m?On1Jf_oemKFono_k`09oo7a
l@0=ono_kooFe]KoJf][ocdm?On<S8co^[Zjolc=c?nj^[[oS8b<ocdm?Om[
Jf_oe]KFono_k`3ooo7alAKolO7a00?ol?3`oo7alOoalO404OoalO400oo`
l?3olO7aoo7al@2Moo7al@03oo3`l?oalO7olO7a0<ColO7a00Col?3`oo7a
lOoalO7ol?3`1?oalO400oodm?Con_[jooknoP01on_^k`0001GoRYRSoogm
oOohn?Sol?3`on_[jooZj^[ojNWYon[Zj_oYjNWoj^[ZonWYjOoXj>SoVi^K
oeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT02ooZj^X02ooYjNWo
j>SXoj2KVomZFEWo@bHVobd92Om29RKoJEUIoj2KVooXj>SojNWY00_oj^[Z
00_ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWY
j@3oon[ZjR[oj^[Z00?ojNWYon[Zj_oZj^X0W?oZj^X00ooYjNWoj^[Zon[Z
jP3=on[ZjP04on_[joo`l?3on?Shoogmo@7ocm;F00001?m1D5ko_<K=oo[j
n_oclo<8oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`
3ooalO42oo3`l0?okno_0_o`l?3ooo7alOoolO7aV?oalO400oo`l?3olO7a
oo7al@02oo7al@03ooGemOojn_[ojN_]007oVinR00000olU?4koDF=`ok_5
c03ooooooooooooof_ooool1ong_l@7o[;2d0OnW[;000006obU0EolR>Dco
>4YIohJAWOo1b<kok>k`ooooooooooooomCooooo00Gon?Wjonc^kooAe=Oo
VinSoifSY`01ok>j_`00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{734, 424},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]If[Length[lfNames] < 3, 
        Return[]]; \[IndentingNewLine]If[{} =!= \
\((javax`swing`UIManager`setLookAndFeel[
              lfNames[\([3, 1]\)]]; $MessageList)\), 
        Abort[]]; \
\[IndentingNewLine]javax`swing`SwingUtilities`updateComponentTreeUI[
        frame]; \[IndentingNewLine]btn@
        setText[lfNames[\([3, 2]\)]]; \[IndentingNewLine] (*\(frame@
            pack[];\)*) \[IndentingNewLine]JavaShow[
        frame]\[IndentingNewLine]]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]If[{} =!= 
          StringPosition[$OperatingSystem, "\<Windows\>"], \
\[IndentingNewLine]If[{} =!= \((javax`swing`UIManager`setLookAndFeel[
                defaultLF]; $MessageList)\), 
          Abort[]], \[IndentingNewLine]If[{} =!= \
\((javax`swing`UIManager`setLookAndFeel[systemLF]; $MessageList)\), 
          Abort[]]\[IndentingNewLine]]; \
\[IndentingNewLine]javax`swing`SwingUtilities`updateComponentTreeUI[
        frame]; \[IndentingNewLine]btn@
        setText[javax`swing`UIManager`getLookAndFeel[]@
            getName[]]; \[IndentingNewLine] (*\(frame@
            pack[];\)*) \[IndentingNewLine]JavaShow[
        frame]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[{
    \(frame@setLocation[0, 0]\), "\[IndentingNewLine]", 
    \(frame@setSize[640, 480]\)}], "Input"],

Cell[BoxData[
    \(Do[\[IndentingNewLine]ReleaseObject[
        feels[\([i]\)]], \[IndentingNewLine]{i, 1, 
        Length[feels]}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(DeleteJObject[pane, btn]\)], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.ImageIcon <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P6c<c<WOooo`K<c<bNooooolc<c3;<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVc<c<IVIV09YVIVH00oooolc<c<c<c003c<c<
00=VIVK<c<aVIVH0VfIVIP03ooooc<c<c<c<0?o<c<``c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c02Ic<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<09[<c<`00fIVI_ooolc<c03oc<c<<Lc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0
VLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c02Jc<c<00=VIVKoooo<
c<`0olc<c37<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVooooc<c<09W<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0V/c<
c003IVIVooooc<c<0?o<c<`ac<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0G<c<`00fIVI_ooolc<c00>c<c<05BMT4:WVe>_YV^aZg^ZZ8:QX86M
W82NVgbLUWBHT6VGRfFGSFVFSG2ARgF=RGfDRWjIPW2PQ6nQQW>KQ7BGQ7JH
QgfIRh:JSHBISGnJRgJLRFVRQebYQTj`QD6gPcNhPc>ePCR`P3R]PCR/QCRZ
RCRZS3J]T3B`U3>]TBfYT2^VSRbMRRjHS3RQVdnUY66RX5J[VdJ[TcVgVdO2
XE:kUDbfSTR_Pd:JLBnQNSNROc^SPD6`Te75YfVkWV:[TEJ_UfNVSW:JQG9g
IDn9NF2GRFnPUgZ[YHF[Z8NXYH:]ZXNZYX6`YX>fYXFkY8G3Y8RkW82oYHZm
YHVkYX^jYHX2^ZJ;00FfYHNeY8JiZHR_WgffYX@00[:SO003/J9g^:Un]ZQk
02_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c003UiNGVIVI
Vi^K00:KVi/019ZJVYVIVIVIVIRHV0FGUiL00iJFUYNGUiJFUP02UiNG0YJF
UP^GUiL5UYJF0YNGU`04V9RHUiNGUiNGUiNG0YJFUP0;V9RHVYZJVIVIVIVI
V9RHVIVIVi^KVIVIV9RHUYJFTi>C00:EUID039JFUYRHV9bLW9ZJVYRHV9VI
VIRHV9JFUY6ATIBDU9NGUiVIV@RKVi/00ibLW9^KVibLW005W9bL0Y^KV`03
W9bLVYZJVi^K00:KVi/00iZJVYbLW9^KV`0/c<c<00=VIVKoooo<c<`0olc<
c37<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVoooo
c<c<00k<c<`0GYj<@9nABZ2EEijDGiN@I9>>IYJ>JIV@IijAIIj>GJ2<FZ6=
Fj2=HYf>Ii^>K9n>L:ZBL:nBL:fCLZV@LZB?LZFAN:FCNjFEO:6AMj:?KZF>
I:N<Ejf:B[B:@;Z:=[j:=[Z7>;F6>;:7>;6;>;2>=Jj?<[2B<;>F<:fA9[6D
;;:I=JjG>Z>B@Z6ECINBDX^6AYjDC:bNDkVXHZjIF9j5C:J;E:^@FiYoBZ68
D:2:DIN2BIf9C[:NHk:MI:B?EZ2<FZ^IMJFFNH1_Dh9cE8enGinBLZZOOj2J
N:FOOJZVPj^UPkBYRKNVR;NRQL>XSLFZSl2VRkjVR[bTR[VTRKZUR[^VRKZW
RKVVQ[RUQK6NOKZXQ;FUPK>TOK6RN@:`XGH[c<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<00k<c<`019JFUYNGUiRHV9RHV0BGUiL00iRHV9NGUiNG
U`05UiNG00>HV9RIVIVIVIT019RHV004VIVIV9RHV9RHV9RH19NGU`03V9RH
UiNGUiNG00BGUiL2V9RH01BGUiNHV9RHV9RHV9RGUiNHV9RGUiNEUIFGUiNI
VIVKVi^IVIVFUYJGUiNHV9REUIFFUYJGUiNEUIFFUYH2VYZJ0YNGU`:IVIT0
1i:BTY>CTiFEUIRHV9ZJVYVIVIZJVP02Vi^K00FLW9bKVi^KVi^LW9bMWId0
0ibLW003Vi^KW9bLW9bL00:LW9`00i^KViZJVYbLW002Vi^K0iZJVRc<c<`0
0fIVI_ooolc<c03oc<c<<Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P5c<c<00=VIVKoooo<c<`03/c<c00FXXY2X8U3VhQ6UHE7Th=8U8=;VXM=
X8Y>Yh]<[Xe:/Ha5/H]2/He3/8i4/917[Xm</YIG/9II[YAIZY1EZHmFZi1I
0Z^BG00VZ8mIZY1GZhm>[Xe6/H`k]hhf_I4b`Y4b_Xle^hde^I0d]i<c]YHa
]IHZ]ILW^9TU_Yl[^YX[]iDa/I8h]9Y=b[EdgljHhmVXd]BSe]j_d]N_[[:?
RXY^QXI^QHE]LWEJQHQYSi=`S8iVRXUKVIEUYIiZ0ZJJIP0PXi]ZYIe^ThQJ
Wi9V[Iie]jEo/j=oY9IcYIIgVXe]TXMYYIMj]:B:]JB:_JV@_jVA`:R>_jF<
_J>:^j>9_:B8_JF9_ZJ:_ZN8^ZF6]j>2_j^8_:Z6^:J0^ZR2/Img]jEm:lc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<0iJFUP>EUID00iJF
UYNGUiNGU`04UiNG0iRHV0:IVIT9V9RH0YNGU`^HV9P2VIVI0YRHV009VIVI
WYjNXZ:RXj>SXZ:RXj>SXZ:RW9bLUYJF00:EUID00i:BTYFEUINGU`02UYJF
00>HV9RIVIVIVIT00iVIV@03UYJFV9RHVYZJ00:KVi/2VIVI00>GUiNFUYJI
VIT00Y^KV`FLW9`00i^KVibLW9bLW002W9bL0Y^KV`:LW9`019^KVibLW9ZJ
VY^KVbc<c<`00fIVI_ooolc<c03oc<c<<Lc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<c01BXXY4WhQ2W8Q3VHI2
VHQ3W8U5X8a7Yha7ZHQ3/he6^8a1]hTk]HPe^8/f]X`f/8`fZXdmZ8e0YhXl
YhLjZ8Lj[HTm[HTo[8Pn[hY3/He3/hm1]8ln]Xhf^90a_Y8_`IH``9D__9D^
_9L_^iX_^Y/_]Y/Z^9XX^YXY^iXY_I/_`Ylk_ie4_9aA`:ASaJad^Zak]kV:
[kN>[;B?XZN7TYImSY9kSY5lRHefT9IjV9mmUI]eSYAXUYQYX:1^XZ1_Y:5^
ZZMbViEQRGm>W8mS[Yad[9Qe/9]l]j:5/If2TX9XOg5FUhU^/::7/jF:]JN<
]jJ:_jN=_jF<0[jTR`0<_jF:`:F8`JJ9`:N8_:>4^:61^jB2^:B1]J5n^JN3
/Z1l^ZR4:lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<1YJF
UP>GUiL2V9RH29NGU`:FUYH5UiNG1IRHV0:IVIT00iRHV9VIVIVIV@06VIVI
0iZJVP03Vi^KW9bLW9bL00:MWId00ibLW9ZJVYRHV002UiNG00JFUYJHV9RI
VIVHV9RGUiNHV9P2VIVI00fJVYZKVi^HV9RDU9BGUiNJVYZIVIVJVYZKVi^J
VYZEUIFCTi>GUiL00Y^KV`ZLW9`5Vi^K00>LW9bJVYZLW9`0;<c<c003IVIV
ooooc<c<0?o<c<`ac<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`00fIVI_ooolc<c00>c<c<01ZKR4>IR4:GRD:HRT6HS4:JS4>OS4NSS4VT
QTR]RDfbRTfbQTN`QD6bR42bR3b]R3NYRCJZRSF/R3:^QRncQc2hRSBjRSFh
R3BlS3ZnScd2`9=003JnTS^mTCRoTSO0US:lV2RiVRFiW2NiWRfiWc6gW36g
VS:iW3JlVSRlVSVnVcnkVD:fUDBiW52nXebgXUnaYVJWWf6WWF:^XFb`X6n^
W6j]Vff^W6jaXG2[WffVWf^^Z7Bn_8W7bYG6bYS5aiRe/8JLTfb9NeREQFBU
T7FPQg6ZTGfjY8o6/IjTU7f<OFJMTGN`YHN`YHFeZhRk[8^lYhboYHh2`JF=
00c2Yhc4YX[3YXS2YHG3YXJnY8>nYHJlYHFgXh:eXX6gY8BfYXD[c<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`6UYJF0YNGU`03UYJFUiNG
UiNG00FGUiL019JFUYNGUiJFUYJFUPBGUiL2V9RH0YVIV@>HV9P=VIVI00FH
V9RJVYZKVi^JVYZKVi/00YVIV@>JVYX01iVIVIZJVYZJVYZJVYVIVI^KVijN
WP03X:2P00bLW9bHV9RDU9BFUYJHV9RGUiNIVIVLW9bNWYjIVIVEUIFHV9P2
Vi^K3YbLW0BKVi//c<c<00=VIVKoooo<c<`0olc<c37<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`0H9j7@I^7
?YZ7>iR6>YR7>IZ8?9n9@:68AJB5AJZ6BZf6Bjn6B;66@[>9@K6:>jn;=jZ;
<Jf><K6?;[F=;KZ>;L2?<<:@<L6></>B=/>D?<BF@<2G?kjE?K^D>K^B>;VC
<;VJ9[RL8KNM9[RO:kVO<KNL<kRK=kVK>K^I>;bI>l2M?l6N@[bJ@K^KA[ZK
B;:HA;2IBJnJBk2IBk:HCKFID;NJE;ZLE;ZNEL6VGkRPF[>NFkNXIk^_LkV`
Mk>]NK:/N[:WNZZKLZRFL:bIN;fXSKVSS;ZUT;j/V<bkYjfQRiF9LJ>IO[FZ
S;R[RK^^Rkb/R[nWSL2VSl:VS/>XSLJXS<FXR/BUQ/6TQ<NZR/:XQl:YR/2Y
R[FPPjBALkBSQjNHNb_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
3/c<c0>FUYH2UIFE19JFUP^GUiL4V9RH1IVIV@>HV9P:VIVI0YZJVPZIVIT2
VYZJ00BKVi^JVYZJVYZKVi/4W9bL00bKVi^IVIVIVIVIVIVLW9bKVi^LW9bM
WIfOWinKVi^FUYJIVIT2W9bL00>MWIfLW9bLW9`01ibLW008WIfMW9bLW9bL
W9bLVi^KV9RHVi^KVIVI;<c<c003IVIVooooc<c<0?o<c<`ac<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<062Y
QCVWQSVVQCJTQC>SQ3:TQCFVQSVXR3fZR42[QSn]Qd2aRSnfSCffSSVdScBc
TS>ZTRj^Uc6dVC2gURfjUB^lUBbnUBbmTbfnUSBkUcNjUcVhUcZeUSVcUcJd
USJcUS2kVbjjVRVkVbblWS2lWC6iWC2kW3:mW3?1X3NoW3C0WCG0WCNlVSJn
W3^oWSnjVCZoWSo3XT?1X46jW3bkWcjmXD2mXCjnXSniWCbhVcnmWdO1XU:l
WUJjW5bmWVFmXfZfX6JfXVNjYFjcWfg2[hG5]I77^Y[4^ic2^ina[8nPVgj[
Y8Nj[hnl[X^o[HVkYhK1ZHo0Z931Yhk2Z8g4ZHc3Z8[3YXK2YHG1Y8BnXhFm
Y8JgWh>SSgB1L5JXV7nAPV/[c<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<00k<c<`8UYJF00BGUiNFUYJGUiNGUiL4V9RH00>GUiNHV9RHV9P01IRH
V0BIVIT4V9RH29VIV@04VYZJVIVIVYZJVYZJ0YVIV@03VYZJVIVIVYZJ00:J
VYX00iVIVIZJVYZJVP02VYZJ0YVIV@03VYZJVi^KVYZJ00:JVYX01i^KViZJ
VYZJVY^KViZJVYfMWIjNWP03WinO00>LW9bIVIVKVi/00ifMW@ZLW9`01i^K
VibLW9^KViRHV9>CTiVIVIFEU@0/c<c<00=VIVKoooo<c<`0olc<c37<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<
c<`09JV5<JZ6<Zb8<ZZ8<JV6<ZN7=:V9=Z^:>K2??Z^;>:f:=[:@=kJC=kBB
<KBB<;>F<;2I<KBM<k^P=KbM<K^K;[fH;KbG;KbG;kZH=;NG=;BF=;>G=[:I
=KBK=kFL=kRK=KjM=;nJ<;fK<;nM<[jM<P02_9/`00JnWC:nWS6kVbjoWC72
X3G1Wc@2`j0h036nVc?4WcO2WCFkVS6lW3FoY3fjXCZgWcFlXC[1Y42mWcg0
WD?2WT[1Ve34WE[6WV6nVUjjWUnhXfC0ZW2eXFk0[h>l/8Ri/8ne/9:n^Yo0
_ZFo^j30^ijo/IJgYXS1ZX_3ZXc3Zi72ZY30Z8k0Z8c2ZH_1Z8W2YhW0YhS2
ZH[0ZHZmZ8^cWhJJR71`H4VYVXN=P6d0:lc<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c00>c<c<1iJFUPBGUiL6V9RH00>IVIVJVYZIVIT01IVIV@BH
V9P>VIVI19ZJVP03VIVIVYZJVYZJ00:IVIT2VYZJ00>IVIVJVYZJVYX01IZJ
VP06Vi^KVYZJVYZJVi^KW9bLVYZJ19fMW@07WYjNWinOWYjNWYjNWIfMVi^K
W9bL00>MWId9W9bL00FKVi^GUiN@T92JVYZEUID0;<c<c003IVIVooooc<c<
0?o<c<`ac<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIV
I_ooolc<c00>c<c<05BPQ2>^TC>]T3BYRc6YRcF`U42WRcN[TCZYT3JVSC2e
WC^^US:VSBJ^TbbbUbjcV2ndVC:jWCNjVS>gURfeTRZhTb^mUc:iUS:jVSNe
UcFcUcBbUS>fVCFfVC6gV2k0WcK2WCG0VC:oV36lUBk0Vc>jUBg1WSJnWCBo
WSFnWcFoWSFkVRo0WcC1Wc>jV2c6Y3RnVBjoWS>mX3RiX3^hXD6iY4NjYDZi
XDVdVTG2YU?2XE:lVU31WeS4XEo0WUo5YF[0YVfoZ7C1Zgbo[8:jZXRhZXng
[9Re/9fa[Ynd/J:f/:2d[I^gZ9FiYi6oYY30YXniY8VnZHjlYhbhXhH2^ZF6
00ZhXhBiY8FmZ8^hY8VdXhV]WHJ:NfI^HDj8O6a`I5@[c<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<00k<c<`00iFEUINGUiNGU`02UiNG00>HV9RG
UiNGUiL00YNGU`04VIVIV9RHUYJFUiNG0iRHV0:IVIT3V9RH00>IVIVHV9RI
VIT00iRHV0:IVIT00iRHV9ZJVYZJVP02VIVI00FHV9RIVIVHV9RJVYZIVIT0
0iZJVP06VIVIVYZJVYZJVIVIVi^KVIVI1iZJVP03VIVIVi^KVi^K00:JVYX0
19^KViZJVYbLW9^KV`JLW9`019fMWIbLW9fMWIfMW@FLW9`00i^KVibLW9bL
W005Vi^K00RLW9bKVi^KVi^JVYZDU9B@T92DU9B@T90/c<c<00=VIVKoooo<
c<`0olc<c37<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVooooc<c<00k<c<`0H:BB;Z>?;Z2;;Z>;=J>:>:J=>j>=>ZbF@J6<<JFA
<ZNC<:ZD;jVB;:nF<KNK>:^?;;>G=[FG=kBC<[^I=l:P?[bJ>;NE=;ZI>[JG
>[2C=JnE=[2F=KFH=;NG<[JE;;RG;[fK>KZH=knM?;bI>l2O@[ZK@;^M@jbA
>:nE?[2H@;JNA;BK?kRN?kjR?kVL>;fM>/>Q?lBSA<6TB;fSC;^UD[fWFk^U
G;VQFk2ED[6DD[6BD[>EEk>FF[ZPILF/LkjYL[jZN;bZO;^YPKZWQ[RWRkJW
T;BWU[6XVJbTUjfWVJnXUZjVTk2TS;FTR[ZUR[bTR;NRQKZWRKNTQ[>PP[>R
Q;:QPk6PP[>TQjfMPjjPQ[>WSj^NRifBP8b3LXn6MgieIR_<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`03/c<c0:GUiL3UYJF0YNGU`03V9RHUYJF
UiNG00>GUiL00iRHV9VIVINGU`03V9RH00BIVIVJVYZIVIVHV9P2VIVI1iRH
V0:IVIT01YZJVYVIVIZJVYVIVIZJVYNGU`:HV9P3VIVI00BJVYZIVIVIVIVJ
VYX2Vi^K00FJVYZKVi^KVi^KVi^JVYX00iRHV0:IVIT00iZJVYbLW9bLW008
W9bL0Y^KV`04W9bLVi^KVi^KVi^K0YbLW003Vi^KW9bLVi^K00>KVi/02YZJ
VY^KViZJVYZJVY^KViZJVYRHV9FEUIJFUY>CTbc<c<`00fIVI_ooolc<c03o
c<c<<Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKo
ooo<c<`03/c<c00hVI0cVI0eWi0kWhi0WXY1Wh]4Y8e7XH]0ZYE4[9Q2Xhhe
/9Pn/9DjZhdc]iDn/Y8mZ8`h[I<nZHhg[Hlg^Y]1]IHlZh`b]9Hn/iQ1/IM0
]9a2]j13]I/l]9Pg^9/g]YXg/9]0ZiY2]Z5>[iY;/IiB/j1K/ImOUhQ=Qg]1
PWPmUhe@ZYmO/ZEO^:QM]Z=D^J9B`:=G`j=J_j9L_J5P^j5T^j9Y^IiY]iUW
0[2@G`0VS6dnRVm0[IQ[[j9e[ZMk/jn2]Jj2/Z^1/:J2/ZF5]:B:]ZB>]:>?
/j:@[Yn<[Z::[JB7Zj:1[JAm/ZMj]:Qh]JMj]ZB0]jB6/Z63/J22/Z>4[j64
[:65/:J;/ZR?[jN@/:RCWiJ5YYf>ZZ2DWI>7TXQl:lc<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c00>c<c<0YJFUP:GUiL2UYJF00FGUiNFUYJHV9RH
V9RGUiL00YRHV005UiNGV9RHV9RHUiNGV9RH00:GUiL02YVIVIRHV9NGUiRH
V9VIVIRHV9VIVIZJVYVIVIRHV0>IVIT019RHV9ZJVYVIVIVIV@:JVYX01iJF
UYBDU9>CTiJFUYVIVIZJVY^KV`02VYZJ1Y^KV`:JVYX2V9RH0Y:BTP03VIVI
VYZJVi^K00>LW9`6Vi^K00BJVYZKVi^KVi^JVYX7Vi^K00VJVYZKVi^KVi^J
VYZKVi^LW9bKVi^LW9bIVIT00YZJVP03V9RHUYJFc<c<02_<c<`00fIVI_oo
olc<c03oc<c<<Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<
00=VIVKoooo<c<`03/c<c01PQXM5Si1>THe@P7Y0NVhjRWe9Wi9NUXUBW91D
WY=AUHQ2WHa4X8a5Xh]3X8@kX8E0T7i0UhU<V8Q:U84oXX]8ZI1=WhI3XHY6
V8=0WXU6Y95=YYE?W8Y2V8HlYHm3Y998VY5<Thi<VY9CQWe2R7m8Ui1LWIIZ
QX=JFETcAdTTJVY4V9I]XYi_WYMSXIAM[IYR[Y9R/Y=U[iAYZiAZYY=YY99Z
Xi1XXheVY8YUXXIQK50[J50/YY9aYiYhVYAdW9ajWimiWiegWi]hXYUlYiUo
ZIN3Z9F4YiB3YiJ2Z9V2YIYnY9YgYYedZj1c[:9a[9mb[iei[YUjZIIhZIQj
[In2Z9b2XY^1Y9j8WiR5XYf:YIn?X9R;[ZJI]ZbRVY26NfiU:lc<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<00REUIFFUYJFUYJCTi>ATI6D
U9BHV9RFUYH2UiNG0YJFUP:GUiL2UYJF00JDU9BFUYJFUYJEUIFGUiNHV9P2
UYJF00JEUIFFUYJGUiNHV9RFUYJEUID3UiNG00bFUYJGUiNDU9BDU9BGUiNH
V9REUIF>SXj;Rh^@T92HV9RIVIT2V9RH00>IVIVHV9RIVIT00YVIV@>HV9P3
UiNG00F>SXj=SHfHV9RIVIVHV9P03YVIV@BJVYX3VIVI0YZJVP03VIVIVYZJ
VIVI00:JVYX01IVIVI^KVibLW9RHV9:BTP0/c<c<00=VIVKoooo<c<`0olc<
c37<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVoooo
c<c<00k<c<`0H5YVDUMSCEMOBUiQC5IE@EED?g5`FginIW5dEgEiF7AfCfe^
@WYfAi><F81c?X=kC5aOA4YB?De?>Dm;<61G>7]^C7IVAFEE<gm`ChIiEhAi
Fh=mGGehF7YeEHJ1HHF2HGaoH7AiFFibDDY;:De?:VY^BG^1Gg=jFDmI?SI0
9eMOB8B7LXV9LHEoIhUmHiB2JY9gIY=iK8mnKX^0K8AoJGmoIGn0HHB1HXMl
G8QhEh5ZBhE[D::8Ki^3JiJ1K8AhH8B4HX:6HhJ5IXV3JHf1JhinKXilKXil
L9>1MIF5MYF8MiJ:M9Z<LYj@MJ6BLjBALJRALJB=KI^6IiV8K9j@MIR>MHf7
LHR5LXb9N8j;O8j:OYZCRJNNUK>YX9^<QF5BBb_<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`03/c<c004T92@Shn?Shn?Shn?0Xf=S@0;TY:BU9BD
TY:BTi>CTY:BTI6ATi>CUYJFTY:BU9BDShn?00><S8`01Hj>SY:BTY6ATHj>
SY:BTP03U9BD0Y>CT`:EUID04IBDU9>CTi:BTX^;Rhb<S96ATIBDU9>CThf=
SHV9RHn?SiFEUIJFUYFEUIBDU9JFUYBDU004UIFE0YBDU003UIFEU9BDU9BD
00:BTY8019NGUiJFUYJFUYBDU0REUID2UYJF0iNGU`FHV9P03YJFUYNGUiRH
V9NGUiJFUYFEUIJFUYNGUiJFUYRHV9ZJVYbLW9NGUhj>SRc<c<`00fIVI_oo
olc<c03oc<c<<Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<
00=VIVKoooo<c<`03/c<c01P9S4]?DI1?44jA4Ll@48eDeA6Gf5DE5Q:G69F
EemBFF9AF619GF56LG5?K6U0XjB4KGY`:SXi8B/S:2XM@CXXOW9LQgEMFDD]
PW1HQgIRMFQGM6eMNWMXMgEYNg]_MGQ]LGM]IVaREEU:9BPE;c8MF5a5Jg1I
K7AMGFICB550G69DM7EWMW1ROG1PQgASSWAUQVYLQVaOPFmQNg9QLg9NKG1K
Kg5KMG=JMfeDWH]caJbF_:2:/YJ1T7=QQ6YIO6]GMW9GLWEHMG=JMg9LN6mN
N6aLN6aNMf]OOg=WQGU[Rh1^T8=`V8QaWXadYY1hZI5e[Y=eZHm^W8EVTH1T
TXAZRh=^OWUVMG=TLg5TLFmSJVIMNgA/Rh1jX9>=RgUeCc`f:lc<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<00R7QhN;Rh^:RXZ;Rh^:RXZ=
SHf?Shn>SXh5Shn?00FBTY:@T92JVYZCTi>8R8P00XJ6QP08RHV9Ti>CTi>C
S8b<Ti>CU9BDTI6ATY:B0Y>CT`0?U9BDTi>CTi>CTI6ASXj>QXJ6QhN7SXj>
TI6ATY:BT92@S8b<Shn?Ti>CTY:B00:CTi<00iBDU9:BTY>CT`02Ti>C1I:B
TP05UiNGWIfMVi^KVYZJU9BD00ZBTY8019>CTiBDU9FEUIJFUP:GUiL2V9RH
00NIVIVHV9RFUYJEUIFFUYJEUIFDU9@00i:BTP06TI6ATi>CUIFEVIVIU9BD
RXZ:;<c<c003IVIVooooc<c<0?o<c<`ac<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<060b<24c<1eFD3[<aJWG
c[6ARVeFD3QDDD1EETi?E4i=DTiHGEIFF4]IF4=SH46f^IanS7lU=B/P9QPW
8Pi3=1NaVGO7ZH=^C2J9JD>CME=gGD9cGdMlKeacJU]dKV9_K6=cLVeVIf5?
C4DP714k=BUWHE=_JemaKf9UHUUCDDERG51aIEMeHdn4JU6FM5RNNURLNe:E
N4j<MTn5ME=mLUAfK5=eJE=iIUF3JEZgUh[_c[oB/J2dUhF9L5aeHdelL5Yh
LEmbKeibK5iaJeecKEmbKf1bKei`KeebLEalNV6:QFRCRV^NSVfZTg6dUgFi
VgNmWg^jWG^XSg2FPFJ?P6V8P6emMfUbL6AZJV1]KFE`KFJ2NgFPUI6l[JRD
PGeVDDh[c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`2QhN7
00B=SHfPX:2RXZ:FUYH2SHf=00B>SXj=SHf=SHf?Shl2SXj>00B?ShnNWYjF
UYJ7QhL2QHF500J8R8RJVYZLW9b=SHfBTY:DU9@2T92@00nBTY:ATI6BTY:A
TI6BTY:ATI6<S8b4Q8B8R8R@T92ATI6BTY:@T92=SHf?Shl00Y6AT@04TY:B
U9BDUIFEUIFE0YBDU003Ti>CTY:BTY:B00:ATI401i:BTYZJVZ>SXijNWYZJ
VY>CTi2@T004TY:B00>ATI6BTY:BTY800i:BTP04Ti>CUIFEUYJFUiNG0YVI
V@05VYZJVi^KVYZJV9RHUYJF00:EUID00i>CTi:BTY6AT@02TY:B00FDU9BI
VIVMWIfFUYJ>SXh0;<c<c003IVIVooooc<c<0?o<c<`ac<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<060b;1@c
;19CBR_Me;?ajLFXWh1ABc50?Ba2@SYBE5=7B4YADUAFEe9MGE5LFDJ<SG]S
KF8G8aTX:Q`]9a5:>AgG_igcdja^Bb>5HSZIMe5mGSmdFSmjJ59/Gdi/HeA_
J5i_K6ESH5U9AC`Q6Q18@3EdJV1cJEmcJEe`IUYNDTA/G4enK5R6KUJAM5JQ
P5ndTFVcU5jYS5BJPe6DOeB;N5N1L5AlIe9jHe>=LFFQPGKVa;S7YiRHOFZ3
KEJ4M5YkKeMmMF9hKf1cJU]dJeagL61lMF=lMfAjMEmaKE9nNE^=QF6IRfJV
SfJaU6ZlVVg3WW;6Y7O5Y7^bU6jIPEn?Nf2;O6MoN6QeLFI[J65]JVE]J6Af
KFRUV9;C`;ZVShVBNG8[c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
00k<c<`2QhN700F<S8bSXj>VYZJJVYZ<S8`00XZ:RP09SHf=Rh^;SHf=SXj>
Shn?SXj>UiNGTI6AQHF500:6QXH02HV9RJ2PX:BTY8f=SI6ATIBDU92@T8n?
Si6AT@02T92@00JATI6BTY:@T92;Rh^4Q8B:RXX4TI6A00J>SXj?ShnBTY:C
Ti>DU9BFUYH2VIVI00FGUiNFUYJEUIFDU9BCTi<00Y6AT@0;U9BDUYJFXZ:R
WIfMUIFETY:BTi>CTY:BTi>CTY:BTI6A00:BTY83Ti>C00RATI6CTi>EUIFG
UiNHV9RIVIVJVYZKVi/2W9bL00JIVIVFUYJEUIFEUIFDU9BBTY83TI6A00FB
TY:IVIVPX:2HV9REUID0;<c<c003IVIVooooc<c<0?o<c<`ac<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<060g
<aHP701GDcJPWh7ThlNQXHTc=28h>2a8BD=3@d53@d=@D51NGE]KEeABCDUA
CTU1@chS:24X:1h/9QY:?bg0/9WPb:aPABN1HT>DMUAdEcUeFd1hI4a^Gda[
GdmXHUAcLFAeMVQ0?RlL6@YHDD5bJEQlKeb5MV62L5Q_Fd9oJTn:MER;MUVF
Pf>OS6b[UG2aUVNWSEZNQURKQEbCP5n5M5QnK5AnK5R6Lf:BOFbFPG2EP6fD
P6R?Nf:<N5f=O624MU^4MUamKEB0L5VBP6ZGPVf:MF24L5QoJe24L4n>MU2N
PUZcTVG0VVW:XFgEZWGAZW76XFZlV6BXRE^@MU64Ke:2LeioMVM/HeaRFeE^
IV>3N7BMS8C0[:75ZijMPW4[c<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<00k<c<`02HR8R8B4Q8f=SIZJVZFUYIZJVXR8R8V9RHb<S002Rh^;00>=
SHf?Shn>SXh00Xf=S@0:RXZ:QXJ6QXJ6QXJ6RXZ:WIfMXZ:RS8b<TI6AU9BD
0Xn?S`0?TI6AT92@T92@T92@TY:BTi>CRXZ:Q8B4SHf=TI6ATY:BU9BDTi>C
Shn?TY:B00:DU9@01IJFUYNGUiVIVIVIVINGU`02UYJF00JEUIFCTi>BTY:B
TY:CTi>EUID2UYJF0YFEU@0AU9BDUIFETi>CTi>CTY:BTi>CUIFEUYJFU9BD
Ti>CTY:BTi>CU9BDUYJFVIVIVYZJVi^K00:MWId019^KViZJVYNGUiBDU0>C
Ti<01I2@T8n?Si6ATIBDU9RHV002WIfM00>FUYK<c<c<c<`0:/c<c003IVIV
ooooc<c<0?o<c<`ac<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`00fIVI_ooolc<c00>c<c<03T/:Q<d=1b9R7>_/Ic:cKZ?TH<W:adm@3Do
@3Q2@Ca5A3m=BTEED4YAC4I<@ci8@cln?cXR91lO81/[:24n>2alLf:IR7AL
ARj0IT^BMeYcF3]eGD=hIU1`He1^IEIZI5IYJ5I^Kedk>RPY:1ICCS]eKEYn
LUb?OfJ@OEn1JT^=MUJFOenAOUjCQ6FDQVVGRFJHPENLPEBNQEbQRF>LQFF?
NUf8M5b8Lej4LUh00XMeH@0URGMQTgmVV8=XVX9VWHIWUH9QT7eLQG1ARW9F
WhAYYHM]UgUOSW1DT7=CUgUEXH5J[XaO_YIUaIYWcIiXeZQ]eZY]bj5U`YUQ
/XaKWWeDT7IERWINPWETOWA[K6EOLV]UNG9ZVXf4jm_<m^C@Xhii02_<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c007QXJ6R8R8UYJFWIfM
XJ6QUiNGQXJ600>:RXX018^;Rhb<S8f=SHb<S0:;Rh/05hZ:RXF5QHF5QHJ6
QXV9RI>CTiNGUhb<S96ATIBDU8n?Si2@T96ATI2@T96ATI2@T96ATI:BTXV9
RHJ6QXb<S9:BTY>CT`02UIFE00BBTY:DU9BEUIFEUID3UYJF00JEUIFFUYJF
UYJGUiNFUYJDU9@3Ti>C0iBDU003UIFEUYJFUYJF00:FUYH02iFEUI>CTi>C
TiJFUYNGUiFEUI>CTiBDU9FEUIJFUYRHV002VYZJ00NKVi^MWIfMWIfKVi^J
VYZHV9REUID00YBDU0:CTi<01i6ATI:BTY>CTiNGUjFUYJJVYYRHV00/c<c<
00=VIVKoooo<c<`0olc<c37<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1Lc<c003IVIVooooc<c<00k<c<`0H3ll<d10=VUYGgEgK8j?QfmbJB//
93Hh;D92=TY;?Di<?Dm<>EUD@5eG@E]@>U9=>T]>Able<b0T8bla;3dm<de7
>EmD@Ui=>HA`F91jHV]E?FUG@FmPCFmVEgMaIGIdIfm`H6QYFBX[6b`Z6dU6
=gmhIXEjIY>4KI>2J8MdEY1kG9R3I9F2HYF6Ii>5J9>3HY9iDIinEj>5Gj>5
Hif0HYQmHYYnJ9f2Kj25LYb1KYAiIYAiI9n3KJB6KZ22J9n2I:B<JYj6HYIl
FIUlG:N6IjZ7JJ9oHIikFiinF:R6H;BAIknJKLNMJlfOJmJTKmj[M>BaN]RV
LLbLJkbAI:V3G9]lGHmiHH=dHGUaIVeZHG1`J6i`IHj<On7NcOG^fjZTSR_<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c009RHV9RXZ:TI6A
Ti>CUiNGTY:BQhN7RHV9RXZ:00><S8`00hf=SHj>SXf=S@02S8b<00V8R8R5
QHF7QhN9RHV;Rh^>SXj=SHfCTi>DU9@00Xj>SP06T92@TI6ATY:BTi>CTY:B
TI6A0XJ6QP03Rh^;U9BDU9BD00:FUYH00i>CTiBDU9JFUP04UYJF00FDU9BE
UIFFUYJGUiNFUYH00YFEU@03UYJFUiNGUYJF00:EUID01YJFUYNGUiJFUYJF
UYNGUiJFUP:EUID2UiNG00JFUYJEUIFEUIFGUiNIVIVJVYX2Vi^K00VLW9bN
WYjOWinMWIfKVi^IVIVGUiNEUIFDU9@00Y>CT`07TI6ATY:BTY:BUiNGY:BT
YjNWVi^K02c<c<`00fIVI_ooolc<c03oc<c<<Lc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<c01P:RTW>CTg?Cdk
CU1=GEmJ@T@o;c0X<38WBDXlEEA0EU@mEe<hJ654NW5@N6i;JVE8IVQMB4i:
;34[>3TcCDY1CdTkFDhlI5E0QW9JTgeUL5a4Kee7M6EBMVeLPgeaPGmbOGi`
K6eO:b`N9RLI>SP[MW=TQWm]ShA`SWmXQgILS7QMT7eOSgiPThAWU8I[TX=T
UgmKXXIQYXUWXHATVgeQVWmTWh=]XhMaXhMbX8A_VWiXWH5[ZH]cZhecYhU]
YXU[Y8]/Xh]YXXQWXhIVYXEVY8=TYXEV[Ha[YHMQ[Y5Y_Yieb:IibZAgd:Eh
fZiohkF4iKF4fJUhbIe^_9=WZhQPWh9PTWeRPW=NNW=SMG=VLG=XM7I[QhMk
YZBE[JZIW9V6:lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<
00V6QXJ9RHV:RXZ=SHf?Shn;Rh^7QhN8R8R<S8`00hf=S@08Shn?TY:BTY:B
T92@TI6AS8b<QhN7RHV90Xb<S004SHf=SXj>Ti>CUIFE0Xn?S`0=TI6ATY:B
U9BDUIFEU9BDTI6AQhN7QXJ6RHV9Ti>CUIFEUYJFUIFE00:DU9@2UIFE0iJF
UP05UIFEUiNGUiNGUYJFUIFE00:FUYH3UiNG00BEUIFFUYJHV9RHV9P7UiNG
00JFUYJGUiNHV9RGUiNHV9RKVi/3W9bL00VNWYjOWinOWinMWIfKVi^IVIVG
UiNFUYJEUID00i>CT`06TY:BTi>CUYJFVi^KW9bLVIVI;<c<c003IVIVoooo
c<c<0?o<c<`ac<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`0
0fIVI_ooolc<c00>c<c<03PT92Hb<cDb=3=<CTeBE54g?3He>2lj?2m6AcMH
Ed9OGT9RGd1dKTZ6OUN7OUEmME5eLV5EED/j>2a5@CEKE4ATFDM/GDQ^FT5l
I4R?MUQiGdAnJDimJe=lKER0M6AdKUi`KUmWJ5Xk?C0X:Qla<BMPH5AnNVj4
OVj2Mf>6Mf28N5j;NUj:Nej=OV6@PVN<OV6@P5nKR6NOS6^KQVNFPF:HP6BJ
PVRIPFL2V7iU02JFO6>JP6NQQfbPQV^MQ6JOR6VKQV^IQ6VNQVZRR6fOQFZP
QFRWSW2`UgRXTG6_V7JlYX72ZXC0Y7o7YX?C/HcH]Ho?[H36Y7JnW6jeUVZ[
SVBQRF>CP621LeQlM5mdKUiaKf9nO72:QWZ<QWZ>Q7RES7d[c<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<00k<c<`01HJ6QXR8R8R8R8b<S8f=S@03
RHV900F;Rh^>SXj?Shn?ShnATI400YBDU006Ti>CTY:BSHf=RHV9RXZ:SXj>
0hn?S`03TI6AU9BDT92@00>BTY802Y>CTi:BTY:BTY6ATHV9RHJ6QXN7Qhn?
SiBDU9FEU@FDU9@4UIFE0YNGU`03UYJFUIFEUYJF00:FUYH3UIFE00FFUYJG
UiNGUiNFUYJGUiL00YJFUP:GUiL2UYJF00BHV9RIVIVHV9RIVIT4W9bL00VN
WYjOWinMWIfLW9bJVYZIVIVHV9RGUiNEUID00Y>CT`:BTY801IBDU9JFUYJF
UYJFUYNGU`0/c<c<00=VIVKoooo<c<`0olc<c37<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`0;410?S<d;cDg
<TE7@Ti@Bd]@BCPk<3a0<TI9>5YLAfMWCFQWBG9]CG]eDGadCgMaCfeXE5I@
@TM1<eQA@FYOCG5TDGe[DgaWC81WBI=hFX5VBHM]DX5]E7a/EG]^FfQQCdY7
>4U9?CHh;B/^9CPk=5QIDG1`IVe[G6iWEH1eHHQjH8alHP:<OF000i21I8Yl
Ghf2HP02T8EU00F=P62=O5jBOf6EPV:FPF800YN0H@0VU7eNUGiOUh1QSgYK
S7MHSgaNTh5YRWQRT7aTVhM^WXQ`WhY_YY5fZYMiZ9MiZYUk]:F6]ZF7[ian
]If1`:J;`:F7_:=k^J5e^:1d]9ea[II/YI9XUXIRPgIFO79GM6aGP7UWRH9b
QWe^U8IiXY:5W8Yn:lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>
c<c<00Z:RXZ8R8R8R8R;Rh^=SHf<S8b9RHV:RXZ;Rh^>SXh2T92@00RATI6C
Ti>CTi>BTY:ATI6=SHf:RXZ=SHd2T92@00FBTY:ATI6ATI6DU9BATI4019:B
TP08T92@Rh^;Rh^;RHV9QhN7RHV9SXj>TY:B0Y6AT@03Ti>CU9BDU9BD00>E
UID029BDU9FEUIJFUYJFUYFEUIBDU9FEUIJFUPJEUID2U9BD0YFEU@03U9BD
UIFEUiNG00:GUiL019RHV9VIVIVIVIVIV@:KVi/2VYZJ0YbLW0>KVi/019ZJ
VYVIVIRHV9JFUP:CTi<01i:BTYBDU9FEUIFEUIJFUYRHV9NGU`0/c<c<00=V
IVKoooo<c<`0olc<c37<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVooooc<c<00k<c<`0>4Q9>D=4=4Y=?4mCA4eA@eIJC3]1<c@k
:dQ<?DmC@U5D@E1B?EED?eEC?55?=U=>>4m:=e9;>e=<?6ELBgI[FGe^FHId
G8QcF9=kGj27JHU`DXeeFHMcFXAdGH9eHVYSDBhZ7Rd_92DX8BX_:3Tn>4U>
Ae=FCDm?@eeGBGYbGhIjHXinI8ioHXelH9:1IH]mH8n9JHb7IhV3HhMnGHUl
G8enGIF2HIR5I0>AOE`09IR4Hij:JIN4Hi5nGI60HY:2JhIeHh]jIYV7LIZ6
KYN6K9f<LYj?LZ6CMYfBMZJMP:NMPYb@N:>BOZbJQZJDO:VIMjZKM;2NMZnN
Lj^JKjZIKZ2AJ963GXj1HHYnI8n3KI:3L8elJYN2LJ29NIb2L`0[c<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`00h^;RhZ:RXb<S002SHf=
00B>SXj:RXZ9RHV<S8`5SHf=1Hb<S003Shn?TY:BTY:B00:CTi<019FEUING
Ui>CTiBDU0>CTi<0392@T8J6QXN7QhJ6QXN7QhV9RHb<S8j>SXb<S8j>SY>C
TiBDU0FEUID2UYJF00BEUIFDU9BDU9BEUID2UYJF0iFEU@03UYJFUiNGUYJF
00:EUID00iJFUYBDU9BDU003UYJF00BGUiNHV9RHV9RHV9P2VYZJ0YRHV004
VYZJVIVIVIVIVIVI0YZJVP:IVIT019RHV9FEUIFEUIFEU@:FUYH019FEUIJF
UYNGUiJFURc<c<`00fIVI_ooolc<c03oc<c<<Lc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<c00hHF12Hf96Cdle
DE<kDE@oHFIBEEa:=C`/@DTj=clb:C4T9R`P;C0U:bhS92HK8b<G;bdPBDHg
De11Hee?NG9RPGQWQGQUPgAMRgUQUh=ZPFeDR7INQ7EPOgARN75QFUI:92@J
:R/S8RLQ;S@`;C<_;C@]<CH_>S`aEeA5Ng=PR7aTSWiTSGaPRgQJTWmQRgaM
THQYShUYTHQYTXMWThASTh1OU81MUX1K0YMoF`0VVX9NYHeY[iMeYXm]Uh=P
TWmOUH5YRGMQU81XWXYaUh9WTGaOUX=UVHQZV8UZThQZW9=fWYAiUHUcW8ej
Y9>1VXUeV8U/Vha[XY9^YYA^YiE][I]c[YadY9E^U8ISSh9RPgEJRg]RXHmg
WhUbUWeWXhQc:lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<
0Xn?S`0:S8b<SHf=SHf=T92@SXj>RHV9Rh^;RHV9QhN7QXJ60XN7Q`07QXJ6
QHF5QhN7Rh^;SHf=Shn?Ti>C00:DU9@01I>CTiBDU9JFUY:BTYBDU002Ti>C
00>BTY:>SXj5QHD00XJ6QPB8R8P018V9RHf=SI>CTiBDU0:EUID00iBDU9FE
UIBDU005UYJF1IFEU@0<UYJFV9RHVIVIV9RHUYJFUIFEUYJFU9BDUIFEUiNG
UYJFUIFE0YJFUP04UiNGUYJFV9RHV9RH0YNGU`04VIVIUiNGUiNGUiNG0YRH
V00<VIVIVYZJVYZJV9RHUYJFUIFETi>CU9BDV9RHUiNGUIFEUiNG;<c<c003
IVIVooooc<c<0?o<c<`ac<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G<c<`00fIVI_ooolc<c00>c<c<061`JdE/J49XID9KFS]FESYRITmNHdlo
B3M1Bd0mB40M:28?6QHK9B@H8R<D7QlJ8b8M8Q`f>C98BdAPHeaMH5URHe]U
HUUUHEE`J5^8PG5WH51SGDmVHUMOGeMFFE97C4HR9AhT9R4T:BDY;bd]<c4Z
<2``=Bi2A3M^JeYoMf:>P6JBPFFGQ6BNRFZMR6VFPf>FQfZGR6^IR6ZLQfRK
Q6BKPF2RQ62YR6F]RfJNO5NTPUniV7FiV7NVR6JJOE^HOUfMPVFNQ6VGO5nR
QFNVQfRJOE^KPEjJPUbEPEbOSFVTU7:OSfjGQVZGPfZJQVjNR76USgNPR6jT
SFjUS6fVSVZWTFZRSfNVU6jLSVVBQF:=P62@Pf>HRFZLRffKR6ZHQFL[c<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`01i6ATI2@T92@T8j>
SXf=SI2@T8n?S`03Rh^;00F6QXJ3Ph>5QHF5QHF4Q8@00XF5Q@04RHV9S8b<
T92@Shn?0i2@T009TI6AUIFET92@Shn?T92@Shn?SXj>S8b<QHF500:6QXH0
1hN7QhR8R8N7QhR8R8Z:RY6ATI>CT`02UIFE00>FUYJGUiNGUiL029JFUP04
UiNGV9RHUIFEUYJF0YZJVP03UiNGUIFEUIFE00:FUYH019FEUINGUiNGUiFE
U@:FUYH019FEUINGUiRHV9RHV0>FUYH00iNGUiRHV9NGU`06V9RH00BGUiNF
UYJEUIFEUID3UiNG00>FUYK<c<c<c<`0:/c<c003IVIVooooc<c<0?o<c<`a
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<
c00>c<c<03MmLDMjLDQbJT=^JTEkMeZ2PVQdMfAPIeM1Bd8iASlL:bPC8B8B
82<:6Ah?7RDC7R8F7ahg?CU;DDm=De5?EE=?EE55Ad9BDdeJFU1dLVIDDDQ?
CdECE4i>Ddm5CTdj@d8O9B4P9B4S:BL_=C<d>SPY<2Tc=ReACd:1NVN;OfNF
QFVMR6VPRFNOR6JOQfFNQfFFPF:LQfRQRVZOQfFMPf2QPenWQF000ZZ7H@0W
YX=M[HMR/XiZ[8QTY89MYHAQZ8YXZhi^Y8MWVgeKYXERZXUVY8ANYhYRXXIN
WXMNX8eUXXiYW8YVUX5RUX5TWXI/Xh]cY8YcXHM^YH]`WXEVVh=QYHmZYY9]
Xi=_Y9MdVY1]TXMWTHIVUXUYW8e/X91^YI9a02_<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`03/c<c0:BTY82TI6A00NCTi>EUIFCTi>@T92;Rh^:
RXZ6QXH00XB4Q005Ph>3Q8B4Q8B4Q8B4RHV900B=SHd01X^;Rhf=SHj>SY:B
TXf=SHb<S0:=SHd03Hb<S8Z:RXF5QHF5QHJ6QXR8R8V9RHN7QhR8R8f=SIBD
U9FEUIJFUP05UiNG00BEUIFFUYJGUiNGUiL2UYJF0iNGU`05UYJFUiNGV9RH
UiNGUYJF00:GUiL00iRHV9NGUiFEU@02UiNG00BFUYJGUiNGUiNFUYH3UiNG
00>EUIFFUYJGUiL019NGU`:FUYH3V9RH00>IVIVGUiNFUYH00YJFUP03UiNG
V9RHV9RH02c<c<`00fIVI_ooolc<c03oc<c<<Lc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<c00gOfe5S7eFSX9L
T8ISUY5dQH=ZIfQFFV5AAe58?4U26RTV4b<S3QdP1QPJ4R@X3Q`M61hL=cTd
Be1<Be5=D5IDDEMCDeE@CTm9GUiFMWI/EEE=Ce18DUA?C59>ATm>>TA37RLV
82HT8b`[<CLe;S@`9RTR@T8fO7MTTXQ_U8EXVhMVY8aXY8YUWh=LW8=KXHMR
XHUUYY1[ZI5]YXaWY8QQZ8YT[HeV00:^SF@09k2?I[FBJ[2>J:R6H:b<IKNG
LKZLN:bBKj67IYj1GjN9IJJ5HZ>3GJR:I:>7H:F>IJ>@J:>?JYj<J9V6IIV4
IJ::KZZBN:N?MIj6JZ:;K9Z3I9EnGYn;JZFBLJ>DLifBM9V@LiR?LYbAMJ>D
MjNFN:fHNK:KN`0[c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<
c<`04Y:BTYBDU9FEUIJFUYNGUiFEUI2@T8n?Shb<S8^;RhJ6QXF5QHB4Q8>3
PhF5QH>3PhB4Q8V9R@>=SHd01Xj>SXf=SHf=SHn?Si>CThj>SP>=SHd01Hb<
S8Z:RXJ6QXF5QHJ6QP02R8R800>6QXJ:RXZCTi<00iJFUP:GUiL2UYJF0YNG
U`:HV9P3UiNG19RHV004VIVIV9RHUiNGV9RH0YZJVP03V9RHUiNGUYJF00:G
UiL00iJFUYNGUiNGU`03V9RH00JGUiNFUYJFUYJGUiNIVIVHV9P2UiNG00>F
UYJEUIFGUiL00iRHV0:GUiL2V9RH0YVIV@03VYZJc<c<c<c<02[<c<`00fIV
I_ooolc<c03oc<c<<Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVKoooo<c<`03/c<c00PRWA=WXYUZIMcWi1_RH1SJ69:CdhjBD/m
EEeBC5I>7BTU3QdJ4AlO31`L5BDU31PH6adHAdI1EUMADE=>DeE@B4Y5FeaG
EEA?HUmHNgQ_FEI=DU9:E5E?DE=@Be5?@DY90R8Z;00>9Bh];3Db;34[;2hS
EeA3UXigXI9eX8a[Y8YU[8mW[hmVZXYQYhYPZHiS0ZfDJ`0^[9=ZZY9VZI5U
[95V[I9W/9=Y[i9X/Y9Y]IE//Y9Y[I1V]9M]_J1f^img[IEaY8aZZi5^]9Me
ZH]WYHMS[Hm[ZXiYYhmYYY=[Z9I`YiEaXY1/Wha[YI1a/9Uj/IYjWhQXX8UY
VhMVU7mPUhIXUhQ[ThM]QgmXQGeXQWiYT8E_VX]dWXecWXU^WXIZ:lc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<00JCTi>GUiNIVIVHV9RE
UIF@T902S8b<00>>SXj=SHf6QXH00XB4Q006Ph>3QHF5Ph>3Q8B4Rh^;SXj>
0Xf=S@08S8b<Shn?SHf=Shn?Ti>CSXj>SHf=SXj>0Xf=S@05Rh^;QXJ6QXJ6
QhN7R8R800:7QhL00hf=SINGUiRHV002UiNG0YRHV0:GUiL00iRHV9VIVIVI
V@05V9RH1IVIV@0:V9RHVIVIVi^KVi^KVIVIUiNGV9RHVIVIV9RHUiNG19RH
V0:IVIT00iRHV9NGUiRHV002VYZJ0YNGU`03UYJFUIFEUYJF00:FUYH019FE
UIBDU9FEUIJFUPBGUiL/c<c<00=VIVKoooo<c<`0olc<c37<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`03J>9
I:VAKJnHMYf:JW]]D6QNAF5LB5QFAf1REEiTFR`c:a@M61/V8P0262<O01dD
6QHV8QU?Aca_J5iTH5MPGEIEDT]CD4UEDDQQFU1jLfUKDdQECTAGDdYCDTeB
Ddi9CTXT;2hR;2hV<34/=C8`=Bho@39XHDjDQV^TT6nUS6BWRUj^SF000[>A
H`0</Y5T/95S/YMXZi=SZY9R[iMW/YYZ[YQW[9IU[IMX[YQY[IEW0[2HJP0T
[iAW/IIY]IY]/YY^ZYM_X8aY[9Ec]9ajZi5^[8m]/IAb[I=`ZI=^[9Qc[iei
[9ahZ9IbYI=_[IUh]J5n^:9kZYA[Y91[VhMTTh=RTh=YP7EOK6ECHf1AGUY>
HU]ALf]PRge`VXUiWhYeWHM`:lc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c00>c<c<00FGUiNHV9RIVIVGUiNBTY800Xn?S`05SXj>Shn?T92@R8R8
Q8B400>5QHD01X>3PhF5QHb<S96ATI2@T8n?S`>=SHd00hn?Si>CThj>SP04
SHf=00B<S8b6QXJ6QXJ7QhL2R8R800B:RXZ@T92FUYJHV9P2UiNG00>HV9RI
VIVIVIT00YRHV003VIVIV9RHV9RH00^IVIT2VYZJ00BIVIVGUiNIVIVJVYX2
V9RH0YVIV@07V9RHVIVIVYZJVYZJVIVIV9RHVIVI00:KVi/00iVIVIRHV9JF
UP02UYJF00NCTi>@T92?Shn>SXj?ShnBTY:EUID00iNGUbc<c<`00fIVI_oo
olc<c03oc<c<<Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<
00=VIVKoooo<c<`03/c<c015[Y9[ZY5Y/YYf[i]jVXU[TXAYRX9]NGAQK6YK
IfMK@d@l;S4Z<SLa<3Da;C8^=3D_@3T_CdLl^kBZ/ZjUJFIOGeaEEeA?EU5;
HemFOgQ^GeQ>F557F5E>E5=>DU=>BDe<8B/]8B`^:cDf:c@_;2lVC4TjOG9L
V8MYX8QRY8MKZhUI/XiL]i5P^9AR^9AT]iEU]iMT/i=P/iEQ^9eX_J5_^Z1_
]Ii/]9a/^Z9d]ima^J5c^j1a]9UZ/YIW]YY[]ia_[YU^XH]RZI5[/iMb/iEa
00>eUg<06;FKM[RPN[RRNk:LLjjHKk6JLKZSN/6XOkjSM[jQMKFILJ28I9b7
J9B4KFUPCd<o=452?3i0?DM9AV1OFgagLHj6Ni>7NI25Lb_<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`03/c<c00<VIVIV9RHVYZJVYZJUiNGUYJF
UIFETi>CTI6AT92@Rh^;QhN718R8R00=RHV9S8b<WYjNWIfMTI6AShn?SXj>
SHf=Shn?U9BDSXj>SHf=SXj>00:=SHd00hb<S8J6QXJ6QP02R8R800B7QhN<
S8bCTi>FUYH3UiNG00>HV9RIVIVIVIT01IVIV@03VYZJVi^KVi^K00:JVYX0
19^KViZJVY^KVi^KV`:IVIT2VYZJ00>IVIVGUiNHV9P00YVIV@BJVYX2Vi^K
00FJVYZIVIVJVYZKVi^LW9`00Y^KV`05VYZJUiNGUYJFUYJFT92@00>:RXX0
0hb<S8n?Si>CT`03UYJF;<c<c003IVIVooooc<c<00G<c<baooooN/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<
c00i[i9V]9U/`:MnaJn8^ZN6[j21[Z::/:RCViB4MG5UH5aCEU=>E51=E5=?
De9@FeMDFeI@If=Jg=WDg=_GIfMUD59?G5iMGemMIfIRPH1kHV5LFeYFFe]I
F5YIEEUJCEEG;3Lk82ha:CDe;S@`;c4VFeI3S81VUH9QX8ALYHEF/HaH_IEQ
_YIR^91M^99Q`YeY_IAP`IIQ_YEQ^Y9O^YIT_ie]`:1a_9e^a:Eg00:oX780
9L2OL[jLKl2KK/6LKkZHJ[2DI:Z>G[NHJ[bJKKfHK;fFJkRAJ;nJL<:PLlBS
M[nPL[JGJ;BFI;fMK<BTLLRTL/JLK<FJKKbBJZf9IJ^=LI1kJ598?R`[9S4f
>Bhi?CA2AD9@DE5LF5ANEE9HC4iDAP0[c<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<00k<c<`02iRHV9ZJVYbLW9fMWIbLW9ZJVY^KVibLW9RHV9:B
TXn?S`04SHf=0Xj>SP05T92@Y:BTY:BTTI6ASHf=00:?Shl01I2@T9FEUI2@
T8j>SXn?S`02SXj>00>=SHf8R8R7QhL00XR8R003QhN7SXj>UIFE00>FUYH0
0iRHV9VIVIZJVP02VIVI00>KVi^IVIVJVYX00iVIV@04VYZJVi^KVYZJW9bL
0i^KV`:JVYX019^KViZJVYVIVIRHV0BJVYX00iVIVIZJVY^KV`02Vi^K0YVI
V@0CVYZJVi^KW9bLVi^KVYZJVIVIUiNGV9RHUIFES8b<QhN7R8R8RHV9RXZ:
S8b<SXj>Shn?SXj>SHf=02c<c<`00fIVI_ooolc<c004c<c<00=VIVK<c<aV
IVH0[VIVIP03ooooc<c<c<c<07S<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`0BkFOM/2]QL>aSKb^Rk:TQjVM
Pl:jXo;[f=;<_XV3MgM`J7I_JF]VHW5/JFmYJFmZIg5WIGE^J8InNibGU7ei
MV]WI6aXIFUVHG9]JHf:Pg1]J6YYI6]]JVU]K6Y`L6A/KTE>Db@]<R<];S<i
=d13>Vi/GhZ3L75UBh]kFXijEIf6GJfDJjV@Iib3Fj26HK:HLjnBJ[RHLK6A
Jin1GIf0GZbBLKFLOK2INK>LOJZEMZVBLj^DMKBINk^PP[NHNJ>9J9J2GIf9
I;>KMK:HLjZ@KJ67IY^1H:^CLKRNNk^QO[>MMP02YiA/01>bWgFhXGNfVW:g
Ug6^SFbUQVVXS7B[UX=mKf8k=2`U9B<Y<C@T<CLU=3/W>CdZ>SXY>CH/>C8]
>S40:lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<00ZJVYZM
WIfMWIfMWIfKVi^JVYZNWYjWYjNRXZ:EUID2TY:B00>ATI6BTY:ATI400Y6A
T@04TY:BUIFEVIVIU9BD0i6AT@09TY:BUiNGTY:BTI6ATY:BTI6ATY:BTI6A
S8b<00:7QhL01HV9RHZ:RY6ATIFEUI2@T002U9BD00>FUYJIVIVHV9P00YJF
UP:IVIT01IZJVYVIVIJFUYJFUYVIV@03VYZJ01:IVIVHV9RIVIVJVYZKVi^J
VYZGUiNEUIFGUiNJVYZIVIVHV9RGUiNFUYJIVIVJVYZKVi^JVYX2V9RH00^J
VYZKVi^JVYZJVYZHV9RGUiNHV9RIVIVBTY:8R8R6QXH00XN7Q`J8R8P/c<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<0:g<c<`00fIVI_ooolc<c01i
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<
c00>c<c<062i/i^e[iN^ZIF][9R[[9ZRXi>`/J?Ad/C=bknPWY:DSH>ITXZS
ViR[Xj6YXj>j/[36][K?_K_Jb<CQcl_Sd<WQclGPc/CQcl?Lc;oSelWhl>?j
m^[oooKloOGio_OZkn]`M7LC5Q/Z;C8Q9RU0ATI>E59=E4e6CDE>ET]WKF5Q
IeUUJE]]LF=?DDAHFTmjO75WJEi^KVIZJV9@CDIJEe9YIV5gLg1ZJFEdMG1?
D4]=CTUWJ6=cKfajMW=^IVAMFUE9CdEIGe=lNVihM6UhNVmEFe5=EDY`N6eo
Og>EThJ2Q7M/LVAUL69jQGF8S7f1PgEoPGI`LFUWJ620PG]mOWQIFUDU9B<F
61LH7B0I8B<F828H8R@K9RXG8RHC7R8H8bD[c<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<00k<c<`2WIfM0ibLW008VYZJWIfMXZ:RXJ6QVYZJUiNG
V9RHVYZJ0Y^KV`04WYjNWinOX:2PXZ:R1J>SX`05XZ:RY:BTZ:RXZ:RXZZZZ
00:YZJT01ZNWYi>CTh>3PhN7QhJ6QX^;R`:=SHd0:8b<S8f=SI6ATI2@T96A
TI:BTXf=SHj>SYBDU96ATI:BTY6ATHb<S8j>SY6ATI>CTi6ATI>CThf=SHb<
S96ATI:BTY>CTi6ATHn?Shb<S8n?SiBDU9>CTiBDU8j>SXf=SI>CTiBDU9RH
V9FEUI:BTY6ATIFEUIJFUP:EUID02Y:BTY6ATIFEUIBDU8j>SXJ6QX>3PhB4
Q8F5QHB4Q0>5QHD00hB4Q8F5QLc<c00[c<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<0:g<c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<062VYYZ[[J2YZj2T
ZZ2TZJ:LXi^OYI^_/ZWQhmS/k>3ooo?oooKooOWooO[lnoWln?OnmOKom_Go
n?Kon_Kon?7on>oomngonNkoo?3omNWooO7mnnoloOGdnO;koo_loofWYJH>
2@dQ7b8B4aDN8R<O9BD^>3L_>cTT<c0S<RlX=c@/>3HkAdLU;c0Y<C</=SLT
<30N:RXh@T<a>C/M8RDb=ST^<CH/<CD]=CPg@D<U;C0`>3/_=3P`<cP^;c@c
=S/g?3l/=C@Y;blS:BTY<S4d?Sde@ClX<S4^=c@e?S/^=c@Y=30Y=C4/>3@d
@3`d?c/d@3hf@T0_>CP]=S=4BDDb=2lV9b4b<bdY:RDO81/T9R<Y;B`P9BPL
92LP:R`M9bT[c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`0
0i^KVibLW9bLW002Vi^K00FJVYZKVi^MWIfUYJFWYjL01:ZZZPbYZJT01:ZZ
ZZVYZJVYZJVYZ@:ZZZX019^KVh61PHF5QH>3P`:5QHD018R8R8V9RHN7QhN7
Q`:8R8P02H^;RhN7QhN7QhR8R8N7QhJ6QXZ:RXV9RHF5Q@02R8R800B7QhN8
R8R:RXZ7QhL3R8R800b7QhN8R8R9RHV8R8R7QhN6QXJ7QhN9RHV:RXZ7QhN8
R8R9RHT4R8R80XV9R@::RXX2R8R800R;Rh^8R8R6QXJ8R8R6QXJ5QHF6QXJ7
QhL2QHF50XJ6QRc<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0[Lc<
c003IVIVooooc<c<07W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVooooc<c<00k<c<`0H9fLUj>TWZNXXjFZY::WXIZQVYfRVj^^
YN_]h_cnlOoom_OgkO7bk?Wkn?coooKnooCooo?ooo;moo7moOCmo?Sno?Wm
o?Wnn_[onoGin?WooOOoooSooo?nooGooo3hnXf7Qc/a;cH^:bXU8A<@2fQW
HYVJUDU;AR<U820R7AHG4UiMFKRd/hZ6QBDO7bHS7QPJ3cXl;/72]<G3]R/W
724M4RTU6Rd[7kBdZ<oAa51@AQXJ41PH3R0M5:bUWNSOf8IgL2@I4ahO6RPZ
9IB?RNGKdYf<Q2<F3RPW8R0R7Hb;Q^CMej:DRb/N5AlN6Blb:gemLm[Hc:NS
V2LQ5D]5>FUQE6iWEgaeIIJ@PU5=@D0n<UADBTY=A3a1>Sa3?38l=2_<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c003VIVIVi^KVi^K00:K
Vi/2VYZJ00BLW9bWYjNYZJVZZZX2Z:RX00>YZJVZZZZYZJT01jVYZ@:ZZZX0
2:VYZJZZZZZZZZZZZZVYZJZZZZRXZ9JFUP:8R8P01HJ6QX:2PY6ATIVIVHb<
S002QHF500B3Ph>?ShnNWYjFUYH2QHF502f4Q8B9RHVPX:2PX:26QXJ4Q8B6
QXJ7QhNMWIfRXZ:=SHf4Q8B3Ph>4Q8BKVi^UYJFDU9B4Q8B5QHF6QXJGUiNT
Y:BHV9R4Q8B6QXJ5QHFGUiNUYJFIVIV5QHF4Q8B8R8RDU9BSXj>KVi^5QHF;
Rh^@T92ATI6CTi>HV9R<S8b:RXZ=SHf<S8`00XZ:RP03RHV9c<c<c<c<02[<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0?oool01Nk^kXR8
R3<c07MgMlc<c002k^k^1Oooo`03k^k^oooooooo02gooomPc<c<00=VIVKo
ooo<c<`0NLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVKoooo<c<`03/c<c00@Thj;WIVFX9nKWIjIXJ>NYjZSXJBMUYR=];JYaLNj
a/Rmc<o6cMC=`lk:_<[:Zk^k0Z>g^006XkFeXk>cXk6aYK6aXjf/XZ^Z0ZF[
Z`16YJZ]WZ>VWjBXXj^^XZV_V9VKMg=ZYYb@MViQ610350h0clbmoOW]]K6U
40X0<bdQ5@/2[J2HooWbi]G>7``6=RDK;B4;Ge<inN_Ann_BCS`V?2XD?RhG
<24:m>G>ooCLSh=]:Ad7ETLb;Ah9h]2looGR_J>B<ad?Bcla<bXKf/ViooCT
ckBS=b0@C3ha=BdP`kFXonoQek^]BS0QCd4d>RhPakFWoo_/`k2O@B`KIE0m
OVaHT7iZ^ZVEi=G2SH9`GUM7GU]<C4do?3ha@4<j@4Hl:lc<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c00>c<c<00>GUiNIVIVJVYX00YZJVP06W9bL
Vi^KVIVIWIfMX:2PXJ6Q0Z:RXP03XJ6QX:2PWYjN00BMWId7W9bL00RJVYZK
Vi^LW9bKVi^IVIVCTi>JVYZBTY82PX:200fQXJ6YZJVMWIf1PH67QhN2PX:K
Vi^YZJVTY:B2PX:6QXJ5QHF=SHd00ZNWY`0/RXZ:QhN7R8R8QHF5YZJVZ:RX
UYJFQHF5S8b<QHF5Xj>SZ:RXW9bLQHF5RXZ:QhN7XZ:RZ:RXWinOQXJ6RXZ:
QhN7WYjNZ:RXX:2PRHV9Rh^;R8R8WYjNZJVYWIfMR8R8SXj>TY:BUIFEW9bL
Xj>SUIFESXj>Shn?S8b<RHV9RXZ:Rh^;;<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c00>c<c<0_ooo`03gMgMIVIV0000008000001VHcITA4A6IV
IXR8R;^k^nk^kS;ooomPc<c<00=VIVKoooo<c<`0NLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<c00AVXn=Z9jL
ZJ6NXIbH[JRR_;V`YJ:INGM[Wif@ZZ^MWZ:DUinDT9fFPYFAQ9VJQ9RGRiJB
00:BUi401I6CSXjARXf>R8^:QXZ6P`02THb904JDS8VCRhR>Q8>CRHRGSHbD
SHF1O6Jl^if8Qf]IF3a6ABVKVWk/j<nESgMNDcmXFdQ^GDfCOFoF_k6kWi=h
FTn8JeV8JdfKOEO6YX2mVgJ8I4:AKD^ELU:CLU6bTG31Xh6LOen;KTjBLeJD
LUJWQ6RhUWZQQV^DNEbLOEjRPfBURVfaUgbfWXJLQ6ZMOf>NP6BRQfc6[9>X
TW^USgRTRVnWRFnkUX>lUX>ZQ76NNFJSOV^DM5n@LEfRQgBTSG^?O6]iJEYT
FdaDCT9:B3a7Acm5ASh[c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
00k<c<`02iRHV9ZJVY^KViZJVYbLW9jNWYZJVY>CTiZJVYbLW9ZJVP02VIVI
00>GUiNHV9RHV9P019RHV0:GUiL2UYJF19NGU`0CUYJFUiNGUiNGUiNGU9BD
WYjNUYJFSXj>Rh^;VIVIYZJVUiNGSXj>Shn?T92@UIFEX:2PVi^KT92@00:B
TY801IFEUIbLW9ZJVY6ATI>CT`02U9BD00BIVIVLW9bFUYJCTi<2U9BD00VG
UiNJVYZGUiNDU9BEUIFFUYJGUiNIVIVKVi/00iJFUP04UiNGWIfMVIVIV9RH
0YNGU`:JVYX00iNGUiFEUIJFUP02U9BD00JGUiNHV9REUIFBTY:?Shn=SHd3
Rh^;;<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<00_oooo^
k^jZZZX0002ZZZ[oool0001VI/aV<laV<iTc<iT00S<cIP03IVIVVIVIc<c<
00;^k^h]ooooH<c<c003IVIVooooc<c<07W<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`05jbRXJVQWjbTX[2X
YJnXX:fTVinGRXb3LXn7M:FMR9nHQHf:MhF7NGn7NWV6O7R2NGinLXN1LhZ4
MXV3MHV3Mhj8O929O`02T8Mn04N6O7:9OgFJSHB>PWJ6N6f>P7FRUXJVWh>F
TG5bKe2JUgRQWWnTXH:c[i:b[I2TWH>_YHbcYi6hZIBiZ9C0[IbiY9?0ZY>j
XH;2Z8?;[HW@/XkA/8o=[8_;[8g<[ho</Y7:/I;E_9g@]iWI`:;G_9oC]IWJ
_jCC_Z7A^Y_J_9[R`J3RbJ[B_j7Hb:kFaJ_TbJcRaJOOaJ[G`j[Mc[OIb[?a
fKobe;cWa[GXakSP_k3Q`K;@/IoF^JOC^JSE_ZcNbkbo[in0M6I?ACU5?c=4
@SI3@cU9Bd00:lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<
0i^KV`:LW9`01Y^KViVIVIFEUIJFUYZJVYVIV@:FUYH3UIFE00>DU9BEUIFF
UYH00YFEU@0AUYJFUiNGUYJFUYJFU9BDUIFEUiNGUYJFU9BDUIFEVIVIVYZJ
UiNGTY:BV9RHVIVIVYZJ00:LW9`00iZJVY^KVibLW002W9bL00JMWIfLW9bM
WIfKVi^LW9bMWId2WYjN0YfMW@>NWYh01J2PX9nOWj2PX:2PX9nOW`02X:2P
00FOWinPX:2QXJ6RXZ:PX:000Z6QX@06XZ:RXJ6QXJ6QXJ6QXZ:RXJ6Q0ZBT
Y0:RXZ82XJ6Q00RNWYjOWinOWinPX:2RXZ:MWIfCTi>;Rh/3RXZ:00><S8c<
c<c<c<`0:/c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<00Co
ooo<c<aVIVH00002oooo00L003=V<l`c<omV<omV<l`c<l`c<iT00c<cIP05
EEEEMgMgZZZZgMgMk^k^02[ooomPc<c<00=VIVKoooo<c<`0NLc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<c01P
Z:N]UYFJVIVKYZ:QWYNAT8IjV8UfYI5hWXMX^9im^j5nZY9^[YMe]J:2Ziao
ZYb1[In5/J:;/JF?/:B>/ZNC]ZjI]ZnL/jbI[JJCT8UfRH9_Y9j8WYR0U8if
VI9h]ZbC`K:KUHE^N6UDd/NaeLffcLN_dm6jc/jfd]Bnd=Bmbm2jb/nidMW2
bm>nd=G1c]6ldM>kb<R^aL2Za/6[_kRU`KZWbLBaa/>`_kjZa<Fc`LBa`/Fd
^KZZ][BU^[NXb<Fdb/Fa`kfWc;n/b[fZa[jYclZf]kJQ^[RS/:NF^:bN^kBT
][2R^;VY`;j_bL6d[:>J]ZnY`kjj^[Fa_KRb][:Y_[Z__KV]dlo3blNkWYb?
I69EATLiBDTmATPk@4@fATXl:lc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c00>c<c<00VKVi^HV9RIVIVKVi^IVIVFUYJGUiNHV9RGUiL00Y^KV`03
V9RHVIVIVi^K00>JVYX3Vi^K01BLW9bMWIfMWIfLW9bKVi^FUYJEUIFJVYZI
VIVGUiNHV9RLW9bMWIfFUYJATI6QXJ6RXZ:QXJ6RXZ:QXJ43XZ:R00>QXJ6S
Xj>RXZ800j:RXP05X:2PWinOX:2PWYjNWinO00:PX:001inOWj2PX:2PX:2P
X9jNWYfMWIjNWP02X:2P016OWinPX:2OWinOWinQXJ6MWIfNWYjKVi^MWIfN
WYjMWIfNWYjOWinPX:2KVi^MWIfOWil00YjNWP07WIfMWYjNWYjNXZ:RXJ6Q
VIVIT92@00>;Rh/00hZ:RX^;Rlc<c00[c<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<00k<c<`01=gMgK^k^fIVIQ4000;oool00b8R8S=VVFIVo`04
IVKo0VHco`03IS?<<c>I<c>I008c<fH01EEEEHR8R;^k^oooc>k^kP0Voooo
H<c<c003IVIVooooc<c<07W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1Lc<c003IVIVooooc<c<00k<c<`0<inV[Y:IWi2EVI>DUY6@S9VBR9^>
OY:0JZ::K[bRPLZ`SKZPOKNNOkFPPJ>BMZZJPIZ9MIZ;N9F8MHj3LHZ1L8V2
LWikJW=bH71^GeMHAUiMBhnAO:6PRijNQXn?MiJANhYnKW5SEVEICEmGBVmY
FeeKC4U:?4Y>?dI<?TQC@d9>@4MEASm=?SQ8>cm=@3A2<c4m;c]6>38j;@02
:c4W02/e>S</<BX^>2l/=blV<bXb@CXW=Rl^>c@c?SXU;R/l@caFF4]SI5IQ
HEUMGEEIFe1IFdiCEDPg>Bhc=2hl?ST`<Rle=c9BEDiHFeAIFeYOH69FFUe=
DEA8C4eGFeaCEeIEFUIBEe5KH5YGFEADEe1>DDY5BT=2Ad51AT12Ad54Bd@0
:lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<00FKVi^IVIVH
V9RHV9RGUiL00YRHV004UIFEUiNGVi^KWIfM0i^KV`04V9RHVYZJUiNGUiNG
0YJFUP:EUID049BDU9:BTY:BTXj>SXn?SiNGUiZJVYVIVINGUiRHV9FEUI2@
T8n?Shj>SY6ATHj>SPF<S8`028f=SH^;RhZ:RX^;RhZ:RXV9RHZ:RXV9R@:7
QhL01hV9RHN7QhR8R8R8R8N7QhV9RHR8R002RHV900>7QhN:RXZ>SXh00Y2@
T007Shn?SXj>SXj>SHf=RHV9R8R8RXZ:00:8R8P01hf=SHj>SXn?Shn?Shj>
SXf=SHb<S004SXj>00B?Shn>SXj>SXj=SHd4Rh^;00><S8c<c<c<c<`0:/c<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<00C^k^k<c<b8R8Pc
<c<2oooo00@c<c=VI/bIVOnIVOl6IVKo0VIVc09V<l`2IS>I0VHcIP04EEEE
R8R8ZZZZgMgM8oooof3<c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<02JLZJnAW::=
V9b?VI^@UYJGVIJIUXn?RGf=Q7FQV8N[XY6;PgIaKF9LGEEKH5YHFUMOFUIS
FeQPFeQLF5MHEeEGEeMAEEA<DU1DFUXkA44e>cUKI5n3RHEcNW=GGUI5BT=?
DDa4AT4_=30V:bLX;RXY;b/29R`Z03PS;2/R:bXR:R`U;BlX<38X<3<W;30Q
:B/S;2/T;BXR:2HP92DV9bTY:RhU:B`T:B`R:RdO:R`O:RhJ9BTR;C4S;3<M
92`e>3eBDDmIFUECG5]DGEaADe9BDDlj=SD`;RlW;2lO:B/V;C<j?D9?BU1@
CU=<D5U@EE]EE5U?CE1DDUEDE5I>CU1BDUAADUA0@DE0A4M7BTm8Be11ATa1
ADi6BU=4B5<j@D/[c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<
c<`01I^KViVIVIRHV9VIVIRHV002VIVI0YJFUP04VIVIVi^KUIFETY:B0Xn?
S`04SXj>Shn?Shn?Shn?0hj>SP:=SHd038j>SXZ:RXV9RI2@T9JFUY>CThn?
Sh^;Rhf=SH^;RhR8R8J6QP:7QhL5QXJ618N7Q`B6QXH00hF5QHJ6QXN7Q`05
QXJ600J5QHF7QhN7QhN5QHF9RHV=SHd2SXj>00B?Shn=SHf=SHf9RHT2QhN7
00B6QXJ7QhN:RXZ<S8`2SHf=0Xj>SP03S8b<SHf=SXj>00>=SHd018Z:RX^;
Rhb<S8b<S0:;Rh/2S8b<00>:RX[<c<c<c<`0:/c<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c00>c<c<00SooooMgMf8R8Pc<`3MgMg<c<`0028cIYT2
IVKo0VJIo`03VIWoIYWoIYWo00MVI_l2IS?<0S<cV@8c<fH016IVIYVIVLc<
c?ooc1oooomPc<c<00=VIVKoooo<c<`0NLc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<c00XX:b/UZ:RUInPUj2O
UYbJWZ2MXj:MW9V@PW]aThb2Ui26NWM`GEiIC59@CUQJDE]MCU9CDe=CDeAF
DUIGE5QKEU]NEEeOE5iODE]M@de>8B//<c/mE5eL=d0o92XX?490ADi==3dl
7bLY5AlP5b4R5R0Q620S7bLZ0QdR:00d7R<Y82<Z82</8bH_:bhg<cHm82@U
9BTX:R`[9bLW8R0S8b4T:2PZ:b`^8RHY7BDW72@V5AdP7B8V9BX^:bhc@d97
FUIGF5IGCUABCUADBda>C4Y=Ad55?STmAd]>ATiABTmCCTiFDTaFDe1IDEAM
DUEJE59CDdm>E5=ADe5BD51@DeEDBdm@>Ci2=CY0=ci6>T5;>D5<>D5>>d9B
0Sa3Db_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c005W9bL
VYZJVYZJVYZJVIVI00:JVYX01iVIVIBDU9NGUiRHV9>CThn?Shf=S@02SXj>
0hf=S@>>SXh2Shn?00f>SXj<S8b6QXJ9RHV?Shn:RXZ6QXJ:RXZ<S8b9RHV6
QXJ4Q8B5QHD00XB4Q003QXJ6QHF5QHF500>5QHD01hJ6QXN7QhR8R8F5QHJ6
QXN7QhJ6QP02QHF500>6QXJ7QhN6QXH00XF5Q@05Q8B4QHF5QXJ6QhN7Rh^;
00:>SXh2SHf=0Xb<S003Rh^;RHV9S8b<00:<S8`3SHf=0Xj>SPF=SHd018j>
SXb<S8Z:RXV9R@F:RXX2Rh^;;<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c00>c<c<0_ooo`06ZZZZ<c<cgMgMc<c<8R8R<c>I0c<co`=VI_l3VIWo
00=VVOmVI_mVI_l00fIVo`03<c?oIVKoIS?<009V<l`026HcVFHcIS<cIVHc
IXR8R:ZZZ]gMgNk^kP?oool00nk^k_ooooooo`0EooooH<c<c003IVIVoooo
c<c<07W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
ooooc<c<00k<c<`04YVLTiRKTZ6TVjNXX:>SVjNTVj^UVJ>ISI:4Mi:2LhIf
IgU[GVaRF6YSFf5NEeYKEE5HD4iHC`9=Edh0BTaFCD]EC4iECE1GCeELEEIK
E3<h<AhQ6QlP6RDV83Pi<dm@BTi@CCe1@2da<2X^;B``;bL[:R/_;SPl>cDi
>Rlc=2X^;b`];c<d>4Y;Cg5bMY:DTdM8@4];?eECAeA@AD]4>Ti7?EUBB5QF
BTU9?dE7?4M9?T=6?DQ9@E5ABE9?B5EBBeiJEeaIE5UEC5]GCUMBCU=?CV]W
J6YVIhj9QI:=QhN3P6YXJEACFDm>E51>Cdm;B51@B51ABDmBBDmBBdiCC4iE
CT=>B3I2@2Da<Ah/;Ah/;b@a=bLd?2Db>`8Q;CT[c<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<00k<c<`2VIVI1I^KV`05VIVIUYJFUYJFU9BDTY:B
00:@T902Shn?0Xj>SPF=SHd3SXj>00F8R8R5QHF5QHF6QXJ9RHT00Xf=S@06
RXZ:QhN7QhN7QhN7QXJ6QhN70XV9R@09R8R8QhN7QhN7R8R8S8b<Ti>CV9RH
Rh^;S8b<00:=SHd2Rh^;00>=SHf>SXj;Rh/018^;R`>=SHd018n?Shj>SXj>
SXj>SP:=SHd2TI6A0YNGU`03UIFETI6ASHf=00:=SHd00hb<S8f=SHf=S@04
SHf=00><S8b:RXZ7QhL00XJ6QP03QhN7R8R8QhN700:7QhL/c<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<00k<c<`2oooo00Jk^k]EEEG^k^k^k^iE
EEEVI/`2IVKo13<co`9VI_l2IYWo0iVIo`03IYWoIVKoIVK<009VI_l016Hc
ofIVofIVofHcc08c<l`01fHcVC<cVC<cIVHcIWMgMjZZZ]gMg@0HooooH<c<
c003IVIVooooc<c<07W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVooooc<c<00k<c<`0>J6NSjJSU;:`XkNeZ;6]XKF_XkN]XK2T
U[2PTK2NT:BBQ9V9NWa`I6iVFeiGCeUIDE9LDdiKDTiKDE5MDe9LDe9IDE=J
DUMMDe]NEd]>Ac0a:bh_:BHU82@S7SHe<De>BE=FCe1ECTmDCE5FCe9GD51C
C59ECUePFEmPFe]LEeaKEeeLF5aKEf=OG7UeLY6>Qfm]HF]XFG=]GgI^HG1V
FWM]HGmeJGM_HWMcI`02LFmR02EcLFAjMVYnNfabK61NEde?CdMAD4]IDTYM
ETiBCdQ:BDEfMWAlOGR0NgF6OgUhMG1NGEU:CTe>D4mHEe=JFEACE4iAEU1@
EDm?ETm?FE5<ETi9E4i<Ee55D4a3CTY6Cda<DU1?De9@DU5@DE=ADU@0:lc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<00FJVYZKVi^MWIfN
WYjLW9`00YfMW@:KVi/01IZJVYRHV9NGUi>CTi6AT@09SXj>0Xn?S`08S8b<
R8R8QhN7QXJ6QHF5R8R8S8b<SXj>0hf=S@03SXj>SHf=SHf=00N?Shl019>C
TiNGUi:BTY6AT@:BTY801I6ATI:BTY>CTi:BTY>CT`03TY:B00BCTi>DU9BB
TY:>SXh3SHf=00B>SXj=SHf<S8bCTi<2U9BD00FEUIFCTi>?Shn<S8b=SHd0
0Xj>SPB=SHd018j>SXf=SHf=SHf=S@><S8`5SHf=;<c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c00>c<c<0_ooo`06^k^kEEEEk^k^gMgMEEEEIVK<
1fIVo`05IS?oIS?<IVKoIVKoIYWo00FIVOl016JIofIVofIVofIVo`<c<ol0
0fHcofHcc6Hcc002IS>I00Hc<fIV<fIV<fJIVIVk^k_MgMd4oooo00?^k^ko
ooooool03Oooof3<c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<062fZiVe[IZk]::i
/jFaZing/:Jo]Zfh[jJ/XYRMThV3NFmgKVESG5APGEILGEQQIfEEHF5BH65D
H61FH5mHHF1IGeeIGEaLGU]PHV5DE5@[:b/e=CM8B4Y6ADXo@4EDF5UBG55O
K5]WM6=YM6A[LfAZL69/L69aLfI[JEa]JEegLFF3Ng24NW1oLVV0LfZ6O7>2
Ng5hM6]oN722NG9lLVV2N6n8OWEmM6^4OG=nNVmiMFYjMV^2Ng67OgAnM6]W
GUEHFE5FFeEKGEaOHF1EFUI<DDYaN71bNG9eNGQbMWMXK6]HGUY;EDa9Dd]=
De5>DeI<DeU;DUQ:DEM=EEQ<E5I9Cde?E51OHU]jNW:3OgB:P7B7NFb6MFF=
N6NFOfnNQ7D[c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`2
W9bL00ZNWYjMWIfLW9bMWIfNWYjMWIfKVi^HV9RDU9BBTY83Shn?00>@T92?
Shn?Shl01Xn?S`07T92@SHf=QhN7R8R8S8b<Rh^;RXZ:00:>SXh00i6ATI:B
TY:BTP04TY:B0Y6AT@03TY:BU9BDU9BD00:CTi<00iFEUIBDU9>CT`02U9BD
00JCTi>DU9BEUIFCTi>EUIFDU9@2Ti>C00BDU9BEUIFCTi>?Shl2SXj>00B?
Shn@T92>SXj=SHd4Ti>C00>ATI6?Shn=SHd028f=S@04S8b<SHf=T92@U9BD
0YFEU@>DU9@00iJFUYNGUlc<c00[c<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<00k<c<`2oooo00Jk^k]4A4C<c<bk^k/c<c<c<iT7IVKo00=VVOmV
I_mVI_l01VIVo`>IVOl2IYWo1fIVo`04IVK<IS?<IS?<IS>I0c<cIP04IVIV
VIVIc<c<k^k^4?ooof3<c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<01RcZijb[:2e
/JJc/:N[ZZFa/:be/JjZYj:NVI>?R81iLVQaJV1YIEYYIUeWIemXJVEWK6mT
K6mTJFaTJ6UYJFU]K6Y]JFIZIV<2JFER015AD4iCDe=8BD]>DUE>DeM@EUI@
FU5OJUYUL61TK5eUJeeWJeeWJEaXJ5acLFA^JUi^J5`00W9ZG`9_IE/0;g9Z
GfeYH6]XHG5/IW5ZI6UPFFaQFg1WH6aUGFENEV]WGVMSFVIREfURF6UPEfUO
EUiEC65NEE]LEUQHF5eMGEaMF5MHD6MYGUmPF5mQGUaNGEYLFE]NEeYMDUMJ
CeEGDU=GF5EFFe5DFEEFFeAHFe1DEE1BDEMHDemOEg5_Hg=]GgEYFGY[F8]f
Hif7LP02Z8eh:lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<
0YbLW0:MWId029bLW9fMWIfMWI^KViVIVIJFUY>CTi6AT@:@T907TI6A00>B
TY:ATI6ATI400Y2@T0:=SHd00hb<S8f=SHf=S@02SXj>00>@T92ATI6ATI40
196AT@03TY:BTI6ATI6A00NATI4019:BTY6ATI2@T92@T0:ATI400hn?Si6A
TI2@T004T92@00B>SXj?Shn?Shn>SXh2Shn?00B>SXjATI6?Shn@T904Shn?
18j>SP03SHf=SXj>SXj>00:=SHd028j>SXn?Si:BTY:BTY6ATI:BTYBDU9NG
U`:HV9P/c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`2oooo
00K<c<aVIVKMgMgMgMeEEEDcIYT6IVKo1VJIo`MVI_l00fJIoiVIoiVIo`02
VIWo1VIVo`9V<ol016IVc6Hcc6HcVC<cV@8c<fH01FHcIVIVVJZZZ/c<c>k^
kP0<ooooH<c<c003IVIVooooc<c<07W<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`07ZN_/JJ^/:bf^:nh_J^f
_;2i`:jc]i^OX7=bKX=nN8n7O89iJWA[FW]cH:NOS<g6]]G=b]K=c]C:bM?8
a]g@b^[Ke>_Me>CHc;b`Y:fUVZbXWK2`YVU/IDmFC`9BFeH015UKF5iNG5eM
FeaLFP9QH5`01emNFV1OFe]LEUYKEE]LE5iQF61SFP02GVAJ00EOIE]JGEAP
HEUUIEeTHEX00UmKDP0JHemFIF9IGE]?Jf]OIfMKIfQJJVQKI61DJ69FJV1F
Kf9JKf1IJUeEKV5IKf9JMFQPLfINKf9JKfELKfEKLFMNLfUPM6YQLVQOKfEK
KVAK0VmRG00>LFIPKFAMIV5KJfQOIFEKDE=8BDa1A4PjBD/nHF9DP7iaUY:6
ViR9VYB6:lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<0YbL
W00>WIfMWYjNWIfMWYjNWIfMVYZJTY:BUIFEUYJFU9BDTI6ATi>CVYZJXJ6Q
0j:RXP06XJ6QXj>SYJFUYJFUY:BTWIfM0Y^KV`03WIfMTI6ASHf=00:>SXh<
Shn?192@T0:?Shl2T92@0hn?S`04T92@Shn?TI6AT92@0Y6AT@03Shn?T92@
T92@00F@T902TI6A00>@T92ATI6ATI400Y6AT@04TY:BTI6ATI6ATI6A0Y2@
T00>TI6AT92@T92@TI6AT92@SHf=S8b<Rh^;S8b<T92@U9BDV9RHVIVIV9RH
;<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<0_ooo`06^k^k
IVIVooook^k^IVIVIVJI0fJIo`EVI_l3IYWo19VIoa5VI_l00fHcoc<cofHc
o`02IS?<0c<cc0<c<fH00gMgMk^k^mgMg@08oooo00?oolc<c<c<c<`0G/c<
c003IVIVooooc<c<07W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVooooc<c<00k<c<`0>Yne`9bb_ibf`ifgaYbgb:JmcJ>g`Y>P
Z5QNGY6@Rm?=`MgD`m76//>hX]oG`?gdhookmOoinOgbl?OYi_k_j?ollool
lOoci_c`h?kei^3Jb[^hZG5bI6IXFfM]HFY]HWAaK75/J6]VHfmZIgQcL7Mb
KgA`KGMdKgimN7n0N7n2Mgj4NWn7O868P8>=QHN>QXF;Ohb?Q8j@QHf?Q9>A
QIFCQiJDR9RFRYFERJ>TUP:GV8X09:6OTYfISJ:NTZ^SV:RKTZnQUZbPTZfQ
TjZMU;FXX:nPVk>VX;>VWKF[XKR[X[FXX;FVXKNXXkRZXKRZWkJUWKRZXK^^
YK>YX:jWWKJcZZJVW7YmLT57?DA:@5IID6iaJ7]nMGeoM820MXF5Nb_<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c003WIfMW9bLWIfM00:M
WId02ijNWYfMWIZJVXn?SiNGUj:RXZ>SXj6QXIjNWZ>SXjRXZ002ZJVY00>X
Z:RWYjNXZ:P00ZVYZ@:XZ:P01JVYZJBTY9jNWY:BTY2@T002TI6A0Y:BTP:A
TI42Ti>C00>BTY:CTi>DU9@019FEU@:FUYH00iNGUiJFUYNGU`02UiNG1IRH
V008Vi^KVIVIVIVIVYZJVIVIVYZJVi^KVYZJ0i^KV`03VYZJW9bLVi^K00^L
W9`01YfMWIbLW9bLW9fMWI^KViBDU0:;Rh/018j>SY:BTYBDU9BDU0:EUID/
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`2oooo00Jk^k]E
EEGMgMg<c<aVIVIVIYT7VIWo00=VVOmVI_mVI_l00VIVo`03IYWoVIWoVIWo
00:IVOl2IYWo16IVo`03<fK<<c?<IVKo00aVI_l01FIVc6HcofHcc6HcVC<c
V@03<c=V00AVIVJ8R8Rk^k_MgMd5ooooH<c<c003IVIVooooc<c<07W<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<
c<`0=92da8nfahnich^idHZidi2leHjcaX>OZgV8RhR?R:FSU[nhY/o8]McG
`mSE`/G3]/2o^nWWj?[imo[imM;>bkVf[nSTfooom??]hL[4][B^X:fVUZ:K
RjbUUK^dY;:[VK^dX[RaWkF]X;>[X;B[Y;J]Y[>ZXJjXW;B^WZfZUjn/VJf/
VZNXVZb/XZf/Z::SWJ6UUZFYV:NZVJBWUP:UXi@2Yj>G00BVXYJXY9RTX9BP
W903XYjC00nUXiJWYYBPWhfIVXRUYYJQXIFOX9RTXijIV9BKVYJGUY:VXYnR
WY^OVIVVWY`00YnGU00@XYfGX9^EX9fFW9^FW9fGXjBOUINBMgUdE5E?AD@o
MgA]VYF?W9F=XIR?VY27Vhj6:lc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c00>c<c<0YbLW00;WIfMW9bLW9bLWIfMW9bLVIVIUIFEUiNGVi^KWYjN
XJ6Q00:SXj<00j2PX9nOWjJVYP02ZJVY00jRXZ:NWYjVYZJZZZZWYjNPX:2M
WIfKVi^IVIVKVi^NWYjLW9bNWYjMWId3W9bL00BMWIfLW9bLW9bMWId3W9bL
00>KVi^LW9bLW9`01I^KV`:JVYX2Vi^K00BJVYZKVi^JVYZIVIT3VYZJ0Y^K
V`03VYZJVIVIVi^K00:JVYX029^KViVIVIVIVIRHV9^KViZJVYVIVIZJVP:I
VIT039ZJVYVIVIZJVYVIVIZJVY^KViRHV9>CThj>SX^;Ri>CTiRHV0:IVIT2
V9RH;<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<0_ooo`06
^k^kEEEEgMgM^k^kEEEEIS=V0fJIo`VIVOl00fJIofIVofIVo`02IYWo19VI
o`EVI_l013<coc<cc3<cc6Hco`YVI_l01FHcofIVofIVc6Hcc3<cc003<c>I
00EV<fIVIYW<c?ooooo^k^h00_ooof3<c<`00fIVI_ooolc<c01ic<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<
062<^Lj6]/b2]M21^MB5_=Z8^]EkY[UWQi:3UINIX9V/ZYfYY96PVhRYYY?1
`[;De<S[jn?in??fmO3in??dlnkYjN7Ng]Bn_;2VXYN/YYZUWi6OUhZNUHJI
SGnHS7jTV8RESW^FSgbGSWfERgnDRX2ERh6ERgnCRW^=QG::PVf<Q6n=QW>=
QWJ@R7f@Qh:;Q7aoO6f2PFf5PW63OFf1NVZ0NFV2NFZ3NV^3MfV<P7:;Og64
N6b4NVj7OG65Nfn1NVYoNVMiMV>1OVeeLfIjN6b0P7IdM6b7QX65Q7mkN7=n
NgJ?RXB>RX67P7J9PGJ8P7F7P7IoN724OGF>RX68QGikN75jMg21O7J2OWEm
MVjUVi:fZJ2/WY>`X9>`W96gY9H[c<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<00k<c<`4W9bL01NMWIfLW9bIVIVEUIFGUiNJVYZLW9bKVi^IVIVK
Vi^OWinSXj>WYjNYZJVXZ:RYZJVXZ:RVYZJTY:BOWinJVYZKVi^JVYX00YVI
V@:GUiL00iVIVINGUiNGU`06UiNG00>FUYJEUIFFUYH01IJFUP03U9BDUIFE
UIFE00JDU9@2UIFE0YBDU006UIFEU9BDU9BDU9BDTi>CU9BD0Y>CT`04UIFE
Ti>CUYJFUIFE0YBDU0:GUiL4UIFE00nDU9BEUIFGUiNFUYJDU9BCTi>DU9BE
UIFCTi>JVYZLW9bJVYZKVi^JVYZLW9`0;<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c00>c<c<0_ooo`08^k^kEEEEk^k^gMgMMgMg<c=VVIWoIYWo
0VIVo`04VFKoVIWoVIWoVIWo19W<o`BIVOl00fJIofIVofIVo`03IVKo0VJI
o`AVI_l00fHcoc<coc<cc003<c?<00<c<omVI_mVI_l00fIVo`04<c?oIVKo
<c?oIS?o0VIVo`05IS?oIS?<IS>I<fJIVIWo00CooomPc<c<00=VIVKoooo<
c<`0NLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKo
ooo<c<`03/c<c00JQ[SAQk[ER[gJQk[EPk;<OJNmL96PH7MmNXJ4RHb3UY:6
XIZ:ZJ:BZZBDYZBGZJFI/:NH^ZfM`KFUa;RZ_;>T/JZJZj>FYInAUY22TH]o
0X1jKP0=ShQnQWmeMVmUNgAZPW]aPWa`Pg]`PWY_Q7Y^QWe^Qg]]QWUYTXEe
00:AQ7<0=IF5MIR8NIB4MI:2MIJ6NIZ:OIb<Oib:O9R6N9Z7NJ6>P:fGR[BL
T9=lKZ><OZJ?PIn8N::;NjVDPjRCPZ>=OjF?P[fWW:ZCRj2<PjRESZNFSZfL
TYR:OinAQ;2STi^>Ni^?Mj^PQ:NIO:RKNj^LOjZEP:RCPZJAP:REQ:nNSZjM
SJJFQj>CQ:NGR:RGQkb[VkRUU:nJQkBNRKRORl:YT`0[c<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<00k<c<`2W9bL00ZMWIfLW9bKVi^JVYZFUYJB
TY:EUIFGUiNHV9RIVIT4Vi^K00ZLW9bMWIfNWYjOWinNWYjLW9bKVi^JVYZH
V9RGUiL2U9BD00BFUYJEUIFBTY:CTi<5U9BD00>EUIFDU9BDU9@019JFUP04
UiNGUYJFUYJFUYJF0iNGU`03UYJFUiNGV9RH00:JVYX01IFEUIRHV9RHV9NG
UiRHV002VIVI0YRHV003W9bLVIVIV9RH00:IVIT019ZJVYNGUiRHV9^KV`:G
UiL019ZJVYVIVIVIVIZJVP:IVIT019RHV9VIVIZJVYZJVPBIVIT00ifMWIbL
W9ZJVP02Vi^K00>MWIg<c<c<c<`0:/c<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c00>c<c<0_ooo`07^k^kEEEEk^k^k^k^VIVI<c=VVLco00FIVOl0
0fJIoiVIoiVIo`02VIWo1YW<o`:IVOl=IVKo0S<co`<c<l`00c<cofHcofIV
o`09IVKo00<c<laV<lc^k^h00oooof3<c<`00fIVI_ooolc<c01ic<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<
05Qn]mF4^mV9_]f8]m5mYkeiWJeeT9U_PH=oR8F6Qgn4P7F7PG>CSGnHTXBJ
UX^WXI>`Xi>`WhfhZIJiZYNdYiJ/XHnOU8:SVXVES7^JTh>PV8^MUHRDS7nC
RGnDRX2AQgfGRH2HQgfGQgZHR7RMSW^RTgjSTWjPSgfJRGVMRgfOSH6UThN[
VH^VUHFWUXBfYIFjZ9bkZInjYYfeXIJbW96`V8j^ThR[THBeVhk2Z9W4ZYVm
Xi:oYY;5[9S3[IS1ZYRlXYG1YY_3Z9nbVY36[ZCE_kC8/ZFhXYBlYiJnZIC1
[IC1[8ngXX?8]97I`ijmYH>gVH7@[icD]J76ZYG6ZiS:/Ig5[YboZYL3a:nL
00FeX8^eWhZoZI:nYHo0Z900:lc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c00>c<c<0YbLW006WIfMW9bLVYZJV9RHUYJFU9BD0YJFUP:EUID019NG
UiRHV9RHV9ZJVP:KVi/3W9bL00NKVi^HV9RIVIVGUiNHV9RIVIVHV9P00iNG
U`03UYJFUiNGUiNG00:GUiL4V9RH0YNGU`03V9RHVIVIVYZJ00:IVIT4W9bL
00>KVi^JVYZJVYX00YVIV@03VYZJWIfMWIfM00:LW9`3WIfM0YbLW006WIfM
VYZJWYjNX:2PWYjNVi^K0YbLW0:MWId01i^KVijNWZ2PX9bLW9ZJVYjNWYnO
W`02WIfM00>NWYjMWIfMWId00ifMW@:KVi/3W9bL;<c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c00>c<c<0_ooo`06VLc<EEEEgMgMc<c<VIVI8R8R
0YW<o`03VIWoVLcoVLco00>Ic?l5VIWo1YW<o`>IVOl2IYWo2VIVo`03IS?o
<c?o<c?o00<c<l`00c<cofHcofIVo`06IVKo00<c<olc<lc<c<`00oooof3<
c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G<c<`00fIVI_ooolc<c00>c<c<03Yj^]ij]]Qk/]5lZ/9lXK>2WZV7VZ26
TY:6S8RBThfFThbGThZHU8VBRh6>QgfGShBTV8ZbYYJn/j6/XHnWW8Z_Y9:X
WH^aYY:bYI:]X8ffYiC2/j2o[YbcX8n^VhZcW8bdUhViVXRjVhJgVGncV7Zd
VgbgWh>fX8ReWXjgXIBeXIZhYIjkZInbXY>eYIG5^:Sci]gVfM7Aa;bn/JVg
ZJ2lZj71[j?3/J?7]ZKA`:h2e/B`02CIbK;Lc;?Pd;OUekgLcKSFakCKbk_B
`[;UeLKchM?ok^3on>_olnG`e/OC^:FjWXW?/9_hf<7bd;OE/i[G/YoQ_:WQ
_Z_M_:WJ_J_B]jC:/j7@^jS?_:_?_Zc5]::eY9:jZIO3/YjmZiNiYi<[c<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`019bLW9^KVi^KViZJ
VP:IVIT00iRHV9NGUiJFUP04V9RH00ZGUiNFUYJHV9RIVIVKVi^NWYjKVi^J
VYZKVi^JVYX2Vi^K00FJVYZLW9bNWYjMWIfKVi/029ZJVPFKVi/2W9bL00RK
Vi^LW9bOWinVYZJTY:BQXJ6NWYjLW9`2WIfM0YjNWP0FX:2PXJ6QXJ6QXJ6Q
XZ:RXj>SY:BTXZ:RXJ6QXZ:RX:2PY:BTYZJVZ:RXZJVYZ:RXY:BTWinOVi^K
WYjNYJFUXj>S0YnOW`06X:2PXJ6QX:2PX:2PWinOWYjN0YnOW`07X:2PWYjN
Vi^KW9bLWYjNWIfMW9bL02c<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`03/c<c0;oool01k^k^eEEEMgMgLc<c9VIV@00<iW<o`02VIWo19W<o`;<
c?l2VLco29VIo`>Ic?l3VIWo0fIVo`04IS?o<c?o<c?oIS?o0fIVo`=V<ol2
<c?o1C<cc08c<ol2IVKo0S<co`04VLc<ooooooooooooH<c<c003IVIVoooo
c<c<07W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
ooooc<c<00k<c<`0H7Jki7NhgWbedgVY`7FJZWjIXXbOXi:PXJF_[Z>/ZInS
XYfOW:2OVYjKU9ZCRiV?QK6TU<:eX/o2[l>fXl2cX<6eWkjaW]75[n[Mb_ob
gOCUd]G4/<bkYlbjY/ZgY]Fn[]o3]N[=_NoE_^S@]=c7Z=W6Y]g>/N;F`>SL
c^;Id>3HeN?NfnGRgN7QfNOWfoGejo7]j_3/kNo[k>gYj>oYjO7YincUgnSO
f>cSf_G]h_S`hoO_h_G^g^oXe^gVe?;[f>_VdngXeK:[VjFNS_G/gOomkool
koohk>kHbkJLSljbY?CDaNW8]n:o[=jiY]fhYN_6]=jkZ<n^WLb]Vl^^W/:X
UkVRT[NTUK^ZV[n_X;NZVZfOTZjPTk>UV;>VU[2TU2_<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`03/c<c0:LW9`019^KViZJVYRHV9RHV0:IVIT2
W9bL0iZJVP06VIVIV9RHV9RHVi^KWYjNX:2P0ijNWP06WIfMXJ6QYJFUZ:RX
YZJVXJ6Q0inOW`05X:2PXJ6QXj>SY:BTXj>S00:QXJ400j:RXZ>SXjFUY@02
Y:BT0jFUY@03YZJVZ:RXYjNW00FWYjL01JJVYZFUYJJVYZNWYjRXZ002YjNW
0ZJVYP07YjNWYZJVYZJVW9bLVYZJYjNWZZZZ00:YZJT01ZBTY9^KVijNWZBT
Y::RXZ6QX@:PX:000j:RXZ2PX9jNWP02WYjN00NLW9bKVi^LW9bLW9bMWIfL
W9bJVYX00Y^KV`03W9bLVi^Kc<c<02_<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`03/c<c0;oool01iW<c6IVI_ooonk^kZZZZP00<iW<o`06VIWo
19W<o`?<c?l00iW<olc<oiVIo`08VIWo00>II_mVVOmVI_l00VIVo`05IS?o
<c?o<c?<IS?<<c?o00=V<ol01FIVofHcofIVoc<cofHco`02<c?<0P00c0@c
<ol01<c<ooooooooooooof3<c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<061a_>Ag
_>>1_]f0//UjXK1oWJN>YjbE[K6N/kRS][bX^L2V];NTZJbXZ:J_ZZBcYiVe
XhgKaZ_hhlSdh<OKb[2kZi:dYHk>`ZchjmSomnGooNgil>6o]ZMiKf=_IE^F
S8:YX9N/YYZWY9>HUh>3QW5dNF=[M65VLVA@GePmD4h`@dLY?T<Q>CdK=CHJ
=34K<c<S<3TX;clZ<D4Z<3h[<Cd_<ch`=3l_<S/c=Se9C55KGf9RIVUWJfaW
JfYTJ6MUIfA=CTUZJfGNg]KoooSonoGon_;/h]VcYYg>_K?Ze/_ih]CVb[c9
[9ZmWX[5YI3J^JKI^ZSE^:S>/J>iWi2XTH>VThB/VXb/W8nYVi2]X9N[XIRW
WYFTViBUW9F[XY^]YYh[c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
00k<c<`2W9bL00ZMWIfKVi^IVIVHV9RJVYZKVi^LW9bMWIfNWYjMWId2Vi^K
0YbLW009Vi^KXJ6QYZJVYJFUXZ:RW9bLVi^KX:2PYjNW00:YZJT01ZRXZ9jN
WY:BTY6ATINGUiZJVP:KVi/00iRHV9FEUI>CT`02TY:B00F>SXj<S8b:RXZ9
RHV8R8P01HN7Q`03R8R8QhN7R8R800B8R8P00hb<S8n?Si2@T004TI6A00B<
S8bATI6TY:BZZZX2ZJVY00VVYZJLW9bPX:2TY:BVYZJRXZ:MWIfKVi^LW9`0
0Z2PX003WinOWYjNVi^K00:IVIT3VYZJ0Y^KV`>JVYX2Vi^K;<c<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<0_ooo`06^k^kEEEEk^k^k^k^
gMgM8R8R0/c<o`BIc?l00iVIoiW<oiVIo`04VLco1Lc<o`06VLcoVIWoVIWo
VIWoIYWoVFKo1VJIo`=VI_l00fHcoc<coc<cc003<c?<0S<co`AV<ol2<c?o
00EV<olc<omVI_lc<onIVOl00oooof3<c<`00fIVI_ooolc<c01ic<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<
03]__NA`^]mi^]R1]ln5/l:>];nB]l2@]KjE^LNC]lFH^<NJ]<6R/KRd^Kc4
`Kc3]jW=^J3NaJOM`jSRcK3iiL[gilgNckS=`J^YWXc5_:_ajMcooo?ooO?g
lnZa[:I9AD99BdQ8CTa>E51DGUILIf5OKVMJJfEBIF<mDU<W?d4L<cTK=3TL
=CXP?40S?d8P=cdS<d0Y=DDY=4HV<T8U;SdV;chY<Ch[<d0/<Si:D5aOIW00
0V=ZM00SGfI^DeYRBdiCbLW9kn_XookkoO[ekNGR]JjXa;^diM_Bgm?7_jnR
UhEgY962[iZ9Uh9_X8]f_jRFcKJV`JZL]Z2C[YR;Xi65ZIV<[j6FZYfDZInF
YijGYIjHYinLXIVGWiNEYJ2MYj:O02_<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`03/c<c005W9bLVi^KW9bLW9bLVi^K00>LW9`00ifMWIbLW9fM
W@02W9bL00BNWYjPX:2NWYjOWil2XJ6Q00RRXZ:VYZJVYZJRXZ:PX:2JVYZO
WinVYZH2ZZZZ00>XZ:RLW9b;Rh/00Xb<S008SHf=Shn?T92@TI6AT92@Shn?
S8b<RHV90hN7Q`04R8R8RHV9R8R8QhN70hR8R0:7QhL3R8R801j=SHf@T92A
TI6ATI6@T92>SXj<S8bQXJ6WYjNZZZZYZJVVYZJMWIfOWinTY:BSXj>MWIfF
UYJHV9RJVYZFUYJGUiNLW9bOWinMWIfKVi^JVYZHV9RJVYZKVi/5VYZJ0YVI
V@03VYZJVi^Kc<c<02_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
3/c<c0;oool01k^k^dA4A=gMgLc<c;^k^`000<c<o`02VLco1/c<o`:Ic?l0
0iVIoiW<oiW<o`02VLco0lc<o`>Ic?l3VIWo2fIVo`03IS?o<c?o<c?o00Dc
<l`3IS?o00EVI_lc<omVI_lc<onIVOl00oooof3<c<`00fIVI_ooolc<c01i
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<
c00>c<c<061]_N9a_Mmi_=Uo^m>6^lf8^LZ6^LZ4^<f3^M64^]B9^mB@^LfI
]L6W][^l_[_>a[_=^jG=^9^kYX^eXHSE`j_A`Z_]h<ghl=gZhm?3_JnXY9V`
[JCPgMKmn_Gooo_alO6QY:]4B5==DEe3Ae=<DV1BF6IGGFUGGVPl@dT/<CDI
7R4W:bh];S8X:BhY:Rl[;SDV:S<Q:30d>dDR:C4]=3`_=ShZ<CT_=Shl@DME
FV1ZKGICEUmLG6I1@DV@T9S[jNkom_Komo;ij^GCa;oNcl[^gmSPdlZg[J5g
KF5LDdAJDd=ABSQ?BSMVHDjLUh>_Z9JbY9NbXYF[VhjSUHRVV8f/WiJZX9NS
VY>UWYRWWibTWibRW9bRW9jPVYbSWJ6[YJT[c<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<00k<c<`:W9bL0YfMW@04W9bLWIfMWinOXJ6Q0YnOW`0D
W9bLVi^KX:2PX:2PYJFUZ:RXYJFUWinOVi^KW9bLY:BTZJVYZZZZZ:RXVi^K
S8b<SHf=Rh^;SHf=SXj>0Xn?S`03RXZ:QhN7Q8B400:7QhL00hJ6QXN7QhN7
Q`02QXJ600j9RHV6QXJ8R8R8R8R7QhN8R8R:RXZ>SXjBTY:>SXj?Shn:RXZH
V9RWYjL2ZJVY00VWYjNQXJ6SXj>UYJFSXj>MWIfBTY:>SXj=SHd00Xb<S003
T92@VIVIW9bL00:KVi/01YZJVYVIVIVIVIZJVY^KViVIV@NJVYX00i^KVlc<
c<c<c00Zc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`2oooo
00?<c<aEEEG^k^h00/c<c0030000c<coVLco00BIc?l7c<co2iW<o`:IVOl0
0iUVofIVofIVo`02IVKo00=V<omVI_mVI_l01VIVo`03IS?o<c?o<c?<00@c
<l`01C<cofIVofIVoc<coiVIo`03ooooH<c<c003IVIVooooc<c<07W<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<
c<`0<ffkgfnkfgBieWNidG^icWbicWZjdgVjeWJkg7NkgWjmgXNmfI>ic9jf
`:fg^K^k/lFiZLNfX/^lYkN[UJ^PS8b4LG5ZF7ihJ<:o/>OSeo?aiL:o]YnL
TjJSW=WFdOWhm_[konOZlhN9USTkBT52E4=4ETmAGUMGHDY:C4a;BEEBCDi9
@e98AV1FEEa@E5I=D5IFEU9FEE=GEP02DUIE00UKGei=DE1UJFQKGEaYJVaR
HVA?Ce5QGfC@c]<00_omo`0Poo[ehLk7_ZfUh<o7k=kE]ZVPNg5WGUI;HeeA
I69FB4Pl>C`aCeE;T9R=YZfUWZ>LTi:=WibGYJ:MXj2KWijIXJ2LXj>QXZBS
XJ:TXjBXXjBYXj>[YZJ`Y:B^YJFa[:bh:lc<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c00>c<c<19^KV`NLW9`3WIfM016NWYjOWinOWinNWYjOWinL
W9bJVYZFUYJATI6DU9BOWinUYJFXZ:ROWinIVIVKVi^SXj<00ZVYZ@03YjNW
UYJFRXZ:00:;Rh/01Hf=SHj>SXb<S8b<S8f=S@02S8b<0Xj>SP03SHf=SXj>
SXj>00>>SXh02Hn?Shf=SI6ATHn?Si6ATI2@T8f=SI2@T::RXP02ZZZZ01>Y
ZJVSXj>MWIfSXj>UYJFLW9bCTi>>SXj?Shn@T92;Rh^9RHV=SHfHV9RLW9bJ
VYZHV9RJVYZKVi/00iZJVP:KVi/00iZJVY^KVi^KV`04Vi^K00>LW9c<c<c<
c<`00lc<c0@0000=c<c<0`0001?<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`03/c<c0;oool01[^k^fIVI_ooooo<omgMg@0000;<c?l2VLco00BI
VOnIc?nIc?nIc?l9c<co0YW<o`>IVOl00iW<oiVIoiVIo`04VIWo00=VVOmV
I_mVI_l00VHco`=V<l`00c<cofHcofIVo`02IVKo0VHco`04<c?o<c?<<c?<
<c?<0VIVo`03<c?oVLcooooo00;ooomPc<c<00=VIVKoooo<c<`0NLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<
c00ALKgOLKcKLk[HM;[DM;[CM;cELkkMLKoSK;kTK[gVLkgTOkkOS;cCU;S6
X[Jm[;Je]kN_00:`[:00CJ^WVi^IS81nLF1NDFm]H6MUF6]YG9bHS=GAaN_U
fL6k[jJPU::LT>7Odooon?;bl>g]kg5bMdM8CDA5BEUIEgAfJg9cHfMVDX5n
JfeUF8V0MhAiMHN0NW]iKGj0LYZLSW]mKgj2M7YnL7n1MWQjKgAfJemPF451
>IfJToojm_oln?Obk^cUgl2h[LO0/>3IbLJo[gMaHf1LD5ECAeaLE55BCEQM
FCTo?c0j?4YEFfMdOEeYMEe[MXVGX9JU[:6`]j:a^9j]]9b]]In`^:2b_9V[
]i^]^i^/_9b]_j2aaIj_`if]a:6abP0[c<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<00k<c<`3W9bL0Y^KV`JLW9`5WIfM00jNWYjLW9bLW9bKVi^I
VIVDU9B?ShnBTY:@T92ATI6IVIVRXZ:VYZJOWil2VYZJ012UYJFZZZZXZ:RW
YjNCTi><S8b;Rh^>SXjCTi>BTY:@T92DU9B@T92EUIFDU9BEUID2U9BD01bI
VIVDU9BEUIFDU9BEUIFDU9BCTi>?Shn:RXZIVIVYZJVZZZZXZ:RVYZJNWYjP
X:2TY:BOWinBTY:?Shn=SHf?Shn=SHf?Shn:RXZ9RHV=SHfBTY82TI6A00>H
V9RJVYZLW9`01IbLW005Vi^KW9bLW9bLW9bLWIfM00:LW9`00ifMWLc<c<c<
c002c<c<00@0003<c<c<c<c<c<`200003/c<c080000Bc<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<00k<c<`2oooo00Jk^k]VIVKoooo^k^kMgMd0
000Dc<co0YW<o`BIVOl2IYWo00FIVOnII_mVVOnII_mVVOl00VIVo`03IS?o
IS?<<c?<00<c<l`2IS?o0fIVo`06IS?oIVKoIVKoIVKo<c?oVIWo0oooof3<
c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G<c<`00fIVI_ooolc<c00>c<c<0W:mg@9b_=T0Cg>mfW6ng6nohVg1iVW0
jfZnjVjmiWNmhH>jf92jd9blbj^na:fb[ZbYX9jKTZNWWInOUG=cIf5QEEeM
DEYJCVe]HG5aIFYXFiRFRMC@a>OSelS5]Z>NRjnZUnkZgo_hlOoonl[:b4Q9
A3dn>65SEWUlJhR;N8:3LHR6NHJ3NXf8Q7UfLHB4NWEfJ7n0LWj0LWMiK7eo
LWanLgMgKFMWGEMGCm_HdOSek_onn?gfl<o7a;ji/nSXg/oAa8N9O6EWFUIH
CEYLDFEXHEUNF5YPGUALGT=<DcM1BdYFI45>GeETMh2BZ9F`aIJebYVhc@02
V;O<0YRhc@09UkO>U;C=T[C?Sk7=T;;>U;GDTK;ASZo@T;;E00C<c<`20000
0/c<c0@00003c<c<100000;<c<`200000/c<c080000@c<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<00k<c<`=W9bL00VMWIfNWYjNWYjMWIfLW9bI
VIVKVi^JVYZBTY800Xn?S`0MSXj>TI6ATY:BTI6AV9RHXZ:RYJFUX:2PVYZJ
W9bLYZJVZJVYZZZZXJ6QS8b<RXZ:T92@U9BDUYJFUIFEUYJFUIFEUYJFTi>C
UIFETi>CUIFEU9BDTi>C00:DU9@049>CTi2@T8j>SZBTY:RXZ:ZZZZVYZJ6Q
XIjNWZJVYZ:RXYJFUY2@T8j>SXn?Si6AT@:?Shl028j>SXb<S8Z:RXf=SHb<
S92@T9NGUibLW0NMWId4W9bL00BMWIfLW9bLW9bLW9`5c<c<0P000004c<c<
00000000c<c<0P0000C<c<`500000/c<c0<0000Ac<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<00k<c<`2oooo00>k^k]4A4C^k^h00/c<c0030000
c<coc<co01G<c?l019W<oiVIoiVIoiVIo`EVI_l00fJIofIVoiUVo`04IVKo
00=V<olc<l`c<l`00c<cc003IS?<IS?oIVKo00=VI_l019VIoooooooooooo
o`C<c<`200000lc<c08000000lc<c00000000002c<c<0P000004c<c<0000
0000c<c<0P0000;<c<`200000/c<c0800002c<c<1@0000;<c<`2000000?<
c<`0000000000/c<c0@00002c<c<0P0000;<c<`200001/c<c0@00002c<c<
0P000003c<c<0000000001?<c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<03E`^Maa
^]]b^mab^m]b_Me__]m[_N9Z_NEZ_nQ[_^Y^_NId_>An^]b7^]NF`=RY`m2S
YJ:UVhnQVHbSWI6KUh]WIEUQGe=GFDaVJ5eDEdiIG5=PIEiSJ65UJV>NXigR
i=WUg/c9_:V/X92o]j[cknKoooSblnf?TH`l@ca<ETi7DDUOJ6=ZLg1WKg5V
KW5gO81YJVaMGEedM7A^KVigMgL00W5cLP03De=CQ8B4k^k^00;oo_l09>WS
iKF_/LJm`>gXk::WZUUSI5IPGeQQH5MPGe]THEENFdQAD4eFEDmGFTI=Dc4j
@cm9De9KJX29VZ6cbIRjgHnkhX^igHRffXVgfH^ifhZhfXJffXZjgXRjgh6e
g82dfh>hh82egGfbg7nfg`C<c<`2000000?<c<`0000000000/c<c0800000
0lc<c00000000002c<c<0P000003c<c<0000000000;<c<`200004<c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<0Y^KV`bLW9`03IjNWYnO
Wi^KViZJVYVIVIZJVYVIVI2@T8n?Shj>SY6ATHj>SXn?S`02T92@00nATI6J
VYZUYJFUYJFOWinJVYZNWYjWYjNZZZZXZ:RGUiN:RXZ=SHf<S8b@T9000Y:B
TP06TI6AU9BDTI6AShn?Ti>CTY:B0i>CT`03SHf=UYJFYjNW00:ZZZX01ZJV
YYfMWJ2PX:JVYY^KVi2@T0>?Shl02Y2@T8n?Shf=SHf=SHj>SXb<S8V9RH^;
Rhj>SYJFUPBMWId2W9bL00>MWIfLW9bLW9`00YfMW@BLW9`00i^KVibLW<c<
c003c<c<0P000005c<c<000000000000c<c<00800003c<c<0P0000;<c<`2
00000/c<c0<0000Ac<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<
c<`2oooo00O<c<aVIVKooooMgMg<c<`A002IVOl02Lc<o`03c?ooc<coc?oo
00_<c?l2VLco0iVIo`=VI_l00fIVc6IVofIVo`07IVKo00=VI/`c<omV<l`0
0S<cc005IS?<IVKoIVKoIVKoVIWo00?oool4c<c<0P0000?<c<`2000000?<
c<`0000000000/c<c08000001<c<c00000000<c<c0800002c<c<0P0000;<
c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P00
0003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c0800005c<c<
0P0000;<c<`2000000C<c<`00000003<c<`200004lc<c003IVIVooooc<c<
07W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVoooo
c<c<00k<c<`0DG:hg76jgG>lggBmh7>mh7:nhVjnhf^mhfZli6fliG2migJn
iW^khH6ig8Vkg9^nd[Zn_jRPUJZTV8n9OHN3N6MUFEYJCU]MDUQKD5iTFVE[
HE]QEeaQFUYOF5mTGEiNE9b@P??Rd>OHaL6dY;J_WnGQeO?cjO_nmlG:aSDk
>daDEU1HFeMOHV5XKW^2R7UnPUQGGF9PIFESJ;Rf^jBRYgMgNE]KGKZj_??a
m?onoo[fmmWCdkbc]>WPhL6g^6ANH61QHfQ`LVQ]L6M]KG=gMVY^KGn4P822
OgQjNGQiNeYMHT]>EEMKIXF;UiRN[9BT^i6fh002R;_Z00f7^^N4^NF3^>:3
^^>4^nB2^nIo^^Ai]^9g]^5j^^Ih^>Ad]nAh^nP01<c<c08000000lc<c000
00000005c<c<0P0000;<c<`2000000?<c<`0000000000/c<c080000@c<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`2Vi^K1YbLW003Vi^K
W9bLW9bL00>LW9`03IfMWIjNWYnOWiZJVY^KViJFUYFEUI2@T8j>SXn?Shj>
SY2@T96AT@03Shn?01>@T92?ShnHV9RVYZJTY:BNWYjMWIfUYJFXZ:RZZZZQ
XJ69RHV=SHf>SXj?ShnATI6EUIFDU9B>SXh00Y2@T00<WYjNVi^KTi>CShn?
WinOZ:RXZZZZZJVYXj>SWYjNYJFUWinO0Y2@T005TY:BTI6ATI6ATi>CTY:B
00:EUID2U9BD00B?Shn<S8b?ShnGUiL2VYZJ19fMW@:LW9`3WIfM0YbLW005
Vi^KW9bLW9bLVi^KW9bL00C<c<`200000/c<c08000000lc<c00000000003
c<c<0P0000;<c<`2000000C<c<`00000003<c<`200004<c<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c00>c<c<0_ooo`07^k^kEEEEoooooooogMgM
<c<cVIWo00_<c?l4c?oo0lc<o`:Ic?l00iVIoiW<oiW<o`07VIWo00NII_mV
I_mVI_mVI_mVI/aV<laV<ol01fIVo`=V<ol3IVKo00BIVOooooooooooool4
c<c<1`000003c<c<0000000000;<c<`2000000C<c<`00000003<c<`20000
0/c<c0800002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`00000
00000/c<c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<
c<`200001<c<c0800003c<c<0P000004c<c<00000000c<c<0P0001?<c<`0
0fIVI_ooolc<c01ic<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`00fIVI_ooolc<c00>c<c<061e^N1d^N1e^^5c_=md_N1c_N1c_N9b_^9`
^n9`^^5b^^9f^nAi^^9j^=mn^>2<^=FU/[ZIVYFJViJ1PWaiNWA`LfY]KVIb
MFYfN6efN6]lOW1kO6j:R7V>S7fEThBFSgnOSH6SSH3D`K;fimCCb;JPVHOC
cKohmNclnoOXi^VBT9FJV9fa[k:]ZjcNf]OJe]?Pf]be[:o2^KcUgmnd[ZjW
XYoCd<_lnOCoo_ScknK7`;KLdl[=`kVRUHb]WiBRUHbUVi:IT8NXWYFVW9>P
V8fSVi2LThZGSXFQV96ESHY^J6QTHVMmO8BTY:jVZ;FOZl>B]Mn;^N^<^^b;
^n^8^nR5^^J3^^>4^nAo^N5n^N5i^>5h^N5i_>If^nAa^>9e_>H4c<c<0P00
0003c<c<0000000000G<c<`200000/c<c08000000lc<c00000000002c<c<
0P00013<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c12LW9`0
1IfMWIVIVIVIVIFEUIBDU002TY:B0i>CT`:DU9@019JFUYNGUiRHV9NGU`:H
V9P08:2PX:JVYZ6QXIVIVJ:RXZRXZ:VYZJJVYYRHV9VIVIfMWIbLW:BTY:>S
XjBTY9fMWInOWjFUYIfMWI^KVj:RXZVYZJZZZZNWYj2PX:>SXj2PX9VIVIZJ
VYVIVIZJVYRHV0:JVYX02YVIVIZJVYRHV9NGUiVIVINGUi6ATI2@T9BDU9^K
V`:LW9`8WIfM1YbLW003Vi^KW9bLc<c<00?<c<`200000/c<c08000000lc<
c00000000004c<c<0P000004c<c<00000000c<c<0P000003c<c<00000000
013<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0;oool02;^k
^eEEENk^k]gMgLc<c6IVIVJIVLcoo`;<c?l00lcoolc<olcoo`07c<co00C<
ooo<c?o<c?o<ool4c<co0YW<o`RIVOl00iUVoiVIofIVo`02IVKo00IVI/aV
<laV<laV<laVI/aV<ol9IVKo0oooo`G<c<`2000000?<c<`0000000000/c<
c0800002c<c<0P000004c<c<00000000c<c<0P0000;<c<`200000/c<c080
0002c<c<0P000004c<c<00000000c<c<0P0000;<c<`2000000?<c<`00000
00000/c<c08000000lc<c00000000002c<c<0P0000C<c<`200000lc<c080
00001<c<c00000000<c<c080000Cc<c<00=VIVKoooo<c<`0NLc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<c01P
LKWOL;SNL;SNK[SMKkWNL;[MLK_NLkcOMKgSL[[PL;SPLkSQM[WSM[[QNK[T
Q[OHY;O8/[FlWj2TSXj>M7E`LG9/T9><W9nFVijCTiF8VIN8WIR5YIf:WI:0
X9F3YiN7XXan]9f=XHai[Yb6iMFnf/jh^:bL^JnSn>oZooSinoGg]k6cTXb>
U92=]:nYnoKboocmlnS//:FYT8J7b/2omNgZoocfoogem>gSbL>gi=k@a/2`
L6YJLF]KKfYGLfaLOgEYRWibQGMZTh=fSWiaRWY]Q7I[Sh5hQ7M_RGihOWAb
N79dXJ2VZZbiYZg0Wk;@T[SUQkKZP[CWQ;KWQKWXP[SVOKKQNKCNN[SQNk[S
NK[TN;_UNKkXLk[TKkKPLK[S1<c<c08000000lc<c00000000005c<c<0P00
00;<c<`2000000?<c<`0000000000/c<c080000@c<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<00k<c<`6Vi^K19bLW0:KVi/4W9bL00VMWIfNWYjJ
VYZGUiNCTi>BTY:HV9RJVYZIVIT00YRHV003VIVIVYZJV9RH00:IVIT02IRH
V9^KViRHV9ZJVZ>SXj:RXYbLW9fMWJRXZ002ZJVY00^MWIfGUiNHV9RMWIfY
ZJVZZZZWYjNLW9bFUYJPX:2WYjL00ZZZZP04YjNWX:2PYJFUX:2P0i6AT@06
TY:BTi>CUIFEU9BDUYJFUIFE0YBDU003UYJFU9BDUIFE00:CTi<00iZJVYbL
W9bLW002WIfM0ibLW004WIfMW9bLW9bLVi^K1YbLW003Vi^KW9bLc<c<00?<
c<`200000/c<c08000000lc<c00000000005c<c<10000004c<c<00000000
c<c<0P00013<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0;o
ool01lc<c5EEENk^k/c<c;^k^eEEEFIVV@04c<co2<coo`;<c?l2c?oo1lc<
o`03VLcoVIWoVIWo00>IVOl019UVofIVoiUVofIVo`FII_l2IVKo00=VI/aV
<l`c<l`00VHcc003IS?oIVKoIVKo00=VI_l3oooo1Lc<c08000000lc<c000
00000002c<c<0P0000;<c<`2000000C<c<`00000003<c<`200000/c<c080
0002c<c<0P0000?<c<`4000000?<c<`0000000000/c<c08000000lc<c000
00000002c<c<0P000003c<c<0000000000;<c<`200001<c<c0800002c<c<
0`000004c<c<00000000c<c<1@00013<c<`00fIVI_ooolc<c01ic<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<
00=[^MmZ^=i[^Ml00VjlhP9^^]h0:W2jgg6kh76kh76kh76igg:jh7Bmh7>k
hGjdeYfac:j_`kRb_9R?TXV0Nhj7Og]lMX66Ogn4OHR:Ohj8N9:5M9N5LIN0
KYIoLIV2LY^2K9j6K:28KY^3Jj2:L/6/UmW7/mO6][Z/XN[Peoonn?_hloOg
mNW[j>W^j_[lnoomo`;on?l07_okookcnOcbloojn?kel=C=aKNcZ9^IS9FH
QhnFQ8nHQIRUTI^VUJJYWZ^XWkB/XK^_Xkn^Y;b^YKZ]YKJ[YJbRVJNNUJNN
VJRTXjBX/H^HZi>/bhjdfh>fi@9o]nX01gnijH2jjWjkjWfjjG^ij7RhiWNg
i@02M;OT00Ac]nAd^>Ee^NIc^^H4c<c<0P000003c<c<0000000000;<c<`2
00000/c<c0030000c<c<c<c<008000001Lc<c000000000000<c<c0020000
4<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<0i^KV`:LW9`3
Vi^K0ibLW00<Vi^KW9bLW9bLW9bLVi^KW9bLWIfMWYjNV9RHUIFEUYJFU9BD
0YFEU@RFUYH2UiNG00>FUYJGUiNMWId00Z6QX@03WIfMYJFUZZZZ00:YZJT2
YjNW00NYZJVZZZZYZJVYZJVZZZZYZJVXZ:P00ZVYZ@03XZ:RWIfMVIVI00>H
V9P2VYZJ0Y^KV`03W9bLWIfMWIfM00:MWId019bLW9^KViZJVYZJVP:KVi/0
0iVIVI^KVibLW00:W9bL0i^KV`>LW9`4c<c<0P000005c<c<000000000000
c<c<00800003c<c<00@0003<c<c<c<c<c<`400000lc<c080000?c<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`2oooo00Nk^k]VIVKoooo^
k^k<c<b8R8Q4A4@01Lc<o`W<ool;c<co19VIo`:II_l2IVKo00=VI/aVI_mV
I_l00fIVo`05VFKoIVKoIVKoIVKoIVK<00=V<l`016JIofIVofIVofIVo`?o
ool5c<c<0P000003c<c<0000000000;<c<`3000000C<c<`00000003<c<`2
000000G<c<`000000000003<c<`00`000005c<c<00000000c<c<000000?<
c<`2000000?<c<`0000000000/c<c0800002c<c<00<0003<c<c<c<`00P00
0005c<c<000000000000c<c<00800004c<c<0P0000K<c<`2000000?<c<`0
000000004lc<c003IVIVooooc<c<07W<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`03FJhgFFgg6NigV^kh6fk
hFbjh6jjgVnkgg6kh7:lhG6kh72jgg6kgP02LkgP019k]m^?/MJQ/]2PYkV@
T9R>RXNHUHjKW9JNXibMXY^UYib/YIF^Xi6aX92[VH^UUhj[WI:eY902]jF=
02>gYHnnZIK?^ZWIa[OIakWOcl:/WiKId/SoooKooo[noo_bnO;kookfmO[m
noolmogdk_;oo?ooo?gainJe[JZi];3cl>_ooo[an?3bo_Ceoo_boo_Yn_;V
l^k^m?;lo?[oo__omoGon?H00_omo@0:ookmlo?cfmcPam3IY;G7PIbiQjgD
R;OUP;SYO;[[0g^ijP06NKWYMkOWLkGUMkWYM[SXM;KV0W:fi@03LkOVMKWX
M;_Y00C<c<`200000/c<c0@00003c<c<100000;<c<`2000000?<c<`00000
00004Lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<1i^KV`BL
W9`00i^KVibLW9bLW003W9bL00JMWIfKVi^HV9RGUiNHV9RIVIT2VYZJ19^K
V`03VYZJVIVIVYZJ00BKVi/01ibLW9nOWj6QXJ6QXJ>SXiZJVZ>SX`03ZZZZ
00JYZJVZZZZXZ:RZZZZYZJVXZ:P2ZZZZ00JVYZJMWIfNWYjXZ:RZZZZXZ:P3
ZJVY00FXZ:RWYjNXZ:RYZJVZZZX00ZVYZ@>ZZZX01ZRXZ:BTY::RXYfMWIVI
VI^KV`RLW9`00i^KVibLW9bLW004Vi^K0YbLW0G<c<`2000000C<c<`00000
003<c<`400000/c<c0@000000lc<c00000000003c<c<0P0000o<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0;oool01k^k^eEEEOoooooo
onk^k[^k^c<c<`02c?oo1Lc<o`03c?ooc<coc?oo00O<ool4c<co0iW<o`:I
VOl00iW<oiVIoiVIo`03VIWo0VIVo`9VI/`00fIVofIVc6IVc003IVKo00>I
I_mVI_mVI_l00VIVo`05VFKoIVKoIVKoIVKok^k^00;oool5c<c<0P000003
c<c<0000000000;<c<`2000000?<c<`0000000000/c<c08000001<c<c000
00000<c<c0800002c<c<0P0000?<c<`4000000?<c<`0000000000P000003
c<c<0000000000;<c<`400000/c<c08000000lc<c00000000005c<c<0P00
00K<c<`2000000?<c<`0000000004lc<c003IVIVooooc<c<07W<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`0
16FggFBfg6NfgFZih09/^^001fjih72khW6khW6khW6kh72jgg:jh002M;cR
04Ad^N1j^N:1]m]fX;QhUJ><Wj>X/jo6blC@dlS>c/;CdL;Ge<?IelSEeLW5
b/>iaLG0b/WEe/k;bKbg/jNZY9RSVY6NU8^RUHfZWIG8_[G[h]V_Z9kMfLkg
m>_fm^coooGmooO`n>gkooSgoO?nooSko?C`knZm^[FBSXeSHF9DDePY;34R
9bd^=d0L:3@E8bhT=Cl]?THJ:34H9S4_>dM4C5U>DUiBE61EEf=3BeIEIGEm
UJfM_]fA]mj1[=N9/n>:^^]n^nYk^n]j^^X2NKWY00If^>Qd]^Ia]NAg^nYf
^^Ud^>L2L;OU00=a^>Ib^NMb^nP0:lc<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c00>c<c<00>KVi^JVYZKVi/019^KV`BLW9`00i^KVibLW9bLW004
W9bL00FIVIVGUiNIVIVMWIfQXJ400j:RXP>SXj<01j6QXJ2PX:6QXJ>SXj6Q
XIfMWI^KV`03VIVI00FJVYZPX:2UYJFLW9bTY:@00ZRXZ0:ZZZX05ZRXZ:ZZ
ZZVYZJZZZZVYZJNWYinOWiNGUi2@T8f=SHN7QhJ6QXR8R8J6QXF5QHR8R8V9
RHJ6QXF5QHV9RHb<S8f=S@:>SXh028b<S92@T9RHV9jNWYfMWI^KVibLW9fM
W@JLW9`2Vi^K0ibLW0>KVi/2W9bL;<c<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c00>c<c<0_ooo`07^k^kEEEEoooogMgMc<c<^k^k4A4A00;^k^hA
c?oo1<c<o`^IVOl01IUVofIVofIVofIVofIVc002IS?<16IVc09VI_l01IVI
ofIVofIVofIVomgMg@02oooo1/c<c0<0000Oc<c<0P0001O<c<`200000/c<
c08000001<c<c00000000<c<c080000Cc<c<00=VIVKoooo<c<`0NLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<
c009IKOMI;KLIkKMJ[WPK;[QJkWOK[WPL;_RKkWP009`^^40CfnigW6igg>k
hG>khG2jhFNfgFnkggBedGjbahV__8>LXFmmOUiTH61PF69OEV5QEF=VFeUS
Fd5ACRi3A2m4ACM3@c]4@CTo?C]0?494@Cln?44m>Te8A6QPGIN@R/c5_Jn[
X^?Oe?oml_oom?Khjo_om>gjjOGol?Knko;ej[Jg[i>BSG9^JfIRHe9@ED=2
B3loBC4e@Ble@ca3DcI0C2Pc>CE2BR/kB392DEERLUaTLE=EHE]OJTmLK51Z
PGjYc8Vmk7fgjGbejX:dihBhj7^ijWJjjGNijGJjjGRjjWNkjWJjjG>jj7Jj
jG>jj002L[WW0W6hiP9`^NH4c<c<0P0002G<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`03/c<c003Vi^KVYZJVi^K00BKVi/019bLW9^KVibLW9bL
W0:KVi/3W9bL00>KVi^LW9bKVi/00Y^KV`03V9RHU9BDT92@00>?Shl00i2@
T8n?Shb<S006RXZ:00V;Rh^:RXZ:RXZ<S8b@T92HV9RQXJ6LW9bUYJD00ZZZ
ZP03Z:RXZZZZZ:RX00:YZJT02:RXZ9jNWYRHV9:BTY2@T8f=SH^;RhZ:RP:8
R8P03X^;RhZ:RXR8R8Z:RXV9RHZ:RXn?Si2@T8j>SXn?Shj>SY2@T9ZJVYfM
WA2LW9`2Vi^K0YbLW2c<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
3/c<c0;oool01k^k^eEEEOooomgMgK^k^jZZZP000007c?oo00?oooo^k^k^
k^h02Lcoo`K<c?l5VIWo0iUVo`04IVKoVFKoVFKoVFKo16IVo`9VI/`3IS?<
00=VI/bIVOmVI_l00VIVo`03gMgMoooooooo00K<c<`300002/c<c080000D
c<c<00<0003<c<c<c<`00P0001C<c<`400000/c<c08000000lc<c0000000
000300004<c<c003IVIVooooc<c<07W<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`0FVJhh6FggfFggfNihFZi
hVVhgf^ih6fkhVbggffhh6jgh6fggW2hh7:jhWBihVnigWG5iV^lfW>ngWBe
dgnedH2U_emiRUQVLfMZLFASJ5mOHEeQH5AMG3i:B2`k>2Xj>Bm1@cI5BS4n
A2dh?3<m?cXo@TE6B5=CDfQWIGIbKhZ7PZ>PVK2]Y=cId?cjk_cll?WomO_o
n?Snl_Ojkk^k/I^HSgehLVURG7E]JZjVXhZ2P51;B5eIFW9`LHF5QJRWXlC2
]VIXGEAMG75lP5YSJ59FFFIUHeYLFeUXKd][P7bfg7>jkW2mmGS1n7VfiGVc
hGRhj7:hjGBhjG:hjGJjjgFkk7Bjjg>kjg6gj76ij@9b^^X0176ijG2hj6ng
ifjfiR_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0fKVi/2
W9bL00BKVi^MWIfKVi^LW9`2Vi^K00FJVYZCTi>@T92ATI6@T9000hn?S`0A
Rh^;RHV9R8R8RHV9RXZ:RHV9R8R8RHV9RXZ:Rh^;SHf=TI6ATi>CUYJFVYZJ
W9bLY:BT00:YZJT2ZZZZ0ZVYZ@0DWYjNVIVIU9BDT92@TY:BW9bLUYJFS8b<
Shn?TY:BUYJFVi^KX:2PTI6AShn?U9BDT92@SXj>T92@Shn?0Y2@T0>LW9`0
0ifMWIbLW9^KV`08W9bL00>KVi^LW9bLW9`00YbLW0>KVi//c<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<00k<c<`2oooo00Rk^k]VIVKooooooooM
gMg<c<`0003^k^h7c?oo00Coooo^k^koooo^k^h3oooo0lcoo`S<c?l00iW<
oiVIoiVIo`02VIWo26IVo`04VIWoIVKoIVKoIVKo16IVc005VIWoIVKoIVKo
IVKogMgM00;ooomPc<c<00=VIVKoooo<c<`0NLc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<c01BIkWQIKOOIKOO
I[SPJ;OPIkKOJ;OPJkWPJKONK;OOKKKOK;GNKkKPLKWQLkSRKkOOL;oPI;CE
LL7VL[cSO[WQO:[<G7NDGFUoJF]hIfA]HEiUH65UGfAWEEmNCeYFDUiLCeiQ
FfacIGAkIW=iJ7=iIfidI6U]HVIYK6e_J6QXKFaZMWEaXj:MaLFmg=cDn__c
mokgm?kfl?O`_/>lSi2:JFQSMg9^JVEOKfMTPGYdQGihQWmiQ7mkPgijR8F0
QX9iQh1`Og]_MgekJ79dEUiQG5eOJF9LGU]FD5YLBfQjMjkELk[^K;SbKkOa
M;7PO[OTMKOWLKOX0W2fi`06LKOXL[SYL;SXL;SXK[KVKkOW0g6ij@03L;SX
K[KVKKGU02_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c12K
Vi/00ibLW9ZJVYbLW002W9bL00JJVYZCTi>ATI6ATI6@T92?Shl2T92@00F?
Shn>SXj?Shn>SXjATI4019:BTP09TI6AT92@TY:BTI6ATY:BTi>CVYZJX:2P
Y:BT00>YZJT02:RXZ:2PX9NGUi6ATI>CTi2@T96ATIBDU0BEUID00iJFUYFE
UIFEU@02U9BD00VBTY:?Shn?Shn@T92?Shn>SXj@T92JVYZLW9`00i^KV`:L
W9`4Vi^K00>LW9bKVi^KVi/00Y^KV`>LW9`3Vi^K;<c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c00>c<c<0_ooo`08c<c<EEEEooooooook^k^gMgM
0000oooo1lcoo`03k^k^c?ook^k^00G^k^h3c?oo1<c<o`:Ic?l9VIWo00>I
I_mVI_mVI_l016IVc0IVI_l01IVIofIVofIVofIVomgMg@02ooooH<c<c003
IVIVooooc<c<07W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<
c003IVIVooooc<c<00k<c<`08VBghF:egf:egf>fh6Beh6>dgfBeh6Rgh6Vf
h6ZghFbghFbeh6nfhW6hhW>gi6nfh6figFNeffjmj72jig:_g6RE_5E]REeR
MVaVLW1UJfaRJVUWK6]_LVaaM6idLWAmNVQbLfMbM09[MGL0;VYbMFmdN75e
N6ibMFa`LFi_LFmaL79dLfY/JJNYY[g2_/kDd?KoonoknKc6aIFNWGUoOgAh
Mfi`Kfi^K6e[K6i]Jf]ZJ71_KFe/JVMWIFe]Jfa[IfeZIFe/JV1YLUYTL5mW
M6][Lg=YJ75WIFMWJF=cPVB=[HFkjGnllgZekH2`hH:ei7Rhj76gjP=`]^T0
176gjW2fjG2fjFnej0A`]^T3KkGX:lc<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c00>c<c<00>KVi^JVYZJVYX019ZJVPZKVi/01iZJVYbLW9bLW9ZJ
VYNGUi6ATI2@T002TI6A00>@T92ATI6BTY800Y:BTP03U9BDTY:BTY:B00:C
Ti<00i:BTY>CTi>CT`04TY:B00^CTi>ATI6LW9bPX:2RXZ:ZZZZYZJVPX:2I
VIVDU9BCTi<00Y:BTP03TI6ATY:BTI6A00:BTY801i6ATI:BTY6ATI6ATI:B
TY6ATI2@T005TI6A00JBTY:FUYJMWIfMWIfLW9bKVi/2W9bL3i^KVbc<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0;oool00k^k^fIVI^k^
kP02gMgM00?<c<`04@3MgMd00_ooo`06olcoooook^k^ooooc?ook^k^3<co
o`?<c?l00iW<oiVIoiVIo`09VIWo0YUVo`03IVKoIVK<IVK<00EVI/`00fIV
oiUVoiUVo`03VIWo0_ooof3<c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<059R]N5O
]=eP/mmQ]=iR]N5Q]=iR]N5U]^5X]n9Z]n5Z]n=/]n5^]nAa^>Aa^>I_]^9^
^=m`^n=Z^>I`^>Q/ZMENRZmRMXi^L7ehKgAnLW9jLG9cKg1^LW=/LW9^Lfmd
NGEeNWI]LG1aMGAgNgYeNGYfNW]iNWacM7IaLg9dMWEmOgikOGafN7MnP7fi
_[Zn`knk`Ko?eM>PYZAWJfYTIVEOGeeGEeEFEE5BDDeLF5EBCdY@CDQEDTeD
DdiNFeIRGeQ]J69cKfabMgf0Qi6HW:NSXZR^Y::m/Zk1_;VHWjM7HgUhY<Mn
/^60^>^4^>Yi/NAh]nYa]nX2L;KY00Ma]nYb^>]b^>]b^>]`]^U_]NQ^]>L0
0VfciP03K[CWL;KYLKOZ02_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`03/c<c0NJVYX:Vi^K00NLW9bKVi^KVi^IVIVEUIFCTi>BTY800i>CT`BB
TY801Y>CTiBDU9:BTY>CTiBDU9>CT`:DU9@3Ti>C00bEUIFDU9BCTi>EUIFO
WinPX:2OWinSXj>KVi^ATI6@T92?Shl2SXj>00B=SHf>SXj=SHf<S8`2SHf=
0Xn?S`05TI6ATY:BTi>CUYJFVYZJ00:KVi/01YjNWYnOWiZJVXn?SiVIVI^K
V`:LW9`00i^KVibLW9^KV`03Vi^K0ibLW0RKVi//c<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<00k<c<`2oooo00Zk^k]VIVKoooo^k^k<c<bk^k/R
8R:Ic<c^k^k<ool2oooo0^k^kP05ooook^k^k^k^ooook^k^00S<ool6c<co
19VIo`03VFKoVIWoVFKo00>II_l2VIWo0YUVo`9VI_l5IVK<00>IVOnII_nI
VOl00YVIo`;ooomPc<c<00=VIVKoooo<c<`0NLc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<c01LHkOUH;ORH;CR
Gk?OGk?QH;CPHKGSHkOSIk[VI[ORIkGSIkCPJ[CSK;GRKKGUKKKSKKKQI[7K
KkWXL;OSIJ76Cg^FOI2N_/;3a;feaknd`;bc`<6k`LK2b]3<g>7Kgn;KinSR
l>oZoOcgooojm_Gan?OcooomnOWgooomno_io?cjo?ghookjmoKbooojiN;K
/jnVa[nglncTl^WRjN3IknGLg]C;hMO=g]C:h]K:h=C6f<bnhMG5g=?2e<Rh
eLVie/^gf<nnc/ZoalK1c<_7c/_6clJme<c1dlo3Y:VSBf1UGH:DNJk@O[gY
J[7WL;SbL[O^L[GZLKCYL[GZM;O/MKS]M;O/L[GZMKS]LKCYK[7VKk;W172c
j2_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c003Vi^KVYZJ
VYZJ00BJVYX4Vi^K00>JVYZKVi^KVi/00i^KV`0:VYZJVi^KVi^KV9RHTY:B
UiNGX:2PWinOX:2PWinO0Z2PX00<XZ:RYJFUYJFUYZJVYjNWZJVYZZZZZ:RX
ZJVYZZZZZJVYZZZZ0ZVYZ@:ZZZX01JRXZ:ZZZZFUYIfMWJ2PX002YjNW00RU
YJFVYZJSXj>TY:BSXj>TY:BSXj>RXZ82Xj>S0Z6QX@:RXZ800j6QXJ2PX:6Q
X@02XJ6Q0Z:RXP06Vi^KShn?U9BDVYZJWIfMVYZJ0YbLW0>KVi/3W9bL00>K
Vi^LW9bKVi/01Y^KVbc<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
3/c<c0;oool03K^k^fIVI_ooooooonk^k/c<c6IVIWMgMoooonk^k_ooomgM
gOooo`02k^k^00Goooo^k^k^k^k^k^koool00^k^kP?<ool:c<co19VIo`05
VFKoIVKoIVK<IVK<IVKo00:II_l019VIoiUVofIVoiUVo`9VI_l2IVK<0iVI
o`04VFKoVIWoooooooooH<c<c003IVIVooooc<c<07W<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`00ebdhUbe
hEbdhP03G;GQ0UffhP1<Gk?QH;CPHkCQIkGSJKKTJkGTJ[CSJ[;RJ[7OK;?Q
M[[YKZgFGY>cE7V<S9nSdmSBeM75e]30b/JjalNmb<_4al[3bL[2`/:h`l2g
al:l_;Vb_[^dc/_6blS3`;nk`L2la/G1_[^f`l2k_[Vca;nial2h`[^c[ZFL
/JNN]jfT_[B[^k6X]jZRa;N_^jjV/JBK_K6U^ZjP/ZJH/jNGYib:]Z^I/jRD
/JJB]:VE[Z>AYYjAZJ:H[:VRZJJQYJ2JYJ6HWIV>Vi^AL7UfJH28NZ:kN;;H
L;W`I;?^LKK_LkCZLKCYL[GZ0WBgk00:L[GZKk;WL[GZL;?XKk;WK[CXL;?X
KK?WK[7VK;;V:lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<
2iZJVPBKVi/2VYZJ00NKVi^LW9bJVYZFUYJBTY:IVIVSXj<00Z:RXP:PX:03
XJ6Q00FPX:2OWinPX:2NWYjOWil00Z6QX@:OWil04:2PX9nOWj2PX9jNWYnO
Wj2PX9nOWi^KVibLW9fMWIjNWYfMWIbLW9nOWifMWI^KV`:MWId2W9bL00ZJ
VYZLW9bLW9bKVi^LW9bKVi^JVYZKVi^LW9bKVi/2VYZJ0YVIV@06Ti>CU9BD
VIVIVi^KW9bLVYZJ19^KV`:LW9`:Vi^K;<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c00>c<c<0_ooo`08^k^kIVIVooooooook^k^gMgMR8R8IVIV
0oooo`;^k^h00oooonk^k^k^kP03oooo00?^k^koooo^k^h00^k^kP?<ool4
c<co00>Ic?nIVOnIVOl029VIo`03VFKoIVKoIVK<00AVI/`00fIVoiUVofIV
o`03VFKo0YVIo`04VFKoVIWoooooooooH<c<c003IVIVooooc<c<07W<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<
c<`00eRchURch5Rdh`04FKKR01YH]N5I/MmK]>1P]>9S]NAU]^EW]NEX]>EZ
/^Ab]NUe/nIh/^1]XLQYTJ]PO8QoSHfWZZ6WXiN]YiVQWI6PWY:SX9VOVi:O
UXfHShJ=R882XYnJ02jDTHbDThn;RXJ2OgZASXV7Q7n6PG^GT8R6OGAlLVR0
M6R?PGBYW9>ZXYnKUIEoNGV0NWYlN7N8Q869QH9mNWF3P7V@SHBDT8NCShB;
Qg^BSh2BS7b=QgVITXRHShRFSHRBRXR=R8b@SiFBTYZ>SiBDT8nCSXZARXB@
TI>O//>5[<eo^o5_]O5b]>h2L[?[0WBek@03LkC/Kk;YK:oV009//NP01Vjc
jVjejfjcjVV`iVV^iFV`iR_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`03/c<c0RJVYX019VIVIZJVYZJVYZJVP>KVi/02IZJVY^KVi^KVi^KViRH
V9JFUY>CTiJFUYbLW002Vi^K0iZJVP:IVIT019RHV9JFUYZJVYZJVP:HV9P0
1iJFUYFEUINGUiJFUYFEUIRHV9FEU@02Ti>C00BEUIFJVYZKVi^IVIT3U9BD
0YJFUP06U9BDUIFEUiNGV9RHUiNGUYJF0YNGU`03UYJFV9RHV9RH00:GUiL0
1IJFUYNGUiRHV9NGUiRHV002UiNG00BHV9RMWIfKVi^MWId8Vi^K00>JVYZK
Vi^KVi/00i^KV`>JVYX/c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
00k<c<`2oooo00Rk^k]VIVKoooo^k^kMgMg<c<bk^k/A4A42oooo00C^k^ko
ooooooo^k^h5oooo0nk^kP03ooook^k^oooo00;^k^h2c?oo0lc<o`03VLco
VIWoVIWo00VIVOl3VFKo1fIVc007VFKoVIWoVIWoVFKoVIWok^k^oooo063<
c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G<c<`00fIVI_ooolc<c00>c<c<0UFdhP04EKKSE[OTE[OTEkSS0UJghP19
FKKRF[GRG;CRGKCQHK?RHkCSJ;KVJ[KXKkK^Kk3XMZcKMJ74QJBiQ9JPQi2?
RHZ2SXYoVY>9Thn6TXf7UXn9ThZ5Vhj8WI2:Ui2:S8N1ShZ4TXn:VIJAViZF
UYFAW9VDZJJQW9NAViB<VI27WYB:WI65W8j1Z9jDZJBNVYVERXV5VIRDShn=
TY:@Ti>AUiRCUYFAViZEX9fHW9VBZJFLSh^2T8UoUHb3SXAkSGigV8N0Wi6>
Vi:EVIRPV:2]UIn[X:F[TI6CUi:>Xj6RZ[S5QJC3Nk?VL[C`LkC^009b/n/0
176djg:ek76djfnbj@9[/>L01fZaif^djFbejVVbifJ_i6F^hfN`i@0[c<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`>VYZJ19^KV`05VYZJ
VIVIVYZJV9RHUiNG00:FUYH01IRHV9NGUiNGUiRHV9NGU`03V9RH00>FUYJG
UiNGUiL00YVIV@04V9RHVIVIVi^KVIVI1IRHV006VYZJVi^KVIVIUYJFVIVI
UiNG0YRHV006VIVIV9RHVIVIVYZJVIVIVi^K0iNGU`03UYJFUIFEUiNG00:H
V9P019VIVIZJVYZJVY^KV`:HV9P00iZJVYjNWYZJVP09Vi^K0iZJVP:KVi/4
VYZJ;<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<0_ooo`05
^k^kIVIVooook^k^gMgM00;<c<`00`000=gMgOooo`02oooo00?^k^kooooo
ool02?ooo`03k^k^olcoc?oo00;<ool6c<co19VIo`:II_l00iVIoiUVoiVI
o`04VIWo0iUVo`AVI/`4VIWo00=VVOo^k^koool0H<c<c003IVIVooooc<c<
07W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVoooo
c<c<00k<c<`4DkGT04mA]^AB]n=C^>AC^>AF]nAG]^AI]NAJ]N9L/^5O/n9S
]NEU]^]R/oAW/o5c[MeeX<:=YkRGXZRKWIbFThjDSh^LUi>IU96IT96ERhbB
QXRJS8bJS8^KT8ZIT8NJTHRITXZIUY6JVIFIV9BIVINKViVUYJ>RXIfZYj:Z
YJ6WX9Z[Y9b]YYbb/:>VYiNTYYRYZifPXYFYZj2/[:Bi^K6`[JS0^kO5_K[D
b/S8_K_3]KBo[jnjYj2nYiFhWXO9[IOOb;SDaknh^;ZU/l2N/lBEZ;JHZK6Q
[:jNZk6@Y[AoY<5i/n=_]>eb]>ia/ne_/N/00Vfbj`05K;?[KKC/K;G/JK;Y
I[7X009U/^P0166aiUn_i62`iF>cj2_<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`03/c<c0nJVYX01I^KViZJVY^KViZJVYVIV@03VYZJ0YRHV005
VIVIV9RHV9RHUiNGUYJF00JHV9P5VIVI00FKVi^JVYZKVi^KVi^JVYX00Y^K
V`05WIfMVi^KVi^KW9bLVYZJ00:LW9`029jNWYbLW9nOWinOWj:RXZ2PX9jN
WYfMW@:LW9`01I^KVifMWJ:RXZ6QXIjNWP02WIfM0Y^KV`04W9bLVi^KVYZJ
VYZJ2i^KV`NJVYX/c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<
c<`2oooo00>k^k]VIVKoool00_ooo`05k^k^c<c<VIVI0000^k^k00koool0
0nk^k/coolcoo`08c<co1IVIo`03VFKoIVK<IVK<009VI/`4VFKo0YVIo`>I
I_l4VIWo00>II_oMgMgoool0H<c<c003IVIVooooc<c<07W<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`0H4nd
hTjehTndhTfdhDjehTbehTnfhE2ghTndh5>ehURgiE^giUbdhUbbhEjbhEfb
j5ZdlUndkFb]efnN^XZU]Y>T[9JSZI2KXIVS[IZT[YfQZZ>TZJFLWjBHV:^L
VJ:ARZfMT:ZJRjNIS]?9_oO`j=[Gd/C3_loAd=cPhOGjoOKko__oonkbmNc]
kno`l^;ThNGZhmGKcm3Fb/O=`l_@bMCId/g?b/?4_jVXY:^WY?Wak_oln_oa
kZjLV/:`[:ZFSKfRSM2eV^;6[]_6]L2g/ZF^]I6/`HBYaXB]bI6fd9Nfb9Fb
a86S_86]d7RdiW6fkfndkFjck6bajVZajFV`j6VbjF^djfZek6NdjVBaif6a
iV2aiUjaiEf`i5nbiV:ejB_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`03/c<c0NIVIT00iZJVYVIVIZJVP09VYZJ00fHV9RJVYZJVYZJVYZIVIVJ
VYZKVi^JVYZKVi^JVYZIVIVJVYZHV9P00YZJVP07VIVIXJ6QZ:RXXj>SX:2P
XZ:RYJFU00:YZJT01ZZZZZRXZ:NWYjNWYjFUYJJVYP:SXj<01J6QXJ:RXZ>S
Xj:RXZ2PX002Vi^K00RXZ:RZZZZXZ:RJVYZNWYjIVIVKVi^OWil2XJ6Q00VN
WYjLW9bKVi^JVYZKVi^LW9bMWIfLW9bIVIT01Y^KV`:JVYX4Vi^K1iZJVRc<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0;oool00k^k^fIV
I_ooo`02oooo00W^k^kooooMgMfk^k/R8R80000R8R9VIVKoc?l03?ooo`03
k^k^c?ooc<co00?<c?l;VIWo0YUVo`IVI/`3VFKo19VIo`03IYWogMgMoooo
063<c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0G<c<`00fIVI_ooolc<c00>c<c<05a=/n=;]>=>]>A<]NA<]N9;]^9<
]N9;]>5=]>5A]^AG^>EI^>IJ]NAL/^=N/N=L]>AE]NMH/mmU[la^Yk^9]<B?
]<B:/lMoZlAnZlZ0ZLNA[L>S/l2WYjNbYIg1[YnfWHV`Uh?1Z9BPRgZZVX_V
fM3oo_K[j^JUZJXi@D@nBDm3DEY<FVDe@dh^?T/eAE90DE]2D5/kBE8nC5Dm
BU96De]3CUAGH6EHH6;Ohn;ooo_flncTgM>OUHVWVHbZVX^LRg^MRWVnZic9
]j^aYZBHW:N?Ykn4/MYi/nEc/^Mb/>5f[MIn[mMjZm=j/=i_[^A^/ni//NY[
/^YZ/NUX/NQW/>MU/>MT/NMS/nQS]>UP/NIM/>AL/^D2Fk?U00=L]>IN]^S<
c<`0:/c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<2IVIV@VJ
VYX2VIVI0ibLW0>JVYX05I^KVifMWI^KVibLW9fMWI^KViZJVYbLW9NGUiZJ
VZBTY:ZZZZJVYY^KVhZ:RX^;Rhb<S8j>SXZ:RXV9RHZ:RP02S8b<00F;Rh^<
S8b;Rh^=SHf<S8`00Xn?S`04YJFUZZZZZ:RXY:BT0YVIV@09VYZJUiNGUiNG
WIfMWinOW9bLVYZJVi^KW9bL00>KVi/01IZJVY^KViZJVY^KViZJVP03Vi^K
3YZJVRc<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0;oool0
1;^k^fIVI^k^k^k^kPOMgMd01k^k^gMgMc<c<`004B8R8VIVVLc<c002oooo
00?^k^koooooool00_ooo`;<ool00nk^k/coolc<o`03c<co00>Ic?nIVOnI
VOl029VIo`BII_l6IVK<0iVIo`:II_l00lc<ooooolc<c01Oc<c<00=VIVKo
ooo<c<`0NLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVKoooo<c<`03/c<c01ABKGSB[KTBkOUCKWWCK[UBkSSBkKRBKCPCkSUDkSV
E[SUEkKTEk?RFk?SGkGVGk[YF;WVG;SOJ;GCJZc4N[C:Mjo8M;7@L;3FKjkI
LZcBRkODXK_:WjFU[J>Gb[BM`:J=/YV5^J:BZ9:4ZIN;WY27/:NPlnkZmoOe
jNg^PXZ=?dY>?DaC?D]F@e=P=DME?dmN?4UI?d]I@DeK@TaH@d]FA4]E/kRn
nOgom_[ij>gWZ:VQWifAThf1HEU<BT@fIEe@YI^AZ9fGY9bJX:2XVjc0RZc?
MZ_MLKK_JK?`JKGaKkC[KJoQL[7TMKCYK[3/Kk?`JJoZ009Y/^T02VRaj6B_
iV>^iF6^i5n_i6>djEjaiEb_hebbiEfei`9J]>H00e^eilc<c<c<c00Yc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`3VIVI0iZJVP:IVIT7
VYZJ00RKVi^JVYZJVYZJVYZIVIVKVi^JVYZKVi/3VYZJ00RLW9bNWYjKVi^K
Vi^NWYjLW9bJVYZKVi/2VIVI00NHV9RLW9bWYjNYZJVWYjNFUYJ;Rh/00Xb<
S004SHf=Rh^;S8b<Rh^;1Hb<S00:WYjNZZZZZJVYYjNWVi^KVYZJUiNGSXj>
Rh^;Shn?19ZJVP03W9bLVi^KVYZJ00BKVi/00iZJVY^KVi^KV`02Vi^K00>J
VYZKVi^KVi/01iZJVP03VIVIVYZJVYZJ00>JVYX/c<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<00k<c<`2oooo00?^k^hc<c?oool00_ooo`05gMgM
^k^k^k^kZZZZ^k^k00;<c<`02]gMgLc<c<c<c<c<c8R8R3<c<`00014A4FIV
IYW<c0;oool2k^k^0lcoo`03ooooc?ooc<co00?<c?l;VIWo00>II_nIVOnI
VOl00iUVo`9VI/`01iVIoiUVoiVIoiVIofJIolbIooooo`1Pc<c<00=VIVKo
ooo<c<`0NLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVKoooo<c<`03/c<c003@;?O@[GQA;OS0097^>@0DTRgi4Zfi4bgiDjgi52e
he:dheFeiENfiUVeiURbi5J`hU^gj5feiF6bgFF`f6N_eFZ_eVbafffbg6nd
gWB_eh6`cYBa`inYZjJOUKNSRlR_VJ2?QKNYYY21OVQJEjBGTIjCSJBJTLJn
/oOaiOGai]CDbVe^J7MkNWQmP8J=ThN<TY:AUhR7S8Z9SY:@Ti^BUn_Ohog_
koofm<C4_:FXWi>FSGn2Ne]KFCm0@S]3AV1UJ9nOWIZHVHJ;THfJZY2[aX6[
dGbbhG2cj6fekfVekfRekFJcjFNbjFZcjV^ckVbdkfNbjfJajV>^if:]iVB_
j6Rck6Nbj`9T/NT01f2_ieb]i5Z]heV`iERbiUNaiEFai00[c<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<00k<c<`00iRHV9VIVIVIV@05VIVI00>J
VYZIVIVIVIT019ZJVP03VIVIVYZJVYZJ00JJVYX049^KViZJVY^KVibLW9^K
ViZJVY^KVijNWYRHV9bLW9JFUXn?SiVIVIRHV9ZJVYnOW`:XZ:P01:>SXi:B
TYBDU9BDU0:GUiL00iRHV9JFUYJFUP02V9RH00RUYJFXZ:RYZJVPX:2KVi^H
V9REUIF?Shl2RXZ:00F@T92JVYZIVIVGUiNIVIT01i^KV`:JVYX3Vi^K1IZJ
VP03Vi^KVYZJVYZJ00:JVYX3VIVI00>JVYZIVIVIVIT0;<c<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c00>c<c<0oooo`034@00oooooooo00;oool0
1>k^k]gMgLc<c<c<c0Bk^k/3c<c<0]gMg@0:c<c<R8R8A4A400004A4AEEEE
ZZZZc?ooooooc?oo1lc<o`03VLcoVIWoVIWo00BIVOl00iUVofIVc6IVc008
VFKo0iVIo`04VFKoVIWoVLcoooooH<c<c003IVIVooooc<c<07W<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`0
13fdgSnfh46fhD>fhP95]^80ATVehdZehdbehTjehTndhU>ei5FeiEJeiEFd
i5JbheZfjEZdiU^chefagen`gf:`gV>agfNah6RagW2_f7b^chR[`INU[Z:Q
WJjNSk:OT:ZPWW5]KT@k?V5HFFmUI8YoNj>ISjBJSZ2GR>CMcOojk?3/h6i[
I6e/JWQhNXZ8Ri:9RWmeM8Z5PYnGUOKVi_oin_o]kLJd/:6MU6a_I59GD6EZ
IUEFFR8V;bhjATABFe]TJf=]MVYkRh6K/XN[cGZZdWF_gfV/h6NbjFBcjf:c
jf2bjP9R/NX2I[7[011V/^aU/^YR[nMP[NES[^MU/^YT/NUQ[^IT/NUQ/>QO
/>MM/>IJ[nEI/>EH/^IG/nH[c<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<00k<c<`00iRHV9VIVIVIV@08VIVI19ZJVP03VIVIVYZJVYZJ00RJVYX2
Vi^K0iZJVP:KVi/01I:BTXZ:RXn?Si6ATIFEU@03VIVI01jTY:BYZJVWYjNA
TI6BTY:DU9BFUYJGUiNCTi>FUYJIVIVWYjNYZJVXZ:RNWYjJVYZBTY:>SXjA
TI6>SXj6QXJ9RHV=SHf@T92ATI6CTi>HV9RKVi^JVYZKVi/EVYZJ0YVIV@:J
VYX/c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`3oooo00>8
R8Q4A4Coool01?ooo`04k^k^gMgMgMgMgMgM0/c<c0Fk^k/2c<c<0mgMg@06
ZZZZA4A400000000A4A4R8R81<c<o`>IVOl00iW<oiVIoiVIo`06VIWo00>I
I_mVI/aVI/`00fIVc0:II_l4VIWo00>II_nIVOooool0H<c<c003IVIVoooo
c<c<07W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
ooooc<c<00k<c<`013fbgSjcgd6dhD6dh@93]>001TJbh4RchDZchTfchdnd
hU6chP9C/n<0?5Bdi5FeiEFgj5BfiEFdhURcgeZagUfagEnah62ah6>]gVf`
gGN^eH>ZbIZ_`[>g`;ne];V^Z[Ne]X^?TS@c>51@DWAbLfMSH55<AW]gK:>O
TiB@Q;nm/O7^iOonnMkLgLC2aoWdn?olnn?He_O_k?oknOobloSTiKZQY:bJ
V75/IT=4?4]>Ade?C3ln@cPk@TaFH4eMJUMZNEegR7>AZH^_chJcfWR^g7Bc
iVN^i6Fbj6:cjP9P/nT2H[7Y00MU/>UU/>YT/>YR/NYP[nQN[NIQ[NL00V6`
j@09GJkVGk3XGk7YH;;ZGK;YFK3VF:oUFK3VF;;W02_<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`03/c<c0:HV9P<VIVI1YZJVP03VIVIVYZJVYZJ
00FJVYX05ibLW9jNWYjNWYfMWIjNWYNGUhR8R8f=SI>CTi2@T8b<S9>CTiZJ
VYNGUinOWjNWYjZZZZBTY:2PX:RXZ:ZZZZBTY:RXZ002ZJVY00VWYjNLW9bJ
VYZBTY:;Rh^<S8b=SHf:RXZ9RHT00Xj>SP05T92@TY:BUiNGVi^KW9bL00:K
Vi/<VYZJ00FIVIVJVYZJVYZJVYZIVIT019ZJVP>IVIT00iZJV/c<c<c<c00Z
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`4oooo00@c<c>I
VIW^k^k^k^h4gMgM0nk^kP?MgMd2c<c<1k^k^`05c<c<gMgMc<c<ZZZZIVIV
008001400b8R8VIVVIW<c002c<co2YVIo`>II_l4IVK<1YVIo`03k^k^c<c<
c<c<05k<c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<00Hm/]hn/mm0/n10/n11/]i2
/Mh2AK7O00A9/^5;]>=>]N9?]>82D;;Q03]C/n=D]^EB]^MD]^EE]>9F/mmI
/]iK/]mM/N1N/>9O[n9W/N9_[]Yi[MBD]m>`aMRoamBm`/Rh`LI/MWQ4C4m<
DEA;Ce14ATEIFUEUI5mNGUJ>SXJKW9Bb/jgfmO?oo_onnOoglOGiko3ooO_i
mO;ooOcVf]j[VZ2ZUieKCe5VIF=jOg]=De4d>3]3@d]2AU5TKGb5VZ]mWKAe
W;UnZlb5]]ie[]][Z]e//nMT/NMQ/^T00V2cj@03HKCZHK;YH[7Y009S/>P2
H:oX00]O[^MM[^IN[nMP/NUO/NUM[nMJ[nIK/>ML/NQJ/NMH[nD00eN^i2_<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0RHV9P7VIVI19ZJ
VP03VIVIVYZJVYZJ00JJVYX04ifMWJ2PX:6QXJ2PX9nOWi>CThb<S8f=SHb<
S8^;Rhj>SY2@T8n?SiNGUiVIVIfMWJRXZ:ZZZZVYZ@02Z:RX00BZZZZXZ:RZ
ZZZUYJD2VYZJ00F=SHf@T92DU9B=SHf9RHT00X^;R`06TI6AV9RHV9RHV9RH
VYZJW9bL0YZJVP03Vi^KVYZJVYZJ00ZJVYX00iVIVIZJVYZJVP02VYZJ00BI
VIVJVYZJVYZJVYX4VIVI;<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<
c00>c<c<1?ooo`07k^k^4@00ooooooook^k^gMgMc<c<00:k^k/2c<c<00CM
gMg^k^k^k^k^k^h3gMgM0/c<c0Jk^k/2c<c<0]gMg@06^k^kIVJI8R8R0000
000R<c=V1IVIo`03VFKoVIWoVIWo00FIVOl2VFKo00=VI/bIVOnIVOl019VI
o`03olcoc<c<c<c<05k<c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<0Snbg`0:@[;P
@K7O@[7O@[7OA;3OAK7PBK;QBkCSC[CTCk?T0Tjbh`06DK?TDkGVEK?VEk?T
F[;RFk7P0Ufah013GK3RFk7TH;G[Gk;VHZkPJZkKN;;GQkKDTKO>UkC4TZJ_
GW1dFFI/@4]??4A7@TM:EE]IEEYFBe1<DEIBRXb9WInL[J^/kNS/oocooo_o
oogon?Kio?oohnK[Z:N_Pgf9DTYGE55JBU5G<Ci4>DA:>D==C59RIfn2G6]n
NIF]Q[CELJS?LZgGLJoNI:OKI:gRJKK^I;G/Fk3VG;7WGK?VGk;VH;7VH;3U
GjkVGZgUHK3YH;3[GjoZG:kXFZoXG;7ZF[3YEZoWF;7Y009F[nL3F:kW00=G
[>EFZnC<c<`0:/c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<
29RHV0NIVIT=VYZJ00ZKVi^LW9bMWIfLW9bJVYZATI6@T92<S8b:RXZ;Rh/2
SXj>00J=SHf>SXjGUiNJVYZLW9bVYZH3ZZZZ00JYZJVZZZZVYZJLW9bEUIF<
S8`2SHf=00V9RHV:RXZ:RXZ=SHfBTY:ATI6GUiNLW9bIVIT00YZJVP04VIVI
VYZJVi^KVi^K1iZJVP04VIVIVYZJVYZJVYZJ0YVIV@:JVYX00iVIVIZJVYVI
V@06VIVI;<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<1Ooo
o`030000oooooooo00;oool00nk^k]gMgMgMg@03c<c<00>k^k_<c<c<c<`0
0]gMg@;^k^h3gMgM0lc<c0>k^k/4c<c<0]gMg@03^k^kR8R88R8R008R8R80
0c<cIVIVVIVIc002VIWo00AVI/bIVOnIVOnII_l:VIWo00?MgMg<c<c<c<`0
G/c<c003IVIVooooc<c<07W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1Lc<c003IVIVooooc<c<00k<c<`2?k;O0T6ag`91/=h01DB`gdFah4Rb
hTVbhDZchP03C;;R059>/^=A/nAF/^EI/>EL[n=L[n5N/>9M/>9K/NAJ/NIJ
/n]G/NII/>EQ/n=X/meY[M9]Z/UiZL1WQI1TMge]Oh=PKW5HHVAUKFmYLW5W
L6meNgU[LFm_Lg9mOgjOWIjb[:kZhNKonOgnmOKoo_oUjNZQYZV:RY9kN8=d
KWZ2P8]fOhJ<VImoRI9cNhIdNXY]M8IdPiJ0X;Uk/]UUZMQW[n5W/>ER[nMV
]NiS]NeO]>]K/^MK/nEL]>AM/nAO/^IN/NMN[nIN[nMQ/NaQ/neP/^aK/>UI
[nQF/NQE/>M@[^AE/nUC/NMC[^EE[^IF[nMI[nQH[NIFZn@[c<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<00k<c<`8V9RH29VIV@04VYZJVIVIVIVI
VIVI1IZJVP:IVIT3VYZJ00RIVIVJVYZDU9BBTY:DU9BATI6?ShnATI42TY:B
00NDU9BBTY:BTY:EUIFJVYZMWIfVYZH00ZVYZ@0:ZZZZYZJVVi^KUiNGU9BD
TY:BUIFEU9BDV9RHUYJF0YBDU005Ti>CUIFEVIVIVi^KVIVI00>JVYX2Vi^K
3IZJVPBIVIT00iZJVYVIVIVIV@05VIVI;<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c00>c<c<1Oooo`038R8Rk^k^oooo00Goool2k^k^0]gMg@;<
c<`3^k^k00?<c<cMgMg^k^h01^k^kP04gMgMc<c<c<c<^k^k1Lc<c00;ooo<
gMgMc<c<ZZZZA4A40000000A8R8RIS?<IVK<VIWo00>II_l016IVc9UVoiVI
ofJIo`:IVOl00iUVoiVIomgMg@1Pc<c<00=VIVKoooo<c<`0NLc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<c0A0
/>00242^gd6_h4:`hDFah4B`gdF_gdJ`h4Rah@9:/n<0BTbbhdb`hUF_i5R]
i5^^i5b]hUf^heb_heVaheRbiUBbj56`iU>bj5RfjEjfi5jcg66`efj^bW6E
XGb?UGF4RHnJWYVQY9bQY9jTY:>YYijWY;:k^;[0_[Nk^[^j^;2ZZZfSX_[_
kOokm??Yh;Re[]WHdmWEe>7KgMW@dmSBe=?Ge]3Fe=CHfLW:c/6nahf;UX28
Tff9WW2^ee^[gV6`j5j_iej`jUjck5N/heR_iEbcj5ZdiUZei5bdi5bdiUbc
j5baj5bajUf_jEnajebbjeN`j5F`ie:aie6`iTn`i@9@/NH01U2_iE2^i5>/
i5J/iEN/iER]iR_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<
c0^HV9P;VIVI0YZJVP>IVIT5VYZJ00BGUiNFUYJEUIFIVIT2VYZJ0i^KV`0:
WYjNWinOWYjNWinOW9bLVi^KZ:RXZJVYYjNWWYjN0Z>SX`03Y:BTXj>SXj>S
00>SXj<01j6QXInOWiNGUiJFUYFEUIZJVYVIV@04VYZJ0YVIV@^JVYX=VIVI
;<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<1Oooo`03MgMg
R8R8oooo00C^k^h6oooo00G^k^kMgMgMgMgMgMg<c<`00k^k^`03c<c<gMgM
k^k^00;oool01Nk^k_ooonk^k^k^k]gMg@02c<c<1;^k^`0>c<c<^k^kc<c<
gMgMc<c<ZZZZIVIV000A0000000c<c=VIVK<VIWoIVK<1IVIo`03VFKoc<co
c<c<05o<c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<13n_g`14?ZkN@:kO@[3Q@k7R
?jgN@JgL@ZkMA[3PB;;RBK?SBK;RBJkRCjkTDjkUE:kSEjkSF:oTFK3UEk7U
E;;VE;?YDkCYD[?ZD[;UEK7RE[7NF:oLIJ[;IHVIHG9iHFmb_<K8n_oom_[k
o?ooloSdnooml?Wfn?klo?omnocgnoKbf]7<[J2Jkn7H^:bPlNoSnocdno[f
noOfoo_ko_[im_[inoooloOfo_ooinC[;Rhh=d19Li:VL;7KG[7WGkC[EjcU
FJkWFk7ZEJcRG[GZ0URbi00FF;?REk?TE[;UE[7VEk3XEk3ZEZ[VFJkWEk3Z
EK3WDK3XD[?XD;?ZC[?WBjkUC;3TCZoVCZgSCj[SD:WQEJ_VEjgV:lc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<39RHV0>IVIT00iRHV9VI
VIVIV@06VIVI0YZJVPJIVIT039FEUI:BTY6ATJ2PX:ZZZZVYZJZZZZVYZJZZ
ZZRXZ:VYZJZZZP:YZJT01J>SXi^KVjJVYYfMWJNWY`03ZJVY00^ZZZZYZJVY
ZJVZZZZXZ:RZZZZVYZJ7QhN:RXZGUiNKVi/00YZJVP:IVIT00iZJVYVIVIZJ
VP05VYZJ3iVIV@:HV9P2VIVI;<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c00>c<c<1Oooo`03k^k^4@00k^k^00?oool00nk^k]gMgMgMg@03k^k^
0oooo`C^k^h2gMgM00G<c<aVIVHR8R9VIVK<c<`01_ooo`?^k^h00mgMgK^k
^k^k^`02^k^k00BZZZZk^k_<c<c<c<`2gMgM00NZZZYVIVH003<00140028c
<fIVIYT01IVIof3<c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<0SV[g@09>ZcN>jgO
?:kP?joQ@;3R@K7Q@;3P@[3QA;;S0097/n@024FahTB^h4>]gdZcjTR`idR]
hdV]hDj_hP9A/N@0BE2`he>ciUBbiUBbj5F`iEJ^h5R[gEb^gVn_eFB5V5m^
ME5JGmOLgo;bm=7@c]3?blC5`:Z_ZJ:XY9>LUhfCSi6DSIVFShb5OJ:IT:>J
TGikLXF<Q8NBRX29QXN=SHN8S8R<SfA_LEUWJ5AOHgn8SgUoRbTc?be0CWFK
/VZ_fEjaie^^i5N/heZ_iUjcjUbcjEN^heVciEZei5RdiEBcheBbiUJdjUBc
kE:_jUVbkUR^jE:/j4n/iDf]idf`idjcjdfejTJ[hdV^i4^^id^/hdfZiE6/
iE>/j5>/iP0[c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`3
UiNG1iRHV0>IVIT3V9RH0YVIV@:HV9P;VIVI00JJVYZDU9BATI6>SXjTY:BX
Z:P2XZ:R00BPX:2LW9bKVi^IVIT2V9RH01>IVIVFUYJIVIVIVIVDU9BFUYJG
UiNFUYJGUiNFUYJGUiNATI6@T92?ShnFUYJEUIF8R8R9RHVHV9P00YZJVP>I
VIT2VYZJ00BIVIVJVYZJVYZJVYX2VIVI0YZJVP03VIVIVYZJVIVI00JIVIT2
V9RH00>IVIVHV9RHV9P00iVIVBc<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`03/c<c0Koool01;^k^a4007MgMk^k^`Coool00nk^k]gMgMgMg@03
gMgM00C^k^koooooooo^k^h2oooo00[^k^koooooooo<c<agMgMEEEDR8R9E
EEFZZZ[^k^h3oooo0^k^kP?MgMd01<c<c;^k^k^k^k^k^`:ZZZX2^k^k1<c<
c007MgMgIVIV000c000A<c=VIVJIgMgM063<c<`00fIVI_ooolc<c01ic<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>
c<c<00Hh[=di[Mhi[Mhj[]lk[n0l[^02?JoQ05Pl[=hl[=`n[]i1[n13/N94
/^=7/nA6]>M2/>E1[nA3[^A5[n=8/>=</^=>/^AA/^EC/nIB/>AD[nAF/>AG
[n5HZmeIZmeWZ=1JOI=?H6YBFfA_LWMXI6EZIF9^JFI/JfJ2Qh61Qh>0RHAh
PGajOgR8RH64P7FVWiF`ZImoO7=bO7=_O7=ZMG5cO7]_LgA/LGAPK6aCHF99
E5QSK7=KHfi2D5e0EfEJQ9aY[]QP/NIO/>EK[^AJ[N=J[nIH[nAF[N9D[^1E
/N1C/^9@/>9@[nEA/^UB/^iA[naF/>aD[NU?[>M=[>I=[NM:[nM9[^I5[NA3
Zn96[^E9[^I9[>E<ZnE?[>MAZnM?ZND[c<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<00k<c<`3UiNG1IRHV0:GUiL3V9RH0iVIV@BHV9P<VIVI00FC
Ti>?Shn>SXjBTY:@T9000i6AT@>FUYH2U9BD00BFUYJEUIFJVYZLW9`2U9BD
00>CTi>BTY:DU9@00Y:BTP08TI6AShn?SHf=TI6AT92@S8b<SHf=U9BD0iZJ
VQ2IVIT00iRHV9VIVIVIV@07V9RH0YVIV@03V9RHc<c<c<c<02[<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0?oool00nk^k_ooooooo`02
oooo00O^k^jZZZYEEEDc<c=VIVJIVIWMgMd00oooo`03k^k^gMgMgMgM00CM
gMd2k^k^0oooo`0:k^k^ooooooook^k^ZZZZEEEE<c<0A4A4R8R8c<c<0ooo
o`04k^k^ooook^k^k^k^0/c<c0>k^k/2ZZZZ00?<c<bk^k_<c<`00oooo`03
olcogMgMoooo063<c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<00DeZmdf[=hh[^0i
[n4j/>800Sb`h`04?;3Q?JoQ?:kP?:kP0Sj^h00<?joQ@[3S@[3S?ZcQ@ZgS
A:oUAJoSAjoTBZoSCK7UD;7TD;3S0Tn]h00lE;3QEJoQDjkMDZ[JGJG=Ji2[
FfioJGF1GV5ZH5]OLVYXMfm]Lg1[L79]JgA_M7mkIg9^GfQSKgA]Jf]QU925
[J>IPWa`M7QZKgMZKG=YMWUbLW5/KVeXGV=MF5iJFemNJViaB4aEDeeWG7B0
EH2CHZK=G:cMGjoRG:gRFJcRF:gSFK3UF[7VDjgOE;3QDk7TCjoRCJkUC:oX
C[3]D;3]Dk3]DJkYD:gXCjkXCjoYBk3XB:gU0T>[hP07AJgTB:gUB:_TBJcU
C:cVC:_UBZWS02_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<
c0:GUiLCV9RH2IVIV@:HV9P01IJFUY6ATI>CTi2@T8n?S`05TY:B00RDU9BB
TY:@T92BTY:ATI6GUiNKVi^DU9@2Ti>C00FBTY:CTi>BTY:BTY:@T9000Xn?
S`08TY:BS8b<Shn?TY:BTi>CV9RHVIVIVYZJ19VIV@03VYZJVIVIVIVI00bI
VIT:V9RH;<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<3Ooo
o`06c<c<MgMgA4A4EEEER8R8gMgM0_ooo`;^k^h01=gMgNk^k/c<c>k^kP[o
ool01nk^kZZZZVIVIS<c<dA4A7MgMk^k^`02k^k^00Goooo^k^kMgMgoc?o^
k^h00/c<c004^k^kZZZZ^k^k^k^k1_ooof3<c<`00fIVI_ooolc<c01ic<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>
c<c<00H_ZMXaZm`c[Mhe[n0h/>8i/N<2>k7S0Sjbh`08?JoQ?:kP?JgO?JgO
?:cN?J_N@jgQAJgR0TJ^i@0RAjoVAjoTBJkTBZkRBJgOBZcMBjgNCjoOD;3P
CZoLCJgMFZWBQ;;CMY:XEVMiATiKG5]QJVIWN79bJVUWK71_EV1ODV1PAeEE
BeMEGfQUCU1;Hf9MLV]UGe]BHfUOIg5XIFaTJFiX0V]ZIP0I@DI0=3XfAD];
HFI/<c]6>d]JL92OKinfGj;<FJWJGJgPG:gRFJcREjcSF:oUF;;VDjoRDk7T
D[;TCZoRBjcSB:_VBZcYC:k[CZcY009?[^P2CjoY00]<[nQ:[nM7[nI5[NA6
[^E7[>A6Zn=7[>A8[NE9[>E6ZN80:lc<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c00>c<c<00BFUYJGUiNGUiNGUiL:V9RH0YNGU`^HV9P3VIVI0YRH
V009Vi^KUiNGT92@S8b<Shn?TI6ATi>CTI6ATY:B00:?Shl2SHf=00N@T92=
SHf@T92BTY:?ShnATI6BTY80196AT@07Rh^;RHV9S8b<T92@RHV9Rh^;UYJF
00:HV9P6VIVI00>JVYZIVIVIVIT00YVIV@>HV9P8VIVI2IRHV2c<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0goool01^k^k_oooooooooo
omgMgGMgM`94A4@01GMgMk^k^nk^k_ooonk^kP0?oooo00_^k^k<c<agMgLc
<c<c<`1VIVJIVIWMgMg<c<cMgMgoc?l00]gMg@?<c<`6ooooH<c<c003IVIV
ooooc<c<07W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVooooc<c<00k<c<`01RfYg2jZgC2/gc:^hCF_hSJ`h`8f[^0013R^h3V_
hCZ^hC^_hP<m[n40B46/h4V]hD^Zh4VZhDR[i4V^iTR`idN_iTF]hTF]h4F^
gTN`gdRah4N`gdF^fdF`gUB_ffJTbFjG]BY8H20cA4=:E5QIGVATIUmPHUAL
GS8m@B4c=b8c>SM6Be5OHSLo@SLk?T11ASi3AdYJFU5UI4eOGdiLGE9JGEEM
H3]6B1PU:adZ<c];FQd_AA4_BFZH/W>`cf6ZeE^[g5b/hE^/heN/iEBZhe6Z
hU2[hTn]hdn_hU2`hdf^hdZ[hTRXi4ZZidf]jT^YiTf[j4n]jTf]jD^[idR[
iTV/i`=9[NP01TF/iT:Yhd:YhdB[iDF/iTB[iB_<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`03/c<c004UYJFUiNGUiNGUiNG0YRHV0:GUiL=V9RH
00>IVIVHV9RHV9P00iRHV00?VIVIV9RHV9RHV9RHVIVIV9RHUiNGRXZ:QhN7
S8b<SXj>T92@Shn?SXj>RHV900:7QhL018^;Rhn?ShZ:RXV9R@::RXX00hj>
SXn?Shj>SP02SXj>00V?Shn;Rh^5QHF6QXJ;Rh^7QhN6QXJGUiNJVYX01YVI
V@:HV9P4VIVI0iRHV003VIVIV9RHV9RH00:IVIT<V9RH;<c<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c00>c<c<1?ooo`03k^k^oooooooo00koool0
1>k^kYVIVFIVIZZZZQGoool01mgMgHR8R5EEEC<c05EEEHR8R<c<c003k^k^
00?MgMgoooooool01?ooof3<c<`00fIVI_ooolc<c01ic<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<01X]Zmd]
[Mh_[Ml_[Ml`[^0`[=lb[=daZm`d[=hg[Mlh[^0j[^4l[^0m[n4l[^11[Mi:
Zmi9ZMa7Z=e5Z^17[nI8/NY6/NU3[^A5[n=6/>82A[3P03]3[Me1Zm]3[mi?
/=ePZM9DR[0?>5HE<DLfAUDnADd/;c@i?T8f@DLU<c`L<3/N<SdU=d<fAe4/
=T0^=40/<T0Z=40X?dL/AD`Y@4HY>T4]=d0/=SllBe8O<3XL;S`[@5DE;T`0
8TABR:aTZ<mO[=YIZ]mHZN1FZnAF[>MC[>Q@Z^I>ZnI>[NE=[^E>[nA?/>M>
[^Q<[>Q>[>YA[ne>[>Y?[NY>[^Y<[>Q9ZNE8Z>A9ZND00TR[iP05B:cWAJcV
@ZWS?jSQ@:WR0091[>@[c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<
00k<c<`:UiNG2iRHV0:IVIT8V9RH0YVIV@03U9BDQhN7QhN700:;Rh/00hN7
QhZ:RXZ:RP03QhN700>8R8R;Rh^8R8P00hR8R003RHV9RXZ:RHV900>8R8P0
1h^;RhN7QhN7QhZ:RXJ6QXB4Q9BDU007VIVI0YRHV0FIVIT00iRHV9VIVIVI
V@03VIVI2IRHV0:GUiL2V9RH;<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c00>c<c<<oooo`05ZZZZEEEE8R8R<c<cZZZZ00OooomPc<c<00=VIVKo
ooo<c<`0NLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVKoooo<c<`03/c<c004:j_L:J_L:j_L;:cM0Rj/gP04;j_N<J_N=JoP=ZkP
0SN]g`8h[=l01cZ/h3f[g4F^gDF/fD:[fd2/gD2^h`02@:oV03e1[^I4[nE4
[^95[N98[N56Zmm5Z]i6Zn5=[N1T]>DhNjD0:dd;<4/Z@E<]>dHP:C8c?4DX
=T4Z?4XX?DhY@58M<TDT=DLY=4H_>4Tc>Td_>T`U>dPS?TTT>TDV=d4Z=3hX
<3/W=3dN;S/S=4HS=e0C;Dh09dhfL9QNYM5LZ]]EZ=iCZ>5DZ^MD[>]@[>]?
[N]@/>e<[>Q;ZnE<[NA?/>MA/>Y?[^Q?[>UA[Na>[>Y<[>U;ZnQ:Z^L00T^Y
i`0:BJOUAjOTAZKSAjWVB:cX@ZWT?ZOQ?:KP>jSQ?:WR:lc<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c00>c<c<0iJFUPfGUiL@V9RH00VJVYZATI65
QHF6QXJ:RXZ9RHV6QXJ9RHV8R8P00hV9R@03QhN7R8R8R8R800>9RHT00hR8
R8V9RHR8R002R8R800>7QhN8R8R7QhL00XR8R005QXJ6QHF5T92@V9RHVIVI
00:HV9P5VIVI0iRHV0JIVIT7V9RH00BGUiNHV9RHV9RHV9P4UiNG;<c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c02]c<c<00=VIVKoooo<c<`0NLc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0
3/c<c00M9JOH9ZSI9jWJ:Z[K;J_M<:cO<JgP<ZkQ<JgP<jgN<J_N<Z[L=J[O
=jgO>ZgS?:kP@K3M@joM@:oM?JgM>ZcP>JcR>jgS?ZgT?jgR?j[P@Z[OAZ_Q
B:gS0098Zn80>4b[hE>Vg3Em[@0bF@`eDAljCB4c@BdiAB@b>b8d@2<iAQ`b
@2HmCB4gABHiAbTkBB@a@BTa?RXf@R4j@B0nAR8mARHjABdiABde@R`hA2<c
@2DfB1/_B14[CP`_EbAGQ5fOcef]h5F/hU:[iE:/j52]jTbZj4b/jDf_k4NZ
iDFXhdJYhTZ]iTb/iTVYiDRVhdVWiDVYiTBVhd:ThDBVhdZZid^[j4NWi090
X]l01dBXi4F^j46[iCZWh3NVgSRWgcJWg`0[c<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<00k<c<`4UYJF2YNGU`JHV9P2UiNG0iRHV003UiNGV9RH
V9RH00FHV9P01Y:BTXJ6QXN7QhR8R8N7QhV9R@:7QhL00hR8R8N7QhV9R@02
R8R800>9RHV7QhN8R8P01HR8R006RHV9R8R8R8R8QhN7R8R8QhN70XJ6QP03
S8b<V9RHVIVI00BIVIT2V9RH00>IVIVHV9RHV9P01iRHV0>GUiL3V9RH0YNG
U`>HV9P4UiNG;<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c02]c<c<
00=VIVKoooo<c<`0NLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVKoooo<c<`03/c<c0059JOI9jWK:j[M;J_N;Z[N008_Z=d0@bfY
gBbXg2^YfbbZgBjZgC6Zgc>]h3F]hSR^h3^^gCV/fCR[fSV[gCZ^hC^_hSb^
hSf/hD2^hd6/hT:]hdF^iDJ^hdJ[hDFZh4ZYge:TgRQ^XPe1JA@iERPoDC12
CS51CR`nB316DCA=E3E9D3Q=D2]0@CE:Bc=<D3=8BdE>CD=?BcACCCELFD=T
JDEPJEi/NEaUM5MUL4eOJeMZNEU_QTeQPSiGP4IXV5jCaeVYgU6_iDj]iDZY
hDJVh4RXhTV/id^^jDV/idN[iP02AZ[U0154ZnE4ZnI6Z^I5ZNE3Yn=5ZNA7
ZnI8[>M4ZnI2ZNA1Z>=0Yn94[NM1ZnDlZN@iYn8gZ>800SJYhP03=JWRc<c<
c<c<02W<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0>FUYH2
UiNG1YJFUPBGUiL2V9RH0iNGU`fHV9P018n?ShR8R8R8R8V9R@::RXX00hV9
RHZ:RX^;R`02Rh^;00B9RHV;Rh^;Rh^;Rh/3S8b<00B=SHf?Shn>SXjATI42
T92@00N?Shn@T92ATI6?Shn>SXj@T92FUYH00iVIV@05V9RHUiNGV9RHV9RH
VIVI00RHV9P00iNGUiRHV9RHV003V9RH0YNGU`:HV9P6UiNG;<c<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c02]c<c<00=VIVKoooo<c<`0NLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<
c00B9JOI9jKI:JOJ:ZKJ;JKK;ZOL;jSM;JWM;j_O;J_N;:_N;ZcO;j_O<Z_P
=:cQ=Z_P>ZkO>:cK0SN[g00g>JgP>ZkQ>jgQ>jgQ?:_P?:[O?ZcQ@ZgS@jgQ
@j_PA:cOC:_QD:;L@XRl@WRTD7^MG7jGIh>HKhbNMY6RJH>BU:Ze`=;FUJ>S
VJFS]/G2[l73/<2o/kZc];^c/lS1]/o<Y;Vne^SdkO[o`=3PS:JePZ>bP:Ji
O:JnOjK7PJK@MI_<Iic@EZWMCJkSBjcSAJSO@jKMA:ONAZWRAJ[RAZ[UA:_U
@j[T00=2ZnD0142YhcnXhT2WhD6XhP93Z^@0246Zi3nXhSjWhCbVh3fZhc^X
hCRVhCFVh08eZ>400c>Wh2nVg/c<c00Zc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<00k<c<`8UYJF29NGU`03V9RHUiNGUiNG00:GUiL3V9RH0YNG
U`JHV9P02iNGUiBDU9:BTY:BTY>CTiBDU9JFUYNGUiBDU9^KVj:RXP02VYZJ
00>PX:2OWinOWil00YjNWP08X:2PXJ6QWIfMYJFUZJVYXZ:RVYZJVIVI19ZJ
VP>HV9P00iVIVIRHV9RHV002UiNG29RHV0BGUiL3V9RH2YNGU`03UYJFc<c<
c<c<02[<c<`00fIVI_ooolc<c004c<c<00=VIVKoooooool0[Oooo`03c<c<
ooooc<c<07W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVooooc<c<00k<c<`01bZZfbVYfRRVf2ZVfBjXfc6YgC6[gP02;j_N0bj/
gP06;j_N<J_N<j_O=J[O>JgN=j_L0SJZf`0_=j_N>:cO>JcR>ZcR>:[P>ZWP
?J_P@:_Q?j[N?jWM@J_OBZ_NC9oADI_:Fj3:IZC;JJ76Kj74O:[;Qjk;P9jf
Wk;1gNC^l_7f_[VmS8J:ZJJ]/:ne[k6^/K6_ZJ>UYI^SooCon?Coa/kQW[O=
MjFlJJ[0HJg5E:G2FjO9IjoGHYo<DIG6E:cNBjoQB:cP0094ZMd04DFZgTFZ
h46YgT>[hT6ZhD:[hT:[i4>/iD6/i42[hcnZhT2YhT6Zhd:[iD6Zi42YhcnX
hP02?ZSR00@lZN8jYn0gYN0eY^02=ZWR00<cYn0`Y=g<c<`0:/c<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<1IJFUQJGUiL00iRHV9NGUiNG
U`02V9RH00>GUiNFUYJGUiL00iRHV009VYZJVi^KVIVIW9bLYJFUZ:RXWinO
UYJFVi^K00>MWId01Y^KViZJVZVYZJVYZJ:RXYfMW@>IVIT01INGUiRHV9ZJ
VYRHV9JFUP02VIVI1IRHV003UiNGV9RHV9RH00JHV9P019NGUiRHV9RHV9RH
V0^GUiL00iJFU/c<c<c<c00Zc<c<00=VIVKoooo<c<`01<c<c;5VIVIkc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>
c<c<00T/[=dZZ=XYYMP/Y]T`Z=`bZ]haZMd_ZM`/Z=/00R^Yf`07;JWL<:[M
<Z[N=J[O=ZcN=j_N=Z[K008dZ=T01SBXfcJZgCNZh3R[hCV/hSZ/hP8lZn00
=S^Yg3VWfSfXg4F[g4fZeU2WdUBXe5FXe5FSdE^Tcf>TcVRPaGbWbI:`bYn^
`Ko3cnCNj=?8d9^;UJnTZZNWYj2NWn7@f?o/o?7Kl<BoeYNY`G:L]FJWaEFX
b4j_dTJ/dTNZddj[eUFVdeV[fdn]h4V_h4J[gd>[gTJ[gdF]h4B/hCnYgD2Y
h3jYgcnXgcnZh42[hcn/i46/i42[hcjYhCnZhP90ZN<2?jSR00XoZN=0Z^@m
Z^<jYn0gY=lfY=lfYn4eZ>4dYn0`Y=d[c<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<00k<c<`00iNGUiJFUYJFUP02UYJF0iNGU`BFUYHCUiNG2IRH
V007VYZJW9bLW9bLX:2PYJFUXZ:RV9RH00:KVi/029ZJVZ>SXjRXZ:FUYJ2P
X9^KViRHV9VIV@JHV9P2VIVI1YRHV0FGUiL4V9RH00>GUiNHV9RGUiL019NG
U`03V9RHUiNGUiNG00:FUYH3UiNG00>FUYK<c<c<c<`0:/c<c003IVIVoooo
c<c<0?o<c<`ac<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`0
0fIVI_ooolc<c00>c<c<00@YYmTXY]PXY=L[YMP2;jOK00@]YMTZY=LZY]TZ
Y]T2:jOJ00H^Z=/`Z=`cZ=deZM`dZ=/dZ=T4<ZSJ03`dZMheZ]li[^<hZn4h
[=liZmliZ=dhYm`kZM`n[M]3[]Y0[=<oZ=DnYmA2YmE<Zm]CZMQBXLaMX<]T
W<63ZljG/LZY//?Rg>K[fmkRd];^k^cZj^com?o]f^fi/LVJZ<=nZ/MZ[<aJ
ZM17X/m4Z=U3[Mm5/N94[]i2Y=E7YmU6[=e3[=a1ZM`oZM]2Z]e4[^11Zmll
Ym]0ZmllZ]dlYmdiYm`jZ=djZMhlZ]llZN4iY]hiY]l2?:KP00`kYMllY^0m
Yn4oZN<nZ>@iY^4eX]dcXM`dX]dcY=hbXmd`Xm`[c<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<00k<c<`>UYJF2YNGU`03V9RHUiNGUiNG00BGUiL2
V9RH19NGU`:HV9P01YNGUiRHV9NGUi^KVibLW9fMW@:UYJD02Z>SXjNWYjNW
YjVYZJFUYIjNWY^KViZJVYVIVIRHV0:GUiL3V9RH0YNGU`:HV9P2UiNG0iRH
V003UiNGV9RHUiNG012GUiL6UYJF;<c<c003IVIVooooc<c<0?o<c<`ac<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>
c<c<00@XY]PXY=L[YMP]YMT2<:GJ00<^XmPZX]H]YmX00RZVf@03;:KI;ZKJ
<:GJ008bYM/00c>WfS>Wf3>Yf`03<ZSJ00<bYm`aZMdg[>400SBYgP<fZ]d0
<3RZg3^^gCNZeSFZeCJ/fSF[fcFWfCj/gdN]gTJVf56YfERVeUfPcG6UbXj^
aijZ]]gGeokel??hm?_ooo3/nZb]`YBU`G2K^eRN`4jSc4fXedNUfdZYhd>W
hT2[hd6^iSbWgcfVgD:/gT2/gCnYfcjZfd6[gd:]hD6/h3^Yg4:`iD2^hcf[
h3ZYgSZYh3ZYgP8jZN02>JKO0SZWh009>jGO?:KP?JOQ?ZSR?:KR>ZCP=Z?N
=J;M=:7L008dX]d00c:SgLc<c<c<c00Yc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<00k<c<`7UYJF00>EUIFFUYJFUYH029JFUPBGUiL00iJFUYNG
UiNGU`06UiNG00>HV9RGUiNGUiL00iNGU`:HV9P01INGUiRHV9RHV9RHV9VI
V@02Vi^K00RTY:BYZJVYZJVZZZZWYjNMWIfKVi^HV9P2UiNG00BHV9RGUiNH
V9RGUiL2V9RH0YNGU`:HV9P2UiNG0iRHV003UiNGV9RHV9RH012GUiL6UYJF
;<c<c003IVIVooooc<c<0?o<c<`ac<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<0RRTe`03:jGH;:CH;jCI008`
YMX00bjVfRbVfBbVf@02;:KI010]YMT`YMXbYM/cYM/cYmXdZ=/eZmddZ]`a
ZMd`Z=`aZMh`ZMhd[>4aZMd_Ym/cZ=d2=J_M038fZ]dfZ]/i[M`h[]hh/^Dg
/>DaZ]lfZn4m[>4nZMddW]90Y=QB/>A9V/Mc/<n2ZKZIZjg]m_7co_[/n_^Q
/kn6Y[eZX/=U/mXnWlY</^=7Y]i=Y^9EZNM<XN51XMi0Z>DmZnQ3/N`nZn<n
[=loZ]hkZM`nZMln[>4mZn0jZMho[^Dn[N@m[><j[>8iZ^8iZn4gZ>0fYml2
>ZWQ00/kZ^8jZN4jYn0iY]lkYN4lY^8gXMdhX]hiXmlgY=lfX^000SBRg`03
=J?Pc<c<c<c<02W<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<
c16FUYH4UiNG00>FUYJGUiNGUiL00YNGU`03UYJFUiNGUiNG00FGUiL2V9RH
0YNGU`06V9RHUiNGUIFEUiNGVIVIUYJF0YZJVP0=Vi^KZ:RXZJVYZ:RXWIfM
VYZJV9RHVYZJUYJFVIVIUiNGV9RHVIVI00>GUiL019RHV9VIVIRHV9RHV0>G
UiL00iRHV9NGUiNGU`03V9RH3INGU`RFUYH/c<c<00=VIVKoooo<c<`0olc<
c37<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVoooo
c<c<00k<c<`29J7D0RVQe@0>;9oE;Z7G;jCI<JKK:j?G:ZCG:jGH;:KI<:GJ
<ZOL=JOM=ZSN<jOJ=JWL0SJ/gP0V<j_O<JWM<:WN<J[O=:gR<:WN;ZKJ<:SL
<Z[N<Z[L<ZSJ<ZKG?:[K>JSM=JcT<ZgX;ZWU<JWU>JcS>j[Q>JSO?J[R?ZOP
D;3RDZ78I::kPZbhYl?7h_Cf^LgDNj2bLJ[5DZC:AZSG@JoR?jcUAJOTAj7O
0TnSh@07Aj?R@:KT=JGT>ZcX>j[R?:WQ>ZOO008hYMd00cVXgcRWgcNVgP02
=jKN00LfYmlgZ>8hZN<gZ>8dYMlbXmdiZ>000SZYh@03>JSP>:GN=Z?L008h
X]h0232JeS>MfCNQgCRRgSFQgc>OgC:PgC>QgR_<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`03/c<c0FEUID9UYJF0YNGU`03UYJFUiNGUiNG00NG
UiL2UYJF0iNGU`03UYJFUiNGUiNG00VGUiL01iVIVINGUiRHV9ZJVYnOWjNW
Yj6QX@02VIVI0YNGU`>HV9P00iNGUiRHV9RHV003UiNG00>HV9RGUiNGUiL0
39NGU`:FUYH5UiNG0iJFUP:EUID6UYJF;<c<c003IVIVooooc<c<0?o<c<`a
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<
c00>c<c<00DRW]8VX]HYXMHYXMH]X=L00RZMe005<JKL;JGJ;JGJ;:GJ:jCI
008^XmT0136RfS6SfBnSeS2Te`8_Y=T2;JGJ02/]Y]/^Ym`c[>4`ZMh^Ym`_
ZM`c[N0e[n8d[=hhZ=Y3YMI3Y=ThY>8_Y>L[Y>T`Yn/fZ>HjYn0kY=]0Z=e5
Z^17YmY:X]1FY<]ZZl^0/<NM]lR>ZKY^X[YHXl=<ZME4[>4nZ>@jY>8oYnI3
Yn=7Yn58Yn55Z>50ZN8iZ^@fZ^<l[NL00Sb[h`05?JcT>jWT>:KQ=jGP=JKP
00<fYn43=ZOS0SFVhP0:=ZOQ=ZOO>JSP>JSP>JKQ=jCO>:;N=j7M>ZCP>:;N
0SJPgP8eXMl00cBPgS:Ng<c<c00Zc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<00k<c<`7UIFE4IJFUP:GUiL019JFUYNGUiNGUiRHV0FGUiL2UYJF
1INGU`08V9RHUiNGUiNGV9RHVIVIVi^KWIfMVi^K19RHV0BGUiL3V9RH0iNG
U`04V9RHUiNGUiNGV9RH4INGU`>FUYH00iNGUiJFUYJFUP05UYJF;<c<c003
IVIVooooc<c<0?o<c<`ac<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G<c<`00fIVI_ooolc<c00>c<c<00DTX=@WXmLZX]LZX]L_X]T00RbOeP03
<JKL;:CI;JGJ008]Y]/01S2UfbnTfS6RfS2QfC:Ufc>WfP8bYm`01BnWg2jV
fbjVfbfVfbjWg002;JKK02d^Ym``Z]dbZ]hcZmlhZ=Y2XmI3Y=/iYN<bYNP_
YN/bZNdgZNLkZ>4oZ=m2Z]m2Z^53Z>16YM]=YmUJZmQ][=F7ZLamXL5OXL=;
YLY2ZMHlZ]lmYnDmY^LlYNHmYnDoZ>91ZN13Z>0oZ=lhZ]hgZ^0iZ^@iYn8i
Yn@jZ>DiYn@fY>4dYN4eY^800cJWh`0;=JKR=JGT=:CS<j?R<Z?O<Z?M<Z?K
=:?K<j;J=:7L<j3K008eWm/2>:;N00<gXMlfX=hbW]`00c:Ng2_<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0BEUID00iJFUYFEUIFEU@0E
UYJF1iNGU`:FUYH4UiNG0YRHV0:GUiL01YRHV9VIVIZJVY^KViVIVIRHV1:G
UiL2UYJF1YNGUa>FUYH/c<c<00=VIVKoooo<c<`0olc<c37<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`04RBP
eRJRf2ROebZQfC2Sg2jQfRZNebjRfbVPf2VRfBZSfR^TfbjRfbfQfRjOfBfN
eS2SfC6TfP8aY]`01S2UfbfUfRbSfbbSfb^RfRfTg0<^Y]/0:S2UfS6Vfc>V
g3NUfSNVgCBVhS2VhbnWhc>Zi3RYhCVXgcZXgCVVgSRUh3ZTh3bUgd>Vgd^V
gERTf6bLcFJIb4jPb42VcSVXeCRXfSfVh3nWiSJRhcNSi3VUhcfWhCnWgSfW
fCVXeCFXecVXh3NUhSJThcNUi3JThcBRhC>Qh08eXn82=ZCS0SFShP8dX^40
1c>QgS>Qg3>Qg3>Qg3:Pfc>PfcBQg002=Z3L00PfX=hgXMlgXMleWmd`W=X_
VmT_WMX`W]/[c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`4
UIFE0YJFUP04UIFEUYJFUIFEUIFE19JFUP:EUIDAUYJF0YNGU`:FUYH9UiNG
0iRHV0NGUiL2UYJF29NGU`03UYJFUiNGUYJF01NFUYH4UIFE;<c<c003IVIV
ooooc<c<0?o<c<`ac<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`00fIVI_ooolc<c00>c<c<00TSWmDTX=HUW]DXWmL^X]/]X=TXW=DYX=PX
WmL00RRQf008:J;I:Z7I;:3I;9oH;IkH;J3G;Z7G<:?J0S2Uf`0@;jCJ;JCL
;JCL;:?K;JCL;ZKK<:GK;jCJ<:?J<:?I;jCJ;:GL;ZOP;jSO;jOL<JKK0SBX
f`0Y<jOJ;jCJ;j?N;j?P<J?Q=ZCQ?:CQ@JCOBj3IEiSBEIS?@Z7A>:OD=:WE
<jOH>:GN?ZKU=J7Q=Z;S>jCU?JGR?jKP?ZKI>jOE=jOE>ZWQ>:KS=ZCS=ZCQ
=:;Q<Z3M<Z3O<j7N<Z3O<Z3M<j7P=:;O=J?R=J?P=J?R=J?P00@dX]d2=J;M
0SNQg@<fX=h01C:Ng32LfRjLfBnMfS2Nf`0[c<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<00k<c<`4UIFE00>FUYJEUIFEUID02YFEUABFUYH2UiNG
1YJFUPBGUiL2UYJF0YNGU`03UYJFUiNGUiNG00:FUYH8UiNG6YJFUPBEUID/
c<c<00=VIVKoooo<c<`0olc<c37<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`05B:Oeb>Neb>LeBNNf2jRgB^O
fRNKeRNNf2^Rg2ZSg2NRfbVRfbZQfbfQg2nQgBnRfbnPf2nRf36Tfc:Ug36U
gP03<:CM0RjRf`0f;j?L<JCM<ZGL<jCL<ZCJ;JCL9JOQ9jWS;:SL<:KD<ZK?
<jO@<JSC;:KG::ON::SU:jSX;ZSW=:KR>:GN?JGLA:?KBYkLAIkJ>j?H=JWJ
<J_J<:[K<jKM=jGP>J?Q>j;T@:?T@JGS@jKQ?jON?:SI>JOH>ZOP>:GP=j?Q
=jCO=Z;P=J;M=J7O=Z?N<YkL<j3K=:3N=J;M=Z;P=Z?N=Z;P=Z?N0S>Pf`08
=:7L=J;M=Z3L=IoK=9kL<igK=Z3N=9kL0c6Mf`03<IoL<9kM;IgL02_<c<`0
0fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0:EUID00iBDU9FEUIJF
UP03UIFE0YJFUP>EUIDNUYJF1YNGU`:FUYH3UiNG00>FUYJGUiNGUiL02ING
UaRFUYH3UIFE00>FUYJEUIFEUID0;<c<c003IVIVooooc<c<0?o<c<`ac<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>
c<c<018RWmLTWmPTWMHVWML]XM`[WmXWVmHWW]PYX]/XXMXUX=TTWmPXWmTY
X=X^X=`_X]/_X=P`X]P2<:?J00@^X]/]XMX/X=T]XMX2;:3I02h^XMXaX]`d
YMdgY]hfYM`aYMhYYn@[ZN@bZ=XdY=8gY<dfYM0aYmLYYmXWZ>8ZZ^L_ZnLb
Z>DdYMdhXm/jXmXlXmdoY^4kXn0iXmlhYmldZ>4`Yml`Y=daY=dfXmhiX]`k
X]dnX]hlXmhjXm`gY=`fXm`gY=deX]/eX]dgY=dgY=lfXm`gY=liY]l6=J;K
0SBQfP8bWmX2<j3K00HeWm/dW]XbW=XbW=XeWmdcWM/2;i_I00@`W]/aWm`^
W]d]WM`[c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`4UIFE
00>FUYJEUIFEUID01iFEU@RFUYH019FEUIJFUYFEUIFEU@>FUYH00iNGUiJF
UYJFUP02UYJF00>GUiNFUYJFUYH019JFUP>GUiL3UYJF0iNGU`03UYJFUiNG
UiNG00JFUYH2UiNG2YJFUP03UiNGUYJFUYJF00bFUYH2UIFE0YJFUP>EUID0
0iJFUYFEUIFEU@0/c<c<00=VIVKoooo<c<`0olc<c37<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`02B6Nf2>N
fB>KebFKf2ZNfbRLfBBJebNMfRJNfP038ikI014VW=TWWMX[WM//W]X^WmT^
WmL^XMP]X=L/WmP[W]L[WMT/W]X[WMT]Wm/`XM/aX]`dXm/00SFRf`0Z=:?K
<j7N=J;M>J7F>Z3A>:7A=ZCG<JGN:jKR::?O;:CP=JCK>J?G>j3D>YoC=j3I
=:;M<Z[O<ZKO>J3R?9oS>YoU=9oS;j;Q;ZGO<ZCJ=:CF=:;C=:;E<J?I<:7M
<:3P<YoP=J;M=:7I=:7J=Z?K>J?M=j;J=j7K>JCL=Z7I13NRfP06=Z7I=J3H
=J3H<j3I<YoJ=9kJ0c>Mf@04=9kL=IoM<igK<YcJ0RnKf@8^W=/2;9cK:lc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<0YFEU@05U9BDUIFE
UIFEUIFEU9BD00^EUID00iJFUYFEUIFEU@05UIFE5YJFUP03UiNGUYJFUYJF
01BFUYH00iNGUiJFUYJFUP09UYJF0iFEU@>FUYH7UIFE;<c<c003IVIVoooo
c<c<0?o<c<`ac<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`0
0fIVI_ooolc<c00>c<c<00XPVm@RWMHQV]<SV]@UW=HUVM@RVM<VWMLUWMTS
W]L29YkJ0RRNf`04:YkK:igI;IkH;YoG12fPf@04;Z3L;j7M:igI;Z3L0S:S
g@0_<IoJ;ikF<IkI<YoJ=9kJ=ikI>IkF>9gC=YkE=J;K<J?Q;J?S:ikM;YoK
=IkE>YoC?:3B>j3F=j7K<Z?M:ZKL;JCL=ikP>icS>I_T=9gQ<:;Q<:OQ=:OM
=JOI=JGE<ZCF<:?J<:;N<J3U<j3S=Z?N=:7I=J;J=Z?K=j7K=9oG<igG<YoG
=9oG<YoG<j3H00@dXMT02SBQfS:OfS6NfC6KebnIeC2JeS:Lf3BNg3JPgS6K
f@8bW=X01BnKfBfIfBbHf2bJfBfKfP0[c<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<00k<c<`01IBDU9FEUIBDU9BDU9FEU@02U9BD3iFEU@:FUYH0
0iFEUIJFUYJFUP02UYJF0YFEU@VFUYH2UIFE3YJFUP:GUiL<UYJF00>EUIFF
UYJFUYH029JFUPFEUID2UYJF29FEUBc<c<`00fIVI_ooolc<c03oc<c<<Lc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0
3/c<c0039IkE8icC8i[B008TVm<01RFLe2JMeBROeb>Je2BMe2NNf0<YX=X0
1BROfBVMf2RJeRbMebnPg002<:7M0RjOf`04;j3L;IkJ;IkJ;YoK0RnPg005
;YoI;I_H:I[D;YoI;IkF008^WMD022nNeS2NfC:PgC:RhCBRhCJRh3RRgSNP
fP8dWMH02SNQfcRVhCNXhSFSgSFOgCJNgCNPhCFQgc6RgRjQfP8_X=P0232R
f36RfS:SgC:SgCBRhCBRgcBQg3>Pf@8bWmP01C:OfS:Of36NfBnMf36Nf@03
<IoJ00H^Wm/]W]X[WMT[W=PbW]`cWM/2<YcJ0c>Mf`06<YcJ:i?B;iOF<i_J
<YcJ<9[H0RnIe`03<I_Ic<c<c<c<02W<c<`00fIVI_ooolc<c004c<c<00=V
IVKoooo<c<`03/c<c003UIFEU9BDU9BD00:DU9@3UIFE00>DU9BEUIFEUID0
1iFEU@>FUYH2UIFE00BFUYJEUIFEUIFEUID2UYJF2IFEU@JFUYH2UIFE00>F
UYJGUiNGUiL05IJFUP>EUID3UYJF19FEU@:FUYH2UIFE0iJFUP03UIFEU9BD
UIFE00JEUID/c<c<00=VIVKoooo<c<`0olc<c37<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<c<`012FMdRBLdBBL
dBBLd@8UWM801RJMeBNNeR>JdR>JdRBKdbFLe08VWML01bNNf2VMf2NIeBZK
ebfNfRjOfbbMf@02:icH0RbMf@03;IkJ;YoK;YoK00<^Wm/02bfPfBbPfBVQ
eR^Of2bOf2fNfS2Nfc:Ng3>OgCBNg3FOg@02=j7O00LfX=`cX=/cX=TcX=Th
X]hgXMdfX=`00S>Pf`06<Z3K<IoJ;j3J;I_F;YcG<9kI0S6OfP07<IkI<9gH
;icG<YoH<IkG<9gH<IkI008bWmX01c:Pfc6OfS6Og36Og2fNfRbMfB^KfP02
:I_I00<ZV]T`W=XaVmT01C6Kf@03<9[H<9SG<IWH008bV]T0136If32HebnG
eRjFeB_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c004UIFE
U9BDU9BDU9BD19FEU@>DU9@5UIFE00>DU9BEUIFEUID04iFEUA:FUYH3UIFE
0YJFUP>EUID019JFUYFEUIFEUIFEU@JFUYHEUIFE00>DU9C<c<c<c<`0:/c<
c003IVIVooooc<c<0?o<c<`ac<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0G<c<`00fIVI_ooolc<c00>c<c<0RFJd08UVM829Y[C0RNKe00::YkI
:9cG9i_F9IWD99SC9IWD9Y[E9i_F:I_G:igI0RbNfP03:igI:YcH:YcH008[
WMT00bbNfRfOfbbNfP02:igI00X]Wm/_X]/[WmP/XML]X=T^XMX_X=``W]/a
WM/`W=X2<igK00/bW]`cWmddXM`dXM`aW]L_W=DcWMTeWm/fX=`cX=/bWmX0
0S6Nf@0?<IoJ<9gH<IkI<YoJ<j3K<YoJ<igI<YcH<I_G<YoJ<9kI;igH;YcG
<9gH<YoJ008bW]`013>QgS6Og2jLfBZKe`8YVMP012ZJfB^KfRnKfc6Jf`D`
VMX00bnHfC>Jg3:If`02<9OI00@aV=X`UmT_U]P]U=H[c<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<00k<c<`6U9BD1IFEU@BDU9@@UIFE00BFUYJE
UIFEUIFEUID2UYJF0iFEU@JFUYH3UIFE19JFUP:EUID00iJFUYFEUIFEU@03
UYJF0iFEU@03UYJFUIFEUIFE00:EUID5UYJF5IFEU@03U9BDc<c<c<c<02[<
c<`00fIVI_ooolc<c03oc<c<<Lc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVKoooo<c<`03/c<c00B8iK=8iS>9ISA8iO@9ISA9IWB
9YWB99SA:YcH:9cG:9[F9Y[E9iWE9i_F:I_G:YcH:I_G:YcH0R^Mf@8YVmL0
1RZLf2bNfRZLf2^MfBbNfR^Mf@8XV]H032ZLf2bNfR^NebbOeRfPfBnPfS6O
g32Nfc2LfRnKfCBNg36Mf`8`W=X01S6NfC6OfS6Pf36Nec:Lf3BLf@8dW]X2
<YoJ0S6Nf@03<j3K=IoK=IoK00<fW]/013NMfcJNfc:OfS2Nf@8_WMP2<9gH
00H_VmT^V]PbX=d`W]/^W=T]VmP2;9[I00@]VmX^W=/`W=`aV]/5<9WJ00<_
V=T`UmT_U]P00bnFf003<9OI<ISJ<ISJ02_<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`03/c<c0RDU9@3UIFE0YBDU1JEUID2UYJF0iFEU@03UYJF
UIFEUIFE00:EUID2UYJF0iFEU@BFUYH2UIFE2IJFUPNEUID00iJFUYFEUIFE
U@0EUIFE;<c<c003IVIVooooc<c<0?o<c<`ac<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<01<SU<hTUm0VUm4S
U/lUU]0VVM8WV=@TU]8UU]8TU]8WV=@WVMDZV]T[WM/]WM`^W]dVUm<XVMDY
V]H00bRIe@0B:Y_G;9gI:I[F:icH;IkJ;9gI:Y_G:9WE:I[F:icH:Y_E:icF
;IkH;YoI<IoL<9kK<9cJ;i_I0c6Mf`09<9kK;igH;IkH;YoI<IoJ<YcJ<Y[I
<I_I<igK008eWmd01CBNg36KfCFOgCFMg3BLf`02=9[J00/eVm/iW=dhW]h_
W=L^W=L`WMPaW]TaWM/_VmT]VML[UmD012jJf0@^V]X00c6Jfc2IfRnHf@03
;iSI00H^UmP]U]L]U=H^UML_U]P^UML2;ICF00<`UmTcV]c<c<`0:/c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<39BDU0BEUID2U9BD00BE
UIFDU9BDU9BDU9@7UIFE00>DU9BEUIFEUID019FEU@03UYJFUIFEUIFE00RE
UID019JFUYFEUIFEUIFEU@BFUYH00iFEUIJFUYJFUP04UIFE0YJFUPNEUID0
0iBDU9FEUIFEU@0=UIFE0iBDU004UIFEU9BDU9BDU9BD0YFEUBc<c<`00fIV
I_ooolc<c03oc<c<<Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVKoooo<c<`03/c<c0039I?>:9KA:9KA008VU<l01bZHdbZHeBNE
dRJDdBNEdRVGe2ZHe@03:YSG00<YUmHVUm<XVMD00RVJeP8XVMD01RZKebbM
fBNHe2VJeR^Lf2bMf@8[W=P022bMfBfNfRZKeBZKeBfKeRjLebnMfRjLf@8_
VmT072fIebjLfC6Og2nPg2jOfBfNf2bMebjLec>Mfc2Jf2nIec6KfCBNg3FO
gC>Mfc6KfCFMg3BLfc>IfC:Hf3BGf3JIfSVKg3VLgBjHe2bJeBjKeRnLe`8`
W=X03bjJf2bHeRZFe2^GeBbHeS2Jf32IfS2GfBnFf2jEebnHfBjGf2fFebbE
eRfFe`02;9GF00T[U=D]U=H_U]P`UmT^UML[T]@ZTM<]U=H_U]P0:lc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<4YBDU0:EUID2U9BD0YFE
U@03U9BDUIFEUIFE00nEUID2UYJF19FEU@04UYJFUIFEUIFEUIFE0iJFUP03
UIFEUYJFUIFE00BEUID2UYJF29FEU@:DU9@5UIFE00>DU9BEUIFEUID01iBD
U0:EUID4U9BD00>EUIG<c<c<c<`0:/c<c003IVIVooooc<c<0?o<c<`ac<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>
c<c<00PUT/dXUM0XUM0TTL`UTLlYUM<ZU]@WTm42:IGC0RVEe@06:9CD9i?C
9Y;B9I7A:YSE:I[F0R^Lf004:Y_G:I[F:icH;9gI0bVJeP8ZVmL00b^Lf2bM
fBfNfP02;I_F0RfJe@8]VML4;I_J00P]VmP/WMT]W]P/WmPZWMHZVmD_VmT^
V]P2;IWG00@_VmT`W=X`W=X_VmT2<igK00XcVmXcVMTeV=TeV=TgVMXfVMX_
VML]VML/V=H]VML3;Y[H00L]VML/U]@]UmD^V=H`V=L`UmT`U]P00RnEe`03
;iKI;IKH;ICG008]U=L00bbCeR^BeBZAe003;iCH00D^TmL/TMD[T=@[T=@/
TMD0:lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<00>CTi>D
U9BDU9@00Y>CT`ZDU9@00i>CTiBDU9FEU@0VUIFE0YJFUPjEUID00iBDU9FE
UIFEU@03UIFE0YBDU003UIFEU9BDU9BD00fDU9@/c<c<00=VIVKoooo<c<`0
olc<c37<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
ooooc<c<00k<c<`022F?bbRBcRNAcB>=bBB>c2VCdBZDdRNAc`8XT]0052RA
dRVBdbZCe2^DeBbEeRfFebVGe2RIeBbJebZKebZHeBNHe2ZHeBVJeRfKf2VJ
eRVGe2JGdbVGe2VJeP8/V]L01RnLebjKeRfJeB^Hdb^GeBbHeP8/V]T01C6O
gRfKfRNHe2JGdbRJeP02:ikG01@ZVmD/V]L/V]L]VML/V]L/V=H/V]L^V]P`
W=X_VmTaVmTbW=XcVmXcVMTdUmPbUMH`U]HdW=/_VmT^V=H2:iOE01D/V=H]
VML]VML^V=H_VML`V=LaUmLaUmTcU]TbUMPaU=L`UmX_U]T^UMP]U=L^UMP]
U=L/TmH/TMD_U=P^TmL012bAe@03:i3D:XoCc<c<02[<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`03/c<c003Ti>CU9BDTi>C00:CTi<=U9BD0YFE
U@>DU9@3UIFE0iBDU0JEUID2U9BD0iFEU@04UYJFUIFEU9BDU9BD5iFEU@:D
U9@:UIFE00>DU9BEUIFEUID03YBDU2c<c<`00fIVI_ooolc<c03oc<c<<Lc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`0
3/c<c00::i?@:I7>9ho<:93=:Y;?:i?@:I7@9ho>:i?B:Y;A0RR@c`0D:I3B
:Y7C:i;D:Y?D:9CB:YSC;9WD:YSC:YOB:iWD;Y_F;9[E;icG;I_F;I[E;9[E
;Y_F;9[E;I[E;9WD0S2JeP8_VML2;IWI00XZV=LYUmH]VmX]VmXZV]TXVMDW
V=@XVMDZVmD/WML2:Y_G00T]VmP[W=P/V]LYV]HZV=DYUm@]VmP]VML^V=H0
0RnGeP0@<IOG<YSH<iWI<ISJ;iSI;iKH;IKG;YOH;iSI<9WJ;iSI;iKH<9OI
<YSJ<IOI<ICE0S6Ce004<I;F;I;F;97E:i3D0bZ?d`03:HkB:XgA;Y7E00@^
TMD2;i;F00<^TMG<c<c<c<`0:Lc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c00>c<c<0YBDU0:CTi<3U9BD00>CTi>DU9BDU9@00Y>CT`JDU9@00iFE
UIBDU9BDU00AUIFE0YBDU0>EUID3U9BD29FEU@:DU9@;UIFE00>DU9BEUIFE
UID01YFEU@ZDU9@2Ti>C29BDU2c<c<`00fIVI_ooolc<c03oc<c<<Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<
c00::I7>:93=9ho<:93=:Y;?:i?@:Y;A:I7@;9CC:i?B0RVAd00I:I3B:Y7C
:i;D:i?B9i7=9iC?:YC@9Y?>:9;>:9G@;9KB:IKA;9KB:IKA:YC@:IKA;YSD
;I[E;YSD;9KB;IGB;9CA;IGD;IOE;iSI008^V]X01BfKfR^If2^If2VIf2RH
e`029iSD00<[VM@ZVmDZVmL00bZKe`<YV]H01BRIeBVGe2VGe2ZFe2fGe@02
;iOF00L`U]H_UMDbV=XaUmT`U]P^UML_U]P00bjGf00<;9?E;ICF;iGG<ICG
<I?D<9;C<I3B;i7B<ICG;Y?G;Y7E;97E0bjAe@8]T=@01BjAeBn@eBjAeBj?
e2f>d`02;XoD:lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<
00BDU9BCTi>CTi>CTi<<U9BD00>CTi>DU9BDU9@02IBDU0>EUID4U9BD29FE
U@>DU9@9UIFE19BDU0BEUID01IBDU9FEUIFEUIFEUIBDU004UIFE69BDU2c<
c<`00fIVI_ooolc<c03oc<c<<Lc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVKoooo<c<`03/c<c0069Xg89hk99hk9:I3;:Y7<:i;=
0RbBd00M;I?A;9;@:i7?:Y3>:Y3@:i7A;9;B:i?B:I7>:YC@:i?@:9;>:93=
:I??;9CA:YC@;IGB:YC@:Y;?:YC@;YKC;iWE;iOD;IGB;YKE;IGD;9CC;9KD
;IKG00</V=P2:IOF00HZV=LYUmHYUm@YUm@ZU]@ZV=D2:iWH1BZHe`0>:iWH
:9KE:9KE:iOG;iSI<YWK<ISJ;iKH;I?E<iKJ<YGI<9?G;Y?G;YCF0RfDeP07
;9?E:i;D;9?E;YCF<ICG<I?D;i7B008`Sm40132AeBjAe2j?dbf@d`<^Sm<2
;HkB00@_T=@aT=@^Sm<^SM42;Hc@00<^SM7<c<c<c<`0:Lc<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c00>c<c<19>CTa2DU9@00i>CTiBDU9BDU006
U9BD0YFEU@JDU9@3UIFE29BDU0:EUID5U9BD00BEUIFDU9BDU9BDU9@4UIFE
00>DU9BEUIFEUID06YBDU0BCTi</c<c<00=VIVKoooo<c<`0olc<c37<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVooooc<c<00k<
c<`022B;aRJ=b2N>bBR?bRV@bbZAc2^AcbbBd0@[TLl2:i7A00P/T]8]Tm</
T]0]UM8/U=4ZT/lYTLh[Tm02;9CA00<^U]<]UM8]UM800bbDd@8[Tm001BnE
eBjDe2fCdbbDdbbCe@02:iCE00LYUMDXU=@XU]DYUmH[UmLZU]@[UM<00RbF
e08/V=P00b^GebZFeRZFeP02:YKF01<[UmLZU]HZU]H/UMH^UmPaV=X`UmT^
U=H/T]@aT]L`TMH_T=D^TMD^TM@/T]@[TM<YT=8[T]@/TmD00S6De`05<YCE
<9;C<I3B<I3B;hkB00</SM4032n>dRf>dRj=dBf<d2j=dC2?dc:?e2n>dRj;
d2b;cbj;d2j=dB_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<
c0FCTi<[U9BD0YFEU@VDU9@3UIFE4iBDU0>CTi<2U9BD0i>CT`>DU9@4Ti>C
;<c<c003IVIVooooc<c<0?o<c<`ac<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0G<c<`00fIVI_ooolc<c00>c<c<00<VR/DWRlHXS<L00RV=b005
:Xk9:ho;;93<:Hg9:ho;008/T<`01Bb@cRfAcbjBd2jDdRbBd002;I?A00@[
TLlZT<h/T]0]Tm42;9;@0RjDdP06;I?A:Y3>:8k<:Ho=:Y3>;I3A0R^Ad@0:
:Y;A;9?E;9GF;9GG:YKG9i?D:IGF:YKF;IKG;9KD0RbDd`05;IGD<9KH;iGG
;ICF;9?E00<ZTm@01B^DeBbEeR^DeB^Be2bBe002;I?E010]T=<[S]4aSmDa
S]@`S]@^Sm@^TMD/TMD/T]@[TM<[T]@/TmD`TmHaU=LaTm@`T]<2<I3B00L_
S]8^SM4^SM4_S]8aS]<_S]8_S=400Rj;d007;hcA<HcB;hcA;XW?;H[?;XW?
;hcA02_<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0NCTi<0
0iBDU9>CTi>CT`0CU9BD0Y>CTa6DU9@00iFEUIBDU9BDU00<U9BD00>CTi>D
U9BDU9@03iBDU0:CTi<3U9BD19>CT`03U9BDTi>CTi>C00>CTi</c<c<00=V
IVKoooo<c<`0olc<c37<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVooooc<c<00k<c<`39X[500<WRlHXS<LXS<L00RR<b00B9h_7
:Hg9:Xk::ho;:Xk<:ho=;I7?;Y;@:i7?;I?A;YCB;9;@:i7?;9;@;I?A;9;@
:i7?;9;@0RfCd@08:i7?:Y3>:i7?;I?A;Y7B;I3A:i7A;9;B0RbCe@07:Y?E
:I;D9Y;C:9CE:iCE;ICF;9CC008]Tm<01BnBdc6BeS6BeRnBeBjAe004;9;D
00<^U=H]TmD/T]@00Rf@d`03;8oB;HkB;XoC008cS]D02S:?eC6?eC2AeRnB
eRfCeBbBe2V@dR^AdbbBe2f@d`8]Sm000bn>d32=d2j;d002;X_@0bn<d@03
;H[?:hS=;XW?00@^RLl3;HS>:lc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c00>c<c<3Y>CTd:DU9@@Ti>C;<c<c003IVIVooooc<c<0?o<c<`ac<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c00>
c<c<00@VRl<UR/8TRL4UR/839h_60RF9a003:8c7:Xk::Xk:008XS<P02bZ>
bR^?bbZ>c2fAcbnCdBjBd2fAcbjBd2fAcbb@cRjBd002;I7?00<^T]0_Tm4`
U=800RnCd@8^TM82;I?C00H/TmD[T]@WT=8VSm4WT=8XTM<2:i;D00H/T]8^
TM8^TM8`T]<`Sm<aS]<2<I3D0Rn@e08^TM@042f@dbnBeC2CeS2AeBj?dbf>
dS2?dc:AeCF=eCB<eS:=e3:?eBn@eBjAeB^@e2Z?d`<ZT=801R^>dBZ<cBZ<
cBf<cRj;cRf:c@8^R/d2;h_>00D^R/d/R</ZQ/T`RLd^Ql/00Rf6bP8^Ql/0
0bb5bB^4b<c<c00Zc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<
c<`019>CTi:BTY:BTY:BTP>CTi<2TY:B29>CTaFDU9@3Ti>C8YBDU0bCTi<0
0i:BTY>CTi>CT`04Ti>C0Y:BTRc<c<`00fIVI_ooolc<c03oc<c<<Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<c<`03/c<
c00B9H[28hS08XNo8hS09X[59h_69X[598S39HW4:8c7:Xk::Hg99h_79X[6
9h_7:Hg99HW7:8c:0RZ>c0<YSL/03BN;bBjBd2^?cBR<bRZ>c2jBd32DdRfA
cbV=bbV<cBZ=cRZ@d2fCd`02;YGG00@[U=HYT]@VSm4WT=82:I3B0Rb?d006
;Y3A<I3B;hcA<HcB<HkC<XoD0S:Ae@8_T=@022V:cRb=dBn@e2n@e2j=dBf<
d2n>dS:?e08cRmD02S>;dc2=dbn=dbb?dbZ=dBJ;cb^AdbZ@dRV?dBR>d08Y
Rl`00bb;cBf<cS6=d002<8c?0S6=d007<8c?;X[=;8S;<8W=;HK::X?7:hC8
008]Q/X00bZ3abN0a<c<c00Zc<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<00k<c<`4TY:B0i>CT`:BTY87Ti>C00>BTY:CTi>CTi<01I>CT`04U9BD
Ti>CTi>CTi>C0iBDU0>CTi<6U9BD0Y>CT`JDU9@00i>CTiBDU9BDU005U9BD
0Y>CT`:DU9@2Ti>C29BDU0:CTi<2U9BD1Y>CT`03U9BDTi>CTi>C00:DU9@5
Ti>C0Y:BTP:CTi<2TY:B;<c<c003IVIVooooc<c<0?o<c<`ac<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_ooolc<c02Ic<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<09[<c<`00fIVI_ooolc<c03oc<c<
<Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVKoooo<
c<`0VLc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c02Jc<c<00=VIVKo
ooo<c<`0olc<c37<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<
c003IVIVooooc<c<09W<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
V/c<c003IVIVooooc<c<0?o<c<`ac<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0G<c<`00fIVI_ooooooo`2Ioooo00?<c<coooo<c<`01<c<c003
IVIVoooooooo09[oool00lc<c?ooolc<c03oc<c<<Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P5c<c<WFIVIPK<c<bNIVIVolc<c3?<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000B8`;S8
h=R8`;R8`;PF00200`01P0800X001002P@03P@03P@03P@<0184200F100@0
1H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<1
2h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8D
Q`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT0
10<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<
12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?
1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHb
T@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`03
1cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8
@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI
2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`0
10YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]G
WP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aN
X@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=
I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]
YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mc
Z0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`4
47f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^
00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::
/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<C
T;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI
]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh
00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/3
5ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn
0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P4002000>KYo4c@jDc@jD02C=3Y@H0080300600P02P004
00:100>100>100>10`04P@801H401005PP06PP06PP06PP801h800`47PP48
PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn5
0`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<4
7h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=
1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086
;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7
=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9
@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:
BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<
Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`
Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?
MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd3
4H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<B
Qk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d
0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL
]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d2
5jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G
/klf6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008001i^WlOoo
ohij]ZJKa;>YdZRMb;>YdP02YY_400Fl^=g^k_CZjO7ooolc@jD01@00P0<0
0H0200:000@00X400h400h400h4300B10P05P@0400F200J200J200J20P07
PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f4
0`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8F
Q`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<3
7HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd3
1BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6
;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHc
TP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9
BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd2
2e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;
FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<
H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]
47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<A
QJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d
4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLD
VkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[
_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_`8H]<0P00000QRd`10000026;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^080080019^WlOooofaJYJnUbP:l^=d02_omok>Yd_oo
oooookbhgIN:_:RMb>KVk?oooc=3Y@@0080300600P02P00400:100>100>1
00>10`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R3
0`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH3
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8
h=Q8T8Q8T8P034R@R0030000b>3HB92800e8T8P0100001Rd`1Rd`<SPf0i8
T8P00`0001Rd`1Rd`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00
P00;VjOaooooZ9g8oooo/jWBH4bJSWZfN6F^Z9g8oooooogo00?oool00c=3
Y@00P000P00300200`01P0800X001002P@03P@03P@03P@<0184200F100@0
1H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<1
2h@12h@00`4<Q0<13H@30@j50`8?Q@8248D3oooo0P8AQP<24XH20Q>600@2
4hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV9
0aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`0
10@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZ
SPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`Ha
T@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7
=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0
UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6
V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`4
2U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN
00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aM
X@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=
Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/
YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X
00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/3
47b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^
0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4B
R[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008C
Sk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH
]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh
0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/3
5ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;
R<2h00=8T8P00038h=P03HS0^005B92800006;C06;C0b>3H00f8`;P014R@
R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000jK
Yo7ooooooooKg>aPC9ZCQKZcZM:l^=ePC9ZISkjVVlC8`moooolc@jD60020
0oooo`800X000`02POooooooo`02oooo0P04P@0300F1oooo00F200<01X84
oooo00<1288128?oool00oooo`<12X<01_ooo`4;Q04;Q04<Q?ooo`4<Q081
3H@01?ooo`4>QOooo`4>Q@823hD01?ooo`8@QOooo`8@Q@824HH00oooo`8A
QP8BQP020Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<G
R0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3
122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>
1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i00
10H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987
=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`Pl
U@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9
A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX3
2TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]D
W@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj02
35bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP03
3F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eX
Y@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`04
3g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX3
47RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]
00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk03
4XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8B
S[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D
]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8D
WKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX3
5JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm
0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl2
6;C000C8h=R8`;R8`;R8`;P6000018S0^003B9280000b>3H00:8`;P90000
0XS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3002000jKYo7ooonl^=fISkkooooF
dMgKg>cco_nVVlC^k_B5M[2CQK[ooolc@jD4002000Ooool00H000H000H3o
ool00X3oool00`03P@06oooo00B100B100F1oooo00F20P06PP08oooo00N2
00N20@N2oooo0@R2oooo0@R30`49P`04oooo0@Z30@Z3oooo0P4;Q0030@b4
oooo0@b400813H@01?ooo`4>QOooo`4>Q@823hD00oooo`8@QOooo`03oooo
0P8AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN8
0aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<4
88/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh5
9hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T004
1RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLe
TPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE
0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4
V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:
C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM
2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<
G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=
HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU
0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?
L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@
N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d0
0a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<B
R;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>
/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd
0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM
]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<E
Y;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d3
5jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H
]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P00038h=P00XS0^0030000
R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000C8h=R8`;R8`;R8
`;P2000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0`00P00?VjOaooooVHnnUhZle=?XkjbcogIkkYn[
FeRUYY_4UYoBH4bJ_;SMoooo<d>U00<008001oooo`01P001P001P?ooo`02
P?ooo`0300>100Koool01840187oool01H7oool200J200Soool01h801h81
1h;oool128;oool128<30@V300Woool12X?oool12h?oool12hCoool138Co
ool00P4=Q004oooo0@j5oooo0@j50P8?Q@04oooo0Q25oooo0Q25108AQP<2
4XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<H
R0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;
0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DX
SP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A
1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP02
1cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8
?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4
V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK
0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN
00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aL
X@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=
HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>
JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?
LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[
0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61
[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`
00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb
4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<D
U[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh
5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj
0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G
[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSP
f8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P0
1@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h
0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000ZKYo7ooonGR[ajK:ZcanRYKZ38`mnCQKYKAY>ISkh2N6F^
00A29hF_YL[ooolc@jD400200`01P003oooo00:000:100Coool200B100?o
ool01H7oool00`06PPCoool00`48PP48P`48P`030@V300Woool12X?oool1
2h?oool12hCoool138Coool00P4=Q004oooo0@j5oooo0@j50P8?Q@03oooo
0Q25oooo00?oool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ7
00@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<M
RP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<5
9Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]
T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B
0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@3
1cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G
0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9
VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;
DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]I
W`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaP
XPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY003
3FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW
0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`me
Z@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@
Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65
[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8B
SK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@C
T[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK
]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ
^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m
5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o
00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h
00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0
^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2002000>KYo7oooooool00_ooo`0:ojf`ogIknLgD
oNg^ooooYY_4QGJ`_;SMoooo<d>U1@00P0<00H000oooo`02P002P@0300>1
00?oool0187oool00P05P@0400F2oooo00J200J20P07PP030@N2oooo0@R2
008128<3oooo0P4:P`07oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?oo
o`4>QOooooooo`823hD01_ooo`8@QOooo`8@Q@8AQ_ooo`824HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028
`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00B8`;P200001HS0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008002Z6/
l_W=e>8V??Be_n8V??A]OOcSjOoooog]k_n]/0;oool00c=3Y@00P000P004
00200`01P003oooo00:000:100?oool200B100Goool01H401H401H;oool0
0P06PP?oool20@R200<128?oool12H<00P49P`812X<01?ooo`4;P`4;Q?oo
o`8138@01oooo`4=Q04=Q?ooo`4>QOooo`4>Q@02oooo00<23hD248D248D0
1?ooo`040Q660Q:60Q:60Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:
0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DV
S@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@
0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i82
1SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7
>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL2
24>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ
0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]B
W@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO
0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R
362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=
IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL3
3VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o
[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_
1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=
/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B
]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g
59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i
0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdF
ZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl0
0aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P0
0`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2h
R<2h00>8`;P4000018S0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_ARK_om
oon]/?cSjOoooc=3Y@0700200`01P003oooo00:000:100<00h4300B10P05
P@0400F200J200J200J20P07PP050@N20@R20@R2oooo0@R300<12H<30@Z3
00<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0
108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP3
6HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@S
S00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP03
1BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<943
1S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC
0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2
242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V003
2DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?
W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;
EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ
35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S
0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH3
3VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?
LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1k
Z`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<A
PZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::
/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk80
0Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD4
59Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PE
W[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW
^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^
_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h
00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2h
R<2hB9280000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08000i^WlOK8c>8V?002ojf`00OO92koY9kf_<Go[K3^Nhcooolc@jD02000
P0<00H000oooo`02P002P@0300>10`04P@801H401005PP06PP06PP06PP80
1h801@47PP48PP48P_ooo`48P`030@V300Coool12X<12X<12h<20@^40`4<
Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<2
5HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT3
0ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=
0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl4
1Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B
1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD
00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8
@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT3
2DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YA
W@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`03
2eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aO
XPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eU
Y0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW
3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@04
3gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@
OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lA
Q:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba
00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<C
T[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ
]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TE
X;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_004
5Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n
5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SP
f002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf003R<2h0P0000B8`;P2
00000XS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0
^8S0^08008000i^WlOW=e?N9U`02oooo00Oo[K3Q5SCoMW_oY9kR9ScoRGlc
@jD02000P0<00H000oooo`02P002P@0300>10`04P@801H401005PP06PP06
PP06PP801h801047PP48PP48PP48P`Coool30@Z300<12h<12h@12h@00`4<
Q0813H@01?ooo`4>Q@4>Q@4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL2
58L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV9
00@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@T
S0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZ
S`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86
<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<0
0`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04
242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6
V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L
00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;
Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<
GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<3
3FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>
KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?
LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/
111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63
[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4B
R[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<3
4i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<D
VKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO
^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk
0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN_
_P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h
00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08001i^WlOoooo>P[_ARK_ooooN9UoW=e002oooo00?cX:kooolc@jD02000
P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J200J200J2
0P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@3
0@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF7
0P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<L
RP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@85
9Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/
S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHc
TPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU003
1cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G
0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8
V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:
DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]H
W`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<
H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=
IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^
Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010md
Z@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]
47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_
00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@04
4Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c
4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LD
VkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i
00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[
_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa
_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P0
3HS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3002000^KYo7oooooRGooooocX:ka
Tj7ooooooOocX:kono`c@jD02000P0<00H0200:000@00X400h400h400h43
00B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V3
0`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR003
0aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A
1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC
0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH3
23nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9
AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>
V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aM
X@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ80
0PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD4
3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?
LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1j
Z`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61
[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@B
RK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb
4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D3
59Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh
5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<0?b>3H00<0
0038h=S8h=P03LSPf00300006;C06;C000o8h=P00`0001Rd`1Rd`002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1000P0>KYo401_oooo>P[_Be_oJl
aO_IfS=3Y@T0080300600P02P00400:100>100>100>10`04P@801H401005
PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;
Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@04
0aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`4
98d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5
:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A
00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7
>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9
AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN
2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ
0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X
3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@
OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh0
0a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@
/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf
0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<F
ZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P10000000018S0
^<SPf8S0^8S0^1H0080300600P02P00400:100>100>100>10`04P@801H40
1005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;
P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>7
0QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<I
R@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@4
98`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5
:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I42
1S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC
00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H0
10Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9
AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@
W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP03
2eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ43
35jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S
0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H2
3VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ003
3g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l
[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<A
Pjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa
4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc
0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H3
59Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<E
WkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX
^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G
[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P100000000
0hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8h=R8`;P0
ohS0^?n8`;QmR<2h0DR@R04000000003R<2hb>3Hb>3H0?o8h=Sob>3HOLSP
f058T8P10000003oR<2hohS0^868`;P100000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l7?ol?3`00?ofMWIooooooooool03?ooool0
0?ool?3`ooo`l?1coo3`l004omWIfOooooooooooonGUi@?ooooo00GoiNGU
ooooooooooooooooonGUi@03ooooo`00ooo`l?3ooo3`l7?ol?3`00gofMWI
oooooooJf][oSHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgo
iNGU00;ooooo003ooo3`l?ool?3`Loo`l?003_oIfMWooooooooooooJf][o
SHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU0Oooool0
0?ool?3`ooo`l?1coo3`l00=omWIfOoooooooooooooooooJf][oSHf=onGU
iOoooooof][Johf=SOoUiNGoooooom[JfP02ooooo`00ooo`l?3ooo3`l7?o
l?3`00?ofMWIooooooooool00_ooool01ooJf][oSHf=onGUiOoooooof][J
ohf=SOoUiND00oooool00?ool?3`ooo`l?1coo3`l003omWIfOoooooooooo
00?ooooo00Oof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003o
oo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`04ooooo`07om[Jf_n=SHgo
iNGUoooooooLg=coSHf=onGUi@01ooooo`00ooo`l?3ooo3`l7?ol?3`00?o
fMWIooooooooool01Oooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo
003ooo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`06ooooo`03omcLg?n=
SHgoiNGU00?ooooo003ooo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`07
ooooo`03omcLg?n=SHgoiNGU00;ooooo003ooo3`l?ool?3`Loo`l?000ooI
fMWoooooooooo`08ooooo`03omcLg?n=SHgoiNGU007ooooo003ooo3`l?oo
l?3`Loo`l?000ooIfMWoooooooooo`09ooooo`7og=cL0Oooool1ooooo`00
ooo`l?3ooo3`l7?ol?3`00?ofMWIooooooooool03?ooool00?ool?3`ooo`
l?1coo3`l0oofMWI003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooo
oon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?oo
k^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^
k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003o
onk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;o
k^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool0
0?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_oo
k^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003o
onKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;o
oooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^ko
onk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00
oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2
ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^
ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0
0?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooooooo
P_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^
k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^
003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooo
oh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooo
oon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?oo
k^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^
k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003o
onk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;o
k^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h000Goi^KV
00Kod=3@ojb/[?n0P83oH61Podm?Com9BDUcodQ8B006odU9BOm?CdooH61P
oh20P?n/[:cod=3@1OoVi^H01_o@d=3o[:b/oh20P?mPH63oCdm?odU9BGGo
B4Q800KoBDU9odm?ComPH63oP820ojb/[?o@d=3oonKViWOoi^KV0005onk^
kP04olC4a?n<S8coVIVIom[JfWOooooo00Cof][JoiVIVOn<S8coa<C41Oo^
k^h01?o4a<CoS8b<oiVIVOoJf]Yiooooo`04om[Jf_nIVIWoS8b<olC4a?oo
k^k^Moo^k^h000Gooooo00?o_knoojFUYOodm?@0NOooool00oodm?CoYJFU
okno_`05ooooo`03okno_onUYJGom?Cd07_ooooo00?om?CdojFUYOno_kl0
oooooomgooooo`001Oo^k^h00onXZ:Sob/[:oo?cl`1hooooo`04ookno_ob
l_;obLW9ojRXZ0Gok^k^00?oZ:RXol[:b_oclo<0N_ooool01?ono_kol_;b
olW9bOnXZ:Soonk^kWOok^k^0005onKViP1GoijNW_oQhN7ok>c/oif@@_nW
Ve?o[jI[ok6[NonZZ8;oXJ21oifLP?nNVgcoW9IdoiR@JOnGRfGoUheYoiJ=
L?nARgGoSHUmoiB:O_nIPW3oX8A_oj66LonKQ7CoUhAfoiR7OOnIRh;oVXf4
oiV=OonJRgKoW8UYoj:7G?nYQTko/8E1okN3=onhPc?o]H4hok20>?n]PCSo
[8DhojZ9>?nZS3Ko[I0dok2D<on]TBgoZI0[ojJ>;?nMRRkoV8`hoj6KConU
Y67oXZ1Foj^KA_n[TcWo]i]7ol:QD_nkUDco]Xi8ojn3@_nJLBooXGXgoj9o
>onSPD7o/9=AolFWJOnkWV;oZi5FojnGIonVSW;oVXEbogMUCon9NF3oUhU_
oj2GN_n[YHGoZjR7ojRUP_n]ZXOoZZJ1ok2VPonfYXGo^jB5ol>TR?nkW83o
_jF:okfUROnkYX_o^ZF:00;o^ZJ;00Go]ZF7okFTQ_niZHSo[immokJVQ002
ok:SO003ok6RMonhZGko]ZQk00;ooooo00?oo_knooooooooool00_ooool0
1?ono_koooooooooooono_h4ooooo`04ookno_ooooooooooooknoPCooooo
00Gono_kooOgmoo/k>cohN7QoijNWP05onKViP06oijNW_oQhN7ok>c/ooKf
m_nGUiOoVIVI0onKVi/01?nJVY[oVIVIoiVIVOnHV9P5oiNGU`03oiJFU_nG
UiOoUYJF00;oUiNG0_nFUYH;oiNGU`GoUYJF0_nGUiL01?nHV9SoUiNGoiNG
UonGUiL2oiJFUP0;oiRHV?nJVY[oVIVIoiVIVOnHV9SoVIVIoi^KVonIVIWo
V9RHoiJFU_nCTi<00_nEUID03?nFUYKoV9RHoibLW?nJVY[oV9RHoiVIVOnH
V9SoUYJFoi6ATOnDU9CoUiNGoiVIV@SoVi^K00?oW9bLoi^KVonLW9`01OnL
W9`2oi^KV`03oibLW?nJVY[oVi^K00;oVi^K00GoVYZJoibLW?nKVi_ooooo
ooknoP04ooooo`04ookno_ooooooooooooknoPCooooo00Coo_knoooooooo
ooooo_kn1_ooool01Ookno_omoOgonc/k?oQhN7oWYjN0?ooi^KVMooVi^H0
00Gok^k^067oXj>SomoOgooXj>SoWXa0oinAB_nPUEOoWYAOoiN@I?nCSVKo
UXiYoiV@IonNTFGoWXiMoj2<F_nQSE_oX8eRoif>IonKSVcoWhi`ojZBL?n_
TW3o[I=bojV@L_nTSg;oYI5hojFCNonUUGcoXI5goj:?K_nUSVCoYhaGojf:
B_ndRT3o^XXfokj:=_njQcSo]HHhok:7>?naRcSo/8heojj?<_n`TS3o/iH`
ojfA9_naU2co/YTeojjG>_nSTT;oXIE=oiNBD_n;QTKoWYA<ojbNDoniZ6;o
[YUHoij5C?nVReCoZi1KoiYoB_nQR53oX8YAoiN2BOnMRDko/YiSok:MI?nT
SeKoX8aJoj^IMOnUUWWoP6mCoh9cE?n=OUooWi9bojZOOonPVWSoYImmojZV
Pon[YH?o]:V9okNVR?ngXXGo`jR=olFZSoo0YX_o_ZJ:okbTR_niY8Wo^ZF:
ok^VROnjYhWo^JJ6okRUQOnaWWgo^ZR4okFUPOncY7go/J9i00;o/:5f00Go
n_[jooShn?ogmoOon?SfooKfmP02ooShn006ooWinOojn_[on?ShooOgmooh
n?Kom_Kf0_ohn?P03OoinOWon_[jooShn?ogmoOon?SfooKfm_ogmoOom_Kf
ooCdm?o^k^koj>SXon3Ph?nSXj<01Oo^k^h01_nSXj?ogmoOonSXj?o]kNgo
UYJFoiNGU`;oV9RH1?nGUiL00onHV9SoUiNGoiNGU`05oiNGU`03oiRHV?nI
VIWoVIVI00CoV9RH00CoVIVIoiRHV?nHV9SoV9RH1?nGUiL00onHV9SoUiNG
oiNGU`04oiNGU`;oV9RH01CoUiNGoiRHV?nHV9SoV9RHoiNGUonHV9SoUiNG
oiFEUOnGUiOoVIVIoi^KVonIVIWoUYJFoiNGUonHV9SoUIFEoiJFU_nGUiOo
UIFEoiJFUP;oVYZJ0_nGUiL2oiVIV@07oi:BT_nCTi?oUIFEoiRHV?nJVY[o
VIVIoiZJVP02oi^KV`05oibLW?nKVi_oVi^KoibLW?nMWId00onLW9`00onK
Vi_oW9bLoibLW002oibLW003oi^KVonJVY[oW9bL00;oVi^K0onJVYX01?oh
n?SomoOgooShm_ofm_H2ooShn006ooWinOojn_[on?ShooOgmoohn?Kom_Kf
0_ohn?P01_oinOWon_[jooShn?ogmoOon?SfooKfmP;on?Sh00OomoOgooKf
m_odm?Cok^k^onSXj?oPh>3oXj>S0?ook^k^Moo^k^h000Gooooo01Wo[jn_
omkNg_oVi^KoXXY2oj29@onKR4KoUHE7oi>3B?nDPd_oVXM=oj2:C_nWRdco
[Xe:ok6<AOnaRd;o/He3ok2>A?n`T4Oo[Xm<ok:FEon`UUWo[YAIojZ@EOnY
SeKoZi1I00;oZi9L02KoZ8mIojZ@Eon[Sdko[Xe6ok6<>ongSSKo_I4bol:A
<_nnScGo^hdeokV@=?ngTc?o]YHaokFF:_neUbOo^9TUokjO:onjVR_o]iDa
ok6B>?ndVTgob[Edomo>V?oSfJSod]BSomKN[ooBejoo[[:?ohZ:K_n6QVko
QHE]og9eF_n5R6WoSi=`ohb>I_n:RE_oVIEUojFNJP;oYYYV027oXi]ZojFM
K_nCR5[oWi9VojfNMOngYGoo/j=oojBFLonUUWOoVXe]oi:7JOnUUg[o]:B:
okFTR_nmZI3o_jVAol2XS_noYHco_J>:ok^SROnlY8So_JF9okjVR_nnYhSo
^ZF6okNSP_noZhSo_:Z6okRVP?njZ8;o/ImgokNUOOoclo<00oobl_801Ooc
lo?ol_;boo;bl_obl_;olo?c00?ol_;b00Golo?coo;bl_obl_;ol_;boo?c
l`03oo;blP08oo?cloobl_;olO7aonk^k_o[jn_oi^KVomkNg_n_[jl5oooo
o`04ojn_[ooNg]koi^KVonc/k0?oUYJF0onEUID00onFUYKoUiNGoiNGU`04
oiNGU`?oV9RH0_nIVIT9oiRHV0;oUiNG2onHV9P2oiVIV@;oV9RH00WoVIVI
oijNW_nRXZ;oXj>Soj:RX_nSXj?oXZ:RoibLW?nFUYH00_nEUID00onBTY;o
UIFEoiNGU`02oiJFUP03oiRHV?nIVIWoVIVI00?oVIVI00?oUYJFoiRHV?nJ
VYX00_nKVi/2oiVIV@03oiNGUonFUYKoVIVI00;oVi^K1OnLW9`00onKVi_o
W9bLoibLW002oibLW0;oVi^K0_nLW9`01?nKVi_oW9bLoiZJV_nKVi/3oo;b
lP05oo?cloobl_;ol_;boo;bl_oclo<00oobl_801Ooclo?ol_;boo;bl_ob
l_;olo?c00?ol_;b00[olo?coo;bl_obl_;ol_;boo7alOo^k^kojn_[onKV
i_oNg]ko[jn_oooooomgooooo`001Oo^k^h0EOnSXj?ogMgMonCTi?nRRTCo
WhQ2oib8@onIQT;oVHQ3oib9AOnPS4OoYha7ojV8@oncSDKo^8a1okN9>one
R3Go^8/fokJ<=_n`S3KoZXdmojR=@?nWRScoYhLjojR7>_n]RCgo[HToojb8
?_n_RT?o/He3ok>?@OndScko]XhfokR@<OnnTRoo`IH`ol2E;onlUBko_9L_
ok^J;onjVboo]Y/ZokRJ:?njVRWo^iXYokfK;oo2Wc_o_ie4okbLDOo0Y6?o
aJadokZ/Nong^H[o[kN>ojbdSonRYhOoTYImohjBNon>TGcoRHefoi2FN_nH
WggoUI]eohjDJ?nFV6WoX:1^oj:PKonTXFkoZZMboi^EHOn9OdkoW8mSojjL
M?n/V7Go/9]lokNRQOnaWH;oTX9XogmaE_nGRFko/::7ok>UR_neYhco]jJ:
oknWSOnoYH`00_nnY8/03?noYH[o`:F8ol6VROo0YhSo_:>4okRQPOnkY8;o
^:B1okFQO_niYh?o/Z1lokZXQ0Kokno_00?ok^k^ono_koo_knl01Oo_knl0
0oo^k^kokno_ono_k`04ono_k`;ok^k^00Gok>c/onWYjOoTi>CogMgMoj>S
X`05onk^kP04oj>SXooMgMgoi>CTonWYj@KoUYJF0onGUiL2oiRHV0SoUiNG
0_nFUYH5oiNGU`GoV9RH0_nIVIT00onHV9SoVIVIoiVIV@06oiVIV@?oVYZJ
00?oVi^KoibLW?nLW9`00_nMWId00onLW9coVYZJoiRHV002oiNGU`06oiJF
U_nHV9SoVIVIoiRHV?nGUiOoV9RH0_nIVIT03OnJVY[oVi^KoiRHV?nDU9Co
UiNGoiZJV_nIVIWoVYZJoi^KVonJVY[oUIFEoi>CTonGUiL00_nKVi/:oibL
W0GoVi^K00?oW9bLoiZJV_nLW9`01Oo_knl00oo^k^kokno_ono_k`05ono_
k`03onk^k_o_knookno_00Gokno_0oo^k^h01Oo/k>cojNWYonCTi?oMgMgo
Xj>S0?ook^k^Moo^k^h000Goi^KV01goWIfMomgMgOoShn?oVhQ3oiV8@_nG
RD;oV8Y1oiR<@_nJS4?oWha7oj><BOnTQTSo[HU=ok::COnbQTOo/8E1ok:8
@?nbR3co[HPgojV9=_nZRSGo[8Pbojj6;oncQc3o^8XdokZ:=OnhR3Co_8`j
okj??@02ol2C@00fokjB>onmTCSo_i8gol2F<_nlV2So^IXUokVL9oniWRgo
^IlaokNL<OngVS;o^I`fokbJ>?nlVSWo_Y/ook^I@_nfUDCo^Ia@okjSG?ng
XUoo/JIVojNOHOnWWF;o[Z5/ok2PKon^W6ko[I]]ojjLK_naXG3oZim]ojJO
Jon^Z7Co_[b9olO:UOo6bYSoaLNHokF`Q_nLTfcoRG]HoiF5I?nUT7GoX8Ma
ojZAOOnjY8ooa[6NojBDOOn<OFKoWI5gok2UQon`YHGo]J^8ok^/RonlYhco
_jF>0_o1YHd04Oo2Yhcoa:J:ol>VR?o2YHGo`jJ6okjTPonnYHKo_:F5okNS
P_neXX7o]jB4okJVQOo/k>cok^k^onc/k?o]kNkok^k^00;okNg]0_o/k>`0
1?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00_ok^k^onc/k?o]kNkok^k^
onc/k?o[jn_oj^[ZonOWiooShn?og]kNoifMW@05onKViP04oifMWOoMgMgo
hn?SonOWi`KoUYJF0_nGUiL00onFUYKoUiNGoiNGU`05oiNGU`04oiJFU_nG
UiOoUYJFoiJFUPCoUiNG0_nHV9P2oiVIV@?oV9RH3OnIVIT01OnHV9SoVYZJ
oi^KVonJVY[oVi^K00;oVIVI0onJVYX01onIVIWoVYZJoiZJV_nJVY[oVIVI
oi^KVonNWYh00onPX:003?nLW9coV9RHoiBDU?nFUYKoV9RHoiNGUonIVIWo
W9bLoijNW_nIVIWoUIFEoiRHV0;oVi^K3_nLW9`4oi^KV`04onk^k_o/k>co
kNg^onk^kP;okNg]0_o/k>`01?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/
00Cok^k^onc/k?o]kNkok^k^0_o]kNd01oo/k>cojn_[on[Zj_oWinOohn?S
omkNg_nMWId0oooVi^IgonKViP001Oo^k^h0HonSXj?ogMgMon;Rh_nNQd7o
VhLnoiZ7>onHQS[oV8LioiZ8??nORD3oXHQ5ojB5AOnZQT[o[HI;ojn6B?na
QT;o/hU1ok6:>on_RcOoZX/aojf><OnaSbko]Hd]okZ>;Oo0Sc3o`Y0aol6>
<_o3TSKo`i@lolBF@?o0Ucoo_YDmok^D>OnkTSSo^I<`okVJ9_nhW27o]idV
okRO:oniWc7o]i`cokRK=oniVcWo^iThokbI>oo0WCoo`Ii2okbJ@OnkVdKo
^Y]8ok:HA?n`VDWo[iY;ok2IBonbV4go]IU@okNJE?njW5Co^YiEol6VGonh
X5[o/iiKokNXIonk[g?o^K1gok>]NOnb[7[o/ZMjojZKL_nXUW3o[9UhokfX
SOniXhco^ZF@okj/V?o<^jOo[J6;oiF9LOnSVGko]JZ<okR[ROnk[X_o_:b:
oknWSOo0YXoo`ZJ>ol>XSOo6Z8coaJR:olBUQ_o1Y8CoajZ:ol:XQoo2ZH[o
`:V:okFPPonTTG?o]:>7ojNHN`02on_[j`Cok>c/00Cojn_[onc/k?o[jn_o
jn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/3onc/k0;ojn_[00Goj>SXonKV
i_oShn?ogMgMoj>SX`05onk^kP04oj>SXooMgMgoh^;RonKViP?oUYJF0_nE
UID4oiJFUP_oUiNG1?nHV9P5oiVIV@?oV9RH2_nIVIT2oiZJVP[oVIVI0_nJ
VYX01?nKVi_oVYZJoiZJV_nKVi/4oibLW00<oi^KVonIVIWoVIVIoiVIVOnL
W9coVi^KoibLW?nMWIgoWinOoi^KVonFUYKoVIVI0_nLW9`00onMWIgoW9bL
oibLW007oibLW009oifMWOnLW9coW9bLoibLW?nKVi_oV9RHoi^KVonIVIWo
jn_[00Cok>c/00Cojn_[onc/k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[
joo[jn/4onc/k0?ojn_[00Goj>SXonKVi_oShn?ogMgMoj>SX`3oonk^kWOo
k^k^0005ooooo`1Sojn_[ooLg=coh^;RojV5>OnWQSWoYXDfojB5<onSQ3;o
Y8DeojJ6>OnXR3goZXQ0oj^6?on]Qd3o/HXookJ=?OnfSSWo]8ldok>B<onZ
TRko[YLaokBI<?ngURgo^YD[okbE;?nnUBco_I<]okjF=?nkUcOo^YLiokRG
>_neUSWo/iLfokBF=_ncUS3o^i/^okZJ:OnkVbco_9h`okbM<OniWC3o^i`b
okfL<oo1X3Oo_i`dol2M=Oo0WCOo_9XfokjL>onoWSoo^YTjoknN?oo3XT?o
`J11okZL??nkWcko_J50okfQ?_nnXSoo^IdlokRK?onmWdOo`J9BokbNE_nj
W5co_IiUokfSJ_nfX6Ko]Z9WokZUK_ncWfgo`Zn5olFeTOo7^Y[oa;^Lol:k
Wona[8ooX9]noj^TQonj[hoo_:j;okn]ROnkYhKo`JV?ol2XT?o1Yhko`ZR=
olBYS?o3Z8[o`jJ6ol:UQOo1Y8Co_Z>5okfTQ_ngWh?oXhmdoh5`E_nXV7oo
TH9[01Gojn_[0_oZj^X01OoXj>Soi^KVon;Rh_oLg=co[jn_00Gooooo00Co
[jn_omcLg?oRh^;oi^KV2?nFUYH01?nGUiOoUYJFoiNGUonGUiL4oiRHV003
oiNGUonHV9SoV9RH00GoV9RH1?nIVIT4oiRHV0SoVIVI00CoVYZJoiVIVOnJ
VY[oVYZJ0_nIVIT00onJVY[oVIVIoiZJVP02oiZJVP03oiVIVOnJVY[oVYZJ
00;oVYZJ0_nIVIT00onJVY[oVi^KoiZJVP02oiZJVP07oi^KVonJVY[oVYZJ
oi^KVonJVY[oWIfMoijNWP03oinOW`03oibLW?nIVIWoVi^K00?oWIfM2_nL
W9`01onKVi_oW9bLoi^KVonHV9SoTi>CoiVIVOnEUID05_o[jn/2on[ZjP05
onSXj?oVi^Koh^;RomcLg?n_[jl0oooooomgooooo`001Oo^k^h0:?nSXj?o
g=cLon;Rh_nYQC7oZXHbojb8<_nZR37oZHHbojN7=?nYRCKoZhXiok2??_n[
RcSo[HXfok:@=onfTcOo]98aokBB<?ncUS3o/9TaokBM<onkX3Go_9daok^K
;_nmV2go_9L]okbG;onjV3Co]iLdokBF=?ncUcKo/YTeokBK=oneW3Oo^9/e
okjM=?noVS3o_I/`oknM<_nnWC82okbK<006okjM<_nnWS7o^i/^oknM<Oo2
X3Go`Ild0_o3X3P0<OnnVc?oa9lgol:M=OnkVS7o_9`eoknT?OnjXC[o]ile
okbQ>_o1Y43o_Ilmol2M@oo2WT[o`I]@olBMF_o6WV7o_YYNokZNGonhXfCo
`:Y`okFQK_o0[h?o_;28okV`Sone/9;o_[ZOol2nYOno^j3o`;^NoknaU_ng
YXSo`JZ;ol>ZS?o3Zi7o`ZZ@ol2XS_o0Z8co`ZV;ol6XROo2YhWo`:N8ol:Y
R_o0ZH[o_JR;ok>OQ_nJR73oL619ojVJQon=P6d05Oo[jn/2on[ZjP05onSX
j?oVi^Koh^;RomcLg?nSXj<01Oo^k^h01?nSXj?og=cLon;Rh_oVi^H7oiJF
UPCoUiNG1_nHV9P00onIVIWoVYZJoiVIV@05oiVIV@CoV9RH3_nIVIT4oiZJ
VP03oiVIVOnJVY[oVYZJ00;oVIVI0_nJVYX00onIVIWoVYZJoiZJVP05oiZJ
VP06oi^KVonJVY[oVYZJoi^KVonLW9coVYZJ1?nMWId01onNWYkoWinOoijN
W_nNWYkoWIfMoi^KVonLW9`00onMWId9oibLW005oi^KVonGUiOoT92@oiZJ
V_nEUID05_o[jn/2on[ZjP05onSXj?oVi^Koh^;RomcLg?nSXj<0ooo^k^ig
onk^kP001OoVi^H0EonMWIgofm_Kon;Rh_nPQ2?o[Y4cojf@=?nYRc7oZH/e
ok2D@?nWRcOoZi4jojV@=_nVSC3o]IdkojjF<_nVSBKo[Y</ok:G;_ncV2oo
]9TbokZM=onjVS?o]iH]okFB:_nhTb_o_ILbokVF<_njVSOo]ILeok>G=?nb
US?o]YTeokJI<OngV2ko`9lfol:M=Oo0VC;o_iPaokbE;_o0Vc?o^YD]ol6N
=_nnWCCo_iheokjO=OnoWSGo^iX_ol2O=?o1Wc?o^YP/olJT>?nnVBko_ihc
okfP>?niX3_o^:51okVTAonjYD[o^J59okBJAOo2YU?o`Z5BokbJD?o1WeSo
a:5Ool2NGoo5YF[o`:I]oknXM?o1Zgco_jb2okZZR?nhZXoo]jbHokF`WOna
[Yoo];6RokJ`X?nd[I_o]jREokVWTOnoYY3o`:J?okVTROnnZHko_:N<okRS
QP02okZUQP0:okRSQ?niY8Go_JR;okRTROndXhWo[If6ohYkI_m^HDkoR7a/
og1TE1Gojn_[0_oZj^X01OoXj>Soi^KVon;Rh_oKfm_oWIfM00Goi^KV00Go
WIfMom_KfooRh^;oi^KVoiFEU@04oiNGU`03oiRHV?nGUiOoUiNG00;oUiNG
00CoVIVIoiRHV?nFUYKoUiNG0onHV9P2oiVIV@?oV9RH00?oVIVIoiRHV?nI
VIT00onHV9P2oiVIV@03oiRHV?nJVY[oVYZJ00;oVIVI00GoV9RHoiVIVOnH
V9SoVYZJoiVIV@03oiZJVP06oiVIVOnJVY[oVYZJoiVIVOnKVi_oVIVI1onJ
VYX00onIVIWoVi^Koi^KV`02oiZJVP04oi^KVonJVY[oW9bLoi^KV`KoW9bL
00CoWIfMoibLW?nMWIgoWIfM1OnLW9`00onKVi_oW9bLoibLW005oi^KV`08
oibLW?nKVi_oVi^KoiZJV_nDU9CoT92@oiBDU?n@T90Fon_[j`;oj^[Z00Go
j>SXonKVi_oRh^;ofm_KoifMW@3oonKViWOoi^KV0005onk^kP1Soj>SXooK
fm_oh^;RojBB;_nSSbkoX8/^oj>;=OnSRSSoYXdkoj>=>_n/UT7oXH`aojFA
<_nWTc3oZY@_ojVB;?n_US7o]i/hoj^?;?ncUcKo]ILgokBC<_nkVCOo`Z0n
okbJ>?ngUCCo^YTjokJG>_n`TcGo[iDfok2F=OneV3Co]iLbokJE;?nhUbko
_I/iokZH=onoWCco_9Tkol2O@_njVd3o^ie3ojbA>?n_UCko/9Q0okJNA?nd
Vcoo^9hookjR?oniW3So_Idjol>Q?oo4XdCo`JA8okfSC?nkYE;o_JMKok^U
G?niXE_o/9EBok6DD_naTU;o/iEGok>FF_njX6GoaJacokjYL_nnZWSo_:Yl
ok^YPOnjYhKo^:N;okJWT?ndYiKo/JRIojbTUon]YiWo[jRFojjVTon`Y8co
]JB:okZUR_nlY8So]j:5okZWROngY8Ko/j22ok>RQ?nbXH?o/J22ok>TQon]
WH?o[Z26ok>WSon[WX_oWI:0ohb3L_n?QWOoOWEV01Gojn_[00Ooj^[ZonWY
jOoXj>Soi^KVon;Rh_oKfm_oXj>S00Gok^k^00CoXj>Som_KfooRh^;oi^KV
0_nGUiL3oiJFUP;oUiNG00?oV9RHoiJFU_nGUiL00onGUiL00onHV9SoVIVI
oiNGU`03oiRHV004oiVIVOnJVY[oVIVIoiRHV0;oVIVI1onHV9P2oiVIV@06
oiZJV_nIVIWoVYZJoiVIVOnJVY[oUiNG0_nHV9P3oiVIV@04oiZJV_nIVIWo
VIVIoiZJVP;oVi^K00GoVYZJoi^KVonKVi_oVi^KoiZJVP03oiRHV0;oVIVI
00?oVYZJoibLW?nLW9`02?nLW9`2oi^KV`04oibLW?nKVi_oVi^Koi^KV`;o
W9bL00?oVi^KoibLW?nKVi/00onKVi/02_nJVY[oVi^KoiZJV_nJVY[oVi^K
oiZJV_nHV9SoUIFEoiJFU_nCTi<Fon_[j`07on[Zj_oYjNWoj>SXonKVi_oR
h^;ofm_Koj>SX`3oonk^kWOok^k^0005ooooo`0kojn_[ooKfm_ohN7QoiV@
<onIT3GoWi0koin>@?nNRT7oWh]4ojB=AonQRd3oZYE4ojbH@_nSSSGo/9Pn
ok2E>_n[SC?o]iDnok:B?OnXS3So[I<nojV>=on]ScOo^Y]1okFF??n[S3;o
]9Hnok>H@OnaUd3o]9a2okNP@oneVcco]9PgokRK=onfVSOo/9]0oj^J@_nf
XDko[iY;ok6ND_ncX5_o/ImOoiN8COn7Nd7oPWPmoiN=D?nZWeoo/ZEOokRX
GOnfXeCo^J9Bol2SEoo3Xe[o_j9LokfQH?nkXFCo^j9YokVNJOngVFL00_n`
T5l09_n<KCkoRVm0ojfHJon_XWGo[ZMkok>_P_ne[X;o/Z^1ok2VP_nbYHGo
]:B:okJTS_ndXhoo/j:@ojjOS?n^XX[o[JB7oj^RPOn]Y7go/ZMjokBXN?ne
Yg[o]ZB0okNTQ_nbXH?o/J22ok:SQ?n_XHCo[:65ok2VRonbZ8oo[jN@ok2X
TonOUXGoYYf>ojZPU?nMThOoTXQl5Oo[jn/01ooZj^[ojNWYonSXj?oUiNGo
hN7Qom_Kfon_[jl01Oooool01?n_[joofm_Kon7QhOoUiND2oiJFUP;oUiNG
0_nFUYH01OnGUiOoUYJFoiRHV?nHV9SoUiNG00;oV9RH00GoUiNGoiRHV?nH
V9SoUiNGoiRHV002oiNGU`0:oiVIVOnHV9SoUiNGoiRHV?nIVIWoV9RHoiVI
VOnJVY[oVIVIoiRHV0?oVIVI00CoV9RHoiZJV_nIVIWoVIVI0_nJVYX01onF
UYKoU9BDoi>CTonFUYKoVIVIoiZJV_nKVi/00_nJVYX6oi^KV`;oVYZJ0_nH
V9P2oi:BTP03oiVIVOnJVY[oVi^K00?oW9bL1_nKVi/01?nJVY[oVi^Koi^K
VonJVYX7oi^KV`09oiZJV_nKVi_oVi^KoiZJV_nKVi_oW9bLoi^KVonLW9co
VIVI00;oVYZJ00?oV9RHoiJFU_o[jn/05Oo[jn/01ooZj^[ojNWYonSXj?oU
iNGohN7Qom_Kfon_[jl0oooooomgooooo`001Oo^k^h0HonSXj?ofMWIon3P
h?n6QdGoSi1>oi6=D?n0NT3oNVhjohYmBOnOTUkoUXUBoib@E?nNTe7oUHQ2
oif<A?nPS4GoXh]3oj24>onPQD3oT7i0oiN9C?nHR4[oU84ooj:;B?nYT4go
WhI3oj6:A_nHPd3oWXU6ojBACOnVUDooW8Y2oiR6??nUSd?oY998oiZAC?nC
STcoVY9CohIm@_n8OdSoUi1LoifFJ_n6Pe[oFETcodM99?mZJTCoV9I]oj:N
KonNUf?oXIAMojfJH_n^TV;o/Y=UojnDJOn[U6[oYY=YojBBJ_nST6SoXheV
ojB:IOnRQV7oK50[ofQ@;?nVTW7oYiYhoiZDM?nLW7[oWimioinMMonOVgSo
XYUlojNIOonYUh?oZ9F4ojNDPonWUX;oZ9V2ojFJO_nTVWOoYYedoj^PLon/
XW7o[9mbojnMNOn^VG[oZIIhojVHN_n]Wh;oZ9b2oj:KPOnTWXSoWiR5oj:M
R_nUWhooX9R;ojjVVOnf[:;oVY26og]^I@0Eon_[j`07on[Zj_oYjNWoinOW
onGUiOoPh>3ofMWIoj>SX`05onk^kP05oj>SXooIfMWoh>3PonGUiOnEUID0
0_nFUYH01OnCTi?oTI6AoiBDU?nHV9SoUYJF00;oUiNG0_nFUYH2oiNGU`;o
UYJF00KoU9BDoiJFU_nFUYKoUIFEoiNGUonHV9P2oiJFUP06oiFEUOnFUYKo
UiNGoiRHV?nFUYKoUIFE0onGUiL03?nFUYKoUiNGoiBDU?nDU9CoUiNGoiRH
V?nEUIGoSXj>oh^;Ron@T93oV9RHoiVIV@;oV9RH00?oVIVIoiRHV?nIVIT0
0_nIVIT3oiRHV0?oUiNG00GoSXj>ohf=SOnHV9SoVIVIoiRHV00>oiVIV@Co
VYZJ0onIVIT2oiZJVP03oiVIVOnJVY[oVIVI00;oVYZJ00GoVIVIoi^KVonL
W9coV9RHoi:BTP0Fon_[j`07on[Zj_oYjNWoinOWonGUiOoPh>3ofMWIoj>S
X`3oonk^kWOok^k^0005onKViP1SoifMWOoGemOogmoOoeYVD_mGHdgoEem:
oeiQC?mFED7oEE@oog5`FomnOVKoLGAGogEiF?mdMTooKFi2ogYfAonCS5So
P7<noh=kC?mLGdCoBU8mode?>Om?Bc3oH5Lhog]^C?mfITGoIEDcogm`Con6
NEOoQ7UKoh=mGOmmN5SoNWEEohJ1HOn5PV7oO7mPogAiFOm^LU7oBT/Yode?
:_mZKTWoNh5Oog=jFOm?FCko=T0WoeMOB?n4Qg;oRHUaohEoIon9OF?oU89Z
oi9gI_nCNFcoSgi^oh^0K?n4OfWoOgmUogn0HOn4PF;oQgaLohQhEon1JT_o
QF]@oj:8KonKPf_oUX5/ohAhH?n4Q6;oPXISohJ5I_n9PfWoSH5[ohinK_n>
O6koSWa`oi>1MOnEQGKoUHQgoiJ:M?nJS7;oWY1eoj6BLonTTG7oZ95aojB=
KOnKQVOoVHQ/oij@MOnHSWGoSHMaohR5L_n<RGSoSX]lohj:O_nJThWoYijE
ok>YX?nKS8GoHE9;01Gojn_[00OojNWYonSXj?oVi^Kohn?Son3Ph?oGemOo
WIfM00Goi^KV00GoWIfMomOGeooOgmoohn?Soi2@T003ohn?S`;oSHf=00_o
TY:BoiBDU?nBTY;oTi>Coi:BT_nATI7oTi>CoiJFU_nBTY;oU9BDohn?S`03
ohb<S005ohj>S_nBTY;oTI6Aohj>S_nBTY800onDU9@2oi>CT`;oUIFE017o
U9BDoi>CTonBTY;oRh^;ohb<S?nATI7oU9BDoi>CTon=SHgoRHV9ohn?SonE
UIGoUYJFoiFEUOnDU9CoUYJFoiBDU004oiFEU@;oU9BD00?oUIFEoiBDU?nD
U9@00_nBTY801?nGUiOoUYJFoiJFU_nDU9@8oiFEU@;oUYJF0onGUiL5oiRH
V00>oiJFU_nGUiOoV9RHoiNGUonFUYKoUIFEoiJFU_nGUiOoUYJFoiRHV?nJ
VY[oW9bLoiNGUon>SXhFon_[j`07onWYjOoXj>Soi^KVon?ShooPh>3oemOG
oifMW@3oonKViWOoi^KV0005onk^kP1Soj>SXooLg=coh^;RobHa;OlmAT7o
?44jodA7??m0@SGoDeA6oemQE?mDF4[oG69FoeMOD_mIHU7oF619oeeQA_ma
LDooK6U0oj>TQ?m]NW3o:SXiob4[8olX:Qgo@CXXogibG?n7MEgoFDD]oh9`
F?n7MV;oMFQGogA]GOmjMfSoMgEYog]kKomeN6goLGM]ofI/H_mEFD[o9BPE
oblb7OmHG4GoJg1IofadGOmMIU?oB550oeaRE?mdMFOoMW1Roge`H?n7M6?o
SWAUohIZG?n6K5ooPFmQog]bHOmcLUkoKG1KofmaFomeLe[oMfeDoif;Loo5
[9Ko_:2:ok:FPOn@Lf7oQ6YIoga[EomfLUOoLWEHogEcF_mgLUcoN6mNogQ/
G?mhK5koMf]OogmcIon5NF_oRh1^oi23L?nHR77oWXadojJ@N?nYTGGo[Y=e
ojV?K_nLQFKoTH1Toi:4J_n;PfkoOWUVogEcI?mcLFCoLFmSofYVGOmkM6co
Rh1joj2CSOn;NGGoCc`f01Gojn_[0_oZj^X01OoXj>Soi^KVon;Rh_oLg=co
Xj>S00Gok^k^00coXj>SomcLg?oRh^;oi^KVohN7Qon;Rh_oRXZ:oh^;Ron:
RX[oSHf=ohn?Son>SXh5ohn?S`05oi:BT_n@T93oVYZJoi>CTon8R8P00_n6
QXH02?n9RHWoTi>Coi>CTon<S8coTi>CoiBDU?nATI7oTY:B0_nCTi<03onD
U9CoTi>Coi>CTonATI7oSXj>ohJ6Q_n7QhOoSXj>oi6ATOnBTY;oT92@ohb<
S?n?ShooTi>Coi:BTP02oi>CT`03oiBDU?nBTY;oTi>C00;oTi>C1OnBTY80
1OnGUiOoWIfMoi^KVonJVY[oU9BD00[oTY:B00CoTi>CoiBDU?nEUIGoUYJF
0_nGUiL2oiRHV007oiVIVOnHV9SoUYJFoiFEUOnFUYKoUIFEoiBDU003oi:B
TP06oi6ATOnCTi?oUIFEoiVIVOnDU9CoRXZ:5_o[jn/2on[ZjP05onSXj?oV
i^Koh^;RomcLg?nSXj<0ooo^k^igonk^kP001Oooool0Hon_[joog=cLon;R
h_lb<27o<c0MoeI@>_o<aJWoeljaoi6:KOmFD3SoE550oeEFC_m?E4koCE9>
oeQME_mFF4_oFEQ3of=P@Onf^IcoOXaoobDe:olP9QSo9b8>od<d5onaVGOo
ajV3ofi<9_n9JD?oTgECogMM@_mcGdOoO6mLog=ZFomdKV;oKfaSog=bKOmV
If7oCda5ob0L4Olk=BWoIf5Cofm[GomaKf;oIF9Ioe=AAOmRG53oLFEGogES
Con4JU7oUWAHoiijF?nLNe;oUGQ>ohafCon5ME?oOG9DogI/DomeJE?oNFIE
oh=YF_ngUh[okljoom:aX?ndUhGoRG1LogESCOmlL5[oN75Oog9_G_mbK5ko
LF]Mog=]GombKf3oLVmNog1_GOmbLEcoO7YQohZ5J?nCRV_oWXi]ojZCLOnd
UgGo^I]gokfONonjWG_oZ8m`oiJ1I_n?P6WoR81]ogegJOmbL6CoJVYPofe]
IOm`KFKoPW]eoj2ETOnl[JSoU85mofIACP0Eon_[j`;oj^[Z00Goj>SXonKV
i_oRh^;og=cLojn_[`05ooooo`04ojn_[ooLg=coh^;RonKViP;oQhN700Co
SHf=oj2PX?nRXZ;oUYJF0_n=SHd01?n>SXkoSHf=ohf=SOn?Shl2ohj>SP04
ohn?SonNWYkoUYJFohN7Q`;oQHF500KoR8R8oiZJV_nLW9coSHf=oi:BT_nD
U9@2oi2@T00?oi:BT_nATI7oTY:Boi6ATOnBTY;oTI6Aohb<S?n4Q8CoR8R8
oi2@T?nATI7oTY:Boi2@T?n=SHgoShn?00;oTI6A00CoTY:BoiBDU?nEUIGo
UIFE0_nDU9@00onCTi?oTY:Boi:BTP02oi6AT@07oi:BT_nJVY[oXj>SoijN
W_nJVY[oTi>Coi2@T004oi:BTP03oi6ATOnBTY;oTY:B00?oTY:B00CoTi>C
oiFEUOnFUYKoUiNG0_nIVIT01OnJVY[oVi^KoiZJV_nHV9SoUYJF00;oUIFE
00?oTi>Coi:BT_nATI400_nBTY801OnDU9CoVIVIoifMWOnFUYKoSXj>01Ko
jn_[0_oZj^X01OoXj>Soi^KVon;Rh_oLg=co[jn_0?ooooooMoooool000Go
k^k^06?oXj>SomcLg?oRh^;o<R`Doc</4_mCBR_ogMBcoo7YaOnXWh3oDD/a
od0m;?m2@S[oDUACodM8B_mADUCoEUMBoeeMDOmLFDKoS8ekof=]H_lG8aWo
:2XLobdW4Om:>AgoeknMoo?C[?m^Bb?oQF8joiUgDOmmGSooM5XoogYXD_m/
GdkoK6=DofmXG_m_K6GoHf1IodU5??lQ6Q3oB40eogAZH?mcJEooLfUMog1V
F_mNDTCoK5a=ogi/F?n6KUKoTGAFoj60GondTFWo/iANojV<E?nJPe7oU7mD
oh]hEon1L5CoO6MBogYSDon=LFGoXH5fonK4^?o7YiSoV7eZoh=]E_n4M5[o
NfmGogeeH_mhKf3oLfYKogA[G?mgL63oO7ESogagI?mjMEooLFeBogiiFon=
QF7oVH]VojJ?I_naU6[o_9Y]ol>NL_o6Y7OoaJAkok:DK_nIPEooSg]Poh]l
IomoN6SoMG5Vof]XHOm]JVGoKFQTogI]J?nUV9;odl2jojJ?ROnBNG805Oo[
jn/2on[ZjP05onSXj?oVi^Koh^;RomcLg?nSXj<01Oo^k^h01?nSXj?og=cL
on;Rh_oVi^H2ohN7Q`05ohb<S?nSXj?oYZJVoiZJV_n<S8`00_n:RXX02On=
SHgoRh^;ohf=SOn>SXkoShn?ohj>S_nGUiOoTI6AohF5Q@02ohJ6QP09ohV9
ROnPX:3oY:BTohf=SOnATI7oU9BDoi2@T?n?ShooTI6A00;oT92@00KoTI6A
oi:BT_n@T93oRh^;ohB4Q?n:RXX4oi6AT@06ohj>S_n?ShooTY:Boi>CTonD
U9CoUYJF0_nIVIT01OnGUiOoUYJFoiFEUOnDU9CoTi>C00;oTI6A00_oU9BD
oiJFU_nRXZ;oWIfMoiFEUOnBTY;oTi>Coi:BT_nCTi?oTY:Boi6AT@02oi:B
TP?oTi>C00SoTI6Aoi>CTonEUIGoUiNGoiRHV?nIVIWoVYZJoi^KV`;oW9bL
00KoVIVIoiJFU_nEUIGoUIFEoiBDU?nBTY83oi6AT@05oi:BT_nIVIWoX:2P
oiRHV?nEUID05_o[jn/2on[ZjP05onSXj?oVi^Koh^;RomcLg?nSXj<0ooo^
k^igonk^kP001OoVi^H0HonMWIgofm_Kon;Rh_lg<aKo81`0oeMC=_nPWh7o
i>?7oj6QROlc=2;o>3P/odQ9@om3@d7o@d=3oe1@D?mNGE_oFeMDoe9=BOmA
CTWo@D<nob<X8OlX:1ko;2HJodXo;Oo0/9Woh<R/of159on1HT?oU7IDogAG
>OmeFd3oN6A<ofiOC?m[GdooJ69Dog=aI?meMVSo@3h_oa`I2_mHDD7oLVUH
oga_G?n5MV7oPW1HofmK@_moJTooRWEHoh]fFOnFPf?oWha/oj^EL?naUVOo
YheJoij6F?nKQEcoTh1OohEdF?mnK5CoOVaHohIcH_nBOFcoUX5`oiF0KOnD
P6SoSg]RohahGOn=O63oQ7IKohAfG?mmKECoP71Ioi:0J_nGPVgoRWEPohA`
F?moJe3oQ71?ohifD?nNPU[o/i9Uol2JJOo:XFgoeJYeom6ZLOo6XF[o_9QT
ojR9Fon@MU7oQ6mBoh9cG_moMVOoK6=Lof9KEOm^IV?oPgQdoif<Q?o0[:7o
aJ^Noif2L@0Eon_[j`;oj^[Z00Goj>SXonKVi_oRh^;ofm_KoifMW@05onKV
iP0=oifMWOoKfm_oh^;RonKVi_n8R8SoQ8B4ohf=SOnJVY[oYJFUoiZJV_n8
R8SoRHV9ohb<S002oh^;R`03ohf=SOn?ShooSXj>00;oSHf=00[oRXZ:ohJ6
Q_n6QXKoQXJ6ohZ:R_nMWIgoXZ:Rohb<S?nATI7oU9BD0_n?Shl03onATI7o
T92@oi2@T?n@T93oTY:Boi>CTon:RX[oQ8B4ohf=SOnATI7oTY:BoiBDU?nC
Ti?oShn?oi:BTP02oiBDU005oiJFU_nGUiOoVIVIoiVIVOnGUiL00_nFUYH0
1_nEUIGoTi>Coi:BT_nBTY;oTi>CoiFEU@;oUYJF0_nEUID04OnDU9CoUIFE
oi>CTonCTi?oTY:Boi>CTonEUIGoUYJFoiBDU?nCTi?oTY:Boi>CTonDU9Co
UYJFoiVIVOnJVY[oVi^K00;oWIfM00CoVi^KoiZJV_nGUiOoU9BD0onCTi<0
1On@T93oShn?oi6ATOnDU9CoV9RH00;oWIfM00?oUYJFon_[joo[jn/05?o[
jn/2on[ZjP05onSXj?oVi^Koh^;Rom_KfonMWId0oooVi^IgonKViP001Oo^
k^h0??nSXj?ofm_Kon;Rh_l/:Q?o=3@LohV8Lon_/Icob/fjohnAPolW:ago
?D0eocm0>?m2@CcoAD@oode:AOmED4[oDDa6oda3?_m8@coo?Sljob8T7olO
81_o:bPQochh;?mlLf;oVHQdoea6;_n0IT_oTWMJog=H>omeGD?oN6I@og1S
D?m^IEKoJVAFofUXE_m^Kego>cXXobTX5_mCCS_oMFeJogibG?n?OfKoT7eO
oh5ZBon=MUKoUWmOoi5nG_nCQ6GoU8IYoiN9I_nHPEOoW85Doij5G?nQRF?o
W8EUohmjGOn8M5coR7=NohAbGP;oQgEQ02GoRGMQoi=oI_nHPfSoVX9Voif6
IonEPV7oT7eLohE`DOn:LUKoWhAYojF7KOnGNEooSW1Doi1cDonGNEGoXH5J
ojj<GonnUVGoaIYWolfNJ?oFZ6goeZY]ol^QIOo2VF7o/XaKoiimE?n@MUGo
RWINoh9eI?mnM6_oK6EOog9[IOmiLV[oVXf4on_Kc?ofi=3oXhii01Gojn_[
00Ooj^[ZonWYjOoXj>Soi^KVon;Rh_oKfm_oXj>S00Gok^k^00_oXj>Som_K
fooRh^;oi^KVohJ6Q_n8R8SoUYJFoifMWOnQXJ7oUiNGohJ6QP03ohZ:RP04
oh^;Ron<S8coSHf=ohb<S0;oRh^;01OoRXZ:ohF5QOn5QHGoQXJ6ohV9ROnC
Ti?oUiNGohb<S?nATI7oU9BDohn?Son@T93oTI6Aoi2@T?nATI7oT92@oi6A
TOnBTY;oRHV9ohJ6Q_n<S8coTY:Boi>CT`02oiFEU@04oi:BT_nDU9CoUIFE
oiFEU@?oUYJF00KoUIFEoiJFU_nFUYKoUiNGoiJFU_nDU9@3oi>CT`?oU9BD
00?oUIFEoiJFU_nFUYH00_nFUYH02onEUIGoTi>Coi>CTonFUYKoUiNGoiFE
UOnCTi?oU9BDoiFEUOnFUYKoV9RH00;oVYZJ00OoVi^KoifMWOnMWIgoVi^K
oiZJV_nHV9SoUIFE00;oU9BD0_nCTi<01onATI7oTY:Boi>CTonGUiOoYJFU
ojJVY_nHV9P05_o[jn/01ooZj^[ojNWYonSXj?oVi^Koh^;Rom_KfonSXj<0
ooo^k^igonk^kP001Oooool0Hon_[joofm_Kon7QhOlo?3?o@40fofUYGome
MfcoSXn7ofmbJOl[;2Co=SP]od92=_m:BcgoCT`modm<>OmIE43oGEM1oe]@
>_mBCC[oBdi7oble<olP92?o;c4/ocdm<om=AcWoGeA2oei=>On4L5SoT7YR
of]E?OmYEd7oKf1=ofmVEomgLFGoMWAWofm`H?mXJEWo:R/Kob`Z6om9ASOo
OgQVohEjI_nCQ6goTh9XohMdE_n@NecoV8=ToiF2H_nEQVOoThEXoi>3H_nB
NE7oWWiGoj>5GonSQF?oWH1RoiQmH_nJOVSoWH9_oj25L_nLPFkoU7UVoiAi
I?nOPfgoY8I^oj22J?nOPVCoY8aZoij6H_nFO5WoVGaLojN6IonZQfWoXWmQ
oiikFonNOUSoZ8IPokBAIonoVVgoaie[olfOJooFY6oogZ]donBaN_oHYW7o
c9a[okbAI?nYPecoVgaMohmiHOn3M67oNG5VofeZHOm`L6SoKW1Uohj<OooQ
g/gomNkKojZTSP0Eon_[j`07on[Zj_oYjNWoj>SXonGUiOoQhN7ofm_Kojn_
[`05ooooo`0=ojn_[ooKfm_ohN7QonGUiOn9RHWoRXZ:oi6ATOnCTi?oUiNG
oi:BT_n7QhOoRHV9ohZ:RP03ohb<S003ohf=SOn>SXkoSHf=00;oS8b<00Wo
R8R8ohF5QOn7QhOoRHV9oh^;Ron>SXkoSHf=oi>CTonDU9@00_n>SXh01_n@
T93oTI6Aoi:BT_nCTi?oTY:Boi6AT@;oQXJ600?oRh^;oiBDU?nDU9@00_nF
UYH00onCTi?oU9BDoiJFUP04oiJFUP05oiBDU?nEUIGoUYJFoiNGUonFUYH0
0_nEUID00onFUYKoUiNGoiJFUP02oiFEU@06oiJFU_nGUiOoUYJFoiJFU_nG
UiOoUYJF0_nEUID2oiNGU`06oiJFU_nEUIGoUIFEoiNGUonIVIWoVYZJ0_nK
Vi/02OnLW9coWYjNoinOWonMWIgoVi^KoiVIVOnGUiOoUIFEoiBDU002oi>C
T`07oi6ATOnBTY;oTY:BoiNGUonTY:CoYjNWoi^KV`0Fon_[j`07on[Zj_oY
jNWoj>SXonGUiOoQhN7ofm_Kojn_[`3oooooogOooooo0005onk^kP1Soj>S
XooIfMWoh>3PobXY9oli>COo?Cdkodi@COmMGe[o@T@oobl`:?l`<ROoBDXl
oeED@?mFE3goEe<hofQQA?mjLE3oN6i;ofYUB?mVJ5goB4i:ob`a:olh>C?o
CDY1odm9>omICScoI5E0ohIbF_nCOFGoL5a4ofmMAomdIE;oMVeLoh=mLOn1
Og;oOGi`ofa]Gol[;1ko9RLIocXh:omfLfCoQWm]ohn4L?n>OfSoQgILohah
GOn@OEooSgiPoi>4IonDQV_oTX=ToiMoFonRQV7oYXUWoj64I?nKOF7oVWmT
oin3KOnSQg7oXhMboj24KonJOVSoWH5[ojV;Lon[SG?oYhU]ojJ9JonTRfco
Xh]Yoj:8IonSQVKoYXEVojB3I?nVQFKo[Ha[ojF7HOn^TFWo_YieolRVNOo:
Y7Ood:EhomZ^OooS]HCoiKF4omVYN?o9WFko_9=Woj^8H?nOPV3oTWeRoh9c
G_mjLf?oMG=Vog5cJ?mdMV_oQhMkojJTUOn]ZYWoW9V601Gojn_[00Ooj^[Z
onWYjOoWinOoiNGUon3Ph?oIfMWoXj>S00Gok^k^00goXj>SomWIfOoPh>3o
iNGUohJ6Q_n9RHWoRXZ:ohf=SOn?ShooRh^;ohN7Qon8R8SoS8b<00?oSHf=
00SoShn?oi:BT_nBTY;oT92@oi6ATOn<S8coQhN7ohV9R@;oS8b<00CoSHf=
ohj>S_nCTi?oUIFE0_n?Shl03OnATI7oTY:BoiBDU?nEUIGoU9BDoi6ATOn7
QhOoQXJ6ohV9ROnCTi?oUIFEoiJFU_nEUID00_nDU9@2oiFEU@?oUYJF00Go
UIFEoiNGUonGUiOoUYJFoiFEU@02oiJFUP?oUiNG00CoUIFEoiJFU_nHV9So
V9RH1onGUiL01_nFUYKoUiNGoiRHV?nGUiOoV9RHoi^KV`?oW9bL00WoWYjN
oinOWonOWiooWIfMoi^KVonIVIWoUiNGoiJFU_nEUID00onCTi<01_nBTY;o
Ti>CoiJFU_nKVi_oW9bLoiVIVAKojn_[00Ooj^[ZonWYjOoWinOoiNGUon3P
h?oIfMWoXj>S0?ook^k^Moo^k^h000Goi^KV03_oWIfMomOGeooOgmoo92@V
oc8c=Olb=3?oC4i=oe9DDOlg?3Ko=CP_ocXl;om6AcOoF5M2oemN@_mRGd3o
M6i:ohInEon7OUGoOGEAogEbHOmEED_o>SP/odE1=OmKE4CoI5U7ofaMB?m^
FT7oO6A8ohmfF?miGdCoOVU>oge[DomlKESoP7ATogA^G_m`KUooIfQJoc/m
<?lX:Qoo<C4Wof1PE?mnNVkoQ7i^oh9gHon6Mf3oR7QNoh]jG_n:NekoSGiQ
oi22Ion<OV7oT81Ooi^8IonOS6_oVhIWoiJ1H_nHP6CoVX9XoiV1I`02oiQn
I@0VoiIlHonJP6OoXHM/oj26JonMQ6KoWhQYoi^6JonIQ6WoWXIZoj:8KOnO
QF[oX8EXojN>L?n`UgSoZ95aojnHM_nlYX7o`ZZ4ol2TOoo7YX?odk6<omRe
Soo?[H3oaZAfokjLK_neUV[oZhiToj69HonCP63oPG=HogadGomdKUkoLFmR
ogilL?n:QW[oS8Ijohj4N?nES7dEon_[j`07onWYjOoXj>Soi^KVon?ShooP
h>3oemOGoifMW@05onKViP05oifMWOoGemOogmoOon?Shon6QXH00_n8R8P0
0on<S8coSHf=ohV9R@02ohV9R@05oh^;Ron>SXkoShn?ohn?SonATI400_nD
U9@01_nCTi?oTY:Bohf=SOn9RHWoRXZ:ohj>SP?oShn?00?oTI6AoiBDU?n@
T9000onBTY802_nCTi?oTY:Boi:BT_nATI7oRHV9ohJ6Q_n7QhOoShn?oiBD
U?nEUID5oiBDU0CoUIFE0_nGUiL00onFUYKoUIFEoiJFUP02oiJFUP?oUIFE
00GoUYJFoiNGUonGUiOoUYJFoiNGU`02oiJFUP;oUiNG0_nFUYH01?nHV9So
VIVIoiRHV?nIVIT4oibLW009oijNW_nOWiooWIfMoibLW?nJVY[oVIVIoiRH
V?nGUiOoUIFE00;oTi>C0_nBTY801OnDU9CoUYJFoiJFU_nFUYKoUiNG01Ko
jn_[00OojNWYonSXj?oVi^Kohn?Son3Ph?oGemOoWIfM0?ooi^KVMooVi^H0
00Gok^k^02ooXj>SomcLg?oRh^;o@40noc<d;ole=c;oADM2odi@Bom;D4Wo
>3/`oca0<_m6BCSoFUa7ofMWCOmXIdWoLVe=og]eDOmlM4ooMg5?ofeXE?mF
D4;oAd4coeQA@OmZGdgoLFAAoge[DomlIdcoP6M9oi=hF_n1ITWoQfeBoh5]
E?mlK5GoNfiKofQQCom:AcSoBDTmocHh;Ol[;RGo>3/doeQIDOm`L6KoKF]L
ofiWEOn0MF7oR7YPohalHP02ohamH003oi21I?n:O5ooSH9R00;oT8EU00Go
SH1PohelG_nBOf7oUH9RoiJ1HP02oiN0H@0VoiAmG_nEOUooUh1QohmjFon<
MeSoSgaNoi>1JOn:N6;oT7aToi^7K_nNR73oWhY_ojJAM_nZUgWoZ9MiojZI
NondYHKo]ZF7ojnLO_neWH7o`:J;ol2UQonlXg_o^J5eokRPM?ndWG7o[II/
ojFBJ?nFQV;oPgIFogabEomdK5OoP7UWohV2L_n6OFkoU8Iioj:BQOnLRWhE
on_[j`;oj^[Z00Goj>SXonKVi_oRh^;og=cLoj>SX`05onk^kP05oj>SXooL
g=coh^;RonKVi_n:RXX00_n8R8P01on;Rh_oSHf=ohb<S?n9RHWoRXZ:oh^;
Ron>SXh00_n@T9002?nATI7oTi>Coi>CTonBTY;oTI6Aohf=SOn:RX[oSHf=
0_n@T9001OnBTY;oTI6Aoi6ATOnDU9CoTI6A00CoTY:B00SoT92@oh^;Ron;
Rh_oRHV9ohN7Qon9RHWoSXj>oi:BTP;oTI6A00?oTi>CoiBDU?nDU9@00onE
UID02?nDU9CoUIFEoiJFU_nFUYKoUIFEoiBDU?nEUIGoUYJF1_nEUID2oiBD
U0;oUIFE00?oU9BDoiFEUOnGUiL00_nGUiL01?nHV9SoVIVIoiVIVOnIVIT2
oi^KV`;oVYZJ0_nLW9`3oi^KV`04oiZJV_nIVIWoV9RHoiJFUP;oTi>C00Oo
TY:BoiBDU?nEUIGoUIFEoiJFU_nHV9SoUiNG01Kojn_[0_oZj^X01OoXj>So
i^KVon;Rh_oLg=coXj>S0?ook^k^Moo^k^h000Gooooo03_o[jn_omcLg?oR
h^;oB4Tiod=4=?m:CCcoCe=4odeA@omFFTco>d4coc@k:om8C3goCe=2oe5D
@Om@DSgoEE@ooeEC??mACcKoDdhhodm:=omBBc_oDd`lofELBomfJeWoOFiI
ohIdG?n8LeSoTg]Ooj27JOn9L5;oSGEIohMcF_n4M5goPWERofYSDOl^:Qko
;BlTobDX8OlZ;bSo>ChhodU>AomCETgoCdm3oeeGBOmjLUooQWYRohinI?n>
Of;oSGaPoi:1IOn;OF3oShUYohb7Ion9Pf?oQgiMohUlG?n=OUgoUH9QoiR5
I003oi5mG00UoiR4HonNRVWoUhASoi5nGOnAP6;oTX9[ohIeHon;NVKoVHMa
oiZ6K_nGQVcoWHaboij?L_nQTgKoWI9fojJMP?nWWH;oW91hoj>BO_n/VXKo
YYAlojVIMonZVgCo/9ifojnNLon[VVooZYU^oj2AJ?nAPekoSX5QohYnI?n?
PfgoTX=`ohelJ_nGPW7oX8Uioib2L`0Eon_[j`;oj^[Z00Goj>SXonKVi_oR
h^;og=cLojn_[`05ooooo`07ojn_[ooLg=coh^;RonKVi_n;Rh_oRXZ:ohb<
S002ohf=S@04ohj>S_n:RX[oRHV9ohb<S0GoSHf=1On<S8`00on?ShooTY:B
oi:BTP02oi>CT`04oiFEUOnGUiOoTi>CoiBDU0?oTi>C00coT92@ohJ6Q_n7
QhOoQXJ6ohN7Qon9RHWoS8b<ohj>S_n<S8coSXj>oi>CTonDU9@5oiFEU@;o
UYJF00CoUIFEoiBDU?nDU9CoUIFE0_nFUYH3oiFEU@03oiJFU_nGUiOoUYJF
00;oUIFE00?oUYJFoiBDU?nDU9@00onFUYH01?nGUiOoV9RHoiRHV?nHV9P2
oiZJVP;oV9RH00CoVYZJoiVIVOnIVIWoVIVI0_nJVYX2oiVIV@04oiRHV?nE
UIGoUIFEoiFEU@;oUYJF00CoUIFEoiJFU_nGUiOoUYJF5_o[jn/2on[ZjP05
onSXj?oVi^Koh^;RomcLg?n_[jl0oooooomgooooo`001Oo^k^h0>onSXj?o
g=cLon;Rh_mQH4;oHf96odm?=OmADc_oDE@oof5VD_mEG4[o=C`/od59>_lg
?c;o:C4TobH/8?l]<2Go:bhSob@V6olS8aOo;bdPodU6=omCD47oHee?ogUb
H_n1N6OoQGQUoh=dGOn;NF7oUh=Zoh5]E?n8MUkoQ7EPogmdH_mhLF7oFUI:
ob@T6_lZ:b?o8RLQobhd<?l]<boo;C@]oc4f;olj?37oEeA5og]cH?n8O6Co
SWiTohelH?n;N5[oTWmQoh]lGOnAR6WoShUYoi68JOnBQfOoThASoi>0GonD
P5goUX1K00;oUgmK02KoVX9NojF=JOn_UgGoYXm]oiN3H?nBOeooUH5YohUg
HOnDP6SoWXYaoiN2IonAO5ooUX=UoiV8J_nHRF[oThQZoibCM_nNU7WoUHUc
oib=N_nTTh7oVXUeoiR9K?nKS6_oXY9^ojJDK_nWUFgo[I]cojjLM?nTUFko
U8ISohn2H_n3ME[oRg]Roj6?MonORG;oUWeWoj>8LaGojn_[0_oZj^X01OoX
j>Soi^KVon;Rh_oLg=coXj>S00Gok^k^00CoXj>SomcLg?oRh^;oi^KV0_n?
Shl02_n<S8coSHf=ohf=SOn@T93oSXj>ohV9ROn;Rh_oRHV9ohN7Qon6QXH2
ohN7Q`07ohJ6Q_n5QHGoQhN7oh^;Ron=SHgoShn?oi>CT`02oiBDU005oi>C
TonDU9CoUYJFoi:BT_nDU9@00_nCTi<00onBTY;oSXj>ohF5Q@02ohJ6QPCo
R8R800CoRHV9ohf=SOnCTi?oU9BD0_nEUID00onDU9CoUIFEoiBDU005oiJF
UPGoUIFE00coUYJFoiRHV?nIVIWoV9RHoiJFU_nEUIGoUYJFoiBDU?nEUIGo
UiNGoiJFU_nEUID2oiJFUP04oiNGUonFUYKoV9RHoiRHV0;oUiNG00CoVIVI
oiNGUonGUiOoUiNG0_nHV9P03?nIVIWoVYZJoiZJV_nHV9SoUYJFoiFEUOnC
Ti?oU9BDoiRHV?nGUiOoUIFEoiNGUaKojn_[0_oZj^X01OoXj>Soi^KVon;R
h_oLg=coXj>S0?ook^k^Moo^k^h000Goi^KV06?oWIfMom_KfooRh^;oL6]5
ofaX@_mXID;oFeXkoeIF>_mRITooGV=?ocm8=om1Bd3o?DQ0oadX8_l?6QKo
6bDToaPR8olD7Qoo6R<RoadR7?lf>C;oB4]4of1SG?mMH5WoHV=KofERFOmU
HEGoL6QKohR1LOmWH53oHee?ofIREomOGeOoEUUBodM<A_lR9Ako92HQob@Y
9OlY;bgo;C<aobX`;?l`=Bko@T@gofi[F_moMf;oSX1Voi:1IOnGQ6CoWXUZ
oif8JOnFPf?oUXMZoiN8JonIR6[oW8MXoi^4I?nKPF3oXXAPojV8IOn]RfKo
WWaGojB2GoniV7Go^IQgojJ8I_nJOE_oV7iMoif2IOnNQ6WoUgaOoj:5IonV
QfSoVWeKoi^1G_nJPUcoUH5Loin=JOnTU7;oWhm^oiN6J_nGPf[oVXI^oij8
LOnUSgOoX8Q^ojB=K_nUS6goYXiZojNAJ_nRSfOoYYA^oib>JOnBQF;oSH1P
oi23HonHRF[oW8]]oi^8J_nHQFL05Oo[jn/2on[ZjP05onSXj?oVi^Koh^;R
om_KfonMWId01OoVi^H01OnMWIgofm_Kon;Rh_oVi^KoTI6A00;oT92@00Co
SXj>ohf=SOn@T93oShn?0on;Rh/01On6QXKoPh>3ohF5QOn5QHGoQ8B400;o
QHF500CoRHV9ohb<S?n@T93oShn?0on@T9002OnATI7oUIFEoi2@T?n?Shoo
T92@ohn?Son>SXkoS8b<ohF5Q@02ohJ6QP07ohN7Qon8R8SoQhN7ohR8R?n:
RX[oTI6Aoi>CT`02oiFEU@03oiJFU_nGUiOoUiNG00SoUYJF00CoUiNGoiRH
V?nEUIGoUYJF0_nJVYX00onGUiOoUIFEoiFEU@02oiJFUP04oiFEUOnGUiOo
UiNGoiFEU@;oUYJF00CoUIFEoiNGUonHV9SoV9RH0onFUYH00onGUiOoV9RH
oiNGU`06oiRHV004oiNGUonFUYKoUIFEoiFEU@?oUiNG00?oUYJFon_[joo[
jn/05?o[jn/2on[ZjP05onSXj?oVi^Koh^;Rom_KfonMWId0oooVi^IgonKV
iP001Oo^k^h0>_nSXj?ofm_Kon;Rh_mmLDOoNW58og9Z@om^JTGoNgMJoh:2
J?mdMfCoH6MGod5;@_liASoo72/Xoa<Q8_lB82?o2QTNo`lN9OlC7R;o5QlN
ocLm>Om;DDooCE=AodmEDom?EE7oADM2oe9CCOmJFU3oM79VoeAAB?m?CdGo
DeA>odiCCom5CTgo>T=2oalU8OlP9B7o8bTWoble<old>SSo:C0Yoc<f;OmA
Cd;oPGYWoh]oIonFQFWoWHQYoj29IonOR6KoWhMUoij7IOnFPF;oW8MXoj6:
J_nOQfGoWH=Poj63GonWQF02ojZ7H@0WojJ3GOn]Qf;o/XiZojb8I?nTPUgo
YHAQojR:J?n[SVkoY8MWoi]mFonVQF;oZXUVojB4G_nWRV;oXXINoij7G_nP
SFGoXXiYoib:I_nFPF;oUX5Toij6K?nSRg?oY8Ycoj67K_nURg3oWXEVoi^3
HOnUSf[oYY9]oj>CKonTUgCoVY1]oi:7IonAQVKoUXUYoib=K?nPT6koYI9a
01Gojn_[00Ooj^[ZonWYjOoXj>Soi^KVon;Rh_oKfm_oXj>S00Gok^k^00Co
Xj>Som_KfooRh^;oi^KV0_nBTY82oi6AT@07oi>CTonEUIGoTi>Coi2@T?n;
Rh_oRXZ:ohJ6QP02ohB4Q005oh>3Pon4Q8CoQ8B4ohB4Q?n9RHT01?n=SHd0
1_n;Rh_oSHf=ohj>S_nBTY;oSHf=ohb<S0;oSHf=00goS8b<ohZ:R_n5QHGo
QHF5ohJ6Q_n8R8SoRHV9ohN7Qon8R8SoSHf=oiBDU?nEUIGoUYJF00GoUiNG
00CoUIFEoiJFU_nGUiOoUiNG0_nFUYH3oiNGU`05oiJFU_nGUiOoV9RHoiNG
UonFUYH00_nGUiL00onHV9SoUiNGoiFEU@02oiNGU`04oiJFU_nGUiOoUiNG
oiJFUP?oUiNG00?oUIFEoiJFU_nGUiL01?nGUiL2oiJFUP?oV9RH00?oVIVI
oiNGUonFUYH00_nFUYH00onGUiOoV9RHoiRHV00Fon_[j`07on[Zj_oYjNWo
j>SXonKVi_oRh^;ofm_Koj>SX`3oonk^kWOok^k^0005ooooo`0jojn_[ooK
fm_ohN7Qogm]AOn<OEKoSX9Loi26HonFTGCoQH=ZofMXE_mJHE7oAe58oca9
@_lJ:BKo4b<So`hM8?l661[o4R@Xo`hL7OlH7Qco=cTdod]@C?m;DDgoD5ID
oe5GDomCEE3oCTm9oeiNE_mfMVcoEEE=odm@B?mBE4ooC59>odI?C_ljA4?o
7RLVob0V9?lS;2_o<CLeobhd<?lV:B;o@T8fogagI?nBR6ooU8EXoi^7I_nT
S6SoY8YUoin3G?nLPe_oXHMRoj69IOnVT6_oZI5]ojJ<IonTR67oZ8YTojf=
IP;o[XeT02Oo/8mVokFBJ_n`SVSoZ8IPojb<IOngUg7o^YahojbBKonQQfKo
WX5OojN9IOnVQF;oXh=MojR:I?nSQf3oYHiUoj>@J?nSSf[oWXaXoiV6IOnI
Q6GoXXY^ojZBN?nWSgGoWXIZoj:;K?nJPfCoUGiNoin;J_nUTW7oXiAcoifB
M?nIT7?oV8mboibAMOnSU7OoYiIhojfHNOnbVg/05Oo[jn/01ooZj^[ojNWY
onSXj?oUiNGohN7Qom_Kfon_[jl01Oooool05_n_[joofm_Kon7QhOoUiNGo
TY:BoiBDU?nEUIGoUYJFoiNGUonEUIGoT92@ohn?Son<S8coRh^;ohJ6Q_n5
QHGoQ8B4oh>3Pon5QHGoPh>3ohB4Q?n9RHT3ohf=S@06ohj>S_n=SHgoSHf=
ohn?SonCTi?oSXj>0on=SHd01On<S8coRXZ:ohJ6Q_n5QHGoQXJ600;oR8R8
00?oQXJ6ohZ:R_nCTi<00onFUYH2oiNGU`;oUYJF0_nGUiL2oiRHV0?oUiNG
1?nHV9P01?nIVIWoV9RHoiNGUonHV9P2oiZJVP03oiRHV?nGUiOoUYJF00;o
UiNG00?oUYJFoiNGUonGUiL00onHV9P01_nGUiOoUYJFoiJFU_nGUiOoVIVI
oiRHV0;oUiNG00?oUYJFoiFEUOnGUiL00onHV9P2oiNGU`;oV9RH0_nIVIT0
0onJVY[ojn_[on_[j`0Don_[j`07on[Zj_oYjNWoj>SXonGUiOoQhN7ofm_K
ojn_[`3oooooogOooooo0005onk^kP0Soj>SXooIfMWoh>3PohYdCOnNRVGo
ZIMcoin@Kon9P6?oJ69:odm>>_m9BcgoEEeBodaFC_lM:BGo3QdJoa4O7ol<
71co5BDUo``H6?lK7ASoAdI1oeIGDOmADdkoDeE@odQ:AOmKG5OoEEA?of9O
F?mkN6ooFEI=oe9BB_mDEDooDE=@od]ACom1BTT00_lR:R`03_lU;Rgo;3Db
ob`a:ol/;R?oEeA3oiJ>MonQTWGoX8a[ojB:IOn/SfOo[hmVojZ:HOnWRV3o
ZHiS0_n]U6/0;_n/Tf[oZY9VojVAIOn/TFKo[I9Wok2CJOn_TVSo/Y9YokFE
K?nbTVWo[I1VokBGKOnmX7Ko^imgojfELOnTS6[oZi5^okBGMOnYRfOoYHMS
ojf?JonZSVWoYhmYojJCJonXUW3oYiEaoj:@K?nOS6_oYI1aok2IN_naVW[o
WhQXoj29JOnKQfKoU7mPoiN6J?nGR6_oThM]ohMoJ?n5OFSoQWiYoi25KonJ
RgCoWXecoij9K_nNQVXEon_[j`07on[Zj_oYjNWoinOWonGUiOoPh>3ofMWI
oj>SX`05onk^kP0:oj>SXooIfMWoh>3PonGUiOnCTi?oUiNGoiVIVOnHV9So
UIFEoi2@T0;oS8b<00?oSXj>ohf=SOn6QXH00_n4Q8@01_n3Ph?oQHF5oh>3
Pon4Q8CoRh^;ohj>SP;oSHf=00SoS8b<ohn?Son=SHgoShn?oi>CTon>SXko
SHf=ohj>SP;oSHf=00GoRh^;ohJ6Q_n6QXKoQhN7ohR8R002ohN7Q`03ohf=
SOnGUiOoV9RH00;oUiNG0_nHV9P2oiNGU`03oiRHV?nIVIWoVIVI00GoV9RH
1OnIVIT02_nHV9SoVIVIoi^KVonKVi_oVIVIoiNGUonHV9SoVIVIoiRHV?nG
UiL4oiRHV0;oVIVI00?oV9RHoiNGUonHV9P00_nJVYX2oiNGU`03oiJFU_nE
UIGoUYJF00;oUYJF00CoUIFEoiBDU?nEUIGoUYJF1?nGUiLFon_[j`07on[Z
j_oYjNWoinOWonGUiOoPh>3ofMWIoj>SX`3oonk^kWOok^k^0005onKViP0@
oifMWOoGemOogmoOoj>9I?nYTFgo[iQfoif:J_mkKE3oJ5i5of5LB?mHETOo
H69EoeiTF_l/<b_o51dHoa/V8P;o62<O01go51XFobHR6Om?AccoKfQNofAP
EomPGEKoEE9;oe=@BOmEDDSoHEY@ogYcJOmKDdSoEDi4oeMCB_mCDTgoDU=>
odU>B_lT;2ko8R`^obH`<Ol/=C;o<3D^ocm0<_mXHDkoU8I[ojB@KonUS6Co
YhYNojj=H002ok>AH`0<ok:AI?n`TF?o/YMXoj^CHonZTV;o[iMWok:JJ_n^
V6Oo[9IUojfGJ?n^V6Wo[IEW0_n`V6X09?n_U6Oo/IIYokFJKOnbVVkoZYM_
oj2<JOn/UG?o]9ajoj^AK_n/Sfgo/IAbojfCL?nYTfko[9QcojnMNOn/W7So
Z9IbojFCKon]VGSo]J5nokRRNonZU6_oY91[oi^7I?nCPf;oTh=Yoh1eGom/
IE?oHf1AoeiJC_mRFe7oLf]Poh]mL?nJRGWoWhYeoif7L1Gojn_[00OojNWY
onSXj?oVi^Kohn?Son3Ph?oGemOoWIfM00Goi^KV00WoWIfMomOGeooOgmoo
hn?SoiNGUonHV9SoVIVIoiNGUonBTY800_n?Shl01On>SXkoShn?oi2@T?n8
R8SoQ8B400?oQHF500KoPh>3ohF5QOn<S8coTI6Aoi2@T?n?Shl3ohf=S@03
ohn?SonCTi?oSXj>00CoSHf=00CoS8b<ohJ6Q_n6QXKoQhN70_n8R8P01?n:
RX[oT92@oiJFU_nHV9P2oiNGU`03oiRHV?nIVIWoVIVI00;oV9RH00?oVIVI
oiRHV?nHV9P02onIVIT2oiZJVP04oiVIVOnGUiOoVIVIoiZJVP;oV9RH0_nI
VIT01onHV9SoVIVIoiZJV_nJVY[oVIVIoiRHV?nIVIT00_nKVi/00onIVIWo
V9RHoiJFUP02oiJFUP07oi>CTon@T93oShn?ohj>S_n?ShooTY:BoiFEU@03
oiNGUaKojn_[00OojNWYonSXj?oVi^Kohn?Son3Ph?oGemOoWIfM0?ooi^KV
MooVi^H000Gok^k^04SoXj>SomcLg?oRh^;o[Y9[ojZAJOnbVWKo[i]joiZ9
JonBQ6WoRX9]ogUdHOm/JU_oIfMKod=4??l^<B[o<SLaoc0e<Ol]<Rko=3D_
od0i;om?Acco^kBZok:^YOmYIUooGeaEoeMDComFDD_oHemFogmhK_mOF4ko
F557oeQEC_mDDdkoDU=>odU=C?lQ:bgo8B`^ob/e=_l[=2oo;2lVoda9>_mm
LUcoV8MYoj28H_nTQe_oZhUIok:>G?ngTF3o^9ARokRDI?ngUFGo]iMTok>C
H?ncUF7o^9eXokfQKonjX6oo]Ii/okBLK?njXWCo]imaokVQLonkX77o]9UZ
ok:FIonfVV_o]ia_ojjIK_nQRf;oZI5[ok>GL_ncUG43okFGL`0HokFKM_nh
X7[o^:9kok:LLon^V6oo/IYaokZSN_o1Z7oo_Z=fokjQMOneVG7oX8QToib7
J?nDQ6goJF1?od<o=?m1@Sco?T0modM9A_mPGe_oO7Maohj6NonCQgWoT8Ec
5Oo[jn/2on[ZjP05onSXj?oVi^Koh^;RomcLg?nSXj<01Oo^k^h01_nSXj?o
g=cLon;Rh_oVi^KoVIVIoiRHV0;oVYZJ00SoUiNGoiJFU_nEUIGoTi>Coi6A
TOn@T93oRh^;ohN7Q`CoR8R800goRHV9ohb<S?nNWYkoWIfMoi6ATOn?Shoo
SXj>ohf=SOn?ShooU9BDohj>S_n=SHgoSXj>00;oSHf=00?oS8b<ohJ6Q_n6
QXH00_n8R8P01?n7QhOoS8b<oi>CTonFUYH3oiNGU`03oiRHV?nIVIWoVIVI
00GoVIVI00?oVYZJoi^KVonKVi/00_nJVYX01?nKVi_oVYZJoi^KVonKVi/2
oiVIV@;oVYZJ00?oVIVIoiNGUonHV9P00_nIVIT4oiZJVP;oVi^K00GoVYZJ
oiVIVOnJVY[oVi^KoibLW002oi^KV`05oiZJV_nGUiOoUYJFoiJFU_n@T900
0on:RXX00on<S8coShn?oi>CT`03oiJFUQKojn_[0_oZj^X01OoXj>Soi^KV
on;Rh_oLg=coXj>S0?ook^k^Moo^k^h000Gooooo03co[jn_omcLg?oRh^;o
[i9VokBIK?o0YgkoaJn8okZWQ_n_X87o[Z::ok2XTonKU8CoMG5Uof1LDomF
DdkoE51=oeACComCDU3oFeMDoe]FD?mWHe[og=WDomcKeomWIfGoD59?oeaN
GOmOGegoIfIRoh60NomRHEcoFeYFoe]KFOmHFUWoEEUJodeEEol/=c_o82ha
obTe=Ol^=33o;c4Voe]F@on<P6KoUH9Qoj24G?nUQEKo/HaHokfEHOnnUV;o
^91MokRBHOo2WFWo_IAPol6FHOnnUF7o^Y9OokZFI?noWFgo`:1aokbMK_o4
YGL2oknPLP0Uol2OL_nnW6oo`9]^ol6LKonjV6[o/9ATojZ>G_ngV6[o_9Y]
okfHK?nmUV_o^95XoknJL?o2X7?oa:=foknPL_nfUfSo]9ITokfMK?o4Y77o
b:AbolJLK?o5VVgo_99Zojf9IOn[SG7oT7]Xoe98?_l/:bKo<CHiobhi?Old
@TGo@U1Aoe5LF?mDGUGoDUQ<odiDAP0Eon_[j`;oj^[Z00Goj>SXonKVi_oR
h^;og=cLojn_[`05ooooo`0?ojn_[ooLg=coh^;RonKVi_nHV9SoVYZJoibL
W?nMWIgoW9bLoiZJV_nKVi_oW9bLoiRHV?nBTY;oShn?00CoSHf=0_n>SXh0
1On@T93oY:BTojBTY?nATI7oSHf=00;oShn?00GoT92@oiFEUOn@T93oSXj>
ohn?S`02ohj>SP03ohf=SOn8R8SoQhN700;oR8R800?oQhN7ohj>S_nEUID0
0onFUYH00onHV9SoVIVIoiZJVP02oiVIV@03oi^KVonIVIWoVYZJ00?oVIVI
00CoVYZJoi^KVonJVY[oW9bL0onKVi/2oiZJVP04oi^KVonJVY[oVIVIoiRH
V0CoVYZJ00?oVIVIoiZJV_nKVi/00_nKVi/2oiVIV@0CoiZJV_nKVi_oW9bL
oi^KVonJVY[oVIVIoiNGUonHV9SoUIFEohb<S?n7QhOoR8R8ohV9ROn:RX[o
S8b<ohj>S_n?ShooSXj>ohf=S@0Fon_[j`;oj^[Z00Goj>SXonKVi_oRh^;o
g=cLojn_[`05ooooo`06onOWiono_kooShn?of][JomHF5SoDE5APom@D500
1_mADE7oF5QHof][Jon?Shoo_knoonOWin;ooooo0005onk^kP1>oj>SXooL
g=coh^;RokFOM_o0[HGo`k6=okb^RonbY8OoZIf3ol:jXoobjmSod/bnohV3
MomgL6SoMVmYof]VH_maK6WoKfUYofmZIomaIfGoMFiXohInNonLUiCoOGUf
of]WI?m/J6GoJFIQog9]JOn=RX?oL6eXofYYI?m[KF[oJFe/ofY`L?mTK6ko
ADiCob@]<_lS;Bko<cTgod13>_m^K5ooRX=`og5UBon;Ne[oSWYEoif6GOn]
U6_oZI1Woib3FonPQV7o/YQcojnBJ_nhV77o/I5[oin1GOnMP5ko[99aokFL
OOn`VGWo/iamojZEM_nYTW?oZiAeokBINonkX8;o]iQioj>9J?nFPUgoWHUT
ok>KMOnbV7?oZY1]oj67I_nKPF3oZi=aokRNNonkXGko/ief0_nWU6`04onb
WgGo^:5gokJJL_ngUg7o[Xe/ojF6JOnXS7CoZiJ3oge_H_lk=2co9BDSobTa
=?lT<COo9C@kobLi?OlZ>S[o:CTfob`i<_l]>S405Oo[jn/2on[ZjP05onSX
j?oVi^Koh^;RomcLg?nSXj<01Oo^k^h01OnSXj?og=cLon;Rh_oVi^KoVYZJ
00?oWIfM00KoVi^KoiZJV_nNWYkoYjNWoj:RX_nEUID2oi:BTP03oi6ATOnB
TY;oTI6A00;oTI6A00CoTY:BoiFEUOnIVIWoU9BD0onATI402OnBTY;oUiNG
oi:BT_nATI7oTY:Boi6ATOnBTY;oTI6Aohb<S002ohN7Q`05ohV9ROn:RX[o
TI6AoiFEUOn@T9000_nDU9@00onFUYKoVIVIoiRHV002oiJFUP;oVIVI00Go
VYZJoiVIVOnFUYKoUYJFoiVIV@03oiZJVP0BoiVIVOnHV9SoVIVIoiZJV_nK
Vi_oVYZJoiNGUonEUIGoUiNGoiZJV_nIVIWoV9RHoiNGUonFUYKoVIVIoiZJ
V_nKVi_oVYZJ0_nHV9P02onJVY[oVi^KoiZJV_nJVY[oV9RHoiNGUonHV9So
VIVIoi:BT_n8R8SoQXJ600;oQhN71_n8R8PFon_[j`;oj^[Z00Goj>SXonKV
i_oRh^;og=cLoj>SX`05onk^kP04olC4a?n<S8coVIVIom[JfXOooooo00Co
f][JoiVIVOn<S8coa<C4h_o^k^h000Goi^KV06?oWIfMom_KfooRh^;o^K>K
okF_Uon^ZIGo[JbHoj^/V_nRXi?o/;6Som7Ba?o=bkooX9jBoiB=PonITX[o
Xi^Hoj^SXOnYXj?o^[:`olJf]_o?_K_of/S4on7?booSd<WohLo5on3>a?oQ
cl?og<boon?GbOohl>?on_KZoooom_oloOGonOkgon[_jom`M7Oo4aHKobX]
<_lQ9RWo@4I6odiDD_m=E4goATe5odiFBomWKF7oHFMIofEYFom]LF?oCe54
oeQJComjO77oIfUNofi^I_mZJV;oD4e6oeYGD_mYIV7oMg=`ofYYIOmdMG3o
Ce1;ode>BOmWJ6?oLfm/ogYfLom^IVCoGEYEodU?AOmIGe?oO7Y^ogQdJOmh
NVooEE]AodeEB_m`N6goOgmcoiFCQ_n2Q7OoK79TofE`H_mjQGGoR8amoh63
MOmoPGKoL75YofMXH?n0PG_oOGihoeUJEOlU9B?o5QPGoaPM8?lI8B?o5R0R
oaPR9?lK9R[o5b8Voa<N8_lH8bD05Oo[jn/2on[ZjP05onSXj?oVi^Koh^;R
om_KfonMWId01OoVi^H01?nMWIgofm_Kon;Rh_oVi^H2oifMW@?oW9bL00So
VYZJoifMWOnRXZ;oXJ6QoiZJV_nGUiOoV9RHoiZJVP;oVi^K00CoWYjNoinO
WonPX:3oXZ:R1OnSXj<01OnRXZ;oY:BTojRXZ?nXZ:SoZZZZ00;oZJVY00Ko
YjNWoi>CTon3Ph?oQhN7ohJ6Q_n;Rh/2ohf=S@0Xohb<S?n=SHgoTI6Aoi2@
T?nATI7oTY:Bohf=SOn>SXkoU9BDoi6ATOnBTY;oTI6Aohb<S?n>SXkoTI6A
oi>CTonATI7oTi>Cohf=SOn<S8coTI6Aoi:BT_nCTi?oTI6Aohn?Son<S8co
Shn?oiBDU?nCTi?oU9BDohj>S_n=SHgoTi>CoiBDU?nHV9SoUIFEoi:BT_nA
TI7oUIFEoiJFUP;oUIFE00[oTY:Boi6ATOnEUIGoU9BDohj>S_n6QXKoPh>3
ohB4Q?n5QHGoQ8B40on5QHD00on4Q8CoQHF5on_[j`0Eon_[j`;oj^[Z00Go
j>SXonKVi_oRh^;ofm_KoifMW@05onKViP03ojb/[?nOWioom?Cd08Wooooo
00?om?CdoinOWon/[:`0h_oVi^H000Gok^k^06?oXj>Som_KfooRh^;oYZJJ
oj^]X?nYZj3oY:ZPojBYX_nLXi_oWjFKojnbZOoQhmSok>cPooooloooooKo
oogiooomn_olnoWoo?Sgookem_oom_GoooSfooojm_oon?7oooS_ooogkOoo
nNkoooc`oooejOoooO7ooO__oocmmOodnO;onookoocooOnWYJKo3PT=ob4O
8_lB4aGo7R8SoalU9Ol^>3Oo;c/iob@c<?lS<Roo:3Ldob`h=_lkAdOo9Bl`
obTa<ol/=SOo930`oahZ:_lh@T?o<CTkoadR9Olb=SWo;S4fob`a=Ol]=CSo
=d53obD]<?l`>3_o;c@hoc0c>?l^;cCo<cHkocLl?ol/=CCo:Bl_ob<Y:OlY
<S7o=3hmocE1?olX<S7o;SLdocDn>ol^=cCo:C@`obTe<Ol/>3Co=40loc@o
>old@3ko=T90obli>?l]=S?oA4U5oc8d;olV9b7o<S<]obTZ9OlO81_o92HS
obT];?lP9BSo72@Wob0Z;?lM9bT05Oo[jn/01ooZj^[ojNWYonSXj?oVi^Ko
h^;Rom_KfonSXj<01Oo^k^h01OnSXj?ofm_Kon;Rh_oVi^KoVi^K00;oW9bL
0_nKVi/01OnJVY[oVi^KoifMWOnUYJGoYjNW00CoZZZZ3?nYZJT01?nZZZ[o
ZJVYojVYZOnYZJT2ojZZZP04oi^KVon1PH7oQHF5oh>3P`;oQHF500CoR8R8
ohV9ROn7QhOoQhN70_n8R8P02On;Rh_oQhN7ohN7Qon8R8SoQhN7ohJ6Q_n:
RX[oRHV9ohF5Q@02ohR8R004ohN7Qon8R8SoRXZ:ohN7Q`?oR8R800coQhN7
ohR8R?n9RHWoR8R8ohN7Qon6QXKoQhN7ohV9ROn:RX[oQhN7ohR8R?n9RHT4
ohR8R0;oRHV90_n:RXX2ohR8R008oh^;Ron8R8SoQXJ6ohR8R?n6QXKoQHF5
ohJ6Q_n7QhL2ohF5Q@;oQXJ65_o[jn/01ooZj^[ojNWYonSXj?oVi^Koh^;R
om_KfonSXj<01Oo^k^h00onXZ:Sob/[:oo?cl`28ooooo`04ookno_obl_;o
bLW9ojRXZ>;ok^k^0005ooooo`1Sojn_[ooKfm_ohN7QoifLUonSY9koYjRS
ojFZY?nRYj7oVZ6JoifRVon[[ZGojngRoocnlOooooKomoO]oo7bk?oinoSo
o?ooooKnooodoooolooooo;moooaoOgom?glooSno?oioOconOkjoo[onooe
nOSonOomooOoooohoooolokoooGoooo`n?[oSHN7oc/a;olf;R_o:RDQoa<@
2omXIf;oVIZEodU;A_lS9B3o828MoaHG4_mNGEWo^;BcohZ6QOlU7aoo9R<N
oaPJ3olj?2ko`L:dolG3]_l[9aco8AdBobTU6_l]:aoo];BXoloAa?m@D4Ko
6QX@oaPH3_lP7ACo[:FMonSOf?n6Mg3o91TCoahO6_lX:RGoU8n9onGKd_nM
S8Co8aH>obPW8_lP8QgoS8^6onCMeonRU8_o:ahEoalN6Ol_<R_oOGecom[H
c?nWXiSo9b4Eod]5>OmYHECoKVMGogaeIOnFT8;oDDe1od0n<_mDE4[oBTe4
oca1>_ll@cco<S`d01Gojn_[00Ooj^[ZonWYjOoXj>SoiNGUon7QhOoKfm_o
[jn_00Gooooo00Go[jn_om_KfooQhN7oiNGUoiVIV@04oi^KV`;oVYZJ00Co
W9bLojNWYonYZJWoZZZZ0_nXZ:P00onYZJWoZZZZojVYZ@07ojVYZ@;oZZZZ
00SoZJVYojZZZ_nZZZ[oZZZZojVYZOnZZZ[oZ:RXoiJFUP;oR8R800GoQXJ6
oh:2P_nATI7oVIVIohb<S002ohF5Q@04oh>3Pon?ShooWYjNoiJFUP;oQHF5
02goQ8B4ohV9ROnPX:3oX:2PohJ6Q_n4Q8CoQXJ6ohN7QonMWIgoXZ:Rohf=
SOn4Q8CoPh>3ohB4Q?nKVi_oYJFUoiBDU?n4Q8CoQHF5ohJ6Q_nGUiOoY:BT
oiRHV?n4Q8CoQXJ6ohF5QOnGUiOoYJFUoiVIVOn5QHGoQ8B4ohR8R?nDU9Co
Xj>Soi^KVon5QHGoRh^;oi2@T?nATI7oTi>CoiRHV?n<S8coRXZ:ohf=SOn<
S8`00_n:RXX00on9RHWojn_[on_[j`0Don_[j`07on[Zj_oYjNWoj>SXonGU
iOoQhN7ofm_Kojn_[`05ooooo`04ok2`/?oQhN7ok>c/ooKfmP;ooooo0_o^
k^h01?nZZZ[oEEEEoiVIVOo<c<`2onk^kSOooooo00?oo_knooooooooool0
0_ooool01?ono_koooooooooooono_h4ooooo`04ookno_ooooooooooookn
oPCooooo00Coo_knooooooooooooo_kn1?ooool01?ono_koooooooooooon
o_h4ooooo`04ookno_ooooooooooooknoPCooooo00Coo_knoooooooooooo
o_kn1?ooool01?ono_koooooooooooono_h4ooooo`04ookno_oooooooooo
ooknoPCooooo00Gono_kooOgmoo/k>cohN7Qok2`/03Rooooo`001Oo^k^h0
4onSXj?ofMWIon3Ph?nCSX_oWIVFoj2OVonMWYWoXJ>NojNZXonQY9goUYR=
okBfZOo5ak[oa/Rmolc?a_o=e<go`lk:okc:b_n[^k/00_nS]kP01_nS]KGo
Xk>coj>a/OnU/K7oXjf/oj:[ZP;oYJ^[04KoYJZ]oijSY_nOY:SoXj^^oj:Y
[onHVI_oMg=ZojJLT?mfKV7o6103oa@>0?o?c;gooOW]okFaYOl@2P3o<bdQ
oaD;0_n]X9SoooWbonKEc_lO30Ko=RDKobdQ2omODcWonN_Aoo_[d_m>?2Ko
?2XDoch^5ol`8@[om>G>ooodg?n?Pfgo:Ad7oeI7<_l]7PWoh]2loooeh_nm
Xi;o<ad?od/o<Olc:Q_of/Viooodi?o?]:?o=b0@od`n<Ole;B3o`kFXooo_
hOoG^jgoBS0Qodm1=?lj;R3oakFWoookk?o3/9oo@B`KofE@?OmnK5SoT7iZ
okZYUOoTeL;oSH9`oeiGAomNFdcoC4dooc`n<Om0@c[o@4Hl5Oo[jn/01ooZ
j^[ojNWYonOWiooUiNGoh>3PomWIfOnSXj<01Oo^k^h01_nSXj?ofMWIon3P
h?oUiNGoUiNGoiVIV@?oVYZJ00KoW9bLoi^KVonIVIWoWIfMoj2PX?nQXJ42
oj:RXP03oj6QXOnPX:3oWYjN00CoWIfM1onLW9`02?nJVY[oVi^KoibLW?nK
Vi_oVIVIoi>CTonJVY[oTY:B0_n2PX803OnQXJ7oZJVYoifMWOn1PH7oQhN7
oh:2P_nKVi_oZJVYojBTY?n2PX;oQXJ6ohF5QOn=SHd00_nWYjL0;?n:RX[o
QhN7ohR8R?n5QHGoYZJVojRXZ?nFUYKoQHF5ohb<S?n5QHGoXj>SojRXZ?nL
W9coQHF5ohZ:R_n7QhOoXZ:RojRXZ?nOWiooQXJ6ohZ:R_n7QhOoWYjNojRX
Z?nPX:3oRHV9oh^;Ron8R8SoWYjNojVYZOnMWIgoR8R8ohj>S_nBTY;oUIFE
oibLW?nSXj?oUIFEohj>S_n?ShooS8b<ohV9ROn:RX[oRh^;5_o[jn/01ooZ
j^[ojNWYonOWiooUiNGoh>3PomWIfOnSXj<01Oo^k^h01?nSXj?ogmoOonSX
j?o]kNd2ooooo`0;omgMgOn8R8So4A4AodA4A?lR8R;oVIUVogMgMon8R8So
ZZZZolc<c?o^k^h0<_ooool01Oojn_[on?ShooOgmoohn?Kom_Kf00;on?Sh
00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2ooShn006ooWinOojn_[on?Sh
ooOgmoohn?Kom_Kf0_ohn?P01_oinOWon_[jooShn?ogmoOon?SfooKfmP;o
n?Sh00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2ooShn006ooWinOojn_[o
n?ShooOgmoohn?Kom_Kf0_ohn?P01_oinOWon_[jooShn?ogmoOon?SfooKf
mP;on?Sh00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2ooShn00=ooWinOoj
n_[on?ShooOgmoohn?Kom_KfooOgmoofm_Kom?Cdonk^k_oXj>Soh>3Poj>S
X`3Ronk^kP001OoVi^H05?nMWIgoemOGomoOgonJShgoZ9jLojVQW_nQW9So
[JRRokbi/?nUXYWoNGM[oinMT?nZZigoWZ:DoiNOU?n@WIKoPYFAohBIV_n4
V9OoRiJB0_nBUi401OnAThkoSY6:ohf>R?n;RXKoRXJ300;oTHb904KoU8b9
oi>;R?n>Q8?oThV8oiN=S?nDSHGoPGaVokbkWOn8Qf_oFEPlodI5:OnKVWko
k>S?oiF?MomNDcooJ5]8ofiMCOnCOFooe[naok^OTomhFTooR6]IohQ[COnK
OEOoaZJ0okfKM_n8I4;oTFe;oiEbD_nCLU7o/Y5`ol6SPOnLOeooRfi>oi9c
E_nDLUKoYhAXokRFN_nQQV_oU7ULoiamG_nRPfCoYHY]ok6GO?nfWXKoW8AZ
oieoHonNP6CoXXM/olJ/TonXTW_oYHmhojB:KonWRFoo^iJ3okbFPonZQ77o
WWUVoj=nJonDM5ooT75Moj:7M?nTSG_oSga[ogUYF_mTFdcoE4i2odY8??m7
AcooADHn5Oo[jn/01ooYjNWoj>SXonKVi_oShn?oh>3PomOGeonMWId01OoV
i^H03onMWIgoemOGomoOgooShn?oV9RHoiZJV_nKVi_oVYZJoibLW?nNWYko
VYZJoi>CTonJVY[oW9bLoiZJVP02oiVIV@03oiNGUonHV9SoV9RH00CoV9RH
0_nGUiL2oiJFUPCoUiNG01?oUYJFoiNGUonGUiOoUiNGoiBDU?nNWYkoUYJF
ohj>S_n;Rh_oVIVIojJVY_nGUiOoSXj>ohn?Son@T93oUIFEoj2PX?nKVi_o
T92@00;oTY:B00GoUIFEoibLW?nJVY[oTI6Aoi>CT`02oiBDU004oiVIVOnL
W9coUYJFoi>CT`;oU9BD00WoUiNGoiZJV_nGUiOoU9BDoiFEUOnFUYKoUiNG
oiVIVOnKVi/00onFUYH01?nGUiOoWIfMoiVIVOnHV9P2oiNGU`;oVYZJ00?o
UiNGoiFEUOnFUYH00_nDU9@01_nGUiOoV9RHoiFEUOnBTY;oShn?ohf=S@?o
Rh^;5_o[jn/01ooYjNWoj>SXonKVi_oShn?oh>3PomOGeonMWId01OoVi^H0
3?nMWIgog]kNonKVi_o/k>coooooomgMgOnk^k_o8R8Rok^k^ooooooo<c<0
olbIV@;oc9UV00KoVIUVoiUVI_nIIVKoR8R8ojZZZ_o<c<`2onk^kRgooooo
00Golo?coo;bl_obl_;ol_;boo?cl`03oo;blP05oo?cloobl_;ol_;boo;b
l_oclo<00oobl_801Ooclo?ol_;boo;bl_obl_;olo?c00?ol_;b00Golo?c
oo;bl_obl_;ol_;boo?cl`03oo;blP05oo?cloobl_;ol_;boo;bl_oclo<0
0oobl_801Ooclo?ol_;boo;bl_obl_;olo?c00?ol_;b00Golo?coo;bl_ob
l_;ol_;boo?cl`03oo;blP05oo?cloobl_;ol_;boo;bl_oclo<00oobl_80
3?oclo?ol_;boo;bl_obl_;olo?coo;bl_oalO7ok^k^on_[jooVi^Kog]kN
oifMWN;oi^KV0005onk^kP0Joj>SXooLg=coh^;RojbRXOnYXIoo[:BRok2X
YOn_Z:3o[JBKoinGR_n<Pg;oShMdojFMR?nOV8GoSHYgohF7NOmoQg[oNHIl
ogR2NOmnOW;oQh5cohZ4M_n9PgGoRH=gohj8O?n@RGl2oi27OP17ohIlL_n9
OgGoVXf4ohj2M_n6N6goSX1eoj:FQ_nVWh?oUY5aog9_D?nJUgSoXIioojBQ
P_nc[i;o/Zf@ojBMPon_YHco/jNAokRYU?niZ9Co`:fLokVTToo0ZY?o^Z62
ol:XPoo;[HWod;:>om6`Soo=[8_objb=olb_Soo</Y7ob[6BomFlWOo@]iWo
fL2RomNlWooC]IWof[nTom>nXOoA^Y_of[bJon;1X?oRbJ[od[nQomS8[_oF
aJ_oi<V/on;5YooOaJ[oel>Zomg>]ooIb[?olMVooo;D_?oWa[Goj<Nhon2o
/?oQ`K;od;6OomJiYooC^JSoeKj/omk;_?no[iooP7AVodm5>Om5?c?oA48f
od=3>Om9Bd005Oo[jn/2on[ZjP05onSXj?oVi^Koh^;RomcLg?nSXj<01Oo^
k^h01?nSXj?og=cLon;Rh_oVi^H3oi^KV`;oW9bL00KoVi^KoiVIVOnEUIGo
UYJFoiZJV_nIVIT2oiJFUP?oUIFE00?oU9BDoiFEUOnFUYH00_nEUID04OnF
UYKoUiNGoiJFU_nFUYKoU9BDoiFEUOnGUiOoUYJFoiBDU?nEUIGoVIVIoiZJ
V_nGUiOoTY:BoiRHV?nIVIWoVYZJ00;oW9bL00?oVYZJoi^KVonLW9`00_nL
W9`01_nMWIgoW9bLoifMWOnKVi_oW9bLoifMW@;oWYjN0_nMWId3oijNWP05
oj2PX?nOWiooX:2Poj2PX?nOWil00_nPX:001OnOWiooX:2Poj6QXOnRXZ;o
X:2P00;oXJ6Q00KoXZ:Roj6QXOnQXJ7oXJ6Qoj:RX_nQXJ42ojBTY0;oXZ:R
0_nQXJ402?nNWYkoWinOoinOWonPX:3oXZ:RoifMWOnCTi?oRh^;0on:RXX0
0on<S8cojn_[on_[j`0Don_[j`;oj^[Z00Goj>SXonKVi_oRh^;og=cLoj>S
X`05onk^kP08oj>SXooMgMgoi>CTonWYjOooooooc<c<oiVIVOlc<c<2oooo
o`04ofIV<oo<VFKooiUVoonIIP;oc9UV1?nIVFH01On8R8SoVIVIok^k^ooM
gMgok^k^02[ooooo1_o_knl00oo^k^kokno_ono_k`05ono_k`03onk^k_o_
knookno_00Gokno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^kokno_ono_
k`05ono_k`03onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_knl01Oo_
knl00oo^k^kokno_ono_k`05ono_k`03onk^k_o_knookno_00Cokno_0_o^
k^h01Oo/k>cojNWYonCTi?oMgMgoXj>S0>;ok^k^0005ooooo`1Sojn_[ooL
g=coh^;RojRW[OnFUI[oVIVKojJRXOnNUi7oT8IjoiR9M_nUTGSoWXMXokRN
OOnkXGkoZY9^ojjGMOneXX;oZiaoojZLPOn]WhGo/J:;ok6USon`Y8ko/ZNC
okJ^VOnf[ico/jbIojfVTon@RGKoRH9_ojBNR?nNV83oU8ifoiVBN?nf[9?o
`K:KoiF5K_mhJECod/NaomG=]_o=ajoodm6jolk>]_oBe;kod=Bmol_@^_o:
ckWodMW2ol_C__o@eL7oc]6lom7C^oo8b:koaL2ZolK1Zono^:Go`KZWolW4
/Oo6`k3o_kjZolC5/oo1a;7o`/FdokVjZ_nf]:Go^[NXolS5]?o:aK7o`kfW
olbo[?o:_J[oa[jYolo:]_ng]Z7o^[RSok2WU_nh[9ko^kBTokJ`X_nh^JWo
`;j_olW1]?n/Xi[o]ZnYol>n^_nj]K7o_KRbokJbZOnn^Zoo_KV]om??`oo;
ak_oWYb?ofAREOm6AcWoBDTmodI8>om0A3KoATXl01Gojn_[0_oZj^X01OoX
j>Soi^KVon;Rh_oLg=co[jn_00Gooooo00go[jn_omcLg?oRh^;oi^KVoi^K
VonHV9SoVIVIoi^KVonIVIWoUYJFoiNGUonHV9SoUiNG00;oVi^K00?oV9RH
oiVIVOnKVi/00onJVYX3oi^KV`0DoibLW?nMWIgoWIfMoibLW?nKVi_oUYJF
oiFEUOnJVY[oVIVIoiNGUonHV9SoW9bLoifMWOnFUYKoTI6Aoj6QXOnRXZ;o
XJ6Qoj:RX_nQXJ43oj:RXP03oj6QXOnSXj?oXZ:R00?oXZ:R00GoX:2PoinO
WonPX:3oWYjNoinOW`02oj2PX007oinOWonPX:3oX:2Poj2PX?nNWYkoWIfM
oijNWP02oj2PX00AoinOWonPX:3oWinOoinOWonQXJ7oWIfMoijNW_nKVi_o
WIfMoijNW_nMWIgoWYjNoinOWonPX:3oVi^KoifMWOnOWil00_nNWYh01onM
WIgoWYjNoijNW_nRXZ;oXJ6QoiVIVOn@T9000on;Rh/00on:RX[oRh^;on_[
j`0Eon_[j`;oj^[Z00Goj>SXonKVi_oRh^;og=cLojn_[`05ooooo`0<ojn_
[ooMgMgohn?SonOWioo^k^koc<c<ohR8R?mEEEGok^k^oooooomVIVKoc9UV
0oooVIT01?ooVFKoolaVooo<I_ooVFH2olbIIP08oiVII_nIIVKoVIUVohR8
R?nIVIWo^k^komgMgOo^k^h7ooooo`03onk^k_oooooooooo00Gooooo00?o
k^k^ooooooooool05?ooool01Oo/k>cok^k^onc/k?o]kNkok^k^00;okNg]
0_o/k>`01?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]
kNkok^k^0_o]kNd2onc/k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`0
1?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNkok^k^
0_o]kNd2onc/k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`01?o^k^ko
k>c/ong]k_o^k^h2ong]k@;ok>c/00_ok^k^onc/k?o]kNkok^k^onc/k?o[
jn_oj^[ZonOWiooShn?og]kNojn_[`3Rooooo`001Oo^k^h0=_nSXj?og=cL
on;Rh_nOYZkoTYVOoi2EVOnCU9KoTI2<oiVBR?nKSWkoTX1Zoj::K_nlXX7o
b[2=okZPOOngWWoo]J21oj>BM_nZVX7oVXUeoiZ;N?nER7GoSX=aohZ1L?n9
PW;oOW]Zog=bH?m`KUooEeQ6oeiMBon?TGcoXJ2;oijNQ_n?SgOoUY5kohYn
K_maHeKoIEU=oemGB_m_JE_oGE]<odU:??m:CSooAT`nodQC@om2CT3oAeE6
ocm=?_lhB3_o?de0ocA2<ola?Boo>dHhoc8j;@;o:c4W02_o=CXcob`a:_l^
>2oo;3L_obHc:_lb@C[o9cH_obhk=?lc?S[o9Bh[oca3??mFF4_oHfAFof5Q
FOmMGEGoFE]@oeUKC_mCEDSo=cT^oc<d;_ll?SWo<38_ocDg<_mBEDkoF5]D
oeUKF_mOH6;oEUYModeAE?m8C4goEe]Loe=GE_mEFUKoDUMAoe]PF_mGFECo
E5M@odiAB_m5BT?o@TM1od56@?m2Ad7oA4]401Gojn_[0_oZj^X01OoXj>So
i^KVon;Rh_oLg=coXj>S00Gok^k^00KoXj>SomcLg?oRh^;oi^KVoi^KVonI
VIT2oiRHV007oiNGUonHV9SoV9RHoiFEUOnGUiOoVi^KoifMW@03oi^KV`04
oiRHV?nJVY[oUiNGoiNGU`;oUYJF0_nEUID04?nDU9CoTY:Boi:BT_n>SXko
Shn?oiNGUonJVY[oVIVIoiNGUonHV9SoUIFEoi2@T?n?ShooSXj>oi6ATOn>
SXh5ohb<S008ohf=SOn;Rh_oRXZ:oh^;Ron:RX[oRHV9ohZ:R_n9RHT2ohN7
Q`07ohV9ROn7QhOoR8R8ohR8R?n7QhOoRHV9ohR8R002ohV9R@03ohN7Qon:
RX[oSXj>00;oT92@00OoShn?ohj>S_n>SXkoSHf=ohV9ROn8R8SoRXZ:00;o
R8R800OoSHf=ohj>S_n?ShooShn?ohj>S_n=SHgoS8b<00CoSXj>00CoShn?
ohj>S_n>SXkoSHf=1?n;Rh/00on<S8cojn_[on_[j`0Don_[j`;oj^[Z00Go
j>SXonKVi_oRh^;og=cLoj>SX`05onk^kP08oj>SXooMgMgoh^;RonKVi_o^
k^koc<c<oiVIVOmVIVH2ooooo`08ogMgMoo<VFKoolbIoonIVOooc9WooiVI
ooo<VOooVIT2ooo<V@Goc9UV0onIVFH01?n8R8SoZZZZolc<c?oMgMdSoooo
o`;ojn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/4onc/k004on_[joo/k>co
jn_[on_[j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/
on_[joo[jn/4onc/k004on_[joo/k>cojn_[on_[j`Cok>c/00Cojn_[onc/
k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/4onc/k004on_[joo/
k>cojn_[on_[j`?ok>c/0_o[jn/01OoXj>Soi^KVon?ShooMgMgoXj>S0>;o
k^k^0005onKViP0YoifMWOoKfm_oh^;RoibY[onAW:;oSIRLohnIVon@UYKo
UiVFoiVFSon?RGgoSHAeoj6HQon[XY7oRh=fog5]H_mLGEGoFf1JoeQJEomO
FUKoHe]Hof1KF?mLF5OoF5MEoeMGEomAEECoC59@oeAJF_lkA47o=C/ioe]T
Gon3RHGoLgYcoeMNE_m5BT?oCe5<odA6@Ol_=33o9R/WobP^:_lY;b/00_lV
;2X0>?lS;2_o8R/Zob8Z;?lU;Boo:30bobP`<olW;33o8BT[ob</:olT;B[o
8RPVob0T9OlV9bWo:BX^obDY;?lT:Bco8RX]oalZ;?lO:Rko6RDYob8]<OlS
;3?o7B@/ocDh?OmBDDooFEYEoe=LFomDGEcoDE=Boe9AColj=SGo<2h_obL/
;olO:B_o9RdcocXm@_m?BU3oD4iCoda@FOm@EE_oEEAIodm=D?mDDUGoE5AF
odi>D?mBDUCoDE9Dod11AOm0A4OoAdY?odQ;D?m1ATco@DE>odI:Dom4B5?o
>T5;5Oo[jn/2on[ZjP05onSXj?oVi^Koh^;Rom_KfonMWId01OoVi^H02OnM
WIgofm_Kon;Rh_oVi^KoVi^KoiVIVOnHV9SoVIVIoiRHV002oiVIV@;oUYJF
00CoVIVIoi^KVonEUIGoTY:B0_n?Shl01?n>SXkoShn?ohn?Son?Shl3ohj>
SP;oSHf=00coSXj>ohZ:R_n9RHWoT92@oiJFU_nCTi?oShn?oh^;Ron=SHgo
Rh^;ohR8R?n6QXH2ohN7Q`GoQXJ61?n7QhL4ohJ6QP03ohF5QOn6QXKoQhN7
00GoQXJ600KoQHF5ohN7Qon7QhOoQHF5ohV9ROn=SHd2ohj>SP04ohn?Son=
SHgoSHf=ohV9R@;oQhN700CoQXJ6ohN7Qon:RX[oS8b<0_n=SHd2ohj>SP03
ohb<S?n=SHgoSXj>00?oSHf=00CoRXZ:oh^;Ron<S8coS8b<0_n;Rh/2ohb<
S003ohZ:R_o[jn_ojn_[01Cojn_[0_oZj^X01OoXj>Soi^KVon;Rh_oKfm_o
WIfM00Goi^KV00coWIfMom_KfooQhN7oiNGUonk^k_oMgMgoZZZZoeEEEOoM
gMgoc<c<oeEEEOo<VFH7oonIV@04olbIVOooc9WooiVIoonIV@?oolaV0_o<
c6H2oiVIIP;oVFIV00?oR8R8ojZZZ_o<c<`00_o^k^h3ooooo`03onk^k_oo
oooooooo01SoooooAOo[jn/01ooZj^[ojNWYonSXj?oUiNGohN7Qom_KfonM
WId0h_oVi^H000Gok^k^02_oXj>Som_KfooRh^;oX:b/oiJRX_nEWj3oUj2O
oiJLV_nNX9goXj:MoibIT?n2Ng7oThb2oiN@Q_mjMg3oGEiIodaBD?m>F5[o
DE]ModiBDomCDe?oDeAFoe9FEomDF5_oEU]NoeEMGomDGUooDE]Mod==C_lQ
:bco<c/moeAMG?lg@3oo92XXoca2@?m5CTgo=3dloalW:OlE7b3o5b4RoaHP
8OlH82?o7bLZ00;o7B8X03Co7R<Yob0S:_lP8bco8bH_ob/^=olc=Sgo82@U
obDY:?lZ;2_o9bLWob8P8olS8BCo:2PZob//;_lR9RWo7BDWoa`T9_lE7B3o
7B8VobDZ;_l[;S?o@d97oeYFEomHEUOoCUABodiDE?m;C4koC4Y=odM1AOln
>CgoAd]>odI>DOm:Ce?oCTiFoe9<E_mCD5WoDEAMoe9EF_mDDU?oDdm>oeAC
DOmCDE;oD51@oe=EE?m;Ce3o>Ci2ocDj@?lg?TKo>T5;ocU1C?li@Dko>d9B
0_ll@e<Eon_[j`07on[Zj_oYjNWoj>SXonKVi_oRh^;ofm_Koj>SX`05onk^
kP05oj>SXooKfm_oh^;RonKVi_nLW9`00onJVYX02_nIVIWoVYZJoiZJV_nI
VIWoU9BDoiNGUonHV9SoTi>Cohn?Son=SHd2ohj>SP?oSHf=0on>SXh2ohn?
S`0=ohj>S_n<S8coQXJ6ohV9ROn?ShooRXZ:ohJ6Q_n:RX[oS8b<ohV9ROn6
QXKoQ8B4ohF5Q@02ohB4Q003ohJ6Q_n5QHGoQHF500?oQHF500OoQXJ6ohN7
Qon8R8SoQHF5ohJ6Q_n7QhOoQXJ600;oQHF500?oQXJ6ohN7Qon6QXH00_n5
QHD01On4Q8CoQHF5ohJ6Q_n7QhOoRh^;00;oSXj>0_n=SHd2ohb<S003oh^;
Ron9RHWoS8b<00;oS8b<0on=SHd2ohj>SPGoSHf=00CoSXj>ohb<S?n:RX[o
RHV91On:RXX2oh^;RaKojn_[00Ooj^[ZonWYjOoXj>Soi^KVon;Rh_oKfm_o
Xj>S00Gok^k^00coXj>SomWIfOoPh>3oiNGUooooooo^k^ko^k^kofIVI_oM
gMgoc<c<oeEEEOo<VFH4oonIIP?ooiVI00CoolbIoonIVOooVIWoolbI0_oo
VIT2oonIIP03olbII_ooc6Koc9UV00?oc9UV0onIVFH01OnZZZ[o^k^kolc<
c?o^k^kooooo00?ok^k^0oooool00oo^k^koooooooooo`0AooooodGojn_[
00Ooj^[ZonWYjOoWinOoiNGUon3Ph?oIfMWoXj>S0>;ok^k^0005ooooo`0E
ojn_[ooKfm_ohN7QoiVLTonHVi;oXJBKojNXX?nSXi_oYjBKoj^UVOnSVHgo
TXAgoi:2Lon6MVOoNF]NofaRF?mZHe_oHEiGoeYKEOmAF53oCUQ?00;oCEM>
04[oC5I=od]EC?m>EDgoD5M?oeELEOmFFeCo<cPaoahQ6_lO81[o9BHPocPi
<om?D4[oCU1=oce1@?l]<C3o:Rh]ob``;olW:b[o:bl^ocPl>ole>C[o;c<d
obX^;ol/;Boo<c@hodY;ComaLWKoTYBCodM8@?m;BcooEE=7oeA@AOm;A3[o
CTLmoeUBB?mHET[oBDToodE7??m7BCko@dHmodQ9@OmADDWoDTm8oeEBBomN
FUOoG5UDoeUEC?mKEdkoEe9>oe=?C_m[IfSoJVIWohj9QOnBSHOoQh>0ofYX
JOmDDeWoCdiDoe1>Com?BdSoD518oe1ABOm?DTWoCe9;odiCC?m>EDko@di8
ocI2@?lU<C7o7R`]oah/;olT<COo9c@lobDb>`;o8Bdi5Oo[jn/01ooZj^[o
jNWYonSXj?oUiNGohN7Qom_Kfon_[jl01Oooool01?n_[joofm_Kon7QhOoU
iND2oiVIV@GoVi^K00GoVIVIoiJFU_nFUYKoU9BDoi:BTP02oi2@T0;oShn?
0_n>SXh5ohf=S@?oSXj>00GoR8R8ohF5QOn5QHGoQXJ6ohV9R@02ohf=S@06
ohZ:R_n7QhOoQhN7ohN7Qon6QXKoQhN70_n9RHT02On8R8SoQhN7ohN7Qon8
R8SoS8b<oi>CTonHV9SoRh^;ohb<S002ohf=S@;oRh^;00?oSHf=ohj>S_n;
Rh/01?n;Rh/3ohf=S@04ohn?Son>SXkoSXj>ohj>SP;oSHf=0_nATI42oiNG
U`03oiFEUOnATI7oSHf=00;oSHf=00?oS8b<ohf=SOn=SHd01?n=SHd00on<
S8coRXZ:ohN7Q`02ohJ6QP03ohN7Qon8R8SoQhN700;oQhN75_o[jn/01ooZ
j^[ojNWYonSXj?oUiNGohN7Qom_Kfon_[jl01Oooool03?n_[jooemOGomoO
gooShn?ok^k^oooooonk^k_oMgMgonk^k_oMgMgoR8R8olbIV@;ooiVI1?oo
VFH00oooc6KoolbIooo<V@05ooo<V@;ooiVI0_ooVFH3ooo<IP?oc9UV1?nI
VFH01OnIVIWo^k^komgMgOooooook^k^01KoooooAOo[jn/01ooYjNWoj>SX
onKVi_oShn?oh>3PomOGeon_[jl0h_ooool000Gok^k^03coXj>SomWIfOoP
h>3oXIj?ojJSU?nb/:?o]kFXok6]XOne[j?o]jfQok2TU_n`X97o/9j@ojBB
Q?nIRG[oO71TofiVFomNEdooFEUAoe9LDom>Fe;oCU]Aoe5MDomBG5?oDUUA
oe=JD_mGGE?oFeiGod]>Aol`<B_o;RlYobHU8?lT8ako=SDaode>BOmCEToo
D5E>odmDCOmAETooDUM@oe1CC?mBEDkoGF1IoemPFomKG5OoG5]GoeeLF?mL
FeOoHemLogUeL_nASXOoKfeQof]XFOmcKEooMViQog1VF_mgKF7oOgEYogM_
H_mgLfL2og5_HP0Uog=aI?mjMV[oOW]/og9/H?mNEdgoCdm7oe5@BomIDT[o
GEI>oe9?B?m:BDGoMWIdogamN?n0NgGoQWmiogQeL?mNGEWoBTi=odi@ComH
Ee?oFUUDoe=DC_mAEU3oD5E?odmFCom?FE7oC5I>odUDC_m<Ee7oAE1<od=>
B_m6CdcoC59@odmCD_m@DU7oD55Coe5BE00Eon_[j`07on[Zj_oYjNWoinOW
onGUiOoPh>3ofMWIoj>SX`05onk^kP09oj>SXooIfMWoh>3PonGUiOnJVY[o
Vi^KoifMWOnNWYkoW9bL00;oWIfM0_nKVi/01OnJVY[oV9RHoiNGUonCTi?o
TI6A00WoSXj>0_n?Shl02?n<S8coR8R8ohN7Qon6QXKoQHF5ohR8R?n<S8co
SXj>0on=SHd00on>SXkoSHf=ohf=S@07ohn?S`04oi>CTonGUiOoTY:Boi6A
T@;oTY:B00GoTI6Aoi:BT_nCTi?oTY:Boi>CT`03oi:BTP04oi>CTonDU9Co
TY:Bohj>SP?oSHf=00CoSXj>ohf=SOn<S8coTi>C0_nDU9@01OnEUIGoTi>C
ohn?Son<S8coSHf=00;oSXj>1?n=SHd01?n>SXkoSHf=ohf=SOn=SHd3ohb<
S0GoSHf=5_o[jn/01ooZj^[ojNWYonOWiooUiNGoh>3PomWIfOnSXj<01Oo^
k^h01?nSXj?og=cLon;Rh_oVi^H2ooooo`06olc<c?mgMgOok^k^omgMgOn8
R8Soc9VI0oooVIT00oooc9WooiVIoonIIP02oonIIP04olbII_ooc9WoolbI
oonIV@CoolbI0oooVIT5oonIIP04ooo<I_o<VFKoc9UVolbIIPCoVIUV00Co
ZZZZolc<c?oMgMgok^k^0oooool00oo^k^koooooooooo`0=ooooodGojn_[
0_oZj^X01OoXj>Soi^KVon;Rh_oLg=coXj>S0>;ok^k^0005onKViP1SoifM
WOoGemOogmoOokJ[VOne[I[o^kBRokVcYOnaZioo]k2Voknf[Onh[jKo[::H
oifCROn3NFooMfiUof=LE?mPGEKoG5eHof5WIOmEHF7oDV1QoeAPH?mFH5oo
F65PoeUOGOmIGEcoG5iKof1RHOmDE5Co:b/[ocDe=om8B4[oATE:ocm0AOmD
F5WoDUaAoem/FomWM6?oJGATof]cI?mZL6;oK71Rog5cI_m[JEcoKFUMogMa
IOn3Ng3oQ7Y`ogmbJOn0Lf[oQWacoh9kLOmhM6_oOgQ`oh9iL_mlLVWoPWQ_
ohQnMOmmM6_oQ7ecogijKomiMF[oNWI[oh9kLOn7OgCoOWA[ofMNEOmHFE7o
EU]Eoe]MG?mOHF3oEEYFodaAB_maN73oLWUbogEiN?mbMWOoJ6a[oeQNF_m;
EDcoBE=;odeCDOm>DeKoC5=Iod]BF?m:DEOoCEEHodaDE_m9CdgoCeA@oemR
FomjNW;oPgmdohZ0M?n7NFcoQWEUohehIonFOfooWXAe01Gojn_[00OojNWY
onSXj?oVi^Kohn?Son3Ph?oGemOoWIfM00Goi^KV00CoWIfMomOGeooOgmoo
hn?S0_nLW9`02_nNWYkoWIfMoibLW?nMWIgoWYjNoifMWOnKVi_oV9RHoiBD
U?nBTY83ohn?S`03oi2@T?n?ShooShn?00KoShn?00OoT92@ohf=SOn7QhOo
R8R8ohb<S?n;Rh_oRXZ:00;oSXj>00?oTI6Aoi:BT_nBTY801?nBTY82oi6A
T@03oi:BT_nDU9CoU9BD00;oTi>C00?oUIFEoiBDU?nCTi<00_nDU9@01_nC
Ti?oU9BDoiFEUOnCTi?oUIFEoiBDU0;oTi>C00CoU9BDoiFEUOnCTi?oShn?
0_n>SXh01?n?ShooT92@ohj>S_n=SHd4oi>CT`03oi6ATOn?ShooSHf=00So
SHf=00CoS8b<ohf=SOn@T93oU9BD0_nEUID3oiBDU003oiJFU_nGUiOojn_[
01Gojn_[00OojNWYonSXj?oVi^Kohn?Son3Ph?oGemOoWIfM00Goi^KV00ko
WIfMomcLg?oRh^;oi^KVonk^k_oooooo^k^kogMgMoo<c<co^k^kogMgMoo<
VFKooiVIooo<V@CooiVI00KoolbIoonIVOooVIWoolbIoonIVOo<VIT3oonI
V@?oolbI1_ooVIT5ooo<IP?oc9UV0onIVFH01_n8R8SoZZZZolc<c?o^k^ko
ooooonk^kPkoooooAOo[jn/2on[ZjP05onSXj?oVi^Koh^;RomcLg?nMWId0
h_oVi^H000Gok^k^01_oXj>SomcLg?oRh^;o/j^Nok:/X?ne/JKo/k2Woj^Z
YOna/:co]K6^ojZWX_nNVI?oShR0ogUbJ?maJV3oJFEJofUVGOmWIeooJ6YU
ofM/KomTK6ooI6U/ofAXJOmYJFWoKFaZofeYI_mZIV<00_mYIF804OmAD4ko
De=CodQ9Bom>DUGoCU=Goe1FE_m@FU7oGfYJofE`H?mTK5goIF]MofM[GOmW
JEcoJ6QLog=aI?m^JUkoKVQL00;oLVYO0_m_IE/0;ombJUooKFUPof]XHOma
K6KoLFYTofUPFOm/HE_oL6MPofaUGOmUGUKoJfMNofMSF_mVHUOoJF9HofUP
EomYGeKoGUE<of5NEOmKG5KoF5QHoeeMGOmLGESoEeQ@ofMYG_mOH5SoGf5N
oeaNGOmJG5WoFeiGoeYMD_mGFTooEEMBoe=GF?mEEU_oDEAIoeEFFomDF5_o
D5AEoe1BDOmGF5?oGemGog5_HomcKEooMFUIogY[F?n;MV?oWHMb00;oZ8eh
5Oo[jn/2on[ZjP05onSXj?oVi^Koh^;RomcLg?nSXj<01Oo^k^h01?nSXj?o
g=cLon;Rh_oVi^H2oibLW0;oWIfM00SoW9bLoifMWOnMWIgoVi^KoiVIVOnF
UYKoTi>Coi6AT@;oT92@1onATI400onBTY;oTI6Aoi6AT@02oi2@T0;oSHf=
00?oS8b<ohf=SOn=SHd00_n>SXh00on@T93oTI6Aoi6AT@04oi6AT@03oi:B
T_nATI7oTI6A00OoTI6A00CoTY:Boi6ATOn@T93oT92@0_nATI400on?Shoo
TI6Aoi2@T004oi2@T004ohj>S_n?ShooShn?ohj>SP;oShn?00CoSXj>oi6A
TOn?ShooT92@1?n?Shl4ohj>SP03ohf=SOn>SXkoSXj>00;oSHf=00SoSXj>
ohn?SonBTY;oTY:Boi6ATOnBTY;oU9BDoiNGU`;oV9RH5_o[jn/2on[ZjP05
onSXj?oVi^Koh^;RomcLg?nSXj<01Oo^k^h03?nSXj?og=cLon;Rh_oVi^Ko
ooooonk^k_o<c<coR8R8onk^k_oMgMgoR8R8olbIIPCooiVI00CoolbIoonI
VOooc9WoolbI1OooVIT3ooo<V@08oonII_ooc9WoolbIooo<VOooVIWoolbI
oonIVOooc9T3oonIV@03olbIVOooVIWooiUV00;ooiUV0oo<VFH4oiVIIP04
oiVIVOnk^k_oc<c<onk^kPcoooooAOo[jn/2on[ZjP05onSXj?oVi^Koh^;R
omcLg?nSXj<0h_o^k^h000Gooooo027o[jn_omcLg?oRh^;oYjnaojJ^/?n/
][So[kRmoj^f_?n`^L3o[[>goi^OX?mcLVkoPgihohn7O?n2NF[oM6]Jog]c
H?nWWhcocLJfomG=b_oFcLkoe<[9om?8a_oMd<[oj]_Don_Me?oTf<co_;2T
ojfUV_n/Z9go/;2VofU/IOm?ETl00_mBFeH01?mIFeSoGUiLoeeMFomLG5X2
of5PG007oemNF_mPGe_oFeaFoeYKEOmKG5CoGV5Hof1SFP02oeiTFP05oemU
FomJGECoH65IofEUGOmTHEX00_mOFe806_mSGeKoIF9IoeeKCom[JeooIfMK
ofMXF_mZJ5_oI61DofQRE_mZH5KoKf9JofmPFOmZGEGoKV5IofmRF_meJ63o
LfINofmRF_m_IEcoKfEKog5WG_mcJF3oM6YQog9XGom_IE_oKVAK0_m_HU`0
3_maIV3oKFAMofIQFom[J5ooIFEKoe5CB?m9C47oA4PjodU;?_mQHUCoP7ia
oiJBQ_nKV8WoVYB65Oo[jn/2on[ZjP05onSXj?oVi^Koh^;RomcLg?n_[jl0
1Oooool01?n_[joog=cLon;Rh_oVi^H2oibLW00>oifMWOnNWYkoWIfMoijN
W_nMWIgoVYZJoi:BT_nEUIGoUYJFoiBDU?nATI7oTi>CoiZJV_nQXJ43oj:R
XP06oj6QXOnSXj?oYJFUojFUYOnTY:CoWIfM0_nKVi/00onMWIgoTI6Aohf=
S@02ohj>SPcoShn?1?n@T902ohn?S`;oT92@0on?Shl01?n@T93oShn?oi6A
TOn@T902oi6AT@03ohn?Son@T93oT92@00GoT92@0_nATI400on@T93oTI6A
oi6AT@02oi6AT@04oi:BT_nATI7oTI6Aoi6AT@;oT92@00koTI6Aoi2@T?n@
T93oTI6Aoi2@T?n=SHgoS8b<oh^;Ron<S8coT92@oiBDU?nHV9SoVIVIoiRH
V1Kojn_[0_oZj^X01OoXj>Soi^KVon;Rh_oLg=co[jn_00Gooooo00Co[jn_
om_KfooRh^;oi^KV0_ooool01?o<c<coR8R8ooooooo^k^h2oiVIV@;oolbI
0_ooVIT00oooc9WooiVIooo<V@02oonIV@03ooo<VOooVIWoolbI00CoolbI
00?ooiVIooo<VOooVIT00oooVFH2ooo<V@04oonIVOooc9WooiVIooo<V@;o
oiVI1?ooVFH00oo<VFKooiUVolbIIP03olbIIP?oVIUV00CoVIVIolc<c?oM
gMgok^k^0oooool2onk^kP;ooooo00?ok^k^on_[joo[jn/0@oo[jn/2on[Z
jP05onSXj?oVi^Koh^;Rom_Kfon_[jl0h_ooool000Gok^k^03goXj>SomcL
g?oRh^;oWkG0oibb_onL]/?oWKO6oibgb?nV_LgoXkO2oi>PZ?mHGUkoTI2;
om?=`OoMe<?odLJbol>hX_oOel3ooOCSoookmOoonOWooO;`ooOYi_onknSo
ooccooollOoolnKoo?3Pookei_oPf/[o^kRYog5bI?mVJ5_oIfeQofY]H_md
LFcoLFaXof]VHom_JVOoN7=`ogMbKomdL6goMgA_ogimN?moP7SoOh9gogj4
N_moQgcoPHR0oh>=QOn7SXKoQH]oohb?Q?n>T8GoSHn4oi>AQOnEThOoUYB8
oiRFR_nEUHWoXjBF00;oUiR:02CoXInBoifISOnRWY;oZj>HojRKT_n_XIKo
[:2BojfQTonZWICo]JRPojnPVoncYZ3o/jJMokF[XOnhZj;o]JRPokFVXOng
Z:?o^:ZQokRZWonfYIgo^:ZQok^^YOncZJ3o[ZNMokJcZ_nVYYcoNWebod57
?Om4BT3oEUU@ofiaJ?mkOWGoOGmdoh20M_n5QG/Eon_[j`;oj^[Z00Goj>SX
onKVi_oRh^;og=cLoj>SX`05onk^kP06oj>SXooLg=coh^;RonKVi_nMWIgo
W9bL0onMWId02onNWYkoWIfMoiZJV_n?ShooUiNGoj:RX_nSXj?oXJ6QoijN
W_nSXj?oZ:RX00;oZJVY00?oZ:RXojNWYonXZ:P00_nYZJT2ojRXZ005ojVY
ZOnTY:CoWYjNoi:BT_n@T9000_nATI42oi:BTP;oTI6A0_nCTi<00onBTY;o
Ti>CoiBDU004oiFEU@;oUYJF00?oUiNGoiJFU_nGUiL00_nGUiL5oiRHV008
oi^KVonIVIWoVIVIoiZJV_nIVIWoVYZJoi^KVonJVYX3oi^KV`03oiZJV_nL
W9coVi^K00_oW9bL00KoWIfMoibLW?nLW9coWIfMoi^KVonDU9@2oh^;R`04
ohj>S_nBTY;oU9BDoiBDU0;oUIFE5_o[jn/2on[ZjP05onSXj?oVi^Koh^;R
omcLg?nSXj<01Oo^k^h01?nSXj?ofm_Kon;Rh_oVi^H2ooooo`04olc<c?mg
MgOogMgMolc<c0;oR8R800?ooiVIooo<VOooc9T01Oooc9T01_ooVIWoolbI
ooo<VOooVIWoolbIoonIV@CoolbI00GooiVIooo<VOooVIWooiVIoonIIP02
olbIIP04oonII_ooVIWooiVIooo<V@;ooiVI00CoolbIoonIVOooc9WooiUV
0_ooc6H00oooVFKoolaVoonIIP02olbIIPCoVIUV00CoVIVIojZZZ_nk^k_o
gMgM0_o^k^h2ooooo`03onk^k_o[jn_ojn_[04?ojn_[00Ooj^[ZonWYjOoX
j>Soi^KVon;Rh_oKfm_oXj>S0>;ok^k^0005onKViP0goifMWOoKfm_oh^;R
oi2da?n?]/OoSkW?oh^idOn:^M?oT;cEohjca_n3Wj_oNHR;ohR?R?nUXiKo
_kRVolo8]OoLel?of=G2olG3]_o0_k_ojNOXoo[imoojnOGod/k;okVf[ooX
i=_oooodoo?]hOo:a;Ko]:jPojfVU_nRVh_o[:FEok^dY?nbZiWo^kBRokRa
Wone[J3o/j^PokB[Y?nf[JKo/jZQojjXW?nd[Yko[JZGojn/VOn][9[oYjRJ
ojb/X_n][:SoXZ>Moj6UU_nUZISoYjZIojBWUP02ojFSU0;oYj>G00CoYZ:F
ojRTV?nTX9CoX9b@0onRWY<03onUXiKoYjJDoj2OSOnIVXSoYJJFoj6QUOnO
X9SoY:>NoiVHU?nKVYKoUiJBojJRWonRWY_oWiVIojJNW002oinGU00@oj:M
UonPViGoX9fFoibKU_nLWIOoXjBOoiFGT_mgNGCoE5E?odE4?omgM6goVYF?
oibESOnQV8ooVY27oi^>QQGojn_[0_oZj^X01OoXj>Soi^KVon;Rh_oKfm_o
WIfM00Goi^KV00CoWIfMom_KfooRh^;oi^KV0_nLW9`02onMWIgoW9bLoibL
W?nMWIgoW9bLoiVIVOnEUIGoUiNGoi^KVonNWYkoXJ6Q00;oXj>S00?oX:2P
oinOWonVYZH00_nYZJT03_nRXZ;oWYjNojJVY_nZZZ[oYjNWoj2PX?nMWIgo
Vi^KoiVIVOnKVi_oWYjNoibLW?nNWYkoWIfM0onLW9`01?nMWIgoW9bLoibL
W?nMWId3oibLW003oi^KVonLW9coW9bL00GoVi^K0_nJVYX2oi^KV`04oiZJ
V_nKVi_oVYZJoiVIV@?oVYZJ0_nKVi/00onJVY[oVIVIoi^KV`02oiZJVP08
oi^KVonIVIWoVIVIoiRHV?nKVi_oVYZJoiVIVOnJVYX2oiVIV@0<oiZJV_nI
VIWoVYZJoiVIVOnJVY[oVi^KoiRHV?nCTi?oSXj>oh^;RonCTi?oV9RH0_nI
VIT2oiRHV1Kojn_[0_oZj^X01OoXj>Soi^KVon;Rh_oKfm_oWIfM00Goi^KV
00CoWIfMom_KfooQhN7oiNGU0_ooool02_o<c<coMgMgomgMgOo<c<coR8R8
oiVII_ooc9Woc9VIooo<VOooVIT8ooo<V@04oonIVOooc9WoolbIooo<V@;o
oiVI0oooc9T2oonIV@03ooo<VOooVIWooiUV00?oc9UV00?ooiUVooo<VOoo
VIT00oooVIT01oooc9WoolaVooo<VOooc6KooiUVolbII_ooVFH01?o<VFH0
2OnIVFKoc9UVoiVII_nIVIWoolc<ooooooo^k^koooooonk^kP15on_[j`07
on[Zj_oYjNWoj>SXonGUiOoQhN7ofm_KoifMW@3RonKViP001Oo^k^h0HonS
Xj?ofm_Kon;Rh_n<^LkoQ[K<oh:ed?n1^MCoQKcJohRjeOmkY[WoIhNBoh>E
UonIX9Wo[:ZMojVTTOnPVhSoZJJCol72/_oDe<Sojn_SooWhloofmO3onOSc
ooCck_oYjN7og]kDokjl/?nVXYOo[:JJojFOTOnOUh[oWYF6oiV=OonHS7ko
Y9R8oiF>NonFSgcoUhimoiF;OonDRX3oUH^1oiF;OonCRW_oSHEbohZ2KOn<
Q6ooSHIcohf6M_n@R7goT8N2oh^4O?moO6goPX5]ohF2LOn3OFgoPGYZoh1i
JOn2NF[oPgY[oh=gJOn<P7;oRgmaohAhK?n4NVkoQgeaohEkKon1NV[oOgYW
ogUfHon1OVgoMG=VogYhK?n0P7KoM7A/ohN6POn5Q7ooNgQcogikM_n?RXCo
SXZ1ohN0M_n9PGKoR81eohN0M_moN73oQ7eeohj:POn8QGkoNgQaogYgL?n1
O7KoPWieogefK_nUVi;o]ZVPojbNTon`X9?o/9bAokNTUP0Eon_[j`07on[Z
j_oYjNWoj>SXonKVi_oRh^;ofm_Koj>SX`05onk^kP04oj>SXooKfm_oh^;R
onKViPCoW9bL01OoWIfMoibLW?nIVIWoUIFEoiNGUonJVY[oW9bLoi^KVonI
VIWoVi^KoinOWonSXj?oYjNWojVYZOnXZ:SoZJVYojRXZ?nVYZKoY:BToinO
WonJVY[oVi^KoiZJVP02oiVIV@;oUiNG00?oVIVIoiNGUonGUiL01_nGUiL0
0onFUYKoUIFEoiJFUP05oiJFUP03oiBDU?nEUIGoUIFE00KoU9BD0_nEUID2
oiBDU006oiFEUOnDU9CoU9BDoiBDU?nCTi?oU9BD0_nCTi<01?nEUIGoTi>C
oiJFU_nEUID2oiBDU0;oUiNG1?nEUID03onDU9CoUIFEoiNGUonFUYKoU9BD
oi>CTonDU9CoUIFEoi>CTonJVY[oW9bLoiZJV_nKVi_oVYZJoibLW00Fon_[
j`07on[Zj_oYjNWoj>SXonKVi_oRh^;ofm_Koj>SX`05onk^kP04oj>SXooI
fMWoh>3PonGUi@;ooooo00Soc<c<ohR8R?o^k^kogMgMoiVIVOnIVFKoolbI
oonIV@KoolbI00?ooiVIooo<c?ooc<`01Oooc9T01OooVIWoolbIooo<VOoo
c9WooiVI00?oolbI00CooiVIooo<VOooVIWoolbI0_ooVFH4olbIIP;ooiUV
0_ooVIT00oooc9WoolaVoonIIP02oonIIPCoolaV0oo<VFH00oo<c9Wooooo
ooooo`02ooooodGojn_[00Ooj^[ZonWYjOoWinOoiNGUon3Ph?oIfMWoXj>S
0>;ok^k^0005ooooo`0Mojn_[ooKfm_ohN7QohJhdOn7^]GoR[gJohNjeOn3
//coOJNmog2AX?mPMggoNXJ4ohV<PonFTXKoXIZ:ojVRT_nZY9CoYZBGojVU
VOn`YiSo^ZfMol6eYOo4^:[o_;>Tok6ZV_n[XiKoYInAoiJ@P_nARgl00_n0
NVh03On?R7koQWmeogI_IOmkM6[oPW]aoh9lL?n3Ng3oPWY_ohAjK_n6OFko
Qg]]ohIiJOnBQGD00_nAQ7<0=OnEQGGoV8QioiB4MOnBPWGoUXIioiZ:OOnL
S7ooW8YloiR6N?nJQgWoXHj0ojfGR_ndW93oTga^oj><O_nVSh7oWhQhoj:;
NonYU8?oZ9>2oj>=OonUSh;o_JNLojZCRonPS8?oZ9F>ojNFS_n]W9;oV8Yo
oinAQ?n`Xi?oVhikoi^?Mon[X8CoYiUlojRKNon[W7ooZYF0ojRCP_nVTH3o
Z9F4ojnNS_n^WHgoYYJ7oj>CQ?nWUhSoZ9N7okb[VonhYICo[iZ7okBNROnh
Wh_o`ZVC01Gojn_[00Ooj^[ZonWYjOoXj>SoiNGUon7QhOoKfm_o[jn_00Go
oooo00Co[jn_om_KfooQhN7oiNGU0_nLW9`02_nMWIgoW9bLoi^KVonJVY[o
UYJFoi:BT_nEUIGoUiNGoiRHV?nIVIT4oi^KV`0:oibLW?nMWIgoWYjNoinO
WonNWYkoW9bLoi^KVonJVY[oV9RHoiNGU`;oU9BD00CoUYJFoiFEUOnBTY;o
Ti>C1OnDU9@00onEUIGoU9BDoiBDU004oiJFUP04oiNGUonFUYKoUYJFoiJF
UP?oUiNG00?oUYJFoiNGUonHV9P00_nJVYX01OnEUIGoV9RHoiRHV?nGUiOo
V9RH00;oVIVI0_nHV9P00onLW9coVIVIoiRHV002oiVIV@04oiZJV_nGUiOo
V9RHoi^KV`;oUiNG00CoVYZJoiVIVOnIVIWoVYZJ0_nIVIT01?nHV9SoVIVI
oiZJV_nJVYX4oiVIV@03oifMWOnLW9coVYZJ00;oVi^K00?oWIfMon_[joo[
jn/05?o[jn/01ooZj^[ojNWYonSXj?oUiNGohN7Qom_Kfon_[jl01Oooool0
3?n_[jooemOGomoOgooShn?oooooonk^k_o<c<coR8R8oooooooMgMgoZZZZ
oiUVIP;oolc<2Oooc9T5ooo<c0CoolbI0oooVIT7ooo<V@04ooo<I_ooVFKo
oiUVoonIIP?oc9UV0oooVFH00oooc6KoolbIooo<IP02ooo<IP04ooo<VOoo
c6KoolaVolbIV@;oc9UV00CogMgMonk^k_o^k^koooooAOo[jn/01ooYjNWo
j>SXonKVi_oShn?oh>3PomOGeon_[jl0h_ooool000Gok^k^05_oXj>SomWI
fOoPh>3oO[OEohBkfOn9_]goR;OAogfW_OmiWJgoMI2Iofn1PomoR8GoQXMo
ohB0MOn7PG?oTheooiRBQ?nJUX_oYj6Cok2STon`Whgo^:VFokVZUondYiKo
[:6?oinDP_nSVXWoUHakoiZCPonPV8_oWIF8oiB<OonCRGooU8Z0oi67OOnG
RH3oV8MmoiN7N_nHR7SoWHikoj:CO_nSTWkoX8mmoiZ9NOnMRggoWhf1ojFC
Qon[VH_oYYF5ojNFQ?nfYIGo^ZRLok^YWonjYYgo]J6Fok:LTOn`V8ko[Y>8
oj^AQ?neVhko`ZRIolBZVOnmXi;o_jJBolF/V?o3[ISo`JZHokbRUOo1YY_o
`jROok:JT?o6[ZCoeKndolRbYOnhXYCo_:NFokjYU?o1[ICo`Jb?okNRPoo8
]97ofL>NokfUPongVH7od:nLomBeXOo6ZYGoaZ^HolZaWOo5[Yco_jZG00?o
a:nL00Go]J2;okFOR_noZI;o_ZF?ol2XT00Eon_[j`07on[Zj_oYjNWoinOW
onGUiOoPh>3ofMWIoj>SX`05onk^kP04oj>SXooIfMWoh>3PonGUi@;oW9bL
00KoWIfMoibLW?nJVY[oV9RHoiJFU_nDU9@2oiJFUP;oUIFE00CoUiNGoiRH
V?nHV9SoVYZJ0_nKVi/3oibLW007oi^KVonHV9SoVIVIoiNGUonHV9SoVIVI
oiRHV003oiNGU`03oiJFU_nGUiOoUiNG00;oUiNG1?nHV9P2oiNGU`03oiRH
V?nIVIWoVYZJ00;oVIVI1?nLW9`00onKVi_oVYZJoiZJVP02oiVIV@03oiZJ
V_nMWIgoWIfM00;oW9bL0onMWId2oibLW006oifMWOnJVY[oWYjNoj2PX?nN
WYkoVi^K0_nLW9`2oifMW@07oi^KVonNWYkoX:2PoibLW?nJVY[oWYjNoinO
W`02oifMW@03oijNW_nMWIgoWIfM00?oWIfM0_nKVi/3oibLW1Kojn_[00Oo
j^[ZonWYjOoWinOoiNGUon3Ph?oIfMWoXj>S00Gok^k^00CoXj>SomcLg?oR
h^;oi^KV0_ooool01_o<c<coMgMgomgMgOo<c<coZZZZofIVIPGoolc<00?o
olbIooo<c?ooc<`01Oooc9T6ooo<c0?oolbI00CooiVIooo<VOooVIWoc9VI
0_ooVIT3ooo<V@?oolaV0_ooVFH4olbIIP04oonII_o<VFKoolaVooo<IPCo
olbI0_ooVFH00oo<VFKoolc<ooooo`02ooooodGojn_[0_oZj^X01OoXj>So
i^KVon;Rh_oLg=coXj>S0>;ok^k^0005onKViP0moifMWOoGemOogmoOogZj
g_mj]]SoNk;AogbZ`_mlXK?oPYjYohNJX?n6TY;oQXb8oi:CSOnFThcoUi>:
oiRDROnBRh7oSXMmoiN?Q?nTV8[o/ZJFokjcXOn/XHooYib:ojnTT_nXWH_o
/JJBok:UT_n]X8go]ZNDol:cX?no[Yco/j2?ojjKR_ncW8co]9N9okVJR?nj
VhKo]iUook>HN_ndVgco]in3okJPR?neWXko]j6DokFQV_nhYIko^jVOok:R
ToneYIGoaKRXoo?VgOoVfM7odLBlokjaZOngZJ3o_:^Qol6_Xoo3/J?oakJV
om70[P02omK4/00TomW9/_oLc;?oh=2gonGG_OoLcKSoe/Ndom_;^ooB`[;o
iMG6oo?Qdoook^3oooS[ooociOo`e/OodkRUokZNROo?/9_on=S1oo;@]ooE
/i[oek:Oon6lZOoQ_Z_ogKbYomZmZooB]jCob[>Qom2kZ?o?_:_ockj/olFd
X_neY9;o^ZVGol>bW_nmZiOo^JNC5Oo[jn/01ooYjNWoj>SXonKVi_oShn?o
h>3PomOGeonMWId01OoVi^H01OnMWIgoemOGomoOgooShn?oW9bL00;oVi^K
00KoVYZJoiVIVOnIVIWoV9RHoiNGUonFUYH4oiRHV00:oiNGUonFUYKoV9RH
oiVIVOnKVi_oWYjNoi^KVonJVY[oVi^KoiZJVP;oVi^K00GoVYZJoibLW?nN
WYkoWIfMoi^KV`08oiZJVPGoVi^K0_nLW9`02?nKVi_oW9bLoinOWonVYZKo
Y:BToj6QXOnNWYkoW9bL0_nMWId2oijNWP0Foj2PX?nQXJ7oXJ6Qoj6QXOnR
XZ;oXj>SojBTY?nRXZ;oXJ6Qoj:RX_nPX:3oY:BTojJVY_nXZ:SoZJVYojRX
Z?nTY:CoWinOoi^KVonNWYkoYJFUoj>SX`;oWinO00KoX:2Poj6QXOnPX:3o
X:2PoinOWonNWYh2oinOW`07oj2PX?nNWYkoVi^KoibLW?nNWYkoWIfMoibL
W00Fon_[j`07onWYjOoXj>Soi^KVon?ShooPh>3oemOGoifMW@05onKViP04
oifMWOoLg=coh^;RonKViP;ooooo00Koc<c<ogMgMooMgMgoc<c<ok^k^omV
IS<4ooo<V@Soolc<2Oooc9T02?ooc<coolbIooo<VOooc9WooiVIooo<VOoo
VFKoc9UV0oooVFH4ooo<IPCooiUV1Oo<VFH2oonIIP05oonIVOooVFKooiUV
oonII_o<c<`00_o^k^h00ooooooojn_[on_[j`13on_[j`;oj^[Z00Goj>SX
onKVi_oRh^;og=cLoifMW@3RonKViP001Oo^k^h0HonSXj?og=cLon;Rh_mf
^nCoMkSNogbedomiZL3oMIZZogjIX_n<Wj?oTZ2QojF_[_nS[:WoWj>RoifO
W?nPWi[oWY^DoiZCRonIShGo/JBDol:eX_o?`Zoo`kJSol2cX?o1]Ioo_[6N
om75[ooZgL[ooo;MooCUd_oEa;3oc;^WolbjY_o:]jKoeKj^omo3]OoZcKgo
kmFnonS@]?oLajSofLJVomg>/OoRe/3oj=c>on;Id?oPf=GohmkKonGRgOoQ
hMWoinOKooGejooakN[ol>c]ono[k?o]jNSoknWYoo7Yioo/iMooj=oHoncS
f_oekN;on?3SooO_h_oek]koknSFongVe?objmSojnKCongXeOnbZi_oYIj>
ooG/gOoooNooooc_ooohk?o^f<_o]Yb?oljbY?ode<GojLRgon:o[?oN^JKo
gKRUon_6]?oN^jSocjjMolb]Voo;[Yko`ZRGokVRT_ngY9Go^jZJokn_X?ng
ZY[o[InBojjPToncYISo/jJFok2TU00Eon_[j`;oj^[Z00Goj>SXonKVi_oR
h^;og=cLoj>SX`05onk^kP04oj>SXooLg=coh^;RonKViP;oW9bL00CoVi^K
oiZJV_nHV9SoV9RH0_nIVIT2oibLW0?oVYZJ00KoVIVIoiRHV?nHV9SoVi^K
oijNW_nPX:03oijNWP06oifMWOnQXJ7oYJFUojRXZ?nVYZKoXJ6Q0onOWil0
1OnPX:3oXJ6Qoj>SXonTY:CoXj>S00;oXJ6Q00?oXZ:Roj>SXonUYJD00_nT
Y:@3ojFUY@03ojJVY_nXZ:SoYjNW00GoYjNW00GoYZJVojFUYOnVYZKoYjNW
ojRXZ002ojNWY`;oYZJV00OoYjNWojJVY_nVYZKoW9bLoiZJV_nWYjOoZZZZ
00;oZJVY00KoY:BToi^KVonNWYkoY:BToj:RX_nQXJ42oj2PX003oj:RX_nP
X:3oWYjN00;oWYjN00OoW9bLoi^KVonLW9coW9bLoifMWOnLW9coVYZJ00;o
Vi^K00?oW9bLoi^KVoo[jn/05Oo[jn/2on[ZjP05onSXj?oVi^Koh^;RomcL
g?nSXj<01Oo^k^h01?nSXj?og=cLon;Rh_oVi^H2ooooo`07olc<c?n8R8So
ooooonk^k_nk^k_oIVHcooo<c006ooo<V@Woolc<0oooc9T00oooVIWoolbI
ooo<V@05ooo<V@;ooiVI00?oolbIoonII_ooVFH00oo<VFH3oonIIP;oolaV
0oooVFH4olbIIPCooiUV00Coolc<ooooooo^k^koooooAOo[jn/2on[ZjP05
onSXj?oVi^Koh^;RomcLg?nSXj<0h_o^k^h000Gooooo06?o[jn_omcLg?oR
h^;oLKcTogNlhon1_]goP;;9ogZQ/?moWJOoSZN/oiF]/OnN/kSoXkJlojRi
`?nV];OoY:V/ojRXY_n_ZZCo/jNIokFSSOoKaZ_on>?8ooCPaooKb[3o^j^B
okBUS_o>`Zcon>_HooogiOoooNgonO3QoknfYomiKf?oKfEKoiJ<P_nYX9Oo
[:JJojNTTonHUh?oPhIaogAiHom[M67oIW9Toe1OF?lmD4ko<4=7obTn@olQ
>Cgo6cDfoaXd<OlK<c?o8c0iobP_?olZ<D7o:S0nob/a?Ol_<cko<3@ooblb
>olc=SgoBDaAoe]OH_mRIVWoIf]/ofM[J_mTJ6OoIFMTode>BOmZJfGog]kF
oooon?oonoGooo[boncRfOncYYgoc[fcon[Fbooih]Coi/ZlolV/V_nmWX[o
aJF@omZiY_oI^ZSoeKRXoljaXoniWi3oZ963ojJCQ?n/VXco[9b?ojVKT?n]
X9OoZj6HojNNUOnTViCoYIbEoj^RVon]YYh05Oo[jn/2on[ZjP05onSXj?oV
i^Koh^;RomcLg?n_[jl01Oooool01?n_[joog=cLon;Rh_oVi^H2oibLW00:
oifMWOnKVi_oVIVIoiRHV?nJVY[oVi^KoibLW?nMWIgoWYjNoifMW@;oVi^K
0_nLW9`02OnKVi_oXJ6QojJVY_nUYJGoXZ:RoibLW?nKVi_oX:2PojNWY`02
ojVYZ@06ojRXZ?nNWYkoTY:Boi6ATOnGUiOoVYZJ0_nKVi/00onHV9SoUIFE
oi>CT`02oi:BTP05ohj>S_n<S8coRXZ:ohV9ROn8R8P01On7QhL00on8R8So
QhN7ohR8R004ohR8R003ohb<S?n?ShooT92@00CoTI6A00CoS8b<oi6ATOnT
Y:CoZZZZ0_nYZJT02OnVYZKoW9bLoj2PX?nTY:CoYZJVoj:RX_nMWIgoVi^K
oibLW002oj2PX003oinOWonNWYkoVi^K00;oVIVI0onJVYX2oi^KV`?oVYZJ
0_nKVi/Fon_[j`;oj^[Z00Goj>SXonKVi_oRh^;og=cLojn_[`05ooooo`08
ojn_[ooKfm_oh^;RonKVi_ooooook^k^olc<c?n8R8P2onk^kP03omgMgOmE
EEGoolc<00Goolc<00?oolbIooo<c?ooc9T02_ooc<`6ooo<V@05oonIVOoo
c9WoolbIooo<VOooVIT00oooc9T2oonIIPCoc9UV1OooVFH00oo<VFKooiUV
oonIIP02oonIIP03olc<VOooVFKoolc<00?oooooAOo[jn/2on[ZjP05onSX
j?oVi^Koh^;Rom_Kfon_[jl0h_ooool000Gok^k^03koXj>SomcLg?oRh^;o
KkgTog2jgomi^]SoPKO?ohFc`_n>];ooT[O0oi2e__nE^LOoTkO5oiRhaonJ
]<7oX[6hokBi_?o4`Kco`kNYolfiX?oNaJOogL>Xon;=/?oiiL[omnO=omk?
^?o=`J_oZIj<olFlZooajMcoooocooomloogln[o/JbVodU5@_m9BdSoB4i<
odiDD?mDGUKoG6MQoem^IomJJfGoDVESoceBDolW?d7o73<ioa/d>OlL=C[o
83a0ob<o@_lP=cgo8c=0obTeAOlY=4Ko9S92obD^?OlV;cko:C4nob/c@?l/
<SkoBU1LoemVL0;oHfYd02?oGfI^oe=JH_m;CU?obLW9ono[j?ooo__ooO[e
ongUh_ne[ZSoa;^donGKd_oOdlOo_jnRoiN5MonTTH;o[iZ9oiN2KonPRgKo
_jRFolffY_o1ZYco]Z2CojjHRonSTHGoZIV<ojnQU_nZWICoZInFojNNUonU
WYSoYinLoj6IUonOUiGoYJ2MojNRW`0Eon_[j`;oj^[Z00Goj>SXonKVi_oR
h^;og=cLoj>SX`05onk^kP06oj>SXooLg=coh^;RonKVi_nLW9coVi^K0_nL
W9`01onKVi_oW9bLoibLW?nLW9coWIfMoibLW?nMWId00_nLW9`01?nNWYko
X:2PoijNW_nOWil2oj6QX@08oj:RX_nVYZKoYZJVoj:RX_nPX:3oVYZJoinO
WonVYZH2ojZZZP03ojRXZ?nLW9coRh^;00;oS8b<00SoSHf=ohn?Son@T93o
TI6Aoi2@T?n?ShooS8b<ohV9R@?oQhN700CoR8R8ohV9ROn8R8SoQhN70on8
R8P2ohN7Q`?oR8R801koSHf=oi2@T?nATI7oTI6Aoi2@T?n>SXkoS8b<oj6Q
XOnWYjOoZZZZojVYZOnVYZKoWIfMoinOWonTY:CoXj>SoifMWOnFUYKoV9RH
oiZJV_nFUYKoUiNGoibLW?nOWiooWIfMoi^KVonJVY[oV9RHoiZJV_nKVi/5
oiZJVP;oVIVI00?oVYZJoi^KVoo[jn/05Oo[jn/2on[ZjP05onSXj?oVi^Ko
h^;RomcLg?nSXj<01Oo^k^h01?nSXj?ofm_Kon;Rh_oVi^H2ooooo`03olc<
c?mgMgOogMgM00;oc<c<00?o<c<cooo<c?ooc<`05?ooc<`4ooo<V@05oonI
VOooc9WoolbIooo<VOooVIT01?ooc9T01?ooc6KooiUVoonII_ooVFH5olbI
IP?ooiUV00GoolaVoonII_ooc9WooiUVooo<c003ooooodGojn_[00Ooj^[Z
onWYjOoXj>Soi^KVon;Rh_oKfm_oXj>S0>;ok^k^0005onKViP1SoifMWOoK
fm_oh^;Roffmh_ma_MooNKcIognkdon6^lgoR;W:ohJib_n4^<goPkWAohBj
e?n9^mCoT;W=oiVe`OnW][_o_;jkolk6^oo=^jGocKRKok^VRoneXHSoeL>[
om72Zoo]h<gon?3Mon[Sdoo3_JooZ:BIok2]Y?oPgMKooO[eoooonooalO7o
XJB[odA8Dom=DEgo@dMCodaBH?mBF6KoEeeYoeMNJ?ll@dWo;34eoaTN8OlW
:bko;BhbobPY;_lY:Roo:bheobHZ<olQ:33o=3]5ob8Y<Ol]=3co;cHnobXa
>Ol_=Sko?457oeEJH?mZKGKoDeIOoeaLI_m1@DWoT92Hon_Yk_oom_KoooOb
ooWZiOoCa;oog/o:onkOf?oPdl[o]jfQogM]HOmLDdCoFU=3oe5:>?m?BSOo
IV5>oibGPon_Z9Ko/ZBGok:RUOn[VhkoXiF8ojJHSOn/WiKoZZ2Goj>JTonU
WYSoYinLojBOW?nRW9coXYbNoj2JW?nSWJ7oZjFY01Gojn_[0_oZj^X01OoX
j>Soi^KVon;Rh_oKfm_oWIfM00Goi^KV00CoWIfMom_KfooRh^;oi^KV2_nL
W9`2oifMW@04oibLW?nMWIgoWinOoj6QX@;oWinO01CoW9bLoi^KVonPX:3o
X:2PojFUYOnXZ:SoYJFUoinOWonKVi_oW9bLojBTY?nYZJWoZZZZojRXZ?nK
Vi_oS8b<ohf=SOn;Rh_oSHf=ohj>SP;oShn?00?oRXZ:ohN7Qon4Q8@00_n7
QhL00on6QXKoQhN7ohN7Q`02ohJ6QP0>ohV9ROn6QXKoR8R8ohR8R?n7QhOo
R8R8ohZ:R_n>SXkoTY:Bohj>S_n?ShooRXZ:oiRHV?nWYjL2ojVYZ@09ojNW
YonQXJ7oXj>SojFUYOnSXj?oWIfMoi:BT_n>SXkoSHf=00;oS8b<00?oT92@
oiVIVOnLW9`00_nKVi/01_nJVY[oVIVIoiVIVOnJVY[oVi^KoiVIV@OoVYZJ
00?oVi^Kon_[joo[jn/05?o[jn/2on[ZjP05onSXj?oVi^Koh^;Rom_KfonM
WId01OoVi^H01?nMWIgofm_Kon7QhOoUiND2ooooo`06olc<c?n8R8Sok^k^
omgMgOo<c<co<c<c6?ooc<`4ooo<V@04oonIVOo<VIWooiVIolbIIP;ooiUV
0oooc9T2ooo<IP?ooiUV1Oo<VFH2oonIIP03oonIVOooVFKoolc<00?ooooo
AOo[jn/01ooZj^[ojNWYonSXj?oUiNGohN7Qom_KfonMWId0h_oVi^H000Go
k^k^03KoXj>Som_KfooRh^;oKK_Oofnkfomd^MKoMkWAog^ic_ml^LkoN[[C
ogVje_mf^mcoMk_Nogjmg_n7_MWoTkW<oijf`?n]]kWo^k^colFiZOo7]Z;o
bkbWokN[UOn[X8coS8Aaog5ZF?mnN6So`[n`onOSeooclNGo`[nfoinLTonV
XicofMKAooWhm_ojnoooin[cohN9U_li>d[o@D9Dod=4E_m?DEkoEeMQodY:
C?m<BdWoEE9=odi9@omBB4KoH5IEoea@E?mFCE3oEUIFoe9FEOmCEeH2oe9F
E@09oe]OG_m=DE3oIFUXoe]MG?mYJVcoHV9Todm?DOmQGfCod<kC00;ooogo
023ooo[eon7>aonn[JGoh<o7oncNeOnfZJ3oNg5WoeiFBomSGE7oI69FodQ8
??li?37oCeE;oi2HSOnV[JGoWZ>Loi>BSOnOW9OoYJ:Moj>PVonOWYWoXJ2L
oj>SXOnRY:?oXJ:Toj>TZ?nSY:WoXj>[ojJV/?nTY:koYJFaojb/^1Gojn_[
00Ooj^[ZonWYjOoXj>Soi^KVon;Rh_oKfm_oXj>S00Gok^k^00CoXj>Som_K
fooRh^;oi^KV1?nKVi/7oibLW0?oWIfM017oWYjNoinOWonOWiooWYjNoinO
WonLW9coVYZJoiJFU_nATI7oU9BDoinOWonUYJGoZ:RXoinOWonIVIWoVi^K
oj>SX`02ojVYZ@03ojNWYonFUYKoRXZ:00;oRh^;00GoSHf=ohj>S_n<S8co
S8b<ohf=S@02ohb<S0;oSXj>00?oSHf=ohj>S_n>SXh00on>SXh02On?Shoo
SHf=oi6ATOn?ShooTI6Aoi2@T?n=SHgoT92@oj:RXP02ojZZZP0CojVYZOnS
Xj?oWIfMoj>SXonUYJGoW9bLoi>CTon>SXkoShn?oi2@T?n;Rh_oRHV9ohf=
SOnHV9SoW9bLoiZJV_nHV9SoVYZJoi^KV`03oiZJVP;oVi^K00?oVYZJoi^K
VonKVi/01?nKVi/00onLW9cojn_[on_[j`04on_[j`03onWYjOo[jn_ojn_[
00gojn_[00Ooj^[ZonWYjOoXj>Soi^KVon;Rh_oKfm_oXj>S00Gok^k^00Co
Xj>SomWIfOoPh>3oiNGU0_ooool01_o<c<coR8R8ooooooo^k^kogMgModA4
A1Coolc<0_ooc9T2ooo<c0SoolbI0oooVFH3olbIIP07oonII_ooc6KoolaV
ooo<I_ooVFKoc9UVoonIIP03olbIIP;ooiVI00?ooiUVooo<c?ooool00_oo
oom5on_[j`07on[Zj_oYjNWoinOWonGUiOoPh>3ofMWIoj>SX`3Ronk^kP00
1Oooool05?n_[joofm_Kon7QhOma_MooLKcKog>jf?md^]CoM;[CogBleOmc
_]goLKoSofbni?m^_NKoLkgTognngon<_=?oU;S6oj:f_On/][Go]kN_0_n`
[:00COn[Yi_oViV<oh1nLOmPGU7oKfePofMUF?m[JEcoW9R<omGAaOo[iMWo
`K^_ojJPU?nRW93ohMoCoooon?obl_3okNg_og5bMom7B4goA4E9oeUIEomd
MV_oLW=SofMVD_n1OV_oKFEHohV0Mon4NGGoQh1jog]iKOmnP7;oVYb>og]m
KomnPWCoNWi`ogn1M_mhNVooM7I[oemPF?m1@CWoWIZCooojm_ooo?Somo;^
oncUgoo0^:goal2`on3IbOo6_jooMg5Sof1LD?mEDdOoG5aDoe5BCOmHGEWo
>Clooc0j??m:EE_oIgAmoeeYMOmMJgKoRINPoiJU[?nQ/;OoX[6hoij]]?nL
[KGoWk2hoj2b_?nIZkOoVjfkoi^/_?nL[KooX;75oij_`onM[LCoXK7:01Go
jn_[00Ooj^[ZonWYjOoXj>SoiNGUon7QhOoKfm_o[jn_00Gooooo00Co[jn_
om_KfooQhN7oiNGU0onLW9`2oi^KV`KoW9bL1OnMWId03_nNWYkoW9bLoibL
W?nKVi_oVIVIoiBDU?n?ShooTY:Boi2@T?nATI7oVIVIoj:RX_nVYZKoWinO
0_nJVYX04?nUYJGoZZZZojRXZ?nWYjOoTi>Cohb<S?n;Rh_oSXj>oi>CTonB
TY;oT92@oiBDU?n@T93oUIFEoiBDU?nEUID2oiBDU00LoiVIVOnDU9CoUIFE
oiBDU?nEUIGoU9BDoi>CTon?ShooRXZ:oiVIVOnYZJWoZZZZojRXZ?nVYZKo
WYjNoj2PX?nTY:CoWinOoi:BT_n?ShooSHf=ohn?Son=SHgoShn?ohZ:R_n9
RHWoSHf=oi:BTP;oTI6A00?oV9RHoiZJV_nLW9`01OnLW9`01OnKVi_oW9bL
oibLW?nLW9coWIfM00;oW9bL00?oWIfMon_[joo[jn/00oo[jn/01?ld=3Co
?Cdmod92@_n>SXh<on_[j`08ogQhN?n6QXKojNWYonSXj?oUiNGohN7Qom_K
fon_[jl5ooooo`04ojn_[ooGemOogmoOon?Sh`;ooooo00Koc<c<ohR8R?o^
k^kok^k^omgMgOm4A4@Gooo<c004ooo<VOo<c9WoolbIoonIV@SoolbI00?o
oiUVolbII_o<VFH00_o<VFH00oooVFKoc9UVooo<IP03ooo<IP06oonII_oo
c6KooiVIolbIVOooVFKoolc<0ooooom5on_[j`07onWYjOoXj>Soi^KVon?S
hooPh>3oemOGojn_[`3Rooooo`001Oo^k^h00onSXj?ofMWIon3Ph002og:m
g@;oL[cI04ooLkgJog6ng?m__n;oKL7VofW0jomZ_^[oK[gVogNmhOn3^]So
T;[@oiblbon[_/Co[K:^ojbYX?nNVi;oYjNMoinOUOmcLfOoHF5EoeeMDOmJ
FTkoKFeQog5aIOmZJ5_oV9J9omC@a?oWhmOob<Ffoj>NRon_ZYOok^[Ooo_h
lOoooo_ob/[8odQ9A?lm?SSoHF=FogUlJon8RgSoPX=aohR6NOn6Pg[oSHR4
ogUfLOn4Q7[oMGIXogn0L_mnP7;oMgU/ogeoL_mlOW?oMgM]ofMWGOmGEdoo
fmSAooSek_ooo_SooOK`olo7a?nn^K?oj>SNoloAa?n7RGcoIFMJoeIHCOmJ
G57oIFQQoeUNF?mJH5koE5aNod=<Dolg@D_oBUITod5>GomEI7OoP9:XoiF`
aOnF]L[oVKS=00;oV;O<0_nH^<d02OnG]lkoU;C=oi:dcon?/LgoT;;>oiBe
e?nA/]7oSZo@oi2be@09on_[j`03onSXj?oPh>3ojn_[00;ojn_[00?oj>SX
onKVi_o[jn/01?o[jn/01ooZj^[ojNWYonOWiooUiNGoh>3PomWIfOnSXj<0
1Oo^k^h01?nSXj?ofMWIon3Ph?oUiND=oibLW009oifMWOnNWYkoWYjNoifM
WOnLW9coVIVIoi^KVonJVY[oTY:B00;oShn?01goSXj>oi6ATOnBTY;oTI6A
oiRHV?nRXZ;oYJFUoj2PX?nJVY[oW9bLojJVY_nYZJWoZZZZoj6QXOn<S8co
RXZ:oi2@T?nDU9CoUYJFoiFEUOnFUYKoUIFEoiJFU_nCTi?oUIFEoi>CTonE
UIGoU9BDoi>CT`02oiBDU00@oi>CTon@T93oSXj>ojBTY?nXZ:SoZZZZojVY
ZOnQXJ7oWYjNojJVY_nRXZ;oUYJFoi2@T?n>SXkoShn?oi6AT@;oShn?00So
SXj>ohb<S?n:RX[oSHf=ohb<S?n@T93oUiNGoibLW0OoWIfM1?nLW9`01?nM
WIgoW9bLoibLW?nLW9`5on_[j`05onWYjOo[jn_oiNGUoaLG5oo=cLd01Oo[
jn/2onOWi`0<on_[jooQhN7ojn_[on_[jooAdM7o:BTYonWYjOoWinOoiNGU
on3Ph?oIfMWoXj>S1Oo^k^h01?nSXj?og=cLon;Rh_oVi^H2ooooo`03olc<
c?mgMgOok^k^00;oc<c<00?oA4A4ooo<c?ooc<`05_ooc<`00oooc9Woc<bI
ooo<V@02ooo<V@03oonIVOooc9WooiVI00KoolbI00?oolaVolbII_o<VFH0
1Oo<VFH01_ooc6KoolbIoonIVOooc9WooiUVooo<V@?ooooo7_o[jn/2onOW
i`03on_[jooQhN7ojn_[00;ojn_[00?ogMgMonWYjOo[jn/01?o[jn/00ooX
j>Soi^KVon_[j`0=on_[j`03omKFe_oBd];ojn_[00Kojn_[0_oZj^X01OoX
j>Soi^KVon;Rh_oLg=coXj>S0>;ok^k^0005onKViP0hoifMWOoGemOogmoO
og2ig?ma^]_oL[_Log:kfomb_MgoKkkOof^mh_mZ_NGoJ[oXof^nj_m^_NKo
M;cTogjjg?n7^]OoU/3HojW3d?nSYJ;oYI^?oj6IS?nSWI7oViN;ofMUFOmQ
Ge?oEeU<ofIXGOmDEdkoFEaCof1UG_mSJ67oIFYSoijSWOoRi=WoiMk<olVl
ZOn/X93o_kNZoo?_i_ooooSol_?]ohnAS?ll@ccoC5I>odMABOmOJ6?oJW=`
ofM_LOmVKW7oMgb0ofUZK?mMGEgoM7Adofi^K_mgMgL2og5cLP03oe=CDon4
Q8Cok^k^00;oooko02CojN?UokF_/Oo6_L3okNS/oj:WZ_mIHfCoEV1OoeQQ
H?mGH5ooFfAQoeENFom8DE3oCEIEodmGF_m6CE?o<CY3ocm9DomBFf[oP8VJ
oj6cbOnH^]goSk_Roh^igOn8]][oRKOIoh^ifon:^=[oQ[KJohZjg_n8^]oo
PKGLoh2dfon3^>3oP;GMogfbg?mo]]l4on_[j`0Hon;Rh_lA4A7ojn_[on_[
jon?Shoo:BTYoclo?omaLG7ojn_[ohB4Q?lk>c_o@T92ofa/K?o[jn_oh^;R
oa4A4Oo[jn_ojNWYodi>C_nQXJ7ohn?Son3Ph?oGemOoWIfM1OoVi^H01?nM
WIgoemOGomoOgooShn<2oi^KV`coW9bL00goWYjNoinOWonKVi_oVYZJoiVI
VOnJVY[oVIVIoi2@T?n?ShooSXj>oi6ATOn>SXkoShn?00;oT92@00ooTI6A
oiZJV_nUYJGoYJFUoinOWonJVY[oWYjNojNWYonZZZ[oZ:RXoiNGUon:RX[o
SHf=ohb<S?n@T9000_nBTY801_nATI7oU9BDoi6ATOn?ShooTi>Coi:BTP?o
Ti>C00?oSHf=oiJFU_nWYjL00_nZZZX01_nVYZKoWIfMoj2PX?nVYZKoVi^K
oi2@T0?oShn?00[oT92@ohn?Son=SHgoSHf=ohj>S_n<S8coRHV9oh^;Ron>
SXkoUYJF1?nMWId2oibLW003oifMWOnLW9coW9bL00;oWIfM1?nLW9`00onK
Vi_oW9bLon_[j`04on_[j`07oiRHV?lf=SKoGemOod];Bon][Jgoh^;Roa4A
4@02on_[j`0?olO7aolQ8B7oCdm?ogUiNOla<C7obl_;on_[jooFe]Ko10@4
ojn_[ooVi^Kohn?Son3Ph?oGemOoWIfM00Goi^KV00CoWIfMomcLg?oRh^;o
i^KV0_ooool01_o<c<coR8R8oooooooMgMgoc<c<oeEEEA[oolc<1?ooc9T0
1OooVIWoc<bIolbII_o<VFKoc9VI00KoolbI00?oolaVoonII_o<VFH01?o<
VFH01?ooVFKooiVIoonII_ooc9T3ooooo`Cojn_[00?o@T92okBd]?o[jn/0
0_o[jn/01?maLG7oGemOon;Rh_lA4A42on_[j`07odm?ConTY:Coh^;Roa4A
4Oo[jn_oh^;Roa4A4@02on_[j`0Aoc4a<Oo0`<3ojn_[ofe]KOn5QHGoalO7
ob4Q8Om?CdooNGUioc4a<Oo;bl_ojn_[ofIVI_lj>S[o^[Zjon;Rh_lA4A40
0_o[jn/01on4Q8Co>c/kod92@_m/K6cojn_[on;Rh_lA4A400_o[jn/00om?
CdooY:BTon_[j`03on_[j`0;okBd]?lR8R;o71`Loe9BD_lR8R;oY:BTom[J
f_l;2`_ojn_[om_Kfol92@T00_oZj^X01OoXj>Soi^KVon;Rh_oLg=coWIfM
0>;oi^KV0005onk^kP1Doj>SXooLg=coh^;Rog:hg?ma^]goLkcOogBmh?mc
_N3oL[kRofjnhom[_N?oJ[cToffliOm`_NOoM[kVog^khOn1^McoRK_Loi^n
d_nj_[ooZ:2EojZTV?n?RGgoQh=hofMUFOmJFTkoFeeBoeQKD?mNI5[oIF]Q
oe]QEomLHE[oFUmHoemTGOmNGUCoW920oo?Rd?oWf<Go`KBTokJ_WooUhMGo
lo?Yoo_nmoo5b/Ko=C/kodaDE_m@F5_oEemRof5XK_mkPXSoNGj2oeQGGOmR
H6GoIF=XokRf^onTXZOoMgMioe]KGOnj^[colo7dooonooojm_OofM?Cokbc
]?oYh>7o`KNhofANH?mPHF?oJ71bofQ]L?mWKFgoLgMfofY^KOmoQ83oP89o
ogQjNOmhNG_oFUeRod]>EOmGFfKoQH^GoiRN[?nDY;_oTKKP0_n8^nX03On7
^^OoQ;WUoh>hh_n3^^?oQ;_Toh:ki_mo^^CoNKKRogNfhOmj^^KoN;STogBg
i?mh^nP01?o[jn/01_oRh^;o4A4Aon_[jooKfm_o3`l?om[JfP;ojn_[013o
emOGob8R8_oXj>Sojn_[od51@Oni^KWoh^;Roa4A4Oo[jn_oj^[Zodi>C_nR
XZ;oi^KVon;Rh_oLg=coXj>S1Oo^k^h01?nSXj?og=cLon;Rh_oVi^H2oi^K
V`KoW9bL00?oVi^KoibLW?nLW9`00onLW9`03OnMWIgoWYjNoinOWonJVY[o
Vi^KoiJFU_nEUIGoT92@ohj>S_n?ShooSXj>oi2@T?nATI400on?Shl04on@
T93oShn?oiRHV?nVYZKoY:BToijNW_nMWIgoYJFUojRXZ?nZZZ[oXJ6QohV9
ROn=SHgoSXj>ohn?SonATI7oUIFEoiBDU?n>SXh00_n@T9003?nNWYkoVi^K
oi>CTon?ShooWinOojRXZ?nZZZ[oZJVYoj>SXonNWYkoYJFUoinOW`;oT92@
00GoTY:Boi6ATOnATI7oTi>Coi:BTP02oiFEU@;oU9BD00CoShn?ohb<S?n?
ShooUiNG0_nJVYX4oifMW@;oW9bL0onMWId2oibLW005oi^KVonLW9coW9bL
oi^KVonLW9`01?o[jn/02?oBd];o7AdMolk>c_nl_;co8B4QoijNW_oRh^;o
4A4A0_o[jn/01OnHV9SoGUiNon_[jomgMgOoKVi^00;ojn_[00SoPH61ob`/
;?mCDe?oj>SXonKVi_oRh^;og=cLoj>SX`Gok^k^00CoXj>SomcLg?oRh^;o
i^KV0_ooool01_o<c<coR8R8ooooooo^k^kogMgMofIVIQcoolc<1Oooc9T0
2?ooVIWoc<bIoonII_o<VFKooiUVooo<I_ooVIWoolaV0_ooc9T02Oo<c9Wo
olaVolbII_o<VFKooiUVoonIVOooc9WooiVIolc<V@03ooooo`Cojn_[00Wo
WinOoeIFE_o[jn_ojn_[onSXj?lG5aOo_;blon;Rh_lA4A400_o[jn/01om?
CdooY:BTon;Rh_lA4A7ojn_[on;Rh_lA4A400_o[jn/02_la<C7o`<30on_[
jom]KFgoQHF5oiRHV?mNGUkojn_[ogMgMom^KVh2on_[j`0>o``<3?oRh^;o
jn_[on;Rh_lA4A7ojn_[omOGeolR8R;oj>SXon_[jom1@D7o^KVion;Rh_lA
4A42on_[j`03odm?ConTY:Cojn_[00;ojn_[00cogMgMoa<C4on=SHgojNWY
on_[jom@D53oUYJFom[Jf_l;2`_ojn_[om_Kfol92@T2on[ZjP05onSXj?oV
i^Koh^;RomcLg?nSXj<0h_o^k^h000Gooooo06?o[jn_omcLg?oRh^;oMKWP
ogBih?me^^7oLkcOogBmh?mc_N3oLkgRog:nh_m`^n;oL;[Qog:jh_mf^nCo
NK[RogZhgomn^>3oS;SEojFb^_nIVYGoVY^Foh62O?miNWCoL7=Zofe^I_mb
MF[oMWQ]ogIhJomlOW3oNga^ohZ8NOn>S7goUI>4oiJ?OonOSH7oXhf0omC1
/_ofimCodlRfoj2IQooCcKoon?G/oockmooXi^WoTY2EoiZHWOna[k;o[J^/
omkJeooJe]?oh=[LokF/[oo2^KcoiMoOokB^[_nWXYoodm3;oocim?ooo_So
lnoVolO0]_oLdl[ocL>ioj:ES?n]WiCoXYF<ojFKT_nIT8OoZ9jEojJLTonP
V8goXi^@oibCR_nGSXGoXIRAoiF=R_m^J6SoI69WogelQ?nTY:koYZReoin[
`onB]MooRkW[ohbjk?n;^n_oR;_XohFji_n3^^?oQ;_TognihOmn^N7oNKSQ
ogRihOmi_>KoM[_Tog6hh_me_>H01?o[jn/01OoRh^;o4A4Aon_[jonGUiOo
@d=300?ojn_[013oUIFEoeADE?o[jn_ojn_[ogQhN?mdM7Coh^;Roa4A4Oo[
jn_oj^[Zodi>C_nRXZ;oi^KVon;Rh_oLg=co[jn_1Oooool01?n_[joog=cL
on;Rh_oVi^H@oibLW005oifMWOnIVIWoVIVIoiFEUOnDU9@00_nBTY83oi>C
T`;oU9BD00CoUYJFoiNGUonHV9SoUiNG0_nHV9P08?nPX:3oYZJVoj6QXOnI
VIWoXZ:RojRXZ?nYZJWoYZJVoiRHV?nIVIWoWIfMoibLW?nTY:CoXj>SojBT
Y?nMWIgoWinOojFUYOnMWIgoVi^Koj:RX_nYZJWoZZZZojNWYonPX:3oXj>S
oj2PX?nIVIWoVYZJoiVIVOnJVY[oV9RH0_nJVYX02_nIVIWoVYZJoiRHV?nG
UiOoVIVIoiNGUonATI7oT92@oiBDU?nKVi/2oibLW0SoWIfM1_nLW9`00onK
Vi_oW9bLon_[j`03on_[j`08oi>CTomDE5Cojn_[on_[jomEEEGoWIfMon;R
h_lA4A42on_[j`05onOWiomBDU;oK6a/odU9BOmaLG400_o[jn/02?lU9BGo
_Kfmob@T9?oGemOoi^KVon;Rh_oLg=co[jn_1Oooool01?n_[joofm_Kon;R
h_oVi^H2ooooo`03olc<c?mgMgOok^k^00;ogMgM00?oR8R8olbIVOooc<`0
5_ooc<`2ooo<V@03olc<VOooc9WoolbI00OoolbI00?ooiVIolbIVOo<VFH0
1?o<VFH00oooc6Koc<bIooo<V@03ooo<V@03oonIVOooc9WooiVI00;ooooo
00?ok^k^on_[joo[jn/00_o[jn/02OoWinOo5ADEobh^;_lg=cOo7QhNob`/
;?o[jn_oh^;Roa4A4@02on_[j`07odm?ConTY:Coh^;Roa4A4Oo[jn_oh^;R
oa4A4@02on_[j`0:oc4a<Oo0`<3ojn_[ofe]KOn5QHGoinOWoe9BD_m/K6co
BDU9og5aL@;ojn_[00So20P8on_[joo[jn_oh^;Roa4A4Oo[jn_oUIFEoeAD
E0;ojn_[00CoN7QhogAdM?oRh^;o4A4A0_o[jn/00om?CdooY:BTon_[j`02
on_[j`03oibLW?lA4A7oj>SX00;ojn_[00OoD51@oiJFU_oJf][o2`/;on_[
jooKfm_o2@T900;oj^[Z00Goj>SXonKVi_oRh^;ofm_Kojn_[`3Rooooo`00
1Oo^k^h01?nSXj?og=cLon;Rh_ma^Ml2og2hgP1MofjhgOm_^MkoL;[Mog6k
g_mc_=ooMKgSog:jh?m`^>3oLkSQogJihomf^^7oNK[TohJgf?nT]lSo/[Fl
oinPY?n>SXkoM7E`og5bK?n@ThcoW9nFoi^NTonCUHSoVIN8oifHQOnUWH[o
WI:0oj2EPonWUhOoXXanokBMSOnQS7Wo[Yb6onGE__oJc[So^:bLokV_Xooh
kn[oooSioo_emong/K?oTXb>oiB@SOnd[jWonoKboooloOocj>co/:FYoi26
Qoo:`;oomNgZooolm_oooOGom>gSolW3]ooTg]3oa/2`og1ZF_maJe_oKfYG
og=/G?moMFWoRWibohEgJ_nCPgKoSWiaohYjKOn4MV_oSh5hohAgKon9OWSo
OWAbogQbM?nQX:KoZZbiojJ]`?nO/]3oT[SUohNfj_n2]>OoQ;KWohFij?n2
^>KoOKKQogVdg_mj^>7oNk[SogVji?mh^nGoNKkXog>ji?m_]^3oLK[S00Co
jn_[00Goh^;Roa4A4Oo[jn_o`/;2oa/K6`03on_[j`0@ol;2`_ld=3Cojn_[
on_[jomGEeOoX:2Pon;Rh_l820SodM7Aon[Zj_m8B4SoY:BTonKVi_oRh^;o
g=cLoj>SX`Gok^k^00CoXj>SomcLg?oRh^;oi^KV1_nKVi/4oibLW0;oVi^K
1?nLW9`02OnMWIgoWYjNoiZJV_nGUiOoTi>Coi:BT_nHV9SoVYZJoiVIV@02
oiRHV003oiVIVOnJVY[oV9RH00;oVIVI00WoV9RHoi^KVonHV9SoVYZJoj>S
XonRXZ;oW9bLoifMWOnXZ:P00_nYZJT02onMWIgoUiNGoiRHV?nMWIgoZJVY
ojZZZ_nWYjOoW9bLoiJFU_nPX:3oYjNW00;oZZZZ00CoYjNWoj2PX?nUYJGo
X:2P0onATI401_nBTY;oTi>CoiFEUOnDU9CoUYJFoiFEU@;oU9BD00?oUYJF
oiBDU?nEUID00_nCTi<00onJVY[oW9bLoibLW002oifMW@?oW9bL00CoWIfM
oibLW?nLW9coVi^K1_nLW9`00onKVi_oW9bLon_[j`03on_[j`09okfm_Ole
=CGojn_[on_[jomEEEGoWIfMon;Rh_l92@Wof][J00?ojn_[00gojNWYog5a
LOmdM7Cojn_[okJf]_l^;Rkoj^[ZogYjN_n1PH7oi^KVon;Rh_oLg=coXj>S
00Gok^k^00CoXj>Som_KfooRh^;oi^KV0_ooool01Oo<c<coR8R8omgMgOoM
gMgo^k^k00;oR8R81Oooc<`00oo^k^koolc<ooo<c00Aooo<c0koolbI00?o
olaVoonII_o<VFH01?o<VFH2ooo<V@03oonIVOooc9WoolbI00;ooooo00?o
k^k^on_[joo[jn/00oo[jn/06?m^KVkoR8R8on_[jom6ATKoR8R8on_[jooR
h^;o20P8om7AdOo[jn_oB4Q8ojJVY_oRh^;o4A4Aon_[jooRh^;o2PX:om_K
foo[jn_o;bl_ojVYZOo[jn_oJVYZohJ6QP;ojn_[00?ojNWYog5aLOmdM7@0
0_o[jn/02?l820Sojn_[on_[jooRh^;o4A4Aon_[joo2`/;o=3@d0_o[jn/0
2?mGEeOoX:2Pon;Rh_l820SodM7Aon_[jom8B4SoYZJV0oo[jn/00on0P83o
Bd];on_[j`02on_[j`0>omSHf?oPh>3of][Jo`/;2oo[jn_ofm_Ko`820_m2
@T;o@D51oiNGUooVi^Koh^;Rom_KfonSXj?Ronk^kP001OoVi^H01_nMWIgo
fm_Kon;Rh_m[^MooJ[SNof^ig`;oK[cR0_m^^]h0:_m`^]ooLK_Pog6kh?ma
^n3oLKWOog:jh?md_N3oLk_Qogjde_nM/Lco[Zo3okRb_?nHSi;oRH1kohj7
OomkO7KoPHIoogn4OOn8RWooSXQhoi:5M?nGQG7oUh1^oiIoLOnIPW;oVh9/
oij6K?nPR6koVh=[oj2:L_o1[9OofLNcomO6]_nj[:7oj^3Gooonn?okn??o
moOeonW[j?oYk^[on_ckooomo`;oooSo01kooo_oookcnOoll_?ooo[hooke
l?oDcLGo]k>Xoi^IS?nEV8OoSiJ4ohnHQOnHYI7oVjJEojJYW_n[Z9oo]:bQ
ok^_Xono[ZCo_:jUokZ]YOnfZjGo[::IojNNUOnWWYWoZ:BSojBX/On;V:_o
Tjc;ohjdfon3]^D2ogngjP07ognijOn0^^[oO[_ZogfjjOmk^NSoN;SVogNg
i@02ogBgi004og>gi?md^>GoMKWVog>jiPCojn_[01Soh^;Roa4A4Oo[jn_o
jn_[od92@_m;Bd_oTI6AojFUYOo[jn_oA4A4ofMWIomeMGGo<c<con?ShooR
h^;o2`/;ode=COmcLg?o5ADEomKFe_oVi^Koh^;Rom_KfonMWId5onKViP04
oifMWOoKfm_oh^;RonKViP?oVi^K0_nLW9`3oi^KV`?oW9bL00coVi^KoibL
W?nLW9coW9bLoi^KVonLW9coWIfMoijNW_nHV9SoUIFEoiJFU_nDU9@2oiFE
U@SoUYJF0_nGUiL00onFUYKoUiNGoifMW@02oj6QX@03oifMWOnUYJGoZZZZ
00;oZJVY0_nWYjL01onYZJWoZZZZojVYZOnYZJWoZZZZojVYZOnXZ:P00_nY
ZJT00onRXZ;oWIfMoiVIV@03oiRHV0;oVYZJ0_nKVi/00onLW9coWIfMoifM
W@02oifMW@04oibLW?nKVi_oVYZJoiZJVP;oVi^K00?oVIVIoi^KVonLW9`0
2_nLW9`3oi^KV`?oW9bL1Oo[jn/06?lj>S[oJFUYofi^K_lM7AgoWIfMon;R
h_l;2`_oCdm?ohN7QooTi>CoFEUIoi6ATOl_;booZj^[on_[jomKFe_oQhN7
on[Zj_oDe=Co:BTYonKVi_oRh^;ofm_KoifMW@Goi^KV00CoWIfMom_KfooQ
hN7oiNGU0_ooool01oo<c<coR8R8onk^k_o^k^koc<c<oiVIVOnIIVH01ooo
c<`00oo^k^koolc<onk^kP0Aooo<c0KoolbI00?oc<bIolbIVOooVIT01ooo
c9T4olbIIPCoolbI0_ooool00oo^k^kojn_[on_[j`03on_[j`0Tol[:b_l[
:b_odm?Co`/;2ooLg=cojn_[on;Rh_l;2`_oCDe=ogAdM?lE5AGofMWIon;R
h_lA4A7ojn_[on;Rh_l;2`_oDU9BogYjN_lE5AGoG5aLogIfM_lR8R;o^;Rh
onCTi?mIFEWoTI6Aobl_;on[Zj_ojn_[ojVYZOl410CoR8R8olS8b?oRh^;o
4A4A0_o[jn/02om4A4CoIfMWogEeMOlc<c?ohn?Son;Rh_l;2`_oCDe=ogAd
M?lE5AGofMWI00?ojn_[00?oUYJFob8R8_o[jn/01?o[jn/03?oJf][o2`/;
on_[jooKfm_o2@T9on7QhOoPh>3oi>CTonGUiOoQhN7ofm_KoifMWN;oi^KV
0005onk^kP0@oj>SXooKfm_oh^;RofJhgOmU]mcoIkWNof^kh?m]^n7oK;[P
ofjjg_m_^mooLK_Pog:lhOma^n3oL;[Oog6kgP;oLkgP01;oNkOKohnae_nQ
/]3oX:Nioi2@V?n>RXOoV9F>oi^LU_nNXicoWJ:KojFWW?n/YIGo[Z>Aok6P
T?n[VH_oYIN>oj^MT_neY902okNUS@0SokNUSonnZIKockZYomW6]ooIakWo
glo2ojbOU_oId/Soooofoooon_onoo_ol_Wboo_oo_ofmO[ooO_ooocgoOod
k_;ooocooooloOoainKo]JfZokVd/?ocl>_oooojoo7hl?obo_ComOokoo;o
nooYn_;oi_;^onkdl_olo?[oookkooogmOoon?H00_oooOd02_ooo_golo?c
om_Lh?o7d=WoY;G7oh6L^On7[MCoR;OUoh2hjOml^^/3og^ijP06ogVijOmg
]nOoLkGUogNijOmf^>SoM;KV0_mb]^D00omc]nKoMKWXogBkj@04on_[j`03
onWYjOnYZJWojn_[00;ojn_[00?oaLG5oi>CToo4a<@00_o[jn/03_nn_[ko
/K6aon_[joo[jn_ojNWYojVYZOoOgmooWIfMolS8b?oXj>Soi^KVon;Rh_oK
fm_oXj>S1Oo^k^h01?nSXj?ofm_Kon;Rh_oVi^H7oi^KV`CoW9bL00?oVi^K
oibLW?nLW9`00onLW9`01_nMWIgoVi^KoiRHV?nGUiOoV9RHoiVIV@;oVYZJ
1?nKVi/00onJVY[oVIVIoiZJVP04oi^KV`07oibLW?nOWiooXJ6Qoj6QXOnS
Xj?oVYZJoj>SX`03ojZZZP06ojVYZOnZZZ[oZ:RXojZZZ_nYZJWoZ:RX0_nZ
ZZX01_nVYZKoWIfMoijNW_nXZ:SoZZZZojRXZ0?oZJVY00GoZ:RXojNWYonX
Z:SoZJVYojZZZP02ojVYZ@?oZZZZ00KoZ:RXojBTY?nRXZ;oWIfMoiVIVOnK
Vi/8oibLW003oi^KVonLW9coW9bL00CoVi^K0_nLW9`6on_[j`0<ok2`/?o>
c/ko_Kfmom?CdooYjNWoZJVYomSHf?nOWioojn_[olW9bOnIVIWo_;bl0_o[
jn/02On^[ZkogmoOon[Zj_oYjNWo[jn_omkNg_oRh^;ofm_Koj>SX`05onk^
kP04oj>SXooIfMWoh>3PonGUi@;ooooo00Soc<c<ohR8R?ooooook^k^omgM
gOnk^k_oIVIVonk^kPcoolc<00?ok^k^ooo<c?ooc<`03Oooc<`5ooo<V@03
olc<VOo<VIWoc<bI00;ooiUV1oooc9T01Oo<c9WoolbIooo<VOooc9WooiVI
00;ok^k^00?oooooon_[joo[jn/01?o[jn/00olm?CgoAdM7oeADE002on_[
j`0AonWYjOnYZJWogmoOoijNW_o9bLWojn_[onWYjOnYZJWojn_[onWYjOnY
ZJWog]kNoibLW?o7alOoj>SXojFUYOng]kL00_o[jn/00oo9bLWoVIVIokbl
_002on_[j`06okbl_?l51@GoY:BTom;Bd_oYjNWoZJVY0oo[jn/02Onn_[ko
/K6aon_[joo[jn_ojNWYojVYZOoOgmooWYjNolW9b@04on_[j`03om3@d?l8
20Soa<C400Cojn_[00cof][Jo`/;2oo[jn_ofm_Ko`T92OoZj^[ojNWYonOW
iooUiNGoh>3PomWIfOnSXj?Ronk^kP001Oooool01on_[joofm_Kon7QhOmU
]mgoI;KLofNfgOmZ^N000_m/^^001om^^N3oL;_Rog6kh_ma^n;oLK_Pog2j
gomb^^000_md_>80A?md^N3oN[WRoh6gfomfX;SoN9FSohbOXonX/jooa/_4
om3Cb?o>c/;odm72omOD`ooIelSoeMG9olG:`oniaLGo`<[9omGFc_o;bKco
]k>WojZTV?nSVY7oWYB;oj:ESOnZWIGob;jeon_RfOn_Z9kogMW>ooOdjoof
m^cooooeoogomoo`n>gonoohooOmloonooSonocdoo3_j_nm^[GoTXj=of=Q
H_mDDeSo:B`aob8W;Ol^=d3o72PdoaDS;_lT=Coo;Ci6oaXX<OlH9S7o;c]7
odA<FOm>DUkoDUAPoeEGHom3BeKoEFEeogfE[OnM_]goTKONoh6/eon9/n?o
R[[[ogjkj_mk^n_oN[[Z0_mi^NT01_mf^>SoM;KVog6ei?mg^n[oM[[YogBh
i`;oL;OU00?oLKSVog:iiomb^nP01?o[jn/00ooTi>CoBd];on_[j`0>on_[
j`07on[Zj_oYjNWoj>SXonGUiOoQhN7ofm_Kojn_[`05ooooo`06ojn_[ooK
fm_ohN7QonGUiOnKVi_oVYZJ1OnKVi/4oibLW003oi^KVonLW9coW9bL00Co
W9bL00GoVIVIoiNGUonIVIWoWIfMoj6QX@03oj:RXP?oXj>S00OoXJ6Qoj2P
X?nQXJ7oXj>Soj6QXOnMWIgoVi^K00?oVIVI00GoVYZJoj2PX?nUYJGoW9bL
ojBTY002ojRXZ0;oZZZZ01KoZ:RXojZZZ_nYZJWoZZZZojVYZOnWYjOoWinO
oiNGUon@T93oSHf=ohN7Qon6QXKoR8R8ohJ6Q_n5QHGoR8R8ohV9ROn6QXKo
QHF5ohV9ROn<S8coSHf=0_n>SXh02?n<S8coT92@oiRHV?nNWYkoWIfMoi^K
VonLW9coWIfM1_nLW9`2oi^KV`?oW9bL0onKVi/2oibLW1Kojn_[00Ooj^[Z
onWYjOoXj>SoiNGUon7QhOoKfm_o[jn_00Gooooo00Co[jn_omOGeooOgmoo
hn?S0_ooool01?o<c<coMgMgonk^k_oMgMd2olc<c005ofIV<oo^k^koolc<
ooo<c?o^k^h00oooc<`01Oo^k^koolc<onk^k_ooc<cok^k^00;oolc<00Co
k^k^ooo<c?ooc<cok^k^1oooc<`;ooo<V@03oonIVOo<c9Woc<bI00Coc9UV
0_o<c9T5ooo<V@04oonIVOo^k^koooooooooo`Kojn_[00?oVi^Ko`000?n`
/;002?o[jn/00ooTi>CoBd];on_[j`0@on_[j`05ojBTY?o[jn_ojn_[onCT
i?m;Bd/04Oo[jn/02onATI7o410@oeaLG?moOgooBd];ojJVY_oJf][o2`/;
on_[jooKfm_o10@400;oJVYZ00GoKFe]on?ShooPh>3oemOGojn_[`3Roooo
o`001Oo^k^h03?nSXj?ofMWIon3Ph?mU]mgoI;KLofNfgOmZ^N3oK;[Qof^i
gom^^N3oL;_Rofnih0;oL;[Q04ooKkWNog6igomc^n7oLk_Qog2jhOmW]]go
Kk_OogBedOmn//OoRJnloh>LXOm_OGkoGVAPof1PF?mRGeKoHF5Eof=VFomI
He_o@E5>obi3A?l_A4Go=d=3oc]4@Oli?cgo>d0lod94@Olo?Sco@Cdjode8
A?mXH5goUi2:olc5_On_Zj;ohmoDoooml_ooooCom_S[oo_om?o]n^WomOo`
ooKnkoobmN[o][N_oi>BSOmbKV_oIV9Soe9@EOm3@TSo?cm9oc4e@Ol_=D?o
?4=CocI0C?lX<cWo=D9:ob/kB?lb@U7oEF9boeaTLOmCEF7oFemZodmLK?m@
JX7oOZW<ohVmk?mm]nWoO;GZoh:dion4^>SoNkWZogJjjOmg^NWoM[[YogRj
j_mg^n[oM[[Yog>jj?mf^^WoLk[X00;oL[WW0_ma^>H2og2iiPCojn_[00?o
jNWYokZj^_o[jn/03_o[jn/01ooZj^[ojNWYonOWiooUiNGoh>3PomWIfOnS
Xj<01Oo^k^h01_nSXj?ofMWIon3Ph?oUiNGoVi^KoiZJVPGoVi^K00CoW9bL
oi^KVonLW9coW9bL0_nKVi/3oibLW003oi^KVonLW9coVi^K00;oVi^K00?o
V9RHoiBDU?n@T9000on?Shl00on@T93oShn?ohb<S006ohZ:RP09oh^;Ron:
RX[oRXZ:ohb<S?n@T93oV9RHoj6QXOnLW9coYJFU00;oZZZZ00?oZ:RXojZZ
Z_nXZ:P00_nYZJT02?nXZ:SoWYjNoiRHV?nBTY;oT92@ohf=SOn;Rh_oRXZ:
0_n8R8P03_n;Rh_oRXZ:ohR8R?n:RX[oRHV9ohZ:R_n?ShooT92@ohj>S_n?
ShooSXj>oi2@T?nJVY[oWIfM4?nLW9`2oi^KV`;oW9bL5_o[jn/01ooZj^[o
jNWYonOWiooUiNGoh>3PomWIfOnSXj<01Oo^k^h01?nSXj?og=cLon;Rh_oV
i^H2ooooo`09olc<c?n8R8Sok^k^omgMgOo<c<co^k^kodA4A?ooc<cok^k^
00?oolc<00?ok^k^ooo<c?ooc<`00_o^k^h2ooo<c004onk^k_ooc<coolc<
onk^kP[oolc<00?oolbIolc<VOooc9T02_ooc9T00oooVIWoc<bIolbIV@05
olbIIPCoolbI00?ogMgMooooooooool01_o[jn/00ooVi^Ko][Jfon_[j`08
on_[j`03onWYjOnj^[[ojn_[01?ojn_[00?ojNWYokZj^_o[jn/04Oo[jn/0
2_oCdm?oXJ6QoiZJV_nl_;coh^;RonOWionh^;Sojn_[onSXj?ne]KD2okBd
]005okFe]OoVi^Koh^;RomcLg?nSXj<0h_o^k^h000Goi^KV00CoWIfMomOG
eooOgmooI[SP0_mU]ml0EomW^N7oJ[WRofVhgom[^N3oKK_Rofbggom]^>3o
K[OPoffgg_m`^>3oL[[RogBih_m_^MkoMLGVof^lf_mc_]koM;GCognedOn0
YKooGgV:oeQVLomWJW7oI6=XoemOHOmMHF3oE5eLoci:B?l/>cSo:SXiobm1
@olfAD[o<Ci4obdh??lc?Coo>Sm2odE6B?mCDe?oJ6MUogIbKon:Qh;oXj2I
ok2]Y?oLfM3oo?[^oocll?oiooGonoohooSnl_ogn^oo^k^aoi^HSommN7;o
JF9LogE]J_n^YZ?oRX:0oe1;B?mMFE[oLW1aohF5QOnXYj?oa<:fofIXGOmD
GEcoLGb0oeYSJ?mBEUWoIVESoeYLFomIJ6ooBf^0ogbfg?mc^^koL;geogS1
n?mi]^GoNK?QogRhj?mb^>WoM;SYog:hjOmf^^_oMK_/ogBjjomc^n_oLKOX
og6ij@02og:jjP04og6ijOm`^>SoKkOWofjfiQGojn_[00OojNWYonSXj?oV
i^Kohn?Son3Ph?oGemOoWIfM00Goi^KV00CoWIfMomOGeooOgmoohn?S3OnK
Vi/2oibLW004oi^KVonMWIgoVi^KoibLW0;oVi^K00GoVYZJoi>CTon@T93o
TI6Aoi2@T003ohn?S`0Aoh^;Ron9RHWoR8R8ohV9ROn:RX[oRHV9ohR8R?n9
RHWoRXZ:oh^;Ron=SHgoTI6Aoi>CTonFUYKoVYZJoibLW?nTY:@00_nYZJT2
ojZZZP;oZJVY01CoWYjNoiVIVOnDU9CoT92@oi:BT_nLW9coUYJFohb<S?n?
ShooTY:BoiJFU_nKVi_oX:2Poi6ATOn?ShooU9BDoi2@T?n>SXkoT92@ohn?
S`;oT92@0onLW9`00onMWIgoW9bLoi^KV`08oibLW003oi^KVonLW9coW9bL
00;oW9bL0onKVi/Fon_[j`07onWYjOoXj>Soi^KVon?ShooPh>3oemOGoifM
W@05onKViP04oifMWOoLg=coh^;RonKViP;ooooo00Soc<c<ohR8R?oooooo
k^k^omgMgOo<c<coA4A4onk^kPKoolc<1?o^k^h01?ooc<cok^k^onk^k_o^
k^h=ooo<c0koolbI00[ooiVIolc<VOo<VIWoc9UVolbIVOooc9WooiVIooo<
VOooVIWogMgM0_oooom5on_[j`;oj^[Z00Goj>SXonKVi_oRh^;og=cLoifM
W@3RonKViP001Oo^k^h01?nSXj?og=cLon;Rh_mW^N42ofFgg`1?ofJhh?mX
]n3oIkKOofRgh?m[^N3oJKONofbggom]]]ooK;GNofnfh?ma^N7oLkSRofng
gom`_n3oI;CEog71i_mb_>?oO[WQogbZc?mLMiCoGFUoofU[N?mWI6goHEiU
of1QIOmOI6OoEEmNodmJE_mBGUcoCeiQoe]/LomUM7_oIW=iofQcNOmWKWCo
I6U]of9VJOm/KFooJ6QXofe/J_mfMG7oXj:MolG5_OoLg=Con__cooOnmood
o_Kol?O`okk3_?n?T8[oJFQSogMbK_mZIEooKfMToh5jM?n5OWSoQWmiohAo
Non3OW[oR8F0ohJ2NOn7P73oOg]_ogMmNomXLWCoEUiQoeaMGomYHUcoGU]F
oe1JG?m;J7[oMjkEog>jk_m/^?;oKkOaogBah?mn]nCoMKOWog6gj002og2f
i`06og6gj?mb^>WoL;SXog2hj?m^]^KoKkOW0oma^NT00om`^>SoK[KVoffe
i@0Eon_[j`;oj^[Z00Goj>SXonKVi_oRh^;og=cLoj>SX`05onk^kP04oj>S
XooLg=coh^;RonKViQ3oVi^K00?oW9bLoiZJV_nLW9`00_nLW9`01_nJVY[o
Ti>Coi6ATOnATI7oT92@ohn?S`;oT92@00GoShn?ohj>S_n?ShooSXj>oi6A
T@04oi:BTP09oi6ATOn@T93oTY:Boi6ATOnBTY;oTi>CoiZJV_nPX:3oY:BT
00?oZJVY00SoZ:RXoj2PX?nGUiOoTI6Aoi>CTon@T93oTI6AoiBDU0CoUIFE
00?oUYJFoiFEUOnEUID00_nDU9@02OnBTY;oShn?ohn?Son@T93oShn?ohj>
S_n@T93oVYZJoibLW003oi^KV`;oW9bL1?nKVi/00onLW9coVi^Koi^KV`02
oi^KV`?oW9bL0onKVi/Fon_[j`;oj^[Z00Goj>SXonKVi_oRh^;og=cLoj>S
X`05onk^kP04oj>SXooLg=coh^;RonKViP;ooooo00?oc<c<ohR8R?ooool0
0_o^k^h01?oMgMgoA4A4onk^k_o^k^h6ooo<c0Ook^k^3_ooc<`8ooo<V@04
olc<VOo<VFKoc9VIolbIV@OoolbI00CooiVIooo<VOooc9Woolc<0_oooom5
on_[j`;oj^[Z00Goj>SXonKVi_oRh^;og=cLoj>SX`3Ronk^kP001Oooool0
1?n_[joog=cLon;Rh_mT]n42of:eg`0Oof>fh?mT]N3oHkCOofBeh?mX]n3o
JKKPofZghOm/]n7oK;GPofnfh_ma^>;oLkOTofnfh?m]^MgoIkGKofjmj?m`
^^OoLZoLofRE_?mEKHWoGF9fofaVL_m`IF_oK69ZofUWK?m[Kg;oK75dofid
L_mdOG[oJ79cofMbM002of]eM`0^ofYbMOm_M7SoLGEhofibMOm/L77oKVma
ofmaL?mbM7?oJVaYojNYY_nm`[koc]C@ooKoooo_noWo_<K5oiFNWOmiOgoo
M7Qgofi`Kom^KVcoKF]/ofi]Jom[JVSoL6m]ofe/J_mWIfGoKFe[ofa[Iom]
JVGoKFaZof1YL_mJI73oGfMdof][LomcJFSoLFMUofMWJOmSLh;oI8f]ohFk
jOmo_??oN[G]oh2`hOn2]NCoN;SXog6gjP?oL;KY00CoLKOZog2fjOm`]^Wo
KkGX1?m`]^T3ofnej1Gojn_[0_oZj^X01OoXj>Soi^KVon;Rh_oLg=co[jn_
00Gooooo00Go[jn_omcLg?oRh^;oi^KVoi^KV`06oiZJVP[oVi^K00OoVYZJ
oibLW?nLW9coVYZJoiNGUonATI7oT92@00;oTI6A00?oT92@oi6ATOnBTY80
0_nBTY800onDU9CoTY:Boi:BTP02oi>CT`03oi:BT_nCTi?oTi>C00CoTY:B
00_oTi>Coi6ATOnLW9coX:2Poj:RX_nZZZ[oZJVYoj2PX?nIVIWoU9BDoi>C
T`02oi:BTP03oi6ATOnBTY;oTI6A00;oTY:B00OoTI6Aoi:BT_nATI7oTI6A
oi:BT_nATI7oT92@00GoTI6A00KoTY:BoiJFU_nMWIgoWIfMoibLW?nKVi/2
oibLW0ooVi^K5_o[jn/2on[ZjP05onSXj?oVi^Koh^;RomcLg?n_[jl01Ooo
ool01?n_[joofm_Kon;Rh_oVi^H2ooooo`03olc<c?n8R8Sok^k^00;ogMgM
00?oc<c<oeEEEOoMgMd01_o^k^h2ooo<c003onk^k_ooc<coolc<00Koolc<
00?ok^k^ooo<c?ooc<`01Oooc<`=ooo<V@04olc<VOo<VIWoc9UVolbIIP;o
c9VI1oooc9T2ooooodGojn_[0_oZj^X01OoXj>Soi^KVon;Rh_oKfm_o[jn_
0>;ooooo0005onk^kP1Eoj>SXooLg=coh^;Rof:ehOmO]=goH;?Oof6dg_mR
]N7oHKCNof:ehOmU]^7oJ;ORofZghOmZ]n?oK;OQofjgi?ma^>CoLKSVofnf
h_m^^=ooL;_SofZhi_m`^>SoK:WEoej:[omRMXkoKW1mogQ_M?mnLW;oNW5b
og=_L?m^LW?oK79boficKomdNGGoMGYfofeaL?maMGCoMg]jogEiN_mfNW_o
NGYlog=dM_maLg;oM7IeogeoO_mkOGcoMWQgogj0OOni_[[o_/>ook_1_oo?
eM?oX:JTofM[J_mTIVGoGemMoeMGEOmFEE7oDU5=oeaHEOmBCd[oD4e8oeEB
COmDDdkoGU]Fof9OF?m]J6;oLfm/og9gOOn0Qi7oV9bWoj>RZ?n^Y:;o_K:^
ol6l^OnHWjOoAf=iogRTaomn/^7oP;S[ohBhj_mi/NCoN;OZog6gjP02og2f
j@07og6gj_mb^>_oL[S[og:hjom`]^WoKkGXofjdi`02offciP03ofjdiom`
]^WoLKOZ01Gojn_[0_oZj^X01OoXj>Soi^KVon;Rh_oLg=coXj>S00Gok^k^
00CoXj>SomcLg?oRh^;oi^KV1onJVYX:oi^KV`07oibLW?nKVi_oVi^KoiVI
VOnEUIGoTi>Coi:BTP03oi>CT`CoTY:B00KoTi>CoiBDU?nBTY;oTi>CoiBD
U?nCTi<2oiBDU0?oTi>C00coUIFEoiBDU?nCTi?oUIFEoinOWonPX:3oWinO
oj>SXonKVi_oTI6Aoi2@T?n?Shl2ohj>SP04ohf=SOn>SXkoSHf=ohb<S0;o
SHf=0_n?Shl01OnATI7oTY:Boi>CTonFUYKoVYZJ00;oVi^K00KoWYjNoinO
WonJVY[oShn?oiVIVOnKVi/2oibLW003oi^KVonLW9coVi^K00?oVi^K0onL
W9`8oi^KVaKojn_[0_oZj^X01OoXj>Soi^KVon;Rh_oLg=coXj>S00Gok^k^
00CoXj>Som_KfooRh^;oi^KV0_ooool02?o<c<coR8R8onk^k_o^k^kogMgM
olc<c?mEEEGo^k^k2_o^k^h2ooo<c004onk^k_ooc<coolc<onk^kP_oolc<
0_ooc9T00oo<c9WoolbIooo<V@08ooo<V@;oc<bI00Coc9VIolbII_o<VFKo
c9UV1Oooc9T2ooooodGojn_[00Ooj^[ZonWYjOoXj>Soi^KVon;Rh_oKfm_o
Xj>S0>;ok^k^0005onKViP1OoifMWOoKfm_oh^;Rof>giOmP]n;oH;CRoenc
gomO/n7oH;CPof6ehomS]n?oIk[VofJgh_mW]N?oIkCPofZdhom/]N;oKKGU
offfhom]]^7oI[7Kofnij?m`]n?oIJ76odmkU_mmT9ko_/;3olBm]Oo7_kCo
`;bcol31^oo1a/;ob]3<omcQfooOh]_oinSRoo3_j_omo?OoooojooKelOoh
mo?oooomooWimooooogono_ioocln_oloOSoookjooOfl_oooo[oiN;Kok>_
Y_o6_kOolncToo;Yh_oYh=WoknGLomkDbooQelgog]C:on;Fb_oPe<Kof<bn
on7EaOoLdl;oe<RhomG9^OoFbkOof<nnolk:_oo7a/7oc<_7olk;a_o?a[go
e<c1om??`onTZJ?oBf1Uoef2U?mi[]3oO[gYofZaiom`^?;oL[O^og:ej_ma
]>WoL[GZogBgk?me^>goM;O/og:ej_me^>goLKCYofjai_m_/^L01?m`/nPE
on_[j`;oj^[Z00Goj>SXonKVi_oRh^;ofm_KoifMW@05onKViP05oifMWOoK
fm_oh^;RonKVi_nKVi/01_nJVYX4oi^KV`03oiZJV_nKVi_oVi^K00?oVi^K
00[oVYZJoi^KVonKVi_oV9RHoi:BT_nGUiOoX:2PoinOWonPX:3oWinO0_nP
X:003?nRXZ;oYJFUojFUYOnVYZKoYjNWojVYZOnZZZ[oZ:RXojVYZOnZZZ[o
ZJVYojZZZP;oZJVY0_nZZZX01OnXZ:SoZZZZojFUYOnMWIgoX:2P00;oYjNW
00SoYJFUojJVY_nSXj?oY:BToj>SXonTY:CoXj>Soj:RXP;oXj>S0_nQXJ42
oj:RXP03oj6QXOnPX:3oXJ6Q00;oXJ6Q0_nRXZ801_nKVi_oShn?oiBDU?nJ
VY[oWIfMoiZJVP;oW9bL0onKVi/3oibLW003oi^KVonLW9coVi^K00KoVi^K
5_o[jn/2on[ZjP05onSXj?oVi^Koh^;Rom_KfonMWId01OoVi^H01?nMWIgo
fm_Kon7QhOoUiND2ooooo`08ok^k^on8R8Soooooooooooo^k^kogMgMohR8
R?nIVIT3onk^kP03omgMgOo^k^kok^k^00Kok^k^00?oolc<onk^k_ooc<`0
3_ooc<`?ooo<V@03olc<VOo<VIWooiVI00CoolbI0_oooom5on_[j`07on[Z
j_oYjNWoj>SXonGUiOoQhN7ofm_KoifMW@3RonKViP001Oo^k^h01_nSXj?o
fm_Kon;Rh_mL]>;oG;GQoebdhP?oG;GQ0_mM]^80C?mO/n7oH;CPof>dhOmW
]N?oJKKTof^ei?mZ]>?oJ[;RofZagom//n7oM[[Yofj]e_mNTk?oE7V<ohbO
XooCf=;oeM75omK@`?o:a[[oalNmolS;a?o7b/?obL[2ol;2^?o3`;Ooal:l
okbi/_nn^kCoc/_6ol_8`oo0_k_o`L2lolK5`Onn^kKo`l2kokji/oo4_kWo
al2hol:k/on^YIco/JNNokN]Y?nn]:_o^k6XokNZX_o4]joo^jjVok6TVonm
/JGo^ZjPok:VV?ncYiOoYib:okJ[VOncZ9Co/JJBokBYUOn^Xi7oYYjAojVR
V?n/ZJ;oZJJQojFPV_nUXISoWIV>oi^KTOm`NGKoJH28ogZR^omh/]SoL;W`
ofBck_ma]^ooLkCZog6djOmb]NX2ogBgk00:og:ej_m_/^OoL[GZog2cj?m_
/^OoK[CXog2cj?m]/nOoK[7VofbbiQGojn_[00Ooj^[ZonWYjOoXj>Soi^KV
on;Rh_oKfm_oXj>S00Gok^k^00CoXj>Som_KfooRh^;oi^KV2onJVYX4oi^K
V`;oVYZJ00OoVi^KoibLW?nJVY[oUYJFoi:BT_nIVIWoXj>S00;oXZ:R0_nP
X:03oj6QX@05oj2PX?nOWiooX:2PoijNW_nOWil00_nQXJ42oinOW`0@oj2P
X?nOWiooX:2PoijNW_nOWiooX:2PoinOWonKVi_oW9bLoifMWOnNWYkoWIfM
oibLW?nOWiooWIfMoi^KV`;oWIfM0_nLW9`02_nJVY[oW9bLoibLW?nKVi_o
W9bLoi^KVonJVY[oVi^KoibLW?nKVi/2oiZJVP;oVIVI00KoTi>CoiBDU?nI
VIWoVi^KoibLW?nJVYX4oi^KV`;oW9bL2_nKVi/Fon_[j`07on[Zj_oYjNWo
j>SXonKVi_oRh^;ofm_Koj>SX`05onk^kP04oj>SXooIfMWoh>3PonGUi@;o
oooo00Soc<c<ohR8R?ooooooooooonk^k_oMgMgoZZZZoiVIVA3ok^k^3_oo
c<`7ooo<V@Coc<bI1oooc9T00oo<c9WoolbIooo<V@02ooooodGojn_[00Oo
j^[ZonWYjOoWinOoiNGUon3Ph?oIfMWoXj>S0>;ok^k^0005ooooo`06ojn_
[ooKfm_ohN7QoeRch_mH/n3oF;CS1?mI]^806_mH]N7oFK7Ooe^dh?mP]>;o
HkGTofFfiOmW]NGoJ;CUofZbi?mb]NWoMK?VogRbh?m]XLSoJI6[of1lR?mo
SHgoYjZQojNSUon]YiWoXIfAoj2NT_nSX9WoWi^BoinFSOnHShKoSHR20_nR
WiX0;_nDTHcoU9>?oh^:Q_n2Og[oTHj9ohN4Oon6PG_oUi28ohImM?mlLVSo
P7AXohn1M?nYW9?oZZ:Ooi^EUOmoNGWoP7YjogahMon8Q87oRHF2ogejMOn3
P7WoT8f4oiB@QonCShCoRhMkoi:?P?nBS7coSHMioiVBR?nHShSoUXf8oi::
R?n=R8coT8nEoi:BV_n>SiCoU92?oi>>R_nARXCoT96Coinb`on5[<goOk_a
ofnelOmb]>h2og:cj`;oM;G]00?oLkC/ofnbjOm/[nH00_m//NP01_m^/n[o
K[G[ofjcj_mY/>KoJJkUofV`iQGojn_[00Ooj^[ZonWYjOoXj>SoiNGUon7Q
hOoKfm_o[jn_00Gooooo00Co[jn_om_KfooQhN7oiNGU2?nJVYX01?nIVIWo
VYZJoiZJV_nJVYX3oi^KV`09oiZJV_nKVi_oVi^Koi^KVonHV9SoUYJFoi>C
TonFUYKoW9bL00;oVi^K0onJVYX2oiVIV@04oiRHV?nFUYKoVYZJoiZJVP;o
V9RH00OoUYJFoiFEUOnGUiOoUYJFoiFEUOnHV9SoUIFE00;oTi>C00CoUIFE
oiZJV_nKVi_oVIVI0onDU9@2oiJFUP06oiBDU?nEUIGoUiNGoiRHV?nGUiOo
UYJF0_nGUiL00onFUYKoV9RHoiRHV002oiNGU`05oiJFU_nGUiOoV9RHoiNG
UonHV9P00_nGUiL01?nHV9SoWIfMoi^KVonMWId8oi^KV`03oiZJV_nKVi_o
Vi^K00?oVi^K0onJVYXFon_[j`07on[Zj_oYjNWoj>SXonGUiOoQhN7ofm_K
ojn_[`05ooooo`04ojn_[ooGemOogmoOon?Sh`;ooooo00Goc<c<ohR8R?o^
k^kok^k^omgMg@02olc<c003oeEEEOooooook^k^013ok^k^2?ooc<`>ooo<
V@04olbIVOo<c9Woc<bIolc<V@;oc9VI1Oooc9T00oo^k^koooooon_[j`14
on_[j`07onWYjOoXj>Soi^KVon?ShooPh>3oemOGojn_[`3Rooooo`001Oo^
k^h00onSXj?ofMWIon3Ph002oeFdhP04oeFfhomF]nCoE[OToeNhh`;oE[OR
04WoFKKRoeZeh_mL]>;oGKCQof6ch_mS]>?oJ;KVofZfj?m_]^koKk3XogJ/
fomeXLCoQJBiohBFX?n7T8ooRHZ2ohj:OonJThWoThn6oi:=QonFShWoThZ5
oi^>R?nMT8[oUi2:ohb7POn?RXCoTXn:oiVFTOnKVYKoUYFAoibIU?nYYZ7o
W9NAoi^DS?nIT8OoWYB:oifAQOnLSX7oZ9jDojVTW_nJVIGoRXV5oiVHU?n?
ShgoTY:@oi>CTOnGV9?oUYFAoi^JUOnPWISoW9VBojVUW?n?Rh;oT8UooiF<
Pon>Q7_oSGigoiR7P?nOTHkoVi:EoiVHX?nHX:goUIn[oj2UZonATI?oUi:>
oj>QX_nZ^<GoQJC3og^ci_mb]?3oLkC^00;oL[?[00CoLKC[og:ek?ma]>_o
Kk;Y0_m[/>L01omZ/NOoJkCYofbej_mY/^OoIZoTofF^homW/>D05Oo[jn/0
1ooZj^[ojNWYonOWiooUiNGoh>3PomWIfOnSXj<01Oo^k^h01?nSXj?ofMWI
on3Ph?oUiND>oiZJVPCoVi^K00GoVYZJoiVIVOnJVY[oV9RHoiNGU`02oiJF
UP05oiRHV?nGUiOoUiNGoiRHV?nGUiL00onHV9P00onFUYKoUiNGoiNGU`02
oiVIV@04oiRHV?nIVIWoVi^KoiVIV@GoV9RH00KoVYZJoi^KVonIVIWoUYJF
oiVIVOnGUiL2oiRHV006oiVIVOnHV9SoVIVIoiZJV_nIVIWoVi^K0onGUiL0
0onFUYKoUIFEoiNGU`02oiRHV004oiVIVOnJVY[oVYZJoi^KV`;oV9RH00?o
VYZJoijNW_nJVYX02OnKVi/3oiZJVP;oVi^K1?nJVYXFon_[j`07on[Zj_oY
jNWoinOWonGUiOoPh>3ofMWIoj>SX`05onk^kP04oj>SXooLg=coh^;RonKV
iP;ooooo00Goc<c<ohR8R?o^k^kok^k^omgMg@02olc<c003ob8R8_oMgMgo
oooo00Cok^k^0_ooool8onk^kPcoolc<0_ooc9T00oo<c9WoolbIooo<V@0:
ooo<V@?oc<bI1Oooc9T00oo^k^koooooon_[j`14on_[j`;oj^[Z00Goj>SX
onKVi_oRh^;og=cLoj>SX`3Ronk^kP001OoVi^H00onMWIgoemOGomoOg`04
oe>ei01?oe6fi?mB]n?oDkSToe>hi?mF]nCoEkKToeVei?mJ]N;oG;;Qoenc
h_mS]NGoIKK[of:cm?mW/o7oLjgMogFP`_n=YkSoUj:Xoi^MW?nFThkoU8n;
oibGTonIU97oVI2AoiF;S?nBQXSoVXb<oiZ<RonKT8[oVI27oiZAR?nITX[o
VIJAoiZIUOnIV9CoVIVGoi^KVOnUYJ?oXZ6MojZWX_nZYJ7oYj2Joj^TW?n]
YYco/[2SojJWUonTYYSoZJ^Moj2RUOnYZj3o[:bTokVi/On`[JSo`;^golFm
^_oDb/Sob;fkol>e]?no[joo^ZNPokjWUOnhWXOobJfGomo8^?oDakoo^;Rj
ojFc`?nN/lCoUJRfoiRY/OnQ[:koWZ^aoi2V]?moY<7oNK?SofndkOmb]>ko
LK?]ofnaj`02offbj`05ofbcjom]]>coK;G/ofVbjOmV/NP00_mU/^P01?mQ
/NKoGjoTof2`iOmS/nPEon_[j`07onWYjOoXj>Soi^KVon?ShooPh>3oemOG
oifMW@05onKViP04oifMWOoGemOogmoOon?Sh`ooVYZJ00GoVi^KoiZJV_nK
Vi_oVYZJoiVIV@03oiZJVP;oV9RH00GoVIVIoiRHV?nHV9SoUiNGoiJFUP06
oiRHV0GoVIVI00GoVi^KoiZJV_nKVi_oVi^KoiZJVP02oi^KV`05oifMWOnK
Vi_oVi^KoibLW?nJVYX00_nLW9`02?nNWYkoW9bLoinOWonOWiooXZ:Roj2P
X?nNWYkoWIfM0_nLW9`01OnKVi_oWIfMoj:RX_nQXJ7oWYjN00;oWIfM0_nK
Vi/01?nLW9coVi^KoiZJV_nJVYX;oi^KV`OoVYZJ5_o[jn/01ooYjNWoj>SX
onKVi_oShn?oh>3PomOGeonMWId01OoVi^H01?nMWIgog=cLon;Rh_oVi^H2
ooooo`04ok^k^on8R8Soooooooooo`;ok^k^00Goc<c<ojZZZ_lc<c?oc<c<
ooooo`06onk^kP03ooooooo^k^kok^k^00Kok^k^3?ooc<`4ooo<V@04olc<
VOooc9Woc<bIolc<V@goolbI00?ogMgMooooooo[jn/0A?o[jn/2on[ZjP05
onSXj?oVi^Koh^;RomcLg?nMWId0h_oVi^H000Gok^k^06?oXj>SomcLg?oR
h^;oCkCRodjeh_m?]>;oCKCQodjeh_m<]N;oCkKQoe2gh_m?]>3oDkGRoeRg
iOmK]nKoG;CRoebbhOmN/^7oGK;XoeZdl_mO]>goK:gGofnN^_n:YKKoTjB/
oiJSZOn@Vj7oVJ>]oiZT[_nMXJ[oXjBYojFLWonTV9SoZibIoj:AR_n]WI3o
ZYZ;ojNIS_oCbKoomo3Xom[Gd_o4`koocm7@omcPhOoen_gom__noo_oooo^
l_Gok>g_ono`l_oRi>7oiN[SomGKcoo@e/[oalg3ol_@bOoDfM;ocLo:ol?4
_onYZ:CoZjNTooWak_ooo?[ooo7^ojjLV_o2/:coZYJ=okfRSOo@]I[oh/J^
om_6]Oo0]k;oYJjeoi6/`On4ZLKoQ:g9oi6fd?nG]/SoUK;4oh6S_?n1[M3o
N;CVog6fkom_]>goK[?/ofbaj_mZ/NWoJK3XofVbjOm[]>_oJ[G/ofNdj_mT
/NOoHK7Vof2ai_mN/NGoGK3Toenbi_mR]NT05Oo[jn/2on[ZjP05onSXj?oV
i^Koh^;RomcLg?nSXj<01Oo^k^h01?nSXj?og=cLon;Rh_oVi^H7oiVIV@03
oiZJV_nIVIWoVYZJ00WoVYZJ00goV9RHoiZJV_nJVY[oVYZJoiVIVOnJVY[o
Vi^KoiZJV_nKVi_oVYZJoiVIVOnJVY[oV9RH00;oVYZJ00OoVIVIoj6QXOnX
Z:SoXj>Soj2PX?nRXZ;oYJFU00;oZJVY00KoZZZZojRXZ?nWYjOoYjNWojFU
YOnVYZH2oj>SX`05oj6QXOnRXZ;oXj>Soj:RX_nPX:000_nKVi/02?nXZ:So
ZZZZojRXZ?nJVY[oWYjNoiVIVOnKVi_oWinO0_nQXJ402OnNWYkoW9bLoi^K
VonJVY[oVi^KoibLW?nMWIgoW9bLoiVIV@06oi^KV`;oVYZJ1?nKVi/7oiZJ
VQKojn_[0_oZj^X01OoXj>Soi^KVon;Rh_oLg=coXj>S00Gok^k^00CoXj>S
omcLg?oRh^;oi^KV0_ooool00oo<c<coR8R8ooooo`02ooooo`;ok^k^00Oo
gMgMolc<c?mEEEGo<c<cofIVI_n8R8Sok^k^00?ooooo2Oo^k^h<ooo<c0Wo
olbI0_o<c9T00oo<VIWoolbIooo<V@07ooo<V@03omgMgOoooooojn_[04Co
jn_[0_oZj^X01OoXj>Soi^KVon;Rh_oLg=coXj>S0>;ok^k^0005ooooo`1O
ojn_[ooLg=coh^;Rodfchom;]>?oC[CTodbei?m<]N;oBkKRodbeh_m;]>7o
CKCQoe6fi?mG^>GoFKSVoeZei?mL/^?oG[7Soebdi?mE]NOoF;?OofF_c?m^
Yk_oRKC4ohnda?n:/lOoOj_4ogj[b_n0ZLOoTJg3oj>c`?nWYjOo/ZFMol6^
WonfWHWo/9N3ol6XU?nPRg[oZYZ;onKId?ooo_Kojn[VojFYZ_li@DCo?TU?
od=AF_m<FVGo=D=>obhnBoleAE;o@55Kod9@FolkBE;o?TaEoce:D_m6De_o
@diDoeMPIOmHH6;ogn?Roooonooflncoi=gCoinEROnWVHcoZYZ;oib;NonM
RWWo_Z^LolVgZonaYZCoV9bWohnW_on4/M[oNK?Uog>biomb/>7oMZgFogj_
eomjZm?oN[3Nofn^i?m^/nkoK;7Zof^bj_mZ/NWoJ;7XofN`iomU/>OoI;7W
of>cj?mS]>WoH;7Voef`i?mL/^D00_mK/nD00omL]>KoG[KXon_[j`0Don_[
j`;oj^[Z00Goj>SXonKVi_oRh^;og=cLojn_[`05ooooo`04ojn_[ooLg=co
h^;RonKViPWoVIVI2OnJVYX2oiVIV@?oW9bL0onJVYX05OnKVi_oWIfMoi^K
VonLW9coWIfMoi^KVonJVY[oW9bLoiNGUonJVY[oY:BTojZZZ_nVYZKoVi^K
ohZ:R_n;Rh_oS8b<ohj>S_n:RX[oRHV9ohZ:RP02ohb<S005oh^;Ron<S8co
Rh^;ohf=SOn<S8`00_n?Shl01?nUYJGoZZZZojRXZ?nTY:@2oiVIV@09oiZJ
V_nGUiOoUiNGoifMWOnOWiooW9bLoiZJV_nKVi_oW9bL00?oVi^K00GoVYZJ
oi^KVonJVY[oVi^KoiZJVP03oi^KV`koVYZJ5_o[jn/2on[ZjP05onSXj?oV
i^Koh^;RomcLg?n_[jl01Oooool01?n_[joofm_Kon;Rh_oVi^H2ooooo`04
olc<c?n8R8Sok^k^onk^kPOogMgM00Ooc<c<oiVIVOmVIVKoA4A4ofIVI_nI
VIWogMgM00Sok^k^00?oolc<onk^k_o^k^h01?ooc<`01Oo<c<coolc<ooo<
c?ooc9Woc<bI00?oolbI00?oc<bIooo<VOooc9T01?ooc9T3olc<V@03ooo<
VOo<c9Woc<bI00?oolbI00Coc<bIooo<VOooc<cok^k^AooZj^X01OoXj>So
i^KVon;Rh_oKfm_o[jn_0>;ooooo0005onk^kP1Doj>SXooLg=coh^;RodVe
hom:]^CoBkOUodfiiom=^^GoBkSSod^fh_m9]>3oCkSUoe>hi_mF^>GoEkKT
oeNch_mK/n?oGkGVoenjjOmH^NKoG;SOofRedomZ[<CoN[C:ogN_b?md/M3o
L;3Fofn^fOmb[=;oRkODoj6kb_nOYJGo[J>GolZdWOo0YXgo/YV5okVRT_nX
TXCoZIN;oij@Qon`Yj3olnkZooOgmOoYkNkoPXZ=ocm:C_lmC5?o?D]Fod=C
H?leAeGo?dmNoca9FOloBeWo@DeKod9<F?m3BeKoA4]Eok>h__oioOoom_[i
onS]ionXZJ7oWifAoi>=POmQFDcoBT@fofEMD?nUVi7oZ9fGojBLV_nPX:So
Vjc0ohZ/comfZmgoLKK_ofVcl?mY]O7oKkC[off_hOmb/NCoMKCYofj`k?m_
/o3oJJoZ0_mY/^T02_mX/NSoI:oVof>^iOmQ[^CoGjoTof>djOmN/NGoG:oS
oebbiOmM]NL2oeZdiP03oe^eioo[jn_ojn_[01?ojn_[0_oZj^X01OoXj>So
i^KVon;Rh_oLg=coXj>S00Gok^k^00CoXj>SomcLg?oRh^;oi^KV0onIVIT3
oiZJVP;oVIVI1onJVYX02?nKVi_oVYZJoiZJV_nJVY[oVIVIoi^KVonJVY[o
Vi^K0onJVYX02?nLW9coWYjNoi^KVonKVi_oWYjNoibLW?nJVY[oVi^K0_nI
VIT01onHV9SoW9bLojNWYonYZJWoYjNWoiJFU_n;Rh/00_n<S8`01?n=SHgo
Rh^;ohb<S?n;Rh/5ohb<S00:oijNW_nZZZ[oZJVYojNWYonKVi_oVYZJoiNG
Uon>SXkoRh^;ohn?S`CoVYZJ00?oW9bLoi^KVonJVYX01?nKVi/00onJVY[o
Vi^Koi^KV`02oi^KV`03oiZJV_nKVi_oVi^K00OoVYZJ00?oVIVIoiZJV_nJ
VYX00onJVYXFon_[j`;oj^[Z00Goj>SXonKVi_oRh^;og=cLoj>SX`05onk^
kP09oj>SXooKfm_oh^;RonKVi_ooooook^k^omgMgOmgMgOooooo00;ok^k^
00?ogMgMolc<c?o<c<`00_nk^k/03?o<c<cogMgMomgMgOoMgMgoolc<olc<
c?nZZZ[oMgMgodA4A?mEEEGoVIVIolc<c0Gok^k^0_ooc<`00oo^k^koolc<
ooo<c006ooo<c0goolbI00[oc<bIooo<VOooc9WoolbIolc<VOooc9Woc<bI
oonIVOooc<cok^k^A_oZj^X01_oYjNWoj>SXonKVi_oRh^;ofm_Koj>SXn;o
k^k^0005onKViP06oifMWOoKfm_oh^;Rod2cgom2]N7oA;OS0_m7^>@0D_m8
]nCoB[KTodbgiOm>]nCoD;GSoe:dhomE]NGoEkKVoeVei_mH/^CoE[3Roe^g
j?mM]NGoHK;MofF`f?mW[mGoJZoFofbafom]/]coKkCNogB_eon1/<koU;73
oinYZonVWiGo]j>;olR_VOnPShGo]jVVoi21O_mXFUOoY9NAoijCSOnTVY7o
a[jcooOaiOoelNKoe=C:ofe^J?mgNg[oN7f0ohJ=Ton7S9;oTY6GohR7S?n:
RHkoTY2Coi^BUoo[gn?ooNo_ooofm?o4a;coYJROoi>FSOmoPW_oFe]Iocm0
@_lk@dKoH6EXoinOWOnJV9WoQX^AohfJZ_n@ZlKoPJ_AogbbhOm`/nSoKKG_
ofVekomX]NgoI[?YofNbjOmZ/n[oJk?^ofbdkomW/^_oI[7Zof>^iomR[NKo
I:oXofRck?mW/^/2ofBaj@07of2_iomL[NCoFZgSoeV`iOmH/^KoEk7UoeFa
i00Eon_[j`;oj^[Z00Goj>SXonKVi_oRh^;ofm_KoifMW@05onKViP05oifM
WOoKfm_oh^;RonKVi_nHV9P01onIVIT00onJVY[oVIVIoiVIV@04oiZJVP03
oiVIVOnJVY[oVYZJ00KoVYZJ013oVi^KoiZJV_nKVi_oW9bLoi^KVonJVY[o
Vi^KoijNW_nHV9SoW9bLoiJFU_n?ShooVIVIoiRHV?nJVY[oWinO0_nXZ:P0
1?nSXj?oTY:BoiBDU?nDU9@2oiNGU`03oiRHV?nFUYKoUYJF00;oV9RH00So
YJFUojRXZ?nYZJWoX:2Poi^KVonHV9SoUIFEohn?S`;oRXZ:00GoT92@oiZJ
V_nIVIWoUiNGoiVIV@07oi^KV`;oVYZJ0onKVi/5oiZJVP03oi^KVonJVY[o
VYZJ00;oVYZJ0onIVIT00onJVY[oVIVIoiVIV@0Fon_[j`;oj^[Z00Goj>SX
onKVi_oRh^;ofm_KoifMW@05onKViP04oifMWOoKfm_ohN7QonGUi@?ooooo
00CoEEEEonk^k_oooooooooo0_o^k^h2omgMg@;oc<c<00?o^k^kolc<c?o<
c<`00oo<c<`2omgMg@0;olc<c?nZZZ[oMgMgodA4A?mEEEGoMgMgok^k^ooo
c<cok^k^ooo<c?o<c<`02_ooc<`4ooo<V@;oc<bI00?oolbIolc<VOo<c9T0
2?ooc9T01?o<c9WoolbIooo<c?o^k^i6on[ZjP06onWYjOoXj>SoiNGUon7Q
hOoKfm_oWIfMh_oVi^H000Gok^k^00OoXj>Som_KfooRh^;o?KCNocnfh?m1
]^7o@kKR00;oAKKR04KoBKGSodZehom<]N;oC[GRodndh_mC]NCoEKGUoeJe
iOmE]>CoE[;SoeZfjOmJ]>KoFk?SoefagomO/=ooH[3Nof>agomW/N3oJ;7N
og2_f?ml[/ooR:_1oiNU[_nRXIgo[Yj?ok:OT?nZX9koLFe^od@k?_mQF5Wo
KfETohYoNonSVHooY9Z>oj2GR?oTgLgooo[/oo3/h?m^JfCoKFaZogQhN_n:
R8_oTXV:ogmeM?n:QH;oWiNEooKVi_oonO[oong]olJd/?nQWICoK6mToe9G
D?mUJVKoEEIJob8V;ol^>TKoA59Koe]TJomSKGKoJW^;oh6K/_n7ZlgoNZ[B
ogF_gomY[>3oIk;YofBcjomR/n_oH;;Z0_mR/NX2ofJaj`0@ofJbk?mU/^[o
HZoWof2]iOmS[^OoIK;ZofBajOmQ[^KoI;7Yof6`j?mO/>OoGK3VoeZ_iOmI
/>GoF;;VoeNciQGojn_[00Ooj^[ZonWYjOoXj>Soi^KVon;Rh_oKfm_oXj>S
00Gok^k^00GoXj>Som_KfooRh^;oi^KVoiRHV00:oiVIV@CoVYZJ00?oVIVI
oiZJV_nJVYX02?nJVYX2oi^KV`?oVYZJ0_nKVi/01OnBTY;oRXZ:ohn?SonA
TI7oUIFE00?oVIVI01koY:BTojVYZOnWYjOoTI6Aoi:BT_nDU9CoUYJFoiNG
UonCTi?oUYJFoiVIVOnWYjOoZJVYojRXZ?nNWYkoVYZJoi:BT_n>SXkoTI6A
ohj>S_n6QXKoRHV9ohf=SOn@T93oTI6Aoi>CTonHV9SoVi^KoiZJV_nKVi/E
oiZJVP;oVIVI0_nJVYXFon_[j`07on[Zj_oYjNWoj>SXonKVi_oRh^;ofm_K
oj>SX`05onk^kP04oj>SXooIfMWoh>3PonGUi@?ooooo00?oZZZZogMgMooo
ool00oooool2onk^kP?ogMgM0_o<c<`5ok^k^`03olc<c?oMgMgogMgM00;o
gMgM00Ko^k^kogMgMom4A4CoA4A4ogMgMoo<VIT4ooo<c003ooo<VOooc<co
olc<00Goolc<1?o<c9T01?ooc9Woc<bIooo<VOooc9T3olc<V@;oolbI00Ko
c<bIooo<VOo<c9WoolbIooo<c?o^k^i6on[ZjP06onWYjOoWinOoiNGUon3P
h?oIfMWoXj>Sh_o^k^h000Gooooo00Go[jn_om_KfooQhN7o?K;Nocjcg`02
od6dh@;o@kCP00KoA[;PodRchOm:/n;oCK?Sodndh_mA/n82oe>ch`0loeBd
i?mE]NGoEKOXoeBfiOmE]>;oF;?OoeZag_mM/MgoGk7Pof2ah?mS[MkoKK3M
ogN^eOn3Z/WoVZo2ok>g`?no]KCo^JjZokNe]_n;Si;o=3<hoe1@D_mdLW?o
If=Poe5<A_mkMfcoXinCoiB@Q?no_K7olNkUooonnOoNg=goa<;7ooWdn?oo
o?_ohmSFooO_k?oonoWooo;cooSTiOnjXJCo[9ZHog5/I_m3A3coBdi7ode?
C?lo?T?o>3]2odaFH?m=GF[oEfYioeegR?mcTJWoRjo?ohJcf_mh[]coM;?V
ofN^i?mU/^SoH[?Z0_mP/nT2of:aj@07ofF`jOmU/>[oI;3Zof:aj_mP[nSo
GZgVof6]i`02of6`j@09oef^i_mO/>SoGk7Yof2bj_mM/^WoFK3VoeR_iOmI
/>KoF;;W01Gojn_[00Ooj^[ZonWYjOoXj>SoiNGUon7QhOoKfm_o[jn_00Go
oooo00Co[jn_om_KfooQhN7oiNGU0_nHV9P<oiVIV@KoVYZJ00?oVIVIoiZJ
V_nJVYX01OnJVYX05onLW9coWYjNoijNW_nMWIgoWYjNoiNGUon8R8SoSHf=
oi>CTon@T93oS8b<oi>CTonJVY[oUiNGoinOWonWYjOoZZZZojBTY?nPX:3o
Z:RXojZZZ_nTY:CoZ:RX00;oZJVY00WoYjNWoibLW?nJVY[oTY:Boh^;Ron<
S8coSHf=ohZ:R_n9RHT00_n>SXh01On@T93oTY:BoiNGUonKVi_oW9bL00;o
Vi^K3?nJVYX01OnIVIWoVYZJoiZJV_nJVY[oVIVI00CoVYZJ0onIVIT00onJ
VY[ojn_[on_[j`0Don_[j`07on[Zj_oYjNWoj>SXonGUiOoQhN7ofm_Kojn_
[`05ooooo`04ojn_[ooGemOogmoOon?Sh`Cooooo00CoMgMgojZZZ_o^k^ko
k^k^1?oMgMd3onk^kPCogMgM0_o<c<`4ok^k^`?oc<c<0_oMgMd01onZZZ[o
R8R8oeEEEOm4A4CoEEEEohR8R?o<c<`00oooc<`2ooo<V@03olc<VOooc9Wo
olbI00KoolbI0_o<c9T2ooo<V@03olc<VOooc9WoolbI00CoolbI00?ok^k^
on[Zj_oZj^X0@ooZj^X01ooYjNWoj>SXonKVi_oShn?oh>3PomOGeon_[jl0
h_ooool000Gok^k^00GoXj>SomWIfOoPh>3o?K;Nocjcg`02od2ch008od6b
g_m2/MkoAK7OodFagom9/^7oBkCSodjeh_m?]>82oe2bh@0koe>chomD]^Go
D[KWoeBfiOmE]>;oE[?OoeVbg_mK/]ooGK7Poej`h_mO[n;oIk7Rofn^f_mi
[MCoU;OCok35f?noamCo_L;8okS1a_m/MWSoA4a?odaAE?m;Ce3oA4I5oeUJ
EOmUI5ooGUiFohj>Q_nKW9Co/[>]ooKeloooo_ooo_WoooOamOoiko3ooogk
ooWel_oooOcoi][Noj^JX?nZUigoFdmAofIUHomjOg_oCE=Aoc@h>om3@d_o
@TIAofA]O?n5VZ_oOIfdogFL^OmnZlcoQKKNogF^fom[Z]goK;?WofBaiomQ
/^T00_mP/nT00omQ]>[oHK;Yof:aj@02of>`j0;oH:oX00_oGjkWoef^i_mN
[nOoH;7YoenajOmM[nOoFZoVoe^`iomL/NSoF[7WoeR_i@03oeN^i1Gojn_[
00Ooj^[ZonWYjOoWinOoiNGUon3Ph?oIfMWoXj>S00Gok^k^00CoXj>SomWI
fOoPh>3oiNGU2?nHV9P7oiVIV@CoVYZJ00?oVIVIoiZJV_nJVYX01_nJVYX0
4onMWIgoX:2Poj6QXOnPX:3oWinOoi>CTon<S8coSHf=ohb<S?n;Rh_oSXj>
oi2@T?n?ShooUiNGoiVIVOnMWIgoZ:RXojZZZ_nYZJT00_nXZ:P01?nZZZ[o
Z:RXojZZZ_nUYJD2oiZJVP05ohf=SOn@T93oU9BDohf=SOn9RHT00_n;Rh/0
1_nATI7oV9RHoiRHV?nHV9SoVYZJoibLW0;oVYZJ00?oVi^KoiZJV_nJVYX0
2_nJVYX00onIVIWoVYZJoiZJVP02oiZJVP04oiVIVOnJVY[oVYZJoiZJVPCo
VIVI5_o[jn/01ooZj^[ojNWYonOWiooUiNGoh>3PomWIfOnSXj<01Oo^k^h0
1?nSXj?og=cLon;Rh_oVi^H4ooooo`03omgMgOmEEEGooooo00;ok^k^00?o
gMgMolc<c?o<c<`00_o<c<`2omgMg@;ok^k^1OoMgMd9olc<c0;ogMgM00Wo
c<c<oiVIVOmVIVKoIS<cofIV<onIIVKoc<bIooo<VOooc<`01_ooc9T00oo<
c9WoolbIooo<V@03ooo<V@;oc<bI1Oooc9T00oo^k^koj^[Zon[ZjP15on[Z
jP05onSXj?oVi^Koh^;RomcLg?nSXj<0h_o^k^h000Goi^KV00?oWIfMomOG
eooOgml00_lo/]l02_m2/^3o@K7Ood:agom2/MooA;3OodFah?m9/^7oBkCS
odjdi?m?/n@2odjbh`06oe6ci?mC]NKoEK?VoeNci?mJ/^;oFk7P0_mM/N00
@omM/>;oFk7Tof2ejomO/^KoHZkPofZ^fomh/]OoQkKDoi6gc_nG]<CoTZJ_
oei`M?mIIVco@4]?oca4Aom2Ad[oEE]IoeEJE_m;D4coDEIBohZ<ROnMWico
[J^/ongXk?ooo?oooo_oooomooohm_Woo?ooon?VjonXYjooPgf9oe9:EomD
DE[oBU5Goc4nA?liA4[o>D==odaBH_mWKh;oG6]nogVE[On6]=GoLJS?og:]
eoma[mkoI:OKofB]h_mY]^koI;G/oe^`i_mL/NOoGK?Voenbi_mP/NKoH;3U
oen^i_mN[NGoHK3Yof2`jomO[n[oG:kXoeZ_j?mL/N[oF[3YoeJ_iomH/NT0
0_mF[nL3oeR^i`03oeN/iOmFZnCojn_[01Cojn_[00OojNWYonSXj?oVi^Ko
hn?Son3Ph?oGemOoWIfM00Goi^KV00CoWIfMomOGeooOgmoohn?S2?nHV9P7
oiVIV@goVYZJ00[oVi^KoibLW?nMWIgoW9bLoiZJV_nATI7oT92@ohb<S?n:
RX[oRh^;0_n>SXh01_n=SHgoSXj>oiNGUonJVY[oW9bLojJVYP?oZZZZ00Ko
ZJVYojZZZ_nVYZKoW9bLoiFEUOn<S8`2ohf=S@09ohV9ROn:RX[oRXZ:ohf=
SOnBTY;oTI6AoiNGUonLW9coVIVI00;oVYZJ00CoVIVIoiZJV_nKVi_oVi^K
1onJVYX01?nIVIWoVYZJoiZJV_nJVYX2oiVIV@;oVYZJ00?oVIVIoiZJV_nI
VIT01_nIVITFon_[j`07onWYjOoXj>Soi^KVon?ShooPh>3oemOGoifMW@05
onKViP05oifMWOoLg=coh^;RonKVi_ooool00_o^k^h2ooooo`04odA4A?oo
ooooooooooooo`;ok^k^0_oMgMd6olc<c0;ogMgM0_o^k^h4omgMg@Woc<c<
0_oMgMd00oo<c<coZZZZofIVIP02ofIV<`06oiVII_o<VIWoc<bIooo<VOo<
c9Woc9VI0oooc9T00oo<c9WoolbIooo<V@07ooo<V@03omgMgOoZj^[oj^[Z
04Goj^[Z00Goj>SXonKVi_oRh^;og=cLoifMW@3RonKViP001Oo^k^h00onS
Xj?og=cLon;RhP02ocnbg`;o@K7O0_m1/=h01Om4/=ooAK7PodRbh_m9/^7o
B[?R00?oC;;R05;oC[;Soe6ci?mF/^GoFK3Uoeb_homL[n7oG[3Roef`h_mK
/NCoF[7VoeZcjomG/NKoFK3Uof6chomX/mgoJJgBoffZbOmiZL3oIhF@ofAg
OOm]Oh?oH6iaoeQRI?mUKFooJG9aofM`KomeNgWoJg5_ofmcL_mmOgkoWifN
ok:/[_oZhNKoooWmookem_ooo_ooiNWZoj6VZOn:RY;oNgR3ogA^N_n2P8_o
MWn6ohbIWomoRI;oLg^6ogAjR_m]M8KoM8>Foh2P^Omk/]WoIJWHofN_hOmW
/>GoHZoWofJek_mS]NgoGkC[oe^biomK/nGoG;CToefci?mO/^KoG[7Woej_
i_mN[nOoHK7/of6ckOmP/^coFk3YoeV_j?mF/NSoEK3Woe2^i?mE/nWoDk7W
oe>^iOmE[^KoEZoWoeV_j?mH[NKoEZ_T5Oo[jn/2on[ZjP05onSXj?oVi^Ko
h^;RomcLg?nSXj<01Oo^k^h01?nSXj?og=cLon;Rh_oVi^H8oiRHV0SoVIVI
00CoVYZJoiVIVOnIVIWoVIVI1OnJVYX2oiVIV@?oVYZJ00SoVIVIoiZJV_nD
U9CoTY:BoiBDU?nATI7oShn?oi6AT@;oTY:B00OoU9BDoi:BT_nBTY;oUIFE
oiZJV_nMWIgoYZJV00;oZJVY00[oZZZZojJVY_nKVi_oUiNGoiBDU?nBTY;o
UIFEoiBDU?nHV9SoUYJF0_nDU9@01OnCTi?oUIFEoiVIVOnKVi_oVIVI00?o
VYZJ0_nKVi/=oiZJVPCoVIVI00?oVYZJoiVIVOnIVIT01OnIVITFon_[j`;o
j^[Z00Goj>SXonKVi_oRh^;og=cLoj>SX`05onk^kP04oj>SXooLg=coh^;R
onKViP?ooooo00?ok^k^oooooomVIVH00_o^k^h2ooooo`04onk^k_oooooo
k^k^onk^kPCogMgM1Oo<c<`3omgMg@Cok^k^0_oMgMd8olc<c0?ogMgM00Oo
^k^kogMgMomV<c?oA4A4ofIVI_o<VFKoc<bI00?oolbI00?oc<bIooo<VOoo
c9T00_ooc9T01Oooc<coc<bIooo<VOooc9WogMgM04Ooj^[Z00Goj>SXonKV
i_oRh^;og=cLoj>SX`3Ronk^kP001Oooool00on_[joog=cLon;RhP04od2`
h008od2^gom1[n3o@[3QodFah?m4/=ooAJoOodJ`h?m8/N42odZch`1:odbb
hom</>;oEJoToeR]i?mK[^CoG:gRoef^homL[n?oFK7SoeRbi_mD/^SoDK3V
oe>bj?mH]^WoG[KToejcg?mQ/=OoKZk:og6EXOmlSiGoMHB9ohnJW_nIXJCo
W:6ToijTY?nSZJOoWZNTok:k^?nj`;ko]k^jok^j^?n`ZZ[o[J>Roo[_kOoo
noColnWPokRe[_oIf=?ofMGDon7KgOoId=?of=;Dom?Ge_o@e]Coe=SIolW:
c_o1_/OoSH^Foh28Tom]RIkoL:kGoe^[g_mQ/>SoGZoWoej`j_mN/ncoEjcS
oeR_iOmL/nSoF[CVoeZei?mL]>CoG;CVoebcj?mL/NSoG;7Zoef_jOmO/N_o
G;;[oeN`j?mE/>OoD[7Woe6`i_m?/>D2oe2aiP06oe2_iOm@[^CoDjcToeJ/
iOmG[>GoF:gV5Oo[jn/2on[ZjP05onSXj?oVi^Koh^;RomcLg?n_[jl01Ooo
ool01?n_[joog=cLon;Rh_oVi^H;oiRHV0_oVIVI0_nJVYX3oiVIV@GoVYZJ
00CoUiNGoiJFU_nEUIGoVIVI0_nJVYX3oi^KV`0:oijNW_nOWiooWYjNoinO
WonLW9coVi^KojRXZ?nYZJWoYjNWoijNWP;oXj>S00?oY:BToj>SXonSXj<0
0onSXj<01onQXJ7oWinOoiNGUonFUYKoUIFEoiZJV_nIVIT01?nJVYX2oiVI
V@_oVYZJ3OnIVITFon_[j`;oj^[Z00Goj>SXonKVi_oRh^;og=cLojn_[`05
ooooo`04ojn_[ooKfm_oh^;RonKViP?ooooo00Gok^k^oooooonIVIWoVIVI
ooooo`05onk^kP?ooooo0oo^k^h3omgMg@Coc<c<0_oMgMd00oo^k^kooooo
onk^kP03onk^kP?ogMgM1oo<c<`3omgMg@06ok^k^on8R8SoEEEEofHc<omE
EEGoVIUV0oo<c9T6ooo<V@03ooo<c?oZj^[oj^[Z04Goj^[Z00Goj>SXonKV
i_oRh^;ofm_Kojn_[`3Rooooo`001Oo^k^h00onSXj?og=cLon;RhP04ocn_
g`14ocj^g_m0[]oo@[3Qod>ah_lo[Mko@JgLod:^gOm6/>3oB;;RodVchom9
/^;oBJkRodn^i?mC[^GoE:kSoeN^homH[nCoFK3UoeNaiOmD/^KoE;?Yoe>d
jOmB/n[oD[;UoeFah_mF/MkoF:oLofFZbomURIWoHG9iof5_L_nla/Son_oo
ooKjnoolooooloSdoo_ooOo`nOKon?kloocooOoko?OonoKbom[Ac?n]X9[o
kn7HokR/X?oakn?onocdoo_jm_okmoKooo_kookjnOofn_Wonooooo?gm_on
ooooinC[obh^>?lg@4WoLi:Vog2afomN/NOoGkC[oeN/iOmI[^OoFk7ZoeF/
h_mN]NX2oeRbi00FoeRch_mG/nCoE[;UoeJai_mG/>SoEk3ZoeJZi_mI[^Oo
Ek3ZoeF`iomA/>SoD[?Xoe2cj_m>/nOoBjkUodb`i?m>[nKoCZgSodnZhom@
ZN7oEJ_VoeN]iQGojn_[0_oZj^X01OoXj>Soi^KVon;Rh_oLg=coXj>S00Go
k^k^00CoXj>SomcLg?oRh^;oi^KV3?nHV9P3oiVIV@03oiRHV?nIVIWoVIVI
00KoVIVI0_nJVYX6oiVIV@0<oiFEUOnBTY;oTI6Aoj2PX?nZZZ[oZJVYojZZ
Z_nYZJWoZZZZojRXZ?nYZJWoZZZZ0_nYZJT01OnSXj?oVi^KojJVY_nMWIgo
YjNW00?oZJVY00_oZZZZojVYZOnYZJWoZZZZojRXZ?nZZZ[oYZJVohN7Qon:
RX[oUiNGoi^KV`02oiZJVP;oVIVI00?oVYZJoiVIVOnJVYX01OnJVYX?oiVI
V@;oV9RH0_nIVITFon_[j`;oj^[Z00Goj>SXonKVi_oRh^;og=cLoj>SX`05
onk^kP04oj>SXooKfm_oh^;RonKViPGooooo00KogMgMoeEEEOo^k^kok^k^
ooooooo^k^h3omgMg@05onk^k_oMgMgok^k^onk^k_ooool01?o^k^h3omgM
g@06olc<c?n8R8SoEEEEohR8R?o<c<cok^k^1?ooool2onk^kP03omgMgOo^
k^kogMgM00Coc<c<00Co^k^kolc<c?o<c<coc<c<0_oMgMd01onk^k_oVIVI
oeEEEOmV<c?oIVHcoiVII_o<VIT01?ooc9T00oo<c<coj^[Zon[ZjP14on[Z
jP06onWYjOoXj>Soi^KVon;Rh_oKfm_oXj>Sh_o^k^h000Goi^KV00?oWIfM
om_KfooRh^800_liZmd02Olj[=ko>jgOocb^h?lo[n7o@;3Rod6ahOm0/>3o
@[3QodBbh`02odNci008odFah_m4[^3o@jgOodZcj_m8/>OoB:gSodV]hOm>
[n82oe6ai019oe2`homC/nKoE;;VoeBbj?mE/>GoEZkPoeR[gOmL[]koKjoE
ofB5V?mOKWGoDEYOomOLgoobl_CodM3>om3?boo4aL3oZZnYoj:XY?nCW9Oo
SI>?oi6DSOnIUXooS8Emoj:IT?nSVY7oOW]bohF<Q?n7TX[oP8V6ohN=SOn7
R8coR8b?ofA_LOmIIfSoE5mSogn8SomiOh_o:C<oobe0C_meVk;oJZoIoeja
iomK[^CoEjcSoeZ_i_mN/n[oG;?YoeN^homI/nGoF[GToeRdiOmD/n?oE;;V
oeJdj_mD/ngoDZoZoeVbk_mH[^WoDZcXodn/iOm=[NOoCK3Wodjcjom=]N[o
AZ_SodV^i?m;[^OoBjcSodfZiOmA[>GoDjcXoe>/iP0Eon_[j`;oj^[Z00Go
j>SXonKVi_oRh^;ofm_KoifMW@05onKViP04oifMWOoKfm_oh^;RonKViP?o
UiNG1onHV9P3oiVIV@?oV9RH0_nIVIT2oiRHV0_oVIVI00KoVYZJoiBDU?nA
TI7oSXj>ojBTY?nXZ:P2oj:RXP04oj2PX?nLW9coVi^KoiVIV@;oV9RH01?o
VIVIoiJFU_nIVIWoVIVIoiBDU?nFUYKoUiNGoiJFU_nGUiOoUYJFoiNGUonA
TI7oT92@ohn?SonFUYKoUIFEohR8R?n9RHWoV9RH00;oVYZJ0onIVIT2oiZJ
VP04oiVIVOnJVY[oVYZJoiZJVP;oVIVI0_nJVYX00onIVIWoVYZJoiVIV@06
oiVIV@;oV9RH00?oVIVIoiRHV?nHV9P00onIVITFon_[j`;oj^[Z00Goj>SX
onKVi_oRh^;ofm_KoifMW@05onKViP04oifMWOoKfm_ohN7QonGUi@Kooooo
00Goc<c<odA4A?nIVIWoc<c<onk^kP02ooooo`;ok^k^1OoMgMd4onk^kP0<
ooooooo^k^kok^k^onk^k_oooooogMgMoiVIVOmgMgOoEEEEohR8R?nk^k_o
gMgM0_ooool3onk^kP03omgMgOo^k^kogMgM00Coc<c<0onk^k/5olc<c007
oiVIVOnIVFKoIVIVofHc<onIIVKoc9VIooo<c016on[ZjP06onWYjOoXj>So
iNGUon7QhOoKfm_oWIfMh_oVi^H000Gok^k^00CoXj>Som_KfooRh^;o>:cM
0_li[Mh00olj[]oo>joPocb^h002ocf_h@1Hocb/g_ll[=co?ZkNod6_h?m3
/N;oA;;SodNci?m6]>Oo@[3Uod6_i?m3[^CoAJoSodR`hom</^?oC[;Toe6b
iOmC/nKoD[3ToeB_i?mF/>CoEjoQoeR[gOmIZmgoIjS@oeYmTom?H6[oDU]T
ofmbMomXI6GoJVERofiYI_m/JfKoPXN1oh67Pon0RHCoN85logYoN?n8RH7o
Q81eojJOUOn`ZIooOgacog9lLom_O7?oJWEaog=lNom_LgCoK75dof1/K?mC
HF;oBEAHof=/LomKHfko@U1Mod1GIOmJQ9coJJkHof2ai_mO/>GoFjkToeZ]
homJ[nKoF:oToeJ]h_mD[^3oEK7Poe>bh_m@/>;oD:oUoe6bjOmB/^koDJo/
oeJ`k?mD[NWoCjcWodf/i_m=[NOoBZoWodV^i_m5[NCo@j_RodJ^iOm9[^Ko
BJcUodb[iOm?[>OoDJ_WodnYiAGojn_[00Ooj^[ZonWYjOoXj>Soi^KVon;R
h_oKfm_oXj>S00Gok^k^00CoXj>Som_KfooRh^;oi^KV0onGUiL5oiRHV0;o
UiNG0onHV9P3oiVIV@CoV9RH3?nIVIT01OnCTi?oShn?ohj>S_nBTY;oT92@
00?oTI6A0onFUYH2oiBDU004oiJFU_nEUIGoVYZJoibLW0;oU9BD00?oTi>C
oi:BT_nDU9@00_nBTY802?nATI7oShn?ohf=SOnATI7oT92@ohb<S?n=SHgo
U9BD0onJVYX@oiVIV@03oiRHV?nIVIWoVIVI00OoV9RH0_nIVIT00onHV9So
jn_[on_[j`0Don_[j`07on[Zj_oYjNWoj>SXonKVi_oRh^;ofm_Koj>SX`05
onk^kP04oj>SXooIfMWoh>3PonGUi@?ooooo00?ok^k^ooooooo^k^h00_oo
ool01ooMgMgo^k^kohR8R?mgMgOoR8R8ojZZZ_oMgMd00_ooool2onk^kPKo
gMgM0oo^k^h2ooooo`0:onk^k_ooooooooooomgMgOnk^k_oR8R8ofIVI_mg
MgOoZZZZomgMg@Ook^k^0oo<c<`4ok^k^`05olc<c?nk^k_oc<c<onk^k_oo
ool00_o^k^h00ooMgMgoooooon[ZjP15on[ZjP06onWYjOoWinOoiNGUon3P
h?oIfMWoXj>Sh_o^k^h000Gooooo00So[jn_om_KfooQhN7o=J_MocJ/g_lh
[^3o>JoQocZ`hP;o?;3S00Co?;3Qocf_hOll[^3o?:kP0_ln[^003?lo[n7o
@[3Sod:`holn[>7o@ZgSodB_iOm5[n?oAjoTodZ_hom=/NGoD;7Toe2`h`;o
CjgP03coE;3QoeF_hOmC[]goDZ[JoefUcOm[T:_oFfioofUePOmNHF[oH5]O
og9ZJ?mgKfgoLg1[og1bKOm[M6ooM7mkofMbK_mOJ6?oKgA]of][HOnDT8Go
[J>Ioh9lL?mdN6[oKgMZofecJOmfNG;oLW5/ofi]J?mNHegoF5iJoe]OG_mZ
KW7oB4aEoe=MIomLM83oEH2Cof:VcOmL[=goGjoRoeb]h_mI[>;oF:gSoeV`
iOmJ/NKoDjgOoeB`hOmC/NCoCjoRodf^iOm<[nSoC[3]oe2`kOmC/>goDJkY
oe2]j?m?[^SoCjoYod^`j?m8[ND2od>[hP07odF]i?m8[NGoB:_TodV/iOm<
[>KoC:_UodZYh`0Eon_[j`07on[Zj_oYjNWoj>SXonGUiOoQhN7ofm_Kojn_
[`05ooooo`04ojn_[ooKfm_ohN7QonGUi@;oUiNG4onHV9P9oiVIV@;oV9RH
00GoUYJFoi6ATOnCTi?oT92@ohn?S`05oi:BTP08oiBDU?nBTY;oT92@oi:B
T_nATI7oUiNGoi^KVonDU9@2oi>CT`05oi:BT_nCTi?oTY:Boi:BT_n@T900
0_n?Shl02?nBTY;oS8b<ohn?SonBTY;oTi>CoiRHV?nIVIWoVYZJ1?nIVIT0
0onJVY[oVIVIoiVIV@0<oiVIV@[oV9RH5_o[jn/01ooZj^[ojNWYonSXj?oU
iNGohN7Qom_Kfon_[jl01Oooool01?n_[jooemOGomoOgooShn<2ooooo`03
onk^k_ooooook^k^00Cooooo00Kok^k^ooooooooooooooooolc<c?nIVIT2
ogMgM`04ojZZZ_oMgMgoooooooooo`;ok^k^0ooMgMd00oo^k^kooooooooo
o`08ooooo`07onk^k_nk^k_oR8R8ofIVI_mgMgOoVIVIolc<c004onk^kP05
omgMgOo^k^kogMgMomgMgOo<c<`01?nk^k/6ooooodGoj^[Z00OojNWYonSX
j?oVi^Kohn?Son3Ph?oGemOo[jn_0>;ooooo0005onk^kP09oj>SXooIfMWo
h>3PobnYf_laZmco<jgNocF_h?lh/>;o>K7S00;o>k7S0_ln/^<02?lm[n7o
?:kPocf]golm[Moo?:cNocf[g_m3[N7oAJgR0_m6[^D08_m7[nKoAjoTodV^
i?m:[^;oBJgOodZ/gOm;[MkoCjoOoe2`h?m>[mcoCJgMoeZYd_n4/]?oMY:X
oeIWNOm6CU_oG5]QofYVIomhLW;oJVUWofa`KomFH5ooDV1PodMEEOm;EeGo
GfQUodi@BomSHUgoLV]UoemKD_mSJEooIg5XofE/I?mYKVP2of]ZIP0Iod56
@?ld>SKoAD];of5VK?lc>dKo>d]Jog2@Wom_WkKoGj;<oeVYf_mM[N3oG:gR
oeV/h_mG[>?oF:oUoeRbi_mC[n;oDk7Toe:bi?m>[n;oBjcSodR[i_m:[>Wo
C:k[odj/j@02odn^j0;oCjoY00_oC:oXodZ_iom7[nKoAJgTodJ^iOm7[>Co
AZ_SodN/i?m8[NGoBJcUodJYhP0Eon_[j`07on[Zj_oYjNWoinOWonGUiOoP
h>3ofMWIoj>SX`05onk^kP05oj>SXooIfMWoh>3PonGUiOnFUYH00onGUiL:
oiRHV0;oUiNG2onHV9P3oiVIV@;oV9RH00WoVi^KoiNGUon@T93oS8b<ohn?
SonATI7oTi>Coi6ATOnBTY800_n?Shl2ohf=S@07oi2@T?n=SHgoT92@oi:B
T_n?ShooTI6Aoi:BTP04oi6AT@07oh^;Ron9RHWoS8b<oi2@T?n9RHWoRh^;
oiJFUP02oiRHV0KoVIVI00?oVYZJoiVIVOnIVIT00_nIVIT3oiRHV0SoVIVI
2OnHV9PFon_[j`07on[Zj_oYjNWoinOWonGUiOoPh>3ofMWIoj>SX`05onk^
kP04ojBTY?oDe=Coh^;RonKViPKooooo00?ok^k^ooooooooool01?ooool0
1_o^k^kooooooooooooooooogMgMoiVIV@;oMgMg00?oVIVIolc<c?o^k^h0
0oo^k^h>ooooo`03onk^k_o<c<coVIVI00;oIVIV00CoR8R8ok^k^ooMgMgo
gMgM0oo^k^h01?oMgMgoc<c<olc<c?o<c<`6ooooodGok>c/00Oojn_[on[Z
j_oYjNWoi^KVon;Rh_oDe=CoY:BT0>;ok^k^0005onKViP09oifMWOoGemOo
gmoOobfYg?l^Z]go<:cOoc:^hOle[n;o=[3S00;o=ZkP00Co>:kPocV_hOlj
[^7o>joR0olm[n40B?m1[>3oBJgQod^Zh?m9Z^7oB:_TodV^i_m8/>OoAjoV
odF]h_m5[N3oAJkNodN`gom8/N3oAk3OodF^fom5/=koE:oKofJTbOm^UkGo
:TQPob0cA?m3BUCoF5UNofATI_mOH6;oE5aNoc8m@OlQ<cOo8S<jocM6BomA
Gf;o=cm2ocLk?_m0@DKo?T=7odYJF_mAIFCoCEmOodiLGOmBFUgoEEePoc]6
B?lH9B_o7BXcoc];F_lM;dGo4Bm9ofZH/_mc/<ooHJ[Eoe^[g?mL[>7oFjcS
oeN/iOmDZ^?oDJ[Roe2[h_m?[N?oCjoRoe2`hom=[^?oBZ_RodRXi?m:Z^Oo
CJgZod^Yi_m=ZnSoCjgZodf]jOm;ZnOoB:_VodV/i`?oBJgX00KoAJcVod:Y
hom2ZN?oA:_UodF/i_m4ZnDEon_[j`07onWYjOoXj>Soi^KVon?ShooPh>3o
emOGoifMW@05onKViP05oifMWOoGemOogmoOon?ShonFUYH00onGUiL2oiRH
V0;oUiNG3OnHV9P00onIVIWoV9RHoiRHV003oiRHV00?oiVIVOnHV9SoV9RH
oiRHV?nIVIWoV9RHoiNGUon:RX[oQhN7ohb<S?n>SXkoT92@ohn?Son>SXko
RHV900;oQhN700CoRh^;ohn?Son:RX[oRHV90_n:RXX00on>SXkoShn?ohj>
SP02ohj>SP09ohn?Son;Rh_oQHF5ohJ6Q_n;Rh_oQhN7ohJ6Q_nGUiOoVYZJ
00KoVIVI0_nHV9P4oiVIV@?oV9RH00?oVIVIoiRHV?nHV9P00_nIVIT<oiRH
V1Kojn_[00OojNWYonSXj?oVi^Kohn?Son3Ph?oGemOoWIfM00Goi^KV00Go
XZ:Rolo?coo`l?3ol_;bonk^kP03ooooo`03onk^k_oooooooooo00kooooo
00GogMgMok^k^on8R8So^k^konk^kP0Dooooo`07omgMgOnIVIWoMgMgoeEE
EOmgMgOoZZZZolc<c002onk^kP;ogMgM0_o^k^h3ooooo`03onk^k_oemOGo
m_Kf00?omOGe00Gom_KfooGemOoemOGomOGeooKfmP03ooGem@05ooKfm_oe
mOGomOGeooGemOofm_H00ooemOD01Oofm_KomOGeooGemOoemOGom_Kf00?o
mOGe00Gom_KfooGemOoemOGomOGeooKfmP03ooGem@05ooKfm_oemOGomOGe
ooGemOofm_H00ooemOD01Oofm_KomOGeooGemOoemOGom_Kf00?omOGe00Go
m_KfooGemOoemOGomOGeooKfmP03ooGem@05ooKfm_oemOGomOGeooGemOof
m_H01?oemOD2ooCdm004oo;bl_o`l?3oclo?oj:RX^;oi^KV0005onk^kP05
oj>SXooLg=coh^;Robf[gOl][Mh00_l_[Ml05_l`[^3o<:cOoc:/gOlaZmco
=:cNocN]golh[^3o>ZkQocb^h?lm[n7o?:kPod6]g_m:ZmkoBJWLodNXgOm5
Z^3oAjoVodRaj_m6/NWo@jkTodF_hom6/>82odJ`h00kod>]gOm1Zm_o@joN
odn`gOmPZM;oE8Z`o`lhE_lE<DOo=TIEoci5COl/;cCo>Ci2ocI1AolU<cco
730koahb?OlU=d?o=TMAob`f@?l^=43o;390obXd@?lX?dOo;4E<obU0A_lY
>T7o;CM0ob`f?ollBe;o7c0joa`^??l[@5Go5Bi<o`0RA?mBR:coI:S?oen/
f_mIZ]ooF:WPoeJ[i?mF[>OoDjcXoe2Zi_m>ZnKoCZgUodf^iOm>[nCoCk3W
odj^j?m<[>SoCZcZoe6_kOm>[>[oCjgZodj^j_m<[>SoBJWUodRXi?m9ZND0
0_m8ZnH01Om8[>OoAJcVod:YholoZ>7o@:WR00;o@JcT5Oo[jn/2on[ZjP05
onSXj?oVi^Koh^;RomcLg?nSXj<01Oo^k^h01?nSXj?og=cLon;Rh_oVi^H:
oiNGU`_oV9RH0_nIVIT8oiRHV0;oVIVI00?oU9BDohN7Qon7QhL00_n;Rh/0
0on7QhOoRXZ:ohZ:RP03ohN7Q`03ohR8R?n;Rh_oR8R800?oR8R800?oRHV9
ohZ:R_n9RHT00on8R8P01on;Rh_oQhN7ohN7Qon:RX[oQXJ6ohB4Q?nDU9@0
1onIVIT2oiRHV0GoVIVI00?oV9RHoiVIVOnIVIT00onIVIT9oiRHV0;oUiNG
0_nHV9PFon_[j`;oj^[Z00Goj>SXonKVi_oRh^;og=cLoj>SX`05onk^kP04
ok:b/_o6a/Kolo?cooGem@?ooooo00?ok^k^ooooooooool0;Oooool01Onk
^k_oR8R8ofIVI_mVIVKo^k^k00Oooooo00?omoOgooShn?ohn?P00_ogmoL0
1?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg00Con?ShooOgmoohn?SomoOg
0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh0_ogmoL01?ohn?So
moOgooShn?ogmoL2ooShn0;omoOg00Con?ShooOgmoohn?SomoOg0_ohn?P2
ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh0_ogmoL01?ohn?SomoOgooSh
n?ogmoL2ooShn0;omoOg00Con?ShooOgmoohn?SomoOg0_ohn?P4ooOgm`05
ooKfm_oemOGolo?colK6a_nb/[80h_o^k^h000Gooooo00Oo[jn_omcLg?oR
h^;o:j_LobV[g?l[Zmco;:cM00;o;ZcN00Co;j_Noc6[g_le[n3o=ZkP0_lg
[Ml2ocR/g`07ocZ/h?lmZmcoAJkModF/fOm2Zm_o@:cMod2^h`02od2_iP0m
od6^i_m4[nGoA:kRodF]h_m8[N7oAZ_OodFZg_m6Zn7oCJgPofBdiOlhNjGo
02]=o`/`BolZ@E?o;C]6ob0Y<_lc?4Go:3I1obXlB_lX?Dko:D1BoadbAOlT
=DOo:CA6oblhBOlc>Tgo;cY<obDkB?lS?TWo93Y5obHg@OlZ=3ko:30kobLd
?OlN;S_o8cA6ob<gD?lC;Dko02M>ocI`V?mNYM7oG:[KoeFXg_mCZ>7oE:[W
oeB/jom@[>_oCjg[oe2`kOm<[>SoBj_Uodb]i?m?/>OoDK3Zodn^j?m?[>Wo
DJg/odj/j_m<[>WoBj_XodZZi`02od^Yi`0:odVWiOm7YnCoAZKSodNYi_m8
[>So@ZWTocjWhOllY^3o>jSQocbYhQGojn_[0_oZj^X01OoXj>Soi^KVon;R
h_oLg=co[jn_00Gooooo00Co[jn_omcLg?oRh^;oi^KV0onFUYH=oiNGUa3o
V9RH00WoVYZJoi6ATOn5QHGoQXJ6ohZ:R_n9RHWoQXJ6ohV9ROn8R8P00on9
RHT00on7QhOoR8R8ohR8R003ohV9R@03ohR8R?n9RHWoR8R800;oR8R800?o
QhN7ohR8R?n7QhL00_n8R8P01On6QXKoQHF5oi2@T?nHV9SoVIVI00;oV9RH
1OnIVIT3oiRHV0KoVIVI1onHV9P01?nGUiOoV9RHoiRHV?nHV9P4oiNGUaKo
jn_[0_oZj^X01OoXj>Soi^KVon;Rh_oLg=co[jn_00Gooooo00God];Bok2`
/?oZj^[om?CdooGem@03ooKfmP03ooOgmoofm_Kom_Kf00ComoOg00Com_Kf
ooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKf
m_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?of
m_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Co
m_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04
ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL0
1?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg
00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOg
m`04ooKfm_ogmoOom_KfooKfmPComoOg0_ofm_H2ooGem@04ooCdm?oZj^[o
/;2`om;Bd^;ooooo0005onk^kP0Poj>SXooLg=coh^;RobFWf?lVZ=Wo9jWJ
obZZfol]Zmgo<:cOoc6]h?lb[^7o<JgPoc>]g_laZmko<Z[LocFZgolg[Moo
>ZgSocb^h?m1/=go@joMod2_gOlm[Mgo>ZcPocV/h_lk[N?o?ZgTocn]h_lo
Z^3o@Z[OodJ[hOm8[N<2odR[hP0hodb[hOmCY]co=Gf]o`0bFOl<=E7o7cY=
ob4c@Ol]>DGo938kob8d@?lS>DKo7390obHmCOlQ=dGo9SU7obTkBOlT<D7o
:C4nobXf@_lQ>T7o83i6ob8mA_lV>TGo;CU5obde@_l/>4Co8c=0obDfB?lK
;dSo4B]>o``_EolTEhCoGIo?oef]h?mE[>;oDZ_Uoe:/j?m@[N[oC:[Xodb/
jOm=[ncoAj[UodFXhom6ZN;oBZgVodb/i_m9ZNGoB:KSodVWiOm9ZNKoA:KS
od:ThOm4Y^?oBZ[Wod^[j?m7Yn@2od2Rg`07odBXi?m5[^So@J_UocZWh?lg
Y]ko>:OOocJWg`0Gon[ZjP05onSXj?oVi^Koh^;RomcLg?nSXj<01Oo^k^h0
1?nSXj?og=cLon;Rh_oVi^H4oiJFUP[oUiNG1_nHV9P2oiNGU`?oV9RH00?o
UiNGoiRHV?nHV9P01OnHV9P01_nBTY;oQXJ6ohN7Qon8R8SoQhN7ohV9R@;o
QhN700?oR8R8ohN7Qon9RHT00_n8R8P00on9RHWoQhN7ohR8R005ohR8R006
ohV9ROn8R8SoR8R8ohN7Qon8R8SoQhN70_n6QXH00on<S8coV9RHoiVIV@04
oiVIV@;oV9RH00?oVIVIoiRHV?nHV9P01onHV9P3oiNGU`?oV9RH0_nGUiL3
oiRHV0CoUiNG6?oZj^X01OoXj>Soi^KVon;Rh_oLg=coXj>S00Gok^k^00Co
emOGojRXZ?oAdM7oj>SX0_obl_82oo?cl`Oom?Cd00?olo?cooCdm?odm?@0
1Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd
00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?c
loodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?Cd
ooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@0
1Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd
00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?c
loodm?Com?Cd00Gom?Cd0ooclo<01OoalO7oj>SXom3@d?nXZ:SoemOG0>;o
k^k^0005onKViP08oifMWOoKfm_oh^;RobFWfOlWZM_o:j[Mobf[g_l^Z]h2
obnXg@13obfYgOl/Z=co:jWKobbZgOl^Z]go<J[Ooc>]h?le[N;o>:kPoc^^
gOli[=Wo>:_JocV[gOlj[^7o>joRocb^h_lm[>7o@:kSod6/h_m2[N?oAJkU
odJ^hom6Zn7oAJ[PodZYgomBY=ko:6jRo`e1JOlD>EKo:3mAoc12C_la@Dko
;3i8oc16DOldCECo=DU@ocQ=D?l[@47o=DY;oc=<D?lcB4_oADi=od=?Bold
Ddgo=EaIod=TJOm5H6WoGVaioeaUM?mGIG3oCEm[oeMZNOmIKhKoCF62ociG
P?m6J9SoGY?7oeVYg_mA[nGoCZgUodZYhOm6Y^3oB:SRodV/iom;[^WoBJcW
odN[iP02odJZi@0AodB[iOm4ZnKoAZ[VodFYiOm3Yn?oAJWTodN[i_m8[>Oo
A:_Vod:Yi?m1Z>?o@:ORodB]iom1ZnGo?:WTocVWh_lgZ>800_lfZN800ole
ZN;oj^[Zon[ZjP0Eon[ZjP05onSXj?oVi^Koh^;Rom_KfonMWId01OoVi^H0
1?nMWIgofm_Kon;Rh_oVi^H3oiJFUP;oUiNG1_nFUYH4oiNGU`;oV9RH0onG
UiL=oiRHV004ohn?Son8R8SoR8R8ohV9R@;oRXZ:00?oRHV9ohZ:R_n;Rh/0
0_n;Rh/01?n9RHWoRh^;oh^;Ron;Rh/3ohb<S004ohf=SOn?ShooSXj>oi6A
T@;oT92@00OoShn?oi2@T?nATI7oShn?ohj>S_n@T93oUYJF00?oVIVI00Go
V9RHoiNGUonHV9SoV9RHoiVIV@08oiRHV003oiNGUonHV9SoV9RH00?oV9RH
0_nGUiL2oiRHV0KoUiNG6?oZj^X01OoXj>Soi^KVon;Rh_oKfm_oWIfM00Go
i^KV00Oog]kNolK6a_nXZ:SoYJFUok6a/Ong]kOo^k^k00;o_[jn1_no_kl2
okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6
okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2
okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6
okno_`;o_[jn1_no_kl02?nn_[ko^k^kokNg]ona/K7oYJFUojRXZ?o6a/Ko
g]kNh_oVi^H000Gok^k^01GoXj>Som_KfooRh^;o9JOIobNVfOlYYm[o:ZKJ
obfVfol^Ymco;jSMobfYgOl_Zmoo;J_Nobb[g_l^[=oo;j_Ooc:[h?ld[>7o
=Z_PocZ^golh[=/00_lgZm`0=oli[N3o>ZkQoc^]hOlk[N7o?:_PocbZgoln
[>7o@ZgSod>]hOm3Zn3oA:cOodb[hOm@X]co@XRlod9hY?m@NigoG7jGofN3
V?m_S9koMY6RofV3T_nDZ[Go`=;FoiFSXonIYJ?o]/G2ojo1`on``;oo/kZc
okBk/oncb<7o]/o<ojBi__oFj?CokO[ool3@h?n<Y[GoPZ>boh2V^OmlY[ko
OjK7oh6Vd?meVlcoIic@oeJYgOm=[^?oBjcSodFXgom3Y]goA:ONodJYh_m5
Z^;oAZ[UodB[iOm3Z^@00om2ZnD01?m0ZN?o?jSRod2WhOm1Z>82od>Zi008
od6Zi?loZ>;o?ZOQocbVh?lmZ^?o>jSQocRVhOleY^02ocFXh@03oc>Wh?l_
Y]koj^[Z01Goj^[Z00KojNWYonSXj?oVi^Koh^;Rom_KfonSXj<5onk^kP04
oj>SXooKfm_oh^;RonKViPSoUYJF2?nGUiL00onHV9SoUiNGoiNGU`02oiNG
U`?oV9RH0_nGUiL6oiRHV00;oiNGUonDU9CoTY:Boi:BT_nCTi?oU9BDoiJF
U_nGUiOoU9BDoi^KVonRXZ800_nJVYX00onPX:3oWinOoinOW`02oijNWP08
oj2PX?nQXJ7oWIfMojFUYOnYZJWoXZ:RoiZJV_nIVIT4oiZJVP?oV9RH00?o
VIVIoiRHV?nHV9P00_nGUiL8oiRHV0CoUiNG0onHV9P:oiNGU`03oiJFU_oZ
j^[oj^[Z01Goj^[Z00KojNWYonSXj?oVi^Koh^;Rom_KfonSXj?oonk^kWOo
k^k^0005ooooo`0:ojn_[ooKfm_ohN7QobZZfolYZM[o::KHobZVfOl^Z=_o
<JWMoc6[gP;o;j_N0ol^[=h01_l_Zmko<J_Noc>[goleZ]oo>JgNocN[g0;o
=Z[K02oo=j_NocR/goli[>;o>ZcRocRZh?ljZN3o?J_Pod2[hOloZ]ko?jWM
od6[gom:ZmkoC9oAoe6Kb_mKX<[oIZC;ofVQa_m_XLCoO:[;ohN^bon0W[Ko
Wk;1omgTk_oblOKo_[Vmohb6R_nYYZgo/:neojna[_na/JooZJ>UojFKXooo
m?oon?CoolK>hOnN]lgoMjFlofVZ`?mQ[LGoE:G2oe^WbOmW[mOoHYo<oe6E
a_mD[=koBjoQodR/h002odBYg@0AodFZg_m5Z^3o@JWNod>[h_m1Z^7o@Z_R
od:[i?m3[>Go@JcTod2[holoZ^;o@:WRod6Zhom2ZnGo@J[Tod2YholoZ>80
0_lnZ>801?llZN;o>ZOPocNUh?leY^02ocJYhP03oc>Wh?l`Y=goj^[Z01Go
j^[Z00KojNWYonSXj?oUiNGohN7Qom_Kfon_[jl5ooooo`04ojn_[ooKfm_o
hN7QonGUi@GoUYJF5_nGUiL00onHV9SoUiNGoiNGU`02oiRHV003oiNGUonF
UYKoUiNG00?oV9RH00WoVYZJoi^KVonIVIWoW9bLojFUYOnXZ:SoWinOoiJF
U_nKVi/00onMWId01_nKVi_oVYZJojVYZOnYZJWoXZ:RoifMW@?oVIVI00Go
UiNGoiRHV?nJVY[oV9RHoiJFUP02oiVIV@GoV9RH00?oUiNGoiRHV?nHV9P0
1_nHV9P01?nGUiOoV9RHoiRHV?nHV9P;oiNGU`03oiJFU_oZj^[oj^[Z01Go
j^[Z00KojNWYonSXj?oUiNGohN7Qom_Kfon_[jooooooogOooooo0005onk^
kP0<oj>SXooIfMWoh>3Pobb/gOlZZ=[o:JGHobbVfOl`Z=co<Z[Noc6YgOl_
ZMco;:SK0_l[ZM/01ol]ZMco<:[Moc:Zg_leZ]oo=ZcNocN[g_lfZ]/00_ld
Z=T01_ldZ=_o=Z[MocNZh?lhZn7o>JcRocZ/hP;o?:_P03Ko>jWLocVWf_lm
Z=coAJ_LodfZe_m@Ym;oE:SDoeFXe?mEXm7oFjC?of>Tc_mXX<GoO:O9oi:`
b_nO[/7o_l??onCNj?oCb=3oVh^EojnTZ_nWYjOoX9jOon7@f?ook?colM_`
olBoe_nGZL7oLYbeofJWaOmEZ<SoCZoBodJ/d_m7Z]?oCZ_FoeFVdomIZm_o
CjgPodV_h?m6Zmoo@j_NodJ[gom5[N3oA:cQocnYgOm0ZN3o?ZWOocnXgolo
Z^3o@:_Socn/i?m1[>Co@:_SocjYhOloZ^82od2Yh`;o?jSR00[o?jWSod2Z
i?lmZ^?o>ZOPocNTgolfY=oo=ZOQocFXhOldYn3o<:CM5_oZj^X01_oYjNWo
inOWonGUiOoPh>3ofMWIoj>SX`Gok^k^00GoXj>SomWIfOoPh>3oiNGUoiNG
U`04oiJFUP?oUiNG1?nFUYHCoiNGU`WoV9RH00OoVYZJoibLW?nLW9coX:2P
ojFUYOnRXZ;oV9RH00;oVi^K00SoVYZJoj>SXonXZ:SoYJFUoj2PX?nKVi_o
V9RHoiVIV@KoV9RH0_nIVIT6oiRHV0GoUiNG1?nHV9P00onGUiOoV9RHoiNG
U`04oiNGU`03oiRHV?nGUiOoUiNG00;oUYJF0onGUiL00onFUYKoj^[Zon[Z
jP0Eon[ZjP06onWYjOoWinOoiNGUon3Ph?oIfMWoXj>Sooo^k^igonk^kP00
1OoVi^H01onMWIgoemOGomoOgolYYmWo::KHobRTeol[YMP00_l_Ym/01?l]
YMWo:ZCGobZVfOlZY]T2ob^WfP06objXfol`Z=co<jSMocFYg?ldZ=_o=:SI
1?lbZ=X0??ldZMko=J[OocV^holhZn7o>:cOocV[goliZ=go>:OLoc^Yg?ln
[M_o@jkJod2/doloZ=Go?ZODod:WeOm<Zm_oDjWHoe:Qc?mMX<_oI9c1oh>[
c_nG/L[oZK;3on;Li_o[fmkoh];Bonk^k?oZj^coooCoongJkOni/LWoVZS3
ogjZaomZ[<coFZW@odNRcom4Z=Wo@jgOodFah_m4[]ko@ZCEodNWfOm6[=go
@jcLod6Yg?loZM_o@Z[ModB^h?m1Zmoo?:OKod2[gollZ]go?:OMocVWg?lj
Z=go>ZWNocbZgollZN7o>JKNocVVg`;o?:KP00co>jGOocbVh?lmYn7o?jWS
ocjXi?liY^7o=J;Moc>Qg?ldX]go<jCNoc:SgOl`Xm`Eon[ZjP07onWYjOoX
j>Soi^KVon?ShooPh>3oemOGoifMW@05onKViP04oifMWOoGemOogmoOon?S
h`koUYJF2_nGUiL00onHV9SoUiNGoiNGU`04oiNGU`;oV9RH1?nGUiL2oiRH
V006oiNGUonHV9SoUiNGoi^KVonLW9coWIfM0_nUYJD02_nSXj?oYjNWojNW
YonYZJWoYJFUoijNW_nKVi_oVYZJoiVIVOnHV9P2oiNGU`?oV9RH0_nGUiL2
oiRHV0;oUiNG0onHV9P00onGUiOoV9RHoiNGU`0@oiNGU`KoUYJF5_oZj^X0
1ooYjNWoj>SXonKVi_oShn?oh>3PomOGeonMWId0oooVi^IgonKViP001Oo^
k^h01onSXj?og=cLon;Rh_lXY]So::CGob^Uf?l]YMT00_l`YMX00ol^XmSo
:Z;FobfWfP02obZVf@03obbVfOl^Y][o<:GJ00;o<ZGK00?o<jOJoc>Wf?lc
ZM/00olbZ=X00olbYmco<JWMocN/h@02ocBYgP?o=Z[M033o>:[Loc^^gOlg
Z]Ko=J[EocJ/f_leZm_o=JOIocj/gom7[MkoAZKHoe6YfOmHY]KoGJ3=og6U
b_n>[/OoWZZfomgGeoonmO3oloSdoo_oooo`k?[o[:g2oiBU`Om`Vk_oF9k0
odjSc?m=Z=OoAjGKodZYhom3Yn;o@:_Sod6^i_llYmoo?JKMod:/g_m0[=go
?jWKocjZfom1Zmoo@ZgQod6/h?lkZMco@[3Uod2^holmZn3o>ZWNocZYh?lj
ZMh2ocZYh0;o>JKO0_ljYn002OlkYMoo?:KPocfWhOlnZ>;o?:KRocZTh?lf
Xmko=J;MocBQg002ocBRg@03oc:SgOoZj^[oj^[Z01Goj^[Z00Goj>SXonKV
i_oRh^;og=cLoj>SX`05onk^kP04oj>SXooLg=coh^;RonKViPOoUYJF00?o
UIFEoiJFU_nFUYH02?nFUYH4oiNGU`03oiJFU_nGUiOoUiNG00KoUiNG00?o
V9RHoiNGUonGUiL00onGUiL2oiRHV005oiNGUonHV9SoV9RHoiRHV?nIVIT0
0_nKVi/02?nTY:CoZJVYojVYZOnZZZ[oYjNWoifMWOnKVi_oV9RH0_nGUiL0
1?nHV9SoUiNGoiRHV?nGUiL2oiRHV0;oUiNG0_nHV9P2oiNGU`?oV9RH00?o
UiNGoiRHV?nHV9P04?nGUiL6oiJFUQSoj^[Z00Goj>SXonKVi_oRh^;og=cL
oj>SX`3oonk^kWOok^k^0005ooooo`03ojn_[ooLg=coh^;R00;o::CG00?o
:jGHobbTf?l_Y=T00_l`YMX00ol^Y][o;:KIobbVf@02obbVf@0@obfUfOl`
YM[o<ZGKoc>UfolcYm[o=:SKocF[gOldZ]co<JWMoc2Xg?laZMko<:WNocB/
hOlaZMgo;jOKoc>Xg@;o=J_M03;o=Z[MocJZfoli[Mco>:kNocRbiOlg/>Go
<J[OocJ[hOlm[>7o?ZWMocBNd_m0Y=SoD[3TodVJaomc/<ooPZVjoiV[[Oo]
m_7olokjoncjnonQ/kooQZJmofZR`omU/m[o?Yo:odbbhom7Y]koCJKRoeFY
iom<XN7o@J7Nod2XiOlmZnSo@k7/ocj[holn[=oo?j[Noc^Yg?lnZMoo?ZcQ
ocf[h?ljZMko?jkUocj]i?lm[>?o>ZcRocVZh_liZn7o=jSPocJWg`;o>ZWQ
00_o>j[RocZYhOljYn3o>JKOoc^UhOllY^;o=j7MocRRg_liXmoo=jCOocJR
h002ocBRg`03ocFSh?oZj^[oj^[Z01Goj^[Z00Goj>SXonKVi_oRh^;og=cL
ojn_[`05ooooo`04ojn_[ooLg=coh^;RonKViQ7oUYJF1?nGUiL00onFUYKo
UiNGoiNGU`02oiNGU`03oiJFU_nGUiOoUiNG00GoUiNG0_nHV9P2oiNGU`06
oiRHV?nGUiOoUIFEoiNGUonIVIWoUYJF0_nJVYX03OnKVi_oZ:RXojVYZOnX
Z:SoWIfMoiZJV_nHV9SoVYZJoiJFU_nIVIWoUiNGoiRHV?nIVIT00onGUiL0
1?nHV9SoVIVIoiRHV?nHV9P3oiNGU`03oiRHV?nGUiOoUiNG00?oV9RH3OnG
UiL8oiJFUQSoj^[Z00Goj>SXonKVi_oRh^;og=cLojn_[`3oooooogOooooo
0005onk^kP03oj>SXooLg=coh^;R00;o9J7D0_lYXMD03_l/WmGo;Z7GobnT
fOlaY]_o:j?GobZTeol[YMSo;:KIoc2Uf_lbYmco=JOMocJXg_lcYm[o=JWL
0_lf[=h09_lcZmoo<JWMoc2Yg_laZ]oo=:gRoc2Yg_l^Y][o<:SLoc:Zg_lb
Z]co<ZSJoc:VeollZ]_o>JSMocF/i?lb[NSo;ZWUoc6YiOli[>?o>j[QocVX
golmZ^;o?ZOPoe2`h_mBXLSoI::koh:/^?nW`lOoh_CfokW=e?mkX;;oLJ[5
oe:Tb_m6Z=Oo@JoRocn/iOm5YnCoAj7O0_m?Xn401om7Xn;o@:KTocFUi?lj
[>So>j[RocbYhOljYml00_lhYMd00oliZ=oo>:OOocNVgP02ocNVgP07ocJW
golgZ>;o>:WSocNXh_ldYMoo<Z?MocVXh002ocZYh@03ocVXh?lhYMko=Z?L
00;o>:;N00So<9[Foc>MfOlgXMgo>:;NocFQgolcWmgo<Z3Moc>QgQOoj^[Z
00Goj>SXonKVi_oRh^;og=cLoj>SX`05onk^kP04oj>SXooLg=coh^;RonKV
iPGoUIFE2OnFUYH2oiNGU`03oiJFU_nGUiOoUiNG00OoUiNG0_nFUYH3oiNG
U`03oiJFU_nGUiOoUiNG00WoUiNG00OoVIVIoiNGUonHV9SoVYZJoinOWonW
YjOoXJ6Q00;oVIVI0_nGUiL3oiRHV003oiNGUonHV9SoV9RH00?oUiNG00?o
V9RHoiNGUonGUiL03?nGUiL2oiJFUPGoUiNG0onFUYH2oiFEU@KoUYJF6?oZ
j^X01OoXj>Soi^KVon;Rh_oLg=coXj>S0?ook^k^Moo^k^h000Goi^KV00Go
WIfMom_KfooRh^;o8YkBobJReP02obVQeP04obfPeolZWMCo:YgDoc6Vg0;o
;JGJ00So;:GJob^TfOl^XmWo;Z?Ioc6Rf_laXmWo;j?Foc2Te`;o;jCI0_l]
YMX0:ol]Y]_o;ZOLoc>/hOl`ZMko;ZOLobnYg?lc[N3o=JoRocB/g_lhZ=[o
@jGFod>TfOlhY>;o;jCWob^TjOl`Yn_o=ZSVocZWh?lkY=_o@:SModFZh?m7
Ym[oBZ;@oeJTbomZZl_oP;37oifgb?n>ZK[oKZ:joeRS`om<ZMGoA:cQocjX
i?ljY>;o?jOVod>Whom7Yn7oB:OQodFXhOm0ZN;o>J[TocJZholl[NL00_ll
Zn<01Olm[>Co>jWTocRVhOlgYN3o=JKP00?o=ZOQ0olfYn<2ocFVhP0:ocJW
hOlfYmoo>JSPocVXh?liY^7o=jCOocRRg_lgXMgo>ZCPocRRgP;o=Z3N0_le
XMl00oldX=ko<YkLon[ZjP0Fon[ZjP05onSXj?oVi^Koh^;Rom_KfonMWId0
1OoVi^H01?nMWIgofm_Kon;Rh_oVi^H7oiFEUA7oUYJF0_nGUiL01?nFUYKo
UiNGoiNGUonHV9P5oiNGU`;oUYJF1OnGUiL02?nHV9SoUiNGoiNGUonHV9So
VIVIoi^KVonMWIgoVi^K1?nHV9P4oiNGU`?oV9RH0onGUiL01?nHV9SoUiNG
oiNGUonHV9PAoiNGU`?oUYJF00?oUiNGoiJFU_nFUYH01OnFUYHHon[ZjP05
onSXj?oVi^Koh^;Rom_KfonMWId0oooVi^IgonKViP001Oo^k^h01OnSXj?o
fm_Kon;Rh_lTX=Co9j?G00;o:Z;G00Ko;j;IobbOe_l/WmKo<JKLobbTfOl]
YMX2obfVf`06oc2Ufol_Y=[o<J;Joc2QfOlbYM_o<jOJ0_lbYm`01Ol_Ymco
;ZKKobjVfol]Y]_o;ZOL00;o;JKK02go;ZOLoc2ZgOlbZ]ko<j_OocRXf_m2
XmKo@jCKocVUholbYNSo;jG[oc:YkOlgZNOo>jSQocnXgom2Z]oo@Z[Qod>X
h?m6YM_oCJOIoeZ[f?m][=GoQjW<ogfQ`OmOXL?oBjG:od:Ye_llZ]oo?JOU
ocfViollYNKo?JOUocnXh_m1ZN3o@jSPocnXgolhZ]ko=j[PocVZi?liYn;o
>JOTocZXiOliYnCo=ZCQocBUhOleY^800olfYn<02oleY^;o=JGTocBTholc
Xn;o<Z?Ooc:SgOlbXm_o=:?Koc>Rf_ldXMco<j3K00;o=IoK0_lhX]h00olg
XMoo=Z3Noc:Ng003oc:Ng1Koj^[Z00KojNWYonSXj?oVi^Koh^;Rom_KfonS
Xj<5onk^kP04oj>SXooKfm_oh^;RonKViPCoUIFE00?oUYJFoiFEUOnEUID0
5OnFUYH7oiNGU`;oUYJF1?nGUiL2oiRHV0;oUiNG00KoV9RHoiVIVOnJVY[o
Vi^KoiVIVOnHV9PBoiNGU`;oUYJF1_nGUiLCoiJFUQOoj^[Z00KojNWYonSX
j?oVi^Koh^;Rom_KfonSXj?oonk^kWOok^k^0005ooooo`0Eojn_[ooKfm_o
hN7QobBPe_lVX]So:9oGobZQfOl`Xmco;Z7JobZNeol^X]_o:J3HobVRfOlZ
Xm[o:jCKobjRfol]XM[o;YoIobfNe_l`XmWo<JCJ00;o<JKL00Ko<:GKobfU
f_l/Xm_o;:?Kob^Rf_l]Y=`3objVf`0Zoc2Uf_laY]_o<jKLocNUf_lgY]go
=:KRoc2Vhol_Yn?o<j[TocRYhOliZ=oo>ZSMocVVg_lhYN3o>ZCPocbUgom3
Y]ooBjKMoeRTf?m/W<goIYW8odjPb?m0Y/ko>JSEocRXf_lmY^3o?jOVocJR
holgXnCo>JGSocfWhOloYmko?JOIocVXeOleZ=Oo>JSPocNUh_lfY>?o=jGT
ocJTholdX^7o<j7P0_leXn82ocJTh`;o=J?R0_ldX^401olcXMko<j7Loc>Q
g?lcXMco<Z3Koc>PfoldXM`00_lfX=`02?lfX=ko=j7OocNQgoleWmgo<9cJ
obnKfOl_WM[o<9kK5_oZj^X01_oYjNWoj>SXonGUiOoQhN7ofm_Kojn_[`Go
oooo00Co[jn_om_KfooQhN7oiNGU1?nEUID2oiJFUP04oiFEUOnFUYKoUIFE
oiFEU@CoUYJF0_nEUIDAoiJFUP;oUiNG0_nFUYH9oiNGU`?oV9RH1onGUiL2
oiJFUPSoUiNG00?oUYJFoiNGUonFUYH05onFUYH4oiFEUAOoj^[Z00KojNWY
onSXj?oUiNGohN7Qom_Kfon_[jooooooogOooooo0005onk^kP0<oj>SXooI
fMWoh>3Pob>OeOlTX=Ko9IkEobROeol^X]_o;J3IobRLeOlYX=So:9oG0_lX
XMP02?lYX]Wo:Z7IobbPfOl/WmSo;IkHobfPeol^XMOo<:?J0_l`YM/04?l_
Y=[o;JCLobfTg?l/Xm_o;JCLobjVfol`YM_o;jCJoc2Sf_l`XmWo;jCJobbU
g?l^Yn3o;jSOobnWg?laY]/2ocBXf`0Yoc>Wf_l_Y=[o;j?NobnSh?laXn7o
=ZCQocbThOm1Y=ooBj3IoeNHd_mEV<oo@Z7AocRWe?ldZMGo<jOHocRUg_ln
Y^Go=J7QocJRholkY>Go?JGRocnVh?lnY]Wo>jOEocNWeOljZN7o>:KSocJT
holfY>7o=:;Qoc:PgOlbX=oo<j7Noc:PgolbX=go<j7PocBRgoleXn;o=J?P
ocFSh_leXn001?ldX]d2ocFRg@;o=j7M0olfX=h01OlbW]co<9cJobjLfOl_
WM[o<9kK01Koj^[Z00KojNWYonOWiooUiNGoh>3PomWIfOnSXj<5onk^kP04
oj>SXooIfMWoh>3PonGUi@CoUIFE00?oUYJFoiFEUOnEUID02_nEUIDDoiJF
UP;oUiNG1_nFUYH4oiNGU`;oUYJF0_nGUiL00onFUYKoUiNGoiNGU`02oiJF
UPSoUiNG6_nFUYH4oiFEUAOoj^[Z00KojNWYonOWiooUiNGoh>3PomWIfOnS
Xj?oonk^kWOok^k^0005onKViP0HoifMWOoGemOogmoOob:OeolSW]Oo8icE
obNNf?l^X]go:ioJobNKe_lWW]So:j;LobZSg?lWX]_o:J;KobZQfol]XMco
;j7MobnRfol_X=So;j;Hoc6TfolbYMco<JGN0ol`Y=d2objRf`0fobnSg?la
Y=go<ZGLoc>Tg?lbY=[o;JCLobFWhOlWZN?o;:SLoc2Ve?lbY/oo<jO@oc6X
dol/Y]Oo::ONobRXiOl[Z>So;ZSWocBVh_lhYMko?JGLodBSfom:W]coAIkJ
oc^Sf?leZM[o<J_Joc2ZfolcY]go=jGPocVShOlkX^Co@:?Tod6Uhom3Y^7o
?jONocbXfOliYmSo>ZOPocRUh?lgXn7o=jCOocJRh?leX]go=J7OocJSg_lb
W]co<j3KocBPg_leX]go=Z;PocJSg_lfX^3o=Z?N0_lcX=/02?ldXMco=J;M
ocJPg?leWm_o=9kLoc>MfolfX=ko=9kL0olaWM/00olaWmco<9kMobfMg00E
on[ZjP07onWYjOoXj>Soi^KVon?ShooPh>3oemOGoifMW@05onKViP04oifM
WOoGemOogmoOon?Sh`;oUIFE00?oU9BDoiFEUOnFUYH00onEUID2oiJFUP?o
UIFE7_nFUYH6oiNGU`;oUYJF0onGUiL00onFUYKoUiNGoiNGU`09oiNGUaSo
UYJF0onEUID00onFUYKoUIFEoiFEU@0Fon[ZjP07onWYjOoXj>Soi^KVon?S
hooPh>3oemOGoifMW@3oonKViWOoi^KV0005onk^kP0Eoj>SXooLg=coh^;R
ob:OeolTWmSo99gFobJMeol]XMco:ioJobNKe_lWW]So:J;KobRQf_lUX=Wo
99oHobROfOlYX=[o;Z3LobnRfol_X=So<:;H00;o<:?J00Co;Z;KobfQf_l/
X=Wo;J7J0_l/X=T0;_l^XM[o<J;LocBUgOlgY]ko=ZGLoc6Ug_lYYnCo:jWT
oc:Xf_ldY=;o=jC=ocJUd?laYmOo:JOJobNXh_lZZ^Oo;j_Woc:XiOldYMgo
>:?KocZSf_llXmgo?jKQoc^Sh?liXmoo>:OOocBXhOl`Ymoo<:CMoc6TgOlf
Xmko>J;Loc^RgOlnX]ko?:?NocZSg?lgY=co=Z?LocNTgOleX]_o=J;MocNT
gOlgY=oo=Z?LocNTgoliY]l6ocFRf`;o=:7J0_lbWmX2oc>Pf`06ocFOfold
W][o<YcJoc:Lf_leWmgo<igK0_l_VmT01?l`W]_o<IoLobjNgOl]WM`Gon[Z
jP05onSXj?oVi^Koh^;RomcLg?nSXj<01Oo^k^h01?nSXj?og=cLon;Rh_oV
i^H4oiFEU@03oiJFU_nEUIGoUIFE00OoUIFE2?nFUYH01?nEUIGoUYJFoiFE
UOnEUID3oiJFUP03oiNGUonFUYKoUYJF00;oUYJF00?oUiNGoiJFU_nFUYH0
1?nFUYH3oiNGU`?oUYJF0onGUiL00onFUYKoUiNGoiNGU`06oiJFUP;oUiNG
2_nFUYH00onGUiOoUYJFoiJFUP0<oiJFUP;oUIFE0_nFUYH3oiFEU@03oiJF
U_nEUIGoUIFE01Soj^[Z00Goj>SXonKVi_oRh^;og=cLoj>SX`3oonk^kWOo
k^k^0005ooooo`0<ojn_[ooLg=coh^;Rob6Nf?lSW]Wo8i_GobFKf?lZW]_o
:9cIobBJeolWWM[o9YkJ0olSW]T04OlVW=Wo9igJob^Mfol/W][o;YoIobjO
eol^XMSo;J3GobbOf?l[W]Oo:igIobbNf_l[WMWo;IoKoc2QfolaX]co=:?K
00;o=J;K02[o=:?Koc>Qg_leX]go>J7FocZPdOlhXM7o=ZCGoc6Ug_l[Y^;o
::?OobbTh?leY=_o>J?Goc^Pe?ljWm?o=j3IocBRgOlbZ]oo<ZKOocVPh_ll
Wn?o>YoUocBOhol_X^7o;ZGOoc:Tf_ldY=Ko=:;CocBReOlaXmWo<:7Moc2P
h?lbWn3o=J;MocBQfOldXM[o=Z?KocVSgOlgX][o=j7KocVTg?lfXMT4ocNR
fP06ocJQfOleX=So=J3Hoc>PfOlbWm[o=9kJ0olcWMT01?ldW]co=IoMoc>M
folbW=X2obnKf@;o;YcK0_l/W=/Gon[ZjP05onSXj?oVi^Koh^;RomcLg?n_
[jl01Oooool01?n_[joog=cLon;Rh_oVi^H2oiFEU@05oiBDU?nEUIGoUIFE
oiFEUOnDU9@02onEUID00onFUYKoUIFEoiFEU@05oiFEUAKoUYJF00?oUiNG
oiJFU_nFUYH05?nFUYH00onGUiOoUYJFoiJFUP09oiJFUP?oUIFE0onFUYH7
oiFEUASoj^[Z00Goj>SXonKVi_oRh^;og=cLojn_[`3oooooogOooooo0005
onk^kP0=oj>SXooLg=coh^;Rob2Ke?lRWMKo8I[Cob>Je?lUW=Ko9IWDob:I
dolVWMOo9IgIob>Ne`02obJNfP;o:9kK00Co:YkKob^MfOl]W]So;YoG1?l]
X=T01?l^X=co;j7Mob^MfOl^X=`2oc:Sg@0_oc6Of_l_W]Ko<IkIoc:Of_ld
W][o=ikIocVNe_lhWM?o=YkEocFRfolaXn7o;J?Sob^NgOl^Wm_o=IkEocZO
dollX=;o>j3FocNQfolbXmgo:ZKLobfTg?lgW^3o>icSocVKi?ldWN7o<:;Q
oc2WhOldYmgo=JOIocFUeOlbY=Ko<:?Joc2Rg_laX>Go<j3SocJSg_ldXMWo
=J;JocJSfolgXM_o=9oGoc>MeolbWmOo=9oGoc:OeolcX=P01?ldXMT02_ld
XM[o<YoJoc6NfOlaVmOo;iWEoc2Je_lbW=So=9kLocJPg_laVmT2oc:LfP05
obnKfOl]VMWo;9SHobbJfOl]VmX05ooZj^X01OoXj>Soi^KVon;Rh_oLg=co
Xj>S00Gok^k^00KoXj>SomcLg?oRh^;oi^KVoiBDU?nEUID2oiBDU003oiFE
UOnDU9CoU9BD00ooUIFE0_nFUYH00onEUIGoUYJFoiJFUP02oiJFUP;oUIFE
2OnFUYH2oiFEU@koUYJF0_nGUiL<oiJFUP03oiFEUOnFUYKoUYJF00SoUYJF
1OnEUID2oiJFUPSoUIFE6?oZj^X01OoXj>Soi^KVon;Rh_oLg=coXj>S0?oo
k^k^Moo^k^h000Goi^KV00KoWIfMom_KfooRh^;o9IkEob>LdolSV]82obBK
d`06obFLe?lVWMGo:9oGob>Je?lTWMCo9ikH0olYX=X01OlXWmWo:IgHobRJ
e_l/WMOo;j3L00;o<:7M0_l^Wm/01?l_X=co;IkJobfNf_l^Wm/2obnPg005
objOfOl]VmSo:I[DobjOfOl]W]H00_l^WMD02?l_W]Ko<9kIoc:PgOlbX^7o
=:;QocJRh?lhX]ko=j3J0_ldWMH02_lgXM_o>:KQocNXh_leXmko=IoMocJN
gOlgX>7o=J7Ooc6Rg_l^XMX2obnPf008oc2Rf?laX][o<Z?Moc:SgOldX^7o
=:;OocBQg?lcX=T2oc:Of005oc:Of_lbWmSo<IkIobnMf?laW]T00olaWmX0
1_l^Wm_o;IkJob^MfOl[W=So<YkLoc>Mf`;o<YcJ0olcWM/01_lbW=[o:i?B
obnGe_lcVm[o<YcJoc2Jf0;o;iWG00?o<I_Ion[Zj_oZj^X05OoZj^X01OoX
j>Soi^KVon;Rh_oKfm_oWIfM00Goi^KV00GoWIfMom_KfooRh^;oi^KVoiFE
U@04oiBDU0?oUIFE00?oU9BDoiFEUOnEUID01onEUID3oiJFUP;oUIFE00Co
UYJFoiFEUOnEUIGoUIFE0_nFUYH9oiFEU@KoUYJF0_nEUID00onFUYKoUiNG
oiNGU`0EoiJFUP?oUIFE0onFUYH4oiFEU@;oUYJF0_nEUID3oiJFUP03oiFE
UOnDU9CoUIFE00KoUIFE6?oZj^X01OoXj>Soi^KVon;Rh_oKfm_oWIfM0?oo
i^KVMooVi^H000Gok^k^00CoXj>Som_KfooRh^;o9IgB0olTW=42obFMdP06
obJMeOlWW]Ko8i[Bob>Jd_lTVm?o9IcD0_lVWML01olWW]So:IgHobNIeOlZ
VmOo;IkJobjOfol/WMT00_l[W=P2obbMf@03obfNf_l^Wm_o;YoK00?o;YoK
00_o;J3IobbPfOlYXMKo:ioHobbOf?l]W][o<9kKoc:Ng?lcWmgo=9kLocFO
g@02ocNQg`07ocJPg?lcX=_o<j3Ioc>PfOlhX]ko=j7MocJPg002oc>Pf`06
oc:PfolaWm[o;j3JobfKe_l^W=Oo<9kI0_laWmX01olaW]Wo<9gHobnLeolb
WmSo<IkGoc2Mf?laW]T00_lbWmX01olbX=_o<IoJoc6Og?laWmco;IkJobbM
fOl[VmX00_lYVmT00olZV]Wo<9cJoc6Kf@05oc6Kf@03oc2Jf?l`V=Oo<IWH
00;o<Y[I00Co<IWHoc2Heol_UmKo;YKE5_oZj^X01_oYjNWoj>SXonKVi_oR
h^;ofm_Koj>SX`Gok^k^00GoXj>Som_KfooRh^;oi^KVoiFEU@03oiBDU0Co
UIFE0onDU9@5oiFEU@03oiBDU?nEUIGoUIFE01?oUIFE4_nFUYH3oiFEU@;o
UYJF0onEUID01?nFUYKoUIFEoiFEUOnEUID6oiJFUQGoUIFE00?oU9BDon[Z
j_oZj^X05OoZj^X01_oYjNWoj>SXonKVi_oRh^;ofm_Koj>SXoook^k^Moo^
k^h000Gooooo00?o[jn_om_KfooQhN400_lUV]02obFIdP;o9Y[C0_lWVm@0
2_lZW]Wo:9cGobNKe_lUVMCo99SCobFIe?lVV]Go9i_FobVKeol[WMT2obbN
fP03ob^MfOlZW=So:YcH00;o:igI00?o;9kJobfOfol/W]X00_l[WMT02_l]
Wm_o;j;Kob^Of?l/XMOo;J3IobjQf_l_X=co<9kKoc6Mfol`W=X2oc>Mf`0;
oc:Ng?lcWmgo=:7LocBQg?laW]Oo;icEoc>MfOleWm_o=Z3Loc>PfolbWmX0
0_laW]T03olaWm[o<9gHoc6NfOlbWm[o<j3Koc:Of_lcWMWo<YcHoc6Keolb
Wm[o<9kIobnMf?l^W=Oo<9gHoc:OfP02oc:Ng004oc>Qg_laWmco;YcIobZK
e`;o:IWH00Co:Y[Iob^Kf_l_Vm_o<I[K1Ol`VMX00ol_V=Wo<i[Loc:If`02
oc2Gf@04oc6Hf_l`UmWo;iKHobfDeQKoj^[Z00KojNWYonSXj?oUiNGohN7Q
om_Kfon_[jl5ooooo`04ojn_[ooKfm_ohN7QonGUi@KoU9BD1OnEUID4oiBD
U13oUIFE00CoUYJFoiFEUOnEUIGoUIFE0_nFUYH3oiFEU@KoUYJF0onEUID4
oiJFUP;oUIFE00?oUYJFoiFEUOnEUID00onFUYH3oiFEU@03oiJFU_nEUIGo
UIFE00;oUIFE1OnFUYHEoiFEU@03oiBDU?oZj^[oj^[Z01Goj^[Z00KojNWY
onSXj?oUiNGohN7Qom_Kfon_[jooooooogOooooo0005onk^kP0Eoj>SXooI
fMWoh>3Pob>FcOlSV<ko9ISAob>Gd?lUV=7o9IWBobJId_lTV=7o:YcHobRL
eolXV]Ko9Y[EobNIeOlWVmKo:I_GobZLf?lYVmOo:YcH00;o:igI0_lYVmL0
1_lZW=So;9kJobZLf?l[WMWo;9kJob^Mf@;o:9[F00co:YcHobbNf_l[W]Oo
;9oFobfPfOl_X=[o<IoLoc2Nfol`W=[o;i_IocBNg?laWM/2oc2LfP06oc6N
fOlaWm[o<J3Hoc6NeolbW=So=9cI0_ldW]X2oc:OfP;o<IkI00?o<j3KocFO
foleWm/00olfW]/01?lgWM_o=YkKoc:Of_l`W]T2obnMf0;o<9gH00Ko;i_I
objJf?lbX=go<9kKobjLfOl]VmP2obbJf@04obfKf_l^W=_o<9cLoc6Jf`Go
<9WJ00?o;iSIoc2GfOl_U]P00ol_U]P00ol`UmWo<ISJoc6HfP0Fon[ZjP06
onWYjOoWinOoiNGUon3Ph?oIfMWoXj>S1Oo^k^h01?nSXj?ofMWIon3Ph?oU
iND8oiBDU0?oUIFE0_nDU9@FoiFEU@;oUYJF0onEUID00onFUYKoUIFEoiFE
U@02oiFEU@;oUYJF0onEUID4oiJFUP;oUIFE2OnFUYH7oiFEU@03oiJFU_nE
UIGoUIFE01GoUIFE5ooZj^X01_oYjNWoinOWonGUiOoPh>3ofMWIoj>SXooo
k^k^Moo^k^h000Goi^KV01KoWIfMomOGeooOgmoo8iC>obBGd?lVUm7o8iK?
obFFd?lVVM;o9iSDobBFd_lUU];o99KBobNHe?lWVMGo:Y[Iob^Mfol]WMco
;YkMobJGdolXVMGo:I[F0olXVMD04_lZVmOo;9gIobVJe_l[W=So;IkJobbM
fOlZVmOo:9WEobVJe_l[W=So:Y_Eob^Le_l]W]So;YoIoc6Og?l`W]_o<9cJ
obnKf@?o<IgK00Wo<9kKobnMf?l]W]So;YoIoc6Of_lbW=[o<Y[Ioc6KfOlc
WM/00_leWmd01OldW]co<I_IocFOgOleWMco=9cK00;o=9[J00_o=I_KocVL
gOlhW]ko;icGobjLeol`WMSo<IkIoc6Mfol_VmWo;IWGob^Ge@04objJf0Co
;Y[J00?o<I[Koc2If_l_V=T00ol_V=T01_l^UmSo;IKGobfDe_l^UMOo;iKH
objEe`;o;ICF00?o<9OIoc>Jg?oZj^X05?oZj^X01ooYjNWoj>SXonKVi_oS
hn?oh>3PomOGeonMWId01OoVi^H01?nMWIgoemOGomoOgooShn<<oiBDU0Co
UIFE0_nDU9@01?nEUIGoU9BDoiBDU?nDU9@7oiFEU@03oiBDU?nEUIGoUIFE
00CoUIFE00?oUYJFoiFEUOnEUID02?nEUID01?nFUYKoUIFEoiFEUOnEUID4
oiJFUP03oiFEUOnFUYKoUYJF00CoUIFE0_nFUYH7oiFEU@03oiBDU?nEUIGo
UIFE00goUIFE0onDU9@01?nEUIGoU9BDoiBDU?nDU9@2oiFEUAKoj^[Z00Oo
jNWYonSXj?oVi^Kohn?Son3Ph?oGemOoWIfM0?ooi^KVMooVi^H000Gok^k^
00CoXj>SomcLg?oRh^;o9I?>0_lXU]42obJDc`07obZHdolZV=Go9iGBobJD
dOlWUM;o:IODobZHe@03obZHe`03obVGe_lVUm?o:9WE00;o:I[F0_lXVMD0
1_lZVmOo;9gIobNHe?lYV]Ko:icHobbMf@;o:icH00So;9gIobfNf_lZVmGo
:Y_EobfKe_l^W=Oo;igJobjLf@;o;i_I01co;IWGobjLfOlaWmco;j3LobjO
fOl]W]So;9gGobjLeolcWM_o<9[HobnIeolaVmWo=9kLocFOgOlcWM_o<I_I
ocFMg?ldW=_o<iWIoc:Hf?ldUmSo=YWJocVKg?liW=go;YSDobbJeOl^VmKo
;icG0_l`W=X03ol^V]So;9SFobZFe?l[UmGo;9SFoc2Jf?l`VM[o<9OIobnF
f?l^UMOo;iSIobjGf?l]U]Oo;9GFobfFe`02obbEeP09ob^DeOl]U=Ko;iKH
oc2GfOl^UMOo:i;DobZAdol]U=Ko;iKH01Ooj^[Z00Goj>SXonKVi_oRh^;o
g=cLoj>SX`05onk^kP04oj>SXooLg=coh^;RonKViQ;oU9BD0_nEUID2oiBD
U0;oUIFE00?oU9BDoiFEUOnEUID03onEUID2oiJFUPCoUIFE00CoUYJFoiFE
UOnEUIGoUIFE0onFUYH00onEUIGoUYJFoiFEU@04oiFEU@;oUYJF2?nEUID2
oiBDU0GoUIFE00?oU9BDoiFEUOnEUID01onDU9@2oiFEU@CoU9BD00?oUIFE
on[Zj_oZj^X05_oZj^X01OoXj>Soi^KVon;Rh_oLg=coXj>S0?ook^k^Moo^
k^h000Gooooo00Co[jn_omcLg?oRh^;o9I;=0_lXUM001OlTTLco9I7?obVE
dolZU]Co9i?A00;o:IGC0_lYUMD01_lXU=Co9i?CobJBd_lUTM7o:YSEobVJ
eP;o:icH00Co:Y_GobVJe_l[W=So;9gI0olYV]H2obZKe`03ob^Lf?l/WMWo
;IkJ00;o;I_F0_l]V]D2obfIe`Co;I_J00So;I_HobbMfOl]W]So;9oHobZM
e_lZVmGo;i_IobjJf0;o;IWG00Co;i_Ioc2Lf_l`W=[o;i_I0_lcWM/02_lc
Vm[o<iWIocFHfOleV=Wo=iWJocJIf_l_VMOo;IWGobbHe_l]VML3objJf007
obfIeol/U]Co;IOEobjHe_l`V=Oo<9OIoc2Ff002obnEe`03obnFfOl]U]So
;ICG00;o;ICG00?o;9?Fob^BeOlZTM@00ol_U=P01Ol^TmOo;97Eob^@e?l[
T=Co;97E01Ooj^[Z00Goj>SXonKVi_oRh^;og=cLojn_[`05ooooo`05ojn_
[ooLg=coh^;RonKVi_nCTi<00_nDU9@2oi>CT`[oU9BD00?oTi>CoiBDU?nE
UID09_nEUID2oiJFUPkoUIFE00?oU9BDoiFEUOnEUID00onEUID2oiBDU003
oiFEUOnDU9CoU9BD00goU9BD6?oZj^X01OoXj>Soi^KVon;Rh_oLg=co[jn_
0?ooooooMoooool000Gok^k^00_oXj>SomcLg?oRh^;o9Ho;obRBc_lWTLgo
8hg9obB>c?lYTm7o:YCBobNAc`02obRBd00DobRAd_lYT]?o:Y?Dob^DeOl/
UMKo;IKGobVGe?lXVMGo;9[GobZKeolZV=Go9iSDobZHeOlYV]Ko;I_HobVJ
e_lYUmCo9YOCobVGe?lYV]H2obbJe`06obnLeol^VmKo;I[Eob^Hdol[UmGo
;9SF0_l/V]T01OlaWmko;I_JobNHe?lVUm?o:9[F00;o:ikG01Co:Y_EobbJ
eol/V]Oo;IWGobbJeol/V=Ko;9[GobjJf?l`W=[o;i_Ioc6KfOlbW=[o<i_J
oc>IfOldUmSo<YGFoc2Fe_ldW=_o;i_IobjHeP;o:iOE01Go;9SFobfIeol]
VMOo;YSFobnIeol`V=Oo<IOGoc6GfOlcU]Wo<YGHoc6Deol`Um[o;iKIobjE
f?l]U=Oo;YGHobfDeol/TmKo;97EobnDf?l^TmL01?l/TMD00ol[T=Co:XoC
on[ZjP0Fon[ZjP05onSXj?oVi^Koh^;RomcLg?nSXj<01Oo^k^h01_nSXj?o
g=cLon;Rh_oVi^KoTi>CoiBDU0?oTi>C3OnDU9@2oiFEU@?oU9BD0onEUID3
oiBDU0KoUIFE0_nDU9@3oiFEU@04oiJFU_nEUIGoU9BDoiBDU1OoUIFE0_nD
U9@:oiFEU@03oiBDU?nEUIGoUIFE00koU9BD6?oZj^X01OoXj>Soi^KVon;R
h_oLg=coXj>S0?ook^k^Moo^k^h000Goi^KV00goWIfMom_KfooRh^;o:i?@
obVAc_lWSlco:93=obZBcol[Tm3o:I7@obN?c_l[Tm;o:Y;A00;o:93?01Co
:I3BobZAdol[T]Co:Y?DobRDd_lZV=?o;9WDobZHdolZUm;o:iWDobjKe_l/
V]Go;icGobfKe_l]V]Go;9[EobjKe_l/V]Go;I[EobbIe0;o<9[F0_l_VML2
obfIf@0:obZHeolYUmKo;I_JobfKf_lZV]Wo:9WEobNHe?lXVMGo:Y_EobbM
e`;o:Y_G00Wo;I_Hob^Lf?l/V]Oo:I[FobZHeOlYUmCo;I_HobfIeol^V=H0
0_l_UmH04?laUmOo<YSHoc>IfOlaV=[o;iSIobnFf?l]U]Oo;YOHobnHfOl`
VM[o;iSIobnFf?l`UmWo<YSJoc6GfOlaU=D2oc6Ce004oc6Be_l]T]Ko;97E
ob^@e0?o:XoC00?o:HkBobZ=dOl^TMD01?l^TMD2obnBeP03objAeOoZj^[o
j^[Z01Goj^[Z00Goj>SXonKVi_oRh^;ofm_KoifMW@05onKViP04oifMWOoK
fm_oh^;RonKViP;oU9BD0_nCTi<3oiBDU003oi>CTonDU9CoU9BD00;oTi>C
1_nDU9@00onEUIGoU9BDoiBDU00AoiFEU@;oU9BD0onEUID3oiBDU0SoUIFE
0_nDU9@;oiFEU@03oiBDU?nEUIGoUIFE00KoUIFE2_nDU9@2oi>CT`SoU9BD
6?oZj^X01OoXj>Soi^KVon;Rh_oKfm_oWIfM0?ooi^KVMooVi^H000Gok^k^
00goXj>Som_KfooRh^;o:I7>obR@cOlWSlco:93=obZBcol[Tm3o:Y;AobVA
d?l/U=?o:i?B00;o:I7@01Wo:I3BobZAdol[T]Co:i?BobNAcOlWU<oo:YC@
obJCc_lXT/ko:9G@obbFd_lYU]7o;9KBobVFdOlZU=3o:IKAobjHe?l]V]Go
;YSDobbFd_l]UM;o;9CAobfEe?l]UmGo;iSI00;o;Y[J00Go;I_Job^If?l[
VMSo:IWHobRHe`02obNHe003ob^Ie?lZVmGo:Y_G00?o:Y_G0olYV]H01OlX
VMGo:IODobVGe?lZU]Co;IOE00;o;iOF00Oo<9KFobnEeOlbV=[o<IOIoc2F
f?l^UMOo;iKH00?o;YOH00co;9?EobfDe_l_UMOo<ICGoc6Ce?l`T]?o<I3B
obnAd_laU=Oo;Y?GobjAeOl/TMD3objAe@;o;I3D00Go;Y7Eobn@eOl^TMGo
;XoDobf>d`02obj?e1Koj^[Z00KojNWYonSXj?oVi^Koh^;Rom_KfonSXj<5
onk^kP05oj>SXooKfm_oh^;RonKVi_nDU9@00onCTi<<oiBDU003oi>CTonD
U9CoU9BD00WoU9BD0onEUID4oiBDU0SoUIFE0onDU9@9oiFEU@CoU9BD1?nE
UID01OnDU9CoUIFEoiFEUOnEUIGoU9BD00CoUIFE6?nDU9@Gon[ZjP06onWY
jOoXj>Soi^KVon;Rh_oKfm_oXj>Sooo^k^igonk^kP001Oooool01?n_[joo
fm_Kon7QhOlVSLP2obN>b@03obV@bolZTLco:i;=00;o;9;@01go;I?AobbB
d?l[TLoo:Y3>obZ@d?l[TM7o;9;Bob^Cd_lYTLko:YC@ob^Cd?lXT/ko:93=
obVCcol/U=7o:YC@obfEd_lZU=3o:Y;?obZDd?l^U]?o;iWEobnGe?l]UM;o
;YKEobfEe?l/U=?o;9KDobfFe`03obbHf0;o:IOF00Ko:YSGobVGe_lYUmCo
:IODobZFe?lZV=D2ob^If0Go:YSG00ko:iWHobRFeOlXU]Go:iOGobnHfOlb
VM_o<ISJobnFf?l]TmGo<iKJoc:EfOl`TmOo;Y?GobjDeP;o;ICF00Oo;9?E
ob^Be?l/TmGo;YCFoc6DeolaTmCo;i7B00;o<8oA00Co<97EobjAe?l^Sm?o
;I3C0ol^Sm<2obf>dP04obn@e?laT=Co;XoCobj=d@;o;Hc@00?o;XgAon[Z
j_oZj^X05?oZj^X01_oYjNWoj>SXonGUiOoQhN7ofm_Kojn_[`Gooooo00Co
[jn_om_KfooQhN7oiNGU1?nCTi<@oiBDU003oi>CTonDU9CoU9BD00KoU9BD
0_nEUID6oiBDU0?oUIFE2?nDU9@2oiFEU@GoU9BD00CoUIFEoiBDU?nDU9Co
U9BD1?nEUID00onDU9CoUIFEoiFEU@0JoiBDU0CoTi>C5ooZj^X01_oYjNWo
j>SXonGUiOoQhN7ofm_Kojn_[oooooooMoooool000Gok^k^00_oXj>SomWI
fOoPh>3o98_6obJ=b?lWS/Wo:8o:obV@bolZTLco:i7?obbBd004ob^Ac`;o
:i7A00So;9;BobfCdol/T]3o;IGBobbDdOlZT/oo:I7>ob^Cd0;o;9CA00?o
;YKCobfEd_l]UM800ol/U=42ob^Cd005obnEeOl^U=Co;I?CobbDdol/TmD0
0_l[U=D01olYUMGo:9CDobRFeOlYUmKo:iOGobZFe?l[UM<00_l/U]@2obbH
f003ob^GeolZU]Ko:YKF00;o:YKF01?o:iOGobZFe_lZU]Ko;9GFobjGf?la
V=[o<9OIobjDe_l/T]Co<I;Goc2Ae_l_T=Go;Y7EobjAe?l/T]Co:i7CobV@
d_l[T]Co;9?E00;o<ICG00Go<YCEoc2BdolaT=;o<I3Bobn>dP03obb=d@0<
obn>d_l]S];o;XgAobf<d?l^SM7o<8oCoc:?e?l_S];o;X_@obb;col^Rm3o
;XgA5_oZj^X01_oYjNWoinOWonGUiOoPh>3ofMWIoj>SX`Gok^k^00CoXj>S
omWIfOoPh>3oiNGU1OnCTi<[oiBDU0;oUIFE2OnDU9@3oiFEUA?oU9BD0onC
Ti<2oiBDU0?oTi>C0onDU9@4oi>CTaOoj^[Z00KojNWYonOWiooUiNGoh>3P
omWIfOnSXj?oonk^kWOok^k^0005onKViP06oifMWOoGemOogmoOobJ:aOlW
RlKo:8c70_lYSLP01OlZS/Wo:ho;obb@c?lYSLWo:ho;00;o;93<00Go;93>
obfAcol^T]3o;YCBobbBd002obfCd@04ob^AcolZT<ko;9;@obfCd@;o;9;@
0_l^U=801_l]Tm7o:Y3>obR>c?lYSlgo:Y3>obf@d@;o:i7A00[o:Y;AobbC
eOl/UMKo;9GGobZFeolWTmCo:IGFobZFe_l]U]Oo;9KD0_l/U=<01Ol]UMCo
<9KHobnEeol]U=Ko;9?E00?o:Y?D00Go:iCEobbEe_l[U=Go:i;DobbBe002
obfCe@0@obf@dol[S]7o<HoEoc6>e?l`S]Co;XoDobjAeOl/TMGo;9;Dob^A
dol[T]Co;9?Eoc2Ce_laU=Oo<I?Doc2Bd`;o<I3B00Oo;hkBobj=dOl^SM7o
;hkBoc6>dol_S];o;hcA00;o;X_@00Oo;hcAoc6<d_l_S=7o;XW?obf:col^
RLoo;hcA01Goj^[Z00OojNWYonSXj?oVi^Kohn?Son3Ph?oGemOoWIfM00Go
i^KV00CoWIfMomOGeooOgmoohn?S1onCTi<00onDU9CoTi>Coi>CT`0CoiBD
U0;oTi>C4OnDU9@00onEUIGoU9BDoiBDU00<oiBDU003oi>CTonDU9CoU9BD
00ooU9BD0_nCTi<3oiBDU0CoTi>C00?oU9BDoi>CTonCTi<00onCTi<Fon[Z
jP07onWYjOoXj>Soi^KVon?ShooPh>3oemOGoifMW@3oonKViWOoi^KV0005
onk^kP03ojBTY?oDe=Coh^;R00?o9X[500?o9h_6obR<aolXS<L00_lXS<P0
4_lWRlOo:Hg9obZ>b_l[Sl_o:Xk<ob^?cOl]TLoo;Y;@ob^Acol]Tm7o;YCB
obbBd?l[TLoo;9;@obfCdOl/T]3o:i7?obbBd0;o;I?A00So:i7?obZ@c_l[
TLoo;I?AobjAd_l]T=7o:i7AobbBdP;o;9?E00Oo:Y?EobVBe?lVT]?o:9CE
ob^DeOl]U=Ko;9CC00;o;I?C00Go;i;Coc6Be_laT]Ko;i;EobjAe004obbB
e003objDe_l]TmGo;9;D00;o;I3C00?o;8oBobf>d_l^Sm<00_lcS]D02_lb
SmGo<HoEoc2Ae_l_T]Ko;I?EobbBe?lYT=;o:i7CobbBe?l]T=<2obf?d003
obn>d?l`SM3o;X_@00;o;X_@0ol_S=400ol]R/oo:hS=obj9c`04obj9c`?o
;HS>5Oo/k>`01oo[jn_oj^[ZonWYjOoVi^Koh^;RomCDe?nTY:@01Oo^k^h0
1?nTY:Coe=CDon;Rh_oVi^H>oi>CTd;oU9BD4?nCTi<Fonc/k007on_[jooZ
j^[ojNWYonKVi_oRh^;oe=CDojBTY03oonk^kWOok^k^0005ooooo`07okBd
]?o?clool?3`obJ;`olUR/;o98W1obF:`P03obN;aP;o9HW400?o:8c7obZ>
b_lZS/X00_lXS<P02olZS/[o:ho;obZ>c?l]TLoo;i?AobjBd?l]TLoo;Y;@
obfAcol/T<ko;Y;@00;o;I7?00?o;Y;@obnCdOl`U=800_l_Tm42objAdP;o
;I?C00Ko;9?Eob^Be?lWT=;o9XoAobN@d_lXTM<2ob^Be006obbBd_l^TM;o
;Y7Boc2Bdol`Sm?o<HkC0_laT=@2obn@e0;o;Y7D013o;I3CobnBeOl`TmKo
<97Eobj?dol]S];o<8oCoc:AeOleSMGo=8cFoc:=e?lbSmGo;i3EobjAeOl[
T=Co:XoC0olZT=801_l[S]7o:Xc=obZ<cOl]S<ko;X_>obf:c@;o;X[=0_l_
Rlh01Ol^R/go;8S;obZ6bOl`RLgo;XO;00;o;HK:0_l^Ql/01?l/QLWo:hC8
ooGemOofm_H3ooGem@05ooKfm_oemOGomOGeooGemOofm_H00ooemOD01Oof
m_KomOGeooGemOoemOGom_Kf00ComOGe0_odm?@01?obl_;ol?3`olo?cond
];@5ooooo`05okBd]?o?clool?3`oo;bl_nCTi<00onBTY83oi>CT`;oTY:B
2?nCTi<EoiBDU0?oTi>C8_nDU9@<oi>CT`03oi:BT_nCTi?oTi>C00CoTi>C
0_nBTY801Oofm_KomOGeooGemOoemOGom_Kf00?omOGe00Gom_KfooGemOoe
mOGomOGeooKfmP03ooGem@05ooKfm_oemOGomOGeooGemOofm_H00_oemOD2
ooCdm004oo;bl_o`l?3oclo?okBd]?ooooooMoooool000Gok^k^01Go/[:b
olK6a_oclo?o9H[2ob>8`?lRQkoo8hS0obJ:aOlWRlKo9X[5obB8`olURLCo
:8c7obZ>b_lYSLWo9h_7obJ:a_lWRlOo:Hg9obF9aolXS<X00_lZS/`3obV=
b`0=obN;bOl^T]3o:ho=obR<b_lZS/co;Y;@oc2Dd_l]TLoo:Hg;obV<cOlZ
SLko:Y3@obfCd`02objEe`04ob^De_lYT]Co9XoAobN@dP;o:I3B0_l/Sm00
1_l^T=7o<I3Bobn<dOlaS=;o<HkCoc:?e0;o<Y7E0_l_T=@02?lYR/ko;8gA
obn@e?l_T=Co;XgAobf<d?l_S];o<XoD0_lcRmD02_lcRm?o<8gCobn=dol/
Sm?o:XgAobJ;col[TM?o:Y3BobV?dOlXS]02obV;c003obb;cOl]S<ko<Hg@
00;o<8c?0_laSM001ol`S<oo;X[=obb8bol`RLgo;HK:obZ3aol[Q<P00_l]
Q/X00olZPlOo9h34ooOgm`02ooShn0;omoOg00Con?ShooOgmoohn?SomoOg
0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh1?ogmoL01Oofm_Ko
mOGeoo?cloo6a/Ko/[:b00Gok^k^00Co/[:bolK6a_oclo?omOGe1?nBTY83
oi>CT`;oTY:B1onCTi<00onBTY;oTi>Coi>CT`05oi>CT`04oiBDU?nCTi?o
Ti>Coi>CT`?oU9BD0onCTi<6oiBDU0;oTi>C1_nDU9@00onCTi?oU9BDoiBD
U005oiBDU0;oTi>C0_nDU9@2oi>CT`SoU9BD0_nCTi<2oiBDU0KoTi>C00?o
U9BDoi>CTonCTi<00_nDU9@5oi>CT`;oTY:B0_nCTi<2oi:BTP;on?Sh0_og
moL01?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg00Con?ShooOgmoohn?So
moOg0_ohn?P2ooOgm`09ooShn?ogmoOomoOgooOgmoofm_KomOGeoo?cloo6
a/Ko/[:b0?ook^k^Moo^k^h000Goi^KV00Go_Kfmojf][OoZj^[om?CdooGe
m@03ooKfmP03ooOgmoofm_Kom_Kf00ComoOg00Com_KfooOgmoofm_Kom_Kf
1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKf
mPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_of
m_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoofm_Ko
m_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_Kf
ooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKf
m_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoof
m_Kom_Kf1?ogmoL2ooKfmP;omOGe00Com?Cdon[Zj_n][Jgo_Kfm1OoVi^H0
1Onm_Kgo[Jf]on[Zj_odm?ComOGe00?om_Kf00?omoOgooKfm_ofm_H01?og
moL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPCo
moOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4
ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf
1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKf
mPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_of
m_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoofm_Ko
m_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_Kf
ooKfmP;omOGe00Com?Cdon[Zj_n][Jgo_KfmoooVi^IgonKViP001Oo^k^h0
1?oGemOoZ:RXom7AdOoXj>P2oo;blP;olo?c1oodm?@00ooclo?om?CdooCd
m005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@01Ood
m?@00ooclo?om?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?o
lo?cooCdm?odm?@01Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?clood
m?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?CdooCd
m005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@01Ood
m?@00ooclo?om?CdooCdm005ooCdm0?olo?c00GolO7aonSXj?o@d=3oZ:RX
omOGe`05onk^kP04omOGeonXZ:SodM7AonSXj0;ol_;b0_oclo<7ooCdm003
oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@01Oodm?@00ooclo?o
m?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?od
m?@01Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Go
m?Cd00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?CdooCdm005ooCdm003
oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@01Oodm?@00ooclo?o
m?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?od
m?@00_oclo<01OoalO7oj>SXom3@d?nXZ:SoemOG0?ook^k^Moo^k^h000Go
oooo00OomoOgom_Kfonc/k?oZJVYok6a/Ong]kOo^k^k00;o_[jn1_no_kl2
okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6
okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2
okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno00So_[jn
ok^k^ong]kOo/K6aojVYZOnc/k?ofm_KooOgm`Gooooo00OomoOgom_Kfonc
/k?oZJVYok6a/Ong]kOo^k^k00;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6
okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2
okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6
okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h02?no_koo^k^kokNg]ona
/K7oZJVYok>c/ooKfm_omoOgoooooomgooooo`00ooo^k^koonk^kX;ok^k^
003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooo
oh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV003oogmoOeOoOgmo1omnOWkoogmoObCoOgmo
00001?o3b<ko_/C:okc1b?ni_/@2okNm`P0AokNm`Onh_L;o^Kk4okVo`onh
_lCo][g3okNm`onf^l7o];Zook:g_?oCeMKocm3Aolc=c_oNg]oogn3PomkO
gooOgml00_oNgml0<ooLgMgog]oOom[Jg?oCdm?ofMWIom_KfooKfmcogMgM
om_Lg?oMgMgofm_Mom_KfooGf=Sof=SIomSHf?oAd];of][KomkOgooNg]oo
gmoPomoOgooNg]oogMgMomoOgooKfm_odm?ComWIf_oLg=cofm_KomgMgOoL
g=gog=gMom_Kg?oKfm_oemOHomSIfOoHf=Sod];Bom_KfooNgmoog]kNomoP
h?oNg^3ogmoPomgMgOoNg]kofmcLom;CdooIfMWog=cLom_Kg002omgMg@08
omgMg_oMgMgogMgMomWJf_oKfm_ofMWJom?CdooKfm`2omoOg`05omoPh?oO
gmooh>3PomkNh?oOh>000ooOgn003_oPh>3og]kOon3Ph?oNgn3oh>3PomoO
gooPh>3ogmoOomoPh?oOgmooh>3PomkNh?oOh>3ogmoO0_oOgn003_oPh>3o
g]kOon3Ph?oNgn3oh>3PomoOgooOh>3ogmoOomoPh?oOgmooh>3PomkNh?oO
h>3ogmoO0_oOgn003_oPh>3og]kOon3Ph?oNgn3oh>3PomoOgooOh>3ogmoO
omoPh?oOgmooh>3PomkNh?oOh>3ogmoO0_oOgn003_oPh>3og]kOon3Ph?oN
gn3oh>3PomoOgooOh>3ogmoOomoPh?oOgmooh>3PomkNh?oOh>3ogmoO0_oO
gn003_oPh>3og]kOon3Ph?oNgn3oh>3PomoOgooOh>3ogmoOomoPh?oOgmoo
h>3PomkNh?oOh>3ogmoO0_oOgn007OoPh>3og]kOon3Ph?oNgn3oh>3PomoO
gooOh>3ogmoOomoPh?oOgmooh>3PomkNh?oOh>3ogmoOomkNgooQhN7oh>7Q
on7QhOoRhn?ohN7Son;ShooPhN;oh>;SomoPh_oOhN;og^3QomoQh_oNgn;o
g^3R00?ogmoO01oogmoPomOGe_oOgmoogMoPon;Ti?oKg=cogMgMomcKg?oL
g=gog]kNomoPh?oOgn7og=cLom;FfooFfn;oem_Nom_KfooHf=Sog]oOomcM
g_o0`<3oaLG5omcLgOoFe]Ko^k^kol?3`ooMgMgobLW:olC4a?oGf=SogMkN
00;o`L7100Kocm3@omWIf_oHfM[og=gMom7AdOnj^[X2omKFeP16omWJf_o@
dM7o_;bnomSHfOoKg=cog]kOokZj^_o?d=3ogMgMomCEeOng]kSo`l?3omCD
e?oFe]KogMgMokno_oo8b<Sof][Kol[:c?o6a/Kog=gMomOGeoo4a<Coc<c=
omSHf?oGemOog=cMomoOh?oMgMgof=SHomcLgOoMg]kog=cMomSHf?oMgMoo
gmoOomWIfOoHf=SogMgMomgNg_oLg=coemOGom_Kg?oOgn3of=SHomWJf_oN
g]kog]kOomgNg_oHf=Sof][KomoOgooHfMWofM[JomkNgooOgn3ogMgNomSH
f?oJf]cogmoOom_KfooHf=SofmcLomSHf?oMgMgogmoPomgNgooMgMgoemOG
omkNgP;og]kO03coe]KFomcMgOoNg]oogn3PomkNgooOgmoog]kOomSHfOoI
f][ogmoPomgMgooMg]kof=WIomOGeooKfmcogn3PomgNg_oOgmoog]kOom[J
f_oEeMGofm_Lom_Lg?oJf][ofMWJom[JfooGemSoemOGomgMgOoNgmoogmoO
on3Ph?oNg]kogn3PomkNh?oPh>3og]oOomoOh?oOgmoogmoPomkOgooPh>3o
g]kOomoOh?oOgmoog]kNom_Lg?oHfMWod];BomoOgooMgMkogMgMom[KfooK
fm_of][Kom_KfooJf][ofm_KomWJfooKfm/2om[JfP0?omWIfOoJf][of=SH
om[Jf_oIfM[of]_Kom[Jf_oKfm_of][Jom_KfooJf][ofm_Lom[JfooKfm_o
f][K00?ofm_K00CofM[Jom_KfooJf]_of]_K1OoIfMT01?oJfm_ofMWJom_K
fooJf]X2om_Kf`0<om_Kg?oJf][ofm_Kom[JfooKfmcof][Jom_KfooJf][o
fm_Kom[Jf_oJfm_of=SI1?oIfMT01_oKfm_ofMWIom_KfooJf]_ofMWIomOG
e`;ofMWI00Kof][JomWIfOoJf][ofMWJom[Jf_oIfMT3om[JfP07omWIfOoJ
f][ofMWJom[Jf_oIfMWof][JomWIf@02omSHf004om_KfooJf]_ofm_Kom[K
f`;ofm_K00kofmcLomGEe_oGf=SoemOIomWIf_oHf=SofMWIomSHfOoIfMWo
f=SHomWIf_oGf=WofMWIomSHf@;of=WI00gofMWJomOHf?oIfMWof=SIomWI
f_oHf=SofMWIomSHfOoIfMWof=SHomWIf_oGf=WofMWI00;of=SI00koe]OG
omOHf?oGemSofMWIomSHfOoJf][of=WIomWIf_oIfMWofMWJomWIfOoJf][o
f=SIomWIfP?ofMWI00cofM[JomSHf?oIfMWoe]KHomOGf?oGf=SofMWIomSH
fOoIfMWof=SIom[Jf_oHf=X2om7Bd`0`om;Ce?oAdmCod]CEom7BdooBdmGo
dM;Eom?DeOoBdmCod]?Eom7Ce?oBdmGod]?Dom?DeOoAd]Cod]CEom;Ce?oB
dmGod]?Dom?DeOoAd]?od]CEom7CeOoCe=GodM?Dom;CeOoBdmCod]?Eom7C
e?oCe=GodM;Dom;DeOoBdmCodm?Eom;Ce?oCe=God];Dom?DeOoBdmGodmCE
om;Ce?oBdmGod]?Dom?DeOoBdmCodmCEom7BeOoCe=God]?D0_oCe=D03_oD
eMKod]?Dom?DeOoBdmGodmCEom;Ce?oCe=God]?Dom?DeOoBdmCodmCEom7B
e?oCe=God]?D0_oCe=D03?oCe=Kod]?Dom?DeOoBdmGodmCEom;Ce?oCe=Go
d]?Dom?DeOoBdmCoe=GFom;Ce@CodmCE00Koe=GFom;Ce?oCe=God]?EomCE
e_oBe=D3om?De@03om;CeOoDeMKod]?E00CodmCE00Coe=GFom;Ce?oDeMKo
dmCF0_oDeMH2om?De@;oe=GF00GodmCEom;CeOoDeMKof=WJomcMgP01omoP
h@0000Oo`lW?okk4b_ni`<Ko]Kc2okBj`?nc^[oo];_000;o];Zo00co];Vo
okBj_onb^;go/KNlok2e^_n]/[OoZk2dolc=coo:blcob<W:om[KfooKfm`4
om[JfP0JomOGeooIfMWof=SHol_<c?oCe=Coe=CEomGEeOoFe]KoeMGEomCD
e?oBd]?ocm3@olg=c_o>c/ooc/k>olW:b_oEeMKofMWJom[JfooIf][of][K
omWJf_oGemSofMWJomOGf?o<c<`2omCDe00=omGEeOoFe]KoeMGEomCDe?oB
d];od=3@olk?coo>c/koclo?olW9bOoEe]KofM[Jom[JfP02om[Jf`0:omWJ
f_oGemOofMWIomOHf?o<cLgodm?ComGEeOoGemOoe]OGomSHf0?oemOG00Wo
e=CEomGEeOoDe=Coc<c<omOHf?oJf]_of]_Kom_KfooJf]/00_oKfm/01_oJ
f]_ofm_Kom[KfooJf]_ofm_Kom[Kf`;ofm_K00Kof][Kom[Jf_oKfm_of]_K
om_KfooJf]/2om_Kf`06om[JfooKfm_of]_Kom[JfooKfm_of]_K0_oKfm/0
1_oJf]_of][Jom_KfooJfm_ofm_Kom[Jf`;ofm_K00Kof][Kom_KfooJfm_o
f][Kom_KfooJfm/2om_Kf`06om[JfooJf][ofm_Kom[KfooKfm_of][K0_oK
fm/01OoJf]_ofm_Kom[KfooJf]_ofm_K00?of]_K00Kof][Kom[Jf_oKfm_o
f]_Kom_KfooJf]/2om_Kf`06om[JfooKfm_of][Kom[JfooKfm_of]_K0_oK
fm/03_oJf]_of][Jom_KfooJfm_ofm_Kom[JfooJfm_ofm_Kom[JfooKfm_o
f]_Kom[JfooKfm_of]_K0_oKfm/01_oJf]_of][Jom[KfooJf]_ofm_Kom[J
f`;ofm_K00Gof][Kom[KfooIfMWog=cLom_Kf`03omcMg@03omcLgOoKg=co
fmcM00;of]_M02cofM[LomWKg?oJfmgof=[Lom[KfooJf]_of][Jom[JfooC
dm?ogMgMomSIfOoNgn3ogMoOomkOgooMg]kog=cLom[Jf_oIfMSofm[JomSH
eooAe=WodmSNom?GfooFe]Kod]?ComGEe_oHfMWo^[Zjol30`?oBd];oe]KF
ol;2`_nf]kOofMWIolS8b?o1`L7od];BomGEeOoDeMGo`<31okFe]Ong]kSo
_[jnomOGe`;o]kNg01Oo^KViokZj^_oCdm?oc/k>okfm_OoBd];ofM[Jom[J
f_nj^[[oc<c<omSIfOo=cLgo^KViom3@dOnj^k_o`<71omWJf_oDe=Go^k^k
okJf]_nl_;cod];ComGEe@02om?Cd`0dol30`?nf][Oo]kNgomCDe?oIfM[o
fM[JomCDe?oFe]Kof][KomKFeooDe=Cof]_KomSIfOoDeMGod=3@om7AdOoD
eMGodm?Dolo?d?oGf=SofMWJomKFe_oAdM7oemOGomWIf_oDe=GodM7AomWI
fOoIfM[oemOGom;Bd_oGemOofM[JomKFe_oBd];ofMWIomSHf?oEeMKod]?C
omSHf?oEeMKod];ComSHf?oHfMWoemOHom7AdOoHf=SofMWIomWIf_oAdM;o
e]OGomWJfP;ofMWI00_ofMWJomSIfOoBd];oeMGEomWJf_oGf=Sod];Bom?D
e?oHf=SofMWJom[JfP02omWJfP0?omWIfOoBd];od=3@omCDe?oCe=Codm?C
om3AdOoAdM7oc/k?olo?cooGf=Sof=WIomWJf_oJfm_of][K00;of]_K01So
f][JomWJf_oJfm_of][Kom[KfooJf][of]_Kom_KfooJf][of][KomWIfOoF
emOodmCDolk?cooLg=cofm_KomWIfOoHf=SofMWIomSHf?oIfMWof=SHomWI
fOoHf=T2omSHf005omKFe_oEeMGoeMGEomCDe?oDe=D00_oFe]H01OoGemOo
f=SHomSHf?oIfMWof=SH00;ofMWI00Gof=SHomWIfOoIfMWof=SHomWIf@03
omSHf004omKFe_oEeMGoe=CEomCDe0;oeMGE00Koe]KFomOHf?oGf=Sof=SH
omSIfOoHf=P4omWIf@;of=SH00CofMWIomSHf?oHf=SoemOG0_oFe]H3omCD
e003omGEeOoFe]KoemOG00;of=SH00SoemOGomGEeOoGemOof=SHomWIfOoH
f=Sof=SIomWIf@Cof=SH00[ofMWIomSHf?oHf=SofMWIomSHf?oGf=Sof=SH
omOGeooFe]KoemOG0_oIfMT01ooHf=WofMWIomWIfOoIfMWof][JomGEe_oF
e]L00ooGemP01?oHf=SoemSHomSHf?oGemP2omSHf006omOGf?oHf=SoemSH
omOGf?oHf=SoemSH0_oHf=P01_oGemSoemOGomSHf?oGf=Sof=SHomOGf0;o
f=SH00SoemOHomSHf?oGemSoeMKFomKFe_oGemOoemOHomOHf0;oemOG00So
emSHomOGeooHf=SoemOGomOGf?oHf=SoemOGomSHf0;oemOG00KoemSHomOG
eooGemOoe]KFomGFe_oFemL2omOHf005omSHf?oGemSof=SHomSHfOo?d=40
0oo@dM802_o@d]?od=7Com3BdooAd]?od=7Com3Ad_o@d]?od=7Com7Bdoo@
dM82om7Bd`0:om3Ad_oAd]?odM;Com3AdooAd]?od=7Com3BdooAd]?od=7C
om3AdP;od=;C00KodM;Com3Adoo@d]?odM;Com3AdooAd]<2om3Bd`06om7B
e?oAd]?odM;Com7Be?oAdM?od=7B0ooAd]<01Oo@dM?odM;Com7Bdoo@dM?o
d];C00;odM;C00KodM;Dom7BdooAd]?od];Dom3Bdoo@dM<2om7Bd`03om;C
e?o@d]?odM;C00GodM;C00?odM?Dom7BdooAd]<00_oAd]<02Oo@dM?odM;C
om7BdooBdmCodM;Com;BdooBdmCodM;Com;Ce002om7Bd`04om;Ce?oAd]?o
dM;Com;Ce0;odM;C00Sod]?Dom7BdooBdmCodM;Com7Ce?oBdmCodM;Com;C
e0;odM;C1?oBdm@00ooAdM;odM;Com;Ce002om;Ce006om;BdooBdmCod]?D
om?DeOoHfM[ogMkO0OoQh^<00003olC:d?o0a/_o_<;700;o^l3501Wo^[o4
ok_1a_nj`<Go^/35okNm`onh_L?o]K_0ok2e^_n]/[OoZ:jbojFZ[_o7b<Wo
b<W:olG6aooKg=cog]kNomkOgooNg]kogMkNomkNgooKfmcog=gMomcLg?oA
dM;oe=GE00?of=SH02;oe=GEom3@d?o=cLgobLW9olG6a_o6alOoalO8olO8
b?oFemOof]_KomcMgOoNg]kogMkNomkNgooKfmcogMgMomcLg?oAdM7oe=GE
omSHf?oIfMWof=SHomCDeOoAdM7ocLg=olS9bOo5aLKoalO7olO8b?o8b<So
e]OGom_Kg?oLgMgogMkN0_oNg]h01ooLg=cogMgMomcLg?oBd];oeMGEomSH
fOoJf]X00_oKfm/00ooKg=cofm_Kom_Kf`02omSHf003omGEeOoBd]?og]kN
00;og]kO00?ogmoPomoOgooNg]l00_oOgml03_oNgmoogmoOomkOgooOgmoo
g]oOomkNgooNgmoogmoOomoOh?oNgmoog]kOomoOh?oOgmoog]kO0_oOgml0
1_oNgmoogmoOomkOgooOgmoog]oOomkNg`;og]oO00KogmoPomkOgooNg]oo
gmoPomoOgooNg]l2omoOg`03omkOgooOgmoog]oO00;og]oO0_oNg]l01ooN
gmoogmoPomkOgooNg]oogmoPomoOgooNg]l00_oOgml03_oNg]oogmoOomkO
gooOgmoog]oOomkNgooNgmoogmoOomoOh?oNgmoog]kOomoOh?oOgmoog]kO
0_oOgml02ooNgmoogmoOomkOgooOgmoog]oOomkNgooNgmoogmoOomoOh?oN
gmoog]kO00;ogmoO017og]kOomkOgooOgmoog]oOomoOgooNg]oogmoOomkO
gooNg]kog]kOomoOgooOgn3og]oOomkNgooOgn3og]oOomkNg`02omkOg`04
omkNgooNg]kohN7QomkOg`?ohN7Q0_oQh^82omoPh@03omoPh_oNh>7og]oP
00;og]oQ02gog]kOomoOgooNg]oog]kOomSHf?oUiNGog]kNomkNgooOh>3o
gn3QomoQh_oPi>Coh>?VomoRiOoPh^Cogn3QomWLh?oIg^CofMgQom[KfooI
fM[of][KomKGeono_koob/[:om[Jf_oFe]Ko`L71ol?3`ooMgMkog]kNom_K
fooHf=Sog=cLomOGf?oGemOof][JomgMg_oNg]kog=cLomCDe?nl_;cof=WI
omkOgooJf]X00_oGemL03ooKfm_og]kOomkOgooLg=cof=SHomWIfOoGemOo
g]kNomkNgooMgMgoemOGomkNg_oOgmoog]kNomWIf@02omOGe`0NomWIfOoM
g]kog]kOom_Kg?oFe]Koe]KGomOGeooKfmcogmoOomgMg_oHf=SoemSHomSH
f?oLg=cog]oOomgMg_oHfMWoeMGEomCDe?o?d=3oclo?omCDe?oKfm_og=cM
omcMgOoGf=Soe=CDomCDeOoEeMGof][J0_oLg=d03_oLg=cofMWIomGFe_oE
e]Koe]KFom[Jf_oLg=gofm_KomSHfOoDeMGof][KomgMgOoHf=Soe]KF0_oK
fm`0;_oEeMGof][JomcLg?oLg=goeMGEomOHf?oKfmcofmcLomcLgOoKfmco
fMWJomGEeOoJf][og=cLomKFe_oGemOofmcLomcLgOoLg=cog=gMomcLg?oK
g=coemOGomKFe_oJfm_oe=CDomKFeooEeMKoeMGEom;Cdoo>c/kod];Com_K
fooMgMgogMkNomkOgooNg]oog]kNomkNgooNgmoogmoOomkNgooNg]kogmoO
omkOgooNg]h2omkOg`05omkNgooMg]kofm_KomSHf?oCdm<00_oQhN401?oQ
h^;oh^;Ron7QhOoPh>42on7Qh@;oh>3P00GogmoOomgMgOoKfm_of=SHomOG
e`02omKFe`05omSHf?oJf][og]kMomkOgooPh>000_oQhN400ooPh>3ohN7Q
on7Qh@03on7Qh@0>on3QhOoPh>3og]kNomgMgOoJf][ofMWIomOGeooFe]Ko
emOHomSIfOoJf][ogMgMomoOgooPh>04on7Qh@04on3PhOoQhN7ohN7Qon7R
h@;oh>3P00_ogmoOomgMgOoJf][of=WIomOGeooFe]KoemOGomSHf?oKfm_o
gMgMomkNgP02on3Ph0;og]kN00Soh>3Pon;Rh_oRh^;ohN7Qon;Rh_oQhN;o
hN7Qon;RhP?ohN7R00GohN7Qon7Qh_oQhN7oh^;Ron3Ph002omkNgP03on3P
hOoPh>3ohN7Q00;ohN7Q00SohN;Ron;Rh_oRh^;ogMkNomkNg_oOgn3ogn3P
on3Ph@;ogmoP00Coh>3Qon3Ph?oOgn3oh>3P0_oOh>001OoPh>3ogn3PomoP
h?oOh>3ogmoP00;ogn3P00Ooh>7QomoOh?oOh>3oh>3Qon3Ph?oOgn3oh>3P
00?ogn3P00Cog]oOomgMgOoOgmoogmoO0_oPh>001ooQhN7oh>3Pon3Ph?oP
hN7oh>3QomoPh?oPh>400_oPh>002_oPh>7oh>3Pon3Ph?oOh>3og]kNomgM
gOoNgmooh>3PomoOh?oOh>02on3Ph@04omoPh?oPhN7of=WJomSIfP;ofM[K
00?ofM[LomWJfooHfM/00_oIf]/01ooJfmcofM[KomWJfooJfmcof][LomWJ
fooIf]`00_oIf]/01OoJfmcofM[LomWJg?oIf]cofM[K00;ofM[L00kof]_L
omWJfooIf]_of]_LomWKg?oIf]_of]_LomWJg?oIf]_ofM_LomWKfooJfmco
fM[LomWJf`;ofM_L00?of]_LomWJg?oIf]`00_oJfm`01?oIf]_of]_LomWJ
g?oJf]`4om[Kg004omWJfooJfmcofM_Lom[Kg@;ofM[L0_oJfm`01?oIf]_o
f]_LomWKg?oIfm`3om[Kg005omWKg?oIf]_ofM_Lom[Kg?oKg=d00_oJfm`0
0ooJfmgof]_Lom[Kg007om[Kg004omWJfooJfmcof]_Lom_Lg@;of]_L00?o
f]_Mom[Kg?oJfm`00ooKfm`01OoKg=gof]_Mom_KgOoKfmcof]_L00;ofm_L
0_oKg=d02?oJfmcog=gNom_LgOoJfmcofmcMomcMg_oNgn3oh^?T0OoUi^L0
000VolO<dOo5c=7oa/cBolK<dOo5b]3oa<W?olG:coo3b/oo`lW?ol76c?nm
a<Wo]kc1ojnc^?nWZk3oX:BXoijRY_nl_[oo`<72ol72`ooNg]gohnCTonOX
j?oYjN[ojn_/on[ZjooXj>WojNWYon[ZjOoShn?ogMgMon7QhOoShn?oh>3Q
om[Jf_o>c/koalO6okno_onk^k/2ok^l_00DolW9bOoJf]_ohN;RonOWiooY
jN[ojn_/onWZj_oXjNWojNWZon[ZjooRh^?ogMgLon7QhOoShn?oh>3Pom[J
f_o>clooa/K6ol30`?nl_;/2okbl_01ZolS9bOoJfm_oh^;SonSXj?oYjN[o
k>c[on[ZjooXjNWojNWYon[ZjooShn?ogMgMon?ShooWinKojNWZon_[jooY
jNWoj^[ZonSXjOoVi^Kohn?SomgNgOoShnCojn_[on_[k?o/k>cojn_/on_/
k?o[jncok>c[on_[k?o/k>goj^[[onc/k?o[k>cok>c]on_[joo/kNcojn_[
on_/k?o[jncok>c/on_[k?o[k>cojn_/onc/joo[k>cok>c]on[[joo/k>co
jnc/onc/kOo[jn_ok>g/on_[joo[k>cojn_/onc/k?o[jncojnc/on_[k?o/
k>_ojnc/onc/kOoZjn_ok>c/on_/k?o/k>gojn_[onc]k?o[jn_ojnc/on_[
k?o/k>cojn_/on_/k?o[jncok>c[on_[k?o/k>goj^_[onc/k?o[k>cok>c]
on_[joo/kNcojn_[on_/k?o[jncok>c/on_[k?o[k>cojn_/onc/joo[k>co
k>c]on[[joo/k>cojnc/onc/kOo[jn_ok>g/on_[joo[k>cojn_/onc/k0?o
jn_/01gok>c[on_/k?o/k>goj^[[onc/k?o[jncok>c]on_[joo/kNcojn_[
on_/k?o[jncok>c/on_[k?o[k>cojn_/on_/joo[jncok>c/on[Zj_o_knoo
kNg]onc/k?o/k>gokno^onk^k_o^knookNk^ong^k`02onc]kP0:on_/k_o/
kNgojnc^onc/kOoZj^_ok>c/on_[k?oVi^OokNg]oo7al0;ok>c/057oj^[Z
onc/k?o[k>cojN[[onKYjooUjN_oi>S]onKZkooTjNkoi^__on_[joo/k>co
j^_[onc/joo>clooc/k>om?De?o=cLkoalO8on3Ph?o[jn_of][IomKFeoo/
k>coj^[Zonc/k?o[jncok>c/on_[joo/k>cojNWYon?ShooShnCoj^[[on_[
joo[jncojn_[on_/joo[jncok>c/on[ZjooYjN[ohnCTonCTi?oXjNWok>c/
on[[jooYjN[oi>CTon_/k?o[jn_ojn_/on_[joo[k>_ojn_/onc/k?oZj^_o
k>c/on_[k?oWinSoi^KVonc/k?oZjn_ojn_/on_[joo/k>cojn_[on_[k?o[
jn_ojnc[on[Zj_oVi^OohN7QonGUi_oQh^;ohN7Ron;Rh_oWinKoi^KVonGU
iOoShn@00_oTi>D00ooUiNKoi^KVonSXi`02onOXj009onCTi?oVinOoj>SX
onWZj_oWinSoi^KUon?Si?oPh>7og]kN00;oiNGU01Goi^KWonGUiOoTi>Co
i>CTon?ShooPh>3oj>SXonSYjOoTi>CogMgMonGViOoVinOoinOWonGUi_oP
hN7oh>3PonSYjOoWj>Soh>7PonCTi?oXj>T00ooVinL03_oXjNWoiNGVon3P
gooShnCoinSXon?Si?nl_;goWinPohZ:RonGUiOo_knnomoOh?oVi^Koj>SY
0_o[jn`04oo/k>coj^_[onc/k?oZjn_ojn_/on_[joo[k>cojn_[on_[k?o[
jn_ojnc[on_[k?o/k>cojNWYonSXjOoTi>Goh>3Qong]kOo^k^d00_o[jn/0
2?oZjn_ojn_[on[Zjoo[jn_oj^[ZonWYj?oVi^Kohn?T0_oOgml05_oMgMgo
gMgNomcMgOoOgmkogmoOon?ShooVi^KojNWYon[Zj_o[jn_oj^[Zon_[j_oZ
jn_ok>c[onWYj_o[jn_oj^[ZonWZj_oUiNGoi>CSomoOgooOgmh3omgMg@;o
gmoO017ohn?RonKVi_oYj^WojNWYon_[jooZj^_ok>c/on[Zj_o/k>_oj^[Z
on_[jooYj^[ojNWYonKVi_oShn?ogmoOomoOgP02omgMg@06omcLg?oOgmoo
h>3Pon?Si?oUiNGoj^[Y0_oYjNT00ooVi^KojNWYon[ZjP02on_[j`09onc/
joo[jn_ok>c/on[Zj_o/k>cojn_[onc/k?o[jn_ok>c[00;oj^[Z01Goj>SX
onOWj?oYjNWoj^_[on[Zj_o[jn[ojn_[onc/jooZj^[ok>c/on_[jooWj>So
inOXonWZjOoXj>WojNWYonSYjOoYj^[oj>WYonWYjOoXjNT00_oYjNT06?oZ
j^[oinSXonWZj_oXjNWoj^[ZonSXjOoZj^Woj>SYonWYjOoXjNWojN[ZonSY
jOoYjNWoj>WYonWYjOoXjNWoj^[ZonOXj?oYjNWoi^KVonSXj?oXjNWojn_Z
onWZjP;oj^[Z00Wojn_[on[Zj_oZj^_oj^[Zon[[j_oZj^[ojn_[onWYjOo[
jn/00_oZj^X01ooVi^KoinOVonOXj?oYjNWoj>WYonWZj_oXjNT00_oYjNX0
:_oZj^[ohN;Ton?TiOoQh^?ohnCUon;SiOoSi>Koh^?TonCUiOoRhnCohnCU
on;SiOoSi>Koh^?Uon?Ti_oRi>GohnCUon;TiOoTiNKoh^?Ton?Ti_oSi>Go
hnGVon;Si?oTiNGoh^?Ton?TiOoRhnGohnCVon;TiOoSi>KohnCUon?Ti?oS
i>Goi>GVon;Si?oSiNKohnCUonCUi_oRhnCoi>GUon?Si@;ohnCU00?oi>GV
on?TiOoSi>H00ooSi>D06?oTiNKoh^?TonCUi_oSi>Goi>GVon?TiOoTiNKo
h^?Uon?TiOoShnGoi>GVon?TiOoTiNKohnCUon?UiOoSi>Goi>GVon;Si?oT
iNKohnCUonCUi_oSi>Goi>GUon;Si0;ohnCU00Goi>GVon?TiOoTiNKohnCU
onCUi@02onCUiP0=on;Si?oTiNKoi>CUonGUi_oSi>GoiNKVon?TiOoTiNGo
hnCUonCUi_oSi>Goi>GVon?Ti@02onCUi@07onGVi_oSi>Goi>GVon?Ui_oU
i^OohnCUonGViP02on?Ti@;oi>GV00CohnGVon?Ti_oTiNKoi>CU0_oUi^L1
onCUiP7oiNKW00001?o7cM;oa<[@oko4bonm`lT2okc2b00Xokc2aonk`/Oo
^/36okFk`?n//[OoX:JZoiFJW_n@UIWoRi2DohV=TOnUYjSoZ:Z[ojRYZ_o3
a<CodM;BomcMgOoQh^;oiNGUonCUiOoTi>CohN7QonCThooShn?of][JomCD
e?oGf=Soclo?olC4a?ng]kOo/K6aojZZZ_nUYZKoXZ:SojRYZOng]kSo`lC4
om7AdOoMgMcohN7RonGUi@;oi>CT01OohN7Ron?Ti?oShn?of][IomCDeOoG
emOod=3@ol?4a?nh^;So/K6aojZZZ_nVYZGoXZ:RojVYZOng]kOoa<C4om7A
d_oMgMgohN;RonGViOoUiNGohnCTon;RhP02onCTi00>om[Jf_oGemOoh>3O
on;ShooVi^Koi>CTonGUiOoPhN7og]kOomKGeooJfm[oi>GUonGVi_oUiND2
onGViP1[onKVi_oUiNGoi^KUonGUiOoVi^KoiNGUonKViooUiNGoi^KVonGU
iOoVi^KoiNKVonKVi_oUiNGoi^KVonGVi_oVi^KoiNGUonKViOoUiNGoi^KW
onGUiOoVi^OoiNGUonKVi_oUiNGoi^KVonGVi_oVi^KoiNGUonKVi_oUi^Ko
i^KVonGUiOoVi^GoiNGUonKVi_oUiNGoi^KWonGUiOoVi^KoiNGUonKVi_oU
i^Koi^KVonGUiOoVi^KoiNKVonKVi_oUiNGoi^KUonGUiOoVi^KoiNGUonKV
iooUiNGoi^KVonGUiOoVi^KoiNKVonKVi_oUiNGoi^KVonGVi_oVi^KoiNGU
onKViOoUiNGoi^KVonGUiOoVi^OoiNGUonKVi_oUiNGoi^KVonGVi_oVi^Ko
iNGUonKVi_oUi^Koi^KVonGUiOoVi^GoiNGUonKVi_oUiNGoi^KWonGUiOoV
i^KoiNGUonKVi_oUi^Koi^KVonGUiOoVi^KoiNKVonKVi_oUiNGoi^KUonGU
iOoVi^Koi>CTonWYjOoWinOoj>SWonKVi_oVi^D00ooVi^H03_oVj>Soi^OX
onKWjOoUi^Soi^OWonCUiooUi^OoiNGUonKViooTiNGoiNKVom[Jf_oWinKo
inOW0_oXj>P0>OoQhN7og]kNonCShooTi>?oiNGSon3QhOoOh>;ofmgPomgP
hooUiNGoi^KVonGUiOoVi^GofM[JomKGeooFe]KofMWJon3PhOoUi^Koi>GU
omgNgOoJf][oi^KVonGUiOoVi^OoiNGUonGVi_oUiNGoi^KUon?Si?oMg]ko
iNGUonGVi_oUiNKoi^KVonGUiOoVi^Goi>GUonKVi_oUiNGoi>CTomgMgOoQ
hN7oiNGUonKViOoUiNKohnCTomkNg_oUi^KoiNGVonKVi_oUiNGoi^KUonCU
iOoVi^KoiNGUonKVi`02onCUi@13on?Ti?oVi^GoiNGVonGVi_oUiNGoiNKV
onGUi_oVi^KoiNGUonKViOoTiNGoh>3Pol_<bom]KFkoOWinojf][OoGf=So
g]oOomoOgooKfm_ofMWIom_KfooIf][of][Kom_Kg?oPhN3ogmoOomcLgOoJ
f][ogMgMomoOh?oRh^;og]oOom_LfooIf][of=SHom?CdooIf][og=cLomkN
gooKg=cog=cKom[JfooKg=coemOGomgMgOoPhN7ogMkNomGEeOoDeMGof][J
om_KfooFe]Koe=CEomgMgOoQhN7ogmoPom_KfooFe]Kog=cLom[Jf_oFemOo
gMgMon3QhOoIfMWofM[IomcLg002omoOg`1=oiNHV?nBTY;oZj^/oh:2P_mE
EECo^KViomkOgooRh^;oiNKVonCUiOoUi^KoiNGUonKViOoUiNKoiNKVonGU
iOoUi^KoiNGVonGVi_oTiNGoi^KUonCUiOoUi^KohnCTon;RhooMgMkofM[J
onGUiOoUiNCohn?Son;Rh_oQhN7oh^;Ron7QhOoRh^;ogmoOomkNgOoIfMWo
e]OGomOGeooMgMgogn3Pon?ShooOh>3ogMgLomOGeooFe]KofMWIomkNg_oP
h>3oh^;Ron7QhOoRh^7oh>7Qon;Rh_oQhN7oh^;RomoOgooNg]kofMWIomOG
e_oGemOog=cLon3Ph?oShn?oh>3PomcMgOoGemOoemOFomWIfOoNg]koh>3P
on;Rh_oQhN7oh^;Ron7QhOoRh^400_oQhN400ooPh>3og]kNomWIf@02omOG
e`05omgMg?oOgmoohn?Son3Ph?oMgMd00_oGemL01_oIfMWog]kMon3Ph?oQ
hN7ogmoOomkNgP;ogMgM00_og=cLomgMg?oLg=cogMgMomcLg?oMgMkog=cL
omgMgOoLg=cogMgMomcLg002omgMg@0/on3Ph?oQhN7oh^;Ron7QhOoRh^7o
hN7Qon;Rh_oQhN7oh^;Ron7QhOoMgMkog]kNon3PgooOgmoogn3PomoOgooO
h>3ogmoOon3Ph?oNgmooh>3OomkNgooPh>3ogmoOon3Ph?oNgmoogn3PomkO
gooPh=oogmoOomoPh?oOgmoogn3PomoOgooPh>3og]oOon3PgooNg]ooh>3P
omkOgooOh>3ogMgMomcMgOoMgMd2on3Ph00_on7QhOoPh>3ohN7Qon3Ph?oQ
hN7oh>3Pon7Qh?oOh>3ohN7Qon3Ph?oQhN7ogmoOomkNg_oKfmcog]oNomoO
gooOh>3ogmoOomoPh?oOgn3oh>3PomoOgooQhN3oemSIomWJfooHfM[ofM[L
omSIf_oIf]cof=WJom[JfooHfM_ofM[KomSIfooIf]_ofMWKomWJg?oHfM[o
f]_KomSIf_oIf]cof=WKom[Kg?oHfM[ofM[LomSIf_oIfm/00_oIf]/0?_oH
fM_ofM[KomWJfooJfmcof=WKom[KfooHfM[of]_LomWJfooJfmcof=WJom[K
g?oHfM_of]_KomWJfooIf]cofM[KomWKg?oIf]_of]_LomSIfooJfm_of=WJ
om[Kg?oIf]_of]_LomWJfooJfmcofM[Kom[KfooIf]_ofM[LomWJfooIf]co
fM[Kom[Kg?oIf]_of]_KomSIfooJfmcofM[Kom[Kg?oIf]_of]_LomWIfooJ
fm_ofM[Kom[Kg?oIf]_of]_Lom[Jg?oKfmcofM[Kom_Lg?oIf]_of]_LomWJ
fooKfmgofM[Kom[Kg?oIf]_ofm_L0_oJfm`03_oIf]_of]_Lom[Kg?oJfmgo
fM[Kom[Kg?oIf]_of]cLom[Kg?oKg=gofM[Kom_Lg?oJf]_ofmcL0_oJfm`0
2OoKfmgof]_Lom_LgOoJfmcofm_Lom_LgOoLg=kog]oPon;Si001onKWj000
04gob<kDol;9c_noaL_o^;o4okNn`oni`<Go^;k3okNm`onc^KkoZZneoijT
ZOnAUY_oVIfQojfa]_no`lOoal_>omGFeoo4aLKo[Jj_ok6b/_o1`L;odM;B
om[JfooNgmoogmoOomoPh?oMg]kogMgMomkNg_oLg=goclo@ol?4a?nj^[[o
[Zj_okFe]Oo6a/KoeMGEomcLgOoCe=Cob<W9okNg]ona/K;o_l30olo@d?oI
f][og]kOomkOgooOgn3ogMgNomcLgOoNgmoog=cLolo?d?o4a<Co^[Zjojn_
/?nd];Goa/K7omKFe_oLg=godmCDolS9bOng]kOo/K6boko0`?o?cloof][K
omkNg_oNgmoogn3PomgMgOoMg]kog]kNomgNg_oFe]Kodm?ComWIf@02omgM
g@0;om[KfooHf=Sod];BomGFe_oMg]kogmoPon3PhOoOh>3oh>7QomoPh?oP
h>400_oPhN403_oPh>3oh>3QomoPh?oPh>3oh>3QomoPh?oPhN7oh>3QomoP
h?oPhN7oh>3Pon3QhOoOh>3oh>3Q0_oPhN404_oPh>3oh>7Qon3Ph?oPh>3o
h>7Qon3Ph?oPhN7oh>3QomoPh?oPhN7oh>3Pon7QhOoPh>3oh>3Qon7QhOoP
hN7oh>3Pon3Qh@;oh>3P01koh>7Qon3Ph?oPhN7oh>3Qon3Ph?oPhN7oh>3P
on7QhOoPh>3oh>3Qon7QhOoPhN7oh>3Pon3QhOoPh>3oh>3Qon3QhOoPh>3o
h>7Qon3PhOoPh>3oh>7Qon3Ph?oQhN7oh>3Pon3PhOoQhN7oh>7Qon3Ph?oP
hN42on3Ph00>on3QhOoPh>3oh>7Qon3PhOoPh>3oh>7Qon3Ph?oQhN7oh>3P
on3PhOoQhN7oh>7Qon3Ph?oPhN42on3Ph00?on3QhOoPh>3oh>7Qon3PhOoP
h>3oh>7Qon3Ph?oQhN7oh>3Pon3PhOoQhN7oh>7Qon3Ph?oPhN7ogmoO00So
h^;R02?ohN7Qon3Ph?oOgn3ogn3QomoPh_oOhN;oh>7QomoPh?oPh>3oh>3Q
omoOh?oOh>3of][JomKFe_oGemSofmcLomgMg_oOh>3ogMgNom[JfooIfMWo
f][JomkNg_oKfm_ogn3Pon3PhOoPh>3oh>7Qon3PhOoOh>3oh>7Qon3Ph?oP
hN7ogn3Pon3Ph@02on3Qh@0>on3Ph?oPhN7ogn3Pon3Ph?oPh>7oh>3Pon3Q
hOoPh>3ogMkNomSHf?oPh>3oh>7QomoPh?oPh>42on3Qh@06on3Ph?oPh>7o
gn3PomoOgooMgMgogmoO0_oPh>42omoPh004omgMgOoPhN7ogn3Pon3Ph@;o
h>7Q02[oh>3Pon3PhOoOh>3oh>3Pon3PhOoOh>3oh>3Qon3Ph?oOh>3oh>3Q
on3Ph?oPhN7ogn3Pon3Ph?oPhN7oh>3Qon3Ph?oKfm_oclo?ok>d]?n^[Zko
GemOojVYZOoHf=Woe]KGomCDeOo:b/_odm?Com;Bdoo=cLkocm3@om[KfooI
fMWoe=GEom;Bd_oDe=CofM[Jom[JfooIfMWoe=CDol[:boo@dM42olc<c00l
om7AdOoIf][of][JolW9bOo5a/Koe]KGom?Ce?oCdm?ofMWJomKFe_oBd];o
d=7Aom7Bd_oBd];oclo?om;Bd_oFe]Oof][Kom[Jf_oFe]Koe=CDomKFe_oE
eMGod]?ComKGeooIfMWoemOGomKFe_oEeMGofM[JomWIfOoDeMGod=7AomCE
eOoBd];oNGUjogIfM_oJfm_ogMgMomoOh?oPh>3ogn3Pon3PhOoPh>3ogn3P
on3PhOoOh>3oh>7QomoPh?oPh>3oh>7Qon3PhOoPh>3oh>3QomkNgooLg=go
fMWIom?De?oRh^;ohN7Q0_oPh>005OoOgmooh>3PomkNgooNg]oogMgMomWI
fOoDe=CoemOGomoOgooQhN7oh^;Ron7QhOoRh^;ohN7QomoOgooGemOoe=CD
omWIfOoLg=cog]kOomoOh003omoOg`07omkNgooNg]kogMgMomSHf?oEeMGo
emOGomoOg`02on7Qh@09on;Rh_oQhN7ohN7Qon3Ph?oGemOoe=CDomWIfOoL
g=cog]kN00CogmoO00Oog]kOomoOgooLg=cofMWIomCDe?oGemOoh>3P00;o
hN7Q00goh^;Ron7QhOoQhN7oh>3PomKGeooEeMGofMWIomcLg?oOgmoog]oO
omoOgooNg]kog]oO00;ogmoO00oog]kNomoOgooNg]kog]kNomoOgooNg]ko
gmoOomkOgooNg]kogmoOomkOgooOgmoog]kOomoOgooOh>000_oOgml03OoO
gn3ogmoOomoOh?oOgn3ofm_LomgNg_oNg]kogMgNomkNgooMg]kog]oOomgN
g_oNg]h00_oNg]l04_oMg]kog]kOomgNg_oNg]kog]kOomgNg_oNg]oog]kN
omgNg_oNg]oogMkNomkOgooMgMkog]kNomkOgooNg]oogMkNomkNg`;ogMkN
00[og]kNomcLg?oKfm_of][JomWIfOoJf][ofM[Jom[KfooIf][of][J0_oJ
f]/01?oJf][of][Kom[Jf_oIf]X2om[JfP0LomgMgOoMg]kogMgNomkNgooN
g]kog]oOomgNg_oNg]kog]oOomgNg_oEe]OoemSIomKGf?oFemWoemSIomKG
fOoGf=[oemSIomKGfOoGf=Woe]OIomOHf_oGemSoemSIomOHf_oGf=Woe]SI
omOHfP;oe]OI00koemSIomOGfOoGf=[oemSIomKGfOoGf=Woe]OIomOHf_oG
emWoemSIomOIf_oGf=[oemSIomSIfPCoemSI00cof=WJomOHfOoGf=Wof=SJ
omOHfOoHfM[oemSIomSIfOoHfM[of=SJomOHfOoHfMX2omOHf@03omOIf_oG
f=Wof=WJ00;oemSI00CoemSJomOHfOoHfM[oemSI0ooHfMX01ooGf=Wof=WJ
omOHfOoGf=Wof=WJomOHfOoHfMX00_oGf=T01?oHfM[oemSIomSIf_oGf=T3
omSIfP06omSIfOoHfM[oemSJomOIf_oHfM[oemSI0_oHfMX02_oGf=Wof=WJ
omSHfOoHfM[oemSIomSIf_oHfM_of=WJomSHf_oIfM/4omSIfP03omWJfooH
fM[of=WJ00;of=WJ00?ofMWJomSIf_oHfMX00_oIf]/00ooJfmcoh>7Ron;S
i001onSYj`0000?obM3EolK=doo1b<h00_nma<X04onm`lWo_<?8ok_2aone
^l3oZ:jcoiRMX_nVZjooc=3Com;Ff_oCf=cod]KIonCVj?oYjncoh>7Roko0
`?nl_;goc<g=om[Jf_oQh^800_oSi>@0:_oShn?ohN7Ron3QhOoPh>7ofM[J
olG5aOn^[joo]kNgomSIfOoQhN7oi^KVonWYj_o]kNkokNg]onSXj?o3a<Co
^;Viol[;booIfM[ohN7Ron?Ti?oTi>Cohn?Ton;Rh_oQhN7oh>3PomWJf_o5
aLGo[Zj^okJg]ooHfMWohN7QonGUiOoYjN[okNg^ong]kOoXj>Wo`lC4okVi
^Oo;bl_ofM[Jon3Qh@;ohnCT00coh^?Son7Rh_oQh^;oh^?Son?ShooMgMko
emSHom?Cdoo@d=3od];ComOHf?oMg]h2on?Ti003onCUiOoTi>CohnCT00;o
i>CU00Koi>CTon?Ti?oTi>Goi>CTonCTiOoTiND2onCTi@08onCUiOoTi>Go
i>CTonCUiOoTi>GohnCTonCTiOoTiND2onCTi0?oi>CU00CoiNGUonCTiOoT
i>GoiNGU0_oTi>D06ooUiNGoi>CUonCTi?oTi>Goi>GUonCTiOoTi>Coi>GU
onCTiOoTiNGoiNGUonCUiOoTi>GoiNGUonCUiOoTi>GoiNGUonCUiOoTi>Co
i>GUonGUiOoTi>Goi>CTonCUiOoTi>Goi>GUonGUi@02onCUi@0>onGUiOoT
iNGoi>CUonGUiOoTiNGoi>CTonCUiOoUiNGoi>CUonCTi?oTiNGoi>CUonCU
iOoUiND2onCUi@0KonGUiOoTiNGoi>CUonGUiOoTiNGoi>CTonCUiOoUiNGo
i>CUonCTi?oTiNGoi>CUonCUiOoUiNGoi>GUonCTiOoUiNGoi>GUonCTiOoU
iNGoi>GUonCTi?oTi>GoiNGUonCTiOoTi>Coi>GU00;oi>CU00?ohn?SonCT
i?oVi^H00ooWinL01?oTi>Coh^?Son;RhooWi^H2onOWi`05onKVi_oUiNGo
hN;RonCTiOoUiND00_oTi>D01OoTiNGoi>CTonCTiOoUiNGoi>CU00;oi>CT
0_oTi>D3onCTi0;oh>3Q0_oTi>D02?oUiNGoi>CUonCTi?oUiNGoi>CUonCT
i?oTi>Goi>GU0_oTi>@3onCTi@0;onGUiOoTi>Goi>CUonGUiOoTi>Goi>CT
onGUiOoTi>Goi>CTonCTiOoTiND00_oTi>@01?oTi>Goi>CTonCTiOoUiND2
onCTi@08onGUiOoTi>Goi>CTonGUiOoTi>Goi>CTonCTiOoTiND2onCTi004
onCTiOoTi>Coi>CUonGUi@;oi>CU00SoiNGUonCTiOoTi>CoiNGUonCTiOoT
i>Coi>CUonCUi@;oi>CT04Coi>CUonCTi?oTi>Goi>CUon?ShooOh>3oRh^;
ogmoOooKfm_ogMgNoh:2P_mEEUKoGUiNoj>SXomNGUkoNg]komkOgooLg=go
/K6aoe5ADOnZZZ[ofm_KomkNgooKfm_oMgMgoeIGEomOGeooYJFUoeMGEon9
RHWoa<C5oeYKFomHF5SoJ6QXofQYJOnNWYoof][JomcLgOoGemOoEeMGohJ6
QooJf][ofMWJohR8R?mGEeOoeMGFomcMgOoLg=goR8V9oh61P_oLgMgogMgM
ofMWIonTY:Cog]kNomgNg_nLWIgoKFe]omcMgOoJfm_obLW:oh>3Pom`L73o
UYJGoj:RX_mSI6CogMgNon;RhP;oi>CT00Koi>GUonCTiOoTi>Coi>GUonCT
iOoTi>@2onCTi@09onCTi?oSi>Coi>CUonCTi?oTi>GohnCTon7QhOoMgMko
fMWI00;oj>SX00_oj>SYonSXj?oWinOoinSXonOWj?oVi^Koi>CTomoOgooM
gMgoiNGUonSXj002onWYj@0FonWZj_oYjNWoj>WYonWYjOoVi^KogMgMomoO
gooTi>Coi^KVonOWiooWj>SoinOWonOXj?oXj>Soi^OWonCTi?oOgmoog]kN
onGUiOoXj>SojNWYonSXj0;ojNWY01;oj>WYonSXj?oVi^KogMgMomoOgooU
iNGoi^OWonOWj?oXj>SoinSXonOWiooXj>Soi^OWonCTi?oOgmoog]kNonGU
iOoWinL5onWYj@09onSXj?oVi^Kog]kNomoOgooUiNGoi^OWonOWiooWj>So
inOX00;oinOW00CoinOXonOWiooWinSoj>SX0_oWinP01_oXj>SoinOXonOW
iooXj>SoinOXonOWi`;oinSX0_oWinL01ooWj>SoinOWonSXj?oYjNWoj>SX
onKViooUiNH00_oVi^H00ooWinOoi^KWonKViP03onKVi`05onKVi_oVi^Oo
i^KVonKViooWinL00_oVi^L01_oWinOoi^KWonKVi_oWinOoi^KWonKViP;o
i^KW0_oVi^H01?oVi^Ooi^KVonKViooWinL2onKVi`06onKWiooVi^Ooi^KV
onKViooVi^KoiNGV0_oVi^H00ooUi^KoiNGVonKViP02onGViP0:onKViooV
i^Koi^KVonKWiooVi^Ooi^KVonOWiooVi^Ooi^KVonKVi`?oi^OW00?oiNGV
omkOh?oOh>800_oPhN801ooOh>;oh>7Ron3Qh_oPhN;oh>7Son3Qh_oOh>80
0_oPhN82omoPhP04on3Qh_oOhN;oh>7Ron3Qh`;oh>7R00Soh>7Son3Qh_oO
hN;oh>7Son3Qh_oOh>;oh>7Ron3Qh`Goh>7R00CohN7Son3Qh_oPhN;ohN;S
0_oPhN801OoQh^?oh>7Ron3Qh_oPhN;oh>;S00;oh>7R00?ohN7Son3Qh_oP
hN<00_oQh^<01OoPhN;ohN;Son7Qh_oPhN;ohN;S00;oh>7R00?oh>7Son7R
hooPhN<00ooPhN801ooPhN?ohN;Son7RhooQhN?ohN;Son3QhooPhN800_oQ
h^<01ooQhN;ohN;Son7RhooQh^?oh>7Ron7RhooPhN801?oQh^<01_oRhnCo
hN;Son7QhooRh^?ohN;Son3QhP?ohN;S00Soh>;Ron7RhooQhN?ohN;Son;R
i?oRh^?ohN;Son;Si0;ohN;S00?oh^?Ton7RhooQhN801OoQh^<00ooRhnGo
i^OXon_/k@01onk_l00001Sobm7GolWAe_o9dMKobM3FolS?eOo8cmKob=3E
olG<dOnm`lSoZ[2eoj^`]?o<dMGoem[Nom[Oh_oJg^;ofMgPon?Vj?oal_?o
k>g^omoPhOo7b<Soclo?on?Si?o/k>d2oo3al@;olO7a00Ook^o_on[ZjooO
gn3obLW:olK6a_oUiNKol?3`00;omOGf023om_OgooKfm_oemOKom?CdonWY
j_o8b<WocLk>on;Rhoo/kNgol?3`oo3`lOo`lO7ol?3aonk^kooZj^[ogmoO
ol[:b_o6a/KoiNGVoo3alOoemOGomOKfooOgmooemOKom_Kfoo?cm?oYjNWo
b<S9olg=cOoRh^;ok>c]oo3`l0;ol?7a00Col?3aono`l?o^k^kokNk^0_o]
kNd00oo^k^kok^o_oo3`l002oo3al@08oo3`lOo`lO7ol?7aoo3alOoalO;o
l?7aoo7al_o`lO42oo7alP05oo3alOoalO;ol?7aoo3alOoalO400_o`lO40
1ooalO;ol?7aoo7al_oalO;ol?7aoo7bl_oalO400_oal_803_oalO7olO;b
oo7alOoalO7olO7boo7alOo`lO7olO7boo7alOoalO;olO;boo7alOoal_;o
lO7a0_oal_801OoalO7olO;boo7alOoalO7olO7b00;olO7a00OolO;boo7a
lOoalO;olO;boo7alOoal_;olO7b00;olO;b00OolO7boo7bl_oalO;olO7a
oo7bl_oalO;olO7a00?olO7b00ColO;boo7al_oal_;olO7b0_oal_801ooa
lO;ol_;boo7al_oalO7olO;boo7al_oalO400_oalO801Ooal_;ol_;boo7a
l_obl_;olO7b00;ol_;b00ColO7boo7bl_oalO;olO7a0_oalO803ooalO7o
lO7boo7alOoalO;olO;boo7al_oal_;olO7boo;bl_oal_;olO7boo7bl_oa
lO7ol?3`oo3`l@04oo7al@03oo7al_oal_;ol?3`00?ol?3`00KolO;boo7a
lOoal_;olO7boo7alOoalO82oo7al@?olO7b00ColO;boo7alOoal_;olO7a
0_oal_801OoalO7olO;boo7alOoalO7olO7b00;olO7a00OolO7boo7alOoa
lO;olO;boo7alOoal_;olO7a00;olO;b00GolO7aoo7bl_oalO7olO7aoo7a
lP02oo7al@07oo7al_oalO7olO7boo7bl_oalO7olO;boo7al@02oo7blP05
oo7alOoal_;olO7aoo7alOoalO800_oalO401ooalO;olO7aoo7al_oal_;o
lO7aoo7bl_oalO400_oal_801OoalO7olO;boo7alOoalO7olO7b00;olO7a
00OolO7boo7alOoalO;olO;boo7alOoalO;olO7a00;olO;b04ColO7aoo7b
l_o`lO7okno_onc]kOnUYJKoIfMWonWYjOo@d=3oEUIFolk>c_oIf][oSHf=
oeQHF?oWinOojn_[onOWion6QhOoHV9RogYjNooWinSojn_[ol?3a?mKFeco
emOHomGFe_n3Ph?oIFEUon[Zj_oMg]koa<C4onKViooWj>So`L71oeEEEOo4
aLGoj>SXol?4a?mKFe_oI6ATon;ShooShn?oJFYZoeeMGOnk_;coj>SYonWY
jOn@TI7oRHV9on[Zj_oXjNWoJfa/ojb][OoZj^_oj^[ZojFVY_mcLg?oj>SY
onOWj?mmOGkoLW9bokRh^?nNWYkoKVi^ofATI?oZjn_ok^k^oo3`l@;olO7a
00?ol?7aoo7al_oalO400_oalO800ooalO7olO7boo7al@02oo7alP06oo7a
lOoalO;ol?3`ong]k_oZj^[oiNGV0_odm?@3oo;blP09oo7alOoal_;ol?3`
ong]k_oXj>SokNg]oo7alOobl_;olo?c00;om?Cd01Colo?cooCdm?obl_;o
lO7aonk^k_oWj>SokNk^oo3`l?oal_;ol_;boo7alOobl_;olO7aoo3`l?o]
kNgoinSXong]kOoalO7ol_;boo?cm0?om?Cd027olo?doo?clooalO7okNg]
onSXj?o]kNgol?3`oo7alOoalO;olO7aoo;bl_oalO7ol?3`ong]k_oWj>So
kNg]oo3`l?oblo?om?Cdoo?cm?odm?Colo?doo?clooblo?olO7aong]kOoX
j>SokNg]oo3`l?oal_;olO7aoo;bl_oalO400_obl_801OoalO7ol_;boo7a
lOoalO7ol_;b00;olO7a00Ool_;boo7alOobl_;ol_;boo7alOobl_;olO7a
00;ol_;b00kolO7aoo;bl_obl_;olO7aonk^k_o_knookno`oo3`l?o_l?3o
l?3`oo3`lOo_l?3ol?3aono`l0;ol?3a00koko3`oo3`l?o_l?3okno`oo3`
l?o_l?3okno`oo3`l?o_l?3ol?3`oo3`lOo_l?3ol?3`ono`l0;ol?3a00Wo
ko3`oo3`lOo_l?3okno`oo3`l?o_l?3okno`oo3`l?o_l?000_o`l?000oo_
l?3ol?3`ono`l002oo3`l00Eono`l?o`l?3oko3`ono_l?o`l?3oko3`ono_
l?o`l?3oko3`oo3`l?o`l?7ol?3`oo3alOo`l?7olO7aong]k_oYjN[oj^_/
onWZk?oYj^_ojN_/00;ojN[/1?oZjn`00ooYj^coj^_/onWZk002on[[k009
on[Zk?oZjncoj^_/onWZk?oZjncojN_/onWZk?oYjncojN[/00;oj^_/00?o
jN[/on[[k?oYjn`01OoZjn`01?oZj^coj^_/on[[k?oZj^`2on[[k003on_[
k?oZjncoj^_/00;oj^_/00Coj^c/on_/kOoZjncoj^c]2_oZjn`01_o[jngo
j^_/on_/kOo[jngoj^_/on_/k@Ooj^_/0_o[k>d00ooZjncojnc]on_[k002
on_/k@04on[[kOo[k>gojn_/on[[k0;ojnc]00?oj^_/on_/kOo[jn`00_o[
k>d00ooZjncojnc]on_/k@02on_/k@04on_[kOo[k>gojnc]on[/k0;ojnc]
00?oj^c/on_/kOo[k>d01_o[k>d00oo/k>gokNk_ong^k`02onc]kP0000Co
c=;GolO=doo2bLoo`<O=0_noa/`02?noaL[o^/76ojne^onNYJWo^Ko2olS<
d?o?dmOodmOK0_oEfMd07ooFfMcoi>OYonKXj?oLgMkoc/o?okno`?oHfMWo
iNGUonWYj_o[jn_oj^_[on[ZjooYj^[oi>GUomSHfOo2`/?oemSHonGUi_o/
kNgol_;boo?cloocloCol_?coo;bl_o]kNkoj>SXomSIfOo1`/;of=WIonCU
iOoYjNT00_o[jn/05_oZj^_ojNWZonGVi_oIfMWo`L;2omOGf?oUiNGok>c]
oo;bl_obl_?olo?coo;cloobl_;okNg^onOXj?oHfMWo`L72omSIfOoUi^Ko
jN[Zon[ZjooZjn/2on[Zj`04on_[jooZjn_oj^[Zon[[j`;oj^[[0_oZjn/0
1_oZj^_oj^_[on_[joo[jncoj^[[on[[j`;oj^[[00Kojn_[on[[jooZj^_o
j^_[on[ZjooZjn/2on_[j`;oj^_[0_o[jn`4on[[j`06on_[k?o[jn_oj^_[
on_[jooZjn_ojn_[0_o[jn`03_oZjn_ojn_[on_[k?o[k>cojn_[on_[k?oZ
jn_ojn_[on_/k?o[jncoj^_[on_[k?oZjn_ojn_[0_o[k>`01_o[jn_ojn_/
on_/k?o/k>cojn_[on_[k0;ojn_[00Cojnc/on_[k?o[jn_ojn_/0_o[jn/2
on_/k004on_[joo[jncojnc/onc/k0;ojn_/00Sojn_[on_[k?o[k>cojn_/
on_[joo[jncojn_[on_[k0;ojnc/0_o[jn`01?o[k>cok>c/on_[k?o[jn`2
on_[j`06on_/k?o[jncojn_[on_[k?o[jn_ojn_/0_o[k>`2on_[k00:on_/
k?o/k>cojn_[on_[k?o[jn_ojn_/on_/k?o[jncojn_[on_[k0;ojn_[0_o[
k>`01_o[jn_ojn_/on_/k?o/k>cojn_[on_[k0;ojn_[00Cojnc/on_[k?o[
jn_ojn_/0_o[jn/2on_/k006on_[joo[jncojnc/onc/k?o[jn_ojn_/0_o[
jn/01?o[k>cojn_/on_[joo[jn`2on_[j`;ojnc/00Kojn_[on_[k?o[k>co
k>c/on_[joo[jn`2on_[j`04on_/k?o[jncojn_[on_[k0;ojn_[0_o[k>`0
1_o[jn_ojn_/on_/k?o/k>cojn_[on_[k0;ojn_[00Cojnc/on_[k?o[jn_o
jn_/0_o[jn/2on_/k006on_[joo[jncojnc/onc/k?o[jn_ojn_/0_o[jn/0
1?o[k>cojn_/on_[joo[jn`2on_[j`;ojnc/00Kojn_[on_[k?o[k>cojnc/
on_[joo[jn`2on_[j`0`on_/k?o[jncojn_[on_[k?oZjn_oj^[[on[Zj_oV
inOoXJ:RofAUIOoTi>CoemOHoeIFEonk^k_oh>3Qok6a/OmOGeoohnCTon?S
i?oIfMWoEUIFokbl_?mJFU[oc/k>onCTi?o;blcoEeMGolK6aooQhN7oY:BT
of][JooSi>Coi^OWonCUiOoQhN7og]oOom[KfomHF5WoZj^[on;RhonFUiOo
PX:3ogEeMOo1`/;obl_;oeUIFOnOWj3oRHV90_oRh^<05on=SHgoQXJ6on?S
hooShnCoJFUYojNWYooQh^;ohnCToj:RX_maLG7ohnCTom_Kg?mEEEKo_ko0
onGUiOoSi>CoXj>Tof5QHOoTi>Coj>SYon_[joo[jncojn_[00;ojn_/00Go
jnc/on_[joo[jncoj^_[on_[j`02on_[k00:on[[joo[jncoj^_[onWZj_oW
j>Soi>CTomkOgoo]kNgojn_/on[Zj`Coj>SX00[oinOWonCTi?oNg]koiNGU
onKVi_oXj>SojNWYon[Zj_oYj^[oj^[Z0_oYjNT01OoWinOoiNGUomgMg_oS
i>CoinOW00;oj>SX01CojNWYonSXj?oXj>SoinOWonCTi?oNg]koiNGUonOW
iooYjNWoj>SYon[Zj_oYjNWoj^[ZonWYjOoXj>SoinOWonGUiOoMgMkohnCT
onOWi`Coj>SX00Koj>WYonKWiooTi>CogMgNonCTi?oWinL2onSXj00:on[Z
j_oYjN[oj^[ZonWYjOoXjNWoinOWonGUiOoNg]koi>CTonKWi`Koj>SX00Go
jNWYonSXj?oXj>Soj>SXonWYj@03onSXj003onWYjOoXj>Soj>SX00Goj>SX
00?ojNWYonSXj?oWinP00_oUiND02?oUi^Koi^KWonKViooVinOoiNKVonKV
iooUiNKoi^KV0_oVi^L01ooUiNKoi^KWonGUi_oVi^Koi^KWonKWiooUi^H0
0_oVi^L01OoVinOoiNKVonKViooUiNKoi^KV00;oi^KW00OoiNKVonKWiooU
i^Koi^KVonKViooVinOoiNKV00;oi^KW00Goi^OWonGVi_oVi^OoiNGVonKV
iP02onKVi`04onGUi_oVinOoiNKVonKViP;oi^KW00koiNKVonKViooVi^Ko
i^OWonKVi_oVi^OoiNKVonKViooVinOoi>GUomoOh?oOh>;ogn3QomoPhP;o
h>7R00Kogn3Qon3Qh_oPhN;oh>7RomoPhOoPh>82omoPh@;ogn3R00?ogn3Q
on3Qh_oOh>400ooPhN802?oOh>;oh>7Ron3Ph_oPhN;ogn3Ron3Qh_oOh>7o
gn3R0_oPhN801?oOh>7oh>7RomoPhOoPh>82on3QhP07omoPh_oPhN;oh>7R
on7QhooPh>;oh>7RomoPh@04on3QhP06on7RhooPh>;oh>7Ron7QhooPhN?o
gn7R0_oPhN801_oQh^?oh>7Ron3Qh_oPh>7oh>7Ron7Rh`;oh>7R00CohN;S
on3Qh_oPhN;oh>7S0_oPhN802ooQh^?oh>7Son7RhooPhN;oh>;Son3Qh_oQ
hN;ohN7Son7RhooPhN;ohN;S00;oh>7R0_oQh^<02?oPhN;ohN;Son7RhooQ
h^?oh>7Ron7RhooPhN;oh>7S0_oQh^<01?oPhN;ohN;Son3Qh_oQhN<2on7R
h`07on7Qh_oQh^?ohN;Son7RhooQhN?ohN;Son3QhP03on7Rh`04on7Rh_oS
i>Goi>GVon_[k07okNk_0000E?o;dmSoa/cBol77cOnj`LKo^L36ok_1aonk
`LKo][g2oj^b^?nMXZKo^Kk2ol?7boo9cM7obLgBolkCe_o>dmOocM;FolkA
e?oIfmgof]_Molk?d?na/[;oc<g>omkOgooUi^Ooi^KWonOWiooVi^Soi^KW
on3QhOoEeMGo_KfmomSHf?oPh>7oinOWonOXjOo/kNgokNg^onk^kooYjNWo
inSXon;Rh_oHf=Wo_KfnomGEe_oPhN7oi^KWonKWiooWinSoi^OWonKVi_oP
h>;oe=CEokfm_OoHf=Woh>3PonOXj?oXj>Sok>g]ong]k_o^k^ooj>WYonOW
iooRh^;ofMWIokfm_OoDeMGoh>3RonGVi_oVinOoinSXonKViooWj>Soi^KW
onKWiooVi^SoinSXonKVi_oWinSoi^OWonOWiooVinOoinOXonGVi`;oi^OW
00koinSXonKViooWj>Soi^KWonKWiooVi^SoinSXonKVi_oWinSoi^OWonOW
j?oVinOoinOXonGVi`;oi^OW09CoinSXonKViooWj>Soi^OWonOWiooVinSo
inSXonKViooWj>Soi^OWonOWj?oVinOoinSXonKViooWinOoi^OWonSXj?oV
inOoj>SYonKWiooWinSoi^OXonSXj?oVinOoinSXonOWiooWj>SoinOWonOX
j?oVi^SoinOXonOWiooXj>WoinOWonSXjOoWinOoinSXonOWj?oXj>Woi^OW
onSXj?oWinSoj>SXonOWj?oXj>Soi^OXonOXj?oWinSoj>SYonOWiooXjNWo
inOWonOXj?oWinSoj>SYonOWiooXj>SoinOXonSXj?oWinSoj>SXonKWj?oW
j>SoinOXonSXjOoWinOoj>WYonOWiooWj>SoinOXonSXjOoWinOoj>SXonOW
j?oXj>SoinOXonSXj?oVinSoinSXonOWj?oXj>WoinOWonSYjOoWinOoinSX
onOWj?oXj>WoinOWonSXj?oWinSoj>SXonOWj?oXj>Soi^OXonOXj?oWinSo
j>SYonOWiooXjNWoinOWonOXj?oWinSoj>SYonOWiooXj>SoinOXonSXj?oW
inSoj>SXonKWj?oWj>SoinOXonSXjOoWinOoj>WYonOWiooWj>SoinOXonSX
jOoWinOoj>SXonOWj?oXj>SoinOXonSXj?oVinSoinSXonOWj?oXj>WoinOW
onSYjOoWinOoinSXonOWj?oXj>Woi^OWonSXj?oWinSoj>SXonOWj?oXj>So
i^OXonOXj?oWinSoj>SYonOWiooXjNWoinOW0_oWinP02?oXj>Woi^OWonSX
j?oWinSoj>SXonOWj?oXj>Soi^KX0_oWinP03_oXj>WoinOWonSXjOoWinOo
inSXonOWj?oXj>Woi^OWonSXj?oWinSoj>SXonOWiooXj>Soi^KX0_oWinP0
1?oXj>WoinOWonSXjOoWinL2onOWj01>onSXjOoVinOoinOXonGUi_oShn?o
Wj2Pof=SHooOgn7ohn?TokRi^OmbLW;oKFe]og1`L?mNGUkoh>3QomkNgonW
YjSoJ6QXon?Si?n8R8SoUIFFomkOgooRh^;o[jn`ofe]K_m_KfooK6a/of][
JooRh^;oh>7QomgMgOoJf]_of=SIoh^;RomDE5CocLg>omoOgom/K6coZj^[
oijNWonCTi?oXj>TogUiNOo@d=3oG5aMom[JfooNgmooRX^<ohF5QOoOgn3o
h>7QofMWIonTY:Cog=cLomkNg_nLW9goKVi^on3Ph?nm_KgoDU9BomCDe?oM
gMgogMgNoj^[[?mOGeooh>3PonGUi_oWinOoinSXonOWiooXj>Soi^KXonOW
j?oWinOoj>SXonOWiooXj>Woi^OW0_oWinP04_oXj>Soi^OWonKWiooSi>Co
h>3Qom_KfooYjNWoi^OXonKVi_oUi^Koi^KVonGUiOoVi^Koi>CTon7QhOoJ
f]_oh^;Ron7Qh@;oi>CT0_oUiND00ooVi^Koi>CUonCTi002on;RhP0;om[J
f_oRh^;oi>CTonGUiOoUiNKoi^KVonGUiOoVi^Koi>CTon7Qh_oJf]X00_oQ
hN82onCTi003onKVi_oUiNGoi^KV00;oi>CT00goh^;Son;Rh_oJf][oh^;R
onCTi?oUiNKoiNGUonKVi_oTi>KoiNGUonCTi?oRh^;of][J00;oh^;R00Go
i>CTonCTiOoVi^Koi>CTonKViP02onCTi0;oh^;R01Oof][Kon7Qh_oTi>Co
i^KVonGUiOoVinOoiNGUonGVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonCTi_oUi^KoiNGUonKVi_oUiNGoi^OWonGUi@02onGUiP04onKV
i_oShn?oh^;Son;RhP;ohnCT07;oi>CUon;Si?oTi>CohnCTonCUiOoShnCo
iNGUon?Si?oTi>Cohn?UonCUiOoShn?oi>CUon?Ti?oTi>CohnCTonCTiOoR
hnCoi>CTon?Ti?oTiNGohn?TonGUiOoShnCoi>CTon?SiOoTiNGohn?SonCT
iOoSi>Coi>CTon?Ti?oTi>Gohn?TonCTi?oSi>Coi>GUon?Si?oTiNGohn?T
onCTi?oShnGoi>GUon?ShooTi>GohnCTonCTi?oSi>Coi>CUon?Si?oTi>Co
hnCTonCUiOoShnCoiNGUon7Qh_oMg]oofmcNomgNgooLgMkogMkOomcMg_oM
g]oog=gOomgNh?oLgMoogMkOomcMg_oNg^3og=gNomgNh?oLgMkogMkOomcM
gooNg^3og=gNomgNgooLgMoogMkOomcMgooMg]oog=gOomgNgooLgMkog]oP
omcMg_oNgn3og=gOomgNgooLgMoog]kPomcMg_oNg]oogMkOomgOh?oMg]oo
g]kPomcMgooNg]oogMkOomkOh?oLgMkog]oPomgMgooMg]oogMkPomkOh?oL
gMkog]oPomgNgooNgn3ogMkOomkOh?oLgMl2omgNg`03omkOh?oMg]oog]oP
00;ogMkO03CogMkPomkOh?oMgMoog]oPomgNgooNgn3ogMkOomkOh?oLgMoo
gMkPomgNgooOgn3ogMkOomkOh?oMg]oog]oPomgNh?oNgn3ogMkOomkOh?oM
g]oog]oPomgNgooNgn3og=kPomkOh?oNg]oogmoQomgNgooOh>7ogMkOomkO
h?oMg^3ogmoQomgNgooNgn3og]kOomoOh?oNg^3og]oPomgNh?oNgn3ogn3Q
omkOh?oOh>3ogn3QomoOhOoNgn3ogn3Qon3PhOoUi^Ooj^_/0Oo`lO80000T
ol_Aeoo7c]Coa<[@ol77cOo0algo`<K<okk4b_nk`/So/;Rnoj2VZ_nn`/Ko
`/K:olO;coo:cm?oc=7EolgAeOo<d=CobLgAolS;coo<cm;oc]3BokFf]oo<
c/ooe]OIomWKg?oJg=gofmcMom[LgOoIf]coe]OIol[;c?nc];Goc/o?omCE
e_oJfm_og=gN0ooOh>402?oMg]kofM[KomGFeoo?d=7o/kBeolW;c?oFemWo
fM[L0ooJfm`02?oIfmcoeMOHol[;c?nc];Goc/o@om?DeOoIf]_og=gN0ooO
h>404_oNg]oofM[KomGFeoo>cm3o/kBeol[;c?oEemSofM[Lom[Kg?oJfmgo
f]_Lom[KgOoJfmcof]cMom[KgOoIfmcof]cMom[Kg@?of]_L017of]cMom[K
g?oJfmgof]_Lom[KgOoIfmcof]_Mom[Kg?oJg=gof]_Mom[Kg?oJg=gof]_M
om[Kg?oIfmcof]_Lom[Lg@02om[Kg@03omWKg?oJfmgofM_L00;of]_M0_oJ
g=d01ooJfmgofmcMom[LgOoJfmgofM_Lom[KgOoKg=d01OoJg=d01OoKg=go
f]cMom_LgOoKg=gof]cM00;ofmgN0_oKg=d00ooKg=kog=gNom_MgP04om_M
gP;og=gN00Cog=kNomcMg_oLgMkogMkO1?oLgMh00ooMg]oog=kNomgNgP03
omcMgP05omgNgooLgMkogMkOomgNg_oMgMh00_oMg]l00ooMgMkog=gNomgN
g`03omgNg`05omgNg_oMg]oog=gNomgNgooMg]h00ooMg]l01_oNgmoogMkO
omgNgooMgMkogMkNomkOg`CogMkO00?ogMkNomgNgooMg]l00ooMg]l01_oN
gmoogMkOomgNgooMgMkogMkNomkNg`CogMkO00?og=gNomgNgooMg]h00ooM
g]l00ooNg]oogMkOomgNg`02omgMgPGogMkO00?ogMgNomgNgooMg]h00_oM
g]l01OoMgMkogMkOomgNgooMg]oogMgN00CogMkO00GogMkNomgNgooMgMko
gMkOomgNgP02omgNg`06omgMg_oMg]oogMkOomgNg_oMgMkogMkN0ooMg]l0
0ooMg]kogMkOomcMgP02omgMgP;ogMkO00?ogMgNomgNgooMg]h00_oLgMh0
3_oMgMkogMkOomgNg_oMg]oog=gNomgNgooLgMkogMkOomcMg_oMg]oogMkN
omgMg_oMg]oogMgO0_oLgMh0C_oMgMkogMkOomgMgooMg]oog=gNomgMg_oL
gMkogMkOomcMg_oMg]oogMgNomcMg_oMg]oog=gNom_LgOoHfM[oV9RIoeiN
G_oFemSof=WJomOHfOoEe]OodM;Coj6RXomJFe_of=WJomOHf?m^KfooUiNH
om[Kg?ni^K[oFe]Lom?DeOoHfM[oemOHomGFeooBd]?oUYNGofMWJ?oHfM[o
e]KHom;Ce?nf][OoI6EUoeMGEon][Jkof=WJolO8bOm?Ce3ob/[<ol;3a?mS
HfCoNGYjoiRHVOoHfM[oK6a]ok6b/ooFemSoQ8F6ogioP?oIfM[oemSIof9S
Hon:RhcodmCEomCEe_nDUIGoK6a]omSIf_o1`/?oCdm?ok6b/ooCe=Goe=CE
ojFVYomKFecof=WJom_Lg@?og=gN00?ogMkOomcMg_oLgMh02?oLgMh02?oM
g]oog=gNomWJfooGf=Soe=CEon_[k?oZjn_ojn_[0_oZj^/02OoZj^[oj^_[
onWYj_oWinOog]kNonGUiOoWinOoinOXonSXj002onWYj@09onWZj_oXj>Wo
j>SXonOWiooUiNGogMkNonOWiooYjN[ojn_[00;oj^[[01gojn_[on[[jooY
jNWoi^OWomgNg_oVi^KoinOWonOWj?oXj>SojNWYonSYjOoYjNWoj>SYonSX
j?oWinOoiNGUomkOgooWinOojNWYon[Zj_oZj^_ojn_[on[ZjooZjn_ojNWZ
onOWiooMgMkoiNGUonKVi`02onSXj00?onWYjOoZj^[ojNWYonSXj?oWinOo
i^OWonKVi_oNg]koinOWonWYj_oZj^_oj^[Zon[[jooZj^_ojn_[00;oj^[[
00Sojn_[on[[jooZj^[oj^[Zon[Zjoo[jn_oj^[[on[[j`;oj^[[00Koj^[Z
on[[jooZj^_ojn_[on[ZjooZjn/2onc/k006onc/kOo/kNgok>g]ong^k_o/
kNgokNg]0oo/kNd00oo]kNgok>g]ong]kP02onc]k@06ong^k_o]kNgok>g]
onc]kOo]kNgokNk^0_o]kNd3onc]k@;okNg]00GokNg^ong]kOo/kNgokNk^
ong]k@02onc]k@04ong]kOo]k^kokNg]ong]k@?ok>g]00?okNg]onc]kOo]
kNh00_o/kNd01_o]k^kokNg]onc]kOo/kNgokNg]ong^kP?okNg]00?ok>c]
on[[jooXjNX00ooUi^L01_oUi^Soi^OXonGWj?oUi^SoiNKWonKVj0?oi^OX
00SoiNOWonKVj?oUi^Ooi^OXonGVj?oVinSoiNKXonGWj0;oi^OX00?oi^KX
onGVj?oVinP00ooVinP00ooVi^Soi^OXonGWj002onKWj004onOWj?oVinSo
i^OXonOWj@Coi^OX00?oinSYonKWj?oVinP01OoVinP01?oWj>Woi^OXonKW
j?oWj>T4onKWj003onOXjOoVinSoi^OX00?oi^OX0_oWinP00ooWj>Woi^OX
onKWj002onOXj@?oi^OX00KoinSYonOXj?oVinSoi^OXonOWj?oVinP3onOX
j@04onOWjOoWinSoinSYonOXj@;oi^OX1?oWj>T2onOWj003onKWj?oWj>Wo
inSY00?oinSY00Koj>SYonOXjOoWinSoinSXonOXjOoXj>X5onOXj@;oj>SY
00Goj>WZonSYjOoXjN[okNk_oo3alP01oo;cm00000koc=;Gol_Bf?o:d]So
b]7Gol[Ae_o:dMOob]7FolS>e?nl`lWoWjBYokk3aoo4b<coal_?ol[>d`;o
c];F00_ocM;Fol_@e?o6bloo`lO;okc0a?nOXjKo^[o4ol?9c_o7c=;oa/cA
olK<dP02olK<d@08ol?8cOnj_lCoWZ:Uok^o`_o2aLWoa<S;olS<d?o:c]82
ol_?dP08olW=d?o5bLco`LG9okc0`onNXZGo^[o3ol;7c?o5bm03olK;d00C
olK;coo3b<co^Kk2oifQY?nk_/7o`LG8olC8boo7blkob/oBol[>dOo;c];o
bLc?olG8c?o2aLWo^ko3oifQYOnh_/?o`/S=olG:c`02olG;c`0>olG;d?o4
b]3oaL[?olG;d?o4b/ooaL_@olC:coo5b/ooa/_@olG:coo5blooa<[>olG:
coo4bLl2olG:c`0>olG:d?o4b/ooa<[?olG;d?o4b/ooaL[?ol?9coo4b/oo
aL[?olC:c_o4b/ooa<[>olG;coo4bLh2olG:c`0EolG;d?o4b/ooa<[?olG;
d?o4b/ooaL[?olC:coo5blooaL_@olC:coo5blooaL[>olK;coo4b/ooa<_@
olG;d?o6c=7oaLc@olG;d?o6c=3oaL_@00;oa/c@00?oa/gAolO=dOo7cM40
0_o7cM800oo7c]?oalgBolS>dP03olS?d`06olW?doo:d=CobM3Col[@e?o9
d=Cob]7E0_o<dMD01?o<d]Goc=7EolgBe_o=d]D2olgBeP04olgCe_o=d]Ko
cM;FolkCe`?oc];F00Oocm;Gom3Ceoo?dmOocmCGolkCeoo?dmOocm?F00;o
d=CG00?od=CHom3Ceoo?dmH00_o@e=L02_o@e=Sod=CGom7Ef?oAeMSod=CG
om7Deoo@e=OodMGHom3DeooBeMP4om7Ef006om;EfOoAeMSod]GIom7Df?oB
eMWodmGI0_oBeMT00ooAe=Sod]GIom7Df002om7Ef00?om;Ef?oAeMSodMCH
om;Ef?oAe=Ood]GHom7DeooAe=SodMCIom7Df?oBe=SodMCHom;Ef?oAe=So
dMGI00;od]GH0_oAe=P02?oAeMSodMCGom7Df?o@e=OodMCHom;Ef?oAeMSo
d]GH0_o@e=P01oo@dmOod=CGom7Ef?oBeMSodMCHom;DeooCeMP00_oAe=L0
1Oo@dmKodMCGom;Df?oBeMSodMGH00;od=CG013od=?Fom7Df?oAe=SodMCH
om7Ceoo@dmKodM?Gom3DeooAe=Sod=?Gom7DeooAdmSod=?Gom7Deoo@e=Oo
dMCG0_o@dmL01OoAdmOodMCGom3Deoo?dmOod=CG00;od=?G00?od=;Fom3C
eoo@dmL00_oAdmH00oo@d]KodM?Gom3CeP02om3Ce`1>om7DeooAdmOod=?F
om3Ceoo@d]Oocm?GoloBe_o@d]Kocm;Folg@e?n>T9?oF5UJol_>d_o<cm?o
Z:^^okJj_Oo8c=3oP8:5og1bMOo?dMGo^[c0od]=C_nm`LCoc];FolkAeOmO
H6;oXZBWolc>d_nUYj[o^[g0olO;c_mfN7[oO7j0olc@e?o9c=3oUYRKod]<
C_mZK6ko]kZmol_>d_o<cm?oV9^Nof1RI?o<d=?ocM3DoeeNH?m?DE;o];Nj
olgAeOn@TYKoOGn1olc?dommOh;oMgUkol_>d_o<cm?oGf1RoeAFF?n>T9?o
^Kc0of]]KommOh;oc]7Eolc@e?mUIfWoL79dokZn`Oo1a<OoLgEgoeIHF_o<
cm?oc]7EolkBe_o>d]Goc];FolgAe_o>d]KocM7E0_o>d]D01?o?d]Gocm?F
olkBe_o>d]H2olkAeP05olgAeOo>dMGoc]7Eol_?doo:c]400_o_l?45ong^
k`07onc]k_o[k>gohN;SonWZj_oZj^_ok>c]onc]k@02ong]kP;ok>g^0_o[
jn`01?oYjN[oh^;Son_/kOo/kNh3ong^k`0:onc]k_o]k^ook>g^on[/k?oQ
h^?oj>WZon[[k?o[k>cok>g]ong]kP;okNk^017ok>c]onc]kOoZjncojN[Z
on7Qh_o[k>gok>g^ong^koo/k^ook>g^ong^koo/kNkokNg^on_[k?oQh^?o
jN[Zon[Zj`02onc]k@0:ong^k_o/kNgokNk^onc]k_o[k>goj^_/onSYj_oQ
h^?oj^_/onc]kP?okNk_00Gok>g^ong^koo]k^ookNk_onc]kP02ong^k`05
ong]koo]k^ook>g^ong^koo/kNh01?o]k^l01Oo/kNkokNk_ong^koo]k^oo
k>g^00CokNk_00?ok>g_ong^koo/kNh01?o]k^l01Oo/kNkokNk_ong^koo]
k^ook>g^00;okNk_00GokNk^ong^koo/k^kokNk_onc]kP04ong^k`05onc]
k_o]k^ookNk_ong^koo/kNh01?o]k^l00oo]k^kokNk_onc]kP04ong^k`05
onc]k_o]k^ookNk_ong^koo/kNh01_o]k^l02Oo]kNkokNk_ong^koo^k^oo
k^o_ong^koo^l?7ok^o`onk_l@02onk_l00?onk_lOo^ko3okno`onk_l?o_
ko7ok^o`ono_lOo^ko3oknoaonk_lOo^ko3oko3aonk_l?o^l?7ok^o`00;o
ko3a00Ooknoaono_l?o^ko3oko3aonk_l?o_l?7ok^oa00;oko3a00Gok^o`
ono`lOo_ko7oko3aonk_l002ono`l@;oko3`0_o_l?400oo^ko3oko3aono_
l@02ono`l@05onk_l?o`lO7oko3aono`lOo^ko001?o_l?400oo_ko7oko3a
onk_l@04ono`l@05ono_l?o`l?7oko3aono`lOo_l?000_o`l?44ono`l@0<
ono_l?o`l?7oko3aoo3`lOo_l?;oko3aoo3alOo`l?7ol?7aono`lOo`lO7o
l?3a0oo_l?401?o`l?7oko3aoo3alOo_l?42oo3alP05ono`lOo`lO7ol?3a
oo3al_o_l?401?o`lO800oo_l?7ol?7bono`l@04oo3alP;ol?3a00Col?7b
oo7blooal_?olO;d0Ooal_<0000>olcBf?o9d=Goa<_Aokk6c?noalgo`<O<
ol36c?nma<[o]kg4oi:GVon`]KSo][^ook_0`onn`/D2ol34b00Nol;6b_nn
`/Ko^l34okNl_on`];SoTYJJokJl`_nk`/[o_/G<oko5bonoaL[o`<G;oko5
bonma<Wo][c2oi2EV_n_];Wo]KZnok_0`onl`LGo_lC8oko3b?o0a<Wo_L75
ok^o`ong^koo[kBhoi6FV_nf_<7o_L?90_nma</2okk4bP0Bokk5bonk`/So
];_1oi2DVOn_/kKo];VmokZn`_nl`<Co_/?7oko3aonoa<So_L75okZn`_ne
^Kko[k>gohnDVOne^l7o^l;80_nm`lT02?nl`/So_<;9ok_3b_nl`l[o_<;8
okc3bOnk`lWo_<?90_nk`/T00onl`lWo^l;8ok_3b@02ok_2b@09okc3bOnl
`lSo^l?8ok_2b?nl`/Wo_<?8okc2b?nj`/So^l;800;o_<;800Co_L?9okc3
bOnn`lWo_L?80_nl`lP3ok_3b0;o_<?900?o^l?9ok_2b?nl`lT00_nl`/P0
2onm`lWo_L;8okg3bOnm`lSo_L?9ok_3bOnk`/Wo_<?9okc4b?nma<So^l?8
00;o_<?90onma<T01_nma<[o_LC9okg5bonma<_o_<G:okg6bP;o_LG:00go
_/K;okk7c?nna/co_lO<oko6c?o0alco_lO<oko8cOo0b<go`LS=ol;:c_o1
b/ko`/[@00Co`l_@00[oaL_@olG:coo5bm3oaL_?olG<d?o5c=7oa/cBolO=
dOo6cM7oa/gB0_o8cM42olS=dP;oalgB00GoalkBolS=d_o9c]?ob<gBol[?
e003olW>d`0ColW>d_o:cm?ob/oCol_?doo;cm;ob/kBolW?doo:cm?oc=3D
olc?doo<cmCoblkCol[?e?o;cmCoc<oDolc@e?o<cm?oc=3Dol_@e002ol_@
d`0>ol_?e?o<d=Coc=3Eolc@eOo<cm?oc=3Col_?doo<d=?ocM3Colg?doo<
d=Coc<oDolc@eOo<d=@2olc@e@0>olg@e?o<cm?obloDol_?e?o<cm?ocLoD
olc?doo=cmCobloDol_@e?o<d=CobloDolc@e?o<cm@2ol_?e004olc?e?o;
cmCobm3Colc@d`;oc<oC0_o<cm800oo;cm?obloDolc?d`03ol_?d`05ol_>
doo;cm?obloCol_?doo<cm<00_o;c]<02?o:c]?ob/kBolc?doo;cm;oblkC
ol_?e?o;cm?oc<oD0oo<cm<01oo;c];ob/kBol_>doo;cm?ob/kBol_?doo;
c]800oo:c]801Oo:c]?oc<kColg?e?o;cm?ob/oB00;ob/kB0oo;c]801?o:
c];ob/kColW=d_o:cM82ol[=d@0=olW<d?n;SY7oEeUKolK:c_o8blooTiBH
of9TIomADeGoHfEXojR/[oo9c=7oTI:Gog=dM`02olS<d@0VolS=d_nBUY[o
N7]nolW<dOn:SHooH69Toe9CEOmVJF_o[[6eolO<dOo2a/_oCe1Bogj0Poo0
`lSo`LG:ol?7c?o4b/koO7n2ohR;S_o8c=7obLc@ohV;S_mNH6;oal_@olS;
d?nf^KkoHF=VolC8cOn2Q8SoNgf1olG9c_o7c=3oIfY]oiJJW_mlOh;oD59D
ofIXJ_na];T2olO<d@0AokNl`?mYK6koCU1BoeeOH_n2QHWoHF9UolS;d?o8
c=3obLcAolW=dOo8c=7ob<gAolW<dOo8c=7oalc@olO<dOo8c=400_o9cM40
0oo8bm7ob<cAolO<d@02olO<d@08olK;d?o5bLko`lO;onOXjOoVinSohnCV
on;TiOoRhnD2on;Si006on;SiOoQh^?oemSIom_LgOoOh>3oh>7R0_oRh^<0
5?oQh^?oh^?Son7RhooPhN;og]oPom_LgOoGf=WohN;Son;TiOoRhnGoh^CU
on;Si?oRi>Goh^?Uon;Si?oQh^CoemSIomcLgOoOh>7oh>7R1?oQh^<02ooR
h^?oh>7RomoPh?oKg=coemSIon7RhooRhnGohnCUon;Si?oRi>Goh^?U00;o
h^?T00GohN;SomOHfOoKg=gogn3Qon3QhP02on7Rh`08on7ShooQh^?ohN;S
on7Qh_oNgn3og=gMomSHfOoQh^<2on;Si@;oh^?T00?oh^CUon;SiOoRhnD0
0ooRhn@00ooRhnGohnCUon;Si002on?Ti@;oh^CU0ooRhn@03_oSi>Goh^?U
on;TiOoRhnCoh^CUon;Si?oRhnGohnCUon;Si?oSi>Goh^CUon;SiOoRi>Go
h^?U0_oRhn@01OoSi>Goh^?Ton?TiOoRhnCohn?U00;oh^?U00Ooh^CUon;S
i?oSi>GohnCUon;Si?oRi>Goh^?U00;oh^?T00CohnCUon;TiOoRi>Goh^?T
0_oRi>D2on?Ti@04on;Si?oSi>GohnCUon;Si0;oh^?U0_oRhn@01?oSi>Go
hn?Ton?TiOoRhn@4on?Ti@03on;Si?oSi>GohnCU00?ohnCU00Sohn?Ton;T
iOoSi>Gohn?Uon?TiOoRhnGohnCUon;Ti@?ohnCU00?ohnGVon?TiOoSi>D0
0_oSi>D00ooShnGohnCUon?Ti@02on?Ti@08on;SiOoSi>GohnCUon?TiOoT
i>GohnCUonCUi_oSi>H5on?Ti@03onCUi_oSi>Goi>CU00CohnCU00Coi>GU
on?TiOoTiNKoi>GV1OoSi>D2on?UiP07onCUi_oSi>GohnCUon?TiOoTi>Ko
i>GVon?Ti@02onCUiP0;onCTiOoTiNGohnCUon?TiOoTi>Goi>GVon?TiOoT
iNKohnCUonCUi_oTi>D00_oTiNH02?oTi>Goi>GVonCUi_oTi>Goi>GVonCU
iOoTi>GohnGV2?oTiNH00ooSiNGoi>GVonCUiP03onCUiP03onCTi_oTiNKo
iNGW00Goi>GV00GoiNGVonGVi_oTiNKoiNKWonGViP02onCUiP05onGUi_oT
iNKoiNKVonGViooUiNH00_oUi^L1onWZj`7ok>g^0Oo`lO80000Jol_Beoo6
c=7o`<K<ok[1aonk`LSo_<77ok_1a_nj`LKo];c2ohjCUonQYJWo[[>gokBh
_?nj_/7o^;g0okZn`_ni_L7o^;book>h_?n//KCoX:BXohjCV?nd^/3o^Ko5
okW0aOni`<@2ok[0a@0EokVoaOnh_/Go/kVoohfBUonOY:So[K6eok>g^ong
_<3o^;g1okVn`_nh_L7o^;book>g^on//;CoWj>WohfBUonc^Koo^;k4okNn
a?ng_lGo^;o500;o^;k401Oo][g3ok:i`?n=TYOoWj>Wojfa]Onb]k_o]k_0
okNl`?ni_L7o^;bookNk_onb][[oZjndoinSYon<TIGo/[RmokFl`_nh_/Co
]kk4okJma?ng_/Co]kk3okJm``02okNn``03okNm`ong_/Co][g400;o]kg4
0_nf_L801?nf_<?o][g3okJm`onf_L<2okNm``?o][g300So]Kg3okNn`ong
_L;o][g4okNma?ng_L?o]kk3okJm`P?o]kg300[o]kg4okNm`ong_L?o]kg3
okJm`one_L?o][g3okJl`_ng_L?o]kg40_nf_<<00onf_L;o^;g3okNma002
okNm``0:okNm`_ng_<?o][g3okJm`ong_L;o^;g4okNl`ong_L?o]kk4okNm
`P;o]kg300Ko]ko4okRoa?nh_/Co]kk4okNma?ng_/@2okNoa00:okRoa?ni
_lCo^;k4okNoaOnh_lGo^;o4okVoaOnh_lGo^L76ok[1a`?o^/7600Oo^/75
ok_2a_nk`/Oo^l;7okc3b?nj`lSo_<?900;o_LC90_nnaLT2oko5bP09oko4
b_noaL[o_/G;okk6boo0a/_o`LO;ol36b_o1alco`LO;00;o`/O;00?o`/O:
ol;7boo2b<`00_o3b<d03_o2alco`/S=ol;8cOo3b<coa<S<olG8cOo4b<co
aLW=olG8c?o5bLgoa<W=ol?8c?o4bLgoa<W<0_o5bLd01?o6bLgoa/[=olG:
cOo5bLd2olK:cP0<olG:cOo6b/goa/W=olK9c_o6b/koaL[>olK9c_o6bLgo
a/[>olO:coo6b/ooa/[>0_o6bLd01?o6b/koal_?olK:c_o6blh2olK:cP06
olO:c_o6bLgoa/W>olG9c_o6b/koa/W=0_o6b/h01?o5b/goaLW=olK9cOo7
b/h2olK9c@06olG9cOo4bLgoa/W>olG8c?o6bLgoaLW=0_o6b/h02oo5bLgo
a/[>olG9cOo5b<coa/W=olG9cOo5bLkoa/[?olC9cOo5bLgoa/W>00;oa/W=
00KoaLS<olG9cOo5bLgoa/S<olG9cOo4bLh2olG8c008olK8c?o5b<coaLS<
olG8c?o5b<goa<W=olC8cOo5bLd3olG8c00IolC8c?o5bLgoaLS=olC8c?o4
bLgoa<S=olC8c?o5b<goaLS<olC8c?o3al_oR8^>oeAFF?o1aLWoa<O;olG8
c?o4b<go`lK;olG8cOo4alcoaLS<olK9cOo5b<goaLW=olC7c002olC8c@05
ol?7c?o4alcoa<O<olG8c?o3a//00_o4b<`01?o2a/_o^Kg2od]<C_nUZ:`2
okk0a@0Aokk1a_o0a<So`/O;olC7c?o3alco`lK<olC7c?o4b<co`lO<ol?8
c?o4al_o`/G:ol;5bOo0a<Wo_/?8ol35boo2a//00_o3al/2ol;6b`03olC6
c?o4alco`lS=00;o`/O<00?o`/K;ol34b?o3a//00_o2al`01Oo3b<co`lO;
ol?7boo3alco`/K:00;o`lK;0_o3al/02?o2a/_o`/O<ol;7c?o3al_o`lO<
olC7c?o3al_o`/O<0_o1a//01Oo1a<Wo_/76on;Ri?oPhN?oh>7R00?ogn3Q
01gog^3QomkOh?oNgn3of=WJom?Ce?oJfm_ogMgNon3PhOoPhN;oh>3Qon3Q
hOoOh>7ogMkOom[Kg?oCdmCof=WJomkOhOoNgn3og^3QomoPhOoNgn7ogn3Q
omkOhOoOh>7og]oQomOHfOoBdmCofM[KomgNg`02on3Ph@08on3Qh_oPhN7o
gn3PomgNg_oJfm_od]?DomSIf_oNgn02omoPh@0=omkOh?oNh>7og]oQomkP
hOoOh>7og]oPomSIf_oBdmCofM[JomgNg_oPh>7ogn3Qon3QhP02on3Ph@05
omgNgooIf]_od]?DomSIf_oNgn400ooOh>401ooNh>7og]oPomoPhOoOh>7o
g]oQomoPhOoNgn000_oOh>400ooNgn7ogn3QomkOh@04omoPh@07omkPhOoN
gn3og^3QomoPhOoNh>7ogn3QomkOh@02omoPh@09omkOhOoOh>7og]oQomoP
hOoOh>;og^3QomoPhOoNh>7og]oP00;ogn3Q00?og]oQomoPhOoNgn400_oO
h>401OoNgn7og^3QomkOhOoOh>7ogn7R00?ogn3Q00?og]oPomoPhOoOh>40
1OoOh>401OoNgn7ogn3QomkPhOoOh>7ogn3R00?ogn3Q00Gog]oPomoPhOoO
hN;ogn3Qon3Ph@02omoPh@08omoPh_oNh>7ogn3QomoOhOoOh>7ogn7RomoP
hOoPh>43omoPh@06on3Qh_oOh>7oh>3QomoPhOoOh>;oh>7R1?oOh>400ooP
hN;oh>3Qon3QhP02omoPh@0@on3PhOoPhN;ogn3Qon3Ph_oOh>7oh>3Qon3Q
h_oOh>7oh>3QomoPhOoOhN;oh>7RomoPhOoPhN;ogn3RomoPh@;oh>7R00?o
gn3Qon3Qh_oOh>400_oPhN800ooOh>7oh>7Ron3Ph@02on3QhP04on3QhOoP
hN;oh>7RomoPh@;oh>7R00?oh>3Qon3Qh_oOh>400_oPhN801OoOh>7oh>7R
omoPhOoPhN;ohN7R00?oh>7R00?ogn3Qon3Qh_oQhN800ooPhN800ooQhN;o
hN;Son3QhP03on3QhP07on7Qh_oPhN;ohN;Ron3Qh_oPhN7oh>7Ron7Rh`03
on3QhP0@on7Qh_oQh^?oh>7Ron7Qh_oPhN;ohN;Ron7RhooPhN;ohN;Son7Q
h_oPhN;ohN7Ron7RhooPhN;ohN;Son3QhP;ohN;S00?oh>7Ron7Qh_oPhN80
0_oQh^<02OoPhN;ohN;Son7RhooPhN;ohN;Son;Si?oQhnCoinSYonc]kP01
oo7bl`0000oob]3FolS=doo2b<oo_lG;oko6c?nnaL_o_/G:okk5bonma<[o
YJZ_ohnCUon//;Co^ko2olC8c?o7blh00_o6b/h08?o4b<co^ko3ojba]On>
TiOoXjV^okc1b?nna<[o_lG;oko4b_nna<[o_L?9okk4bOnn`lWo^l;8oj:X
[On>TiOo[;2cok^n`Oo4b<_oaLW=olG:c_o5b/goa<S;okZo`_n//KCoSY:F
oj:X[Onk`LOo_L?9okg4bOnm`/So_L?80onm`lT01_nj`LOoXjR]ohjBU_n[
[k?o^[k2ol?8c0;oaLW<00Woa/[=ol?7boni_/7oZZjcohjBU_nRYjco^l36
okc3b?nl`/P00_nk`/P00onl`/So_<?8okc2b002okc2a`03okc2b?nk`/So
^l?900;o^l;70_nk`/P00onl`/So_<;7okc2a`04ok_2b008ok_2aonk`LOo
^l;8ok_2aonl`/So^l77ok_2b?nl`/P2ok_2b006ok[2aonk`/Oo^l;8ok_2
b?nl`/So_<;70_nk`/L02?nk`/So^/77ok_2b?nk`LOo_<;8ok_2b?nl`/So
^l;80_nk`/L2okc2a`0=okc2b?nm`/Oo^l77ok_2aonl`/Oo^l77ok_2b?nk
`LOo^l;7okc2aonk`/Oo_<;8ok_2a`03okc2a`;o_<;800So^l;8ok_2aonm
`lSo_L;7okc2b?nk`/Oo_<;8okc3b0?o_L?800co_L?9okc3bOnl`lSo_L?9
okk4bOnm`lWo_<?9okg4bOnna<Wo_LG:okg4bOnnaL/2oko6b`07oko7bonn
a/_o`<K;oko6bonoa/co`<O=ol38c@02ol78c@04ol;9cOo2bLko`l[>ol?9
c@;o`lW>00Oo`/W?ol?:d?o3b/ooa<_@olC:coo4bm3oa/cA00?oa/c@01Go
alcAolO<d?o8c=7oal_@olO<dOo8c=3obLgAolW<d?o8c=3ob<cAolW<dOo9
cM7obLkBolW=dOo8cM7obLg@olW=d_o9cM7obLgBolW=dOo:c]400oo:c]80
3_o:c]7oblkBol[>d_o;c];obloCol_>d_o:c];ob/kCol[?d_o9cm7obloC
ol[>d_o;c];obloB0_o;c]<02Oo:c];oblkBol[>d_o:c];ob/oBol_>d_o:
c]7oblkBolc?d`02ol_>dP03olW>d_o:c];ob/kB00CoblkB00cob/gAol_>
d_o;cm;oblkBol[>dOo:c];oblkCol[>doo;c]?ob/gAol_>d_o;cm<2ol_>
dP03olW=d_o:cM;ob/gA00;ob/gB00cob/kBol[=dOo:cM7ob/gBol[<dOo;
cM7obLc@ol[=dOo:c];oblkBol_=dOo:c=42olW=d@0FolW>d_o:c]?obLgB
olS=dOo9c=7obLgBolW<dOo:cM;ob<_@olW<d?n>T9?oFEYLolW<d?o8bm3o
bLcAolW=dOo:cM7ob/gBolW=d_o9cM7obLkAol_>dP;ob/gA00GobLc@olW<
dOo9cM;ob/gBol[=d@04olW<d@0;olW;d?o9c=3oOGn2oeiOHOn=SY7oOGn1
ofQZK?o7bloob<_?ol[<dOo9cM400_o8c=403oo9c=7ob<c@olO<dOo8c=3o
b<_?olO;con5R8_oOh:6olK:coo8bm3oal_?olS;coo8c=3obLcAol[<d@02
olS;d009olO;d?o7c=7oalcAolS<d?o8bm3oal_@olO<dOo7c=3obLc@00?o
al_@0_o8bm03olO;d00AolO<d?o8cM7ob<c@olS<coo8bm3ob<cAolO;dOo7
c=7oa/[?olK9c_o4al_oiNKXonSYj_oWj>Woj>SZonOXj_oXj>X00_oXjNX0
1ooWj>Woi^OYomkNgooLg=goi>GVonSXjOoZj^/00_oZjn`01ooXjN[ohnCU
omcMgOoMg]ooinSYonOXj_oXjNX00_oWj>T00ooXjN[oinSYonSYjP03onOX
j@0=omgNgooLgMgohnCUonSYj_oYj^_oj^_[on[[k?oYjN[oi>CUomcLgOoM
g]ooinSYonSXjP02onOXjP?oj>WZ00ooinSYonSYjOoWinWoi^SYomgNgooL
gMkoi>CUonSXjOoZjncoj^_[on[[k?oXj>Woi>CUomcMgOoNg]l00_oWj>T0
0ooXjN[oinSYonSXjP02onSYjP;oinSY00?oj>WZonOXjOoXjNX00_oWj>T3
onSYjP04onOXjOoXjN[oinSYonSXjP;oj>WZ0_oWj>T00ooXjN[oj>SYonSY
jP02onOXj@?oj>WZ00CoinSYonOYj_oWj>WoinWZ0_oXjNX01ooWj>WoinSZ
onSYj_oXjNWoj>WZonOXj_oWj>T00ooXjNX00ooWj>Woj>WZonOXj@03onSY
jP;oinSY00?oj>WZonSYjOoXjNX00_oWj>X3onSYjP03onOXjOoXjN[oinSY
00Soj>WZ00?oinWZonSYj_oXjNX00_oXjNX00ooXj>[oj>WZonOXj@02onSY
jP03onWYj_oXjN[oj>WZ00Goj>WZ00GojNW[onWYj_oXjN[oj>WZonWYjP03
onSYjP03onWZjooXjN[oj>WZ00Goj>WZ0ooYjNX01_oXjN[ojN[ZonSYj_oX
jN[ojNW[onWZj`;oj>WZ00?ojN[[onSYj_oYjNX00_oXjNX01ooXjN_ojN[[
onWZjooXjN[ojN[[onSYj_oYjNX00_oYj^/2onSYjP03onWZjooYjN[ojN[[
00;oj>WZ0ooYj^/00ooXjN[ojN[[onSYjP03onWZj`;ojNWZ00?ojN[[onWZ
j_oYj^/01OoYj^/00ooXjN[ojN[[onWYjP02onWZj`04on[ZjooYj^_ojN[[
on[Zj`CojN[[00Goj^_[on[[k?oZjn_ojN[[on[Zj`02onWZj`07on[ZjooZ
jncojN[[onWZjooZjncojN[[on[Zj`02onWZj`06on[[k?oZj^_oj^[[onWZ
jooYjn_ojN[Z0_oYj^/01_oZjncojN[[on[[k?oYj^_ok>g^oo7bl`7oloCf
00001onl`l[obm7FolW?e_o9cmKob]3Fol[Aeoo9cmD00_o8cmD04oo8cM?o
XjN/oijRY_nn`lKocm?GomKJg_oGfmooe]WMoloCe_nn`/GoWj>Voj6VZoo6
cM?oalgDolW?eOo8c]Cob]3FolS>e?o:d=@00_o9cm@07Oo7cM;oaLcBoj2V
Z_nNXZGo_/75oloCeooEfMcoem_OomGJg_o>dmKo_L75oijRY_nQYJWoalc@
olO=doo8cmCob<kColW>e?o7cM?obLoDolS=doo9cmCoalcBolK<d_nPYZ[o
WJ6Tokg1a?o>d]KoeMWL00;oe][M017oc];Eokg1a?nMXJGoX:FYolG<dOo6
c=7ob<kColO=d_o8c]CoalkColO?e?o6cM?ob<oDolK=d_o8c];oalgColO>
e002olK=d`1;olO<dOo8c]Coa/cBolS?doo7cM;ob<oColK=doo7c]CoaLcB
olO>e?o6cM;oalkBolK=doo7cM?oa/gBolO=doo6c=;ob<kColK<d_o8cM?o
a/cAolO>e?o6cM?oalkColK<d_o8c]?oa/gBolO=d_o5cM;oa/gColK=d_o7
cM?oa/cBolS>doo6c=7ob<kBolK<d_o7c]?oalcBolO>doo6c=7oalkColK<
d_o7cM;oa/cColO=doo6cM;oalgColK<dOo8c]?oa/cAolS>d_o6c=7ob<kD
olO=d_o7c]?oa/cAolO>doo6cM;ob<kBolS=d_o8c]?oalgBolS>doo6c=7o
b<kColO=d_o8cm;oa/cAolS>e?o6cM?oalkColO=dOo9cmCoalgB00?ob<kC
03Sob<kBolS>e?o7cM?obM3DolO>doo9d=CoalkColW@eOo8cm?obLoEolS>
doo:d=GobLoDol[AeOo9dMKobm7FolW@eOo:dMKobM3Eol_Beoo9dMKobm?G
ol[Be_o<e=Soc=?HolgEfOo=e=SocmKJolgDfOo?e]Woc]GJoloFfoo?eM[o
d=KKom3Df_oBe]_od=GJom7Gf_o@eM[od]OLom7Ff_oCem_odMKJomCHg?oB
em[oe=SKom?Gg?oCf=cod]OKomCGg?oCem[oeMWLom?Gf_oEf]codmSLomGJ
gP;oeMWL01Coe=SKomKIgOoDem_oeMWLomCIgOoDfMkoe=SLomGIgOoDf=co
e][MomGHg?oFf]goe=SLomKJg_oDfMgoeM[NomCHg?oFf]koeMSMomKJg@;o
e]WM05ooeMWLomKJg_oEf=coe][NomGHg?oGf]goeMSLomOJg_oEfMgoe][M
omGHg?oFf]koeMWLomKJgOoFfMgoemWNomGHg?oFfMgoeMSLomKJg_oEf=go
em[MomGHgOoGfMkoeMSLomKHgOoDem_oe][MomGHg?oFfMcoeMSLomGIgOoD
em_oeMSLomCGfooFfMkoeMSLomKJg?oDf=_oe][MomGIg?oEfMgoe=OLomKI
g_oDem_oe]SKomGHg?oFf=goe=SLomKHgOoDem[o_;o2ojBWZ_oEf=_oe=SK
omGIgOoEf=coeMSMom?GfooEfMkoeMSMomKIgOoEf=goeMSLomCGfooEf=go
e=OKomGHgOoDem_oeMWLom?Gg?oEfMgoe=OKomGHg?oDem[oe]WMom;FfOnc
]KWoR8^=oi:DUonXZjkodmOKom?FfooEf=codmOKomGIg?oDe]_oeMSMom?G
fooCemcodMGJomCGg?oBeM[o/kJiojnb]@02om;Ff`0=om?GfooBe][oe=OL
om?Ff_oFfMcodmKJomCGg?oCe]_odmOLom7Ff_oDf=codmKKomCGf`02om?G
f`0Fom;Ff_oDem_od]GJom?Gg?oBe][odmSKom;FfooDemcodmKKom?Gg?oC
e][oeMSLom?Ff_oCem_od]OLom;GgOoAe]_od]KKom;EfOoAdmOojN_]ooCe
m@;ol_?d05Kol?7coo7bloo`lO;ol_?doo3al_oal_;oknoaonSXjOoUi^Oo
kNk^ono`lOobloCoko3`onk^k_oUi^Koj>WZonk_l?oal_?oko3aoo7bm?o`
lO;olO;boo7alooal_?ol?7boo7bloo_lO;olO;cong^kooXjNWoiNKVong^
koo`l?7ol_?dono`lOo^k^ooiNKVonSXj?o^ko3olO;coo3al_oal_?ol?7b
oo7bloo`lO;ol_?coo3al_oal_?ol?7boo7bloo]k^ooj>WZonGVi_o]k^go
l?7boo;cloo`l?7okNk^onGViooXjN[ok^o`oo;bloo`lO;olO;doo3alooa
l_?ol?7boo;bm?o`lO;olO;boo3blooal_?ol?7boo7bloo`lO;olO;doo3a
l_oblo?ol?7boo;cm?oalO;olO;cono`l_oal_?ol?7boo7blP;olO;c00ko
l?7boo7bloo`lO;olO?doo3al_obl_?ol?7boo7bm?o`lO;olO;coo3al_ob
l_Col?7boo7blP;olO;c00Sol?7boo7bloo`lO;ol_;doo3al_oblo?ol?7b
oo;cm0;olO;c00Col?7boo;cm?o`lO;olO;b0_oal_<03_o`lO;olO;coo3a
l_oal_Col?7boo;cloo`lO;ol_;doo7blooal_Col?7boo;cm?o`lO;olO?c
0_oal_<04?o`lO;olO;coo3al_obloCol?7boo;cloo`lO;ol_?doo7bloob
l_?ol?7boo;cm?oalO;ol_?coo7bloobl_@2oo7bl`0/oo3al_obloColO7b
oo;clooalO;ol_?doo7bloobloCol?7boo;cm?oalO;olO?boo7bloobloCo
lO;coo;blooalO;ol_?doo3al_oblo?olO;boo;cm?oal_?ol_?doo3al_oc
loColO;coo;clooal_?ol_?doo7blooblo?olO;boo;cm?o`lO;oloCdoo7b
loobloColO;coo;cm?oalO;olo?eoo7blooblo<2oo;cm00Poo7bloobloCo
lO;boo?cm?oal_;oloCdoo7bloocloCol_?coo?cm?oal_?oloCeoo7blooc
lo?ol_?doo?cm?obl_?olo?doo;bloocm?GolO;coo?dm?oal_?oloCeoo;c
m?ocloColO;coo?dmOoal_?oloCdoo;cm?ocm?@2oo;cm00Goo;bloocm?Go
l_;cooCdm?obloColoCeoo;cm?ocm?GolO;coo?dmOobl_?oloCdoo;cm?ob
m?ColO;coo;cm?oal_?oloCeoo7bloocm?ColO;coo?dmOoalo<00_oblo@0
0ooaloCol_?doo;cm002oo;cm07olO?d0Oo]ko000005oi^V/?o8c]?oaL_A
oko6c?nnaLX00_nna<T05OnnaL[o_LC9okg3b?ng_<7oVYjSoiNJW_nb][Wo
`<?7olK:cOo0a<Oo/[FhoiNKW_nKWj?o][c1okg3b?nm`lWo_/?9okg3bOnm
`l[o_/C:okg3b@02okk3b@0Dokg3b?nl`lSo];_1oiVNX_nGVYgo/KFhoko3
aoo5bLgo_/?6ok6e^OnFVYgoVIjRokFj`?nl`/Oo_/;8okg3bOnl`lSo_L?9
okg3b?nl`/P3okg3b00?okc2aond^[ooVIjRoiFIWOna];So_l?6olG8bonn
`lKo/KFhoiFIWOnIWZ?o]K_0okc1a_nl`/So^l;800Go_<;80_nl`lP03_nk
`/Oo^l;8okc2b?nl`/So_L?8okg2b?nk`/Oo^l;8okc2b?nm`lSo_<;8okc2
aonl`/So^l770_nl`/P4okc2a`05okg3b?nm`/Oo_<;7okc2aonk`/L00_nl
`/L00onk`/Oo_<;7okc2aP02okc2a`04ok[1aonk`/Oo^l;7ok_1aP;o_<;7
00?o_<;6okg2aonk`LL00_nl`/P2ok_2a`0<ok_1aonk`/Oo^l;7okc2a_nl
`/Oo_L;8okc2aonm`/Oo_<;7okc2a_nl`/Oo^l;70_nl`/L01?nk`/Oo_<;7
ok_1aonl`/L2okg2a`;o_<;700Co^l76okg3aonm`/Oo^l;70onl`/L01?nl
`LSo^l77ok_2aonk`/L2okg2a`05okc2aonm`/So_L?7okc2aonm`lP00_nl
`/P02Onm`lSo_L;8okg3b?nm`lSo_L;7okg3aonl`/Oo_L?7okk3b002okc3
b007okk4b?nm`lSo_L?8okg4b?nla<So_LC9okg4bP02okk5b@03okk5b_nn
a/[o_/G:00;o_lK;00So_lK:oko6boo0alco`<O<ol78cOo0algo`LO<ol;8
c0;o`LW=00Ko`/W=ol;9c_o4bLkoa<[=olG:c_o6bll2olG;c`0DolG:coo5
b/koa/_@olK;coo6blkoalc?olO<d?o8c=3oalc@olO;d?o7c=3oalcAolS<
d?o9c=3ob<c?olS<d?o8cM7oalc?olW<dOo9cM42olW=d005olS=d?o9cM7o
bLgAolW=dOo:cM400_o9cM400oo9cM;obLc@ol[=d@02ol[=d@04ol[>d_o;
c];ob/gAol[=dP;ob/kA0_o:c]801_o;c];ob/gAol[>dOo:c];ob/gAol_=
dP;oblgA00KoblkBol[>dOo:cM3ob/gBol[=dOo:c]45ol[=d@06ol[>dOo9
cM3obLgAol[=dOo:c=7ob/gA0_o:cM000oo;c]7ob/gBol[>d@02ol[=d@05
ol_>dOo:cM7ob/gAol[=dOo:c=000_o:cM401_o:c=3oblgAol[=dOo:cM3o
b/cAolW<d@Cob/gA00?obLcAol[=dOo;c]800_o:c=001?o:cM7ob/c@ol[>
dOo:cM42olW<d008ol[=d?o9cM7obLcAolW<d?o:cM7obLcAol[<d?o9cM02
olW<d005olW;d?o8bloobLc@olW<d?o9c<l00_o9c=002oo:c=3obL_?olS;
coo8bm3oal_@olS;d?o9bm3ob<_?olS;d?o8c=3ob<_@00;obLc@00Cob<c?
olS<d?o9cM3obLc@0_o7bm000oo8c=3oal_?olO;c`05olS;c`;obLc@0_o7
bll2olS<d004olS;d?o8b/ooal_@olS;c`;obLc@00Cob<_?olS;d?o8bm3o
al_?0_o8bll01Oo5b<coeMOJonSYj_oWj>Woi^OX00;oiNKW00CoiNGVonGV
iooUi^Ooi>GV0_oUi^L01ooNgn3of]_LomOGf?oDe=Goe]OHom[Kg?oOh>40
0_oTiNL01?oUi^Koi>GVonCUiooUi^L2onCUiP0^onGViooTiNKoiNKWonGU
iooTiNKoi>KWonCUi_oOh>7of]_LomKGeooEeMKoe]OHom[Kg?oOh>7oi>GV
onGUi_oUi^Ooi>GVonGViooUiNOoi>GVonGViooTiNKoiNKWonCUiooTiNKo
iNGWonCUi_oTiNOogn3Qom[JfooFemSoeMGFomKGeooKfmcogn3QonCUi_oU
i^Ooi>GVonGViooTi^Ooi>KVonGViooTiNKoiNGWonGVi`;oi>GV00OoiNKW
onCUi_oUi^OoiNKWonCUi_oTi^Ooi>GV00;oiNKW00Koi>KVonCUiooTiNKo
i>KWonGViooTiNH2onGVi`0;onCUi_oUi^OoiNKWonCUi_oUi^Koi>GVonGV
iooUiNOoi>GVonGUiooUiNH00_oUi^L01?oUiNKoiNKWonGViooTiNH2onGV
i`03onCUi_oUi^Ooi>GV00OoiNKW00Coi>GVonGViooUi^OoiNGV0_oUi^L0
0ooTiNKoiNKWonGUiP07onGVi`07onCUi_oUi^OoiNKWonGVi_oVinOoiNKW
onGViP08onGVi`06onKViooUi^KoiNKWonGViooUiNKoi^OW1?oUi^L00ooV
i^OoiNKWonGVi`03onGVi`06onKViooUi^KoiNKWonKViooUi^Ooi^OX1?oU
i^L01ooVinOoiNKWonGViooVi^OoiNKWonKViooVinP00_oUi^L00ooVinOo
iNKWonKWj004onGVi`0@onKWj?oVi^OoiNKWonKViooUi^Ooi^KXonKWiooU
i^Ooi^KWonKWj?oUi^Ooi^OXonKViooUi^Ooi^OXonKVi`;oi^OX00?oi^KW
onKWiooVi^L00_oVinP01ooVi^Ooi^KXonKWj?oVi^OoinOXonKWj?oVinL0
1?oVinP02_oVinOoi^OXonKWj?oVinSoinOXonKWiooVinSoinOXonKWj?oW
j>P2onKWj003onOWj?oVinSoinSX00Koi^OX00Coi^OWonKWj?oVinSoiNKW
0_oVinP01ooUi^Ooi^OXonGViooUi^OoiNKXonGViooTiNH00ooUi^L01?oT
iNKoi^OXon_]k_o]ko01on3Si@0000SoK7V4olO=d_o3bLko_LC8okW0aOni
_l?o^[o4okZna0;o^Kk300[o^Ko4okRoa?nQYj_oTIFIoh>6R_mkOh;oPhN;
oi2EVOnQYj_o^;k30_ni_/<02?ni_lCo^;k3okRoa?nh_/?o^Ko4okRoa?ng
_L?o^Kk40_ni_/<03_nh_/?o]kc2oj:VZonAUIWoPXJ9ogYnPOn3Qh[oTIFI
oj6VZong_<7o^;k3okVn`ong_L;o^;g30_nh_L801?nh_/?o]kg2okRn`_nh
_/82okNm`P0<okRm`_ng_<7oXJJZohnDV?n2QX[oNgn2oh65ROn@U9SoX:F[
okJl`Onh_/;o]kg10_ng_L802Onf_<;o]kg2okRm`_ng_<;o^;g2okJm`_ng
_/;o]kg2okJl`P02okNm``;o]kg200Wo]Kg2okJm`_ng_L;o]kc1okJl`Ong
_L;o]kg1okNm`_ng_<400_ng_L802_nf_<;o]kg2okNl`Ong_<7o]kg1okNl
`Ong_L;o][g2okJl`_ne_<42okJl`@05okRm`_nf_<;o][c1okFl`Onf^l40
0_ng_<800onf_<;o][g2okJl`@02okNl`P0>okJl`Onf_<3o][g2okJl`Ong
_<;o]kc1okNm`Ong_L;o][c1okNl`_nf_<;o][c1okRm`_ng_<82okNm`P;o
][c100Oo]kg2okJl`Onf_<;o]kc1okNl`_ng_L7o]kc100;o]kg200?o][c1
okJm`Onf_<400_ng_L801_ng_L7o]kg0okNm`_nf_<;o]kg2okJl`P;o]kg1
01ko][c1okNm`Onf_<7o]kc1okNm`Onf_<7o]kg1okRm`_nf_L7o]kc0okNm
`_ng_<7o^;g2okRm`Onh_/;o]kk2okJl`_nh_L;o]kg1okNl`_nh_L;o]kg1
okNm`_ng_L?o]kg2okNm`Oni_/;o^Kg2okVn`_nh_L82okRn``08okNm`_ni
_/?o^Kk3okVn`oni_lCo^;o4okW0a?nj`<@2okW0a004ok[1a_nk`LKo^l;6
ok_3aP;o_<?800ko^l?7okc4aonl`lOo_<?7okg4b?nna<Oo_lG9ol35bOo0
a<So_lG8ol35bOnoaLWo`<G:ol35b@;o`LK:00Ko`LG:ol;6b_o1a/Wo`<G9
ol;6b_o3a/T2ol?6bP;o`LK:0oo3al/02Oo3a/[oa<K:olC7boo3al_o`lS<
olC7boo4al[oa<S;olC7b`04olC8b`0<olG8c?o4b<coa<S<olC8boo4b<co
aLS<olC8boo5b<_oa<S;olC8c?o5b<coaLO;0_o5b</01Oo4al_o`lO:olC8
boo5alcoaLS<00?oa<S;00Koa<O;olG8boo5al_oa<O;olG8c?o5b</2olG8
c0;oa<O;00SoaLS;olC7boo4b<coa<O:olC7boo5al_oa<O:olG8c0;oa<O;
00?oaLS;olC7b_o3al/00_o4al/02Oo3al_oa<O;olC7boo4b<coa<O;olG7
boo5b<_oa<O:olG7b`02olC7bP09olC8c?o3a/_oa<O;olC7c?o3al[o`lK:
olC7b_o3al[oa<O<00;oa<O:00go`lO;ol?5boo3a/_o`lK:olC6bOo3a/_o
`/K:olC7b_o3al_o`/K:ol;5bOo4a/Wo`lK:00;oa<K;0_o3a/X2ol;6bP0<
ol?6bOo4a/Woa<O:olC6b_o3al_oa<O<ol?6boo1aL[o`lK:ol?5bOo3a/[o
`/G90_o2a/X00oo2aL[o`lK;ol?6bP02ol?6bP08ol;5b_o1aLWo`/K:ol;6
b_o1aLWo`/K:ol75bOo2a//2olC6bP0:ol?6b_o1aLWo`/K:ol;6b_o2a/Wo
`/K:ol34aoo3a/Wof]_Lon?Si0OohN;S00KohN7Ron7RhooQh^?oh>7Ron7R
hooQhN82on7Rh`03on7Rh_oQhN;ohN;S00;ohN;S00Coh>7Ron7RhooQh^?o
h>7R0_oQh^<00ooQhN;ohN;Son3Qh`02on7Rh`;oh>7R00CohN;Son3Qh_oQ
h^?ohN7R0_oQh^<01_oPhN;ohN;Son7RhooPhN?ohN;Son7Qh`;ohN;S0_oP
hN83on7Rh`06on7Qh_oQh^?oh^;Ton3Qh_oQh^?oh>;R1OoQh^<2on3QhP?o
hN;S00Coh>7Son7RhooQh^?oh>7R0_oQh^<00ooPhN;ohN;Son7Rh`03on7R
h`05on3Qh_oQh^?ohN7Son7RhooPhN801OoQh^<00ooQhN?ohN;Son7RhP02
on7Rh`;oh>7R0ooQh^<00ooQhN;oh^;Son;Rh`09on7Rh`04on3Qh_oQh^?o
hN;Son;Rh`;ohN;S00?oh^;Son7Rh_oQh^<01ooQh^<00ooPhN;ohN;Son7R
h`03on7Rh`03on;Si?oQh^?oh^;S00;ohN;S00?oh^;Son7RhooRh^<00ooQ
h^<01_oRh^?ohN;Son;RhooQh^?oh^;Son;Si0CohN;S00Coh^;Ton7RhooR
h^?oh^;S0_oQh^<02?oRh^CohN;Son;RhooQh^?oh^?Son;Si?oQh^?oh^?S
0_oQh^<01?oRh^?ohN;Son;ShooRhn<2on7Rh`04on;ShooRh^?oh^?Son;R
h`;oh^?T00Coh^;Son;ShooQh^?ohN;S0_oRh^<03_oRhn?oh^?Ton;RhooQ
h^?oh^?Ton;RhooRhnCoh^;Son;ShooRhnCoh^;Son;Si?oRhn?oh^;S1?oR
hn@00ooRh^?ohN;Son;Si002on;Si004on;RhooRhnCohnCTon;Sh`?oh^?T
00?ohn?Ton;Si?oShn@00_oRhn@02OoRh^?oh^?Ton;Si?oShnCoh^?Ton?S
i?oSi>Coh^?Ton?Ti002on;Si0;ohn?T0_oSi>D00ooRhnCohN;Son;Si002
on;Si00;on;ShooRhnCohn?Ton7ShooRhnCoh^?Son7RhooRhnCohN;Son7S
hooQh^<01OoPh^<01_oOhN;oh>7Ron7Ri?oSi>KojN_/onc^l07o`lS:0000
4_lbA53oU9nWolG:c_noaLWo_L?8okk4b?nn`lOo_L;7okk3b?nm`lOo_/;7
okk3b?nm`lOo_L;7okc2aonk`LKo_<;7okg2b0;o_<;700Go_L;8okk3b?nl
`/Oo_<;7okg3b002okg2a`04okg3aonl`/So_<;7okg2a`?o_<;70_nl`LL0
7?nk`LKo_<76okc1a_nl`LOo_L;7okc2aonl`LKo_<;6okc2aonl`LKo_<;7
okc1aonl`/Oo^l;6okc1a_nl`LGo_<;6okg2aonk`LKo^l75okc2a_nl`LKo
^[o5ok_0aOnj_lGo_<76okc2aonk`LH2okc1aP0:ok_1aOnk`LKo^l76okc2
a_nl`LKo^l76okc1a_nk`LKo^/76ok_2aP;o^l7600Ko_<77okc1aOnl`LKo
^l76ok[0a_nk`LD2ok_1aP0;ok_1aOnk`<Go_<76okc1a_nk`<Go^l76ok[0
a_nj`<Go^l77ok_0a_nk`LH00_nk`<D2ok_0aP0=ok_1a_nj`<Ko^/35okc1
a_nk`LKo^/35ok[0a_nj`<Go^l35okc1a_nk`<Go^l36ok[0aP02ok[0a@;o
_<7600co^l75ok_0aOnl`LGo_<75ok_0aOnk`LKo^l75ok_0aOnk`<Ko^/35
ok_1a_nk`<H2ok_0a@06ok_0a_nk`LKo^l35ok_0aOnl`LKo^l750_nk`<D0
1?nk`LGo^l35ok_1a_nj`<D2ok_1aP;o^l3500Co_<35ok_1a_nk`LKo^l75
0_nl`LH3ok_0a@0<okc1aOnl`LKo^l35ok_1a_nk`LGo^l36okc1a_nk`LGo
_<75ok_1a_nk`<Ko_<760_nl`LD01_nl`LKo^l76ok_0a_nl`LKo^l75ok_1
aP;o_<7600?o_<75okc1a_nl`/H00_nl`LD2okc2aP07okc1a_nl`/Ko_<;6
okc1a_nm`/Oo_<76okg2a`03okc2aP04okc3aonm`lOo_L;7okc3a`?o_LC8
00?o_/C8okg4b?nma<P00_nna<P2oko5b@09okk5bOnoaL[o`<K:ol37b_o0
a/[o`LK;ol77c?o1al_o`LS;00;o`/S<00Co`lS<olC9c?o2b<co`lW<0_o3
b<d03_o4b<goa<W=olG:cOo5bLgoa<W<olG:c_o6bLgoa/W<olO:cOo7b/ko
al[=olO:c_o5bLkoa/_>0_o7b/h04oo6b/gob<_>olW<coo8blooal[=olS;
c_o7blkoa/_>olO<coo7bloob<_?olW<coo8bloob<c?olS;coo8blkob<_?
olW<d?o8c=000_o8bll02Oo9c=3ob<_?olS;c_o8c<oob<_?olW;coo9c<oo
b<_?olS<c`02olW<c`08olW;coo9c<oob<c?olS;coo8blkob<_?olS;c_o7
b/h2olS;cP;ob<_?00?ob<_>olW;c_o9blh00_o7blh02_o9c<oob<c?olS;
c_o8blkob<_?olO;c_o7b/kob<c?olS;c_o8b/d2olS;cP0;olS<coo8blko
b<_>olS:c_o8blkob<_?olS;c_o8b/kobL_?olS:c_o7b/h00_o7b/l01?o7
b/kob<[>olO:cOo7blh2olS:cP09olO:c_o6b/koal[>olO:cOo7bLgob<[>
olS9c_o7bLkoal[>00;oa/[>00Soal[>olO:cOo8b/kob<[>olO:c_o7b/oo
al_>olO:cP;oalW=00coal[>olK9cOo7b/gob<_=olO:c_o7bLgoal[=olK:
cOo7b/goalW=olG9cOo5bLh2olO:cP04olK9cOo5bLgoa/[>olO:cP;oal[=
00Coa/[>olK9cOo7b/koaLW=0_o5b/d01?o4al[oblg?omkOhOoYj^/2onSY
jP03onWZjooXjN[oj>WZ00?oj>WZ00?ojN[ZonSYj_oYjNX01?oXjNX01_oY
jN[oj>WZonSYj_oYj^_oj>WZonSXjP?oj>WZ00?ojN[ZonSYj_oXjNX01?oX
jNX01OoYjN[oj>WZonSYj_oYj^_ojNWZ00Coj>WZ00?ojNWZonSYj_oXjNX0
1?oXjNX01_oYjN[oj>WZonSYj_oYj^_ojNWZonSYjP;ojNWZ00Coj>WZonWZ
jooXjN[ojNWZ1?oXjNX01?oYjN[oj>WZonSYj_oYj^/5onSYjP03onWYj_oX
jN[oj>WZ00?oj>WZ00GojNWZonWZjooXjN[oj>SZonWZj`05onSYjP03onWY
j_oXjN[oj>WZ00Coj>WZ00_ojNW[onSYj_oXjN[ojN[[onWYj_oXjN[ojN[Z
onWYj_oXjN[ojN[[onSYjP02onWYjP09onSYj_oYjN[ojNWZonWZj_oYjN[o
j>WZonWZjooYjN[oj>WZ00;ojN[Z00CojNWZonWZjooXjN[ojNWZ0ooXjNX0
3_oYjN[ojN[[onSYj_oXjN[ojN[[onWYj_oXjN[ojN[ZonWZjooYjN[ojN[[
onSYj_oYj^_ojNWZ0_oXjNX01ooYjN[ojN[[onWYj_oXjN[oj^[[onWZj_oX
jNX00_oYj^X01?oXjN[ojN[[onSYj_oYj^/3onWYjP;ojN[[00GojNWZonSY
j_oYj^_ojN[[onWYjP02onWZj`07onWZj_oYj^_oj>WZonWZjooYjN[oj>WZ
onWYjP02onWZj`05onWZj_oYjN[oj^[[onWZjooYjNX00_oYj^/03_oYj^[o
jN[[onSYj_oYj^_ojN[ZonWYj_oYj^[ojN[[on[ZjooYj^_ojNW[on[[k?oZ
j^_ojN[Z0ooYj^/01_oZj^_ojNWZonWZjooYj^_ojN[ZonWZj`;oj^[[0_oY
j^/00ooZjncoj^[[onWZj`02on[Zj`07onWZjooZjn_oj^[[on[[jooZj^_o
jN[[on[Zj`02on[[j`;ojN[[00?oj^_/on[Zk?oYj^/00_oZjn/00ooZj^_o
j^_/onWZj`02on[Zj`09onWZjooZj^_oj^[[on[ZjooYj^_oj>[Zon[[k?oY
j^_oj>[Z00;ojN[[00Goj>[ZonWZjooXjN[oj>[ZonSYjP04onOYjP09onKX
jOoUinSoinSZonKXjOoVinSoi^SYonW[k?o]k^oohnKX007oZZfa00001?lN
<D?o@E1LoiBMY_o8cM82olO=dP03olS=d_o8cM7ob<gB00Cob<gA00GoalgA
olO<dOo7cM;ob<gBolS=d@02olO=d@CoalcA00WoalgAolK<dOo7cM7oalcA
olO=dOo7c=7oalc@olO<dOo7cM400oo7c=402oo7c=3oa/c@olO<dOo7c=7o
a/cAolK<d?o7c=7oa/cAolO<dOo7c=3oa/_@00;oalcA00goa/cAolO;d?o7
c=3oa/c@olK;d?o6c=7oa/_@olO<d?o6blooa/_@olG;d?o6bm7oa/c@00;o
a/_@00Ooa/_AolK;d?o6blooa/c@olG;d?o6c=3oalc@00;oa/_@00WoaL_?
olG<d?o5bm3oalc@olK<d?o5bm3oa/_?olK;d?o6c=000_o6bm000oo6bloo
aL_@olK;d002olK;d003olK:coo7bm3oa/_?00;oa/_@00?oaL[?olG;d?o5
bm000_o5bm02olK;d00<olG:coo6bm3oaL_@olK;d?o5blooa/_?olG;coo6
c=3oa/_?olG:coo6blooa/_@0_o6bll00oo6bm3oaL_@olG:c`03olK;c`03
olG;coo5bm3oaL_@00;oa/_@00Soa/[?olK;d?o6bm3oa/_@olK;coo6bm3o
aL_@olG;c`?oa/_?00?oaL_?olK;coo6bll00_o6bm000oo5b/ooa/_@olK;
d003olK;d008olK:coo5b/ooa/_@olG;coo6bm3oa/_?olK<coo6bll2olK;
d003olK:coo6blooal_@00;oa/_@00Ooal_@olK;coo6b/ooa/_@olG;d?o6
blooaL_?00;oa/_?00Goal_@olK;d?o5b/ooa/_@olO;d002olK;d003olK<
d?o6bm3oaL_?00;oa/_?00Coa/c@olK;coo7c=3oa/_@0_o6c=001?o6bloo
al_@olO<d?o6c=03olO<d00;olK;coo7c=3oalc@olK<dOo6c=3oalgAolO=
d?o7cM7oalcAolK<d?o7cM000_o8cM402_o7cM7ob<kBolO=d_o7cM7ob<kB
olW>d_o9cm;ob<kBolW?doo8cm<2ol[@e00>olW?doo:d=Cobm3Dol_@eOo;
dMGoc=;FolcAeOo;dMKoc=;Fol_BeOo<d]Koc=7FolkCeOo>dmH2oloCe`05
olkBe_o>dmKocm?Gom3Df?o?dmL00_o@e=L01oo@dmOodMCHoloCeoo@e=So
d=CGom7Ef?o@e=P01?oAeMP3om;Ef003om?EfOoBeMSodMGH00;od]GH00[o
d]GIom;Ef?oBeMWod]GHom?FfOoCeMWod]CHom;EfOoCe]WodmKJ0ooCe]T2
om;Ef@Cod]GH00OodMGHom;EfOoBeMWod]CHom?Ef?oCe]WodmGH00?od]GH
0_oBeMT2om;Ef00=om7Df?oBeMSod]GHom?Ff?oBeMSodMCGom;Ef?oBe]Wo
d]GIom;Ef?oCe]Sod]GHom;Df003om?Ef00Bom;Ef?oCeMWod]GHom;Ef?oB
e=SodMCGom7Df?oBeMSod]CHom;Ef?oCeMSod]CGom7DeooBe=Sod]CGom;E
f?oAe=Sod]CH1?oAe=P01ooBe=Sod]GHom;Ef?oBe=Sod]GIom;Df?oAe=L0
0_oBe=L2om7De`0;om;EeooBe=OodMCHom7Deoo@dmKod=?Hom7Df?oAdmOo
d=?Gom7Df?oAe=L00_o@dmL02?o@dmKodMCGom7DeooBe=OodMCGom7Df?oA
e=Ood=?F0_o@dmL02OoAe=Ood=?FoloAe?oBe=Kog^3Ron[[kOo`lO;oloCe
oo?dm002oo?dm@05ooCdmOocm?GoloCdoo?dmOodm?D00_ocm?D00oodmOGo
loCeoo?dm003oo?dm@06oo?cm?ocm?GoloCeooCem_ocm?Golo?d1?ocm?D0
0oodm?GoloCeoo?dm003oo?dm@06oo?dm?odm?GoloCeooCdmOocm?Golo?d
1?ocm?D01?odmOGoloCeoo?dm?odm?D2oo?dm@06oo?cm?odm?GoloCeooCd
mOocm?GoloCd1?ocm?D01?odmOGoloCeoo?dm?odm?D2oo?dm@06oo?dm?od
m?GoloCeooCdmOocm?Golo?d1?ocm?D00oodmOGoloCeoo?dm003oo?dm@0>
oo?dm?ocm?GoloCeooCemOocm?GoloCdoo?dmOodm?GoloCeooCdmOodmOGo
loCeoo?dm?odm?D3oo?dm@06ooCemOocm?Gom?Gfoo?dmOocm?ColoCe0ood
m?D00oodmOGoloCeoo?dm003ooCdm@05oo?dmOodm?GoloCeooCem_odm?D0
0_ocm?D01?odm?GoloCeoo?dmOodmOH2oo?dm@?om?Ce00SoloCeooCemOoc
m?Gom?GfooCdmOocm?Gom?CeooCem@;om?Ce00Com?Gfoo?dmOocm?Gom?Ge
0_odm?D02?ocm?Gom?Geoo?dmOodmOKom?Ceoo?dmOodm?Gom?Ge0_odm?D0
1?oemOKom?Ceoo?dmOodmOD2ooCdm@08oo?dmOodmOKom?CeooCem_odmOGo
loCeooCdmOodmOD2ooCdm@04ooCem_odm?GoloCeooCemP;om?Ge00Som?Ce
ooCem_odm?GomOGfooCem_ocm?Gom?GeooCemP;om?Ge00comOGfooCemOod
m?Gom?GfooCemOodmOKom?CeooCem_odmOGomOGfooCem_odm?D4ooCemP04
ooGfm_oemOKom?GeooGemP;om?Gf00Som?GeooGem_odmOKomOKgooGem_od
mOGomOGfooGfmP;omOGf00?omOKgooGem_odmOD00ooemOH01_odmOKomOGf
ooCem_oem_Kom?GfooCdm@Com?Gf00ComOKfooCem_ocm?Gom?Ge0oocm?D0
1OocmOKoloCeoo?emOobm?Gol_?d00;ol_Cd00Kol_?doo7cm?obloColO?d
oo7blooalo@2oo7bl`06oo3blooal_ColO;coo;cm?oTi^So/KBg0On^/[H0
0009oa`^?_lL:cSo;CU4ofE`N_nEWjOo^;k3olO<d?o6blooalc@00;oa/_?
00Koal_?olK;coo6blooa/_?olO;d?o6b/l4olK;c`09olK;c_o7blooa/_?
olK<d?o5blooaL[?olK;coo6b/koal_?00;oa/_?00goaL[?olK:c_o6b/ko
al_>olO;coo6b/ooa/_?olG:c_o5blooaL[?olG:c_o6b/ooaL[>00;oa/[>
00?oa/_?olG:c_o6blh01?o6b/h01Oo5b/ooaLW>olK:c_o6b/koaLW>00;o
aL[>0oo6b/h01Oo4bLkoaL[>olG:c_o5b/koaL[?00;oaL[>00goaLW>olG:
coo5bLkoa<W>olG:c_o5bLkoaL[>olG9c_o5b/koa<W>olG:c_o5bLkoa/[>
00?oaL[>00Woa<W>olG:c_o4bLkoa<W=olG:c_o5bLgoaL[>olC9c_o5b/h0
0_o4bLh01_o3bLgoaL[>olG:c_o5bLgoaL[>olC9c@;oaL[>00Woa<W=olG:
c_o5bLgoaL[=olG9cOo5b/koaLW=olK9cOo5bLd00_o5b/h05?o5bLkoaL[>
olG9cOo6b/koaLW>olC9cOo4b/koa<W=olG:c_o5bLkoaL[>olC9c_o5b/ko
aLW=olK:c_o5b/koaLW=olG:c_o5bLgoa/[>0_o5bLd02?o5b/koaLW=olG:
c_o5bLkoaL[>olC9cOo5bLkoa<W=0_o5b/h02?o4b/goa<[>olC9cOo5b/ko
aLW>olG9cOo5b/koa<W=0_o5b/d02Oo5b/koa<W=olC9cOo4bLgoaL[=olG:
c_o5bLgoaL[=olG9c@02olG:cP09olC9cOo5b/koaLW>olG:c_o5bLkoa/[>
olG9cOo5bLkoa<W>00;oaL[>00?oaLW=olG:c_o5bLd00_o5b/h01oo5b/go
aL[>olG9c_o6b/koaL[>olK:c_o5b/d00_o5b/h01_o6b/koaL[>olG:c_o6
b/koaLW>olK:cP;oaL[>00Goa/_>olK:c_o6b/koa/[>olK;cP02olK:cP07
olG:c_o6blkoa/_?olK:c_o6blooa/_>olO;c`02olK;c`0BolK<coo6bloo
a/c?olK<coo6c=3oa/_?olO<d?o7cM3oalgAolS=dOo7cM7ob<gAolS=d?o8
c];ob<gAolW>dOo:cm;obLoB1?o;d=<01oo;d=Cobm3Colc@e?o<d=Coc=3C
olgAe?o<d=@00oo=dM@01Oo>dMGocM3DolkAeOo>d]Gocm;E00;oc]7D00Co
c]7EoloBeOo@d]Gocm;D0_o?d]D02Oo@dmGocm;EolkBeOo?d]Gocm;Dom3C
eOo@d]God=?EoloCeP02om3CeP0Eom7Ce_o@dmKod=;Fom3CeOo@d]GodM?F
om3CeOo?d]God=?Fom3BeOo@d]Kod=?Fom7Ce_o?dmGod=?Eom3BeOo?dmGo
d=?Eom3BeOo@dmKocm;E00;od=?F00Kod=;Fom7Ce_o@d]God=?Eom3BeOo@
dmD3om3Be@05om3Be_oAdmKod=;Eom7Ce_o@d]D00_oAdmH2om3Be@03om3A
e?o@d]God=;E00Cod=;E00?od=?Fom3BeOo?d]D00_o@d]D02oo@d]Kocm;E
oloBeOo?d]Goc]7EoloBe?o@d]God=?EoloBe?o@d]Gocm;E00;od=;E00Oo
cm;Eom3BeOo?dMCocm;EolkAe?o?d]Cocm;E00;ocm7D00Ooc]7DoloBeOo>
dMGoc]7EoloAe?o?d]God=;E00?ocm7D00Cod=;EoloBeOo?d]Cocm;E0_o?
dM@01?o>dMCocm7DoloAe?o?dMD2oloAe004olk@doo<cm;oc<oAolc>d0;o
c<kA00Coc<k@olc>dOo;c]3oc<kA0_o<c]001Oo;cM3oc<g@ol_=d?o<c]3o
c<kA00;oblk@01Goblg@olc>dOo<c]3oc<k@olc>dOo;c]3oc<kAol_>d?o<
c]3oblg@olc=d?o<c]3oc<kAolc>d?o<cM3oc<k@ol_>d?o<cm7oc<k@ol_=
d?o<c]400_o;c]02olc>d00Fol[=d?o;c]3oblg@olc>d?o<c]7oblk@olc>
dOo<c]3ocLkAolc>d?o;c]3oc<oAolc>d?o<c]7oblk@olc>dOo;cM3oblk@
ol_=d?o<c]7oblkAol_=d0;oblk@00Koc<oAolc>dOo;cM3oc<k@ol_>d?o;
c]42ol_>d009ol_=d?o;c]3oblk@olc>dOo<c]3oblg@olc>d?o<cM3ocLkA
00;oc<k@00Soc<kAol_=d?o<c]7oc<k@olc>dOo;c]3oc<kAolc>d0;oc<kA
00?oc<g@olc>dOo;cM000oo<c]403_o=cm7oc<k@olc>dOo;c]3oc<kAolc>
d?o<c]7oc<k@olc?dOo<c]7oc<k@olg?dOo<c]7ocLoA0_o<c]400oo<cm7o
c<k@olg?d@02olc?d@03olc>d?o<c]7oc<k@00;oc<kA00?oc<k@olg?dOo<
c]400_o=cm400oo<c]7ocLoAolc?d@02olg?dP03olg@dOo<cm7ocLoA00?o
cLoA00SocLkAolg?dOo=cm7oc/oAolg?dOo=c]7ocLoAolc>d0;ocLoA00Ko
c/oBolg?dOo>cm;oc/oAolk@d_o>cm83olg?d@05olk@d_o=cm;ocLoBolk?
d_o=cm400_o=cm801?o=d=;ocLoAolg?d_o>cm42olk@dP03olg?dOo>d=;o
c/oA00;oc]3B00Woc/oBolk@d_o>cm;oc]3Colk?d_o>d=;oc/oBolk@d_o>
cm800_o>d=804?o>cm;ocm3Bolk@d_o?d=;oc]3Colk@d_o?d=?oc]3BoloA
doo>d=?ocm7Colo@doo?dM?ocm3ColoAdoo@dM@2oloAd`07olo@doo?dMCo
cm7Colk@doo?dMCocm7Com3Be002om3Bd`?ocm7C00kod=;DoloBe?o>dM?o
cm7Colo@d_o?dM?oc]3Colk@d_o>d=?oc/oBolk@doo>d=;ocM3Bolg?d@;o
cM3B00gocM3Colc@doo;c]7ob/k@olW=d?o9c]7ob<g@olO<coo8cLooalc>
olK;c_o5b/goa/[=00?oaLW<00coa/W<olG9c?o5bL_oaLW<olC8c?o5bLco
a<W;okBj__nBVJ3oH6Q`obLa>_lD8B/1oaDU<000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(path = 
        StringJoin[$JavaSwingMaterial, "\<KumamotoCastle.jpg\>"];\)\), "\
\[IndentingNewLine]", 
    \(icon = NewImageIcon[path]\), "\[IndentingNewLine]", 
    \(iconWidth = icon@getIconWidth[]\), "\n", 
    \(iconHeight = icon@getIconHeight[]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject134859792056321]], "Output"],

Cell[BoxData[
    \(96\)], "Output"],

Cell[BoxData[
    \(128\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<java.awt.Toolkit\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["java.awt.Toolkit", 12]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{\(kit = 
      java`awt`Toolkit`getDefaultToolkit[]\), "\[IndentingNewLine]", 
    StyleBox[\(img = kit@getImage[path]\),
      FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", \(ReleaseObject[
      kit]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "com.apple.mrj.internal.awt.publicpeers.VToolkit"] \
\[RightGuillemet]\),
      JLink`Objects`JavaObject130324658913281]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "com.apple.mrj.internal.awt.graphics.VImage"] \[RightGuillemet]\),
      JLink`Objects`JavaObject11521803419649]], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<javax.swing.GrayFilter\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["javax.swing.GrayFilter", 82]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(gry = javax`swing`GrayFilter`createDisabledImage[img]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "com.apple.mrj.internal.awt.graphics.VImage"] \[RightGuillemet]\),
      JLink`Objects`JavaObject107786633478145]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(grayIcon = NewImageIcon[gry]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject3252917633025]], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\(savedLayout = pane@getLayout[];\)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]pane@
        setLayout[\[IndentingNewLine]JavaNew["\<java.awt.FlowLayout\>", \
\[IndentingNewLine]java`awt`FlowLayout`LEFT, 5, 
            10]\[IndentingNewLine]]\[IndentingNewLine]]\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(b1 = NewJButton[pane, "\<icon\>", icon]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject127306202873857]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(b2 = NewJButton[pane, "\<gray\>", grayIcon]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject27359780536321]], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell["Animation GIF is available too.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(animgif = 
      NewImageIcon[\[IndentingNewLine]StringJoin[$JavaSwingMaterial, \
"\<GIFAnim.gif\>"]]\), "\n", 
    \(spriteWidth = animgif@getIconWidth[]\), "\n", 
    \(spriteHeight = animgif@getIconHeight[]\)}], "Input",
  CellTags->"animgif"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject46469331550209]], "Output"],

Cell[BoxData[
    \(63\)], "Output"],

Cell[BoxData[
    \(60\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(b3 = NewJButton[pane, "\<Animation GIF\>", animgif]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject29297750310913]], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\(JavaShow[frame];\)\), "\[IndentingNewLine]", 
    \(frame@repaint[]\)}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(DeleteJObject[pane, b1]\), "\[IndentingNewLine]", 
    \(DeleteJObject[pane, b2]\), "\[IndentingNewLine]", 
    \(DeleteJObject[pane, b3]\)}], "Input"],

Cell[BoxData[{
    \(ReleaseObject[icon]\), "\[IndentingNewLine]", 
    \(ReleaseObject[grayIcon]\), "\[IndentingNewLine]", 
    \(ReleaseObject[animgif]\)}], "Input"],

Cell[BoxData[{
    \(ReleaseObject[gry]\), "\[IndentingNewLine]", 
    \(ReleaseObject[img]\)}], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.SwingConstants <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(swTop\), "\[IndentingNewLine]", 
    \(swLeft\), "\[IndentingNewLine]", 
    \(swBottom\), "\[IndentingNewLine]", 
    \(swRight\), "\[IndentingNewLine]", 
    \(swNorth\), "\[IndentingNewLine]", 
    \(swNorthEast\), "\[IndentingNewLine]", 
    \(swEast\), "\[IndentingNewLine]", 
    \(swSouthEast\), "\[IndentingNewLine]", 
    \(swSouth\), "\[IndentingNewLine]", 
    \(swSouthWest\), "\[IndentingNewLine]", 
    \(swWest\), "\[IndentingNewLine]", 
    \(swNothWest\), "\[IndentingNewLine]", 
    \(swCenter\), "\[IndentingNewLine]", 
    \(swHorizontal\), "\[IndentingNewLine]", 
    \(swVertical\)}], "Input"],

Cell[BoxData[
    \(1\)], "Output"],

Cell[BoxData[
    \(2\)], "Output"],

Cell[BoxData[
    \(3\)], "Output"],

Cell[BoxData[
    \(4\)], "Output"],

Cell[BoxData[
    \(1\)], "Output"],

Cell[BoxData[
    \(2\)], "Output"],

Cell[BoxData[
    \(3\)], "Output"],

Cell[BoxData[
    \(4\)], "Output"],

Cell[BoxData[
    \(5\)], "Output"],

Cell[BoxData[
    \(6\)], "Output"],

Cell[BoxData[
    \(7\)], "Output"],

Cell[BoxData[
    \(8\)], "Output"],

Cell[BoxData[
    \(0\)], "Output"],

Cell[BoxData[
    \(0\)], "Output"],

Cell[BoxData[
    \(1\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JLabel <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo@oooo`0XYkgB
ZKc:/L33]:RXXfI^ZEEUZ5I/TUU/[j:[[K^k/lK2UJZSNX^5CEaIAU=IF6=W
FfAOA4]3@TDl>C`c@D<hCU15ATLoD559FUeF?T4j>C`c@D<hBTPkDT`lF54n
IEi;GEa:H65AIVQJGf5C@TDj=cda@dQ1?4<k0Si5?P1;?4<k?dHnA4U2@4Dn
@TDlCDhnHU]1LfY;LV]AQ7m[WI^<YJNLG65J@4Y2<S`d<chf=3lg<chf>D0i
?dHo@dQ4B4HjH4leHdh_HU0hIU]9JVIKJFYTLG=`P8F1TY>;YjRJ_;ZSc/V[
g]VaiMj`i=ZWg]NYd]>cdMFloOo/nOkZkOCRfn7C_<BiXZVRRI:?B51B?TI9
:C0h9Rdg=3Y6<cU7<CY;=4IJ=e1V>U=Y>UMY@5maB6YfH8F>Q:N[Z<[;^]WC
cNCLf>[Lg^_JgNG@g=o:iN76j]Vklmbjl]bgl]bemn6j00;hhkP00ocW^_oo
ooooo`2loooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooom3oooo
02R`aMR``m6`_l:g/kBkTYReNH>GFVZ>HW6eZk>b`<2]`l2:XimdR8I4E5<o
CE1AG5iAFUE1B411ASlm@3M4AciBDd]8BD5=D4U3ASlk?SM2ACi3ACY2@3A:
AcIJDd5YI51RHDmGF4QNH59@DTDj?C8m@cM1ASm2BD42?dHo03LnACdoASi2
Ad0m@S]0@cY:BceOF3icJT]lME^JUH6^[9fVZ9e=DT/mA3de?cLb?CDc?SHi
@c/oASm0ACm1AT95AC]BBSEJCSISFdIcK5YiLfM_Jf1]JF1jLfUiLFB6OfbA
Rg>JUGRe/Y7BdZcGfK;Cf[R`_JVW]jZgbKfib/3@hMOSm>c^ooWeoooChN5:
F5PT;c4[=SP/=CXQ:RlK92TU;cPQ<Ch00Qle@`0B7cU68Si:83i88D99;4]>
>5IFAEmLCVEOFV]QKg]_QheoXJFF^[VUe<jfhMNlj=k3jn;5k^G60^kS``03
m>[7oooooooo0;coool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
od?oool0N;C6e;G7dk33bKG0`/?1`ZbPXW5NHW]/LJ>SYK?1`ZFo`7bJVVR2
PcI;C3Q8B4]GEd=>BSU3>ci5?CXo>4=6?dmBBdA7@497@Ce2?3Xo>D56@495
?4Q8?UaJBfMQDF]VDfMVE51A@EIHBTA6>CTl<DE;?cm4?D99@D17?d99@D17
?cm6?Sm4?CXo>3e0=dQ9>f9L@VmXBh9lI9ZHPkJgYhf@QD57?Cm6?Sm9@3]5
?3a6?D9<@dI=AD56?d12?D15?dI@ADE@@UEKCGEfJ929NHaoKXA_FXE]EIAj
HIV4JI^;LHZ4JYFJQ:bmZZS1[Yjo]YW0aI>nai>kaHjf_YW0aiVna9^m_ijm
_i6][SeFDcE<ARi1>ad^9R0`9RDb:1`Y82<b;ah^;Qd/;ada<Qhc=R0h>R0i
?A`f=ahf>2]0@CA6AS]9BDE@C4iDD5QMEf9YHUISG5Y[HfEdKGZ:P9^XW[G1
]LOAa]CLckkoool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?o
ool0N;;3cKC6d;?:dZc8bjo=bi6ZYTiHEemSHXF=Sk70`j2m`G2AUU]hOS59
CCa<C4QDDSa7@cM2?3a3?3Ln=Si3?4Y=AT56@3i3?D98A3To>ce2?Sm4?E1B
AfMXFV]XEfISDVARDdi@@U1BADI8>d54>DU<@Ci3?3a3>d17?d=:@T99@Cm6
?Si3?3Tn=c`o=TI7>F9LA6eVBXF1J9FBOk^l[VQ[H457?D58@4=:@T5;@4==
@TM?A4M=@dE8@DA5?d97@Cm;AcM6?d5;@V9VF7mlJhIjI8=_EXM`DIAmGYn:
KJZLPYZHPi^VV:Vn]i^i^I>k`hfmdHc2fXk2f8g0dhnncY6mbYFmahba]f>2
QBe:B2m6@2Hj<Ah^8bDc92Xg9RLb92hf:bLa:2Ha:B<`:A/Z9b0`;bPh=b<e
=Ad/;bDd=b/i?30k?CQ2A3]3AD15B4==CT]OH49LFcaDE41IEUE[JFAjMfj1
OGB7Pkkoool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool0
J[G8ck37ck;@fZC=diC;b7ja[4YWHe=SHXJATkW;ciNh`FZ?V5UeP3eAF4AB
Dd=>BSe8@S]6@3e4?CU0>Ci3?4Q=ATM<ATE:A3m5@CDn>Ca2?Sm4?TM8@5EE
BEaIBUmNC5UJC51BADY<?dU=?dQ;@4I9?T56?cXo>3i5?D=:@T=8@D15?Si3
?3Xo>3`o>4E5>EIA>g5[DHN2K:FTT[FfZ5=FBdI<@T17?ca4>DA<@DM?@T98
?454>DI7?dU9@DQ7@TI7@TE7@TQ9@E9DAeYMC5]MAfITBgMfF7=bE7imHI2B
OI^OTJZe/KO6bk33dJo<gYk<hiG;hiC8gY;5fXZibi:lc8jb`72AVTiZKRm4
Ab`l>bLc;c0j<Rld;C0c:S/m<SXl;cPj;3/o<CPn<Rlf;S4k<cHo?34j>C<m
?SDo@@8c?Cl01cU3AC]5Aca4Acm9BSa:BT9BDD5DDP02@5=?00=0Dde3Edi;
GeH0__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo@oooo`1h
]/gCZlK=Zm3IX]?JU=3AT/S8MiFGMhV;YK:h`MGLQZ^dLYRSIX2=CEiXBUEG
?4M3?TM2?4Hn>d8k>d0i?d@mAda5C55;CE9<@DM3=cdi?D<o?d@n@T<kBDTm
D4dnEeE6DU=5Ce54A4PjAd/mB4]0@TDl@DLm?44j>d8j@4Lo@DHo?d@m?T<l
>d0i?3lh@T@gCddhNGANQH9_^;JWTi>7Ce99BTe6AT]4@4PmBe55Be53@THh
?ClbA4@jBTLnB4@kETm7Ee18D4i2BT`oBDdnB54nE5e:Ig1KMWmZMWm/NXEg
U9nG/Kfm_<WA_L[J^M3R/=KYXm;TYM?S[=KVYL_HXL??Mi>NAEiU:ci4=DA7
?TQ:<3Hf?Cln?Cdk>cXfAD8k?C/_>CLZ>3P/>SX`>S/c?Sli?T0k?3hk<cLf
=c/l=S`l>450@4U6@4]7?DQ4?TU5>DA0@4a8AE9;AeA=BUM>B5Q>BEU?D61E
__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo@oooo`0N/<oD
Yl[@X/kGY]KPXm;L[M7MZkW6[kO4^/SC]<oJL9JQQjfhOI>QEf=_B4mE?dQ5
?TA0>d8j>3lg?48h@TDlADPoC4m8CU==AT]5>Sli?44k?d@mB4XoDU=50UAA
@009D595BTe2ATTnA4LlATU0A4Ln>d4g?dDk>Chg008oA3d0=ce2>ci3?3]0
>C/n=ci0=E9A?G]iI8f<N[^l[Ve_I51CBTa?B4aABTY@ATeCAda@@T=5=d11
<dE3=dM5>DQ2=UQ??UUA?U1:>TA5=d57?D==A4YECe9OF79nNWJ2OWF1OiZV
Y;[8bL7?d/SGg<3CfKoHgKODf;C@e;[Cek_CejZm`F=bMCm=CT5;CCHn@3Lk
?SDf>451@cdk?Shi?DI2@DU8@dA4?002@Chi00i3@Se1@3a0?c]4@cm<CDQ<
CDM5B44nA3XoAcXmB3XmBSU2CT15DDM7DDT2@de400A:E4]@F4eBFTmFGU>n
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooom3oooo02VXcMFW
cmNPcmVVe>6Xc=baambh`=O7cN>gb]^Q_lYPQY6K`<V>XZeIHfe2BE59CU4o
A3hm@cTj@3I1A3U5Aca3ACY:Bd==D4U0@c`g?3Do@S]1A3]9BCeGEDIJE4AF
Dd9CEDQ7BSm=D4E3AS]6BD18Bd8d>S0nA3Xg?3D00Se2>`17?44j?T<l>d0i
>C`e>cdbE593MgIRWYn?_;jaHF=HDeI=C55:C598Ade3ATXlA4Hi@T@fAD<f
AT@gB4@iBT@fE4hhGUQ2FEI3BDXl@4<l@4I4B55@De]MH6Q[LWanN8:3Xjn_
`]3@_m7Ab=cK_M7@`mOHam_J`M?C`];Aa]CDYK6aCEMF@4U6?490=cdk?d=2
>cdl?3hm?ClnA4I5?d50>SXh?Shl?clmA4<oAdI2@3lk@3`iC4U4ADDmBd]1
Bde0BDdlB4lmATljAE4iBeM3?dXlAU17009;DdP0155GCEEKDEiQF6U/HKko
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool08JW?g:O?
fj??fZW?g;K<hKg;iKW2gkW9hjk:ghnc`E^0R:O8cJJo`fYiP5UPJTM:CdE7
@Se0=C/m<4M7>e=CAe9BATm?AEADBTY;@cXm=411>DA6>e9@@eMD@f1IAe9=
>TQ:?@02@4Hl03Q1AcdoAC/nA3Y0@cXk?SDo@SU3ASdo@S]3ASlm@3U4Ad0k
@3Xl?cIADTAmOVjYZIfi^k1MGUICETm>Dda:D4I=D4M9CCm5AcY2A3I6A3M:
B3]?Bd1BCT9CD3eGET9EDdA7Ac/o?SU4@d5=BdaCDEASHF9aLG5lP7na_;Rm
cL[5fmS2gm^ofMS4fMc=gn?1d=?6e]K6e=B7UY=5DDdnBD<iA3`g@cTf@SP2
=d<g0SI2=P0I>4@j=d0k>d4o?d=2@dE2@TA1@44l@T4mATE0Ad@kB4PlCDhn
Ce8mCe@nC5@lBE8gAU0h@Tdo?dU0CUE=DEQ@F5mGEEaDI6URIfeS0;koool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool0LZG;gZG<gJS@
g:g>gK?8gKK7hK38i:o=jJ[>i7>GYFV8SKKDe:K5`7R@T6M`NEmOIdA6@D94
=dI7>D=4=UECAU=AA5UGBeUICD];@c`m=D12=dA4>51>@EQB@V1IAUIA?Te?
@T98?Si4>T16?3i4>Sa2>3e0=cXm=3i1>454>d13?495?T13?4=6?ca1>cXm
=U9DAh63MKJh[KBg[UmRFeAGD4iCC4eBBdY=A4E9>d53=Sm1<d93=DU7>Ti:
?e1<@5=B@5IE@e=AA4U6?D=0>dM3@4i8B59<C6eWIgimNHf?R[o8`l?Dc/?L
e[oNf;_Iel7IgLSKh/CGgLGGfkS7bVQhMce<BCa9@SI3>SA1=cA2=CE3=SI4
=CE3=3E6=SU7>SA1>SI1?CY3?Sm5@D15?d53?TA5?dM8@4];@Da=?de>?Te@
?DiA?4iC?4eC>D]C?4eA@dY=@P9CETd015ULDeQNE6Y]I6ecJKkoool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool08ZW=iJW=hjgAhJg>
gK7>h;3Ciio?iH6ebVZEZ4U[MeYcMiFb[JG;`8b]YUMTJV][Le1CC4i@@e1A
@dA2=E]HBE]GBfITF69RETm?Acho=d53>4E5>E5?@UUC@f=LBEYE@U1CB4=:
@P8m@S/0>3a1>STn=cTl<c/n=DI7?dA5?DA7@413?4=5@494?d56@3e2>de@
AH24M/;5^ZJYX5eOFU5FD4aABdaABTA7?T14=Si0<ci0<TE5>Da<@5=@AeMC
B5I@@UQBA59>@dM4>d8o>TE2?DU5@T]8@fERGGimN9BGT<K@b<KEd<GJeL?N
fL3LgL7LiKkIi<GMilGLi:Vn`deOHCa<C3Q4@SA0?3<n>3<n=SI0=`8g@CP0
43U3>S]7?CI3>CE2>3I3>CY6?3e7?3m7?457?DI9?Ti@ADa>@Da>@4e?@DmA
@e5D@`9@Dd8025ICA5EB@eUEBEEAAEQFBE]LCVa^H7EiJ[koool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hoooood?oool08jgAjjc>ijo?i:S;gZcE
ijSIjX;1dTF0T3=JJcMBGDMKG6R2NIc5]Ig3^5=RIFMZKfIYHUaNDE1@A4I4
=eMEB5mMD6QVFVIVG4m@B3`o=Sm2>DE7?5ABAUQEAV=LBUIC@TiAB4=:@ca1
>`02?44j03Hg?3Dj?CA2ACa?D4Q7B414Ad0j?CI1@cho@Ca3B492Ad1:CD:0
PgS9c<>BUHiIGUY@EE59CTY8CDI2ACa1A3To@cE1@cI4ASU;Bd5ADDMGEDUG
E4EHEDICCd=9ASe2?cQ3@3]9A41=B4AMFUEjNGBDUY7:dL[7e]75f]G3gM[2
g]o1g^Jlf>?1g>G9h>RN/kQ5Ee/oCDhd?Sle?Sdf?3Xg?CT2>d0l01/j?Sdl
?Sdj@3`jAS`gACPg@cLiACTlAcTnASToAcY2B3a7CD59C45:CD9>D4EADdQB
E4U@DTM?Cd=FDTIJE4IGE4EBCT9CDDAHF4aYJEegNF`0__ooo`:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Sooooo@oooo`1cZ/kVYl_S[<kWYm3VW=7S
OK_:Gin[:f5]<TaI>DM@@4a<DVMNR:bNU;R/EfMVDU]JKG9[HfIKBde2AdLk
ATHjDU98EEE;H65IBTm9=c`f>Chh@DLmDUA9E5E7FeQ7CT`mADY3@4Y2>d8k
>T4j?44j>Chg?T4hC4e5D559ADHn@D8l=SLa?Clj>S`g@4Do@4DnBe57QH]o
bm39OhAnFEiJD5EAAda8A4U3@TM0@TPl@4Hj@4<h?T4f@D8jA4DmB4XmEUQ3
F5Y4EEI4Bd`nA44hA3lkC4A2Dd]9IUiLPWejVIVGcM?AbMSEa]cI`]oM`MoO
`MgQ`mcQ`MSNb]gSTZ6TB5=E@DU;=C/k>S/m>c/m?S`o@Cm2@Cm4?CY1?CPo
>CTk?4<k>4<e=d8d>D@f?4@g?DDh?dLl@DTn@d]0A4Y0AD]1BTe4CE19Ce9;
D55;Ce18CU56E5M<DUA9009?D4P00e=DCV1QFgIgL@2noooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?oooom3oooo01FWcNBSbN2[dnfXe^j6`mI;
RYU9Oh]5JW<mAe59BE4nAdI=GUInW91iUhe1DTa1C4QQJ65NI5Y9C4=8Bd0j
>c<00TA5?@0=EUUBBDm;<c`g>3hj@TU2DEA;DE=8EUA7B4Pl?44j?TM2>d8k
>D0i0090ACh01TE6?U9CBde>ATA5?Cho>CXk=@8m?cX02ci3?Ci3?4mEBhjD
R/W>ag1eKeEIF4]?CT97@ci3?Cm4?@02@4Hl02HnA3Pn@CPn@CY0@ca2ACYC
ED1FF49EEd9<Cci3@cM0@3Q7A3m?BTMWHUn3OgjIVi[<eMC;fm_9g^75hNG3
h>C5g^;<hNC8fmo=g=nDWj5=EeI1AdM0@T4k>c/m>c`o?Ci4?d=4?dDm>d0j
=chi=cXk?CP2>3df00@k@CLl@SPmACXoAc`3@TXo00Y3BCm4BD98BdA<CdQA
DTaBEDi<DTQCFDm?E4eAETl2D59=00=HFUMdMW?oool0_Oooo`:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Sooooo@oooo`1PY]7TX/oTY=?]V]3/MkG<
>6n3DVmoJg>0F4aFG4mFDE=BDUiJKh1jGG1Z<T4j?4U0Ae9:C5I>@DQ0@DLm
?3lh@dQ1@4DoB4i:A4e:<C`h=d0m?dQ3BU59Ade3CDm2A4Hk=chg?TM2>d8k
>3lhADY3B4e6BT]3DeA<C4e5A4Dm>c`f?Chh?3hi@D<n?T<o@4DoC55:TIN=
`/O0IFYTCe=BA4Q7?D<o>d8k>d8j>d<h?4@i?DDj@DHo@TM0@TM1A4DmDU11
EE8oEEA2CU50A4Pi?d<d?dDg@dTmGF=INWmhUI^IbmGGcM[RbmgYbmk_bMo]
c>3Wc=kRd=oRdMoP[KNfGVMR@DM3@dQ2>chg>Sdf?3lh?d8k?d4l>Sli>3di
>S`i0SXh>@0F?3Xk?Cdk?Clj?44k?TDn@TU1?dTn@D]0A4a1A4`oATa0BDm3
Ce97DeI;D5=:EUU@DEA=F5]DD5E?Be1:CeEALWQd__ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo@oooo`0]YMKWX]GXVLgURKoGLjc0?fao
G6mmL71jLfI]Ed]?H69QEUmL@4Y9@4]7>TDo=D8i=3lk>4<m=T0h=Sde@TM0
C55:Ada5?D@m?DLo;CHa<c`i>T<n@DQ1?D8lATM1?d8k=Sdf@DQ1>d8k>3df
BTe4D5=:CDm4DE=8Bda4@d@n=3L`>C/f=cTd008n@cl0?DA9@dM<AI>HTKg2
_61UHDa@Cd55A3m3@Si4@3e2?3Y1>CY0=Si4>T=8@DE:A497@d52?5=?@eIC
A5MEAU=DA4a??TE9>458>498>UeSEg^2NYFNVlgGfLgJhl_Kj<WLjlKLj/gQ
k<?Dg<oNhm?Qh/SBdFigLT99@T15?STo=CPn=3To=CY2=c]3>3Y1>CU0>3a1
>cXh>cdh?3dk?Slm?Sdm>c/m>3a1>d17?cm7?4=;?TM?@TY@@P02BDm100Y>
DTAAEDMBDd]GFU=@DdaIG5EAEU19CTQ<Dda`NW:noooo0XS0^058T8P10000
000018S0^<SPf8S0^8S0^?oooom3oooo05ZLeNRPen^Jcn66]lQ`WZ]YSYM[
PXQ`NgmRIVUTI6AcMGALH5m4B4Ll@T11AdDh@ChkADHd?Sdh@C`h?cPk@CMG
FTmMHE<k@C<m@cDe?C0c>S8h?CLj?3Tl?3hl>Slf=SPe>SI4Bd@k?SDk?C9;
BcmEEDUJFTi<CT54ACdl?cPh?CTg?3Pf>cLl@3m2ATE1AT98CdR<Th^g_[MG
GEU;Cdi6BTTh?3/h?CTl?STl@CY0@cXoAC]1ASm2Ad50AD50@SeHETYGEDIE
DdACDT1FEdE4ACE<CCmBDTQOGUUjNWRX[:g@f=_9f=_<hNC6h>77hnO7gn_7
f^WAhno>gNC6dM=QJVU9DTlk@Cdg?SLh?cP3>T4j00`l@CXo@S]0@C`k>c/j
>S`i>C/i>CTm?ca2A3m3ASloAC]5Bcl2AT`n00e9CCm;Cd5>DT=@E4EBETQ>
DDQBE4m@DTeLHE]DFE9<DDY@EDiaN700__ooo`:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Sooooo@oooo`1IU]3VW=GYWmCVTL7?N:2ZIHJ=J865MXR8
GVYZFF9OKWAbK75]EU]GB4e9ATY9A4Y:?dU:>493?490>Sli?T4hFUi@K6iP
FUi=ADTh?TDe>3hb=c`e?3`j>c/m?3Ln>SLn=3Pg?D@m?T4j?Cld@d<iCdm3
EEE9ATPm@D@k>cdh>3di>Cdl=SXi>Cdl@dE4ADY6BU5:PHR1^;jjCE=AC51A
@DE6?Cln>S`i?3hi?D0i?d8i@D@k@DI0@TM1@4A3@48mDU98FUQ9EUA5De90
EEA2BDLhBDLjAT<jEE5>MgEf[Jjbd=SKc]kNc>;PaN;Na>;Rb^Caa]_/cN3^
b=WQ/;^oE5iOA4e<?4E2=d0k008h@C`01CY0?3Xo>C`n>Cdn>3ho>P02?Cln
01Hl?Sdj?3Ti>cHn@CY7BT5>DDQ9C45:CT1=DD=BETQGFdaIGDiHG4eFFDiE
F55EEe9<DDeFFeE?E4i:CdQBEe5fNgBnoooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?oooom3oooo05RNe^nOeNfOd^NHamN<]<1kWJI]RHaXOGiA
HEi9EE5NJ61ZLFYEG5E7C4I5BTA:D4a0BDPi@d8j@3`f>c@h>C5@DTEXJE]X
JUa<D45:CSll@SHf?38l?CPi>CTi=3Pl>Slk?d0k@Cm1AT8n@CY2@ceBDd]@
DDU3A3`m@3Tg>C@i>cPk?CXf>3Dg>CI0@3i5Ad98CdQ_NG6l`[i9Cde@E5Do
@d@n@3li>cPk?CPm@3U0@cY3ASe3B492Ad4o@d8o@CaACTEMFT]DDT=BDCm>
Cce=CSi8B3a0@3Q>CD]kNgfd]kc>emcBhNC:gn37i>;4h^C6hNc3f^S=hNc@
hNVLYj]=EeHnAd@l@Sh2>D8m00Lj@3`i?c/i?SXk?CPm?SPn?cXo@Ch00T12
@@0E?T0m>S`g?D0iCU58Gf9IFUeBEUU>DeM9EEU;FemAHFEGIVYLIfYQE5IA
E5ICD59AFE]HEUQECU1;DEIBL7E_0;koool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hoooood?oool0::;Hm:CJm:3BjI_:g9k8eYRmaWNFVE5[JTEK
F4eQF71mM7^7OEmYH4iECDA;@d=:@TQAC4I?C4I;AD13?3dm=DQ8?UiNDV]/
GUAFB5EIBdE8?CTl<d52?3lo?CPf=c/k>cXn@CTo?ca0?c<h=494?e9CCT93
?SXk=P8h>SD2>S`i02`f=S@i>SE1@3a0@Ca3BT=XLV[2b<I@EUACEeQ1ADHl
?Sdg>CHj?3Lm@3U2ACa7BT57C4I3B48o@d8n@3]DDDQQGE5CDD9CDT1:BcU>
Ccm9Bci6Ad5CEE:;Si:naL_:emgAh^W5gN7:i^W7i>S4gn[2f^K=hNcEi^f:
UIM<EUDoAD4l@Sh2>44l01Tj@3`i?c/j?c/j?c/o@3]1@Se2A451@d12A451
@chl?cPk?SM9C4=JGEAcMV]aM6U^LFI/L69[KV=YK65VJEiSIUmCEE9CEEAA
De800UUKFP03Ce5>DEEDJg1/0;koool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2hoooood?oool0F9g@kjCGm:GGl:;AiJC?gig5cg^QY5UiN55^JFJ0
MhVMU82BQUm/HU5MDDaFBdE?A4aCC4iECTa>BDA5?d8o>4E2>EIDB6QXG5aN
DF1TETmBAcm2=dI7?dQ9@cln>S/k>CLk?4A8Bd96Ac8f=d=5A4Q:BC<e<STk
>3Ph=S`l>Sho>SXk=SLf<Sln>DA1?3Xk=D58@FehL<;;b5IOG4aBDT57AcLk
>SHk=cXl=ce0>D57?DQ>A4Y?BDA9@ce1@3`n>EEBBF9NDUIDAEMEATY;>dU;
?DM:?dU>AeMMFiZTY/KCfLSIhLoSk<GLi<_VkLWTkL_VlLKNj<_Oj<kPi7B0
P4UDD3m5@Cm6?`8k@S/01c]1?CY0?3Xo>c]0?411?493?TA6@@02@D<n01E3
AD0o@S/i?3Dl?cI4Aci1A3UEF4eaM6V6RGj:SHAmP7MYK6=KGEQFF5MCE5I@
DE=BDeEFEeU=CdiEEUQ_LG00__ooo`:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Sooooo@oooo`1HXM;bX=7_Xm;/YmG/YmGUWLWDR[>iNZ2QGH1lLY6;
Uk:[QIZAJgabGV]RFVILBUA;@dY3BDi8A4Do?C`g@Sdg@SheCDU0Hf5EHF5E
JF]NFEaA@dHkATPmCTm7AdLo>cXe=cLeCe5@Ce1B?Ci0?d12>S/m;c4`?Cln
>3Pf>c/i?3dh=cPc=3D_?C`g@D0k>CXdAU18OXV3a<g:Ef1OADY=?dA7=c/l
>cln?3hk?D0i@4DnB4i4BDi8@TM1>cln>cdhB4DlFEE9F5I7F5U9D551BDdn
BDm3C5=<DUaKY;:eb]_Rb]kWc^C_amo[c>C`an;]bNC_b>3Zc>3Wb=[LIW9`
BE9=>d8k>3lh0Sa3?009?48n>d4m>d0l>Slk?T0k@44l@T@o@48m@D<n0095
B4402454?Ci1>3i1>413>4A7?4Q;@TU<@dI9@094Ad002DE7@U1BDE1ADe9C
EEAEEeYKGDe>D5AEEfY[K@2noooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?oooom3oooo05RVeO>Qd>jPcnVUeNbXenVQdMnIb=2G`/Q]UIEjWYb[
blRX`[nO/k5lS8UUM755D4a2BD9:CdQ3A3hm?3M8@ce8@C]:@ceKEdiVIUab
M6UVJUa9CCm3ACQBE4M@D4@l?30k>35@CDQBDDe7AdDk>c/d=SDg>cXk?chk
?CXh>SLi>SDh>C<d=Blh>C=0@C]0ACiCGEFAWYO8dlmDGUe5CDloA4Ll@44n
@T4m@Shk@3Tn@ca4BT14BD<n@cdh?S`k?CPn>c9FDTIMFdaFEdMDEDE<D45>
ET]8Dd]?GEf[_/;:g^O:h>g;h_3:hO7;h_;5gnc3g^W7h^W=h^O1dm=MJFM7
D4/i@3Tf>c@2>T4j00@k@Cdj@3`j?c/j?c/2?Clj0T54?@0<@TDnA4M0ATU2
ATU0ADPo@dHm?d8i@TDlADQ1ATU2ADQ1@dE00T53?P08ATQ7Bde<EEMFF5YI
H69QCU1?DUACI6IU__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo@oooo`0iW/_ZY]?`Z=OaX];YWM3SWm?QXmCRX];LUlC:RkBj/=KI[lkA
/L[>Q9VNKGj5C5YM@4U6C55:A4E0?SdhBdI2ASli?cPbBTDoKfaSNgebLgEX
D5A6A4HiEUQ:FEY<A48cCTHiEdm2GEI<FeQAADI1@TA1DEED@dQ4@dE2>C/f
>c`f?D0i=cXc<cPa@4DnCEA=FfIPWZZVc]SGE5iMC5AF?TI8@4I6?T91?dA0
008k@3T08D16?415?cXo>CLm>CXo>D51>EiJCfESEUECA5=DA4]?@4iFBcm<
ADmRH;;7c<SPj/OQk/KPlLWRm/[PmLKPlLCPjl[Uk<_PhkC6aU9NFTE?Ace4
?Cm4?CHm=SLn=cPn>STo>`02>Slk00lm?cXn@3]3ASm5B454Ad11A3e0@cY1
A3]3ASe2ACa4Aci3ASe2ACi1A3e0@Sd00Sm1?003?T0kB4Y7Bde:009DEU<0
15aNFd]=BUAFDfQZIkkoool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
oooood?oool0IJ?@kJ?Ajj;Ajj7CjZ;FjjCIjj?Hj:3DhZ3AgjCBgk3JiZW=
fK3=fjK0cdIKK5e]NUmYJU5HDDa>Bd93?TQ4@D]6@T4i=T@o>EICBXB6NiFG
RTmCACm3=4Q<?EYLCUQEA5eA>ei?>V1DA6mYFeADC4A6@E9GDe]PG51BCDA7
@3Tl=CDh;c4g;C@k<d9<@e9MEEUVGj2_Z/??cEEQHE1JG3]3AD98B3]1?c]0
?3Tn=cLl=CTo=CY1>S]2>cY0?3Pm=cdm=EECAfYXFeaJCEmPDUUKCU9JCdeJ
De9VIKK>d/?NilCPk/ORmLSSn<KOmLOPm<WUlL?NiMCYk9j`/5=OFdA>ASe4
?Ce2>cXo>CTn>3Hl>3Dk=cLl>3Tn>S`n>Cdo>Si3?3m4?D=8@DI;A4E;@@02
@TPn0154BT11Ace3BCln@c`m@S]3B48oA3hh?CTl@C]0@Se@DTeIFeIHFUEM
GeYCEE1>D4][KFP0__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo@oooo`1JWlgWXM3ZXM?/X=C/WmK[X=W]XM[]XMS/X]K[Y=OZ[=W/ZM;V
[m;XXl7IB69kCF9eJWQkE5eJBU1>?T0m@d90BDA1AD0lAT4k@D4iK6iSPXIh
C512?d<d@THgF5Y<IV=@Je]2LF14M6QBQ7e[LFmS@4<lDEI@HVMQHVAODeI?
@TDl>C`a=C/a>T8gA4i5C5U@CeiIZ[Vfb=CDEV9RBeEG?4I8?TI8A4Y8?dA0
?44k>Slh>d0i?4<l?D@m>d4m>Sli>CXbBDToKVaPJVQKJFMJH69EEE]ABeQA
DFET^=7Fa>3[`N7^`n3baN7fa^3gan;eb>C`aN3WdnS]UjVYCUYH@DY5?D8l
>d0i>Chh>3dg0SHl>00L>3di>Chj?3hi?3hi>Slh>d0i?T<l@DHo@TM0@4Hl
?dDk@DLmA4Y0ATa2@dQ1@TM0A4U3@DI0>d0l>ChhA4M0DEA=F5]DEeYCGF1I
EEQADE=>JVmY__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo
@oooo`0LWLcVWm7ZX]C]X=C/WMG/WMO]WmWaX=[bX][cYMWaZ=OaZmOb[mOa
Y<OSFGREBF=jGG1gBeMGCEEGAd]<Bd];B4A3Ad=0?c`e?3`dCU15FemA?48d
0Se3=@0LDUI8JfQEPg9FSW]KSX1VWYN4WYjBADQ1CUE>Ff9KI6USFUeDB4Xo
>C/^=CP]>Clc?TPm?da3B5MB/<2m`m7ACUYJAe5C?dU;>T94A4e<?dE1?4<l
0SU0>00N>T4j>d8k>T0l>Chh=3L`>C/`K6aPMWAXK6YNIFEKEUU@Ae9<BUaL
]/oDa>;/`N;a_]ga`n;ga^3ian;gaN7_a>7YcnK/S9jPAU9@?4E0>d0j>S`g
>C/f=c`f0SHl>00>=cdi>3hj>Chh>Chh?D8l?44k?D8l@DHo@TM0@DHo?dDk
@4HlA4U2ADY30TM<A@94BD<02Sm4@3Dj=4M:@E1CBUAJD5=ICeYPEUILDU=H
DF]bJ[koool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool0
F9g?j9oCjj7EkIgCkI_EkIcEl9cHlY_GlIkGm:7Im:;ElZ_Jn:gImZO@kWRL
_5moUUI/NDIEFU1KGe1HFUEFF4a;BDa;Achn=T94>Ci1=T16>3@j;3Y0=3Hl
<4U<@feZFHUjGJ:?Kj6ENk2[V;k0]DE<ADQAC4eFDF9WHFAUGEUICDQ6>Cdn
<494=TQ>@TIBAT]JEK30_Kg;bd=ADDQCEDA>D3Y2A3i7ASi4@3]2>cPo=cLn
=SU0>CY1>STo>cLn=cDj<bha:6EUFgQfJVQTFF=PEe=DC4A=B3m?CjO0a<;P
j/;Sl[cMl<;RmlGQnLGQm/?Pk/KSjm3WkhJHW4A@D3i4@Se2?SXl=`8h>SD0
1cLl>3Lm>CTo>cTo>cXo>CTn>497@@02?d@n00M2Ad53B492Ad10ACi0AS`o
A3e0ACh00TM<A@0<@TM1ADY4@TM3<cPbAdY1CU56DUQ>DeU?FV1FF5mGEUeE
J79Y__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo@oooo`05
W]7/WM?]W=;/Vm?^VmC_00:Lf?@0GiWElI[Elj3ImYkFlJOJmjGGlZSFl9K2
gHFY_gZDXeY/MTaKHT]FFU=HFe=EE5MHDdI7?dA6>ce1<d16>SQ0<cDm<RTa
9SXo>6YXFhEgGJZIOJbTSKFcY<?8`D=<BDI@CdA=C5]PFVYZHV]WFeMA@dM1
<D]8=eMHBUaREUAQFZZm^L3@cd]IFTaGFd5<CSe7B3a5A3m5@ca3?3U0>3Po
=cY1>C]2>cY0?3U0>CU0>2`b:5QHCW1/Hf1ICemHD5=@BDQ=BCM7AXnWZkkL
i/;Tl;gPll;UnL;Pn<?OmL?Pl<WUl=;Xlh>DVdQCED57Ad15@C`n>cPj=cTk
>3Pm>CTn>SY0?3]1?C]0>SXo>D15?ci3?ce2?Sm4?T56@456?`02@4Dn010n
@c`oA3e6BdA7C4E2Ad55BTA2Ad4c>392B3i8CTA@EDiBEe1GGUIGHEUFH5QT
KfNnoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooom3oooo00FJ
d>bIdNbIdNbHdNjIeO400YgHmP:Ke_@0<ikJmYoHlj7IlZ7EkJKHkjOGkIo:
gJK3dgB:UdAFH4=@EU1HFeUMG5IHDd95?4E8?C]1<c]3=SU1=SPo=b`c;30e
;e=CBHf1JJjRR:nZUkNi[/39aTiIFdQCEcQ2@eAFDfYWH7=[GV9IB517=UA;
>V=MCFU[GUQUGZ:e/lWIfFMgMd]FFSY5Ace7BCY4@ca5@S]2>cPo>3Po=`02
>T4i01Ti?c/g?CTg@CT]=2a4ACePG5=JDDQJDDYDCdU>D4dmBd]dS92lf^:n
h^jnhoG2io[1hOS0goC1g_36h^k>i>mlSIE9E5PoADDn@T400cXl>@07>Chj
>d0l?48n?D@m?D8k?44k?D8n008k@3`01ci3?d15?d15?d56?d=8@D56?d=8
@@02AT]40TA9@`0:@4Do=S/e@4DnADY3CeA=DEQADeeEF65LEf9LI6mY__oo
o`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo@oooo`0lV<o]V]7_
V]7_V=7_V=?aVmKdWMSfW=OeWMWeW=SdWmWaWmO^W]OZXm_/Ymc/Y]GU/=7P
PYVW@5AOA59KCeUKFf5QDE=>@D@kCE15@TPj>T8e>40e?TDm>D0i<3@c@40h
N71MW9AmZZRK^l:k/kk0C5]R@U5H=Ci3Ce5@J6=MNfmSN6QIKUm<KF1=M6UG
Lg1QGfYTVjj/c]kNSYjNBEAH>TE7?4I8>491>dA1>D<k>3lh>3lg0SU0>00J
=cdi=C/g<cde=3/c=cP`Ee=:GUA;GU==G5E?F5QFDEeMI7Un_M_S^]kZ_nCd
`NKi_^7g`>3e`N3ba>3^bMo/MXN?Ae9F?454?3do>3Ph0S`n>`0:>Slk?44m
?D@m?TDn?dHn?TDn?T<o?D50?D8n?dA00Sm4?P04@DHoA4U2@TM0A4U20T=8
@@0<ADY3@dQ1?D8l?44k@4Do@dQ2CUE>D5IBD5UDEf1MFVEQIG5]__ooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo@oooo`06VM3^VmCaVmCb
VM;`U]7_V=?a0Y_Fm00bW][fV]K`W]S`W=K/X=W]X]_^X][[YMKWZLcPQIn`
@eESB5EMC5AFFf1LD5E?Be19DEM;D5I8Bdm1@THh@TDl@D@m=cTh@T<n@3d^
NWMVXjJM_/O4VjV/>DQ?>DI>?TM<ATM9H5]GNViRPW9RPW5MP71IOFeDLfYI
K7=/WJ^/cmkQZkZmBUMM@DmB?4M9=T0o?TM2?TDm0Sa2>00M?D<i?44j>3lh
=C/g<S/f?D@m=CH`EeA;J5mFIeeDIeiGI6=OHf]]GG1f_mcT]m_W_NCc_NKh
_N7g`>?ga^Gia^7bb>3/M8N>BEAJ?454?3do>C/j?Cll008k@3`00ca2?Si5
?T17@002@4M000M0AD4oA40oA40n@cll@C/k@3Xm@S/00T15?P0?@TM0?T<l
?d@mAT]4@TM0?D8l@TM1@DI2A4U5DE=@DE=>DeEBFEmMG6IWJ7=e0;koool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool00iWBl9SClIWD
lP02V]Gc05bJe_:Ke?6Ke?6PfOJQf_NOf?>MennQfo>Tg_JNe^fGbN9lWk]?
Igm0CU]8CeEEEeANGeUAEU14BD9<DTQUJE]QGe1KF4MGDD=3@3Lo@3]2A457
B49:CDJ;THfnalIMIV]8DeTa?48mADPm@D1?CTUhL6EnLF2:NV><N5f>NEZA
PFZ<RhNJXjS>fMnhaliAHVTkCE4jBD`c@SlnB41?EDUCEdTm?c8j?S13ASde
>S<e>cLb=SDh>STl?cQ4AS]XIUUVHeAOFDeIETmIGEiIJ6fccmZmho2ji?Ba
g_71j_jlh_Nlgo?6ho?@j?AUN7m6DELi@D<m@D0l@Cde>SHk@3`n@clm@cll
@ShlAShoASlmA3dl@C/3?D8l0Sa1>`05?T<m@4Do@DI0@DI0@TM10094BD<0
2d97@Cm4?Se2?Sm3A4M8BUA@CEMBCUIACEeMFeMNIW>0R@2noooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?oooom3oooo05ZHdo6Gd_2Gd_2Hdo6I
e?:Je_:Me_>NeoBJdo2Me_>NeoBNeo:Qf_FSg?NLe>nFanEPQjQQO9UZNXUS
JW1JG5UMGUQ?E4hoA3i:CdQRI5UZIeIbKEYbJe]NFTm>CdY1@d8m@Si2Ad=d
NWR7T8m=EEM:DUDk@dHe>Sdg?3Q4A3aUHEEfKU^;OF>KR6ZQRVZQTGRMW9R`
^L3BgnS5e]iNLWTnDePgBD/gAT<jA3]BF4aQHeE@DD=5ACTo@SLe>S<n@clo
?d4k>cdi>cI3AS]SI5IPGTmMEd]NFE=HFE]ULWRmf>>oiO:ki_NdhOBmiofh
g_>kg_;2hO?<ho5QLge2CeDg?d4i?cdi?SXf>cLj?c/2?48n00Dj@chkA3ll
@c`j@CXl@C/013e2?005?T<m@4Do@TM1A4U3AT]50098CDL034I;AD=8@T15
?ci3?cXo@TE6BUE@CEaCCU]DCV9PHE]SKW^8V;koool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hoooood?oool02YODliKClYGBlIGBkiKCl9WFlicG
mIkImiOBl9[FlP:Lf?@0E:3ImZ7JmigFli[=k8ZbeHFT`GnFZ6UhOeMPGeUN
F5MLF5UKETi@BeeNEVaZGGIcI7=aHVEUFeMIET96AD15?d56?e]RFdiDD3Pn
?3i4@T16A3Tn>SDg<Shn=61MCXEnJiZ>MZVIOjZINjjSSIbRW[C5c<?FgLKJ
hfb3RceAF3=5BCM5ACDo=diAB6ATF5mODe5AAd52>SLi=453@T90@cTg>SDg
<TE8?F9SEF1MCUiFBfAMEeQHFWJ0RL?Jj;cPl;_Tm[GRmKgVo;[PmKgPm<;Q
ll[QkemaNd5>E3Q0@S/o?SXl>CLi=SPm>CTo>c]1?Ca2?Se3?c]2>cPo>0Dl
@C/04ci3?D15?d97@DI;ADU>B4aABd]@BTM<AT97@Ci3?Ca2?SDn?D=7B59A
C5UDCUYGDV1QHeUWLWjAXP2noooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?oooom3oooo00VFdo:Ed_6Ed_6Ed_6Fdo:HeO:Kf?NMf?JLeoD00YgH
mP1EVmOcVmKdW][fXM[hX]OgYm?hTkOGNYV]H7J1FVQYHfUWG5iMDE5?BTU5
E5=>IVIJKVmQI6IHGf9IF5eIA4Q7?T<l?48fBDm5@DLm@dQ1@4Dn>C/f=STb
>3Ta<c<WBTLhOGQUUhmj[J>:/JF;/JbIY;>`^M;I^]GL`mkWQj:[?UEK>4U@
>dI8>ClkA4M0EeM=IF9IH5eFBT]5>S`g>cdl>cTl=C<f>3TdC4e5IVMIJFEI
IUeDIemLIFAYRI>LaMcZ^Mg]^nCf]n;e_>;i`>Cj_^7e`N3bb=o]GFmi@DiD
>412>Shm>3Xg=SPe>3Xg>3di>d4m?TA0?dE1?4<l>D0i008l@C/3>d0j00Dl
@C/n@cdoA3i2Ad55BT@00TM<AP0<ADY4@4Do>d0j=cdi=3hm@DY7DE9<EEE=
EUMBEUiQDfEcO9FY__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo@oooo`10T]7bTm;cU=?dU=?dUMCeU]GdUmKgVMKeWM[iW]_jWM[iVmSe
V]OfW=WfWm[jXm_lXm?iWLS[QJ_2EWJ3BUeSI6i_HfAVBdM8Ad51C4U4HV9H
JViPH6IJH6MOEe]J@4E1@dTo@4Hh?D<e@dLiBdm1BDdo>cdb?ShbC4do@3h_
?3X[GU]:PGaY]:nKc<J``/Jg/l_;_=kW^]cU_MkWXKo9?5EL>DaC=T55?D=3
@D8mD4e6I65JIfAME5=>@d@o>c/k0SXe>@0J?C`hDE9:IfMKLfmSKVMOJ6=P
Lg9gV::/amk^^mka_nSl]n3f^Mge`^Gk_]kc_mk`aMcZFfeg?daB=Si0>S`k
=SHd>CTg>3Xg>cdj?D8n0T15@@04?D8l>d0j?D8l?D8l1Sa1>`8oA3h03T15
?d97@D=8@T15?cXo>C@j=S<o>d5>AdmEBe=FCE9GDe1KGdaSMGjL];koool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool00i;Am9?BliCC
mP03U]Gf00BEe?FDdoBIeONKf?L2WM[i04bLfORKf?NLfORNfO^Tf?nVe_ZI
ammOQ9@aC5=5DeIOH6ANF5YEC4eBCDUOH5QOIEUGHEILIUeBEe<k@3Y2B3a>
EDEAEDIEEdU9Bce9BSY2@358ASLo?Bi0?Rlj>2Ti>RY;BCb8RG^o`;:ka[je
e]^dh>^bg>Rdf^F_cmXkEV4jCE@c?T@l@4<o?ce<BDASGUQUHU]GEU5>CdU2
@T0n>Cdm>CXm?3Q?D4QOGe=_KF5/IEmRGUeYJVnCWj_0f^Vlgo;0jOfghONh
g?BohOZlgoG0go?5gniLKWQ0CE<g?d4j?3/g=cD2?3`j00Hm?C]0@Sm1@d0n
@cll@C/m@S`2?d@n00Ln@cdoA3hoA3hn@cdm@S`l@C/n@cd00Se2?00=@4Do
@TM1@DI0>d0j<S`d<D0i@516CUI;DEM=DEMECEaSBfIkQJO20;koool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool0193@m97Am9?CmiCD
m`:EeOP01YCDmi?CmYKEn9OFmiWHnI[InP>If?T0DIcHnYgDnioCn:?FlG2N
[S5AG3E6CEAEFU]BEeeAEEYBD65RG5ALDDMCBE1JDDiCCDI9@Sm3=E5EAVEX
Eg1cHV9PDEIE@di;>TQ5=4I3<TU7>4Q9>cdo=3Tl<f5VGj^bZ[W<b[7LiJgP
lJoNk[GOkkKGiTIPKD5CGCi9CcLk?Shl?DU6@F5LEVISFV5QEemQETm?AdA0
@Cdi>STj=DmAAUQJCFATF5mLEEQFEeIKHH^KZ;_Hj;SNlK[Tn[OTnk_Qn;cP
n;gPm/;QmLSRlEibOD9?EcQ0@c/l?SPh>3`k>CXj>3dm>cm1?T12?cm1?T12
?D94?`03?d@n00I0ACm1AT10ACln@cdk@3Y0ACl2?d@n00e1AT12Ad50AClk
@3Xc?CDa@CM1DDI>ETU?Eda@FEI<FV=<J7j<[ld0__ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo@oooo`06T=3dTM7eT];fTm?gU=ChU=Cg
0YGEn003VMSkV=OjUmKi00:Ge_L0BiSGn9_Jnj3Loj3Joj?KoZKNnG2P]3AH
ITYNIfIYLUU?Edi3BEQ?D6EWHU9LE49>A4YDBe1CC5AECEePEDiB@e=EAfMX
F6aZFfMTDfYTE61JBV5NCD]9?4A6>dA7@416@U9MFJ6]ZkgDfZcJjZWPmJcL
l;KQm;?DiDQRLD1@GD19D3Lj?chl?DM4?f5ME6e[Gg9`Hg9cHe]KCdY6@cdi
>3Xk=EAGC5YND61REEMFDEAFEE9KHXnR/;kOl;KOlk;PmkGSn[[To;OMm;[N
m<3PmLORleibOD5>ESHn@CXk?CLg=`02>3Le00Hj>SPo?ce0@Slo@Ci2A3m7
BD@2?D8l00Hn@ce0ACm1AT10AClm@S`j?cT2@DI00T97@@0<@4Do?D8l>Sli
=3hf<D4g@U97CUI9CeE;CUMFBUQSBfMoS[7A__ooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Sooooo@oooo`03SLkdSm3fTM;h00:AdoH01i;DmiCD
n9KFnY;BmYGEnISHo9OGnP02U]Ki03jFeORFd_JGdOJZh_nQf_F2]LY5K7eO
MXAbNH=/JG1bJg9jMGUgNgYII5hf@CUCFU9SIEYBDTIEEdaIG553ACQEETQY
IeQ[J5MXHU9^J5QUHU=KFDe3A3i1Ad=5CdiFI6FS/[Ned=^YfNnXh?VZg?>h
hON[b]i2EfQ8EV<i@4Ph>Ci3@D92?cY@CT9`KUmYJ5A`KeY`KeeGDTa7@d0m
@3M5Bce>EDE?EDMDEe1HGUi>Ff><Xk6oi?J]g>h2/^Gj00Zbh?NegoFggO;3
i_[1g>eXOX/mBU<k@TPi>S`j>3T2?C`j0S/k>`04?Cll@D=0@dE0A4I10d15
@@07?dA0?D8n?T<o?dA0@4E1?dA0@DI20092Ad<03456@Si3?cLl>2lf;bhk
<S]9?5MMDEQKDU5GEE9OJ4YTOHFVakkoool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hoooood?oool018k?mI3Ami7Bn97Bn0:AdoH019?CmiCDn9?C
miKFnP:Geo/0CYOGnYSHniSGnYGDmigInikInJ3ImYC8h72J/7BAXHNEXXfA
W::R[9nRYhbDUfA`L51KEe9IDEiNDV5ODf=TG5EHCcm1=U=CAf9PDfQUEVQR
E6=PDFEQEEQHCT53?Se6AD=>D5ASJ:6b^[WEhjWGkigCkk3NmZcBik3;gTEH
Ica8E3i2BcLh?3Xj>492>U1>@V]ZF7=bGFi^E6e/EfaXGEEBBd94=d=:>TYC
@TeEAU9GD5ENGDmPJ9:^^[KPl:_NlJkUnZgTnJgOm[CRnKKPm[cQm<WVmV^1
ST5?F30g?Cho@C`j>cXh>C/j>08j>SX03Si0?DI8ADY<AdY<Ad15@Cm4@3i3
?ce2?Sa1?Ce2?Sm4@456@Sm4@456@P=2Ad<02d56@S]0?3@j=S8o=S]7>e=F
BeIGCeAHEeMQJTYPN7ZG]`2noooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?oooom3oooo0Y3Am`:Ad_P2T=7g0Y7Bn01QU=ChUMGiU]KjU]KjUmOk
VMWmV=SlUmKiWmckV=?aXM[hXMKeVlORTKC:W[S9ZK_7ZkO3XZnhN8F>BeQN
FVAUG65KGEeAHV1CIfQRDeE@?3dg@T8jB4HjGUa?IV9FFEE9HEmCEEI>@4Do
?4E4@4]?C5eTVJ^e^]KT[mWa[=_e/=W_/]?VGgJ6B5QU<CY3?T=9?Ci0=cLe
?3de@D4eE5E3LgEOKfmELg5JNG=UKFILG5e=E5Q7Be90ATlnC5=;EEmNE6M^
XKk</]g^[N7fZnChZ^?gZmoe]>Cj]>7f_>;e_Mg/Pi^W=dE>>T57=cPl?3`l
>SPi?C/l>SXj=cLg>S`i@DI2AT]5A4U3?dA0?T<o?D8n?44m>d0l?44m?dA0
@DI2?dA000=1AT803497@d56@Se2?SHl>3E0>3i8?eAFBeYJDU]KFEaSJdiP
MWF>[;koool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool7
T=7g00>Ad_RCdoNDe?P00YCDn00dU]KjVMWmVMWmUmOjUmKeV]OdW]WiXMKh
Z=KgYLkZZLgS[/kM/lgL//WGMXVH@E9LDUeSJFe/JFUMGf1BJFYTEeUD@D8m
@d@lATHlEeE9FUQ<F5I:FUY@DeA<@dQ2?DI5>dU<AEAKSJ2W^M?PZLgS[]O]
^M[]QIn^@eEQ@deF@dY@>3`o@D94>S`i=3L`>C/`@dHeJfeHM7ALO7MQ0WM^
G`0NLg1OJfiIGF9<D5M7D5M?EEmPEfYa[loL/Mka[^GjZ>;hZ^Cj[N7i/n?j
]^Ck/Mc_`^?dQJ2[@U=K=d15>Ce0=cLi>cTj?C/l>SXj<cDd<cPd?D8n@DI0
?T<m0Se2?P05?T<o?D8n?D8n?D8n?dA00090AD42@DI20T15@@0;?dA0>d0l
=C/g;cXd?DLnEeU>GemEGEiIGfAZDfAfMHfU0;koool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hoooood?oool4Sm3f00>@dONAd_RBd_H00Y;BmP:C
doL0F9;BmYGCn9SFniWHniOHn9?Dl9cLn9_EnYgBnZ3AnJKGn:?Bk:KEjJ_F
jK?HjgB>YD=EJCI0C5eRIFY/HFEWFVIYHUIHDd94?dm@B5]MDUUICDQ8?5=E
B5MICU5DBd=:@c]6@SU5ACe<ChFGVkgDg;KFhk7BhHnZ]D1CFU1KGcm7BDY>
Cd12@C/m?3e2?S4f<Se0>D=5>UmPD7MfHX1iIWm_H7a/G7M`GGIdGG9dGVQ/
FeiTFUIPGeY/M[WFi[7NljoVnjKPmZcVo:oSnjoQn;7Qmk3Ml<CXn8NS[dAF
H3I1AcPl?cXj?3Tg>3`j>cPh>3<e=3@i=Ca1?Ci5?Sa3?3Xo>ca1?Ci3?`90
AD42?dA000A0AD51AT91AT91AT82?dA000/n@clj?c/e>cL/>C8iA3aAE4UN
GUANGeURIfYGIgI^QIL0__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Sooooo@oooo`06S/oeSLkdSLkdSm3fT=7gTM;h0Y;BmP1@SlocT];fTm?g
T];fU=;gU]CiV=OjUmShUMScVM[hV=;hWM?oW=7mW]GlV]GcX=cdYMgdYMG/
HXBP@UMb:CA6DEILI6YPJViPCU5:C4i9>3/d>3/bCe56GEmBADLjATXlE5M<
BU14@4Lo>4<k>4A0>DM7Nh^;^Lc@W[W0R:>ZBUeQ?Ta=?dQ5ADM4?SljB4U4
>C/j?D50;S8a=c`h?3lhBd]1KVaOPW][RWMXR7ETPgMQOWQPNGMPLW=QKVmW
IFi]K7f7^]OW[mca[N?kY^3h[>Kn/>Cl[^3gZMW`^NKi^n3bOifX>4aE>DA:
<3Dh@4530SXj>P09=cTh=CLf=3Te=c`h=chg=Sdf>Chj>d0l?T<o00I0AD42
@DI20d15@@0:?44m=S`h=40l>D@nBTe4G5aBHV=KJFm]FV]cHgV7__ooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo@oooo`1<S/oeSLkdS/kd
SloeTM7gT];hT];fTM7eS/kbTm?gU]CiUM?hU=?fUMCgV=OjV=WiTmSeUMOg
W=OoVm7oW=CoUmCoUmcmU]kgV=_eU/oZDgZK=Di]9C59>T5;Adi6CE=5ADQ1
BD]6@4<l=ST`@D@iFemABdm1@dLhDeM9Ade1@4Pm?DTo@Di7?4]6L7mlZ[fk
DVMX@5AC?De:CUUCAda5A4DmB4Q0@44k?T0m>3`k<3Hf;C<c=SPe=cPcE55:
NW1VSgU[UGmZTh=/Rh5XPWeWOGaZOWifNh61TZ2[_m[[/=[`[n?k0Z[Rn`0E
[Moh/>3gZ]cc/N3b/]WZDg5l>dmH;STo<cPk>S/m?3`l>SXj>3Xi>S`k>3di
=C/g<cXc=3/d>Slk>d0l?D8n008n@cl00cm4@415@D56@P03@DI20T15@@0;
?T<o>Slk=3Xh=T90>DE1AD]1FUa?HVAIJW1/GVedH7Ao0;koool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hoooood?oool0HHo@n8k?mHg>mXo?mI7A
mi;Bn97Ami3@m8k>m9?CmiSFniOEnYCBmiGDmiSFniWIo93Em9;GmZCOoi?<
nIgGoiKEoi_Toh_FmHgGm9cKnV>A/ciMO3M7GSi7D4aCC5QJCF5NEeIABemL
DfUWFUaMCEYKBde>?U5D@eMIBde@ADU?ADeDCE9KETMBCV]gLij]Z3e<Ad9A
C51KDd17?d=5>TE5>DQ8?T51>Cm1?3@i=CY0@34g=cTm?30b;cXk=VQQEh]j
J95lIi61JY66L9F=NYFAQI6@S8J>TJo1cl;QljoLlk7UoJgUoZOOn:WKm;3P
mjgOm[;QmIFlcCaJIBi2BcM2B2`a=38d<c/k>cLg=cPj>Ce2?Si4@3Y0?3U0
>Ca3?3U0>@03>d0l00@l@Cdn@cm1AT93B4@2@TM300i1AT8oA40n@clk@3`e
>SH_=C</>SXf@Si5BT=HFTmNGUAVJfMNJg=QLgnnoooo0XS0^058T8P10000
000018S0^<SPf8S0^8S0^?oooom3oooo00B9c?J:c_F<coV?d?P2T]7j00ZC
dOZCdORAcoRBd?NCdOREdoZFe_bFe_ZEeO^CeOP2U=Kh00FGe_VIeOVJe_ZH
eoZEfO`00YCJo019U=CgQkcL@FV3>E=RB5EKHfIOHEY@LV5JVhR1WHf0WI1o
XIV4Qh5[F5<mDe0mFUI:FeM>H5aIEeIDFUaKEUYKKgEe_<G2>T@l@de4@TM0
?d8iATPmB4Pn@d0i?clg>CPc=CH`>C/h:c0/>3hj=3Xf;SLb>chcNgIPUheb
U8UcWY>1X9J<YJ2LZZ^`Y;2l_m[[]Mkb[N7gZ>;hZ>;jZ>3g[=od[]kd[^3g
]>;iW<?D=U=Q<DE>=3m5;C8e;Bl^>CTi>CTg>C/h=c`h=cdi=d4i>48j>D<k
=T0h>T4j008l@c`01C]1?Ca2?Sm5@d98AT55A002@dM600e0A4=1@d10@Slk
?CPb>3H^?3`hA498CDMEEDeNFeIPHV5OJG=NKWd0__ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo@oooo`06RLkgR/ohS<oiSM3jSm3hT<oh
0Y7?n0:Bd?T0;Y?An9CDnYKFo9KFo9CEni?DnYGFo9GGnYKFnIOFmIWFmIOF
mIKHnYCHoH[?mYOHoXk9jGJT_5]kRVUjPFI[IfeVH7=QGH5^IhemL:bOSZ>K
QXf9L6=NB5MB?UeGBF5JD6YUHFEQH61PH5IJFFAZJ<39a4Q=ATaBB4e@AdM:
@DM7?DI6?4I3?4Q5?P8n?SH0:2LX8R/]:3]2>b/d;cE0>Rdg;3Xl9YBBNIF>
NiB<OkF]Z[Fc][2h`kW<gKOJkZoMm:SPmjGQnJOQnJWQn:gPmK3Pm[3PmkCR
nIk4ecQEHc14CC<n@Rhc=S0b<CTi=cTk>3/m>S]1?Ca3?3U3>cI1>CE0>3M1
>3Q2>@8l@c`053a2?Se3?cm5@d57AD=7ATA8Ad=7AT55A494@D53@3/m>30f
<RLe=C<o?DQ;A5UFCFAOFFIVIVA]MVAbOkkoool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooood?oool018W>mh[?n8_>n8c?n@:>coT2S/gf0Y?A
nP0:Tm;kU=?lUMGkU=GkTmCjT]?iTmOnUMKlU]KjU]Ki0YKEmP1:U=KiT]Kk
SmCmV]_oUm7fULKTMYV]Ni6LKGIkNWakPWikNWE_PX1dXJ:BUYN5MGQSFUa7
Gei:GUe;FUQ9HEmCI6ALIFQQG6=LEF1J^lK0BU59BDi7Ce99DeI=DU9:CDe5
BdPoAT<j?c`e=CD]@d@l=3L`<CH`:S4Z6bDM;SH[=CPWAdHbQ89cYJFK/K>b
`lcC`mGS]mCV/mcb[=kgZ>3kYN7kYn3kZN7j[N7g[n7h/=oi]^?jY<WL?EYX
<DE><ci2<SLj=SPg>SXh>C/h>cdj>d4m?D@m>dDm>D<k=d4i0S]2>P8l@c`0
13e3?ci4@414@d14@`93AdH03T96AD55A4=5@T12?cTk=Rhd<2di=CE2>DE9
>eIDAfAPE6MXHVMaLfakP[koool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hoooood?oool2RLkg0X_>n0:=c_P2S/gf00BCdOZBdOZBdOZCd_/2TmCj
03fBdoV?doZBeOnBeOnDeOfEeOVFeOREeORDe?ZAeObCe_n@dofLeonFbn^D
_=FB[l6GZKFT/KNR/;6N[JZP[:RV/jZHY9YRKEmAF4QaMFASI59THe5[K5aY
JeiMHeUBGEE9F574dLY?ETm2Ad16BD1DEdiKFe=JFU9GE4]<BD1:Aci5@S/j
>S90@CU2AChc>34b>C4`=R`h>Rdd=RUDFU2S[:W4d]FgbmK1g^jbe^bbh?Z^
hOjYh?h00ZOPo@0[Z>3kZ^3h[>3h/=oi^N?kZ/gQAF5_<dE?<Se1=SXk>cdl
?3`j>c/i>3Xg>3di>T4j>T@l>dDm>T@l?4<k>d8j>d8k?4<l?D<o?TA0?d=2
?T91@TI5@4A3?d=2@4A3@TA1?d4n=cTd;C<_=40l?DQ2C4i3GE]>K6QMJfaV
J75fL7j70;koool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?o
ool2R<gf00B9c_N:coR;c_R<coT2Sm3j0i;AnP1GTM;jT]?kT]?kSm?jSm;l
S]?mSmCnT]?mTm;kUM?hU=ChU=CjT]KmT]GoS<ojWMcoU/kcYMCbX/OQZl[N
[l_IZ/_D/=7F/<oD]];FRJ6UFF][A4m9I6aQNWa^MGITM7EUJfeOGVIKEfAK
C5aI`M3=DeeE@dQ1@D@mCE19F5Q@GemGIF9IHUmFI65HEeA;A44hA4@j@D8j
>Sdd?D0g>C`e>3/d=3TeGVQWU:JZ_MGO_Mk]Ym3T/n7k[N3mZ]ooZ=onYn3n
Y]omY]olYmojZMoi[Mcf]moh[loTBfEd<dI=<Ca0=c/l?Cdm?Sdk>c`g>3Xg
=S/g=cdi>T0l>d8k?4<l?4<k?4@i008k@SX053e2?3i3?Ci3?ci3?d96AD14
@cm4@415@D=5@Sm1?SPj=c4e=3Do@D9:CEACDFQSGgQcL75`MFUbPG>2UKko
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool2Qlce00J8
cOJ9c_N;c_R<coV@dO^Ad_`2T=7i00J?d?R@dOVAd_ZAd_Z?doZ=d_/2Rm;n
05:?d_fAd_ZCdoVCdoNCe?ZAeObCe_nAe?nHf?nCdORJd?:Sd_2QbnBRbn6S
d^BPdN2Mbm^fg>mNOHm;HFla@4LkA4=^KfM`LF=aLV9RI5IIHEIGHemDI6Bg
alM8DDa2Ad14Ad1=D4UEEDeJFU9THEQYIUe^K61MFdmRH5AIETe;Bd5BE4U1
@cQ7B491@d8i?T9?GV>Z`lZ`e>:Ye>Fjk?nOeO6Ug?^UfofWg?jWg?bVgObW
g_bVgoZXg_R[fO>eg_Bad^E@JWTeATha>Slg>c`k>cTm?3Pl?CPl?3Xk?CXi
?SXi?c/j@CXk@SXmA3`mACXl@c/k@SX2?D8l018n@cloA413AdI1ADA0AD52
Ad=3AD8n@3di>cPe>CPh@4=5BTiAD4iRGEYdKVi_KWA/MHIoT:Bnoooo0XS0
^058T8P10000000018S0^<SPf8S0^8S0^?oooom3oooo0XC;m@:7c?H01HW>
n8[?nHg@nXkAnhg@nP03S<oi00B=dOR>d_V>d_V<dOX2Rm;n05N>dObAd_ZB
d_RBd_JAd_R?doZ@doj?e?jAe?nDeOfEdOJTg?fRe?FTfOROfoNHeO6HcnjY
eoUENI]3G7X]?54^=Cln?SiJEdi/JUeJFTi@Dda<EEAHIFf/^KlkA450ACm5
B45<CdQGEdmIFE5NFe9THUIUHEITH5EEDDIbKV=iMf]kNFedLVI@CdYADE<m
@DY7FF>Xa]6dgo2YgO:Rg?BRg_ZSfobVfofYfob[g?f[g_fXg_ZWgoZWgOF/
f_:ggOBge^YIL7hlBU<c?44i?Chk>cTl>cLl?CPm?C/l?S/j?c/l@Ce1AT14
BD8oA3e0AS`oA3dn@c`l@C/m@Sa0AD53B4A2Ad<00d56@P0<@48o>cdj=cTf
=S/g@4I4Be1<E558H5aCLFaVJV]]JgN3QYVZ__ooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Sooooo@oooo`:4boD2Q/_e00F7c?J9c_R:coR;d?V<
coT00h_>n004S=3gSM7hSM7hS=7j0XcCo`1>S]?lS];iT=7gTM7eT=7gS];g
T=?mS]?lUM[oTmSoUMKlV=KkU=3dUMCeTmSiU]cnX^3oWM;lK9K0@Uj3;d1L
=3]=>3LlAD8mCTXoBDLkGEiHHfUYHFYcRI>L?dE5@TM1@48mADQ1EUM?GEeE
GeaCI69FG5Q=F5A9HEeALFeQLfmTQ81eKFUNF5E@EE=HD5APAUQV[<gL/=oa
WMO]X^;mXN7mY]omZmgn/=ko/Mko/Mkm[=kiZ=khZ=cd[mcc^]kd_M[/GgJ4
@DmH>413?T0o?Cdk>cXf>c`g>c/i>C/h>Chj?dA0BDi8DEI?0T57?@08@DHo
?d@m?D8l?T<m@TM3AT]7@DI2@4E10Sm4@00<?Cll=cTf=3Hc=3TeA4U3EEQ?
H5iAKVYNO7U`K71_IGJ0OiBU__ooo`:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Sooooo@oooo`:4boL00hK=nHO>nXO>n003Qlkh0XcAn`B<dOX01XkA
nhgBnh[Anh_CnhkCnY3Dn@>CeOP00i7EnXkBmi3Eo002TMWo01ZAe_fAeOZE
eoZDf?^Ag?bAfojGf?nMe_n2[MPUAF`mD6h^=TTl?D92?CUGD4IEDDEDE4aT
IVEfNh5PIfdj@412Ad59BdI2ACi@DDUEEDd2GeaC02iLF4eBCT=XI5QcKf>4
OW:2O71dKV9JEDmDDUMCEf=3EF>[c=fchoNVh?RPh?^Qg_^Wg_f_h?nfhOnf
gofcg?R`g?N[gOJ/g?>ggoRkg_C6hoEXOX/oC5@oAdXn@3ln?S`m?3Pg>3<l
?3Xl?S/m@Shn@cm4BD=KH5U<CdI3AS/n@CQ1A3]5B454Ad02@T@o0115AdA1
@d10@Sm0@Slh?CTa=S8d>CDm@Sa8CDIDEdaYIeYgM6EgMfebN7IPLWj=YkRn
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooom3oooo0XC;m`03
QLchQ/giQlkh00F7c_P2R/oh00V;d?V<dOZ=d?Z<dOZ:d_Z:d_R<d_J>d_N>
d_D00Y3Bm@13S];eS];gSmGiT]SlT=WlSmOmSmSkT=WlTM[mTMgmRmKfTmOl
W=SmT<3X@FF9<d]W;S];<SDjCTe8JfMLJ6AHLVmVKFiYJ6a]Ri2CBdm>@4E1
?T0k?T4jCe1:CTm7E5A:FUM>E515F5A9M71TMg=WOWQ/NWAXKfUMFUE?D4]A
DEEPB5YX[/gO[mkbX][cY^;nZ^KoYmgi[mkj]=_h/mSc]=Wc]Mog^>Kn_>Wo
`NOnaNGjdNcmKXBA@4eE>D54?3hm?Shl@d8n?Slj0090@Sl03Si3?ce2?T56
@5MLEEQKDTiAAT=6?D13>T95?T=6?d=5@494?dA6@d53@090@Sl033Ll>30e
<C@i=Ce2?TY?BEIID6YXG7EaIW5bK6]eMV5fQi>_aKkoool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hoooood?oool00h?:mXC;mh?<m`02Q<gh00N5
c_V6coZ7d?^4cOJ5c_N7c_R9d?X00hcAn`03S=7jSM;iS=;f00:=dOH3S=3e
00F=dOJ?doJ?eON@e_RAeoT00hoHn`0/Sm[jSm[gRmG`U=WhUmKeXmGfMj2l
BfYoAUYUDUeOKgA^N7Y_LgAVNWY^L75YJFiXV9fI>cdj@48o@T@o?3lhBda6
CTm7De=9Cdm5BTPlDe55KFUNKf]PMW9WNGEZK6EKDdi8DdiBC4mHA5AQZ<GE
[]S^Ym_cZN7lY]ki[Moj]N7j_>7k0[gQn@0>_^Ck_NOo_NOo`^Kn`n?hd>_l
M8RCA55G>D53?d=2?d4n@d@o@44lA4I30T15@@0K?T<o@TM1EeaEH6=HFE]>
C4i3@d@l?d8k@D@m@48m?CljA4I3@TA1@D=0@48o=c`h<CHb=S/g@DI2Ce=B
FE]HK6UTLg1[K6i]IFmhIX2GVkgI0;koool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hoooood?oool2Pl[f0X;;mP08PlcgQ<oiQM3jQ]7kQ<gfQ/oh
R<oiR]7k0XgBo005S=7kS=7jSm?jSm?hS];g00>=dOP2S];i062@e?V?doJ?
doJ?eONAeoV?f?V?f?^?f?V?fOJAfoBGgONDe>nRfoJSdnYmX[EXQ91hRi62
T91oRH63R85iOgE]LV]PIem@EDm2A453AD93AD0n@3]BDdeIFU9NGUIJFU1;
B3mIEd]/JUi/J5eeLFImNFiZIUeBCDMGEEI?DUM<FVFZa=>cenf]foF^h?^V
fOBehofli_k1ioc1iO_0i?Zni?^khobhh?W0i?bmgO;;iOIiSIQ:EedmADM2
ATDm?ca2@ci0@Se3B4A1AT90AD4oA412Ad5EFU=PHUMOHEAFF4e:C452ACa0
@c`n@3/j?3M4AT=2A451@d0n@3df>cLc>3@l@Ce8CDU?De9JG5UZJFA^KFQU
JFYMJgAZRIjQa^6noooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oo
oom3oooo18;;n00FP/ggPlkhQ<oiPm3jQ<oiQM3jQm3iR=7jR]7kRM3jRm3j
RlkhT=7iT=7gSm3hSM3jS]7lS]?mT=?nT=?mTM;jTM;h0Y7CmP1FTMGhTMOi
TMOiT=KhTm[hUMchU=WfU]WdVMO`YmofW<_OP:NhQjF`OIBLQIJMR9JGOh^;
N8=oG6MS=d0kAdU6>3Pf@D8mH65LP85kK6eUDeA<ATPmB4PnG5aBK6aRJVMN
J6ELKV]RGU]DDDi9FEUGFEiQH6ef]<WJ^][a/MSe]^;o]nCo]n?l^^Cj^n7d
^=ka^=kc^^3g^n?l_N;l`>Cl`^;gdN_lRIfXC5]P>dE6?TA0>SliA4I1@dE0
A4U3@4M0?TA0?48n?44kC55:GEmBHF=EGV1CDUA9ATLo@D8l?d4l?T0k@dE2
@48o?Cll>C/h<cPd=CXf@DI2CU=?C5=<EeaE0VU[H004GVQOEf]ZKY:NWl[K
__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo@oooo`>2boP0
0h7;n8;=mh;=m`02PLkh00B3c_R4coV6coR6coP2Qlkh06Z9c_R9c?J>cOJ>
cOJ>coV<coZ=d?f=dOn?dOn?d_n@d?bAd_ZBd_RBd_JAdoJ@e?NAeORBe_VE
fOb@e?N>doBJgojFfOBHf?6Rf_>C`mZ7/<IgUjb?Z;b5V:N2U9iZNH0oCU50
C4a8C4/h>3Hf=c97B4=SI5iJFeE?D4Q9BT97AceFETaQHEMSHeUVHea[J65I
ETmCDTeMGeYKI6=NJg>]`=70g?BjfoZgg_fjhonghOZihoVjhoFiho>ih_Ji
h_Rhh?VhgONkgoO7j?_FlOnJ/;]=G64kADI0AT93B493AD10ACm1B44nACho
AD4m@cll@C]9CTMIFdiNH59NH5=DETU8BD51@SY0@Se2A3m0@Slm?c`j?3Tf
>3Dc>3@g?3Q3B4A?E51AEe=LHE]/KV=XJf1PJf=MLg5jX:VNc]bnoooo0XS0
^058T8P10000000018S0^<SPf8S0^8S0^?oooom3oooo0X7:m`:1boP018;<
nH3=nH3=mgo<mP:1c_P04X?>n8G>nHK=mhO>n8W>n8[=mhg<mHk<mHk=nHc?
o8g?ohc@ohgAohk@oho?oI7@ni?AnY?An0:AdOD0?Y?En9GFo9CDohkAoXoB
o9GKoiOMoi3EmYWHnIgEn9k>lYo7jk7BmJo:j:_1fF5fRCa@Fci=DSXn?cln
>Sho>STj=DQ9@dU:A4M8@411>DQ9@E9CBeYKDfMXH6e/Ig9aK5iMF65RG6I[
IEeWIUASJYf``L?KmL;OokKInK?JnKCNmkOTnKgXnKkYnKkYo;cUnkKNn;;G
l[OKllGVnLoZnj6g`T]JGcm;Bd98A4M<AT97@3m4?D58@Ci5?P91Ad<06Se4
?DQ=AUIHBe]LCUiPDe]MD51ABDE6?T52?D93?Sm1?S`n>cTk>3Li=SHk=c]0
?4E:ATiBDEUNHV=XJg1bKfI[If=_KFAlP8>]^j3@i;koool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hoooood?oool2P<[g00J1boR2c?V0cOUoc?Qo
c?J0boD2Plkh01:4coV5c_V7c_R8coV;d?Z=d?^=c?N>cOR>c_Z=d?f>d?n=
dOn>d?n=con?cofAd?^Cd_^Bd_P2T=3d02bBe?NEe_jBeOnEf?nDfOn9c_FD
f_j>e?J>d?>IeobJcoNVe_jOa^f`d_N`cN]EKhILMXM5EV1CEeY>CDU7AT8o
?SU:BT96ASi5ACe1@SXl?CM=CTQJGEIYJVAVIf9THeiEE4mVIf5]LVaXLG1L
JG:M[/33foG0gO^deoFih?fcgoRdh_T2]^?h02bgi?^hi?fih_jfh?VggoRo
hoVog_2N]/99F5e5Ce0oAD50ACi8CDI3Bd12C4<nB3m0BT91B44j@CU2B3iH
FTmLGU5SIEYVJ5eNH5E>CdM4ACm1@Sa0@Sdn@3dj?c/i?SXk@3a0AD57C4Q=
DE1KH6=UJFa`L79RIVUSKWAVOXZ8/L>LcnBnoooo0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?oooom3oooo00Ukb?AlbOEmb_Imb_J0b_N1boR2cON5
c_V4cOP00X?<m`07QLchQlkhQlkhQ/ggQlcfR<_fRLcg00>:cOP01h_>nHo?
ni;BoY7Bo9;Cni7Bn93Am`02Sm3f04f@e?NBe_^>doZ=eO^@e_ZAeoVCf?VD
fORFf?RGf?RIeONKdoBPd_>We?>Zd^bN`MN5XKIcQYATIfaNFUMQG5Q^JV5_
Jf1@C459ASe4A3a6Ad97BDI@E5=IGEa[KFYJFeIFETiLGEE[K6MWK6mIHfnE
Y[[0f?Bmg?Vig_RkiOfehoZchoZeh_ndhonbhOn_g_b]g?R^gONgjOndh_[7
k?nU_la>GFA<E5I0ACm;CTE6C412CCm1CCm0CSm2CT13CT16C417BT5BEDiK
GUMQHUYLGU=WIe]PH5A2@SQ2@c]5B450AClnA4000S@j>00;@TQ6BDm=DUMC
HfIOJ6UTJVQ[JVYdGfQiKhFJV<7GX=;Y0;koool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooood?oool2O/gh00Z0cOUoc?R1boR1boR3c?N4cOR7
c_Z6cOV5c?R6cOT4Q/gg0X[?n@1IS<ojRlkiSLkhS/oiT=7kTM;lT=7iTM;j
TM;hT=7gSM7fS];gT=CgT]KiTMOkT=KjSm?fSmCeT]CdUMSeV=[jVmcjVM[j
VmSgWMKdY=OfZmWcZ];[Wl;HV[71VZ6WUYFCV9F@VIF<RhMlHemDE558A4@l
@D4oBTa;D5AEDeMHGf5NEeUDEeU>H69GIfQSIFU/Ef1_TZ:i_=Ka]]Sd/][c
/n7h/>3f[Moh[]oo[moo[^3oZmgnZ]gh[>3hZ=kh/n;l_N7gVkG4B5ENCeAG
ATQ3A4Ln@TPl@4/k?ddn@U11AE53AE12ATa0ADPoE5UCG5iIIFIPJ6QNKF]O
JVQKF5I:BD/n@4<j?D8k@DM3008i@Sl02d9;B4M=Be5FD6MZGf]/I6e[KVY/
N6=^PWF?Z9W5gZ7Dk`2noooo0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?oooom3oooo00AjboQkc?UmboUmb_P2OlWf00B1b_N2boR4cOZ4cOX2QLch
00Z3c?N4cOR6coZ7d?^:dOf9d?b:coV;d?Z<coZ=d?/2Sm3j0Xo@n0:@dOT2
S];g02f?doR@e?VEe_jDeO^CdoNCdoJEeORHfOVLg?nNgonKfojJfo^Je_RN
eOBUe_BZf?:[dnb]c=jP[KJJWZ6LW9ZNWIRBShI`KFASH5M>CTI2@ci=Cdi:
CTe=DE1IFeQQI5eNGeMQHUYUJ65UJf]HI72DY[ZkfO>ffoJ`g?FahoZ[goFX
g_RXgOd00ZWMo`0[YmclY]cfYmgeZMcg]^;k^=_aU:^kC5IPCe9GB4Q6@d@n
AdY1A4`o@De1@U13AE55AU15ADe2@dQ1DEI@FUeFI6EMJf]OJFMJJFMHIF=F
CDe1AdQ0?T<l?TA0>44l>d4mAD]7CeA@GF9KJFaQKFiVK6a^If]gI7>8O9Zd
Vl[VW=Gb0;koool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?o
ool02gO8mGS9mW[8mW_9mgc9mgo9mX;;n8?<nH39mX7:mh;;n002P/_f00Z3
c?N6coZ8dOb8dOb7c_Z6cOV9c_R;d?Z=d?^<coX2SLkh00B>coN?d?R@dOV?
doX2Sm?h00NAd_ZCd_^Fe?fJeOfMfOjOfonNgOl00YgMo`1@V]coV]cnV][m
V]KhW]GdX]GbY]G_[M7W[/7?V:>YRI6CQXZ9O7egI6ALIfAMFe]CEUEAH61N
E5ICDUMCE5IAG5mHDU=;DeI=G65JGVMVE69[SZ>f]MG^[mWbZ][aZ=kfZ>3g
YMkiY=cmYMgoY=coX][kXM[eXmWa[]gg/=Sa^=O/QYVZDUYUCU5FB4Q8B4U4
D5=<BE56@Ti4@4e3@di6ADm7ATe6ADY4D5E?IFQQJV]SKViRKVYNK6UJKVaM
Fea>D597@4Hl?4<l=T0h?D<oBU5:EeaFJfiWKFmTKVmWJfa`HVYgJ7Z@PjG1
V<g/VMKe__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo@ooo
o`09MlWhN<[iN/_jO<[hOL[hO/_iP/ckPlglPL_j00:2c?T04H7;n83:mh7;
n8C>nhK@oHG?o8G>nHC=n8O>nXW@o8cAnhg@nhc?nXg=nHg>n8k?nI3An@02
TM;j05Z>d_V@dOVBco^FdOfLeOnOfOnQfonPg?nMfonJg?nFf_nHg?nKg?nJ
f_fLf?ZQf_RVfoZ]fO;1g_2U^LB;VZ5iQ8IVK6Y?DDaPGeYYJF5PGeYWJ69K
GEQIFeIEEe9HFUE@DdaGFU5NHeaRJfQHIVn?Y[RceNj[eo:Rf?2QgOFShOZN
g_ZOfofPg?nQfonOf_ZNf_BRf?2/f?6Xb^>id^Q^OXiCFVACE5U>C4e>CDUA
DTa;D4U3CDE1C4A2CDM4CDQ5BdM5BTI:CdU[KVE[KF9ZJee`KEi/JEQ^KE]Z
Je]FF4]5BclnACdl@c]3B49@EDiKGUMYK6=cLfMaLVY/L7=SKg]]QIf:/lnI
dO:GfO^noooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooom3oooo
0WS:n@06N/_jNL[iNlWiO<WgOlWhP<[i0hC>o@05P/ciPL_hPL_hPL_hP/ci
00:3cOX01XC>nhO@nhWBoH_BoXgAoXg@n`:=cOT0GXk?nHo@nY3Ani3AnHkB
nHk?nIC?niK?o9SAo9[Do9_EnicHoI[HoISJoICHoIGJoiKJoiKHniSGnYkJ
o:CMnj_Mn;7Gk:W6eYN^_7nBVFMbM4A:B55CCVATG6YZHV][HeiOFE]NEf=U
H6QZIEaNFEULEFI/HV]dKem`Mi>]_[CHlZ[ImJ7IlYoMmYgOnI[KnISHni_I
oYoKoioJnYkJlZGIkkCJlK7=hkC9fUe[N5=GH5QGG5MFE4i=B4]<ATM<ADA>
AT9=Ad=>BT9=BD=<BDA:AT=8@VEXGfYZH6MUF6m/GF]XEfYWEW5bH6EWFE=G
BDE;@CY1>D15?U1FC5ePEfa^HgMeJG=cJficMVIfPgFCZhnng9CCm9CJo;ko
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool017G9n7K:
nGO9nGO8m`9iaoL017_7n7c8nH?=oX;<n`:1boX02Wo<nWk;nGk;nGg:n7o<
nX7>nX?@o8K@oHSAoXW@o0:<d?d0A8c?nX_>nHg=nHk?nHo@nY3Anho@nXo>
nI;?niC?niC?nIG@n9KBmiKEn9KFnYKHni;Fni;Ho97FoI3DnICDn9[InZ3K
njCIn:WGlK7Gk:70e82JYfUjPT==Cd14@dY;AFYZHWAdJW1aJFMXH71cK6a^
JE]MF4Y<AfAWGVQaK5]/LhjX^JgBk:7Bl9OCkiGFlY_NniOInIKFnYWGo9kH
oJ3Imj3HkjKFj[OGk;;9fi>U/eMQJU9EFU5ADEMFDTm?Ad]<A4]>AdQ?B4E>
B@92CDT06TA=BTM=BDM<AEaOE6e]HFi/GFm/Ffm/FFaYEWAcHG5bI61TETmE
BCe3>D13>U=FCFAUGGEeJgQdJG=cJg5iO6j2SGnS^IG8iI3Bm97JoKkoool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool057C8mgG9n7O9
nGO9nGW:nGc:nWk:nh3<oGk8nGg7n7c6mGg7mWg:n7k;nGg:n7c9mgc:n7k<
nX;?nh?@o0:5c_/018W=nX_?o8g@oH_>n@:=cOT2Sm3j00J>coV=c_R@coZB
d?VCdORDd_L2UMCg00>EeORBe_V@e?L00Y3FnP1=T]KkVMWmW]gnYMgoY=_j
Z=_j[mggSkS>IhJHFW1m@DiF>T94?T0m@T<kJVYPPXAiLWAYLGA[IfYSGf5N
DeE@HfALJW1/GFacSJJj[=7/XMCcVMCbUmSfW=knV=[lU]KjV]KkW]KiX=Gd
X=CZYm;S[/WJXK?1IWAmDEYOCE5@@T<nDe19DU98De=9D5=:Be9:ADm7@DY5
@Da6ATm:BE=;Ada5CU56JF]NKVaMIfACKFQEIV=@IfIDKVmOIFUJG5mDBDm3
BDa3FUeBJ6YOMgM[NgM/M7E_MH22M8nJQk77V]7_T=CgTM_o0;koool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool2L/Ke00Ada_Ifb?Qh
b?UibOX2NlWi0go;o003O/[kOL[hO<Wg009jaoD057c:n7g;nH3=nh7>o8;;
n87:mhK:nH[>nh_>nhc?o93@o9;BoY?Coi;BoY3Anhk?nHkBnHc@mhoAm9GG
n@:Kg?`0DYKHn9;GmXoCmY7GnIGIo9SJoIWHni_GnJ3FnZ;HnYWAlZ?JnHnl
fDIZPU1[OSU;EcDn@cTm?413?4A6>eYLDGYlLH62NVe^J5UIEeIGDV=SFF]`
JTeJHiJ_`jG:iic>kigHnYKFnIGGnIOGnikIoiS?mZ3BmIk=jI_8gJC8e[36
df9aN5EPI51IF4e@BEEGC4Q6>Ta=?eMGBe1DATU?ADA;@ci8?ce7?d9=ADYD
BdE:@eULDfQZGFm]GW5^GFeZEfUVDfMVE6a]GFIZFeePEEQNDUmREfEXGG5c
J820M8f9P8F7PWf<ShFS[Y6oeY;=jhoCmY7Kokkoool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hoooood?oool2M/[i0WS:nP04NLWjN/[kO<[jO<[j
0Wg9nP9lb?T03gc9mgg:n7k;nGo<nX3=ngo<nX3=nh?=o8?<nH?:n8O;nX_?
oX_>nhc?o93@o003TM7m05Z@dO^=d?Z>doZ<d_J=doFCf?VIfo^Ig?VFfOJE
eoNDfOZEfObGfObHf?bJe_ZJeONNe?ROeOVRg_nJe_ZA`n@dGGU1GgLfBe`h
ADhe?Cm0AClo@SU7BCiIFe1ZJf=^KFQVIF5NGEUaKVMXJVMAGVN;Y;ZXc>bQ
doJLf?bGeo^Be?NEdoRId?NMc_JOc>fLa=jTbM^dd]a^OhM5CU=9DU5=E4e<
CdABE4I5ASI6AcMAE4=@DTA=D4E9CdE4C450BT52CTA9DdXnACe:D4IMGe9Z
Jee^KE]]JUMZIeIVIE=VIeUUJE]PHeQIGe=MH5ERIEY^KVAkNg6?S8N7Rhb2
UYf=/KnHc>:Bdo6=doF>f?fnoooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?oooom3oooo0WG9n004M/ShMlWiN<WhN/Sh0Wc8n@0;PLgnOl_lOL[h
NlSfN/OeNlSfOL[hO/_iPLklPL_jPL_h00:4cOX01hG<nXS<nH_>nhg=nho?
oI3@o97Ao@02Sm3j05Z>dO^>dob=eOf;eOZ?eOVCf?VGfOVGf_NFfOJFf?RG
g?fFfobGfObIeobLe_^Ne_VPe?VNe?RMgOnCdoVIcoE6Li@hFWHhDFLfAU<d
?d<nA48oA3do@SM5AcaKFe=`KFQ/J6ELF5E/JF9PHV5IIG6;Xk^Zd?BQd_ZE
d?R?d?JAdONIeOZKd?RTd_J3Z/UGMhi7I796GF=9EeY1BTU:D4a<DTQ=DD9A
E45@DCmADT1<Cca=D3m>DTA;DDE7CdA1Bd12CT96D4M5C4A8CDILGU=_Kf=b
L65_KUa/JU]UHeAQHUAWJeeXJf1SJEmWJV5]L6EjNW26QH26QXJ6SiJ8XjjE
`=6KennBeoJ9d_F;eOZnoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?oooom3oooo00]aaOAba_EcaOEeaOIiaoMjb?Qlb?UmbOZ1cOj0c?emb_P0
0g_8mP0<O<WgOL[hP/ckPLWiP<WfQ<_iQLcjR<ckRLciRlkkS/klT=3l0Y7A
o@09Sm3jS/oiS]7kSmCmSMCnRmGlSmCkT]KiU=Kh00:CeOD0DIGGmiSJo9OI
o9KHni[HoIoIoj;Joj?Go9oGo9;CniCEoI_EoG:Rb3aPPSUDKc=6Ec]8DCQ2
@cm6?d13>453>5AABVMRGVAOG59=BV=PFf5UIUYXMI6[a:K>lYS<m93>mho@
n8g>m9KBmiK:lJcGnWZL^4QSN3mFGT=BED18BTI:BDA9@dE;@DY>?d]@?51C
?U=F@D]>>d]>?DY>@4U<@DI<@T=;@49<@D5=@dA>AT17@5EHCfa^Hfa]GfYX
FFUWF5mPDUeODVEXGFI/HVAZH6Y]I79eK7amMHB6PGYoQHNGY92da9O;h9KI
m8kIn8[DmhgGo02noooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oo
oom3oooo0W?5m006MLKeM/OfNLOgNlWiO/[kOl_l0Wk8m`0;OLOfO/SgOlWh
P<[iOlchP/ciPL[gP<OePLSfQ/[iR<ci00:9c?T03Xc<nXo?ni7AoI;BoY7B
o8g@nXc?nHoBo97DohkBohgAoXoBo9;CnI;BmP:AdO@0DI?EmiCFnI?DnYCE
niSHoYoKoj7Koj3HoI[DnY;FoI?FoiC?nI31jU1hW3ACLS16GCY:Ec]6BSe6
@D16?4U;@5iKE6iYIFaRHEaDDVUXHfidM55QL9:]b9c6k9;9lYGDoI?GoYCE
niSDnIK8kJgEn6^9XciCI3]=DDE?D3Pn?Se1@3Pm=d98?TeDA4eB?TiC?E1C
?U1C@4a??TM9?4A7?4=9?dA<@D9<@Cm;@D9;ASa2?U9ECVY[Hf][GfUZG6Y[
GFAUEfIXFfY]HVM]HfI[I6aaJW=fKGQiLG]oOWV2THnX_Y_8giGAjh_FmHWI
nXgHohoJo`2noooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooom3
oooo0WG7mP9ea_D017S6mWW7mgc8nGg9nPAnb?L2OlWh00inboN1boR2bON1
b?J5bOR8c?^:cOZ9c?V;boV<c?Z?co^@d?bAd_b@dO/2SM3j00N>dO^@doj=
con<c_n?cofAd?^Bd?T00Y3>l`0nTM7eTM;hT=7iTM;jU=GmV=KmV]KkV=;h
T]3gT]GoSM3jTLchV<_fMj79@V>6>51Z<dAD=T=9>T=2ADY3FeeBMW=/PGUf
NFe]IemMKVmZLG]lC5m^Tk;>WL[aU<ghU=GoS=7jS=3gU=3eVlgb]MckJ8BJ
@UAR>DA6?dE3?D52?Cln=S/e@DLmCUA6CUE3DEI2DUM3DUE4CU12AdTn@TDl
@dHmA4a1@Ta1@4a2ADi9?dQ5D5E?IVUPK6iS0Ve]H@0AJF]NJfiSJW1VJFiW
KG9[MW]dNGigOh1jPHJ9Q9FYV;ODW]7^T=;bPm?dP]KkR=OnRmSo0;koool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool067G7mWC6mGG6
mGG6mGS6m7[7mGk8mgo9n8;<nh7;nX39mWk7m7g7m7k8mGo9mX3:mhC;nHS<
nhc?o8kAoXo?oHc<nX_;mhg=n@:?co/2Sm3j0hgAn01ISM3kSlcoS/_oSl_o
TlgmTlkjT/ggSlgfSlkgT=7iSM3jS<oiSM3jT=7iT];hTLofSloeRm3iRlkh
T<giVlkiU/3ZK8jcDFZ8@EIY?4YCAe5BF5mHL75YPGigQgekPG=cM6YYLG=^
KgYlEfamU;KBX];jTm3lS=7jQLgeSmCkT<kcV/c_[=?`Eg:7@E9L=T0o?T<m
@D94?3do>3di>T0f?THgA4djATdkBThmCDm1CDm2BT]3A4M0@dHo@TU1@D]2
?dY2?dY6?DI5Ada8FUeFJ6UQK6aPJVYNIfULIVUPHfQQIfaVLgYcPXN1QX^4
S8f7T9RKVJg6W/;VU]7cRM?fP=GjO]KnPmCoR=Oo0;koool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hoooood?oool3NLKb01Ela_=nb?F1b_N4cOZ5
c_^1b_Mob?Ema_=laO9ma_=obOJ3cOZ6cob9cOZ=d?f@dojDe?nBd_j=cOV;
boN=cOT00Xk>nP03SLgiS/oiSM3j00:<coT0FH_>nHo=ohk:oho;oi7=oi;?
o93=nHk=n8g>n8g@nXc?nXW>n8[=n8g>n8o@nY7@nI;AnX_>n9CEoi7>nYW>
nYO4kY6ggVV6YVIlTe][N6ehO7j4PXJ7PXR4PHZ2P8j4QHb7RgImPfanRVEo
UXjee:3AnXo<n8cAnhoHohgBnHg=lI_@lZ_Dl55]PT=EGc@n?CTn>SXl>c/m
?497@ce2>cU1=459>Sm5=d55=dE9>d]=@T]<A4M8@T95?T15?T58@3i8@3]7
AC]5A497@EIGCfm/HgQfJWAbIW5aIf]^IfU^J71eKh>8Q9:HU9FKVIZPX9n]
]ZG4hI[:l8o?lh[FnXWLohGJohKEoh_Ho`2noooo0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?oooom3oooo01:1a>j3a_23a_20`nf3a_2;c_R>dOb:
coV5bOIoa_9ma?1naO60ao>1b_F3c?N7c_Z>c_Z@coX3TM3k00F@coZ>coV=
c_R<c?R=cOT00hc?nP0=RlkiRLkhRLciRl_iSLgkS<cjRl_iS/klT=?nSm;m
S<ojR<ggRLgj00:;c_/2S/kj04Z?c_Z>cOV@coZ@cOVAboVDb_RIc?VJaNn>
/=F0VKMmSZ:3RiR;SY>DU9JDTYF?SI2=SHn:TI^0TZR1Wk^<[lnE`NJIcOFE
d_j>dof:dO^9d?ZAd_RGco:Lb^A<KH0cBE@/>Sdc?3/i?C`j?c]0ACm5BTA2
Ad0j@3Hl?cI2AC`n@CQ1A3]5AT16Ad55AT12ACa1A3/nAChjBDHkBTDk@3U@
CT9fKV>BRWmkMfioO7EnOgUkOGR5Qh:FViNPYZJNZJfT/[fV`]NJcNb@dON=
doN8d_N6dOR8doZ;eOb=eOfnoooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?oooom3oooo01b6a>^9bNn<b_>;b_>?c_NGf?nJfonFfOn9c_R3b_B1
b?:2bO>3b_J3c?N4cOR7c_Z:boF<boJ=c?N>coV?c_V>coV=cOV;c_V9bOF8
boJ9c?V:cOX2Rlkk0XW=nP05RlkkSM3kS<ojR<ggRLgj00::c_/00hO;n8W=
nXW=nP02Rlkk036=cO^>c_b?cOb?c_Z=c?R?c_V@co^@cOZEcObHboJD_^J>
[m2@Z<:BXKBGXJfLYJjPZK:OZK:N[KBL//2H]mBE^n2G`NNHb>jFcOJBco^>
dOb:dOf8coV@dOVFdO>Mc>I7JWddC5H^?D8c?3/e>cLf>cDj?cToA3hn@cdi
?SPh>c@i?3E2ACi4Ad16Ad57B495ASh00TA5?@0B@DI0=4<n>TU4?dDkAD<g
HUY?Uhj5UiB?SY2=Ri6ARiBCTibKWZRYY;6iYKS6Y/7FXl[WTM3c0X[Dn@05
R=;gR=3fRM7gS=7hSM;i0;koool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hoooood?oool03H_:lhg>mXo>nHo@nY?DoYOJoi[MoiOLohS<nH?:mX78
m87:mH7:m`02OlWf00b2boJ5b?F8b?B9bOF9c?N<c?R;c_V;c_^:c_^6bOJ6
b_N6b_T2Ql_j0XS<n`06RLgjQ/[gRLgjRLgjR<ciQl_h1HO>nP0ZRLgjR/kk
RlkkS<olS/klSlokQlcfRm3iSM;lS=3mSlomT/okU/_cV<KXUkcIUKG<U[74
V[G6Wk[;Wko>W/;BX<KKXLgZW/c^V/c_U/cbT/geT<ojS]7nS];oRLkhSlkg
V<k`VLGP@5mc=TYE<Se1=C/k=S/g=CXf=c`h>Slk0Se2?00K>S`g=SPc?T0k
?d4l@D@m@TDn@d@nA4DoADI0@dQ2=4<n>4M2@TPn@D4gD4a3QXF0X:BUWZV_
UjR`VZjgWk>lX;S2X[k<Y<CIXl[WW<kaT=7g00>:e?/018[BnXWAnHWAnH[B
n[koool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool00i3A
nhkAnhc?n@02R/gg0XcAn`0>R<oiPl[fOlScO/ObO/WcO/SeNlSdO<KcOLOd
PLSfQ<SgQLWhQl_jR<ck0XW=o007QlkjQl_jQLcjQ/[iQ<_iQ/[iQ<_i00:6
b_T018G9n8O;n8S<nHK=n@:5c?P018O>nXS?nhO>nXO>nP:9cOX2Rlkk02>>
c_b=d?^6cON9doZ;e?n8dOb8co^;d?ZAd?^EcoFHb^^Ia^FHa=nLb>6Nc>BM
cNBJcNRIcn^Fbn^Fc>jEcO2CcoBAd?V@dO^>dOj=dOj?co^AcoJJc>n@^]<h
EFLfB58f?T4h?3/f>ST00SHk=`09=c`h?44m?d@n?d4l>S`g?T0k?d4l@48m
@4<l00=1@S`05Si3?CU5@CE2>ce2>dE6?TQ9@eiTI8:AV::haJ2mcIg0dj33
eYo5f9g7gi[9iiK:lI;=mHcAnXWCnX[Dnh_Eo8_Cn`::d_X00h_Cnooooooo
o`2loooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooom3oooo00F>
dOb;d?Z6boF2ao60aNl00Wo6lP0;O<G`PL[gO/SeOLOdOL[fOL[hNlWgNlSf
O<WgO/SgP<Sh00:1bOT04H;:nX?;nh?;nh?<nHG;o8?;nhC:nh?;nh?9nX;:
nX?9nXC;nHK=nhO>o8S?oHK?o8?<n@02P/_h00>4cOZ5c_V6coX00XO>nP0T
RLgjR/kkRlkkRm3jQm3iR=?jR=?mQ]7kQLolQm3mRlolS/oiT]3gU<kdUlod
Um;dUM7eT=3cSM7fSM7dS/kaSlobTM7eTM;hSm;lS]7lS=3mRlkkT]7mU]3h
X]3dRZo:>E=T>dUB>d14>S`k0SHj>@03=CTh=3Te=S/g008j?c/073Pm>DA6
@dA6@DE7@TA6@D=5@412?C`n>CPm=cE2>c=0>CHk=3m4?T16ASE2B5]eQ9^o
eIo;i9S:iIS;j9[?kYO?l8k<lh[=nX_BohO@nHK@mhSBn@::e?/2R=;i00>;
eOcoooooool0_?ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo
@oooo`03Q<_ePLSbO/G_00=ka>l05Gc5l7_6l7k8mG[7lgW6lW[9m7c:n7W:
mg_9mgc:nW_7n7_7nGc8nWc8nGc8nWc8nGk8nGk8mgo9nX3:nH79n@02P/[j
0h?;n`0;Q<clPlciQ<gjQ<kkQ<gjPL_hP/ciQ<kkPlkhQ<ghQLki00:7c_X3
RLgj00B9d?Z7d?V7d?^6dO/2R=3o00>9d?j:c_f;c_/00Xg=n@0:S<chR<gg
Q/giQ]3mR=?mRmCgS=;dS=;fS=7hS=7k0Xc@o@0<SlomSlciV<geY=3cO:2j
?EAT>TU@>Sm2=cTh>Cdl=c/j=CTh0S@h=`0N=CXf=S/g=c`h@48o@D=0@TA1
A4I1ADM2@dE0@48m>d8k=3li>D@l>3dg>3hj=T539CU4DGB8VLSTULg^S<_^
SLgaTM;hS];iQlkjPlooQmGoQM3jQ<keQLof0XSBn@03QLofQm7hRmGl0;ko
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool01G_4kgW2
kGW2kGW3l7[4l@03N<Ga00Uia_Afa?9e`o5ea_=faoIeaoIfaoIhbOQhb?/0
0W[7n`09N/SiNLKjNLOhNlOiNlOhNlOiO<SiOlWjP<[k00:1bo`00h3:nh3:
nH3:n@02O/Sg00V0cO^3cOb1c_b1c_Z3d?aoc?R2c?V3cOZ6co`00XO>o006
Q/gkQl_hRm3jR/ghR/gjR/kk0Xc>o`:;cOl01Y3@oho?ohk>oX_=oh_?oh_A
o`::e?l05HWCnXSBmhS@mXW>mhW>n8_?o8g@oI;AoI3;miO;lj7>kfV;Y3]B
HSM6CCQ1@3Hk=cXn?CDi>S@h>CHj>CLk>P02=CTh01`h?3/g>cXg?3Pj?c/m
@Si1AT93B4A2Ad=0AT8jA3`mAcloA3hi@Sla@4DT?TeKQIjEbnf9b_:5c?J7
coN8coV7d?^4dOn1don2e?n7dOj4cOJ4coL2Qm;j00>4coN5d?R:eOd0__oo
o`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo@oooo`9e_n`04GK0
kGO4l7S5lGG4kgC3kW?2kGS6m7C5lW?4lGC5lWG7mWC6mGG7mWK8n7S:o7S9
oWW9o003N<Sk00Ekb?akbOYjb?Ulb?YmbOX00Wk:n`0dOLWjOLOhN/KgPlgl
OL[hO<WgOlcjP<gkO/_iOL[fO/_gOL[fOlchPlgjQLolQ/olQ/gkQLcjQ/[i
S<olS<chRl_iS<cjS<clRl_kS<clSLgmS/knSLcoS<_nRlgoS<ooS]7oR]3o
QLgmRmCmR]CkR];jR/oiR/kkRlkkS/klSlkjULkkVLgdX<_[G7nE=e5N<dE9
>dI2?48n=c/j0S0d=@0:=SXk>Cdl=SXi=CTh>3`k>Shm>Cdl>Slk?44m?dA0
0T15@@0<?dA0@dY3?4<l@DI0@4U8;d17945CH8fZSLO]Q/_eR=;oR]Go0XG@
nP0;R=GoQ=KoPM7oR=GoQm3iQ]7iRMClR=?kQM3hQm;jS=Oo0;koool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool2Ll3^00=d`Nmd`_1e
`o400WG3l@0;LlCaL/?`M<GbMLKeLlGdM<KeM/SgMlWhMLOgM/SjM<Ok009e
a_/047O8oGO9ngS8ngS8ngO7n7_9nWg;o7c:ngW7mgS6mW_7n7c:nW[6mg[8
n7c:nWg;n`9nc?X017g;nGc:n7o=ngo<nP:2c?T2Q<gj00B4boV3b_R8c?V:
cOX2S<ch0hg;nP03S/ckSlglS/kn00F>c_h01Xg@oH_Bo8_Bo8gBo8g@nhg@
o@:>c_`04Xo<nI39m9c@mig:jDY^Q3]GHbm2ASA0?3M1>CPn?3Pl?C4e=Rlc
=3Di>SPl?CTm?3e1@3Tm?08j?Sd05c/o?Sm4@497@d56@Se2?T99@SLn=T=8
@Si7AS=4C2e:G5V8YXk9lHS?nhSBohG@n8G?mXSBnHKAnH?@o8KDoh;=mhC?
m`02Qm;j00B5d?R4coN3dOR5doZnoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?oooom3oooo0W:ok@9b`>h2Ll7_0g;3l008M<GbLlGdL/CcLlGd
MLOfM/SgMLOgMLSj0gC7n`08M/OlMlWkMlOjM/KiMlOhN<SiNlWjN/Si0WW7
m`0:NlWiO<[jO<[jO<[jOL_kO/clOLkmOLkkOlgkO/cj0Wg;n@0=PL_hP/ci
QLkkQ/olRM3nR]7oR=7nRM3lRm3jS<ojSLgiS<ggSLch00:=cOT3Rlkk00R>
c_b>c_Z@coZ@dO^=d?^;d?Z;c_V:cOP2S<cj00b>c?^?c?VCc?NHc?6JanA4
JWliEf4cB4TgAT4i@c/d>SPg>c`2<cLh00`h?3di?Chf>STh?3/i?C`j?Sdl
@3m0A4=3B4A2Ad<oA40l@C/2?TDm01I1AT0kAD@gB50`Cf5DPZ>;bO24boN5
cob5c_N5cO>;dOF8d?J5c_N7d_b5d?R7d_Z8do^7d_Z4coN3c_J1coJ3dORn
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooom3oooo172nk09a
_nd00g31kW72kg?4l@02M<Gb00Ib`o1ba?=da_EeaoIda_Ifb?X3MLOi0WK8
nP03M/KiMLGfMlOh00AgaoP00gS8nG[:ng[:n`02NLWj00=jb_]jboYjboX0
0g_<n`0>N<KdNlWgPL_jPlglQ<gjQLkkQlklQm3mPm3lP]7lQM3jQLkgQ/kf
R<gd0XS=mPB7c_P05X[?n8c@mho@mY7Amho?nh_>nhc<nX_;nH[:n8_;nHk<
ni3=nYG@n9?9kIO6hSeSMS9@FS15ASQ4@3@n=S<i=cLk?08f>S/013Xn?CPl
>cDi>3Hj>@8h?S`06Sa2?T=9ADI<B457@ca2?S]2>c]2>TE<A3i3?C]5A3U:
DSIEIe:0XHc7kh?8lXC=n8K;m8S<lHg?lX[>lHO<lhO?mh?>mX;?nHCAnh?@
nP:2coT00hCAnhKCoOooo`2moooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?oooom3oooo16nmj`0AL;k/LKo]Kl3]L<7^LlCaM<GbLlCaLL;_LL;a
LlGdM<KeLlGdMLOgM<KfMLGhM<KfM/Ki009fa_L01gG5mWO7n7K6mgG5mWK6
mgO7n7S8n@02NLWj1GS8n@0;N<WhNL[iNL[iMlGcNlWgQ<kmQLonQLkkP/_h
P/WgP<[g009lcOX00gk=mX;=mHG?mP02Qloe00Z6d?N5d?R5d?Z5d?Z6coR8
d?R;d?N>d?>@d?J>c_X2SLgk0Xc<nP0^SLgkS/klSlkjTlkfTlW[UlKR?69e
;DUD;3i2=T4m=c`f=c/j>Cdn=c/l=CTj>3`k=c/j=CTh>3`k>3hl=S`j>d4m
A4Y6ATa8@4I2>d4m?4<l?4<kA4]3?44k?TQ7=DQ??5]]FhVZRLC/PlSbPlcg
QL[cQ/[_S<kaRlg`Ql_bQ/kfP/ggPLkhP/oi0X7>n003P/oiQ=7kQM;l0;ko
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool01FnljW2m
jg2mjg2mjg2nk002LKo]00Ab`>id`_1e`o5d`_02L/3^00=ca?5daO9ca?<0
0W?4l`03ML?dM<GdMlGf00=ha_H017O8mgK7mWG5mWK6m`9gaoP00gS8nGO7
n7W9o002N<Sk0WS8n@05NLWjNL[iNL[iO<[jOlgm00:5coh03HC=nX;;n8;9
mh7;nWg>oG_=o7k=n8?>mXK@mhWAmhSBnHOAn8?@nP02P]7l00R3d?b6coR7
coN;coB=c_J<c?R<c?Z;c_/2S<ol01^;c_^;c_V<cON=bo:Hc_2C`=e2IGT]
AE4[>3hj?Se0@C`i>cXj?Sdi?C`g>cXh?3/f>STd>SPh?S`g?CTd>SHh?SY1
Ad=1BTDlAD0jA3`mAcl00Se7?P0C>D0i@Ta;<4=:@5maJiVjQl;ZQ/[gQLkk
Pl[dQ<W`R<caR<ccPl[dQ/ojQ=7kPm;kP]7jP<ohOlcf009nboD00go<m_oo
ooooo`2loooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooom3oooo
0VnljP03L;g[LKk/LKo]00=a_nd01g;0kW?1kg?1kg6okG;0kWC2l7?4l@03
M<;`00=d`_9e`o5gaOD00gS6mP03MLKeM/OfM/Kg00Afa_L00gO7n7K6nGO7
nP02MlOj0WS8n@9hbOP2Olgm0121boYobOQob?F0bOJ5c?Z7con0c_imc_f1
boR3c?F7c?F8cOJ5cOF3c?F3d?b2d?h2PLoo00N4c_^6cOV:cON<cON:b_J9
c?V;c_/00X_?o00>RLgjR<ggR/_eSL_bW]ChPJg:@61e;D1>:S4i=cDf?c/j
=CLf>Cdl>Shm0STm?00P=CTh<SPf=C/i=S`h=C/g=cdi?D<o?DI1>d@o>dDm
?TQ0?DLn>T@k>T4j@D]:<DA;AFAhN:K7Q<;[QLcjQ<kmP/_fPLSbQ<_eQ<_g
P/[jPm3nPM3kPM3iP<ohOlkgP<gg0go<m[koool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooood?oool016fjj6jkjG2mjg6nk09b_nd00g6nk72m
jg6nk002Ll3^00Eb_neb`Nad`niea>mc`^d00WG2kP04ML;`ML;^MlCbN<Gc
0WO5l`04M<;bM/CdMlSgMlSg0WK6m`06MLOgM/ShMLGhMLGhM/KiMlOj0gS8
n@03MlOhO<[jNlWi009maoH0:go8mH;9mhO;nXO=oX;;oX39o8?7n8G8mHW9
mH[;mHK9m8C8mhG=oh;>oh7=oh;>ohG<ohS<oHc<nXk=nH[=nXW=nX[>nhS?
nhS?nHO>n8K=mhS;mHk<ligCmf6=ZSIDK2hnCBlb>cP_=3`c=3@d=3Lk>SPl
>cHj>CDj=S8g<c0f<P02=C/g00<f?3Pg@CTi@c/00S]5?@8lASh05SU5>ce7
?S]2>ce7B3Y<ETQYO7Z[c8G2kX79nH7=oWo<nX3:mh?=nX3<oGk;ogo?ogc=
nWc=n7o>nH3?nX7@nh;Ao0:3d?bnoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?oooom3oooo02A/^NM]^^Q`_N]a_^ab_nea_^a`_N]__>Y`_N]b
_nec`>ia_neb`>id`nid`_1c`^ef`o5g`Nie`_1e`^if`o5ga?9fa?9e`o=a
_nme`o=gb?MhbOQgaoQfa_MeaoMhb?Ufa_UgaoYibOajb_d2Nl_l0W[:n`0A
N/ShNlWiOL[hPL_jQ<clQ/gkQl_jQL_lP/WmP/SkPlOhQLOgRl_gS<chRl_i
Ql_jQ<cn00>3c?l07XG<ohW<ohg=oHg=nhg@nhcAnh_@nXW@nXS?nHS@n8S?
nH_?mX[8kiS=kdUbT2m;HCA1DCTl@d0g>T4h>CHf=SLk>SDi>34e=30e<Bhd
<30f<SPn>SDk=cPn>P8i@c/03SY4?3a6?Sa6?S]5?3E1=d5;@Sa2?SM2ASmE
HTM[PGF[cHC5kgk6mWo;o0:0b_T01h;?oH3>oW_;oWk>oh7?oH7@nh;?n`03
Pm3l00>2co^1c_[oool0_Oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Sooooo@oooo`0;KK_YKkg[Kkg[K;[XKK[XKkcZL[k_Lko`L;c]LKg^L;k^
009a_nl01g31kW31l772kg2lkG?0kWK2lgK3l@02L/3`00Me`o=ha_Mfa?Ee
`oAd`_=fa?Efa_T00WS8n`0KMlOjNLKjMlChMlChN/OkN/[kNLWjN<SiNLWj
N/_jO<[jOLWjOlWhP/[jPl_kQ/cmQlgnQLgoQ<clPlWjP/WgQLWhQ/[gQl_j
QLcjRLooQ/kn00:5cOd0?8G<nXC;nHS<nHg@nhS9lhW:lX_<m8c@mh_@mhW>
mH[=mho?mI3:l9W:jdU^RCMBIb/kB3m4B491?cHe<B/];30f=SDk>C4g=Bdc
<Ble<c<i=C<l=c@m>3Q1?3Q2>SU3>ca6?SY4?3M1>3U3>SI2=3]5?3Y0@3I3
C3MBICYXP8;3hgo9kX39mX79nH?:n8?<nH3=nGk<nWg;nGc:n7g:mX?=nXK@
ohG?oX;<nh3:nH7;nX?=o;koool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hoooood?oool01V^iifjljVnmjfjljVjkjFnljP9`_>d3LKg^00=a_nmb
`?1``O000W72l@08LKo_M<3aML7bML7bLl7aL/3`M<;cM/Ce0gC2l`0=ML?d
M<CgMLGhMLGhM<CgNLKjNLGiN<GiN/OkNLWjN<SiMlOhN<Si009ib_T03W_9
nGg9nX3:nH;:nXC:nhC<o879nH38n7o7mh38n8?:n8G<nXK=nhO>o0:4boT0
=XG<n8K=nHO>nXK=nHS?nhgBo8_<mX_:lh[;lh[>mHW>mhS=mXW<mXg=liC;
lYS9jTaaS49OLBi0BSI0@S<e<SHg<BHZ:BP^;Rdc<C4g=CHl>STo?CHo>S<l
=c@m>3M0>cM1>CY4?45;@d1:@S]5?3Y4>CQ3=Ca6?C]0@cI2CS5@ICEWPWc1
h7_9kH?<mh;;n8G9n8;9mgk;mgk=n7o>mh3=m`:4c_/01XC>oH?=o87;nWg:
n7_8mW[7mKkoool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?o
ool016ZfiffijW2lkFnkk0=a^n`01fnijW:lkG:lkG:lkG6mkW:nkg6ok`02
L/3`0W>ol09d`?42Ll7a0WC2l`04ML?dM/CeMlGfMlGf0WC4m@9eaOP01GW6
nWS5nGW7n7_9nWS8n@02M/Kg00Ehb?UfaoIgb?MiaoMkaoP00Wk8n@9oaoL0
18?;nh7;nWo9n7o9n0:1bOT03X;;n87:mh7:mh7:mhC;nHO>o8O>nXK=nHO>
nX_?o8c?nXS;mXG:m8C;m@:4cOH0:8C;mHS<li3;lho1i4=ZQcUHK2a0BcI1
@bX_:b`^:A`Q7B4W9BT_;Ble<bhd<2`b;Rdc;c4g<cHl>3Lm>CHl>3Y0?4A;
A4=:@c]2>cDo=SDo=3]5?3]0@cI2CS1<HSQWPgZogW_9kH7:mH7:mhG9n8?:
n7o<n7k=n09oc_T0283=ngk;nGc9mgc9mgo<nWk<nWc:nWW7mkkoool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool026RdiF^gj6fijVfi
jVnijW6kk76ijg2hjP9`^^/2LK_/011b_>ea_Nia_Nia_Nic_o1b_^ma_Nib
_^mc`O5d`_9d`_=c`O9e`oAfa?Eha_MgaOH2M<Ce011eaOQfa_Uga?QhaOUi
aoQibOYgaoQeaOIfa_MibOYfaoIgb?Mjb?QkbOUlb?Unb?T2OLOf00>3cOb0
cO^0b_T00Wo9n008P<ShP<WfOlSeQ<gjPlciQLcjQlklQ/gi0XC;m`0iQ/gi
RlonQ/[iP/WgP/_hPlgjP/ggP/_fQL[cSlgdTLO[EX:O>e]`<DMD>DQ;;SLb
:BhX8bTU9bdY;cDc<cTe;cDa:S0/;S@`=cdi=S`h=cdi=S`h>T0l@DM3?dHo
=S`h<STb<S`a>T4i?3m4=d=?<4aR?Fb8Nl3OOL__OLKaOlSeQLWhQLcjP/ok
OlkiOLcgNl[eOL_iNL[gMlSeN<WfNlciO<gjNlckN<[i0;koool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hoooood?oool01fRdiFVeiVVeiVVeiVfg
j72jjg:jk002LKW[0W:jk09b_>d2Lkg^0W:nk`04LKg^L;c]LKg^Ll7a0WC2
lP03L/3`L/3aLl7b009e`o@2L/;c00ec`oAeaOIda?Eda?Efa_Mhb?UgaoQd
a_IeaoMhb_Yhb_UiboYjboX00Wg;n`9mbOX01Wc8nGg:n7c:n7c9mgg:n7k;
n@>2c?/038G>nhC=nXC;nHG<nXC;nH;9mhC8mhG<nXG=oH;:nWo9n7o<nP:0
c_`0;X7;n8;9lhS7l9C<kh6^beUlT4ALJ3E7BC8m=c0g;c0g<2/b:b/a;C8h
=3Pn>SLm>CHl>3Lm>CHl>3To>cXo>ca1?D15@Ca1?CDi>38i<S8l<CY1>Ce0
ACa6DS=?IDEdT7_0ggg;kgg6lGo8mHG9nXK<oH;?nh3?nWg<mgc;mWg>ng_>
nW[=nGW<n09hb_T00gO9n7G9moooo`2moooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?oooom3oooo0VRfiP05IkGUIk?TJKGVL;[[L[c]009b^^`2
Lk_]0W>mkP=d_^l01G6mkW2lkG2lkG6mkW;0l002Ll7a00Eb`?1c`O9c`O9d
`_=e`o@00W?3m00:M<CeMLGfM<CeLl?dMLGfMlOhM/ShMLOgM/ShN<[j0WO9
n003N<WhNL[iN/Sh00=jb?P01Wg;nGc:n7c:n7c:n7k;nGo<nP:0b_T00h?<
nH7:mh;9m`02Pl[h01f2bON5bOR6c?f4c?j0b_]mbOYocOencoiocO]oc?Z3
b_J6ann=aNRGa^9oY;MROHQ9Fee2CdQ2C4<i@3Pd>c@b>C8c>S<e>cLd>SHb
>3@a=c<b>3@g?CT00STn>P0A?40o>3`k=3Pg=3Xf>3lg?4<l?d97@DYI>5AZ
CgjJNl3QNLO[PLcfP/_hPlWjPl_kP<gk009oc_T02Gk?nWW<n7[=nG[>nWW=
nGO;nGK:n7O;nGS<nP2noooo0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?oooom3oooo00UY^NYX^>UW]nQW]NIZ^>U_^ne`_>ea^na`^^/00W6kk09`
_>d3LKg^00Ab_nea_^aa_^aa_^`4LKo_00Ifa?Ae`o=e`oAe`oAda?EeaOH2
M<Ce00Eda_IcaOEcaOEeaoMfb?P00WG7m`03M/ShM/SgMLOf009eaoH2M/Of
0WO8m`9kc?/2N/_j0Wc:nP0PO<WgNlSfO/SgO/SgPLWiPl_kQ<_iPl[hQLWh
Q/cmQ<cnPL[mO/[kO/clO<glOL_iOlcjQ<ghS<geS<CWVl[VU;W<KhZCJWal
HFaTHVYODUUACEA<@dY3=chg<CPa<3L`0c8g<`0K=S/g=SXi=SXi>Cdl=c/j
=3Pi=S`h>d8j?D@m@DA9ADiM?e]aFXVUO/?TN<K/PL_hP/[jP/SkPLWiO/_i
NlciO<gjOLkkMLOfM/[hN<cjNLgk009hc?X2NLgk__ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo@oooo`9X_>/01VRjjVNijFVijVfmkVnm
kFfkj`9/^>T016fijVbjjVjjjfjlk09_^n`4L[o]0W2nkP9__Nd017G3lgC2
lW?1lW?1lP9c`o@027;2lg30lGK8n7?5mG;4m7G7mgO9nGG7m`9da_H2N<[i
0gO9n01;N<[iNL[iNL_jM/SgMLOfMlSgN<WhO<[jOL_kO/_iOL[hOLOfO/Sg
PLWiQ<clQLcjPl[hQ<SgPlWjQ/koPlgnOl_lOL_kO<[jO<[hOlchQ/ohQ/G^
S<CWV<KPS[74Eg1gKGelJWA[KgMZJW9WFF1H@DQ1;cH_;SD^=3/d=3Te;c@`
=S/g>Chj=c/j=SXi>Shm>3`k=SXk=cdk>d8j?48n@4=:B55RA61hH96_PLGX
N<K/OLOdO/SgP<SjP<[kOL_iN/_hN<WfM/WeN<[iN<cjNL_jNLgkNL_jMl_i
M/SgM<Sf0;koool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?o
ool2I;c/00mR^>UO]NIT^>MZ_>a[^naW]nQ[^NU^_>a`_^i]_^e]^n]Z^nY_
_Neb`?1`_N/00g6nk09a_nd00g6okg;0l7C2lP03M<;b17;2l`9da_D00g?5
m773lW73lP02M<Ke00AcaOAgbOUfb?Qda_H2LlGe00Mdb?Mhb_Yhc?]caoIe
bOQibo]kcOd00Wc=o006O<[jNlWiP<cmOLWjO/SgOlWh0X;:nP0JQ<[kQ/cm
OlGfO/KfO/SgO/_iP<gkPLkjP/ggPl_cQ/C[TLOYV<CMIXNFCFAZFFQUJW9W
HVQJHFUNC5I==T0h;3H^;SD^;cH_;cDa;S@`0SDj=P0N>3`k?d=2?D50<3@c
<3@e?TA2@DQ1>T0l@4=:BUIVAVAlJIZhO/;UN<O^N/OeOLOhP<SjOlWjNL[i
N<[iN<_gNLchMlWhMlWiN<SiMlWiNLWjNL_kN/[kN/cl__ooo`:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Sooooo@oooo`9P^nX01V2hj5ngif6giVNk
jVRjjVJhj09Y^^T2J[_Z00AY^^UZ^nY[_>]/_N`2L;g[0W6nk09a_nd2LKo_
00Ac`O5d`_9d`_9d`_84L/;c0g?5m005L/CcLlGdMLOfM<KeLL?b009eaoL0
17C6mWG7mgC8mgG9n09fb_T017C8mgG9n7O9nGO9n@9ib_T2N/Sh00Alb?Uj
a_Mla_Enb?L2PLWi01R2b_Z5bob1aoR1aoR1bOV1boR2c?V3c_R3c?F5b_68
a^^Aa^J5[lM9JGPmDUM:EU9UJf5NHUA1BChd?SDZ=2`X<RX^=Bh`=c02<3Hb
0S@i=@0G=CTh>Shm>cln<cLf<cLh?TA2>dDm>T<n@DE>@dmO>5I`G8n^NKoQ
Nl[aNLOeNlOhO/SiO<SiMlWhM/[hM/[fN<[iMlWi00Ahb?T00gW9nW[:ng[:
n`2noooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooom3oooo00iL
^>UM^NYO^^UP^>QQ]nQS^NYU^NQU]nMY^NYX^>UW^>MX^NQY^^UZ^nX2J[_X
0W2mj`9a_^`0172nk76okG6okG6ok@Ac`O44L/?b00aa`o9ba?=caOAcaOAe
a_EfaoIdaOAa`_5da?EeaOIeaoMfb?P2MLWh0WC8m`03Ml_jM/[iM/Sh009e
aoL027K8n7S8nGW9nW_9nGW7mg[6mgc8nH3:n`9obOX05X79nH36mh37mGo8
mGo9mX3:mh3;mH39lX?7kXc8kIC7iVbD[C=@H395Bce8A5]NEDiBA38i<BXe
;BHa:BPc:b`e<08]=S401Rhg<SDk=cDk=c@j=SHl>3Tm?08f>ST03Se3?cU4
?3]6@496Cci;Fc5AJU^>[GW2hgW;lGW7mG_7n7_7nG[8nGK8m`9cb_L00gG9
mgO9nGO9n`02MlOj00AgaoQhb?Uhb?UibOZnoooo0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?oooom3oooo00YK]nQN^>YO^^UQ^NUR^>UT]nUT^>MU
]nMZ^^]/^^/2JkWY00A/^^Y]^n]]^nU]^nT3L;g[00=a_^a`_^a`_^`00W6o
k@9b`?02Ll7a00Ua`_5b`o9b`o9b`o9``_5ba?=da_EcaOAca?<00WC5m007
LlCcM<CeM<CeMLGfMLOgMLWhM<Sg009caoH00gS<ngO;nWO9n@02MlWi00Ih
b_Yjb_]kboaocOembo]kbOT2OLWj01IkaoQmaoQnb?UoaoMob?EnaoAnb?Eo
bOIob_B0bO:3anj;anbCaNIEOIH`CEdbAD`jA4=9C4<k?S<b?3<^>C4[=S02
:SD_01`[=2l/=C0_>3<f?3Pi?c/h?SXe>cLh?CTg?3Ph?3/m@clh@c/jAT90
AdlnBe`gEg1SV;MmanYcanagb?Ejb?QkbOYhb?UebOMab_IbbOIcbOQfbO/3
M/Sj17K8n;koool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?o
ool01EfgjEjhjV6ijf>ik6Bgj@02I;KX00=U]NQ/^^]]^N/00VfijP04K;SY
KKWZK[_YKkcZ0Vnlj09`_N/016nmjg2nk72nk72nk09b`>h017;0l7?1lG72
lG72l@9b`o8016k1kG?6lWK7mW?4l`9b`?0047K4m7S6mWO5mWG5mWC4mG?5
mG;6mG?7mW77n7?6n7G8nWO9ngS:o7W;oGW;ng[<o09kbo`00go?og_;o7S9
n002N/Sh01IiaoMkaoQlb?V1bOV0b?QobOQnboMoc?R0cON3c?N6boB8a^f=
`^A0JHD`Cf<_@d`g@d<i?SPb=B`^>C4Z=c0X=302:3D^00@Y=2h/=c4_>S@`
>C@2=d0k01<c?3Le>cLe?3Dh?SXmAcle@STkAd=2BE4lC5`eEg1SV[Qla^U_
`^Yfb?Mhb?UibOYhb_Ydb_U`boP00W;:n003LlWjMLSjMLSj00=daoT2MLWh
__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo@oooo`9O]nT0
262fjFFhk6JhjVJfjFFej6RejF^gjFjgjP9_]nT2K[KX00I_]nM_^NQ__>Q_
_>Q__>Y`_N/2Kkg[0W2nk09a_nd2L/3`0W72l@9b`o802fk1kG?6lWK7mW;3
lW2nkW6okgK4m7W7mgS6mgO5mW?3m002L/Cd00Mba_EaaoQbb?UcaOMda_Qf
b?Yhb_`00WW;n`06NLWjN<SiN/[kMlOhM/OfMlSg0W[8n00FNlWiO<[jP<[k
OlWhO<SiO<[hOL_iO/ghP/ciQ/_eRlWbS<3U@6V7<E1U:Si9=T53>3di=CXd
:cH`9SD`9c<_:CDa0RXg<00G:cH`;CPb;3D`=3dh=Slj=3dh=Sdf=C`e>3lh
?dU1=d@k?Te8B55J?e1P<UI`GIJdNLGWLLK]M/SgMlWiNLWjMl_jLl_i00=`
boP2L/[j0g79n@03LlWjLlWhLlWh0;koool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hoooood?oool02Unej5jaiEjaiF>djFNgk6RejfVejFbejVnf
jVjej@9^]>L2KkGX00=_]NI^]^Ia^nP00fnlj09__N/3L;k/00Ea_nea_nmb
`?1``O1a`_400W;3lP06Kl3]L/?`M<GbL/?`L/3`M<;b0WO3m00<MlGfM/Ce
Ll?dL/CdL/CfLLCfL<KgLLOhLlGgM<KhMLOiM/Sj0WO9n`03M/ShMLOgMlWi
009eaoL06GS:nW[;nWW:nGW:nGc:nWg9nWc8nG[8nGS9n7W:nGc:n7g:n878
m8_:mHo4k5AoWc=CJRY0CS0m@c]1@CDk=bhj=RLf<b@c;RLf<@02:STd01P[
>34Z=c0_>S@c?SPf@3Ph@SXi@c/e?cLh?cLnB3ljBT11D4]:Dea3E6@fFWAP
VKMja^Q`b>icaoEdb?Mfb?YfbO]bb_Q^boL2Klch00I`boY_bO]_b_U_b_U`
boYbb_X2Ll_k__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo
@oooo`0AGK;XFJoRFjkRH;?WI[O/IkO/JKK/JkO[L;W^K[GYJk;VKK?VL;KY
LKOZL;KYK;CTL;[Y00=__>X3Kkg[0g2nk003LKo]L/3`L<7`009a`_400g;3
lW31kW72k`02L/?`00Ae`o=gaOEf`_=c`O42M/Ce0W?3m004L/CfLLCfLLCf
LLCf0gG7m`03M/ShM/SjM/Sj009eaoL02WS:nWO9nGS:nW_=oGg>oG_<ngS9
n7[8n7k<o7g;n`9ib_T0;7W9nW[;nWc:nWo9n8C7m8k7lVNE]c=GLBY4DbTj
@SQ2@bXc;Rll=BHe;R0_:R<b;BPg=2/j=bdi=b`h=3I1>cM2>SU3>ca6?Se7
?cM0>cLm>Ca5@3i;@Se<BD5>ET1EISYRNfNP_Wc6jFk1jG?6lWC6mGG7mgG9
n779mfk;mfk:nFo;nP9^b_/2K/[i00A`boYac?]ac?]bcObnoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?oooom3oooo00EK]NYJ]>QK/^ML/nQP
]N/00V>fjP0:HkGWI;CWJ;KWJkWZK;SZJkOYJ[KWK[SYL;[[L;c]0Vjlk005
Kkg[L;g[K[_YKK[VKkcX009b_n/00g70jg2nk6o0k@02K/7]00=``Nia`_5c
`O400WC2lP9c`O43M<;c0g;2l`08L/;eLL?eLL?eLL?cMLKeMLKcMLOfM/Sg
0WK:n@9gb_`01G[=ogW;oGO9nGO7n7[8n002NlWg00Ikb_EjbOAhbOAhbOIh
bOQhb_X2N<[l02Mhb?]la?J6a_9d[=4XEG8]D6<[A4/P<S8[>S<[>bhU=bTW
=RlV=C8O;BhT<SD_>S`/>3P_>S@iA3`f@SHoBd4j@chg@3d`>3Y1BD/nAd90
C4XlCeDmFVPfHgY_Z<In`>=i`nYf`nega_5iaoEgb_IcbOQ^bOP00V[9n@06
Kl_lK/[iK/[iK/[iKl_jL<ck0W3;n[koool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hoooooa[oool4o`009Oooo`9H/nP015VcieZdj5fdjEjejP9N
]>L016Bfj6JhjVRhjFRhj@9Z^>T01VfijVjjjfbjjf^ijVbjjVjlk09`_N/0
172mjG:ojg6njW6njP9`_nX01Vo0kFo2kVo2kW33kg;0l7?1l@9d`_82Ll7a
00=d`_=e`oAb`_<00g;2l`=b`_D01G;2lgG6lgK7lWG8m7K9m@02MLWh0WG8
nP0fMl[lM/WkMlOhMlSgNlWiOL_iOlchO/ghOLcgN/_fNL[gNL[iNL_kNL_m
Ml[nMlSmO<[kQ<_iNKON@GJE9TmS9dMB93`n:C`f:3X/9SPX9cL]8c8_7R`_
8bhb:cHh;cTj<chh?DTo>dLk@4a2?4E0=d0o;SHi>T95@4I4@D]:>dmF>EUX
=69jKJG6OkoUO<?]NL;]N<GaN<ObM/OdL/WfK/Wf0Vc;n`9^b_T016k9n6o:
nG3;nW7<n`9`boZnoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oo
oolIoooo00Co003oooooooooool2o`009?ooo`04E[;UEk?VF[CXFkGY0Ufd
j@04G[CWGkGXI[SZI[SZ0VNgj008J[SYJkWZKKW[K[[/JkWZJ[SYK;SYKk_/
0W2mj`0<L[cYM;k[KkcXL;gYKkkYL;oZKl3]L<7^L<?_LLC`LKo_L/3`17?1
l@03M<;cML?dL/;c00=b`_<2Ll?d00Ac`oIc`oAea_Efao@2MLSd0gC8m`08
LlOfM/[iMLWhM/KgMlSgNlWiOL_iOlcj0Wo>n@0XNlcgNL[gN<WhMlWiMlWk
M/WkM/SjNlWjP<WfOKkVIYfl9E9Y8dME9d9;9S`j9CH/:3P[9c@[8RhZ8Bd]
8R`]9c4`<3Tf>44l@de5@4Y1?dU0>T<n=Sll;SPg>412@TI7ADe@?U1L=eIZ
=F9oJZ;7O;gWNL;]N<;_0WK5l00;LlK`L/KbL<WeKlchLLglKl[iK/WhL<Sh
LLWiL/[jLl_k009bb_Znoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0
^<3oool4o`000_ooo`Ko0002oooo1Ol00004ooooo`00o`00oooo0_l000?o
ool4o`000_ooo`;o0005oooo0ol000;oool2o`000_ooo`;o0002oooo0_l0
0003ooooo`00o`0000;oool2o`001?ooo`;o00000oooool00?l00002oooo
0_l000;oool2o`000_ooo`Go0002oooo0_l00003ooooo`00o`0000;oool4
o`000_ooo`;o0002oooo1?l000?oool4o`000_ooo`;o0002oooo0_l000Go
ool015B`heJbiE^ejEbfjP9N]NX0162fjF6gjVJijfJhjP9V]^L01fVgj6^i
jVfijfjjk6jlkFbjjffijP02Kk_/00=^^nU`^^Ub_>T00Vnlj009L;gYKkkY
L;k/Kl3]L<7^LL;_L;k^LKo_L/3`00=c`O400gC2lgG3m7;2l`02L/;c0g?3
m008M<CgM<CeM<GdM<GbM<OcM<KeM<SfM<Sg0W?7mP0hMl_jMlWiMlOhMlSg
N/ShNlWgO<WgNlWgO<gjN/_hN<WfM/OfMLOfMLOgM<OiMLOgM/OfNL?`O/7[
O;OI>FR494YO8d=B93e27S4]9SH/9C8[8c0Y:3<_9Rl/9BhY;CHa>T4jA4i6
@4Y2>D<k=T0h<chh<chj?TM4A4Q9B4mE@UAR>5M/>FJ7J:;:Mk[WMKo^ML;`
LlCaM<GbLlK`L/O`LLScL<_gLLci0W38n09aaoP017?9nWC:ngG8nW?9n[ko
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h_oooo`;o0002oooo0_l0
0003ooooo`00o`0000Goool2o`000_ooo`;o00001Oooool00?l00?l00?oo
o`02o`0000?ooooo003o00000_ooo`;o00000oooool00?l00005oooo0ol0
0004ooooo`00o`00o`000_ooo`;o00000oooool00?l00002oooo0_l000;o
ool2o`001?ooo`;o00000oooool00?l00002oooo0_l000;oool2o`0000?o
oooo003o00000_ooo`;o00001?ooool00?l00?ooo`?o00000oooool00?l0
0002oooo0_l00004ooooo`00o`00oooo0_l000;oool2o`0000?ooooo003o
00000_ooo`;o00000oooool00?l00002oooo0_l000Goool02UB`heNciU^e
jEbfjUjfj5feienej62fjFFhjVBgj@9T]^P03fNgj6VijVbjjfbjjg2lkVjj
k6fijfjjjg2jjfjhifnij76kjW:ljG2mjG2mj`02Kkg[00E^_na_`>m_`>m`
_^ia_nl00g;0l004Ll7aM<;bML?cLL7b0g;2l`9c`o@2M<Ce00=ca?=ca?5c
aO@00WC6m@05MLOfM<SgM<SgNL_kN<[j00AhbOP0=7[8mWW7mG[;n7W:nGO8
mgK7mWG7mWK8mgG9n7K8n7O8mgK3lGg4kX?1j5V>[RaHLam3Fb<oCA``<B<b
;B<`:BHc;2lj<R`f;BL^9R`c:cDj=499@TA;A3U3>cQ2>S8m=CE0>45;@dE6
B4]?F4EEICUGKd5]T6^TcgNkjW>ol7C2lW;4lgC7lgC7lG?8lG38l779lG78
mG77mW77n09ca_P2MLSj00=fb?YdaoWoool0_Oooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Rooooo0_l000;oool2o`0000?ooooo003o00001Ooo
o`;o0002oooo0_l00003ooooo`00o`0000;oool2o`0000?ooooo003o0000
1Oooo`;o0005oooo0ol00004ooooo`00o`00o`000_ooo`;o00000oooool0
0?l00002oooo0_l000;oool2o`001?ooo`;o00000oooool00?l00002oooo
0_l000;oool2o`0000?ooooo003o00000_ooo`;o00000oooool00?l00002
oooo0_l00003ooooo`00o`0000Goool2o`0000?ooooo003o00001Oooo`;o
0002oooo0_l00003ooooo`00o`0000;oool2o`001Oooo`04E[;UEk?VF[CX
F[CX0U^ci@9K/N@2HkKX0VBfj005I[KWIkOXJ[SYJkWZK[[/009/^>X01Ffi
jfnijVnijW2jjG:lj`02LkgZ0W2mj`9__N/0172nkVjokW2nkW6ok`Ab`?00
17?1lGC2lW71lW71lPAb`_<2Ll?d00Ab`o9ca?5caOAda_D2MLOf0WC8m`9g
bOT027O8mgS9n7W:nG[;nWc:n7_9nG[;nWW9nP9gb?L0;GK8mgO9n7K:n7K:
n7O9n7C2l7g6lgg0jW>]dd1bUAm:JQm2F1lc?24a<B8a;RXg<34m<c4i;2dc
9bdc:Bld;Ce2?4E:ASm5@D1:@SA0=SA2=Cm9@4=5A4Y=E4EEI3UGKdMeUfnZ
e7Vol7G3m773lg;4m7C6mGC7lG;7l7;7kW;7l7;6lWC8m`03LlKh00AeaoUf
b?YeaoUeaoVnoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^<?oool2
o`0000?ooooo003o00001_ooo`;o00001?ooool00?l00?ooo`;o0002oooo
0_l00003ooooo`00o`0000Co00000oooool00?l00004oooo0_l00005oooo
o`00ooooo`00oooo00;o00001?ooool00?l00?ooo`;o0002oooo0_l000;o
ool2o`001?ooo`;o00000oooool00?l00002oooo0_l000;oool2o`000_oo
o`;o00001?ooool00?l00?ooo`;o0002oooo0_l00003ooooo`00o`0000Co
00001?ooool00?l00?ooo`;o0005oooo0_l000;oool2o`0000?ooooo003o
00000_ooo`;o0005oooo0UNciP04E[;SEk?TFK?UF[CV0U^ci@04G[CUH;KW
HkKXI;OY0VBfj006IkOXJKWZK;W]J[O[JkOYK;SZ0VnijP04LK_ZLkg/Lkg/
L[c[0g2mj`05Kkg[Kkg]L;k^L;k/LKo]009b`>h2LKo_00Ab`?1c`O5a`_5a
`_44LL7b0W;2l`04LlCcM<GdLlGdM<Ke1GG7mP04M<KeM/OfMlSgN<Wh0WW:
n@0/N<WhNLWlN<SkMlOhMlSgN<WhMl[fMLWeMLWgM/[hL/?bNlSfMkkZO;_V
GiJo;f288dYY8ce>8S<j8c<c:STd;SX^<3PY<SPZ=3L/;c8[>C/h@TI5@DM5
B55<>4@j=dDf@4`nATM2C51CAEER=UEZBgVJKjgFNL7aLl?dLLCfLLGdLlGd
0W;5k`05L/G]LlK^LlSaMLWhM<Oi009ca_P2M<Oi0W?6n;koool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h`oooo`;o00000oooool00?l00007oooo
1?l00003ooooo`00o`0000;oool2o`0000?ooooo003o00000_ooo`;o0000
0oooool00?l00004oooo0_l00005ooooo`00o`00o`00oooo00;o00001?oo
ool00?l00?ooo`;o0002oooo0_l000;oool2o`001?ooo`;o00000oooool0
0?l00002oooo0_l000;oool2o`000oooo`Co00000oooool00?l00002oooo
0_l00003ooooo`00o`0000;oool2o`0000Cooooo003o003oool2o`001Ooo
o`;o0002oooo0_l00003ooooo`00o`0000;oool2o`001Oooo`06E[;UEK7T
EK7REk?TFkGWGKOY0Ungj@04GK?TGkGVI;OYI;OY0V>ei`06IKOWJ;SYKK[^
JkS/JkOYK;SZ0Vjhj@06KkWXL[c[L[c[L[c[L;g[KkcZ0W2mj`9`_^h2LKo]
0W;0kP9a_nl2L/3`0W72l@Ia`O800gC5m7G6mGC6m@02MLOf0gC6m@9caO@2
M<Gd0WK7mP06MLKeM<CeN<SkMlOlM/KiMlSg0WO8m@0bM<OcL/KbMl_iL/Cc
NlckMl7`O/3`M[?P@GNU:EIm9dEM8CM48cHl:CTh:3D[;3LY=S`^>C`a<C8/
=CLd?d50?dE3BeA?>dPn>T/kAE91BDa3CU9AA5MN<eAUBGZHKZkDM/3]L<;b
L/KeKlGdLLGcLLC`L<?]L/G]M<OaM/WeMLWhL/SiLlKhLLOhM<OiL/SiLlKh
L<Kg__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;S3oooo0_l00003
ooooo`00o`0000Goool01?l00?ooooooooooo`;o00001Oooool00?l00?l0
0?ooo`02o`0000?ooooo003o00000_ooo`;o00000oooool00?l00004oooo
0_l00005ooooo`00o`00o`00oooo00;o00001?ooool00?l00?ooo`;o0002
oooo0ol00003ooooo`00o`0000Coool2o`0000Gooooo003o003o003oool0
0ol00005ooooo`00o`00ooooo`0000?oool2o`0000Cooooo003o003oool3
o`0000?ooooo003o00000_ooo`;o00001?ooool00?l00?ooo`;o0002oooo
0_l000;oool00ol00?ooooooo`02o`0000Gooooo003o003o003oool00_l0
00Goool05eFahUVeiUZfieNci5Rbi5^eiebdiUR`hV2fieneiUjdiEneiVBg
jFJijfFhjVJhjVJfjFZgjfbjjf^ijVZfif^gj6nij002L[c[00ea^nY^^nU`
_N]`_>e_^na^_>a`_^i^_>Y__N]`_^aa_neb`>ic`Nl00W?1l@05Kl3_LL;a
L/?bLL;aL/;c009c`o@01771lW?5m7?5m7C5m09ca?<01GC5m7G6mGO8mg?4
lgG6m@02MLOf0WC6m@0jMLOfMlWiMLKkMLKkMlOjMlSgMlSeMlScMLSbLlOc
MLWgL/KdMlWiO<[kMKg_NK_]J:KG=FRC:4eZ8d1B83]69S/n9CH`9S@W;ST[
=cdc>S`g=CLd=cTh@dU7CEIAAeA:?e10AE=2@dTm@D]3@5EH>UiZHYJ^N;[L
LKoVLLGaK/CcKlGdLLGcLlKbM<GbM<G`LlCaL/GaLLOfLLWiLlWjLLWiLLOh
KlOgLLOhLLWi__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;S3oooo
0_l00003ooooo`00o`0000Koool4o`000_ooo`;o00000oooool00?l00003
oooo1?l000;oool2o`001?ooo`;o0002oooo00?o003oooooool00_l00003
ooooo`00o`0000Co00001?ooool00?l00?ooo`;o0005oooo0_l00004oooo
o`00o`00oooo0_l000;oool2o`000oooo`Co0003oooo0_l00003ooooo`00
o`0000;oool4o`000_ooo`;o0002oooo1?l000?oool4o`000_ooo`;o0000
0oooool00?l00006oooo00UC[n1G/nAG/nAD/>5F/>9J]>IM]NMI/N=O]NH0
0V2fi`07HKOXHkKXI;OYIKSZI[W[J;S[J[O[009Z^>T026^gjFbhjFnijVni
j72jjFjhiffjj72mj`9a_Nh00g6okg?1lFnmj`02L;k/00=a_neb`>ib`>h0
0W;0l005Kl3_LL;aLL;aL<7`LL7b009b`_<00g71lW32lG;4l`02MLKe0gC5
m09ea_D00gK7mWG7mWG7mP02MLOf02Yfb?MgbOUea_]ea_]gaoYgb?Mgb?Eg
b?=fbO=ebOEdb?IaaoIeb?Yhb?]f`_Ana_Qk__9JUL4hI8LXC6HL?DhO?4@T
>SPY>S8_>S8a>30^<2/f>3E1ADA<DU1:De0kB3lc@cHlCCe9DdQ6Dda0FU/j
HVaTVk1i_]ec`NM_a>d2KlKc00=ba_9dao=ea_<00WG6l`05M<KeLLOfL<Sh
LLWiL<Sh00=_aoL00g38n?ooooooo`2loooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^<?oool2o`0000?ooooo003o00003?ooo`;o000<oooo0_l0
017oool2o`000_ooo`;o0008oooo0_l0027oool2o`006_ooo`0:DZkOEK7R
E;3QDZkODjoPEk?TF[CVFK?UFk?SGKGU0V2fi`9O]NH00f6gj6FhjVJhjP02
I[KY00UX^>U/^^]]^n]]^NY/^>U]^^Q/^NM]^NY`_>d00W2nkP04L;k_L/3`
L;k/L;k/0W6ok@9b`>h2LKo]00=_`>m``O1``O000Vo0k`0=LL;aL/?bLL;a
K/3`LL?cM/OfMlSgMLKeLlCcML?aM/CbMlSeM/Od009eaoH2M/Sg03=ebOQd
aoUdao]ea_]fa_UfaoIiaoEhbOIgb_IgboMdb?IeboYbb?UdaoUc`oAiaOIo
aoUe]N=BR:hgI8<NAUlI?DdO?48W?3dZ>CHX<B`Y;RXg?3Q9CDaAEeE7DThc
@3T[>S<fAS`f@c`oDTi6HfM3KgaTW[Ic^]Y__nA_a>e_a_5`ao9cao=eb?9f
aoAgb?Efb?MebOQ`b?P01Fg8m`03KlOgK/Kfoooo0;goool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h`oooo`;o00000oooool00?l0000<oooo0_l0
00coool2o`003_ooo`;o0002oooo00?o003oooooool00_l000Soool2o`00
8Oooo`;o000Joooo00]A[MiC[n1C[n1B[]mC[n1G/nAI/nEH/^AI/N5J/^9M
/n@00Ujdi@09GkGVH;KWH[SYHKCVHkGWIKGXJ;S[K;[[KK_/009^^^/00fjk
jFfjj6jjj`02Kkg]00=]^n]]^na^_>`00W2nk09a_nd4L/3^00=``O1a`_5`
`O000Vo0k`05L/?bLlCcL/?bKKo_LL?c009faoH037C5m7;3lWG3lGK4lWO8
mGG6lg?5m7C6mGK8mgG9mgC8mg;5m`9dao/09WG5n7G6mGS6mWW7mGS9mWO9
n7;6mGO=o7;8nGC7nGC6mW31l7K2lgRojff[e4n5ZBmPOR9<I211DRDmAbTk
?bXf=S]1?dE:ATiCCe=IEd]FDSQ7A351?SU9B3mADD5IGC]MIcUXNV6N^W>l
gGG4jg;5k`9ba_803WC7lGG8lWK7m7K7m7G7mWC8mg38n6g8mfk6mVc7mVo7
mg38n6o7mfg5mKkoool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
od?oool024n^g56`gUB`geB`geFah5JbhENbhEJah09G/N<02UZbi5bdiUng
jF2hjV6gjV2fjF2cif:ejFJhjVNij`9X^>T00f^ijFfkjfjlk002K;[Z0Vfk
j`07JK[YJKWZJ[_ZK[cZKkkYL;k/LKo]009b`>h2Ll7_00=``Nib`o1a`_40
0W31l00:L/?bLlCcLlCcKl7aLL?cM<CeM<GdM<;bM<;`ML?a0WO5l`07M<Gb
L/GaLlGdM<SfM<SgL/KeK/Ce009dao/0<WG5n7G6mGO5mGO5lgK7mWG7mW75
m7S<ng77n7C:ngS<ng;4lgG6lG[7lGc3kFNVcdb6ZcUZRReBK2a9FcI9Ece:
D55IFeQNFU]QGEYSGU=MG4=ADCa;CSmBF4IJIDQSM4=YP4EfU6NVbG6ihGC3
kW;5lG?6lWC7lgC7lGG7kgG6lGG6lg?5m7;6mG;8nFo7mfo5mVo7m`9aaoP0
0g36mfo5m_ooo`2moooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oo
oom3oooo00=@[meA/=iE/N000eJbh@0CE[7PEK3OFK?UF;;TF[;TGKGWH;SZ
HKW[HKOZGkGXH[GYIKS/J;[/IkW[I[KWIKGVJ;KVJkWYK;[Z009Z^>P02Vbj
jVZkjVZkjV^kk6fnkFjljVnnjG2nk76okG;0kP=c`Nl01G31kW;3l7;3lW31
l772l@02LlCc00Yb`o9a`o=a`o=b`_=a`_5c`O5d`_1fa?9gaO=e`o42LlCa
02mca_9caoIcaoI`a_E^a?Edao]daoUeaoUeaOIgaOEgaO=gaOEea_EeaoMg
boY_aOIdb_UicO]cao=fbO5jc?AlbOEa^^EVYM1ER[92KHloGWY9H79DHVeM
IfUWKFUYL6UUKVUJI6=8EUM1D5M4EfE4FW53HWhmIXI8O:=][=M`^NIb`?1a
`o9ca_9dao400WG7k`06M<G`LlK`LLGcLLGdLlKhL<Kg1G;5m`03LLCfoooo
oooo0;coool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooood?oool2
DK3N00AC[miD/=mE/N1E/N02E[7P00AH/^AI/nEL]>IM]NL2G[KX00IM]NML
]>IQ]nYR^>]U^>YT]nT2I;KV00=W^>MX^NQZ^nX00VRij009JK[YJ[[[Jk_/
K;k^L<7`Kkg[KkkYL;oZLL3[00Ab`>h00fo0kG72kg72l@02LL;a0W?4l`07
LL;aL/CdLL?eL<3aL<7`Ll7aML?a009faO001W?2kG?4kgG6lgC7lg?7mW;6
m@9`a_L017;8ngC7nGK8nWO7n0=iaoL0:gO8mgO9nGO:o736mGG;nWG<mg;7
l7K:kgC7kgG8m7?1kgFij6bWdef:/eIhVe]cRf5cPFIaLfefLFihKfafKV=]
K5=QI4YHHdYLL59[RSiPQRUDOcmcXW:ai7W0m7W6nW;4m7C5m7C5l7K5kWG7
kGG7kg?6l7;6m775m774mW;5m`02LlGg00Aba?Ia`oEba?Iba?Jnoooo0XS0
^058T8P10000000018S0^<SPf8S0^8S0^?oooom3oooo00YA/=i@[meB[]eB
[]eC[miD/=mF/N1H/n9F/>9H/^@2G;CV00YJ/^AH/>9H/>9I/N=P]^UO]NQQ
]>IR]NMU]nMW^NT2JK[Y00A]_^eZ^nYY^^UZ^nX2Jk_/00A]_nm``_5`_^a`
_nX2LL3[0W;0kP9a_nd01Fjok731kW72lG31l772l@02L/?b01E``O1ba?I`
`_A__o1``O1e`o=fa?9ea>md`nic`^eca>mfaoAeb?AcaoIba_EaaoQbb?Ub
b?]daoUfb?Yhb?T00Wc8n@0bNlWiN<WhMLOiM<OiLLOfN<olM/ghL/[`N<ca
L/K[M<SfM/OfOLGgO;[YLZ7=JXjbJ8:MJ7Z8Kgf0LWegKgU`KWUaKWQgHVme
F6IcDfEm=Dmb@VBACWRXJ9g?Pl;hK[O/L;gcM/SjLlCcM<G`M/G^MLO]MLO_
LlSaLlOcLLSeLL?eL/CfLlGgL/CfL/;eLL7dL/;eLl?f__ooo`:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
oooooooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooo
ooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0
^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo>OooobeVIYTDoooo
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo>Oooo`03IVJI
c<coc<co02W<c?l00fIVVOooooooo`0Boooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?oooooooooo>Oooo`03IVJIc<coc<co02W<c?l00fIVVOoo
ooooo`0Boooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
>Oooo`03IVJIc<coc<co02W<c?l00fIVVOooooooo`0Boooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?oooooooooo>Oooo`03IVJIc<coc<co00;<
c?l300000lc<o`H00002c<co0P000006c<co0000c<coc<co0000c<co0P00
00C<c?l300000lc<o`030000c<coc<co00;<c?l00fIVVOooooooo`0Boooo
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo>Oooo`05IVJI
c<coc<coc<co000000?<c?l010000<c<olc<o`0000K<c?l00`000<c<olc<
o`0200000/c<o`800002c<co00@0003<c?o<c?l00003c<co00@0003<c?o<
c?l00004c<co00=VIYWoooooool04_ooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;SoooooooooocWoool01FIVVLc<olc<olc<o`000003c<co00@0
003<c?o<c?l00006c<co00D0003<c?o<c?o<c?l000000/c<o`050000c<co
c<coc<co000000;<c?l00`000<c<olc<o`04c<co00<0003<c?o<c?l00/c<
o`03IVJIoooooooo01;oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
oooooooooolioooo00=VIYW<c?o<c?l01Lc<o`040000c<coc<co00001lc<
o`@00002c<co00D0003<c?o<c?o<c?l000000/c<o`D00002c<co00<0003<
c?o<c?l00/c<o`03IVJIoooooooo01;oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hoooooooooolioooo00=VIYW<c?o<c?l01Lc<o`040000c<co
c<co00002/c<o`040000c<coc<co00000lc<o`040000c<coc<co00000lc<
o`040000c<coc<co00001<c<o`03IVJIoooooooo01;oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hoooooooooolioooo00=VIYW<c?o<c?l01Lc<
o`040000c<coc<co00001/c<o`050000c<coc<coc<co000000;<c?l20000
0/c<o`040000c<coc<co00000lc<o`040000c<coc<co00001<c<o`03IVJI
oooooooo01;oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooo
oolioooo00=VIYW<c?o<c?l01Lc<o`040000c<coc<co00001lc<o`<00003
c<co00@0003<c?l000000004c<co0`0000?<c?l00`000<c<olc<o`02c<co
00=VIYWoooooool04_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
ooooooooocWoool00fIVVLc<olc<o`05c<co00@0003<c?o<c?l0000=c<co
00<0003<c?o<c?l02lc<o`030000c<coc<co00;<c?l00fIVVOooooooo`0B
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo>Oooo`03
IVJIc<coc<co00G<c?l010000<c<olc<o`0000g<c?l00`000<c<olc<o`0;
c<co00<0003<c?o<c?l00/c<o`03IVJIoooooooo01;oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hoooooooooolioooo00=VIYW<c?o<c?l0:Lc<
o`03IVJIoooooooo01;oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
oooooooooolioooo00=VIYW<c?o<c?l0:Lc<o`03IVJIoooooooo01;oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooolioooo00=VIYW<
c?o<c?l0:Lc<o`03IVJIoooooooo01;oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hoooooooooolioooo00=VIYW<c?o<c?l0:Lc<o`03IVJIoooo
oooo01;oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hooooooooooli
oooo;FIVVACoool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooo
oomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_oo
o`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
ooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooo
oomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_oo
o`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
ooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooo
oomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_oo
o`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
ooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooo
oomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_oo
o`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
ooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooo
oomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_oo
o`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
ooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooo
oomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_oo
o`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
ooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooo
oomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?ooool[oooo0P00
0?oooom=oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?ooool[oooo
0P000?oooom=oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooolF
oooo1@0000;oool2000000?oool0000000000_ooo`800002oooo0P000004
oooo00000000oooo0P0000;oool200000_ooo`@00006oooo100000;oool6
00000_ooo`D000001?ooo`0000000?ooo`800003oooo100000;oool20000
oooooaKoool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooaGoool2
00000oooo`8000001?ooo`0000000?ooo`800002oooo0P0000;oool20000
00Goool000000000003oool00P000004oooo00000000oooo0P0000;oool2
00001?ooo`800002oooo0P000003oooo0000000000Goool200000_ooo`80
00001Oooo`00000000000?ooo`02000000?oool0000000000_ooo`800000
0oooo`000000003ooooo5_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Sooooo6_ooo`8000001?ooo`0000000?ooo`800002oooo0P0000;oool2
000000?oool0000000000_ooo`8000001?ooo`0000000?ooo`800008oooo
0P0000;oool2000000?oool0000000001Oooo`800002oooo0P000003oooo
0000000000;oool2000000?oool0000000001Oooo`80003ooooo5_ooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo6?ooo`@000001?ooo`00
00000?ooo`800002oooo0P0000;oool2000000?oool0000000000_ooo`80
00001?ooo`0000000?ooo`H00008oooo0P000003oooo0000000000Koool2
000000Coool00000003oool200000_ooo`8000000oooo`00000000040000
00?oool000000000oooooaKoool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hoooooaKoool500000_ooo`8000000oooo`0000000002oooo0P0000;o
ool2000000?oool0000000000_ooo`8000001?ooo`0000000?ooo`800002
oooo0P0000Soool2000000?oool0000000001oooo`@000000oooo`000000
0002oooo0P000003oooo0000000000;oool2000000?oool000000000oooo
oaKoool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooaGoool40000
1?ooo`8000001Oooo`00000000000?ooo`03000000Coool00000003oool3
000000Coool00000003oool2000000?oool0000000000_ooo`800008oooo
0P000003oooo0000000000Goool010000?ooooooooooo`8000001Oooo`00
000000000?ooo`02000000?oool0000000000_ooo`8000000oooo`000000
003ooooo5_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo5Ooo
o`800006oooo0P000004oooo00000000oooo0P0000;oool200000_ooo`80
00000oooo`0000000002oooo0P0000;oool400002Oooo`8000000oooo`00
00000006oooo100000;oool2000000?oool0000000000oooo`@00002oooo
0P000?oooolFoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooolE
oooo0P0000?oool200005_ooo`80000?oooo0P000003oooo0000000000co
ool200003?ooo`80003ooooo5_ooo`:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Sooooo5_ooo`D00002oooo0P0001?oool200003oooo`8000000ooo
o`000000000<oooo0P0000coool20000oooooaKoool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
oooooooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7goool2
k^k^00BZZZYEEEFIVIW<c<`2k^k^ooooooCoool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hOOooo`0;gMgMR8R84A4AA4A48R8RVIUVMgMgR8R8ZZZZ
c<c<k^k^0?oooooaoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7co
ool01mgMgK^k^b8R8[^k^ooooc<c0<bIV@02c9UV00JIVFJIIVJIIVJ8R8RZ
ZZ[<c<`2k^k^oooooncoool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
O?ooo`03c<c<VIVI<c<c00;oool016IV<lbII_nII_nIIP;<VFH4VIUV00F8
R8RIVIVk^k_MgMg^k^h0ooooonWoool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2hNoooo`08k^k^c<c<R8R8EEEEk^k^ooooIVIVc9UV0onIV@04oiUV
olaVolaVoiUV0/bIIP08VIUVVFIVVIUVR8R8VIVI^k^kgMgMk^k^1oooo`03
k^k^oooooooo00Goool00nk^k_ooooooo`3ooooodoooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Qkoooo00C^k^k<c<bIVIUVIVH2oooo00QgMgO<
VFKoc9WoVIWoc9WoVIWoc9WoVIT2olbI1LbIIP>IVFH018R8R:ZZZ/c<c=gM
gOoooooRoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7_oool02>k^
k]gMgJZZZUEEEMgMgLc<c5EEELbIIPOoVIT01<bIVOo<VOnIVOnIV@?oc6H2
c<aV0YVIIP:IIVH00hR8R:ZZZ/c<c002k^k^0oooo`03k^k^oooooooo0?oo
oooGoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7coool01nk^k[^k
^fIVI]gMgLc<c5EEELbIIP04oiUV0onIV@04olbIoiVIoiVIolbI0_nIV@;o
VFH00lbII_o<I/bIIP03c9UV0iVIIP05ZZZZ^k^kc<c<k^k^oooo00?^k^h3
oooo00?^k^koooooool0ooooom3oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2hNoooo`08k^k^oooo^k^kMgMgk^k^gMgMR8R8c9VI0_nIV@CoVFH0
0oo<I_o<VOo<V@05olbI0_nIV@;oVFH3olaV0lbIIPBIVFH01IVIVK^k^mgM
gOooonk^kP3oooooeOooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qm
oooo00K<c<agMgO^k^kMgMf8R8S<VIT3oiVI00?oc9WoVIWoVFH00_nIIP04
c9UVolbIolbIoiVI1?o<V@?oVIT5oiUV00Coc6K<VFK<VFK<VFH4VIUV00BZ
ZZ[<c<cMgMg^k^h3oooo00?^k^koooooool0ooooolcoool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hNoooo`0:k^k^oooo^k^kMgMgc<c<^k^kMgMg
c9UVoiVIolbI1?nIV@06olbIoiVIoiVIolbIoiVIc9VI0onIV@?oc9T6oiVI
1Oo<IP?<VFH3VIUV00J8R8RZZZ[<c<c^k^koooo^k^kooooocOooo`:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Qloooo00O^k^k<c<b8R8S^k^kMgMf8
R8S<VFH01?nIV@04olbIoiVIolbIolbI1OnIV@?oc9T02?nII_o<VOo<VOo<
VOnIVOo<VOnIVOo<V@?oVIT00lbIVOnIVOnIIP02oiUV0lbIIPBIVFH019VI
VK^k^lc<c>k^k_ooooo;oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0
^7goool01<c<c8R8R?ooonk^kP:IVIT2olbI0_nIV@03olbIoiVIolbI00;o
VIT00oo<VOnIVOo<V@04olbI00?oVIWoc9WoVIT00onIIP;oc9T01?nIVOo<
VOnIVOo<V@;oVIT4oiUV00?<VFKoVFK<VFH00lbIIP>IVFH019VIVLc<c=gM
gNk^kP?oool2k^k^0_ooo`03k^k^oooooooo0?oooonmoooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^7goool01<c<c7MgMmgMgLc<c0:8R8P00onI
VOo<VOo<V@05olbI00KoVIWoc9Woc9WoVIWoc9WoVIT4olbI00GoVIWoc9Wo
VIWoVIWoVFH00/bIIP04oiUVoiVIoiVIolbI0_nIV@04olbIoiVIolbIoiUV
0_o<IP03oiUVolaVoiUV00;<VFH4VIUV00BIVIVZZZZk^k_MgMd2k^k^0_oo
o`03k^k^oooooooo0?oooonmoooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^7goool02/c<c7MgMmgMgLc<c8R8R9VII_o<VLbIVOo<VOnIV@Soc9T0
1?nIVOo<VOo<VOo<V@;oVIT3olbI0_nIV@03olbIoiVIoiUV00?<VFH00onI
I_o<VOnIV@03oiVI00Ooc9Woc6Koc9Woc6KoVFK<VFKoVFH01<bIIP09VIUV
c9UVVIUVVIVIolc<ooook^k^ooook^k^0?oooonooooo0XS0^058T8P10000
000018S0^<SPf8S0^8S0^7goool02<c<c8R8R>k^k]gMgIVIVIVII_o<VOnI
V@Koc9T00onIVOo<c?o<c005olbI00GoVIWoc9Woc9Woc9WoVIT00oo<V@04
oiVIolbIoiVIolbI0_nIIPC<VFH2oiUV0_nIV@03olbIolaVoiUV00;oVFH4
olaV0lbIIP03c<bIoooooooo0?ooooo1oooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^7coool01nk^k/c<c8R8R?ooomgMgJZZZYUVIP02olc<2Oo<
V@Goc<`4olbI0onIV@Ooc9T01?o<I_nII_nII_nIIP?<VFH3oiUV00?oc6Ko
c9Woc6H00_o<IP04olbIolaVolaVc9VI0/bIIP03gMgMk^k^k^k^0?ooooo0
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7goool01/c<c7MgMmgM
gLc<c:ZZZVIVIPGoc<`00oo<VOo<c?o<c005olbI1_o<c0?oc9T01?nIVOo<
VOnIVLbIV@;oVIT3olbI0oo<IP;oVFH4c9UV00CoVFK<VFKoc6Koc6H4olbI
0_nIIP03c9UVolc<oooo0?ooooo1oooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^7goool01/c<c7MgMmgMgLc<c;^k^fIV<`Coc9T8olc<2Oo<V@08
olc<olbIolbIolbIoiVIolbIoiUVc9UV0onIIPCoc6H4oiUV1LbIIP;oVFH0
1OnIVOnII_nII_nII/c<c002k^k^oooool3oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hOOooo`07c<c<R8R8ooook^k^^k^kIVHcolc<00Koc9T9
olc<0oo<V@03oiVIolbIolbI00Goc9T2oiVI00?oc9WoVFKoVFH00lbIIP?o
VFH2olaV0onIIPC<VFH4oiUV00?oc<coooo^k^h0oooool3oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hO?ooo`03k^k^c<c<R8R800;^k^h00mgM
gEEEEOo<c005olc<00?oc9Woc<coc9T02_o<c0Koc9T01OnIVOo<VOo<VOo<
VOnIV@03olbI0_nIIPC<VFH5oiUV00?<VFKoVFKoVFH00_nIIP03c<bIoiUV
olc<0?ooooo2oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7goool0
0lc<c7MgMmgMg@02c<c<00<c<c?oc<coc<`05?o<c0Coc9T01OnIVOo<VOo<
VOo<VOnIV@04olbI00Coc6KoVFKoVFKoVFH5c9UV0onIIP05olaVoiUVolbI
oiUVolc<0?ooooo2oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7go
ool01/c<c8R8R>k^k]gMgLc<c3<c<aSoc<`4olbI00CoVIW<VIWoVIW<VFH2
oiUV0oo<V@;oc6H3oiUV1LbIIP;oVFH00onIVOnII_o<c03ooooo`_ooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Qmoooo00K<c<b8R8Soooo^k^kM
gMe4A4@Dolc<0_o<V@;oc<`8olbI0onIIP?<VFH01onII_o<I_o<I_o<I_nI
I/bII_nIIP03c9UV0_nIV@03oiUVolc<oooo00koool300003oooo`@0003o
ooooWOooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qmoooo00K<c<b8
R8S^k^k^k^kMgMe4A4@Golc<00Coc9W<c9Woc9WoVIT8olbI00?oVFK<VFK<
VFH00/bIIP03oiUVc9UVolaV00?oc6H01_nII_o<I_nIVLbIVOnII_o<c17o
ool200003Oooo`040000oooooooooooo0P000?oooonLoooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^7goool00lc<c7MgMnk^kP02c<c<00=4A4Co
c<coc<`05_o<c003olbIc<bIolbI00;oc9T00onIVOo<VOnIV@06olbI00?o
c6K<VFK<VFH01LbIIP06olaVolbIoiVIolbIoiUVolbI1oooo`800004oooo
0P0000;oool300000_ooo`8000000oooo`0000000002oooo0P0000;oool2
000000Coool00000003oool2000000Coool00000003oool20000oooooi?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hOOooo`06c<c<R8R8oooo
gMgMc<c<EEEE6_o<c0Coc9T01OnIVLc<VLbII/bII/bIV@06olbI00?oc6Ko
VFK<VFH01<bIIP04oiUVoiVIoiUVolbI1oooo`800004oooo0P0000;oool3
00000_ooo`8000000oooo`0000000002oooo0P000004oooo00000000oooo
0`000004oooo00000000oooo0P000003oooo000000000?oooonCoooo0XS0
^058T8P10000000018S0^<SPf8S0^8S0^7goool01/c<c8R8R?ooonk^k]gM
gFIVIQcoc<`5olbI00SoVIW<c9WoVFK<VFKoVFKoc6KoVIWoc6H2olbI00W<
c9Woc6K<VFK<VFKoVFKoVIWoc9WoVIW<c9T01oooo`800004oooo0P000004
oooo00000000oooo0P000004oooo00000000oooo0P0000;oool2000000?o
ool0000000000_ooo`80003oooooW?ooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Qmoooo00?<c<agMgO^k^h00]gMg@03R8R8c9VIolc<01Koc<`2
olbI00?<c9Woc9Woc9T01oo<V@03oiVIc9VIc9UV00C<VFH00oo<I/c<VOo<
V@03olbI00?oVIWoc9WoVIT00_ooo`03k^k^oooooooo00;oool200001?oo
o`8000001?ooo`0000000?ooo`8000001?ooo`0000000?ooo`800002oooo
0P000003oooo0000000000;oool20000oooooicoool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hOOooo`05c<c<R8R8gMgMgMgM^k^k00:8R8P5olc<
00?^k^koc<coc<`04Oo<c0koc9T00oo<I_nII/bIIP04c9UV0_o<V@03oiVI
olbIolbI00;oool00nk^k_ooooooo`02oooo1@000004oooo00000000oooo
0P000004oooo00000000oooo0P000003oooo0000000000;oool2000000?o
ool0000000000_ooo`80003oooooW?ooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Qmoooo00O<c<b8R8S^k^k^k^k<c<bIVIVIIVH01oo<c003k^k^
olc<k^k^017oc<`6olbI00?<c9W<VIWoVIT01oo<V@C<VFH4olbI0_ooo`03
k^k^oooooooo00;oool200001?ooo`@00003oooo10000005oooo00000000
0000oooo008000001?ooo`0000000?ooo`<0003oooooW?ooo`:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Qmoooo00S<c<b8R8Soooo^k^kMgMfk^k]V
IVK^k^h<olc<00?^k^koc<coc<`03Oo<c0Goc9T00lc<VLbIVLc<V@02oiUV
1oo<V@05c<bIolbIolbIolbIoiVI00;^k^h5oooo0P0000Coool400000ooo
o`@000001?ooo`0000000?ooo`800003oooo0P000003oooo000000000?oo
oonLoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7goool01<c<c7Mg
Mnk^k]gMg@;<c<`01FIV<nk^k_o<c?o<c>k^kP03olc<00G^k^koc<c^k^ko
c<c^k^h00_o<c004k^k^olc<olc<k^k^1oo<c0_oc9T00onIVLc<VLc<V@04
c9UV0/c<V@Goc9T00onIVNk^k_ooo`05oooo0P0000Coool20000oooook?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hOOooo`09c<c<R8R8k^k^
gMgMc<c<^k^kA4A4olc<k^k^00?oc<`00nk^k_o<c?o<c002k^k^0_o<c004
k^k^olc<olc<k^k^2_o<c003olbIc<bIolbI00[oc9T00onIVLc<VLbIV@05
c9UV1?o<V@03gMgMoooooooo00Coool5000000?oool0000000001oooo`80
003oooooZ_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qmoooo00S<
c<b8R8Soooo^k^kMgMg<c<a4A4C^k^h6olc<1>k^kP04olc<k^k^k^k^k^k^
3Oo<c0koc9T02_nIVLc<VLbIVLbII/bIVOo<VOnIVOo<VOnIVMgMgOooooo1
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7goool00lc<c8R8R?oo
o`02k^k^00CMgMe4A4C^k^k^k^h6olc<1nk^kPkoc<`8olbI00C<c9W<VFK<
VIW<VIT7olbI00CoVIWoc9Woc9Woc<cooooo`Oooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Qmoooo00?<c<b8R8S^k^h00]gMg@03c<c<EEEEgMgM
00K^k^h2olc<00?^k^koc<coc<`01_o<c003k^k^olc<olc<00Goc<`=olbI
00C<c9W<VIW<VFK<VFH2c9VI1oo<VOooooo1oooo0XS0^058T8P100000000
18S0^<SPf8S0^8S0^7goool02<c<c8R8R>k^k^k^k]gMgLc<c5EEEK^k^`[^
k^h2olc<00C^k^koc<coc<c^k^h;olc<0_o<V@03c<bIolbIolbI00Soc9T2
c<bI00C<VIW<VFK<VFK<VFH5olbIoooool7oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hOOooo`08^k^kR8R8ooooooook^k^gMgMR8R8VIVI0nk^
kP03gMgMk^k^k^k^00K^k^h00oo<c>k^k_o<c00>olc<3oo<V@03c<bIc9VI
oiVI00Coc9Wooooo`Oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qm
oooo00S<c<b8R8Soooooooo^k^kMgMfZZZZIVIT@k^k^3_o<c0Ooc9T4c<bI
1oo<V@03c<bIolbIolbI0?ooooo1oooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^7goool01Lc<c8R8R>k^k^k^k]gMg@02c<c<00=EEEGoooo^k^h0
4>k^kPSoc<`>olbI00C<VIW<c9W<c9W<c9T2c9VI1Oo<V@03k^k^oooooooo
0?oooonnoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7goool01Lc<
c8R8R>k^k^k^k]gMg@02c<c<00<R8R;MgMgoool01>k^kP;oool8k^k^3?o<
c0;oc9T00lc<VOo<VOo<V@0:olbI0lc<V@Goc9T00nk^k_ooooooo`3ooooo
__ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qmoooo00Bk^k^8R8So
ooooool2k^k^00G<c<bZZZXc<c?<c<coool01^k^kP03ooook^k^k^k^00K^
k^h<olc<1?o<V@04c<bIolbIc<bIc<bI3Oo<V@03gMgMoooooooo0?oooonn
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7goool00lc<c8R8R?oo
o`02oooo0^k^kP07gMgMc<c<EEEE<c<cIVIVR8R8k^k^00?oool9k^k^3?o<
c0Woc9T2c<bI00?<VIWoc9Woc9T01oo<V@03gMgMoooooooo0?oooonnoooo
0XS0^058T8P10000000018S0^<SPf8S0^8S0^7goool01<c<c8R8R>k^k^k^
kPOMgMd01lc<c9VIVFIVITA4A6IVIYVIVMgMg@08k^k^00?oc<c^k^k^k^h0
1?o<c005c<c<olc<olc<olbIc<bI00?oc9T00lc<VOo<VOo<V@04olbI0lc<
V@03olbIc<bIc<bI00?oc9T01<c<VOo<VOo<c>k^k_oooonooooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^7coool01>k^k]gMgGMgMoooo`;^k^h0
0mgMgLc<c<c<c002^k^k00c<c<cMgMgMgMgMgMgoc<c<c<bZZZYgMgM4A4AE
EEFIVIW<c<`5k^k^0_o<c003k^k^olc<olc<00Koc<`=olbI00[<c9Woc9Wo
c9Woc9W<c9Woc9W<c9WoVIWoc<c^k^kooooo_oooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Qnoooo00AEEEG^k^koooooool2k^k^0]gMg@;<c<`0
0k^k^lc<c<c<c003c<c<0]gMg@0;c<c<ZZZZMgMgA4A4EEEEMgMg^k^kolc<
k^k^olc<c<c<00[oc<`4olbI0/c<V@03olbIc<bIc<bI00Soc9T01<c<VOo<
VOo<c>k^k_oooonooooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7ko
ool00jZZZWMgMoooo`03oooo0^k^kP?MgMd2c<c<1K^k^`03c<c<gMgMgMgM
00;MgMd01[^k^gMgMdA4A4A4A7MgMlbIV@Coc<`00oo<VOo<c?o<c005olc<
1<c<V@04olbIc<bIolbIolbI0lc<V@;oc9T01/c<VOo<VLc<VOo<VOo<c>k^
k_oooonooooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7ooool017Mg
MjZZZ^k^k^k^kPCMgMd3k^k^1=gMg@;<c<`4^k^k0lc<c0;MgMd01jZZZXR8
R5EEEDA4A5EEEHR8R<c<c003olc<0_o<V@03c<bIolbIolbI00Koc9T2c<bI
0_o<V@03c<bIolbIolbI00Coc9T00nk^k_ooooooo`3ooooo_Oooo`:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Qooooo00?MgMeEEEGoool00^k^kP03
gMgMc<c<c<c<00;<c<`2gMgM0^k^kPGMgMd9c<c<0]gMg@09c<c<VIVIIVIV
IS<cIVHcVFIVc<bIolbIolc<00Koc9T00lc<VOo<VOo<V@03olbI0/c<V@Go
c9T00nk^k_ooooooo`3ooooo_Oooo`:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Qloooo0^k^kP;oool014A4A?ooooooooooo`;^k^h2gMgM1/c<c0;M
gMd2k^k^1=gMg@W<c<`2gMgM00?<c<bZZZYVIVH00VIV<`06VIUVc9VIc<bI
olbIc<bIc9VI0oo<V@03c<bIolbIolbI00Ooc9T00mgMgOooooooo`3ooooo
_Oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qnoooo00?^k^kooomV
IVH00^k^kP;oool01>k^k_ooonk^k^k^kPCMgMd5c<c<0mgMg@C^k^h2gMgM
2<c<c0?MgMd01k^k^gMgMfHc<dA4A6IVI/bII/c<V@03olbI00?<c9Woc9Wo
c9T00_o<V@05olc<c<bIolbIolbIgMgM0?oooonooooo0XS0^058T8P10000
000018S0^<SPf8S0^8S0^7koool01Nk^k_oooiVIVIVIVOooo`05k^k^0ooo
o`?^k^h3gMgM1<c<c0;MgMd00nk^k_ooonk^kP03k^k^0mgMg@O<c<`3gMgM
00Jk^k^8R8QEEEEV<c=EEEFIVFH3c<bI1_o<V@03olc<oooooooo0?oooonm
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^83oool01]gMgEEEENk^
k^k^k_ooonk^kP?MgMd01Nk^k]gMgNk^k^k^k_ooo`04k^k^0mgMg@06c<c<
R8R8EEEER8R8c<c<k^k^1?ooo`;^k^h00mgMgNk^k]gMg@04c<c<00Bk^k_<
c<c<c<c<c<`2gMgM00Nk^k^IVIUEEEEV<c=VIS>IVFK<VIT01?o<V@03c<c<
oooooooo0?oooonmoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^87o
ool01Lc<c4A4A9VIVLc<c>k^kP02oooo0^k^kPGMgMd4k^k^00coooo^k^k^
k^k^k^kooooMgMfIVIUgMgMEEEF8R8Rk^k_MgMd2oooo0nk^kP03gMgMk^k^
gMgM00C<c<`3^k^k1Lc<c007VIVIVIUVIVIVIS<cVFIVc9VIolc<0?oooono
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7koool00nk^k_ooonk^
kP02oooo00OMgMfk^k^8R8QgMgN8R8RZZZ[MgMd00_ooo`;^k^h6gMgM0nk^
kP;oool02^k^k_ooooooomgMgK^k^hR8R6IVIWMgMjZZZ]gMg@O^k^h3c<c<
1;^k^`05c<c<^k^kc<c<k^k^oooo00;^k^h00mgMgOooooooo`3ooooo__oo
o`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qmoooo00?^k^koooo^k^h0
1?ooo`06k^k^ooooooooooooc<c<VIVI0WMgM`04ZZZZgMgMoooooooo0^k^
kP?MgMd00nk^k_ooooooo`08oooo00O^k^jk^k^8R8QVIVIgMgNIVIW<c<`0
1>k^kP05gMgMk^k^gMgMgMgMc<c<00Bk^k_oooooaOooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;R1oooo00?^k^koooooool01?ooo`06k^k^oooo
oooooooogMgMVIVI0WMgM`03VIVIc<c<k^k^00?^k^h>oooo00?^k^k<c<bI
VIT00VIVIP04R8R8^k^kgMgMgMgM0nk^kP04gMgMc<c<c<c<c<c<ooooolGo
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hNoooo`05k^k^oooooooo
ooook^k^013oool01MgMgK^k^hR8R;^k^nk^kP0Doooo00OMgMfIVIUgMgME
EEEgMgNZZZ[<c<`00^k^kP;MgMd2k^k^0oooo`03k^k^oooooooo0?oooonm
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^7koool00nk^k_oooooo
o`0]oooo00Fk^k^8R8QVIVIVIVJk^k/0ooooolKoool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
oooooooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooo
ooooN_ooo`:8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h
0DR@R04000000004R<2hb>3HR<2hR<2h5P00P0<00H0200:000@00X400h40
0h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R20081
28<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108A
QP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN8
0`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3
126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh0
0`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA
1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLe
TP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`Pm
U@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4
V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/3
2TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN
2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:00
10aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=
HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iY
Y@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?
LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X3
47V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61
[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;02
4XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P03
4hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E
]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`04
5Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X3
5ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm
00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1000P003VjOa<d>U<d>U00Tc
@jD600200`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X80
1X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@0
0`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<3
6hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=
12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5
:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9
AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YA
W@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]G
W`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW
3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mc
Z@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@
OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hA
Q:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H0
11BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ
_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P03
5k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P3002000NKYo7ooon>N[JVVlBcZM:XWLRcZM800ZJKa005_;SMk^kd
j^Waoooo<d>U00D0080300600P02P00400:100>100>100>10`04P@801H40
1005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;
P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>7
0QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<I
R@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@4
98`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5
:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I42
1S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC
00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H0
10Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9
AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@
W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP03
2eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ43
35jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S
0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H2
3VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ003
3g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l
[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<A
Pjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa
4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc
0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H3
59Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<E
WkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX
^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G
[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C08000008H]<0@00000QRd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000BKYo7ooom/FZF_
YLX2_;SM00[ooOncZM;ooooooonl^=fGR[bXWLSVi^cooolc@jD400200`01
P0800X001002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N2
00<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@3
0@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ7
00@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<M
RP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<5
9Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]
T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B
0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@3
1cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G
0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9
VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;
DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]I
W`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaP
XPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY003
3FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW
0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`me
Z@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@
Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65
[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8B
SK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@C
T[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK
]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ
^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m
5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o
00<G/[l35k>o0QRd`003b>3HB928B92800a8T8P00`000<SPf4R@R00=B928
00@0000H]<0H]<38h=P>B92800<0000H]<0H]<000XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008002i^WlOooojRMb?oook>YdV1<VXij]WQU[ZRM
b?ooooomo`03oooo00<c@jD0080008000`00P0<00H0200:000@00X400h40
0h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R20081
28<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD20Q250ooo
o`824HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<G
R0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3
122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>
1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i00
10H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987
=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`Pl
U@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9
A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX3
2TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]D
W@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj02
35bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP03
3F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eX
Y@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`04
3g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX3
47RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]
00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk03
4XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8B
S[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D
]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8D
WKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX3
5JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm
0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl2
6;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd
`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0P00P00>VjOaoooooooofmc/H4bJThFj/jWB_;SMH4bJVHnn
YY_4b<?Ooooo<d>U1P00P0?oool200:000<00X7oooooool00_ooo`801840
0`05POooo`05PP0300J21?ooo`030@R20@R3oooo00?oool30@Z300Koool1
2h@12h@138Coool138@20@f400Coool13XGoool13XD20Pn500Coool248Go
ool248D20Q6600?oool24HH24XH00P8BQP824hH0108CQ`8DQ`8DQ`8DQ`<2
5HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT3
0ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=
0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl4
1Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B
1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD
00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8
@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT3
2DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YA
W@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`03
2eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aO
XPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eU
Y0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW
3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@04
3gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@
OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lA
Q:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba
00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<C
T[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ
]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TE
X;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_004
5Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n
5k6o5k6o00<G/[l35k>o0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P00dR@
R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8
T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00>
VjOaoooo_;SMVHnnooooe]7Mfmc/lokoYY_4k^kdQGJ`ThFjoooo<d>U1000
P007oooo006000600060oooo00:0oooo00<00h401_ooo`04P@04P@05POoo
o`05PP801X802?ooo`07PP07PP47P_ooo`48P_ooo`48P`<12H<01?ooo`4:
P`4:Poooo`812h@00`4<Q?ooo`4<Q0020@f400Coool13XGoool13XD20Pn5
00?oool248Goool00oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB70`8E
Q`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<3
78X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd2
1BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5
;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86
<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@0
0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1
U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9
B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M
2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;
F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR
362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT
3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>
KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?
M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n
[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64
[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;40
11:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B
/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg
59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP
^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@F
Zk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG
/KlG/Kl00aNb_`<G/kl26;C000C8h=R8`;R8`;R8`;P6000018S0^003B928
0000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P00000
0QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008003i^WlOoooiV?
_YN:_=CCj>n//omfNnjOZe]HYJJKa9JOdV1<V[bhgOoooc=3Y@03002000Oo
ool00H000H000H3oool00X3oool00`03P@06oooo00B100B1oooo00F1oooo
0P06PP08oooo00N200N20@N2oooo0@R2oooo0@R30`49P`09oooo0@Z3oooo
0@^3oooo0@^4oooo0@b4oooo00813H@01?ooo`4>QOooo`4>Q@823hD01?oo
o`8@QOooo`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:
0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DV
S@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@
0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i82
1SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7
>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL2
24>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ
0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]B
W@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO
0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R
362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=
IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL3
3VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o
[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_
1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=
/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B
]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g
59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i
0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdF
ZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl0
0aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P0
0`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2h
R<2h00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOXZFjP
b<?OThFjFdJCVHnn0WQU[P04@RN5[jG:oooo<d>U1000P0<00H000oooo`02
P002P@04oooo0P04P@03oooo00F1oooo00<01X84oooo00<1288128<128<0
0`49P`09oooo0@Z3oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?ooo`4>
QOooo`4>Q@823hD00oooo`8@QOooo`03oooo0P8AQP<24XH20Q>600@24hL2
58L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV9
00@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@T
S0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZ
S`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86
<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<0
0`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04
242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6
V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L
00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;
Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<
GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<3
3FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>
KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?
LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/
111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63
[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4B
R[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<3
4i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<D
VKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO
^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk
0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN_
_P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h
00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@
R00000026;C000?8h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOaoooooooo
00;oool02_n]/?mfNoW=e?g]k_ooojJKa8Ef/;bhgOoooc=3Y@D008030060
00?oool00X000X400`03P@03oooo00B1oooo00801H401005P_ooo`06PP06
PP801h800`47P_ooo`48PP020@R30oooo`812X<01oooo`4;Poooo`4;Q?oo
o`4<Q?ooo`020@f400Coool13XGoooooool20Pn500Koool248Goool248D2
4HKoool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP3
5hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX3
11n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DW
S@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y02
1Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP03
1cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`Lk
U@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`04
2D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX3
2T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M
00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ03
35^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<
HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eW
Y0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>
L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX3
3gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]
0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl3
4XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8B
SK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C
]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<D
W;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T3
5J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm
0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l3
5k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028
`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^004
R<2h0P0000F8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3002000ZQ[?;icMCR9Scd]KoR9ScdKGglhnWoooomkNko[K02
oooo00<c@jD0080008001000P0<00H000oooo`02P002P@03oooo0P04P@05
oooo00F100F100F2oooo00801X83oooo0P48PP030@R3oooo0@V300812H<2
0@Z300Coool12h<12hCoool20@b400Ooool13H@13HCoool13XGoool13XD0
0_ooo`030Pn50Q250Q2500Coool0108AQP8BQP8BQP8BQP824hH0108CQ`8D
Q`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT0
10<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<
12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?
1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHb
T@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`03
1cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8
@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI
2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`0
10YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]G
WP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aN
X@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=
I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]
YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mc
Z0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`4
47f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^
00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::
/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<C
T;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI
]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh
00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/3
5ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn
0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P0
0dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB928
0000008H]<000lSPf8S0^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000fKYo7mkNkR9Scn
mOSgRIOdHVkcX:kdHVkooOoo[K3lhnWooolc@jD01`00P0<00H000oooo`02
P002P@0300>10`04P@801H401005PP06PP06PP06PP801h801@47PP48PP48
P_ooo`48P`030@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD3
0Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN8
0aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@O
R`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd5
9hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_
T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`Ld
TPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD3
23bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3
V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;
VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@03
2eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aK
X08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R
00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@3
3FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W
00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mg
ZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<A
P:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7
/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb
0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@3
4iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg
0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS
^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G
[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc
_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2h
R<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0
^0800002R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2002000>KYo7fb<cR9S`00_n]/007gb@^ojBNm[c5
ojf`kW^<oooo<d>U00P00803006000?oool00X000X400`03P@<0184200F1
00@01H801X801X801X8200N200D11h81288128;oool128<00`49P`04oooo
0@Z30@Z30@^30P4;Q0<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>6
00@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV8
0aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@4
8h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh0
0`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A
0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`Lf
T`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF
0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP0
0`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:
Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh3
2eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aM
X@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeR
X`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V
0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP3
3g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@
Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P03
4H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4B
R[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb
008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne
11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh
5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<F
Yk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG
[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0
^00;R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38
h=P00hS0^0800004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2002000>KYo7icMCgRIL00_ooo`07ojf`
hAHdogIkojBNhRHlohUo<d>U00P00803006000?oool00X000X400`03P@<0
184200F100@01H801X801X801X8200N200@11h812881288128<4oooo0`4:
P`030@^30@^40@^400<138@20@f400Coool13XD13XD13XD30Pn50`8@Q@@2
4HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<G
R0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;
0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>
00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_
T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87
=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8
?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9
A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK
0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]D
WP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP
00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R
3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>
JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X
3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ
0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<A
PJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`
0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[80
0a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<C
UKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL0
11FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj
0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]
_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C0
00?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P900000XS0^005B928
00006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2002000NKYo7oooocX:kdHVkoooogRIOicM@00_oo
o`03lj2^oooo<d>U00P0080300600P02P00400:100>100>100>10`04P@80
1H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<0
0`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP04
0Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<I
R@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><
00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5
:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6
<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<3
1cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88
@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9
AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL
10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]F
WP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<
GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<3
3F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>
K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mb
Z0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[
0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62
[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa
4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P02
4hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@D
V;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN
^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk
0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn
00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P0
2hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8
T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00;
VjOaooooohUooooolj2^lI>Qoooooogolj2^oo_l<d>U00P0080300600P02
P00400:100>100>100>10`04P@801H401005PP06PP06PP06PP801h800`47
PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD3
0Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<F
R0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@N
RP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@03
1BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^
T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB
00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@3
1c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G
00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:
VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;
Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJ
X0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R
0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@3
3FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW
0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mf
ZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8A
Ojd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166
[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=
/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]003
4i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g
0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR
^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF
[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb
_`<G/kl26;C03lSPf0030000b>3Hb>3H00g8h=P00`0001Rd`1Rd`00?b>3H
00<0000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0@00803
VjOa00KoooocX:kd]Kof_<GkfMXc@jD900200`01P0800X001002P@03P@03
P@03P@<0184200F100@01H801X801X801X8200N200<11h81288128800P48
P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q66
0`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP3
0aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<4
8H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP03
1BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46
<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB
0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE
10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH
2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:
CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;
E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX004
35bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeR
XPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU
0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0ma
Z0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@
NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]
4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08B
RK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<C
S[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe
0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@E
WKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<F
YKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd0
0aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;PF00200`01P0800X001002P@03
P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h8128812880
0P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D4
0Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP3
5hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@P
R`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDW
SP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6
;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB
1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D3
23fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH
2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<
V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;
E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaL
X00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQ
XPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D3
3VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`
Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1h
ZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@03
4H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8
/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb
00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@3
4iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg
00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT
^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G
[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd
`0:8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@R040
00000003R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058T8P1000000000hS0^<SP
f<SPf03ob>3HolSPf7g8h=P1B9280@000000ohS0^?n8`;R1R<2h0@000000
\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?oo
l?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`
l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003o
oo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;o
l?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV0002ooooo`;ok^k^00CoZZZZoeEEEOnIVIWoc<c<0_o^k^heoooooooo
k^k^ooo^k^i3onk^kP000_ooool02ooMgMgoR8R8oa4A4Om4A4Co8R8RoiVI
I_mgMgOoR8R8ojZZZ_o<c<cok^k^0?oooooooooooomeooooo`0000Sooooo
omgMgOnk^k_o8R8Rok^k^ooooooo<c<0olbIV@;oc9UV00KoVIUVoiUVI_nI
IVKoR8R8ojZZZ_o<c<`2onk^kRgoooooooo^k^koonk^kT?ok^k^00001?oo
ooooc<c<oiVIVOlc<c<2ooooo`04ofIV<oo<VFKooiUVoonIIP;oc9UV1?nI
VFH01On8R8SoVIVIok^k^ooMgMgok^k^02[ooooooooVi^KoonKViT?oi^KV
00002?o^k^koc<c<ohR8R?mEEEGok^k^oooooomVIVKoc9UV0oooVIT01?oo
VFKoolaVooo<I_ooVFH2olbIIP08oiVII_nIIVKoVIUVohR8R?nIVIWo^k^k
omgMgOo^k^h7ooooo`03onk^k_oooooooooo00Gooooo00?ok^k^oooooooo
ool05?ooooooonk^k_ook^k^@oo^k^h00004onk^k_o<c<coVIVIofIVIP;o
oooo00SoMgMgolbII_ooc9WooiVIooo<VOooVIWoolbIoonIV@;oolbI1Oo<
VFH3oiVIIP04ohR8R?nZZZ[oc<c<omgMgOoooooooooooomVooooo`0000So
k^k^omgMgOnZZZ[oEEEEomgMgOo<c<coEEEEolbIIPOooiVI00Coc9VIooo<
VOooVIWooiVI0oooc6H2olc<IP;oVIUV0_nIIVH00on8R8SoZZZZolc<c002
onk^kP?ooooo00?ok^k^ooooooooool06?ooooooonk^k_ook^k^@oo^k^h0
0008ooooooo^k^ko^k^kofIVI_oMgMgoc<c<oeEEEOo<VFH4oonIIP?ooiVI
00CoolbIoonIVOooVIWoolbI0_ooVIT2oonIIP03olbII_ooc6Koc9UV00?o
c9UV0onIVFH01OnZZZ[o^k^kolc<c?o^k^kooooo00?ok^k^0oooool00oo^
k^koooooooooo`0Aooooooooi^KVoooVi^I3onKViP0000Sok^k^oooooonk
^k_oMgMgonk^k_oMgMgoR8R8olbIV@;ooiVI1?ooVFH00oooc6KoolbIooo<
V@05ooo<V@;ooiVI0_ooVFH3ooo<IP?oc9UV1?nIVFH01OnIVIWo^k^komgM
gOooooook^k^01Koooooooo^k^koonk^kT?ok^k^0002ooooo`06olc<c?mg
MgOok^k^omgMgOn8R8Soc9VI0oooVIT00oooc9WooiVIoonIIP02oonIIP04
olbII_ooc9WoolbIoonIV@CoolbI0oooVIT5oonIIP04ooo<I_o<VFKoc9UV
olbIIPCoVIUV00CoZZZZolc<c?oMgMgok^k^0oooool00oo^k^kooooooooo
o`3oooooooooooooD?ooool0000:onk^k_oooooo^k^kogMgMoo<c<co^k^k
ogMgMoo<VFKooiVIooo<V@CooiVI00KoolbIoonIVOooVIWoolbIoonIVOo<
VIT3oonIV@?oolbI1_ooVIT5ooo<IP?oc9UV0onIVFH01_n8R8SoZZZZolc<
c?o^k^koooooonk^kPkoooooooo^k^koonk^kT?ok^k^00002?ooooook^k^
olc<c?n8R8Sok^k^omgMgOn8R8Soc9UV1?ooVIT01?ooc9WooiVIooo<VOoo
c9T5oonIV@?oolbI00SooiUVooo<VOooc9WoolbIoonIVOooc9WooiVIooo<
V@?ooiVI00?oc9VIoonIVOooVFH00_ooVFH3olbIIPCoVIUV00CoVIVIok^k
^oo<c<cok^k^3?ooooooonKVi_ooi^KV@ooVi^H000;ooooo00Coc<c<ohR8
R?ooooook^k^0_nIVIT2ooo<V@;ooiVI00?oolbIoonIVOooc9T00_ooVIT0
0oooc9WooiVIooo<V@04ooo<V@03oonIVOooc9WooiVI00?ooiUV0_ooc9T0
1?ooVIWoolbIoonIVOooc9T2oonIV@CooiUV00?oc9UVoonII_o<VFH00oo<
VFH3oiVIIP04oiVIVOo<c<cogMgMonk^kP?ooooo0_o^k^h2ooooooook^k^
ooo^k^i4onk^kP000_ooool01?o<c<coMgMgomgMgOo<c<`2ohR8R003oonI
VOooc9WoolbI00GoolbI00KooiVIooo<VOooc9WooiVIooo<VOooVIT4ooo<
V@05oonIVOooc9WooiVIoonIVOooVFH00_o<VFH01?ooVFKooiVIoonIVOoo
c9T2oonIV@04ooo<VOooVIWoolbIoonIIP;oolaV00?ooiUVooo<I_ooVFH0
0_o<VFH4oiVIIP04oiVIVOnZZZ[o^k^komgMg@;ok^k^0_ooool00oo^k^ko
ooooooooo`3ooooooooooooo@Oooool000;ooooo00[oc<c<ogMgMooMgMgo
c<c<ohR8R?nIVFKoolbIolbIVOooc9WooiVI2?ooc9T01?ooVIWoolbIooo<
VOooc9T2oonIV@?oolbI0_ooVIT00oooc9WooiVIoonIIP03olbIIP03oonI
I_ooc9WooiVI00?ooiVI00OoolbIooo<I_ooc9WoolaVoonII_o<VFKooiUV
00Coc9UV00SoVIUVolbII_nIVFKoVIVIooo<c?ooooook^k^ooooooook^k^
ooo^k^i4onk^kP000_ooool02?o<c<coR8R8onk^k_oMgMgoVIVIoiVII_oo
c9WooiVI1_ooc9T00oooVIWoolc<ooo<c005ooo<V@05oonIVOooc9WoolbI
ooo<VOooVIT00oooc9T01?ooVIWoolbIoonIVOooc9T2oonIIPCoc9UV0_oo
VFH2oonIV@03ooo<VOooc6KooiUV00;ooiUV1?ooc6H3olbIIP03olc<VOoo
oooooooo00;ooooooooVi^KoonKViT?oi^KV00002?ooooook^k^olc<c?n8
R8SoooooomgMgOnZZZ[oVFIV0_ooc<`9ooo<V@Goolc<1?ooc9T3oonIV@Oo
olbI00CoolaVoonII_ooVFKooiUV0oo<VFH3oonIIP03ooo<I_ooc9WoolaV
00;oolaV00CoolbIooo<I_ooc6Koc9VI0_o<VFH01?oMgMgok^k^onk^k_oo
ooooonk^k_ook^k^@oo^k^h000;ooooo00Koc<c<ogMgMooMgMgoc<c<ojZZ
Z_mVIVH5ooo<c003ooo<VOooc<coolc<00GoolbI1_ooc<`3ooo<V@04oonI
VOooc9WooiVIolbIV@;ooiVI0oooc9T3ooo<IP;ooiUV1?o<VFH01?ooVFKo
c9UVooo<I_ooc6H4ooo<V@;ooiUV00?oc9UVooo<c?ooool0oooooooooooo
odGooooo0002ooooo`06olc<c?mgMgOogMgMolc<c?nk^k_oIVHc1?ooc9T8
ooo<c0WoolbI00Soolc<ooo<VOooc9WoolbIoonIVOooc9WooiUVolbIIP?o
oiUV1?ooc6H4oonIIPGoc9UV0_ooVFH01OooVIWooiUVoonII_ooVFKoc<c<
00;ok^k^00?oooooonk^k_o^k^h0ooo^k^koonk^kT7ok^k^0002ooooo`07
olc<c?n8R8Soooooonk^k_nk^k_oIVHcooo<c006ooo<V@Woolc<0oooc9T0
0oooVIWoolbIooo<V@05ooo<V@;ooiVI00?oolbIoonII_ooVFH00oo<VFH3
oonIIP;oolaV0oooVFH4olbIIPCooiUV00Coolc<ooooooo^k^kooooooooV
i^KoonKViT?oi^KV00001?ooooook^k^olc<c?n8R8P2onk^kP03omgMgOmE
EEGoolc<00Goolc<00?oolbIooo<c?ooc9T02_ooc<`6ooo<V@05oonIVOoo
c9WoolbIooo<VOooVIT00oooc9T2oonIIPCoc9UV1OooVFH00oo<VFKooiUV
oonIIP02oonIIP03olc<VOooVFKoolc<00?oooooooo^k^koonk^kT?ok^k^
0002ooooo`03olc<c?mgMgOogMgM00;oc<c<00?o<c<cooo<c?ooc<`05?oo
c<`4ooo<V@05oonIVOooc9WoolbIooo<VOooVIT01?ooc9T01?ooc6KooiUV
oonII_ooVFH5olbIIP?ooiUV00GoolaVoonII_ooc9WooiUVooo<c03ooooo
ooooooooA_ooool000;ooooo00Koc<c<ohR8R?o^k^kogMgMolc<c?lc<c<H
ooo<c0CoolbI00CooiVIolbIVOooVIWoc9UV0_ooVFH3ooo<V@;oolaV0ooo
VFH5olbIIP;ooiUV00?ooiVIoonII_ooc<`00oooooooonk^k_ook^k^@oo^
k^h000;ooooo00Koc<c<ohR8R?ooooook^k^omgMgOm4A4@Dooo<c0;oolbI
0_ooc<`8ooo<V@?ooiUV0oo<VFH01oooVFKoolaVooo<I_ooc6KooiUVolbI
I_ooVFH00oo<VFH2oonIV@03oonII_ooc<cooooo00;ooooooooVi^KoonKV
iT?oi^KV0002ooooo`06olc<c?n8R8Sok^k^onk^k_oMgMgoA4A45oooc<`0
1?ooc9Woc<bIooo<VOooVIT8ooo<V@03oonII_o<VFKoc9UV00;oc9UV00?o
oiUVolbII_ooc6H00oooc6H01_ooVFKoolaVoonIVOo<VIWooiUVooo<c0?o
oooo9oo^k^h00ooLg=cok>c/onk^kP02on?Sh`?ok^k^00?oeMGEonc/k?o^
k^h01_o^k^h00ooLg=cogmoOonk^kP0Bonk^kP03omCDe?o2`/;ohn?S0?oo
k^k^l_o^k^h000;ooooo00?oc<c<ogMgMoo^k^h00_o<c<`00om4A4Coolc<
ooo<c00Fooo<c003ooo<VOo<c9WoolbI00;oolbI00?ooiVIooo<VOooVIT0
1_ooc9T00oooc6Koc9UVolbIIP05olbIIP06ooo<I_ooc9WooiVIooo<VOoo
VFKoolbI1oooool00om>CTkoM7Adooooo`04ooooo`05obl_;omOGeoooooo
od10@?moOgl00_ooool01_nSXj?o71`Loooooooooooo@410ogmoO`;ooooo
00Ko@410ogmoOoooooooooooogYjN_m3@d<2ooooo`0BokBd]?l92@Wooooo
oooooomADE7o20P8oaXJ6_nLW9co4a<CoeMGEooooooodm?CobDU9OlN7Qko
^[Zjoooooom0@43oOgmo0_ooool01_oKfm_o=CDeo`h>3_l<30co>CTiomcL
g0;ooooo00Ko@410ogmoOooooooooooooj>SXolL71`7ooooo`0:oijNW_lD
51Co3`l?oc8b<_lE5AGo820Pol[:b_oooooo=3@dogIfMP;ooooo00?o=SHf
ogAdM?ooool0oooooooXooooo`000_ooool01_o<c<coR8R8oooooooMgMgo
c<c<oeEEEA[oolc<1?ooc9T01OooVIWoc<bIolbII_o<VFKoc9VI00KoolbI
00?oolaVoonII_o<VFH01?o<VFH01?ooVFKooiVIoonII_ooc9T3ooooo`Co
k^k^00?oZ:RXoa<C4ooXj>P00oo^k^h01_nm_Kgo0000okJf]_o^k^ko>c/k
ogIfMP;ok^k^00KoV9RHoaXJ6_o^k^kok^k^oc/k>omfMWH2onk^kP06oc/k
>omfMWKok^k^onk^k_maLG7o?Shn0_o^k^h02OnXZ:So20P8onk^k_nh^;So
0`<3olk>c_oFe]KoE5ADo`l?3`02onk^kP03ofUYJOll?3cokNg]00;ok^k^
00Ko>c/kogIfM_o^k^kokNg]oc0`<?m<C4`2omkNgP06odm?Cola<C7okNg]
onk^k_lk>c_oMWIf0_o^k^h00onHV9So6QXJonk^kP05onk^kP03ohb<S?l3
0`?oRXZ:00;ok^k^00Koh>3Po`000?n][Jgok^k^oc0`<?m^KVh2onk^kP03
oc8b<_m/K6cok^k^0?ook^k^j?o^k^h000;ooooo00Koc<c<ohR8R?oooooo
k^k^omgMgOmVIVHLooo<c0GoolbI00SooiVIolc<VOooVFKoc9UVoonII_oo
c6KooiVIooo<IP;oolbI00Woc<bIooo<I_o<VFKoc9UVoonII_ooVIWoolbI
oonIVOo<c9T00oooool4onKViP03on?SholI6AWoIVIV00?oRXZ:00Ko@D51
ob@T9?oVi^Koi^KVocTi>OmbLW82onKViP06oi>CTolI6AWoi^KVonKVi_li
>CWoLW9b0_oVi^H01_li>CWoLW9bonKVi_oVi^KoKVi^oc`l?0;oi^KV00Wo
XZ:Ro`P82?oVi^Ko`l?3o`820_nZZZ[oi^KVohn?SolL71`00_oVi^H00om5
ADGoIVIVonKViP02onKViP06ocTi>OmbLW;oi^KVol;2`_l0003oYJFU0_oV
i^H01_nUYJGo0000olK6a_oVi^Ko>CTiog9bLP;oi^KV00?oTi>CoaTI6OoV
i^H01?oVi^H00ooOgmoo4Q8BoeeMG@03onKViP06omWIfOl0003oYjNWonKV
i_l^;RkoJVYZ0_oVi^H00ol`<33oJ6QXonKViP3oonKVi^Soi^KV0002oooo
o`03olc<c?mgMgOok^k^00;ogMgM00?oR8R8olbIVOooc<`05_ooc<`2ooo<
V@03olc<VOooc9WoolbI00OoolbI00?ooiVIolbIVOo<VFH01?o<VFH00ooo
c6Koc<bIooo<V@03ooo<V@03oonIVOooc9WooiVI00;ooooo1_o^k^h01omf
MWKo3Ph>of5QHOmQHF7oEUIFo`000?n1PH400_o^k^h01_lk>c_oMWIfonk^
k_o^k^koV9RHoaXJ6P;ok^k^00Ko>c/kogIfM_o^k^kok^k^oc/k>omfMWH2
onk^kP06og5aLOln?Skok^k^onk^k_nXZ:So20P80_o^k^h01OnQXJ7o;Rh^
obl_;olb<S;o7AdM00;ok^k^00?oAdM7ofYZJ_o^k^h00_o^k^h01_lk>c_o
MWIfonk^k_na/K7o0000omKFeP;ok^k^00Koe=CDo`000?nd];Cok^k^oc/k
>omfMWH2onk^kP03oiRHV?lJ6Q[ok^k^00Cok^k^00?oaLG5o`000?nf][H0
0oo^k^h01_oPh>3o0000ojf][Oo^k^ko<30`ofi^KP;ok^k^00?o<S8bofa/
K?o^k^h0ooo^k^kXonk^kP000_ooool01Oo<c<coR8R8omgMgOoMgMgo^k^k
00;oR8R81Oooc<`00oo^k^koolc<ooo<c00Aooo<c0koolbI00?oolaVoonI
I_o<VFH01?o<VFH2ooo<V@03oonIVOooc9WoolbI00;ooooo00?ok^k^oooo
ooooool00oooool01ooQhN7o0`<3omgMgOooooooWIfMo`D51OoZj^X00_oo
ool01_m0@43oGEeMooooooooooooWIfMoadM7@;ooooo00Ko@410ogmoOooo
oooooooood10@?m]KFd2ooooo`06ogUiNOlc<c?oo_knoooooonc/k?o2@T9
1?ooool00oomoOgoU9BDob4Q8@02ooooo`03ode=COmbLW;ooooo00;ooooo
00Ko@410ogmoOooooooog=cLo`000?nd];@2ooooo`06ok:b/_l0003oh>3P
oooooom0@43oGEeM0_ooool00onMWIgo7AdMooooo`04ooooo`03ok>c/ol0
003oh^;R00Cooooo00GolO7aooclo?oooooo=3@dogIfMP02ooooo`05ocHf
=_lN7QkoA4A4odA4A?mSHf<0oooooooVooooo`000_ooool01oo<c<coR8R8
onk^k_o^k^koc<c<oiVIVOnIIVH01oooc<`00oo^k^koolc<onk^kP0Aooo<
c0KoolbI00?oc<bIolbIVOooVIT01oooc9T4olbIIPCoolbI0_ooool7onk^
kP05odE5AOm`L73ok^k^oc@d=?m=CDd00oo^k^h01_lk>c_o4Q8Bofi^K_o?
clooDE5AodM7A`;ok^k^00ko>c/kogIfM_o^k^kok^k^oc/k>olC4a?oPX:2
omSHf?lj>S[o71`LoeUIFOoBd];oJFUYobl_;`;ok^k^00koZ:RXol_;boo[
jn_oFUYJodi>C_o^k^koj>SXodA4A?mUIFGohn?Son[Zj_o^k^ko>c/kogIf
MP;ok^k^00Ko?3`lod=3@oo?clooc/k>od92@_lo?cl2onk^kP06oc/k>olB
4Q;oKVi^olo?comADE7oAdM71Oo^k^h00onh^;So0000olC4a007onk^kP06
oc0`<?m^KVkok^k^onk^k_lb<S;oDE5A0_nc/k<00onl_;cok^k^onk^kP3o
onk^k^Cok^k^0002ooooo`08olc<c?n8R8Soooooonk^k_oMgMgo^k^kofIV
I_o^k^h<ooo<c003onk^k_ooc<coolc<00goolc<1Oooc9T00oo<c9Woc9VI
olc<V@02oonIIPOoolbI00Goc<bIooo<VOooc9WoolbIoonIV@02onk^kP03
oooooooVi^Koi^KV00Coi^KV00GoWIfMoaDE5Oni^KWo0000ojFUY@03onKV
iP06od];BomnOWkoKFe]oa8B4_lY:BWo/;2`0_oVi^H03_m;Bd_oOgmoonKV
i_oVi^KoBd];ogemOOmUIFGo3Ph>ob@T9?o0`<3oRXZ:oaLG5olL71coW9bL
0_oVi^H03_mlO7co;Bd]o`h>3_lc<c?o/;2`onKVi_mbLW;o1`L7o`X:2_lH
61SoW9bLonKVi_m;Bd_oOgmo0_oVi^H01_oAdM7oBDU9o`d=3Ol=3@goBd];
om;BdP;oi^KV00KoBd];oginO_m]KFgo4Q8BobTY:On`/;05onKViP03omGE
eOl0003oSHf=00Ooi^KV00Ko;Rh^ofYZJ_oVi^Koi^KVoc0`<?mXJ6SoonKV
i^Woi^KV0002ooooo`04olc<c?mgMgOok^k^omgMg@;oc<c<00GoIVHconk^
k_ooc<coolc<onk^kP03ooo<c005onk^k_ooc<cok^k^ooo<c?o^k^h00_oo
c<`01?o^k^koolc<ooo<c?o^k^h7ooo<c0_oolbI00?ooiVIolc<VOo<c9T0
1?o<VFH2olc<V@GoolbI00CooiVIonk^k_oooooooooo1_o^k^h01OoZj^[o
5QHFobHV9_lK6a_okNg]00Kok^k^00?okNg]onk^k_o^k^h02Oo^k^h00oo]
kNgok^k^onk^kP02onk^kP03ong]kOo^k^kok^k^00?ok^k^00?ok>c/onk^
k_o^k^h00_o^k^h00om7AdOoJVYZonk^kP08onk^kP;okNg]1oo^k^h00oo]
kNgok^k^onk^kP06onk^kP03oeaLG?lQ8B7og=cL00Kok^k^00Ko<30`ofi^
K_o^k^kok^k^oc8b<_m/K6coonk^k^Wok^k^0002ooooo`09olc<c?n8R8So
k^k^omgMgOo<c<co^k^kodA4A?ooc<cok^k^00?oolc<00?ok^k^ooo<c?oo
c<`00_o^k^h2ooo<c004onk^k_ooc<coolc<onk^kP[oolc<00?oolbIolc<
VOooc9T02_ooc9T00oooVIWoc<bIolbIV@05olbIIPCoolbI00?ogMgMoooo
ooooool01oooool00omjNW[o0000oginOP0<ooooo`03oe]KFonBTY;ooooo
01Cooooo00?oh>3PomkNg_ooool00_ooool00omKFe_oTY:Booooo`0Eoooo
o`0;on_[jom1@D7o7QhNog]kNonGUiOoMGEeoc4a<Onn_[kooooooc@d=?mf
MWH00_ooool00olf=SKo;Rh^ofEUI@02ofEUI@03okRh^?oooooooooo0?oo
oooohoooool000;ooooo00Soc<c<ohR8R?ooooook^k^omgMgOo<c<coA4A4
onk^kPKoolc<1?o^k^h01?ooc<cok^k^onk^k_o^k^h=ooo<c0koolbI00[o
oiVIolc<VOo<VIWoc9UVolbIVOooc9WooiVIooo<VOooVIWogMgM0_ooool7
onk^kP03omOGeon?Shoof=SH00cok^k^00?oZ:RXokno_oo^k^h06Oo^k^h0
0onXZ:So_knoonk^kP0Fonk^kP0:ong]kOnUYJGoMWIfof9RH_n1PH7oXj>S
on3Ph?o^k^koXj>Sok^k^`;ok^k^00?oY:BTohn?Son?Shl00_n?Shl00oo3
`l?ok^k^onk^kP3oonk^k^?ok^k^0002ooooo`03olc<c?n8R8Sooooo00;o
k^k^00CogMgModA4A?o^k^kok^k^1_ooc<`7onk^kPkoolc<2?ooc9T01?o<
c9Woc9UVolbIVOo<VIT7ooo<V@04oonIVOooc9WoolbIooo<c0;ooooooooV
i^KoonKViT?oi^KV0002ooooo`03olc<c?n8R8Sok^k^00;ogMgM00?oc<c<
oeEEEOoMgMd01_o^k^h2ooo<c003onk^k_ooc<coolc<00Koolc<00?ok^k^
ooo<c?ooc<`01Oooc<`=ooo<V@04olc<VOo<VIWoc9UVolbIIP;oc9VI1ooo
c9T2ooooooook^k^ooo^k^i3onk^kP000_ooool02?o<c<coR8R8onk^k_o^
k^kogMgMolc<c?mEEEGo^k^k2_o^k^h2ooo<c004onk^k_ooc<coolc<onk^
kP_oolc<0_ooc9T00oo<c9WoolbIooo<V@08ooo<V@;oc<bI00Coc9VIolbI
I_o<VFKoc9UV1Oooc9WoooooooooooooAOooool000;ooooo00So^k^kohR8
R?ooooooooooonk^k_oMgMgoR8R8oiVIV@?ok^k^00?ogMgMonk^k_o^k^h0
1_o^k^h00oooc<cok^k^ooo<c00>ooo<c0ooolbI00?oc<bIolbIVOooVIT0
1?ooc9T2ooooooook^k^ooo^k^i3onk^kP000_ooool02?o<c<coR8R8oooo
ooooooook^k^omgMgOnZZZ[oVIVI4?o^k^h>ooo<c0OoolbI1?o<c9T7ooo<
V@03olc<VOooc9WoolbI00;ooooooooVi^KoonKViT?oi^KV0002ooooo`05
olc<c?n8R8Sok^k^onk^k_oMgMd00_o<c<`00omEEEGoooooonk^kP0@onk^
kPSoolc<3_ooc9T01?o<VIWoc<bIolc<VOo<c9T2olbIV@GoolbI00?ok^k^
ooooooo^k^h0ooo^k^koonk^kT;ok^k^0002ooooo`05olc<c?n8R8Sok^k^
onk^k_oMgMd00_o<c<`00olR8R;ogMgMooooo`04onk^kP;ooooo2?o^k^h<
ooo<c0;oolbI00?oc<bIooo<VOooc9T02_ooc9T3olc<V@GoolbI00?ok^k^
ooooooooool0oooooooooooood;ooooo0002ooooo`04ok^k^on8R8Sooooo
ooooo`;ok^k^00Goc<c<ojZZZ_lc<c?oc<c<ooooo`06onk^kP03ooooooo^
k^kok^k^00Kok^k^3?ooc<`4ooo<V@04olc<VOooc9Woc<bIolc<V@goolbI
00?ogMgMooooooo^k^h0ooo^k^koonk^kT;ok^k^0002ooooo`03olc<c?n8
R8Sooooo00;ooooo0_o^k^h01ooMgMgoc<c<oeEEEOlc<c?oIVIVohR8R?o^
k^h00oooool9onk^kPcoolc<2Oooc9T2olc<V@03olbIVOooc9WoolbI00Oo
olbI00?ogMgMoooooooVi^H0oooVi^KoonKViT;oi^KV0002ooooo`04olc<
c?n8R8Sok^k^onk^kPOogMgM00Ooc<c<oiVIVOmVIVKoA4A4ofIVI_nIVIWo
gMgM00Sok^k^00?oolc<onk^k_o^k^h01?ooc<`01Oo<c<coolc<ooo<c?oo
c9Woc<bI00?oolbI00?oc<bIooo<VOooc9T01?ooc9T3olc<V@03ooo<VOo<
c9Woc<bI00?oolbI00?oc<bIooo<VOooc<`0ooo^k^koonk^kTCok^k^0000
1Oooooook^k^omgMgOmgMgOooooo00;ok^k^00?ogMgMolc<c?o<c<`00_nk
^k/03?o<c<cogMgMomgMgOoMgMgoolc<olc<c?nZZZ[oMgMgodA4A?mEEEGo
VIVIolc<c0Gok^k^0_ooc<`00oo^k^koolc<ooo<c006ooo<c0goolbI00[o
c<bIooo<VOooc9WoolbIolc<VOooc9Woc<bIoonIVOooc<cok^k^oooooooo
oooood?ooooo0003ooooo`04oeEEEOo^k^koooooooooo`;ok^k^0_oMgMd2
olc<c003ok^k^oo<c<coc<c<00?oc<c<0_oMgMd02oo<c<coZZZZogMgMom4
A4CoEEEEogMgMonk^k_oolc<onk^k_ooc<coc<c<00[oolc<1?ooc9T2olc<
V@03ooo<VOo<c9Woc<bI00SoolbI00?oc<bIooo<VOooc<`0ooo^k^koonk^
kTCok^k^0003ooooo`03ojZZZ_mgMgOooooo00?ooooo0_o^k^h3omgMg@;o
c<c<1Onk^k/00oo<c<cogMgMomgMg@02omgMg@06ok^k^omgMgOoA4A4odA4
A?mgMgOoc9VI1?ooc<`00oooc9Woolc<ooo<c005ooo<c0Coc<bI00CoolbI
olc<VOooc9WoolbI0oo<c9T2ooo<V@06olc<VOooc9Woc<bIooo<VOooc<co
k^k^oooVi^KoonKViT?oi^KV0004ooooo`04ogMgMonZZZ[ok^k^onk^kPCo
gMgM0oo^k^h4omgMg@;oc<c<1?nk^k/3olc<c0;ogMgM00OoZZZZohR8R?mE
EEGoA4A4oeEEEOn8R8Soc<c<00?oolc<0_ooc9T00oo<c9WoolbIooo<V@06
ooo<V@;oc<bI0_ooc9T00oo<c9WoolbIooo<V@04ooo<VOook^k^ooo^k^i4
onk^kP001?ooool00ooMgMgoEEEEooooo`02onk^kP03omgMgOo<c<coc<c<
00;oc<c<0_oMgMd2onk^kPGogMgM2Oo<c<`2omgMg@09olc<c?nIVIWoIVIV
ofHc<omVIS?oVFIVolc<VOooc9Woolc<00KoolbI00?oc<bIooo<VOooc9T0
0oooc9T2olc<V@GoolbI00?ok^k^ooooooooool0oooooooooooood7ooooo
00000oooooook^k^onk^kP02ooooo`04odA4A?ooooooooooooooo`;ok^k^
0_oMgMd6olc<c0;ogMgM0_o^k^h4omgMg@Woc<c<0_oMgMd00oo<c<coZZZZ
ofIVIP02ofIV<`06oiVII_o<VIWoc<bIooo<VOo<c9Woc9VI0oooc9T00oo<
c9WoolbIooo<V@07ooo<V@03omgMgOo^k^kok^k^0?ook^k^ooo^k^i1onk^
kP000oooool00oo^k^koooooofIVIP02onk^kP;ooooo00Cok^k^ooooooo^
k^kok^k^1?oMgMd5olc<c0?ogMgM1?o^k^h2omgMg@Soc<c<0ooMgMd01onk
^k_oMgMgofHc<om4A4CoIVIVolbII_o<c9T00oooc9T00oo<c9WoolbIooo<
V@02ooo<V@05ooo<c?o<c9WoolbIooo<VOoMgMd0oooVi^KoonKViT?oi^KV
0003ooooo`05onk^k_ooooooVIVIoiVIVOooool01Oo^k^h3ooooo`?ok^k^
0ooMgMd4olc<c0;ogMgM00?ok^k^ooooooo^k^h00oo^k^h3omgMg@Ooc<c<
0ooMgMd01_nk^k_oR8R8oeEEEOmV<c?oEEEEoiVIIP?oc<bI1_ooc9T00ooo
c<cok^k^onk^kP3oonk^k_ook^k^@Oo^k^h000Gooooo00KogMgMoeEEEOo^
k^kok^k^ooooooo^k^h3omgMg@05onk^k_oMgMgok^k^onk^k_ooool01?o^
k^h3omgMg@06olc<c?n8R8SoEEEEohR8R?o<c<cok^k^1?ooool2onk^kP03
omgMgOo^k^kogMgM00Coc<c<00Co^k^kolc<c?o<c<coc<c<0_oMgMd01onk
^k_oVIVIoeEEEOmV<c?oIVHcoiVII_o<VIT01?ooc9T00oo<c<cooooooooo
o`3ooooooooooooo@Oooool000Kooooo00Goc<c<odA4A?nIVIWoc<c<onk^
kP02ooooo`;ok^k^1OoMgMd4onk^kP0<ooooooo^k^kok^k^onk^k_oooooo
gMgMoiVIVOmgMgOoEEEEohR8R?nk^k_ogMgM0_ooool3onk^kP03omgMgOo^
k^kogMgM00Coc<c<0onk^k/5olc<c007oiVIVOnIVFKoIVIVofHc<onIIVKo
c9VIooo<c03oonk^k_ook^k^@oo^k^h000?ooooo00?ok^k^ooooooo^k^h0
0_ooool01ooMgMgo^k^kohR8R?mgMgOoR8R8ojZZZ_oMgMd00_ooool2onk^
kPKogMgM0oo^k^h2ooooo`0:onk^k_ooooooooooomgMgOnk^k_oR8R8ofIV
I_mgMgOoZZZZomgMg@Ook^k^0oo<c<`4ok^k^`05olc<c?nk^k_oc<c<onk^
k_ooool00_o^k^h00ooMgMgoooooonKViP3oonKVi_ooi^KV@_oVi^H000;o
oooo00?ok^k^ooooooo^k^h01?ooool01_o^k^koooooooooooooooooc<c<
oiVIV@;oMgMg00CoZZZZomgMgOoooooooooo0_o^k^h3omgMg@03onk^k_oo
oooooooo00Sooooo00Ook^k^ok^k^on8R8SoIVIVogMgMonIVIWoc<c<00Co
k^k^00GogMgMonk^k_oMgMgogMgMolc<c004ok^k^`Koooooooo^k^koonk^
kT?ok^k^0006ooooo`03onk^k_oooooooooo00Cooooo00Kok^k^oooooooo
ooooooooomgMgOnIVIT2ogMgM`03oiVIVOo<c<cok^k^00?ok^k^3_ooool0
0oo^k^koc<c<oiVIV@02ofIVIP04ohR8R?nk^k_ogMgMomgMg@?ok^k^00Co
gMgMolc<c?o<c<coc<c<ooooooooooooodWooooo00001Oo^k^kooooooooo
ooooooook^k^013ooooo00GogMgMok^k^on8R8So^k^konk^kP0Dooooo`07
omgMgOnIVIWoMgMgoeEEEOmgMgOoZZZZolc<c002onk^kP;ogMgM0_o^k^h3
ooooooook^k^ooo^k^i4onk^kP000oooool00oo^k^koooooooooo`0]oooo
o`05ok^k^on8R8SoIVIVofIVI_nk^k/01oooooooonKVi_ooi^KV@ooVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^I<onKV
iP0XojNmd_nY_<[o/L33okBXZ?nSIVkoZEEUojQFK?nBFFco[j:[ojfk^onc
a/;oUJZSogZ;QOm=G5WoAU=IoeQSIomKI5ooA4]3od95??li?3?o@D<hodi@
AOm6AcooD559oeYME_ln@C[o>C`cod53>?m:B3_oDT`loeQA?_mUGT_oGEa:
of1QDOmVJ5[oGf5Cod95>_lg?C7o@dQ1oca3>`;o?TDn04_o?4<kocm6?_m4
BD;o@4Dnod95??m=CSkoHU]1og=ZBombJe7oQ7m[oifKS?nUYicoG65Jod1:
@_lb?3Co<chfoc@o=olc?SKo>D0iocm6?om3B4CoB4Hjof1?=OmSCRooHU0h
ofIKBOmZIU_oJFYTog5cL?n0QH7oTY>;ojNXV_nl^Z?oc/V[omkI/OoUg[3o
i=ZWomkGZOoBdk?odMFloogok?oio^[okOCRom_Qdonla;WoXZVRohVBSom8
D5;o?TI9obT`>?lV;COo=3Y6oc<iAola>T_o=4IJocM@I_ljDfWo>UMYod1O
LOm8JWKoH8F>ohBWZonXb/_o^]WColgTg?oHj]cog^_JomgUd?oLgl[oiN76
on[I^oocg;[ol]bgoo;L]OoghKX00_ohhkP00oolik[oi^KVonKViP2konKV
iP00ooo^k^i<onk^kP0Xok35f?n``m7o/;o2okNc]?nkTYSo]GV3oiMJJ_n>
HW7o]J^cok;0`?n]`l3oRZ>OogB8Q_m4E5?o?de@oe5LG_mAFUGo@DQ0od56
?olm@3OoA4Lnoe9CBom8BD7oCE19od=6?olk?SOo@TDnod=5>_m2@3CoBTLf
oeYC@OmYI53oHV5?oeMHB?mNH5;oD595ocXm<_lm@cOo@DHood99@@;o?dHo
03Oo?TDmocm6?_m2Ad3o?D8kod13>_m:BcgoGePnog=ZBomlME_oVYF1ojj/
WOnVZ9goCE9;oce4?Ole?cOo<Sdeoc<n=_li@c_o?dHood15?om1AT;oADDk
oe9:=OmJCSKoHe]6og=/F_miLfOoKf]PofeYH?mjLfWoNG5TohIoK?nARg?o
VYEhokFbTOoBdZcoemVbom?J^?n`_JWoYkNZokO9_Onib/3od>7Gon?dk?o^
ooWomOooom?QhOm:F5So92laob/f>?l/=C[o8BX_oa/T:OlU;cSo8C4n00;o
7cE301;o7cU6ob8nB_lP?TSo8D99oba;C_lhEUKoAEmLodiUGomJJf7oKg]_
ohN=OonQYIKo^[VUomC>]_oQekcoj=k3on_RaOo^iLH2onkS``03ooCZaoo^
k^kok^k^0;_ok^k^003oooooodcooooo07So]<KDokG7don``lWo]L32ol?1
`_n/X:;oLEiRog]/LOnSXjGo/l72ojFo`?mlVY[oJ8:3ocI;C?lhB4SoBeMG
od=>B_li@c_o?TDmocXo>?m3ASooCe9;odA7@?m2Ad7o?D8locXo>Om1AT3o
@TDlodQ8?_mLFT_oIf5Aof]VDomWIUCoD551oeIHB_m4ASWo>C`aodE;?olo
A3go@TU1od17?om2BD7o@4Loocm6?_loA3go>Slhoce0=om8BC_oHUa2ofmX
Bon2O6CoVYR3okJgYon=T8Go@DLmocm6?_loBD3o>dDloca6?Om2C4?oATe5
od56?om0@Sgo@4DoodI@AOm5D4;oEE]=ogEfJ?n@RGWoS7m^ohA_F_n5KEGo
U7YQoiV4JOnKRg7oRXAZoiFJQ?n/_J[oZ<6^oijo]_nI`<GoTkk7oi>kaOn>
][koVL37oiVna?nK_KooW[fooi6][_lmEU?o=Da6obi1>olM;RKo830VobDb
:?lL:B3o8c8_oah^;_lM;2oo7C4boahc=_lP>3[o83Tmoa`f=olN=SSo:d11
ocA6A_lkBDWoAE1<odiDD?mHGEOoHVURoeISG?mJJf?oIGA]ogZ:P?nKZ9ko
]L6eolOAa_oDg<nmooooo`00ooo^k^i<onk^kP1hok;3cOnda]3o/l[Bojc8
bon_cL_oTJZVodiHEomOHf;oQHf?ok70`onP_L7oL96Foe]hO_laBDgo?4a<
odQDD_llAd?o=d8loca3??lg?SKo?T<lodY=A_m1AT3o?T<mod98A?li?c_o
?D8nocm4?Om@DTOoIfQJof]XEomVHe;oI69Codi@@_m@DTGoATPkod54>Om9
C47o?T<loca3>om0Acoo@dY2od99@OloASko?T<locTn=oll?cKoATLiof9L
A?m]IT[oQH5XoiFBOonk_:koJ6]Pod57?Om1B43o@dY2od5;@?m3CD;oAdm4
odM=@om5B47oA4Dood97@OloBdOo=dHood5;@_mRIUSoOga[ohIjI?n3KeKo
Qg1AoiAmG_nORVgoZYb2oiZHPonKYYSoZKjgoi^i^OnC^l?oSKgAohc2f_n>
`]SoSL3Cohnnc_nA_L[oUKg7ohba]omSPXGo;DY8obm6@?lV>S7o7RhSobDc
9?lZ=bKo9c8Tobhf:olW<BSo9S4Yob<`:OlK:ROo830_obPh=olS=CGo7B`_
obDd=ol[>Cco<3/mocQ2A?lk@dGo@4E8od==C_m;Gf3o@UaKocaDE?m0FEKo
EF]YofAjMom^PGgoM8N3_Oo^k^h00?ooi^KVC?oVi^H0J_neb<oo/<O?ok;@
f_nTcM?oU<_8ogja[?m:If?oDf=RohJAToniblooUkS1ofZ?V?mIMH3o?E5H
odABDom3CT[o?DQ2oc]6@?lmA3go>D0ioci3??m8CDKoAda6odE:A?loAD7o
=Chioca2?_loA3koAdQ0oeEEBOmLFD[oGei<oeUJC?m@DTGoBT`oodU=?om8
Bd3oATTnod56?olj?cSo?TDmod=:@_m3B47o@4Dnoci3??lj?cSo?3lhodE5
>OmFDC_oLF]AohN2K?nUY9;o]KJXoe=FBom6C4;o@4Looca4>Om4C47oAdm2
od98??m1A3WoATLoodU9@Om8Ad;oATM2odE7@_m8BD7oDUA7oeYMC?mKGDOo
IVA;ogMfF?mcLUCoOWeQoi2BOOnKWi7oZ[FaokO6bon``m7o[lcNoik<honE
bn?oU<SNoi;5f_n:^L_oT[c<ohjb`?m`TI[oCVY^obm4Aol/?3_o9c<_oc0j
<_l_=2go<3<Zoc/m<_lj?2oo>3X/oc/o<Olh?S;o;cH^oc4k<olf?cco<CXi
oc<m?_le?d42oc<m?`07ocU3AOlkADOo?4A7ocm9B_llBT[o@U9Aod5DDP02
od1CC`03od1CCOm3EdkoBemF0;goi^KV003oonk^kTcok^k^07So]/gCoj_6
cOn[d=WoX]?JoiC@dOnBb<SoMiFGogN9RonU/[So`MGLohJ[]?mbV:?oIX2=
odeNJ?m:EEOo?4M3oci7@_llASko>d8koc]0>OloA3goAda5odaABom=DTco
@DM3ocLm>Olm@coo?d@nod93>om9BCgoD4dnoeMEA_mBDdGoCe54odA8>_m7
BcgoB4]0od95??m1Acgo?44joc]2>_m0Acoo@DHoocm4?Oln@cco>d0ioc`o
>?m2A3OoCddhogUdG_n5PVoo^;JWoi>CQom?DTWoBTe6odI;A?m0B3goBe55
od]A@om2ASSo?ClbodA4>_m:AckoB4@koeI?AomGD4SoD4i2odY<?om9CCko
B54noeAMB_mWL5_oMWmZogIoK?mjQGOoU9nGok6m_OnlbM7o_L[JokW@h_n`
e^WoXm;TojGChon/e^KoYL_Hoj73comgTikoAEiUob/nA?leA4Oo?TQ:oc0f
=_lm?cko?Cdkoc/j=_m5@S_o?C/_ocTg:_lh>2co>SX`ocXk<oln?cWo?T0k
oc`n>olc=cKo=c/locHl??lh@D3o@4U6od1;AolmB4Co?TU5ocU4@?m0C4So
AE9;odMDCOm:EdkoB5Q>odUICom@H5Fmonk^kP00oooooom<ooooo`0Nok3?
e?nWb]3oX/kGojKFh?nSd]co[M7Moj^ia_n_]lCo^/SCokC?f_m`UZ7oQjfh
ogfCXOmGHfooB4mEocm8AOlnA43o>d8jocPo=oll@SSo@TDlodE8?om<CdSo
CU==odI;AOlj?cWo?44kocm4?Om8BSooDU=50_mDDD002Om@DTGoBTe2odI9
?_m4AccoATU0odA7?_lk@COo?dDkocTn=`02ocm4?@0goce2>oln@cco>d0i
oc/n=oln@3GoDU4mog]iI?n=S7[o^kb^ofe_I?m@Dd[oC4m8odaAB_m:D4Ko
CE=7oda@@_m3ACOo@44codE3=om7ACWoB48foeQ??_mIDCkoD4XjodA5=om1
Acgo@de4odYEComBGeSoLWijogJ2O_mePGooVZJTok[8bOo1cm;ob=OLol3C
fOnof=go]mCHokC@e?njdmOo^m?GojZm`OmSLWGo?de>od5;COlf?T3o=c/n
ocDf>?m1@D?o?C/nochi?Om6@T7oBDQ3odA4?002od4n>@0>od=2?Om1@3co
@3lkodA3?om<CDSoC4e7odE8@OlnA3[o?dLjoce8>_lmBSWo@Ti0odEAAom7
DDT2od==A004odYDBom@F4goDUY?oeINDkgooooo003oonk^kTcok^k^02Wo
Z<gEojO?eonPcmWoY]CQojS<g?naamco^<3GolO=hongb]_oXKo:of26TOnK
`<WoSZ:]oeUSKOm2BE7oBDiAocm4?_lm@cWo>T0fod54>Om5Acco@dDjodY;
@om=D4Wo@4<locLl=Olo@S_o@D@kodU9?OmGEDKoFUA4oeIC@_mCEDSoAdXo
ode@AOm3AS_oATU0odQ;@_ld>S3o?T@jocLl=@02oce2>`17oca1>_ln@cco
>d0iocTl=Olk?C;oE593ogMfH_nNWhoo_;jaof5SF?mCETgoC55:odaBB?m7
CD?oATXlodA6>Om2A3KoAD<fodI4=om8A3WoBT@foeA>>?mNF4;oFEI3odU:
??m0@cco@4I4odQAD?mCFegoH6Q[og9lO_mhPX?oXjn_ol;@d?nodM7ob=cK
okgAd?o3emSoam_Jol7Cdoo2d]7oa]CDojFa/Om=EeKo@4U6oca2@?lg?C_o
?d=2oc/m??ll?Sgo?ClnodA6AOlo@D3o>SXhochn??lo?cgoA4<oodM6@_m0
?c_o@3`ioda9A?m5ACgoBd]1od]=@?m9CCcoB4lmodI?>_m5DCWoBeM3ocm:
??m6D4L00_m;DdP01?mAEdgoEE]AoeiQF?mYK66monk^kP00oooVi^I<onKV
iP0QojW?g?nWcm_oXloJojW?g?nfc>7o_L_UokW2gonibN?o[/[Oohnc`OmK
P8SoYlS=ojJo`omZNH3oFF1ZodM:Com5Ad;o?D0eoc/m<?m7Ac_oDe=7oe9B
A_m?CdGoE5A:odY;@olj?CCo@44iodA6>omBD4?oEeA3of1IAomBCC[oB4Xm
00;o@4Hl03So@DLmocm5>olnA3[o@4<joc/n=Olo@SWo@dHmocm2>om3ASoo
?D0iodA7@?lk@3[o?3lfoe5BA?mmOVkoZJVMokVk/?mMGUKoDeI?odiCC?m:
D4KoCE17odU=?om5Ac[o@T@fodI4=om:B3_oCd]0oe9>@_mCD3goEeI2oeEC
A?m7Ac_o?chiodA3@Om=BdcoDe5Dof=QH_maLG7oO81ook6l^?nmcL[oaM_H
ol;OfonofMSoa=WLolgOhoo1d=?oa]KFolKDe?n7UY?oAE5=oci9@oliA3co
=d<iocI2>0;o=d<g0_lf@SH06OlhA3[o=d0koc]1?olo@d;o@dE2od94@Om0
@Cco@T4modI5@?m7A3_oB4Plode>?_m?DSgoCe@nodaD??m9DSOoAU0hod9=
?oloBD3oCUE=oe5HD?mHGeOoEEaDofAYH_mWKF<0_OoVi^H00?ook^k^C?o^
k^h0L_nUbmkoYLcMojS@g?n]c]go/lSMokK7hOn`b>Co[lgYoj[>i?mcUjGo
JHR=okKDe?nVaL3oN92@ofM`NOmOGfOoA4I1od94=om6AcWo@d@foeECA_mC
DDCoFEM;oeUICOm;Bd?o?3deod12=om4A3SoD4i1oeQB@_mPFDKoEU4node?
@_m2B3ko?T@jod16??lnA3[o?48hoce0=olj?CCo?T4hod54>om0@cco@TDn
od13??m3ASoo?44kocXm=_mBE4OoPH=eokJh[Ond]jkoGf9KoeAGD?m>Ddco
CE9;odY=A?m5BC_o@D<focm1<om2@cGoBDLjodi:?om@C43oDe90oeIE@omC
DDCoBDHmod=0>om7@d3oCTQ8oe9<C?m]IfOoOWeiohf?R_nob<?o`mC>ol?L
e_nog]So^mWGol7IgOo8fn;oa=OMolGGfonhal[oJ7Qgoce<BOllBD;o=T<j
ocA1=old@SGo=D<focI4=Ole@cCo=DHfocU7>_ld@C[o=T4mocY3?_loAD7o
@4Dood53?_m4ACooAdQ0od];@Om<CCooCDhnode@?Om>DCcoCU<lodeC>Om;
DccoCE53odY=@P;oDeI=00CoFEaCoeQNE?mZKFCoKG=Y_Oo^k^h00?oooooo
C?ooool08_nYcNGoZLgSojgAhOn]c]go/LkPok3CionOcnGoPKG:ofZEZ?m9
JgOoFW=goiFb[OnUbl3oS:fVoeMTJ_m[Jg?oD5=<odi@@om@DD?oA48eoe]H
BOmKEd_oIVAHof9RE_m?CdOo?Slgod53>?m5ACWoDDm2oeUC@omSG4WoFUE2
oe1CB?m3BT82oce2>`0hoca1>_li?SOo>C`coc/n=Om6AcooA4DmodA7@?m0
@cco@dE0od94?om1AT3o?D8kode@AOn0Q7Ko`/FjojJYX?mMGe[oDEI@odaA
Bom<DD[oA4Lnod14=_ln@3?o?T0bodE5>Om<C43oDe17oeMCB?mFD4;oF594
oe9>@om7A3_o@SljodE2?Om9AD;oBdQ3ofERGOmnOGSoU9N@olK@b?o6eM3o
aM[Eol?NfOo0g=go`McUokkIi?o5gNOoaMcTojVn`om=Gf7o?4a<ocQ4@_ld
@3co<chhoc<n=_lf@3L2ocM1>00@ocU3>_lkAcgo=T<iocE2>?lf@cWo>THl
oce7??loAcco@DLmodI9?_m>D4GoC4i1oda>@?m=Cd7oCe53oe5D@`;oD5=2
00SoEU=4oeEB@omIEDWoEE55oeQFBOmKG4koK6iPogEiJ[gooooo003oonk^
kTcok^k^02?o[M7[ojc>ion_cnCoZ<_NojcEionXfN[oP/7BodF0T?lcFV_o
=e9ModMKG?mXPWWoW<Feoig3^?mCHVGoIfY_ofIYH_mLGU7oD514odI4=omG
EDSoGee@ofQVF_mVIUcoCe18oc`o=_lo@SWoADLloeABA_mHEDKoHea:oeIC
@_m>DDSo@dY3oca1>`02oca1>P0focLl=Olj?CCo@TDlodm@B?m7B43oA4M0
ocXm=_m1@cko?d4lod=8@_m2Ad3oBTe2oh23N?o9c<?oTYF>oeUNF_m@EE7o
BDi:odQ=A_m2ACco@D@iocm3=Om1@cKoA4Hiod];@OmADDOoEeE9oeMDAOmH
EDKoDdm3odU6?Om2?cSo@d0kodU4@?m=B4CoGEYEogYiM?nDUY7ob]7:olOF
dOo5f]Go`mgJol;Ngoo1g^Ko_=SSol7LiOo9h>SoW[>hodEGFoloCDko=3ho
ocDn?Olf?3[o=cdi0_lk@3`06olj?Sgo?3hmocY0??ljASco=dDhocM3=oli
ACWo?4Lioci6>OloAc[o@TPlodM=@Om9C47oBTe2odi@AOmADdSoDUA9oe1B
Aom?Cd?oEU96oeYDA_mGE4GoDTi2oe=AA?mHF4coJFUMogMiK02monk^kP00
oooVi^I<onKViP1coj[>i_nWbn?o[<kWojO@i_nLdN?oOK_:oenOZol[HFgo
<TaIocU7D?m0C4coDVMNohR/W_nD^:coEfMVoe9KF_m]LV_oHfIKod]=@_m7
Ac_oATHjoe9BB?mEED_oH65IodY?BOlg?3Ko>Chhod57?OmBE4WoE5E7oe]H
Aom>C3goADY3od1:@_lk@S_o>T4joca1>_li?SOo?T4hoda=AOm@DDWoADHn
od52??lf=c7o?CljocXl=om0ACoo@4Dnod]AAon5Rgoobm39ogn4O_mIGU[o
D5EAodM<B?m4BD?o@TM0od98??m0AS[o@4<hoci1=_m1@S[oA4DmodQ:?OmF
F4?oF5Y4oeEFA?m;C3koA44hod@o>om<A4;oDd]9ofING?n2OG[oVIVGolgC
dOo9f=Goa]cIol;OgOo1gmoo`MgQol?LhOo1f=kob]gSoi:QY?m8DeGo@DU;
ocDk>olj>cgo>c/mochl?om1?d;o@Cm4ocdj@Olm>3oo>CTkoca3>olh@cGo
=d8docU4=_llA3Oo?DDhocm7??m1BCko@d]0odA:@?m5Bd7oBTe4ode@BOm?
DT_oD55;odm@B?m>DDKoE5M<oe9DB@02odm@B003oe=DC_mPHE_oMWMa0;go
i^KV003oonk^kTcok^k^01GoYlgToj?9h?n[dngoZ=K^ohK3e_m;RYWoBGn;
odEZLolmAe7oBDUAoci7A_m=GUKoOYb@ogVGSOm1DTco@Da8of5XHOmNI5[o
BDa3odQ;@?lj>c<00_m4ACd03OmFFE;oBDm;oc<l=olh?S[o@TU2oe5DBomA
DdSoEUA7odQ8??ll@C[o?TM2oc]2>oli@3T00_m0ACh01_m5ASkoDU=;ode>
A_m4ACgo?SliocXk=@;o?Clj00_o?T<moci3??m?ED_oSYB:olW>aom`MFoo
EEUHod]?C_m2Ad?o?T<mocm4?@02od16?00Voci4>?ln@CSo?T4jod13??m2
AC[oDeE0oeIH@_mEEd;oC4lnod=3=om0@3SoAd@oodm:AomWHUooPgmnoiVK
V_o<eMCobm_KolWNhOo5hNGo`n3TolGNh_o<hNCob=_OolgLgonDWj7oCEMF
od57Aom0@T7o>c/kocdk??lo?CkoA3m3od@oAOlm>d3o>SLnocTg>_lk?CP2
ocPm=P04oc]1=oll@SSo?DDjocm7?0?o@TXo00[o@dToodA9@_m8BdCoC4m8
oe5BC?mBEDkoC598oe=ICom?E4goDEI?0_m@DTd00omHFUOoM7Iconk^kP2l
onk^kP00oooooom<ooooo`1PojKAi?nRcnCoY=?]oi[@k?mg]Lco>6n3oe9_
Oom[Lh3oF4aFoea?E_mADe;oDUiJofn0N_mML6[o<T4joca9@?m7DT[oC5I>
od58@?m1Acgo?3lhod=8@Om0ACooB4i:odA=B_la?3So=d0mocm8@om:DDWo
Ade3ode?@_m4AS_o=chgoci7@_lk@S_o>3lhodE:@om8CDKoBT]3oe=DC?m<
CDGoA4Dmoc/l=_lm?SSo?3hiod53?_ln@coo@4DoodaAB_nAUhgo`/O0ofEZ
I?m?De;oA4Q7oce3?olk@S_o>d8joc]3>?llA3Wo?DDjod56?om2Ad3o@TM1
odA5?OmBD47oEE8ooeED@_m>DD3oA4Piocm3=?loACOo@dTmoeeSFOmjOgSo
UI^Iol_Eeoo=f^;obmgYol_Nkoo9gngoc>3WolcNh_o@gn;odMoPojfg]_mN
If;o@DM3od=8@_lk?SOo>Sdfoc`o>?lo@S_o?d4locXo>Olh?CWo>S`i0_lj
>3T05_ll>S_o?Cdkocdo>_ll@C_o?TDnod99@OloBCko@D]0odA<@Om4C3oo
ATa0odU?@om?DTOoDeI;oe1CB_mFFE3oDEA=oeQKE?m@EDooBe1:odmEDOmb
N7Bmooooo`00ooo^k^i<onk^kP0]ojGFionReNSoVLgUohVoeomc[<3o?fao
oea_OOm`L7[oLfI]oeM;ComPHV7oEUmLod1:BOm0BdOo>TDoocE2>Old?c_o
>4<mocI0>?lf?CGo@TM0odaAB_m7C4Go?D@moce7?ol]=S7o<c`iocY3?_m1
B47o?D8lodI7@Olo@S_o=Sdfod58@Olk@S_o>3dfodY=A?m@Dd[oCDm4oe5C
B?m;C4Co@d@noc@g<?li>cKo=cTd00;o?T<o03goA4U3odM<AOnCV97o_L:l
of1UHOm<D4oo@DE4ocm3@_lnA43o?D8locY1>Olj@3Ko?T@jod=8@Om5BTCo
@TM3od52??mCCd?oEU=4oeMEA_mCE4CoC4lnodE9>?m1B3So@TPjoeeSEomk
PW[oUIjKolgGfOo=f^?obm_XolWLjoo6g>[ocN7/ol?Dg?o?g^?odn7RolSB
dOm^Mg;o@TU2od15?_li?cGo>3hdocTo=Olj@SOo>d<hocY1>Oli@3So?44k
ocXh>olm>3co?C/noclm?_lm?C_o>cdhoca1>om0Acoo?dLlod=;?_m7Cd;o
BU1200;oBDm100[oCU94oe5EAomBDd_oEeYCoe1CC?mIG5GoDEI@odU>B?m<
DdcoL7Yb_Oo^k^h00?ooi^KVC?oVi^H0F_nLeNSoX=O[oi[?hOn6]lSoL9j[
ofV>Uom[PXSoL7]oof9VJOmTI6CoLgEdoeaPGom4B4Oo?490od57AOlh@Cko
>dE6oc@n?Olh@Cco>3lhoc]1=omGFTooGF5Coc]1<olm@cGo=Cd`oc<j<_lh
?COo>S`ioc`l?_ll>Soo=SHhocDj=_m4BdCo>cheoc/m<_m;BcooEEE9oeYJ
C_m<CT7oA4Dmoc`o>?lh?CWo=c`hocHk=oll@3oo@TI5od56@_m8CdSoS9>;
okNn]omGGEWoBdm>odI:BOlh?3_o>3dioc`n>Oll@C[o@4<jocm5>om1ASoo
@TM1od15@Om0@SgoF5I:oeMEA_mEDdCoDe90oeIGAOm4ACGoC4dooe9BB?mO
GUWoNWYhojR/[Oo@f=_obMSKolcQi?o6h>7oan?WolOOjoo7f^WodN?_olkM
i?o6dM?oHFYYodUBColk@Cgo=chgocPo>0?o>T4j00co?44jocm2>om0@Cco
>c/kocXj??li>C_o>CTiocdo??m2A3oo@dHoocm5>om5Bcl2odI<?P0=odU=
?om;Cd7oCU93oe1DAOmBETSoCU58oe9DCom@DTgoG65KoeAID_m<DD[oD5E>
og5hL02monKViP00ooo^k^i<onk^kP1IoiK@i_nLeNWoWmCVoi71comhX:[o
IHJ=ofR1QOmfR8SoGVYZoeURGom^M7;oK75]oeIKEom8CDWoATY9odA:B_lo
BD[o>493oca2@?lj?cWo?T4hoeYND?m/KV3oFUi=odE9>?lnACGo>3hbocLl
=Oll?3[o>c/moc`g?_lj=cko=3Pgoce4?Oln@C[o?Cldod=3>Om?Cd?oEEE9
odI8?Om1A3_o>cdhocPm>Oli?Cco=SXiocTm??m3ADCoADY6odYAB_n1R87o
^;jjodeCDOm<D57o@DE6ocdo?_lj?3Wo?3hioce0>Olo@SWo@D@kod56@?m2
Ad7o@4A3od12?OmBDTSoFUQ9oeIDAOmCDT3oEEA2odU7>?m9Ac[oAT<joeEA
C_mgMGKo[Jjbom3Hfoo>g]koc>;PolGRg_o4h^;ob^CaolKKk?o=h>kob=WQ
ok2k_omDGUooA4e<oca5@_lg@3/00_lh@C`01Olj@3co>Slioc`n>Olm?SSo
?Slj00;o?Cln01Ko?3hmocXl>Oli>cKo?T4jodM:@Om>DDSoBDa1odY>@?m=
DD?oDUI8oeMKC?mIGDkoF5a=oeIIC_mEF57oEEMBodaACOmFFeGoCeA>odY?
B?mBEe7oMW]d_Oo^k^h00?ooooooC?ooool0F?nNe^ooWmG]oioBionHamOo
S;C0og^MY_m]RHcoJ7enoe5QG_m9EE7oGVQPofYaJ_mEG5GoAda6odE:A?m:
D4co@4U8ocU3@_lj@3co=S/docPi<Om@DTGoJ6UKofQZG?m<D47oBThooca2
=_lf?3;o?3dhocTi>Oli=3So?3Xooc/o@?lk@Coo@DI2oci1>_m2@cgoDU=;
oe1ABOm3A3co?D0iocLi=?li>cSo>cdjocHh=Olg>CKo@40nodE7@_m8CdSo
KgUaokc2__m9CdgoD5AEocm3A?ln@3oo>C/hoc/m>?lm@3Wo@4<jod=6?Om3
B4;o@TM1ocm3@_lo@CcoDDi5oeeJBomDDT?oDU4oodi??Om=CSkoB4Plod10
>?m>CD_oNg]mokBg_?o>emcod^7Tol[Oh?o7i>;oa>;TolKQk?o3f^SocN7/
om3QjOnLYj_oCEMFoci7A?ll@Sh2ocU2?@07ocY0??li?c_o>Chjoc/m>?lm
?SSo?Sljocm1?P02od12@@0Eoci0?Olj?3Oo?D0iodiAB?mOHUWoFUeBoeII
C_mCEdWoEEU;oe]ODOmQIEOoIVYLofMZHOmDEU7oE5ICoe1BDOmIFeSoEUQE
odi@BomAEU;oL7E_0;gooooo003oonk^kTcok^k^02SoX]SdojCJm?nPd^Wo
Vl[Loik8e_nH_LKoMiJIoe5[J_m5FeSoCF5Hog1mM?mkQggoGfUPodiECOm4
Bd?o@dY2odQAC?m6CdcoAT]5od13??lm?CGoB4PnoeiND_m[K5koE5I8oeEI
Bom5B3go>C`cod52??lo?cgo>3Hgoc/k>olj?T7o>Clooca0?olc>3Co@T@o
oe9CC_m2@cko>S/f0_lh>SD2ocXl>@0/ocHf=?li>SGo@D0lod11??m3BT?o
J79Zol;8a_m@EUCoDeMHod55A_ll?Sgo=cTfocXl=olm@3Wo@TDlodM:@Om7
C4Ko@dQ2ocm3@_ln@3_oE558of5MDOmCDD;oDe90odY;>Om>CcooBD/nodI7
@OmCEE;oRhnBokk5boo:emgodN;YolGMhOo:i^WoanCXolCOj_o2f^KocN7/
omGVkOn:UIOoC5IEocm5@Oll@Sh2ocQ1?00IocY0??li?c_o>SlkocXo>olo
@3_o@D8mod94@Om1@d3o@TA1od53?_ll?cSo>chgodU<@omJGECoLgI[og5d
JOm^LFKoK71Rof]^HomYK67oIVUNof=VGomCEE;oDeEDoe5CDP02oeUKFP03
odmAC_mAEECoJg1/0;gok^k^003oonKViTcoi^KV05SoWM3_ojCGm?nUeo3o
X]7UojC?gonMaLooNj6ToeUiN?mAKVWoIX1gohVMU?n0TXKoGfaRoe5MDOm<
ET_oADm4odaCC?m>EDkoC4i9odA5?om2?cSoAD8ioeIDB?mXJ5coG5iAof1T
E_m?DTOo?d8godI7?om8BD?o?chjoc/k>Olg>ccoA4Q;od96Aolb=SOo@dE4
odQ:BOlc=C;o>C/hocPh=_ll?3[o?SljocXk=_lg=S;o?chiodA1??lj>cGo
@DQ1ofehL?o2blSoEUmLodaBD_m1AdOo=c/jocHk=olj?3Oo?D0iod57?Om8
CTCoBTm9odA9@olm@D3o?3hioeEBBOmRGU;oEUA5oeMEA_m:Bc_oBD/modM:
?om9CTOoEeeKoiZTY_o6dmWob=WQoloSk?o5g>CobnK]olWTkOo;i_7oa]kX
ol_Oj?o>h>CoM820odUDD?loAD7o?dHo0_lk@S/01olk@Cgo>T0locXo>olk
@3co@44lod93?_m4AT400_m1@ch05Om3AD3o?d8kocTl=Oll?cKoA4Lnod54
>OmEF4goLGAYohJ9O_n:SHCoOH1gofU/HomKGESoEUQGoe=DE_m@DE?oDU=E
oeIGFOm=CdkoEEIHofmaL02monKViP00ooo^k^i<onk^kP1Hoj7Bl_nPdNoo
Xm;/ojOEk?nWeNGoWLWDohZc^OmjX:7oGH1log:ARonG/Z_oQIZAof]lL_mN
Jf;oFVILodYDBom3BT?oBDi8odA5?olm?3Oo@Sdgod8n=Om=BD3oHf5Eof5Q
EOmYJekoFEaAod=6>om6B3goCTm7odM7?olk>SGo=cLeodmAD?m?D5;o?Ci0
ocm0@_lj>cgo;c4`ocdo?_lh>3Ko>c/ioc`m>?lg>3?o=3D_ocdl=om1@3_o
>CXdodI@B?mnRH?oa<g:oeMPGom5BTgo?dA7ocLk??lk?cko?3hkoce0>Om0
ACkoB4i4odU>B?m2Ad7o>clnoc/m>?m8ACcoFEE9oeQFAomHFDWoD551odU=
?_m9Cd?oC5=<oe9LFonT/[Gob]_Rol[Nioo>i>ooamo[olcTl?o7h^gobNC_
olSPj_o<h>Oob=[LofIbL?m9DTgo>d8kocPo>0;o?4<l00Wo?48noc]1?Olk
@3co>Slkoci0>om0@Cco@T@ood12?Om1@ch00_m5B4402?m1A3go?T4hoci1
>?m0@cSoA4LlodQ;@_m9C4?oATU00_m4Ad002Om5Ad;oD59Aoe1ADomBDeGo
E5EGoeYKGOm=CU3oE5EGofY[K@2monk^kP00oooooom<ooooo`1HojKElonQ
d>koX<oYojGEk?nXenWoXM7OoiW8d?nG`/SoKIFEogZNW?n[blSoZ<:ooinc
/OmlS8WoIGAaodE@C?m2BD;oBTm8od=4?_lm?3OoB4<modQ1>om:@cgoFeM>
ofIVG?mbM6WoIVYLodU=?om3ACSoDUA7oe1@A?ll?33o>cPaoe1=B?mBDDgo
AdM5oc/k>old=SGo=c/joc/o?_lk?C[o>3XgocTj=Olh>C?o=3D_ocPi<om0
@C_o@4Dnoe=MEOnAWYOob=??oeANGOm5CDoo?dA7oca0@Oln@T7o?D8noc]0
>Oln@ccoA4Y0odA9@oln@cgo>3hloc/m>?ln>c;oEU96oeeKC?mFEdOoE5E5
oda@@Om>ET_oB5=;odmMGOn[_/;ob]kWol[PkOo;h_3ob^7aol_Rl_o5gnco
`mkYolORjOo=h^Oo`M?CoeeYIom7D4_o>D0iocHk=0;o>T4j00Co>d4mocY0
??lj?c_o>Slk0_lm?cX2od54?@0<od95?_m4Ad3oATU2odI9@?m5B3oo@dHm
ocm2>Om2ACcoADQ1odI9@_m5B47o@dE00_m1@ch02?m6B4OoBde<oeEGE_mH
FUWoH69Qodi@ComBE5?oI6IU_Oooool00?ook^k^C?o^k^h0>OnNbn[oY]?`
ojSGlOnRd^WoWM3SoioChOnSe>;oX];LoiO4b_n;];[o/=KIojo>dOnab/ko
Q9VNofenQOm<FUgo@4U6odaAB_m4AD3o?Sdhod]6@_m6?cWo?cPbodY5?om_
K6?oNgebog=eJ?m@E4KoA4HioeIHB_mIFTcoA48codi6>OmGCd;oGEI<oe]H
DOm5AT7o@TA1oe5EE?m3B4Co@dE2ocTk=_lk?3Ko?D0iocLj<olc>37o@4Dn
odeDCOmKIV3oWZZVolkHeomDGUgoC5AFoci6B?m0ATKo?T91ocm4@002oc]0
>@0Qod16??m0ACoo>SliocLm>Olj?cWo@D4ioeiJComUHeKoEE=4oe=DA?m;
Cd3oCUI;ocm<AOm?HV3o//O<olSPj_o7hNkoa^3aolWRm_o:h?Goa^3aolCP
joo:iNcobn3SokC6a_mBGU[oADm7oce4?OloA3go=SdfocLn=olh?S[o>Clk
00;o>Slk00oo?Cljoci0>om3ASooADQ1odA7@?m1A3go@4<jod54>om3ASgo
@TDlodA7?_m3ASgo@TDnod54?Om0@Sd00_lo@C`00oln@3_oB4Y7od]=BP02
oeAFD`04oeaNFom;CD[oE5ICofQZIkgok^k^003oonKViTcoi^KV06GoXm3]
oj?AjonRdN_oXM?Zoj;FjonTfN_oXmSXoj3Dh_nPdMooY=;Ook3Ji_nYcMWo
/<gKojK0com6FfcoGFejoemYJ_mAF57oC4i;od93?_m8A47oBdI2od4i=_m4
?cWoEU=:ohB6NonEUh[oCe=5ocm3=?m8C3goFUa>oeQEA?mMDC_oGTljof1D
A?m_JE_oE5A<odA6@OmBEe?oFf1Loe1BCOm4Ad3o>C`eocDh;ola=bgo=3/c
od9<@omBGEGoFFIOoj2_Z_o3clgoEF5Qoe1JG?lk@dGo@TQ8oc]1?olk@3co
>ChgocLl=Oli?cGo>T4joc]2>olj@3co>3dgocdm=OmEDdOoJVQKoeaJCOmO
H5;oFE]>oe9JCom=FU?oDVIUokK>d_o3g^Ooa>3^olORmOo8hoSoa]oeolOP
m?o9iO7o`mkUomCYk?nN/;3oDemKodA>A_lmA3go?D8kocXo>Oli?SSo=S`h
ocDk=olg?3So>Chjoc`n>Olm?c[o?T<locm4?Om3B47oAT]4odE;@@02od98
?P0AodA:@?m1Acgo@dTooci3??lm@S_o@dQ2ocm4?_lh?CWo?44kod12?Om@
DTgoFE]FoeQJEOmMGe[oDeE@odi@Bom[KFP0_OoVi^H00?ook^k^C?o^k^h0
F_nOcNOoXM3Zoj7Ck?nPe>coWmK[oj3IkOnQf^goXMS/oj;FjonTen[o[=W/
ojWBi_n_d^SoXl7IodQRNom=HWGoJWQkoeAMF_m:D4ko?T0mod=2@?m9A47o
AD0lodI1>om1@CWoK6iSoh:6N?m<D4;o?d<dod96=omHFTcoIV=@of]K@_ma
H4CoM6QBohAmJomaKf?o@4<loe5FD?mRIf7oHVAOoe=FCom2ACco>C`aocDk
<Olj@SOoA4i5odaID?m?GUWoZ[VfolSDe?mFHV;oBeEGoca6B?lnATSoA4Y8
ocm4@?ll@C_o>Slhoc]0>Oll@cco?D@moc]1?Olj?cWo>CXbodU9?om^K63o
JVQKofUWF_mPHUGoEE]Aod]HDOmAIFCo^=7FolCPjoo1hNko`n3bolGQm_o6
h?Ooan;eolSTl?o5h>OodnS]oiNYZOm>FUSo@DY5oce2??lk@3Wo>ChhocPm
=`;o=S`h01co>3diocTn>_ll?SWo?3hiocXo>?lk@3Wo?T<lod56?om2Ad3o
@4Hlocm5>om1AcgoA4Y0odI<@_m3B47o@TM0odA9@om1AT3o>d0locTn>?m4
Ad3oDEA=oeQKE?mGFU?oGF1IoeEHDOmADdkoJVmY_Oo^k^h00?ooooooC?oo
ool07?nMc>KoWm7Zoj;DkOnPe>coWMG/oigGkOnOfO7oX=[boj;JlonUfO7o
Z=Oaoj_Gl_n_eo7oY<OSoeUhUOm9Hg[oGG1god]GEom=EEOoAd]<od];Bom8
A4?oAd=0ocll=Oll?3CoCU15oe]ODOll@S@2oce3=@0Loe9FB?m[J5GoPg9F
ohikFon>P6KoWYN4oijNT_m5B47oCUE>oe]RFomTJF?oFUeDodQ:?oli>bko
=CP]ocTo<olnB3go?da3odQGD_n``;go`m7AodiJF_m7DE?o?dU;ocY2A?m4
CDco?dE1oca3?0;o>D0h01ko>T4joc]2>olj@3co>Chhoc@g<?li>c3oK6aP
ogIdJ?m/JUkoIFEKoeIID?m7DTcoBUaLokK?e?o4h^co`N;aokkMlOo3h_Oo
a^3iolORmoo5hNooa>7YoloVk?n<WZ3oAU9@oca5@?lk@3[o>S`gocTk=_lg
?3H2ocHl>00>ocLm>Olh?S[o>ChhocTn>?lm@Sco?44koce2??m1ASoo@TM0
od56?oloAC_o@4HlodA9@_m5BT<2odM<A@;oA4U300[o?dA0ocDj=?m7BT7o
D5=:oeAJD?mCFDooFV1FoeILD_mCF57oJg9Z_Oooool00?ook^k^C?o^k^h0
F?nMcnSoWm?[oj7EkOnMdngoVmG]oicEl?nLf?;oVmOaoikGm?nQfOCoX]Gb
oj_Jn?n]fOKoYm3^ogRL_?mOOiKoEVaiodIEF_m@FeooD5QJoeEFF?m<BdWo
C4]7ochn=_m2A3Wo?T4fod16>?ld>Rco>T0docHl<?m9C4?oKFYIohUjGOnR
SfooXIEkok2[V?nn`;GoADa5odQAC?m=EU7oHVMQofAUGOmIFDgoB4Hiocdn
<?m2A3KoB4i2odIBA_m;FUGo/<2mokg;bom3DE7oB5=EodA>D?lj@TCo?TM6
oci4@?lk@S_o>3lgocLn=_li@3Wo>T4jocTo>olg?SOo=CXcobha:?mUIE_o
N7IZofQTFOmSH5OoDeA<odA=B?loCdooYl34ol;Pj_o2ho;o_=g`ol;Rmoo5
hOWoaN7fol?Pk_o6hn_od>O_ohJHW?m4D53o?TA2oce2?_lj?3L2ocPj=@07
ocLl>?lg?CWo>ClkocTo>olj?cWo>Chhod97@@02ocm4?P07od97@Om3B4;o
@TM0od15?_m0ASco?d@mod15?P02odM<A@0<od97@Om5BTCo@TM3oc<h<_m7
BT7oCU56oe9HC_mCFDooFV1FoeQOEomFGEGoJ79Y_Oo^k^h00?ooi^KVC?oV
i^H01OnNdNcoWM?]oicBk?nKdnkoVmC_00;oW=Sd05ooVMGaoi[ElonPfOKo
W]KaojOJmonUeo;oZ=K`oiK2gOn5ZKooNYBSoeY/M_m<Ff;oBeIJoe=HFomC
EECoEeQCodI7?om4AS_o?D4cod16>_lh@3?o=CdbobTa9_lj?cSoJVQKohEg
GOnZVGgo[:B=okFcY?o3b<7o@da9odI@Com4CDcoFf1JofYZH_m[Ie_oEe53
odM1<Om;B3OoEeQ:oeaRE_mDHE[oZ[fiol3@com;FE[oC5MKod5<C_lmAdSo
?4E4ocm5@oll@cco>D0hocPo=olj@CWo>d8kocY0??li@3Wo>D0hob`b:?mH
F4koL6aSof1IComOF53oDe19odQ=BOlgAdKoSjN[okkLi_o2i?3o_N3col;U
nOo2h?So`moeol?Pl?o9iO3od^Scoh>DVom8DeGo@DM7od15@Oll?S_o>3Xg
ocTk>?lh?CWo>ChjocY0??lk@Cgo>d0jocXo>Om0ACoo?T<ooce2?_loA3ko
@DI0od56?`02od15?P0@oci3??loA3goAT]4odM<AOm2Ad7oADY4od97@Olc
>3;o@TPnodQ>A?m@EDkoDUM@oeMNE_mGHEWoEV1HofA_Ikgoi^KV003oonk^
kTcok^k^00GoV]3/oiWAk?nIdNcoV=7^oiWEl@02oigHmP;oVmKd03?oW][f
oioHlonQfO;oXMG]ojKHkonWengoWl[MojK3domdRYOoA5IPod=@E_m@F5_o
FEeLoeIHDom2ACcoADPmoc]1<olk@cKo>D4focPo=ol/<bco<3D_oe=CBOn=
PFWo[Z:8ojnZUong^Jko`<W6odiIFom8DeOo>493oeAFDomZIf3oLf]Nof9I
B?m@AcKoE4/jof=MCOmYJekoF6ENoj:e/oo9fMWoIgMgod]FF_ljADOo?DM9
ocY4@ollAD;o>d8kocPo>?lh?cL00_lj@CT06Oli?c_o=cdiocM1>Ol]=2co
A4Dmof1LDomJDDSoFU5:oeA?BOm>D4go?D];ogB<T?nlf^;o_^;^okkSmOo2
io[o`N7hol3Om?o1g_3oa^;^olkTkomlSIGoBEAHocm5AOln@T400olj?3T0
1oli?S[o>d0loca2?_lmA3go?D8koca1>olm@Sh00_lk@3`01oln@coo@4Do
od15?om1ASoo@dQ1od56?om3B4400_m6Bd@2odA9@`0:od15?olf>cGo@4Dn
odE:@om?E4goDEQAoe=MEOmHHEcoEf9LofA_JKgok^k^003oooooodcooooo
03coV<o]oi[AkonJdNooV=7_oiSClOnKe_CoWMSfoicGmOnMfOGoW=SdoioI
lOnOenkoW]OZoj?Kk?nWg>coY]GUok3Ah?n2VJOo@5AOodABFom?FE_oFf5Q
oe5CC_m1A3_oCE15od98>_lj@SGo>40eoci5?Oli@3Wo<3@cod10>?mhL5go
W9AmojZXVonk`[_o/kk0odaKH_m2DESo=Ci3odmAD?mXHegoNfmSogQXFOm^
GdcoKF1=ogAYEomcL67oGfYToi^^[?o>g]koSYjNodUDF?ljADOo?4I8ocQ2
@OlkA47o>D<kocPo>?lh?cL2ocU0>00JocLm>Ole>cOo<cdeoc@k<olg>33o
Ee=:oeiDBomNDdgoG5E?oeQHE_mAGEgoI7UnokgKhonjg^[o_nCdol7VnOnn
hOOo`>3eol7Pl_o4h>kobMo/ogJ7Som7DUKo?454oc`m?olh>3P2oc`n>`0:
ocXo>oll@Cgo?D@moci5?_loASko?TDnoci3?olm@D3o?D8nocm4@0;o?d@n
00Co@DHoodA9@_m2Ad3oA4U20_m3B4403?m5BT?o@dQ1oce2??ll@C_o@4Do
od=8@_m>EDkoD5IBoe1IE?mGH5goFVEQofEaKKgooooo003oonk^kTcok^k^
00KoVM3^oi_DlOnKe?;oVM;`oiKAkonHdo42oi_Fm00boikJm_nJe_3oW]S`
oicFk?nPfNgoX]_^oj;JjonUe^OoZLcPohFO/?m3EF?oB5EModaDE_mKH5co
D5E?od]@BOmAEd_oD5I8od]?@Om2ASSo@TDlod54?Olg>CSo@T<nod0m;_mj
MfKoXjJMokk7a?nKZJco>DQ?ocU6C_lnAdcoATM9of1KEomjKV;oPW9Roh9a
GOn0L5WoOFeDog=ZFOm/LfcoWJ^/oloNhOn[^[goBUMMod5?D_llAdWo=T0o
oci7@_lnACd2oca2>00Moce3>Oll@C[o>3lhocDk=olb>cKo?D@mocDf<?mG
E4_oJ5mFofMME?mWGUOoI6=Oof=[KOmML7Ko_mcTokOKionmi??o_NKhokgQ
moo0hoOoa^GiolKQl_o8h>coM8N>odUDF_ll@DCo?3doocTk>_lm?c`00_lk
@3`00oll@Sko?TDnod17@002od17@007od15@OloA43o?dA0oci3?oll@C_o
>d0joce2>`02od15?P0?od97@?ln@cco?d@modI;A?m2Ad3o?D8lod97@Om1
AT;oA4U5oe5CD?mADdkoDeEBoeUOGOmLIVOoJ7=e0;gok^k^003oonKViTco
i^KV00?oVM;`oiSClOnIe?800_nJeO<0G?nJe_;oVmCaoi_DlOnPfOKoXM[g
oioHlonMenooXM_cojCNm_nNe^goUlWRogbO^om?Igoo@4iKodQ?EOmEEeCo
GUmIoe5FD?m4BD;oC598ofEYFomQGe3oFeQ7oeMA@om3@3Oo?d0kod94@Om7
B4;oBTe6oh^ASOnnalKoGFI[odQCFOla?4;o?DE8oce1@?m?CTWoN71Uogia
H?n:NV?oS7QMohiiF_nAPF[oS8^7oiZSZ?o>fMoo^<O>oe5RJOlkCE7o>TU<
oc=2?olnB43oCeE9oe=GBOlm?c;o>Sh`od=6?Ole>S?o=C/goc8f=Olh>SWo
?3lhodA6>omXIUWoIV=DoemICOmIETooFEeNoeUXKOnccm[o_N?`ok[Tm?na
g_7o`N[nokcRmonlgo?oa^?com3Xm?mUN7ooAU5GocU1@olm@D3o?44mocDj
=_lk@3co?T<ooce3?oll@Sko?4Hnocm6?olmA3go?44k0olm@S`2oca1>`05
oci3?Om0ACoo@DI0od56@?m2Ad400_m4BD<02om2Ad7o?d@noce2?_lo@dCo
AdQ:oeA@COmGDTkoEU5=oeeMFomGGVKoLh290;goi^KV003oonk^kTcok^k^
05[oV=?aoiOBl?nGd_3oV=?aoiWDl_nJe_;oWMKcoikGm?nJdo3oWMKcoikG
m?nNeo;oXM[eoj?LmonLe>ooU/OUof27Z?mQO9WoJWZ9of=ZL?mJG5WoGEiH
odmDC_loA3koBTm8of9TFOmZIeKoLVeJog9[FomNFTooCTm:od53@_lm@Sko
@TM3ogAjN?n7T8ooCEEGodYBEOlk@dKo=CXmocLl>?m4A3coIF5EogI^Fon;
OF?oVhQZoj6:J_nQTGSoWIbHok2i`?oBgnSoaMKNoeibNOlnDeSo=dU;ocM6
@oljA3_oDUQ<of5SEOm@DD?oADDiocm2=ole>S?o?T<ooclo@Olk>cgo>C/f
od=6>omSI5KoH5i?oeeGBomNFE?oF5UKofEbN?nmf>?o_nGbok_VmondhOCo
_NOmokSNlonkg_;o`^7colcSlOmQLggo@TmEocLo@Oli?cgo>ChjocHk=olj
?c/2oca2?P05ocY3?_lkA3oo?4<locY1>_ll@C/01?lm@S`01Oln@cgo@4Do
od97@Om4BD?oAT]500;oB4e700coAT]5od=8@_m0ACoo?T<oocXo@_m5AT[o
EE1=oeaCC_mKE4koHV1Qoe]SK_mkR9Rmonk^kP00oooooom<ooooo`0:oiOD
lonFdo;oUM;aoiGBkonFdo3oVMKcoicGmOnNfOOoUm;`oi[FlP;oW=Sd05Co
X=Wfoj7JmonMe_?oV/g/ohZbeOn5Y<7oOiJXofUhOomGH5ooFEiHoeMLF?mI
FeKoCU1;oeeNE_m/JUgoMW=Tog=aH_mUIE_oEeUFod96AOm0ACoo@DHooe]R
Fom>E53o>3hloci4@_m0ATCo>ChjocDg<_ln?SCoH5e>ohEnJonJSWKoZIUo
ojZINon^XhgoW::NokC5c?o3e]goa][Sofb3RolmDESo<dE9ocM5AOle?cOo
CU58ofATF?mOGe?oDE57od52>_lg>CCo@D=2od90@oli=c[o=CLbodE8?OmR
HeGoH5e>oeiFBomTGEOoF5QJogJ0ROo3f^So_>3`ok_Tm_neh_Go_NKlok[P
mOnmh?Co`^7col[QkomOLG_o@DiDocQ0@_lk?cko>S`iocLi=_lh?CWo>Clk
oc]1?Oll@Sko?D<ooc]2>olh?cP5oca1>`0Coci3?Om0ACoo@TM1odI;AOm9
CTSoC55;od]@B_m7C4Ko@TM1oci3?Oll@Sko=Chmod=7B?mBDDcoFEA>oeYG
D_mPHF?oFFMbogjAXP2mooooo`00ooo^k^i<onk^kP09oiKCl_nEd_7oUM;a
oiGBlOnFdo;oV=Gboi_HmonMf?KoW=Oe00;oWMSf05GoVmOcoi_Fm?nNf_Ko
XM[hoj;GmonWdoSoTkOGogZI[OmPMX7oFVQYof=YIomLGUgoDE5?odY9AOmD
DdkoIVIJofi_HOmTIUSoGf9IoeQMFOm4B4Oo?T<loca2=_m9CdGo@DLmod=8
@Om0ACko>C/focHi<_lh>C7o<c<WodY7>?mmN6GoUhmjojfSR_naYH_o/JbI
ojBc/?nid]Wo^]GLol?Nion7XZ_o?UEKocQ9D?lkATSo>ClkodA7@?mGEdgo
IF9Iof1ME_m:BdGo>S`goc/m??lk>Cco=C<focPi=?m<CDGoIVMIofUUFOmV
GECoIemLofETJOn9TicoaMcZokWMkOnki?Ko]n;eokcRnOo0i?[o_^7eol7P
l_o8gngoGFmiod5>E?lh@4;o>ShmocPj=olf>3Go>3XgocPm>Olk@Cgo?TA0
ocm5@Oll@cco>D0i00;o?44k0olk@3X01Oll@C_o?T<mocm4?_m2Ad7oADY4
00;oAda600coADY4od15?olk@3[o=cdioc@n?Om1BTOoDE9<oeEECOmFEe;o
EUiQoe=ULomlUJVmonk^kP00oooVi^I<onKViP10oi;Al_nCd_?oU=?doiCC
m?nEe?GoU]GdoiOFmonIe_GoWM[ioikKn_nMf_WoVmSeoi[Gm_nLfOKoWm[j
oj?Ko?nSdoWoWLS[ohF[`_mFMX?oBUeSofA^KomSI6KoBdM8odM1@Om<BDCo
HV9HofY^H?mPIU[oH6MOoeMKF_m0AD7o@dTood16>?lm@cGo@dLiod]?@Om9
CCoo>cdbochn<_m<CCoo@3h_oc`j:omNFd[oPGaYokB_Voo<a[3o`/Jgok?;
bonlg^Oo^]cUokgNionQ_lWo?5ELocU<Dolf@DGo?D=3od52?Om@CDKoI65J
ofMTGOmDDdko@d@ooc/k>`;o>SDi01[o?C`hoe5BB_mWIe_oLfmSofiWGomX
Hf3oLg9goiRR[?o7g^ko^mkaokoXo?ngh?Ko^Mgeol;Unonng_?o_mk`olGL
j_mKKGOo?daBocHn@?lj?3_o=SHdocTi=olh>SOo>cdjoce2?P;o@4E100Co
?D8loc]0>_lm@Sco?D8l1_ll@C/2ocm4?P0>od15?om2Ad7o@dQ2od15?olj
?cWo=3Xfoc<o>om1CTOoCeE;oe=FCOmBEe?oD5]OodaSMOmnW;BmonKViP00
ooo^k^i<onk^kP03oi;Am?nCd_?oU=?f00?oU]Gf00CoUMCeoiCCm?nIeOOo
VmSg0_nMf_T0C?nLfOSoVmSgoicIn?nNfO_oY=SoojKFn_nIamooGhBDoc5<
Dom5DeKoGf1ToeiHF_mEC4goDTe9oemPF?mOIEWoEf5FoeaVGOmBEe?o>d0j
od98??m>EDGoDEE6oeEGBOm9BcgoBDXjod90<Om8ASOo?cd^od0n;olj>2Wo
>CXZod]9??n8RG_o_l2bok_6__nee]_o]>3[ok;Lj?ndf^Go[loJoc]FHOlj
CECo<ci4oca0@olo?cgoC4U4of=NF?mUHU_oEeIAodi?BOm2@T3o?STmocdi
>_lm?3SoCe18oemODom_KF7oK6EOof9NGOmYJVooTin[ol3JjOnlgo;o`>Wm
okOQmonhg?Co_n7jokcOmOo0go?oaMo^oea^N?m0CE?o=cm1ocXl>olg=cD2
oc`l>P06ocdm>om0@Soo@D=0oci3?oll@C_o?D8l0_loA3h01oln@cgo?d@n
ocm4?_ln@cgo?D8loca1>oln@cd00_lm@S`03Om0ACoo@TM1od56@?lk@3[o
<S`doc50>Om0D4KoCUI;oe5GCOmAEeGoCEaSod]VNon5Yl80_Oo^k^h00?oo
ooooC?ooool01?n@d?CoTM7doi?CmonDe?L2oiGEn006oiCDmonCdoKoU]Gh
oiOFmonIf?WoV]Wj0onIf?T0DOnLf?[oWMCkoioCn?nSe_7oL9j^oc5AG?le
ATgoE5EJoe]BEomMDEGoFU9@of5RG?mDG57oAe=9oe1JDOm>DdgoATU2ocm3
=OmAEDKoIFQGog1cH_mRH57oEUE3odi;>_m8ACCoAT<bodU7>?m8BC_o?Cld
ocTl<omQIUooZk:ZokW<b_nag>Go[N3aojoNk_negnoo]]OVodIPKOm1Dego
?TU?ocLk?_ln?3goBDI1of5LE_mVHe[oHF5GoemQE_m?CdOoA411ocdi>_li
>SGoCe56oeQJCOmTI5SoGeaEoeQFEomFFf7oRi^Xok_Hj?nhg_7o^^CjokOT
nonkhOSo_>3hokgPm_o2hOGob>;aoeibOOm2CeOo>413oc/l?_lh>3So?3/i
ocXj>?lm?C_o?d4nod12?olo@Cko@48mod94?`03ocm4?P06od15?om1AT3o
@4Dooci3?Olk@3[o@4Do0_loA3h03Om1AT3o@TM1od15?olk@3[o<cdeoc51
=om1DDKoCUI9odmGC?m@FEKoC5YSodaXO_n<[ld0_Oooool00?ook^k^C?o^
k^h01_n@d?CoTM7eoi;Bm_nCdoOoU=ChoiCDm`;oUMGh00?oVMSkoiSGn_nG
e_T00_nGe_L0BonHeoSoVm[koj3LoonPf_ooXm_nojKNnOm`X;Co=5QVodYN
IomVJG;oFDmGodi3BOmHCe3oIFMRoe9LE?m2CTCoBUA;oe1CC?mDEDgoGF1E
odiB@omCEDOoIfQHofaZFomWI5?oJVADof1JB_mQGTgoBdTlodA6>om4Ad3o
@4I2oe9MFOnQ[J_o_MCJojcJj_nYh?Go[=c`okKQm?nce>GoB69aod1@GOm0
BE3o=cXoochl?Om7A3ooHEeDofe[GombL6?oLW=Soe]KCom:AT?o?CThocXk
=OmDEdcoFUi@of1REOmGEU7oE5IEoe9KH_n?X[3o_]o`okKOlonbh?Oo]N?j
ok[To?nggOCo^]kdol3PmOo7h_?oGW9mod5>E_lf?T7o>S/mocLg=`02ocPg
=@06ocXj>?lo?cgo@48oocm1?_m2A3ooAdU40_lm@S`01_ln@cgo@4Dood56
@?m0ACoo?D8locXo>@;o@DI00_m2Ad403?m0ACoo?D8locXo>Old?SKo<D4g
od9BAom>ETWoCeE;odiGE_m:F6?oBfMoohjadKgok^k^003oonKViTcoi^KV
00?oSLkdoho@m_nAd_P00_nAdoH01onBe?OoU=ChoiKFn_nBd_KoUMGioiSH
o?nGeoX00_nFe_T0?_nFeOSoU];foiOAm_nZh_ooXM[eoh:eb_m5K7goGgJ4
og9iPom/JG3oLV]bogYeNOmgNg[oFFANocI1>OmCFU;oHfEJoe9BA_mEEdco
FEaAod=5>?mEETSoJFMHof]XEomXHU;oKVQHofERDomKFDgo@d@nod57@om5
CdkoEVAUoj>b]oned=_oZMW_ojSPnOnZg??o^>7goj_:g_m2EfSoB5ISocU0
B?lh>Cko@d52od8o>_m@CT;oL6iOofUXE?m`Ke[oL6mMoeMBC?m7@d3o?D0g
odE;?Om>EDGoCeE7oeAGD?mHGUkoCU]SohbS/Onoi?Ko[Mc^0_nbiOX02_nb
h?Oo]MoeokOMl_o3i_[o`Mc]ofQnRolmBU?o>d98ocTj??lj>3T2ocdl>P;o
>c/k00Co?Cllod53@?m3AD3oA4I10om0AD401oloA43o?D8noci3?oloA43o
@4E1ocm4@?m1AT800_m2Ad<03?m1AT;o?T<oocLl>?l_=Roo;S/boc]9??mG
GE7oF5]Boe5GEOmBGfSoBVAmohFVakgoi^KV003oonk^kTcok^k^00CoS/oe
oi3AmonAd_SoTM;h0_nAdoH01?nCdoOoU=Choi?CmonFe_X2oiOGn`1>oiOG
n_nHf?_oV=OjoiGDmonMfO_oW]Wioj3Im_nDb>3oL9Z`ogBAXOn7UJ;oSI6L
oj:R[?nOXZOoS9BGofA`L?m@FeOoDUUAoeiND_mQGe?oHfALoeEHColo@CKo
De=7of9PDomXIEKoJ69Dof=PDOmUHEGoF5Q>od53?_lmATGo@di@oeASJ?nQ
/[[o^MGSojWGkonMdnoo/=kfojcBion`bmkoAEQWoca8E?ln@T_o=cPlocXj
>?m2@S[oD4i2of]ZF?mcLUgoKViDofe/Eom/J5goEE9;od94=om3BS[oBU=2
odeEA_mBEe3oEEiModmPJ?nB[[[o]^3`oj_NlOn^iO[o[NCiojgOm_ndh_Wo
]^3fokcQm?o9i_KoJh6>od5?F?l`=cgo?Sm1oc`j>olj>3Wo>cXh0_lj>SX0
3_ln@3goATQ5odY<Aom:C4Oo@4E1ocm4@?ln@coo?D8noca1?Olm@Sko?dA0
od56@_loA43o@DI20om2Ad<02om1AT;o>d0loc@j=_lb?cKo>dLkoe=FBomF
EdooE5QGoeMQJ_m:H7SoNYNg0;gok^k^003oooooodcooooo0_n@dOL2oi7B
n0;oT=7g0_nAd_P0HOnDe?SoUMGioiKFn_nFe_[oUmOkoiWIoOnHf?coUmKi
oioLnonHdo7oXM[hoj7FmOnKan;oTKC:oijhbOnY^lOoZkO3oj:_^?mhQHko
BeQNoeYTIOmLHE_oGEeAof9PDomWJ6;oDeE@oc`m=om2@S[oB4HjoeiLComV
HUKoFEE9of5ODomEETko@4Dooca5A?m0BdooC5eToiV[]Onje^Co[mWaojcK
mOn`fNoo/]?VoemfQ_m8F6Go<CY3oci3BOlm?T3o=cLeoc`m=Om1@CGoE5E3
og=eGom_KeGoLg5JogUcIOm]IUcoG5e=oeAHAom;DT3oATlnodaCBomEGeko
E6M^oj6nc?nbgNko[N7foj_Tn?nZhoOoZmoeokCTn_ndhOKo_>;eokgMk?n3
VjOo=dE>ocY1Aolg>3co?3`locXh>Olm>cco>SXjocLg=olj?3Wo@DI2odI;
AOm4BD?o?dA0oci3?olm@Sko?44moc]0??ll@Cgo?dA0od56@_loA4000om1
AT803?m2Ad?o@DI2oce2?_lf?3So=D0hoci8?omDET_oFUYBoe]KFOmLHf_o
CV1fogF>[;gooooo003oonk^kTcok^k^1on@dOL00onAd_SoTm?goiCDn002
oiCDn00doiKFn_nIfOgoVMWmoiOGn_nGe_GoV]OdoikInOnQe_SoZ=KgojG>
j_nYcN?o[/kMok?=g?nbbMOoMXVHod5BG?mBGF?oJFe/ofUYGOmOH5;oJFYT
oeMIE?m1@Sgo@d@lodI6??mGEDWoFUQ<oeQFB_mJFU3oDeA<od=8@_lmATGo
>dU<odEDFon=X:Oo^M?PojW=hon^engo^M[]ohFO[_m3EF7o@deFod=:D?lh
?3oo@D94ocXl>Old=c3o>C/`od=6=Om[KESoM7ALogagH@;oMfiO01koLg1O
of]^FOmMHTcoD5M7oe1GComEGf3oEfYaojo?g?nag_7o[^GjojSRn?nZi?[o
[N7iok?Sn_nfi?_o/Mc_ol;Sm?n5X:_o@U=KocM0AOli?D3o=cLioc/i>_lm
>cco>SXjoc<e=?lc>3Co?D8nod56@?ln@cd2oce2?P05oci3?olm@Sko?D8n
oce2?_loA4000_m0AD42od56@P;o@4E100_o?dA0oc]0??le>cOo;cXdoce7
?_mGFDkoGemEoeeNFOmOI6[oDfAfogF=Y@2monk^kP00oooVi^I<onKViPCo
Sm3f00?oT=7goi7Bn?nBd_H00_nBd_H2oi?Cm`1Hoi;Bm_nEdoSoV=KkoiWH
nonGf?SoTmC`oicLn?nKeO[oWM;joj3AnOnVeoSoXm;/ojKEjOn[e^Wo/mS[
ogB>YOm3EFWo=T1<oeeRIOmZK67oIFMJofIYH_mFF5?o@T@oodm@B?mKGE;o
FEU=odQ8??mCEDSoEeU>oe5DBom3BT?o>dI2ocU5AOlmC4ooQINKokgDg?nf
e^?o/M;QohnZ]Om0De[oD5]Oocm7BOm:CToo@491oc/m??lm@Sko<CHboce0
>Om3AC[oGf1@ogMfH_n0NFKoOfmPoga/G?mgL5goMWAMog9dG_mXK5_oGVAJ
oeIPGomJK7Ko^MKVok7Nlon_i__oY^3fojcVo?n_ho_o[n7hok7Qmon`gO3o
a>ShohNS[om4EV3o=T57ocPl?olj>Sco>CLhoc`j>olh>3So<cDdoc@i=Oll
@Cgo?TDnoca3??lj?c_o?44moci3?`;o@4E10_loA4001?m0AD7o@DI2od56
@_m1AT82ocm4@00;oci3?olj?c_o=C/gob`i<_liA3coDEA9oeiNE?mNGeWo
HVMZoeMWM_m^QIL0_OoVi^H00?ook^k^C?o^k^h01_n>coGoSLkdohg>m?n?
d?KoT=7goi7Bn0;oT];f053oSlocoi;Bm_nCdoOoT];foiCBmonFe?WoV=Oj
oiOHn?nEf??oVM[hoiSBn?nMdoooW=7moikEo?nJeO?oX=cdojGMm?nUeNco
HXBPod9GL_lY=4KoDEILofAZH?mZKV3oCU5:oda>BOlh>cCo>3/bodmAA_mM
Ge;oADLjodI:??mDEdcoBU14od17?olh@c_o>4A0ocU7AomkRh_o^Lc@oiji
`?n8Xj[oBUeQoci<COloB4GoADM4ocho>_m8BDCo>C/joce1@?l^<S7o=c`h
oc`o>?m;Bd7oKVaOoh9kJon:MfSoR7EToh=gHOmnN63oNGMPog9cHOm^KfOo
IFi]ofamQonjenOo[mcaojgSnonVh?So[>Knok3To?n^h?OoZMW`okWVnOnk
h?;oOifXocQ<EOliA4[o<3Dhod11@`;o>SXj00Wo=cThocDg=_ld>CGo=c`h
ocLn=olf?CKo>Chjoc]0??ln@cl01_m0AD42od56@P?o@4E100[o?44mocHl
>?ld@3co>D@nodY=A?mLG5;oHV=KofU_KOmJJg?oHgV7_Oo^k^h00?oooooo
C?ooool0C?n>coGoSLkdohk>m?n?coGoTM7goi;Bn?nBd_KoTM7eohk>l_nC
doOoU]CioiGCn?nDdoKoUMCgoiSGn_nHfOWoTmSeoiGGmonLeoooVm7ooicD
oonGe?ooUmcmoiKNmonHfoGoU/oZoe=jVoleCVgo9C59ocY1Bom7CTKoCE=5
odE8@Om9BdKo@4<locHi<?m1A3WoFemAod]?@Om3AcSoDeM9odM=@Om0B3go
?DTood5>AollBdKoL7mlojZm^omBIfSo@5ACoce=B_m>FE?oAda5odA5?Om8
B43o@44koci0?Olh?3_o<3Hfobdc<olf>3Go=cPcoeAAB_mjL6KoSgU[oiEo
J_nCPfcoRh5Xoh9mIommO6[oOWifog^1POnBX:_o_m[[ok3Jl?n_ho/2oj[R
n`0EojgOn?n`h?OoZ]ccok7Pl_nbfN[oDg5loc]?F?l^>Coo<cPkocXk?Oll
?3co>SXjocPj>Olj?3_o>3diocDk=olc>S?o=3/docXo>olk@3co?D8n00;o
?T<o00?o?dA0od15@Om1AT800om1AT82od15@@0;oci3?olj?c_o=3XhocI2
@?liAD7oAD]1oeYLComRI5WoJW1/oei]M?mPM7l0_Oooool00?ook^k^C?o^
k^h0HOn?d?SoS/oeohg>m_n?coGoTM7goi;Bn?nAdOOoT=3dohk>m?nCdoOo
V=KkoiOEn_nDd_OoUMCgoiSFnonIfOcoT=Gdoi;Gm_nTgoooTlcioigGoonF
eOooVnCooh_FmOn=eoCoW=_jof>A/olnGGco=dMNoci7D?m<DdcoF5Y=of5N
EomFDD_oGeaCofUWF_mLGDgoFU];ode>?_mAE4?oEeU;ode@AOm9CdGoCEA=
oe9KE_m7DTkoJgMcoij]Z?lmC4Oo@U5<oe1KDom0Acoo@dDjodE5>Om8B3ko
@D4iocm1??ld>CGo>T10oc4g=oli?Cco<38_ocXk=_mXHEOoRgYXoi5lIonA
PF[oTHI`oiF=N_nETHGoTI2<ohJ>TOn_`Loo`^7cojoLlonaiOgo[NGnojOO
n?nYfoCo/>3gojgOm_nbhOGoUKc=ocaJIOl^@T_o=d98ob`a=?lb=3?o>c/k
ocLg=olh>SWo?D8noci4@?lj@3co>D0ioca3??li@3T00olk@3`01?ll@Cgo
?T<ood56@_m3B4@2od97@`0>od56@_loA43o?T<ooc]0??le>SKo;cDcob`j
>_lf@SkoADY3oeQJComNGUCoIV]Woei[LomQLgnmonk^kP00oooVi^I<onKV
iP04ohW<m_n:c_GoS<oioho@n0;oT]7j00[oTm7joi?An?nAcoSoT]3goi?A
n?nEdo[oU]KloiKFn_nEeO_oTmGh0_nDe_P01OnGe_WoVMGioi[Fn_nHeo[o
UMWl00;oU=[l04WoU=CgohNlg?m1JH?o>E=RodQEFomSIUooHEY@og9QF_nK
R87oWHf0oif@OonQVHCoQh5[oeQC?OmCD3goFUI:oe]GC_mPG5WoEeIDoeYL
FomFFU_oKgEeokc5`_ljA3co@de4od97@?lo@SWoATPmodQ8?_m3@3Wo?clg
ocTh<ole=S3o>C/hob/`;?lh?S[o=3Xfobhg<_lk?S?oNgIPoiN=L_nDRG?o
WY>1oj2FS?nUX9coZZ^`ojB`_?nof^_o]MkbojgQmonXh_SoZ>;jojSPmon/
goCo[]kdojkPmondh_WoW<?DocICHOlaADko=3m5obdb=Ol];bko>CTiocTi
=oli>cSo=c`hocLm>Olg@CWo>48jocU3>olf@3So>T4j00;o?4<l00Go>d4m
oca2?_loAD?o@TQ6od55A002od=7AP0=od14@om1@d3o@48ooc/m>?lb>3Ko
;S`locQ4@_m8CDOoEEE=oeiKE_mPHV7oGfUcoei^O@2monKViP00ooo^k^i<
onk^kP06ohW>mon:coSoS<oiohg@n_n?d?SoT<oh0_nAcoP2oi;@n@0^oi?A
n?nDe?[oU]KloiKFo?nDeO_oTmCjoiGFo?nEeo[oU]KioiOFmOnIe_GoUmKe
oiKHn_nDf?goR/ofoiOHo_n>bNWoMZBloe]kR_mYNX7oIV]WofeVH?mcHEgo
PFiWohemL?n/WhkoXi^6ohf9L?mSGTSoEe8noeeGBOmQFU3oJVEQofEQH?mP
H63oEUYIofAZJ?o0bLCoB4e6odaBB?m=D4OoAdY1odM7?Om6AScoAT<lodQ5
?P;o?Shf02So9bPRob/]:?lk@S_o:c@_ocE0>_l]=bco>S`VoiBBNOnESW_o
U8aookF]Z_ne/kKo/;S3okW<gOngf^ko[mgdojSPmonUhOWoYn7iojWQn?n]
h?Go/>3fok3Pmondh_WoW/CGocQEHol`A4go<ci2obhc=_l`<S7o>CTgocTk
>?lk?C[o>d4moca3??li@c_o=T4iocE0>?lg@CSo>48i0_ll@c`05?ll@Sko
?D<oocm5@om1AdGo@dM6odA8Aom3AdKo@DE4od94@Om1@d3o>cdhoc0f<_lW
=CGo<clmodQ;A?mIETgoI5mIofIVI_mTKGKoI79o_Oo^k^h00?ooooooC?oo
ool01?n9c_OoR/ohoh_>n?n<coT2ohk?n@;oS/gf0_nCdOX02_nCd__oU=?l
oiGEnonDeO_oTmCjoi;CnOnCeokoUMKloiKFn_nFe_T2oiKEmP1:oiCFnOnB
e__oSmCmoi[KoonGdOKoULKTogJI[OmkTIcoKGIkogYlNon2OW_oNWE_oh:0
M?nQXY;oUYN5ogEhHomJG4OoGei:oeiMBomJF4WoHEmCofATG?mUJ67oG6=L
oeEPF_nka/3oBU59odU>Aom?DTWoDeI=oe9BB_m=CDGoBdPoodI3>_lo?3Go
=CD]od=4??ld=c3o<CH`obXa:_lK9Ago;SH[ocDh9om7AS;oQ89cojFUVona
/k;o`lcCol?Ehonge>Ko/mcbojcNmonXh?_oYN7kojOPnonYhO[o[N7gojoQ
n?n`goWo]^?jojC9g?lmFVSo<DE>oc<n@_lb=c[o=SPgocXj>?li>cSo>cdj
oc]1?OlmA3go>dDmocU3>olg@CT2oc]2>P;o?4<l00Co?D<ooci4@?m0A4?o
@4A30_m3AdH03_m2ATGo@DE4od=5@_m0@Soo>C/fobhd<?l]>CGo=D8iodE9
>omFE4OoI61DofMXH_mWLG?oK7^2_Oooool00?ook^k^C?o^k^h2ohW>m`;o
Rlkh0_n=c_P2ohk=mP04oi?An_nBdO[oT]7joi?Bn`;oTmCj03goT]?iohoC
n_nBeOooT]GooiCEoOnEeOWoU]GhoiGEn?nDe?[oTMGloi?Foon@dogoW=Oo
oiK;jonD_=GoTZo1oiNY]OnT/KOoX[2aoij]Z_nP[:SoY[>ZoiRTV_mRKEoo
DEQ8og5eI?mSI5;oI6=Aof]/G?mYJekoGF=Ioe9MEOm9F57oa=7:odmFCom2
Ad3oATU0oeAGC_mKFe?oFUYBoeMDBom<BD3oBTLnodE2>olj>S;o@44iod95
?_lc>37o<STaoc0f;?lh>Rgo=3HYoeAJD?nS[:Woa=;EokO;e_o1g^ko/]K/
ok;Pn_n^hOkoZN3n00;oYn3m02_oZ>3koj[Pn?n/h?So/=oiokWSnonZcN7o
AF5_oc=5Colb?D7o=SXkoc/m??ll?3[o>c/iocPj=olh?CWo>T4jocY4??lk
ACgo>T@loca3>olk@S[o>d8koca3??lm@coo?TA0ocm3@_ln@T7o@TI5od14
@olo@d;o@4A3od94@Olo@Cko=cTdobdc;old@3co?DQ2oda>@omMFdkoK6QM
of]/I_mXLGKoL7j70;gok^k^003oonKViTcoi^KV0_n8cOH01?n9c_OoR/oh
oh_>n?n<coT2oho@nP?oT]7j05OoTM;joi;CnonBdo_oSm?johoBo?n>dogo
SmCnoi;CoOnCd__oUM?hoiCDn?nDe?[oT]Kmoi;Eoon<co[oWMcooiK>lonU
e?;oX/OQoj_:g_n_bmWoZ/_Dok3Ae_n`cmCo]];FohVQYOmIJf_oA4m9ofA/
HOmjO6koMGITogAeIOm[KEooGVIKoeMTFom<G5Wo`M3=oe=MEOm3B47o@D@m
ode@BOmHF53oGemGofERFOmRGeKoI65HoeMDBom4@CSoA4@jod52>_lj?CCo
?D0gocTl=Olh>cCo=3TeoeiXIonDYZ[o_MGOokgNkOnWd>Co/n7kojgPoOnZ
goooZ=onojOPo_nVgogoY]olojOOn_nYgoWo[McfokOOn?n_cnCoBfEdoc=6
COla?43o=c/locdm?Oln?C_o>c`gocPj=olf>cOo=cdiocY0??lk@S_o?4<l
oca3>ollA3T00_lk@SX05?lm@Sco?T<moci3?oln@coo@TI5od14@oloA43o
@4E1od=5@_lo@Cko>3Xgoc4e=?le?d7o@TY=oeACDOmXHeooN7=`og5`MOmY
LX7oLh:E_OoVi^H00?ook^k^C?o^k^h2ohO<m@06ohS=m_n9c_OoRlkhohc?
nOn@dO_oTM;l0_n@dOT01_n?d?SoT=7ioi7Bn_nAd_[oSm?johgBn`;oRm;n
05;oSm;moi7Bn_nCdoWoTm?goi?Dn_nAeOcoTmKooi7DoonHf?ooTm7hoi[@
l_nSd_3oXL_Toj;;hOnSd^CoX=7Poig;fonfg>ooGWf?od]QKola@4Oo>dA3
ofi_Iom`LF?oLG9Rof9TE_mIHEKoEf=OoeATI?ngalOoB55<od97@?m4Ad3o
CE19oeEECOmJFU;oI65HofUVGOm^K63oGE]?of9PE?mIETgoBd]1oe9DBOm1
@cSoAdQ2od53@_li?T;oCeiSoj[3b_n`e>;oZMCUok[/oonOeO7oYMckojGK
oOnWg?koYmclojKMo?nWg_coY]ojojSNn?n[fO?o]Mkdok7BiOm@JWWo=DI>
oc4j?olg>cco>c/iocdl>?ll?CSo?3`joc/m>_li?S[o>ClkocY1>_lk@S[o
?D@loce5>_ll@c_o>d8j0_lm@S`04_ln@coo?dA0od=7A_m1ADCo@4E1od97
@om3AD;o?T0mocTk>?le>CSo>413odE:C_mAD4koHUeJogA^K_m_KWCoK7F6
ogn@Y;gok^k^003oooooodcooooo0_n4boD2ohO<mP05ohW>n?n:coWoSM3j
ohkAnon=d?X00on<coT01?n=dOSoS];iohkBnOn<dOX2oh_BoP1GohkAo?nA
d_[oT];hoi;Bm_nAd_SoSm?joi3Co_n?e?koTMCooiCEoOnEdOKoY=cmoj;D
mOnTfOSoWm_goiSElOnHcnkoZMOioeEiVom3G7[o;CaAobhe?oln?SkoFUM>
ofaZGOmJFTkoD5=<odaEE?mHIFgo[;Vooc]4@Om0ACooADQ1oda?B?mGEdoo
FEUAoeiKD_mTHUKoIF5FofAPEOmEDDKoLViSogUgJomkNFgoM79Voe1?B_mA
DE?o?D5:odMIHonXa]7o]=o`ojWMl_nRg?CoX]kjoj?Ko?nVfogoZM_loj_L
oOn[g_goZ=kjojOOn_nWgOGo[=[bokOMm?nge^[oFG1noca:Dolc?47o>Cdn
oc/k>Oll>cOo?3dhocdm>oll?S_o>Slkoca1?Om1AT3oA4U2ocm4?Om0ASco
?d@moci3??ll@C_o?D8lod15@Om3B4Co@TM300?o@DI200co@48ooc/m>_lg
>CKo=S/god16A?m;D4coE558of1LDomaK6KoJV]]of]gPon6VJZmooooo`00
ooo^k^i<onk^kP;oQ<_e0_n6boD01On7c?KoRLkhoh[?n?n;d?WoS<oi00?o
Rlkh00CoS=3gohgAn?n=dOSoS=7j0_n<dol0C_n>docoS];ioi3AmonAdOGo
T=7gohkBmon@dogoS]?loiGJoonCf?ooUMKloiSFnonDd?CoUMCeoi?HnOnF
g?koX^3ooigBo?m/U/3o@Uj3obm0G?ld>dgo>3LlodE2?Om>BSooBDLkoeeN
F?mSJFWoHFYcohVCW?loADGo@TM1od12?Om5B47oEUM?oeeMEOmOG5?oI69F
oeaHCOmHE4WoHEeAog5]HOmcKfCoQ81eofeYG_mHEE3oEE=Hoe1DH?m6F6Ko
[<gLok3OlOnMengoX^;moj7QoOnVgogoZmgnok3Noonag_oo/MkmojcNnOnX
g_SoZ=cdojoLlonjg_Co_M[/oemfQ?m1CeSo>413oci0?olm?C_o>cXfoc/l
=olk>cWo>C/hocTn>_loA43oBDi8oe5FC`;o@DLm00So@DHoocm4?Olm@Sco
?T<mod97@om6BdOo@DI2od15@@;o?dA000co?CllocLi=_ld=S?o=3TeodA9
@omEF4ooH5iAofiZG_mlNG3oK71_ofEfP?moU:Fmonk^kP00oooVi^I<onKV
iP;oQ<_g00?oQ/giohO>n_n7c_P00on7c_P2ohcAn`CoS=7j00KoS]7kohgB
non:dO_oRm?kohkCn_n@e?T3oi?En003oi7En_n>d_OoT=Gl00;oTMWo01[o
TMKmoi7En_nEeo[oU=Skoi7Lo?nAfokoUmSooigFoon2[MSo9DE/oce@K_l^
=TWo?3e2od8m>OmGD4KoEE55oeADC?mTIVGoMW^1of1WKOlj@43o@TM1odU;
A_m2ACkoD559oeEEC@;oGeaC02koG5Q=oe9>@omXI5SoLfmSohAnL_n2O73o
M6iRoeYEComDDUOoDeMSod=EHon[c=go/n?gojKPn?nPh?_oXMkkojONoOn_
h?oo]^7ookKOoOncg?So/=cgoj_Mm_n/g??o]mohok_Nm?o6hoGoJ7j;ocm<
E?loAd[o?T0oochn??lm?3So=cPcoc`l>_ll?S_o?D8noci3?om4BD?oFf1I
oda?A_m3AS_o?T4hod54>om5B47oA4M00_m2A3l04?m5AdCo@D=0od12?om0
@Soo>3dioc4f<_ld>CGo?D8lodQ=A_mDEdcoJFMJogMdIOmgMfgoLWQfof1b
O_n=YkRmonKViP00ooo^k^i<onk^kP;oQ<_g00?oQLchohK=nOn7c_P01On7
c_P2oh[?n009oh_@nOn<dO[oSM3johcAn_n:d_[oR];hohcBm_n>d_OoS];e
00;oT=;e04?oS];eohkBmon?eOWoT]Sloi3Io?n?eogoSmSkoi3Io?nAf_go
TMgmoh_Fm_nCeocoW=Smoi30j?m1IHWo<d]WobhkBolb=C[oCTe8of]WG?mX
I5SoLVmVofe^JOmXK6goRi2Cod]?C_m0AD7o?T0koci1>_m?D4[oCTm7oeAD
B_mJEdkoE515oeQDBOmdL6CoMg=WogihK?mjM6SoKfUMoeYECom@Be7oDEEP
odQJJ?n^cMoo[mkboj;JlonVh_koZ^KoojOMnOn_g_[o]=_hok?HlondfO?o
]MogokSVo_nljOoo`NOnolGUn_oAk?goKXBAod1=EOli@DCo?3hmochn??m3
@Sko?Slj00;o@48o00ko?T<ooce2?_m1AT3oEeaEoeQKD_m>DDKo@dHmod13
>_m2ACko@dHood=5@?m2A3ooA4I3od53@0;o@48o00co=c`hoc0e<Old>CGo
?D8nodY?BOmFFE3oJVQLogEaI_maLVcoJgEfof5fQonC[lFmonk^kP00oooo
oom<ooooo`03oh?:m_n4boOoPlcg00;oQ<gh00OoQLkiohK?n_n7d?_oQ<gf
ohG>mon7c_SoRM3j00?oS=7k00?oS=7johgBnOn<d_H00_n=dOH3ohc@m@05
ohgAm_n?doKoSmGgoi3Fn?nAeoT00on?f?/0;?n?f_[oSm[goh_El?nDfOSo
UmKeoj?Em_mgX;coBfYoodIJIOmBGEooKgA^ogQjKomcM6KoNWY^og1aJOmY
KVSoV9fIoc/m>_m0@Soo@T@ooc`o>?m;C4KoCTm7oe=CBOm?CdGoBTPloe=A
AOm]JEkoKf]PogIbIomiMF[oK6EKoe=>B?mCCU;oC4mHodADHOnXaMGo[]S^
ojOKlonYhOcoY]kiojgOn_nehO[o_>7k0_nmhOT03_nni?_o_NOookgWooo2
i_ko`n?hom3[o?mdR9?oA55GocU1@olo@d;o?d4nod=4?om0@CcoA4I30_m0
AD406oln@coo@TM1oeMLEOmPHeSoFE]>oda>@om3A3co?d8kod54?Om0@Sgo
?CljodA6@om2A47o@D=0od12?olg?3So<CHbocHk=om1AT;oCe=BoeUKF?m/
JFCoLg1[ofa^KOmUKgSoIX2Goi^mf@2mooooo`00ooo^k^i<onk^kP;oPl[f
0_n2boH02?n3c?OoQ<oiohG@n_n6dO_oQ<gfohK?n?n8coWoR]7k0_n=d_`0
1On<dO_oS=7johoCn_n?doSoS];g00?oSM7h0_n>d_T0H?n@e?WoSm?fohoC
m_n?eOOoTMOiohoHnOn?f?_oSmSiohoIm_nAfoCoUmggoiCDkonRfoKoXm?Z
ogfR]OmXQ93oN8^Aoh:@T?moRH7oPhR1ogUoMOm]LV_oH6MOoe1ECom2A47o
@dE2od=5@?ln@3_oDU==oeUJD_mNGUKoFUY@od]8?omIEd_oK6YNofaXGOme
LFKoOGU^ofYVGOmBCDOoEeEFodmBEom<FVGoZ/CCok?GkOn]foGo[^3kojKI
m?nehogo_>Knol7Wo?o1iO_o`>CjokkTnonkhoco^>3iol3To?nmgO;obnGf
ogV=V?m:Eego?DE7od96AOlm?cco@T<nod12?Om3B4Co@DI2od15@OloA43o
@TM1oeEJDomPHUOoGf5DoeIHCOm:C47o@TDlod13??ln@3_o>S`godA6@om2
A47o@D=0oci0?Olf>cOo<cPdoca1?Om8CDWoCe=BoeYLFOmZJFCoKVeXofEY
J_mMJgCoJXVNoj76hKgok^k^003oonKViTcoi^KV1?n2boP05_n2cOOoPlkh
ohC?nOn3d?[oQ<oiohG@n_n7d?WoR=7joh[Anon9d?[oRm3joh_>n?n@dOWo
T=7goho@n?n=d?[oS]7lohkCoOn@dokoT=?moi7Bn_nAd_P2oi7CmP1Foi7E
n?nAeoWoTMOioi3Fn?nCf_SoUMchoiCIm_nFfOCoVMO`ojOOm_nLbmooP:Nh
ohNU/?mmU9coQIJMohRFUomoRh_oN8=ooeaWHolg@3_oAdU6ocPh=_m1@Sgo
H65Loh21Nom/KFGoDeA<odI8?Om8B3koG5aBofa/H_mZIekoJ6ELofi[H_mN
FeCoDDi9oeUIEomIGV7oH6efokC9f_njf_7o/MSeokKRoongi?oo]n?lok[T
n_nkhOCo^=kaokSNlonjh?Oo^n?lokgRo?o0i?co`^;gom7[o?n9WJSoC5]P
oc]5A_lnA43o>SliodA6@Om3AD3oA4U3od17@?lnA43o?48noca1>om<DD[o
GEmBof5SEOmNH5?oDUA9odI7?om1@Sco?d4loci0>om3AD;o@48oocdo??li
>cSo<cPdocDj=_m1AT;oCU=?odaCC?mGG5D2ofU[H004oeiXGomGJf[oKY:N
oio:fkgoi^KV003oonk^kTcok^k^0on2boP00on1boSoP/ggoh;=m`02oh7>
n004oh?>n?n4coWoQ/ohohK?n0;oQlkh06[oRLkhohW<m_n>cOKoS/gfohk?
nOn<co[oSM3mohgAoon?dOooSm;ooi3@o?nAd_[oT];hoi;Bm_nAdoKoT=Cg
oi7En?nBe_WoUMWloi3Dmon>doCoV]onoiKIm?nHf?7oX][coi?3f_n7/<Ko
MiN/ohnX_?n5V:OoPYBNofYiP?loCU7o@4a<odQ<Bolh>3Ko=SLbodM8@omS
I5koFU]Eodm@B?m9BT;oAdLmoeIFC?mQHEOoHf=IofISG?m[J67oFEI?oe=B
COmMGe[oFfASoei[Lon]`=7o`=cdok[Kn_ngg_go^^?ookOQn_nihoWo^^?e
okWSlonih_Ko^N;hokSPnOnhgOOo^mogolOXnooFlOooV[2kodeLHOlkADKo
@4I2od=8@_m3AD3o@4Dood58@OlnACko?dE1oce3?oll@C_oBDi7oeUKC_mN
H5;oGV1CoeAFBOm8BD7o@D8jod12?Om2A3oo@48oocdo??lj?3Wo=SPeoc<h
=?lg?3So@dQ4odmDD?mAEe?oG65Kofa^HomXJf3oH6]SoeecLOmjX:WoW/kL
_Oo^k^h00?ooooooC?ooool2oh7:m`;oPL_h00CoP/cioh3=nOn0cOOoOlcf
0_n1c_P04_n3c_SoQLkiohK=mon7c_SoRLkhoh[=mon=c?GoS/ceohk=nOn<
cocoSLooohc@oon=dOooS]3ooho?oOnAd?_oTm7joi?An0;oTM7e03koTmGh
oiGFo?nDe?ooS]7nohoBo?nEfoooUmgooi3Em_nIf?WoWMGhoik>l_nOan_o
/M;eojo:j?n[`MWoHGJ9oca@FolnCE;o>Shoocln>_ln?c[o>CXeodQ9@om9
BTCoAdQ0od11>Om8BD7oDU=;oeYKDomWJ63oKFaWog9aK?mNGESoHF9LofI[
IOmMIfKoE6=Zoif``Oo3foGo`]oookKInOncf_Wo]=kgokOTnOnmj?Wo_^Wi
okkYo?nliO_o]]khok;Gl_ngfo?oaNKioloZnonQ]l;oBeYOocm;Bom2B4Co
Ada6od97@?loA3go@DQ1oci5?P;o@DM301[o?D@modQ=A_mFF4_oFea>oeiP
DomKGE3oD559odE6?_m1@Sgo@T<nocm1?_ll?S_o>C/hocLi=_lf>cOo>d0l
odE:A_m>DU7oFEiRof=XJom`LVooIV]Wof=_KOmTO83oPjfkoj3@i;gooooo
003oonk^kTcok^k^0_n0b_L01_n1boSoP/cioh3=nOmoc?SoOlcfoh3;m@;o
Plkh01;oQ<oiohG>nOn7c_SoR<oioh_@n_n=d?_oSLcgohk=n?n>c_[oSM3m
ohk@oon=dOooS]3oohg?oon?cogoTM3koi?BnonBd_P2oi3@m00/oi;DmonE
e_koT]GooiGHoonDfOooRLkeoiCJo_n>e?KoS]3coiWGo?nJcoOoY]Knoio6
kOn`d_Oo/<g[oeE_Q_mLMXOoAEIPoe=GF_m>CDWoAdI2ocln>Om:BT;oATHn
odE5?Om1@S[o?3dgode>B?mJGEKoJFYTofIWH_mTHekoEEA?ofIWHOm]LVco
J75`oeaYL_nM[/3o`m_eol3MnondeoGo^N3mok?On?ndh_T2okKSn00/okOT
nonhi?go^N;nokKPnOnggoSo_n?iokoNl?nN]/;oBEQModE?D?loAD7o@4Dn
odQ=A_m3Bd3o@Ta3oci8?om0BT;o@DQ1ocY1>Om2B3koF5Y?oeaNDOmSIE[o
IVQMoeiPEOm>CdOoA4Dood52??m0@Sgo?T0mocXo>oli?S[o>d0lod15@Om7
C4SoCE5@oe]PHomUJFcoL71bof9VJOmSKWCoIWj:ohRa`onLcnBmonk^kP00
oooVi^I<onKViP09og_8m?mlbOGoOL[fogg:m_n0b_OoPL_hoh;=mon5c_Wo
Q<gh00;oPlcg00OoQLchohO>n?n7c_SoQ/ggohO<m_n8boKoRLcg00?oR/gh
00OoRlkioho?nonBd_koTM;loi;CnonAd_SoT=7g00;oSm3f04goT=Cgoi;F
non>do[oSMGkoi3Fn_nAeoWoTmSioiCIn?nFf?SoUmShoiWEmonKdoCoX=;c
ojODlonZd^coW/7GohFQ]_mcQYCoI6M/oeiJEomQG5SoKVYQofm[H?m@C47o
BDHmodA4??m6Ad;oAdU6oe1DDomIGEcoJfeZoeYKE_mFETkoG5eEof]/IomW
K6ooFF=_oiFV^_o0f?Co_MciokWNn?nkiOgo]N?jok?Sn_neh_oo]>?ook;Q
oon_g_co[MchojkMmongjOoo]>;jolO/oonU_lcoCUeTodaDE_m0ACooBdi5
odI<@?m2CCoo@Ddood1>?om2CT3o@di0odI<@?m7BT7oDUE>oe]NEomQHU[o
G5iCofMWFomPH5Co@T8hod93>om5B47o@4Dooci4@002oc@j>00;od98A_m9
CdgoDUMCof=VGomXJFCoJVQ[ofYZM?mOJ7WoKhFJoiS1eonPd^T0_OoVi^H0
0?ook^k^C?o^k^h2ogk=n00:oh3=nOmoc?SoPL_hoh7;n?n3c?OoQ<ghohO>
n_n6cOWoQLchohK=n@CoQ/gg0_n:coT0FOn<co[oRlkiohg>n?n>coWoT=7k
oi7Bo?n@dOWoTM;joi7Bn?n@dOOoSM7fohkBmon@e?OoT]Kioi7Gnon@e_[o
Sm?fohoDmOnBe?CoUMSeoiSJn_nKg?[oVM[joi_HmonMe_CoY=Ofoj_IlonZ
d^_oWl;HoiZa`OnJXJOoUYFCoiRET?nIUHcoRhMlof=OE?mDDDSoA4@lod51
?om:C4_oD5AEoe=GF?mOHEkoEeUDoeMIC_mPHUOoIfQSofEYK?mGH6ooTZ:i
okcFlOnff?Co/][cok?Qn?n`h?Ko[MohojkOoon_gooo[^3ooj_Mo_nZgOSo
[>3hojSNn?nch_co_N7goi^ea?m8EEkoCeAGodI8@om4Acko@TPlod1;>olo
CCko@U11odEA@om5D4;oATa0odE8?omDFE?oG5iIofEVH?mXJ5koKF]OofYX
FomHET[oBD/nod13>_lm@S_o@DM300;o>D8o00_o@T]8odM=BomAEU3oIfYO
of]/I?m]JfkoJVahof=^P_meSjSoVLGNoj7Dk`2monk^kP00oooooom<oooo
o`04og[;n?mkc?WoOL_iogg:n0;oOlWf00CoPL[goh;;n?n4cO[oQ<gj0_n5
c?P02_n3c?OoQ<ghohK?n_n7d?_oR]7mohW@o?n:coWoRm3johc?n_n=d?/2
oho@nP;oSm3h0_n@dOT2ohkBm`0]ohoCn?n@e?WoUMKnoiCEnonCdoOoTm?f
oiGEn?nHfOWoW=cooikOoonKfokoV]_koi[Fn?nNeOCoYMKdoj[Hl_n[dnco
[LcNoj2]]_nJWZ7oW9bJoijMV?nBShKoL6eTof=PEom>CTKo@T<node?C_m:
CTgoCE5@oeUKF?mQI5goGUmGof5RF_mUJ67oIF][oeQTL?nDY[[o^mWcokKK
m_n`g?Go/N?joj_OmOnXg_SoZ=gm00;oZMgo02_oYmclojKLm_nWgOGoZMcg
okKRnonhfo7oU:^kodaFH?m?DUOoB4Q6od=4?_m7BT7oA4`ood5=@Om2D4?o
AE55odI@AOm5CD;o@dQ1oe5FD?mJGEKoI6EMof][GomYIe[oJFMHofESE_m=
CD7oAdQ0oci3??lnA43o>44loc]1?Om5BdOoCeA@oeeRFomYK67oKFiVofa/
K_mWJgOoI7>8ogbJ]?nKb^KoW=Gb0;gooooo003oonk^kTcok^k^00_oMlSe
ogS9m_mjb?KoNlWgogc9momobOKoP/_hoh?<nOn0bOKoPL[goh;;n002oh;;
mP0:oh?<mon6co[oR=7lohSAo?n7c_[oQ/giohW>n?n;d?[oSM3kohc?nP;o
SLkh00CoS/ogoho@n?n@dOWoSm?j0_n?doP01onAd_[oTm;koiKDoOnJeOgo
WMWnoioKoonNgOl00_nMgOl0D?nJg?ooV]cnoi[JoOnJe_SoW]Gdoj;El_nV
eNoo[M7Wojk1conHXjWoRI6CohJ:ROmlOGOoI6ALofMTGOmKFe?oEUEAof1P
G_mDEU?oDUMCoeAFDOmLGeSoDU=;oe=FCOmLHE[oGVMVoeARJon>XkKo]MG^
ojoIl_nZf_7oZ=kfojSPmonUg_WoY=cmojGMoonTg?ooX][koj7JmOnSfO7o
[]ggok3HlOnhencoQYVZoe9JIOm>DEKoB4Q8odQ9A?m@DdcoBE56od9>A?m0
CD?o@di6odE?Aom6CDKoADY4oe1EComUJ67oJV]Sofi^H_m^JUkoK6UJofi/
GOmKG4koD597od16??ll@cco=T0hoce3?om:DD[oEeaFof]^Iom]KfCoKVmW
of]/L?mRJWOoJ7Z@oh>U`OnHcNcoVMKe_Oo^k^h00?ooi^KVC?oVi^H02Omg
bOSoN<[iog[;n_mlb_SoOL[hogk;nOn2c?_oPlgloh7;nP02oh;<n@0Aoh7;
n?n0b_OoPL_hohC>non6d?goQLolohG>nOn4cOSoQlkjohW@o?n<dO_oSM3k
ohc?n_n=cOWoSLkhohk?nOn@dOT00_nAd_X0F_n>d_WoT=7ioi;?nonFdOgo
W=GooioIoonQfoooX=cooigKoonJg?ooU][ooiSLoonKg?ooV][moicHn_nQ
f_SoY]_jojgIl_o1g_3oYKW4oh^JXOmiQ8KoIVaZodmAC?mPGe[oJFUQof1O
F_mWJ6;oFeeHoeUKE_mEEe;oF5YEoe1CC?mGFU7oGV=Lof9[J?mHIVooSjJh
ok?Ek_n[eo;oX]S`oj7MmOnShO[oW]kjoioKoOnPg?ooXM_ooioJn_nNf_Co
X]S`ojcHlOnXb^?o^M;XofinS_mCFVCoDeAIodi<COm>CDWoDE9<od]@BOm3
CDGo@Da4od9=Aom4CDSoAD]7odE:A_m:CdWoJfiUof]]H_mZJegoL6eNofaY
F?m^KE_oJV]KoeIHBom5Bcoo?TDmoca3>om3B4;oD5E>oe]NEomYK6?oLg=W
og5bJ_m/L7?oHfmkoff5WOn:/looVM7boiOInkgoi^KV003oonk^kTcok^k^
0_mhb_T01_mjbo[oNL[iog_9nOmlbOOoOlWhoh3:n@?oQ<km00GoP/cioh7;
n?n1boSoPL_hoh;<n@02oh?=nP06ohC>non7d?_oRM;moh_Bo_n=dOkoSM3k
0_n=cOT0G_n>coWoSm3joi3Anon@dOWoS];iohk?nOnDco_oU/oloiSAo?nJ
e?coVmGkoicHoOnJf?goV=[moiCHoOnEf_ooU][ooiKHnonHeo[oW][lojCM
non[gOSo/MO/ojW6e_nG[[coOi:IofMbM?m4BTSoDE=>ofATG?mZJV;oJf]S
oeiOFOmKGUOoHfEPofQZIOmLGUWoFEaEofI/H_m[M6ooGg1goi>]__ndf?;o
Z]Weoj7Il_nOgOKoWMoioi[KnOnHf?_oVmWnoioKoonOf_[oW][bojGIkond
f_7o/LgSokC9f_mMJgSoDeMPoeQGG?mGEUCoCTe8od]<A_m7C4GoA4i6od9=
Aom3CT[o@Te9od=<BOm4BTKo@dQ2ofEXGomZJV3oIfEHofm/GOm[J5OoJVMF
og5bH?mUIeWoDeM9odE;@Olj@CWo@4Dnoe1FC?mMH5OoK6iSogMeJOmcLf_o
KW=fofIfPomeTj_oSkkLoiCCm?nDf_bmonk^kP00oooooom<ooooo`04ogG9
n?mfb_WoMlWiogO8m`;oNLOg00CoNlOhogc8nOn3cOkoP/ck0_n1boX02_mo
c?[oO/_iogk;nOmmb_SoOlcjoh7>n_n3d?coQ]3mohSAo_n9d?`2ohc@o@14
ohc?n_n;c_WoSLgiohk?nOn?d?[oT=7koho@n_n?c_WoT/okoiC?nonDcoWo
UM3hoiKBmonFeOSoU]KjoiKHnonBe__oT]Sloi7FoOn@e?WoU=Choi[In_nP
fo_oY=WhojWGlOnaencoXL3Doh2JYomYNX;o@de?od14@om:BdGoJVYRogAd
J_m`LFWoIfQPog1cK?m/KVWoFeeHodY<AomTIekoJ75/oe]/Lon>Z;Wo[M;/
oj7Bl?nGdnooUMKboi_NnonGfOWoU]KjoiWGo?nNf?goX=Wgoj3HkonVe^[o
]mO/ok;9fonCYK?oEf5Zoe9EF_mADE7oEeIBodm?Aom;C4CoBdi7odQ?B?m5
CTT2od9=B@0JodA=B_m7CDWoAda5oeaOE?m]KF7oKVaMofm/Fom_K5WoK6UF
ogAcHOmaLVCoH6AFodmEBOlm@cWo@4<joe=FCOmTIEgoMGE[ogQdJOmcLf_o
LGUlofj2SOmoXkWoULSUoi3Bm?nAf_fmooooo`00ooo^k^i<onk^kP0DogC8
momebOSoMlWiogO9nOmib_WoO<[jogk:non0c?goO/Siogg7n?mla_GoOLOf
ogg:n?mnboWoOL[hogc9momlb_SoO/cjoh;?non3d?`2ohG>n`04ohW=n_n;
cocoSM3moh_>n@;oSLgi0_n?d?X01_n>coWoSLkhoi3?n_nBd?WoTm7hoiCB
m`;oUMCg00?oUMGhoi;FnOn@e?L00_n@e_X0COnBe__oVMWmoikMo_nUgOoo
Y=_jojSKn_n_gOOoSkS>ofN6V?mJL7go@DiFocY2A?ln@3go@T<kofYZH?n2
Q7WoLWAYog5dJomWJV?oGf5Noe=ED?mSI5coJW1/oee/Lon=Y[[o[=7/oj7D
lonIe?;oUmSfoicNo_nHf_coU]Kjoi[FnonNe_WoX=Gdoj3Dj_nWd^?o[/WJ
oj6c`OmVM7goDEYOodeAD?m2@ckoDe19oe9BB?mCDdWoD5=:od]BB_m5CdOo
@DY5od5<A_m6Cd[oBE=;odM<AOm>DDKoJF]Nofi/GOmWI5?oKFQEofISD?mW
IUCoKVmOofEYF_mLGeCoBDm3odU<@omJGE;oJ6YOogMgJomkMfcoM7E_ogF0
P_mdSi[oQk77oi[Akon@e?OoTM_o0;gok^k^003oonKViTcoi^KV0_mba_D0
1?mda_KoM/ShogS8nOmibOX2og_9n@?oOl_l00?oO/[kogg:n?mlbOL00_mj
aoD05?mlb_SoOL_ioh3=non1c_coP/_hoh7:mon6b_WoR/kkoh_>non<coco
T=3loi;Bo_nCdoooT];noi3Anon>coWoS];iohc@mon?dOCoUMOi0_nKg?`0
D_nFf?SoT]OfohoCm_nAeoWoUMWloiSJoOnIf?_oVmOioj3Fn_nRf?[oVM7b
oj?JnOn?_=WoAVZ2oe1[O_liBeOo=Ci3ocTm??m0@ccoA4HkoeYLDOmjO77o
PH9jofe^J?mIFEOoEUMBof=SFOm[L6[oCEYSoiJ_`onUb^OoW<k_oigHn_nF
e_WoUMOioiOGnonNfOooV<ofoj3BmOnNcNWoVlSMojC8e_n`a]?oHW5hoeEP
I?m@FESoCE19oeEGC?m8AS[oC4dooeMGBom@E4KoBDm5odA;@olnB3oo?DLo
od9=AOm:E4_oADY3oeULDomXJUgoKfeNog5^GOm]JUOoJFICofMVE?m/KEgo
IVYKoeePEOmHGU;oGf9GofEXGOmaLfSoP81dohf9P?n5Qh;oOHb?ohFS[_nA
_mKoT/g[ohoCm_nAfonmonKViP00ooo^k^i<onk^kP;oM/[i0_mhb_X01?mi
bO[oN/[kogc:n_mlb_X2ogg9nP;oO<Si00ooO<Wgogg:n?mnboWoOlcjoh3=
nomoc?[oP<gkoh?=o?n3c?WoPl[hohO;n_n;cokoRlkkohc?o?n@d?`00onA
dOd0F_n@dO_oSM3johkCn_n<d_KoSM?eoi?HnOnIfo_oVMcioiKIm_nEeoOo
U=WjoiGIo?nGfOcoV=Sloi[Fn_nJeOOoW]ChoioEnOnRg_ooV]Kjoi73i?ld
GGWo@EmgocI;G?lhADko=Cdood15?olo@SWoAdTnoeUKD?mZJf?oKVeXofIU
HOmNGEWoLFiWofQZIomAGVOoRjBjojS<k?nQdoKoW=SloiOGnonBe?OoUM?h
oiW@monMc_KoWlc]oic4g_nTbM_o]=;LofioQom5CU?oBE9AodeDCOm<CdCo
DUA6odE6=_m6AcOoDEA3oe1BA?m=D4GoBDm5odA<@Om0BT7o@Ti4odUCB_ln
ACgoBU16oeeOD_mZJegoKVeKofeZEomZIeKoIVECofIWFOmUJE_oH6=HoeUO
DomMH5GoHVEJofi^I?mkNg7oShb7ohN;S?n2UYgoSK6ooiS<h_nBdo7oSM?e
ohkHoKgok^k^003oooooodcooooo0_mebOP01?mfb?SoMlWiogS9n?mjb?P2
ogc8n@0;oh7=o_mobocoOL[hog_8m_mjaoGoNlSfogg:n?mnboWoPLkloh7;
n_n1boP00_n4cOX01on5c?[oR<cioh_>non=cO_oSlomoi3@o?nAdOd00_n?
d?X0F_n>dO_oS]?lohgEoOn;eO[oSmGioi?HnOnGfOWoUm[goiKIm_nFf?So
UmcmoiKKo?nGfOcoVMOloicFnonNe_WoX=CioikDn?nMgOooTm?ioiW?mOm6
LiCo>5YfocQAIolfAU?o=3m3oci4@_loA3go?d8godE7??mKFe?oL6eXofaX
IOmLF5GoK6URof1RHOmIIG7oRj>koj[@m?nQd_[oUM3hoho@m_nAdOOoVMGj
oi_@n?nTd_KoPj[9oeMgS_m7I7;oAUeSodUGF_m1BTWoBU1<odaBB?m=DD;o
DEA1oe1A?omADT3oC4llode@?om>DTCoBe55odM?A?m1Bd3o@Ti2odI@Aom5
C4CoB4e6oeaNDom_Kf?oLW1Qofm^G?m/JU_oIF=Dof5RE?mWJegoJ6]Pof=Y
GomWJV7oKG1UogYjL?n6QH3oQXJ6ohJ?U_n8XjkoUL3Aoi_GkonBeoKoRM;e
oh_En[gooooo003oonk^kTcok^k^00_oLLGdog;6mOmcaOGoMLGfogW7momj
b?SoO<Siogg9n_n1cOkoP<cmogg:n003og_8mP0<ogc9mommb_SoP/ckoh79
nOn0bOKoQ<_iohG<n_n8c?_oRLcioh_>non>c_coT=3l0_nAdOd02On?d?[o
S/oiohkAnon?e?goSMCnoh_Eo?n?e?_oT]KioiCFn002oi?Em@1AoiGGmonH
f_coUmWloiKHnonJf?goWmWooj;JoonSeocoWmOloi;CnonDeOgoVmGmog:R
b?llH8;o>EA_oc=6EolkB57o>493ocm6?om0@cSo@D<hoeAAB_mWHUkoI5mL
oe9=B_mSH5_oHFEVoeYXMOnAZlCoY/kboiS<m?n@c_OoSm3hohg>m?nFd_Oo
U/[aojcGn_mjW;SoB6=hocmFG_m3DUGo@4Q:odI:BOm4BD?oAD]1odY>?om;
D3coD5<noe=F@Om;CS_oBdhmodY>@?m9C47oATa2od=;@?m2C47o@De3odA>
A_m0Ad3oEEQ?ofa^Hom/KEooJVQIofUWF?mOH5;oGEmBofEXGOmVK6;oI6YP
ofY]I?mbMFcoO7eeohB6POmjOhGoQiNToi2da?nGbn3oU]WdohkIn?n:e?Oo
SMOl0;gok^k^003oonKViTcoi^KV0_mcaO@01_mea_GoM/OfogW7momkbOWo
O/[kogo;o0;oO/Sg00_oOLOfogk8momobOSoP<[iogo<n?n2c?WoPL[goh37
mOn1b?KoQ/[iohS<n@02ohW<n@0>ohc<n_n?co_oTM7moi;Bo_nAd_coSM3j
ohc?nOn?d_coTMCoohkBoon=dOkoSm;loi;CnOnBd_H2oi7Am01Aoi?EmonD
e_WoTmCjoiCEnonHf?koWm_ooj7KoonPf?goV]Cjoi;FoOnCe_ooU<oioi31
j_m@N9co=5=boc16GOljBUOo>dI:oce6@Om0AScoBD]0oeiKE?m^JFGoK69Q
oeaDD_mYJ6?oKWAdoe5QL?nB[LSoW<K/oi;9l_nEe?goTmOnoiCEnonHe?Wo
U/S]ojgEn?m[RJ?o?U=Toc]=DOm5Ce3o>3hnoce1@?lh?COo@TPnodeDA?m=
DSkoCU<moe1C?_m@Dd3oC4lnodM9??m4Acco@dToodA<@Om2C47o?d]1od9;
A_ll@SkoDUE>ofY[Hom[JeooJFYLofY[GOmTIEOoIVQKofY]H_mWKF?oIV]T
ofaaJ_mcMVgoN7Uaog]oO_miPY7oSjRnoi_8gonEdN_oRmKeohWIn_n=f?oo
Sm[o0;goi^KV003oonk^kTcok^k^0_meaoH2ogG6m@04ogS6m_miaoOoO<Si
ogg9nPCoO/Sg0_mobOP03_mnboOoPL_hoh;9mon1b?KoQLWhohS<non:cO[o
RLcioh_;nOn<c?[oSlokoi3@o?nAd_coT=7k0_n=d?X01on>dO_oT=?nohg?
oon<c_ooSlomoi7@nonBd?T00_n@c_<0?_nAdOGoTM;hoi3AnOnAd_[oU=Gm
oiSFoOnJe__oV=;hoi;@monBeOooSM3joi7<n?nHboKoMj79od9SQ_lhD6[o
<dADocI3BOlj@d;oADY3oe]MD_mfLfcoPGUfogU]KOmWGegoKVmZog5kO?m<
GfkoTk;>oig:lOnDcOSoU=GoohcAn_n<d?OoU=3eoi_=l_neg?_oJ8BJod9D
H_liA4Ko?dE3oce1@_lm?cko=S/eod57?Om>E4KoCUE3oe5F@_mBEd?oDUE4
odi@@_m7BCko@TDlod=6?Om4C47o@Ta1od1<@_m5CTWo?dQ5oe1EComVJF3o
K6iS0_m]KF404OmYJekoJfiSofY`I_mYKVOoKG9[ogIkM?miOWOoOh1joh66
ROn4UJWoV;ODoikAk_n@d_;oPm?doh;Fnon8eokoRmSo0;gok^k^003ooooo
odcooooo01SoMLOfogC6mOmea_GoMLKeogS6m?mjaoGoO/Sgogo9n?n2c?_o
PL_joh39m_mnaoCoOLOdogk8mOmobOKoP<[gohC;nOn8c?_oS<olohkAo_n?
cogoS<cjoh_;mon=cOT2oho?n`;oSm3j0on=dOP0FOn=d?_oSlcoohk;oon?
boooTlgmoi?>n_nBcOOoSlgfoho>mon@dOWoSM3johc?nOn=d?[oT=7ioi;B
n?nAcoKoSloeoh_@nOn;c_SoT<gioi_>nOnF`>[oK8jcoe5ZR?m1EVWo?4YC
odMAD_mHGeSoL75Yoh5nMon7OG_oPG=cogAZJOmaLfkoKgYloeM/OOnD]];o
X];joi?@o?n<dO[oQLgeohoDnon@c_?oV/c_ojcCl?mGLXOo@E9LocI0?oln
@cgo@D94oc`m?olh?CWo>T0foci6=om4CC[oATdkodY>?Om=Cd7oCDm2odY;
@om4Ad3o@dHood99@Om1Bd;o?dY2ocm:A_lmATGoAda8oeYME_mXJF7oK6aP
ofYZG_mWJEcoIVUPof=XHOmWK6KoLgYcoh:7POn6RhCoS8f7oi2HVonI[LKo
W/;VoiKAlon9doKoP=GjogkFo_n3e?ooR=Oo0;gooooo003oonk^kTcok^k^
0omia_805Omla_?oO/Seoh7:mon4cO[oQLkkoh7:momob?GoOLKcogc5l_mm
a_?oOlWfoh?=n_n6cocoRLgjohg@oOn@dokoU=Cooi;Bo_n=cOWoRl_gohg=
n@02ohk>nP03ohg=nOn>coWoSM3j00;oS<oi05WoRlkioho=oon>b_ooSl_o
oi7=oonBcocoT<giohk=n?n=c_SoSM3johc?n_n9c_SoR/ghohg>n?n?d?[o
TM3ioi;An_n;c_SoU=Gooi7>n_nIc_[oUlC^oi6gg_mYQZKoIWbCoe][N?m]
N7coOXB2ohJ7P_n8Q87oRX:0ohj4QOn<Qh_oMWf3ofanR_mUOiKoS[GDoj3A
n_n?c?SoS=7kohoHoon=d_WoSLgaoi_@l_n[e?3oDFf2od=EGold?Sgo>Chj
ocXl>olk?Cco@TM3oce2>oli@CCo@DTjocm5=om1ACOoADTkod]=@_m;C4Co
AdQ2od95?_m0ACko@DQ0oci8@?lkAdGo>dE4od97@OmFEdooKfaSogQfJ_md
LVKoLG5Wof]^IomYKVSoL7E_oh>8Q?nBV9CoUI^IoiZPX?nO[KKoYLCQoi[:
l?n?co?oR]KjohWLoon5f_ooQ]Gooh_Ho`2monk^kP00oooVi^I<onKViP0B
oh74k_n3a_3oPlK`oh33kOn3a_3oRlkhohkAo?n:coWoQLWfogo6l_mma?3o
O/Gaoh37lon1b_GoPlcgohO>n_n>c_[oT<oj0onAd?/01On@co[oS/oiohg>
n?n<c?SoSLgi00?oS<oj00goRlkiohW>n?n9c?WoRl_iohg=non<c?[oRl_i
ohk>o?n@dokoSm;mohc?n_n8cOOoRLgj00;oRlkk0_n>c_X0B_n?c_[oS/gi
oi3?n_n@cOWoTL_ioiC:n?nIc?WoV/G_ohj`eOn0VKOoOHjRoh>;V?n;SY?o
U9BFoiBBUOn?SI3oSHf?ohZAVon0TZSoPInkohb_conE`NKoVLgeoiGBo_n>
dogoR]7kohW@n_nAd_SoUloboic:i?m<KH3o<dUDob`j?Olc?3_o>CdlocXo
>om0ACooADY4od97@?lj@3Ko?3lfod95??ln@CSo@D@kodE6@?m6Ad7oADI0
od95??m1A3_o?TDnocY9A_lkBTGo>d0ioe1>@_mfKV?oTXYoog]gK_moO7Go
OWmiog]mN?n5Qh;oUY^Goj2VY_nNZJgoY;:mojK2eonJcNcoT=7gohgCmon8
d_OoQ]7hohSCn_n;eOcoSMGm_OoVi^H00?ook^k^C?o^k^h07?n6a>_oRLW_
ohc:lon;b_?oSlkgoiOHoonJfoooU]WoohW>n?n3b_CoPLSboh;9lon3b_Ko
PlcgohC=n?n7c_[oR/_eohc;m_n=c?OoS/oioho>nOn>coWoSLgioh_>nOn9
bOGoR<_fohW<nOn:cOX2oh_>n`;oRLgj00GoRlkkohg@non<co[oR<ggohW=
nP02oh[>n`03ohO;n?n9cO[oRLgj00;oRlkk037oSLgkohk>o?n?cOcoSlkj
ohg<n?n?c_WoT<okoi3=n_nEcOcoV<_foiBni_n>[m3oT:S2oi:Q]?nGXJgo
W:F^oj2Y/_nOZK;oWZfdoibb`?nH]mCoUK_PoiO1ionHb>koU/gfoi;?non>
dOcoR]7mohS?nOn@dOWoU]7coig<i_m7JWgo=4aFobhm@_lc?3_o=C/gocHk
=Olj?cWo?d@noci3?Oli?SSo>3/docTl=Om2ACkoA4M0odI7@Om7B4;oADHn
00;oA4Dm01;o@DI0ocA3?_ljBDCo?dDkodE3=omRFTooUhj5oiNDSon>T8go
Ri6Aoh^DTonCW9_oWZRYojBa^OnU^<KoY/7Foj?:ionAd?<2oh[Dn@05ohSB
mon8d?KoRM7gohcAn?n=d_T0_Oo^k^h00?ooooooC?ooool03On;b_?oSLkf
oho>nOn?d?[oTmCnoiOJoonJgOooUmcoohS<nOn3b_KoPLSdoh7:mOn1b_L0
0_mobOH03?n2boKoQLSeohS8m?n9bOGoRLcgohc<n?n;c_WoRlkkoh[>non6
bOKoQ/[gohK:n@;oQl_j0_n8c?/01_n9cO[oQ/[gohW=n_n9cO[oR<ciohO;
n0GoQlkj02[oRLgjoh[>non;c__oS<olohk>o?n?co_oQlcfoh_@nOn=d_co
S=3moho?oOnBco_oU/_coiS6j?nG_=WoUKG<oiJaa?nJ]LKoWk[;oinoc_nN
`];oX<KKoj7=j_nNc>koV/c_oiK<l_nBcOGoT<ojohkAo_n>d_ooRLkhoho>
monHc_3oVLGPod1OLolfBUGo<Se1ocDk>olf>cOo=CXfocLl>?lj?c/2oce2
?00KocXl=olf>3?o?T0kocm1??m1A3go@TDnod=4?_m4ACooADI0od=8@_ld
@cko>4M2od98?_m1@COoD4a3ohJ5P?nPY:GoWZV_oiNX/?nJ[[OoWk>loj2h
`_nR_/coY<CIoj?:ionLc_7oT=7g00?oR]Ck00CoR];johWAnOn9dOWoR];j
_Oooool00?ook^k^C?o^k^h00on@dO_oS]7kohc?n@02oh[=m`;oS=7k00ko
R<oioh?:m_mob??oO/Obogk9lomnb?GoNlSdogc6lommaoCoPLSfohC8mon5
bOSoQl_johS<n`;oRLgl00OoQlkjohO;n_n5c?[oQ/[iohC;nOn6b_WoQ<_i
00;oQ/[i00CoQLWhohO;n?n8c?WoQ/gi0_n5c?P01?n7c_[oR<okohO>n_n7
c_X2ohW=nP;oRlkk02?oS/klohg@non6cOOoRM?joh_Doon8dOcoR<okoh_@
n_nAd?_oULoeoiS:jonIa^GoV<COoic8hOnNc>CoWLgToi[=j?nIcn_oU/_[
oiK<k_nEcO3oTlodoi7@nOn@dO_oS]7nohgAo_n?co_oTLofoi[<kon@^]?o
>5EWocI8D_lf?T7o>3`kocHj>@02ocHk=`09ocLl>?ll@Cgo?d@nocm1??lj
?3Oo?T0kocm1??m0@Sgo@4<l00?o@D8l01Ko?T<mocU5@Ole@S_o?D8kodE6
?_m8BD?oGVAToh:AV?nR^<GoX;g=oig0donP`mKoWlGHoig7gonJbNOoU/[a
oi;=mOn<dO[oRM?joh[Dnon;eOcoRm?k0_n:d_X00on;do_ok^k^onk^kP2k
onk^kP00oooVi^I<onKViP05ohkAo?n;d?[oQ/_eoh;7lOn0aNl00_moa_80
2omlaO3oPL[gogk8mOmmaoCoOL[fogg:n?mkbOOoNlSfogc9momnb?OoP<Sh
00;oPLWi017oP/[joh?;non3bo_oPlciohG;o?n3bo_oQ<[koh?;non3bO[o
P/[joh?9n_n4boWoQ/gkohO>o?n8cogoQ/oloh?<n@02oh;;n003ohC=n_n5
c_WoQ/oj00;oQlkj02CoRLgjoh[>non;c__oRm3johO@nOn8do[oR=?mohKA
non5cocoQm3moh_?o?n>coWoT]3goiC>m?nGcoCoUm;doiGAmOn@d??oSM7f
ohgAm?n>c_7oSloboi7AmOnAd_SoSm;lohkAo?n<d?goRlkkoi;AoOnFd?So
X]3dohZ_b_liDfCo>dUBoc]0A?lj?3/2ocHj>@03ocDi>?ld>CGo=S/g00;o
>Slk01co>3diodA6@om4AT7oADM2odA6@Om3AD3o@48moc`n>Olh?COo=D8k
oc=0>Olf>cCo?d@nod16A_le@TSoFgF4oi^oeOnObnCoV<[UoiS;j?nJcnko
Ulo`ohk<lon:cO[oRm;oohO@nOn6d?OoR=;i0_n:e?/2ohSBn@03oh_Eo?oV
i^Koi^KV0;_oi^KV003oonk^kTcok^k^00?oQ<_eoh78l_mnaNl00omka>l0
5OmlaO3oNlK`ogk8mOmjao?oNLKbog[9m?mlb_SoNL[gog_9momlb_[oNlOh
og_7nOmlb?[oO<Siogc8n_mlb?WoO/Siogk8momobO[oP<[ioh79n@02oh;:
nP?oPl_k00_oQ<cloh?<nOn4cO[oQ<kkohC=n_n1boSoP/ciohC>non3c_So
Q<ghohG>n@02ohO>nP?oRLgj00CoRM3johO@nOn7d?_oQ]7k0_n8d?l00on9
d?koR/kmoh_>n`02ohg=n@0:ohc<n?n8cOOoQ/giohK@oOn8dogoRmCgohcB
m?n<d_KoS=7hohcAn`;oS=3m00coSlomoho<nOnHcOGoY=3cogbP^_lmE6Co
>TU@ocXo@_lg>CSo>CdlocLk>_le>CP2oc@h=`0NocDj=_lf>cOo=c`hod12
?om1@d3o@TA1odA6@Om5Ad;o@dE0od12?Olk@S_o=3liocU4??lh?COo>3hj
ocI1@olU>DCoDGB8oiW8i?nEcNkoS<_^ohg=lOnAd_SoS];iohO>n_n3cooo
QmGoohG@n_n4c_GoQLof0_n8d_T00on5coKoQm7hoh_Eo02monk^kP00oooo
oom<ooooo`05og_4komi`^goNL;]ogW3l?mja?400omhaO402Omia_CoM/Cb
ogG3lOmea_?oM/OfogG7m_mfaoKoN<WhogS8n`02og[7n`09og[8nOmia_[o
NLOhog_7nOmkaoSoNlOiogc8nOmobO[oP<[k00;oPL_l00?oP<[koh3:nOn0
b_T00_mnb?L02On0cO_oPlgloh7>o?n1c_[oPm3logo<n?n2c?WoPlgjohK?
o002ohO>o006ohK=non7boSoRm3joh[=n?n:cO[oR/kk0_n<c_l2oh_=o`06
oi3@oon?coooS/knoh_=oon;coooRm7o0_n:e?l05On9do[oR=;gohS@m_n9
c_OoRLkhoh_?o?n=d?goT]7moi3;monGbo?oXLk_ofV;Y?lkDV;o=dI=ocQ1
@?lf>cOo>ShmocDi>_ld>3Wo=SXiocLk>P02ocDi>00LocPl>olg>c[o=c`h
ocXo>olm@Sko@DI2od=8A?m2Ad?o@4I2ocY4??lmAcoo?d@nocU2?ola@4Go
93i=oe^5W_nEbngoRL[bohG<m_n7coOoR<oiohO@non4dOooPM?ooh;Doon7
dOkoQ<gfohC?m`;oQm;j00?oQ<ogohG@n?n:eOd0_Oooool00?ook^k^C?o^
k^h2ogFok00AogK0kOmga?3oN<GaogG4komd`nkoLl;]ogS6m?mdaO;oLlCa
ogC5l_meaoKoM<KeogG7m_mfb?SoN<[logS9o_mibO`00omhb?/01Omkb?co
NlWjog[8nOmlb?[oOLWj00;oO/[k03CoOLWjogg7n?mja_OoPlglogg:n?ml
bOOoOlcjoh3=nomnboWoOL[fogk;mommb_KoOlchoh?=n_n5cocoQ/olohK=
non5c?[oQ/[iohc?o?n<c?SoRl_iohc<n_n<c?coRl_kohc<o?n=cOgoS/kn
ohg<oon<bokoRlgoohc?oon>dOooR]3oohG=oOn;e?goR]Ckoh[Bn_n:coWo
R/kkoh_>non>c_coSlkjoiG>nonIcOCoX<_[oeaoUOlgDEko<dE9oc]6@_ll
@Sko=c/j0_l`=3D02_lf>S_o>CdlocHj>Ole>CSo>3`kocXn?Oli?Cco>Slk
oca1?OloA402od15@@0<ocm4@?m3BT?o?4<lod56@?m0BDSo;d17obA1DomP
SJ[oSLO]ohK;mOn8d_ooR]Go0_n5d?X02on8eOooQ=Kooh7Aoon8eOooQm3i
ohKAnOn9e?coR=?kohG@n?n7d_[oS=Oo0;gok^k^003oonKViTcoi^KV0_mc
`>h00omd`NooM<;`ogG3l@02ogG3l@0;og?4lOmb`o3oM<GbogG6mOmcaOCo
M<KeogK8momgbOSoMLOgogK8n_mdao/00_mea_/04?mgb?goMlWkogS8nomh
b?_oMlOhog_9n_mmbocoO<[kogW7momha_KoNlOhogc:n_mja_OoN/Shogc:
n_mmbo/2ogk<nP04ogg;nOmlb_SoOlgkogo<nP;oP/ci0_n4cOX01?n4boWo
Pl[hohS<nOn:cOX2ohc<n0?oSL_j00?oS/ckoho=o?n>c_h01On>c_h01_n=
d?goRm;loh_Bo?n=d_coSM3kohg@o@;oS/kl01;oSlcioi39m?nLd?OoWL[Y
odY^Q?lkEf?o;d96ocA0??lg@CWo>3hlocPl?Ola=CKo;c<docDi>_lh?3go
>Cdloce1@?li?C`2ocXn?@0Goc/o?_loA43o@TM3od56@_lm@Sko@TU2ocLn
=_m3B4;o?TM6oc=4C?l]BUcoFHRVohk9lOn8co_oR=;oohG@n?n5coKoR=;i
ohKAnOn3d?coQ]Cooh;=mon4coL00_n7d_X01?n5d?SoQ<ogoh?An?n5doZm
onKViP00ooo^k^i<onk^kP;oL[o]0_mb`>h2og?1k`?oL/?`00SoM<Gbog?5
m?mba??oLlGdogG7m_mfb?OoMLOgogG8nP?oM<Ok00SoM/OlogO9nomgao[o
M/KiogO7n?mhb?WoNlWjog[8n@;oNLOg00[oNlWiogc:n_mlb_[oO<[jogg;
nomnc?coOLkmogg>nomocO_oO/cj0_mmboT03On1boSoP/ciohG>non6coco
RM3noh[Aoon8dOkoRM3loh_@n_n<co[oSLgiohc=mon=c?P00_n=cOT3oh_>
n`08ohk>o?n>c_[oT<ojoi3Anon=d?_oRm3joh_>nOn:cOP2ohc<nP0<ohk<
non?c?WoTlcgoiS<lOnJanCoA6YoocUGHOlcB4Wo=dI1ocU3>old>SSo=c/l
0_lc=cP03?lh?3go>CdnocHj>Olh?3_o>CdlocXn?Oll@3oo@4A3od=8A?m2
Ad?o?dA0oca1>`;o?TDm01Ko@DI0oc]5A?lgB53o<4mQoeB2Xon;bO3oQ<_g
ohG?o?n5c_OoQLgcoh_AmOn8d?KoQLkgohOBo?n5d?SoQm;johSCnon7d_[o
Q<ogoh?>m_n1coKoPm7h_Oo^k^h00?ooooooC?ooool4og2nk0;oLKo]00?o
L<7^og72komca?400_mdaO801_mb`o3oL/CcogC6mOmeaoKoM<KfogK8nP?o
MLOi0_mfb?X00omfa_WoMLGfogO7n004ogO7n003ogS8nOmjb__oN/[k00;o
NLWj00?oN/[kog[;n_mjboX00omkc?/03_mha_CoNlWgoh7;n_n3cOcoQ<gj
ohG>non7c_coQm3moh?@o?n2dOcoQM3johG>mon6c_KoR<gd0_n8cOH4ohO>
n00Foh[?n?n<d?OoSm3foi7Amon?co_oRlkkohc<n_n;boWoR/[hoh_;nOn>
c?_oT<gjoiG@n?nCbNgoUlKRoceSM_lbD5[o<4E6ocQ4@?ld?SKo<cTgocLk
?0;o=SXk00Co>ShmocPl>ole>CSo=SXi0_lh?S`06_ll@Sko@dU5odI<B?m1
Ad?o?48noc]2>olk@S[oADa4oci3?OlkADCo>DYBocIEIomBP:7oS<O_oh?8
l_n4cOSoQ/_dohS<lOn=co;oR/kaohO<lon7coOoPlkfoh;?nOn4dO_oPm3j
0_n2coT00on4dO_oQ]?mooooo`2looooo`00ooo^k^i<onk^kPCoKkg[017o
L;k/og6okOm_`>goL<7^og?4lOmdaO;oLlCaog72koma`_7oLlGdogC6mOmc
aOCoMLOgogC6m_meaOSoM<KfogK6n@02ogK6m`07ogG5m_mgaoSoM/KgogG5
m_mfa_OoMlOhogS8n@02ogW9nPGoN<Si00_oN<WhogW:nOmib_WoMlGcog_9
mon4c_goQLonohG>non2boSoP/Wgoh3:m`02ogc=nP03ogk=m_n2cOGoQLof
00;oQloe00[oQ]3gohG@n?n5d?[oQM3johK?n?n8d?SoRm3gohk@lon@d?Ko
S/kj0_n=cO/2ohc<nP0^ohg=non>c_coSlkjoi?>m_nCbN_oUlKRocaRMOl]
BECo;3i2ocI1?Olg?3Ko=c/jocTm?_lg>cco=CTjocPl>olg>c[o=CThocPl
>olh?Sco=S`joc]1?Om4BTKoATa8od16@_lk@Cgo?4<loca3>om4Bd?o?44k
oci8AoleB4oo?5]]oe^9Z_n9a>coPlSboh?<mon5b_?oQ/[_ohc>lOn;cO3o
Ql_bohK>m_n2cOOoPLkhoh;?n@;oPLkh00?oP/oiohCAnon5d_`0_Oo^k^h0
0?ooi^KVC?oVi^H01Om__>[oL;g[og2mjom`_N_oL;k/00;oLKo]00CoL/3^
ogC2l?me`o7oM<;`0_mb`>h00omca?7oM<Gbog?4l`02og?4l`03ogG3m?md
aOCoMlGf00?oN<Kf00CoMlSgogK7m_meaOKoM/Kg0_mgaoP00omhb?WoMlOh
ogW9o002ogS8n`;oN<Si00GoNLWjogW:nOmib_WoO<[jogo=o@02ohG?oP0=
ohC=n_n2boSoP/Wgoh7;n_mmc_goNlglogk=n?n3c_KoQ]3gohWAmon8d_Wo
Qm7hoh?@nP02oh;Ao008oh?@o?n6coSoQlogoh_?m?n=c_KoS<chohc<n_n;
c_/2ohc?o00Koh_>non;c_WoS<ggohg;l_nHc_3oTl3Mod9UNOl]AE7o:cPn
ocXn?Om0@Cco>C/jocXn?Oli?Cco=c/jocPl>olf>SWo=3XhocPn??lg?CWo
=3XfocPn>_m1Ad?o@DY5oca5@?ljA3co?DLo00;o?DLn01?o>D0iod9<Bol`
@d[o@5maof^I^_n7`^[oQ/[gohG>non3b_CoQ<W`ohS<lOn8c??oPl[dohK?
n_n4dO_oPm;koh;An_n0coSoOlcf00;oO/_e00?oOlcfonKVi_oVi^H0^ooV
i^H00?ook^k^C?o^k^h2ofnljP03og2mjoma_^coLKo]00?oLKo]00OoL/3^
og?1komc`NooLKo]og;0k_md`_3oLlCa00?oM<;`00?oM<;bogG3lOmgaOD0
0omha_H00omea_GoM/OfogK6m`04ogK6m`03ogO7n?mfa_WoMlOj00;oMlOj
0_mhb?T2ogS9n0;oOlgm013oPL_jogo9n?mob?GoP<WfohG<n_n7coooP<kn
ogg>oOn1boSoPlceohO<mOn8cOKoQLgeoh?<mOn3d?coP]3n0_n1col01on4
c__oQ/gioh[=mon<cOOoR/[fohW<nOn;c_/00_n;co`03_n9cO[oR<ggoh[;
mOn=bo;oW]Choh6]b_m0H7Go;D1>obXa>Olg=CKo?c/jocDg=_li?Cco>Shm
0_li?C`08?le>CSo<SPfocDk>Olf?3So=C/gocLm>Olm@coo?DI1oc]4?olk
ACgo?TQ0oce7?_ljA3_o>T4jod5;B_laA4_oAFAhogRVaon4`^_oQLcjohC>
oOn2boKoPLSbohC;mOn4boOoP/[joh?@o_n1d?_oPM3ioh3?n?moc_OoP<gg
0omoc?Jmonk^kP00oooooom<ooooo`04offjj?m^^nWoL;g[og6nk0;oL[o]
00?oLKk/og2mjoma_^`00_mc`>h01Omb_ngoL/7/ogC3k_mea>ooLl;]00;o
ML;^00CoML;`ogG2k_mga?;oN<Gc0_mgaO<01?md`_;oM/CdogO8momgb?L2
ogK6m`06ogG7momfb?SoMLGhogG5n?mfa_WoMlOj0omhb?T00omgaoSoO<[j
og_9n@02ogg7mP0[ogo8mOn2bOOoQl_johO=o_n2bokoP<Wloh?7n?n5b?Go
RLWeoh[;mOn6bOCoQ<SgohG=oon2c_ooPLgooh;>oon5c?ooR<cmohc<n_n>
cOWoR/gjohW=n_n:c__oR<okohS?nOn7c_SoQ/ggohS;mOn>c??oWM?gof6=
Z_lfE6co;Si=oblb>olh;cCo?3<doc@d=?lg>c[o>3`kocHj>Ole>SKo<SLc
oc0f<P02ocDk=`03ocHl>?lg@CWo>D<k00;o>dDm0_llASh05_liAC_o?DLn
oc]2>olmAdSo>TaFodQYO?mjZlcoQL;^oh79nOn1cOkoOlcjoh3:mon3cO[o
P<cmogk;oomocoooO<gjogc=n?moc_WoP<ojoh7@non2dO`2oh?@o;gooooo
003oonk^kTcok^k^02CoK;WWoffjj?m`_N_oLKk/og:okOma_^coL;g[ofnl
j_m`_N_oL[o]og?0k_ma_ngoL/3^ogC3k_md`_3oLl;]ogK3lOmg`NkoML;`
ogG2k_mf`o7oMlCbogK4l_me`o?oLKo_ogG3lomgb?OoN<WhogO7n?mfa_Oo
MLOgogS8nOmfa_WoMlOjogW9o?mjb_d2og_;o0;oN/[k017oN/Shog_9nOmm
b_SoPL_johC<o?n6cO_oQl_johG;o?n2bOgoP/Skoh?7n?n5aoOoRl_gohc<
n?n;boWoQl_johC<oP03oh?<o`0NohG<oon9c?ooSLgmohg=non=d?_oS=7k
oh_@n_n9d?[oR<oiohS@n?n8coWoRlofoh[8konHcNooBG:@obm;HOld@E7o
>Ca3od0g>_m1>3Wo=SHfocLk>_le>CSo<CDdoc0e<Ol^=33o<3HbocPn>_le
>cOo>3hj0_li@c/03_ljA3co?4Hnoca6?_lkACco=D4god5;@_ll@Sko=d96
ocmEH_m7Jh7oMJ_=ohC5komna_KoOl_l0_n0b_T01on2cogoP<knog_;o_mn
c_ooPLomoh7@non2co/00on3d?`00on2co_oPLkjonk^kP2lonk^kP00oooV
i^I<onKViP0;offkjOm__N_oKkg[ofbjj?m]^^SoKkcZog:nkomc_o3oL;c]
og6mk_m`_^h00_ma_nl01om``NkoL<7`og72kom`_>goLl3^ogK2lomf`o40
0_mb`?001ome`o?oN<KgogK4mOme`oCoM<;cogK4mOmfa_T00_mhb?/06omg
ao[oNLKjogO4n?mga?SoN/Okog[:nomibO[oN<SiogW9n_mjbo[oO<[jogg9
n_mobOSoP/[joh?;non6c?goQlgnohG=oon4c?coPlWjoh;9mon5bOSoQ/[g
ohO;n_n5c?[oRLooohK>oP02ohG=o@0lohG<n_n4boWoR<ciohg@non8bO?o
RL[boh_<m?n<d?OoRm3gohW>mOn:cOOoSloeoi3:l?nIb^_oBFj9ocMBIol[
>dSo?dA8od91?olf=C7o:bd/oc0f=_le>cWo<CLeobdc<Ol_=C?o<cTeoc<l
=old?CSo>44locQ2>_li@c_o?4HnocY4??lg@CSo>D<jocI2=?lkACco>T10
ocI3C?lgDVGo>VR0oh;3homobNkoP<Wfoh79nOn3b_SoPlcioh3=nOmnc?[o
OL_iogc:n?mmb_KoPlgjohK@oon5cokoP/ckoh3:nOn1bo[oPlgl_OoVi^H0
0?ook^k^C?o^k^h01_m[^NOoK[cZofnmjom^_>[oK[_YofnljP;oL;c]0oma
_Nh00oma_nooL/3`og31l002og72l@08og6okomd`?7oML7bogG1l_mc`O7o
L/3`ogC2lomfa?D3ogC2l`0=ogG3m?mda?OoMLGhogG5n?mda?OoNLKjogW5
nOmhaOWoN/OkogW9n_mhb?WoMlOhogS8n@02ogW:n@0>og_9nOmmbO[oP<[i
oh;:n_n4b__oQ<cloh79nOn0b?SoOlOgoh38n?n3b_SoQLcjohK=non7c_`2
ohC;n@0fohG<n?n6cOWoQlkjohK=nOn8co_oSM;loh_<m_n;b_?oR/_coh[>
mOn9c_OoR<gfohW<m_n=cO?oU<_boiS9j_m<LHco@Umaobi0B_lf@4;o<cDb
ocHg<OlV:RWo:2h^obdc<Ola=cGo=S`jocTo?Olf?c[o<c`goc@m>?lg@3_o
=d4iocY4??m1Bd?o@4Y2oc]5??ljA3Wo>4<eoca6?Olk@4?o=T9>oc5@IOle
Ih;oO<7Pog_9kOn3c?OoP/_hohG9n?n2bOOoO/_gogk=n?moc_OoP<gg0_n4
c_/01_n4c_goPlgloh7;n_mmb_SoNlSfog[7mKgok^k^003oooooodcooooo
00CoJ[KWoffij_m`_>goKk_/0oma^n`01om_^N[oL[c]og:lkOmb_>goLKg^
og:nkoma_nl00_mb`?02og>ol0;oM<3a0_mc`O42ogC2l`04ogG3m?mfa?Go
MlGfogO5mP;oM<Ce0_meaOP01Omia_[oN<GiogW7n?mkbO[oN<Si00;oM/Kg
00GoN<SiogK7m_mgb?OoNLOgog_7n002ogk8n@;oOlOg00CoPl_koh7;n_mo
bOSoOlWh0_n1bOT03_n2boSoPL[goh7:mon1b_OoQ<_iohO>o?n7c_[oQ/gi
ohO>n_n;cocoS<ojohS;m_n5b_CoQ<_e0_n4cOH0:?n4boGoR<ccoi3;lon?
`NCo@fZ7ocUHK?l/@4_o=T53obX_:ol/;RWo724Mob4W9OlY;bgo;cDcobhd
<?l/<Rko;C<_oc4g<olf?3So=cdiocHl>?lj@3coA4]4od=:@olk@S_o=Clf
ocDo=?lkACco>d13ocI2C_l`C6;o>6N3ogZog_mkbNgoPL[eoh7:mon5bOSo
Pl[hogo<n?mncOP2ogo>n@08oh3=nomnboWoO<Wgogc9momoc?[oO/cjogc:
n_miaoNmooooo`00ooo^k^i<onk^kP08ofRdiOm[]nSoKKWZoffij_m_^N[o
LK_/og6ijom`^>X2og2jj`;oLK_/013oL[c]og6mk_ma_NkoLKg^og>ol?mb
_^ooLKg^og:nkomc`O7oM<;bogC2lomc`O;oML?dogK4mOmha_OoMlGf0_md
a?D04?meaOSoM/KiogO4n?mhaOWoNLOhogW9n_mgaoSoMLGfogK6momibO[o
M/OfogO8momjb?SoNlWiogc8nOmnb?T2ogg7mP03oh?=o?n0cO_oP<[i00;o
OlWh00SoP<Shoh39m_mob?GoQ<gjoh?<nOn5c?[oQlklohK=n@;oQ<_g03Wo
Q/gioh_?o_n6b_WoP/Wgoh;;n?n3cO[oP/ggoh;;m_n5b_?oSlgdoi77jomF
PYoo>e]`oc57E?liB4_o;SLbobT^:?lS:BGo9bdYoble<olc>CGo;cDaobX`
;?l^=33o=cdiocHl>?lg?CWo=S`hocY0??m1Ad?o?dHoocHl>?lb>C;o<S`a
ocY1>Oll?dCo=d=?oc1<H_lmK8SoNl3Oogg;komma_7oOlSeohG9n?n5c?[o
P/okogo>nOmmc?OoNl[eogg;nOmib_OoMlSeogS9m_mkc?WoO<gjog_<nomh
b_T0_Oo^k^h00?ooi^KVC?oVi^H01omX]>GoJKGVofVei_mY]NKoKKOXog2j
jomb^^`00_ma^N/2og:jk0;oL[c]0_mc_Nh2og:nk`04og6mk_m`_>goLKg^
og?1l@;oM<;b00?oL/3`og;0lOmc`O800_me`o@2og;2l`0=og?3m?meaOKo
M<CeogC4mOmfa_OoN<SiogO7n?mda_KoMLOgogS:n_mhb_WoNL_jog[;nP02
ogg;n`;oOLWj00KoO<Siogg:n?mlb_SoO<Wgogg:n?mnboT3oh;<n`0<ohG>
non4cO[oQ<_iohG<n_n4boWoP/WgohC8mon5c?[oQLgmoh;:n_mobOSoOlcj
0_n0c_`0;_n1boSoP/WcohS7l?nDc>ooPJk;oeUlT?m4G6So=DM9oc8m=ol`
=boo<3L`ob/b:ol[<Bgo<SPdocPn>_lg?CWo=S`hocLm>Olf?3So>ClkocXo
>oll@Cgo@4E1oca1?Ole>CSo<STboc8l<Olj@CWo?D15oca6D_lcCfGoAGB@
og_0gommbnooOLKaogo8mOn5bO[oQ/cmoh;?non0co[oOLcgogc;m_mmc__o
Nlkjog[=nOmic?P2ogS:n@03ogO9n?mebOOoi^KV0;coi^KV003oonk^kTco
k^k^0_mX]^H01OmW]NGoIk?TofVei_m`^^_oL[c]00;oL[[/0_mc^nd2og>m
kP?oM;k_00GoLKg^og2lkOm`_>goLKg^og;0l002og?1l@05og;0l?mc`O;o
Ll7bogC2lome`o@00_mc`o@02_mda?GoMLGfogC4mOmc`oCoMLGfogO7n?mf
b?SoMLOgogK8n?mhb_X2ogO9n003ogS9n?mib_WoN/Sh00?oN/Sh00KoOL_i
ogc:n?mlb_SoO<[hogk;nOmoc?X2oh3:n@03oh?<nOn1b_OoP/Wg00;oPl[h
01goP/WgohG9n?n6c?goQ<cnoh3:nommbO[oOlgmogk?o_mocO_oOlcjoh?:
m_n6anooSLGXoiO6h_moY;OoHWf8odUKGOm2CdSo@Ta3ocU0>?ld>cCo<STb
oc<j<ole>cOo=3Xfoc8h=?la=c?o<SPdocLm>@02ocTn>P0Aoca0?olh?3_o
=3Pgoc@j=_lh?cOo?4<locm2Aom1BUWo>5AZodmnV_mk`>7oNLO[oh7<m_n2
boSoPlWjoh?;non0cO/00_moc_T02Omnco[oNLchog[=nOmjc_[oNLgiogO;
nOmfb_SoMl_iogS<nP2monk^kP00oooooom<ooooo`09ofVij_mX^>WoIkOX
ofNei_mZ^>WoKk_]og2lkOma^ncoL;[[00;oLK_/0_m`_>d3og6mkP04og:o
kOma_^coLKk/og6nk0CoLKo_00KoM/CdogG3lome`oCoML?dogC4mOmeaOH2
ogC4m@05ogC6m_mcaOGoLlGeogG7momfb?P00_meaoL00omfb?SoM/SgogG7
mP02ogG7mP;oM/Of0_mgb?L2og_<n`;oN/_j0_mlb_X08?mlbOOoNlSfogk8
momnb?OoPLWioh?;non4boWoPl[hohG9n?n6c?goQ<cnoh7:oOmnb__oO/cl
ogc=o?mmboWoOlcjohC=n?n<cOGoS<CWoi_:i_nD^LcoKhZCofYlO?mQK6Co
HVYOoe9IDOm=E4co@dY3ocLn=ola>37o<3L`0olb=c<06olf>cOo=SXiocHj
>Oli?Cco=c/joc@h>Olf?3So>d8joce4?Om1A4WoADiMocmKLOmJRJGoO/?T
ogS6k?n1boSoP/[joh;8non1bOWoO/_iog_<nOmlcO[oOLkkogG7m_mfb_So
N<cjogW=n`02ogS<nP;oNLgk_Oooool00?ook^k^C?o^k^h2ofRlj`06ofRj
j_mW^NWoJKWZoffmk_m__NgoKK_[0_m/^>T01?m]^N[oK;[Zofjjjom^_>`2
ofnkk0CoL[o]0_m`_^h2ofnmk@04ogG3lomd`_;oLl7bog?1lP;oLl?d00So
L/;cog30lOmfb?SoLlGeog;4m?meaoOoMlWiogG7m`;oM<Kf0_mhb_T3ogO9
n01;ogS:nOmib_WoNL_jogK8momeaoKoMlSgogS9n?mlb_[oOL_kogk;nOmm
b_SoOLOfogk8mon1bOWoQ<clohG<n_n3b_SoQ<Sgoh?9n_n6c_ooPlgnogo;
o?mmbo_oO<[jogc:n?moc?SoQ/ohohK5k_n<a>OoV<KPohjaa?mGL7OoKGel
ofYdJom_Mf[oJW9WoeUPF?m1B47o;cH_obhe;_ld>cCo=3Teobld<?lf>cOo
>ChjocLk>_lf>SWo>ShmocPl>olf>S_o=cdkoc]2>_ll@Sko@4=:odQAH_m4
H7SoH96_oh75j?mha^coOLOdogk8mon0b?[oP<[kogg;nOmjboSoN<WfogK9
mOmhb_WoN<cjogW;n_micO_oNL_jogO;nOmfb?OoM<Sf0;gok^k^003oonKV
iTcoi^KV0_mT_>`03omR^>WoGkGVofBhiomZ_>coJk_/ofNgj?m[^NWoK[c/
og2nk_m]_^goKK_[ofZkj_m__NgoL/3`og2mj`03og6nk0;oLKo]00?oLKo_
og;0l?md`_800omd`_84og;2l`;oM<Ke00?oLlGdog73l_ma`o800_mda_D0
1?mcaOCoMlWiogK8n?mda_H2og?5m@07ogC8momhb_[oN<ckog?7m_mebOSo
NL_kog_=o@02ogc=o006ogc:n_mkbOWoP<cmogg9n_mnb?OoOlWh0_n2b_X0
6_n4b__oQ/cmogo5m_mna_KoO/Sgogk;nOn0cO_oPLkjoh;=mon3bo?oQ/C[
oi77jOnHa=goIXNFodeTJ_mIJ6GoJW9Wof9XF_mQJEkoC5I=ocI0>?l/=Rko
;SD^oblf;ol_=C7o;S@`0_le>SH07_lh?3_o?d=2oce1@?l`=3?o<3@eoci4
@_m1B47o>T0lod13B_m:EVKoAVAlofVJ^?mn`^GoN<O^og[7mOmmaoSoP<Sj
ogo9n_mib_WoN<[iogS;momic?SoMlWhogO9nOmhb?WoMlWiogW9n_mibo_o
N/[kog[<o;goi^KV003oonk^kTcok^k^0_mP^nX01_mP^>SoGkOWof6gi_mW
^n[oJ;[ZofJhj0;oJK[Y0_mZ^nX01?mY^^WoJ[_Zof^ljom/_N`2og2mj`;o
LKk/0_ma_nd2og6ok`04og?1lOmd`_;oM<;bogC2lPCoL/;c0omcaO@01Omb
a??oLlGdogG7m_mda_GoLL?b00;oMLOg00CoM<KfogG7momdb?OoMLWh0_mf
b_T01?mdb?OoMLWhogO9nOmgbOT2ogW:n@;oN/Sh00CoO<Siog[6momla_Go
O/Sg0_n1bOT06?n2b_[oQL_loh77n?n1aoSoPLWioh7;n?n2c?WoPlkhoh?<
mOn5b_7oR<K[oi76i_n5[lOoBFUhoceBEom:EU;oIF]QoeiRE?m1BCko=3he
obXd;?lX<R[o;SD^oc0g<0;o<3Hb0_ld>CD05ole>CSo>Shmoc/o?_lc=cKo
<cLhoci4@_lkACgo>T<nod55C_m3Ceoo>5I`oeb?[_mi_n7oNl[aogW7mOmk
aoSoO/Siogc8nOmgbOSoM/[hogK:m_mhb_WoMlWi00CoN<Si00?oNLWjog[:
nomjb_/0_Oo^k^h00?ooooooC?ooool03_mL^>WoGKWZoenjjOmP^>SoHKOX
of>ij_mU^NSoIKOWofVij_mX^>WoIkSWofRij?mY^^WoJ[_Z0_mZ^nP2og2m
j`;oLKk/00CoL;k/og6okOma_ngoLKo]1?mc`O44og;3lP0<og73l_mba??o
LlGdog?5m?mea_GoM/OfogC5m?ma`_7oM<CeogG5m_meaoOoM/Sh0_mebOP2
ogC8m`03ogO;n_mfb_WoM/Sh00;oMLOg00SoM/ShogS8nOmibO[oNlWiogW7
momja_OoO<Sioh3:n`;oOlWj01KoPLWioh36mon0aoGoOlSeogo9m_n0b_Oo
P<_eoh39l_n3ankoS<S]oiC7i_m/U:go<e1Poc95BolmB4CoFeiEodiBA?lb
>C7o:SD]obHa:OlX<b_o;3D`0_l]=S401_l^=c;o=C/gocDk=old>SKo=S`h
ocTm?0;o=SXi00ko?D<oocU4??lkAT3o@TI?oci;FolaDF[oFhj]ogW2homi
bo7oNLOeog_7n?mkaoWoN/SiogK8m`;oLl[g00?oMLWgogO9nOmgbO/00_mg
aoX01?mgaoSoN<SiogS8nOmibOZmooooo`00ooo^k^i<onk^kP0:oe^gj?mN
^>[oGk[Yof6ijOmR^>WoI;OYofBhiomU]nOoJ[[[ofbjj`;oJkWY00CoK;[Z
offkjom]^nWoKK_Y0om`_N/00oma_^coL;k/og2nk002og6ok@;oL/3`0_mc
`O402Oma`_7oL/?bog;3l_mb`o;oL<;aog;4lomda_GoLlGdog?4l`02ogC5
m007og?4lomda?GoM<CeogG5m_meaoOoMLWhogC8m`02og?7mP03ogS<nomg
bo[oMlWi00;oMlWi00KoN<[jog[:nomkbocoOlgmogg;nomkbOT2ogg9nP0F
og_7n?mmaoSoO/Siogo7momob?GoO/Odogk8mOmobOKoOl[doh39l_n3anko
RlO/oi?5i_mEOIKo<4eMoc95C?ljA4?oBDa3oc/n<olb?3?o;STaob/f<0;o
:SD_01co:c@_ob`e<?l_>3?o=S`hocTo>olh?S[o=C/gocPm>Olg?3So>3`k
oce3?olh@c_o>TI2od17ColnBeco=eM`of>H]omman[oLlO/ogO8mOmjb?So
NlWjogS8nOmebOOoLL[fog;9m_mcbOSoM/Wk0omfb?X4ogK8n;gok^k^003o
onKViTcoi^KV00GoGKOYoejhj_mQ^N_oHkW/ofBgj@02ofBfj003ofFej?m/
^^_oKKW[00;oKKWZ00CoK;SYoffij_m^^nWoKkcZ0_m__>P2og2mj`04ofnm
jom`_^coL;k/og2nk0;oL/3^00CoL/3`og?1lOma`_7oLL;a0_mb`o801?m^
`NgoLlKbogK7m_mca?<2og;0l00@ogK4m?mha_KoMlGfogG5m_mda?GoLlGe
og;6mOmcaoKoLLOhog?6n?meb?[oMlWkogS:o?mibogoNL_kog[<o0;oNl_l
00?oOlooog_;o?mhbOP00_mjb?P05_miaoOoNlOhogc8nOn1bOWoP<Shogo9
n?mnboOoOlchoh3=mon3c?OoQ/_dohS6kOn=`^Co@6V5oc1?Hol_@dco=d=3
ocTn>?lb=Bco;STaobXg<?lX=302obPe;P04obTd;_l/=c7o;cXdoc0i=0;o
=d0k01?o<c`gocDk=ole?3Go>3hjoce7?ole@SWo>dM3od99DOllC5co=EM`
of>J^?mla^WoKl;ZogK8momhb?WoNLWjogS:n_mdb_WoL<_h00;oL/[h00?o
LlWjogG8n_meb?X00omdaoT2ogG9n;goi^KV003oonk^kTcok^k^0_mO]nT0
2?mP]^WoIKS/ofJhj_mV]^WoIKGXofRejOm[]nWoK[OZ0_m_]nT2ofjfj006
ofngiom_^NSoKkcXofnlj?m__>[oL;g[0_m__N/2og2nk0;oLKo]0_mb`?02
og72l@;oL/?b00_oK/7]og?6l_mfaoKoL/?bog2nk_ma_nooM/CdogW7momh
a_OoMlGfog?3m002og;4m007og;6mOmaaoSoL/Siog?5momda_SoM/SjogS:
o002ogW;n`06ogW9n_mhb?WoN/[kogO7n?mfaoKoMlSg0_mjb?P05_mkbOWo
O<[joh3:nomobOSoO<Siogc:n?mmboWoO/ghoh;<nOn6boGoRlWbohc0iOm0
JHOo<E1UobXnBOlf@D?o>3diocDj=?l[=S3o9SD`obLc;olY=C42obXg<00G
ob/f<?l]>3;o;3D`oc@m>?lf?c[o=3dhocHm=_le?3Go>3lhocm9@OlgA3_o
?Te8odQAF_loD63o<UI`oefF]?miaNOoLLK]ogK8momgbOWoNLWjogO;n_mc
boT00om`boP2og;:nP?oLLWi00?oLlWjog?9n?mcbOP0_Oo^k^h00?oooooo
C?ooool02_mO]NSoG[7UoejaiOmS]>WoIkO/ofRejomY]NWoK;GZofnfj_m^
]NT2ofjdi`;oKkGX00?oKkGVofjfi_ma^nP00om__>P2ofnmj`?oL;k/00Go
LKo]og6okomb`?3oL<7`og72l@02og;3lP06ofo0kOmb`o3oM<Gbog;3l?mb
`?3oM<;b0_mg`o@03?mgaOKoM/Ceog?3m?mba?CoL/Cfog74m_m`a_OoLLOh
og?5momda_SoMLOiogK8nP;oMlWk00?oM/ShogG7momgbOT00_meaoL06Omh
b_[oN/_jogW:nOmib_WoO<[jogg9n_mlb?WoN/SiogS9n?mib_WoO<[hogg:
n?n1b?CoRl[eoho4k?mDOioo<e=ZobY0C_l`?D?o>d51ocDk=ol^>SKo9cHc
ob@c;_lW=S400_lZ>C@06?l[>37o:SL`oblj=?lc?SSo=T0hocQ2>_li@c_o
=ClgocPo=olnB3oo>TY0od5@Bom:Deco@eATocIJM?mPVKOoN/KXog38k_mc
aoGoM<SgogK8n_mfbO_oL/[hofk;m`;oKlch00KoL<_jofo9nom_b_WoKl[i
og3;n_mbb_X2og?;nkgooooo003oonk^kTcok^k^017oGK;XoeV_h_mK[^;o
H;?WofJgk?mW]ncoJKK/of^gjom`^NkoK[GYof^bi_m]/nKoL;KYog6gj_m`
]^WoK;CTog2jj@03ofnljP?oKkg[0om`_^`00oma_ngoL/3`og31l002og72
l@03og;3l_m``NkoLL;_00;oL/?`00CoML?cogO5mOmf`_?oLl7a0_mfa?D2
og?3m004og;4m_maa?KoLLCfog74mP?oMLOg00?oM/ShogK8n_mfb?X00_me
aoL02_mhb_[oMlWiogS:n_mkcOgoOLkmog_<nomhbOSoN/Shogk<o?mmbo/2
ogW:n@0/ogW9n_mjbo[oO<[jogo9n?n4aoCoS/ObofNE]olcEg7o:TACobTj
@_lh@T?o:S<^obll=OlV=Bko82lZob<b;OlX=cCo:cXgobdi=ol/>3Co=T4k
ocM2>_li@c_o?4Hnoce7?olg@3_o=cdioca5@?lnBd;o?Da9od5>E_m0EFKo
>V9kofNP__mla^WoK/7Yog?6l_mda_GoMLOgogG9n?mabOOoK/_gofk:nOm_
boX2ofk:n`;oK/[i00CoL<_jog7<nomac?_oL/gl_Oo^k^h00?ooi^KV7ooV
i^H01Oo/[JgolWIfooEGEoocKFgoj[Vi02Soi^KV00GoFkGZoeZdj?mK/^Oo
G;?Xof2ej`02of>fjP0:of>eiomT]>OoJ;KWof^ij_m/^>[oJkOYofZfiom^
^>WoL;[[og2lk@;oK[c/00GoKkg[og2mjom^^nWoKK[Vofnlj002og:oj`03
og70jom`_^coKl3]00;oK/7]00?oL<7^og72lOmc`O400_md`_82og?1l@?o
M<;c0omb`_<02?mb`_GoLL?eog73mOma`o?oMLKeogG6lomeaoKoM/Sg0_mf
b_T2ogO:o005og[=oomibogoMlWiogO7n?mjb?P00_mkbOL01_mkb_GoN/Wd
ogS9m?mhbOKoN<WhogS:nP;oN<[l02OoN<Skogc4m_n6a_;oM:cAobQEL_l]
D6?o:dA;ob0b<_l[>S?o:c/^obDg:OlW=Roo9SDboal];_lT<SGo;cXlob`h
>?l_>SCo>D@locI2=_loBd7o>T<nocM0?Ol`>3[o@DU;oci7@_m0C4[o?4mE
oceJJ?lfHg[oKjS6ogk0homi`n[oM/?]ogO6lOmiaoGoMl[fog?9n?m^bOP0
0_mZbOT01_m_bocoK/[iofk:nOm^b_WoKl_jog3<n`;oL<_j_OoVi^H00;co
k^k^00Gol=3@oo`Z:_oiB4SolibLonkYj@1Monk^kP06ooEoOoogKVkom9ZJ
ooQLG?on2P[olZn_9oo^k^h2oeRcj004oeVciomJ]>SoGKCYoejejP;oG[CW
00CoI;KXofJhj_mX^>WoJ;SY0_mZ^>T01_m]^N[oK[[[ofbjjom[^N[oK;[Z
ofjlk0;oL;g[00CoL;gYog:ojoma_^[oLKkZ0_m`_nX01_m_`>goKl;^ofo2
k_m``nooL/3`og?1l@;oM<;b0_mc`O400omd`_?oML?dog;2l`03og;2l`?o
L/;e00GoL/;cogG6lomfao;oMLSdogK9m@02ogG9n0;oMLSj03KoMl[logK9
nomgaoSoMlSgog_9nOmmboWoOlchogk=n?mmc?OoN/_fogW:momib_WoNL_k
ogW;oOmgb_koMlSmogc:non4boWoNKONod5fUOlVCf?o9dMBob@l?_lY?3Ko
:3X/obHh:?lW=bgo8c8_oah/;olS;S;o:cHhobli>_lc?SSo?DTooc]7>om0
C4;o?4E0ocM0?ol^=SWo>T95od16A?m1Bd[o>dmFocUIJ?ldHW[oKJG6ogno
iOml`ngoNL;]ogS5lOmhao;oM/Odog;9m_m^bOH2ofc;n`;oK/[i00CoK/Wh
ofo:nOm`bo[oLLck0_m`boZmonk^kP00_?ooool01OookNgook2`oon[Zooo
7AgoojRX00[ooooo00?oonc/ooomoOooool00_oom?@01_oooooooo7aoooi
nOooo_koonGUooonoPGooooo00?oooCdoooXj?ooool06_ooool00oooiNGo
oogmooooo`0Mooooo`03ooo/k?oooOgooooo00;oooCd1Oooool00oooFU[o
odM7ooooo`03ooooo`03ooodm?ooj>Sooooo00Sooooo00?oong]ooo_kooo
ool01?ooool00oook>coono_ooooo`0>ooooo`04oeJbiOmG/nKoF[CXoe^e
j@;oGKCY00CoG[CWoenej?mV^>[oI[SZ0_mW]nP02?mZ^>WoJkWZoffijom^
^^coJkWZofZhjOm/^>WoKk_/0_m`_N/03?mb_>WoM;k[ofnlj?m`_NWoKkkY
og2oj_m_`>goL<7^og33komaa?3oLKo_og;0l0CoLl7a00?oM<;cogG3m?mb
`_<00omb`_<2og?3m004og?3m_mc`oCoMLKeogK7m0;oMLSd0omdb?L02?mc
aoKoM/[iogG9n?mfa_OoMlSgog_9nOmmboWoOlcj0_moc_T0:?mkc?OoNL[g
ogS9n?mgbOWoMlWkogK9nomfb?[oNlWjoh39m_mm_^KoIYflobEBJOlSAeGo
9d9;obHl>_lU=Rco:3P[obLd:olR;R[o8Bd]ob8/;OlW<C3o<3TfocQ1??m3
CDGo@4Y1ocm9@?lj@cko=Sllobhh=olh@4;o@TI7odE=D?lnD5co=eIZocER
OomZX/OoO;gWogW2kOmh`^l2ogK5l00;og?6l?mba_;oL<Weofo<n?macOco
Kl[iofk9n?m`b?SoLLWiog;:n_mcbo/00_mbb_Zmooooo`00_oo^k^h01Oog
HV;onE5Aonk^k_o^k^konc8b00Coo`0000ooncHfonk^k_oiBd_ooPL7oodH
6?odTI7ooA4AooUADOo^k^konS/kooUCDool8b?ooATIoodC4oob[jl00_o^
k^h02Oo_emOonTE5ooh20_ol823ooADEoo:d]?o^k^konS/kooIfMP06onk^
kP03onoFe_oo003omGin00;ok^k^00?onTA4oo`U9Oo^k^h00_o^k^h02ooj
>c_omWIfonk^k_o^k^kol<C4oo`R8_om71colZf]onk^k_oj>c_omWIf00;o
k^k^00?om9RHoodJ6_o^k^h01Oo^k^h01_ok<33omfi^onk^k_o^k^konS/k
ooIfMP;ok^k^00KomW5aooXn?_o^k^kok^k^oo>XZ?on20P2onk^kP0=ooU;
Boon1`OooAPHooBATOom4A7onE5Aonk^k_o_emOon5IFoo/e=OofLG7om9:B
oodL7002onk^kP09onoGeoojADGooP82oo`P8?om5AGol[Bdonk^k_ok<33o
mfi^00;ok^k^00gokmGEooXk>ooo003ooA0@oodK6oo^inOok^k^oo3<c?ok
<C7ooPd=ooh;2ook=CGol<g=00;ok^k^00KonS/kooIfM_o^k^kok^k^ooBH
V?om6QX5onk^kP04oeB`homF/^GoFkGYoebfjP;oG[GZ00CoH;KYof6gj_mV
^N_oI[SZ0_mV]^L01omY]nSoJkWZoffijom^^^coK[c]ofbjjom]^NX00_m_
^n`00om^^nWoL;[Yog:lj@02ofnlj009og2mjOm__^WoL;k/ofo0kOm``Nko
LL;_og2nk_ma_nooL/3`00?oLl7a00?oM<;cogG3m?mb`_<00_mb`_<3og?3
m008ogC4momda?GoM<GdogC5l_mdao?oM<KeogC8m_mdb?L2og?7mP0hogO;
n_mgbOWoMlOhogO8momjb?SoNlWgogc9momkbOOoO<gjog[;n?mhbOKoM/Of
ogG7m_meaoOoM<OiogG7momfaoKoNL?`ogk1joml]mWo>FR4obA:GolS@e;o
93e2oaha;OlV=Rco9C8[ob<`:OlX<boo9Rl/obD^:Ol]=S7o>T4jodA>A_m0
BT;o>D<kocI0>?lc?SSo<chjoci7A?m4B4WoB4mEod9DH_lhEfco>FJ7ofRR
b_mg^^OoMKo^ogG2l?mca?7oM<Gbog?6l?mbao3oLLScog3;momac?T2og38
n0;oLLOh00CoLlWjogC:nomeb?[oLlWj_Oo^k^h00;ooi^KV00KolGaloo/M
7OoVi^Koi^KVooT`<?ocJ6P4onKViP06on^b/_on0`?ojLO7onS?coofDU;o
o@l?0_oVi^H04Ooh>CWon3`lonOGeooVh^;olW1`oodA4OoWfm_oi^KVooPm
?Ooh>CWojLW9onKVi_oWfm_oim[JonKVi_oh>CWolW9b00Koi^KV00Sokhj>
ood=3Ooi<c?oi^KVonKOgoon2@Woo@d=onZo_`;oi^KV00Oon3Tioo9bL_oV
i^Koi^KVoo=UIOoh>S[oi^GU00;oi^KV00Kon3Tioo9bL_oVi^Koi^KVonnC
Tool6AT6onKViP06ooT^;_ocJV[oi^KVonKVi_oh>CWolW9b0_oVi^H03Ooc
KVkon3`lonKVi_oVi^KokJ:Rooh82?oVi^Kojk:booh30ooYalOoj<o?ooIB
D_om3`l00_oVi^H01_ogADGonRTYonnBT_obKfoonRPXoodB4P;oi^KV00Wo
n3dmooPi>OoYbLWoi^KVonOKfooWf][oi^KVooT^;_ocJVX00_oVi^H02Ooh
>c_onRLWon^g]ooVi^KojL;2onKTi?oViNGonBh^ooI9B@02onOFeP06ooI<
C?oi;booi^GUonKVi_oh>CWolW9b0_oVi^H00oo_Ti?oo1TIonKViP04onKV
iP0:oeB`homG/nKoFkGYoebfj_mN]^SoGKGWoenej?mP]^WoIKSZofBgj@;o
I;KX00ooIkOXofVij_m/^^_oK;[[og2lk_m^^^coKKW[ofjjjom`^^_oK[SW
ofnij?ma^n[oL[cYog2mjOm`_N/00_m__N/01Om^_ncoKl3_ofo0kom`_^ko
LKo_00?oL/3`00CoLl7aogC2l_me`o?oLL7b0omb`_<2og?3m0;oM<Ce00?o
LlCcog?4lOmcaO@00_mda_D01OmeaoKoM<SgogC8momibo_oN<[j00CoN<Wh
03CoN/SfogW7mOmjboSoNL[iogO8momfaoKoMLOfogK8momebOSoM/ShogO8
momf`o7oOLC^oh?1j?mISZko;5Qcoam3FolS?dgo730aob<b;OlS<2Wo9S</
oblj<_l/=Rgo9bhVob`c:ole>SCo@TU2odA;A?li@c_o>48joc8m=Ole@3So
@D]3odE6B?m;CeSoAEEUocUGKom1KI3oJjC?ogNkj_mc_o3oM<;bog;4lomd
ao?oM<Oaog?8lOm`b?3oLLWaog78mOmaaoKoLLOh0_mca_P2ogG8nP03ogK8
n_mdaoWoi^KV0;coi^KV002oonk^kP06ooF0P?ol71cok^k^onk^k_ok<S;o
mfa/1?o^k^h01_o`b/[ooP82oo:`/?o^k^kom9BDoo`M7@;ok^k^00[onS/k
ooIfM_o^k^kok^k^onoGeooo003olj6Qoo3>c_oo003olZ^[1Oo^k^h00ooj
>c_omWIfonk^kP05onk^kP08ooU?CoogJf_ooAXJonoHf?ob/;3oo1hNooMV
I_ofN7P2onk^kP06ooXk>oofMWKok^k^onk^k_oiAdOomfYZ0oo^k^h01_oj
>c_omWIfonk^k_o^k^kom9RHoodJ6PKok^k^00Konc0`ooM^K_o^k^kok^k^
ooXk>oofMWH2onk^kP0AooIaLOoj?Skok^k^onk^k_ocZ:SooPP8onk^k_o`
b/[ooP82oo:`/?o^k^kom9BDoo`M7Oo^k^kok^GUooh82?ob[:`00_o^k^h0
1_oeS8coo@l?onk^k_o`c/koo`00oo:[Z`Gok^k^00Konc0`ooM^K_o^k^ko
l<g=ool00?oeRh/4onk^kP03oo39bOoo003olZZZ00;ok^k^00KolZZZool0
0?o`cLgok^k^ooXk>oofMWH2onk^kP03ooBHV?om6Q[ok^k^00Cok^k^00Co
E[;UoeNci_mJ]>SoF[CX0_mK/nD2oe^ai0;oHkKX0_mT]^P01OmV]^OoIkOX
ofZhjOm[^N[oK[[/00;oK;SZ00GoKKW[ofnij_m_^N[oL;[Yog:lj`02og>m
jP;oL;g[0_m__N/01?m`_^koK[o^og2nk_ma_nl4og;0l004og?1lOmd`_;o
LL7bog71lPCoL/;c0_mc`o@01?mb`o;oLlCaog?5m?mda_D2ogG7mP;oM<Sg
0_mgbOT02?mgb?OoN<WhogW:nOmjbo[oO<[hog_9nOmjbo[oNLWj0_mgb?L0
;Omfb?OoMlWhogK:n?mfb_SoMlWhogC2l?mma_?oOL3Zog>]dom0LYGo7dYZ
oam2F?lO<cco8C4aob8a;_lZ=c3o<Cdcoc4i;?l]<bOo;C<Yobld;Olm@Sco
ADY6ocm5@Om0BT;o=40focA2=OloBD3o@dE4odY=E?m5EFCo>EM_odMeUom_
Z]CoNKo`ogG3m?ma`o?oL/CdogC6mOmdao7oL/O`og;7k_mbao3oL/KbogC8
m`03og?6n004ogG7nOmfb?[oMLOiogG7nKgok^k^002oooooo`06oon:R_oo
7aoooooooooooooo=SKoogAd1Oooool01Ooo[Jgooc8boolc<ooo=SKoob0P
00;ooooo00?ood10oomoOoooool00_ooool01Ooo5QKooi6Aoonn__oo003o
ocdm00?ooclo00CoolC4oooooooo@43oogmo1Oooool02Ooono_oo`l?oonm
_OooJ6SooiZJoomgMoooIVKool30ool];@02ooooo`06oom0@?ooOgoooooo
ooooooooCDgoog9b0oooool01_oo@43oogmooooooooooooooj>SoolL70Ko
oooo00Kooc@doomfM_oooooooooooom0@?ooOgl2ooooo`06oomjN_oo@d?o
oooooooooooo];Coo`T90_ooool02Ooo[Jgooc8boolc<ooo=SKoob0Poooo
oooo`/;oo`00oooViP02ooooo`06oon/[?oo4A7ooooooonn__oo003oocdm
0ooo?cl02?ooa<Cooooooold=?ooMWKooooooonn__oo003oolk>1?ooool0
0ooo_[koo`00oooViP02ooooo`06oooTi?oo003ool71oooooooo@43oogmo
0_ooool00oooXj?ooa`Looooo`04ooooo`;oEk?V00CoE[;SoeNci?mI/nGo
F[CV0_mK/nD01?mN]>GoH;KWof>fj?mT]nT2ofBfj006ofNgj?mY^N[oK;W]
ofZgjom[]nWoK;SZ0_m_^NX01?ma^n[oLkg/og>mk?mb_>/3og2mj`05ofnm
jom__NgoL;k^og2nk?ma_nd00_mb`>h2og6ok`04og;0l?mc`O7oLL;aog72
l@CoLL7b0_mb`_<01?mca??oM<Gdog?5m?mda_D5ogG7mP04ogC6mOmfaoKo
MlSgogS9n0;oNL[i02coN<WhogW9o?mhb?_oMlOhogO8momhbOSoMl[fogG9
mOmebOOoM/[hog;3l_mkb?KoMkkZogbki_mOU[oo;f28ob=:JOlS?Dko8S<j
ob<c<olZ>CCo;SX^oc0h:Olb>2[o=3L/oblb:oli>cSo@TI5od57AOm8DDco
>4@jocM5=_m0C3koATM2oda@Dom5EF;o=UEZod]iV_m_[MKoNL7aog?3m?ma
a?KoLLGdog?5m0;oL/G_00GoL/G]og?6k_mcb?7oMLWhogC7n@02og?6n0;o
M<Oi0_mca_Rmooooo`00_oo^k^h01_oeP83oo1`Lonk^k_o^k^konc8booM/
K0Ook^k^00?ok^c/ooF:R_ol7Qh00_o^k^h04Ooj>c_omW5aonk^k_o^k^ko
kmgMool00?ob][Kol<c<ool00?ocWioolL71oo6i^Oon0P;okmGEonk^k_oj
>c_omWIf00Gok^k^00gol[Jfooh;2oo^j>SolZVYooY6A_ok;BgolijNonk/
k?om51Col<_;onk^k_oj>c_omWIf00;ok^k^00?onDM7ooMZJ_o^k^h00_o^
k^h01_oj>c_on5IFonk^k_o^k^kom9:BoodK6`Kok^k^00Konc0`ooM^K_o^
k^kok^k^ooXk>oogIFD2onk^kP06ooI`L?ok;book^g]onk^k_ocYjOooPP8
1?o^k^h01oo^k>comHZ:oo`N7_o^k^kol<_;ool00?obZ:P00_o^k^h04Ooc
X:3oo@l?onk^k_o`c<coo`00oo>OWooa`L7olKViooh20_o_eMGok^k^oo/`
<?ogKVkok^k^oo3<c?oo003omHN700Cok^k^00?ol<g=ool00?ocZ:P00_o^
k^h01_ocYZKoo`00oo3AdOo^k^konS/kooQFEP;ok^k^00?om9:BoodK6oo^
k^h01?o^k^h01_mF/^GoEK7ToeFah_mG/nCoFkGWoefgj@;oGkOY00CoGK?T
oenei_mT]nWoI;OY0_mS]NL01_mU]nOoJ;SYoffjk_m[^>coJkOYofbhjP;o
K[SY00KoKkWXog:ljomb_>_oL[c[og2mjom__>X2og2mj`;oL;k^0_ma_nd2
og;0kP;oLKo_0_mb`?02og72l@KoLL7b00?oM<GdogG6mOmda_D00_meaoH3
ogC6m@;oLlGd0_mdaO@2ogK7mP06ogG6mOmda?GoN<SkogO7o?mfa_WoMlSg
0_mgb?D0<_mdao?oL/KbogO;nOmba??oNlckogO1l?mn`?3oM[?Pod5gYOlY
EWgo9dEMob4gA?lS=Sco:CThobPe:ol/=bWo=S`^ocTl<Ola<Rco=CLdocm1
@?loAD?oBeA?oc]8?_ljBc_oAE91odU<@om>DU7oA5MNoc=DIOm9NYSoKZkD
ogK0kOm``_;oL/Keofo5m?maaO?oLLC`og33kOmbaNgoM<OaogK9mOmebOSo
L/Siog?6n?maaoSoM<Oiog;8nOmca_SoL<Kg_Oo^k^h00;ooi^KV00KolGal
oo/K6ooVi^Koi^KVooT`<?ocJ6P5onKViP05onfRX_oYa<Coi^?SooEGEoof
Bd/00_oVi^H03Ooh>CWoo1PHoo28R?oYa/Kom5iNood?3ooVhn?oi^KVooPh
>?odH63oi]kNonn>S_oj9RH00_oVi^H00ooh>CWolW9bonKViP04onKViP0J
oo=]KOogADGoi^KVonKOgoom413ooP82onOEeOoVi^KomEaLoo5hN?oVi^Ko
n3Tioo9bL_oVi^Koi^3PooM1@OodHV;oimcLonKRh_oVi^Kon3TioodB4_oc
JV[ojLS8ooI>C_ogADD6onKViP0>ooT^;_ocJV[oi^KVonKVi_oh>CWoo18B
oo5nO_oXdM7on3Phoo/K6ooeEUKoj<_;oo=UIOoj;Rh2onKViP05onfRX_oY
a<Coi^?SooEGEoofBd/00_oVi^H01_oi=CGon3loonS;booWfMWomTe=ood?
3`;oi^KV00Gon3PhooAPH?oVg]kokhj>ooXV9P02onKViP09ooT^;_ocJV[o
i^KVonKVi_oh>3Sonb<Sonb[ZooViNGojLS800;oi^KV00Kon3XjooM0@?oY
b<SojLO7ooQ0@?oh?Cd2onKViP06ooPi>Oom4Q;olfYZonW8b?ofCTkomdE5
1OoVi^H05omE/N;oFKGVoeZfiomG/nCoF;;Toe^eiomL]>KoF;3Rof2fiomO
]NKoG[CUoenei_mT]nWoI[W[ofFhj_mV^>[oI[KYofZgjom/^^_oJkWZofZf
iom[]nSoKkWX00;oL[c[00goLK_ZofjkjOm`_N_oL;c]ofnkk?m^_>coL;k^
ofjlj_m__N_oL;k/og6okOmb`>koLl7_00;oLl7a00GoKl3_og72lOmb`o;o
LL;aog;2l`02og?3m004og71l_mcaOCoLlGdogC5m0;oLlCc00GoM<GdogG6
mOmgb?OoLlCcogG6m@02ogG7mP;oM<Ke03[oMLOfogO9nOmea__oMLKkogO7
n_mgb?OoMlSeogO8lomeb?;oLlOcogG9momba_CoMlWiogc:nome_NooNK_]
ofRVeoleJ9?o:4eZob=0D_lP>dKo9S/nobDf<?lV=2Oo;ST[ocLm<olj?3Oo
=CLdocLi>?m3BDOoCEIAodMDB_loD43oAE=2od=9?Om1Bd?o@5EHocYNJ_mR
UZkoN;[Log6oi_maaO7oK/Ccofo5m?maaO?oLlKbogC5l_mdaO3oLlCaog;5
lOmaaoKoLLWiog?9n_mabOWoLLOhofo7momaaoSoLLWi_OoVi^H00;ook^k^
00KomH20oo`L7?o^k^kok^k^oo/b<_ogK6`5onk^kP05ooF0P?ok;Rkoo@h>
oo/e=Ooa][H00_o^k^h01_oj>c_omW=cooQNG_on30cooALGoo>LW0;ok^k^
00GokmKFooY2@_on30cooAXJoo:ZZP02onk^kP03ooXk>oofMWKok^k^00Co
k^k^00KonTE5ooBCToo^k^kok^k^ooQJF_oj@402onk^kP0Boo:`/?oiAdOo
k^k^ooU>C_oePh?ok^k^ooIfM_on1`OooP/;oodI6OocXZ;ok^k^ooXk>oof
MGGomW1`oodB4_ok:R[olKJf1_o^k^h03_ok<33omfi^onk^k_o^k^konDi>
ooF1POogJFWoo@h>oo`U9Oo`a/Kom8n?oodH6?ol7Agolj6Q0_o^k^h01Ooe
P83onbh^ood>3_ok=CGolKJf00;ok^k^00Kokm?CooXo?oon2P[oo2HVooM^
K_ol9bL2onk^kP05onoFe_oj@T;ooP`<oodJ6_obZZX00_o^k^h02Ook<33o
mfi^onk^k_o^k^kokmSHooUADOon3PkooPX:oo`S8`02onk^kP06onoHf?oi
C4cooPh>ooh>3_oiCTkokmWI0_o^k^h01_oiCTkomH:2ooI`L?om4Q;onbXZ
oo6f]PGok^k^00WoDjoPoeNci?mG/nCoE;3QoeJ`h_mJ]>KoGKGWoeVahomO
]NH00_mP]^L01omQ]nSoHkKXofBgjOmU^>[oI[W[ofRhjomZ]n/00_mZ^>T0
2?m[]nWoK;SYofnij_m_^NSoL;[Yofjhiom]^^SoL;g[0_ma_Nh00oma_noo
Ll7aofnmj`02og2nk003og6okOmb`>koL/3^00;oL/3`00GoKl3_og72lOma
`_7oL<7`og71lP02og;2l`03og71l_m``_7oL/Cc00;oMLKe0omdaO@2ogG6
m@03ogK7m_meaoKoMLOf00;oMLOf02[oM/SgogO9nOmea__oMLKkogO7n_mg
b?OoMlSeogO8lomfbO?oMLWeogC8m_maaoKoMLSjogS8nomf`_CoO/Khog^n
l_mJUL7o>6B7obQ<I_lL?Dko7ca4ob@j>?lY>S;o;cXboc4h<?l^<2_o=SPe
od55A?m<DU3oBU=@oc]8?olc@cKo?4dmodUCB?m6Ddco@5YKocYRK?mTVk3o
NKkMog?1iom_a>d2ofo6l`03og;6l_mdao?oMLKc00;oMLKc00GoM<Keog77
m_m`b?SoLLWiog38n003ofo7m`03og38n?o^k^kok^k^0;_ok^k^002ooooo
o`06oon:R_oo7aoooooooooooooo=SKoogAd1oooool00ooooOgooooooooo
o`02ooooo`04oom0@?ooOgooooooooomo@Kooooo00?oooclooooooooool0
0_ooool00ooo@43oogmoooooo`0Cooooo`03oom=COooLW;ooooo00;ooooo
00Cood10oomoOoooooooookn2?ooool00ooo=3CoogIfooooo`04ooooo`03
ooono_oooooooooo00;ooooo00?oooknooooooooool00oooool00ooooOgo
ooooooooo`04ooooo`03ooomoOoooooooooo00Gooooo00?ooocloooooooo
ool00_ooool00ooo=3CoogIfooooo`04ooooo`03ooolo?oooooooooo00?o
oooo0_ooo_h7ooooo`03ooono_oooooooooo00Gooooo00[oDZkOoeFah_mD
/>7oDZkOoe>_h?mG/nCoF[CVoeVciOmK/n?oGKGU0_mP]^L2oeneiP03of6g
j?mU^>[oI[SZ00;oI[KY00WoJ;SYofbjjom]^n_oKKWZofbhjOm]^^SoK;WW
offij_m`_>d00_m`_^h01?m`_^ooL/3`og2nk?m`_^`2og6ok@;oL/3^0_ma
_nd00om_`>ooL<7`og31l002ofo0k`0=og72lOmb`o;oLL;aofk0l?ma`o?o
M/OfogO8momea_GoLlCcogG3lOmfa?;oMlSeogK7m002ogG7mP;oM/Sg03?o
MLWhogC7nOmdao_oMLKkogK6nOmfaoKoNLOeogS9m_mgb_KoMl_gogC8m_me
bo[oL/SiogC7nOmc`oCoNLGfogo7nOme]N?oDXR^ocMTPolNAUoo6Ce=oall
@_lW?3go:STfobPa;?lY;R[o=c`hodU=C?mAEeGoAe9>oc=0>Ol[>S?o=THl
ocI3??loDTkoAV=Wod=_O?mTW[KoLk[Jofnoi?m_a>goKlKaog37l_mcao?o
MLSbogK7m?mgb?GoM/SgogG9n?m`b?P01Om]b?L00om_aoOoK/Kfooooo`2l
ooooo`00_oo^k^h01_oeP83oo1`Lonk^k_o^k^konc8booM/K0cok^k^00?o
nS/kooIfM_o^k^h03?o^k^h00ooj>c_omWIfonk^kP0?onk^kP06ooQDE?oe
R8Sok^k^onk^k_o`dM7ol<o?0oo^k^h00ooj>c_omWIfonk^kP09onk^kP03
oo/`<?ogKVkok^k^02?ok^k^00?onc0`ooM^K_o^k^h06oo^k^h02omA[Mko
DjoPoe>_h?mB[]ooDjoPoeNci?mI/nGoF;;ToeVahOmJ/^;oGK?T00;oG[CU
00WoGkGVof2fiomR^>WoHKCVof>eiomU]NSoJ;S[ofbjjom]^n`00_m^^^/0
0om^^nWoKK[Xofjjj`02ofnmk@03offkjom]^ncoK[c/00;oL;k/0_ma_nd4
og;0kP03og31l?ma`_7oL<7`00;oKl3_00GoL/?bog?4lomb`o;oKKo_og73
l`02ogK7mP0<ogC5m?mb`o;oML?aogK4l_mgb?GoMLKcog?5m?mda_GoM/Sg
ogG9momdb?OoL/Gg0_mdao/09_meaOSoMLKeogS6m_miaoGoN<WfogO9n?mb
a_GoMlglog;8nOmdaoWoM<Kfog31l?mf`_?oN;o[off[e?m?QJWo;f1nob9<
I?lP@E;o9Ce7obTk?olZ=SKo>d4oodE:A_m>DdooDeUGod]FD_lhAdCo<D4n
ocU9B?loDE7o@EUMoc]MIoliJ7[oHIjjog>lgOmea>_oL/G_0_mba_803_md
ao7oMLSbogK7m?mfaoCoMLOfogC8mom`b?SoKLSgofk6m_m/aoKoKlOgog38
n?m_aoOoKLGe_Oo^k^h00;ooi^KV00Koj[blonjFU_oVi^Koi^KVonfNW_o[
];@<onKViP03ooPi>OobLW;oi^KV00coi^KV00?on3Tioo9bL_oVi^H03ooV
i^H00oo]XZ;oj[RhonKViP06onKViP03ooPi>OobLW;oi^KV00Woi^KV00?o
kIfMon^e]OoVi^H08ooVi^H00oo]WIgojkFeonKViP0KonKViP08odn^g?mA
/=koE;3OoeB`gomE/N3oE[;QoeNbhOmF/N02oeNah`0:oeZbi?mL]>KoGkOY
of2hj_mQ]n[oH;KYof2ciomR]NWoI[SZofNij`;oJ;SY00?oJkWYoffkjom^
_>`00_m/^^X2offkj`07ofVjjOmY^N[oJ[_Zofjlj_m__^WoL;k/og6ok@02
og;0kP;oLl7_00?oL<7^og;3l?ma`_400_m``O002_mb`o;oLlCcog?4lom_
`O7oLL?cogC4mOmdaOCoM<;bogC2l?me`o42ogO5l`07ogC5l_mbaO7oLlGd
ogC8m_mdb?OoL/Keofk4m@02ogC7n`0bogG5n?mea_GoMlGeogO5lomfaoKo
MLOfog75m?mhc?_oLLOhogC:nomhc?_oL/CcogG6lOmjao7oO<?]ofNVcom<
QZ_o>FZ:obeBK?l/BE_o=TUGoce:D?mAFE_oF5iJoe]QGOmJHekoDeeLod=A
DOllBdko?e9HodIJIOm8HgCo@fV0odEfU?mWY/WoLKWQogC3k_mbaO7oLlKb
ogC7lomdao7oMLO_ogG6lOmea_?oLlGdog;6mOmbb?WoKlOgofo5m_m_aoL2
og77n003og36mom_aOKoi^KV0;coi^KV003Aonk^kP03onkZj_o^k>cok^k^
00cok^k^00?ok^[Zonk/k?o^k^h06?o^k^h00oo^j^[ok^c/onk^kP1=onk^
kP03oe2_gOmA/=koEK7P00?oE[;Q01?oE[7PoeF`gomI/nGoF;;ToeZbi?mM
]NOoH;SZof6ijomQ]n[oGkGXof:ejOmU^>coJ;[/ofNijomV]^OoIKGVofRf
i_m[^NWoK;[Z00;oJ[SX00[oK;[ZofZkj_mZ^n[oJk_/offnkOm^_>[oKkkY
og2nk?ma_ngoL/3^0omc`Nl01Om``NkoL/?`og;3l_m``O3oLL;a00;oLlCc
00[oL/?bog73loma`o?oL/;cog72lOmc`O7oM<;`ogK4l_mgaO?oML?a0_mc
a?40;omca_;oLlOfog?7m_m`a_GoK/CeogC7nomdaoWoMLOiogG5m_mgaOGo
MlGcogO5mOmea_GoMLOgogO;n_m_aOKoM<[iogW=nomcao?oM/Waog[<m?ml
bOGoLK[UofJUd?mER[;o@Vf?ocmNN_m9H7;oE69]oeeWJOmWKFWoJG1YofE^
JOmJI6?oB5IGod5@Eom4EfGoA5Yaod=RO_lmIXKoB7bSoff/eom`^NKoL/3`
og73l_mca_;oM<Oa00;oMLO_00KoM<G`og?6l?maaO?oLLGdog?6n?m`a_L5
og;5m`03og74m_o^k^kok^k^0;_ok^k^003oooooodcooooo0_mA/=h01?mC
[mkoE;3OoeFah?mE/N02oeJah004oeRbi?mI/nGoG;CVoefei`;oG[KX00Ko
GKGWoebdi_mQ]n[oH[S[ofFhj_mT]nT2ofBfiP03ofNhiomX^NSoJ[_Z00;o
J;WX00WoJK[YofZjjom[^ncoK;k^og31l?m__N_oKkkYog2oj_ma`>/01?mb
`>h00om_`>goLL;_og72l@02og72l@;oLlCc00OoLL;aog;4m?ma`oGoL<3a
og31l?mc`O7oML?a00;oM/G`00KoLl;]og?4komea_?oM<Ocog?7m_mba_D2
og36m`04og;8nomdaoWoM/SjogO7n0?oNLOg02_oMlSgogO9nOmgb_coL<Ke
ogG;n_mec?OoL/O`ogK:komdanooMLSdog?1kome^NSoK:OCoef:/omFN9_o
Fg>;of5cPOmVLG?oKGIaofihKom/MVkoHfe/oe=QI?m:F6?oBUa`oe9[R_ln
H8Ko:EAoocmcX_mb/NCoNL3dogW6n_mba?CoM<GdogC5l?mfaNkoMLO]ogG7
komca_3oL/Kdog75m?maa?KoL/Gg00;oLlGg00CoL/Cfog73mOmba?KoL/Cf
_Oooool00?ook^k^C?o^k^h02_mA/=koD:oMoe:^gOmB[]goDjoNoeB`gomF
/N3oF;?RoeJ`h_mH/^@2oebdiP0:oeZbi?mH/>;oF;3RoeVahomP]^WoGkGX
of6di_mR]NOoIKOWofNij@;oJK[Y00CoKKk]ofZkj_mY^^WoJ[_Z0_m[^n`0
1?m]_nooL<;aog2nk?m`_nX2og70j`;oL/3^0_ma_nd01Om^_ncoL<7^og72
lOm``O3oLL;a00;oL/?b01GoL<7`og;4m_m``_CoKko`og31l?me`o?oM/Cb
ogG4komd`nkoLl;]og?4komfaoCoMLSdog?7m_mba_GoLLOhog;8nOmbb?_o
M<OiogK8n_mhb?T00_mlb?T0<_mkbOWoN<WhogG7nOmdaoWoLLOfogS?o?mf
cOSoL/[`ogS<lOmba^_oM<SfogK7m_mmaOOoO;[Yog:QcOmZS[;oJ8:MofQj
R?m_OH3oLWegofmiL?m^NG7oKWQgof9_MOmHIW?oDfEmocE?L_m2I97oCWRX
ofRMcon3`_SoK[O/og2mlomfb?[oLlCcogC5l?mfaNkoMLO]ogG7komcb?7o
LlOcog78mOma`oGoL/Cfog?5momba?KoL/;eog71m?mb`_GoLl?f_Oo^k^h0
0?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooooooo
P_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^
k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^
003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooo
oh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooo
oon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?oo
k^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^
k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003o
onk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;o
k^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^kS3ok^k^00?oTi>Cok6a/Oo^k^h0ooo^k^i?onk^kP00oooo
ool`ooooo`03od10@?moOgoooooo017ooooo00GogmoOobd];Om>CTkoZ:RX
oo[jnP3oooooocWooooo003oonk^kQWok^k^00?ok>c/olg=cOoFe]H05?o^
k^h01Olk>c_oMWIfong]kOoEeMGokNg]00Wok^k^00?ohn?SomSHf?o^k^h0
0oo^k^h01OoMgMgoY:BToinOWolK6a_oW9bL00[ok^k^00?og=cLonc/k?o^
k^h00_oShn<01_o^k^koh>3PonSXj?o]kNgoeMGEong]k@Gok^k^00?ohn?S
omSHf?o^k^h0ooo^k^hLonk^kP00oooVi^HHonKViP06oijNW_l92@Wo2`/;
ob0P8?l`<33oUYJF0_oVi^H01_li>CWoLW9bonKVi_oVi^Ko>CTiog9bLP;o
i^KV00KoKVi^oc`l??oVi^Koi^KVoj:RX_l820P2onKViP06ocTi>Om3@d?o
8R8RoaPH6?lB4Q;oZJVY0_oVi^H02_li>CWoLW9bonKVi_oVi^Kod=3@od92
@_l20P;o7alOoa@D5?n^[Zh5onKViP05oemOGom>CTkoi^KVonKVi_l`<300
1?l000003old=3Coi^KVodU9BOl71`Oo5aLGohb<S?lA4A7oCTi>onKVi_li
>CWoD51@ob8R8_lH61So4Q8BojVYZ@02onKViP09om3@d?m2@T;o0P82oalO
7olD51Co[Zj^onKVi_li>CWoLW9b0?ooi^KV6?oVi^H00?ook^k^6?o^k^h0
2_o7alOo/[:bonWYjOo^k^koTY:Bo`<30oo?clook^k^oc/k>omfMWH2onk^
kP06oc/k>omfMWKok^k^onk^k_maLG7o?Shn0_o^k^h03_nXZ:So20P8onk^
k_o^k^ko>c/kochn?_oOgmooj^[ZogAdM?lA4A7oh^;Ronk^k_lk>c_oMWIf
0_o^k^h01_lo?coo>c/kom3@d?o^k^koh^;Ron7Qh@Gok^k^00KoP820oahN
7_o^k^kok^k^oc8b<_m/K6`4onk^kP06okRh^?l30`?oc/k>omKFe_mDE5Co
3`l?0_o^k^h04Olk>c_o?ShnomoOgooZj^[oM7Adoa4A4OoRh^;ok^k^oclo
?olk>c_od=3@onk^k_oRh^;ohN7Qonk^k_lk>c_oMWIf0?ook^k^6?o^k^h0
0?oooooo7?ooool01_oQhN7o0000okJf]_oooooo@410ogmoO`;ooooo00Ko
@410ogmoOoooooooooooogYjN_m3@d<2ooooo`06okBd]?l92@Wooooooooo
oom0@43oOgmo0_ooool02_oWinOo0000ojf][Ooooooo@410ogmoOooooooo
gMgMo`000?nh^;P9ooooo`06ohZ:R_lO7aoooooooooooolf=SKoM7Ad1?oo
ool01_oIfMWo0`<3okfm_OooooooWinOob0P80;ooooo00[o@410ogmoOooo
ooooooooonOWiol0003o[Jf]omgMgOl0003o^;Rh1Oooool00om0@43oOgmo
ooooo`3ooooooaOooooo003oonk^kQ_ok^k^00Ooh>3PodU9BOl71`OohN7Q
onk^k_lk>c_oMWIf00;ok^k^00Ko>c/kogIfM_o^k^kok^k^og5aLOln?Sh2
onk^kP06ojRXZ?l820Sok^k^onk^k_lk>c_oMWIf0oo^k^h02OlD51CoQhN7
onk^k_lk>c_oMWIfonk^k_na/K7o0000ocPh>003ocXj>P03okJf]_o^k^ko
k^k^00?ok^k^00KoP820oa`L7?o^k^kok^k^oc8b<_m/K6`5onk^kP05oj6Q
XOl^;Rko;bl_oc8b<_lM7Ad00_o^k^h00olk>c_oMWIfonk^kP02onk^kP05
oa@D5?n7QhOo/K6ao`000?lh>3P00olj>SX01?nf][Kok^k^oc/k>omfMWKo
onk^kQSok^k^003oonKViQ[oi^KV00CoY:BToaTI6OlD51CoZj^[0_oVi^H0
1_li>CWoLW9bonKVi_oVi^Ko>CTiof9RHP;oi^KV00KoKFe]obh^;_oUiNGo
i^KVoj6QXOl820P2onKViP0BocTi>Om^KVkoi^KVonKVi_oEeMGo0000ojn_
[ooVi^Ko>CTiog9bL_oVi^KoaLG5o`000?nJVY[o^[Zjok>c/ol20P;oc/k>
1OoVi^H01_mlO7co6a/KonKVi_oVi^Ko<30`ofQXJ0Ooi^KV00?oi>CTohF5
QOlM7Ad00_oVi^H04Oli>CWoKVi^onKVi_oVi^KoeMGEo`000?n_[jooaLG5
o`000?nJVY[o^[Zjok>c/ol20P;oc/k>onKVi_li>CWoLW9b0?ooi^KV6?oV
i^H00?ook^k^6Oo^k^h01?mhN7So0000oe1@D?oFe]H3onk^kP0>oc/k>omf
MWKok^k^onk^k_lk>c_o4a<Coh:2P_oHf=So>SXjoa`L7?mIFEWod];BofUY
JOl_;bl2onk^kP0:oc/k>olI6AWoS8b<olg=cOmRHV;o3`l?on_[joo^k^ko
>c/kogIfMP;ok^k^00Go>SXjof=SHooVi^KoTi>CobPX:006onk^kP06oh20
P?lL71cok^k^onk^k_lb<S;oK6a/1Oo^k^h01OnXZ:Sobl_;on_[jomJFU[o
CTi>00;ok^k^00go>c/koaTI6On<S8cocLg=of9RH_l?3`oojn_[onk^k_lj
>S[oHf=SonKVi_nCTi?o:2PX00;ok^k^00?o>c/kogIfM_o^k^h0ooo^k^hG
onk^kP00oooooolHooooo`03onKVi_l20P;oTi>C00Gooooo00koE5ADohf=
SOoooooooooooeADE?n;Rh_oLG5aoa0@4?lX:2SoeMGEoiZJV_lJ6Q[o820P
ojf][@;ooooo00KoE5ADohZ:R_mUIFGo3@d=oaTI6OnXZ:P2ooooo`09od10
@?moOgoooooooooooooVi^KoAdM7o`d=3OlL71co]kNg00Kooooo00KoRXZ:
oalO7oooooooooooocHf=_mdM7@5ooooo`05ohZ:R_lb<S;o410@ocTi>Oo4
a<@00_ooool01_m0@43oO7alofEUIOl=3@go6ATIojRXZ0;ooooo00Goi^KV
odM7Aol=3@go71`LokNg]`02ooooo`03od10@?moOgoooooo0?oooooo5ooo
ool00?ook^k^6?o^k^h00oo9bLWo0@41omOGe`0<onk^kP03ong]kOo^k^ko
k^k^00;ok^k^00?okNg]onk^k_o^k^h01?o^k^h00oo/k>cok^k^onk^kP02
onk^kP03oc/k>omfMWKok^k^00?ok^k^00?ojn_[onk^k_o^k^h01_o^k^h0
1_n0P83o71`Lonk^k_o^k^ko<S8bofa/K0Ook^k^00?ok>c/onk^k_o^k^h0
0_o^k^h01?lk>c_oMWIfonk^k_o/k>`6onk^kP03on_[joo^k^kok^k^00;o
k^k^00?o>c/kogIfM_o^k^h0ooo^k^hGonk^kP00oooVi^HIonKViP05od92
@_ld=3CoP820oeQHF?m?Cdl00_oVi^H00omBDU;oPh>3onKViP0EonKViP03
ocTi>OmbLW;oi^KV00coi^KV00KoO7aloa/K6ooVi^Koi^KVoc0`<?mXJ6P<
onKViP03ocTi>OmbLW;oi^KV00coi^KV00?o>CTiog9bL_oVi^H0oooVi^HG
onKViP00ooo^k^hIonk^kP05on[Zj_nYZJWoIVIVoginO_nb/[800_o^k^h0
0onXZ:So_knoonk^kP0Eonk^kP03oc/k>omfMWKok^k^00cok^k^00Ko`l?3
oi^KVoo^k^kok^k^ojBTY?nj^[X<onk^kP03oc/k>omfMWKok^k^00cok^k^
00?o>c/kogIfM_o^k^h0ooo^k^hGonk^kP00oooooolhooooo`03oo_knoom
oOgooooo01kooooo00?ono_koogmoOooool03?ooool00ookno_ooOgmoooo
o`3ooooooaOooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oogmoOeOoOgmo1omnOWkoogmoObCoOgmo00001?o[jn_o
i^KVon;Rh_oNg]h4omgMg@?og]kN00?og=cLomkNg_oMgMd00_oMgMd0oooN
g]kog=cLomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNgP004OoMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomcL
g?oMgMgofm_K00;og=cL03?ogMgMomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]h00_oL
g=`01OoIfMWof=SHomOGeooHf=SofMWJ00;og=cL0?oog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oLg=cog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]h001OogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMgP03omkNgP03omgMgOoNg]kog]kN00?o
gMgM0OoQhN41onOWi`7oj^[Z00000oo/k>coi^KVon3Ph007omWIf@04omSH
f?oFe]Kodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oH
f=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Co
f=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=SKomWIf@;o
f=SH00Koe]KFom?CdooCdm?oe=CDomOGeooHf=P2omWIf@03omSHf?oIfMWo
fMWI00;of=SH2OoIfMT00ooHf=SofMWIomWIf@02omSHf003omWIfOoHf=So
f=SH00;of=SH5ooIfMT01?oHf=Soe]KFom;Bd_o?cll2olg=c@04olo?cooC
dm?oemOGomSHf?oofMWI5_oIfMT00ooHf=SofMWIomWIf@06omWIf@7og]kN
0OoVi^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoPh>3oh^;R00;o
hN7Q00gog]kNom_KfooCdm?oalO7ok^k^onb/[;o[Jf]ok:b/_nk^k_oalO7
om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?oalO7ok^k^onb/[;o
[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooC
dm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO0=[o
hN7Q00Woh>3PomoOgooKfm_oe]KFomCDe?oFe]Kof][JomkNg_oPh>001_oO
gml3on3Ph003omoOgooPh>3oh>3P00;oh>3P2?oOgml2omkNgP;ogmoO0ooP
h>02omoOg`;oh>3P0_oOgml=on3Ph005omoOgooMgMgofMWIomGEeOoCdm<0
0_oBd]800ooFe]Kog=cLon3Ph01_on7Qh@03on3Ph?oQhN7ohN7Q00GohN7Q
00?oh>3Pon7QhOoQhN40<_oQhN400ooPh>3ohN7Qon7Qh@1Xon7Qh@03on;R
h_oQhN7oh^;R00CohN7Q0OoTi>@1onSXj07okNg]00000oo`l?3okno_oo7a
l@03oo3`l03oono_koo`l?3ok^k^onWYjOoKfm_o`L71ojBTY?n<S8coNWYj
ogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7aono_kooalO7o
kno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2`_nTY:CoS8b;og]kNomg
MgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<S?mkNg_oMgMf
og]kNon<S8coY:BTol;2`_oJf][oj^[Zong]kOoalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_000Koo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
k^k^ono_kooZj^[oinOW00;oh>3P00Oohn?Son_[jOo[jn_oj^[ZonKVi_oX
j>SoinOW00;ojNWY01;ok^k/onc/k?o/k>coj>SXonc/k?o]kNgol?3`onc/
k?oZj^Soi^KVonSXj?oWinOojNWYonSXj?o[jn_oinOWonOWiOoUiND2onWY
j@0?onk^k_o]kNgokNg]onSXj?o[jnWok>c/onk^k_oYjNWoj^[Zon_[joo_
knook>c/onc/j_oZj^[ok^k^00;ok>c/0?ooj^[Zono_koo/k>cok>cZon[Z
j_o^k^kok>c/ojn_[omfMWKoFEUIofi^K_ng]kKoh>3PonWYjOo]kNgolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knl002golO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`l?o_knl01?o`l?000003oo;bl_o^k^koinOW00CoiNGU013o
i>CTomoOgooAdM7o/K6aohZ:R_mUIFGoDE5AodE5AOm2@T;oADE5oe5ADOmV
IVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@00ooUiNGoi>CTonGUi002onCTi00?
omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKo
RXZ:ok6a/OoAdM3og]kN00;oi>CT0>goiNGUonCTi?oUiNGoi>CTonCThooN
g]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:
R_na/K7odM7AomkNg_oTi>?oi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiN@00_oTi>@0ooo5aLGo:2PXodA4
A?n@T93odM7AomcLfooKfm_oemOGomCDe?oFe]Koe=CDomGEeOoIfMWoh>3O
omkNg_oJf][oe=CDomWIfOoNg]koh^;RomcLg?oGemKoe=CDomKFe_oDe=Co
eMGEomSHf?oKfm_oemOGomKFeOoEeMGoemOGomSHf?oNg]kogmoOomcLg?oE
eMGoemOFomcLg?oMgMgoemOGomKFe_oKfm_ohN7QomkNg_oKfm[of][JomkN
g_oLg=cof][Jom_KfooPh>3ogmoOomcLfooIfMWog]kNomoOgomdM7CoIfMW
ohf=SOmDE5Co20P8oj:RX_oLg=coh^;RonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGohn?SonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUon?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi000F?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>@4onGUi@06onCTi?oUiNGoiNGUonGUiOoXj>Sok>c/
0Oobl_800003ooCdm?o]kNgoinOW00;oh>3P01?ohN7QomoOgooNg]kod];B
okBd]?n7QhOoG5aLofdk=OnNCT;ocFiNonV3Koo=KeooWDe3ofdk=_mLG5co
QhN7okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m]
H2coWYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aLohN7Qond];Cod];BomkN
gP05on3Ph00AomkNg_oBd];o];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UE
oi7=AomZWSCoBFX_oeaLG?n7QhOo];Bdom;Bd_oNg]h0fOoPh>001_oOgmoo
clo?oiVIVOnBTY;o6ATIohb<S0;oeMGE01ooclo?ol;2`_o>c/koc/k>olG5
aOo:b/[of][JomSHf?o@d=3obl_;olo?cooHf=Sof][JomGEeOo?cloo`L71
om3@d?o>c/koa<C4ol_;booHf=SoemOGokjn__nk^k_odM7Aom3@d?oEeMGo
f=SHom?Cdoo<c<coc/k>00;oeMGE00Goc/k>olc<c?oCdm?of][JomSHf002
om;BdP04omSHf?oGemOodM7Aom?Cd`;ofMWI00Kodm?Com7AdOoGemOof=SH
om7AdOo@d=02om7Ad@04odI6A_m1@D7oemOGomkNgW7oh>3P00?ogmoOon3P
h?oPh>000_oPh>000ooOgmooh>3Pon3Ph02Lon3Ph003omoOgooPh>3ogmoO
00;ogmoO0ooPh>000ooQhN7oinOWonc/k001ooCdm00000?om_Kfoo;bl_o[
jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWiooJUiNohlf;_o/L67onIf@oofa
YOom_:oooKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;Rh_oWinL00ooX
j>P04ooWinOoh^;Rolg=cOnOWiooKVIOoi=b8_o]dDConO=doogmSOomoIGo
oOf>ooWhM_o]edOoTg<RofiWGonOWioocLg=on;Rh_oWinL00ooXj>P04ooW
inOoh^;Rolg=cOnOWiooH6QOod]l8onBhD_o_OUkom3mT_oHoI_oe?fEol3i
O_nHj4goCH0Tof1YGonOWioocLg=on;Rh_oWinL0f_oXj>P01?oVi^KohN7Q
oeeMGOm=CDd2omgMg@0Ooe1@D?l71`Oo5ADEohB4Q?lF5QKo@d=3on;Rh_oM
gMgoW9bLo`000?n?ShoogMgMon7QhOoKfm_o@410o`P82?lI6AWoR8R8o`/;
2omHF5So]kNgo``<3?l71`Oo8b<SobLW9ommOGgof][JomgMgOoDe=Co2`/;
oeUIF@02omWIf@03oeeMGOl;2`_odm?C00;ogmoO00KoFUYJodi>C_oNg]ko
g]kNob<S8on4Q8@2on7Qh@0<ogYjN_l^;RkogMgMomgMgOo2`/;oD51@oc<c
<om^KVkoPh>3ob4Q8OoNg]koi^KVoooXj>POonSXj07ok>c/0Oobl_81ooKf
mP0000?omoOgooShn?ohn?P00oohn?P04oogmoOok^k^olk>c_n@T93oQBl[
onUTE_okTXOooZJKoojaYOoo]j[oo[>VoojXW?ojU8WokVQIohTa:on@T93o
c/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93oVFT[oo2m?Ook
h6koo_B2ooknR_oooi;oo_j<ookhPookiG3ol<8noiUZ:on@T93oc/k>onk^
k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93o@W<[ohC>@on]kg?o`_j8
olknT?oFoiOod?jBolKnROnbmGCoR==3odAe:on@T93oc/k>onk^k_ogmoL0
f_ohn?P09Oofm_KolO7aoh61POlO7aookNg]olK6a_l0003o`l?3om?CdomL
G5co20P8on[Zj_o`l?3oj^[Zoe9BD_lD51Co?CdmonWYjOo`l?3o[jn_o`L7
1ooBd];ocLg=odi>C_lK6a_ok^k^om_Kfon^[Zkoj>SXonc/k?n^[Zko0000
okBd]?o/k>co/;2`o`/;2olJ6QX00_oTi>@02olS8b?o3Ph>ojBTY?o]kNgo
k^k^of1PH?mDE5Cok^k^ong]kOlV9RKoSHf=00;ol?3`00coPX:2oc4a<Oo/
k>coj^[Zod=3@ol_;booW9bLog=cLolZ:R[o6QXJonk^k_ofm_I_ooShn003
ooOgmoohn?Son?Sh00Gon?Sh00?omoOgooShn?ohn?P0WOohn?P00oogmoOo
n?ShooShn002ooShn004ooOgmooinOWomoOgooKfmP7on?Sh00000oojn_[o
mOGeonk^kP02onc/k03oon_[jooYjNWogmoOokZj^_mhDU;o_c8TonIcJ?om
RGkooiN;oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c9?miDU;o^[ZjomoO
gooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3ooMYS
oooZL_onlgkoooZ2ookfOoook7?oo]iToo[7DOoRTQcoRFICokZj^_oOgmoo
j^[Zon_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]D_mAXacoTM9EojKWJ_nh
nG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]D_nj^[[ogmoOon[Z
j_o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
0019onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/onWYjOoUiNGoNWYjoa`L7?oQhN;oc<c<
o`<30onPX:3og]kNoiBDU?lC4a?ohN7Qon3PhOo@d=3o1PH6oj6QXOl92@Wo
_knoon7QhOnj^[[o0P82ok:b/_oMgMgoP820obPX:?oShn?oinOWonGUiOoO
gmoofm_Kom?Cdol820SoQHF5omoOgomYJFWoBTY:ocDe=On][Jgo_Kfmo`L7
1omhN7SoEEEEomoOgooPh>3oFe]Koe1@D002on7Qh@0:ob@T9?n5QHGogmoO
on7QhOmkNg_o;bl_on3Ph?oDe=Co1@D5ojRXZ0;ohn?S0?ooOWiooaHF5_oQ
hN7oj^[Zon_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on[Zj_o/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?oZj^_ok>c/on_[joo/k>cojn_[onc/k?oZ
j^[ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn/001[ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k0Kojn_[00Go
k>c/on_[joo[jn_ok^k^ooKfmP01ooWin@0000?ono_koo?cloo]kNd00_oU
iND0oooVi^Koi>CTomWIfOnb/[;oNBh^olQ2<ooSJUcom7Y]oof8O?onUh[o
oY^>oojHRoonRWkom7]]onM[GOo:@SCoNbh^ok:b/_oHf=Soi>CTonGUiOoV
i^KoiNGVonCTi?oHf=So/[:boiIE;_oZW2_onka4ook<Doomf6;oo^=bookY
MOoniW?oo]]Uoog<Dook`DGokYh[oiUF;_nb/[;of=SHonCTi?oUiNGoi^KV
onGUiOoTi>Cof=SIok:b/_l^HRkoHjd[ohO:B?nGg5WoYNEYok;cMonhmW_o
]?EiojOZJonHg5WoRLm;of>^:ol^Hbko/[:bomSHfOoTi>CoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUiP00=?oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oShn?ogmoOogMgMolK6a_og=cLon7QhOnNWYko;bl_ob/[
:olb<S;o4Q8BomcLg?oJf]_oQ8B4ob0P8?oPh>3oDU9BofQXJ?oJf][og]kN
oi2@T?lZ:R[o;Rh^ob`/;?lW9bL2omkNgP0ComWIfOoCdmCod=3@oe]KFol0
003o_Kfmom[Jf_lX:2SoQhN7ogMgN?mXJ6SoPX:2oc`l??o2`/;o3`l?omCD
e?oJf][oFEUIodi>CP02omcLg021ob<S8on1PH7oeMGEomOGeomgMgOo;Rh^
omcLg?nSXj?o0000olO7aooHf=SofMWIohf=S_lE5AGog=cLonCTi?oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oT
i>Goi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Koi>CT00;o
iNGU0:;oi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNH2onKViP03onGUiOoVi^Koi^KV00?o
i^KV00?oiNGUong]kOodm?@00Oojn_X00003ooclo?ohn?SolO7a00?ok^k^
01?ojn_[on7QhOnl_;coNQLGol<o<_oCETWoi6QJonmgK?odPgWomhMlooF4
N_ocNFgoiFUKomUHB_o4?c;oO1LGokbl_?oQhN7ok>c/00?ok^k^01?ok>c/
on7QhOnl_;coYDLGonJG<_oe[33ooKa1oog9Doomd63onm=UoogBH?oncECo
oKe2ooZ_<_oYVc;oYDHGokbl_?oQhN7ok>c/00?ok^k^01?ok>c/on7QhOnl
_;co5eTGoenX<_mf_COoQ/e7oiKFF_nRh6GoXn1Yoj?QIonGfUcoQ/i7ogNo
=omOZc;o5eTGokbl_?oQhN7ok>c/0=[ok^k^02kok>c/onOWiomkNg_o71`L
onCTi?oYjNWoi^KVon7QhOoNg]koSHf=oa@D5?oVi^Koi>CTocDe=OmiNGWo
jn_[ok:b/_lE5AGogmoOonKVi_oTi>CohN7QomgMgOmjNW[o:BTYonSXj?oU
iNGogMgMok6a/OlV9RKo2`/;oi^KVooYjNWoc<c<o`000?o>c/ko`l?3obDU
9Om;Bd_oO7alonSXj?la<C7oYJFUonCTi?mMGEgoDE5A0_oWinL02_lU9BGo
JFUYomoOgooOgmooMgMgoc4a<OoYjNWo`L71o`000?nWYjL2omoOg`04oi>C
TolF5QKoinOWonc/k:cok^k^00?okNg]onk^k_o^k^h0K_o^k^h00oo]kNgo
l_;booShn001ooclo0000oomoOd05_olo?cooOgmoogmoOolo?colo?com7A
dOmX1`Oo^3@dolLo<ooBD4?ofV9Eon=^H_oTLVCoi6mRomaTEooCDD?oc44d
okTd=?m[1`Ood];Boo?cloolo?`3oogmo@0Cooclo?oclo?od];Boih[1ooJ
RSCoji/IooFX:Ooh]3oonKe:ooRoCOoj_d[onKPoooJZ:_o_WQWofh/doj8]
1ooBd];olo?cooclo003oogmo@0Cooclo?oclo?od];Bo`M01om=VSCoGj/P
og2h;omo`d?oR/e@ohg=D_n:cU3oPLM4og6i;omR[R3oCY/do`M21ooBd];o
lo?cooclo03Joogmo@0Soo_knoogmoOoQ8B4oahN7_oclo?onOWiok>c/oo@
d=3olo?cofQXJ?m7AdOon_[jomCDe?l0003ogMgMooclo?okno_o9bLWojRX
Z?oinOWoZj^[omGEeOoalO7oE5ADoeiNG_oinOWom?CdoiBDU?l51@Go@410
om7AdOogmoOon?ShoiNGUol[:b/00_ojn_X06olT92Co1`L7olS8b?okno_o
QHF5of=SHoogmoOoHf=SoeMGEoohn?SonOWiobLW9olE5AGoPh>3omOGeom2
@T;oHf=Soo_knoojn_[o=3@dodU9BOoKfm_oiNGUodm?ColG5aOon_[joocl
o03ooogmoAcooOgm00?oo?cloogmoOolo?`00oomoOd0000joogmoOojn_[o
lo?conk^k_o`l?3okno_onk^k_oYjNWodm?CoeXL7?nR=3Co]2PMol4i;?o7
BCcoceI:om1GBoo@Ed[obTXnol<k;_nf:1goXS@doe`M7OoCdm?oj^[Zonk^
k_o`l?3okno_oo3`koo^k^koj^[Zom?Cdon<9Agob74domV47OoTU1GoiidT
onjX<oo`ZSCokjXconbP9OoWUaGog8PMolQa=?n<9Agodm?Con[Zj_o^k^ko
l?3`ono_koo`l?3ok^k^on[ZjOoCdm?o7CPMocB2=?m7UAgoFZDKofV]:P;o
M;Ph0>;oMKThof^a:omKYacoB9XMocB2=?lM>1godm?Con[ZjOo^k^kol?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`0_o_knl0k_oZj^[oOWinoa`L7?oXj>OokNg]ohR8R?l`<33o
3`l?oc4a<Ona/K7ok^k^ohF5Q?m=CDgokno_onk^k_o_knooRXZ:oeUIFOo^
k^koN7Qhob/[:ol?3`oo>3Phokno_oo]kNgoi>CTo`h>3_mYJFWogmoOon?S
hooUiNGojn_[of5QHOmgMgOok^k^ono_k_mfMWKo9RHVong]kOo_knooc<c<
ob`/;?oZj^[oKFe/of9RH_o/k>cokNg]oc/k>onCTi?oHV9Ro`h>3_ld=3Co
a<C4ono_koo^k^kodM7Aoc`l??l:2P[o9bLWofa/K?l/;2cokno_onk^k_o`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`onk^k_o`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?03ono_k`1Too3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_k`;ol?3`1_o_knl1oo?cl`7onOWi
0Oono_h00003ookno_ogmoOol?3`00CojNWY017oinOWom_KfomSBd_oPC8b
ojHe=Onf=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mSBd_o
fm_KonOWi`05onWYj@0AonOWiooKfm_oRD];ojm;<_o=McGoeX/]on2L;_oP
X3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;oRD];om_KfooWinL01OoYjNT0
4OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[ZbooL:dhofn^>_m`[CSoJZX_
oe>K;OliR3Go<V0bod];BooKfm_oinOW0=_ojNWY00Koj>SXonKVi_mkNg_o
71`LonCTi?oXj>P2onWYj@03onOWiooYjNWojNWY00_ojNWY00coinOWonWY
jOoYjNWoj>SXomSHf?l:2P[o[Zj^omgMgOoNg]koh>3PonGUiOoXj>P8onWY
j@06onSXj?oVi^Kohn?Son?ShooVi^Koj>SX0ooYjNT00ooXj>SojNWYonWY
j@04onWYj@03onOWiooYjNWojNWY0?oojNWY6ooYjNT00ooXj>SojNWYonWY
j@04onWYj@7ol?3`0OogmoL1ooknoP0000Goo_knoo[jn_odm?Cokno_oo7a
l@02oo3`l00Aono_koo[jn_oUIBDodlS8onEE5Co^g=com>EUOoJW9cofYjL
omVLW?oDUIGo^g=coiEDE?m?8b?oUIBDon[Zj_o_knl01Oo`l?004Oo_knoo
j^[ZojVDU?n18b?o^VYDomBJLooT_9Goj/NLonW7W?oZaicoiKbEomBJLonk
JUCoPB<SojZDU?oZj^[okno_00Gol?3`017okno_on[Zj_nDU9Co8bXSoeAj
E?mcYG?oW/JEojc>W?n]cYco[<jLoik6UOmcYG?oE7YDob<Z8onDU9Coj^[Z
ono_k`3Koo3`l0;okno_00CoP820oadM7Oo^k^kokno_4oo`l?02ono_k`07
ofATI?lY:BWoPH61of=SHolk>c_ok^k^ono_k`08oo3`l006ono_koo^k^ko
Lg=cofUYJOo^k^kokno_ooo`l?0]oo3`l004oo7alOo`l?3om?Cdoo[jnP7o
o_kn00001?o/k_3oooooooooooono_h2ooooo`;oo_kn0?oooOgmooShn?m^
KVkoFSlook6@T?oNbLWol>CToo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooSh
n?olo?coooooookno_ooooooo_knooooo_ono_koooooooclo?ohn?SoSFe]
ohXo?oo9TI3ojM39ooCYi?ofjnKom>WTonW@bOo9TI3oRCloohe]KOohn?Oo
o?clooooooono_koooooookno_ooooooo_knooooo_olo?con?Shofe]KOlo
?cooT9f@olWEbOoTk>Coi^kVonC/i?o9eLWoT9f@oclo?om]KFgon?Shoocl
o?ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_h003Soooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_kooooooogmoOo@d=3oYJFU
ooknoOono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
oooooOgmol71`?maLG7oPH61ojn_[`;oo_kn00coooooookno_ooookoo_kn
ooooooono_koooooookno_oooooooOgmol;2`Onl_;`2ooknoP3oooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_kooooo000Yookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_h00_ooool00oono_koooooooooo`03ooooo`7on__k0000
1?o1b<koo_knoo[jn_odm?@5oo7al@0=ono_kooFe]KoJf][od<m?OnKS8co
a[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7al@0=ono_kooG
e]KoPf][og@m?OneS8coeKZjon7<c?oF^[[o]Xb<og8m?On1Jf_oemKFono_
k`09oo7al@0=ono_kooFe]KoJf][ocdm?On<S8co^[Zjolc=c?nj^[[oS8b<
ocdm?Om[Jf_oe]KFono_k`3ooo7alOoolO7a=?oalO401?o`l?3olO7aoo7a
lOo`l?04oo7al@03ooCdm?ojn_[oo_kn007ojng^00001On4SiWooOgmooSh
n?o`l?3ojn_[00?oj^[Z00gojNWYon[Zj_oYjNWoj>SXoi^KVomIFEWo9RHV
o`T92OlV9RKoFEUIoi^KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nPVi_o
JUUIod<V9_l]2@Wo@RHVofUIFOnPVi_oj>SXonWYj@0;on[ZjP0;onWYjOoX
j>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT0oooZj^[o
on[ZjScoj^[Z00Cojn_[oo3`l?ohn?SooOgm0OoBe]P00004ocI6DOnh`<Go
nOWiooCdm0SolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`
l?0?oo7al@;ol?3`0oo_knl2oo3`l?oolO7aoooalO4joo7al@03oo3`l?oa
lO7olO7a00;olO7a00?omOGeoo[jn_o/kNl00OnQYJP00003oad_?om<FF?o
^Ko50?oooooooooooomlooooo`7okNk_0On]/;81ojFZ[@0000Ko72hmoaXY
=Olb?4KoOXR@okg3b?o[k>koooooooooooooM_ooool01OoZjnco^l34ogV1
Qol/=Cgo4alY007o52@_0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(path = 
        StringJoin[$JavaSwingMaterial, "\<Moai.jpg\>"];\)\), "\
\[IndentingNewLine]", 
    \(icon = NewImageIcon[path]\), "\[IndentingNewLine]", 
    \(iconWidth = icon@getIconWidth[]\), "\n", 
    \(iconHeight = icon@getIconHeight[]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject46728858304513]], "Output"],

Cell[BoxData[
    \(120\)], "Output"],

Cell[BoxData[
    \(128\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\(savedLayout = pane@getLayout[];\)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]pane@
        setLayout[\[IndentingNewLine]JavaNew["\<java.awt.GridLayout\>", 3, 3, 
            5, 5]\[IndentingNewLine]]\[IndentingNewLine]]\)}], "Input"],

Cell["Simple label.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(l1 = NewJLabel[pane, "\<Simple JLabel\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JLabel"] \[RightGuillemet]\),
      JLink`Objects`JavaObject79424447840257]], "Output"]
}, Open  ]],

Cell["A label with icon.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(l2 = NewJLabel[pane, "\<JLabel with ImageIcon\>", icon]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JLabel"] \[RightGuillemet]\),
      JLink`Objects`JavaObject811446829057]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(l2@setHorizontalTextPosition[\[IndentingNewLine]javax`swing`JLabel`LEFT\
\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(l2@setVerticalTextPosition[\[IndentingNewLine]javax`swing`JLabel`TOP\
\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]l2@
        setBackground[java`awt`Color`white]; \[IndentingNewLine]l2@
        setForeground[java`awt`Color`red]\[IndentingNewLine]]\)], "Input"],

Cell["Opacity of the label is set by setOpaque method.", "Text"],

Cell[BoxData[
    \(l2@setOpaque[True]\)], "Input"],

Cell[BoxData[
    \(\(\(l2@setOpaque[False]\)\(\ \)\( (*transparent*) \)\)\)], "Input"],

Cell[BoxData[
    \(\(\( (*\(frame@pack[];\)*) \)\(\[IndentingNewLine]\)\(JavaShow[
      frame]\)\)\)], "Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(animgif = 
        JavaNew["\<javax.swing.ImageIcon\>", 
          StringJoin[$JavaSwingMaterial, "\<GIFAnim.gif\>"]];\)\), "\n", 
    \(spriteWidth = animgif@getIconWidth[]\), "\n", 
    \(spriteHeight = animgif@getIconHeight[]\)}], "Input",
  CellTags->"animgif"],

Cell[BoxData[
    \(63\)], "Output"],

Cell[BoxData[
    \(60\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(label = 
      NewJLabel[pane, \[IndentingNewLine]"\<Animation GIF\>", 
        animgif, \[IndentingNewLine]0, 0, spriteWidth + 100, 
        spriteHeight + 
          6, \[IndentingNewLine]javax`swing`JLabel`LEFT]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JLabel"] \[RightGuillemet]\),
      JLink`Objects`JavaObject62273938784257]], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(JavaShow[frame]\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]h = \((pane@\(getBounds[]@height\) - 
              spriteHeight)\)/2; \[IndentingNewLine]label@
        setText["\<Flying...\>"]; \[IndentingNewLine]For[t = 0, t < 550, 
        t += 1, label@
          setBounds[Round[0.5  h \((1 + Sin[2  Pi\ t/50])\)], 
            Round[h \((1 + Cos[2  Pi\ t/100])\)], spriteWidth + 100, 
            spriteHeight + 6]]; \[IndentingNewLine]label@
        setText["\<Animation GIF\>"];\[IndentingNewLine]]\)}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(ReleaseObject[icon]\), "\[IndentingNewLine]", 
    \(ReleaseObject[animgif]\)}], "Input"],

Cell[BoxData[{
    \(DeleteJObject[pane, l1]\), "\[IndentingNewLine]", 
    \(DeleteJObject[pane, l2]\)}], "Input"],

Cell[BoxData[
    \(DeleteJObject[pane, label]\)], "Input"],

Cell[BoxData[{
    \(frame@setLocation[0, 0]\), "\[IndentingNewLine]", 
    \(frame@setSize[640, 480]\)}], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.border <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<1jc<c<1L30`7[<
c<co`<300L30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qjc<c<1L30
`7[<c<`5`<30N/c<c?o0`<01`<300XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<afVIVI0/c<c0G0`<02c<c<MYVIV@;<c<`5`<300/c<c7Ko0002
c<c<ol30`070`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c003VIVIc<c<c<c<
07;<c<`00iVIVLc<c<c<c005`<300/c<c7Ko0002c<c<ol30`070`<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<07;<c<`0
0iVIVLc<c<c<c005`<300/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<
c005`<300/c<c7Ko0002c<c<ol30`070`<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<30
0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c7Ko0002
c<c<ol30`070`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c003VIVIc<c<c<c<
07;<c<`00iVIVLc<c<c<c005`<300/c<c7Ko0002c<c<ol30`070`<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<07;<c<`0
0iVIVLc<c<c<c005`<300/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<
c005`<300/c<c0Go001/c<c<1Ol000;<c<co`<300L30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<
c<c<00G0`<02c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02
c<c<1Ol006c<c<`5o`000/c<c?o0`<01`<300XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30
`0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`5o`00
K<c<c0Go0002c<c<ol30`070`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c003
VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c0Go001/c<c<1Ol0
00;<c<co`<300L30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<00>IVIW<c<c<
c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<1Ol006c<c<`5o`000/c<c?o0
`<01`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<
c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`00iVIVLc<c<c<c01bc<c<
00>IVIW<c<c<c<`01L30`0;<c<`5o`00K<c<c0Go0002c<c<ol30`070`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<07;<
c<`00iVIVLc<c<c<c005`<300/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<
c<c<c005`<300/c<c0Go001/c<c<1Ol000;<c<co`<300L30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0L/c<c003VIVI
c<c<c<c<00G0`<02c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0
`<02c<c<1Ol006c<c<`5o`000/c<c?o0`<01`<300XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`0
1L30`0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`5
o`00K<c<c0Go0002c<c<ol30`070`<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<
c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c0Go001/c<c<
1Ol000;<c<co`<300L30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<00>IVIW<
c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<1Ol006c<c<`5o`000/c<
c?o0`<01`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`00iVIVLc<c<c<c01b
c<c<00>IVIW<c<c<c<`01L30`0;<c<`5o`00K<c<c0Go0002c<c<ol30`070
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<
07;<c<`00iVIVLc<c<c<c005`<300/c<c003VIVIc<c<c<c<07;<c<`00iVI
VLc<c<c<c005`<300/c<c0Go001/c<c<1Ol000;<c<co`<300L30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0L/c<c003
VIVIc<c<c<c<00G0`<02c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<
00G0`<02c<c<1Ol006c<c<`5o`000/c<c?o0`<01`<300XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<
c<`01L30`0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<
c<`5o`00K<c<c0Go0002c<c<ol30`070`<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<30
0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c0Go001/
c<c<1Ol000;<c<co`<300L30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<00>I
VIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<1Ol006c<c<`5o`00
0/c<c?o0`<01`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`00iVIVLc<c<c<
c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`5o`00K<c<c0Go0002c<c<ol30
`070`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<
c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c003VIVIc<c<c<c<07;<c<`0
0iVIVLc<c<c<c005`<300/c<c0Go001/c<c<1Ol000;<c<co`<300L30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0L/c<
c003VIVIc<c<c<c<00G0`<02c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<
c<c<00G0`<02c<c<1Ol006c<c<`5o`000/c<c?o0`<01`<300XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<
c<c<c<`01L30`0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30
`0;<c<`5o`00K<c<c0Go0002c<c<ol30`070`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005
`<300/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c0Go
001/c<c<1Ol000;<c<co`<300L30`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<
00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<1Ol006c<c<`5
o`000/c<c?o0`<01`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`00iVIVLc<
c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`5o`00K<c<c0Go0002c<c<
ol30`070`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c003VIVIc<c<c<c<07;<
c<`00iVIVLc<c<c<c005`<300/c<c0Go001/c<c<1Ol000;<c<co`<300L30
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0
L/c<c003VIVIc<c<c<c<00G0`<02c<c<00>IVIW<c<c<c<`0L/c<c003VIVI
c<c<c<c<00G0`<02c<c<1Ol006c<c<`5o`000/c<c?o0`<01`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c01bc<c<00>I
VIW<c<c<c<`01L30`0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`0
1L30`0;<c<`5o`00K<c<c0Go0002c<c<ol30`070`<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<
c005`<300/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<
c0Go001/c<c<1Ol000;<c<co`<300L30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02
c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<1Ol006c<
c<`5o`000/c<c?o0`<01`<300XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`00iVI
VLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`5o`00K<c<c0Go0002
c<c<ol30`070`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c003VIVIc<c<c<c<
07;<c<`00iVIVLc<c<c<c005`<300/c<c0Go001/c<c<1Ol000;<c<co`<30
0L30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<
c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<00>IVIW<c<c<c<`0L/c<c003
VIVIc<c<c<c<00G0`<02c<c<1Ol006c<c<`5o`000/c<c?o0`<01`<300XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c01bc<c<
00>IVIW<c<c<c<`01L30`0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<
c<`01L30`0;<c<`5o`00K<c<c0Go0002c<c<ol30`070`<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<
c<c<c005`<300/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<30
0/c<c0Go001/c<c<1Ol000;<c<co`<300L30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0
`<02c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<1Ol0
06c<c<`5o`000/c<c?o0`<01`<300XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`0
0iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`5o`00K<c<c0Go
0002c<c<ol30`070`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c003VIVIc<c<
c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c0Go001/c<c<1Ol000;<c<co
`<300L30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<
c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<00>IVIW<c<c<c<`0L/c<
c003VIVIc<c<c<c<00G0`<02c<c<1Ol006c<c<`5o`000/c<c?o0`<01`<30
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c01b
c<c<00>IVIW<c<c<c<`01L30`0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<
c<c<c<`01L30`0;<c<`5o`00K<c<c0Go0002c<c<ol30`070`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<07;<c<`00iVI
VLc<c<c<c005`<300/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005
`<300/c<c0Go001/c<c<1Ol000;<c<co`<300L30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<
00G0`<02c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<
1Ol006c<c<`5o`000/c<c?o0`<01`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<
c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`5o`00K<c<
c0Go0002c<c<ol30`070`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c003VIVI
c<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c0Go001/c<c<1Ol000;<
c<co`<300L30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>I
VIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<00>IVIW<c<c<c<`0
L/c<c003VIVIc<c<c<c<00G0`<02c<c<1Ol006c<c<`5o`000/c<c?o0`<01
`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<
c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`00iVIVLc<c<c<c01bc<c<00>I
VIW<c<c<c<`01L30`0;<c<`5o`00K<c<c0Go0002c<c<ol30`070`<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<07;<c<`0
0iVIVLc<c<c<c005`<300/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<
c005`<300/c<c0Go001/c<c<1Ol000;<c<co`<300L30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<
c<c<00G0`<02c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02
c<c<1Ol006c<c<`5o`000/c<c?o0`<01`<300XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30
`0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`5o`00
K<c<c0Go0002c<c<ol30`070`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c003
VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c0Go001/c<c<1Ol0
00;<c<co`<300L30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<00>IVIW<c<c<
c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<1Ol006c<c<`5o`000/c<c?o0
`<01`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<
c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`00iVIVLc<c<c<c01bc<c<
00>IVIW<c<c<c<`01L30`0;<c<`5o`00K<c<c0Go0002c<c<ol30`070`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<07;<
c<`00iVIVLc<c<c<c005`<300/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<
c<c<c005`<300/c<c0Go001/c<c<1Ol000;<c<co`<300L30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0L/c<c003VIVI
c<c<c<c<00G0`<02c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0
`<02c<c<1Ol006c<c<`5o`000/c<c?o0`<01`<300XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`0
1L30`0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`5
o`00K<c<c0Go0002c<c<ol30`070`<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<
c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c0Go001/c<c<
1Ol000;<c<co`<300L30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<00>IVIW<
c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<1Ol006c<c<`5o`000/c<
c?o0`<01`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`00iVIVLc<c<c<c01b
c<c<00>IVIW<c<c<c<`01L30`0;<c<`5o`00K<c<c0Go0002c<c<ol30`070
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<
07;<c<`00iVIVLc<c<c<c005`<300/c<c003VIVIc<c<c<c<07;<c<`00iVI
VLc<c<c<c005`<300/c<c0Go001/c<c<1Ol000;<c<co`<300L30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0L/c<c003
VIVIc<c<c<c<00G0`<02c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<
00G0`<02c<c<1Ol006c<c<`5o`000/c<c?o0`<01`<300XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<
c<`01L30`0;<c<`00iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<
c<`5o`00K<c<c0Go0002c<c<ol30`070`<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<30
0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c0Go001/
c<c<1Ol000;<c<co`<300L30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<00>I
VIW<c<c<c<`0L/c<c003VIVIc<c<c<c<00G0`<02c<c<1Ol006c<c<`5o`00
0/c<c?o0`<01`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0iVIVLc<c<c<c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`00iVIVLc<c<c<
c01bc<c<00>IVIW<c<c<c<`01L30`0;<c<`5o`00K<c<c0Go0002c<c<ol30
`070`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<
c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c003VIVIc<c<c<c<07;<c<`0
0iVIVLc<c<c<c005`<300/c<c0Go001/c<c<1Ol000;<c<co`<300L30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0L/c<
c003VIVIc<c<c<c<00G0`<02c<c<00>IVIW<c<c<c<`0L/c<c003VIVIc<c<
c<c<00G0`<02c<c<1Ol000K<c<`400000/c<c0030000c<c<c<c<00H00000
1<c<c00000000<c<c0800002c<c<0P000003c<c<0000000000;<c<`20000
A/c<c0Go0002c<c<ol30`070`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c003
VIVIc<c<c<c<07;<c<`00iVIVLc<c<c<c005`<300/c<c0Go0005c<c<0P00
00;<c<`2000000C<c<`0003<c<c<c<`200001Lc<c08000000lc<c0000000
0002c<c<0P000003c<c<0000000000;<c<`20000A/c<c0Go0002c<c<ol30
`070`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<
c<c<00G<c<`200000lc<c0800002c<c<0P000003c<c<0000000000;<c<`4
0000FLc<c003VIVIc<c<c<c<00G0`<02c<c<00>IVIW<c<c<c<`01<c<c0@0
0002c<c<00<0003<c<c<c<`01P000004c<c<00000000c<c<0P0000;<c<`2
000000?<c<`0000000000/c<c080001>c<c<00>IVIW<c<c<c<`01L30`0;<
c<`9o`0000?<c<`0000000000/c<c0800002c<c<00@0003<c<`000000005
c<c<0P000003c<c<0000000000;<c<`2000000C<c<`00000003<c<`20000
0lc<c4Wo0002c<c<ol30`070`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<00G<c<`200000lc<c08000000lc<c0000000
0002c<c<0P000003c<c<0000000000;<c<`20000F<c<c003VIVIc<c<c<c<
00G0`<02c<c<00>IVIW<c<c<c<`00lc<c0800002c<c<0P000004c<c<0000
c<c<c<c<0P0000G<c<`2000000?<c<`0000000000/c<c08000000lc<c000
00000002c<c<0P0004k<c<`00iVIVLc<c<c<c005`<300/c<c0Wo0005c<c<
0P0000;<c<`010000<c<c000000000G<c<`2000000?<c<`0000000000/c<
c08000000lc<c0000000000300000lc<c4Wo0002c<c<ol30`070`<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<00G<c<`2
00000lc<c08000000lc<c00000000002c<c<0P000003c<c<0000000005c<
c<`00iVIVLc<c<c<c005`<300/c<c003VIVIc<c<c<c<00?<c<`200000/c<
c0800002c<c<00@0003<c<`000000005c<c<0P000003c<c<0000000000;<
c<`2000000C<c<`00000003<c<`20000Clc<c003VIVIc<c<c<c<00G0`<02
c<c<2Ol000G<c<`200000/c<c0040000c<c<000000001Lc<c08000000lc<
c00000000002c<c<0P000003c<c<0000000000800004c<c<BOl000;<c<co
`<300L30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<
c<c<c<`01Lc<c0800003c<c<0P000003c<c<0000000000;<c<`2000000?<
c<`000000000100005S<c<`00iVIVLc<c<c<c005`<300/c<c003VIVIc<c<
c<c<00O<c<`200000/c<c0040000c<c<000000001Lc<c08000000lc<c000
00000002c<c<0P000003c<c<0000000000<0001?c<c<00>IVIW<c<c<c<`0
1L30`0;<c<`9o`001Lc<c0800002c<c<00@0003<c<`000000005c<c<0P00
0005c<c<000000000000c<c<008000001<c<c00000000<c<c0800003c<c<
BOl000;<c<co`<300L30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<1IVIV@?<c<`200000lc<c08000000lc<c00000000002c<c<0P000003
c<c<0000000000;<c<`200000/c<c5NIVIT2c<c<1L30`0;<c<`5VIVI1Lc<
c0800002c<c<00@0003<c<`000000005c<c<0P000003c<c<0000000000;<
c<`2000000?<c<`0000000000P0000C<c<a=VIVI0/c<c0G0`<02c<c<2Ol0
00G<c<`200000/c<c0040000c<c<000000001Lc<c08000001<c<c0000000
0<c<c0800002c<c<0P0000;<c<`200000/c<c4Wo0002c<c<ol30`070`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h2/c<c0800003c<c<0P000003
c<c<0000000000;<c<`2000000?<c<`0000000000/c<c080001Kc<c<1L30
`0c<c<`200000/c<c0040000c<c<000000001Lc<c08000001Lc<c0000000
00000<c<c002000000C<c<`00000003<c<`20000D/c<c0G0`<0@c<c<0P00
00?<c<`300003lc<c080001Ac<c<ol30`070`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h2/c<c0800003c<c<1P000003c<c<0000000000;<c<`4
0000G<c<c0G0`<0<c<c<0P0000;<c<`010000<c<c000000000G<c<`20000
00C<c<`00000003<c<`200000/c<c0800002c<c<0P00057<c<`5`<304<c<
c0800003c<c<0`0000G<c<`200002<c<c080001Ac<c<ol30`070`<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h2/c<c0800006c<c<0P0000;<c<`2
0000H/c<c0G0`<0<c<c<0P0000?<c<`300003lc<c080001Ec<c<1L30`7[<
c<co`<300L30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P8c<c<1P00
0003c<c<0000000000;<c<`00`000<c<c<c<c0020000H/c<c0G0`<0<c<c<
0P0000?<c<`300001Lc<c0800008c<c<0P0005G<c<`5`<30N/c<c?o0`<01
`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^7[<c<`5`<30N/c<c0G0
`<1jc<c<ol30`070`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<
c0G0`<1jc<c<1L30`7[<c<co`<300L30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Qjc<c<1L30`7[<c<`5`<30N/c<c?o0`<01`<300XS0^058T8P1
0000000018S0^<SPf8S0^8S0^7[<c<`5`<30N/c<c0G0`<1jc<c<ol30`070
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0
^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;QjP8201L30`007ooooMgMgk^k^k^k^8R8RV@2IIS=V009V06H02C<0
<iUV014A4Lc<c>k^kWMgMlc<c?ooogMgM`02k^k^00<R8R:I09UV<fH00VH0
IP09<`0cVFH04A4Ac<c<k^k^MgMgc<c<ooooMgMg00;^k^h00b8R8YT0VFHc
IP02IP1V00Tc03>IIP0A4A7<c<c^k^igMgO<c<cooomgMgL00^k^kP038R8R
V@2IIS=V009V06H02C<0<iUV014A4Lc<c>k^kWMgMlc<c?ooogMgM`02k^k^
00<R8R:I09UV<fH00VH0IP09<`0cVFH04A4Ac<c<k^k^MgMgc<c<ooooMgMg
00;^k^h00b8R8YT0VFHcIP02IP1V00Tc03>IIP0A4A7<c<c^k^igMgO<c<co
oomgMgL00^k^kP038R8RV@2IIS=V009V06H02C<0<iUV014A4Lc<c>k^kWMg
Mlc<c?ooogMgM`02k^k^00<R8R:I09UV<fH00VH0IP03<`0c`<30`<3000?0
`<1jP8201L30`7[ob005`<30N_ooo`;0`<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hNX20P0G0`<001_ooodA4A>k^kYVIVA4A4DA4A0;<0<`019T0
V@0cI/bI07MgM`;^k^h027MgMlc<c?ooodA4A>k^kYVIVA4A4DA4A0;<0<`0
19T0V@0cI/bI07MgM`;^k^h027MgMlc<c?ooodA4A>k^kYVIVA4A4DA4A0;<
0<`019T0V@0cI/bI07MgM`;^k^h027MgMlc<c?ooodA4A>k^kYVIVA4A4DA4
A0;<0<`019T0V@0cI/bI07MgM`;^k^h027MgMlc<c?ooodA4A>k^kYVIVA4A
4DA4A0;<0<`019T0V@0cI/bI07MgM`;^k^h027MgMlc<c?ooodA4A>k^kYVI
VA4A4DA4A0;<0<`019T0V@0cI/bI07MgM`;^k^h027MgMlc<c?ooodA4A>k^
kYVIVA4A4DA4A0;<0<`019T0V@0cI/bI07MgM`;^k^h027MgMlc<c?ooodA4
A>k^kYVIVA4A4DA4A0;<0<`00iT0V@0cI/30`004`<30NX20P0G0`<1jolP0
1L30`7V>SXh00ooool30`<30`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hNX20P0G0`<002Ooooc<c<nk^kWMgMc<c<fIVIS<c<l`0c4A4A00203=V
00igMgO^k^k^k^igMgNk^k_ooolc<c?^k^igMgLc<c=VIVHc<c?<0<a4A4@2
03=V00igMgO^k^k^k^igMgNk^k_ooolc<c?^k^igMgLc<c=VIVHc<c?<0<a4
A4@203=V00igMgO^k^k^k^igMgNk^k_ooolc<c?^k^igMgLc<c=VIVHc<c?<
0<a4A4@203=V00igMgO^k^k^k^igMgNk^k_ooolc<c?^k^igMgLc<c=VIVHc
<c?<0<a4A4@203=V00igMgO^k^k^k^igMgNk^k_ooolc<c?^k^igMgLc<c=V
IVHc<c?<0<a4A4@203=V00igMgO^k^k^k^igMgNk^k_ooolc<c?^k^igMgLc
<c=VIVHc<c?<0<a4A4@203=V00mgMgO^k^k^k^igMgNk^k_ooolc<c?^k^ig
MgLc<c=VIVHc<c?<0<a4A4@0<fH01L30`7Z0P805`<30N_o800G0`<000hj>
S_ooool0001eo`0000B>SXkoooo0`<30`<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hNX20P0G0`<000oooogMgMnk^kP03k^k^00Jk^k]V<fKoooo^
k^jIVIV8R8P2k^k^00AgMgO<c<cooomgMgL4k^k^00Jk^k]V<fKoooo^k^jI
VIV8R8P2k^k^00AgMgO<c<cooomgMgL4k^k^00Jk^k]V<fKoooo^k^jIVIV8
R8P2k^k^00AgMgO<c<cooomgMgL4k^k^00Jk^k]V<fKoooo^k^jIVIV8R8P2
k^k^00AgMgO<c<cooomgMgL4k^k^00Jk^k]V<fKoooo^k^jIVIV8R8P2k^k^
00AgMgO<c<cooomgMgL4k^k^00Jk^k]V<fKoooo^k^jIVIV8R8P2k^k^00Ag
MgO<c<cooomgMgL4k^k^00Jk^k]V<fKoooo^k^jIVIV8R8P2k^k^00AgMgO<
c<cooomgMgL4k^k^00Bk^k]V<fKoooo^k^h5`<30NX20P0G0`<1jolP01L30
`003SXj>ooooo`0007C<c<`00ol008j>S_ooo`02`<300XS0^058T8P10000
000018S0^<SPf8S0^8S0^7Z0P805`<3000?ooolc<c?oool02nk^kP05MgMg
c<c<oooo<c<coooo00_^k^h01GMgMlc<c?oooc<c<oooo`0;k^k^00EgMgO<
c<cooolc<c?oool02nk^kP05MgMgc<c<oooo<c<coooo00_^k^h01GMgMlc<
c?oooc<c<oooo`0;k^k^00EgMgO<c<cooolc<c?oool02nk^kP05MgMgc<c<
oooo<c<coooo00O^k^h5`<301820P7;<c<`4P8201L30`7[ob005`<3000>>
SXkooooo0000M<c<c003o`00SXj>oooo00;0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hNX20P0G0`<000ooooc<c<gMgM`0<MgMg0_ooo`03<c<c
MgMgMgMg00]gMgL2oooo00<c<c=gMgMgMgL02gMgM`;oool00c<c<gMgMgMg
M`0;MgMg0_ooo`03<c<cMgMgMgMg00]gMgL2oooo00<c<c=gMgMgMgL02gMg
M`;oool00c<c<gMgMgMgM`0;MgMg0_ooo`03<c<cMgMgMgMg00IgMgL5`<30
1820P7;<c<`4P8201L30`7[ob005`<3000>>SXkooooo0000M<c<c003o`00
SXj>oooo00;0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hNX20P0G0
`<000oooohR8R4A4A006A4A400<c<c=4A4A4A4@00dA4A003VIVIooooR8R8
00M4A4@00c<c<dA4A4A4A003A4A400>IVIWooon8R8P01dA4A003<c<cA4A4
A4A400=4A4@00iVIVOooohR8R007A4A400<c<c=4A4A4A4@00dA4A003VIVI
ooooR8R800M4A4@00c<c<dA4A4A4A003A4A400>IVIWooon8R8P01dA4A003
<c<cA4A4A4A400=4A4@00iVIVOooohR8R007A4A400<c<c=4A4A4A4@00dA4
A003VIVIooooR8R800M4A4@00c<c<l30`<30`003`<301820P7;<c<`4P820
1L30`7[ob005`<3000>>SXkooooo0000M<c<c003o`00SXj>oooo00;0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hNX20P0G0`<000oooodA4A6IV
IP03MgMg00=VIVIgMgMgMgL01GMgM`05<c<cc<c<ooooA4A4IVIV00=gMgL0
0fIVIWMgMgMgM`05MgMg00Dc<c?<c<cooom4A4AVIVH00gMgM`03IVIVMgMg
MgMg00EgMgL01C<c<lc<c?ooodA4A6IVIP03MgMg00=VIVIgMgMgMgL01GMg
M`05<c<cc<c<ooooA4A4IVIV00=gMgL00fIVIWMgMgMgM`05MgMg00Dc<c?<
c<cooom4A4AVIVH00gMgM`03IVIVMgMgMgMg00EgMgL01C<c<lc<c?ooodA4
A6IVIP03MgMg00=VIVIgMgMgMgL01GMgM`05<c<cc<c<ooooA4A4IVIV00=g
MgL016IVIWMgMgMgMgMgM`G0`<04P820L/c<c0B0P805`<30N_o800G0`<00
0hj>S_ooool0001dc<c<00?o002>SXkoool00/30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;QjP8201L30`00<oooo<c<ck^k^k^k^^k^kMgMgZZZZ
ooook^k^gMgMMgMggMgM0^k^kP04MgMgc<c<oooo<c<c0^k^kP08^k^kMgMg
ZZZZooook^k^gMgMMgMggMgM0^k^kP04MgMgc<c<oooo<c<c0^k^kP08^k^k
MgMgZZZZooook^k^gMgMMgMggMgM0^k^kP04MgMgc<c<oooo<c<c0^k^kP08
^k^kMgMgZZZZooook^k^gMgMMgMggMgM0^k^kP04MgMgc<c<oooo<c<c0^k^
kP08^k^kMgMgZZZZooook^k^gMgMMgMggMgM0^k^kP04MgMgc<c<oooo<c<c
0^k^kP08^k^kMgMgZZZZooook^k^gMgMMgMggMgM0^k^kP04MgMgc<c<oooo
<c<c0^k^kP08^k^kMgMgZZZZooook^k^gMgMMgMggMgM0^k^kP04MgMgc<c<
oooo<c<c0^k^kP06^k^kMgMgZZZZooook^k^gMgM1L30`0B0P81bc<c<1820
P0G0`<08olP0J/c<c0Sob005`<3000>>SXkooooo0000M<c<c003o`00SXj>
oooo00;0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hNX20P0G0`<00
1_oooc<c<oooonk^kWMgM`0cc08c<`003TA4A3<0<`008VH0IWMgMoooogMg
Mk^k^ooooc<c<oooonk^kWMgM`0cc08c<`003TA4A3<0<`008VH0IWMgMooo
ogMgMk^k^ooooc<c<oooonk^kWMgM`0cc08c<`003TA4A3<0<`008VH0IWMg
MoooogMgMk^k^ooooc<c<oooonk^kWMgM`0cc08c<`003TA4A3<0<`008VH0
IWMgMoooogMgMk^k^ooooc<c<oooonk^kWMgM`0cc08c<`003TA4A3<0<`00
8VH0IWMgMoooogMgMk^k^ooooc<c<oooonk^kWMgM`0cc08c<`003TA4A3<0
<`008VH0IWMgMoooogMgMk^k^ooooc<c<oooonk^kWMgM`0cc08c<`003TA4
A3<0<`008VH0IWMgMoooogMgMk^k^ooooc<c<oooonk^kWMgM`0cc08c<`00
0dA4A3<0<l30`004`<301820P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0
`<000hj>S_ooool0001dc<c<00?o002>SXkoool00/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P:P820I/c<c0Z0P805`<3001;ooomgMgO^k^k^
k^iVIVH0I_l0I/a4A4@c03<c<c=gMgLc03>8R8S^k^iVIVK<c<cooomgMgL2
k^k^00iVIVH0I_l0I/a4A4@c03<c<c=gMgLc03>8R8S^k^iVIVK<c<cooomg
MgL2k^k^00iVIVH0I_l0I/a4A4@c03<c<c=gMgLc03>8R8S^k^iVIVK<c<co
oomgMgL2k^k^00iVIVH0I_l0I/a4A4@c03<c<c=gMgLc03>8R8S^k^iVIVK<
c<cooomgMgL2k^k^00iVIVH0I_l0I/a4A4@c03<c<c=gMgLc03>8R8S^k^iV
IVK<c<cooomgMgL2k^k^00iVIVH0I_l0I/a4A4@c03<c<c=gMgLc03>8R8S^
k^iVIVK<c<cooomgMgL2k^k^00iVIVH0I_l0I/a4A4@c03<c<c=gMgLc03>8
R8S^k^iVIVK<c<cooomgMgL2k^k^00IVIVH0I_l0I/a4A4@c03<c<c<5`<30
1820P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001d
c<c<00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P:P820I/c<c0Z0P805`<3000Gooolc<c?^k^kMgMdA4A400P1Vo`0><fK<
8R8RR8R8VIVI8R8RgMgMk^k^MgMgc<c<oooo<c<ck^k^gMgM4A4A0P1Vo`0>
<fK<8R8RR8R8VIVI8R8RgMgMk^k^MgMgc<c<oooo<c<ck^k^gMgM4A4A0P1V
o`0><fK<8R8RR8R8VIVI8R8RgMgMk^k^MgMgc<c<oooo<c<ck^k^gMgM4A4A
0P1Vo`0><fK<8R8RR8R8VIVI8R8RgMgMk^k^MgMgc<c<oooo<c<ck^k^gMgM
4A4A0P1Vo`0><fK<8R8RR8R8VIVI8R8RgMgMk^k^MgMgc<c<oooo<c<ck^k^
gMgM4A4A0P1Vo`0><fK<8R8RR8R8VIVI8R8RgMgMk^k^MgMgc<c<oooo<c<c
k^k^gMgM4A4A0P1Vo`0><fK<8R8RR8R8VIVI8R8RgMgMk^k^MgMgc<c<oooo
<c<ck^k^gMgM4A4A0P1Vo`03<fK<8R8RR8R800G0`<04P820L/c<c0B0P805
`<302?o806[<c<`8olP01L30`003SXj>ooooo`0007C<c<`00ol008j>S_oo
o`02`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0Z0P81Vc<c<2X20
P0G0`<001_oooc<c<nk^kS<c<c<0<`004@8R8R803P0c<c<0<a40000003<c
<k^k^gMgMk^k^ooooc<c<nk^kS<c<c<0<`004@8R8R803P0c<c<0<a400000
03<c<k^k^gMgMk^k^ooooc<c<nk^kS<c<c<0<`004@8R8R803P0c<c<0<a40
000003<c<k^k^gMgMk^k^ooooc<c<nk^kS<c<c<0<`004@8R8R803P0c<c<0
<a40000003<c<k^k^gMgMk^k^ooooc<c<nk^kS<c<c<0<`004@8R8R803P0c
<c<0<a40000003<c<k^k^gMgMk^k^ooooc<c<nk^kS<c<c<0<`004@8R8R80
3P0c<c<0<a40000003<c<k^k^gMgMk^k^ooooc<c<nk^kS<c<c<0<`004@8R
8R803P0c<c<0<a40000003<c<k^k^gMgMk^k^ooooc<c<nk^kS<c<c<0<`00
4@8R8R800`0c<c<0<l30`004`<301820P7;<c<`4P8201L30`0Sob01Zc<c<
2?o800G0`<000hj>S_ooool0001dc<c<00?o002>SXkoool00/30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P:P820I/c<c0Z0P805`<3001;ooomg
MgMV<fIV<fIgMgN8R8QVIVHc<`00<l`0I/`c06H0001V<fHc<c=gMgO<c<co
oomgMgL2IS=V00igMgN8R8QVIVHc<`00<l`0I/`c06H0001V<fHc<c=gMgO<
c<cooomgMgL2IS=V00igMgN8R8QVIVHc<`00<l`0I/`c06H0001V<fHc<c=g
MgO<c<cooomgMgL2IS=V00igMgN8R8QVIVHc<`00<l`0I/`c06H0001V<fHc
<c=gMgO<c<cooomgMgL2IS=V00igMgN8R8QVIVHc<`00<l`0I/`c06H0001V
<fHc<c=gMgO<c<cooomgMgL2IS=V00igMgN8R8QVIVHc<`00<l`0I/`c06H0
001V<fHc<c=gMgO<c<cooomgMgL2IS=V00igMgN8R8QVIVHc<`00<l`0I/`c
06H0001V<fHc<c=gMgO<c<cooomgMgL2IS=V00IgMgN8R8QVIVHc<`00<l`0
I/`5`<301820P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_oo
ool0001dc<c<00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P:P820I/c<c0Z0P805`<3000Wooom4A4@c03?<0<aV<fIVIVHA
002IIP3<V@000P1Vc0:I09T03;^k^gMgMlc<c?ooodA4A3<0<l`0c6HcIVIV
IQ4009UV0<bI0080I/`2V@2I00bk^k]gMgO<c<cooom4A4@c03?<0<aV<fIV
IVHA002IIP3<V@0206K<0YT0V@0<^k^kMgMgc<c<ooooA4A4<`0cc03<IS=V
IVIV4@00VFH0c9T00P1Vc0:I09T03;^k^gMgMlc<c?ooodA4A3<0<l`0c6Hc
IVIVIQ4009UV0<bI0080I/`2V@2I00bk^k]gMgO<c<cooom4A4@c03?<0<aV
<fIVIVHA002IIP3<V@0206K<0YT0V@0<^k^kMgMgc<c<ooooA4A4<`0cc03<
IS=VIVIV4@00VFH0c9T00P1Vc0:I09T03K^k^gMgMlc<c?ooodA4A3<0<l`0
c6HcIVIVIQ4009UV0<bI001Vc005`<301820P7;<c<`4P8201L30`0Sob01Z
c<c<2?o800G0`<000hj>S_ooool0001dc<c<00?o002>SXkoool00/30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P:P820I/c<c0Z0P805`<3000Co
oolc<c?<c<a4A4@2000000hc03=VIP3oc02IIP1V06K<0?mV06IV<fIgMgNk
^k_ooolc<c?<c<a4A4@2000000hc03=VIP3oc02IIP1V06K<0?mV06IV<fIg
MgNk^k_ooolc<c?<c<a4A4@2000000hc03=VIP3oc02IIP1V06K<0?mV06IV
<fIgMgNk^k_ooolc<c?<c<a4A4@2000000hc03=VIP3oc02IIP1V06K<0?mV
06IV<fIgMgNk^k_ooolc<c?<c<a4A4@2000000hc03=VIP3oc02IIP1V06K<
0?mV06IV<fIgMgNk^k_ooolc<c?<c<a4A4@2000000hc03=VIP3oc02IIP1V
06K<0?mV06IV<fIgMgNk^k_ooolc<c?<c<a4A4@2000000hc03=VIP3oc02I
IP1V06K<0?mV06IV<fIgMgNk^k_ooolc<c?<c<a4A4@2000000@c03=VIP3o
c02IIP05`<301820P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>
S_ooool0001dc<c<00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P:P820I/c<c0Z0P805`<3000OooomgMgO^k^k^k^hR8R:I
09UV<fH00VH0IP06<`0cVFH04A4Ac<c<k^k^MgMgFlc<c008VFH04A4Ac<c<
k^k^MgMgc<c<ooooMgMg0^k^kP038R8RV@2IIS=V009V06H00c<0<l30`<30
`003`<301820P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_oo
ool0001dc<c<00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P:P820I/c<c0Z0P805`<3000Kooom4A4C^k^jIVITA4A54A4@2
c03<00BI09T0<fK<V@1gMgL2k^k^00=gMgO<c<c<c<`0FLc<c00<c9T0MgMg
k^k^k^k^MgMgc<c<ooooA4A4k^k^VIVI4A4AA4A40/`0c003V@2I03=V`<30
00C0`<04P820L/c<c0B0P805`<302?o806[<c<`8olP01L30`003SXj>oooo
o`0007C<c<`00ol008j>S_ooo`02`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^0Z0P81Vc<c<2X20P0G0`<002Ooooc<c<nk^kWMgMc<c<fIVIS<c
<l`0c4A4A00203=V00EgMgO^k^k^k^igMgNk^k/0F/c<c00@03=VMgMgk^k^
k^k^MgMg^k^koooo<c<ck^k^MgMg<c<cIVIV<c<cc03<A4A403=V1L30`0B0
P81bc<c<1820P0G0`<08olP0J/c<c0Sob005`<3000>>SXkooooo0000M<c<
c003o`00SXj>oooo00;0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
2X20P6K<c<`:P8201L30`003ooooMgMgk^k^00?^k^h01[^k^fHcI_ooonk^
kYVIVHR8R0;^k^h00gMgMlc<c<c<c01Ic<c<00RIVIV8R8S^k^k^k^igMgO<
c<cooomgMgL4k^k^00Bk^k]V<fKoooo^k^h5`<301820P7;<c<`4P8201L30
`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001dc<c<00?o002>SXkoool0
0/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P:P820I/c<c0Z0P805
`<3000?ooolc<c?oool02nk^kP03MgMgc<c<c<c<05W<c<`4k^k^00EgMgO<
c<cooolc<c?oool01nk^kPG0`<04P820L/c<c0B0P805`<302?o806[<c<`8
olP01L30`003SXj>ooooo`0007C<c<`00ol008j>S_ooo`02`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^0Z0P81Vc<c<2X20P0G0`<000ooooc<c
<gMgM`0<MgMg00?oooo<c<c<c<`0F<c<c0EgMgL2oooo00<c<c=gMgMgMgL0
1WMgM`G0`<04P820L/c<c0B0P805`<302?o806[<c<`8olP01L30`003SXj>
ooooo`0007C<c<`00ol008j>S_ooo`02`<300XS0^058T8P10000000018S0
^<SPf8S0^8S0^0Z0P81Vc<c<2X20P0G0`<000oooohR8R4A4A006A4A400<c
<c=4A4A4A4@00dA4A003VIVIc<c<c<c<05S<c<`5A4A400>IVIWooon8R8P0
1dA4A003<c<c`<30`<3000?0`<04P820L/c<c0B0P805`<302?o806[<c<`8
olP01L30`003SXj>ooooo`0007C<c<`00ol008j>S_ooo`02`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^0Z0P81Vc<c<2X20P0G0`<000oooodA4
A6IVIP03MgMg00=VIVIgMgMgMgL01GMgM`03<c<cc<c<c<c<05W<c<`4MgMg
00Dc<c?<c<cooom4A4AVIVH00gMgM`04IVIVMgMgMgMgMgMg1L30`0B0P81b
c<c<1820P0G0`<08olP0J/c<c0Sob005`<3000>>SXkooooo0000M<c<c003
o`00SXj>oooo00;0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h2X20
P6K<c<`:P8201L30`00<oooo<c<ck^k^k^k^^k^kMgMgZZZZooook^k^gMgM
MgMggMgM0^k^kP03MgMgc<c<c<c<05W<c<`027MgMmgMgNk^k^k^kWMgMlc<
c?oooc<c<`;^k^h01[^k^gMgMjZZZ_ooonk^k]gMg@G0`<04P820L/c<c0B0
P805`<302?o806[<c<`8olP01L30`003SXj>ooooo`0007C<c<`00ol008j>
S_ooo`02`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0Z0P81Vc<c<
2X20P0G0`<001_oooc<c<oooonk^kWMgM`0cc08c<`0024A4A3<0<`008VH0
IWMgMoooogMgMk^k^e[<c<`030008VH0IWMgMoooogMgMk^k^ooooc<c<ooo
onk^kWMgM`0cc08c<`000dA4A3<0<l30`004`<301820P7;<c<`4P8201L30
`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001dc<c<00?o002>SXkoool0
0/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P:P820I/c<c0Z0P805
`<3000oooomgMgO^k^k^k^iVIVH0I_l0I/a4A4@c03<c<c=gMgLc03>8R8S^
k^iVIVH0Flc<c008MgMg<`0cR8R8k^k^IVIVc<c<ooooMgMg0^k^kP06IVIV
06Ko06K<A4A4<`0c<c<c1L30`0B0P81bc<c<1820P0G0`<08olP0J/c<c0So
b005`<3000>>SXkooooo0000M<c<c003o`00SXj>oooo00;0`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h2X20P6K<c<`:P8201L30`005oooo<c<c
k^k^gMgM4A4A0080I_l023=Vc28R8XR8R9VIVB8R8]gMgNk^kWMgMe_<c<`0
2iVIVB8R8]gMgNk^kWMgMlc<c?oooc<c<nk^k]gMgA4A4@0206Ko00<cI/`R
8R:8R8P01L30`0B0P81bc<c<1820P0G0`<08olP0J/c<c0Sob005`<3000>>
SXkooooo0000M<c<c003o`00SXj>oooo00;0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h2X20P6K<c<`:P8201L30`006oooo<c<ck^k^<c<c<`0c
000A0R8R8P0803<c<`0c4@000000<c<c^k^kMgMg^k^kF/c<c00<4@000000
<c<c^k^kMgMg^k^koooo<c<ck^k^<c<c<`0c000A0R8R8P0303<c<`0c`<30
00C0`<04P820L/c<c0B0P805`<302?o806[<c<`8olP01L30`003SXj>oooo
o`0007C<c<`00ol008j>S_ooo`02`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^0Z0P81Vc<c<2X20P0G0`<003oooogMgMfHcIVHcIWMgMhR8R6IV
IS<c000cc01Vc3<0IP0006HcIS<c<gMgM`1Kc<c<00Pc06H0001V<fHc<c=g
MgO<c<cooomgMgL2IS=V00IgMgN8R8QVIVHc<`00<l`0I/`5`<301820P7;<
c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001dc<c<00?o
002>SXkoool00/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P:P820
I/c<c0Z0P805`<3000Wooom4A4@c03?<0<aV<fIVIVHA002IIP3<V@000P1V
c0:I09T00k^k^gMgMlc<c01Jc<c<0100I/bI09VI09Vk^k]gMgO<c<cooom4
A4@c03?<0<aV<fIVIVHA002IIP3<V@00I/`5`<301820P7;<c<`4P8201L30
`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001dc<c<00?o002>SXkoool0
0/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P:P820I/c<c0Z0P805
`<3000Cooolc<c?<c<a4A4@2000000Xc03=VIP3oc02IIP1V06K<0?mV06IV
<fIgMgNk^k]Jc<c<00YV06K<0?mV06IV<fIgMgNk^k_ooolc<c?<c<a4A4@2
000000@c03=VIP3oc02IIP05`<301820P7;<c<`4P8201L30`0Sob01Zc<c<
2?o800G0`<000hj>S_ooool0001dc<c<00?o002>SXkoool00/30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P:P820I/c<c0Z0P805`<3000Oooomg
MgO^k^k^k^hR8R:I09UV<fH00VH0IP06<`0cVFH04A4Ac<c<k^k^MgMgFlc<
c008VFH04A4Ac<c<k^k^MgMgc<c<ooooMgMg0^k^kP038R8RV@2IIS=V009V
06H00c<0<l30`<30`003`<301820P7;<c<`4P8201L30`0Sob01Zc<c<2?o8
00G0`<000hj>S_ooool0001dc<c<00?o002>SXkoool00/30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P:P820I/c<c0Z0P805`<3000Kooom4A4C^
k^jIVITA4A54A4@2c03<00BI09T0<fK<V@1gMgL2k^k^00=gMgO<c<c<c<`0
FLc<c00<c9T0MgMgk^k^k^k^MgMgc<c<ooooA4A4k^k^VIVI4A4AA4A40/`0
c003V@2I03=V`<3000C0`<04P820L/c<c0B0P805`<302?o806[<c<`8olP0
1L30`003SXj>ooooo`0007C<c<`00ol008j>S_ooo`02`<300XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0Z0P81Vc<c<2X20P0G0`<002Ooooc<c<nk^
kWMgMc<c<fIVIS<c<l`0c4A4A00203=V00EgMgO^k^k^k^igMgNk^k/0F/c<
c00@03=VMgMgk^k^k^k^MgMg^k^koooo<c<ck^k^MgMg<c<cIVIV<c<cc03<
A4A403=V1L30`0B0P81bc<c<1820P0G0`<08olP0J/c<c0Sob005`<3000>>
SXkooooo0000M<c<c003o`00SXj>oooo00;0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h2X20P6K<c<`:P8201L30`003ooooMgMgk^k^00?^k^h0
1[^k^fHcI_ooonk^kYVIVHR8R0;^k^h00gMgMlc<c<c<c01Ic<c<00RIVIV8
R8S^k^k^k^igMgO<c<cooomgMgL4k^k^00Bk^k]V<fKoooo^k^h5`<301820
P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001dc<c<
00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P:
P820I/c<c0Z0P805`<3000?ooolc<c?oool02nk^kP03MgMgc<c<c<c<05W<
c<`4k^k^00EgMgO<c<cooolc<c?oool01nk^kPG0`<04P820L/c<c0B0P805
`<302?o806[<c<`8olP01L30`003SXj>ooooo`0007C<c<`00ol008j>S_oo
o`02`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0Z0P81Vc<c<2X20
P0G0`<000ooooc<c<gMgM`0<MgMg00?oooo<c<c<c<`0F<c<c0EgMgL2oooo
00<c<c=gMgMgMgL01WMgM`G0`<04P820L/c<c0B0P805`<302?o806[<c<`8
olP01L30`003SXj>ooooo`0007C<c<`00ol008j>S_ooo`02`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^0Z0P81Vc<c<2X20P0G0`<000oooohR8
R4A4A006A4A400<c<c=4A4A4A4@00dA4A003VIVIc<c<c<c<05S<c<`5A4A4
00>IVIWooon8R8P01dA4A003<c<c`<30`<3000?0`<04P820L/c<c0B0P805
`<302?o806[<c<`8olP01L30`003SXj>ooooo`0007C<c<`00ol008j>S_oo
o`02`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0Z0P81Vc<c<2X20
P0G0`<000oooodA4A6IVIP03MgMg00=VIVIgMgMgMgL01GMgM`03<c<cc<c<
c<c<05W<c<`4MgMg00Dc<c?<c<cooom4A4AVIVH00gMgM`04IVIVMgMgMgMg
MgMg1L30`0B0P81bc<c<1820P0G0`<08olP0J/c<c0Sob005`<3000>>SXko
oooo0000M<c<c003o`00SXj>oooo00;0`<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h2X20P6K<c<`:P8201L30`00<oooo<c<ck^k^k^k^^k^kMgMg
ZZZZooook^k^gMgMMgMggMgM0^k^kP03MgMgc<c<c<c<05W<c<`027MgMmgM
gNk^k^k^kWMgMlc<c?oooc<c<`;^k^h01[^k^gMgMjZZZ_ooonk^k]gMg@G0
`<04P820L/c<c0B0P805`<302?o806[<c<`8olP01L30`003SXj>ooooo`00
07C<c<`00ol008j>S_ooo`02`<300XS0^058T8P10000000018S0^<SPf8S0
^8S0^0Z0P81Vc<c<2X20P0G0`<001_oooc<c<oooonk^kWMgM`0cc08c<`00
24A4A3<0<`008VH0IWMgMoooogMgMk^k^e[<c<`030008VH0IWMgMoooogMg
Mk^k^ooooc<c<oooonk^kWMgM`0cc08c<`000dA4A3<0<l30`004`<301820
P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001dc<c<
00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P:
P820I/c<c0Z0P805`<3000oooomgMgO^k^k^k^iVIVH0I_l0I/a4A4@c03<c
<c=gMgLc03>8R8S^k^iVIVH0Flc<c008MgMg<`0cR8R8k^k^IVIVc<c<oooo
MgMg0^k^kP06IVIV06Ko06K<A4A4<`0c<c<c1L30`0B0P81bc<c<1820P0G0
`<08olP0J/c<c0Sob005`<3000>>SXkooooo0000M<c<c003o`00SXj>oooo
00;0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h2X20P6K<c<`:P820
1L30`005oooo<c<ck^k^gMgM4A4A0080I_l023=Vc28R8XR8R9VIVB8R8]gM
gNk^kWMgMe_<c<`02iVIVB8R8]gMgNk^kWMgMlc<c?oooc<c<nk^k]gMgA4A
4@0206Ko00<cI/`R8R:8R8P01L30`0B0P81bc<c<1820P0G0`<08olP0J/c<
c0Sob005`<3000>>SXkooooo0000M<c<c003o`00SXj>oooo00;0`<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h2X20P6K<c<`:P8201L30`006oooo
<c<ck^k^<c<c<`0c000A0R8R8P0803<c<`0c4@000000<c<c^k^kMgMg^k^k
F/c<c00<4@000000<c<c^k^kMgMg^k^koooo<c<ck^k^<c<c<`0c000A0R8R
8P0303<c<`0c`<3000C0`<04P820L/c<c0B0P805`<302?o806[<c<`8olP0
1L30`003SXj>ooooo`0007C<c<`00ol008j>S_ooo`02`<300XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0Z0P81Vc<c<2X20P0G0`<003oooogMgMfHc
IVHcIWMgMhR8R6IVIS<c000cc01Vc3<0IP0006HcIS<c<gMgM`1Kc<c<00Pc
06H0001V<fHc<c=gMgO<c<cooomgMgL2IS=V00IgMgN8R8QVIVHc<`00<l`0
I/`5`<301820P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_oo
ool0001dc<c<00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P:P820I/c<c0Z0P805`<3000Wooom4A4@c03?<0<aV<fIVIVHA
002IIP3<V@000P1Vc0:I09T00k^k^gMgMlc<c01Jc<c<0100I/bI09VI09Vk
^k]gMgO<c<cooom4A4@c03?<0<aV<fIVIVHA002IIP3<V@00I/`5`<301820
P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001dc<c<
00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P:
P820I/c<c0Z0P805`<3000Cooolc<c?<c<a4A4@2000000Xc03=VIP3oc02I
IP1V06K<0?mV06IV<fIgMgNk^k]Jc<c<00YV06K<0?mV06IV<fIgMgNk^k_o
oolc<c?<c<a4A4@2000000@c03=VIP3oc02IIP05`<301820P7;<c<`4P820
1L30`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001dc<c<00?o002>SXko
ool00/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P:P820I/c<c0Z0
P805`<3000OooomgMgO^k^k^k^hR8R:I09UV<fH00VH0IP06<`0cVFH04A4A
c<c<k^k^MgMgFlc<c008VFH04A4Ac<c<k^k^MgMgc<c<ooooMgMg0^k^kP03
8R8RV@2IIS=V009V06H00c<0<l30`<30`003`<301820P7;<c<`4P8201L30
`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001dc<c<00?o002>SXkoool0
0/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P:P820I/c<c0Z0P805
`<3000Kooom4A4C^k^jIVITA4A54A4@2c03<00BI09T0<fK<V@1gMgL2k^k^
00=gMgO<c<c<c<`0FLc<c00<c9T0MgMgk^k^k^k^MgMgc<c<ooooA4A4k^k^
VIVI4A4AA4A40/`0c003V@2I03=V`<3000C0`<04P820L/c<c0B0P805`<30
2?o806[<c<`8olP01L30`003SXj>ooooo`0007C<c<`00ol008j>S_ooo`02
`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0Z0P81Vc<c<2X20P0G0
`<002Ooooc<c<nk^kWMgMc<c<fIVIS<c<l`0c4A4A00203=V00EgMgO^k^k^
k^igMgNk^k/0F/c<c00@03=VMgMgk^k^k^k^MgMg^k^koooo<c<ck^k^MgMg
<c<cIVIV<c<cc03<A4A403=V1L30`0B0P81bc<c<1820P0G0`<08olP0J/c<
c0Sob005`<3000>>SXkooooo0000M<c<c003o`00SXj>oooo00;0`<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h2X20P6K<c<`:P8201L30`003oooo
MgMgk^k^00?^k^h01[^k^fHcI_ooonk^kYVIVHR8R0;^k^h00gMgMlc<c<c<
c01Ic<c<00RIVIV8R8S^k^k^k^igMgO<c<cooomgMgL4k^k^00Bk^k]V<fKo
ooo^k^h5`<301820P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>
S_ooool0001dc<c<00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P:P820I/c<c0Z0P805`<3000?ooolc<c?oool02nk^kP03
MgMgc<c<c<c<05W<c<`4k^k^00EgMgO<c<cooolc<c?oool01nk^kPG0`<04
P820L/c<c0B0P805`<302?o806[<c<`8olP01L30`003SXj>ooooo`0007C<
c<`00ol008j>S_ooo`02`<300XS0^058T8P10000000018S0^<SPf8S0^8S0
^0Z0P81Vc<c<2X20P0G0`<000ooooc<c<gMgM`0<MgMg00?oooo<c<c<c<`0
F<c<c0EgMgL2oooo00<c<c=gMgMgMgL01WMgM`G0`<04P820L/c<c0B0P805
`<302?o806[<c<`8olP01L30`003SXj>ooooo`0007C<c<`00ol008j>S_oo
o`02`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0Z0P81Vc<c<2X20
P0G0`<000oooohR8R4A4A006A4A400<c<c=4A4A4A4@00dA4A003VIVIc<c<
c<c<05S<c<`5A4A400>IVIWooon8R8P01dA4A003<c<c`<30`<3000?0`<04
P820L/c<c0B0P805`<302?o806[<c<`8olP01L30`003SXj>ooooo`0007C<
c<`00ol008j>S_ooo`02`<300XS0^058T8P10000000018S0^<SPf8S0^8S0
^0Z0P81Vc<c<2X20P0G0`<000oooodA4A6IVIP03MgMg00=VIVIgMgMgMgL0
1GMgM`03<c<cc<c<c<c<05W<c<`4MgMg00Dc<c?<c<cooom4A4AVIVH00gMg
M`04IVIVMgMgMgMgMgMg1L30`0B0P81bc<c<1820P0G0`<08olP0J/c<c0So
b005`<3000>>SXkooooo0000M<c<c003o`00SXj>oooo00;0`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h2X20P6K<c<`:P8201L30`00<oooo<c<c
k^k^k^k^^k^kMgMgZZZZooook^k^gMgMMgMggMgM0^k^kP03MgMgc<c<c<c<
05W<c<`027MgMmgMgNk^k^k^kWMgMlc<c?oooc<c<`;^k^h01[^k^gMgMjZZ
Z_ooonk^k]gMg@G0`<04P820L/c<c0B0P805`<302?o806[<c<`8olP01L30
`003SXj>ooooo`0007C<c<`00ol008j>S_ooo`02`<300XS0^058T8P10000
000018S0^<SPf8S0^8S0^0Z0P81Vc<c<2X20P0G0`<001_oooc<c<oooonk^
kWMgM`0cc08c<`0024A4A3<0<`008VH0IWMgMoooogMgMk^k^e[<c<`03000
8VH0IWMgMoooogMgMk^k^ooooc<c<oooonk^kWMgM`0cc08c<`000dA4A3<0
<l30`004`<301820P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>
S_ooool0001dc<c<00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P:P820I/c<c0Z0P805`<3000oooomgMgO^k^k^k^iVIVH0
I_l0I/a4A4@c03<c<c=gMgLc03>8R8S^k^iVIVH0Flc<c008MgMg<`0cR8R8
k^k^IVIVc<c<ooooMgMg0^k^kP06IVIV06Ko06K<A4A4<`0c<c<c1L30`0B0
P81bc<c<1820P0G0`<08olP0J/c<c0Sob005`<3000>>SXkooooo0000M<c<
c003o`00SXj>oooo00;0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
2X20P6K<c<`:P8201L30`005oooo<c<ck^k^gMgM4A4A0080I_l023=Vc28R
8XR8R9VIVB8R8]gMgNk^kWMgMe_<c<`02iVIVB8R8]gMgNk^kWMgMlc<c?oo
oc<c<nk^k]gMgA4A4@0206Ko00<cI/`R8R:8R8P01L30`0B0P81bc<c<1820
P0G0`<08olP0J/c<c0Sob005`<3000>>SXkooooo0000M<c<c003o`00SXj>
oooo00;0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h2X20P6K<c<`:
P8201L30`006oooo<c<ck^k^<c<c<`0c000A0R8R8P0803<c<`0c4@000000
<c<c^k^kMgMg^k^kF/c<c00<4@000000<c<c^k^kMgMg^k^koooo<c<ck^k^
<c<c<`0c000A0R8R8P0303<c<`0c`<3000C0`<04P820L/c<c0B0P805`<30
2?o806[<c<`8olP01L30`003SXj>ooooo`0007C<c<`00ol008j>S_ooo`02
`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0Z0P81Vc<c<2X20P0G0
`<003oooogMgMfHcIVHcIWMgMhR8R6IVIS<c000cc01Vc3<0IP0006HcIS<c
<gMgM`1Kc<c<00Pc06H0001V<fHc<c=gMgO<c<cooomgMgL2IS=V00IgMgN8
R8QVIVHc<`00<l`0I/`5`<301820P7;<c<`4P8201L30`0Sob01Zc<c<2?o8
00G0`<000hj>S_ooool0001dc<c<00?o002>SXkoool00/30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P:P820I/c<c0Z0P805`<3000Wooom4A4@c
03?<0<aV<fIVIVHA002IIP3<V@000P1Vc0:I09T00k^k^gMgMlc<c01Jc<c<
0100I/bI09VI09Vk^k]gMgO<c<cooom4A4@c03?<0<aV<fIVIVHA002IIP3<
V@00I/`5`<301820P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>
S_ooool0001dc<c<00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P:P820I/c<c0Z0P805`<3000Cooolc<c?<c<a4A4@20000
00Xc03=VIP3oc02IIP1V06K<0?mV06IV<fIgMgNk^k]Jc<c<00YV06K<0?mV
06IV<fIgMgNk^k_ooolc<c?<c<a4A4@2000000@c03=VIP3oc02IIP05`<30
1820P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001d
c<c<00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P:P820I/c<c0Z0P805`<3000OooomgMgO^k^k^k^hR8R:I09UV<fH00VH0
IP06<`0cVFH04A4Ac<c<k^k^MgMgFlc<c008VFH04A4Ac<c<k^k^MgMgc<c<
ooooMgMg0^k^kP038R8RV@2IIS=V009V06H00c<0<l30`<30`003`<301820
P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001dc<c<
00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P:
P820I/c<c0Z0P805`<3000Kooom4A4C^k^jIVITA4A54A4@2c03<00BI09T0
<fK<V@1gMgL2k^k^00=gMgO<c<c<c<`0FLc<c00<c9T0MgMgk^k^k^k^MgMg
c<c<ooooA4A4k^k^VIVI4A4AA4A40/`0c003V@2I03=V`<3000C0`<04P820
L/c<c0B0P805`<302?o806[<c<`8olP01L30`003SXj>ooooo`0007C<c<`0
0ol008j>S_ooo`02`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0Z0
P81Vc<c<2X20P0G0`<002Ooooc<c<nk^kWMgMc<c<fIVIS<c<l`0c4A4A002
03=V00EgMgO^k^k^k^igMgNk^k/0F/c<c00@03=VMgMgk^k^k^k^MgMg^k^k
oooo<c<ck^k^MgMg<c<cIVIV<c<cc03<A4A403=V1L30`0B0P81bc<c<1820
P0G0`<08olP0J/c<c0Sob005`<3000>>SXkooooo0000M<c<c003o`00SXj>
oooo00;0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h2X20P6K<c<`:
P8201L30`003ooooMgMgk^k^00?^k^h01[^k^fHcI_ooonk^kYVIVHR8R0;^
k^h00gMgMlc<c<c<c01Ic<c<00RIVIV8R8S^k^k^k^igMgO<c<cooomgMgL4
k^k^00Bk^k]V<fKoooo^k^h5`<301820P7;<c<`4P8201L30`0Sob01Zc<c<
2?o800G0`<000hj>S_ooool0001dc<c<00?o002>SXkoool00/30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P:P820I/c<c0Z0P805`<3000?ooolc
<c?oool02nk^kP03MgMgc<c<c<c<05W<c<`4k^k^00EgMgO<c<cooolc<c?o
ool01nk^kPG0`<04P820L/c<c0B0P805`<302?o806[<c<`8olP01L30`003
SXj>ooooo`0007C<c<`00ol008j>S_ooo`02`<300XS0^058T8P100000000
18S0^<SPf8S0^8S0^0Z0P81Vc<c<2X20P0G0`<000ooooc<c<gMgM`0<MgMg
00?oooo<c<c<c<`0F<c<c0EgMgL2oooo00<c<c=gMgMgMgL01WMgM`G0`<04
P820L/c<c0B0P805`<302?o806[<c<`8olP01L30`003SXj>ooooo`0007C<
c<`00ol008j>S_ooo`02`<300XS0^058T8P10000000018S0^<SPf8S0^8S0
^0Z0P81Vc<c<2X20P0G0`<000oooohR8R4A4A006A4A400<c<c=4A4A4A4@0
0dA4A003VIVIooooR8R800M4A4@00c<c<dA4A4A4A003A4A400>IVIWooon8
R8P01dA4A003<c<cA4A4A4A400=4A4@00iVIVOooohR8R007A4A400<c<c=4
A4A4A4@00dA4A003VIVIooooR8R800M4A4@00c<c<dA4A4A4A003A4A400>I
VIWooon8R8P01dA4A003<c<cA4A4A4A400=4A4@00iVIVOooohR8R007A4A4
00<c<c=4A4A4A4@00dA4A003VIVIooooR8R800M4A4@00c<c<l30`<30`003
`<301820P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0
001dc<c<00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P:P820I/c<c0Z0P805`<3000?ooom4A4AVIVH00gMgM`03IVIVMgMg
MgMg00EgMgL01C<c<lc<c?ooodA4A6IVIP03MgMg00=VIVIgMgMgMgL01GMg
M`05<c<cc<c<ooooA4A4IVIV00=gMgL00fIVIWMgMgMgM`05MgMg00Dc<c?<
c<cooom4A4AVIVH00gMgM`03IVIVMgMgMgMg00EgMgL01C<c<lc<c?ooodA4
A6IVIP03MgMg00=VIVIgMgMgMgL01GMgM`05<c<cc<c<ooooA4A4IVIV00=g
MgL00fIVIWMgMgMgM`05MgMg00Dc<c?<c<cooom4A4AVIVH00gMgM`03IVIV
MgMgMgMg00EgMgL01C<c<lc<c?ooodA4A6IVIP03MgMg00AVIVIgMgMgMgMg
MgL5`<301820P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_oo
ool0001dc<c<00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P:P820I/c<c0Z0P805`<3000cooolc<c?^k^k^k^jk^k]gMgNZ
ZZ[oooo^k^kMgMegMgOMgMd2k^k^00AgMgO<c<cooolc<c<2k^k^00Rk^k]g
MgNZZZ[oooo^k^kMgMegMgOMgMd2k^k^00AgMgO<c<cooolc<c<2k^k^00Rk
^k]gMgNZZZ[oooo^k^kMgMegMgOMgMd2k^k^00AgMgO<c<cooolc<c<2k^k^
00Rk^k]gMgNZZZ[oooo^k^kMgMegMgOMgMd2k^k^00AgMgO<c<cooolc<c<2
k^k^00Rk^k]gMgNZZZ[oooo^k^kMgMegMgOMgMd2k^k^00AgMgO<c<cooolc
<c<2k^k^00Rk^k]gMgNZZZ[oooo^k^kMgMegMgOMgMd2k^k^00AgMgO<c<co
oolc<c<2k^k^00Rk^k]gMgNZZZ[oooo^k^kMgMegMgOMgMd2k^k^00AgMgO<
c<cooolc<c<2k^k^00Jk^k]gMgNZZZ[oooo^k^kMgMd5`<301820P7;<c<`4
P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001dc<c<00?o002>
SXkoool00/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P:P820I/c<
c0Z0P805`<3000Kooolc<c?oooo^k^igMgL0<l`2<c<000i4A4@c03<0029V
06IgMgOooomgMgNk^k_ooolc<c?oooo^k^igMgL0<l`2<c<000i4A4@c03<0
029V06IgMgOooomgMgNk^k_ooolc<c?oooo^k^igMgL0<l`2<c<000i4A4@c
03<0029V06IgMgOooomgMgNk^k_ooolc<c?oooo^k^igMgL0<l`2<c<000i4
A4@c03<0029V06IgMgOooomgMgNk^k_ooolc<c?oooo^k^igMgL0<l`2<c<0
00i4A4@c03<0029V06IgMgOooomgMgNk^k_ooolc<c?oooo^k^igMgL0<l`2
<c<000i4A4@c03<0029V06IgMgOooomgMgNk^k_ooolc<c?oooo^k^igMgL0
<l`2<c<000i4A4@c03<0029V06IgMgOooomgMgNk^k_ooolc<c?oooo^k^ig
MgL0<l`2<c<000=4A4@c03?0`<001<30`0B0P81bc<c<1820P0G0`<08olP0
J/c<c0Sob005`<3000>>SXkooooo0000M<c<c003o`00SXj>oooo00;0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h2X20P6K<c<`:P8201L30`00B
ooooMgMgk^k^k^k^IVIV06Ko06K<A4A4<`0c<c<cMgMg<`0cR8R8k^k^IVIV
c<c<ooooMgMg0^k^kP0>IVIV06Ko06K<A4A4<`0c<c<cMgMg<`0cR8R8k^k^
IVIVc<c<ooooMgMg0^k^kP0>IVIV06Ko06K<A4A4<`0c<c<cMgMg<`0cR8R8
k^k^IVIVc<c<ooooMgMg0^k^kP0>IVIV06Ko06K<A4A4<`0c<c<cMgMg<`0c
R8R8k^k^IVIVc<c<ooooMgMg0^k^kP0>IVIV06Ko06K<A4A4<`0c<c<cMgMg
<`0cR8R8k^k^IVIVc<c<ooooMgMg0^k^kP0>IVIV06Ko06K<A4A4<`0c<c<c
MgMg<`0cR8R8k^k^IVIVc<c<ooooMgMg0^k^kP0>IVIV06Ko06K<A4A4<`0c
<c<cMgMg<`0cR8R8k^k^IVIVc<c<ooooMgMg0^k^kP06IVIV06Ko06K<A4A4
<`0c<c<c1L30`0B0P81bc<c<1820P0G0`<08olP0J/c<c0Sob005`<3000>>
SXkooooo0000M<c<c003o`00SXj>oooo00;0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h2X20P6K<c<`:P8201L30`005oooo<c<ck^k^gMgM4A4A
0080I_l03S=Vc28R8XR8R9VIVB8R8]gMgNk^kWMgMlc<c?oooc<c<nk^k]gM
gA4A4@80I_l03S=Vc28R8XR8R9VIVB8R8]gMgNk^kWMgMlc<c?oooc<c<nk^
k]gMgA4A4@80I_l03S=Vc28R8XR8R9VIVB8R8]gMgNk^kWMgMlc<c?oooc<c
<nk^k]gMgA4A4@80I_l03S=Vc28R8XR8R9VIVB8R8]gMgNk^kWMgMlc<c?oo
oc<c<nk^k]gMgA4A4@80I_l03S=Vc28R8XR8R9VIVB8R8]gMgNk^kWMgMlc<
c?oooc<c<nk^k]gMgA4A4@80I_l03S=Vc28R8XR8R9VIVB8R8]gMgNk^kWMg
Mlc<c?oooc<c<nk^k]gMgA4A4@80I_l03S=Vc28R8XR8R9VIVB8R8]gMgNk^
kWMgMlc<c?oooc<c<nk^k]gMgA4A4@80I_l00c=Vc28R8XR8R005`<301820
P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001dc<c<
00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qj
P8201L30`006oooo<c<ck^k^<c<c<`0c000A0R8R8P0>03<c<`0c4@000000
<c<c^k^kMgMg^k^koooo<c<ck^k^<c<c<`0c000A0R8R8P0>03<c<`0c4@00
0000<c<c^k^kMgMg^k^koooo<c<ck^k^<c<c<`0c000A0R8R8P0>03<c<`0c
4@000000<c<c^k^kMgMg^k^koooo<c<ck^k^<c<c<`0c000A0R8R8P0>03<c
<`0c4@000000<c<c^k^kMgMg^k^koooo<c<ck^k^<c<c<`0c000A0R8R8P0>
03<c<`0c4@000000<c<c^k^kMgMg^k^koooo<c<ck^k^<c<c<`0c000A0R8R
8P0>03<c<`0c4@000000<c<c^k^kMgMg^k^koooo<c<ck^k^<c<c<`0c000A
0R8R8P0>03<c<`0c4@000000<c<c^k^kMgMg^k^koooo<c<ck^k^<c<c<`0c
000A0R8R8P0303<c<`0c`<3000C0`<04P820L/c<c0B0P805`<302?o806[<
c<`8olP01L30`003SXj>ooooo`0007C<c<`00ol008j>S_ooo`02`<300XS0
^058T8P10000000018S0^<SPf8S0^8S0^7Z0P805`<3001;ooomgMgMV<fIV
<fIgMgN8R8QVIVHc<`00<l`0I/`c06H0001V<fHc<c=gMgO<c<cooomgMgL2
IS=V00igMgN8R8QVIVHc<`00<l`0I/`c06H0001V<fHc<c=gMgO<c<cooomg
MgL2IS=V00igMgN8R8QVIVHc<`00<l`0I/`c06H0001V<fHc<c=gMgO<c<co
oomgMgL2IS=V00igMgN8R8QVIVHc<`00<l`0I/`c06H0001V<fHc<c=gMgO<
c<cooomgMgL2IS=V00igMgN8R8QVIVHc<`00<l`0I/`c06H0001V<fHc<c=g
MgO<c<cooomgMgL2IS=V00igMgN8R8QVIVHc<`00<l`0I/`c06H0001V<fHc
<c=gMgO<c<cooomgMgL2IS=V00igMgN8R8QVIVHc<`00<l`0I/`c06H0001V
<fHc<c=gMgO<c<cooomgMgL2IS=V00IgMgN8R8QVIVHc<`00<l`0I/`5`<30
1820P7;<c<`4P8201L30`0Sob01Zc<c<2?o800G0`<000hj>S_ooool0001d
c<c<00?o002>SXkoool00/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;QjP8201L30`009ooooA4A4<`0cc03<IS=VIVIV4@00VFH0c9T00080I/`2
V@2I00bk^k]gMgO<c<cooom4A4@c03?<0<aV<fIVIVHA002IIP3<V@0206K<
0YT0V@0<^k^kMgMgc<c<ooooA4A4<`0cc03<IS=VIVIV4@00VFH0c9T00P1V
c0:I09T03;^k^gMgMlc<c?ooodA4A3<0<l`0c6HcIVIVIQ4009UV0<bI0080
I/`2V@2I00bk^k]gMgO<c<cooom4A4@c03?<0<aV<fIVIVHA002IIP3<V@02
06K<0YT0V@0<^k^kMgMgc<c<ooooA4A4<`0cc03<IS=VIVIV4@00VFH0c9T0
0P1Vc0:I09T03;^k^gMgMlc<c?ooodA4A3<0<l`0c6HcIVIVIQ4009UV0<bI
0080I/`2V@2I00fk^k]gMgO<c<cooom4A4@c03?<0<aV<fIVIVHA002IIP3<
V@00I/`01L30`0B0P81bc<c<1820P0G0`<1jolP01L30`003SXj>ooooo`00
07C<c<`00ol008j>S_ooo`02`<300XS0^058T8P10000000018S0^<SPf8S0
^8S0^7Z0P805`<3000Cooolc<c?<c<a4A4@2000000hc03=VIP3oc02IIP1V
06K<0?mV06IV<fIgMgNk^k_ooolc<c?<c<a4A4@2000000hc03=VIP3oc02I
IP1V06K<0?mV06IV<fIgMgNk^k_ooolc<c?<c<a4A4@2000000hc03=VIP3o
c02IIP1V06K<0?mV06IV<fIgMgNk^k_ooolc<c?<c<a4A4@2000000hc03=V
IP3oc02IIP1V06K<0?mV06IV<fIgMgNk^k_ooolc<c?<c<a4A4@2000000hc
03=VIP3oc02IIP1V06K<0?mV06IV<fIgMgNk^k_ooolc<c?<c<a4A4@20000
00hc03=VIP3oc02IIP1V06K<0?mV06IV<fIgMgNk^k_ooolc<c?<c<a4A4@2
000000hc03=VIP3oc02IIP1V06K<0?mV06IV<fIgMgNk^k_ooolc<c?<c<a4
A4@2000000@c03=VIP3oc02IIP05`<301820P7;<c<`4P8201L30`7[ob005
`<3000>>SXkooooo0000M<c<c003o`00SXj>oooo00;0`<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hNX20P0G0`<001oooogMgMnk^k^k^kR8R8YT0
VFHcIP02IP1V00Tc03>IIP0A4A7<c<c^k^igMgO<c<cooomgMgL00^k^kP03
8R8RV@2IIS=V009V06H02C<0<iUV014A4Lc<c>k^kWMgMlc<c?ooogMgM`02
k^k^00<R8R:I09UV<fH00VH0IP09<`0cVFH04A4Ac<c<k^k^MgMgc<c<oooo
MgMg00;^k^h00b8R8YT0VFHcIP02IP1V00Tc03>IIP0A4A7<c<c^k^igMgO<
c<cooomgMgL00^k^kP038R8RV@2IIS=V009V06H02C<0<iUV014A4Lc<c>k^
kWMgMlc<c?ooogMgM`02k^k^00<R8R:I09UV<fH00VH0IP09<`0cVFH04A4A
c<c<k^k^MgMgc<c<ooooMgMg00;^k^h00b8R8YT0VFHcIP02IP1V00Tc03>I
IP0A4A7<c<c^k^igMgO<c<cooomgMgL00^k^kP038R8RV@2IIS=V009V06H0
0c<0<l30`<30`003`<301820P7;<c<`4P8201L30`7[ob005`<3000>>SXko
oooo0000M<c<c003o`00SXj>oooo00;0`<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hNX20P0G0`<001_ooodA4A>k^kYVIVA4A4DA4A0;<0<`019T0
V@0cI/bI07MgM`;^k^h027MgMlc<c?ooodA4A>k^kYVIVA4A4DA4A0;<0<`0
19T0V@0cI/bI07MgM`;^k^h027MgMlc<c?ooodA4A>k^kYVIVA4A4DA4A0;<
0<`019T0V@0cI/bI07MgM`;^k^h027MgMlc<c?ooodA4A>k^kYVIVA4A4DA4
A0;<0<`019T0V@0cI/bI07MgM`;^k^h027MgMlc<c?ooodA4A>k^kYVIVA4A
4DA4A0;<0<`019T0V@0cI/bI07MgM`;^k^h027MgMlc<c?ooodA4A>k^kYVI
VA4A4DA4A0;<0<`019T0V@0cI/bI07MgM`;^k^h027MgMlc<c?ooodA4A>k^
kYVIVA4A4DA4A0;<0<`019T0V@0cI/bI07MgM`;^k^h027MgMlc<c?ooodA4
A>k^kYVIVA4A4DA4A0;<0<`00iT0V@0cI/30`004`<301820P7;<c<`4P820
1L30`7[ob005`<3000>>SXkooooo0000M<c<c003o`00SXj>oooo00;0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hNX20P0G0`<002Ooooc<c<nk^
kWMgMc<c<fIVIS<c<l`0c4A4A00203=V00igMgO^k^k^k^igMgNk^k_ooolc
<c?^k^igMgLc<c=VIVHc<c?<0<a4A4@203=V00igMgO^k^k^k^igMgNk^k_o
oolc<c?^k^igMgLc<c=VIVHc<c?<0<a4A4@203=V00igMgO^k^k^k^igMgNk
^k_ooolc<c?^k^igMgLc<c=VIVHc<c?<0<a4A4@203=V00igMgO^k^k^k^ig
MgNk^k_ooolc<c?^k^igMgLc<c=VIVHc<c?<0<a4A4@203=V00igMgO^k^k^
k^igMgNk^k_ooolc<c?^k^igMgLc<c=VIVHc<c?<0<a4A4@203=V00igMgO^
k^k^k^igMgNk^k_ooolc<c?^k^igMgLc<c=VIVHc<c?<0<a4A4@203=V00mg
MgO^k^k^k^igMgNk^k_ooolc<c?^k^igMgLc<c=VIVHc<c?<0<a4A4@0<fH0
1L30`7Z0P805`<30N_o800G0`<000hj>S_ooool0001dc<c<00?o002>SXko
ool00/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QjP8201L30`003
ooooMgMgk^k^00?^k^h01[^k^fHcI_ooonk^kYVIVHR8R0;^k^h017MgMlc<
c?ooogMgM`C^k^h01[^k^fHcI_ooonk^kYVIVHR8R0;^k^h017MgMlc<c?oo
ogMgM`C^k^h01[^k^fHcI_ooonk^kYVIVHR8R0;^k^h017MgMlc<c?ooogMg
M`C^k^h01[^k^fHcI_ooonk^kYVIVHR8R0;^k^h017MgMlc<c?ooogMgM`C^
k^h01[^k^fHcI_ooonk^kYVIVHR8R0;^k^h017MgMlc<c?ooogMgM`C^k^h0
1[^k^fHcI_ooonk^kYVIVHR8R0;^k^h017MgMlc<c?ooogMgM`C^k^h01[^k
^fHcI_ooonk^kYVIVHR8R0;^k^h017MgMlc<c?ooogMgM`C^k^h01;^k^fHc
I_ooonk^kPG0`<1jP8201L30`7[ob005`<3000>>SXkooooo0000MOl00004
SXj>oooo`<30`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^7Z0P805
`<3000?ooolc<c?oool02nk^kP05MgMgc<c<oooo<c<coooo00_^k^h01GMg
Mlc<c?oooc<c<oooo`0;k^k^00EgMgO<c<cooolc<c?oool02nk^kP05MgMg
c<c<oooo<c<coooo00_^k^h01GMgMlc<c?oooc<c<oooo`0;k^k^00EgMgO<
c<cooolc<c?oool02nk^kP05MgMgc<c<oooo<c<coooo00O^k^h5`<30NX20
P0G0`<1jolP01L30`003SXj>oooooooo07Goool018j>S_oool30`<30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;QjP8201L30`003oooo<c<cMgMg
00agMgL2oooo00<c<c=gMgMgMgL02gMgM`;oool00c<c<gMgMgMgM`0;MgMg
0_ooo`03<c<cMgMgMgMg00]gMgL2oooo00<c<c=gMgMgMgL02gMgM`;oool0
0c<c<gMgMgMgM`0;MgMg0_ooo`03<c<cMgMgMgMg00]gMgL2oooo00<c<c=g
MgMgMgL01WMgM`G0`<1jP8201L30`7[ob005`<30NHj>SP03oooo`<30`<30
00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P1000000001XS0^<SPf8S0
^8S0^?ooolc<c7QSHf<5`<3000>>SXk<c<coool0Moooo`G0`<000ooo0<c<
c000o`1g003o1L30`003003oc<c<ool007Ooo`05`<3000<00?o<c<co0000
Mol000;0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0_ooogK<c<`0
0hj>SV=SHl30`004`<300Xj>SWK<c<`2oooo1L30`0;oo`1fc<c<0P00o`G0
`<02003oM/c<c0;oo`05`<300P00ogK<c<`0103o0?l00<30`<30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0
`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<0
0?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30`<000l30`003ool0003o
c<c<07K<c<`00ol00<30`<30`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003
oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<
c003ool0`<30`<3000?0`<000ooo0000olc<c01fc<c<00?o0030`<30`<00
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30
`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30`<30`003`<300_oo07O<
c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo0<30`<30`003`<3000?o
o`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01f
c<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<00?o0`<30`<000l30`080
0?mgc<c<00?oo`30`<30`<000l30`003ool0003oc<c<07K<c<`00ol00<30
`<30`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=S
Hl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02
ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<c003ool0`<30`<3000?0
`<000ooo0000olc<c01fc<c<00?o0030`<30`<000XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>
c<c<07K<c<`00ooool30`<30`003`<300_oo07O<c<`00`00ol30`<30`003
`<300P00ogO<c<`00ooo0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003
o`00`<30`<3000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<
c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<00
0l30`0;oo`1gc<c<00<00?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30
`<000l30`003ool0003oc<c<07K<c<`00ol00<30`<30`002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=S
Hf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30
`<3000?0`<02003oMlc<c003ool0`<30`<3000?0`<000ooo0000olc<c01f
c<c<00?o0030`<30`<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0;o
oomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30
`<30`003`<300_oo07O<c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo
0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0
`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<0
0?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30`<000l30`003ool0003o
c<c<07K<c<`00ol00<30`<30`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003
oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<
c003ool0`<30`<3000?0`<000ooo0000olc<c01fc<c<00?o0030`<30`<00
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30
`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30`<30`003`<300_oo07O<
c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo0<30`<30`003`<3000?o
o`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01f
c<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<00?o0`<30`<000l30`080
0?mgc<c<00?oo`30`<30`<000l30`003ool0003oc<c<07K<c<`00ol00<30
`<30`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=S
Hl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02
ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<c003ool0`<30`<3000?0
`<000ooo0000olc<c01fc<c<00?o0030`<30`<000XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>
c<c<07K<c<`00ooool30`<30`003`<300_oo07O<c<`00`00ol30`<30`003
`<300P00ogO<c<`00ooo0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003
o`00`<30`<3000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<
c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<00
0l30`0;oo`1gc<c<00<00?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30
`<000l30`003ool0003oc<c<07K<c<`00ol00<30`<30`002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=S
Hf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30
`<3000?0`<02003oMlc<c003ool0`<30`<3000?0`<000ooo0000olc<c01f
c<c<00?o0030`<30`<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0;o
oomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30
`<30`003`<300_oo07O<c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo
0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0
`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<0
0?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30`<000l30`003ool0003o
c<c<07K<c<`00ol00<30`<30`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003
oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<
c003ool0`<30`<3000?0`<000ooo0000olc<c01fc<c<00?o0030`<30`<00
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30
`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30`<30`003`<300_oo07O<
c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo0<30`<30`003`<3000?o
o`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01f
c<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<00?o0`<30`<000l30`080
0?mgc<c<00?oo`30`<30`<000l30`003ool0003oc<c<07K<c<`00ol00<30
`<30`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=S
Hl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02
ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<c003ool0`<30`<3000?0
`<000ooo0000olc<c01fc<c<00?o0030`<30`<000XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>
c<c<07K<c<`00ooool30`<30`003`<300_oo07O<c<`00`00ol30`<30`003
`<300P00ogO<c<`00ooo0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003
o`00`<30`<3000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<
c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<00
0l30`0;oo`1gc<c<00<00?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30
`<000l30`003ool0003oc<c<07K<c<`00ol00<30`<30`002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=S
Hf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30
`<3000?0`<02003oMlc<c003ool0`<30`<3000?0`<000ooo0000olc<c01f
c<c<00?o0030`<30`<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0;o
oomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30
`<30`003`<300_oo07O<c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo
0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0
`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<0
0?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30`<000l30`003ool0003o
c<c<07K<c<`00ol00<30`<30`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003
oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<
c003ool0`<30`<3000?0`<000ooo0000olc<c01fc<c<00?o0030`<30`<00
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30
`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30`<30`003`<300_oo07O<
c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo0<30`<30`003`<3000?o
o`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01f
c<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<00?o0`<30`<000l30`080
0?mgc<c<00?oo`30`<30`<000l30`003ool0003oc<c<07K<c<`00ol00<30
`<30`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=S
Hl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02
ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<c003ool0`<30`<3000?0
`<000ooo0000olc<c01fc<c<00?o0030`<30`<000XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>
c<c<07K<c<`00ooool30`<30`003`<300_oo07O<c<`00`00ol30`<30`003
`<300P00ogO<c<`00ooo0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003
o`00`<30`<3000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<
c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<00
0l30`0;oo`1gc<c<00<00?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30
`<000l30`003ool0003oc<c<07K<c<`00ol00<30`<30`002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=S
Hf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30
`<3000?0`<02003oMlc<c003ool0`<30`<3000?0`<000ooo0000olc<c01f
c<c<00?o0030`<30`<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0;o
oomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30
`<30`003`<300_oo07O<c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo
0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0
`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<0
0?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30`<000l30`003ool0003o
c<c<07K<c<`00ol00<30`<30`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003
oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<
c003ool0`<30`<3000?0`<000ooo0000olc<c01fc<c<00?o0030`<30`<00
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30
`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30`<30`003`<300_oo07O<
c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo0<30`<30`003`<3000?o
o`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01f
c<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<00?o0`<30`<000l30`080
0?mgc<c<00?oo`30`<30`<000l30`003ool0003oc<c<07K<c<`00ol00<30
`<30`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=S
Hl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02
ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<c003ool0`<30`<3000?0
`<000ooo0000olc<c01fc<c<00?o0030`<30`<000XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>
c<c<07K<c<`00ooool30`<30`003`<300_oo07O<c<`00`00ol30`<30`003
`<300P00ogO<c<`00ooo0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003
o`00`<30`<3000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<
c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<00
0l30`0;oo`1gc<c<00<00?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30
`<000l30`003ool0003oc<c<07K<c<`00ol00<30`<30`002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=S
Hf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30
`<3000?0`<02003oMlc<c003ool0`<30`<3000?0`<000ooo0000olc<c01f
c<c<00?o0030`<30`<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0;o
oomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30
`<30`003`<300_oo07O<c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo
0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0
`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<0
0?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30`<000l30`003ool0003o
c<c<07K<c<`00ol00<30`<30`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003
oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<
c003ool0`<30`<3000?0`<000ooo0000olc<c01fc<c<00?o0030`<30`<00
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30
`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30`<30`003`<300_oo07O<
c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo0<30`<30`003`<3000?o
o`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01f
c<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<00?o0`<30`<000l30`080
0?mgc<c<00?oo`30`<30`<000l30`003ool0003oc<c<07K<c<`00ol00<30
`<30`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=S
Hl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02
ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<c003ool0`<30`<3000?0
`<000ooo0000olc<c01fc<c<00?o0030`<30`<000XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>
c<c<07K<c<`00ooool30`<30`003`<300_oo07O<c<`00`00ol30`<30`003
`<300P00ogO<c<`00ooo0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003
o`00`<30`<3000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<
c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<00
0l30`0;oo`1gc<c<00<00?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30
`<000l30`003ool0003oc<c<07K<c<`00ol00<30`<30`002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=S
Hf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30
`<3000?0`<02003oMlc<c003ool0`<30`<3000?0`<000ooo0000olc<c01f
c<c<00?o0030`<30`<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0;o
oomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30
`<30`003`<300_oo07O<c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo
0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0
`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<0
0?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30`<000l30`003ool0003o
c<c<07K<c<`00ol00<30`<30`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003
oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<
c003ool0`<30`<3000?0`<000ooo0000olc<c01fc<c<00?o0030`<30`<00
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30
`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30`<30`003`<300_oo07O<
c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo0<30`<30`003`<3000?o
o`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01f
c<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<00?o0`<30`<000l30`080
0?mgc<c<00?oo`30`<30`<000l30`003ool0003oc<c<07K<c<`00ol00<30
`<30`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=S
Hl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02
ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<c003ool0`<30`<3000?0
`<000ooo0000olc<c01fc<c<00?o0030`<30`<000XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>
c<c<07K<c<`00ooool30`<30`003`<300_oo07O<c<`00`00ol30`<30`003
`<300P00ogO<c<`00ooo0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003
o`00`<30`<3000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<
c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<00
0l30`0;oo`1gc<c<00<00?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30
`<000l30`003ool0003oc<c<07K<c<`00ol00<30`<30`002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=S
Hf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30
`<3000?0`<02003oMlc<c003ool0`<30`<3000?0`<000ooo0000olc<c01f
c<c<00?o0030`<30`<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0;o
oomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30
`<30`003`<300_oo07O<c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo
0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0
`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<0
0?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30`<000l30`003ool0003o
c<c<07K<c<`00ol00<30`<30`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003
oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<
c003ool0`<30`<3000?0`<000ooo0000olc<c01fc<c<00?o0030`<30`<00
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30
`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30`<30`003`<300_oo07O<
c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo0<30`<30`003`<3000?o
o`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01f
c<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<00?o0`<30`<000l30`080
0?mgc<c<00?oo`30`<30`<000l30`003ool0003oc<c<07K<c<`00ol00<30
`<30`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=S
Hl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02
ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<c003ool0`<30`<3000?0
`<000ooo0000olc<c01fc<c<00?o0030`<30`<000XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>
c<c<07K<c<`00ooool30`<30`003`<300_oo07O<c<`00`00ol30`<30`003
`<300P00ogO<c<`00ooo0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003
o`00`<30`<3000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<
c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<00
0l30`0;oo`1gc<c<00<00?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30
`<000l30`003ool0003oc<c<07K<c<`00ol00<30`<30`002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=S
Hf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30
`<3000?0`<02003oMlc<c003ool0`<30`<3000?0`<000ooo0000olc<c01f
c<c<00?o0030`<30`<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0;o
oomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30
`<30`003`<300_oo07O<c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo
0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0
`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<0
0?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30`<000l30`003ool0003o
c<c<07K<c<`00ol00<30`<30`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003
oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<
c003ool0`<30`<3000?0`<000ooo0000olc<c01fc<c<00?o0030`<30`<00
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30
`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30`<30`003`<300_oo07O<
c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo0<30`<30`003`<3000?o
o`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2ooooMlc<c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01f
c<c<00?oooo0`<30`<000l30`0;oo`1gc<c<00<00?o0`<30`<000l30`080
0?mgc<c<00?oo`30`<30`<000l30`003ool0003oc<c<07K<c<`00ol00<30
`<30`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=S
Hl30`<30`003`<3000=SHf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02
ool0Mlc<c003003o`<30`<3000?0`<02003oMlc<c003ool0`<30`<3000?0
`<000ooo0000olc<c01fc<c<00?o0030`<30`<000XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;ooomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>
c<c<07K<c<`00ooool30`<30`003`<300_oo07O<c<`00`00ol30`<30`003
`<300P00ogO<c<`00ooo0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003
o`00`<30`<3000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooMlc<
c003Hf=S`<30`<3000?0`<000f=SHhj>S/c<c01fc<c<00?oooo0`<30`<00
0l30`0;oo`1gc<c<00<00?o0`<30`<000l30`0800?mgc<c<00?oo`30`<30
`<000l30`003ool0003oc<c<07K<c<`00ol00<30`<30`002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0_ooogO<c<`00f=SHl30`<30`003`<3000=S
Hf>>SXk<c<`0M/c<c003oooo`<30`<3000?0`<02ool0Mlc<c003003o`<30
`<3000?0`<02003oMlc<c003ool0`<30`<3000?0`<000ooo0000olc<c01f
c<c<00?o0030`<30`<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0;o
oomgc<c<00=SHf?0`<30`<000l30`003Hf=SSXj>c<c<07K<c<`00ooool30
`<30`003`<300_oo07O<c<`00`00ol30`<30`003`<300P00ogO<c<`00ooo
0<30`<30`003`<3000?oo`000?o<c<`0M/c<c003o`00`<30`<3000:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3ooooM/c<c003Hf=S`<30`<3000?0
`<000f=SHhj>SXj>SP1fc<c<00?oooo0`<30`<000l30`0?oo`1fc<c<00<0
0?o0`<30`<000l30`0<00?mfc<c<00?oo`30`<30`<000l30`003ool0003o
003o07K<c<`00ol00<30`<30`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hNOooo`03c<c<`<30`<3000?0`<02Hf=SMhj>SP03c<c<`<30`<3000?0
`<1iool000?<c<c0`<30`<000l30`7T00?l00lc<c<30`<30`003`<300_oo
07L00?l00lc<c<30`<30`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
N_ooo`G0`<1iHf=S00>>SXk0`<30`<000l30`7[oo`05`<30NP00o`G0`<1i
ool000<00?o0`<30`<000XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0
`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30
`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<30
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hNV=SH`G0`<000hj>S_ooooooo`1goooo1L30
`7X00?l5`<3000<00?ooo`3oo`00Mooo00G0`<1jo`000/30`0:8`;P1B928
0@00000000F8`;S8h=R8`;R8`;Soool0N8j>SP03Hf=S`<30`<3000?0`<00
0hj>SV=SHoooo`1goooo1L30`003ool0003o003o07L00?l5`<300P00ogSo
o`05`<3000?oo`00o`00o`00MP3o0003o`00`<30`<3000:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>
SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2
ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<00
0hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<
c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0
`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00
ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<30
00C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<30
0P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S
`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5
`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30
`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>
Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c080
0?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l0
0<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003
SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<
c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o
0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<
c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0
M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0
103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2oooo
M/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02
ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<
c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0
`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<
07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_oo
o`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003o
c<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<
0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0
003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01e
c<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003
ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<
c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30
`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=S
Hlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool0
1L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>
SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2
ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<00
0hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<
c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0
`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00
ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<30
00C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<30
0P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S
`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5
`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30
`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>
Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c080
0?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l0
0<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003
SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<
c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o
0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<
c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0
M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0
103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2oooo
M/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02
ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<
c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0
`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<
07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_oo
o`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003o
c<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<
0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0
003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01e
c<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003
ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<
c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30
`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=S
Hlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool0
1L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>
SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2
ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<00
0hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<
c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0
`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00
ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<30
00C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<30
0P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S
`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5
`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30
`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>
Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c080
0?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l0
0<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003
SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<
c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o
0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<
c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0
M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0
103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2oooo
M/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02
ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<
c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0
`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<
07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_oo
o`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003o
c<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<
0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0
003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01e
c<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003
ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<
c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30
`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=S
Hlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool0
1L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>
SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2
ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<00
0hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<
c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0
`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00
ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<30
00C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<30
0P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S
`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5
`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30
`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>
Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c080
0?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l0
0<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003
SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<
c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o
0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<
c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0
M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0
103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2oooo
M/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02
ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<
c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0
`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<
07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_oo
o`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003o
c<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<
0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0
003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01e
c<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003
ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<
c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30
`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=S
Hlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool0
1L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>
SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2
ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<00
0hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<
c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0
`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00
ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<30
00C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<30
0P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S
`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5
`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30
`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>
Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c080
0?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l0
0<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003
SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<
c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o
0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<
c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0
M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0
103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2oooo
M/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02
ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<
c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0
`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<
07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_oo
o`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003o
c<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<
0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003ool0
003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01e
c<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30`003
ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=SHlc<
c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool01L30
`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>SV=S
Hlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2ool0
1L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<000hj>
SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<c<`2
ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0`<00
0hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00ogK<
c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<3000C0
`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<300P00
ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S`<30
00C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5`<30
0P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30`<30
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>Hf=S
`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c0800?l5
`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l00<30
`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003SXj>
Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<c080
0?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o0?l0
0<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2ooooM/c<c003
SXj>Hf=S`<3000C0`<000hj>SV=SHlc<c01ec<c<0_ooo`G0`<02ool0M/c<
c0800?l5`<300P00ogK<c<`2ool01L30`003ool0003oc<c<07G<c<`0103o
0?l00<30`<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qhoooo00>>
SXiSHf?0`<001<30`003SXj>Hf=SHf=S07ISHf<00ooool30`<30`003`<30
N?oo00800?l5`<30N@00o`03ool0`<30`<3000?0`<000ooo0000o`00o`1e
003o00@0o`3o0030`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
NOooo`03Hf=S`<30`<3000?0`<1jSXj>1L30`7Woo`000`00ol30`<30`003
`<30NP00o`G0`<1iool000?o0030`<30`<000XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
ol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o
`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<1jSXj>1L30
`7[oool5`<30NP00o`G0`<1jool00/30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Qjc<c<1L30`7Woool00hj>S/30`<30`003`<30NHj>SP03oooo
`<30`<3000?0`<1iool000<00?o0`<30`<000l30`7T00?l00ooo0<30`<30
`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<
07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o
`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<
00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004
`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<
c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0`<001<30`003
SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`000?o<c<`0MLc<
c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@00?ooo`30`<30
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>
S/c<c01ec<c<00?ooon>SXk0`<001<30`003SXj>ooooc<c<07G<c<`00hj>
S_oool30`004`<3000?oo`000?o<c<`0MLc<c003ool0003o`<3000C0`<00
0`00oooo0<c<c01ec<c<00@00?ooo`30`<30`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hN/c<c0G0`<000oooohj>S/c<c01ec<c<00?ooon>SXk0
`<001<30`003SXj>ooooc<c<07G<c<`00hj>S_oool30`004`<3000?oo`00
0?o<c<`0MLc<c003ool0003o`<3000C0`<000`00oooo0<c<c01ec<c<00@0
0?ooo`30`<30`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hN/c<c0G0
`<000oooohj>SXj>SP1eSXj>00?ooon>SXk0`<001<30`003SXj>oooooooo
07Goool00hj>S_oool30`004`<3000?oo`000?l00?l0M@00o`03ool0003o
`<3000C0`<000`00oooo0?oo001eool000@00?ooo`30`<30`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hN/c<c0G0`<1ioooo00>>SXk0`<30`<00
0l30`7V>SXh00ooool30`<30`003`<30NOoo0003003o`<30`<3000?0`<1i
003o00?oo`30`<30`<000XS0^058T8P1000000000hS0^<SPf8S0^03oR<2h
ohS0^7f8`;P1B9280@00000000B8`;S8h=R8`;R8`;PF00200`01P0800X00
1002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h81
288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?
Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP3
5hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX3
11n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DW
S@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y02
1Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP03
1cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`Lk
U@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`04
2D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX3
2T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M
00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ03
35^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<
HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eW
Y0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>
L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX3
3gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]
0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl3
4XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8B
SK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C
]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<D
W;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T3
5J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm
0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l3
5k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P4002000>KYo4c
@jDc@jD02C=3Y@H0080300600P02P00400:100>100>100>10`04P@801H40
1005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;
P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>7
0QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<I
R@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@4
98`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5
:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I42
1S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC
00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H0
10Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9
AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@
W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP03
2eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ43
35jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S
0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H2
3VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ003
3g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l
[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<A
Pjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa
4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc
0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H3
59Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<E
WkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX
^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G
[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0<008001i^WlOooohij]ZJKa;>YdZRMb;>YdP02YY_4
00Fl^=g^k_CZjO7ooolc@jD01@00P0<00H0200:000@00X400h400h400h43
00B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V3
0`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR003
0aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A
1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC
0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH3
23nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9
AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>
V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aM
X@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ80
0PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD4
3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?
LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1j
Z`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61
[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@B
RK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb
4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D3
59Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh
5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<0P00000QRd
`10000026;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080080019^W
lOooofaJYJnUbP:l^=d02_omok>Yd_oooooookbhgIN:_:RMb>KVk?oooc=3
Y@@0080300600P02P00400:100>100>100>10`04P@801H401005PP06PP06
PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q003
0@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<K
R@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d4
9Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[
S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO
00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y
00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n
[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64
[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P04
59Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl
00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G
/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=Q8T8Q8T8P034R@R0030000b>3H
B92800e8T8P0100001Rd`1Rd`<SPf0i8T8P00`0001Rd`1Rd`002R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P00;VjOaooooZ9g8oooo/jWBH4bJ
SWZfN6F^Z9g8oooooogo00?oool00c=3Y@00P000P00300200`01P0800X00
1002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h81
288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?
Q@8248D3oooo0P8AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`04
0aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX3
11j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=
00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I03
1Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86
=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`Lj
U0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88
@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX3
2DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M
0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl3
35ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<
H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eV
Y0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>
KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT3
3gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]
0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl4
4HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb
4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d
00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLD
VkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT3
5J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[
_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`03
5k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P03HS0^005
B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000jKYo7ooooooooKg>aPC9ZCQKZcZM:l
^=ePC9ZISkjVVlC8`moooolc@jD600200oooo`800X000`02POooooooo`02
oooo0P04P@0300F1oooo00F200<01X84oooo00<1288128?oool00oooo`<1
2X<01_ooo`4;Q04;Q04<Q?ooo`4<Q0813H@01?ooo`4>QOooo`4>Q@823hD0
1?ooo`8@QOooo`8@Q@824HH00oooo`8AQP8BQP020Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@04
0aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`4
98d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5
:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A
00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7
>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9
AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN
2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ
0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X
3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@
OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh0
0a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@
/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf
0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<F
ZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000C8h=R8`;R8`;R8`;P60000
18S0^003B9280000b>3H00:8`;P900000XS0^005B92800006;C06;C0b>3H
00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3002000jKYo7ooonl^=fISkkooooFdMgKg>cco_nVVlC^k_B5M[2CQK[o
oolc@jD4002000Ooool00H000H000H3oool00X3oool00`03P@06oooo00B1
00B100F1oooo00F20P06PP08oooo00N200N20@N2oooo0@R2oooo0@R30`49
P`04oooo0@Z30@Z3oooo0P4;Q0030@b4oooo0@b400813H@01?ooo`4>QOoo
o`4>Q@823hD00oooo`8@QOooo`03oooo0P8AQP<24XH20Q>600@24hL258L2
58L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@3
6XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@T
S@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZ
S`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y40
10HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`Lh
T`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G
246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6
V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:
DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;
Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ42
35nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS
00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH0
10i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?
LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m
[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P03
4HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[43
4X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c
0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH2
59Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^003
5J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY
_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G
/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<001<SPf8S0^8S0^8S0^0H00004
R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0
^4R@R00000026;C000C8h=R8`;R8`;R8`;P2000018S0^0800002R<2h00A8
T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00?
VjOaooooVHnnUhZle=?XkjbcogIkkYn[FeRUYY_4UYoBH4bJ_;SMoooo<d>U
00<008001oooo`01P001P001P?ooo`02P?ooo`0300>100Koool01840187o
ool01H7oool200J200Soool01h801h811h;oool128;oool128<30@V300Wo
ool12X?oool12h?oool12hCoool138Coool00P4=Q004oooo0@j5oooo0@j5
0P8?Q@04oooo0Q25oooo0Q25108AQP<24XH20Q>600@24hL258L258L258L3
0QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^9
0`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@U
S@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?
10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHc
TPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0Lh
U0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G
246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI
0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:
DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil0
0`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<
Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=
IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^
Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT0
10mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/
47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_
4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:<
/@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`03
4i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@D
V[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i
5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`0
11J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa
_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038
h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C0
00?8h=R8`;R8`;P00XS0^0800002R<2h0P0000>8`;P014R@R00001Rd`1Rd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000ZKYo7ooonGR[aj
K:ZcanRYKZ38`mnCQKYKAY>ISkh2N6F^00A29hF_YL[ooolc@jD400200`01
P003oooo00:000:100Coool200B100?oool01H7oool00`06PPCoool00`48
PP48P`48P`030@V300Woool12X?oool12h?oool12hCoool138Coool00P4=
Q004oooo0@j5oooo0@j50P8?Q@03oooo0Q25oooo00?oool20Q660`8BQP82
4hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<3
6HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<
10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DY
SP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946
<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<3
1cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8
?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5
V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK
0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]E
WP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ
35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP02
3F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>
JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0ma
Z0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[
0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^
00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9
/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8C
Sk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<D
UkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PE
W[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk
0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^
_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2h
R<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000
R<2hR<2hB9280000008H]<000lSPf8S0^8S0^003R<2h100000B8`;P014R@
R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000>K
Yo7oooooool00_ooo`0:ojf`ogIknLgDoNg^ooooYY_4QGJ`_;SMoooo<d>U
1@00P0<00H000oooo`02P002P@0300>100?oool0187oool00P05P@0400F2
oooo00J200J20P07PP030@N2oooo0@R2008128<3oooo0P4:P`07oooo0@^3
oooo0@^4oooo0@b4oooo00813H@01?ooo`4>QOooooooo`823hD01_ooo`8@
QOooo`8@Q@8AQ_ooo`824HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`82
5XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X3
0af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=
0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l3
1Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86
<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`Li
U0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8
@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T3
2DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M
0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l4
2eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R
362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT
00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>
KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T3
3gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n
[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`03
4HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:<
/Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B
]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g
59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@04
5J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`F
ZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG
/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8
`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3H
R<2hR<2h00B8`;P200001HS0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0<008002Z6/l_W=e>8V??Be_n8V??A]OOcSjOoo
oog]k_n]/0;oool00c=3Y@00P000P00400200`01P003oooo00:000:100?o
ool200B100Goool01H401H401H;oool00P06PP?oool20@R200<128?oool1
2H<00P49P`812X<01?ooo`4;P`4;Q?ooo`8138@01oooo`4=Q04=Q?ooo`4>
QOooo`4>Q@02oooo00<23hD248D248D01?ooo`040Q660Q:60Q:60Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028
`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8`;P4000018S0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008003I^W
lOg]k^8V??ken?N9UoARK_>P[_ARK_omoon]/?cSjOoooc=3Y@0700200`01
P003oooo00:000:100<00h4300B10P05P@0400F200J200J200J20P07PP05
0@N20@R20@R2oooo0@R300<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@3
0@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ7
00@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<M
RP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<5
9Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]
T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B
0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@3
1cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G
0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9
VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;
DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]I
W`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaP
XPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY003
3FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW
0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`me
Z@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@
Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65
[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8B
SK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@C
T[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK
]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ
^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m
5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o
00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h
00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0
^8S0^002R<2h0P0000:8`;P200000hS0^004B92800006;C06;C00XS0^058
T8P10000000018S0^<SPf8S0^8S0^08008000i^WlOK8c>8V?002ojf`00OO
92koY9kf_<Go[K3^Nhcooolc@jD02000P0<00H000oooo`02P002P@0300>1
0`04P@801H401005PP06PP06PP06PP801h801@47PP48PP48P_ooo`48P`03
0@V300Coool12X<12X<12h<20@^40`4<Q0<13H@30@j50`8?Q@<248D40Q66
0`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP3
0aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<4
8H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP03
1BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46
<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB
0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE
10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH
2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:
CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;
E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX004
35bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeR
XPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU
0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0ma
Z0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@
NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]
4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08B
RK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<C
S[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe
0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@E
WKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<F
YKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd0
0aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003
b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@R000
01Rd`1Rd`<SPf003R<2h0P0000B8`;P200000XS0^004B92800006;C06;C0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^08008000i^WlOW=e?N9U`02
oooo00Oo[K3Q5SCoMW_oY9kR9ScoRGlc@jD02000P0<00H000oooo`02P002
P@0300>10`04P@801H401005PP06PP06PP06PP801h801047PP48PP48PP48
P`Coool30@Z300<12h<12h@12h@00`4<Q0813H@01?ooo`4>Q@4>Q@4>Q@<2
3hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ8
0aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:
0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<5
9hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@
0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=980
0`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7
>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL0
10U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ
0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]C
W@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP
0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82
366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=
Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL2
3W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ
0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o
[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_
0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb
4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<C
Tk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL3
59bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i
0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/
_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o
0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0T00002
R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0^058
T8P10000000018S0^<SPf8S0^8S0^08008001i^WlOoooo>P[_ARK_ooooN9
UoW=e002oooo00?cX:kooolc@jD02000P0<00H0200:000@00X400h400h40
0h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<3
0@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<2
4XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<H
R0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;
0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DX
SP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A
1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP02
1cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8
?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4
V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK
0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN
00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aL
X@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=
HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>
JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?
LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[
0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61
[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`
00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb
4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<D
U[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh
5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj
0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G
[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSP
f8S0^8S0^00;R<2h00=8T8P00038h=P03HS0^005B92800006;C06;C0b>3H
00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3002000^KYo7oooooRGooooocX:kaTj7ooooooOocX:kono`c@jD02000
P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J200J200J2
0P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@3
0@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF7
0P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<L
RP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@85
9Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/
S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHc
TPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU003
1cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G
0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8
V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:
DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]H
W`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<
H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=
IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^
Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010md
Z@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]
47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_
00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@04
4Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c
4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LD
VkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i
00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[
_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa
_aNa_`035k:o0aNc_`8H]<0?b>3H00<00038h=S8h=P03LSPf00300006;C0
6;C000o8h=P00`0001Rd`1Rd`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1000P0>KYo401_oooo>P[_Be_oJlaO_IfS=3Y@T0080300600P02P004
00:100>100>100>10`04P@801H401005PP06PP06PP06PP801h800`47PP48
PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn5
0`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<4
7h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=
1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086
;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7
=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9
@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:
BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<
Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`
Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?
MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd3
4H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<B
Qk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d
0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL
]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d2
5jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G
/klf6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^1H0080300600P02
P00400:100>100>100>10`04P@801H401005PP06PP06PP06PP801h800`47
PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD3
0Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<F
R0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@N
RP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@03
1BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^
T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB
00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@3
1c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G
00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:
VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;
Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJ
X0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R
0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@3
3FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW
0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mf
ZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8A
Ojd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166
[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=
/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]003
4i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g
0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR
^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF
[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb
_`<G/klf6;C00XS0^058T8P1000000000hS0^<SPf8S0^03oR<2hohS0^7f8
`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@R0400000
0003R<2hb>3Hb>3H0?o8h=Sob>3HOLSPf058T8P10000003oR<2hohS0^868
`;P100000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?oo
l?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`
l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003o
oo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;o
l?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^0002ooooogWoU9BD2?oooomioiBDU?ooooooQOoo
ool000;ok^k^00?oU9BDonk^k_o^k^h0MOo^k^h00onDU9Cok^k^onk^kP06
onk^kP03oiBDU?o^k^kok^k^07Gok^k^00?oU9BDonk^k_o^k^h01_o^k^ih
ool00?ook^k^1Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0MOoVi^H00onD
U9Coi^KVonKViP06onKViP03oiBDU?oVi^Koi^KV07Goi^KV00?oU9BDonKV
i_oVi^H01_oVi^Ihool00?ooi^KV1OoVi^H000;ok^k^00?oU9BDonk^k_o^
k^h0MOo^k^h00onDU9Cok^k^onk^kP06onk^kP03oiBDU?o^k^kok^k^07Go
k^k^00?oU9BDonk^k_o^k^h01_o^k^ihool00?ook^k^1Oo^k^h000;ooooo
00?oU9BDooooooooool0MOooool00onDU9Coooooooooo`06ooooo`03oiBD
U?oooooooooo07Gooooo00?oU9BDooooooooool01_oooomhool00?oooooo
1Oooool000;ok^k^00?oU9BDonk^k_o^k^h0MOo^k^h00onDU9Cok^k^onk^
kP06onk^kP03oiBDU?o^k^kok^k^07Gok^k^00?oU9BDonk^k_o^k^h01_o^
k^ihool00?ook^k^1Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0MOoVi^H0
0onDU9Coi^KVonKViP06onKViP03oiBDU?oVi^Koi^KV07Goi^KV00?oU9BD
onKVi_oVi^H01_oVi^H5ool006koi^KV1Ooo003oonKViPGoi^KV0002onk^
kP03oiBDU?o^k^kok^k^07Gok^k^00?oU9BDonk^k_o^k^h01_o^k^h00onD
U9Cok^k^onk^kP1eonk^kP03oiBDU?o^k^kok^k^00Kok^k^1Ooo001^onk^
kPGoo`00ooo^k^h5onk^kP000_ooool00onDU9Coooooooooo`1eooooo`03
oiBDU?oooooooooo00Kooooo00?oU9BDooooooooool0MOooool00onDU9Co
ooooooooo`06ooooo`Goo`00K_ooool5ool00?oooooo1Oooool000;ok^k^
00?oU9BDonk^k_o^k^h0MOo^k^h00onDU9Cok^k^onk^kP06onk^kP03oiBD
U?o^k^kok^k^07Gok^k^00?oU9BDonk^k_o^k^h01_o^k^h5ool006kok^k^
1Ooo003oonk^kPGok^k^0002onKViP03oiBDU?oVi^Koi^KV07Goi^KV00?o
U9BDonKVi_oVi^H01_oVi^H00onDU9Coi^KVonKViP1eonKViP03oiBDU?oV
i^Koi^KV00Koi^KV1Ooo001^onKViPGoo`00oooVi^H5onKViP000_o^k^h0
0onDU9Cok^k^onk^kP1eonk^kP03oiBDU?o^k^kok^k^00Kok^k^00?oU9BD
onk^k_o^k^h0MOo^k^h00onDU9Cok^k^onk^kP06onk^kPGoo`00K_o^k^h5
ool00?ook^k^1Oo^k^h000;ooooo00?oU9BDooooooooool0MOooool00onD
U9Coooooooooo`06ooooo`03oiBDU?oooooooooo07Gooooo00?oU9BDoooo
ooooool01_ooool5ool006kooooo1Ooo003oooooo`Gooooo0002onk^kP03
oiBDU?o^k^kok^k^07Gok^k^00?oU9BDonk^k_o^k^h01_o^k^h00onDU9Co
k^k^onk^kP1eonk^kP03oiBDU?o^k^kok^k^00Kok^k^1Ooo001^onk^kPGo
o`00ooo^k^h5onk^kP000_oVi^H00onDU9Coi^KVonKViP1eonKViP03oiBD
U?oVi^Koi^KV00Koi^KV00?oU9BDonKVi_oVi^H0MOoVi^H00onDU9Coi^KV
onKViP06onKViPGoo`00K_oVi^H5ool00?ooi^KV1OoVi^H000;ok^k^00?o
U9BDonk^k_o^k^h0MOo^k^h00onDU9Cok^k^onk^kP06onk^kP03oiBDU?o^
k^kok^k^07Gok^k^00?oU9BDonk^k_o^k^h01_o^k^h5ool006kok^k^1Ooo
003oonk^kPGok^k^0002ooooo`03oiBDU?oooooooooo07Gooooo00?oU9BD
ooooooooool01_ooool00onDU9Coooooooooo`1eooooo`03oiBDU?oooooo
oooo00Kooooo1Ooo001^ooooo`Goo`00ooooool5ooooo`000_o^k^h00onD
U9Cok^k^onk^kP1eonk^kP03oiBDU?o^k^kok^k^00Kok^k^00?oU9BDonk^
k_o^k^h0MOo^k^h00onDU9Cok^k^onk^kP06onk^kPGoo`00K_o^k^h5ool0
0?ook^k^1Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0MOoVi^H00onDU9Co
i^KVonKViP06onKViP03oiBDU?oVi^Koi^KV07Goi^KV00?oU9BDonKVi_oV
i^H01_oVi^H5ool006koi^KV1Ooo003oonKViPGoi^KV0002onk^kP03oiBD
U?o^k^kok^k^07Gok^k^00?oU9BDonk^k_o^k^h01_o^k^h00onDU9Cok^k^
onk^kP1eonk^kP03oiBDU?o^k^kok^k^00Kok^k^1Ooo001^onk^kPGoo`00
ooo^k^h5onk^kP000_ooool00onDU9Coooooooooo`1eooooo`03oiBDU?oo
oooooooo00Kooooo00?oU9BDooooooooool0MOooool00onDU9Cooooooooo
o`06ooooo`Goo`00K_ooool5ool00?oooooo1Oooool000;ok^k^00?oU9BD
onk^k_o^k^h0MOo^k^h00onDU9Cok^k^onk^kP06onk^kP03oiBDU?o^k^ko
k^k^07Gok^k^00?oU9BDonk^k_o^k^h01_o^k^h5ool006kok^k^1Ooo003o
onk^kPGok^k^0002onKViP03oiBDU?oVi^Koi^KV07Goi^KV00?oU9BDonKV
i_oVi^H01_oVi^H00onDU9Coi^KVonKViP1eonKViP03oiBDU?oVi^Koi^KV
00Koi^KV1Ooo001^onKViPGoo`00oooVi^H5onKViP000_o^k^h00onDU9Co
k^k^onk^kP1eonk^kP03oiBDU?o^k^kok^k^00Kok^k^00?oU9BDonk^k_o^
k^h0MOo^k^h00onDU9Cok^k^onk^kP06onk^kPGoo`00K_o^k^h5ool00?oo
k^k^1Oo^k^h000;ooooo00?oU9BDooooooooool0MOooool00onDU9Cooooo
ooooo`06ooooo`03oiBDU?oooooooooo07Gooooo00?oU9BDooooooooool0
1_ooool5ool006kooooo1Ooo003oooooo`Gooooo0002onk^kP03oiBDU?o^
k^kok^k^07Gok^k^00?oU9BDonk^k_o^k^h01_o^k^h00onDU9Cok^k^onk^
kP1eonk^kP03oiBDU?o^k^kok^k^00Kok^k^1Ooo001^onk^kPGoo`00ooo^
k^h5onk^kP000_oVi^H00onDU9Coi^KVonKViP1eonKViP03oiBDU?oVi^Ko
i^KV00Koi^KV00?oU9BDonKVi_oVi^H0MOoVi^H00onDU9Coi^KVonKViP06
onKViPGoo`00K_oVi^H5ool00?ooi^KV1OoVi^H000;ok^k^00?oU9BDonk^
k_o^k^h0MOo^k^h00onDU9Cok^k^onk^kP06onk^kP03oiBDU?o^k^kok^k^
07Gok^k^00?oU9BDonk^k_o^k^h01_o^k^h5ool006kok^k^1Ooo003oonk^
kPGok^k^0002ooooo`03oiBDU?oooooooooo07Gooooo00?oU9BDoooooooo
ool01_ooool00onDU9Coooooooooo`1eooooo`03oiBDU?oooooooooo00Ko
oooo1Ooo001^ooooo`Goo`00ooooool5ooooo`000_o^k^h00onDU9Cok^k^
onk^kP1eonk^kP03oiBDU?o^k^kok^k^00Kok^k^00?oU9BDonk^k_o^k^h0
MOo^k^h00onDU9Cok^k^onk^kP06onk^kPGoo`00K_o^k^h5ool00?ook^k^
1Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0MOoVi^H00onDU9Coi^KVonKV
iP06onKViP03oiBDU?oVi^Koi^KV07Goi^KV00?oU9BDonKVi_oVi^H01_oV
i^H5ool006koi^KV1Ooo003oonKViPGoi^KV0002onk^kP03oiBDU?o^k^ko
k^k^07Gok^k^00?oU9BDonk^k_o^k^h01_o^k^h00onDU9Cok^k^onk^kP1e
onk^kP03oiBDU?o^k^kok^k^00Kok^k^1Ooo001^onk^kPGoo`00ooo^k^h5
onk^kP000_ooool00onDU9Coooooooooo`1eooooo`03oiBDU?oooooooooo
00Kooooo00?oU9BDooooooooool0MOooool00onDU9Coooooooooo`06oooo
o`Goo`00K_ooool5ool00?oooooo1Oooool000;ok^k^00?oU9BDonk^k_o^
k^h0MOo^k^h00onDU9Cok^k^onk^kP06onk^kP03oiBDU?o^k^kok^k^07Go
k^k^00?oU9BDonk^k_o^k^h01_o^k^h5ool006kok^k^1Ooo003oonk^kPGo
k^k^0002onKViP03oiBDU?oVi^Koi^KV07Goi^KV00?oU9BDonKVi_oVi^H0
1_oVi^H00onDU9Coi^KVonKViP1eonKViP03oiBDU?oVi^Koi^KV00Koi^KV
1Ooo001^onKViPGoo`00oooVi^H5onKViP000_o^k^h00onDU9Cok^k^onk^
kP1eonk^kP03oiBDU?o^k^kok^k^00Kok^k^00?oU9BDonk^k_o^k^h0MOo^
k^h00onDU9Cok^k^onk^kP06onk^kPGoo`00K_o^k^h5ool00?ook^k^1Oo^
k^h000;ooooo00?oU9BDooooooooool0MOooool00onDU9Coooooooooo`06
ooooo`03oiBDU?oooooooooo07Gooooo00?oU9BDooooooooool01_ooool5
ool006kooooo1Ooo003oooooo`Gooooo0002onk^kP03oiBDU?o^k^kok^k^
07Gok^k^00?oU9BDonk^k_o^k^h01_o^k^h00onDU9Cok^k^onk^kP1eonk^
kP03oiBDU?o^k^kok^k^00Kok^k^1Ooo001^onk^kPGoo`00ooo^k^h5onk^
kP000_oVi^H00onDU9Coi^KVonKViP1eonKViP03oiBDU?oVi^Koi^KV00Ko
i^KV00?oU9BDonKVi_oVi^H0MOoVi^H00onDU9Coi^KVonKViP06onKViPGo
o`00K_oVi^H5ool00?ooi^KV1OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0
MOo^k^h00onDU9Cok^k^onk^kP06onk^kP03oiBDU?o^k^kok^k^07Gok^k^
00?oU9BDonk^k_o^k^h01_o^k^h5ool006kok^k^1Ooo003oonk^kPGok^k^
0002ooooo`03oiBDU?oooooooooo07Gooooo00?oU9BDooooooooool01_oo
ool00onDU9Coooooooooo`1eooooo`03oiBDU?oooooooooo00Kooooo1Ooo
001^ooooo`Goo`00ooooool5ooooo`000_o^k^h00onDU9Cok^k^onk^kP1e
onk^kP03oiBDU?o^k^kok^k^00Kok^k^00?oU9BDonk^k_o^k^h0MOo^k^h0
0onDU9Cok^k^onk^kP06onk^kPGoo`00K_o^k^h5ool00?ook^k^1Oo^k^h0
00;oi^KV00?oU9BDonKVi_oVi^H0MOoVi^H00onDU9Coi^KVonKViP06onKV
iP03oiBDU?oVi^Koi^KV07Goi^KV00?oU9BDonKVi_oVi^H01_oVi^H5ool0
06koi^KV1Ooo003oonKViPGoi^KV0002onk^kP03oiBDU?o^k^kok^k^07Go
k^k^00?oU9BDonk^k_o^k^h01_o^k^h00onDU9Cok^k^onk^kP1eonk^kP03
oiBDU?o^k^kok^k^00Kok^k^1Ooo001^onk^kPGoo`00ooo^k^h5onk^kP00
0_ooool00onDU9Coooooooooo`1eooooo`03oiBDU?oooooooooo00Kooooo
00?oU9BDooooooooool0MOooool00onDU9Coooooooooo`06ooooo`Goo`00
K_ooool5ool00?oooooo1Oooool000;ok^k^00?oU9BDonk^k_o^k^h0MOo^
k^h00onDU9Cok^k^onk^kP06onk^kP03oiBDU?o^k^kok^k^07Gok^k^00?o
U9BDonk^k_o^k^h01_o^k^h5ool006kok^k^1Ooo003oonk^kPGok^k^0002
onKViP03oiBDU?oVi^Koi^KV07Goi^KV00?oU9BDonKVi_oVi^H01_oVi^H0
0onDU9Coi^KVonKViP1eonKViP03oiBDU?oVi^Koi^KV00Koi^KV1Ooo001^
onKViPGoo`00oooVi^H5onKViP000_o^k^h00onDU9Cok^k^onk^kP1eonk^
kP03oiBDU?o^k^kok^k^00Kok^k^00?oU9BDonk^k_o^k^h0MOo^k^h00onD
U9Cok^k^onk^kP06onk^kPGoo`00K_o^k^h5ool00?ook^k^1Oo^k^h000;o
oooo00?oU9BDooooooooool0MOooool00onDU9Coooooooooo`06ooooo`03
oiBDU?oooooooooo07Gooooo00?oU9BDooooooooool01_ooool5ool006ko
oooo1Ooo003oooooo`Gooooo0002onk^kP03oiBDU?o^k^kok^k^07Gok^k^
00?oU9BDonk^k_o^k^h01_o^k^h00onDU9Cok^k^onk^kP1eonk^kP03oiBD
U?o^k^kok^k^00Kok^k^1Ooo001^onk^kPGoo`00ooo^k^h5onk^kP000_oV
i^H00onDU9Coi^KVonKViP1eonKViP03oiBDU?oVi^Koi^KV00Koi^KV00?o
U9BDonKVi_oVi^H0MOoVi^H00onDU9Coi^KVonKViP06onKViPGoo`00K_oV
i^H5ool00?ooi^KV1OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0MOo^k^h0
0onDU9Cok^k^onk^kP06onk^kP03oiBDU?o^k^kok^k^07Gok^k^00?oU9BD
onk^k_o^k^h01_o^k^h5ool006kok^k^1Ooo003oonk^kPGok^k^0002oooo
o`03oiBDU?oooooooooo07Gooooo00?oU9BDooooooooool01_ooool00onD
U9Coooooooooo`1eooooo`03oiBDU?oooooooooo00Kooooo1Ooo001^oooo
o`Goo`00ooooool5ooooo`000_o^k^h00onDU9Cok^k^onk^kP1eonk^kP03
oiBDU?o^k^kok^k^00Kok^k^00?oU9BDonk^k_o^k^h0MOo^k^h00onDU9Co
k^k^onk^kP06onk^kPGoo`00K_o^k^h5ool00?ook^k^1Oo^k^h000;oi^KV
00?oU9BDonKVi_oVi^H0MOoVi^H00onDU9Coi^KVonKViP06onKViP03oiBD
U?oVi^Koi^KV07Goi^KV00?oU9BDonKVi_oVi^H01_oVi^H5ool006koi^KV
1Ooo003oonKViPGoi^KV0002onk^kP03oiBDU?o^k^kok^k^07Gok^k^00?o
U9BDonk^k_o^k^h01_o^k^h00onDU9Cok^k^onk^kP1eonk^kP03oiBDU?o^
k^kok^k^00Kok^k^1Ooo001^onk^kPGoo`00ooo^k^h5onk^kP000_ooool0
0onDU9Coooooooooo`1eooooo`03oiBDU?oooooooooo00Kooooo00?oU9BD
ooooooooool0MOooool00onDU9Coooooooooo`06ooooo`Goo`00K_ooool5
ool00?oooooo1Oooool000;ok^k^00?oU9BDonk^k_o^k^h0MOo^k^h00onD
U9Cok^k^onk^kP06onk^kP03oiBDU?o^k^kok^k^07Gok^k^00?oU9BDonk^
k_o^k^h01_o^k^h5ool006kok^k^1Ooo003oonk^kPGok^k^0002onKViP03
oiBDU?oVi^Koi^KV07Goi^KV00?oU9BDonKVi_oVi^H01_oVi^H00onDU9Co
i^KVonKViP1eonKViP03oiBDU?oVi^Koi^KV00Koi^KV1Ooo001^onKViPGo
o`00oooVi^H5onKViP000_o^k^h00onDU9Cok^k^onk^kP1eonk^kP03oiBD
U?o^k^kok^k^00Kok^k^00?oU9BDonk^k_o^k^h0MOo^k^h00onDU9Cok^k^
onk^kP06onk^kPGoo`00K_o^k^h5ool00?ook^k^1Oo^k^h000;ooooo00?o
U9BDooooooooool0MOooool00onDU9Coooooooooo`06ooooo`03oiBDU?oo
oooooooo07Gooooo00?oU9BDooooooooool01_ooool5ool006kooooo1Ooo
003oooooo`Gooooo0002onk^kP03oiBDU?o^k^kok^k^07Gok^k^00?oU9BD
onk^k_o^k^h01_o^k^h00onDU9Cok^k^onk^kP1eonk^kP03oiBDU?o^k^ko
k^k^00Kok^k^1Ooo001^onk^kPGoo`00ooo^k^h5onk^kP000_oVi^H00onD
U9Coi^KVonKViP1eonKViP03oiBDU?oVi^Koi^KV00Koi^KV00?oU9BDonKV
i_oVi^H0MOoVi^H00onDU9Coi^KVonKViP06onKViPGoo`00K_oVi^H5ool0
0?ooi^KV1OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0MOo^k^h00onDU9Co
k^k^onk^kP06onk^kP03oiBDU?o^k^kok^k^07Gok^k^00?oU9BDonk^k_o^
k^h01_o^k^h5ool006kok^k^1Ooo003oonk^kPGok^k^0002ooooo`03oiBD
U?oooooooooo07Gooooo00?oU9BDooooooooool01_ooool00onDU9Cooooo
ooooo`1eooooo`03oiBDU?oooooooooo00Kooooo1Ooo001^ooooo`Goo`00
ooooool5ooooo`000_o^k^h00onDU9Cok^k^onk^kP1eonk^kP03oiBDU?o^
k^kok^k^00Kok^k^00?oU9BDonk^k_o^k^h0MOo^k^h00onDU9Cok^k^onk^
kP06onk^kPGoo`00K_o^k^h5ool00?ook^k^1Oo^k^h000;oi^KV00?oU9BD
onKVi_oVi^H0MOoVi^H00onDU9Coi^KVonKViP06onKViP03oiBDU?oVi^Ko
i^KV07Goi^KV00?oU9BDonKVi_oVi^H01_oVi^H5ool000?oi^KV00GobLW9
obPX:?m6ATKoUiNGon7Qh@02onKViP03ofATI?nQXJ7oi^KV067oi^KV1Ooo
003oonKViPGoi^KV0002onk^kP03oiBDU?o^k^kok^k^07Gok^k^00?oU9BD
onk^k_o^k^h01_o^k^h00onDU9Cok^k^onk^kP02onk^kP05om3@d?lZ:R[o
B4Q8oibLW?oYjNT00_o^k^h00omWIfOoYjNWonk^kP1Yonk^kP03oiBDU?o^
k^kok^k^00Kok^k^1Ooo0003onk^kP05omgMgOnTY:CoWinOoa/K6onLW9`0
0_o^k^h00onHV9SoFEUIonk^kP1Qonk^kPGoo`00ooo^k^h5onk^kP000_oo
ool00onDU9Coooooooooo`0Cooooo`03onGUiOomoOgooooo00Kooooo00?o
m?CdonSXj?ooool0E_ooool00onDU9Coooooooooo`06ooooo`03oiBDU?oo
oooooooo00;ooooo00GokNg]ok2`/?n[Zj_o7AdMojRXZ002ooooo`03oj>S
XomPH63ooooo06Wooooo00?oU9BDooooooooool01_ooool5ool000Kooooo
00OoJVYZoeMGEoooooooooooonc/k?lH61Soo_kn00Cooooo00?o=SHfo`00
0?l000000_l000001?lj>S[ooooood10@?moOgl2ooooo`06od10@?moOgoo
oooooooooonSXj?o71`L0_ooool01om0@43oOgmooooooookno_oCDe=obd]
;Oo_knl0@oooool5ool00?oooooo1Oooool000;ok^k^00?oU9BDonk^k_o^
k^h01oo^k^h00omZJV[o=3@donk^kP03onk^kP0;oc/k>omfMWKok^k^onk^
k_o4a<Co8R8Roa`L7?n][Jgok^k^oc/k>omfMWH00_o^k^h01_oGemOoADE5
o`820_lP823o5ADEokBd]5Gok^k^00?oU9BDonk^k_o^k^h01_o^k^h00onD
U9Cok^k^onk^kP05onk^kP07of9RH_mADE7ok^k^onk^k_oLg=co5QHFong]
k@04onk^kP03oc8b<_l0003o000000;o000000Co=SHfonk^k_lk>c_oMWIf
0_o^k^h01_lk>c_oMWIfonk^k_o^k^koV9RHoaXJ6P;ok^k^00Oo>c/kogIf
M_o^k^koj^[ZodM7AolZ:R[ogmoO04_ok^k^00?oU9BDonk^k_o^k^h01_o^
k^h5ool000Kok^k^00?oP820oahN7_o^k^h00_o^k^h00olh>3So^;Rhonk^
kP03onk^kP03oc8b<_m/K6cok^k^00Cok^k^00Ko>c/kogIfM_o^k^kok^k^
oc/k>omfMWH2onk^kP0:oiRHV?lJ6Q[ok^k^onk^k_lk>c_oMWIfong]kOmH
F5So7QhNomKFeTCok^k^1Ooo003oonk^kPGok^k^0002onKViP03oiBDU?oV
i^Koi^KV00Ooi^KV00?oIVIVoc8b<_oVi^H00ooVi^H01oli>CWoLW9bonKV
i_oVi^KoIFEUocXj>_oUiND00_oVi^H02_li>CWoLW9bonKVi_oVi^Ko?Cdm
ocTi>Oo9bLWoi^KVom_KfooJf]YEonKViP03oiBDU?oVi^Koi^KV00Koi^KV
00?oU9BDonKVi_oVi^H01OoVi^H00omlO7co7AdMonKViP02onKViP03ocLg
=onb/[;oi^KV00?oi^KV00?o<30`ofQXJ?oVi^H01?oVi^H01_li>CWoLW9b
onKVi_oVi^Ko>CTiog9bLP;oi^KV00[oTi>CoaTI6OoVi^Koi^KVocTi>Omb
LW;oiNGUoeEEEOlM7Agoclo?C?oVi^H00onDU9Coi^KVonKViP06onKViP[o
o`0000?oi^KVogalO?lK6a/00ooVi^H00omlO7coKVi^onKViP03onKViP03
oc0`<?mXJ6Soi^KV00Coi^KV00Ko>CTiog9bL_oVi^Koi^KVocTi>OmbLW82
onKViP09oi>CTolI6AWoi^KVonKVi_li>CWoLW9bofMWIolC4a?oaLG500;o
i^KVB?oo003oonKViPGoi^KV0002onk^kP03oiBDU?o^k^kok^k^00Ook^k^
00?oJVYZoc@d=?o^k^h00oo^k^h01_lk>c_oMWIfonk^k_o^k^koAdM7ofYZ
JP?ok^k^00Ko>c/kogIfM_o^k^koc/k>o`000?n[Zj]Ionk^kP03oiBDU?o^
k^kok^k^00Kok^k^00?oU9BDonk^k_o^k^h01Oo^k^h00on0P83o71`Lonk^
kP02onk^kP03oh20P?maLG7ok^k^00?ok^k^00?o<S8bofa/K?o^k^h01?o^
k^h01_lk>c_oMWIfonk^k_o^k^ko>c/kogIfMP;ok^k^00WoV9RHoaXJ6_o^
k^kok^k^oc/k>omfMWKoJf][oa@D5?o<c<`0COo^k^h00onDU9Cok^k^onk^
kP06onk^kP[oo`0000?ok^k^oh20P?lL71`00oo^k^h00oo7alOo:RXZonk^
kP03onk^kP03oc8b<_m/K6cok^k^00Cok^k^00Ko>c/kogIfM_o^k^kok^k^
oc/k>omfMWH2onk^kP08oiRHV?lJ6Q[ok^k^onk^k_lk>c_o=3@do`000?nf
][H3onk^kTSoo`00ooo^k^h5onk^kP000_ooool00onDU9Coooooooooo`07
ooooo`03og9bL_lh>3Sooooo00?ooooo00Ko@410ogmoOoooooooooooode=
COmbLW83ooooo`06od10@?moOgoooooookjn__l0003o?Cdm0olo?cl00oo4
a<Coooooooooo`1Cooooo`03oiBDU?oooooooooo00Kooooo00?oU9BDoooo
ooooool01Oooool00on:RX[o7alOooooo`02ooooo`03omKFe_l];Bgooooo
00?ooooo00?o=SHfogAdM?ooool01?ooool01_m0@43oOgmooooooooooooo
@410ogmoO`;ooooo00SoXj>Soa`L7?oooooooooood10@?lh>3So0000ol?3
`dkooooo00?oU9BDooooooooool01_ooool:ool00003oooooon:RX[o7alO
00Cooooo00?o8b<Son3Ph?ooool00_ooool00olf=SKoM7Adooooo`04oooo
o`06od10@?moOgoooooooooooom0@43oGEeM0_ooool02OnMWIgo7AdMoooo
oooooooo@410oginO_mFEUKoD51@oogmo@02ooooodSoo`00ooooool5oooo
o`000_o^k^h00onDU9Cok^k^onk^kP07onk^kP03ofYZJ_ld=3Cok^k^00?o
k^k^00Ko>c/kogIfM_o^k^kok^k^odM7AomZJVX3onk^kP0:oc/k>omfMWKo
k^k^olc<c?l0003oWinOol71`Oni^KWo0P82omGEeEGok^k^00?oU9BDonk^
k_o^k^h01_o^k^h00onDU9Cok^k^onk^kP05onk^kP03oh20P?lL71cok^k^
00?ok^k^00?o820Pom7AdOo^k^h00_o^k^h00olb<S;oK6a/onk^kP04onk^
kP06oc/k>omfMWKok^k^onk^k_lk>c_oEUIF0_o^k^h02OnBTY;o6a/Konk^
k_o^k^ko>c/kogEeMOm@D53oBTY:onc/k01=onk^kP03oiBDU?o^k^kok^k^
00Kok^k^2_oo00000oo^k^koP820oa`L7004onk^kP03ofQXJ?n9RHWok^k^
00;ok^k^00?o<S8bofa/K?o^k^h01?o^k^h02_lk>c_oMWIfonk^k_o^k^ko
>c/koa8B4_m^KVkoclo?oe5ADOm7AdL2onk^kP05oc/k>omfMWKoinOWocPh
>?mXJ6P00_o^k^i8ool00?ook^k^1Oo^k^h000;oi^KV1onDU9@3onKViP03
ofIVI_lb<S;oi^KV00?oi^KV00_o>CTiog9bL_oVi^Koh>3Pod51@OmRHV;o
g=cLon;Rh_oVi^Ko>CTiog9bLP02onKViP06ocPh>?mPH63og]kNohj>S_lV
9RKoi^KVE_nDU9@8onKViPOoU9BD00?oi^KVogalO?lK6a/01?oVi^H00omU
IFGoQ8B4onKViP02onKViP03oc0`<?mXJ6Soi^KV00Coi^KV00[o>CTiog9b
L_oVi^Koi^KVocTi>OlB4Q;oJVYZolS8b?m>CTkoADE50_oVi^H01Oli>CWo
LW9bomoOgolf=SKoIFEU00;oi^KVC?nDU9@8onKViP[oo`0000?oi^KVogal
O?lK6a/01?oVi^H00onZZZ[o?cloonKViP02onKViP03oc0`<?mXJ6Soi^KV
00Coi^KV00[oBd];ogmoOooVi^Koi^KVod];BomnOWkoKFe]oa8B4_lY:BWo
/;2`0_oVi^H01oli>CWoLW9bonKVi_oEeMGo;bl_oiRHV?oVi^H0B?oo003o
onKViPGoi^KV000<onk^kP03ofYZJ_ld=3Cok^k^00?ok^k^00_oCTi>oh>3
Poo^k^koMWIfo`L71ol;2`_o6ATIoj:RX_o^k^ko>c/kogIfMP02onk^kP05
omKFe_m2@T;o30`<oaXJ6_nZZZX0Ioo^k^h00on0P83o71`Lonk^kP03onk^
kP03ok2`/?m1@D7ok^k^00;ok^k^00?o<S8bofa/K?o^k^h01?o^k^h02_m>
CTkoPh>3onk^k_o^k^koCTi>oh:2P_m`L73o4Q8BobXZ:_nf][H2onk^kP06
oc/k>omfMWKok^k^omgMgOla<C7oWIfMH?o^k^h00on0P83o71`Lonk^kP03
onk^kP03onWYjOlC4a?oh^;R00;ok^k^00?o<S8bofa/K?o^k^h02oo^k^h0
0oo]kNgok^k^onk^kP02onk^kP03oc/k>omfMWKok^k^0?ook^k^DOo^k^h0
00cooooo00?oLW9bocPh>?ooool01oooool00om=CDgoLW9booooo`02oooo
o`03od10@?moOgoooooo00?ooooo00?oo?clooooooooool0Ioooool00on:
RX[o7alOooooo`03ooooo`03oo[jn_lE5AGolo?c00;ooooo00?o=SHfogAd
M?ooool02oooool00oono_koooooooooo`02ooooo`03od10@?moOgoooooo
06?ooooo00?oRXZ:oalO7oooool01?ooool01_mFEUKo[Jf]oooooooooooo
=SHfogAdM0Gooooo00?oFe]Koi:BT_ooool02Oooool00om0@43oOgmooooo
o`3ooooooe7ooooo0009onk^kP05ofm_KomNGUkoGUiNobXZ:_lD51@00omN
GUh00ooNg]koE5ADohR8R002onk^kP03om7AdOo?clook^k^00;ok^k^00?o
>c/kogIfM_o^k^h0KOo^k^h00on0P83o71`Lonk^kP04onk^kP06oe1@D?nQ
XJ7ok^k^onk^k_lb<S;oK6a/1Oo^k^h00omDE5CoR8R8onk^kP09onk^kP03
oc/k>omfMWKok^k^06?ok^k^00?o`l?3oi^KVoo^k^h01?o^k^h01_o4a<Co
_;blonk^k_o^k^koY:BTokZj^PGok^k^00?oZ:RXokno_oo^k^h02Oo^k^h0
0olk>c_oMWIfonk^kP3oonk^kU7ok^k^0009onKViP03oiFEUOn:RX[oRXZ:
00GoRXZ:00?og=cLoj:RX_nh^;P01ooVi^H00oli>CWoLW9bonKViP1]onKV
iP03okbl_?nFUYKoi^KV00Coi^KV00Ko_KfmokJf]_oVi^Koi^KVoijNW_nd
];@5onKViP03oj:RX_nh^;Soi^KV00Woi^KV00?o>CTiog9bL_oVi^H0POoV
i^H00ooRh^;oi>CTonKViP3oonKViU7oi^KV000Konk^kP03on[Zj_o/k>co
k^k^08_ok^k^00?oj^[Zonc/k?o^k^h0ooo^k^kEonk^kP00oooooooooooo
oh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h007coP8201_oo
ool02?lc<c?ok^k^ogMgMolc<c?oIVIVoc<c<oo<0<coA4A40_l0<fH03_mg
MgOok^k^onk^k_mgMgOo^k^koooooolc<c?ok^k^ogMgMolc<c?oIVIVoc<c
<oo<0<coA4A40_l0<fH03_mgMgOok^k^onk^k_mgMgOo^k^koooooolc<c?o
k^k^ogMgMolc<c?oIVIVoc<c<oo<0<coA4A40_l0<fH03_mgMgOok^k^onk^
k_mgMgOo^k^koooooolc<c?ok^k^ogMgMolc<c?oIVIVoc<c<oo<0<coA4A4
0_l0<fH03_mgMgOok^k^onk^k_mgMgOo^k^koooooolc<c?ok^k^ogMgMolc
<c?oIVIVoc<c<oo<0<coA4A40_l0<fH03_mgMgOok^k^onk^k_mgMgOo^k^k
oooooolc<c?ok^k^ogMgMolc<c?oIVIVoc<c<oo<0<coA4A40_l0<fH03_mg
MgOok^k^onk^k_mgMgOo^k^koooooolc<c?ok^k^ogMgMolc<c?oIVIVoc<c
<oo<0<coA4A40_l0<fH03_mgMgOok^k^onk^k_mgMgOo^k^koooooolc<c?o
k^k^ogMgMolc<c?oIVIVoc<c<oo<0<coA4A40_l0<fH00omgMgOooooooooo
o`03ooooogcoP8201Ooooomlooo8087ooooo001loh20P0Gok^k^00?ooooo
ogMgMoo^k^h00oo^k^h01_nk^k_oIS=Vooooooo^k^koVIVIohR8R0;ok^k^
00CoMgMgolc<c?ooooooMgMg1?o^k^h01_nk^k_oIS=Vooooooo^k^koVIVI
ohR8R0;ok^k^00CoMgMgolc<c?ooooooMgMg1?o^k^h01_nk^k_oIS=Voooo
ooo^k^koVIVIohR8R0;ok^k^00CoMgMgolc<c?ooooooMgMg1?o^k^h01_nk
^k_oIS=Vooooooo^k^koVIVIohR8R0;ok^k^00CoMgMgolc<c?ooooooMgMg
1?o^k^h01_nk^k_oIS=Vooooooo^k^koVIVIohR8R0;ok^k^00CoMgMgolc<
c?ooooooMgMg1?o^k^h01_nk^k_oIS=Vooooooo^k^koVIVIohR8R0;ok^k^
00CoMgMgolc<c?ooooooMgMg1?o^k^h01_nk^k_oIS=Vooooooo^k^koVIVI
ohR8R0;ok^k^00CoMgMgolc<c?ooooooMgMg1?o^k^h01_nk^k_oIS=Voooo
ooo^k^koVIVIohR8R0Gok^k^O?n0P805onk^kWcoolP01Oo^k^ikok:b/P7o
oooo001loh20P0Goi^KV00?ooooooc<c<oooool02oo^k^h01OmgMgOoc<c<
oooooolc<c?ooooo00_ok^k^00GoMgMgolc<c?oooooo<c<cooooo`0;onk^
kP05ogMgMoo<c<cooooooc<c<oooool02oo^k^h01OmgMgOoc<c<oooooolc
<c?ooooo00_ok^k^00GoMgMgolc<c?oooooo<c<cooooo`0;onk^kP05ogMg
Moo<c<cooooooc<c<oooool02oo^k^h01OmgMgOoc<c<oooooolc<c?ooooo
00Wok^k^1OoVi^Iloh20P0Goi^KVO?oob005onKViP03ok:b/_ooooooo`00
07Ooo`000Onb/[81ooooo`00O?n0P805onk^kP03oooooolc<c?oMgMg00co
MgMg0_ooool00olc<c?oMgMgogMgM`0;ogMgM`;ooooo00?o<c<cogMgMomg
MgL02omgMgL2ooooo`03oc<c<omgMgOoMgMg00_oMgMg0_ooool00olc<c?o
MgMgogMgM`0;ogMgM`;ooooo00?o<c<cogMgMomgMgL02omgMgL2ooooo`03
oc<c<omgMgOoMgMg00_oMgMg0_ooool00olc<c?oMgMgogMgM`08ogMgM`Go
k^k^O?n0P805onk^kWcoolP01Oo^k^h00onb/[;oooooool0001fonk^kP7o
o`000Onb/[81ooooo`00O?n0P806ooooo`03ohR8R?m4A4CoA4A400GoA4A4
00?o<c<codA4A?m4A4@00om4A4@00onIVIWoooooohR8R007odA4A003oc<c
<om4A4CoA4A400?oA4A400?oVIVIoooooon8R8P01om4A4@00olc<c?oA4A4
odA4A003odA4A003oiVIVOooooooR8R800OoA4A400?o<c<codA4A?m4A4@0
0om4A4@00onIVIWoooooohR8R007odA4A003oc<c<om4A4CoA4A400?oA4A4
00?oVIVIoooooon8R8P01om4A4@00olc<c?oA4A4odA4A003odA4A003oiVI
VOooooooR8R800OoA4A400?o<c<codA4A?m4A4@00om4A4@00onIVIWooooo
ohR8R007odA4A003oc<c<om4A4CoA4A400Gooooo1?n0P81dooooo`CoP820
1Ooooomlooo800Gooooo00?o/[:boooooooo0000M_ooool1ool0007o/[:b
0Oooool007coP8201Oo^k^h00oooooooA4A4ofIVIP03ogMgM`03ofIVI_mg
MgOoMgMg00GoMgMg00Go<c<colc<c?ooooooA4A4ofIVIP03ogMgM`03ofIV
I_mgMgOoMgMg00GoMgMg00Go<c<colc<c?ooooooA4A4ofIVIP03ogMgM`03
ofIVI_mgMgOoMgMg00GoMgMg00Go<c<colc<c?ooooooA4A4ofIVIP03ogMg
M`03ofIVI_mgMgOoMgMg00GoMgMg00Go<c<colc<c?ooooooA4A4ofIVIP03
ogMgM`03ofIVI_mgMgOoMgMg00GoMgMg00Go<c<colc<c?ooooooA4A4ofIV
IP03ogMgM`03ofIVI_mgMgOoMgMg00GoMgMg00Go<c<colc<c?ooooooA4A4
ofIVIP03ogMgM`03ofIVI_mgMgOoMgMg00GoMgMg00Go<c<colc<c?oooooo
A4A4ofIVIP03ogMgM`03ofIVI_mgMgOoMgMg00?oMgMg1Oo^k^h4oh20P7Co
k^k^1?n0P805onk^kWcoolP01Oo^k^h00onb/[;oooooool0001fonk^kP7o
o`000Onb/[81ooooo`00O?n0P805onKViP0<oooooolc<c?ok^k^onk^k_nk
^k_oMgMgojZZZ_ooooook^k^omgMgOmgMgOogMgM0_o^k^h01?mgMgOoc<c<
oooooolc<c<2onk^kP08ok^k^omgMgOoZZZZooooooo^k^kogMgMogMgMooM
gMd2onk^kP04ogMgMoo<c<cooooooc<c<`;ok^k^00So^k^kogMgMonZZZ[o
ooooonk^k_oMgMgoMgMgomgMg@;ok^k^00CoMgMgolc<c?oooooo<c<c0_o^
k^h02?nk^k_oMgMgojZZZ_ooooook^k^omgMgOmgMgOogMgM0_o^k^h01?mg
MgOoc<c<oooooolc<c<2onk^kP08ok^k^omgMgOoZZZZooooooo^k^kogMgM
ogMgMooMgMd2onk^kP04ogMgMoo<c<cooooooc<c<`;ok^k^00So^k^kogMg
MonZZZ[oooooonk^k_oMgMgoMgMgomgMg@;ok^k^00CoMgMgolc<c?oooooo
<c<c0_o^k^h02?nk^k_oMgMgojZZZ_ooooook^k^omgMgOmgMgOogMgM0_o^
k^h01?mgMgOoc<c<oooooolc<c<2onk^kP08ok^k^omgMgOoZZZZooooooo^
k^kogMgMogMgMooMgMd5onKViPCoP820M?oVi^H4oh20P0Goi^KVO?oob005
onKViP03ok:b/_ooooooo`0007Koi^KV0Ooo0001ok:b/P7ooooo001loh20
P0Gok^k^00Kooooooc<c<oooooook^k^ogMgMol0<l`2oc<c000>odA4A?lc
03?o000RofH0I_mgMgOoooooogMgMonk^k_ooooooc<c<oooooook^k^ogMg
Mol0<l`2oc<c000>odA4A?lc03?o000RofH0I_mgMgOoooooogMgMonk^k_o
oooooc<c<oooooook^k^ogMgMol0<l`2oc<c000>odA4A?lc03?o000RofH0
I_mgMgOoooooogMgMonk^k_ooooooc<c<oooooook^k^ogMgMol0<l`2oc<c
000>odA4A?lc03?o000RofH0I_mgMgOoooooogMgMonk^k_ooooooc<c<ooo
ooook^k^ogMgMol0<l`2oc<c000>odA4A?lc03?o000RofH0I_mgMgOooooo
ogMgMonk^k_ooooooc<c<oooooook^k^ogMgMol0<l`2oc<c000>odA4A?lc
03?o000RofH0I_mgMgOoooooogMgMonk^k_ooooooc<c<oooooook^k^ogMg
Mol0<l`2oc<c000>odA4A?lc03?o000RofH0I_mgMgOoooooogMgMonk^k_o
oooooc<c<oooooook^k^ogMgMol0<l`2oc<c0004odA4A?lc03?o000RofH0
IPGok^k^1?n0P81donk^kPCoP8201Oo^k^ilooo800Gok^k^00?o/[:boooo
oooo0000M_o^k^h1ool0007o/[:b0Oooool007coP8201_ooool04OmgMgOo
k^k^onk^k_mVIVKo06Koo`1Vc?m4A4Co<`0coc<c<omgMgOo<`0cohR8R?o^
k^koIVIVolc<c?ooooooMgMg00;ok^k^00koIVIVo`1Vool0I/coA4A4oc<0
<olc<c?oMgMgoc<0<on8R8Sok^k^ofIVI_o<c<coooooogMgM`;ok^k^00ko
IVIVo`1Vool0I/coA4A4oc<0<olc<c?oMgMgoc<0<on8R8Sok^k^ofIVI_o<
c<coooooogMgM`;ok^k^00koIVIVo`1Vool0I/coA4A4oc<0<olc<c?oMgMg
oc<0<on8R8Sok^k^ofIVI_o<c<coooooogMgM`;ok^k^00koIVIVo`1Vool0
I/coA4A4oc<0<olc<c?oMgMgoc<0<on8R8Sok^k^ofIVI_o<c<coooooogMg
M`;ok^k^00koIVIVo`1Vool0I/coA4A4oc<0<olc<c?oMgMgoc<0<on8R8So
k^k^ofIVI_o<c<coooooogMgM`;ok^k^00koIVIVo`1Vool0I/coA4A4oc<0
<olc<c?oMgMgoc<0<on8R8Sok^k^ofIVI_o<c<coooooogMgM`;ok^k^00So
IVIVo`1Vool0I/coA4A4oc<0<olc<c?oMgMgoc<0<`Gooooo1?n0P81doooo
o`CoP8201Oooool8ooo806cooooo2?oob005ooooo`03ok:b/_ooooooo`00
07Kooooo0Ooo0001ok:b/P7ooooo001loh20P0Gok^k^00Gooooooc<c<oo^
k^kogMgMoa4A4@02o`1Vo`0>oc=Vc?lR8R;oR8R8oiVIVOlR8R;ogMgMonk^
k_mgMgOoc<c<oooooolc<c?ok^k^omgMgOlA4A42o`1Vo`0>oc=Vc?lR8R;o
R8R8oiVIVOlR8R;ogMgMonk^k_mgMgOoc<c<oooooolc<c?ok^k^omgMgOlA
4A42o`1Vo`0>oc=Vc?lR8R;oR8R8oiVIVOlR8R;ogMgMonk^k_mgMgOoc<c<
oooooolc<c?ok^k^omgMgOlA4A42o`1Vo`0>oc=Vc?lR8R;oR8R8oiVIVOlR
8R;ogMgMonk^k_mgMgOoc<c<oooooolc<c?ok^k^omgMgOlA4A42o`1Vo`0>
oc=Vc?lR8R;oR8R8oiVIVOlR8R;ogMgMonk^k_mgMgOoc<c<oooooolc<c?o
k^k^omgMgOlA4A42o`1Vo`0>oc=Vc?lR8R;oR8R8oiVIVOlR8R;ogMgMonk^
k_mgMgOoc<c<oooooolc<c?ok^k^omgMgOlA4A42o`1Vo`0>oc=Vc?lR8R;o
R8R8oiVIVOlR8R;ogMgMonk^k_mgMgOoc<c<oooooolc<c?ok^k^omgMgOlA
4A42o`1Vo`05oc=Vc?lR8R;oR8R8oiVIVOlR8R801Oo^k^h4oh20P7Cok^k^
1?n0P805onk^kPSoolP0K?o^k^h8ooo800Gok^k^00?o/[:boooooooo0000
M_o^k^h1ool0007o/[:b0Oooool000[oP820J?oVi^H:oh20P0Goi^KV00Ko
oooooc<c<oo^k^ko<c<coc<0<ol00142ob8R8P0>o`0c<olc03?o4@00o`00
0?lc<c?o^k^kogMgMonk^k_ooooooc<c<oo^k^ko<c<coc<0<ol00142ob8R
8P0>o`0c<olc03?o4@00o`000?lc<c?o^k^kogMgMonk^k_ooooooc<c<oo^
k^ko<c<coc<0<ol00142ob8R8P0>o`0c<olc03?o4@00o`000?lc<c?o^k^k
ogMgMonk^k_ooooooc<c<oo^k^ko<c<coc<0<ol00142ob8R8P0>o`0c<olc
03?o4@00o`000?lc<c?o^k^kogMgMonk^k_ooooooc<c<oo^k^ko<c<coc<0
<ol00142ob8R8P0>o`0c<olc03?o4@00o`000?lc<c?o^k^kogMgMonk^k_o
oooooc<c<oo^k^ko<c<coc<0<ol00142ob8R8P0>o`0c<olc03?o4@00o`00
0?lc<c?o^k^kogMgMonk^k_ooooooc<c<oo^k^ko<c<coc<0<ol00142ob8R
8P0>o`0c<olc03?o4@00o`000?lc<c?o^k^kogMgMonk^k_ooooooc<c<oo^
k^ko<c<coc<0<ol00142ob8R8P04o`0c<olc03?o4@00o`0000Goi^KV1?n0
P81donKViPCoP8201OoVi^H8ooo806coi^KV2?oob005onKViP03ok:b/_oo
ooooo`0007Koi^KV0Ooo0001ok:b/P7ooooo000:oh20P6Sok^k^2_n0P805
onk^kP0BoooooomgMgOoIS=VofHcI_mgMgOoR8R8ofIVI_lc<`3o03?<o`1V
c?lc06Ko0000ofHcI_lc<c?oMgMgolc<c?ooooooMgMg0_mV<fH03_mgMgOo
R8R8ofIVI_lc<`3o03?<o`1Vc?lc06Ko0000ofHcI_lc<c?oMgMgolc<c?oo
ooooMgMg0_mV<fH03_mgMgOoR8R8ofIVI_lc<`3o03?<o`1Vc?lc06Ko0000
ofHcI_lc<c?oMgMgolc<c?ooooooMgMg0_mV<fH03_mgMgOoR8R8ofIVI_lc
<`3o03?<o`1Vc?lc06Ko0000ofHcI_lc<c?oMgMgolc<c?ooooooMgMg0_mV
<fH03_mgMgOoR8R8ofIVI_lc<`3o03?<o`1Vc?lc06Ko0000ofHcI_lc<c?o
MgMgolc<c?ooooooMgMg0_mV<fH03_mgMgOoR8R8ofIVI_lc<`3o03?<o`1V
c?lc06Ko0000ofHcI_lc<c?oMgMgolc<c?ooooooMgMg0_mV<fH03_mgMgOo
R8R8ofIVI_lc<`3o03?<o`1Vc?lc06Ko0000ofHcI_lc<c?oMgMgolc<c?oo
ooooMgMg0_mV<fH02?mgMgOoR8R8ofIVI_lc<`3o03?<o`1Vc?lc06Ko0000
1Oo^k^h4oh20P7Cok^k^1?n0P805onk^kPSoolP0K?o^k^h8ooo800Gok^k^
00?o/[:boooooooo0000M_o^k^h1ool0007o/[:b0Oooool000[oP820J?oo
ool:oh20P0Kooooo00SoA4A4oc<0<oo<0<coIS=VofIVI_lA003oVFH0olbI
00;o06K<0_nI09T03?nk^k_oMgMgolc<c?ooooooA4A4oc<0<oo<0<coIS=V
ofIVI_lA003oVFH0olbI00;o06K<0_nI09T03?nk^k_oMgMgolc<c?oooooo
A4A4oc<0<oo<0<coIS=VofIVI_lA003oVFH0olbI00;o06K<0_nI09T03?nk
^k_oMgMgolc<c?ooooooA4A4oc<0<oo<0<coIS=VofIVI_lA003oVFH0olbI
00;o06K<0_nI09T03?nk^k_oMgMgolc<c?ooooooA4A4oc<0<oo<0<coIS=V
ofIVI_lA003oVFH0olbI00;o06K<0_nI09T03?nk^k_oMgMgolc<c?oooooo
A4A4oc<0<oo<0<coIS=VofIVI_lA003oVFH0olbI00;o06K<0_nI09T03?nk
^k_oMgMgolc<c?ooooooA4A4oc<0<oo<0<coIS=VofIVI_lA003oVFH0olbI
00;o06K<0_nI09T03?nk^k_oMgMgolc<c?ooooooA4A4oc<0<oo<0<coIS=V
ofIVI_lA003oVFH0olbI00;o06K<00?oV@2Iooooooooool00oooool4oh20
P7Cooooo1?n0P805ooooo`SoolP0K?ooool8ooo800Gooooo00?o/[:boooo
oooo0000M_ooool1ool0007o/[:b0Oooool000[oP820J?o^k^h:oh20P0Go
k^k^00Cooooooc<c<oo<c<coA4A40_l000003_lc03?oIVH0ooo<0?nIIP3o
IP1Vol`0oomV06KoIS=VogMgMonk^k_ooooooc<c<oo<c<coA4A40_l00000
3_lc03?oIVH0ooo<0?nIIP3oIP1Vol`0oomV06KoIS=VogMgMonk^k_ooooo
oc<c<oo<c<coA4A40_l000003_lc03?oIVH0ooo<0?nIIP3oIP1Vol`0oomV
06KoIS=VogMgMonk^k_ooooooc<c<oo<c<coA4A40_l000003_lc03?oIVH0
ooo<0?nIIP3oIP1Vol`0oomV06KoIS=VogMgMonk^k_ooooooc<c<oo<c<co
A4A40_l000003_lc03?oIVH0ooo<0?nIIP3oIP1Vol`0oomV06KoIS=VogMg
Monk^k_ooooooc<c<oo<c<coA4A40_l000003_lc03?oIVH0ooo<0?nIIP3o
IP1Vol`0oomV06KoIS=VogMgMonk^k_ooooooc<c<oo<c<coA4A40_l00000
3_lc03?oIVH0ooo<0?nIIP3oIP1Vol`0oomV06KoIS=VogMgMonk^k_ooooo
oc<c<oo<c<coA4A40_l000001_lc03?oIVH0ooo<0?nIIP3oIP1Vol`0o`Go
k^k^1?n0P81donk^kPCoP8201Oo^k^h8ooo806cok^k^2?oob005onk^kP03
ok:b/_ooooooo`0007Kok^k^0Ooo0001ok:b/P7ooooo000:oh20P6Soi^KV
2_n0P805onKViP07oooooomgMgOok^k^onk^k_lR8R;oV@2IofHcIP02ofH0
IP09oc<0<onIIP3o4A4Aolc<c?o^k^koMgMgolc<c?ooooooMgMg00;ok^k^
00?o8R8RoiT0VOmV<fH00_mV06H02Olc03?oVFH0oa4A4Oo<c<cok^k^ogMg
Moo<c<coooooogMgM`02onk^kP03ob8R8_nI09WoIS=V00;oIP1V00Wo<`0c
oiUV0?lA4A7oc<c<onk^k_mgMgOoc<c<oooooomgMgL00_o^k^h00olR8R;o
V@2IofHcIP02ofH0IP09oc<0<onIIP3o4A4Aolc<c?o^k^koMgMgolc<c?oo
ooooMgMg00;ok^k^00?o8R8RoiT0VOmV<fH00_mV06H02Olc03?oVFH0oa4A
4Oo<c<cok^k^ogMgMoo<c<coooooogMgM`02onk^kP03ob8R8_nI09WoIS=V
00;oIP1V00Wo<`0coiUV0?lA4A7oc<c<onk^k_mgMgOoc<c<oooooomgMgL0
0_o^k^h00olR8R;oV@2IofHcIP02ofH0IP09oc<0<onIIP3o4A4Aolc<c?o^
k^koMgMgolc<c?ooooooMgMg00;ok^k^00?o8R8RoiT0VOmV<fH00_mV06H0
0olc03?oVFH0oa4A4@05onKViPCoP820M?oVi^H4oh20P0Goi^KV2?oob01/
onKViPSoolP01OoVi^H00onb/[;oooooool0001fonKViP7oo`000Onb/[81
ooooo`002_n0P81Xonk^kP[oP8201Oo^k^h01_ooooooA4A4onk^k_nIVIWo
4A4AodA4A0;oc03<00CoV@2Io`0cI_o<V@3oMgMg0_o^k^h02?mgMgOoc<c<
oooooom4A4Cok^k^oiVIVOlA4A7oA4A40_o<0<`01?nI09Wo03=VolbI0?mg
MgL2onk^kP08ogMgMoo<c<coooooodA4A?o^k^koVIVIoa4A4Om4A4@2ol`0
c004oiT0VOl0<fKoc9T0ogMgM`;ok^k^00SoMgMgolc<c?ooooooA4A4onk^
k_nIVIWo4A4AodA4A0;oc03<00CoV@2Io`0cI_o<V@3oMgMg0_o^k^h02?mg
MgOoc<c<oooooom4A4Cok^k^oiVIVOlA4A7oA4A40_o<0<`01?nI09Wo03=V
olbI0?mgMgL2onk^kP08ogMgMoo<c<coooooodA4A?o^k^koVIVIoa4A4Om4
A4@2ol`0c004oiT0VOl0<fKoc9T0ogMgM`;ok^k^00SoMgMgolc<c?oooooo
A4A4onk^k_nIVIWo4A4AodA4A0;oc03<00CoV@2Io`0cI_o<V@3oMgMg0_o^
k^h02?mgMgOoc<c<oooooom4A4Cok^k^oiVIVOlA4A7oA4A40_o<0<`01?nI
09Wo03=VolbI0?mgMgL5onk^kPCoP820M?o^k^h4oh20P0Gok^k^2?oob01/
onk^kPSoolP01Oo^k^h00onb/[;oooooool0001fonk^kP7oo`000Onb/[81
ooooo`002_n0P81Xooooo`[oP8201_ooool02?lc<c?ok^k^ogMgMolc<c?o
IVIVoc<c<oo<0<coA4A40_l0<fH01OmgMgOok^k^onk^k_mgMgOo^k^k05co
oooo0_o^k^h02omgMgOo^k^koooooolc<c?ok^k^ogMgMolc<c?oIVIVoc<c
<oo<0<coA4A400;o03=V00?oMgMgooooooooool00oooool4oh20P7Cooooo
1?n0P805ooooo`SoolP0K?ooool8ooo800Gooooo00?o/[:boooooooo0000
M_ooool1ool0007o/[:b0Oooool000[oP820J?o^k^h:oh20P0Gok^k^00?o
ooooogMgMoo^k^h00oo^k^h01_nk^k_oIS=Vooooooo^k^koVIVIohR8R0;o
k^k^00?oMgMgolc<c?o^k^h0GOo^k^h01?mgMgOoc<c<oooooomgMgL4onk^
kP06ok^k^omV<fKoooooonk^k_nIVIWoR8R81Oo^k^h4oh20P7Cok^k^1?n0
P805onk^kPSoolP0K?o^k^h8ooo800Gok^k^00?o/[:boooooooo0000M_o^
k^h1ool0007o/[:b0Oooool000[oP820J?oVi^H:oh20P0Goi^KV00?ooooo
oc<c<oooool02oo^k^h00omgMgOoc<c<onKViP1KonKViP;ok^k^00GoMgMg
olc<c?oooooo<c<cooooo`09onk^kPGoi^KV1?n0P81donKViPCoP8201OoV
i^H8ooo806coi^KV2?oob005onKViP03ok:b/_ooooooo`0007Koi^KV0Ooo
0001ok:b/P7ooooo000:oh20P6Sok^k^2_n0P805onk^kP03oooooolc<c?o
MgMg00coMgMg00?oooooonk^k_o^k^h0F_o^k^h3ogMgM`;ooooo00?o<c<c
ogMgMomgMgL02?mgMgL5onk^kPCoP820M?o^k^h4oh20P0Gok^k^2?oob01/
onk^kPSoolP01Oo^k^h00onb/[;oooooool0001fonk^kP7oo`000Onb/[81
ooooo`002_n0P81Xooooo`[oP8201_ooool00on8R8SoA4A4odA4A005odA4
A003oc<c<om4A4CoA4A400?oA4A400?oVIVIooooooooool0F_ooool3odA4
A003oiVIVOooooooR8R800OoA4A400?o<c<codA4A?m4A4@01Oooool4oh20
P7Cooooo1?n0P805ooooo`SoolP0K?ooool8ooo800Gooooo00?o/[:boooo
oooo0000M_ooool1ool0007o/[:b0Oooool000[oP820J?o^k^h:oh20P0Go
k^k^00?oooooodA4A?mVIVH00omgMgL00omVIVKoMgMgogMgM`05ogMgM`03
oc<c<oo<c<cok^k^05_ok^k^0_mgMgL01Olc<c?oc<c<oooooom4A4CoIVIV
00?oMgMg00?oIVIVogMgMomgMgL00omgMgL5onk^kPCoP820M?o^k^h4oh20
P0Gok^k^2?oob01/onk^kPSoolP01Oo^k^h00onb/[;oooooool0001fonk^
kP7oo`000Onb/[81ooooo`002_n0P81XonKViP[oP8201OoVi^H03?oooooo
<c<conk^k_o^k^ko^k^kogMgMonZZZ[oooooonk^k_oMgMgoMgMgomgMg@;o
k^k^00?oMgMgolc<c?oVi^H0FooVi^H2onk^kP04ogMgMoo<c<cooooooc<c
<`;ok^k^00So^k^kogMgMonZZZ[oooooonk^k_oMgMgoMgMgomgMg@Goi^KV
1?n0P81donKViPCoP8201OoVi^H8ooo806coi^KV2?oob005onKViP03ok:b
/_ooooooo`0007Koi^KV0Ooo0001ok:b/P7ooooo000:oh20P6Sok^k^2_n0
P805onk^kP06oooooolc<c?oooooonk^k_mgMgOo03?<0_lc<`002?m4A4Co
<`0co`008_mV06KoMgMgoooooomgMgOo^k^kG?o^k^h02_mgMgOoooooogMg
Monk^k_ooooooc<c<oooooook^k^ogMgMol0<l`2oc<c0004odA4A?lc03?o
000RofH0IPGok^k^1?n0P81donk^kPCoP8201Oo^k^h8ooo806cok^k^2?oo
b005onk^kP03ok:b/_ooooooo`0007Kok^k^0Ooo0001ok:b/P7ooooo000:
oh20P6Sooooo2_n0P806ooooo`0?ogMgMoo^k^kok^k^ofIVI_l0I_oo06K<
odA4A?lc03?o<c<cogMgMolc03?oR8R8onk^k_mVIVKoc<c<05cooooo00Ko
R8R8onk^k_mVIVKoc<c<oooooomgMgL2onk^kP08ofIVI_l0I_oo06K<odA4
A?lc03?o<c<cogMgMolc03<5ooooo`CoP820M?ooool4oh20P0Gooooo2?oo
b01/ooooo`SoolP01Oooool00onb/[;oooooool0001fooooo`7oo`000Onb
/[81ooooo`002_n0P81Xonk^kP[oP8201Oo^k^h01Ooooooo<c<conk^k_oM
gMgo4A4A00;o06Ko00Wo<fK<ob8R8_n8R8SoVIVIob8R8_oMgMgok^k^ogMg
Moo<c<`0G?o^k^h02OoMgMgok^k^ogMgMoo<c<cooooooc<c<oo^k^kogMgM
oa4A4@02o`1Vo`05oc=Vc?lR8R;oR8R8oiVIVOlR8R801Oo^k^h4oh20P7Co
k^k^1?n0P805onk^kPSoolP0K?o^k^h8ooo800Gok^k^00?o/[:boooooooo
0000M_o^k^h1ool0007o/[:b0Oooool000[oP820J?oVi^H:oh20P0Goi^KV
00Kooooooc<c<oo^k^ko<c<coc<0<ol00142ob8R8P08o`0c<olc03?o4@00
o`000?lc<c?o^k^kogMgMonk^k]LonKViP0:oc<c<onk^k_oMgMgok^k^ooo
oooo<c<conk^k_lc<c?o<`0co`004@;o8R8R00Co03<coc<0<olA003o0000
1OoVi^H4oh20P7Coi^KV1?n0P805onKViPSoolP0K?oVi^H8ooo800Goi^KV
00?o/[:boooooooo0000M_oVi^H1ool0007o/[:b0Oooool000[oP820J?o^
k^h:oh20P0Gok^k^013oooooogMgMomV<fKoIS=VogMgMon8R8SoIVIVoc<c
0?l0<lco06K<oc<0I_l0003oIS=Voc<c<omgMgOoc<c<G?o^k^h01_mV<fKo
<c<cogMgMoo<c<coooooogMgM`;oIS=V00SoMgMgohR8R?mVIVKo<c<0o`0c
c?l0I/co<`1Vo`0000Gok^k^1?n0P81donk^kPCoP8201Oo^k^h8ooo806co
k^k^2?oob005onk^kP03ok:b/_ooooooo`0007Kok^k^0Ooo0001ok:b/P7o
oooo000:oh20P6Sooooo2_n0P806ooooo`08odA4A?lc03?oc03<ofHcI_mV
IVKo4@00oiUV0?o<V@02o`1Vc0;oV@2I00?o^k^kogMgMoo<c<`0G?ooool0
3OnI09Wo^k^kogMgMoo<c<coooooodA4A?lc03?oc03<ofHcI_mVIVKo4@00
oiUV0?o<V@000_l0I/`00onI09Woooooooooo`03ooooo`CoP820M?ooool4
oh20P0Gooooo2?oob01/ooooo`SoolP01Oooool00onb/[;oooooool0001f
ooooo`7oo`000Onb/[81ooooo`002_n0P81Xonk^kP[oP8201Oo^k^h01?oo
oooo<c<colc<c?m4A4@2o`00000:oc<0<omVIP3ool`0oiUV0?mV06Koc03o
ofH0I_mV<fKoMgMgok^k^ecok^k^00SoIP1VofHcI_mgMgOo^k^koooooolc
<c?oc<c<odA4A0;o000000Ko<`0cofIV0?ooc03oVFH0ofH0I_o<0?l5onk^
kPCoP820M?o^k^h4oh20P0Gok^k^2?oob01/onk^kPSoolP01Oo^k^h00onb
/[;oooooool0001fonk^kP7oo`000Onb/[81ooooo`002_n0P81XonKViP[o
P8201OoVi^H01oooooooMgMgonk^k_o^k^ko8R8RoiT0VOmV<fH00_mV06H0
1olc03?oVFH0oa4A4Oo<c<cok^k^ogMgMoo<c<`0G?oVi^H01_o<c<cok^k^
ogMgMoo<c<coooooogMgM`;ok^k^00?o8R8RoiT0VOmV<fH00_mV06H00olc
03?oVFH0oa4A4@05onKViPCoP820M?oVi^H4oh20P0Goi^KV2?oob01/onKV
iPSoolP01OoVi^H00onb/[;oooooool0001fonKViP7oo`000Onb/[81oooo
o`002_n0P81Xonk^kP[oP8201Oo^k^h01_ooooooA4A4onk^k_nIVIWo4A4A
odA4A0;oc03<00CoV@2Io`0cI_o<V@3oMgMg0_o^k^h00omgMgOoc<c<onk^
kP1Monk^kP08ogMgMoo<c<coooooodA4A?o^k^koVIVIoa4A4Om4A4@2ol`0
c004oiT0VOl0<fKoc9T0ogMgM`Gok^k^1?n0P81donk^kPCoP8201Oo^k^h8
ooo806cok^k^2?oob005onk^kP03ok:b/_ooooooo`0007Kok^k^0Ooo0001
ok:b/P7ooooo000:oh20P6Sooooo2_n0P806ooooo`08oc<c<oo^k^koMgMg
oc<c<omVIVKo<c<col`0c?m4A4@2o`0cIP05ogMgMoo^k^kok^k^ogMgMonk
^k/0G?ooool2onk^kP0;ogMgMonk^k_ooooooc<c<oo^k^koMgMgoc<c<omV
IVKo<c<col`0c?m4A4@00_l0<fH00omgMgOoooooooooo`03ooooo`CoP820
M?ooool4oh20P0Gooooo2?oob01/ooooo`SoolP01Oooool00onb/[;ooooo
ool0001fooooo`7oo`000Onb/[81ooooo`002_n0P81Xonk^kP[oP8201Oo^
k^h00oooooooMgMgonk^kP03onk^kP06ok^k^omV<fKoooooonk^k_nIVIWo
R8R80_o^k^h00omgMgOoc<c<onk^kP1Monk^kP04ogMgMoo<c<coooooogMg
M`Cok^k^00Ko^k^kofHcI_ooooook^k^oiVIVOn8R8P5onk^kPCoP820M?o^
k^h4oh20P0Gok^k^2?oob01/onk^kPSoolP01Oo^k^h00onb/[;oooooool0
001fonk^kP7oo`000Onb/[81ooooo`002_n0P81XonKViP[oP8201OoVi^H0
0ooooooo<c<cooooo`0;onk^kP03ogMgMoo<c<coi^KV05_oi^KV0_o^k^h0
1OmgMgOoc<c<oooooolc<c?ooooo00Wok^k^1OoVi^H4oh20P7Coi^KV1?n0
P805onKViPSoolP0K?oVi^H8ooo800Goi^KV00?o/[:boooooooo0000M_oV
i^H1ool0007o/[:b0Oooool000[oP820J?o^k^h:oh20P0Gok^k^00?ooooo
oc<c<omgMgL03?mgMgL00oooooook^k^onk^kP1Jonk^kP?oMgMg0_ooool0
0olc<c?oMgMgogMgM`08ogMgM`Gok^k^1?n0P81donk^kPCoP8201Oo^k^h8
ooo806cok^k^2?oob005onk^kP03ok:b/_ooooooo`0007Kok^k^0Ooo0001
ok:b/P7ooooo000:oh20P6Sooooo2_n0P806ooooo`03ohR8R?m4A4CoA4A4
00GoA4A400?o<c<codA4A?m4A4@00om4A4@00onIVIWoooooooooo`1Joooo
o`?oA4A400?oVIVIoooooon8R8P01om4A4@00olc<c?oA4A4odA4A005oooo
o`CoP820M?ooool4oh20P0Gooooo2?oob01/ooooo`SoolP01Oooool00onb
/[;oooooool0001fooooo`7oo`000Onb/[81ooooo`002_n0P81Xonk^kP[o
P8201Oo^k^h00oooooooA4A4ofIVIP03ogMgM`03ofIVI_mgMgOoMgMg00Go
MgMg00?o<c<colc<c?o^k^h0Foo^k^h2ogMgM`05oc<c<oo<c<coooooodA4
A?mVIVH00omgMgL00omVIVKoMgMgogMgM`03ogMgM`Gok^k^1?n0P81donk^
kPCoP8201Oo^k^h8ooo806cok^k^2?oob005onk^kP03ok:b/_ooooooo`00
07Kok^k^0Ooo0001ok:b/P7ooooo000:oh20P6Soi^KV2_n0P805onKViP0<
oooooolc<c?ok^k^onk^k_nk^k_oMgMgojZZZ_ooooook^k^omgMgOmgMgOo
gMgM0_o^k^h00omgMgOoc<c<onKViP1KonKViP;ok^k^00CoMgMgolc<c?oo
oooo<c<c0_o^k^h02?nk^k_oMgMgojZZZ_ooooook^k^omgMgOmgMgOogMgM
1OoVi^H4oh20P7Coi^KV1?n0P805onKViPSoolP0K?oVi^H8ooo800Goi^KV
00?o/[:boooooooo0000M_oVi^H1ool0007o/[:b0Oooool000[oP820J?o^
k^h:oh20P0Gok^k^00Kooooooc<c<oooooook^k^ogMgMol0<l`2oc<c0008
odA4A?lc03?o000RofH0I_mgMgOoooooogMgMonk^k]Lonk^kP0:ogMgMooo
ooooMgMgok^k^ooooooo<c<cooooooo^k^koMgMgo`0cc0;o<c<000CoA4A4
oc<0<ol002;oIP1V1Oo^k^h4oh20P7Cok^k^1?n0P805onk^kPSoolP0K?o^
k^h8ooo800Gok^k^00?o/[:boooooooo0000M_o^k^h1ool0007o/[:b0Ooo
ool000[oP820J?ooool:oh20P0Kooooo00ooMgMgonk^k_o^k^koIVIVo`1V
ool0I/coA4A4oc<0<olc<c?oMgMgoc<0<on8R8Sok^k^ofIVI_o<c<`0G?oo
ool01_n8R8Sok^k^ofIVI_o<c<coooooogMgM`;ok^k^00SoIVIVo`1Vool0
I/coA4A4oc<0<olc<c?oMgMgoc<0<`Gooooo1?n0P81dooooo`CoP8201Ooo
ool8ooo806cooooo2?oob005ooooo`03ok:b/_ooooooo`0007Kooooo0Ooo
0001ok:b/P7ooooo000:oh20P6Sok^k^2_n0P805onk^kP05oooooolc<c?o
k^k^omgMgOlA4A400_l0I_l02OlcI/co8R8RohR8R?nIVIWo8R8RomgMgOo^
k^koMgMgolc<c01Lonk^kP09omgMgOo^k^koMgMgolc<c?oooooo<c<conk^
k_oMgMgo4A4A00;o06Ko00Go<fK<ob8R8_n8R8SoVIVIob8R8P05onk^kPCo
P820M?o^k^h4oh20P0Gok^k^2?oob01/onk^kPSoolP01Oo^k^h00onb/[;o
ooooool0001fonk^kP7oo`000Onb/[81ooooo`002_n0P81XonKViP[oP820
1OoVi^H01_oooooo<c<conk^k_lc<c?o<`0co`004@;o8R8R00So03<coc<0
<olA003o0000oc<c<onk^k_oMgMgok^k^ecoi^KV00[o<c<cok^k^omgMgOo
^k^koooooolc<c?ok^k^oc<c<olc03?o000A0_lR8R801?l0<c?o<`0coa40
0?l00005onKViPCoP820M?oVi^H4oh20P0Goi^KV2?oob01/onKViPSoolP0
1OoVi^H00onb/[;oooooool0001fonKViP7oo`000Onb/[81ooooo`002_n0
P81Xonk^kP[oP8201Oo^k^h04?ooooooMgMgofHcI_mV<fKoMgMgohR8R?mV
IVKo<c<0o`0cc?l0I/co<`1Vo`000?mV<fKo<c<cogMgMoo<c<aLonk^kP06
ofHcI_lc<c?oMgMgolc<c?ooooooMgMg0_mV<fH02?mgMgOoR8R8ofIVI_lc
<`3o03?<o`1Vc?lc06Ko00001Oo^k^h4oh20P7Cok^k^1?n0P805onk^kPSo
olP0K?o^k^h8ooo800Gok^k^00?o/[:boooooooo0000M_o^k^h1ool0007o
/[:b0Oooool000[oP820J?ooool:oh20P0Kooooo00SoA4A4oc<0<oo<0<co
IS=VofIVI_lA003oVFH0olbI00;o06K<0_nI09T00onk^k_oMgMgolc<c01L
ooooo`0=oiT0VOnk^k_oMgMgolc<c?ooooooA4A4oc<0<oo<0<coIS=VofIV
I_lA003oVFH0olbI0002o`1Vc003oiT0VOoooooooooo00?ooooo1?n0P81d
ooooo`CoP8201Oooool8ooo806cooooo2?oob005ooooo`03ok:b/_oooooo
o`0007Kooooo0Ooo0001ok:b/P7ooooo000:oh20P6Sok^k^2_n0P805onk^
kP04oooooolc<c?oc<c<odA4A0;o000000[o<`0cofIV0?ooc03oVFH0ofH0
I_o<0?ooIP1VofHcI_mgMgOo^k^kG?o^k^h02?mV06KoIS=VogMgMonk^k_o
oooooc<c<oo<c<coA4A40_l000001_lc03?oIVH0ooo<0?nIIP3oIP1Vol`0
o`Gok^k^1?n0P81donk^kPCoP8201Oo^k^h8ooo806cok^k^2?oob005onk^
kP03ok:b/_ooooooo`0007Kok^k^0Ooo0001ok:b/P7ooooo000:oh20P6So
i^KV2_n0P805onKViP07oooooomgMgOok^k^onk^k_lR8R;oV@2IofHcIP02
ofH0IP07oc<0<onIIP3o4A4Aolc<c?o^k^koMgMgolc<c01LonKViP06olc<
c?o^k^koMgMgolc<c?ooooooMgMg0_o^k^h00olR8R;oV@2IofHcIP02ofH0
IP03oc<0<onIIP3o4A4A00Goi^KV1?n0P81donKViPCoP8201OoVi^H8ooo8
06coi^KV2?oob005onKViP03ok:b/_ooooooo`0007Koi^KV0Ooo0001ok:b
/P7ooooo000:oh20P6Sok^k^2_n0P805onk^kP06oooooom4A4Cok^k^oiVI
VOlA4A7oA4A40_o<0<`01?nI09Wo03=VolbI0?mgMgL2onk^kP03ogMgMoo<
c<cok^k^05gok^k^00SoMgMgolc<c?ooooooA4A4onk^k_nIVIWo4A4AodA4
A0;oc03<00CoV@2Io`0cI_o<V@3oMgMg1Oo^k^h4oh20P7Cok^k^1?n0P805
onk^kPSoolP0K?o^k^h8ooo800Gok^k^00?o/[:boooooooo0000M_o^k^h1
ool0007o/[:b0Oooool000[oP820J?ooool:oh20P0Kooooo00So<c<conk^
k_mgMgOo<c<cofIVI_lc<c?oc03<odA4A0;o03=V00GoMgMgonk^k_o^k^ko
MgMgok^k^`1Looooo`;ok^k^00_oMgMgok^k^ooooooo<c<conk^k_mgMgOo
<c<cofIVI_lc<c?oc03<odA4A002o`0cIP03ogMgMooooooooooo00?ooooo
1?n0P81dooooo`CoP8201Oooool8ooo806cooooo2?oob005ooooo`03ok:b
/_ooooooo`0007Kooooo0Ooo0001ok:b/P7ooooo000:oh20P6Sok^k^2_n0
P805onk^kP03oooooomgMgOok^k^00?ok^k^00Ko^k^kofHcI_ooooook^k^
oiVIVOn8R8P2onk^kP03ogMgMoo<c<cok^k^05gok^k^00CoMgMgolc<c?oo
ooooMgMg1?o^k^h01_nk^k_oIS=Vooooooo^k^koVIVIohR8R0Gok^k^1?n0
P81donk^kPCoP8201Oo^k^h8ooo806cok^k^2?oob005onk^kP03ok:b/_oo
ooooo`0007Kok^k^0Ooo0001ok:b/P7ooooo000:oh20P6Soi^KV2_n0P805
onKViP03oooooolc<c?ooooo00_ok^k^00?oMgMgolc<c?oVi^H0FooVi^H2
onk^kP05ogMgMoo<c<cooooooc<c<oooool02Oo^k^h5onKViPCoP820M?oV
i^H4oh20P0Goi^KV2?oob01/onKViPSoolP01OoVi^H00onb/[;oooooool0
001fonKViP7oo`000Onb/[81ooooo`002_n0P81Xonk^kP[oP8201Oo^k^h0
0ooooooo<c<cogMgM`0<ogMgM`03ooooooo^k^kok^k^05[ok^k^0omgMgL2
ooooo`03oc<c<omgMgOoMgMg00SoMgMg1Oo^k^h4oh20P7Cok^k^1?n0P805
onk^kPSoolP0K?o^k^h8ooo800Gok^k^00?o/[:boooooooo0000M_o^k^h1
ool0007o/[:b0Oooool000[oP820J?ooool:oh20P0Kooooo00?oR8R8odA4
A?m4A4@01Om4A4@00olc<c?oA4A4odA4A003odA4A003oiVIVOoooooooooo
05[ooooo0om4A4@00onIVIWoooooohR8R007odA4A003oc<c<om4A4CoA4A4
00Gooooo1?n0P81dooooo`CoP8201Oooool8ooo806cooooo2?oob005oooo
o`03ok:b/_ooooooo`0007Kooooo0Ooo0001ok:b/P7ooooo000:oh20P6So
k^k^2_n0P805onk^kP03oooooom4A4CoIVIV00?oMgMg00?oIVIVogMgMomg
MgL01OmgMgL00olc<c?oc<c<onk^kP1Konk^kP;oMgMg00Go<c<colc<c?oo
ooooA4A4ofIVIP03ogMgM`03ofIVI_mgMgOoMgMg00?oMgMg1Oo^k^h4oh20
P7Cok^k^1?n0P805onk^kPSoolP0K?o^k^h8ooo800Gok^k^00?o/[:boooo
oooo0000M_o^k^h1ool0007o/[:b0Oooool000[oP820J?oVi^H:oh20P0Go
i^KV00cooooooc<c<oo^k^kok^k^ok^k^omgMgOoZZZZooooooo^k^kogMgM
ogMgMooMgMd2onk^kP03ogMgMoo<c<coi^KV05_oi^KV0_o^k^h01?mgMgOo
c<c<oooooolc<c<2onk^kP08ok^k^omgMgOoZZZZooooooo^k^kogMgMogMg
MooMgMd5onKViPCoP820M?oVi^H4oh20P0Goi^KV2?oob01/onKViPSoolP0
1OoVi^H00onb/[;oooooool0001fonKViP7oo`000Onb/[81ooooo`002_n0
P81Xonk^kP[oP8201Oo^k^h01_oooooo<c<cooooooo^k^koMgMgo`0cc0;o
<c<000SoA4A4oc<0<ol002;oIP1VogMgMoooooooMgMgok^k^ecok^k^00[o
MgMgoooooomgMgOo^k^koooooolc<c?oooooonk^k_mgMgOo03?<0_lc<`00
1?m4A4Co<`0co`008_mV06H5onk^kPCoP820M?o^k^h4oh20P0Gok^k^2?oo
b01/onk^kPSoolP01Oo^k^h00onb/[;oooooool0001fonk^kP7oo`000Onb
/[81ooooo`002_n0P81Xooooo`[oP8201_ooool03omgMgOok^k^onk^k_mV
IVKo06Koo`1Vc?m4A4Co<`0coc<c<omgMgOo<`0cohR8R?o^k^koIVIVolc<
c01Looooo`06ohR8R?o^k^koIVIVolc<c?ooooooMgMg0_o^k^h02?mVIVKo
06Koo`1Vc?m4A4Co<`0coc<c<omgMgOo<`0c1Oooool4oh20P7Cooooo1?n0
P805ooooo`SoolP0K?ooool8ooo800Gooooo00?o/[:boooooooo0000M_oo
ool1ool0007o/[:b0Oooool000[oP820J?o^k^h:oh20P0Gok^k^00Gooooo
oc<c<oo^k^kogMgMoa4A4@02o`1Vo`09oc=Vc?lR8R;oR8R8oiVIVOlR8R;o
gMgMonk^k_mgMgOoc<c<05cok^k^00WogMgMonk^k_mgMgOoc<c<oooooolc
<c?ok^k^omgMgOlA4A400_l0I_l01OlcI/co8R8RohR8R?nIVIWo8R8R00Go
k^k^1?n0P81donk^kPCoP8201Oo^k^h8ooo806cok^k^2?oob005onk^kP03
ok:b/_ooooooo`0007Kok^k^0Ooo0001ok:b/P7ooooo000:oh20P6Soi^KV
2_n0P805onKViP06oooooolc<c?ok^k^oc<c<olc03?o000A0_lR8R802?l0
<c?o<`0coa400?l0003o<c<cok^k^omgMgOo^k^kG?oVi^H02_lc<c?o^k^k
ogMgMonk^k_ooooooc<c<oo^k^ko<c<coc<0<ol00142ob8R8P04o`0c<olc
03?o4@00o`0000Goi^KV1?n0P81donKViPCoP8201OoVi^H8ooo806coi^KV
2?oob005onKViP03ok:b/_ooooooo`0007Koi^KV0Ooo0001ok:b/P7ooooo
000:oh20P6Sok^k^2_n0P805onk^kP0@oooooomgMgOoIS=VofHcI_mgMgOo
R8R8ofIVI_lc<`3o03?<o`1Vc?lc06Ko0000ofHcI_lc<c?oMgMgolc<c5co
k^k^00KoIS=Voc<c<omgMgOoc<c<oooooomgMgL2ofHcIP08ogMgMon8R8So
IVIVoc<c0?l0<lco06K<oc<0I_l00005onk^kPCoP820M?o^k^h4oh20P0Go
k^k^2?oob01/onk^kPSoolP01Oo^k^h00onb/[;oooooool0001fonk^kP7o
o`000Onb/[81ooooo`002_n0P81Xooooo`[oP8201_ooool02?m4A4Co<`0c
ol`0c?mV<fKoIVIVoa400?nIIP3oc9T00_l0I/`2oiT0V@03ok^k^omgMgOo
c<c<05cooooo00goV@2Iok^k^omgMgOoc<c<oooooom4A4Co<`0col`0c?mV
<fKoIVIVoa400?nIIP3oc9T000;o06K<00?oV@2Iooooooooool00oooool4
oh20P7Cooooo1?n0P805ooooo`SoolP0K?ooool8ooo800Gooooo00?o/[:b
oooooooo0000M_ooool1ool0007o/[:b0Oooool000[oP820J?o^k^h:oh20
P0Gok^k^00Cooooooc<c<oo<c<coA4A40_l000002_lc03?oIVH0ooo<0?nI
IP3oIP1Vol`0oomV06KoIS=VogMgMonk^k]Lonk^kP08ofH0I_mV<fKoMgMg
ok^k^ooooooo<c<colc<c?m4A4@2o`000006oc<0<omVIP3ool`0oiUV0?mV
06Koc03o1Oo^k^h4oh20P7Cok^k^1?n0P805onk^kPSoolP0K?o^k^h8ooo8
00Gok^k^00?o/[:boooooooo0000M_o^k^h1ool0007o/[:b0Oooool000[o
P820J?oVi^H:oh20P0Goi^KV00OoooooogMgMoo^k^kok^k^ob8R8_nI09Wo
IS=V00;oIP1V00Oo<`0coiUV0?lA4A7oc<c<onk^k_mgMgOoc<c<05coi^KV
00Koc<c<onk^k_mgMgOoc<c<oooooomgMgL2onk^kP03ob8R8_nI09WoIS=V
00;oIP1V00?o<`0coiUV0?lA4A401OoVi^H4oh20P7Coi^KV1?n0P805onKV
iPSoolP0K?oVi^H8ooo800Goi^KV00?o/[:boooooooo0000M_oVi^H1ool0
007o/[:b0Oooool000[oP820J?o^k^h:oh20P0Gok^k^00KoooooodA4A?o^
k^koVIVIoa4A4Om4A4@2ol`0c004oiT0VOl0<fKoc9T0ogMgM`;ok^k^00?o
MgMgolc<c?o^k^h0GOo^k^h02?mgMgOoc<c<oooooom4A4Cok^k^oiVIVOlA
4A7oA4A40_o<0<`01?nI09Wo03=VolbI0?mgMgL5onk^kPCoP820M?o^k^h4
oh20P0Gok^k^2?oob01/onk^kPSoolP01Oo^k^h00onb/[;oooooool0001f
onk^kP7oo`000Onb/[81ooooo`002_n0P81Xooooo`[oP8201_ooool02?lc
<c?ok^k^ogMgMolc<c?oIVIVoc<c<oo<0<coA4A40_l0<fH01OmgMgOok^k^
onk^k_mgMgOo^k^k05cooooo0_o^k^h02omgMgOo^k^koooooolc<c?ok^k^
ogMgMolc<c?oIVIVoc<c<oo<0<coA4A400;o03=V00?oMgMgooooooooool0
0oooool4oh20P7Cooooo1?n0P805ooooo`SoolP0K?ooool8ooo800Gooooo
00?o/[:boooooooo0000M_ooool1ool0007o/[:b0Oooool000[oP820J?o^
k^h:oh20P0Gok^k^00?oooooogMgMoo^k^h00oo^k^h01_nk^k_oIS=Voooo
ooo^k^koVIVIohR8R0;ok^k^00?oMgMgolc<c?o^k^h0GOo^k^h01?mgMgOo
c<c<oooooomgMgL4onk^kP06ok^k^omV<fKoooooonk^k_nIVIWoR8R81Oo^
k^h4oh20P7Cok^k^1?n0P805onk^kPSoolP0K?o^k^h8ooo800Gok^k^00?o
/[:boooooooo0000M_o^k^h1ool0007o/[:b0Oooool000[oP820J?oVi^H:
oh20P0Goi^KV00?ooooooc<c<oooool02oo^k^h00omgMgOoc<c<onKViP1K
onKViP;ok^k^00GoMgMgolc<c?oooooo<c<cooooo`09onk^kPGoi^KV1?n0
P81donKViPCoP8201OoVi^H8ooo806coi^KV2?oob005onKViP03ok:b/_oo
ooooo`0007Koi^KV0Ooo0001ok:b/P7ooooo000:oh20P6Sok^k^2_n0P805
onk^kP03oooooolc<c?oMgMg00coMgMg00?oooooonk^k_o^k^h0F_o^k^h3
ogMgM`;ooooo00?o<c<cogMgMomgMgL02?mgMgL5onk^kPCoP820M?o^k^h4
oh20P0Gok^k^2?oob01/onk^kPSoolP01Oo^k^h00onb/[;oooooool0001f
onk^kP7oo`000Onb/[81ooooo`002_n0P81Xooooo`[oP8201_ooool00on8
R8SoA4A4odA4A005odA4A003oc<c<om4A4CoA4A400?oA4A400?oVIVIoooo
oon8R8P01om4A4@00olc<c?oA4A4odA4A003odA4A003oiVIVOooooooR8R8
00OoA4A400?o<c<codA4A?m4A4@00om4A4@00onIVIWoooooohR8R007odA4
A003oc<c<om4A4CoA4A400?oA4A400?oVIVIoooooon8R8P01om4A4@00olc
<c?oA4A4odA4A003odA4A003oiVIVOooooooR8R800OoA4A400?o<c<codA4
A?m4A4@00om4A4@00onIVIWoooooohR8R007odA4A003oc<c<om4A4CoA4A4
00?oA4A400?oVIVIoooooon8R8P01om4A4@00olc<c?oA4A4odA4A005oooo
o`CoP820M?ooool4oh20P0Gooooo2?oob01/ooooo`SoolP01Oooool00onb
/[;oooooool0001fooooo`7oo`000Onb/[81ooooo`002_n0P81Xonk^kP[o
P8201Oo^k^h00oooooooA4A4ofIVIP03ogMgM`03ofIVI_mgMgOoMgMg00Go
MgMg00Go<c<colc<c?ooooooA4A4ofIVIP03ogMgM`03ofIVI_mgMgOoMgMg
00GoMgMg00Go<c<colc<c?ooooooA4A4ofIVIP03ogMgM`03ofIVI_mgMgOo
MgMg00GoMgMg00Go<c<colc<c?ooooooA4A4ofIVIP03ogMgM`03ofIVI_mg
MgOoMgMg00GoMgMg00Go<c<colc<c?ooooooA4A4ofIVIP03ogMgM`03ofIV
I_mgMgOoMgMg00GoMgMg00Go<c<colc<c?ooooooA4A4ofIVIP03ogMgM`03
ofIVI_mgMgOoMgMg00GoMgMg00Go<c<colc<c?ooooooA4A4ofIVIP03ogMg
M`03ofIVI_mgMgOoMgMg00GoMgMg00Go<c<colc<c?ooooooA4A4ofIVIP03
ogMgM`03ofIVI_mgMgOoMgMg00?oMgMg1Oo^k^h4oh20P7Cok^k^1?n0P805
onk^kPSoolP0K?o^k^h8ooo800Gok^k^00?o/[:boooooooo0000M_o^k^h1
ool0007o/[:b0Oooool000[oP820J?oVi^H:oh20P0Goi^KV00cooooooc<c
<oo^k^kok^k^ok^k^omgMgOoZZZZooooooo^k^kogMgMogMgMooMgMd2onk^
kP04ogMgMoo<c<cooooooc<c<`;ok^k^00So^k^kogMgMonZZZ[oooooonk^
k_oMgMgoMgMgomgMg@;ok^k^00CoMgMgolc<c?oooooo<c<c0_o^k^h02?nk
^k_oMgMgojZZZ_ooooook^k^omgMgOmgMgOogMgM0_o^k^h01?mgMgOoc<c<
oooooolc<c<2onk^kP08ok^k^omgMgOoZZZZooooooo^k^kogMgMogMgMooM
gMd2onk^kP04ogMgMoo<c<cooooooc<c<`;ok^k^00So^k^kogMgMonZZZ[o
ooooonk^k_oMgMgoMgMgomgMg@;ok^k^00CoMgMgolc<c?oooooo<c<c0_o^
k^h02?nk^k_oMgMgojZZZ_ooooook^k^omgMgOmgMgOogMgM0_o^k^h01?mg
MgOoc<c<oooooolc<c<2onk^kP08ok^k^omgMgOoZZZZooooooo^k^kogMgM
ogMgMooMgMd2onk^kP04ogMgMoo<c<cooooooc<c<`;ok^k^00So^k^kogMg
MonZZZ[oooooonk^k_oMgMgoMgMgomgMg@Goi^KV1?n0P81donKViPCoP820
1OoVi^H8ooo806coi^KV2?oob005onKViP03ok:b/_ooooooo`0007Koi^KV
0Ooo0001ok:b/P7ooooo000:oh20P6Sok^k^2_n0P805onk^kP06oooooolc
<c?oooooonk^k_mgMgOo03?<0_lc<`003_m4A4Co<`0co`008_mV06KoMgMg
oooooomgMgOo^k^koooooolc<c?oooooonk^k_mgMgOo03?<0_lc<`003_m4
A4Co<`0co`008_mV06KoMgMgoooooomgMgOo^k^koooooolc<c?oooooonk^
k_mgMgOo03?<0_lc<`003_m4A4Co<`0co`008_mV06KoMgMgoooooomgMgOo
^k^koooooolc<c?oooooonk^k_mgMgOo03?<0_lc<`003_m4A4Co<`0co`00
8_mV06KoMgMgoooooomgMgOo^k^koooooolc<c?oooooonk^k_mgMgOo03?<
0_lc<`003_m4A4Co<`0co`008_mV06KoMgMgoooooomgMgOo^k^koooooolc
<c?oooooonk^k_mgMgOo03?<0_lc<`003_m4A4Co<`0co`008_mV06KoMgMg
oooooomgMgOo^k^koooooolc<c?oooooonk^k_mgMgOo03?<0_lc<`003_m4
A4Co<`0co`008_mV06KoMgMgoooooomgMgOo^k^koooooolc<c?oooooonk^
k_mgMgOo03?<0_lc<`001?m4A4Co<`0co`008_mV06H5onk^kPCoP820M?o^
k^h4oh20P0Gok^k^2?oob01/onk^kPSoolP01Oo^k^h00onb/[;oooooool0
001fonk^kP7oo`000Onb/[81ooooo`002_n0P81Xooooo`[oP8201_ooool0
4OmgMgOok^k^onk^k_mVIVKo06Koo`1Vc?m4A4Co<`0coc<c<omgMgOo<`0c
ohR8R?o^k^koIVIVolc<c?ooooooMgMg00;ok^k^00koIVIVo`1Vool0I/co
A4A4oc<0<olc<c?oMgMgoc<0<on8R8Sok^k^ofIVI_o<c<coooooogMgM`;o
k^k^00koIVIVo`1Vool0I/coA4A4oc<0<olc<c?oMgMgoc<0<on8R8Sok^k^
ofIVI_o<c<coooooogMgM`;ok^k^00koIVIVo`1Vool0I/coA4A4oc<0<olc
<c?oMgMgoc<0<on8R8Sok^k^ofIVI_o<c<coooooogMgM`;ok^k^00koIVIV
o`1Vool0I/coA4A4oc<0<olc<c?oMgMgoc<0<on8R8Sok^k^ofIVI_o<c<co
ooooogMgM`;ok^k^00koIVIVo`1Vool0I/coA4A4oc<0<olc<c?oMgMgoc<0
<on8R8Sok^k^ofIVI_o<c<coooooogMgM`;ok^k^00koIVIVo`1Vool0I/co
A4A4oc<0<olc<c?oMgMgoc<0<on8R8Sok^k^ofIVI_o<c<coooooogMgM`;o
k^k^00SoIVIVo`1Vool0I/coA4A4oc<0<olc<c?oMgMgoc<0<`Gooooo1?n0
P81dooooo`CoP8201Oooool8ooo806cooooo2?oob005ooooo`03ok:b/_oo
ooooo`0007Kooooo0Ooo0001ok:b/P7ooooo000:oh20P6Sok^k^2_n0P805
onk^kP05oooooolc<c?ok^k^omgMgOlA4A400_l0I_l03_lcI/co8R8RohR8
R?nIVIWo8R8RomgMgOo^k^koMgMgolc<c?oooooo<c<conk^k_oMgMgo4A4A
0_l0I_l03_lcI/co8R8RohR8R?nIVIWo8R8RomgMgOo^k^koMgMgolc<c?oo
oooo<c<conk^k_oMgMgo4A4A0_l0I_l03_lcI/co8R8RohR8R?nIVIWo8R8R
omgMgOo^k^koMgMgolc<c?oooooo<c<conk^k_oMgMgo4A4A0_l0I_l03_lc
I/co8R8RohR8R?nIVIWo8R8RomgMgOo^k^koMgMgolc<c?oooooo<c<conk^
k_oMgMgo4A4A0_l0I_l03_lcI/co8R8RohR8R?nIVIWo8R8RomgMgOo^k^ko
MgMgolc<c?oooooo<c<conk^k_oMgMgo4A4A0_l0I_l03_lcI/co8R8RohR8
R?nIVIWo8R8RomgMgOo^k^koMgMgolc<c?oooooo<c<conk^k_oMgMgo4A4A
0_l0I_l03_lcI/co8R8RohR8R?nIVIWo8R8RomgMgOo^k^koMgMgolc<c?oo
oooo<c<conk^k_oMgMgo4A4A0_l0I_l01OlcI/co8R8RohR8R?nIVIWo8R8R
00Gok^k^1?n0P81donk^kPCoP8201Oo^k^h8ooo806cok^k^2?oob005onk^
kP03ok:b/_ooooooo`0007Kok^k^0Ooo0001ok:b/P7ooooo001loh20P0Go
i^KV00Kooooooc<c<oo^k^ko<c<coc<0<ol00142ob8R8P0>o`0c<olc03?o
4@00o`000?lc<c?o^k^kogMgMonk^k_ooooooc<c<oo^k^ko<c<coc<0<ol0
0142ob8R8P0>o`0c<olc03?o4@00o`000?lc<c?o^k^kogMgMonk^k_ooooo
oc<c<oo^k^ko<c<coc<0<ol00142ob8R8P0>o`0c<olc03?o4@00o`000?lc
<c?o^k^kogMgMonk^k_ooooooc<c<oo^k^ko<c<coc<0<ol00142ob8R8P0>
o`0c<olc03?o4@00o`000?lc<c?o^k^kogMgMonk^k_ooooooc<c<oo^k^ko
<c<coc<0<ol00142ob8R8P0>o`0c<olc03?o4@00o`000?lc<c?o^k^kogMg
Monk^k_ooooooc<c<oo^k^ko<c<coc<0<ol00142ob8R8P0>o`0c<olc03?o
4@00o`000?lc<c?o^k^kogMgMonk^k_ooooooc<c<oo^k^ko<c<coc<0<ol0
0142ob8R8P0>o`0c<olc03?o4@00o`000?lc<c?o^k^kogMgMonk^k_ooooo
oc<c<oo^k^ko<c<coc<0<ol00142ob8R8P04o`0c<olc03?o4@00o`0000Go
i^KV1?n0P81donKViPCoP8201OoVi^H8ooo806coi^KV2?oob005onKViP03
ok:b/_ooooooo`0007Koi^KV0Ooo0001ok:b/P7ooooo001loh20P0Gok^k^
01;oooooogMgMomV<fKoIS=VogMgMon8R8SoIVIVoc<c0?l0<lco06K<oc<0
I_l0003oIS=Voc<c<omgMgOoc<c<oooooomgMgL2ofHcIP0>ogMgMon8R8So
IVIVoc<c0?l0<lco06K<oc<0I_l0003oIS=Voc<c<omgMgOoc<c<oooooomg
MgL2ofHcIP0>ogMgMon8R8SoIVIVoc<c0?l0<lco06K<oc<0I_l0003oIS=V
oc<c<omgMgOoc<c<oooooomgMgL2ofHcIP0>ogMgMon8R8SoIVIVoc<c0?l0
<lco06K<oc<0I_l0003oIS=Voc<c<omgMgOoc<c<oooooomgMgL2ofHcIP0>
ogMgMon8R8SoIVIVoc<c0?l0<lco06K<oc<0I_l0003oIS=Voc<c<omgMgOo
c<c<oooooomgMgL2ofHcIP0>ogMgMon8R8SoIVIVoc<c0?l0<lco06K<oc<0
I_l0003oIS=Voc<c<omgMgOoc<c<oooooomgMgL2ofHcIP0>ogMgMon8R8So
IVIVoc<c0?l0<lco06K<oc<0I_l0003oIS=Voc<c<omgMgOoc<c<oooooomg
MgL2ofHcIP08ogMgMon8R8SoIVIVoc<c0?l0<lco06K<oc<0I_l00005onk^
kPCoP820M?o^k^h4oh20P0Gok^k^2?oob01/onk^kPSoolP01Oo^k^h00onb
/[;oooooool0001fonk^kP7oo`000Onb/[81ooooo`00O?n0P806ooooo`08
odA4A?lc03?oc03<ofHcI_mVIVKo4@00oiUV0?o<V@02o`1Vc0;oV@2I00co
^k^kogMgMoo<c<coooooodA4A?lc03?oc03<ofHcI_mVIVKo4@00oiUV0?o<
V@02o`1Vc0;oV@2I00co^k^kogMgMoo<c<coooooodA4A?lc03?oc03<ofHc
I_mVIVKo4@00oiUV0?o<V@02o`1Vc0;oV@2I00co^k^kogMgMoo<c<cooooo
odA4A?lc03?oc03<ofHcI_mVIVKo4@00oiUV0?o<V@02o`1Vc0;oV@2I00co
^k^kogMgMoo<c<coooooodA4A?lc03?oc03<ofHcI_mVIVKo4@00oiUV0?o<
V@02o`1Vc0;oV@2I00co^k^kogMgMoo<c<coooooodA4A?lc03?oc03<ofHc
I_mVIVKo4@00oiUV0?o<V@02o`1Vc0;oV@2I00co^k^kogMgMoo<c<cooooo
odA4A?lc03?oc03<ofHcI_mVIVKo4@00oiUV0?o<V@02o`1Vc0;oV@2I00co
^k^kogMgMoo<c<coooooodA4A?lc03?oc03<ofHcI_mVIVKo4@00oiUV0?o<
V@02o`1Vc003oiT0VOoooooooooo00?ooooo1?n0P81dooooo`CoP8201Ooo
oomlooo800Gooooo00?o/[:boooooooo0000M_ooool1ool0007o/[:b0Ooo
ool007coP8201Oo^k^h01?oooooo<c<colc<c?m4A4@2o`00000>oc<0<omV
IP3ool`0oiUV0?mV06Koc03oofH0I_mV<fKoMgMgok^k^ooooooo<c<colc<
c?m4A4@2o`00000>oc<0<omVIP3ool`0oiUV0?mV06Koc03oofH0I_mV<fKo
MgMgok^k^ooooooo<c<colc<c?m4A4@2o`00000>oc<0<omVIP3ool`0oiUV
0?mV06Koc03oofH0I_mV<fKoMgMgok^k^ooooooo<c<colc<c?m4A4@2o`00
000>oc<0<omVIP3ool`0oiUV0?mV06Koc03oofH0I_mV<fKoMgMgok^k^ooo
oooo<c<colc<c?m4A4@2o`00000>oc<0<omVIP3ool`0oiUV0?mV06Koc03o
ofH0I_mV<fKoMgMgok^k^ooooooo<c<colc<c?m4A4@2o`00000>oc<0<omV
IP3ool`0oiUV0?mV06Koc03oofH0I_mV<fKoMgMgok^k^ooooooo<c<colc<
c?m4A4@2o`00000>oc<0<omVIP3ool`0oiUV0?mV06Koc03oofH0I_mV<fKo
MgMgok^k^ooooooo<c<colc<c?m4A4@2o`000006oc<0<omVIP3ool`0oiUV
0?mV06Koc03o1Oo^k^h4oh20P7Cok^k^1?n0P805onk^kWcoolP01Oo^k^h0
0onb/[;oooooool0001fonk^kP7oo`000Onb/[81ooooo`00O?n0P805onKV
iP07oooooomgMgOok^k^onk^k_lR8R;oV@2IofHcIP02ofH0IP09oc<0<onI
IP3o4A4Aolc<c?o^k^koMgMgolc<c?ooooooMgMg00;ok^k^00?o8R8RoiT0
VOmV<fH00_mV06H02Olc03?oVFH0oa4A4Oo<c<cok^k^ogMgMoo<c<cooooo
ogMgM`02onk^kP03ob8R8_nI09WoIS=V00;oIP1V00Wo<`0coiUV0?lA4A7o
c<c<onk^k_mgMgOoc<c<oooooomgMgL00_o^k^h00olR8R;oV@2IofHcIP02
ofH0IP09oc<0<onIIP3o4A4Aolc<c?o^k^koMgMgolc<c?ooooooMgMg00;o
k^k^00?o8R8RoiT0VOmV<fH00_mV06H02Olc03?oVFH0oa4A4Oo<c<cok^k^
ogMgMoo<c<coooooogMgM`02onk^kP03ob8R8_nI09WoIS=V00;oIP1V00Wo
<`0coiUV0?lA4A7oc<c<onk^k_mgMgOoc<c<oooooomgMgL00_o^k^h00olR
8R;oV@2IofHcIP02ofH0IP09oc<0<onIIP3o4A4Aolc<c?o^k^koMgMgolc<
c?ooooooMgMg00;ok^k^00?o8R8RoiT0VOmV<fH00_mV06H00olc03?oVFH0
oa4A4@05onKViPCoP820M?oVi^H4oh20P0Goi^KVO?oob005onKViP03ok:b
/_ooooooo`0007Koi^KV0Ooo0001ok:b/P7ooooo001loh20P0Gok^k^00Ko
ooooodA4A?o^k^koVIVIoa4A4Om4A4@2ol`0c004oiT0VOl0<fKoc9T0ogMg
M`;ok^k^00SoMgMgolc<c?ooooooA4A4onk^k_nIVIWo4A4AodA4A0;oc03<
00CoV@2Io`0cI_o<V@3oMgMg0_o^k^h02?mgMgOoc<c<oooooom4A4Cok^k^
oiVIVOlA4A7oA4A40_o<0<`01?nI09Wo03=VolbI0?mgMgL2onk^kP08ogMg
Moo<c<coooooodA4A?o^k^koVIVIoa4A4Om4A4@2ol`0c004oiT0VOl0<fKo
c9T0ogMgM`;ok^k^00SoMgMgolc<c?ooooooA4A4onk^k_nIVIWo4A4AodA4
A0;oc03<00CoV@2Io`0cI_o<V@3oMgMg0_o^k^h02?mgMgOoc<c<oooooom4
A4Cok^k^oiVIVOlA4A7oA4A40_o<0<`01?nI09Wo03=VolbI0?mgMgL2onk^
kP08ogMgMoo<c<coooooodA4A?o^k^koVIVIoa4A4Om4A4@2ol`0c004oiT0
VOl0<fKoc9T0ogMgM`;ok^k^00SoMgMgolc<c?ooooooA4A4onk^k_nIVIWo
4A4AodA4A0;oc03<00CoV@2Io`0cI_o<V@3oMgMg1Oo^k^h4oh20P7Cok^k^
1?n0P805onk^kWcoolP01Oo^k^h00onb/[;oooooool0001fonk^kP7oo`00
0Onb/[81ooooo`00O?n0P806ooooo`08oc<c<oo^k^koMgMgoc<c<omVIVKo
<c<col`0c?m4A4@2o`0cIP0>ogMgMoo^k^kok^k^ogMgMonk^k_ooooooc<c
<oo^k^koMgMgoc<c<omVIVKo<c<col`0c?m4A4@2o`0cIP0>ogMgMoo^k^ko
k^k^ogMgMonk^k_ooooooc<c<oo^k^koMgMgoc<c<omVIVKo<c<col`0c?m4
A4@2o`0cIP0>ogMgMoo^k^kok^k^ogMgMonk^k_ooooooc<c<oo^k^koMgMg
oc<c<omVIVKo<c<col`0c?m4A4@2o`0cIP0>ogMgMoo^k^kok^k^ogMgMonk
^k_ooooooc<c<oo^k^koMgMgoc<c<omVIVKo<c<col`0c?m4A4@2o`0cIP0>
ogMgMoo^k^kok^k^ogMgMonk^k_ooooooc<c<oo^k^koMgMgoc<c<omVIVKo
<c<col`0c?m4A4@2o`0cIP0>ogMgMoo^k^kok^k^ogMgMonk^k_ooooooc<c
<oo^k^koMgMgoc<c<omVIVKo<c<col`0c?m4A4@2o`0cIP0>ogMgMoo^k^ko
k^k^ogMgMonk^k_ooooooc<c<oo^k^koMgMgoc<c<omVIVKo<c<col`0c?m4
A4@2o`0cIP03ogMgMooooooooooo00?oooooO?n0P805ooooogcoolP01Ooo
ool00onb/[;oooooool0001fooooo`7oo`000Onb/[81ooooo`00O?n0P805
onk^kP03oooooomgMgOok^k^00?ok^k^00Ko^k^kofHcI_ooooook^k^oiVI
VOn8R8P2onk^kP04ogMgMoo<c<coooooogMgM`Cok^k^00Ko^k^kofHcI_oo
ooook^k^oiVIVOn8R8P2onk^kP04ogMgMoo<c<coooooogMgM`Cok^k^00Ko
^k^kofHcI_ooooook^k^oiVIVOn8R8P2onk^kP04ogMgMoo<c<coooooogMg
M`Cok^k^00Ko^k^kofHcI_ooooook^k^oiVIVOn8R8P2onk^kP04ogMgMoo<
c<coooooogMgM`Cok^k^00Ko^k^kofHcI_ooooook^k^oiVIVOn8R8P2onk^
kP04ogMgMoo<c<coooooogMgM`Cok^k^00Ko^k^kofHcI_ooooook^k^oiVI
VOn8R8P2onk^kP04ogMgMoo<c<coooooogMgM`Cok^k^00Ko^k^kofHcI_oo
ooook^k^oiVIVOn8R8P2onk^kP04ogMgMoo<c<coooooogMgM`Cok^k^00Ko
^k^kofHcI_ooooook^k^oiVIVOn8R8P5onk^kWcoP8201Oo^k^ilooo800Go
k^k^00?o/[:boooooooo0000Mooo0001ok:b/P7ooooo001loh20P0Goi^KV
00?ooooooc<c<oooool02oo^k^h01OmgMgOoc<c<oooooolc<c?ooooo00_o
k^k^00GoMgMgolc<c?oooooo<c<cooooo`0;onk^kP05ogMgMoo<c<cooooo
oc<c<oooool02oo^k^h01OmgMgOoc<c<oooooolc<c?ooooo00_ok^k^00Go
MgMgolc<c?oooooo<c<cooooo`0;onk^kP05ogMgMoo<c<cooooooc<c<ooo
ool02oo^k^h01OmgMgOoc<c<oooooolc<c?ooooo00Wok^k^1OoVi^Iloh20
P0Goi^KVO?oob005onKViP03ok:b/_oooooooooo07Oooooo0Onb/[81oooo
o`00O?n0P805onk^kP03oooooolc<c?oMgMg00coMgMg0_ooool00olc<c?o
MgMgogMgM`0;ogMgM`;ooooo00?o<c<cogMgMomgMgL02omgMgL2ooooo`03
oc<c<omgMgOoMgMg00_oMgMg0_ooool00olc<c?oMgMgogMgM`0;ogMgM`;o
oooo00?o<c<cogMgMomgMgL02omgMgL2ooooo`03oc<c<omgMgOoMgMg00_o
MgMg0_ooool00olc<c?oMgMgogMgM`08ogMgM`Gok^k^O?n0P805onk^kWco
olP01Oo^k^ikok:b/P7ooooo003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`0000?oooooonk^k_mlO7`0NOmlO7`5onk^kP03ok:b
/_o^k^kooooo07Wooooo1Oo^k^h00oooo`3ok^k^o`00o`1io`00o`Gok^k^
00?o003oonk^k_ooo`00NOooo`05onk^kP03o`00ooo^k^koo`0007Woo`00
0002ooooogSoi^KV00?o/[:bogalO?oVi^H01?oVi^H2ok:b/WSoi^KV0_oo
ool5onKViP;oool0N?oVi^H2o`00o`Goi^KV0_l00?mhonKViP;oool01OoV
i^H2o`00ogSoi^KV0Ol0o`01ool000000_oooomionk^kP03ogalO?o^k^ko
k^k^00?ok^k^00?oO7alok:b/_o^k^h0N?o^k^h00oooooook^k^onk^kP03
onk^kP;oool0NOo^k^h00ol00?ook^k^onk^kP03onk^kP;o003oNOo^k^h0
0oooo`3ok^k^onk^kP03onk^kP03oooo0?l00?ook^k^07Sok^k^0Ooo0000
07_ooooo00?oO7alooooooooool00oooool00omlO7co/[:booooo`1noooo
o`;oool0NOooool00ol00?ooooooooooo`03ooooo`;o003oNOooool00ooo
o`3oooooooooo`03ooooo`03oooo0?l00?oooooo07Sooooo0Ooo000000;o
ooooNOo^k^h00omlO7cok^k^onk^kP03onk^kP03ogalO?nb/[;ok^k^07So
k^k^00?oooooonk^k_o^k^h00oo^k^h2oooo07Wok^k^00?o003oonk^k_o^
k^h00oo^k^h2o`00ogWok^k^00?oool0onk^k_o^k^h00oo^k^h00oooo`3o
003oonk^kP1honk^kP7oo`000002ooooogWoi^KV00?oO7alonKVi_oVi^H0
0ooVi^H00omlO7co/[:bonKViP1honKViP03oooooooVi^Koi^KV00?oi^KV
0_ooo`1ionKViP03o`00oooVi^Koi^KV00?oi^KV0_l00?mionKViP03oooo
0?oVi^Koi^KV00?oi^KV00?oool0o`00oooVi^H0N?oVi^H1ool000000_oo
oomionk^kP03ogalO?o^k^kok^k^00?ok^k^00?oO7alok:b/_o^k^h0N?o^
k^h00oooooook^k^onk^kP03onk^kP;oool0NOo^k^h00ol00?ook^k^onk^
kP03onk^kP;o003oNOo^k^h00oooo`3ok^k^onk^kP03onk^kP03oooo0?l0
0?ook^k^07Sok^k^0Ooo000007_ooooo00?oO7alooooooooool00oooool0
0omlO7co/[:booooo`1nooooo`;oool0NOooool00ol00?ooooooooooo`03
ooooo`;o003oNOooool00oooo`3oooooooooo`03ooooo`03oooo0?l00?oo
oooo07Sooooo0Ooo000000;oooooNOo^k^h00omlO7cok^k^onk^kP03onk^
kP03ogalO?nb/[;ok^k^07Sok^k^00?oooooonk^k_o^k^h00oo^k^h2oooo
07Wok^k^00?o003oonk^k_o^k^h00oo^k^h2o`00ogWok^k^00?oool0onk^
k_o^k^h00oo^k^h00oooo`3o003oonk^kP1honk^kP7oo`000002ooooogWo
i^KV00?oO7alonKVi_oVi^H00ooVi^H00omlO7co/[:bonKViP1honKViP03
oooooooVi^Koi^KV00?oi^KV0_ooo`1ionKViP03o`00oooVi^Koi^KV00?o
i^KV0_l00?mionKViP03oooo0?oVi^Koi^KV00?oi^KV00?oool0o`00oooV
i^H0N?oVi^H1ool000000_oooomionk^kP03ogalO?o^k^kok^k^00?ok^k^
00?oO7alok:b/_o^k^h0N?o^k^h00oooooook^k^onk^kP03onk^kP;oool0
NOo^k^h00ol00?ook^k^onk^kP03onk^kP;o003oNOo^k^h00oooo`3ok^k^
onk^kP03onk^kP03oooo0?l00?ook^k^07Sok^k^0Ooo000007_ooooo00?o
O7alooooooooool00oooool00omlO7co/[:booooo`1nooooo`;oool0NOoo
ool00ol00?ooooooooooo`03ooooo`;o003oNOooool00oooo`3ooooooooo
o`03ooooo`03oooo0?l00?oooooo07Sooooo0Ooo000000;oooooNOo^k^h0
0omlO7cok^k^onk^kP03onk^kP03ogalO?nb/[;ok^k^07Sok^k^00?ooooo
onk^k_o^k^h00oo^k^h2oooo07Wok^k^00?o003oonk^k_o^k^h00oo^k^h2
o`00ogWok^k^00?oool0onk^k_o^k^h00oo^k^h00oooo`3o003oonk^kP1h
onk^kP7oo`000002ooooogWoi^KV00?oO7alonKVi_oVi^H00ooVi^H00oml
O7co/[:bonKViP1honKViP03oooooooVi^Koi^KV00?oi^KV0_ooo`1ionKV
iP03o`00oooVi^Koi^KV00?oi^KV0_l00?mionKViP03oooo0?oVi^Koi^KV
00?oi^KV00?oool0o`00oooVi^H0N?oVi^H1ool000000_oooomionk^kP03
ogalO?o^k^kok^k^00?ok^k^00?oO7alok:b/_o^k^h0N?o^k^h00ooooooo
k^k^onk^kP03onk^kP;oool0NOo^k^h00ol00?ook^k^onk^kP03onk^kP;o
003oNOo^k^h00oooo`3ok^k^onk^kP03onk^kP03oooo0?l00?ook^k^07So
k^k^0Ooo000007_ooooo00?oO7alooooooooool00oooool00omlO7co/[:b
ooooo`1nooooo`;oool0NOooool00ol00?ooooooooooo`03ooooo`;o003o
NOooool00oooo`3oooooooooo`03ooooo`03oooo0?l00?oooooo07Sooooo
0Ooo000000;oooooNOo^k^h00omlO7cok^k^onk^kP03onk^kP03ogalO?nb
/[;ok^k^07Sok^k^00?oooooonk^k_o^k^h00oo^k^h2oooo07Wok^k^00?o
003oonk^k_o^k^h00oo^k^h2o`00ogWok^k^00?oool0onk^k_o^k^h00oo^
k^h00oooo`3o003oonk^kP1honk^kP7oo`000002ooooogWoi^KV00?oO7al
onKVi_oVi^H00ooVi^H00omlO7co/[:bonKViP1honKViP03oooooooVi^Ko
i^KV00?oi^KV0_ooo`1ionKViP03o`00oooVi^Koi^KV00?oi^KV0_l00?mi
onKViP03oooo0?oVi^Koi^KV00?oi^KV00?oool0o`00oooVi^H0N?oVi^H1
ool000000_oooomionk^kP03ogalO?o^k^kok^k^00?ok^k^00?oO7alok:b
/_o^k^h0N?o^k^h00oooooook^k^onk^kP03onk^kP;oool0NOo^k^h00ol0
0?ook^k^onk^kP03onk^kP;o003oNOo^k^h00oooo`3ok^k^onk^kP03onk^
kP03oooo0?l00?ook^k^07Sok^k^0Ooo000007_ooooo00?oO7aloooooooo
ool00oooool00omlO7co/[:booooo`1nooooo`;oool0NOooool00ol00?oo
ooooooooo`03ooooo`;o003oNOooool00oooo`3oooooooooo`03ooooo`03
oooo0?l00?oooooo07Sooooo0Ooo000000;oooooNOo^k^h00omlO7cok^k^
onk^kP03onk^kP03ogalO?nb/[;ok^k^07Sok^k^00?oooooonk^k_o^k^h0
0oo^k^h2oooo07Wok^k^00?o003oonk^k_o^k^h00oo^k^h2o`00ogWok^k^
00?oool0onk^k_o^k^h00oo^k^h00oooo`3o003oonk^kP1honk^kP7oo`00
0002ooooogWoi^KV00?oO7alonKVi_oVi^H00ooVi^H00omlO7co/[:bonKV
iP1honKViP03oooooooVi^Koi^KV00?oi^KV0_ooo`1ionKViP03o`00oooV
i^Koi^KV00?oi^KV0_l00?mionKViP03oooo0?oVi^Koi^KV00?oi^KV00?o
ool0o`00oooVi^H0N?oVi^H1ool000000_oooomionk^kP03ogalO?o^k^ko
k^k^00?ok^k^00?oO7alok:b/_o^k^h0N?o^k^h00oooooook^k^onk^kP03
onk^kP;oool0NOo^k^h00ol00?ook^k^onk^kP03onk^kP;o003oNOo^k^h0
0oooo`3ok^k^onk^kP03onk^kP03oooo0?l00?ook^k^07Sok^k^0Ooo0000
07_ooooo00?oO7alooooooooool00oooool00omlO7co/[:booooo`1noooo
o`;oool0NOooool00ol00?ooooooooooo`03ooooo`;o003oNOooool00ooo
o`3oooooooooo`03ooooo`03oooo0?l00?oooooo07Sooooo0Ooo000000;o
ooooNOo^k^h00omlO7cok^k^onk^kP03onk^kP03ogalO?nb/[;ok^k^07So
k^k^00?oooooonk^k_o^k^h00oo^k^h2oooo07Wok^k^00?o003oonk^k_o^
k^h00oo^k^h2o`00ogWok^k^00?oool0onk^k_o^k^h00oo^k^h00oooo`3o
003oonk^kP1honk^kP7oo`000002ooooogWoi^KV00?oO7alonKVi_oVi^H0
0ooVi^H00omlO7co/[:bonKViP1honKViP03oooooooVi^Koi^KV00?oi^KV
0_ooo`1ionKViP03o`00oooVi^Koi^KV00?oi^KV0_l00?mionKViP03oooo
0?oVi^Koi^KV00?oi^KV00?oool0o`00oooVi^H0N?oVi^H1ool000000_oo
oomionk^kP03ogalO?o^k^kok^k^00?ok^k^00?oO7alok:b/_o^k^h0N?o^
k^h00oooooook^k^onk^kP03onk^kP;oool0NOo^k^h00ol00?ook^k^onk^
kP03onk^kP;o003oNOo^k^h00oooo`3ok^k^onk^kP03onk^kP03oooo0?l0
0?ook^k^07Sok^k^0Ooo000007_ooooo00?oO7alooooooooool00oooool0
0omlO7co/[:booooo`1nooooo`;oool0NOooool00ol00?ooooooooooo`03
ooooo`;o003oNOooool00oooo`3oooooooooo`03ooooo`03oooo0?l00?oo
oooo07Sooooo0Ooo000000;oooooNOo^k^h00omlO7cok^k^onk^kP03onk^
kP03ogalO?nb/[;ok^k^07Sok^k^00?oooooonk^k_o^k^h00oo^k^h2oooo
07Wok^k^00?o003oonk^k_o^k^h00oo^k^h2o`00ogWok^k^00?oool0onk^
k_o^k^h00oo^k^h00oooo`3o003oonk^kP1honk^kP7oo`000002ooooogWo
i^KV00?oO7alonKVi_oVi^H00ooVi^H00omlO7co/[:bonKViP1honKViP03
oooooooVi^Koi^KV00?oi^KV0_ooo`1ionKViP03o`00oooVi^Koi^KV00?o
i^KV0_l00?mionKViP03oooo0?oVi^Koi^KV00?oi^KV00?oool0o`00oooV
i^H0N?oVi^H1ool000000_oooomionk^kP03ogalO?o^k^kok^k^00?ok^k^
00?oO7alok:b/_o^k^h0N?o^k^h00oooooook^k^onk^kP03onk^kP;oool0
NOo^k^h00ol00?ook^k^onk^kP03onk^kP;o003oNOo^k^h00oooo`3ok^k^
onk^kP03onk^kP03oooo0?l00?ook^k^07Sok^k^0Ooo000007_ooooo00?o
O7alooooooooool00oooool00omlO7co/[:booooo`1nooooo`;oool0NOoo
ool00ol00?ooooooooooo`03ooooo`;o003oNOooool00oooo`3ooooooooo
o`03ooooo`03oooo0?l00?oooooo07Sooooo0Ooo000000;oooooNOo^k^h0
0omlO7cok^k^onk^kP03onk^kP03ogalO?nb/[;ok^k^07Sok^k^00?ooooo
onk^k_o^k^h00oo^k^h2oooo07Wok^k^00?o003oonk^k_o^k^h00oo^k^h2
o`00ogWok^k^00?oool0onk^k_o^k^h00oo^k^h00oooo`3o003oonk^kP1h
onk^kP7oo`000002ooooogWoi^KV00?oO7alonKVi_oVi^H00ooVi^H00oml
O7co/[:bonKViP1honKViP03oooooooVi^Koi^KV00?oi^KV0_ooo`1ionKV
iP03o`00oooVi^Koi^KV00?oi^KV0_l00?mionKViP03oooo0?oVi^Koi^KV
00?oi^KV00?oool0o`00oooVi^H0N?oVi^H1ool000000_oooomionk^kP03
ogalO?o^k^kok^k^00?ok^k^00?oO7alok:b/_o^k^h0N?o^k^h00ooooooo
k^k^onk^kP03onk^kP;oool0NOo^k^h00ol00?ook^k^onk^kP03onk^kP;o
003oNOo^k^h00oooo`3ok^k^onk^kP03onk^kP03oooo0?l00?ook^k^07So
k^k^0Ooo000007_ooooo00?oO7alooooooooool00oooool00omlO7co/[:b
ooooo`1nooooo`;oool0NOooool00ol00?ooooooooooo`03ooooo`;o003o
NOooool00oooo`3oooooooooo`03ooooo`03oooo0?l00?oooooo07Sooooo
0Ooo000000;oooooNOo^k^h00omlO7cok^k^onk^kP03onk^kP03ogalO?nb
/[;ok^k^07Sok^k^00?oooooonk^k_o^k^h00oo^k^h2oooo07Wok^k^00?o
003oonk^k_o^k^h00oo^k^h2o`00ogWok^k^00?oool0onk^k_o^k^h00oo^
k^h00oooo`3o003oonk^kP1honk^kP7oo`000002ooooogWoi^KV00?oO7al
onKVi_oVi^H00ooVi^H00omlO7co/[:bonKViP1honKViP03oooooooVi^Ko
i^KV00?oi^KV0_ooo`1ionKViP03o`00oooVi^Koi^KV00?oi^KV0_l00?mi
onKViP03oooo0?oVi^Koi^KV00?oi^KV00?oool0o`00oooVi^H0N?oVi^H1
ool000000_oooomionk^kP03ogalO?o^k^kok^k^00?ok^k^00?oO7alok:b
/_o^k^h0N?o^k^h00oooooook^k^onk^kP03onk^kP;oool0NOo^k^h00ol0
0?ook^k^onk^kP03onk^kP;o003oNOo^k^h00oooo`3ok^k^onk^kP03onk^
kP03oooo0?l00?ook^k^07Sok^k^0Ooo000007_ooooo00?oO7aloooooooo
ool00oooool00omlO7co/[:booooo`1nooooo`;oool0NOooool00ol00?oo
ooooooooo`03ooooo`;o003oNOooool00oooo`3oooooooooo`03ooooo`03
oooo0?l00?oooooo07Sooooo0Ooo000000;oooooNOo^k^h00omlO7cok^k^
onk^kP03onk^kP03ogalO?nb/[;ok^k^07Sok^k^00?oooooonk^k_o^k^h0
0oo^k^h2oooo07Wok^k^00?o003oonk^k_o^k^h00oo^k^h2o`00ogWok^k^
00?oool0onk^k_o^k^h00oo^k^h00oooo`3o003oonk^kP1honk^kP7oo`00
0002ooooogWoi^KV00?oO7alonKVi_oVi^H00ooVi^H00omlO7co/[:bonKV
iP1honKViP03oooooooVi^Koi^KV00?oi^KV0_ooo`1ionKViP03o`00oooV
i^Koi^KV00?oi^KV0_l00?mionKViP03oooo0?oVi^Koi^KV00?oi^KV00?o
ool0o`00oooVi^H0N?oVi^H1ool000000_oooomionk^kP03ogalO?o^k^ko
k^k^00?ok^k^00?oO7alok:b/_o^k^h0N?o^k^h00oooooook^k^onk^kP03
onk^kP;oool0NOo^k^h00ol00?ook^k^onk^kP03onk^kP;o003oNOo^k^h0
0oooo`3ok^k^onk^kP03onk^kP03oooo0?l00?ook^k^07Sok^k^0Ooo0000
07_ooooo00?oO7alooooooooool00oooool00omlO7co/[:booooo`1noooo
o`;oool0NOooool00ol00?ooooooooooo`03ooooo`;o003oNOooool00ooo
o`3oooooooooo`03ooooo`03oooo0?l00?oooooo07Sooooo0Ooo000000;o
ooooNOo^k^h00omlO7cok^k^onk^kP03onk^kP03ogalO?nb/[;ok^k^07So
k^k^00?oooooonk^k_o^k^h00oo^k^h2oooo07Wok^k^00?o003oonk^k_o^
k^h00oo^k^h2o`00ogWok^k^00?oool0onk^k_o^k^h00oo^k^h00oooo`3o
003oonk^kP1honk^kP7oo`000002ooooogWoi^KV00?oO7alonKVi_oVi^H0
0ooVi^H00omlO7co/[:bonKViP1honKViP03oooooooVi^Koi^KV00?oi^KV
0_ooo`1ionKViP03o`00oooVi^Koi^KV00?oi^KV0_l00?mionKViP03oooo
0?oVi^Koi^KV00?oi^KV00?oool0o`00oooVi^H0N?oVi^H1ool000000_oo
oomionk^kP03ogalO?o^k^kok^k^00?ok^k^00?oO7alok:b/_o^k^h0N?o^
k^h00oooooook^k^onk^kP03onk^kP;oool0NOo^k^h00ol00?ook^k^onk^
kP03onk^kP;o003oNOo^k^h00oooo`3ok^k^onk^kP03onk^kP03oooo0?l0
0?ook^k^07Sok^k^0Ooo000007_ooooo00?oO7alooooooooool00oooool0
0omlO7co/[:booooo`1nooooo`;oool0NOooool00ol00?ooooooooooo`03
ooooo`;o003oNOooool00oooo`3oooooooooo`03ooooo`03oooo0?l00?oo
oooo07Sooooo0Ooo000000;oooooNOo^k^h00omlO7cok^k^onk^kP03onk^
kP03ogalO?nb/[;ok^k^07Sok^k^00?oooooonk^k_o^k^h00oo^k^h2oooo
07Wok^k^00?o003oonk^k_o^k^h00oo^k^h2o`00ogWok^k^00?oool0onk^
k_o^k^h00oo^k^h00oooo`3o003oonk^kP1honk^kP7oo`000002ooooogWo
i^KV00?oO7alonKVi_oVi^H00ooVi^H00omlO7co/[:bonKViP1honKViP03
oooooooVi^Koi^KV00?oi^KV0_ooo`1ionKViP03o`00oooVi^Koi^KV00?o
i^KV0_l00?mionKViP03oooo0?oVi^Koi^KV00?oi^KV00?oool0o`00oooV
i^H0N?oVi^H1ool000000_oooomionk^kP03ogalO?o^k^kok^k^00?ok^k^
00?oO7alok:b/_o^k^h0N?o^k^h00oooooook^k^onk^kP03onk^kP;oool0
NOo^k^h00ol00?ook^k^onk^kP03onk^kP;o003oNOo^k^h00oooo`3ok^k^
onk^kP03onk^kP03oooo0?l00?ook^k^07Sok^k^0Ooo000007_ooooo00?o
O7alooooooooool00oooool00omlO7co/[:booooo`1nooooo`;oool0NOoo
ool00ol00?ooooooooooo`03ooooo`;o003oNOooool00oooo`3ooooooooo
o`03ooooo`03oooo0?l00?oooooo07Sooooo0Ooo000000;oooooNOo^k^h0
0omlO7cok^k^onk^kP03onk^kP03ogalO?nb/[;ok^k^07Sok^k^00?ooooo
onk^k_o^k^h00oo^k^h2oooo07Wok^k^00?o003oonk^k_o^k^h00oo^k^h2
o`00ogWok^k^00?oool0onk^k_o^k^h00oo^k^h00oooo`3o003oonk^kP1h
onk^kP7oo`000002ooooogWoi^KV00?oO7alonKVi_oVi^H00ooVi^H00oml
O7co/[:bonKViP1honKViP03oooooooVi^Koi^KV00?oi^KV0_ooo`1ionKV
iP03o`00oooVi^Koi^KV00?oi^KV0_l00?mionKViP03oooo0?oVi^Koi^KV
00?oi^KV00?oool0o`00oooVi^H0N?oVi^H1ool000000_oooomionk^kP03
ogalO?o^k^kok^k^00?ok^k^00?oO7alok:b/_o^k^h0N?o^k^h00ooooooo
k^k^onk^kP03onk^kP;oool0NOo^k^h00ol00?ook^k^onk^kP03onk^kP;o
003oNOo^k^h00oooo`3ok^k^onk^kP03onk^kP03oooo0?l00?ook^k^07So
k^k^0Ooo000007_ooooo00?oO7alooooooooool00oooool00omlO7co/[:b
ooooo`1nooooo`;oool0NOooool00ol00?ooooooooooo`03ooooo`;o003o
NOooool00oooo`3oooooooooo`03ooooo`03oooo0?l00?oooooo07Sooooo
0Ooo000000;oooooNOo^k^h00omlO7cok^k^onk^kP03onk^kP03ogalO?nb
/[;ok^k^07Sok^k^00?oooooonk^k_o^k^h00oo^k^h2oooo07Wok^k^00?o
003oonk^k_o^k^h00oo^k^h2o`00ogWok^k^00?oool0onk^k_o^k^h00oo^
k^h00oooo`3o003oonk^kP1honk^kP7oo`000002ooooogWoi^KV00?oO7al
onKVi_oVi^H00ooVi^H00omlO7co/[:bonKViP1honKViP03oooooooVi^Ko
i^KV00?oi^KV0_ooo`1ionKViP03o`00oooVi^Koi^KV00?oi^KV0_l00?mi
onKViP03oooo0?oVi^Koi^KV00?oi^KV00?oool0o`00oooVi^H0N?oVi^H1
ool000000_oooomionk^kP03ogalO?o^k^kok^k^00?ok^k^00?oO7alok:b
/_o^k^h0N?o^k^h00oooooook^k^onk^kP03onk^kP;oool0NOo^k^h00ol0
0?ook^k^onk^kP03onk^kP;o003oNOo^k^h00oooo`3ok^k^onk^kP03onk^
kP03oooo0?l00?ook^k^07Sok^k^0Ooo000007_ooooo00?oO7aloooooooo
ool00oooool00omlO7co/[:booooo`1nooooo`;oool0NOooool00ol00?oo
ooooooooo`03ooooo`;o003oNOooool00oooo`3oooooooooo`03ooooo`03
oooo0?l00?oooooo07Sooooo0Ooo000000;oooooNOo^k^h00omlO7cok^k^
onk^kP03onk^kP03ogalO?nb/[;ok^k^07Sok^k^00?oooooonk^k_o^k^h0
0oo^k^h2oooo07Wok^k^00?o003oonk^k_o^k^h00oo^k^h2o`00ogWok^k^
00?oool0onk^k_o^k^h00oo^k^h00oooo`3o003oonk^kP1honk^kP7oo`00
0002ooooogWoi^KV00?oO7alonKVi_oVi^H00ooVi^H00omlO7co/[:bonKV
iP1honKViP03oooooooVi^Koi^KV00?oi^KV0_ooo`1ionKViP03o`00oooV
i^Koi^KV00?oi^KV0_l00?mionKViP03oooo0?oVi^Koi^KV00?oi^KV00?o
ool0o`00oooVi^H0N?oVi^H1ool000000_oooomionk^kP03ogalO?o^k^ko
k^k^00?ok^k^00?oO7alok:b/_o^k^h0N?o^k^h00oooooook^k^onk^kP03
onk^kP;oool0NOo^k^h00ol00?ook^k^onk^kP03onk^kP;o003oNOo^k^h0
0oooo`3ok^k^onk^kP03onk^kP03oooo0?l00?ook^k^07Sok^k^0Ooo0000
07_ooooo00?oO7alooooooooool00oooool00omlO7co/[:booooo`1noooo
o`;oool0NOooool00ol00?ooooooooooo`03ooooo`;o003oNOooool00ooo
o`3oooooooooo`03ooooo`03oooo0?l00?oooooo07Sooooo0Ooo000000;o
ooooNOo^k^h00omlO7cok^k^onk^kP03onk^kP03ogalO?nb/[;ok^k^07So
k^k^00?oooooonk^k_o^k^h00oo^k^h2oooo07Wok^k^00?o003oonk^k_o^
k^h00oo^k^h2o`00ogWok^k^00?oool0onk^k_o^k^h00oo^k^h00oooo`3o
003oonk^kP1honk^kP7oo`000002ooooogWoi^KV00?oO7alonKVi_oVi^H0
0ooVi^H00omlO7co/[:bonKViP1honKViP03oooooooVi^Koi^KV00?oi^KV
0_ooo`1ionKViP03o`00oooVi^Koi^KV00?oi^KV0_l00?mionKViP03oooo
0?oVi^Koi^KV00?oi^KV00?oool0o`00oooVi^H0N?oVi^H1ool000000_oo
oomionk^kP03ogalO?o^k^kok^k^00?ok^k^00?oO7alok:b/_o^k^h0N?o^
k^h00oooooook^k^onk^kP03onk^kP;oool0NOo^k^h00ol00?ook^k^onk^
kP03onk^kP;o003oNOo^k^h00oooo`3ok^k^onk^kP03onk^kP03oooo0?l0
0?ook^k^07Sok^k^0Ooo000007_ooooo00?oO7alooooooooool00oooool0
0omlO7co/[:booooo`1nooooo`;oool0NOooool00ol00?ooooooooooo`03
ooooo`;o003oNOooool00oooo`3oooooooooo`03ooooo`03oooo0?l00?oo
oooo07Sooooo0Ooo000000;oooooNOo^k^h00omlO7cok^k^onk^kP03onk^
kP03ogalO?nb/[;ok^k^07Sok^k^00?oooooonk^k_o^k^h00oo^k^h2oooo
07Wok^k^00?o003oonk^k_o^k^h00oo^k^h2o`00ogWok^k^00?oool0onk^
k_o^k^h00oo^k^h00oooo`3o003oonk^kP1honk^kP7oo`000002ooooogWo
i^KV00?oO7alonKVi_oVi^H00ooVi^H00omlO7co/[:bonKViP1honKViP03
oooooooVi^Koi^KV00?oi^KV0_ooo`1ionKViP03o`00oooVi^Koi^KV00?o
i^KV0_l00?mionKViP03oooo0?oVi^Koi^KV00?oi^KV00?oool0o`00oooV
i^H0N?oVi^H1ool000000_oooomionk^kP03ogalO?o^k^kok^k^00?ok^k^
00?oO7alok:b/_o^k^h0N?o^k^h00oooooook^k^onk^kP03onk^kP;oool0
NOo^k^h00ol00?ook^k^onk^kP03onk^kP;o003oNOo^k^h00oooo`3ok^k^
onk^kP03onk^kP03oooo0?l00?ook^k^07Sok^k^0Ooo000007_ooooo00?o
O7alooooooooool00oooool00omlO7co/[:booooo`1nooooo`;oool0NOoo
ool00ol00?ooooooooooo`03ooooo`;o003oNOooool00oooo`3ooooooooo
o`03ooooo`03oooo0?l00?oooooo07Sooooo0Ooo000000;oooooNOo^k^h0
0omlO7cok^k^onk^kP03onk^kP03ogalO?nb/[;ok^k^07Sok^k^00?ooooo
onk^k_o^k^h00oo^k^h2oooo07Wok^k^00?o003oonk^k_o^k^h00oo^k^h2
o`00ogWok^k^00?oool0onk^k_o^k^h00oo^k^h00oooo`3o003oonk^kP1h
onk^kP7oo`000002ooooogWoi^KV00?oO7alonKVi_oVi^H00ooVi^H00oml
O7co/[:bonKViP1honKViP03oooooooVi^Koi^KV00?oi^KV0_ooo`1ionKV
iP03o`00oooVi^Koi^KV00?oi^KV0_l00?mionKViP03oooo0?oVi^Koi^KV
00?oi^KV00?oool0o`00oooVi^H0N?oVi^H1ool000000_oooomionk^kP03
ogalO?o^k^kok^k^00?ok^k^00?oO7alok:b/_o^k^h0N?o^k^h00ooooooo
k^k^onk^kP03onk^kP;oool0NOo^k^h00ol00?ook^k^onk^kP03onk^kP;o
003oNOo^k^h00oooo`3ok^k^onk^kP03onk^kP03oooo0?l00?ook^k^07So
k^k^0Ooo000007_ooooo00?oO7alooooooooool00oooool00omlO7co/[:b
ooooo`1nooooo`;oool0NOooool00ol00?ooooooooooo`03ooooo`;o003o
NOooool00oooo`3oooooooooo`03ooooo`03oooo0?l00?oooooo07Sooooo
0Ooo000000;oooooNOo^k^h00omlO7cok^k^onk^kP03onk^kP03ogalO?nb
/[;ok^k^07Sok^k^00?oooooonk^k_o^k^h00oo^k^h2oooo07Wok^k^00?o
003oonk^k_o^k^h00oo^k^h2o`00ogWok^k^00?oool0onk^k_o^k^h00oo^
k^h00oooo`3o003oonk^kP1honk^kP7oo`000002ooooogWoi^KV00?oO7al
onKVi_oVi^H00ooVi^H00omlO7co/[:bonKViP1honKViP03oooooooVi^Ko
i^KV00?oi^KV0_ooo`1ionKViP03o`00oooVi^Koi^KV00?oi^KV0_l00?mi
onKViP03oooo0?oVi^Koi^KV00?oi^KV00?oool0o`00oooVi^H0N?oVi^H1
ool000000_oooomionk^kP03ogalO?o^k^kok^k^00?ok^k^00?oO7alok:b
/_o^k^h0N?o^k^h00oooooook^k^onk^kP03onk^kP;oool0NOo^k^h00ol0
0?ook^k^onk^kP03onk^kP;o003oNOo^k^h00oooo`3ok^k^onk^kP03onk^
kP03oooo0?l00?ook^k^07Sok^k^0Ooo000007_ooooo00?oO7aloooooooo
ool00oooool00omlO7co/[:booooo`1nooooo`;oool0NOooool00ol00?oo
ooooooooo`03ooooo`;o003oNOooool00oooo`3oooooooooo`03ooooo`03
oooo0?l00?oooooo07Sooooo0Ooo000000;oooooNOo^k^h00omlO7cok^k^
onk^kP03onk^kP03ogalO?nb/[;ok^k^07Sok^k^00?oooooonk^k_o^k^h0
0oo^k^h2oooo07Wok^k^00?o003oonk^k_o^k^h00oo^k^h2o`00ogWok^k^
00?oool0onk^k_o^k^h00oo^k^h00oooo`3o003oonk^kP1honk^kP7oo`00
0003ooooogSoi^KV00?oO7alonKVi_oVi^H00ooVi^H00omlO7co/[:bok:b
/P1honKViP03oooooooVi^Koi^KV00?oi^KV0oooo`1honKViP03o`00oooV
i^Koi^KV00?oi^KV0ol00?mhonKViP03oooo0?oVi^Koi^KV00?oi^KV00?o
ool0o`00ool00?l0N?oVi^H1ool00000Noooool6onk^kP;oO7alNOnb/[86
onk^kW_oool01_o^k^iko`00o`Kok^k^0_ooo`1io`00o`7ok^k^0021oooo
og_oO7al00?o/[:booooooooool00ooooomloooo00GoooooO?l00?l5oooo
og_oool00Ol00?l00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^00000oooooooO7alogalO01iogalO0Goi^KV00?o/[:boooooooo
ool0NOooool5onKViP03oooo0?l00?oo003o07Wo003o1OoVi^H00ol00?oo
ool0oooo001ioooo00Goi^KV00?oool0ool00?oo0000NOoo000000;ooooo
NOnb/[800omlO7cok^k^onk^kP03onk^kP03ok:b/_mlO7cooooo07Wooooo
1Oo^k^h2oooo07[o003o1Oo^k^h2o`00og[oool01Oo^k^h00oooo`3o003o
o`3o001ho`3o007oo`00001jooooo`03ok:b/_mlO7cooooo00Cooooo00?o
/[:bogalO?ooool0O_ooool2oooo07Sooooo0_l00?l5ooooo`;o003oN?oo
ool2oooo00Gooooo00?oool0o`00ooooool0Moooool1o`3o007oo`000002
ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1g
onk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2
oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`000002oooo
ogSoi^KV00?o/[:bogalO?oVi^H01?oVi^H00onb/[;oO7alonKViP1gonKV
iP;ooooo1OoVi^H2oooo07Soi^KV0_l00?l5onKViP;o003oN?oVi^H2oooo
00Goi^KV00?oool0o`00oooVi^H0MooVi^H1o`3o007oo`000002ooooogSo
k^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;o
oooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Go
k^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`00001jooooo`03ok:b
/_mlO7cooooo00Cooooo00?o/[:bogalO?ooool0O_ooool2oooo07Sooooo
0_l00?l5ooooo`;o003oN?ooool2oooo00Gooooo00?oool0o`00ooooool0
Moooool1o`3o007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^
k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l0
0?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^
k^h1o`3o007oo`000002ooooogSoi^KV00?o/[:bogalO?oVi^H01?oVi^H0
0onb/[;oO7alonKViP1gonKViP;ooooo1OoVi^H2oooo07Soi^KV0_l00?l5
onKViP;o003oN?oVi^H2oooo00Goi^KV00?oool0o`00oooVi^H0MooVi^H1
o`3o007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb
/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^
kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o
007oo`00001jooooo`03ok:b/_mlO7cooooo00Cooooo00?o/[:bogalO?oo
ool0O_ooool2oooo07Sooooo0_l00?l5ooooo`;o003oN?ooool2oooo00Go
oooo00?oool0o`00ooooool0Moooool1o`3o007oo`000002ooooogSok^k^
00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo
1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^
00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`000002ooooogSoi^KV00?o
/[:bogalO?oVi^H01?oVi^H00onb/[;oO7alonKViP1gonKViP;ooooo1OoV
i^H2oooo07Soi^KV0_l00?l5onKViP;o003oN?oVi^H2oooo00Goi^KV00?o
ool0o`00oooVi^H0MooVi^H1o`3o007oo`000002ooooogSok^k^00?o/[:b
ogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2
oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0
o`00ooo^k^h0Moo^k^h1o`3o007oo`00001jooooo`03ok:b/_mlO7cooooo
00Cooooo00?o/[:bogalO?ooool0O_ooool2oooo07Sooooo0_l00?l5oooo
o`;o003oN?ooool2oooo00Gooooo00?oool0o`00ooooool0Moooool1o`3o
007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;o
O7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o
003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007o
o`000002ooooogSoi^KV00?o/[:bogalO?oVi^H01?oVi^H00onb/[;oO7al
onKViP1gonKViP;ooooo1OoVi^H2oooo07Soi^KV0_l00?l5onKViP;o003o
N?oVi^H2oooo00Goi^KV00?oool0o`00oooVi^H0MooVi^H1o`3o007oo`00
0002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^
kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^
k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`00001j
ooooo`03ok:b/_mlO7cooooo00Cooooo00?o/[:bogalO?ooool0O_ooool2
oooo07Sooooo0_l00?l5ooooo`;o003oN?ooool2oooo00Gooooo00?oool0
o`00ooooool0Moooool1o`3o007oo`000002ooooogSok^k^00?o/[:bogal
O?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo
07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00
ooo^k^h0Moo^k^h1o`3o007oo`000002ooooogSoi^KV00?o/[:bogalO?oV
i^H01?oVi^H00onb/[;oO7alonKViP1gonKViP;ooooo1OoVi^H2oooo07So
i^KV0_l00?l5onKViP;o003oN?oVi^H2oooo00Goi^KV00?oool0o`00oooV
i^H0MooVi^H1o`3o007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h0
1?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^
0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0
Moo^k^h1o`3o007oo`00001jooooo`03ok:b/_mlO7cooooo00Cooooo00?o
/[:bogalO?ooool0O_ooool2oooo07Sooooo0_l00?l5ooooo`;o003oN?oo
ool2oooo00Gooooo00?oool0o`00ooooool0Moooool1o`3o007oo`000002
ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1g
onk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2
oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`000002oooo
ogSoi^KV00?o/[:bogalO?oVi^H01?oVi^H00onb/[;oO7alonKViP1gonKV
iP;ooooo1OoVi^H2oooo07Soi^KV0_l00?l5onKViP;o003oN?oVi^H2oooo
00Goi^KV00?oool0o`00oooVi^H0MooVi^H1o`3o007oo`000002ooooogSo
k^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;o
oooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Go
k^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`00001jooooo`03ok:b
/_mlO7cooooo00Cooooo00?o/[:bogalO?ooool0O_ooool2oooo07Sooooo
0_l00?l5ooooo`;o003oN?ooool2oooo00Gooooo00?oool0o`00ooooool0
Moooool1o`3o007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^
k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l0
0?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^
k^h1o`3o007oo`000002ooooogSoi^KV00?o/[:bogalO?oVi^H01?oVi^H0
0onb/[;oO7alonKViP1gonKViP;ooooo1OoVi^H2oooo07Soi^KV0_l00?l5
onKViP;o003oN?oVi^H2oooo00Goi^KV00?oool0o`00oooVi^H0MooVi^H1
o`3o007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb
/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^
kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o
007oo`00001jooooo`03ok:b/_mlO7cooooo00Cooooo00?o/[:bogalO?oo
ool0O_ooool2oooo07Sooooo0_l00?l5ooooo`;o003oN?ooool2oooo00Go
oooo00?oool0o`00ooooool0Moooool1o`3o007oo`000002ooooogSok^k^
00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo
1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^
00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`000002ooooogSoi^KV00?o
/[:bogalO?oVi^H01?oVi^H00onb/[;oO7alonKViP1gonKViP;ooooo1OoV
i^H2oooo07Soi^KV0_l00?l5onKViP;o003oN?oVi^H2oooo00Goi^KV00?o
ool0o`00oooVi^H0MooVi^H1o`3o007oo`000002ooooogSok^k^00?o/[:b
ogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2
oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0
o`00ooo^k^h0Moo^k^h1o`3o007oo`00001jooooo`03ok:b/_mlO7cooooo
00Cooooo00?o/[:bogalO?ooool0O_ooool2oooo07Sooooo0_l00?l5oooo
o`;o003oN?ooool2oooo00Gooooo00?oool0o`00ooooool0Moooool1o`3o
007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;o
O7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o
003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007o
o`000002ooooogSoi^KV00?o/[:bogalO?oVi^H01?oVi^H00onb/[;oO7al
onKViP1gonKViP;ooooo1OoVi^H2oooo07Soi^KV0_l00?l5onKViP;o003o
N?oVi^H2oooo00Goi^KV00?oool0o`00oooVi^H0MooVi^H1o`3o007oo`00
0002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^
kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^
k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`00001j
ooooo`03ok:b/_mlO7cooooo00Cooooo00?o/[:bogalO?ooool0O_ooool2
oooo07Sooooo0_l00?l5ooooo`;o003oN?ooool2oooo00Gooooo00?oool0
o`00ooooool0Moooool1o`3o007oo`000002ooooogSok^k^00?o/[:bogal
O?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo
07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00
ooo^k^h0Moo^k^h1o`3o007oo`000002ooooogSoi^KV00?o/[:bogalO?oV
i^H01?oVi^H00onb/[;oO7alonKViP1gonKViP;ooooo1OoVi^H2oooo07So
i^KV0_l00?l5onKViP;o003oN?oVi^H2oooo00Goi^KV00?oool0o`00oooV
i^H0MooVi^H1o`3o007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h0
1?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^
0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0
Moo^k^h1o`3o007oo`00001jooooo`03ok:b/_mlO7cooooo00Cooooo00?o
/[:bogalO?ooool0O_ooool2oooo07Sooooo0_l00?l5ooooo`;o003oN?oo
ool2oooo00Gooooo00?oool0o`00ooooool0Moooool1o`3o007oo`000002
ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1g
onk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2
oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`000002oooo
ogSoi^KV00?o/[:bogalO?oVi^H01?oVi^H00onb/[;oO7alonKViP1gonKV
iP;ooooo1OoVi^H2oooo07Soi^KV0_l00?l5onKViP;o003oN?oVi^H2oooo
00Goi^KV00?oool0o`00oooVi^H0MooVi^H1o`3o007oo`000002ooooogSo
k^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;o
oooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Go
k^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`00001jooooo`03ok:b
/_mlO7cooooo00Cooooo00?o/[:bogalO?ooool0O_ooool2oooo07Sooooo
0_l00?l5ooooo`;o003oN?ooool2oooo00Gooooo00?oool0o`00ooooool0
Moooool1o`3o007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^
k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l0
0?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^
k^h1o`3o007oo`000002ooooogSoi^KV00?o/[:bogalO?oVi^H01?oVi^H0
0onb/[;oO7alonKViP1gonKViP;ooooo1OoVi^H2oooo07Soi^KV0_l00?l5
onKViP;o003oN?oVi^H2oooo00Goi^KV00?oool0o`00oooVi^H0MooVi^H1
o`3o007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb
/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^
kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o
007oo`00001jooooo`03ok:b/_mlO7cooooo00Cooooo00?o/[:bogalO?oo
ool0O_ooool2oooo07Sooooo0_l00?l5ooooo`;o003oN?ooool2oooo00Go
oooo00?oool0o`00ooooool0Moooool1o`3o007oo`000002ooooogSok^k^
00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo
1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^
00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`000002ooooogSoi^KV00?o
/[:bogalO?oVi^H01?oVi^H00onb/[;oO7alonKViP1gonKViP;ooooo1OoV
i^H2oooo07Soi^KV0_l00?l5onKViP;o003oN?oVi^H2oooo00Goi^KV00?o
ool0o`00oooVi^H0MooVi^H1o`3o007oo`000002ooooogSok^k^00?o/[:b
ogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2
oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0
o`00ooo^k^h0Moo^k^h1o`3o007oo`00001jooooo`03ok:b/_mlO7cooooo
00Cooooo00?o/[:bogalO?ooool0O_ooool2oooo07Sooooo0_l00?l5oooo
o`;o003oN?ooool2oooo00Gooooo00?oool0o`00ooooool0Moooool1o`3o
007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;o
O7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o
003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007o
o`000002ooooogSoi^KV00?o/[:bogalO?oVi^H01?oVi^H00onb/[;oO7al
onKViP1gonKViP;ooooo1OoVi^H2oooo07Soi^KV0_l00?l5onKViP;o003o
N?oVi^H2oooo00Goi^KV00?oool0o`00oooVi^H0MooVi^H1o`3o007oo`00
0002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^
kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^
k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`00001j
ooooo`03ok:b/_mlO7cooooo00Cooooo00?o/[:bogalO?ooool0O_ooool2
oooo07Sooooo0_l00?l5ooooo`;o003oN?ooool2oooo00Gooooo00?oool0
o`00ooooool0Moooool1o`3o007oo`000002ooooogSok^k^00?o/[:bogal
O?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo
07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00
ooo^k^h0Moo^k^h1o`3o007oo`000002ooooogSoi^KV00?o/[:bogalO?oV
i^H01?oVi^H00onb/[;oO7alonKViP1gonKViP;ooooo1OoVi^H2oooo07So
i^KV0_l00?l5onKViP;o003oN?oVi^H2oooo00Goi^KV00?oool0o`00oooV
i^H0MooVi^H1o`3o007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h0
1?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^
0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0
Moo^k^h1o`3o007oo`00001jooooo`03ok:b/_mlO7cooooo00Cooooo00?o
/[:bogalO?ooool0O_ooool2oooo07Sooooo0_l00?l5ooooo`;o003oN?oo
ool2oooo00Gooooo00?oool0o`00ooooool0Moooool1o`3o007oo`000002
ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1g
onk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2
oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`000002oooo
ogSoi^KV00?o/[:bogalO?oVi^H01?oVi^H00onb/[;oO7alonKViP1gonKV
iP;ooooo1OoVi^H2oooo07Soi^KV0_l00?l5onKViP;o003oN?oVi^H2oooo
00Goi^KV00?oool0o`00oooVi^H0MooVi^H1o`3o007oo`000002ooooogSo
k^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;o
oooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Go
k^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`00001jooooo`03ok:b
/_mlO7cooooo00Cooooo00?o/[:bogalO?ooool0O_ooool2oooo07Sooooo
0_l00?l5ooooo`;o003oN?ooool2oooo00Gooooo00?oool0o`00ooooool0
Moooool1o`3o007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^
k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l0
0?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^
k^h1o`3o007oo`000002ooooogSoi^KV00?o/[:bogalO?oVi^H01?oVi^H0
0onb/[;oO7alonKViP1gonKViP;ooooo1OoVi^H2oooo07Soi^KV0_l00?l5
onKViP;o003oN?oVi^H2oooo00Goi^KV00?oool0o`00oooVi^H0MooVi^H1
o`3o007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb
/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^
kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o
007oo`00001jooooo`03ok:b/_mlO7cooooo00Cooooo00?o/[:bogalO?oo
ool0O_ooool2oooo07Sooooo0_l00?l5ooooo`;o003oN?ooool2oooo00Go
oooo00?oool0o`00ooooool0Moooool1o`3o007oo`000002ooooogSok^k^
00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo
1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^
00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`000002ooooogSoi^KV00?o
/[:bogalO?oVi^H01?oVi^H00onb/[;oO7alonKViP1gonKViP;ooooo1OoV
i^H2oooo07Soi^KV0_l00?l5onKViP;o003oN?oVi^H2oooo00Goi^KV00?o
ool0o`00oooVi^H0MooVi^H1o`3o007oo`000002ooooogSok^k^00?o/[:b
ogalO?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2
oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0
o`00ooo^k^h0Moo^k^h1o`3o007oo`00001jooooo`03ok:b/_mlO7cooooo
00Cooooo00?o/[:bogalO?ooool0O_ooool2oooo07Sooooo0_l00?l5oooo
o`;o003oN?ooool2oooo00Gooooo00?oool0o`00ooooool0Moooool1o`3o
007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;o
O7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o
003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007o
o`000002ooooogSoi^KV00?o/[:bogalO?oVi^H01?oVi^H00onb/[;oO7al
onKViP1gonKViP;ooooo1OoVi^H2oooo07Soi^KV0_l00?l5onKViP;o003o
N?oVi^H2oooo00Goi^KV00?oool0o`00oooVi^H0MooVi^H1o`3o007oo`00
0002ooooogSok^k^00?o/[:bogalO?o^k^h01?o^k^h00onb/[;oO7alonk^
kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^0_l00?l5onk^kP;o003oN?o^
k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0Moo^k^h1o`3o007oo`00001j
ooooo`03ok:b/_mlO7cooooo00Cooooo00?o/[:bogalO?ooool0O_ooool2
oooo07Sooooo0_l00?l5ooooo`;o003oN?ooool2oooo00Gooooo00?oool0
o`00ooooool0Moooool1o`3o007oo`000002ooooogSok^k^00?o/[:bogal
O?o^k^h01?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo
07Sok^k^0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00
ooo^k^h0Moo^k^h1o`3o007oo`000002ooooogSoi^KV00?o/[:bogalO?oV
i^H01?oVi^H00onb/[;oO7alonKViP1gonKViP;ooooo1OoVi^H2oooo07So
i^KV0_l00?l5onKViP;o003oN?oVi^H2oooo00Goi^KV00?oool0o`00oooV
i^H0MooVi^H1o`3o007oo`000002ooooogSok^k^00?o/[:bogalO?o^k^h0
1?o^k^h00onb/[;oO7alonk^kP1gonk^kP;ooooo1Oo^k^h2oooo07Sok^k^
0_l00?l5onk^kP;o003oN?o^k^h2oooo00Gok^k^00?oool0o`00ooo^k^h0
Moo^k^h1o`3o007oo`00001kooooo`03ogalO?oooooooooo00?ooooo00?o
/[:bogalO?mlO7`0N?mlO7`6ooooog_oool000?o003oooooooooool00ooo
oomko`00o`03oooo0?oooooooooo00?ooooo00?oool0o`00ool00?l0N?l0
0?l1ool00000O?ooool5onk^kWco/[:b1Oo^k^iloooo00Gok^k^O?l00?l5
onk^kWcoool0003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00POo^k^ilok:b/PGok^k^O?ooool5onk^kWco003o1Oo^k^iloooo
0000o?ooool00onb/[;oooooooooo`03ooooog_o/[:b1_oooomkoooo0003
o`00oooooooooooo00?oooooNol00?l1oooo0000POo^k^h00ooooooo/[:b
onk^kP1gonk^kP03oooooonb/[;ok^k^00Cok^k^00?o/[:booooooo^k^h0
Moo^k^h00onb/[;oooooonk^kP04onk^kP03oooo0?l00?ook^k^07Ook^k^
00?oool0o`00ooo^k^h01?o^k^h00ol00?ooool0onk^kP1gonk^kP7o003o
0Oooo`00087oi^KV00?ooooook:b/_oVi^H0MooVi^H00ooooooo/[:bonKV
iP04onKViP03ok:b/_ooooooi^KV07Ooi^KV00?o/[:boooooooVi^H01?oV
i^H00oooo`3o003oonKViP1gonKViP03oooo0?l00?ooi^KV00Coi^KV00?o
003ooooo0?oVi^H0MooVi^H1o`00o`7oool00021onk^kP03oooooonb/[;o
k^k^07Ook^k^00?ooooook:b/_o^k^h01?o^k^h00onb/[;oooooonk^kP1g
onk^kP03ok:b/_ooooook^k^00Cok^k^00?oool0o`00ooo^k^h0Moo^k^h0
0oooo`3o003oonk^kP04onk^kP03o`00ooooo`3ok^k^07Ook^k^0Ol00?l1
oooo0000P_ooool00onb/[;oooooooooo`1gooooo`03ok:b/_oooooooooo
00?ooooo00?o/[:booooooooool0Moooool00onb/[;oooooooooo`04oooo
o`03oooo0?l00?oooooo07Oooooo00?oool0o`00ooooool01?ooool00ol0
0?ooool0ooooo`1gooooo`7o003o0Oooo`00087ok^k^00?ooooook:b/_o^
k^h0Moo^k^h00ooooooo/[:bonk^kP04onk^kP03ok:b/_ooooook^k^07Oo
k^k^00?o/[:booooooo^k^h01?o^k^h00oooo`3o003oonk^kP1gonk^kP03
oooo0?l00?ook^k^00Cok^k^00?o003ooooo0?o^k^h0Moo^k^h1o`00o`7o
ool00021onKViP03oooooonb/[;oi^KV07Ooi^KV00?ooooook:b/_oVi^H0
1?oVi^H00onb/[;oooooonKViP1gonKViP03ok:b/_ooooooi^KV00Coi^KV
00?oool0o`00oooVi^H0MooVi^H00oooo`3o003oonKViP04onKViP03o`00
ooooo`3oi^KV07Ooi^KV0Ol00?l1oooo0000POo^k^h00ooooooo/[:bonk^
kP1gonk^kP03oooooonb/[;ok^k^00Cok^k^00?o/[:booooooo^k^h0Moo^
k^h00onb/[;oooooonk^kP04onk^kP03oooo0?l00?ook^k^07Ook^k^00?o
ool0o`00ooo^k^h01?o^k^h00ol00?ooool0onk^kP1gonk^kP7o003o0Ooo
o`0008;ooooo00?o/[:booooooooool0Moooool00onb/[;oooooooooo`03
ooooo`03ok:b/_oooooooooo07Oooooo00?o/[:booooooooool01?ooool0
0oooo`3o003oooooo`1gooooo`03oooo0?l00?oooooo00Cooooo00?o003o
oooo0?ooool0Moooool1o`00o`7oool00021onk^kP03oooooonb/[;ok^k^
07Ook^k^00?ooooook:b/_o^k^h01?o^k^h00onb/[;oooooonk^kP1gonk^
kP03ok:b/_ooooook^k^00Cok^k^00?oool0o`00ooo^k^h0Moo^k^h00ooo
o`3o003oonk^kP04onk^kP03o`00ooooo`3ok^k^07Ook^k^0Ol00?l1oooo
0000POoVi^H00ooooooo/[:bonKViP1gonKViP03oooooonb/[;oi^KV00Co
i^KV00?o/[:boooooooVi^H0MooVi^H00onb/[;oooooonKViP04onKViP03
oooo0?l00?ooi^KV07Ooi^KV00?oool0o`00oooVi^H01?oVi^H00ol00?oo
ool0onKViP1gonKViP7o003o0Oooo`00087ok^k^00?ooooook:b/_o^k^h0
Moo^k^h00ooooooo/[:bonk^kP04onk^kP03ok:b/_ooooook^k^07Ook^k^
00?o/[:booooooo^k^h01?o^k^h00oooo`3o003oonk^kP1gonk^kP03oooo
0?l00?ook^k^00Cok^k^00?o003ooooo0?o^k^h0Moo^k^h1o`00o`7oool0
0022ooooo`03ok:b/_oooooooooo07Oooooo00?o/[:booooooooool00ooo
ool00onb/[;oooooooooo`1gooooo`03ok:b/_oooooooooo00Cooooo00?o
ool0o`00ooooool0Moooool00oooo`3o003oooooo`04ooooo`03o`00oooo
o`3ooooo07Oooooo0Ol00?l1oooo0000POo^k^h00ooooooo/[:bonk^kP1g
onk^kP03oooooonb/[;ok^k^00Cok^k^00?o/[:booooooo^k^h0Moo^k^h0
0onb/[;oooooonk^kP04onk^kP03oooo0?l00?ook^k^07Ook^k^00?oool0
o`00ooo^k^h01?o^k^h00ol00?ooool0onk^kP1gonk^kP7o003o0Oooo`00
087oi^KV00?ooooook:b/_oVi^H0MooVi^H00ooooooo/[:bonKViP04onKV
iP03ok:b/_ooooooi^KV07Ooi^KV00?o/[:boooooooVi^H01?oVi^H00ooo
o`3o003oonKViP1gonKViP03oooo0?l00?ooi^KV00Coi^KV00?o003ooooo
0?oVi^H0MooVi^H1o`00o`7oool00021onk^kP03oooooonb/[;ok^k^07Oo
k^k^00?ooooook:b/_o^k^h01?o^k^h00onb/[;oooooonk^kP1gonk^kP03
ok:b/_ooooook^k^00Cok^k^00?oool0o`00ooo^k^h0Moo^k^h00oooo`3o
003oonk^kP04onk^kP03o`00ooooo`3ok^k^07Ook^k^0Ol00?l1oooo0000
P_ooool00onb/[;oooooooooo`1gooooo`03ok:b/_oooooooooo00?ooooo
00?o/[:booooooooool0Moooool00onb/[;oooooooooo`04ooooo`03oooo
0?l00?oooooo07Oooooo00?oool0o`00ooooool01?ooool00ol00?ooool0
ooooo`1gooooo`7o003o0Oooo`00087ok^k^00?ooooook:b/_o^k^h0Moo^
k^h00ooooooo/[:bonk^kP04onk^kP03ok:b/_ooooook^k^07Ook^k^00?o
/[:booooooo^k^h01?o^k^h00oooo`3o003oonk^kP1gonk^kP03oooo0?l0
0?ook^k^00Cok^k^00?o003ooooo0?o^k^h0Moo^k^h1o`00o`7oool00021
onKViP03oooooonb/[;oi^KV07Ooi^KV00?ooooook:b/_oVi^H01?oVi^H0
0onb/[;oooooonKViP1gonKViP03ok:b/_ooooooi^KV00Coi^KV00?oool0
o`00oooVi^H0MooVi^H00oooo`3o003oonKViP04onKViP03o`00ooooo`3o
i^KV07Ooi^KV0Ol00?l1oooo0000POo^k^h00ooooooo/[:bonk^kP1gonk^
kP03oooooonb/[;ok^k^00Cok^k^00?o/[:booooooo^k^h0Moo^k^h00onb
/[;oooooonk^kP04onk^kP03oooo0?l00?ook^k^07Ook^k^00?oool0o`00
ooo^k^h01?o^k^h00ol00?ooool0onk^kP1gonk^kP7o003o0Oooo`0008;o
oooo00?o/[:booooooooool0Moooool00onb/[;oooooooooo`03ooooo`03
ok:b/_oooooooooo07Oooooo00?o/[:booooooooool01?ooool00oooo`3o
003oooooo`1gooooo`03oooo0?l00?oooooo00Cooooo00?o003ooooo0?oo
ool0Moooool1o`00o`7oool00021onk^kP03oooooonb/[;ok^k^07Ook^k^
00?ooooook:b/_o^k^h01?o^k^h00onb/[;oooooonk^kP1gonk^kP03ok:b
/_ooooook^k^00Cok^k^00?oool0o`00ooo^k^h0Moo^k^h00oooo`3o003o
onk^kP04onk^kP03o`00ooooo`3ok^k^07Ook^k^0Ol00?l1oooo0000POoV
i^H00ooooooo/[:bonKViP1gonKViP03oooooonb/[;oi^KV00Coi^KV00?o
/[:boooooooVi^H0MooVi^H00onb/[;oooooonKViP04onKViP03oooo0?l0
0?ooi^KV07Ooi^KV00?oool0o`00oooVi^H01?oVi^H00ol00?ooool0onKV
iP1gonKViP7o003o0Oooo`00087ok^k^00?ooooook:b/_o^k^h0Moo^k^h0
0ooooooo/[:bonk^kP04onk^kP03ok:b/_ooooook^k^07Ook^k^00?o/[:b
ooooooo^k^h01?o^k^h00oooo`3o003oonk^kP1gonk^kP03oooo0?l00?oo
k^k^00Cok^k^00?o003ooooo0?o^k^h0Moo^k^h1o`00o`7oool00022oooo
o`03ok:b/_oooooooooo07Oooooo00?o/[:booooooooool00oooool00onb
/[;oooooooooo`1gooooo`03ok:b/_oooooooooo00Cooooo00?oool0o`00
ooooool0Moooool00oooo`3o003oooooo`04ooooo`03o`00ooooo`3ooooo
07Oooooo0Ol00?l1oooo0000POo^k^h00ooooooo/[:bonk^kP1gonk^kP03
oooooonb/[;ok^k^00Cok^k^00?o/[:booooooo^k^h0Moo^k^h00onb/[;o
ooooonk^kP04onk^kP03oooo0?l00?ook^k^07Ook^k^00?oool0o`00ooo^
k^h01?o^k^h00ol00?ooool0onk^kP1gonk^kP7o003o0Oooo`00087oi^KV
00?ooooook:b/_oVi^H0MooVi^H00ooooooo/[:bonKViP04onKViP03ok:b
/_ooooooi^KV07Ooi^KV00?o/[:boooooooVi^H01?oVi^H00oooo`3o003o
onKViP1gonKViP03oooo0?l00?ooi^KV00Coi^KV00?o003ooooo0?oVi^H0
MooVi^H1o`00o`7oool00021onk^kP03oooooonb/[;ok^k^07Ook^k^00?o
oooook:b/_o^k^h01?o^k^h00onb/[;oooooonk^kP1gonk^kP03ok:b/_oo
ooook^k^00Cok^k^00?oool0o`00ooo^k^h0Moo^k^h00oooo`3o003oonk^
kP04onk^kP03o`00ooooo`3ok^k^07Ook^k^0Ol00?l1oooo0000P_ooool0
0onb/[;oooooooooo`1gooooo`03ok:b/_oooooooooo00?ooooo00?o/[:b
ooooooooool0Moooool00onb/[;oooooooooo`04ooooo`03oooo0?l00?oo
oooo07Oooooo00?oool0o`00ooooool01?ooool00ol00?ooool0ooooo`1g
ooooo`7o003o0Oooo`00087ok^k^00?ooooook:b/_o^k^h0Moo^k^h00ooo
oooo/[:bonk^kP04onk^kP03ok:b/_ooooook^k^07Ook^k^00?o/[:boooo
ooo^k^h01?o^k^h00oooo`3o003oonk^kP1gonk^kP03oooo0?l00?ook^k^
00Cok^k^00?o003ooooo0?o^k^h0Moo^k^h1o`00o`7oool00021onKViP03
oooooonb/[;oi^KV07Ooi^KV00?ooooook:b/_oVi^H01?oVi^H00onb/[;o
ooooonKViP1gonKViP03ok:b/_ooooooi^KV00Coi^KV00?oool0o`00oooV
i^H0MooVi^H00oooo`3o003oonKViP04onKViP03o`00ooooo`3oi^KV07Oo
i^KV0Ol00?l1oooo0000POo^k^h00ooooooo/[:bonk^kP1gonk^kP03oooo
oonb/[;ok^k^00Cok^k^00?o/[:booooooo^k^h0Moo^k^h00onb/[;ooooo
onk^kP04onk^kP03oooo0?l00?ook^k^07Ook^k^00?oool0o`00ooo^k^h0
1?o^k^h00ol00?ooool0onk^kP1gonk^kP7o003o0Oooo`0008;ooooo00?o
/[:booooooooool0Moooool00onb/[;oooooooooo`03ooooo`03ok:b/_oo
oooooooo07Oooooo00?o/[:booooooooool01?ooool00oooo`3o003ooooo
o`1gooooo`03oooo0?l00?oooooo00Cooooo00?o003ooooo0?ooool0Mooo
ool1o`00o`7oool00021onk^kP03oooooonb/[;ok^k^07Ook^k^00?ooooo
ok:b/_o^k^h01?o^k^h00onb/[;oooooonk^kP1gonk^kP03ok:b/_oooooo
k^k^00Cok^k^00?oool0o`00ooo^k^h0Moo^k^h00oooo`3o003oonk^kP04
onk^kP03o`00ooooo`3ok^k^07Ook^k^0Ol00?l1oooo0000POoVi^H00ooo
oooo/[:bonKViP1gonKViP03oooooonb/[;oi^KV00Coi^KV00?o/[:boooo
oooVi^H0MooVi^H00onb/[;oooooonKViP04onKViP03oooo0?l00?ooi^KV
07Ooi^KV00?oool0o`00oooVi^H01?oVi^H00ol00?ooool0onKViP1gonKV
iP7o003o0Oooo`00087ok^k^00?ooooook:b/_o^k^h0Moo^k^h00ooooooo
/[:bonk^kP04onk^kP03ok:b/_ooooook^k^07Ook^k^00?o/[:booooooo^
k^h01?o^k^h00oooo`3o003oonk^kP1gonk^kP03oooo0?l00?ook^k^00Co
k^k^00?o003ooooo0?o^k^h0Moo^k^h1o`00o`7oool00022ooooo`03ok:b
/_oooooooooo07Oooooo00?o/[:booooooooool00oooool00onb/[;ooooo
ooooo`1gooooo`03ok:b/_oooooooooo00Cooooo00?oool0o`00ooooool0
Moooool00oooo`3o003oooooo`04ooooo`03o`00ooooo`3ooooo07Oooooo
0Ol00?l1oooo0000POo^k^h00ooooooo/[:bonk^kP1gonk^kP03oooooonb
/[;ok^k^00Cok^k^00?o/[:booooooo^k^h0Moo^k^h00onb/[;oooooonk^
kP04onk^kP03oooo0?l00?ook^k^07Ook^k^00?oool0o`00ooo^k^h01?o^
k^h00ol00?ooool0onk^kP1gonk^kP7o003o0Oooo`00087oi^KV00?ooooo
ok:b/_oVi^H0MooVi^H00ooooooo/[:bonKViP04onKViP03ok:b/_oooooo
i^KV07Ooi^KV00?o/[:boooooooVi^H01?oVi^H00oooo`3o003oonKViP1g
onKViP03oooo0?l00?ooi^KV00Coi^KV00?o003ooooo0?oVi^H0MooVi^H1
o`00o`7oool00021onk^kP03oooooonb/[;ok^k^07Ook^k^00?ooooook:b
/_o^k^h01?o^k^h00onb/[;oooooonk^kP1gonk^kP03ok:b/_ooooook^k^
00Cok^k^00?oool0o`00ooo^k^h0Moo^k^h00oooo`3o003oonk^kP04onk^
kP03o`00ooooo`3ok^k^07Ook^k^0Ol00?l1oooo0000P_ooool00onb/[;o
ooooooooo`1gooooo`03ok:b/_oooooooooo00?ooooo00?o/[:boooooooo
ool0Moooool00onb/[;oooooooooo`04ooooo`03oooo0?l00?oooooo07Oo
oooo00?oool0o`00ooooool01?ooool00ol00?ooool0ooooo`1gooooo`7o
003o0Oooo`00087ok^k^00?ooooook:b/_o^k^h0Moo^k^h00ooooooo/[:b
onk^kP04onk^kP03ok:b/_ooooook^k^07Ook^k^00?o/[:booooooo^k^h0
1?o^k^h00oooo`3o003oonk^kP1gonk^kP03oooo0?l00?ook^k^00Cok^k^
00?o003ooooo0?o^k^h0Moo^k^h1o`00o`7oool00021onKViP03oooooonb
/[;oi^KV07Ooi^KV00?ooooook:b/_oVi^H01?oVi^H00onb/[;oooooonKV
iP1gonKViP03ok:b/_ooooooi^KV00Coi^KV00?oool0o`00oooVi^H0MooV
i^H00oooo`3o003oonKViP04onKViP03o`00ooooo`3oi^KV07Ooi^KV0Ol0
0?l1oooo0000POo^k^h00ooooooo/[:bonk^kP1gonk^kP03oooooonb/[;o
k^k^00Cok^k^00?o/[:booooooo^k^h0Moo^k^h00onb/[;oooooonk^kP04
onk^kP03oooo0?l00?ook^k^07Ook^k^00?oool0o`00ooo^k^h01?o^k^h0
0ol00?ooool0onk^kP1gonk^kP7o003o0Oooo`0008;ooooo00?o/[:boooo
ooooool0Moooool00onb/[;oooooooooo`03ooooo`03ok:b/_oooooooooo
07Oooooo00?o/[:booooooooool01?ooool00oooo`3o003oooooo`1goooo
o`03oooo0?l00?oooooo00Cooooo00?o003ooooo0?ooool0Moooool1o`00
o`7oool00021onk^kP03oooooonb/[;ok^k^07Ook^k^00?ooooook:b/_o^
k^h01?o^k^h00onb/[;oooooonk^kP1gonk^kP03ok:b/_ooooook^k^00Co
k^k^00?oool0o`00ooo^k^h0Moo^k^h00oooo`3o003oonk^kP04onk^kP03
o`00ooooo`3ok^k^07Ook^k^0Ol00?l1oooo0000POoVi^H00ooooooo/[:b
onKViP1gonKViP03oooooonb/[;oi^KV00Coi^KV00?o/[:boooooooVi^H0
MooVi^H00onb/[;oooooonKViP04onKViP03oooo0?l00?ooi^KV07Ooi^KV
00?oool0o`00oooVi^H01?oVi^H00ol00?ooool0onKViP1gonKViP7o003o
0Oooo`00087ok^k^00?ooooook:b/_o^k^h0Moo^k^h00ooooooo/[:bonk^
kP04onk^kP03ok:b/_ooooook^k^07Ook^k^00?o/[:booooooo^k^h01?o^
k^h00oooo`3o003oonk^kP1gonk^kP03oooo0?l00?ook^k^00Cok^k^00?o
003ooooo0?o^k^h0Moo^k^h1o`00o`7oool00022ooooo`03ok:b/_oooooo
oooo07Oooooo00?o/[:booooooooool00oooool00onb/[;oooooooooo`1g
ooooo`03ok:b/_oooooooooo00Cooooo00?oool0o`00ooooool0Moooool0
0oooo`3o003oooooo`04ooooo`03o`00ooooo`3ooooo07Oooooo0Ol00?l1
oooo0000POo^k^h00ooooooo/[:bonk^kP1gonk^kP03oooooonb/[;ok^k^
00Cok^k^00?o/[:booooooo^k^h0Moo^k^h00onb/[;oooooonk^kP04onk^
kP03oooo0?l00?ook^k^07Ook^k^00?oool0o`00ooo^k^h01?o^k^h00ol0
0?ooool0onk^kP1gonk^kP7o003o0Oooo`00087oi^KV00?ooooook:b/_oV
i^H0MooVi^H00ooooooo/[:bonKViP04onKViP03ok:b/_ooooooi^KV07Oo
i^KV00?o/[:boooooooVi^H01?oVi^H00oooo`3o003oonKViP1gonKViP03
oooo0?l00?ooi^KV00Coi^KV00?o003ooooo0?oVi^H0MooVi^H1o`00o`7o
ool00021onk^kP03oooooonb/[;ok^k^07Ook^k^00?ooooook:b/_o^k^h0
1?o^k^h00onb/[;oooooonk^kP1gonk^kP03ok:b/_ooooook^k^00Cok^k^
00?oool0o`00ooo^k^h0Moo^k^h00oooo`3o003oonk^kP04onk^kP03o`00
ooooo`3ok^k^07Ook^k^0Ol00?l1oooo0000P_ooool00onb/[;ooooooooo
o`1gooooo`03ok:b/_oooooooooo00?ooooo00?o/[:booooooooool0Mooo
ool00onb/[;oooooooooo`04ooooo`03oooo0?l00?oooooo07Oooooo00?o
ool0o`00ooooool01?ooool00ol00?ooool0ooooo`1gooooo`7o003o0Ooo
o`00087ok^k^00?ooooook:b/_o^k^h0Moo^k^h00ooooooo/[:bonk^kP04
onk^kP03ok:b/_ooooook^k^07Ook^k^00?o/[:booooooo^k^h01?o^k^h0
0oooo`3o003oonk^kP1gonk^kP03oooo0?l00?ook^k^00Cok^k^00?o003o
oooo0?o^k^h0Moo^k^h1o`00o`7oool00021onKViP03oooooonb/[;oi^KV
07Ooi^KV00?ooooook:b/_oVi^H01?oVi^H00onb/[;oooooonKViP1gonKV
iP03ok:b/_ooooooi^KV00Coi^KV00?oool0o`00oooVi^H0MooVi^H00ooo
o`3o003oonKViP04onKViP03o`00ooooo`3oi^KV07Ooi^KV0Ol00?l1oooo
0000POo^k^h00ooooooo/[:bonk^kP1gonk^kP03oooooonb/[;ok^k^00Co
k^k^00?o/[:booooooo^k^h0Moo^k^h00onb/[;oooooonk^kP04onk^kP03
oooo0?l00?ook^k^07Ook^k^00?oool0o`00ooo^k^h01?o^k^h00ol00?oo
ool0onk^kP1gonk^kP7o003o0Oooo`0008;ooooo00?o/[:booooooooool0
Moooool00onb/[;oooooooooo`03ooooo`03ok:b/_oooooooooo07Oooooo
00?o/[:booooooooool01?ooool00oooo`3o003oooooo`1gooooo`03oooo
0?l00?oooooo00Cooooo00?o003ooooo0?ooool0Moooool1o`00o`7oool0
0021onk^kP03oooooonb/[;ok^k^07Ook^k^00?ooooook:b/_o^k^h01?o^
k^h00onb/[;oooooonk^kP1gonk^kP03ok:b/_ooooook^k^00Cok^k^00?o
ool0o`00ooo^k^h0Moo^k^h00oooo`3o003oonk^kP04onk^kP03o`00oooo
o`3ok^k^07Ook^k^0Ol00?l1oooo0000POoVi^H00ooooooo/[:bonKViP1g
onKViP03oooooonb/[;oi^KV00Coi^KV00?o/[:boooooooVi^H0MooVi^H0
0onb/[;oooooonKViP04onKViP03oooo0?l00?ooi^KV07Ooi^KV00?oool0
o`00oooVi^H01?oVi^H00ol00?ooool0onKViP1gonKViP7o003o0Oooo`00
087ok^k^00?ooooook:b/_o^k^h0Moo^k^h00ooooooo/[:bonk^kP04onk^
kP03ok:b/_ooooook^k^07Ook^k^00?o/[:booooooo^k^h01?o^k^h00ooo
o`3o003oonk^kP1gonk^kP03oooo0?l00?ook^k^00Cok^k^00?o003ooooo
0?o^k^h0Moo^k^h1o`00o`7oool00022ooooo`03ok:b/_oooooooooo07Oo
oooo00?o/[:booooooooool00oooool00onb/[;oooooooooo`1gooooo`03
ok:b/_oooooooooo00Cooooo00?oool0o`00ooooool0Moooool00oooo`3o
003oooooo`04ooooo`03o`00ooooo`3ooooo07Oooooo0Ol00?l1oooo0000
POo^k^h00ooooooo/[:bonk^kP1gonk^kP03oooooonb/[;ok^k^00Cok^k^
00?o/[:booooooo^k^h0Moo^k^h00onb/[;oooooonk^kP04onk^kP03oooo
0?l00?ook^k^07Ook^k^00?oool0o`00ooo^k^h01?o^k^h00ol00?ooool0
onk^kP1gonk^kP7o003o0Oooo`00087oi^KV00?ooooook:b/_oVi^H0MooV
i^H00ooooooo/[:bonKViP04onKViP03ok:b/_ooooooi^KV07Ooi^KV00?o
/[:boooooooVi^H01?oVi^H00oooo`3o003oonKViP1gonKViP03oooo0?l0
0?ooi^KV00Coi^KV00?o003ooooo0?oVi^H0MooVi^H1o`00o`7oool00021
onk^kP03oooooonb/[;ok^k^07Ook^k^00?ooooook:b/_o^k^h01?o^k^h0
0onb/[;oooooonk^kP1gonk^kP03ok:b/_ooooook^k^00Cok^k^00?oool0
o`00ooo^k^h0Moo^k^h00oooo`3o003oonk^kP04onk^kP03o`00ooooo`3o
k^k^07Ook^k^0Ol00?l1oooo0000P_ooool00onb/[;oooooooooo`1goooo
o`03ok:b/_oooooooooo00?ooooo00?o/[:booooooooool0Moooool00onb
/[;oooooooooo`04ooooo`03oooo0?l00?oooooo07Oooooo00?oool0o`00
ooooool01?ooool00ol00?ooool0ooooo`1gooooo`7o003o0Oooo`00087o
k^k^00?ooooook:b/_o^k^h0Moo^k^h00ooooooo/[:bonk^kP04onk^kP03
ok:b/_ooooook^k^07Ook^k^00?o/[:booooooo^k^h01?o^k^h00oooo`3o
003oonk^kP1gonk^kP03oooo0?l00?ook^k^00Cok^k^00?o003ooooo0?o^
k^h0Moo^k^h1o`00o`7oool00021onKViP03oooooonb/[;oi^KV07Ooi^KV
00?ooooook:b/_oVi^H01?oVi^H00onb/[;oooooonKViP1gonKViP03ok:b
/_ooooooi^KV00Coi^KV00?oool0o`00oooVi^H0MooVi^H00oooo`3o003o
onKViP04onKViP03o`00ooooo`3oi^KV07Ooi^KV0Ol00?l1oooo0000POo^
k^h00ooooooo/[:bonk^kP1gonk^kP03oooooonb/[;ok^k^00Cok^k^00?o
/[:booooooo^k^h0Moo^k^h00onb/[;oooooonk^kP04onk^kP03oooo0?l0
0?ook^k^07Ook^k^00?oool0o`00ooo^k^h01?o^k^h00ol00?ooool0onk^
kP1gonk^kP7o003o0Oooo`0008;ooooo00?o/[:booooooooool0Moooool0
0onb/[;oooooooooo`03ooooo`03ok:b/_oooooooooo07Oooooo00?o/[:b
ooooooooool01?ooool00oooo`3o003oooooo`1gooooo`03oooo0?l00?oo
oooo00Cooooo00?o003ooooo0?ooool0Moooool1o`00o`7oool00021onk^
kP03oooooonb/[;ok^k^07Ook^k^00?ooooook:b/_o^k^h01?o^k^h00onb
/[;oooooonk^kP1gonk^kP03ok:b/_ooooook^k^00Cok^k^00?oool0o`00
ooo^k^h0Moo^k^h00oooo`3o003oonk^kP04onk^kP03o`00ooooo`3ok^k^
07Ook^k^0Ol00?l1oooo0000POoVi^H00ooooooo/[:bonKViP1gonKViP03
oooooonb/[;oi^KV00Coi^KV00?o/[:boooooooVi^H0MooVi^H00onb/[;o
ooooonKViP04onKViP03oooo0?l00?ooi^KV07Ooi^KV00?oool0o`00oooV
i^H01?oVi^H00ol00?ooool0onKViP1gonKViP7o003o0Oooo`00087ok^k^
00?ooooook:b/_o^k^h0Moo^k^h00ooooooo/[:bonk^kP04onk^kP03ok:b
/_ooooook^k^07Ook^k^00?o/[:booooooo^k^h01?o^k^h00oooo`3o003o
onk^kP1gonk^kP03oooo0?l00?ook^k^00Cok^k^00?o003ooooo0?o^k^h0
Moo^k^h1o`00o`7oool00022ooooo`03ok:b/_oooooooooo07Oooooo00?o
/[:booooooooool00oooool00onb/[;oooooooooo`1gooooo`03ok:b/_oo
oooooooo00Cooooo00?oool0o`00ooooool0Moooool00oooo`3o003ooooo
o`04ooooo`03o`00ooooo`3ooooo07Oooooo0Ol00?l1oooo0000POo^k^h0
0ooooooo/[:bonk^kP1gonk^kP03oooooonb/[;ok^k^00Cok^k^00?o/[:b
ooooooo^k^h0Moo^k^h00onb/[;oooooonk^kP04onk^kP03oooo0?l00?oo
k^k^07Ook^k^00?oool0o`00ooo^k^h01?o^k^h00ol00?ooool0onk^kP1g
onk^kP7o003o0Oooo`00087oi^KV00?ooooook:b/_oVi^H0MooVi^H00ooo
oooo/[:bonKViP04onKViP03ok:b/_ooooooi^KV07Ooi^KV00?o/[:boooo
oooVi^H01?oVi^H00oooo`3o003oonKViP1gonKViP03oooo0?l00?ooi^KV
00Coi^KV00?o003ooooo0?oVi^H0MooVi^H1o`00o`7oool00021onk^kP03
oooooonb/[;ok^k^07Ook^k^00?ooooook:b/_o^k^h01?o^k^h00onb/[;o
ooooonk^kP1gonk^kP03ok:b/_ooooook^k^00Cok^k^00?oool0o`00ooo^
k^h0Moo^k^h00oooo`3o003oonk^kP04onk^kP03o`00ooooo`3ok^k^07Oo
k^k^0Ol00?l1oooo0000P_ooool00onb/[;oooooooooo`1gooooo`03ok:b
/_oooooooooo00?ooooo00?o/[:booooooooool0Moooool00onb/[;ooooo
ooooo`04ooooo`03oooo0?l00?oooooo07Oooooo00?oool0o`00ooooool0
1?ooool00ol00?ooool0ooooo`1gooooo`7o003o0Oooo`00087ok^k^00?o
oooook:b/_o^k^h0Moo^k^h00ooooooo/[:bonk^kP04onk^kP03ok:b/_oo
ooook^k^07Ook^k^00?o/[:booooooo^k^h01?o^k^h00oooo`3o003oonk^
kP1gonk^kP03oooo0?l00?ook^k^00Cok^k^00?o003ooooo0?o^k^h0Moo^
k^h1o`00o`7oool00021onKViP03oooooonb/[;oi^KV07Ooi^KV00?ooooo
ok:b/_oVi^H01?oVi^H00onb/[;oooooonKViP1gonKViP03ok:b/_oooooo
i^KV00Coi^KV00?oool0o`00oooVi^H0MooVi^H00oooo`3o003oonKViP04
onKViP03o`00ooooo`3oi^KV07Ooi^KV0Ol00?l1oooo0000POo^k^h00ooo
oooo/[:bonk^kP1gonk^kP03oooooonb/[;ok^k^00Cok^k^00?o/[:boooo
ooo^k^h0Moo^k^h00onb/[;oooooonk^kP04onk^kP03oooo0?l00?ook^k^
07Ook^k^00?oool0o`00ooo^k^h01?o^k^h00ol00?ooool0onk^kP1gonk^
kP7o003o0Oooo`0008;ooooo00?o/[:booooooooool0Moooool00onb/[;o
ooooooooo`03ooooo`03ok:b/_oooooooooo07Oooooo00?o/[:boooooooo
ool01?ooool00oooo`3o003oooooo`1gooooo`03oooo0?l00?oooooo00Co
oooo00?o003ooooo0?ooool0Moooool1o`00o`7oool00021onk^kP03oooo
oonb/[;o/[:b07Oo/[:b00?ooooook:b/_o^k^h01?o^k^h00onb/[;ooooo
ooooo`1gooooo`03ok:b/_ooooook^k^00Cok^k^00?oool0o`00ool00?l0
Mol00?l00oooo`3o003oonk^kP04onk^kP03o`00ooooo`3oool007Ooool0
0Ol00?l1oooo0000POoVi^Ikooooo`03ok:b/_oVi^Koi^KV00?oi^KVNonb
/[800oooooooi^KVonKViP03onKViW_oool000?o003oonKVi_oVi^H00ooV
i^Iko`00o`7oool0003oogmoOeOoOgmo1omnOWkoogmoObCoOgmo00001?o[
jn_oi^KVon;Rh_oNg]h4omgMg@?og]kN00?og=cLomkNg_oMgMd00_oMgMd0
oooNg]kog=cLomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNgP004OoMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omcLg?oMgMgofm_K00;og=cL03?ogMgMomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]h0
0_oLg=`01OoIfMWof=SHomOGeooHf=SofMWJ00;og=cL0?oog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oLg=cog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]h001OogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMgP03omkNgP03omgMgOoNg]kog]kN
00?ogMgM0OoQhN41onOWi`7oj^[Z00000oo/k>coi^KVon3Ph007omWIf@04
omSHf?oFe]Kodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT0
1?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI
00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=SKomWI
f@;of=SH00Koe]KFom?CdooCdm?oe=CDomOGeooHf=P2omWIf@03omSHf?oI
fMWofMWI00;of=SH2OoIfMT00ooHf=SofMWIomWIf@02omSHf003omWIfOoH
f=Sof=SH00;of=SH5ooIfMT01?oHf=Soe]KFom;Bd_o?cll2olg=c@04olo?
cooCdm?oemOGomSHf?oofMWI5_oIfMT00ooHf=SofMWIomWIf@06omWIf@7o
g]kN0OoVi^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoPh>3oh^;R
00;ohN7Q00gog]kNom_KfooCdm?oalO7ok^k^onb/[;o[Jf]ok:b/_nk^k_o
alO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?oalO7ok^k^onb
/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_K
fooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO
0=[ohN7Q00Woh>3PomoOgooKfm_oe]KFomCDe?oFe]Kof][JomkNg_oPh>00
1_oOgml3on3Ph003omoOgooPh>3oh>3P00;oh>3P2?oOgml2omkNgP;ogmoO
0ooPh>02omoOg`;oh>3P0_oOgml=on3Ph005omoOgooMgMgofMWIomGEeOoC
dm<00_oBd]800ooFe]Kog=cLon3Ph01_on7Qh@03on3Ph?oQhN7ohN7Q00Go
hN7Q00?oh>3Pon7QhOoQhN40<_oQhN400ooPh>3ohN7Qon7Qh@1Xon7Qh@03
on;Rh_oQhN7oh^;R00CohN7Q0OoTi>@1onSXj07okNg]00000oo`l?3okno_
oo7al@03oo3`l03oono_koo`l?3ok^k^onWYjOoKfm_o`L71ojBTY?n<S8co
NWYjogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7aono_kooa
lO7okno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2`_nTY:CoS8b;og]k
NomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<S?mkNg_o
MgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]kOoalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_000K
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNook^k^ono_kooZj^[oinOW00;oh>3P00Oohn?Son_[jOo[jn_oj^[ZonKV
i_oXj>SoinOW00;ojNWY01;ok^k/onc/k?o/k>coj>SXonc/k?o]kNgol?3`
onc/k?oZj^Soi^KVonSXj?oWinOojNWYonSXj?o[jn_oinOWonOWiOoUiND2
onWYj@0?onk^k_o]kNgokNg]onSXj?o[jnWok>c/onk^k_oYjNWoj^[Zon_[
joo_knook>c/onc/j_oZj^[ok^k^00;ok>c/0?ooj^[Zono_koo/k>cok>cZ
on[Zj_o^k^kok>c/ojn_[omfMWKoFEUIofi^K_ng]kKoh>3PonWYjOo]kNgo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knl002golO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`l?o_knl01?o`l?000003oo;bl_o^k^koinOW00CoiNGU
013oi>CTomoOgooAdM7o/K6aohZ:R_mUIFGoDE5AodE5AOm2@T;oADE5oe5A
DOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@00ooUiNGoi>CTonGUi002onCT
i00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmV
IVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT0>goiNGUonCTi?oUiNGoi>CTonCT
hooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIV
ohZ:R_na/K7odM7AomkNg_oTi>?oi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiN@00_oTi>@0ooo5aLGo:2PX
odA4A?n@T93odM7AomcLfooKfm_oemOGomCDe?oFe]Koe=CDomGEeOoIfMWo
h>3OomkNg_oJf][oe=CDomWIfOoNg]koh^;RomcLg?oGemKoe=CDomKFe_oD
e=CoeMGEomSHf?oKfm_oemOGomKFeOoEeMGoemOGomSHf?oNg]kogmoOomcL
g?oEeMGoemOFomcLg?oMgMgoemOGomKFe_oKfm_ohN7QomkNg_oKfm[of][J
omkNg_oLg=cof][Jom_KfooPh>3ogmoOomcLfooIfMWog]kNomoOgomdM7Co
IfMWohf=SOmDE5Co20P8oj:RX_oLg=coh^;RonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGohn?SonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUon?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi000F?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>@4onGUi@06onCTi?oUiNGoiNGUonGUiOoXj>So
k>c/0Oobl_800003ooCdm?o]kNgoinOW00;oh>3P01?ohN7QomoOgooNg]ko
d];BokBd]?n7QhOoG5aLofdk=OnNCT;ocFiNonV3Koo=KeooWDe3ofdk=_mL
G5coQhN7okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaL
G?m]H2coWYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aLohN7Qond];Cod];B
omkNgP05on3Ph00AomkNg_oBd];o];BdohN7QomLG5coAfL^ofRN<onAcDOo
Z^UEoi7=AomZWSCoBFX_oeaLG?n7QhOo];Bdom;Bd_oNg]h0fOoPh>001_oO
gmooclo?oiVIVOnBTY;o6ATIohb<S0;oeMGE01ooclo?ol;2`_o>c/koc/k>
olG5aOo:b/[of][JomSHf?o@d=3obl_;olo?cooHf=Sof][JomGEeOo?cloo
`L71om3@d?o>c/koa<C4ol_;booHf=SoemOGokjn__nk^k_odM7Aom3@d?oE
eMGof=SHom?Cdoo<c<coc/k>00;oeMGE00Goc/k>olc<c?oCdm?of][JomSH
f002om;BdP04omSHf?oGemOodM7Aom?Cd`;ofMWI00Kodm?Com7AdOoGemOo
f=SHom7AdOo@d=02om7Ad@04odI6A_m1@D7oemOGomkNgW7oh>3P00?ogmoO
on3Ph?oPh>000_oPh>000ooOgmooh>3Pon3Ph02Lon3Ph003omoOgooPh>3o
gmoO00;ogmoO0ooPh>000ooQhN7oinOWonc/k001ooCdm00000?om_Kfoo;b
l_o[jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWiooJUiNohlf;_o/L67onIf@
oofaYOom_:oooKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;Rh_oWinL0
0ooXj>P04ooWinOoh^;Rolg=cOnOWiooKVIOoi=b8_o]dDConO=doogmSOom
oIGooOf>ooWhM_o]edOoTg<RofiWGonOWioocLg=on;Rh_oWinL00ooXj>P0
4ooWinOoh^;Rolg=cOnOWiooH6QOod]l8onBhD_o_OUkom3mT_oHoI_oe?fE
ol3iO_nHj4goCH0Tof1YGonOWioocLg=on;Rh_oWinL0f_oXj>P01?oVi^Ko
hN7QoeeMGOm=CDd2omgMg@0Ooe1@D?l71`Oo5ADEohB4Q?lF5QKo@d=3on;R
h_oMgMgoW9bLo`000?n?ShoogMgMon7QhOoKfm_o@410o`P82?lI6AWoR8R8
o`/;2omHF5So]kNgo``<3?l71`Oo8b<SobLW9ommOGgof][JomgMgOoDe=Co
2`/;oeUIF@02omWIf@03oeeMGOl;2`_odm?C00;ogmoO00KoFUYJodi>C_oN
g]kog]kNob<S8on4Q8@2on7Qh@0<ogYjN_l^;RkogMgMomgMgOo2`/;oD51@
oc<c<om^KVkoPh>3ob4Q8OoNg]koi^KVoooXj>POonSXj07ok>c/0Oobl_81
ooKfmP0000?omoOgooShn?ohn?P00oohn?P04oogmoOok^k^olk>c_n@T93o
QBl[onUTE_okTXOooZJKoojaYOoo]j[oo[>VoojXW?ojU8WokVQIohTa:on@
T93oc/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93oVFT[oo2m
?Ookh6koo_B2ooknR_oooi;oo_j<ookhPookiG3ol<8noiUZ:on@T93oc/k>
onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93o@W<[ohC>@on]kg?o
`_j8olknT?oFoiOod?jBolKnROnbmGCoR==3odAe:on@T93oc/k>onk^k_og
moL0f_ohn?P09Oofm_KolO7aoh61POlO7aookNg]olK6a_l0003o`l?3om?C
domLG5co20P8on[Zj_o`l?3oj^[Zoe9BD_lD51Co?CdmonWYjOo`l?3o[jn_
o`L71ooBd];ocLg=odi>C_lK6a_ok^k^om_Kfon^[Zkoj>SXonc/k?n^[Zko
0000okBd]?o/k>co/;2`o`/;2olJ6QX00_oTi>@02olS8b?o3Ph>ojBTY?o]
kNgok^k^of1PH?mDE5Cok^k^ong]kOlV9RKoSHf=00;ol?3`00coPX:2oc4a
<Oo/k>coj^[Zod=3@ol_;booW9bLog=cLolZ:R[o6QXJonk^k_ofm_I_ooSh
n003ooOgmoohn?Son?Sh00Gon?Sh00?omoOgooShn?ohn?P0WOohn?P00oog
moOon?ShooShn002ooShn004ooOgmooinOWomoOgooKfmP7on?Sh00000ooj
n_[omOGeonk^kP02onc/k03oon_[jooYjNWogmoOokZj^_mhDU;o_c8TonIc
J?omRGkooiN;oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c9?miDU;o^[Zj
omoOgooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3o
oMYSoooZL_onlgkoooZ2ookfOoook7?oo]iToo[7DOoRTQcoRFICokZj^_oO
gmooj^[Zon_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]D_mAXacoTM9EojKW
J_nhnG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]D_nj^[[ogmoO
on[Zj_o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/0019onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/onWYjOoUiNGoNWYjoa`L7?oQhN;o
c<c<o`<30onPX:3og]kNoiBDU?lC4a?ohN7Qon3PhOo@d=3o1PH6oj6QXOl9
2@Wo_knoon7QhOnj^[[o0P82ok:b/_oMgMgoP820obPX:?oShn?oinOWonGU
iOoOgmoofm_Kom?Cdol820SoQHF5omoOgomYJFWoBTY:ocDe=On][Jgo_Kfm
o`L71omhN7SoEEEEomoOgooPh>3oFe]Koe1@D002on7Qh@0:ob@T9?n5QHGo
gmoOon7QhOmkNg_o;bl_on3Ph?oDe=Co1@D5ojRXZ0;ohn?S0?ooOWiooaHF
5_oQhN7oj^[Zon_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on[Zj_o/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?oZj^_ok>c/on_[joo/k>cojn_[onc/
k?oZj^[ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn/001[ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k0Kojn_[
00Gok>c/on_[joo[jn_ok^k^ooKfmP01ooWin@0000?ono_koo?cloo]kNd0
0_oUiND0oooVi^Koi>CTomWIfOnb/[;oNBh^olQ2<ooSJUcom7Y]oof8O?on
Uh[ooY^>oojHRoonRWkom7]]onM[GOo:@SCoNbh^ok:b/_oHf=Soi>CTonGU
iOoVi^KoiNGVonCTi?oHf=So/[:boiIE;_oZW2_onka4ook<Doomf6;oo^=b
ookYMOoniW?oo]]Uoog<Dook`DGokYh[oiUF;_nb/[;of=SHonCTi?oUiNGo
i^KVonGUiOoTi>Cof=SIok:b/_l^HRkoHjd[ohO:B?nGg5WoYNEYok;cMonh
mW_o]?EiojOZJonHg5WoRLm;of>^:ol^Hbko/[:bomSHfOoTi>CoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUiP00=?oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oShn?ogmoOogMgMolK6a_og=cLon7QhOnNWYko;bl_
ob/[:olb<S;o4Q8BomcLg?oJf]_oQ8B4ob0P8?oPh>3oDU9BofQXJ?oJf][o
g]kNoi2@T?lZ:R[o;Rh^ob`/;?lW9bL2omkNgP0ComWIfOoCdmCod=3@oe]K
Fol0003o_Kfmom[Jf_lX:2SoQhN7ogMgN?mXJ6SoPX:2oc`l??o2`/;o3`l?
omCDe?oJf][oFEUIodi>CP02omcLg00?ob<S8on1PH7oeMGEomOGeomgMgOo
;Rh^omcLg?nSXj?o0000olO7aooHf=SofMWIohf=S_lE5AGog=cL00;oi>CT
073oi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Koi>CT
0_oUiND0X_oVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUiP;oi^KV00?oiNGUonKVi_oVi^H0
0ooVi^H00ooUiNGokNg]ooCdm001oo[jnP0000?oo?clooShn?oalO400oo^
k^h04oo[jn_ohN7Qokbl_?mj5aOo`clbom=FBOoTJ5[okgM/ooB3NOogQgco
mHAjoo=iKOoUJE_ofEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/
k>cohN7Qokbl_?nUAaOoiYLbooF/<?om_47ooLUCoog@H?okdfGooM9Pook=
E?om_D;onZlbonVK<_nUAQOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Q
okbl_?lGFAOoGjPbogJm=on6cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOo
Mklgoen[<_lGFAOo_;blon7QhOo/k>`0f_o^k^h0;_o/k>coinOWog]kNolL
71coi>CTonWYjOoVi^KohN7QomkNg_n=SHgo51@DonKVi_oTi>Co=CDeogUi
NOo[jn_o/[:boaDE5OoOgmooi^KVonCTi?oQhN7ogMgMogYjN_lY:BWoj>SX
onGUiOoMgMgo/K6aobHV9_l;2`_oVi^KonWYjOo<c<co0000olk>c_o3`l?o
9BDUod];BomlO7coj>SXoc4a<OnUYJGoi>CToeeMGOmADE42onOWi`0:obDU
9OmYJFWogmoOomoOgomgMgOo<C4aonWYjOo1`L7o0000ojNWY`;ogmoO00Co
Ti>CoaHF5_oWinOok>c/[?o^k^h00oo]kNgok^k^onk^kP1^onk^kP03ong]
kOobl_;on?Sh007oo?cl0003oogmo@0Fooclo?omoOgooOgmooclo?oclo?o
dM7AofP71onh=3Coaclcom9@@ooJHUGohfiRonAbI?oTKf;og6AGom=A@oo<
@CCo^C@dof/71ooBd];olo?cooclo0?ooOgm01?oo?cloo?clooBd];oWR/7
omZ:=?o[VaWomJPYooRd?ooi_D[on;m=ooZoB_oi^3oomZXZonnN6OoKRcCo
XRd7om;Bd_oclo?oo?cl00?ooOgm01?oo?cloo?clooBd];o1d07odfJ=?mO
Zb3oL;P_ogo3@on:cE3oSLeBoh[>D?n1adCoLKT_of:^8?m>VcCo1d87om;B
d_oclo?oo?cl0=[ooOgm02?ono_kooOgmon4Q8Co7QhNoo?clooinOWo/k>c
om3@d?oclo?oJ6QXodM7Aoojn_[oe=CDo`000?oMgMgoo?cloo_knolW9bOo
Z:RXooWinOn[Zj_oeMGEoo7alOmDE5CoGUiNooWinOodm?CoU9BDo`D51Om0
@43odM7AooOgmoohn?SoUiNGob/[:`02oo[jnP0Kob@T9?l71`Oob<S8oo_k
non5QHGoHf=SooOgmomSHf?oEeMGooShn?oinOWo9bLWoaDE5On3Ph?oemOG
od92@_mSHf?ono_koo[jn_ld=3CoBDU9om_KfooUiNGoCdm?oaLG5ooinOWo
o?cl0?oooOgm7?omoOd00oolo?cooOgmooclo003oogmo@0003[ooOgmoo[j
n_oclo?ok^k^oo3`l?o_knook^k^onWYjOoCdm?oFQ`Loj8d=?nd:1go`CT/
olM9??o?ET[od5M;om1GB_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[o
k^k^oo3`l?o_knool?3_onk^k_oZj^[odm?Coh`U7Oo8LCCofH@MonBD5OoW
WBCokZPcoo2Z=?o_ZS?ok:0UonNG5OoLR1gob74doh`U7OoCdm?oj^[Zonk^
k_o`l?3okno_oo3`l?o^k^koj^[Yom?CdolM>1go=88dodNE7OmJYA_oJJdZ
0_md^3P0h_me^CSoJk4[oe^W7?m8VQgo=88doadh7OoCdm?oj^[Yonk^k_o`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?02ono_k`3^on[Zj_mnOWko71`LonSXioo]kNgoR8R8oc0`
<?l?3`oo<C4aok6a/Oo^k^koQHF4ode=COo_knook^k^ono_kon:RX[oFEUI
onk^k_mhN7So:b/[o`l?3olh>3So_knoong]kOoTi>Co3Ph>ofUYJOoOgmoo
hn?SonGUiOo[jn_oHF5QogMgMoo^k^kokno^ogIfM_lV9RKokNg]ono_koo<
c<co;2`/on[Zj_m]KFcoHV9Ronc/k?o]kNgo>c/koi>CTomRHV;o3Ph>oc@d
=?o4a<Cokno_onk^k_oAdM7o?3`lo`X:2_lW9bOoK6a/ob`/;?o_knook^k^
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3ok^k^oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l0?okno_06Col?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_0_o`l?06ono_k`7olo?c0Ooi
nOT1ooknoP0000?oo_knooOgmoo`l?001?oYjNT04OoWinOofm_Kof=;Bon1
<S;oYSDeokHd;Oo2CD7o`eA9olAEB_o3E4Wo`Te1okHd;OnU=CGoPC8bof=;
BooKfm_oinOW00GojNWY017oinOWom_Kfon9Bd_o[d/boleg=OoFRbgoh9`^
on2P<_oQX3Coh:0bomnJ;_oFRbgobWDeojm;<_n9Bd_ofm_KonOWi`05onWY
j@0AonOWiooKfm_oBd];oc9P<_ljRCGoDi/]of^[;om`[CSoKjhjog2]>?mZ
ZRooDi/]ocV8=OlbH3;oBd];om_KfooWinL0fooYjNT01_oXj>Soi^KVog]k
NolL71coi>CTonSXj0;ojNWY00?oinOWonWYjOoYjNT02ooYjNT03?oWinOo
jNWYonWYjOoXj>Sof=SHo`X:2_n^[ZkogMgMomkNg_oPh>3oiNGUonSXj0So
jNWY00Koj>SXonKVi_oShn?ohn?SonKVi_oXj>P3onWYj@03onSXj?oYjNWo
jNWY00CojNWY00?oinOWonWYjOoYjNT0oooYjNTKonWYj@03onSXj?oYjNWo
jNWY00CojNWY0Oo`l?01ooOgm`7oo_kn00001Oono_kon_[jooCdm?o_knoo
lO7a00;ol?3`017okno_on_[jonEU9CoCb<SoiEDE?nkLg?odiFEomZLW?oJ
WYcofIbLomBEUOnkLg?oUEADodlS8onEU9Coj^[Zono_k`05oo3`l00Aono_
kooZj^[oZIBDoh4S8onjJUCoe9YconBlUOoZaicojLNLon[7W?oU_9Goe9Yc
ok]ZE?n18b?oZYBDon[Zj_o_knl01Oo`l?004Oo_knooj^[ZoiBDU?lS:R?o
E7YDog>ULonNaYGo[<jLojg>W?n/cYcoW/JEog>ULomDNUCo8bXSoiBDU?oZ
j^[okno_0=_ol?3`0_o_knl01?n0P83o7AdMonk^k_o_knlCoo3`l0;okno_
00OoI6ATobTY:On1PH7oHf=Soc/k>oo^k^kokno_00Sol?3`00Kokno_onk^
k_mcLg?oJFUYonk^k_o_knoooo3`l2gol?3`00ColO7aoo3`l?odm?Con_[j
0Oono_h00004onc^l?ooooooooooooknoP;ooooo0_ono_h0ooomoOgon?Sh
ofi^K_mJ?coo/I2@omk9bOo`i>ColnKVoo3Ti?oNbLWo/I2@oeXo?om]KFgo
n?Shooclo?ooooooo_knooooooono_koooonookno_ooooooo?clooShn?n=
KFgoRSloolVAT?oYd<Wom>WTooK[i_odjNCojM39olVAT?n9?cooSFe]ooSh
moolo?coooooookno_ooooooo_knooooooono_koooonooclo?ohn?SoKFe]
oclo?on@WI3obMG9onC/i?oVk^Koi>cTolWEbOn@WI3o?cloofe]KOohn?So
o?clooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooooknoP00>?ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_oooooooOgmom3@d?nU
YJGoo_kmookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooomoOgo`L70og5aLOn1PH7o[jn_0_ono_h03?ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooomoOgo`/;1okbl_0;oo_kn0?oooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooool002Woo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooooknoP02ooooo`03ookno_oooooooooo00?ooooo0Oojno/0
0004ol78c_ono_kon_[jooCdm0GolO7a00gokno_omKFe_m[Jf_o@cdmoi^<
S?o6^[[oe/c<olNj^_nKS8co@cdmof][JooFe]Kokno_00WolO7a00gokno_
omOFe_n3Jf_oM3dmokF<S?oE^[[ohLc<omJj^_nfS8coLSdmoh5[JooGe]Ko
kno_00WolO7a00gokno_omKFe_m[Jf_o?Cdmohb<S?nj^[[oc<g<okZj^_n<
S8co?Cdmof][JooFe]Kokno_0?oolO7aoooalO4doo7al@04oo3`l?oalO7o
lO7aoo3`l0ColO7a00?om?Cdoo[jn_ono_h00Oo[kNh00005ohB?VOomoOgo
n?Shoo3`l?o[jn/00ooZj^X03OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUIFOlV
9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT02ooZj^X02ooYjNWoj>SXoj2K
VomZFEWo@bHVobd92Om29RKoJEUIoj2KVooXj>SojNWY00_oj^[Z00_ojNWY
onSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@3oon[Z
j_ooj^[Z??oZj^X01?o[jn_ol?3`ooShn?omoOd1om;Ff00000Co=TIAokS0
aOoinOWom?Cd2?oalO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2
oo3`l0oolO7a0_o`l?03ono_k`;ol?3`oooalO7ooo7alC[olO7a00?ol?3`
oo7alOoalO400_oalO400ooemOGon_[jonc]k`01oj6UZ00000?o7BloodaI
Honi_lD0ooooooooooooogcooooo0Oo]k^l1ojf`/P7oYJZ]00001_lL;Sgo
6RTeoc8lA_mnR93o_L?8on_/k_oooooooooooomfooooo`05on[[k?nk`<Co
NH67ob`e?OlC7bT00OlD92l00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[BoxData[{
    \(\(savedLayout = pane@getLayout[];\)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]\(pane@
          setLayout[\[IndentingNewLine]JavaNew["\<java.awt.GridLayout\>", 5, 
              5, 5, 5]\[IndentingNewLine]];\)\[IndentingNewLine]]\)}], "Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[BoxData[
    \(JavaBlock[\(NewJPanelEmptyBorder[pane];\)]\)], "Input"],

Cell[BoxData[
    \( (*\ Etched\ Border\ *) \)], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]NewJPanelEtchedBorder[
        pane]; \[IndentingNewLine]NewJPanelEtchedBorder[pane, 
        False]; \[IndentingNewLine]NewJPanelEtchedBorder[pane, 
        True, \[IndentingNewLine]java`awt`Color`yellow, \
\[IndentingNewLine]java`awt`Color`blue]; \
\[IndentingNewLine]NewJPanelEtchedBorder[pane, 
        False, \[IndentingNewLine]java`awt`Color`yellow, \
\[IndentingNewLine]java`awt`Color`blue];\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \( (*\ Bevel\ Border\ *) \)], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]NewJPanelBevelBorder[
        pane]; \[IndentingNewLine]NewJPanelBevelBorder[pane, 
        False]; \[IndentingNewLine]NewJPanelBevelBorder[pane, 
        True, \[IndentingNewLine]java`awt`Color`yellow, \
\[IndentingNewLine]java`awt`Color`blue]; \
\[IndentingNewLine]NewJPanelBevelBorder[pane, 
        False, \[IndentingNewLine]java`awt`Color`yellow, \
\[IndentingNewLine]java`awt`Color`blue]; \
\[IndentingNewLine]NewJPanelBevelBorder[pane, 
        True, \[IndentingNewLine]java`awt`Color`yellow, \
\[IndentingNewLine]java`awt`Color`blue, \
\[IndentingNewLine]java`awt`Color`red, \
\[IndentingNewLine]java`awt`Color`green];\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \( (*\ Soft\ Bevel\ Border\ *) \)], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]NewJPanelSoftBevelBorder[
        pane]; \[IndentingNewLine]NewJPanelSoftBevelBorder[pane, 
        False]; \[IndentingNewLine]NewJPanelSoftBevelBorder[pane, 
        True, \[IndentingNewLine]java`awt`Color`yellow, \
\[IndentingNewLine]java`awt`Color`blue]; \
\[IndentingNewLine]NewJPanelSoftBevelBorder[pane, 
        False, \[IndentingNewLine]java`awt`Color`yellow, \
\[IndentingNewLine]java`awt`Color`blue]; \
\[IndentingNewLine]NewJPanelSoftBevelBorder[pane, 
        True, \[IndentingNewLine]java`awt`Color`yellow, \
\[IndentingNewLine]java`awt`Color`blue, \
\[IndentingNewLine]java`awt`Color`red, \
\[IndentingNewLine]java`awt`Color`green];\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \( (*\ Matte\ Border\ *) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<javax.swing.border.MatteBorder\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["javax.swing.border.MatteBorder", 34]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Constructors["\<javax.swing.border.MatteBorder\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"MatteBorder(int, int, int, int, java.awt.Color)\"\>"},
          {"\<\"MatteBorder(int, int, int, int, javax.swing.Icon)\"\>"},
          {"\<\"MatteBorder(java.awt.Insets, java.awt.Color)\"\>"},
          {"\<\"MatteBorder(java.awt.Insets, javax.swing.Icon)\"\>"},
          {"\<\"MatteBorder(javax.swing.Icon)\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {"MatteBorder(int, int, int, int, java.awt.Color)", 
        "MatteBorder(int, int, int, int, javax.swing.Icon)", 
        "MatteBorder(java.awt.Insets, java.awt.Color)", 
        "MatteBorder(java.awt.Insets, javax.swing.Icon)", 
        "MatteBorder(javax.swing.Icon)"}]]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaBlock[\(NewJPanelMatteBorder[pane, 10, 10, 10, 10];\)]\)], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]path = 
        StringJoin[$JavaSwingMaterial, "\<NB(S).GIF\>"]; \
\[IndentingNewLine]icon = NewImageIcon[path]; \[IndentingNewLine]iconWidth = 
        icon@getIconWidth[]; \[IndentingNewLine]iconHeight = 
        icon@getIconHeight[]; \[IndentingNewLine]NewJPanelMatteBorderTileIcon[
        pane, icon];\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \( (*\ Line\ Border\ *) \)], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]NewJPanelLineBorder[pane, 
        4]; \[IndentingNewLine]NewJPanelLineBorder[pane, 8, 
        java`awt`Color`orange];\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \( (*\ Compound\ Border\ *) \)], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]\(NewJPanelCompoundBorder[\
\[IndentingNewLine]pane, \
\[IndentingNewLine]JavaNew["\<javax.swing.border.EtchedBorder\>"], \
\[IndentingNewLine]JavaNew["\<javax.swing.border.LineBorder\>", 
            java`awt`Color`red]\[IndentingNewLine]];\)\[IndentingNewLine]]\)],\
 "Input"],

Cell[BoxData[
    \( (*\ Titled\ Border\ *) \)], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]NewJPanelTitledBorder[
        pane]; \[IndentingNewLine]NewJPanelTitledBorder[
        pane, "\<J/Link\>"]; \[IndentingNewLine]NewJPanelTitledBorder[
        pane, \[IndentingNewLine]"\<J/Link\>", \
\[IndentingNewLine]JavaNew["\<javax.swing.border.LineBorder\>", 
          java`awt`Color`red, 
          5]\[IndentingNewLine]];\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(pane@removeAll[]\)], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JButton <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P1000000001HS0^<SPf8S0^8S0^<c<c03ooooo
ooooogWoool2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVc<c<ofIV
I_mVIVIgIVIV00Cooon8`;R8`;Q8T8P1000000001XS0^<SPf8S0^8S0^6IV
I_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
ooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooooo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoooooc<c<6<c<c4NIVLcoc<c<5lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c1S<c<`00iVIc<c<c<c<
c013c<c<00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<00>IVLc<c<c<c<`0
@lc<c003VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<c<c<c<c<04?<
c<`00iVIc<c<c<c<c03oc<c<5Lc<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c1S<c<`00iVIc<c<c<c<c00@c<c<
100000;<c<`00`000<c<c<c<c006000000C<c<`00000003<c<`200000/c<
c08000000lc<c00000000002c<c<0P0001?<c<`00iVIc<c<c<c<c03oc<c<
5Lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooolc<c1S<c<`00iVIc<c<c<c<c00?c<c<0P0000;<c<`2000000C<c<`0
003<c<c<c<`200001Lc<c08000000lc<c00000000002c<c<0P000003c<c<
0000000000;<c<`200004lc<c003VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<
c003VIW<c<c<c<c<00o<c<`200000/c<c0800002c<c<00@0003<c<`00000
0005c<c<0P000003c<c<0000000000;<c<`2000000C<c<`00000003<c<`2
00005<c<c003VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<c<c<c<c<
01?<c<`200000/c<c0040000c<c<000000001Lc<c08000000lc<c0000000
0002c<c<0P000003c<c<0000000000<0000Dc<c<00>IVLc<c<c<c<`0olc<
c1G<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooooo<c<`Hc<c<00>IVLc<c<c<c<`04lc<c0800002c<c<00@0003<c<`0
00000005c<c<0P000003c<c<0000000000;<c<`2000000?<c<`000000000
0P0001G<c<`00iVIc<c<c<c<c03oc<c<5Lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c1S<c<`00iVIc<c<c<c<
c00Cc<c<0P0000;<c<`010000<c<c000000000G<c<`2000000G<c<`00000
0000003<c<`00P000004c<c<00000000c<c<0P0001C<c<`00iVIc<c<c<c<
c03oc<c<5Lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooolc<c1S<c<`00iVIc<c<c<c<c00Cc<c<0P0000;<c<`01000
0<c<c000000000G<c<`2000000C<c<`00000003<c<`200000/c<c0800002
c<c<0P0001?<c<`00iVIc<c<c<c<c03oc<c<5Lc<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c1S<c<`00iVIc<c<
c<c<c00Cc<c<0P0000?<c<`300003lc<c080000Gc<c<00>IVLc<c<c<c<`0
olc<c1G<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooooo<c<`Hc<c<00>IVLc<c<c<c<`04lc<c0800003c<c<0`0000G<
c<`200002<c<c080000Gc<c<00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<
00>IVLc<c<c<c<`0@lc<c003VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003
VIW<c<c<c<c<04?<c<`00iVIc<c<c<c<c03oc<c<5Lc<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c1S<c<`00iVI
c<c<c<c<c013c<c<00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<00>IVLc<
c<c<c<`0@lc<c003VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<c<c<
c<c<04?<c<`00iVIc<c<c<c<c03oc<c<5Lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c1S<c<`00iVIc<c<c<c<
c013c<c<00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<00>IVLc<c<c<c<`0
@lc<c003VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<c<c<c<c<04?<
c<`00iVIc<c<c<c<c03oc<c<5Lc<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c1S<c<`00iVIc?ooooooo`13oooo
00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<00>IVLcoooooool0@oooo`03
VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<oooooooo04?oool00iVI
c<c<c<c<c03oc<c<5Lc<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c1S<c<`00iVIc?ooooooo`13oooo00>IVLc<
c<c<c<`0olc<c1G<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooooo<c<`Hc<c<00>IVLcoooooool02Oooo`05kno_oooo
kno_kno_oooo00?_knl01?ooono_kno_koooo`?_knl01?ooono_kno_kooo
o`;_knl00oooono_koooo`02kno_00Goooo_kno_kno_knooool00no_k`05
ooookno_ooookno_oooo00;_knl00oooono_kno_k`02kno_00?oooo_knoo
ool02Oooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<oooooooo
00Ooool2kno_00?Ng]k>c/kNg]h00/k>cP;Ng]h01Lk>c/k>e]kNg/k>c/k>
eP02g]kN00?>c/k>c]KNg]h00/k>cP06g]kNc/k>c/k>g]kNc/k>g]kN0/k>
cP04g]kNc/k>g]kNc/k>0]kNgP;>c/h01MkNg/k>c]kNg/k>c]kNgP02c/k>
0]kNgP;>c/h2g]kN00?_knooooooool01oooo`03VIW<c<c<c<c<0?o<c<`E
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
ooooc<c<6<c<c003VIW<oooooooo00Ooool00no_klk>cZf][@05[Jf]00BL
W:F][Jf][JfLW:D3[Jf]00BLW:F][Jf][JfLW:D2[Jf]00JLW:F][Jf][JfL
W:F][JfLW9`4[Jf]00BLW:F][Jf][JfLW:D2[Jf]00FLW:F][JfLW:F][JfL
W:D00jf][@07W9bU[Jf][Jf][Jf]_Kfmc/k>kno_00Soool00iVIc<c<c<c<
c03oc<c<5Lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooolc<c1S<c<`00iVIc?ooooooo`06oooo00K_knoNg]j][Jf<
S8akNg][Jf/FNg]k00=[Jg]kNg]kNg/04W]kN`04Ng^<W9bLc/k>g]kN2?oo
o`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<oooooooo00Koool0
0no_klk>cV][J`02BTYJ00eJFUY:BTY:BUXi>D9:BUXi>D9:BTY:BUXi>D9:
BTXi>D9:BTXi>D800TY:BP05BTYJ>CU2BTY:BTY:BTYJ009:BTX00dY:FTY:
BTY:BP02BTY:00I:BUY:BTY:BTY:BUY:BTY:BUX3BTY:00A:BUY:BTY:BUY:
BTX2BTYJ15YJFP03S8bDg]kNoooo00Ooool00iVIc<c<c<c<c03oc<c<5Lc<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
olc<c1S<c<`00iVIc?ooooooo`06oooo00S_knnm_Ke:BTY[Jf][Jg]JFW=[
Jg]:BTX3>CTi01LY:C4i>CTi>CTi>D9:BUYJFUYJFV]JFUY[Jf]JFV][Jf]J
FV]JFW<i>CUJFUXi>D9JFV/i>CU:BUXi>D9:BUXi>D9:BTX00STi@P08BTYJ
>CTiFUY[Jf][FUY[Jf][FUY[BTY:0UYJJ`07Jf][FUY[Jf]kNg]kFUY[Jf][
g]kN00Soool00iVIc<c<c<c<c03oc<c<5Lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c1S<c<`00iVIc?oooooo
o`07oooo00N][Je:BUYJFV]JFV][Jf][Jg]:BUX00bTY<@03>CTiBTY:BTYJ
009JFV/00eYJFUYJJeYJJ`03FUY[00Y[Jf][Jg/i>CU:BUXi>D9JFUXY:C5J
FUXY:C5:BTX2>CU200a:BUXi>CU:BUXY:BU[Jf]JFV][Jg]JFW=kNa3Wk`1:
DS5[Jg/2FUY[0V][N`03FUY[Jf][g]kN00Soool00iVIc<c<c<c<c03oc<c<
5Lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooolc<c1S<c<`00iVIc?ooooooo`06oooo00?_knn][Jdi>D800UYJJ`05
Jf][Jf]kBTY:61PH>CU2009:BUX2FUYJ01=:BUYJFUYJFV]JFUYJFV][Jf]J
FV][Jf]JFV][Jf/i>D9:BUXi>CUJFV/i>CU:BUXi>CU:BUXi>D800TY:BP04
>CU2BTYJ:BTaFUY[0V][J`03FUYcLg]J[Jda00=[Jf/01eYJJf][Jf][Nf][
JeYJJmkNg^o_k`07oooo00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<00>I
VLcoooooool01_ooo`05kno_W9bLBTY:FUY[Jf][009[Jg/013Ti@RTY<DY:
BTY:BP=:BUX00eYJFUYJJeYJFP03FUY[00][Jf]SFV][Jf][Jg/i>D9:BUXi
>D9JFV/i>CU:BUXi>CT00TY:BP08>CU2BTYJ>CTiFUYJ>CTiFUY[Jf][FUY[
0V][N`0:FUYcJf]kJf]kFUY[Jf][FUY[Ng]kFUYcFUYJc/k>2?ooo`03VIW<
c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<oooooooo00Koool00no_kg]k
S4Y:BP02FUY[0V][N`8i>CT00cTi@TY:FTY:BP03BTYJ00=JFUYJFV]JFUX0
1EYJJ`0?Jf][:BTaFUYJ:BTaFUY[:BTaBTYJ:BTaBTYJ>CTi>CU2BTY::BTa
BTYJ:BTY009JFV/01f][JeYJJf][Nf][Jf][NeYJJf][N`02FUY[00E[Jg][
Jf]:BUZm_LK_knl01oooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003
VIW<oooooooo00Koool00mkNig]kNeYJFP03Jf]k00=kNg]:BUY:BTX00TY:
FP0FFUYJFUY[FUY[Jf][FUY[Jf][Jf]kFUYcNg]kJf]kNg^<Ng]kNg^<FUYJ
FUY[BTY:Jf]kBTY:Jf]kFUYJFUY[FUYJ0UYJJ`04FUYJJf]kBTYJNg]k0g]k
S007S8b<Ng^<Ng]kNg^<Ng]kJf]kNg]k009kNh`00eYJFZf][No_k`07oooo
00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<00>IVLcoooooool01_ooo`05
g]kN_Kfmc/kFg]kNc/kF00;Ng]h00lk>e]kNimkNgP04g]kN00O>c]KNg]k>
c]K>c]KNg]k>c]KNg]h01/k>eP06c/k>c/kFc/k>c/kFc/k>c/kF0lk>cP0<
_Kg6c/k>c/k>c/k>_Kg6c/k>_Kfmc/k>_Kg6c/k>_Kg6c/k>0[fm_@04c/k>
S8b<[Jf]kno_1oooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<
oooooooo00Koool00lk>cZf]]Kfm_@02W9bU0Zf]]@03[Jf]W9bU[Jf]00NL
W:D01YbLW9bLYIbLW9bLYHb<U9bLW0><S9@018b<S8b<U8b<S8b<S0:<S9@3
S8b<00MkNhb<S8akNhb<S8akNhb<S8akNg/00W]kS00:Ng]kNg^<Ng]kNg]k
Jf]kNg]kJf]kNg^<S8b<kno_1oooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<
6<c<c003VIW<oooooooo00Koool02<k>cZf][Jf]]CTi>CTi@W]kNjf]]Kfm
_@:][KD2[Jf]00B][KFLW:F][KFLW:D2[Jf]0YbLY@07S8bDW9bUW9bLW9bU
[Jf][Jfe_Kfm00:][KD01ibLYIbLW8b<S8b<U8b<S8b<U9bLW004S8bD00F<
S8b<S9B<S8b<S9AkNh`00Xb<S007Ng^<BTY:BTYJBTY:S8b<S8bDkno_00Oo
ool00iVIc<c<c<c<c03oc<c<5Lc<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c1S<c<`00iVIc?ooooooo`06oooo
00ONg]jLW:Fm_Ke[Jg]:BTZLW:Fm_Kd01Zf]]@03[Jf][Jfe[Jf]00:LW:D0
1:f][Kfma]kNg^o_k`[oool00mkNikfmaYbLY@02S8bD00J<S8b<S9B<S9B<
S9B<S8b<S9@3S8b<0W]kS005FUYJ>CTiJf]kS8b<W9bL00Soool00iVIc<c<
c<c<c03oc<c<5Lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooolc<c1S<c<`00iVIc?ooooooo`06oooo00WNg]j][Jfm
_LJm_Kfm_LJ][KFm_Kf][KFm_Kd01Jf]]@04W9bU[Jf]c/k>kno_0_ooo`09
knogg]kN_Kg6_Kfm[Jfe[Jf]W9bU[Jf]W9bU00:][KD02<k>c]kNino_kmkN
g[fmaZf]]IbLYG]kS0:<S9@01IbLW8b<U8b<U8b<S8b<U002S8b<00EkNhb<
S8b<S8akNhb][Jd02?ooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003
VIW<oooooooo00Koool01^o_kjf]]Kfma[fmaZf]]Kfm_@J][KD00ibLYJf]
[MkNgP02knog00CNg^Nm_LJLW:FLW9`3W9bU00BLW9bLW:FLW:FLW:D3W9bL
0hb<U0:LW:D2_Kg600?>c/jLW:F<S9@018b<U003S8b<S8bDNg^<00:<S8`0
0g]kS7]kNkfm_@08oooo00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<00>I
VLcoooooool01_ooo`09knog[Jf]c/k>[Jfe_Kfm[Jfe_Kg6[Jfe_Kfm00:]
[KD01Zf][Lk>c^o_mno_mlk>cZf][@:LW:D00jf]]Jf][Jf][@02W9bU00>]
[JfLW:FLW:D00ibLY@0;W9bLW9bUW9bLW9bUS8bDW9bLS8bDW9bL[Jfec/kF
c/k>00F<S9@00hb<S8b<U7]kS002S8b<00=kNhbm_Kgoool01oooo`03VIW<
c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<oooooooo00Ooool00kfm_Kfm
a[fm_@02_Kg600>][KFm_Kf][KD00Zf]]@0;kno_oooog]kN[Jfe[Jf][Jfe
[Jf][JfeW9bU[JfeW9bU00:][Jd029bLYJf][IbLYIbLYJf][IbLYIbLW9bL
Y@:LW9`02YbLYHb<U9bLW9bLW8b<U9bLYKfma]kNgYbLYHb<S0><S9@01Xb<
S8b<U8b<S8b<U7]kNlk>cPSoool00iVIc<c<c<c<c03oc<c<5Lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c1S<
c<`00iVIc?ooooooo`07oooo00Fm_Kfm_LJm_Kf][KFm_LH00[fm_@06[Jfe
_Kfmknogknog_KfmW9bU1:f]]@:][Jd019bLYJf]]IbLYJf]]@:LW:D00jf]
[IbLYIbLY@04W9bU00FLW9bLW:FLW9b<S9BLW:D00hb<U003[Jfec/k>[Jf]
00:<S9@01hb<S8b<U8b<S8b<S8b<U7]kS=kNgP08oooo00>IVLc<c<c<c<`0
olc<c1G<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooooo<c<`Hc<c<00>IVLcoooooool01oooo`03_Kg6_Kfm_Kg600:m
_Kd01KfmaZf]]Jf]]Oooono_k`02[Jfe00>m_Kf][KF][KD00Zf]]@06[Jf]
[Jfe[Jf][Jf][JfeW9bU0Zf][@:LW:D00jf][IbLYIbLY@02W9bL00NLW:FL
W9bLW9bLW:F<S9BLW:FLW9`00Xb<U005W9bU_Kg6W9bUS8bDW9bL00><S9@2
S8b<00?Ng]koooooool01_ooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<
c003VIW<oooooooo00Ooool03<k>c[fm_Kfma[fm_KfmaZf]]Kfm_No_mmkN
ikfm_Jf]]KfmaPJ][KD02:f][Jf]]Jf]]Jf][Jf]]IbLYJf]]Jf][@BLW:D0
1:f][IbLYIbLYIbLY@:LW9`019bLYHb<U9bLW9bLY@:<S9@00ibLYJf]]Hb<
U004S8bD00>LW9b<S9C_knl02?ooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<
6<c<c003VIW<oooooooo00Ooool01<k>eZf]]Lk>c[fmaP:m_Kd02Lk>c/k>
e[fmaZf]]Kfm_Jf]]Kfm_Jf]]Kfm_@05[Jfe00V][Jf][KFLW:F][KF][JfL
W:F][JfLW:F][Jd019bLY@03W9bLW9bUW9bU00:LW9`01IbLYHb<U8b<U9bL
W8b<U002W9bL00><S9BLW9b<S9@00hb<U0Woool00iVIc<c<c<c<c03oc<c<
5Lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooolc<c1S<c<`00iVIc?ooooooo`07oooo00?Ng]j][KFm_LH00kfmaP08
[Jfe_Kfm_Kfm[Jfe_Kg6_Kfm[Jfe_Kg60jf]]@03_Kfm[Jfe[Jfe00:][KD0
2:f][IbLYIbLYIbLW9bLYIbLW9bLYJf][@FLW:D019bLW9bLYIbLW9bLY@:L
W9`01Hb<U9bLYHb<U9bLW8b<S003S8bD0YbLW0Woool00iVIc<c<c<c<c03o
c<c<5Lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooooolc<c1S<c<`00iVIc?ooooooo`07oooo00?_knnm_Kg>c/h00[fm
aP03W9bUW9bL_Kg600:m_Kd00kfmaZf]]KfmaP02[Jfe00>m_Kf][KF][KD0
0jf]]@08W9bU[Jf]_Kfmc/kFg]kNc/kFc/k>[Jf]0ibLY@0>[Jf]W9bUW9bU
W9bUW9bLW9bUW9bLW9bUS8bDW9bUS8bDW9bLS8bDJf]k0Xb<U003W9bLS8bD
[Jf]00Woool00iVIc<c<c<c<c03oc<c<5Lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c1S<c<`00iVIc?oooooo
o`07oooo00O_knn][KG>c/jm_LK>c/ikNg^LW:D00[fmaP04_Kfm[Jfe_Kfm
[Jfe0[fm_@:][KD01KfmaZf]]Jf]]Jf][Lk>eP02oooo00?_koO_kno_knl0
0^o_m`03g]kW_KfmW9bL00BLW:D03:f][IbLW9bLYIbLW9bLYIbLW9bLYHb<
U9bLYF][Jg]kNibLW0:<S9@00kfm_Oooooooo`07oooo00>IVLc<c<c<c<`0
olc<c1G<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooooo<c<`Hc<c<00>IVLcoooooool01oooo`03knog_Kfmc/kF00:m
_LH02EYJJkfm_Kfma[fm_Kfma[fm_Kfma[fm_KfmaP02[Jfe00Vm_Kf][KF]
[KF][KG_knooooo>c/j][KF][Jd00YbLY@:][KD2g]kW00Bm_KfLW:FLW:F]
[Jd3W9bU00FLW9bLW:FLW9bLW:F<S9@00YbLW006Jf][FUY[W9bUS8bDS8b<
_Kg62Oooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<oooooooo
00Soool01Kfm_Lk>c[fma[fm_EYJFP03_Kg600Fm_Kfm_LJm_Kf][KFm_LH0
0[fm_@:][KD01;fm_Lk>e_ooojf]]@:][Jd02Jf]]Jf][Jf]]IbLYJf][IbL
YKfmaZf]]Jf][@04W9bU00B][JfLW:FLW9bLW:D3W9bL00NLW:E[Jg]JFUZL
W9b<S9B<S8c>c/h02Oooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003
VIW<oooooooo00Soool01Kfma/k>e/k>c[fmaUYJFP04_Kg60[fm_@04_Kg6
_Kfm_Kg6[Jfe0[fm_@03[JfeW9bU[Jfe00:][KD01;fm_Jf]]Jf]]Jf][@:]
[KD01ibLYJf][Hb<U7]kNjf]]IbLYJf][@05W9bU00ZLW9bLW:FLW:FLW:Ek
Ng]:BUZLW:FLW9b<S9CNg]h9oooo00>IVLc<c<c<c<`0olc<c1G<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`H
c<c<00>IVLcoooooool02?ooo`06_Kg6c/k>_Kg6c/k>FUY[_Kfm0[fmaP0=
_Kfm_Kg6_Kfm_Kg6_Kfm[Jfe_Kg6[Jfe_Kg6_KfmJf]k[Jf]_Kfm00F][KD0
2Zf][Jf]]Jf][Jf]]EYJFV][Jjf]]Jf][IbLYJf][@FLW:D2W9bL00NLW:EJ
FV][Jf^LW9bLW:F<S9CNg]h02Oooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<
6<c<c003VIW<oooooooo00Soool2c/k>00Nm_LKNg]i[Jg^][Jg>c/jm_LK>
c/h00[fmaP07_Kfm_Kg6_Kfm_Kfm_Kg6[Jfe_Kg600:LW:D6[Jfe00f][Jf]
[KF][KF][Je[Jg^LW:F][KFLW:F][JfLW:F][JfLW:F][Jd00YbLY@09W9bL
W9bUW9bUFUYJS8b<W9bUW9bLS8bDkno_00Woool00iVIc<c<c<c<c03oc<c<
5Lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooolc<c1S<c<`00iVIc?ooooooo`08oooo00ONg]jm_LK>c/jm_LJ][KF<
S8c>c]H01KfmaP09_Kfm_Kg6_Kfm_Kfm_Kg6[Jfe_Kfm_Kg6_Kfm00J][KD0
0jf][IbLYLk>cP02[Jfe00>][JfLW:F][Jd01ibLY@:LW9`01EYJJibLYIbL
W9bLYIbLW00:oooo00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<00>IVLco
ooooool02?ooo`03g]kN_Kg6c/k>00;>c/h017]kS;fma[fma/k>cPBm_LH0
1kfm_Kfma[fmaZf]]Kfm_KfmaZf]]@02c/k>00>][KFm_Kf][KD00Zf]]@07
_Kfmc/k>[Jfe[Jf][JfeW9bU[Jfe00:LW:D01:f][IbLYIbLYJf][@:LW:D0
0jf][Hb<U8b<U002W9bL0YbLY@[oool00iVIc<c<c<c<c03oc<c<5Lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<
c1S<c<`00iVIc?ooooooo`08oooo00[Ng]jm_LK>c]K>c]KNg]jm_Kf<S9C>
c]Jm_LK>c/h4_Kg600Fm_Kfm_LJm_Kf][KFm_LH00Zf]]@>m_LH3_Kfm0Zf]
]@:][Jd00ibLYJf]]IbLY@02[Jf]00>LW:F][JfLW:D019bLY@06FUYJW9bU
[Jf]W9bLW9bU[Jf]2_ooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003
VIW<oooooooo00Soool02No_kkfma/k>eXb<S7]kS;fma[fm_Jf]]Lk>eP02
_Kg600?>c/jm_LJm_Kd00[fmaPBm_Kd01Kfma[fm_Jf]]Jf]]Kfm_@06[Jfe
0jf][@05[JfeW9bU[Jf]W9bU[Jf]00:LW:D02:f][Hb<U3Ti@Xb<S6][Ng]k
S9bLYKfm_@[oool00iVIc<c<c<c<c03oc<c<5Lc<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c1S<c<`00iVIc?oo
ooooo`09oooo00Vm_Kg>c/i:BTXY:BV][Jg>c]Jm_Kfm_LK>c/h00kfmaP0:
c/k>_Kg6_Kfm_Kg6_Kfm_Kg6_Kfm[Jfe_Kfm_Kg60Zf]]@03_Kg6[Jfe[Jfe
00B][KD00jf][Jf]]IbLY@02[Jf]00bLW:F][JfLW:F][JfLW:F<S8a:BTY[
Jf/Y:BU[Jf^LW:Fm_LH:oooo00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<
00>IVLcoooooool02Oooo`07_Kg6c/kF_Kg6_Kg6c/kF_Kg6c/kF00:m_LH0
1Lk>c[fma/k>c[fma[fm_@03_Kg600Vm_Kfm_LJm_Kfm_LJ][KFm_LJm_Kf]
[KFm_Kd00Zf]]@04_Kfm[Jfe[Jfe[Jfe0Zf][@0>[JfeW9bU[JfeW9bU[Jf]
W9bU[Jf]Ng^<BTY:W9bUS8b<W9bUS8bDc/k>2_ooo`03VIW<c<c<c<c<0?o<
c<`Ec<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVKoooooc<c<6<c<c003VIW<oooooooo00Woool00kfma]kNg/k>cP02c/k>
00K>c]Jm_LK>c/k>c/jm_LK>c/h2_Kg600?>c/jm_LJm_Kd00[fmaP06_Kfm
_Kg6_Kfm_Kfm[Jfe_Kg60Zf]]@03_Kfm[Jfe[Jfe00B][KD2[Jf]00V][KFL
W:F][KF][JfLW:F][JekNg]JFUZ][Jd00YbLY@03W9bLc/kFoooo00Woool0
0iVIc<c<c<c<c03oc<c<5Lc<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooolc<c1S<c<`00iVIc?ooooooo`09oooo00[>
c/kNg]k>c]K>c/k>c]Jm_LK>c]K>c/jm_LK>c/h2c/kF0kfmaP09c/k>_Kg6
_Kfm_Kg6_Kfm_Kg6_Kfm_Kg6[Jfe00:m_Kd00jf]]Kfm_Jf]]@03[Jfe00b]
[Jf][KF][KFLW:F][Jf][KFLW:F][Jf][KE[Jf]JFV^][Jd2W9bU00>LW9cN
g]koool02Oooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<oooo
oooo00Woool4c/kF00[>c/k>c]Jm_LK>c]K>c/jm_LK>c/jm_LK>c]K>c/h4
_Kg600bm_Kfm_LJm_Kfm_LJ][KFm_LJ][KFm_LJ][KFm_Kf][KFm_Kd3[Jfe
00Z][Jf][KF][Jf][JfLW:F][KFLW:F][KEJFV][Jg/2[Jf]00>LW:F][Jg_
knl02_ooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<oooooooo
00Woool01MkNg/k>c/k>e/k>c/k>eP02c/k>00G>c]Jm_LK>c/k>c]Jm_LH0
0/k>cP03_Kg6c/k>c/k>00>m_LH4_Kfm00Vm_LJ][KFm_Kf][KFm_Kf][KFm
_Kf][KFm_Kd01:f]]@:][Jd2[Jfe00MJFUYkNg^][KFLW:F][JfLW:G_knl0
2_ooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<oooooooo00Wo
ool00mkNg/k>e/k>eP03c/kF00K>c/k>c]K>c]K>c/jm_LK>c]H2_Kg600C>
c]Jm_LJm_LK>c/h5_Kg600Vm_Kfm_LJm_Kfm_LJm_Kf][KFm_LJm_KfLW:D0
0jf]]@0<[Jf][Jfe[Jfe[Jf]W9bU_KfmBTYJS8b<[Jf]W9bU[Jf]W9bU2ooo
o`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<oooooooo00Woool0
0mkNg/k>e/k>eP02c/kF00O>c/k>c]K>c]Jm_LK>c]K>c/jm_LH00/k>cP03
_Kg6c/k>_Kg600:m_LH02[fm_Kfma[fma[fm_Kfma[fm_KfmaZf]]Kfm_Kfm
aP:][KD3[Jf]00Bm_Kf][KF][KF][Jd3[Jfe00I:BTZ<S9B][JfLW:F][KF]
[Jd;oooo00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<00>IVLcoooooool0
2Oooo`06kno__Kg6g]kNc/kFc/k>c/kF0lk>cP05_Kg6c/kFc/k>_Kg6c/k>
00:m_LH01/k>c[fma[fm_Kfma[fm_KfmaP>m_Kd01Jf]]KfmaZf]]Jf]]Kfm
_@02[Jfe00>LW:Fm_Kf][Jd00Zf]]@>][Jd01jf]]CTi@YbLYJf]]IbLYJf]
[Kfm_@0;oooo00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<00>IVLcooooo
ool02Oooo`03kno_c/k>g]kN00?>c]H00lk>c/k>e/k>eP02c/k>00G>c]Jm
_LK>c/jm_LK>c/h00kfmaP03c/k>_Kg6_Kg600>m_LH4_Kfm00F][KFm_Kf]
[KF][JfLW:D01Jf]]@03[Jf][JfeBTY:00>LW:D00jf][Kfma_ooo`0:oooo
00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<00>IVLcoooooool02_ooo`03
_Kg6g]kNc/kF00;>c]H00no_koooooooo`0:oooo00?_koOoooooool02ooo
o`03c/kF[Jfe[Jfe00>][KD2[Jf]00Hi>D:][Jf][JfLW:F][Jfm_LH;oooo
00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<00>IVLcoooooool02_ooo`08
c/k>g]kWc/kFg]kN[Jfe_Kfmc/kFg]kN0]kNi`;Ng]h00mkNimkNg]kNgP05
g]kN00S>c]KNg]k>c]K>c/kNg]k>c]K>c/k>c]H2c/k>0[fmaP:][KD00kfm
_Jf]]Jf][@02[Jfe00NLW:Di>D:m_KfLW:F][JfLW:G>c/h02oooo`03VIW<
c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<oooooooo00[oool02<k>e]kN
g]kNg/k>e[fm_F][Nno_kibLY@9JFUX025YJJf][JeYJFUYJFV][JeYJJeYJ
FUYJJ`EJFUX2FUY[0eYJFP03FUY[FUYJJf][00:m_Kd3[Jfe00Fm_Kf][KF]
[KFLW:Di>D800Zf]]@03[Jf]W9bUg]kN00_oool00iVIc<c<c<c<c03oc<c<
5Lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooolc<c1S<c<`00iVIc?ooooooo`0:oooo017>c/kNg^O>c]KNg]jm_LIk
Ng_Ng^N][Jd0000i>CTH61PQ8AP0000i>CT0000H61PY:C400QPH6004>CTi
61PH:BTY:BTY0`000006:BTYFUYJBTY:0000>CTi_Kg60Zf]]@09_Kfm[Jfe
[Jfe[Jfe_KfmS8bDBTY:_KfmW9bU00:][Jd00mkNioooooooo`09oooo00>I
VLc<c<c<c<`0olc<c1G<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<00>IVLcoooooool02_ooo`09g]kN
c/kFc/kFg]kWc/kFJf]kg]kN[Jf]61PH009:BTX043Ti>DY:BTY:BSTi>DY:
BTYB<CTi@TY:BSTi>DY:BSTi>DY:BTYB<EYJFQPH65YJFP9kNg/01aPH63Ti
@/k>cZf]]KfmaZf]]Kfm_@03[Jfe00><S8aJFUZ][KD00Zf]]@03[Jf]kno_
oooo00[oool00iVIc<c<c<c<c03oc<c<5Lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c1S<c<`00iVIc?oooooo
o`0:oooo00?Ng]k>c]KNg]h00/k>eP0>Jf][g]kN_Kg60000FUYJBTY:Ng]k
>CTiFUYJJf][BTY:BTYJFUYJBTY:0UYJFP0>BTYJFUYJFUYJJf][0000>CTi
[Jf]Ng]k61PH>CTic/k>_Kfm[Jfe_Kg60jf]]@08_KfmNg]kFUY[_Kfm[Jf]
[Jfe[Jf]kno_2oooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<c003VIW<
oooooooo00[oool5g]kN00>LW:G>c]K>c/h00hb<S003Ng^<S8b<Ng]k00=k
Ng/00g]kS8b<S7]kN`02Ng]k00YkNhakNg]kNg]kNhakNg^<S8a[Jg]kNg^<
S9Bm_LH2_Kfm00F][KFm_LJ][KF][KFm_Kd00YbLY@B][KD<oooo00>IVLc<
c<c<c<`0olc<c1G<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooooo<c<`Hc<c<00>IVLcoooooool02_ooo`06kno_c/k>
g]kWc/k>c/kFg]kN0/k>eP03g]kWg]kNg]kW00?Ng^L2g]kN00KNg^O>c]K>
c]KNg^O>c]KNg]h5c/kF00Zm_LK>c/k>c/k>c/j][KFm_LJ][KFm_Kf][KFm
_Kd2[Jfe00Jm_Kf][KF][KF][Jf][KFm_Kd<oooo00>IVLc<c<c<c<`0olc<
c1G<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooooo<c<`Hc<c<00>IVLcoooooool02_ooo`06kno_c/kF_Kg6:BTaFUY[
kno_0]kNgP03c/kFg]kNc/kF00K>c]H2c/k>00>m_LK>c]Jm_LH00/k>cP04
_Kg6c/k>_Kg6c/k>0kfmaP03c/k>_Kfm_Kg600:m_Kd01jf]]KfmaZf]]Kfm
_IbLW3Ti@UYJFP02_Kfm3?ooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<
c003VIW<oooooooo00_oool02^o_kmkNgYbLYKfm_No_kmkNimkNg]kNimkN
g]kNi`cNg]h02lk>e]kNg/k>c]kNg/k>e/k>c]kNg/k>c/k>e/k>c/k>eP05
c/k>00Fm_LK>c/j<S8bLW:G>c/h03Oooo`03VIW<c<c<c<c<0?o<c<`Ec<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooooo
c<c<6<c<c003VIW<oooooooo04?oool00iVIc<c<c<c<c03oc<c<5Lc<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<
c1S<c<`00iVIc?ooooooo`13oooo00>IVLc<c<c<c<`0olc<c1G<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`H
c<c<00>IVLcoooooool0@oooo`03VIW<c<c<c<c<0?o<c<`Ec<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<6<c<
c003VIW<oooooooo04?oool00iVIc<c<c<c<c03oc<c<5Lc<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c1S<c<`0
0iVIc?ooooooo`13oooo00>IVLc<c<c<c<`0olc<c1G<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Hc<c<AiVI
c?o<c<`Gc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
ooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooogOoool01Lc<c?ooohS0^8S0^4R@R0010000000018S0^<SPf8S0
^8S0^?mVIVKoIVIVNFIVIP04c<c<R<2hR<2hB9280@00000000B8`;S8h=R8
`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
ol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o
`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0
^058T8P1000000001HS0^<SPf8S0^8S0^<c<c03oooooooooogWoool2R<2h
0DR@R04000000006R<2hb>3HR<2hR<2hIVIVc<c<ofIVI_mVIVIgIVIV00Co
oon8`;R8`;Q8T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
ooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooooo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
ooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooooo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooolc<c17<c<`200000/c<c0030000c<c<c<c<008000000lc<
c00000000003c<c<0P0000?<c<`200000lc<c0800003c<c<0P000003c<c<
0000000000@000000lc<c00000000002c<c<00<0003<c<c<c<`00P000003
c<c<0000000000?<c<`200000lc<c0800003c<c<0P0000?<c<`400000/c<
c0800003c<c<0P000?o<c<`Bc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<4Lc<c08000001Lc<c00000000000
0<c<c002000000?<c<`0000000000lc<c0800003c<c<0P0000?<c<`20000
0lc<c08000000lc<c00000000005c<c<0P000005c<c<000000000000c<c<
008000000lc<c00000000003c<c<0P0000?<c<`200000lc<c0800002c<c<
0P0000;<c<`2000000?<c<`0000000000lc<c080003oc<c<4/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c17<
c<`2000000G<c<`000000000003<c<`00P000003c<c<0000000000D00003
c<c<0P0000?<c<`200000lc<c08000000lc<c00000000005c<c<0P000005
c<c<000000000000c<c<008000000lc<c0000000000500000lc<c0800003
c<c<0P000003c<c<0000000000K<c<`70000olc<c1;<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<`Ac<c<0P00
0005c<c<0000c<c<0000c<c<00800002c<c<0P000003c<c<0000000000C<
c<`200000lc<c0800003c<c<0P000003c<c<0000000000G<c<`2000000G<
c<`0003<c<`0003<c<`00P0000;<c<`2000000?<c<`0000000001<c<c080
0003c<c<0P000003c<c<0000000000O<c<`2000000?<c<`000000000olc<
c1?<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooooo<c<`Ac<c<0P000005c<c<0000c<c<0000c<c<00800002c<c<0P00
0003c<c<0000000000C<c<`200000lc<c0L000000lc<c000000000040000
00S<c<`00000003<c<`0003<c<`0003<c<`200000/c<c08000000lc<c000
00000004c<c<0P0000?<c<`2000000?<c<`0000000001lc<c08000000lc<
c0000000003oc<c<4lc<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c17<c<`4000000?<c<`0000000000P0000;<
c<`2000000?<c<`0000000001<c<c0800003c<c<0P0000?<c<`2000000?<
c<`0000000001Lc<c0@000000lc<c0000000000200000/c<c08000000lc<
c00000000004c<c<0P0000?<c<`2000000?<c<`0000000001lc<c0800000
0lc<c0000000003oc<c<4lc<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooolc<c17<c<`4000000?<c<`0000000000P00
00;<c<`2000000?<c<`0000000001<c<c0800003c<c<0P0000?<c<`20000
00?<c<`0000000001Lc<c0@000000lc<c0000000000200000/c<c0800000
0lc<c00000000004c<c<0P0000?<c<`2000000?<c<`0000000001lc<c080
00000lc<c0000000003oc<c<4lc<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c17<c<`300000lc<c0<00003c<c<
0`0000G<c<`200000lc<c0800003c<c<0P000003c<c<0000000000G<c<`3
00000lc<c0<00003c<c<0`0000G<c<`200000lc<c0800002c<c<0P0000;<
c<`200000lc<c0<0003oc<c<5<c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c17<c<`300000lc<c0<00003c<c<
0`0000?<c<`6000000?<c<`0000000000lc<c08000000lc<c00000000004
000000C<c<`0000000000003c<c<0`0000?<c<`300000lc<c0H000000lc<
c00000000003c<c<100000C<c<`30000olc<c1C<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
ooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooooo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
0?ooooooooooMoooo`05c<c<ooooR<2hR<2hB928004000000004R<2hb>3H
R<2hR<2hofIVI_mVIVIiIVIV00C<c<b8`;R8`;Q8T8P1000000000hS0^<SP
f8S0^03oR<2hohS0^7f8`;P1B9280@00000000B8`;S8h=R8`;R8`;PF0020
0`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X801X801X82
00N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<1
3H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL2
0QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:
0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDU
S@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?
0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B
1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7
>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL3
24:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI
0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YB
W@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO
10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaP
XPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eU
Y0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW
3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY
0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@
OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l0
0a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@B
S;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<C
T[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK
]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T0
11FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l
5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o
5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P4
002000>KYo4c@jDc@jD02C=3Y@H0080300600P02P00400:100>100>100>1
0`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49
P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:6
0P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P0
0`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<4
8X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h3
1BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`
T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLe
T`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF
0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P3
2DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:
CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP03
2eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<
GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R
008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU
10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X
3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@
NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhA
PJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/004
4XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?
/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je
0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN
^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<F
Y[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm
5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0<008001i^WlOooohij]ZJKa;>YdZRM
b;>YdP02YY_400Fl^=g^k_CZjO7ooolc@jD01@00P0<00H0200:000@00X40
0h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2
008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25
108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN8
0aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<4
88/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh5
9hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T004
1RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLe
TPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE
0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4
V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:
C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM
2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<
G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=
HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU
0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?
L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@
N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d0
0a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<B
R;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>
/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd
0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM
]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<E
Y;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d3
5jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H
]<0P00000QRd`10000026;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^080080019^WlOooofaJYJnUbP:l^=d02_omok>Yd_oooooookbhgIN:_:RM
b>KVk?oooc=3Y@@0080300600P02P00400:100>100>100>10`04P@801H40
1005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;
P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>7
0QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<I
R@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@4
98`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5
:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I42
1S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC
00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H0
10Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9
AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@
W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP03
2eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ43
35jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S
0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H2
3VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ003
3g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l
[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<A
Pjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa
4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc
0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H3
59Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<E
WkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX
^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G
[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=Q8T8Q8T8P034R@
R0030000b>3HB92800e8T8P0100001Rd`1Rd`<SPf0i8T8P00`0001Rd`1Rd
`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00;VjOaooooZ9g8
oooo/jWBH4bJSWZfN6F^Z9g8oooooogo00?oool00c=3Y@00P000P0030020
0`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X801X801X82
00N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<1
3H@30@j50`8?Q@8248D3oooo0P8AQP<24XH20Q>600@24hL258L258L258L3
0QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^9
0`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@U
S@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?
10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHc
TPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0Lh
U0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G
246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI
0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:
DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil0
0`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<
Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=
IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^
Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT0
10mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/
47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_
4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:<
/@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`03
4i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@D
V[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i
5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`0
11J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa
_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038
h=P03HS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000jKYo7ooooooooKg>aP
C9ZCQKZcZM:l^=ePC9ZISkjVVlC8`moooolc@jD600200oooo`800X000`02
POooooooo`02oooo0P04P@0300F1oooo00F200<01X84oooo00<1288128?o
ool00oooo`<12X<01_ooo`4;Q04;Q04<Q?ooo`4<Q0813H@01?ooo`4>QOoo
o`4>Q@823hD01?ooo`8@QOooo`8@Q@824HH00oooo`8AQP8BQP020Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000C8h=R8`;R8
`;R8`;P6000018S0^003B9280000b>3H00:8`;P900000XS0^005B9280000
6;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P3002000jKYo7ooonl^=fISkkooooFdMgKg>cco_nVVlC^
k_B5M[2CQK[ooolc@jD4002000Ooool00H000H000H3oool00X3oool00`03
P@06oooo00B100B100F1oooo00F20P06PP08oooo00N200N20@N2oooo0@R2
oooo0@R30`49P`04oooo0@Z30@Z3oooo0P4;Q0030@b4oooo0@b400813H@0
1?ooo`4>QOooo`4>Q@823hD00oooo`8@QOooo`03oooo0P8AQP<24XH20Q>6
00@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV8
0aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@4
8h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh0
0`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A
0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`Lf
T`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF
0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP0
0`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:
Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh3
2eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aM
X@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeR
X`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V
0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP3
3g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@
Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P03
4H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4B
R[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb
008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne
11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh
5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<F
Yk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG
[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<001<SPf8S0^8S0
^8S0^0H00004R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P0
1@0008S0^8S0^4R@R00000026;C000C8h=R8`;R8`;R8`;P2000018S0^080
0002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0`00P00?VjOaooooVHnnUhZle=?XkjbcogIkkYn[FeRUYY_4UYoBH4bJ
_;SMoooo<d>U00<008001oooo`01P001P001P?ooo`02P?ooo`0300>100Ko
ool01840187oool01H7oool200J200Soool01h801h811h;oool128;oool1
28<30@V300Woool12X?oool12h?oool12hCoool138Coool00P4=Q004oooo
0@j5oooo0@j50P8?Q@04oooo0Q25oooo0Q25108AQP<24XH20Q>600@24hL2
58L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV9
00@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@T
S0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZ
S`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86
<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<0
0`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04
242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6
V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L
00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;
Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<
GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<3
3FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>
KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?
LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/
111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63
[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4B
R[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<3
4i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<D
VKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO
^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk
0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN_
_P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h
00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@
R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h0P0000>8`;P014R@
R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000ZK
Yo7ooonGR[ajK:ZcanRYKZ38`mnCQKYKAY>ISkh2N6F^00A29hF_YL[ooolc
@jD400200`01P003oooo00:000:100Coool200B100?oool01H7oool00`06
PPCoool00`48PP48P`48P`030@V300Woool12X?oool12h?oool12hCoool1
38Coool00P4=Q004oooo0@j5oooo0@j50P8?Q@03oooo0Q25oooo00?oool2
0Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP3
5hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@P
R`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDW
SP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6
;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB
1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D3
23fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH
2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<
V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;
E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaL
X00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQ
XPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D3
3VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`
Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1h
ZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@03
4H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8
/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb
00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@3
4iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg
00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT
^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G
[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd
`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P0
1HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^003R<2h1000
00B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2002000>KYo7oooooool00_ooo`0:ojf`ogIknLgDoNg^ooooYY_4QGJ`
_;SMoooo<d>U1@00P0<00H000oooo`02P002P@0300>100?oool0187oool0
0P05P@0400F2oooo00J200J20P07PP030@N2oooo0@R2008128<3oooo0P4:
P`07oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?ooo`4>QOooooooo`82
3hD01_ooo`8@QOooo`8@Q@8AQ_ooo`824HH30Q:60P8CQP040Q>70QB70QB7
0QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ9
0`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d4
98d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl0
0`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6
<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7
>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1
U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT0
10U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L
2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO
2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaO
X@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`03
3FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>
KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y
3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0
111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64
[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;
/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<C
TK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ
]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP
^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`4
5ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n
00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B928
0000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P00000
0QRd`003b>3HR<2hR<2h00B8`;P200001HS0^004B92800006;C06;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0<008002Z6/l_W=e>8V??Be_n8V
??A]OOcSjOoooog]k_n]/0;oool00c=3Y@00P000P00400200`01P003oooo
00:000:100?oool200B100Goool01H401H401H;oool00P06PP?oool20@R2
00<128?oool12H<00P49P`812X<01?ooo`4;P`4;Q?ooo`8138@01oooo`4=
Q04=Q?ooo`4>QOooo`4>Q@02oooo00<23hD248D248D01?ooo`040Q660Q:6
0Q:60Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<G
R0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;
0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>
00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_
T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87
=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8
?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9
A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK
0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]D
WP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP
00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R
3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>
JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X
3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ
0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<A
PJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`
0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[80
0a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<C
UKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL0
11FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj
0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]
_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C0
00?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005
R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8`;P40000
18S0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_ARK_omoon]/?cSjOoooc=3
Y@0700200`01P003oooo00:000:100<00h4300B10P05P@0400F200J200J2
00J20P07PP050@N20@R20@R2oooo0@R300<12H<30@Z300<12h<12h@12h@0
0`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<3
6hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=
12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5
:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9
AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YA
W@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]G
W`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW
3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mc
Z@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@
OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hA
Q:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H0
11BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ
_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P03
5k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R000
0<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H
]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008000i^WlOK8c>8V
?002ojf`00OO92koY9kf_<Go[K3^Nhcooolc@jD02000P0<00H000oooo`02
P002P@0300>10`04P@801H401005PP06PP06PP06PP801h801@47PP48PP48
P_ooo`48P`030@V300Coool12X<12X<12h<20@^40`4<Q0<13H@30@j50`8?
Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP3
5hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX3
11n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DW
S@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y02
1Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP03
1cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`Lk
U@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`04
2D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX3
2T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M
00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ03
35^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<
HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eW
Y0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>
L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX3
3gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]
0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl3
4XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8B
SK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C
]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<D
W;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T3
5J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm
0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l3
5k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h2@0000:8
`;P01DR@R00001Rd`1Rd`<SPf003R<2h0P0000B8`;P200000XS0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008000i^W
lOW=e?N9U`02oooo00Oo[K3Q5SCoMW_oY9kR9ScoRGlc@jD02000P0<00H00
0oooo`02P002P@0300>10`04P@801H401005PP06PP06PP06PP801h801047
PP48PP48PP48P`Coool30@Z300<12h<12h@12h@00`4<Q0813H@01?ooo`4>
Q@4>Q@4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF7
0P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<L
RP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@85
9Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/
S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHc
TPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU003
1cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G
0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8
V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:
DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]H
W`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<
H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=
IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^
Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010md
Z@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]
47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_
00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@04
4Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c
4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LD
VkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i
00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[
_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa
_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P0
0XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008001i^WlOoooo>P
[_ARK_ooooN9UoW=e002oooo00?cX:kooolc@jD02000P0<00H0200:000@0
0X400h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R2
0@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD3
0Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN8
0aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@O
R`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd5
9hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_
T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`Ld
TPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD3
23bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3
V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;
VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@03
2eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aK
X08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R
00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@3
3FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W
00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mg
ZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<A
P:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7
/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb
0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@3
4iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg
0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS
^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G
[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc
_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P03HS0^005B9280000
6;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P3002000^KYo7oooooRGooooocX:kaTj7ooooooOocX:ko
no`c@jD02000P0<00H0200:000@00X400h400h400h4300B10P05P@0400F2
00J200J200J20P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^4
0@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L2
58L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@3
6XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@T
S@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZ
S`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y40
10HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`Lh
T`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G
246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6
V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:
DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;
Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ42
35nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS
00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH0
10i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?
LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m
[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P03
4HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[43
4X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c
0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH2
59Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^003
5J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY
_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G
/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<0?b>3H00<00038h=S8h=P03LSP
f00300006;C06;C000o8h=P00`0001Rd`1Rd`002R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1000P0>KYo401_oooo>P[_Be_oJlaO_IfS=3Y@T00803
00600P02P00400:100>100>100>10`04P@801H401005PP06PP06PP06PP80
1h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=
Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`82
5XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X3
0af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=
0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l3
1Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86
<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`Li
U0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8
@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T3
2DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M
0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l4
2eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R
362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT
00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>
KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T3
3gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n
[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`03
4HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:<
/Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B
]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g
59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@04
5J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`F
ZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG
/Kl00aNb_`<G/klf6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^1H0
080300600P02P00400:100>100>100>10`04P@801H401005PP06PP06PP06
PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b4
0`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8E
Q`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<3
78X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd2
1BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5
;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86
<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@0
0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1
U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9
B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M
2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;
F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR
362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT
3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>
KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?
M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n
[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64
[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;40
11:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B
/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg
59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP
^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@F
Zk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG
/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P1000000000hS0^<SPf8S0^03o
R<2hohS0^7f8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h
0DR@R04000000003R<2hb>3Hb>3H0?o8h=Sob>3HOLSPf058T8P10000003o
R<2hohS0^868`;P100000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?oo
l?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`
l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003o
oo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;o
l?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool0
0?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_oo
k^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003o
onKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;o
oooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^ko
onk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00
oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2
ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^
ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0
0?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooooooo
P_ooool00?ook^k^ooo^k^j2onk^kP0000Kod=3@ojb/[?n0P83oH61Podm?
Com9BDWoodQ8B?ooB4Q8M_m8B4P01Om9BDWoCdm?of1PH?n0P83o[:b/007o
d=3@00001?o4a<CoS8b<oiVIVOoJf][oooooooooooooN_ooool00ooJf][o
VIVIohb<S001olC4a00000?o_knoojFUYOodm?@0ooooooooooooogcooooo
0Oodm?@1ojFUY@7o_kno00000onXZ:Sob/[:oo?cl`3oooooooooooooNooo
ool00oono_kol_;bolW9b@01ojRXZ00000GoWYjNon7QhOo/k>com_Kfoo_k
n`05ooooo`04ookno_ooooooooooooknoPCooooo00Coo_knoooooooooooo
o_kn1?ooool01?ono_koooooooooooono_h4ooooo`04ookno_oooooooooo
ooknoPCooooo00Coo_knooooooooooooo_kn1?ooool01?ono_kooooooooo
ooono_h4ooooo`04ookno_ooooooooooooknoPCooooo00Coo_knoooooooo
ooooo_kn1?ooool01?ono_koooooooooooono_h4ooooo`04ookno_oooooo
ooooooknoPCooooo00Coo_knooooooooooooo_kn1?ooool01?ono_kooooo
ooooooono_h4ooooo`04ookno_ooooooooooooknoPCooooo00Coo_knoooo
ooooooooo_kn1?ooool01?ono_koooooooooooono_h4ooooo`04ookno_oo
ooooooooooknoPCooooo00Coo_knooooooooooooo_kn1?ooool01?ono_ko
ooooooooooono_h4ooooo`04ookno_ooooooooooooknoPCooooo00Coo_kn
ooooooooooooo_kn1?ooool01?ono_koooooooooooono_h4ooooo`04ookn
o_ooooooooooooknoPCooooo00Coo_knooooooooooooo_kn1?ooool01?on
o_koooooooooooono_h4ooooo`04ookno_ooooooooooooknoPCooooo00Co
o_knooooooooooooo_kn1?ooool01?ono_koooooooooooono_h4ooooo`04
ookno_ooooooooooooknoPCooooo00Coo_knooooooooooooo_kn1?ooool0
1?ono_koooooooooooono_h4ooooo`04ookno_ooooooooooooknoPCooooo
00Coo_knooooooooooooo_kn1?ooool01?ono_koooooooooooono_h4oooo
o`04ookno_ooooooooooooknoPCooooo00Coo_knooooooooooooo_kn1?oo
ool01?ono_koooooooooooono_h4ooooo`04ookno_ooooooooooooknoPCo
oooo00Coo_knooooooooooooo_kn1?ooool01?ono_koooooooooooono_h4
ooooo`04ookno_ooooooooooooknoPCooooo00Coo_knooooooooooooo_kn
1?ooool01?ono_koooooooooooono_h4ooooo`04ookno_ooooooooooookn
oPCooooo00Coo_knooooooooooooo_kn1?ooool01?ono_koooooooooooon
o_h4ooooo`04ookno_ooooooooooooknoPCooooo00Coo_knoooooooooooo
o_kn1?ooool01?ono_koooooooooooono_h4ooooo`04ookno_oooooooooo
ooknoPCooooo00Coo_knooooooooooooo_kn1?ooool01?ono_kooooooooo
ooono_h4ooooo`04ookno_ooooooooooooknoPCooooo00Coo_knoooooooo
ooooo_kn1?ooool01?ono_koooooooooooono_h4ooooo`04ookno_oooooo
ooooooknoPCooooo00Coo_knooooooooooooo_kn1?ooool01?ono_kooooo
ooooooono_h4ooooo`04ookno_ooooooooooooknoPCooooo00Coo_knoooo
ooooooooo_kn1?ooool01?ono_koooooooooooono_h4ooooo`04ookno_oo
ooooooooooknoPCooooo00Coo_knooooooooooooo_kn1?ooool01?ono_ko
ooooooooooono_h4ooooo`04ookno_ooooooooooooknoPCooooo00Coo_kn
ooooooooooooo_kn1?ooool01?ono_koooooooooooono_h4ooooo`04ookn
o_ooooooooooooknoPCooooo00Coo_knooooooooooooo_kn1?ooool01?on
o_koooooooooooono_h4ooooo`04ookno_ooooooooooooknoPCooooo00Co
o_knooooooooooooo_kn1?ooool01?ono_koooooooooooono_h4ooooo`04
ookno_ooooooooooooknoPCooooo00Coo_knooooooooooooo_kn1?ooool0
1?ono_koooooooooooono_h4ooooo`04ookno_ooooooooooooknoPCooooo
00Coo_knooooooooooooo_kn1?ooool01?ono_koooooooooooono_h5oooo
o`04oo_knoogmoOok>c/on7Qh@7oWYjN00002?nSXj?ogmoOonSXj?o]kNgo
lo?cooKfm_ogmoOom_Kf0_ohn?P01_oinOWon_[jooShn?ogmoOon?SfooKf
mP;on?Sh00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2ooShn006ooWinOoj
n_[on?ShooOgmoohn?Kom_Kf0_ohn?P01_oinOWon_[jooShn?ogmoOon?Sf
ooKfmP;on?Sh00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2ooShn006ooWi
nOojn_[on?ShooOgmoohn?Kom_Kf0_ohn?P01_oinOWon_[jooShn?ogmoOo
n?SfooKfmP;on?Sh00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2ooShn006
ooWinOojn_[on?ShooOgmoohn?Kom_Kf0_ohn?P01_oinOWon_[jooShn?og
moOon?SfooKfmP;on?Sh00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2ooSh
n006ooWinOojn_[on?ShooOgmoohn?Kom_Kf0_ohn?P01_oinOWon_[jooSh
n?ogmoOon?SfooKfmP;on?Sh00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2
ooShn006ooWinOojn_[on?ShooOgmoohn?Kom_Kf0_ohn?P01_oinOWon_[j
ooShn?ogmoOon?SfooKfmP;on?Sh00KonOWioo[jn_ohn?SomoOgooShm_of
m_H2ooShn006ooWinOojn_[on?ShooOgmoohn?Kom_Kf0_ohn?P01_oinOWo
n_[jooShn?ogmoOon?SfooKfmP;on?Sh00KonOWioo[jn_ohn?SomoOgooSh
m_ofm_H2ooShn006ooWinOojn_[on?ShooOgmoohn?Kom_Kf0_ohn?P01_oi
nOWon_[jooShn?ogmoOon?SfooKfmP;on?Sh00KonOWioo[jn_ohn?SomoOg
ooShm_ofm_H2ooShn006ooWinOojn_[on?ShooOgmoohn?Kom_Kf0_ohn?P0
1_oinOWon_[jooShn?ogmoOon?SfooKfmP;on?Sh00KonOWioo[jn_ohn?So
moOgooShm_ofm_H2ooShn006ooWinOojn_[on?ShooOgmoohn?Kom_Kf0_oh
n?P01_oinOWon_[jooShn?ogmoOon?SfooKfmP;on?Sh00KonOWioo[jn_oh
n?SomoOgooShm_ofm_H2ooShn006ooWinOojn_[on?ShooOgmoohn?Kom_Kf
0_ohn?P01_oinOWon_[jooShn?ogmoOon?SfooKfmP;on?Sh00KonOWioo[j
n_ohn?SomoOgooShm_ofm_H2ooShn006ooWinOojn_[on?ShooOgmoohn?Ko
m_Kf0_ohn?P01_oinOWon_[jooShn?ogmoOon?SfooKfmP;on?Sh00KonOWi
oo[jn_ohn?SomoOgooShm_ofm_H2ooShn006ooWinOojn_[on?ShooOgmooh
n?Kom_Kf0_ohn?P01_oinOWon_[jooShn?ogmoOon?SfooKfmP;on?Sh00Ko
nOWioo[jn_ohn?SomoOgooShm_ofm_H2ooShn006ooWinOojn_[on?ShooOg
moohn?Kom_Kf0_ohn?P01_oinOWon_[jooShn?ogmoOon?SfooKfmP;on?Sh
00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2ooShn006ooWinOojn_[on?Sh
ooOgmoohn?Kom_Kf0_ohn?P01_oinOWon_[jooShn?ogmoOon?SfooKfmP;o
n?Sh00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2ooShn006ooWinOojn_[o
n?ShooOgmoohn?Kom_Kf0_ohn?P01_oinOWon_[jooShn?ogmoOon?SfooKf
mP;on?Sh00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2ooShn006ooWinOoj
n_[on?ShooOgmoohn?Kom_Kf0_ohn?P01_oinOWon_[jooShn?ogmoOon?Sf
ooKfmP;on?Sh00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2ooShn006ooWi
nOojn_[on?ShooOgmoohn?Kom_Kf0_ohn?P01_oinOWon_[jooShn?ogmoOo
n?SfooKfmP;on?Sh00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2ooShn006
ooWinOojn_[on?ShooOgmoohn?Kom_Kf0_ohn?P01_oinOWon_[jooShn?og
moOon?SfooKfmP;on?Sh00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2ooSh
n006ooWinOojn_[on?ShooOgmoohn?Kom_Kf0_ohn?P01_oinOWon_[jooSh
n?ogmoOon?SfooKfmP;on?Sh00KonOWioo[jn_ohn?SomoOgooShm_ofm_H2
ooShn006ooWinOojn_[on?ShooOgmoohn?Kom_Kf0_ohn?P01_oinOWon_[j
ooShn?ogmoOon?SfooKfmP;on?Sh00KonOWioo[jn_ohn?SomoOgooShm_of
m_H2ooShn006ooWinOojn_[on?ShooOgmoohn?Kom_Kf0_ohn?P01_oinOWo
n_[jooShn?ogmoOon?SfooKfmP;on?Sh00KonOWioo[jn_ohn?SomoOgooSh
m_ofm_H2ooShn006ooWinOojn_[on?ShooOgmoohn?Kom_Kf0_ohn?P01_oi
nOWon_[jooShn?ogmoOon?SfooKfmP;on?Sh00KonOWioo[jn_ohn?SomoOg
ooShm_ofm_H2ooShn006ooWinOojn_[on?ShooOgmoohn?Kom_Kf0_ohn?P0
1_oinOWon_[jooShn?ogmoOon?SfooKfmP;on?Sh00KonOWioo[jn_ohn?So
moOgooShm_ofm_H2ooShn006ooWinOojn_[on?ShooOgmoohn?Kom_Kf0_oh
n?P01_oinOWon_[jooShn?ogmoOon?SfooKfmP;on?Sh00KonOWioo[jn_oh
n?SomoOgooShm_ofm_H2ooShn006ooWinOojn_[on?ShooOgmoohn?Kom_Kf
0_ohn?P01_oinOWon_[jooShn?ogmoOon?SfooKfmP;on?Sh00KonOWioo[j
n_ohn?SomoOgooShm_ofm_H2ooShn00=ooWinOojn_[on?ShooOgmoohn?Ko
m_KfooShn?ogmoOom_KfooCdm?o^k^koj>SXon3Ph001oj>SX`0000So[jn_
omkNg_oVi^Kok>c/onk^k_o_knoolO7aoo?cl`?ol_;b00Golo?coo;bl_ob
l_;ol_;boo?cl`03oo;blP05oo?cloobl_;ol_;boo;bl_oclo<00oobl_80
1Ooclo?ol_;boo;bl_obl_;olo?c00?ol_;b00Golo?coo;bl_obl_;ol_;b
oo?cl`03oo;blP05oo?cloobl_;ol_;boo;bl_oclo<00oobl_801Ooclo?o
l_;boo;bl_obl_;olo?c00?ol_;b00Golo?coo;bl_obl_;ol_;boo?cl`03
oo;blP05oo?cloobl_;ol_;boo;bl_oclo<00oobl_801Ooclo?ol_;boo;b
l_obl_;olo?c00?ol_;b00Golo?coo;bl_obl_;ol_;boo?cl`03oo;blP05
oo?cloobl_;ol_;boo;bl_oclo<00oobl_801Ooclo?ol_;boo;bl_obl_;o
lo?c00?ol_;b00Golo?coo;bl_obl_;ol_;boo?cl`03oo;blP05oo?cloob
l_;ol_;boo;bl_oclo<00oobl_801Ooclo?ol_;boo;bl_obl_;olo?c00?o
l_;b00Golo?coo;bl_obl_;ol_;boo?cl`03oo;blP05oo?cloobl_;ol_;b
oo;bl_oclo<00oobl_801Ooclo?ol_;boo;bl_obl_;olo?c00?ol_;b00Go
lo?coo;bl_obl_;ol_;boo?cl`03oo;blP05oo?cloobl_;ol_;boo;bl_oc
lo<00oobl_801Ooclo?ol_;boo;bl_obl_;olo?c00?ol_;b00Golo?coo;b
l_obl_;ol_;boo?cl`03oo;blP05oo?cloobl_;ol_;boo;bl_oclo<00oob
l_801Ooclo?ol_;boo;bl_obl_;olo?c00?ol_;b00Golo?coo;bl_obl_;o
l_;boo?cl`03oo;blP05oo?cloobl_;ol_;boo;bl_oclo<00oobl_801Ooc
lo?ol_;boo;bl_obl_;olo?c00?ol_;b00Golo?coo;bl_obl_;ol_;boo?c
l`03oo;blP05oo?cloobl_;ol_;boo;bl_oclo<00oobl_801Ooclo?ol_;b
oo;bl_obl_;olo?c00?ol_;b00Golo?coo;bl_obl_;ol_;boo?cl`03oo;b
lP05oo?cloobl_;ol_;boo;bl_oclo<00oobl_801Ooclo?ol_;boo;bl_ob
l_;olo?c00?ol_;b00Golo?coo;bl_obl_;ol_;boo?cl`03oo;blP05oo?c
loobl_;ol_;boo;bl_oclo<00oobl_801Ooclo?ol_;boo;bl_obl_;olo?c
00?ol_;b00Golo?coo;bl_obl_;ol_;boo?cl`03oo;blP05oo?cloobl_;o
l_;boo;bl_oclo<00oobl_801Ooclo?ol_;boo;bl_obl_;olo?c00?ol_;b
00Golo?coo;bl_obl_;ol_;boo?cl`03oo;blP05oo?cloobl_;ol_;boo;b
l_oclo<00oobl_801Ooclo?ol_;boo;bl_obl_;olo?c00?ol_;b00Golo?c
oo;bl_obl_;ol_;boo?cl`03oo;blP05oo?cloobl_;ol_;boo;bl_oclo<0
0oobl_801Ooclo?ol_;boo;bl_obl_;olo?c00?ol_;b00Golo?coo;bl_ob
l_;ol_;boo?cl`03oo;blP05oo?cloobl_;ol_;boo;bl_oclo<00oobl_80
1Ooclo?ol_;boo;bl_obl_;olo?c00?ol_;b00Golo?coo;bl_obl_;ol_;b
oo?cl`03oo;blP05oo?cloobl_;ol_;boo;bl_oclo<00oobl_801Ooclo?o
l_;boo;bl_obl_;olo?c00?ol_;b00Golo?coo;bl_obl_;ol_;boo?cl`03
oo;blP05oo?cloobl_;ol_;boo;bl_oclo<00oobl_801Ooclo?ol_;boo;b
l_obl_;olo?c00?ol_;b00Golo?coo;bl_obl_;ol_;boo?cl`03oo;blP05
oo?cloobl_;ol_;boo;bl_oclo<00oobl_801Ooclo?ol_;boo;bl_obl_;o
lo?c00?ol_;b00Golo?coo;bl_obl_;ol_;boo?cl`03oo;blP05oo?cloob
l_;ol_;boo;bl_oclo<00oobl_801Ooclo?ol_;boo;bl_obl_;olo?c00?o
l_;b00Golo?coo;bl_obl_;ol_;boo?cl`03oo;blP05oo?cloobl_;ol_;b
oo;bl_oclo<00oobl_801Ooclo?ol_;boo;bl_obl_;olo?c00?ol_;b00Go
lo?coo;bl_obl_;ol_;boo?cl`03oo;blP05oo?cloobl_;ol_;boo;bl_oc
lo<00oobl_801Ooclo?ol_;boo;bl_obl_;olo?c00?ol_;b00Golo?coo;b
l_obl_;ol_;boo?cl`03oo;blP05oo?cloobl_;ol_;boo;bl_oclo<00oob
l_801Ooclo?ol_;boo;bl_obl_;olo?c00?ol_;b00Golo?coo;bl_obl_;o
l_;boo?cl`03oo;blP05oo?cloobl_;ol_;boo;bl_oclo<00oobl_801Ooc
lo?ol_;boo;bl_obl_;olo?c00?ol_;b00Golo?coo;bl_obl_;ol_;boo?c
l`03oo;blP05oo?cloobl_;ol_;boo;bl_oclo<00oobl_801Ooclo?ol_;b
oo;bl_obl_;olo?c00?ol_;b00Golo?coo;bl_obl_;ol_;boo?cl`03oo;b
lP05oo?cloobl_;ol_;boo;bl_oclo<00oobl_801Ooclo?ol_;boo;bl_ob
l_;olo?c00;ol_;b00GolO7aonk^k_o[jn_oi^KVomkNgP01ojn_[`0000Oo
Xj>SomgMgOoTi>CojNWYon_[joo/k>cok^k^00;okno_00?ok^k^ono_koo_
knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03onk^k_o_knookno_00Go
kno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03
onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^ko
kno_ono_k`05ono_k`03onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_
knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03onk^k_o_knookno_00Go
kno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03
onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^ko
kno_ono_k`05ono_k`03onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_
knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03onk^k_o_knookno_00Go
kno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03
onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^ko
kno_ono_k`05ono_k`03onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_
knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03onk^k_o_knookno_00Go
kno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03
onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^ko
kno_ono_k`05ono_k`03onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_
knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03onk^k_o_knookno_00Go
kno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03
onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^ko
kno_ono_k`05ono_k`03onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_
knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03onk^k_o_knookno_00Go
kno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03
onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^ko
kno_ono_k`05ono_k`03onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_
knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03onk^k_o_knookno_00Go
kno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03
onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^ko
kno_ono_k`05ono_k`03onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_
knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03onk^k_o_knookno_00Go
kno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03
onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^ko
kno_ono_k`05ono_k`03onk^k_o_knookno_00Gokno_00?ok^k^ono_koo_
knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03onk^k_o_knookno_00Go
kno_00?ok^k^ono_koo_knl01Oo_knl00oo^k^kokno_ono_k`05ono_k`03
onk^k_o_knookno_00Gokno_0_o^k^h01?o/k>cojNWYonCTi?oMgMd1oj>S
X`0000SoWIfMomgMgOoShn?oinOWonWYjOo[jn_ok>c/onk^kP;okNg]0_o/
k>`01?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNko
k^k^0_o]kNd2onc/k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`01?o^
k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNkok^k^0_o]
kNd2onc/k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`01?o^k^kok>c/
ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNkok^k^0_o]kNd2onc/
k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`01?o^k^kok>c/ong]k_o^
k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNkok^k^0_o]kNd2onc/k004onk^
k_o/k>cokNg^onk^kP;okNg]0_o/k>`01?o^k^kok>c/ong]k_o^k^h2ong]
k@;ok>c/00Cok^k^onc/k?o]kNkok^k^0_o]kNd2onc/k004onk^k_o/k>co
kNg^onk^kP;okNg]0_o/k>`01?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/
00Cok^k^onc/k?o]kNkok^k^0_o]kNd2onc/k004onk^k_o/k>cokNg^onk^
kP;okNg]0_o/k>`01?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^
onc/k?o]kNkok^k^0_o]kNd2onc/k004onk^k_o/k>cokNg^onk^kP;okNg]
0_o/k>`01?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]
kNkok^k^0_o]kNd2onc/k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`0
1?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNkok^k^
0_o]kNd2onc/k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`01?o^k^ko
k>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNkok^k^0_o]kNd2
onc/k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`01?o^k^kok>c/ong]
k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNkok^k^0_o]kNd2onc/k004
onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`01?o^k^kok>c/ong]k_o^k^h2
ong]k@;ok>c/00Cok^k^onc/k?o]kNkok^k^0_o]kNd2onc/k004onk^k_o/
k>cokNg^onk^kP;okNg]0_o/k>`01?o^k^kok>c/ong]k_o^k^h2ong]k@;o
k>c/00Cok^k^onc/k?o]kNkok^k^0_o]kNd2onc/k004onk^k_o/k>cokNg^
onk^kP;okNg]0_o/k>`01?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00Co
k^k^onc/k?o]kNkok^k^0_o]kNd2onc/k004onk^k_o/k>cokNg^onk^kP;o
kNg]0_o/k>`01?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/
k?o]kNkok^k^0_o]kNd2onc/k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/
k>`01?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNko
k^k^0_o]kNd2onc/k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`01?o^
k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNkok^k^0_o]
kNd2onc/k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`01?o^k^kok>c/
ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNkok^k^0_o]kNd2onc/
k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`01?o^k^kok>c/ong]k_o^
k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNkok^k^0_o]kNd2onc/k004onk^
k_o/k>cokNg^onk^kP;okNg]0_o/k>`01?o^k^kok>c/ong]k_o^k^h2ong]
k@;ok>c/00Cok^k^onc/k?o]kNkok^k^0_o]kNd2onc/k004onk^k_o/k>co
kNg^onk^kP;okNg]0_o/k>`01?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/
00Cok^k^onc/k?o]kNkok^k^0_o]kNd2onc/k004onk^k_o/k>cokNg^onk^
kP;okNg]0_o/k>`01?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^
onc/k?o]kNkok^k^0_o]kNd2onc/k004onk^k_o/k>cokNg^onk^kP;okNg]
0_o/k>`01?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]
kNkok^k^0_o]kNd2onc/k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`0
1?o^k^kok>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNkok^k^
0_o]kNd2onc/k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`01?o^k^ko
k>c/ong]k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNkok^k^0_o]kNd2
onc/k004onk^k_o/k>cokNg^onk^kP;okNg]0_o/k>`01?o^k^kok>c/ong]
k_o^k^h2ong]k@;ok>c/00Cok^k^onc/k?o]kNkok^k^0_o]kNd2onc/k00;
onk^k_o/k>cokNg^onk^k_o]kNgok>c/on_[jooZj^[oinOWon?ShooNg]h0
0OnMWId00007oj>SXooMgMgoh^;RonKVi_oYjNWojn_[on[ZjP02onc/k004
on_[joo/k>cojn_[on_[j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[1?o/k>`0
1?o[jn_ok>c/on_[joo[jn/4onc/k004on_[joo/k>cojn_[on_[j`Cok>c/
00Cojn_[onc/k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/4onc/
k004on_[joo/k>cojn_[on_[j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[1?o/
k>`01?o[jn_ok>c/on_[joo[jn/4onc/k004on_[joo/k>cojn_[on_[j`Co
k>c/00Cojn_[onc/k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/4
onc/k004on_[joo/k>cojn_[on_[j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[
1?o/k>`01?o[jn_ok>c/on_[joo[jn/4onc/k004on_[joo/k>cojn_[on_[
j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[joo[
jn/4onc/k004on_[joo/k>cojn_[on_[j`Cok>c/00Cojn_[onc/k?o[jn_o
jn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/4onc/k004on_[joo/k>cojn_[
on_[j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[
joo[jn/4onc/k004on_[joo/k>cojn_[on_[j`Cok>c/00Cojn_[onc/k?o[
jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/4onc/k004on_[joo/k>co
jn_[on_[j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/
on_[joo[jn/4onc/k004on_[joo/k>cojn_[on_[j`Cok>c/00Cojn_[onc/
k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/4onc/k004on_[joo/
k>cojn_[on_[j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[1?o/k>`01?o[jn_o
k>c/on_[joo[jn/4onc/k004on_[joo/k>cojn_[on_[j`Cok>c/00Cojn_[
onc/k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/4onc/k004on_[
joo/k>cojn_[on_[j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[1?o/k>`01?o[
jn_ok>c/on_[joo[jn/4onc/k004on_[joo/k>cojn_[on_[j`Cok>c/00Co
jn_[onc/k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/4onc/k004
on_[joo/k>cojn_[on_[j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[1?o/k>`0
1?o[jn_ok>c/on_[joo[jn/4onc/k004on_[joo/k>cojn_[on_[j`Cok>c/
00Cojn_[onc/k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/4onc/
k004on_[joo/k>cojn_[on_[j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[1?o/
k>`01?o[jn_ok>c/on_[joo[jn/4onc/k004on_[joo/k>cojn_[on_[j`Co
k>c/00Cojn_[onc/k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/4
onc/k004on_[joo/k>cojn_[on_[j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[
1?o/k>`01?o[jn_ok>c/on_[joo[jn/4onc/k004on_[joo/k>cojn_[on_[
j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[joo[
jn/4onc/k004on_[joo/k>cojn_[on_[j`Cok>c/00Cojn_[onc/k?o[jn_o
jn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/4onc/k004on_[joo/k>cojn_[
on_[j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[
joo[jn/4onc/k004on_[joo/k>cojn_[on_[j`Cok>c/00Cojn_[onc/k?o[
jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/4onc/k004on_[joo/k>co
jn_[on_[j`Cok>c/00Cojn_[onc/k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/
on_[joo[jn/4onc/k004on_[joo/k>cojn_[on_[j`Cok>c/00Cojn_[onc/
k?o[jn_ojn_[1?o/k>`01?o[jn_ok>c/on_[joo[jn/4onc/k0;ojn_[00Co
j>SXonKVi_oShn?ogMgM0OnSXj<00005ojn_[ooLg=coh^;RonKVi_oXj>P0
0_oZj^[oon_[jooojn_[M?o[jn/2on[ZjP04onSXj?oVi^Koh^;RomcLg07o
[jn_00001OnSXj?og=cLon;Rh_oVi^Koj>SX00;oj^[Zooo[jn_oon_[jgCo
jn_[0_oZj^X01?oXj>Soi^KVon;Rh_oLg=`1oj>SX`0000GoWIfMomcLg?oR
h^;oi^KVonSXj002on[Zj_oojn_[ooo[jn]don_[j`;oj^[Z00Coj>SXonKV
i_oRh^;og=cL0OnMWId00005oj>SXooKfm_oh^;RonKVi_oXj>P00_oZj^[o
on_[jooojn_[M?o[jn/2on[ZjP04onSXj?oVi^Koh^;Rom_Kf`7oXj>S0000
1on_[joofm_Kon;Rh_oVi^Koj>SXonWYjOoZj^X0ooo[jn_oon_[jgCojn_[
00Koj^[ZonWYjOoXj>Soi^KVon;Rh_oKfm/1ojn_[`0000OoXj>Som_KfooQ
hN7oiNGUonSXj?oYjNWoj^[Z0?oojn_[ooo[jn]don_[j`06on[Zj_oYjNWo
j>SXonGUiOoQhN7ofm_K0OnSXj<00007oifMWOoIfMWoh>3PonGUiOoWinOo
jNWYon[ZjP3oon_[jooojn_[M?o[jn/01_oZj^[ojNWYonOWiooUiNGoh>3P
omWIf@7oWIfM00001onSXj?oemOGomoOgooShn?oi^KVonSXj?oYjNT0ooo[
jn_oon_[jgCojn_[00KojNWYonSXj?oVi^Kohn?Son3Ph?oGemL1oj>SX`00
00Go[jn_omcLg?oRh^;oi^KVonSXj002on[Zj_oojn_[ooo[jn]don_[j`;o
j^[Z00Coj>SXonKVi_oRh^;og=cL0On_[jl00005oj>SXooLg=coh^;RonKV
i_oXj>P00_oZj^[oon_[jooojn_[M?o[jn/2on[ZjP04onSXj?oVi^Koh^;R
omcLg07oXj>S00001OnMWIgog=cLon;Rh_oVi^Koj>SX00;oj^[Zooo[jn_o
on_[jgCojn_[0_oZj^X01?oXj>Soi^KVon;Rh_oLg=`1oifMW@0000GoXj>S
om_KfooRh^;oi^KVonSXj002on[Zj_oojn_[ooo[jn]don_[j`;oj^[Z00Co
j>SXonKVi_oRh^;ofm_K0OnSXj<00007ojn_[ooKfm_oh^;RonKVi_oXj>So
jNWYon[ZjP3oon_[jooojn_[M?o[jn/01_oZj^[ojNWYonSXj?oVi^Koh^;R
om_Kf`7o[jn_00001onSXj?ofm_Kon7QhOoUiNGoj>SXonWYjOoZj^X0ooo[
jn_oon_[jgCojn_[00Koj^[ZonWYjOoXj>SoiNGUon7QhOoKfm/1oj>SX`00
00OoWIfMomWIfOoPh>3oiNGUonOWiooYjNWoj^[Z0?oojn_[ooo[jn]don_[
j`06on[Zj_oYjNWoinOWonGUiOoPh>3ofMWI0OnMWId00007oj>SXooGemOo
gmoOon?ShooVi^Koj>SXonWYj@3oon_[jooojn_[M?o[jn/01_oYjNWoj>SX
onKVi_oShn?oh>3PomOGe`7oXj>S00001On_[joog=cLon;Rh_oVi^Koj>SX
00;oj^[Zooo[jn_oon_[jgCojn_[0_oZj^X01?oXj>Soi^KVon;Rh_oLg=`1
ojn_[`0000GoXj>SomcLg?oRh^;oi^KVonSXj002on[Zj_oojn_[ooo[jn]d
on_[j`;oj^[Z00Coj>SXonKVi_oRh^;og=cL0OnSXj<00005oifMWOoLg=co
h^;RonKVi_oXj>P00_oZj^[oon_[jooojn_[M?o[jn/2on[ZjP04onSXj?oV
i^Koh^;RomcLg07oWIfM00001OnSXj?ofm_Kon;Rh_oVi^Koj>SX00;oj^[Z
ooo[jn_oon_[jgCojn_[0_oZj^X01?oXj>Soi^KVon;Rh_oKfm/1oj>SX`00
00Oo[jn_om_KfooRh^;oi^KVonSXj?oYjNWoj^[Z0?oojn_[ooo[jn]don_[
j`06on[Zj_oYjNWoj>SXonKVi_oRh^;ofm_K0On_[jl00007oj>SXooKfm_o
hN7QonGUiOoXj>SojNWYon[ZjP3oon_[jooojn_[M?o[jn/01_oZj^[ojNWY
onSXj?oUiNGohN7Qom_Kf`7oXj>S00001onMWIgofMWIon3Ph?oUiNGoinOW
onWYjOoZj^X0ooo[jn/Zon_[j`06oiRHV?n][JgojNWYon_[jooZj^[oW9bL
ooo[jn]4on_[j`06on[Zj_oYjNWoinOWonGUiOoPh>3ofMWI0OnMWId00007
oj>SXooGemOogmoOon?ShooVi^Koj>SXonWYj@3oon_[jb[ojn_[00?oQ8B4
ofe]KOll?3`00_o[jn/00olo?cooi>CTon_[j`3oon_[jd;ojn_[00KojNWY
onSXj?oVi^Kohn?Son3Ph?oGemL1oj>SX`0000Go[jn_omcLg?oRh^;oi^KV
onSXj002on[Zj_oojn_[;?o[jn/01OlK6a_oe]KFon_[jomkNg_oZ:RX00;o
jn_[00?ofm_Ko`410Olf=SH00_lf=SH01Onn_[ko4A4Aon_[jooRh^;o4A4A
00;ojn_[00SoCdm?ojBTY?oRh^;o4A4Aon_[joo;bl_o7alOokFe]Ooojn_[
;Oo[jn/2on[ZjP04onSXj?oVi^Koh^;RomcLg07o[jn_00001OnSXj?og=cL
on;Rh_oVi^Koj>SX00;oj^[Zooo[jn//on_[j`05ob/[:oni^KWojn_[ol;2
`_mQHF400_o[jn/00ooKfm_o2@T9on_[j`02on_[j`05on;Rh_lA4A7ojn_[
on;Rh_lA4A400_o[jn/01om?CdooY:BTon;Rh_lA4A7oe=CDob<S8onUYJD0
ooo[jn/^on_[j`;oj^[Z00Coj>SXonKVi_oRh^;og=cL0OnSXj<00005oifM
WOoLg=coh^;RonKVi_oXj>P00_oZj^[oon_[jbcojn_[00Go:b/[okVi^Oo[
jn_ojn_[ocTi>@02on_[j`03om_Kfol92@Wojn_[00;ojn_[00Goh^;Roa4A
4Oo[jn_oh^;Roa4A4@02on_[j`06odm?ConTY:Coh^;Ro`l?3ol_;booShn?
ooo[jn/_on_[j`;oj^[Z00Coj>SXonKVi_oRh^;og=cL0OnMWId00005oj>S
XooKfm_oh^;RonKVi_oXj>P00_oZj^[oon_[jbcojn_[00Wo:b/[okVi^Oo[
jn_ojn_[ofATI?o0`<3ojn_[om_Kfol92@T00oo[jn/03OoRh^;o4A4Aon_[
jooRh^;o20P8om7AdOo[jn_oB4Q8ojJVY_oRh^;o4A4Aohb<S?mDE5@0ooo[
jn/_on_[j`;oj^[Z00Coj>SXonKVi_oRh^;ofm_K0OnSXj<00007ojn_[ooK
fm_oh^;RonKVi_oXj>SojNWYon[ZjP3oon_[jbcojn_[00Wo:b/[okVi^Oo[
jn_ojn_[ojZZZ_miNGWojn_[om_Kfol92@T00oo[jn/03_oRh^;o4A4Aon_[
jooRh^;o2`/;ode=COmdM7Co5ADEomWIfOoRh^;o4A4Aon_[jom^KVkoLg=c
ooo[jn/^on_[j`06on[Zj_oYjNWoj>SXonKVi_oRh^;ofm_K0On_[jl00007
oj>SXooKfm_ohN7QonGUiOoXj>SojNWYon[ZjP3oon_[jbcojn_[00Wo:b/[
okVi^Oo[jn_ojn_[onGUiOln?Skojn_[om_Kfol92@T00oo[jn/03ooYjNWo
ZJVYon_[jooYjNWoZJVYomoOgonNWYkobLW9on_[jooRh^;o4A4Aon_[jooZ
j^[oZ:RXonGUi@3oon_[jbgojn_[00Koj^[ZonWYjOoXj>SoiNGUon7QhOoK
fm/1oj>SX`0000OoWIfMomWIfOoPh>3oiNGUonOWiooYjNWoj^[Z0?oojn_[
;?o[jn/00ol[:b_o^KVion_[j`02on_[j`04odi>C_oFe]Kofm_Ko`T92@?o
jn_[00?oi>CTod];Boo[jn/01_o[jn/00ooRh^;o4A4Aon_[j`3oon_[jc3o
jn_[00Koj^[ZonWYjOoWinOoiNGUon3Ph?oIfMT1oifMW@0000OoXj>SomOG
eooOgmoohn?SonKVi_oXj>SojNWY0?oojn_[;?o[jn/00ono_koogmoOon_[
j`02on_[j`04om7AdOoMgMgoj>SXokRh^0?ojn_[00?ojNWYokZj^_o[jn/0
1_o[jn/00ooUiNGoDE5Aon_[j`3oon_[jc3ojn_[00KojNWYonSXj?oVi^Ko
hn?Son3Ph?oGemL1oj>SX`0000Go[jn_omcLg?oRh^;oi^KVonSXj002on[Z
j_oojn_[ooo[jn]don_[j`;oj^[Z00Coj>SXonKVi_oRh^;og=cL0On_[jl0
0005oj>SXooLg=coh^;RonKVi_oXj>P00_oZj^[oon_[jooojn_[M?o[jn/2
on[ZjP04onSXj?oVi^Koh^;RomcLg07oXj>S00001OnMWIgog=cLon;Rh_oV
i^Koj>SX00;oj^[Zooo[jn_oon_[jgCojn_[0_oZj^X01?oXj>Soi^KVon;R
h_oLg=`1oifMW@0000GoXj>Som_KfooRh^;oi^KVonSXj002on[Zj_oojn_[
ooo[jn]don_[j`;oj^[Z00Coj>SXonKVi_oRh^;ofm_K0OnSXj<00007ojn_
[ooKfm_oh^;RonKVi_oXj>SojNWYon[ZjP3oon_[jooojn_[M?o[jn/01_oZ
j^[ojNWYonSXj?oVi^Koh^;Rom_Kf`7o[jn_00001onSXj?ofm_Kon7QhOoU
iNGoj>SXonWYjOoZj^X0ooo[jn_oon_[jgCojn_[00Koj^[ZonWYjOoXj>So
iNGUon7QhOoKfm/1oj>SX`0000OoWIfMomWIfOoPh>3oiNGUonOWiooYjNWo
j^[Z0?oojn_[5oo[jn]5oooooooojn_[6?o[jn/01_oZj^[ojNWYonOWiooU
iNGoh>3PomWIf@7oWIfM00001onSXj?oemOGomoOgooShn?oi^KVonSXj?oY
jNT0ooo[jn/Gon_[jdGoooooooo[jn/Hon_[j`06onWYjOoXj>Soi^KVon?S
hooPh>3oemOG0OnSXj<00005ojn_[ooLg=coh^;RonKVi_oXj>P00_oZj^[o
on_[jaOojn_[AOooooooon_[jaSojn_[0_oZj^X01?oXj>Soi^KVon;Rh_oL
g=`1ojn_[`0000GoXj>SomcLg?oRh^;oi^KVonSXj002on[Zj_oojn_[5oo[
jn]5oooooooojn_[6?o[jn/2on[ZjP04onSXj?oVi^Koh^;RomcLg07oXj>S
00001OnMWIgog=cLon;Rh_oVi^Koj>SX00;oj^[Zooo[jn/Gon_[j`_ooooo
00Gokno_ooooooo_knookno_ooooo`03ono_k`04ooooooo_knookno_oooo
o`?okno_00Coooooono_koo_knoooooo0_o_knl00oooooookno_ooooo`02
ono_k`05ooooooo_knookno_ono_koooool00oo_knl01Oooooookno_oooo
ooo_knoooooo00;okno_00?oooooono_koo_knl00_o_knl00oooooookno_
ooooo`09oooooooojn_[6?o[jn/2on[ZjP04onSXj?oVi^Koh^;RomcLg07o
WIfM00001OnSXj?ofm_Kon;Rh_oVi^Koj>SX00;oj^[Zooo[jn/Gon_[j`Wo
oooo0_o_knl00ooNg]koc/k>omkNgP02olk>cP;og]kN00Goc/k>olk>e_oN
g]koc/k>olk>eP02omkNgP03olk>c_o>c]Kog]kN00;oc/k>00Kog]kNolk>
c_o>c/kog]kNolk>c_oNg]h2olk>cP04omkNg_o>c/kog]kNolk>cP;og]kN
0_o>c/h01OoNg]koc/k>omkNg_o>c/kog]kN00;oc/k>0_oNg]h2olk>cP;o
g]kN00?okno_ooooooooool01oooooooon_[jaSojn_[0_oZj^X01?oXj>So
i^KVon;Rh_oKfm/1oj>SX`0000Oo[jn_om_KfooRh^;oi^KVonSXj?oYjNWo
j^[Z0?oojn_[5oo[jn/9ooooo`03ono_koo>c/ko[Jf]00Go[Jf]00CoW9bU
ojf][On][JgoW9bU0on][Jd01?nLW:Go[Jf]ojf][OnLW:D2ojf][@06oibL
YOn][Jgo[Jf]oibLYOn][JgoW9bL1?n][Jd01?nLW:Go[Jf]ojf][OnLW:D2
ojf][@05oibLYOn][JgoW9bUojf][OnLW:D00on][Jd01onLW:Go[Jf]ojf]
[On][Jgo_Kfmolk>c_o_knl02?ooooooon_[jaSojn_[00Koj^[ZonWYjOoX
j>Soi^KVon;Rh_oKfm/1ojn_[`0000OoXj>Som_KfooQhN7oiNGUonSXj?oY
jNWoj^[Z0?oojn_[5oo[jn/8ooooo`06ono_kooNg]ko[Jf]ohb<S?mkNg_o
Jf][5_mkNg/00om[Jg_oNg]kog]kN`0Bog]kN`04og]kS?nLW9coc/k>omkN
gPSoooooooo[jn/Hon_[j`06on[Zj_oYjNWoj>SXonGUiOoQhN7ofm_K0OnS
Xj<00007oifMWOoIfMWoh>3PonGUiOoWinOojNWYon[ZjP3oon_[jaOojn_[
2?ooool00oo_knooc/k>of][J`02odY:FP0=oeYJF_m:BT[oBTYJocTi@_m:
BU[o>CU2odY:B_m:BU[o>CU2odY:B_li>D;oBTY:ocTi@P02odY:BP05odY:
F_li>D;oBTY:odY:B_m:BUX00_m:BTX00om:BU[oBTY:odY:BP02odY:BP06
odY:F_m:BT[oBTY:odY:F_m:BT[oBTYJ0om:BTX01?m:BU[oBTY:odY:F_m:
BTX2odY:FPCoFUYJ00?oS8bDomkNg_ooool01oooooooon_[jaSojn_[00Ko
j^[ZonWYjOoWinOoiNGUon3Ph?oIfMT1oifMW@0000OoXj>SomOGeooOgmoo
hn?SonKVi_oXj>SojNWY0?oojn_[5oo[jn/8ooooo`08ono_konm_KgoBTY:
of][Jom[Jg_oFUYcof][Nom:BTX3ocTi>@0GobTY<Oli>CWo>CTiocTi@_m:
BU[oFUYJoeYJJomJFU[oJf][oeYJJom[Jf_oFUY[oeYJLoli>CWoFUYJocTi
@_mJFV_o>CTiodY:F_li>D;oBTYJocTi@_m:BTX00_li>D802?m:BU[o>CTi
oeYJJom[Jf_oFUY[of][JomJFV_oBTY:0_mJFV/01om[Jf_oFUY[of][Nomk
Ng_oFUY[of][JooNg]h02?ooooooon_[jaSojn_[00KojNWYonSXj?oVi^Ko
hn?Son3Ph?oGemL1oj>SX`0000Go[jn_omcLg?oRh^;oi^KVonSXj002on[Z
j_oojn_[5oo[jn/9ooooo`07ojf][Om:BU[oFUY[oeYJJom[Jf_oJf]kodY:
FP03obTY<@03ocTi>Om:BT[oBTYJ00;oFUY[00?oFUYJoeYJJomJFV/00omJ
FV/02_m[Jf_oJf]kocTi>Om:BU[o>CU2oeYJF_lY:C7oFUYJobTY<Om:BTX2
ocTi@P0<odY:F_li>CWoBTYJobTY:Om[Jf_oFUY[of][NomJFW?oNg/@onO_
0?m:DS7oJf]k0_mJFV/2of][N`03oeYJJom[Jf_og]kN00Soooooooo[jn/H
on_[j`;oj^[Z00Coj>SXonKVi_oRh^;og=cL0On_[jl00005oj>SXooLg=co
h^;RonKVi_oXj>P00_oZj^[oon_[jaOojn_[2?ooool00oo_knoo[Jf]ocTi
@P02oeYJJ`05of][Jom[Jg_oBTY:oaPH6?li>D800_m:BUX2oeYJFP0CodY:
F_mJFU[oFUY[oeYJF_mJFV_oJf][oeYJJom[Jf_oFUY[of][Joli>D;oBTYJ
ocTi>OmJFV_o>CTiodY:F_li>CWoBTYJocTi@P02odY:BP04ocTi@_m:BU[o
:BTaoeYJJ`;oJf][00?oFUYcog=kF_n][C400om[Jf/01omJFV_oJf][of][
Nom[Jf_oFUY[omkNg_o_knl01oooooooon_[jaSojn_[0_oZj^X01?oXj>So
i^KVon;Rh_oLg=`1oj>SX`0000GoWIfMomcLg?oRh^;oi^KVonSXj002on[Z
j_oojn_[5oo[jn/8ooooo`05ono_konLW9coBTY:oeYJJom[Jf/00_m[Jg/0
1?li>D;o:BTaodY:B_m:BTX3odY:FP03oeYJF_mJFV_oFUYJ00?oFUY[00_o
Jf][of=JJom[Jf_oJf]kocTi@_m:BU[o>CU2oeYJJoli>CWoBTYJocTi>@02
odY:BP08ocTi@_m:BU[o>CTioeYJF_li>CWoFUY[of][JomJFV/2of][N`0:
oeYJLom[Jg_oJf]koeYJJom[Jf_oFUY[og]kNomJFW?oFUYJolk>cPSooooo
ooo[jn/Hon_[j`;oj^[Z00Coj>SXonKVi_oRh^;og=cL0OnMWId00005oj>S
XooKfm_oh^;RonKVi_oXj>P00_oZj^[oon_[jaOojn_[2?ooool00oo_knoo
Ng^<odY:BP02oeYJJ`;oJf]k0_li>CT00oli>D;oBTYJodY:BP03odY:FP03
oeYJF_mJFV_oFUYJ00GoFUY[00ooJf][obTY<OmJFU[o:BTaoeYJJolY:C7o
BTYJobTY<Om:BU[o>CTiocTi@_m:BT[o:BTaodY:F_lY:BT00_mJFV/01om[
Jf_oFUY[of][Nom[Jf_oJf]koeYJJom[Jg/00_mJFV/01Om[Jg_oJf][odY:
F_nm_LKokno_00Ooooooooo[jn/Hon_[j`;oj^[Z00Coj>SXonKVi_oRh^;o
fm_K0OnSXj<00007ojn_[ooKfm_oh^;RonKVi_oXj>SojNWYon[ZjP3oon_[
jaOojn_[2?ooool00ooNg^OoNg]koeYJFP03of][N`03og]kNom:BU[oBTY:
00;oBTYJ01KoFUYJoeYJJomJFV_oJf][oeYJJom[Jf_oJf]koeYJLomkNg_o
Jf]kog]kS?mkNg_oNg^<oeYJF_mJFV_oBTY:of][Nom:BT[oJf]koeYJF_mJ
FV_oFUYJ0_mJFV/01?mJFU[oJf]kodY:F_mkNg/3og]kS007ohb<S?mkNhco
Ng]kog]kS?mkNg_oJf]kog]kN`02og]kS003oeYJF_n][Jgokno_00Oooooo
ooo[jn/Hon_[j`06on[Zj_oYjNWoj>SXonKVi_oRh^;ofm_K0On_[jl00007
oj>SXooKfm_ohN7QonGUiOoXj>SojNWYon[ZjP3oon_[jaOojn_[2?ooool0
1OoNg]ko_Kfmolk>e_oNg]koc/kF00;og]kN00?oc/kFomkNiooNg]h01?oN
g]h01oo>c]Kog]kNolk>e_o>c]Kog]kNolk>e_oNg]h01_o>c]H01_o>c/ko
c/kFolk>c_o>c]Koc/k>olk>eP?oc/k>00co_Kg6olk>c_o>c/koc/k>okfm
a_o>c/ko_Kfmolk>c_nm_LKoc/k>okfma_o>c/h2okfm_@04olk>c_n<S8co
[Jf]ono_k`Ooooooooo[jn/Hon_[j`06on[Zj_oYjNWoj>SXonGUiOoQhN7o
fm_K0OnSXj<00007oifMWOoIfMWoh>3PonGUiOoWinOojNWYon[ZjP3oon_[
jaOojn_[2?ooool00oo>c/ko[Jfeokfm_@02oibLY@;o[Jfe00?o[Jf]oibL
YOn][Jd01onLW:D01_nLW9coW9bUoibLW?nLW:GoS8bDoibLW0?oS8bD00Co
S8b<ohb<U?n<S8coS8b<0_n<S9@3ohb<S007og]kS?n<S8coNg^<ohb<S?mk
NhcoS8b<og]kN`02og]kS00:og]kNomkNhcoNg]kog]kNom[Jg_oNg]kof][
NomkNhcoS8b<ono_k`Ooooooooo[jn/Hon_[j`06on[Zj_oYjNWoinOWonGU
iOoPh>3ofMWI0OnMWId00007oj>SXooGemOogmoOon?ShooVi^Koj>SXonWY
j@3oon_[jaOojn_[2?ooool02?o>c/ko[Jf]ojf]]Oli>CWo>CU2og]kNon]
[KGo_Kfm0_n][KD2ojf][@04ojf]]OnLW:Go[JfeoibLY@;o[Jf]0_nLW:D0
1on<S9CoW9bUoibLW?nLW:Go[Jf]ojf]]Onm_Kd00_n][KD01onLW:GoW9bL
ohb<S?n<S9CoS8b<ohb<U?nLW9`01?n<S9@01On<S8coS8bDohb<S?n<S9Co
Ng^<00;oS8b<00OoNg^<odY:B_m:BU[oBTY:ohb<S?n<S9Cokno_00Oooooo
ooo[jn/Hon_[j`06onWYjOoXj>Soi^KVon?ShooPh>3oemOG0OnSXj<00005
ojn_[ooLg=coh^;RonKVi_oXj>P00_oZj^[oon_[jaOojn_[2?ooool01ooN
g]koW9bUokfm_Om[Jg_oBTY:oibLYOnm_Kd01_n][KD00on][Jgo[Jfeojf]
[@02oibLY@04ojf][Onm_LKog]kNono_k`[ooooo00?og]kWokfma_nLW:D0
0_n<S9@01_n<S8coS8bDohb<U?n<S9CoS8b<ohb<U0?oS8b<0_mkNh`01OmJ
FU[o>CTiof][Non<S8coW9bL00Soooooooo[jn/Hon_[j`;oj^[Z00Coj>SX
onKVi_oRh^;og=cL0On_[jl00005oj>SXooLg=coh^;RonKVi_oXj>P00_oZ
j^[oon_[jaOojn_[2?ooool02OoNg]ko[Jf]okfma_nm_Kgo_Kg6ojf]]Onm
_Kgo[Jfeokfm_@05ojf]]@04oibLYOn][Jgoc/k>ono_k`;ooooo00Woknog
omkNg_nm_LKo_Kfmojf]]On][JgoW9bUojf][OnLW:D00_n][KD02?o>c/ko
g]kWono_kooNg]ko_Kg6ojf]]OnLW:GoNg^<0_n<S9@01OnLW9coS8bDohb<
U?n<S8coS8bD00;oS8b<00GoNg^<ohb<S?n<S8coNg^<ojf][@08oooooooo
jn_[6?o[jn/2on[ZjP04onSXj?oVi^Koh^;RomcLg07oXj>S00001OnMWIgo
g=cLon;Rh_oVi^Koj>SX00;oj^[Zooo[jn/Gon_[j`Sooooo00Kokno_ojf]
]Onm_LKo_Kg6ojf]]Onm_Kd6ojf]]@03oibLYOn][Jgog]kN00;oknog00Co
g]kWokfma_nLW:GoW9bL0onLW:D01?nLW9coW9bUoibLYOnLW:D3oibLW0?o
S8bD0_nLW:D2okfmaP03olk>c_nLW:GoS8bD00CoS8bD00?oS8b<ohb<U?mk
Nh`00_n<S8`00omkNhcoNg]kokfm_@08oooooooojn_[6?o[jn/2on[ZjP04
onSXj?oVi^Koh^;RomcLg07oWIfM00001OnSXj?ofm_Kon;Rh_oVi^Koj>SX
00;oj^[Zooo[jn/Gon_[j`Sooooo00Woknogojf][Oo>c/ko[Jfeokfm_On]
[KGo_Kg6ojf]]Onm_Kd00_n][KD01_n][Jgoc/k>ono_moo_koOoc/k>ojf]
[@;oW9bU00?o[Jfeojf][On][Jd00_nLW:D00on][JgoW9bUoibLY@03oibL
Y@0;oibLW?nLW:GoW9bLoibLYOn<S9CoW9bLohb<U?nLW9co[Jfeolk>e_o>
c/h01On<S9@00on<S8coS8bDog]kS002ohb<S003og]kS?nm_Kgooooo00Oo
ooooooo[jn/Hon_[j`;oj^[Z00Coj>SXonKVi_oRh^;ofm_K0OnSXj<00007
ojn_[ooKfm_oh^;RonKVi_oXj>SojNWYon[ZjP3oon_[jaOojn_[2Oooool0
0onm_Kgo_Kg6okfm_@02okfmaP03ojf]]Onm_Kgo[Jfe00;o[Jfe00_okno_
oooooooNg]ko[Jfeojf][On][KGo[Jf]ojf]]OnLW:Go[JfeoibLY@02ojf]
[@08oibLYOn][JgoW9bUoibLYOn][JgoW9bUoibLW?nLW:D2oibLW00:oibL
YOn<S9CoW9bLoibLW?n<S9CoW9bUokfma_oNg]koW9bUohb<S0?oS8bD00Ko
S8b<ohb<U?n<S8coS8bDog]kNoo>c/h8oooooooojn_[6?o[jn/01_oZj^[o
jNWYonSXj?oVi^Koh^;Rom_Kf`7o[jn_00001onSXj?ofm_Kon7QhOoUiNGo
j>SXonWYjOoZj^X0ooo[jn/Gon_[j`Wooooo00Go_Kfmokfma_nm_Kgo[Jfe
okfmaP02okfm_@06ojf]]Onm_Kgoknogono_monm_KgoW9bU1?n][KD2ojf]
[@04oibLYOn][KGoW9bUojf]]@;oW9bU00?o[Jf]oibLYOnLW:D01?nLW:D0
1OnLW9coW9bUoibLW?n<S9CoW9bU00?oS8bD00?o[Jfeolk>c_n][Jd00_n<
S9@01on<S8coS8bDohb<S?n<S8coS8bDog]kS?oNg]h02?ooooooon_[jaSo
jn_[00Koj^[ZonWYjOoXj>SoiNGUon7QhOoKfm/1oj>SX`0000OoWIfMomWI
fOoPh>3oiNGUonOWiooYjNWoj^[Z0?oojn_[5oo[jn/9ooooo`03okfma_nm
_Kgo_Kg600;o_Kfm00Go_Kg6ojf]]On][KGoooooono_k`02ojf]]@03okfm
_On][KGo[Jfe00;o[Jfe00Ko[Jf]ojf]]On][Jgo[Jf]ojf]]OnLW:D2ojf]
[@;oW9bU00?o[Jf]oibLYOnLW:D00_nLW9`01onLW:GoW9bLoibLW?nLW:Go
S8bDoibLYOnLW9`00_n<S9@01OnLW:Go_Kg6oibLYOn<S9CoW9bL00?oS8bD
0_n<S8`00ooNg]koooooooooo`06oooooooojn_[6?o[jn/01_oZj^[ojNWY
onOWiooUiNGoh>3PomWIf@7oWIfM00001onSXj?oemOGomoOgooShn?oi^KV
onSXj?oYjNT0ooo[jn/Gon_[j`Wooooo00coc/k>okfm_Onm_LKo_Kfmokfm
a_n][KGo_Kfmono_mooNg^Oo_Kfmojf]]Onm_LH6ojf]]@08ojf][On][KGo
[Jfeojf][On][KGoW9bUojf]]On][Jd4oibLY@04ojf][OnLW:GoW9bUoibL
Y@;oW9bL00CoW9bUohb<U?nLW9coW9bU0_n<S9@00onLW:Go[Jfeohb<U004
ohb<U003oibLW?n<S9Cokno_00Soooooooo[jn/Hon_[j`06onWYjOoXj>So
i^KVon?ShooPh>3oemOG0OnSXj<00005ojn_[ooLg=coh^;RonKVi_oXj>P0
0_oZj^[oon_[jaOojn_[2Oooool01?o>c]Ko[Jfeolk>c_nm_LH2okfm_@09
olk>c_o>c]Ko_Kg6ojf]]Onm_Kgo[Jfeokfm_On][KGo_Kfm00Go[Jfe00Wo
[Jf]ojf]]OnLW:Go[Jfeojf][OnLW:Go[Jf]oibLYOn][Jd01?nLW:D00onL
W9coW9bUoibLY@02oibLW005oibLYOn<S9CoS8bDoibLW?n<S9@00_nLW9`0
0on<S9CoW9bLohb<U003ohb<U0Woooooooo[jn/Hon_[j`;oj^[Z00Coj>SX
onKVi_oRh^;og=cL0On_[jl00005oj>SXooLg=coh^;RonKVi_oXj>P00_oZ
j^[oon_[jaOojn_[2Oooool00ooNg]ko[JfeokfmaP03okfmaP08ojf]]Onm
_Kgo_Kfmojf]]Onm_LKo_Kfmojf]]Onm_LH3ojf]]@03okfm_On][KGo[Jfe
00;o[Jfe00So[Jf]oibLYOnLW:GoW9bLoibLYOnLW9coW9bUojf][@GoW9bU
00CoW9bLoibLYOnLW9coW9bU0_nLW9`01On<S9CoW9bUohb<U?nLW9coS8b<
00?oS8bD0_nLW9`9oooooooojn_[6?o[jn/2on[ZjP04onSXj?oVi^Koh^;R
omcLg07oXj>S00001OnMWIgog=cLon;Rh_oVi^Koj>SX00;oj^[Zooo[jn/G
on_[j`Wooooo00?okno_okfm_Oo>c/h00_nm_LH00onLW:GoW9bLokfmaP02
okfm_@03okfma_n][KGo_Kg600;o[Jfe00?o_Kfmojf]]On][KD00on][KD0
2?nLW:Go[Jf]okfm_Oo>c]Kog]kNolk>e_o>c/ko[Jf]0onLW:D03_n][Jgo
W9bUoibLYOnLW:GoW9bLoibLYOnLW9coW9bUohb<U?nLW:GoS8bDoibLW?n<
S9CoJf]k0_n<S9@00onLW9coS8bDojf][@09oooooooojn_[6?o[jn/2on[Z
jP04onSXj?oVi^Koh^;RomcLg07oWIfM00001OnSXj?ofm_Kon;Rh_oVi^Ko
j>SX00;oj^[Zooo[jn/Gon_[j`Wooooo00Ookno_ojf]]Oo>c/ko_Kg6olk>
c_mkNg_oW9bU00;o_Kg600Co_Kfmojf]]Onm_Kgo[Jfe0_nm_Kd2ojf]]@05
okfma_n][KGo[Jfeojf][Oo>c]H00_ooool00oo_koOokno_ono_k`02ono_
m`03omkNionm_KgoW9bL00CoW9bU00co[Jf]oibLW?nLW:GoW9bLoibLYOnL
W9coW9bUohb<U?nLW:GoJf][og]kNonLW9`2ohb<U003okfm_Ooooooooooo
00Ooooooooo[jn/Hon_[j`;oj^[Z00Coj>SXonKVi_oRh^;ofm_K0OnSXj<0
0007ojn_[ooKfm_oh^;RonKVi_oXj>SojNWYon[ZjP3oon_[jaOojn_[2Ooo
ool00oo_koOo_Kfmolk>eP02okfmaP09oeYJJonm_Kgo_Kg6okfm_Onm_LKo
_Kfmokfma_nm_Kgo_Kg600;o[Jfe00Wo_Kfmojf]]On][KGo[Jfeono_kooo
ooooc/k>ojf]]On][Jd00_nLW:D2ojf]]@;og]kW00Co_KfmoibLYOnLW:Go
[Jf]0onLW:D01OnLW9coW9bUoibLW?nLW:GoS8bD00;oW9bL00KoJf][oeYJ
JonLW:GoS8bDohb<S?nm_LH9oooooooojn_[6?o[jn/01_oZj^[ojNWYonSX
j?oVi^Koh^;Rom_Kf`7o[jn_00001onSXj?ofm_Kon7QhOoUiNGoj>SXonWY
jOoZj^X0ooo[jn/Gon_[j`[ooooo00Go_Kfmolk>c_nm_LKo_KfmoeYJFP03
okfmaP05okfm_Onm_LKo_Kfmojf]]Onm_LH00_nm_Kd2ojf]]@04okfm_Oo>
c]Koooooojf]]@;o[Jf]00Wo[Jfeojf][On][KGoW9bUojf][OnLW:Go_Kg6
ojf]]On][Jd01?nLW:D01?n][JgoW9bUoibLW?nLW:D3oibLW007oibLYOm[
Jg_oFUYJoibLW?n<S9CoS8b<olk>cP09oooooooojn_[6?o[jn/01_oZj^[o
jNWYonSXj?oUiNGohN7Qom_Kf`7oXj>S00001onMWIgofMWIon3Ph?oUiNGo
inOWonWYjOoZj^X0ooo[jn/Gon_[j`[ooooo00Go_Kg6olk>e_o>c/ko_Kg6
oeYJFP04okfmaP;o_Kfm00Co_Kg6okfm_Onm_LKo[Jfe0_nm_Kd00on][KGo
W9bUojf]]@02ojf]]@04okfm_On][KGo[Jfeojf][@;o[Jfe00OoW9bUojf]
[On<S9CoNg]kojf]]OnLW:Go[Jf]00GoW9bU00[oW9bLoibLYOnLW:GoW9bU
og]kNom:BU[oW9bUoibLW?n<S9Cog]kN2Oooooooon_[jaSojn_[00Koj^[Z
onWYjOoWinOoiNGUon3Ph?oIfMT1oifMW@0000OoXj>SomOGeooOgmoohn?S
onKVi_oXj>SojNWY0?oojn_[5oo[jn/:ooooo`06okfma_o>c/ko_Kg6olk>
c_mJFV_o_Kfm0_nm_LH03Onm_Kgo_Kg6okfm_Onm_LKo_Kfmojf]]Onm_LKo
[Jfeokfma_nm_KgoJf]kojf][Onm_Kd01On][KD02_n][Jgo[Jfeojf][On]
[KGoFUYJof][Jon][KGo[Jf]oibLYOn][Jd5oibLY@;oW9bL00OoW9bUoeYJ
Jom[Jf_oW9bLoibLYOn<S9Cog]kN00Woooooooo[jn/Hon_[j`06onWYjOoX
j>Soi^KVon?ShooPh>3oemOG0OnSXj<00005ojn_[ooLg=coh^;RonKVi_oX
j>P00_oZj^[oon_[jaOojn_[2_ooool2olk>cP07okfma_oNg]koJf]kojf]
[Oo>c/ko_Kg6olk>cP02okfmaP07okfm_Onm_LKo_Kfmokfm_Onm_LKo[Jfe
okfmaP02oibLY@Ko[Jfe00go[Jf]ojf]]On][KGo[Jf]of][NonLW:Go[Jfe
oibLYOn][JgoW9bUojf][OnLW:Go[Jf]00;oW9bU00WoW9bLoibLYOnLW:Go
FUYJohb<S?nLW:GoW9bLohb<U?o_knl02Oooooooon_[jaSojn_[0_oZj^X0
1?oXj>Soi^KVon;Rh_oLg=`1ojn_[`0000GoXj>SomcLg?oRh^;oi^KVonSX
j002on[Zj_oojn_[5oo[jn/:ooooo`07omkNg_nm_LKoc/k>okfma_n][KGo
S8b<olk>eP05okfmaP09okfm_Onm_LKo_Kfmokfm_Onm_LKo[Jfeokfm_Onm
_LKo_Kfm00Ko[Jfe00?o[Jf]oibLYOo>c/h00_n][KD00on][JgoW9bUojf]
[@07oibLY@;oW9bL00GoFUY[oibLYOnLW9coW9bUoibLW00:oooooooojn_[
6?o[jn/2on[ZjP04onSXj?oVi^Koh^;RomcLg07oXj>S00001OnMWIgog=cL
on;Rh_oVi^Koj>SX00;oj^[Zooo[jn/Gon_[j`[ooooo00?og]kNokfma_o>
c/h00_o>c/h01?mkNhco_Kg6okfma_o>c/h4okfmaP07okfm_Onm_LKo_Kg6
ojf]]Onm_Kgo_Kg6ojf]]@02olk>cP03ojf]]Onm_Kgo[Jfe00;o[Jfe00Oo
_Kfmolk>c_n][KGo[Jf]ojf]]OnLW:Go[Jfe00;oW9bU00Co[Jf]oibLYOnL
W:Go[Jf]0_nLW:D00on][JgoS8bDohb<U002oibLW0;oW9bU2_ooooooon_[
jaSojn_[0_oZj^X01?oXj>Soi^KVon;Rh_oLg=`1oifMW@0000GoXj>Som_K
fooRh^;oi^KVonSXj002on[Zj_oojn_[5oo[jn/:ooooo`0:omkNg_nm_LKo
c/kFolk>e_oNg]ko_Kfmohb<U?o>c]Ko_Kg6olk>cPCo_Kg600Go_Kfmokfm
a_nm_Kgo[JfeokfmaP02ojf]]@?o_Kg60onm_Kd2ojf]]@;o[Jf]00?oW9bU
ojf]]OnLW:D00_n][Jd00onLW:Go[Jf]oibLY@04oibLY@06oeYJF_nLW:Go
[Jf]oibLW?nLW:Go[Jf]2_ooooooon_[jaSojn_[0_oZj^X01?oXj>Soi^KV
on;Rh_oKfm/1oj>SX`0000Oo[jn_om_KfooRh^;oi^KVonSXj?oYjNWoj^[Z
0?oojn_[5oo[jn/:ooooo`09ono_konm_LKoc/kFohb<S?mkNhco_Kg6okfm
_On][KGoc/kF00;o_Kg600?oc/k>okfma_nm_Kd00_nm_LH4okfm_@05okfm
a_nm_Kgo[Jfeojf]]Onm_Kd01_n][KD3ojf][@05ojf]]OnLW:Go[Jf]oibL
YOn][Jd00_nLW:D02?n][JgoS8bDocTi@_n<S8coJf]kog]kS?nLW:Go_Kfm
2_ooooooon_[jaSojn_[00Koj^[ZonWYjOoXj>Soi^KVon;Rh_oKfm/1ojn_
[`0000OoXj>Som_KfooQhN7oiNGUonSXj?oYjNWoj^[Z0?oojn_[5oo[jn/;
ooooo`09okfm_Oo>c/koBTY:obTY:On][Jgoc/kFokfm_Onm_LKoc/k>00?o
_Kg600[oc/k>okfma_nm_Kgo_Kg6okfm_Onm_LKo_Kfmojf]]Onm_Kgo_Kg6
0_n][KD00onm_LKo[Jfeojf]]@04ojf]]@03ojf][On][KGoW9bU00;o[Jf]
00coW9bUojf][OnLW:Go[Jf]oibLYOn<S8coBTY:of][JolY:BWoJf][oibL
YOnm_LH:oooooooojn_[6?o[jn/01_oZj^[ojNWYonSXj?oUiNGohN7Qom_K
f`7oXj>S00001onMWIgofMWIon3Ph?oUiNGoinOWonWYjOoZj^X0ooo[jn/G
on_[j`_ooooo00Oo_Kg6olk>e_nm_LKo_Kg6olk>e_nm_LKoc/kF00;o_Kg6
00Goc/k>okfma_o>c/ko_Kg6okfm_@03okfmaP09okfm_Onm_LKo_Kfmokfm
a_n][KGo_Kg6okfm_On][KGo_Kfm00;o[Jfe00Co_Kfmojf]]On][KGo[Jfe
0_n][Jd03_n][KGoW9bUojf]]OnLW:Go[Jf]oibLYOn][JgoNg^<odY:B_nL
W:GoS8b<oibLYOn<S9Coc/k>2_ooooooon_[jaSojn_[00Koj^[ZonWYjOoW
inOoiNGUon3Ph?oIfMT1oifMW@0000OoXj>SomOGeooOgmoohn?SonKVi_oX
j>SojNWY0?oojn_[5oo[jn/;ooooo`03okfma_oNg]koc/k>00;oc/k>00Ko
c/kFokfma_o>c/koc/k>okfma_o>c/h2okfmaP03olk>c_nm_LKo_Kfm00;o
_Kg600Ko_Kfmokfma_nm_Kgo_Kfmojf]]Onm_LH2ojf]]@03okfm_On][KGo
[Jfe00Co[Jfe0_n][Jd02On][KGoW9bUojf]]On][JgoW9bUojf][OmkNg_o
FUYJojf][@02oibLY@03oibLW?o>c]Kooooo00Woooooooo[jn/Hon_[j`06
onWYjOoXj>Soi^KVon?ShooPh>3oemOG0OnSXj<00005ojn_[ooLg=coh^;R
onKVi_oXj>P00_oZj^[oon_[jaOojn_[2oooool02_o>c/kog]kNolk>e_o>
c/koc/kFokfma_o>c]Koc/k>okfma_o>c/h2olk>eP?o_Kg600Woc/k>okfm
a_nm_Kgo_Kg6okfm_Onm_LKo_Kfmokfma_n][KD00_nm_Kd00on][KGo_Kfm
ojf]]@03ojf]]@0<ojf][On][KGo[JfeoibLYOn][Jgo[JfeoibLYOn][Jgo
[Jfeof][JomJFV_o[Jf]0_nLW:D00onLW9cog]kNooooo`09oooooooojn_[
6?o[jn/2on[ZjP04onSXj?oVi^Koh^;RomcLg07o[jn_00001OnSXj?og=cL
on;Rh_oVi^Koj>SX00;oj^[Zooo[jn/Gon_[j`_ooooo1?o>c]H02_o>c/ko
c/kFokfma_o>c]Koc/k>okfma_o>c/ko_Kg6olk>e_o>c/h4okfmaP0<okfm
_Onm_LKo_Kfmokfma_n][KGo_Kg6ojf]]Onm_LKo[Jfeokfm_On][KGo_Kfm
0on][KD02_n][Jgo[Jfeojf][On][JgoW9bUojf]]OnLW:Go[JfeoeYJJom[
Jg/2ojf][@03oibLYOn][Jgokno_00[oooooooo[jn/Hon_[j`;oj^[Z00Co
j>SXonKVi_oRh^;og=cL0OnSXj<00005oifMWOoLg=coh^;RonKVi_oXj>P0
0_oZj^[oon_[jaOojn_[2oooool01OoNg]koc/k>olk>e_o>c/koc/kF00;o
c/k>00Goc/kFokfma_o>c/koc/kFokfmaP02olk>cP03okfma_o>c/koc/k>
00?o_Kg61?nm_Kd02Onm_LKo[Jfeokfm_On][KGo_Kfmojf]]Onm_Kgo[Jfe
okfm_@04ojf]]@;o[Jf]0_n][KD01omJFU[oNg]kojf]]OnLW:Go[Jf]oibL
YOo_knl02_ooooooon_[jaSojn_[0_oZj^X01?oXj>Soi^KVon;Rh_oLg=`1
oifMW@0000GoXj>Som_KfooRh^;oi^KVonSXj002on[Zj_oojn_[5oo[jn/;
ooooo`03omkNg_o>c]Koc/kF00?oc/kF00Koc/k>olk>e_o>c]Koc/k>okfm
a_o>c]H2okfmaP04olk>e_nm_LKo_Kg6olk>cPGo_Kg600Wo_Kfmokfma_nm
_Kgo_Kg6okfm_On][KGo_Kg6okfm_OnLW:D00on][KD03?n][Jgo[Jfeojf]
]On][JgoW9bUokfm_Om:BU[oS8b<ojf][OnLW:Go[Jf]oibLY@_oooooooo[
jn/Hon_[j`;oj^[Z00Coj>SXonKVi_oRh^;ofm_K0OnSXj<00007ojn_[ooK
fm_oh^;RonKVi_oXj>SojNWYon[ZjP3oon_[jaOojn_[2oooool00ooNg]ko
c/kFolk>eP02olk>eP07olk>c_o>c]Koc/kFokfma_o>c]Koc/k>okfmaP02
olk>cP03okfma_o>c/ko_Kg600;o_Kg600[o_Kfmokfma_nm_LKo_Kfmokfm
a_nm_Kgo_Kg6ojf]]Onm_Kgo_Kg60_n][KD3ojf][@04okfm_On][KGo[Jfe
ojf][@?o[Jfe00KoBTY:ohb<U?n][JgoW9bUojf]]On][Jd;oooooooojn_[
6?o[jn/01_oZj^[ojNWYonSXj?oVi^Koh^;Rom_Kf`7o[jn_00001onSXj?o
fm_Kon7QhOoUiNGoj>SXonWYjOoZj^X0ooo[jn/Gon_[j`_ooooo00Kokno_
okfma_oNg]koc/kFolk>c_o>c]H3olk>cP05okfma_o>c]Koc/k>okfma_o>
c/h00_nm_LH01_o>c/ko_Kg6okfm_Onm_LKo_KfmokfmaP?o_Kfm00Go[Jfe
okfma_n][KGo[Jfeokfm_@02ojf]]@03oibLYOnm_Kgo[Jf]00;o[Jfe0on]
[Jd01on][KGo>CU2oibLYOn][KGoW9bUojf][Onm_Kd02oooooooon_[jaSo
jn_[00Koj^[ZonWYjOoXj>SoiNGUon7QhOoKfm/1oj>SX`0000OoWIfMomWI
fOoPh>3oiNGUonOWiooYjNWoj^[Z0?oojn_[5oo[jn/;ooooo`03ono_koo>
c/kog]kN00?oc/kF00?oc/k>olk>e_o>c]H00_o>c/h01Oo>c]Ko_Kg6olk>
c_nm_LKoc/k>00?o_Kg600?oc/k>okfma_nm_LH00onm_LH4okfm_@05ojf]
]Onm_Kgo[Jfeojf][OnLW:D01On][KD00on][Jgo[JfeodY:BP03oibLY@03
ojf][Onm_LKooooo00[oooooooo[jn/Hon_[j`06on[Zj_oYjNWoinOWonGU
iOoPh>3ofMWI0OnMWId00007oj>SXooGemOogmoOon?ShooVi^Koj>SXonWY
j@3oon_[jaOojn_[3?ooool00onm_LKog]kNolk>eP02olk>eP03ono_kooo
oooooooo00[ooooo00?oknogooooooooool02oooool00oo>c]Ko[Jfeojf]
]@03ojf]]@;o[Jf]00Ko>CU2ojf][On][JgoW9bUojf][Onm_LH;oooooooo
jn_[6?o[jn/01_oYjNWoj>SXonKVi_oShn?oh>3PomOGe`7oXj>S00001On_
[joog=cLon;Rh_oVi^Koj>SX00;oj^[Zooo[jn/Gon_[j`cooooo00Soc/k>
omkNioo>c]Kog]kNojf]]Onm_Kgoc/kFomkNgP;og]kW0_oNg]h00ooNg^Oo
g]kNomkNgP05omkNgP08olk>e_oNg]koc/kFolk>c_oNg]koc/kFolk>c_o>
c]H2olk>cP;o_Kg60_n][KD00onm_Kgo[Jfeojf][@02ojf]]@07oibLYOli
>D;o_KfmoibLYOn][JgoW9bUolk>cP0;oooooooojn_[6?o[jn/2on[ZjP04
onSXj?oVi^Koh^;RomcLg07o[jn_00001OnSXj?og=cLon;Rh_oVi^Koj>SX
00;oj^[Zooo[jn/Gon_[j`cooooo00Soc/kFomkNg_oNg]koc/kFokfm_Om[
Jg_okno_oibLY@;oFUYJ00SoFUY[of][JomJFU[oFUYJof][JomJFV_oFUYJ
oeYJJ`GoFUYJ0_mJFV/3oeYJFP03oeYJJomJFU[oJf][00;o_Kfm0on][KD0
1Onm_Kgo[Jfeojf]]OnLW:Go>CU200;o[Jfe00?o[Jf]oibLYOoNg]h02ooo
ooooon_[jaSojn_[0_oZj^X01?oXj>Soi^KVon;Rh_oLg=`1oj>SX`0000Go
WIfMomcLg?oRh^;oi^KVonSXj002on[Zj_oojn_[5oo[jn/<ooooo`0Aolk>
c_oNg^Ooc/kFomkNg_nm_LKoNg]komkNion][Jgo0000ocTi>OlH61So8B4H
o`000?li>CWo0000oaPH6?lY:C400_lH61P01?li>CWo61PHobTY:OlY:BT3
o`000006obTY:OmJFU[oBTY:o`000?li>CWo_Kg60_n][KD02Onm_Kgo[Jfe
ojf]]On][KGo_Kfmohb<U?m:BT[o_KfmoibLY@02ojf][@03omkNiooooooo
oooo00Woooooooo[jn/Hon_[j`;oj^[Z00Coj>SXonKVi_oRh^;og=cL0OnM
WId00005oj>SXooKfm_oh^;RonKVi_oXj>P00_oZj^[oon_[jaOojn_[3?oo
ool02OoNg]koc/kFolk>e_oNg^Ooc/kFof][NooNg]ko[Jf]oaPH6002odY:
BP0@ocTi>Om:BT[oBTY:ocTi>Om:BT[oBU8aocTi@_m:BT[o>CTiodY:B_li
>CWoBTY:odYB<OmJFU[o61PHoeYJFP;oNg]k00Oo61PHocTi@_o>c/ko[Jfe
okfma_n][KGo_Kfm00?o[Jfe00?oS8b<oeYJF_n][KD00_n][KD00on][Jgo
kno_ooooo`0:oooooooojn_[6?o[jn/2on[ZjP04onSXj?oVi^Koh^;Rom_K
f`7oXj>S00001on_[joofm_Kon;Rh_oVi^Koj>SXonWYjOoZj^X0ooo[jn/G
on_[j`cooooo00?og]kNolk>e_oNg]h00_o>c]H03_m[Jf_og]kNokfma_l0
003oFUYJodY:B_mkNg_o>CTioeYJF_m[Jf_oBTY:odY:F_mJFU[oBTY:0_mJ
FUX03_m:BU[oFUYJoeYJF_m[Jf_o0000ocTi>On][JgoNg]koaPH6?li>CWo
c/k>okfm_On][KGo_Kg60on][KD02?nm_KgoNg]koeYJJonm_Kgo[Jf]ojf]
]On][Jgokno_2oooooooon_[jaSojn_[00Koj^[ZonWYjOoXj>Soi^KVon;R
h_oKfm/1ojn_[`0000OoXj>Som_KfooQhN7oiNGUonSXj?oYjNWoj^[Z0?oo
jn_[5oo[jn/<ooooo`Gog]kN00?oW9bUolk>e_o>c/h00on<S8`00omkNhco
S8b<og]kN`03og]kN`03og]kS?n<S8coNg]k00;oNg]k00[oNg^<og]kNomk
Ng_oNg^<og]kNon<S8coJf]kog]kNon<S9Co_Kg60_nm_Kd01On][KGo_Kg6
ojf]]On][KGo_Kfm00;oW9bU1?n][KD<oooooooojn_[6?o[jn/01_oZj^[o
jNWYonSXj?oUiNGohN7Qom_Kf`7oXj>S00001onMWIgofMWIon3Ph?oUiNGo
inOWonWYjOoZj^X0ooo[jn/Gon_[j`cooooo00Kokno_olk>c_oNg^Ooc/k>
olk>e_oNg]h2olk>eP03omkNiooNg]kog]kW00?og]kW0_oNg]h01_oNg^Oo
c/kFolk>e_oNg^Ooc/kFomkNgPGoc/kF00[o_Kg6olk>c_o>c/koc/k>ojf]
]Onm_LKo[Jfeokfm_On][KGo_Kfm0_n][KD01_nm_Kgo[Jfeojf]]On][Jgo
[Jfeokfm_@coooooooo[jn/Hon_[j`06on[Zj_oYjNWoinOWonGUiOoPh>3o
fMWI0OnMWId00007oj>SXooGemOogmoOon?ShooVi^Koj>SXonWYj@3oon_[
jaOojn_[3?ooool01_o_knooc/kFokfma_lY:C7oFUY[ono_k`;og]kN00?o
c/kFomkNg_o>c]H01_o>c]H2olk>cP03okfma_o>c]Ko_Kg600;oc/k>00Co
_Kg6olk>c_nm_LKoc/k>0onm_LH00oo>c/ko_KfmokfmaP02okfm_@07ojf]
]Onm_LKo[Jfeokfm_OnLW9co>CU2oeYJFP02okfm_@coooooooo[jn/Hon_[
j`06onWYjOoXj>Soi^KVon?ShooPh>3oemOG0OnSXj<00005ojn_[ooLg=co
h^;RonKVi_oXj>P0oooZj^XIon[ZjPgooooo00[okno_omkNg_nLW:Go_Kfm
ono_kooNg^Oog]kNomkNiooNg]kog]kW3?oNg]h02oo>c]Kog]kNolk>c_oN
g]koc/kFolk>c_oNg]koc/k>olk>e_o>c/koc/kF00Goc/k>00Go_Kg6olk>
c_n<S8coW9bUolk>cP0=ooooooooj^[Z6_oZj^X01?oXj>Soi^KVon;Rh_oL
g=`1ojn_[`0000GoXj>SomcLg?oRh^;oi^KVonSXj03oon[ZjQWoj^[ZAOoo
ooooon[ZjQ[oj^[Z00Coj>SXonKVi_oRh^;og=cL0OnSXj<00005oifMWOoL
g=coh^;RonKVi_oXj>P0oooZj^XIon[ZjTGooooooooZj^XJon[ZjP04onSX
j?oVi^Koh^;RomcLg07oWIfM00001OnSXj?ofm_Kon;Rh_oVi^Koj>SX0?oo
j^[Z6OoZj^Y5ooooooooj^[Z6_oZj^X01?oXj>Soi^KVon;Rh_oKfm/1oj>S
X`0000Ko[jn_om_KfooRh^;oi^KVonSXj?oYjNWoon[ZjQSoj^[ZAOoooooo
on[ZjQWoj^[Z00GojNWYonSXj?oVi^Koh^;Rom_Kf`01ojn_[`0000KoXj>S
om_KfooQhN7oiNGUonSXj?oYjNWoon[ZjQSoj^[ZAOooooooon[ZjQWoj^[Z
00GojNWYonSXj?oUiNGohN7Qom_Kf`01oj>SX`0000KoWIfMomWIfOoPh>3o
iNGUonOWiooYjNWoon[Zj_ooj^[ZM_oZj^X01OoYjNWoinOWonGUiOoPh>3o
fMWI007oWIfM00001onSXj?oemOGomoOgooShn?oi^KVonSXj?oYjNT0oooZ
j^[oon[ZjWCoj^[Z00KojNWYonSXj?oVi^Kohn?Son3Ph?oGemL1oj>SX`00
00Go[jn_omcLg?oRh^;oi^KVonSXj03oon[Zj_ooj^[ZN?oZj^X01?oXj>So
i^KVon;Rh_oLg=`1ojn_[`0000GoXj>SomcLg?oRh^;oi^KVonSXj03oon[Z
j_ooj^[ZN?oZj^X01?oXj>Soi^KVon;Rh_oLg=`1oj>SX`0000GoWIfMomcL
g?oRh^;oi^KVonSXj03oon[Zj_ooj^[ZN?oZj^X01?oXj>Soi^KVon;Rh_oL
g=`1oifMW@0000GoXj>Som_KfooRh^;oi^KVonSXj03oon[Zj_ooj^[ZN?oZ
j^X01?oXj>Soi^KVon;Rh_oKfm/1oj>SX`0000Ko[jn_om_KfooRh^;oi^KV
onSXj?oYjNWoon[Zj_ooj^[ZM_oZj^X01OoYjNWoj>SXonKVi_oRh^;ofm_K
007o[jn_00001_nSXj?ofm_Kon7QhOoUiNGoj>SXonWYjOooj^[ZoooZj^Yf
on[ZjP05onWYjOoXj>SoiNGUon7QhOoKfm/00OnSXj<00006oifMWOoIfMWo
h>3PonGUiOoWinOojNWYoooZj^[oon[ZjWKoj^[Z00GojNWYonOWiooUiNGo
h>3PomWIf@01oifMW@0000KoXj>SomOGeooOgmoohn?SonKVi_oXj>RIonWY
j@Goj^[Z1?oYjNWoon[Zj];oj^[Z00KojNWYonSXj?oVi^Kohn?Son3Ph?oG
emL1oj>SX`0000Go[jn_omcLg?oRh^;oi^KVonSXj03oon[Zj_ooj^[ZN?oZ
j^X01?oXj>Soi^KVon;Rh_oLg=`1ojn_[`0000GoXj>SomcLg?oRh^;oi^KV
onSXj002on[ZjYSojNWY1OoZj^X4onWYjOooj^[Ze?oZj^X01?oXj>Soi^KV
on;Rh_oLg=`1oj>SX`0000GoWIfMomcLg?oRh^;oi^KVonSXj002on[ZjYSo
jNWY1OoZj^X4onWYjOooj^[Ze?oZj^X01?oXj>Soi^KVon;Rh_oLg=`1oifM
W@0000GoXj>Som_KfooRh^;oi^KVonSXj002on[ZjYSojNWY1OoZj^X4onWY
jOooj^[Ze?oZj^X01?oXj>Soi^KVon;Rh_oKfm/1oj>SX`0000Oo[jn_om_K
fooRh^;oi^KVonSXj?oYjNWoj^[Z09SojNWY1OoZj^X4onWYjOooj^[ZdooZ
j^X01OoYjNWoj>SXonKVi_oRh^;ofm_K007o[jn_00001onSXj?ofm_Kon7Q
hOoUiNGoj>SXonWYjOoZj^X0V?oYjNT5on[ZjPCojNWYoooZj^[Con[ZjP05
onWYjOoXj>SoiNGUon7QhOoKfm/00OnSXj<00007oifMWOoIfMWoh>3PonGU
iOoWinOojNWYon[ZjP2HonWYj@Goj^[Z1?oYjNWoon[Zj]?oj^[Z00GojNWY
onOWiooUiNGoh>3PomWIf@01oifMW@0000KoXj>SomOGeooOgmoohn?SonKV
i_oXj>RIonWYj@Goj^[Z1?oYjNWoon[Zj];oj^[Z00KojNWYonSXj?oVi^Ko
hn?Son3Ph?oGemL1oj>SX`0000Go[jn_omcLg?oRh^;oi^KVonSXj002on[Z
jYSojNWY1OoZj^X4onWYjOooj^[Ze?oZj^X01?oXj>Soi^KVon;Rh_oLg=`1
ojn_[`0000GoXj>SomcLg?oRh^;oi^KVonSXj002on[ZjYSojNWY1OoZj^X4
onWYjOooj^[Ze?oZj^X01?oXj>Soi^KVon;Rh_oLg=`1oj>SX`0000GoWIfM
omcLg?oRh^;oi^KVonSXj002on[ZjYSojNWY1OoZj^X4onWYjOooj^[Ze?oZ
j^X01?oXj>Soi^KVon;Rh_oLg=`1oifMW@0000GoXj>Som_KfooRh^;oi^KV
onSXj002on[ZjYSojNWY1OoZj^X4onWYjOooj^[Ze?oZj^X01?oXj>Soi^KV
on;Rh_oKfm/1oj>SX`0000Oo[jn_om_KfooRh^;oi^KVonSXj?oYjNWoj^[Z
09SojNWY1OoZj^X4onWYjOooj^[ZdooZj^X01OoYjNWoj>SXonKVi_oRh^;o
fm_K007o[jn_00001onSXj?ofm_Kon7QhOoUiNGoj>SXonWYjOoZj^X0V?oY
jNT5on[ZjPCojNWYoooZj^[Con[ZjP05onWYjOoXj>SoiNGUon7QhOoKfm/0
0OnSXj<00007oifMWOoIfMWoh>3PonGUiOoWinOojNWYon[ZjP2HonWYj@Go
j^[Z1?oYjNWoon[Zj]?oj^[Z00GojNWYonOWiooUiNGoh>3PomWIf@01oifM
W@0000KoXj>SomOGeooOgmoohn?SonKVi_oXj>RIonWYj@Goj^[Z1?oYjNWo
on[Zj];oj^[Z00KojNWYonSXj?oVi^Kohn?Son3Ph?oGemL1oj>SX`0000Oo
/;2`omCDe?oRh^;oi^KVonWYjOoZj^[ojn_[0?ook>c/ooo/k>adonc/k006
on_[jooZj^[ojNWYonKVi_oRh^;oe=CD0On`/;000005ojRXZ?o?clool?3`
oo;bl_odm?@00ooemOD01Oofm_KomOGeooGemOoemOGom_Kf00?omOGe00Go
m_KfooGemOoemOGomOGeooKfmP03ooGem@05ooKfm_oemOGomOGeooGemOof
m_H00ooemOD01Oofm_KomOGeooGemOoemOGom_Kf00?omOGe00Gom_KfooGe
mOoemOGomOGeooKfmP03ooGem@05ooKfm_oemOGomOGeooGemOofm_H00ooe
mOD01Oofm_KomOGeooGemOoemOGom_Kf00?omOGe00Gom_KfooGemOoemOGo
mOGeooKfmP03ooGem@05ooKfm_oemOGomOGeooGemOofm_H00ooemOD01Oof
m_KomOGeooGemOoemOGom_Kf00?omOGe00Gom_KfooGemOoemOGomOGeooKf
mP03ooGem@05ooKfm_oemOGomOGeooGemOofm_H00ooemOD01Oofm_KomOGe
ooGemOoemOGom_Kf00?omOGe00Gom_KfooGemOoemOGomOGeooKfmP03ooGe
m@05ooKfm_oemOGomOGeooGemOofm_H00ooemOD01Oofm_KomOGeooGemOoe
mOGom_Kf00?omOGe00Gom_KfooGemOoemOGomOGeooKfmP03ooGem@05ooKf
m_oemOGomOGeooGemOofm_H00ooemOD01Oofm_KomOGeooGemOoemOGom_Kf
00?omOGe00Gom_KfooGemOoemOGomOGeooKfmP03ooGem@05ooKfm_oemOGo
mOGeooGemOofm_H00ooemOD01Oofm_KomOGeooGemOoemOGom_Kf00?omOGe
00Gom_KfooGemOoemOGomOGeooKfmP03ooGem@05ooKfm_oemOGomOGeooGe
mOofm_H00ooemOD01Oofm_KomOGeooGemOoemOGom_Kf00?omOGe00Gom_Kf
ooGemOoemOGomOGeooKfmP03ooGem@05ooKfm_oemOGomOGeooGemOofm_H0
0ooemOD01Oofm_KomOGeooGemOoemOGom_Kf00?omOGe00Gom_KfooGemOoe
mOGomOGeooKfmP03ooGem@05ooKfm_oemOGomOGeooGemOofm_H00ooemOD0
1Oofm_KomOGeooGemOoemOGom_Kf00?omOGe00Gom_KfooGemOoemOGomOGe
ooKfmP03ooGem@05ooKfm_oemOGomOGeooGemOofm_H00ooemOD01Oofm_Ko
mOGeooGemOoemOGom_Kf00?omOGe00Gom_KfooGemOoemOGomOGeooKfmP03
ooGem@05ooKfm_oemOGomOGeooGemOofm_H00ooemOD01Oofm_KomOGeooGe
mOoemOGom_Kf00?omOGe00Gom_KfooGemOoemOGomOGeooKfmP03ooGem@05
ooKfm_oemOGomOGeooGemOofm_H00ooemOD01Oofm_KomOGeooGemOoemOGo
m_Kf00?omOGe00Gom_KfooGemOoemOGomOGeooKfmP03ooGem@05ooKfm_oe
mOGomOGeooGemOofm_H00ooemOD01Oofm_KomOGeooGemOoemOGom_Kf00?o
mOGe00Gom_KfooGemOoemOGomOGeooKfmP03ooGem@05ooKfm_oemOGomOGe
ooGemOofm_H00ooemOD01Oofm_KomOGeooGemOoemOGom_Kf00?omOGe00Go
m_KfooGemOoemOGomOGeooKfmP03ooGem@05ooKfm_oemOGomOGeooGemOof
m_H00ooemOD01Oofm_KomOGeooGemOoemOGom_Kf00?omOGe00Gom_KfooGe
mOoemOGomOGeooKfmP03ooGem@05ooKfm_oemOGomOGeooGemOofm_H00ooe
mOD01Oofm_KomOGeooGemOoemOGom_Kf00?omOGe00Gom_KfooGemOoemOGo
mOGeooKfmP03ooGem@05ooKfm_oemOGomOGeooGemOofm_H00ooemOD01Oof
m_KomOGeooGemOoemOGom_Kf00?omOGe00Gom_KfooGemOoemOGomOGeooKf
mP03ooGem@05ooKfm_oemOGomOGeooGemOofm_H00ooemOD01Oofm_KomOGe
ooGemOoemOGom_Kf00?omOGe00Gom_KfooGemOoemOGomOGeooKfmP03ooGe
m@05ooKfm_oemOGomOGeooGemOofm_H00ooemOD01Oofm_KomOGeooGemOoe
mOGom_Kf00?omOGe00Gom_KfooGemOoemOGomOGeooKfmP03ooGem@05ooKf
m_oemOGomOGeooGemOofm_H00ooemOD01Oofm_KomOGeooGemOoemOGom_Kf
00?omOGe00Gom_KfooGemOoemOGomOGeooKfmP03ooGem@05ooKfm_oemOGo
mOGeooGemOofm_H00ooemOD01Oofm_KomOGeooGemOoemOGom_Kf00?omOGe
00Gom_KfooGemOoemOGomOGeooKfmP03ooGem@05ooKfm_oemOGomOGeooGe
mOofm_H00ooemOD01Oofm_KomOGeooGemOoemOGom_Kf00?omOGe00Gom_Kf
ooGemOoemOGomOGeooKfmP03ooGem@05ooKfm_oemOGomOGeooGemOofm_H0
0ooemOD01Oofm_KomOGeooGemOoemOGom_Kf00?omOGe00Gom_KfooGemOoe
mOGomOGeooKfmP03ooGem@05ooKfm_oemOGomOGeooGemOofm_H00ooemOD0
1Oofm_KomOGeooGemOoemOGom_Kf00?omOGe00Gom_KfooGemOoemOGomOGe
ooKfmP03ooGem@05ooKfm_oemOGomOGeooGemOofm_H00ooemOD01oofm_Ko
mOGeooCdm?odm?Col_;boo3`l?o?cll00OnXZ:P00005ojb/[?o6a/Kolo?c
ooGemOofm_H00oogmoL01?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg00Co
n?ShooOgmoohn?SomoOg0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;o
n?Sh0_ogmoL01?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg00Con?ShooOg
moohn?SomoOg0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh0_og
moL01?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg00Con?ShooOgmoohn?So
moOg0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh0_ogmoL01?oh
n?SomoOgooShn?ogmoL2ooShn0;omoOg00Con?ShooOgmoohn?SomoOg0_oh
n?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh0_ogmoL01?ohn?SomoOg
ooShn?ogmoL2ooShn0;omoOg00Con?ShooOgmoohn?SomoOg0_ohn?P2ooOg
m`04ooShn?ogmoOon?ShooOgm`;on?Sh0_ogmoL01?ohn?SomoOgooShn?og
moL2ooShn0;omoOg00Con?ShooOgmoohn?SomoOg0_ohn?P2ooOgm`04ooSh
n?ogmoOon?ShooOgm`;on?Sh0_ogmoL01?ohn?SomoOgooShn?ogmoL2ooSh
n0;omoOg00Con?ShooOgmoohn?SomoOg0_ohn?P2ooOgm`04ooShn?ogmoOo
n?ShooOgm`;on?Sh0_ogmoL01?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg
00Con?ShooOgmoohn?SomoOg0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOg
m`;on?Sh0_ogmoL01?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg00Con?Sh
ooOgmoohn?SomoOg0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh
0_ogmoL01?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg00Con?ShooOgmooh
n?SomoOg0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh0_ogmoL0
1?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg00Con?ShooOgmoohn?SomoOg
0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh0_ogmoL01?ohn?So
moOgooShn?ogmoL2ooShn0;omoOg00Con?ShooOgmoohn?SomoOg0_ohn?P2
ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh0_ogmoL01?ohn?SomoOgooSh
n?ogmoL2ooShn0;omoOg00Con?ShooOgmoohn?SomoOg0_ohn?P2ooOgm`04
ooShn?ogmoOon?ShooOgm`;on?Sh0_ogmoL01?ohn?SomoOgooShn?ogmoL2
ooShn0;omoOg00Con?ShooOgmoohn?SomoOg0_ohn?P2ooOgm`04ooShn?og
moOon?ShooOgm`;on?Sh0_ogmoL01?ohn?SomoOgooShn?ogmoL2ooShn0;o
moOg00Con?ShooOgmoohn?SomoOg0_ohn?P2ooOgm`04ooShn?ogmoOon?Sh
ooOgm`;on?Sh0_ogmoL01?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg00Co
n?ShooOgmoohn?SomoOg0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;o
n?Sh0_ogmoL01?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg00Con?ShooOg
moohn?SomoOg0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh0_og
moL01?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg00Con?ShooOgmoohn?So
moOg0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh0_ogmoL01?oh
n?SomoOgooShn?ogmoL2ooShn0;omoOg00Con?ShooOgmoohn?SomoOg0_oh
n?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh0_ogmoL01?ohn?SomoOg
ooShn?ogmoL2ooShn0;omoOg00Con?ShooOgmoohn?SomoOg0_ohn?P2ooOg
m`04ooShn?ogmoOon?ShooOgm`;on?Sh0_ogmoL01?ohn?SomoOgooShn?og
moL2ooShn0;omoOg00Con?ShooOgmoohn?SomoOg0_ohn?P2ooOgm`04ooSh
n?ogmoOon?ShooOgm`;on?Sh0_ogmoL01?ohn?SomoOgooShn?ogmoL2ooSh
n0;omoOg00Con?ShooOgmoohn?SomoOg0_ohn?P2ooOgm`04ooShn?ogmoOo
n?ShooOgm`;on?Sh0_ogmoL01?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg
00Con?ShooOgmoohn?SomoOg0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOg
m`;on?Sh0_ogmoL01?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg00Con?Sh
ooOgmoohn?SomoOg0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh
0_ogmoL01?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg00Con?ShooOgmooh
n?SomoOg0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh0_ogmoL0
1?ohn?SomoOgooShn?ogmoL2ooShn0;omoOg00Con?ShooOgmoohn?SomoOg
0_ohn?P2ooOgm`04ooShn?ogmoOon?ShooOgm`;on?Sh0_ogmoL01oohn?So
moOgooOgmoofm_KomOGeoo?cloo6a/H00On/[:`00005olC4a?n^[Zkoj^[Z
ooCdm?oemOD00oofm_H00oogmoOom_KfooKfmP04ooOgm`04ooKfm_ogmoOo
m_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOg
ooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOg
moofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_og
moOom_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_Ko
moOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Com_Kf
ooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKf
m_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?of
m_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Co
m_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04
ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL0
1?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg
00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOg
m`04ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf1?og
moL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPCo
moOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4
ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf
1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKf
mPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_of
m_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoofm_Ko
m_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_Kf
ooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKf
m_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoof
m_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOo
m_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOg
ooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOg
moofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_og
moOom_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_Ko
moOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Com_Kf
ooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKf
m_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?of
m_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Co
m_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04
ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL0
1?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg
00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4ooOg
m`04ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf1?og
moL01?ofm_KomoOgooKfm_ofm_H4ooOgm`04ooKfm_ogmoOom_KfooKfmPCo
moOg00Com_KfooOgmoofm_Kom_Kf1?ogmoL01?ofm_KomoOgooKfm_ofm_H4
ooOgm`04ooKfm_ogmoOom_KfooKfmPComoOg00Com_KfooOgmoofm_Kom_Kf
1?ogmoL00oofm_KomoOgooKfmP02ooGem@03ooCdm?oZj^[o[Zj^007oa<C4
00001?oWinOo[jn_om7AdOoXj>P2oo;blP;olo?c1oodm?@00ooclo?om?Cd
ooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@0
1Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd
00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?c
loodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?Cd
ooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@0
1Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd
00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?c
loodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?Cd
ooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@0
1Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd
00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?c
loodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?Cd
ooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@0
1Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd
00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?c
loodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?Cd
ooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@0
1Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd
00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?c
loodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?Cd
ooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@0
1Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd
00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?c
loodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?Cd
ooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@0
1Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd
00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?c
loodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?Cd
ooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@0
1Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd
00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?c
loodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@01Oodm?@00ooclo?om?Cd
ooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd00?olo?cooCdm?odm?@0
1Oodm?@00ooclo?om?CdooCdm005ooCdm003oo?cloodm?Com?Cd00Gom?Cd
00Solo?cooCdm?oclo?olo?coo7alOoXj>Sod=3@ojn_[`7oinOW00001ooV
i^KocLg=ojb/[?nVYZKo/K6aokNg]onk^k/00_nn_[h6okno_`;o_[jn1_no
_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn
_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no
_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn
_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no
_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn
_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no
_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn
_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no
_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn
_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no
_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn
_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no
_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn
_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no
_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn
_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no
_kl2okjn_PKo_kno0_nn_[h6okno_`;o_[jn1_no_kl2okjn_PKo_kno0_nn
_[h01_nk^k_o]kNgok6a/OnVYZKo[:b/olg=c@7oi^KV003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP0000gok^k^ong]kOo]kNgo
jn_[onSXj?oUiNGoh^;RomgMgOoHf=Soe=CDom7AdOo>c/koc<c<00;obl_;
ooo:b/[ool[:bV?ob/[:0_o;bl/02_o<c<coc/k>om7AdOoDe=Cof=SHomgM
gOoRh^;oiNGUonSXj?o[jn/2ong]k@;ok^k^0002ooknoP0:oo_knooinOWo
lo?cong]kOoUiNGog=cLomCDe?o<c<coalO7ol?3``;o`<300_no_koookjn
__oo_[jnHOnn_[h2okno_`;o`<3000[o`l?3olO7aoo<c<coe=CDomcLg?oU
iNGokNg]oo?clooinOWono_k0_ono_h1ooooo`0000kokNg]on[Zj_oWinOo
h^;RomWIfOo>c/ko`l?3okRh^?n^[ZkoYZJVoj2PX?nLW9coVIVIoiRHV?oo
UiNGoonGUiMUoiNGU`0=oiRHV?nIVIWoW9bLoj2PX?nVYZKo[Zj^okRh^?o3
`l?oc/k>omWIfOoRh^;oinOWon[ZjP02ong]k@0000gohn?Son3Ph?oJf][o
dM7AolG5aOng]kOoZ:RXoibLW?n@T93oR8R8oh61POmnOWkoNg]k0?ooNWYj
oomjNWYWogYjNP0=og]kNomnOWkoPH61ohR8R?n@T93oW9bLojRXZ?ng]kOo
aLG5om7AdOoJf][oh>3Pon?Sh`01onGUi@0001Coj>SXon;Rh_oIfMWob/[:
okZj^_nXZ:SoV9RHoi:BT_nUYJGo`<30omOGeoo[jn_om_KfooOgmooinOWo
n?ShooWinOojn_[onOWiooOgm`?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00Con?Sh00oonOWiooShn?ogmoOokNg]omSHf?o1`L7oYJFUoi:BT_nH
V9SoZ:RXokZj^_o:b/[ofMWIon;Rh_oXj>P00Oo/k>`0000<ooKfm_o]kNgo
gMgMol[:b_nd];CoWinOojZZZ_o>c/kok^k^ooKfm_olo?coo_knoooooooo
ooooofWooooo00coo_knooclo?ogmoOokno_olo?con[Zj_oWinOokBd]?o:
b/[ogMgMong]kOofm_H1oo_kn`0000[oh^;RomKFe_o3`l?o[Zj^oiZJV_n]
[Jgog]kNon_[joodm?Cono_kooooooooooooofgooooo00[ono_koo?cloo/
k>cohN7Qok2`/?nJVY[o[Zj^ol?3`ooFe]Koh^;R0OoXj>P0000:omKFe_o7
alOo/[:boibLW?nWYjOoe=CDon3Ph?o/k>comOGeoogmoOoooooooooooom]
ooooo`0:ookno_ofm_Kok>c/on;Rh_oIfMWoZj^[oibLW?nb/[;oalO7omKF
eP7ogMgM00002ooHf=Soa/K6ojj^[_nSXj?oa/K6omCDe?oPh>3ok>c/oo;b
l_olo?coo_kn0?oooooooooooom/ooooo`0:oo[jn_odm?Coj^[Zon?ShooG
emOocLg=ojJVY_n^[Zkoa/K6omSHf07oh^;R00003ooShn?ocLg=ok2`/?n_
[jooa/K6om;Bd_oLg=coi^KVonc/k?oemOGon?Shoo[jn_omoOgooooooocl
o008ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo00?o
oOgmooooooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoo
oooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooooooo
o`05ooooo`03oogmoOoooooooooo00Gooooo00?ooOgmooooooooool01Ooo
ool00oomoOgoooooooooo`06ooooo`0?oogmoOoooooooOgmoo_knoohn?So
m?Cdong]kOoVi^KogmoOomKFe_o<c<co]KFeok6a/Oo=cLgohn?S007olo?c
00004ooAdM7o^k^koj6QXOnf][Ko`l?3olo?cooFe]KogmoOonKVi_oZj^[o
kno_oo?cloodm?ComOGeooOgmoofm_KomoOgooKfm_ohn?P00_ogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_Kf
ooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooSh
n?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_og
moL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOo
moOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?of
m_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?So
moOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg
00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOg
m`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_Kf
ooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf
0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL0
1?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg
0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Ko
n?ShooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2
ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOg
moogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04
ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2
ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_oh
n?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;o
moOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOg
ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg00Co
m_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL3ooKfmP0?ooOgmoofm_Kom?Cd
oo;bl_o`l?3ojn_[onKVi_oQhN7of][Jom?Cdoo9bLWo_knoojJVY_nk^k_o
dM7A007ohN7Q00002oo9bLWo/[:boijNW_nc/k?o`<30olW9bOoCdm?ofMWI
omgMgOoRh^;oiNGU00;oj^[Z00?ok>c/ong]kOo]kNd01oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Go
k^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03
oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^k^h01Oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h2ong]k@;ok>c/00cojNWYonKVi_oShn?oh>3Pom_KfooEeMGo
cLg=olG5aOnk^k_oYJFUok:b/_o9bLT1omSHf00000godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
TooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kN
U?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooN
g]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5
omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgM
g@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Go
g]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kN
f_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8
on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oM
gMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
d@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5
omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01
omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkN
gPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Q
h@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCo
gMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM
@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000go
b/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooN
g]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5
omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8
b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgM
g@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Co
g]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
TooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kN
U?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooN
g]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5
omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgM
g@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Go
g]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kN
f_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oM
gMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3P
h001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5
omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01
on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkN
gPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWI
f@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCo
gMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@00
00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM
@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000go
dM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooN
g]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:
okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5
omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k
^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgM
g@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nE
UIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Co
g]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
TooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kN
U?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooN
g]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5
omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgM
g@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQ
XJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Go
g]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o
^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kN
f_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFe
ol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oM
gMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
d@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5
omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001
oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkN
gPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Q
h@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCo
gMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@00
00godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM
@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000go
h>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJ
f][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooN
g]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7A
ok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][o
fm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5
omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@
ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe
]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgM
g@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:
b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onD
U9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?o
g=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Co
g]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5
aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGo
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
TooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kN
U?oMgMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo
_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooN
g]h5omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oM
gMd2omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf
]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5
omgMg@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2
omcLg00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`
/?nPX:3o]KFeol[:bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0
`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgM
g@Gog]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcL
g00=om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nP
X:3o^k^kom7Ad@01on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3o
a/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Go
g]kNf_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=
om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7o
b<S8on3Ph001oo7al@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6
olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kN
f_oMgMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_K
fooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^k
om7Ad@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<
c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oM
gMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5
omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01
on7Qh@0000goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkN
gPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SH
omKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph001oo7a
l@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CD
omOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNf_oMgMd5omkNgPCo
gMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJf][of=SHomKF
e_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7Ad@01on7Qh@00
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kN]?oMgMd00oo4a<Co^KVi
omcLg00SomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoN
g]iTomgMg@0<obh^;_n?ShoogMgMolg=cOn:RX[ob/[:omgMgOnUYJGo0@41
omgMgOm3@d?oI6AT1OoMgMd00olX:2SoDU9BomgMg@02omgMg@03of9RH_l`
<33ogMgM00?ogMgM00?o;Rh^ofATI?oMgMd00ooMgMd01Ol20P;oT92@omgM
gOoMgMgo;Rh^00Co000000ko>SXjomgMgOl^;RkoShn?omgMgOo=cLgoRXZ:
ol[:b_oMgMgoYJFUo`410OoMgMgo@d=3ofATI0GogMgM00?o:2PXoe9BD_oM
gMd00_oMgMd00omRHV;o<30`omgMg@03omgMg@03obd];OmVIVKogMgM00;o
gMgM00WoR8R8oa0@4?l71`Oo8B4QoaLG5om1@D7o_;blod=3@omTI6@01OoM
gMd00olX:2SoDU9BomgMg@0GomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oN
g]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bC
omkNgPGogMgM1OoNg]iTomgMg@0=obh^;_n?ShoogMgMog]kNol0003oLg=c
omgMgOnUYJGo0@41omgMgOnLW9co4Q8BomOGe`03omgMg@03ojn_[ol0003o
ZJVY00?ogMgM00?oHV9Roc0`<?oMgMd00ooMgMd00ol^;RkoI6ATomgMg@03
omgMg@06o`820_n@T93ogMgMomgMgOl^;RkoI6AT1OoMgMd03Ol^;RkoShn?
omgMgOmkNg_o0000og=cLooMgMgoYJFUo`410OoMgMgoW9bLoa8B4_oGemL0
0ooMgMd00on_[joo0000ojVYZ@03omgMg@03of9RH_l`<33ogMgM00?ogMgM
00oo;Bd]ofIVI_oMgMgogMgMoh>3Pol20P;oN7Qhom[Jf_oMgMgofm_KoiZJ
V_nk^k_oW9bLoa8B4_oGemL00ooMgMd00on_[joo0000ojVYZ@0HomgMg@Go
g]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007o
lO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]iTomgMg@0=obh^
;_n?ShoogMgMob/[:olm?Cgo8B4QomgMgOnUYJGo0@41omgMgOoJf][o61PH
of9RHP03ohF5Q@03oclo?olR8R;ogMgM00?ogMgM00?oHV9Roc0`<?oMgMd0
0ooMgMd00ol^;RkoI6ATomgMg@03omgMg@06o`820_n@T93ogMgMomgMgOl^
;RkoI6AT1OoMgMd03Ol^;RkoShn?omgMgOl[:b_o?Cdmob4Q8OoMgMgoYJFU
o`410OoMgMgof][JoaPH6?mRHV800on5QHD00olo?coo8R8RomgMg@03omgM
g@03of9RH_l`<33ogMgM00?ogMgM00Ko;Bd]ofIVI_oMgMgoe]KFoa4A4OmE
EED6omgMg@03om[Jf_lH61SoHV9R00?oQHF500?o?cloob8R8_oMgMd06?oM
gMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o^k^kom7A
d@01on7Qh@0000gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNI?oMgMd0
2Ol^;RkoShn?okZj^_l0003o]kNgob@T9?n][JgoYJFUo`410@02omgMg@07
ofi^K_l=3@goFUYJoeYJF_m@D53o0000ogQhN004omgMg@03of9RH_l`<33o
gMgM00?ogMgM00?o;Rh^ofATI?oMgMd00ooMgMd01_l20P;oT92@omgMgOoM
gMgo;Rh^ofATI0GogMgM00Wo;Rh^ohn?Sonj^[[o0000okNg]olT92Co[Jf]
ojFUYOl10@400_oMgMd01om^KVko3@d=oeYJF_mJFU[oD51@o`000?mhN7P0
1?oMgMd00omRHV;o<30`omgMg@03omgMg@06obd];OmVIVKogMgMokNg]ol0
003oZ:RX1ooMgMd01om^KVko3@d=oeYJF_mJFU[oD51@o`000?mhN7P06OoM
gMd5omkNgPCogMgM@ooNg]h5omgMg@Cog]kNU?oMgMd2omcLg00=om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
bP01omWIf@0000godM7Aok^k^onDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oA
dM7oe=CDomOGeooJf][ofm_K00?og=cLTooNg]h5omgMg@Gog]kNI?oMgMd0
2Ol^;RkoShn?of][JolY:BWogMgMogIfM_mKFe_oYJFUo`410@02omgMg@07
ol?3`ol20P;o_knoomgMgOn8R8So10@4ol[:bP04omgMg@03of9RH_l`<33o
gMgM00?ogMgM00?o;Rh^ob/[:omPH6000omPH6001_l0003oT92@omgMgOoM
gMgo;Rh^obLW9`;oF5QH00coKVi^omgMgOoMgMgo;Rh^ohn?Som[Jf_o:BTY
omgMgOmfMWKoFe]KojFUYOl10@42omgMg@07ol?3`ol20P;o_knoomgMgOn8
R8So10@4ol[:bP04omgMg@03of9RH_l`<33ogMgM00?ogMgM00Ko;Bd]ofIV
I_oMgMgoVi^Ko`000?o3`l<7omgMg@07ol?3`ol20P;o_knoomgMgOn8R8So
10@4ol[:bP0IomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM
1OoNg]iTomgMg@09obh^;_n>SXko6a/KogQhN?oMgMgoaLG5oa4A4OnOWioo
0@4100?ogMgM00Go@410ofQXJ?oMgMgo<30`odM7A`05omgMg@03of9RH_l`
<33ogMgM00?ogMgM00?o;Rh^ocPh>?mlO7`00omlO7`01_l10@7oT92@omgM
gOoMgMgo;Rh^ocdm?@;oR8R800coUYJFomgMgOoMgMgo;Rh^ohj>S_lK6a_o
N7QhomgMgOo5aLGo4A4AoinOWol10@43omgMg@05od10@?mXJ6SogMgMoc0`
<?m7AdL01OoMgMd00omRHV;o<30`omgMg@03omgMg@06obd];OmVIVKogMgM
ojb/[?l0003o][Jf2?oMgMd01Om0@43oJ6QXomgMgOl`<33oAdM701[ogMgM
1OoNg]h4omgMgD?og]kN1OoMgMd4omkNgYCogMgM0_oLg=`03OoKfm_of][J
omSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3oXJ6QolS8b?oPh>00
0OoalO40000=om7AdOnk^k_oU9BDojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg9?og]kN1OoMgMd5omkNgVCogMgM00Co
;Rh^oe]KFol10@7oa/K60_oMgMd00oll?3coGEeMo`410@03omgMg@05oiNG
UolD51Co/[:bo`000?nNWYh01OoMgMd00omRHV;o<30`omgMg@03omgMg@03
obh^;_mTI6CogMgM00?ogMgM00Ko0P82oi2@T?oMgMgogMgMobh^;_mTI6@5
omgMg@04obh^;_mKFe_o0@41olK6aP;ogMgM00?o?3`loeeMGOl10@400ooM
gMd01OnGUiOo51@Dok:b/_l0003oWYjN00GogMgM00?oHV9Roc0`<?oMgMd0
0ooMgMd01_l];BgoIVIVomgMgOo=cLgo0@41ohR8R0SogMgM00GoUiNGoa@D
5?nb/[;o0000oijNWP0JomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jD
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkN
gPGogMgM1OoNg]iTomgMg@03obh^;_lA4A7o>SXj00?ogMgM00?oSXj>oa0@
4?l10@400ooMgMd01OoIfMWo51@Dob<S8olI6AWog=cL00GogMgM00?oHV9R
oc0`<?oMgMd00ooMgMd00ol^;RkoI6ATomgMg@03omgMg@06o`820_n@T93o
gMgMomgMgOl^;RkoI6AT1OoMgMd00ol^;Rko4A4AocXj>P03omgMg@03ohj>
S_l@413o0@4100?ogMgM00GofMWIoa@D5?lS8b?o6ATIomcLg005omgMg@03
of9RH_l`<33ogMgM00?ogMgM00Oo;Bd]ofIVI_oMgMgogMgMoeEEEOlP823o
cLg=00OogMgM00GofMWIoa@D5?lS8b?o6ATIomcLg00JomgMg@Gog]kN1?oM
gMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]iTomgMg@03obh^;_l0003o
R8R800?ogMgM00?oe=CDo`X:2_l10@401?oMgMd00omYJFWo0000ofe]K@03
omgMg@05ofMWIomGEeOoEeMGobLW9olC4a<00omGEeL00oo>c/ko;Rh^ofAT
I004omgMg@06o`820_n@T93ogMgMomgMgOl^;Rko9bLW0omGEeL01OnOWioo
gMgMobh^;_l0003oR8R800?ogMgM00?oe=CDo`X:2_l10@401?oMgMd00omY
JFWo0000ofe]K@03omgMg@05ofMWIomGEeOoEeMGobLW9olC4a<00omGEeL0
0oo>c/ko;Bd]ofIVIP02omgMg@08ol_;bolh>3So6QXJofYZJ_n2PX;oI6AT
obTY:OnTY:@3omgMg@03ofUYJOl0003oKFe]01_ogMgM1OoNg]h4omgMgD?o
g]kN1OoMgMd4omkNgYCogMgM0_oLg=`03OoKfm_of][JomSHf?oFe]Kod];B
om3@d?o:b/[oaLG5okfm_On`/;3oX:2Pok^k^ooAdM400OoQhN40000=on3P
h?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg9?og]kN1OoMgMd5omkNgVCogMgM00?oV9RHohF5QOoAdM40
1?oMgMd00onMWIgoQXJ6omgMg@03omgMg@03olS8b?n5QHGobLW900?ogMgM
00?oShn?ohF5QOn5QHD01On5QHD00ooCdm?oV9RHojf][@04omgMg@05ohN7
Qonn_[kogMgMomgMgOnHV9P01?n5QHD01One]KGogMgMoiRHV?n5QHGodM7A
00CogMgM00?oWIfMohJ6Q_oMgMd00ooMgMd00oo8b<SoQHF5olW9b@03omgM
g@03ohn?Son5QHGoQHF500GoQHF500?odm?CoiNGUon^[Zh00ooMgMd01ooL
g=coVYZJofi^K_mKFe_oMWIfoiFEUOo@d=000ooMgMd00oo8b<SoQHF5olW9
b@0KomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8
b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJ
omgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgM
g@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:
007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Go
g]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007o
hN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN
1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oM
gMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q0000
3Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3
omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkN
gPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3o
b<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGo
gMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM
1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oN
g]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bC
omkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jD
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkN
gPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGo
gMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM
1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoN
g]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJ
omgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<So
h>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgM
g@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Go
g]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007o
fMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN
1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oM
gMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3
omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkN
gPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o
^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGo
gMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8
oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM
1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBD
U?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oN
g]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bC
omkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jD
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkN
gPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGo
gMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM
1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2P
X?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoN
g]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJ
omgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_o
dM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgM
g@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P
007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Go
g]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007o
hN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN
1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI
00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oM
gMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q0000
3OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3
omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkN
gPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o
]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oK
fm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGo
gMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^k
oiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/0
0ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM
1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFE
UOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooL
g=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oN
g]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5
aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nW
YjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bC
omkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jD
omgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkN
gPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgM
g@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo
/;2`oj2PX?ne]KGob/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jf
ol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGo
gMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;o
g=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj2PX?nk^k_odM7A007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30
`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM
1OoNg]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL
00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6Q
XOo8b<Soh>3P007olO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6
a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoN
g]kJomgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00go
fm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk
^k_odM7A007ohN7Q00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJ
omgMg@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_K
om[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGo
b/[:007ofMWI00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgM
g@Gog]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[J
f_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A
007ohN7Q00003OoPh>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Go
g]kN1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oH
f=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007o
lO7a00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoD
e=CoemOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN
1?oMgMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=So
e]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q
00003Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=Co
emOGom[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oM
gMe3omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KF
om;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI0000
3OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOG
om[Jf_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3
omkNgPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?nk^k_odM7A007ohN7Q00003OoP
h>3ob<S8oiFEUOnWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=bComkNgPGogMgM1OoNg]kJomgMg@Gog]kN1?oMgMe3omkN
gPGogMgM1?oNg]jDomgMg@;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@
d=3ob/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3P007olO7a00003Oo@d=3o
^;RhoibLW?n/[:co^k^kolK6a_o=cLgodm?ComOGeooKfm_ogmoOon7QhOoR
h^800_oShn<7onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;o
i^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKo
iNGU0_oVi^H6onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@03
onKVi_oTi>Coi>CT00;ohn?S00coh^;Ron3Ph?oLg=cofMWIomKFe_o@d=3o
bLW9ol71`One]KGoYJFUokRh^?o@d=01on3Ph00000gob/[:okFe]OnDU9Co
YjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM
00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN
0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd0
0_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]kogMgM
omgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkN
g_oMgMgogMgM00;og=cL00gofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:
olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:007ofMWI00003OoDe=Co_knoohb<
S?nNWYko[Jf]okVi^Oo2`/;oalO7olc<c?o@d=3od];BomGEeOoFe]H00_oG
emL00ooHf=SofMWIomWIf@3oomWIfOoofMWIGooIfMT2omSHf0;oemOG00co
eMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo_knookFe]OnYZJWoV9RHokno_ooD
e=@1on;RhP0000goj>SXomCDe?n<S8coTi>Coj:RX_n_[joo^[Zjol71`Oo7
alOobl_;olk>c_o@d=3odM7A00;odm?C0ooDe=@2omGEe@04omKFe_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGE
eOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]Ko
eMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oF
e]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oD
e=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGE
omKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGE
e@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oE
eM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKF
e_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCD
e0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE
00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGE
e0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KF
omGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD
0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoF
e]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2
omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKF
e_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04
omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KF
omGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGE
eOoFe]KoeMGD0_oDe=@2omGEe@05omKFe_oEeMGoe]KFomGEeOoDe=@00_oC
dm<03?oAdM7od=3@olg=cOo:b/[o`l?3okjn__nf][KoZj^[oifMWOnEUIGo
e=CDonSXj07olo?c00004_oMgMgocLg=oi2@T?n9RHWoUiNGojFUYOnb/[;o
_knool_;booAdM7oeMGEomOGeooIfMWof][Jom_KfooJf][ofm_KomcLg0Oo
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=co
fm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooK
fm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03
omcLg?oKfm_ofm_K00Gofm_K00kof][JomWIfOoHf=Soe]KFom?Cdoo=cLgo
`/;2okJf]_n/[:coWinOoi2@T?nFUYKocLg=omgMg@7oiNGU00002ooJf][o
c/k>oibLW?mjNW[oR8R8oiJFU_nZZZ[oa<C4omGEeOoKfm_og]kN00;oh>3P
0ooRh^800ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<0
1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<0
1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<0
1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<0
1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<0
1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<0
1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<0
1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<0
1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S
00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`;oh^;R
00gohN7Qon3Ph?oOgmoog=cLomOGeoo5aLGo[:b/oijNW_n@T93oPX:2oj2P
X?o>c/kof][J007oh>3P00003_oUiNGogMgMol;2`_mkNg_oN7QhohJ6Q_nO
WiooaLG5omSHf?oMgMgogmoOon7QhOoRh^;ohn?S0ooTi>@4onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT
00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU
0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@Goi>CT00gohn?Son7QhOoPh>3o
gmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4ol?3`ooMgMgoiNGU007oj^[Z
00002ooinOWolo?conWYjOnXZ:SoIFEUog=cLon=SHgo^k^komCDe?oJf][o
gMgM00;ogmoO00?oh>3Pon7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;R
on7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7o
hN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05
on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN40
0ooRh^;ohN7Qon7Qh@02on7Qh@0=on3Ph?oOgmoogMgMomcLg?oEeMGo^KVi
ohj>S_mkNg_oKVi^oj^[ZooYjNWolo?cooWin@01oogmo@0000cojn_[onSX
j?oRh^;oemOGohf=SOmRHV;oMWIfojBTY?o7alOod];BomGEeOoHf=P2om[J
fP?ofm_K1ooLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL
00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcL
g003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL
00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcL
g003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL
00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcL
g003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL
00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcL
g003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL
00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcL
g003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL
00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcL
g003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL
00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcL
g003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL
00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcL
g003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL
00Gog=cL00?ofm_KomcLg?oLg=`01?oLg=`04?oKfm_og=cLom_KfooJf][o
fMWIomSHf?oCdm?oaLG5oibLW?meMGGoIfMWoi2@T?oGemOoh^;RonSXj?o[
jn/1ong]k@0000koiNGUon;Rh_oOgmoof][JolW9bOn7QhOoFUYJog]kNonS
Xj?o_;blolK6a_o;bl_ocLg=olo?c`;odM7A1OoBd]800ooAdM7od];Bom7A
d@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoB
d];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7A
d@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoB
d];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7A
d@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoB
d];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7A
d@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoB
d];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7A
d@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoB
d];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7A
d@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoB
d];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7A
d@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoB
d];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7A
d@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoB
d];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7A
d@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoB
d]804OoAdM7od];Bom7AdOoAdM7od=3@olo?coo<c<cob<S8ok^k^onLW9co
LW9boe]KFon:RX[obLW9om[Jf_oOgmooh^;R00;oiNGU0002ong]k@0>on[Z
j_oXj>Soh^;RomcLg?nLW9coKFe]ofQXJ?n3Ph?oUiNGoj>SXon/[:co[jn_
ok6a/Onb/[82okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd
]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd
]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFe
okJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd
]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@03one]KGo/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9R
H_m^KVkoWinOomcLg?oRh^;oj>SXon[ZjP02ong]k@7ok^k^00004_oooooo
o_knookno_olo?conOWiooKfm_obl_;ofMWIojRXZ?n3Ph?oKVi^ofEUIOmY
JFWoLW9bogAdM?miNGWoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7co
OGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogem
O?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7al
ogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_o
O7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00?oO7alog]kNomlO7`00_mjNWX02omgMgOoM7Adofm_
KomdM7CoQHF5ojRXZ?oJf][ol_;booKfm_oinOWoo?cl00;oo_kn0_ooool0
00;ok^k^0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;RhP03on3Ph?oOgmoo
g]kN0?oogMgMoooMgMeWomgMg@03omkNg_oOgmooh>3P00;oh^;R00CoiNGU
onSXj?oZj^[ok>c/0_o]kNd3onk^kP001?oVi^H2onGUi@03onCTi?oRh^;o
h^;R00;oh>3P0_oOgmooomkNg_oog]kNIooNg]h2omoOg`;oh>3P0_oRh^80
0ooTi>CoiNGUonGUi@05onKViP00oomoOgmGogmoO`OoOWinoomoOglTogmo
O`0000Cojn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP03omcLg?oNg]kogMgM
00;ogMgM0?oog]kNomcLg?oNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]h0017ogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oLg=cogMgMom_Kf`02omcLg00comgMgOoMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kN00;og=cL00GofMWIomSHf?oGemOof=SHomWIfP02omcLg03oomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kog=cLomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN000GomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMh00ooNg]h00ooMgMgo
g]kNomkNgP03omgMg@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>00
1ooIfMT01?oHf=Soe]KFom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSH
f0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooH
f=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOo
f=SHfooIfMT2omSHf006omKFe_oCdm?odm?ComCDe?oGemOof=SH0_oIfMT0
0ooHf=SofMWIomWIf@02omSHf0WofMWI00?of=SHomWIfOoIfMT00_oHf=P0
0ooIfMWof=SHomSHf002omSHf1OofMWI00Cof=SHomKFe_oBd];oclo?0_o=
cLd01?o?cloodm?ComOGeooHf=SoomWIfAKofMWI00?of=SHomWIfOoIfMT0
1_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWoi>CTon3Ph?oQhN7o
h>3Pon;RhP02on7Qh@0=omkNg_oKfm_odm?ColO7aonk^k_o/[:bojf][Onb
/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7
aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=
omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?o
fm_KomoOg`3Jon7Qh@09on3Ph?oOgmoofm_KomKFe_oDe=Coe]KFom[Jf_oN
g]koh>3P00KogmoO0ooPh>000ooOgmooh>3Pon3Ph002on3Ph0SogmoO0_oN
g]h2omoOg`?oh>3P0_oOgml2on3Ph0;ogmoO3OoPh>001OoOgmoogMgMomWI
fOoEeMGodm?C00;od];B00?oe]KFomcLg?oPh>00KooQhN400ooPh>3ohN7Q
on7Qh@05on7Qh@03on3Ph?oQhN7ohN7Q03;ohN7Q00?oh>3Pon7QhOoQhN40
J?oQhN400ooRh^;ohN7Qon;RhP04on7Qh@7oi>CT0OoXj>P1ong]k@0000?o
l?3`ono_kooalO400oo`l?00ooo_knool?3`onk^k_oYjNWofm_Kol71`OnT
Y:CoS8b<ogYjN_mgMgOoNg]kohb<S?nTY:Co`/;1om[Jf_oZj^[okNg]oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo]kNgoj^[Zom[Jf_o2`/;oY:BT
ohb<RomkNg_oMgMgog]kNon<S8coY:BTol;2`_oJf][oj^[Xong]kOoalO7o
kno_oo7alOo_knoolO7aono_kooalNookNg]on[Zj_oJf][o`/;2ojBTY?n<
S8coNg]kogMgM_mkNg_oS8b<ojBTY?o2`/;of][Jon[Zj_o]kNgolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_k`006ooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_onk^k_o_knooj^[ZonOWi`02on3Ph007on?Shoo[jnWojn_[
on[Zj_oVi^Koj>SXonOWi`02onWYj@0Bonk^k?o/k>cok>c/onSXj?o/k>co
kNg]oo3`l?o/k>coj^[XonKVi_oXj>SoinOWonWYjOoXj>Sojn_[onOWiooW
inGoiNGU0_oYjNT03oo^k^kokNg]ong]kOoXj>Sojn_Yonc/k?o^k^kojNWY
on[Zj_o[jn_okno_onc/k?o/k>[oj^[Zonk^kP02onc/k03oon[Zj_o_knoo
k>c/onc/j_oZj^[ok^k^onc/k?n_[jooMWIfoeUIFOm^KVko]kNfon3Ph?oY
jNWokNg]oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_000]oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo`l?3okno_
oo3`l?o_knool?3`ono_koo`l?3okno_00Col?3`00000oobl_;ok^k^onOW
i`04onGUi@0@onCTi?oOgmoodM7Aok6a/On:RX[oIFEUoe5ADOm5ADGo@T92
odE5AOmADE7oIVIVohZ:ROna/K7odM7AomkNgP;oi>CT00?oiNGUonCTi?oU
iN@00_oTi>@03ooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5
AOmADE7oIVIVohZ:R_na/K7odM7@omkNgP02onCTi03]onGUiOoTi>CoiNGU
onCTi?oTi>?og]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGo
DE5AofIVI_n:RX[o/K6aom7AdOoNg]koi>CSonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT00;oi>CT0?oo
aLG5obPX:?m4A4CoT92@om7AdOoLg=_ofm_KomOGeooDe=Coe]KFomCDe?oE
eMGofMWIon3PgooNg]kof][JomCDe?oIfMWog]kNon;Rh_oLg=coemOFomCD
e?oFe]Koe=CDomGEeOoHf=Sofm_KomOGeooFe]GoeMGEomOGeooHf=Sog]kN
omoOgooLg=coeMGEomOGe_oLg=cogMgMomOGeooFe]Kofm_Kon7QhOoNg]ko
fm_Jom[Jf_oNg]kog=cLom[Jf_oKfm_oh>3PomoOgooLg=_ofMWIomkNg_oO
gmooM7AdofMWIon=SHgoE5ADo`P82?nRXZ;og=cLon;Rh_oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUon?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoShn?oiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>@005SoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CT1?oUiND01_oTi>CoiNGUonGUiOoU
iNGoj>SXonc/k07ol_;b00000oodm?CokNg]onOWi`02on3Ph00Con7QhOoO
gmoog]kNom;Bd_nd];CoQhN7oeaLG?m]>cGoWTi2ole^G_oYPfoocFmOoie=
@om]>cKoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomkNg_oBd];o];Bd
ohN7QomLG5coKF0/oijF;_o=cCoojNU=olg=?onNVRooKF<]oeaLG?n7QhOo
];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLodMW;_mX
WS?oTLe7oj[YEOnAcDOoJYhdodUZ;omLG5coQhN7okBd]?oBd];og]kN0=Wo
h>3P00KogmoOolo?conIVIWoTY:BoaTI6On<S8`2omGEe@0Oolo?coo2`/;o
c/k>olk>c_o5aLGob/[:om[Jf_oHf=Sod=3@ol_;boo?cloof=SHom[Jf_oE
eMGoclo?ol71`Oo@d=3oc/k>olC4a?o;bl_of=SHomOGeonn_[ko^k^kom7A
dOo@d=3oeMGEomSHf?oCdm?oc<c<olk>cP02omGEe@05olk>c_o<c<codm?C
om[Jf_oHf=P00_oBd]801?oHf=SoemOGom7AdOoCdm<2omWIf@06om?CdooA
dM7oemOGomSHf?oAdM7od=3@0_oAdM401?m6ATKo@D51omOGeooNg]iaon3P
h003omoOgooPh>3oh>3P00;oh>3P00?ogmoOon3Ph?oPh>00W?oPh>000ooO
gmooh>3PomoOg`02omoOg`?oh>3P00?ohN7QonOWioo/k>`00Oodm?@00003
ooKfm_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgoWinOofYNG_n?=Rko
k71QooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=cOoR
h^;oinOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOofiVGonCLR;okM54ooWc
M?omoHgooOfEoogmS_oin7KokMM7oi=c8_m^IeooWinOolg=cOoRh^;oinOW
00?oj>SX01?oinOWon;Rh_o=cLgoWinOof1XGom;O2?oT^5;okgiNoo@oI;o
f?fKomCmUOo0nGkoV>Q=odf09?mPJEooWinOolg=cOoRh^;oinOW0=[oj>SX
00Coi^KVon7QhOmMGEgoCDe=0_oMgMd07om@D53o1`L7oaDE5On4Q8Co5QHF
od=3@ooRh^;ogMgMoibLW?l0003oShn?omgMgOoQhN7ofm_Kod10@?l820So
6ATIohR8R?l;2`_oF5QHokNg]ol<30co1`L7ob<S8olW9bOoOGemom[Jf_oM
gMgoe=CDo`/;2omIFET00_oIfMT00omMGEgo2`/;om?Cd`02omoOg`06oeYJ
F_m>CTkog]kNomkNg_lS8b?oQ8B40_oQhN403?mjNW[o;Rh^omgMgOoMgMgo
`/;2oe1@D?lc<c?oKVi^oh>3PolQ8B7og]kNonKVi_ooj>SX7ooXj>P1onc/
k07ol_;b0Oofm_H00003ooOgmoohn?Son?Sh00?on?Sh01?omoOgonk^k_o>
c/koT92@ohD_:ooYI5Koni:7oojVVoon/JGookNZoojcY_onZ9conYB9oniX
FOn9<B_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@
oiUY:oo`_Cgonn1^ookdP_onoX[ooonBooknS?onn8?onnE`oo32?_nIJR_o
T92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@od9c:on4
cT?o[Nmcol;nR?o>oY3oe_nGom3nT_o6oXWo/_EdohSC@om4MB_oT92@olk>
c_o^k^komoOg0=[on?Sh02Gom_Kfoo7alOn1PH7o7alOong]kOo6a/Ko0000
ol?3`ooCdm?oG5aLo`P82?oZj^[ol?3`on[Zj_mBDU;o51@Docdm?OoYjNWo
l?3`ojn_[ol71`Ood];Bolg=cOm>CTko6a/Konk^k_oKfm_o[Zj^onSXj?o/
k>co[Zj^o`000?nd];Cok>c/ok2`/?l;2`_o6QXJ00;oi>CT00_o8b<So`h>
3_nTY:CokNg]onk^k_mPH63oE5ADonk^k_o]kNgo9RHVohf=S@02oo3`l00<
oh:2P_la<C7ok>c/on[Zj_m3@d?o;bl_oibLW?mcLg?o:RXZoaXJ6_o^k^ko
m_KfKoohn?P00oogmoOon?ShooShn005ooShn003ooOgmoohn?Son?Sh09go
n?Sh00?omoOgooShn?ohn?P00_ohn?P01?ogmoOonOWiooOgmoofm_H1ooSh
n00000?on_[jooGemOo^k^h00_o/k>`0ooo[jn_ojNWYomoOgonj^[[oN59B
oklb9?oVLfSooHUnoonGRoonXYKoojRLoojTV?ooVXgooXYoonifJ_o3<bCo
NE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/on[Zj_oOgmoo^[ZjohQUD_oR
TAconL=@oogJHooojW;oo_=nooojP_onmWooonacookNI?ojae7ohY8LohUV
Donj^[[ogmoOon[Zj_o[jn_ok>c/on_[jooZj^[ogmoOokZj^_mBKE;oDJ<L
oi7BEOnVif[o^?Ujol3nP_o7ohWo`oj4okWmNonWk6coU=IGoe:V7?mBKE;o
^[ZjomoOgooZj^[ojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k000BOo/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?oYjNWoiNGUogYjN_lL
71cohN7Rolc<c?l30`?oX:2PomkNg_nDU9Co4a<Con7QhOoPh>7od=3@o`H6
1_nQXJ7o2@T9okno_ooQhN7o^[Zjo`820_nb/[;ogMgMoh20P?lX:2Sohn?S
onOWiooUiNGogmoOom_KfooCdm?o20P8ohF5QOoOgmooJFUYodY:B_le=CGo
[Jf]okfm_Ol71`OoN7QhoeEEEOoOgmooh>3Poe]KFom@D5000_oQhN402_lT
92CoQHF5omoOgooQhN7oNg]kobl_;ooPh>3oe=CDo`D51OnXZ:P2on?Sh`3o
oginOolF5QKohN7Qon[Zj_o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?oZ
j^[ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>coj^[[onc/k?o[jn_ok>c/
on_[joo/k>coj^[Zonc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[000Jonc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jn`6on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT00003oo_knooc
lo?okNg]00;oiNGU0?ooi^KVonCTi?oIfMWo/[:bogT^;_o8@S?ohfYLooAj
KOomR7cooYN:oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;of=SH
onCTi?oUiNGoi^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^lA?onc5?o
oMQRookSL_onjGGoo^IcookKIOomc5?onl55onjN:onIERko/[:bomSHf?oT
i>CoiNGUonKVi_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on7bTSoUmaIojGU
JOnblgOo^?IkokCeNOnWjV_oV=aIohW?BomS[R_o;V<^ok:b/_oHf=Woi>CT
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNH0
03Coi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^Kohn?SomoOgomgMgOo6a/KomcLg?oQhN7o
WYjNobl_;ol[:b_o<S8boa8B4_oLg=cof][KohB4Q?lP823oh>3Poe9BD_mX
J6Sof][JomkNg_n@T93o:RXZobh^;_l/;2co9bLW0_oNg]h04ooIfMWodm?D
om3@d?mKFe_o0000okfm_OoJf][o:2PXohN7QomgMgSoJ6QXoh:2P_ll?3co
`/;2o`l?3ooDe=Cof][JoeUIFOm>CTh00_oLg=`03olS8b?oPH61omGEeOoG
emOoMgMgobh^;_oLg=coXj>So`000?o7alOof=SHomWIfOn=SHko5ADEomcL
g002onCTi01`onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonCTi0;oiNGU0:;oi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNH2onKViP03onGUiOoV
i^Koi^KV00?oi^KV00?oiNGUong]kOodm?@00Oojn_X00003ooclo?ohn?So
lO7a00?ok^k^01?ojn_[on7QhOnl_;coNQLGol<o<_oCETWoi6QJonmgK?od
PgWomhMlooF4N_ocNFgoiFUKomUHB_o4?c;oO1LGokbl_?oQhN7ok>c/00?o
k^k^01?ok>c/on7QhOnl_;coYDLGonJG<_oe[33ooKa1oog9Doomd63onm=U
oogBH?oncECooKe2ooZ_<_oYVc;oYDHGokbl_?oQhN7ok>c/00?ok^k^01?o
k>c/on7QhOnl_;co5eTGoenX<_mf_COoQ/e7oiKFF_nRh6GoXn1Yoj?QIonG
fUcoQ/i7ogNo=omOZc;o5eTGokbl_?oQhN7ok>c/0=[ok^k^02kok>c/onOW
iomkNg_o71`LonCTi?oYjNWoi^KVon7QhOoNg]koSHf=oa@D5?oVi^Koi>CT
ocDe=OmiNGWojn_[ok:b/_lE5AGogmoOonKVi_oTi>CohN7QomgMgOmjNW[o
:BTYonSXj?oUiNGogMgMok6a/OlV9RKo2`/;oi^KVooYjNWoc<c<o`000?o>
c/ko`l?3obDU9Om;Bd_oO7alonSXj?la<C7oYJFUonCTi?mMGEgoDE5A0_oW
inL02_lU9BGoJFUYomoOgooOgmooMgMgoc4a<OoYjNWo`L71o`000?nWYjL2
omoOg`04oi>CTolF5QKoinOWonc/k:cok^k^00?okNg]onk^k_o^k^h0K_o^
k^h00oo]kNgol_;booShn001ooclo0000oomoOd05_olo?cooOgmoogmoOol
o?colo?com7AdOmX1`Oo^3@dolLo<ooBD4?ofV9Eon=^H_oTLVCoi6mRomaT
EooCDD?oc44dokTd=?m[1`Ood];Boo?cloolo?`3oogmo@0Cooclo?oclo?o
d];Boih[1ooJRSCoji/IooFX:Ooh]3oonKe:ooRoCOoj_d[onKPoooJZ:_o_
WQWofh/doj8]1ooBd];olo?cooclo003oogmo@0Cooclo?oclo?od];Bo`M0
1om=VSCoGj/Pog2h;omo`d?oR/e@ohg=D_n:cU3oPLM4og6i;omR[R3oCY/d
o`M21ooBd];olo?cooclo03Joogmo@0Soo_knoogmoOoQ8B4oahN7_oclo?o
nOWiok>c/oo@d=3olo?cofQXJ?m7AdOon_[jomCDe?l0003ogMgMooclo?ok
no_o9bLWojRXZ?oinOWoZj^[omGEeOoalO7oE5ADoeiNG_oinOWom?CdoiBD
U?l51@Go@410om7AdOogmoOon?ShoiNGUol[:b/00_ojn_X06olT92Co1`L7
olS8b?okno_oQHF5of=SHoogmoOoHf=SoeMGEoohn?SonOWiobLW9olE5AGo
Ph>3omOGeom2@T;oHf=Soo_knoojn_[o=3@dodU9BOoKfm_oiNGUodm?ColG
5aOonOWiooclo03ooogmoAcooOgm00?oo?cloogmoOolo?`00oomoOd0000j
oogmoOojn_[olo?conk^k_o`l?3okno_onk^k_oYjNWodm?CoeXL7?nR=3Co
]2PMol4i;?o7BCcoceI:om1GBoo@Ed[obTXnol<k;_nf:1goXS@doe`M7OoC
dm?oj^[Zonk^k_o`l?3okno_oo3`koo^k^koj^[Zom?Cdon<9Agob74domV4
7OoTU1GoiidTonjX<oo`ZSCokjXconbP9OoWUaGog8PMolQa=?n<9Agodm?C
on[Zj_o^k^kol?3`ono_koo`l?3ok^k^on[ZjOoCdm?o7CPMocB2=?m7UAgo
FZDKofV]:P;oM;Ph0>;oMKThof^a:omKYacoB9XMocB2=?lM>1godm?Con[Z
jOo^k^kol?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`0_o_knl0k_oZj^[oOWinoa`L7?oXj>OokNg]
ohR8R?l`<33o3`l?oc4a<Ona/K7ok^k^ohF5Q?m=CDgokno_onk^k_o_knoo
RXZ:oeUIFOo^k^koN7Qhob/[:ol?3`oo>3Phokno_oo]kNgoi>CTo`h>3_mY
JFWogmoOon?ShooUiNGojn_[of5QHOmgMgOok^k^ono_k_mfMWKo9RHVong]
kOo_knooc<c<ob`/;?oZj^[oKFe/of9RH_o/k>cokNg]oc/k>onCTi?oHV9R
o`h>3_ld=3Coa<C4ono_koo^k^kodM7Aoc`l??l:2P[o9bLWofa/K?l/;2co
kno_onk^k_o`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`onk^k_o`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?03ono_k`1Too3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_k`;ol?3`1_o_knl1
oo?cl`7onOWi0Oono_h00003ookno_ogmoOol?3`00CojNWY017oinOWom_K
fomSBd_oPC8bojHe=Onf=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDe
oh4b<_mSBd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oRD];ojm;<_o=McGo
eX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;oRD];om_KfooW
inL01OoYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[ZbooL:dhofn^
>_m`[CSoJZX_oe>K;OliR3Go<V0bod];BooKfm_oinOW0=_ojNWY00Koj>SX
onKVi_mkNg_o71`LonCTi?oXj>P2onWYj@03onOWiooYjNWojNWY00_ojNWY
00coinOWonWYjOoYjNWoj>SXomSHf?l:2P[o[Zj^omgMgOoNg]koh>3PonGU
iOoXj>P8onWYj@06onSXj?oVi^Kohn?Son?ShooVi^Koj>SX0ooYjNT00ooX
j>SojNWYonWYj@04onWYj@03onOWiooYjNWojNWY0?oojNWY6ooYjNT00ooX
j>SojNWYonWYj@04onWYj@7ol?3`0OogmoL1ooknoP0000Goo_knoo[jn_od
m?Cokno_oo7al@02oo3`l00Aono_koo[jn_oUIBDodlS8onEE5Co^g=com>E
UOoJW9cofYjLomVLW?oDUIGo^g=coiEDE?m?8b?oUIBDon[Zj_o_knl01Oo`
l?004Oo_knooj^[ZojVDU?n18b?o^VYDomBJLooT_9Goj/NLonW7W?oZaico
iKbEomBJLonkJUCoPB<SojZDU?oZj^[okno_00Gol?3`017okno_on[Zj_nD
U9Co8bXSoeAjE?mcYG?oW/JEojc>W?n]cYco[<jLoik6UOmcYG?oE7YDob<Z
8onDU9Coj^[Zono_k`3Koo3`l0;okno_00CoP820oadM7Oo^k^kokno_4oo`
l?02ono_k`07ofATI?lY:BWoPH61of=SHolk>c_ok^k^ono_k`08oo3`l006
ono_koo^k^koLg=cofUYJOo^k^kokno_ooo`l?0]oo3`l004oo7alOo`l?3o
m?Cdoo[jnP7oo_kn00001?o/k_3oooooooooooono_h2ooooo`;oo_kn0?oo
oOgmooShn?m^KVkoFSlook6@T?oNbLWol>CToo?Vi_o`i>Cog/W9ok6@T?mJ
?cooKFe]ooShn?olo?coooooookno_ooooooo_knooooo_ono_kooooooocl
o?ohn?SoSFe]ohXo?oo9TI3ojM39ooCYi?ofjnKom>WTonW@bOo9TI3oRClo
ohe]KOohn?Ooo?clooooooono_koooooookno_ooooooo_knooooo_olo?co
n?Shofe]KOlo?cooT9f@olWEbOoTk>Coi^kVonC/i?o9eLWoT9f@oclo?om]
KFgon?Shooclo?ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_h003Soooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooooogm
oOo@d=3oYJFUooknoOono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_oooooooOgmol71`?maLG7oPH61ojn_[`;oo_kn00coooooookn
o_ooookoo_knooooooono_koooooookno_oooooooOgmol;2`Onl_;`2ookn
oP3oooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_kooooo000Yookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_h00_ooool00oono_koooooooooo`03oooo
o`7on__k00001?o1b<koo_knoo[jn_odm?@5oo7al@0=ono_kooFe]KoJf][
od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7a
l@0=ono_kooGe]KoPf][og@m?OneS8coeKZjon7<c?oF^[[o]Xb<og8m?On1
Jf_oemKFono_k`09oo7al@0=ono_kooFe]KoJf][ocdm?On<S8co^[Zjolc=
c?nj^[[oS8b<ocdm?Om[Jf_oe]KFono_k`3ooo7alOoolO7a=?oalO401?o`
l?3olO7aoo7alOo`l?04oo7al@03ooCdm?ojn_[oo_kn007ojng^00001On4
SiWooOgmooShn?o`l?3ojn_[00?oj^[Z00gojNWYon[Zj_oYjNWoj>SXoi^K
VomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY00_oj^[Z00_ojNWY
onSXj?nPVi_oJUUIod<V9_l]2@Wo@RHVofUIFOnPVi_oj>SXonWYj@0;on[Z
jP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oY
jNT0oooZj^[oon[ZjScoj^[Z00Cojn_[oo3`l?ohn?SooOgm0OoBe]P00004
ocI6DOnh`<GonOWiooCdm0SolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`
l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l?oolO7aoooalO4joo7a
l@03oo3`l?oalO7olO7a00;olO7a00?omOGeoo[jn_o/kNl00OnQYJP00003
oad_?om<FF?o^Ko50?oooooooooooomlooooo`7okNk_0On]/;81ojFZ[@00
00Ko72hmoaXY=Olb?4KoOXR@okg3b?o[k>koooooooooooooM_ooool01OoZ
jnco^l34ogV1Qol/=Cgo4alY007o52@_0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[BoxData[{
    \(\(savedLayout = pane@getLayout[];\)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]\(pane@
          setLayout[\[IndentingNewLine]JavaNew["\<java.awt.GridLayout\>", 3, 
              3, 5, 5]\[IndentingNewLine]];\)\[IndentingNewLine]]\)}], "Input"],

Cell[BoxData[
    \(JavaBlock[\(NewJButton[pane, "\<MATHEMATICA\>"];\)]\)], "Input"],

Cell[BoxData[{
    \(\(path = StringJoin[$JavaSwingMaterial, "\<hdd.gif\>"];\)\), "\n", 
    \(\(icon = NewImageIcon[path];\)\), "\n", 
    \(\(iconWidth = icon@getIconWidth[];\)\), "\n", 
    \(\(iconHeight = icon@getIconHeight[];\)\)}], "Input"],

Cell[BoxData[
    \(\(button = NewJButton[pane, "\<J/Link\>", icon];\)\)], "Input"],

Cell[BoxData[{
    \(\(button@setVerticalTextPosition[swBottom];\)\), "\n", 
    \(\(button@setHorizontalTextPosition[swCenter];\)\)}], "Input"],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"],

Cell[BoxData[{
    \(\(JavaBlock[\[IndentingNewLine]icon2 = 
          JavaNew["\<javax.swing.ImageIcon\>", 
            StringJoin[$JavaSwingMaterial, "\<hdd.gif\>"]]; 
        icon3 = JavaNew["\<javax.swing.ImageIcon\>", 
            StringJoin[$JavaSwingMaterial, "\<file.gif\>"]]; \
\[IndentingNewLine]button@setIcon[icon2]; \[IndentingNewLine]button@
          setRolloverEnabled[True]; \[IndentingNewLine]button@
          setRolloverIcon[icon3];\[IndentingNewLine]];\)\), "\n", 
    \(JavaShow[frame]\)}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(ReleaseObject[icon]\)], "Input"],

Cell[BoxData[
    \(DeleteJObject[pane, button]\)], "Input"],

Cell[BoxData[{
    \(\(pane@removeAll[];\)\), "\[IndentingNewLine]", 
    \(frame@repaint[]\)}], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["<<< SimpleBeep >>>",
  FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003j0000=AP00`40o`00
0?l0003onP00000000>8`;Q8T8Q8T8P0mTR@R04000000003R<2hb>3HR<2h
0?F8`;P1B9280@00000000>8`;S8h=R8`;P0mHS0^058T8P1000000001HS0
^<SPf8S0^8S0^<c<c01hooooNLc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVK<c<afIVIV00?oooo<c<c<c<`0Mlc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVKooomec<c<00=VIVKoooo<c<`0N<c<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVKooomec<c<00=VIVKoooo<c<`0
N<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKoool[c<c<7iVI
c2_<c<`00fIVI_ooolc<c01hc<c<0XS0^058T8P1000000001XS0^<SPf8S0
^8S0^6IVI_ooob_<c<`00iVIc<c<c<c<c00Kc<c<00>IVLc<c<c<c<`0:Lc<
c003IVIVooooc<c<07S<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
IVIVoooo:lc<c003VIW<c<c<c<c<01C<c<`200001Lc<c003VIW<c<c<c<c<
02W<c<`00fIVI_ooolc<c01^c<c<0P0000S<c<`2R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hIVIVoooo:lc<c003VIW<c<c<c<c<01C<c<`200001Lc<
c003VIW<c<c<c<c<02W<c<`00fIVI_ooolc<c01^c<c<0P0000S<c<`2R<2h
0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo:lc<c003VIW<00000000
00@00003c<c<100000?<c<`400000/c<c08000000lc<c00000000002c<c<
00>IVLc<c<c<c<`0:Lc<c004IVIVoooo000000001/c<c0800004c<c<1000
00?<c<`400000lc<c0@00005c<c<0P000003c<c<0000000000?<c<`20000
00?<c<`0000000000/c<c0800002c<c<0P0000;<c<`400000/c<c0800002
c<c<0P0000G<c<`200000/c<c0@00005c<c<0P000003c<c<0000000000?<
c<`400000lc<c0@00002c<c<0P000003c<c<0000000000;<c<`2000000C<
c<b8`;R8`;Q8T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooob_<c<`00iVI
c00000000003c<c<0P000003c<c<0000000000;<c<`2000000?<c<`00000
00000/c<c08000001Lc<c000000000000<c<c002000000?<c<bIVLc<c<`0
:/c<c004IVIVoooo000000001/c<c0800003c<c<0P0000;<c<`2000000?<
c<`0000000000/c<c08000000lc<c00000000002c<c<0P0000C<c<`30000
00C<c<`00000003<c<`2000000G<c<`000000000003<c<`00P0000;<c<`2
00000/c<c0800002c<c<0P000003c<c<0000000000;<c<`200001<c<c080
0002c<c<0P0000;<c<`200001<c<c0<000001<c<c00000000<c<c0800002
c<c<0P000003c<c<0000000000;<c<`2000000G<c<`000000000003<c<`0
0P000004c<c<00000000c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0
^6IVI_ooob_<c<`00iVIc00000000003c<c<0P000003c<c<0000000000G<
c<`200001Lc<c0800002c<c<0P000003c<c<VIW<c<c<02[<c<`016IVI_oo
o`00000000K<c<`200000lc<c0800008c<c<0`0000C<c<`300001<c<c080
0002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<
c0800002c<c<0P0000;<c<`2000000?<c<`0000000000/c<c0800004c<c<
0P0000;<c<`200000/c<c0800004c<c<0P0000;<c<`2000000?<c<`00000
00001Lc<c0800005c<c<0P0000;<c<`200001<c<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVKoool[c<c<00>IVL`0000000000lc<c0800000
0lc<c00000000004000000?<c<`00000000010000003c<c<0000000000;<
c<`2000000?<c<bIVLc<c<`0:/c<c003IVIVoooo000000D00002c<c<0P00
00?<c<`600000/c<c0@00003c<c<100000G<c<`200000/c<c08000000lc<
c00000000002c<c<0P000003c<c<0000000000;<c<`200000/c<c0800002
c<c<0P000003c<c<0000000000;<c<`200001<c<c0800002c<c<0P0000;<
c<`200001<c<c0800002c<c<0P000003c<c<0000000000@000000lc<c000
00000004000000?<c<`0000000000/c<c0800004c<c<0XS0^058T8P10000
00001XS0^<SPf8S0^8S0^6IVI_ooob_<c<`00iVIc0000000000400000/c<
c0800002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`000000000
0/c<c08000000lc<c9VIc<c<c00Zc<c<00AVIVKoool000000003c<c<0P00
0003c<c<0000000000?<c<`200000/c<c08000001<c<c0000000000000C<
c<`300001lc<c0800002c<c<0P000003c<c<0000000000;<c<`2000000?<
c<`0000000000/c<c0800002c<c<0P0000;<c<`2000000?<c<`000000000
0/c<c0800004c<c<0P0000;<c<`200000/c<c0800004c<c<0P0000;<c<`2
000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P000003
c<c<0000000000;<c<`200001<c<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVKoool[c<c<00>IVL`0000000000lc<c08000000lc<c0000000
0002c<c<0P000003c<c<0000000000;<c<`2000000G<c<`000000000003<
c<`00P000003c<c<VIW<c<c<02[<c<`016IVI_ooo`00000000?<c<`20000
00?<c<`0000000000lc<c0800002c<c<0P000003c<c<0000000000;<c<`2
000000?<c<`0000000000/c<c0800004c<c<0`000004c<c<00000000c<c<
0P0000;<c<`2000000?<c<`0000000000/c<c0800003c<c<00<0003<c<c<
c<`00P000005c<c<000000000000c<c<00800004c<c<0P0000?<c<`00`00
0<c<c<c<c00200001<c<c0<000001<c<c00000000<c<c0800002c<c<0P00
0003c<c<0000000000;<c<`2000000G<c<`000000000003<c<`00P0000C<
c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo:lc<c003VIW<
0000000000?<c<`200000/c<c0@00003c<c<100000;<c<`2000000?<c<`0
000000000/c<c003VIW<c<c<c<c<02W<c<`016IVI_ooo`00000000?<c<`2
000000?<c<`0000000000P0000;<c<`400000lc<c0@00003c<c<100000G<
c<`2000000?<c<`0000000000/c<c0800002c<c<2P0000;<c<`400000/c<
c08000000lc<c00000000004c<c<100000;<c<`400001Lc<c08000000lc<
c00000000003c<c<100000?<c<`400000/c<c08000000lc<c00000000005
c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooob_<c<`00iVI
c00000000003c<c<0P0001K<c<`00iVIc<c<c<c<c00Yc<c<00AVIVKoool0
00000003c<c<0P0001k<c<`200003<c<c0800002c<c<0P0001?<c<`20000
3<c<c080000Mc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_oo
ob_<c<`00iVIc0000000000400005lc<c003VIW<c<c<c<c<02W<c<`00fIV
I_ooo`00000500007lc<c080000=c<c<00D0003<c<c<c<c<c<`000005<c<
c0030000c<c<c<c<00[<c<`200007Lc<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVKoool[c<c<00>IVLc<c<c<c<`06lc<c003VIW<c<c<c<c<
02W<c<`00fIVI_ooolc<c01hc<c<0XS0^058T8P1000000001XS0^<SPf8S0
^8S0^6IVI_ooob_<c<`00iVIc<c<c<c<c00Kc<c<00>IVLc<c<c<c<`0:Lc<
c003IVIVooooc<c<07S<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
IVIVoooo:lc<c003VIW<c<c<c<c<01_<c<`00iVIc<c<c<c<c00Yc<c<00=V
IVKoooo<c<`0N<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKo
ool[c<c<00>IVLc<c<c<c<`06lc<c003VIW<c<c<c<c<02W<c<`00fIVI_oo
olc<c01hc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooob_<
c<`OVIW<:lc<c003IVIVooooc<c<07S<c<`2R<2h0DR@R04000000006R<2h
b>3HR<2hR<2hIVIVooooMLc<c003IVIVooooc<c<07S<c<`2R<2h0DR@R040
00000006R<2hb>3HR<2hR<2hIVIVooooMLc<c003IVIVooooc<c<07S<c<`2
R<2h0DR@R04000000005R<2hb>3HR<2hR<2hIVIV07Koool00lc<c?ooolc<
c01hc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^7QVIVIjc<c<0XS0
^058T8P1000000000hS0^<SPf8S0^03eR<2h0DR@R04000000004R<2hb>3H
R<2hR<2h4`00P02Y006000:000>100B100F100J200N20@R30@V30@Z30@^4
0@b40@f40@j50Pn50Q260Q660Q>60QB70QF70QJ70aN80aR80aV90aZ90a^9
0ab:0af:11j:11n;122;126<12:<12><12F=1BJ=1BN=1BR>1BV>1BZ?1B^?
1Bb?1Rf@1Rj@1Rn@1S2A1S6A1S:B1S>B1cBB1cFC1cNC1cRC1cVD1cZD1c^E
23bE23fE23jF23nF242F246G24:G2D>H2DBH2DFH2DJI2DNI2DVI2DZJ2T^J
2TbK2TfK2TjK2TnL2U2L2U6L2e:M2e>M2eBN2eFN2eJN2eNO2eRO2eVO35^P
35bP35fQ35jQ35nQ362R366R3F:S3F>S3FBS3FFT3FJT3FNT3FRU3VVU3VZV
3V^V3VfV3VjW3VnW3W2W3g6X3g:X3g>Y3gBY3gFY3gJZ3gNZ47RZ47V[47Z[
47^/47b/47f/47n]4H2]4H6]4H:^4H>^4HB_4HF_4HJ_4XN`4XR`4XV`4XZa
4X^a4Xbb4Xfb4hjb4hnc4i6c4i:c4i>d4iBd4iFe59Je59Ne59Rf59Vf59Zf
59^g59bg5Ifh5Ijh5Inh5J2i5J6i5J>i5JBj5ZFj5ZJk5ZNk5ZRk5ZVl5ZZl
5Z^l5jbm5jfm5jjn5jnn5k2n5k6o5k:o03HH]<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1000P003VjOa<d>U<d>U00Tc@jD300200:T00H000X00
0h4018401H401X801h8128<12H<12X<12h@138@13H@13XD23hD248H24HH2
4hH258L25HL25XL35hP368P36HT36XT36hT378X37HX47XX47h/488/48H`4
8X`48h`49Hd59Xd59hd5:8h5:Hh5:Xl5:hl5;8l6;I06;Y06;i06<946<I46
<Y86<i87=987=I<7=i<7>9<7>I@7>Y@7>iD8?9D8?ID8?YH8?iH8@9H8@IL8
@YL9@iP9A9P9AIP9AYT9AiT9BIT9BYX:BiX:C9/:CI/:CY/:Ci`:D9`:DI`;
DYd;Did;E9h;EIh;EYh;Eil;F9l;FIl<Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=
HZ<=Hj<=I:<=IJ@=IZ@=Ij@=J:D>JJD>JZH>JjH>KJH>KZL>KjL>L:L?LJP?
LZP?LjT?M:T?MJT?MZX?MjX@N:X@NJ/@NZ/@Nj`@O:`@OJ`@OjdAP:dAPJdA
PZhAPjhAQ:lAQJlAQZlBQk0BR;0BRK0BR[4BRk4BS;8BSK8CS[8CSk<CTK<C
T[<CTk@CU;@CUKDDU[DDUkDDV;HDVKHDV[HDVkLDW;LEWKPEW[PEWkPEX;TE
XKTEXkTEY;XFYKXFY[/FYk/FZ;/FZK`FZ[`FZk`G[;dG[KdG[[hG[khG/;hG
/KlG/[l0=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000NK
Yo7ooon>N[JVVlBcZM:XWLRcZM800ZJKa005_;SMk^kdj^Waoooo<d>U0080
0800Z@01P002P003P@04P@05P@06PP07PP48P`49P`4:P`4;Q04<Q04=Q04>
Q@8?Q@8@QP8AQP8CQP8DQ`8EQ`8FQ`<GR0<HR0<IR@<JR@<KR@<LRP<MRP@N
RP@OR`@PR`@QS0@RS0@SS0@US@DVS@DWS@DXSPDYSPDZS`D[S`D/S`H]T0H^
T0H_T0H`T@HaT@HbTPHcTPLdTPLeT`LgT`LhT`LiU0LjU0LkU@PlU@PmU@Pn
UPPoUPQ0UPQ1U`Q2U`U3V0U4V0U5V0U6V@U7V@U9V@U:VPY;VPY<V`Y=V`Y>
V`Y?W0Y@W0YAW0]BW@]CW@]DWP]EWP]FWP]GW`]HW`]IW`aKX0aLX0aMX@aN
X@aOX@aPXPaQXPeRX`eSX`eTX`eUY0eVY0eWY0eXY@iYY@iZYPi[YPi]YPi^
Y`i_Y`i`Y`maZ0mbZ0mcZ@mdZ@meZ@mfZPmgZQ1hZQ1iZa1jZa1k[11l[11m
[11o[A60[A61[A62[Q63[Q64[a65[a66[a:7/1:8/1:9/1::/A:;/A:</Q:=
/Q>>/Q>?/a>A/a>B/a>C]1>D]1>E]ABF]ABG]ABH]QBI]QBJ]QBK]aBL]aFM
^1FN^1FO^1FP^AFQ^AFS^AFT^QJU^QJV^aJW^aJX^aJY_1JZ_1J[_1N/_AN]
_AN^_QN__QN`_QNa_aNb_`026;C08000008H]<0@00000QRd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2002000BKYo7ooom/FZF_YLX2_;SM0;Co
oOncZM;ooooooonl^=fGR[bXWLSVi^cooolc@jD008000H000X000h401840
1H401X801h8128<12H<12X<12h@138@13H@13XD23hD248H24HH24hH258L2
5HL25XL35hP368P36HT36XT36hT378X37HX47XX47h/488/48H`48X`48h`4
9Hd59Xd59hd5:8h5:Hh5:Xl5:hl5;8l6;I06;Y06;i06<946<I46<Y86<i87
=987=I<7=i<7>9<7>I@7>Y@7>iD8?9D8?ID8?YH8?iH8@9H8@IL8@YL9@iP9
A9P9AIP9AYT9AiT9BIT9BYX:BiX:C9/:CI/:CY/:Ci`:D9`:DI`;DYd;Did;
E9h;EIh;EYh;Eil;F9l;FIl<Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ<=Hj<=
I:<=IJ@=IZ@=Ij@=J:D>JJD>JZH>JjH>KJH>KZL>KjL>L:L?LJP?LZP?LjT?
M:T?MJT?MZX?MjX@N:X@NJ/@NZ/@Nj`@O:`@OJ`@OjdAP:dAPJdAPZhAPjhA
Q:lAQJlAQZlBQk0BR;0BRK0BR[4BRk4BS;8BSK8CS[8CSk<CTK<CT[<CTk@C
U;@CUKDDU[DDUkDDV;HDVKHDV[HDVkLDW;LEWKPEW[PEWkPEX;TEXKTEXkTE
Y;XFYKXFY[/FYk/FZ;/FZK`FZ[`FZk`G[;dG[KdG[[hG[khG/;hG/KlG/[l2
6;C000?8h=Q8T8Q8T8P034R@R0030000b>3HB92800e8T8P0100001Rd`1Rd
`<SPf0i8T8P00`0001Rd`1Rd`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0P00P00;VjOaooooZ9g8oooo/jWBH4bJSWZfN6F^Z9g8oooooogo00?o
ool0[3=3Y@00P000P001P002P003P@04P@05P@06PP07PP48P`49P`4:P`4;
Q04<Q04=Q04>Q@8?Q@8@QP8AQP8CQP8DQ`8EQ`8FQ`<GR0<HR0<IR@<JR@<K
R@<LRP<MRP@NRP@OR`@PR`@QS0@RS0@SS0@US@DVS@DWS@DXSPDYSPDZS`D[
S`D/S`H]T0H^T0H_T0H`T@HaT@HbTPHcTPLdTPLeT`LgT`LhT`LiU0LjU0Lk
U@PlU@PmU@PnUPPoUPQ0UPQ1U`Q2U`U3V0U4V0U5V0U6V@U7V@U9V@U:VPY;
VPY<V`Y=V`Y>V`Y?W0Y@W0YAW0]BW@]CW@]DWP]EWP]FWP]GW`]HW`]IW`aK
X0aLX0aMX@aNX@aOX@aPXPaQXPeRX`eSX`eTX`eUY0eVY0eWY0eXY@iYY@iZ
YPi[YPi]YPi^Y`i_Y`i`Y`maZ0mbZ0mcZ@mdZ@meZ@mfZPmgZQ1hZQ1iZa1j
Za1k[11l[11m[11o[A60[A61[A62[Q63[Q64[a65[a66[a:7/1:8/1:9/1::
/A:;/A:</Q:=/Q>>/Q>?/a>A/a>B/a>C]1>D]1>E]ABF]ABG]ABH]QBI]QBJ
]QBK]aBL]aFM^1FN^1FO^1FP^AFQ^AFS^AFT^QJU^QJV^aJW^aJX^aJY_1JZ
_1J[_1N/_AN]_AN^_QN__QN`_QNa_aNb_`8H]<000lSPf8S0^8S0^00;R<2h
00=8T8P00038h=P03HS0^005B92800006;C06;C0b>3H00f8`;P014R@R000
01Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000jKYo7o
oooooooKg>aPC9ZCQKZcZM:l^=ePC9ZISkjVVlC8`moooolc@jD3002000/0
0H000X3oool018401H401X801h8128?oool12X<12h@01?ooo`0=0Q260Q66
0Q>6oooo0QF7oooo0aN80aR80aV9oooo0a^90ab:0af:00?oool03P@QS0@R
S0@SS?ooo`DVS@DWS@DXSPDYSPDZSoooo`D/S`H]T0H^T0H_T0Coool02`Ld
TPLeToooo`LhT`LiU?ooo`LkU@PlUOooo`PnUPPoUP03oooo06X9@iP9A9P9
AIP9AYT9AiT9BIT9BYX:BiX:C9/:CI/:CY/:Ci`:D9`:DI`;DYd;Did;E9h;
EIh;EYh;Eil;F9l;FIl<Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ<=Hj<=I:<=
IJ@=IZ@=Ij@=J:D>JJD>JZH>JjH>KJH>KZL>KjL>L:L?LJP?LZP?LjT?M:T?
MJT?MZX?MjX@N:X@NJ/@NZ/@Nj`@O:`@OJ`@OjdAP:dAPJdAPZhAPjhAQ:lA
QJlAQZlBQk0BR;0BRK0BR[4BRk4BS;8BSK8CS[8CSk<CTK<CT[<CTk@CU;@C
UKDDU[DDUkDDV;HDVKHDV[HDVkLDW;LEWKPEW[PEWkPEX;TEXKTEXkTEY;XF
YKXFY[/FYk/FZ;/FZK`FZ[`FZk`G[;dG[KdG[[hG[khG/;hG/KlG/[l26;C0
00C8h=R8`;R8`;R8`;P6000018S0^003B9280000b>3H00:8`;P900000XS0
^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P3002000jKYo7ooonl^=fISkkooooFdMgK
g>cco_nVVlC^k_B5M[2CQK[ooolc@jD200200:T00H000X3oool018401H7o
ool01h8128?oool12X?oool138@13H@13XGoool248H24HKoool258L25HOo
ool35hP368P36HWoool36hT378[oool47XX47h/488_oool48X`48hcoool5
9Xd59hd5:8h5:Hh5:Xooool5;8l6;I06;Y3oool6<946<I46<Y;oool7=987
=I?oool7>9<7>ICoool7>iD8?9Goool8?YKoool8@9H8@IL8@YOoool9A9P9
AIP9AYT9AiT9BIT9BYX:BiX:C9/:CI/:CY/:Ci`:D9`:DI`;DYd;Did;E9h;
EIh;EYh;Eil;F9l;FIl<Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ<=Hj<=I:<=
IJ@=IZ@=Ij@=J:D>JJD>JZH>JjH>KJH>KZL>KjL>L:L?LJP?LZP?LjT?M:T?
MJT?MZX?MjX@N:X@NJ/@NZ/@Nj`@O:`@OJ`@OjdAP:dAPJdAPZhAPjhAQ:lA
QJlAQZlBQk0BR;0BRK0BR[4BRk4BS;8BSK8CS[8CSk<CTK<CT[<CTk@CU;@C
UKDDU[DDUkDDV;HDVKHDV[HDVkLDW;LEWKPEW[PEWkPEX;TEXKTEXkTEY;XF
YKXFY[/FYk/FZ;/FZK`FZ[`FZk`G[;dG[KdG[[hG[khG/;hG/KlG/[l00QRd
`004b>3HR<2hR<2hR<2h1P0000B8`;P00dR@R0000<SPf002R<2h00<00028
`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<001<SPf8S0^8S0^8S0
^0800004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P300200;VKYo7ooonISkjGR[cDdnS_[;?oMW_^Wj]K
F:FVVlBFWm9PC9Zl^=gooolc@jD008000H000X3oool018401H7oool01h81
28?oool12X?oool138@13H@13XGoool248H24HKoool258L25HOoool35hP3
68P36HWoool36hT378[oool47XX47h/488_oool48X`48hcoool59Xd59hd5
:8h5:Hh5:Xooool5;8l6;I06;Y3oool6<946<I46<Y;oool7=987=I?oool7
>9<7>ICoool7>iD8?9Goool8?YKoool8@9H8@IL8@YL9@iP9A9P9AIP9AYT9
AiT9BIT9BYX:BiX:C9/:CI/:CY/:Ci`:D9`:DI`;DYd;Did;E9h;EIh;EYh;
Eil;F9l;FIl<Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ<=Hj<=I:<=IJ@=IZ@=
Ij@=J:D>JJD>JZH>JjH>KJH>KZL>KjL>L:L?LJP?LZP?LjT?M:T?MJT?MZX?
MjX@N:X@NJ/@NZ/@Nj`@O:`@OJ`@OjdAP:dAPJdAPZhAPjhAQ:lAQJlAQZlB
Qk0BR;0BRK0BR[4BRk4BS;8BSK8CS[8CSk<CTK<CT[<CTk@CU;@CUKDDU[DD
UkDDV;HDVKHDV[HDVkLDW;LEWKPEW[PEWkPEX;TEXKTEXkTEY;XFYKXFY[/F
Yk/FZ;/FZK`FZ[`FZk`G[;dG[KdG[[hG[khG/;hG/KlG/[l00QRd`003b>3H
R<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^005
0000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P2
00000hS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0
^8S0^08008002Y^WlOoooiN:_7Y/Z[?7j:U^X<S3gi>5^U]6TiV?_P9hIJh0
448WQJnUb_oooc=3Y@00P001P002P?ooo`04POooo`06P_ooo`48Poooo`4:
P`4;Q0Coool07P8@QP8AQ_ooo`8DQ`8EQoooo`<GR0<HR0<IROooo`<KR@<L
RP<MRP@NRP@OR`@PRoooo`@RS0@SS?ooo`DVS@DWS@DXSPDYSPDZSoooo`D/
S`H]T0H^T0H_T0Coool02PLdTPLeToooo`LhT`LiU?ooo`LkU@PlUOooo`Pn
UPGoool0J@U4V0U5V0U6V@U7V@U9V@U:VPY;VPY<V`Y=V`Y>V`Y?W0Y@W0YA
W0]BW@]CW@]DWP]EWP]FWP]GW`]HW`]IW`aKX0aLX0aMX@aNX@aOX@aPXPaQ
XPeRX`eSX`eTX`eUY0eVY0eWY0eXY@iYY@iZYPi[YPi]YPi^Y`i_Y`i`Y`ma
Z0mbZ0mcZ@mdZ@meZ@mfZPmgZQ1hZQ1iZa1jZa1k[11l[11m[11o[A60[A61
[A62[Q63[Q64[a65[a66[a:7/1:8/1:9/1::/A:;/A:</Q:=/Q>>/Q>?/a>A
/a>B/a>C]1>D]1>E]ABF]ABG]ABH]QBI]QBJ]QBK]aBL]aFM^1FN^1FO^1FP
^AFQ^AFS^AFT^QJU^QJV^aJW^aJX^aJY_1JZ_1J[_1N/_AN]_AN^_QN__QN`
_QNa_aNb_`026;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P0
0`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2h
R<2h00>8`;P4000018S0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008000i^WlOooooooo`02oooo00[o[K3oMW_icMCm
kNkooonVVlB5M[2l^=gooolc@jD2002001@00H000X3oool0187oool01X;o
ool128?oool12X<12h@138@13H@13XGoool248H24HKoool258L25HL2oooo
00`368P36HWoool36hT378X37HX47XX47h/488_oool48X`48h`4oooo00d5
:Hh5:Xooooooool6;I06;Y06;i06<946<I46<Y;oool7=987=I<00_ooo`1d
1cVDoooooooo23bEoooo23jFoooo242F246G24:Goooo2DBH2DFH2DJI2DNI
2DVI2DZJ2T^J2TbK2TfK2TjK2TnL2U2L2U6L2e:M2e>M2eBN2eFN2eJN2eNO
2eRO2eVO35^P35bP35fQ35jQ35nQ362R366R3F:S3F>S3FBS3FFT3FJT3FNT
3FRU3VVU3VZV3V^V3VfV3VjW3VnW3W2W3g6X3g:X3g>Y3gBY3gFY3gJZ3gNZ
47RZ47V[47Z[47^/47b/47f/47n]4H2]4H6]4H:^4H>^4HB_4HF_4HJ_4XN`
4XR`4XV`4XZa4X^a4Xbb4Xfb4hjb4hnc4i6c4i:c4i>d4iBd4iFe59Je59Ne
59Rf59Vf59Zf59^g59bg5Ifh5Ijh5Inh5J2i5J6i5J>i5JBj5ZFj5ZJk5ZNk
5ZRk5ZVl5ZZl5Z^l5jbm5jfm5jjn5jnn5k2n5k6o5k:o0QRd`003b>3HR<2h
R<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000
R<2hR<2hB9280000008H]<000lSPf8S0^8S0^004R<2h0P0000F8`;P014R@
R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000ZQ
[?;icMCR9Scd]KoR9ScdKGglhnWoooomkNko[K02oooo00lc@jD008000800
08000H000X3oool0187oool01X;oool128?oool12X<12h@00oooo`030Pn5
0Q26oooo00;oool00`8EQoooo`<GR002oooo01D36XT36hT378X37HX47XX4
7h/488_oool48X`48hcoool59Xd59hd5:8h5:Hh5:Xooool5;8ooool6;Y06
;i000oooo`051S>B1cBB1cFCoooo1cRC00;oool01@LkUOooo`PmU@PnUPPo
UP03oooo06X9@iP9A9P9AIP9AYT9AiT9BIT9BYX:BiX:C9/:CI/:CY/:Ci`:
D9`:DI`;DYd;Did;E9h;EIh;EYh;Eil;F9l;FIl<Fj0<G:0<GJ4<GZ4<Gj4<
H:8<HJ8=HZ<=Hj<=I:<=IJ@=IZ@=Ij@=J:D>JJD>JZH>JjH>KJH>KZL>KjL>
L:L?LJP?LZP?LjT?M:T?MJT?MZX?MjX@N:X@NJ/@NZ/@Nj`@O:`@OJ`@OjdA
P:dAPJdAPZhAPjhAQ:lAQJlAQZlBQk0BR;0BRK0BR[4BRk4BS;8BSK8CS[8C
Sk<CTK<CT[<CTk@CU;@CUKDDU[DDUkDDV;HDVKHDV[HDVkLDW;LEWKPEW[PE
WkPEX;TEXKTEXkTEY;XFYKXFY[/FYk/FZ;/FZK`FZ[`FZk`G[;dG[KdG[[hG
[khG/;hG/KlG/[l26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8
`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3H
R<2hR<2h00>8`;P4000018S0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_AR
K_omoon]/?cSjOoooc=3Y@04002000L00H000X3oooooool01H401X801h80
0_ooo`2P0@Z30@^40@b40@f40@j50Pn50Q260Q66oooo0QB70QF7oooo0aN8
0aR80aV90aZ90a^90ab:0af:11j:11n;122;oooo12:<12><oooo1BJ=1BN=
1BR>1BV>1BZ?1B^?1Bb?1Rf@1Rj@1Rn@1S2A1S6A1S:B1S>B1cBB1cFC1cNC
1cRC1cVD1cZD1c^E23bE23fE23jF23nF242F246G24:G2D>H2DBH2DFH2DJI
2DNI2DVI2DZJ2T^J2TbK2TfK2TjK2TnL2U2L2U6L2e:M2e>M2eBN2eFN2eJN
2eNO2eRO2eVO35^P35bP35fQ35jQ35nQ362R366R3F:S3F>S3FBS3FFT3FJT
3FNT3FRU3VVU3VZV3V^V3VfV3VjW3VnW3W2W3g6X3g:X3g>Y3gBY3gFY3gJZ
3gNZ47RZ47V[47Z[47^/47b/47f/47n]4H2]4H6]4H:^4H>^4HB_4HF_4HJ_
4XN`4XR`4XV`4XZa4X^a4Xbb4Xfb4hjb4hnc4i6c4i:c4i>d4iBd4iFe59Je
59Ne59Rf59Vf59Zf59^g59bg5Ifh5Ijh5Inh5J2i5J6i5J>i5JBj5ZFj5ZJk
5ZNk5ZRk5ZVl5ZZl5Z^l5jbm5jfm5jjn5jnn5k2n5k6o5k:o0QRd`003b>3H
R<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^005
0000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P2
00000hS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0
^8S0^08008000i^WlOK8c>8V?002ojf`00OO92koY9kf_<Go[K3^Nhcooolc
@jD01@00P007006000:0oooooooo00F100J200N200;oool0X04:P`4;Q04<
Q04=Q04>Q@8?Q@8@QP8AQ_ooo`8DQ`8EQoooo`<GR0<HR0<IR@<JR@<KR@<L
RP<MRP@NRP@OR`@PRoooo`@RS0@SS?ooo`DVS@DWS@DXSPDYSPDZS`D[S`D/
S`H]T0H^T0H_T0H`T@HaT@HbTPHcTPLdTPLeT`LgT`LhT`LiU0LjU0LkU@Pl
U@PmU@PnUPPoUPQ0UPQ1U`Q2U`U3V0U4V0U5V0U6V@U7V@U9V@U:VPY;VPY<
V`Y=V`Y>V`Y?W0Y@W0YAW0]BW@]CW@]DWP]EWP]FWP]GW`]HW`]IW`aKX0aL
X0aMX@aNX@aOX@aPXPaQXPeRX`eSX`eTX`eUY0eVY0eWY0eXY@iYY@iZYPi[
YPi]YPi^Y`i_Y`i`Y`maZ0mbZ0mcZ@mdZ@meZ@mfZPmgZQ1hZQ1iZa1jZa1k
[11l[11m[11o[A60[A61[A62[Q63[Q64[a65[a66[a:7/1:8/1:9/1::/A:;
/A:</Q:=/Q>>/Q>?/a>A/a>B/a>C]1>D]1>E]ABF]ABG]ABH]QBI]QBJ]QBK
]aBL]aFM^1FN^1FO^1FP^AFQ^AFS^AFT^QJU^QJV^aJW^aJX^aJY_1JZ_1J[
_1N/_AN]_AN^_QN__QN`_QNa_aNb_`8H]<000lSPf8S0^8S0^00;R<2h00=8
T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P00hS0^080
0004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2002000>KYo7icMCgRIL00_ooo`07ojf`hAHdogIkojBN
hRHlohUo<d>U00D008008P01P002P?ooo`04P@05P@06PP07PP48Poooo`4:
P`4;Q04<Q04=Q04>Q@8?Q@8@QP8AQP8CQP8DQ`8EQoooo`<GR0<HR0<IR@<J
R@<KR@<LRP<MRP@NRP@OR`@PRoooo`@RS0@SS0Goool0PPDZS`D[S`D/S`H]
T0H^T0H_T0H`T@HaT@HbTPHcTPLdTPLeT`LgT`LhT`LiU0LjU0LkU@PlU@Pm
U@PnUPPoUPQ0UPQ1U`Q2U`U3V0U4V0U5V0U6V@U7V@U9V@U:VPY;VPY<V`Y=
V`Y>V`Y?W0Y@W0YAW0]BW@]CW@]DWP]EWP]FWP]GW`]HW`]IW`aKX0aLX0aM
X@aNX@aOX@aPXPaQXPeRX`eSX`eTX`eUY0eVY0eWY0eXY@iYY@iZYPi[YPi]
YPi^Y`i_Y`i`Y`maZ0mbZ0mcZ@mdZ@meZ@mfZPmgZQ1hZQ1iZa1jZa1k[11l
[11m[11o[A60[A61[A62[Q63[Q64[a65[a66[a:7/1:8/1:9/1::/A:;/A:<
/Q:=/Q>>/Q>?/a>A/a>B/a>C]1>D]1>E]ABF]ABG]ABH]QBI]QBJ]QBK]aBL
]aFM^1FN^1FO^1FP^AFQ^AFS^AFT^QJU^QJV^aJW^aJX^aJY_1JZ_1J[_1N/
_AN]_AN^_QN__QN`_QNa_aNb_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P0
0038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008001i^W
lOoooo>P[_ARK_ooooN9UoW=e002oooo00?cX:kooolc@jD01@00P02Y0060
00:000>100B100F100J200N20@R30@V30@Z30@^40@b40@f40@j50Pn50Q26
0Q660Q>60QB70QF70QJ70aN80aR80aV90aZ90a^90ab:0af:11j:11n;122;
126<12:<12><12F=1BJ=1BN=1BR>1BV>1BZ?1B^?1Bb?1Rf@1Rj@1Rn@1S2A
1S6A1S:B1S>B1cBB1cFC1cNC1cRC1cVD1cZD1c^E23bE23fE23jF23nF242F
246G24:G2D>H2DBH2DFH2DJI2DNI2DVI2DZJ2T^J2TbK2TfK2TjK2TnL2U2L
2U6L2e:M2e>M2eBN2eFN2eJN2eNO2eRO2eVO35^P35bP35fQ35jQ35nQ362R
366R3F:S3F>S3FBS3FFT3FJT3FNT3FRU3VVU3VZV3V^V3VfV3VjW3VnW3W2W
3g6X3g:X3g>Y3gBY3gFY3gJZ3gNZ47RZ47V[47Z[47^/47b/47f/47n]4H2]
4H6]4H:^4H>^4HB_4HF_4HJ_4XN`4XR`4XV`4XZa4X^a4Xbb4Xfb4hjb4hnc
4i6c4i:c4i>d4iBd4iFe59Je59Ne59Rf59Vf59Zf59^g59bg5Ifh5Ijh5Inh
5J2i5J6i5J>i5JBj5ZFj5ZJk5ZNk5ZRk5ZVl5ZZl5Z^l5jbm5jfm5jjn5jnn
5k2n5k6o5k:o008H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P03HS0
^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P3002000^KYo7oooooRGooooocX:kaTj7o
oooooOocX:kono`c@jD01@00P02Y006000:000>100B100F100J200N20@R3
0@V30@Z30@^40@b40@f40@j50Pn50Q260Q660Q>60QB70QF70QJ70aN80aR8
0aV90aZ90a^90ab:0af:11j:11n;122;126<12:<12><12F=1BJ=1BN=1BR>
1BV>1BZ?1B^?1Bb?1Rf@1Rj@1Rn@1S2A1S6A1S:B1S>B1cBB1cFC1cNC1cRC
1cVD1cZD1c^E23bE23fE23jF23nF242F246G24:G2D>H2DBH2DFH2DJI2DNI
2DVI2DZJ2T^J2TbK2TfK2TjK2TnL2U2L2U6L2e:M2e>M2eBN2eFN2eJN2eNO
2eRO2eVO35^P35bP35fQ35jQ35nQ362R366R3F:S3F>S3FBS3FFT3FJT3FNT
3FRU3VVU3VZV3V^V3VfV3VjW3VnW3W2W3g6X3g:X3g>Y3gBY3gFY3gJZ3gNZ
47RZ47V[47Z[47^/47b/47f/47n]4H2]4H6]4H:^4H>^4HB_4HF_4HJ_4XN`
4XR`4XV`4XZa4X^a4Xbb4Xfb4hjb4hnc4i6c4i:c4i>d4iBd4iFe59Je59Ne
59Rf59Vf59Zf59^g59bg5Ifh5Ijh5Inh5J2i5J6i5J>i5JBj5ZFj5ZJk5ZNk
5ZRk5ZVl5ZZl5Z^l5jbm5jfm5jjn5jnn5k2n5k6o5k:o008H]<0?b>3H00<0
0038h=S8h=P03LSPf00300006;C06;C000o8h=P00`0001Rd`1Rd`002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1000P0>KYo401_oooo>P[_Be_oJl
aO_IfS=3Y@H00800Z@01P002P003P@04P@05P@06PP07PP48P`49P`4:P`4;
Q04<Q04=Q04>Q@8?Q@8@QP8AQP8CQP8DQ`8EQ`8FQ`<GR0<HR0<IR@<JR@<K
R@<LRP<MRP@NRP@OR`@PR`@QS0@RS0@SS0@US@DVS@DWS@DXSPDYSPDZS`D[
S`D/S`H]T0H^T0H_T0H`T@HaT@HbTPHcTPLdTPLeT`LgT`LhT`LiU0LjU0Lk
U@PlU@PmU@PnUPPoUPQ0UPQ1U`Q2U`U3V0U4V0U5V0U6V@U7V@U9V@U:VPY;
VPY<V`Y=V`Y>V`Y?W0Y@W0YAW0]BW@]CW@]DWP]EWP]FWP]GW`]HW`]IW`aK
X0aLX0aMX@aNX@aOX@aPXPaQXPeRX`eSX`eTX`eUY0eVY0eWY0eXY@iYY@iZ
YPi[YPi]YPi^Y`i_Y`i`Y`maZ0mbZ0mcZ@mdZ@meZ@mfZPmgZQ1hZQ1iZa1j
Za1k[11l[11m[11o[A60[A61[A62[Q63[Q64[a65[a66[a:7/1:8/1:9/1::
/A:;/A:</Q:=/Q>>/Q>?/a>A/a>B/a>C]1>D]1>E]ABF]ABG]ABH]QBI]QBJ
]QBK]aBL]aFM^1FN^1FO^1FP^AFQ^AFS^AFT^QJU^QJV^aJW^aJX^aJY_1JZ
_1J[_1N/_AN]_AN^_QN__QN`_QNa_aNb_`0f6;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^1<00800Z@01P002P003P@04P@05P@06PP07PP48P`49
P`4:P`4;Q04<Q04=Q04>Q@8?Q@8@QP8AQP8CQP8DQ`8EQ`8FQ`<GR0<HR0<I
R@<JR@<KR@<LRP<MRP@NRP@OR`@PR`@QS0@RS0@SS0@US@DVS@DWS@DXSPDY
SPDZS`D[S`D/S`H]T0H^T0H_T0H`T@HaT@HbTPHcTPLdTPLeT`LgT`LhT`Li
U0LjU0LkU@PlU@PmU@PnUPPoUPQ0UPQ1U`Q2U`U3V0U4V0U5V0U6V@U7V@U9
V@U:VPY;VPY<V`Y=V`Y>V`Y?W0Y@W0YAW0]BW@]CW@]DWP]EWP]FWP]GW`]H
W`]IW`aKX0aLX0aMX@aNX@aOX@aPXPaQXPeRX`eSX`eTX`eUY0eVY0eWY0eX
Y@iYY@iZYPi[YPi]YPi^Y`i_Y`i`Y`maZ0mbZ0mcZ@mdZ@meZ@mfZPmgZQ1h
ZQ1iZa1jZa1k[11l[11m[11o[A60[A61[A62[Q63[Q64[a65[a66[a:7/1:8
/1:9/1::/A:;/A:</Q:=/Q>>/Q>?/a>A/a>B/a>C]1>D]1>E]ABF]ABG]ABH
]QBI]QBJ]QBK]aBL]aFM^1FN^1FO^1FP^AFQ^AFS^AFT^QJU^QJV^aJW^aJX
^aJY_1JZ_1J[_1N/_AN]_AN^_QN__QN`_QNa_aNb_`0f6;C00XS0^058T8P1
000000000hS0^<SPf8S0^03eR<2h0DR@R04000000003R<2hb>3HR<2h0?F8
`;P1B9280@00000000>8`;S8h=S8h=P0mLSPf058T8P10000003iR<2h0@00
0000\
\>"], "Graphics",
  ImageSize->{250, 53},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004<0000?b000`400?l0
0000o`00003oooo`l?0=oo3`l000ooo`l?0=oo3`l000ooo`l?0=oo3`l000
ooo`l?0=oo3`l000ooo`l?0=oo3`l000ooo`l?0=oo3`l000ooo`l?0=oo3`
l000ooo`l?0=oo3`l000ooo`l?0=oo3`l000ooo`l?0=oo3`l000ooo`l?0=
oo3`l000ooo`l?0=oo3`l000ooo`l?0=oo3`l000ooo`l?0=oo3`l000ooo`
l?0=oo3`l00000goooooookno_ono_koo?clooWinOofm_Kol_;bong]kOoX
j>Sohn?Son3Ph?oMgMgofm_K00;of][JIooIfMT2om[JfP0:om_KfooMgMgo
h>3Pon?ShooXj>SokNg]oo;bl_ofm_KonOWiooclo0;oo_knR?ooool000;o
kNg]00[oj^[ZonSXj?oRh^;ogMgMomKFe_o=cLgoa/K6okjn__nj^[[o][Jf
1?nc/k=Uok:b/PCo/k>c00[o][JfokZj^_nn_[koa/K6olg=cOoFe]KogMgM
on;Rh_oXj>Soj^[Z0_o]kNf7onk^kP0000koiNGUon;Rh_oOgmoof][Jom;B
d_o7alOo_Kfmok:b/_nXZ:SoX:2Poi^KVonHV9SoU9BDoi>CTfWoTY:B00go
Ti>CoiBDU?nHV9SoVi^Koj2PX?nXZ:So/[:bokfm_Oo7alOod];Bom[Jf_oO
gmooh^;R00;oiNGUQ_oVi^H0000>on_[jooXj>Soh^;RomSHf?o;bl_o_[jn
ojj^[_nQXJ7oUIFEohb<S?n5QHGoPX:2ogmoOomnOWiYogemO@0?oginO_mo
OgooPX:2ohF5QOn<S8coUIFEoj6QXOn^[Zko_[jnol_;booHf=Soh^;RonSX
j?o[jn_okNg]08Kok^k^00005?oinOWolo?conWYjOoIfMWoalO7okBd]?nR
XZ;oVYZJojZZZ_o3`l?ofMWIonc/k?ofm_KomoOgooWinOohn?SonOWioo[j
n_oinOWomoOg0oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00_ohn?P0
4?oinOWon?ShooOgmoo^k^kof][JolC4a?nZZZ[oVYZJoj:RX_nd];CoalO7
omWIfOoYjNWolo?cooWinOomoOf6ooooo`0000coiNGUomgMgOo>c/ko_Kfm
ojRXZ?nEUIGoYJFUolc<c?o^k^kom_Kfooclo?ono_i]ooooo`0=ookno_ol
o?comoOgono_koo=cLgoYZJVoiFEUOnXZ:So_Kfmolk>c_oMgMgoiNGUon[Z
jP1konk^kP03oi>CTona/K7ok^k^00Sok^k^00002_oJf][oc/k>okfm_OnX
Z:SoUYJFoj^[ZooNg]kojn_[ooCdm?okno]0ooooo`03oijNW_nn_[kooooo
02kooooo00_ono_koo?cloo/k>cohN7Qojj^[_nFUYKoZ:RXokfm_Oo>c/ko
f][Jon3Ph01konKViP03ocTi>OmbLW;oi^KV00Soi^KV00002_oMgMgocLg=
okRh^?nQXJ7oZ:RXomCDe?oPh>3ok>c/ooGemOomoOe0ooooo`03od10@?mo
Ogoooooo02kooooo00_oo_knooKfm_o/k>coh^;RomWIfOn/[:coXJ6QokRh
^?o=cLgogMgMonGUi@0?onk^kP03on?ShooHf=Sok^k^00?ok^k^0_oQhN45
onk^kP;ohN7Q2?o^k^h01OoPh>3oj>SXong]kOoEeMGokNg]00Cok^k^00?o
jn_[omoOgoo^k^h01_o^k^h00ooEeMGok>c/onk^kP02onk^kP03omGEeOo/
k>cok^k^00;ok^k^00?og=cLomoOgoo^k^h04Oo^k^h00ooEeMGok>c/onk^
kP02onk^kP03omcLg?oOgmook^k^00Ook^k^00Goh>3PonSXj?o]kNgoeMGE
ong]k@05onk^kP03on?ShooHf=Sok^k^00Cok^k^00?ohn?SomSHf?o^k^h0
0_o^k^h01Olk>c_oMWIfong]kOoEeMGokNg]00Kok^k^00002ooXj>Soe=CD
okZj^_nYZJWoa/K6omCDe?oPh>3ok>c/oo;bl_olo?coo_kn03?ooooo00?o
m?CdonSXj?ooool01?ooool00oodm?Coj>SXooooo`02ooooo`05od10@?mo
Ogooo_knonGUiOono_h0;?ooool03_ojn_[om?Cdon[Zj_oShn?oemOGolg=
cOn/[:co^[ZjomCDe?oXj>Solo?coooooolf=SKoMgMg1Oooool00om0@43o
Ogmoooooo`02ooooo`0<onOWiom:BT[o0`<3ob<S8olG5aOo`L71oooooolU
9BGo410@ob0P8?m=CDgom_Kf0_ooool01OlU9BGo410@ob0P8?m=CDgom_Kf
00Kooooo00Ko@410oeUIFOlV9RKo6a/KoaDE5Onl_;`2ooooo`06okno_olK
6a_o1`L7oe9BD_n6QXKo<30`0_ooool04?oCdm?o9BDUoahN7_nj^[[ooooo
om?CdolU9BGo7QhNokZj^_oooooofm_KocDe=Ol>3Pko30`<ocTi>OoLg=`2
ooooo`06od10@?moOgoooooooooooonSXj?o71`L1_ooool02ooCdm?o9BDU
oahN7_nj^[[oooooom_Kfole=CGo3Ph>o``<3?li>CWog=cL00Kooooo00Ko
@410oeUIFOlV9RKo6a/KoaDE5Onl_;`2ooooo`0DonOWiom:BT[o0`<3ob<S
8olG5aOo`L71oooooooWinOoBTY:o`<30olS8b?o5aLGol71`Ooooooo@410
od];BolV9RKo6a/KoaDE5Onl_;`2ooooo`7oADE50OlY:BT1ooooo`0000oo
e=CDokno_onVYZKo[:b/olK6a_oBd];og=cLonKVi_o/k>comOGeooShn?oj
n_[ooOgmooooooolo?`02?ooool00oomoOgoooooooooo`05ooooo`03oogm
oOoooooooooo00Gooooo00?ooOgmooooooooool01Oooool00oomoOgooooo
ooooo`03ooooo`0KocHf=_l0003o0000oa4A4Om6ATKohN7QoooooooWinOo
BTY:o`<30olR8R;o5aLGol71`OooooooinOWodY:B_l30`?o8b<SoaHF5_o1
`L7ooooood10@?m;Bd_o9RHVoa/K6olE5AGo^[Zj00Oooooo00?ooOgmoooo
ooooool01Oooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo
00Gooooo00?ooOgmooooooooool01?ooool04oomoOgooooooogmoOokno_o
n?ShooCdm?o]kNgoi^KVomoOgooFe]Koc<c<ok:b/_nWYjOo_knoomCDe?oR
h^;ok^k^oc8b<_m_Kfl01Oo^k^h00olk>c_oMWIfonk^kP02onk^kP0<oclo
?olk>c_od=3@onk^k_oRh^;ohN7Qonk^k_nc/k?oj^[Zong]kOlb<S;oR8R8
0_o^k^h01Onc/k?oj^[Zong]kOlb<S;oR8R800Kok^k^00ko>c/kochn?_oO
gmooj^[ZogAdM?lA4A7oh^;Ronk^k_m>CTkoDe=ConKVi_nCTi?o3Ph>ob`/
;0;ok^k^00?oJFUYoc`l??o]kNd00_o^k^h01omYJFWo?3`long]kOo^k^ko
kNg]oc0`<?m<C4`00_oNg]h01_m?Cdoo<C4aong]kOo^k^ko>c/kogIfMP;o
k^k^00?oV9RHoaXJ6_o^k^h01Oo^k^h01omYJFWo?3`long]kOo^k^kokNg]
oc0`<?m<C4`00_oNg]h00om?Cdoo<C4aong]k@05onk^kP0Poc/k>oln?Sko
gmoOon[Zj_mdM7Co4A4Aon;Rh_o^k^ko?clooc/k>oo@d=3ok^k^on;Rh_oQ
hN7ok^k^oclo?olk>c_od=3@onk^k_oRh^;ohN7Qonk^k_lk>c_o?ShnomoO
gooZj^[oM7Adoa4A4OoRh^;ok^k^oh^;RommOGd1onk^kP0001?ob/[:okFe
]OnNWYko][Jfol?3`oo?clooe]KFomoOgooVi^Koj^[Zono_kooclo?om?Cd
ooGemOogmoOom_KfooOgmoofm_Kon?Sh00;omoOg0_ofm_H2ooOgm`04ooKf
m_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKf
mP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`0RooKfm_ohn?So
moOgooOgmold=3CoLW9boo;bl_o>c/ko9RHVoeQHF?ogmoOo@D51ocdm?OoG
emOomoOgon_[jooYjNWon?Shod51@Olm?CgoemOGooKfm_o[jn_oj^[ZooKf
m_ln?Sko@410onOWioobl_;oN7Qhoa8B4_o[jn_om_KfooShn0;omoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL01?ofm_Kon?Sh
ooOgmoogmoL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOg
m`0HooKfm_ohn?SomoOgooOgmoofm_KomoOgooKfm_odm?Col_;boo3`l?o[
jn_oi^KVon7QhOoJf][odm?ColW9bOno_kooXj>SokFe]Oo:b/[ofMWIonKV
i_l`<33oJf][1OoVi^H01oli>CWoLW9bonKVi_oVi^KoalO7o`000?nUYJD0
1ooVi^H00ona/K7o4a<CohB4Q004onKViP03ok6a/OlC4a?oQ8B400Koi^KV
00[o>CTiog9bL_oVi^Koi^KVom3@d?l0003oW9bLonKVi_lW9bOoPH610_oV
i^H01_m^KVko:b/[onKVi_oVi^KoADE5ofIVIP?oi^KV00OoADE5ofIVI_oV
i^Koi^KVol;2`_l0003oYJFU00;oi^KV00KoYJFUo`000?o6a/Koi^KVocTi
>OmbLW82onKViP03oi>CTolI6AWoi^KV00Goi^KV00OoADE5ofIVI_oVi^Ko
i^KVol;2`_l0003oYJFU00;oi^KV00?oYJFUo`000?o6a/H01OoVi^H02_li
>CWoLW9bonKVi_oVi^Kod=3@o`000?nLW9coalO7o`000?nUYJD4onKViP03
olO7aol0003oYJFU00Goi^KV00Oo>CTiog9bL_oVi^Koi^KVom3@d?l0003o
W9bL00Coi^KV00002oo@d=3o^;Rhoj2PX?nc/k?o`<30olW9bOoCdm?ofMWI
omgMgOoRh^;oiNGU00;oj^[Z00?ok>c/ong]kOo]kNd01oo^k^h00oo`l?3o
k^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP03onk^kP0;oc8b<_m_Kfool?3`onk^
k_mTI6Co9RHVolk>c_l0003oZj^[onk^k_o`l?000_o^k^h00oo>c/ko0000
oj^[Z`02onk^kP05oo3`l?o^k^kok^k^oc/k>omfMWH00_o^k^h00ooGemOo
0000oj6QX@06onk^kP03oo3`l?o^k^kok^k^00Gok^k^00?ol?3`onk^k_o^
k^h01Oo^k^h00oo`l?3ok^k^onk^kP05onk^kP03oo3`l?o^k^kok^k^00?o
k^k^0_o]kNd2onc/k00BonWYjOoVi^Kohn?Son3Ph?oKfm_oeMGEolg=cOo5
aLGo^k^kojNWYonh^;Sod=3@on3Ph?o^k^ko<S8boe5ADOnj^[[og=cL0oo^
k^h01olk>c_oMWIfonk^k_o^k^ko/K6ao`000?lh>3P00olj>SX01onf][Ko
k^k^omCDe?m5ADGo0P82ofUYJOoUiND00_o^k^h01OoDe=CoADE5o`820_mY
JFWoiNGU00Kok^k^00?o>c/kogIfM_o^k^h00_o^k^h01OlD51CoQhN7onk^
k_lY:BWoRHV900;ok^k^00KoQHF5ob`/;?o^k^kok^k^odM7AomZJVX3onk^
kP07odM7AomZJV[ok^k^onk^k_na/K7o0000omKFeP02onk^kP06omCDe?l0
003o];Bdonk^k_lk>c_oMWIf0_o^k^h00onHV9So6QXJonk^kP05onk^kP07
odM7AomZJV[ok^k^onk^k_na/K7o0000omKFeP02onk^kP03omCDe?l0003o
];Bd00Gok^k^00?o>c/kogIfM_o^k^h00_o^k^h01OlD51CoQhN7ok6a/Ol0
003o>3Ph00?o>SXj00Co][Jfok6a/Ol0003o>3Ph0olj>SX01?nf][Kok^k^
oc/k>omfMWH3onk^kP03oa@D5?n7QhOok^k^00?ok^k^00003OoOgmooaLG5
oijNW_n/[:co^k^kolK6a_o=cLgodm?ComOGeooKfm_ogmoOon7QhOoRh^80
0_oShn<7onGUi@;oi^KV1_oUiND2onKViPKoiNGU0_oVi^H6onGUi@;oi^KV
1OoUiND02Ol`<33oJf][onKVi_o=cLgo30`<og5aLOnZZZ[o0000ocHf=P03
ocPh>004ok2`/?nZZZ[o0000ocHf=P?o>3Ph00Co/;2`onGUiOli>CWoLW9b
0_oUiND00ooVi^Ko4a<Coh:2PP05onGUi@;oi^KV1_oUiND2onKViPKoiNGU
0_oVi^H6onGUi@;oi^KV1OoUiND2onCTi0;ohn?S01Ooh^;Ron3Ph?oLg=co
fMWIomKFe_o@d=3obLW9ol71`One]KGoYjNWolG5aOoOgmool?3`oooooolf
=SKo7QhNob4Q8Ol10@7oFUYJooCdm?oooooo@410ofUYJ@02ooooo`0;om_K
fol0003oZj^[olo?coo7alOo0`<3onGUiOoooooo@D51od92@_oKfm/01?oo
ool00om1@D7o@T92om_Kf`08ooooo`0:od10@?mjNW[oooooooooooo]kNgo
0000ol?3`ooooooo;2`/oi>CT`;ooooo00KoShn?oc0`<?ooooooooooode=
COmbLW83ooooo`07ode=COmbLW;ooooooooooooLg=co0000okBd]002oooo
o`06ok:b/_l0003oh>3Poooooom0@43oGEeM0_ooool00onMWIgo7AdMoooo
o`05ooooo`07ode=COmbLW;ooooooooooooLg=co0000okBd]002ooooo`03
ok:b/_l0003oh>3P00Gooooo01So@410ogYjN_ooooooooooong]kOl0003o
`l?3om_Kfol0003oZj^[olo?coo7alOo0`<3onGUiOoKfm_o0000oj^[Zoo?
clooalO7o`<30ooUiNGooooood10@?mjNWX2ooooo`03ong]kOl0003o`l?3
00Cooooo00003OoAdM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7A
dOoDe=CoemOGom[Jf_oKfm/00ooLg=`2omkNgP?ogMgM00?og]kNomgMgOoM
gMd00_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0ooMgMd00ooNg]ko
gMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@0M
obl_;ol[:b_o=SHfoa<C4on5QHGofm_Kokfm_Ol0003oU9BDok>c/on/[:co
0P82olO7aonm_Kgo0000oiBDU?nd];Co[:b/o`820_o7alOog]kNocLg=omY
JFWogMgMomkNg_o=cLgo0000ojVYZOoNg]h00ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgMg@03omkNg_oM
gMgogMgM00;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgPCogMgM0_oL
g=`08?oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm_On`/;3o
X:2Pok^k^ooAdM7ohN7Qonk^k_lb<S;oKfm_onk^k_o4a<Co2`/;of9RH_o^
k^ko>c/koa4A4On7QhOoe=CDonc/k?lj>S[oHf=SonKVi_nCTi?o:2PX0_o^
k^h01Olc<c?oS8b<onk^k_oHf=SojNWY00;ok^k^00Go<c<cohb<S?o^k^ko
f=SHonWYj@06onk^kP0:oc/k>olI6AWoS8b<olg=cOmRHV;o3`l?on_[joo^
k^ko:BTYohV9R@;ok^k^01CoQHF5ob`/;?o^k^koj>SXodA4A?mUIFGohn?S
on[Zj_oXj>SoA4A4ofEUIOoShn?oj^[Zonk^k_ll?3co@d=3olo?coo>c/ko
@T92oclo?`;ok^k^00Ko>c/koa8B4_m^KVkoclo?oe5ADOm7AdL5onk^kP0<
onSXj?m4A4CoIFEUon?ShooZj^[ok^k^oc`l??m3@d?oclo?olk>c_m2@T;o
?clo1_o^k^h03Olk>c_o6ATIohb<S?o=cLgoHV9Ro`l?3oo[jn_ok^k^ocXj
>_mSHf?oi^KVoi>CTolX:2P00_o^k^h01Olj>S[oHf=SonKVi_nCTi?o:2PX
00;ok^k^00Oo>c/koaTI6On<S8cocLg=of9RH_l?3`oojn_[00Cok^k^0000
3Oo=cLgo^KViohb<S?nNWYko[Jf]okVi^Oo2`/;oalO7olc<c?o@d=3od];B
omGEeOoFe]H00_oGemL00ooHf=SofMWIomWIf@0SomWIf@0<obd];Om:BT[o
OGemocHf=_mVIVKoeMGEomWIfOle=CGoFe]Kom;Bd_n6QXKo92@T0_oIfMT0
1Ole=CGoFe]Kom;Bd_n6QXKo92@T00;ofMWI00Oo=SHfoaHF5_n0P83o^k^k
oeUIFOl>3Pkoe]KF02CofMWI0_oHf=P2omOGe`0@omGEeOoCdm?od=3@olk>
c_o:b/[oaLG5okno_one]KGoZJVYoiRHV?ni^KWocLg=om_KfooVi^Ko<30`
of][J`;oi^KV00goG5aLoa`L7?oVi^KoBd];og]kNomCDe?o20P8omSHf?o?
cloo@410o`/;2olI6AWoYJFU00;oi^KV00Go[:b/oc@d=?l>3Pko4A4Aom7A
d@02onKViP05ojb/[?ld=3Co3Ph>oa4A4OoAdM401_oVi^H01_li>CWoKfm_
oe]KFol;2`_o5QHFoiNGU`;oi^KV01Co?3`lohj>S_oVi^Koi^KVoh^;Rolo
?cooi^KVog9bL_l71`Oo2PX:oaPH6?nLW9coLW9bo`L71ol:2P[o61PHoibL
W?oVi^KodM7AodU9B@;o3@d=00[oBd];om;Bd_oVi^Koi^KVod];BomnOWko
KFe]oa8B4_lY:BWo/;2`1OoVi^H02?mbLW;o1`L7o`X:2_lH61SoW9bLonKV
i_oAdM7oBDU90_l=3@d00om;Bd_od];BonKViP05onKViP06ocTi>Om_Kfoo
Fe]Ko`/;2olF5QKoUiNG0_oVi^H01Oo?cloo@410o`/;2olI6AWoYJFU00;o
i^KV00Goclo?od10@?l;2`_o6ATIojFUY@02onKViP06od];BomlO7coFe]K
o`/;2olF5QKoUiNG1OoVi^H0000=omSHf?o6a/KoRHV9oi>CTonRXZ;o[jn_
okZj^_o1`L7oalO7ol_;boo>c/kod=3@om7Ad@02om?Cd`?oe=CD0_oEeMD0
1?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD
0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]Ko
eMGEomKFe_oEeM@2omCDe0;oeMGE01Coe]KFobd];OmSHf?oeMGDolC4a?l8
20SoUiNGomGEeOo1`L7o>c/ko`X:2_lG5aOoV9RHomCDe?oEeMGo`<30oc/k
>ol:2P[o5aLGoiRHV0;oe=CD00KoATI6og=cLomDE5Co2PX:oa@D5?n<S8/2
omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;o
eMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@03omKFe_oEeMGoe=CD
00;odm?C013odM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jfoj^[ZonMWIgo
TY:BolK6a_oHf=Soh^;Ronk^k_lb<S;oKfm_0_o^k^h00om0@43o?cloonk^
kP03onk^kP05on_[joo^k^kok^k^onk^k_o[jn/01_o^k^h00oo[jn_ok^k^
onk^kP04onk^kP03on_[joo^k^kok^k^00Kok^k^00Co>c/kogIfM_o^k^ko
k>c/3?o^k^h00om7AdOoJVYZonk^kP02onk^kP03odM7AomZJV[ok^k^00Co
k^k^0_o]kNd7onk^kP03ong]kOo^k^kok^k^00Kok^k^00?oAdM7ofYZJ_o^
k^h01?o^k^h2ong]k@Sok^k^00Co>c/kogIfM_o^k^kok>c/1_o^k^h00oo[
jn_ok^k^onk^kP04onk^kP03on_[joo^k^kok^k^00Gok^k^00?ok>c/onk^
k_o^k^h01Oo^k^h0000Bong]kOoLg=coUIFEohV9ROnGUiOoYJFUok:b/_no
_koobl_;om7AdOoEeMGoemOGomWIfOoJf][ofm_Kom[Jf_oKfm_og=cL1ooK
fm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o
g=cLom_KfooKfm/01OoKfm/02_oLg=cofm_Kom_KfooKfm_o;Rh^ofIVI_oK
fm_oalO7o`P82?mkNg/3om_Kf`04omSHf?oKfm_ofm_KomcLg0?ofm_K00Go
f=SHom_KfooKfm_ofm_KomcLg003om_Kf`05omWIfOoKfm_ofm_Kom_KfooL
g=`01ooKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00Go
fm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`03om_Kf`0F
om[Jf_oIfMWof=SHomKFe_oCdm?ocLg=ol;2`_nf][Ko[:b/oinOWon@T93o
Vi^KomcLg?o]kNgom_Kfoooooolf=SKo;bl_oeYJF_lW9bOo0P82ojj^[Qoo
oooo00?o@410ogmoOoooool03Oooool00ooPh>3og]kNooooo`02ooooo`03
on3Ph?oNg]kooooo01Kooooo00?oh>3PomkNg_ooool03_ooool00om0@43o
Ogmoooooo`0Nooooo`0000_oh^;RomKFe_nPX:3oNWYjohR8R?nFUYKoZZZZ
olC4a?oEeMGofm_KomkNgP02on3Ph0?oh^;R00?oi>CTon?ShooShn<01OoS
hn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?o
i>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`02on?Sh`06oc0`<?lY
:BWoA4A4oa8B4_lG5aOoe]KF1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03
onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Co
hn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`03on?Sh`;oh^;R01CohN7Qon3Ph?oO
gmoog=cLomOGeoo5aLGo[:b/oijNW_n@T93oPX:2ojBTY?oFe]Koh^;RonSX
j?o^k^koY:BTohn?Son@T93oXJ6Qolo?cb3ok^k^00?o>c/kogIfM_o^k^h0
??o^k^h00olk>c_oMWIfonk^kP0Nonk^kP0000kogMgMomKFe_nl_;coNWYj
ogQhN?n6QXKoWinOolG5aOoHf=SogMgMomoOgooQhN7oh^;Ron?Sh`?oi>CT
1?oUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CT
onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGU
iOoTi>CoiNGU00?oiNGU00GoWIfMohV9ROn=SHgo^KVion?Sh`03onGUi@;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oU
iND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGo
i>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND3onCTi00>
on?ShooQhN7oh>3PomoOgooJf][oa/K6oj6QXOn=SHgoP820oh>3Ponm_Kgo
e]KFomgMgOoRh^8VonKViP03on;Rh_oTi>Coi^KV03coi^KV00?oh^;RonCT
i?oVi^H07_oVi^H0000;onSXj?oRh^;ofMWIoinOWomUIFGoLg=cohf=SOnk
^k_oe=CDom[Jf_oMgMd00_oOgml00ooPh>3ohN7Qon7Qh@05on7Qh@03on;R
h_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q
00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;R
h_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Q
on7Qh@08on7Qh@0>on3Ph?oOgmoogMgMomcLg?oEeMGo^KViohj>S_mkNg_o
KVi^oj:RX_oIfMWoh^;RonSXj?o/k>b6onk^kP0000coo?clooWinOobl_;o
inOWoiBDU?mRHV;oMWIfojBTY?o7alOod];BomGEeOoHf=P2om[JfP?ofm_K
1ooLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cL
omcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`00_oLg=`04OoKfm_og=cLom_KfooJf][ofMWIomSH
f?oCdm?oaLG5oibLW?meMGGoIfMWoiNGUooWinOol_;booWinOolo?coo_kn
08Kooooo00003_o]kNgoj^[ZonOWiooRh^;oclo?ohZ:R_mJFU[oNg]koj>S
Xonl_;coa/K6ol_;boo=cLgoclo?0_oAdM45om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;B
d_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP;odM7A00god=3@olo?coo<c<cob<S8ok^k^onLW9coLW9boe]KFon=SHgo
clo?on;Rh_oWinOoj^[Z00;okNg]Q_o^k^h000;oiNGU00koh^;Ron3Ph?oK
fm_oeMGEoiRHV?m/K6coJ6QXoh>3PonGUiOoXj>Sojb/[?n_[joo/K6aok:b
/P;o];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd
0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd
]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H03ond];Co/k>cok:b
/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9RH_m]KFgoVi^KomGEeOoKfm_oh>3P
on;RhP02onGUiHOoi^KV00004_o^k^kokNg]ong]kOo[jn_oj>SXonGUiOoR
h^;obl_;oijNW_mmOGgoJf][ofATI?mYJFWoLW9bogAdM?miNGWoO7alog]k
N`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogal
O?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00koO7alogYjN_mjNW[oMgMgogAdM?m^KVko
LG5aogmoOonNWYkoc<c<on;Rh_oUiNGoj>SXon_[j`;okNg]R?o^k^h000;o
oooo0_ono_h02OomoOgono_kooWinOofm_Kolo?coo;bl_o`l?3okno_onk^
kP1[ong]k@09onk^k_o_knool?3`oo;bl_oclo?om_KfooWinOokno_ooOgm
00;oo_knROooool000Cok^k^0_o]kNd00oo/k>coj^[Zon[ZjP02onSXj0;o
inOWJooVi^H2onOWi`;oj>SX0_oZj^X00oo/k>cokNg]ong]k@2;onk^kP00
oomoOgl=ogmoO`0000Cojn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP1bomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
gMgM0_oLg=`0POoKfm_ogMgMomcLg?oMgMgogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMg@03omkNgP03omgMgOoN
g]kog]kN00?ogMgM0OoQhN41onOWi`7oj^[Z00000oo/k>coi^KVon3Ph007
omWIf@04omSHf?oFe]Kodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH
2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSH
f0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooH
f=P/omWIf@;of=SH00?ofMWIomSHf?oHf=P00ooIfMT2omSHf0GofMWI00?o
f=SHomKFe_oCdm<00_oCdm<00ooFe]Kof=SHomSHf00>omWIf@04omSHf?oI
fMWofMWIomSHf13ofMWI0_oHf=QHomWIf@03omSHf?oIfMWofMWI00KofMWI
0OoNg]h1onKViP7ok>c/00001oo^k^kojNWYonCTi?oPh>3ohN7Qon3Ph?oR
h^800_oQhN403OoNg]kog=cLom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k
^oo7alOodm?Com_KfooOgml02OoQhN403OoOgmoofm_Kom?Cdoo7alOo^k^k
ok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml02OoQhN403OoOgmoo
fm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooO
gml07OoQhN4:on3Ph003omoOgooPh>3oh>3P00KogmoO0_oPh>03omoOg`Go
h>3P00OogmoOom_KfooGemOoe=CDomGEeOoIfMWogMgM00;oh>3P00?ogmoO
on3Ph?oPh>000_oQhN47on3Ph0KogmoO00?oh>3PomoOgooPh>002ooPh>00
1?oOgmoog]kNomkNg_oOgml2on3Ph5OohN7Q00?oh^;Ron7QhOoRh^801?oQ
hN41onCTi07ojNWY0Oo]kNd00003oo3`l?o_knoolO7a00?ol?3`05[okno_
oo3`l?o^k^kojNWYom_Kfoo1`L7oY:BTohb<S?mkNg_oMgMgog]kNon<S8co
Y:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_oNg]kogMgMomkNg_oS8b<ojBT
Y?o2`/;of][Jon[Zj?o]kNgolO7aono_kooalO7okno_oo7alOo_knoolO7_
ong]kOoZj^[of][Jol;2`_nTY:CoS8b<og]kNomgMgKoNg]kohb<S?nTY:Co
`/;2om[Jf_oZj^[okNg]oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_koo`l?02onc/
k007on_[joo^k^cok>c/ong]kOo/k>cok^k^on[ZjP02on_[j`0:onk^k?oY
jNWoj>SXonKVi_oYjNWoi^KVon[Zj_o[jn_okNg[onSXj0;ojNWY00OokNg]
on[Zj_o/k>cok>c/ono_kOoZj^[oj>SX00;ohn?S00gogmoOon?ShooXj>So
kNg[on[Zj_o[jn_ok>c/oo3`l?o_knool?3`ong]kOo/k>[oj^[Z00;ok^k^
00Kokno_on[Zj_oYjNWoi^KVonSXi_oWinL2onWYj@06onc/k?oYjNWok>c/
ong]kOo^k^coj^[Z0_o/k>`02?o^k^koj^[Zonc/k?o/k>cokno]on_[jooY
jNWoi^KV0_oXj>P2ong]k@1Moo3`k_o_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo`
l?3okno_oo3`l?o_knool?3`ono_koo`l?3okno_00Col?3`00000oobl_;o
k^k^onOWi`04onGUi@0@onCTi?oOgmoodM7Aok6a/On:RX[oIVIVoe5ADOm5
ADGo@T92odE5AOmADE7oIVIVohZ:ROna/K7odM7AomkNgP;oi>CT00?oiNGU
onCTi?oUiN@00_oTi>@03ooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo
@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7@omkNgP02onCTi00bonGUiOoT
i>CoiNGUonCTi?oTi>?og]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92
@_m5ADGoDE5AofIVI_n:RX[o/K6aom7AdOoNg]koi>CSonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTon?ShooNg]h2om_Kf`0:omkNgOoLg=cofm_KomcLg?oOgmoofm_K
omWIfOoLg=cogMgLomOGe`?oeMGE00Coe=CDomWIfOoMgMgogMgL0_oGemL0
4_oKfm_ogMgMom[Jf_oJf][og]kNon7Qh?oKfm_of=SHodI6A_l`<33oN7Qh
ol;2`_oJf][og]kMom[Jf_oIfMWogMgMon?Sh`;oi>CT01KogmoOomcLfooI
fMWogmoOon;Rh_oQhN7ofm_KomKFe_oDe=Coe]KEomCDe?oFe]Kofm_KomcL
g?oHf=Sog=cLomoOgooOgmkofMWIom_KfooNg]kogmoO0_oJf]X0GooMgMgo
h>3Oom_KfooGemOoeMGEomOGeooIfMWogmoOon;Rh_oTi>?oi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CT00CoiNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o]
kNd1oo;blP0000?om?Cdong]kOoWinL00_oPh>004ooQhN7ogmoOomkNg_oB
d];o];BdohN7QomLG5coKC/eoii>@_o=KeoojH=_ole_GonNCT?oKC/foeaL
G?n7QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aL
ofeP;?nNURkocLdoonWYCOo=cCooWYX_ofeS;OmLG5coQhN7okBd]?oBd];o
g]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m7IbkoJ9hcoi7=AonZ
jEGoTLe7ofZN=?m9JRooG5aLohN7Qond];Cod];BomkNgP0Kon3Ph013omkN
g_oHf=Sod];BomCDe?oFe]Kod];Bolo?cooBd];oe]KFom?CdooAdM7oeMGE
omKFe_o@d=3oa<C4ol_;boo?cloobLW9olC4a?oHf=SoeMGEom3@d?o4a<Co
d=3@omSHf?oBd];odM7AomSHf?oKfm_oe]KFom7AdOnEUIGoX:2Pochn?_m;
Bd_oe=CDomSHf?oBd];odM7AomSHf?oNg]koh>3PomoOgooJf][odm?Com7A
dOoHf=SogMgMom[Jf_oCdm?oclo?ol30`?o@d=3ocLg=okno_ooDe=Coe]KF
om7AdOoDe=CofMWIomSHf?oAdM7od];BomSHf?oIfMWodm?Com7Ad@02omOG
e`08om7AdOo?cloob<S8olC4a?oHf=Sofm_KomkNg_oOgmmDon3Ph003omoO
gooPh>3ogmoO00;ogmoO0ooPh>000ooQhN7oinOWonc/k001ooCdm00000?o
m_Kfoo;bl_o[jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWiooJemOohlf;_o]
LF7onIf@oofaYOom_:oooKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;R
h_oWinL00ooXj>P04ooWinOoh^;Rolg=cOnOWiooKVIOoi=b8_o]dDConO=d
oogmSOomoIGooOf>ooWhM_o]edOoTg<RofiWGonOWioocLg=on;Rh_oWinL0
0ooXj>P04ooWinOoh^;Rolg=cOnOWiooH6QOod]l8onBhD_o_OUkom3mT_oH
oI_oe?fEol3iO_nHj4goCH0Tof1YGonOWioocLg=on;Rh_oWinL06_oXj>P0
:OoVi^KogmoOoc0`<?n?Shoofm_KolO7aon8R8SoaLG5om_KfonUYJGo0@41
omgMgOoNg]koKFe]o`P82?lA4A7oLg=coc0`<?lT92CogMgMom_Kfom;Bd_o
30`<of9RH_oQhN7oKFe]ocXj>_oOgmoohn?Sol?3`ol0003o`L71on7QhOnP
X:3o3@d=omOGeooNg]koOGemoaLG5ooMgMgoi>CT00;oi^KV01Coh^;Rogmo
OolX:2SogmoOonGUiOoShn?o][JfoalO7ol92@Wo=SHfogAdM?l820SoUYJF
omgMgOl?3`ooUiNGon7QhOoOgmoo@T92ofATI0;oh>3P00coMGEeoc8b<_oM
gMgofm_Kokjn__ll?3co0P82oalO7olE5AGo];BdonKVi_oWinMMonSXj07o
k>c/0Oobl_81ooKfmP0000?omoOgooShn?ohn?P00oohn?P04oogmoOok^k^
olk>c_n@T93oQBl[onUTE_okTXOooZJKoojaYOoo^:_oo[>VoojXW?okU8Wo
kVQIohTa:on@T93oc/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@
T93oVFT[oo2m?Ookh6koo_B2ooknR_oooi;oo_j<ookhPookiG3ol<8noiUZ
:on@T93oc/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93o@W<[
ohC>@on]kg?o`_j8olknT?oFoiOod?jBolKnROnbmGCoR==3odAe:on@T93o
c/k>onk^k_ogmoL06_ohn?P0;oofm_Kokno_oc<c<onIVIWoinOWoh>3Pol0
003oO7alonSXj?n`/;3o0@41ong]kOoShn?o1PH6oj:RX_oMgMgoMgMgo`00
0?o>c/kol?3`ol;2`_l0003odM7AooCdm?oalO7oMGEeochn?_o^k^kol_;b
om3@d?l0003oclo?oo7alOo8b<So0000ol?3`oo^k^koQXJ6oaTI6OoYjNWo
kno_oo;bl_odm?ColO7aohR8R?l[:b_ok^k^00;omOGe01coI6AToclo?ooU
iNGo/k>coalO7omWIfOokno_ong]kOl@413oXZ:Roo3`l?o_knooAdM7of][
Joo_knool?3`oginO_le=CGojn_[onSXj?lg=cOoA4A4olk>c_oWinOogMgM
onCTi?oemOGomoOgE_ohn?P00oogmoOon?ShooShn002ooShn004ooOgmooi
nOWomoOgooOgm`7on?Sh00000oojn_[omOGeonk^kP02onc/k02Ion_[jooY
jNWogmoOokZj^_miDU;o_c8TonMdJOomRGkooiR<oojRU_ooZ9cooZBHoonJ
SOonRWookWIZol<c9?miDU;o^[ZjomoOgooZj^[ojn_[onc/k?o[jncoj^[Z
omoOgonj^[[oR6EBon:A7?oi`e3ooMYSoooZL_onlgkoooZ2ookfOoook7?o
o]iToo[7DOoRTQcoRFICokZj^_oOgmooj^[Zon_[joo/k>cojn_[on[Zj_oO
gmoo^[Zjoe9]D_mAXacoTM9EojKWJ_nhnG[o`?j2olOoROo3oXCo^OekojO/
K?nDeUOoDZHLoe9]D_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/onWYjOoS
hn?o<30`oi2@T?oHf=Wo;Bd]od10@?lS8b?of][JojJVY_l10@7ohN7Qon?S
i?l@413oO7alomoOgond];Co0000om7AdOoTi>CoV9RIo`l?3ooPh>3oinOW
on?Shom_Kfoo>c/komoOgooQhN;o`l?3o`000?o5aLGoi>CTokno_ol0003o
^;Rhon7Qh_moOgoo5aLGomWIfOoMgMgohN7QonGUiOoTi>CoPH61obPX:?oO
gmooi^KVonSXj?mdM7Co7alOomWIfOoLg=go>c/kofm_KooTi>Coh>3Po`l?
3onHV9SohN7QomoOh?m3@d?oIFEU00;oh>3P05ooMgMgoc8b<_oPh>3o^;Ri
o`000?nXZ:Sog=cLomWIfOoKfm_ohN7QonWYjOoZj^_ok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k007on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT00003oo_k
nooclo?okNg]00;oiNGU0:3oi^KVonCTi?oIfMWo/[:bogT^;_o8@SCohfYL
ooAjKOomR7cooYN:oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;o
f=SHonCTi?oUiNGoi^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^lA?on
c5?ooMQRookSL_onjGGoo^IcookKIOomc5?onl55onjN:onIERko/[:bomSH
f?oTi>CoiNGUonKVi_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on7bTSoUmaI
ojGUJOnblgOo^?IkokCeNOnWjV_oV=aIohW?BomS[R_o;V<^ok:b/_oHf=Wo
i>CTonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^Kohn?SomgMgOl_;booRh^;ok6a/_l0003o]kNg
obDU9OnXZ:SoX:2Po`410OoLg=coh>3Qok:b/_li>CWo9BDUoc/k>ol0003o
cLg=omgMgOnCTiCo410@omKFe_oNg]kog=cLofa/K?li>CWoe=CDomKFeonl
_;co0000ol;2`_oOgmoo^k^ko`000?nd];Cog=cLogalO?lG5aOoe]KFom[J
f_oNg]koh>3PomoOgommOGko9bLWomGEeOoLg=cog]kNom_KfomTI6Co820P
oc`l??lC4a?oKFe]on3Ph?oLg=co3`l?oi>CTooGemOoeMGFod51@OmRHV;o
emOGomKFe_mcLg?o<C4aomgMgOnJVY_o00001?lg=cL0Eonb/[;oi>CTonCT
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUi@02onKViP03onGUiOoVi^Koi^KV00?o
i^KV00?oiNGUong]kOodm?@00Ookno/00003ooclo?ohn?SolO7a00?ok^k^
01?ojn_[on7QhOnl_;coNQLGol<o<_oCETWoi6QJonmgK?odPgWon8MlooF4
N_ocNFgoiFUKomUHB_o4?c;oO1LGokbl_?oQhN7ok>c/00?ok^k^01?ok>c/
on7QhOnl_;coYDLGonJG<_oe[33ooKa1oog9Doomd63onm=UoogBH?oncECo
oKe2ooZ_<_oYVc;oYDHGokbl_?oQhN7ok>c/00?ok^k^01?ok>c/on7QhOnl
_;co5eTGoenX<_mf_COoQ/e7oiKFF_nRh6GoXn1Yoj?QIonGfUcoQ/i7ogNo
=omOZc;o5eTGokbl_?oQhN7ok>c/01[ok^k^02Ook>c/onGUiOla<C7oShn?
ofi^K_l/;2coj>SXogemOOmNGUkoY:BTo`410OoShn?ojNWYonKVi_oRh^;o
h>3Pojf][Ol0003oemOGonCTi?nHV9So410@omgMgOoShn?oi>CTog1`L?lT
92Coe]KFomoOgono_koo0000ol_;booYjNWo`L71o`000?nj^[[oi>CToh61
POl61PH00oln?Sh08_o;bl_ojNWYohB4Q?lJ6Q[of][Jon;Rh_oUiNGoinOW
on?ShooPh>3of=SHocLg=ombLW;oj^[ZonOWiol?3`ooRXZ:omoOgooNg]ko
@d=3oeIFE_oPh>3ogmoOogMgMolc<c?ojNWYokjn__l0003oX:2PokJf]_nZ
ZZ[o0P82omWIfOo]kNeMonk^kP03ong]kOobl_;on?Sh007oo?cl0003oogm
o@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@@ooJ
HUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];olo?coocl
o0?ooOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWomJPYooRd?ooi_D[o
n;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?oo?cl00?ooOgm
01?oo?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:cE3oSLeBoh[>
D?n1adCoLKT_of:^8?m>VcCo1d87om;Bd_oclo?oo?cl01[ooOgm04cono_k
ooCdm?ld=3CoUiNGoalO7on7QhOon_[jomgMgOlC4a?oZJVYo`410Oobl_;o
nOWiol30`?o4a<Colo?cohb<S?lQ8B7on_[jooGemOnMWIgo410@onKVi_o^
k^kom?CdogQhN?lA4A7oC4a<ol[:b_n9RHWo51@DooKfm_oinOWoc/k>o`00
0?o6a/Kolo?cohV9ROlC4a?o][JfokVi^Onj^[[okNg]ooWinOn?Shoo30`<
oeMGEooAdM7okNg]onc/k?nVYZKoi^KVonCTi?lB4Q;o[Jf]oo_knoojn_[o
410@oahN7_nUYJGog=cLoaXJ6_lP823oOGemomkNg_m7AdOoGemOoo_knooj
n_[o=3@dog5aLOo^k^koSXj>ocDe=Ookno_oo?clFoomoOd00oolo?cooOgm
ooclo003oogmo@0003[ooOgmoo[jn_oclo?ok^k^oo3`l?o_knook^k^onWY
jOoCdm?oFadMoj8d=?nd:1go`CX]olM9??o?ET[od5M;om1GB_o:BSko`c/^
okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_onk^k_oZj^[o
dm?Coh`U7Oo8LCCofH@MonBD5OoWWBCokZPcoo2Z=?o_ZS?ok:0UonNG5OoL
R1gob74doh`U7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`l?o^k^koj^[Yom?C
dolM>1go=88dodNE7OmJYA_oJJdZ0_md^3P0KOme^CSoJk4[oe^W7?m8VQgo
=88doadh7OoCdm?oj^[Yonk^k_o`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_onk^k_oWinOo<C4a
oemOGol10@7od];Bonk^k_o/k>co@D51of5QHOl10@7oi^KVonk^kOnPX:3o
>CTioa4A4OlV9RKoV9RHono_koo5aLGo410@o`410OlI6AWoDU9BonWYjOma
LG7o?CdmoiNGUolO7aoo61PHoi6ATOo^k^kokNg]ol?3`ol0003o_;blonSX
ion2PX;o61PHomoOgooRh^;ohn?SonOWioo[jn_oTi>Boclo?onBTY;o5aLG
oiBDU?oPh>3oCdm?oalO7olA4A7oCdm?onSXj?o^k^kokno_obLW9onPX:3o
CTi>o`T92Olf=SKoh>3Pofi^K_l?3`oo;2`/okjn__o^k^kokno^om;Bd_ll
?3co2`/;oadM7Onb/[800_o_knl0E_o`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_0_o`l?06ono_k`7olo?c0OoinOT1ooknoP0000?oo_knooOgmoo`
l?001?oYjNT04OoWinOofm_Kof=;Bon1<S;oYSDeokHd;Oo2CD7o`eA9olAE
B_o3E4Wo`Te1okHd;OnU=CGoPC8bof=;BooKfm_oinOW00GojNWY017oinOW
om_Kfon9Bd_o[d/boleg=OoFRbgoh9`^on2P<_oQX3Coh:0bomnJ;_oFRbgo
bWDeojm;<_n9Bd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oBd];oc9P<_lj
RCGoDi/]of^[;om`[CSoKjhjog2]>?mZZRooDi/]ocV8=OlbH3;oBd];om_K
fooWinL06ooYjNT03OoXj>Soi>CToc0`<?lB4Q;o?3`lonKVi_oXj>SoinOW
oi>CTolA4A7o0@41on?ShooWinL00_oYjNT00ooWinOojNWYonWYj@02onSX
j00DoifMWOl@413oinOWonOWiooTi>CoKfm_oc/k>ooShn?oinOWonSXj?oY
jNWoj>SXonOWioo2`/;o0000okZj^_oTi>CoP820oaLG5ooMgMd2omkNgP03
on7QhOoVi^Koj>SX00;ojNWY00?oj>SXonOWiooYjNT00_oYjNT00ooWinOo
jNWYonWYj@05onWYj@05onSXj?oYjNWojNWYonWYjOoWinL01_oYjNT00ooV
i^KojNWYonWYj@1IonWYj@03onSXj?oYjNWojNWY00CojNWY0Oo`l?01ooOg
m`7oo_kn00001Oono_kon_[jooCdm?o_knoolO7a00;ol?3`017okno_on_[
jonEU9CoCb<SoiEDE?nkLg?odiFEomZLW?oJWYcofIbLomBEUOnkLg?oUEAD
odlS8onEU9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oZIBDoh4S8onjJUCo
e9YconBlUOoZaicojLNLon[7W?oU_9Goe9Ycok]ZE?n18b?oZYBDon[Zj_o_
knl01Oo`l?004Oo_knooj^[ZoiBDU?lS:R?oE7YDog>ULonNaYGo[<jLojg>
W?n/cYcoW/JEog>ULomDNUCo8bXSoiBDU?oZj^[okno_01_ol?3`00Gokno_
onk^k_lb<S;o0000oi>CT`03ono_k`05onCTi?l;2`_o0@41onk^k_o_knl0
1oo`l?002OoShn?o_knoono_koo_knook^k^ogAdM?lm?CgokNg]ono_k`03
oo3`l007ono_koo:b/[o0000ol?3`oo^k^koQXJ6o`T92@03oeiNGP03ogUi
NOo^k^kokno_07_ol?3`00ColO7aoo3`l?odm?Con_[j0Oono_h00004oogm
oOooooooooooooknoP;ooooo0_ono_h0G_omoOgon?Shofi^K_mJ?coo/I2@
omk9bOo`i>ColnKVoo3Ti?oNbLWo/I2@oeXo?om]KFgon?Shooclo?oooooo
o_knooooooono_koooonookno_ooooooo?clooShn?n=KFgoRSloolVAT?oY
d<Wom>WTooK[i_odjNCojM39olVAT?n9?cooSFe]ooShmoolo?coooooookn
o_ooooooo_knooooooono_koooonooclo?ohn?SoKFe]oclo?on@WI3obMG9
onC/i?oVk^Koi>cTolWEbOn@WI3o?cloofe]KOohn?Soo?clooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_oooooooOgmojn_[onHV9SolO7`oogmoOooool2ookn
oP0FokBd]?nJVY[ooOgmooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_oooooooOgmookno_mlO7co@D51oogmoOono_goo_knoooo
o`;oo_kn08?ok^k^oiVIVOo[jn_oo_kmom7AdOnIVIWoV9RHoiVIVOnHV9So
[:b/oogmoOooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooooknoP02ooooo`03
ookno_oooooooooo00?ooooo0OomoOd00004ooShn?ono_kon_[jooCdm0Go
lO7a00gokno_omKFe_m[Jf_o@cdmoi^<S?o6^[[oe/c<olNj^_nKS8co@cdm
of][JooFe]Kokno_00WolO7a00gokno_omOFe_n3Jf_oM3dmokF<S?oE^[[o
hLc<omJj^_nfS8coLSdmoh5[JooGe]Kokno_00WolO7a00gokno_omKFe_m[
Jf_o?Cdmohb<S?nj^[[oc<g<okZj^_n<S8co?Cdmof][JooFe]Kokno_03Ko
lO7a00?ok^k^ong]kOoalO40QOoalO401?o`l?3olO7aoo7alOo`l?04oo7a
l@03ooCdm?ojn_[oo_kn007omoOg00001Oo[jn_ooOgmooShn?o`l?3ojn_[
00?oj^[Z00gojNWYon[Zj_oYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKo
FEUIoi^KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]
2@Wo@RHVofUIFOnPVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^KoeUI
FOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT0a_oZj^X01?o[jn_ol?3`
ooShn?omoOd1onc/k00000Coa/K6ookno_ojn_[om?Cd2?oalO42oo3`l0?o
kno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;o
l?3`a?oalO400oo`l?3olO7aoo7al@02oo7al@03ooGemOojn_[oo_kn007o
a/K600000oo6a/Ko`l?3oo[jnP3oooooo`Oooooo0OoinOT1olC4a07oa/K6
00001_oKfm_o_knookFe]OoWinOomoOgooclo?oooooo0Oooool01OomoOgo
moOgonOWione]KGo_kno007of][J0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{268, 63},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleBeep",
        ButtonData:>{"SimpleBeep.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SimpleBeep[]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.awt.event.ActionEvent"] \[RightGuillemet]\),
      JLink`Objects`JavaObject51672164335617]], "Print"],

Cell[BoxData[
    \("Beep"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.awt.event.ActionEvent"] \[RightGuillemet]\),
      JLink`Objects`JavaObject118084371218433]], "Print"],

Cell[BoxData[
    \("Beep"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.awt.event.ActionEvent"] \[RightGuillemet]\),
      JLink`Objects`JavaObject104713500491777]], "Print"],

Cell[BoxData[
    \("Beep"\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.plaf.basic.BasicArrowButton <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h5<30`1AVIVKo`<30ol30`5;0`<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h5<30`003c<c<VIVIVIVI012IVIT00fIVI/30`<30
`03o`<30ol30`530`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h5<30
`003c<c<ooooc<c<00o<c<`00iVIVFIVI/30`03o`<30ol30`570`<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h5<30`003c<c<ooooc<c<00o<c<`0
0iVIVFIVI/30`03o`<30ol30`570`<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h5<30`003c<c<ooooc<c<00o<c<`00iVIVFIVI/30`03o`<30ol30
`570`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h5<30`003c<c<oooo
c<c<00o<c<`00iVIVFIVI/30`03o`<30ol30`570`<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h5<30`003c<c<ooooc<c<00o<c<`00iVIVFIVI/30
`03o`<30ol30`570`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h5<30
`003c<c<ooooc<c<00o<c<`00iVIVFIVI/30`03o`<30ol30`570`<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h5<30`003c<c<ooooc<c<00G<c<`0
0fIVI/c<c<c<c007c<c<00>IVIUVIVK0`<00ol30`?o0`<1A`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^1C0`<000lc<c?ooolc<c004c<c<0fIV
IPS<c<`00iVIVFIVI/30`03o`<30ol30`570`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h5<30`003c<c<ooooc<c<00?<c<`5IVIV1lc<c003VIVI
IVIV`<300?o0`<3o`<30DL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PD`<3000?<c<coooo<c<`00/c<c0MVIVH6c<c<00>IVIUVIVK0`<00ol30
`?o0`<1A`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^1C0`<001<c<
c?ooolc<c<c<c0UVIVH5c<c<00>IVIUVIVK0`<00ol30`?o0`<1A`<300XS0
^058T8P10000000018S0^<SPf8S0^8S0^1C0`<000lc<c?ooolc<c00?c<c<
00>IVIUVIVK0`<00ol30`?o0`<1A`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^1C0`<000lc<c?ooolc<c00?c<c<00>IVIUVIVK0`<00ol30`?o0
`<1A`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^1C0`<000lc<c?oo
olc<c00?c<c<00>IVIUVIVK0`<00ol30`?o0`<1A`<300XS0^058T8P10000
000018S0^<SPf8S0^8S0^1C0`<000lc<c?ooolc<c00?c<c<00>IVIUVIVK0
`<00ol30`?o0`<1A`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^1C0
`<000lc<c?ooolc<c00?c<c<00>IVIUVIVK0`<00ol30`?o0`<1A`<300XS0
^058T8P10000000018S0^<SPf8S0^8S0^1C0`<000lc<c?ooooooo`0?oooo
00>IVIUVIVK0`<00ol30`?o0`<1A`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^1C0`<0Cc<c<00=VIVK0`<30`<00ol30`?o0`<1@`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^1AVIVHD`<3056IVI_o0`<3o`<30?/30
`0:8`;P1B9280@00000000F8`;S8h=R8`;R8`;S<c<`04YVIV@03IVIV`<30
`<3001;0`<000lc<c9VIVIVIV@0@VIVI00=VIVK0`<30`<00ol30`?o0`<0l
`<300XS0^058T8P1000000001XS0^<SPf8S0^8S0^<c<c?oooa3<c<`00iVI
VFIVI/30`00C`<3000?<c<coooo<c<`03lc<c003VIVIIVIV`<300?o0`<3o
`<30?L30`0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;S<c<coool@c<c<
00>IVIUVIVK0`<004l30`003c<c<ooooc<c<00o<c<`00iVIVFIVI/30`03o
`<30ol30`3g0`<02R<2h0DR@R04000000006R<2hb>3HR<2hR<2hc<c<oooo
4<c<c003VIVIIVIV`<3001?0`<000lc<c?ooolc<c00?c<c<00>IVIUVIVK0
`<00ol30`?o0`<0m`<300XS0^058T8P1000000001XS0^<SPf8S0^8S0^<c<
c?oooa3<c<`00iVIVFIVI/30`00C`<3000?<c<coooo<c<`03lc<c003VIVI
IVIV`<300?o0`<3o`<30?L30`0:8`;P1B9280@00000000J8`;S8h=R8`;R8
`;S<c<coool@c<c<00>IVIUVIVK0`<004l30`003c<c<ooooc<c<00o<c<`0
0iVIVFIVI/30`03o`<30ol30`3g0`<02R<2h0DR@R04000000006R<2hb>3H
R<2hR<2hc<c<oooo2Lc<c003IVIVc<c<c<c<00C<c<`00iVIVFIVI/30`00C
`<3000?<c<coooo<c<`01<c<c003IVIVc<c<c<c<00S<c<`00iVIVFIVI/30
`03o`<30ol30`3g0`<02R<2h0DR@R04000000006R<2hb>3HR<2hR<2hc<c<
oooo2<c<c09VIVH6c<c<00>IVIUVIVK0`<004l30`003c<c<ooooc<c<00C<
c<`2IVIV2Lc<c003VIVIIVIV`<300?o0`<3o`<30?L30`0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;S<c<coool7c<c<0fIVIPK<c<`00iVIVFIVI/30
`00C`<3000?<c<coooo<c<`01<c<c0=VIVH8c<c<00>IVIUVIVK0`<00ol30
`?o0`<0m`<300XS0^058T8P1000000001XS0^<SPf8S0^8S0^<c<c?ooo`K<
c<`4IVIV1/c<c003VIVIIVIV`<3001?0`<000lc<c?ooolc<c004c<c<16IV
IPO<c<`00iVIVFIVI/30`03o`<30ol30`3g0`<02R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hc<c<oooo1Lc<c0EVIVH6c<c<00>IVIUVIVK0`<004l30
`003c<c<ooooc<c<00C<c<`5IVIV1/c<c003VIVIIVIV`<300?o0`<3o`<30
?L30`0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;S<c<coool6c<c<16IV
IPK<c<`00iVIVFIVI/30`00C`<3000?<c<coooo<c<`01<c<c0AVIVH7c<c<
00>IVIUVIVK0`<00ol30`?o0`<0m`<300XS0^058T8P1000000001XS0^<SP
f8S0^8S0^<c<c?ooo`O<c<`3IVIV1/c<c003VIVIIVIV`<3001?0`<000lc<
c?ooolc<c004c<c<0fIVIPS<c<`00iVIVFIVI/30`03o`<30ol30`3g0`<02
R<2h0DR@R04000000006R<2hb>3HR<2hR<2hc<c<oooo2<c<c09VIVH6c<c<
00>IVIUVIVK0`<004l30`003c<c<ooooc<c<00C<c<`2IVIV2Lc<c003VIVI
IVIV`<300?o0`<3o`<30?L30`0:8`;P1B9280@00000000J8`;S8h=R8`;R8
`;S<c<coool9c<c<00=VIVK<c<c<c<`01<c<c003VIVIIVIV`<3001?0`<00
0lc<c?ooolc<c004c<c<00=VIVK<c<c<c<`02<c<c003VIVIIVIV`<300?o0
`<3o`<30?L30`0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;S<c<coool@
c<c<00>IVIUVIVK0`<004l30`003c<c<ooooc<c<00o<c<`00iVIVFIVI/30
`03o`<30ol30`3g0`<02R<2h0DR@R04000000006R<2hb>3HR<2hR<2hc<c<
oooo4<c<c003VIVIIVIV`<3001?0`<000lc<c?ooolc<c00?c<c<00>IVIUV
IVK0`<00ol30`?o0`<0m`<300XS0^058T8P1000000001HS0^<SPf8S0^8S0
^<c<c00Aoooo00>IVIUVIVK0`<004l30`003c<c<oooooooo00ooool00iVI
VFIVI/30`03o`<30ol30`3g0`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h4lc<c003IVIV`<30`<3001;0`<0Cc<c<00=VIVK0`<30`<00ol30`?o0
`<0l`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^1C0`<0DIVIVol30
`?o0`<1B`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^1C0`<000lc<
c9VIVIVIV@0@VIVI00=VIVK0`<30`<00ol30`?o0`<1@`<300XS0^058T8P1
0000000018S0^<SPf8S0^8S0^1C0`<000lc<c?ooolc<c00?c<c<00>IVIUV
IVK0`<00ol30`?o0`<1A`<300XS0^058T8P10000000018S0^<SPf8S0^8S0
^1C0`<000lc<c?ooolc<c00?c<c<00>IVIUVIVK0`<00ol30`?o0`<1A`<30
0XS0^058T8P10000000018S0^<SPf8S0^8S0^1C0`<000lc<c?ooolc<c00?
c<c<00>IVIUVIVK0`<00ol30`?o0`<1A`<300XS0^058T8P10000000018S0
^<SPf8S0^8S0^1C0`<000lc<c?ooolc<c00?c<c<00>IVIUVIVK0`<00ol30
`?o0`<1A`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^1C0`<000lc<
c?ooolc<c00?c<c<00>IVIUVIVK0`<00ol30`?o0`<1A`<300XS0^058T8P1
0000000018S0^<SPf8S0^8S0^1C0`<000lc<c?ooolc<c00?c<c<00>IVIUV
IVK0`<00ol30`?o0`<1A`<300XS0^058T8P10000000018S0^<SPf8S0^8S0
^1C0`<001<c<c?ooolc<c<c<c0UVIVH5c<c<00>IVIUVIVK0`<00ol30`?o0
`<1A`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^1C0`<000lc<c?oo
olc<c002c<c<1fIVIPK<c<`00iVIVFIVI/30`03o`<30ol30`570`<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h5<30`003c<c<ooooc<c<00?<c<`5
IVIV1lc<c003VIVIIVIV`<300?o0`<3o`<30DL30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;PD`<3000?<c<coooo<c<`01<c<c0=VIVH8c<c<00>I
VIUVIVK0`<00ol30`?o0`<1A`<300XS0^058T8P10000000018S0^<SPf8S0
^8S0^1C0`<000lc<c?ooolc<c005c<c<00=VIVK<c<c<c<`01lc<c003VIVI
IVIV`<300?o0`<3o`<30DL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PD`<3000?<c<coooo<c<`03lc<c003VIVIIVIV`<300?o0`<3o`<30DL30
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PD`<3000?<c<coooo<c<`0
3lc<c003VIVIIVIV`<300?o0`<3o`<30DL30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;PD`<3000?<c<coooo<c<`03lc<c003VIVIIVIV`<300?o0
`<3o`<30DL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PD`<3000?<
c<coooo<c<`03lc<c003VIVIIVIV`<300?o0`<3o`<30DL30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;PD`<3000?<c<coooo<c<`03lc<c003VIVI
IVIV`<300?o0`<3o`<30DL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PD`<3000?<c<coooooool03oooo`03VIVIIVIV`<300?o0`<3o`<30DL30
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PD`<304lc<c003IVIV`<30
`<300?o0`<3o`<30D<30`0:8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0
^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2h5P00P0<00H0200:0
00@00X400h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N2
0@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<2
3hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ8
0aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:
0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<5
9hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@
0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=980
0`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7
>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL0
10U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ
0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]C
W@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP
0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82
366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=
Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL2
3W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ
0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o
[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_
0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb
4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<C
Tk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL3
59bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i
0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/
_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o
0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1000P003VjOa
<d>U<d>U00Tc@jD600200`01P0800X001002P@03P@03P@03P@<0184200F1
00@01H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<1
2h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108C
Q`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT3
6HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS004
12B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>
1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A
0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`Lg
T`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F
00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH
2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:
D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh0
0`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ
0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eS
X`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP0
0`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@
O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh3
4H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::
/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?
/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf
0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P3
5Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<F
Z;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P03
5jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P3002000NKYo7ooon>N[JVVlBcZM:XWLRcZM800ZJK
a005_;SMk^kdj^Waoooo<d>U00D0080300600P02P00400:100>100>100>1
0`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49
P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:6
0P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P0
0`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<4
8X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h3
1BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`
T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLe
T`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF
0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P3
2DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:
CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP03
2eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<
GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R
008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU
10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X
3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@
NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhA
PJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/004
4XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?
/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je
0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN
^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<F
Y[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm
5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C08000008H
]<0@00000QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000BK
Yo7ooom/FZF_YLX2_;SM00[ooOncZM;ooooooonl^=fGR[bXWLSVi^cooolc
@jD400200`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X80
1X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@0
0`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<3
6hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=
12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5
:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9
AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YA
W@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]G
W`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW
3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mc
Z@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@
OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hA
Q:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H0
11BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ
_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P03
5k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HB928B92800a8T8P00`000<SP
f4R@R00=B92800@0000H]<0H]<38h=P>B92800<0000H]<0H]<000XS0^058
T8P10000000018S0^<SPf8S0^8S0^08008002i^WlOooojRMb?oook>YdV1<
VXij]WQU[ZRMb?ooooomo`03oooo00<c@jD0080008000`00P0<00H0200:0
00@00X400h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N2
0@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<2
3hD20Q250oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:
0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DV
S@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@
0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i82
1SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7
>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL2
24>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ
0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]B
W@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO
0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R
362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=
IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL3
3VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o
[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_
1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=
/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B
]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g
59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i
0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdF
ZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl0
0aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00f8`;P0
1DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0P00P00>VjOaoooooooofmc/H4bJThFj/jWB
_;SMH4bJVHnnYY_4b<?Ooooo<d>U1P00P0?oool200:000<00X7oooooool0
0_ooo`8018400`05POooo`05PP0300J21?ooo`030@R20@R3oooo00?oool3
0@Z300Koool12h@12h@138Coool138@20@f400Coool13XGoool13XD20Pn5
00Coool248Goool248D20Q6600?oool24HH24XH00P8BQP824hH0108CQ`8D
Q`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT0
10<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<
12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?
1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHb
T@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`03
1cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8
@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI
2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`0
10YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]G
WP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aN
X@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=
I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]
YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mc
Z0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`4
47f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^
00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::
/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<C
T;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI
]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh
00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/3
5ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn
0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`004b>3HR<2hR<2hR<2h1P00
00B8`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SP
f00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0`00P00>VjOaoooo_;SMVHnnooooe]7Mfmc/lokoYY_4k^kdQGJ`ThFj
oooo<d>U1000P007oooo006000600060oooo00:0oooo00<00h401_ooo`04
P@04P@05POooo`05PP801X802?ooo`07PP07PP47P_ooo`48P_ooo`48P`<1
2H<01?ooo`4:P`4:Poooo`812h@00`4<Q?ooo`4<Q0020@f400Coool13XGo
ool13XD20Pn500?oool248Goool00oooo`824HH30Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@04
0aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`4
98d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5
:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A
00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7
>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9
AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN
2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ
0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X
3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@
OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh0
0a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@
/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf
0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<F
ZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000C8h=R8`;R8`;R8`;P60000
18S0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8
`;Q8T8P000000QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0^004
B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<00800
3i^WlOoooiV?_YN:_=CCj>n//omfNnjOZe]HYJJKa9JOdV1<V[bhgOoooc=3
Y@03002000Ooool00H000H000H3oool00X3oool00`03P@06oooo00B100B1
oooo00F1oooo0P06PP08oooo00N200N20@N2oooo0@R2oooo0@R30`49P`09
oooo0@Z3oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?ooo`4>QOooo`4>
Q@823hD01?ooo`8@QOooo`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<K
R@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d4
9Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[
S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO
00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y
00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n
[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64
[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P04
59Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl
00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G
/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000
b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd
`003b>3HR<2hR<2h00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00:VjOaooooUhZl
NVbZ/lOXZFjPb<?OThFjFdJCVHnn0WQU[P04@RN5[jG:oooo<d>U1000P0<0
0H000oooo`02P002P@04oooo0P04P@03oooo00F1oooo00<01X84oooo00<1
288128<128<00`49P`09oooo0@Z3oooo0@^3oooo0@^4oooo0@b4oooo0081
3H@01?ooo`4>QOooo`4>Q@823hD00oooo`8@QOooo`03oooo0P8AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR003
0aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A
1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC
0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH3
23nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9
AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>
V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aM
X@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ80
0PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD4
3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?
LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1j
Z`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61
[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@B
RK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb
4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D3
59Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh
5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0
^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@00
08S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00hS0^0@00004R<2h00A8
T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003
VjOaoooooooo00;oool02_n]/?mfNoW=e?g]k_ooojJKa8Ef/;bhgOoooc=3
Y@D00803006000?oool00X000X400`03P@03oooo00B1oooo00801H401005
P_ooo`06PP06PP801h800`47P_ooo`48PP020@R30oooo`812X<01oooo`4;
Poooo`4;Q?ooo`4<Q?ooo`020@f400Coool13XGoooooool20Pn500Koool2
48Goool248D24HKoool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL2
0QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:
0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDU
S@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?
0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B
1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7
>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL3
24:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI
0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YB
W@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO
10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaP
XPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eU
Y0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW
3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY
0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@
OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l0
0a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@B
S;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<C
T[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK
]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T0
11FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l
5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o
5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002
R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSP
f8S0^8S0^004R<2h0P0000F8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P3002000ZQ[?;icMCR9Scd]KoR9ScdKGglhnWo
ooomkNko[K02oooo00<c@jD0080008001000P0<00H000oooo`02P002P@03
oooo0P04P@05oooo00F100F100F2oooo00801X83oooo0P48PP030@R3oooo
0@V300812H<20@Z300Coool12h<12hCoool20@b400Ooool13H@13HCoool1
3XGoool13XD00_ooo`030Pn50Q250Q2500Coool0108AQP8BQP8BQP8BQP82
4hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<3
6HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<
10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DY
SP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946
<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<3
1cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8
?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5
V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK
0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]E
WP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ
35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP02
3F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>
JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0ma
Z0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[
0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^
00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9
/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8C
Sk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<D
UkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PE
W[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk
0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^
_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2h
R<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000
R<2hR<2hB9280000008H]<000lSPf8S0^8S0^003R<2h100000B8`;P014R@
R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000fK
Yo7mkNkR9ScnmOSgRIOdHVkcX:kdHVkooOoo[K3lhnWooolc@jD01`00P0<0
0H000oooo`02P002P@0300>10`04P@801H401005PP06PP06PP06PP801h80
1@47PP48PP48P_ooo`48P`030@V30`4:P`030@^30@^40@^400<138@30@f4
0`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8F
Q`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<3
7HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd3
1BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6
;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHc
TP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9
BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd2
2e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;
FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<
H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]
47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<A
QJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d
4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLD
VkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[
_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0
^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8
`;R8`;P00XS0^0800002R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7fb<cR9S`00_n]/007
gb@^ojBNm[c5ojf`kW^<oooo<d>U00P00803006000?oool00X000X400`03
P@<0184200F100@01H801X801X801X8200N200D11h81288128;oool128<0
0`49P`04oooo0@Z30@Z30@^30P4;Q0<138@30@f40`4>Q@<23hD30Q25108A
QP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN8
0`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3
126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh0
0`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA
1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLe
TP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`Pm
U@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4
V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/3
2TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN
2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:00
10aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=
HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iY
Y@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?
LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X3
47V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61
[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;02
4XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P03
4hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E
]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`04
5Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X3
5ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm
00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<00
0lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0
000H]<0H]<38h=P00hS0^0800004R<2h0P0000:8`;P014R@R00001Rd`1Rd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7icMCgRIL0
0_ooo`07ojf`hAHdogIkojBNhRHlohUo<d>U00P00803006000?oool00X00
0X400`03P@<0184200F100@01H801X801X801X8200N200@11h8128812881
28<4oooo0`4:P`030@^30@^40@^400<138@20@f400Coool13XD13XD13XD3
0Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<F
R0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@N
RP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@03
1BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^
T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB
00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@3
1c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G
00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:
VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;
Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJ
X0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R
0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@3
3FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW
0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mf
ZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8A
Ojd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166
[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=
/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]003
4i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g
0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR
^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF
[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb
_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P90000
0XS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2002000NKYo7oooocX:kdHVkoooog
RIOicM@00_ooo`03lj2^oooo<d>U00P0080300600P02P00400:100>100>1
00>10`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R3
0`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH3
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8
h=R8`;R8`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SP
f00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0`00P00;VjOaooooohUooooolj2^lI>Qoooooogolj2^oo_l<d>U00P0
080300600P02P00400:100>100>100>10`04P@801H401005PP06PP06PP06
PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b4
0`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8E
Q`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<3
78X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd2
1BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5
;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86
<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@0
0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1
U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9
B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M
2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;
F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR
362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT
3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>
KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?
M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n
[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64
[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;40
11:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B
/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg
59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP
^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@F
Zk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG
/KlG/Kl00aNb_`<G/kl26;C03lSPf0030000b>3Hb>3H00g8h=P00`0001Rd
`1Rd`00?b>3H00<0000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0
^8S0^0@00803VjOa00KoooocX:kd]Kof_<GkfMXc@jD900200`01P0800X00
1002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h81
288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?
Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP3
5hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX3
11n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DW
S@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y02
1Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP03
1cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`Lk
U@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`04
2D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX3
2T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M
00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ03
35^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<
HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eW
Y0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>
L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX3
3gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]
0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl3
4XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8B
SK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C
]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<D
W;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T3
5J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm
0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l3
5k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PF00200`01P080
0X001002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<1
1h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j5
0`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<4
7XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd0
0`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6
;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHd
TP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD
0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3
U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9
BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd3
2e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<
FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaP
XP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT
0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_
Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?
MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd2
4Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@A
QZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8B
SK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@0
0a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK
]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<E
X[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m
5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o=QRd`0:8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;Qm
R<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058T8P10000
00000hS0^<SPf<SPf03ob>3HolSPf7g8h=P1B9280@000000ohS0^?n8`;R1
R<2h0@000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:50001ib000`400?l0
0000o`00003oooooooooooooohOooooo003oooooooooooooQoooool00?oo
oooooooooon7ooooo`00ooooooooooooohOooooo003oooooooooooooQooo
ool00?oooooooooooon7ooooo`000_oooooooo3`l?ool?3`Loo`l?000ooI
fMWoooooooooo`0?ooooo`000_oooooooo3`l?ool?3`Loo`l?001?oIfMWo
oooooooooooUiND3ooooo`05onGUiOoooooooooooooooooUiND01_ooool0
00;oooooooo`l?3ooo3`l7?ol?3`00gofMWIoooooooJf][oSHf=onGUiOoo
oooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00Gooooo0002oooooooo
l?3`ooo`l?1coo3`l00>omWIfOooooooooooom[Jf_n=SHgoiNGUoooooooJ
f][oSHf=onGUiOoooooof][Johf=SOoUiND4ooooo`000_oooooooo3`l?oo
l?3`Loo`l?003OoIfMWooooooooooooooooof][Johf=SOoUiNGoooooom[J
f_n=SHgoiNGUoooooooJf]X01Oooool000;oooooooo`l?3ooo3`l7?ol?3`
00?ofMWIooooooooool00_ooool01ooJf][oSHf=onGUiOoooooof][Johf=
SOoUiND01_ooool000;oooooooo`l?3ooo3`l7?ol?3`00?ofMWIoooooooo
ool00oooool01ooJf][oSHf=onGUiOoooooof][Johf=SOoUiND01Oooool0
00;oooooooo`l?3ooo3`l7?ol?3`00?ofMWIooooooooool01?ooool01ooJ
f][oSHf=onGUiOoooooog=cLohf=SOoUiND01?ooool000;oooooooo`l?3o
oo3`l7?ol?3`00?ofMWIooooooooool01Oooool01OoJf][oSHf=onGUiOoo
oooog=cL00Gooooo0002ooooooool?3`ooo`l?1coo3`l003omWIfOoooooo
oooo00Kooooo00?og=cLohf=SOoUiND01_ooool000;oooooooo`l?3ooo3`
l7?ol?3`00?ofMWIooooooooool01oooool00ooLg=coSHf=onGUi@05oooo
o`000_oooooooo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`08ooooo`03
omcLg?n=SHgoiNGU00Cooooo0002ooooooool?3`ooo`l?1coo3`l003omWI
fOoooooooooo00Wooooo00?og=cLooooooooool00oooool000;oooooooo`
l?3ooo3`l7?ol?3`00?ofMWIooooooooool03oooool000;oooooooo`l?3o
oo3`l7?ol?3`3ooIfMT3ooooo`00ooooooooooooohOooooo0002oooooooo
k^k^ooo^k^j2onk^kP?ooooo0002ooooooooi^KVoooVi^J2onKViP?ooooo
0002ooooooook^k^ooo^k^j2onk^kP?ooooo003oooooooooooooQoooool0
00;oooooooo^k^koonk^kX;ok^k^0oooool000;ooooooooVi^KoonKViX;o
i^KV0oooool000;oooooooo^k^koonk^kX;ok^k^0oooool00?oooooooooo
oon7ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`000_ooooooonKV
i_ooi^KVP_oVi^H3ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00
ooooooooooooohOooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo0002
ooooooooi^KVoooVi^J2onKViP?ooooo0002ooooooook^k^ooo^k^j2onk^
kP?ooooo003oooooooooooooQoooool000;oooooooo^k^koonk^kX;ok^k^
0oooool000;ooooooooVi^KoonKViX;oi^KV0oooool000;oooooooo^k^ko
onk^kX;ok^k^0oooool00?oooooooooooon7ooooo`000_ooooooonk^k_oo
k^k^P_o^k^h3ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3ooooo`000_oo
ooooonk^k_ook^k^P_o^k^h3ooooo`00ooooooooooooohOooooo0002oooo
ooook^k^ooo^k^j2onk^kP?ooooo0002ooooooooi^KVoooVi^J2onKViP?o
oooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo003oooooooooooooQooo
ool000;oooooooo^k^koonk^kX;ok^k^0oooool000;ooooooooVi^KoonKV
iX;oi^KV0oooool000;oooooooo^k^koonk^kX;ok^k^0oooool00?oooooo
oooooon7ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`000_oooooo
onKVi_ooi^KVP_oVi^H3ooooo`000_ooooooonk^k_ook^k^P_o^k^h3oooo
o`00ooooooooooooohOooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo
0002ooooooooi^KVoooVi^J2onKViP?ooooo0002ooooooook^k^ooo^k^j2
onk^kP?ooooo003oooooooooooooQoooool000;oooooooo^k^koonk^kX;o
k^k^0oooool000;ooooooooVi^KoonKViX;oi^KV0oooool000;oooooooo^
k^koonk^kX;ok^k^0oooool00?oooooooooooon7ooooo`000_ooooooonk^
k_ook^k^P_o^k^h3ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3ooooo`00
0_ooooooonk^k_ook^k^P_o^k^h3ooooo`00ooooooooooooohOooooo0002
ooooooook^k^ooo^k^j2onk^kP?ooooo0002ooooooooi^KVoooVi^J2onKV
iP?ooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo003ooooooooooooo
Qoooool000;oooooooo^k^koonk^kX;ok^k^0oooool000;ooooooooVi^Ko
onKViX;oi^KV0oooool000;oooooooo^k^koonk^kX;ok^k^0oooool00?oo
oooooooooon7ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`000_oo
ooooonKVi_ooi^KVP_oVi^H3ooooo`000_ooooooonk^k_ook^k^P_o^k^h3
ooooo`00ooooooooooooohOooooo0002ooooooook^k^ooo^k^j2onk^kP?o
oooo0002ooooooooi^KVoooVi^J2onKViP?ooooo0002ooooooook^k^ooo^
k^j2onk^kP?ooooo003oooooooooooooQoooool000;oooooooo^k^koonk^
kX;ok^k^0oooool000;ooooooooVi^KoonKViX;oi^KV0oooool000;ooooo
ooo^k^koonk^kX;ok^k^0oooool00?oooooooooooon7ooooo`000_oooooo
onk^k_ook^k^P_o^k^h3ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3oooo
o`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00ooooooooooooohOooooo
0002ooooooook^k^ooo^k^j2onk^kP?ooooo0002ooooooooi^KVoooVi^J2
onKViP?ooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo003ooooooooo
ooooQoooool000;oooooooo^k^koonk^kX;ok^k^0oooool000;ooooooooV
i^KoonKViX;oi^KV0oooool000;oooooooo^k^koonk^kX;ok^k^0oooool0
0?oooooooooooon7ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00
0_ooooooonKVi_ooi^KVP_oVi^H3ooooo`000_ooooooonk^k_ook^k^P_o^
k^h3ooooo`00ooooooooooooohOooooo0002ooooooook^k^ooo^k^j2onk^
kP?ooooo0002ooooooooi^KVoooVi^J2onKViP?ooooo0002ooooooook^k^
ooo^k^j2onk^kP?ooooo003oooooooooooooQoooool000;oooooooo^k^ko
onk^kX;ok^k^0oooool000;ooooooooVi^KoonKViX;oi^KV0oooool000;o
ooooooo^k^koonk^kX;ok^k^0oooool00?oooooooooooon7ooooo`000_oo
ooooonk^k_ook^k^P_o^k^h3ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3
ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00ooooooooooooohOo
oooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo0002ooooooooi^KVoooV
i^J2onKViP?ooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo003ooooo
ooooooooQoooool000;oooooooo^k^koonk^kX;ok^k^0oooool000;ooooo
oooVi^KoonKViX;oi^KV0oooool000;oooooooo^k^koonk^kX;ok^k^0ooo
ool00?oooooooooooon7ooooo`000_ooooooonk^k_ook^k^P_o^k^h3oooo
o`000_ooooooonKVi_ooi^KVP_oVi^H3ooooo`000_ooooooonk^k_ook^k^
P_o^k^h3ooooo`00ooooooooooooohOooooo0002ooooooook^k^ooo^k^j2
onk^kP?ooooo0002ooooooooi^KVoooVi^J2onKViP?ooooo0002oooooooo
k^k^ooo^k^j2onk^kP?ooooo003oooooooooooooQoooool000;oooooooo^
k^koonk^kX;ok^k^0oooool000;ooooooooVi^KoonKViX;oi^KV0oooool0
00;oooooooo^k^koonk^kX;ok^k^0oooool00?oooooooooooon7ooooo`00
0_ooooooonk^k_ook^k^P_o^k^h3ooooo`000_ooooooonKVi_ooi^KVP_oV
i^H3ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00oooooooooooo
ohOooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo0002ooooooooi^KV
oooVi^J2onKViP?ooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo003o
ooooooooooooQoooool000;oooooooo^k^koonk^kX;ok^k^0oooool000;o
oooooooVi^KoonKViX;oi^KV0oooool000;oooooooo^k^koonk^kX;ok^k^
0oooool00?oooooooooooon7ooooo`000_ooooooonk^k_ook^k^P_o^k^h3
ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3ooooo`000_ooooooonk^k_oo
k^k^P_o^k^h3ooooo`00ooooooooooooohOooooo0002ooooooook^k^ooo^
k^j2onk^kP?ooooo0002ooooooooi^KVoooVi^J2onKViP?ooooo0002oooo
ooook^k^ooo^k^j2onk^kP?ooooo003oooooooooooooQoooool000;ooooo
ooo^k^koonk^kX;ok^k^0oooool000;ooooooooVi^KoonKViX;oi^KV0ooo
ool000;oooooooo^k^koonk^kX;ok^k^0oooool00?oooooooooooon7oooo
o`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`000_ooooooonKVi_ooi^KV
P_oVi^H3ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00oooooooo
ooooohOooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo0002oooooooo
i^KVoooVi^J2onKViP?ooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo
003oooooooooooooQoooool000;oooooooo^k^koonk^kX;ok^k^0oooool0
00;ooooooooVi^KoonKViX;oi^KV0oooool000;oooooooo^k^koonk^kX;o
k^k^0oooool00?oooooooooooon7ooooo`000_ooooooonk^k_ook^k^P_o^
k^h3ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3ooooo`000_ooooooonk^
k_ook^k^P_o^k^h3ooooo`00ooooooooooooohOooooo0002ooooooook^k^
ooo^k^j2onk^kP?ooooo0002ooooooooi^KVoooVi^J2onKViP?ooooo0002
ooooooook^k^ooo^k^j2onk^kP?ooooo003oooooooooooooQoooool000;o
ooooooo^k^koonk^kX;ok^k^0oooool000;ooooooooVi^KoonKViX;oi^KV
0oooool000;oooooooo^k^koonk^kX;ok^k^0oooool00?oooooooooooon7
ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`000_ooooooonKVi_oo
i^KVP_oVi^H3ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00oooo
ooooooooohOooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo0002oooo
ooooi^KVoooVi^J2onKViP?ooooo0002ooooooook^k^ooo^k^j2onk^kP?o
oooo003oooooooooooooQoooool000;oooooooo^k^koonk^kX;ok^k^0ooo
ool000;ooooooooVi^KoonKViX;oi^KV0oooool000;oooooooo^k^koonk^
kX;ok^k^0oooool00?oooooooooooon7ooooo`000_ooooooonk^k_ook^k^
P_o^k^h3ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3ooooo`000_oooooo
onk^k_ook^k^P_o^k^h3ooooo`00ooooooooooooohOooooo0002oooooooo
k^k^ooo^k^j2onk^kP?ooooo0002ooooooooi^KVoooVi^J2onKViP?ooooo
0002ooooooook^k^ooo^k^j2onk^kP?ooooo003oooooooooooooQoooool0
00;oooooooo^k^koonk^kX;ok^k^0oooool000;ooooooooVi^KoonKViX;o
i^KV0oooool000;oooooooo^k^koonk^kX;ok^k^0oooool00?oooooooooo
oon7ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`000_ooooooonKV
i_ooi^KVP_oVi^H3ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00
ooooooooooooohOooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo0002
ooooooooi^KVoooVi^J2onKViP?ooooo0002ooooooook^k^ooo^k^j2onk^
kP?ooooo003oooooooooooooQoooool000;oooooooo^k^koonk^kX;ok^k^
0oooool000;ooooooooVi^KoonKViX;oi^KV0oooool000;oooooooo^k^ko
onk^kX;ok^k^0oooool00?oooooooooooon7ooooo`000_ooooooonk^k_oo
k^k^P_o^k^h3ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3ooooo`000_oo
ooooonk^k_ook^k^P_o^k^h3ooooo`00ooooooooooooohOooooo0002oooo
ooook^k^ooo^k^j2onk^kP?ooooo0002ooooooooi^KVoooVi^J2onKViP?o
oooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo003oooooooooooooQooo
ool000;oooooooo^k^koonk^kX;ok^k^0oooool000;ooooooooVi^KoonKV
iX;oi^KV0oooool000;oooooooo^k^koonk^kX;ok^k^0oooool00?oooooo
oooooon7ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`000_oooooo
onKVi_ooi^KVP_oVi^H3ooooo`000_ooooooonk^k_ook^k^P_o^k^h3oooo
o`00ooooooooooooohOooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo
0002ooooooooi^KVoooVi^J2onKViP?ooooo0002ooooooook^k^ooo^k^j2
onk^kP?ooooo003oooooooooooooQoooool000;oooooooo^k^koonk^kX;o
k^k^0oooool000;ooooooooVi^KoonKViX;oi^KV0oooool000;oooooooo^
k^koonk^kX;ok^k^0oooool00?oooooooooooon7ooooo`000_ooooooonk^
k_ook^k^P_o^k^h3ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3ooooo`00
0_ooooooonk^k_ook^k^P_o^k^h3ooooo`00ooooooooooooohOooooo0002
ooooooook^k^ooo^k^j2onk^kP?ooooo0002ooooooooi^KVoooVi^J2onKV
iP?ooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo003ooooooooooooo
Qoooool000;oooooooo^k^koonk^kX;ok^k^0oooool000;ooooooooVi^Ko
onKViX;oi^KV0oooool000;oooooooo^k^koonk^kX;ok^k^0oooool00?oo
oooooooooon7ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`000_oo
ooooonKVi_ooi^KVP_oVi^H3ooooo`000_ooooooonk^k_ook^k^P_o^k^h3
ooooo`00ooooooooooooohOooooo0002ooooooook^k^ooo^k^j2onk^kP?o
oooo0002ooooooooi^KVoooVi^J2onKViP?ooooo0002ooooooook^k^ooo^
k^j2onk^kP?ooooo003oooooooooooooQoooool000;oooooooo^k^koonk^
kX;ok^k^0oooool000;ooooooooVi^KoonKViX;oi^KV0oooool000;ooooo
ooo^k^koonk^kX;ok^k^0oooool00?oooooooooooon7ooooo`000_oooooo
onk^k_ook^k^P_o^k^h3ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3oooo
o`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00ooooooooooooohOooooo
0002ooooooook^k^ooo^k^j2onk^kP?ooooo0002ooooooooi^KVoooVi^J2
onKViP?ooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo003ooooooooo
ooooQoooool000;oooooooo^k^koonk^kX;ok^k^0oooool000;ooooooooV
i^KoonKViX;oi^KV0oooool000;oooooooo^k^koonk^kX;ok^k^0oooool0
0?oooooooooooon7ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00
0_ooooooonKVi_ooi^KVP_oVi^H3ooooo`000_ooooooonk^k_ook^k^P_o^
k^h3ooooo`00ooooooooooooohOooooo0002ooooooook^k^ooo^k^j2onk^
kP?ooooo0002ooooooooi^KVoooVi^J2onKViP?ooooo0002ooooooook^k^
ooo^k^j2onk^kP?ooooo003oooooooooooooQoooool000;oooooooo^k^ko
onk^kX;ok^k^0oooool000;ooooooooVi^KoonKViX;oi^KV0oooool000;o
ooooooo^k^koonk^kX;ok^k^0oooool00?oooooooooooon7ooooo`000_oo
ooooonk^k_ook^k^P_o^k^h3ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3
ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00ooooooooooooohOo
oooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo0002ooooooooi^KVoooV
i^J2onKViP?ooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo003ooooo
ooooooooQoooool000;oooooooo^k^koonk^kX;ok^k^0oooool000;ooooo
oooVi^KoonKViX;oi^KV0oooool000;oooooooo^k^koonk^kX;ok^k^0ooo
ool00?oooooooooooon7ooooo`000_ooooooonk^k_ook^k^P_o^k^h3oooo
o`000_ooooooonKVi_ooi^KVP_oVi^H3ooooo`000_ooooooonk^k_ook^k^
P_o^k^h3ooooo`00ooooooooooooohOooooo0002ooooooook^k^ooo^k^j2
onk^kP?ooooo0002ooooooooi^KVoooVi^J2onKViP?ooooo0002oooooooo
k^k^ooo^k^j2onk^kP?ooooo003oooooooooooooQoooool000;oooooooo^
k^koonk^kX;ok^k^0oooool000;ooooooooVi^KoonKViX;oi^KV0oooool0
00;oooooooo^k^koonk^kX;ok^k^0oooool00?oooooooooooon7ooooo`00
0_ooooooonk^k_ook^k^P_o^k^h3ooooo`000_ooooooonKVi_ooi^KVP_oV
i^H3ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00oooooooooooo
ohOooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo0002ooooooooi^KV
oooVi^J2onKViP?ooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo003o
ooooooooooooQoooool000;oooooooo^k^koonk^kX;ok^k^0oooool000;o
oooooooVi^KoonKViX;oi^KV0oooool000;oooooooo^k^koonk^kX;ok^k^
0oooool00?oooooooooooon7ooooo`000_ooooooonk^k_ook^k^P_o^k^h3
ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3ooooo`000_ooooooonk^k_oo
k^k^P_o^k^h3ooooo`00ooooooooooooohOooooo0002ooooooook^k^ooo^
k^j2onk^kP?ooooo0002ooooooooi^KVoooVi^J2onKViP?ooooo0002oooo
ooook^k^ooo^k^j2onk^kP?ooooo003oooooooooooooQoooool000;ooooo
ooo^k^koonk^kX;ok^k^0oooool000;ooooooooVi^KoonKViX;oi^KV0ooo
ool000;oooooooo^k^koonk^kX;ok^k^0oooool00?oooooooooooon7oooo
o`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`000_ooooooonKVi_ooi^KV
P_oVi^H3ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00oooooooo
ooooohOooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo0002oooooooo
i^KVoooVi^J2onKViP?ooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo
003oooooooooooooQoooool000;oooooooo^k^koonk^kX;ok^k^0oooool0
00;ooooooooVi^KoonKViX;oi^KV0oooool000;oooooooo^k^koonk^kX;o
k^k^0oooool00?oooooooooooon7ooooo`000_ooooooonk^k_ook^k^P_o^
k^h3ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3ooooo`000_ooooooonk^
k_ook^k^P_o^k^h3ooooo`00ooooooooooooohOooooo0002ooooooook^k^
ooo^k^j2onk^kP?ooooo0002ooooooooi^KVoooVi^J2onKViP?ooooo0002
ooooooook^k^ooo^k^j2onk^kP?ooooo003oooooooooooooQoooool000;o
ooooooo^k^koonk^kX;ok^k^0oooool000;ooooooooVi^KoonKViX;oi^KV
0oooool000;oooooooo^k^koonk^kX;ok^k^0oooool00?oooooooooooon7
ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`000_ooooooonKVi_oo
i^KVP_oVi^H3ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00oooo
ooooooooohOooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo0002oooo
ooooi^KVoooVi^J2onKViP?ooooo0002ooooooook^k^ooo^k^j2onk^kP?o
oooo003oooooooooooooQoooool000;oooooooo^k^koonk^kX;ok^k^0ooo
ool000;ooooooooVi^KoonKViX;oi^KV0oooool000;oooooooo^k^koonk^
kX;ok^k^0oooool00?oooooooooooon7ooooo`000_ooooooonk^k_ook^k^
P_o^k^h3ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3ooooo`000_oooooo
onk^k_ook^k^P_o^k^h3ooooo`00ooooooooooooohOooooo0002oooooooo
k^k^ooo^k^j2onk^kP?ooooo0002ooooooooi^KVoooVi^J2onKViP?ooooo
0002ooooooook^k^ooo^k^j2onk^kP?ooooo003oooooooooooooQoooool0
00;oooooooo^k^koonk^kX;ok^k^0oooool000;ooooooooVi^KoonKViX;o
i^KV0oooool000;oooooooo^k^koonk^kX;ok^k^0oooool00?oooooooooo
oon7ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`000_ooooooonKV
i_ooi^KVP_oVi^H3ooooo`000_ooooooonk^k_ook^k^P_o^k^h3ooooo`00
ooooooooooooohOooooo0002ooooooook^k^ooo^k^j2onk^kP?ooooo0002
ooooooooi^KVoooVi^J2onKViP?ooooo0002ooooooook^k^ooo^k^j2onk^
kP?ooooo003oooooooooooooQoooool000;oooooooo^k^koonk^kX;ok^k^
0oooool000;ooooooooVi^KoonKViX;oi^KV0oooool000;oooooooo^k^ko
onk^kX;ok^k^0oooool00?oooooooooooon7ooooo`000_ooooooonk^k_oo
k^k^P_o^k^h3ooooo`000_ooooooonKVi_ooi^KVP_oVi^H3ooooo`000_oo
oolDonk^kQCoRXZ:ooo^k^koonk^kU[ok^k^0oooool001Kooooo00?ol?3`
omcLg?oLg=`04?oLg=`00on:RX[oooooooooo`3oooooooooooooFoooool0
00;ooooo5?o^k^h00oo`l?3ohN7Qoo3`l00?oo3`l003omcLg?n:RX[ok^k^
0?ook^k^ooo^k^iIonk^kP?ooooo0002oooooaCoi^KV00?ol?3`on7QhOo`
l?003oo`l?000ooLg=coRXZ:onKViP3oonKVi_ooi^KVFOoVi^H3ooooo`00
0_oooolDonk^kP03oo3`l?oQhN7ol?3`00ool?3`00?og=cLohZ:R_o^k^h0
ooo^k^koonk^kUWok^k^0oooool001Kooooo00?ol?3`on7QhOo`l?003oo`
l?000ooLg=coRXZ:ooooo`3oooooooooooooG?ooool000;ooooo5?o^k^h0
0oo`l?3ohN7Qoo3`l00?oo3`l003omcLg?n:RX[ok^k^0?ook^k^ooo^k^iI
onk^kP?ooooo0002oooooaCoi^KV00?ol?3`on7QhOo`l?003oo`l?000ooL
g=coRXZ:onKViP3oonKVi_ooi^KVFOoVi^H3ooooo`000_oooolDonk^kP03
oo3`l?oQhN7ol?3`00Kol?3`00?oRXZ:oo3`l?o`l?001_o`l?000ooLg=co
RXZ:onk^kP3oonk^k_ook^k^FOo^k^h3ooooo`005_ooool00oo`l?3ohN7Q
oo3`l005oo3`l0?oRXZ:1oo`l?000ooLg=coRXZ:ooooo`3ooooooooooooo
G?ooool000;ooooo5?o^k^h00oo`l?3ohN7Qoo3`l004oo3`l0GoRXZ:1_o`
l?000ooLg=coRXZ:onk^kP3oonk^k_ook^k^FOo^k^h3ooooo`000_oooolD
onKViP03oo3`l?oQhN7ol?3`00?ol?3`1on:RXX5oo3`l003omcLg?n:RX[o
i^KV0?ooi^KVoooVi^IIonKViP?ooooo0002oooooaCok^k^00?ol?3`on7Q
hOo`l?000_o`l?09ohZ:RPCol?3`00?og=cLohZ:R_o^k^h0ooo^k^koonk^
kUWok^k^0oooool001Kooooo00?ol?3`on7QhOo`l?003oo`l?000ooLg=co
RXZ:ooooo`3oooooooooooooG?ooool000;ooooo5?o^k^h00oo`l?3ohN7Q
oo3`l00?oo3`l003omcLg?n:RX[ok^k^0?ook^k^ooo^k^iIonk^kP?ooooo
0002oooooaCoi^KV00?ol?3`on7QhOo`l?003oo`l?000ooLg=coRXZ:onKV
iP3oonKVi_ooi^KVFOoVi^H3ooooo`000_oooolDonk^kP03oo3`l?oQhN7o
l?3`00ool?3`00?og=cLohZ:R_o^k^h0ooo^k^koonk^kUWok^k^0oooool0
01Kooooo00?ol?3`on7QhOo`l?003oo`l?000ooLg=coRXZ:ooooo`3ooooo
ooooooooG?ooool000;ooooo5?o^k^h00oo`l?3ohN7Qon7Qh@0?on7Qh@03
omcLg?n:RX[ok^k^0?ook^k^ooo^k^iIonk^kP?ooooo0002oooooaCoi^KV
4oo`l?000on:RX[oi^KVonKViP3oonKVi_ooi^KVF?oVi^H3ooooo`000_oo
oolDohZ:RQCok^k^5?n:RX[oonk^k_ook^k^A_o^k^h3ooooo`000_ooool0
0oo`l?3og=cLomcLg00@omcLg003ohZ:R_oooooooooo01;ooooo00?ol?3`
omcLg?oLg=`04?oLg=`00on:RX[oooooooooo`3oooooooooooooAoooool0
00;ooooo00?ol?3`on7QhOo`l?003oo`l?000ooLg=coRXZ:onk^kP0Conk^
kP03oo3`l?oQhN7ol?3`00ool?3`00?og=cLohZ:R_o^k^h0ooo^k^koonk^
kTGok^k^0oooool000;ooooo00?ol?3`on7QhOo`l?003oo`l?000ooLg=co
RXZ:onKViP0ConKViP03oo3`l?oQhN7ol?3`00ool?3`00?og=cLohZ:R_oV
i^H0oooVi^KoonKViTGoi^KV0oooool000;ooooo00?ol?3`on7QhOo`l?00
3oo`l?000ooLg=coRXZ:onk^kP0Conk^kP03oo3`l?oQhN7ol?3`00ool?3`
00?og=cLohZ:R_o^k^h0ooo^k^koonk^kTGok^k^0oooool000;ooooo00?o
l?3`on7QhOo`l?003oo`l?000ooLg=coRXZ:ooooo`0Cooooo`03oo3`l?oQ
hN7ol?3`00ool?3`00?og=cLohZ:R_ooool0ooooooooooooodSooooo0002
ooooo`03oo3`l?oQhN7ol?3`00Sol?3`00?oRXZ:oo3`l?o`l?001?o`l?00
0ooLg=coRXZ:onk^kP0Conk^kP03oo3`l?oQhN7ol?3`00Col?3`00?oRXZ:
oo3`l?o`l?002?o`l?000ooLg=coRXZ:onk^kP3oonk^k_ook^k^AOo^k^h3
ooooo`000_ooool00oo`l?3ohN7Qoo3`l007oo3`l0;oRXZ:1_o`l?000ooL
g=coRXZ:onKViP0ConKViP03oo3`l?oQhN7ol?3`00Col?3`0_n:RXX9oo3`
l003omcLg?n:RX[oi^KV0?ooi^KVoooVi^I5onKViP?ooooo0002ooooo`03
oo3`l?oQhN7ol?3`00Kol?3`0on:RXX6oo3`l003omcLg?n:RX[ok^k^01?o
k^k^00?ol?3`on7QhOo`l?001?o`l?03ohZ:RPSol?3`00?og=cLohZ:R_o^
k^h0ooo^k^koonk^kTGok^k^0oooool000;ooooo00?ol?3`on7QhOo`l?00
1Oo`l?04ohZ:RPKol?3`00?og=cLohZ:R_ooool04oooool00oo`l?3ohN7Q
oo3`l004oo3`l0CoRXZ:1oo`l?000ooLg=coRXZ:ooooo`3ooooooooooooo
B?ooool000;ooooo00?ol?3`on7QhOo`l?001?o`l?05ohZ:RPKol?3`00?o
g=cLohZ:R_o^k^h04oo^k^h00oo`l?3ohN7Qoo3`l004oo3`l0GoRXZ:1_o`
l?000ooLg=coRXZ:onk^kP3oonk^k_ook^k^AOo^k^h3ooooo`000_ooool0
0oo`l?3ohN7Qoo3`l005oo3`l0CoRXZ:1_o`l?000ooLg=coRXZ:onKViP0C
onKViP03oo3`l?oQhN7ol?3`00Col?3`1?n:RXX7oo3`l003omcLg?n:RX[o
i^KV0?ooi^KVoooVi^I5onKViP?ooooo0002ooooo`03oo3`l?oQhN7ol?3`
00Kol?3`0on:RXX6oo3`l003omcLg?n:RX[ok^k^01?ok^k^00?ol?3`on7Q
hOo`l?001?o`l?03ohZ:RPSol?3`00?og=cLohZ:R_o^k^h0ooo^k^koonk^
kTGok^k^0oooool000;ooooo00?ol?3`on7QhOo`l?001oo`l?02ohZ:RPKo
l?3`00?og=cLohZ:R_ooool04oooool00oo`l?3ohN7Qoo3`l004oo3`l0;o
RXZ:2Oo`l?000ooLg=coRXZ:ooooo`3oooooooooooooB?ooool000;ooooo
00?ol?3`on7QhOo`l?002?o`l?000on:RX[ol?3`oo3`l004oo3`l003omcL
g?n:RX[ok^k^01?ok^k^00?ol?3`on7QhOo`l?001?o`l?000on:RX[ol?3`
oo3`l008oo3`l003omcLg?n:RX[ok^k^0?ook^k^ooo^k^i5onk^kP?ooooo
0002ooooo`03oo3`l?oQhN7ol?3`00ool?3`00?og=cLohZ:R_oVi^H04ooV
i^H00oo`l?3ohN7Qoo3`l00?oo3`l003omcLg?n:RX[oi^KV0?ooi^KVoooV
i^I5onKViP?ooooo0002ooooo`03oo3`l?oQhN7ol?3`00ool?3`00?og=cL
ohZ:R_o^k^h04oo^k^h00oo`l?3ohN7Qoo3`l00?oo3`l003omcLg?n:RX[o
k^k^0?ook^k^ooo^k^i5onk^kP?ooooo0002ooooo`03oo3`l?oQhN7ol?3`
00ool?3`00?og=cLohZ:R_ooool04oooool00oo`l?3ohN7Qoo3`l00?oo3`
l003omcLg?n:RX[ooooo0?oooooooooooom8ooooo`000_ooool00oo`l?3o
hN7Qon7Qh@0?on7Qh@03omcLg?n:RX[ok^k^01?ok^k^00?ol?3`on7QhOoQ
hN403ooQhN400ooLg=coRXZ:onk^kP3oonk^k_ook^k^AOo^k^h3ooooo`00
0_oooolCoo3`l003ohZ:R_oVi^Koi^KV01;oi^KV4oo`l?000on:RX[oi^KV
onKViP3oonKVi_ooi^KVA?oVi^H3ooooo`000_oooolDonk^kQCoRXZ:ooo^
k^koonk^kU[ok^k^0oooool001Kooooo00?ol?3`omcLg?oLg=`04?oLg=`0
0on:RX[oooooooooo`3oooooooooooooFoooool000;ooooo5?o^k^h00oo`
l?3ohN7Qoo3`l00?oo3`l003omcLg?n:RX[ok^k^0?ook^k^ooo^k^iIonk^
kP?ooooo0002oooooaCoi^KV00?ol?3`on7QhOo`l?003oo`l?000ooLg=co
RXZ:onKViP3oonKVi_ooi^KVFOoVi^H3ooooo`000_oooolDonk^kP03oo3`
l?oQhN7ol?3`00ool?3`00?og=cLohZ:R_o^k^h0ooo^k^koonk^kUWok^k^
0oooool001Kooooo00?ol?3`on7QhOo`l?003oo`l?000ooLg=coRXZ:oooo
o`3oooooooooooooG?ooool000;ooooo5?o^k^h00oo`l?3ohN7Qoo3`l00?
oo3`l003omcLg?n:RX[ok^k^0?ook^k^ooo^k^iIonk^kP?ooooo0002oooo
oaCoi^KV00?ol?3`on7QhOo`l?003oo`l?000ooLg=coRXZ:onKViP3oonKV
i_ooi^KVFOoVi^H3ooooo`000_oooolDonk^kP03oo3`l?oQhN7ol?3`00;o
l?3`2On:RXX4oo3`l003omcLg?n:RX[ok^k^0?ook^k^ooo^k^iIonk^kP?o
oooo000Fooooo`03oo3`l?oQhN7ol?3`00?ol?3`1on:RXX5oo3`l003omcL
g?n:RX[ooooo0?oooooooooooomLooooo`000_oooolDonk^kP03oo3`l?oQ
hN7ol?3`00Col?3`1On:RXX6oo3`l003omcLg?n:RX[ok^k^0?ook^k^ooo^
k^iIonk^kP?ooooo0002oooooaCoi^KV00?ol?3`on7QhOo`l?001Oo`l?03
ohZ:RPOol?3`00?og=cLohZ:R_oVi^H0oooVi^KoonKViUWoi^KV0oooool0
00;ooooo5?o^k^h00oo`l?3ohN7Qoo3`l006oo3`l003ohZ:R_o`l?3ol?3`
00Kol?3`00?og=cLohZ:R_o^k^h0ooo^k^koonk^kUWok^k^0oooool001Ko
oooo00?ol?3`on7QhOo`l?003oo`l?000ooLg=coRXZ:ooooo`3ooooooooo
ooooG?ooool000;ooooo5?o^k^h00oo`l?3ohN7Qoo3`l00?oo3`l003omcL
g?n:RX[ok^k^0?ook^k^ooo^k^iIonk^kP?ooooo0002oooooaCoi^KV00?o
l?3`on7QhOo`l?003oo`l?000ooLg=coRXZ:onKViP3oonKVi_ooi^KVFOoV
i^H3ooooo`000_oooolDonk^kP03oo3`l?oQhN7ol?3`00ool?3`00?og=cL
ohZ:R_o^k^h0ooo^k^koonk^kUWok^k^0oooool001Kooooo00?ol?3`on7Q
hOo`l?003oo`l?000ooLg=coRXZ:ooooo`3oooooooooooooG?ooool000;o
oooo5?o^k^h00oo`l?3ohN7Qon7Qh@0?on7Qh@03omcLg?n:RX[ok^k^0?oo
k^k^ooo^k^iIonk^kP?ooooo0002oooooaCoi^KV4oo`l?000on:RX[oi^KV
onKViP3oonKVi_ooi^KVF?oVi^H3ooooo`000_ooooooogmoOeOoOgmo1omn
OWkoogmoObCoOgmo0oooool000;ooooo00Cojn_[onKVi_oRh^;og]kN1?oM
gMd3omkNgP03omcLg?oNg]kogMgM00;ogMgM0?oog]kNomcLg?oNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]h0017ogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oLg=cogMgMom_Kf`02omcL
g00comgMgOoMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN00;og=cL00GofMWIomSHf?oG
emOof=SHomWIfP02omcLg03oomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
g=cLomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kN000GomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMh00ooNg]h00ooMgMgog]kNomkNgP03omgMg@03on7QhOoWinOo
j^[Z00?ooooo0002ooooo`03onc/k?oVi^Koh>3P00OofMWI00Cof=SHomKF
e_oCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oG
emOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=So
emOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf=_ofMWI0_oHf=P0
1_oFe]Kodm?Com?CdooDe=CoemOGomSHf0;ofMWI00?of=SHomWIfOoIfMT0
0_oHf=P9omWIf@03omSHf?oIfMWofMWI00;of=SH00?ofMWIomSHf?oHf=P0
0_oHf=PGomWIf@04omSHf?oFe]Kod];Bolo?c`;ocLg=00Coclo?om?CdooG
emOof=SHoooIfMTFomWIf@03omSHf?oIfMWofMWI00KofMWI00?og]kNonKV
i_o/k>`00oooool000;ooooo00Ook^k^onWYjOoTi>Coh>3Pon7QhOoPh>3o
h^;R00;ohN7Q00gog]kNom_KfooCdm?oalO7ok^k^onb/[;o[Jf]ok:b/_nk
^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?oalO7ok^k
^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoO
om_KfooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_o
gmoO0=[ohN7Q00Woh>3PomoOgooKfm_oe]KFomCDe?oFe]Kof][JomkNg_oP
h>001_oOgml3on3Ph003omoOgooPh>3oh>3P00;oh>3P2?oOgml2omkNgP;o
gmoO0ooPh>02omoOg`;oh>3P0_oOgml=on3Ph005omoOgooMgMgofMWIomGE
eOoCdm<00_oBd]800ooFe]Kog=cLon3Ph01_on7Qh@03on3Ph?oQhN7ohN7Q
00GohN7Q00?oh>3Pon7QhOoQhN40<_oQhN400ooPh>3ohN7Qon7Qh@1Xon7Q
h@03on;Rh_oQhN7oh^;R00CohN7Q00?oi>CTonSXj?o]kNd00oooool000;o
oooo00?ol?3`ono_kooalO400oo`l?00ooo_knool?3`onk^k_oYjNWofm_K
ol71`OnTY:CoS8b<ogYjN_mgMgOoNg]kohb<S?nTY:Co`/;1om[Jf_oZj^[o
kNg]oo7alOo_knoolO7aono_kooalNookno_oo7alOo]kNgoj^[Zom[Jf_o2
`/;oY:BTohb<RomkNg_oMgMgog]kNon<S8coY:BTol;2`_oJf][oj^[Xong]
kOoalO7okno_oo7alOo_knoolO7aono_kooalNookNg]on[Zj_oJf][o`/;2
ojBTY?n<S8coNg]kogMgM_mkNg_oS8b<ojBTY?o2`/;of][Jon[Zj_o]kNgo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_k`006ooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_onk^k_o_knooj^[ZonOWi`02on3Ph007on?Shoo[
jnWojn_[on[Zj_oVi^Koj>SXonOWi`02onWYj@0Bonk^k?o/k>cok>c/onSX
j?o/k>cokNg]oo3`l?o/k>coj^[XonKVi_oXj>SoinOWonWYjOoXj>Sojn_[
onOWiooWinGoiNGU0_oYjNT03oo^k^kokNg]ong]kOoXj>Sojn_Yonc/k?o^
k^kojNWYon[Zj_o[jn_okno_onc/k?o/k>[oj^[Zonk^kP02onc/k03oon[Z
j_o_knook>c/onc/j_oZj^[ok^k^onc/k?n_[jooMWIfoeUIFOm^KVko]kNf
on3Ph?oYjNWokNg]oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_000]oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo`
l?3okno_oo3`l?o_knool?3`ono_koo`l?3okno_00Col?3`0oooool000;o
oooo00?ol_;bonk^k_oWinL01?oUiND04?oTi>CogmoOom7AdOna/K7oRXZ:
ofEUIOmADE7oADE5od92@_m5ADGoDE5AofIVI_n:RXWo/K6aom7AdOoNg]h2
onCTi003onGUiOoTi>CoiNGT00;oi>CT00oog]kNom7AdOna/K7oRXZ:ofIV
I_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6aom7Ad?oNg]h00_oT
i>@0kOoUiNGoi>CTonGUiOoTi>Coi>CSomkNg_oAdM7o/K6aohZ:R_mVIVKo
DE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM7og]kNonCThooT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi002onCTi03oolG5aOlX:2SoA4A4oi2@T?oAdM7og=cKom_KfooG
emOoe=CDomKFe_oDe=CoeMGEomWIfOoPh=oog]kNom[Jf_oDe=CofMWIomkN
g_oRh^;og=cLomOGe_oDe=Coe]KFomCDe?oEeMGof=SHom_KfooGemOoe]KE
omGEeOoGemOof=SHomkNg_oOgmoog=cLomGEeOoGemKog=cLomgMgOoGemOo
e]KFom_KfooQhN7og]kNom_Kf_oJf][og]kNomcLg?oJf][ofm_Kon3Ph?oO
gmoog=cKomWIfOoNg]kogmoOogAdM?mWIfOoSHf=oeADE?l820SoXZ:RomcL
g?oRh^;oiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoShn?oiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGohn?SonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
001HonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi0CoiNGU
00Ooi>CTonGUiOoUiNGoiNGUonSXj?o/k>col_;b00?ooooo0002ooooo`03
ooCdm?o]kNgoinOW00;oh>3P01?ohN7QomoOgooNg]kod];BokBd]?n7QhOo
G5aLofdk=OnNCT;ocFiNonV3Koo=KeooWDe3ofdk=_mLG5coQhN7okBd]?oB
d];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m]H2coWYH^olg=
?ooYjDgocLdooijJ;om]HbgoG5aLohN7Qond];Cod];BomkNgP05on3Ph00A
omkNg_oBd];o];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=AomZWSCo
BFX_oeaLG?n7QhOo];Bdom;Bd_oNg]h0fOoPh>001_oOgmooclo?oiVIVOnB
TY;o6ATIohb<S0;oeMGE01ooclo?ol;2`_o>c/koc/k>olG5aOo:b/[of][J
omSHf?o@d=3obl_;olo?cooHf=Sof][JomGEeOo?cloo`L71om3@d?o>c/ko
a<C4ol_;booHf=SoemOGokjn__nk^k_odM7Aom3@d?oEeMGof=SHom?Cdoo<
c<coc/k>00;oeMGE00Goc/k>olc<c?oCdm?of][JomSHf002om;BdP04omSH
f?oGemOodM7Aom?Cd`;ofMWI00Kodm?Com7AdOoGemOof=SHom7AdOo@d=02
om7Ad@04odI6A_m1@D7oemOGomkNgW7oh>3P00?ogmoOon3Ph?oPh>000_oP
h>000ooOgmooh>3Pon3Ph02Lon3Ph003omoOgooPh>3ogmoO00;ogmoO0ooP
h>001?oQhN7oinOWonc/k?odm?@3ooooo`000_ooool00oofm_Kol_;bon_[
j`03onSXj00ConOWiooRh^;ocLg=oinOWomZGUkoScH^ona`HOoiWI3ooK6U
oofl[oom]:OonInConedHonB=booJemOoinOWoo=cLgoh^;RonOWi`03onSX
j00ConOWiooRh^;ocLg=oinOWom^IUooTg8RongAA?oilgCooOf=oogmUOom
oHkonOQfongGAonCLb;oKVMOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOW
iooRh^;ocLg=oinOWomPJ5ooBg`Soi;QBonmnG_od?fBomSmVooDoIGo`?Un
oiSXCOm=P2CoH6UOoinOWoo=cLgoh^;RonOWi`3JonSXj004onKVi_oQhN7o
GEeMode=C@;ogMgM01ooD51@o`L71olE5AGoQ8B4oaHF5_m3@d?oh^;RomgM
gOnLW9co0000ohn?SooMgMgohN7Qom_Kfom0@43o20P8oaTI6On8R8So2`/;
oeQHF?ng]kOo30`<o`L71olS8b?o9bLWogemOOoJf][ogMgMomCDe?l;2`_o
FEUI00;ofMWI00?oGEeMo`/;2ooCdm<00_oOgml01_mJFU[oCTi>omkNg_oN
g]ko8b<SohB4Q0;ohN7Q00coNWYjobh^;_oMgMgogMgMol;2`_m@D53o<c<c
ofi^K_n3Ph?o8B4QomkNg_oVi^KoonSXj1ooj>SX00?ok>c/oo;bl_ofm_H0
0oooool000;ooooo00?omoOgooShn?ohn?P00oohn?P04oogmoOok^k^olk>
c_n@T93oQBl[onUTE_okTXOooZJKoojaYOoo]j[oo[>VoojXW?ojU8WokVQI
ohTa:on@T93oc/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93o
VFT[oo2m?Ookh6koo_B2ooknR_oooi;oo_j<ookhPookiG3ol<8noiUZ:on@
T93oc/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93o@W<[ohC>
@on]kg?o`_j8olknT?oFoiOod?jBolKnROnbmGCoR==3odAe:on@T93oc/k>
onk^k_ogmoL0f_ohn?P09Oofm_KolO7aoh61POlO7aookNg]olK6a_l0003o
`l?3om?CdomLG5co20P8on[Zj_o`l?3oj^[Zoe9BD_lD51Co?CdmonWYjOo`
l?3o[jn_o`L71ooBd];ocLg=odi>C_lK6a_ok^k^om_Kfon^[Zkoj>SXonc/
k?n^[Zko0000okBd]?o/k>co/;2`o`/;2olJ6QX00_oTi>@02olS8b?o3Ph>
ojBTY?o]kNgok^k^of1PH?mDE5Cok^k^ong]kOlV9RKoSHf=00;ol?3`00co
PX:2oc4a<Oo/k>coj^[Zod=3@ol_;booW9bLog=cLolZ:R[o6QXJonk^k_of
m_I_ooShn003ooOgmoohn?Son?Sh00Gon?Sh00?omoOgooShn?ohn?P0WOoh
n?P00oogmoOon?ShooShn002ooShn005ooOgmooinOWomoOgooKfm_ohn?P0
0oooool000;ooooo00?on_[jooGemOo^k^h00_o/k>`0ooo[jn_ojNWYomoO
gonj^[[oN59Boklb9?oVLfSooHUnoonGRoonXYKoojRLoojTV?ooVXgooXYo
onifJ_o3<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/on[Zj_oOgmoo
^[ZjohQUD_oRTAconL=@oogJHooojW;oo_=nooojP_onmWooonacookNI?oj
ae7ohY8LohUVDonj^[[ogmoOon[Zj_o[jn_ok>c/on_[jooZj^[ogmoOokZj
^_mBKE;oDJ<Loi7BEOnVif[o^?Ujol3nP_o7ohWo`oj4okWmNonWk6coU=IG
oe:V7?mBKE;o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k000BOo/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?oYjNWo
iNGUogYjN_lL71cohN7Rolc<c?l30`?oX:2PomkNg_nDU9Co4a<Con7QhOoP
h>7od=3@o`H61_nQXJ7o2@T9okno_ooQhN7o^[Zjo`820_nb/[;ogMgMoh20
P?lX:2Sohn?SonOWiooUiNGogmoOom_KfooCdm?o20P8ohF5QOoOgmooJFUY
odY:B_le=CGo[Jf]okfm_Ol71`OoN7QhoeEEEOoOgmooh>3Poe]KFom@D500
0_oQhN402_lT92CoQHF5omoOgooQhN7oNg]kobl_;ooPh>3oe=CDo`D51OnX
Z:P2on?Sh`3ooginOolF5QKohN7Qon[Zj_o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?oZj^[ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>coj^[[onc/
k?o[jn_ok>c/on_[joo/k>coj^[Zonc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[000Jonc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jn`6on_[j`06onc/k?o[jn_ojn_[onk^k_ofm_KonOWi0ooo
ool000;ooooo00?ono_koo?cloo]kNd00_oUiND0oooVi^Koi>CTomWIfOnb
/[;oNBh^olQ2<ooSJUcom7Y]oof8O?onUh[ooY^>oojHRoonRWkom7]]onM[
GOo:@SCoNbh^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGVonCTi?oHf=So/[:b
oiIE;_oZW2_onka4ook<Doomf6;oo^=bookYMOoniW?oo]]Uoog<Dook`DGo
kYh[oiUF;_nb/[;of=SHonCTi?oUiNGoi^KVonGUiOoTi>Cof=SIok:b/_l^
HRkoHjd[ohO:B?nGg5WoYNEYok;cMonhmW_o]?EiojOZJonHg5WoRLm;of>^
:ol^Hbko/[:bomSHfOoTi>CoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUiP00=?oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oShn?ogmoO
ogMgMolK6a_og=cLon7QhOnNWYko;bl_ob/[:olb<S;o4Q8BomcLg?oJf]_o
Q8B4ob0P8?oPh>3oDU9BofQXJ?oJf][og]kNoi2@T?lZ:R[o;Rh^ob`/;?lW
9bL2omkNgP0ComWIfOoCdmCod=3@oe]KFol0003o_Kfmom[Jf_lX:2SoQhN7
ogMgN?mXJ6SoPX:2oc`l??o2`/;o3`l?omCDe?oJf][oFEUIodi>CP02omcL
g00?ob<S8on1PH7oeMGEomOGeomgMgOo;Rh^omcLg?nSXj?o0000olO7aooH
f=SofMWIohf=S_lE5AGog=cL00;oi>CT073oi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^Koi>CT0_oUiND0X_oVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUiP;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H01?oUiNGokNg]ooCdm?oj
n_X3ooooo`000_ooool00oolo?con?Shoo7al@03onk^kP0Con_[jooQhN7o
_;blogXG5oo3?c;odeI9onAXF_o_Mfcom8=iooN7O?oeQ7[olgU]onEYFooI
F4[oa3lbog`G5onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;blojE7
5ooVUc;omJ``oofl@OombE?ooM1Poo_CIOomdV3oo/eDoofm@_oj[c;ojI/b
ojE65onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;bloaMI5omOZ3;o
M[dgohK=AonFeU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg_cOoGj/boaMI5onl
_;cohN7Qonc/k03Jonk^kP0^onc/k?oWinOoNg]koa`L7?oTi>CojNWYonKV
i_oQhN7og]kNohf=SOlD51Coi^KVonCTi?le=CGoNGUion_[jonb/[;o5ADE
omoOgooVi^Koi>CTon7QhOoMgMgoNWYjobTY:OoXj>SoiNGUomgMgOna/K7o
9RHVo`/;2onKVi_ojNWYolc<c?l0003oc/k>ol?3`olU9BGoBd];ogalO?oX
j>So<C4aojFUYOoTi>CoGEeMoe5AD@;oinOW00[o9BDUofUYJOoOgmoogmoO
ogMgMola<C7ojNWYol71`Ol0003oYjNW0_oOgml01?nCTi?o5QHFonOWioo/
k>b/onk^kP03ong]kOo^k^kok^k^06kok^k^00CokNg]oo;bl_ohn?Soo?cl
0oooool000;ooooo0oomoOd05_olo?cooOgmoogmoOolo?colo?com7AdOmX
1`Oo^3@dolLo<ooBD4?ofV9Eon=^H_oTLVCoi6mRomaTEooCDD?oc44dokTd
=?m[1`Ood];Boo?cloolo?`3oogmo@0Cooclo?oclo?od];Boih[1ooJRSCo
ji/IooFX:Ooh]3oonKe:ooRoCOoj_d[onKPoooJZ:_o_WQWofh/doj8]1ooB
d];olo?cooclo003oogmo@0Cooclo?oclo?od];Bo`M01om=VSCoGj/Pog2h
;omo`d?oR/e@ohg=D_n:cU3oPLM4og6i;omR[R3oCY/do`M21ooBd];olo?c
ooclo03Joogmo@0Soo_knoogmoOoQ8B4oahN7_oclo?onOWiok>c/oo@d=3o
lo?cofQXJ?m7AdOon_[jomCDe?l0003ogMgMooclo?okno_o9bLWojRXZ?oi
nOWoZj^[omGEeOoalO7oE5ADoeiNG_oinOWom?CdoiBDU?l51@Go@410om7A
dOogmoOon?ShoiNGUol[:b/00_ojn_X06olT92Co1`L7olS8b?okno_oQHF5
of=SHoogmoOoHf=SoeMGEoohn?SonOWiobLW9olE5AGoPh>3omOGeom2@T;o
Hf=Soo_knoojn_[o=3@dodU9BOoKfm_oiNGUodm?ColG5aOonOWiooclo03o
oogmoAcooOgm00?oo?cloogmoOolo?`00oomoOd3ooooo`000_ooool0>_om
oOgon_[joo?cloo^k^kol?3`ono_koo^k^kojNWYom?CdomJ71coXS@dok@X
7Oo1>BcoadTlolmFB_o@Ed_od5M:olY:?_o3>bko]RPMoj8d=?mL7Agodm?C
on[Zj_o^k^kol?3`ono_koo`l>ook^k^on[Zj_oCdm?oS2DMolQa=?oIQ1go
i9@EonNM9?o^Z3?ol:XdonnZ<oo/X2GoiiLEomb87Oo8LCCoS2DMom?CdooZ
j^[ok^k^oo3`l?o_knool?3`onk^k_oZj^Wodm?Coadh7OldPSCoAiDMoeZU
6omY[BX2ogBh>03RogFi>?m[/B_oFjLLodRJ7OldPSCo7CPMom?CdooZj^Wo
k^k^oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l0;okno_0>koj^[ZoginO_lL71coj>SWong]kOn8
R8So<30`o`l?3ola<C7o/K6aonk^k_n5QHCoCDe=ono_koo^k^kokno_ohZ:
R_mIFEWok^k^ogQhN?l[:b_o3`l?ocPh>?no_kookNg]onCTi?l>3PkoJFUY
omoOgooShn?oiNGUon_[jomQHF7oMgMgonk^k_o_knkoMWIfobHV9_o]kNgo
kno_olc<c?l/;2coj^[Zofe]K?mRHV;ok>c/ong]kOlk>c_oTi>Cof9RH_l>
3Pko=3@dolC4a?o_knook^k^om7AdOll?3co2PX:obLW9om/K6co;2`/ono_
koo^k^kol?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o^k^kol?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`0oo_knl0I?o`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knl2oo3`l0Kokno_00?o
lo?cooWinOono_h00oooool000;ooooo00?oo_knooOgmoo`l?001?oYjNT0
4OoWinOofm_Kof=;Bon1<S;oYSDeokHd;Oo2CD7o`eA9olAEB_o3E4Wo`Te1
okHd;OnU=CGoPC8bof=;BooKfm_oinOW00GojNWY017oinOWom_Kfon9Bd_o
[d/boleg=OoFRbgoh9`^on2P<_oQX3Coh:0bomnJ;_oFRbgobWDeojm;<_n9
Bd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oBd];oc9P<_ljRCGoDi/]of^[
;om`[CSoKjhjog2]>?mZZRooDi/]ocV8=OlbH3;oBd];om_KfooWinL0fooY
jNT01_oXj>Soi^KVog]kNolL71coi>CTonSXj0;ojNWY00?oinOWonWYjOoY
jNT02ooYjNT03?oWinOojNWYonWYjOoXj>Sof=SHo`X:2_n^[ZkogMgMomkN
g_oPh>3oiNGUonSXj0SojNWY00Koj>SXonKVi_oShn?ohn?SonKVi_oXj>P3
onWYj@03onSXj?oYjNWojNWY00CojNWY00?oinOWonWYjOoYjNT0oooYjNTK
onWYj@03onSXj?oYjNWojNWY00CojNWY00?ol?3`ooOgmoono_h00oooool0
00;ooooo00Goo_knoo[jn_odm?Cokno_oo7al@02oo3`l00Aono_koo[jn_o
UIBDodlS8onEE5Co^g=com>EUOoJW9cofYjLomVLW?oDUIGo^g=coiEDE?m?
8b?oUIBDon[Zj_o_knl01Oo`l?004Oo_knooj^[ZojVDU?n18b?o^VYDomBJ
LooT_9Goj/NLonW7W?oZaicoiKbEomBJLonkJUCoPB<SojZDU?oZj^[okno_
00Gol?3`017okno_on[Zj_nDU9Co8bXSoeAjE?mcYG?oW/JEojc>W?n]cYco
[<jLoik6UOmcYG?oE7YDob<Z8onDU9Coj^[Zono_k`3Koo3`l0;okno_00Co
P820oadM7Oo^k^kokno_4oo`l?02ono_k`07ofATI?lY:BWoPH61of=SHolk
>c_ok^k^ono_k`08oo3`l006ono_koo^k^koLg=cofUYJOo^k^kokno_ooo`
l?0]oo3`l005oo7alOo`l?3om?Cdoo[jn_ono_h00oooool000;ooooo00Co
k>k`ooooooooooooo_kn0_ooool2ooknoP3ooogmoOohn?SoKVi^oeXo?ona
T93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSloofe]KOohn?Soo?cloooo
ooono_koooooookno_ooookoo_knooooooolo?con?Shohe]KOn:?coobI6@
onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo?on=KFgon?Sgooclo?oooooo
o_knooooooono_koooooookno_ooookoo?clooShn?m]KFgo?clooi2MT?o9
eLWoi>cTonK^i_oTk>CobMG9oi2MT?lo?cooKFe]ooShn?olo?coooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_kn000hooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooomoOgod=3@ojFUYOono_goo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_kooooooogmoOo1
`L3oLG5aoh61POn_[jl2ooknoP0<ooooooono_koooonookno_ooooooo_kn
ooooooono_kooooooogmoOo2`/7o_;bl0_ono_h0ooooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooo`00:Oono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_kn00;ooooo00?oo_knooooooooool00oooool00oojno_oooooooooo`01
ooooo`000_ooool01?o1b<koo_knoo[jn_odm?@5oo7al@0=ono_kooFe]Ko
Jf][od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09
oo7al@0=ono_kooGe]KoPf][og@m?OneS8coeKZjon7<c?oF^[[o]Xb<og8m
?On1Jf_oemKFono_k`09oo7al@0=ono_kooFe]KoJf][ocdm?On<S8co^[Zj
olc=c?nj^[[oS8b<ocdm?Om[Jf_oe]KFono_k`3ooo7alOoolO7a=?oalO40
1?o`l?3olO7aoo7alOo`l?04oo7al@04ooCdm?ojn_[oo_knon_]kP?ooooo
0002ooooo`05ohB?VOomoOgon?Shoo3`l?o[jn/00ooZj^X03OoYjNWoj^[Z
onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT0
2ooZj^X02ooYjNWoj>SXoj2KVomZFEWo@bHVobd92Om29RKoJEUIoj2KVooX
j>SojNWY00_oj^[Z00_ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUI
FOnKVi_oj>SXonWYj@3oon[Zj_ooj^[Z??oZj^X01Oo[jn_ol?3`ooShn?om
oOgod]KH00?ooooo0002ooooo`04ocI6DOnh`<GonOWiooCdm0SolO7a0_o`
l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_
knl2oo3`l?oolO7aoooalO4joo7al@03oo3`l?oalO7olO7a00;olO7a00Co
mOGeoo[jn_o/kNooXJFX0oooool000;ooooo00?o7BloodaIHoni_lD0oooo
ooooooooogcooooo00?okNk_ojf`/_nUZZd00oooool000;ooooo00Ko72hm
oaXY=Olb?4KoOXR@okg3b?o[k>koooooooooooooM_ooool01_oZjnco^l34
ogV1Qol/=Cgo4alYoa@T;`?ooooo003oooooooooooooQoooool00001\
\>"], "Input",
  Evaluatable->False,
  ImageSize->{645, 487},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<javax.swing.plaf.basic.BasicArrowButton\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["javax.swing.plaf.basic.BasicArrowButton", 43]\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\(savedLayout = pane@getLayout[];\)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]pane@
        setLayout[Null]\[IndentingNewLine]]\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(d = 20;\)\), "\n", 
    \(\(\(bU = 
      NewBasicArrowButton[pane, 
        javax`swing`plaf`basic`BasicArrowButton`NORTH, d, 
        0]\)\(\[IndentingNewLine]\)
    \)\), "\n", 
    \(\(\(bR = 
      NewBasicArrowButton[pane, javax`swing`plaf`basic`BasicArrowButton`EAST, 
        2  d, d]\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(\(\(bD = 
      NewBasicArrowButton[pane, 
        javax`swing`plaf`basic`BasicArrowButton`SOUTH, d, 
        2  d]\)\(\[IndentingNewLine]\)
    \)\), "\n", 
    \(bL = 
      NewBasicArrowButton[pane, javax`swing`plaf`basic`BasicArrowButton`WEST, 
        0, d]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.plaf.basic.BasicArrowButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject137009490296833]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.plaf.basic.BasicArrowButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject115673233620993]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.plaf.basic.BasicArrowButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject4116659044353]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.plaf.basic.BasicArrowButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject54082446295041]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(\(DeleteJObject[pane, bU];\)\), "\[IndentingNewLine]", 
    \(\(DeleteJObject[pane, bR];\)\), "\[IndentingNewLine]", 
    \(\(DeleteJObject[pane, bD];\)\), "\[IndentingNewLine]", 
    \(\(DeleteJObject[pane, bL];\)\)}], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JToggleButton <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000F8`;S8h=R8`;R8`;S<c<`0oooooooooomi
oooo0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI/c<c?mVIVKoIVIV
MfIVIP04ooooR<2hR<2hB9280@00000000J8`;S8h=R8`;R8`;QVIVKooooo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<
c00XYkgBZKc:/L33]:RXXfI^ZEEUZ5I/TUU/[j:[[K^k/lK2UJZSNX^5CEaI
AU=IF6=WFfAOA4]3@TDl>C`c@D<hCU15ATLoD559FUeF?T4j>C`c@D<hBTPk
DT`lF54nIEi;GEa:H65AIVQJGf5C@TDj=cda@dQ1?4<k0Si5?P1;?4<k?dHn
A4U2@4Dn@TDlCDhnHU]1LfY;LV]AQ7m[WI^<YJNLG65J@4Y2<S`d<chf=3lg
<chf>D0i?dHo@dQ4B4HjH4leHdh_HU0hIU]9JVIKJFYTLG=`P8F1TY>;YjRJ
_;ZSc/V[g]VaiMj`i=ZWg]NYd]>cdMFloOo/nOkZkOCRfn7C_<BiXZVRRI:?
B51B?TI9:C0h9Rdg=3Y6<cU7<CY;=4IJ=e1V>U=Y>UMY@5maB6YfH8F>Q:N[
Z<[;^]WCcNCLf>[Lg^_JgNG@g=o:iN76j]Vklmbjl]bgl]bemn6j00;hhkP0
0ocW^/c<c<c<c03oc<c<3<c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooklc<c00X/<GH/<?A/;o2]k>d^i:H]GV3UeYZ
SV9a]J^c//30[L?0RZ>OM8R6A5AC?de@DEaNDEYE@DQ0@DHo?D0gA4LnDU=;
B4U1CE19@dHo>chg@TDn@dDj@T0dBTLfFU=1JFA@HV5?EeQ8GV1BD595>Sdb
?D<g@DHo@TU10Sm6?`0g?TDm?dHn@TM0?D8k@4<jBT/mGePnLfY;O7EKVYF1
[ZbMYZRMCE9;?D@m=Clg<Sde<chf>D<k?dHo@4Do@DI2ADDkDTXeFThfHe]6
LfaJNG=WKf]PKFUPNW=YNG5TQWm/TH]cVYEh]K:Ad]:/emVbdmZh/;fYYkNZ
]lVm^L[0d>7GhoC/k_oimOoodn7QBUQH92la:cHh;3Dj8BX_6b@Y9Blh8C4n
008O=D<04QliAR8nBR0nB252BBa;CSQFETEOG4iUGeY[HFmkKhN=Oj6UU[Zi
YMC>]^7G_>SN`n_RaNkUaP;^hl<00oCZalc<c<c<c03oc<c<3<c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<c01h
]<KD]LOC/<?9]L32`l72[:2RLEiRNfaaXj>U/l72YKo0O9ZJJ8:3=T]<>4Q8
BeMG@di:>D<k?TDm>Slh@dHoCe9;A4M0@TM1?D8l>Sli@DI0@TDlB4PnG5Y;
If5AJfICIfIDD551EUQ:A4Hi>C`aAD/o?d@m@TU1@4Lo@TU1@4Lo?dHn?d@m
>Slh?D0gB4TkHUa2KfQ;PWaTVYR3][NWSI25@DLm?dHn?dU0>dDl?4Hm@Ta3
ATe5@DHo@48m@4DoAU15AE12EE]=MGIXT8UiS7m^Q6mJQFeEU7YQVHAYVh]a
RXAZUIZ4[;fZZ<6^W[nfVL35Tkk7Tk_5S[JnVL37VKk4VkfoW[foTJf^?EIC
=Da6;T4k7BhV830V9C8X72TP8c8_7Rh^7B`_7C4b7S<f83Pj83Tm73Hg7SHh
:d11=4I6>dU9AE1<CUA@F5eGHVUREV=LFV]SIGA]NXZ0VjRN]L6eam76e=c?
olc<c0k<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooono<c<`0N;;3cKC6d;?:dZc8bjo=bi6ZYTiHEemSHXF=Sk70`j2m
`G2AUU]hOS59CCa<C4QDDSa7@cM2?3a3?3Ln=Si3?4Y=AT56@3i3?D98A3To
>ce2?Sm4?E1BAfMXFV]XEfISDVARDdi@@U1BADI8>d54>DU<@Ci3?3a3>d17
?d=:@T99@Cm6?Si3?3Tn=c`o=TI7>F9LA6eVBXF1J9FBOk^l[VQ[H457?D58
@4=:@T5;@4==@TM?A4M=@dE8@DA5?d97@Cm;AcM6?d5;@V9VF7mlJhIjI8=_
EXM`DIAmGYn:KJZLPYZHPi^VV:Vn]i^i^I>k`hfmdHc2fXk2f8g0dhnncY6m
bYFmahba]f>2QBe:B2m6@2Hj<Ah^8bDc92Xg9RLb92hf:bLa:2Ha:B<`:A/Z
9b0`;bPh=b<e=Ad/;bDd=b/i?30k?CQ2A3]3AD15B4==CT]OH49LFcaDE41I
EUE[JFAjMfj1OGB7Poo<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooo_c<c<06Zeb<n`alnbd=ZTcM>DblQn/Ja:
If=CHf:6TI>iblnG^<5ZSiQIMH0mDEQ4DU=3CTXmB48kAT0mA3di@3Tn@ca8
CDI7C4I5BT@oAD4e?STl@ShoA3i7B41EEDULFDYOGTaIFTa@DTE:C3m9CCm8
Bd16BCi1ASlj?cPnACe3BT93B450AChn@c`j?cPl?cQ5ACUFDC]aJe67PVbU
Y9:e]ZQCET]6C490AcllA3U4C457Cd92B3a1A3U6Acm9BD58Ad96Ad95Ad98
BD5BE4MJGDaKGDMVI4]gMUQcLUAnOF6@TWfKWi6Z]K6ga/^``m6_c=jNc>>E
bn>Db=jBaMZ:^L^B_<b>//1`TIY>JVh_A4L/?3/W<bl`>S8_=2d`<bXk?C8j
?2lh>R`k?c4h?S8_=Rha>c<f?c`a>STc?Che?d42<cdo00Li@dDkADLlA4Lo
BDXlBTY2DU51E5800T1CC`03@5==@eM>BemF0?o<c<`>c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<07RfcM>[
a/f[d=VRdmZDd=6Bb<QgUIMgRH^U/[S1eMb6ZkAbV:=VP8e=GVQ:EELlAd<n
Ad8lAShk@S/k@3ToA3e7C4E<DD]=DTa1Ad<g?CTm@cloA3i2@c]9BCe@CCiG
EDIBDdE?DDA4B3Y7Bce8Bd12ACa1Acdl@CXk@SY0Acm1ASloA3dn@c`k@3Tl
?cQ2A3M?CCQiM5j5PVnh]ZNCThM?DTU:CDI6BdA0B3e;DDE;DD=2ASPm?c94
A3Y:Aci8A3]FCdMGD4Q@CT9:C3m9CCi8DCiDGDYWL5]fOfYfOfajQGNDWiNa
_KflbM6mb]Zid>:`e^VSd^BUdn>/e^JUbmRQ`lmgTii5GVD[?T@eA4LnB4X`
=SHm?chm?C/k>SI5@S/m>bli=bXh>2`j>S0j>c<n?cTn@3/l?S/c=cHg>c`f
?3`h@D10BDI0BdLmB4@nBDDiA410C4Q5DT]7E4e:Edi8F4i9FDm@H5Goc<c<
3/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooklc<c00N/<oDYl[@X/kGY]KPXm;L[M7MZkW6[kO4^/SC]<oJL9JQQjfh
OI>QEf=_B4mE?dQ5?TA0>d8j>3lg?48h@TDlADPoC4m8CU==AT]5>Sli?44k
?d@mB4XoDU=50UAA@009D595BTe2ATTnA4LlATU0A4Ln>d4g?dDk>Chg008o
A3d0=ce2>ci3?3]0>C/n=ci0=E9A?G]iI8f<N[^l[Ve_I51CBTa?B4aABTY@
ATeCAda@@T=5=d11<dE3=dM5>DQ2=UQ??UUA?U1:>TA5=d57?D==A4YECe9O
F79nNWJ2OWF1OiZVY;[8bL7?d/SGg<3CfKoHgKODf;C@e;[Cek_CejZm`F=b
MCm=CT5;CCHn@3Lk?SDf>451@cdk?Shi?DI2@DU8@dA4?002@Chi00i3@Se1
@3a0?c]4@cm<CDQ<CDM5B44nA3XoAcXmB3XmBSU2CT15DDM7DDT2@de400A:
E4]@F4eBFTmFGU?oc<c<3/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooklc<c00YZ<gEYloGX<oIY]CQZ<cL/LOL^<3G
algS]l[KXKo:H8JAVl39SZ:]FF=]@TUABDiA?d@n?D<i>T0f@D@iADLl@dDj
BT]3CE19@4<l=c`e?d8k@D@kBDTmEeE6FUA4EU=2DeE8AdXoCE15@dHkATU0
B4]2=3X`?T@j=c`e008m@S/0Aca1>Si3?3]0>CTl=C/m<UAB@gMfHYjOSkbn
/F5SF5=FCDaABTaBB4M=@dI:?4A6>D94=TE3=TI4=dQ4>DY4=UA>>5iH@UUF
@dU:?413?416A4QAD5=KGF1XJg9lOWR2Pj>_[l;@d;oAdLSLfkgAd<?Gf<OK
f/7Cdl;BdLKDe:Fa/DeGET19ASa2@3Lm>cm3@S/m?3`n?Cdo?TA6ACm1@3Xj
>3hn?3lo?DA3?dM6@T0o>d0l>Da9A4E5?D];@D]=@4U=?4Q??DI?>TEA>D]G
@cm:?4I@A`02Be=800AAEdeEFe5NHEQYK67oc<c<3/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<c00QZLoLYloK
XloJZLoL]/cQ_L_U^L;O^LWS[/[OSk?1Fh28YlS=Y[o3JWV0FF1ZAdY?ADM2
?D0e>cd`AdLkDe=7DU96Cdm5E5A:BT]3>Sdd@44iA4HkDU13EeA3H5U7DTdj
B4Xm0090AS`0>457?Cm5>ci4>T13>S/n=Cm2>D=6?Cm2>d=6?ce0>DA7@3]0
>S`o=U5BA7enKZVYWKVk/5eNEU=FCdiCC4Y@ATe@AdU=?dE7>T94=TI4=dY8
>dm;@59>@U=@?EMF@UECA4M7>cln>DA3@De;C5=AE6=QHW5aLGb0Ok6l^;g=
b/GKf<;OfkoIf<CIg<gOhl7@dlKFe/KDe8NFTdEACCi9@cU4?3M3>CI2>08g
@cL2=T8f01ThA3Xg@3/k@Clo@d93AD92A450@Ca2@Ce6AD17A3]8B3a=CSi?
DSe?E3i<E3a9DSM6D3Q2CCloBD1>EDeAF51HGeMEG5ATJF9WKF<0olc<c0k<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ono<c<`0LZG;gZG<gJS@g:g>gK?8gKK7hK38i:o=jJ[>i7>GYFV8SKKDe:K5
`7R@T6M`NEmOIdA6@D94=dI7>D=4=UECAU=AA5UGBeUICD];@c`m=D12=dA4
>51>@EQB@V1IAUIA?Te?@T98?Si4>T16?3i4>Sa2>3e0=cXm=3i1>454>d13
?495?T13?4=6?ca1>cXm=U9DAh63MKJh[KBg[UmRFeAGD4iCC4eBBdY=A4E9
>d53=Sm1<d93=DU7>Ti:?e1<@5=B@5IE@e=AA4U6?D=0>dM3@4i8B59<C6eW
IgimNHf?R[o8`l?Dc/?Le[oNf;_Iel7IgLSKh/CGgLGGfkS7bVQhMce<BCa9
@SI3>SA1=cA2=CE3=SI4=CE3=3E6=SU7>SA1>SI1?CY3?Sm5@D15?d53?TA5
?dM8@4];@Da=?de>?Te@?DiA?4iC?4eC>D]C?4eA@dY=@P9CETd015ULDeQN
E6Y]I6ecJOo<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooo_c<c<02:YcNFYcN>]dN6]c]fac^2`dnNOcnF1]LYZ
UJQ9JgMJLgNE/ZfUbl2<[JIGI6Y[Jg=@Dda>D4=@DD=4@SEKF4UKEd]VI5QR
HUI?CdLn?cM1@cQ5ACUACd9IDd=SG4UJED9@DdQ3BT82?D8k03Pl@CXi?SLi
?3<k?SE6Acm4ACe4Ad10@ca3AD12A3m1AT0m@S]=D4F0Q7K2aKZVZJ1MGeYA
EU1<DD]<DDY4Aci0A3Hn@3<n@395ACU<C41CD4MGDdQFD49HDTABCT=7A3]2
?cY5@Se9AD9;B4=UHUenOGRDUi36d<S6eM35f]G3g]W0g=g1g>FnfNC5gNO5
g>BY_/==Gf4lC4`hA48d@3`c?SPc?SHf@3L2=d4h010i@cXkAcdf@cTe@SPf
@cTjAS`mAc`oAca1Ace6BCi>D4E<CT5<CT1=Cd5?DD=AE4<2D5=200QFDdAE
DT=IEDUEDDEHETUKG4i/KV1eNF[oc<c<3/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooklc<c00S[M7[[<kW[loTZ<_N
[=GWZ=WZP/7BAH2@<eY[=e9MAe]LJ89iW<FeWL>hDf9UIfY_IVURG5iAD514
AT@gEeE8Gee@J6IJIVILCe18?3lf?d8iADLlE596F5E6Hea:EU=2CU58@dY3
?44k008l@CX0=SLl=CXm=495?4m@B4M8@4A7@3Xm=T53?Sm1?4=8@T97@4Y=
@X23N<W<`i:ESUUNFU1EDDU>BTQ=AT95?454>Cm3=D53=TA6>D];@E5AAeME
BEMDAEQEAU=?@dU6?D8o>4=0>dU4@4e8A5eJEGYiM9BFTL[Ab/OFdLGJeL?M
f/;Ngl7Ni[cHhl7LiLWPj9jc^4EGFcm=CS@n?cDn?CHl>SLm>@8k@3`06cXn
?C`n?CY0?3Y6?3M5>3M3=cU5>Ca7>Ci6>Cm7>T98?4M=@DU<@DY=@Ti@AE5C
B59DBE1BAdm?@eIBAUYDAUMDAE9>@U=AA5QHC6UYGGMiK03oc<c<3/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<
c01cZ/kVYl_S[<kWYm3VW=7SOK_:Gin[:f5]<TaI>DM@@4a<DVMNR:bNU;R/
EfMVDU]JKG9[HfIKBde2AdLkATHjDU98EEE;H65IBTm9=c`f>Chh@DLmDUA9
E5E7FeQ7CT`mADY3@4Y2>d8k>T4j?44j>Chg?T4hC4e5D559ADHn@D8l=SLa
?Clj>S`g@4Do@4DnBe57QH]obm39OhAnFEiJD5EAAda8A4U3@TM0@TPl@4Hj
@4<h?T4f@D8jA4DmB4XmEUQ3F5Y4EEI4Bd`nA44hA3lkC4A2Dd]9IUiLPWej
VIVGcM?AbMSEa]cI`]oM`MoO`MgQ`mcQ`MSNb]gSTZ6TB5=E@DU;=C/k>S/m
>c/m?S`o@Cm2@Cm4?CY1?CPo>CTk?4<k>4<e=d8d>D@f?4@g?DDh?dLl@DTn
@d]0A4Y0AD]1BTe4CE19Ce9;D55;Ce18CU56E5M<DUA9009?D4P00e=DCV1Q
FgIgL@3oc<c<3/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooklc<c00EYlgTXlWPZm?]Z=K^Q/?FBhZIBGn;AFYc?DMA
BDUA?TM6CEiFOYb@NIN=@E9<@Da8HFQQGVAJBDa3B4]0>S/c0094ACd03EII
DTU?Bc<l=cPn>T99@U5DBe5CB5IDAdQ8?3a1>Si7@S]2>cU0>@02@4Dn00I5
ASiBDd]=CTI4ACdn?cTj>cD2?Clj00/n@cdn@ca?ED^>U8[9c/M`MFmEFEQ;
Cdi2Ad<n@cdoA3d00T16?00V?T@h?T4h?T4j@4<l@TDjDeE0EUQ2EEM2C4ln
@d<g@40hAd@oCdY7If9OPgmnVI^Jc=GDbm_KbMkQaN7U`n3TaMkRc>7Tb=_O
cMcOU9nQCEMF@DM7@491>c/k?C/l?cdnA3m3A3m5?C]0>SLn>CLj>cdh0SPm
=P04>d4g?48h?DDj?dLl0d9:?`0:@dToA4U2B4]4C4m8DE9<DUE>C598DeU?
CeA=DEI?0U1BC@03F5YGM7Icc<c<0?o<c<`=c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<062VdNBRcnBTdnfJ
d>ag]L`hKh=BKgm[Lh1HC5ILCeIADe9BGUY_P7YML6Xb@CXlBD17DTY<ETi1
B411Acdl?cQ3B450ACm8CTY4CDXa?3Pg@3doB4=:DDU7CD==Cd94AS/g?SLn
Ad8k@S/h?cQ5BT=8CDI:Bd=CE4a<CDE4ACdk?3Hm?SPl?SU1@chn@cm0ACm<
DDZAUhg2al1UJVA?De94B4Lm@clk@S/k@SXk@cPlA3TmACY1ASm2Ad12Ad54
ACeBD45EDSmEE49>DD14B3To@c@oACM3BCeMHeUjOgREViW;eMO=f^;;gNW;
g^o9gng<h>O<g^;@gn;Agn2]]kINIf91Ad=3B48k?SLj?CHl?cPo@S/o@C`j
?cTh?CTj?3T2>SPi01Hl>S/m?C/m?cXl@C/nACi2BD4oBCi1Bd14C454C3m6
C419Cd=?DTMCET]@DdYFFE1AE4eHFeA@EDm;D4Y?EE5bN7Coc<c<3/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<
c00]YMKWX]GXVLgURKoGLjc0?faoG6mmL71jLfI]Ed]?H69QEUmL@4Y9@4]7
>TDo=D8i=3lk>4<m=T0h=Sde@TM0C55:Ada5?D@m?DLo;CHa<c`i>T<n@DQ1
?D8lATM1?d8k=Sdf@DQ1>d8k>3dfBTe4D5=:CDm4DE=8Bda4@d@n=3L`>C/f
=cTd008n@cl0?DA9@dM<AI>HTKg2_61UHDa@Cd55A3m3@Si4@3e2?3Y1>CY0
=Si4>T=8@DE:A497@d52?5=?@eICA5MEAU=DA4a??TE9>458>498>UeSEg^2
NYFNVlgGfLgJhl_Kj<WLjlKLj/gQk<?Dg<oNhm?Qh/SBdFigLT99@T15?STo
=CPn=3To=CY2=c]3>3Y1>CU0>3a1>cXh>cdh?3dk?Slm?Sdm>c/m>3a1>d17
?cm7?4=;?TM?@TY@@P02BDm100Y>DTAAEDMBDd]GFU=@DdaIG5EAEU19CTQ<
Dda`NW;oc<c<3/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooklc<c01JW=GXX=O[V/oQQ[O8L9j[JHjGJh:8L7]oHVIY
I6ATLgEdG61OA4Q7?490@DM5>44n>dE6=3hm>44l>3lh>d4gEeY?GF5C>d4c
?D<e=Cd`<cXb>3dg>S`i?3`n?3Xo=SHh=CXfA4]4>che>cdbBd/oEEE9FUY>
C4i1A4Dm?3lh>3di=c`h=S/g?40o@TI5@DI2B4m8S9>;]kjgEeeIBdm>ATY9
>3`k>3di?3hi?44j@4<j?dDk@DHo@TM1@4E1@48mF5I:EeE6EE=4De90EUM5
A4DeC4doDU98GeiINWYhZ:b]d=SKbMSKc>7Ta^3Qan?Wamo[am[YdN?_c]gT
a]7CHFYYBE9?>d4m=chg>3lh0cY1>P0<?44j?d8k@44l>c/k>SXl>CTk>CTi
?Cll@T@o@dHo?dDkAD/o0TI<?P0=BDdoBdm1CU93D5A5DUI8CU58DUA?D59=
G65KE5UBC55:D5E>LGQ`0?o<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<05VFd>JLeNVOe>JA`LmhX:YU
QXeXPHEfR8QNJVYIHUm^M79/LFeFFeM8CDU6BTU4BTXoBDXh@T<l@T0j?cTn
@CQJGU1/KV1JGTe5BCPnACDh?S8g?3Dl?3Xk>cdl=chj=chd>3LmA3dn@CXm
?cA3@cU?Cd=EEDU6B3e1A3/k?CPh?CTi?C`f>STi?Ca3ADA5BTI:DDZ1R86h
_[Y=De5<D551ADHm?chj?3Tl?STm@3To@SU1A3]1AT12Ad50A4=0@SeBDTQJ
F4UFE4ECDT1EE499AcQ9AcY6@cYEDDigMGJ][[;@f=_>g]k<h^35h]k4h^;:
i?76fnc=h>k8fN6`^kmDGUm4CD`lAD8g@3/00SQ1?005>T0l>Sli?3hi?Chh
?Slj008m?ch05S`n?CXl>CTk=Si1>TM:@DiAB4U<@DY>@4eA@e9FB5MKC5UM
CUQLCEIICUEHDEEGDTaACEIKEDmDCTY?B59GDGIkM?o<c<`>c<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<05RN
e^nOeNfOd^NHamN<]<1kWJI]RHaXOGiAHEi9EE5NJ61ZLFYEG5E7C4I5BTA:
D4a0BDPi@d8j@3`f>c@h>C5@DTEXJE]XJUa<D45:CSll@SHf?38l?CPi>CTi
=3Pl>Slk?d0k@Cm1AT8n@CY2@ceBDd]@DDU3A3`m@3Tg>C@i>cPk?CXf>3Dg
>CI0@3i5Ad98CdQ_NG6l`[i9Cde@E5Do@d@n@3li>cPk?CPm@3U0@cY3ASe3
B492Ad4o@d8o@CaACTEMFT]DDT=BDCm>Cce=CSi8B3a0@3Q>CD]kNgfd]kc>
emcBhNC:gn37i>;4h^C6hNc3f^S=hNc@hNVLYj]=EeHnAd@l@Sh2>D8m00Lj
@3`i?c/i?SXk?CPm?SPn?cXo@Ch00T12@@0E?T0m>S`g?D0iCU58Gf9IFUeB
EUU>DeM9EEU;FemAHFEGIVYLIfYQE5IAE5ICD59AFE]HEUQECU1;DEIBL7E_
0?o<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoooo_c<c<02RRf?BTf_BPd^VKb]bNb=JH_LIgUYUAJfY5FeQ=HEQ`
OGAkQgeOJF1>EDe4Bd=3BT98DDa6Cda6BdE0@c`m?CE8B3iNGU9[K5iDETQE
FD]5B3di?3=1@S`o?cdh=SLk>c/j?T4i?cll@3lc>3A2A3mBDdi2@chj>cH2
>3Xe0SXl>@0/=SHd>CXe@D0l@44l@dY3J79Z`/S6D5IDDeMH@DE6?3hm=cTf
>S`g?D0i@TDlAdY1Ada6@dQ2?d=2?T0kE558HEeADe52De90BT/iCTloBD/n
ATM1DeEBRhnB_/G;b]OMdN;YaMgQb^KYanCXa=oZ`][VcN7/eNK]RYFGC5IE
?dE1?48n0SQ1?00I>T0l>Clk>Slk>Slk?d0k@D8m@TA1@D=0@TA1@D<n?3lh
>chgBDa3FUeDLgI[LGAYKW5VK71RJfiSJFaQIVUNHfIODeEBDeEDDE=B009I
FeX00dmACU5EE6]`K03oc<c<3/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooklc<c01HWM3_Y=OdYMO`X]7UY<oOWLG?
Nj6TFGUhDFiYIX1gRIfDP9:6GfaRDEeAC5I;ADm4C5=<CUE>C4i9A4Do@Slh
AD8iEUA8J6QLG5iAH6AFCe97?d8gATLoB4U3?chj>c/i=c/lA4Q;@TI7<SHg
@dE4B4Y9<cDb>C/h>3Pf?3`j?Slj>S/f=cHb?chiA44l>S/e@DQ1KGQ``/_8
EUmLC59B@DM7=c/j=S/g>S`g?D0i@DLmB4i4BTm9A4U3?D50?3hiEE99HUiB
EUA5EeE6BT/kBD/mAdXoBDi7EeeKVZBVa]?Ib=WQcn?/aMcTbnK]bNC]bnKa
a]kXbmoXc^3TM820BEA@?dE1?dHo0S]2>`07>d4m>T0l>Slk>d0l@44l@T<n
A4I10091@ch05D=5@3m2>cTl=C`o=TA7?T54>EEHCG5dJHJ9OXZ=Q7f0MfU/
He]MF5IHEe=DEU1ADe9CEEIGFDe?CUEFF6maL03oc<c<3/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<c01HXM;b
X=7_Xm;/YmG/YmGUWLWDR[>iNZ2QGH1lLY6;Uk:[QIZAJgabGV]RFVILBUA;
@dY3BDi8A4Do?C`g@Sdg@SheCDU0Hf5EHF5EJF]NFEaA@dHkATPmCTm7AdLo
>cXe=cLeCe5@Ce1B?Ci0?d12>S/m;c4`?Cln>3Pf>c/i?3dh=cPc=3D_?C`g
@D0k>CXdAU18OXV3a<g:Ef1OADY=?dA7=c/l>cln?3hk?D0i@4DnB4i4BDi8
@TM1>cln>cdhB4DlFEE9F5I7F5U9D551BDdnBDm3C5=<DUaKY;:eb]_Rb]kW
c^C_amo[c>C`an;]bNC_b>3Zc>3Wb=[LIW9`BE9=>d8k>3lh0Sa3?009?48n
>d4m>d0l>Slk?T0k@44l@T@o@48m@D<n0095B4402454?Ci1>3i1>413>4A7
?4Q;@TU<@dI9@094Ad002DE7@U1BDE1ADe9CEEAEEeYKGDe>D5AEEfY[K@3o
c<c<3/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooooklc<c01HY]GcXM3^X<oYYMG/Z=OYXM7OVLS@Ul;8KIFENYjLZl_8
Z<:oWk>aO8b9IGAaAE1<@TU2BTm8@d@n?C`gB4<mB44kBT<mFeM>IVILLWAY
IVYLBDdo@dDhDUA7D514?3``>cPaD4e8DU5=AdM5>c/k=3He=c/j>cln>cdj
>3Xg>CXe>3Tc=3D_>3Tc@44k@4DnDeeETIjGb=??E5iMADe??dA7?411?T91
?D8n>d0i?T<lA4Y0A4U3?T<m>3hl>cdh?S/bEU96GE]<EUM7E5E5C511CUI;
B5=;CeeMZkk2b]kWb^3]bn;`b^7abn;baMo/`mkYan;YcN;W`M?CGFUWAe1;
>D0i=S/d0SY1>P04>d4m>T0l>Slk>Slk0Sdo>P91A3d03495?TA7@4I9@TI9
@4E8?d=6?Cm2>D95?4E8@DI9@TE8@D=5@091@ch024I8Ad]=C5EGEUQJFF1R
HDi@Ce9DDfAVIOo<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoooo_c<c<03VNbnZVdo2Xeo6Rd^VMd>>Odn6Se>:R
d]bGa<Z;];Z`e]V_c]6ab/j4VIi]OXE<FUe0BDI<DDY4AD0n?CQ;AT96?cTo
>39:ACm_K6=kOG9cMFQ@E4I4ASUFF4YIFTa4@S=>ASUGCd9METaKF555AT52
A45AEEA3B4A3AD8i>cHk?3Hm@3Tg>S<c>350ACi=E4eKIV2NZZK>f=MDGUe<
E5HnATQ0ATHn@T4oA4000S]0>@0Q@4Hl@4Do>Sli=cdi>Sli@D4iGUY?IF=F
EE=4DeA4Bdm0CUI;?da5Cf9P//O<b>3Zan7^a^3abN;fb^3ea^3aa>3[b^G/
bn3S]<K6DUiJADm7?D@m?d@m=Sdf=chg>3hj>Clk008j?c/03cdo>Si0>d=6
?dE8@DA7@454?D13>T54>d=6?D95?4A7?T=6?D95?T54?D12?@02?d4l00<n
@3]8BTM;CDX00UAFD`04G5iKBde:E5ICJ6YWolc<c0k<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooono<c<`0IJ?@kJ?A
jj;Ajj7CjZ;FjjCIjj?Hj:3DhZ3AgjCBgk3JiZW=fK3=fjK0cdIKK5e]NUmY
JU5HDDa>Bd93?TQ4@D]6@T4i=T@o>EICBXB6NiFGRTmCACm3=4Q<?EYLCUQE
A5eA>ei?>V1DA6mYFeADC4A6@E9GDe]PG51BCDA7@3Tl=CDh;c4g;C@k<d9<
@e9MEEUVGj2_Z/??cEEQHE1JG3]3AD98B3]1?c]0?3Tn=cLl=CTo=CY1>S]2
>cY0?3Pm=cdm=EECAfYXFeaJCEmPDUUKCU9JCdeJDe9VIKK>d/?NilCPk/OR
mLSSn<KOmLOPm<WUlL?NiMCYk9j`/5=OFdA>ASe4?Ce2>cXo>CTn>3Hl>3Dk
=cLl>3Tn>S`n>Cdo>Si3?3m4?D=8@DI;A4E;@@02@TPn0154BT11Ace3BCln
@c`m@S]3B48oA3hh?CTl@C]0@Se@DTeIFeIHFUEMGeYCEE1>D4][KFP0olc<
c0k<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooono<c<`0FYo=ij7@jZ7Ck:3Dk9oFjj3IkJ7JkJ7Hk:;FjjCGjZcIk:WB
iZoBj:?1fDQRNdeRMFYhNeAMFTY@CSi0?D=2@4U4@DE0?4I1>d51>Fa^Hh:6
N4a@@Sm3=496=eQJC6ISD6]K@W5PA7AXDXAmJg5_Hd13?55FD69WHF9TGe=F
Cd95?3Tl<CDk<CY2=dA>ADaID4mNFJZi]/SDe5IRHT]EEca6B3i6B4A:B3m4
@3a1>cXo>3]0>Ca3?3e4?C]1?CXo>CTj<TU9?fi/H6YXFfUWFV1REEEKDD]H
DE5UI;SAe/CPjl7Qk/?Pl/GQm/KPmlORmLSTl<GPim?XkINYZDiJF45:ACe2
?3]0>CTn>3Pm=`8f?3P073Pm>CTn>S`n>C`n>CXo>3]0>Ci3?456?d97@416
?3m5>d57?DA:@4I<@T=8@D97@4A9@d56@3]0?3Tn>4A7@55DCEQKE5MJDeeP
FEEHDE5CCVY_JOo<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoooo_c<c<01bMc>JOdNZRe>fPe>bMeNbMenfOfO6P
f_:Rf_>UfO6Xeo6[eo:_eo6Tan=IN9E9HgYML7M;EeM=EEM7Bda;Bd]8A4=7
@d0o?3Dl?3A>D4EKGe4l@S@2?D<e01aBETQ[J5F3LUJ>Ne^>P6JNUhBNWY95
B45>EDiKHU]TJF=JGEA8BSli>bhe>2di?c<nB3doC4=8Ee:``;g3dM5>FUY7
DE<oBD/j@TA4CD`oAD4l@c`2>D0h01hj@CXk@S/j@3`i?SPd=c0i>c1/K61f
M6Q/JUiUIE]FFE17DTa:G5bfcmC4h^c1h_6ngO73h_O6h?W7h_O5hNo4hNW?
i^b<WZ16DU0lAD0k@3Xj?3Li>cHg?3H2=S`h00hg?CTh?SXi?SPi?SPm@S`l
@C/m@Sa1ASm2Ad11ASloAC]0ASa4BD95BT<2Ada50TA9@`0:?dA0=CXdAdY1
D5=:E5Y@DeU?FV1FEUaBDeQAJg9Zolc<c0k<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooono<c<`0F9g?j9oCjj7EkIgC
kI_EkIcEl9cHlY_GlIkGm:7Im:;ElZ_Jn:gImZO@kWRL_5moUUI/NDIEFU1K
Ge1HFUEFF4a;BDa;Achn=T94>Ci1=T16>3@j;3Y0=3Hl<4U<@feZFHUjGJ:?
Kj6ENk2[V;k0]DE<ADQAC4eFDF9WHFAUGEUICDQ6>Cdn<494=TQ>@TIBAT]J
EK30_Kg;bd=ADDQCEDA>D3Y2A3i7ASi4@3]2>cPo=cLn=SU0>CY1>STo>cLn
=cDj<bha:6EUFgQfJVQTFF=PEe=DC4A=B3m?CjO0a<;Pj/;Sl[cMl<;RmlGQ
nLGQm/?Pk/KSjm3WkhJHW4A@D3i4@Se2?SXl=`8h>SD01cLl>3Lm>CTo>cTo
>cXo>CTn>497@@02?d@n00M2Ad53B492Ad10ACi0AS`oA3e0ACh00TM<A@0<
@TM1ADY4@TM3<cPbAdY1CU56DUQ>DeU?FV1FF5mGEUeEJ79Yolc<c0k<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooono<
c<`01IkAk9gCkIcBk9_CkY_Dk`02W=Sd05nIeO6JeO>PfOJNe_6Wf_NUeo:X
e_2F`]f5ZKmjU:=JK7I<Ff9;EUYCF5]CEEAGF5=6Acm4AS/m@C=0ASXh@3<e
?C8Y<BHj?cQZJ5^5MefZVGf/Y8fe/jC3b<53C4U6D4m4CDaKH5YZJV9[Ie]G
DD=7@C5;B3MGF4YLHUIDHEZZ_KW0d<m;FEY<Ee]1C4hmAdPlAD@oAD<l@c`i
@3Ph?cLj@CTk@S/j@3`i@3Ti@3P/<RQHF4i`K6=PFDmOF51CD4U8CDTgAdJ?
Yj^ng>K2i?2mh??2iOW2h?S3goG3h?39iO3Bj?>3U9]8DeE1AdM0AD4l?S/h
>SLi>cPh?CTi?SXj@3`k@Cdk@3Xj?cU0ACln@clm@ShoA3i1AT11ASl00T15
?P0@?T<l?d@mAT]4Ada5@TM1ADY4@TM1<cPb@TPnB4i4D5E>DUM@EeiFEf5I
EV1HI6mWolc<c0k<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooono<c<`01I[@k9WAk9WAk9SAkYWEl@02WMSf0Y_Fm00c
W][fWmScXMWbXMG]Y]S_YmO]Wl[MY/?CM8ZGA5IP@e1FD5QKFEeLEUQC@TDl
ADPm>d4c>d<f>D4f>3lg;3</<3D_De=9SH5Y[Z:8[jZG]kV^`<W6CUUKB5=G
>493E5ICJVMPLf]NHUU8D4LfE4/jHee=JF]NF6ENX[FcbMWIIgMgBeIJ>TE7
?DM9>TA3?4E2>d8k>3lh>3lg008j@CT06CTo>cLm>CM1>Bdd;4A5?F1LDeYA
B5YABUA?BDi@CCe;BgB<T;cJh[kRk[kSmL;Wn/7Qn<3Om<7Nl<KRk/kTkgb=
UDUDF3m5ACi2@@03>S`i00Li?SXk@3`l@ShmA3dm@S/l@C/m@Sh00S]0?007
?T<o@4Do@4Do@DHo@dQ1@DHo@dQ10096Bd@2A4U300Y0AClf>cE0ACi5BT=?
E4eAF55CGEEHHEaGHUaTKfWoc<c<3/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooooklc<c00lV<o]V]7_V]7_V=7_V=?a
VmKdWMSfW=OeWMWeW=SdWmWaWmO^W]OZXm_/Ymc/Y]GU/=7PPYVW@5AOA59K
CeUKFf5QDE=>@D@kCE15@TPj>T8e>40e?TDm>D0i<3@c@40hN71MW9AmZZRK
^l:k/kk0C5]R@U5H=Ci3Ce5@J6=MNfmSN6QIKUm<KF1=M6UGLg1QGfYTVjj/
c]kNSYjNBEAH>TE7?4I8>491>dA1>D<k>3lh>3lg0SU0>00J=cdi=C/g<cde
=3/c=cP`Ee=:GUA;GU==G5E?F5QFDEeMI7Un_M_S^]kZ_nCd`NKi_^7g`>3e
`N3ba>3^bMo/MXN?Ae9F?454?3do>3Ph0S`n>`0:>Slk?44m?D@m?TDn?dHn
?TDn?T<o?D50?D8n?dA00Sm4?P04@DHoA4U2@TM0A4U20T=8@@0<ADY3@dQ1
?D8l?44k@4Do@dQ2CUE>D5IBD5UDEf1MFVEQIG5]olc<c0k<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooono<c<`01YW@
kY_DlI_DlYWBl9KAkiSCl@:Ke_@0<YkJmY[Fl9kHl9cFk:3IkJ;KkZ;JjjGF
ijW<h8FO/4=EHdQEGDaDEU]PG51ECd]@BE5GBe1FB4]?@D96>495?454?CLi
>493?T0m;WYgIZ>VWKk7a9^Y[3U8CcU6CSi7C4I7BF1KEgY^HX9bHX9aGH1`
FGe]E7=ZFFacK9f[[<oNhJ^j_DYGGD5?DSa7BCI0?ci7@Si5?@8l@SP07Ce3
>Ca1>SPo>3Dk=c8k=Se4?CDf<5MDBfQOEVMME6MNEfASGf=[KEe`M[oLi;OK
ikgTlkgVn;gQml3SmlKUnLKQl/SPk7B7STUDFSa1A3`m?cTk>Sdo?002>d0l
00<l@ShnACi0Ad000T17@007@4E1?dA0?dA0?T<o?44k>d0j?D8k0090ACh0
3d97@3i3?3m4?DI;A497@3e2?497@D56@TA9AE5CD55CCU=EDUUOGEaVIfQc
M@3oc<c<3/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooklc<c003VM;`V=?aVMCb00:JeO<0G9[FlY_DlI_DlJ3ImZ7J
mioHligGkj7KljCNmYkFkIO9hWbO^dmWOd1>FdQ?EEEGE5iOFE5FD4A9@TaB
B6EYFf5OD5]HAeMA@d=0=cm0>d94@DM8@TY=AX^ASKk7aUeVJdQCFC4l@Se5
B3e1@4m>BGQ`IGiaH8YjHhahGHiiFY61JXb;QiZSZ<kIgkS7cU5RJC]=DCY9
C3=2?ci8@4mEBE=GBCdo<SXn<4=6?CDj<cDk=c8f=CPj>C`o>4A6>fQVFFIS
E5mICEUFCeUMGUUXKK??f[gSl;[Tm;7NlL7Zo[cRmkcOllKSlm3Xm6EhOdIA
EcU1@ce1@3a1?CDj=S]0?3i3?ce3?ca2?Sa6?Sm6?ce4?Ca1>`<m@S`2?44k
00Dn@ce0ACm1AT11AT12Ad400TA9@`0;@TM1?d@n?D8n?d=4AdQ:E51=Ee9>
EU5=GEeKEeiVLh290?o<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooo_c<c<05ZHdo6Gd_2Gd_2Hdo6Ie?:Je_:M
e_>NeoBJdo2Me_>NeoBNeo:Qf_FSg?NLe>nFanEPQjQQO9UZNXUSJW1JG5UM
GUQ?E4hoA3i:CdQRI5UZIeIbKEYbJe]NFTm>CdY1@d8m@Si2Ad=dNWR7T8m=
EEM:DUDk@dHe>Sdg?3Q4A3aUHEEfKU^;OF>KR6ZQRVZQTGRMW9R`^L3BgnS5
e]iNLWTnDePgBD/gAT<jA3]BF4aQHeE@DD=5ACTo@SLe>S<n@clo?d4k>cdi
>cI3AS]SI5IPGTmMEd]NFE=HFE]ULWRmf>>oiO:ki_NdhOBmiofhg_>kg_;2
hO?<ho5QLge2CeDg?d4i?cdi?SXf>cLj?c/2?48n00Dj@chkA3ll@c`j@CXl
@C/013e2?005?T<m@4Do@TM1A4U3AT]50098CDL034I;AD=8@T15?ci3?cXo
@TE6BUE@CEaCCU]DCV9PHE]SKW^8V?o<c<`>c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<00ZGe?>Fdo:Ed_6E
d^nFdo2Ie_>LeoFNfONGd_2Je_82W=Sd05BPfOJQf_NMe_>JcNb:/]F5Y<5o
UZQYN7mGH5mIGUQGG5QIFeI>D4]MGUI/JUefLfAcLF9UIE]GFEI2ATE0ACm1
ASmKHU]>E50h?S`nA490AT@i?SXe=c8n?SAPGDj5OV^JSWJYVGnZVG^^XhfL
XYjdaLc3e]g6f^=/Ph/mDEPcADTgADDe?cM>DDQTI5QOGe=ADDM1@SXg>CA1
@d92@4<i=cXe=c95B3eRHeEPGDiNET]TGEMHF5YfP8W3f^Rlh?2ki?Jeh_Fm
i_bjh?Fmh?C2hO?:hNmOLG]1CU@h@48k?chj?3Tg>CHh?CTi?c/k@Cdl@Shm
@clk@S/h?cP5?44k01<n@ce0ACm2Ad56BdE9CTQ<DD];D4Y7C4I2Ad4n@cdl
@She?Se3AdQBDDaIE4iJEe9PHF=IIg9nTJ80olc<c0k<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooono<c<`02IKClYGB
lIGBlIGBlIKClYSElY_HmigHmYcGm@02WMSf05FKeo>Ke_BNf_JQf_RReoNW
doRC]mMjVJePMX5JJ6USJFMLGUeADDm:BDEDDdiVIUY^Kf5TIUQOHUUHGEU4
B4Ln@c`l@SI9CdE1Ace3B450AChi>cHf>C8h>C4c<bM:AcQmN6FGSgZ]XhZa
YH^a[9VT/k2id]VjeMc3g^N7XZ/nEE/hBE0kATPi?c]4Ad1GEdeUHUUPGEI:
BdDj?3Lk?C`k>C`e<cHh>CA<CDEVIeUYIEUVGEAWGeaUI6V9Tic5g>ZigNfk
i?Jgh_Flh_W0i?ZnhOG1h?;8gneMKgU1CU@h@48j?Sdh>SLf>3Dh>SLh?CTk
@CdnA40oAD4l@c`i@3T00Sa1>`<k@3X01Ca1>ci3?Cm4?T97@DE:A002Ada6
00a5BTA0AClk@3Xg?CTd?Se1BTMADTaEEDeFEe9FGV5CIG=lUJWoc<c<3/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
klc<c010T]7bTm;cU=?dU=?dUMCeU]GdUmKgVMKeWM[iW]_jWM[iVmSeV]Of
W=WfWm[jXm_lXm?iWLS[QJ_2EWJ3BUeSI6i_HfAVBdM8Ad51C4U4HV9HJViP
H6IJH6MOEe]J@4E1@dTo@4Hh?D<e@dLiBdm1BDdo>cdb?ShbC4do@3h_?3X[
GU]:PGaY]:nKc<J``/Jg/l_;_=kW^]cU_MkWXKo9?5EL>DaC=T55?D=3@D8m
D4e6I65JIfAME5=>@d@o>c/k0SXe>@0J?C`hDE9:IfMKLfmSKVMOJ6=PLg9g
V::/amk^^mka_nSl]n3f^Mge`^Gk_]kc_mk`aMcZFfeg?daB=Si0>S`k=SHd
>CTg>3Xg>cdj?D8n0T15@@04?D8l>d0j?D8l?D8l1Sa1>`8oA3h03T15?d97
@D=8@T15?cXo>C@j=S<o>d5>AdmEBe=FCE9GDe1KGdaSMGjL]?o<c<`>c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_
c<c<00>BdOBCd_>DdoH00iKEmP04UMCeU=?dVMGgVmSg0YgJn@1<W=WhVmSg
W=WhW]WkY=SoY]KjVLOOGhBD<DaCAE=FGf1TGUQJEDa=DTe9Gf1HGfEIEf5F
G6IMDUMC>d0j@TPlCUE5DEE6EEM9BD/mBDXj@T0aB4Hg?cd^@3h_>SPY>CXZ
BdTlR8Uk_l2b^lJn]MKK]>3[/]cX]=[U[loJ>eIQ>TeD<ci4?413?clmC4U4
HeiHIF9KEeIACTm9@T90?STm?CTj?C`hCe18GemCKfeQK6EOHUiMJFY_Tin[
`=[Y_=ob`>Wm]n7g^=cd_n7j_=oe`=ocaMo^G6ih@4eC=cm1>S`k=cLe0S`l
>P06?Cdk@48o@D=0?T<o?44k?D8l0Sm4?P07?T<m?d@n?d@n?T<m?D8l?44k
?T<m008m@S`03D15?d97@D56@3]0>S8l=350>D1@ATiFBe5GCE5GEDeLHd]V
NhFW`P3oc<c<3/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooklc<c004T=3dTM7dTm?gU=Cg0YGEn006U=CgTm?fU]Gh
UmKgVMSiV]Wj0iWHn@1AW=SjWMCkWm?hXmKaL9j^<E5L=DI=E5EJFe9GGE5E
FU9@HF9LE5aAAe=9D5YACU==ATU2?d<eDEE6IFQGL7=RHV1AEUE3CT/jB4Dd
AT<bBDLhB4Tk?Cld>C`cHFIOZk:Z^Lc:/McU[N3a[mk^]Mo_]]OVAV1]@E=M
?TU?=c/n?S`mBDI1HEaFIV=JHF5GGf5FCdm7A411?CTj>CXeCe56F5Y=I6AH
GeaEF5IGEU]QRi^X^mSX^=ka^^Cj]nCk^n7h_>3h_N3f`^7eb>;aGW9m@TmG
>413>c`n>3Ph?3/i>SXh?Cdk?d4n@48o?d4n@48m@T@o00<oA3h01T15?d56
@415?ci3?C]0>T15?`8oA3h03D56@497@D15?c]0>S<m=C51=d5AATiFBDmG
C51IETaJHdaXOXb_c@3oc<c<3/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooklc<c006T=3dTM7eT];fTm?gU=ChU=Cg
0YGEn003VMSkV=OjUmKi00:Ge_L0BiSGn9_Jnj3Loj3Joj?KoZKNnG2P]3AH
ITYNIfIYLUU?Edi3BEQ?D6EWHU9LE49>A4YDBe1CC5AECEePEDiB@e=EAfMX
F6aZFfMTDfYTE61JBV5NCD]9?4A6>dA7@416@U9MFJ6]ZkgDfZcJjZWPmJcL
l;KQm;?DiDQRLD1@GD19D3Lj?chl?DM4?f5ME6e[Gg9`Hg9cHe]KCdY6@cdi
>3Xk=EAGC5YND61REEMFDEAFEE9KHXnR/;kOl;KOlk;PmkGSn[[To;OMm;[N
m<3PmLORleibOD5>ESHn@CXk?CLg=`02>3Le00Hj>SPo?ce0@Slo@Ci2A3m7
BD@2?D8l00Hn@ce0ACm1AT10AClm@S`j?cT2@DI00T97@@0<@4Do?D8l>Sli
=3hf<D4g@U97CUI9CeE;CUMFBUQSBfMoS[7Aolc<c0k<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooono<c<`00hg>m8o@
mY7Bn002TM?f00NBe?NDe?RFe_ZBd_JEeOVHf?bGeoX00YKFn@0nU]GhU];f
Um7fZ^;oXM[eP[G:AFamGgJ4LWV3K6U`LV]bNWEiMg]jFFAN=T4iDeYBHfEJ
DU96EEM<FEaA@dDhEEI8JFMHJfQGJ69BKVQHIF9CFeU=@d@n@DM3ADm>EVAU
Xk:g]M3KZMW_Z>3iZ]cc^>7gZl[N@UMXB5IS>D18>3Tn@d52@SljD4i2L6iO
JFQDL6mJL6mMEe9<Ad=0?D0gAD/mCUE5CeE7E5M@F5iNCU]SS:>a_nCf[Mc^
0[;UnP0:/^3g]Moe]mgb`nKj`Mc]J7j;?DYC>d98>CXl>SPi0Sdl>P8k>c/0
13do?453@4=5@4A6@@=0AD401cm4@3e2?Si3?cm4@415@Cm4@456@P02@TM3
00a1AT8n@clg?3P_=Rl^>c8kBCaGGE5HFe9AEeEBGfQ:I7f5Y/Ooc<c<3/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
klc<c004S/oeT=7gTM;hTM;h0Y7CmP04Tm?gU=ChTm?gU]Kj0YOGn`1>UmOj
V=SkV=OjUMCgWMWkW]WiX=WfU<SPL9Z`M96QQiFRSI6LXZ:/Wj:WS9BGI71`
D5]GDUUAGUiBHEmCHfALEEQ??d4fDe=7HV1CJ6EFJ69DHf1AIF5EF5Q>@D<n
?DI5@di@E6=XXK:j^MGSZMO_WM?_/=kf[=;W/<_NAEQW?4QD?T9;=cPl>SXh
@T8jD4i2JfYHLg9MKViDKFaGK6QMEE9;@T@g@dXjBU=2CEE6DUM@EEiMCf1X
TZjj]^3`Zmka[^Gj[NCi[Mof]>;i]^3f_>7dbNKfJh6>@DmH<3Lm?Sm1?3Xk
>SPi>cXh0SXj>P0>?T0mATQ5BTa7BTa7@4E1?dA0?T<o?D8n?44m?D8n?dA0
@DI2?dA0@DI20d97@`0;@DI2>d0l=3Xf<Slf>dLkDeI;EUM?E5QGEf5ZBV1h
NYNg0?o<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoooo_c<c<0Y3Am`:Ad_P2T=7g0Y7Bn01QU=ChUMGiU]KjU]Kj
UmOkVMWmV=SlUmKiWmckV=?aXM[hXMKeVlORTKC:W[S9ZK_7ZkO3XZnhN8F>
BeQNFVAUG65KGEeAHV1CIfQRDeE@?3dg@T8jB4HjGUa?IV9FFEE9HEmCEEI>
@4Do?4E4@4]?C5eTVJ^e^]KT[mWa[=_e/=W_/]?VGgJ6B5QU<CY3?T=9?Ci0
=cLe?3de@D4eE5E3LgEOKfmELg5JNG=UKFILG5e=E5Q7Be90ATlnC5=;EEmN
E6M^XKk</]g^[N7fZnChZ^?gZmoe]>Cj]>7f_>;e_Mg/Pi^W=dE>>T57=cPl
?3`l>SPi?C/l>SXj=cLg>S`i@DI2AT]5A4U3?dA0?T<o?D8n?44m>d0l?44m
?dA0@DI2?dA000=1AT803497@d56@Se2?SHl>3E0>3i8?eAFBeYJDU]KFEaS
JdiPMWF>[?o<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooo_c<c<1i3Am`03TM;hTm?gU=Ch00:De?P0=9KFnYWI
oIWIoIOGnYOFmI[Gm9kInJ7Fn:SFmjG>jZW=hjk>gK?=g;;9egJ9V45BG59M
HfU]K6UYGEmPDVUZI5MIE452?D=4?4I6?5MEBEYHC5QFBUYJD5=DC4=8@Se6
AC]9C4EDFhfPYkWCh:W=hjkGkKWJkHFO[T=EHD==ET=:D3Pl?d52A3Xl>C@g
<3Tk<4=6=F]]F7AdG7agH@9gKUl07W=`Gf]^FEeRC51GAe1GCeEOH5MZLJo?
g;7NlJkUnZSRn:[TnZgQnK?Sn[KTnk7Lkl;Sm8FPZd9CFcM0ACTm@3Lg>C/i
>Sdk?3Xj>S<e=3<h=3e2?T56@3i3?@8m@Sh01Ci3?ce2?Se2?Se2?Sm4@002
@4E10T56@P90AD402cm4@3]0?3Dk=blj=3e7?UMICUmOEEeNFEmTJU=TMWF=
Y@3oc<c<3/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooklc<c0B?d?H00i3Ami7Bn9;BmP02T];f0Y?Cm`1HT];fUM?h
V=KkVMSkUmShTmC`W=chVmGjWM;jX=7iY]OhXm;/Y]GYZmKY/mS[M8jU@eEY
=T1<GF9UJVaQIFMJIVUREUQC@T@oCe18FeeBFEU=B4PlDeE8EeU>DEA;@dY3
>dI2>DE5?Da?QINK_MCL]]KS/M;QSjZe@5=JD5]O?dM9BTi?@491>cdl?D8n
<CHb?D0i@dDjGf1@MgIRP7UVOfmPO6aLMg1MMWAMLWANJ6aKGVAJEV1OFVaf
^MKV/Mkc[nKkY^3f[>Kl[n?k[n7h/N7g/=g`a>ShQj>_A5IP=T57>3`o>SXl
>CLh?3Xk>3Ph<cDd=3Te?44m?TDn?4<l>Slk?44m?T<o0T15@@8oA4001415
@D56@T56@T56@P8oA4002ci3?cXo>cDk=b`i<SU4?55DBEiNE5iOFF9WJUMW
MVj5U`3oc<c<3/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooklc<c006S/oeSLkdSLkdSm3fT=7gTM;h0Y;BmP1@Sloc
T];fTm?gT];fU=;gU]CiV=OjUmShUMScVM[hV=;hWM?oW=7mW]GlV]GcX=cd
YMgdYMG/HXBP@UMb:CA6DEILI6YPJViPCU5:C4i9>3/d>3/bCe56GEmBADLj
ATXlE5M<BU14@4Lo>4<k>4A0>DM7Nh^;^Lc@W[W0R:>ZBUeQ?Ta=?dQ5ADM4
?SljB4U4>C/j?D50;S8a=c`h?3lhBd]1KVaOPW][RWMXR7ETPgMQOWQPNGMP
LW=QKVmWIFi]K7f7^]OW[mca[N?kY^3h[>Kn/>Cl[^3gZMW`^NKi^n3bOifX
>4aE>DA:<3Dh@4530SXj>P09=cTh=CLf=3Te=c`h=chg=Sdf>Chj>d0l?T<o
00I0AD42@DI20d15@@0:?44m=S`h=40l>D@nBTe4G5aBHV=KJFm]FV]cHgV7
olc<c0k<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooono<c<`0C8k?mHg>m8k>m8o?mI7Ami;Bn9;BmY7AmHk>lY?CmiKD
nIGCn9CCmYGDmiSGnYSInI?HmIGGmicGoi_AoicDoiODoiOLoIKNmiSKmIK?
jU=jVcE>KBDaBCY1BdM>ATeCADE8@DU;AT13?3Hi<454>E]ODD]?@D=7>5=G
BDM=@D18?Ce9?d5>Aca;AW1oO:Zm^e9WJ41DDce=BTiIDdM<ADA5?DQ8@411
>ci0?CPl>c0f=Rdc<cHh=CLh<eAABWY`IXmiJiEoJY>3K8^1J89mIgelJWin
MW^1PI:PZkoJjk3Jl:oSn`:Zh_/05JgOn;3Pmj[Llk7Pl[;IjU=aO3]?F2hi
?c<h>cXk?C`l?3Xj>SPj>CXl>cPm>CDk=c<j<c@k=3Xo>c]0?3e2?P02?T<o
00<oA410AD51AT800d56@P90AD402ci3?cXo>c@j>3I2@3U5@DE;@EYLCf9T
FFY`K5i]M61dO`3oc<c<3/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooklc<c01QSm3hS/oeSLkfSloeTM7gT];hTM7g
T=3dS/kdTm?gV=KkUmGjU=;gUMCgV=KkVMWlT=GdT]OfY=ooTlciWMOoU]Go
VnCoRmKeSMOdW=_jHi6c?Uel=dMN?TM@C5=<F5Y=HEiGEU5;GeaCJFMJG5e=
FU];CDhnDEA3EeU;CE15BDm5CEA=DU]FAe9>JgMcWZfX?Da7@U5<D5]C@4Lo
@dDjADDiB4Pn@D4i?d4l=3Te>T10<CLg>Cdl<38_>S/fJ65GRgYXTGaWTH5Z
THI`UHejUI65TI2<QXjA[l7?`^7c[mcc/NGm[NGnYmohZM_d/>3g[Mof/^7e
UKc=?5YU;T9;=d98;34d<S@c>c/k=cLg>3Xi?D8n?TA0>T0l>D0i?4<l>D0i
00<k@3`013a1?Ci3?d56@T=8A092Ad<03T56@Sm4@3i3?c]0?3Dj=Rle<b`j
>SI2?TE:@eQJCeiNE6I[Iei[Lf5cOoo<c<`>c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<00B9c?J:c_F<coV?
d?P2T]7j00ZCdOZCdORAcoRBd?NCdOREdoZFe_bFe_ZEeO^CeOP2U=Kh00FG
e_VIeOVJe_ZHeoZEfO`00YCJo019U=CgQkcL@FV3>E=RB5EKHfIOHEY@LV5J
VhR1WHf0WI1oXIV4Qh5[F5<mDe0mFUI:FeM>H5aIEeIDFUaKEUYKKgEe_<G2
>T@l@de4@TM0?d8iATPmB4Pn@d0i?clg>CPc=CH`>C/h:c0/>3hj=3Xf;SLb
>chcNgIPUhebU8UcWY>1X9J<YJ2LZZ^`Y;2l_m[[]Mkb[N7gZ>;hZ>;jZ>3g
[=od[]kd[^3g]>;iW<?D=U=Q<DE>=3m5;C8e;Bl^>CTi>CTg>C/h=c`h=cdi
=d4i>48j>D<k=T0h>T4j008l@c`01C]1?Ca2?Sm5@d98AT55A002@dM600e0
A4=1@d10@Slk?CPb>3H^?3`hA498CDMEEDeNFeIPHV5OJG=NKWd0olc<c0k<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ono<c<`01XW>mh[?n8c?nHg@nXo@n93?n0:AcoP2T]3i02jCdORDe?ZFe_bF
e_bDeO^Ce?ZEe_bEeoZFe_VGe_FIe_FGe_FFf?ZDf?f:coJGf?j>bNUfY;aK
NhYYNX5VJfM]IV1cHEf1KVN=OG2/WhjSVhJ=RG1SGTQGDSiMEdUQFU1ZIF5U
HF1PH61FFUUTJVS0bLA8CDI<DTQ=D4M7BT57Ace6ASa6@ca8ACh2?Shf02PW
:28[;BPk@S/[=2le@3X]=b`j?2JDTWVESW^DS7ne[JZe/kJ`^<>ic=fgf^j_
gOBXh?NUhOVWhOVYhOR]h?F`h?J`h?Ndh_VNa=LhEF<`A4dc?T8^<cH`<S4i
>CLi>cPk?CXk@Cdl@c`i@c/f@CTe@3Pg@CPh@ST2?4<l01@l@Shm@cloAD=1
AdE3AdI4B4M3AdI1ADA2A451@d0k?CP`=S8W=CDc?ce8BdAIETeTGeUVIVIT
KGITLWooc<c<3/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooklc<c004RLkgR/ohRlkhS<oi0Xk?n@:>cOH2Tm7j00ZC
d_^DdobEeO^DeO^Ce?ZBdoVCeojEe_bFe_ZFe_T2U]Gf04ZDe_VBe_^?e?fJ
fonGdOJEa^AfVJekTIa]MW]jO7^2OW]jMFn2P7BQXY:FUhEeN6=JG4MOGTYN
GD]JF4UQGe=TI5aUJ65LHeaEH5Zka/1:DDU9CTM?DTUCETeBDTY=CDE;B3m6
@cXo?3De=Be3A3`d=c0a=S0Z<BXK9Ad^=R/e>2M7AS:4PW>UYI^a/k;3c=?3
eN>ge>Jcg?:/g_NXh?^UhO^Wh?^YhOZ]hON_hOR`goVfhoZTbM`mFVPaADhc
?T8b=cXf>3Lj>SPi>cPk?CXk@CdmA3dkACdi@c/g@CT2>d8j0Sa3?004?D<o
?TA0@4A3@4A30T=7AP0>@TI5@DE4@dE2@48o>C/f;S@`;CTe=D8iADTkEUA7
I61DIfQRIg5cK7^2olc<c0k<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooono<c<`2RLkg0X_>n0:=c_P2S/gf00BCdOZB
dOZBdOZCd_/2TmCj03fBdoV?doZBeOnBeOnDeOfEeOVFeOREeORDe?ZAeObC
e_n@dofLeonFbn^D_=FB[l6GZKFT/KNR/;6N[JZP[:RV/jZHY9YRKEmAF4Qa
MFASI59THe5[K5aYJeiMHeUBGEE9F574dLY?ETm2Ad16BD1DEdiKFe=JFU9G
E4]<BD1:Aci5@S/j>S90@CU2AChc>34b>C4`=R`h>Rdd=RUDFU2S[:W4d]Fg
bmK1g^jbe^bbh?Z^hOjYh?h00ZOPo@0[Z>3kZ^3h[>3h/=oi^N?kZ/gQAF5_
<dE?<Se1=SXk>cdl?3`j>c/i>3Xg>3di>T4j>T@l>dDm>T@l?4<k>d8j>d8k
?4<l?D<o?TA0?d=2?T91@TI5@4A3?d=2@4A3@TA1?d4n=cTd;C<_=40l?DQ2
C4i3GE]>K6QMJfaVJ75fL7j70?o<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<0XS=mP04RLkgR/ohRlkh
S<oi0Xo@nP>BdOX0Ei7BnY;Cni;CnhoCnXoBo8kCoHoDoY;CoI?BniGCn9CD
n9CDnY;FoI;Eohc?nYgLoiK>ljGDlZ;7hJ_:gZo;fJ[;e;3Ae[3?e;KBeXVQ
YEU[JdA?BFA/HGYlKWEfI7AeIF]]GeiVFeMTFdaLFL7@cE=MED=8@D54?De@
BEQHD5mOEfERFF9OEVAQF5MDBdA1>4A4>T52>SXm=3e0=cTl=CPk=3@i=EiX
IiBVZ[gEgkgNkJO@i;?QnjgPoJ[OojSOoZOPoZKOoJKOo:OOnZWOnJgLm[OO
n:o?i4]UM3=6CC4l@3Lk?3dm?Chm>c/l=cPj=cHk=cLm>CY0?3]2>ca3?3a3
>ca4>@02>d8j01@m@S`n@cdn@cln@cm2ATE0A4<oA410AD53AD8o@Chh>SLa
=C@e?d52BTeDDe5XHemhLg1aL7EYLX5cPYGoc<c<3/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<c0:7c?D01XS=
mXW>mh_>n8c?nI3Ani7Bo0:@dOT01Xo@n93AnI7BnY7BnXoCnXgBn`:;d_h0
DXoBoI7BnY?CnI?Cmi?DnY7Eo9?Foi7DoiSHoi?An9[@lZ?Bl:7;i:;;hJ?B
i:3Ah9g;fkKLkeimSd]QKc50Ac]4@fi_Ig1aHg5bHV9TEUUQEUMSGeATI;O7
adQAC497@4A7@4e@BEEECEYJDVAQF6UVGFi/H5eKCf9PE5UFCD];@E9DBD53
>4M8@T53@STn@TmNHj[3b[3DhZWDiK[/oioElJGLnjGKoJOLoZOLo:KMo:ON
o:KOnZSNn:_IlkGNm;7BiE1ZNCE6CS4j?cLk?3/k>Cdl>3`m>3`l>S/m>STn
>STo>cY1>S]2>Se4?3e5>Sa3>c]2>P8m@S`04Si3?cm4@4=7AT55A415@D97
@d=5@Si0?CTk>3Di>3Q0@dE:CU5@CV9MFWA^KVm^M6aeQWn@Y?o<c<`>c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_
c<c<0XC;m@:7c?H01HW>n8[?nHg@nXkAnhg@nP03S<oi00B=dOR>d_V>d_V<
dOX2Rm;n05N>dObAd_ZBd_RBd_JAd_R?doZ@doj?e?jAe?nDeOfEdOJTg?fR
e?FTfOROfoNHeO6HcnjYeoUENI]3G7X]?54^=Cln?SiJEdi/JUeJFTi@Dda<
EEAHIFf/^KlkA450ACm5B45<CdQGEdmIFE5NFe9THUIUHEITH5EEDDIbKV=i
Mf]kNFedLVI@CdYADE<m@DY7FF>Xa]6dgo2YgO:Rg?BRg_ZSfobVfofYfob[
g?f[g_fXg_ZWgoZWgOF/f_:ggOBge^YIL7hlBU<c?44i?Chk>cTl>cLl?CPm
?C/l?S/j?c/l@Ce1AT14BD8oA3e0AS`oA3dn@c`l@C/m@Sa0AD53B4A2Ad<0
0d56@P0<@48o>cdj=cTf=S/g@4I4Be1<E558H5aCLFaVJV]]JgN3QYVZolc<
c0k<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooono<c<`2Q<_e0XK;m@05QlcfRLkhR/ohRm3iS<oi00>;c_P018c@mhgA
n8gAn8cAnP:<dol0CXkCo8kBnI3Ami7AmI3AmhkBmi3CoHkCo9GJoi?HoiGF
o9SFniC@m9GDmI?HnIKLoZ;PoigBo6bF`49NPbm0G3@kCCPg?4E2?Di:?dU7
>eeNF6=YJF5ZLhVCW3m5AD97@D12?DE8@EIGCeeMEEmLDfAREUaHCEQDBF5M
DG5]HG=_I8B0MFeYGUQED5ECF51DH4IHIZc=g;3OlIgGkJ;RoJ7QoJKOoJ_M
o[3Nok7Nok7NoJcNnJSNn:SLm:oLlk[Nm;gJk5mfQ45?F3Q0@ci0?cdm>c/j
=S/l=c/k>CTk>3Tn>Sm4@4U>B55FC`91Acd02456?cm4?Ce2?3i3?D97@dI;
Ad56@T15@@8oA40033do?3Li=S@f<c@i=DA9@eEHCf1NDFiZGWaiL6a`KfEf
P7nDYOo<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoooo_c<c<0XC;m`03Q/giQlkjQlkh00>7c_P2S=7k18cAnP06
S]7kSM;kR]7kRm?kS]?jT=Ci0i?En003TMGjS];gT=Gl00:AfOl06Y7FoI7E
nYGGnYCHni7Lo97KoYOHoigFoh:]f2E5K3e@KRhfBC`m@T8m>EM@AUEAAEAD
C6AVIGIkPF1WKCY0@497@DU;AT95?U1ABEEEC@9OG5<0;UaHCE9>@fQTF7=_
HhAnLX9lL7A^HUYECeABEe=GHd=EHj_<gK?SmjKPn:3Pnj7NnjONoJoPokKQ
okKOoK?Ln;3Lmj_MmZcLlkOOn;_Nm<KSmFQnRcm<E3m7BSi0?chn?3dl>3Lh
<c`l>S`n>ce2?Si3?dA9@e]PFDa?AT=6>ci1>454>dE8@DA7@092A3l044E7
A453@412?d12?cPm>C4f<S@i=Ce2?4Q=AUAGC6UWFWMdIGMgKG9hMV1bOXfW
^?o<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoooo_c<c<0XC;m`03QLchQ/giQlkh00F7c_P2R/oh00V;d?V<dOZ=
d?Z<dOZ:d_Z:d_R<d_J>d_N>d_D00Y3Bm@13S];eS];gSmGiT]SlT=WlSmOm
SmSkT=WlTM[mTMgmRmKfTmOlW=SmT<3X@FF9<d]W;S];<SDjCTe8JfMLJ6AH
LVmVKFiYJ6a]Ri2CBdm>@4E1?T0k?T4jCe1:CTm7E5A:FUM>E515F5A9M71T
Mg=WOWQ/NWAXKfUMFUE?D4]ADEEPB5YX[/gO[mkbX][cY^;nZ^KoYmgi[mkj
]=_h/mSc]=Wc]Mog^>Kn_>Wo`NOnaNGjdNcmKXBA@4eE>D54?3hm?Shl@d8n
?Slj0090@Sl03Si3?ce2?T56@5MLEEQKDTiAAT=6?D13>T95?T=6?d=5@494
?dA6@d53@090@Sl033Ll>30e<C@i=Ce2?TY?BEIID6YXG7EaIW5bK6]eMV5f
Qi>_aOo<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoooo_c<c<00>3b_J4boN3c?L00XC=n007QLkiQ/ojQm3kQ<gf
QLkgQlkhRM3j00><dO/00hcAnXgBnHcBmP02SM7f0hc@m@05SM7fSm?fSmGg
T=KhTMOi00>?f?/0;8oJnXoJmh_El9CIn9OFmJ?EmWNP_4]ZOdIJIE9MGfmd
KWQjKg=dIWYjKW1aJFU^J9RMVC/m>T12?d94?c`o>4]<ATi?Ae=CBDm?ADY8
?5=AAFeYGVm[H7IbIgUeJVaUFe=>B5=>DTa?F4ADHJS5eJkHkZOKljWQo:KN
nJgOn[GQn[cQn`:mhOT03[kTnkgWokgWol;Vo/?Sn=3[o7B8TdAAEcU1@cm3
@Sm1?T=4?d11?4A6@`90AD406ci3?d97@EMLEF1SF5UKCTa>@d=4?3m2>d54
?D12?Cdo>TA6@d94@D53@412?cLl>34f<SHk=d56@TmCDUUKF6aYI7=`Jfa^
KFE_N6J0Ui^mf@3oc<c<3/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooklc<c0:3b_H2P/_f00R3c?N4coV5d?Z6dO^4
cOJ6coR8coV:dO/2SM;l00F<dO^<dOZ?doZ?doR>d_L00hgAn0:>d_T0H93D
nHoCmXoCmXoEmi7GnHoHnHoHnhoHnHoImY7Km9OMmiCDkj;KmZ?CjWfR]FR4
T7R;TH:@T7n9PH>8PGUoMFebJf1WGe1ECd94@D=5@T=5@3i0>e9CCEUJDUiN
EUYJD4]8?eUGBfaZGVaXGGEaIWeiKVYVGE9=AeMEETmBEdaJIJ[4dk?GkJgK
mJkPnjKIm;GSoKcVo/7Wo<7Unl3Tn[kTnk_So;SPnL3To;gMl/_UmWV=V4YG
GCe5Ad96ACdo?493?T12?D=8A456@T15@Cm4@497@EEJDf1REemQE5IHCDY<
@D95?413?3i0>cXl=dA6@d94@D53@3i0?CHk=c<h=3a1?DQ=BDmCDUYLFFYY
I6i]J6EYJUe[M6Z9WZ76h@G<c<`400000lc<c0D00002c<c<0`0000?<c<`5
0000klc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooooklc<c0B2boP05X;=mh?>n8C?nH?@nXC?nHG@nXO@nHSAnX[AnhW@
nX_@nX_>n93AnI3Amho@n8g@nXkAo8kCoI3CoY3CoI7BnY7Bn0:AdoH0EY7E
n97GnI7GnI3Fn9?Jn9GLn9CImYKIm9WGl:OOmYc;gh2W^8NU/7fDW8FFWHRF
Ugn;RgR3OeaWHcM0>dM9ASPh=T52?F1QG821Nfa]IE=DC4I8?DQ8?UaLDVa/
HVYWGVQUG6i[HUiKE55>BEUIEeUNHF1]M[C9f[[JlK7HmKKRokOTokOSo;[T
n[_Qm;SNlKSNlk[Pmk_So;gRo<3To<;Rmm7[o8VMZ4aKH3]5ASi4@3Xo>DA6
@D=5@4A9@d17@3i4@3a2?Sa1>daABUeODV5SEEiPDe9DBDI7?d52?3m1?3i0
>d=5@T12?cdo?3Tk>3<h=3Dj=T56@TiCCdaCC5MLE@9YJf0015iXGeM[JVjB
WYo:f`C<c<`200000/c<c08000000lc<c00000000002c<c<0P0000;<c<`3
00000/c<c0800002c<c<0P000>o<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooono<c<`3P/_h00>1boR2cON2cOL00X7>
n004PlkhQ<oiQ/ohQ/oh0XO>n01ZRLkhRLcfS/gfS/gfS/oiS<ojSM3mSM7o
Sm7oSm;oT=3lTM;jT];hT];fTM?fT=CgTMGhT]KiUMWlT=CgS]?dV]onU]Wd
V=SaX][cTl?JQk36MiN/SjRlQIRWPYBNJWV0?diA@4a<B4a;>3Pf=SLbAdQ3
HfANFU]ECe18BDY2AdLmEUI<HF5GHf=IIV=LJfQQFEI?De9=GEmJFfASGV]c
[L3A`=cd^]_j]mkm^^?o]n7j^N?i^^?e^N?c^N;f^N;h^>3i^=gg^moganSk
e_7oV[2kCEaQ>dE6@4I2@dQ2@dE0@4Do@DQ1?TDn?dE1?D<o?44kBDi7FE]>
GV1BGV1CE5I9B4U1@D8j@48m@T@o@48o?Cll>S`i=SPe<cPd=c`h@dQ4CeA@
DEMCG65KK6iSJ6]PH6]SGG=aNZ2YW/kL1<c<c0800002c<c<0P000003c<c<
0000000000;<c<`2000000C<c<`00000003<c<`2000000?<c<`000000000
0/c<c080003_c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoooo_c<c<0X7:m`:1boP018;<nH3=nH3=mgo<mP:1c_P04X?>
n8G>nHK=mhO>n8W>n8[=mhg<mHk<mHk=nHc?o8g?ohc@ohgAohk@oho?oI7@
ni?AnY?An0:AdOD0?Y?En9GFo9CDohkAoXoBo9GKoiOMoi3EmYWHnIgEn9k>
lYo7jk7BmJo:j:_1fF5fRCa@Fci=DSXn?cln>Sho>STj=DQ9@dU:A4M8@411
>DQ9@E9CBeYKDfMXH6e/Ig9aK5iMF65RG6I[IEeWIUASJYf``L?KmL;OokKI
nK?JnKCNmkOTnKgXnKkYnKkYo;cUnkKNn;;Gl[OKllGVnLoZnj6g`T]JGcm;
Bd98A4M<AT97@3m4?D58@Ci5?P91Ad<06Se4?DQ=AUIHBe]LCUiPDe]MD51A
BDE6?T52?D93?Sm1?S`n>cTk>3Li=SHk=c]0?4E:ATiBDEUNHV=XJg1bKfI[
If=_KFAlP8>]^j3@i0S<c<`200000/c<c08000001<c<c00000000<c<c080
00000lc<c00000000002c<c<0P000003c<c<000000000>o<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooono<c<`2P<[g
00J1boR2c?V0cOUoc?Qoc?J0boD2Plkh01:4coV5c_V7c_R8coV;d?Z=d?^=
c?N>cOR>c_Z=d?f>d?n=dOn>d?n=con?cofAd?^Cd_^Bd_P2T=3d02bBe?NE
e_jBeOnEf?nDfOn9c_FDf_j>e?J>d?>IeobJcoNVe_jOa^f`d_N`cN]EKhIL
MXM5EV1CEeY>CDU7AT8o?SU:BT96ASi5ACe1@SXl?CM=CTQJGEIYJVAVIf9T
HeiEE4mVIf5]LVaXLG1LJG:M[/33foG0gO^deoFih?fcgoRdh_T2]^?h02bg
i?^hi?fih_jfh?VggoRohoVog_2N]/99F5e5Ce0oAD50ACi8CDI3Bd12C4<n
B3m0BT91B44j@CU2B3iHFTmLGU5SIEYVJ5eNH5E>CdM4ACm1@Sa0@Sdn@3dj
?c/i?SXk@3a0AD57C4Q=DE1KH6=UJFa`L79RIVUSKWAVOXZ8/L>Lcn@8c<c<
0P0000?<c<`4000000C<c<`00000003<c<`200000lc<c0@0003_c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<
00Ukb?AlbOEmb_Imb_J0b_N1boR2cON5c_V4cOP00X?<m`07QLchQlkhQlkh
Q/ggQlcfR<_fRLcg00>:cOP01h_>nHo?ni;BoY7Bo9;Cni7Bn93Am`02Sm3f
04f@e?NBe_^>doZ=eO^@e_ZAeoVCf?VDfORFf?RGf?RIeONKdoBPd_>We?>Z
d^bN`MN5XKIcQYATIfaNFUMQG5Q^JV5_Jf1@C459ASe4A3a6Ad97BDI@E5=I
GEa[KFYJFeIFETiLGEE[K6MWK6mIHfnEY[[0f?Bmg?Vig_RkiOfehoZchoZe
h_ndhonbhOn_g_b]g?R^gONgjOndh_[7k?nU_la>GFA<E5I0ACm;CTE6C412
CCm1CCm0CSm2CT13CT16C417BT5BEDiKGUMQHUYLGU=WIe]PH5A2@SQ2@c]5
B450AClnA4000S@j>00;@TQ6BDm=DUMCHfIOJ6UTJVQ[JVYdGfQiKhFJV<7G
X=;Y00S<c<`2000000?<c<`0003<c<`00/c<c0@00003c<c<0`0000?<c<`2
0000klc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooooklc<c09ncOP02X3=nGo<n87;n87;n8?<mhC=n8O>nXK=nHG<n8K=
n@B6cOL2R/oi05V<coZ;c_V=c_R>coV@dO^Ad_b@dOVAd_ZAd_R@dON=dOJ>
d_N@e?NBe_VAeo^@e_Z?doJ?e?FBe?BEf?FHf_ZKg?ZIf_ZKf?NMe_BTeoJ[
fO>Zd^^O`]RJ/L6JXJNFUI>HUI2IUHb;QgaSGeADDDQ4A3a1@Cm:C4]@E5EC
EeQOHEiGFEAGFDiPHUMWJ6=UJFaGH6nBX[Vle_6ff?Bbf_>chOR`h?J]goR^
gon_gon^h?n[gOjZgOR/h?RXg_Rch_bmhONK]LA8EEi?E5M6B4=4Aci2B3a0
Bc/oCCi2D455DD=5D496C415B3mDFE=LGUUUIV1XJ5i]JemZJ5]HETY9Bci0
@cXm@S]1Ad<00SU2?`0;@T]8Ade;DEI@IfYOJfaTKF]^JVahHfj2MHnXVLGN
XMC_00S<c<`200000/c<c0@000000lc<c00000000003c<c<0P000003c<c<
000000000080003`c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooo_c<c<00AjboQkc?UmboUmb_P2OlWf00B1b_N2boR4
cOZ4cOX2QLch00Z3c?N4cOR6coZ7d?^:dOf9d?b:coV;d?Z<coZ=d?/2Sm3j
0Xo@n0:@dOT2S];g02f?doR@e?VEe_jDeO^CdoNCdoJEeORHfOVLg?nNgonK
fojJfo^Je_RNeOBUe_BZf?:[dnb]c=jP[KJJWZ6LW9ZNWIRBShI`KFASH5M>
CTI2@ci=Cdi:CTe=DE1IFeQQI5eNGeMQHUYUJ65UJf]HI72DY[ZkfO>ffoJ`
g?FahoZ[goFXg_RXgOd00ZWMo`0[YmclY]cfYmgeZMcg]^;k^=_aU:^kC5IP
Ce9GB4Q6@d@nAdY1A4`o@De1@U13AE55AU15ADe2@dQ1DEI@FUeFI6EMJf]O
JFMJJFMHIF=FCDe1AdQ0?T<l?TA0>44l>d4mAD]7CeA@GF9KJFaQKFiVK6a^
If]gI7>8O9ZdVl[VW=Gb00S<c<`20000olc<c0C<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooono<c<`02gO8mGS9mW[8
mW_9mgc9mgo9mX;;n8?<nH39mX7:mh;;n002P/_f00Z3c?N6coZ8dOb8dOb7
c_Z6cOV9c_R;d?Z=d?^<coX2SLkh00B>coN?d?R@dOV?doX2Sm?h00NAd_ZC
d_^Fe?fJeOfMfOjOfonNgOl00YgMo`1@V]coV]cnV][mV]KhW]GdX]GbY]G_
[M7W[/7?V:>YRI6CQXZ9O7egI6ALIfAMFe]CEUEAH61NE5ICDUMCE5IAG5mH
DU=;DeI=G65JGVMVE69[SZ>f]MG^[mWbZ][aZ=kfZ>3gYMkiY=cmYMgoY=co
X][kXM[eXmWa[]gg/=Sa^=O/QYVZDUYUCU5FB4Q8B4U4D5=<BE56@Ti4@4e3
@di6ADm7ATe6ADY4D5E?IFQQJV]SKViRKVYNK6UJKVaMFea>D597@4Hl?4<l
=T0h?D<oBU5:EeaFJfiWKFmTKVmWJfa`HVYgJ7Z@PjG1V<g/VMKe2<c<c080
003oc<c<1<c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooklc<c009MlWhN<[iN/_jO<[hOL[hO/_iP/ckPlglPL_j00:2
c?T04H7;n83:mh7;n8C>nhK@oHG?o8G>nHC=n8O>nXW@o8cAnhg@nhc?nXg=
nHg>n8k?nI3An@02TM;j05Z>d_V@dOVBco^FdOfLeOnOfOnQfonPg?nMfonJ
g?nFf_nHg?nKg?nJf_fLf?ZQf_RVfoZ]fO;1g_2U^LB;VZ5iQ8IVK6Y?DDaP
GeYYJF5PGeYWJ69KGEQIFeIEEe9HFUE@DdaGFU5NHeaRJfQHIVn?Y[RceNj[
eo:Rf?2QgOFShOZNg_ZOfofPg?nQfonOf_ZNf_BRf?2/f?6Xb^>id^Q^OXiC
FVACE5U>C4e>CDUADTa;D4U3CDE1C4A2CDM4CDQ5BdM5BTI:CdU[KVE[KF9Z
Jee`KEi/JEQ^KE]ZJe]FF4]5BclnACdl@c]3B49@EDiKGUMYK6=cLfMaLVY/
L7=SKg]]QIf:/lnIdO:GfO_oc<c<3/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooooklc<c09hb_T01W[;nWW:nG_9nGc9
mgo9n83:n@>4c_d01H;<nH7;n87;n87;n8;<n@02Plgj00J4c_^7d?^9d_f;
d_j=dOj=d?/2SLgi05j>coV?d?Z@dO^@dOV>d_V>coVDco^FcobHdObJe?bK
eO^Lf?fJf?fHf_fDf?fEf_nFf_nFf?^HeoZNf_bTgO^[gORaenbYa]JG[[ao
TYUWLWA4BTQADdiTI5aZJV9[Jf=NGeUKGUMSIF1XJVELGUUIG5EVK69[M6mO
L7NC[Kjdf?:ZfOFQfO:OgOJMgoVJfoVHf?^KfOjOfonOf_ZNf_:UfNndf_6a
cN>dbMYMJgQCEf1HEeaGEUA>CDQ;C4I7C4E4CTI2CDM3CTY2CDU3C4U4BTI3
B49UJ5mZJV1WIEQ_K5e[J5MZIeIaLV1UIeUCEdU5Bd4j@CU0ACi@ETaMH5M/
KV=gMFUcLf]^LgIVMX=eTj^?_]bDdoBDf_coc<c<3/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<c004MLWhM/[i
MlWiMlSg0WW7m`04NlOhO<SiPlgnP/ck0X7;nP0:OlcjO/_iO/_iOL[hOlcj
PLkjPm3lQ]3mR=7nRM3l0Xc@o@14S<ojRlkiSLgiS/oiSm3jT=7kSm3jSlki
T/okU<okU<oiUM3hU];gU]GhU]KjU]SkT]KkT]SlTMKmT=CiU=ChV]WjX=_k
Y=WhZMOa/MO/XL3DP9ZWJGZ2@de?@4A3BT]5JVYRM7AZL75YIfQPL7=/K6iY
FeeHBTa7I6MNJ75/FfacSZRi[M;/XM;`Um?_UMKbVmkkUmWiU]KjVMOlW]Sm
X=WgX=S_Y]KZ]mO///WKTjFcEf5ZDUEJDE5AEeIBCdm7Bda4Bdi7B4m8ADi9
0T9=B@0JA4e:Ade9Ada5G5mDKFeQKVaMKfaKKfaIK6UFM7=QLG9TH6AFCeE9
?D<i@4<jDeI=I6EMMGE[N7AYLg=[LGUlKX:=Oj>iULSUT=;dTM[molc<c0k<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ono<c<`057C8mgG9n7O9nGO9nGW:nGc:nWk:nh3<oGk8nGg7n7c6mGg7mWg:
n7k;nGg:n7c9mgc:n7k<nX;?nh?@o0:5c_/018W=nX_?o8g@oH_>n@:=cOT2
Sm3j00J>coV=c_R@coZBd?VCdORDd_L2UMCg00>EeORBe_V@e?L00Y3FnP1=
T]KkVMWmW]gnYMgoY=_jZ=_j[mggSkS>IhJHFW1m@DiF>T94?T0m@T<kJVYP
PXAiLWAYLGA[IfYSGf5NDeE@HfALJW1/GFacSJJj[=7/XMCcVMCbUmSfW=kn
V=[lU]KjV]KkW]KiX=GdX=CZYm;S[/WJXK?1IWAmDEYOCE5@@T<nDe19DU98
De=9D5=:Be9:ADm7@DY5@Da6ATm:BE=;Ada5CU56JF]NKVaMIfACKFQEIV=@
IfIDKVmOIFUJG5mDBDm3BDa3FUeBJ6YOMgM[NgM/M7E_MH22M8nJQk77V]7_
T=CgTM_o0?o<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooo_c<c<0W;6m@04M<KfM/ShN<SiNLWj0W_9n@=obo`0
0gk:ngg:n7c9m`02N/Oe01Alb_QmboV0cO^1c_b2boR1b_N6b_V:c_^;c_^<
cob@d?bBd_jCdonBd_j@dO^>coV>d_V<d?N?dOBEeoT2Vmcl05:Ff?RBeoJ?
doJAeoVEfObHf_fIf?^KeoVPe_ZRf?ZIdO:Sf_V?_=U6JX9@JghiBeLe?T<i
?Ca0@ca4AS]JG55jO761PWY]KVQIFEMFEe9SHeU[L6Y=FV>F[l>Ub^NLc^nM
f?ZFe_VEeoVGeo^NfOnHcoJPd_FNcNVKb=fTb=J`a]=RLGQEH6A@FEQ=D4UE
Eda8ASY<CCmGEd]@E4I9CdE4Bd<nB3lmAcm2CDE:E4]5BT=IG5=XJUe_KEia
KUe]JUMYIU=WIUA/KEeVJU]MH5EHGU9OHUMUJ5eaLfR0P7B=RH25Qh9mS8n5
XjjA_mJBcN^?doJAfoooc<c<3/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooklc<c09fb_T2N<[j00AibOYjb_]lb_Yl
b_X2OLWj0Wc8n@0?O<WgOL[hO/_iOlcjP<gkOlcjP<gkPlglPlciPl[hQl_j
RlonRlkkS<olT=3l00>AdOd0FY3Anhg@nXkCnXcBmXgCmI?HnIWKniWLnIKI
mYGGmiCInYGIo9OIo9SHo9[FnY[EmikDn9oEnJ;Noi[FnY73i3AMND5OMcI;
G3Q5CSDm?d15?cm2>DM9?UUKD6Y[Hfi]J6IUHEiMFG5^IfQZIe5NIh^T^ZS<
k:7CmYcHo9OGni;DmiGCn9W@mig>mYo<kIc4gZC9fkCBg6ioQdE>DdUBDDeD
CDa?A59DATE6=TI7=e5D@e1BA4e@ADU?ADA<@D1:@D9>A4UCBSi5?DY@AUeO
DVY[GFi]FfeZEfYWEVIUDfIWFFEYFf1SF5UODeePEF9UFVi^I7]kLHn<QhN;
S8:FWHfa_iS<hY;ClHgCmHkHoOo<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<0WG9n004M/ShMlWiN<Wh
N/Sh0Wc8n@0;PLgnOl_lOL[hNlSfN/OeNlSfOL[hO/_iPLklPL_jPL_h00:4
cOX01hG<nXS<nH_>nhg=nho?oI3@o97Ao@02Sm3j05Z>dO^>dob=eOf;eOZ?
eOVCf?VGfOVGf_NFfOJFf?RGg?fFfobGfObIeobLe_^Ne_VPe?VNe?RMgOnC
doVIcoE6Li@hFWHhDFLfAU<d?d<nA48oA3do@SM5AcaKFe=`KFQ/J6ELF5E/
JF9PHV5IIG6;Xk^Zd?BQd_ZEd?R?d?JAdONIeOZKd?RTd_J3Z/UGMhi7I796
GF=9EeY1BTU:D4a<DTQ=DD9AE45@DCmADT1<Cca=D3m>DTA;DDE7CdA1Bd12
CT96D4M5C4A8CDILGU=_Kf=bL65_KUa/JU]UHeAQHUAWJeeXJf1SJEmWJV5]
L6EjNW26QH26QXJ6SiJ8XjjE`=6KennBeoJ9d_F;eO[oc<c<3/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<c00;
LLGdL/KeLlGeMLGfNLOgN/ShO<SiOLWjPLgnP<cmOL[h00=kb?H037c9mgg:
n8;<nh79nH39mXC;nHG<nXS<nhW<nH_>nhk>o93@o0:AdOd02Ho@nXk?nHkA
nhoDoHgDoX_Eo8oDni;FnICFn002TmGe056EeoNHf_bGfObFf?^Jf?fOfOnR
f_nSeobOeobBdo^DeOfKeOebX/PlH88iE6lcAULkB54h@T<oASm0@cQ1@cQD
DDYWHUiTGeaBCDYSH5]QIFIJJ7FAZlBVc_:Hc?B@c_N?d?R=c_BFd_NFb_6/
eoYjW;Q8HgPoEUi3DUE0B4Y6BTU4BD=5Bd5:CSm;D3a@DciCET5;CS];CSe:
CT19C456C493Bd12C451CD=4CTI0Ad1EF4m/KV=/KEmZJ5UYIeQOH59MGe9U
J5eVK69TJV1ZKFAbMFalOGF4QX5jOhF7UjB@]<BGbn2FfOB>fOR:e?N=eo`0
olc<c0k<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooono<c<`2LlGd00Iea_EfaoIiaoMkbOUnb_]obo`2O/Sg00]maoIn
b?MobOR0b_Uoc?R2c?V1b_N0aoF1b?J6b_V8c?T00XW<n@0>S<cjSlokTM7m
T];nTM;lSM3jS<oiSm;lTMCoS];oSM7nSm;lT]?iT];f0Y7Am01ATmGgU=Ki
TmCjU=GkV=SnWm_oXM_oX=SmV]CjT]KmTmKoU<oiT<7ZD7RL=5=b<4IM>TYG
>dI:?DI1@4HlBD]0GU]DKVUUK69QG5ABJFQSKWAdDF5`TZg8W<K/T/WbUMCm
TmOnU=GkV=CiU/S][MGhJhVS?U=T>deAADm@>3hn?D50>3dg@TPnCEA4CE8n
CU<mD5<nD5=0C4lnAdTlA4Ll@dToA4a1@Ta1?d]1@T]6?48nDUE>JV]SJf]O
JFYLJV]MI6EGIVQKJVeRIfeSIV]TK75ZLgI]N7UaNgmnNH:ASjRnVlSOUM7[
RmKeRMWjSMSoSm[o0?o<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooo_c<c<0WG7mP9ea_D017S6mWW7mgc8nGg9
nPAnb?L2OlWh00inboN1boR2bON1b?J5bOR8c?^:cOZ9c?V;boV<c?Z?co^@
d?bAd_b@dO/2SM3j00N>dO^@doj=con<c_n?cofAd?^Bd?T00Y3>l`0nTM7e
TM;hT=7iTM;jU=GmV=KmV]KkV=;hT]3gT]GoSM3jTLchV<_fMj79@V>6>51Z
<dAD=T=9>T=2ADY3FeeBMW=/PGUfNFe]IemMKVmZLG]lC5m^Tk;>WL[aU<gh
U=GoS=7jS=3gU=3eVlgb]MckJ8BJ@UAR>DA6?dE3?D52?Cln=S/e@DLmCUA6
CUE3DEI2DUM3DUE4CU12AdTn@TDl@dHmA4a1@Ta1@4a2ADi9?dQ5D5E?IVUP
K6iS0Ve]H@0AJF]NJfiSJW1VJFiWKG9[MW]dNGigOh1jPHJ9Q9FYV;ODW]7^
T=;bPm?dP]KkR=OnRmSo0?o<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<01QeaoIda_Eea_Eea_Eha_Aj
aoEnb?MobOR2c?^1boZ0bOInaoAmaoAnb?EobOJ0b_N4boV8c?^<cob>dOj?
cof<c?Z;boN=cOT2Slok0Xo@nP>=dOP0FHg@nho<ohk;oho;oi?=oI?>nY;=
mho=mXo>mi3AnHg@nXc?nHg@nY3AnI;Bn97?mXo?mH_@nH_>n93=nI_>nIK0
jVb>/e5ZR45FJCa:DdMADUQOF71aJH5nMhMmNh5cLgAZJG5cKVmjO5M/OIBf
dZ;BnY?@o8cAnXG=mHoDni3>li[<kjcCl5MbQd5BG3I0?ci3?D52A3`m?cPm
>CY0=Si6=dA=>TI=>dY>?De?@De?@TY;@dA7@4=6?d99@D5;@Sm:@Sm:ASe6
ADM<B5YMEVQYHFa/H6YZGVMYG6IYH6=XHFM/IW=jLh:7PHJ;Q8b=Qi2HViV]
aYk2iYKAlhWCmX3EnWkFoX?DohSGo`3oc<c<3/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<c0=ia_805Gc6lgk8
mH7:mhC=nXG>nh7:mgo8mGg6lgc5lWg6lgo9mX?=nXK?o8W=nXg@oI3CoYCD
oi;BoXg=nH_;mhg=n@02S/kj00>=cOV>coV=d?X00Xc?n@1IRlkiSlgoS/[o
Sl_oTLgoT/olT<giS/ghSLkhSM3jS<ojRLkhR/ghSLkhSm3jTM3iT]7jRlkh
U=GoTLkjVLkjUlC^TKONJHJVIWbCFf]hKGQlOXB2QXN2R8B1RX:0SXB5S8N;
MWf3K7j:IGnFS[GDX=7jSlchS=7kSmSoSM;iSLgaVm3bZmC`DFf2@eEO=3hm
>Chj>S`k>cdl@TM3?D8k>D4d@DTj?dDg@DDgADTkBde2Bda4AdQ2@TDn@4Dn
@DQ0?TQ0>dM5>dE4@TM1EUM?KfaSN7IZM79VLG5WJfiWJFiXL7E_PhR4TYRD
UI^IVZ2PWjffYLCQV/[`SlocR]KjRMcoQM[oQ]GoRmSo0?o<c<`>c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<
01:1a>j3a_23a_20`nf3a_2;c_R>dOb:coV5bOIoa_9ma?1naO60ao>1b_F3
c?N7c_Z>c_Z@coX3TM3k00F@coZ>coV=c_R<c?R=cOT00hc?nP0=RlkiRLkh
RLciRl_iSLgkS<cjRl_iS/klT=?nSm;mS<ojR<ggRLgj00:;c_/2S/kj04Z?
c_Z>cOV@coZ@cOVAboVDb_RIc?VJaNn>/=F0VKMmSZ:3RiR;SY>DU9JDTYF?
SI2=SHn:TI^0TZR1Wk^<[lnE`NJIcOFEd_j>dof:dO^9d?ZAd_RGco:Lb^A<
KH0cBE@/>Sdc?3/i?C`j?c]0ACm5BTA2Ad0j@3Hl?cI2AC`n@CQ1A3]5AT16
Ad55AT12ACa1A3/nAChjBDHkBTDk@3U@CT9fKV>BRWmkMfioO7EnOgUkOGR5
Qh:FViNPYZJNZJfT/[fV`]NJcNb@dON=doN8d_N6dOR8doZ;eOb=eOgoc<c<
3/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooklc<c00LQ/C[RLW_S<[cRl[cSlkgUmSoV]_oU]WoRLkhPl[dPLSbP/Wc
Pl[fPlcgQ<ghQlkjR/_eS<_fSLcgS/oiSlkiS/oiSLgiRlkiRLWeR<_fRLci
R/gj0X_>n`:9cOX01H_>nhg@nhc?nXS=mhW=nP02R/kk00>7boR9cOZ9cOX0
0X_>n`0aSLgkS/klSlglSlkjSLchSlkiT<okT<gjULglV<_fU;kVSZo@T:S2
TZ6dUj6]W:F^X:VbWjVbWZfdW;;0V;ODUK_PUl7WV<S^U/gfT/okS]7lR]7m
R<oiT=7iU]7cWLcVAfYm=4aF;Se2<c`k=C/g=S/e>Sli?d@n?T<m>Chh>3/d
>C`e@TDnA4M0ATM1AdQ2ADHn0094ACd04T56@3A3?SY9A3m5>dE3=f9JCiN>
QINDShj@SH^ATH^DTi>LVijXZJBa^JFhaZK1eZ?:ii7@l`::e?T01HSBmhS@
mXWAmhcAn8gBn@3oc<c<3/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooklc<c00=Rl[cSLkfSlkiSm3jTmCnUm[oV]go
UmcoR<ciPl[fPLSdPL[ePL[g009obOH038;;mXG8mHS8m8W9mHW<mhc<n8_>
nH_>nh[>nhK9mXK:mhK:n@:7boX2R<ck00J9cOZ6b_N9cOZ9cOZ8c?V7boP5
Qlkj02Z9cOZ:c_^;c_^<cob>c_b?co^7c?J;d?V=d_b<d?f?cofBco^Fbo>H
a^RG_=VE]LbF/LBJ]LJO^/^O_ljN`]:Pa]^QcNZNc>jJc>nFc?:BcOF@coZ>
dOj>d_n9c_R?c_NHc_2IaN10Gg<fBUDb?D4e>c/f>cLe>SHg?3Pj?c/2?D8l
01/j?3Lf>3<n@3/o@Ca1A3e2ACi3A3i4ACm5AT13B48d@chhAd92B3i1@CM@
C4>6QH2PY:FNZJnGZ;2J[[NO/kbP^<:R_/bTa=VSb^NLc_6@dOL00h[Dn`04
R];jRM7iRM7iR];jolc<c0k<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooono<c<`00i3AnhkAnhc?n@02R/gg0XcAn`0>
R<oiPl[fOlScO/ObO/WcO/SeNlSdO<KcOLOdPLSfQ<SgQLWhQl_jR<ck0XW=
o007QlkjQl_jQLcjQ/[iQ<_iQ/[iQ<_i00:6b_T018G9n8O;n8S<nHK=n@:5
c?P018O>nXS?nhO>nXO>nP:9cOX2Rlkk02>>c_b=d?^6cON9doZ;e?n8dOb8
co^;d?ZAd?^EcoFHb^^Ia^FHa=nLb>6Nc>BMcNBJcNRIcn^Fbn^Fc>jEcO2C
coBAd?V@dO^>dOj=dOj?co^AcoJJc>n@^]<hEFLfB58f?T4h?3/f>ST00SHk
=`09=c`h?44m?d@n?d4l>S`g?T0k?d4l@48m@4<l00=1@S`05Si3?CU5@CE2
>ce2>dE6?TQ9@eiTI8:AV::haJ2mcIg0dj33eYo5f9g7gi[9iiK:lI;=mHcA
nXWCnX[Dnh_Eo8_Cn`::d_X00h_Cnlc<c<c<c03oc<c<3<c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<c005S]7l
Rm3jQ/_eP/OaP<G_009oa_802gc5l87:mgk8mGg7m7g:mWg:n7_9mg_8mWc9
mgk8mh38n002PLWi0162b_Z3bo^3bo^3c?V5bob3bo^4b_^3bo^3bOZ2b_Z3
bOZ4boV6cO^7c_b8cof6cob3c?T00X;;n003Q<gjQLkiQ/oj00:7c_X098W=
nX[>nh_>nh_@nXO@nHSCnXSCoHKAnhG?o8O@oH_?o8k?nI;@miC>m9O?m9OB
m9GAmI3@lhgAmXgAm8k>lHo?lY7AmI7Bn8oBo8kAo8c@oH_>ni;AoIK@n:;@
m8Z_bSUCI3]9DS]0A3Xl>`8f>ST00cDi>3@i=CHk=`02>Slk01`h?CU4AT=4
AT55Ad94AT53AD10@Sdl?STh?CLe@S/c@3Tf>c@oA3i0ATHe@TQKMHBK_mFO
bnBHb^FHbnRJcnjGco2>c?>:cOZ;d_n7d?V6d?N8d_T2R]Ck0XSBn@03RmGl
c<c<c<c<0?o<c<`<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooo_c<c<00>4boF1b?9naNl00g_4k`0EO<G`NlK`O/Se
N/OcNLKbN/WdO<[hNL[gNlWgO<[jNlOhNlOiO<SjO<SiO<SjO<SiO/SiO/Sg
OlWjP<[iPLWi00:2b_X3Pl_k00^4c?b3c?V4cOZ4c_^4cOZ1boR2c?V4c_^3
c_R4cOR5c_T00XO>nP>9cOX018W@nXO@nHO@nhKAn`:8d?l00hW@oX[>oH_>
n`02SLgi00Z<c?R8cON6cOV6d?f8dof;e?N<d_B<d_J<dOR<dO/2S=3m00b?
cof?c?VHcOFTd?=lX;XmE6@jBE0j?d8g>CPi?C`g>cXe>CP2=3Pg01he>SHf
>cLg?3Q0@Sm1@d12A454AT55Ad93AD10@Sdk@S/d?cTiA3`h?CLh?SXf@D<U
>DAAM8RIb>BEcNj<bnj=cO6Ad_R>d_V7c_Z3con7eOn5d?Z4c_F5coH2R=;i
00>5coJ7dOR;eO`0olc<c0k<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooono<c<`01G_4kgW2kGW2kGW3l7[4l@03N<Ga
00Uia_Afa?9e`o5ea_=faoIeaoIfaoIhbOQhb?/00W[7n`09N/SiNLKjNLOh
NlOiNlOhNlOiO<SiOlWjP<[k00:1bo`00h3:nh3:nH3:n@02O/Sg00V0cO^3
cOb1c_b1c_Z3d?aoc?R2c?V3cOZ6co`00XO>o006Q/gkQl_hRm3jR/ghR/gj
R/kk0Xc>o`:;cOl01Y3@oho?ohk>oX_=oh_?oh_Ao`::e?l05HWCnXSBmhS@
mXW>mhW>n8_?o8g@oI;AoI3;miO;lj7>kfV;Y3]BHSM6CCQ1@3Hk=cXn?CDi
>S@h>CHj>CLk>P02=CTh01`h?3/g>cXg?3Pj?c/m@Si1AT93B4A2Ad=0AT8j
A3`mAcloA3hi@Sla@4DT?TeKQIjEbnf9b_:5c?J7coN8coV7d?^4dOn1don2
e?n7dOj4cOJ4coL2Qm;j00>4coN5d?R:eOd0olc<c0k<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooono<c<`2MKo/015f
`>ega?1haO5ea>md`nic`^eha_AdaO9ca?5daO9eaoIda_EeaoIfb?Qhb_ah
bOiibO`00gS8n`05NlSlNlWjN/SiO<SjOLWj009nb_/0=7g9nWg7n7[6mh?=
o7g:n7c9mgo<nX3=ngk;nGg:mWk;mgg:mWo<n8?=nXG?o8K?o8K=nhG<nXK:
nHc?o8c<n8_;nHc<nXc<o8_;nhc<o8g=oHk>oXg<ohc;oX_=ohc?ohkAoh[@
ohG=oH_DoH[Dnh[BnX[?nH[>nh_>nhk>o8o>nYG>niW=m:3;jeaoUCMAGS=5
BC]6@Sa2?SLk>P8`=3D02SHj>cTm?3Hj>CDi>3Pl>cXn?CTm?3Xo>ca1?Cm4
@090AD4033m4@4=:@ca3?456@419B2m0AbA1Df2=ZXg7kHK;mHSBoh[Eo`:5
d?X02hSEohCFoh7AohSEohO@nHKAnHWDo8SCnhG@n8OBnXcGo`3oc<c<3/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
klc<c09c`>h00gC1kgC2l7G3l@02ML?a00]ca?5b`o1daO9ea_EcaOAda_Ef
b?MgbOQeaoMfb?Ydao/00WG6n`0@MlSmMlWkN<SkN<SkMlOhNlWjOL_lO<[k
NLOgN<KfNlOhO<[jN/KgN/ShO<[jOL_k0Wk<nP04OL_iO<[hOlgkOlcj0X;<
n@:4cOX018C;nH?:n8S<nH[=nP:<c?P3SL_j00>>c?^?cOb>c_h01Hk>oP06
SM3mRm;lRm;lSM;lSM3kSM3m0Xk>o00BSlciT<WdW=3gWL[YBVj4>eMS;d96
=40l=d4i>3hl>3`m<CDf;c<d=CTj>3`m>Cdl?D50>Cdl0SXn?@0G>cln?dA0
@TM3@DI2?D8n@TU2=chf@dQ2?TM6<dA<;DYLFHRVS/WaR<okR=;oQM3hQLof
R=;iQ]7iPm3lQ]CoP/ggQ<og00:7d_X018G@n8C?mh?An8GCn_o<c<`>c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_
c<c<0W:ok@9b`>h2Ll7_0g;3l008M<GbLlGdL/CcLlGdMLOfM/SgMLOgMLSj
0gC7n`08M/OlMlWkMlOjM/KiMlOhN<SiNlWjN/Si0WW7m`0:NlWiO<[jO<[j
O<[jOL_kO/clOLkmOLkkOlgkO/cj0Wg;n@0=PL_hP/ciQLkkQ/olRM3nR]7o
R=7nRM3lRm3jS<ojSLgiS<ggSLch00:=cOT3Rlkk00R>c_b>c_Z@coZ@dO^=
d?^;d?Z;c_V:cOP2S<cj00b>c?^?c?VCc?NHc?6JanA4JWliEf4cB4TgAT4i
@c/d>SPg>c`2<cLh00`h?3di?Chf>STh?3/i?C`j?Sdl@3m0A4=3B4A2Ad<o
A40l@C/2?TDm01I1AT0kAD@gB50`Cf5DPZ>;bO24boN5cob5c_N5cO>;dOF8
d?J5c_N7d_b5d?R7d_Z8do^7d_Z4coN3c_J1coJ3dOSoc<c<3/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<c0A`
_^`2LKo]00=``Nia`^mca?400WC5lP06L/?`L/CcM<KeMLOfM<KfM/Sj0gG7
n@9fb?X00gK6nGG5mWO7n004MlOh00=hb?Ujb_]jb_/00WW9nP03N/[kN/_j
N/_j00=kc?/03WS6m7_9mh7;nX?=o8C=nXG>nhO>o8O@oH?@o8;Ao8G@nXG>
mhK>mXS=m0:8cOH4Qlkh01J:coR<d?N?d?JAdON?co^;c_^<c?Z;boV:b_R;
boV>c?^@cOZEd?RCbNfGa^8mHgHbD5X`ADHhA40d?SHc>CLg>c`2=SXk00@j
?Sdh?3/e>CPf>ST2>3hl01Xl@Si3BDE6C4Q1Ad<l@Shk@S/k@SY5C4@n@cdk
AD@iBU8fEFMBP:6<ann3b?:4cOR6boB8c?6=co::c_67c?>7coN3c_J2coV4
dO^3d?X2P/oi00>4dO^6dog<c<`0olc<c0g<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooono<c<`4Kkg[015`_^aa_ne_
`>e``Nica?5daO9ca?5a`^ma`_5caOAda_EcaOAeaoMda_IeaOQda_Ifa_T0
0WK6m`07MLGfMlOhM/KgMLGfM/KgMlOhN<Si009ibOX5N<Si00]hbOQib_Ui
b_UgaO=kbON4c_f5coj5c_^2boR2bON0b_L00Wc=nP03O/gfP/geQLof00:7
coD02XK@mhG@n8G@nXG@nXK?n8S@n8_@mhk@li3@mXk>nP:=cO/2S<cj02j=
cO^>c_b?c_ZCc_JCbN^Ga^8lHWD]BE@/?T8f@Cdg?3Hg>cXi?Chg>c`e>CXh
?3/g>cXe>CPh?3/h?S`f?3Xk@Ce4BTI6C4Q0AT8k@Cdl@c`l@c]4Bd<l@C/n
B4LeB4llFfeKRJZ9a>b3b?:3c?N5b_>6b^n<c_6;cO27bo:6c_J2cON1c_R2
coT2PLkh00>2coV4dO^5d_`0olc<c0k<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooono<c<`01FnljW2mjg2mjg2mjg2n
k002LKo]00Ab`>id`_1e`o5d`_02L/3^00=ca?5daO9ca?<00W?4l`03ML?d
M<GdMlGf00=ha_H017O8mgK7mWG5mWK6m`9gaoP00gS8nGO7n7W9o002N<Sk
0WS8n@05NLWjNL[iNL[iO<[jOlgm00:5coh03HC=nX;;n8;9mh7;nWg>oG_=
o7k=n8?>mXK@mhWAmhSBnHOAn8?@nP02P]7l00R3d?b6coR7coN;coB=c_J<
c?R<c?Z;c_/2S<ol01^;c_^;c_V<cON=bo:Hc_2C`=e2IGT]AE4[>3hj?Se0
@C`i>cXj?Sdi?C`g>cXh?3/f>STd>SPh?S`g?CTd>SHh?SY1Ad=1BTDlAD0j
A3`mAcl00Se7?P0C>D0i@Ta;<4=:@5maJiVjQl;ZQ/[gQLkkPl[dQ<W`R<ca
R<ccPl[dQ/ojQ=7kPm;kP]7jP<ohOlcf009nboD00go<m/c<c<c<c03oc<c<
3<c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooklc<c09__>X00g2mjg6nk76ok@03LKo]00Mb`>ic`Nmc`Nma_neb`>id
`_1ca?400gC2l003M<;bML?aMlGe00=ha_H00gG6mGK7mWK6m`04M/Kg00=g
aoQfa_UgaoX00WO7nP9hb?T2N<Wh0Wo=o@0@PL_jOlWhOlSeP<WfQLcjQloo
P<knOLkmPL_hPlceQlceR<gfQLgePlcePm3lP]3n0X7?o`07Q<kkQ/giR/gg
S<ggR/[fRLciRlkk00:;co`03XW=nXS=mh[;mHg;lYkDn86]bT1PMBe0CRXa
>CLe=Slk>SDg=STm?3Xn?@8i?C`083Di>38h=SDk>CHl>3Dk=cLm>Ce3?ce6
@C]4?c]5?Ci8@3e7?SY4>cY1>T5;BS54BdETN7RVahC2jhG<nXC>oH;;mX78
lXC;mHC;mh;:nX?@oX7@nh7@nH3?n7o>mh3=m`=oc?Koc<c<3/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<c004
KK[XK[_YL;g[LKk/0W:ok@03LKk/L;g[LKk/009c`>h01G:okG;1k7C3kWG4
kg?2k@02ML;^00Ae`_1e`^iga?9haO<2MlGc00Ad`_9fa?Agb?Mgb?L2M/Kg
00IeaoMfb?QeaOQeaOQfa_UgaoX3N<Si00=gaoQlb_YkbOT00Wg7mP0[OlSe
P/WgQl_jQlgnP/_nP<WlPlOhQLSeRLWeR/_eQ/WdQ<SgQLgoP/koPLgoP/ko
QLcoR<cmS<cjS/giR/gjRLgjR/kkR<okR<oiQlkhQ/ggR<_eS/ccWM?gHHfZ
=UA/;Si=;c8k>2ld?3<d=3@d=c/j>3`k=SXi=CXf<SLc<3Hb008e>cL00cHl
>3M1>CU3>`02>dDm0Sa6?P0F>DDk?DLn>d8k?DM8>TaFB6UlNZ_<QL;^PLWi
PLgnOlcjP<[gPlgjP<cmO/_oOlooO<gjO<ghOlkiP<ojPM3kP]7l0X?@o?o<
c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVKoooo_c<c<02A/^NM]^^Q`_N]a_^ab_nea_^a`_N]__>Y`_N]b_nec`>ia
_neb`>id`nid`_1c`^ef`o5g`Nie`_1e`^if`o5ga?9fa?9e`o=a_nme`o=g
b?MhbOQgaoQfa_MeaoMhb?Ufa_UgaoYibOajb_d2Nl_l0W[:n`0AN/ShNlWi
OL[hPL_jQ<clQ/gkQl_jQL_lP/WmP/SkPlOhQLOgRl_gS<chRl_iQl_jQ<cn
00>3c?l07XG<ohW<ohg=oHg=nhg@nhcAnh_@nXW@nXS?nHS@n8S?nH_?mX[8
kiS=kdUbT2m;HCA1DCTl@d0g>T4h>CHf=SLk>SDi>34e=30e<Bhd<30f<SPn
>SDk=cPn>P8i@c/03SY4?3a6?Sa6?S]5?3E1=d5;@Sa2?SM2ASmEHTM[PGF[
cHC5kgk6mWo;o0:0b_T01h;?oH3>oW_;oWk>oh7?oH7@nh;?n`03Pm3l00>2
co^1c_[<c<`0olc<c0g<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI_ooono<c<`02ffkjFnmjfnmjfbjj6fjj6nljW:nkg>o
l72lkG6mkW2nkP02LKo_00M``Ni``O1a`^m`_>ec`>if`_=f`o400W;0l007
ML?cN<KgM/CeML?dM<;cM/CeM/Ki009hb?/06gO7nWW6nWO4n7O4n7[7ng[:
ngW9nWS8nGW9nW[;nWc:nWg9nWo9n8;:nX?;nhK<oHO=oXG=ohC<o8?9nX;9
mhG9n8K:mhO;nXG<nXW?ohK>oP02QLgm03b5c?Z4boV8c?V=d?^8bO>9b_:;
c?B<d?N;d?N9c_F:cON?coF@b_2Ib^]9KXTgDVL[>dPoA4Q2@Clf=C4[;B``
=SHe>cTa=cD]<c4_=C<c>CDc?3Ld?CPh@C`h@SXi@c/lAShjA3`g@CPi@cXf
@S@kAC`j@40f@d`gDVDjJ822`n=obNj0bOJ1bOV3b_R3c?V0cOUnc?YmboUl
b_Qmb_J3cOZ6d?n5coj2c?^0b_V1boZ3cOcoc<c<3/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<c006JkWWK[cZ
Kkg[K[cZK[_YKkcZ0W2lk@=a_Nh00g6okg;0l731l002LL;a00Qa_nmd`?5e
`O9e`O9c`O5b`?1d`_=fa?D3M<;c00ee`oAda?MeaOQeaOQda?Mia_YiaOUh
aOUjao]ibOYhb?UgaoQhb?T00WW:n@0>NlWiOLWjP<[iP/[jQ<[kQ<clPLWi
P<ShOlOgP<ShPl[hQLcjQ/gkQlkl0XC;n@0fQLchQ/giQlkjQ/giR<okSM;l
RlcfRl[cR/_cR/keRLkgR<gfRLcfSLgcU<_bV<WZC76<@Uma;T1:=T12<cDb
=SLa9RXY:2h^;C<a<CLe=S`j>Clm=Slj<c`g=3dh=d0k=d4i>T@l@D]3@4Y2
>dDl>T@i>4<e?4Hm>d13=T9><E1U=FN2O<7PNlW]PlcgP/_hQLWhP/WgO/_g
O/ghOlkgP<gg0XC>n`06Q<kmPlglPL_jOL[hNlSfN/Oeolc<c0k<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooono<c<`0
16ZfiffijW2lkFnkk0=a^n`01fnijW:lkG:lkG:lkG6mkW:nkg6ok`02L/3`
0W>ol09d`?42Ll7a0WC2l`04ML?dM/CeMlGfMlGf0WC4m@9eaOP01GW6nWS5
nGW7n7_9nWS8n@02M/Kg00Ehb?UfaoIgb?MiaoMkaoP00Wk8n@9oaoL018?;
nh7;nWo9n7o9n0:1bOT03X;;n87:mh7:mh7:mhC;nHO>o8O>nXK=nHO>nX_?
o8c?nXS;mXG:m8C;m@:4cOH0:8C;mHS<li3;lho1i4=ZQcUHK2a0BcI1@bX_
:b`^:A`Q7B4W9BT_;Ble<bhd<2`b;Rdc;c4g<cHl>3Lm>CHl>3Y0?4A;A4=:
@c]2>cDo=SDo=3]5?3]0@cI2CS1<HSQWPgZogW_9kH7:mH7:mhG9n8?:n7o<
n7k=n09oc_T0283=ngk;nGc9mgc9mgo<nWk<nWc:nWW7moo<c<`>c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<
00QX]>E[]nQ]^NY]^NY_^NYa^naa^N]`^>X2L;[[0W6kk00@L[c]LKg^LKg^
LKg^Lko`L[k_LKg^L[k_Ll7aM<;bM<;cLl7bML?dM/CeN<KgMlGf0WC4m@0@
MLGhM/KiMlChN<GiNLOhNLWjMlOhMLGfM/KgNLWjM/OfMlSgN/ShNlWiO<Si
O/Si0Wg7mP03PlglP<gkP<[i009obOP02838n839mWo8mHC=nX?<nHG<nXO>
o8K=n@:4boL0>HK=nH_?oXK:nH;9mh;;n8?=nX;=mh;;mXG:lho=m977jeJ2
Wc]KL357E3U8Bbhg<RT^:2<Y9BL]:Ble<c<i=Ble<BX`;2hd<3Lm>CHl>3Lm
>CHl>3Y0?457@cm6?cHl>38i<S8l<CY1>C`oA3M3Cc1<HSe/R7_0ggg;kgg6
lGo8mHG9n8G<nX;?ngo>nGg<mg_:mGg;nGW:mgO8mGS9mW_<nGc=nW_<ngS:
n@3oc<c<3/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooklc<c007J;CUJKGVJKGVJKGVKKOXL;[[L[[/009a^N/2L[[/
0W:lk@9c_Nh2L[k_00Aa_Ni`_>ea_Nic`O42M<;b00=b`?1b`?5c`O800WG3
m09b`_<03G?3m7G5mWC4mGC4mGK6mgS8nGO7n7C6mWG7mgS:nWS:nGW;nW[;
nP02OL_k0Wg9nP06O<SiOL[hO<[hO<WgOL[hO/_i0h;<n`0<QLkkQ<gjQ<_i
QLcjQ<_iP/WgQ<SgQLcjQLgmP/[jOlWhOlcj0X3>o00^PL_hP/WcR<O`U<c_
PJk;FGb@A5aX=DM9<Sdg<3L_<3L`:c8[:c4]<SPd>3hj=cdi=S`h=cdi=S`h
>Clk>Slk?44m@4E1?44m=CTh<STb<S`a>T4i?D15?4IB<dmUAGB@Nl3OOL__
OLKaOlSeQLWjQ/cmP/okP<ojOLcgO<_fOLkkNlkjN/giNLch0WS:n@03MlWh
MLWgc<c<0?o<c<`=c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooo_c<c<0VRfiP05IkGUIk?TJKGVL;[[L[c]009b^^`2
Lk_]0W>mkP=d_^l01G6mkW2lkG2lkG6mkW;0l002Ll7a00Eb`?1c`O9c`O9d
`_=e`o@00W?3m00:M<CeMLGfM<CeLl?dMLGfMlOhM/ShMLOgM/ShN<[j0WO9
n003N<WhNL[iN/Sh00=jb?P01Wg;nGc:n7c:n7c:n7k;nGo<nP:0b_T00h?<
nH7:mh;9m`02Pl[h01f2bON5bOR6c?f4c?j0b_]mbOYocOencoiocO]oc?Z3
b_J6ann=aNRGa^9oY;MROHQ9Fee2CdQ2C4<i@3Pd>c@b>C8c>S<e>cLd>SHb
>3@a=c<b>3@g?CT00STn>P0A?40o>3`k=3Pg=3Xf>3lg?4<l?d97@DYI>5AZ
CgjJNl3QNLO[PLcfP/_hPlWjPl_kP<gk009oc_T02Gk?nWW<n7[=nG[>nWW=
nGO;nGK:n7O;nGS<nP3oc<c<3/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooklc<c009JKWZJ;SYIkOXIkGVJ[SYKk_]
L;c]LK_/L;[[009a^n`2L;c]0g6mkP04L[o]LKk/LKk/LKk/176ok`06M/Cd
ML?cML?dML?dM<CeMLGf0WC4m@05M<KfLlGeLlGeMLOgM/Sh009eaoL00gK8
n7K8mgG7mP02MLOf0WK7mP9gb?L2Nlck0W[;nP9lb_X087c9mg_8mWk8mgk8
mh79nH?;nhC;nH?:n8G9n8K<oHC<oX7:oGk:ngk<o7c=o7g;nGo<nXC=n8c=
mHc4ii_:iYBic6n:TfYlO65/I69ZGe9IDDeDC4=:@cLn=c4h<C0g<0<b=c<0
6cHk=cHj>CHj>CTm?3Lk>S@h>CHl>3]2>Se4?D54BDE>GCmKLEZ9YGk3i7S6
k87;n8;:nX;8nh79nGk;nG_<nGc=nWg>ngG7mWK:n7S<nWW=n`02N<cj0WW=
noo<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoooo_c<c<0VRlj`06J;[ZIkWYJKWZKKg^Kkg]KK_[0Vbhj@04KKWZ
K;[ZK[[[K[c/0Vnkk0Ab_nd2L;k^0Vnmk@04ML?cM<;bLl7bLl7b0W?3m008
L/;cL<3aM/ShLlGeL/CdMLOgMlWiMLOg0WC6mP9hb_T3MlWh04]hb_Uib_Ui
boYfb?MeaoIgb?MhbOQlb_Ymbo]nboUmb_QmaoInb?N1bOV4c?b5c?Z3b_R4
b?N3bOZ6c_n3cOioboambo]lb_Ylb_Qoc?R6coR6aNj<a>NHa^2>/LAGL7M]
OGaZM6]_MfYZLVMIH5Q1B44_=Rl^=Bhd>c@d>CD_=30f>cLi?SXg>cXf>STj
?Sdh?3/f>S/g?C/k@SXl@Si0@dY8DF94H7QPTJn1aNQha^amaoAnb?N0b?Z0
b_]mboUjboQhbOIfbOEhb_Uhc?YiboYicO]iboYgboUfb?Mdb?H0olc<c0k<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ono<c<`2I;c/00mR^>UO]NIT^>MZ_>a[^naW]nQ[^NU^_>a`_^i]_^e]^n]Z
^nY__Neb`?1`_N/00g6nk09a_nd00g6okg;0l7C2lP03M<;b17;2l`9da_D0
0g?5m773lW73lP02M<Ke00AcaOAgbOUfb?Qda_H2LlGe00Mdb?Mhb_Yhc?]c
aoIebOQibo]kcOd00Wc=o006O<[jNlWiP<cmOLWjO/SgOlWh0X;:nP0JQ<[k
Q/cmOlGfO/KfO/SgO/_iP<gkPLkjP/ggPl_cQ/C[TLOYV<CMIXNFCFAZFFQU
JW9WHVQJHFUNC5I==T0h;3H^;SD^;cH_;cDa;S@`0SDj=P0N>3`k?d=2?D50
<3@c<3@e?TA2@DQ1>T0l@4=:BUIVAVAlJIZhO/;UN<O^N/OeOLOhP<SjOlWj
NL[iN<[iN<_gNLchMlWhMlWiN<SiMlWiNLWjNL_kN/[kN/clolc<c0k<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooono<
c<`2H;_Z00IP^>QO]nMQ]nIW^nYX^^YV^>P2JK[Y0VZkjP04JK[YJ[_ZJkc[
K;g/0W2mj`9a_^`2LKo]0W6ok`04Ll7aM<;bM<;bM<;b17;2l`=caO@01G;4
lg?5m7G7mWC6mG73lP02MLOg00Ada_IeaoMdb?MebOP2M/[i00Adb?MebOQg
bOUgbOT2NL[i0W[8n004O<SiN/KgO<KeO/Sg0X79n@0HP/[jQL_lPLOhPLOh
PLWiPL_hP/ciPlkhPlceQL[aR<K[TLKVQJo7BFUh?E9GBUIBIF]QGV9D@DTn
=3he:S@/:38Z;SD^<3L`0S0f<P8d>CD05cDi>3Xn?C/o?S<g=S<g>3i4@S]5
?CY3?T55CT=?GcQFL5b?[WVohG_:lGW7mG_7n7k8nGc8nGO9n7K:n7K:mWS:
nGO9n@04N<Si00=ibOYjb_]jb_/0olc<c0k<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooono<c<`03UbhjEfijUnjjF2h
j66gj6>ijVFij6FgifVijVRhjFNhifRij6VjjFZkjP9Z^nP2L;g[0W6nk004
L;k/LKo]LKo]LKo]17?1l@Ab`o803773lW;4lg?5m7?5m7G6mGK7mWC5m772
lGC4mGG5mWG7mgK8n09ebOP2M<Sg00=gboYfb_Ufb?P00WG7m`08M/ShN<Si
NLWjNlWiNLOgN/KgO<SiP<[k0Wo9nP0FPLWiP<KgP<OeOlSeOlWfP<[gP<_e
P<WbPlO^S<S]U<OVK9B]<e1P<TE;?DQ4FeiECU94<STa:SD]9S4Y:3<[;3D`
0Rdf<@06;SLb=C/g=C/g=3Xf=S`h>Cdl0SHj>@0>?D<o>D@l>dI0@TI??T]K
<E5ZFhj]NL;SNL_aNLOeNlOhNlOiN/SiM/Sg0W?:m`03MLWgMlWiMlWk009g
aoX017O7n7S8nGS8nGW9n_o<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<00YK]nQN^>YO^^UQ^NUR^>UT
]nUT^>MU]nMZ^^]/^^/2JkWY00A/^^Y]^n]]^nU]^nT3L;g[00=a_^a`_^a`
_^`00W6ok@9b`?02Ll7a00Ua`_5b`o9b`o9b`o9``_5ba?=da_EcaOAca?<0
0WC5m007LlCcM<CeM<CeMLGfMLOgMLWhM<Sg009caoH00gS<ngO;nWO9n@02
MlWi00Ihb_Yjb_]kboaocOembo]kbOT2OLWj01IkaoQmaoQnb?UoaoMob?En
aoAnb?EobOIob_B0bO:3anj;anbCaNIEOIH`CEdbAD`jA4=9C4<k?S<b?3<^
>C4[=S02:SD_01`[=2l/=C0_>3<f?3Pi?c/h?SXe>cLh?CTg?3Ph?3/m@clh
@c/jAT90AdlnBe`gEg1SV;MmanYcanagb?Ejb?QkbOYhb?UebOMab_IbbOIc
bOQfbO/3M/Sj17K8n?o<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooo_c<c<00EM]nUN^>YQ^N]S^NaT]nT00VBf
j003IKGXK;[[KKW[009]^NX016bhjFfijVjkjFnljP9__>P2L;g[00A__N]`
_^a`_^a`_^`2L/3^00Ab`?1c`O5a`_5a`_42L/?b00A^`Neca_9faoIca?<2
L/3`011fa?Aha_IgaOIeaOIda?EcaOEba_EcaoIaaoQca_Qeb?YgbO]hb_ai
boeibo]jc?`2Nl_l00=ocomkboahbOP00W[8n00FNLOgNlOhO<SiPLWiP<Sh
OlWhO/_gOlchP<ggPlcgQ/_dR<K]SL;T@6V5<4mS;d=<=d=3>Chh<SD/;STa
:SL`:3@`0RPe;P04:C@^;3La;cXd<3Td0SM0>`0C<c`g=C/g=C`e>3hj?DLo
=D8i>dM3@TUA?4aL=EM`HiZhO<KYKl;ZM/SgN<SiNLWjN<[jM<[iL<_h009b
b_P00g?9nWG8nWG8nP03M<Oi0WG9n?o<c<`>c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<0Ungj@08H;KYIKS/
I[SZI[KYIKGXJ;GYJkOYK[OZ0Vngj@9^]^P01Vngifnij6nlj6nlj6nljW2m
j`9__N/2L;k/0W6ok@9b`?02LL;a0W;3lP0;K/7]LlKbM/OfL/?bL;k^LKo_
M/CdNLOgN<KgMlGfLl?d009ba?@01g;6mG77n7;8nG?5mgC6n7K8nWS:o002
NL_k00IibOYhb?Ujb_]gaoQfaoIgb?L2N/Sh01IkbOUlb_Z0b_]obOQlb?Ul
b_QmboUncOR2c?V6boF;bO:<`>E0JHLaD6DZ?TTf@D<h?CTe>S@[=S0V=C0W
<blY=C42:SL`01L[=S0]>38/=C0d?CPf?cXd?CPf?CHe?3Dh?cPoBD4gA3/n
CDQ8DEXoD60bEW1MU[AiaNMaa^efb?MgbOUibOYgboYcboT00g3;n09bb_X3
LLWi00=cbOYcbOQcbOP0olc<c0k<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooono<c<`02Unej5jaiEjaiF>djFNgk6Re
jfVejFbejVnfjVjej@9^]>L2KkGX00=_]NI^]^Ia^nP00fnlj09__N/3L;k/
00Ea_nea_nmb`?1``O1a`_400W;3lP06Kl3]L/?`M<GbL/?`L/3`M<;b0WO3
m00<MlGfM/CeLl?dL/CdL/CfLLCfL<KgLLOhLlGgM<KhMLOiM/Sj0WO9n`03
M/ShMLOgMlWi009eaoL06GS:nW[;nWW:nGW:nGc:nWg9nWc8nG[8nGS9n7W:
nGc:n7g:n878m8_:mHo4k5AoWc=CJRY0CS0m@c]1@CDk=bhj=RLf<b@c;RLf
<@02:STd01P[>34Z=c0_>S@c?SPf@3Ph@SXi@c/e?cLh?cLnB3ljBT11D4]:
Dea3E6@fFWAPVKMja^Q`b>icaoEdb?Mfb?YfbO]bb_Q^boL2Klch00I`boY_
bO]_b_U_b_U`boYbb_X2Ll_kolc<c0k<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooono<c<`04Efbj5V_hU^^hV2cifJg
k6Ngk6Vfk6^gjg2ikVjejF^biVfciW2fjG6gjW2fjFbdi72jj@03KkcZ0fnm
j`=`_^`00g6okG;0l731l002LL;a00=b`o9``Nia`^l00W;3l004ML?cMlGe
M/;cLl7a0WK4m@9c`o@017;4mW74mW74mW74mP=eaoL00gK8n7K8nWK8nP02
MLOg00Yhb_YgbOUhb_YkcOemc_ekc?]hbOQjb?Qnc?ambo/2NL[i02aibOYj
boYlb_YobOR4aoB>ao9WUKLcEg4ZA5<Y>T8h@T<Z<bh_?3DV=BhP;bXS<RdX
=c@[>SL]>CL/>3@f@C/g@SXi@c/lAShmAclg@3/g?CTlAD0nBd8mC4U1CUI0
EFHjHW]WX;ila^U^`NUca_9da_EeaoMebOQabOM^boM^b_U_boX2K/[k0Vk:
n@04L<_jLLckLLckL/glolc<c0k<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooono<c<`01E^ejUZdj5^biebcj62ej`02
HkKZ00YS]NMT]>MX]^M[^NY/^>Y[]nUZ]^M^^>U`^^]`_>d2K[c/00E__N]`
_N]^^nU]^^I__>P00W:oj`03LL3[L;k/Kl3]009^`Nd00g31kW72lG?1l@02
M<;b0W?1l@=d`_<3L/;c00Qb`_Ea`oEa`oEa`o=ea_Eea_=eaoIfb?L2M/[i
0WO:o005N/goNL_mMlWiMlOhN/Sh009kbOL01W_:mG[9m7S9m7S9mWS9n7S:
nP9hb_`09gS8ngc4mXK6lWB/dBQELRe@Hb]4Bb0b<R/j<b/k;RDg:BLf;bHe
<Ql];R@b=Blj?2`h>2lj=3U4?3I2=Sm;@CY3?SM0?C0h>T59Bci7@T1<BSa?
ECeJJ3ISNVnXaWk0hgW3jWK3kGO6lGW7mGO:mW?9n6k9n002J/Wi00I_boa^
b_U^b_U^b_U_boY`c?/2L<_jolc<c0k<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooono<c<`2F;?X00AI/nMJ]>QM]>UN
]NX2G[CW00AT]^QV^>YX^>UX^>T2J[SY00I]^NY^^^]/^^][^NY/^^Y^_>`2
L;g[00A`_NUb_n]a_^Ya_^X2L;oZ00I_`>e_`^i_`^i``nmb`?1c`O42M<;b
0W?1l@03M<;cML?dL/;c00=b`_<3L/;e00Eb`_=ea_=fao9eb?AfbOD00WG9
n09eb?X0=WO:o7K9ngO7n7O8mg_9nGg;nGo<n7k=n7g<mg[;mWW:mgW:nGW;
ngW;oGO:oWO8oGc:nhC;nGVggT5fUBI?HbM7DR@l?RTl=RPj;2Hh:2Lg;B<b
;ah/;b<^<R/f>2li>S<n>3e9?c]7>d1<@Sa5@3M0?bhf>CY2AD16A45;BS]?
ESUIJ3ARNVfUaWnoiGc3kGW2kGS5lGS7lWK7m7;9mVk9mP9/bo/2K/[i00A^
bOQ_b_U`boYac?/2L<_jolc<c0k<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooono<c<`015JbiENciUZdj5^ej@9M]>T0
15jdienej6JhjVJhjP9W]nP026ZhjF^ijVfijfjjk6^ijVZhjFbhjFnkk09`
_N/037:ljGBnjfnlj72mjFnnjG2ojVo0kG31kW33kg74l76okg;0l0Ac`O40
0gC2lgG3m7;2l`03L/;c0W?3m004Ll?fLl?dMLKeM/Od0WG8m0=db?L027?7
mWK:nGG9n7K6mgO8mg_9nGg;nGo<nP9oc_T0:7_<mgW:mgS9n7O9nGO9ngK9
ngK8nW_9nX39mWfniVJM_2EBJB=7EBM2BbHl>RDf;2Ph:bLd:b8^:R4];B8/
;BLa<30i=SQ1?4==AD1:@Cm9@3Y3?SHo?2hh=cQ0@T96AdE=D3i@G3MFJSER
OfZRagbmigW2kGS2k`9faO002g?6l7;6lW39mFo<n77=o6o:nFk9n738n779
nG;:nW?;n`02L/[jolc<c0k<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooono<c<`015B`heJbiE^ejEbfjP9N]NX0162f
jF6gjVJijfJhjP9V]^L01fVgj6^ijVfijfjjk6jlkFbjjffijP02Kk_/00=^
^nU`^^Ub_>T00Vnlj009L;gYKkkYL;k/Kl3]L<7^LL;_L;k^LKo_L/3`00=c
`O400gC2lgG3m7;2l`02L/;c0g?3m008M<CgM<CeM<GdM<GbM<OcM<KeM<Sf
M<Sg0W?7mP0hMl_jMlWiMlOhMlSgN/ShNlWgO<WgNlWgO<gjN/_hN<WfM/Of
MLOfMLOgM<OiMLOgM/OfNL?`O/7[O;OI>FR494YO8d=B93e27S4]9SH/9C8[
8c0Y:3<_9Rl/9BhY;CHa>T4jA4i6@4Y2>D<k=T0h<chh<chj?TM4A4Q9B4mE
@UAR>5M/>FJ7J:;:Mk[WMKo^ML;`LlCaM<GbLlK`L/O`LLScL<_gLLci0W38
n09aaoP017?9nWC:ngG8nW?9n_o<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<00YD/>=G/nIK]NUL]^YN
]^QM]NMO]NQP]^UU^>YT]nT2I;KX00mW]nQY^NY/^^]/^^]`_>i^^^a]^N]^
^^]`^^]^^>M_^NQa^nYb_>U`_NU`_N/00Vnmj`05K[o/Kl3_Kl3_L;k^LKo_
00=b`?0017?1lGC2lWG3lg71lP=b`_<2Ll?d0WC4m@03LlCcLlCaLlGd009d
a_D01GG7mWC8mgC8mgW;ngS:nP04N<Wh03Ajb?IiaoEjboQib_Ugb?MfaoIe
aoIfb?MebOQfb?Qgb?Mf`o5ma>j3`NQISZh/F7<O@e/S?ddL<34S<RdS<2TV
<b`_>S8/=RdW;RH/<b/e>SA2BD94Bd@i@c/h@SXb?CDe@3Q1Bd=5ATQ;CeQ5
EFDiEfm1KI1[Y<mg^nYc_o1d`_9ba?=dao=dao5cb?5`b?1abO5ab?EaaoIa
aoP2LlKh0WG8nP03M/SjM<Oic<c<0?o<c<`=c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<00AF/^EG/nIJ]>QJ
]>P2Fk?U0U^ai09S]^P2I;KX00EV]^MW]nQZ^>U[^NY^^^`00VbhjP05KKW[
KkWZKkWZL;[YL[c[009c_NX2L;g[0Vnmj`04L;k^K[o^L;k^LKo_17;0l004
Ll7aM<;bLL7bLL7b17;2l`9c`o@017;3lW?4lG?5m7C6m@9eaoH2M<Sg0WO9
n@08MlSgN<WhNL[iN/_jO<[hNlWiN/_jNLWj0WO8m`0]M/SgMlWhM/[hM/[h
MlWhM<;`OLKcOL3ZLjgC@7:E7dYZ7d9H7c<l8C4a8S4^:SL`<Cdc<CT/;C<W
;C<Y;c@]?D8lADY6?dE1@4Y2=40f=48e?dU0@dE4BTeDAEET>EM_AgFGKj[D
NKo`ML?dLL?cL/CdM<KeM<OaL/O`L/O^L/O`L/KbM<Sg00=ca_P017G7nGK8
nWG7nGG7nOo<c<`>c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooo_c<c<0UNciP04E[;SEk?TFK?UF[CV0U^ci@04G[CU
H;KWHkKXI;OY0VBfj006IkOXJKWZK;W]J[O[JkOYK;SZ0VnijP04LK_ZLkg/
Lkg/L[c[0g2mj`05Kkg[Kkg]L;k^L;k/LKo]009b`>h2LKo_00Ab`?1c`O5a
`_5a`_44LL7b0W;2l`04LlCcM<GdLlGdM<Ke1GG7mP04M<KeM/OfMlSgN<Wh
0WW:n@0/N<WhNLWlN<SkMlOhMlSgN<WhMl[fMLWeMLWgM/[hL/?bNlSfMkkZ
O;_VGiJo;f288dYY8ce>8S<j8c<c:STd;SX^<3PY<SPZ=3L/;c8[>C/h@TI5
@DM5B55<>4@j=dDf@4`nATM2C51CAEER=UEZBgVJKjgFNL7aLl?dLLCfLLGd
LlGd0W;5k`05L/G]LlK^LlSaMLWhM<Oi009ca_P2M<Oi0W?6n?o<c<`>c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_
c<c<00IF/^EE/NAE/N9G/nAK]NMM]nT2GkOY00AM/nAO]NIT]nUT]nT2HkGW
00IU]nMX^>U]^^i[^>a[]nU/^>X2K[SY00I_^NQb_>]b_>]b_>]`_N]__>X2
L;g[0W2nkP9a_nd2L/3^0W6ok`9b`?02LL;a1W71lP03M<GdMLKeM<Ke009e
aoH3M<Ke0W?5m09daO@2M/Of00Iea_Eda?Ehb?]gaoafa_Ugb?L2MlSe039d
ao=ba_9gboUba?=kc?]g`O1n`?1f/n11MjDYEWdWAEdQ=d@S=S`Y>CPX=B//
=bTf?2hi?34a<R`e=c@o@D0oAD=;E4lkB3hjBc]5DT59C4=>DU54EehcE6E9
NYQ^[]Af`>e``_9ba_E_aOAaaO=aa?1``nebaNedao5fbOEebOQbb?Uca_Qa
aoQdaoUbb?Uca_Q`a_Ooc<c<3/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooklc<c00GEK7RFKGVF[KWEk?TF;;TFkGW
G;CVF;3RH;KWGkGVG[CUGkGVI;OYI[W[IKSZI[SZI[KYJ[O[K;[[JkWZJ[KW
JkOXKkWX009b_>/03G6kjVjkjG2mjg2lkFnkk6jlk72nkVjljVnmjg2nk76o
kG;0kW?1k`02Ll7a00E_`>ma`_5b`o9a`_5b`_<00W?3m004LL7bLlGdLlGd
M<Gd0W?4l`05M<GdMLKeMlSgLlCcMLKe009eaoH2M<Ke03YeaoIgbOUea_]e
a_]gaoYgb?Mgb?Egb?=eb?9cao=ebOMba_AgbOUlb_]e_Nmi^neXY]LeJ9<X
CFXS@58P>dHV>chU=S0V=2L^>B/g?C<j?3Le=c@g>CQ3BDM=EU57E4XoD415
Dd93BCe1Bd=0EEPjGVYRUZih^]aa_nIaaO5^a?=_aOAaaO=ca_9daO9daO1c
a?5baO5aaoIabOUcbOYabOUaaoQ_aoMaaoQabOWoc<c<3/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooklc<c009DjoP
Ek?TEk?TE;3QE[3RF[CVGKGWFK7SGkGV009P]^L01f6gj6>fj6BgjFFhjVJi
jfRhjfZgj`02J[SY00Q[]nU/^>U_^NY_^NQ`^^U^^>M]^^Q`_N/2LKg^00=a
_nmc`O5__N/00W2nk003LKo]L/3^L/3^009b`?001Fo0kg72lG72lG31l771
lP02L/;c00=a`O9``_5ba?<00WG6m@=daO@2MLKe00=faoIeaoIeaoH00WG7
mP0ZM/SgMlWiMLKkMLKkMlOjMlSgMlSeMlScM/WcMLWeM<SfLLOfMLSjN<Sk
M/;dO/KhNkkbFYG1>6B7:4aV73e>7ca493Xh:CXb;cXb<CP`;S0[=SPe@DE4
C59@BU=@>dPo<d<f?4dmBE=8AU=<@5YK>V9/I9^`NKkMLl7WKlC]0Vo6l`03
L/KbM<OcMLKc009ea_<01GC6mG77mW38n779nG38n003KlOg00=`b?S<c<c<
c<`0olc<c0c<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooono<c<`02U:^geFahUB`hE:^ge>_h5Nci5ZdiUVciE^chefe
i@9P]^L2GkGV00=Q]nQU^>YV^>X00VJfj@09J;SYK;[[KK_[KKWZK;SYKK[X
K;WWKKWZL;c]009`_^h0172nkg;0l72nk72nk09a_nd2L/3^0W6ok@03Kl3_
L<7`L<7`009_`>l03G72lG;3lW72lFk0l773lgK7mWO8mgG6mG?4lgG3lGK4
lWO8mGK7m002MLOf0WK8m`0cMLWhM<OiM<OkMLKkM/KiM/OfNLOeN<WfMl[f
Ml_gM<SfML_jL/SiM<OiLl?dNLGfOlOiMKGSDXR^=fB37TIO6Ce=7ca29c`m
:STf:34/:BhZ=c`hBDe<DEMEAe9><d0i:cXc=THl=T<l?e9>AV=W@fmlI9jf
Lk[JKkoTKlC]KlKaL<ObLlOcMLSbM/OdMlSeM/SgMLWhL<Sh00E]b?L00fo7
mfk6m/c<c03oc<c<3Lc<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooklc<c00;DJgNDjoPDjoPDZkODjoPEk?TFK?UF;;T
FK7QF[;RGK?T009N]>D02EneiV2fif:hjF6diV>eifFej6Rhjfbjjffkk002
K[[[00=^^nU]^^Q^^^/00Vnmk@03KK_[KK_/K[c/009`_^`2LKo]17;0kP03
L<7`LL;aL<7`009_`>l01G;3lW?4lg;3lVfokg73l`02M/Of00adaOAb`o9e
`o5fa?9gb?Eea_=caOAda_Efb?MebOMdb?MbaOL2M<Ok02IeaOQea_Eha_Ii
aoEhbOIgbOQba_EgcOabb?UdaoUda_I``O1f`_=h_n]]ZmA?QJT_H7hRC6@P
@E8U?DLY>clZ=SHk@Cm5BTI>DdmCFEM;EU8hAd@a@ChiBDPoDE51FEdkGFLi
J7YQW[Yc_=eea>]baNl2L/Kb00idao5eb?9faoAfaoAeaoIdb?M`b?Q]b?M^
a_I/aoI_aoM`b?Q_aoM]aOGoc<c<3/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooooklc<c008CjkLDK3NE;3OE;3OEK7P
E[;QEk;QE[7P0UNah`0:F[;TG;CVGkOYH;SZHKOZH;KYH;?WH[GYI[SZIkW[
0VRhj@03JkWYKK_[K[c/009/^^X2KK_[00MY^^UY^NYZ^nY^_>Y__^U`_^aa
_nd00W;0kP9c`Nl00g31kW;3l772l@02L<7`00Yb`o9ca?=ca?=_`O5a`o=d
a?EdaOAd`_9d`_1e`o42MlGc00MdaO9baO5caOAdb?Idb?Mba_E^a?D00WC7
n`0bMLGhMLKeMlGeMlGcM/OfMLOfLLGdN<ckLLOhM<[kN<ckL/CcMLKaN/Oa
O<?]IjK?C8J[>FZ:;E9/;4UK=TUG?DY@DEUKF5iJFf5MFV=NDeeL@e5A?4]>
?e9HAUYUB6=d@fV0AGJDIjK9LKWQM<?^L/GaLlKbM<OcM<OaMLO_MLKaMLKc
LlGdL/KeL/SiKlOgKlGfKlOg0W77n003L<KgKlGfc<c<0?o<c<`=c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooo_c<c<
00=@[meA/=iE/N000eJbh@0CE[7PEK3OFK?UF;;TF[;TGKGWH;SZHKW[HKOZ
GkGXH[GYIKS/J;[/IkW[I[KWIKGVJ;KVJkWYK;[Z009Z^>P02VbjjVZkjVZk
jV^kk6fnkFjljVnnjG2nk76okG;0kP=c`Nl01G31kW;3l7;3lW31l772l@02
LlCc00Yb`o9a`o=a`o=b`_=a`_5c`O5d`_1fa?9gaO=e`o42LlCa02mca_9c
aoIcaoI`a_E^a?Edao]daoUeaoUeaOIgaOEgaO=gaOEea_EeaoMgboY_aOId
b_UicO]cao=fbO5jc?AlbOEa^^EVYM1ER[92KHloGWY9H79DHVeMIfUWKFUY
L6UUKVUJI6=8EUM1D5M4EfE4FW53HWhmIXI8O:=][=M`^NIb`?1a`o9ca_9d
ao400WG7k`06M<G`LlK`LLGcLLGdLlKhL<Kg1G;5m`03LLCfc<c<c<c<0?o<
c<`<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVKoooo_c<c<0U6`gP04DjoNE;3OEK7PEK7P0UJah004F;;TFK?UG;CVGKGW
0Ujfj006GKGWG;CVHKOZH[S[IKSZI;OY0VBfiP03IkSWJ;WXJ[_Z009X^NP0
2FVjjFZjjf^kk6bnkW31l6nmjfnnjG2ojW70j`04L/3^00=_`>ea`^ma`_40
0W72l@9ca?<01g72lG;4m773mG30lG31l7?1lGG3l@02M/G`00Ic`^eca>me
a_=dao=caoIba_D2L<Kg00Abb?]daoUfb?YgaoP3NLOg02]gb?MgbOUgb_a`
a_EeboYec?Mbao1fb^mdanmeb?Ac`Nme^NQ/Ym=MR[=FN9]KLh]QLh5VLG=]
MW5^N6m/MViSKFaCHFA:F6=:G71BJhXnH8HYE7loLj9b/NAi`?Aia_Yba?Ad
aOAdaO1faNieaneeanmca_1ba_AaaOAaa?IbaOL00W?5m`04L/CfLL?eL/Cf
L/Cfolc<c0k<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooono<c<`02U6`gU2_gE:^gE:^gE>_gUB`geJah5RchUJ`hURb
i09L]>H02UZbi5R`hUR`hUVahf2fjEnej66diV:eifFgifNij@9Y^^T016fn
kFZkjVVjjFZkjP9[^n`016fokg32lG2nk72ojP9a`>/2L/3^0W6ok@05K[o/
L<7^LL;aL<7`LL;a009b`o805G31l7;4mW32m6nol731l7G3lgK4lWG4kgC3
kW?2kG?4kgK7m7G8m7?7mW;6mG77n7;8nG;8ngC7nGK8nWS8n@02O<Si039k
bOUhbOQeaoUdaoUaaoIhcoafcOQbb_1hc?5ba^]db?IfaoImaOMl^^UbXLeZ
S[9XPYeXNXQ_OH1bOGM_NG1^NG5^N7MRKgEHIW=CIGdeCg92I95>N:QXWLn3
`_Q^]na`_O=fb?Yca?=daO1faNieaneeanmcb?5cao=ab?Ea`oEba?IcaOMb
a?Ib`_Ea`OAb`_Ec`oKoc<c<3/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH0oooooooooomgoooo00G<c<cooon8`;R8`;Q8T8P00@00000000B8
`;S8h=R8`;R8`;SoIVIVofIVIWUVIVH01<c<c8S0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000F8`;S8h=R8`;R8`;S<c<`0oooooooooomi
oooo0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVIYVIVOmVIVKoIVIV
MfIVIP04ooooR<2hR<2hB9280@00000000J8`;S8h=R8`;R8`;QVIVK<c<co
VIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nI
VIWoVIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVI
VOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVI
oiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWo
VIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnI
VIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVI
VGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVI
MYVIV@05IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
c<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUf
VIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<
c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJI
VIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<
c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVI
V@05IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<
oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<co
VIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nI
VIWoVIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVI
VOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVI
oiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWo
VIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnI
VIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI/c<c?nIVIT/VIVI0P0000:IVIT00`0009VIVIVIV@02
00000YVIV@@00003VIVI100000:IVIT200000YVIV@80003oVIVI;9VIV@05
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVI
VBbIVIT2000000FIVIT000000000002IVIT00P000003VIVI0000000000:I
VIT2000000>IVIT0000000000YVIV@8000000iVIV@0000000002VIVI0P00
0?nIVIT/VIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVK<c<coVIVI;9VIV@8000001IVIV@000000000009VIV@02000000>I
VIT0000000000YVIV@8000000iVIV@0000000002VIVI0P000003VIVI0000
000000:IVIT20000oiVIVBbIVIT01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI/c<c?nIVIT/VIVI0P000005VIVI0000VIVI0000
VIVI008000000iVIV@0000000002VIVI0P000003VIVI0000000000:IVIT2
000000>IVIT0000000000YVIV@80003oVIVI;9VIV@05IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVBbIVIT2000000FI
VIT0002IVIT0002IVIT00P000003VIVI0000000000:IVIT2000000>IVIT0
000000000YVIV@8000000iVIV@0000000002VIVI0P000?nIVIT/VIVI00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVI
;9VIV@@000000iVIV@000000000200000YVIV@030000VIVIVIVI00800002
VIVI00<0002IVIVIVIT00P000005VIVI000000000000VIVI0080003oVIVI
;9VIV@05IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
c<c<oiVIVBbIVIT4000000>IVIT0000000000P0000:IVIT400000iVIV@@0
0002VIVI0P000003VIVI000000000?nIVIT]VIVI00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVI;9VIV@<00003VIVI
0`000?nIVIU1VIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVK<c<coVIVI;9VIV@<00003VIVI0`000?nIVIU1VIVI00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVI
VGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVI
MYVIV@05IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
c<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUf
VIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<
c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJI
VIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<
c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVI
V@05IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<
oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<co
VIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nI
VIWoVIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVI
VOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVI
oiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWo
VIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnI
VIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVI
VGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVI
MYVIV@05IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
c<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUf
VIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<
c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJI
VIT01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<
c?nIVIWoVIVIMYVIV@05IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVI
V@05IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<
oiVIVOnIVIUfVIVI00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVK<c<coVIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI/c<c?nIVIWoVIVIMYVIV@05IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<oiVIVOnIVIUfVIVI
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVK<c<co
VIVIoiVIVGJIVIT01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oc<c<olc<c7O<c<`01IVIVOooohS0^8S0^4R@R00100000000
18S0^<SPf8S0^8S0^?mVIVKoIVIVNFIVIP04c<c<R<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0
`<1j`<300XS0^058T8P1000000001HS0^<SPf8S0^8S0^<c<c03ooooooooo
ogWoool2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVc<c<ofIVI_mV
IVIgIVIV00Cooon8`;R8`;Q8T8P1000000001XS0^<SPf8S0^8S0^6IVI_oo
ooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooooo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
ooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooooo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooolc<c37<c<`500000lc<c08000001<c<c000
00000<c<c0800002c<c<0P000?o<c<`ac<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<<<c<c0800003c<c<0P00
0004c<c<00000000c<c<0`000003c<c<0000000000;<c<`20000olc<c37<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ooo<c<`ec<c<0P000003c<c<0000000000;<c<`2000000?<c<`000000000
0/c<c080003oc<c<<Lc<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c3?<c<`4000000?<c<`0000000000/c<c080
00000lc<c00000000002c<c<0P000?o<c<`ac<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<<Lc<c0D00002c<c<
0P0000;<c<`2000000?<c<`0000000000/c<c080003oc<c<<Lc<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c33<
c<`400001<c<c0800002c<c<0P000005c<c<000000000000c<c<0080003o
c<c<<Lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooooolc<c33<c<`200001/c<c0800002c<c<0P000004c<c<00000000
c<c<0P000?o<c<`bc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<<<c<c0800003c<c<0P000?o<c<`oc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<
<Lc<c0D0003oc<c<@<c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
ooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooooo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
ooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKooooo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomgoooo00G<
c<cooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;SoIVIVofIVIWUV
IVH01<c<c8S0^8S0^4R@R04000000003R<2hb>3HR<2h0?n8`;SoR<2hOHS0
^058T8P10000000018S0^<SPf8S0^8S0^1H0080300600P02P00400:100>1
00>100>10`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP02
0@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@2
4HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<G
R0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;
0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>
00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_
T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87
=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8
?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9
A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK
0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]D
WP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP
00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R
3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>
JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X
3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ
0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<A
PJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`
0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[80
0a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<C
UKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL0
11FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj
0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]
_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0@008000i^WlC=3YC=3Y@09
<d>U1P00P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J2
00J200J20P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^4
00<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L2
58L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT3
0a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@T
S@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`03
1B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010Hb
TPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`Lh
U0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G
246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@04
2DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:
DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;
Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ
00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=
IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]
Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?
LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[004
47j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^
4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a
0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A
/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf
00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h
5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@F
Z[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h0
0aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0`00P007VjOaooooSWZfYY_4/jWBZ9g8/jWB00:VVl@01KbhgNk^
m>[YlOoooc=3Y@0500200`01P0800X001002P@03P@03P@03P@<0184200F1
00@01H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<1
2h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108C
Q`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT3
6HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS004
12B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>
1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A
0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`Lg
T`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F
00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH
2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:
D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh0
0`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ
0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eS
X`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP0
0`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@
O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh3
4H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::
/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?
/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf
0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P3
5Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<F
Z;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P03
5jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`20000026;C04000008H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P004VjOaooooK5ZU
[jG:0[bhg@0:oogo/jWBoooooooo_;SMUhZlZ9g8i^K/oooo<d>U1000P0<0
0H0200:000@00X400h400h400h4300B10P05P@0400F200J200J200J20P07
PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f4
0`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8F
Q`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<3
7HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd3
1BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6
;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHc
TP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9
BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd2
2e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;
FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<
H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]
47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<A
QJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d
4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLD
VkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[
_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_`8H]<000lSPf4R@R4R@R00<B92800<00038h=Q8T8P03DR@
R00400006;C06;C0b>3H3TR@R00300006;C06;C000:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2002000^KYo7ooonXWLSoooncZM9PC9Z>N[IhIJjX
WLSooooooOl00oooo`03<d>U0020002000<0080300600P02P00400:100>1
00>100>10`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP02
0@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50P8@Q@?o
ool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP3
5hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;
0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DW
SPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@
00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB
1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8
?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H
2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J
0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;
E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P
0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ80
0`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=
J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L0
10m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ
0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60
[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`
0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK82
4Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<C
U;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L2
59fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j
0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/
_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o
0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf00=R<2h00E8T8P0000H
]<0H]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P10000000018S0
^<SPf8S0^8S0^08008003Y^WlOooooooom_Lk61<VY>5^[>Yd[bhgF1<VYV?
_ZJKa<S3gooooc=3Y@H00803oooo0P02P00300:1oooooooo00;oool200B1
00<01H7oool01H800`06PPCoool00`48PP48Poooo`03oooo0`4:P`06oooo
0@^40@^40@b4oooo0@b40P4=Q004oooo0@j5oooo0@j50P8?Q@04oooo0Q25
oooo0Q250P8AQP03oooo0Q660Q:600824XH20Q>600@24hL258L258L258L3
0QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^9
0`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@U
S@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?
10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHc
TPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0Lh
U0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G
246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI
0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:
DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil0
0`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<
Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=
IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^
Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT0
10mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/
47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_
4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:<
/@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`03
4i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@D
V[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i
5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`0
11J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa
_QNa_aNa_`035k:o0aNc_`8H]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8
T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004
B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<00800
3Y^WlOoookbhgIV?__ooomKAgM_Lk??nojJKa>k^m8Ef/9>5^_oooc=3Y@@0
08001oooo`01P001P001P?ooo`02P?ooo`0300>100Koool0184018401H7o
ool01H8200J200Soool01h801h811h;oool128;oool128<30@V300Coool1
2X<12X?oool20@^400<138Coool138@00P4=Q004oooo0@j5oooo0@j50P8?
Q@03oooo0Q25oooo00?oool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<2
5HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT3
0ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=
0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl4
1Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B
1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD
00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8
@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT3
2DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YA
W@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`03
2eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aO
XPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eU
Y0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW
3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@04
3gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@
OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lA
Q:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba
00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<C
T[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ
]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TE
X;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_004
5Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n
5k6o5k6o00<G/[l35k>o0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P00dR@
R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000
008H]<001<SPf8S0^8S0^8S0^0800004R<2h0P0000:8`;P014R@R00001Rd
`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000nKYo7ooonI
SkjGR[cDdnS_[;?oMW_^Wj]KF:FVVlBFWm9PC9Zl^=gooolc@jD00`00P007
oooo006000600060oooo00:0oooo00<00h401_ooo`04P@04POooo`05POoo
o`801X802?ooo`07PP07PP47P_ooo`48P_ooo`48P`<12H<02Oooo`4:Pooo
o`4;Poooo`4;Q?ooo`4<Q?ooo`020@f400Coool13XGoool13XD20Pn500Co
ool248Goool248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ7
00@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<M
RP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<5
9Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]
T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B
0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@3
1cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G
0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9
VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;
DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]I
W`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaP
XPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY003
3FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW
0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`me
Z@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@
Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65
[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8B
SK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@C
T[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK
]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ
^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m
5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o
00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h
00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0
^8S0^002R<2h0P0000:8`;P200000hS0^004B92800006;C06;C00XS0^058
T8P10000000018S0^<SPf8S0^8S0^08008002Y^WlOoooiN:_7Y/Z[?7j:U^
X<S3gi>5^U]6TiV?_P9hIJh0148WQJnUb_oooc=3Y@@00803006000?oool0
0X000X401?ooo`8018400oooo`05POooo`0300J21?ooo`030@R20@R30@R3
00<12H<02Oooo`4:Poooo`4;Poooo`4;Q?ooo`4<Q?ooo`020@f400Coool1
3XGoool13XD20Pn500?oool248Goool00oooo`824HH30Q:60P8CQP040Q>7
0QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<I
R@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@4
98`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5
:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I42
1S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC
00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H0
10Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9
AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@
W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP03
2eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ43
35jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S
0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H2
3VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ003
3g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l
[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<A
Pjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa
4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc
0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H3
59Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<E
WkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX
^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G
[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0
^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8
T8P000000QRd`003b>3HR<2hR<2h00>8`;P4000018S0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008000i^WlOoooooo
o`02oooo00[o[K3oMW_icMCmkNkooonVVlB5M[2l^=gooolc@jD500200`01
P003oooo00:000:100<00h400oooo`04POooo`0200F100@01H;oool01X80
1X8200N200<11h;oool128800P48P`?oool20@Z300Ooool12h?oool12hCo
ool138Coool00P4=Q004oooo0@j5oooooooo0P8?Q@06oooo0Q25oooo0Q25
0Q66oooo0P8AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ8
0aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:
0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<5
9hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@
0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=980
0`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7
>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL0
10U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ
0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]C
W@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP
0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82
366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=
Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL2
3W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ
0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o
[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_
0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb
4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<C
Tk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL3
59bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i
0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/
_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o
0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000
R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P0
18S0^0800005R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0`00P00:XJcbnLgDhRHlm;FohRHlm6emo>?YoooooNg^ojf`
0_ooo`03<d>U0020002000@00803006000?oool00X000X400oooo`801840
1Oooo`05P@05P@05P_ooo`0200J20oooo`8128800`48Poooo`49P`020@V3
0P4:P`04oooo0@^30@^4oooo0P4<Q007oooo0@f40@f4oooo0@j5oooo0@j5
00;oool00`8?Q@8@Q@8@Q@04oooo00@24HH24XH24XH24XH20Q>600@24hL2
58L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV9
00@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@T
S0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZ
S`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86
<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<0
0`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04
242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6
V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L
00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;
Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<
GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<3
3FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>
KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?
LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/
111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63
[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4B
R[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<3
4i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<D
VKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO
^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk
0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN_
_P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h
00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@
R00000026;C000?8h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00=VjOaoNg^hRHl
o_GhmhVGm69^lj2^m69^oogoojf`o>?Yoooo<d>U00L00803006000?oool0
0X000X400`03P@<0184200F100@01H801X801X801X8200N200D11h812881
28;oool128<00`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn5
0`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<4
7h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=
1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086
;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7
=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9
@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:
BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<
Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`
Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?
MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd3
4H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<B
Qk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d
0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL
]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d2
5jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G
/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0
^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8
`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0P00P003VjOam/S<hRHl00;o[K001mlT;_nTW_Jl
aOn]/>ikS?oooc=3Y@0800200`01P003oooo00:000:100<00h4300B10P05
P@0400F200J200J200J20P07PP050@N20@R20@R2oooo0@R300<12H<01?oo
o`4:P`4:P`4;P`812h@30@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00:8`;P900000XS0^005B92800006;C06;C0
b>3H00>8`;P2000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P003VjOanLgDmhVG00;oool01on]
/>4F=?mfNonTW^8V??n9Oc=3Y@0800200`01P003oooo00:000:100<00h43
00B10P05P@0400F200J200J200J20P07PP040@N20@R20@R20@R31?ooo`<1
2X<00`4;P`4;Q04;Q0030@b40P4=Q004oooo0@j50@j50@j50`8?Q@<248D4
0Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP3
5hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@P
R`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDW
SP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6
;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB
1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D3
23fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH
2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<
V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;
E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaL
X00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQ
XPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D3
3VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`
Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1h
ZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@03
4H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8
/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb
00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@3
4iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg
00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT
^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G
[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd
`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@
R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0P00P007VjOaoooolj2^m69^oooomhVGnLgD00;o
ool00o>P[_oooc=3Y@0800200`01P0800X001002P@03P@03P@03P@<01842
00F100@01H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z3
00<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0
108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP3
6HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@S
S00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP03
1BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<943
1S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC
0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2
242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V003
2DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?
W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;
EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ
35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S
0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH3
3VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?
LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1k
Z`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<A
PZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::
/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk80
0Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD4
59Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PE
W[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW
^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^
_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h
00^8`;P00dR@R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004
B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<00800
2i^WlOoooon9Oooooo>P[_6CXOooooomoo>P[_oko3=3Y@0800200`01P080
0X001002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<1
1h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j5
0`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<4
7XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd0
0`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6
;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHd
TP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD
0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3
U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9
BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd3
2e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<
FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaP
XP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT
0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_
Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?
MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd2
4Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@A
QZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8B
SK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@0
0a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK
]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<E
X[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m
5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o0QRd`0o8h=P00`000<SPf<SPf00=b>3H00<0000H]<0H]<003lSP
f00300006;C06;C000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P40020
0i^Wl@06oooolj2^m;Fom[c5nmWJ<d>U2@00P0<00H0200:000@00X400h40
0h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R20081
28<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108A
QP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN8
0`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3
126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh0
0`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA
1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLe
TP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`Pm
U@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4
V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/3
2TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN
2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:00
10aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=
HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iY
Y@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?
LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X3
47V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61
[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;02
4XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P03
4hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E
]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`04
5Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X3
5ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm
00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h5P00P0<00H0200:000@00X40
0h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2
008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25
108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN8
0aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<4
88/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh5
9hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T004
1RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLe
TPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE
0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4
V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:
C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM
2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<
G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=
HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU
0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?
L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@
N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d0
0a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<B
R;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>
/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd
0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM
]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<E
Y;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d3
5jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH
]<02R<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=S8h=P0olSPf?o8h=Qmb>3H0DR@R04000000?n8`;SoR<2hPHS0^0400000
0001\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?oo
l?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`
l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003o
oo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;o
l?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000oooooooo
oooooh;ooooo000@oh:2PP03oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2
P_n2PX803?n2PX800on3Ph?oPX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:2
00coPX:200?oPh>3oh:2P_n2PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2
PP03oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2P_n2PX803?n2PX800on3
Ph?oPX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2
P_n2PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2PP03oh>3Pon2PX;oPX:2
00;oPX:200?oPh>3oh:2P_n2PX803?n2PX800on3Ph?oPX:2oh:2PP02oh:2
PP03oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2P_n2PX800_n2PX800on3
Ph?oPX:2oh:2PP0<oh:2PP03oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2
P_n2PX803?n2PX800on3Ph?oPX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:2
00coPX:200?oPh>3oh:2P_n2PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2
PP03oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2P_n2PX803?n2PX800on3
Ph?oPX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2
P_n2PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2PP03oh>3Pon2PX;oPX:2
00;oPX:200?oPh>3oh:2P_n2PX803?n2PX800on3Ph?oPX:2oh:2PP02oh:2
PP03oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2P_n2PX800_n2PX800on3
Ph?oPX:2oh:2PP0<oh:2PP03oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2
P_n2PX803?n2PX800on3Ph?oPX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:2
00coPX:200?oPh>3oh:2P_n2PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2
PP03oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2P_n2PX803?n2PX800on3
Ph?oPX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2
P_n2PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2PP03oh>3Pon2PX;oPX:2
00;oPX:200?oPh>3oh:2P_n2PX803?n2PX800on3Ph?oPX:2oh:2PP02oh:2
PP03oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2P_n2PX800_n2PX800on3
Ph?oPX:2oh:2PP0<oh:2PP03oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2
P_n2PX803?n2PX800on3Ph?oPX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:2
00coPX:200?oPh>3oh:2P_n2PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2
PP03oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2P_n2PX803?n2PX800on3
Ph?oPX:2oh:2PP01oh:2PP0000CoPh>3omgMgOoXj>Sokno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@07oo7al@03oo3`l?oalO7olO7a00;okno_1OoalO400oo`
l?3olO7aoo7al@05oo7al@7oj^[Z0OoKfm/1oh>3P`0000CoQ8B4on3Ph?oc
lo?oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0oomoOd4ookn
oP;oo?cl1?ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn0_omoOd1ooGe
m@7ohN7Q0On3Ph<00004ohB4Q?oPh>3omOGeooknoQ;ooooo0_ono_hBoooo
o`;oo_kn4_ooool2ooknoQ;ooooo0_ono_hBooooo`;oo_kn4_ooool2ookn
oQ;ooooo0_ono_hBooooo`;oo_kn4_ooool2ooknoQ;ooooo0_ono_hBoooo
o`;oo_kn4_ooool2ooknoQ;ooooo0_ono_hBooooo`;oo_kn4_ooool2ookn
oQ;ooooo0_ono_hBooooo`;oo_kn4_ooool2ooknoQ;ooooo0_ono_hBoooo
o`;oo_kn4_ooool2ooknoQ;ooooo0_ono_hBooooo`;oo_kn4_ooool2ookn
oQ;ooooo0_ono_hBooooo`;oo_kn4_ooool2ooknoQ;ooooo0_ono_hBoooo
o`;oo_kn4_ooool2ooknoQ;ooooo0_ono_h=ooooo`7om_Kf0OoTi>@1oh>3
P`0000?oPh>3omoOgooalO406_oinOT4oo[jnPCono_k1?olo?`IoogmoB3o
o?cl@?omoOdOooclo23ooOgm?oolo?`PoogmoB3oo?clW_omoOe0ooclo1Wo
oOgm3?olo?`Joo_kn`7ol_;b0OoPh>01oh>3P`0000?oPh>3omoOgooalO40
6_oinOT4oo[jnPCono_k1?olo?`IoogmoB3oo?cl@?omoOdOooclo23ooOgm
?oolo?`PoogmoB3oo?clW_omoOe0ooclo1WooOgm3?olo?`Joo_kn`7ol_;b
0OoPh>01oh>3P`0000?oPh>3omoOgooalO406_oinOT4oo[jnPCono_k1?ol
o?`IoogmoB3oo?cl@?omoOdOooclo23ooOgm?oolo?`PoogmoB3oo?clW_om
oOe0ooclo1WooOgm3?olo?`Joo_kn`7ol_;b0OoPh>01oh>3P`0000?oPh>3
omoOgooalO406_oinOT4oo[jnPCono_k1?olo?`IoogmoB3oo?cl@?omoOdO
ooclo23ooOgm?oolo?`PoogmoB3oo?clW_omoOe0ooclo1WooOgm3?olo?`J
oo_kn`7ol_;b0OoPh>01oh>3P`0000?oPh>3omoOgooalO406_oinOT4oo[j
nPCono_k1?olo?`IoogmoB3oo?cl@?omoOdOooclo23ooOgm5Oolo?`0:?nW
_M;oZKc:ok70`ondZ:SoXfI^ojUEIOnXEVcoTUU/ojnRZon]^k_o/lK2oiFZ
XomjRhGoCEaIodICFOmHHfOoFfAOodA;@om2ACco>C`cod53>?m>D4GoATLo
oe1ABOmJGEKo?T4jocTl<om1@cSoBTPkoe9<??mHDCkoIEi;oeeLB_mPHE7o
IVQJoemQDom2AC[o=cdaod=8@Oll@c/2oci5?P1;oca3>oloASkoA4U2od15
?_m2ACcoCDhnof9K@OmcJT_oLV]AohAoJonMVhcoYJNLoeaQF_m0BT;o<S`d
oc<n=_ld?cOo<chfocU0>OloASoo@dQ4odQ6>_mPCcGoHdh_of9@>?mVFdWo
JVIKofUZI?maLg3oP8F1oi:CRonWZ9[o_;ZSolk9ZooNfK7oiMj`onCJYooN
ejWod]>com7E_?omonconOkZongdh_oKhM?o_<Bioj:YX_n9TXooB51Boci6
BOlY<3So9Rdgoc@jA_lc>DOo<CY;ocA6F_lgD6Ko>U=YocYGJOm0Gg7oB6Yf
of25S_n4Yj_oZ<[;ok[Idoo=i=cof>[Lomk[f_oMiM3og=o:onGQa_oZfK_o
lmbjoo;L]oobg;Gomn6j00;on>>h00?oo>NjoogmoOomoOd0S_omoOe0oocl
o1WooOgm3?olo?`Joo_kn`7ol_;b0OoPh>01oh>3P`0000?oPh>3omoOgooa
lO406_oinOT4oo[jnPCono_k1?olo?`IoogmoB3oo?cl@?omoOdOooclo23o
oOgm5Oolo?`0:?n`aMSo/<?Aok2o`_ng/kCo^i:HokEiPonGFV[oSV9aokF[
/onb`<3o[L?0ohZSWomdR8KoA5ACocm=D?mAG5koDEYEod58@?m1ASoo?D0g
odA7?_mBDd_oB4U1ode@BOm3ASoo>chgod95?_m3AC[o@T0dodY7=_mJDd7o
JFA@of9QComGF4SoGV1Boe1BAOlj?C;o?D<god56?om2BD42ocm6?`0goci5
?OloASko@TM0oce2>om0@c[oBT/moemH?_mcJT_oO7EKoiZEPOn^[9goYZRM
odeBBolmA3go=Clgoc8m=Olc?SKo>D<kocm6?om0ACoo@DI2odE5>omBBSGo
FThfof=KA_mcK5[oNG=Wofm[H?m]JF3oNW=YogUaI?n6OfcoTH]coiZEN?ne
/Y7od]:/omOI/_oCf[So/;fYojNgZ_ngbKgo^L[0om3QeooSm>cok_oiooGo
oooChN7oBUQHob@_<Ol[=SSo;3Djob4Z;olK92Wo9Blhob4a?P02oale@`0B
oaliA_lR?T[o83i8ob52BOl/Bdko>5IFodEOG?m>IEooFV]QofmkKon7SGoo
XJFFokZiYOoDc[KohMNlonSN`oo[h/Gok^G60_o^hl<00oodj/OooOgmoogm
o@2>oogmoD3oo?cl6OomoOd<ooclo1[ono_k0Oobl_81on3Ph07oPh>30000
0on3Ph?ogmoOoo7al@0JooWin@Con_[j1?okno/4ooclo1WooOgm8?olo?a0
oogmoAooo?cl8?omoOdEooclo01hokC6e?neam?o/<?9okG0`_o3`L;o[:2R
og5NH_mkK77oXj>Uok?1`_nU_l3oO9ZJofR2PolfBdco>4Q8od]GEom3CT[o
>D<koci5?Olj?cSo@dHoodmBBom4Ad3o@TM1oce2??lj?cWo@DI0od95??m8
B3koG5Y;ofMQDOm[IU?oIfIDoe1A@OmFF4[oA4HiocTl<Om5Bcoo?d@mod99
@Om0Acoo@TU1od17?oloASko?d@mocXo>?lm@3OoB4Tkof9L@_m_J4_oPWaT
oiZHPonf]jOoSI25od57?OloASko?dU0oc]5??llASgo@Ta3odI=AOm1ASoo
@48mod15?om6D4GoAE12oeEKCOmeMVSoT8UiohaoK_n4Ke[oQFeEoiAjHOnI
Q6WoVh]aohZ4J_nEVXCo[;fZojS1[_nN_kKoVL35oi>naonC^lGoS[JnoiW0
aonI_/CoVkfooijm_onA[Jko?EICocE<A_l^@C_o7BhVob0`9_lU<RSo72TP
ob<b;olN;Rko7B`_oada<_lN<cKo83Pjob0i?OlL=SOo7SHhob]0@OldATKo
>dU9odE@C?m>E53oF5eGof9YH_mFHecoFV]SofEdKOmjRX3oVjRNokG1]Oo7
dLKoe=c?T?omoOe0ooclo1WooOgm3?olo?`Joo_kn`7ol_;b0OoPh>01oh>3
P`0000?oPh>3omoOgooalO406_oinOT4oo[jnPCono_k1?olo?`IoogmoB3o
o?cl@?omoOdOooclo23ooOgm5Oolo?`0N?nb`lgo]<K@ok?:d_n/b<_o[lg;
oi6ZY_m>F5OoGf=RohF=Sona`<?oX;g1og2AU_mKN7ko<DU=oca<C?m8E5;o
?4M3ocM2??ll@cco=chfoci3??m:CDKo@DI0oci3?Om2B4Co>Clkoce2?_lo
A3goD597ofMXF_m[J5OoIV=BofARDom>D4;oD595odI8>om1A3WoBDa1oci3
??ll@c_o@4Lood=:@_m2BD7o?dHnoci3??li?SOo?3lfodI7>OmRG4CoKFI:
ohF1J?nETWoo^kb^ofQ[H?m1Acgo@DQ0od=:@_m1Bd3o@de2odM?A?m7CD?o
ADQ1odA5?om2Ad7o?d]7ocM6?om1Bd;oHVIHogmlJon6NVCoPfmFohM`DOnD
OEkoWhY]ojZLP_nJV8?oVjJHojVn]onK^KWoTk_3ohfmdOn<`][oS/;Hohg0
don?_/koTKg:oiFmaon</KOoHh:5obe:B?l_AT3o9SXaoah^8olU<bCo:SLV
obLb9?l^=R_o9c4XobHa:OlS<2Wo6bXWob0`;olX>3Oo8cDeoad/;olU=3Oo
:cTloc0k?Olh@TCo>d=5od15B?m3CDkoBemPod9LFollE5Co@5UFoeE[JOmT
NWOoKX5mogB7Pi3ooOgm@?olo?`Ioogmo@coo?cl6_okno/1oo;blP7oh>3P
0On3Ph<00003oh>3PooOgmool?3`01[on?Sh1?oinOT2oo[jnP;ono_k1?ol
o?`IoogmoB3oo?cl@?omoOdOooclo23ooOgm5Oolo?`0J_neb<oo/<O?ok;@
f_nTcM?oU<_8ogja[?m:If?oDf=RohJAToniblooUkS1ofZ?V?mIMH3o?E5H
odABDom3CT[o?DQ2oc]6@?lmA3go>D0ioci3??m8CDKoAda6odE:A?loAD7o
=Chioca2?_loA3koAdQ0oeEEBOmLFD[oGei<oeUJC?m@DTGoBT`oodU=?om8
Bd3oATTnod56?olj?cSo?TDmod=:@_m3B47o@4Dnoci3??lj?cSo?3lhodE5
>OmFDC_oLF]AohN2K?nUY9;o]KJXoe=FBom6C4;o@4Looca4>Om4C47oAdm2
od98??m1A3WoATLoodU9@Om8Ad;oATM2odE7@_m8BD7oDUA7oeYMC?mKGDOo
IVA;ogMfF?mcLUCoOWeQoi2BOOnKWi7oZ[FaokO6bon``m7o[lcNoik<honE
bn?oU<SNoi;5f_n:^L_oT[c<ohjb`?m`TI[oCVY^obm4Aol/?3_o9c<_oc0j
<_l_=2go<3<Zoc/m<_lj?2oo>3X/oc/o<Olh?S;o;cH^oc4k<olf?cco<CXi
oc<m?_le?d42oc<m?`07ocU3AOlkADOo?4A7ocm9B_llBT[o@U9Aod5DDP02
od1CC`03od1CCOm3EdkoBemF093ooOgm@?olo?`Ioogmo@Koo?cl1_okno/J
oo[jnP7ol_;b0OoOgml1oh>3P`0000?oPh>3omoOgoo`l?006_ohn?P4ooWi
n@Con_[j1?okno/Cooclo0Kono_k1_olo?`Doo_kn`Koo?cl1_okno/doocl
o0Kono_k1Oolo?`Doo_kn`Koo?cl1_okno/Dooclo0Kono_k1_olo?`?oo_k
n`1hokK=don[a/goZm3Ioj;Cf_nDd=7oT/S8ogNEUomgRH_oYK:hol7Eg?n6
ZkCoLYRSofJ0SOm=GVSoBUEGoca7@olnAd;o?4Hnoc]2>olk@3Wo?d@modM<
AOm<DD_oCE9<od57@olg?CWo?D<oocm4?_m2@c_oBDTmoe1=?_mGEDKoDU=5
odmAA?m4B3[oAd/modQ;@?m2ACco@DLmoca1>_lk@S[o@4Lood56?oloA3go
?T<loc]0>Oll?cSo@T@godm=>?miM5koQH9_okRfYonCThOoCe99odY=A_m6
BdCo@4Pmod]AAOm;DD?o@THhocdo<_m4A3[oBTLnodQ4>omFCdOoEe18oe1>
@_m:C3ooBDdnodQA?_mDGD[oIg1KogIoJ_mfOfcoNXEgoiBOUona_Kgo_<WA
okg:f_nid>;o/=KYoj?Bi?nUdn?o[=KVojG;f?nQ`looMi>NodENIOl[?TCo
=DA7oci8B_l`=SKo?Clnocdm>olk>SKoAD8kocdk;oli=b[o>3P/ocXj<?lj
>c?o?Slioci0>oll?S_o<cLfocLk??lf?3co>450od19A_m0BdOo?DQ4oci9
AOliA43o@4a8odEBBom7E4goBUM>odQHC_m9FDooD61ER_olo?`6oo_kn`Ko
o?cl=?okno/6ooclo0Kono_k4oolo?`<oo_kna[on_[j0Oobl_81omoOg`7o
Ph>300000on3Ph?og]kNoo3`l00JooShn0ConOWi1?ojn_X4oo_kna?oo?cl
1_okno/6ooclo3Cono_k1_olo?`6oo_knaCoo?cl1_okno/5ooclo1Cono_k
1_olo?`6oo_knaCoo?cl1_okno/6ooclo0oono_k01ko/<oDojO:d?nRc]Oo
Y]KPoj?Bg?n]dMgoZkW6ojnga?njb=?o]<oJog2FXOn7[KSoOI>QoeMSKom8
CeGo?dQ5oci4@?lk@S[o>3lgoca2>?m2ACcoADPooda?B?m>DdgoAT]5ocXo
>Oll@C_o?d@modQ:?omBDdD2oeAA@009oe1BAOm:CD;oATTnodA7??m6BD3o
A4Lnoc]1=oloAC_o>Chg00;o?d@m03Oo?D8koci3??lk@3Wo>chgoci0=OmB
DCgoNgUTohf<N_nk_:koKFmToe1CB_m<CdSoC55:odY@A_m=DdOoC512od=5
=om0@C?oAD<godM5>Om8@SKoF4lnoeUA?_m@BS[oA4Dgod57?Om3CDCoBUE?
oe9OF?mbOW[oMX9nogF1OonJYZCo^/S9ol7?d_o8emco`=?IokoHgOnge=So
]=3Dok[CeonkdmOoZ[g1of=bMOloCDko@D]=ocHn@?lg>cko=CHhod51@olm
>cko?STmodI2@Om9B4?oA4@l00;o@Chi00ko@d8mod50??m0?c_oA4<ooda=
B?m<CDOoADQ1oci4>_loAc[o?DPjoce:>Om2CT3oAE57odMAB@;o@de400Co
BUA;oe1HCOmBFTooEUiC:ookno/6ooclo0Kono_k=?olo?`6oo_kn`Koo?cl
>Ookno/Joo[jnPcono_k4oolo?`4oo_kn`Con_[j1?oinOTJooShn07olO7a
0OoOgml1oh>3P`0000?oPh>3omkNg_o_knl05_ogmoL8ooShn0ConOWi2?oj
n_[9oo_kn`0YojS=eOnWcmOoX<oIojKDhOnXc=co/LOLokS0eoo7cN?o]l[K
oj6ob_mPQY7oVl39ohjR[OmIHfgo@TUAodU>DOloA3ko?D<iocY0=_m1A3Wo
ADLlod=5>_m:Bd?oCE19od13??lg?3Go?d8kod54>om9BCgoEeE6oeYDA?mF
Dd;oDeE8odM:?om=D4Go@dHkodI9@?m8Bd;o=3X`oci4>_lg?3D00_lm@S/0
Aoll@C[o?T<loc]0>Oli?3Go>cdboeAB@omgMV;oWYn?okbn/OmQHeSoDeI=
odaAB_m<DTSoAde3odI:??m4ASWo@T@fodE3=_m6A3OoB4@iodY4=_mDCSSo
GUQ2oeUF@om9BSco@4<lod16A?m8DE3oDe]Mof1XJombO7koN8:3oj>_[oo2
d=3o_m7AolSLfonmdM3o`mOHolOKf_o1dm?o`];AolKDe?nU/K7oCEMFod19
A_ll@T3o=cdkocm3@_lk?Cco?3hmocdo?_m4ATGo?d50ocXj>?ln?Sco?clm
odA3?om7AT;o@3lkod0l>Om<BDCoADDmod];@Om;CD3oBDdlodQ??Om6Cc[o
AE4iod]G@oloBScoAU1700;oBe=800CoDEM=oeEKDOmNHESoJFaQR_okno/6
ooclo0Kono_k5?olo?`6oo_kn`Koo?cl=ookno/2oo[jnP;onOWi7_ohn?P1
oo;blP7oh>3P0On3Ph<00003oh>3PooMgMgokno_01KomoOg2?ohn?P4ooWi
n@Son_[j=Ookno/Poo[jnWCono_k027oZLoLojO?fonScm[oZLoLokK<hOnm
bnGo^L;OokW9hon^b]ooSk?1oe^0R?nWb<goY[o3ofYiP?mIH6[oAdY?odE7
@_lm@3Go>cd`odM7>omCDdOoDU96odm?AOmDE4[oBT]3ocXm=?m0@CWoA4Hk
oe9@@omGE4?oH5U7oe9=>_m8BSd00_m0AS`0>?m1Acgo?dDkoci4>_m0@c[o
>cheocm2>Om3ASgo?d8kod=6?olm@3WoA4M0oc]0>_ll?cKoDE94ogenK_nY
ZIgo^K^`oeeNE_mCETooCU=<odY@A_m=D4OoBDdoodE7>_m2A3KoAT@godY8
>om?Bd3oDTi2oe=@?OmGET;oEE=4odM7>olo?SWoA4=1ode;C?mCDECoHf5R
og5aLOmlP7oo/Kbhokg=b_o5fmSo`]oKokoIf?o4fMcocMoSol7@doo6e]Ko
a]CDohNFTom5DDgo?TU3ocU4??lg@cWo=T8h0_lg@cL2ocI2=P0IocQ4>_lg
@3_o>d4oocm3@_m3AD;o@TA1od11??m2@CgoATE0odM4>om8B3coCDhnodmB
?Om?E3koC5@lodUB=om6D3So@Tdoocm9@?m>EDgoDEQ@oeQOEomEG5CoI6UR
ofM]H`0aoo[jnT3ono_k6Oojn_X<oo_knaCoo?cl3?okno/Joo[jnQKono_k
1oojn_X2ooWin@;on?Sh2?ogmoLFooKfmP7olO7a0OoPh>01oh>3P`0000?o
Ph>3omgMgOo_knl05_ogmoL8ooShn0;onOWi0_ohn?P8ooWinC?on_[j0_oi
nOT2oo[jnQconOWi0_ojn_X2ooWinG;on_[j07;oYL_NojG<gOnXd=co[LkM
ok?8gOnfan7o/<STojo=jOnZc^CoLiNUofV8SOnfe=CoY/G0ogR@T?mWL7Wo
GemWodA6@Om2A3OoATLiod=4=_mEDdKoDe54oeUGBomIFDgoBd]3oc`m=Om0
@SOoA4@hoe1>@OmHDT;oH5U6oeIA?_m=Cd;o@TPnoci4>_m0ASco?T@joca2
>?lm@3Oo>Sddoci1>?m1A3_o@4<lod95?_m0@cco@dHooca1>olj?CKoDUA7
oh63MOnf^:go];N^oemRFomDEe3oCU=<odeBBom:CDCoADTkod53=_lo@C?o
@T<eodU7>_m>BSooD4a0oe=B@?mFED?oDe54odU6?Om3@3_oAd=0odi8B?mB
C4coKFMWogimNOn=Sh[o_lS3ol?Dc_o3g=Ko_mkHok_Ieoo1fMgob=_RolCG
gOo5em_o^<O:ofQhMolmC4Wo?4U2ocI3>_ld@COo=48eocE3=_lfA3Go=D<d
ocE6=_liAc[o=44jocI1?Olj@cko?dE1od15?om1@ckoA4DoodM8@?m;Bd7o
C4doode>?_m=D3goCU4lodiC??m=DcWoBe<lodeA@om:CD82oe=FC@04oeUL
DomHGUCoJVeTofecJBoonOWi0_ojn_X2ooWinCcon_[j0_oinOT2oo[jnQ_o
nOWi1?ojn_XLoo_kn`Con_[j7?oinOT2oo[jnP;onOWi5?ojn_X7ooWin@Co
n?Sh2?ogmoLFooKfmP7olO7a0OoPh>01oh>3P`0000?oPh>3omgMgOo_knl0
5_ogmoL8ooShn0;onOWi0_ohn?P8ooWinC?on_[j0_oinOT2oo[jnQconOWi
0_ojn_X2ooWinG;on_[j02;oZLgUojW=hon]dN7o[LkMok7>h?n`dnOoWloU
oh6eb_mZUJSoBF]goeYcMonE/ZgoYL_0ohb]Y_mGI6[oJf]coe1CC?m>D4?o
D553odA2=OmKF4WoFeM;ofITF?mRHUKoCdm7ocho=om1@cSoADDioe5?@_mI
Dd?oHea9oeYE@_m@DdSo@dY20_lm@S/0>?ll@C[o>ChgocTl<olk?SGoATLo
odA5?Om4Ad3o@4<lod=5@?m2A3oo@DI0oce2>om=D4GoP8Afol;5^_nVZJ3o
GEmJoe5FD?m<DD_oC55:odA7?_m0A3Ko?T0coci0<_m5ACWoC4a0oe=@AomG
DdSoEU12oeQBA?mBCT?oAd@kod8o>_m5@SgoBDE2od]8@omUHUgoOWehoiBG
T?o6d<Soa]G@olGJeOo3g]Wo`=cMol7LiOnnfNCoaMgWolGLi?nY_/?oCEmQ
oca<C?lhA4;o=40loc<n>?lc?SKo=T0g0_lg@CP04?li@c[o>dLmocI3>Ole
@SSo=T<iocY6??lmAcco?dLlod57?Om6BCkoCU15oda>@Om<CT3oCDm1odmA
@omAE4<2oe1C@P08oeICA?mEDT?oFEE9oeEAAOmHETWoFea>ofa^H?meNFX_
ooWin@;on_[j0_oinOTloo[jnP;onOWi0_ojn_XKooWin@Con_[j7?okno/4
oo[jnQconOWi0_ojn_X2ooWinACon_[j1ooinOT4ooShn0SomoOg5_ofm_H1
oo7al@7oh>3P0On3Ph<00003oh>3PooMgMgok^k^01Kom_Kf2?ogmoL4ooSh
n0SonOWi<oojn_X2ooWin@;on_[j7?oinOT2oo[jnP;onOWiL_ojn_X08on]
dN_o[<kWojo?i?nXbmko[=GWojSIj_n2`M;oAH2@oc=JJolgDUgoAe]LofR2
NOnLaKGoWL>hoe=RIOmWJVooIVURoeaNDOm@D4CoAT@goeMEB?mOGE3oJ6IJ
ofIVG?m?D4So?3lfocm2>Om5AccoE596oeQEA_mSG4[oEU=2odiAB?m3BT?o
?44k00;o?44j03Ko=c`eocXm=?m2ACcoCe18odM8@?m4Ad3o>Sdfod53?_lo
@Cco@dQ2od97@?m:CD;oP8=holW<`onBUHkoFEiJoe1EDOm9CT[oB4e6od95
??m1A3Wo?d<eod53=_m4ASWoBd]1oe5AAomGEDWoEeA5oeQEA_mCCd?oBDHm
od8o>?m3@3_oBDA0ode8A?mMFUGoNWUdoiBFTOo:dL[oamKAolGJeOo3gM[o
`]kOol7Ni_nlf>?o`McUolWPj?nN/kSoAEMKocm=C_ld?Soo=ChmocHl>_lg
?CT2oc]0?00KocXn?Oll?Sgo>T0locY6??lgACSo=d<gocU5>OllAcWo?THi
ocm7>_m2B3coAde1odU<@Om:CD;oCU15oe5CB?mBE4WoD597odm?@omFDTKo
FUA6oeMDAOmBCT;oDe54oeQHC?mYJEgoMgU/02oonOWi0_ojn_X2ooWinCco
n_[j0_oinOT2oo[jnQ_onOWi1?ojn_XLoo_kn`Con_[j7?oinOT2oo[jnP;o
nOWi5?ojn_X7ooWin@;omoOg0_ohn?P8ooKfmQKomOGe0OoalO41omoOg`7o
Ph>300000on3Ph?ogMgMonk^kP0FooKfmPSomoOg1?ohn?P8ooWinC?on_[j
0_oinOT2oo[jnQconOWi0_ojn_X2ooWinG;on_[j07?oZ/kVojO;hon/c^Oo
Ym3VoicAhomm^l[oGin[ob]QKOlbC5Wo>DM@od1<C?mBIekoR:bNoiBh[?mG
IfKoDU]JofebJomSIU_oBde2odM7>om6AS[oDU98oeEEBomPHEWoBTm9ocLl
=_li?SSo@DLmoe9DBOmDEDOoFeQ7odi<?Om5BT?o@4Y2oc]2>olj@C[o?44j
ocTn=oln@CSoC4e5oe1ABOm5ASko@D8locHg<Olm?c[o>S`god15?om0ACko
Be57ohF;Ooo;d<WoOhAnoeUNF_m@EE7oAda8odA9@om2Ad3o@TPlod16>_m0
@cSo?T4fod52>_m4ACgoB4XmoeIH@omHFTCoEEI4od]<?_m4@CSoA3lkoda4
@_mCBdWoIUiLoh9mN_nIVIOocM?AolWHeOo6g=Wo`]oMol7Ogoo1gN7o`mcQ
ol7Hg_o:gN?oTZ6TodQCEOm1BD_o=C/kocXk?Olk>cgo?S`ood4o@_m1?dCo
?CY1ocdh?oli>C_o?4<kocQ3=Olg@SCo>D@foca4=olmACSo?dLlod59?_m3
Bd3oA4Y0odE;@Om:CDCoCE19odmBBom@DD_oCe18odiAA_mDEdcoDUA900;o
Ce1800?oDeA>of1QFomfMg40;ooinOT2oo[jnP;onOWi??ojn_X2ooWin@;o
n_[j6ooinOT4oo[jnQcono_k1?ojn_XLooWin@;on_[j0_oinOTDoo[jnPOo
nOWi0_ogmoL2ooShn0Som_Kf5_oemOD1oo7al@7ogmoO0On3Ph<00003oh>3
PooMgMgok^k^01Kom_Kf2?ogmoL4ooShn0SonOWi<oojn_X2ooWin@;on_[j
7?oinOT2oo[jnP;onOWiL_ojn_X05OnWcNCoXlWPoj_CkOnXe^koQ/?Fod^:
VOm9Oh_oAFYcoce7DOm9BE7o?TM6odeNE_mnW93oNIN=od5BC?m1C4SoHFQQ
oeiTF_m9C4?oB4]0ocXk<`02odA5?@0=oeIID_m9Cd_o<c`gocPn>_m2BD;o
DEA;oe5CB?mFE4OoB4Ploca1>_lnAd;o>d8kocU0>@02od15?P06odE6?_mB
Dd_oCDi6odA5?Oln?cWo>S/e0_lm?cX02oln@cgo?T<lodmEBon>U8[obLk7
og1eKomEFESoBdm>od97@oln@cgo?d@m00;o@4Hl02Ko?T@hoci1>?ln@C[o
@4<lod95>_mCED3oEUQ2oeEG@_m<Ccko@d<god10>?m7A3ooCdY7ofMRGon3
OgkoVI^JolcEe?o;fm_obMkQolGQiOo3h>CoaMkRolcQi?o8fmoocMcOoiBO
XOm=EeKo@DM7od12@Olk>c_o?C/loclm?_m4?d?oA3m5ocdk@?lj=cko>CLj
oc/m>0;o>3df00Co>d4goca2>?lmAC[o?dLl0om2BSl02_m3BCooA4U2odQ;
A?m<CdSoDE9<oe9EC_m<DTSoDeU?odmDCOmAETl2oe1BC@03oeQJEomdMW?o
nOWi02konOWi0_ojn_X2ooWinCcon_[j0_oinOT2oo[jnQ_onOWi1?ojn_XL
oo_kn`Con_[j7?oinOT2oo[jnP;onOWi5?ojn_X7ooWin@;omoOg0_ohn?P8
ooKfmQKomOGe0OoalO41omoOg`7oPh>300000on3Ph?ogMgMonk^kP0FooKf
mPSomoOg1?ohn?P8ooWinC?on_[j0_oinOT2oo[jnQconOWi0_ojn_X2ooWi
nG;on_[j063oY]7Toj;?i?nTdngoV]3/ogNec?lhKh?oDVmoof]cP?mHC5Ko
G4mFoe5CD_mBGU[oKh1joee`J_lb@C[o?4U0odMBB_m<ETko@DQ0od57?Oll
?cSo@dQ1od15?om8CT[oA4e:oc4l>?lg@3go?dQ3odYABOm7CD?oCDm2odA6
>olg?SOo?TM2oc]2>olh?cSoADY3odQ=A_m:Bd?oDeA<oda=AOm4ACgo>c`f
ocdn>?ll?SWo@D<noci3?om0ACooC55:oi6GSOo2al3oIFYTodmCD_m4B4Oo
?D<ooc]2>olk@S[o>d<hoca4>OlmAC[o@DHood97@?m2Ad7oA4Dmoe9@@OmE
DSooEEA2odiA@?m4B3Wo?d<docm5=om3BCgoGF=IogYoN?nEViWobmGGolgJ
h_o;gNWobmk_olWOkOo<h>Ooc=kRom3Oh_oAgn3o[KNfoeiWH_m1Ad?o@dQ2
oc/n=olj?CKo?3lhocm2>olo@Cco>SliocPm>Olj?3T2ocXh>@0Foc`j>olm
?C_o?Cljoca1>olnACko@TU1ocm9?_m1Bd3oA4a1odA<?om6C43oBDm3odmB
AomCET_oD5=:oeIID?mAE4goF5]Doe1ECom;D4[oCeEAog9hM2oonOWi0_oj
n_X2ooWinCcon_[j0_oinOT2oo[jnQ_onOWi1?ojn_XLoo_kn`Con_[j7?oi
nOT2oo[jnP;onOWi5?ojn_X7ooWin@;omoOg0_ohn?P8ooKfmQKomOGe0Ooa
lO41omoOg`7oPh>300000on3Ph?ogMgMonk^kP0FooKfmPSomoOg1?ohn?P8
ooWinA?on_[j0_oinOT2oo[jnW_onOWi0_ojn_X2ooWinAcon_[j0_oinOT2
oo[jnQ?onOWi02goYMKWoj;Ej?nIcNGoRKoGog>/`?loK7ooG6mmog1`N_mc
IVgoEd]?of1RHOmFGeco@4Y9od1;AoljACoo=D8ioc@o>olh@cgo=T0hocHm
=Om2Ad3oC55:odM<AOlmA3go?DLoobdf<Olc?3Wo>T<nod58@Olm@ScoATM1
ocm2>olf?CKo@DQ1oc]2>olh?CKoBTe4oe1CB_m=CdCoDE=8od]<A?m3A3ko
=3L`ocTk=_lg>C@00_ln@cl0?Om4BD?oAda5oi>HTOnm`[coH6EQoda@Com1
ADCo?d=2oci4@?lm@Sco>T4iocY0=_lnA3[o@dQ1odE:A?m2Ad?o@D8loe=?
@omFDdCoEeE6oe=DA?m<CckoADThod58>?m2B3[oGF=Gog^2N_nEWY_ocMOI
olgJhoo;fnSobMc[olKLj_o=hNco`mCLoloNhooChN;ob=;AofigL_m2BD;o
@4DnocTo=Olh?SCo>CleocY2=olk@cSo>T4iocU0>?ll@C_o>SPkocdh??lm
>cko?cdnocdm>olk?CSo?44kod17?oloAcco@d/nodM?@_m:D4800_m9Cd40
2_m>DTCoDEE7oe9CBomGFU?oD5=<oeULEOmAEU3oBDi8odaCC?m`NW8aooSh
n43onOWi7Oohn?P2ooWin@;on_[j7?okno/2oo[jnP;onOWi7?ohn?P4ooWi
nACon_[j1ooinOT2ooOgm`;on?Sh2?ofm_HFooGem@7ol?3`0OoPh>01oh>3
P`0000?oPh>3omgMgOo^k^h05_ofm_H8ooOgm`Con?Sh2?oinOTCoo[jnP;o
nOWi0_ojn_YkooWin@;on_[j0_oinOTLoo[jnP;onOWi0_ojn_XCooWin@1J
oicEj?nPen_oV/oQohJgb?m`WZ_oJHjGof^2R?m`NgooHVIYofATI?mcMGCo
G61OodA8Aoll@T3o@DM5ocQ1?_lkADKo=3hmocQ1??lh?cSo>d4goeMJComM
HE?o>d4coce3=Ole?C3o<cXbocPm=olj?3Wo?3`noc`j?olf=SSo=CXfodA;
A?lk?SGo>cdbod];?omEEDWoFUY>oda>@Om4ACgo?3lhocPm>Olg?3So=S/g
oca0?om2ATGo@DI2odQ?B?n<Th_o]kjgoeMMFOm;CdkoATY9ocPl>olh?CWo
?3hioca1>_m0@c[o?dDkod56?om2Ad7o@4E1od12?OmHET[oEeE6oeECA?mC
DT3oEUM5odA5=Om<CCooDU98oemNFOmjNWSoZ:b]om3Hfoo9f=_oc>7TolKP
hOo7hnOoamo[olOJjOoAhnooc]gTolKAdomQJVWoBE9?oc]1?Olg?SOo>3lh
0olj@CX03?ll@C[o?d8kod11??lk>c_o>SXlocTi>oli>CWo?Cllod94?om3
ASoo?dDkodE;?`;oAT`n00goBDdood]?@Om>DT?oD5A5oe9FB?m>DDSoDUA?
oe1BCOmLHE_oE5UBodaAB_m@EDkoLGQ`037on?Sh@?oinOTMooShn0;onOWi
0_ojn_XLoo_kn`;on_[j0_oinOTLooShn0ConOWi5?ojn_X7ooWin@;omoOg
0_ohn?P8ooKfmQKomOGe0Oo`l?01on3Ph07oPh>300000on3Ph?ogMgMonk^
kP0FooKfmPSomoOg1?ohn?P8ooWinA?on_[j0_oinOT2oo[jnW_onOWi0_oj
n_X2ooWinAcon_[j0_oinOT2oo[jnQ?onOWi05WoU]3VoicEjOnOe>KoTL7?
ogRPZ_mUQXgoJ865ogJ8R?mNJV[oFF9OofidL_m/LFgoEU]GodQ=BOm6BTWo
A4Y:ocm9B_lh@T?o?490ocXo>Oln@CSoFUi@ofa^H?mJGTgoADThoci5=Olh
?S;o=c`eoc`l>_lk>cgo?3LnocXg?_ld>3Oo?D@moci1>_lm?cCo@d<iodm?
@omEEDWoATPmod54>olk?CSo>3diocTm??lf>SWo>Cdlod=5A?m5BTKoBU5:
oh68POnh_[[oCE=Aoda@DOm1ADKo?ClnocXl>Oll?SWo?D0iocm2>Om1A3_o
@DI0od97@Om0A4?o@48moe9BB?mJF4WoEUA5oe=B@?mEE4;oBDLhodU7>_m6
@c[oEE5>ogMeM_n][[;od=SKolkNg_o<h^3oaN;NolCRh_o:i?7oa]_/olgP
k_o8fN7o/;^ooeANGom4CDco?4E2ocM0>`02ocQ1?005ocY0??lj?cWo?3hi
ocdn>?ln?cX00_lm?ch05_ll?Sgo>S`iocTk=_ln@C[oAdY1odiAB?m9C47o
BTi0odeA@omBETSoEe]<oeUMC_mHG4goEUU>oeEHDOmEEe;oC55=oeIKEOm?
E4koBTm8oe9GDOmfNg@aooShn43onOWi7Oohn?P2ooWin@;on_[j7?okno/2
oo[jnP;onOWi7?ohn?P4ooWinACon_[j1ooinOT2ooOgm`;on?Sh2?ofm_HF
ooGem@7ol?3`0OoPh>01oh>3P`0000?oPh>3omgMgOo]kNd05_oemOD8ooKf
mPComoOg2?ohn?PeooWinB3on?Sh?OoinOT2oo[jnP;onOWi7?ojn_X2ooWi
n@;on_[j4ooinOT0F?nNe^ooWmG]oioBionHamOoS;C0og^MY_m]RHcoJ7en
oe5QG_m9EE7oGVQPofYaJ_mEG5GoAda6odE:A?m:D4co@4U8ocU3@_lj@3co
=S/docPi<Om@DTGoJ6UKofQZG?m<D47oBThooca2=_lf?3;o?3dhocTi>Oli
=3So?3Xooc/o@?lk@Coo@DI2oci1>_m2@cgoDU=;oe1ABOm3A3co?D0iocLi
=?li>cSo>cdjocHh=Olg>CKo@40nodE7@_m8CdSoKgUaokc2__m9CdgoD5AE
ocm3A?ln@3oo>C/hoc/m>?lm@3Wo@4<jod=6?Om3B4;o@TM1ocm3@_lo@Cco
DDi5oeeJBomDDT?oDU4oodi??Om=CSkoB4Plod10>?m>CD_oNg]mokBg_?o>
emcod^7Tol[Oh?o7i>;oa>;TolKQk?o3f^SocN7/om3QjOnLYj_oCEMFoci7
A?ll@Sh2ocU2?@07ocY0??li?c_o>Chjoc/m>?lm?SSo?Sljocm1?P02od12
@@0Eoci0?Olj?3Oo?D0iodiAB?mOHUWoFUeBoeIIC_mCEdWoEEU;oe]ODOmQ
IEOoIVYLofMZHOmDEU7oE5ICoe1BDOmIFeSoEUQEodi@BomAEU;oL7E_057o
n?Sh8?oinOTOooShn23onOWi8?ohn?PFooWin@Oon?Sh1?ogmoL8ooKfmQKo
mOGe0Oo_knl1omoOg`7oPh>300000on3Ph?ogMgMonc/k00FooCdm0SomOGe
1?ofm_H8ooOgmiCon?Sh8?oinOTEooShn00Xoj;Hm?nTf_CoX=;Yoi_:g?nN
b=KoV;g6ogNFVOmAJf[oAE]HodeQF?m`OGCoNhMmoemYH?m>EDgoA4]3od=:
@_m8DDcoATm<odI;AOm0@cco?CdeodQ8?_mNGU;oJfaNoeAFB?mEFD_oADPm
ocTl<om1@Sco?clmocPf=olk>c_o>Si1ocTo?oll@3oo<cPdod94?omBDdko
@T<nocXk=P;o>3Xe0_lj?3T0;?lf=SCo>CXeod50??m0@Cco@dY3ofQbJ_o2
b<KoD5IDoe=GF?m1ADKo?3hmocLi=_lj?3Oo?D0iod95??m7BT7oAda6od=8
@_lo@d;o?T0koeAAB?mQGE7oDe52oe=B@?m:BcWoCTloodU;?_m6Ad7oDeEB
oh^?T_nnaL_ob]OMom7RjOo5gN7ob^KYolOTj?o4gn[o`][VolgQk?oEi^go
RYFGodaFEOloAD7o?48n0_lh@C`06Olj@3co>ClkocXo>olj?c_o?d0kod52
?Om2A47o@D=0od94@Om1@cko?3lhoc/n=om9C4?oFUeDog=fJomaM6WoKW5V
ofa`H_m[KV?oJFaQofIYG_mSIUooDeEBoe=EE?mADe800_mIFeX00om?DDko
DEEDof]`K00WooShn0[omoOg2_ohn?P<ooOgm`[on?Sh2_ogmoN;ooShn1?o
moOg5_ofm_H1ono_k`7ogmoO0On3Ph<00003oh>3PooMgMgok>c/01Kom?Cd
2?oemOD4ooKfmPSomoOgU?ohn?PPooWinAGon?Sh05SoWM3_ojCGm?nUeo3o
X]7UojC?gonMaLooNj6ToeUiN?mAKVWoIX1gohVMU?n0TXKoGfaRoe5MDOm<
ET_oADm4odaCC?m>EDkoC4i9odA5?om2?cSoAD8ioeIDB?mXJ5coG5iAof1T
E_m?DTOo?d8godI7?om8BD?o?chjoc/k>Olg>ccoA4Q;od96Aolb=SOo@dE4
odQ:BOlc=C;o>C/hocPh=_ll?3[o?SljocXk=_lg=S;o?chiodA1??lj>cGo
@DQ1ofehL?o2blSoEUmLodaBD_m1AdOo=c/jocHk=olj?3Oo?D0iod57?Om8
CTCoBTm9odA9@olm@D3o?3hioeEBBOmRGU;oEUA5oeMEA_m:Bc_oBD/modM:
?om9CTOoEeeKoiZTY_o6dmWob=WQoloSk?o5g>CobnK]olWTkOo;i_7oa]kX
ol_Oj?o>h>CoM820odUDD?loAD7o?dHo0_lk@S/01olk@Cgo>T0locXo>olk
@3co@44lod93?_m4AT400_m1@ch05Om3AD3o?d8kocTl=Oll?cKoA4Lnod54
>OmEF4goLGAYohJ9O_n:SHCoOH1gofU/HomKGESoEUQGoe=DE_m@DE?oDU=E
oeIGFOm=CdkoEEIHofmaL00WooShn0[omoOg2_ohn?P<ooOgm`[on?Sh2_og
moN;ooShn1?omoOg5_ofm_H1ono_k`7ogmoO0On3Ph<00003oh>3PooMgMgo
k>c/01Kom?Cd2?oemOD4ooKfmPSomoOgU?ohn?PPooWinAGon?Sh05SoXM;b
oj3AkonSd^coYmG/ojOEiOnMbMCoR[>iogZPXOmMP7coLY6;oiNbZon5VY7o
Jgaboei[H_mJIUcoBUA;od=:@om9CTSoA4Doocdl=om2?COo@Sheode9@?mS
HEGoHF5EofU[G_mIG57o@dHkodI8?Om>CdOoAdLooc/j=Olg=cGoCe5@odm@
D_lm?T3o?d12ocXk?Ol_<C3o?ClnocPh=_lk>cWo?3dhocLh<old=Boo?C`g
od50>oli>SCoAU18ogj9Poo4cL[oEf1OodE:COloA4Oo=c/loc/o?_ll?S_o
?D0iod15?_m8CTCoBDi8od97@Olk?cko>cdhodQ5??mIEDWoF5I7oeQIBOm@
DD7oBDdnodU?@om<DdcoDUaKojBb]Oo:fn;ob]kWolkTkoo7gn_oc>C`olOR
kOo9i>oob>3ZolcPioo8f]coIW9`odUBCOlk@S_o>3lh0_ll@c`02Oll@Sko
>d4moc]0??lj?c_o?T0kod11??m2A3oo@48mod53?P02odE8@@08od54?Oln
@CSo?T4hod13>?m4AccoB4]2odU<@om6BD02odA7@009odE7@_m@DU7oD55C
oe9CEOmDEEOoFU]Mode>D?mDEEOoJV]]02Oon?Sh2_ogmoL:ooShn0comoOg
2_ohn?P:ooOgmh_on?Sh4oogmoLFooKfmP7okno_0OoOgml1oh>3P`0000?o
Ph>3omgMgOo/k>`05_odm?@8ooGem@Com_Kf2?ogmoL<ooShn0WomoOg2_oh
n?P<ooOgm`[on?Sh2_ogmoL<ooShn0[omoOg2_ohn?P[ooOgmaCon?Sh3?oi
nOTDooShn0_omoOg05SoY]Gcoj7@k_nPcnWoYMG/ojSGjOnQdMooVLS@oiO2
b?m]UIGoNYjLoj_;b?nX`[ooWk>aogb<ROmUM77oAE1<od99@_m:CdSo@d@n
ocdl=om8@cgoB44kodY3?OmKEdkoIVILog9dJOmVJUcoBDdood=5>?mBE4Oo
D514oc`l<?lk>37oD4e8oe9ACOm7AdGo>c/koc@f=Olg>c[o>clnoc/m>_lh
>SOo>CXeocPi<old=Boo>3Tcod11>om0ACkoDeeEoi6NUoo8dlooE5iModE=
ColoA4Oo?411oci2@Olm@Sko>d0ioci3??m4BT3oA4U3oci3?Olh?Sco>cdh
ochk<_mFDTKoGE]<oeIGAomDEDGoC511odiFBom8Dd_oCeeMoj^n`_o:g^Oo
b^3]ol_Rl?o:hO7obn;bolGOk?o3g^Woan;YolgRioo1dm?oGFUWodM@Boli
@3Wo=S/d0_lj@CX01?lk@Cgo>T0locXo>olj?c/2ocdo>P;o@D@m00co@TDn
odA7@?m6BD;oATU0odE8?om3ASgo?d8iod95??m5B47oATU2odE8@Om3AD02
od53?P08odI8Aom;CDcoEEMFoeQJFOmPHV7oCU1?oe9DDomTIVDaooOgmb3o
m_Kf=OogmoL:ooShn0[omoOg3?ohn?P:ooOgm`[on?Sh3?ogmoL:ooShn0[o
moOg3?ohn?PCooOgmaKom_Kf0Oo^k^h1on3Ph07oPh>300000on3Ph?ogMgM
onc/k00FooCdm0SomOGe1?ofm_H8ooOgm`con?Sh2OogmoL:ooShn0comoOg
2_ohn?P:ooOgm`con?Sh2_ogmoL:ooShn2_omoOg5?ohn?P<ooWinACon?Sh
2oogmoL0>OnNbn[oY]?`ojSGlOnRd^WoWM3SoioChOnSe>;oX];LoiO4b_n;
];[o/=KIojo>dOnab/koQ9VNofenQOm<FUgo@4U6odaAB_m4AD3o?Sdhod]6
@_m6?cWo?cPbodY5?om_K6?oNgebog=eJ?m@E4KoA4HioeIHB_mIFTcoA48c
odi6>OmGCd;oGEI<oe]HDOm5AT7o@TA1oe5EE?m3B4Co@dE2ocTk=_lk?3Ko
?D0iocLj<olc>37o@4DnodeDCOmKIV3oWZZVolkHeomDGUgoC5AFoci6B?m0
ATKo?T91ocm4@002oc]0>@0Qod16??m0ACoo>SliocLm>Olj?cWo@D4ioeiJ
ComUHeKoEE=4oe=DA?m;Cd3oCUI;ocm<AOm?HV3o//O<olSPj_o7hNkoa^3a
olWRm_o:h?Goa^3aolCPjoo:iNcobn3SokC6a_mBGU[oADm7oce4?OloA3go
=SdfocLn=olh?S[o>Clk00;o>Slk00oo?Cljoci0>om3ASooADQ1odA7@?m1
A3go@4<jod54>om3ASgo@TDlodA7?_m3ASgo@TDnod54?Om0@Sd00_lo@C`0
0oln@3_oB4Y7od]=BP02oeAFD`04oeaNFom;CD[oE5ICofQZIc7omoOg8?of
m_HeooOgm`[on?Sh2_ogmoL<ooShn0[omoOg2_ohn?P<ooOgm`[on?Sh2_og
moL<ooShn1?omoOg5_ofm_H1onk^kP7oh>3P0On3Ph<00003oh>3PooMgMgo
k>c/01Kom?Cd2?oemOD4ooKfmPSomoOg3?ohn?P9ooOgm`[on?Sh3?ogmoL:
ooShn0[omoOg3?ohn?P:ooOgm`[on?Sh:oogmoLDooShn0conOWi5?ohn?P;
ooOgm`1Uoj?@kOnSdN_oX]7[oj7Cj_nRe^_oY=W[oj?Hj?nPe>;oX=7OojCB
gon`f^KoZLgIok3=fonV`<ooAU]/oee]N_mOJF[oDEQAoda>Bom2@ckoB4A1
od]6@_m1>CKoA3lioeICB_n4QW_oUIN:odmCAOlo@cCoB4`moeYLC_mHEDCo
GE4koei?>_mPE4CoKfUKoeADC?m4AT7oDUMCoe]PG?m@DTgoA4M0ocTl=Ole
>2oo<CL]oc@k<om2C4?oDUeEoeUVGonP[j[o`lo=oeEQHOm@FUco>d=5od98
B?lk@Coo>d0locTn=olg?3Go>CleocY1>_lk@S_o>T0locPm=olm?CGoEE=7
ofYXFomLFTgoGf1BoeUKC_mBFTooCEYCoe9VIOnfc];o`mkWolCPk_o7h_Go
b>?holKOmOo7h?CobNGaol?NiOoDjNcoW[2`oe=OFom4CTKo?D@moce2>olj
?cWo>ChhocHl>?le>cOo=c`hocTn>_ll?SWo?Cljoci3??loA3go@dQ1odI;
A?m5Bd400_m2B3h04Om4BT3o@DLmod=9?oln@cco?D8kod=8@_loA3ko>3di
oca1>om0@SgoD59=oeUKE_mHFUGoGEmJoe=ED?m>D4_oJfeX037omoOg8?of
m_HeooOgm`[on?Sh2_ogmoL<ooShn0[omoOg2_ohn?P<ooOgm`[on?Sh2_og
moL<ooShn1?omoOg5_ofm_H1onk^kP7oh>3P0On3Ph<00003oh>3PooMgMgo
k>c/01Kom?Cd2?oemOD4ooKfmPSomoOg3?ohn?P9ooOgm`[on?Sh3?ogmoL:
ooShn0[omoOg3?ohn?P:ooOgm`[on?Sh:oogmoLDooShn0conOWi5?ohn?P;
ooOgm`1Joio=ionQd>[oXM?/oj3Dk?nOe^_oX=W]oj7JkOnQf>coX]K[ojCG
j_n/fNcoZM;VojoBj?nS`MWoB69kodeRMOmZN7_oE5eJodY@C_ln@3go@d90
odU4@Om5@3coAT4kod51>Om/KV?oPXIhoda@@_lo@cCo@THgoeQJC?mVHe3o
Je]2og5PA?mdJ5;oQ7e[og5_Hom0@ccoDEI@of9WHOmRI5ooDeI?od95??li
?37o=C/aocY2=om4CTGoC5U@odmNFOnZ^KKob=CDoeIRH_m;EEOo?4I8oci6
B?m4BTSo?dA0oca1>olj?cSo>d0ioca3??lmA3go>d4mocXo>Oli>S;oBDTo
ofi/H?mZJ5_oJFMJof1REOmEFe7oBeQAoe5UI?nhdMKoa>3[ol7Qk_o3h?;o
aN7folKPmoo7h_Gob>C`olGPiooCj>goUjVYodiJF?m1BTGo?D8loc]0>Oli
?SSo>3dg0_lf?3P07?lh?CWo>Chjoc`n>Oll?SWo>Slhoc]0>Oln@cco@DHo
od97@?m0ASco?dDkod57?Om4BT3oATa2od=8@Om2Ad3oA4U3od56@?lk@3co
>ChhodA7@?mAE4goF5]DoeMJDomMH5WoEEQAoe5CC_mZKfTaooOgmb3om_Kf
=OogmoL:ooShn0[omoOg3?ohn?P:ooOgm`[on?Sh3?ogmoL:ooShn0[omoOg
3?ohn?PCooOgmaKom_Kf0Oo^k^h1on3Ph07oPh>300000on3Ph?ogMgMonc/
k00NooCdm0;omOGe0_ofm_JBooOgm`[on?Sh2_ogmoL<ooShn0[omoOg2_oh
n?P;ooOgm`0Loig<i_nOdN[oX]C]oj3Dk?nMeNcoWMO]oioIlOnPf_;oX][c
ojGIlOnXeo7oZmObojoGlOnTan?oFGREodUSN_mML7OoBeMGodeEEom7Bdco
Bd];odQ4@om7@d3o?c`eoc`l=?m>D4GoFemAoca2=0;o?D<e01coDUI8of]X
EOn3LUKoSW]Kohj0I_nNUhCoWYjBodE8@Om>EDkoFf9KofAYHomJGECoB4Xo
ocTk;_le>2go>Clcoci8?OloC4?oB5MBok30_Oo3dM7oCUYJodMADoloBD_o
>T94odA=C?loAD7o?4<l0_li@3P07_lj@C[o>d8kocY0??li?SSo=3L`ocTk
<?m/K63oMWAXofaZG_mUIE_oEUU@odMBC?m:G5co]/oDolCRk?o1h_7o_]ga
ol?Rmoo6h?Woan;golGQkoo4hNWocnK/ohbNX?m6DU3o?4E0oc]0>_lj?3Oo
>C/focLl=P;o=S`h00ko=cdiocPn>_li?SSo>Chhoce2??ll@C_o?D8lod56
?om2Ad3o@DHoocm5>om0AScoA4U2odE:@`;oAda50_m4BD<02_loA43o=CXd
odM:@Om@Dd[oE5Y@oe=IComJH5KoEUaBoe=HDOm[LVXaooOgmb3om_KfW_og
moLPooKfmP7ok^k^0OoOgml1oh>3P`0000?oPh>3omgMgOo/k>`07_odm?@2
ooGem@;om_KfT_ogmoL:ooShn0[omoOg3?ohn?P:ooOgm`[on?Sh2oogmoL0
F?nMcnSoWm?[oj7EkOnMdngoVmG]oicEl?nLf?;oVmOaoikGm?nQfOCoX]Gb
oj_Jn?n]fOKoYm3^ogRL_?mOOiKoEVaiodIEF_m@FeooD5QJoeEFF?m<BdWo
C4]7ochn=_m2A3Wo?T4fod16>?ld>Rco>T0docHl<?m9C4?oKFYIohUjGOnR
SfooXIEkok2[V?nn`;GoADa5odQAC?m=EU7oHVMQofAUGOmIFDgoB4Hiocdn
<?m2A3KoB4i2odIBA_m;FUGo/<2mokg;bom3DE7oB5=EodA>D?lj@TCo?TM6
oci4@?lk@S_o>3lgocLn=_li@3Wo>T4jocTo>olg?SOo=CXcobha:?mUIE_o
N7IZofQTFOmSH5OoDeA<odA=B?loCdooYl34ol;Pj_o2ho;o_=g`ol;Rmoo5
hOWoaN7fol?Pk_o6hn_od>O_ohJHW?m4D53o?TA2oce2?_lj?3L2ocPj=@07
ocLl>?lg?CWo>ClkocTo>olj?cWo>Chhod97@@02ocm4?P07od97@Om3B4;o
@TM0od15?_m0ASco?d@mod15?P02odM<A@0<od97@Om5BTCo@TM3oc<h<_m7
BT7oCU56oe9HC_mCFDooFV1FoeQOEomFGEGoJ79Y<OogmoLPooKfmYkomoOg
8?ofm_H1ong]k@7ogmoO0On3Ph<00003oh>3PooMgMgok>c/01kom?Cd0_oe
mOD2ooKfmY;omoOg2_ohn?P:ooOgm`con?Sh2_ogmoL:ooShn0_omoOg00Go
W]7/oigCkOnLd^coVm?^oi_Dk`02oicHm01OoiWElOnJeO?oX=WfoikFlOnW
f_OoYMObojSFl?nF`]goQJVoogZDXomJK7KoC5]Rod]FF_mCF5_oDeEDoeMH
Dom6AcooA4Hkoce1<om0AS[o>40cocDm<_lY<BKo>SlhofYXFon5MegoZYUm
ojbTSOne/jCo`lS1od=<BOm6D4ooA4e<oe]PF_mZJV;oJfMKoeMA@om7@C7o
BdPgoeMHB_mLHUKoE65JojZm^Oo0d<ooBeUJodaGFom1C4ko?DM8oca5A?lo
AD?o?4<locU0>?lh?cOo>T4ioc]2>olj@3co>D0iocU0>?l/<RSoF5Q>og1/
HomPFDooGeQ@oe=@BOm8CDWo=dM6ohnWZonng>Ko`^C`okgPloo2iOWo`^3h
ol?OmOo3h?3obNG`om;Xlon3U9_oB5=Eod57Aom0AD7o?3hkocPj=oli>cSo
>3diocTn>_lj@3co>d4moc]0>_lj?cWo@4Dooci3?olm@Sko?d@nod56@?m1
ASl00_m0ACh04?ln@cco?d@modI;A?m7C4Go@TM1odE:A?m2Ad7o<cPbod98
?_m8CTCoD5E>oe9GD?mGGUKoEf5IoeIPF?mTKfLaooOgmb3om_KfW_ogmoLP
ooKfmP7okNg]0OoOgml1oh>3P`0000?oPh>3omgMgOo]kNd07_odm?@4ooGe
mCgom_Kf8?ogmoLoooKfmR3omoOg5Oofm_H01OnJd>coVM7/oiWAk?nHdNko
VMGa00;oWMSf0_nKe_@0<onNf_KoWmScoj7Il_nQeNgoY]S_ojOGkOnOb]go
Y/?CogB:Uom4EV3o@e1Foe1HFomIGEcoEUQCod95??m5B3go>d4coc]3=_li
@CKo>3lgob`c;?l`=BooDe=9ohf1JOn^XXSo[jZGokNi[_o0bLKoCUUKodQC
Eolh@T?oE5ICofYWH?mcJekoHUU8oe17=_mDBc[oHee=ofU[G_mHIEkoX[Fc
olWIfOmWMgOoBeIJocY5AolmAdWo>TA3oca5@_lk@S_o>3lhocPo=`02ocY1
>@0IocTo>olg?CWo=d4iobdd;?m4ACgoH5aCoeYAB?mJDD[oE4m9odi@COlm
Bd_oM8b@okcJh_nnh^ko_^?eol;Wn_o1hOSo`=odol7Nl?o6h^koc^C_ogb=
UOm9E5So?dE5oci2@@03ocXl>@07ocTn>_lk@3co?48noce4?Olm@S_o?44k
oce2?P02oc]0?007oci3?om0ACoo@4Dood56?om3B47o@DHood=8@@02odI;
A0;oA4U300[o@4DoocHk=Om0ACkoADY3odmDCOmAF57oDeeEoeQQG?mGHUco
I6mYT?ofm_HPooOgmb3om_Kf7oogmoLPooKfmP7okNg]0OoOgml1oh>3P`00
00?oPh>3omkNg_o^k^h08?odm?@mooGem@Com_Kf7?ogmoL4ooKfmQcomOGe
0_ofm_H2ooGemAgom_Kf8?ogmoLEooKfmP0loiS?kOnJdNooV]7_oiSAkonH
do7oVmKdoigHm_nLeoGoWMWeoicHm?nOfO7oWmO^oikGj_nSfncoYmc/ojKE
iOn`dN3oPYVWod1DGom4DU_oCeUKoe]QHOmADdko@D@kode@AOm2B3[o>T8e
ocQ0=OlnACgo>D0ioc0d<om0@3SoN71MoibDOOnZZ9_o^l:kok>n`?m<Ff;o
@U5HocDn@om?DE3oJ6=Mog]_HomhJ5WoKUm<ofePCOmdJEOoLg1QoemZI?nK
[Zcoc]kNohjNW_m9E5So>TE7oca6B?lh@T7o>dA1ocU3>olh?cSo>3lg0_li
@3P06_lg?CWo=C/goc<m=Old>c?o=cP`oeMCB_mNE4_oGU==oeaEComHF5Ko
DEeMofAiO_nmfn?o^]kZokoTm?o1i_Wo_^7gol3PmOo1h?;oa>3^olWOk?mf
QhooAe9Foca1A?ll?Coo>3Ph0_ll?S/02_lj?c_o?44moce4?OlnACko?dHn
oci5?_ln@coo?D50oce2?_loA402ocm4?P04od56?om4BD;o@TM0odA9@P;o
@dQ100coADY3od=8@Olm@Sco?44kod15?om3B4;oCUE>oe1FD_m@FECoEf1M
oeYUHOmULFe_ooKfmP;omOGe0_ofm_HKooGem@Com_Kf7?ogmoL4ooKfmQco
mOGe0_ofm_H2ooGemA_om_Kf0_oemOD2ooKfmQkomOGe0Oo/k>`1omkNgP7o
Ph>300000on3Ph?og]kNonk^kP0PooCdm3gomOGe1?ofm_HLooOgm`Com_Kf
7?oemOD2ooKfmP;omOGe7Oofm_HPooOgmaGom_Kf00KoVM3^oi_DlOnKe?;o
VM;`oiKAkonHdo42oi_Fm00boikJm_nJe_3oW]S`oicFk?nPfNgoX]_^oj;J
jonUe^OoZLcPohFO/?m3EF?oB5EModaDE_mKH5coD5E?od]@BOmAEd_oD5I8
od]?@Om2ASSo@TDlod54?Olg>CSo@T<nod0m;_mjMfKoXjJMokk7a?nKZJco
>DQ?ocU6C_lnAdcoATM9of1KEomjKV;oPW9Roh9aGOn0L5WoOFeDog=ZFOm/
LfcoWJ^/oloNhOn[^[goBUMMod5?D_llAdWo=T0ooci7@_lnACd2oca2>00M
oce3>Oll@C[o>3lhocDk=olb>cKo?D@mocDf<?mGE4_oJ5mFofMME?mWGUOo
I6=Oof=[KOmML7Ko_mcTokOKionmi??o_NKhokgQmoo0hoOoa^GiolKQl_o8
h>coM8N>odUDF_ll@DCo?3doocTk>_lm?c`00_lk@3`00oll@Sko?TDnod17
@002od17@007od15@OloA43o?dA0oci3?oll@C_o>d0joce2>`02od15?P0?
od97@?ln@cco?d@modI;A?m2Ad3o?D8lod97@Om1AT;oA4U5oe5CD?mADdko
DeEBoeUOGOmLIVOoJ7=e06oom_Kf0_oemOD2ooKfmQ_omOGe1?ofm_HLooOg
m`Com_Kf7?oemOD2ooKfmP;omOGe6oofm_H2ooGem@;om_Kf7_oemOD1onc/
k07og]kN0On3Ph<00003oh>3PooNg]kok^k^023om?Cd?OoemOD4ooKfmQco
moOg1?ofm_HLooGem@;om_Kf0_oemODMooKfmR3omoOg5Oofm_H00onId_3o
V=?aoiWDlP02oi[El`1Loi[Fl_nKe?7oVmCaoj3Im_nQf_OoWmScoigGkonQ
fo?oY=kfoikFkOnGbN;oO9nkodmWOom0CU_oB4mEoeEGE?mNGeWoDEI@odA9
@_m<DTSoIFUKof5OD?mKF4OoEe53od=0=olo@3_o@TA1odM8@_m:CDKoRi6=
okk7a_mMIV_oB5=Ioc4l@_lmADSo?D50odm>BOmhL6GoOW5PohYjHon<N5go
SWUJoi61J_n<RhOoVZ>XolkIgonhalkoDF9Yoc]=DOljBDco<d8ooci8@?m?
EDWoDeM9ocdo<_lj?S3o@dHmocDj<ole>cOo<SHeocPj>Oll?cSoA4HkofQV
FOmVHeCoGeU=oeUFComIGEkoFFQ]ok??f_nmho3o^^Cdok7NlOo1j_ko_>;g
okcOloo6ho?od>SdofEhOom6DEOo>D53oce1@?ll@Cgo=CXfoc]0??ln@coo
?D<ooca2?_llASko?dHooce4?Oll@C/3oce2?0;o?44k00Go?T<mod15?om1
AT3o@DI0od97@@02odA9@`0;od97@OloA3ko?D8nocm3A?m7B4[oE51=oeMB
C_mFDDgoGEeKoeMNI_mcP8T0Koofm_H2ooGem@;om_Kf6ooemOD4ooKfmQco
moOg1?ofm_HLooGem@;om_Kf0_oemODKooKfmP;omOGe0_ofm_HNooGem@7o
jn_[0OoNg]h1oh>3P`0000?oPh>3omkNg_o^k^h0?oodm?@NooGem@;om_Kf
0_oemODLooKfmP;omOGe0_ofm_HLooGem@;om_Kf0_oemOEBooKfmP1JoiSC
lOnGd_3oUm;`oiSClOnIe?;oV]KboigFlonNeoCoV]?`oigFlonNeoCoW]Ob
oj7JmOnSg?OoW=C_oiK7iOmPQjSoHGbIofYjROmSJW3oFUaIoeeNF?m?E4ko
?d@nodY?B?mRI5WoJVMFog9]F_mbJe_oGUY?odi?B_m1@d;o?D8nod97@omd
NWSoQi2?odeEEom:DUGo>d=6ocDj?Olg?3SoA4@lofEQEOmfKU_oRgeSoi^8
J_nQRV[oXI5hoifLV?n`^L3od]oXolGFg_mNLWWo?U=HocM9BolgAT?o>T@k
oe9HC?mQHeGoD553odE5>Olo@SOo=CXcoci3?olo?d7o>c/mocTk=_m3AS_o
HfAFof1NComMEd_oGUUCoeQIFomULWSo_MSSokoUl_nki_Oo]>7dokgWoOnh
g_?o^mkbol;Qloo<ho7oHG=mod9?EOlg?d7o>ClmocTn>_lf>cOo>Slk0_ll
@Sh01Olj@cko>d@ooca3??lj@C[o?44k00Co?D8l00Go?T<mod15?om2Ad7o
A4U3odI;A@02odQ=A`0<odI;AOm3B4;o@4Dooci3?olj?d;oADI:oeE@COmL
DdkoFeA>of9PHOmKHfkoNhRHKoofm_H2ooGem@;om_Kf6ooemOD2ooKfmP;o
mOGe7?ofm_H2ooGem@;om_KfGOoemOD1on_[j`7ogMgM0On3Ph<00003oh>3
PooNg]kok^k^03oom?Cd7_oemOD2ooKfmP;omOGe7?ofm_H2ooGem@;om_Kf
7?oemOD2ooKfmP;omOGeD_ofm_H02_nGe??oU]?boiGBlOnEd^ooU]?`oiWF
lonLeoGoW]WgoiOBl?nJe_82oicHm01Doj3Im_nQf_OoWMKcoi[=k?n:/]Go
QJC1ognFZ?mYN7ooEf1OoeUNF?mGG5SoFE]Fodi@BomMGUKoK6YMogIcI?mc
LF;oIFEKoeMIE_m2ATGo@4Dood56?omKHU_oCUA@ocPn??lnA4;o@4I4ocTn
>_le=c;o?Shdof1MC_n5OV_oVXifojVIOonZVG_o[Z>=oibRW_ndaLco`mKM
olKJhom/Ph_o?E5Hoc=5BOlgADGo=ClgodiAB?mTI5SoGemCoe5AAom1@S[o
=cTdod53@_m2@4?o>CLjocDg<_m5B3goHV=Eof1MC_mNET_oI5eGoeQHF_mf
P8Wo`m[XokcPl?nki?Ko]N;eokgVo?njh?Go_N3dol;Qloo:hNooGg5kod5>
E?lh@4;o>clnocXl>Olg>CKo>3diocTo>olk@Cgo?48noce3?olk@S_o>3lh
1Oll@C/04oln@cgo@4Dood97@Om6BdGoBDi8odaABom;D4[oAda6od97@Oln
@cgo?48nocDn?Om3AdSoDU5<oeUDC_mJEe;oH65SoeUWL_mnTJ80Koofm_H2
ooGem@;om_Kf6ooemOD2ooKfmP;omOGe7?ofm_H2ooGem@;om_KfGOoemOD1
on_[j`7ogMgM0On3Ph<00003oh>3PooNg]kok^k^03oom?Cd7_oemOD2ooKf
mP;omOGe7?ofm_H2ooGem@;om_Kf7?oemOD2ooKfmP;omOGeD_ofm_H02OnF
do;oUM;aoiGBlOnEd_7oU]?boiSEl_nKf?OoWMSfoicGm@02oigHmP1Eoi_G
lonKe_CoW][foj7Jn?nReoOoYm?hoi>geomjVJgoH7J1oeYXJOmSJFOoG5iM
oe5ACom:BDGoE5=>ofIVF_m^Kf7oI6IHoemRFOmHGEWoA4Q7oci3??ll@SKo
BDm5od57?Om3B47o@4DnocTk=_lf>C;o>3Taoc<c9om:AcSoOGQUoiN?N_n]
Xh[o/JF;ok6/VOnT/k3o^M;Iok[Eg?o3g^OoQj:[ociEFolhBE3o>dI8ocTo
>om4Ad3oEeM=ofERFOmPGEKoBT]5ocXl=olk?Cco>cTlocDc=_lh>CCoC4e5
ofIWFOmYIEWoIUeDofMOG?mUI6WoRI>LolGLj_nigNgo^nCfokORmOnlh_Wo
`>CjokkQmOo1h?;ob=o]oee_NOm1CUCo>412ocXn?Olh>SOo=SPeocPj=olh
?CWo>d4moci4@?loAD7o?4<locU0>@02oca1>`?o>d0j00Go?44koci3?Olo
A3ko@TM1odE:A002odM<AP0<odE:A?m0ACoo>d0jocLm>Old?Sgo@DY7oe5B
C?mEEDgoEUMBoeINHOmCIG?oO9FYKoofm_H2ooGem@;om_Kf6ooemOD2ooKf
mP;omOGe7?ofm_H2ooGem@;om_KfGOoemOD1on_[j`7ogMgM0On3Ph<00003
oh>3PooNg]kok^k^03oom?Cd7_oemOD2ooKfmP;omOGe7?ofm_H2ooGem@;o
m_Kf7?oemOD2ooKfmP;omOGeD_ofm_H0@?nBdO;oTm;coiCCm?nDdoCoUMCe
oiKEm?nGe_OoVMKeoigJnOnNfo[oWM[ioi_HmOnJeoKoW=WfoioJn_nSfoco
Xm?ioig8jon5Zl;oEWJ3odYMHomTKVooHfAVod]7B?m7@D7oC4U4of9RF?mZ
KV3oH6IJof1WGomGFe[o@4E1od=9?om0ASSo?D<eod=7>Om;Cd7oBDdooc/m
<_ln?S;oC4dood0n;oll>R_oGU]:oh5lJOnd[i_oc<J`ol;6]oncbl_o_=kW
ok[LiOnmg^OoXKo9ocaEG?liC5?o=T55oce3@om1@SgoD4e6ofAQF_mWI5go
E5=>od=4?olk>c/2ocXe>@0Jocdl>?mADT[oIfMKog=_Hom^IeooJ6=Pog=b
MonHXZcoamk^ok_NlOnoj?co]n3fokWMmOo2iO_o_]kcokoNl?o5g>[oFfeg
ocm<D_lf?T3o>S`kocHf=?li>COo>3Xgoc/m>_lm@Sh2od15@@04oce2??lk
@3[o?D8loce2?0Ko?44k0_loA3h03_m0ACoo@TM1od=8@_m0ACoo>Slioc@j
=_lc?c_o@Di7odmEBomCETgoDUMCoe1KGom<HgGoOYbdKoofm_H2ooGem@;o
m_Kf6ooemOD2ooKfmP;omOGe7?ofm_H2ooGem@;om_KfGOoemOD1on_[j`7o
gMgM0On3Ph<00003oh>3PooNg]kok^k^03oom?Cd7_oemOD2ooKfmP;omOGe
7?ofm_H2ooGem@;om_Kf7?oemOD2ooKfmP;omOGeD_ofm_H00onBdOCoTm;c
oiCCmP03oiKEmP04oiGDmOnDdoCoVMGgoi_Hm`;oWM[i04coW=Whoi_HmonL
fOSoW]WkojCHoonVe_[oVLOOoen4U?laC5?oAE=FoemPI?mNF5[oEDa=oe9=
BOmOH5SoGfEIoeMQE_mLIUgoDUMCoc]0>_m2B3coCUE5oe5EA_mEEdWoBD/m
odU:>_m2@37oB4Hgoclm;_m0?Roo>SPYocTj:_m;BCcoR8Ukoko0/_nka[ko
]MKKokCPjonbg>So]=[Uojo?f_lkEV7o>TeDoc<nA?ll@4?o?clmoda9A?mS
GUSoIF9KoeMFDOm>CdWo@T90ochi?Olm>C[o?C`hodm@B?mOGe?oKfeQofaU
GomRGUgoJFY_oi>OZoo0f^Wo_=obol3YoOnghOOo^=cdokoQn_nlgoGo`=oc
olGOk_mLKWSo@4eCocLo@Olj?3_o=cLe0_ll?3X01_lm?C_o@48ood53@?ln
@coo?44koce2?0;o?d@n00Oo?T<mocm4?_loA3ko?T<moce2??ll@C_o?T<m
00;o?D8l00go@4Dood97@Om1AT3o>d0joc8l=?la@3Wo@516odiFBomAEdgo
DEMEodeLHom;IW_oQJO206oom_Kf0_oemOD2ooKfmQ_omOGe0_ofm_H2ooGe
mAcom_Kf0_oemOD2ooKfmUgomOGe0Oo[jn/1omkNgP7oPh>300000on3Ph?o
g]kNonk^kP0oooCdm1komOGe0_ofm_H2ooGemAcom_Kf0_oemOD2ooKfmQco
mOGe0_ofm_H2ooGemE;om_Kf00CoT=3doi7Am?nCdoOoU=Cg0_nEeOP01_nD
e?OoTm?foiKEn?nGe_OoVMSioi[InP?oVMSi057oW=SjoigDnonOdoSoXmKa
og2N[_laDEco=DI=oeAEF_mKDUOoGE5EoeYBD?mQHUcoE5aAodMCBOm@FU7o
CU==odI9@_lo@cGoDEE6ofEXEom`Lf;oHV1AoeIE@om>Bc[oB4DdodI3<_m9
AcSoB4Tkocdo=?li?3?oHFIOoj^bZ_nic<[o/McUojgPlOn_g^ko]Mo_okKG
i_m6H6go@E=Moci9Colg>cko?S`modU6@OmQG5KoIV=Jof5QEomOHEKoCdm7
odA0@Olm>C[o>CXeodmAA_mHFTgoI6AHoemLEOmHEUOoEU]Qoh^KZ?nkf>So
^=kaok[Tn_ngi?_o^n7hokcPn?nmh?Ko`^7eolSRlOmNLWgo@TmGocQ0@olk
?3ko>3Phoc`k>Olj>SSo?Cdkocm1?_m0@Soo?d4nod12?Om2A3l00oloA3h0
1_m0ACoo@DI0od15?oln@cgo>d0jod15?`;o?d@n00go@DI0od97@Om0ACoo
>d0joc<m=Ola@COo@E56odiFBOm?EdcoD5UFodaJHom<J7koS:o=06oom_Kf
0_oemOD2ooKfmQ_omOGe0_ofm_H2ooGemAcom_Kf0_oemOD2ooKfmUgomOGe
0Oo[jn/1omkNgP7oPh>300000on3Ph?og]kNong]k@0Joo?cl`Kom?Cd1_oc
lo<IooCdm1komOGe0_ofm_H2ooGemAcom_Kf0_oemOD2ooKfmQcomOGe0_of
m_H2ooGemE;om_Kf00KoT=3doi7AmOnBd_KoTm?goiCDn?nDe?L2oiGEn003
oiWHnonHeo[oUmKi00;oUmKg04_oV=Ohoi_JnonPg?ooX=[ooj?Ko_nVg_Wo
L:2docAHI_m:GVOoIVUboeU?Eom>@dWoF4m@ofEWH_mBG5Co@Ti4odYDBom@
DdcoE5E=oeePEOm>DT?oDeE7ofMXF?m/JU_oIfACofYTE?mPFT[oHEi=od]9
??m4AS_oA4M0od16@_mBGEWoXJf[okgDf_n/f^[oZN3eojcLl?nfhOCo/mCU
odQRLOm0D5go@4U@ocLj?oln?3goAd@oof5ME?m]JeooLW1Sog9cHomKFdoo
BTI3ocdi>?lj>cGoE5M<oeYND?mPHUGoEeIAoeAFEOmBFf;oSj:`okkOl?nf
go?o/^3gokGSn_nji?co]mgdok[Nm?o0h?Goan;coeibOOm1CUKo=Si1ocXk
?Olg=cL00_lh=cD01_lj>SSo?clmod12?olo@Cko@T@oodM9A0;o?D8l00Ko
?T<mod15?om1AT3o@4Dooce2??lj?cT2od56@0;o@TM100co@4Dooce2??lj
?cWo=3hfoc51=om2DTOoCUI9odmEBom>EeKoBUQSod]WOon>/M4_ooKfmP;o
mOGe0_ofm_HLooGem@;om_Kf0_oemODLooKfmP;omOGe0_ofm_HKooGem@;o
m_Kf0_oemODLooKfmP;omOGe0_ofm_HmooGemB3om?Cd0Oo/k>`1omkNgP7o
Ph>300000on3Ph?og]kNonc/k00Joo;blPcolo?c6Oodm?BdooGem@03ohg>
m?n?d?KoTM;h00;oTM?f00OoT]CgoiCDn?nFe_[oT];foiGEnOnHf?coUmOj
00;oU]Ki03koU]GhoiKBm_nGdOKoZ^;ooj7JmOn2]L[oAFamoemfQ?mbNH?o
K6U`og9[L_mjMGWoMg]joeUTG_lf@CWoDeYBof=UF_mBDTKoEEM<oeULDOm3
ACSoEEI8ofUWF?m[J5OoJ69BofiXF?mUHU?oFeU=od=4?_m1Ad?oADm>oeIT
IOnS/[Oo]M3KojWIkonXh?WoZ]ccokSQmon[b]ko@UMXodQFHoli@4So>3Tn
od=1@_m2?c[oD4i2og1^GomYJ5CoL6mJog1_GOmGDTcoAd=0oce0=om5Bcgo
CUE5odmEAomDEe3oF5iNodiKHon<Xk7o_nCfojgLkP;o/^Gj00[o/^3gokGO
mOnggO;o`nKjol7LkOmXOX_o?DYCoc]2B?li>Sco>SPi0_lm?3X2oc/k>`04
ocdo??m1@d3o@dE0odA6@@?o@4E100Oo?dA0oce2?_ln@coo?dA0od15@Olo
A43o@DI200;o@TM300co@DI2oci3?olg?3So;cH_obhk<_lkBCcoEeeAoeQK
D_mAEeGoDUmXodYTOOn5Y/LaooGemB3om?CdW_oemODPooCdm07ok>c/0OoO
gml1oh>3P`0000?oPh>3omkNg_o/k>`06_oalO44oo;blP;olo?c0_obl_84
oo?cleWom?Cd8?oemOEDooCdm004ohk?mOn@dOOoTM;hoi7Bn0;oTM?f00Co
Tm?goiCDn?nCdoOoU]Kj0_nGeo/0C_nGeo[oV=SkoiSGn_nEe?OoWMWkoikI
nOnPfOKoU<SPog2J/?mdTJ7oQiFRohfAW?nRXZcoWj:WohbDUomTL73oD5]G
oe9IDOmNGU;oHEmCof=TG?mEF4oo?d4foe=CAomRH5?oJ6EFofQRE?mSH57o
IF5EoeQHC_m1@cko?DI5od=>D?mDHfSoXK:jokWEhonYenooWM?_ok3Nm_n/
d^Oo/<_NodEHIollB5Co?T9;ocLh??lj>SSo@T8joe1>@_m[JUSoLg9Mofi^
E?m]K5OoK6QMoeEBBom2A3Oo@dXjodYC@_m=EDKoDUM@oeENGOm?H6SoTZjj
okKPl?n[g_7o[^GjojgTnOn]goKo]>;iokKPm_nlhOCobNKfof^1S_m1CeSo
<3Lmocho@Oll>S_o>SPioc/j>0;o>SXj00ko?T0modI8AOm:C4OoBTa7od15
@OloA43o?T<ooce2?_ll@Cgo?D8nocm4@?m1AT;o?dA0od56@P?o@TM300_o
@DI2oc]0??ld>SKo<Slfoc]7>omCET_oEUM?oeAHEomGHF[oBV1hogZG]`3Y
ooCdm0Kolo?c1_odm?@Joo?cl`7ojn_[0OoPh>01oh>3P`0000?oPh>3omkN
g_o/k>`06_oalO44oo;blP;olo?c0_obl_84oo?cleWom?Cd8?oemOEDooCd
m0;oT=7g0_nAd_P2oi3Am`;oTM;h067oU=ChoiGEnOnFe_[oU]KjoiOGnonI
fOgoV=SloiOFnOnOg?_oV=?aoj7Jn?nQe_GoVlORoi6db_nN^<WoZK_7oj^g
`onR[kSoN8F>od]HG_mJI6GoG65KoeeMDOmRH5?oIfQRoe=ED?ll?COo@T8j
odQ6>_mNG4ooIV9FoeUEBOmQGe?oEEI>od15?ollADCo@4]?odaMI?nIZkGo
^]KTojoIlOn/foGo/=W_ok;Ci_mOMXKoB5QUoc4j@oln@dWo?Ci0ocLg=Oll
?CGo@D4eoeAE@omcMEooKfmEog=aF_miLfGoKFILoeaMCOmDF4OoBe90odI?
?_m<Dd_oEEmNoeAWK_nQ_/co/]g^ojgQm_n[i?SoZ^?goj_OmOndi?[o]>7f
okcRmOnmgNcoPi^WocM5C_lj@DOo=cPloc`l??lj>3Wo?C/locXj>_lg=cOo
>S`iod56@_m6BdGoA4U3ocm4@?ln@coo?D8noca1?Olk@3co?44mocm4@?m1
AT;o?dA000?o@DI200co@TM3od56@_lm@Sko=S`hocE0>?lnB3ooE5I;oeYJ
D_mKFeWoG6=[odiPM_meSZcYooCdm0Kolo?c1_odm?@Joo?cl`7ojn_[0OoP
h>01oh>3P`0000?oPh>3omkNg_o[jn/06_o`l?04oo7al@Col_;b1?oclo=I
ooCdm23omOGeE?odm?@7oi3Am`03oi7Bn?nCdoOoU=Ch00;oU=Ch03CoU]Kj
oiWIoOnIfOgoUmOjoiOFmOnJeoCoW]Wioj7Fn?nXe_OoYLkZojW=hon^c]go
/lgLok;9eomfRISo@E9Loe9MHomYKFcoJFUMoemPD_mYJVCoEeUDod52?Om3
A3coATHloeMEBOmJF4coF5I:oeYJD?mCE4co@dQ2oce6AOlkBDcoAEAKohfP
Yonidn3oZLgSojkGkOnif^goQIn^od=EHOm3CEKo@dY@ocPl?om1@TCo>S`i
oc@g<?li>c3o@dHeof]]F?mdM5coO7MQ0_mgKUl07_mcL5ooJfiIoeeRC?m@
EdOoD5M?oeEOH?mGJW7o[loLok7NlOn^iO[oZ>;hoj[Tn_n]hOWo/n?jokKT
nonag>oo`^?dohFPZom2De_o=d15ocTm@?lg=cWo>cTjocdk??lj>S[o<cDd
oc<h=?lm@Sko@DI0oci3?@;o?D8n00Go?T<ooce2?_lm@Sko?D8nocm4@002
od15@@;o@DI20_m0AD402oloA43o>d0locDk=ol_>SCo?DLnoeMIC_mOGeGo
GEiIoemTJ_mCI7KoMHfU02_om?Cd1_oclo<6ooCdm1Colo?c1_odm?@6oo?c
li;om?Cd3?oclo<Joo;blP7ok>c/0OoPh>01oh>3P`0000?oPh>3omkNg_o[
jn/06_o`l?04oo7al@Col_;b1?oclo=IooCdm23omOGeE?odm?@4oho@mP03
oi3AmonAd_SoT];f00;oT];f0_nCdoL0F?nBd_KoUM?hoiSFnonIf?_oUmSh
oi?Dl?nLg?SoVmGjoigBn_nPdOWoY]Ohoj?Bk?nVeNWoZmKYok?HjomdSZGo
@eEYocI0C?mMHVGoJVaQofEWF_mVJF;oEUQCod94?om?D4SoFeeBoeUICOm8
B3coDeE8oeMIC_mAE4_o@dY3oc]6@_liADGo?Da?ohFGVonme=co]]KSok7B
hOn?Z[Go@5=Joe1KGoloAdWoBTi?od12@Olk?Cco?D8noc4f<_lm@3Wo@dDj
oemPD?mgMV;oP7UVogm_H?mlK5coMg1MogIdGOmbM5koJ6aKoeiTF_mFH5oo
FVafokWFi_nag_?o[nKkojKPm_n/i_co[n?kojoQn?nahOOo/=g`olCXn?n7
XjooA5IPocI1Aolh?3oo>SXlocTg>?ll>S_o>3Phoc<e=?ld>CGo?44moci5
?_ll@cco>Slkoca1?Oln@cl2od15@@;o?dA000Co@4E1od56@_m1AT;o@DI2
0_loA4002oln@coo>SlkocDk=ol/>C;o>D@loe5DBOmNGUCoGUmIof9WJ_mG
IgKoKXFG02_om?Cd1_oclo<6ooCdm1Colo?c1_odm?@6oo?cli;om?Cd3?oc
lo<Joo;blP7ok>c/0OoQhN41oh>3P`0000?oPh>3omkNg_o[jn/06_o`l?04
oo7al@Col_;b1?oclo=IooCdm23omOGeE?odm?@01_n>coGoSLkdohg>m?n?
d?KoT=7goi7Bn0;oT];f053oSlocoi;Bm_nCdoOoT];foiCBmonFe?WoV=Oj
oiOHn?nEf??oVM[hoiSBn?nMdoooW=7moikEo?nJeO?oX=cdojGMm?nUeNco
HXBPod9GL_lY=4KoDEILofAZH?mZKV3oCU5:oda>BOlh>cCo>3/bodmAA_mM
Ge;oADLjodI:??mDEdcoBU14od17?olh@c_o>4A0ocU7AomkRh_o^Lc@oiji
`?n8Xj[oBUeQoci<COloB4GoADM4ocho>_m8BDCo>C/joce1@?l^<S7o=c`h
oc`o>?m;Bd7oKVaOoh9kJon:MfSoR7EToh=gHOmnN63oNGMPog9cHOm^KfOo
IFi]ofamQonjenOo[mcaojgSnonVh?So[>Knok3To?n^h?OoZMW`okWVnOnk
h?;oOifXocQ<EOliA4[o<3Dhod11@`;o>SXj00Wo=cThocDg=_ld>CGo=c`h
ocLn=olf?CKo>Chjoc]0??ln@cl01_m0AD42od56@P?o@4E100[o?44mocHl
>?ld@3co>D@nodY=A?mLG5;oHV=KofU_KOmJJg?oHgV7:oodm?@6oo?cl`Ko
m?Cd5?oclo<6ooCdm0Kolo?cT_odm?@<oo?cla[ol_;b0Oo/k>`1on7Qh@7o
Ph>300000on3Ph?og]kNon_[j`0Joo3`l0ColO7a1?obl_84oo?cleWom?Cd
8?oemOEDooCdm01<ohk?mOn=c_CoS/kdoho?mOnAdOOoT];hoi;Bm_nAdOGo
S/kboi?CmonFe?WoUM?hoiCCm_nEe?OoV=OjoiSInOnCf?GoUMOgoicGoonK
dOooW=CooiODoonGg?goU]kgoiSKmOnFcn[oDgZKocE>KOlU<DWo>T5;odM>
A_m=DdGoADQ1odU;A_m0@cco=ST`od54>OmKGe7oBdm1od=7>?mCEdWoAde1
od18?OlmBCoo@Di7oca;A_m`OgcoZ[fkoe9WJ?m0E5?o?De:odiIDom7C4Go
A4DmodQ8@?m0@C_o?T0mocPl>ol`=SKo;C<cocHh=Olg>3?oE55:ogY`I_n?
NF_oUGmZoi>3K?n;PFSoPWeWogelJ_mnOWKoNh61oi:PZonof^_o/=[`ojoS
n`;oZ^;k01Go[Mohok3PmonZg??o/N3bok;Ij_mCLGco>dmHobhi?olc>3_o
>S/moc`l??lj>S[o>3XiocXl>olh?CWo=C/goc<j<old>cCo>Slkoc]0??lm
@Sh00_ln@cl00oloA43o@4E1od56@P03od56@P;o@4E100_o?T<oocXo>old
>SSo=T90ocU5@Om5Bd7oFUa?of9TFOmZL6coGVedof1dO`0[ooCdm0Kolo?c
1_odm?@Doo?cl`Kom?Cd1_oclo>BooCdm0colo?c6_obl_81onc/k07ohN7Q
0On3Ph<00003oh>3PooNg]kojn_[01[ol?3`1?oalO44oo;blPColo?cFOod
m?@PooGemECom?Cd067oSm3hohk?mOn=c_KoSloeoi7AmonBd_SoTM7goi3@
m?n>c_CoTm?goiSFnonGeO[oU=;goiGDmonHe__oVMWloi3Em?nBeoKoY=oo
oi?<nOnMeoooU]Gooi_Toon;e_GoSMOdoicKn_mSTK?o?UelocM7G_lnAe3o
C5=<oeQJCOmQGUOoEU5;oemLDomYIe[oG5e=oeYKBom=CSkoDEA3oeMIBom=
D4GoBDm5odeDCOmBFeKoAe9>of]gLonN[JSo?Da7od9AC?m@Fe?o@4Lood=5
>_m5ACWoB4Pnod51>Olo@Cco=3TeocY0@?la=cOo>Cdloc0b;olj>cKoJ65G
oh]jJ?nAO6OoTH5Zoi66L?nESG[oUI65oi6@S?n6SY7o[l7?ol;Qlon_g??o
/NGmojgUo_nWgoSoZM_dok3Pmon]goKo/^7eoiFlcOllFVGo;T9;ocM2B?l/
<CCo<S@coc/k>olg=cOo>3Xioce2?_lnA43o>T0locU0>Oll@cco>D0i00?o
>d0l00Co?44moci3?om1AT;o@dQ40_m2Ad<03_m1AT;o?dA0oci3?olk@3co
=CXfoble<ol/>S[o=T8nodE:@omHFTooGUiDofI[IomNJg?oHG=o:oodm?@6
oo?cl`Kom?Cd5?oclo<6ooCdm0Kolo?cT_odm?@<oo?cla[ol_;b0Oo/k>`1
on7Qh@7oPh>300000on3Ph?og]kNon_[j`0Joo3`l0ColO7a1?obl_84oo?c
leWom?Cd8?oemOEDooCdm004ohW<m_n:c_GoS<oioho@n0;oT]7j00[oTm7j
oi?An?nAcoSoT]3goi?An?nEdo[oU]KloiKFn_nEeO_oTmGh0_nDe_P01OnG
e_WoVMGioi[Fn_nHeo[oUMWl00;oU=[l04WoU=CgohNlg?m1JH?o>E=RodQE
FomSIUooHEY@og9QF_nKR87oWHf0oif@OonQVHCoQh5[oeQC?OmCD3goFUI:
oe]GC_mPG5WoEeIDoeYLFomFFU_oKgEeokc5`_ljA3co@de4od97@?lo@SWo
ATPmodQ8?_m3@3Wo?clgocTh<ole=S3o>C/hob/`;?lh?S[o=3Xfobhg<_lk
?S?oNgIPoiN=L_nDRG?oWY>1oj2FS?nUX9coZZ^`ojB`_?nof^_o]MkbojgQ
monXh_SoZ>;jojSPmon/goCo[]kdojkPmondh_WoW<?DocICHOlaADko=3m5
obdb=Ol];bko>CTiocTi=oli>cSo=c`hocLm>Olg@CWo>48jocU3>olf@3So
>T4j00;o?4<l00Go>d4moca2?_loAD?o@TQ6od55A002od=7AP0=od14@om1
@d3o@48ooc/m>?lb>3Ko;S`locQ4@_m8CDOoEEE=oeiKE_mPHV7oGfUcoei^
O@0[ooCdm0Kolo?c1_odm?@Doo?cl`Kom?Cd1_oclo>BooCdm0colo?c6_ob
l_81onc/k07oh>3P0On3Ph<00003oh>3PooNg]kojn_[01[ol?3`1?oalO44
oo;blPColo?cFOodm?@PooGemECom?Cd00KoRLkgoh[?n?n<coWoSM3joho@
n?n@coP2oi7?n0;oT]3i02koTm7hoiCDn_nFe_coU]KloiCEnonCe?[oUMKl
oiGGn_nFe_WoUmKeoiWFmOnGe_GoU]SjoiCHoOn:coKoUmSnohk9jOmfY;co
Fg^:ofUjPOmVJfOoKFIPog=QGOn1KVOoSGe`ojbOS_nSVhKoSHU`of=NB?mG
DSkoGEM9of5JD?mZIF7oIF5Pof1PH?mFFUWoI6YXol39a?m8CDKoC598ode@
Aom7BT7oAdLmodI6??m6@ccoB4Dn0_ln?SH0:?lW:2;o:bdXoc]2>ol[=2oo
=D0jobdg;?lj?2KoU99ioiF>NonDS7oo]JfZokFc]_n`^<?o^LcMokOJk_n_
gOCoZ>3gojGQnOnWhOWoZN7hojgPmOn`h?Ko/>3gokCRnOnNa=Oo>5ESoc14
COlc?T;o;S<foc0b<Oli>COo>C/hoc/m>_lk@Cgo?4<locU3>olf@CWo=D0h
ocM1>?lh@ST2oca3?00Doca2?_lm@coo?dE3od57AOm3AdKoA4Q7od=7A_m1
ADCo@TA1od53@?lk?CSo<3HbobLe=Olc?cgoB4]4oeUFCOmTGeWoIVIVofA]
M_mTLWl[ooCdm0Kolo?c1_odm?@Doo?cl`Kom?Cd1_oclo>BooCdm0colo?c
6_obl_81onc/k07oh>3P0On3Ph<00003oh>3PooNg]kojn_[01kol?3`0_oa
lO42oo;blUOolo?c1_odm?@6oo?claCom?Cd1_oclo<5ooCdm4oolo?c00Co
RLkgoh[?n?n;c_SoS<oi0_n>coT2ohk=mP;oTm7j00[oTm;koiCCo?nEeO_o
U=Gkoi?Dn_nBdoWoTmOnoiGFo?nFe_[oU]Ki0_nFeOH0B_nDe_WoT]KkohoD
oOnJfoooUm7foiG6i?mfVJgoNi6LofefNomjO7_oPWikogYeKon2P7CoXJ:B
oiJGQOmeN6?oFUa7oemNB_mNGD_oFUQ9of5ODomTI5coIFQQoeaSG?mEH5[o
^lK0odYABOm9CTOoCe99oe=FCOmBDT[oCDe5od]8?om6@c[o?c`eocDe;Om3
A3co=3L`oc4f<?lZ<B[o6bDMobhf:ole>2OoAdHbohB2LonUYI_o/K>bol?<
doo3eN?o]mCVok?Ll_n/g_OoZ>3kojGQnonWh?_oZN7jojgQmon_hOSo/=oi
okKSn_nTbMco?EYXoc55C_lc?T;o<SLjocHh=olj>SSo>C/hoc/m>_lk@Cgo
?D@moc]5?Oli@c_o=d4i0_lk@SX2oca3?004oce3?olnA43o@4A3od14@`;o
@dM600ko@TI5od55A?m3AD;o@48oocTk=_l^=33o;CTeocE2>Om5BC_oEUA7
ofAPE?mWJ6;oIg5cofakP^oolo?c8?obl_81on_[j`7oh>3P0On3Ph<00003
oh>3PooMgMgojn_[01kol?3`0_oalO42oo;blUOolo?c1_odm?@6oo?claCo
m?Cd1_oclo<5ooCdm4oolo?c0_n9c_L2oh_>n0;oSLkh0_n>cOH01?nCdO[o
T]7joi;An_nCd_/2oi?DnP0moi;CnOn?do[oT]Gooi;EoonDeOgoUMGioiKE
n?nEeOSoU=Cjoi7Eo?nCe_ooT=?moicGoonFbn_oU;cEoi:_`OnGZKGoY;6g
oj:`/OnN[J[oX:bXojJcZ_nHY9[oHVeOoe5HB?maMFCoHfABofASDOm[K5co
JF]NoeeSFOmBGEGoBEQAolCAb_m?EToo@TM0odI9@?mDEdkoFe]CoeYJD_mG
E4_oC4U0odY7?_m5@S_o>SXbod11>Om2ACko<cPaoc8i<Ol`=Rco>3X]oc@f
:OmDFU3oXjbYolCBeOngbmKo`Mk^ok;Fk?nbh?[o[^7nojWPoP02ojOPo@0[
ojSPnonZh?So[>3hok3OnOniho_oZ/gQodEQKolcADoo<Se1ocHj>olk?Cco
?3`joc/k>Olh>SOo>3diocY1>_ljA3co>dDmocY4??ll@c_o>d8joc]2>oll
@cco?D<ooci4@?lo@d;o?T91od96AOm0A4?o?d=2od14@om2A47o?d4nocLi
=?l]<boo=40loce8@_m<CT?oGE]>ofaXGOm[K6KoJ75fog1nQ`0Aoo?clb3o
l_;b__oclo<Poo;blP7ojn_[0OoOgml1oh>3P`0000?oPh>3omkNg_oZj^X0
6_oalO44oo;blP;olo?c0_obl_84oo?clk;om?Cd1_oclo<6ooCdm0oolo?c
0_n8cOH01?n9c_OoR/ohoh_>n?n<coT2oho@nP?oT]7j05OoTM;joi;CnonB
do_oSm?johoBo?n>dogoSmCnoi;CoOnCd__oUM?hoiCDn?nDe?[oT]Kmoi;E
oon<co[oWMcooiK>lonUe?;oX/OQoj_:g_n_bmWoZ/_Dok3Ae_n`cmCo]];F
ohVQYOmIJf_oA4m9ofA/HOmjO6koMGITogAeIOm[KEooGVIKoeMTFom<G5Wo
`M3=oe=MEOm3B47o@D@mode@BOmHF53oGemGofERFOmRGeKoI65HoeMDBom4
@CSoA4@jod52>_lj?CCo?D0gocTl=Olh>cCo=3TeoeiXIonDYZ[o_MGOokgN
kOnWd>Co/n7kojgPoOnZgoooZ=onojOPo_nVgogoY]olojOOn_nYgoWo[Mcf
okOOn?n_cnCoBfEdoc=6COla?43o=c/locdm?Oln?C_o>c`gocPj=olf>cOo
=cdiocY0??lk@S_o?4<loca3>ollA3T00_lk@SX05?lm@Sco?T<moci3?oln
@coo@TI5od14@oloA43o@4E1od=5@_lo@Cko>3Xgoc4e=?le?d7o@TY=oeAC
DOmXHeooN7=`og5`MOmYLX7oLh:E3?odm?@5oo?cl`Kom?CdE?oclo<6ooCd
m0Kolo?c4oodm?@6oo?cl`Kom?Cd5?oclo<6ooCdm0Kolo?c<oodm?@<oo?c
la[ol_;b0Oo[jn/1omkNgP7oPh>300000on3Ph?ogMgMon[ZjP0Joo7al@Co
l_;b0_oclo<2oo;blPColo?c/_odm?@6oo?cl`Kom?Cd3ooclo<2ohO<m@06
ohS=m_n9c_OoRlkhohc?nOn@dO_oTM;l0_n@dOT01_n?d?SoT=7ioi7Bn_nA
d_[oSm?johgBn`;oRm;n05;oSm;moi7Bn_nCdoWoTm?goi?Dn_nAeOcoTmKo
oi7DoonHf?ooTm7hoi[@l_nSd_3oXL_Toj;;hOnSd^CoX=7Poig;fonfg>oo
GWf?od]QKola@4Oo>dA3ofi_Iom`LF?oLG9Rof9TE_mIHEKoEf=OoeATI?ng
alOoB55<od97@?m4Ad3oCE19oeEECOmJFU;oI65HofUVGOm^K63oGE]?of9P
E?mIETgoBd]1oe9DBOm1@cSoAdQ2od53@_li?T;oCeiSoj[3b_n`e>;oZMCU
ok[/oonOeO7oYMckojGKoOnWg?koYmclojKMo?nWg_coY]ojojSNn?n[fO?o
]Mkdok7BiOm@JWWo=DI>oc4j?olg>cco>c/iocdl>?ll?CSo?3`joc/m>_li
?S[o>ClkocY1>_lk@S[o?D@loce5>_ll@c_o>d8j0_lm@S`04_ln@coo?dA0
od=7A_m1ADCo@4E1od97@om3AD;o?T0mocTk>?le>CSo>413odE:C_mAD4ko
HUeJogA^K_m_KWCoK7F6ogn@Y0com?Cd2ooclo<Joo;blS[olo?c1_odm?@6
oo?cla?om?Cd1_oclo<6ooCdm1Colo?c1_odm?@6oo?clc?om?Cd3?oclo<J
oo;blP7ojn_[0OoMgMd1oh>3P`0000?oPh>3omgMgOoZj^X07_oalO44oo;b
l[colo?c5Oobl_82ohC;m@;oQlcf00GoRLkhoh[?nOn=d?[oS]7kohg@nP03
ohc?n@04ohgAn?n>d_WoS];iohcAnP;oRm;n05OoS]7loi7Bn_nBd_SoT];f
oi7Bn?n?do[oT=?nohoDo_nAe?ooU=GmoiGAm_nTg?goX]CeojCIn?nOfoOo
V=GaoiS?k_nYeoWoEGVKod=LN_l]?57o;SDoochn?_mJEdkoK6YMoeYJC_m@
DdcoC5EDoeQUKOn/^Koo>dA1od15?om5B47oC4m8oeMGComIFE7oGU]BofAR
E_mUHEKoI61EoeEAA_mbKV?oNGM[og]iKOmdLVKoD4m:oe5ADolm@D[oAeUS
ojS6dOndgo3oZMgboj;Lm?nRg_[oXm_lojKKoOnYfocoZmcmoj_NoOnXg_[o
YmojojOMmOn/f_;o]mgdokOFj_mIL7ko?4YCoc<l@Oli?Cko>c/ioc`k=oll
?CSo?Cdkoc`n>olj?c_o?44mod56@?m4BD;o?d@mod16??loA3go?T<loca1
>olm@Sco@4E1od=8A?m2Ad<00om1AT803?m0@Soo>cdjocLi=_lf>cOo@4I4
od]@C?mDDDSoH5aCog5/I_mZJfgoJgN3ohJIZPoolo?c1?obl_8Loo7al@Co
l_;b7_oclo<Poo;blQoolo?c8?obl_8ooo?clb3ol_;b0OoZj^X1omgMg@7o
Ph>300000on3Ph?ogMgMon[ZjP0Noo7al@Col_;b_?oclo<Eoo;blP;oQ<_e
0_n6boD01On7c?KoRLkhoh[?n?n;d?WoS<oi00?oRlkh00CoS=3gohgAn?n=
dOSoS=7j0_n<dol0C_n>docoS];ioi3AmonAdOGoT=7gohkBmon@dogoS]?l
oiGJoonCf?ooUMKloiSFnonDd?CoUMCeoi?HnOnFg?koX^3ooigBo?m/U/3o
@Uj3obm0G?ld>dgo>3LlodE2?Om>BSooBDLkoeeNF?mSJFWoHFYcohVCW?lo
ADGo@TM1od12?Om5B47oEUM?oeeMEOmOG5?oI69FoeaHCOmHE4WoHEeAog5]
HOmcKfCoQ81eofeYG_mHEE3oEE=Hoe1DH?m6F6Ko[<gLok3OlOnMengoX^;m
oj7QoOnVgogoZmgnok3Noonag_oo/MkmojcNnOnXg_SoZ=cdojoLlonjg_Co
_M[/oemfQ?m1CeSo>413oci0?olm?C_o>cXfoc/l=olk>cWo>C/hocTn>_lo
A43oBDi8oe5FC`;o@DLm00So@DHoocm4?Olm@Sco?T<mod97@om6BdOo@DI2
od15@@;o?dA000co?CllocLi=_ld=S?o=3TeodA9@omEF4ooH5iAofiZG_ml
NG3oK71_ofEfP?moU:D?oo?cl`Col_;b7?oalO44oo;blQkolo?c8?obl_8O
oo?clb3ol_;b?ooclo<Poo;blP7oj^[Z0OoLg=`1oh>3P`0000?oPh>3omgM
gOoZj^X07_oalO44oo;bl[colo?c5Oobl_82ohC;m`03ohK=nOn7c_[oQlkh
00?oQlkh0_n<dO/4ohcAnP06ohkAnon=d__oR]7koh_Cnon>do[oT=Ci0onC
eOP00onAeO[oS];goi3Eo002oi7Io`0Joi7FoOnAeO[oUMOjoiCHnonAg?co
TM_noiOHoonMe_ooPZgHobE5K?lmD6ko;SI9oc`m@_m2?CWoEe16oeEAAOmD
E4coI6IUogIkPOmPIfgo>T10od97@Om9BdKo@TDnoe1ABOmEEDd2oemLD`0^
oeaHCOmBCT?oJ6AHog=_Hon4OW;oPWa`ogA^H_mJEDooE59Goe=GHom3EF?o
ZlcMok?SmonVh?SoX>3koj7NnonWg_go[n3ookKQoonfgogo/mchok3Lmon[
gOKo[=ccokOOn?nkg_Coa^?eofQnRoloC5Co?dM:oci0?oln?Sco?C`hocLh
<oll?3[o?3hkoce2?_ln@cooA4U3oe]PFOm<CdKo@dHkoci1>?m1A3_oADQ1
odA7@0;o@T@o013oADM4od53@?m0@Soo@48oocPm>Ola=S;o=3Teoce2??m8
CDKoE5M<ofUWF_mgM6GoMgM]og9hM_mPLWkoSJNh3ooclo<4oo;blQcolO7a
1?obl_8Noo?clb3ol_;b7ooclo<Poo;blSoolo?c8?obl_81on[ZjP7og=cL
0On3Ph<00003oh>3PooMgMgoj^[Z01kolO7a1?obl_:loo?claGol_;b0_n4
boL00on5c?SoQ/giohO>n005ohO>n0;oR/oh00WoRm3iohcAn_n=d?[oS=7j
oh[Bn_n:d_SoS=;fohkBmon>d_D00_n@d_D0@on>d_GoS];gohoEnOnBf?co
T=WlohoGoOn?f?_oT=Wloi7JoOnAgOgoRmKfoi?Go?nLf?goT<3Xod5UROlc
BfOo;S];oc8e>_m>CDSoJfMLofQTF?mbKfKoKFiYofQ/KOn;T9?oBdm>od15
@Oln@3_o?T4jodm@B_m>CdOoE5A:oeYGC_mDD4GoF5A9ogA`I?mgLfOoOWQ/
ogYdJ?m_JEgoFUE?oe1;DOmAEF3oB5YXojk=gon_g_;oX][cojKRo_nZi_oo
YmgiojoNn_ndfoSo/mScokCIlonegoOo^>KnokcYooo1iokoaNGjom7/oOm^
Q97o@4eEocU1A?ll?Sgo?Shlod=2?_ln?cX00_m0@Sl03_ln@coo?D8nod56
@?mGG5GoF5]BodiAA_m3ASgo@4<jod95?_m3ASoo@dE0od94?om4AT?o@D=0
0_m0@Sl03?lg?3So<3Daoc@i=Olm@SkoBTm9oeIID?mZJ5coMG5Vog5bK?m[
MGKoHGJ7oi>_a@;olo?c00Goe=CDobXZ:_m:BT[oX:2Ponk^kP08oo?cl`Co
l_;b7?oalO44oo;blQkolo?c8?obl_8Ooo?clb3ol_;b?ooclo<Poo;blP7o
j^[Z0OoLg=`1oh>3P`0000?oPh>3omgMgOoZj^X07_oalO44oo;bl[colo?c
5Oobl_800on3b_KoQ<_goh?<m`02ohC=n007ohG>nOn6co[oQm3kohC=m_n5
c_OoQlkhohW@nP03ohcAn`03ohcAn_n=d_WoS=;f00;oSM7f0on<d?D01On=
dOKoSm?fohoEmon@e_SoTMOi00?oSmSk02coSm[johoJmon;eO3oU=WhoiOF
mOnSeOKoMj2lod]ZOom6FVGoDUeOofmdK_mhNVooLgAVogYjK_m`LFWoJFiX
oiRMVOlk?C[o@48ood94?oll?cSoBda6odi?AomCDdWoCdm5odY8??mCDDGo
KFUNofm[H?mfLVOoNGEZofaUFomCCTSoDdiBoda?F?m4E67oZ<GEojkHk_nW
fo?oZN7lojKNnOn]go[o]N7jokcQn`;o_N7i00ko_^CkokgWoonmiooo`^Kn
ol?Sn?o@jocoM8RCodAAEoli@D?o?d=2ocm1?_m3A3oo@44lodA6@`;o@4E1
01_o?T<ood97@OmGG5GoH6=HoeUKC_m<CT?o@d@locm2>om1A3go@48mocdo
>_m4AT?o@TA1od53@?m0@Soo=c`hoc4f<_lf>cOo@DI2odmCD_mIFeSoK6UT
og=`Jom/KVgoIFmhofJ0UonK_MT00_oclo<01OoQhN7oYjNWoj:RX_lK6a_o
X:2P00?olo?c00?oh>3Poo7alOoclo<00_oXj>P4oo;blPGolO7a00?ogmoO
ono_kooalO400_oVi^HBoo7al@Col_;b7_oclo<Poo;blQoolo?c8?obl_8o
oo?clb3ol_;b0OoZj^X1omcLg07oPh>300000on3Ph?ogMgMon[ZjP0Noo3`
l0;olO7a0_obl_:loo?claGol_;b0_n3b_H2oh;;mP08oh?<mon4coWoQM3j
ohKAnon4cOKoQ/ohohS?nOn:dO/2ohgBo005ohcAnon<dO[oSm?johoCn?n>
d_L00on=dOP2ohkBn@1Poi3DnOn?doKoSm?fohoEmonAeoWoSmSiohoHnon?
f?WoSmWfoi7Km?nGgOOoU=C_oj;Km_nSdn[oOJ:eofR4T?mhRi7oPY2@ogn9
POn3R87oNGmeofebJomPIeooD5E?od94@Om3AD;o@dE0oci0>omBDdgoFEYB
oeiNE_mJFU3oBdPooeUGBom/JUkoK6QMogEaI_mmNFkoJVIMoe9=AomGEEKo
Ce9GodaJIOnZa=?o/mO]ojgKmOn^h?_oY]WdokGSoOnli_ko`NOlol7Unoo0
i?[o_^Ckok_So?nhh?Wo`>ClokgMl_o;iOKoNHfHodYGGOlmADOo@TI5ocdo
??m2@cko@48mod=8A?m1AT;o@4E1ocm4@?m2Ad7oEEYCof1REomOHECoEUQ=
odY<@Om2ACco@4<loci0>olj?3OoA4I3od94@Om1@d3o?T0mocHk=olc>3Co
?44modQ=BOm?De;oFUaIofYYI?m^KFSoIFUZoee[M?mZRIkoXLKQ1Ooclo<0
2_mUIFGoDU9Boo?clooclo?oCDe=o`L71olH61SoU9BDoa8B4_mBDU82oo;b
lP03ogIfM_l0003od=3@00?olO7a00KoC4a<o`L71olH61SoTi>Coa4A4OmB
DU8Boo7al@Col_;b7_oclo<Poo;blQoolo?c8?obl_8moo?cl`Col_;b7_oa
lO41on[ZjP7og=cL0On3Ph<00003oh>3PooMgMgoj^[Z01kol?3`0_oalO42
oo;bl[colo?c5Oobl_84oh;;n00Foh;=mon3c_SoQ<oioh?@n_n4coWoQM3j
ohO@nOn8dO[oR]7kohW@n_n;d?[oRlkhoi3AnOn@dOOoSm3hohg@n_n>dOco
S]?moi3Co_n@dogoTM;joi7Bn0;oTM?f05KoTMGhoi7GnOnAeoWoT=Khoi?J
n?nEg?SoU=WfoiKIm?nIeo3oYmofoic;gon0YkSoQjF`ogfDW?n5UYgoR9JG
ogn;RomhPgooG6MSocM0>om7BDKo>3Pfod52?OmPHEcoP85kofa]IOmCE4co
ATPmodQ8?_mLG5;oK6aRofYWG_mXIEcoKV]RoeiKE?mACTWoFEUGoeUNHOmP
KGKo]<WJok[JlOnaf?Go]^;ookOToonghoco^^Cjok_Qm?nhg_7o^=kcok[P
monkhoco_N;lol3To?o2h_OodN_lohVMZ?m<Ff3o>dE6oci4@?lj?cWoA4I1
od=5@?m4BD?o@4M0oci4@?ll@Sko?44kodaAB_mMGe;oHF=EoeiPDomBE4Wo
ATLood52??lo@Cco?T0kod=5@_m0@Soo?CllocTk>?lc>3Co=CXfod56@_m>
DdooC5=<oeMLE@;oJF]P00CoGVQOoeM[J_m^TYkoWl[K1Ooclo<03on3Ph?o
7alOoo?clonl_;co0`<3om;Bd_oKfm_oEUIFoa0@4?oclo?ol_;boo7alOlM
7Ago4a<Cog=cL`02oo7al@06ok^k^ol30`?od=3@omWIfOmFEUKo410@4ooa
lO44oo;blQkolo?c8?obl_8Ooo?clb3ol_;b?Ooclo<4oo;blQkolO7a0OoZ
j^X1omcLg07oPh>300000on3Ph?ogMgMon[ZjP0Noo3`l0;olO7a0_obl_:l
oo?claGol_;b0on2boP00on1boSoP/ggoh;=m`02oh7>n004oh?>n?n4coWo
Q/ohohK?n0;oQlkh06[oRLkhohW<m_n>cOKoS/gfohk?nOn<co[oSM3mohgA
oon?dOooSm;ooi3@o?nAd_[oT];hoi;Bm_nAdoKoT=Cgoi7En?nBe_WoUMWl
oi3Dmon>doCoV]onoiKIm?nHf?7oX][coi?3f_n7/<KoMiN/ohnX_?n5V:Oo
PYBNofYiP?loCU7o@4a<odQ<Bolh>3Ko=SLbodM8@omSI5koFU]Eodm@B?m9
BT;oAdLmoeIFC?mQHEOoHf=IofISG?m[J67oFEI?oe=BCOmMGe[oFfASoei[
Lon]`=7o`=cdok[Kn_ngg_go^^?ookOQn_nihoWo^^?eokWSlonih_Ko^N;h
okSPnOnhgOOo^mogolOXnooFlOooV[2kodeLHOlkADKo@4I2od=8@_m3AD3o
@4Dood58@OlnACko?dE1oce3?oll@C_oBDi7oeUKC_mNH5;oGV1CoeAFBOm8
BD7o@D8jod12?Om2A3oo@48oocdo??lj?3Wo=SPeoc<h=?lg?3So@dQ4odmD
D?mAEe?oG65Kofa^HomXJf3oH6]SoeecLOmjX:WoW/kL1Ooclo<05on3Ph?o
7AdMoo?cloo>c/ko0P82okBd]?oclo?oUiNGoahN7_oclo?ol_;bokFe]Ol:
2P[oZZZZoaLG5oo]kNgolO7aolg=cOl20P;o/[:boo7alOnFUYKo7QhN01?o
lO7a1?obl_8Noo?clb3ol_;b7ooclo<Poo;blSgolo?c1?obl_8Noo7al@7o
j^[Z0OoLg=`1oh>3P`0000?oPh>3omgMgOoZj^X07_o`l?04oo7alCgol_;b
8?oclo<Poo;blQoolo?c7_obl_82oo7al@;ol_;b4ooalO42oh7:m`;oPL_h
00CoP/cioh3=nOn0cOOoOlcf0_n1c_P04_n3c_SoQLkiohK=mon7c_SoRLkh
oh[=mon=c?GoS/ceohk=nOn<cocoSLooohc@oon=dOooS]3ooho?oOnAd?_o
Tm7joi?An0;oTM7e03koTmGhoiGFo?nDe?ooS]7nohoBo?nEfoooUmgooi3E
m_nIf?WoWMGhoik>l_nOan_o/M;eojo:j?n[`MWoHGJ9oca@FolnCE;o>Sho
ocln>_ln?c[o>CXeodQ9@om9BTCoAdQ0od11>Om8BD7oDU=;oeYKDomWJ63o
KFaWog9aK?mNGESoHF9LofI[IOmMIfKoE6=Zoif``Oo3foGo`]oookKInOnc
f_Wo]=kgokOTnOnmj?Wo_^WiokkYo?nliO_o]]khok;Gl_ngfo?oaNKioloZ
nonQ]l;oBeYOocm;Bom2B4CoAda6od97@?loA3go@DQ1oci5?P;o@DM301[o
?D@modQ=A_mFF4_oFea>oeiPDomKGE3oD559odE6?_m1@Sgo@T<nocm1?_ll
?S_o>C/hocLi=_lf>cOo>d0lodE:A_m>DU7oFEiRof=XJom`LVooIV]Wof=_
KOmTO83oPjfkoj3@i0Gol_;b00WoPX:2oadM7Oobl_;ol_;bojBTY?l_;boo
<30`oc<c<olN7Qh00_obl_801OmKFe_oF5QHoo;bl_lT92CoYjNW00;ol_;b
00GoY:BTobl_;ol`<33o<c<coahN7P0Eoo;blQkolo?c1?obl_8Loo7al@;o
l_;b0_oalO4moo;blSgolo?c0_obl_82oo7alAkol?3`0OoZj^X1omcLg07o
Ph>300000on3Ph?og=cLon[ZjP0Noo3`l0ColO7a^_obl_82oo7al@;ol_;b
4ooalO42oh3:m`06oh7;n?n2c?WoP<giogo<n?moc?KoP<_e0_n3c_P04_n4
coWoQLkiohO>n?n8coWoRm3johg@non=c?OoS/ghohk>n_n=d?goS]3oohgA
oon>d?ooSLoooho?oOnAd?_oTm;koi;Bn0;oT=3d02coT]CgoiGFo_nBeOoo
UMSooiCIoon9c_GoU=[nohkDm_n>d??oVMOloi[?monVe_koWlK]ok3Bmon`
cN_oEFn6oeafQom5EV3oDeMJodi=BOm7AT;o?chiodY:@_m6ASkoADDmod52
>_ll?COoCDi8oeYME_mYJVCoIVMRofASG_mEE4ooIVMQofebK?mXLG3oG6Ub
oif^`?o3foGo`=gkokCGmOnih?go/mohokCRn@;o]^?h02co]nCkokSToOni
h_ko]^3iokOOn?nohoWo_mk`oijf`_m9F5goADm@ocm5@Om0ACkoB4e6od=;
@?m2C4?o?TPood1:@_m1B47o>T4iod98?_mHFTooG5iAof=UF_mVJ5goGV1E
odi?Aom4ACoo@D8lod12?Oln@3go>SlkocTn>_lk@3co@4E1odM<B?m=DE3o
Ff1SofEYK?m`L7;oHVIYof=^M?mVOX[oR;73oic?i0GolO7a00?oPX:2oadM
7OoalO400ooalO402_o_knooRh^;oalO7ooalO7oi^KVo`X:2_nb/[;olO7a
oh:2P_m6ATH4oo7al@03ono_kon;Rh_o7alO01?olO7a0_obl_82oo7alK[o
l_;b0_oalO42oo7alQkol?3a0Oo[jn/1omcLg07oPh>300000on3Ph?og=cL
on[ZjP0Poo3`l3golO7a0_obl_82oo7alAcol_;b0_oalO42oo;blQcolO7a
0_obl_82oo7alA_ol_;b0_oalO42oo;blQkolO7a5Oo`l?002Omkb?CoO<We
ogg:m_mmb_KoP<[goh7;n?n2cOOoQLkiohC=n002oh?<m`07ohG<n?n7c_So
QlkhohK=mon7c?KoR<_fohW<m`03oh[=n007oh_>nOn?co_oT];noi7Bo?nB
do_oTM;hoi3Am`02oho@mP1=oi3DmonBe__oS]?johgEnon@e_[oTMOioi?H
nOnDfOSoU]ShoiOHn?nIeOOoVm?doj3BlonWe??oZ];/oik1eon5XKKoLhJD
ofAWK?mNFUOoHEaHofiZHOm_Jf3oD4a1odU6?Om4A3coATM2odM9A_m@E5?o
FEeLof]]J_mJFeKoEUI>oeaMEOm[K6OoIfa_oeUSKonEY[[o`=SdokgLnOni
g_So^nGmokGSn_ncho[o]N;ookCSoonbhOoo[mklojgLn?n^gOOo]nWookCR
n_o7k?ooYKo<odiMI?m<E5Ko@4Dood]>AOm6C43o@Tdood5=?om0CSoo@Ti0
od=>@?m6C43oAdY1oe9EC_mKGUOoHF9JoeaNDomWIe_oH61Dod92>?m2@c_o
ADQ1od15?olnA4000_ld>SP02om2B4KoBDm=oe9GDomSIUooJ6UTofYXJomZ
JWCoGfQiofn5V_nH`MOoX=;Y00Gol?3`01OoPH61oadM7Oo`l?3ol?3`ojVY
ZOo=cLgokNg]oe]KFom?Cdool?3`oiVIVOlM7Agol?3`oo7alOoMgMgo1`L7
omKFe_obl_;oZZZZolk>c_o_knooG5aLodm?C`0coo;blP;olO7a0_obl_8k
oo7al@;ol_;b0_oalO5Doo;blPOolO7b0_o`l?42oo7al@Sol?3`5_o_ko01
on_[j`7og=cL0On3Ph<00003oh>3PooLg=coj^[Z023ol?3`?OoalO42oo;b
lP;olO7a7?obl_82oo7al@;ol_;b7?oalO42oo;blP;olO7a6oobl_82oo7a
l@;ol_;b7_oalO4Eoo3`l0;oO/gh00[oP<giogo<n?n1boSoPL_hoh?<mon4
cOSoQlkjohK=nOn5c?SoQ/gi1?n6cOL2oh[?n@1Iohc?n_n;c_WoSLkhohk?
nOn@dO_oTM;loi3AnOnAd_[oTM;hoi3Amon=dOKoS];goi3DmonBe_WoTMOk
oi3Fn_n?doKoSmCeoi;Dm?nEf?GoV=[joi_Ln_nIf_[oVmSgoigFm?nTeoKo
ZmWcoj[BjonO`]SoV[71oiZQYonFUI?oV9F@oiVES?n;QgcoHemDoeAAB?m4
A3co@D4oodY<Bom@E5GoDeMHoemQG_mGFECoEeU>of1REomWJ6?oIFU/oeMP
KonBX[Wo_=KaokKHm?nbf_?o/n7hok3Pm_n]goSo[]ooojoOoon^h?ooZmgn
oj[Mn?n/h?SoZ=khok?Ro?nmhOOoVkG4odQEG_m?E5OoATQ3odA7?_m2B3co
@4/kocm=?_m2D47oAE53odE@@_m6C43oADPooeAIDomLGUWoIFIPofQXG_m]
JeooJVQKoeQFB_m9Bcko@4<joce2>om1Ad<00_li@Sl02om2BdSoAde;oe5F
D?mWJUooJfaTofe[K_mZK7SoHfj2ogF?Z?nIaMkoXMC_00Gol?3`00coPH61
oadM7Oo`l?3ol?3`oh61POl_;boo3`l?ocDe=Onh^;Sol?3`oeIFE_mnOWh2
oo7al@09oo;bl_mLG5coRh^;oo;bl_n2PX;o;bl_o`l?3olf=SKo^[Zj03?o
l_;b0_oalO42oo;blS_olO7a0_obl_82oo7alECol_;b1ooalO82oo3`l@;o
lO7a2?o`l?0Fono_l07ojn_[0OoLg=`1oh>3P`0000?oPh>3omcLg?oZj^X0
5_o_knlDoo3`l3?olO7a0_obl_82oo7alAcol_;b0_oalO42oo;blQcolO7a
0_obl_82oo7alA_ol_;b0_oalO42oo;blQkolO7a5Oo`l?001?mjboSoNlci
ogg;nOmmb_P2ogo9mP04oh7:mon2boSoQ<gjohC=nP;oQLch00[oPlcgohC=
n?n6co[oQm3koh[AoOn9d?coR/oioh_@n_n<co[oSM3k0_n?d?X2oho@n0;o
T=7i0_n>d_L0;On?doSoT=CioiGFo_nDeO_oTm?goi?Cm_nEeOSoV=WioicL
oonNgoooVm_noi[KnonJe_SoW]GdojGFm?nZf?;oZm?/ojg<g_nP[KKoVYjQ
oibLV_nNWISoTXn6og1]I?mSH5OoCTi6od93?_m=CdkoBTi=odeAD?mIFeSo
HFAMoeiOEomQHU[oIFQQofE[JomHI73oU:Jjok_IlonffoKo/=ceok7Sn_n[
goGoZ=khojSMo@02ojWMo`0[ojOLo?nVg?KoYmgeojWLmonfh__o^=_aoiB[
^om<EV3oCe9GodQ8A_m3A3koAdY1odA<?om1CD7o@U13odEAAOm6D4GoADe2
od=8@OmAEU3oFUeFofAUGOm[JeooJFMJofUWF?mUHeKoCDe1odM8@?ln@cco
?TA0ocQ1??lk@CgoAD]7odmDD?mMHU_oJFaQofe^I_m/K6koIf]gofAcR?ml
V[CoVl[VoicElP05oo3`l003oh61POlM7Agol?3`00?ol?3`00Cok^k^oo3`
l?o`l?3ol?3`1?oalO46oo;blP03oo3`l?obl_;ol_;b03?ol_;b0_oalO42
oo;blS_olO7a0_obl_82oo7alECol_;b1ooalO42oo3`l0;ol?3a2?o_ko0F
onk^k`7ojn_[0OoLg=`1oh>3P`0000?oPh>3omcLg?oZj^X05_o_knlDoo3`
l3?olO7a0_obl_82oo7alAcol_;b0_oalO42oo;blQcolO7a0_obl_82oo7a
lA_ol_;b0_oalO42oo;blQkolO7a5Oo`l?002omgb?GoN<Wfog[8m_mkbOOo
O<Wgogo9m_n2boSoPlcioh39m_n1b_OoP/_h00;oP/_f00[oPlcgohK?n_n8
dOcoR=7lohO>n_n6cOWoRLkhoh_@n_n=d?_oS<oj0_n=c_P01?n>coOoSm3h
oi3AnOn?doX2ohoCn007oi7Bn_nCd__oU]Cmoi[EoOnMfOkoWm_ooikMo`02
oigMo`1@oi[LoonJg?koV][moi[Fn?nNeOCoX]GbojKEkon]dNOo[/7?oiRS
ZOn9TI?oQXZ9ogamMomTI5coIfAMoe]KDomFEE7oH61NoeAFDomBEe?oE5IA
oeaOF?mBDd_oDeI=oeaQF_mNIfKoE69[ohjS]_neeNko[mWboj[JlOnXg_Ko
Z>3gojGNnOnTg?goYMgoojCLoonRf__oXM[eoj?IlOn^gOOo/=SaokSGk?n6
VJ[oDUYUodiAE_m8B4SoB4U4oe1CC?m9DDKo@Ti4od1=@om3CTKoADm7odI=
A_m5BTCoD5E?ofEXHOmZJf?oKViRofiZG_m/JE[oKVaMoe]LC_m@DTOo@4Hl
oca3??lf@3So?D<oodYAB_mGG5KoJfiWofe_I?m^KfOoJfa`of9ZMomXNY3o
PjG1oiS=k?nIe_D5oo3`l003oh61POlM7Agol?3`00Ool?3`1?oalO4loo;b
lP;olO7a0_obl_8koo7al@;ol_;b0_oalO5Doo;blPOolO7a0_o`l?02oo3`
l@Sokno`5_o^k^l1on_[j`7og=cL0On3Ph<00003oh>3PooLg=coj^[Z01Ko
kno_5?o`l?0coo7al@;ol_;b0_oalO4Loo;blP;olO7a0_obl_8Loo7al@;o
l_;b0_oalO4Koo;blP;olO7a0_obl_8Noo7alAGol?3`00WoMlWhogS:nOmj
bo[oO<[hogg:n?mnboWoP/ckoh?=o?n1boX00_n2c?T04On1boSoP<[goh7;
n?n4c__oQ]3mohG?o?n5c_WoQ<ghohO>n_n9d?coS=7kohg@non<co[oSLgi
ohg>n?n>coWoT=7i00;oTM;j05[oS];ioi3AnOnBco_oU]7moicEoonOfOoo
XM_ooj3LoonMfoooV]cooiKJoonHg?ooVmcooi[JoOnLf?[oXM[hojKKn_n]
fO;o`Mk`ojFia?n;VZ7oNHB6ofI/J_m?DDcoH5mJofUYHOmPGe[oIfQRoe]M
F?mIFeKoEEMBoeQJEOm@DdcoEeYAoeiSG?mRJfSoF6I_ohnV^?nceNkoZmOb
oj;Hl?nQgOGoXn7joikNn_nOfogoX=cooj7KoonOf_[oW][doj;Hl?n/f?7o
Z<[SokWBj?m^OXkoDeYToe=DFOm>C4goCTe9oe5BC?m;D4Wo@de5od5<A?m2
CDOoA4e8odE;Aom5BTKoBTm9of]^IOm[KF;oJV]Mog1]G_m/JESoKVeKofY[
FomFF4_oAD/ooci5?Oll@c_o@dQ2oe1EC_mKGUOoJFaSog=cIomaLV[oK71c
of=_Nom]QIgoR[??oiWAl_nGfO/5oo3`l003olC4a?nMWIgol?3`00Ool?3`
1?oalO4loo;blP;olO7a0_obl_8koo7al@;ol_;b0_oalO5Doo;blPOolO7a
0_o`l?02oo3`l@Sokno`5_o^k^l1on_[j`7og=cL0On3Ph<00003oh>3PooL
g=coj^[Z01Kokno_5?o`l?0coo7al@;ol_;b0_oalO4Loo;blP;olO7a0_ob
l_8Loo7al@;ol_;b0_oalO4Koo;blP;olO7a0_obl_8Noo7alAGol?3`0_mh
b_T01_mjbo[oNL[iog_9nOmlbOOoOlWhoh3:n@?oQ<km00GoP/cioh7;n?n1
boSoPL_hoh;<n@02oh?=nP06ohC>non7d?_oRM;moh_Bo_n=dOkoSM3k0_n=
cOT0G_n>coWoSm3joi3Anon@dOWoS];iohk?nOnDco_oU/oloiSAo?nJe?co
VmGkoicHoOnJf?goV=[moiCHoOnEf_ooU][ooiKHnonHeo[oW][lojCMnon[
gOSo/MO/ojW6e_nG[[coOi:IofMbM?m4BTSoDE=>ofATG?mZJV;oJf]SoeiO
FOmKGUOoHfEPofQZIOmLGUWoFEaEofI/H_m[M6ooGg1goi>]__ndf?;oZ]We
oj7Il_nOgOKoWMoioi[KnOnHf?_oVmWnoioKoonOf_[oW][bojGIkondf_7o
/LgSokC9f_mMJgSoDeMPoeQGG?mGEUCoCTe8od]<A_m7C4GoA4i6od9=Aom3
CT[o@Te9od=<BOm4BTKo@dQ2ofEXGomZJV3oIfEHofm/GOm[J5OoJVMFog5b
H?mUIeWoDeM9odE;@Olj@CWo@4Dnoe1FC?mMH5OoK6iSogMeJOmcLf_oKW=f
ofIfPomeTj_oSkkLoiCCm?nDf_`?oo3`l0ColO7a??obl_82oo7al@;ol_;b
>ooalO42oo;blP;olO7aE?obl_87oo7al@;ol?3`0_o`l?48ono_l1Kok^k_
0Oo[jn/1omcLg07oPh>300000on3Ph?og=cLon[ZjP0Fono_kaCol?3`<ooa
lO42oo;blP;olO7a7?obl_82oo7al@;ol_;b7?oalO42oo;blP;olO7a6oob
l_82oo7al@;ol_;b7_oalO4Eoo3`l004ogG9n?mfb_WoMlWiogO8m`;oNLOg
00CoNlOhogc8nOn3cOkoP/ck0_n1boX02_moc?[oO/_iogk;nOmmb_SoOlcj
oh7>n_n3d?coQ]3mohSAo_n9d?`2ohc@o@14ohc?n_n;c_WoSLgiohk?nOn?
d?[oT=7koho@n_n?c_WoT/okoiC?nonDcoWoUM3hoiKBmonFeOSoU]KjoiKH
nonBe__oT]Sloi7FoOn@e?WoU=Choi[In_nPfo_oY=WhojWGlOnaencoXL3D
oh2JYomYNX;o@de?od14@om:BdGoJVYRogAdJ_m`LFWoIfQPog1cK?m/KVWo
FeeHodY<AomTIekoJ75/oe]/Lon>Z;Wo[M;/oj7Bl?nGdnooUMKboi_NnonG
fOWoU]KjoiWGo?nNf?goX=Wgoj3HkonVe^[o]mO/ok;9fonCYK?oEf5Zoe9E
F_mADE7oEeIBodm?Aom;C4CoBdi7odQ?B?m5CTT2od9=B@0JodA=B_m7CDWo
Ada5oeaOE?m]KF7oKVaMofm/Fom_K5WoK6UFogAcHOmaLVCoH6AFodmEBOlm
@cWo@4<joe=FCOmTIEgoMGE[ogQdJOmcLf_oLGUlofj2SOmoXkWoULSUoi3B
m?nAf_d?oo3`l0ColO7a??obl_82oo7al@;ol_;b>ooalO42oo;blP;olO7a
E?obl_87oo7al@;ol?3`0_o`l?48ono_l1Kok^k_0Oo[jn/1omcLg07oPh>3
00000on3Ph?og=cLon[ZjP0Poo3`l3golO7a0_obl_82oo7alAcol_;b1?oa
lO4Loo3`l0ColO7a6oobl_82oo7al@;ol_;b7_oalO4Eoo3`l00DogC8mome
bOSoMlWiogO9nOmib_WoO<[jogk:non0c?goO/Siogg7n?mla_GoOLOfogg:
n?mnboWoOL[hogc9momlb_SoO/cjoh;?non3d?`2ohG>n`04ohW=n_n;coco
SM3moh_>n@;oSLgi0_n?d?X01_n>coWoSLkhoi3?n_nBd?WoTm7hoiCBm`;o
UMCg00?oUMGhoi;FnOn@e?L00_n@e_X0COnBe__oVMWmoikMo_nUgOooY=_j
ojSKn_n_gOOoSkS>ofN6V?mJL7go@DiFocY2A?ln@3go@T<kofYZH?n2Q7Wo
LWAYog5dJomWJV?oGf5Noe=ED?mSI5coJW1/oee/Lon=Y[[o[=7/oj7DlonI
e?;oUmSfoicNo_nHf_coU]Kjoi[FnonNe_WoX=Gdoj3Dj_nWd^?o[/WJoj6c
`OmVM7goDEYOodeAD?m2@ckoDe19oe9BB?mCDdWoD5=:od]BB_m5CdOo@DY5
od5<A_m6Cd[oBE=;odM<AOm>DDKoJF]Nofi/GOmWI5?oKFQEofISD?mWIUCo
KVmOofEYF_mLGeCoBDm3odU<@omJGE;oJ6YOogMgJomkMfcoM7E_ogF0P_md
Si[oQk77oi[Akon@e?OoTM_o017ol?3`7_oalO42oo;blP;olO7a7?obl_82
oo7al@;ol_;b>ooalO42oo;blP;olO7aE?obl_87oo7alP;ol?3a0_oalO48
oo3`l1Kokno`0Oo[jn/1omcLg07oPh>300000on3Ph?ofm_Kon[ZjP0Poo3`
l3golO7a0_obl_82oo7alAcol_;b1?oalO4Loo3`l0ColO7a6oobl_82oo7a
l@;ol_;b7_oalO4Eoo3`l0;oL/Ke00CoM<KfogK8n?mhb?WoNLWj0_mkbOT3
ogo;o003ogk:nommb_SoO<Wg00;oN/Oe01CoO<[hogg;nOn0cO_oPLkloh;;
n?n1b_OoQ/[ioh[>non;c__oS<oloi3@o?nBd_koTm?ooi;Bo_n@dO_oS/oi
ohkBnOn<d?OoSm7doiGGn@;oVmcl05;oU]Shoi;Gm_n?doKoTMOioiGIo?nH
f_goVMSkoi_GnOnPe_[oX]SjoiWAl_nSf_WoSkcIodIZP_m@Jgko>D]GocDn
@oli?Cco@4<lodA6>omJG57oNWaaoh62N_m]KVSoFEUGoeIGD_mSHeWoJg1Z
odeJHonF[l?oYL[Woic>konMf?[oU]KioiGGnOnGeo_oW]WooiS?m_nPd_Go
W/gYoi_8gOnTb=Ko/<KCof9aN?mEH6CoD5UHode@BOmEEdcoB4Hjoda=?omG
Ed_oD5A6odU?AOm4Bd?o?TPooce7?om2CDGoBUA;odE:@omIG5?oJ6YMofm]
G_maKUgoKFYGofUVDomWIUCoK6eMofIZFomMH5GoF5iBoemREomUJ5goLG=X
oh20M?n=RH3oQHN2ogf<Son5XjkoTKoFoi;=jon?doKoTM_o4Oo`l?0Noo7a
l@;ol_;b0_oalO4Loo;blP;olO7a0_obl_8koo7al@;ol_;b0_oalO5Doo;b
lPOolO7b0_o`l?42oo7al@Sol?3`5_o_ko01on_[j`7og=cL0On3Ph<00003
oh>3PooKfm_oj^[Z023ol?3`GooalO4Poo3`l3oolO7a5Oo`l?02ogK:n@;o
N<[j00CoNLWjog[:nomlb_[oO<[j0_mmbOX2ogc8n@0?ogc9mommb_SoO/_i
ogo<n_n0cO_oOlcjoh3=non3cOcoPlcioh?:n?n7bo[oRlonoh_>non<coco
T=3l00?oTM7m05[oT=7kohg@n_n>do[oS=;fohgCmOnCf?WoVM_koiWLnOnF
fOKoUMOgoiCIn_nEfOcoUmWloiSHo?nJe_[oV]GgoikDn?nOeOWoX]kooi[F
n_nA`nCo=5eiod5OMolfBeco>4E>ocDm?om0ACoo?d8iodM9?_mIFe3oJV]S
ofi]J?mVIF7oGUeIog5^IomXJVOoDEiWoh^T^_nXc>coXM?foicHo?nGeo_o
T]CgoiGCn?nId?OoWLkfoio<kOnLa=koY<WKokCBg?m^OhOoADiCodUBDOm=
E4goC4m4oe9DA_m5ASKoATLgoe5D@om@DTCoCE15odU?AOm4C47o@4Y1od9>
A?m9Dd[o?TDmodY@A_mMGe;oJV]Mofi]Fom]JUOoJVMFofIUDomVIeWoIFUK
of1SF?mIGe?oGF1Eof9UF_m^KVCoNg]aohn<Qon7RhcoPYJMohfa_onHc>;o
T]?aohgCmOn>f?daoo3`l;GolO7a2Oo`l?4:oo3`l1Kokno`0Oo[jn/1omcL
g07oPh>300000on3Ph?ofm_Kon[ZjP0Fono_kaCol?3`5OoalO4Poo3`l23o
lO7a7_o`l?04oo7alA_ol_;b1?oalO4coo3`l0;oMLWh00CoM/ShogO9nOmh
bOSoN/Sh0_mlb?T02on1cOkoOl_logg:n?mkb?KoN/Oeog_8m_mmb_SoO/_i
oh7>o?n1bo[oPL_h00;oQ<gj00OoQLcjohS<nOn;c__oSLgkoho?oOn@d?co
TM7m00;oSm3j05[oS]7kohkCo?n=eOgoRmGjohoEnOnCf?WoUmWioiOJmonF
fOKoU]ShoiOLoOnFfocoUmWloiWGo?nLe__oW]Kioj3DnOnNe?SoWMgooi?C
nOnIcoGoAW>DocQJM_lhDFOo=TICoc@o@olnA4;o?d@mocm2=om5AccoFe]C
og1]J?m/J6GoG5QEofaYH_mPHV7oFFEaoh^S^onZd?CoXM;joiG@n?n?d?Ko
TM7goiWEn_nKd?SoY=;foh>ZbOmGMhkoAfAbodIMHom9Ee[o@DY9odY@C?m<
DTSoCE52oe5D@Om@DCooDE90oda???m=D3ooCU94od]AAOm7CdCo@D]0od9>
@_m6D4OoADa4odQ=A_mLGU?oKfmSog9`HOm_KUcoK6YKofESE?mQHUCoIf]M
ofQ[H?mSJEooIfYQofe`IOmjNW3oQXF0ohJ6Q_n6SiKoR:>^oiG0dOnKenoo
T]OfohWBmOn;eOXAoo3`l;golO7a0_obl_82oo7alACol_;b1ooalO42oo3`
l0;olO7a2?o`l?0Fono_k`7oj^[Z0OoMgMd1oh>3P`0000?oPh>3om_KfooZ
j^X05_o_knlDoo3`l1GolO7aH?o`l?0Ooo7alCGol?3`00_oLLGdog;6mOmc
aOGoMLGfogW7momjb?SoO<Siogg9n_n1cOkoP<cmogg:n003og_8mP0<ogc9
mommb_SoP/ckoh79nOn0bOKoQ<_iohG<n_n8c?_oRLcioh_>non>c_coT=3l
0_nAdOd02On?d?[oS/oiohkAnon?e?goSMCnoh_Eo?n?e?_oT]KioiCFn002
oi?Em@1AoiGGmonHf_coUmWloiKHnonJf?goWmWooj;JoonSeocoWmOloi;C
nonDeOgoVmGmog:Rb?llH8;o>EA_oc=6EolkB57o>493ocm6?om0@cSo@D<h
oeAAB_mWHUkoI5mLoe9=B_mSH5_oHFEVoeYXMOnAZlCoY/kboiS<m?n@c_Oo
Sm3hohg>m?nFd_OoU/[aojcGn_mjW;SoB6=hocmFG_m3DUGo@4Q:odI:BOm4
BD?oAD]1odY>?om;D3coD5<noe=F@Om;CS_oBdhmodY>@?m9C47oATa2od=;
@?m2C47o@De3odA>A_m0Ad3oEEQ?ofa^Hom/KEooJVQIofUWF?mOH5;oGEmB
ofEXGOmVK6;oI6YPofY]I?mbMFcoO7eeohB6POmjOhGoQiNToi2da?nGbn3o
U]WdohkIn?n:e?OoSMOl057ol?3`?ooalO50oo3`l1KolO7a4oo`l?0Fono_
k`7oj^[Z0OoMgMd1oh>3P`0000?oPh>3om[Jf_oZj^X05_o_knlDoo3`l1Go
lO7aH?o`l?0Ooo7alCGol?3`0_mcaO@01_mea_GoM/OfogW7momkbOWoO/[k
ogo;o0;oO/Sg00_oOLOfogk8momobOSoP<[iogo<n?n2c?WoPL[goh37mOn1
b?KoQ/[iohS<n@02ohW<n@0>ohc<n_n?co_oTM7moi;Bo_nAd_coSM3johc?
nOn?d_coTMCoohkBoon=dOkoSm;loi;CnOnBd_H2oi7Am01Aoi?EmonDe_Wo
TmCjoiCEnonHf?koWm_ooj7KoonPf?goV]Cjoi;FoOnCe_ooU<oioi31j_m@
N9co=5=boc16GOljBUOo>dI:oce6@Om0AScoBD]0oeiKE?m^JFGoK69QoeaD
D_mYJ6?oKWAdoe5QL?nB[LSoW<K/oi;9l_nEe?goTmOnoiCEnonHe?WoU/S]
ojgEn?m[RJ?o?U=Toc]=DOm5Ce3o>3hnoce1@?lh?COo@TPnodeDA?m=DSko
CU<moe1C?_m@Dd3oC4lnodM9??m4Acco@dToodA<@Om2C47o?d]1od9;A_ll
@SkoDUE>ofY[Hom[JeooJFYLofY[GOmTIEOoIVQKofY]H_mWKF?oIV]Tofaa
J_mcMVgoN7Uaog]oO_miPY7oSjRnoi_8gonEdN_oRmKeohWIn_n=f?ooSm[o
057ol?3`?ooalO50oo3`l1KolO7a4oo`l?0Fono_k`7oj^[Z0OoMgMd1oh>3
P`0000?oPh>3om[Jf_oZj^X05_o_knlDoo3`l1GolO7aH?o`l?0Ooo7alCGo
l?3`0_meaoH2ogG6m@04ogS6m_miaoOoO<Siogg9nPCoO/Sg0_mobOP03_mn
boOoPL_hoh;9mon1b?KoQLWhohS<non:cO[oRLcioh_;nOn<c?[oSlokoi3@
o?nAd_coT=7k0_n=d?X01on>dO_oT=?nohg?oon<c_ooSlomoi7@nonBd?T0
0_n@c_<0?_nAdOGoTM;hoi3AnOnAd_[oU=GmoiSFoOnJe__oV=;hoi;@monB
eOooSM3joi7<n?nHboKoMj79od9SQ_lhD6[o<dADocI3BOlj@d;oADY3oe]M
D_mfLfcoPGUfogU]KOmWGegoKVmZog5kO?m<GfkoTk;>oig:lOnDcOSoU=Go
ohcAn_n<d?OoU=3eoi_=l_neg?_oJ8BJod9DH_liA4Ko?dE3oce1@_lm?cko
=S/eod57?Om>E4KoCUE3oe5F@_mBEd?oDUE4odi@@_m7BCko@TDlod=6?Om4
C47o@Ta1od1<@_m5CTWo?dQ5oe1EComVJF3oK6iS0_m]KF404OmYJekoJfiS
ofY`I_mYKVOoKG9[ogIkM?miOWOoOh1joh66ROn4UJWoV;ODoikAk_n@d_;o
Pm?doh;Fnon8eokoRmSo057ol?3`?ooalO50oo3`l1KolO7a4oo`l?0Fono_
k`7oj^[Z0OoMgMd1oh>3P`0000?oPh>3om[Jf_oZj^X08?o`l?0Ooo7alCKo
l?3`2_o_knl:oo3`l0cokno_4oo`l?0Foo7alCGol?3`01SoMLOfogC6mOme
a_GoMLKeogS6m?mjaoGoO/Sgogo9n?n2c?_oPL_joh39m_mnaoCoOLOdogk8
mOmobOKoP<[gohC;nOn8c?_oS<olohkAo_n?cogoS<cjoh_;mon=cOT2oho?
n`;oSm3j0on=dOP0FOn=d?_oSlcoohk;oon?boooTlgmoi?>n_nBcOOoSlgf
oho>mon@dOWoSM3johc?nOn=d?[oT=7ioi;Bn?nAcoKoSloeoh_@nOn;c_So
T<gioi_>nOnF`>[oK8jcoe5ZR?m1EVWo?4YCodMAD_mHGeSoL75Yoh5nMon7
OG_oPG=cogAZJOmaLfkoKgYloeM/OOnD]];oX];joi?@o?n<dO[oQLgeohoD
non@c_?oV/c_ojcCl?mGLXOo@E9LocI0?oln@cgo@D94oc`m?olh?CWo>T0f
oci6=om4CC[oATdkodY>?Om=Cd7oCDm2odY;@om4Ad3o@dHood99@Om1Bd;o
?dY2ocm:A_lmATGoAda8oeYME_mXJF7oK6aPofYZG_mWJEcoIVUPof=XHOmW
K6KoLgYcoh:7POn6RhCoS8f7oi2HVonI[LKoW/;VoiKAlon9doKoP=GjogkF
o_n3e?ooR=Oo00Sol?3`2Oo_knl:oo3`l0cokno_2_o`l?0:ono_kaKol?3`
?ooalO50oo3`l1oolO7a8?o`l?01on[ZjP7ogMgM0On3Ph<00003oh>3PooJ
f][oj^[Z023ol?3`7ooalO4foo3`l0[okno_2_o`l?0<ono_ka?ol?3`5_oa
lO4eoo3`l0?oNLKb01GoO<Kcogk8mOn1b_OoQ<gjohG>non1b_OoOlSeogg6
lomlaO;oOLKcogo9m_n3cO[oQ/olohW=n_n=d?goT=?noiCDoonBd_koSLgi
oh_;mon=cOT00_n>c_X00on=cOWoS/oiohg@nP02ohc?n@1Ioh_>nOn?cOoo
S/[ooho;oonAcOooT/oloi3=nOn>cOSoSLkhohg@n_n<co[oRLkhoh[=n?n=
c_SoSm3joi7@nOnBdO[oRlkhoiCEoonAc_[oVLkjoiO4k_nA]mkoJHJVofIl
TomKJgSoKGQlogj4P_n6Qh;oR8B1ohZ2P?n>Q8GoS8N;ogImPom/OX[oIGnF
ohjee?nPdO[oSlchohcAnon?f?ooSM;iohg=lOnKd?;oZmC`oe5]P_m3EEoo
=3hmocTn>_lj?3_o>cdlod97@olm@S_o>D4dod59>_loACOo@DDgodE9>om;
CD;oBda4odM8@_m2ACko@4Dnod58@?lnB43o>dM5oc]5A?m2Ad7oEUM?ofm/
HomhMV[oM79Vog5aIom[KVOoJFiXog1eKon3R8CoTYRDoiFKVOnJX:3oWjff
ojG4hOnJb_3oSlocoh[Fn_n9g?ooQM[oohKEoon;f?l02?o`l?09ono_k`[o
l?3`3?o_knl:oo3`l0[okno_5_o`l?0ooo7alD3ol?3`7ooalO4Poo3`l07o
j^[Z0OoMgMd1oh>3P`0000?oPh>3om[Jf_oZj^X08?o`l?0Ooo7alCKol?3`
2_o_knl:oo3`l0cokno_4oo`l?0Foo7alCGol?3`01;oPLC^oh?6l?n3a_3o
P<?]oh?6l?n;c_SoS]7loh[?nOn5bOKoOlKbogg4l?mnaO7oP<Ocoh7:mOn3
c?OoQlkjohk>n_n@coX3oi7@n`05oi3?n_n>coWoSLkhohc<n?n=cOT00on<
coX03On;c_WoRLkhohW<nOn;boWoSLgkohc<n_n;boWoS/kloi3Co_n?d_go
S<ojohS=mon9cOX00_n;c_/2ohk>nP1:oho>n_n>cOWoT<ojoi3=nOnAboWo
U<[hoiW<nOnJaNooS[3Eoh2I]ommSZ;oPh^Hoh^>TonDU9KoU9:Eohn=T?n=
SHooRY6Koh2BZ?n1Wk_oS:o?oiG1i_nIcOGoUM;nohkCoOn:dO_oRM3joi7B
n?nGco;oW<[Toda]P?lcBECo;3Xmoc<l>oli?Cco>Slkod15?om5BTCo@TM0
ocY0=_ll?cKo@TDloci1>?m1A3_oADI0odI7@Om5AT3o@TDlod54>olnACko
>TU6oc]:AOlk@3WoD4i2ogI^HonBRWooNgM^ogmlMOmnOgWoNgehohF7P_nF
ViOoX:JVoijY[OnT/[goY/;Goi[=k?n@dOOoSM?gohSBmon6dOSoR=?joh_E
o?n=eOd8oo3`l0Wokno_2_o`l?0<ono_k`[ol?3`2_o_knlFoo3`l3oolO7a
@?o`l?0Ooo7alB3ol?3`0OoZj^X1omgMg@7oPh>300000on3Ph?of][Jon[Z
jP0Poo3`l1oolO7a=_o`l?0:ono_k`[ol?3`3?o_knlCoo3`l1KolO7a=Oo`
l?007?n6a>_oRLW_ohc:lon;b_?oSlkgoiOHoonJfoooU]WoohW>n?n3b_Co
PLSboh;9lon3b_KoPlcgohC=n?n7c_[oR/_eohc;m_n=c?OoS/oioho>nOn>
coWoSLgioh_>nOn9bOGoR<_fohW<nOn:cOX2oh_>n`;oRLgj00GoRlkkohg@
non<co[oR<ggohW=nP02oh[>n`03ohO;n?n9cO[oRLgj00;oRlkk037oSLgk
ohk>o?n?cOcoSlkjohg<n?n?c_WoT<okoi3=n_nEcOcoV<_foiBni_n>[m3o
T:S2oi:Q]?nGXJgoW:F^oj2Y/_nOZK;oWZfdoibb`?nH]mCoUK_PoiO1ionH
b>koU/gfoi;?non>dOcoR]7mohS?nOn@dOWoU]7coig<i_m7JWgo=4aFobhm
@_lc?3_o=C/gocHk=Olj?cWo?d@noci3?Oli?SSo>3/docTl=Om2ACkoA4M0
odI7@Om7B4;oADHn00;oA4Dm01;o@DI0ocA3?_ljBDCo?dDkodE3=omRFToo
Uhj5oiNDSon>T8goRi6Aoh^DTonCW9_oWZRYojBa^OnU^<KoY/7Foj?:ionA
d?<2oh[Dn@05ohSBmon8d?KoRM7gohcAn?n=d_T02?o`l?09ono_k`[ol?3`
3?o_knl:oo3`l0[okno_5_o`l?0ooo7alD3ol?3`7ooalO4Poo3`l07oj^[Z
0OoMgMd1oh>3P`0000?oPh>3om[Jf_oYjNT05_o_knl:oo3`l0[okno_3?o`
l?09ono_k`[ol?3`C?o_knl:oo3`l0Wokno_3?o`l?0:ono_k`[ol?3`:oo_
knl03On;b_?oSLkfoho>nOn?d?[oTmCnoiOJoonJgOooUmcoohS<nOn3b_Ko
PLSdoh7:mOn1b_L00_mobOH03?n2boKoQLSeohS8m?n9bOGoRLcgohc<n?n;
c_WoRlkkoh[>non6bOKoQ/[gohK:n@;oQl_j0_n8c?/01_n9cO[oQ/[gohW=
n_n9cO[oR<ciohO;n0GoQlkj02[oRLgjoh[>non;c__oS<olohk>o?n?co_o
Qlcfoh_@nOn=d_coS=3moho?oOnBco_oU/_coiS6j?nG_=WoUKG<oiJaa?nJ
]LKoWk[;oinoc_nN`];oX<KKoj7=j_nNc>koV/c_oiK<l_nBcOGoT<ojohkA
o_n>d_ooRLkhoho>monHc_3oVLGPod1OLolfBUGo<Se1ocDk>olf>cOo=CXf
ocLl>?lj?c/2oce2?00KocXl=olf>3?o?T0kocm1??m1A3go@TDnod=4?_m4
ACooADI0od=8@_ld@cko>4M2od98?_m1@COoD4a3ohJ5P?nPY:GoWZV_oiNX
/?nJ[[OoWk>loj2h`_nR_/coY<CIoj?:ionLc_7oT=7g00?oR]Ck00CoR];j
ohWAnOn9dOWoR];j2?o`l?09ono_k`[ol?3`;?o_knl:oo3`l0[okno_:oo`
l?0:ono_k`[ol?3`3?o_knl:oo3`l0[okno_;?o`l?09ono_k`[ol?3`5_o_
knl1on[ZjP7ogMgM0On3Ph<00003oh>3PooJf][ojNWY01Kokno_2_o`l?0:
ono_k`col?3`2Oo_knl:oo3`l4cokno_2_o`l?09ono_k`col?3`2_o_knl:
oo3`l2_okno_00?oT=7kohkAnon<coT00_n:cOL2ohcAn`0>ohS?nOn3b_Ko
OlScogk7l_mnbO?oO/Seog_8m?mla_?oOLOdoh78m_n4b?OoQLWhohO;n_n8
c?/2ohW=o007ohO>n_n7bo[oQLcjohK:nOn4boWoQ/[iohC;n@02ohK:n@04
ohG9n?n7boSoR<ciohK=n@;oQLch00CoQlkjohS?non7c_[oQlkj0_n9cOX2
oh_>n`0Sohk>o?n=d?_oQ/ggohWCn_n;e?ooR=7lohS?non;d?[oTM3koiG?
mOnHb^_oVLKUoiS4gonLb>7oW/cToig=i?nJcNSoVLo[oiK;jonFc>koULg`
oi??m?nAd?WoT=7kohkAo_n=dOkoSlokoi7?m_nJc>ooT;[CocQEIolfB5;o
=Si1ocPl>olf>ST00_lf>cL02Olg?3So?44mocm4?_lo@Cco>S`goci0>olo
@Cco@48mod13?003od52?00Foci3?OliAD7o=D8koce2>om5ASkoB4U3oeiT
I?n2TISoX[S5oj2mcOnM`=?oX<?Foio5f?nMamooV/WWoiK:lOnBcOGoS=7j
ohWCn_n:e?_oRmGloh_Cn`;oR];j00?oRm?koo3`l?o`l?001_o`l?09ono_
k`[ol?3`;?o_knl:oo3`l0[okno_:oo`l?0:ono_k`[ol?3`3?o_knl:oo3`
l0[okno_;?o`l?09ono_k`[ol?3`5_o_knl1on[ZjP7og=cL0On3Ph<00003
oh>3PooJf][ojNWY01Kokno_2_o`l?0:ono_k`col?3`2Oo_knl:oo3`l4co
kno_2_o`l?09ono_k`col?3`2_o_knl:oo3`l2_okno_00GoS]7loh_@n_n6
boGoP/Oaoh35k`02ogo6lP0;ogc5l?n1b_OoO/Seogg7m?mmb_KoOL[hog_9
momkb?KoO<Wgogk8mon0b?P00_n1bOT04On2b_[oPl_koh?;non3c?WoQL_l
oh?;non4b__oPl_koh?9n_n2b_[oPlWjohC;nOn6cO_oQlklohS?oOn6coco
Plci00;oP/_h00?oQ<gjohG>nOn6coX00_n7c_X09?n9cO[oR/kkoh_>non;
d?[oQm3iohSCn_n8dogoQ]7kohG?o?n7d?goRlolohk?nOnBd?OoU<kdoiO?
m?nGd_CoUM7eoi3@lon=dOKoSM7dohk>lOn?co;oTM7eoi7Bn?n?d_coS]7l
ohc@oOn;c__oT]7moiK@n?nRd?CoRZo:ocUCI?lkBE;o>d14ocXl>`;o=SXi
00?o=CThoc@i=Olf>cL00_lj?c/07?lh?CWoA4I3odA6@Om5Ad;oA4I1od=5
@?m0@Sgo?3hiocPm=ole@S_o<d0iocHk=?loA3ko@4I6ocE2B?mKMHCoVkoE
oio;i?nHb^GoV<_Xoi[?k_nGco3oS/ccoh[=n_n;d_ooQm3iohK@mon8d_T2
oh[Dn`;oR=;i00?oRmGloo3`l?o`l?001_o`l?09ono_k`[ol?3`;?o_knl:
oo3`l0[okno_:oo`l?0:ono_k`[ol?3`3?o_knl:oo3`l0[okno_;?o`l?09
ono_k`[ol?3`5_o_knl1on[ZjP7og=cL0On3Ph<00003oh>3PooJf][oj>SX
023ok^k^MOo_knl:oo3`l0Wokno_Boo`l?000on4boGoPLSbogk5k`03og_4
k`0Eogc5l?mka_3oO/Seog[7lomia_;oN/Wdogc:n?mib_OoNlWgogc:n_mk
aoSoNlOiogc8n_mlb?WoO<Sjogc8nOmnb?WoO/Sgogo9n_n0b_WoPLWi00;o
P/[j0on3bo/02on4c?coPlciohC=n_n4c__oQ<gjoh7;n?n2c?WoQ<kkoh?>
n?n4cOSoQLki00;oQlkj0on9cOX01?n9d?[oQm3iohO@non6dO/2ohS@o`03
ohW@o_n:c_goRlkk00;oSLgi00[oS<chohS=mon6cOWoQ]3mohSCoOn;e?Oo
S=;dohcBm_n<dOSoS=7k0_n<d?d03?n?cogoSlcioiS=mOnTd??oO:2joceD
I?ljBE3o>Sm2ocLi>?li?Cco=c/jocDi>0;o=3Pg01ko=CXfocHk=olg?3So
@48ood53@?m2A47oA4I1odE7@_m3AD3o@48moc]2>old?cWo>D@locPm=olh
?S[o=T53obDiA?mAM8SoVLSToiG=k_n<bnkoSLgaoi7Bn?n>d_WoQlkjoh??
oon7eOooQM3johC>mOn5coH2ohSBn@03ohG?m_n7dOSoRmGl00Sol?3`2Oo_
knl:oo3`l2cokno_2_o`l?0:ono_kb_ol?3`2_o_knl:oo3`l0cokno_2_o`
l?0:ono_kbcol?3`2Oo_knl:oo3`l1Kokno_0OoYjNT1om[JfP7oPh>30000
0on3Ph?ofMWIonOWi`0Nong]k@Cok^k^7Oo_knlPonk^kSKokno_2_o`l?09
ono_kd_ol?3`00GoNlC_ogW2kOmi`^goNL?`og[4l@03ogS5l@09ogW6m?mf
a?;oML?aogG6lomfaoKoMLOfogK7m_mhbOSoN<Sk00;oN/Ok00WoN/SiogW6
n_miaoSoNlOiog_7n?mkaoWoO<Siogo9n_n0b_/00_n1bo`00on0b__oP<[i
oh3:n@02ogk8m`09oh3=non3cOcoPLkloh7>n_n3d?coOlchoh;<nOn3cO[o
Q/ol00;oQlkl00KoQ/gkohO;n?n;d?[oR/ghoh[=n_n:c_/2ohc>o`;oRlgo
00KoT=3ooho?oon>c_koRlgooh_?oon;dOl2oh[Do`0EohWCn_n8d_OoR=3f
ohW>mon9c_SoRlolohg@oOnBdOgoT<_goiO;lonQc^ooJH^Toc]BH_lgATgo
>450ocHk=olj?Sgo=CTjoc@h>Olf>SWo=c/j00;o=CTh01co>3`kocLk>_lg
?3So>Slkoce2?_m1AT;o@dQ4od97@om0AT;o>T@loce7?oloA3ko>D8ooc50
AOlT?TgoFhFNoiG;kOn9b_;oQLcfohO?mon8coWoQm3kohCAoon1doooP]Co
ohOAo_n4cOKoQ<og0_n7d_X00on4coOoQM3hoh[Eo@08oo3`l0Wokno_2_o`
l?0/ono_k`[ol?3`2_o_knl[oo3`l0[okno_2_o`l?0<ono_k`[ol?3`2_o_
knl/oo3`l1?okno_5_o^k^h1onSXj07ofMWI0On3Ph<00003oh>3PooIfMWo
inOW01kokNg]1?o^k^hMono_kb3ok^k^=_o_knl:oo3`l0Wokno_Boo`l?02
ogFok00AogK0kOmga?3oN<GaogG4komd`nkoLl;]ogS6m?mdaO;oLlCaogC5
l_meaoKoM<KeogG7m_mfb?SoN<[logS9o_mibO`00omhb?/01Omkb?coNlWj
og[8nOmlb?[oOLWj00;oO/[k03CoOLWjogg7n?mja_OoPlglogg:n?mlbOOo
Olcjoh3=nomnboWoOL[fogk;mommb_KoOlchoh?=n_n5cocoQ/olohK=non5
c?[oQ/[iohc?o?n<c?SoRl_iohc<n_n<c?coRl_kohc<o?n=cOgoS/knohg<
oon<bokoRlgoohc?oon>dOooR]3oohG=oOn;e?goR]Ckoh[Bn_n:coWoR/kk
oh_>non>c_coSlkjoiG>nonIcOCoX<_[oeaoUOlgDEko<dE9oc]6@_ll@Sko
=c/j0_l`=3D02_lf>S_o>CdlocHj>Ole>CSo>3`kocXn?Oli?Cco>Slkoca1
?OloA402od15@@0<ocm4@?m3BT?o?4<lod56@?m0BDSo;d17obA1DomPSJ[o
SLO]ohK;mOn8d_ooR]Go0_n5d?X02on8eOooQ=Kooh7Aoon8eOooQm3iohKA
nOn9e?coR=?kohG@n?n7d_[oS=Oo00Sol?3`2Oo_knl:oo3`l2cokno_2_o`
l?0:ono_kb_ol?3`2_o_knl:oo3`l0cokno_2_o`l?0:ono_kbcol?3`4oo_
knlFonk^kP7oj>SX0OoHf=P1oh>3P`0000?oPh>3omWIfOoWinL07_o]kNd4
onk^kQgokno_8?o^k^hfono_k`[ol?3`2Oo_knm;oo3`l0;oLl3^00?oM<7_
ogC2l?me`o400_me`o402omca?7oL/?`ogC5l_mea_GoLlGdogC6mOmfb?Oo
MlWhogG7momfb?[oM<Ok00;oMLKk013oMlSmogO9nomhb?_oN<SkogO7n?mk
bO[oOL_logc:nomiaoOoN<Kfog_7n?mlb_[oN/Kgog[8n?mlb_[oOL_k0_mn
c?X01?mmboWoO<[hogo=nomoc?X2oh;<n@;oQ<gj00CoQ<_ioh?:n?n8c?Wo
R/gj0_n<c?P3ohg;nP03ohk<non?cOcoS/kn00GoS/kn00KoSM3moh_Bo?n;
d_coSM;lohg@non=d?d2ohk>o00Boho<nOn@bOCoW=3goig:jOm:KXCo>eMS
obm2A_ld@3co=d4iocPn??lh?3go<CDfoblc=?le>C[o>3`mocTm??lm@D3o
>Cdl0_lj?Sd05olk?cko?dA0od97@om1AT;o?D8nod99@_lg?SKo@dQ2oci7
A_lcA4co;DYLoeV8Y_n>bO7oR<okohSBoon5d?SoQLofohSBnOn6dOWoPm3l
ohKDoon2cOOoQ<og00;oQm;j00CoQM3hohC?mon3dOSoQM?j2?o`l?09ono_
k`[ol?3`;?o_knl:oo3`l0[okno_:oo`l?0:ono_k`[ol?3`3?o_knl:oo3`
l0[okno_;?o`l?0Cono_kaKok^k^0OoXj>P1omSHf07oPh>300000on3Ph?o
fMWIonKViP0Nonc/k0CokNg]6oo^k^h2ong]k@;ok^k^7?o]kNd2onk^kP;o
kNg]7_o^k^idono_k`;oL[o]0_mb`>h2og?1k`?oL/?`00SoM<Gbog?5m?mb
a??oLlGdogG7m_mfb?OoMLOgogG8nP?oM<Ok00SoM/OlogO9nomgao[oM/Ki
ogO7n?mhb?WoNlWjog[8n@;oNLOg00[oNlWiogc:n_mlb_[oO<[jogg;nomn
c?coOLkmogg>nomocO_oO/cj0_mmboT03On1boSoP/ciohG>non6cocoRM3n
oh[Aoon8dOkoRM3loh_@n_n<co[oSLgiohc=mon=c?P00_n=cOT3oh_>n`08
ohk>o?n>c_[oT<ojoi3Anon=d?_oRm3joh_>nOn:cOP2ohc<nP0<ohk<non?
c?WoTlcgoiS<lOnJanCoA6YoocUGHOlcB4Wo=dI1ocU3>old>SSo=c/l0_lc
=cP03?lh?3go>CdnocHj>Olh?3_o>CdlocXn?Oll@3oo@4A3od=8A?m2Ad?o
?dA0oca1>`;o?TDm01Ko@DI0oc]5A?lgB53o<4mQoeB2Xon;bO3oQ<_gohG?
o?n5c_OoQLgcoh_AmOn8d?KoQLkgohOBo?n5d?SoQm;johSCnon7d_[oQ<og
oh?>m_n1coKoPm7h2?o`l?09ono_k`[ol?3`5_o_knlPonk^kSookno_5_o^
k^hDono_k`col?3`2_o_knl:oo3`l1?okno_1?o^k^hNong]k@7oj>SX0OoH
f=P1oh>3P`0000?oPh>3omWIfOoVi^H07_o/k>`4ong]kA_ok^k^0_o]kNd2
onk^kQcokNg]0_o^k^h2ong]kAkok^k^M?o_knl4og2nk0;oLKo]00?oL<7^
og72komca?400_mdaO801_mb`o3oL/CcogC6mOmeaoKoM<KfogK8nP?oMLOi
0_mfb?X00omfa_WoMLGfogO7n004ogO7n003ogS8nOmjb__oN/[k00;oNLWj
00?oN/[kog[;n_mjboX00omkc?/03_mha_CoNlWgoh7;n_n3cOcoQ<gjohG>
non7c_coQm3moh?@o?n2dOcoQM3johG>mon6c_KoR<gd0_n8cOH4ohO>n00F
oh[?n?n<d?OoSm3foi7Amon?co_oRlkkohc<n_n;boWoR/[hoh_;nOn>c?_o
T<gjoiG@n?nCbNgoUlKRoceSM_lbD5[o<4E6ocQ4@?ld?SKo<cTgocLk?0;o
=SXk00Co>ShmocPl>ole>CSo=SXi0_lh?S`06_ll@Sko@dU5odI<B?m1Ad?o
?48noc]2>olk@S[oADa4oci3?OlkADCo>DYBocIEIomBP:7oS<O_oh?8l_n4
cOSoQ/_dohS<lOn=co;oR/kaohO<lon7coOoPlkfoh;?nOn4dO_oPm3j0_n2
coT00on4dO_oQ]?moo3`l007oo3`l0Wokno_2_o`l?0Fono_kb3ok^k^?oo_
knlFonk^kQCokno_3?o`l?0:ono_k`[ol?3`4oo_knl4onk^kQkokNg]0OoX
j>P1omSHf07oPh>300000on3Ph?ofMWIonKViP0Nonc/k0CokNg]6oo^k^h2
ong]k@;ok^k^7?o]kNd2onk^kP;okNg]7_o^k^idono_k`CoKkg[017oL;k/
og6okOm_`>goL<7^og?4lOmdaO;oLlCaog72koma`_7oLlGdogC6mOmcaOCo
MLOgogC6m_meaOSoM<KfogK6n@02ogK6m`07ogG5m_mgaoSoM/KgogG5m_mf
a_OoMlOhogS8n@02ogW9nPGoN<Si00_oN<WhogW:nOmib_WoMlGcog_9mon4
c_goQLonohG>non2boSoP/Wgoh3:m`02ogc=nP03ogk=m_n2cOGoQLof00;o
Qloe00[oQ]3gohG@n?n5d?[oQM3johK?n?n8d?SoRm3gohk@lon@d?KoS/kj
0_n=cO/2ohc<nP0^ohg=non>c_coSlkjoi?>m_nCbN_oUlKRocaRMOl]BECo
;3i2ocI1?Olg?3Ko=c/jocTm?_lg>cco=CTjocPl>olg>c[o=CThocPl>olh
?Sco=S`joc]1?Om4BTKoATa8od16@_lk@Cgo?4<loca3>om4Bd?o?44koci8
AoleB4oo?5]]oe^9Z_n9a>coPlSboh?<mon5b_?oQ/[_ohc>lOn;cO3oQl_b
ohK>m_n2cOOoPLkhoh;?n@;oPLkh00?oP/oiohCAnon5d_`02?o`l?09ono_
k`[ol?3`5_o_knlPonk^kSookno_5_o^k^hDono_k`col?3`2_o_knl:oo3`
l1?okno_1?o^k^hNong]k@7oj>SX0OoHf=P1oh>3P`0000?oPh>3omWIfOoV
i^H07_o/k>`4ong]kA_ok^k^0_o]kNd2onk^kQcokNg]0_o^k^h2ong]kAko
k^k^M?o_knl01Om__>[oL;g[og2mjom`_N_oL;k/00;oLKo]00CoL/3^ogC2
l?me`o7oM<;`0_mb`>h00omca?7oM<Gbog?4l`02og?4l`03ogG3m?mdaOCo
MlGf00?oN<Kf00CoMlSgogK7m_meaOKoM/Kg0_mgaoP00omhb?WoMlOhogW9
o002ogS8n`;oN<Si00GoNLWjogW:nOmib_WoO<[jogo=o@02ohG?oP0=ohC=
n_n2boSoP/Wgoh7;n_mmc_goNlglogk=n?n3c_KoQ]3gohWAmon8d_WoQm7h
oh?@nP02oh;Ao008oh?@o?n6coSoQlogoh_?m?n=c_KoS<chohc<n_n;c_/2
ohc?o00Koh_>non;c_WoS<ggohg;l_nHc_3oTl3Mod9UNOl]AE7o:cPnocXn
?Om0@Cco>C/jocXn?Oli?Cco=c/jocPl>olf>SWo=3XhocPn??lg?CWo=3Xf
ocPn>_m1Ad?o@DY5oca5@?ljA3co?DLo00;o?DLn01?o>D0iod9<Bol`@d[o
@5maof^I^_n7`^[oQ/[gohG>non3b_CoQ<W`ohS<lOn8c??oPl[dohK?n_n4
dO_oPm;koh;An_n0coSoOlcf00;oO/_e00?oOlcfoo3`l?o`l?001_o`l?09
ono_k`[ol?3`5_o_knlPonk^kSookno_5_o^k^hDono_k`col?3`2_o_knl:
oo3`l1?okno_1?o^k^hNong]k@7oj>SX0OoHf=P1oh>3P`0000?oPh>3omWI
fOoVi^H07_o/k>`4ong]kA_ok^k^0_o]kNd2onk^kQcokNg]0_o^k^h2ong]
kAkok^k^M?o_knl2ofnljP03og2mjoma_^coLKo]00?oLKo]00OoL/3^og?1
komc`NooLKo]og;0k_md`_3oLlCa00?oM<;`00?oM<;bogG3lOmgaOD00omh
a_H00omea_GoM/OfogK6m`04ogK6m`03ogO7n?mfa_WoMlOj00;oMlOj0_mh
b?T2ogS9n0;oOlgm013oPL_jogo9n?mob?GoP<WfohG<n_n7coooP<knogg>
oOn1boSoPlceohO<mOn8cOKoQLgeoh?<mOn3d?coP]3n0_n1col01on4c__o
Q/gioh[=mon<cOOoR/[fohW<nOn;c_/00_n;co`03_n9cO[oR<ggoh[;mOn=
bo;oW]Choh6]b_m0H7Go;D1>obXa>Olg=CKo?c/jocDg=_li?Cco>Shm0_li
?C`08?le>CSo<SPfocDk>Olf?3So=C/gocLm>Olm@coo?DI1oc]4?olkACgo
?TQ0oce7?_ljA3_o>T4jod5;B_laA4_oAFAhogRVaon4`^_oQLcjohC>oOn2
boKoPLSbohC;mOn4boOoP/[joh?@o_n1d?_oPM3ioh3?n?moc_OoP<gg0omo
c?Haono_kb3ok^k^?oo_knlPonk^kSgokno_1?o^k^hNong]k@7oinOW0OoG
emL1oh>3P`0000?oPh>3omWIfOoVi^H07_o/k>`4ong]kA_ok^k^0_o]kNd2
onk^kQcokNg]0_o^k^h2ong]kAkok^k^M?o_knl01?m]^^SoK[_Yog2mjoma
_^`2og:ok@03og6nk?m`_N_oLKk/00;oLl3^00GoL[o]og;1k?md`nkoMLC_
og?2k@02ogG2kP04ogG2l?me`^koMlCbogS5l`;oMlGc00CoM<;bogK4m?mg
b?OoMlSg0_mfa_L01_meaoOoM/ShogG5n?meaOSoM/KiogO7nP?oN<Si00?o
MlOhogc:n_mkbOT00_mmaoH0:omob?GoP/WgohO;n_n7cOkoP/_noh39o?n3
aoSoQLSeohW9mOn:boGoQ/WdohC8mon5cOooP/kooh7=oon2c_ooQLcoohS<
oOn<c?[oS/gioh[=n_n9cO[oR/kkohS?non8coWoQlkhohK=mon8boGoS/cc
oigCmomQSJ[o=UA/obhnCOl_<S_o>2ldoc`c=?ld=3Co=c/jocPl>olf>SWo
=CXfoc8g<ol`=S800_le>cL00olf?3So=d4iocU3>`02oc]5?@;o?4Hn01Ko
>DDkoce7?_lk@S_o?DM8ocY<E_m8JGcoNZ_<ohG2k_n1bOWoPLgnogo<n_n0
b_OoPlgjoh3<oOmnboooOlooogc=n_mlcOSoOlkioh3?n_n1d?_oP]7l0_n3
d?`aono_kb3ok^k^?oo_knlPonk^kR3okno_7Oo^k^h4ong]kAkok>c/0OoW
inL1omOGe`7oPh>300000on3Ph?ofMWIonKViP0Nonc/k0CokNg]6oo^k^h2
ong]k@;ok^k^7?o]kNd2onk^kP;okNg]7_o^k^idono_k`0Tofbiiom]^^So
L;g[og6nk?mb_ngoLKk/og2mjom__>[oL;g[og:okOmc`>koLKo]og;0k_md
`nkoM<;`og?2kOmf`o7oMl7^ogG2l?me`^koM/?aogO4l_mfa?;oML?cog6o
kome`o?oMlSgogS9n?mgaoSoM/KgogG7momhb?WoM/KiogO7n_mibOcoN/[m
0_mkbo`2og[:n`0Aog[8n?mkbOWoOL[hoh7;n_n4c?coQ/gkohO;n_n5boco
P/Wmoh;8non3aoSoQLOgoh_;mon<c?SoRl_iohO;n_n4c?h00on3c?l07_n5
c?ooRLcoohg=oOn=cO_oSM3kohcAnon;d?[oRM3johS?nOn8d?SoR<oioh_?
m_n:b>ooV<g_odUbT?l_Bf7o=45AocTl@om0=c[o@CPiocHf=_lg>c[o=CTh
oc4e=?l`=C7o;S@`oc0f<_lh?S[o=C/gocPn>P;o>D<k00ko>T@loca6?_ll
ASko>dDlocE1=om1Bd;o?48nocM2A_loEF;oAf^1ogF[cOn4aNooO/Kfogo;
o0;oP<[i00OoP/omoh3>o_mkbokoO/kooh7?oOn1d?_oP/ok00?oPm3l00?o
P/okoh7>n_o_knl0<?o_knlPonk^kSookno_8?o^k^hPono_kagok^k^1?o]
kNdNonc/k07oinOW0OoGemL1oh>3P`0000?oPX:2omWIfOoVi^H07_o]kNd2
onk^kP;okNg]6oo^k^h4ong]kAcok>c/1?o]kNdLonk^kP;okNg]0_o^k^hL
ong]k@;ok^k^0_o]kNeBonk^kP0;offkjOm__N_oKkg[ofbjj?m]^^SoKkcZ
og:nkomc_o3oL;c]og6mk_m`_^h00_ma_nl01om``NkoL<7`og72kom`_>go
Ll3^ogK2lomf`o400_mb`?001ome`o?oN<KgogK4mOme`oCoM<;cogK4mOmf
a_T00_mhb?/06omgao[oNLKjogO4n?mga?SoN/Okog[:nomibO[oN<SiogW9
n_mjbo[oO<[jogg9n_mobOSoP/[joh?;non6c?goQlgnohG=oon4c?coPlWj
oh;9mon5bOSoQ/[gohO;n_n5c?[oRLooohK>oP02ohG=o@0lohG<n_n4boWo
R<ciohg@non8bO?oRL[boh_<m?n<d?OoRm3gohW>mOn:cOOoSloeoi3:l?nI
b^_oBFj9ocMBIol[>dSo?dA8od91?olf=C7o:bd/oc0f=_le>cWo<CLeobdc
<Ol_=C?o<cTeoc<l=old?CSo>44locQ2>_li@c_o?4HnocY4??lg@CSo>D<j
ocI2=?lkACco>T10ocI3C?lgDVGo>VR0oh;3homobNkoP<Wfoh79nOn3b_So
Plcioh3=nOmnc?[oOL_iogc:n?mmb_KoPlgjohK@oon5cokoP/ckoh3:nOn1
bo[oPlgl<Oo_knlPonk^kR3okno_=Oo^k^hDono_k`col?3`2?o_knl2onk^
kP;okno_2?o^k^hEong]kB3ok>c/0OoXj>P1omSHf07oPX:200000on2PX;o
f][JonGUi@0monk^kPCokNg]7?o/k>`4ong]kAcok^k^1?o]kNdNonc/k1go
kNg]0_o^k^h2ong]kC?ok^k^00KoJkWWofjlj_m__N_oK[cZofjkjOm__>X2
og2lk@?oLKg^00?oLKo_og;0l?m``O000_ma`_402?ma_nooM<3aogG1l_me
`O;oLl7aog;0l?md`_?oM/Ce0omd`_<03Ome`oCoM<CgogG5n?meaOSoM<Cg
ogW6n_miaOWoN<Giog[7nomibO[oN<SiogO7n?mhb?T00_mib_T03_mkbOWo
OLWjoh3:nOn2b_[oQ<[kohC<o?n1bOWoP<Shogo7mon0b?SoPl[hohG<n_n6
cO_oQlkl0_n4boT0=_n5c?SoQ/giohO>n_n6cOWoR<okohgBo?n;c?KoRl[c
oh[;lon:c_GoRLkgohS=m_n9c?KoSLgcoiC;l_nHbN[oC76<od9OLOl^@4[o
=T12oc<e<_lf=c7o9RXYobP^;_l]<c7o<CLeocHl>_li?cgo=Sljoc<l=old
?CSo=d0kocM1>OljA3co@D]3od1:@_lkACco>T@iocQ3=OllASgo>d13ocI2
C_laD6Go=FN2ogc1h?mkbNgoPlcgoh;;n?n5bOSoP/Wgogk;momncOSoOlkg
oh3=m`;oQ<kk00KoQ<kmoh?=o?n1bo[oOL[hog_8m_mjaoD_ono_k`Cok^k^
7?o]kNd4onk^kQcokno_1?o^k^hKong]k@;ok^k^0_o]kNdDonk^kQCokno_
3?o`l?08ono_k`Cok^k^2?o]kNdeonc/k07oj>SX0OoHf=P1oh:2PP0000?o
PX:2om[Jf_oUiND0?Oo^k^h4ong]kAcok>c/1?o]kNdLonk^kPCokNg]7_o/
k>`Mong]k@;ok^k^0_o]kNdconk^kP04ofZfiom]^N[oL;c]ofnkk0?oLK_/
00OoKkWZog:lkOmb_>goL[c]og6mk_mb_^ooLKo_00;oL/3`0_mc_o02ogC0
l@;oLl7a0_md`_<01?me`oCoM/CeogO5m_mgaOH2ogC4m@;oMLGh00GoNLKj
ogS5nOmiaoSoNlWjogS8n@02ogK6m`05ogS8nOmfaoKoMlSgogW7momkaoP0
0_mnb?T2ogo7m`04oh?;non1bo[oOlWhogo9n0;oPLWi00koP/_hoh7:mon1
b_OoPL[gohC;nOn7c_coQlkjohK=nOn7c_[oRlolohc?n_n8boKoQL[dohC;
m@;oQ<gf02SoQ<_eohS<lon@bo?oSl7Tod=ZQoliF6co;41;ocI1@olZ;b_o
;2hYoa`Q7OlQ9bGo:Bl]oble<ol^=33o;38^obdc;ola=c?o=S`hocLm>Olf
?3So>T0lodA;A?m3BT?o>d8kocDo=_le?cCo>dDloc]0@olf@Tko<4aRocQW
Pomj_mkoNlW]oh7:mOn1b_OoQLWhoh?:n?moc?SoO/gh0_moc_T02?n0cO_o
O/_iogc9momlbOOoOlcjogk<n_mlb_[oNLOg;oo_knl4onk^kQcokNg]1?o^
k^hLono_k`Cok^k^6oo]kNd2onk^kP;okNg]5?o^k^hDono_k`col?3`2?o_
knl4onk^kPSokNg]=Oo/k>`1onSXj07of=SH0On2PX800003oh:2P_oJf][o
iNGU03gok^k^1?o]kNdLonc/k0CokNg]7?o^k^h4ong]kAkok>c/7Oo]kNd2
onk^kP;okNg]<oo^k^h02?mX]>GoJkOXoffij_m]^N[oKkWZog6kk?ma^N_o
L;SZ0_m`^^/2og6kk00@og:lkOma_NkoLKg^og6mk_mc_o3oL[k_og6mk_mb
_^ooLl7aogC2l_md`_?oLl7bogG3m?mfa?GoN<KgogO5mP;oM<Ce013oMLGh
ogK6nOmga?SoN<GiogW7n?mibO[oMlOhogG5m_mfa_OoNLWjogK7m_mgb?Oo
N/Shog_9nOmlb?WoO/Si0_mmaoH00on3cOcoP<gkoh3:n@02ogo9n008oh38
n?n0bOKoOlSeohC=n_n3c?WoQLcjohO>o?n6cOT2ohC;m`0iohK=nOn;coko
Q/[ioh;9mon2boSoPlgjoh;=mon2boKoQL[coho=m?nAan_oEX:Ooc]KL?la
AeCo>DQ;obhg<_lY;RSo8bTUobL]:Ol_=C?o<cTeoble<OlZ<2co;S@`ocLm
>Olf?3So=cdiocHl>?lj@3co@DM3ocm6?olf?3So<STboc8l<Olj@CWo?3m4
ocM3Col`C6;o?Fb8og_0gommbnooOLKaogo8mOn5bOSoQLcjoh;?nomoc_Wo
OLcgog_:mOmmboWoNL[gogO8mOmhbOKoNlciogc=n_mkc?_oN<[i02ookno_
1?o^k^hLong]k@Cok^k^7?o_knl4onk^kQ_okNg]0_o^k^h2ong]kACok^k^
5?o_knl<oo3`l0Cokno_1?o^k^h2ong]k@;ok^k^1?o]kNd4onc/k3Gojn_[
0OoXj>P1omSHf07oPX:200000on2PX;of][JonGUi@0monk^kPCokNg]7?o/
k>`4ong]kAcok^k^1?o]kNdNonc/k1gokNg]0_o^k^h2ong]kC?ok^k^00Oo
J;CUofVei_mY]NKoJKGVoffgj?m`^^_oL[[/00;oLKW[0_mb^^`2og:lk@;o
Lkg^0_mb_^l01?ma_NkoL;c]og6mk_mc`O42ogC2lP03og;0l?mb`?7oLl7b
00;oML?d0_mb`_<03Omc`oCoMLGfogC4mOmda?GoM/KgogS8nOmgaoSoM<Kf
ogG7momhb_[oN<[iogW;n_mjboX00_mmbo/2ogg9nP06ogc8nOmmb_SoO<[h
ogc9mommb_SoO/_i0on2c?/03?n5c__oQ<gjohC;nOn5c?[oQ<_ioh;9mon4
b?OoQLcjohG=oOn2b_[oOlWhogo<nP;oP<kl02koPL_hoh;9lon8ao3oU<c_
oh6^bomIO93oA5aXocE7BOlb?COo<3L_oc0g<?l[<R_o:c4]oc8h=?lh?S[o
=cdiocHl>?lg?CWo=S`hocTo>olj?c_o?44mod15@Oll@Cgo=CThoc8i<_lb
?37o>T4ioce0AOllAU;o<dmUodEdT?mk`=ooOL__ogg6lOmob?GoQLWjohK<
oOn2co_oP<ojogg<momlboKoOLkkog_>n_mjcOWoNLch0_mhb_T00omgbOSo
MLWgonk^kP0@onk^kQkokno_1?o^k^hLong]k@Cok^k^7?o_knl4onk^kQ_o
kNg]0_o^k^h2ong]kAkok^k^6_o_knl4onk^kPCokNg]1?o/k>`ion_[j`7o
inOW0OoGemL1oh:2PP0000?oPX:2om[Jf_oUiND0?Oo^k^h4ong]kAcok>c/
1?o]kNdLonk^kPCokNg]7_o/k>`Mong]k@;ok^k^0_o]kNdconk^kP;oJ;KV
00GoIkGUofNci?mY]NKoL;[[og:lk@02og:jk0;oLk_]0_mc_Nh3ogBnk`05
og6mk_m`_>goL;c]og6mk_mb`?000_mc`O401Omb`?3oLl7bog?1l_md`_?o
ML?d00;oLl?d00[oM<CeogG5m_mda?GoLl?dogG5m_mgaoSoM/ShogG7momf
b?SoN<[j0_mgbOP00omhbOSoNL[iog[8n003og[8n006ogg;nOmlb_SoO<[h
ogc:n?mnboWoOlcj0_n0b_T00on3c?WoPL[goh;9m`02oh?:n00Moh;9mon5
bOSoQ/cmohC<o_n0b__oOLWjogo=oOmncokoOlgkogo<n_n3b_KoQ/O_ohg5
j?nGa^;oOjBgof9mR?m9Fego@Tm8od9<@oli@3So=3/doc8i<_lc>S?o=C/g
oc@j=_lb>3Co<CLcoc8h=?lg?CT00_li?SX04Oll@3oo>3`koc@h=old>SKo
>3lgoca3??lo@TOo@DYIocQDJ_m?OY[oNl3QogW7jon1c?KoP/_hoh?9n_n3
bo_oP<gk00;oOlki00WoO/ojogW<n?mjcOWoN/kjogW=nOmgboWoM/[hogO;
nOmhc?X04Oo^k^hNono_k`Cok^k^7?o]kNd4onk^kQcokno_1?o^k^hKong]
k@;ok^k^0_o]kNdNonk^kQ[okno_1?o^k^h4ong]k@Cok>c/>Oo[jn/1onOW
i`7oemOG0On2PX800003oh:2P_oJf][oiNGU03gok^k^1?o]kNdLonc/k0Co
kNg]7?o^k^h4ong]kAkok>c/7Oo]kNd2onk^kP;okNg]<oo^k^h02OmY^N[o
J;SYofNgj?mW]NKoJ[SYofnkkOm`_>goLK_/og2jj`02og6kk0;oL;c]0oma
_Nh01?mb_ngoLKk/og6nk?ma_^`4og6ok`06ogK4m?me`o?oML?dogG3m?md
a?GoMLGf0_mda?D01Omda_KoLlGeog?5mOmeaoOoM/Sh00;oMLOg00?oM/Sh
ogK8momeaoH00_meaoH2ogK7mP;oMlSg0_mkc?/2og[;nP;oO<[j023oO<Wg
og_8m_mnb?OoO/Sgoh79nOn3bo_oQ<_ioh?:n?n5bOSoQ/cmohC<o_n1b_go
O/[kogk<o?mlcOcoOL_iogo<n_n4cOSoS<geohc4ionKb^KoU;W<ofn:TomZ
O7coHFaTof9ZGomBFE7oCEA<od=:@olg?SOo<CPaoc0g<0?o<SLc01_o=S/g
ocHj>Olf>SWo>CdlocLk>_ld>3Wo=S`hoc]2>_lmA3go@DA9odE>GOloFg7o
FXVUogk3i?mha^coPL_hoh;:n_n2b?_oPLWiogk;nOmkc?WoO<gjogg>nome
aoKoM/[hogS<n_micO/00_mhc?X2ogW=na7ok^k^7_o_knl4onk^kQcokNg]
1?o^k^hLono_k`Cok^k^6oo]kNd2onk^kP;okNg]7_o^k^hJono_k`Cok^k^
1?o]kNd4onc/k3Wojn_[0OoWinL1omOGe`7oPX:200000on2PX;of][JonGU
i@0monk^kPCokNg]7?o/k>`4ong]kAcok^k^1?o]kNdNonc/k1gokNg]0_o^
k^h2ong]kC?ok^k^0_mX_>/01_mX^^[oIkWYofVij_m]_NkoKkg]offkj`;o
K;SY00CoKKWZofbjj_m^^^_oK[c/0_m_^n`4og:ok@;oL;k^0_m__Nd01?me
`o?oM<;bog?1l_mc`O82og?3m008og;2lom``?7oM/Shog?5mOmba?CoMLOg
ogO9nOmeaoL2ogC6mP;oN<[i0omgbOP0Bomhb_WoNL[iogW;n_mfb?OoMLOf
ogO8momhbOSoO<[jogg;nomnboWoOL[hogg7m_mnb?OoPLWiohC<o?n5c?[o
Pl[hohC8mon3bO[oQ/kooh?=o_mobocoOL_kogc:n_mlb_SoOlchohK?n?n6
aNkoS<CWoiS6h?n>/LCoEg1gofemO?mZM6_oKgMZofYbIomIH5So@DQ1oblf
;ol^=Bko=3/doc@i=Ol_=33o=S/gocTn>_lg>c[o=SXiocXn?Olh?3_o=SXk
ocLm>olk@S[o?48nod13B_m8DF;oA61hof2A[on1aNSoN<K/ogg7m?mnb?Oo
P<Sjoh3:nommboWoN/_hogS9m_mfbOGoN<[iogS<n_mibo[oNLgkogW;n_mg
boWoM/SgogC8mP0Aonk^kQkokno_1?o^k^hLong]k@Cok^k^7?o_knl4onk^
kQ_okNg]0_o^k^h2ong]kAkok^k^6_o_knl4onk^kPCokNg]1?o/k>`ion_[
j`7oinOW0OoGemL1oh:2PP0000?oPX:2omWIfOoUiND0?Oo^k^h4ong]kAco
k>c/1?o]kNdLonk^kPCokNg]7_o/k>`Mong]k@;ok^k^0_o]kNdconk^kP;o
I;c/00ooH[SYoenei_mT^>OoJ[c/of^kk?mW]nSoJkWYofjlk?m`_^koKKk]
offkjomZ^n[oKkg]og;0l?m`_N/00oma_^`2og6ok@03og6okomb`?3oM<;b
00?oM<;b1?mb`_<2ogC6m@03og?5m?ma`o;oLL?b00;oM<Ke00CoLlGdogO9
nOmfb?SoM<Kf0_mcaOD01omdb?OoN<[jogS<nomcaoKoMLWhogW;nomkcOd0
0_mlcO`01_mlb_[oNlWioh3<oOmmbO[oO/Sgogo9n0;oP/[j01[oQ<[kohK<
oOmoaOKoO/Kfogk8momnboWoP<gkoh7>n_n2cOOoPl_cohK4jonAanWoV<CM
ofJ7U_m=I6[oFFQUofYbIomRJ5[oHFUNodaFCOlf@3So;3H^obhe;_l_=Roo
;cDaobhd<0;o=CXf01ko>3`kocm3@_lm@D3o<3@coc0d=OlnA4;o@DQ1ocY0
??m0@d[oBUIVodITO?mYV[SoO/;UogS7k_mjaoGoOLOhoh38n_mobO[oNL[i
ogS:nOmhboOoNLchogO9n?mgbOWoN<SiogO9nOmibO[oNL_kog[:nomjc?`A
onk^kQkokno_1?o^k^hLong]k@Cok^k^7?o_knl4onk^kQ_okNg]0_o^k^h2
ong]kAkok^k^6_o_knl4onk^kPCokNg]1?o/k>`ion_[j`7oinOW0OoHf=P1
oh:2PP0000?oPX:2omWIfOoUiND0?Oo^k^h4ong]kAcok>c/1?o]kNdLonk^
kPCokNg]7_o/k>`Mong]k@;ok^k^0_o]kNdconk^kP;oH;_Z00KoH;SXoeng
iomQ]nKoIk_ZofRjj_mV^>P2ofVjj@;oJ[_Z00CoJK[YofZkj_m[_>_oK;g/
0_m`_N/2og6nk0;oLKo]0_ma_nl01?mc`O7oM<;bogC2l_md`_84og;2l`?o
LlGd00GoL/Ccog?5m?meaoKoM<Keog73lP02ogG7m`04ogC6m_meaoOoM<Sg
ogG9n0;oM/[i00CoM<SgogG9n?mgbOWoMlWi0_mib_T2og[8n004ogc8nOmj
a_OoO<Keogk8m`;oPLWi01SoP/[johG;o?n1aoSoPLOhoh79nOn1boSoP/ci
oh?>n?n3c?GoQL[aohS6jonAa^KoQJo7odUYN?lmDUOoBUIBofE[HOmNHUCo
@DTnoc@n=OlZ=2co:38Zobhe;_l`=c02oc0f<P;o=3Te01Oo=CThocXn?Olk
?cko<cLfoc<g>?lnA4;o>dDmocY3?_m1ADko@dmOocQFL?mLSjkoNKoQog_:
lOmiaoGoNlOhogk8nOmlb?WoMlWhogK:n?mfb_KoN<[iogO9n@04ogS8n@03
ogW9n_mjb__oN/[k017ok^k^7_o_knl4onk^kQcokNg]1?o^k^hLono_k`Co
k^k^6oo]kNd2onk^kP;okNg]7_o^k^hJono_k`Cok^k^1?o]kNd4onc/k3Wo
jn_[0OoWinL1omSHf07oPX:200000on2PX;ofMWIonCTi00iong]k@cok>c/
5?o[jn/<onc/k1CokNg]3?o/k>`Don_[j`Kok>c/1Oo[jn/Jonc/k3GokNg]
00koG;SYoefij_mO^^WoH;SXof6gj?mS^N[oIKWXofFgiomY^N[oJ;SYofNh
iomX^NSoJK[YofZkjP;oJ[_X0_m`_N/2og6nk004og2nk?ma_ngoLKo]og6o
k@CoLl7a1?mb`o803?ma`o;oL/Ccog?5m?mcaOCoMLKeogK7m_mdaOCoLL;a
ogC4mOmeaOKoMLOgogK8n0;oMLWh0_mdb?L00omgbo[oM/[iogK8n002ogG7
m`08ogK8n?mhb?WoNLWjog_9nOmiaoOoN/Kgogc8nOn0b_/2ogo9nP0Foh79
nOn0a_OoP<Oeogo8mOmobOKoP<[goh3;mOn0bO;oPlO^ohc8kOnDanKoK9B]
oc=@H?lbAD_o?DQ4oe]NEOm>DTCo<STaobXe;OlV<BWo:3<[ob`e<0;o;CHa
00Ko;SLbocDk=ole>cOo=3XfocHl>?li?C`2ocHj>@0>oce3?oliA3co>dI0
od96ColnBe_o<E5Zoe^>[Omi`^?oNL_aogW7mOmkaoSoNlOiog[8nOmfb?L2
og?:m`03ogG9momgbOWoMlWk00;oMlOj00CoMlOhogS8nOmhb?WoNLWj3oo]
kNd2onk^kP;okNg]7?o^k^h4ong]kAcok>c/1?o]kNdLonk^kP;okNg]0_o^
k^hkong]k@;ok^k^0_o]kNdHonk^kPCokNg]0_o/k>`2ong]k@Cok>c/>Oo[
jn/1onOWi`7of=SH0On2PX800003oh:2P_oHf=Soi>CT03Wok>c/1_o[jn/6
onc/k1Cojn_[1_o/k>`6on_[jaCok>c/1_o[jn/6onc/k1Cojn_[1_o/k>`5
on_[jdook>c/00[oFkOXoejhj_mO^^WoHKWYof:hjOmT]nWoI;SWofFgiomZ
^^_oK;[[0_m[^NT01?m/^^[oKK_[offkjOm]^nT3og2mj`03og6nk?m`_^co
L;k/00;oLKo]0_mb`?02og?1l@09og72lOmb`o;oL/?bog;3l_m``_7oL/Cc
ogC6mOmcaOCoLlCc00;oM<Gd00OoLlCcogC4mOmda?GoMLGfogG7momebOSo
M<Sg00;oLlOf00?oN<ckogO;n_mgbOT00_mgbOT01_mhb_[oN/[kog_;o?mo
cOgoOL_kog_9n@;oOLWj01KoNlOhogg7n?mnb?WoOlOgogo8mOmnaoCoO/Se
ogo9m_mob_CoP<Wboh?7k_n;ancoTlGVoeEmU_l`CEgo<TE<ocY4@om9C4?o
>chcoc8l<ol^>C7o:cH`0_lZ=Bl07?l[=2oo;3D`oblh<olf?3So>ClkocPn
>_le>cOo>3diocLl>?lh?3_o?D<oocQ3>oljAT;o@4M?oci;G?lgEg3oHiRg
ogg7j_mcancoMlSeog[8n?mkbO[oN<SiogG9momab_KoL/Wfog?9n?mfbO/3
ogK8nPCoM/Sh4Oo/k>`Pong]kB3ok>c/?oo]kNdPonc/k1[okNg]3?o/k>`I
on_[jb3oj^[Z0OoVi^H1omWIf@7oPX:200000on3Ph?of=SHonCTi00ion_[
j`Kok>c/1_o[jn/donc/k0Kojn_[1_o/k>aCon_[j`Kok>c/1_o[jn/?onc/
k005oefgjOmN^>[oHKW[of>ik?mT]nT00_mT]^P00omU]NSoK;[[offij`02
offijP04ofbhjOm]^N[oK[_YofnljP;oKkcX0_m`_N/01?m__N_oL;k/og2n
k?m`_^`2og;0kP04og;0l?mc`O7oLL;aog72l@;oL/?b00CoK/7]og?6l_mf
aoKoLlCc0_mb`?004?mfa?CoN<KfogO5m_meaOKoM<Ceog?5mOmba_GoLlOf
og77n?mca_SoMLSjogO9nomhb_coNL_mogW;nomjc?`2og_;o003ogo?oomk
bocoN<Wh00;oN/Sh01KoNLOgog_7n?mlb?WoPLWioh38n?mobOSoO/_gogo<
n?n0cOOoPlcgohK;m?n8a^goSL;Tod1YQOl`Cf?o;d=<ocM3@oli?SSo<SD/
obhi<OlZ=c3o:3@`0_lX=Bh01?lY=2ko;3Laoblj=?l`>C@2ocM0>`0Coc<l
=ole>cOo=C`eocPn>_lmAcoo=D8ioc]7@om2BE7o?4aLocEGL?mSV[SoO<KY
ofo2j_mfb?OoN<SiogW9n_mhb_[oM<[iog3;n002og;:n003og?9n_meb?[o
MLSj00?oM<Oi0_mebOP[onc/k0Kojn_[1_o/k>`Don_[j`Kok>c/1_o[jn/c
onc/k0Kojn_[1_o/k>`Don_[j`Kok>c/1_o[jn/Donc/k0Kojn_[1_o/k>`G
on_[j`Coj^[Z7_oYjNT1onGUi@7ofMWI0On3Ph<00003oh>3PooHf=Soi>CT
03Wojn_[1_o/k>`6on_[jcCok>c/1_o[jn/6onc/k5?ojn_[1_o/k>`6on_[
j`ook>c/0_mO]nT02?mP]^WoIKS/ofJhj_mV]^WoIKGXofRejOm[]nWoK[OZ
0_m_]nT2ofjfj006ofngiom_^NSoKkcXofnlj?m__>[oL;g[0_m__N/2og2n
k0;oLKo]0_mb`?02og72l@;oL/?b00_oK/7]og?6l_mfaoKoL/?bog2nk_ma
_nooM/CdogW7momha_OoMlGfog?3m002og;4m007og;6mOmaaoSoL/Siog?5
momda_SoM/SjogS:o002ogW;n`06ogW9n_mhb?WoN/[kogO7n?mfaoKoMlSg
0_mjb?P05_mkbOWoO<[joh3:nomobOSoO<Siogc:n?mmboWoO/ghoh;<nOn6
boGoRlWbohc0iOm0JHOo<E1UobXnBOlf@D?o>3diocDj=?l[=S3o9SD`obLc
;olY=C42obXg<00Gob/f<?l]>3;o;3D`oc@m>?lf?c[o=3dhocHm=_le?3Go
>3lhocm9@OlgA3_o?Te8odQAF_loD63o<UI`oefF]?miaNOoLLK]ogK8momg
bOWoNLWjogO;n_mcboT00om`boP2og;:nP?oLLWi00?oLlWjog?9n?mcbOP0
:oo/k>`6on_[j`Kok>c/5?o[jn/6onc/k0Kojn_[<oo/k>`6on_[j`Kok>c/
5?o[jn/6onc/k0Kojn_[5?o/k>`6on_[j`Kok>c/5oo[jn/4on[ZjQkojNWY
0OoUiND1omWIf@7oPh>300000on3Ph?of=SHon?Sh`0oon[ZjT3ojn_[GooZ
j^XEon_[j`0:oenej?mN/NGoG[7Uof>djOmW]ncoJ;G[ofVejOm/]N[oKkKZ
ofjej@;oK[CW0_m_]NP00om_]NKoK[KVog6kj003ofnlj0;oKkg[0om`_^`0
1Oma_ngoLKo_og;0l?m``O3oLL;a00;oL/?b00KoKl3]og;3l?mdaO;oL/?`
og;0l?md`_82ogO3m00<ogO5m_mfa?GoLl?dog;4m?mba?KoLLCfog36moma
aoSoLlGgogC6n?meaoWoM/Sj0_mgbO/00omfb?SoMLOgogO9n@02ogG7m`0I
ogS:n_mjbo[oNL[iogW:nOmlb_[oOLWjogc8nOmjb?WoN<WhogW:nOmlb_So
OL[hoh78m?n;b_GoSlC/oeAoWolcDf[o:T1>oc0m@olk@D7o=C/gobhj=_lW
=S?o93<^obLf<@02obXi=00Hob/h<OlZ=c3o;cXdoc<n>?lf@3So>48jocU3
>ole?cOo>3lgoci8?oljBT3o@E1;odYCG?m3E6Co=UYdof2I]omja^SoL<S^
og?7mOmdb?OoM/SjogK9nombb_SoK/_g0_m_c?P01_m`bo[oKlWkofo:nOm_
b_WoL<_jog;:nP;oLl_k<Oo[jn/Pon[ZjQ[ojn_[1_o/k>`6on_[ja?ok>c/
3?o[jn/Jon[ZjSgojn_[1?oZj^XNonWYj@7oiNGU0OoIfMT1oh>3P`0000?o
Ph>3omOGeooShn<0?ooZj^Y0on_[jeooj^[Z5Oo[jn/04OmM/^SoFJoRoe^^
h_mP/nOoI[O/ofNgk?mY]^coJkO[og2ik_m^]NWoJk;Voffci_m`]^WoLKOZ
og2fjOm/]>CoL;[Y00?oKkcZ0om__N/3og2nk003og6okOmb`?3oL<7`00;o
LL;a00?oL/?bog31k_ma`^l00_mb`o001?me`o?oMlGeogK2lomc`O42ogK4
m@;oLl?d00CoL/Cfog74m_maa?KoLLCf0omeaoL00omfb?SoM/SjogK8nP02
ogG7m`0:ogS:n_mgbOWoN<[jog_=oOmmc_goNlckogS9n?mjb?SoO/clogg;
n`;oNL[i02coNLWjog[;n_mlb_[oOlWhohC7m?n>ao;oIiFgoc=GLOlZA5?o
:CY2ocQ2@olZ<bko;c`eobHe;_lP;b[o8c8]obPg=?l[>SOo;CTgob`h=?lf
@C_o=d8jocU3>ollASko?DLoocM0>olg?CWo?4E0oci;@_lmC4Wo@DiFod1E
I_ljHW_oIj2nogc6jOm^`NWoLlKbogC6mOmeaoOoMLWhog79mom^boOoK/[i
ofo;nP;oK/[k0_m^b_T01?m`bo[oLLckog7<nombcO`aon_[jb3oj^[Z6_o[
jn/6onc/k0Kojn_[4oo/k>`<on_[ja[oj^[Z?Oo[jn/4on[ZjQkojNWY0OoU
iND1om[JfP7oPh>300000on3Ph?oemOGon?Sh`0oon[ZjT3ojn_[GooZj^XE
on_[j`05oe^ej_mJ]>SoFk;Woebcj?mP]N/00_mS]^X02_mS]NOoI;CWofRf
iom[^N[oK;SZof^gjOmZ]^OoK[SYog2jjom`_>d2ofjlk005ofnmjom`_N_o
K[_Yoffji_m__>P00_mb_n/00oma`>_oL;k/ofo0k@02ofk1k@03og31k_ma
`_7oLl7a00;oM<;b0_mc`O43ogC2l`?oL/;c00SoL/;eog73mOma`oGoLL?c
ogG6mOmea_?oMLOfogK8m`;oM/[i0_mgb_`01OmjcOooNL_mogO9nOmgaoSo
N/Sh00;oNlWg00KoNl[eog[9m?mhbOCoN<WfogS9n?mhb_X2ogS:o00WogS8
nomla?KoQ/KbogB/dOlXEG;o;E1Sob]4BolP<S;o:cXcob/k;_lU=bWo9cH_
obHe<_lO;Bko938eoblj??l/>3So;cXdocU4??lf@SKo?d]1ocY3?_lg@3go
<3Pjod59BolnAd;o@4a:oca?EOlmFVSo=V=jofnXa_mn`>?oNL?ZogK3kOmg
a_7oNLOeogO:m_mcbOSoK/Wh00;oJ/Wi00KoKl_lofk:nOm^b_WoK/[iofo;
n_m`c?/2og3;nS7ojn_[8?oZj^XJon_[j`Kok>c/1_o[jn/Conc/k0cojn_[
6_oZj^Xmon_[j`Coj^[Z7_oYjNT1onGUi@7of][J0On3Ph<00003oh>3PooG
emOohn?S03ooj^[Z@?o[jn]Oon[ZjQGojn_[0_mH/nP01?mI/nOoF[CXoefd
jOmN]NX2oejdi`04ofBfj?mV^>[oJ;SYofRhj@;oJ[SY00KoKKWZofjjjom/
^^_oJkWZofbjj_m^_>`2og2mj`04og2mjOmb_n_oLKkZog6njP;oL;oZ00Ko
Kl3]ofo2k_m_`^koL<?_og;0l?mc`O42ogC2lP;oLl7a00?oM<;cogG3m?mb
`_<00omb`_<3og;2m@05og;2lomea_?oM/ObogG8m?mfbOD00_mebOP2ogG8
nP0fogO:o?mfbO_oMlOhogO8momkbOWoOL_iogo<n?mncOSoOLcgog[;m_mi
b_OoNL[iogW;nomibogoMl[nogO8oOmlb__oQ<_iogVgg_m1MYGo9TmSobM7
D_lT?3ko:C`fobPj;?lV>2So9cL]ob<b;olN;2oo8bhbob/f>?l_>C[o<chh
oce9?olkAc_o@4a2oca5@?lg@3oo;SHiocY2AOm0ATCo@D]:oc]?E_liFFSo
=69joffUa_mo_nGoO<?]ogW2kOmhaO7oN<ObogK7m?mbbOKoK/Wf0_m/bo/2
ofk:n@04ofk9n?m_b_WoL<_jog7<n`;oL<_j<Oo[jn/Pon[ZjQ[ojn_[1_o/
k>`6on_[ja?ok>c/3?o[jn/Jon[ZjSgojn_[1?oZj^XNonWYj@7oiNGU0OoJ
f]X1oh>3P`0000?oPh>3omOGeooShn<0?ooZj^Y0on_[jeooj^[Z5Oo[jn/0
1?mF/^GoEk?VoeZdj?mK]NT2oefdj@04oejdiomO]NSoI[SZofJhjP;oIkOX
00SoJ[SYof^ij_m]^N_oK[[/of^ij_mZ^>WoK;SYofnkk0;oL;g[00coL[cY
ogBnjom__>SoL;gYofnnjOm`_n[oKl3]og31k_m``nooLLC`og6okomb`?04
og?1l@03ogC2lome`oCoL/;c00?oL/;c0_mc`o@01?mc`oKoLl?dogG6mOmf
ao@2ogG8m0?oM<Sg00SoLlOfogK:nOmebOSoM/KgogO8momkbOWoOL_iogo<
nP;oOlki02SoNlcgogW:momhbOSoMlWiogO9nomfbO_oM/Sjog_9n_n0bOKo
OKkVofJM_?lUDVWo8dMEobM2BolV?3[o9CH/obPh:olW=2_o8RhZob4];OlR
;2go9c4`oc0i=_lh@Cco@de5od1:@OloBD3o>T<nocHo??l^>3Oo>412od96
Aom5CE3o?U1LocMFJ_leHWooJZ;7ogbmiomi`^goN<;_0_mfaO002omca_3o
L/Kbog39mOm_c?SoLLglofo:nOm^bOSoL<Shog79nOmbb_[oLl_k00;oL/[j
<Oo[jn/Pon[ZjQ[ojn_[1_o/k>`6on_[ja?ok>c/3?o[jn/Jon[ZjSgojn_[
1?oZj^XNonWYj@7oiNGU0OoJf]X1oh>3P`0000?oPh>3omOGeooShn<0?OoY
jNT4on[ZjSkojn_[?OoZj^X2onWYj@;oj^[Z7?oYjNT4on[ZjQ?ojn_[00Co
E;3SoeJbiOmK]NWoG;KZ0_mN]NX01?mP]^WoHKOZofJijomV^>X2ofJfi`07
ofVgj?m[^N[oKKW[ofjjk?m^_>goK;[[offijP02ofnkk003ofjkjOm`^^Wo
L[cY00;oKkcX00WoL;gYofnnjOm`_^coKl3]og31k_ma`^ooL;k^og6okomb
`?000omc`O400omd`_?oML?dog;2l`02og;2l`?oLl?d00SoM<CgogC4mOmd
aOCoM<GbogC7lomda_GoM<SfogC8m`;oLlOf03SoMl_jogO9nOmgaoSoMlSg
og[8n?mkbOOoO<Wgog_9momlcO[oN/_hogS9m_mfaoKoMLOfogG7momdaoWo
MLOgogK7m_mi`o3oO/7[ogbgfOliJ8Co94YOob=3D_lT?D;o7S4]obHf;?lU
<R_o8c0YobPc;olV;bco9BhYobdf<Olj@C[oA4i6od1:@_li@c_o=T0hoc<n
>?lc?S[o?TM4odA8BOm8CeGo@UARocQGK?liIXOoJ:;:ogNjiome_nkoML;`
og?4lOmdaO;oLlK`og;7l?mab??oL<_gog7<n@;oL<Sh0_maaoP01?mcbO[o
M<[kogG8n_mcbOXaon_[jb3oj^[Z6_o[jn/6onc/k0Kojn_[4oo/k>`4on_[
j`;oj^[Z0_o[jn/4on[ZjQSojNWY1?oZj^XNon_[jagoj^[Z1?oYjNTNonSX
j07oiNGU0OoIfMT1oh>3P`0000?oPh>3omOGeooShn<0?OoYjNT4on[ZjSko
jn_[?OoZj^X2onWYj@;oj^[Z7?oYjNT4on[ZjQ?ojn_[00[oE;3SoeNci_mK
]NWoG;KZoejfj?mM]NOoGkGXof2fjOmU^>[oI;OY0_mT]^P03omW]nSoJKWZ
ofbjjom/^^_oL;c^ofjjk?m]^N_oK[[[og2jjom^^>OoKkWXog6kj_mb_>Wo
L;gYog2mj`02ofnmj`05ofjok?m_`>ooKl3_og2nk_ma_nl00omb`?001?mc
`O7oM<;bogG3loma`O83og;2l`;oLl?d0_mda?D00omca??oLlCaog?5m002
ogC6m@05ogG7m_mdb?OoM<SgogW;nomhb_X01?mhbOP0=?mjb?KoNLOeog[;
n?mib_WoMlSgogK7m_meaoKoM/SgogG9n?mfb?SoMlSgogK3lOmma>koPl7X
oeV>[_l/F7?o7d=Kob<oCOlL<37o8c8]ob<`:OlV<bco;cXbob`f;OlW;RKo
;3<[ocDj=?m2BD;oA4]4ocU3>olh@S[o<SdeocE0>?m1Bd?oADI8od]?F?m5
EFGo>EM_od5]T?m[Y<ooMk_Zog>ol?md`_;oL/CcogC7lomdao7oLlSaog38
l?mabO7oLLSeog77m_maaoP2og?6n0;oMLSj00?oM/SjogC7nOo[jn/0<?o[
jn/Pon[ZjQ[ojn_[1_o/k>`6on_[ja?ok>c/1?o[jn/2on[ZjP;ojn_[1?oZ
j^XHonWYj@Coj^[Z7_o[jn/Mon[ZjPCojNWY7_oXj>P1onGUi@7ofMWI0On3
Ph<00003oh>3PooGemOohn?S03gojNWY1?oZj^Xnon_[jcgoj^[Z0_oYjNT2
on[ZjQcojNWY1?oZj^XCon_[j`04oeJbiOmG/nKoF[CXoeZdj0;oFk?U0_mK
/N@2of>fj0;oI;KX00GoI[KWofNgj?mZ^>WoJkWZofjjk002ofbhjP05offi
jom_^N[oKkWZog2jjOmb_>/00_mc_NX2og2mj`;oKkg[00CoL;k^ofjok_m`
_^koLKo_1?mb`?001?mc`O7oM<;bog71l_ma`O84og;2l`;oLl?d00CoL/?b
og?4lOmcaOCoM<Ke0_meaoH2ogC8m`;oMlWi00SoMlSgogS9n?mib_WoN/_j
ogc:n?mkbOWoN/_jogW9nP;oMlSg02goM/SgogO9n?mfb_SoM/[hogO9n?md
`_3oOLKcogg0j_mc[M?o@7:Eoam:J_lO@USo7c<lob4a<OlR<Bko:SL`oc4m
<ola>Bco;C<Wobdc:Ol_=2go?D8lodE:A_loAD7o@4Y2ocA0=_ld@SGo?dU0
od=5A?m:CECoAEETocUGKom7MIOoKj[DogVol?me`oCoLL?cog;4m?mda_Go
M<Oaog;7l?mbankoL/O`og;6l_mdb?L00omca_P01?meaoWoM/SjogG7nOme
aoTaon_[jb3oj^[Z?Oo[jn/4on[ZjQcojNWY1?oZj^XNon_[jagoj^[Z1?oY
jNTNonSXj07oiNGU0OoIfMT1oh>3P`0000?oPh>3omKFe_oShn<0?OoXj>P4
onWYjCcoj^[Z0_oYjNT2on[ZjSgojNWY7_oXj>P4onWYjA?oj^[Z0_mG/nH0
1?mF/^?oEk?ToeVciOmJ]>H2oe^ci@04oejdiOmP]^OoHkKXofBgj@;oI;KX
00KoIkOXofVij_m/^NgoJ[O[of^gjOm/^>X2ofnijP04og6kj_mc_NcoLkg/
og:lj`?oL;g[00GoKkg[ofnmkOm`_^koL;k/og6ok@02og;0kP;oLKo_00Co
L/3`og?1lOma`_7oLL;a1?ma`O82og;2l`04og?4lomdaOCoLlGdogC6m@Go
MLOf00CoM<KeogK7m_mgb?OoN<Wh0_mib_T0;?mhbOSoNLWlogS8nomgaoSo
MlSgogS9n?mgb_KoMLWeogG9momfb_SoL/?bog_8m_mg_^[oO;_VoenF_ol_
H8So8dYYob<mC_lR<c[o8c<cobXi=?l^>Rko<3PYoc8h:_ld=bco;c8[ocTk
>?m2ATGo@DM5odQAC?lhA3[o=dDfod1<?_m6Ad;oC51CodEEH_lfEF[oBgVJ
ofn]e_mi`O7oLl?dog74m_maaOCoLlGd0_mbaNl01OmbaNgoLlK^og?8lOme
bOSoM<Oi00;oLlKh0_mdaoT2og?6n2ooj^[Z0_oYjNT2on[ZjQcojNWY0_oZ
j^X2onWYjC_oj^[Z1?oYjNTLonSXj0CojNWY7?oZj^X2onWYj@;oj^[Z5?oY
jNTConSXj1KoinOW0OoUiND1omSHf07oPh>300000on2PX;oeMGEon;RhP1M
onWYj@;oj^[Z0_oYjNUKon[ZjP;ojNWY0_oZj^XconWYj@06oeJbiOmE/NCo
EK7RoeNci?mK]NOoGKOY0_mO]nT01?mM/nCoGkGVofBgjOmT]nT2of>ei`06
ofFgiomX^>WoKK[^of^hk?m[]nWoK;SZ0_m^^>T01_m_^NSoL[c[og:ljomb
_>_oL;g[ofnljP;oL;g[0_m`_^h2og6ok@;oL/3^0_ma_nl2og;0l0;oLL;a
1_ma`O800omdaOCoMLKeogC6m@02ogG7mP?oM<Ke0_mcaO@2ogC5m0;oM/Of
00KoMLKeogC4mOmhb?_oMlOlogK6nOmgb?L2ogO8m@0bogC7lomba_;oMl_i
og;4lomkc?_oMl7`ogk0l?mf/n3o@GNUobUFOOlWAEgo8CM4ob<f??lY>CSo
:3D[ob`g:Olf?2ko>C`aoc4b;?le=cCo?d50ocm5@om;E4oo>dPnocY;>om5
DT7oBDa3odiBDOm4Eeko<eAUodUjV?m^[]CoM/3]og32l_mba_GoKlGdog75
lomaa?3oL<?]og;5kOmdao7oM/WeogG9n?mbb?WoLlKhog77n?mdaoWoL/Si
og?6n?m`a_L?on[ZjP;ojNWY0_oZj^YLonWYj@;oj^[Z0_oYjNTKon[ZjP;o
jNWY0_oZj^YDonWYjA?oj>SX5_oWinL1onCTi07ofMWI0On2PX800003oh:2
P_oDe=Coh^;R05ooj>SXGooYjNTeonSXj00GoeFah_mI]NKoF[KWoeNci?mH
/^CoFkGWoebdi_mH/>;oH;KWoenei_mN]>GoGkGVofBgjOmV^N_oIKSZofJh
j_mV]^WoJ[O[ofbjjom[^N[oJ[KWof^gj?m_^NP00_mb_>/03Oma^n[oK[_Y
og2mjom`_>goKk_/ofjlk?m`_^koK[cZofnmjom`_^coLKo]og;0k_mc`Nl0
0_mc`O401Om_`>ooLL;aog;3l_ma`_7oL/;c00;oLl?d00CoLL7bog?5m?mc
aOCoM<Gd0_mca?<01OmdaOCoMLKeogO8momca??oMLKe00;oMLOf0_mda_D0
>_meaoKoMlWiogG6nomea__oMlOjogO8momgb?GoMlScogG8l_mcao?oMLWg
og;6m?mgbOWoO<[kogFmkomi^ngoJ:KGocEXTolXCF[o8d1Bob0kA_lV>cko
9CH`obHd9ol^>B_o=cdcocXl=ole=cCo=cThod=9Aom=EU7oAeA:ocm@@?m5
Dd;o@dTmod5;@om0EESo>UiZof:F[_mh^]coLKoVog75lOm^a??oKlGdog75
lomca_;oM<GbogC5l?mca?7oL/Gaog77m_mabOWoLlWjog79nOmaaoSoKlOg
og77n?mabOTAonWYjF3oj>SX7ooYjNUFonSXj1?oinOW5_oVi^H1onCTi07o
f=SH0On2PX800003oh:2P_oDe=Coh^;R05ooj>SXGooYjNTeonSXj009oe>_
h?mG/nCoEk?ToeB`hOmF/>;oF[CVoefeiomI/N?oGkGV00;oH;KW00OoHKOX
of>fj?mT]nWoIKSZofJijomX^>_oJ[O[00;oJ[SY00SoJkOYofbhjOm_^N[o
KkWXog2jjOm^^>OoKK[Xog2mj`;oLKg^00?oLKo_og?1lOm__N/00_m`_^`0
0oma_ngoL/3^og;0kP02og;0l005ofo0koma`_7oLL;aog31l?ma`O800_mb
`_<00oma`O;oL<;aog;4l`02ogG6m@?oM<Gd0_mea_D00omfaoKoMLOfogG7
mP02ogG7mP0ZogK8momgbOWoMLKkogG6nomgao[oMlSgogO8mOmgb??oM/Wc
ogG9mOmdb?KoLLOfogG8n_mhb?_oM/;dogk6n?mk__;oFYG1ocQTQolXC6Ko
73e>oallA?lT>SSo:CXboblj<_la>33o;S0[ocHh=Om1ADCoC59@odYCD?lk
B3oo<d<foca=?Om9DdSoAU=<od1JFoljHVcoI9^`ogVngOmc`NOoKlC]0_m_
a_<00omba_;oM<OcogG6l`02ogG6l`05ogC6mOmaaoKoL<Shog79nOm`b?P0
0om_aoL00om`b?SojNWYonWYj@0?onWYjMGoj>SX4ooWinLFonKViP7oi>CT
0OoHf=P1oh:2PP0000?oPX:2omCDe?oRh^80=_oWinL9onSXj0[oinOW5_oX
j>QEonWYjACoj>SX3?oWinL:onSXj0[oinOW2ooXj>P02_mB[]ooEK7RoeB`
hOmB[]ooDjoPoeNci?mJ]>KoFK?Uoe^chomM]ND2of2fi`;oGkGV00?oHKOX
ofFhj_mV^>X00_mV]^T02OmX^>WoK;[[offkjom]^N[oK;SYoffjj?m/^NOo
KKWZog2lk@02og2nkP04og2nkomb`?3oL;k/og2nk0;oLKo]0_mb`>h2og6o
k@03ofo0kom``O3oL<7`00;oKl3_00goLL;aog;3l_ma`_7oK/3`og73lomf
aoKoMlSgogG6mOmca??oML?aogK4l_mgb?GoM/Od00;oMLOf0_mfb?L0<ome
bOSoM<OiogC7nomea__oM/KiogK7m_miaoGoN<WfogO:m_mgboOoM<SfogG;
n_mbb?WoM<Oiog?3m?miaOKoOlOiogFehomBR:ko=fB3oai6GolI?Dgo7ca2
obLl?OlZ>CKo:34/obT^:_lg?3SoBDe<oe5GEOm7DTko<d0iob/j<olfASco
=T<locmBC_m6HfOo@fmlofBN]_mc^][oKkoTofo4kOm_a_7oL<Obog?7lome
b?;oM/OdogO8mOmfb?OoMLWhog38n005ofg8m`03ofo7mom^a_KojNWY013o
jNWYMOoXj>P:onOWi`[oj>SX3?oWinL:onSXj0[oinOW3?oXj>P:onOWi`[o
j>SX4ooWinL4onKViQkoiNGU0OoTi>@1omOGe`7oPX:200000on2PX;oe=CD
on;RhP0fonOWi`Woj>SX2_oWinLFonSXj5GojNWY5?oXj>P<onOWi`[oj>SX
2_oWinL;onSXj00;oe6]g_mC[n3oDjoPoe:^gomC[n3oEk?ToeVciOmH/^Co
FK7QoeZbh_mM/n@00_mN]>D02OmO]NKoH;KWof:hjOmQ]>KoHkGWofFej?mX
^>_oK;[[offkk002ofjjj`03ofjkjOm]^^SoK[[[00;oKkg]00?oKK_[offk
k?m^_>`00_m`_^`2og6ok@CoL/3^00?oL<7`og72lOm``O000_m_`>l01Omb
`o;oLlCcog;3l_m]_nooLL?c00;oM/Of00coM<Gdog;3l_me`o7oM/CbogO8
mOmea_?oLlGdogC6mOmfb?OoMLWgogC8mombaOL2ogC7n`0VogG5n?mea_Go
N<KfogW7mOmhbOKoMlWhog;6mOmgcOcoL/SiogC7nOmda_KoL<7`ogK2lomh
_n_oKJ_Dodn5ZOl_H7ko8TaTob11D_lU?DOo:C/oobXf=_lk@CooADY6odiC
ComCFEOoBeIBocQ7A?la@Cko>DU8ocmADOm1FEgo>eeWocUXN_mQW[[oLkcM
ogG4jombaNl2og;6lP0>ogC7lOmeb?;oM/OdogK7m?meaoKoM<Sgog38n?m]
b?OoK/Kfofc7m_m_aoOoL<Shofo7mom]aODAonWYjGGoj>SX2_oWinL:onSX
j0coinOW2_oXj>P:onOWi`coj>SX2_oWinL:onSXj1?oinOW1?oVi^HNonGU
i@7oi>CT0OoGemL1oh:2PP0000?oPX:2omCDe?oRh^80=_oWinL9onSXj0[o
inOW5_oXj>QEonWYjACoj>SX3?oWinL:onSXj0[oinOW2ooXj>P02?m?[]co
DK3NoeB`gomD/=ooEK7PoeJbhOmG/^7oE[7P0_mG/N<02_mJ/^CoG;CVoeng
jOmP^>[oHKOZof2fjOmP/nOoH[GYofJhj_mW^N/2ofRhj@03of^ijOm]^n_o
K[c/00;oK;[Z0_m]^n/01omY^^WoJKWZofZkj_m^_>[oKkkYog2nk?ma_nd0
0_mb`>h2og?1k`03og31k_mb`o3oLL;a00;oL<7`00[oL/?bog?4lomca??o
Kl7aog73lomda?GoM<GdogC2l_md`_3oML?a0_mgaO<01omdaO;oL/Gaog?5
m?mdb?KoM<Sgog;6mOm^a?D00_mdao/0<_meaOSoMLKeogO5mOmgaO?oM/Of
ogG7m_maaOCoN<ckog77n?mdb__oN<ckog;4lomea_7oN/Oaogc3kOmWY/oo
C8J[ocUZR_l]DVco;4UKocI9EolmBU3oDEUKoeQNF_mKHEgoFV=Noe=MG?m3
DE7o?4]>ocmBF?m6FVGoB6=dod=YP?m5MYCoIjK9og6ihOmd`nkoL/Gaog?6
l_mdao?oM<OaogG7komea_7oMLKcog?5m?mba_GoL/Siofo7mom_aOKoKlOg
0_maaoP00om`a_OoKlGfonWYj@0@onWYjGGoj>SX2_oWinL:onSXj0coinOW
2_oXj>P:onOWi`coj>SX2_oWinL:onSXj1?oinOW1?oVi^HNonGUi@7oi>CT
0OoGemL1oh:2PP0000?oPX:2omCDe?oRh^80=_oWinL9onSXj0[oinOW5_oX
j>QEonWYjACoj>SX3?oWinL:onSXj0[oinOW2ooXj>P00om@[mgoDK3NoeFa
h003oeJbh@0CoeJah?mE/=ooFK?UoeRbi?mJ/^CoGKGWof2hj_mQ^N_oHKOZ
oenej?mR]NWoIKS/ofRjk?mW^N_oI[KWofFei_mX]^KoJkWYofbjjP02ofZh
j00:ofbjj_mZ^n[oJ[_Zof^kk?m]_^goK[cZofnnjOm`_^coLKo]og;0kP?o
Ll7_00GoL<7^og;3l?mb`o;oL<7`og72l@02og?4l`0:og;3l_ma`o?oLL?c
og;2loma`_7oLl7aogC2l?mfa?;oMlGcogG3l@;oLlCa02ooLlKbog?7m_mc
aoKoL<Keofk4mOmdao_oM<OiogG7nOmeaOKoMlGeogO5lomgaOGoMLKeogG7
momgbo[oKlGfogC:nOmicO_oLlOcogK9lOmjc?CoO<Weog6jiOmVYM3oEHZb
od9]SoloGW[oBF1boeARKOmMIfWoIfeYofU`JOmUKVWoFVASodQFEom1D5Oo
A5MUodAJLOm3HWko?FJ6odQlXom][=OoL;WVog;0l?ma`o;oLlKbogC7l@02
ogG7k`06ogC5l?mca_3oLLGcog75m?mca_SoL<Kg1OmbaOL00omaa?KojNWY
onWYj@0?onWYjGGoj>SX2_oWinL:onSXj0coinOW2_oXj>P:onOWi`coj>SX
2_oWinL:onSXj1?oinOW1?oVi^HNonGUi@7oi>CT0OoGemL1oh:2PP0000?o
PX:2omCDe?oRh^80=_oWinL9onSXj0[oinOW5_oXj>QEonWYjACoj>SX3?oW
inL:onSXj0[oinOW2ooXj>P2oe6`gP04oe>_g_mD/=ooEK7PoeFah0;oE[7P
00CoF;;ToeVciOmL]>KoGKGW0_mN]^P01_mM]NOoG;CVof6gj_mR^>_oIKSZ
ofBgj@;oI;KV00?oIkSWofRij?mZ^nX00_mX^NP02OmY^^WoJ[[[of^kk?m/
_^koL<7`ofnmjom__^WoL;oZog70j`04og;0kP03ofo0kOma`^ooLL;a00;o
LL;a0_mca?<01oma`_7oL/Cdog73mOm``?7oL<7`og?1lOme`o400_mfaO00
1_mc`^goLlC_ogG6lomdao?oLlOfog;6m@;oL<Kg00CoL/SkogC7nOmfb?[o
MlOh0omiaoL0:omgb?OoMlWiogO:o?m`a_GoML_jogG<mombao3oM/[_ogC7
komeb?CoLl7_ogFij?m/Ym?oGHZcoeIhVomKLh_oHG>1ofIaLom]MW7oKWQ_
ofafK_mSKFcoDf5TodYHHom:G73oDV^:ociPQ_lYE7oo?g>Rog:ai?mi`?Co
NLKjog;4m?mdaOCoM<G`ogK5k_meangoMLO_og?6l?mba_CoLLGdog74m_mb
aOL00_mcaOL01?mba?KoLL?eog;4m_mba?HAonWYjGGoj>SX2_oWinL:onSX
j0coinOW2_oXj>P:onOWi`coj>SX2_oWinL:onSXj1?oinOW1?oVi^HNonGU
i@7oi>CT0OoGemL1oh:2PP0000?oPX:2omCDe?oRh^80=_oWinL9onSXj0[o
inOW5_oXj>QEonWYjACoj>SX3?oWinL:onSXj0[oinOW2ooXj>P02_mA/=ko
D:oMoe:^gOmB[]goDjoNoeB`gomF/N3oF;?RoeJ`h_mH/^@2oebdiP0:oeZb
i?mH/>;oF;3RoeVahomP]^WoGkGXof6di_mR]NOoIKOWofNij@;oJK[Y00Co
KKk]ofZkj_mY^^WoJ[_Z0_m[^n`01?m]_nooL<;aog2nk?m`_nX2og70j`;o
L/3^0_ma_nd01Om^_ncoL<7^og72lOm``O3oLL;a00;oL/?b01GoL<7`og;4
m_m``_CoKko`og31l?me`o?oM/CbogG4komd`nkoLl;]og?4komfaoCoMLSd
og?7m_mba_GoLLOhog;8nOmbb?_oM<OiogK8n_mhb?T00_mlb?T0<_mkbOWo
N<WhogG7nOmdaoWoLLOfogS?o?mfcOSoL/[`ogS<lOmba^_oM<SfogK7m_mm
aOOoO;[Yog:QcOmZS[;oJ8:MofQjR?m_OH3oLWegofmiL?m^NG7oKWQgof9_
MOmHIW?oDfEmocE?L_m2I97oCWRXofRMcon3`_SoK[O/og2mlomfb?[oLlCc
ogC5l?mfaNkoMLO]ogG7komcb?7oLlOcog78mOma`oGoL/Cfog?5momba?Ko
L/;eog71m?mb`_GoLl?f4OoYjNUeonSXj0[oinOW2_oXj>P<onOWi`[oj>SX
2_oWinL<onSXj0[oinOW2_oXj>PConOWi`Coi^KV7_oUiND1onCTi07oemOG
0On2PX800003oh:2P_oDe=Coh^;R03KoinOW2OoXj>P:onOWiaKoj>SXEOoY
jNTDonSXj0coinOW2_oXj>P:onOWid_oj>SX2_oWinL:onSXj0coinOW5?oX
j>PEonWYjGGoj>SX2_oWinL:onSXj0coinOW2_oXj>P:onOWi`coj>SX2_oW
inL:onSXj1?oinOW1?oVi^HNonGUi@7oi>CT0OoGemL1oh:2PP0000?oPX:2
omCDe?oRh^80=_oWinL9onSXj0[oinOW5_oXj>QEonWYjACoj>SX3?oWinL:
onSXj0[oinOWBooXj>P:onOWi`[oj>SX3?oWinLDonSXj1GojNWYMOoXj>P:
onOWi`[oj>SX3?oWinL:onSXj0[oinOW3?oXj>P:onOWi`[oj>SX4ooWinL4
onKViQkoiNGU0OoTi>@1omOGe`7oPX:200002_n2PX;oe=CDomcLg?oRh^;o
i^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooV
i^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oV
i^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oR
h^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOW
iooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCT
i?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGU
h_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGU
onOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGU
onCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008
onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?o
iNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^Ko
iNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCT
i008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV
00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooV
i^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2
onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;o
i^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?S
hooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooU
iND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGU
i@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KV
on?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H0
0ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2
onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;o
i^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooV
i^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oV
i^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oR
h^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOW
iooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCT
i?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGU
h_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGU
onOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGU
onCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008
onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?o
iNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^Ko
iNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCT
i008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV
00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooV
i^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2
onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;o
i^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?S
hooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooU
iND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGU
i@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KV
on?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H0
0ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2
onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;o
i^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooV
i^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oV
i^H2onGUi@;oi^KV00GoiNGUonOWiooVi^Kog]kNom;BdP01oh:2PP0000Wo
PX:2om3@d?oKfm_ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oS
hn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCT
i?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Q
h@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>00
0_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oN
g^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7Q
hOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?S
on;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00Wo
hN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oS
hn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCT
i?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Q
h@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>00
0_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oN
g^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7Q
hOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?S
on;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00Wo
hN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oS
hn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCT
i?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Q
h@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>00
0_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oN
g^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7Q
hOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?S
on;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00Wo
hN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oS
hn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCT
i?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Q
h@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>00
0_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oN
g^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7Q
hOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?S
on;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00Wo
hN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oS
hn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCT
i?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Q
h@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>00
0_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oN
g^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7Q
hOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?S
on;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00Wo
hN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oS
hn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCT
i?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Q
h@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>00
0_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oN
g^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7Q
hOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?S
on;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00Wo
hN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oS
hn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCT
i?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Q
h@7og=cL0Oo>c/h1oh:2PP0000SoPX:2ol_;booGemOof][JomcLg?oMgMgo
g=cLomgMg@;ofm_K01;ogmoOom_KfooJf][ogMgMomoOgooMgMgog=cLomgM
gOoJf][og=cLomgMgOoLg=cogMgJom[Jf_oLg=cogMgMomcLg?oMgMd2om_K
f`0BomoOgooKfm_of][JomgMgOoOgmoogMgMomcLg?oMgMgof][JomcLg?oM
gMgog=cLomgMf_oJf][og=cLomgMgOoLg=cogMgM0_oKfm/04_oOgmoofm_K
om[Jf_oMgMgogmoOomgMgOoLg=cogMgMom[Jf_oLg=cogMgMomcLg?oMgM[o
f][JomcLg?oMgMgog=cLomgMg@;ofm_K01;ogmoOom_KfooJf][ogMgMomoO
gooMgMgog=cLomgMgOoJf][og=cLomgMgOoLg=cogMgJom[Jf_oLg=cogMgM
omcLg?oMgMd2om_Kf`0BomoOgooKfm_of][JomgMgOoOgmoogMgMomcLg?oM
gMgof][JomcLg?oMgMgog=cLomgMf_oJf][og=cLomgMgOoLg=cogMgM0_oK
fm/04_oOgmoofm_Kom[Jf_oMgMgogmoOomgMgOoLg=cogMgMom[Jf_oLg=co
gMgMomcLg?oMgM[of][JomcLg?oMgMgog=cLomgMg@;ofm_K01;ogmoOom_K
fooJf][ogMgMomoOgooMgMgog=cLomgMgOoJf][og=cLomgMgOoLg=cogMgJ
om[Jf_oLg=cogMgMomcLg?oMgMd2om_Kf`0BomoOgooKfm_of][JomgMgOoO
gmoogMgMomcLg?oMgMgof][JomcLg?oMgMgog=cLomgMf_oJf][og=cLomgM
gOoLg=cogMgM0_oKfm/04_oOgmoofm_Kom[Jf_oMgMgogmoOomgMgOoLg=co
gMgMom[Jf_oLg=cogMgMomcLg?oMgM[of][JomcLg?oMgMgog=cLomgMg@;o
fm_K01;ogmoOom_KfooJf][ogMgMomoOgooMgMgog=cLomgMgOoJf][og=cL
omgMgOoLg=cogMgJom[Jf_oLg=cogMgMomcLg?oMgMd2om_Kf`0BomoOgooK
fm_of][JomgMgOoOgmoogMgMomcLg?oMgMgof][JomcLg?oMgMgog=cLomgM
f_oJf][og=cLomgMgOoLg=cogMgM0_oKfm/04_oOgmoofm_Kom[Jf_oMgMgo
gmoOomgMgOoLg=cogMgMom[Jf_oLg=cogMgMomcLg?oMgM[of][JomcLg?oM
gMgog=cLomgMg@;ofm_K01;ogmoOom_KfooJf][ogMgMomoOgooMgMgog=cL
omgMgOoJf][og=cLomgMgOoLg=cogMgJom[Jf_oLg=cogMgMomcLg?oMgMd2
om_Kf`0BomoOgooKfm_of][JomgMgOoOgmoogMgMomcLg?oMgMgof][JomcL
g?oMgMgog=cLomgMf_oJf][og=cLomgMgOoLg=cogMgM0_oKfm/04_oOgmoo
fm_Kom[Jf_oMgMgogmoOomgMgOoLg=cogMgMom[Jf_oLg=cogMgMomcLg?oM
gM[of][JomcLg?oMgMgog=cLomgMg@;ofm_K01;ogmoOom_KfooJf][ogMgM
omoOgooMgMgog=cLomgMgOoJf][og=cLomgMgOoLg=cogMgJom[Jf_oLg=co
gMgMomcLg?oMgMd2om_Kf`0BomoOgooKfm_of][JomgMgOoOgmoogMgMomcL
g?oMgMgof][JomcLg?oMgMgog=cLomgMf_oJf][og=cLomgMgOoLg=cogMgM
0_oKfm/04_oOgmoofm_Kom[Jf_oMgMgogmoOomgMgOoLg=cogMgMom[Jf_oL
g=cogMgMomcLg?oMgM[of][JomcLg?oMgMgog=cLomgMg@;ofm_K01;ogmoO
om_KfooJf][ogMgMomoOgooMgMgog=cLomgMgOoJf][og=cLomgMgOoLg=co
gMgJom[Jf_oLg=cogMgMomcLg?oMgMd2om_Kf`0BomoOgooKfm_of][JomgM
gOoOgmoogMgMomcLg?oMgMgof][JomcLg?oMgMgog=cLomgMf_oJf][og=cL
omgMgOoLg=cogMgM0_oKfm/04_oOgmoofm_Kom[Jf_oMgMgogmoOomgMgOoL
g=cogMgMom[Jf_oLg=cogMgMomcLg?oMgM[of][JomcLg?oMgMgog=cLomgM
g@;ofm_K01;ogmoOom_KfooJf][ogMgMomoOgooMgMgog=cLomgMgOoJf][o
g=cLomgMgOoLg=cogMgJom[Jf_oLg=cogMgMomcLg?oMgMd2om_Kf`0BomoO
gooKfm_of][JomgMgOoOgmoogMgMomcLg?oMgMgof][JomcLg?oMgMgog=cL
omgMf_oJf][og=cLomgMgOoLg=cogMgM0_oKfm/04_oOgmoofm_Kom[Jf_oM
gMgogmoOomgMgOoLg=cogMgMom[Jf_oLg=cogMgMomcLg?oMgM[of][JomcL
g?oMgMgog=cLomgMg@;ofm_K01;ogmoOom_KfooJf][ogMgMomoOgooMgMgo
g=cLomgMgOoJf][og=cLomgMgOoLg=cogMgJom[Jf_oLg=cogMgMomcLg?oM
gMd2om_Kf`0BomoOgooKfm_of][JomgMgOoOgmoogMgMomcLg?oMgMgof][J
omcLg?oMgMgog=cLomgMf_oJf][og=cLomgMgOoLg=cogMgM0_oKfm/04_oO
gmoofm_Kom[Jf_oMgMgogmoOomgMgOoLg=cogMgMom[Jf_oLg=cogMgMomcL
g?oMgM[of][JomcLg?oMgMgog=cLomgMg@;ofm_K01;ogmoOom_KfooJf][o
gMgMomoOgooMgMgog=cLomgMgOoJf][og=cLomgMgOoLg=cogMgJom[Jf_oL
g=cogMgMomcLg?oMgMd2om_Kf`0BomoOgooKfm_of][JomgMgOoOgmoogMgM
omcLg?oMgMgof][JomcLg?oMgMgog=cLomgMf_oJf][og=cLomgMgOoLg=co
gMgM0_oKfm/04_oOgmoofm_Kom[Jf_oMgMgogmoOomgMgOoLg=cogMgMom[J
f_oLg=cogMgMomcLg?oMgM[of][JomcLg?oMgMgog=cLomgMg@;ofm_K01;o
gmoOom_KfooJf][ogMgMomoOgooMgMgog=cLomgMgOoJf][og=cLomgMgOoL
g=cogMgJom[Jf_oLg=cogMgMomcLg?oMgMd2om_Kf`09omoOgooKfm_of][J
omgMgOoOgmoogMgMomcLg?oFe]Koc/k>007oPX:200000on2PX;og]kNong]
k@02onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knoo
l?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_
koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2
onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`
oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`
l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^
kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`
l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3o
kno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06
ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002
ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_
0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_
koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_
k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`
l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`
l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?o
l?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?00
0oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3o
kno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`
0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_
knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_
ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_
knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knoo
l?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_
koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2
onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`
oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`
l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^
kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`
l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3o
kno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06
ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002
ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_
0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_
koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_
k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`
l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`
l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?o
l?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?00
0oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3o
kno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`
0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_
knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_
ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_
knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knoo
l?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_
koo`l?3okno_0_o`l?001_o_knool?3`oo3`l?o_knook>c/on7Qh@7oPX:2
00000on2PX;ojn_[ooclo002oogmo@05ooclo?omoOgoo?cloogmoOolo?`0
0_omoOd01?olo?cooOgmooclo?omoOd3ooclo0KooOgm00Goo?cloogmoOol
o?cooOgmooclo002oogmo@04ooclo?omoOgoo?cloogmo@?oo?cl1_omoOd0
1Oolo?cooOgmooclo?omoOgoo?cl00;ooOgm00Coo?cloogmoOolo?cooOgm
0oolo?`6oogmo@05ooclo?omoOgoo?cloogmoOolo?`00_omoOd01?olo?co
oOgmooclo?omoOd3ooclo0KooOgm00Goo?cloogmoOolo?cooOgmooclo002
oogmo@04ooclo?omoOgoo?cloogmo@?oo?cl1_omoOd01Oolo?cooOgmoocl
o?omoOgoo?cl00;ooOgm00Coo?cloogmoOolo?cooOgm0oolo?`6oogmo@05
ooclo?omoOgoo?cloogmoOolo?`00_omoOd01?olo?cooOgmooclo?omoOd3
ooclo0KooOgm00Goo?cloogmoOolo?cooOgmooclo002oogmo@04ooclo?om
oOgoo?cloogmo@?oo?cl1_omoOd01Oolo?cooOgmooclo?omoOgoo?cl00;o
oOgm00Coo?cloogmoOolo?cooOgm0oolo?`6oogmo@05ooclo?omoOgoo?cl
oogmoOolo?`00_omoOd01?olo?cooOgmooclo?omoOd3ooclo0KooOgm00Go
o?cloogmoOolo?cooOgmooclo002oogmo@04ooclo?omoOgoo?cloogmo@?o
o?cl1_omoOd01Oolo?cooOgmooclo?omoOgoo?cl00;ooOgm00Coo?cloogm
oOolo?cooOgm0oolo?`6oogmo@05ooclo?omoOgoo?cloogmoOolo?`00_om
oOd01?olo?cooOgmooclo?omoOd3ooclo0KooOgm00Goo?cloogmoOolo?co
oOgmooclo002oogmo@04ooclo?omoOgoo?cloogmo@?oo?cl1_omoOd01Ool
o?cooOgmooclo?omoOgoo?cl00;ooOgm00Coo?cloogmoOolo?cooOgm0ool
o?`6oogmo@05ooclo?omoOgoo?cloogmoOolo?`00_omoOd01?olo?cooOgm
ooclo?omoOd3ooclo0KooOgm00Goo?cloogmoOolo?cooOgmooclo002oogm
o@04ooclo?omoOgoo?cloogmo@?oo?cl1_omoOd01Oolo?cooOgmooclo?om
oOgoo?cl00;ooOgm00Coo?cloogmoOolo?cooOgm0oolo?`6oogmo@05oocl
o?omoOgoo?cloogmoOolo?`00_omoOd01?olo?cooOgmooclo?omoOd3oocl
o0KooOgm00Goo?cloogmoOolo?cooOgmooclo002oogmo@04ooclo?omoOgo
o?cloogmo@?oo?cl1_omoOd01Oolo?cooOgmooclo?omoOgoo?cl00;ooOgm
00Coo?cloogmoOolo?cooOgm0oolo?`6oogmo@05ooclo?omoOgoo?cloogm
oOolo?`00_omoOd01?olo?cooOgmooclo?omoOd3ooclo0KooOgm00Goo?cl
oogmoOolo?cooOgmooclo002oogmo@04ooclo?omoOgoo?cloogmo@?oo?cl
1_omoOd01Oolo?cooOgmooclo?omoOgoo?cl00;ooOgm00Coo?cloogmoOol
o?cooOgm0oolo?`6oogmo@05ooclo?omoOgoo?cloogmoOolo?`00_omoOd0
1?olo?cooOgmooclo?omoOd3ooclo0KooOgm00Goo?cloogmoOolo?cooOgm
ooclo002oogmo@04ooclo?omoOgoo?cloogmo@?oo?cl1_omoOd01Oolo?co
oOgmooclo?omoOgoo?cl00;ooOgm00Coo?cloogmoOolo?cooOgm0oolo?`6
oogmo@05ooclo?omoOgoo?cloogmoOolo?`00_omoOd01?olo?cooOgmoocl
o?omoOd3ooclo0KooOgm00Goo?cloogmoOolo?cooOgmooclo002oogmo@04
ooclo?omoOgoo?cloogmo@?oo?cl1_omoOd01Oolo?cooOgmooclo?omoOgo
o?cl00;ooOgm00Coo?cloogmoOolo?cooOgm0oolo?`6oogmo@05ooclo?om
oOgoo?cloogmoOolo?`00_omoOd01?olo?cooOgmooclo?omoOd3ooclo0Ko
oOgm00Goo?cloogmoOolo?cooOgmooclo002oogmo@04ooclo?omoOgoo?cl
oogmo@;oo?cl0Oo`l?01oh:2PP002On2PX82oh>3P`CoPX:200CoPh>3oh:2
P_n3Ph?oPh>30on2PX800on3Ph?oPX:2oh:2PP04oh:2PP;oPh>31?n2PX80
1?n3Ph?oPX:2oh>3Pon3Ph<3oh:2PP03oh>3Pon2PX;oPX:200CoPX:20_n3
Ph<4oh:2PP04oh>3Pon2PX;oPh>3oh>3P`?oPX:200?oPh>3oh:2P_n2PX80
1?n2PX82oh>3P`CoPX:200CoPh>3oh:2P_n3Ph?oPh>30on2PX800on3Ph?o
PX:2oh:2PP04oh:2PP;oPh>31?n2PX801?n3Ph?oPX:2oh>3Pon3Ph<3oh:2
PP03oh>3Pon2PX;oPX:200CoPX:20_n3Ph<4oh:2PP04oh>3Pon2PX;oPh>3
oh>3P`?oPX:200?oPh>3oh:2P_n2PX801?n2PX82oh>3P`CoPX:200CoPh>3
oh:2P_n3Ph?oPh>30on2PX800on3Ph?oPX:2oh:2PP04oh:2PP;oPh>31?n2
PX801?n3Ph?oPX:2oh>3Pon3Ph<3oh:2PP03oh>3Pon2PX;oPX:200CoPX:2
0_n3Ph<4oh:2PP04oh>3Pon2PX;oPh>3oh>3P`?oPX:200?oPh>3oh:2P_n2
PX801?n2PX82oh>3P`CoPX:200CoPh>3oh:2P_n3Ph?oPh>30on2PX800on3
Ph?oPX:2oh:2PP04oh:2PP;oPh>31?n2PX801?n3Ph?oPX:2oh>3Pon3Ph<3
oh:2PP03oh>3Pon2PX;oPX:200CoPX:20_n3Ph<4oh:2PP04oh>3Pon2PX;o
Ph>3oh>3P`?oPX:200?oPh>3oh:2P_n2PX801?n2PX82oh>3P`CoPX:200Co
Ph>3oh:2P_n3Ph?oPh>30on2PX800on3Ph?oPX:2oh:2PP04oh:2PP;oPh>3
1?n2PX801?n3Ph?oPX:2oh>3Pon3Ph<3oh:2PP03oh>3Pon2PX;oPX:200Co
PX:20_n3Ph<4oh:2PP04oh>3Pon2PX;oPh>3oh>3P`?oPX:200?oPh>3oh:2
P_n2PX801?n2PX82oh>3P`CoPX:200CoPh>3oh:2P_n3Ph?oPh>30on2PX80
0on3Ph?oPX:2oh:2PP04oh:2PP;oPh>31?n2PX801?n3Ph?oPX:2oh>3Pon3
Ph<3oh:2PP03oh>3Pon2PX;oPX:200CoPX:20_n3Ph<4oh:2PP04oh>3Pon2
PX;oPh>3oh>3P`?oPX:200?oPh>3oh:2P_n2PX801?n2PX82oh>3P`CoPX:2
00CoPh>3oh:2P_n3Ph?oPh>30on2PX800on3Ph?oPX:2oh:2PP04oh:2PP;o
Ph>31?n2PX801?n3Ph?oPX:2oh>3Pon3Ph<3oh:2PP03oh>3Pon2PX;oPX:2
00CoPX:20_n3Ph<4oh:2PP04oh>3Pon2PX;oPh>3oh>3P`?oPX:200?oPh>3
oh:2P_n2PX801?n2PX82oh>3P`CoPX:200CoPh>3oh:2P_n3Ph?oPh>30on2
PX800on3Ph?oPX:2oh:2PP04oh:2PP;oPh>31?n2PX801?n3Ph?oPX:2oh>3
Pon3Ph<3oh:2PP03oh>3Pon2PX;oPX:200CoPX:20_n3Ph<4oh:2PP04oh>3
Pon2PX;oPh>3oh>3P`?oPX:200?oPh>3oh:2P_n2PX801?n2PX82oh>3P`Co
PX:200CoPh>3oh:2P_n3Ph?oPh>30on2PX800on3Ph?oPX:2oh:2PP04oh:2
PP;oPh>31?n2PX801?n3Ph?oPX:2oh>3Pon3Ph<3oh:2PP03oh>3Pon2PX;o
PX:200CoPX:20_n3Ph<4oh:2PP04oh>3Pon2PX;oPh>3oh>3P`?oPX:200?o
Ph>3oh:2P_n2PX801?n2PX82oh>3P`CoPX:200CoPh>3oh:2P_n3Ph?oPh>3
0on2PX800on3Ph?oPX:2oh:2PP04oh:2PP;oPh>31?n2PX801?n3Ph?oPX:2
oh>3Pon3Ph<3oh:2PP03oh>3Pon2PX;oPX:200CoPX:20_n3Ph<4oh:2PP04
oh>3Pon2PX;oPh>3oh>3P`?oPX:200?oPh>3oh:2P_n2PX801?n2PX82oh>3
P`CoPX:200CoPh>3oh:2P_n3Ph?oPh>30on2PX800on3Ph?oPX:2oh:2PP04
oh:2PP;oPh>31?n2PX800on3Ph?oPX:2oh:2PP02oh:2PP00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooLg=coomcLg>2og=c
L`0000CoLg=con_[joo`l?3okno_1?o`l?001Oo_knoolO7aoo3`l?o/k>co
k^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_knookno_onk^k_o_knl01?o`
l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h2ono_k`05oo3`
l?o_knookno_onk^k_o_knl01?o`l?001Oo_knoolO7aoo3`l?o/k>cok^k^
00;okno_0_o^k^h2ono_k`05oo3`l?o_knookno_onk^k_o_knl01?o`l?00
1Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_
knookno_onk^k_o_knl01?o`l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;o
kno_0_o^k^h2ono_k`05oo3`l?o_knookno_onk^k_o_knl01?o`l?001Oo_
knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_knoo
kno_onk^k_o_knl01?o`l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_
0_o^k^h2ono_k`05oo3`l?o_knookno_onk^k_o_knl01?o`l?001Oo_knoo
lO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_knookno_
onk^k_o_knl01?o`l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^
k^h2ono_k`05oo3`l?o_knookno_onk^k_o_knl01?o`l?001Oo_knoolO7a
oo3`l?o/k>cok^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_knookno_onk^
k_o_knl01?o`l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h2
ono_k`05oo3`l?o_knookno_onk^k_o_knl01?o`l?001Oo_knoolO7aoo3`
l?o/k>cok^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_knookno_onk^k_o_
knl01?o`l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h2ono_
k`05oo3`l?o_knookno_onk^k_o_knl01?o`l?001Oo_knoolO7aoo3`l?o/
k>cok^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_knookno_onk^k_o_knl0
1?o`l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h2ono_k`05
oo3`l?o_knookno_onk^k_o_knl01?o`l?001Oo_knoolO7aoo3`l?o/k>co
k^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_knookno_onk^k_o_knl01?o`
l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h2ono_k`05oo3`
l?o_knookno_onk^k_o_knl01?o`l?001Oo_knoolO7aoo3`l?o/k>cok^k^
00;okno_0_o^k^h2ono_k`05oo3`l?o_knookno_onk^k_o_knl01?o`l?00
1Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_
knookno_onk^k_o_knl01?o`l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;o
kno_0_o^k^h2ono_k`05oo3`l?o_knookno_onk^k_o_knl01?o`l?001Oo_
knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_knoo
kno_onk^k_o_knl01?o`l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_
0_o^k^h2ono_k`05oo3`l?o_knookno_onk^k_o_knl01?o`l?001Oo_knoo
lO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_knookno_
onk^k_o_knl01?o`l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^
k^h2ono_k`05oo3`l?o_knookno_onk^k_o_knl01?o`l?001Oo_knoolO7a
oo3`l?o/k>cok^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_knookno_onk^
k_o_knl01?o`l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h2
ono_k`05oo3`l?o_knookno_onk^k_o_knl01?o`l?001Oo_knoolO7aoo3`
l?o/k>cok^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_knookno_onk^k_o_
knl01?o`l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h2ono_
k`05oo3`l?o_knookno_onk^k_o_knl01?o`l?001Oo_knoolO7aoo3`l?o/
k>cok^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_knookno_onk^k_o_knl0
1?o`l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h2ono_k`05
oo3`l?o_knookno_onk^k_o_knl01?o`l?001Oo_knoolO7aoo3`l?o/k>co
k^k^00;okno_0_o^k^h2ono_k`05oo3`l?o_knookno_onk^k_o_knl01?o`
l?001Oo_knoolO7aoo3`l?o/k>cok^k^00;okno_0_o^k^h1ono_k`7ojn_[
0OmcLg<00004og=cLooUiNGojNWYon_[j`;ojNWY00?ojn_[on[Zj_oYjNT0
0_oYjNT01?oXj>SojNWYon[Zj_oZj^X2onWYj@03onSXj?oYjNWoj^[Z00?o
j^[Z00Gojn_[onWYjOoYjNWojn_[on[ZjP03onWYj@04onSXj?oYjNWoj^[Z
on[ZjP;ojNWY00?oj>SXonWYjOoZj^X00ooZj^X01Oo[jn_ojNWYonWYjOo[
jn_oj^[Z00?ojNWY00Coj>SXonWYjOoZj^[oj^[Z0_oYjNT00ooXj>SojNWY
on[ZjP03on[ZjP05on_[jooYjNWojNWYon_[jooZj^X00ooYjNT01?oXj>So
jNWYon[Zj_oZj^X2onWYj@03onSXj?oYjNWoj^[Z00?oj^[Z00Gojn_[onWY
jOoYjNWojn_[on[ZjP03onWYj@04onSXj?oYjNWoj^[Zon[ZjP;ojNWY00?o
j>SXonWYjOoZj^X00ooZj^X01Oo[jn_ojNWYonWYjOo[jn_oj^[Z00?ojNWY
00Coj>SXonWYjOoZj^[oj^[Z0_oYjNT00ooXj>SojNWYon[ZjP03on[ZjP05
on_[jooYjNWojNWYon_[jooZj^X00ooYjNT01?oXj>SojNWYon[Zj_oZj^X2
onWYj@03onSXj?oYjNWoj^[Z00?oj^[Z00Gojn_[onWYjOoYjNWojn_[on[Z
jP03onWYj@04onSXj?oYjNWoj^[Zon[ZjP;ojNWY00?oj>SXonWYjOoZj^X0
0ooZj^X01Oo[jn_ojNWYonWYjOo[jn_oj^[Z00?ojNWY00Coj>SXonWYjOoZ
j^[oj^[Z0_oYjNT00ooXj>SojNWYon[ZjP03on[ZjP05on_[jooYjNWojNWY
on_[jooZj^X00ooYjNT01?oXj>SojNWYon[Zj_oZj^X2onWYj@03onSXj?oY
jNWoj^[Z00?oj^[Z00Gojn_[onWYjOoYjNWojn_[on[ZjP03onWYj@04onSX
j?oYjNWoj^[Zon[ZjP;ojNWY00?oj>SXonWYjOoZj^X00ooZj^X01Oo[jn_o
jNWYonWYjOo[jn_oj^[Z00?ojNWY00Coj>SXonWYjOoZj^[oj^[Z0_oYjNT0
0ooXj>SojNWYon[ZjP03on[ZjP05on_[jooYjNWojNWYon_[jooZj^X00ooY
jNT01?oXj>SojNWYon[Zj_oZj^X2onWYj@03onSXj?oYjNWoj^[Z00?oj^[Z
00Gojn_[onWYjOoYjNWojn_[on[ZjP03onWYj@04onSXj?oYjNWoj^[Zon[Z
jP;ojNWY00?oj>SXonWYjOoZj^X00ooZj^X01Oo[jn_ojNWYonWYjOo[jn_o
j^[Z00?ojNWY00Coj>SXonWYjOoZj^[oj^[Z0_oYjNT00ooXj>SojNWYon[Z
jP03on[ZjP05on_[jooYjNWojNWYon_[jooZj^X00ooYjNT01?oXj>SojNWY
on[Zj_oZj^X2onWYj@03onSXj?oYjNWoj^[Z00?oj^[Z00Gojn_[onWYjOoY
jNWojn_[on[ZjP03onWYj@04onSXj?oYjNWoj^[Zon[ZjP;ojNWY00?oj>SX
onWYjOoZj^X00ooZj^X01Oo[jn_ojNWYonWYjOo[jn_oj^[Z00?ojNWY00Co
j>SXonWYjOoZj^[oj^[Z0_oYjNT00ooXj>SojNWYon[ZjP03on[ZjP05on_[
jooYjNWojNWYon_[jooZj^X00ooYjNT01?oXj>SojNWYon[Zj_oZj^X2onWY
j@03onSXj?oYjNWoj^[Z00?oj^[Z00Gojn_[onWYjOoYjNWojn_[on[ZjP03
onWYj@04onSXj?oYjNWoj^[Zon[ZjP;ojNWY00?oj>SXonWYjOoZj^X00ooZ
j^X01Oo[jn_ojNWYonWYjOo[jn_oj^[Z00?ojNWY00Coj>SXonWYjOoZj^[o
j^[Z0_oYjNT00ooXj>SojNWYon[ZjP03on[ZjP05on_[jooYjNWojNWYon_[
jooZj^X00ooYjNT01?oXj>SojNWYon[Zj_oZj^X2onWYj@03onSXj?oYjNWo
j^[Z00?oj^[Z00Gojn_[onWYjOoYjNWojn_[on[ZjP03onWYj@04onSXj?oY
jNWoj^[Zon[ZjP;ojNWY00?oj>SXonWYjOoZj^X00ooZj^X01Oo[jn_ojNWY
onWYjOo[jn_oj^[Z00?ojNWY00Coj>SXonWYjOoZj^[oj^[Z0_oYjNT00ooX
j>SojNWYon[ZjP03on[ZjP05on_[jooYjNWojNWYon_[jooZj^X00ooYjNT0
1?oXj>SojNWYon[Zj_oZj^X2onWYj@03onSXj?oYjNWoj^[Z00?oj^[Z00Go
jn_[onWYjOoYjNWojn_[on[ZjP03onWYj@04onSXj?oYjNWoj^[Zon[ZjP;o
jNWY00?oj>SXonWYjOoZj^X00ooZj^X01Oo[jn_ojNWYonWYjOo[jn_oj^[Z
00?ojNWY00Coj>SXonWYjOoZj^[oj^[Z0_oYjNT00ooXj>SojNWYon[ZjP03
on[ZjP05on_[jooYjNWojNWYon_[jooZj^X00ooYjNT01?oXj>SojNWYon[Z
j_oZj^X2onWYj@03onSXj?oYjNWoj^[Z00?oj^[Z00Gojn_[onWYjOoYjNWo
jn_[on[ZjP03onWYj@04onSXj?oYjNWoj^[Zon[ZjP;ojNWY00?oj>SXonWY
jOoZj^X00ooZj^X01Oo[jn_ojNWYonWYjOo[jn_oj^[Z00?ojNWY00Coj>SX
onWYjOoZj^[oj^[Z0_oYjNT00ooXj>SojNWYon[ZjP03on[ZjP05on_[jooY
jNWojNWYon_[jooZj^X00ooYjNT01?oXj>SojNWYon[Zj_oZj^X2onWYj@03
onSXj?oYjNWoj^[Z00?oj^[Z00Gojn_[onWYjOoYjNWojn_[on[ZjP03onWY
j@04onSXj?oYjNWoj^[Zon[ZjP?ojNWY0OoTi>@1og=cL`0000?oLg=comgM
gOoUiND00_oUiND00ooTi>Cohn?SonCTi002onCTi005onGUiOoVi^Koi>CT
onGUiOoTi>@00_oShn<3onCTi003onKVi_oUiNGoi>CU00;oiNGU00?oi>CT
on?ShooTi>@00_oTi>@01OoUiNGoi^KVonCTi?oUiNGoi>CT00;ohn?S0ooT
i>@00ooVi^KoiNGUonCTi@02onGUi@03onCTi?oShn?oi>CT00;oi>CT00Go
iNGUonKVi_oTi>CoiNGUonCTi002on?Sh`?oi>CT00?oi^KVonGUiOoTi>D0
0_oUiND00ooTi>Cohn?SonCTi002onCTi005onGUiOoVi^Koi>CTonGUiOoT
i>@00_oShn<3onCTi003onKVi_oUiNGoi>CU00;oiNGU00?oi>CTon?ShooT
i>@00_oTi>@01OoUiNGoi^KVonCTi?oUiNGoi>CT00;ohn?S0ooTi>@00ooV
i^KoiNGUonCTi@02onGUi@03onCTi?oShn?oi>CT00;oi>CT00GoiNGUonKV
i_oTi>CoiNGUonCTi002on?Sh`?oi>CT00?oi^KVonGUiOoTi>D00_oUiND0
0ooTi>Cohn?SonCTi002onCTi005onGUiOoVi^Koi>CTonGUiOoTi>@00_oS
hn<3onCTi003onKVi_oUiNGoi>CU00;oiNGU00?oi>CTon?ShooTi>@00_oT
i>@01OoUiNGoi^KVonCTi?oUiNGoi>CT00;ohn?S0ooTi>@00ooVi^KoiNGU
onCTi@02onGUi@03onCTi?oShn?oi>CT00;oi>CT00GoiNGUonKVi_oTi>Co
iNGUonCTi002on?Sh`?oi>CT00?oi^KVonGUiOoTi>D00_oUiND00ooTi>Co
hn?SonCTi002onCTi005onGUiOoVi^Koi>CTonGUiOoTi>@00_oShn<3onCT
i003onKVi_oUiNGoi>CU00;oiNGU00?oi>CTon?ShooTi>@00_oTi>@01OoU
iNGoi^KVonCTi?oUiNGoi>CT00;ohn?S0ooTi>@00ooVi^KoiNGUonCTi@02
onGUi@03onCTi?oShn?oi>CT00;oi>CT00GoiNGUonKVi_oTi>CoiNGUonCT
i002on?Sh`?oi>CT00?oi^KVonGUiOoTi>D00_oUiND00ooTi>Cohn?SonCT
i002onCTi005onGUiOoVi^Koi>CTonGUiOoTi>@00_oShn<3onCTi003onKV
i_oUiNGoi>CU00;oiNGU00?oi>CTon?ShooTi>@00_oTi>@01OoUiNGoi^KV
onCTi?oUiNGoi>CT00;ohn?S0ooTi>@00ooVi^KoiNGUonCTi@02onGUi@03
onCTi?oShn?oi>CT00;oi>CT00GoiNGUonKVi_oTi>CoiNGUonCTi002on?S
h`?oi>CT00?oi^KVonGUiOoTi>D00_oUiND00ooTi>Cohn?SonCTi002onCT
i005onGUiOoVi^Koi>CTonGUiOoTi>@00_oShn<3onCTi003onKVi_oUiNGo
i>CU00;oiNGU00?oi>CTon?ShooTi>@00_oTi>@01OoUiNGoi^KVonCTi?oU
iNGoi>CT00;ohn?S0ooTi>@00ooVi^KoiNGUonCTi@02onGUi@03onCTi?oS
hn?oi>CT00;oi>CT00GoiNGUonKVi_oTi>CoiNGUonCTi002on?Sh`?oi>CT
00?oi^KVonGUiOoTi>D00_oUiND00ooTi>Cohn?SonCTi002onCTi005onGU
iOoVi^Koi>CTonGUiOoTi>@00_oShn<3onCTi003onKVi_oUiNGoi>CU00;o
iNGU00?oi>CTon?ShooTi>@00_oTi>@01OoUiNGoi^KVonCTi?oUiNGoi>CT
00;ohn?S0ooTi>@00ooVi^KoiNGUonCTi@02onGUi@03onCTi?oShn?oi>CT
00;oi>CT00GoiNGUonKVi_oTi>CoiNGUonCTi002on?Sh`?oi>CT00?oi^KV
onGUiOoTi>D00_oUiND00ooTi>Cohn?SonCTi002onCTi005onGUiOoVi^Ko
i>CTonGUiOoTi>@00_oShn<3onCTi003onKVi_oUiNGoi>CU00;oiNGU00?o
i>CTon?ShooTi>@00_oTi>@01OoUiNGoi^KVonCTi?oUiNGoi>CT00;ohn?S
0ooTi>@00ooVi^KoiNGUonCTi@02onGUi@03onCTi?oShn?oi>CT00;oi>CT
00GoiNGUonKVi_oTi>CoiNGUonCTi002on?Sh`?oi>CT00?oi^KVonGUiOoT
i>D00_oUiND00ooTi>Cohn?SonCTi002onCTi005onGUiOoVi^Koi>CTonGU
iOoTi>@00_oShn<3onCTi003onKVi_oUiNGoi>CU00;oiNGU00?oi>CTon?S
hooTi>@00_oTi>@01OoUiNGoi^KVonCTi?oUiNGoi>CT00;ohn?S0ooTi>@0
0ooVi^KoiNGUonCTi@02onGUi@03onCTi?oShn?oi>CT00;oi>CT00GoiNGU
onKVi_oTi>CoiNGUonCTi002on?Sh`?oi>CT00?oi^KVonGUiOoTi>D00_oU
iND00ooTi>Cohn?SonCTi002onCTi005onGUiOoVi^Koi>CTonGUiOoTi>@0
0_oShn<3onCTi003onKVi_oUiNGoi>CU00;oiNGU00?oi>CTon?ShooTi>@0
0_oTi>@01OoUiNGoi^KVonCTi?oUiNGoi>CT00;ohn?S0ooTi>@00ooVi^Ko
iNGUonCTi@02onGUi@03onCTi?oShn?oi>CT00;oi>CT00GoiNGUonKVi_oT
i>CoiNGUonCTi002on?Sh`?oi>CT00?oi^KVonGUiOoTi>D00_oUiND00ooT
i>Cohn?SonCTi002onCTi005onGUiOoVi^Koi>CTonGUiOoTi>@00_oShn<3
onCTi003onKVi_oUiNGoi>CU00;oiNGU00?oi>CTon?ShooTi>@00_oTi>@0
1OoUiNGoi^KVonCTi?oUiNGoi>CT00;ohn?S0OoUiND1omkNgP7oLg=c0000
0omcLg?oeMGEomgMg@1OomkNgQkogmoO1?oNg]hDomgMg@Sog]kN0_oOgml2
omkNgPOogmoO3?oPh>08omoOg`;og]kN0_oOgml8omkNgQCogMgM0_oNg]h2
omgMgAcog]kN0_oMgMd2omkNgQ_ogMgM1?oNg]hLomoOg`Cog]kN>ooMgMd4
omkNgQkogmoO7_oNg]h2omgMg@;og]kN7?oMgMd2omkNgP;ogMgMN_oNg]h4
omgMgAkog=cL0OoNg]h1omGEe@7oLg=c00000omcLg?oeMGEomgMg@1OomkN
gQkogmoO1?oNg]hDomgMg@Sog]kN0_oOgml2omkNgPOogmoO3?oPh>08omoO
g`;og]kN0_oOgml8omkNgQCogMgM0_oNg]h2omgMgAcog]kN0_oMgMd2omkN
gQ_ogMgM1?oNg]hLomoOg`Cog]kN>ooMgMd4omkNgQkogmoO7_oNg]h2omgM
g@;og]kN7?oMgMd2omkNgP;ogMgMN_oNg]h4omgMgAkog=cL0OoNg]h1omGE
e@7oLg=c00000omcLg?oeMGEomgMg@1OomkNgQkogmoO1?oNg]hDomgMg@So
g]kN0_oOgml2omkNgPOogmoO3?oPh>08omoOg`;og]kN0_oOgml8omkNgQCo
gMgM0_oNg]h2omgMgAcog]kN0_oMgMd2omkNgQ_ogMgM1?oNg]hLomoOg`Co
g]kN>ooMgMd4omkNgQkogmoO7_oNg]h2omgMg@;og]kN7?oMgMd2omkNgP;o
gMgMN_oNg]h4omgMgAkog=cL0OoNg]h1omGEe@7oLg=c00000omcLg?oeMGE
omgMg@1OomkNgQkogmoO1?oNg]hDomgMg@Sog]kN0_oOgml2omkNgPOogmoO
3?oPh>08omoOg`;og]kN0_oOgml8omkNgQCogMgM0_oNg]h2omgMgAcog]kN
0_oMgMd2omkNgQ_ogMgM1?oNg]hLomoOg`Cog]kN>ooMgMd4omkNgQkogmoO
7_oNg]h2omgMg@;og]kN7?oMgMd2omkNgP;ogMgMN_oNg]h4omgMgAkog=cL
0OoNg]h1omGEe@7oLg=c00000omcLg?oeMGEomgMg@1OomkNgQkogmoO1?oN
g]hDomgMg@Sog]kN0_oOgml2omkNgPOogmoO3?oPh>08omoOg`;og]kN0_oO
gml8omkNgQCogMgM0_oNg]h2omgMgAcog]kN0_oMgMd2omkNgQ_ogMgM1?oN
g]hLomoOg`Cog]kN>ooMgMd4omkNgQkogmoO7_oNg]h2omgMg@;og]kN7?oM
gMd2omkNgP;ogMgMN_oNg]h4omgMgAkog=cL0OoNg]h1omGEe@7oLg=c0000
0omcLg?oeMGEomgMg@1OomkNgQkogmoO1?oNg]hDomgMg@Sog]kN0_oOgml2
omkNgPOogmoO3?oPh>08omoOg`;og]kN0_oOgml8omkNgQCogMgM0_oNg]h2
omgMgAcog]kN0_oMgMd2omkNgQ_ogMgM1?oNg]hLomoOg`Cog]kN>ooMgMd4
omkNgQkogmoO7_oNg]h2omgMg@;og]kN7?oMgMd2omkNgP;ogMgMN_oNg]h4
omgMgAkog=cL0OoNg]h1omGEe@7oLg=c00000omcLg?oeMGEomgMg@1OomkN
gQkogmoO1?oNg]hDomgMg@Sog]kN0_oOgml2omkNgPOogmoO3?oPh>08omoO
g`;og]kN0_oOgml8omkNgQCogMgM0_oNg]h2omgMgAcog]kN0_oMgMd2omkN
gQ_ogMgM1?oNg]hLomoOg`Cog]kN>ooMgMd4omkNgQkogmoO7_oNg]h2omgM
g@;og]kN7?oMgMd2omkNgP;ogMgMN_oNg]h4omgMgAkog=cL0OoNg]h1omGE
e@7oLg=c00000omcLg?oeMGEomgMg@1OomkNgQkogmoO1?oNg]hDomgMg@So
g]kN0_oOgml2omkNgPOogmoO3?oPh>08omoOg`;og]kN0_oOgml8omkNgQCo
gMgM0_oNg]h2omgMgAcog]kN0_oMgMd2omkNgQ_ogMgM1?oNg]hLomoOg`Co
g]kN>ooMgMd4omkNgQkogmoO7_oNg]h2omgMg@;og]kN7?oMgMd2omkNgP;o
gMgMN_oNg]h4omgMgAkog=cL0OoNg]h1omGEe@7oLg=c00000omcLg?oe=CD
omgMg@1OomkNgQkogmoO1?oNg]hLomgMg@Cog]kN6ooOgml4omkNgQcogMgM
0_oNg]h2omgMgAcog]kN0_oMgMd2omkNgQ_ogMgM1?oNg]hLomoOg`Cog]kN
>ooMgMd4omkNgQkogmoO7_oNg]h2omgMg@;og]kN7?oMgMd2omkNgP;ogMgM
N_oNg]h4omgMgAkog=cL0OoNg]h1omCDe07oLg=c00000omcLg?odm?ComcL
g01MomgMg@;og]kN0_oMgMdLomkNgPCogMgM7?oLg=`4omgMgA_og]kN1?oM
gMdNomcLg23ogMgM7OoLg=`4omgMgAcog]kN1?oMgMdkomcLg0CogMgM7?oN
g]h2omgMg@;og]kN7_oMgMdPomcLg7SogMgM3?oLg=`Jom_Kf`7ogMgM0OoC
dm<1og=cL`0000?oLg=com;Bd_oKfm/0>OoKfm/6omcLg0Kofm_K=?oLg=`6
om_Kf`Kog=cL5?oKfm/6omcLg0Gofm_K5?oLg=`6om_Kf`Kog=cLDooKfm/6
omcLg0Kofm_K5?oLg=`6om_Kf`Kog=cL=?oKfm/5omcLg0Kofm_K5?oLg=`6
om_Kf`Kog=cL^?oKfm/Pom[JfP7ofm_K0OoBd]81og=cL`0000?oLg=com;B
d_oKfm/0FOoLg=`6om_Kf`Kog=cL=?oKfm/;omcLg1CogMgM3?oLg=`jom_K
faoof][J8?oKfm/oom[Jf]kofm_K8?oJf]X1omcLg07od];B0OmcLg<00003
og=cLooAdM7of][J03oof][J7_oKfm/4om[JfQcofMWI0_oJf]X2omWIfAko
f][J7ooKfm/Nom[JfP;ofMWI0_oJf][JomWIf@;of][J0_oIfMTLom[JfP;o
fMWI0_oJf]ZLomWIf@7of][J0OoAdM41og=cL`0000?oLg=com3@d?oIfMT0
?OoIfMT2om[JfP;ofMWI7?oJf]X4omWIfAkof=SH7_oIfMT2om[JfP;ofMWI
6ooJf]X2omWIf@;of][J7_oIfMWNomSHf23ofMWIW_oHf=P1omWIf@7od=3@
0OmcLg<00003og=cLoo@d=3ofMWI03gofMWI0_oJf]X2omWIfAcof][J1?oI
fMTNomSHf1kofMWI0_oJf]X2omWIfA_of][J0_oIfMT2om[JfQkofMWIg_oH
f=PPomWIfIkof=SH0OoIfMT1om3@d07oLg=c00000omcLg?oclo?omWIf@0m
omWIf@;of][J0_oIfMTLom[JfPCofMWI7_oHf=QOomWIfMkof=SH8?oIfMVN
omSHf07ofMWI0Oo?cll1og=cL`0000?oLg=colo?cooIfMT0?OoIfMT2om[J
fP;ofMWI7?oJf]X4omWIfAkof=SHGooIfMWNomSHf23ofMWIW_oHf=P1omWI
f@7oclo?0OmcLg<00003og=cLoo?cloofMWI03gofMWI0_oJf]X2omWIfAco
f][J1?oIfMTNomSHf5oofMWIg_oHf=PPomWIfIkof=SH0OoIfMT1olo?c`7o
Lg=c00000omcLg?oclo?omWIf@0momWIf@;of][J0_oIfMTLom[JfPCofMWI
7_oHf=QOomWIfMkof=SH8?oIfMVNomSHf07ofMWI0Oo?cll1og=cL`0000?o
Lg=colo?cooHf=P0?ooHf=PFomWIfACof=SH3?oGemL:omSHf0[oemOGBooH
f=P:omOGe`[of=SHb_oGemL:omSHf0[oemOG3?oHf=P:omOGe`Wof=SHUOoG
emL1omSHf07oclo?0OmcLg<00003og=cLoo>c/kof=SH05Gof=SH5?oGemL<
omKFeQCoemOG:ooHf=P:omOGe`[of=SHEOoGemLPomKFeUooemOG8?oFe]HP
omOGeeooe]KF@?oGemL1olk>cP7oLg=c00000omcLg?oc/k>omSHf01EomSH
f1CoemOG3?oFe]HDomOGeb_of=SH2_oGemL:omSHf5GoemOG8?oFe]IOomOG
eb3oe]KF8?oGemMOomKFeT3oemOG0Oo>c/h1og=cL`0000?oLg=colg=cOoF
e]H0_?oFe]H2omGEe@;oe]KF7?oEeMD2omKFeP;oeMGEGOoFe]HPomOGeaoo
e]KF8?oGemLnomKFeP;oeMGE0_oFe]HKomGEe@;oe]KF0_oEeMDLomKFeP;o
eMGE0_oFe]HLomGEe@;oe]KF0_oEeMDnomKFeP7ocLg=0OmcLg<00003og=c
Loo<c<coeMGE03ooeMGE8?oDe=AOomGEeB3oe=CDGOoEeMD2omKFeP;oeMGE
7?oFe]H2omGEe@;oe]KF6ooEeMD2omKFeP;oeMGE7?oFe]H2omGEe@;oe]KF
?_oEeMDOomCDe23oeMGE8?oDe=A0omGEe@7oc<c<0OmcLg<00003og=cLoo;
bl_oeMGE03WoeMGE3?oDe=@Dom?Cd`Koe=CD1_oCdm<JomCDe3WoeMGE3?oD
e=@Dom?Cd`coe=CD>OoEeMDNomCDe0CoeMGE7?oFe]H2omGEe@;oe]KF6ooE
eMD2omKFeP;oeMGE7?oFe]H4omGEeCSoe=CD1_oCdm<6omCDe1?odm?C1_oD
e=@6om?CdaCoe=CD1_oCdm<6omCDe1Codm?C3?oDe=@iomGEe@7oe=CD0Oo;
bl/1og=cL`0000?oLg=col_;booEeMD0>OoEeMD<omCDe1Codm?C1_oDe=@6
om?Cda[oe=CD>OoEeMD<omCDe1Codm?C3?oDe=@iomGEeAkoe=CD1?oEeMDL
omKFeP;oeMGE0_oFe]HKomGEe@;oe]KF0_oEeMDLomKFePCoeMGE>?oDe=@6
om?Cd`Koe=CD4ooCdm<6omCDe0Kodm?C5?oDe=@6om?Cd`Koe=CD5?oCdm<<
omCDe3WoeMGE0OoDe=@1ol_;b`7oLg=c00000omcLg?obl_;omCDe00iomCD
e0codm?C6_oBd]8Jom?Cd`Koe=CD1_oCdm<comCDe0codm?C5?oBd]8<om?C
dc?oe=CD1_oCdm<6omCDe1Codm?C3?oDe=@JomGEeAooe=CD6_oEeMD<omCD
e3[odm?C7ooBd]8Pom?Cda[od];B3?oCdm<iomCDe07odm?C0Oo;bl/1og=c
L`0000?oLg=col_;booDe=@0>OoDe=@<om?Cda[od];B6_oCdm<6omCDe0Ko
dm?C<ooDe=@<om?CdaCod];B3?oCdm<comCDe0Kodm?C1_oDe=@Dom?Cd`co
e=CD6_oEeMDOomCDe1[oeMGE3?oDe=@jom?Cdaood];B8?oCdm<Jom;BdPco
dm?C>OoDe=@1om?Cd`7obl_;0OmcLg<00003og=cLoo;bl_oe=CD03Woe=CD
3?oCdm<Jom;BdQ[odm?C1_oDe=@6om?Cdc?oe=CD3?oCdm<Dom;BdPcodm?C
<ooDe=@6om?Cd`Koe=CD5?oCdm<<omCDe1[oeMGE7ooDe=@JomGEe@coe=CD
>_oCdm<Oom;BdR3odm?C6_oBd]8<om?CdcWoe=CD0OoCdm<1ol_;b`7oLg=c
00000omcLg?obl_;omCDe00iomCDe0codm?C6_oBd]8Jom?Cd`Koe=CD1_oC
dm<comCDe0codm?C5?oBd]8<om?Cdc?oe=CD1_oCdm<6omCDe1Codm?C3?oD
e=@JomGEeAooe=CD6_oEeMD<omCDe3[odm?C7ooBd]8Pom?Cda[od];B3?oC
dm<iomCDe07odm?C0Oo;bl/1og=cL`0000?oLg=col[:b_oCdm<0?OoCdm<4
om;BdQcodM7A0_oBd]82om7AdAkod];B?ooCdm<Pom;BdSoodm?C6_oBd]8<
om?CdaCoe=CD1_oCdm<6omCDe1Codm?C1OoDe=@6om?CdaCoe=CD3?oCdm<J
om;BdQkodm?C1?oBd]8Kom7Ad@;od];B0_oAdM4Lom;BdP;odM7A0_oBd]8L
om7Ad@Cod];B?OoCdm<1om;BdP7ob/[:0OmcLg<00003og=cLoo:b/[od];B
03god];B0_oAdM42om;BdQcodM7A0_oBd]82om7AdMcod];B8?oCdm<Oom;B
dR3odm?C8?oBd]8Nom?Cd`Cod];B6ooAdM42om;BdP;odM7A7?oBd]82om7A
d@;od];B7?oAdM42om;BdP;odM7A?_oBd]81ol[:bP7oLg=c00000omcLg?o
b/[:om;BdP0mom;BdP;odM7A0_oBd]8Lom7Ad@;od];B0_oAdM7Lom;BdR3o
dm?C7ooBd]8Pom?Cdb3od];B7_oCdm<4om;BdQ_odM7A0_oBd]82om7AdAco
d];B0_oAdM42om;BdQcodM7A0_oBd]82om7AdCkod];B0Oo:b/X1og=cL`00
00?oLg=colO7aooBd]807_oAdM42om;BdP;odM7A6ooBd]82om7Ad@;od];B
??oAdM42om;BdP;odM7A>ooBd]82om7Ad@;od];BVooAdM42om;BdP;odM7A
>ooBd]84om7AdAkod=3@W?oAdM42om;BdP;odM7A7_oBd]81om7Ad@7ob<S8
0OmcLg<00003og=cLoo5aLGodM7A023od=3@7ooAdM50om3@d3oodM7AWoo@
d=0eom7AdACod=3@3?o?cll:om3@d0[oclo?U?o@d=0Pom7Ad@7od=3@0Oo7
alL1og=cL`0000?oLg=colG5aOoAdM408?o@d=0Oom7AdD3od=3@?ooAdM6O
om3@d3GodM7A5?o@d=0<olo?c`[od=3@2_o?clnDom3@d23odM7A0Oo@d=01
olO7a`7oLg=c00000omcLg?oaLG5om3@d00Folo?c`[od=3@2_o?clnZom3@
d0[oclo?2_o@d=0[olo?c`[od=3@2_o?cll<om3@d0[oclo?2_o@d=0<olo?
c`[od=3@2_o?cll[om3@d0[oclo?2_o@d=0<olo?c`[od=3@2_o?clm[om3@
d0[oclo?2_o@d=0<olo?c`Wod=3@2_o?cllGom3@d07oalO70OmcLg<00003
og=cLoo4a<Coclo?023oc/k>U?o?cll:om3@d0[oclo?3?o@d=0Dolo?ccGo
c/k>8?o?cllPolk>cSooclo?5_o>c/hDolo?c`cod=3@2_o?cll9om3@d5Ko
clo?7oo>c/hQolo?c`7oa/K60OmcLg<00003og=cLoo4a<Coclo?023oc/k>
U?o?cll:om3@d0[oclo?3?o@d=0Dolo?ccGoc/k>8?o?cllPolk>cSooclo?
5_o>c/hDolo?c`cod=3@2_o?cll9om3@d5Koclo?7oo>c/hQolo?c`7oa/K6
0OmcLg<00003og=cLoo4a<Coclo?023oc/k>U?o?cll:om3@d0[oclo?3?o@
d=0Dolo?ccGoc/k>8?o?cllPolk>cSooclo?5_o>c/hDolo?c`cod=3@2_o?
cll9om3@d5Koclo?7oo>c/hQolo?c`7oa/K60OmcLg<00003og=cLoo4a<Co
clo?023oc/k>U?o?cll:om3@d0[oclo?3?o@d=0Dolo?ccGoc/k>8?o?cllP
olk>cSooclo?5_o>c/hDolo?c`cod=3@2_o?cll9om3@d5Koclo?7oo>c/hQ
olo?c`7oa/K60OmcLg<00003og=cLoo3`l?oclo?023oc/k>__o?clloolk>
cR3oclo?8?o>c/hoolo?cb3oc/k>Ooo?cllOolk>cR7oclo?0Oo6a/H1og=c
L`0000?oLg=col?3`oo?cll08?o>c/jnolo?ccooc/k>8?o?cllPolk>cSoo
clo?8?o>c/ioolo?caooc/k>8Oo?cll1olK6aP7oLg=c00000omcLg?o`/;2
olo?c`0Polk>cSooclo?8?o>c/hoolo?cckoc/k>0_o=cLd2olk>cQ_ocLg=
0_o>c/h2olg=cAcoc/k>0_o=cLd2olk>cQcocLg=1?o>c/hmolo?cb3oc/k>
8?o?clloolk>cQkoclo?1?o>c/hKolg=c@Coc/k>7_o?cll1olk>cP7oaLG5
0OmcLg<00003og=cLoo1`L7oc/k>01kocLg=0_o>c/h2olg=cC_oc/k>0_o=
cLd2olk>cQcocLg=0_o>c/h2olg=cC_oc/k>0_o=cLd2olk>cSkocLg=7oo<
c<`Polg=cAkoc<c<0_o=cLd2olk>cQgoclo?7_o>c/h2olg=c@;oc/k>7?o=
cLd2olk>cP;ocLg=7?o>c/h2olg=c@;oc/k>>oo=cLd2olk>cP;ocLg=7?o>
c/h4olg=cA_oc<c<1?o=cLdNolk>cP7oc<c<0Oo3`l<1og=cL`0000?oLg=c
ol71`Oo<c<`0?oo<c<`Jolg=c@coc<c<5?o;bl/6olc<c0Kobl_;6_o<c<`o
olg=cA[oc<c<1_o;bl/6olc<c1?obl_;1_o<c<`6ol_;bcSoc<c<1?o=cLdK
olk>cPCocLg=?_o<c<`Polg=cAWoc<c<1_o;bl/6olc<c1Cobl_;1_o<c<`6
ol_;baCoc<c<1_o;bl/6olc<c1?obl_;1_o<c<`6ol_;ba[oc<c<0Oo:b/X1
ol71`@7oLg=c00000omcLg?o`L71olc<c00oolc<c1[ocLg=3?o<c<`Dol_;
b`Koc<c<1_o;bl/Jolc<c3oocLg=6_o<c<`6ol_;b`Koc<c<4oo;bl/6olc<
c0Kobl_;>?o<c<`4olg=cA_oc/k>1?o=cLdnolc<c23ocLg=6Oo<c<`6ol_;
b`Koc<c<5?o;bl/6olc<c0Kobl_;5?o<c<`6ol_;b`Koc<c<4oo;bl/6olc<
c0Kobl_;6_o<c<`1ol[:bP7o`L710OmcLg<00003og=cLoo0`<3oc<c<03oo
c<c<6_o=cLd6olc<c0Kobl_;5?o:b/X<ol_;ba[oc<c<7oo=cLdjolc<c0co
bl_;6Oo:b/Xjol_;b`Coc<c<0_o=cLd2olc<c0CocLg=5oo>c/h4olg=cCko
c<c<6_o=cLd<olc<c1Wobl_;6_o:b/X<ol_;baCoc<c<3?o;bl/Col[:bPco
bl_;6_o<c<`1olW9b@7o`<300OmcLg<00003og=cLono_kooc<c<03ooc<c<
6_o=cLd6olc<c0Kobl_;5?o:b/X<ol_;ba[oc<c<6Oo=cLd<olc<c1Cobl_;
1_o<c<`6ol_;baCoc<c<3?o;bl/Iol[:bS[obl_;1?o<c<`2olg=c@;oc<c<
1?o=cLdGolk>cPCocLg=F?o<c<`6ol_;b`Koc<c<6Oo;bl/Jol[:bPcobl_;
5?o<c<`<ol_;ba?ob/[:3?o;bl/Jolc<c07obLW90Oo0`<01og=cL`0000?o
Lg=cokno_oo<c<`0?oo<c<`Jolg=c@Koc<c<1_o;bl/Dol[:bPcobl_;6_o<
c<`Iolg=c@coc<c<5?o;bl/6olc<c0Kobl_;5?o<c<`<ol_;baWob/[:>_o;
bl/4olc<c0;ocLg=0_o<c<`4olg=cAOoc/k>1?o=cLeHolc<c0Kobl_;1_o<
c<`Iol_;ba[ob/[:3?o;bl/Dolc<c0cobl_;4oo:b/X<ol_;ba[oc<c<0Oo9
bLT1ol30`07oLg=c00000omcLg?o_knoolc<c00oolc<c1[ocLg=1_o<c<`6
ol_;baCob/[:3?o;bl/Jolc<c1WocLg=3?o<c<`Dol_;b`Koc<c<1_o;bl/D
olc<c0cobl_;6Oo:b/Xjol_;b`Coc<c<0_o=cLd2olc<c0CocLg=5oo>c/h4
olg=cESoc<c<1_o;bl/6olc<c1Wobl_;6_o:b/X<ol_;baCoc<c<3?o;bl/C
ol[:bPcobl_;6_o<c<`1olW9b@7o`<300OmcLg<00003og=cLono_kooc<c<
03ooc<c<6_o=cLd6olc<c0Kobl_;5?o:b/X<ol_;ba[oc<c<6Oo=cLd<olc<
c1Cobl_;1_o<c<`6ol_;baCoc<c<3?o;bl/Iol[:bS[obl_;1?o<c<`2olg=
c@;oc<c<1?o=cLdGolk>cPCocLg=F?o<c<`6ol_;b`Koc<c<6Oo;bl/Jol[:
bPcobl_;5?o<c<`<ol_;ba?ob/[:3?o;bl/Jolc<c07obLW90Oo0`<01og=c
L`0000?oLg=cokno_oo;bl/0?oo<c<`Jolg=c@Koc<c<1_o;bl/Dol[:bPco
bl_;6_o<c<`Iolg=c@coc<c<5?o;bl/6olc<c0Kobl_;5?o<c<`<ol_;baWo
b/[:>_o;bl/4olc<c0;ocLg=0_o<c<`4olg=cAOoc/k>1?o=cLeHolc<c0Ko
bl_;1_o<c<`Iol_;ba[ob/[:3?o;bl/Dolc<c0cobl_;4oo:b/X<ol_;ba[o
c<c<0Oo9bLT1okno_`7oLg=c00000omcLg?o_knool_;b`0oolc<c1[ocLg=
1_o<c<`6ol_;baCob/[:3?o;bl/Jolc<c1WocLg=3?o<c<`Dol_;b`Koc<c<
1_o;bl/Dolc<c0cobl_;6Oo:b/Xjol_;b`Coc<c<0_o=cLd2olc<c0CocLg=
5oo>c/h4olg=cESoc<c<1_o;bl/6olc<c1Wobl_;6_o:b/X<ol_;baCoc<c<
3?o;bl/Col[:bPcobl_;6_o<c<`1olW9b@7o_kno0OmcLg<00003og=cLono
_koob/[:03Wobl_;1_o<c<`6ol_;baCoc<c<3?o;bl/Jol[:bQ[obl_;1_o<
c<`5ol_;baCoc<c<1_o;bl/6olc<c3[obl_;7oo:b/Xjol_;b`coc<c<5?o=
cLd;olc<c7Wobl_;8?o:b/XPol_;baoob/[:8?o;bl/1olW9b@7o_kno0Omc
Lg<00003og=cLonn_[kobLW903oob/[:7_o;bl/4ol[:bQcobLW90_o:b/X2
olW9bAkob/[:7oo;bl/nol[:bP;obLW90_o:b/XKolW9b@;ob/[:0_o9bLTn
ol[:bQoobl_;OOo:b/X2olW9b@;ob/[:7?o9bLT2ol[:bP;obLW97?o:b/X2
olW9b@;ob/[:6oo9bLT2ol[:bP;obLW97_o:b/X1olW9b@7o_kno0OmcLg<0
0003og=cLonm_Kgob/[:03oob/[:7_o;bl/4ol[:bQcobLW90_o:b/X2olW9
bEgob/[:7_o;bl/4ol[:bUOobLW91?o:b/X2ol_;b`;ob/[:1?o;bl/Dolc<
c0_obl_;Moo:b/X2olW9b@;ob/[:7?o9bLT2ol[:bP;obLW9GOo:b/X1olS8
b07o_kno0OmbLW800003og=cLonl_;cobLW903gobLW90_o:b/X2olW9bAco
b/[:1?o9bLTNolS8b5gobLW90_o:b/X2olW9bAcob/[:1?o9bLUKolS8b0Co
bLW96oo:b/X2olW9b@;ob/[:OOo9bLTPolS8b5oobLW90Oo8b<P1okno_`7o
LW9b00000omcLg?o_;blolS8b00oolS8b23obLW9Goo8b<Q0olW9bEoob<S8
7oo9bLUPolS8b1oobLW9@?o8b<POolW9bB7ob<S80Ono_kl1og9bLP0000?o
Lg=cokbl_?o7alL0?oo8b<PPolW9bEoob<S8@?o9bLUOolS8b1oobLW9H?o8
b<POolW9bD3ob<S87oo9bLTQolS8b07o_[jn0OmbLW800003og=cLonl_;co
alO703oob<S88?o9bLUOolS8b43obLW9Goo8b<POolW9bF3ob<S87oo9bLU0
olS8b1oobLW98Oo8b<P1okjn_P7oLW9b00000omcLg?o_;blolO7a`0oolS8
b23obLW9Goo8b<Q0olW9bEoob<S87oo9bLUPolS8b1oobLW9@?o8b<POolW9
bB7ob<S80Onn_[h1og9bLP0000?oLg=cokbl_?o7alL0?oo8b<PPolW9bEoo
b<S8@?o9bLTlolS8b003okVi^Onk^k_ob<S800Gob<S800?o^KViok^k^oo8
b<P06?o8b<POolW9bF3ob<S87oo9bLU0olS8b1oobLW98Oo8b<P1okjn_P7o
LW9b00000omcLg?o^k^kolO7a`0folO7a`Wob<S82_o7alL/olS8b0[oalO7
2_o8b<P[olO7a`[ob<S82_o7alL/olS8b0[oalO72_o8b<PUolO7a`09obXZ
:_n0P83oalO7okRh^?mlO7co][JfolO7aonEUIGo0@4100;oalO700KoZZZZ
obTY:Ol:2P[o2@T9ob`/;?n[Zj/2olO7a`06ojZZZ_lY:BWo2PX:o`T92Ol/
;2coZj^[0_o7alL01_la<C7oHf=SolO7aoo7alOoOgmooaDE5@GoalO75?o8
b<P<olW9bA?ob<S8C?o7alL:olS8b0WoalO73?o8b<P:olO7a`[ob<S8;?o7
alL:olS8b0[oalO73?o8b<P9olO7a`[ob<S85oo7alL1okjn_P7oLW9b0000
0omcLg?o^k^kolO7a`0folO7a`Wob<S82_o7alL/olS8b0[oalO72_o8b<P[
olO7a`[ob<S82_o7alL/olS8b0[oalO72_o8b<PUolO7a`0=obXZ:_n0P83o
alO7ofi^K_l0003oIfMWolO7aonEUIGo0@41olO7aoo6a/Ko:2PXoclo?`02
okVi^@06od92@_lY:BWoa/K6olK6a_lX:2So?clo0_ni^KT01_m2@T;o:BTY
olK6a_o7alOo<C4aof=SH`;oalO700?oOgmooaDE5Oo7alL01?o7alLDolS8
b0cobLW94oo8b<Q<olO7a`[ob<S82Oo7alL<olS8b0[oalO72_o8b<P/olO7
a`[ob<S82_o7alL<olS8b0WoalO72_o8b<PGolO7a`7o_[jn0OmbLW800003
og=cLonj^[[oalO703KoalO72Oo8b<P:olO7abcob<S82_o7alL:olS8b2_o
alO72_o8b<P:olO7abcob<S82_o7alL:olS8b2GoalO700go:RXZoh20P?o7
alOo9bLWocLg=olN7QkoalO7oiFEUOl10@7oalO7ojRXZ?l0003oSXj>00;o
alO700KoSXj>o`000?n[Zj_oZ:RXo`000?n>SXh2olO7a`06ohj>S_l0003o
Zj^[olO7aola<C7oHf=S0_o7alL00omoOgoo5ADEolO7a`04olO7aaCob<S8
3?o9bLTColS8b4coalO72_o8b<P9olO7a`cob<S82_o7alL:olS8b2coalO7
2_o8b<P:olO7a`cob<S82Oo7alL:olS8b1OoalO70Onm_Kd1og9bLP0000?o
Lg=cokVi^Oo6a/H0=_o7alL9olS8b0[oalO7;?o8b<P:olO7a`[ob<S8:oo7
alL:olS8b0[oalO7;?o8b<PDolO7abGoa/K600go:BTYoh20P?nVYZKo0000
ojBTY?lP823oVi^KoiBDU?l10@7oa/K6oi>CTol0003o/[:b00;oa/K600Ko
/K6ao`000?nEUIGoTi>Co`000?nb/[82olK6aP06ok6a/Ol0003oUIFEolK6
a_la<C7oHV9R0_o6a/H00omnOWko5ADEolK6aP04olK6aP[oalO72_o8b<P<
olW9b@Wob<S82_o7alLfolK6aSooalO78?o6a/HFolO7a`[ob<S82_o7alL<
olS8b0WoalO72_o8b<PGolO7a`7o^k^k0OmbLW800003og9bL_nj^[[oa/K6
03KoalO72Oo8b<P:olO7abcob<S82_o7alL:olS8b7GoalO7;oo6a/H03OlY
:BWoP820of1PH?lU9BGoa/K6ofYZJ_mADE7oU9BDo`410Oo6a/KoZZZZo`00
0?n;Rh/00_o6a/H01_n:RX[o0000ojj^[_n[Zj_o0000ohb<S0;oalO700Ko
RXZ:o`000?n^[ZkoalO7oc4a<Om8B4P2olO7a`03ogYjN_lF5QKoalO700Co
alO72_o8b<P:olO7a`cob<S82Oo7alL:olS8b2coalO72_o8b<P:olO7a`co
b<S84oo7alLFolK6aUKoalO72Oo8b<P:olO7aaOob<S80Onk^k/1og9bLP00
00?oLW9bokVi^Oo5aLD0=_o7alL9olS8b0[oalO7;?o8b<P:olO7a`[ob<S8
Loo7alL4olK6aRgoaLG500Wo:BTYoginO_lH61SoJf][olG5aOn`/;3o3`l?
ohj>S_l10@400_o5aLD03_lb<S;o=cLgoj^[Zon[Zj_o=cLgoc@d=?o5aLGo
a/K6oc8b<_lg=cOo[:b/oj^[Zolg=cOo=3@d0_o6a/H01_la<C7o3`l?oe]K
Fon/[:co@d=3oc/k>`Goa/K65?o7alL<olS8b1?oalO7;?o6a/HDolO7a`co
b<S82?o7alL2olK6aP;oalO71oo6a/HDolG5a@;oa/K60_o5aLDNolK6aSKo
alO72Oo8b<P:olO7aaOob<S80Oni^KT1og9bLP0000?oLW9bokRh^?o5aLD0
=_o7alL9olS8b0[oalO7;?o8b<P:olO7a`[ob<S8Loo7alL4olK6aRgoaLG5
00Co:BTYoe5ADOl10@7o/;2`0_o5aLD00olf=SKoDe=Co`410@02olG5a@0:
ok>c/olo?coo2`/;o`/;2om1@D7o];BdolG5aOo6a/Ko];Bdoclo?`;o2`/;
00[o@D51okBd]?o6a/Koa/K6od51@Om/K6coGEeMo`l?3olS8b?oV9RH1Oo6
a/HDolO7a`cob<S84oo7alL/olK6aQCoalO73?o8b<P8olO7a`;oa/K60_o7
alL7olK6aQCoaLG50_o6a/H2olG5aAkoa/K6=_o7alL9olS8b0[oalO75oo8
b<P1okRh^07oLW9b00000ombLW;o]kNgolG5a@0oolK6aQKoalO72_o8b<P:
olO7a`cob<S85?o7alMcolK6aPCoaLG5;Oo4a<@00olY:BWo3`l?oc<c<`03
olC4a003oginO_l>3Pko0@4100Coa<C40_o3`l<00oo4a<CoaLG5olG5a@03
olG5a@;oa<C41oo5aLD00oo4a<CoaLG5olG5a@05olG5a@Soa/K60_o7alL2
olK6aPSoalO73?o8b<P7olO7a`;oa/K60_o7alL8olK6aSCoaLG51?o6a/HL
olO7a`;oa/K60_o5aLDMolC4a1koaLG50_o6a/H2olG5aCgoa/K68Oo7alL1
okRh^07oLW9b00000ombLW;o]kNgolG5a@0oolK6aQKoalO72_o8b<P:olO7
a`cob<S85?o7alMcolK6aPCoaLG5;Oo4a<@00olY:BWo0000ogUiN@03olC4
a003okbl_?l92@Wo0@4100Ooa<C45_o5aLD8olK6aP;oalO70_o6a/H8olO7
a`cob<S81oo7alL2olK6aP;oalO72?o6a/HdolG5a@Coa/K67?o7alL2olK6
aP;oaLG57Oo4a<@NolG5a@;oa/K60_o5aLDmolK6aR7oalO70Onh^;P1og9b
LP0000?oLW9bokNg]oo5aLD0?oo6a/HFolO7a`[ob<S82_o7alL<olS8b1Co
alO7Loo6a/H4olG5aBgoa<C400?oQhN7ogIfM_nj^[X01?o4a<@00on;Rh_o
MgMgolC4a006olC4a1KoaLG52?o6a/H2olO7a`;oa/K62?o7alL<olS8b0Oo
alO70_o6a/H2olO7a`Soa/K6=?o5aLD4olK6aQcoalO70_o6a/H2olG5aAgo
a<C47_o5aLD2olK6aP;oaLG5?Oo6a/HQolO7a`7o^;Rh0OmbLW800003og9b
L_ng]kOoaLG503ooa/K65_o7alL:olS8b0[oalO73?o8b<PDolO7ag?oa/K6
1?o5aLDmolC4a1KoaLG52?o6a/H2olO7a`;oa/K62?o7alL<olS8b0OoalO7
0_o6a/H2olO7a`Soa/K6=?o5aLD4olK6aQcoalO70_o6a/H2olG5aAgoa<C4
7_o5aLD2olK6aP;oaLG5?Oo6a/HQolO7a`7o^;Rh0OmbLW800003og9bL_ng
]kOoaLG503ooa/K65_o7alL:olS8b0[oalO73?o8b<PDolO7ag?oa/K61?o5
aLDmolC4a1KoaLG52?o6a/H2olO7a`;oa/K62?o7alL<olS8b0OoalO70_o6
a/H2olO7a`Soa/K6=?o5aLD4olK6aQcoalO70_o6a/H2olG5aAgoa<C47_o5
aLD2olK6aP;oaLG5?Oo6a/HQolO7a`7o^;Rh0OmbLW800003og9bL_ng]kOo
aLG503ooa/K6@?o7alMmolK6aPCoaLG5?Oo4a<@NolG5a@Coa/K66oo7alL4
olK6aScoaLG51?o6a/HLolO7a`;oa/K60_o5aLDMolC4a1koaLG50_o6a/H2
olG5aCgoa/K68Oo7alL1okNg]`7oLW9b00000ombLW;o]kNgolC4a00NolG5
a@;oa/K60_o5aLEKolK6aP;oaLG50_o6a/HkolG5a@;oa/K60_o5aLDholK6
aPCoaLG50_o4a<@2olG5a@Coa<C4<oo3`l<6olC4a0Ko`l?36?o4a<@4olG5
aA_oa/K60_o5aLD2olK6aQkoaLG57_o4a<@4olG5aAcoa/K61?o5aLDkolC4
a0CoaLG57?o6a/H2olG5a@;oa/K66oo5aLD2olK6aP;oaLG57oo6a/H1okNg
]`7oLW9b00000ombLW;o]kNgolC4a00Jol?3``coa<C4FOo5aLDoolC4a3[o
aLG53?o4a<@col?3``Koa<C41_o3`l<JolC4a3ooaLG58?o4a<@PolG5aCoo
a<C48?o5aLDOolC4a27oaLG50Onf][H1og9bLP0000?oLW9bokJf]_o3`l<0
8?o4a<@molG5a@;oa/K60_o5aLDLolK6aP;oaLG50_o6a/ImolG5aEgoa<C4
1?o5aLDKolK6aPCoaLG5WOo4a<AOolG5a@7oa<C40Ong]kL1og9bLP0000?o
LW9bokJf]_o3`l<06_o2`/8<ol?3`cWoa<C48?o5aLGNolC4a1ooaLG5>_o4
a<@6ol?3``Koa<C45?o3`l<6olC4a0Ko`l?3V?o4a<@1ol?3``7o][Jf0Omb
LW800003og9bL_nf][Ko`/;201[o`L711?o2`/82ol?3``;o`/;21?o3`l<C
olC4a0Ko`l?31_o4a<@Dol?3``Koa<C41_o3`l<DolC4a0Ko`l?31_o4a<@c
ol?3``Koa<C41_o3`l<dolC4a0Ko`l?31_o4a<ACol?3``Koa<C41_o3`l<c
olC4a0Ko`l?31_o4a<@Jol?3`a[o`/;23?o3`l<ColC4a0Ko`l?31_o4a<@D
ol?3``Koa<C41_o3`l<DolC4a0Ko`l?31_o4a<@iol?3``7o`/;20Onf][H1
og9bLP0000?oLW9bokJf]_o2`/806_o1`L44ol;2`P;o`l?30_o2`/84ol?3
`a?oa<C41_o3`l<6olC4a1Co`l?31_o4a<@6ol?3`aCoa<C41_o3`l<6olC4
a3?o`l?31_o4a<@6ol?3`cCoa<C41_o3`l<6olC4a5?o`l?31_o4a<@6ol?3
`c?oa<C41_o3`l<6olC4a1[o`l?36_o2`/8<ol?3`a?oa<C41_o3`l<6olC4
a1Co`l?31_o4a<@6ol?3`aCoa<C41_o3`l<6olC4a3Wo`l?30Oo2`/81okJf
]P7oLW9b00000ombLW;o][Jfol;2`P0Jol71`@Co`/;20_o3`l<2ol;2`PCo
`l?34oo4a<@6ol?3``Koa<C4Loo3`l<6olC4a0Ko`l?3=?o4a<@6ol?3``Ko
a<C4Loo3`l<5olC4a0Ko`l?35?o4a<@6ol?3``Koa<C46_o3`l<Jol;2`Pco
`l?34oo4a<@6ol?3``Koa<C45?o3`l<6olC4a0Ko`l?35?o4a<@6ol?3``Ko
a<C4>Oo3`l<1ol;2`P7o]KFe0OmbLW800003og9bL_nf][Ko`/;201[o`L71
1?o2`/82ol?3``;o`/;21?o3`l<ColC4a0Ko`l?31_o4a<Acol?3``Koa<C4
1_o3`l<dolC4a0Ko`l?31_o4a<Acol?3``Goa<C41_o3`l<DolC4a0Ko`l?3
1_o4a<@Jol?3`a[o`/;23?o3`l<ColC4a0Ko`l?31_o4a<@Dol?3``Koa<C4
1_o3`l<DolC4a0Ko`l?31_o4a<@iol?3``7o`/;20One]KD1og9bLP0000?o
LW9bokJf]_o2`/806_o1`L44ol;2`P;o`l?30_o2`/84ol?3`a?oa<C41_o3
`l<6olC4a7?o`l?31_o4a<@6ol?3`cCoa<C41_o3`l<6olC4a7?o`l?31Oo4
a<@6ol?3`aCoa<C41_o3`l<6olC4a1[o`l?36_o2`/8<ol?3`a?oa<C41_o3
`l<6olC4a1Co`l?31_o4a<@6ol?3`aCoa<C41_o3`l<6olC4a3Wo`l?30Oo2
`/81okFe]@7oLW9b00000ombLW;o][Jfol;2`P0Jol71`@Co`/;20_o3`l<2
ol;2`PCo`l?34oo4a<@6ol?3``Koa<C4Loo3`l<6olC4a0Ko`l?3=?o4a<@6
ol?3``Koa<C4Loo3`l<5olC4a0Ko`l?35?o4a<@6ol?3``Koa<C46_o3`l<J
ol;2`Pco`l?34oo4a<@6ol?3``Koa<C45?o3`l<6olC4a0Ko`l?35?o4a<@6
ol?3``Koa<C4>Oo3`l<1ol;2`P7o]KFe0OmbLW800003og9bL_nf][Ko`/;2
01[o`L711?o2`/82ol?3``;o`/;21?o3`l<ColC4a0Ko`l?31_o4a<Acol?3
``Koa<C41_o3`l<dolC4a0Ko`l?31_o4a<Acol?3``Goa<C41_o3`l<DolC4
a0Ko`l?31_o4a<@Jol?3`a[o`/;23?o3`l<ColC4a0Ko`l?31_o4a<@Dol?3
``Koa<C41_o3`l<DolC4a0Ko`l?31_o4a<@iol?3``7o`/;20One]KD1og9b
LP0000?oLW9bokFe]Oo2`/807_o1`L44ol;2`_oo`l?3Voo3`l<Pol;2`Yko
`l?30Oo2`/81okFe]@7oLW9b00000ombLW;o]KFeol;2`P0Nol71`@Co`/;2
ooo3`l>Kol?3`b3o`/;2W_o3`l<1ol;2`P7o]KFe0OmbLW800003og9bL_ne
]KGo`/;201ko`L711?o2`/8Mol?3`eko`/;20_o1`L42ol;2`Q_o`L711?o2
`/8nol?3`cgo`/;20_o1`L42ol;2`Qco`L710_o2`/82ol71`Ago`/;28?o3
`l=0ol;2`Qoo`l?3Ooo2`/81ol71`@7o];Bd0OmbLW800003og9bL_nd];Co
`L7101ko`L711?o2`/8Mol?3`cko`/;20_o1`L42ol;2`Qko`L717Oo0`<04
ol71`Cco`/;20_o1`L42ol;2`Q_o`L710_o2`/82ol71`Aco`/;21?o1`L4L
ol30`0Co`L717Oo2`/8Pol?3`ggo`/;20_o1`L42ol;2`Qco`L710_o2`/82
ol71`Cgo`/;20Oo0`<01okBd]07oLW9b00000ombLW;o/k>col71`@0Nol71
`@;o`/;20_o1`L5Kol;2`P;o`L710_o2`/8Nol71`Aoo`<30GOo1`L42ol;2
`P;o`L717?o2`/84ol71`Aco`<301?o1`L5kol;2`P;o`L710_o2`/8Kol71
`@;o`/;20_o1`L4Lol;2`PCo`L717?o0`<04ol71`Cgo`/;20Oo0`<01okBd
]07oLW9b00000ombLW;o/k>col71`@0Nol71`@;o`/;20_o1`L5Kol;2`P;o
`L710_o2`/8Nol71`Aoo`<30GOo1`L42ol;2`P;o`L717?o2`/84ol71`Aco
`<301?o1`L5kol;2`P;o`L710_o2`/8Kol71`@;o`/;20_o1`L4Lol;2`PCo
`L717?o0`<04ol71`Cgo`/;20Oo0`<01okBd]07oLW9b00000ombLW;o/k>c
ol71`@0Nol71`@;o`/;20_o1`L5Kol;2`P;o`L710_o2`/8Nol71`Aoo`<30
GOo1`L42ol;2`P;o`L717?o2`/84ol71`Aco`<301?o1`L5kol;2`P;o`L71
0_o2`/8Kol71`@;o`/;20_o1`L4Lol;2`PCo`L717?o0`<04ol71`Cgo`/;2
0Oo0`<01okBd]07oLW9b00000ombLW;o/k>col71`@0Nol71`@;o`/;20_o1
`L5Kol;2`P;o`L710_o2`/8Nol71`Aoo`<30GOo1`L42ol;2`P;o`L717?o2
`/84ol71`Aco`<301?o1`L5kol;2`P;o`L710_o2`/8Kol71`@;o`/;20_o1
`L4Lol;2`PCo`L717?o0`<04ol71`Cgo`/;20Oo0`<01okBd]07oLW9b0000
0ombLW;o/k>col71`@0Nol71`@;o`/;20_o1`L5Kol;2`P;o`L710_o2`/8N
ol71`Aoo`<30GOo1`L42ol;2`P;o`L717?o2`/84ol71`Aco`<301?o1`L5k
ol;2`P;o`L710_o2`/8Kol71`@;o`/;20_o1`L4Lol;2`PCo`L717?o0`<04
ol71`Cgo`/;20Oo0`<01okBd]07oLW9b00000ombLW;o/k>col71`@0Nol71
`@;o`/;20_o1`L5Kol;2`P;o`L710_o2`/8Nol71`Aoo`<30GOo1`L42ol;2
`P;o`L717?o2`/84ol71`Aco`<301?o1`L5kol;2`P;o`L710_o2`/8Kol71
`@;o`/;20_o1`L4Lol;2`PCo`L717?o0`<04ol71`Cgo`/;20Oo0`<01okBd
]07oLW9b00000ombLW;o/k>col30`00Pol30`5oo`L715_o0`<0:okno_`Wo
`<303?no_kl:ol30`0[o_knoEOo0`<0Fol71`ACo`<303?no_klDol30`3?o
`L710_o2`/82ol71`Cco`/;21?o1`L4Mol30`23o`L718?o0`<0ool71`@7o
_kno0Ond];@1og9bLP0000?oLW9bok>c/oo0`<008?o0`<1Ool71`AKo`<30
2_no_kl9ol30`0co_kno2_o0`<0:okno_eGo`<305_o1`L4Dol30`0co_kno
5?o0`<0col71`@;o`/;20_o1`L4lol;2`PCo`L717Oo0`<0Pol71`B3o`<30
?oo1`L41okno_`7o/k>c0OmbLW800003og9bL_nc/k?o`<30023o`<30Goo1
`L4Fol30`0[o_kno2Oo0`<0<okno_`[o`<302_no_kmEol30`1Ko`L715?o0
`<0<okno_aCo`<30<oo1`L42ol;2`P;o`L71??o2`/84ol71`Ago`<308?o1
`L4Pol30`3oo`L710Ono_kl1ok>c/`7oLW9b00000ombLW;o/K6aokno_`2d
ol30`0[o_kno2_o0`<1;okno_aCo`<305_o1`L4Pol30`5go`L710_o2`/82
ol71`ACo`/;22?o1`L42ol30`0;o`L711oo0`<0<okno_aCo`<305_o1`L4o
ol30`23o`L710Oo0`<01ok>c/`7oLW9b00000omaLG7o/;2`okjn_P0Fol30
`1Co_kno5Onn_[hfokno_`[o`<302_no_kl[ol30`0[o_kno2_o0`<1;okno
_`[o`<302_no_knEol30`1Ko`L712_o0`<09okno_`co_[jn5?no_kl/ol30
`0[o_kno2_o0`<0<okno_`Wo`<302_no_klGol30`07o/[:b0OmaLG400003
og5aLOn`/;3o_[jn01Ko`<305?no_klEokjn_SKo_kno2_o0`<0:okno_b_o
`<302_no_kl:ol30`4_o_kno2_o0`<0:okno_iGo`<305_o1`L4:ol30`0Wo
_kno3?nn_[hDokno_bco`<302_no_kl:ol30`0co_kno2Oo0`<0:okno_aOo
`<300Onb/[81og5aL@0000?oLG5aok2`/?nn_[h05_o0`<0Dokno_aGo_[jn
=_no_kl:ol30`0[o_kno:oo0`<0:okno_`[o`<30Bono_kl:ol30`0[o_kno
UOo0`<0Fol71`@[o`<302Ono_kl<okjn_QCo_kno;?o0`<0:okno_`[o`<30
3?no_kl9ol30`0[o_kno5oo0`<01ok6a/@7oLG5a00000omaLG7o/;2`okfm
_@0Nokno_`Co_[jn6onm_Kd2okjn_P;o_Kfm?_nn_[hookno_eoo_[jnMOno
_kl:ol30`0[o_kno5_o0`<0Fol71`@So`<301?no_kl7okjn_QCo_Kfm1?nn
_[hDokno_`[o`<302_no_kl<ol30`1Co_kno5Onn_[hQokno_`7o/K6a0Oma
LG400003og5aLOn`/;3o_Kfm01ko_kno1?nn_[hKokfm_@;o_[jn0_nm_Kdn
okjn_Soo_knoGonn_[ieokno_`[o`<302_no_klFol30`1Ko`L712?o0`<04
okno_`Oo_[jn5?nm_Kd4okjn_QCo_kno2_o0`<0:okno_`co`<305?no_klE
okjn_R7o_kno0Ona/K41og5aL@0000?oLG5aok2`/?nm_Kd07_no_kl4okjn
_Q_o_Kfm0_nn_[h2okfm_Cko_[jn?ono_kmOokjn_WGo_kno2_o0`<0:okno
_aKo`<305_o1`L48ol30`0Co_kno1onn_[hDokfm_@Co_[jn5?no_kl:ol30
`0[o_kno3?o0`<0Dokno_aGo_[jn8Ono_kl1ok6a/@7oLG5a00000omaLG7o
/;2`okfm_@0Nokno_`Co_[jn6onm_Kd2okjn_P;o_Kfm?_nn_[hookno_eoo
_[jnMOno_kl:ol30`0[o_kno5_o0`<0Fol71`@So`<301?no_kl7okjn_QCo
_Kfm1?nn_[hDokno_`[o`<302_no_kl<ol30`1Co_kno5Onn_[hQokno_`7o
/K6a0OmaLG400003og5aLOn_[joo_Kfm01ko_kno1?nn_[hKokfm_@;o_[jn
0_nm_Kdnokjn_Soo_knoGonn_[jEokno_`[o`<302_no_kl<ol30`0So_kno
0_nn_[h2okno_`Oo_[jn5?nm_Kd4okjn_Sko_kno7onn_[hQokno_`7o/;2`
0OmaLG400003og5aLOn_[joo_Kfm01ko_kno1?nn_[hKokfm_@;o_[jn0_nm
_Kdnokjn_Soo_knoGonn_[jEokno_`[o`<302_no_kl<ol30`0So_kno0_nn
_[h2okno_`Oo_[jn5?nm_Kd4okjn_Sko_kno7onn_[hQokno_`7o/;2`0Oma
LG400003og5aLOn_[joo_Kfm01ko_kno0_nn_[h2okfm_Ago_;bl?_nm_Kd2
okjn_P;o_Kfm>onn_[h2okfm_@;o_[jnFonm_Kd2okjn_P;o_Kfm?_nn_[hO
okno_d3o_[jn7_no_kl4okjn_Q_o_Kfm0_nn_[h2okfm_Ako_[jn8?no_km0
okjn_P7o/;2`0OmaLG400003og5aLOn^[Zko_Kfm01ko_[jn1?nm_KeMokbl
_3oo_KfmGonl_;`nokfm_@;o_[jn0_nm_KdKokjn_P;o_Kfm0_nn_[hlokfm
_@;o_[jn0_nm_KdLokjn_P;o_Kfm0_nn_[hkokfm_@;o_[jn0_nm_KdLokjn
_P;o_Kfm0_nn_[hnokfm_@7o[jn_0OmaLG400003og5aLOn][Jgo_Kfm07Wo
_;bl1_nk^k/6okbl_1Co^k^k1_nl_;`5ok^k^oSo_;bl@?nm_Kdookbl_23o
_Kfm@?nl_;`1ojf][@7oLG5a00000omaLG7o[Jf]okfm_@1iokbl_0Ko^k^k
1_nl_;`Dok^k^`Ko_;bl1Onk^k_hokbl_43o_Kfm?onl_;`Pokfm_D3o_;bl
0On][Jd1og5aL@0000?oLG5aojf][Onm_Kd06_nl_;`6ok^k^`Ko_;blFOnk
^k/PokZj^[So^k^k1_nl_;`6ok^k^aCo_;bl1Onk^k/6okbl_1Co^k^k1_nl
_;`6ok^k^e?o_;bl1_nk^k/6okbl_1Co^k^k3?nl_;`Jokfm_AWo_;bl1_nk
^k/6okbl_1_o^k^k0On][Jd1og5aL@0000?oLG5aojb/[?nm_Kd06_nl_;`6
ok^k^`Ko_;blFOnk^k/PokZj^[So^k^k1_nl_;`6ok^k^aCo_;bl1Onk^k/6
okbl_5Co^k^k1_nl_;`6ok^k^a?o_;bl1_nk^k/6okbl_1Co^k^k1_nl_;`6
ok^k^c?o_;bl1_nk^k/6okbl_1_o^k^k0On/[:`1og5aL@0000?oLG5aojb/
[?nm_Kd06_nl_;`6ok^k^`Ko_;blFOnk^k/PokZj^[So^k^k1_nl_;`6ok^k
^aCo_;bl1Onk^k/6okbl_5Co^k^k1_nl_;`6ok^k^a?o_;bl1_nk^k/6okbl
_1Co^k^k1_nl_;`6ok^k^c?o_;bl1_nk^k/6okbl_1_o^k^k0On/[:`1og5a
L@0000?oLG5aojb/[?nm_Kd06_nl_;`6ok^k^`Ko_;blFOnk^k/PokZj^[So
^k^k1_nl_;`6ok^k^aCo_;bl1Onk^k/6okbl_5Co^k^k1_nl_;`6ok^k^a?o
_;bl1_nk^k/6okbl_1Co^k^k1_nl_;`6ok^k^c?o_;bl1_nk^k/6okbl_1_o
^k^k0On/[:`1og5aL@0000?oLG5aojb/[?nm_Kd06_nl_;`6ok^k^`Ko_;bl
FOnk^k/PokZj^[So^k^k1_nl_;`6ok^k^aCo_;bl1Onk^k/6okbl_5Co^k^k
1_nl_;`6ok^k^a?o_;bl1_nk^k/6okbl_1Co^k^k1_nl_;`6ok^k^c?o_;bl
1_nk^k/6okbl_1_o^k^k0On/[:`1og5aL@0000?oLG5aoj^[Zonl_;`08?nk
^k]MokZj^P;o^KVi0_nj^[XLokVi^@;o^[Zj0_ni^KTmokZj^WWo^k^k1_nl
_;`6ok^k^aCo_;bl2onk^k/JokZj^Uoo^k^k8?nj^[YOok^k^`7o^[Zj0On/
[:`1og5aL@0000?oLG5aoj^[Zonl_;`08?nk^k]MokZj^P;o^KVi0_nj^[XL
okVi^@;o^[Zj0_ni^KTmokZj^WWo^k^k1_nl_;`6ok^k^aCo_;bl2onk^k/J
okZj^Uoo^k^k8?nj^[YOok^k^`7o^[Zj0On/[:`1og5aL@0000?oLG5aojZZ
Z_nk^k/0OOnj^[X2okVi^@;o^[Zj7?ni^KT2okZj^P;o^KVi?Onj^[ZNok^k
^b3o^[Zj@?nk^k]nokZj^R3o^k^k0Onj^[X1oj^[Z`7oLG5a00000omaLG7o
Z:RXokZj^P1ookVi^B3o^;Rh?Oni^KT2okZj^P;o^KViV_nj^[X2okVi^@;o
^[Zj7?ni^KT2okZj^P;o^KVi??nj^[X2okVi^@;o^[Zj?Oni^KTPokRh^1go
^KVi0_nj^[X2okVi^Ako^[Zj0Oni^KT1ojZZZP7oLG5a00000om`L73oZJVY
okVi^@2OokVi^Aoo^;RhWOni^KT2okZj^P;o^KVi6onj^[X2okVi^@;o^[Zj
7?ni^KT2okZj^P;o^KVi7?nj^[X2okVi^@;o^[Zj7?ni^KT2okZj^P;o^KVi
6onj^[X2okVi^@;o^[ZjFoni^KT2okZj^P;o^KVi7_nj^[X1okRh^07oZZZZ
0Om`L7000003og1`L?nWYjOo^;Rh09Go^;Rh2_ng]kL9okRh^0co]kNg2_nh
^;P:okNg]iGo^;Rh7oni^KTPokRh^23o^KVi8?nh^;POokVi^AKo^;Rh2_ng
]kL:okRh^0co]kNg2_nh^;P:okNg]aGo^;Rh8?ni^KT1okNg]`7oZJVY0Om`
L7000003og1`L?nVYZKo]kNg01Ko]kNg2_nh^;P:okNg]f_o^;Rh2_ng]kL9
okRh^0co]kNg2_nh^;P:okNg]mCo^;Rh8?ni^KUEokRh^1Co]kNg5_nf][HF
okNg]a?o^;Rh5_ni^KT1okNg]`7oZ:RX0Om`L7000003og1`L?nUYJGo][Jf
023o][JfOong]kLOokJf]QKo]kNg2_nh^;P:okNg]h_o^;Rh2Ong]kL:okRh
^0co]kNg5?nh^;PFokVi^AKo^;Rh2_ng]kL9okRh^3Co]kNg1?nf][HLokFe
]@;o][Jf0_ne]KDDokJf]PWo]kNg2_nh^;PFokVi^@7o][Jf0OnXZ:P1og1`
L00000?oL71`ojFUYOnf][H08?nf][IookNg]aoo][Jf5_ng]kL:okRh^0[o
]kNgRonh^;P9okNg]`[o^;Rh3?ng]kLDokRh^1Ko^KVi5_nh^;P:okNg]`Wo
^;Rh=?ng]kL4okJf]Qco]KFe0_nf][H2okFe]ACo][Jf2Ong]kL:okRh^1Ko
^KVi0Onf][H1ojRXZ07oL71`00000om`L73oYJFUokJf]P0PokJf]Woo]kNg
7onf][HFokNg]`[o^;Rh2_ng]kN;okRh^0Wo]kNg2_nh^;P<okNg]aCo^;Rh
5_ni^KTFokRh^0[o]kNg2Onh^;PdokNg]`Co][Jf7?ne]KD2okJf]P;o]KFe
5?nf][H9okNg]`[o^;Rh5_ni^KT1okJf]P7oZ:RX0Om`L7000003og1`L?nU
YJGo][Jf023o][JfOong]kLOokJf]QKo]kNg2_nh^;P:okNg]h_o^;Rh2Ong
]kL:okRh^0co]kNg5?nh^;PFokVi^AKo^;Rh2_ng]kL9okRh^3Co]kNg1?nf
][HLokFe]@;o][Jf0_ne]KDDokJf]PWo]kNg2_nh^;PFokVi^@7o][Jf0OnX
Z:P1og1`L00000?oL71`ojFUYOnf][H08?nf][IookNg]aoo][Jf5_ng]kL:
okRh^0[o]kNgRonh^;P9okNg]`[o^;Rh3?ng]kLDokRh^1Ko^KVi5_nh^;P:
okNg]`Wo^;Rh=?ng]kL4okJf]Qco]KFe0_nf][H2okFe]ACo][Jf2Ong]kL:
okRh^1Ko^KVi0Onf][H1ojRXZ07oL71`00000om`L73oYJFUokJf]P0PokJf
]Woo]kNg7onf][HFokNg]`[o^;Rh2_ng]kN;okRh^0Wo]kNg2_nh^;P<okNg
]aCo^;Rh5_ni^KTFokRh^0[o]kNg2Onh^;PdokNg]`Co][Jf7?ne]KD2okJf
]P;o]KFe5?nf][H9okNg]`[o^;Rh5_ni^KT1okJf]P7oZ:RX0Om`L7000003
og1`L?nUYJGo][Jf023o][JfOong]kLOokJf]QKo]kNg2_nh^;P:okNg]h_o
^;Rh2Ong]kL:okRh^0co]kNg5?nh^;PFokVi^AKo^;Rh2_ng]kL9okRh^3Co
]kNg1?nf][HLokFe]@;o][Jf0_ne]KDDokJf]PWo]kNg2_nh^;PFokVi^@7o
][Jf0OnXZ:P1og1`L00000?oL71`ojFUYOnf][H08?nf][IookNg]aoo][Jf
5_ng]kL:okRh^0[o]kNgRonh^;P9okNg]`[o^;Rh3?ng]kLDokRh^1Ko^KVi
5_nh^;P:okNg]`Wo^;Rh=?ng]kL4okJf]Qco]KFe0_nf][H2okFe]ACo][Jf
2Ong]kL:okRh^1Ko^KVi0Onf][H1ojRXZ07oL71`00000om_KfooXJ6Qok:b
/P04ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o
/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd
]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb/[800ona/K7o/k>cok:b/P05
ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c
0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd]0;o
/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b
/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb
/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b
00Co/k>cok:b/_nb/[;o/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04
ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb/[80
0ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co
/k>cok:b/_nb/[;o/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c
/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb/[800ona
/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>c
ok:b/_nb/[;o/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb
/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb/[800ona/K7o
/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b
/_nb/[;o/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o
/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb/[800ona/K7o/k>c
ok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb
/[;o/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:b
okBd]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb/[800ona/K7o/k>cok:b
/P05ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o
/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd
]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb/[800ona/K7o/k>cok:b/P05
ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c
0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd]0;o
/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b
/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb
/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b
00Co/k>cok:b/_nb/[;o/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04
ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb/[80
0ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co
/k>cok:b/_nb/[;o/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c
/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb/[800ona
/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>c
ok:b/_nb/[;o/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb
/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb/[800ona/K7o
/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b
/_nb/[;o/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o
/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb/[800ona/K7o/k>c
ok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb
/[;o/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:b
okBd]0;o/[:b00Co/k>cok:b/_nb/[;o/k>c0_nb/[800ona/K7o/k>cok:b
/P05ok:b/P04ok>c/onb/[;o/[:bokBd]0;o/[:b00Co/k>cok:b/_nb/[;o
/k>c0_nb/[800ona/K7o/k>cok:b/P05ok:b/P04ok>c/onb/[;o/[:bokBd
]0;o/[:b00Ko/k>cok:b/_nb/[;o/k>cok6a/OnQXJ41ofm_K`0000CoKVi^
oiZJV_n_[joo[Zj^0_n_[jl00on^[Zko[jn_ojj^[P04ojj^[PCo[jn_0_n^
[Zh01On/[:co/;2`ojj^[_n_[joo[Zj^00;o[jn_00?o[Zj^ojn_[on^[Zh0
1?n^[Zh4ojn_[`;o[Zj^00Go[:b/ok2`/?n^[Zko[jn_ojj^[P02ojn_[`03
ojj^[_n_[joo[Zj^00Co[Zj^1?n_[jl2ojj^[P05ojb/[?n`/;3o[Zj^ojn_
[on^[Zh00_n_[jl00on^[Zko[jn_ojj^[P04ojj^[PCo[jn_0_n^[Zh01On/
[:co/;2`ojj^[_n_[joo[Zj^00;o[jn_00?o[Zj^ojn_[on^[Zh01?n^[Zh4
ojn_[`;o[Zj^00Go[:b/ok2`/?n^[Zko[jn_ojj^[P02ojn_[`03ojj^[_n_
[joo[Zj^00Co[Zj^1?n_[jl2ojj^[P05ojb/[?n`/;3o[Zj^ojn_[on^[Zh0
0_n_[jl00on^[Zko[jn_ojj^[P04ojj^[PCo[jn_0_n^[Zh01On/[:co/;2`
ojj^[_n_[joo[Zj^00;o[jn_00?o[Zj^ojn_[on^[Zh01?n^[Zh4ojn_[`;o
[Zj^00Go[:b/ok2`/?n^[Zko[jn_ojj^[P02ojn_[`03ojj^[_n_[joo[Zj^
00Co[Zj^1?n_[jl2ojj^[P05ojb/[?n`/;3o[Zj^ojn_[on^[Zh00_n_[jl0
0on^[Zko[jn_ojj^[P04ojj^[PCo[jn_0_n^[Zh01On/[:co/;2`ojj^[_n_
[joo[Zj^00;o[jn_00?o[Zj^ojn_[on^[Zh01?n^[Zh4ojn_[`;o[Zj^00Go
[:b/ok2`/?n^[Zko[jn_ojj^[P02ojn_[`03ojj^[_n_[joo[Zj^00Co[Zj^
1?n_[jl2ojj^[P05ojb/[?n`/;3o[Zj^ojn_[on^[Zh00_n_[jl00on^[Zko
[jn_ojj^[P04ojj^[PCo[jn_0_n^[Zh01On/[:co/;2`ojj^[_n_[joo[Zj^
00;o[jn_00?o[Zj^ojn_[on^[Zh01?n^[Zh4ojn_[`;o[Zj^00Go[:b/ok2`
/?n^[Zko[jn_ojj^[P02ojn_[`03ojj^[_n_[joo[Zj^00Co[Zj^1?n_[jl2
ojj^[P05ojb/[?n`/;3o[Zj^ojn_[on^[Zh00_n_[jl00on^[Zko[jn_ojj^
[P04ojj^[PCo[jn_0_n^[Zh01On/[:co/;2`ojj^[_n_[joo[Zj^00;o[jn_
00?o[Zj^ojn_[on^[Zh01?n^[Zh4ojn_[`;o[Zj^00Go[:b/ok2`/?n^[Zko
[jn_ojj^[P02ojn_[`03ojj^[_n_[joo[Zj^00Co[Zj^1?n_[jl2ojj^[P05
ojb/[?n`/;3o[Zj^ojn_[on^[Zh00_n_[jl00on^[Zko[jn_ojj^[P04ojj^
[PCo[jn_0_n^[Zh01On/[:co/;2`ojj^[_n_[joo[Zj^00;o[jn_00?o[Zj^
ojn_[on^[Zh01?n^[Zh4ojn_[`;o[Zj^00Go[:b/ok2`/?n^[Zko[jn_ojj^
[P02ojn_[`03ojj^[_n_[joo[Zj^00Co[Zj^1?n_[jl2ojj^[P05ojb/[?n`
/;3o[Zj^ojn_[on^[Zh00_n_[jl00on^[Zko[jn_ojj^[P04ojj^[PCo[jn_
0_n^[Zh01On/[:co/;2`ojj^[_n_[joo[Zj^00;o[jn_00?o[Zj^ojn_[on^
[Zh01?n^[Zh4ojn_[`;o[Zj^00Go[:b/ok2`/?n^[Zko[jn_ojj^[P02ojn_
[`03ojj^[_n_[joo[Zj^00Co[Zj^1?n_[jl2ojj^[P05ojb/[?n`/;3o[Zj^
ojn_[on^[Zh00_n_[jl00on^[Zko[jn_ojj^[P04ojj^[PCo[jn_0_n^[Zh0
1On/[:co/;2`ojj^[_n_[joo[Zj^00;o[jn_00?o[Zj^ojn_[on^[Zh01?n^
[Zh4ojn_[`;o[Zj^00Go[:b/ok2`/?n^[Zko[jn_ojj^[P02ojn_[`03ojj^
[_n_[joo[Zj^00Co[Zj^1?n_[jl2ojj^[P05ojb/[?n`/;3o[Zj^ojn_[on^
[Zh00_n_[jl00on^[Zko[jn_ojj^[P04ojj^[PCo[jn_0_n^[Zh01On/[:co
/;2`ojj^[_n_[joo[Zj^00;o[jn_00?o[Zj^ojn_[on^[Zh01?n^[Zh4ojn_
[`;o[Zj^00Go[:b/ok2`/?n^[Zko[jn_ojj^[P02ojn_[`03ojj^[_n_[joo
[Zj^00Co[Zj^1?n_[jl2ojj^[P05ojb/[?n`/;3o[Zj^ojn_[on^[Zh00_n_
[jl00on^[Zko[jn_ojj^[P04ojj^[PCo[jn_0_n^[Zh01On/[:co/;2`ojj^
[_n_[joo[Zj^00;o[jn_00?o[Zj^ojn_[on^[Zh01?n^[Zh4ojn_[`7o[Jf]
0OnNWYh1ofi^KP0000OoK6a/oiFEUOn[Zj_o[:b/ojVYZOn/[:coZJVY00;o
ZZZZ00OoZJVYojZZZ_nWYjOoZj^[ojZZZ_n/[:coZj^[00;oZZZZ00Wo[:b/
ojRXZ?n/[:coZj^[ojRX[?n/[:coZJVYojb/[?nYZJT00_nZZZX01onYZJWo
ZZZZojNWYon[Zj_oZZZZojb/[?n[Zj/00_nZZZX02On/[:coZ:RXojb/[?n[
Zj_oZ:R/ojb/[?nYZJWo[:b/ojVYZ@02ojZZZP07ojVYZOnZZZ[oYjNWoj^[
ZonZZZ[o[:b/oj^[Z`02ojZZZP09ojb/[?nXZ:So[:b/oj^[ZonXZ:co[:b/
ojVYZOn/[:coZJVY00;oZZZZ00OoZJVYojZZZ_nWYjOoZj^[ojZZZ_n/[:co
Zj^[00;oZZZZ00Wo[:b/ojRXZ?n/[:coZj^[ojRX[?n/[:coZJVYojb/[?nY
ZJT00_nZZZX01onYZJWoZZZZojNWYon[Zj_oZZZZojb/[?n[Zj/00_nZZZX0
2On/[:coZ:RXojb/[?n[Zj_oZ:R/ojb/[?nYZJWo[:b/ojVYZ@02ojZZZP07
ojVYZOnZZZ[oYjNWoj^[ZonZZZ[o[:b/oj^[Z`02ojZZZP09ojb/[?nXZ:So
[:b/oj^[ZonXZ:co[:b/ojVYZOn/[:coZJVY00;oZZZZ00OoZJVYojZZZ_nW
YjOoZj^[ojZZZ_n/[:coZj^[00;oZZZZ00Wo[:b/ojRXZ?n/[:coZj^[ojRX
[?n/[:coZJVYojb/[?nYZJT00_nZZZX01onYZJWoZZZZojNWYon[Zj_oZZZZ
ojb/[?n[Zj/00_nZZZX02On/[:coZ:RXojb/[?n[Zj_oZ:R/ojb/[?nYZJWo
[:b/ojVYZ@02ojZZZP07ojVYZOnZZZ[oYjNWoj^[ZonZZZ[o[:b/oj^[Z`02
ojZZZP09ojb/[?nXZ:So[:b/oj^[ZonXZ:co[:b/ojVYZOn/[:coZJVY00;o
ZZZZ00OoZJVYojZZZ_nWYjOoZj^[ojZZZ_n/[:coZj^[00;oZZZZ00Wo[:b/
ojRXZ?n/[:coZj^[ojRX[?n/[:coZJVYojb/[?nYZJT00_nZZZX01onYZJWo
ZZZZojNWYon[Zj_oZZZZojb/[?n[Zj/00_nZZZX02On/[:coZ:RXojb/[?n[
Zj_oZ:R/ojb/[?nYZJWo[:b/ojVYZ@02ojZZZP07ojVYZOnZZZ[oYjNWoj^[
ZonZZZ[o[:b/oj^[Z`02ojZZZP09ojb/[?nXZ:So[:b/oj^[ZonXZ:co[:b/
ojVYZOn/[:coZJVY00;oZZZZ00OoZJVYojZZZ_nWYjOoZj^[ojZZZ_n/[:co
Zj^[00;oZZZZ00Wo[:b/ojRXZ?n/[:coZj^[ojRX[?n/[:coZJVYojb/[?nY
ZJT00_nZZZX01onYZJWoZZZZojNWYon[Zj_oZZZZojb/[?n[Zj/00_nZZZX0
2On/[:coZ:RXojb/[?n[Zj_oZ:R/ojb/[?nYZJWo[:b/ojVYZ@02ojZZZP07
ojVYZOnZZZ[oYjNWoj^[ZonZZZ[o[:b/oj^[Z`02ojZZZP09ojb/[?nXZ:So
[:b/oj^[ZonXZ:co[:b/ojVYZOn/[:coZJVY00;oZZZZ00OoZJVYojZZZ_nW
YjOoZj^[ojZZZ_n/[:coZj^[00;oZZZZ00Wo[:b/ojRXZ?n/[:coZj^[ojRX
[?n/[:coZJVYojb/[?nYZJT00_nZZZX01onYZJWoZZZZojNWYon[Zj_oZZZZ
ojb/[?n[Zj/00_nZZZX02On/[:coZ:RXojb/[?n[Zj_oZ:R/ojb/[?nYZJWo
[:b/ojVYZ@02ojZZZP07ojVYZOnZZZ[oYjNWoj^[ZonZZZ[o[:b/oj^[Z`02
ojZZZP09ojb/[?nXZ:So[:b/oj^[ZonXZ:co[:b/ojVYZOn/[:coZJVY00;o
ZZZZ00OoZJVYojZZZ_nWYjOoZj^[ojZZZ_n/[:coZj^[00;oZZZZ00Wo[:b/
ojRXZ?n/[:coZj^[ojRX[?n/[:coZJVYojb/[?nYZJT00_nZZZX01onYZJWo
ZZZZojNWYon[Zj_oZZZZojb/[?n[Zj/00_nZZZX02On/[:coZ:RXojb/[?n[
Zj_oZ:R/ojb/[?nYZJWo[:b/ojVYZ@02ojZZZP07ojVYZOnZZZ[oYjNWoj^[
ZonZZZ[o[:b/oj^[Z`02ojZZZP09ojb/[?nXZ:So[:b/oj^[ZonXZ:co[:b/
ojVYZOn/[:coZJVY00;oZZZZ00OoZJVYojZZZ_nWYjOoZj^[ojZZZ_n/[:co
Zj^[00;oZZZZ00Wo[:b/ojRXZ?n/[:coZj^[ojRX[?n/[:coZJVYojb/[?nY
ZJT00_nZZZX01onYZJWoZZZZojNWYon[Zj_oZZZZojb/[?n[Zj/00_nZZZX0
2On/[:coZ:RXojb/[?n[Zj_oZ:R/ojb/[?nYZJWo[:b/ojVYZ@02ojZZZP07
ojVYZOnZZZ[oYjNWoj^[ZonZZZ[o[:b/oj^[Z`02ojZZZP09ojb/[?nXZ:So
[:b/oj^[ZonXZ:co[:b/ojVYZOn/[:coZJVY00;oZZZZ00OoZJVYojZZZ_nW
YjOoZj^[ojZZZ_n/[:coZj^[00;oZZZZ00Wo[:b/ojRXZ?n/[:coZj^[ojRX
[?n/[:coZJVYojb/[?nYZJT00_nZZZX01onYZJWoZZZZojNWYon[Zj_oZZZZ
ojb/[?n[Zj/00_nZZZX02On/[:coZ:RXojb/[?n[Zj_oZ:R/ojb/[?nYZJWo
[:b/ojVYZ@02ojZZZP07ojVYZOnZZZ[oYjNWoj^[ZonZZZ[o[:b/oj^[Z`02
ojZZZP09ojb/[?nXZ:So[:b/oj^[ZonXZ:co[:b/ojVYZOn/[:coZJVY00;o
ZZZZ00OoZJVYojZZZ_nWYjOoZj^[ojZZZ_n/[:coZj^[00;oZZZZ00Wo[:b/
ojRXZ?n/[:coZj^[ojRX[?n/[:coZJVYojb/[?nYZJT00_nZZZX01onYZJWo
ZZZZojNWYon[Zj_oZZZZojb/[?n[Zj/00_nZZZX02On/[:coZ:RXojb/[?n[
Zj_oZ:R/ojb/[?nYZJWo[:b/ojVYZ@02ojZZZP07ojVYZOnZZZ[oYjNWoj^[
ZonZZZ[o[:b/oj^[Z`02ojZZZP09ojb/[?nXZ:So[:b/oj^[ZonXZ:co[:b/
ojVYZOn/[:coZJVY00;oZZZZ00OoZJVYojZZZ_nWYjOoZj^[ojZZZ_n/[:co
Zj^[00;oZZZZ00Wo[:b/ojRXZ?n/[:coZj^[ojRX[?n/[:coZJVYojb/[?nY
ZJT00_nZZZX01onYZJWoZZZZojNWYon[Zj_oZZZZojb/[?n[Zj/00_nZZZX1
oiBDU07oKFe]00001?m[Jf_oYjNWolW9bOo9bLT3ol_;b`04olW9bOo:b/[o
c<c<olc<c0;obl_;00Kob/[:olk>c_o:b/[ob/[:olW9bOo;bl/2ol[:bP03
olg=cOo<c<WobLW900?obl_;00CobLW9ol[:b_o<c<coc<c<0_o;bl/01_o:
b/[oc/k>ol[:b_o:b/[obLW9ol_;b`;ob/[:00?ocLg=olc<bOo9bLT00oo;
bl/01?o9bLWob/[:olc<c?o<c<`2ol_;b`06ol[:b_o>c/kob/[:ol[:b_o9
bLWobl_;0_o:b/X00oo=cLgoc<c9olW9b@03ol_;b`04olW9bOo:b/[oc<c<
olc<c0;obl_;00Kob/[:olk>c_o:b/[ob/[:olW9bOo;bl/2ol[:bP03olg=
cOo<c<WobLW900?obl_;00CobLW9ol[:b_o<c<coc<c<0_o;bl/01_o:b/[o
c/k>ol[:b_o:b/[obLW9ol_;b`;ob/[:00?ocLg=olc<bOo9bLT00oo;bl/0
1?o9bLWob/[:olc<c?o<c<`2ol_;b`06ol[:b_o>c/kob/[:ol[:b_o9bLWo
bl_;0_o:b/X00oo=cLgoc<c9olW9b@03ol_;b`04olW9bOo:b/[oc<c<olc<
c0;obl_;00Kob/[:olk>c_o:b/[ob/[:olW9bOo;bl/2ol[:bP03olg=cOo<
c<WobLW900?obl_;00CobLW9ol[:b_o<c<coc<c<0_o;bl/01_o:b/[oc/k>
ol[:b_o:b/[obLW9ol_;b`;ob/[:00?ocLg=olc<bOo9bLT00oo;bl/01?o9
bLWob/[:olc<c?o<c<`2ol_;b`06ol[:b_o>c/kob/[:ol[:b_o9bLWobl_;
0_o:b/X00oo=cLgoc<c9olW9b@03ol_;b`04olW9bOo:b/[oc<c<olc<c0;o
bl_;00Kob/[:olk>c_o:b/[ob/[:olW9bOo;bl/2ol[:bP03olg=cOo<c<Wo
bLW900?obl_;00CobLW9ol[:b_o<c<coc<c<0_o;bl/01_o:b/[oc/k>ol[:
b_o:b/[obLW9ol_;b`;ob/[:00?ocLg=olc<bOo9bLT00oo;bl/01?o9bLWo
b/[:olc<c?o<c<`2ol_;b`06ol[:b_o>c/kob/[:ol[:b_o9bLWobl_;0_o:
b/X00oo=cLgoc<c9olW9b@03ol_;b`04olW9bOo:b/[oc<c<olc<c0;obl_;
00Kob/[:olk>c_o:b/[ob/[:olW9bOo;bl/2ol[:bP03olg=cOo<c<WobLW9
00?obl_;00CobLW9ol[:b_o<c<coc<c<0_o;bl/01_o:b/[oc/k>ol[:b_o:
b/[obLW9ol_;b`;ob/[:00?ocLg=olc<bOo9bLT00oo;bl/01?o9bLWob/[:
olc<c?o<c<`2ol_;b`06ol[:b_o>c/kob/[:ol[:b_o9bLWobl_;0_o:b/X0
0oo=cLgoc<c9olW9b@03ol_;b`04olW9bOo:b/[oc<c<olc<c0;obl_;00Ko
b/[:olk>c_o:b/[ob/[:olW9bOo;bl/2ol[:bP03olg=cOo<c<WobLW900?o
bl_;00CobLW9ol[:b_o<c<coc<c<0_o;bl/01_o:b/[oc/k>ol[:b_o:b/[o
bLW9ol_;b`;ob/[:00?ocLg=olc<bOo9bLT00oo;bl/01?o9bLWob/[:olc<
c?o<c<`2ol_;b`06ol[:b_o>c/kob/[:ol[:b_o9bLWobl_;0_o:b/X00oo=
cLgoc<c9olW9b@03ol_;b`04olW9bOo:b/[oc<c<olc<c0;obl_;00Kob/[:
olk>c_o:b/[ob/[:olW9bOo;bl/2ol[:bP03olg=cOo<c<WobLW900?obl_;
00CobLW9ol[:b_o<c<coc<c<0_o;bl/01_o:b/[oc/k>ol[:b_o:b/[obLW9
ol_;b`;ob/[:00?ocLg=olc<bOo9bLT00oo;bl/01?o9bLWob/[:olc<c?o<
c<`2ol_;b`06ol[:b_o>c/kob/[:ol[:b_o9bLWobl_;0_o:b/X00oo=cLgo
c<c9olW9b@03ol_;b`04olW9bOo:b/[oc<c<olc<c0;obl_;00Kob/[:olk>
c_o:b/[ob/[:olW9bOo;bl/2ol[:bP03olg=cOo<c<WobLW900?obl_;00Co
bLW9ol[:b_o<c<coc<c<0_o;bl/01_o:b/[oc/k>ol[:b_o:b/[obLW9ol_;
b`;ob/[:00?ocLg=olc<bOo9bLT00oo;bl/01?o9bLWob/[:olc<c?o<c<`2
ol_;b`06ol[:b_o>c/kob/[:ol[:b_o9bLWobl_;0_o:b/X00oo=cLgoc<c9
olW9b@03ol_;b`04olW9bOo:b/[oc<c<olc<c0;obl_;00Kob/[:olk>c_o:
b/[ob/[:olW9bOo;bl/2ol[:bP03olg=cOo<c<WobLW900?obl_;00CobLW9
ol[:b_o<c<coc<c<0_o;bl/01_o:b/[oc/k>ol[:b_o:b/[obLW9ol_;b`;o
b/[:00?ocLg=olc<bOo9bLT00oo;bl/01?o9bLWob/[:olc<c?o<c<`2ol_;
b`06ol[:b_o>c/kob/[:ol[:b_o9bLWobl_;0_o:b/X00oo=cLgoc<c9olW9
b@03ol_;b`04olW9bOo:b/[oc<c<olc<c0;obl_;00Kob/[:olk>c_o:b/[o
b/[:olW9bOo;bl/2ol[:bP03olg=cOo<c<WobLW900?obl_;00CobLW9ol[:
b_o<c<coc<c<0_o;bl/01_o:b/[oc/k>ol[:b_o:b/[obLW9ol_;b`;ob/[:
00?ocLg=olc<bOo9bLT00oo;bl/01?o9bLWob/[:olc<c?o<c<`2ol_;b`06
ol[:b_o>c/kob/[:ol[:b_o9bLWobl_;0_o:b/X00oo=cLgoc<c9olW9b@03
ol_;b`04olW9bOo:b/[oc<c<olc<c0;obl_;00Kob/[:olk>c_o:b/[ob/[:
olW9bOo;bl/2ol[:bP03olg=cOo<c<WobLW900?obl_;00CobLW9ol[:b_o<
c<coc<c<0_o;bl/00oo:b/[oc/k>ol[:bP02ol[:bP7o[Jf]0Om[Jf/00006
ofYZJ_nb/[;of][JomSHf?oKfm_ofMWI0_oJf]X2omWIf@05omSHf?oJf][o
f=SHomWIfOoHf=P00_oIfMT02OoHf=SofMWIomWIfOoKfm_ofMWIomWIf?oH
f=Sofm_KomWIf@02om[JfP;ofMWI00Gof=SHom[Jf_oHf=SofMWIomSHf002
omWIf@09omSHf?oIfMWofMWIom_KfooIfMWofMWHomSHf?oKfm_ofMWI00;o
f][J0_oIfMT01OoHf=Sof][JomSHf?oIfMWof=SH00;ofMWI00Wof=SHomWI
fOoIfMWofm_KomWIfOoIfMSof=SHom_KfooIfMT00_oJf]X2omWIf@05omSH
f?oJf][of=SHomWIfOoHf=P00_oIfMT02OoHf=SofMWIomWIfOoKfm_ofMWI
omWIf?oHf=Sofm_KomWIf@02om[JfP;ofMWI00Gof=SHom[Jf_oHf=SofMWI
omSHf002omWIf@09omSHf?oIfMWofMWIom_KfooIfMWofMWHomSHf?oKfm_o
fMWI00;of][J0_oIfMT01OoHf=Sof][JomSHf?oIfMWof=SH00;ofMWI00Wo
f=SHomWIfOoIfMWofm_KomWIfOoIfMSof=SHom_KfooIfMT00_oJf]X2omWI
f@05omSHf?oJf][of=SHomWIfOoHf=P00_oIfMT02OoHf=SofMWIomWIfOoK
fm_ofMWIomWIf?oHf=Sofm_KomWIf@02om[JfP;ofMWI00Gof=SHom[Jf_oH
f=SofMWIomSHf002omWIf@09omSHf?oIfMWofMWIom_KfooIfMWofMWHomSH
f?oKfm_ofMWI00;of][J0_oIfMT01OoHf=Sof][JomSHf?oIfMWof=SH00;o
fMWI00Wof=SHomWIfOoIfMWofm_KomWIfOoIfMSof=SHom_KfooIfMT00_oJ
f]X2omWIf@05omSHf?oJf][of=SHomWIfOoHf=P00_oIfMT02OoHf=SofMWI
omWIfOoKfm_ofMWIomWIf?oHf=Sofm_KomWIf@02om[JfP;ofMWI00Gof=SH
om[Jf_oHf=SofMWIomSHf002omWIf@09omSHf?oIfMWofMWIom_KfooIfMWo
fMWHomSHf?oKfm_ofMWI00;of][J0_oIfMT01OoHf=Sof][JomSHf?oIfMWo
f=SH00;ofMWI00Wof=SHomWIfOoIfMWofm_KomWIfOoIfMSof=SHom_KfooI
fMT00_oJf]X2omWIf@05omSHf?oJf][of=SHomWIfOoHf=P00_oIfMT02OoH
f=SofMWIomWIfOoKfm_ofMWIomWIf?oHf=Sofm_KomWIf@02om[JfP;ofMWI
00Gof=SHom[Jf_oHf=SofMWIomSHf002omWIf@09omSHf?oIfMWofMWIom_K
fooIfMWofMWHomSHf?oKfm_ofMWI00;of][J0_oIfMT01OoHf=Sof][JomSH
f?oIfMWof=SH00;ofMWI00Wof=SHomWIfOoIfMWofm_KomWIfOoIfMSof=SH
om_KfooIfMT00_oJf]X2omWIf@05omSHf?oJf][of=SHomWIfOoHf=P00_oI
fMT02OoHf=SofMWIomWIfOoKfm_ofMWIomWIf?oHf=Sofm_KomWIf@02om[J
fP;ofMWI00Gof=SHom[Jf_oHf=SofMWIomSHf002omWIf@09omSHf?oIfMWo
fMWIom_KfooIfMWofMWHomSHf?oKfm_ofMWI00;of][J0_oIfMT01OoHf=So
f][JomSHf?oIfMWof=SH00;ofMWI00Wof=SHomWIfOoIfMWofm_KomWIfOoI
fMSof=SHom_KfooIfMT00_oJf]X2omWIf@05omSHf?oJf][of=SHomWIfOoH
f=P00_oIfMT02OoHf=SofMWIomWIfOoKfm_ofMWIomWIf?oHf=Sofm_KomWI
f@02om[JfP;ofMWI00Gof=SHom[Jf_oHf=SofMWIomSHf002omWIf@09omSH
f?oIfMWofMWIom_KfooIfMWofMWHomSHf?oKfm_ofMWI00;of][J0_oIfMT0
1OoHf=Sof][JomSHf?oIfMWof=SH00;ofMWI00Wof=SHomWIfOoIfMWofm_K
omWIfOoIfMSof=SHom_KfooIfMT00_oJf]X2omWIf@05omSHf?oJf][of=SH
omWIfOoHf=P00_oIfMT02OoHf=SofMWIomWIfOoKfm_ofMWIomWIf?oHf=So
fm_KomWIf@02om[JfP;ofMWI00Gof=SHom[Jf_oHf=SofMWIomSHf002omWI
f@09omSHf?oIfMWofMWIom_KfooIfMWofMWHomSHf?oKfm_ofMWI00;of][J
0_oIfMT01OoHf=Sof][JomSHf?oIfMWof=SH00;ofMWI00Wof=SHomWIfOoI
fMWofm_KomWIfOoIfMSof=SHom_KfooIfMT00_oJf]X2omWIf@05omSHf?oJ
f][of=SHomWIfOoHf=P00_oIfMT02OoHf=SofMWIomWIfOoKfm_ofMWIomWI
f?oHf=Sofm_KomWIf@02om[JfP;ofMWI00Gof=SHom[Jf_oHf=SofMWIomSH
f002omWIf@09omSHf?oIfMWofMWIom_KfooIfMWofMWHomSHf?oKfm_ofMWI
00;of][J0_oIfMT01OoHf=Sof][JomSHf?oIfMWof=SH00;ofMWI00Wof=SH
omWIfOoIfMWofm_KomWIfOoIfMSof=SHom_KfooIfMT00_oJf]X2omWIf@05
omSHf?oJf][of=SHomWIfOoHf=P00_oIfMT02OoHf=SofMWIomWIfOoKfm_o
fMWIomWIf?oHf=Sofm_KomWIf@02om[JfP;ofMWI00Gof=SHom[Jf_oHf=So
fMWIomSHf002omWIf@09omSHf?oIfMWofMWIom_KfooIfMWofMWHomSHf?oK
fm_ofMWI00;of][J0_oIfMT01OoHf=Sof][JomSHf?oIfMWof=SH00;ofMWI
00Wof=SHomWIfOoIfMWofm_KomWIfOoIfMSof=SHom_KfooIfMT00_oJf]X2
omWIf@05omSHf?oJf][of=SHomWIfOoHf=P00_oIfMT02OoHf=SofMWIomWI
fOoKfm_ofMWIomWIf?oHf=Sofm_KomWIf@02om[JfP;ofMWI00Gof=SHom[J
f_oHf=SofMWIomSHf003omWIf@7o]KFe0OmZJVX000;oJFUY00GoJ6QXofUY
JOmXJ6SoJFUYofQXJ002ofUYJ@06ofQXJ?mYJFWoJ6QXofUYJOmXJ6SoJFUY
0_mXJ6P00omYJFWoJ6QXofQXJ002ofQXJ0;oJFUY00?oJ6QXofUYJOmXJ6P0
0_mYJFT01_mXJ6SoJFUYofQXJ?mYJFWoJ6QXofUYJ@;oJ6QX00?oJFUYofQX
J?mXJ6P00_mXJ6P2ofUYJ@03ofQXJ?mYJFWoJ6QX00;oJFUY00KoJ6QXofUY
JOmXJ6SoJFUYofQXJ?mYJFT2ofQXJ003ofUYJOmXJ6SoJ6QX00;oJ6QX0_mY
JFT00omXJ6SoJFUYofQXJ002ofUYJ@06ofQXJ?mYJFWoJ6QXofUYJOmXJ6So
JFUY0_mXJ6P00omYJFWoJ6QXofQXJ002ofQXJ0;oJFUY00?oJ6QXofUYJOmX
J6P00_mYJFT01_mXJ6SoJFUYofQXJ?mYJFWoJ6QXofUYJ@;oJ6QX00?oJFUY
ofQXJ?mXJ6P00_mXJ6P2ofUYJ@03ofQXJ?mYJFWoJ6QX00;oJFUY00KoJ6QX
ofUYJOmXJ6SoJFUYofQXJ?mYJFT2ofQXJ003ofUYJOmXJ6SoJ6QX00;oJ6QX
0_mYJFT00omXJ6SoJFUYofQXJ002ofUYJ@06ofQXJ?mYJFWoJ6QXofUYJOmX
J6SoJFUY0_mXJ6P00omYJFWoJ6QXofQXJ002ofQXJ0;oJFUY00?oJ6QXofUY
JOmXJ6P00_mYJFT01_mXJ6SoJFUYofQXJ?mYJFWoJ6QXofUYJ@;oJ6QX00?o
JFUYofQXJ?mXJ6P00_mXJ6P2ofUYJ@03ofQXJ?mYJFWoJ6QX00;oJFUY00Ko
J6QXofUYJOmXJ6SoJFUYofQXJ?mYJFT2ofQXJ003ofUYJOmXJ6SoJ6QX00;o
J6QX0_mYJFT00omXJ6SoJFUYofQXJ002ofUYJ@06ofQXJ?mYJFWoJ6QXofUY
JOmXJ6SoJFUY0_mXJ6P00omYJFWoJ6QXofQXJ002ofQXJ0;oJFUY00?oJ6QX
ofUYJOmXJ6P00_mYJFT01_mXJ6SoJFUYofQXJ?mYJFWoJ6QXofUYJ@;oJ6QX
00?oJFUYofQXJ?mXJ6P00_mXJ6P2ofUYJ@03ofQXJ?mYJFWoJ6QX00;oJFUY
00KoJ6QXofUYJOmXJ6SoJFUYofQXJ?mYJFT2ofQXJ003ofUYJOmXJ6SoJ6QX
00;oJ6QX0_mYJFT00omXJ6SoJFUYofQXJ002ofUYJ@06ofQXJ?mYJFWoJ6QX
ofUYJOmXJ6SoJFUY0_mXJ6P00omYJFWoJ6QXofQXJ002ofQXJ0;oJFUY00?o
J6QXofUYJOmXJ6P00_mYJFT01_mXJ6SoJFUYofQXJ?mYJFWoJ6QXofUYJ@;o
J6QX00?oJFUYofQXJ?mXJ6P00_mXJ6P2ofUYJ@03ofQXJ?mYJFWoJ6QX00;o
JFUY00KoJ6QXofUYJOmXJ6SoJFUYofQXJ?mYJFT2ofQXJ003ofUYJOmXJ6So
J6QX00;oJ6QX0_mYJFT00omXJ6SoJFUYofQXJ002ofUYJ@06ofQXJ?mYJFWo
J6QXofUYJOmXJ6SoJFUY0_mXJ6P00omYJFWoJ6QXofQXJ002ofQXJ0;oJFUY
00?oJ6QXofUYJOmXJ6P00_mYJFT01_mXJ6SoJFUYofQXJ?mYJFWoJ6QXofUY
J@;oJ6QX00?oJFUYofQXJ?mXJ6P00_mXJ6P2ofUYJ@03ofQXJ?mYJFWoJ6QX
00;oJFUY00KoJ6QXofUYJOmXJ6SoJFUYofQXJ?mYJFT2ofQXJ003ofUYJOmX
J6SoJ6QX00;oJ6QX0_mYJFT00omXJ6SoJFUYofQXJ002ofUYJ@06ofQXJ?mY
JFWoJ6QXofUYJOmXJ6SoJFUY0_mXJ6P00omYJFWoJ6QXofQXJ002ofQXJ0;o
JFUY00?oJ6QXofUYJOmXJ6P00_mYJFT01_mXJ6SoJFUYofQXJ?mYJFWoJ6QX
ofUYJ@;oJ6QX00?oJFUYofQXJ?mXJ6P00_mXJ6P2ofUYJ@03ofQXJ?mYJFWo
J6QX00;oJFUY00KoJ6QXofUYJOmXJ6SoJFUYofQXJ?mYJFT2ofQXJ003ofUY
JOmXJ6SoJ6QX00;oJ6QX0_mYJFT00omXJ6SoJFUYofQXJ002ofUYJ@06ofQX
J?mYJFWoJ6QXofUYJOmXJ6SoJFUY0_mXJ6P00omYJFWoJ6QXofQXJ002ofQX
J0;oJFUY00?oJ6QXofUYJOmXJ6P00_mYJFT01_mXJ6SoJFUYofQXJ?mYJFWo
J6QXofUYJ@;oJ6QX00?oJFUYofQXJ?mXJ6P00_mXJ6P2ofUYJ@03ofQXJ?mY
JFWoJ6QX00;oJFUY00KoJ6QXofUYJOmXJ6SoJFUYofQXJ?mYJFT2ofQXJ003
ofUYJOmXJ6SoJ6QX00;oJ6QX0_mYJFT00omXJ6SoJFUYofQXJ002ofUYJ@06
ofQXJ?mYJFWoJ6QXofUYJOmXJ6SoJFUY0_mXJ6P00omYJFWoJ6QXofQXJ002
ofQXJ0;oJFUY00?oJ6QXofUYJOmXJ6P00_mYJFT01_mXJ6SoJFUYofQXJ?mY
JFWoJ6QXofUYJ@;oJ6QX00?oJFUYofQXJ?mXJ6P00_mXJ6P2ofUYJ@03ofQX
J?mYJFWoJ6QX00;oJFUY00KoJ6QXofUYJOmXJ6SoJFUYofQXJ?mYJFT2ofQX
J003ofUYJOmXJ6SoJ6QX00;oJ6QX0_mYJFT00omXJ6SoJFUYofQXJ002ofUY
J@06ofQXJ?mYJFWoJ6QXofUYJOmXJ6SoJFUY0_mXJ6P00omYJFWoJ6QXofQX
J002ofQXJ0;oJFUY00?oJ6QXofUYJOmXJ6P00_mYJFT01_mXJ6SoJFUYofQX
J?mYJFWoJ6QXofUYJ@;oJ6QX00?oJFUYofQXJ?mXJ6P00_mXJ6P2ofUYJ@03
ofQXJ?mYJFWoJ6QX00;oJFUY00KoJ6QXofUYJOmXJ6SoJFUYofQXJ?mYJFT2
ofQXJ003ofUYJOmXJ6SoJ6QX00;oJ6QX0_mYJFT00omXJ6SoJFUYofQXJ002
ofUYJ@06ofQXJ?mYJFWoJ6QXofUYJOmXJ6SoJFUY0_mXJ6P00omYJFWoJ6QX
ofQXJ002ofQXJ0;oJFUY00?oJ6QXofUYJOmXJ6P00_mYJFT01_mXJ6SoJFUY
ofQXJ?mYJFWoJ6QXofUYJ@;oJ6QX0OmYJFT1ofQXJ07oJ6QX003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP004?n2PX800on3Ph?o
PX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2P_n2
PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2PP03oh>3Pon2PX;oPX:200;o
PX:200?oPh>3oh:2P_n2PX803?n2PX800on3Ph?oPX:2oh:2PP02oh:2PP03
oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2P_n2PX800_n2PX800on3Ph?o
PX:2oh:2PP0<oh:2PP03oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2P_n2
PX803?n2PX800on3Ph?oPX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:200co
PX:200?oPh>3oh:2P_n2PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2PP03
oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2P_n2PX803?n2PX800on3Ph?o
PX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2P_n2
PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2PP03oh>3Pon2PX;oPX:200;o
PX:200?oPh>3oh:2P_n2PX803?n2PX800on3Ph?oPX:2oh:2PP02oh:2PP03
oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2P_n2PX800_n2PX800on3Ph?o
PX:2oh:2PP0<oh:2PP03oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2P_n2
PX803?n2PX800on3Ph?oPX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:200co
PX:200?oPh>3oh:2P_n2PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2PP03
oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2P_n2PX803?n2PX800on3Ph?o
PX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2P_n2
PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2PP03oh>3Pon2PX;oPX:200;o
PX:200?oPh>3oh:2P_n2PX803?n2PX800on3Ph?oPX:2oh:2PP02oh:2PP03
oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2P_n2PX800_n2PX800on3Ph?o
PX:2oh:2PP0<oh:2PP03oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2P_n2
PX803?n2PX800on3Ph?oPX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:200co
PX:200?oPh>3oh:2P_n2PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2PP03
oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2P_n2PX803?n2PX800on3Ph?o
PX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2P_n2
PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2PP03oh>3Pon2PX;oPX:200;o
PX:200?oPh>3oh:2P_n2PX803?n2PX800on3Ph?oPX:2oh:2PP02oh:2PP03
oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2P_n2PX800On2PX800004oh>3
PooMgMgoj>SXono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401ooalO400oo`l?3o
lO7aoo7al@02ono_k`GolO7a00?ol?3`oo7alOoalO401OoalO41on[ZjP7o
fm_K0On3Ph<00004ohB4Q?oPh>3olo?cooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP?ooOgm1?ono_h2ooclo0Coo_kn00?ooOgmookno_om
oOd00_omoOd2ooknoP;ooOgm0OoemOD1on7Qh@7oPh>300001?n4Q8Coh>3P
ooGemOono_hBooooo`;oo_kn4_ooool2ooknoQ;ooooo0_ono_hBooooo`;o
o_kn4_ooool2ooknoQ;ooooo0_ono_hBooooo`;oo_kn4_ooool2ooknoQ;o
oooo0_ono_hBooooo`;oo_kn4_ooool2ooknoQ;ooooo0_ono_hBooooo`;o
o_kn4_ooool2ooknoQ;ooooo0_ono_hBooooo`;oo_kn4_ooool2ooknoQ;o
oooo0_ono_hBooooo`;oo_kn4_ooool2ooknoQ;ooooo0_ono_hBooooo`;o
o_kn4_ooool2ooknoQ;ooooo0_ono_hBooooo`;oo_kn4_ooool2ooknoQ;o
oooo0_ono_hBooooo`;oo_kn4_ooool2ooknoQ;ooooo0_ono_hBooooo`;o
o_kn3Oooool1ooKfmP7oi>CT0On3Ph<00003oh>3PooOgmoolO7a01[onOWi
1?ojn_X4oo_kn`Coo?cl6OomoOdPooclo43ooOgm7oolo?`PoogmoCooo?cl
8?omoOdPooclo9kooOgm@?olo?`Ioogmo@coo?cl6_okno/1oo;blP7oh>3P
0On3Ph<00003oh>3PooOgmoolO7a01[onOWi1?ojn_X4oo_kn`Coo?cl6Oom
oOdPooclo43ooOgm7oolo?`PoogmoCooo?cl8?omoOdPooclo9kooOgm@?ol
o?`Ioogmo@coo?cl6_okno/1oo;blP7oh>3P0On3Ph<00003oh>3PooOgmoo
lO7a01[onOWi1?ojn_X4oo_kn`Coo?cl6OomoOdPooclo43ooOgm7oolo?`P
oogmoCooo?cl8?omoOdPooclo9kooOgm@?olo?`Ioogmo@coo?cl6_okno/1
oo;blP7oh>3P0On3Ph<00003oh>3PooOgmoolO7a01[onOWi1?ojn_X4oo_k
n`Coo?cl6OomoOdPooclo43ooOgm7oolo?`PoogmoCooo?cl8?omoOdPoocl
o9kooOgm@?olo?`Ioogmo@coo?cl6_okno/1oo;blP7oh>3P0On3Ph<00003
oh>3PooOgmoolO7a01[onOWi1?ojn_X4oo_kn`Coo?cl6OomoOdPooclo43o
oOgm7oolo?`PoogmoCooo?cl8?omoOdPooclo9kooOgm@?olo?`Ioogmo@co
o?cl6_okno/1oo;blP7oh>3P0On3Ph<00003oh>3PooOgmoolO7a01[onOWi
1?ojn_X4oo_kn`Coo?cl6OomoOdPooclo43ooOgm7oolo?`PoogmoCooo?cl
8?omoOdPooclo9kooOgm@?olo?`Ioogmo@coo?cl6_okno/1oo;blP7oh>3P
0On3Ph<00003oh>3PooOgmoolO7a01[onOWi1?ojn_X4oo_kn`Coo?cl6Oom
oOdPooclo43ooOgm7oolo?`PoogmoCooo?cl8?omoOdPooclo9kooOgm@?ol
o?`Ioogmo@coo?cl6_okno/1oo;blP7oh>3P0On3Ph<00003oh>3PooOgmoo
lO7a01[onOWi1?ojn_X4oo_kn`Coo?cl6OomoOdPooclo43ooOgm7oolo?`P
oogmoCooo?cl8?omoOdPooclo9kooOgm@?olo?`Ioogmo@coo?cl6_okno/1
oo;blP7oh>3P0On3Ph<00003oh>3PooOgmool?3`01[on?Sh1?oinOT2oo[j
nP;ono_k1?olo?`IoogmoB3oo?cl@?omoOdOooclo23ooOgm?oolo?`Poogm
oB3oo?clW_omoOe0ooclo1WooOgm1_olo?`6oo_kna[on_[j0Oobl_81omoO
g`7oPh>300000on3Ph?ogmoOoo3`l00JooShn0ConOWi1?ojn_X4oo_kna?o
o?cl1_okno/6ooclo1Cono_k1_olo?`6oo_kncCoo?cl1_okno/5ooclo1Co
no_k1_olo?`6oo_knaCoo?cl1_okno/6ooclo3?ono_k1_olo?`6oo_knaCo
o?cl1_okno/6ooclo1Cono_k1_olo?`6oo_kni;oo?cl1_okno/6ooclo3Co
no_k1_olo?`6oo_kna?oo?cl3?okno/Joo[jnP7ol_;b0OoOgml1oh>3P`00
00?oPh>3omkNg_o`l?006_ohn?P4ooWin@Con_[j1?okno/Cooclo0Kono_k
1_olo?`doo_kn`Koo?cl1_okno/Dooclo0Kono_k1Oolo?`Doo_kn`Koo?cl
1_okno/Dooclo0Kono_k1_olo?`Joo_knaWon_[j3?okno/Dooclo0cono_k
6_ojn_Xioo_kn`Koo?cl1_okno/dooclo0Kono_k1_olo?`ioo_kna[on_[j
3?okno/Cooclo0Cono_k1?ojn_X4ooWinA[on?Sh0OoalO41omoOg`7oPh>3
00000on3Ph?og]kNono_k`0FooOgm`Son?Sh1?oinOT8oo[jn_oono_kc?ok
no/6ooclo0Kono_k5?olo?`6oo_kn`Koo?cl=ookno/2oo[jnP;onOWi7_oh
n?P1oo;blP7oh>3P0On3Ph<00003oh>3PooMgMgokno_01KomoOg2?ohn?P4
ooWin@Son_[j=Ookno/Poo[jnWoono_k7oojn_XPoo_kneoon_[j@?okno/I
oo[jnPcono_k5?olo?`<oo_kna[on_[j5_okno/7oo[jnP;onOWi0_ohn?P8
ooOgmaKom_Kf0OoalO41on3Ph07oPh>300000on3Ph?ogMgMono_k`0FooOg
m`Son?Sh0_oinOT2ooShn0SonOWi<oojn_X2ooWin@;on_[j7?oinOT2oo[j
nP;onOWiNoojn_X2ooWin@;on_[j6ooinOT2oo[jnP;onOWi7?ojn_X2ooWi
n@;on_[jFooinOT2oo[jnP;onOWi??ojn_X2ooWin@;on_[j6ooinOT4oo[j
nQcono_k1?ojn_XLooWin@;on_[j0_oinOTDoo[jnPOonOWi1?ohn?P8ooOg
maKom_Kf0OoalO41on3Ph07oPh>300000on3Ph?ogMgMono_k`0FooOgm`So
n?Sh0_oinOT2ooShn0SonOWi<oojn_X2ooWin@;on_[j7?oinOT2oo[jnP;o
nOWiNoojn_X2ooWin@;on_[j6ooinOT2oo[jnP;onOWi7?ojn_X2ooWin@;o
n_[jFooinOT2oo[jnP;onOWi??ojn_X2ooWin@;on_[j6ooinOT4oo[jnQco
no_k1?ojn_XLooWin@;on_[j0_oinOTDoo[jnPOonOWi1?ohn?P8ooOgmaKo
m_Kf0OoalO41on3Ph07oPh>300000on3Ph?ogMgMonk^kP0FooKfmPSomoOg
1?ohn?P8ooWinC?on_[j0_oinOT2oo[jnQconOWi0_ojn_X2ooWinG_on_[j
0_oinOT2oo[jnQ_onOWi0_ojn_X2ooWinAcon_[j0_oinOT2oo[jnU_onOWi
0_ojn_X2ooWinCcon_[j0_oinOT2oo[jnQ_onOWi1?ojn_XLoo_kn`Con_[j
7?oinOT2oo[jnP;onOWi5?ojn_X7ooWin@;omoOg0_ohn?P8ooKfmQKomOGe
0OoalO41omoOg`7oPh>300000on3Ph?ogMgMonk^kP0FooKfmPSomoOg1?oh
n?P8ooWinC?on_[j0_oinOT2oo[jnQconOWi0_ojn_X2ooWinG_on_[j0_oi
nOT2oo[jnQ_onOWi0_ojn_X2ooWinAcon_[j0_oinOT2oo[jnU_onOWi0_oj
n_X2ooWinCcon_[j0_oinOT2oo[jnQ_onOWi1?ojn_XLoo_kn`Con_[j7?oi
nOT2oo[jnP;onOWi5?ojn_X7ooWin@;omoOg0_ohn?P8ooKfmQKomOGe0Ooa
lO41omoOg`7oPh>300000on3Ph?ogMgMonk^kP0FooKfmPSomoOg1?ohn?P8
ooWinC?on_[j0_oinOT2oo[jnQconOWi0_ojn_X2ooWinG_on_[j0_oinOT2
oo[jnQ_onOWi0_ojn_X2ooWinAcon_[j0_oinOT2oo[jnU_onOWi0_ojn_X2
ooWinCcon_[j0_oinOT2oo[jnQ_onOWi1?ojn_XLoo_kn`Con_[j7?oinOT2
oo[jnP;onOWi5?ojn_X7ooWin@;omoOg0_ohn?P8ooKfmQKomOGe0OoalO41
omoOg`7oPh>300000on3Ph?ogMgMonk^kP0FooKfmPSomoOg1?ohn?P8ooWi
nC?on_[j0_oinOT2oo[jnQconOWi0_ojn_X2ooWinG_on_[j0_oinOT2oo[j
nQ_onOWi0_ojn_X2ooWinAcon_[j0_oinOT2oo[jnU_onOWi0_ojn_X2ooWi
nCcon_[j0_oinOT2oo[jnQ_onOWi1?ojn_XLoo_kn`Con_[j7?oinOT2oo[j
nP;onOWi5?ojn_X7ooWin@;omoOg0_ohn?P8ooKfmQKomOGe0OoalO41omoO
g`7oPh>300000on3Ph?ogMgMonk^kP0FooKfmPSomoOg1?ohn?P8ooWinA?o
n_[j0_oinOT2oo[jnW_onOWi0_ojn_X2ooWinAcon_[j0_oinOT2oo[jnQko
nOWi7oohn?PPooWinEoon?Sh@?oinOTMooShn0;onOWi0_ojn_XLoo_kn`;o
n_[j0_oinOTLooShn0ConOWi5?ojn_X7ooWin@;omoOg0_ohn?P8ooKfmQKo
mOGe0Oo`l?01on3Ph07oPh>300000on3Ph?ogMgMonk^kP0FooKfmPSomoOg
1?ohn?P8ooWinA?on_[j0_oinOT2oo[jnW_onOWi0_ojn_X2ooWinAcon_[j
0_oinOT2oo[jnQkonOWi7oohn?PPooWinEoon?Sh@?oinOTMooShn0;onOWi
0_ojn_XLoo_kn`;on_[j0_oinOTLooShn0ConOWi5?ojn_X7ooWin@;omoOg
0_ohn?P8ooKfmQKomOGe0Oo`l?01on3Ph07oPh>300000on3Ph?ogMgMonk^
kP0FooKfmPSomoOg1?ohn?P8ooWinA?on_[j0_oinOT2oo[jnW_onOWi0_oj
n_X2ooWinAcon_[j0_oinOT2oo[jnQkonOWi7oohn?PPooWinEoon?Sh@?oi
nOTMooShn0;onOWi0_ojn_XLoo_kn`;on_[j0_oinOTLooShn0ConOWi5?oj
n_X7ooWin@;omoOg0_ohn?P8ooKfmQKomOGe0Oo`l?01on3Ph07oPh>30000
0on3Ph?ogMgMong]k@0FooGem@Som_Kf1?ogmoL8ooShn3GonOWi8?ohn?Pm
ooWin@;on_[j0_oinOTLoo[jnP;onOWi0_ojn_XNooWinAoon?Sh8?oinOUo
ooShn23onOWi7oohn?PPooWinB3on?Sh5_oinOT7ooShn0ComoOg2?ofm_HF
ooGem@7okno_0OoOgml1oh>3P`0000?oPh>3omgMgOo/k>`05_odm?@8ooGe
m@Com_Kf2?ogmoNDooShn23onOWi]?ohn?P:ooOgm`[on?Sh3?ogmoL:ooSh
n0[omoOgRoohn?PCooOgmaKom_Kf0Oo_knl1omoOg`7oPh>300000on3Ph?o
gMgMonc/k00FooCdm0SomOGe1?ofm_H8ooOgmiCon?Sh8?oinOVdooShn0[o
moOg2_ohn?P<ooOgm`[on?Sh2_ogmoN;ooShn1?omoOg5_ofm_H1ono_k`7o
gmoO0On3Ph<00003oh>3PooMgMgok>c/01Kom?Cd2?oemOD4ooKfmPSomoOg
U?ohn?PPooWinKCon?Sh2_ogmoL:ooShn0comoOg2_ohn?P:ooOgmh_on?Sh
4oogmoLFooKfmP7okno_0OoOgml1oh>3P`0000?oPh>3omgMgOo/k>`05_od
m?@8ooGem@Com_Kf2?ogmoL<ooShn0WomoOg2_ohn?P<ooOgm`[on?Sh2_og
moL<ooShn0[omoOg2_ohn?P[ooOgmaCon?Sh3?oinOTDooShn;ComoOg8?of
m_HeooOgm`[on?Sh2_ogmoL<ooShn0[omoOg2_ohn?P<ooOgm`[on?Sh2_og
moL<ooShn1?omoOg5_ofm_H1onk^kP7oh>3P0On3Ph<00003oh>3PooMgMgo
k>c/01Kom?Cd2?oemOD4ooKfmPSomoOg3?ohn?P9ooOgm`[on?Sh3?ogmoL:
ooShn0[omoOg3?ohn?P:ooOgm`[on?Sh:oogmoLDooShn0conOWi5?ohn?Rd
ooOgmb3om_Kf=OogmoL:ooShn0[omoOg3?ohn?P:ooOgm`[on?Sh3?ogmoL:
ooShn0[omoOg3?ohn?PCooOgmaKom_Kf0Oo^k^h1on3Ph07oPh>300000on3
Ph?ogMgMonc/k00FooCdm0SomOGe1?ofm_H8ooOgm`con?Sh2OogmoL:ooSh
n0comoOg2_ohn?P:ooOgm`con?Sh2_ogmoL:ooShn2_omoOg5?ohn?P<ooWi
nACon?Sh]?ogmoLPooKfmSGomoOg2_ohn?P:ooOgm`con?Sh2_ogmoL:ooSh
n0comoOg2_ohn?P:ooOgm`con?Sh4oogmoLFooKfmP7ok^k^0OoPh>01oh>3
P`0000?oPh>3omgMgOo/k>`05_odm?@8ooGem@Com_Kf2?ogmoL<ooShn0Wo
moOg2_ohn?P<ooOgm`[on?Sh2_ogmoL<ooShn0[omoOg2_ohn?P[ooOgmaCo
n?Sh3?oinOTDooShn;ComoOg8?ofm_HeooOgm`[on?Sh2_ogmoL<ooShn0[o
moOg2_ohn?P<ooOgm`[on?Sh2_ogmoL<ooShn1?omoOg5_ofm_H1onk^kP7o
h>3P0On3Ph<00003oh>3PooMgMgok>c/01kom?Cd0_oemOD2ooKfmY;omoOg
2_ohn?P:ooOgm`con?Sh2_ogmoL:ooShn;ComoOg8?ofm_JNooOgmb3om_Kf
0Oo^k^h1omoOg`7oPh>300000on3Ph?ogMgMonc/k00NooCdm0;omOGe0_of
m_JBooOgm`[on?Sh2_ogmoL<ooShn0[omoOg2_ohn?RdooOgmb3om_KfW_og
moLPooKfmP7okNg]0OoOgml1oh>3P`0000?oPh>3omgMgOo/k>`07_odm?@2
ooGem@;om_KfT_ogmoL:ooShn0[omoOg3?ohn?P:ooOgm`[on?Sh]?ogmoLP
ooKfmYkomoOg8?ofm_H1ong]k@7ogmoO0On3Ph<00003oh>3PooMgMgokNg]
01kom?Cd1?oemODmooKfmR3omoOg?oofm_HPooOgmooom_Kf7_ofm_HPooOg
mb3om_Kf7oogmoLPooKfmP7okNg]0OoOgml1oh>3P`0000?oPh>3omkNg_o^
k^h08?odm?@mooGem@Com_Kf7?ogmoL4ooKfmQcomOGe0_ofm_H2ooGemAgo
m_Kf8?ogmoLNooKfmP;omOGe0_ofm_HKooGem@;om_Kf0_oemODLooKfmP;o
mOGe0_ofm_HLooGem@;om_Kf0_oemOEkooKfmP;omOGe0_ofm_HKooGem@Co
m_Kf7?ogmoL4ooKfmQcomOGe0_ofm_H2ooGemA_om_Kf0_oemOD2ooKfmQko
mOGe0Oo/k>`1omkNgP7oPh>300000on3Ph?og]kNonk^kP0PooCdm3gomOGe
1?ofm_HLooOgm`Com_Kf7?oemOD2ooKfmP;omOGe7Oofm_HPooOgmakom_Kf
0_oemOD2ooKfmQ_omOGe0_ofm_H2ooGemAcom_Kf0_oemOD2ooKfmQcomOGe
0_ofm_H2ooGemG_om_Kf0_oemOD2ooKfmQ_omOGe1?ofm_HLooOgm`Com_Kf
7?oemOD2ooKfmP;omOGe6oofm_H2ooGem@;om_Kf7_oemOD1onc/k07og]kN
0On3Ph<00003oh>3PooNg]kok^k^023om?Cd?OoemOD4ooKfmQcomoOg1?of
m_HLooGem@;om_Kf0_oemODMooKfmR3omoOg7_ofm_H2ooGem@;om_Kf6ooe
mOD2ooKfmP;omOGe7?ofm_H2ooGem@;om_Kf7?oemOD2ooKfmP;omOGeNoof
m_H2ooGem@;om_Kf6ooemOD4ooKfmQcomoOg1?ofm_HLooGem@;om_Kf0_oe
mODKooKfmP;omOGe0_ofm_HNooGem@7ojn_[0OoNg]h1oh>3P`0000?oPh>3
omkNg_o^k^h0?oodm?@NooGem@;om_Kf0_oemODLooKfmP;omOGe0_ofm_HL
ooGem@;om_Kf0_oemOEKooKfmP;omOGe0_ofm_HKooGem@;om_Kf0_oemODL
ooKfmP;omOGe0_ofm_HLooGem@;om_Kf0_oemOEkooKfmP;omOGe0_ofm_HK
ooGem@;om_Kf0_oemODLooKfmP;omOGe0_ofm_IMooGem@7ojn_[0OoMgMd1
oh>3P`0000?oPh>3omkNg_o^k^h0?oodm?@NooGem@;om_Kf0_oemODLooKf
mP;omOGe0_ofm_HLooGem@;om_Kf0_oemOEKooKfmP;omOGe0_ofm_HKooGe
m@;om_Kf0_oemODLooKfmP;omOGe0_ofm_HLooGem@;om_Kf0_oemOEkooKf
mP;omOGe0_ofm_HKooGem@;om_Kf0_oemODLooKfmP;omOGe0_ofm_IMooGe
m@7ojn_[0OoMgMd1oh>3P`0000?oPh>3omkNg_o^k^h0?oodm?@NooGem@;o
m_Kf0_oemODLooKfmP;omOGe0_ofm_HLooGem@;om_Kf0_oemOEKooKfmP;o
mOGe0_ofm_HKooGem@;om_Kf0_oemODLooKfmP;omOGe0_ofm_HLooGem@;o
m_Kf0_oemOEkooKfmP;omOGe0_ofm_HKooGem@;om_Kf0_oemODLooKfmP;o
mOGe0_ofm_IMooGem@7ojn_[0OoMgMd1oh>3P`0000?oPh>3omkNg_o^k^h0
?oodm?@NooGem@;om_Kf0_oemODLooKfmP;omOGe0_ofm_HLooGem@;om_Kf
0_oemOEKooKfmP;omOGe0_ofm_HKooGem@;om_Kf0_oemODLooKfmP;omOGe
0_ofm_HLooGem@;om_Kf0_oemOEkooKfmP;omOGe0_ofm_HKooGem@;om_Kf
0_oemODLooKfmP;omOGe0_ofm_IMooGem@7ojn_[0OoMgMd1oh>3P`0000?o
Ph>3omkNg_o^k^h0?oodm?@NooGem@;om_Kf0_oemODLooKfmP;omOGe0_of
m_HLooGem@;om_Kf0_oemOEKooKfmP;omOGe0_ofm_HKooGem@;om_Kf0_oe
mODLooKfmP;omOGe0_ofm_HLooGem@;om_Kf0_oemOEkooKfmP;omOGe0_of
m_HKooGem@;om_Kf0_oemODLooKfmP;omOGe0_ofm_IMooGem@7ojn_[0OoN
g]h1oh>3P`0000?oPh>3omkNg_o^k^h0?oodm?@NooGem@;om_Kf0_oemODL
ooKfmP;omOGe0_ofm_HLooGem@;om_Kf0_oemOEKooKfmP;omOGe0_ofm_HK
ooGem@;om_Kf0_oemODLooKfmP;omOGe0_ofm_HLooGem@;om_Kf0_oemOEk
ooKfmP;omOGe0_ofm_HKooGem@;om_Kf0_oemODLooKfmP;omOGe0_ofm_IM
ooGem@7ojn_[0OoNg]h1oh>3P`0000?oPh>3omkNg_o]kNd06_oclo<6ooCd
m0Kolo?c6Oodm?@NooGem@;om_Kf0_oemODLooKfmP;omOGe0_ofm_HLooGe
m@;om_Kf0_oemOEKooKfmP;omOGe0_ofm_HKooGem@;om_Kf0_oemODLooKf
mP;omOGe0_ofm_HLooGem@;om_Kf0_oemODkooKfmP;omOGe0_ofm_HLooGe
m@;om_Kf0_oemODLooKfmP;omOGe0_ofm_HKooGem@;om_Kf0_oemODLooKf
mP;omOGe0_ofm_HmooGemB3om?Cd0Oo/k>`1omkNgP7oPh>300000on3Ph?o
g]kNonc/k00Joo;blPcolo?c6Oodm?CoooGemEkomOGe8?odm?BNooGemB3o
m?Cd0Oo/k>`1omoOg`7oPh>300000on3Ph?og]kNonc/k00Joo7al@Col_;b
0_oclo<2oo;blPColo?cFOodm?@PooGemIkom?Cd8?oemOGgooCdm0Kolo?c
1_odm?@Joo?cl`7ojn_[0OoPh>01oh>3P`0000?oPh>3omkNg_o/k>`06_oa
lO44oo;blP;olo?c0_obl_84oo?cleWom?Cd8?oemOFNooCdm23omOGemood
m?@6oo?cl`Kom?Cd6_oclo<1on_[j`7oh>3P0On3Ph<00003oh>3PooNg]ko
jn_[01[ol?3`1?oalO44oo;blPColo?cFOodm?@PooGemIkom?Cd8?oemODi
ooCdm0Kolo?c1_odm?@Doo?cl`Kom?Cd1_oclo>BooCdm0colo?c6_obl_81
onc/k07oh>3P0On3Ph<00003oh>3PooNg]kojn_[01[ol?3`1?oalO44oo;b
lPColo?cFOodm?@PooGemIkom?Cd8?oemODiooCdm0Kolo?c1_odm?@Doo?c
l`Kom?Cd1_oclo>BooCdm0colo?c6_obl_81onc/k07ohN7Q0On3Ph<00003
oh>3PooNg]kojn_[01[ol?3`1?oalO44oo;blPColo?cFOodm?@PooGemIko
m?Cd8?oemODiooCdm0Kolo?c1_odm?@Doo?cl`Kom?Cd1_oclo>BooCdm0co
lo?c6_obl_81onc/k07ohN7Q0On3Ph<00003oh>3PooNg]kojn_[01[ol?3`
1?oalO44oo;blPColo?cFOodm?@PooGemIkom?Cd8?oemODiooCdm0Kolo?c
1_odm?@Doo?cl`Kom?Cd1_oclo>BooCdm0colo?c6_obl_81onc/k07ohN7Q
0On3Ph<00003oh>3PooNg]kojn_[01[ol?3`1?oalO44oo;blPColo?cFOod
m?@PooGemIkom?Cd8?oemODiooCdm0Kolo?c1_odm?@Doo?cl`Kom?Cd1_oc
lo>BooCdm0colo?c6_obl_81onc/k07ohN7Q0On3Ph<00003oh>3PooNg]ko
jn_[01[ol?3`1?oalO44oo;blPColo?cFOodm?@PooGemIkom?Cd8?oemODi
ooCdm0Kolo?c1_odm?@Doo?cl`Kom?Cd1_oclo>BooCdm0colo?c6_obl_81
onc/k07oh>3P0On3Ph<00003oh>3PooNg]kojn_[01[ol?3`1?oalO44oo;b
lPColo?cFOodm?@PooGemIkom?Cd8?oemODiooCdm0Kolo?c1_odm?@Doo?c
l`Kom?Cd1_oclo>BooCdm0colo?c6_obl_81onc/k07oh>3P0On3Ph<00003
oh>3PooNg]kojn_[01kol?3`0_oalO42oo;blUOolo?c1_odm?@6oo?claCo
m?Cd1_oclo<5ooCdm9?olo?c1_odm?@6oo?claCom?Cd1_oclo<6ooCdm?Oo
lo?c8?obl_81on_[j`7oh>3P0On3Ph<00003oh>3PooMgMgojn_[01kol?3`
0_oalO42oo;blUOolo?c1_odm?@6oo?claCom?Cd1_oclo<5ooCdm9?olo?c
1_odm?@6oo?claCom?Cd1_oclo<6ooCdm1Wolo?c8?obl_:noo?clb3ol_;b
0Oo[jn/1omoOg`7oPh>300000on3Ph?og]kNon[ZjP0Joo7al@Col_;b0_oc
lo<2oo;blPColo?c/_odm?@6oo?cl`Kom?Cd<ooclo<6ooCdm0Kolo?cE?od
m?@5oo?cl`Kom?CdE?oclo<6ooCdm0Kolo?c4oodm?@6oo?cl`Kom?Cd5?oc
lo<6ooCdm0Kolo?c<oodm?@<oo?cla[ol_;b0Oo[jn/1omkNgP7oPh>30000
0on3Ph?ogMgMon[ZjP0Joo7al@Col_;b0_oclo<2oo;blPColo?c/_odm?@6
oo?cl`Kom?Cd<ooclo<6ooCdm0Kolo?cE?odm?@;oo?cla[ol_;b>_oclo<6
ooCdm0Kolo?c4oodm?@6oo?cl`Kom?Cd5?oclo<6ooCdm0Kolo?c<oodm?@<
oo?cla[ol_;b0Oo[jn/1omgMg@7oPh>300000on3Ph?ogMgMon[ZjP0Noo7a
l@Col_;b_?oclo<ooo;blUgolo?c1?obl_8Loo7al@Col_;b7_oclo<Poo;b
lQoolo?c8?obl_8ooo?clb3ol_;b0OoZj^X1omgMg@7oPh>300000on3Ph?o
gMgMon[ZjP0Noo7al@Col_;b_?oclo<ooo;blUgolo?c1?obl_8Loo7al@Co
l_;b7_oclo<Poo;blQoolo?c8?obl_8ooo?clb3ol_;b0OoZj^X1omcLg07o
Ph>300000on3Ph?ogMgMon[ZjP0Noo7al@Col_;b_?oclo<ooo;blUgolo?c
1?obl_8Loo7al@Col_;b7_oclo<Poo;blQoolo?c8?obl_8ooo?clb3ol_;b
0OoZj^X1omcLg07oPh>300000on3Ph?ogMgMon[ZjP0Noo7al@Col_;b_?oc
lo<ooo;blUgolo?c1?obl_8Loo7al@Col_;b7_oclo<Poo;blQoolo?c8?ob
l_8ooo?clb3ol_;b0OoZj^X1omcLg07oPh>300000on3Ph?ogMgMon[ZjP0N
oo7al@Col_;b_?oclo<ooo;blQKolo?c00?olO7aom7AdOoKfm/01Ooclo<0
0oo`l?3ohn?Soo?cl`0loo?cl`Col_;b7?oalO44oo;blQkolo?c8?obl_8O
oo?clb3ol_;b?ooclo<Poo;blP7oj^[Z0OoLg=`1oh>3P`0000?oPh>3omgM
gOoZj^X07_o`l?02oo7al@;ol_;b_?oclo<ooo;blQGolo?c00KoYjNWo`T9
2Ol<30co8R8Roc<c<onOWil2oo?cl`06okJf]_lI6AWo1PH6odi>C_moOgoo
;Bd]0_oclo<01_ll?3coNGUioo?clooclo?oVi^KoaXJ6S;olo?c1?obl_8L
oo7al@Col_;b7_oclo<Poo;blQoolo?c8?obl_8moo?cl`Col_;b7_oalO41
on[ZjP7og=cL0On3Ph<00003oh>3PooMgMgoj^[Z01kol?3`0_oalO42oo;b
l[colo?c?oobl_8Eoo?cl`0>ol_;bonf][Kok^k^oo?clonEUIGo0`<3om?C
dooclo?oD51@oeADE?o[jn_oUYJFo`h>3_l];Bd2oo?cl`06oc`l??miNGWo
lo?coo?clonKVi_o6QXJ<_oclo<4oo;blQcolO7a1?obl_8Noo?clb3ol_;b
7ooclo<Poo;blSgolo?c1?obl_8Noo7al@7oj^[Z0OoLg=`1oh>3P`0000?o
Ph>3omgMgOoZj^X07_o`l?02oo7al@;ol_;b_?oclo<ooo;blQWolo?c00Ko
e]KFo`000?n][Jgolo?cobTY:On9RHT2oo?cl`06ogAdM?l];Bgolo?coo?c
loll?3coNGUi0_oclo<00onKVi_o6QXJoo?cl`0aoo?cl`Col_;b7?oalO44
oo;blQkolo?c8?obl_8Ooo?clb3ol_;b?Ooclo<4oo;blQkolO7a0OoZj^X1
omcLg07oPh>300000on3Ph?ogMgMon[ZjP0Noo3`l0ColO7a?Oobl_8Poo?c
lb3ol_;b7ooclo<Noo;blP;olO7a0_obl_8koo7al@;ol_;b0_oalO4Foo;b
lP0;on?Shom:BT[o1`L7onGUiOobl_;o:BTYoh^;Roobl_;olo?cohR8R?l]
;Bd00_oclo<01_ll?3coNGUioo?clooclo?oVi^KoaXJ6QGolo?c?oobl_8N
oo?cl`Col_;b7?oalO42oo;blP;olO7a?Oobl_8moo?cl`;ol_;b0_oalO4N
oo3`l07oj^[Z0OoLg=`1oh>3P`0000?oPh>3omcLg?oZj^X07_o`l?04oo7a
lK[ol_;b0_oalO42oo;blS_olO7a0_obl_82oo7alAGol_;b00Co[:b/oaXJ
6_lE5AGo];Bd0_obl_801_lY:BWoRh^;oo;bl_obl_;oQhN7obd];@;ol_;b
00Ko?3`loeQHF?obl_;ol_;boiBDU?lK6a/Coo;blP;olO7a0_obl_8koo7a
l@;ol_;b0_oalO6joo;blP;olO7a0_oalO8Noo3`l@7ojn_[0OoLg=`1oh>3
P`0000?oPh>3omcLg?oZj^X08?o`l?0moo7al@;ol_;b0_oalO4Loo;blP;o
lO7a0_obl_8Loo7al@;ol_;b0_oalO4Koo;blP;olO7a0_obl_8Noo7alCoo
l?3`5_oalO401?miNGWo0000oe5ADOoIfMT3oo7al@06obTY:On;Rh_ol_;b
oo7alOn7QhOo;Bd]0_obl_801_ll?3co4Q8Bofm_KooBd];oDU9BodU9BA?o
l_;b1?oalO4Koo3`l0ColO7a??obl_82oo7al@;ol_;b>ooalO42oo;blP;o
lO7aE?obl_87oo7alP;ol?3a0_oalO48oo3`l1Kokno`0Oo[jn/1omcLg07o
Ph>300000on3Ph?og=cLon[ZjP0Poo3`l3golO7a0_obl_82oo7alAcol_;b
0_oalO42oo;blQcolO7a0_obl_82oo7alA_ol_;b0_oalO42oo;blQkolO7a
?oo`l?0Eoo7al@03omWIfOl10@7oRXZ:00GolO7a00Ko?clooiFEUOobl_;o
lO7aoi:BT_m2@T82oo;blP06odm?Con4Q8CoLW9boa8B4_l[:b_o^[Zj4oob
l_84oo7alA_ol?3`1?oalO4loo;blP;olO7a0_obl_8koo7al@;ol_;b0_oa
lO5Doo;blPOolO7b0_o`l?42oo7al@Sol?3`5_o_ko01on_[j`7og=cL0On3
Ph<00003oh>3PooLg=coj^[Z01Kokno_5?o`l?0coo7al@;ol_;b0_oalO4L
oo;blP;olO7a0_obl_8Loo7al@;ol_;b0_oalO4Koo;blP;olO7a0_obl_8N
oo7alCool?3`5OoalO400oo<c<co0@41om[JfP06oo7al@;ol_;b0_oalO46
oo;blP03oo7alOobl_;ol_;b01?ol_;b1?oalO4Koo3`l0ColO7a??obl_82
oo7al@;ol_;b>ooalO42oo;blP;olO7aE?obl_87oo7al@;ol?3`0_o`l?48
ono_l1Kok^k_0Oo[jn/1omcLg07oPh>300000on3Ph?og=cLon[ZjP0Fono_
kaCol?3`<ooalO42oo;blP;olO7a7?obl_82oo7al@;ol_;b7?oalO42oo;b
lP;olO7a6oobl_82oo7al@;ol_;b7_oalO4ooo3`l1KolO7a00GoADE5ocHf
=_n6QXKoG5aLoe=CD`03oo7al@;ol_;b0_oalO4Loo;blPColO7a6oo`l?04
oo7alCcol_;b0_oalO42oo;blS_olO7a0_obl_82oo7alECol_;b1ooalO42
oo3`l0;ol?3a2?o_ko0Fonk^k`7ojn_[0OoLg=`1oh>3P`0000?oPh>3omcL
g?oZj^X05_o_knlDoo3`l3?olO7a0_obl_82oo7alAcol_;b0_oalO42oo;b
lQcolO7a0_obl_82oo7alA_ol_;b0_oalO42oo;blQkolO7a?oo`l?0Foo7a
l@05ong]kOn/[:coIfMWoh20P?nd];@00ooalO42oo;blP;olO7a7?obl_84
oo7alA_ol?3`1?oalO4loo;blP;olO7a0_obl_8koo7al@;ol_;b0_oalO5D
oo;blPOolO7a0_o`l?02oo3`l@Sokno`5_o^k^l1on_[j`7og=cL0On3Ph<0
0003oh>3PooLg=coj^[Z01Kokno_5?o`l?0coo7al@;ol_;b0_oalO4Loo;b
lP;olO7a0_obl_8Loo7al@;ol_;b0_oalO4Koo;blP;olO7a0_obl_8Noo7a
lCool?3`7_oalO42oo;blP;olO7a7?obl_84oo7alA_ol?3`1?oalO4loo;b
lP;olO7a0_obl_8koo7al@;ol_;b0_oalO5Doo;blPOolO7a0_o`l?02oo3`
l@Sokno`5_o^k^l1on_[j`7og=cL0On3Ph<00003oh>3PooLg=coj^[Z01Ko
kno_5?o`l?0coo7al@;ol_;b0_oalO4Loo;blP;olO7a0_obl_8Loo7al@;o
l_;b0_oalO4Koo;blP;olO7a0_obl_8Noo7alCool?3`7_oalO42oo;blP;o
lO7a7?obl_84oo7alA_ol?3`1?oalO4loo;blP;olO7a0_obl_8koo7al@;o
l_;b0_oalO5Doo;blPOolO7a0_o`l?02oo3`l@Sokno`5_o^k^l1on_[j`7o
g=cL0On3Ph<00003oh>3PooLg=coj^[Z023ol?3`?OoalO42oo;blP;olO7a
7?obl_84oo7alAcol?3`1?oalO4Koo;blP;olO7a0_obl_8Noo7alAKol?3`
2_o_knl:oo3`l0_okno_5?o`l?0Doo7al@;ol_;b0_oalO4Loo;blPColO7a
7Oo`l?0Noo7al@;ol_;b0_oalO4Loo;blP;olO7a0_obl_8koo7al@;ol_;b
0_oalO5Doo;blPOolO7b0_o`l?42oo7al@Sol?3`5_o_ko01on_[j`7og=cL
0On3Ph<00003oh>3PooKfm_oj^[Z023ol?3`?OoalO42oo;blP;olO7a7?ob
l_84oo7alAcol?3`1?oalO4Koo;blP;olO7a0_obl_8Noo7alAKol?3`2_o_
knl:oo3`l0_okno_5?o`l?0Doo7al@;ol_;b0_oalO4Loo;blPColO7a7Oo`
l?0Noo7al@;ol_;b0_oalO4Loo;blP;olO7a0_obl_8koo7al@;ol_;b0_oa
lO5Doo;blPOolO7b0_o`l?42oo7al@Sol?3`5_o_ko01on_[j`7og=cL0On3
Ph<00003oh>3PooKfm_oj^[Z023ol?3`GooalO4Poo3`l3oolO7a5_o`l?0:
ono_k`[ol?3`2oo_knlDoo3`l3KolO7a?oo`l?2eoo7al@Wol?3a2_o`l?0F
ono_l07ojn_[0OoLg=`1oh>3P`0000?oPh>3om_KfooZj^X05_o_knlDoo3`
l1GolO7a8?o`l?0Poo7alAkol?3`1?oalO4Koo;blPColO7aOOo`l?0Poo7a
lAool?3`_OoalO42oo;blP;olO7a5?obl_87oo7al@;ol?3`0_oalO48oo3`
l1Kokno_0OoZj^X1omgMg@7oPh>300000on3Ph?ofm_Kon[ZjP0Fono_kaCo
l?3`5OoalO5Poo3`l1oolO7ao_o`l?0ooo7alD3ol?3`5_oalO4Coo3`l1Ko
kno_0OoZj^X1omgMg@7oPh>300000on3Ph?of][Jon[ZjP0Fono_kaCol?3`
5OoalO5Poo3`l1oolO7ao_o`l?0ooo7alD3ol?3`5_oalO4Coo3`l1Kokno_
0OoZj^X1omgMg@7oPh>300000on3Ph?of][Jon[ZjP0Fono_kaCol?3`5Ooa
lO5Poo3`l1oolO7ao_o`l?0ooo7alD3ol?3`5_oalO4Coo3`l1Kokno_0OoZ
j^X1omgMg@7oPh>300000on3Ph?of][Jon[ZjP0Poo3`l1oolO7a=_o`l?0:
ono_k`[ol?3`3?o_knlCoo3`l1KolO7a=_o`l?0:ono_k`[ol?3`2oo_knl:
oo3`l0[okno_C?o`l?09ono_k`[ol?3`3?o_knl:oo3`l0[okno_5_o`l?0o
oo7alD3ol?3`7ooalO4Poo3`l07oj^[Z0OoMgMd1oh>3P`0000?oPh>3om[J
f_oZj^X08?o`l?0Ooo7alCKol?3`2_o_knl:oo3`l0cokno_4oo`l?0Foo7a
lCKol?3`2_o_knl:oo3`l0_okno_2_o`l?0:ono_kdcol?3`2Oo_knl:oo3`
l0cokno_2_o`l?0:ono_kaKol?3`?ooalO50oo3`l1oolO7a8?o`l?01on[Z
jP7ogMgM0On3Ph<00003oh>3PooJf][oj^[Z023ol?3`7ooalO4foo3`l0[o
kno_2_o`l?0<ono_ka?ol?3`5_oalO4foo3`l0[okno_2_o`l?0;ono_k`[o
l?3`2_o_knm<oo3`l0Wokno_2_o`l?0<ono_k`[ol?3`2_o_knlFoo3`l3oo
lO7a@?o`l?0Ooo7alB3ol?3`0OoZj^X1omgMg@7oPh>300000on3Ph?of][J
on[ZjP0Poo3`l1oolO7a=_o`l?0:ono_k`[ol?3`3?o_knlCoo3`l1KolO7a
=_o`l?0:ono_k`[ol?3`2oo_knl:oo3`l0[okno_C?o`l?09ono_k`[ol?3`
3?o_knl:oo3`l0[okno_5_o`l?0ooo7alD3ol?3`7ooalO4Poo3`l07oj^[Z
0OoMgMd1oh>3P`0000?oPh>3om[Jf_oYjNT05_o_knl:oo3`l0[okno_3?o`
l?09ono_k`[ol?3`C?o_knl:oo3`l0Wokno_3?o`l?0:ono_k`[ol?3`Joo_
knl:oo3`l0[okno_;?o`l?09ono_k`[ol?3`;?o_knl:oo3`l0[okno_:oo`
l?0:ono_k`[ol?3`3?o_knl:oo3`l0[okno_;?o`l?09ono_k`[ol?3`5_o_
knl1on[ZjP7ogMgM0On3Ph<00003oh>3PooJf][ojNWY01Kokno_2_o`l?0:
ono_k`col?3`2Oo_knl:oo3`l4cokno_2_o`l?09ono_k`col?3`2_o_knl:
oo3`l6_okno_2_o`l?0:ono_kbcol?3`2Oo_knl:oo3`l2cokno_2_o`l?0:
ono_kb_ol?3`2_o_knl:oo3`l0cokno_2_o`l?0:ono_kbcol?3`2Oo_knl:
oo3`l1Kokno_0OoZj^X1omcLg07oPh>300000on3Ph?of][JonWYj@0Fono_
k`[ol?3`2_o_knl<oo3`l0Wokno_2_o`l?1<ono_k`[ol?3`2Oo_knl<oo3`
l0[okno_2_o`l?1[ono_k`[ol?3`2_o_knl/oo3`l0Wokno_2_o`l?0/ono_
k`[ol?3`2_o_knl[oo3`l0[okno_2_o`l?0<ono_k`[ol?3`2_o_knl/oo3`
l0Wokno_2_o`l?0Fono_k`7oj^[Z0OoLg=`1oh>3P`0000?oPh>3om[Jf_oX
j>P08?o^k^ieono_k`[ol?3`2Oo_knm<oo3`l1Cokno_2oo^k^hDono_kdco
l?3`2Oo_knl:oo3`l2cokno_2_o`l?0:ono_kb_ol?3`2_o_knl:oo3`l0co
kno_2_o`l?0:ono_kbcol?3`2Oo_knl:oo3`l1Kokno_0OoYjNT1om[JfP7o
Ph>300000on3Ph?ofMWIonOWi`0Nong]k@Cok^k^7Oo_knlPonk^kSKokno_
2_o`l?09ono_kdcol?3`5?o_knl;onk^kQCokno_C?o`l?09ono_k`[ol?3`
;?o_knl:oo3`l0[okno_:oo`l?0:ono_k`[ol?3`3?o_knl:oo3`l0[okno_
;?o`l?0Cono_kaKok^k^0OoXj>P1omWIf@7oPh>300000on3Ph?ofMWIonOW
i`0Nong]k@Cok^k^7Oo_knlPonk^kSKokno_2_o`l?09ono_kdcol?3`5?o_
knl;onk^kQCokno_C?o`l?09ono_k`[ol?3`;?o_knl:oo3`l0[okno_:oo`
l?0:ono_k`[ol?3`3?o_knl:oo3`l0[okno_;?o`l?0Cono_kaKok^k^0OoX
j>P1omSHf07oPh>300000on3Ph?ofMWIonOWi`0Nong]k@Cok^k^7Oo_knlP
onk^kSKokno_2_o`l?09ono_kdcol?3`5?o_knl;onk^kQCokno_C?o`l?09
ono_k`[ol?3`;?o_knl:oo3`l0[okno_:oo`l?0:ono_k`[ol?3`3?o_knl:
oo3`l0[okno_;?o`l?0Cono_kaKok^k^0OoXj>P1omSHf07oPh>300000on3
Ph?ofMWIonKViP0Nonc/k0CokNg]6oo^k^h2ong]k@;ok^k^7?o]kNd2onk^
kP;okNg]7_o^k^ioono_kaook^k^5_o_knl:oo3`l0[okno_;?o`l?09ono_
k`[ol?3`5_o_knlPonk^kSookno_5_o^k^hDono_k`col?3`2_o_knl:oo3`
l1?okno_1?o^k^hNong]k@7oj>SX0OoHf=P1oh>3P`0000?oPh>3omWIfOoV
i^H07_o/k>`4ong]kA_ok^k^0_o]kNd2onk^kQcokNg]0_o^k^h2ong]kAko
k^k^Ooo_knlOonk^kQKokno_2_o`l?0:ono_kbcol?3`2Oo_knl:oo3`l1Ko
kno_8?o^k^hoono_kaKok^k^5?o_knl<oo3`l0[okno_2_o`l?0Cono_k`Co
k^k^7_o]kNd1onSXj07of=SH0On3Ph<00003oh>3PooIfMWoi^KV01kok>c/
1?o]kNdKonk^kP;okNg]0_o^k^hLong]k@;ok^k^0_o]kNdNonk^kWookno_
7oo^k^hFono_k`[ol?3`2_o_knl/oo3`l0Wokno_2_o`l?0Fono_kb3ok^k^
?oo_knlFonk^kQCokno_3?o`l?0:ono_k`[ol?3`4oo_knl4onk^kQkokNg]
0OoXj>P1omSHf07oPh>300000on3Ph?ofMWIonKViP0Nonc/k0CokNg]6oo^
k^h2ong]k@;ok^k^7?o]kNd2onk^kP;okNg]7_o^k^ioono_kaook^k^5_o_
knl:oo3`l0[okno_;?o`l?09ono_k`[ol?3`5_o_knlPonk^kSookno_5_o^
k^hDono_k`col?3`2_o_knl:oo3`l1?okno_1?o^k^hNong]k@7oj>SX0OoH
f=P1oh>3P`0000?oPh>3omWIfOoVi^H07_o/k>`4ong]kA_ok^k^0_o]kNd2
onk^kQcokNg]0_o^k^h2ong]kAkok^k^Ooo_knlOonk^kWookno_8?o^k^ho
ono_kb3ok^k^?Oo_knl4onk^kQkokNg]0OoWinL1omOGe`7oPh>300000on3
Ph?ofMWIonKViP0Nonc/k0CokNg]6oo^k^h2ong]k@;ok^k^7?o]kNd2onk^
kP;okNg]7_o^k^ioono_kaook^k^Ooo_knlPonk^kSookno_8?o^k^hPono_
kagok^k^1?o]kNdNonc/k07oinOW0OoGemL1oh>3P`0000?oPh>3omWIfOoV
i^H07_o/k>`4ong]kA_ok^k^0_o]kNd2onk^kQcokNg]0_o^k^h2ong]kAko
k^k^Ooo_knlOonk^kWookno_8?o^k^hoono_kb3ok^k^8?o_knlMonk^kPCo
kNg]7_o/k>`1onOWi`7oemOG0On3Ph<00003oh:2P_oIfMWoi^KV01kokNg]
0_o^k^h2ong]kA_ok^k^1?o]kNdLonc/k0CokNg]7?o^k^h2ong]k@;ok^k^
7?o]kNd2onk^kP;okNg]W?o^k^iOono_kb3ok^k^8?o_knleonk^kQCokno_
3?o`l?08ono_k`;ok^k^0_o_knl8onk^kQGokNg]8?o/k>`1onSXj07of=SH
0On2PX800003oh:2P_oJf][oiNGU03gok^k^1?o]kNdLonc/k0CokNg]7?o^
k^h4ong]kAkok>c/7Oo]kNd2onk^kP;okNg]WOo^k^hmono_k`Cok^k^7?o]
kNd4onk^kQcokno_1?o^k^hKong]k@;ok^k^0_o]kNdDonk^kQCokno_3?o`
l?08ono_k`Cok^k^2?o]kNdeonc/k07oj>SX0OoHf=P1oh:2PP0000?oPX:2
om[Jf_oUiND0?Oo^k^h4ong]kAcok>c/1?o]kNdLonk^kPCokNg]7_o/k>`M
ong]k@;ok^k^0_o]kNfMonk^kSgokno_1?o^k^hLong]k@Cok^k^7?o_knl4
onk^kQ_okNg]0_o^k^h2ong]kACok^k^5?o_knl<oo3`l0Sokno_1?o^k^h8
ong]kCGok>c/0OoXj>P1omSHf07oPX:200000on2PX;of][JonGUi@0monk^
kPCokNg]7?o/k>`4ong]kAcok^k^1?o]kNdNonc/k1gokNg]0_o^k^h2ong]
kIgok^k^?Oo_knl4onk^kQcokNg]1?o^k^hLono_k`Cok^k^6oo]kNd2onk^
kP;okNg]5?o^k^hDono_k`col?3`1?o_knl4onk^kP;okNg]0_o^k^h4ong]
k@Cok>c/=Oo[jn/1onSXj07of=SH0On2PX800003oh:2P_oJf][oiNGU03go
k^k^1?o]kNdLonc/k0CokNg]7?o^k^h4ong]kAkok>c/7Oo]kNd2onk^kP;o
kNg]Noo^k^h2ong]k@;ok^k^7?o]kNd2onk^kP;okNg]7Oo^k^hNono_k`Co
k^k^7?o]kNd4onk^kQcokno_1?o^k^hKong]k@;ok^k^0_o]kNdNonk^kQ[o
kno_1?o^k^h4ong]k@Cok>c/>Oo[jn/1onOWi`7oemOG0On2PX800003oh:2
P_oJf][oiNGU03gok^k^1?o]kNdLonc/k0CokNg]7?o^k^h4ong]kAkok>c/
7Oo]kNd2onk^kP;okNg]Noo^k^h2ong]k@;ok^k^7?o]kNd2onk^kP;okNg]
7Oo^k^hNono_k`Cok^k^7?o]kNd4onk^kQcokno_1?o^k^hKong]k@;ok^k^
0_o]kNdNonk^kQ[okno_1?o^k^h4ong]k@Cok>c/>Oo[jn/1onOWi`7oemOG
0On2PX800003oh:2P_oJf][oiNGU03gok^k^1?o]kNdLonc/k0CokNg]7?o^
k^h4ong]kAkok>c/7Oo]kNd2onk^kP;okNg]Noo^k^h2ong]k@;ok^k^7?o]
kNd2onk^kP;okNg]7Oo^k^hNono_k`Cok^k^7?o]kNd4onk^kQcokno_1?o^
k^hKong]k@;ok^k^0_o]kNdNonk^kQ[okno_1?o^k^h4ong]k@Cok>c/>Oo[
jn/1onOWi`7oemOG0On2PX800003oh:2P_oJf][oiNGU03gok^k^1?o]kNdL
onc/k0CokNg]7?o^k^h4ong]kAkok>c/7Oo]kNd2onk^kP;okNg]Noo^k^h2
ong]k@;ok^k^7?o]kNd2onk^kP;okNg]7Oo^k^hNono_k`Cok^k^7?o]kNd4
onk^kQcokno_1?o^k^hKong]k@;ok^k^0_o]kNdNonk^kQ[okno_1?o^k^h4
ong]k@Cok>c/>Oo[jn/1onOWi`7oemOG0On2PX800003oh:2P_oIfMWoiNGU
03gok^k^1?o]kNdLonc/k0CokNg]7?o^k^h4ong]kAkok>c/7Oo]kNd2onk^
kP;okNg]Noo^k^h2ong]k@;ok^k^7?o]kNd2onk^kP;okNg]7Oo^k^hNono_
k`Cok^k^7?o]kNd4onk^kQcokno_1?o^k^hKong]k@;ok^k^0_o]kNdNonk^
kQ[okno_1?o^k^h4ong]k@Cok>c/>Oo[jn/1onOWi`7of=SH0On2PX800003
oh:2P_oIfMWoiNGU03gok^k^1?o]kNdLonc/k0CokNg]7?o^k^h4ong]kAko
k>c/7Oo]kNd2onk^kP;okNg]Noo^k^h2ong]k@;ok^k^7?o]kNd2onk^kP;o
kNg]7Oo^k^hNono_k`Cok^k^7?o]kNd4onk^kQcokno_1?o^k^hKong]k@;o
k^k^0_o]kNdNonk^kQ[okno_1?o^k^h4ong]k@Cok>c/>Oo[jn/1onOWi`7o
f=SH0On2PX800003oh:2P_oIfMWoi>CT03WokNg]3?o/k>`Don_[j`cok>c/
5?o]kNd<onc/k1Cojn_[1_o/k>`5on_[ja[ok>c/_?o]kNd2onk^kP;okNg]
7?o^k^h4ong]kAcok>c/1?o]kNdLonk^kP;okNg]0_o^k^hkong]k@;ok^k^
0_o]kNdHonk^kPCokNg]0_o/k>`2ong]k@Cok>c/>Oo[jn/1onOWi`7of=SH
0On2PX800003oh:2P_oHf=Soi>CT03Wok>c/1_o[jn/6onc/k1Cojn_[1_o/
k>`6on_[jaCok>c/1_o[jn/6onc/k1Cojn_[1_o/k>`5on_[jiWok>c/8?o]
kNdOonc/k23okNg]8?o/k>`oong]kB3ok>c/6_o]kNd<onc/k1Wojn_[8?oZ
j^X1onKViP7ofMWI0On2PX800003oh>3PooHf=Soi>CT03Wojn_[1_o/k>`6
on_[jcCok>c/1_o[jn/6onc/k5?ojn_[1_o/k>`6on_[jk;ok>c/1_o[jn/6
onc/k1Cojn_[1_o/k>`6on_[jc?ok>c/1_o[jn/6onc/k1Cojn_[1_o/k>`6
on_[jaCok>c/1_o[jn/6onc/k1Oojn_[1?oZj^XNonWYj@7oiNGU0OoIfMT1
oh>3P`0000?oPh>3omSHf?oTi>@0>Oo[jn/6onc/k0Kojn_[=?o/k>`6on_[
j`Kok>c/Doo[jn/6onc/k0Kojn_[/_o/k>`6on_[j`Kok>c/5?o[jn/6onc/
k0Kojn_[<oo/k>`6on_[j`Kok>c/5?o[jn/6onc/k0Kojn_[5?o/k>`6on_[
j`Kok>c/5oo[jn/4on[ZjQkojNWY0OoUiND1omWIf@7oPh>300000on3Ph?o
f=SHon?Sh`0oon[ZjT3ojn_[GooZj^YIon_[j`Kok>c/1_o[jn/Donc/k0Ko
jn_[1_o/k>`ion_[jb3oj^[Z6_o[jn/6onc/k0Kojn_[4oo/k>`<on_[ja[o
j^[Z?Oo[jn/4on[ZjQkojNWY0OoUiND1omWIf@7oPh>300000on3Ph?oemOG
on?Sh`0oon[ZjT3ojn_[GooZj^YIon_[j`Kok>c/1_o[jn/Donc/k0Kojn_[
1_o/k>`ion_[jb3oj^[Z6_o[jn/6onc/k0Kojn_[4oo/k>`<on_[ja[oj^[Z
?Oo[jn/4on[ZjQkojNWY0OoUiND1om[JfP7oPh>300000on3Ph?oemOGon?S
h`0oon[ZjT3ojn_[GooZj^YIon_[j`Kok>c/1_o[jn/Donc/k0Kojn_[1_o/
k>`ion_[jb3oj^[Z6_o[jn/6onc/k0Kojn_[4oo/k>`<on_[ja[oj^[Z?Oo[
jn/4on[ZjQkojNWY0OoUiND1om[JfP7oPh>300000on3Ph?oemOGon?Sh`0o
on[ZjT3ojn_[GooZj^YIon_[j`Kok>c/1_o[jn/Donc/k0Kojn_[1_o/k>`i
on_[jb3oj^[Z6_o[jn/6onc/k0Kojn_[4oo/k>`<on_[ja[oj^[Z?Oo[jn/4
on[ZjQkojNWY0OoUiND1om[JfP7oPh>300000on3Ph?oemOGon?Sh`0oon[Z
jT3ojn_[GooZj^YIon_[j`Kok>c/1_o[jn/Donc/k0Kojn_[1_o/k>`ion_[
jb3oj^[Z6_o[jn/6onc/k0Kojn_[4oo/k>`<on_[ja[oj^[Z?Oo[jn/4on[Z
jQkojNWY0OoUiND1om[JfP7oPh>300000on3Ph?oemOGon?Sh`0monWYj@Co
j^[Z?_o[jn/mon[ZjP;ojNWY0_oZj^XLonWYj@Coj^[Z_?o[jn/Pon[ZjQ[o
jn_[1_o/k>`6on_[ja?ok>c/1?o[jn/2on[ZjP;ojn_[1?oZj^XHonWYj@Co
j^[Z7_o[jn/Mon[ZjPCojNWY7_oXj>P1onGUi@7ofMWI0On3Ph<00003oh>3
PooGemOohn?S03gojNWY1?oZj^Xnon_[jcgoj^[Z0_oYjNT2on[ZjQcojNWY
1?oZj^Zlon_[jb3oj^[Z6_o[jn/6onc/k0Kojn_[4oo/k>`4on_[j`;oj^[Z
0_o[jn/4on[ZjQSojNWY1?oZj^XNon_[jagoj^[Z1?oYjNTNonSXj07oiNGU
0OoIfMT1oh>3P`0000?oPh>3omOGeooShn<0?OoYjNT4on[ZjSkojn_[?OoZ
j^X2onWYj@;oj^[Z7?oYjNT4on[ZjUgojn_[8?oZj^Xoon_[jb3oj^[Z?Oo[
jn/4on[ZjQcojNWY1?oZj^XNon_[jagoj^[Z1?oYjNTNonSXj07oiNGU0OoI
fMT1oh>3P`0000?oPh>3omKFe_oShn<0?OoXj>P4onWYjCcoj^[Z0_oYjNT2
on[ZjSgojNWY7_oXj>P4onWYjE_oj^[Z0_oYjNT2on[ZjQcojNWY0_oZj^X2
onWYjC_oj^[Z0_oYjNT2on[ZjQcojNWY0_oZj^X2onWYjC_oj^[Z1?oYjNTL
onSXj0CojNWY7?oZj^X2onWYj@;oj^[Z5?oYjNTConSXj1KoinOW0OoUiND1
omSHf07oPh>300000on2PX;oeMGEon;RhP1MonWYj@;oj^[Z0_oYjNUKon[Z
jP;ojNWY0_oZj^YkonWYj@;oj^[Z0_oYjNTkon[ZjP;ojNWY0_oZj^YLonWY
j@;oj^[Z0_oYjNTKon[ZjP;ojNWY0_oZj^YDonWYjA?oj>SX5_oWinL1onCT
i07ofMWI0On2PX800003oh:2P_oDe=Coh^;R05ooj>SXGooYjNUoonSXj3oo
jNWYH?oXj>POonWYjEKoj>SX4ooWinLFonKViP7oi>CT0OoHf=P1oh:2PP00
00?oPX:2omCDe?oRh^80GooXj>QOonWYjIooj>SX7ooYjNWEonSXj1?oinOW
5_oVi^H1onCTi07of=SH0On2PX800003oh:2P_oDe=Coh^;R03KoinOW2OoX
j>P:onOWiaKoj>SXEOoYjNTDonSXj0coinOW2_oXj>P:onOWid_oj>SX2_oW
inL:onSXj0coinOW5?oXj>PEonWYjGGoj>SX2_oWinL:onSXj0coinOW2_oX
j>P:onOWi`coj>SX2_oWinL:onSXj1?oinOW1?oVi^HNonGUi@7oi>CT0OoG
emL1oh:2PP0000?oPX:2omCDe?oRh^80=_oWinL9onSXj0[oinOW5_oXj>QE
onWYjACoj>SX3?oWinL:onSXj0[oinOWBooXj>P:onOWi`[oj>SX3?oWinLD
onSXj1GojNWYMOoXj>P:onOWi`[oj>SX3?oWinL:onSXj0[oinOW3?oXj>P:
onOWi`[oj>SX4ooWinL4onKViQkoiNGU0OoTi>@1omOGe`7oPX:200000on2
PX;oe=CDon;RhP0fonOWi`Woj>SX2_oWinLFonSXj5GojNWY5?oXj>P<onOW
i`[oj>SX2_oWinM;onSXj0[oinOW2_oXj>P<onOWiaCoj>SX5OoYjNUeonSX
j0[oinOW2_oXj>P<onOWi`[oj>SX2_oWinL<onSXj0[oinOW2_oXj>PConOW
i`Coi^KV7_oUiND1onCTi07oemOG0On2PX800003oh:2P_oDe=Coh^;R03Ko
inOW2OoXj>P:onOWiaKoj>SXEOoYjNTDonSXj0coinOW2_oXj>P:onOWid_o
j>SX2_oWinL:onSXj0coinOW5?oXj>PEonWYjGGoj>SX2_oWinL:onSXj0co
inOW2_oXj>P:onOWi`coj>SX2_oWinL:onSXj1?oinOW1?oVi^HNonGUi@7o
i>CT0OoGemL1oh:2PP0000?oPX:2omCDe?oRh^80=_oWinL9onSXj0[oinOW
5_oXj>QEonWYjACoj>SX3?oWinL:onSXj0[oinOWBooXj>P:onOWi`[oj>SX
3?oWinLDonSXj1GojNWYMOoXj>P:onOWi`[oj>SX3?oWinL:onSXj0[oinOW
3?oXj>P:onOWi`[oj>SX4ooWinL4onKViQkoiNGU0OoTi>@1omOGe`7oPX:2
00000on2PX;oe=CDon;RhP0fonOWi`Woj>SX2_oWinLFonSXj5GojNWY5?oX
j>P<onOWi`[oj>SX2_oWinM;onSXj0[oinOW2_oXj>P<onOWiaCoj>SX5OoY
jNUeonSXj0[oinOW2_oXj>P<onOWi`[oj>SX2_oWinL<onSXj0[oinOW2_oX
j>PConOWi`Coi^KV7_oUiND1onCTi07oemOG0On2PX800003oh:2P_oDe=Co
h^;R03KoinOW2OoXj>P:onOWiaKoj>SXEOoYjNTDonSXj0coinOW2_oXj>P:
onOWid_oj>SX2_oWinL:onSXj0coinOW5?oXj>PEonWYjGGoj>SX2_oWinL:
onSXj0coinOW2_oXj>P:onOWi`coj>SX2_oWinL:onSXj1?oinOW1?oVi^HN
onGUi@7oi>CT0OoGemL1oh:2PP0000?oPX:2omCDe?oRh^80=_oWinL9onSX
j0[oinOW5_oXj>QEonWYjACoj>SX3?oWinL:onSXj0[oinOWBooXj>P:onOW
i`[oj>SX3?oWinLDonSXj1GojNWYMOoXj>P:onOWi`[oj>SX3?oWinL:onSX
j0[oinOW3?oXj>P:onOWi`[oj>SX4ooWinL4onKViQkoiNGU0OoTi>@1omOG
e`7oPX:200002_n2PX;oe=CDomcLg?oRh^;oi^KVon?ShooVi^KoiNGUonCT
i?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGU
h_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGU
onOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGU
onCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008
onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?o
iNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^Ko
iNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCT
i008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV
00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooV
i^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2
onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;o
i^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?S
hooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooU
iND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGU
i@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KV
on?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H0
0ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2
onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;o
i^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooV
i^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oV
i^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oR
h^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOW
iooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCT
i?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGU
h_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGU
onOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGU
onCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008
onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?o
iNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^Ko
iNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCT
i008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV
00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooV
i^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2
onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;o
i^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?S
hooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooU
iND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGU
i@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KV
on?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H0
0ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2
onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oRh^;o
i^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooV
i^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oV
i^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGUh_oR
h^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00?oiNGUonOW
iooVi^H00ooUiND2onCTi008onGUh_oRh^;oi^KVon?ShooVi^KoiNGUonCT
i?oVi^H2onGUi@;oi^KV00?oiNGUonOWiooVi^H00ooUiND2onCTi008onGU
h_oRh^;oi^KVon?ShooVi^KoiNGUonCTi?oVi^H2onGUi@;oi^KV00GoiNGU
onOWiooVi^Kog]kNom;BdP01oh:2PP0000WoPX:2om3@d?oKfm_ohN7QonCT
i?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Q
h@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>00
0_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oN
g^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7Q
hOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?S
on;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00Wo
hN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oS
hn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCT
i?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Q
h@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>00
0_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oN
g^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7Q
hOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?S
on;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00Wo
hN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oS
hn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCT
i?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Q
h@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>00
0_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oN
g^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7Q
hOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?S
on;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00Wo
hN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oS
hn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCT
i?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Q
h@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>00
0_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oN
g^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7Q
hOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?S
on;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00Wo
hN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oS
hn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCT
i?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Q
h@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>00
0_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oN
g^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7Q
hOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?S
on;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00Wo
hN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oS
hn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCT
i?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Q
h@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>00
0_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oN
g^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7Q
hOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?S
on;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00Wo
hN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oS
hn?ohN7Qon7QhOoRh^82on7Qh@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCT
i?oPh>3ohn?Son;Rh_oPh>000_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Q
h@?oh^;R00WohN7Qon;Rh_oNg^7ohN7QonCTi?oPh>3ohn?Son;Rh_oPh>00
0_oRh^801?oShn?ohN7Qon7QhOoRh^82on7Qh@7og=cL0Oo>c/h1oh:2PP00
00SoPX:2ol_;booGemOof][JomcLg?oMgMgog=cLomgMg@;ofm_K01;ogmoO
om_KfooJf][ogMgMomoOgooMgMgog=cLomgMgOoJf][og=cLomgMgOoLg=co
gMgJom[Jf_oLg=cogMgMomcLg?oMgMd2om_Kf`0BomoOgooKfm_of][JomgM
gOoOgmoogMgMomcLg?oMgMgof][JomcLg?oMgMgog=cLomgMf_oJf][og=cL
omgMgOoLg=cogMgM0_oKfm/04_oOgmoofm_Kom[Jf_oMgMgogmoOomgMgOoL
g=cogMgMom[Jf_oLg=cogMgMomcLg?oMgM[of][JomcLg?oMgMgog=cLomgM
g@;ofm_K01;ogmoOom_KfooJf][ogMgMomoOgooMgMgog=cLomgMgOoJf][o
g=cLomgMgOoLg=cogMgJom[Jf_oLg=cogMgMomcLg?oMgMd2om_Kf`0BomoO
gooKfm_of][JomgMgOoOgmoogMgMomcLg?oMgMgof][JomcLg?oMgMgog=cL
omgMf_oJf][og=cLomgMgOoLg=cogMgM0_oKfm/04_oOgmoofm_Kom[Jf_oM
gMgogmoOomgMgOoLg=cogMgMom[Jf_oLg=cogMgMomcLg?oMgM[of][JomcL
g?oMgMgog=cLomgMg@;ofm_K01;ogmoOom_KfooJf][ogMgMomoOgooMgMgo
g=cLomgMgOoJf][og=cLomgMgOoLg=cogMgJom[Jf_oLg=cogMgMomcLg?oM
gMd2om_Kf`0BomoOgooKfm_of][JomgMgOoOgmoogMgMomcLg?oMgMgof][J
omcLg?oMgMgog=cLomgMf_oJf][og=cLomgMgOoLg=cogMgM0_oKfm/04_oO
gmoofm_Kom[Jf_oMgMgogmoOomgMgOoLg=cogMgMom[Jf_oLg=cogMgMomcL
g?oMgM[of][JomcLg?oMgMgog=cLomgMg@;ofm_K01;ogmoOom_KfooJf][o
gMgMomoOgooMgMgog=cLomgMgOoJf][og=cLomgMgOoLg=cogMgJom[Jf_oL
g=cogMgMomcLg?oMgMd2om_Kf`0BomoOgooKfm_of][JomgMgOoOgmoogMgM
omcLg?oMgMgof][JomcLg?oMgMgog=cLomgMf_oJf][og=cLomgMgOoLg=co
gMgM0_oKfm/04_oOgmoofm_Kom[Jf_oMgMgogmoOomgMgOoLg=cogMgMom[J
f_oLg=cogMgMomcLg?oMgM[of][JomcLg?oMgMgog=cLomgMg@;ofm_K01;o
gmoOom_KfooJf][ogMgMomoOgooMgMgog=cLomgMgOoJf][og=cLomgMgOoL
g=cogMgJom[Jf_oLg=cogMgMomcLg?oMgMd2om_Kf`0BomoOgooKfm_of][J
omgMgOoOgmoogMgMomcLg?oMgMgof][JomcLg?oMgMgog=cLomgMf_oJf][o
g=cLomgMgOoLg=cogMgM0_oKfm/04_oOgmoofm_Kom[Jf_oMgMgogmoOomgM
gOoLg=cogMgMom[Jf_oLg=cogMgMomcLg?oMgM[of][JomcLg?oMgMgog=cL
omgMg@;ofm_K01;ogmoOom_KfooJf][ogMgMomoOgooMgMgog=cLomgMgOoJ
f][og=cLomgMgOoLg=cogMgJom[Jf_oLg=cogMgMomcLg?oMgMd2om_Kf`0B
omoOgooKfm_of][JomgMgOoOgmoogMgMomcLg?oMgMgof][JomcLg?oMgMgo
g=cLomgMf_oJf][og=cLomgMgOoLg=cogMgM0_oKfm/04_oOgmoofm_Kom[J
f_oMgMgogmoOomgMgOoLg=cogMgMom[Jf_oLg=cogMgMomcLg?oMgM[of][J
omcLg?oMgMgog=cLomgMg@;ofm_K01;ogmoOom_KfooJf][ogMgMomoOgooM
gMgog=cLomgMgOoJf][og=cLomgMgOoLg=cogMgJom[Jf_oLg=cogMgMomcL
g?oMgMd2om_Kf`0BomoOgooKfm_of][JomgMgOoOgmoogMgMomcLg?oMgMgo
f][JomcLg?oMgMgog=cLomgMf_oJf][og=cLomgMgOoLg=cogMgM0_oKfm/0
4_oOgmoofm_Kom[Jf_oMgMgogmoOomgMgOoLg=cogMgMom[Jf_oLg=cogMgM
omcLg?oMgM[of][JomcLg?oMgMgog=cLomgMg@;ofm_K01;ogmoOom_KfooJ
f][ogMgMomoOgooMgMgog=cLomgMgOoJf][og=cLomgMgOoLg=cogMgJom[J
f_oLg=cogMgMomcLg?oMgMd2om_Kf`0BomoOgooKfm_of][JomgMgOoOgmoo
gMgMomcLg?oMgMgof][JomcLg?oMgMgog=cLomgMf_oJf][og=cLomgMgOoL
g=cogMgM0_oKfm/04_oOgmoofm_Kom[Jf_oMgMgogmoOomgMgOoLg=cogMgM
om[Jf_oLg=cogMgMomcLg?oMgM[of][JomcLg?oMgMgog=cLomgMg@;ofm_K
01;ogmoOom_KfooJf][ogMgMomoOgooMgMgog=cLomgMgOoJf][og=cLomgM
gOoLg=cogMgJom[Jf_oLg=cogMgMomcLg?oMgMd2om_Kf`0BomoOgooKfm_o
f][JomgMgOoOgmoogMgMomcLg?oMgMgof][JomcLg?oMgMgog=cLomgMf_oJ
f][og=cLomgMgOoLg=cogMgM0_oKfm/04_oOgmoofm_Kom[Jf_oMgMgogmoO
omgMgOoLg=cogMgMom[Jf_oLg=cogMgMomcLg?oMgM[of][JomcLg?oMgMgo
g=cLomgMg@;ofm_K01;ogmoOom_KfooJf][ogMgMomoOgooMgMgog=cLomgM
gOoJf][og=cLomgMgOoLg=cogMgJom[Jf_oLg=cogMgMomcLg?oMgMd2om_K
f`0BomoOgooKfm_of][JomgMgOoOgmoogMgMomcLg?oMgMgof][JomcLg?oM
gMgog=cLomgMf_oJf][og=cLomgMgOoLg=cogMgM0_oKfm/04_oOgmoofm_K
om[Jf_oMgMgogmoOomgMgOoLg=cogMgMom[Jf_oLg=cogMgMomcLg?oMgM[o
f][JomcLg?oMgMgog=cLomgMg@;ofm_K01;ogmoOom_KfooJf][ogMgMomoO
gooMgMgog=cLomgMgOoJf][og=cLomgMgOoLg=cogMgJom[Jf_oLg=cogMgM
omcLg?oMgMd2om_Kf`09omoOgooKfm_of][JomgMgOoOgmoogMgMomcLg?oF
e]Koc/k>007oPX:200000on2PX;og]kNong]k@02onk^kP06ono_koo`l?3o
kno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`
0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_
knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_
ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_
knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knoo
l?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_
koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2
onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`
oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`
l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^
kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`
l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3o
kno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06
ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002
ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_
0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_
koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_
k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`
l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`
l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?o
l?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?00
0oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3o
kno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`
0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_
knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_
ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_
knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knoo
l?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_
koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2
onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`
oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`
l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^
kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`
l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3o
kno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06
ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002
ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_
0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_
koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_
k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`
l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`
l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?o
l?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?00
0oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3o
kno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`
0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`l?001_o_
knool?3`oo3`l?o_knook>c/on7Qh@7oPX:200000on2PX;ojn_[ooclo002
oogmo@05ooclo?omoOgoo?cloogmoOolo?`00_omoOd01?olo?cooOgmoocl
o?omoOd3ooclo0KooOgm00Goo?cloogmoOolo?cooOgmooclo002oogmo@04
ooclo?omoOgoo?cloogmo@?oo?cl1_omoOd01Oolo?cooOgmooclo?omoOgo
o?cl00;ooOgm00Coo?cloogmoOolo?cooOgm0oolo?`6oogmo@05ooclo?om
oOgoo?cloogmoOolo?`00_omoOd01?olo?cooOgmooclo?omoOd3ooclo0Ko
oOgm00Goo?cloogmoOolo?cooOgmooclo002oogmo@04ooclo?omoOgoo?cl
oogmo@?oo?cl1_omoOd01Oolo?cooOgmooclo?omoOgoo?cl00;ooOgm00Co
o?cloogmoOolo?cooOgm0oolo?`6oogmo@05ooclo?omoOgoo?cloogmoOol
o?`00_omoOd01?olo?cooOgmooclo?omoOd3ooclo0KooOgm00Goo?cloogm
oOolo?cooOgmooclo002oogmo@04ooclo?omoOgoo?cloogmo@?oo?cl1_om
oOd01Oolo?cooOgmooclo?omoOgoo?cl00;ooOgm00Coo?cloogmoOolo?co
oOgm0oolo?`6oogmo@05ooclo?omoOgoo?cloogmoOolo?`00_omoOd01?ol
o?cooOgmooclo?omoOd3ooclo0KooOgm00Goo?cloogmoOolo?cooOgmoocl
o002oogmo@04ooclo?omoOgoo?cloogmo@?oo?cl1_omoOd01Oolo?cooOgm
ooclo?omoOgoo?cl00;ooOgm00Coo?cloogmoOolo?cooOgm0oolo?`6oogm
o@05ooclo?omoOgoo?cloogmoOolo?`00_omoOd01?olo?cooOgmooclo?om
oOd3ooclo0KooOgm00Goo?cloogmoOolo?cooOgmooclo002oogmo@04oocl
o?omoOgoo?cloogmo@?oo?cl1_omoOd01Oolo?cooOgmooclo?omoOgoo?cl
00;ooOgm00Coo?cloogmoOolo?cooOgm0oolo?`6oogmo@05ooclo?omoOgo
o?cloogmoOolo?`00_omoOd01?olo?cooOgmooclo?omoOd3ooclo0KooOgm
00Goo?cloogmoOolo?cooOgmooclo002oogmo@04ooclo?omoOgoo?cloogm
o@?oo?cl1_omoOd01Oolo?cooOgmooclo?omoOgoo?cl00;ooOgm00Coo?cl
oogmoOolo?cooOgm0oolo?`6oogmo@05ooclo?omoOgoo?cloogmoOolo?`0
0_omoOd01?olo?cooOgmooclo?omoOd3ooclo0KooOgm00Goo?cloogmoOol
o?cooOgmooclo002oogmo@04ooclo?omoOgoo?cloogmo@?oo?cl1_omoOd0
1Oolo?cooOgmooclo?omoOgoo?cl00;ooOgm00Coo?cloogmoOolo?cooOgm
0oolo?`6oogmo@05ooclo?omoOgoo?cloogmoOolo?`00_omoOd01?olo?co
oOgmooclo?omoOd3ooclo0KooOgm00Goo?cloogmoOolo?cooOgmooclo002
oogmo@04ooclo?omoOgoo?cloogmo@?oo?cl1_omoOd01Oolo?cooOgmoocl
o?omoOgoo?cl00;ooOgm00Coo?cloogmoOolo?cooOgm0oolo?`6oogmo@05
ooclo?omoOgoo?cloogmoOolo?`00_omoOd01?olo?cooOgmooclo?omoOd3
ooclo0KooOgm00Goo?cloogmoOolo?cooOgmooclo002oogmo@04ooclo?om
oOgoo?cloogmo@?oo?cl1_omoOd01Oolo?cooOgmooclo?omoOgoo?cl00;o
oOgm00Coo?cloogmoOolo?cooOgm0oolo?`6oogmo@05ooclo?omoOgoo?cl
oogmoOolo?`00_omoOd01?olo?cooOgmooclo?omoOd3ooclo0KooOgm00Go
o?cloogmoOolo?cooOgmooclo002oogmo@04ooclo?omoOgoo?cloogmo@?o
o?cl1_omoOd01Oolo?cooOgmooclo?omoOgoo?cl00;ooOgm00Coo?cloogm
oOolo?cooOgm0oolo?`6oogmo@05ooclo?omoOgoo?cloogmoOolo?`00_om
oOd01?olo?cooOgmooclo?omoOd3ooclo0KooOgm00Goo?cloogmoOolo?co
oOgmooclo002oogmo@04ooclo?omoOgoo?cloogmo@;oo?cl0Oo`l?01oh:2
PP002On2PX82oh>3P`CoPX:200CoPh>3oh:2P_n3Ph?oPh>30on2PX800on3
Ph?oPX:2oh:2PP04oh:2PP;oPh>31?n2PX801?n3Ph?oPX:2oh>3Pon3Ph<3
oh:2PP03oh>3Pon2PX;oPX:200CoPX:20_n3Ph<4oh:2PP04oh>3Pon2PX;o
Ph>3oh>3P`?oPX:200?oPh>3oh:2P_n2PX801?n2PX82oh>3P`CoPX:200Co
Ph>3oh:2P_n3Ph?oPh>30on2PX800on3Ph?oPX:2oh:2PP04oh:2PP;oPh>3
1?n2PX801?n3Ph?oPX:2oh>3Pon3Ph<3oh:2PP03oh>3Pon2PX;oPX:200Co
PX:20_n3Ph<4oh:2PP04oh>3Pon2PX;oPh>3oh>3P`?oPX:200?oPh>3oh:2
P_n2PX801?n2PX82oh>3P`CoPX:200CoPh>3oh:2P_n3Ph?oPh>30on2PX80
0on3Ph?oPX:2oh:2PP04oh:2PP;oPh>31?n2PX801?n3Ph?oPX:2oh>3Pon3
Ph<3oh:2PP03oh>3Pon2PX;oPX:200CoPX:20_n3Ph<4oh:2PP04oh>3Pon2
PX;oPh>3oh>3P`?oPX:200?oPh>3oh:2P_n2PX801?n2PX82oh>3P`CoPX:2
00CoPh>3oh:2P_n3Ph?oPh>30on2PX800on3Ph?oPX:2oh:2PP04oh:2PP;o
Ph>31?n2PX801?n3Ph?oPX:2oh>3Pon3Ph<3oh:2PP03oh>3Pon2PX;oPX:2
00CoPX:20_n3Ph<4oh:2PP04oh>3Pon2PX;oPh>3oh>3P`?oPX:200?oPh>3
oh:2P_n2PX801?n2PX82oh>3P`CoPX:200CoPh>3oh:2P_n3Ph?oPh>30on2
PX800on3Ph?oPX:2oh:2PP04oh:2PP;oPh>31?n2PX801?n3Ph?oPX:2oh>3
Pon3Ph<3oh:2PP03oh>3Pon2PX;oPX:200CoPX:20_n3Ph<4oh:2PP04oh>3
Pon2PX;oPh>3oh>3P`?oPX:200?oPh>3oh:2P_n2PX801?n2PX82oh>3P`Co
PX:200CoPh>3oh:2P_n3Ph?oPh>30on2PX800on3Ph?oPX:2oh:2PP04oh:2
PP;oPh>31?n2PX801?n3Ph?oPX:2oh>3Pon3Ph<3oh:2PP03oh>3Pon2PX;o
PX:200CoPX:20_n3Ph<4oh:2PP04oh>3Pon2PX;oPh>3oh>3P`?oPX:200?o
Ph>3oh:2P_n2PX801?n2PX82oh>3P`CoPX:200CoPh>3oh:2P_n3Ph?oPh>3
0on2PX800on3Ph?oPX:2oh:2PP04oh:2PP;oPh>31?n2PX801?n3Ph?oPX:2
oh>3Pon3Ph<3oh:2PP03oh>3Pon2PX;oPX:200CoPX:20_n3Ph<4oh:2PP04
oh>3Pon2PX;oPh>3oh>3P`?oPX:200?oPh>3oh:2P_n2PX801?n2PX82oh>3
P`CoPX:200CoPh>3oh:2P_n3Ph?oPh>30on2PX800on3Ph?oPX:2oh:2PP04
oh:2PP;oPh>31?n2PX801?n3Ph?oPX:2oh>3Pon3Ph<3oh:2PP03oh>3Pon2
PX;oPX:200CoPX:20_n3Ph<4oh:2PP04oh>3Pon2PX;oPh>3oh>3P`?oPX:2
00?oPh>3oh:2P_n2PX801?n2PX82oh>3P`CoPX:200CoPh>3oh:2P_n3Ph?o
Ph>30on2PX800on3Ph?oPX:2oh:2PP04oh:2PP;oPh>31?n2PX801?n3Ph?o
PX:2oh>3Pon3Ph<3oh:2PP03oh>3Pon2PX;oPX:200CoPX:20_n3Ph<4oh:2
PP04oh>3Pon2PX;oPh>3oh>3P`?oPX:200?oPh>3oh:2P_n2PX801?n2PX82
oh>3P`CoPX:200CoPh>3oh:2P_n3Ph?oPh>30on2PX800on3Ph?oPX:2oh:2
PP04oh:2PP;oPh>31?n2PX801?n3Ph?oPX:2oh>3Pon3Ph<3oh:2PP03oh>3
Pon2PX;oPX:200CoPX:20_n3Ph<4oh:2PP04oh>3Pon2PX;oPh>3oh>3P`?o
PX:200?oPh>3oh:2P_n2PX801?n2PX82oh>3P`CoPX:200CoPh>3oh:2P_n3
Ph?oPh>30on2PX800on3Ph?oPX:2oh:2PP04oh:2PP;oPh>31?n2PX800on3
Ph?oPX:2oh:2PP02oh:2PP00oomoOgmGogmoO`OoOWinoomoOglTogmoO`00
00Cojn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP03omcLg?oNg]kogMgM00;o
gMgM0?oog]kNomcLg?oNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]h0017ogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oLg=cogMgMom_Kf`02omcLg00comgMgOoMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kN00;og=cL00GofMWIomSHf?oGemOof=SHomWIfP02omcLg03oomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kog=cLomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kN000GomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMh00ooNg]h00ooMgMgog]kN
omkNgP03omgMg@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>001ooI
fMT01?oHf=Soe]KFom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_o
fMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;
omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH
fooIfMT2omSHf006omKFe_oCdm?odm?ComCDe?oGemOof=SH0_oIfMT00ooH
f=SofMWIomWIf@02omSHf0WofMWI00?of=SHomWIfOoIfMT00_oHf=P00ooI
fMWof=SHomSHf002omSHf1OofMWI00Cof=SHomKFe_oBd];oclo?0_o=cLd0
1?o?cloodm?ComOGeooHf=SoomWIfAKofMWI00?of=SHomWIfOoIfMT01_oI
fMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3P
on;RhP02on7Qh@0=omkNg_oKfm_odm?ColO7aonk^k_o/[:bojf][Onb/[;o
^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk
^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoO
gooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_K
omoOg`3Jon7Qh@09on3Ph?oOgmoofm_KomKFe_oDe=Coe]KFom[Jf_oNg]ko
h>3P00KogmoO0ooPh>000ooOgmooh>3Pon3Ph002on3Ph0SogmoO0_oNg]h2
omoOg`?oh>3P0_oOgml2on3Ph0;ogmoO3OoPh>001OoOgmoogMgMomWIfOoE
eMGodm?C00;od];B00?oe]KFomcLg?oPh>00KooQhN400ooPh>3ohN7Qon7Q
h@05on7Qh@03on3Ph?oQhN7ohN7Q03;ohN7Q00?oh>3Pon7QhOoQhN40J?oQ
hN400ooRh^;ohN7Qon;RhP04on7Qh@7oi>CT0OoXj>P1ong]k@0000?ol?3`
ono_kooalO400oo`l?00ooo_knool?3`onk^k_oYjNWofm_Kol71`OnTY:Co
S8b<ogYjN_mgMgOoNg]kohb<S?nTY:Co`/;1om[Jf_oZj^[okNg]oo7alOo_
knoolO7aono_kooalNookno_oo7alOo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<
RomkNg_oMgMgog]kNon<S8coY:BTol;2`_oJf][oj^[Xong]kOoalO7okno_
oo7alOo_knoolO7aono_kooalNookNg]on[Zj_oJf][o`/;2ojBTY?n<S8co
Ng]kogMgM_mkNg_oS8b<ojBTY?o2`/;of][Jon[Zj_o]kNgolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
k`006ooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_onk^k_o_knooj^[ZonOWi`02on3Ph007on?Shoo[jnWojn_[on[Z
j_oVi^Koj>SXonOWi`02onWYj@0Bonk^k?o/k>cok>c/onSXj?o/k>cokNg]
oo3`l?o/k>coj^[XonKVi_oXj>SoinOWonWYjOoXj>Sojn_[onOWiooWinGo
iNGU0_oYjNT03oo^k^kokNg]ong]kOoXj>Sojn_Yonc/k?o^k^kojNWYon[Z
j_o[jn_okno_onc/k?o/k>[oj^[Zonk^kP02onc/k03oon[Zj_o_knook>c/
onc/j_oZj^[ok^k^onc/k?n_[jooMWIfoeUIFOm^KVko]kNfon3Ph?oYjNWo
kNg]oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_000]oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo`l?3okno_oo3`
l?o_knool?3`ono_koo`l?3okno_00Col?3`00000oobl_;ok^k^onOWi`04
onGUi@0@onCTi?oOgmoodM7Aok6a/On:RX[oIFEUoe5ADOm5ADGo@T92odE5
AOmADE7oIVIVohZ:ROna/K7odM7AomkNgP;oi>CT00?oiNGUonCTi?oUiN@0
0_oTi>@03ooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmA
DE7oIVIVohZ:R_na/K7odM7@omkNgP02onCTi03]onGUiOoTi>CoiNGUonCT
i?oTi>?og]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5A
ofIVI_n:RX[o/K6aom7AdOoNg]koi>CSonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT00;oi>CT0?ooaLG5
obPX:?m4A4CoT92@om7AdOoLg=_ofm_KomOGeooDe=Coe]KFomCDe?oEeMGo
fMWIon3PgooNg]kof][JomCDe?oIfMWog]kNon;Rh_oLg=coemOFomCDe?oF
e]Koe=CDomGEeOoHf=Sofm_KomOGeooFe]GoeMGEomOGeooHf=Sog]kNomoO
gooLg=coeMGEomOGe_oLg=cogMgMomOGeooFe]Kofm_Kon7QhOoNg]kofm_J
om[Jf_oNg]kog=cLom[Jf_oKfm_oh>3PomoOgooLg=_ofMWIomkNg_oOgmoo
M7AdofMWIon=SHgoE5ADo`P82?nRXZ;og=cLon;Rh_oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUon?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoShn?oiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>@005SoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CT1?oUiND01_oTi>CoiNGUonGUiOoUiNGo
j>SXonc/k07ol_;b00000oodm?CokNg]onOWi`02on3Ph00Con7QhOoOgmoo
g]kNom;Bd_nd];CoQhN7oeaLG?m]>cGoWTi2ole^G_oYPfoocFmOoie=@om]
>cKoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomkNg_oBd];o];BdohN7
QomLG5coKF0/oijF;_o=cCoojNU=olg=?onNVRooKF<]oeaLG?n7QhOo];Bd
om;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLodMW;_mXWS?o
TLe7oj[YEOnAcDOoJYhdodUZ;omLG5coQhN7okBd]?oBd];og]kN0=Woh>3P
00KogmoOolo?conIVIWoTY:BoaTI6On<S8`2omGEe@0Oolo?coo2`/;oc/k>
olk>c_o5aLGob/[:om[Jf_oHf=Sod=3@ol_;boo?cloof=SHom[Jf_oEeMGo
clo?ol71`Oo@d=3oc/k>olC4a?o;bl_of=SHomOGeonn_[ko^k^kom7AdOo@
d=3oeMGEomSHf?oCdm?oc<c<olk>cP02omGEe@05olk>c_o<c<codm?Com[J
f_oHf=P00_oBd]801?oHf=SoemOGom7AdOoCdm<2omWIf@06om?CdooAdM7o
emOGomSHf?oAdM7od=3@0_oAdM401?m6ATKo@D51omOGeooNg]iaon3Ph003
omoOgooPh>3oh>3P00;oh>3P00?ogmoOon3Ph?oPh>00W?oPh>000ooOgmoo
h>3PomoOg`02omoOg`?oh>3P00?ohN7QonOWioo/k>`00Oodm?@00003ooKf
m_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgoWinOofYNG_n?=Rkok71Q
ooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=cOoRh^;o
inOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOofiVGonCLR;okM54ooWcM?om
oHgooOfEoogmS_oin7KokMM7oi=c8_m^IeooWinOolg=cOoRh^;oinOW00?o
j>SX01?oinOWon;Rh_o=cLgoWinOof1XGom;O2?oT^5;okgiNoo@oI;of?fK
omCmUOo0nGkoV>Q=odf09?mPJEooWinOolg=cOoRh^;oinOW0=[oj>SX00Co
i^KVon7QhOmMGEgoCDe=0_oMgMd07om@D53o1`L7oaDE5On4Q8Co5QHFod=3
@ooRh^;ogMgMoibLW?l0003oShn?omgMgOoQhN7ofm_Kod10@?l820So6ATI
ohR8R?l;2`_oF5QHokNg]ol<30co1`L7ob<S8olW9bOoOGemom[Jf_oMgMgo
e=CDo`/;2omIFET00_oIfMT00omMGEgo2`/;om?Cd`02omoOg`06oeYJF_m>
CTkog]kNomkNg_lS8b?oQ8B40_oQhN403?mjNW[o;Rh^omgMgOoMgMgo`/;2
oe1@D?lc<c?oKVi^oh>3PolQ8B7og]kNonKVi_ooj>SX7ooXj>P1onc/k07o
l_;b0Oofm_H00003ooOgmoohn?Son?Sh00?on?Sh01?omoOgonk^k_o>c/ko
T92@ohD_:ooYI5Koni:7oojVVoon/JGookNZoojcY_onZ9conYB9oniXFOn9
<B_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@oiUY
:oo`_Cgonn1^ookdP_onoX[ooonBooknS?onn8?onnE`oo32?_nIJR_oT92@
olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@od9c:on4cT?o
[Nmcol;nR?o>oY3oe_nGom3nT_o6oXWo/_EdohSC@om4MB_oT92@olk>c_o^
k^komoOg0=[on?Sh02Gom_Kfoo7alOn1PH7o7alOong]kOo6a/Ko0000ol?3
`ooCdm?oG5aLo`P82?oZj^[ol?3`on[Zj_mBDU;o51@Docdm?OoYjNWol?3`
ojn_[ol71`Ood];Bolg=cOm>CTko6a/Konk^k_oKfm_o[Zj^onSXj?o/k>co
[Zj^o`000?nd];Cok>c/ok2`/?l;2`_o6QXJ00;oi>CT00_o8b<So`h>3_nT
Y:CokNg]onk^k_mPH63oE5ADonk^k_o]kNgo9RHVohf=S@02oo3`l00<oh:2
P_la<C7ok>c/on[Zj_m3@d?o;bl_oibLW?mcLg?o:RXZoaXJ6_o^k^kom_Kf
Koohn?P00oogmoOon?ShooShn005ooShn003ooOgmoohn?Son?Sh09gon?Sh
00?omoOgooShn?ohn?P00_ohn?P01?ogmoOonOWiooOgmoofm_H1ooShn000
00?on_[jooGemOo^k^h00_o/k>`0ooo[jn_ojNWYomoOgonj^[[oN59Boklb
9?oVLfSooHUnoonGRoonXYKoojRLoojTV?ooVXgooXYoonifJ_o3<bCoNE9B
okZj^_oOgmooj^[Zon_[joo/k>cojn_/on[Zj_oOgmoo^[ZjohQUD_oRTAco
nL=@oogJHooojW;oo_=nooojP_onmWooonacookNI?ojae7ohY8LohUVDonj
^[[ogmoOon[Zj_o[jn_ok>c/on_[jooZj^[ogmoOokZj^_mBKE;oDJ<Loi7B
EOnVif[o^?Ujol3nP_o7ohWo`oj4okWmNonWk6coU=IGoe:V7?mBKE;o^[Zj
omoOgooZj^[ojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k000BOo/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?oYjNWoiNGUogYjN_lL71co
hN7Rolc<c?l30`?oX:2PomkNg_nDU9Co4a<Con7QhOoPh>7od=3@o`H61_nQ
XJ7o2@T9okno_ooQhN7o^[Zjo`820_nb/[;ogMgMoh20P?lX:2Sohn?SonOW
iooUiNGogmoOom_KfooCdm?o20P8ohF5QOoOgmooJFUYodY:B_le=CGo[Jf]
okfm_Ol71`OoN7QhoeEEEOoOgmooh>3Poe]KFom@D5000_oQhN402_lT92Co
QHF5omoOgooQhN7oNg]kobl_;ooPh>3oe=CDo`D51OnXZ:P2on?Sh`3oogin
OolF5QKohN7Qon[Zj_o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?oZj^[o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>coj^[[onc/k?o[jn_ok>c/on_[
joo/k>coj^[Zonc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[000Jonc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jn`6
on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT00003oo_knooclo?o
kNg]00;oiNGU0?ooi^KVonCTi?oIfMWo/[:bogT^;_o8@S?ohfYLooAjKOom
R7cooYN:oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;of=SHonCT
i?oUiNGoi^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^lA?onc5?ooMQR
ookSL_onjGGoo^IcookKIOomc5?onl55onjN:onIERko/[:bomSHf?oTi>Co
iNGUonKVi_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on7bTSoUmaIojGUJOnb
lgOo^?IkokCeNOnWjV_oV=aIohW?BomS[R_o;V<^ok:b/_oHf=Woi>CTonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNH003Co
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^Kohn?SomoOgomgMgOo6a/KomcLg?oQhN7oWYjN
obl_;ol[:b_o<S8boa8B4_oLg=cof][KohB4Q?lP823oh>3Poe9BD_mXJ6So
f][JomkNg_n@T93o:RXZobh^;_l/;2co9bLW0_oNg]h04ooIfMWodm?Dom3@
d?mKFe_o0000okfm_OoJf][o:2PXohN7QomgMgSoJ6QXoh:2P_ll?3co`/;2
o`l?3ooDe=Cof][JoeUIFOm>CTh00_oLg=`03olS8b?oPH61omGEeOoGemOo
MgMgobh^;_oLg=coXj>So`000?o7alOof=SHomWIfOn=SHko5ADEomcLg002
onCTi01`onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onCTi0;oiNGU0:;oi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNH2onKViP03onGUiOoVi^Ko
i^KV00?oi^KV00?oiNGUong]kOodm?@00Oojn_X00003ooclo?ohn?SolO7a
00?ok^k^01?ojn_[on7QhOnl_;coNQLGol<o<_oCETWoi6QJonmgK?odPgWo
mhMlooF4N_ocNFgoiFUKomUHB_o4?c;oO1LGokbl_?oQhN7ok>c/00?ok^k^
01?ok>c/on7QhOnl_;coYDLGonJG<_oe[33ooKa1oog9Doomd63onm=UoogB
H?oncECooKe2ooZ_<_oYVc;oYDHGokbl_?oQhN7ok>c/00?ok^k^01?ok>c/
on7QhOnl_;co5eTGoenX<_mf_COoQ/e7oiKFF_nRh6GoXn1Yoj?QIonGfUco
Q/i7ogNo=omOZc;o5eTGokbl_?oQhN7ok>c/0=[ok^k^02kok>c/onOWiomk
Ng_o71`LonCTi?oYjNWoi^KVon7QhOoNg]koSHf=oa@D5?oVi^Koi>CTocDe
=OmiNGWojn_[ok:b/_lE5AGogmoOonKVi_oTi>CohN7QomgMgOmjNW[o:BTY
onSXj?oUiNGogMgMok6a/OlV9RKo2`/;oi^KVooYjNWoc<c<o`000?o>c/ko
`l?3obDU9Om;Bd_oO7alonSXj?la<C7oYJFUonCTi?mMGEgoDE5A0_oWinL0
2_lU9BGoJFUYomoOgooOgmooMgMgoc4a<OoYjNWo`L71o`000?nWYjL2omoO
g`04oi>CTolF5QKoinOWonc/k:cok^k^00?okNg]onk^k_o^k^h0K_o^k^h0
0oo]kNgol_;booShn001ooclo0000oomoOd05_olo?cooOgmoogmoOolo?co
lo?com7AdOmX1`Oo^3@dolLo<ooBD4?ofV9Eon=^H_oTLVCoi6mRomaTEooC
DD?oc44dokTd=?m[1`Ood];Boo?cloolo?`3oogmo@0Cooclo?oclo?od];B
oih[1ooJRSCoji/IooFX:Ooh]3oonKe:ooRoCOoj_d[onKPoooJZ:_o_WQWo
fh/doj8]1ooBd];olo?cooclo003oogmo@0Cooclo?oclo?od];Bo`M01om=
VSCoGj/Pog2h;omo`d?oR/e@ohg=D_n:cU3oPLM4og6i;omR[R3oCY/do`M2
1ooBd];olo?cooclo03Joogmo@0Soo_knoogmoOoQ8B4oahN7_oclo?onOWi
ok>c/oo@d=3olo?cofQXJ?m7AdOon_[jomCDe?l0003ogMgMooclo?okno_o
9bLWojRXZ?oinOWoZj^[omGEeOoalO7oE5ADoeiNG_oinOWom?CdoiBDU?l5
1@Go@410om7AdOogmoOon?ShoiNGUol[:b/00_ojn_X06olT92Co1`L7olS8
b?okno_oQHF5of=SHoogmoOoHf=SoeMGEoohn?SonOWiobLW9olE5AGoPh>3
omOGeom2@T;oHf=Soo_knoojn_[o=3@dodU9BOoKfm_oiNGUodm?ColG5aOo
nOWiooclo03ooogmoAcooOgm00?oo?cloogmoOolo?`00oomoOd0000joogm
oOojn_[olo?conk^k_o`l?3okno_onk^k_oYjNWodm?CoeXL7?nR=3Co]2PM
ol4i;?o7BCcoceI:om1GBoo@Ed[obTXnol<k;_nf:1goXS@doe`M7OoCdm?o
j^[Zonk^k_o`l?3okno_oo3`koo^k^koj^[Zom?Cdon<9Agob74domV47OoT
U1GoiidTonjX<oo`ZSCokjXconbP9OoWUaGog8PMolQa=?n<9Agodm?Con[Z
j_o^k^kol?3`ono_koo`l?3ok^k^on[ZjOoCdm?o7CPMocB2=?m7UAgoFZDK
ofV]:P;oM;Ph0>;oMKThof^a:omKYacoB9XMocB2=?lM>1godm?Con[ZjOo^
k^kol?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`0_o_knl0k_oZj^[oOWinoa`L7?oXj>OokNg]ohR8
R?l`<33o3`l?oc4a<Ona/K7ok^k^ohF5Q?m=CDgokno_onk^k_o_knooRXZ:
oeUIFOo^k^koN7Qhob/[:ol?3`oo>3Phokno_oo]kNgoi>CTo`h>3_mYJFWo
gmoOon?ShooUiNGojn_[of5QHOmgMgOok^k^ono_k_mfMWKo9RHVong]kOo_
knooc<c<ob`/;?oZj^[oKFe/of9RH_o/k>cokNg]oc/k>onCTi?oHV9Ro`h>
3_ld=3Coa<C4ono_koo^k^kodM7Aoc`l??l:2P[o9bLWofa/K?l/;2cokno_
onk^k_o`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`onk^k_o`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?03ono_k`1Too3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_k`;ol?3`1_o_knl1oo?c
l`7onOWi0Oono_h00003ookno_ogmoOol?3`00CojNWY017oinOWom_KfomS
Bd_oPC8bojHe=Onf=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b
<_mSBd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oRD];ojm;<_o=McGoeX/]
on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;oRD];om_KfooWinL0
1OoYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[ZbooL:dhofn^>_m`
[CSoJZX_oe>K;OliR3Go<V0bod];BooKfm_oinOW0=_ojNWY00Koj>SXonKV
i_mkNg_o71`LonCTi?oXj>P2onWYj@03onOWiooYjNWojNWY00_ojNWY00co
inOWonWYjOoYjNWoj>SXomSHf?l:2P[o[Zj^omgMgOoNg]koh>3PonGUiOoX
j>P8onWYj@06onSXj?oVi^Kohn?Son?ShooVi^Koj>SX0ooYjNT00ooXj>So
jNWYonWYj@04onWYj@03onOWiooYjNWojNWY0?oojNWY6ooYjNT00ooXj>So
jNWYonWYj@04onWYj@7ol?3`0OogmoL1ooknoP0000Goo_knoo[jn_odm?Co
kno_oo7al@02oo3`l00Aono_koo[jn_oUIBDodlS8onEE5Co^g=com>EUOoJ
W9cofYjLomVLW?oDUIGo^g=coiEDE?m?8b?oUIBDon[Zj_o_knl01Oo`l?00
4Oo_knooj^[ZojVDU?n18b?o^VYDomBJLooT_9Goj/NLonW7W?oZaicoiKbE
omBJLonkJUCoPB<SojZDU?oZj^[okno_00Gol?3`017okno_on[Zj_nDU9Co
8bXSoeAjE?mcYG?oW/JEojc>W?n]cYco[<jLoik6UOmcYG?oE7YDob<Z8onD
U9Coj^[Zono_k`3Koo3`l0;okno_00CoP820oadM7Oo^k^kokno_4oo`l?02
ono_k`07ofATI?lY:BWoPH61of=SHolk>c_ok^k^ono_k`08oo3`l006ono_
koo^k^koLg=cofUYJOo^k^kokno_ooo`l?0]oo3`l004oo7alOo`l?3om?Cd
oo[jnP7oo_kn00001?o/k_3oooooooooooono_h2ooooo`;oo_kn0?oooOgm
ooShn?m^KVkoFSlook6@T?oNbLWol>CToo?Vi_o`i>Cog/W9ok6@T?mJ?coo
KFe]ooShn?olo?coooooookno_ooooooo_knooooo_ono_koooooooclo?oh
n?SoSFe]ohXo?oo9TI3ojM39ooCYi?ofjnKom>WTonW@bOo9TI3oRCloohe]
KOohn?Ooo?clooooooono_koooooookno_ooooooo_knooooo_olo?con?Sh
ofe]KOlo?cooT9f@olWEbOoTk>Coi^kVonC/i?o9eLWoT9f@oclo?om]KFgo
n?Shooclo?ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_h003Soooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_kooooooogmoOo@
d=3oYJFUooknoOono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_oooooooOgmol71`?maLG7oPH61ojn_[`;oo_kn00coooooookno_oo
ookoo_knooooooono_koooooookno_oooooooOgmol;2`Onl_;`2ooknoP3o
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_kooooo000Yookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_h00_ooool00oono_koooooooooo`03ooooo`7o
n__k00001?o1b<koo_knoo[jn_odm?@5oo7al@0=ono_kooFe]KoJf][od<m
?OnKS8coa[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7al@0=
ono_kooGe]KoPf][og@m?OneS8coeKZjon7<c?oF^[[o]Xb<og8m?On1Jf_o
emKFono_k`09oo7al@0=ono_kooFe]KoJf][ocdm?On<S8co^[Zjolc=c?nj
^[[oS8b<ocdm?Om[Jf_oe]KFono_k`3ooo7alOoolO7a=?oalO401?o`l?3o
lO7aoo7alOo`l?04oo7al@03ooCdm?ojn_[oo_kn007ojng^00001On4SiWo
oOgmooShn?o`l?3ojn_[00?oj^[Z00gojNWYon[Zj_oYjNWoj>SXoi^KVomI
FEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY00_oj^[Z00_ojNWYonSX
j?nPVi_oJUUIod<V9_l]2@Wo@RHVofUIFOnPVi_oj>SXonWYj@0;on[ZjP0;
onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT0
oooZj^[oon[ZjScoj^[Z00Cojn_[oo3`l?ohn?SooOgm0OoBe]P00004ocI6
DOnh`<GonOWiooCdm0SolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`l0?o
kno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l?oolO7aoooalO4joo7al@03
oo3`l?oalO7olO7a00;olO7a00?omOGeoo[jn_o/kNl00OnQYJP00003oad_
?om<FF?o^Ko50?oooooooooooomlooooo`7okNk_0On]/;81ojFZ[@0000Ko
72hmoaXY=Olb?4KoOXR@okg3b?o[k>koooooooooooooM_ooool01OoZjnco
^l34ogV1Qol/=Cgo4alY007o52@_0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[BoxData[{
    \(\(savedLayout = pane@getLayout[];\)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]\(pane@
          setLayout[\[IndentingNewLine]JavaNew["\<java.awt.GridLayout\>", 3, 
              3, 5, 5]\[IndentingNewLine]];\)\[IndentingNewLine]]\)}], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]NewJToggleButton[
        pane, "\<Sun\>"]; \[IndentingNewLine]NewJToggleButton[
        pane, "\<Moon\>", True];\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]path = 
        JavaNew["\<java.lang.String\>", 
          StringJoin[$JavaSwingMaterial, "\<Moai.jpg\>"]]; 
      icon = JavaNew["\<javax.swing.ImageIcon\>", 
          path]; \[IndentingNewLine]iconWidth = 
        icon@getIconWidth[]; \[IndentingNewLine]iconHeight = 
        icon@getIconHeight[]; \[IndentingNewLine]NewJToggleButton[
        pane, "\<Java\>", False, icon];\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(pane@removeAll[]\)], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"],

Cell[BoxData[
    \(frame@repaint[]\)], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JCheckBox <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l00000o`00003oo`00003o
00000880000000000`28`;P0B92804R@R03o04R@R?l0B928OP18T8P10000000000<0R<2h0<SPf028
`;P0o`28`;So08S0^7d0R<2h0@18T8P10000000000<0R<2h0<SPf028`;P0o`28`;So08S0^7d0R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30
NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c7X0c<c<0P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`3<c<co0<c<c7X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<
NP3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c7X0c<c<0P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`3<c<co0<c<c7X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;PC0<c<c1X0VIW<
o`3<c<co0<c<c4d0c<c<0P28`;P104R@R040000000001P28`;P0b>3H08S0^028`;P0oonX0;6aFPL0
Q8@]00<0NGTR08B4;@24Q2d00`24Q2d01@2l_6D0c<c<0<c<c03<c<`0VIW<01P0c<c<00<0VIW<0<c<
c03<c<`0o`3<c<co0<c<c4/0c<c<0P28`;P104R@R040000000001`28`;P0b>3H08S0^028`;P0oonX
08B4;@2JVT<00`2UYDh00`2JVT<0YJE>0:FUCP050:FUCP0307Ui8P3MgHH0c<c<0080c<c<00<0VIW<
0<c<c03<c<`05P3<c<`00`2IVL`0c<c<0<c<c03o0<c<c?l0c<c<B`3<c<`208S0^040B9280@000000
000608S0^038h=P0R<2h08S0^03oojP0NGTR0P3dm9d0203BdW/0YJE>0<O7L03oojP0m?BM0>WYTP2U
YDh0jNVB0P3dm9d00`2UYDh0gMf60<c<c0020<c<c00309VIc03<c<`0c<c<01H0c<c<00<0VIW<0<c<
c03<c<`0o`3<c<co0<c<c4/0c<c<0P28`;P104R@R040000000002P28`;P0b>3H08S0^028`;P0oonX
07Ui8P3oojP0m?BM0:FUCP1GNHH207Ui000808B4;@1iEb80EeLF09YG@`2UYDh0oonX0:FUCP3BdW/3
0<c<c00309VIc03<c<`0000000@000000`3<c<`200000080c<c<1@0000000`3<c<`0000000000003
0<c<c00309VIc03<c<`0c<c<0?l0c<c<o`3<c<a;0<c<c080R<2h0@18T8P10000000000H0R<2h0<SP
f028`;P0R<2h0?ooZ02UYDh20?CdW@0<09ZJ@`1GVZP0EiZ608B4;@1iEb80NGTR0:FUCP1iEb80/K5J
0?CdW@2JVT<0gMf60`3<c<`00`2IVL`00000000000030<c<c080000000<0c<c<0000000000000P3<
c<`200000080c<c<0P0000000`3<c<`00000000000030<c<c00309VIc03<c<`0c<c<0?l0c<c<o`3<
c<a;0<c<c080R<2h0@18T8P10000000000T0R<2h0<SPf028`;P0R<2h0?ooZ01iNB80m?BM0>WYTP1R
HP/00P1GVZP02@1iVXH0KFdF0;6aFP2l_6D0KFdF0>WYTP3dm9d0YJE>0=gMQP030<c<c00309VIc03<
c<`0c<c<00<0c<c<0P0000000`3<c<`00000000000020<c<c08000000P3<c<`2000000030<c<c000
0000000000<0c<c<00<0VIW<0<c<c03<c<`0o`3<c<co0<c<c4/0c<c<0P28`;P104R@R04000000000
2P28`;P0b>3H08S0^028`;P0oonX07Ui8P3dm9d0NGTR07UG8P1GE`/206e]5P0805Mi8P1iEb80HUL0
05MG001iNB80d]9k0:FUCP3BdW/30<c<c00409VIc03<c<`0c<c<0<c<c0@0000000<0c<c<00000000
00000`3<c<`2000000040<c<c000000000000<c<c08000000`3<c<`00`2IVL`0c<c<0<c<c03o0<c<
c?l0c<c<B`3<c<`208S0^040B9280@000000000608S0^038h=P0R<2h08S0^03oojP0YJE>0P2JND<0
302UYDh0/K5J09ZJ@`1iN@00EgV605NJQP1iEd<0EeL009Yi@`1iNB80YJE>0=gMQP<0c<c<00<0VIW<
0<c<c0000000100000020<c<c0800000103<c<`4000000030<c<c0000000000000<0c<c<00<0VIW<
0<c<c03<c<`0o`3<c<co0<c<c4/0c<c<0P28`;P104R@R040000000003@28`;P0b>3H08S0^028`;P0
oonX08B4;@1iEb80gEN609Yi@`2JVT<0HUL00;bJ003M_0000P1GVXH20;aGI@030=;BN`2UYDh0gMf6
00<0c<c<00<0VIW<0000000000000P0000040<c<c08000000P3<c<`010000000c<c<0<c<c03<c<`2
000000030<c<c0000000000000<0c<c<00<0VIW<0<c<c03<c<`0o`3<c<co0<c<c4/0c<c<0P28`;P1
04R@R040000000002028`;P0b>3H08S0^028`;P0oonX07Ui8P3MgHH0Q8@]0P1GE`002P1iEb80VYX0
0?oM002lVP00VUM30=eGZ02JEd<0VWU30:FUCP3BdW/30<c<c00309VIc0000000000000D0c<c<1000
00020<c<c0@000000P3<c<`4000000030<c<c02IVL`0c<c<0?l0c<c<o`3<c<a<0<c<c080R<2h0@18
T8P10000000000H0R<2h0<SPf028`;P0R<2h0?ooZ02UYDh20?CdW@0306e]5P2lEfD0VWU30080VUM3
00L0NELR0;bJ001RHP/0gMf60?CdW@2UYDh0gMf600<0c<c<00<0VIW<0000000000000`3<c<`20000
00030<c<c0000000000000h0c<c<00<0VIW<0<c<c03<c<`0o`3<c<co0<c<c4/0c<c<0P28`;P104R@
R040000000002P28`;P0b>3H08S0^028`;P0oonX08B4;@3dm9d0_;aU069R2`24Q2d20=eGQP040;aG
I@1GND<0gK`00:FUCP80m?BM00<0YJE>0=gMQP3<c<`00P3<c<`00`2IVL`0c<c<00000004000000<0
c<c<00<000000<c<c03<c<`0303<c<`00`2IVL`0c<c<0<c<c03o0<c<c?l0c<c<B`3<c<`208S0^040
B9280@000000000=08S0^038h=P0R<2h08S0^03oojP0NGTR0?CdW@2UYDh0NGTR09ZJ@`1iNB80gEN6
08B4;@0205Mi@`050:FUCP3dm9d0m?BM0:FUCP3BdW/00`3<c<`00`2IVL`0c<c<0<c<c00F0<c<c003
09VIc03<c<`0c<c<0?l0c<c<o`3<c<a;0<c<c080R<2h0@18T8P10000000000H0R<2h0<SPf028`;P0
R<2h0?ooZ02UYDh40?CdW@060=;BN`2JND<0oonX0?CdW@2l_6D0/K5J0P3dm9d00`2UYDh0gMf60<c<
c0020<c<c00309VIc03<c<`0c<c<01H0c<c<00<0VIW<0<c<c03<c<`0o`3<c<co0<c<c4/0c<c<0P28
`;P104R@R040000000001`28`;P0b>3H08S0^028`;P0oonX07Ui8P3oojP02`3dm9d00`2UYDh0gMf6
0<c<c0020<c<c00309VIc03<c<`0c<c<01H0c<c<00<0VIW<0<c<c03<c<`0o`3<c<co0<c<c4/0c<c<
0P28`;P104R@R040000000001P28`;P0b>3H08S0^028`;P0oonX07Ui8Pd0YJE>00D0oonX0<c<c03<
c<`0c<c<09VIc00H0<c<c00309VIc03<c<`0c<c<0?l0c<c<o`3<c<a;0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2h4`3<c<`J09VIc?l0c<c<o`3<c<a=0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c7X0c<c<0P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<
c7X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c7X0c<c<0P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<
c7X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30`7X0`<300P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o0<30
`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c7X0c<c<0P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<
c7X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c7X0c<c<0P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<
c7X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0
^040B9280@000000000508S0^038h=P0R<2h08S0^03<c<`0303ooooo0<c<c?l0c<c<K@3<c<`208S0
^040B9280@000000000608S0^038h=P0R<2h08S0^01VIVH0c<c<2P1VIVH00`3oool0c<c<0<c<c03o
0<c<c?l0c<c<J`3<c<`208S0^040B9280@000000000608S0^038h=P0R<2h08S0^01VIVH0oooo2@3<
c<`00`1VIVH0oooo0<c<c0030<c<c08000000P3<c<`00`000000c<c<0<c<c00200000080c<c<1000
00030<c<c0@000000P3<c<`200000080c<c<0P00003o0<c<c?l0c<c<B`3<c<`208S0^040B9280@00
0000000708S0^038h=P0R<2h08S0^01VIVH0oooo0<c<c002000000H0c<c<00<0IVIV0?ooo`3<c<`0
0`3<c<`2000000050<c<c000000000000000003<c<`00P0000000`3<c<`00000000000020<c<c080
000000<0c<c<0000000000000P3<c<`2000000030<c<c000000000000080c<c<0P00003o0<c<c?l0
c<c<B`3<c<`208S0^040B9280@000000000708S0^038h=P0R<2h08S0^01VIVH0oooo0<c<c0030000
00D0c<c<00<0IVIV0?ooo`3<c<`00`3<c<`2000000050<c<c000000000000000003<c<`00P000000
0`3<c<`00000000000020<c<c080000000<0c<c<0000000000000P3<c<`2000000030<c<c0000000
00000080c<c<0P00003o0<c<c?l0c<c<B`3<c<`208S0^040B9280@000000000708S0^038h=P0R<2h
08S0^01VIVH0oooo0<c<c004000000@0c<c<00<0IVIV0?ooo`3<c<`00`3<c<`2000000050<c<c000
0000c<c<0000003<c<`00P0000000`3<c<`00000000000020<c<c080000000<0c<c<000000000000
0P3<c<`2000000030<c<c000000000000080c<c<0P00003o0<c<c?l0c<c<B`3<c<`208S0^040B928
0@000000000708S0^038h=P0R<2h08S0^01VIVH0oooo0<c<c002000000030<c<c0000000000000<0
c<c<00<0IVIV0?ooo`3<c<`00`3<c<`2000000050<c<c0000000c<c<0000003<c<`00P0000000`3<
c<`00000000000020<c<c080000000<0c<c<0000000000000P3<c<`2000000030<c<c00000000000
0080c<c<0P00003o0<c<c?l0c<c<B`3<c<`208S0^040B9280@000000000708S0^038h=P0R<2h08S0
^01VIVH0oooo0<c<c00200000080c<c<0P0000020<c<c00306IVIP3oool0c<c<00<0c<c<10000000
0`3<c<`000000000000200000080c<c<00<000000<c<c03<c<`00P0000020<c<c0030000003<c<`0
c<c<0080000000D0c<c<00000000000000000<c<c00200000?l0c<c<o`3<c<a;0<c<c080R<2h0@18
T8P10000000000H0R<2h0<SPf028`;P0R<2h06IVIP3oool60<c<c080000000<0c<c<06IVIP3oool0
103<c<`4000000030<c<c00000000000008000000P3<c<`4000000<0c<c<100000020<c<c0800000
00<0c<c<000000000000o`3<c<co0<c<c4`0c<c<0P28`;P104R@R040000000001P28`;P0b>3H08S0
^028`;P0IVIV0?ooo`L0c<c<00@000000<c<c01VIVH0oooo103<c<`3000000<0c<c<0`00003o0<c<
c?l0c<c<H03<c<`208S0^040B9280@000000000608S0^038h=P0R<2h08S0^01VIVH0oooo2@3<c<`0
0`1VIVH0oooo0<c<c0030<c<c0<000000`3<c<`300000?l0c<c<o`3<c<aP0<c<c080R<2h0@18T8P1
0000000000D0R<2h0<SPf028`;P0R<2h06IVIP0:0?ooo`030<c<c03oool0c<c<0?l0c<c<o`3<c<a/
0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h301VIVKo0<c<c?l0c<c<KP3<c<`2
08S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P1
0000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c7X0c<c<0P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co
0<c<c7X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`2
08S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P1
0000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c7X0c<c<0P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co
0<c<c7X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`2
08S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P1
0000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c7X0c<c<0P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<0208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`30`<3o
0<30`7X0`<300P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<30`?l0`<30NP30`<02
08S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0`<30o`30`<1j0<30`080R<2h0@18T8P1
0000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c7X0c<c<0P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co
0<c<c7X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`2
08S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P1
0000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c7X0c<c<0P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co
0<c<c7X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`2
08S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P1
0000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c7X0c<c<0P28`;P104R@R040000000001@28
`;P0b>3H08S0^028`;P0c<c<00`0ooooo`3<c<co0<c<c6d0c<c<0P28`;P104R@R040000000001P28
`;P0b>3H08S0^028`;P0IVIV0<c<c0X0IVIV00<0oooo0<c<c03<c<`0o`3<c<co0<c<c6/0c<c<0P28
`;P104R@R040000000001P28`;P0b>3H08S0^028`;P0IVIV0?ooo`T0c<c<00<0IVIV0?ooo`3<c<`0
103<c<`5000000<0c<c<0P000000103<c<`000000000003<c<`200000080c<c<0P00003o0<c<c?l0
c<c<E03<c<`208S0^040B9280@000000000608S0^038h=P0R<2h08S0^01VIVH0oooo2@3<c<`00`1V
IVH0oooo0<c<c0030<c<c08000000`3<c<`2000000040<c<c000000000000<c<c0<0000000<0c<c<
0000000000000P3<c<`200000?l0c<c<o`3<c<aD0<c<c080R<2h0@18T8P10000000000H0R<2h0<SP
f028`;P0R<2h06IVIP3oool90<c<c00306IVIP3oool0c<c<00P0c<c<0P0000000`3<c<`000000000
00020<c<c080000000<0c<c<0000000000000P3<c<`200000?l0c<c<o`3<c<aD0<c<c080R<2h0@18
T8P10000000000H0R<2h0<SPf028`;P0R<2h06IVIP3oool90<c<c00306IVIP3oool0c<c<00H0c<c<
100000000`3<c<`00000000000020<c<c080000000<0c<c<0000000000000P3<c<`200000?l0c<c<
o`3<c<aD0<c<c080R<2h0@18T8P10000000000H0R<2h0<SPf028`;P0R<2h06IVIP3oool90<c<c003
06IVIP3oool0c<c<00@0c<c<1@0000020<c<c08000000P3<c<`2000000030<c<c000000000000080
c<c<0P00003o0<c<c?l0c<c<E03<c<`208S0^040B9280@000000000608S0^038h=P0R<2h08S0^01V
IVH0oooo2@3<c<`00`1VIVH0oooo0<c<c0030<c<c0@00000103<c<`200000080c<c<0P0000001@3<
c<`00000000000000000c<c<00800000o`3<c<co0<c<c5@0c<c<0P28`;P104R@R040000000001P28
`;P0b>3H08S0^028`;P0IVIV0?ooo`T0c<c<00<0IVIV0?ooo`3<c<`00`3<c<`2000000H0c<c<0P00
00020<c<c080000000@0c<c<000000000000c<c<0P00003o0<c<c?l0c<c<E@3<c<`208S0^040B928
0@000000000608S0^038h=P0R<2h08S0^01VIVH0oooo2@3<c<`00`1VIVH0oooo0<c<c0030<c<c080
00000`3<c<`200000?l0c<c<o`3<c<aR0<c<c080R<2h0@18T8P10000000000H0R<2h0<SPf028`;P0
R<2h06IVIP3oool90<c<c00306IVIP3oool0c<c<00@0c<c<1@00003o0<c<c?l0c<c<H`3<c<`208S0
^040B9280@000000000508S0^038h=P0R<2h08S0^01VIVH02P3oool00`3<c<`0oooo0<c<c03o0<c<
c?l0c<c<K03<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0IVIVo`3<c<co0<c<
c6h0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c7X0c<c<0P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<
c7X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c7X0c<c<0P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<
c7X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<NP3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<o`3<c<aj0<c<c080R<2h0@18T8P10000
000000<0R<2h0<SPf028`;P0o`28`;So08S0^7d0R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0
R<2h5P0008030001P08000:000@000:10003P@000h4000>10`0018420005P@040005PP001X8000J2
0006PP8000N200<00@N20048PP0128800P0128<30049P`<00@Z300<00@^3004;Q0012h@00`0138@3
004=Q0<00@j50`023hD3008@Q@@00Q660`024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P02
5XL010035XP00aN800<GR0035hP300<HR00300<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:
0`047XX300@OR`<0122;0`048H/300@RS0@012><00@012B<00@TS@0498d012F=0P059Hd300DVS@03
00DWS@059hh01BN>00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T080
1Rn@00@01RnA00H`T@06<9401S2A0`06<I4200HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB
00LeTP07=I800P07=I<300LfT`<01cNC00<01cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D3
00PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4
V009A9P300U5V00300U6V009AYT02DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK
0`0:CY/300Y?W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<0
2eFN0`0;EYh00`0;Eih02eNO00]GW`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<
GJ4035fQ0`0<GZ4200aOX@0400aOXP0<H:80362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<3
00eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H2
00i]YP0400i]Y`0>KZL03VjW00i^Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mc
Z00?LjT03g>Y00@03gBY0`0?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/
00@047j/011n[@0@OZd047n]0P0AOjd30160[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h0
4HB_0164[`030165[`@04HJ_0`0BQk0301:8/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:<
/@0401:</P0BSK804Xfb01:=/P804Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c
01>B]00CT[@00`0CTk@301>D]0<04iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL0
59^g01BK]`<059bg0P0DWKL0100EWKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i
0`0EX[T301FS^P<05JBj0`0FYKX301JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd0
5Zbm0P0G[;d301N]_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<0
5k>o=P0H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0@0002000<0VjOa03=3Y@0c
@jD02@0c@jD60000P0<000600P000X0010000X4000>10003P@000h430004P@8000F100@000F20006
PP001X8000J20P001h800`011h800@R20048PP020048P`<00@V30`012X<00`012h<00@^4004;Q003
004<Q0<00@f40`013XD3008?Q@<00Q2510024HH3008BQP800Q>600@00Q>7008DQ`0258L00QB70`02
5HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<00aV800<IR@036HT010036XT300<KR@<00ab:
0`037HX300@NRP<011n;0`0488/300@QR`<012:<10048h`0100498`012B=00@TS@049Hd200DUS@<0
1BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?1005;8l300H]T0<0
1Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@801S:A00@01S:B00HcTP06<i801S>B0P06=980
0`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD00LhU00300LiU0<01cZD0`07>iD3
00PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL200Q3U`0400U3V009
A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09BYX300Y;VP<02TbK
0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;
E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P0P0<G:00100<G:40
35fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=HJ803F:R00eRXP02
00eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iYY@<03VZU100>JjH3
00i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP03g6X00maZ0<03g:X
00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`<047b/
100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh00`0APZh30163[P03
0164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;
/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?/`<04i2c0`0CTK<0
0`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI]P8059Zf00@059Zg
01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<05J2h01FP^@0EX;T0
100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100FZ[`0100FZk`05Z^m
01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<0
5k:o0`0G/klf01Rd`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0`0008001`2KYo40
oooo08ij]P2VVl@0/jWB0:RMb02cZM800P2VVl@01@2l^=d0k^kd0>[Yl@3oool0<d>U00D000200`00
0H020002P0040002P@000h4000>10003P@<000B10P001H4010001H8000J20006PP001X820007PP03
0047PP0128800@R200800@R30`012H<3004:P`03004;P`012h@00@^400<00@b40`013H@3004>Q@<0
0Pn50`0248D4008AQP<00Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<G
R0035hP00aN80`0368P00`036HP00aV900<IR@0400<JR@<00a^90`0378X300<MRP<011j:0`047h/3
00@PR`<0126;0`048X`400@SS00400@TS00498d012B=00@US@801BF=0`059Xd00`059hd01BN>00DW
SP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06;Y0200H_T00400H_T@06
<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06<i8200HdTP0300LdTP07=I801cFB0080
1cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<0
23nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G00@02D>H00U4V009A9P02DBH0`09AIP0
0`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`4
00Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP<02eJN00<0
2eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<035jQ
0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R00803F:S0`0=Hj<300eTX`03
00eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL0
3VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@04
00mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4011m[004011n[00@OZd0
47j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162[P<04H>^00<04HB^0164[`0AQ:l00`0A
QJl40166[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb
01:=/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d00<0
4i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L059^g01BK]`0DVkL301BL
]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX3
01FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd05Z^m01J/_@805jbm0`0G
[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C08000
000201Rd`10000000P0H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080002000@0
VjOa0?ooo`1/FZD0[jG:0P2l^=d02P3ooOl0/jWB0?ooo`3oool0_;SM09N:_02XWLP0i^K/0?ooo`0c
@jD40000P0<000600P000X0010000X4000>10003P@000h430004P@8000F100@000F20006PP001X80
00J20P001h800`011h800@R20048PP020048P`<00@V30`012X<00`012h<00@^4004;Q003004<Q0<0
0@f40`013XD3008?Q@<00Q2510024HH3008BQP800Q>600@00Q>7008DQ`0258L00QB70`025HL2008F
Q`0400<FR0035hP00aN800<GR0<00aR800<00aV800<IR@036HT010036XT300<KR@<00ab:0`037HX3
00@NRP<011n;0`0488/300@QR`<012:<10048h`0100498`012B=00@TS@049Hd200DUS@<01BJ=00<0
1BN=00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?1005;8l300H]T0<01Rj@0P06
;i001006;i401S2A00H`T@06<94300HaT@801S:A00@01S:B00HcTP06<i801S>B0P06=9800`07=980
1cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD00LhU00300LiU0<01cZD0`07>iD300PlU@<0
23fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL200Q3U`0400U3V009A9P02DBH
00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09BYX300Y;VP<02TbK0`0:CI/3
00Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h00`0;
EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P0P0<G:00100<G:4035fQ00aM
X@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=HJ803F:R00eRXP0200eRX`<0
3F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iYY@<03VZU100>JjH300i/YP80
3VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP03g6X00maZ0<03g:X00<03g>X
00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`<047b/100@OJ`0
100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh00`0APZh30163[P030164[P0A
Q:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;/@804Xba
00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?/`<04i2c0`0CTK<00`0CT[<0
4i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI]P8059Zf00@059Zg01BK]`0D
VkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<05J2h01FP^@0EX;T0100EXKT3
01FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100FZ[`0100FZk`05Z^m01J[_@0F
[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G
/kl201Rd`0030<SPf018T8P0B92800`0B92800<000000<SPf018T8P03@18T8P0100000006;C001Rd
`038h=P>04R@R0030000000H]<006;C00080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
0P0008002`2KYo40oooo0:RMb03oool0/jWB061<VP2>N[H0N6F^0:RMb03oool0oogo00<0oooo00<0
<d>U0000P00008000`0008030001P08000:000@000:10003P@000h4000>10`0018420005P@040005
PP001X8000J20006PP8000N200<00@N20048PP0128800P0128<30049P`<00@Z300<00@^3004;Q001
2h@00`0138@3004=Q0<00@j50`023hD2008@Q@<0oooo0P024HH3008BQP800Q>600@00Q>7008DQ`02
58L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<00aV800<IR@036HT010036XT3
00<KR@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<012:<10048h`0100498`012B=00@TS@04
9Hd200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?1005
;8l300H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@801S:A00@01S:B00HcTP06<i80
1S>B0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD00LhU00300LiU0<0
1cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL200Q3
U`0400U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09BYX3
00Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<0
2eBM00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P0P0<
G:00100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=HJ80
3F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iYY@<0
3VZU100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP03g6X
00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3
011kZ`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh00`0A
PZh30163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa01::
/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?/`<0
4i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI]P80
59Zf00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<05J2h
01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100FZ[`0
100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G
/Kl05k6o00<05k:o0`0G/kl201Rd`0030<SPf028`;P0R<2h00/0R<2h00<0B92800000038h=P03@28
`;P01@18T8P0000001Rd`00H]<00b>3H00d0R<2h00@0B9280000000H]<006;C00P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;P20000P00>09^Wl@3oool0oooo0=_Lk01PC9X0ThFj0;>YdP2l
^=d0H4bJ09V?_P2VVl@0b<?O0?ooo`0c@jD60000P0<0oooo0P000X000`000X40oooo0?ooo`020?oo
o`8000B100<000F10?ooo`001H800`001X840?ooo`030048PP0128<0oooo00<0oooo0`012X<01P3o
ool00@^4004;Q00138@0oooo004<Q0800@f400@0oooo004>Q@3oool00@j50P023hD0103oool00Q25
0?ooo`0248D2008AQP030?ooo`024HH00Q:600800Q:60P024hH010024hL00QB7008DQ`0258L3008E
Q`800QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV900<IR@0400<JR@<00a^90`0378X3
00<MRP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@TS00498d012B=00@US@801BF=0`05
9Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06
;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06<i8200HdTP03
00LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07>Y@300LkU@<0
23bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G00@02D>H00U4
V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/3
00Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]D
WP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aLX00400aLX@0<
GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R0080
3F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<0
3VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?LZP0
0`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4
011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162[P<04H>^00<0
4HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa01::/@<04X^a
0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc0`0CT;<301>A/`03
01>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L0
59^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@04
01FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd0
5Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G
/[l301Nc_`806;C000@0b>3H08S0^028`;P0R<2h1P00000408S0^00304R@R0000000b>3H0080R<2h
2@00000208S0^00504R@R00000006;C001Rd`038h=P03@28`;P01018T8P0000001Rd`00H]<0208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^0<0002000h0VjOa0?ooo`2l^=d0VHnn0?ooo`3F
dMd0fmc/0??no`2VVl@0k^kd08Ef/02CQKX0oooo03=3Y@@0002000L0oooo0001P0000H0000600?oo
o`000X00oooo00<000>100H0oooo0004P@00184000F10?ooo`001H820006PP080?ooo`001h8000N2
0047PP3oool00@R20?ooo`0128<30049P`040?ooo`012X<00@Z30?ooo`800@^400<00@b40?ooo`01
38@00P013H@0103oool00@j50?ooo`013XD2008?Q@030?ooo`0248D0oooo00<0oooo0P024HH3008B
QP800Q>600@00Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<0
0aV800<IR@036HT010036XT300<KR@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<012:<1004
8h`0100498`012B=00@TS@049Hd200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZ
SP05:Xl01BZ?00<01B^?1005;8l300H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@80
1S:A00@01S:B00HcTP06<i801S>B0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07
>9<01cRD00LhU00300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1
U`08@IL0246G0`08@YL200Q3U`0400U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009
AiT300U8V@<02DVJ0`09BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YA
W@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO
100;FIl300aJX0<035^P0P0<G:00100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<
H:80362R0P0<HJ800`0=HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eV
Y0<03FNT0`0=J:D300iYY@<03VZU100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL2
00i`Y`0400m`Z00?LJP03g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?
MjX3011hZP<047V[0`0@NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]
00<04H6]0161[P0APJh00`0APZh30163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`
0P0BRK00100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0C
S[804hnb01>?/P0201>?/`<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF
]@<059Ne100DV;H301BI]P8059Zf00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P0
5Ijh01FN^0<05Inh00<05J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0F
Yk/301JX^`<05ZVl100FZ[`0100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h0
0`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0040<SPf028`;P0R<2h08S0^0H0
00001028`;P00`18T8P000000<SPf00208S0^00300000028`;P0R<2h00D0R<2h00D0000008S0^028
`;P0B9280000000201Rd`0040<SPf028`;P0R<2h08S0^08000001028`;P200000080R<2h00@0B928
0000000H]<006;C00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P30000P00?09^Wl@3o
ool0VHnn09N:_03DdnP0kjbc0?mfN`3^Wj/0FeRU0:JKa02FWm80H4bJ0;bhg@3oool0<d>U00<00020
00L0oooo0001P0000H0000600?ooo`000X00oooo00<000>100H0oooo0004P@001840oooo0005P@3o
ool20006PP080?ooo`001h8000N20047PP3oool00@R20?ooo`0128<30049P`090?ooo`012X<0oooo
004;P`3oool00@^40?ooo`0138@0oooo00800@f400@0oooo004>Q@3oool00@j50P023hD0103oool0
0Q250?ooo`0248D4008AQP<00Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ8
00<GR0035hP00aN80`0368P00`036HP00aV900<IR@0400<JR@<00a^90`0378X300<MRP<011j:0`04
7h/300@PR`<0126;0`048X`400@SS00400@TS00498d012B=00@US@801BF=0`059Xd00`059hd01BN>
00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06;Y0200H_T00400H_
T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06<i8200HdTP0300LdTP07=I801cFB
00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07>Y@300LkU@<023bE0`08?ID400Pn
UP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G00@02D>H00U4V009A9P02DBH0`09
AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:
Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP<02eJN
00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<0
35jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R00803F:S0`0=Hj<300eT
X`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>
KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mc
Z@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4011m[004011n[00@
OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162[P<04H>^00<04HB^0164[`0AQ:l0
0`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;80
4Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d
00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L059^g01BK]`0DVkL3
01BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0E
XkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd05Z^m01J/_@805jbm
0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C0
00<0b>3H08S0^028`;P02`28`;P00`18T8P000000<SPf00208S0^00300000028`;P0R<2h00D0R<2h
00D0000008S0^028`;P0B9280000000201Rd`0030<SPf028`;P0R<2h0080R<2h0P00000208S0^080
00000`28`;P01018T8P0000001Rd`00H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^080002000X0VjOa0?ooo`2GR[`0NVbZ0;?7j02YKZ00b<?O09>5^P1KAY<0VHnn0P1hIJh010129hD0
[jG:0?ooo`0c@jD40000P0<0006000<0oooo0002P0000X40103oool20004P@030?ooo`001H40oooo
00<000J2103oool00`0128800@R30048P`030049P`090?ooo`012X<0oooo004;P`3oool00@^40?oo
o`0138@0oooo00800@f400@0oooo004>Q@3oool00@j50P023hD00`3oool00Q250?ooo`030?ooo`80
0Q660`024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN800<GR0035hP3
00<HR00300<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:0`047XX300@OR`<0122;0`048H/3
00@RS0@012><00@012B<00@TS@0498d012F=0P059Hd300DVS@0300DWS@059hh01BN>00<01BR>0`05
:Hh00`05:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@00@01RnA00H`T@06<9401S2A
0`06<I4200HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB00LeTP07=I800P07=I<300LfT`<0
1cNC00<01cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP04
00Q0U`08@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009A9P300U5V00300U6V009AYT0
2DJI00@02DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:CY/300Y?W0@02U2L00@02U6L
00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN0`0;EYh00`0;Eih02eNO00]G
W`0300]HW`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ4035fQ0`0<GZ4200aOX@0400aO
XP0<H:80362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eSX`<03FBS00<03FFS00eUY00=
IJ@00`0=IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW00i^
Y`<03VnW0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?LjT03g>Y00@03gBY0`0?MJT3
00mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@047j/011n[@0@OZd047n]0P0A
Ojd30160[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_0164[`030165[`@04HJ_0`0B
Qk0301:8/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P80
4Xjb00<04hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@301>D]0<0
4iFe0`0DU[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g01BK]`<059bg0P0DWKL0100E
WKP05Ijh01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0FYKX3
01JV^`<05ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm0P0G[;d301N]_@0301N^_@0G
[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o0P0H]<000`38h=P0R<2h08S0
^00;08S0^00304R@R0000000b>3H0080R<2h00<0000008S0^028`;P01@28`;P01@000000R<2h08S0
^018T8P0000000806;C000<0b>3H08S0^028`;P00`28`;P4000000@0R<2h00@0B9280000000H]<00
6;C00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20000P00309^Wl@3oool0oooo0080
oooo00X0ojf`0?mfN`3icM@0oNg^0?ooo`2VVl@0QGJ`0;bhg@3oool0<d>U1@0008030001P0030?oo
o`000X0000:100<000>100<0oooo0004P@3oool00P001H4010001H80oooo0006PP001X820007PP03
0047PP3oool00@R200800@R30`3oool2004:P`070?ooo`012h<0oooo004;Q03oool00@b40?ooo`02
004=Q0040?ooo`013XD0oooo0?ooo`800Pn500H0oooo008@Q@3oool00Q25008AQP3oool2008AQP<0
0Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN80`0368P0
0`036HP00aV900<IR@0400<JR@<00a^90`0378X300<MRP<011j:0`047h/300@PR`<0126;0`048X`4
00@SS00400@TS00498d012B=00@US@801BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<0
1BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A
0P06<Y401006<Y801S>B00HcTP06<i8200HdTP0300LdTP07=I801cFB00801cFC0`07=Y<300LgT`03
00LhT`07>9@01cRD00<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0
246G00Q1U`08@IL300Q2U`8024>G00@02D>H00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@04
00U7V@<02DRI0`09BIX300U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId0
2U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;
F9l400]IW`<035ZP0`0<Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R
00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<0
3FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_
Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX3
00mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@O:`4011m[004011n[00@OZd047j]011o[@804Gn]0`0A
P:d00`0APJd04H6^0161[P030162[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0B
R;0201:9/00401:9/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P03
01>>/P0CSk804hnb00804hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<0
59Je0`0DUkD401BH]P<059Vf0P0DV[H0100DV[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN
^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/3
01JW^`<05ZRk0`0FZK`401JZ_00401J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^
_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C000<0b>3H08S0^028`;P02`28
`;P00`18T8P000000<SPf00208S0^00300000028`;P0R<2h00D0R<2h00D0000008S0^028`;P0B928
0000000201Rd`0030<SPf028`;P0R<2h00@0R<2h0P00000508S0^00404R@R00000006;C001Rd`080
R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0`0008002P2Q[?80nLgD0>8V?03d]Kl0hRHl
0?A]O@3lhnT0oooo0?g]kP3o[K020?ooo`0303=3Y@000800002000@000200`000H000`3oool000:0
0002P@030?ooo`8000B100D0oooo0005P@001H4000F20?ooo`020006PP<0oooo0P0128800`0128<0
oooo0049P`020049P`800@Z300@0oooo004;P`012h@0oooo0P0138@01`3oool00@f4004=Q03oool0
0@j50?ooo`013XD00P3oool00`023hD00Q25008@Q@040?ooo`04008AQP024XH00Q:6008BQP800Q>6
00@00Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<00aV800<I
R@036HT010036XT300<KR@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<012:<10048h`01004
98`012B=00@TS@049Hd200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl0
1BZ?00<01B^?1005;8l300H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@801S:A00@0
1S:B00HcTP06<i801S>B0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD
00LhU00300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0
246G0`08@YL200Q3U`0400U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8
V@<02DVJ0`09BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd2
00]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl3
00aJX0<035^P0P0<G:00100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R
0P0<HJ800`0=HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT
0`0=J:D300iYY@<03VZU100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`04
00m`Z00?LJP03g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011h
ZP<047V[0`0@NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]
0161[P0APJh00`0APZh30163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00
100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb
01>?/P0201>?/`<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne
100DV;H301BI]P8059Zf00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN
^0<05Inh00<05J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX
^`<05ZVl100FZ[`0100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh3
01N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0030<SPf028`;P0R<2h00/0R<2h00<0B928
00000038h=P00P28`;P00`000000R<2h08S0^00508S0^00500000028`;P0R<2h04R@R00000000P0H
]<000`38h=P0R<2h08S0^00308S0^0@000001028`;P01018T8P0000001Rd`00H]<0208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^080002000d0VjOa0?g]kP3R9S`0o_Gh0?N9U`3dHVh0lj2^
0?ARKP3ooOl0ojf`0?cSj@3oool0<d>U00L000200`000H000`3oool000:00002P@030003P@<000B1
0P001H4010001H8000J20006PP001X820007PP050047PP0128800@R20?ooo`0128<00`012H<3004:
P`03004;P`012h@00@^400<00@b40`013H@3004>Q@<00Pn50`0248D4008AQP<00Q:60P024hH01002
4hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV900<I
R@0400<JR@<00a^90`0378X300<MRP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@TS004
98d012B=00@US@801BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl0
0`05:hl400D/S`<01Rf@0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y80
1S>B00HcTP06<i8200HdTP0300LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD
00<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL3
00Q2U`8024>G00@02D>H00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09
BIX300U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M
0`0;Did00`0;E9d02eBN00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP
0`0<Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQ
XP0300eQXP0=HZ803F:R00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eX
Y@<03VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X
00maZ00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@
NJ/3011jZ`<047^[0`0@O:`4011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^
0161[P030162[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9
/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb
00804hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH
]P<059Vf0P0DV[H0100DV[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0E
WkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0F
ZK`401JZ_00401J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n
00<05k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C000<0b>3H08S0^028`;P02`28`;P00`18T8P00000
0<SPf00208S0^00300000028`;P0R<2h00D0R<2h00D0000008S0^028`;P0B9280000000201Rd`003
0<SPf028`;P0R<2h0080R<2h0P00000208S0^08000000`28`;P01018T8P0000001Rd`00H]<0208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^080002000<0VjOa0?K8c03R9S`00P3o[K001`3O
92h0ojBN0?Jla@3o[K00kW^<0?ooo`0c@jD0200008030001P0030?ooo`000X0000:100<000>10`00
18420005P@040005PP001X8000J20006PP8000N200D00@N20048PP012880oooo0048P`030049P`04
0?ooo`012X<00@Z3004;P`800@^40`0138@3004=Q0<00@j50`023hD3008@Q@@00Q660`024XH2008C
QP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN800<GR0035hP300<HR00300<IR003
6HT00aV900@00aZ90`036hT300<LRP<00af:0`047XX300@OR`<0122;0`048H/300@RS0@012><00@0
12B<00@TS@0498d012F=0P059Hd300DVS@0300DWS@059hh01BN>00<01BR>0`05:Hh00`05:Xh01BZ?
00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@00@01RnA00H`T@06<9401S2A0`06<I4200HbT@04
00HbTP06<i801S>B00HcTP801SBB00<01cBB00LeTP07=I800P07=I<300LfT`<01cNC00<01cRC00Lh
U007>9@00`07>I@300LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G
00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009A9P300U5V00300U6V009AYT02DJI00@02DNI0`09
B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:CY/300Y?W0@02U2L00@02U6L00YAW@0:DId02U:M
0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN0`0;EYh00`0;Eih02eNO00]GW`0300]HW`@02eVO
0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ4035fQ0`0<GZ4200aOX@0400aOXP0<H:80362R00aP
XP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eW
Y0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW00i^Y`<03VnW0P0>L:L0
100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?LjT03g>Y00@03gBY0`0?MJT300mfZP<03gNZ0`0@
N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@047j/011n[@0@OZd047n]0P0AOjd30160[@030161
[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_0164[`030165[`@04HJ_0`0BQk0301:8/0804XV`
00@04XVa01::/@0BR[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb00<04hjb01>?
/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@301>D]0<04iFe0`0DU[D301BG
]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g01BK]`<059bg0P0DWKL0100EWKP05Ijh01FN^00E
W[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0FYKX301JV^`<05ZNk0`0F
Z;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm0P0G[;d301N]_@0301N^_@0G[[h05jjn00<05jnn
0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o0P0H]<000`38h=P0R<2h08S0^00;08S0^00304R@
R0000000b>3H0080R<2h2@00000208S0^00504R@R00000006;C001Rd`038h=P00`28`;P2000000@0
R<2h0P00000208S0^00404R@R00000006;C001Rd`080R<2h0@18T8P10000000000@0R<2h0<SPf028
`;P0R<2h0P0008000`2KYo40nLgD0?N9U`020?ooo`070?n]/03Q5S@0ogIk0?nTWP3R9S`0ohUo03=3
Y@080000P0<0006000<0oooo0002P0000X400`000h430004P@8000F100@000F20006PP001X8000J2
0P001h8010011h800@R20048PP0128<40?ooo`<00@Z300<00@^3004;Q0012h@00`0138@2004=Q004
0?ooo`013XD00@j5004>Q@<00Pn50`0248D4008AQP<00Q:60P024hH010024hL00QB7008DQ`0258L3
008EQ`800QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV900<IR@0400<JR@<00a^90`03
78X300<MRP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@TS00498d012B=00@US@801BF=
0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/S`<01Rf@
0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06<i8200Hd
TP0300LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07>Y@300Lk
U@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G00@02D>H
00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<02T^J0`0:
C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN
00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aLX00400aL
X@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=HZ803F:R
00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>JZD400i[
YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP03g6X0`0?
LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[0`0@
O:`4011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162[P<04H>^
00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa01::/@<0
4X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc0`0CT;<301>A
/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0DV[H0100D
V[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P05J2i01FP
^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_00401J[_00F
Zkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl0
0`0G/[l301Nc_`806;C000<0b>3H08S0^028`;P02`28`;P00`18T8P000000<SPf00208S0^0T00000
0P28`;P01@18T8P0000001Rd`00H]<00b>3H00d0R<2h00@0B9280000000H]<006;C00P28`;P104R@
R040000000001028`;P0b>3H08S0^028`;P20000P00709^Wl@3oool0lj2^0?ARKP3oool0mhVG0?W=
e0020?ooo`030?>P[P3oool0<d>U00P000200`000H020002P0040002P@000h4000>10003P@<000B1
0P001H4010001H8000J20006PP001X820007PP030047PP0128800@R200800@R30`012H<3004:P`03
004;P`012h@00@^400<00@b40`013H@3004>Q@<00Pn50`0248D4008AQP<00Q:60P024hH010024hL0
0QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV900<IR@04
00<JR@<00a^90`0378X300<MRP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@TS00498d0
12B=00@US@801BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05
:hl400D/S`<01Rf@0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B
00HcTP06<i8200HdTP0300LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<0
1cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2
U`8024>G00@02D>H00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX3
00U:VP<02T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;
Did00`0;E9d02eBN00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<
Fj0200aLX00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP03
00eQXP0=HZ803F:R00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<0
3VVU0`0>JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00ma
Z00?LJP03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3
011jZ`<047^[0`0@O:`4011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161
[P030162[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0B
R[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb0080
4hnc0`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<0
59Vf0P0DV[H0100DV[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP0
0`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`4
01JZ_00401J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<0
5k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C000<0b>3H08S0^028`;P02`28`;P00`18T8P000000<SP
f00=08S0^00504R@R00000006;C001Rd`038h=P03@28`;P01018T8P0000001Rd`00H]<0208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^0<0002000/0VjOa0?ooo`3oRGl0oooo0?>P[P3aTj40
oooo0?omo`3cX:h0oo_l03=3Y@080000P0<000600P000X0010000X4000>10003P@000h430004P@80
00F100@000F20006PP001X8000J20P001h800`011h800@R20048PP020048P`<00@V30`012X<00`01
2h<00@^4004;Q003004<Q0<00@f40`013XD3008?Q@<00Q2510024HH3008BQP800Q>600@00Q>7008D
Q`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0<00aR800<00aV800<IR@036HT01003
6XT300<KR@<00ab:0`037HX300@NRP<011n;0`0488/300@QR`<012:<10048h`0100498`012B=00@T
S@049Hd200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00<01B^?
1005;8l300H]T0<01Rj@0P06;i001006;i401S2A00H`T@06<94300HaT@801S:A00@01S:B00HcTP06
<i801S>B0P06=9800`07=9801cFB00LeTP0200LeT`<01cJC0`07=i<00`07>9<01cRD00LhU00300Li
U0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL2
00Q3U`0400U3V009A9P02DBH00U4V0<02DFH00<02DJH00U6V@09AYT01009AiT300U8V@<02DVJ0`09
BYX300Y;VP<02TbK0`0:CI/300Y>V`<02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M
00<02eBM00]DWP0;E9h00`0;EIh300]FWP0300]GWP0;Eil02eNO00<02eRO100;FIl300aJX0<035^P
0P0<G:00100<G:4035fQ00aMX@0<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ800`0=
HJ803F:R00eRXP0200eRX`<03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D300iY
Y@<03VZU100>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW0`0>KjL200i`Y`0400m`Z00?LJP0
3g6X00maZ0<03g:X00<03g>X00mcZ@0?LjT0100?M:T300meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@
NZ/3011kZ`<047b/100@OJ`0100@OZ`047j]011n[@0@Ojd2015o[@<04H2]00<04H6]0161[P0APJh0
0`0APZh30163[P030164[P0AQ:l04HB_00<04HF_100AQZl301:7/0<04XR`0P0BRK00100BRK404XZa
01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[800`0CS[804hnb01>?/P0201>?
/`<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0<04iBd0`0CUKD301BF]@<059Ne100DV;H301BI
]P8059Zf00@059Zg01BK]`0DVkL059^g0`0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0<05Inh00<0
5J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk0`0FYk/301JX^`<05ZVl100F
Z[`0100FZk`05Z^m01J[_@0F[;d201N/_@<05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na
_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0l0b>3H00<000000<SPf038h=P03@38h=P00`0000006;C0
01Rd`00?0<SPf0030000000H]<006;C00080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
1000080309^Wl@060?ooo`3cX:h0m;Fo0?Jla@3kfMX0<d>U2@0008030001P08000:000@000:10003
P@000h4000>10`0018420005P@040005PP001X8000J20006PP8000N200<00@N20048PP0128800P01
28<30049P`<00@Z300<00@^3004;Q0012h@00`0138@3004=Q0<00@j50`023hD3008@Q@@00Q660`02
4XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN800<GR0035hP300<HR003
00<IR0036HT00aV900@00aZ90`036hT300<LRP<00af:0`047XX300@OR`<0122;0`048H/300@RS0@0
12><00@012B<00@TS@0498d012F=0P059Hd300DVS@0300DWS@059hh01BN>00<01BR>0`05:Hh00`05
:Xh01BZ?00DZS`0300D[S`@01Bb?0`06;I0300H^T0801Rn@00@01RnA00H`T@06<9401S2A0`06<I42
00HbT@0400HbTP06<i801S>B00HcTP801SBB00<01cBB00LeTP07=I800P07=I<300LfT`<01cNC00<0
1cRC00LhU007>9@00`07>I@300LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08
@IL0246G00Q1U`<024:G0P08@iL01009@iP02DBH00U4V009A9P300U5V00300U6V009AYT02DJI00@0
2DNI0`09B9T300U9VP<02DZJ0`0:BiX300Y<V`<02TfK0`0:CY/300Y?W0@02U2L00@02U6L00YAW@0:
DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN0`0;EYh00`0;Eih02eNO00]GW`0300]H
W`@02eVO0`0<FZ0300aKX08035bP00@035bQ00aMX@0<GJ4035fQ0`0<GZ4200aOX@0400aOXP0<H:80
362R00aPXP80366R00<03F6R00eRXP0=HZ800P0=HZ<300eSX`<03FBS00<03FFS00eUY00=IJ@00`0=
IZ@300eWY0<03FRU0`0>JJD300iZY@@03V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW00i^Y`<03VnW
0P0>L:L0100?L:P03g6X00maZ00?LJP300mbZ00300mcZ00?LjT03g>Y00@03gBY0`0?MJT300mfZP<0
3gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/3011l[0@047f/00@047j/011n[@0@OZd047n]0P0AOjd30160
[@030161[@0APJh04H6^00<04H:^0`0APjh00`0AQ:h04HB_0164[`030165[`@04HJ_0`0BQk0301:8
/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb00<0
4hjb01>?/P0CSk800P0CSk<301>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@301>D]0<04iFe0`0D
U[D301BG]@@059Rf0`0DVKH201BJ]P0401BJ]`0DVkL059^g01BK]`<059bg0P0DWKL0100EWKP05Ijh
01FN^00EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0FYKX301JV^`<0
5ZNk0`0FZ;/301JY_0@05ZZl00@05Z^l01J[_@0FZkd05Zbm0P0G[;d301N]_@0301N^_@0G[[h05jjn
00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o=P0H]<0208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^1H000200`000H020002P0040002P@000h4000>10003P@<000B10P001H40
10001H8000J20006PP001X820007PP030047PP0128800@R200800@R30`012H<3004:P`03004;P`01
2h@00@^400<00@b40`013H@3004>Q@<00Pn50`0248D4008AQP<00Q:60P024hH010024hL00QB7008D
Q`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN80`0368P00`036HP00aV900<IR@0400<JR@<0
0a^90`0378X300<MRP<011j:0`047h/300@PR`<0126;0`048X`400@SS00400@TS00498d012B=00@U
S@801BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl00`05:hl400D/
S`<01Rf@0`06;Y0200H_T00400H_T@06<9401S2A00H`T@<01S6A0P06<Y401006<Y801S>B00HcTP06
<i8200HdTP0300LdTP07=I801cFB00801cFC0`07=Y<300LgT`0300LhT`07>9@01cRD00<01cVD0`07
>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL300Q2U`8024>G
00@02D>H00U4V009A9P02DBH0`09AIP00`09AYP02DJI00U6V@0400U7V@<02DRI0`09BIX300U:VP<0
2T^J0`0:C9/300Y=V`<02TjK0`0:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;
E9d02eBN00]DWP0300]EWP<02eJN00<02eNN00]GW`0;Eil00`0;F9l400]IW`<035ZP0`0<Fj0200aL
X00400aLX@0<GJ4035fQ00aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0300eQXP0=
HZ803F:R00803F:S0`0=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eXY@<03VVU0`0>
JZD400i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL300i_Y`803W2W00@03g2X00maZ00?LJP0
3g6X0`0?LZP00`0?LjP03g>Y00mcZ@0400mdZ@<03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<0
47^[0`0@O:`4011m[004011n[00@OZd047j]011o[@804Gn]0`0AP:d00`0APJd04H6^0161[P030162
[P<04H>^00<04HB^0164[`0AQ:l00`0AQJl40166[`<04XN`0`0BR;0201:9/00401:9/@0BR[404XZa
01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P0301>>/P0CSk804hnb00804hnc0`0C
T;<301>A/`0301>B/`0CT[@04i:d00<04i>d0`0CU;@301>E]@<059Je0`0DUkD401BH]P<059Vf0P0D
V[H0100DV[L059^g01BK]`0DVkL301BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0`0EWkP00`0EX;P0
5J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/301JW^`<05ZRk0`0FZK`401JZ_004
01J[_00FZkd05Z^m01J/_@805jbm0`0G[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na
_`0G/Kl00`0G/[l301Nc_cH06;C00P28`;P104R@R040000000000`28`;P0b>3H08S0^03o08S0^?l0
R<2hO@28`;P104R@R040000000000`28`;P0b>3H08S0^03o08S0^?l0R<2hO@28`;P104R@R0400000
00000`28`;P0b>3H0<SPf03o0<SPf?l0b>3HO@38h=P104R@R0400000003o08S0^?l0R<2hP@28`;P1
00000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l7?ol?3`00?ofMWIooooooooool03?ooool0
0?ool?3`ooo`l?1coo3`l004omWIfOooooooooooonGUi@?ooooo00GoiNGU
ooooooooooooooooonGUi@03ooooo`00ooo`l?3ooo3`l7?ol?3`00gofMWI
oooooooJf][oSHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgo
iNGU00;ooooo003ooo3`l?ool?3`Loo`l?003_oIfMWooooooooooooJf][o
SHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU0Oooool0
0?ool?3`ooo`l?1coo3`l00=omWIfOoooooooooooooooooJf][oSHf=onGU
iOoooooof][Johf=SOoUiNGoooooom[JfP02ooooo`00ooo`l?3ooo3`l7?o
l?3`00?ofMWIooooooooool00_ooool01ooJf][oSHf=onGUiOoooooof][J
ohf=SOoUiND00oooool00?ool?3`ooo`l?1coo3`l003omWIfOoooooooooo
00?ooooo00Oof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003o
oo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`04ooooo`07om[Jf_n=SHgo
iNGUoooooooLg=coSHf=onGUi@01ooooo`00ooo`l?3ooo3`l7?ol?3`00?o
fMWIooooooooool01Oooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo
003ooo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`06ooooo`03omcLg?n=
SHgoiNGU00?ooooo003ooo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`07
ooooo`03omcLg?n=SHgoiNGU00;ooooo003ooo3`l?ool?3`Loo`l?000ooI
fMWoooooooooo`08ooooo`03omcLg?n=SHgoiNGU007ooooo003ooo3`l?oo
l?3`Loo`l?000ooIfMWoooooooooo`09ooooo`7og=cL0Oooool1ooooo`00
ooo`l?3ooo3`l7?ol?3`00?ofMWIooooooooool03?ooool00?ool?3`ooo`
l?1coo3`l0oofMWI003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooo
oon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?oo
k^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^
k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003o
onk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;o
k^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool0
0?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_oo
k^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003o
onKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;o
oooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^ko
onk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00
oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2
ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^
ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0
0?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooooooo
P_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^
k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^
003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooo
oh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooo
oon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?oo
k^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^
k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003o
onk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;o
k^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool0
0?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV000Donk^kQ_o
OZgIooo^k^koonk^kU?ok^k^00000oooojSo/K5JohB4;@06ohB4;@03ogUi
8_n4Q2goQ8@]00?oQ8@]00?o_;aUooooooooool00_ooool00omn[MWooooo
ooooo`0Gooooo`03ogj]fOoooooooooo0?oooooooooooomAooooo`0000?o
oonXohB4;OnJVT<00onUYDh00onJVT?oYJE>ojFUCP05ojFUCP03ogUi8_oM
gHKok^k^00?ok^k^00?oOZgIonk^k_o^k^h05oo^k^h00omn[MWok^k^onk^
kP3oonk^k_ook^k^DOo^k^h0000<ooooZ?miNB;om?BMooCdWOoBdW_oYJE>
olO7L?ooojSom?BMonWYT_nUYDkojNVB0_odm9d00onUYDkogMf6onKViP03
onKViP04ogj]fOoTi>Coa/K6olo?c`Koi^KV00Ooc/k>onCTi?oVi^Koi^KV
omCDe?oTi>Coi^KV00;og=cL1ooVi^H00omn[MWoi^KVonKViP3oonKVi_oo
i^KVDOoVi^H00006ooooZ?miNB;ooonXooCdWOnUYDkoEgV60_miN@002?n4
Q2goNELRoeMG5_nJEd?oYJE>ooooZ?nUYDkod]9k1?o^k^h01_mn[MWo2@T9
o``<3?lQ8B7o<S8boi^KV`;ok^k^00koa<C4ob8R8_lL71co[Jf]onk^k_m;
Bd_o1`L7oaPH6?nATI7o4A4Aoe5ADOo^k^ko>c/kogIfMPCok^k^00?oOZgI
onk^k_o^k^h0ooo^k^koonk^kU7ok^k^00004?ooojSoYJE>ooCdWOodm9go
VYY3oeNJZ?mGVXKoQ8@]ogUG8_miNB;oYJE>ogUG8_na/E[om?BMoiZJ@ooM
gHH4ooooo`0Bogj]fOno_koon_[joooooonMWIgo10@4omkNg_ooooooLG5a
od51@Oono_koooooolK6a_l410CogMgMonKVi_mKFe_o4A4A0_ooool00om0
@43oOgmoooooo`03ooooo`03ogj]fOoooooooooo0?oooooooooooomAoooo
o`0000GooonXogUi8_odm9gojNVBof9R2`02oeNJZ009ogVJQ_m]KAKo/K5J
okblIOm]KAKojNVBooCdWOnUYDkogMf600Cok^k^00[oOZgIonk^k_o^k^ko
k^k^om;Bd_l0003oZJVYonk^k_m7AdOoJVYZ0_o^k^h01_o:b/[o0P82ok2`
/?o^k^koU9BDoadM7@;ok^k^00?o>c/kogIfM_o^k^h00oo^k^h00omn[MWo
k^k^onk^kP3oonk^k_ook^k^DOo^k^h00006ooooZ?miNB;om?BMogUi8_mi
Eb;oEeL;0_m]KAH02?mGNB;oNELRof9G0?mGE`3oNGTRom;BNonUYDkod]9k
1?oVi^H02_mn[MWoi^KVonKVi_oHf=SoAdM7o`L71ooJf][oi^KVodE5AOmV
IVH3onKViP05oibLW?l];Bgo;Rh^oc0`<?lL71`00_oVi^H00oli>CWoLW9b
onKViP03onKViP03ogj]fOoVi^Koi^KV0?ooi^KVoooVi^IAonKViP00013o
oonXojFUC_nJND?oVWU3ojFUC_na/E[oVYY3ogUi0?mGNHKoEiZ6ogUG@omG
E`3oVWU3ogUi8_nUYDkogMf61?o^k^h01_mn[MWok^k^ojVYZOlJ6Q[o5ADE
ok6a/@;ok^k^00?oAdM7ofYZJ_o^k^h01?o^k^h00oo/k>coRXZ:oahN7P02
onk^kP03oc/k>omRHV;ok^k^00?ok^k^00?oOZgIonk^k_o^k^h0ooo^k^ko
onk^kU7ok^k^00002OooojSoQ8@]ogUG8_oMEhKoVWU3oiZJ@omRE`3o_9X0
omfl0002oeNJQP;o_5MU00?od]9kojFUC_oMgHH01?ooool01Omn[MWoPH61
o`410OmFEUKoi^KV00;ooooo00_onOWiodU9BOm]KFgom?Cdoo_knooooooo
];Bdom[Jf_olo?coHF5QoeADE002ooooo`07od10@?lC4a?oTI6AonCTi?om
oOgoooooogj]f@3oooooooooooooDoooool00004ooooZ?miNB;ogMf6ohB4
;@;oEeL000[oNELRoiZJ0?oog@3o_9X0oiYG@ooMEjSoVUM3oiYi@onUYDko
d]9k1?o^k^h00omn[MWo0@41ohV9R@04onk^kP0;ogIfM_l71`Oo2`/;oaTI
6OnRXZ;ok^k^oh20P?l^;Rko3Ph>ocDe=Onf][H00_o^k^h01om>CTkoOgmo
oeIFE_l820Soh>3Ponk^k_mn[MT0ooo^k^koonk^kU?ok^k^00001oooojSo
YJE>ooCdWOodm9goKFdFokaGIOnJND<00_nJEd<01omiEb;o_9X0of9R2ooM
gHKom?BMojFUC_oMgHH01?oVi^H00omn[MWo0@41om3@d005onKViP03odE5
AOmVIVKoi^KV00Coi^KV00?oi>CTonKVi_oVi^H01OoVi^H01?oShn?oi^KV
onKVi_mn[MWoonKVi_ooi^KVDooVi^H00006ooooZ?n4Q2gom?BMokblIOmR
HP_oQ8@]0_oMEhH01?nlEfGoEgU3omfl0?nUYDh2ooCdW@03ojFUC_oMgHKo
k^k^00?ok^k^00KoOZgIodE5AOlf=SKoQ8B4oe]KFomBDU82onk^kP03om7A
dOo?clook^k^00ook^k^00?oOZgIonk^k_o^k^h0ooo^k^koonk^kU7ok^k^
00002OooojSoNGTRooCdWOnUYDkoNGTRoiZJ@omiNB;ogEN6ohB4;@02oeMi
@`05ojFUC_odm9gom?BMojFUC_oBdW/01?ooool01_mn[MWono_kokJf]_m^
KVkoR8R8okno_aCooooo00?oOZgIooooooooool0oooooooooooooe7ooooo
00000oooojSoYJE>ooCdW@03ooCdW@06om;BNonJND?ooonXooCdWOnl_6Go
/K5J0_odm9d00onUYDkogMf6onk^kP03onk^kP03ogj]fOo^k^kok^k^01Oo
k^k^00?oOZgIonk^k_o^k^h0ooo^k^koonk^kU7ok^k^00000oooojSoNGTR
ooooZ00;ooCdW@03ojFUC_oMgHKoi^KV00?oi^KV00?oOZgIonKVi_oVi^H0
5ooVi^H00omn[MWoi^KVonKViP3oonKVi_ooi^KVDOoVi^H00003ooooZ?mi
NB;oYJE>00coYJE>00?ooonXonk^k_o^k^h00_o^k^h00omn[MWok^k^onk^
kP0Gonk^kP03ogj]fOo^k^kok^k^0?ook^k^ooo^k^iAonk^kP005?oooolK
ogj]fOoooooooooooomCooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool0
0?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00006onk^k_o]kNgoinOWon3Ph?oHf=Soe]KF1_oEeMD0
1OoFe]Kof=SHomoOgooVi^Kok>c/0?ook^k^ooo^k^iaonk^kP0000Kooooo
ooWinOoQhN7o_KfnojNWZ?nOX:06oijOW`06oinPX?nUYJKo^;RiomcLg?of
m_Koo_knooooooooooooog3ooooo00001_o/k>coh>3PokJf]_mnOWkoFe]K
oe=CD`KoDE5A00KoDe=CoeUIFOmgMgOo[Zj^omgMgOo[jn_oonk^k_ook^k^
L?o^k^h0000Bon?ShooHf=SoUiRIog>0S?nJ]kkoX/?6oj30aOnO_lKoYLG;
oj?1b?nQ`LGoX;o6oj;1a_nK^<?oMHNCohZ;S_oCdm?oh^;R4_oVi^H00ooD
e=CoemOGonKViP05onKViP03omCDe?oGemOoi^KV0?ooi^KVoooVi^IConKV
iP0001;ojNWYon;Rh_n;Si?oXLKTom;ko_oJo_gof_ooomOko?ngh>Gob?7c
omgooooJo_kog?omolkko_nZd?7oOhJ=omoOgooXj>P5onk^kP09oc8b<_nJ
VY[ok^k^omgMgOnEUIGof][Jonk^k_nb/[;o0@4100;ok^k^00Koc<c<oc4a
<Ol=3@go2`/;ocDe=Oo=cLd2onk^kP06olc<c?la<C7o3@d=o`/;2ole=CGo
cLg=0_o^k^h01_lk>c_oMWIfonk^k_o^k^koV9RHoaXJ6_ook^k^ooo^k^i:
onk^kP0001;onOWiooCdm?n@U9WoXlO^ok[Wo_nojoWoaoCoohna_?l10@7o
9Rd`ojW?g?o5looo_n[hokcVoOnWc_SoPh^Coo7alOoinOT5ooooo`0=ocHf
=_nUYJGoooooohj>S_l0003oQHF5oooooono_koo0P82ooooooono_ko=3@d
oe9BDP02onk^kP06oeEEEOle=CGoo_knookno_ld=3CoDU9B0_o^k^h01_mE
EEGo=CDeookno_oooooo@410ogmoO`;ooooo00?oXj>Soa`L7?ooool0oooo
ooooooooodWooooo00004_oXj>Sohn?SohN;T?nI`>Oo[MSlok?Poonag?So
;c]4o`410Ol0003oG7B4okWWoonbg_go[]Smoig6l?mjPh_oh>3PonSXj0Go
k^k^00go<S8boiZJV_o^k^ko;Rh^od92@_lT92Cok^k^ok:b/_l10@7ok^k^
olW9bOl0003oZZZZ00;ok^k^00KoZZZZo`000?o=cLgobLW9o`000?nZZZX2
onk^kP06ojZZZ_l0003ocLg=onk^k_lk>c_oMWIf0_o^k^h00onHV9So6QXJ
onk^kP3oonk^k_ook^k^BOo^k^h0000Bon3Ph?oLg=coPHJ<ohnfgonNboOo
Xm?oog^N_ol0003o<T1?oc91Col0003oR[;Foj[GoonNb_OoTK[UogAnR?oI
fMWoh>3P1OoVi^H03Ol`<33oU9BDol71`Ol0003o_knoobDU9Ond];Co[:b/
o`410OoVi^KoZj^[o`000?o?cll00_oVi^H01_o=cLgo0000ojj^[_n[Zj_o
0000olo?c`;oi^KV00KocLg=o`000?n^[Zkoi^KVocTi>OmbLW82onKViP03
oi>CTolI6AWoi^KV0?ooi^KVoooVi^I9onKViP0001;oj>SXon?Shon3RHoo
OjcHohnmk_nCaoko82/fo`L:3?mnZ]KoIXV]o`000?lfAe[oU<Kkoi30lOn4
/MkoM7n:on3Ph?oXj>P5onk^kP0=oc8b<_nJVY[oLg=cob`/;?o^k^koOgmo
of9RH_nb/[;o0@41onk^k_o=cLgo0000ojRXZ002onk^kP06ojJVY_l0003o
dM7Aolg=cOl0003oZ:RX0_o^k^h01_nVYZKo0000om7AdOo^k^ko>c/koeIF
EP;ok^k^00?oTY:Boa/K6oo^k^h0ooo^k^koonk^kTWok^k^00004_oinOWo
m?Cdoh^AV?m/W<koOK;/oeZ0Zol0003o:ce@oh6im_ml/nko:ci@o`000?mN
R;?oO[?^og2Qf?mgPXoolO7aooWin@Gooooo00Wo=SHfojBTY?lP823oRh^;
oooooooTi>Co51@DokRh^?l20P800_ooool01_m1@D7oB4Q8omkNg_oMgMgo
AdM7odA4A0;ooooo00Ko@D51odQ8B?oNg]kogMgModM7Aom4A4@2ooooo`06
od10@?lD51CoMWIfomkNg_mGEeOoCDe=oooooooooooood[ooooo00004_oX
j>Sohn?Sogj5S?mCQl;oHigNoaDQ;ol00@7oDHBmof6Oh_mTXnWoC7fdo`H:
3olC7RWoHI[KoeNAcOmZN8Koh>3PonSXj0Gok^k^00Co<S8bof9RH_l10@7o
eMGE0_o^k^h00om1@D7oI6ATo`410@02onk^kP06omSHf?m<C4co3Ph>o`h>
3_m>CTkofMWI0_o^k^h01_oHf=SoC4a<o`h>3_l>3PkoCTi>omWIf@;ok^k^
00KoCTi>oh:2P_m`L73o4Q8BobXZ:_nf][Koonk^k_ook^k^B_o^k^h0000B
on3Ph?oLg=coMWj7ocQj`_lcIIWo1Q0JoaTfEOm5S=ko?XCBocb2com7TN;o
73UJo`000?lYD7So?h?>of1_OooIfMWoh>3P1OoVi^H00ol`<33o4Q8Boc`l
?003onKViP03oi>CTolA4A7o0@4100Coi^KV0_oUiND6onKViP;oiNGU1ooV
i^H00ooUiNGoi^KVonKViP3oonKVi_ooi^KVB_oVi^H0000BonSXj?oVi^Ko
NX>>obi_^_mCT=CoE9OQoeNIhomCU=_oDY7Ioe>Af_mEU]goDXc>o`D;4_l;
4Q[o:fR`oei`Q?oShn?oj>SX1Oo^k^h00olb<S;o0000oi>CT`03onk^kP03
onCTi?l;2`_o0@410?ook^k^ooo^k^iRonk^kP0001;on?Shookno_n;T9_o
>6RcoiRkjOnZa^ooYlG`ojO8lOnTa?3oYLK`oj[:lon_d?[oJG^Do`D51Ol>
94_oJGJ>ooclo?oinOT5ooooo`03ok2`/?nJVY[ol_;b00Cooooo00?o][Jf
oi^KVoooool0ooooooooooooof7ooooo00004_oWinOok^k^oi>CVolS<X3o
SiW?okBmi_nj`n[o^/7ZokBlione_nOo_<?Yokg6k?n^]^3o:RXdo`002omb
M7gok^k^onSXj?ook^k^ooo^k^i`onk^kP00017ohN7QonKVi_nk^kgo8bAC
oahOG_lh?7Wo?d5mocm0OOlk?G[o?3iiocm0OOln@Wgo>Sajob4SCol0003o
DE5Aon3Ph03oonKVi_ooi^KVLOoVi^H00005ong]kOo^k^kojn_[om?Cdoo1
`L402?o0`<401?o3`lCoGemOo`000OnVYZKoonk^k_ook^k^LOo^k^h000co
oooo00Koo?clooooooo;bl_o1@D5odQ8B?obl_;oooooooooooooL?ooool0
0?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV00001_o^k^ko
kNg]onOWiooPh>3of=SHomKFePKoeMGE00Goe]KFomSHf?oOgmooi^KVonc/
k03oonk^k_ook^k^LOo^k^h00006oooooooinOWohN7Qokfm_OnWYjOoWinO
1_nNWYh01_nOWiooYJFUokRh^?oLg=com_Kfookno_oooooooooooom`oooo
o`0000Kok>c/on3Ph?nf][KoOWinoe]KFomCDe<6oe5AD@06oe=CDomIFEWo
MgMgojj^[_oMgMgojn_[ooo^k^koonk^kW3ok^k^00001ooShn?of=SHoiRH
V?n3Ph?o[Zj^okNg]onf][H01Ong]kL01_nf][Ko/[:bohR8R?n<S8codm?C
on;RhPGoi^KV00?oi>CTolK6a_o?cll01OoVi^H00ooShn?oemOGonKViP3o
onKVi_ooi^KVH?oVi^H00006onWYjOoRh^;oTI6Aolo?coolo?coo_kn1_oo
ool01_ono_kooOgmomcLg?n8R8SogmoOonSXj0Cok^k^00KoY:BTo`T92Ol<
30co8B4Qoc8b<_nKVi/2onk^kP06ok:b/_lI6AWo1PH6oda<C?mmOGgo;2`/
0_o^k^h01_lk>c_oMWIfonk^k_o^k^koV9RHoaXJ6_ook^k^ooo^k^iFonk^
kP0000KonOWiooCdm?nGUiOoe]KFooKfm_okno/7ooclo005ooOgmooLg=co
Shn?oo7alOoinOT01?ooool03_oFe]Ko_knooo[jn_ooooooWIfMo`@41?oN
g]kooooooeADE?mIFEWomoOgoijNW_l?3`oo<30`0_ooool01_m0@43oOgmo
ooooooooooooXj>Soa`L7?oooooooooooomFooooo`0000Ooj>SXon?Shon>
SXkod=3@on_[joo`l?3olO7a00;ol_;b0ooclo<01_obl_;ojn_[omKFe_n6
QXKoh>3PonSXj0Sok^k^00Kod];Bo`000?nYZJWok^k^obTY:On6QXH2onk^
kP06og5aLOl/;2cok^k^onk^k_lk>c_oMWIf0_o^k^h00onHV9So6QXJonk^
kP3oonk^k_ook^k^EOo^k^h00006on3Ph?oLg=coRHV9olS8b?oOgmooi>CT
0ooVi^H2onGUi@07onKVi_oUiNGog]kNolg=cOn2PX;ofMWIon3Ph007onKV
iP07omSHf?m7AdOo1`L7om[Jf_oVi^Ko9bLWohB4Q002onKViP06oh20P?l[
:b_oi^KVonKVi_li>CWoLW9b0_oVi^H00onCTi?o6ATIonKViP3oonKVi_oo
i^KVEOoVi^H00008onSXj?oShn?oS8b<ol30`?oDe=Cof][JomcLg?oKfm/2
omcLg008om_KfooLg=cogMgMomGEeOo7alOoQ8B4on3Ph?oXj>P6onk^kP04
ojVYZOlJ6Q[o5ADEok6a/@;ok^k^00Ko:BTYohV9ROo^k^kok^k^ohF5QOl/
;2`2onk^kP06oc/k>omFEUKok^k^onk^k_nBTY;o6a/Kooo^k^koonk^kUKo
k^k^00001_oinOWom?CdoiBDU?nj^[[oc<c<om3@d0?odM7A00Wod];Bom7A
dOoBd];odm?Colg=cOno_kooRHV9oo7alOoinOT01Oooool01?n1PH7o0@41
oeIFE_oVi^H3ooooo`06ob`/;?nCTi?ooooooooooon?Shoo<30`0_ooool0
1_m0@43o51@DogIfM_oNg]koEeMGode=COoooooooooooomFooooo`0001;o
j>SXon?Shon:RX[o[Zj^ol71`Oo5aLGoalO7olS8b?o5aLGoalO7olS8b?o7
alOoaLG5olC4a?ng]kOoP820on3Ph?oXj>P4onk^kP03omKFe_l10@7oRHV9
00Gok^k^00Ko?Shnoi>CToo^k^kok^k^oi2@T?m1@D42onk^kP06odi>C_n2
PX;oL71`oa8B4_lZ:R[o][Jfooo^k^koonk^kUKok^k^00002?oPh>3og=cL
ohF5QOnTY:Co]KFeokVi^Onm_Kgo_;bl0_ni^KT02?nl_;co^[ZjokZj^_nh
^;SoZj^[og]kNooIfMWoh>3P1?oVi^H00oo2`/;o0@41om3@d00@onKViP03
onGUiOoVi^Koi^KV0?ooi^KVoooVi^IFonKViP0000[oj>SXonKVi_n;Rh_o
Xj>Sok^k^ono_koo`L71ol;2`_o0`<3o_kno0_o1`L401_no_koo^k^kojVY
ZOmmOGgohn?SonSXj0Gok^k^00GoADE5ocHf=_n4Q8CoFe]Koe9BDP3oonk^
k_ook^k^I_o^k^h0000BooShn?ono_koVIVIoibLW?oAdM7of=SHomOGeooH
f=Soe]KFomOGeooKfm_ofMWIomOGeoo@d=3oX:2PohB4Q?olo?con?Sh1Ooo
ool01Ookno_o][Jfofi^K_n8R8So_kno0?oooooooooooomVooooo`0001;o
inOWonk^k_nIVIWoKFe]okRh^?o=cLgodM7Aom3@d?o>c/koclo?om;Bd_oA
dM7oclo?okVi^OmbLW;oOWinonk^k_oYjNWoonk^k_ook^k^L?o^k^h00006
on7QhOoVi^Ko_;bloda<C?mADE7oJFUY0_m]KFd02_mZJV[oJFUYof][Jom]
KFgoJFUYoeMGEom6ATKoZJVYonKVi_oRh^;oonKVi_ooi^KVL?oVi^H00004
ong]kOo^k^kojn_[om?Cd`[o`L7100?oclo?onWYjOo^k^h0ooo^k^koonk^
kW7ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00oomoOgmGogmoO`OoOWinoomoOglTogmoO`0000Co
jn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP03omcLg?oNg]kogMgM00;ogMgM
0?oog]kNomcLg?oNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]h0017ogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oLg=cogMgMom_Kf`02omcLg00comgMgOoMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
00;og=cL00GofMWIomSHf?oGemOof=SHomWIfP02omcLg03oomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kog=cLomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kN000GomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMh00ooNg]h00ooMgMgog]kNomkN
gP03omgMg@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>001ooIfMT0
1?oHf=Soe]KFom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI
00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWI
f@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SHfooI
fMT2omSHf006omKFe_oCdm?odm?ComCDe?oGemOof=SH0_oIfMT00ooHf=So
fMWIomWIf@02omSHf0WofMWI00?of=SHomWIfOoIfMT00_oHf=P00ooIfMWo
f=SHomSHf002omSHf1OofMWI00Cof=SHomKFe_oBd];oclo?0_o=cLd01?o?
cloodm?ComOGeooHf=SoomWIfAKofMWI00?of=SHomWIfOoIfMT01_oIfMT1
omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;R
hP02on7Qh@0=omkNg_oKfm_odm?ColO7aonk^k_o/[:bojf][Onb/[;o^k^k
olO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o
/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0>omoOgooK
fm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoO
gooPh>3Ion7Qh@09on3Ph?oOgmoofm_KomKFe_oDe=Coe]KFom[Jf_oNg]ko
h>3P00KogmoO0ooPh>000ooOgmooh>3Pon3Ph002on3Ph0SogmoO0_oNg]h2
omoOg`?oh>3P0_oOgml2on3Ph0;ogmoO3OoPh>001OoOgmoogMgMomWIfOoE
eMGodm?C00;od];B00?oe]KFomcLg?oPh>00KooQhN400ooPh>3ohN7Qon7Q
h@05on7Qh@03on3Ph?oQhN7ohN7Q03;ohN7Q00?oh>3Pon7QhOoQhN40J?oQ
hN400ooRh^;ohN7Qon;RhP04on7Qh@7oi>CT0OoXj>P1ong]k@0000?ol?3`
ono_kooalO400oo`l?00ooo_knool?3`onk^k_oYjNWofm_Kol71`OnTY:Co
S8b<ogYjN_mgMgOoNg]kohb<S?nTY:Co`/;1om[Jf_oZj^[okNg]oo7alOo_
knoolO7aono_kooalNookno_oo7alOo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<
RomkNg_oMgMgog]kNon<S8coY:BTol;2`_oJf][oj^[Xong]kOoalO7ok^k^
oo7alOo_knoolO7aono_kooalNookNg]on[Zj_oJf][o`/;2ojBTY?n<S8co
Ng]kogMgM_mkNg_oS8b<ojBTY?o2`/;of][Jon[Zj_o]kNgolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
k`006ooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_onk^k_o_knooj^[ZonOWi`02on3Ph007on?Shoo[jnWojn_[on[Z
j_oVi^Koj>SXonOWi`02onWYj@0Bonk^k?o/k>cok>c/onSXj?o/k>cokNg]
oo3`l?o/k>coj^[XonKVi_oXj>SoinOWonWYjOoXj>Sojn_[onOWiooWinGo
iNGU0_oYjNT03oo^k^kokNg]ong]kOoXj>Sojn_Yonc/k?o^k^kojNWYon[Z
j_o[jn_okno_onc/k?o/k>[oj^[Zonk^kP02onc/k03oon[Zj_o_knook>c/
onc/j_oZj^[ok^k^onc/k?n_[jooMWIfoeUIFOm^KVko]kNfon3Ph?oYjNWo
kNg]oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_000]oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo`l?3okno_oo3`
l?o_knool?3`ono_koo`l?3okno_00Col?3`00000oobl_;ok^k^onOWi`04
onGUi@0@onCTi?oOgmoodM7Aok6a/On:RX[oIFEUoe5ADOm5ADGo@T92odE5
AOmADE7oIVIVohZ:ROna/K7odM7AomkNgP;oi>CT00?oiNGUonCTi?oUiN@0
0_oTi>@03ooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmA
DE7oIVIVohZ:R_na/K7odM7@omgMg@02onCTi03]onGUiOoTi>CoiNGUonCT
i?oTi>?og]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5A
ofIVI_n:RX[o/K6aom7AdOoNg]koi>CSonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT00;oi>CT0?ooaLG5
obPX:?m4A4CoT92@om7AdOoLg=_ofm_KomOGeooDe=Coe]KFomCDe?oEeMGo
fMWIon3PgooNg]kof][JomCDe?oIfMWog]kNon;Rh_oLg=coemOFomCDe?oF
e]Koe=CDomGEeOoHf=Sofm_KomOGeooFe]GoeMGEomOGeooHf=Sog]kNomoO
gooLg=coeMGEomOGe_oLg=cogMgMomOGeooFe]Kofm_Kon7QhOoNg]kofm_J
om[Jf_oNg]kog=cLom[Jf_oKfm_oh>3PomoOgooLg=_ofMWIomkNg_oOgmoo
M7AdofMWIon=SHgoE5ADo`P82?nRXZ;og=cLon;Rh_oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUon?ShooUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoShn?oiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>@005SoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CT1?oUiND01_oTi>CoiNGUonGUiOoUiNGo
j>SXonc/k07ol_;b00000oodm?CokNg]onOWi`02on3Ph00Don7QhOoOgmoo
g]kNom;Bd_nd];CoQhN7oeaLG?m]>cGoWTi2ole^G_oYPfoocFmOoie=@om]
>cKoG5aLohN7Qond];Cod];BomkNg_oOgml4on3Ph00BomkNg_oBd];o];Bd
ohN7QomLG5coKF0/oijF;_o=cCoojNU=olg=?onNVRooKF<]oeaLG?n7QhOo
];Bdom;Bd_oNg]kogmoO1?oPh>004_oNg]kod];BokBd]?n7QhOoG5aLodMW
;_mXWS?oTLe7oj[YEOnAcDOoJYhdodUZ;omLG5coQhN7okBd]?oBd];og]kN
omoOgmSoh>3P00KogmoOolo?conIVIWoTY:BoaTI6On<S8`2omGEe@0Oolo?
coo2`/;oc/k>olk>c_o5aLGob/[:om[Jf_oHf=Sod=3@ol_;boo?cloof=SH
om[Jf_oEeMGoclo?ol71`Oo@d=3oc/k>olC4a?o;bl_of=SHomOGeonn_[ko
^k^kom7AdOo@d=3oeMGEomSHf?oCdm?oc<c<olk>cP02omGEe@05olk>c_o<
c<codm?Com[Jf_oHf=P00_oBd]801?oHf=SoemOGom7AdOoCdm<2omWIf@06
om?CdooAdM7oemOGomSHf?oAdM7od=3@0_oAdM401?m6ATKo@D51omOGeooN
g]iaon3Ph003omoOgooPh>3oh>3P00;oh>3P00?ogmoOon3Ph?oPh>00W?oP
h>000ooOgmooh>3PomoOg`02omoOg`?oh>3P00?ohN7QonOWioo/k>`00Ood
m?@00003ooKfm_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgoWinOofYN
G_n?=Rkok71QooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinO
olg=cOoRh^;oinOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOofiVGonCLR;o
kM54ooWcM?omoHgooOfEoogmS_oin7KokMM7oi=c8_m^IeooWinOolg=cOoR
h^;oinOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOof1XGom;O2?oT^5;okgi
Noo@oI;of?fKomCmUOo0nGkoV>Q=odf09?mPJEooWinOolg=cOoRh^;oinOW
0=[oj>SX00Coi^KVon7QhOmMGEgoCDe=0_oMgMd07om@D53o1`L7oaDE5On4
Q8Co5QHFod=3@ooRh^;ogMgMoibLW?l0003oShn?omgMgOoQhN7ofm_Kod10
@?l820So6ATIohR8R?l;2`_oF5QHokNg]ol<30co1`L7ob<S8olW9bOoOGem
om[Jf_oMgMgoe=CDo`/;2omIFET00_oIfMT00omMGEgo2`/;om?Cd`02omoO
g`06oeYJF_m>CTkog]kNomkNg_lS8b?oQ8B40_oQhN403?mjNW[o;Rh^omgM
gOoMgMgo`/;2oe1@D?lc<c?oKVi^oh>3PolQ8B7og]kNonKVi_ooj>SX7ooX
j>P1onc/k07ol_;b0Oofm_H00003ooOgmoohn?Son?Sh00?on?Sh01?omoOg
onk^k_o>c/koT92@ohD_:ooYI5Koni:7oojVVoon/JGookNZoojcY_onZ9co
nYB9oniXFOn9<B_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>
c/koT92@oiUY:oo`_Cgonn1^ookdP_onoX[ooonBooknS?onn8?onnE`oo32
?_nIJR_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@
od9c:on4cT?o[Nmcol;nR?o>oY3oe_nGom3nT_o6oXWo/_EdohSC@om4MB_o
T92@olk>c_o^k^komoOg0=[on?Sh02Gom_Kfoo7alOn1PH7o7alOong]kOo6
a/Ko0000ol?3`ooCdm?oG5aLo`P82?oZj^[ol?3`on[Zj_mBDU;o51@Docdm
?OoYjNWol?3`ojn_[ol71`Ood];Bolg=cOm>CTko6a/Konk^k_oKfm_o[Zj^
onSXj?o/k>co[Zj^o`000?nd];Cok>c/ok2`/?l;2`_o6QXJ00;oi>CT00_o
8b<So`h>3_nTY:CokNg]onk^k_mPH63oE5ADonk^k_o]kNgo9RHVohf=S@02
oo3`l00<oh:2P_la<C7ok>c/on[Zj_m3@d?o;bl_oibLW?mcLg?o:RXZoaXJ
6_o^k^kom_KfKoohn?P00oogmoOon?ShooShn005ooShn003ooOgmoohn?So
n?Sh09gon?Sh00?omoOgooShn?ohn?P00_ohn?P01?ogmoOonOWiooOgmoof
m_H1ooShn00000?on_[jooGemOo^k^h00_o/k>`0ooo[jn_ojNWYomoOgonj
^[[oNE9Boklb9?oVLfSooHUnoonGRoonXYKoojRLoojTV?ooVXgooXYoonif
J_o3<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/on[Zj_oOgmoo^[Zj
ohQUD_oRTAconL=@oogJHooojW;oo_=nooojP_onmWooonacookNI?ojae7o
hY8LohUVDonj^[[og]kNon[Zj_o[jn_ok>c/on_[jooZj^[ogmoOokZj^_mB
KE;oDJ<Loi7BEOnVif[o^?Ujol3nP_o7ohWo`oj4okWmNonWk6coU=IGoe:V
7?mBKE;o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k000BOo/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?oYjNWoiNGU
ogYjN_lL71cohN7Rolc<c?l30`?oX:2PomkNg_nDU9Co4a<Con7QhOoPh>7o
d=3@o`H61_nQXJ7o2@T9okno_ooQhN7o^[Zjo`820_nb/[;ogMgMoh20P?lX
:2Sohn?SonOWiooUiNGogmoOom_KfooCdm?o20P8ohF5QOoOgmooJFUYodY:
B_le=CGo[Jf]okfm_Ol71`OoN7QhoeEEEOoOgmooh>3Poe]KFom@D5000_oQ
hN402_lT92CoQHF5omoOgooQhN7oNg]kobl_;ooPh>3oe=CDo`D51OnXZ:P2
on?Sh`3ooginOolF5QKohN7Qon[Zj_o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?oZj^[ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>coj^[[onc/k?o[
jn_ok>c/on_[joo/k>coj^[Zonc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[000Jonc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jn`6on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT00003
oo_knooclo?okNg]00;oiNGU0?ooi^KVonCTi?oIfMWo/[:bogT^;_o8@S?o
hfYLooAjKOomR7cooYN:oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb
/[;oemOGonCTi?oUiNGoi^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^l
A?onc5?ooMQRookSL_onjGGoo^IcookKIOomc5?onl55onjN:onIERko/[:b
omSHf?oTi>CoiNGUonKVi_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on7bTSo
UmaIojGUJOnblgOo^?IkokCeNOnWjV_oV=aIohW?BomS[R_o;V<^ok:b/_oG
emSoi>CTonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNH003Coi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Kohn?SomoOgomgMgOo6a/KomcL
g?oQhN7oWYjNobl_;ol[:b_o<S8boa8B4_oLg=cof][KohB4Q?lP823oh>3P
oe9BD_mXJ6Sof][JomkNg_n@T93o:RXZobh^;_l/;2co9bLW0_oNg]h04ooI
fMWodm?Dom3@d?mKFe_o0000okfm_OoJf][o:2PXohN7QomgMgSoJ6QXoh:2
P_ll?3co`/;2o`l?3ooDe=Cof][JoeUIFOm>CTh00_oLg=`03olS8b?oPH61
omGEeOoGemOoMgMgobh^;_oLg=coXj>So`000?o7alOof=SHomWIfOn=SHko
5ADEomcLg002onCTi01`onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonCTi0;oiNGU0:;oi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNH2onKViP03
onGUiOoVi^Koi^KV00?oi^KV00?oiNGUong]kOodm?@00Oojn_X00003oocl
o?ohn?SolO7a00?ok^k^01?ojn_[on7QhOnl_;coNQLGol<o<_oCETWoi6QJ
onmgK?odPgWomhMlooF4N_ocNFgoiFUKomUHB_o4?c;oO1LGokbl_?oQhN7o
jn_[00?ok^k^01?ok>c/on7QhOnl_;coYDLGonJG<_oe[33ooKa1oog9Doom
d63onm=UoogBH?oncECooKe2ooZ_<_oYVc;oYDHGokbl_?oQhN7ok>c/00?o
k^k^01?ok>c/on7QhOnl_;co5eTGoenX<_mf_COoQ/e7oiKFF_nRh6GoXn1Y
oj?QIonGfUcoQ/i7ogNo=omOZc;o5eTGokbl_?oQhN7ok>c/0=[ok^k^02ko
k>c/onOWiomkNg_o71`LonCTi?oYjNWoi^KVon7QhOoNg]koSHf=oa@D5?oV
i^Koi>CTocDe=OmiNGWojn_[ok:b/_lE5AGogmoOonKVi_oTi>CohN7QomgM
gOmjNW[o:BTYonSXj?oUiNGogMgMok6a/OlV9RKo2`/;oi^KVooYjNWoc<c<
o`000?o>c/ko`l?3obDU9Om;Bd_oO7alonSXj?la<C7oYJFUonCTi?mMGEgo
DE5A0_oWinL02_lU9BGoJFUYomoOgooOgmooMgMgoc4a<OoYjNWo`L71o`00
0?nWYjL2omoOg`04oi>CTolF5QKoinOWonc/k:cok^k^00?okNg]onk^k_o^
k^h0K_o^k^h00oo]kNgol_;booShn001ooclo0000oomoOd05_olo?cooOgm
oogmoOolo?colo?com7AdOmX1`Oo^3@dolLo<ooBD4?ofV9Eon=^H_oTLVCo
i6mRomaTEooCDD?oc44dokTd=?m[1`Ood];Boo?cloolo?`3oogmo@0Coocl
o?oclo?od];Boih[1ooJRSCoji/IooFX:Ooh]3oonKe:ooRoCOoj_d[onKPo
ooJZ:_o_WQWofh/doj8]1ooBd];ol_;booclo003oogmo@0Cooclo?oclo?o
d];Bo`M01om=VSCoGj/Pog2h;omo`d?oR/e@ohg=D_n:cU3oPLM4og6i;omR
[R3oCY/do`M21ooBd];olo?cooclo03Joogmo@0Soo_knoogmoOoQ8B4oahN
7_oclo?onOWiok>c/oo@d=3olo?cofQXJ?m7AdOon_[jomCDe?l0003ogMgM
ooclo?okno_o9bLWojRXZ?oinOWoZj^[omGEeOoalO7oE5ADoeiNG_oinOWo
m?CdoiBDU?l51@Go@410om7AdOogmoOon?ShoiNGUol[:b/00_ojn_X06olT
92Co1`L7olS8b?okno_oQHF5of=SHoogmoOoHf=SoeMGEoohn?SonOWiobLW
9olE5AGoPh>3omOGeom2@T;oHf=Soo_knoojn_[o=3@dodU9BOoKfm_oiNGU
odm?ColG5aOonOWiooclo03ooogmoAcooOgm00?oo?cloogmoOolo?`00oom
oOd0000joogmoOojn_[olo?conk^k_o`l?3okno_onk^k_oYjNWodm?Coe/M
7OnR=3Co]2PMol4i;?o7BCcoceI:om1GBoo@Ed[obTXnol<k;_nf:1goXS@d
oe`M7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`koo^k^koj^[Zom?Cdon<9Ago
b74domV47OoTU1GoiidTonjX<oo`ZSCokjXconbP9OoWUaGog8PMolQa=?n<
9Agod];Bon[Zj_o^k^kol?3`ono_koo`l?3ok^k^on[ZjOoCdm?o7CPMocB2
=?m7UAgoFZDKofV]:P;oM;Ph0>;oMKThof^a:omKYacoB9XMocB2=?lM>1go
dm?Con[ZjOo^k^kol?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`0_o_knl0k_oZj^[oOWinoa`L7?oX
j>OokNg]ohR8R?l`<33o3`l?oc4a<Ona/K7ok^k^ohF5Q?m=CDgokno_onk^
k_o_knooRXZ:oeUIFOo^k^koN7Qhob/[:ol?3`oo>3Phokno_oo]kNgoi>CT
o`h>3_mYJFWogmoOon?ShooUiNGojn_[of5QHOmgMgOok^k^ono_k_mfMWKo
9RHVong]kOo_knooc<c<ob`/;?oZj^[oKFe/of9RH_o/k>cokNg]oc/k>onC
Ti?oHV9Ro`h>3_ld=3Coa<C4ono_koo^k^kodM7Aoc`l??l:2P[o9bLWofa/
K?l/;2cokno_onk^k_o`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`onk^k_o`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?03ono_k`1T
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_k`;ol?3`
1_o_knl1oo?cl`7onOWi0Oono_h00003ookno_ogmoOol?3`00CojNWY017o
inOWom_KfomSBd_oPC8bojHe=Onf=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf
=2goYCDeoh4b<_mSBd_ofm_KonOWi`05onWYj@0BonOWiooKfm_oRD];ojm;
<_o=McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;oRD];
om_KfooWinOoj>SX1?oYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[
ZbooL:dhofn^>_m`[CSoJZX_oe>K;OliR3Go<V0bod];BooKfm_oinOW0=_o
jNWY00Koj>SXonKVi_mkNg_o71`LonCTi?oXj>P2onWYj@03onOWiooYjNWo
jNWY00_ojNWY00coinOWonWYjOoYjNWoj>SXomSHf?l:2P[o[Zj^omgMgOoN
g]koh>3PonGUiOoXj>P8onWYj@06onSXj?oVi^Kohn?Son?ShooVi^Koj>SX
0ooYjNT00ooXj>SojNWYonWYj@04onWYj@03onOWiooYjNWojNWY0?oojNWY
6ooYjNT00ooXj>SojNWYonWYj@04onWYj@7ol?3`0OogmoL1ooknoP0000Go
o_knoo[jn_odm?Cokno_oo7al@02oo3`l00Aono_koo[jn_oUIBDodlS8onE
E5Co^g=com>EUOoJW9cofYjLomVLW?oDUIGo^g=coiEDE?m?8b?oUIBDonWY
jOo_knl01Oo`l?004Oo_knooj^[ZojVDU?n18b?o^VYDomBJLooT_9Goj/NL
onW7W?oZaicoiKbEomBJLonkJUCoPB<SojZDU?oZj^[okno_00Gol?3`013o
kno_on[Zj_nDU9Co8bXSoeAjE?mcYG?oW/JEojc>W?n]cYco[<jLoik6UOmc
YG?oE7YDob<Z8onDU9Coj^[Z0_o_knoJoo3`l0;okno_00CoP820oadM7Oo^
k^kokno_4oo`l?02ono_k`07ofATI?lY:BWoPH61of=SHolk>c_ok^k^ono_
k`08oo3`l006ono_koo^k^koLg=cofUYJOo^k^kokno_ooo`l?0]oo3`l004
oo7alOo`l?3om?Cdoo[jnP7oo_kn00001?o/k_3oooooooooooono_h2oooo
o`;oo_kn0?oooOgmooShn?m^KVkoFSlook6@T?oNbLWol>CToo?Vi_o`i>Co
g/W9ok6@T?mJ?cooKFe]ooShn?olo?coooooookno_ooooooo_knooooo_on
o_koooooooclo?ohn?SoSFe]ohXo?oo9TI3ojM39ooCYi?ofjnKom>WTonW@
bOo9TI3oRCloohe]KOohn?Ooo?clooooooono_koooooookno_ooooooo_kn
ooooo_olo?con?Shofe]KOlo?cooT9f@olWEbOoTk>Coi^kVonC/i?o9eLWo
T9f@oclo?om]KFgon?Shooclo?ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_h003Sooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_kooooooogmoOo@d=3oYJFUooknoOono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_oooooooOgmol71`?maLG7oPH61ojn_[`;oo_kn
00coooooookno_ooookoo_knooooooono_koooooookno_oooooooOgmol;2
`Onl_;`2ooknoP3oooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo000Y
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_h00_ooool00oono_kooooo
ooooo`03ooooo`7on__k00001?o1b<koo_knoo[jn_odm?@5oo7al@0>ono_
kooFe]KoJf][od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_oe]KF
ono_koo`l?08oo7al@0=ono_kooGe]KoPf][og@m?OneS8coeKZjon7<c?oF
^[[o]Xb<og8m?On1Jf_oemKFono_k`02oo7al@03oo3`l?oalO7olO7a00Co
lO7a00gokno_omKFe_m[Jf_o?Cdmohb<S?nj^[[oc<g<okZj^_n<S8co?Cdm
of][JooFe]Kokno_0?oolO7aoooalO4doo7al@04oo3`l?oalO7olO7aoo3`
l0ColO7a00?om?Cdoo[jn_ono_h00Oo[kNh00005ohB?VOomoOgon?Shoo3`
l?o[jn/00ooZj^X03OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9
obHV9_mIFEWoVi^KonSXj?oYjNT02ooZj^X02ooYjNWoj>SXoj2KVomZFEWo
@bHVobd92Om29RKoJEUIoj2KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nK
Vi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@3oon[Zj_ooj^[Z
??oZj^X01?o[jn_ol?3`ooShn?omoOd1om;Ff00000Co=TIAokS0aOoinOWo
m?Cd2?oalO42oo3`l0?okno_0_o`l?04oo7al@03oo3`l?oalO7olO7a00So
lO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`l?03oo7al@03
oo3`l?oalO7olO7a0?oolO7aoooalO4doo7al@03oo3`l?oalO7olO7a00;o
lO7a00?omOGeoo[jn_o/kNl00OnQYJP00003oad_?om<FF?o^Ko50?oooooo
oooooomlooooo`7okNk_0On]/;81ojFZ[@0000Ko72hmoaXY=Olb?4KoOXR@
okg3b?o[k>koooooooooooooM_ooool01OoZjnco^l34ogV1Qol/=Cgo4alY
007o52@_0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[BoxData[{
    \(\(savedLayout = pane@getLayout[];\)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]\(pane@
          setLayout[\[IndentingNewLine]JavaNew["\<java.awt.GridLayout\>", 10, 
              3, 5, 5]\[IndentingNewLine]];\)\[IndentingNewLine]]\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(box1 = NewJCheckBox[pane, "\<Sun\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JCheckBox"] \[RightGuillemet]\),
      JLink`Objects`JavaObject117322400399361]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(box2 = NewJCheckBox[pane, "\<Moon\>", True]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JCheckBox"] \[RightGuillemet]\),
      JLink`Objects`JavaObject106834090262529]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(icon = 
      JavaNew["\<javax.swing.ImageIcon\>", 
        StringJoin[$JavaSwingMaterial, "\<NB(S).GIF\>"]]\), "\n", 
    \(iconWidth = icon@getIconWidth[]\), "\n", 
    \(iconHeight = icon@getIconHeight[]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject31863372513281]], "Output"],

Cell[BoxData[
    \(16\)], "Output"],

Cell[BoxData[
    \(16\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(icon2 = 
      JavaNew["\<javax.swing.ImageIcon\>", 
        StringJoin[$JavaSwingMaterial, "\<NB(S)2.GIF\>"]]\), "\
\[IndentingNewLine]", 
    \(iconWidth = icon2@getIconWidth[]\), "\n", 
    \(iconHeight = icon2@getIconHeight[]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject21778067881985]], "Output"],

Cell[BoxData[
    \(16\)], "Output"],

Cell[BoxData[
    \(16\)], "Output"]
}, Open  ]],

Cell["\<\
Using icons is possible for the substitution of the default check \
mark.
To replace icons by the user's click, setIcon( ) method is available. An \
event handler also should be introduced.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(box3 = NewJCheckBox[pane, "\<Star\>", False, icon]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JCheckBox"] \[RightGuillemet]\),
      JLink`Objects`JavaObject40243893895169]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"],

Cell[BoxData[
    \(box3@setIcon[icon2]\)], "Input"],

Cell[BoxData[
    \(box3@setIcon[icon]\)], "Input"],

Cell[BoxData[
    \(box3@setIcon[icon2]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(DeleteJObject[pane, box1]\)], "Input"],

Cell[BoxData[
    \(DeleteJObject[pane, box2]\)], "Input"],

Cell[BoxData[
    \(DeleteJObject[pane, box3]\)], "Input"],

Cell[BoxData[
    \(ReleaseObject[icon]\)], "Input"],

Cell[BoxData[
    \(ReleaseObject[icon2]\)], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["<<< SimpleJCheckBox >>>",
  FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002c0000E1P00`40o`00
0?l0003o/`00000000>8`;Q8T8Q8T8P0[dR@R04000000003R<2hb>3HR<2h
0:j8`;P1B9280@00000000>8`;S8h=R8`;P0[XS0^058T8P10000000018S0
^<SPf8S0^8S0^:_<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hZlc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;R[c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^:_<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hZlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;R[c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^:_<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hZlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;R[c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^:_<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hZlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;R[c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^:_<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hZlc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;R[c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^:_<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hZlc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;R[c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^:_<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hZlc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;PCc<c<4iVIc8G<c<`2R<2h0DR@R0400000
0006R<2hb>3HR<2hR<2hoonX/K5J1hB4;@03NGTRQ8@]Q8@]00>4Q2d01Kbl
ILc<c<c<c<c<c9VIc00Ac<c<00>IVLc<c<c<c<`0Plc<c0:8`;P1B9280@00
000000N8`;S8h=R8`;R8`;SoojR4Q2fJVT<00jFUCP03VYY3YJE>YJE>00FU
YDh00gUi8]gMQ/c<c002c<c<00>IVLc<c<c<c<`03lc<c003VIW<c<c<c<c<
08?<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hoonXNGTR0_CdW@08
d]9kYJE>alM`oonXm?BMjNVBYJE>jNVB0_CdW@03YJE>gMf6c<c<00;<c<`0
0iVIc<c<c<c<c00?c<c<00>IVLc<c<c<c<`0Plc<c0:8`;P1B9280@000000
00Z8`;S8h=R8`;R8`;SoojQiNB;oojSdm9fUYDiGNHH2NGT000R4Q2eiEb9G
EaJJEd>UYDkoojRUYDkBdW/3c<c<00>IVLc<c<c<c<`0100000?<c<`20000
0lc<c08000000lc<c9VIc<c<c024c<c<0XS0^058T8P1000000001XS0^<SP
f8S0^8S0^?ooZ:FUCP;dm9d039ZJ@eNJZ5NJQXB4;GUG8WUi8ZFUCWUG8[6a
F_CdWIZJ@mgMQP?<c<`019VIc<c<c000000000;<c<`200000/c<c0800002
c<c<0`000003c<c<VIW<c<c<08C<c<`2R<2h0DR@R04000000009R<2hb>3H
R<2hR<2hoonXNGTRm?BMjNVBHV8;009GVZP02GVJQVe]5[6aF[blIFe]5^WY
T_CdWJFUC]gMQP03c<c<00>IVL`0000000001<c<c08000000lc<c0000000
0002c<c<0`000003c<c<VIW<c<c<08C<c<`2R<2h0DR@R0400000000:R<2h
b>3HR<2hR<2hoonXNGTRm?BMNGTRNELREeL;0Ve]5P08EgTRNELRHUL0EeL0
NGTRd]9kYJE>d]9k0lc<c003VIW<0000000000C<c<`2000000C<c<`00000
003<c<`4000000?<c<bIVLc<c<`0Q<c<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;SoojRUYDh2VWU300bUYDja/EZJVT=iN@1GNHIGVXIiEd=GE`2J
ND=iNB:UYDkMgHH3c<c<00>IVL`0000000001<c<c08000001/c<c0000000
0<c<c0000<c<c08000000lc<c9VIc<c<c024c<c<0XS0^058T8P100000000
3HS0^<SPf8S0^8S0^?ooZ8B4;GUG8]eGQYYi@iZJ@f9G0;bJ0=fl0002EiZ6
0[aGI@03d]9kYJE>gMf600?<c<`00iVIc00000000004c<c<0P000003c<c<
00000000008000001Lc<c00000000<c<c9VIc025c<c<0XS0^058T8P10000
000028S0^<SPf8S0^8S0^?ooZ7Ui8]gMQXB4;@9GE`002WUG8YZJ0?oM0;bJ
09YG@meGZ9YG@iYi@jFUC];BN`?<c<`00iVIc00000000004c<c<0P000004
c<c<0000000000000/c<c08000000lc<c9VIc<c<c024c<c<0XS0^058T8P1
000000001XS0^<SPf8S0^8S0^?ooZ:FUCP;dm9d00fe]5[aGIIYi@`02VUM3
00MiEb:lVP1RHP_MgHKdm9fUYDkMgHH00lc<c004VIW<c<c<000000000/c<
c0800002c<c<0`0000;<c<`2000000?<c<bIVLc<c<`0Q<c<c0:8`;P1B928
0@00000000Z8`;S8h=R8`;R8`;SoojR4Q2gdm9fl_6ERHP^4Q2d2gEN600Bl
EfEGND?M_02UYDh2m?BM00>UYDkMgHK<c<`00/c<c003VIW<c<c<c<c<00@0
0003c<c<0P0000?<c<`2000000?<c<bIVLc<c<`0Q<c<c0:8`;P1B9280@00
000000f8`;S8h=R8`;R8`;SoojQiNB;dm9fUYDiiNB:JVT=iNB;MEhJ4Q2d0
0UMi@`05YJE>m?BMm?BMYJE>d]9k00?<c<`00iVIc<c<c<c<c00?c<c<00>I
VLc<c<c<c<`0Plc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;SoojRU
YDh4m?BM00KBdW^JND?oojSdm9fl_6Fa/EX2m?BM00>UYDkMgHK<c<`00/c<
c003VIW<c<c<c<c<00o<c<`00iVIc<c<c<c<c023c<c<0XS0^058T8P10000
00001hS0^<SPf8S0^8S0^?ooZ7Ui8_ooZ00;m?BM00>UYDkMgHK<c<`00/c<
c003VIW<c<c<c<c<00o<c<`00iVIc<c<c<c<c023c<c<0XS0^058T8P10000
00001XS0^<SPf8S0^8S0^?ooZ7Ui8PfUYDh01OooZ<c<c<c<c<c<c9VIc00A
c<c<00>IVLc<c<c<c<`0Plc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PCc<c<4iVIc8G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hZlc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;R[c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^:_<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hZlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;R[c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^:_<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hZlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;R[c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^:_<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hZlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;R[c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^:_<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hZlc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;R[c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^:_<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hZlc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;R[c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^:_<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hZlc<c0:8`;P1B928
0@00000000>8`;S8h=R8`;P0[XS0^058T8P10000000018S0^<SPf8S0^8S0
^1<00800HP01P003P@05P@07PP49P`4:P`4<Q04>Q@8@Q@8BQP8CQ`8EQ`<G
R0<IR@<KR@<MRP@NRP@PR`@RS0@TS0DVS@DWSPDYSPD[S`H]T0H_T0HaT@Hb
TPLdTPLfT`LhU0LjU0LkU@PmU@PoUPQ1U`Q3U`U5V0U6V@U8V@U:VPY<V`Y>
V`Y?W0YAW@]CW@]EWP]GW`]IW`aJX0aLX0aNX@aPXPeRXPeSX`eUY0eWY0iY
Y@i[YPi]YPi^Y`m`Z0mbZ0mdZ@mfZPmgZQ1iZa1kZa1m[11o[A61[A62[Q64
[a66[a:8/1::/A:;/A:=/Q>?/a>A/a>C]1>E]ABF]ABH]QBJ]QBL]aFN^1FO
^1FQ^AFS^QJU^QJW^aJY_1JZ_1N/_AN^_QN`_QNb_cHH]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h1000P003VjOa<d>U<d>U00Tc@jD300200680
0H000h401H401h812H<12X<138@13XD248D24XH24hL25HL35hP36HT36hT3
7HX47XX488/48X`498`59Xd59hh5:Hh5:hl6;I06;i06<I46<Y87=987=Y<7
>9@7>Y@7>iD8?ID8?iH8@IL8@iL9AIP9AYT9B9T9BYX:C9/:CY/:Ci`:DId;
Did;EIh;Eil;FIl<FZ0<G:0<GZ4<H:8=HZ8=Hj<=IJ@=Ij@>JJD>JjH>KJH>
KZL?L:P?LZP?M:T?MZX?MjX@NJ/@Nj/@OJ`@OjdAPJdAPZhAQ:lAQZlBR;0B
R[4BRk4BSK8CSk<CTK<CTk@CUKDDU[DDV;HDV[HDW;LEW[PEWkPEXKTEXkXF
YKXFYk/FZK`FZ[`G[;dG[[hG/;hG/[lf6;C00XS0^058T8P10000000018S0
^<SPf8S0^8S0^0<008001i^WlOooohij]ZJKa;>YdZRMb;>YdP02YY_400Fl
^=g^k_CZjO7ooolc@jD00P00P01R006000>100F100N20@V30@Z30@b40@j5
0Q250Q:60Q>70QF70aN80aV90a^90af:11j:122;12:<12B<1BJ=1BN>1BV>
1B^?1Rf@1Rn@1S6A1S:B1cBB1cJC1cRD1cZD1c^E23fE23nF246G24>G2DFH
2DJI2DRI2DZJ2TbK2TjK2TnL2U6M2e>M2eFN2eNO2eVO35ZP35bP35jQ362R
3F:R3F>S3FFT3FNT3VVU3V^V3VfV3VjW3g2X3g:X3gBY3gJZ3gNZ47V[47^[
47f/47n]4H6]4H:^4HB_4HJ_4XR`4XZa4X^a4Xfb4hnc4i6c4i>d4iFe59Je
59Rf59Zf59bg5Ijh5Inh5J6i5J>j5ZFj5ZNk5ZVl5ZZl5jbm5jjn5k2n5k:o
0QRd`20000026;C04000008H]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0P00P004VjOaooooK5ZU[jG:0[bhg@1]oogo/jWBoooooooo_;SMUhZl
Z9g8i^K/oooo<d>U0020006000>100F100N20@V30@Z30@b40@j50Q250Q:6
0Q>70QF70aN80aV90a^90af:11j:122;12:<12B<1BJ=1BN>1BV>1B^?1Rf@
1Rn@1S6A1S:B1cBB1cJC1cRD1cZD1c^E23fE23nF246G24>G2DFH2DJI2DRI
2DZJ2TbK2TjK2TnL2U6M2e>M2eFN2eNO2eVO35ZP35bP35jQ362R3F:R3F>S
3FFT3FNT3VVU3V^V3VfV3VjW3g2X3g:X3gBY3gJZ3gNZ47V[47^[47f/47n]
4H6]4H:^4HB_4HJ_4XR`4XZa4X^a4Xfb4hnc4i6c4i>d4iFe59Je59Rf59Zf
59bg5Ijh5Inh5J6i5J>j5ZFj5ZNk5ZVl5ZZl5jbm5jjn5k2n5k:o008H]<00
0lSPf4R@R4R@R00<B92800<00038h=Q8T8P03DR@R00400006;C06;C0b>3H
3TR@R00300006;C06;C000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
002000^KYo7ooonXWLSoooncZM9PC9Z>N[IhIJjXWLSooooooOl00oooo`1U
<d>U00200020006000>100F100N20@V30@Z30@b40@j50Q250Q:60Q>70QF7
0aN80aV90a^90af:11j:122;12:<12B<1BJ=1BN>1BV>1B^?1Rf@1Rn@1S6A
1S:B1cBB1cJC1cRD1cZD1c^E23fE23nF246G24>G2DFH2DJI2DRI2DZJ2TbK
2TjK2TnL2U6M2e>M2eFN2eNO2eVO35ZP35bP35jQ362R3F:R3F>S3FFT3FNT
3VVU3V^V3VfV3VjW3g2X3g:X3gBY3gJZ3gNZ47V[47^[47f/47n]4H6]4H:^
4HB_4HJ_4XR`4XZa4X^a4Xfb4hnc4i6c4i>d4iFe59Je59Rf59Zf59bg5Ijh
5Inh5J6i5J>j5ZFj5ZNk5ZVl5ZZl5jbm5jjn5k2n5k:o008H]<000lSPf8S0
^8S0^00;R<2h00=8T8P00038h=P03HS0^005B92800006;C06;C0b>3H00f8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
002000jKYo7ooooooooKg>aPC9ZCQKZcZM:l^=ePC9ZISkjVVlC8`moooolc
@jD3002000/00H000h7oool01h812H<12X<138@13XGoool24XH24hL01?oo
o`0=0af:11j:122;oooo12B<oooo1BN>1BV>1B^?oooo1Rn@1S6A1S:B00?o
ool03PLjU0LkU@PmUOooo`Q1U`Q3U`U5V0U6V@U8VOooo`Y<V`Y>V`Y?W0YA
W@Coool02`aJX0aLX?ooo`aPXPeRX_ooo`eUY0eWY?ooo`i[YPi]YP03oooo
02<?M:T?MZX?MjX@NJ/@Nj/@OJ`@OjdAPJdAPZhAQ:lAQZlBR;0BR[4BRk4B
SK8CSk<CTK<CTk@CUKDDU[DDV;HDV[HDW;LEW[PEWkPEXKTEXkXFYKXFYk/F
ZK`FZ[`G[;dG[[hG/;hG/[l00QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P0
0dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00
P00>VjOaoooo_;SMVHnnooooe]7Mfmc/lokoYY_4k^kdQGJ`ThFjoooo<d>U
0P00P01R006000>1oooo00N20@V3oooo0@b40@j5oooo0Q:6oooo0QF70aN8
0aV9oooo0af:11j:oooo12:<12B<oooo1BN>1BV>1B^?oooo1Rn@1S6Aoooo
1cBB1cJC1cRDoooo1c^E23fEoooo246G24>G2DFH2DJI2DRIoooo2TbK2TjK
2TnLoooo2e>M2eFN2eNOoooo35ZP35bPoooo362R3F:Roooo3FFT3FNToooo
3V^Voooo3VjW3g2X3g:Xoooo3gJZ3gNZ47V[47^[47f/47n]4H6]4H:^4HB_
4HJ_4XR`4XZa4X^a4Xfb4hnc4i6c4i>d4iFe59Je59Rf59Zf59bg5Ijh5Inh
5J6i5J>j5ZFj5ZNk5ZVl5ZZl5jbm5jjn5k2n5k:o0QRd`004b>3HR<2hR<2h
R<2h1P0000B8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^005
0000R<2hR<2hB9280000008H]<001<SPf8S0^8S0^8S0^0800004R<2h0P00
00:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3002007:KYo7ooonISkjGR[cDdnS_[;?oMW_^Wj]KF:FVVlBFWm9PC9Zl
^=gooolc@jD008000H000h7oool01h812H?oool138@13XGoool24XKoool2
5HL35hP36HWoool37HX47X[oool48X`498coool59hh5:Hh5:hooool6;i06
<I7oool7=987=Y<7>9Coool7>iD8?IGoool8@IL8@iL9AIP9AYT9B9Woool:
C9/:CY/:Cicoool;Did;EIh;Eiooool<FZ0<G:3oool<H:8=HZ;oool=IJ@=
IjCoool>JjKoool>KZL?L:P?LZP?M:T?MZX?MjX@NJ/@Nj/@OJ`@OjdAPJdA
PZhAQ:lAQZlBR;0BR[4BRk4BSK8CSk<CTK<CTk@CUKDDU[DDV;HDV[HDW;LE
W[PEWkPEXKTEXkXFYKXFYk/FZK`FZ[`G[;dG[[hG/;hG/[l26;C000?8h=R8
`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D0
0028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8`;P200000XS0^080
0003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0P00P00:VjOaooooUhZlNVbZ/lOXZFjPb<?OThFjFdJCVHnn0WQU[P0@
@RN5[jG:oooo<d>U0020006000>1oooo00N2oooo0@Z3oooo0@j5oooo0Q:6
0Q>71?ooo`0N0af:11j:oooo12:<12B<oooo1BN>1BV>1B^?oooo1Rn@1S6A
1S:B1cBB1cJC1cRDoooo1c^E23fEoooo246G24>G2DFH2DJI2DRIoooo2TbK
2TjK2TnL2U6M1?ooo`0:35ZP35bPoooo362R3F:Roooo3FFT3FNToooo3V^V
1Oooo`0R3gJZ3gNZ47V[47^[47f/47n]4H6]4H:^4HB_4HJ_4XR`4XZa4X^a
4Xfb4hnc4i6c4i>d4iFe59Je59Rf59Zf59bg5Ijh5Inh5J6i5J>j5ZFj5ZNk
5ZVl5ZZl5jbm5jjn5k2n5k:o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R000
0<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H
]<000lSPf8S0^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7oooooool00_ooo`0:
ojf`ogIknLgDoNg^ooooYY_4QGJ`_;SMoooo<d>U0P00P00D006000>1oooo
00N2oooo0@Z3oooo0@j5oooo0Q:60Q>70QF70aN80aV9oooo0af:11j:oooo
12:<12B<0_ooo`0<1BV>1B^?oooo1Rn@1S6A1S:B1cBB1cJC1cRDoooo1c^E
23fE1?ooo`0=2DJI2DRIoooooooo2TjK2TnL2U6M2e>M2eFN2eNOoooo35ZP
35bP00;oool0;@eRX_ooooooo`eWY?ooo`i[Y_ooo`i^Y`m`Z0mbZ?ooo`mf
ZPmgZQ1iZa1kZa1m[11o[A61[A62[Q64[a66[a:8/1::/A:;/A:=/Q>?/a>A
/a>C]1>E]ABF]ABH]QBJ]QBL]aFN^1FO^1FQ^AFS^QJU^QJW^aJY_1JZ_1N/
_AN^_QN`_QNb_`026;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8
`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3H
R<2hR<2h00B8`;P200001HS0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0<008002Z6/l_W=e>8V??Be_n8V??A]OOcSjOoo
oog]k_n]/0;oool03c=3Y@00P000P000P001P003POooo`07P_ooo`4:Pooo
o`4>QOooo`8BQP8CQ`03oooo00<36hT37H[oool00_ooo`0312B<oooo1BN>
00;oool05@H]T0H_T0HaT@HbTPLdTPLfT`LhU?ooo`LkU@PmUOooo`Q1U`Q3
U`U5V0U6V@U8VOooo`Y<Voooo`Y?W0YAW@03oooo00D;FIl<FZ0<G:3oool<
H:800_ooo`053FFToooo3VVU3V^V3VfV00?oool08`mdZ@mfZPmgZQ1iZa1k
Za1m[11o[A61[A62[Q64[a66[a:8/1::/A:;/A:=/Q>?/a>A/a>C]1>E]ABF
]ABH]QBJ]QBL]aFN^1FO^1FQ^AFS^QJU^QJW^aJY_1JZ_1N/_AN^_QN`_QNb
_`026;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0
^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8
`;P4000018S0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_ARK_omoon]/?cS
jOoooc=3Y@04002000L00H000h7oooooool12H<12X<138@00_ooo`1I0Q:6
0Q>70QF70aN80aV90a^90af:11j:oooo12:<12B<oooo1BN>1BV>1B^?1Rf@
1Rn@1S6A1S:B1cBB1cJC1cRDoooo1c^E23fEoooo246G24>G2DFH2DJI2DRI
2DZJ2TbK2TjK2TnL2U6M2e>M2eFN2eNO2eVO35ZP35bP35jQ362R3F:R3F>S
3FFT3FNT3VVU3V^V3VfV3VjW3g2X3g:X3gBY3gJZ3gNZ47V[47^[47f/47n]
4H6]4H:^4HB_4HJ_4XR`4XZa4X^a4Xfb4hnc4i6c4i>d4iFe59Je59Rf59Zf
59bg5Ijh5Inh5J6i5J>j5ZFj5ZNk5ZVl5ZZl5jbm5jjn5k2n5k:o008H]<00
0lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8
`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002
R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2002000>KYo7fb<cR9S`00_n]/007gb@^ojBNm[c5ojf`kW^<
oooo<d>U00D008001`01P003POooooooo`49P`4:P`4<Q002oooo05T24XH2
4hL25HL35hP36HT36hT37HX47X[oool48X`498coool59hh5:Hh5:hl6;I06
;i06<I46<Y87=987=Y<7>9Coool7>iD8?IGoool8@IL8@iL9AIP9AYT9B9T9
BYX:C9/:CY/:Ci`:DId;Did;EIh;Eil;FIl<FZ0<G:0<GZ4<H:8=HZ8=Hj<=
IJ@=Ij@>JJD>JjH>KJH>KZL?L:P?LZP?M:T?MZX?MjX@NJ/@Nj/@OJ`@OjdA
PJdAPZhAQ:lAQZlBR;0BR[4BRk4BSK8CSk<CTK<CTk@CUKDDU[DDV;HDV[HD
W;LEW[PEWkPEXKTEXkXFYKXFYk/FZK`FZ[`G[;dG[[hG/;hG/[l00QRd`003
b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@R000
01Rd`1Rd`<SPf003R<2h0P0000B8`;P200000XS0^004B92800006;C06;C0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^08008000i^WlOW=e?N9U`02
oooo00Oo[K3Q5SCoMW_oY9kR9ScoRGlc@jD01@00P00R006000>1oooo00N2
0@V30@Z30@b40@j5oooo0Q:60Q>70QF70aN80aV90a^90af:11j:122;12:<
12B<oooo1BN>1BV>1B^?1Rf@1Rn@1S6A1S:B1cBB1cJC1cRDoooo1c^E23fE
1Oooo`0k2DRI2DZJ2TbK2TjK2TnL2U6M2e>M2eFN2eNO2eVO35ZP35bP35jQ
362R3F:R3F>S3FFT3FNT3VVU3V^V3VfV3VjW3g2X3g:X3gBY3gJZ3gNZ47V[
47^[47f/47n]4H6]4H:^4HB_4HJ_4XR`4XZa4X^a4Xfb4hnc4i6c4i>d4iFe
59Je59Rf59Zf59bg5Ijh5Inh5J6i5J>j5ZFj5ZNk5ZVl5ZZl5jbm5jjn5k2n
5k:o008H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0T00002
R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0^058
T8P10000000018S0^<SPf8S0^8S0^08008001i^WlOoooo>P[_ARK_ooooN9
UoW=e002oooo00?cX:kooolc@jD01@00P01R006000>100F100N20@V30@Z3
0@b40@j50Q250Q:60Q>70QF70aN80aV90a^90af:11j:122;12:<12B<1BJ=
1BN>1BV>1B^?1Rf@1Rn@1S6A1S:B1cBB1cJC1cRD1cZD1c^E23fE23nF246G
24>G2DFH2DJI2DRI2DZJ2TbK2TjK2TnL2U6M2e>M2eFN2eNO2eVO35ZP35bP
35jQ362R3F:R3F>S3FFT3FNT3VVU3V^V3VfV3VjW3g2X3g:X3gBY3gJZ3gNZ
47V[47^[47f/47n]4H6]4H:^4HB_4HJ_4XR`4XZa4X^a4Xfb4hnc4i6c4i>d
4iFe59Je59Rf59Zf59bg5Ijh5Inh5J6i5J>j5ZFj5ZNk5ZVl5ZZl5jbm5jjn
5k2n5k:o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf00=R<2h00E8
T8P0000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0<008002i^WlOoooon9Oooooo>P[_6CXOooooom
oo>P[_oko3=3Y@05002006800H000h401H401h812H<12X<138@13XD248D2
4XH24hL25HL35hP36HT36hT37HX47XX488/48X`498`59Xd59hh5:Hh5:hl6
;I06;i06<I46<Y87=987=Y<7>9@7>Y@7>iD8?ID8?iH8@IL8@iL9AIP9AYT9
B9T9BYX:C9/:CY/:Ci`:DId;Did;EIh;Eil;FIl<FZ0<G:0<GZ4<H:8=HZ8=
Hj<=IJ@=Ij@>JJD>JjH>KJH>KZL?L:P?LZP?M:T?MZX?MjX@NJ/@Nj/@OJ`@
OjdAPJdAPZhAQ:lAQZlBR;0BR[4BRk4BSK8CSk<CTK<CTk@CUKDDU[DDV;HD
V[HDW;LEW[PEWkPEXKTEXkXFYKXFYk/FZK`FZ[`G[;dG[[hG/;hG/[l26;C0
3lSPf0030000b>3Hb>3H00g8h=P00`0001Rd`1Rd`00?b>3H00<0000H]<0H
]<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0@00803VjOa00Kooooc
X:kd]Kof_<GkfMXc@jD6002006800H000h401H401h812H<12X<138@13XD2
48D24XH24hL25HL35hP36HT36hT37HX47XX488/48X`498`59Xd59hh5:Hh5
:hl6;I06;i06<I46<Y87=987=Y<7>9@7>Y@7>iD8?ID8?iH8@IL8@iL9AIP9
AYT9B9T9BYX:C9/:CY/:Ci`:DId;Did;EIh;Eil;FIl<FZ0<G:0<GZ4<H:8=
HZ8=Hj<=IJ@=Ij@>JJD>JjH>KJH>KZL?L:P?LZP?M:T?MZX?MjX@NJ/@Nj/@
OJ`@OjdAPJdAPZhAQ:lAQZlBR;0BR[4BRk4BSK8CSk<CTK<CTk@CUKDDU[DD
V;HDV[HDW;LEW[PEWkPEXKTEXkXFYKXFYk/FZK`FZ[`G[;dG[[hG/;hG/[lf
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^1<00800HP01P003P@05
P@07PP49P`4:P`4<Q04>Q@8@Q@8BQP8CQ`8EQ`<GR0<IR@<KR@<MRP@NRP@P
R`@RS0@TS0DVS@DWSPDYSPD[S`H]T0H_T0HaT@HbTPLdTPLfT`LhU0LjU0Lk
U@PmU@PoUPQ1U`Q3U`U5V0U6V@U8V@U:VPY<V`Y>V`Y?W0YAW@]CW@]EWP]G
W`]IW`aJX0aLX0aNX@aPXPeRXPeSX`eUY0eWY0iYY@i[YPi]YPi^Y`m`Z0mb
Z0mdZ@mfZPmgZQ1iZa1kZa1m[11o[A61[A62[Q64[a66[a:8/1::/A:;/A:=
/Q>?/a>A/a>C]1>E]ABF]ABH]QBJ]QBL]aFN^1FO^1FQ^AFS^QJU^QJW^aJY
_1JZ_1N/_AN^_QN`_QNb_cHH]<02R<2h0DR@R04000000003R<2hb>3HR<2h
0:j8`;P1B9280@00000000>8`;S8h=R8`;P0[XS0^058T8P1000000000hS0
^<SPf<SPf02^b>3H0DR@R04000000;:8`;P100000000\
\>"], "Graphics",
  ImageSize->{179, 84},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004/0000b2000`400?l0
0000o`00003oooo`l?0Noo3`l003omWIfOoooooooooo00cooooo003ooo3`
l1kol?3`00CofMWIooooooooooooiNGU0oooool01OoUiNGooooooooooooo
ooooiNGU00?ooooo003ooo3`l1kol?3`00gofMWIoooooooJf][oSHf=onGU
iOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003ooo3`
l1kol?3`00kofMWIoooooooooooof][Johf=SOoUiNGoooooom[Jf_n=SHgo
iNGUoooooooJf][oSHf=onGUi@7ooooo003ooo3`l1kol?3`00gofMWIoooo
ooooooooooooom[Jf_n=SHgoiNGUoooooooJf][oSHf=onGUiOoooooof][J
00;ooooo003ooo3`l1kol?3`00?ofMWIooooooooool00_ooool01ooJf][o
SHf=onGUiOoooooof][Johf=SOoUiND00oooool00?ool?3`7_o`l?000ooI
fMWoooooooooo`03ooooo`07om[Jf_n=SHgoiNGUoooooooJf][oSHf=onGU
i@02ooooo`00ooo`l?0Noo3`l003omWIfOoooooooooo00Cooooo00Oof][J
ohf=SOoUiNGoooooomcLg?n=SHgoiNGU007ooooo003ooo3`l1kol?3`00?o
fMWIooooooooool01Oooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo
003ooo3`l1kol?3`00?ofMWIooooooooool01_ooool00ooLg=coSHf=onGU
i@03ooooo`00ooo`l?0Noo3`l003omWIfOoooooooooo00Oooooo00?og=cL
ohf=SOoUiND00_ooool00?ool?3`7_o`l?000ooIfMWoooooooooo`08oooo
o`03omcLg?n=SHgoiNGU007ooooo003ooo3`l1kol?3`00?ofMWIoooooooo
ool02Oooool1omcLg07ooooo0Oooool00?ool?3`7_o`l?000ooIfMWooooo
ooooo`0<ooooo`00ooo`l?0Noo3`l0oofMWI003oooooobgooooo003oonk^
kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgooooo003o
onk^kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgooooo
003oonk^kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgo
oooo003oonk^kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003ooooo
obgooooo003oonk^kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003o
ooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^
003oooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV003oonk^kRgo
k^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV003oonk^
kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV003o
onk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV
003oonk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgo
i^KV003oonk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKV
iRgoi^KV003oonk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^003o
onKViRgoi^KV003oonk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^
003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgooooo003oonk^kRgo
k^k^003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgooooo003oonk^
kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgooooo003o
onk^kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgooooo
003oonk^kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgo
oooo000Donk^kQOoOZgIooo^k^h2onk^kP0000?ooonXok6aF_n4Q2d01_n4
Q2d00omiNB;oQ8@]ohB4;@03ohB4;@03okblIOoVi^Koi^KV00;oi^KV00?o
OZgIonKVi_oVi^H04ooVi^H00omn[MWoi^KVonKViP3oonKViP0000?ooonX
ohB4;OnJVT<00onUYDh00onJVT?oYJE>ojFUCP05ojFUCP03ogUi8_oMgHKo
k^k^00?ok^k^00?oOZgIonk^k_o^k^h04oo^k^h00omn[MWok^k^onk^kP3o
onk^kP0000cooonXogUi8_odm9gom?BMom;BNonUYDkoalM`ooooZ?odm9go
jNVBojFUC_oYjI82ooCdW@03ojFUC_oMgHKooooo00?ooooo00OoOZgIoooo
ooooooooo_knomcLg?oKfm_oo_kn00oooooo00?oOZgIooooooooool0oooo
ool00006ooooZ?miNB;ooonXooCdWOnUYDkoEgV60_miN@002?n4Q2goNELR
oeMG5_nJEd?oYJE>ooooZ?nUYDkod]9k1?o^k^h02Omn[MWok^k^oiVIVOl@
413o7AdMob0P8?l=3@goR8R8ong]k@02onk^kP03oc8b<_nJVY[ok^k^00;o
k^k^00?o];Bdo`000?n@T9000oo^k^h00omn[MWok^k^onk^kP3oonk^kP00
013ooonXojFUC_odm9gom?BMoiZJ@omGVZSoEiZ6ohB4;OmiEb;oNGTRojFU
C_miEb;o/K5JooCdWOnJVT?ogMf61?oVi^H01?mn[MWoTi>Co`T92OnUYJD2
onKViP03ok>c/olB4Q;oNGUi00;oi^KV00So<30`oiBDU?oVi^Koi^KVomgM
gOlQ8B7o0000oh^;R`?oi^KV00?oOZgIonKVi_oVi^H0oooVi^H00005oooo
Z?miNB;om?BMonWYT_mRHP/00_mGVZP02OmiVXKoKFdFok6aF_nl_6GoKFdF
onWYT_odm9goYJE>omgMQP04onk^kP03ogj]fOlI6AWoCTi>00Cok^k^00Ko
R8R8o`/;2ooMgMgok^k^oc8b<_nJVYX2onk^kP04ofe]KOlA4A7o:2PXoi2@
T0?ok^k^00?oOZgIonk^k_o^k^h0ooo^k^h00006ooooZ?miNB;om?BMogUi
8_miEb;oEeL;0_m]KAH02?mGNB;oNELRof9G0?mGE`3oNGTRom;BNonUYDko
d]9k1?ooool00omn[MWo0000oiVIV@04ooooo`0<on;Rh_l0003o^k^koooo
oolf=SKoYJFUooooooo:b/[o0`<3oj>SXolo?cooVi^K0oooool00omn[MWo
ooooooooo`3oooooo`00013ooonXojFUC_nJND?oVWU3ojFUC_na/E[oVYY3
ogUi0?mGNHKoEiZ6ogUG@omGE`3oVWU3ogUi8_nUYDkogMf61?o^k^h00omn
[MWo0000ol[:bP04onk^kP0<on[Zj_l0003oSXj>onk^k_lb<S;oVYZJonWY
jOlY:BWoADE5onk^k_lj>S[oT92@0oo^k^h00omn[MWok^k^onk^kP3oonk^
kP0000WooonXohB4;OmiEb;ogEN6oiYi@onJVT?oHUL0okbJ0?oM_0000_mG
VXH2okaGI@03om;BNonUYDkogMf600Coi^KV00?oOZgIo`000?no_kl01?oV
i^H03?nl_;co0000oiZJV_oVi^Ko<30`oiBDU?mcLg?o30`<olc<c?oVi^Ko
>3Phoh^;R`?oi^KV00?oOZgIonKVi_oVi^H0oooVi^H00004ooooZ?miNB;o
gMf6ohB4;@;oEeL000[oNELRoiZJ0?oog@3o_9X0oiYG@ooMEjSoVUM3oiYi
@onUYDkod]9k1?o^k^h00omn[MWo0P82oiNGU`04onk^kP08oh20P?l0003o
alO7onk^k_lb<S;oL71`o`@41?n<S8`2onk^kP03ocXj>_n@T93ok^k^00;o
k^k^00?oOZgIonk^k_o^k^h0ooo^k^h00007ooooZ?nUYDkom?BMooCdWOm]
KAKo_5MUoiYi@`02oiYG@`07ogUG8_nlVP3oHV8;omgMQ_odm9goYJE>omgM
QP04ooooo`04ogj]fOmWIfOo;2`/oo;blP;ooooo00?onOWiocLg=om<C4`0
0_ooool00olf=SKo1@D5od10@003ooooo`03oclo?onKVi_ooooo00;ooooo
00?oOZgIooooooooool0ooooool00006ooooZ?n4Q2gom?BMokblIOmRHP_o
Q8@]0_oMEhH01?nlEfGoEgU3omfl0?nUYDh2ooCdW@03ojFUC_oMgHKok^k^
00?ok^k^00WoOZgIomgMgOlm?Cgo9RHVog]kNon0P83o<30`obh^;_oBd]80
0_o^k^h00olb<S;o20P8olg=c@03onk^kP03ocXj>_n@T93ok^k^00;ok^k^
00?oOZgIonk^k_o^k^h0ooo^k^h00009ooooZ?miNB;om?BMojFUC_miNB;o
VYY3ogUi8_oMEhKoQ8@]00;oEgU300GoYJE>ooCdWOodm9goYJE>om;BN`04
onKViP08ogj]fOoVi^Koi>CToibLW?m]KFgoJ6QXoiBDU?oPh>03onKViP03
oijNW_n[Zj_oi^KV00?oi^KV00?oXZ:Rol;2`_oVi^H00_oVi^H00omn[MWo
i^KVonKViP3oonKViP0000?ooonXojFUC_odm9d00oodm9d01_oBdW_oVWU3
ooooZ?odm9go_;aUok6aFP;om?BM00?oYJE>omgMQ_o^k^h00oo^k^h00omn
[MWok^k^onk^kP0Conk^kP03ogj]fOo^k^kok^k^0?ook^k^00000oooojSo
NGTRooooZ00;ooCdW@03ojFUC_oMgHKooooo00?ooooo00?oOZgIoooooooo
ool04oooool00omn[MWoooooooooo`3oooooo`0000?ooonXogUi8_nUYDh0
3?nUYDh00oooojSok^k^onk^kP02onk^kP03ogj]fOo^k^kok^k^01?ok^k^
00?oOZgIonk^k_o^k^h0ooo^k^h001Coi^KV5omn[MWoonKViP;oi^KV003o
onk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV
003oonk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgo
i^KV003oonk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKV
iRgoi^KV003oonk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^003o
onKViRgoi^KV003oonk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^
003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgooooo003oonk^kRgo
k^k^003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgooooo003oonk^
kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgooooo003o
onk^kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgooooo
003oonk^kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgo
oooo003oonk^kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003ooooo
obgooooo003oonk^kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003o
ooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^
003oooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV003oonk^kRgo
k^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV003oonk^
kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV003o
onk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV
003oonk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgo
i^KV003oonk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKV
iRgoi^KV003oogmoObgoOgmo00001?o[jn_oi^KVon;Rh_oNg]h4omgMg@?o
g]kN08;ogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkogMgM0_oLg=`0TOoKfm_ogMgM
omcLg?oMgMgogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMd00ooNg]h00ooMgMgo
g]kNomkNgP03omgMg@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>00
1ooIfMT01?oHf=Soe]KFom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSH
f0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooH
f=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOo
f=SH??oIfMT2omSHf003omWIfOoHf=Sof=SH00?ofMWI0_oHf=P5omWIf@03
omSHf?oFe]Kodm?C00;odm?C00?oe]KFomSHf?oHf=P03_oIfMT01?oHf=So
fMWIomWIfOoHf=P@omWIf@;of=SHJ?oIfMT00ooHf=SofMWIomWIf@06omWI
f@7og]kN0OoVi^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoPh>3o
h^;R00;ohN7Q00gog]kNomcLg?oCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk
^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?oalO7ok^k
^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoO
om_KfooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_o
gmoO02gohN7Q2_oPh>000ooOgmooh>3Pon3Ph006omoOg`;oh>3P0ooOgml5
on3Ph007omoOgooKfm_oemOGomCDe?oEeMGofMWIomgMg@02on3Ph003omoO
gooPh>3oh>3P00;ohN7Q1ooPh>06omoOg`03on3Ph?oOgmooh>3P00_oh>3P
00CogmoOomkNg_oNg]kogmoO0_oPh>1Won7Qh@03on;Rh_oQhN7oh^;R00Co
hN7Q0OoTi>@1onWYj@7okNg]00000oo`l?3okno_oo7al@03oo3`l01Zono_
koo`l?3ok^k^onWYjOoKfm_o`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<
ojBTY?o2`/7of][Jon[Zj_o]kNgolO7aono_kooalO7okno_oo7akoo_knoo
lO7aong]kOoZj^[of][Jol;2`_nTY:CoS8b;og]kNomgMgOoNg]kohb<S?nT
Y:Co`/;2om[Jf_oZj^SokNg]oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<S?mkNg_oMgMfog]kNon<S8coY:BT
ol;2`_oJf][oj^[Zong]kOoalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo3`l0;ok>c/00Oojn_[onk^k?o/k>cokNg]onc/k?o^
k^koj^[Z00;ojn_[00[ok^k/onWYjOoXj>Soi^KVonWYjOoVi^Koj^[Zon_[
joo]kN_oj>SX0_oYjNT01oo]kNgoj^[Zonc/k?o/k>cokno]on[Zj_oXj>P0
0_oShn<03OoOgmoohn?SonSXj?o]kN_oj^[Zon_[joo/k>col?3`ono_koo`
l?3okNg]onc/j_oZj^X00_o^k^h01_o_knooj^[ZonWYjOoVi^Koj>SVonOW
i`;ojNWY00Kok>c/onWYjOo/k>cokNg]onk^k?oZj^X2onc/k008onk^k_oZ
j^[ok>c/onc/k?o_kngojn_[onWYjOoVi^H2onSXj0;okNg]06gol?3^ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo`l?3okno_
oo3`l?o_knool?3`ono_koo`l?3okno_00Col?3`00000oobl_;ok^k^onOW
i`04onGUi@0@onCTi?oOgmoodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92
odE5AOmADE7oIVIVohZ:ROna/K7odM7AomkNgP;oi>CT00?oiNGUonCTi?oU
iN@00_oTi>@03ooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5
AOmADE7oIVIVohZ:R_na/K7odM7@omkNgP02onCTi012onGUiOoTi>CoiNGU
onCTi?oTi>?og]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGo
DE5AofIVI_n:RX[o/K6aom7AdOoNg]koi>CSonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oShn?og]kN0_oKfm/02_oNg]gog=cLom_K
fooLg=cogmoOom_KfooIfMWog=cLomgMg?oGemL3omGEe@04omCDe?oIfMWo
gMgMomgMg0;oemOG01;ofm_KomgMgOoJf][of][JomkNg_oQhN3ofm_KomSH
f?m6ATKo<30`ogQhN?o2`/;of][JomkNgOoJf][ofMWIomgMgOoShn<2onCT
i00FomoOgooLg=_ofMWIomoOgooRh^;ohN7Qom_KfooFe]Koe=CDomKFeOoD
e=Coe]KFom_KfooLg=cof=SHomcLg?oOgmoogmoNomWIfOoKfm_og]kNomoO
g`;of][J06oogMgMon3PgooKfm_oemOGomGEeOoGemOofMWIomoOgooRh^;o
i>CSonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>@01?oUiND01_oTi>CoiNGUonGUiOoUiNGoj>SXong]k@7ol_;b00000ood
m?CokNg]onOWi`02on3Ph00Con7QhOoOgmoog]kNom;Bd_nd];CoQhN7oeaL
G?m]>cGoWTi2ole_GooYPfoocFmOoii>@om]>cKoG5aLohN7Qond];Cod];B
omkNgP05on3Ph00AomkNg_oBd];o];BdohN7QomLG5coKF0/oijF;_o=cCoo
jNU=olg=?onNVRooKF<]oeaLG?n7QhOo];Bdom;Bd_oNg]h01OoPh>004OoN
g]kod];BokBd]?n7QhOoG5aLodMW;_mXWS?oTLe7oj[YEOnAcDOoJYhdodUZ
;omLG5coQhN7okBd]?oBd];og]kN02_oh>3P04?og]kNomSHf?oBd];oe=CD
omKFe_oBd];oclo?om;Bd_oFe]Kodm?Com7AdOoEeMGoe]KFom3@d?o4a<Co
bl_;olo?coo9bLWoa<C4omSHf?oEeMGod=3@olC4a?o@d=3of=SHom;Bd_oA
dM7of=SHom_KfooFe]KodM7AoiFEUOnPX:3o?Shnod];BooDe=Cof=SHom;B
d_oAdM7of=SHomkNg_oPh>3ogmoOom[Jf_oCdm?odM7AomSHf?oMgMgof][J
om?Cdoo?cloo`<30om3@d?o=cLgo_knoomCDe?oFe]KodM7AomCDe?oIfMWo
f=SHom7AdOoBd];of=SHomWIfOoCdm?odM7A00;oemOG00SodM7Aolo?coo8
b<Soa<C4omSHf?oKfm_og]kNomoOgfCoh>3P00?ogmoOon3Ph?oOgml00_oO
gml3on3Ph003on7QhOoWinOok>c/007om?Cd00000oofm_Kol_;bon_[j`03
onSXj00ConOWiooRh^;ocLg=oinOWom[GeooScH^oneaHOoiWI3ooK6Uoofl
[oom]:OonInConedHonB=booJemOoinOWoo=cLgoh^;RonOWi`03onSXj00C
onOWiooRh^;ocLg=oinOWom^IUooTg8RongAA?oilgCooOf=oogmUOomoHko
nOQfongGAonCLb;oKVMOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooR
h^;ocLg=oinOWomPJ5ooBg`Soi;QBonmnG_od?fBomSmVooDoIGo`?UnoiSX
COm=P2CoH6UOoinOWoo=cLgoh^;RonOWi`0ZonSXj00YonKVi_oOgmoo<30`
ohn?SooKfm_oalO7ohR8R?o5aLGofm_KojFUYOl10@7ogMgMomkNg_m]KFgo
20P8oa4A4OmcLg?o<30`ob@T9?oMgMgofm_Kod];Bol<30coHV9Ron7QhOm]
KFgo>SXjomoOgooShn?o`l?3o`000?o1`L7ohN7Qoj2PX?l=3@goemOGomkN
g_mmOGgo5aLGomgMgOoTi>@00_oVi^H05?oRh^;oOgmoobPX:?oOgmooiNGU
on?Shonf][Ko7alOo`T92Olf=SKoM7Ado`P82?nFUYKogMgMo`l?3onGUiOo
hN7QomoOgom2@T;oI6AT0_oPh>003?meMGGo<S8bomgMgOoKfm_o_[jnoc`l
??l20P;o7alOoaDE5Ond];Coi^KVonOWifgoj>SX0Oo/k>`1oo;blP7om_Kf
00000oogmoOon?ShooShn003ooShn00CooOgmoo^k^koc/k>oi2@T?n5;b_o
jFAFoo^BQoonYY_oo[6UoonhZoon/jKooZRLoo^DROo^J5WoRC4[oi2@T?o>
c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_P
K_onm8;oo_j:ooooT_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^
ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSo
c_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^ooOgm`0Z
ooShn00_ooKfm_o_knoo<c<coiVIVOoWinOoPh>3o`000?mlO7coj>SXok2`
/?l10@7okNg]on?Shol61PKoXZ:RomgMgOmgMgOo0000olk>c_o`l?3o`/;2
o`000?oAdM7om?Cdoo7alOmeMGGo?Shnonk^k_obl_;od=3@o`000?o?cloo
lO7aolS8b?l0003o`l?3onk^k_n6QXKo6ATIonWYjOo_knool_;booCdm?oa
lO7oR8R8ob/[:oo^k^h00_oemOD07?mTI6Co?cloonGUiOnc/k?o7alOofMW
Ioo_knookNg]oa0@4?nRXZ;ol?3`ono_kom7AdOoJf][ono_koo`l?3oOWin
ocDe=Oo[jn_oj>SXocLg=om4A4Coc/k>onOWiooMgMgoi>CTooGemOogmoMV
ooShn003ooOgmoohn?Son?Sh00;on?Sh00ComoOgooWinOogmoOomoOg0Ooh
n?P00003oo[jn_oemOGok^k^00;ok>c/0:Wojn_[onWYjOoOgmoo^[ZjogUB
D_no<RCoigAYoof9O_ooV8cooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<T
ogUBD_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[k?oZj^[ogmoOokZj^_n8IE;o
hY4LooW3D?omfV?oonYbookcO_oonX;oo_Ioooo/LoongVCon/MAon:B7?n9
IU?o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S
7?nAdUGoY^MZokSiN_o0oX;oaon9ol?nQ?nioG_oYna/oiCFEomBYQcoDVeB
okZj^_oOgmooj^[Zon_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
onWYjOoShn?o<30`oi2@T?oHf=Wo;Bd]od10@?lS8b?of][JojJVY_l10@7o
hN7Qon?Si?l@413oO7alomoOgond];Co0000om7AdOoTi>CoV9RIo`l?3ooP
h>3oinOWon?Shom_Kfoo>c/komoOgooQhN;o`l?3o`000?o5aLGoi>CTokno
_ol0003o^;Rhon7Qh_moOgoo5aLGomWIfOoMgMgohN7QonGUiOoTi>CoPH61
obPX:?oOgmooi^KVonSXj?mdM7Co7alOomWIfOoLg=go>c/kofm_KooTi>Co
h>3Po`l?3onHV9SohN7QomoOh?m3@d?oIFEU00;oh>3P06ooMgMgoc8b<_oP
h>3o^;Rio`000?nXZ:Sog=cLomWIfOoKfm_ohN7QonWYjOoZj^_ok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>`01oo[jn/01Oo/k>cojn_[
on_[joo^k^kom_Kf007onOWi00000ookno_olo?cong]k@02onGUi@2`onKV
i_oTi>CofMWIok:b/_mi;Rkob48don=ZG?odNVgooHQloojGR_onVhkooYR;
ooj:O_odNfgoif]MolY2=?mk;Rko/[:bomSHf?oTi>CoiNGUonKVi_oUiNKo
i>CTomSHf?nb/[;oUUD^onZL:ook_4Coo/aCoogHH_onhg;oo^UeookVLoon
ffGooLaCoo_1AOo^WR_oVEH^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGUonCT
i?oHf=Wo/[:bobiR;_mS[B_oQlY8oiOLFOnUiFWo/_=gokSfNondmGWoYnY[
oiSLFOn9cd_oHjh[obiS;_nb/[;of=SIonCTi?oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oShn?ogMgMobl_;on;Rh_o/K6bo`000?ng]kOo
9BDUojRXZ?nPX:3o0@41omcLg?oPh>7o/[:bocTi>OlU9BGo>c/ko`000?o=
cLgogMgMoi>CU?l@413oe]KFomkNg_oLg=coK6a/ocTi>OoDe=Coe]KGokbl
_?l0003o`/;2omoOgonk^k_o0000okBd]?oLg=coO7aloaLG5ooFe]Kof][J
omkNg_oPh>3ogmoOogemO_lW9bOoeMGEomcLg?oNg]kofm_KofATI?lP823o
?3`loa<C4om]KFgoh>3PomcLg?l?3`ooTi>ComOGeooEeMKo@D51of9RH_oG
emOoe]KFog=cLola<C7ogMgMoiZJVol00004ocLg=`1Wok:b/_oTi>Coi>CU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUi@02onKV
iP03onGUiOoVi^Koi^KV00?oi^KV00?oiNGUong]kOodm?@00Ookno/00003
ooclo?ohn?SolO7a00?ok^k^01?ojn_[on7QhOnl_;coNQLGol<o<_oCETWo
i6QJonmgK?odPgWon8MlooF4N_ocNFgoiFUKomUHB_o4?c;oO1LGokbl_?oQ
hN7ok>c/00?ok^k^01?ok>c/on7QhOnl_;coYDLGonJG<_oe[33ooKa1oog9
Doomd63onm=UoogBH?oncECooKe2ooZ_<_oYVc;oYDHGokbl_?oQhN7ok>c/
00?ok^k^01?ok>c/on7QhOnl_;co5eTGoenX<_mf_COoQ/e7oiKFF_nRh6Go
Xn1Yoj?QIonGfUcoQ/i7ogNo=omOZc;o5eTGokbl_?oQhN7ok>c/02[ok^k^
02Ook>c/onGUiOla<C7oShn?ofi^K_l/;2coj>SXogemOOmNGUkoY:BTo`41
0OoShn?ojNWYonKVi_oRh^;oh>3Pojf][Ol0003oemOGonCTi?nHV9So410@
omgMgOoShn?oi>CTog1`L?lT92Coe]KFomoOgono_koo0000ol_;booYjNWo
`L71o`000?nj^[[oi>CToh61POl61PH00oln?Sh08_o;bl_ojNWYohB4Q?lJ
6Q[of][Jon;Rh_oUiNGoinOWon?ShooPh>3of=SHocLg=ombLW;oj^[ZonOW
iol?3`ooRHV9omoOgooNg]ko@d=3oeIFE_oPh>3ogmoOogMgMolc<c?ojNWY
okjn__l0003oX:2PokJf]_nZZZ[o0P82omWIfOo]kNe]onk^kP03ong]kOob
l_;on?Sh007oo?cl0003oogmo@0Fooclo?omoOgooOgmooclo?oclo?odM7A
ofP71onh=3Coaclcom9@@ooJHUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo
^C@dof/71ooBd];olo?cooclo0?ooOgm01?oo?cloo?clooBd];oWR/7omZ:
=?o[VaWomJPYooRd?ooi_D[on;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7
om;Bd_oclo?oo?cl00?ooOgm01?oo?cloo?clooBd];o1d07odfJ=?mOZb3o
L;P_ogo3@on:cE3oSLeBoh[>D?n1adCoLKT_of:^8?m>VcCo1d87om;Bd_oc
lo?oo?cl02[ooOgm04cono_kooCdm?ld=3CoUiNGoalO7on7QhOon_[jomgM
gOlC4a?oZJVYo`410Oobl_;onOWiol30`?o4a<Colo?cohb<S?lQ8B7on_[j
ooGemOnMWIgo410@onKVi_o^k^kom?CdogQhN?lA4A7oC4a<ol[:b_n9RHWo
51@DooKfm_oinOWoc/k>o`000?o6a/Kolo?cohV9ROlC4a?o][JfokVi^Onj
^[[okNg]ooWinOn?Shoo30`<oeMGEooAdM7okNg]onc/k?nVYZKoi^KVonCT
i?lB4Q;o[Jf]oo_knoojn_[o410@oahN7_nUYJGog=cLoaXJ6_lP823oOGem
omkNg_m7AdOoGemOoo_knoojn_[o=3@dog5aLOo^k^koSXj>ocDe=Ookno_o
o?clJoomoOd00oolo?cooOgmooclo003oogmo@0003[ooOgmoo[jn_oclo?o
k^k^oo3`l?o_knook^k^onWYjOoCdm?oFadMoj8d=?nd:1go`CX]olM9??o?
ET[od5M;om1GB_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`
l?o_knool?3_onk^k_oZj^[odm?Coh`U7Oo8LCCofH@MonBD5OoWWBCokZPc
oo2Z=?o_ZS?ok:0UonNG5OoLR1gob74doh`U7OoCdm?oj^[Zonk^k_o`l?3o
kno_oo3`l?o^k^koj^[Yom?CdolM>1go=88dodNE7OmJYA_oJJdZ0_md^3P0
OOme^CSoJk4[oe^W7?m8VQgo=88doadh7OoCdm?oj^[Yonk^k_o`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo^k^koinOWoc4a<OmOGeoo0@41
om;Bd_o^k^kok>c/od51@OmQHF7o0@41onKVi_o^k^goX:2PocTi>OlA4A7o
9RHVoiRHV?o_knooaLG5oa0@4?l10@7o6ATIoe9BD_oYjNWoLG5aocdm?OnG
UiOo7alOoaPH6?nATI7ok^k^ong]kOo3`l?o0000okbl_?oXj>OoPX:2oaPH
6?oOgmooh^;Ron?ShooWinOojn_[oi>CT_lo?cooTY:BoaLG5onDU9Coh>3P
odm?ColO7aoo4A4Aodm?CooXj>Sok^k^ono_kolW9bOoX:2Podi>C_l92@Wo
=SHfon3Ph?m^KVko3`l?ob`/;?nn_[kok^k^ono_k_oBd];o?3`lo`/;2olM
7Ago/[:b00;okno_06Kol?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knl2oo3`l0Kokno_0Ooclo<1ooWin@7oo_kn0000
0oono_komoOgoo3`l004onWYj@0AonOWiooKfm_oHd];oh4b<_nV=CGo]S@]
ol9=@Oo3E4Woa5E:ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooWinL0
1OoYjNT04OoWinOofm_KohU;Bon_Bc;ocGLeomJ;;OoPW2koh:0bon6P=?oP
X3;ogiX^omJ;;Oo:MCGo[d/bohU;BooKfm_oinOW00GojNWY017oinOWom_K
fom;Bd_o<V0bocZ9=OmCVbgoJj/_og2]>?m_[S[oL:dhofZZ;omCVbgo>HPe
oc9P<_m;Bd_ofm_KonOWi`0[onWYj@0=onSXj?oTi>Co<30`oa8B4_ll?3co
i^KVonSXj?oWinOoTi>Coa4A4Ol10@7ohn?SonOWi`02onWYj@03onOWiooY
jNWojNWY00;oj>SX01CoWIfMoa0@4?oWinOoinOWonCTi?m_Kfoo>c/kon?S
hooWinOoj>SXonWYjOoXj>SoinOWol;2`_l0003o^[ZjonCTi?n0P83o5aLG
omgMg@;og]kN00?ohN7QonKVi_oXj>P00_oYjNT00ooXj>SoinOWonWYj@02
onWYj@03onOWiooYjNWojNWY00?ojNWY00?oj>SXonWYjOoXj>P00ooYjNT0
0ooWinOojNWYonWYj@04onWYj@03onKVi_oYjNWojNWY06WojNWY00?oj>SX
onWYjOoYjNT01?oYjNT1oo3`l07omoOg0Oono_h00005ookno_ojn_[om?Cd
ono_kooalO400_o`l?004Oo_knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGo
fYbLomZNW?oIW9coe9FEok]cLonEE5CoCb<SoiFDU?oZj^[okno_00Gol?3`
017okno_on[Zj_nYU9CoPB<SokYZE?oDVW?oi;bEon[7W?oYaicoj/NLonFl
UOoDVW?o^fYDoh4S8onZU9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oU9BD
ob<Z8omDNUCoLjEcoik6UOn/cYco[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?o
U9BDon[Zj_o_knl0:oo`l?001Oo_knook^k^oc8b<_l0003oTi>C00?okno_
00Goi>CTo`/;2ol10@7ok^k^ono_k`07oo3`l009on?Shono_kookno_ono_
koo^k^koM7Adocdm?Oo]kNgokno_00?ol?3`00Ookno_ol[:b_l0003o`l?3
onk^k_n6QXKo2@T900?oGUiN00?oNGUionk^k_o_knl03?o`l?000oo_knoo
l?3`oo3`l01loo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn00001?omoOgo
ooooooooooono_h2ooooo`;oo_kn06kooOgmooShn?m^KVkoFSlook6@T?oN
bLWol>CToo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?coooooookn
o_ooooooo_knooooo_ono_koooooooclo?ohn?SoSFe]ohXo?oo9TI3ojM39
ooCYi?ofjnKom>WTonW@bOo9TI3oRCloohe]KOohn?Ooo?clooooooono_ko
ooooookno_ooooooo_knooooo_olo?con?Shofe]KOlo?cooT9f@olWEbOoT
k>Coi^kVonC/i?o9eLWoT9f@oclo?om]KFgon?Shooclo?ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooomoOgo[jn_oiRH
V?oalO3ooOgmooooo`;oo_kn01Ko];BdoiZJV_omoOgoooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooomoOgoo_knogalO?m1
@D7ooOgmooknoOono_kooooo0_ono_h0Too^k^koVIVIon_[joono_godM7A
oiVIVOnHV9SoVIVIoiRHV?n/[:cooOgmooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooooknoP02ooooo`03ookno_oooooo
oooo00?ooooo0Oojn_X00004ooShn?ono_kon_[jooCdm0GolO7a00gokno_
omKFe_m[Jf_o@cdmoi^<S?o6^[[oe/c<olNj^_nKS8co@cdmof][JooFe]Ko
kno_00WolO7a00gokno_omOFe_n3Jf_oM3dmokF<S?oE^[[ohLc<omJj^_nf
S8coLSdmoh5[JooGe]Kokno_00WolO7a00gokno_omKFe_m[Jf_o?Cdmohb<
S?nj^[[oc<g<okZj^_n<S8co?Cdmof][JooFe]Kokno_04KolO7a00?ok^k^
ong]kOoalO40UOoalO401?o`l?3olO7aoo7alOo`l?04oo7al@03ooCdm?oj
n_[oo_kn007ol?3`00001Oo[jn_ooOgmooShn?o`l?3ojn_[00?oj^[Z00go
jNWYon[Zj_oYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooX
j>SojNWY00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo@RHVofUI
FOnPVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9
obHV9_mIFEWoVi^KonSXj?oYjNT0i_oZj^X01?o[jn_ol?3`ooShn?omoOd1
om[JfP0000Coa/K6ookno_ojn_[om?Cd2?oalO42oo3`l0?okno_0_o`l?0?
oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`i?oalO40
0oo`l?3olO7aoo7al@02oo7al@03ooGemOojn_[okNg]007oY:BT00000oo6
a/Ko`l?3oo[jnP3oooooobOooooo0Oo^k^h1ok2`/07oZZZZ00001_oKfm_o
_knookFe]OoWinOomoOgooclo?oooooo8Oooool01Ookno_okno_omWIfOnT
Y:CoZJVY007o`L710000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{300, 200},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleJCheckBox",
        ButtonData:>{"SimpleJCheckBox.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[BoxData[
    \(SimpleJCheckBox[]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JRadioButton <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;SoojRa/EX7Q8@]00=i
NB:4Q2f4Q2d00hB4;@03_;aUc<c<c<c<0?o<c<coc<c<J<c<c0:8`;P1B928
0@00000000N8`;S8h=R8`;R8`;SoojR4Q2fJVT<00jFUCP03VYY3YJE>YJE>
00FUYDh00gUi8]gMQ/c<c03oc<c<olc<c6W<c<`2R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hoonXNGTR0_CdW@08d]9kYJE>alM`oonXm?BMjNVBYJE>
jNVB0_CdW@03YJE>gMf6c<c<0?o<c<coc<c<JLc<c0:8`;P1B9280@000000
00Z8`;S8h=R8`;R8`;SoojQiNB;oojSdm9fUYDiGNHH2NGT000R4Q2eiEb9G
EaJJEd>UYDkoojRUYDkBdW/4c<c<0P0000?<c<`200000/c<c0@00003c<c<
0P000003c<c<0000000000;<c<`2000000?<c<`0000000000lc<c0800000
0lc<c00000000002c<c<0P0000;<c<`40000olc<c?o<c<`hc<c<0XS0^058
T8P1000000001XS0^<SPf8S0^8S0^?ooZ:FUCP;dm9d039ZJ@eNJZ5NJQXB4
;GUG8WUi8ZFUCWUG8[6aF_CdWIZJ@mgMQPC<c<`200000/c<c0<000000lc<
c00000000002c<c<0P000004c<c<00000000c<c<0`000003c<c<00000000
00;<c<`200000lc<c08000000lc<c00000000002c<c<0P000003c<c<0000
000000;<c<`20000olc<c?o<c<`gc<c<0XS0^058T8P1000000002HS0^<SP
f8S0^8S0^?ooZ7Ui8_CdWNWYTV9R2`02EiZX00UiVXI]KAJa/EZl_6E]KAKY
jI;dm9fUYDkMgHH01<c<c0800002c<c<0`000003c<c<0000000000G<c<`2
00000/c<c08000000lc<c00000000002c<c<0P0000?<c<`2000000?<c<`0
000000000/c<c08000000lc<c00000000002c<c<0P000?o<c<coc<c<=lc<
c0:8`;P1B9280@00000000Z8`;S8h=R8`;R8`;SoojQiNB;dm9eiNB9iEb9G
E`/2KFdF00QGNB9iEb9RE`1GE`1iNB;BdW^UYDkBdW/4c<c<0P000003c<c<
00000000008000000lc<c00000000004000000?<c<`0000000000/c<c080
00000lc<c00000000002c<c<0P0000?<c<`2000000?<c<`0000000000/c<
c08000000lc<c00000000002c<c<0P000?o<c<coc<c<=lc<c0:8`;P1B928
0@00000000J8`;S8h=R8`;R8`;SoojRUYDh2VWU300bUYDja/EZJVT=iN@1G
NHIGVXIiEd=GE`2JND=iNB:UYDkMgHH4c<c<0P000003c<c<0000c<c<0080
00000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`2000000?<
c<`0000000000/c<c0800003c<c<0P000003c<c<0000000000;<c<`20000
00?<c<`0000000000/c<c080003oc<c<olc<c3O<c<`2R<2h0DR@R0400000
000=R<2hb>3HR<2hR<2hoonXQ8@]NELRgEN6VWU3VYY3HUL0_9X0gK`0009G
VXH2_5MU00?BdW^UYDkMgHH01<c<c0@000001<c<c00000000<c<c0800002
c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c080
0003c<c<0P000005c<c<000000000000c<c<00800002c<c<00<0003<c<c<
c<`00P000?o<c<coc<c<=lc<c0:8`;P1B9280@00000000R8`;S8h=R8`;R8
`;SoojQiNB;MgHJ4Q2d2EeL000YiEb:JVP3og@2lVP2JEd?MEjRJEd>JND>U
YDkBdW/4c<c<0`0000;<c<`200000/c<c0@00002c<c<0P0000;<c<`60000
00?<c<`0000000000P000004c<c<00000000c<c<0P000003c<c<00000000
00?<c<`40000olc<c?o<c<`hc<c<0XS0^058T8P1000000001XS0^<SPf8S0
^8S0^?ooZ:FUCP;dm9d00fe]5[aGIIYi@`02VUM300MiEb:lVP1RHP_MgHKd
m9fUYDkMgHH01<c<c0<00002c<c<0P0000o<c<`20000olc<c?o<c<a>c<c<
0XS0^058T8P1000000002XS0^<SPf8S0^8S0^?ooZ8B4;OCdWKblIF9R2hB4
;@;MEhH01;aGIEMi@mfl0:FUCP;dm9d00jFUC]gMQ/c<c003c<c<0P0000?<
c<`200004<c<c0030000c<c<c<c<00G<c<`20000olc<c?o<c<a5c<c<0XS0
^058T8P1000000003HS0^<SPf8S0^8S0^?ooZ7Ui8_CdWJFUCWUi8YZJ@gUi
8]eGQXB4;@02EgU300FUYDkdm9gdm9fUYDkBdW/0olc<c?o<c<aZc<c<0XS0
^058T8P1000000001XS0^<SPf8S0^8S0^?ooZ:FUCPCdm9d01];BNiYi@ooo
Z?CdWKblIK6aFP;dm9d00jFUC]gMQ/c<c03oc<c<olc<c6W<c<`2R<2h0DR@
R04000000007R<2hb>3HR<2hR<2hoonXNGTRoonX00_dm9d00jFUC]gMQ/c<
c03oc<c<olc<c6W<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hoonX
NGTR3JFUCP03oonXc<c<c<c<0?o<c<coc<c<J<c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0
`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P4
c<c<1?ooooo<c<coc<c<L/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<0_ooo`AVIVH2ooooolc<c?o<c<a`c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`2IVIV1<c<c09VIVH00oooolc<c<c<c004c<c<
1P000003c<c<0000000000;<c<`400000lc<c0@00003c<c<0P000003c<c<
0000000000C<c<`400000/c<c0800002c<c<0P000?o<c<coc<c<>lc<c0:8
`;P1B9280@00000000N8`;S8h=R8`;R8`;S<c<aVIVKoool01lc<c003IVIV
ooooc<c<00C<c<`200001Lc<c08000000lc<c00000000002c<c<0P000003
c<c<0000000000;<c<`2000000?<c<`0000000000/c<c0800003c<c<0P00
00;<c<`2000000?<c<`0000000000/c<c080003oc<c<olc<c3_<c<`2R<2h
0DR@R04000000008R<2hb>3HR<2hR<2hc<c<IVIVooooc<c<100000;<c<`0
0fIVI_ooolc<c004c<c<0P0000G<c<`2000000?<c<`0000000001Lc<c080
0005c<c<0P0000;<c<`200000lc<c0800002c<c<0P000003c<c<00000000
00;<c<`20000olc<c?o<c<`kc<c<0XS0^058T8P1000000001hS0^<SPf8S0
^8S0^6IVI_ooolc<c00600000/c<c003IVIVooooc<c<00?<c<`200001Lc<
c08000000lc<c00000000004000000?<c<`0000000001Lc<c0800002c<c<
0P0000?<c<`200000/c<c08000000lc<c00000000002c<c<0P000?o<c<co
c<c<>lc<c0:8`;P1B9280@00000000N8`;S8h=R8`;R8`;QVIVKoooo<c<`0
1P0000;<c<`00fIVI_ooolc<c003c<c<1P000004c<c<00000000c<c<0P00
00;<c<`2000000?<c<`0000000001Lc<c0800002c<c<0P0000?<c<`20000
0/c<c08000000lc<c00000000002c<c<0P000?o<c<coc<c<>lc<c0:8`;P1
B9280@00000000N8`;S8h=R8`;R8`;QVIVKoooo<c<`01P0000;<c<`00fIV
I_ooolc<c003c<c<0P0000G<c<`2000000?<c<`0000000000/c<c0800000
0lc<c00000000002c<c<0P000003c<c<0000000000;<c<`200001<c<c003
0000c<c<c<c<008000001Lc<c000000000000<c<c0020000olc<c?o<c<`k
c<c<0XS0^058T8P1000000001hS0^<SPf8S0^8S0^6IVI_ooolc<c0060000
0/c<c003IVIVooooc<c<00?<c<`200001Lc<c0800002c<c<100000?<c<`4
000000?<c<`0000000000P000003c<c<0000000000800002c<c<100000;<
c<`2000000?<c<`000000000olc<c?o<c<`lc<c<0XS0^058T8P100000000
28S0^<SPf8S0^8S0^<c<c6IVI_ooolc<c0@00002c<c<00=VIVKoooo<c<`0
1<c<c0800005c<c<0P0000o<c<`20000olc<c?o<c<a?c<c<0XS0^058T8P1
000000001XS0^<SPf8S0^8S0^<c<c6IVIP;oool4c<c<0_ooo`03IVIVoooo
c<c<00C<c<`6000000?<c<`0000000004<c<c0030000c<c<c<c<0?o<c<co
c<c<CLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<0VIVIPCo
ool2IVIV00?oooo<c<c<c<`0olc<c?o<c<a]c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0C<c<`4IVIVolc<c?o<c<abc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<
olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<aj
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<
olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j
`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000
000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<
olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<aj
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^13<c<`ZVIW<olc<c?o<c<a0c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^13<c<`00iVIc<c<c<c<c00Vc<c<00>IVLc<c<c<c<`0olc<c?o<c<`n
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0C<c<`4oooo2<c<c003
VIW<c<c<c<c<02K<c<`00iVIc<c<c<c<c03oc<c<olc<c3k<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c0;oool4IVIV0_ooo`K<c<`00iVI
c<c<c<c<c00Vc<c<00>IVLc<c<c<c<`0olc<c?o<c<`nc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`2IVIV1<c<c09VIVH00oooolc<c<c<
c003c<c<00>IVL`0000000001/c<c0800002c<c<0P0000;<c<`400000lc<
c0800002c<c<100000;<c<`200000/c<c08000000lc<c9VIc<c<c03oc<c<
olc<c3o<c<`2R<2h0DR@R04000000007R<2hb>3HR<2hR<2hc<c<IVIVoooo
00O<c<`00fIVI_ooolc<c003c<c<00>IVL`0000000001/c<c0800002c<c<
0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c0800002
c<c<0P000003c<c<0000000000;<c<`2000000?<c<bIVLc<c<`0olc<c?o<
c<`oc<c<0XS0^058T8P1000000001hS0^<SPf8S0^8S0^<c<c6IVI_ooo`07
c<c<00=VIVKoooo<c<`00lc<c003VIW<0000000000K<c<`200000/c<c080
00000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`200000/c<
c08000000lc<c00000000002c<c<0P000003c<c<VIW<c<c<0?o<c<coc<c<
?lc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKoool9c<c<00=V
IVKoooo<c<`00/c<c003VIW<0000000000@00002c<c<0P0000;<c<`20000
00?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P0000;<c<`2
000000?<c<`0000000000/c<c08000000lc<c9VIc<c<c03oc<c<olc<c3o<
c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo2Lc<c003IVIV
ooooc<c<00;<c<`00iVIc00000000003c<c<0P000003c<c<0000000000;<
c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P00
00;<c<`2000000?<c<`0000000000/c<c08000000lc<c9VIc<c<c03oc<c<
olc<c3o<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo2Lc<
c003IVIVooooc<c<00;<c<`00iVIc00000000003c<c<0P000005c<c<0000
00000000c<c<00800002c<c<00<0003<c<c<c<`00P000003c<c<00000000
00?<c<`00`000<c<c<c<c002000000G<c<`000000000003<c<`00P000003
c<c<VIW<c<c<0?o<c<coc<c<?lc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVKoool9c<c<00=VIVKoooo<c<`00/c<c003VIW<0000000000?<
c<`2000000C<c<`00000003<c<`200000lc<c0@000000lc<c00000000002
00000/c<c0@00002c<c<0P000003c<c<0000000000;<c<`00iVIc<c<c<c<
c03oc<c<olc<c3k<c<`2R<2h0DR@R04000000007R<2hb>3HR<2hR<2hc<c<
IVIVoooo00O<c<`00fIVI_ooolc<c003c<c<00>IVL`0000000000lc<c080
00000lc<c0000000000<c<c<0P00013<c<`00iVIc<c<c<c<c03oc<c<olc<
c3k<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hc<c<IVIV0_ooo`C<
c<`2oooo00=VIVKoooo<c<`00lc<c003VIW<0000000000@00002c<c<0P00
00g<c<`00`000<c<c<c<c00>c<c<00>IVLc<c<c<c<`0olc<c?o<c<`nc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`2IVIV1?ooo`9VIVH0
0oooolc<c<c<c003c<c<00>IVLc<c<c<c<`09/c<c003VIW<c<c<c<c<0?o<
c<coc<c<?/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P4c<c<16IV
IPS<c<`00iVIc<c<c<c<c00Vc<c<00>IVLc<c<c<c<`0olc<c?o<c<`nc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^13<c<`00iVIc<c<c<c<c00V
c<c<00>IVLc<c<c<c<`0olc<c?o<c<`nc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^13<c<`00iVIc<c<c<c<c00Vc<c<00>IVLc<c<c<c<`0olc<
c?o<c<`nc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^13<c<`ZVIW<
olc<c?o<c<a0c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<co
c<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
olc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<co
c<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<
c<`2R<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058T8P1
0000000018S0^<SPf8S0^8S0^1H0080300600P02P00400:100>100>100>1
0`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49
P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:6
0P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P0
0`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<4
8X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h3
1BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`
T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLe
T`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF
0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P3
2DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:
CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP03
2eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<
GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R
008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU
10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X
3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@
NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhA
PJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/004
4XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?
/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je
0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN
^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<F
Y[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm
5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0@008000i^WlC=3YC=3Y@09<d>U1P00
P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J200J200J2
0P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@3
0@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF7
0P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<L
RP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@85
9Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/
S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHc
TPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU003
1cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G
0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8
V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:
DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]H
W`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<
H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=
IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^
Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010md
Z@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]
47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_
00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@04
4Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c
4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LD
VkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i
00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[
_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa
_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0`00P007VjOaooooSWZfYY_4/jWBZ9g8/jWB00:VVl@01KbhgNk^m>[YlOoo
oc=3Y@0500200`01P0800X001002P@03P@03P@03P@<0184200F100@01H80
1X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@1
2h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8D
Q`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<J
R@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=
12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?
00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@04
1S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC
1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8
@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI
00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YA
W0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]G
W`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<
Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<0
0`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP04
3VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mc
Z@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/
00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<A
Q:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<B
Rk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<3
4i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8D
V[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<E
X;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl
11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`
_P035k6n5k6o5k6o00<G/[l35k>o0QRd`20000026;C04000008H]<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0P00P004VjOaooooK5ZU[jG:0[bh
g@0:oogo/jWBoooooooo_;SMUhZlZ9g8i^K/oooo<d>U1000P0<00H0200:0
00@00X400h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N2
0@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<2
3hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ8
0aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:
0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<5
9hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@
0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=980
0`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7
>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL0
10U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ
0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]C
W@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP
0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82
366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=
Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL2
3W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ
0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o
[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_
0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb
4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<C
Tk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL3
59bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i
0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/
_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o
0aNc_`8H]<000lSPf4R@R4R@R00<B92800<00038h=Q8T8P03DR@R0040000
6;C06;C0b>3H3TR@R00300006;C06;C000:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2002000^KYo7ooonXWLSoooncZM9PC9Z>N[IhIJjXWLSooooo
oOl00oooo`03<d>U0020002000<0080300600P02P00400:100>100>100>1
0`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49
P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50P8@Q@?oool20Q66
0`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP3
0aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<4
8H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP03
1BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46
<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB
0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE
10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH
2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:
CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;
E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX004
35bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeR
XPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU
0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0ma
Z0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@
NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]
4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08B
RK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<C
S[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe
0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@E
WKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<F
YKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd0
0aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003
b>3HR<2hR<2h00^8`;P00dR@R0000<SPf00=R<2h00E8T8P0000H]<0H]<38
h=P03HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0
^8S0^08008003Y^WlOooooooom_Lk61<VY>5^[>Yd[bhgF1<VYV?_ZJKa<S3
gooooc=3Y@H00803oooo0P02P00300:1oooooooo00;oool200B100<01H7o
ool01H800`06PPCoool00`48PP48Poooo`03oooo0`4:P`06oooo0@^40@^4
0@b4oooo0@b40P4=Q004oooo0@j5oooo0@j50P8?Q@04oooo0Q25oooo0Q25
0P8AQP03oooo0Q660Q:600824XH20Q>600@24hL258L258L258L30QF70P8F
Q`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<3
7HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd3
1BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6
;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHc
TP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9
BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd2
2e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;
FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<
H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]
47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<A
QJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d
4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLD
VkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[
_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_`8H]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P00038
h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B9280000
6;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008003Y^WlOoo
okbhgIV?__ooomKAgM_Lk??nojJKa>k^m8Ef/9>5^_oooc=3Y@@008001ooo
o`01P001P001P?ooo`02P?ooo`0300>100Koool0184018401H7oool01H82
00J200Soool01h801h811h;oool128;oool128<30@V300Coool12X<12X?o
ool20@^400<138Coool138@00P4=Q004oooo0@j5oooo0@j50P8?Q@03oooo
0Q25oooo00?oool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ7
00@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<M
RP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<5
9Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]
T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B
0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@3
1cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G
0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9
VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;
DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]I
W`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaP
XPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY003
3FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW
0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`me
Z@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@
Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65
[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8B
SK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@C
T[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK
]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ
^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m
5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o
00<G/[l35k>o0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P00dR@R0000<SP
f002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<00
1<SPf8S0^8S0^8S0^0800004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000nKYo7ooonISkjGR[cD
dnS_[;?oMW_^Wj]KF:FVVlBFWm9PC9Zl^=gooolc@jD00`00P007oooo0060
00600060oooo00:0oooo00<00h401_ooo`04P@04POooo`05POooo`801X80
2?ooo`07PP07PP47P_ooo`48P_ooo`48P`<12H<02Oooo`4:Poooo`4;Pooo
o`4;Q?ooo`4<Q?ooo`020@f400Coool13XGoool13XD20Pn500Coool248Go
ool248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP3
5hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX3
11n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DW
S@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y02
1Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP03
1cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`Lk
U@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`04
2D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX3
2T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M
00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ03
35^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<
HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eW
Y0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>
L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX3
3gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]
0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl3
4XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8B
SK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C
]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<D
W;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T3
5J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm
0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l3
5k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028
`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^002
R<2h0P0000:8`;P200000hS0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^08008002Y^WlOoooiN:_7Y/Z[?7j:U^X<S3gi>5
^U]6TiV?_P9hIJh0148WQJnUb_oooc=3Y@@00803006000?oool00X000X40
1?ooo`8018400oooo`05POooo`0300J21?ooo`030@R20@R30@R300<12H<0
2Oooo`4:Poooo`4;Poooo`4;Q?ooo`4<Q?ooo`020@f400Coool13XGoool1
3XD20Pn500?oool248Goool00oooo`824HH30Q:60P8CQP040Q>70QB70QB7
0QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ9
0`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d4
98d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl0
0`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6
<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7
>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1
U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT0
10U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L
2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO
2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaO
X@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`03
3FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>
KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y
3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0
111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64
[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;
/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<C
TK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ
]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP
^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`4
5ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n
00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B928
0000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P00000
0QRd`003b>3HR<2hR<2h00>8`;P4000018S0^004B92800006;C06;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^08008000i^WlOooooooo`02oooo
00[o[K3oMW_icMCmkNkooonVVlB5M[2l^=gooolc@jD500200`01P003oooo
00:000:100<00h400oooo`04POooo`0200F100@01H;oool01X801X8200N2
00<11h;oool128800P48P`?oool20@Z300Ooool12h?oool12hCoool138Co
ool00P4=Q004oooo0@j5oooooooo0P8?Q@06oooo0Q25oooo0Q250Q66oooo
0P8AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN8
0aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<4
88/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh5
9hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T004
1RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLe
TPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE
0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4
V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:
C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM
2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<
G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=
HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU
0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?
L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@
N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d0
0a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<B
R;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>
/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd
0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM
]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<E
Y;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d3
5jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H
]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h
00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P018S0^080
0005R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0`00P00:XJcbnLgDhRHlm;FohRHlm6emo>?YoooooNg^ojf`0_ooo`03
<d>U0020002000@00803006000?oool00X000X400oooo`8018401Oooo`05
P@05P@05P_ooo`0200J20oooo`8128800`48Poooo`49P`020@V30P4:P`04
oooo0@^30@^4oooo0P4<Q007oooo0@f40@f4oooo0@j5oooo0@j500;oool0
0`8?Q@8@Q@8@Q@04oooo00@24HH24XH24XH24XH20Q>600@24hL258L258L2
58L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT3
0a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@T
S@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`03
1B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010Hb
TPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`Lh
U0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G
246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@04
2DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:
DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;
Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ
00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=
IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]
Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?
LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[004
47j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^
4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a
0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A
/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf
00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h
5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@F
Z[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h0
0aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P0
0038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R0000002
6;C000?8h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00=VjOaoNg^hRHlo_GhmhVG
m69^lj2^m69^oogoojf`o>?Yoooo<d>U00L00803006000?oool00X000X40
0`03P@<0184200F100@01H801X801X801X8200N200D11h81288128;oool1
28<00`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@2
4HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<G
R0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;
0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>
00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_
T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87
=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8
?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9
A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK
0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]D
WP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP
00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R
3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>
JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X
3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ
0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<A
PJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`
0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[80
0a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<C
UKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL0
11FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj
0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]
_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C0
00?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005
R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8`;P20000
0XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0P00P003VjOam/S<hRHl00;o[K001mlT;_nTW_JlaOn]/>ik
S?oooc=3Y@0800200`01P003oooo00:000:100<00h4300B10P05P@0400F2
00J200J200J20P07PP050@N20@R20@R2oooo0@R300<12H<01?ooo`4:P`4:
P`4;P`812h@30@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>7
0QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<I
R@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@4
98`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5
:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I42
1S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC
00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H0
10Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9
AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@
W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP03
2eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ43
35jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S
0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H2
3VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ003
3g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l
[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<A
Pjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa
4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc
0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H3
59Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<E
WkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX
^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G
[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0
^003B9280000b>3H00:8`;P900000XS0^005B92800006;C06;C0b>3H00>8
`;P2000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0P00P003VjOanLgDmhVG00;oool01on]/>4F=?mf
NonTW^8V??n9Oc=3Y@0800200`01P003oooo00:000:100<00h4300B10P05
P@0400F200J200J200J20P07PP040@N20@R20@R20@R31?ooo`<12X<00`4;
P`4;Q04;Q0030@b40P4=Q004oooo0@j50@j50@j50`8?Q@<248D40Q660`8B
QP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR8
00<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/3
12:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>
0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946
<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087
=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10Pn
UP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH
0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/3
2TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h0
0`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ
35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeR
XP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZ
Y@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0ma
Z0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/3
47Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^
4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK00
11:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8C
Sk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF
]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPE
W[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX3
5ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^
_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3H
R<2hR<2h00^8`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd
`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0P00P007VjOaoooolj2^m69^oooomhVGnLgD00;oool00o>P
[_oooc=3Y@0800200`01P0800X001002P@03P@03P@03P@<0184200F100@0
1H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<1
2h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8D
Q`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT0
10<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<
12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?
1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHb
T@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`03
1cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8
@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI
2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`0
10YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]G
WP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aN
X@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=
I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]
YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mc
Z0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`4
47f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^
00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::
/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<C
T;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI
]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh
00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/3
5ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn
0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P0
0dR@R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B9280000
6;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008002i^WlOoo
oon9Oooooo>P[_6CXOooooomoo>P[_oko3=3Y@0800200`01P0800X001002
P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h812881
28800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<2
48D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP3
5hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;
0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DW
SPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@
00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB
1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8
?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H
2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J
0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;
E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P
0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ80
0`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=
J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L0
10m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ
0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60
[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`
0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK82
4Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<C
U;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L2
59fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j
0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/
_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o
0QRd`0o8h=P00`000<SPf<SPf00=b>3H00<0000H]<0H]<003lSPf0030000
6;C06;C000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P400200i^Wl@06
oooolj2^m;Fom[c5nmWJ<d>U2@00P0<00H0200:000@00X400h400h400h43
00B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V3
0`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR003
0aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A
1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC
0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH3
23nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9
AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>
V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aM
X@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ80
0PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD4
3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?
LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1j
Z`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61
[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@B
RK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb
4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D3
59Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh
5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h5P00P0<00H0200:000@00X400h400h40
0h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<3
0@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<2
4XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<H
R0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;
0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DX
SP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A
1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP02
1cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8
?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4
V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK
0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN
00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aL
X@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=
HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>
JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?
LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[
0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61
[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`
00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb
4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<D
U[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh
5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj
0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G
[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h
0DR@R04000000003R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058T8P100000000
0hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8h=S8h=P0
olSPf?o8h=Qmb>3H0DR@R04000000?n8`;SoR<2hPHS0^04000000001\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l7?ol?3`00?ofMWIooooooooool03?ooool0
0?ool?3`ooo`l?1coo3`l004omWIfOooooooooooonGUi@?ooooo00GoiNGU
ooooooooooooooooonGUi@03ooooo`00ooo`l?3ooo3`l7?ol?3`00gofMWI
oooooooJf][oSHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgo
iNGU00;ooooo003ooo3`l?ool?3`Loo`l?003_oIfMWooooooooooooJf][o
SHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU0Oooool0
0?ool?3`ooo`l?1coo3`l00=omWIfOoooooooooooooooooJf][oSHf=onGU
iOoooooof][Johf=SOoUiNGoooooom[JfP02ooooo`00ooo`l?3ooo3`l7?o
l?3`00?ofMWIooooooooool00_ooool01ooJf][oSHf=onGUiOoooooof][J
ohf=SOoUiND00oooool00?ool?3`ooo`l?1coo3`l003omWIfOoooooooooo
00?ooooo00Oof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003o
oo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`04ooooo`07om[Jf_n=SHgo
iNGUoooooooLg=coSHf=onGUi@01ooooo`00ooo`l?3ooo3`l7?ol?3`00?o
fMWIooooooooool01Oooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo
003ooo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`06ooooo`03omcLg?n=
SHgoiNGU00?ooooo003ooo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`07
ooooo`03omcLg?n=SHgoiNGU00;ooooo003ooo3`l?ool?3`Loo`l?000ooI
fMWoooooooooo`08ooooo`03omcLg?n=SHgoiNGU007ooooo003ooo3`l?oo
l?3`Loo`l?000ooIfMWoooooooooo`09ooooo`7og=cL0Oooool1ooooo`00
ooo`l?3ooo3`l7?ol?3`00?ofMWIooooooooool03?ooool00?ool?3`ooo`
l?1coo3`l0oofMWI003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooo
oon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?oo
k^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^
k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003o
onk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;o
k^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool0
0?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_oo
k^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003o
onKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;o
oooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^ko
onk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00
oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2
ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^
ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0
0?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooooooo
P_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^
k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^
003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooo
oh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooo
oon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?oo
k^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^
k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003o
onk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;o
k^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool0
0?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_oo
k^k^P_o^k^h00003ooooZ?na/E[oQ8@]00KoQ8@]00?oNGTRohB4;On4Q2d0
0on4Q2d00onl_6Goooooooooo`3oooooooooooooL?ooool00003ooooZ?n4
Q2goVYY300?oYJE>00?oVYY3ojFUC_nUYDh01OnUYDh00omiNB;ogMf6onk^
kP3oonk^k_ook^k^LOo^k^h0000<ooooZ?miNB;om?BMooCdWOoBdW_oYJE>
olO7L?ooojSom?BMonWYT_nUYDkojNVB0_odm9d00onUYDkogMf6onKViP0@
onKViP03omcLg?oAdM7oi^KV00?oi^KV00?ohn?SomOGeooVi^H01_oVi^H0
0oo>c/koi>CTonKViP0ConKViP03omCDe?oGemOoi^KV0?ooi^KVoooVi^Hi
onKViP0000KooonXogUi8_ooojSom?BMojFUC_mGNHH2ogUi0008ohB4;Omi
Eb;oEeLFoiYG@onUYDkooonXojFUC_oBdW/5onk^kP03oc8b<_nJVY[ok^k^
00;ok^k^00?o];Bdo`000?n@T9000_o^k^h03OoGemOoADE5o`820_lP823o
5ADEokBd]?o^k^ko/[:boaTI6Ol61PKoC4a<ogemOOl/;2`00_o^k^h01oo4
a<Co8R8Roa`L7?n][Jgok^k^oc/k>omfMWH00oo^k^h01_lk>c_oMWIfonk^
k_o^k^ko>c/kogIfMP;ok^k^00[oV9RHoaXJ6_o^k^kok^k^olc<c?la<C7o
3@d=o`/;2ole=CGocLg=ooo^k^koonk^kSSok^k^00004?ooojSoYJE>ooCd
WOodm9goVYY3oeNJZ?mGVXKoQ8@]ogUG8_miNB;oYJE>ogUG8_na/E[om?BM
oiZJ@ooMgHH5ooooo`08ocHf=_nUYJGoooooooooooofm_Ko9BDUo`000?nK
Vi/2ooooo`0=odA4A?m0@43ogmoOoooooooclo?ol_;boooooomDE5CoFEUI
ooOgmonNWYko3`l?oc0`<002ooooo`03og5aLOm1@D7oo_kn00;ooooo00?o
@410ogmoOoooool00_ooool01_m0@43oOgmooooooooooooo@410ogmoO`;o
oooo00KoXj>Soa`L7?ooooooo_knoc@d=?mBDU82onk^kP03oeEEEOle=CGo
o_kn0?oooooooooooolgooooo`0000GooonXogUi8_odm9gojNVBof9R2`02
oeNJZ009ogVJQ_m]KAKo/K5JokblIOm]KAKojNVBooCdWOnUYDkogMf600Go
k^k^00co<S8boiZJV_o^k^kok^k^ofe]KOlA4A7o:2PXoi2@T?o^k^koc/k>
o`000?n[Zj/5onk^kP06obTY:On6QXKok^k^onk^k_maLG7o;2`/0_o^k^h0
0om7AdOoJVYZonk^kP02onk^kP03oc/k>omfMWKok^k^00;ok^k^00Ko>c/k
ogIfM_o^k^kok^k^oc/k>omfMWH2onk^kP06oiRHV?lJ6Q[ok^k^olW9bOl0
003oZZZZ0_o^k^h00onZZZ[o0000olg=c@3oonk^k_ook^k^=oo^k^h00006
ooooZ?miNB;om?BMogUi8_miEb;oEeL;0_m]KAH02?mGNB;oNELRof9G0?mG
E`3oNGTRom;BNonUYDkod]9k1OoVi^H03?l`<33oU9BDonKVi_nf][Ko0P82
oi>CTolh>3SoRh^;onKVi_n[Zj_o0000ocLg=`?o>3Ph00Co/;2`onKVi_lW
9bOoQ8B40_oVi^H01_n0P83o:b/[onKVi_oVi^KoADE5ofIVIP?oi^KV00?o
>CTiog9bL_oVi^H00_oVi^H01_li>CWoLW9bonKVi_oVi^Ko>CTiog9bLP;o
i^KV00KoTi>CoaTI6OoVi^KoZj^[o`000?o?cll2onKViP03olg=cOl0003o
[Zj^0?ooi^KVoooVi^HgonKViP00013ooonXojFUC_nJND?oVWU3ojFUC_na
/E[oVYY3ogUi0?mGNHKoEiZ6ogUG@omGE`3oVWU3ogUi8_nUYDkogMf61Oo^
k^h04olb<S;oVYZJonWYjOlY:BWoADE5onk^k_lj>S[oT92@onk^k_o<c<co
0000oinOWoo1`L7o^KVio`820_oEeMGok^k^obTY:On9RHT00_o^k^h01_n5
QHGo;2`/onk^k_o^k^koAdM7ofYZJP?ok^k^00?o>c/kof9RH_o^k^h00_o^
k^h01_lk>c_oMWIfonk^k_o^k^ko>c/koeIFEP;ok^k^00KoTY:Boa/K6oo^
k^kocLg=o`000?nXZ:P2onk^kP03ojJVY_l0003odM7A0?ook^k^ooo^k^hg
onk^kP0000WooonXohB4;OmiEb;ogEN6oiYi@onJVT?oHUL0okbJ0?oM_000
0_mGVXH2okaGI@03om;BNonUYDkogMf600Gooooo00So=SHfojFUYOn0P83o
3Ph>on?Shooooooo?clooi^KV`;ooooo00Go?cloof][JoogmoOoWYjNob/[
:`02ooooo`0Dob`/;?nCTi?ooooooooooon?Shoo<30`oooooooinOWoBDU9
ofe]KOodm?Cono_koooooom0@43o4a<Coi6ATOoTi>CooOgmod10@?moOgl2
ooooo`06od10@?lD51CoMWIfomkNg_mGEeOoCDe=0_ooool01_m1@D7oB4Q8
omkNg_oMgMgoAdM7odA4A?oooooooooooolhooooo`0000CooonXogUi8_oM
gHKoQ8@]0_mGE`002_miEb;oVYX0oooM0?nlVP3oVUM3omeGZ?nJEd?oVWU3
ojFUC_oBdW/5onk^kP04oc8b<_m`L73o10@4ohb<S0;ok^k^00Wo>SXjoi2@
T?o^k^kok^k^omKFe_m2@T;o30`<oaXJ6_nZZZX00_o^k^h05?ln?SkoTi>C
onk^k_o^k^koT92@od51@Oo^k^koMWIfo`L71ol;2`_o6ATIoj:RX_o^k^ko
CTi>ogmoOomFEUKo20P8on3Ph?m>CTkoPh>30_o^k^h01_m>CTkoPX:2og1`
L?lB4Q;o:RXZokJf]P;ok^k^00Kof=SHoda<C?l>3Pko3Ph>odi>C_oIfMWo
onk^k_ook^k^>?o^k^h00007ooooZ?nUYDkom?BMooCdWOm]KAKo_5MUoiYi
@`02oiYG@`07ogUG8_nlVP3oHV8;omgMQ_odm9goYJE>omgMQP05onKViP03
oc0`<?l410Co>CTi00?oi^KV00?o>3Phoh^;RooVi^H00ooVi^H00ooShn?o
i^KVonKViP0:onKViP03odE5AOmVIVKoi^KV00Goi^KV00?ohn?SonKVi_oV
i^H01_oVi^H00ooUiNGoi^KVonKViP04onKViP;oiNGUoooVi^KoonKViS[o
i^KV00001_ooojSoQ8@]ooCdWOnl_6GoHV8;ohB4;@;ogEN600Co_5MUoeMi
@ooM_03oYJE>0_odm9d00onUYDkogMf6onk^kP04onk^kP03oc8b<_l820So
cLg=00?ok^k^00?o>SXjoi2@T?o^k^h04?o^k^h00ooAdM7oclo?onk^kP07
onk^kP03oeADE?n8R8Sok^k^0?ook^k^ooo^k^i7onk^kP0000WooonXogUi
8_odm9goYJE>ogUi8_nJVT?oNGTRomeGQ_n4Q2d00_mGND<01OnUYDkom?BM
ooCdWOnUYDkod]9k00Gooooo00?o/;2`okjn__ooool00oooool00ond];Co
f=SHooooo`0Jooooo`03okBd]?o=cLgooooo0?oooooooooooom7ooooo`00
00?ooonXojFUC_odm9d00oodm9d01_oBdW_oVWU3ooooZ?odm9go_;aUok6a
FP;om?BM00?oYJE>omgMQ_o^k^h0ooo^k^koonk^kW7ok^k^00000oooojSo
NGTRooooZ00;ooCdW@03ojFUC_oMgHKoi^KV0?ooi^KVoooVi^IaonKViP00
00?ooonXogUi8_nUYDh03?nUYDh00oooojSok^k^onk^kP3oonk^k_ook^k^
L?o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_oo
k^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003o
onKVi_ooi^KVP_oVi^H000?ok^k^00Goi^KVomWJf_nn`<;oYZ^`oiBMYP02
ohZGX@05oiBMY_nVZk3o_Ko1omWJf_oVi^H0ooo^k^koonk^kW?ok^k^0002
ooooo`06ooOgmooOgn3o_L33oiFOZ?mjRIOoIWZ=0_mNM8D01_mUNH_oN8RE
oi>MY_nk_/;ogmoPooOgmooooooooooooombooooo`0000Sok^k^onKVi_o@
d=7oZ:faoh6=UomRLh;oCei/odIBG@;o@TaD00OoAE1JodeMJOmPL7koOXZD
ojN[/?o@d=7oi^KV0?ook^k^ooo^k^iaonk^kP0001;og]kNol[;c?nUZZko
P8^Dof1^NOm8DegoDf9/ogB:U_nC/[SoUkFjogR@W?mFIW?oAe5LoeaYMOml
R97oXjR/olW:booNg]hBonKViP03omcLg?oAdM7oi^KV00Coi^KV00?oeMGE
omOGeooVi^H01?oVi^H00oo>c/koi>CTonKViP07onKViP03omCDe?oGemOo
i^KV0?ooi^KVoooVi^I3onKViP0001;ofM[Jok:f^On8U9ooJ7J3odiKJ?mb
Rj;o_NWhomGooooJoooof?ooom;noonok?ooNiF`odmMJOmTLWkoQI6Lok:e
^OoIf]X5onk^kP03oc8b<_l0003o000000;o000000Co?cloonk^k_lk>c_o
MWIf0_o^k^h05OoGemOoADE5o`820_lP823o5ADEokBd]?o^k^koeMGEoc/k
>ol0003o410@oa/K6ooWinOok^k^olC4a?lR8R;o71`Lojf][Oo^k^ko>c/k
ogIfMP03onk^kP06olc<c?la<C7o3@d=o`/;2ole=CGocLg=0_o^k^h01_lk
>c_oMWIfonk^k_o^k^koV9RHoaXJ6_ook^k^ooo^k^hjonk^kP0001;oe=KG
ojB/]?mfRigoFFMdog6>/?nehooo`^onokoZo?ndg_?o/M_aokOUnonljooo
]nCoogbK_omEI7;oLXNIoj:[/ooDeML5ooooo`03ocHf=_mdM7Cooooo00Co
oooo01Go@410ogmoOoooooooooooodA4A?m0@43ogmoOoooooooclo?ol_;b
oooooom2@T;o;2`/ol_;booooooof=SHoogmoOooooooLG5aod51@Oono_h0
0_ooool01om0@43oOgmoooooooooooooo_knoc@d=?mBDU800_o^k^h01_mE
EEGo=CDeookno_oooooo@410ogmoO`;ooooo00?oXj>Soa`L7?ooool0oooo
ooooooooocWooooo00004_nk_/3oSi^Uof=kSomHL8SoVl[gojoLoOn`foko
X/W[oiFje_nB^=CoV/7XojSEo?nXfOgoUlOloeYeTOmNM8OoRYRTokBh^`Go
k^k^00?o<S8bofa/K?o^k^h01?o^k^h01_lk>c_oMWIfonk^k_o>c/ko0000
oj^[Z`Cok^k^00?ocLg=o`000?n;Rh/01Oo^k^h00om7AdOoJVYZonk^kP02
onk^kP07oc/k>omfMWKok^k^onk^k_o9bLWo0000ojZZZP02onk^kP06ojZZ
Z_l0003ocLg=onk^k_lk>c_oMWIf0_o^k^h00onHV9So6QXJonk^kP3oonk^
k_ook^k^>Oo^k^h0000Bojjb]On8UZ;oEVn5ofR?^_nFb?goX<oloig8m_mc
T[;oAEIWod1@H?mYQZGoUKo^oiW;oOn?`o[oJIC3oeAYO?n0TZ?oXJN]1OoV
i^H00ol`<33oJ6QXonKViP04onKViP06ocTi>OmbLW;oi^KVoj^[Zol0003o
=cLg0olh>3P01?n`/;3oZj^[o`000?ni^KT5onKViP03odE5AOmVIVKoi^KV
00;oi^KV00Oo>CTiog9bL_oVi^Koi^KVoj^[Zol0003oclo?00;oi^KV00Ko
cLg=o`000?n^[Zkoi^KVocTi>OmbLW82onKViP03oi>CTolI6AWoi^KV0?oo
i^KVoooVi^HionKViP0000So/kNjohjLZOmDKXCoIYO?oh>gkonBa?[oRKCR
obPd@`;o000000So72HaogZQd?n?`__oO[3[of6EdOmBIW_oOYJ[oiZS[0Go
k^k^00Go<S8bobXZ:_mOGeooGemOogMgM`02onk^kP0=oc/k>omfMWKok^k^
olc<c?l0003oWinOol71`Oni^KWo0P82omGEeOo<c<co0000ohN7Q`05onk^
kP03odM7AomZJV[ok^k^00;ok^k^00Oo>c/kof9RH_o^k^kok^k^olg=cOl0
003oZ:RX00;ok^k^00KoYZJVo`000?oAdM7ok^k^oc/k>omFEUH2onk^kP03
oi:BT_lK6a_ok^k^0?ook^k^ooo^k^hionk^kP0000Oo`<?6oiVW]?mDKHGo
E8c:ofnQg?ml/nkoM:CG00;o0@4200Wo0`@6o`000?mPR;OoO[OeofVMf?m=
Q/_oCfElohFP]onNZ[<01Oooool01Olf=SKoAdM7oifMWOnMWIgo[Zj^00;o
oooo00Wo@410ogmoOooooooooooooclo?om[Jf_omoOgoijNW_l[:b/00_oo
ool05olo?coo9bLWokjn__ono_kog]kNoooooooinOWoBDU9ofe]KOodm?Co
no_koooooom0@43o4a<Coi6ATOoTi>CooOgmod51@Om8B4Sog]kNomgMgOm7
AdOoA4A400;ooooo00Ko@410oa@D5?mfMWKog]kNoeMGEom=CDgooooooooo
oooo>_ooool00008ok:e^?nBX:coEG28oc=[[om=QlSoGiWPof6IfOlK:3H2
o`@10008oa8K8omGRlKoGY_SodN3a_lWI:koCV=joh>L/_nJXj`5onk^kP03
oc8b<_m/K6cok^k^00Cok^k^00Wo>c/kogIfM_o^k^kok^k^omKFe_m2@T;o
30`<oaXJ6_nZZZX00_o^k^h04ooHf=SoDE5Ao`h>3_l:2P[o8b<Sonk^k_mf
MWKo1`L7o`/;2olI6AWoXZ:Ronk^k_m>CTkoOgmooeIFE_l820Soh>3PomSH
f?m<C4`00_l>3Ph02_m>CTkofMWIonk^k_o^k^koCTi>oh:2P_m`L73o4Q8B
obXZ:_nf][Koonk^k_ook^k^>_o^k^h0000BokBf^On@WJSoHgfEoai@S?lX
JKCo@h7;oe^Ff_mIQkSoA5Q/od9DIOmEOjcoF9GFod>5colTI[?o4DB<oe]a
Qon8VJSoYJ^_1OoVi^H00ol`<33oJ6QXonKViP04onKViP03ocTi>OmbLW;o
i^KV00?oi^KV00?ohn?SonKVi_oVi^H01OoVi^H01_oShn?oi^KVonKVi_oV
i^KoADE5ofIVIPKoi^KV00Cohn?SonKVi_oVi^Koi^KV0_oUiND7onKViP03
onGUiOoVi^Koi^KV0?ooi^KVoooVi^HjonKViP0001;oaLK8oj2X/?mmU:So
=eJ0oa58U?lkLk_oMJ3MoiNik?nXaOSo[<_loj73m?n3ZnCoAGRooa8nU?lZ
?GGoNHfQoibV[_o0`/@5onk^kP03oc8b<_lZ:R[oGUiN00;oGUiN00CoZj^[
onk^k_lk>c_oMWIf4?o^k^h00ooAdM7oclo?onk^kP3oonk^k_ook^k^Coo^
k^h0000BonWZj_o0a<OoWJZeogN8W?lW>GKo=DBFogf1`?ne]>3od/k^om[E
l?o6`nKoUi[=odmDWOlW:fkoJgZBoifZ]Oo0a<OojN[Z1Oooool00on`/;3o
VYZJoiZJVP02oiZJVP04om7AdOoooooo@410ogmoOooooooooooooomRoooo
o`0001;oi^KVom;Bdona]KWoUj>/ofYgS_lb=FOoA4=eogQhU?nEUZKoUiRP
oh20TOmBDWCo<cIMof9_QOnEXJ[o/KFiom;BdooVi^H<onk^kP03on[Zj_o/
k>cok^k^0?ook^k^ooo^k^iQonk^kP00017oi^KVomkNg_o:blcoZjncoi>O
Z?mhR9WoDEaaoce3C_lb<cOo;Rl`ocXoAOm;EVKoLX6Boi:NZ?n[/;?ob/_<
omkNgP3oonKVi_ooi^KVLOoVi^H000;ok^k^00koi^KVom7Bdona]KWoU:6/
ohBK[omhU:coLHfVog6=YOmhTZ[oQ9Z^oiBQ[?na]KWodM;ConKVi_ook^k^
ooo^k^ibonk^kP000oooool01OogmoOohN7Rol?7b_nZ/[[oWJZe00;oVZRd
00GoWJZeojZb^_o3al[ohN7RooOgm`3oooooooooooooLoooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV0004onk^kP04ong]kOoY
jNWoh^;RomkNgP;of][J00Cog]kNon7QhOoXj>SokNg]ooo^k^koonk^kWCo
k^k^0002ooooo`0>ookno_olo?comOGeon;Rh_o;bl_o]kNgojb/[?n[Zj_o
];BdolS8b?oNg]kol_;booclo?ono_koooooooooooooL_ooool0000Aonk^
k_o]kNgojn_[on3Ph?o6a/KoXZ:Roh:2P_m^KVkoHf=Sof9RH_m[Jf_oOWin
oifMWOo2`/;ogmoOon_[joo]kNd0ooo^k^koonk^kW7ok^k^00004OoVi^Ko
iNGUomcLg?o0`<3oUIFEofa/K?mdM7CoVIVIokRh^?nl_;coW9bLogYjN_mY
JFWoShn?ok^k^ooIfMWoi>CT01Ooi^KV00?oe=CDomOGeooVi^H01OoVi^H0
0oo>c/koi>CTonKViP02onKViP03omCDe?oGemOoi^KV0?ooi^KVoooVi^I:
onKViP0000SokNg]onWYjOoEeMGoYZJVogMgMonRXZ;okNg]ooknoP?ooooo
00Oolo?cojb/[?mfMWKoWYjNom3@d?oWinOokNg]00Gok^k^00?o<S8bofm_
Koo^k^h01?o^k^h01_lk>c_oMWIfonk^k_o^k^koV9RHoaXJ6P;ok^k^00Ko
c<c<oc4a<Ol=3@go2`/;ocDe=Oo=cLd2onk^kP0;olC4a?lR8R;o71`Lojf]
[Oo^k^koc<c<oc4a<Ol=3@go2`/;ocDe=Oo=cLd00_o^k^h01_lk>c_oMWIf
onk^k_o^k^koV9RHoaXJ6_ook^k^ooo^k^i1onk^kP0000Ooo_knooCdm?oC
dm?oShn?ojVYZOo^k^koo?cl00Coo_kn00Oon?Shoo3`l?nc/k?oRHV9olc<
c?oalO7ooOgm00Gooooo00?o=SHfogMgMoooool01?ooool02_m0@43oOgmo
ooooooooooooXj>Soa`L7?ooooooo_knoc@d=?mBDU82onk^kP0;oeEEEOle
=CGoo_knoooooomaLG7o@D51ookno_ooooooo_knoc@d=?mBDU800_o^k^h0
1_mEEEGo=CDeookno_oooooo@410ogmoO`;ooooo00?oXj>Soa`L7?ooool0
oooooooooooood3ooooo00004_o/k>coh>3Pok2`/?n>SXkof][Jon_[jooc
lo?on_[jooooooolo?comoOgoo7alOoXj>Sofm_KoiBDU?nVYZKog]kNon_[
j`Gok^k^00?o<S8bofm_Koo^k^h01?o^k^h02_lk>c_oMWIfonk^k_o^k^ko
V9RHoaXJ6_o^k^kobLW9o`000?nZZZX2onk^kP06ojZZZ_l0003ocLg=onk^
k_m7AdOoJVYZ0_o^k^h00oo9bLWo0000ojZZZP02onk^kP06ojZZZ_l0003o
cLg=onk^k_lk>c_oMWIf0_o^k^h00onHV9So6QXJonk^kP3oonk^k_ook^k^
@?o^k^h0000Bon;Rh_oKfm_oVi^Kojj^[_oJf][ohN7Qon_[joo_knool_;b
oo3`l?o]kNgoj^[Zon3Ph?oHf=So/k>coi:BT_oHf=Soh^;R1OoVi^H01?l`
<33oCTi>okBd]?oDe=@3onKViP0:ocTi>OmbLW;oi^KVonKVi_nCTi?o6ATI
onKVi_n[Zj_o0000olo?c`;oi^KV00KocLg=o`000?n^[Zkoi^KVodE5AOmV
IVH2onKViP03oj^[Zol0003oclo?00;oi^KV00KocLg=o`000?n^[Zkoi^KV
ocTi>OmbLW82onKViP03oi>CTolI6AWoi^KV0?ooi^KVoooVi^I0onKViP00
00SojNWYonKVi_nJVY[o]kNgolk>c_oHf=Soh>3Pon7Qh@;oi>CT00Sohn?S
omkNg_oIfMWobl_;okRh^?n@T93oh^;RonWYj@Gok^k^00Wo<S8boa`L7?lN
7Qko0000oeADE?oShn?ok^k^oc/k>omFEUH00_o^k^h01_nBTY;o6a/Konk^
k_o=cLgo0000ojRXZ0;ok^k^00KoYZJVo`000?oAdM7ok^k^odM7AomZJVX2
onk^kP03olg=cOl0003oZ:RX00;ok^k^00KoYZJVo`000?oAdM7ok^k^oc/k
>omFEUH2onk^kP03oi:BT_lK6a_ok^k^0?ook^k^ooo^k^i0onk^kP0001;o
nOWiookno_nRXZ;o];Bdol?3`oo<c<cod];Bom?CdooEeMGoe=CDom;Bd_o?
cloocLg=ol71`Onc/k?oTY:BoogmoOojn_X5ooooo`0=ocHf=_mgMgOooooo
om?Cdol<30coJVYZoooooom0@43o51@DogIfM_oNg]koEeMGode=C@02oooo
o`0Cod51@Om8B4Sog]kNomgMgOm7AdOoA4A4oooooooinOWoBDU9ofe]KOod
m?Cono_koooooom1@D7oB4Q8omkNg_oMgMgoAdM7odA4A002ooooo`06od10
@?lD51CoMWIfomkNg_mGEeOoCDe=oooooooooooood7ooooo00004_oWinOo
k^k^oj:RX_nKVi_o/K6aokfm_Oo3`l?oa<C4ol?3`oo1`L7o`/;2ol71`Onm
_Kgo/;2`oiRHV?nATI7ok^k^onWYj@Gok^k^00go<S8bofm_Koo^k^kok^k^
of1PH?lM7Agok^k^oc/k>omeMGGoL71`oa8B4_lZ:R[o][Jf00;ok^k^00oo
f=SHoda<C?l>3Pko3Ph>odi>C_oIfMWok^k^ogIfM_l71`Oo2`/;oaTI6OnR
XZ;ok^k^omSHf?m<C4`00_l>3Ph02_m>CTkofMWIonk^k_o^k^koCTi>oh:2
P_m`L73o4Q8BobXZ:_nf][Koonk^k_ook^k^@Oo^k^h00007on7QhOoVi^Ko
]KFeohF5QOnKVi_o[jn_okbl_002ol30`009ol71`Ono_koo^k^kok6a/OnJ
VY[oOGemojBTY?oVi^Koh^;R00Goi^KV00_o<30`of][JooVi^Koi^KVochn
?_lm?Cgoi^KVocTi>OmbLW;oi^KVonGUi@06onKViP;oiNGU1?oVi^H00om5
ADGoIVIVonKViP04onKViP;oiNGU1ooVi^H00ooUiNGoi^KVonKViP3oonKV
i_ooi^KV@OoVi^H0000Bon_[joo^k^kogmoOohj>S_moOgooY:BTokjn__o<
c<codM7AomCDe?oBd];oalO7ojRXZ?mlO7coMWIfomCDe?o^k^kok>c/1Oo^
k^h02Olb<S;o:b/[oeADE?lT92Co0@41oj:RX_o^k^ko>c/kogIfMP0>onk^
kP03om7AdOo?clook^k^0?ook^k^ooo^k^iAonk^kP00017oooooooclo?oo
ooooclo?ogIfM_moOgooZZZZolG5aOoBd];odm?ColW9bOne]KGoQXJ6ofIV
I_nk^k_oooooooclo006ooooo`05ok2`/?nJVY[oVi^Kojf][OoNg]h00_oo
ool00om0@43oOgmoooooo`3oooooooooooooHOooool000;ok^k^0_o]kNd0
1?nc/k?oHV9RoeaLG?n3Ph<2oiVIV@06ohJ6Q_mRHV;oEEEEoj6QXOoYjNWo
kNg]3_o^k^h00ooZj^[ok>c/onk^kP3oonk^k_ook^k^HOo^k^h000;oi^KV
0ooUiND02oo5aLGoO7aloeMGEom4A4Co@410oeEEEOmcLg?o^KVionCTi?oV
i^KoiNGU0?ooi^KVoooVi^IbonKViP000oo^k^h2ong]k@08onk^k_o]kNgo
gMgMom3@d?o?cloof][Jon_[joo^k^h2ong]kOook^k^ooo^k^iconk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ooOgmoEomoOgl7oginO_ooOgmo9?moOgl00004on_[jooVi^Ko
h^;RomkNgPCogMgM00Gog]kNomgMgOoNg]kog=cLomkNgP03omgMg@3oomkN
g_oLg=cog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN000AomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kog=cL
omgMgOoKfm/00_oLg=`0<ooMgMgogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNgP02omcL
g005omWIfOoHf=SoemOGomSHf?oIfMX00_oLg=`0oooNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomcLg?oNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNgP005ooMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgN00?og]kN00?ogMgMomkNg_oNg]h00ooM
gMd1on7Qh@7oinOW0OoZj^X00003onc/k?oVi^Koh>3P00OofMWI00Cof=SH
omKFe_oCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSH
f?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oH
f=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf=_ofMWI0_oH
f=P01_oFe]Kodm?Com?CdooDe=CoemOGomSHf0;ofMWI00?of=SHomWIfOoI
fMT00_oHf=P9omWIf@03omSHf?oIfMWofMWI00;of=SH00?ofMWIomSHf?oH
f=P00_oHf=PGomWIf@04omSHf?oFe]Kod];Bolo?c`;ocLg=00Coclo?om?C
dooGemOof=SHoooIfMTFomWIf@03omSHf?oIfMWofMWI00KofMWI0OoNg]h1
onKViP7ok>c/00001oo^k^kojNWYonCTi?oPh>3ohN7Qon3Ph?oRh^800_oQ
hN403OoNg]kofm_Kom?Cdoo7alOo^k^kok:b/_n][Jgo/[:bok^k^oo7alOo
dm?Com_KfooOgml02OoQhN403OoOgmoofm_Kom?Cdoo7alOo^k^kok:b/_n^
[Zko/[:bok^k^oo7alOodm?Com_KfooOgml02OoQhN403OoOgmoofm_Kom?C
doo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml0f_oQ
hN402OoPh>3ogmoOom_KfooFe]Koe=CDomKFe_oJf][og]kNon3Ph006omoO
g`?oh>3P00?ogmoOon3Ph?oPh>000_oPh>08omoOg`;og]kN0_oOgml3on3P
h0;ogmoO0_oPh>02omoOg`goh>3P00GogmoOomgMgOoIfMWoeMGEom?Cd`02
om;BdP03omKFe_oLg=coh>3P06oohN7Q00?oh>3Pon7QhOoQhN401OoQhN40
0ooPh>3ohN7Qon7Qh@0bon7Qh@03on3Ph?oQhN7ohN7Q06SohN7Q00?oh^;R
on7QhOoRh^801?oQhN41onCTi07oj>SX0Oo]kNd00003oo3`l?o_knoolO7a
00?ol?3`0?ookno_oo3`l?o^k^kojNWYom_Kfoo1`L7oY:BTohb<S?mjNW[o
MgMgog]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7alOo_
knoolO7_ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_oNg]kogMg
MomkNg_oS8b<ojBTY?o2`/;of][Jon[Zj?o]kNgolO7aono_kooalO7okno_
oo7alOo_knoolO7_ong]kOoZj^[of][Jol;2`_nTY:CoS8b<og]kNomgMgKo
Ng]kohb<S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knl001_olO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo^
k^kokno_on[Zj_oWinL00_oPh>001ooShn?ojn_Yon_[jooZj^[oi^KVonSX
j?oWinL00_oYjNT04_o^k^cok>c/onc/k?oXj>Sok>c/ong]kOo`l?3ok>c/
on[Zj?oVi^Koj>SXonOWiooYjNWoj>SXon_[jooWinOoinOUonGUi@;ojNWY
00ook^k^ong]kOo]kNgoj>SXon_[jOo/k>cok^k^onWYjOoZj^[ojn_[ono_
koo/k>cok>cZon[Zj_o^k^h00_o/k>`0oooZj^[okno_onc/k?o/k>[oj^[Z
onk^k_o/k>co[jn_ogIfM_mIFEWoKVi^okNg]_oPh>3ojNWYong]kOoalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_k`00;OoalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNool?3`ono_koo`l?3okno_oo3`
l?o_knool?3`ono_k`04oo3`l00000?ol_;bonk^k_oWinL01?oUiND04?oT
i>CogmoOom7AdOna/K7oRXZ:ofEUIOmADE7oADE5od92@_m5ADGoDE5AofIV
I_n:RXWo/K6aom7AdOoNg]h2onCTi003onGUiOoTi>CoiNGT00;oi>CT00oo
g]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:
RX[o/K6aom7Ad?oNg]h00_oTi>@0kOoUiNGoi>CTonGUiOoTi>Coi>CSomkN
g_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:
ok6a/OoAdM7og]kNonCThooTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi002onCTi03oolG5aOlX:2SoA4A4
oi2@T?oAdM7og=cKom_KfooGemOoe=CDomKFe_oDe=CoeMGEomWIfOoPh=oo
g]kNom[Jf_oDe=CofMWIomkNg_oRh^;og=cLomOGe_oDe=Coe]KFomCDe?oE
eMGof=SHom_KfooGemOoe]KEomGEeOoGemOof=SHomkNg_oOgmoog=cLomGE
eOoGemKog=cLomgMgOoGemOoe]KFom_KfooQhN7og]kNom_Kf_oJf][og]kN
omcLg?oJf][ofm_Kon3Ph?oOgmoog=cKomWIfOoNg]kogmoOogAdM?mWIfOo
SHf=oeADE?l820SoXZ:RomcLg?oRh^;oiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoShn?oiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGohn?SonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CT001HonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi0CoiNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o/k>`1
oo;blP0000?om?Cdong]kOoWinL00_oPh>004ooQhN7ogmoOomkNg_oBd];o
/k>cohN7QomLG5coKC/eoii>@_o=KUkojH=_ole_GonMCD?oKC/foeaLG?n7
QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLofeP
;?nNURkocLdoonWYCOo=cCooWYX_ofeS;OmLG5coQhN7okBd]?oBd];og]kN
00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m7IbkoJ9hcoi7=AonZjEGo
TLe7ofZN=?m9JRooG5aLohN7Qond];Cod];BomkNgP3Ion3Ph006omoOgoo?
clooVIVIoi:BT_lI6AWoS8b<0_oEeMD07oo?cloo`/;2olk>c_o>c/koaLG5
ol[:b_oJf][of=SHom3@d?o;bl_oclo?omSHf?oJf][oeMGEolo?coo1`L7o
d=3@olk>c_o4a<Cobl_;omSHf?oGemOo_[jnok^k^ooAdM7od=3@omGEeOoH
f=Sodm?Colc<c?o>c/h00_oEeMD01Oo>c/koc<c<om?CdooJf][of=SH00;o
d];B00Cof=SHomOGeooAdM7odm?C0_oIfMT01_oCdm?odM7AomOGeooHf=So
dM7Aom3@d0;odM7A00CoATI6od51@OoGemOog]kNLOoPh>000ooOgmooh>3P
on3Ph002on3Ph003omoOgooPh>3oh>3P09coh>3P00?ogmoOon3Ph?oOgml0
0_oOgml3on3Ph003on7QhOoWinOok>c/007om?Cd00000oofm_Kol_;bon_[
j`03onSXj00ConOWiooRh^;ocLg=oinOWomZGUkoScH^ona`HOoiWI3ooK6U
oofl[oom]:OonInConedHonB=booJemOoinOWoo=cLgoh^;RonOWi`03onSX
j00ConOWiooRh^;ocLg=oinOWom^IUooTg8RongAA?oilgCooOf=oogmUOom
oHkonOQfongGAonCLb;oKVMOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOW
iooRh^;ocLg=oinOWomPJ5ooBg`Soi;QBonmnG_od?fBomSmVooDoIGo`?Un
oiSXCOm=P2CoH6UOoinOWoo=cLgoh^;RonOWi`3JonSXj004onKVi_oQhN7o
GEeMode=C@;ogMgM01ooD51@o`L71olE5AGoQ8B4oaHF5_m3@d?oh^;RomgM
gOnLW9co0000ohn?SooMgMgohN7Qom_Kfom0@43o20P8oaTI6On8R8So2`/;
oeQHF?ng]kOo30`<o`L71olS8b?o9bLWogemOOoJf][ogMgMomCDe?l;2`_o
FEUI00;ofMWI00?oGEeMo`/;2ooCdm<00_oOgml01_mJFU[oCTi>omkNg_oN
g]ko8b<SohB4Q0;ohN7Q00coNWYjobh^;_oMgMgogMgMol;2`_m@D53o<c<c
ofi^K_n3Ph?o8B4QomkNg_oVi^KoonSXj1ooj>SX0Oo/k>`1oo;blP7om_Kf
00000oogmoOon?ShooShn003ooShn00CooOgmoo^k^koc/k>oi2@T?n5;b_o
jFAFoo^BQoonYY_oo[6UoongZ_on/jKooZRLooZDROo^J5WoRC4[oi2@T?o>
c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_P
K_onm8;oo_j:ooooT_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^
ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSo
c_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^ooOgm`3J
ooShn00UooKfm_oalO7oPH61oalO7oo]kNgoa/K6o`000?o3`l?odm?CoeaL
G?l820Soj^[Zoo3`l?oZj^[oDU9Boa@D5?lm?CgojNWYoo3`l?n_[joo1`L7
om;Bd_o=cLgoCTi>oa/K6oo^k^kofm_Kojj^[_oXj>Sok>c/ojj^[_l0003o
];Bdonc/k?n`/;3o2`/;oaXJ6P02onCTi00;ob<S8ol>3PkoY:BTong]kOo^
k^koH61PoeADE?o^k^kokNg]obHV9_n=SHd00_o`l?003?n2PX;o<C4aonc/
k?oZj^[o@d=3obl_;onLW9coLg=cobXZ:_lJ6Q[ok^k^ooKfmVoon?Sh00?o
moOgooShn?ohn?P01Oohn?P00oogmoOon?ShooShn02MooShn003ooOgmooh
n?Son?Sh00;on?Sh00ComoOgooWinOogmoOom_Kf0Oohn?P00003oo[jn_oe
mOGok^k^00;ok>c/0?oojn_[onWYjOoOgmoo^[ZjogQBD_no<RCoiW=Xoof9
O_ooUh_ooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<TogUBD_nj^[[ogmoO
on[Zj_o[jn_ok>c/on_[k?oZj^[ogmoOokZj^_n8IE;ohY4LooW3D?omfV?o
onYbookcO_oonX;oo_Ioooo/LoongVCon/MAon:B7?n9IU?o^[ZjomoOgooZ
j^[ojn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S7?nAdUGoY^MZokSi
N_o0oX;oaon9ol?nQ?nioG_oYna/oiCFEomBYQcoDVeBokZj^_oOgmooj^[Z
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jn`0
04Wok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojNWYonGUiOmjNW[o71`Lon7Qh_o<c<co
0`<3oj2PX?oNg]koU9BDoa<C4ooQhN7oh>3Qom3@d?l61PKoXJ6Qo`T92Ono
_koohN7QokZj^_l20P;o/[:bomgMgOn0P83o:2PXon?ShooWinOoiNGUomoO
gooKfm_odm?Co`P82?n5QHGogmoOofUYJOm:BT[o=CDeojf][Onm_Kgo1`L7
ogQhN?mEEEGogmoOon3Ph?mKFe_oD51@00;ohN7Q00[o92@TohF5QOoOgmoo
hN7Qog]kNol_;booh>3PomCDe?l51@GoZ:RX0_oShn<0oomnOWoo5QHFon7Q
hOoZj^[ojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>coj^[Zonc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on[Zjoo/k>cojn_[onc/k?o[jn_ok>c/on[Z
j_o/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[j`006_o/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/1_o[jn/01Oo/
k>cojn_[on_[joo^k^kom_Kf007onOWi00000ookno_olo?cong]k@02onGU
i@3oonKVi_oTi>CofMWIok:b/_mi;Rkob48con=ZG?odNVgooHQloojGR_on
VhkooYR;ooj:O_odNfgoif]MolY2=?mk;Rko/[:bomSHf?oTi>CoiNGUonKV
i_oUiNKoi>CTomSHf?nb/[;oUUD^onZL:ook_4Coo/aCoogHH_onhg;oo^Ue
ookVLoonffGooLaCoo_1AOo^WR_oVEH^ok:b/_oHf=Soi>CTonGUiOoVi^Ko
iNGUonCTi?oHf=Wo/[:bobiR;_mS[B_oQlY8oiOLFOnUiFWo/_=gokSfNond
mGWoYnY[oiSLFOn9cd_oHjh[obiS;_nb/[;of=SIonCTi?oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV000donKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVon?ShooOgmooMgMgoa/K6ooLg=cohN7QoijNW_l_;boo:b/[
oc8b<_lB4Q;og=cLom[Jfon4Q8Co820Pon3Ph?mBDU;oJ6QXom[Jf_oNg]ko
T92@obXZ:_l^;Rko;2`/obLW9`;og]kN01?ofMWIom?Ce?o@d=3oFe]Ko`00
0?nm_Kgof][JobPX:?n7QhOoMgMhofQXJ?n2PX;o?3`lol;2`_l?3`ooe=CD
om[Jf_mIFEWoCTi>00;og=cL00oo8b<Soh61POoEeMGoemOGogMgMol^;Rko
g=cLoj>SXol0003oalO7omSHf?oIfMWoSHf>oaDE5OoLg=`00_oTi>@0L?oV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oTi>@2onGU
i@2RonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGV0_oVi^H00ooUiNGoi^KVonKViP03onKV
iP03onGUiOo]kNgom?Cd007on_[j00000oolo?con?Shoo7al@03onk^kP0C
on_[jooQhN7o_;blogXG5oo3?c;odeI9onAXF_o_Mfcom8=iooN7O?oeQ7[o
lgU]onEYFooIF4[oa3lbog`G5onl_;cohN7Qonc/k003onk^kP0Conc/k?oQ
hN7o_;blojE75ooVUc;omJ``oofl@OombE?ooM1Poo_CIOomdV3oo/eDoofm
@_oj[c;ojI/bojE65onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;bl
oaMI5omOZ3;oM[dgohK=AonFeU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg_cOo
Gj/boaMI5onl_;cohN7Qonc/k03Jonk^kP0^onc/k?oWinOoNg]koa`L7?oT
i>CojNWYonKVi_oQhN7og]kNohf=SOlD51Coi^KVonCTi?le=CGoNGUion_[
jonb/[;o5ADEomoOgooVi^Koi>CTon7QhOoMgMgoNWYjobTY:OoXj>SoiNGU
omgMgOna/K7o9RHVo`/;2onKVi_ojNWYolc<c?l0003oc/k>ol?3`olU9BGo
Bd];ogalO?oXj>So<C4aojFUYOoTi>CoGEeMoe5AD@;oinOW00[o9BDUofUY
JOoOgmoogmoOogMgMola<C7ojNWYol71`Ol0003oYjNW0_oOgml01?nCTi?o
5QHFonOWioo/k>b/onk^kP03ong]kOo^k^kok^k^06kok^k^00?okNg]oo;b
l_ohn?P00Oolo?`000?ooOgm01Koo?cloogmoOomoOgoo?cloo?clooAdM7o
J0L7okPd=?o7?c?odU13omYREOoSKV;oi79TonA_H_oLI5Oode53ola1=?ni
=3CoJ`L7om;Bd_oclo?oo?cl0oomoOd04oolo?colo?com;Bd_nN:`OofXXd
on^K6OoeZ2Won;@oooVmB_oh_dgon[m:ooVh?oofZR[okihIom^;=?nR;@Oo
d];Boo?cloolo?`00oomoOd04oolo?colo?com;Bd_l7@0OoCIXdoen[8?m`
^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^BooHZhPodjK=?l7@POod];Boo?c
loolo?`0f_omoOd08ookno_omoOgohB4Q?lN7Qkolo?cooWinOnc/k?od=3@
oo?clomXJ6SoAdM7oo[jn_oDe=Co0000omgMgOolo?cono_kobLW9onXZ:So
nOWioj^[ZooEeMGolO7aoeADE?mNGUkonOWiooCdm?nDU9Co1@D5od10@?oA
dM7omoOgooShn?nGUiOo:b/[00;on_[j01_o92@To`L71oo8b<Sono_kohF5
QOmSHf?omoOgof=SHomGEeOon?ShooWinOlW9bOo5ADEoh>3PooGemOo@T92
of=SHookno_on_[joc@d=?m9BDWofm_KonGUiOm?Cdoo5aLGooWinOolo?`0
ooomoOdLoogmo@03ooclo?omoOgoo?cl00?ooOgm0000>_omoOgon_[joo?c
loo^k^kol?3`ono_koo^k^kojNWYom?CdomJ71coXS@dok@X7Oo1>BcoadTl
olmFB_o@Ed_od5M:olY:?_o3>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^ko
l?3`ono_koo`l>ook^k^on[Zj_oCdm?oS2DMolQa=?oIQ1goi9@EonNM9?o^
Z3?ol:XdonnZ<oo/X2GoiiLEomb87Oo8LCCoS2DMom?CdooZj^[ok^k^oo3`
l?o_knool?3`onk^k_oZj^Wodm?Coadh7OldPSCoAiDMoeZU6omY[BX2ogBh
>03RogFi>?m[/B_oFjLLodRJ7OldPSCo7CPMom?CdooZj^Wok^k^oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l0;okno_0>koj^[ZoginO_lL71coj>SWong]kOn8R8So<30`o`l?
3ola<C7o/K6aonk^k_n5QHCoCDe=ono_koo^k^kokno_ohZ:R_mIFEWok^k^
ogQhN?l[:b_o3`l?ocPh>?no_kookNg]onCTi?l>3PkoJFUYomoOgooShn?o
iNGUon_[jomQHF7oMgMgonk^k_o_knkoMWIfobHV9_o]kNgokno_olc<c?l/
;2coj^[Zofe]K?mRHV;ok>c/ong]kOlk>c_oTi>Cof9RH_l>3Pko=3@dolC4
a?o_knook^k^om7AdOll?3co2PX:obLW9om/K6co;2`/ono_koo^k^kol?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o^k^kol?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`0oo_knl0I?o`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knl2oo3`l0Kokno_0Ooclo<1ooWin@7o
o_kn00000oono_komoOgoo3`l004onWYj@0AonOWiooKfm_oHd];oh4b<_nV
=CGo]S@]ol9=@Oo3E4Woa5E:ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];om_K
fooWinL01OoYjNT04OoWinOofm_KohU;Bon_Bc;ocGLeomJ;;OoPW2koh:0b
on6P=?oPX3;ogiX^omJ;;Oo:MCGo[d/bohU;BooKfm_oinOW00GojNWY017o
inOWom_Kfom;Bd_o<V0bocZ9=OmCVbgoJj/_og2]>?m_[S[oL:dhofZZ;omC
Vbgo>HPeoc9P<_m;Bd_ofm_KonOWi`3KonWYj@06onSXj?oVi^KoNg]koa`L
7?oTi>Coj>SX0_oYjNT00ooWinOojNWYonWYj@0;onWYj@0<onOWiooYjNWo
jNWYonSXj?oHf=So2PX:ojj^[_oMgMgog]kNon3Ph?oUiNGoj>SX2?oYjNT0
1_oXj>Soi^KVon?ShooShn?oi^KVonSXj0?ojNWY00?oj>SXonWYjOoYjNT0
1?oYjNT00ooWinOojNWYonWYj@3oonWYjA_ojNWY00?oj>SXonWYjOoYjNT0
1?oYjNT1oo3`l07omoOg0Oono_h00005ookno_ojn_[om?Cdono_kooalO40
0_o`l?004Oo_knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZNW?oI
W9coe9FEok]cLonEE5CoCb<SoiFDU?oZj^[okno_00Gol?3`017okno_on[Z
j_nYU9CoPB<SokYZE?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYD
oh4S8onZU9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCo
LjEcoik6UOn/cYco[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Zj_o_
knl0foo`l?02ono_k`04oh20P?lM7Agok^k^ono_ka?ol?3`0_o_knl01omT
I6Co:BTYoh61POmSHf?o>c/konk^k_o_knl02?o`l?001_o_knook^k^og=c
LomYJFWok^k^ono_koool?3`;Oo`l?001?oalO7ol?3`ooCdm?ojn_X1ookn
oP0000Con?Wjooooooooooooo_kn0_ooool2ooknoP3ooogmoOohn?SoKVi^
oeXo?onaT93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSloofe]KOohn?So
o?clooooooono_koooooookno_ooookoo_knooooooolo?con?Shohe]KOn:
?coobI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo?on=KFgon?Sgoocl
o?ooooooo_knooooooono_koooooookno_ooookoo?clooShn?m]KFgo?clo
oi2MT?o9eLWoi>cTonK^i_oTk>CobMG9oi2MT?lo?cooKFe]ooShn?olo?co
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_kn000hooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooomoOgod=3@ojFUYOon
o_goo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
oogmoOo1`L3oLG5aoh61POn_[jl2ooknoP0<ooooooono_koooonookno_oo
ooooo_knooooooono_kooooooogmoOo2`/7o_;bl0_ono_h0ooooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooo`00:Oono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_kn00;ooooo00?oo_knooooooooool00oooool1oogmo@0000Co
h^GXookno_ojn_[om?Cd1OoalO403Oo_knooe]KFof][Jom3?CgoVhb<olJj
^_oFc<coakZjoi^<S?m3?CgoJf][omKFe_o_knl02OoalO403Oo_knooemKF
oh=[Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<S?mb?CgoPF][omOFe_o_knl0
2OoalO403Oo_knooe]KFof][Jolm?CgoS8b<okZj^_o<cLco^[Zjohb<S?lm
?CgoJf][omKFe_o_knl0oooalO7ooo7alCColO7a00Col?3`oo7alOoalO7o
l?3`1?oalO400oodm?Con_[jooknoP01ooGfmP0000GoYZfcoogmoOohn?So
l?3`on_[j`03on[ZjP0=onWYjOoZj^[ojNWYonSXj?nKVi_oFEUIobHV9_l9
2@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoX9^KofYI
FOm39RKo;@T9od8V9_mYFEWoX9^KonSXj?oYjNT02ooZj^X02ooYjNWoj>SX
oi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY0?ooj^[ZoooZ
j^Xlon[ZjP04on_[joo`l?3on?Shoogmo@7oiNKW00001?lmBE;ofmoRooWi
nOodm?@8oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`
3ooalO42oo3`l0?okno_0_o`l?3ooo7alOoolO7a>_oalO400oo`l?3olO7a
oo7al@02oo7al@03ooGemOojn_[on?Wi007o^kbm00000olI:COoGVI]omgP
hP3oooooooooooooO?ooool1oo[jn`7oaLK70Oo8bLX00006oa//>olG92ko
>T9:oj>Y[_oPhnGon?WiooooooooooooogKooooo00Gom_OgonCUi_o3aLKo
R8^=ohJ9R`01oiVMX000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[BoxData[{
    \(\(savedLayout = pane@getLayout[];\)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]\(pane@
          setLayout[\[IndentingNewLine]JavaNew["\<java.awt.GridLayout\>", 10, 
              3, 5, 5]\[IndentingNewLine]];\)\[IndentingNewLine]]\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(b1 = NewJRadioButton[pane, "\<Photon\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JRadioButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject93824063897601]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(b2 = NewJRadioButton[pane, "\<Electron\>", True]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JRadioButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject77727465996289]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(icon = 
      JavaNew["\<javax.swing.ImageIcon\>", 
        StringJoin[$JavaSwingMaterial, "\<NB(S).GIF\>"]]\), "\n", 
    \(iconWidth = icon@getIconWidth[]\), "\n", 
    \(iconHeight = icon@getIconHeight[]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject40192136183809]], "Output"],

Cell[BoxData[
    \(16\)], "Output"],

Cell[BoxData[
    \(16\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(icon2 = 
      JavaNew["\<javax.swing.ImageIcon\>", 
        StringJoin[$JavaSwingMaterial, "\<NB(S)2.GIF\>"]]\), "\
\[IndentingNewLine]", 
    \(iconWidth = icon2@getIconWidth[]\), "\n", 
    \(iconHeight = icon2@getIconHeight[]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject110149888901121]], "Output"],

Cell[BoxData[
    \(16\)], "Output"],

Cell[BoxData[
    \(16\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(b3 = NewJRadioButton[pane, "\<Neutrino\>", False, icon]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JRadioButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject39136043991041]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"],

Cell[BoxData[
    \(b3@setIcon[icon2]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(DeleteJObject[pane, b1]\), "\[IndentingNewLine]", 
    \(DeleteJObject[pane, b2]\), "\[IndentingNewLine]", 
    \(DeleteJObject[pane, b3]\)}], "Input"],

Cell[BoxData[{
    \(ReleaseObject[icon]\), "\n", 
    \(ReleaseObject[icon2]\)}], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["<<< SimpleJRadioButton >>>",
  FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002X0000J1P00`40o`00
0?l0003oZ000000000>8`;Q8T8Q8T8P0Y4R@R04000000003R<2hb>3HR<2h
0:>8`;P1B9280@00000000>8`;S8h=R8`;P0XhS0^058T8P10000000018S0
^<SPf8S0^8S0^:3<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hX<c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;RPc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^:3<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hX<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;RPc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^:3<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hX<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;RPc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^:3<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hX<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;RPc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^:3<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hX<c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;RPc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^:3<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hX<c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;RPc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^:3<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hX<c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;RPc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^:3<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hX<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;RPc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^:3<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
X<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;RPc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^:3<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2hX<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;RPc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^1?<c<`CVIW<N/c<c0:8`;P1B928
0@00000000J8`;S8h=R8`;R8`;SoojRa/EX7Q8@]00=iNB:4Q2f4Q2d00hB4
;@05_;aUc<c<c<c<c<c<VIW<017<c<`00iVIc<c<c<c<c01hc<c<0XS0^058
T8P1000000001hS0^<SPf8S0^8S0^?ooZ8B4;IZJ@`03YJE>00>JVT>UYDjU
YDh01JFUCP03NGTRgMf6c<c<00;<c<`00iVIc<c<c<c<c00?c<c<00>IVLc<
c<c<c<`0N<c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;SoojQiNB82
m?BM00SBdW^UYDk7ag3oojSdm9gYjI:UYDkYjI82m?BM00>UYDkMgHK<c<`0
0/c<c003VIW<c<c<c<c<00o<c<`00iVIc<c<c<c<c01hc<c<0XS0^058T8P1
000000002XS0^<SPf8S0^8S0^?ooZ7Ui8_ooZ?CdWJFUCUMiQP9iN@0028B4
;GUG8UMG5YYG@jFUC_ooZ:FUC];BN`?<c<`00iVIc<c<c<c<c00400000lc<
c0800003c<c<0P000003c<c<VIW<c<c<07W<c<`2R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hoonXYJE>0_CdW@0<VYY3EiZXEiZ6Q8@]NELRNGTRYJE>
NELR/K5Jm?BMVYY3gMf60lc<c004VIW<c<c<000000000/c<c0800002c<c<
0P0000;<c<`3000000?<c<bIVLc<c<`0NLc<c0:8`;P1B9280@00000000V8
`;S8h=R8`;R8`;SoojQiNB;dm9gYjI9RHP/00UNJZ009NIZ6KFdF/K5J_;aU
KFdFjNVBm?BMYJE>gMf600?<c<`00iVIc00000000004c<c<0P000003c<c<
0000000000;<c<`3000000?<c<bIVLc<c<`0NLc<c0:8`;P1B9280@000000
00Z8`;S8h=R8`;R8`;SoojQiNB;dm9eiNB9iEb9GE`/2KFdF00QGNB9iEb9R
E`1GE`1iNB;BdW^UYDkBdW/3c<c<00>IVL`0000000001<c<c08000001<c<
c00000000<c<c0@000000lc<c9VIc<c<c01ic<c<0XS0^058T8P100000000
1XS0^<SPf8S0^8S0^?ooZ:FUCP:JND<03:FUC[6aFYZJ@gUi05MiQUNJQWUG
@eMG09Yi@gUi8ZFUC]gMQP?<c<`00iVIc00000000004c<c<0P000006c<c<
00000000c<c<0000c<c<0P000003c<c<VIW<c<c<07W<c<`2R<2h0DR@R040
0000000=R<2hb>3HR<2hR<2hoonXQ8@]NELRgEN6VWU3VYY3HUL0_9X0gK`0
009GVXH2_5MU00?BdW^UYDkMgHH00lc<c003VIW<0000000000C<c<`20000
00?<c<`0000000000P000005c<c<00000000c<c<VIW<07[<c<`2R<2h0DR@
R04000000008R<2hb>3HR<2hR<2hoonXNGTRgMf6Q8@]0UMG000:NELRVYX0
omd0_9X0VUM3gENXVUM3VWU3YJE>d]9k0lc<c003VIW<0000000000C<c<`2
000000C<c<`0000000000002c<c<0P000003c<c<VIW<c<c<07W<c<`2R<2h
0DR@R04000000006R<2hb>3HR<2hR<2hoonXYJE>0_CdW@03KFdF_5MUVWU3
00:JEd<01gUG8[bJ069R2mgMQ_CdWJFUC]gMQP03c<c<00BIVLc<c<`00000
0002c<c<0P0000;<c<`300000/c<c08000000lc<c9VIc<c<c01ic<c<0XS0
^058T8P1000000002XS0^<SPf8S0^8S0^?ooZ8B4;OCdWKblIF9R2hB4;@;M
EhH01;aGIEMi@mfl0:FUCP;dm9d00jFUC]gMQ/c<c002c<c<00>IVLc<c<c<
c<`0100000?<c<`200000lc<c08000000lc<c9VIc<c<c01ic<c<0XS0^058
T8P1000000003HS0^<SPf8S0^8S0^?ooZ7Ui8_CdWJFUCWUi8YZJ@gUi8]eG
QXB4;@02EgU300FUYDkdm9gdm9fUYDkBdW/00lc<c003VIW<c<c<c<c<00o<
c<`00iVIc<c<c<c<c01hc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0
^?ooZ:FUCPCdm9d01];BNiYi@oooZ?CdWKblIK6aFP;dm9d00jFUC]gMQ/c<
c002c<c<00>IVLc<c<c<c<`03lc<c003VIW<c<c<c<c<07S<c<`2R<2h0DR@
R04000000007R<2hb>3HR<2hR<2hoonXNGTRoonX00_dm9d00jFUC]gMQ/c<
c002c<c<00>IVLc<c<c<c<`03lc<c003VIW<c<c<c<c<07S<c<`2R<2h0DR@
R04000000006R<2hb>3HR<2hR<2hoonXNGTR3JFUCP05oonXc<c<c<c<c<c<
VIW<017<c<`00iVIc<c<c<c<c01hc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^1?<c<`CVIW<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;RPc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^:3<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hX<c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;RPc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^:3<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hX<c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;RPc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^:3<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hX<c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;RPc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^:3<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hX<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;RPc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^:3<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
X<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;RPc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^:3<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2hX<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;RPc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^:3<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hX<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;RP
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^:3<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hX<c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;RPc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^:3<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hX<c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;RPc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^:3<
c<`2R<2h0DR@R04000000003R<2hb>3HR<2h0:>8`;P1B9280@00000000B8
`;S8h=R8`;R8`;PC002005L00X0018401X8128812X<138@13XD248D24XH2
58L25XL368P36XT378X47XX488/48X`498d59Xd5:8h5:Xl5;8l6;i06<I46
<i87=I87=i<7>I@7>iD8?ID8?iH8@IL8@iL9AIP9AiT9BIX:BiX:CI/:Ci`:
DId;Did;EIh;Eil;FIl<G:0<GZ4<H:8=HZ8=I:<=IZ@=J:D>JZD>K:H>KZL>
L:L?LZP?M:T?MZX@N:X@NZ/@O:`@OZdAP:dAPZhAQ:lAQZlBRK0BRk4BSK8C
Sk8CTK<CTk@CUKDDUkDDVKHDVkLDWKLEWkPEXKTEXkXFYKXFYk/FZK`FZkdG
[KdG[khG/Kl0=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P40020
00>KYo4c@jDc@jD02C=3Y@<00800E`02P004P@06PP48PP4:P`4<Q04>Q@8@
Q@8BQP8DQ`8FQ`<HR0<JR@<LRP@NRP@PR`@RS0@TS@DVS@DXSPDZS`D/S`H_
T0HaT@HcTPLeTPLgT`LiU0LkU@PmU@PoUPQ1U`Q3U`U5V0U7V@U9VPY;VPY=
V`Y?W0YAW@]CW@]EWP]GW`]IW`aLX0aNX@aPXPeRXPeTX`eVY0eXY@iZY@i/
YPi^Y`i`Y`mbZ0mdZ@mfZQ1hZQ1jZa1l[11n[A60[A62[Q64[a66[a:9/1:;
/A:=/Q>?/Q>A/a>C]1>E]ABG]ABI]QBK]aBM]aFO^1FQ^AFS^QJU^QJW^aJY
_1J[_AN]_AN__QNa_`0f6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0<008001i^WlOooohij]ZJKa;>YdZRMb;>YdP02YY_400Fl^=g^k_CZjO7o
oolc@jD00P00P01G00:000B100J20@R20@Z30@b40@j50Q250Q:60QB70QJ7
0aR80aZ90ab:11j:122;12:<12B=1BJ=1BR>1BZ?1Bb?1Rn@1S6A1S>B1cFB
1cNC1cVD1c^E23fE23nF246G24>G2DFH2DNI2DVJ2T^J2TfK2TnL2U6M2e>M
2eFN2eNO2eVO35bP35jQ362R3F:R3FBS3FJT3FRU3VZU3VbV3VjW3W2W3g:X
3gBY3gJZ47RZ47Z[47b/47j]4H2]4H:^4HB_4HJ_4XV`4X^a4Xfb4hnb4i6c
4i>d4iFe59Ne59Vf59^g59fg5Inh5J6i5J>j5ZFj5ZNk5ZVl5Z^m5jfm5jnn
5k6o008H]<0P00000QRd`10000026;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^080080019^WlOooofaJYJnUbP:l^=d0H_omok>Yd_oooooookbh
gIN:_:RMb>KVk?oooc=3Y@00P002P004P@06PP48PP4:P`4<Q04>Q@8@Q@8B
QP8DQ`8FQ`<HR0<JR@<LRP@NRP@PR`@RS0@TS@DVS@DXSPDZS`D/S`H_T0Ha
T@HcTPLeTPLgT`LiU0LkU@PmU@PoUPQ1U`Q3U`U5V0U7V@U9VPY;VPY=V`Y?
W0YAW@]CW@]EWP]GW`]IW`aLX0aNX@aPXPeRXPeTX`eVY0eXY@iZY@i/YPi^
Y`i`Y`mbZ0mdZ@mfZQ1hZQ1jZa1l[11n[A60[A62[Q64[a66[a:9/1:;/A:=
/Q>?/Q>A/a>C]1>E]ABG]ABI]QBK]aBM]aFO^1FQ^AFS^QJU^QJW^aJY_1J[
_AN]_AN__QNa_`8H]<000lSPf4R@R4R@R00<B92800<00038h=Q8T8P03DR@
R00400006;C06;C0b>3H3TR@R00300006;C06;C000:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2002000^KYo7ooonXWLSoooncZM9PC9Z>N[IhIJjX
WLSooooooOl00oooo`1J<d>U0020002000:000B100J20@R20@Z30@b40@j5
0Q250Q:60QB70QJ70aR80aZ90ab:11j:122;12:<12B=1BJ=1BR>1BZ?1Bb?
1Rn@1S6A1S>B1cFB1cNC1cVD1c^E23fE23nF246G24>G2DFH2DNI2DVJ2T^J
2TfK2TnL2U6M2e>M2eFN2eNO2eVO35bP35jQ362R3F:R3FBS3FJT3FRU3VZU
3VbV3VjW3W2W3g:X3gBY3gJZ47RZ47Z[47b/47j]4H2]4H:^4HB_4HJ_4XV`
4X^a4Xfb4hnb4i6c4i>d4iFe59Ne59Vf59^g59fg5Inh5J6i5J>j5ZFj5ZNk
5ZVl5Z^m5jfm5jnn5k6o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SP
f00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^08008003Y^WlOooooooom_Lk61<
VY>5^[>Yd[bhgF1<VYV?_ZJKa<S3gooooc=3Y@<008002`02P004POooo`48
PP4:P`4<Q04>Q@8@QOooo`8DQ`8FQ`04oooo00d488/48X`498goool5:8ko
ool5;8l6;i06<I7oool7=I87=i<7>I@00oooo`0>246G24>G2DFHoooo2DVJ
2T^J2TfK2TnL2U6Moooo2eFN2eNO2eVO35bP1?ooo`0;3FJT3FRUoooo3VbV
3VjWoooo3g:X3gBYoooo47RZ47Z[00?oool06162[Q64[a66[a:9/1:;/A:=
/Q>?/Q>A/a>C]1>E]ABG]ABI]QBK]aBM]aFO^1FQ^AFS^QJU^QJW^aJY_1J[
_AN]_AN__QNa_`8H]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P00038
h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B9280000
6;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008003Y^WlOoo
okbhgIV?__ooomKAgM_Lk??nojJKa>k^m8Ef/9>5^_oooc=3Y@800800E`02
P004POooo`48PP4:Poooo`4>Q@8@QOooo`8DQoooo`<HR0<JR@<LR_ooo`@P
R`@RS?ooo`DVS@DXS_ooo`D/S`H_T0HaTOooo`LeTPLgToooo`LkU@PmU@Po
U_ooo`Q3U`U5V?ooo`U9VPY;VPY=V`Y?W0YAWOooo`]EWP]GW`]IWoooo`aN
X@aPXPeRX_ooo`eVY0eXYOooo`i/YPi^Yoooo`mbZ0mdZOoooa1hZ_oooa1l
[11n[A60[Ooooa64[a66[a:9/1:;/A:=/Q>?/Q>A/a>C]1>E]ABG]ABI]QBK
]aBM]aFO^1FQ^AFS^QJU^QJW^aJY_1J[_AN]_AN__QNa_`026;C000C8h=R8
`;R8`;R8`;P6000018S0^003B9280000b>3H00:8`;P00`0008S0^8S0^005
R<2h00D00028`;R8`;Q8T8P000000QRd`004b>3HR<2hR<2hR<2h0P0000B8
`;P200000XS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0<00800Ii^WlOoooiV?_YN:_=CCj>n//omfNnjOZe]HYJJKa9JO
dV1<V[bhgOoooc=3Y@00P002P004POooo`48PP4:Poooo`4>Q@8@QOooo`8D
Qoooo`<HR0<JR@<LR_ooo`@PR`@RS?ooo`DVS@DXS_ooo`D/S`H_T0HaTOoo
o`LeTPLgToooo`LkU@PmU@PoU_ooo`Q3U`U5V?ooo`U9VPY;VPY=V`Y?W0YA
WOooo`]EWP]GW`]IWoooo`aNX@aPXPeRX_ooo`eVY0eXYOooo`i/YPi^Yooo
o`mbZ0mdZOoooa1hZ_oooa1l[11n[A60[A62[Q64[a66[a:9/1:;/A:=/Q>?
/Q>A/a>C]1>E]ABG]ABI]QBK]aBM]aFO^1FQ^AFS^QJU^QJW^aJY_1J[_AN]
_AN__QNa_`026;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P0
0`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2h
R<2h00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOXZFjP
b<?OThFjFdJCVHnn0WQU[P0@@RN5[jG:oooo<d>U002000:000B1oooo0@R2
oooo0@b4oooo0Q25oooo0QB70QJ71?ooo`0N122;12:<oooo1BJ=1BR>oooo
1Bb?1Rn@1S6Aoooo1cFB1cNC1cVD1c^E23fE23nFoooo24>G2DFHoooo2DVJ
2T^J2TfK2TnL2U6Moooo2eFN2eNO2eVO35bP1?ooo`0:3FJT3FRUoooo3VbV
3VjWoooo3g:X3gBYoooo47RZ1Oooo`0G4HB_4HJ_4XV`4X^a4Xfb4hnb4i6c
4i>d4iFe59Ne59Vf59^g59fg5Inh5J6i5J>j5ZFj5ZNk5ZVl5Z^m5jfm5jnn
5k6o008H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000
R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P0
0hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0P00P003VjOaoooooooo00;oool02_n]/?mfNoW=e?g]k_oo
ojJKa8Ef/;bhgOoooc=3Y@8008005002P004POooo`48P_ooo`4<Q?ooo`8@
QOooo`8DQ`8FQ`<HR0<JR@<LR_ooo`@PR`@RS?ooo`DVS@DXSP;oool030H_
T0HaTOooo`LeTPLgT`LiU0LkU@PmU@PoU_ooo`Q3U`U5V0Coool03@Y?W0YA
WOooooooo`]GW`]IW`aLX0aNX@aPXPeRX_ooo`eVY0eXY@02oooo028>KZOo
ooooool?M:Woool@N:[oool@O:`@OZdAP:gooolAQ:lAQZlBRK0BRk4BSK8C
Sk8CTK<CTk@CUKDDUkDDVKHDVkLDWKLEWkPEXKTEXkXFYKXFYk/FZK`FZkdG
[KdG[khG/Kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P0
0`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2h
R<2h00B8`;P200001HS0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0<008002Z6/l_W=e>8V??Be_n8V??A]OOcSjOoooog]
k_n]/0;oool03c=3Y@00P000P000P002P004POooo`48P_ooo`4<Q?ooo`8@
QOooo`8DQ`8FQ`03oooo00<47XX488_oool00_ooo`031BR>oooo1Bb?00;o
ool05@HcTPLeTPLgT`LiU0LkU@PmU@PoU_ooo`Q3U`U5V?ooo`U9VPY;VPY=
V`Y?W0YAWOooo`]EW_ooo`]IW`aLX003oooo00D=I:<=IZ@=J:Goool>K:H0
0_ooo`053g:Xoooo3gJZ47RZ47Z[00?oool06162[Q64[a66[a:9/1:;/A:=
/Q>?/Q>A/a>C]1>E]ABG]ABI]QBK]aBM]aFO^1FQ^AFS^QJU^QJW^aJY_1J[
_AN]_AN__QNa_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0
^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8
`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0P00P00=VjOaoNg^hRHlo_GhmhVGm69^lj2^m69^
oogoojf`o>?Yoooo<d>U00@008001`02P004POooooooo`4:P`4<Q04>Q@02
oooo04h258L25XL368P36XT378X47XX488/48Xcoool59Xd5:8koool5;8l6
;i06<I46<i87=I87=i<7>I@7>iD8?ID8?iKoool8@iL9AISoool9BIX:BiX:
CI/:Ci`:DId;Did;EIh;Eil;FIl<G:0<GZ4<H:8=HZ8=I:<=IZ@=J:D>JZD>
K:H>KZL>L:L?LZP?M:T?MZX@N:X@NZ/@O:`@OZdAP:dAPZhAQ:lAQZlBRK0B
Rk4BSK8CSk8CTK<CTk@CUKDDUkDDVKHDVkLDWKLEWkPEXKTEXkXFYKXFYk/F
ZK`FZkdG[KdG[khG/Kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H
00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003
b>3HR<2hR<2h00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOam/S<hRHl00;o
[K001mlT;_nTW_JlaOn]/>ikS?oooc=3Y@05002000L00X00187oooooool1
2X<138@13XD00_ooo`1>0QB70QJ70aR80aZ90ab:11j:122;12:<oooo1BJ=
1BR>oooo1Bb?1Rn@1S6A1S>B1cFB1cNC1cVD1c^E23fE23nFoooo24>G2DFH
oooo2DVJ2T^J2TfK2TnL2U6M2e>M2eFN2eNO2eVO35bP35jQ362R3F:R3FBS
3FJT3FRU3VZU3VbV3VjW3W2W3g:X3gBY3gJZ47RZ47Z[47b/47j]4H2]4H:^
4HB_4HJ_4XV`4X^a4Xfb4hnb4i6c4i>d4iFe59Ne59Vf59^g59fg5Inh5J6i
5J>j5ZFj5ZNk5ZVl5Z^m5jfm5jnn5k6o0QRd`003b>3HR<2hR<2h00^8`;P0
0dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf003R<2h
0P0000B8`;P200000XS0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008000i^WlOW=e?N9U`02oooo00Oo[K3Q5SCoMW_o
Y9kR9ScoRGlc@jD01@00P00R00:000B1oooo0@R20@Z30@b40@j50Q25oooo
0QB70QJ70aR80aZ90ab:11j:122;12:<12B=1BJ=1BR>oooo1Bb?1Rn@1S6A
1S>B1cFB1cNC1cVD1c^E23fE23nFoooo24>G2DFH1Oooo`0`2U6M2e>M2eFN
2eNO2eVO35bP35jQ362R3F:R3FBS3FJT3FRU3VZU3VbV3VjW3W2W3g:X3gBY
3gJZ47RZ47Z[47b/47j]4H2]4H:^4HB_4HJ_4XV`4X^a4Xfb4hnb4i6c4i>d
4iFe59Ne59Vf59^g59fg5Inh5J6i5J>j5ZFj5ZNk5ZVl5Z^m5jfm5jnn5k6o
0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h2@0000:8`;P0
1DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0P00P007VjOaoooolj2^m69^oooomhVGnLgD
00;oool00o>P[_oooc=3Y@05002005L00X0018401X8128812X<138@13XD2
48D24XH258L25XL368P36XT378X47XX488/48X`498d59Xd5:8h5:Xl5;8l6
;i06<I46<i87=I87=i<7>I@7>iD8?ID8?iH8@IL8@iL9AIP9AiT9BIX:BiX:
CI/:Ci`:DId;Did;EIh;Eil;FIl<G:0<GZ4<H:8=HZ8=I:<=IZ@=J:D>JZD>
K:H>KZL>L:L?LZP?M:T?MZX@N:X@NZ/@O:`@OZdAP:dAPZhAQ:lAQZlBRK0B
Rk4BSK8CSk8CTK<CTk@CUKDDUkDDVKHDVkLDWKLEWkPEXKTEXkXFYKXFYk/F
ZK`FZkdG[KdG[khG/Kl00QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SP
f00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0<008002i^WlOoooon9Oooooo>P
[_6CXOooooomoo>P[_oko3=3Y@05002005L00X0018401X8128812X<138@1
3XD248D24XH258L25XL368P36XT378X47XX488/48X`498d59Xd5:8h5:Xl5
;8l6;i06<I46<i87=I87=i<7>I@7>iD8?ID8?iH8@IL8@iL9AIP9AiT9BIX:
BiX:CI/:Ci`:DId;Did;EIh;Eil;FIl<G:0<GZ4<H:8=HZ8=I:<=IZ@=J:D>
JZD>K:H>KZL>L:L?LZP?M:T?MZX@N:X@NZ/@O:`@OZdAP:dAPZhAQ:lAQZlB
RK0BRk4BSK8CSk8CTK<CTk@CUKDDUkDDVKHDVkLDWKLEWkPEXKTEXkXFYKXF
Yk/FZK`FZkdG[KdG[khG/Kl00QRd`0o8h=P00`000<SPf<SPf00=b>3H00<0
000H]<0H]<003lSPf00300006;C06;C000:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P400200i^Wl@06oooolj2^m;Fom[c5nmWJ<d>U1P00P01G00:0
00B100J20@R20@Z30@b40@j50Q250Q:60QB70QJ70aR80aZ90ab:11j:122;
12:<12B=1BJ=1BR>1BZ?1Bb?1Rn@1S6A1S>B1cFB1cNC1cVD1c^E23fE23nF
246G24>G2DFH2DNI2DVJ2T^J2TfK2TnL2U6M2e>M2eFN2eNO2eVO35bP35jQ
362R3F:R3FBS3FJT3FRU3VZU3VbV3VjW3W2W3g:X3gBY3gJZ47RZ47Z[47b/
47j]4H2]4H:^4HB_4HJ_4XV`4X^a4Xfb4hnb4i6c4i>d4iFe59Ne59Vf59^g
59fg5Inh5J6i5J>j5ZFj5ZNk5ZVl5Z^m5jfm5jnn5k6o03HH]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h4`00P01G00:000B100J20@R20@Z30@b4
0@j50Q250Q:60QB70QJ70aR80aZ90ab:11j:122;12:<12B=1BJ=1BR>1BZ?
1Bb?1Rn@1S6A1S>B1cFB1cNC1cVD1c^E23fE23nF246G24>G2DFH2DNI2DVJ
2T^J2TfK2TnL2U6M2e>M2eFN2eNO2eVO35bP35jQ362R3F:R3FBS3FJT3FRU
3VZU3VbV3VjW3W2W3g:X3gBY3gJZ47RZ47Z[47b/47j]4H2]4H:^4HB_4HJ_
4XV`4X^a4Xfb4hnb4i6c4i>d4iFe59Ne59Vf59^g59fg5Inh5J6i5J>j5ZFj
5ZNk5ZVl5Z^m5jfm5jnn5k6o03HH]<02R<2h0DR@R04000000003R<2hb>3H
R<2h0:>8`;P1B9280@00000000>8`;S8h=R8`;P0XhS0^058T8P100000000
0hS0^<SPf<SPf02Sb>3H0DR@R04000000:N8`;P100000000\
\>"], "Graphics",
  ImageSize->{168, 104},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004/0000b2000`400?l0
0000o`00003oooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000
ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`
l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]
oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`
l?0]oo3`l000ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00
ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKV
iP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]
onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooV
i^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00
oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^
kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]
onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^
k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00
ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]oooo
o`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]
ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00oooo
ool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00
ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^
kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]
onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^
k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00
ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKV
iP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]
onKViP00ooo^k^h]onk^kP00ooooool]ooooo`005?o^k^hGogj]fOook^k^
0_o^k^h00003ooooZ?na/E[oQ8@]00KoQ8@]00?oNGTRohB4;On4Q2d00on4
Q2d00onl_6Goi^KVonKViP02onKViP03ogj]fOoVi^Koi^KV01?oi^KV00?o
OZgIonKVi_oVi^H0oooVi^H00003ooooZ?n4Q2goVYY300?oYJE>00?oVYY3
ojFUC_nUYDh01OnUYDh00omiNB;ogMf6onk^kP03onk^kP03ogj]fOo^k^ko
k^k^01?ok^k^00?oOZgIonk^k_o^k^h0ooo^k^h0000<ooooZ?miNB;om?BM
ooCdWOoBdW_oYJE>olO7L?ooojSom?BMonWYT_nUYDkojNVB0_odm9d00onU
YDkogMf6ooooo`03ooooo`07ogj]fOooooooooooookno_oLg=cofm_Kookn
oP0?ooooo`03ogj]fOoooooooooo0?oooooo00001_ooojSoNGTRooooZ?od
m9goYJE>oeMiQP;oNGT000SoQ8@]ogUG8_mGEaKoVUM3ojFUC_ooojSoYJE>
om;BN`Cok^k^00WoOZgIonk^k_nIVIWo410@oadM7OlP823o3@d=ohR8R?o]
kNd00_o^k^h00olb<S;oVYZJonk^kP02onk^kP03okBd]?l0003oT92@00?o
k^k^00?oOZgIonk^k_o^k^h0ooo^k^h0000@ooooZ?nUYDkom?BMooCdWOnJ
VT?oEiZXoeNJQ_n4Q2goNELRogUi8_nUYDkoNELRok6aF_odm9goVYY3omgM
QPCoi^KV00CoOZgIoi>CTol92@WoYJFU0_oVi^H00onc/k?o4Q8BogUiN@02
onKViP08oc0`<?nDU9Coi^KVonKVi_oMgMgo8B4Qo`000?n;Rh/3onKViP03
ogj]fOoVi^Koi^KV0?ooi^KV00001OooojSoNGTRooCdWOoYjI;oHV8;00;o
EiZX00WoNIZ6ofe]5_na/E[o_;aUofe]5_oYjI;om?BMojFUC_oMgHH01?o^
k^h00omn[MWo6ATIodi>CP04onk^kP06ohR8R?l;2`_ogMgMonk^k_lb<S;o
VYZJ0_o^k^h01?m]KFgo4A4AobPX:?n@T903onk^kP03ogj]fOo^k^kok^k^
0?ook^k^00001_ooojSoNGTRooCdWOmiNB;oNELRoeMG2`;oKFdF00SoEgTR
ogUG8_mRE`3oEeL0ogUi8_oBdW_oYJE>om;BN`Cooooo00?oOZgIo`000?nI
VIT01?ooool03?oRh^;o0000ok^k^ooooooo=SHfojFUYOoooooob/[:o`<3
0onSXj?o?clooi^KV`?ooooo00?oOZgIooooooooool0ooooool0000@oooo
Z?nUYDkoVWU3oiYi@onUYDko/K5JoiZJ@omiN@3oEgV6oeNJQ_miEd?oEeL0
oiYi@omiNB;oYJE>omgMQPCok^k^00?oOZgIo`000?o:b/X01?o^k^h03?oZ
j^[o0000ohj>S_o^k^ko<S8boiZJV_oYjNWo:BTYodE5AOo^k^ko>SXjoi2@
T0?ok^k^00?oOZgIonk^k_o^k^h0ooo^k^h00009ooooZ?n4Q2goNELRomeG
Q_nJND?oVYY3of9G0?nlVP3ogK`000;oEiZ60_nlEfD00ooBdW_oYJE>omgM
QP04onKViP03ogj]fOl0003o_kno00Coi^KV00co_;blo`000?nJVY[oi^KV
oc0`<?nDU9CoLg=co``<3?o<c<coi^KVocPh>?n;Rh/3onKViP03ogj]fOoV
i^Koi^KV0?ooi^KV00001?ooojSoNGTRomgMQ_n4Q2d2oeMG000:ogUG8_nJ
VP3oomd0okbJ0?nJEd?ogENXoiYG@onJND?oYJE>om;BN`Cok^k^00?oOZgI
o`820_nGUiL01?o^k^h02?n0P83o0000olO7aoo^k^ko<S8bog1`L?l410Co
S8b<0_o^k^h00olj>S[oT92@onk^kP02onk^kP03ogj]fOo^k^kok^k^0?oo
k^k^00001oooojSoYJE>ooCdWOodm9goKFdFokaGIOnJND<00_nJEd<01omi
Eb;o_9X0of9R2ooMgHKom?BMojFUC_oMgHH01?ooool01?mn[MWoIfMWob`/
;?obl_82ooooo`03ooWinOlg=cOoC4a<00;ooooo00?o=SHfo`D51Om0@400
0oooool00olo?cooVi^Kooooo`02ooooo`03ogj]fOoooooooooo0?oooooo
00001_ooojSoQ8@]ooCdWOnl_6GoHV8;ohB4;@;ogEN600Co_5MUoeMi@ooM
_03oYJE>0_odm9d00onUYDkogMf6onk^kP03onk^kP09ogj]fOoMgMgo?Cdm
obHV9_mkNg_oP820oc0`<?l^;Rkod];B00;ok^k^00?o<S8bo`P82?o=cLd0
0oo^k^h00olj>S[oT92@onk^kP02onk^kP03ogj]fOo^k^kok^k^0?ook^k^
00002OooojSoNGTRooCdWOnUYDkoNGTRoiZJ@omiNB;ogEN6ohB4;@02oeMi
@`05ojFUC_odm9gom?BMojFUC_oBdW/01?oVi^H02?mn[MWoi^KVonCTi?nL
W9coKFe]ofQXJ?nDU9Coh>3P0ooVi^H00onNWYkoZj^[onKViP03onKViP03
oj:RX_o2`/;oi^KV00;oi^KV00?oOZgIonKVi_oVi^H0oooVi^H00003oooo
Z?nUYDkom?BM00?om?BM00Kod]9koiYi@oooojSom?BMokblIOna/EX2ooCd
W@03ojFUC_oMgHKok^k^00?ok^k^00?oOZgIonk^k_o^k^h04oo^k^h00omn
[MWok^k^onk^kP3oonk^kP0000?ooonXogUi8_ooojP02oodm9d00onUYDko
gMf6ooooo`03ooooo`03ogj]fOoooooooooo01?ooooo00?oOZgIoooooooo
ool0ooooool00003ooooZ?miNB;oYJE>00coYJE>00?ooonXonk^k_o^k^h0
0_o^k^h00omn[MWok^k^onk^kP0Conk^kP03ogj]fOo^k^kok^k^0?ook^k^
000DonKViQOoOZgIoooVi^H2onKViP00ooo^k^h]onk^kP00ooooool]oooo
o`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]
ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00oooo
ool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00
ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^
kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]
onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^
k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00
ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKV
iP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]
onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooV
i^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00
oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^
kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]
onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^
k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00
ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]oooo
o`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]
ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00oooo
ool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00oomoOgl]ogmoO`00
00Cojn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP22omgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomgMg@;og=cL097ofm_KomgMgOoLg=cogMgMomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgM00?og]kN00?ogMgMomkNg_oNg]h00ooMgMd1on7Qh@7o
inOW0OoZj^X00003onc/k?oVi^Koh>3P00OofMWI00Cof=SHomKFe_oCdm?o
d=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?C
om3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?C
doo@d=03olg=c@04om3@d?oCdm?oemOGomSHf3cofMWI0_oHf=P00ooIfMWo
f=SHomSHf003omWIf@;of=SH1OoIfMT00ooHf=Soe]KFom?Cd`02om?Cd`03
omKFe_oHf=Sof=SH00kofMWI00Cof=SHomWIfOoIfMWof=SH4?oIfMT2omSH
f6SofMWI00?of=SHomWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007
onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=co
dm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09
on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7
aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:b
ojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`0]on7Qh@[oh>3P00?ogmoO
on3Ph?oPh>001_oOgml2on3Ph0?ogmoO1OoPh>001ooOgmoofm_KomOGeooD
e=CoeMGEomWIfOoMgMd00_oPh>000ooOgmooh>3Pon3Ph002on7Qh@Ooh>3P
1_oOgml00ooPh>3ogmoOon3Ph00;on3Ph004omoOgooNg]kog]kNomoOg`;o
h>3PIooQhN400ooRh^;ohN7Qon;RhP04on7Qh@7oi>CT0OoYjNT1ong]k@00
00?ol?3`ono_kooalO400oo`l?00J_o_knool?3`onk^k_oYjNWofm_Kol71
`OnTY:CoS8b<og]kNomgMgOoNg]kohb<S?nTY:Co`/;1om[Jf_oZj^[okNg]
oo7alOo_knoolO7aono_kooalNookno_oo7alOo]kNgoj^[Zom[Jf_o2`/;o
Y:BTohb<RomkNg_oMgMgog]kNon<S8coY:BTol;2`_oJf][oj^[Xong]kOoa
lO7okno_oo7alOo_knoolO7aono_kooalNookNg]on[Zj_oJf][o`/;2ojBT
Y?n<S8coNg]kogMgM_mkNg_oS8b<ojBTY?o2`/;of][Jon[Zj_o]kNgolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_koo`l?02onc/
k007on_[joo^k^cok>c/ong]kOo/k>cok^k^on[ZjP02on_[j`0:onk^k?oY
jNWoj>SXonKVi_oYjNWoi^KVon[Zj_o[jn_okNg[onSXj0;ojNWY00OokNg]
on[Zj_o/k>cok>c/ono_kOoZj^[oj>SX00;ohn?S00gogmoOon?ShooXj>So
kNg[on[Zj_o[jn_ok>c/oo3`l?o_knool?3`ong]kOo/k>[oj^[Z00;ok^k^
00Kokno_on[Zj_oYjNWoi^KVonSXi_oWinL2onWYj@06onc/k?oYjNWok>c/
ong]kOo^k^coj^[Z0_o/k>`02?o^k^koj^[Zonc/k?o/k>cokno]on_[jooY
jNWoi^KV0_oXj>P2ong]k@1]oo3`k_o_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7ol?3`ono_koo`l?3okno_oo3`l?o_knool?3`
ono_k`04oo3`l00000?ol_;bonk^k_oWinL01?oUiND04?oTi>CogmoOom7A
dOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RXWo/K6a
om7AdOoNg]h2onCTi003onGUiOoTi>CoiNGT00;oi>CT00oog]kNom7AdOna
/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6aom7A
d?oNg]h00_oTi>@0@_oUiNGoi>CTonGUiOoTi>Coi>CSomkNg_oAdM7o/K6a
ohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM7o
g]kNonCThooTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
hn?SomkNgP;ofm_K00[og]kMomcLg?oKfm_og=cLomoOgooKfm_ofMWIomcL
g?oMgMcoemOG0ooEeMD01?oDe=CofMWIomgMgOoMgM`2omOGe`0Bom_KfooM
gMgof][Jom[Jf_oNg]kohN7Pom_KfooHf=SoATI6oc0`<?mhN7So`/;2om[J
f_oNg]gof][JomWIfOoMgMgohn?S0_oTi>@05_oOgmoog=cKomWIfOoOgmoo
h^;Ron7QhOoKfm_oe]KFomCDe?oFe]Goe=CDomKFe_oKfm_og=cLomSHf?oL
g=cogmoOomoOg_oIfMWofm_KomkNg_oOgml2om[JfP1_omgMgOoPh=oofm_K
omOGeooEeMGoemOGomWIfOoOgmooh^;RonCThooTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT00CoiNGU00Koi>CTonGUiOoU
iNGoiNGUonSXj?o]kNd1oo;blP0000?om?Cdong]kOoWinL00_oPh>004ooQ
hN7ogmoOomkNg_oBd];o];BdohN7QomLG5coKC/eoii>@_o=KeoojH=_ole_
GonNCT?oKC/foeaLG?n7QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];B
okBd]?n7QhOoG5aLofeP;?nNURkocLdoonWYCOo=cCooWYX_ofeS;OmLG5co
QhN7okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m7
IbkoJ9hcoi7=AonZjEGoTLe7ofZN=?m9JRooG5aLohN7Qond];Cod];BomkN
gP0[on3Ph013omkNg_oHf=Sod];BomCDe?oFe]Kod];Bolo?cooBd];oe]KF
om?CdooAdM7oeMGEomKFe_o@d=3oa<C4ol_;boo?cloobLW9olC4a?oHf=So
eMGEom3@d?o4a<Cod=3@omSHf?oBd];odM7AomSHf?oKfm_oe]KFom7AdOnE
UIGoX:2Pochn?_m;Bd_oe=CDomSHf?oBd];odM7AomSHf?oNg]koh>3PomoO
gooJf][odm?Com7AdOoHf=SogMgMom[Jf_oCdm?oclo?ol30`?o@d=3ocLg=
okno_ooDe=Coe]KFom7AdOoDe=CofMWIomSHf?oAdM7od];BomSHf?oIfMWo
dm?Com7Ad@02omOGe`08om7AdOo?cloob<S8olC4a?oHf=Sofm_KomkNg_oO
gmmTon3Ph003omoOgooPh>3ogmoO00;ogmoO0ooPh>000ooQhN7oinOWonc/
k001ooCdm00000?om_Kfoo;bl_o[jn/00ooXj>P04ooWinOoh^;Rolg=cOnO
WiooJemOohlf;_o]LF7onIf@oofaYOom_:oooKBWooVOToo]M6?oTSL_of]O
GonOWioocLg=on;Rh_oWinL00ooXj>P04ooWinOoh^;Rolg=cOnOWiooKVIO
oi=b8_o]dDConO=doogmSOomoIGooOf>ooWhM_o]edOoTg<RofiWGonOWioo
cLg=on;Rh_oWinL00ooXj>P04ooWinOoh^;Rolg=cOnOWiooH6QOod]l8onB
hD_o_OUkom3mT_oHoI_oe?fEol3iO_nHj4goCH0Tof1YGonOWioocLg=on;R
h_oWinL0:_oXj>P0:OoVi^KogmoOoc0`<?n?Shoofm_KolO7aon8R8SoaLG5
om_KfonUYJGo0@41omgMgOoNg]koKFe]o`P82?lA4A7oLg=coc0`<?lT92Co
gMgMom_Kfom;Bd_o30`<of9RH_oQhN7oKFe]ocXj>_oOgmoohn?Sol?3`ol0
003o`L71on7QhOnPX:3o3@d=omOGeooNg]koOGemoaLG5ooMgMgoi>CT00;o
i^KV01Coh^;RogmoOolX:2SogmoOonGUiOoShn?o][JfoalO7ol92@Wo=SHf
ogAdM?l820SoUYJFomgMgOl?3`ooUiNGon7QhOoOgmoo@T92ofATI0;oh>3P
00coMGEeoc8b<_oMgMgofm_Kokjn__ll?3co0P82oalO7olE5AGo];BdonKV
i_oWinM]onSXj07ok>c/0Oobl_81ooKfmP0000?omoOgooShn?ohn?P00ooh
n?P04oogmoOok^k^olk>c_n@T93oQBl[onUTE_okTXOooZJKoojaYOoo^:_o
o[>VoojXW?okU8WokVQIohTa:on@T93oc/k>onk^k_ogmoL00oohn?P04oog
moOok^k^olk>c_n@T93oVFT[oo2m?Ookh6koo_B2ooknR_oooi;oo_j<ookh
PookiG3ol<8noiUZ:on@T93oc/k>onk^k_ogmoL00oohn?P04oogmoOok^k^
olk>c_n@T93o@W<[ohC>@on]kg?o`_j8olknT?oFoiOod?jBolKnROnbmGCo
R==3odAe:on@T93oc/k>onk^k_ogmoL0:_ohn?P0;oofm_Kokno_oc<c<onI
VIWoinOWoh>3Pol0003oO7alonSXj?n`/;3o0@41ong]kOoShn?o1PH6oj:R
X_oMgMgoMgMgo`000?o>c/kol?3`ol;2`_l0003odM7AooCdm?oalO7oMGEe
ochn?_o^k^kol_;bom3@d?l0003oclo?oo7alOo8b<So0000ol?3`oo^k^ko
QXJ6oaTI6OoYjNWokno_oo;bl_odm?ColO7aohR8R?l[:b_ok^k^00;omOGe
01coI6AToclo?ooUiNGo/k>coalO7omWIfOokno_ong]kOl@413oXZ:Roo3`
l?o_knooAdM7of][Joo_knool?3`oginO_le=CGojn_[onSXj?lg=cOoA4A4
olk>c_oWinOogMgMonCTi?oemOGomoOgI_ohn?P00oogmoOon?ShooShn002
ooShn004ooOgmooinOWomoOgooOgm`7on?Sh00000oojn_[omOGeonk^kP02
onc/k02Yon_[jooYjNWogmoOokZj^_miDU;o_c8TonMdJOomRGkooiR<oojR
U_ooZ9cooZBHoonJSOonRWookWIZol<c9?miDU;o^[ZjomoOgooZj^[ojn_[
onc/k?o[jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3ooMYSoooZL_onlgko
ooZ2ookfOoook7?oo]iToo[7DOoRTQcoRFICokZj^_oOgmooj^[Zon_[joo/
k>cojn_[on[Zj_oOgmoo^[Zjoe9]D_mAXacoTM9EojKWJ_nhnG[o`?j2olOo
ROo3oXCo^OekojO/K?nDeUOoDZHLoe9]D_nj^[[ogmoOon[Zj_o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?oYjNWohn?Soc0`<?n@T93of=SI
obd];Om0@43o8b<Som[Jf_nVYZKo0@41on7QhOoShnCo410@ogalO?oOgmoo
];Bdo`000?oAdM7oi>CToiRHVOl?3`ooh>3PonOWiooShn?oKfm_oc/k>ooO
gmoohN7Rol?3`ol0003oaLG5onCTi?no_koo0000okRh^?oQhN;oOgmooaLG
5ooIfMWogMgMon7QhOoUiNGoi>CToh61POlX:2SogmoOonKVi_oXj>SoM7Ad
oalO7ooIfMWog=cMoc/k>om_Kfooi>CTon3Ph?l?3`ooV9RHon7QhOoOgn3o
@d=3ofEUI@02on3Ph01_ogMgMolb<S;oh>3PokRh^Ol0003oZ:RXomcLg?oI
fMWofm_Kon7QhOoYjNWoj^[[onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/00Oojn_[00Gok>c/on_[joo[jn_ok^k^ooKfmP01ooWin@00
00?ono_koo?cloo]kNd00_oUiND0/?oVi^Koi>CTomWIfOnb/[;oNBh^olQ2
=?oSJUcom7Y]oof8O?onUh[ooY^>oojHRoonRWkom7]]onM[GOo:@SCoNbh^
ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGVonCTi?oHf=So/[:boiIE;_oZW2_o
nka4ook<Doomf6;oo^=bookYMOoniW?oo]]Uoog<Dook`DGokYh[oiUF;_nb
/[;of=SHonCTi?oUiNGoi^KVonGUiOoTi>Cof=SIok:b/_l^HRkoHjd[ohO:
B?nGg5WoYNEYok;cMonhmW_o]?EiojOZJonHg5WoRLm;of>^:ol^Hbko/[:b
omSHfOoTi>CoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Kohn?S
omgMgOl_;booRh^;ok6a/_l0003o]kNgobDU9OnXZ:SoX:2Po`410OoLg=co
h>3Qok:b/_li>CWo9BDUoc/k>ol0003ocLg=omgMgOnCTiCo410@omKFe_oN
g]kog=cLofa/K?li>CWoe=CDomKFeonl_;co0000ol;2`_oOgmoo^k^ko`00
0?nd];Cog=cLogalO?lG5aOoe]KFom[Jf_oNg]koh>3PomoOgommOGko9bLW
omGEeOoLg=cog]kNom_KfomTI6Co820Poc`l??lC4a?oKFe]on3Ph?oLg=co
3`l?oi>CTooGemOoeMGFod51@OmRHV;oemOGomKFe_mcLg?o<C4aomgMgOnJ
VY_o00001?lg=cL0Ionb/[;oi>CTonCTiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiND00_oVi^H00ooUiNGoi^KVonKViP03onKV
iP03onGUiOo]kNgom?Cd007ono_k00000oolo?con?Shoo7al@03onk^kP0C
on_[jooQhN7o_;blogXG5oo3?c;odeI9onAXF_o_Mfcom8=iooR7O?oeQ7[o
lgU]onEYFooIF4[oa3lbog`G5onl_;cohN7Qonc/k003onk^kP0Conc/k?oQ
hN7o_;blojE75ooVUc;omJ``oofl@OombE?ooM1Poo_CIOomdV3oo/eDoofm
@_oj[c;ojI/bojE65onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;bl
oaMI5omOZ3;oM[dgohK=AonFeU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg_cOo
Gj/boaMI5onl_;cohN7Qonc/k00Zonk^kP0Wonc/k?oUiNGo<C4aohn?Som^
KVko;2`/onSXj?mmOGgoGUiNojBTY?l10@7ohn?SonWYjOoVi^Koh^;Ron3P
h?n][Jgo0000omOGeooTi>CoV9RHoa0@4?oMgMgohn?SonCTi?m`L73o92@T
omKFe_oOgmoo_knoo`000?o;bl_ojNWYol71`Ol0003o^[ZjonCTi?n1PH7o
1PH600?o?Shn02;obl_;onWYjOn4Q8Co6QXJom[Jf_oRh^;oiNGUonOWiooS
hn?oh>3PomSHf?lg=cOoLW9bon[Zj_oWinOo3`l?ohZ:R_oOgmoog]kNod=3
@omFEUKoh>3PomoOgomgMgOo<c<conWYjOnn_[ko0000oj2PX?nf][KoZZZZ
o`820_oIfMWokNg]KOo^k^h00oo]kNgol_;booShn001ooclo0000oomoOd0
5_olo?cooOgmoogmoOolo?colo?com7AdOmX1`Oo^3@dolLo<ooBD4?ofV9E
on=^H_oTLVCoi6mRomaTEooCDD?oc44dokTd=?m[1`Ood];Boo?cloolo?`3
oogmo@0Cooclo?oclo?od];Boih[1ooJRSCoji/IooFX:Ooh]3oonKe:ooRo
COoj_d[onKPoooJZ:_o_WQWofh/doj8]1ooBd];olo?cooclo003oogmo@0C
ooclo?oclo?od];Bo`M01om=VSCoGj/Pog2h;omo`d?oR/e@ohg=D_n:cU3o
PLM4og6i;omR[R3oCY/do`M21ooBd];olo?cooclo00Zoogmo@1<oo_knood
m?Co=3@doiNGUolO7aooQhN7oo[jn_oMgMgo4a<CojVYZOl10@7ol_;booWi
nOo0`<3oa<C4oo?clon<S8co8B4Qoo[jn_oemOGoWIfMoa0@4?oVi^Kok^k^
ooCdm?mhN7So4A4Aoda<C?o:b/[oRHV9oa@D5?ofm_KonOWiolk>c_l0003o
a/K6oo?clon9RHWo4a<CokJf]_ni^KWo^[Zjong]kOoinOWoShn?o``<3?mG
EeOodM7Aong]kOo/k>coYZJVonKVi_oTi>Co4Q8Bojf][Ookno_on_[joa0@
4?lN7QkoYJFUomcLg?lJ6Q[o820PogemOOoNg]koAdM7oemOGookno_on_[j
oc@d=?maLG7ok^k^ohj>S_le=CGono_kooclo6_ooOgm00?oo?cloogmoOol
o?`00oomoOd0000joogmoOojn_[olo?conk^k_o`l?3okno_onk^k_oYjNWo
dm?Coe/M7OnR=3Co]2PMol4j;Oo7BCcoceI:om1GBoo@Ed[obTXnol<k;_nf
:1goXS@doe`M7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`koo^k^koj^[Zom?C
don<9Agob74domV47OoTU1GoiidTonjX<oo`ZSCokjXconbP9OoWUaGog8PM
olQa=?n<9Agodm?Con[Zj_o^k^kol?3`ono_koo`l?3ok^k^on[ZjOoCdm?o
7CPMocB2=?m7UAgoFZDKofV]:P;oM;Ph07goMKThof^a:omKYacoB9XMocB2
=?lM>1godm?Con[ZjOo^k^kol?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knook^k^onOWiola<C7oGemOo`410OoBd];ok^k^onc/k?m1@D7oHF5Q
o`410OoVi^Kok^k]oj2PX?li>CWo4A4AobHV9_nHV9Sokno_olG5aOl@413o
0@41oaTI6OmBDU;ojNWYog5aLOlm?CgoUiNGoalO7olH61SoTI6Aonk^k_o]
kNgo`l?3o`000?nl_;coj>SWoh:2P_lH61SogmoOon;Rh_oShn?oinOWon_[
jonCTi;o?clooi:BT_lG5aOoU9BDon3Ph?m?Cdoo7alOoa4A4Om?Cdooj>SX
onk^k_o_knoo9bLWoj2PX?m>CTko2@T9ocHf=_oPh>3oKVi^o`l?3ol/;2co
_[jnonk^k_o_knkod];Boc`l??l;2`_o7AdMok:b/P02ono_k`1Voo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_0_o`
l?06ono_k`7olo?c0OoinOT1ooknoP0000?oo_knooOgmoo`l?001?oYjNT0
4OoWinOofm_Kof=;Bon1<S;oYSDeokHd;Oo2CD7o`eA9olAEB_o3E4Wo`Te1
okHd;OnU=CGoPC8bof=;BooKfm_oinOW00GojNWY017oinOWom_Kfon9Bd_o
[d/boleg=OoFRbgoh9`^on2P<_oQX3Coh:0bomnJ;_oFRbgobWDeojm;<_n9
Bd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oBd];oc9P<_ljRCGoDi/]of^[
;om`[CSoKjhjog2]>?mZZRooDi/]ocV8=OlbH3;oBd];om_KfooWinL0:ooY
jNT03OoXj>Soi>CToc0`<?lB4Q;o?3`lonKVi_oXj>SoinOWoi>CTolA4A7o
0@41on?ShooWinL00_oYjNT00ooWinOojNWYonWYj@02onSXj00DoifMWOl@
413oinOWonOWiooTi>CoKfm_oc/k>ooShn?oinOWonSXj?oYjNWoj>SXonOW
ioo2`/;o0000okZj^_oTi>CoP820oaLG5ooMgMd2omkNgP03on7QhOoVi^Ko
j>SX00;ojNWY00?oj>SXonOWiooYjNT00_oYjNT00ooWinOojNWYonWYj@05
onWYj@05onSXj?oYjNWojNWYonWYjOoWinL01_oYjNT00ooVi^KojNWYonWY
j@1YonWYj@03onSXj?oYjNWojNWY00CojNWY0Oo`l?01ooOgm`7oo_kn0000
1Oono_kon_[jooCdm?o_knoolO7a00;ol?3`017okno_on_[jonEU9CoCb<S
oiEDE?nkLg?odiFEomZLW?oJWYcofIbLomBEUOnkLg?oUEADodlS8onEU9Co
j^[Zono_k`05oo3`l00Aono_kooZj^[oZIBDoh4S8onjJUCoe9YconBlUOoZ
aicojLNLon[7W?oU_9Goe9Ycok]ZE?n18b?oZYBDon[Zj_o_knl01Oo`l?00
4Oo_knooj^[ZoiBDU?lS:R?oE7YDog>ULonNaYGo[<jLojg>W?n/cYcoW/JE
og>ULomDNUCo8bXSoiBDU?oZj^[okno_02_ol?3`00Gokno_onk^k_lb<S;o
0000oi>CT`03ono_k`05onCTi?l;2`_o0@41onk^k_o_knl01oo`l?002OoS
hn?o_knoono_koo_knook^k^ogAdM?lm?CgokNg]ono_k`03oo3`l007ono_
koo:b/[o0000ol?3`oo^k^koQXJ6o`T92@03oeiNGP03ogUiNOo^k^kokno_
08_ol?3`00ColO7aoo3`l?odm?Con_[j0Oono_h00004oogmoOoooooooooo
ooknoP;ooooo0_ono_h0K_omoOgon?Shofi^K_mJ?coo/I2@omk9bOo`i>Co
lnKVoo3Ti?oNbLWo/I2@oeXo?om]KFgon?Shooclo?ooooooo_knooooooon
o_koooonookno_ooooooo?clooShn?n=KFgoRSloolVAT?oYd<Wom>WTooK[
i_odjNCojM39olVAT?n9?cooSFe]ooShmoolo?coooooookno_ooooooo_kn
ooooooono_koooonooclo?ohn?SoKFe]oclo?on@WI3obMG9onC/i?oVk^Ko
i>cTolWEbOn@WI3o?cloofe]KOohn?Soo?clooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_kooooooogmoOn_[jooV9RHoo7al?om
oOgooooo0_ono_h05_nd];CoVYZJoogmoOooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_kooooooogmoOono_koO7alod51@OomoOgo
o_kmookno_ooool2ooknoP2Conk^k_nIVIWojn_[ooknoOoAdM7oVIVIoiRH
V?nIVIWoV9RHojb/[?omoOgoooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_kn00;ooooo00?oo_knooooooooool00ooo
ool1oogmo@0000Con?Shookno_ojn_[om?Cd1OoalO403Oo_knooe]KFof][
Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?CgoJf][omKFe_o_knl02Ooa
lO403Oo_knooemKFoh=[Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<S?mb?Cgo
PF][omOFe_o_knl02OoalO403Oo_knooe]KFof][Jolm?CgoS8b<okZj^_o<
cLco^[Zjohb<S?lm?CgoJf][omKFe_o_knl0A_oalO400oo^k^kokNg]oo7a
l@2Eoo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_ono_h0
0OogmoL00005on_[joomoOgon?Shoo3`l?o[jn/00ooZj^X03OoYjNWoj^[Z
onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT0
2ooZj^X02ooYjNWoj>SXoj2KVomZFEWo@bHVobd92Om29RKoJEUIoj2KVooX
j>SojNWY00_oj^[Z00_ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUI
FOnKVi_oj>SXonWYj@3Von[ZjP04on_[joo`l?3on?Shoogmo@7ok>c/0000
1?o6a/Koo_knoo[jn_odm?@8oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`
l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`l?3Too7al@03oo3`l?oa
lO7olO7a00;olO7a00?omOGeoo[jn_ono_h00Oo6a/H00003olK6a_o3`l?o
n_[j0?oooooo9oooool1ooWin@7oa<C40Oo6a/H00006om_Kfono_koo]KFe
onOWioogmoOoo?cloooooolQooooo`05oogmoOogmoOoinOWokFe]Ono_kl0
0OoJf]X00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{300, 200},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleJRadioButton",
        ButtonData:>{"SimpleJRadioButton.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[BoxData[
    \(SimpleJRadioButton[]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.ButtonGroup <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<oiVIVOnIVIUfVIVI0/c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<ab
c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c03oc<c<olc<c7;<c<`00iVIVLc<c<c<c002R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<
L/c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00>IVIW<c<c<c<`0olc<c?o<c<abc<c<00>IVIW<c<c<c<`00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<
c7;<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<0?o<c<coc<c<L/c<c003VIVIc<c<c<c<00:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<
c<abc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c7;<c<`00iVIVLc<c<c<c002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<co
c<c<L/c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<abc<c<00>IVIW<c<c<c<`00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<
olc<c7;<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<L/c<c003VIVIc<c<c<c<00:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<
c?o<c<abc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c7;<c<`00iVIVLc<c<c<c002
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<
c<coc<c<L/c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<abc<c<00>IVIW<c<c<c<`0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03o
c<c<olc<c7;<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<L/c<c003VIVIc<c<c<c<
00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0
olc<c?o<c<abc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c7;<c<`00iVIVLc<c<c<
c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<
0?o<c<coc<c<L/c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<abc<c<00>IVIW<c<c<
c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<
c03oc<c<olc<c7;<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<L/c<c003VIVIc<c<
c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<
c<`0olc<c?o<c<abc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c7;<c<`00iVIVLc<
c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<
c<c<0?o<c<coc<c<L/c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<abc<c<00>IVIW<
c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<
c<c<c03oc<c<olc<c7;<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<L/c<c003VIVI
c<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<
c<c<c<`0olc<c?o<c<abc<c<00>IVIW<c<c<c<`00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c7;<c<`00iVI
VLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<0?o<c<coc<c<L/c<c003VIVIc<c<c<c<00:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<abc<c<00>I
VIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c03oc<c<olc<c7;<c<`00iVIVLc<c<c<c002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<L/c<c003
VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>I
VIW<c<c<c<`0olc<c?o<c<abc<c<00>IVIW<c<c<c<`00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c7;<c<`0
0iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
VIVIc<c<c<c<0?o<c<coc<c<L/c<c003VIVIc<c<c<c<00:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<abc<c<
00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0iVIVLc<c<c<c03oc<c<olc<c7;<c<`00iVIVLc<c<c<c002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<L/c<
c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00>IVIW<c<c<c<`0_/c<c0Cooolic<c<1?ooodk<c<`4ooooolc<c23<c<`0
0iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
VIVIc<c<c<c<0;c<c<`2oooo16IVIP;ooolec<c<0_ooo`AVIVH2ooooB/c<
c0;oool4IVIV0_ooooo<c<`Nc<c<00>IVIW<c<c<c<`00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02lc<c<0VIVIPC<c<`2
IVIV00?oooo<c<c<c<`01<c<c0H000001<c<c00000000<c<c0800002c<c<
0P0000;<c<`2000000C<c<`00000003<c<`200000/c<c080000@c<c<0VIV
IPC<c<`2IVIV00?oooo<c<c<c<`01<c<c0800002c<c<00<0003<c<c<c<`0
0P0000;<c<`500000/c<c0@00004c<c<100000C<c<`500001Lc<c0800003
c<c<0P00013<c<`2IVIV1<c<c09VIVH00oooolc<c<c<c005c<c<0`0000?<
c<`300000/c<c08000000lc<c00000000002c<c<0P0000;<c<`2000000?<
c<`0000000000/c<c0@00003c<c<0`0000;<c<`200000lc<c0@00002c<c<
1P0000;<c<`400000lc<c0@00003c<c<10000<O<c<`00iVIVLc<c<c<c002
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0;_<
c<`00fIVI_ooolc<c006c<c<00=VIVKoooo<c<`01<c<c0800005c<c<0P00
0003c<c<0000000000;<c<`2000000C<c<`00000003<c<`3000000?<c<`0
000000000/c<c080000?c<c<00=VIVKoooo<c<`01/c<c003IVIVooooc<c<
00C<c<`2000000G<c<`000000000003<c<`00P000003c<c<0000000000;<
c<`2000000?<c<`0000000000/c<c0800002c<c<0P0000;<c<`200000/c<
c0800003c<c<0P0000C<c<`200000/c<c0<0000?c<c<00=VIVKoooo<c<`0
1/c<c003IVIVooooc<c<00G<c<`300000lc<c0<00002c<c<0P000003c<c<
0000000000;<c<`2000000C<c<`00000003<c<`3000000?<c<`000000000
0/c<c0800002c<c<0`000004c<c<0000000000000/c<c0800002c<c<0P00
0003c<c<0000000000G<c<`200000/c<c08000000lc<c00000000002c<c<
0P000003c<c<0000000000;<c<`20000a/c<c003VIVIc<c<c<c<00:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0^lc<c003
IVIVooooc<c<00K<c<`00fIVI_ooolc<c004c<c<0P0000G<c<`2000000?<
c<`0000000000/c<c08000000lc<c00000000002c<c<0P0000;<c<`40000
4<c<c003IVIVooooc<c<00@00002c<c<00=VIVKoooo<c<`01<c<c0800000
1Lc<c000000000000<c<c002000000?<c<`0000000000/c<c08000000lc<
c00000000005c<c<0P0000C<c<`200001/c<c0800005c<c<0P000003c<c<
00000000013<c<`00fIVI_ooolc<c006c<c<00=VIVKoooo<c<`01Lc<c0<0
0003c<c<0`0000;<c<`2000000?<c<`0000000000/c<c08000000lc<c000
00000002c<c<0P000003c<c<0000000000;<c<`200000/c<c0<000001<c<
c0000000000000G<c<`300000/c<c0800004c<c<0P0000;<c<`2000000?<
c<`0000000000/c<c08000000lc<c00000000002c<c<0P000<K<c<`00iVI
VLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<0;[<c<`00fIVI_ooolc<c008c<c<00=VIVKoooo<c<`00lc<c080
0005c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<
c0800003c<c<0P00013<c<`00fIVI_ooolc<c00600000/c<c003IVIVoooo
c<c<00?<c<`2000000G<c<`0003<c<`0003<c<`00P0000;<c<`2000000C<
c<`00000003<c<`200001Lc<c0800004c<c<0P0000C<c<`400001Lc<c0D0
000?c<c<00=VIVKoooo<c<`02<c<c003IVIVooooc<c<00?<c<`2000000C<
c<`00000003<c<`2000000C<c<`00000003<c<`2000000?<c<`000000000
0/c<c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`2
000000S<c<`00000003<c<`0003<c<`0003<c<`200000/c<c0@00004c<c<
0P0000?<c<`200000/c<c08000000lc<c00000000002c<c<0P000003c<c<
0000000000;<c<`20000a/c<c003VIVIc<c<c<c<00:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0^/c<c003IVIVooooc<c<
00S<c<`00fIVI_ooolc<c003c<c<0P0000G<c<`2000000?<c<`000000000
0/c<c08000000lc<c00000000002c<c<0P0000;<c<`400003lc<c003IVIV
ooooc<c<00H00002c<c<00=VIVKoooo<c<`00lc<c08000001Lc<c0000<c<
c0000<c<c00200000lc<c0@000000lc<c00000000005c<c<0P0000C<c<`2
00000/c<c0D00007c<c<0`00013<c<`00fIVI_ooolc<c008c<c<00=VIVKo
ooo<c<`00lc<c08000001<c<c00000000<c<c08000001<c<c00000000<c<
c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`20000
00?<c<`0000000000/c<c08000001<c<c00000000<c<c0<000001<c<c000
00000<c<c0<00007c<c<0P0000;<c<`200000/c<c08000000lc<c0000000
0002c<c<0P000003c<c<0000000000;<c<`20000a/c<c003VIVIc<c<c<c<
00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0
^/c<c003IVIVooooc<c<00S<c<`00fIVI_ooolc<c003c<c<0P0000G<c<`2
000000G<c<`000000000003<c<`00P000003c<c<0000000000;<c<`20000
00?<c<`0000000000/c<c080000>c<c<00=VIVKoooo<c<`01P0000;<c<`0
0fIVI_ooolc<c003c<c<10000003c<c<00000000008000000lc<c0000<c<
c002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000001<c<
c08000000lc<c0000000000200002<c<c0D0000?c<c<00=VIVKoooo<c<`0
2<c<c003IVIVooooc<c<00?<c<`2000000C<c<`00000003<c<`2000000C<
c<`00000003<c<`2000000G<c<`000000000003<c<`00P000004c<c<0000
0000c<c<0`0000;<c<`00`000<c<c<c<c002000000C<c<`00000003<c<`3
000000C<c<`00000003<c<`200000/c<c0800005c<c<0P000003c<c<0000
000000;<c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002
c<c<0P000<K<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c003VIVIc<c<c<c<0;[<c<`00fIVI_ooolc<c008c<c<00=V
IVKoooo<c<`00lc<c0800005c<c<0P000004c<c<00000000c<c<0P0000;<
c<`200000/c<c08000000lc<c00000000002c<c<0P0000k<c<`00fIVI_oo
olc<c00600000/c<c003IVIVooooc<c<00?<c<`4000000?<c<`000000000
0P0000;<c<`400000lc<c0@00002c<c<0P0000C<c<`2000000?<c<`00000
00002/c<c08000000lc<c0000000000?c<c<00=VIVKoooo<c<`02<c<c003
IVIVooooc<c<00?<c<`2000000?<c<`0000000000P0000;<c<`2000000C<
c<`00000003<c<`2000000?<c<`0000000000lc<c08000000lc<c0000000
0002c<c<100000;<c<`200000/c<c0030000c<c<c<c<00800002c<c<1000
00K<c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<
0P000003c<c<0000000000;<c<`20000a/c<c003VIVIc<c<c<c<00:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0^lc<c003
IVIVooooc<c<00K<c<`00fIVI_ooolc<c004c<c<0P0002_<c<`00fIVI_oo
olc<c00400000/c<c003IVIVooooc<c<00C<c<`300000lc<c0<0000@c<c<
0P0000;<c<`200000/c<c0800003c<c<0P0000C<c<`200000/c<c0<0000?
c<c<00=VIVKoooo<c<`01/c<c003IVIVooooc<c<00?<c<`200000lc<c0<0
0003c<c<0P0000k<c<`200006Lc<c0800002c<c<0P000003c<c<00000000
00;<c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<
0P000<K<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<0;_<c<`00fIVI_ooooooo`04c<c<0_ooo`03
IVIVooooc<c<00C<c<`200001Lc<c080000Tc<c<00=VIVKoooooool01<c<
c0;oool00fIVI_ooolc<c004c<c<0`0000?<c<`300004Lc<c0@00004c<c<
1@0000G<c<`200000lc<c080000?c<c<00=VIVKoooooool01<c<c0;oool0
0fIVI_ooolc<c003c<c<0P0000?<c<`300000lc<c0@0000<c<c<0P0001[<
c<`400000lc<c0@00003c<c<100000?<c<`40000alc<c003VIVIc<c<c<c<
00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0
_<c<c09VIVH4oooo0VIVIP03ooooc<c<c<c<03;<c<`2IVIV1?ooo`9VIVH0
0oooolc<c<c<c017c<c<0VIVIPCoool2IVIV00?oooo<c<c<c<`0olc<c1_<
c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<0;k<c<`4IVIV>Lc<c0AVIVI>c<c<16IVI_o<c<`Pc<c<
00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0iVIVLc<c<c<c03oc<c<olc<c7;<c<`00iVIVLc<c<c<c002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<L/c<
c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00>IVIW<c<c<c<`0olc<c?o<c<abc<c<00>IVIW<c<c<c<`00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c7;<
c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<0?o<c<coc<c<L/c<c003VIVIc<c<c<c<00:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<ab
c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c03oc<c<olc<c7;<c<`00iVIVLc<c<c<c002R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<
L/c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00>IVIW<c<c<c<`0olc<c?o<c<abc<c<00>IVIW<c<c<c<`00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<
c7;<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<0?o<c<coc<c<L/c<c003VIVIc<c<c<c<00:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<
c<abc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c7;<c<`00iVIVLc<c<c<c002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<co
c<c<L/c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<abc<c<00>IVIW<c<c<c<`00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<
olc<c7;<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<L/c<c003VIVIc<c<c<c<00:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<
c?o<c<abc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c7;<c<`00iVIVLc<c<c<c002
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<00?<
c<`200001/c<c0800002c<c<1@0000;<c<`2000000?<c<`0000000000lc<
c0@00002c<c<0P0000?<c<`200000/c<c0800002c<c<0P000?o<c<coc<c<
?lc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00>IVIW<c<c<c<`00lc<c0800006c<c<0P000003c<c<0000000000;<
c<`2000000?<c<`0000000000/c<c0800002c<c<0P0000;<c<`2000000?<
c<`0000000000lc<c0800002c<c<0P0000;<c<`20000olc<c?o<c<`oc<c<
00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0iVIVLc<c<c<c003c<c<0P0000K<c<`2000000?<c<`0000000000/c<c080
00000lc<c00000000002c<c<0P0000;<c<`200000/c<c08000000lc<c000
00000003c<c<0P0000;<c<`200000/c<c080003oc<c<olc<c3o<c<`00iVI
VLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<00?<c<`600000/c<c0800002c<c<0P000004c<c<00000000c<c<
0P0000;<c<`200000/c<c0800002c<c<0P000003c<c<0000000000?<c<`2
00000/c<c0800002c<c<0P000?o<c<coc<c<?lc<c003VIVIc<c<c<c<00:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<1IVIV@03c<c<00000000
00?<c<`2000000?<c<`0000000000lc<c0@000000lc<c00000000002c<c<
0P0000;<c<`200000/c<c08000000lc<c00000000003c<c<0P0000;<c<`2
00000/c<c0800002c<c<oiVIVOnIVITnVIVI0/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P8c<c<0P0000?<c<`2000000G<c<`00000003<c<`0
00000lc<c08000000lc<c00000000002c<c<0P0000?<c<`00`000<c<c<c<
c002000000?<c<`0000000000lc<c0<000001Lc<c000000000000<c<c002
0000olc<c?o<c<a2c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0S<
c<`200000lc<c08000000lc<c00000000002c<c<10000003c<c<00000000
00H00002c<c<100000;<c<`4000000C<c<`00000003<c<`200000/c<c080
003oc<c<olc<c4?<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h2<c<
c0800003c<c<0P000003c<c<0000000000S<c<`200000/c<c080003oc<c<
olc<c5[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h2<c<c0H00002
c<c<0P0000W<c<`010000<c<c<c<c<c<c0<0003oc<c<olc<c5S<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1000000000hS0^<SPf8S0
^03oR<2hohS0^7f8`;P1B9280@00000000B8`;S8h=R8`;R8`;PF00200`01
P0800X001002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N2
00<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@3
0@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ7
00@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<M
RP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<5
9Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]
T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B
0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@3
1cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G
0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9
VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;
DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]I
W`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaP
XPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY003
3FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW
0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`me
Z@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@
Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65
[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8B
SK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@C
T[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK
]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ
^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m
5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o
00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P40020
00>KYo4c@jDc@jD02C=3Y@H0080300600P02P00400:100>100>100>10`04
P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<1
2X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0<008001i^WlOooohij]ZJKa;>YdZRMb;>Y
dP02YY_400Fl^=g^k_CZjO7ooolc@jD01@00P0<00H0200:000@00X400h40
0h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R20081
28<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108A
QP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN8
0`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3
126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh0
0`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA
1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLe
TP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`Pm
U@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4
V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/3
2TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN
2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:00
10aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=
HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iY
Y@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?
LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X3
47V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61
[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;02
4XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P03
4hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E
]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`04
5Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X3
5ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm
00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<0P
00000QRd`10000026;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
080019^WlOooofaJYJnUbP:l^=d02_omok>Yd_oooooookbhgIN:_:RMb>KV
k?oooc=3Y@@0080300600P02P00400:100>100>100>10`04P@801H401005
PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;
Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@04
0aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`4
98d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5
:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A
00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7
>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9
AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN
2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ
0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X
3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@
OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh0
0a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@
/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf
0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<F
ZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=Q8T8Q8T8P034R@R003
0000b>3HB92800e8T8P0100001Rd`1Rd`<SPf0i8T8P00`0001Rd`1Rd`002
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00;VjOaooooZ9g8oooo
/jWBH4bJSWZfN6F^Z9g8oooooogo00?oool00c=3Y@00P000P00300200`01
P0800X001002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N2
00<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@3
0@j50`8?Q@8248D3oooo0P8AQP<24XH20Q>600@24hL258L258L258L30QF7
0P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<L
RP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@85
9Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/
S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHc
TPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU003
1cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G
0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8
V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:
DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]H
W`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<
H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=
IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^
Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010md
Z@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]
47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_
00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@04
4Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c
4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LD
VkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i
00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[
_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa
_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P0
3HS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2002000jKYo7ooooooooKg>aPC9ZC
QKZcZM:l^=ePC9ZISkjVVlC8`moooolc@jD600200oooo`800X000`02POoo
ooooo`02oooo0P04P@0300F1oooo00F200<01X84oooo00<1288128?oool0
0oooo`<12X<01_ooo`4;Q04;Q04<Q?ooo`4<Q0813H@01?ooo`4>QOooo`4>
Q@823hD01?ooo`8@QOooo`8@Q@824HH00oooo`8AQP8BQP020Q:60P8CQP04
0Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<I
R@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><
00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5
:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6
<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<3
1cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88
@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9
AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL
10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]F
WP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<
GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<3
3F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>
K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mb
Z0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[
0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62
[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa
4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P02
4hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@D
V;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN
^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk
0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn
00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000C8h=R8`;R8`;R8
`;P6000018S0^003B9280000b>3H00:8`;P900000XS0^005B92800006;C0
6;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3002000jKYo7ooonl^=fISkkooooFdMgKg>cco_nVVlC^k_B5
M[2CQK[ooolc@jD4002000Ooool00H000H000H3oool00X3oool00`03P@06
oooo00B100B100F1oooo00F20P06PP08oooo00N200N20@N2oooo0@R2oooo
0@R30`49P`04oooo0@Z30@Z3oooo0P4;Q0030@b4oooo0@b400813H@01?oo
o`4>QOooo`4>Q@823hD00oooo`8@QOooo`03oooo0P8AQP<24XH20Q>600@2
4hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV9
0aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`0
10@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZ
SPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`Ha
T@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7
=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0
UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6
V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`4
2U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN
00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aM
X@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=
Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/
YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X
00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/3
47b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^
0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4B
R[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008C
Sk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH
]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh
0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/3
5ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<001<SPf8S0^8S0^8S0
^0H00004R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@00
08S0^8S0^4R@R00000026;C000C8h=R8`;R8`;R8`;P2000018S0^0800002
R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0`00P00?VjOaooooVHnnUhZle=?XkjbcogIkkYn[FeRUYY_4UYoBH4bJ_;SM
oooo<d>U00<008001oooo`01P001P001P?ooo`02P?ooo`0300>100Koool0
1840187oool01H7oool200J200Soool01h801h811h;oool128;oool128<3
0@V300Woool12X?oool12h?oool12hCoool138Coool00P4=Q004oooo0@j5
oooo0@j50P8?Q@04oooo0Q25oooo0Q25108AQP<24XH20Q>600@24hL258L2
58L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@3
6XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@T
S@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZ
S`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y40
10HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`Lh
T`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G
246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6
V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:
DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;
Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ42
35nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS
00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH0
10i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?
LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m
[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P03
4HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[43
4X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c
0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH2
59Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^003
5J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY
_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G
/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8
T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R000
00026;C000?8h=R8`;R8`;P00XS0^0800002R<2h0P0000>8`;P014R@R000
01Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000ZKYo7o
oonGR[ajK:ZcanRYKZ38`mnCQKYKAY>ISkh2N6F^00A29hF_YL[ooolc@jD4
00200`01P003oooo00:000:100Coool200B100?oool01H7oool00`06PPCo
ool00`48PP48P`48P`030@V300Woool12X?oool12h?oool12hCoool138Co
ool00P4=Q004oooo0@j5oooo0@j50P8?Q@03oooo0Q25oooo00?oool20Q66
0`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP3
0aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<4
8H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP03
1BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46
<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB
0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE
10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH
2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:
CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;
E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX004
35bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeR
XPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU
0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0ma
Z0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@
NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]
4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08B
RK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<C
S[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe
0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@E
WKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<F
YKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd0
0aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003
b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0
^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^003R<2h100000B8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
002000>KYo7oooooool00_ooo`0:ojf`ogIknLgDoNg^ooooYY_4QGJ`_;SM
oooo<d>U1@00P0<00H000oooo`02P002P@0300>100?oool0187oool00P05
P@0400F2oooo00J200J20P07PP030@N2oooo0@R2008128<3oooo0P4:P`07
oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?ooo`4>QOooooooo`823hD0
1_ooo`8@QOooo`8@Q@8AQ_ooo`824HH30Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<K
R@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d4
9Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[
S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO
00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y
00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n
[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64
[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P04
59Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl
00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G
/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000
b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd
`003b>3HR<2hR<2h00B8`;P200001HS0^004B92800006;C06;C00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0<008002Z6/l_W=e>8V??Be_n8V??A]
OOcSjOoooog]k_n]/0;oool00c=3Y@00P000P00400200`01P003oooo00:0
00:100?oool200B100Goool01H401H401H;oool00P06PP?oool20@R200<1
28?oool12H<00P49P`812X<01?ooo`4;P`4;Q?ooo`8138@01oooo`4=Q04=
Q?ooo`4>QOooo`4>Q@02oooo00<23hD248D248D01?ooo`040Q660Q:60Q:6
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8
h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h
00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8`;P4000018S0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08003I^WlOg]k^8V??ken?N9UoARK_>P[_ARK_omoon]/?cSjOoooc=3Y@07
00200`01P003oooo00:000:100<00h4300B10P05P@0400F200J200J200J2
0P07PP050@N20@R20@R2oooo0@R300<12H<30@Z300<12h<12h@12h@00`4<
Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<2
5HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT3
0ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=
0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl4
1Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B
1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD
00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8
@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT3
2DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YA
W@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`03
2eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aO
XPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eU
Y0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW
3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@04
3gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@
OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lA
Q:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba
00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<C
T[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ
]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TE
X;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_004
5Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n
5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SP
f002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<00
0lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0^004B92800006;C06;C0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^08008000i^WlOK8c>8V?002
ojf`00OO92koY9kf_<Go[K3^Nhcooolc@jD02000P0<00H000oooo`02P002
P@0300>10`04P@801H401005PP06PP06PP06PP801h801@47PP48PP48P_oo
o`48P`030@V300Coool12X<12X<12h<20@^40`4<Q0<13H@30@j50`8?Q@<2
48D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP3
5hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;
0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DW
SPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@
00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB
1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8
?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H
2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J
0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;
E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P
0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ80
0`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=
J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L0
10m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ
0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60
[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`
0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK82
4Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<C
U;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L2
59fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j
0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/
_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o
0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h2@0000:8`;P0
1DR@R00001Rd`1Rd`<SPf003R<2h0P0000B8`;P200000XS0^004B9280000
6;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008000i^WlOW=
e?N9U`02oooo00Oo[K3Q5SCoMW_oY9kR9ScoRGlc@jD02000P0<00H000ooo
o`02P002P@0300>10`04P@801H401005PP06PP06PP06PP801h801047PP48
PP48PP48P`Coool30@Z300<12h<12h@12h@00`4<Q0813H@01?ooo`4>Q@4>
Q@4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8F
Q`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<3
7HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd3
1BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6
;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHc
TP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9
BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd2
2e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;
FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<
H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]
47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<A
QJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d
4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLD
VkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[
_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0
^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C06;C0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^08008001i^WlOoooo>P[_AR
K_ooooN9UoW=e002oooo00?cX:kooolc@jD02000P0<00H0200:000@00X40
0h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2
008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25
108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN8
0aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<4
88/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh5
9hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T004
1RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLe
TPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE
0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4
V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:
C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM
2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<
G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=
HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU
0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?
L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@
N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d0
0a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<B
R;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>
/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd
0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM
]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<E
Y;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d3
5jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H
]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P03HS0^005B92800006;C0
6;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3002000^KYo7oooooRGooooocX:kaTj7ooooooOocX:kono`c
@jD02000P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J2
00J200J20P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^4
00<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L2
58L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT3
0a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@T
S@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`03
1B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010Hb
TPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`Lh
U0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G
246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@04
2DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:
DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;
Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ
00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=
IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]
Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?
LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[004
47j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^
4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a
0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A
/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf
00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h
5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@F
Z[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h0
0aNa_QNa_aNa_`035k:o0aNc_`8H]<0?b>3H00<00038h=S8h=P03LSPf003
00006;C06;C000o8h=P00`0001Rd`1Rd`002R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h1000P0>KYo401_oooo>P[_Be_oJlaO_IfS=3Y@T008030060
0P02P00400:100>100>100>10`04P@801H401005PP06PP06PP06PP801h80
0`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<1
3XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:
0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DV
S@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@
0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i82
1SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7
>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL2
24>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ
0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]B
W@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO
0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R
362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=
IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL3
3VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o
[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_
1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=
/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B
]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g
59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i
0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdF
ZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl0
0aNb_`<G/klf6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^1H00803
00600P02P00400:100>100>100>10`04P@801H401005PP06PP06PP06PP80
1h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=
Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`82
5XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X3
0af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=
0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l3
1Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86
<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`Li
U0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8
@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T3
2DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M
0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l4
2eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R
362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT
00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>
KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T3
3gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n
[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`03
4HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:<
/Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B
]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g
59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@04
5J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`F
ZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG
/Kl00aNb_`<G/klf6;C00XS0^058T8P1000000000hS0^<SPf8S0^03oR<2h
ohS0^7f8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@
R04000000003R<2hb>3Hb>3H0?o8h=Sob>3HOLSPf058T8P10000003oR<2h
ohS0^868`;P100000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?oo
l?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`
l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003o
oo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;o
l?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool0
0?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_oo
k^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003o
onKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;o
oooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^ko
onk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00
oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2
ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^
ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0
0?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooooooo
P_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^
k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^
003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooo
oh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooo
oon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?oo
k^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^
k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003o
onk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;o
k^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool0
0?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_oo
k^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003o
onKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;o
oooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^ko
onk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00
oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2
ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^
ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0
0?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooooooo
P_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^
k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^
003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooo
oh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooo
oon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?oo
k^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^
k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003o
onk^k_ook^k^P_o^k^h000;ooooooonDU9CooiBDU7ooU9BD0Oooool000;o
k^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^kW_ok^k^0OnDU9@1onk^kP00
0_oVi^H00onDU9Coi^KVonKViP3oonKVi_ooi^KVNooVi^H1oiBDU07oi^KV
0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^ikonk^kP7oU9BD0Oo^
k^h000;ooooo00?oU9BDooooooooool0ooooooooooooog_ooooo0OnDU9@1
ooooo`000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^Noo^k^h1oiBD
U07ok^k^0002onKViP03oiBDU?oVi^Koi^KV0?ooi^KVoooVi^IkonKViP7o
U9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^kW_ok^k^
0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3oooooooooooooNooo
ool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^ik
onk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^KoonKV
iW_oi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_oo
k^k^Noo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oooooo
oooooomkooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^
k^koonk^kW_ok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP3o
onKVi_ooi^KVNooVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^
0?ook^k^ooo^k^ikonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDoooooooo
ool0ooooooooooooog_ooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^
onk^kP3oonk^k_ook^k^Noo^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oV
i^Koi^KV0?ooi^KVoooVi^IkonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BD
onk^k_o^k^h0ooo^k^koonk^kW_ok^k^0OnDU9@1onk^kP000_ooool00onD
U9Coooooooooo`3oooooooooooooNoooool1oiBDU07ooooo0002onk^kP03
oiBDU?o^k^kok^k^0?ook^k^ooo^k^ikonk^kP7oU9BD0Oo^k^h000;oi^KV
00?oU9BDonKVi_oVi^H0oooVi^KoonKViW_oi^KV0OnDU9@1onKViP000_o^
k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^Noo^k^h1oiBDU07ok^k^0002
ooooo`03oiBDU?oooooooooo0?oooooooooooomkooooo`7oU9BD0Oooool0
00;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^kW_ok^k^0OnDU9@1onk^
kP000_oVi^H00onDU9Coi^KVonKViP3oonKVi_ooi^KVNooVi^H1oiBDU07o
i^KV0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^ikonk^kP7oU9BD
0Oo^k^h000;ooooo00?oU9BDooooooooool0ooooooooooooog_ooooo0OnD
U9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^Noo^k^h1
oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV0?ooi^KVoooVi^IkonKV
iP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^kW_o
k^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3ooooooooooooo
Noooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^
k^ikonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^Ko
onKViW_oi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^
k_ook^k^Noo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oo
oooooooooomkooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0
ooo^k^koonk^kW_ok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKV
iP3oonKVi_ooi^KVNooVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^ko
k^k^0?ook^k^ooo^k^ikonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDoooo
ooooool0ooooooooooooog_ooooo0OnDU9@1ooooo`000_o^k^h00onDU9Co
k^k^onk^kP3oonk^k_ook^k^Noo^k^h1oiBDU07ok^k^0002onKViP03oiBD
U?oVi^Koi^KV0<3oi^KV00CoiNGUon7QhOoKfm_oe]KF0_oCdm<01?oFe]Ko
f][Jon3Ph?oUiNDdonKViP04onGUiOoQhN7ofm_KomKFeP;odm?C00Coe]KF
om[Jf_oPh>3oiNGUAooVi^H01?oUiNGohN7Qom_KfooFe]H2om?Cd`04omKF
e_oJf][oh>3PonGUiOooi^KV8OoVi^H1oiBDU07oi^KV0002onk^kP03oiBD
U?o^k^kok^k^0;kok^k^00kokNg]on_[jooTi>Cod];Bokfm_OnZZZ[oX:2P
oinOWonXZ:So^[Zjolo?cooQhN7ojn_[ong]kC3ok^k^00kokNg]on_[jooT
i>Cod];Bokfm_OnZZZ_oX:2PoinOWonXZ:Wo^[Zjolo?cooQhN7ojn_[ong]
kD?ok^k^00kokNg]on_[jooTi>Cod];Bokfm_OnZZZ[oX:2PoinOWonXZ:So
^[Zjolo?cooQhN7ojn_[ong]kOook^k^7oo^k^h1oiBDU07ok^k^0002oooo
o`03oiBDU?oooooooooo0;gooooo013oo_knooclo?oalO7oeMGEojj^[_n<
S8coMWIfof][JomZJV[oLg=cohR8R?nYZJWod=3@ono_koolo?coo_kn;_oo
ool04?ono_koo?cloo7alOoEeMGo[Zj^ohb<S?mfMWKoJf][ofYZJ_mcLg?o
R8R8ojVYZOo@d=3okno_ooclo?ono_i1ooooo`0@ookno_olo?colO7aomGE
eOn^[ZkoS8b<ogIfM_m[Jf_oJVYZog=cLon8R8SoZJVYom3@d?o_knooo?cl
ookno_oooooo7_ooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^
0;gok^k^013okNg]on?Shoo6a/KoVYZJog1`L?mfMWKoVYZJokRh^?nl_;co
WIfMogalO?m/K6coU9BDol;2`_oPh>3ok>c/6_o^k^h00oo[jn_ogmoOonk^
kP0Aonk^kP0@ong]kOoShn?oa/K6oiZJV_m]KW3oJWElohFKY_nO_/?oXl76
ohROZ_m^NXCoJFY]oiBDU?o2`/;oh>3Ponc/k1;ok^k^00?og=cLonc/k?o^
k^h00_oShn<3onk^kP03omgMgOoOgmook^k^00Cok^k^00CokNg]olg=cOo<
c<cokNg]1?o^k^h00oo/k>cocLg=omKFeP0Eonk^kP0@ong]kOoShn?oa/K6
oiZJV_m`L73oMWIfoiZJV_nh^;So_;bloifMWOmlO7coK6a/oiBDU?o2`/;o
h>3Ponc/k1kok^k^00?oj^[ZomSHf?o^k^h01_o^k^h00ooLg=cogmoOonk^
kP0>onk^kP;ohN7Q3_o^k^h00ooIfMWod=3@onk^kP05onk^kP03omWIfOo@
d=3ok^k^00Gok^k^00?ofMWIom3@d?o^k^h0`_o^k^h1oiBDU07ok^k^0002
onKViP03oiBDU?oVi^Koi^KV0;coi^KV00SoiNGUon7QhOo>c/koX:2PogAd
M?nQXJ7okNg]ooknoP?ooooo00Oolo?coj^[ZomcLg?oVIVIolW9bOoOgmoo
iNGU00Goi^KV00?o<30`o`000?l000000_l000001?ld=3Coi^KVocTi>Omb
LW82onKViP06ocTi>OmbLW;oi^KVonKVi_nCTi?o6ATI0_oVi^H02_n/[:co
61PHo`H61_m9BDWoN7Qhob/[:ooVi^Kob<S8oa8B4_ng]kL2onKViP03ogMg
MolE5AGod=3@00Goi^KV01;oiNGUon7QhOo>c/koX:2PofaaN?moVK3o_^[i
omGooooJoooof?ooom;noonok?ooR::mofYaN?nIVIWobLW9omoOgooUiND5
onKViP09oc0`<?nDU9Coi^KVomGEeOn@T93odm?ConKVi_n/[:co0@4100;o
i^KV00goBDU9o`L71olG5aOoS8b<oa4A4Om>CTkoi^KVolk>c_li>CWo0000
oa0@4?lJ6Q[ogmoO00;oi^KV00koTi>Coa0@4?lL71co7alOo``<3?n3Ph?o
iNGUonKVi_nNWYko2@T9o`/;2olP823o<30`oiJFUPGoi^KV00?oHf=SodE5
AOoVi^H00_oVi^H00oo6a/Ko20P8ogMgM`05onKViP08onGUiOoQhN7oc/k>
oj2PX?mdM7CoXJ6Qong]kOono_h3ooooo`07oo?clon[Zj_oLg=coiVIVOo9
bLWogmoOonGUi@06onKViP07odE5AOlL71coi^KVonKVi_oRh^;o20P8oeYJ
FP03onKViP06ocTi>OmbLW;oi^KVonKVi_li>CWoLW9b0_oVi^H02_nCTi?o
6ATIonKVi_oVi^KoXj>So``<3?l10@7o:2PXohB4Q?l?3`l2onKViP06olG5
aOl_;boo30`<o`X:2_lc<c?oa/K60_oVi^H00oo?cloo0000ogYjNP02onKV
iP03od51@OlT92Coi^KV00;oi^KV00Go8B4Qo`h>3_lL71coADE5omgMg@02
onKViP03oa8B4_l0003o000000;o000000WoBd];onKVi_oVi^Koi>CToeQH
F?lK6a_o9bLWoc@d=?oFe]H00_oVi^H01_oTi>CoF5QHoa/K6olW9bOo=3@d
omKFeP;oi^KV00Koi>CToeQHF?lK6a_o9bLWoc@d=?oFe]K1onKViP7oU9BD
0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0_?o^k^h01oo]kNgohn?SolC4
a?n6QXKoYjNWonk^k_okno/00_ono_h02OomoOgoo_knooShn?o`l?3o/K6a
oh61POnn_[koh>3Ponc/k005onk^kP03oc8b<_m/K6cok^k^00Cok^k^00Ko
>c/kogIfM_o^k^kok^k^oc/k>omfMWH2onk^kP0:oiRHV?lJ6Q[ok^k^onk^
k_m>CTkoDe=ConKVi_nCTi?o3Ph>ob`/;0;ok^k^00KoWIfMob0P8?oPh>3o
/K6ao`D51Onc/k<6onk^kP0Bong]kOoShn?oa<C4oh24QommV[go]N?ool;_
o_noj_co]=kcok7KlOngiO_o_>_ookOToon4Y<WoN7j4okjn__oPh>3ok>c/
1Oo^k^h04?lb<S;oVYZJonk^k_n4Q8Co0000ogalO?o^k^ko/[:bo`410Oo^
k^ko^;Rho`<30oo>c/koe]KFoeADE?l?3`l2onk^kP0:ocdm?OlY:BWo_Kfm
onk^k_o9bLWok>c/onk^k_nIVIWo2@T9ojZZZP;ok^k^00_o^KVioa<C4omn
OWkok^k^olO7aonb/[;ojNWYonk^k_nBTY;o0`<3olo?c`04onk^kP03onCT
i?lO7aooVIVI00;ok^k^00?o?ShnobXZ:_oYjNT01Oo^k^h01oo]kNgohn?S
olC4a?n6QXKoYjNWonk^k_okno/00_ono_h02OomoOgoo_knooShn?o`l?3o
/K6aoh61POnn_[koh>3Ponc/k005onk^kP08on_[jol<30co0000om?Cdoo^
k^ko_[jno`000?lJ6QX3onk^kP06oc/k>omfMWKok^k^onk^k_lk>c_oMWIf
0_o^k^h03_nHV9So6QXJonk^k_o^k^ko;bl_oeADE?oMgMgo_;blobXZ:_l?
3`ook^k^ong]kOl`<33oC4a<0_oNg]h03?m?Cdoo<C4aong]kOo^k^koTi>C
o`h>3_le=CGok^k^onOWiol92@Wo3Ph>olG5a@;ok^k^00Go/k>con[Zj_o]
kNgo<S8bohR8R002onk^kP03odi>C_lZ:R[oe]KF00;oe]KF00WogmoOonk^
k_o^k^koR8R8obl_;ooXj>Sok^k^oeYJF_mADE400_o^k^h01_n8R8So;bl_
onSXj?o^k^koFUYJoe5AD@;ok^k^00KoR8R8obl_;ooXj>Sok^k^oeYJF_mA
DE71onk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0_?ooool0
4_omoOgolO7aokfm_OnCTi?of][Jonc/k?oclo?on_[jooooooolo?comoOg
oo7alOoYjNWofm_KoiRHV?nb/[;ok^k^ooclo0Gooooo00?o=SHfogAdM?oo
ool01?ooool01_m0@43oOgmooooooooooooo@410ogmoO`;ooooo00KoXj>S
oa`L7?ooooooooooob`/;?n@T902ooooo`03ogYjN_l`<33ooooo00;ooooo
00CoIVIVodi>C_lG5aOoQhN71oooool04_omoOgolO7aokbm_OmdR9goVl[g
ok7Noon`fokoX/W[oiFje_nB^=CoV/7XojSEo?nZfoooUlOlog29Y?n_/;;o
k^k^ooclo0Gooooo01Co=SHfojFUYOoooooo<S8bodM7AolW9bOooooookno
_ol20P;oooooomWIfOl30`?o_KfmoooooonOWioo820PoooooooLg=co0000
oiFEU@Cooooo00?on_[joa/K6omDE5@01?ooool00onBTY;o30`<ong]k@04
ooooo`03on7QhOl0003o][Jf00Gooooo00Ko_knooa<C4ooWinOoWYjNo`82
0_o8b<P6ooooo`0BoogmoOoalO7o_Kfmoi>CTooJf][ok>c/oo?cloojn_[o
ooooooclo?ogmoOolO7aonWYjOoKfm_oV9RHok:b/_o^k^koo?cl1Oooool0
2Oo9bLWo0@41od=3@onVYZKooooooi6ATOlT92Co4a<ComCDe002ooooo`06
od10@?moOgoooooooooooom0@43oOgmo0_ooool01_nSXj?o71`LoooooooX
j>So0@41olG5a@;ooooo00KoZj^[oa4A4Ooooooof=SHo`000?ng]kL2oooo
o`0<okNg]ol0003og=cLoooooomEEEGoLg=coa`L7?oXj>So_Kfmob4Q8Om^
KVkoPH611?ooool00oo5aLGo5QHFoi>CT`02ooooo`03onGUiOlJ6Q[oXZ:R
00Gooooo00[o9bLWoiJFU_ooooooooooolo?col410CoinOWoooooolW9bOo
UYJF0_ooool01_o?cloo10@4onOWiooooooo9bLWoiJFUP;ooooo00?oclo?
o`@41?oWinL0`?ooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^
0;cok^k^01;oj^[Zon;Rh_nPX:3o[Zj^om[Jf_oQhN7ojn_[ono_koobl_;o
l?3`ong]kOoZj^[oh>3PomSHf?nd];CoUYJFon3Ph?oZj^X5onk^kP03oc8b
<_m/K6cok^k^00Cok^k^00Ko>c/kogIfM_o^k^kok^k^oc/k>omfMWH2onk^
kP06oiRHV?lJ6Q[ok^k^onk^k_lY:BWoRHV90_o^k^h00on5QHGo;2`/onk^
kP02onk^kP04on7QhOl92@Wo3Ph>onKViPOok^k^01;oj^[Zon;Rh_nJWZ;o
L9O2oiK8oOnRdOkoWLSfog>B/_m5EVOo@51PofV6YOnE_nkoV/cnoho3n_m^
V/WoRi2Gon3Ph?oZj^X5onk^kP09oc8b<_nJVY[ob<S8o`000?o5aLGo9bLW
okZj^_nb/[;o0@4100;ok^k^00WoXJ6Qobh^;_l_;boo<S8boadM7Oo^k^ko
/K6ao`000?o0`<001?o^k^h00oo7alOo0000ohj>SP04onk^kP03om;Bd_l0
003o[Zj^00?ok^k^00Coh>3PodU9BOl71`OohN7Q1_o^k^h01?mRHV;o@D51
o`l?3omTI6@7onk^kP0Bon[Zj_oRh^;oX:2Pojj^[_oJf][ohN7Qon_[joo_
knool_;boo3`l?o]kNgoj^[Zon3Ph?oHf=So];BdoiJFU_oPh>3oj^[Z1Oo^
k^h02OmnOWko:RXZoh^;RomRHV;ok^k^oe5ADOmJFU[oDe=Coh:2PP02onk^
kP06oc/k>omfMWKok^k^onk^k_lk>c_oMWIf0_o^k^h01_nHV9So6QXJonk^
k_nc/k?o0000omKFeP;ok^k^00KoX:2Po`l?3oo^k^ko/K6ao`000?oFe]H2
onk^kP0<omCDe?l0003o];Bdon[Zj_l>3Pko/;2`of5QHOn?ShooKfm_oemO
Gonc/k?o:RXZ0_o^k^h01OoDe=CoADE5o`820_mYJFWoiNGU00?ok^k^00?o
b<S8oaPH6?nNWYh00oo^k^h00ooTi>Co0000okFe]@02onk^kP06on[Zj_l0
003o[jn_onCTi?l0003o]KFe0_o^k^h01_oZj^[o0000ojn_[ooTi>Co0000
okFe]@;ok^k^00?oj^[Zo`000?n_[jl0`?o^k^h1oiBDU07ok^k^0002onKV
iP03oiBDU?oVi^Koi^KV0;coi^KV00SohN7QomkNg_nEUIGo]kNgolk>c_oH
f=Soh>3Pon7Qh@;oi>CT00Sohn?SomkNg_oIfMWobl_;okRh^?n<S8cofm_K
on7Qh@Goi^KV00?o<30`ofQXJ?oVi^H01?oVi^H01_li>CWoLW9bonKVi_oV
i^Ko>CTioe=CD`;oi^KV00KoSHf=oaXJ6_oVi^Koi^KVobLW9on4Q8@2onKV
iP03oh20P?l[:b_oi^KV00;oi^KV00CoJVYZoadM7Om1@D7oJFUY1ooVi^H0
2?oQhN7og]kNoh^AUomVUlooQKWaoi?5non9]>;o:3A30_l000002?lL9S7o
NZ7@oho2nomo/^goHIGAogN2SooKfm_ohN7Q1OoVi^H02Ol`<33oU9BDofm_
Kol[:b_oi^KVog]kNomNGUko[:b/o`410@04onKViP07onCTi?n5QHGo7AdM
onKVi_o5aLGo0000oh:2PP04onKViP03oj:RX_l0003o`l?300Coi^KV00?o
h^;Ro`000?n:RXX00_oVi^H01?nTY:Co6ATIoa@D5?n[Zj/7onKViP04om_K
fol@413o5QHFom[JfPOoi^KV00SohN7QomkNg_nEUIGo]kNgolk>c_oHf=So
h>3Pon7Qh@;oi>CT00Sohn?SomkNg_oIfMWobl_;okRh^?n<S8cofm_Kon7Q
h@Goi^KV00Wo?ShnofATI?nm_Kgo9RHVonKVi_lH61SoRh^;oi6ATOln?Sh0
0_oVi^H01_li>CWoLW9bonKVi_oVi^Ko>CTioe=CD`;oi^KV00KoSHf=oaXJ
6_oVi^Kob/[:o`000?nPX:02onKViP06oi^KVol?3`ooi^KVolK6a_l0003o
XZ:R0_oVi^H04OnPX:3o0000ol[:b_n_[joo2PX:on3Ph?nTY:Co@d=3ob`/
;?nIVIWoi>CToa<C4oo4a<Coi^KVocXj>_lk>c_oaLG500Koi^KV00?oa<C4
oaPH6?nFUYH00_oVi^H00oo5aLGo0000okfm_@03onKViP05o`/;2onATI7o
aLG5o`000?nm_Kd00ooVi^H01Ol;2`_oTI6AolG5aOl0003o_Kfm00?oi^KV
00?o2`/;oi6ATOoVi^H0_ooVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^
k^kok^k^0;cok^k^01;oj>SXong]kOnHV9So];Bdol;2`_o<c<cod];Bom?C
dooEeMGoe=CDom;Bd_o?cloocLg=ol30`?nc/k?oRXZ:onc/k?oYjNT5onk^
kP03oc8b<_m/K6cok^k^00Cok^k^00[o>c/kogIfM_o^k^kok^k^oc/k>olB
4Q;oKVi^olo?comADE7oAdM70_o^k^h01_lY:BWoRHV9onk^k_o^k^koQHF5
ob`/;0;ok^k^00KoYJFUo`H61_nm_KgofMWIoaHF5_nf][H6onk^kP07onSX
j?o]kNgoRi:JoeB<b_maY=ooO;?^ogBTe`02o`410P09o`<41_l0003oH8Rg
ogjgmOmZX=coCHK;ofmmS_o/k>cojNWY00Gok^k^00Wo<S8boiVIVOlM7Ago
PH61onk^k_oDe=Co4Q8Boj^[Zol10@400_o^k^h01OnXZ:Sobl_;on_[jomJ
FU[oCTi>00;ok^k^00Wo>SXjob@T9?na/K7okNg]olo?coo^k^ko^KVio`00
0?o5aLD01?o^k^h02?o3`l?o0000oinOWoo^k^koN7Qho`000?m@D53oe]KF
2?o^k^h01?n[Zj_o0000o`T92Oo5aLD7onk^kP0BonSXj?o]kNgoV9RHokBd
]?o2`/;oc<c<om;Bd_oCdm?oeMGEomCDe?oBd];oclo?olg=cOo0`<3o/k>c
ohZ:R_o/k>cojNWY1?o^k^h03_oXj>So20P8ojJVY_o]kNgo3`l?ol71`Ol0
003oalO7omSHf?l820SoiNGUonk^k_lk>c_oMWIf0_o^k^h01_lk>c_o4Q8B
ofi^K_o?clooDE5AodM7A`;ok^k^00Ko?Shnod51@OoCdm?ofm_Koda<C?l?
3`l2onk^kP0Goc`l??m3@d?oclo?olk>c_m2@T;o?cloonk^k_m`L73oAdM7
onk^k_oWinOo410@o`820_oMgMgok^k^oemOGommOGgok^k^oc<c<on<S8co
k^k^omSHf?oYjNT01Oo^k^h01onk^k_o20P8okRh^?o^k^kof][Jo`000?nk
^k/00oo^k^h01Ol410CoXj>Som[Jf_l0003o^k^k00?ok^k^00Go10@4oj>S
XooJf][o0000ok^k^`03onk^kP03o`@41?nSXj?ok^k^0;ook^k^0OnDU9@1
onk^kP000_ooool00onDU9Coooooooooo`2looooo`0BooShn?oooooo[Jf]
oi^KVonb/[;o_Kfmol?3`oo4a<Co`l?3ol71`Oo2`/;o`L71okfm_Ona/K7o
V9RHoiZJV_oooooon_[j1Oooool00olf=SKoM7Adooooo`04ooooo`0:oeAD
E?n=SHgooooooooooomDE5CoS8b<ogUiNOlD51Co;Rh^olC4a0;ooooo00[o
@d=3oijNW_oooooooooooi^KVom6ATKoooooonWYjOl/;2coUiNG0_ooool0
0on_[joo?clooo[jnP05ooooo`08ooShn?ooooooXZR_oc=[[om@RlgoGiWP
of6IfOlK:3H2o`@10008oa8K8omGRlKoGY_SodZ7bolWI:koPhjMoooooooj
n_X5ooooo`04ocHf=_mZJV[o0P82onGUi@;ooooo00?oATI6ofa/K?l20P80
0_ooool01On:RX[o<S8boa0@4?li>CWoa<C400;ooooo00Woj>SXoeMGEol?
3`oo2`/;obHV9_ooooook^k^o`<30onRXZ801?ooool01_n:RX[o0000omKF
e_oVi^Ko0P82oi>CT`Wooooo00KomOGeob0P8?mCDe?oQHF5ocDe=Oolo?`6
ooooo`0BooShn?oooooo[Jf]oi^KVonb/[;o_Kfmol?3`oo4a<Co`l?3ol71
`Oo2`/;o`L71okfm_Ona/K7oV9RHoiZJV_oooooon_[j1?ooool01oo2`/;o
0`<3oo7alOooooooC4a<oeUIFOlB4Q800_ooool01Olb<S;o]KFeoooooomD
E5CoSHf=00;ooooo00KoE5ADohb<S?miNGWo51@Dobh^;_o4a<@2ooooo`06
onKVi_m4A4Co30`<obPX:?m]KFgo4A4A0_ooool02OoXj>SoDU9Bo`l?3ol?
3`ooE5ADonWYjOooooooBTY:oijNWP02ooooo`0<of5QHOm5ADGooooooooo
oonm_KgoCDe=oooooono_koo>SXjoa0@4?lC4a?oj>SX1_ooool01_lo?coo
KFe]oooooooooooo2PX:ojj^[P;ooooo00Kojn_[o`000?o@d=3oooooo`X:
2_n^[Zh2ooooo`06on_[jol0003od=3@ooooool:2P[o[Zj^0_ooool00oo[
jn_o0000om3@d030ooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^
k^h0_?o^k^h01ooYjNWok^k^ok^k^on6QXKoVi^Kojn_[onl_;`00_o0`<00
2Oo1`L7o_knook^k^ona/K7oVYZJoginO_nYZJWok^k^on[ZjP05onk^kP03
oc8b<_m/K6cok^k^00_ok^k^00?okNg]onk^k_o^k^h05_o^k^h04_oYjNWo
k^k^okBg^olWFICo:6VdodB3cOmKU][oFHNhodAHK?m2E6GoEGn/oeREe_m4
Q]3o96JcoaE8TOnMXZ_ok^k^on[ZjPGok^k^00?o<S8boa8B4_ln?Sh00oo^
k^h00onIVIWo4A4Ao`410@04onk^kP03onc/k?o^k^kok^k^00Gok^k^00Oo
jn_[onk^k_o^k^kok^k^of1PH?lY:BWohN7Q00;ok^k^00Ooj>SXoc<c<om6
ATKok^k^olW9bOl10@7oemOG00Wok^k^00KoK6a/o`h>3_oFe]Kojn_[oc0`
<?mnOWh6onk^kP07onWYjOo^k^ko^k^kohJ6Q_nKVi_o[jn_okbl_002ol30
`009ol71`Ono_koo^k^kok6a/OnJVY[oOWinojVYZOo^k^koj^[Z00Cok^k^
00OoMgMgoc8b<_o^k^kok^k^ogmoOol20P;oATI600;ok^k^00?oLW9bofEU
IOo^k^h01oo^k^h00oo]kNgok^k^onk^kP04onk^kP04onc/k?o^k^koX:2P
o`l?3`Cok^k^0_o]kNd@onk^kP03on_[joo^k^kok^k^00;ok^k^00KokNg]
onk^k_o^k^kok^k^obh^;_mbLW82onk^kP06oeeMGOmKFe_ok^k^onk^k_nD
U9Co:2PX0_o^k^h01_mMGEgoFe]Konk^k_o^k^koU9BDobPX:0;ok^k^00Ko
GEeMoe]KFoo^k^kok^k^oiBDU?lX:2S1onk^kP7oU9BD0Oo^k^h000;oi^KV
00?oU9BDonKVi_oVi^H0_?oVi^H04_oShn?oi^KVomOGeon;Rh_oOgmoojBT
Y?nn_[koc<c<om7AdOoDe=Cod];BolO7aonXZ:SoO7alogAdM?o<c<coi^KV
onCTi0Goi^KV00?o<30`ofQXJ?oVi^H01?oVi^H00omBDU;oPh>3onKViP0M
onKViP0Bon?ShooVi^Koe]KGoe1ZT_lAB9Co?7FnogFPgOnG^NcoZ<Ghojc;
o?nQ`oCoPj_TodMj`olB?YCo>DR1ol[:cOoVi^Koi>CT1OoVi^H00ol`<33o
0000ohj>SP03onKViP03omcLg?l:2P[o0@41013oi^KV00SoeMGEoc/k>olT
92CoMgMgogalO?l^;Rko;Bd]ol_;b`;oi^KV00Go@T92oc@d=?n0P83oF5QH
odm?C`05onKViP03okVi^Ol20P;oRXZ:00;oi^KV00?o`<30o`d=3Oo1`L40
1OoVi^H04_oShn?oi^KVomOGeon;Rh_oOgmoojBTY?nn_[koc<c<om7AdOoD
e=Cod];BolO7aonXZ:SoO7alogAdM?o<c<coi^KVonCTi0Coi^KV00Oo=cLg
ofe]KOoVi^Koi^KVok:b/_l0003oMgMg00;oi^KV00Go[jn_ob8R8_oVi^Ko
DU9Boh>3P`0>onKViP03oi^KVol?3`ooi^KV01[oi^KV00KoDE5AodU9BOn:
RX[oEUIFo`D51Oo<c<`2onKViP06olW9bOlJ6Q[oKVi^ohB4Q?lF5QKoYZJV
0_oVi^H01_o9bLWo6QXJofi^K_n4Q8Co5QHFojJVYP;oi^KV00KobLW9oaXJ
6_m^KVkoQ8B4oaHF5_nVYZK1onKViP7oU9BD0OoVi^H000;ok^k^00?oU9BD
onk^k_o^k^h0_Oo^k^h04?o[jn_ok^k^ol71`OmcLg?oOgmoojVYZOo4a<Co
dM7Aom?Cdoo8b<So];BdohJ6Q_mTI6Co[jn_onk^k_o[jn/6onk^kP03ojBT
Y?nj^[[ok^k^00Cok^k^00?oZ:RXokno_oo^k^h07_o^k^h04?o[jn_ok^k^
okJi`_la@83o=DBFogj2`onf]N7od/k^om[El?o7a>OoVIc@odmDWOl^;gCo
Xj>conk^k_o[jn/6onk^kP03ojBTY?n?ShoohN7Q00Cok^k^00?oZJVYoi2@
T?o^k^h04?o^k^h01_o/k>coXJ6Qog1`L?m/K6coVYZJonSXj0?ok^k^00Go
j^[ZojVYZOmVIVKoOWinok:b/P05onk^kP03okBd]?nEUIGokNg]00?ok^k^
00?o[jn_okJf]_o^k^h01Oo^k^h04?o[jn_ok^k^ol71`OmcLg?oOgmoojVY
ZOo4a<CodM7Aom?Cdoo8b<So];BdohJ6Q_mTI6Co[jn_onk^k_o[jn/5onk^
kP07oiJFU_o=cLgok^k^onk^k_oYjNWoShn?om3@d002onk^kP05on[Zj_n?
Shoojn_[ojRXZ?no_kl03_o^k^h00onPX:3o3`l?onk^kP0Jonk^kP05om[J
f_nQXJ7oJf][oi2@T?oLg=`01?o^k^h01?oBd];oOGemog1`L?nn_[h4onk^
kP04om;Bd_mmOGgoL71`okjn_PCok^k^00Cod];BogemOOm`L73o_[jn`_o^
k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0;kooooo0_ono_h0
1?no_kooIVIVoeaLG?n3Ph<2oiVIV@06ohJ6Q_mRHV;oF5QHojb/[?ojn_[o
o_kn<?ooool2ooknoP0<okBc`_m5@gKoA4=eogQhU?nEUZKoUiRPoh20TOmB
DWCo@T9Yoj:R/_ojn_[oo_kn@oooool2ooknoP04okno_omVIVKoG5aLoh>3
P`;oVIVI00KoQXJ6of9RH_mHF5So[:b/oo[jn_ono_hRooooo`03ookno_oj
n_[ooooo0?Wooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP2n
onk^kP?okNg]00_oc<c<oh20P?mIFEWoA4A4od51@OmGEeOoMgMgol30`?o/
k>cok^k^ong]k@0`onk^kP?okNg]00_obLW>ogalR_mBDUSo=cLioc<c<om=
CDkoLW9koknoa?o/k>cok^k^ong]k@13onk^kP?okNg]00_oc<c<oh20P?mI
FEWoA4A4od51@OmGEeOoMgMgol30`?o/k>cok^k^ong]k@3oonk^kQook^k^
0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP2oonKViP;oiNGU00So
i^KVonGUiOoEeMGobLW9olS8b?oCdm?ohn?SonKViP;oiNGU<_oVi^H2onGU
i@08onKVi_oUiNGoeMGEolW9bOo8b<Sodm?Con?ShooVi^H2onGUiDGoi^KV
0_oUiND02?oVi^KoiNGUomGEeOo9bLWob<S8om?CdooShn?oi^KV0_oUiNGo
onKViR3oi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^
k_ook^k^Noo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oo
oooooooooomkooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0
ooo^k^koonk^kW_ok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKV
iP3oonKVi_ooi^KVNooVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^ko
k^k^0?ook^k^ooo^k^ikonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDoooo
ooooool0ooooooooooooog_ooooo0OnDU9@1ooooo`000_o^k^h00onDU9Co
k^k^onk^kP3oonk^k_ook^k^Noo^k^h1oiBDU07ok^k^0002onKViP03oiBD
U?oVi^Koi^KV0?ooi^KVoooVi^IkonKViP7oU9BD0OoVi^H000;ok^k^00?o
U9BDonk^k_o^k^h0ooo^k^koonk^kW_ok^k^0OnDU9@1onk^kP000_ooool0
0onDU9Coooooooooo`3oooooooooooooNoooool1oiBDU07ooooo0002onk^
kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^ikonk^kP7oU9BD0Oo^k^h000;o
i^KV00?oU9BDonKVi_oVi^H0oooVi^KoonKViW_oi^KV0OnDU9@1onKViP00
0_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^Noo^k^h1oiBDU07ok^k^
0002ooooo`03oiBDU?oooooooooo017ooooo00?ok>c/oogmoOooool00_od
m?@3ooooo`03onGUiOomoOgooooo00Oooooo00?ok>c/ono_koooool0oooo
oooooooooeGooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP05
onk^kP03oc8b<_m_Kfook^k^00Cok^k^01;o>c/kogIfM_o^k^kok^k^od];
Bol71`Oo61PHoi6ATOlA4A7oDE5Aonk^k_o4a<Co8R8Roa`L7?n][Jgok^k^
og=cLolm?Cd3onk^kP06olc<c?la<C7o3@d=o`/;2ole=CGocLg=0_o^k^h0
0olk>c_oMWIfonk^kP02onk^kP06oc/k>omfMWKok^k^onk^k_maLG7o?Shn
0_o^k^h00onXZ:So20P8onk^kP3oonk^k_ook^k^@_o^k^h1oiBDU07ok^k^
0002onKViP03oiBDU?oVi^Koi^KV00Goi^KV00?o<30`of][JooVi^H01?oV
i^H02Oli>CWoLW9bonKVi_nb/[;o0`<3olO7aoo?clooDU9Bo`l?3`02onKV
iP03ofEUIOlj>S[oiNGU00;oi^KV00OoKfm_oc/k>ooVi^Koi^KVonGUiOl^
;RkoBDU900;oe]KF00KoC4a<obl_;ooUiNGoi^KVocTi>OmbLW83onKViP06
ocTi>OmbLW;oi^KVonKVi_m^KVko?3`l0_oVi^H00onRXZ;o20P8onKViP3o
onKVi_ooi^KV@_oVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^
00Gok^k^00?o<S8bofm_Koo^k^h01?o^k^h02Olk>c_oMWIfonk^k_o:b/[o
0P82ok2`/?o^k^koU9BDoadM7@02onk^kP03odM7AomZJV[ok^k^00;ok^k^
00OoLg=cocdm?Oo^k^kok^k^olW9bOl0003oZZZZ00;ok^k^00KoZZZZo`00
0?o=cLgok^k^oc/k>omfMWH3onk^kP06oc/k>omfMWKok^k^onk^k_maLG7o
?Shn0_o^k^h00onXZ:So20P8onk^kP3oonk^k_ook^k^@_o^k^h1oiBDU07o
k^k^0002ooooo`03oiBDU?oooooooooo00Gooooo00Co=SHfoeMGEoo8b<So
k>c/0oooool02Om0@43oOgmooooooooooooo[Jf]oc8b<_lc<c?o=SHfob0P
8002ooooo`03ode=COmbLW;ooooo00;ooooo00OoO7alod92@_oooooooooo
okjn__l0003oi^KV00;ooooo00Koi>CTo`000?o1`L7ooooood10@?moOgl3
ooooo`06od10@?moOgoooooooooooomjNW[o@d=30_ooool00ond];Co2@T9
ooooo`3ooooooooooooo@_ooool1oiBDU07ooooo0002onk^kP03oiBDU?o^
k^kok^k^00Gok^k^00Wo<S8boa`L7?lN7Qko0000oeADE?oShn?ok^k^oc/k
>omfMWH01?o^k^h00oo/k>coRXZ:oahN7P02onk^kP03odM7AomZJV[ok^k^
00;ok^k^00OoLg=cocdm?Oo^k^kok^k^olg=cOl0003oZ:RX00;ok^k^00Ko
YZJVo`000?oAdM7ok^k^oc/k>omRHV83onk^kP0:oc/k>omUIFGok^k^onk^
k_m`L73o;bl_ong]kOo^k^koYjNWo`P82?ook^k^ooo^k^i3onk^kP7oU9BD
0Oo^k^h000;oi^KV1onDU9@02_oVi^Ko<30`of][JooVi^Ko_[jno`X:2_mO
Geooi^KVocTi>OmbLW82onKViP0Goj:RX_o4a<Cohn?SoeMGEom;Bd_oi^KV
on3Ph?m1@D7oHV9RomcLg?oRh^;ohN7QofYZJ_lh>3Sog=cLon7QhOoVi^Ko
>SXjod10@?o8b<SoalO7od10@?lm?Cd00_oVi^H04?li>CWo4A4Aoh:2P_o=
cLgoi>CTocTi>OlB4Q;oOWinom7AdOlh>3So6a/KoeIFE_o;bl_oIFEUobh^
;_oVi^KooiBDU?ooU9BD@onDU9@1onKViP002_o^k^h02Olb<S;oKfm_onk^
k_o^k^koH61PoadM7Oo^k^ko>c/kogIfMP02onk^kP0Coh20P?l^;Rko3Ph>
ocDe=Onf][Kok^k^ogIfM_l71`Oo2`/;oaTI6OnRXZ;oQHF5o``<3?l61PKo
6ATIohb<S?o^k^kof=SHoda<C002o`h>3P0Codi>C_oIfMWok^k^onk^k_m>
CTkoOgmooeIFE_l820Soh>3Podi>C_n1PH7oJFUYo`h>3_lU9BGoa/K6ohn?
SolH61So7AdMoj6QX@3oonk^k_ook^k^AOo^k^h000[ooooo00Wo=SHfogMg
MoooooooooooodE5AOm4A4Cooooood10@?moOgl01?ooool00oomoOgooooo
ooooo`02ooooo`03ode=COmbLW;ooooo00;ooooo00?oOgmood51@Oooool0
1?ooool2ooknoPOooooo00?oo?clooooooooool00_ooool00oono_kooooo
ooooo`02ooooo`03ookno_oooooooooo0?oooooooooooom4ooooo`002_o^
k^h02Olb<S;o:b/[oeADE?lT92Co0@41oj:RX_o^k^ko>c/kogIfMP09onk^
kP03om7AdOo?clook^k^00;ok^k^00?o[:b/oa`L7?o^k^h0ooo^k^koonk^
kUkok^k^000:onKViP05oijNW_n:RX[oRh^;oibLW?o8b<P00_oVi^H00oli
>CWoLW9bonKViP0=onKViP05on3Ph?ln?Sko7alOoaTI6Oo1`L40oooVi^Ko
onKViUcoi^KV000Aonk^kP03on[Zj_o/k>cok^k^00ook^k^00?ofMWIomkN
g_o^k^h0ooo^k^koonk^kUcok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oogmoOeOoOgmo1omnOWko
ogmoObCoOgmo00001?o[jn_oi^KVon;Rh_oNg]h4omgMg@?og]kN0?oogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oLg=cog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMd001Kog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomcLg?oMgMgofm_K0_oLg=`0<ooMgMgogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNgP02omcLg005omWIfOoHf=SoemOGomSHf?oIfMX00_oL
g=`0oooNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNgP005ooMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN00?og]kN
00?ogMgMomkNg_oNg]h00ooMgMd1on7Qh@7oinOW0OoZj^X00003onc/k?oV
i^Koh>3P00OofMWI00Cof=SHomKFe_oCdm?od=3@0oo=cLd01?o@d=3odm?C
omOGeooHf=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?C
dooGemOof=SH1OoIfMT00ooHf=SofMWIomWIf@03omWIf@04omSHf?oGemOo
dm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SHfooIfMT2omSHf006omKF
e_oCdm?odm?ComCDe?oGemOof=SH0_oIfMT00ooHf=SofMWIomWIf@02omSH
f0WofMWI00?of=SHomWIfOoIfMT00_oHf=P00ooIfMWof=SHomSHf002omSH
f1OofMWI00Cof=SHomKFe_oBd];oclo?0_o=cLd01?o?cloodm?ComOGeooH
f=SoomWIfAKofMWI00?of=SHomWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/
k>`00007onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkN
g_oLg=codm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_K
omoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o
^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk
^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`3Jon7Qh@09on3P
h?oOgmoofm_KomKFe_oDe=Coe]KFom[Jf_oNg]koh>3P00KogmoO0ooPh>00
0ooOgmooh>3Pon3Ph002on3Ph0SogmoO0_oNg]h2omoOg`?oh>3P0_oOgml2
on3Ph0;ogmoO3OoPh>001OoOgmoogMgMomWIfOoEeMGodm?C00;od];B00?o
e]KFomcLg?oPh>00oooQhN4Hon7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoT
i>@1onWYj@7okNg]00000oo`l?3okno_oo7al@03oo3`l03oono_koo`l?3o
k^k^onWYjOoKfm_o`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2
`/7of][Jon[Zj_o]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aong]
kOoZj^[of][Jol;2`_nTY:CoS8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2
om[Jf_oZj^SokNg]oo7alOo_knoolO7aono_kooalO7okno_oo7akoo]kNgo
j^[Zom[Jf_o2`/;oY:BTohb<S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJ
f][oj^[Zong]kOoalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_000Koo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNook^k^ono_kooZj^[oinOW00;o
h>3P00Oohn?Son_[jOo[jn_oj^[ZonKVi_oXj>SoinOW00;ojNWY01;ok^k/
onc/k?o/k>coj>SXonc/k?o]kNgol?3`onc/k?oZj^Soi^KVonSXj?oWinOo
jNWYonSXj?o[jn_oinOWonOWiOoUiND2onWYj@0?onk^k_o]kNgokNg]onSX
j?o[jnWok>c/onk^k_oYjNWoj^[Zon_[joo_knook>c/onc/j_oZj^[ok^k^
00;ok>c/0?ooj^[Zono_koo/k>cok>cZon[Zj_o^k^kok>c/ojn_[omfMWKo
FEUIofi^K_ng]kKoh>3PonWYjOo]kNgolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knl002golO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`l?o_knl01?o`
l?000003oo;bl_o^k^koinOW00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:
R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN
0_oTi>@00ooUiNGoi>CTonGUi002onCTi00?omkNg_oAdM7o/K6aohZ:R_mV
IVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM3og]kN00;o
i>CT0>goiNGUonCTi?oUiNGoi>CTonCThooNg]kodM7Aok6a/On:RX[oIVIV
oe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7AomkNg_oTi>?o
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiN@00_oTi>@0ooo5aLGo:2PXodA4A?n@T93odM7AomcLfooKfm_o
emOGomCDe?oFe]Koe=CDomGEeOoIfMWoh>3OomkNg_oJf][oe=CDomWIfOoN
g]koh^;RomcLg?oGemKoe=CDomKFe_oDe=CoeMGEomSHf?oKfm_oemOGomKF
eOoEeMGoemOGomSHf?oNg]kogmoOomcLg?oEeMGoemOFomcLg?oMgMgoemOG
omKFe_oKfm_ohN7QomkNg_oKfm[of][JomkNg_oLg=cof][Jom_KfooPh>3o
gmoOomcLfooIfMWog]kNomoOgomdM7CoIfMWohf=SOmDE5Co20P8oj:RX_oL
g=coh^;RonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i000F?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>@4onGU
i@06onCTi?oUiNGoiNGUonGUiOoXj>SokNg]0Oobl_800003ooCdm?o]kNgo
inOW00;oh>3P01?ohN7QomoOgooNg]kod];BokBd]?n7QhOoG5aLofdk=OnN
CT;ocFmOonV3Koo=KeooWTi3ofdk=_mLG5coQhN7okBd]?oBd];og]kN00Go
h>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m]H2coWYH^olg=?ooYjDgocLdo
oijJ;om]HbgoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomkNg_oBd];o
];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=AomZWSCoBFX_oeaLG?n7
QhOo];Bdom;Bd_oNg]h0fOoPh>001_oOgmooclo?oiVIVOnBTY;o6ATIohb<
S0;oeMGE01ooclo?ol;2`_o>c/koc/k>olG5aOo:b/[of][JomSHf?o@d=3o
bl_;olo?cooHf=Sof][JomGEeOo?cloo`L71om3@d?o>c/koa<C4ol_;booH
f=SoemOGokjn__nk^k_odM7Aom3@d?oEeMGof=SHom?Cdoo<c<coc/k>00;o
eMGE00Goc/k>olc<c?oCdm?of][JomSHf002om;BdP04omSHf?oGemOodM7A
om?Cd`;ofMWI00Kodm?Com7AdOoGemOof=SHom7AdOo@d=02om7Ad@04odI6
A_m1@D7oemOGomkNg_ooh>3P5_oPh>000ooOgmooh>3PomoOg`02omoOg`?o
h>3P00?ohN7QonOWioo/k>`00Oodm?@00003ooKfm_obl_;ojn_[00?oj>SX
01?oinOWon;Rh_o=cLgoWinOof]OGon?=RkokG5QooVMT?om/JGooKb_oofd
YooiWi?okGASoi8g;om[GeooWinOolg=cOoRh^;oinOW00?oj>SX01?oinOW
on;Rh_o=cLgoWinOofiVGonCLR;okM54ooWcM?omoHgooOfEoogmS_oin7Ko
kMM7oi=c8_m^IeooWinOolg=cOoRh^;oinOW00?oj>SX01?oinOWon;Rh_o=
cLgoWinOof1XGom;O2?oT^5;okgiNoo@oI;of?fKomCmUOo0nGkoV>Q=odf0
9?mPJEooWinOolg=cOoRh^;oinOW0=[oj>SX00Coi^KVon7QhOmMGEgoCDe=
0_oMgMd07om@D53o1`L7oaDE5On4Q8Co5QHFod=3@ooRh^;ogMgMoibLW?l0
003oShn?omgMgOoQhN7ofm_Kod10@?l820So6ATIohR8R?l;2`_oF5QHokNg
]ol<30co1`L7ob<S8olW9bOoOGemom[Jf_oMgMgoe=CDo`/;2omIFET00_oI
fMT00omMGEgo2`/;om?Cd`02omoOg`06oeYJF_m>CTkog]kNomkNg_lS8b?o
Q8B40_oQhN403?mjNW[o;Rh^omgMgOoMgMgo`/;2oe1@D?lc<c?oKVi^oh>3
PolQ8B7og]kNonKVi_ooj>SX7ooXj>P1onc/k07ol_;b0Oofm_H00003ooOg
moohn?Son?Sh00?on?Sh01?omoOgonk^k_o>c/koT92@ohD_:ooYI5Koni:7
oojVVoon/JGookR[oojcY_onZ9coniB9oniXFOn9<B_oT92@olk>c_o^k^ko
moOg00?on?Sh01?omoOgonk^k_o>c/koT92@oiUY:oo`_Cgonn1^ookdP_on
oX[ooonBooknS?onn8?onnE`oo32?_nIJR_oT92@olk>c_o^k^komoOg00?o
n?Sh01?omoOgonk^k_o>c/koT92@od9c:on4cT?o[Nmcol;nR?o>oY3oe_nG
om3nT_o6oXWo/_EdohSC@om4MB_oT92@olk>c_o^k^komoOg0=[on?Sh02Go
m_Kfoo7alOn1PH7o7alOong]kOo6a/Ko0000ol?3`ooCdm?oG5aLo`P82?oZ
j^[ol?3`on[Zj_mBDU;o51@Docdm?OoYjNWol?3`ojn_[ol71`Ood];Bolg=
cOm>CTko6a/Konk^k_oKfm_o[Zj^onSXj?o/k>co[Zj^o`000?nd];Cok>c/
ok2`/?l;2`_o6QXJ00;oi>CT00_o8b<So`h>3_nTY:CokNg]onk^k_mPH63o
E5ADonk^k_o]kNgo9RHVohf=S@02oo3`l00<oh:2P_la<C7ok>c/on[Zj_m3
@d?o;bl_oibLW?mcLg?o:RXZoaXJ6_o^k^kom_Kfooohn?PHooShn003ooOg
moohn?Son?Sh00;on?Sh00ComoOgooWinOogmoOomoOg0Oohn?P00003oo[j
n_oemOGok^k^00;ok>c/0?oojn_[onWYjOoOgmoo^[ZjogUBD_no<RCoigAY
oof9O_ooV8cooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<TogUBD_nj^[[o
gmoOon[Zj_o[jn_ok>c/on_[k?oZj^[ogmoOokZj^_n8IE;ohY4LooW3D?om
fV?oonYbookcO_oonX;oo_Ioooo/LoongVCon/MAon:B7?n9IU?o^[ZjomoO
gooZj^[ojn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S7?nAdUGoY^MZ
okSiN_o0oX;oaon9ol?nQ?nioG_oYna/oiCFEomBYQcoDVeBokZj^_oOgmoo
j^[Zon_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jn`004Wok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojNWYonGUiOmjNW[o71`Lon7Qh_o<
c<co0`<3oj2PX?oNg]koU9BDoa<C4ooQhN7oh>3Qom3@d?l61PKoXJ6Qo`T9
2Ono_koohN7QokZj^_l20P;o/[:bomgMgOn0P83o:2PXon?ShooWinOoiNGU
omoOgooKfm_odm?Co`P82?n5QHGogmoOofUYJOm:BT[o=CDeojf][Onm_Kgo
1`L7ogQhN?mEEEGogmoOon3Ph?mKFe_oD51@00;ohN7Q00[o92@TohF5QOoO
gmoohN7Qog]kNol_;booh>3PomCDe?l51@GoZ:RX0_oShn<0oomnOWoo5QHF
on7QhOoZj^[ojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[j`006_o/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/1_o[jn/0
1Oo/k>cojn_[on_[joo^k^kom_Kf007onOWi00000ookno_olo?cong]k@02
onGUi@0ZonKVi_oTi>CofMWIok:b/_mi;Rkob48don=ZG?odNVgooHQloojG
R_onVhkooYR;ooj:O_odNfgoif]MolY2=?mk;Rko/[:bomSHf?oTi>CoiNGU
onKVi_oUiNKoi>CTomSHf?nb/[;oUUD^onZL:ook_4Coo/aCoogHH_onhg;o
o^UeookVLoonffGooLaCoo_1AOo^WR_oVEH^ok:b/_oHf=Soi>CT0ooUiND0
oooTi>Cof=SIok:b/_l^HRkoHjd[ohO:B?nGg5WoYNEYok;cMonhmW_o]?Ei
ojOZJonHg5WoRLm;of>^:ol^Hbko/[:bomSHfOoTi>CoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oShn?ogmoOogMgMolK6a_og=cLon7QhOnNWYko;bl_ob/[:olb<S;o
4Q8BomcLg?oJf]_oQ8B4ob0P8?oPh>3oDU9BofQXJ0001ooJf][og]kNoi2@
T?lZ:R[o;Rh^ob`/;?lW9bL00_oNg]h04ooIfMWodm?Dom3@d?mKFe_o0000
okfm_OoJf][o:2PXohN7QomgMgSoJ6QXoh:2P_ll?3co`/;2o`l?3ooDe=Co
f][JoeUIFOm>CTh00_oLg=`0oolS8b?oPH61omGEeOoGemOoMgMgobh^;_oL
g=coXj>So`000?o7alOof=SHomWIfOn=SHko5ADEomcLg?oTi>CoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUi@009_oVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGV0_oVi^H00ooUiNGoi^KVonKViP03
onKViP03onGUiOo]kNgom?Cd007ono_k00000oolo?con?Shoo7al@03onk^
kP0Con_[jooQhN7o_;blogXG5oo3?c;odeI9onAXF_o_Mfcom8=iooR7O?oe
Q7[olgU]onEYFooIF4[oa3lbog`G5onl_;cohN7Qonc/k003onk^kP0Conc/
k?oQhN7o_;blojE75ooVUc;omJ``oofl@OombE?ooM1Poo_CIOomdV3oo/eD
oofm@_oj[c;ojI/bojE65onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o
_;bloaMI5omOZ3;oM[dgohK=AonFeU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg
_cOoGj/boaMI5onl_;cohN7Qonc/k03Jonk^kP0^onc/k?oWinOoNg]koa`L
7?oTi>CojNWYonKVi_oQhN7og]kNohf=SOlD51Coi^KVonCTi?le=CGoNGUi
on_[jonb/[;o5ADEomoOgooVi^Koi>CTon7QhOoMgMgoNWYjobTY:OoXj>So
iNGUomgMgOna/K7o9RHVo`/;2onKVi_ojNWYolc<c?l0003oc/k>ol?3`olU
9BGoBd];ogalO?oXj>So<C4aojFUYOoTi>CoGEeMoe5AD@;oinOW00[o9BDU
ofUYJOoOgmoogmoOogMgMola<C7ojNWYol71`Ol0003oYjNW0_oOgml01?nC
Ti?o5QHFonOWioo/k>coonk^kQkok^k^00?okNg]oo;bl_ohn?P00Oolo?`0
00?ooOgm01Koo?cloogmoOomoOgoo?cloo?clooAdM7oJ0L7okPd=?o7?c?o
dU13omYREOoSKV;oi79TonA_H_oLI5Oode53ola1=?ni=3CoJ`L7om;Bd_oc
lo?oo?cl0oomoOd04oolo?colo?com;Bd_nN:`OofXXdon^K6OoeZ2Won;@o
ooVmB_oh_dgon[m:ooVh?oofZR[okihIom^;=?nR;@Ood];Boo?cloolo?`0
0oomoOd04oolo?colo?com;Bd_l7@0OoCIXdoen[8?m`^2ooOl=3oh[=D?n=
cE;oR/i@oh77A?ma^BooHZhPodjK=?l7@POod];Boo?cloolo?`0f_omoOd0
8ookno_omoOgohB4Q?lN7Qkolo?cooWinOnc/k?od=3@oo?clomXJ6SoAdM7
oo[jn_oDe=Co0000omgMgOolo?cono_kobLW9onXZ:SonOWioj^[ZooEeMGo
lO7aoeADE?mNGUkonOWiooCdm?nDU9Co1@D5od10@?oAdM7omoOgooShn?nG
UiOo:b/[00;on_[j01_o92@To`L71oo8b<Sono_kohF5QOmSHf?omoOgof=S
HomGEeOon?ShooWinOlW9bOo5ADEoh>3PooGemOo@T92of=SHookno_on_[j
oc@d=?m9BDWofm_KonGUiOm?Cdoo5aLGoo[jn_olo?`0ooomoOdLoogmo@03
ooclo?omoOgoo?cl00?ooOgm0000>_omoOgon_[joo?cloo^k^kol?3`ono_
koo^k^kojNWYom?CdomK7AgoXS@dok@X7Oo1>RgoadTlolmFB_o@Ed_od5M:
olY:?_o3>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>oo
k^k^on[Zj_oCdm?oS2DMolQa=?oIQ1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/
X2GoiiLEomb87Oo8LCCoS2DMom?CdooZj^[ok^k^oo3`l?o_knool?3`onk^
k_oZj^Wodm?Coadh7OldPSCoAiDMoeZU6omY[BX2ogBh>03RogFi>?m[/B_o
FjLLodRJ7OldPSCo7CPMom?CdooZj^Wok^k^oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l0;okno_
0?ooj^[ZoginO_lL71coj>SWong]kOn8R8So<30`o`l?3ola<C7o/K6aonk^
k_n5QHCoCDe=ono_koo^k^kokno_ohZ:R_mIFEWok^k^ogQhN?l[:b_o3`l?
ocPh>?no_kookNg]onCTi?l>3PkoJFUYomoOgooShn?oiNGUon_[jomQHF7o
MgMgonk^k_o_knkoMWIfobHV9_o]kNgokno_olc<c?l/;2coj^[Zofe]K?mR
HV;ok>c/ong]kOlk>c_oTi>Cof9RH_l>3Pko=3@dolC4a?o_knook^k^om7A
dOll?3co2PX:obLW9om/K6co;2`/ono_koo^k^kol?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knl005Kol?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_k`;ol?3`1_o_knl1oo?cl`7onOWi0Oono_h0
0003ookno_ogmoOol?3`00CojNWY017oinOWom_KfomSBd_oPC8bojHe=Onf
=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mSBd_ofm_KonOW
i`05onWYj@0AonOWiooKfm_oRD];ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0d
on2P<_oOVRkoeX/]olYe=On_Bc;oRD];om_KfooWinL00ooYjNT04ooXj>So
jNWYonOWiooKfm_oBd];oc9P<_ljRCGoDi/]of^[;om`[CSoKjhjog2]>?mZ
ZRooDi/]ocV8=OlbH3;oBd];om_KfooWinL0fooYjNT01_oXj>Soi^KVog]k
NolL71coi>CTonSXj0;ojNWY00?oinOWonWYjOoYjNT02ooYjNT03?oWinOo
jNWYonWYjOoXj>Sof=SHo`X:2_n^[ZkogMgMomkNg_oPh>3oiNGUonSXj0So
jNWY00Koj>SXonKVi_oShn?ohn?SonKVi_oXj>P3onWYj@03onSXj?oYjNWo
jNWY00CojNWY00?oinOWonWYjOoYjNT0oooYjNTKonWYj@03onSXj?oYjNWo
jNWY00CojNWY0Oo`l?01ooOgm`7oo_kn00001Oono_kon_[jooCdm?o_knoo
lO7a00;ol?3`017okno_on_[jonEU9CoCb<SoiEDE?nkLg?odiFEomZLW?oJ
WYcofIbLomBEUOnkLg?oUEADodlS8onEU9Coj^[Zono_k`05oo3`l00Aono_
kooZj^[oZIBDoh4S8onjJUCoe9YconBlUOoZaicojLNLon[7W?oU_9Goe9Yc
ok]ZE?n18b?oZYBDon[Zj_o_knl01Oo`l?004Oo_knooj^[ZoiBDU?lS:R?o
E7YDog>ULonNaYGo[<jLojg>W?n/cYcoW/JEog>ULomDNUCo8bXSoiBDU?oZ
j^[okno_0=_ol?3`0_o_knl01?n0P83o7AdMonk^k_o_knlCoo3`l0;okno_
00OoI6ATobTY:On1PH7oHf=Soc/k>oo^k^kokno_00Sol?3`00Kokno_onk^
k_mcLg?oJFUYonk^k_o_knoooo3`l2gol?3`00ColO7aoo3`l?odm?Con_[j
0Oono_h00004ookno_ooooooooooooknoP;ooooo0_ono_h0ooomoOgon?Sh
ofi^K_mJ?coo/I2@omk9bOo`i>ColnKVoo3Ti?oNbLWo/I2@oeXo?om]KFgo
n?Shooclo?ooooooo_knooooooono_koooonookno_ooooooo?clooShn?n=
KFgoRSloolVAT?oYd<Wom>WTooK[i_odjNCojM39olVAT?n9?cooSFe]ooSh
moolo?coooooookno_ooooooo_knooooooono_koooonooclo?ohn?SoKFe]
oclo?on@WI3obMG9onC/i?oVk^Koi>cTolWEbOn@WI3o?cloofe]KOohn?So
o?clooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooooknoP00>?ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_oooooooOgmom3@d?nU
YJGoo_kmookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooomoOgo`L70og5aLOn1PH7o[jn_0_ono_h03?ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooomoOgo`/;1okbl_0;oo_kn0?oooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooool002Woo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooooknoP02ooooo`03ookno_oooooooooo00?ooooo0Oohnoh0
0004ooooooono_kon_[jooCdm0GolO7a00gokno_omKFe_m[Jf_o@cdmoi^<
S?o6^[[oe/c<olNj^_nKS8co@cdmof][JooFe]Kokno_00WolO7a00gokno_
omOFe_n3Jf_oM3dmokF<S?oE^[[ohLc<omJj^_nfS8coLSdmoh5[JooGe]Ko
kno_00GolO7a017ol?3`oo7alOoalO7olO7aono_kooFe]KoJf][ocdm?On<
S8co^[Zjolc=c?nj^[[oS8b<ocdm?Om[Jf_oe]KFono_k`3ooo7alOoolO7a
=?oalO401?o`l?3olO7aoo7alOo`l?04oo7al@03ooCdm?ojn_[oo_kn007o
j_;l00001OoemOGooOgmooShn?o`l?3ojn_[00?oj^[Z00gojNWYon[Zj_oY
jNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY00_o
j^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo@RHVofUIFOnPVi_oj>SX
onWYj@05on[ZjP03onWYjOoZj^[oj^[Z00?oj^[Z00_ojNWYonSXj?nKVi_o
FEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@3oon[Zj_ooj^[Z??oZ
j^X01?o[jn_ol?3`ooShn?omoOd1ofe]K@0000CoalO7oogmoOojn_[om?Cd
2?oalO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l0oolO7a
0_o`l?03ono_k`;ol?3`oooalO7ooo7alC[olO7a00?ol?3`oo7alOoalO40
0_oalO400ooemOGon_[jol?Je`01odalM`0000?oe=CDolk>c_ooool0oooo
ooooooooogcooooo0OoHj^P1ohRYY07oLInI00001Oobl_;oe=CDolK6a_oe
mOGoo_kn0?oooooooooooomgooooo`05ooCin?oLk>[o]]??ogNLUomaX9T0
0On1]Zl00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell["a panel is created on the frame", "Text"],

Cell[BoxData[{
    \(\(savedLayout = pane@getLayout[];\)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]\(pane@
          setLayout[
            JavaNew["\<java.awt.GridLayout\>", 5, 
              5]];\)\[IndentingNewLine]]\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(panel = NewJPanelTitledBorder[pane, "\<Platform\>"]\), "\n", 
    \(JavaShow[frame]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JPanel"] \[RightGuillemet]\),
      JLink`Objects`JavaObject59884762562561]], "Output"]
}, Open  ]],

Cell["buttons are created on the panel", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(group = JavaNew["\<javax.swing.ButtonGroup\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ButtonGroup"] \[RightGuillemet]\),
      JLink`Objects`JavaObject24024771985409]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]panel@
        setLayout[
          JavaNew["\<java.awt.FlowLayout\>"]]\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\( (*\ add\ buttons\ on\ JPanel\ *) \)\(\[IndentingNewLine]\)\(b1 = 
      NewJRadioButton[panel, "\<Linux\>"]\[IndentingNewLine]
    b2 = NewJRadioButton[panel, "\<MacOS X\>"]\[IndentingNewLine]
    \(\(b3 = 
      NewJRadioButton[panel, "\<Windows2000\>"]\)\(\[IndentingNewLine]\)
    \) (*\ add\ buttons\ to\ the\ group\ *) \[IndentingNewLine]
    \(group@add[b1];\)\[IndentingNewLine]
    \(group@add[b2];\)\[IndentingNewLine]
    \(\(group@add[b3];\)\(\[IndentingNewLine]\)
    \) (*\ select\ a\ button\ *) \[IndentingNewLine]
    b2@setSelected[True]\)\)\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JRadioButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject134235276967937]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JRadioButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject101088313212929]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JRadioButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject81624796495873]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(DeleteJObject[panel, b1]\), "\[IndentingNewLine]", 
    \(DeleteJObject[panel, b2]\), "\[IndentingNewLine]", 
    \(DeleteJObject[panel, b3]\)}], "Input"],

Cell[BoxData[
    \(ReleaseObject[group]\)], "Input"],

Cell[BoxData[
    \(DeleteJObject[pane, panel]\)], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JList <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<coolc<og[<c?l2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
ooo<c?mjc<co0XS0^058T8P10000000018S0^<SPf8S0^8S0^2o<c?l20000
olc<ooo<c?m9c<co0XS0^058T8P10000000018S0^<SPf8S0^8S0^2o<c?l2
0000olc<ooo<c?m9c<co0XS0^058T8P1000000001HS0^<SPf8S0^8S0^<c<
o`0200001<c<o`8000000lc<o`000000000200000/c<o`8000000lc<o`00
00000003c<co100000;<c?l6000000?<c?l0000000000/c<o`@00002c<co
0P000003c<co0000000000;<c?l200000/c<o`800002c<co1@000003c<co
0000000000;<c?l200000/c<o`80003oc<coolc<obc<c?l2R<2h0DR@R040
00000005R<2hb>3HR<2hR<2hc<co00800003c<co0P000003c<co00000000
00;<c?l2000000G<c?l000000000003<c?l00P000003c<co0000000000;<
c?l2000000?<c?l0000000001Lc<o`8000000lc<o`0000000002c<co0P00
0005c<co000000000000c<co008000000lc<o`0000000002c<co0P000003
c<co0000000000;<c?l2000000?<c?l0000000000/c<o`8000000lc<o`00
0000003oc<coolc<obg<c?l2R<2h0DR@R04000000005R<2hb>3HR<2hR<2h
c<co00800003c<co0P000003c<co0000000000;<c?l2000000?<c?l00000
00000/c<o`8000000lc<o`0000000002c<co0P000003c<co0000000000G<
c?l2000000?<c?l0000000001Lc<o`800002c<co0P000003c<co00000000
00;<c?l2000000?<c?l0000000000/c<o`8000000lc<o`0000000002c<co
0P000003c<co000000000?o<c?ooc<co;Lc<o`:8`;P1B9280@00000000F8
`;S8h=R8`;R8`;S<c?l00P0000;<c?l200000/c<o`800002c<co0P000003
c<co0000000000;<c?l2000000?<c?l0000000000/c<o`8000000lc<o`00
00000005c<co0P000003c<co0000000000@000000lc<o`0000000002c<co
0P000003c<co0000000000;<c?l200000/c<o`8000001<c<o`0000000<c<
o`800002c<co0P000003c<co000000000?o<c?ooc<co;Lc<o`:8`;P1B928
0@00000000F8`;S8h=R8`;R8`;S<c?l01P0000;<c?l200000/c<o`800000
0lc<o`0000000002c<co0P000003c<co0000000000;<c?l2000000?<c?l0
0000000010000004c<co00000000c<co0P0000;<c?l2000000?<c?l00000
00000/c<o`8000000lc<o`0000000002c<co0P0000?<c?l4000000?<c?l0
000000000/c<o`8000000lc<o`000000003oc<coolc<obg<c?l2R<2h0DR@
R04000000005R<2hb>3HR<2hR<2hc<co00800003c<co0P0000;<c?l00`00
0<c<olc<o`02000000G<c?l000000000003<c?l00P0000;<c?l00`000<c<
olc<o`02000000?<c?l0000000001Lc<o`8000000lc<o`0000000002c<co
0P000005c<co000000000000c<co008000001Lc<o`00000000000<c<o`02
000000?<c?l0003<c?l00/c<o`8000001Lc<o`00000000000<c<o`020000
00?<c?l000000000olc<ooo<c?l]c<co0XS0^058T8P1000000001HS0^<SP
f8S0^8S0^<c<o`0200000lc<o`800002c<co100000;<c?l2000000?<c?l0
000000000lc<o`@00002c<co0P0000G<c?l200000/c<o`@00002c<co0P00
0003c<co0000000000;<c?l2000000?<c?l0000000000lc<o`@00002c<co
0P000004c<co00000000c<co10000?o<c?ooc<co;<c<o`:8`;P1B9280@00
000000F8`;S8h=R8`;R8`;S<c?l00P0000?<c?l200002<c<o`80000<c<co
0P0000G<c?l200003lc<o`80000Cc<co0P000?o<c?ooc<co;Lc<o`:8`;P1
B9280@00000000F8`;S8h=R8`;R8`;S<c?l01P0000W<c?l200003<c<o`H0
00000lc<o`000000000?c<co0P0001C<c?l00`000<c<olc<o`3oc<coolc<
ob_<c?l2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<ooo<c?mjc<co
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c?ooc<coN/c<o`:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Soc<coolc<og[<c?l2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2holc<ooo<c?mjc<co0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?o<c?ooc<coN/c<o`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oo
ooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooooooo
og[oool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hoooo00800004oooo
0P000003oooo0000000000800002oooo0P000003oooo0000000000?oool4
00000_ooo`H00002oooo100000;oool2000000?oool0000000000_ooo`80
0004oooo1@000?oooooooooo??ooo`:8`;P1B9280@00000000F8`;S8h=R8
`;R8`;Soool00P0000?oool2000000?oool0000000000_ooo`8000001Ooo
o`00000000000?ooo`02000000?oool0000000000_ooo`8000000oooo`00
00000005oooo0P0000;oool2000000Goool000000000003oool00P000003
oooo0000000000?oool200000_ooo`80003ooooooooooccoool2R<2h0DR@
R04000000005R<2hb>3HR<2hR<2hoooo00800003oooo0P000003oooo0000
000000;oool2000000?oool0000000000_ooo`8000000oooo`0000000002
oooo0P000003oooo0000000000Goool200001Oooo`800002oooo0P000003
oooo0000000000?oool200000_ooo`80003ooooooooooccoool2R<2h0DR@
R04000000005R<2hb>3HR<2hR<2hoooo00800002oooo0P0000;oool20000
0_ooo`8000000oooo`0000000002oooo0P000003oooo0000000000;oool2
00000_ooo`800004oooo1P000003oooo0000000000;oool2000000?oool0
000000001?ooo`8000000oooo`000000003ooooooooooccoool2R<2h0DR@
R04000000005R<2hb>3HR<2hR<2hoooo00H00002oooo0P0000;oool20000
00?oool0000000000_ooo`8000000oooo`0000000002oooo0P0000?oool2
00000oooo`800002oooo0P000003oooo0000000000;oool2000000?oool0
000000001Oooo`@0003ooooooooooccoool2R<2h0DR@R04000000005R<2h
b>3HR<2hR<2hoooo00800003oooo0P0000;oool00`000?ooooooo`020000
00Goool000000000003oool00P0000;oool00`000?ooooooo`0200000ooo
o`800003oooo0P0000;oool2000000Goool000000000003oool00P000003
oooo0000000000?oool010000?ooooooooooo`80003ooooooooooccoool2
R<2h0DR@R04000000005R<2hb>3HR<2hR<2hoooo00800003oooo0P0000;o
ool400000_ooo`8000000oooo`0000000003oooo100000Goool200000ooo
o`@00002oooo0P000003oooo0000000000;oool400000_ooo`@0003ooooo
ooooocgoool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hoooo00800003
oooo0P0000Soool200004?ooo`800008oooo0P000?ooooooooooC?ooo`:8
`;P1B9280@00000000F8`;S8h=R8`;R8`;Soool01P0000Woool200003?oo
o`H00008oooo0P000?ooooooooooC?ooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oo
ooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooooooo
og[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000F8`;S8
h=R8`;R8`;Soool00P0000Coool2000000?oool0000000000P0000;oool2
000000?oool0000000000oooo`@00002oooo1P000003oooo0000000000;o
ool400000_ooo`800002oooo0P000?ooooooooooAOooo`:8`;P1B9280@00
000000F8`;S8h=R8`;R8`;Soool00P0000?oool2000000?oool000000000
0_ooo`8000001Oooo`00000000000?ooo`02000000?oool0000000000_oo
o`8000000oooo`0000000005oooo0P000003oooo0000000000;oool20000
00?oool0000000000_ooo`80003oooooooooodGoool2R<2h0DR@R0400000
0005R<2hb>3HR<2hR<2hoooo00800003oooo0P000003oooo0000000000;o
ool2000000?oool0000000000_ooo`8000000oooo`0000000002oooo0P00
0003oooo0000000000Goool2000000?oool0000000000_ooo`8000000ooo
o`0000000002oooo0P000?ooooooooooAOooo`:8`;P1B9280@00000000F8
`;S8h=R8`;R8`;Soool00P0000;oool200000_ooo`800002oooo0P000003
oooo0000000000;oool2000000?oool0000000000_ooo`8000000oooo`00
00000005oooo0P000003oooo0000000000;oool2000000?oool000000000
0_ooo`80003oooooooooodGoool2R<2h0DR@R04000000005R<2hb>3HR<2h
R<2hoooo00H00002oooo0P0000;oool2000000?oool0000000000_ooo`80
00000oooo`0000000002oooo0P000003oooo0000000000Goool2000000?o
ool0000000000_ooo`8000000oooo`0000000002oooo0P000?oooooooooo
AOooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;Soool00P0000?oool2
00000_ooo`030000oooooooo008000001Oooo`00000000000?ooo`020000
0_ooo`030000oooooooo008000000oooo`0000000005oooo0P0000;oool0
0`000?ooooooo`02000000Goool000000000003oool00P000?oooooooooo
AOooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;Soool00P0000?oool2
00000_ooo`@00002oooo0P000003oooo0000000000?oool400000_ooo`80
0005oooo0P0000;oool400000_ooo`8000000oooo`000000003ooooooooo
odKoool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hoooo00800003oooo
0P0000Soool200003?ooo`80003ooooooooooe[oool2R<2h0DR@R0400000
0005R<2hb>3HR<2hR<2hoooo00H00009oooo0P0000coool200001Oooo`80
003ooooooooooe?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoiVI
c?nIVLajVIW<0XS0^058T8P1000000001HS0^<SPf8S0^8S0^9VIc03oc<co
olc<ogS<c?l019VIc8S0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hVIW<
03C<c?l40000olc<ooo<c?m0c<co00BIVLb8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^9VIc00cc<co00@0003<c?o<c?o<c?l20000olc<ooo<c?lo
c<co00BIVLb8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^9VIc0020000
1<c<o`8000000lc<o`000000000200000/c<o`8000000lc<o`0000000003
c<co100000;<c?l200001lc<o`@00002c<co0P0000;<c?l200000/c<o`80
00000lc<o`0000000002c<co0P000004c<co00000000c<co0P000003c<co
0000000000;<c?l20000olc<ooo<c?l^c<co00BIVLb8`;R8`;Q8T8P10000
00001HS0^<SPf8S0^8S0^9VIc00200000lc<o`8000000lc<o`0000000002
c<co0P000005c<co000000000000c<co008000000lc<o`0000000002c<co
0P000003c<co0000000000K<c?l200000/c<o`8000000lc<o`0000000002
c<co0P000004c<co00000000c<co0`000004c<co00000000c<co0`000004
c<co00000000c<co0P0000;<c?l20000olc<ooo<c?l^c<co00BIVLb8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^9VIc00200000lc<o`8000000lc<
o`0000000002c<co0P000003c<co0000000000;<c?l2000000?<c?l00000
00000/c<o`8000000lc<o`0000000006c<co0P0000G<c?l200000/c<o`80
00000lc<o`0000000002c<co0P000003c<co0000000000;<c?l2000000C<
c?l00000003<c?l200000/c<o`80003oc<coolc<obk<c?l019VIc8S0^8S0
^4R@R04000000005R<2hb>3HR<2hR<2hVIW<00800002c<co0P0000;<c?l2
00000/c<o`8000000lc<o`0000000002c<co0P000003c<co0000000000;<
c?l2000000?<c?l000000000100000;<c?l6000000?<c?l0000000000/c<
o`8000000lc<o`0000000002c<co0P000003c<co0000000000;<c?l20000
00C<c?l00000003<c?l200000/c<o`80003oc<coolc<obk<c?l019VIc8S0
^8S0^4R@R04000000005R<2hb>3HR<2hR<2hVIW<00H00002c<co0P0000;<
c?l2000000?<c?l0000000000/c<o`8000000lc<o`0000000002c<co0P00
0003c<co0000000000?<c?l2000000?<c?l0000000000/c<o`8000000lc<
o`0000000002c<co0P000003c<co0000000000;<c?l2000000?<c?l00000
00000/c<o`8000001<c<o`0000000<c<o`800002c<co0P000?o<c?ooc<co
;/c<o`04VIW<R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;RIVL`00P00
00?<c?l200000/c<o`030000c<coc<co008000001Lc<o`00000000000<c<
o`0200000/c<o`030000c<coc<co008000000lc<o`0000000003c<co0P00
0003c<co0000000000;<c?l2000000G<c?l000000000003<c?l00P000004
c<co00000000c<co0`000003c<co0000000000;<c?l2000000C<c?l00000
003<c?l3000000?<c?l000000000olc<ooo<c?l^c<co00BIVLb8`;R8`;Q8
T8P1000000001HS0^<SPf8S0^8S0^9VIc00200000lc<o`800002c<co1000
00;<c?l2000000?<c?l0000000000lc<o`@00002c<co0P0000?<c?l20000
0/c<o`@00002c<co0P000003c<co0000000000?<c?l2000000C<c?l00000
003<c?l200000/c<o`8000001<c<o`0000000<c<o`8000000lc<o`000000
003oc<coolc<obo<c?l019VIc8S0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hVIW<00800003c<co0P0000S<c?l200003<c<o`800003c<co0P000?o<
c?ooc<coE<c<o`04VIW<R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;RI
VL`01P0000W<c?l200003<c<o`H0000Nc<co0P000?o<c?ooc<co=Lc<o`04
VIW<R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;RIVL`0olc<ooo<c?mh
c<co00BIVLb8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^9VIc03oc<co
olc<ogS<c?l019VIc8S0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hVIW<
0?o<c?ooc<coN<c<o`04VIW<R<2hR<2hB9280@00000000F8`;S8h=R8`;R8
`;RIVL`0olc<ooo<c?mhc<co00BIVLb8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^?nIVLcoVIW<NYVIc0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000005R<2hb>3HR<2hR<2hoooo00800004oooo0P000003
oooo0000000000800002oooo0P000003oooo0000000000?oool400000_oo
o`800007oooo1@000003oooo0000000000;oool200000_ooo`8000000ooo
o`0000000002oooo1@000?oooooooooo>Oooo`:8`;P1B9280@00000000F8
`;S8h=R8`;R8`;Soool00P0000?oool2000000?oool0000000000_ooo`80
00001Oooo`00000000000?ooo`02000000?oool0000000000_ooo`800000
0oooo`0000000006oooo0P0000;oool2000000?oool0000000000_ooo`80
00001?ooo`0000000?ooo`<000000oooo`0000000002oooo0P000?oooooo
oooo>Oooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;Soool00P0000?o
ool2000000?oool0000000000_ooo`8000000oooo`0000000002oooo0P00
0003oooo0000000000;oool2000000?oool0000000001_ooo`800002oooo
0P000003oooo0000000000;oool2000000?oool0000000000_ooo`800000
0oooo`0000000002oooo0P000?oooooooooo>Oooo`:8`;P1B9280@000000
00F8`;S8h=R8`;R8`;Soool00P0000;oool200000_ooo`800002oooo0P00
0003oooo0000000000;oool2000000?oool0000000000_ooo`8000000ooo
o`000000000400000oooo`8000001?ooo`0000000?ooo`800002oooo0P00
0003oooo0000000000;oool200000_ooo`8000000oooo`000000003ooooo
ooooocWoool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hoooo00H00002
oooo0P0000;oool2000000?oool0000000000_ooo`8000000oooo`000000
0002oooo0P000003oooo0000000000?oool200000oooo`@000000oooo`00
00000002oooo0P000003oooo0000000000;oool200000oooo`@0003ooooo
ooooocWoool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hoooo00800003
oooo0P0000;oool00`000?ooooooo`02000000Goool000000000003oool0
0P0000;oool00`000?ooooooo`02000000?oool0000000000oooo`800000
0oooo`000?ooo`02oooo0P000005oooo000000000000oooo008000001?oo
o`0000000?ooo`<000000oooo`000?ooo`02oooo0P000?oooooooooo>Ooo
o`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;Soool00P0000?oool20000
0_ooo`@00002oooo0P000003oooo0000000000?oool400000_ooo`800003
oooo0P0000;oool400000_ooo`8000000oooo`0000000003oooo0P000003
oooo0000000000;oool40000ooooooooooljoooo0XS0^058T8P100000000
1HS0^<SPf8S0^8S0^?ooo`0200000oooo`800008oooo0P0000coool20000
0oooo`80000Coooo0P000?oooooooooo@?ooo`:8`;P1B9280@00000000F8
`;S8h=R8`;R8`;Soool01P0000Woool200003?ooo`H0000Doooo0P000?oo
oooooooo@?ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooooooo
og[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h;_ooo`@0003oooooooooodSoool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h;Oooo`040000oooooooooooo0P000?ooooooooooAoooo`:8`;P1
B9280@00000000F8`;S8h=R8`;R8`;Soool00P0000Coool2000000?oool0
000000000P0000;oool2000000?oool0000000000oooo`@00002oooo1@00
00Coool400000oooo`8000000oooo`000000003oooooooooodOoool2R<2h
0DR@R04000000005R<2hb>3HR<2hR<2hoooo00800003oooo0P000003oooo
0000000000;oool2000000Goool000000000003oool00P000003oooo0000
000000;oool2000000?oool0000000000_ooo`800002oooo0P0000;oool2
000000Coool00000003oool30000oooooooooom7oooo0XS0^058T8P10000
00001HS0^<SPf8S0^8S0^?ooo`0200000oooo`8000000oooo`0000000002
oooo0P000003oooo0000000000;oool2000000?oool0000000000_ooo`80
00000oooo`0000000003oooo0P000003oooo0000000000;oool2000000?o
ool0000000000_ooo`80003oooooooooodOoool2R<2h0DR@R04000000005
R<2hb>3HR<2hR<2hoooo00800002oooo0P0000;oool200000_ooo`800000
0oooo`0000000002oooo0P000003oooo0000000000;oool2000000?oool0
000000000oooo`8000000oooo`0000000002oooo0P000003oooo00000000
00;oool20000oooooooooom7oooo0XS0^058T8P1000000001HS0^<SPf8S0
^8S0^?ooo`0600000_ooo`800002oooo0P000003oooo0000000000;oool2
000000?oool0000000000_ooo`8000000oooo`0000000003oooo0P000003
oooo0000000000;oool2000000?oool0000000000_ooo`80003ooooooooo
odOoool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hoooo00800003oooo
0P0000;oool00`000?ooooooo`02000000Goool000000000003oool00P00
00;oool00`000?ooooooo`02000000?oool0000000000oooo`800002oooo
00<0003oooooool00P000004oooo00000000oooo0`000?ooooooooooAooo
o`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;Soool00P0000?oool20000
0_ooo`@00002oooo0P000003oooo0000000000?oool400000_ooo`800003
oooo0P0000;oool400000oooo`8000000oooo`000000003oooooooooodOo
ool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hoooo00800003oooo0P00
00Soool200003?ooo`800002oooo0P000?ooooooooooE_ooo`:8`;P1B928
0@00000000F8`;S8h=R8`;R8`;Soool01P0000Woool200003?ooo`D0003o
oooooooooeOoool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooo
oomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_oo
o`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@000000
00>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2h
R<2h5P00P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J2
00J200J20P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^4
00<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L2
58L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT3
0a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@T
S@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`03
1B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010Hb
TPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`Lh
U0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G
246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@04
2DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:
DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;
Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ
00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=
IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]
Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?
LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[004
47j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^
4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a
0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A
/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf
00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h
5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@F
Z[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h0
0aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h1000P003VjOa<d>U<d>U00Tc@jD600200`01P0800X001002P@03
P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h8128812880
0P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D4
0Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP3
5hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@P
R`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDW
SP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6
;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB
1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D3
23fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH
2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<
V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;
E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaL
X00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQ
XPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D3
3VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`
Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1h
ZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@03
4H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8
/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb
00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@3
4iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg
00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT
^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G
[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000NKYo7ooon>N[JV
VlBcZM:XWLRcZM800ZJKa005_;SMk^kdj^Waoooo<d>U00D0080300600P02
P00400:100>100>100>10`04P@801H401005PP06PP06PP06PP801h800`47
PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD3
0Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<F
R0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@N
RP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@03
1BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^
T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB
00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@3
1c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G
00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:
VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;
Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJ
X0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R
0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@3
3FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW
0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mf
ZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8A
Ojd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166
[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=
/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]003
4i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g
0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR
^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF
[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb
_`<G/kl26;C08000008H]<0@00000QRd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2002000BKYo7ooom/FZF_YLX2_;SM00[ooOncZM;ooooooonl
^=fGR[bXWLSVi^cooolc@jD400200`01P0800X001002P@03P@03P@03P@<0
184200F100@01H801X801X801X8200N200<11h81288128800P48P`<12H<3
0@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP82
4hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<3
6HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<
10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DY
SP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946
<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<3
1cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8
?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5
V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK
0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]E
WP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ
35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP02
3F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>
JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0ma
Z0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[
0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^
00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9
/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8C
Sk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<D
UkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PE
W[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk
0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^
_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HB928
B92800a8T8P00`000<SPf4R@R00=B92800@0000H]<0H]<38h=P>B92800<0
000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0^8S0^08008002i^W
lOooojRMb?oook>YdV1<VXij]WQU[ZRMb?ooooomo`03oooo00<c@jD00800
08000`00P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J2
00J200J20P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^4
00<138@30@f40`4>Q@<23hD20Q250oooo`824HH30Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@04
0aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`4
98d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5
:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A
00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7
>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9
AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN
2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ
0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X
3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@
OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh0
0a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@
/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf
0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<F
ZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003
B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H
]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00>VjOaoooo
oooofmc/H4bJThFj/jWB_;SMH4bJVHnnYY_4b<?Ooooo<d>U1P00P0?oool2
00:000<00X7oooooool00_ooo`8018400`05POooo`05PP0300J21?ooo`03
0@R20@R3oooo00?oool30@Z300Koool12h@12h@138Coool138@20@f400Co
ool13XGoool13XD20Pn500Coool248Goool248D20Q6600?oool24HH24XH0
0P8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP3
0aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<4
8H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP03
1BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46
<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB
0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE
10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH
2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:
CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;
E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX004
35bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeR
XPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU
0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0ma
Z0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@
NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]
4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08B
RK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<C
S[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe
0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@E
WKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<F
YKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd0
0aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`004
b>3HR<2hR<2hR<2h1P0000B8`;P00dR@R0000<SPf002R<2h2@0000:8`;P0
1DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0`00P00>VjOaoooo_;SMVHnnooooe]7Mfmc/
lokoYY_4k^kdQGJ`ThFjoooo<d>U1000P007oooo006000600060oooo00:0
oooo00<00h401_ooo`04P@04P@05POooo`05PP801X802?ooo`07PP07PP47
P_ooo`48P_ooo`48P`<12H<01?ooo`4:P`4:Poooo`812h@00`4<Q?ooo`4<
Q0020@f400Coool13XGoool13XD20Pn500?oool248Goool00oooo`824HH3
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000C8
h=R8`;R8`;R8`;P6000018S0^003B9280000b>3H00:8`;P00`0008S0^8S0
^005R<2h00D00028`;R8`;Q8T8P000000QRd`004b>3HR<2hR<2hR<2h0P00
00B8`;P200000XS0^004B92800006;C06;C00XS0^058T8P10000000018S0
^<SPf8S0^8S0^0<008003i^WlOoooiV?_YN:_=CCj>n//omfNnjOZe]HYJJK
a9JOdV1<V[bhgOoooc=3Y@03002000Ooool00H000H000H3oool00X3oool0
0`03P@06oooo00B100B1oooo00F1oooo0P06PP08oooo00N200N20@N2oooo
0@R2oooo0@R30`49P`09oooo0@Z3oooo0@^3oooo0@^4oooo0@b4oooo0081
3H@01?ooo`4>QOooo`4>Q@823hD01?ooo`8@QOooo`8@Q@@24HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028
`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8`;P200000XS0^0800003
R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0P00P00:VjOaooooUhZlNVbZ/lOXZFjPb<?OThFjFdJCVHnn0WQU[P04@RN5
[jG:oooo<d>U1000P0<00H000oooo`02P002P@04oooo0P04P@03oooo00F1
oooo00<01X84oooo00<1288128<128<00`49P`09oooo0@Z3oooo0@^3oooo
0@^4oooo0@b4oooo00813H@01?ooo`4>QOooo`4>Q@823hD00oooo`8@QOoo
o`03oooo0P8AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ8
0aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:
0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<5
9hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@
0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=980
0`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7
>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL0
10U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ
0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]C
W@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP
0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82
366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=
Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL2
3W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ
0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o
[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_
0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb
4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<C
Tk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL3
59bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i
0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/
_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o
0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000
R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P0
0hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0P00P003VjOaoooooooo00;oool02_n]/?mfNoW=e?g]k_oo
ojJKa8Ef/;bhgOoooc=3Y@D00803006000?oool00X000X400`03P@03oooo
00B1oooo00801H401005P_ooo`06PP06PP801h800`47P_ooo`48PP020@R3
0oooo`812X<01oooo`4;Poooo`4;Q?ooo`4<Q?ooo`020@f400Coool13XGo
ooooool20Pn500Koool248Goool248D24HKoool20Q660`8BQP824hH0108C
Q`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT3
6HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS004
12B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>
1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A
0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`Lg
T`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F
00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH
2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:
D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh0
0`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ
0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eS
X`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP0
0`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@
O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh3
4H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::
/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?
/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf
0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P3
5Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<F
Z;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P03
5jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8
`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2h
B9280000008H]<000lSPf8S0^8S0^004R<2h0P0000F8`;P014R@R00001Rd
`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000ZQ[?;icMCR
9Scd]KoR9ScdKGglhnWoooomkNko[K02oooo00<c@jD0080008001000P0<0
0H000oooo`02P002P@03oooo0P04P@05oooo00F100F100F2oooo00801X83
oooo0P48PP030@R3oooo0@V300812H<20@Z300Coool12h<12hCoool20@b4
00Ooool13H@13HCoool13XGoool13XD00_ooo`030Pn50Q250Q2500Coool0
108AQP8BQP8BQP8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP3
5hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX3
11n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DW
S@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y02
1Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP03
1cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`Lk
U@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`04
2D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX3
2T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M
00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ03
35^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<
HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eW
Y0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>
L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX3
3gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]
0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl3
4XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8B
SK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C
]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<D
W;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T3
5J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm
0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l3
5k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028
`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^003
R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2002000fKYo7mkNkR9ScnmOSgRIOdHVkcX:kdHVkooOoo[K3l
hnWooolc@jD01`00P0<00H000oooo`02P002P@0300>10`04P@801H401005
PP06PP06PP06PP801h801@47PP48PP48P_ooo`48P`030@V30`4:P`030@^3
0@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL2
58L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV9
00@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@T
S0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZ
S`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86
<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<0
0`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04
242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6
V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L
00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;
Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<
GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<3
3FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>
KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?
LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/
111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63
[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4B
R[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<3
4i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<D
VKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO
^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk
0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN_
_P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h
00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@
R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h0P0000>8`;P014R@
R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000>K
Yo7fb<cR9S`00_n]/007gb@^ojBNm[c5ojf`kW^<oooo<d>U00P008030060
00?oool00X000X400`03P@<0184200F100@01H801X801X801X8200N200D1
1h81288128;oool128<00`49P`04oooo0@Z30@Z30@^30P4;Q0<138@30@f4
0`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8F
Q`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<3
7HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd3
1BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6
;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHc
TP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9
BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd2
2e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;
FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<
H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]
47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<A
QJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d
4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLD
VkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[
_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0
^0T00002R<2h00E8T8P0000H]<0H]<38h=P00hS0^0800004R<2h0P0000:8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
002000>KYo7icMCgRIL00_ooo`07ojf`hAHdogIkojBNhRHlohUo<d>U00P0
0803006000?oool00X000X400`03P@<0184200F100@01H801X801X801X82
00N200@11h812881288128<4oooo0`4:P`030@^30@^40@^400<138@20@f4
00Coool13XD13XD13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB7
0QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ9
0`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d4
98d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl0
0`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6
<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7
>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1
U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT0
10U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L
2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO
2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaO
X@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`03
3FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>
KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y
3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0
111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64
[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;
/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<C
TK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ
]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP
^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`4
5ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n
00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B928
0000b>3H00:8`;P900000XS0^005B92800006;C06;C0b>3H00f8`;P014R@
R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000NK
Yo7oooocX:kdHVkoooogRIOicM@00_ooo`03lj2^oooo<d>U00P008030060
0P02P00400:100>100>100>10`04P@801H401005PP06PP06PP06PP801h80
0`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<1
3XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:
0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DV
S@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@
0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i82
1SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7
>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL2
24>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ
0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]B
W@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO
0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R
362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=
IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL3
3VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o
[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_
1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=
/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B
]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g
59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i
0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdF
ZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl0
0aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00f8`;P0
1DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0`00P00;VjOaooooohUooooolj2^lI>Qoooo
oogolj2^oo_l<d>U00P0080300600P02P00400:100>100>100>10`04P@80
1H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<0
0`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP04
0Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<I
R@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><
00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5
:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6
<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<3
1cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88
@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9
AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL
10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]F
WP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<
GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<3
3F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>
K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mb
Z0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[
0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62
[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa
4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P02
4hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@D
V;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN
^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk
0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn
00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C03lSPf0030000b>3H
b>3H00g8h=P00`0001Rd`1Rd`00?b>3H00<0000H]<0H]<000XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0@00803VjOa00KoooocX:kd]Kof_<GkfMXc
@jD900200`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X80
1X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@0
0`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<3
6hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=
12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5
:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9
AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YA
W@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]G
W`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW
3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mc
Z@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@
OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hA
Q:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H0
11BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ
_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P03
5k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;PF00200`01P0800X001002P@03P@03P@03P@<0184200F100@01H80
1X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@1
2h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8D
Q`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<J
R@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=
12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?
00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@04
1S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC
1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8
@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI
00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YA
W0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]G
W`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<
Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<0
0`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP04
3VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mc
Z@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/
00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<A
Q:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<B
Rk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<3
4i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8D
V[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<E
X;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl
11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`
_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;So
R<2hOHS0^058T8P1000000000hS0^<SPf<SPf03ob>3HolSPf7g8h=P1B928
0@000000ohS0^?n8`;R1R<2h0@000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l7?ol?3`00?ofMWIooooooooool03?ooool0
0?ool?3`ooo`l?1coo3`l004omWIfOooooooooooonGUi@?ooooo00GoiNGU
ooooooooooooooooonGUi@03ooooo`00ooo`l?3ooo3`l7?ol?3`00gofMWI
oooooooJf][oSHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgo
iNGU00;ooooo003ooo3`l?ool?3`Loo`l?003_oIfMWooooooooooooJf][o
SHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU0Oooool0
0?ool?3`ooo`l?1coo3`l00=omWIfOoooooooooooooooooJf][oSHf=onGU
iOoooooof][Johf=SOoUiNGoooooom[JfP02ooooo`00ooo`l?3ooo3`l7?o
l?3`00?ofMWIooooooooool00_ooool01ooJf][oSHf=onGUiOoooooof][J
ohf=SOoUiND00oooool00?ool?3`ooo`l?1coo3`l003omWIfOoooooooooo
00?ooooo00Oof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003o
oo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`04ooooo`07om[Jf_n=SHgo
iNGUoooooooLg=coSHf=onGUi@01ooooo`00ooo`l?3ooo3`l7?ol?3`00?o
fMWIooooooooool01Oooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo
003ooo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`06ooooo`03omcLg?n=
SHgoiNGU00?ooooo003ooo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`07
ooooo`03omcLg?n=SHgoiNGU00;ooooo003ooo3`l?ool?3`Loo`l?000ooI
fMWoooooooooo`08ooooo`03omcLg?n=SHgoiNGU007ooooo003ooo3`l?oo
l?3`Loo`l?000ooIfMWoooooooooo`09ooooo`7og=cL0Oooool1ooooo`00
ooo`l?3ooo3`l7?ol?3`00?ofMWIooooooooool03?ooool00?ool?3`ooo`
l?1coo3`l0oofMWI003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oogj]fOooOZgIP_mn[MT0
0003ogj]fOo2`/;o`/;2037o`/;200?oN7Qhoi2@T?o2`/80ooo2`/;ool;2
`T[o`/;20Omn[MT00003ogj]fOo2`/;o`/;2037o`/;200?o<30`of1PH?o2
`/80ooo2`/;ool;2`T[o`/;20Omn[MT00003ogj]fOo2`/;o`/;200Wo`/;2
00?o/k>cokFe]Oo2`/800oo2`/801Ong]kOo_Kfmol71`On^[Zko`L7100Go
`/;200?o/k>cokFe]Oo2`/804?o2`/800oni^KWo/;2`ol;2`P02ol;2`P05
oc0`<?mPH63o`L71ojj^[_o1`L403?o2`/800onc/k?o`<30ol;2`P02okVi
^@_o`/;200?o[Zj^ol30`?o2`/80ooo2`/;ool;2`RWo`/;20Omn[MT00004
ogj]fOo2`/;o:BTYoeYJFP;o`/;200[o^k^koa`L7?le=CGo`L71ojJVY_lX
:2So2PX:o`T92Ol[:b_oYjNW0_o2`/801_l`<33o@d=3oa`L7?lD51Co3`l?
ohn?S`;o`/;200KoYZJVobPX:?l:2P[o2@T9ob/[:onWYjL2ol;2`P03obTY
:Ol0003o000000;o000000Co<c<col;2`_l`<33oH61P0_o2`/803On_[joo
>3Pho`820_lJ6Q[o4A4Aoi:BT_o2`/;o<30`ocTi>OlL71co51@Do`l?3on?
Shl00_o2`/801_l`<33oH61Pol;2`_o2`/;oO7aloaDE5@;o`/;200Wo?Cdm
o`H61_lC4a?oMWIfo`h>3_m2@T;o`/;2oc0`<?mPH6000_o2`/802?mlO7co
5ADEol;2`_o2`/;oX:2Poa`L7?lF5QKoSHf=ooo2`/;ool;2`R[o`/;20Omn
[MT00004ogj]fOo2`/;o:BTYoeYJFP;o`/;200KoEEEEo`l?3on_[joo`L71
obLW9oln?Sh2okFe]@0>od10@?lX:2So`L71ol;2`_l`<33o<S8bokFe]Onn
_[koGemOo`h>3_nh^;So`L71obLW9oln?Sh2okFe]@06od10@?lX:2So`L71
ol;2`_lY:BWoF5QH1Oo2`/802?l`<33oH61Pol;2`_o2`/;o<c<coc0`<?nY
ZJWo`/;20_nh^;P02oo2`/;o<30`oc8b<_ne]KGo_[jnoemOGol>3Pko^;Rh
ol;2`_l`<33oH61P00;o`/;200WoO7aloaDE5Oo2`/;oUYJFo`<30onXZ:So
[Zj^odE5AOl<30`00_o2`/801_l`<33oH61Pol;2`_o2`/;oO7aloaDE5@;o
`/;200?oEEEEoc4a<Oo1`L40ooo2`/;ool;2`R_o`/;20Omn[MT0000<ogj]
fOo2`/;o:BTYoeYJF_o2`/;oTi>Co`410On6QXKo`/;2ojBTY?l0003oRh^;
0_o2`/801_n;Rh_o0000ojNWYoo2`/;o<30`of1PH0;o`/;200Ko[jn_o`00
0?n3Ph?oY:BTo`000?n;Rh/2ol;2`P06oh^;Rol0003oYjNWol;2`_lY:BWo
F5QH1Oo2`/801_l`<33oH61Pol;2`_nXZ:So0000oh^;R`Go`/;200[o<30`
of1PH?o2`/;o`/;2ojn_[ol0003oPh>3ol;2`_l`<33oH61P0_o2`/802Oml
O7co5ADEol;2`_nUYJGo0P82ohn?Soo2`/;oN7QhoaPH6002ol;2`P06oc0`
<?mPH63o`/;2ol;2`_mlO7co5ADE0_o2`/800olj>S[oEUIFol;2`P3ool;2
`_oo`/;2:oo2`/81ogj]f@0000OoOZgIol;2`_lY:BWoF5QHokFe]OlJ6Q[o
Cdm?00;o`/;200?oT92@o`000?n^[Zh00_o2`/801_n][Jgo0000oi:BT_o2
`/;o<30`of1PH0?o`/;200Go410@ofi^K_n@T93o0000ojj^[P02ol;2`P06
ojf][Ol0003oTY:Bol;2`_lY:BWoF5QH1Oo2`/801_l`<33oH61Pol;2`_n@
T93o0000obh^;P?o;bl_00CoUIFEol;2`_l`<33oH61P0oo2`/801Ol@413o
KVi^ol;2`_l`<33oH61P00;o`/;200GoO7aloaDE5Oo2`/;o`/;2oh>3P`02
obHV9P06obTY:OlH61So`/;2ol;2`_l`<33oH61P0_o2`/801_mlO7co5ADE
ol;2`_o2`/;o>SXjoeIFE_oo`/;2ooo2`/8/ol;2`P7oOZgI00001?mn[MWo
`/;2obTY:Ol20P82o`000006oi:BT_o2`/;o`/;2ojNWYol0003oR8R80_o2
`/801_n7QhOo0000ojZZZ_o2`/;o<30`oeaLG0;o`/;200Ko];Bdo`000?nD
U9CoYjNWo`000?n8R8P2ol;2`P06ohN7Qol0003oZZZZol;2`_lY:BWo8R8R
0_m=CDd04?mQHF7o`/;2ol;2`_l`<33oH61Pol;2`_nVYZKo0000oh:2P_nM
WIgoUiNGo`820_n^[Zko`/;2oc0`<?mLG5`2ol;2`P06okBd]?l0003oU9BD
ol;2`_l`<33oATI60_o2`/800omgMgOo5QHFol;2`P03ol;2`P03ol30`?m`
L73o6ATI00;o`/;200Ko<30`odI6A_o2`/;o`/;2ogMgMolF5QH2ol;2`P03
ocXj>_mFEUKo`/;20?oo`/;2ooo2`/8[ol;2`P7oOZgI00002?mn[MWo`/;2
obTY:OmJFU[o[:b/ogEeMOl61PKoS8b<0_o2`/801_la<C7o=SHfojRXZ?nX
Z:So=SHfoc<c<`;o`/;200[o<30`oa@D5?mbLW;oYjNWodm?Col<30co_kno
ol;2`_la<C7o=SHf0_nXZ:P01_lf=SKo<c<col;2`_o2`/;o:BTYocHf=P;o
MgMg00GoQ8B4ol;2`_o2`/;o<30`of1PH002ol;2`P05obl_;omADE7o^k^k
ogQhN?lP82000_o2`/803_l`<33o51@Dog9bL_nWYjOoCdm?o``<3?no_koo
`/;2oc0`<?l?3`ooFEUIojRXZ?m2@T;o>SXj0_o2`/801On8R8SoYJFUokno
_om9BDWo?clo00;o`/;200co<30`o`l?3omIFEWoZ:RXod92@_lj>S[o`/;2
okfm_Olg=cOoDU9BokVi^Onn_[kool;2`_oo`/;2:_o2`/81ogj]f@0000Co
OZgIol;2`_lY:BWoFUYJ0_o2`/801_lg=cOo?clool;2`_o2`/;o/;2`ochn
?P;o2`/;00[o?clook6a/Oo2`/;o`/;2oc0`<?mNGUkoC4a<o`T92OlC4a?o
Ogmo0_o2`/801_n`/;3o?Shno`/;2ol;2`_o?clook6a/@;o`/;200?o:BTY
oeQHF?o2`/801?o2`/802Ol`<33oH61Pol;2`_o2`/;o[Zj^ocHf=_l92@Wo
5ADEoh^;R`02ol;2`P06oclo?omXJ6SoC4a<o`T92OlC4a?oOgmo0_o2`/80
1_l`<33oGemOoeaLG?l?3`oo8R8RoiFEU@;o`/;200GoJ6QXobHV9_l<30co
:b/[oiFEU@02ol;2`P0<oclo?omZJV[oG5aLo`l?3olR8R;oUIFEol;2`_mP
H63o1PH6o`T92OlD51CoQ8B4ooo2`/;ool;2`R[o`/;20Omn[MT00004ogj]
fOo2`/;o:BTYoeYJFP;o`/;200?o:2PXod10@?o2`/800oo2`/82ol71`@Co
`/;200Co<30`of1PH?o2`/;o`<301_o2`/82ol71`@Co`/;200?o:BTYoeQH
F?o2`/801?o2`/800ol`<33oH61Pol;2`P03ol;2`P03okno_oo2`/;o`/;2
00Go`/;200?o`<30ol;2`_o2`/800_o2`/801?l`<33oH61Pol;2`_o1`L46
ol;2`P03ol30`?o2`/;o`/;200Go`/;200?o`L71ol;2`_o2`/800_o2`/80
0olj>S[oEUIFol;2`P3ool;2`_oo`/;2:oo2`/81ogj]f@0000SoOZgIol;2
`_lY:BWo8b<SodA4A?lJ6Q[o2@T9oiBDU0[o`/;200?o<30`of1PH?o2`/80
3Oo2`/800olY:BWo8R8Roda<C002oda<C004oh^;Roo2`/;o<30`of1PH17o
`/;200?o<30`of1PH?o2`/805?o2`/800onZZZ[oZ:RXol;2`P3ool;2`_oo
`/;2:oo2`/81ogj]f@0000?oOZgIol;2`_n5QHD00_meMGD00on>SXko_Kfm
ol;2`P0:ol;2`P03oc0`<?mPH63o`/;200go`/;200?oQHF5ogEeMOmeMGD0
0_meMGD01?nOWioo`/;2oc0`<?mPH60Aol;2`P03oc0`<?mPH63o`/;20?oo
`/;2ooo2`/92ol;2`P7oOZgI00000omn[MWo`/;2ol;2`P0?ol;2`P03okjn
__o0`<3o`/;201Co`/;200?o_[jnol30`?o2`/804?o2`/800onn_[ko`<30
ol;2`P3ool;2`_oo`/;2@_o2`/81ogj]f@0000?oOZgIol;2`_o2`/80ooo2
`/;ool;2`Wko`/;20Omn[MT00003ogj]fOo2`/;o`/;20?oo`/;2ooo2`/9n
ol;2`P7oOZgI003oogj]fOooOZgIP_mn[MT00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool000cooooo00?ok>c/
ono_koooool00oooool01OoalO7onOWiookno_oUiNGoo_kn00Gooooo00?o
k>c/ono_koooool03Oooool00oodm?Coj>SXooooo`02ooooo`05oo7alOoi
nOWoo_knonGUiOono_h02Oooool00oo/k>cooOgmooooo`02ooCdm?oooooo
oooooolnooooo`000_ooool03_lf=SKoMgMgoooooooooooom_KfobHV9_m6
ATKoo_knom_Kfole=CGo3Ph>o``<3?li>CWog=cL0_ooool01_m0@43oFEUI
obHV9_lK6a_o5ADEokbl_0;ooooo00Sofm_KocDe=Ol>3Pko30`<ocTi>OoL
g=cooooooiZJVPKo000000oo`<30oooooooWinOoBTY:o`<30olS8b?o5aLG
ol71`Ooooooo@410oeUIFOlV9RKo6a/KoaDE5Onl_;`00_ooool00om0@43o
Ogmoooooo`02ooooo`06oe5ADOl820So6QXJoibLW?lC4a?oEeMGoooooooo
ooooockooooo0002ooooo`0:ocHf=_mgMgOooooooooooom`L73o51@DonOW
ioono_ko=3@doe9BDP;ok^k^00koEEEEocDe=Oono_kooooood10@?m3@d?o
kno_oo_knommOGgo4a<Coo?cloono_ko=3@doe9BDP;ok^k^00KoEEEEocDe
=Oono_kog=cLo`/;2omaLG44onk^kP0Coo_knoooooooA4A4od10@?oOgmoo
oooooo?cloobl_;ooooood10@?m3@d?okno_oo_knommOGgo4a<Coo?clooo
oooo@410ogmoO`02ooooo`06olK6a_l410CogMgMonKVi_mKFe_o4A4Aoooo
ooooooooocoooooo0002ooooo`0:ocHf=_mgMgOooooool;2`_l20P;o/K6a
oooooooHf=So0000okNg]`;ooooo00Ko]kNgo`000?oLg=cooooood10@?mo
Ogl2ooooo`06onOWiol0003o[Jf]omSHf?l0003o]kNg0_ooool01ong]kOo
0000omcLg?ooooooUYJFo`@41?o;bl/01?ooool00ooMgMgo0000okRh^005
ooooo`0:od10@?moOgoooooooooooooWinOo0000ojf][Ooooooo@410ogmo
O`;ooooo00KofMWIo`<30onm_KgooooooinOWolP823ooooooooooooo?ooo
ool000;ooooo00Go=SHfogAdM?o_knoo8b<SofQXJ002ooooo`03okjn__l0
003oi^KV00;ooooo00Koi>CTo`000?o1`L7ooooood10@?moOgl3ooooo`05
oaHF5_nATI7o_[jno`000?oVi^H00_ooool00ooTi>Co0000ol71`@02oooo
o`03odM7AolX:2Som_Kf00?ooooo00?o_[jno`000?lm?Cd00olo?cl01?o4
a<Cooooood10@?moOgl3ooooo`05oaHF5_nATI7ooooood10@?moOgl00ooo
ool01On][Jgo<S8boc<c<olf=SKo820P0?ooooooooooooloooooo`000_oo
ool01Olf=SKo0`<3o`000?l0003o`L7100;ooooo00?og=cLo`000?nd];@0
0_ooool01_nb/[;o0000on3Ph?oooooo@410ogYjNP;ooooo00KokNg]o`00
0?o3`l?og=cLo`000?nd];@2ooooo`03ok:b/_l0003oh>3P00;ooooo00?o
iNGUoa4A4Om_Kfl00oooool02_oKfm_o0000oj^[Zoo?clooalO7o`<30ooU
iNGooooood10@?mjNWX2ooooo`06ong]kOl0003o`l?3oooooom0@43oJFUY
1Oooool00oomoOgoU9BDob4Q8@3ooooooooooooo?oooool000;ooooo00Ko
=SHfogMgMooShn?oVYZJo`P82?ni^KT2ooooo`06od51@Om8B4Sog]kNomgM
gOm7AdOoA4A40_ooool03_m0@43o6a/KoiNGUooLg=coJFUYoa4A4Oolo?co
oooood51@Om8B4Sog]kNomgMgOm7AdOoA4A41?ooool00onWYjOo0@41okfm
_@03ooooo`05oclo?om[Jf_omoOgoijNW_l[:b/00_ooool04_m0@43o6a/K
oiNGUooLg=coJFUYoa4A4Oolo?cooooood10@?lC4a?oTI6AonCTi?omoOgo
];Bdom[Jf_olo?coHF5QoeADE?ooooooooooooloooooo`000_ooool01_lf
=SKoMgMgooooooooooooBDU9oe=CD`;ooooo00Koj>SXoe9BD_l?3`oo3`l?
oeADE?oYjNT2ooooo`06od10@?mlO7coIFEUo`d=3OlI6AWoZ:RX0_ooool0
1_oXj>SoDU9Bo`l?3ol?3`ooE5ADonWYj@Gooooo00?oEeMGoahN7_o`l?00
0_ooool01OoVi^KoAdM7o`d=3OlL71co]kNg00;ooooo00Ko@410ogalO?mU
IFGo3@d=oaTI6OnXZ:P2ooooo`0:oeADE?n9RHWoGEeMo`T92Oo`l?3oRXZ:
oc8b<_l@413o>CTiolC4a?ooooooooooooloooooo`000_ooool01_lf=SKo
MgMgoooooooooooo=CDeoeEEE@Cooooo0_ono_h4ooooo`04od10@?moOgoo
oooooogmo@Kooooo0_ono_h7ooooo`03ong]kOlI6AWoGUiN00Cooooo00?o
o?clooooooooool00_ooool01?m0@43oOgmoooooooomoOd7ooooo`05oocl
o?ooooooooooooooooomoOd0oooooooooooood7ooooo0002ooooo`06ocHf
=_l_;booFUYJob<S8ol<30co`l?32_ooool00om0@43oOgmoooooo`0<oooo
o`03oo;bl_mUIFGoIFEU00;oIFEU00?o=3@do`000?o>c/h02?ooool00om0
@43oOgmoooooo`3oooooooooooooC_ooool000;ooooo00Go/;2`oiZJV_nJ
VY[o^k^kooWin@0;ooooo`03od10@?moOgoooooo00cooooo00?omoOgoiZJ
V_nJVYX01?nJVYX00ooVi^Koooooooooo`06ooooo`03od10@?moOgoooooo
0?oooooooooooom>ooooo`004_ooool00ookno_ooOgmooooo`0Looooo`03
oo_knoomoOgooooo0?oooooooooooom>ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`003?oo
ool00oo/k>cokno_ooooo`03ooooo`05oo7alOoinOWoo_knonGUiOono_h0
1Oooool00oo/k>cokno_ooooo`0@ooooo`03onc/k?o_knoooooo0?oooooo
oooooom@ooooo`000_ooool03_lf=SKoMgMgoooooooooooom_KfobHV9_m6
ATKoo_knom_Kfole=CGo3Ph>o``<3?li>CWog=cL0_ooool01_m0@43oFEUI
obHV9_lK6a_o5ADEokbl_0;ooooo00Kofm_KocDe=Ol>3Pko30`<ocTi>OoL
g=`2ooooo`03ocHf=_l0003o000000;o000000Co>SXjoooooom0@43oOgmo
0_ooool01_oKfm_o=CDeo`h>3_l<30co>CTiomcLg0;ooooo00Ko@410ogmo
Oooooooooooooj>SXolL71coooooooooooooAoooool000;ooooo00[o=SHf
ogMgMoooooooooooog1`L?lD51CoinOWookno_ld=3CoDU9B0_o^k^h03_mE
EEGo=CDeookno_oooooo@410od=3@oo_knoono_kogemOOlC4a?olo?cookn
o_ld=3CoDU9B0_o^k^h01_mEEEGo=CDeookno_oooooo=SHfogAdM0Gooooo
00Ko@410ogmoOoooooooo_knoc@d=?mBDU82onk^kP06oeEEEOle=CGoo_kn
oooooom0@43oOgmo0_ooool00onSXj?o71`Looooo`3oooooooooooooA_oo
ool000;ooooo00[o=SHfogMgMooooooo`/;2o`820_na/K7oooooomSHf?l0
003o]kNg0_ooool01_ng]kOo0000omcLg?oooooo@410ogmoO`;ooooo00Ko
inOWo`000?n][Jgof=SHo`000?ng]kL2ooooo`06okNg]ol0003og=cLoooo
oolf=SKoM7Ad1Oooool01_m0@43oOgmooooooooHf=So0000okNg]`;ooooo
00Ko]kNgo`000?oLg=cooooood10@?moOgl2ooooo`03oj>SXolL71cooooo
0?oooooooooooom6ooooo`000_ooool01Olf=SKoM7Adono_kolS8b?oJ6QX
00;ooooo00?o_[jno`000?oVi^H00_ooool01_oTi>Co0000ol71`Ooooooo
@410ogmoO`?ooooo00Go5QHFoi6ATOnn_[ko0000onKViP02ooooo`06onCT
i?l0003o`L71oooooolf=SKoM7Ad1Oooool01_m0@43oOgmooooooonn_[ko
0000onKViP;ooooo00Koi>CTo`000?o1`L7ooooood10@?moOgl2ooooo`03
oj>SXolL71cooooo0?oooooooooooom6ooooo`000_ooool01Olf=SKo0`<3
o`000?l0003o`L7100;ooooo00?og=cLo`000?nd];@00_ooool01_nb/[;o
0000on3Ph?oooooo@410ogYjNP;ooooo00KokNg]o`000?o3`l?og=cLo`00
0?nd];@2ooooo`06ok:b/_l0003oh>3Poooooolf=SKoM7Ad1Oooool01_m0
@43oOgmooooooooLg=co0000okBd]0;ooooo00Ko/[:bo`000?oPh>3ooooo
od10@?mMGEd2ooooo`03oifMWOlM7Agooooo0?oooooooooooom6ooooo`00
0_ooool01_lf=SKoMgMgon?ShonJVY[o20P8okVi^@;ooooo00Ko@D51odQ8
B?oNg]kogMgModM7Aom4A4@2ooooo`0>od10@?lK6a_oUiNGomcLg?mYJFWo
4A4Aooclo?oooooo@D51odQ8B?oNg]kogMgModM7Aom4A4@2ooooo`03ocHf
=_mdM7Cooooo00Cooooo00[o@410ogmoOooooooooooood51@Om8B4Sog]kN
omgMgOm7AdOoA4A40_ooool01_m0@43o51@DogIfM_oNg]koEeMGode=COoo
oooooooooom7ooooo`000_ooool01_lf=SKoMgMgooooooooooooBDU9oe=C
D`;ooooo00Koj>SXoe9BD_l?3`oo3`l?oeADE?oYjNT2ooooo`06od10@?ml
O7coIFEUo`d=3OlI6AWoZ:RX0_ooool01_oXj>SoDU9Bo`l?3ol?3`ooE5AD
onWYj@;ooooo00?o=SHfogAdM?ooool01?ooool01_mDE5CoSHf=oooooooo
ooooj>SXoe9BDP;o3`l?00[oE5ADonWYjOoooooooooooeADE?n<S8coNGUi
oa@D5?l^;Rkoa<C4ooooooooooooodOooooo0002ooooo`06ocHf=_mgMgOo
oooooooooole=CGoEEEE1?ooool2ooknoPCooooo00Co@410ogmoOooooooo
oOgm1_ooool2ooknoPCooooo00?o=SHfogAdM?ooool02_ooool2ooknoPOo
oooo00?oo_knooooooooool0ooooooooooooodOooooo0002ooooo`06ocHf
=_l_;booFUYJob<S8ol<30co`l?32_ooool00om0@43oOgmoooooo`0=oooo
o`03ocHf=_mdM7Cooooo00Cooooo00?oFe]Koi:BT_ooool0oooooooooooo
oeKooooo0002ooooo`05ok2`/?nJVY[oVYZJok^k^ooinOT02oooool00om0
@43oOgmoooooo`0=ooooo`03ok2`/?o8b<Sooooo00Cooooo00?o];Bdolg=
cOooool0oooooooooooooeKooooo000Booooo`03oo_knoomoOgooooo0?oo
oooooooooom]ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003o
onk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oo`/;2ooo2`/:2ol;2
`P00>?o2`/801OnBTY;oHf=SodU9BOmLG5coW9bL0?oo`/;2ooo2`/95ol;2
`P00>?o2`/801_mXJ6SoFEUIogemOOm;Bd_o20P8ohn?Sooo`/;2ooo2`/94
ol;2`P003?o2`/800onc/k?o]KFeol;2`P03ol;2`P05okNg]onm_Kgo`L71
ojj^[_o1`L401Oo2`/800onc/k?o]KFeol;2`P0<ol;2`P03okVi^On`/;3o
`/;200ko`/;200?oA4A4ocHf=_o2`/800_o2`/800ono_koo]KFeol;2`P3o
ol;2`_oo`/;2?_o2`/8000;o`/;200ko:BTYoeYJF_o2`/;o`/;2ok^k^olL
71co=CDeol71`OnVYZKo:2PXo`X:2_l92@Wo:b/[ojNWY`;o`/;200Ko<30`
od=3@olL71co51@Do`l?3on?Shl2ol;2`P06ojJVY_lX:2So2PX:o`T92Ol[
:b_oYjNW0_o2`/800olY:BWoFUYJol;2`P04ol;2`P09ojn_[olh>3So0P82
oaXJ6_lA4A7oTY:Bol;2`_l`<33oH61P00;o`/;200[oO7aloaDE5Oo2`/;o
`/;2ojn_[om6ATKo:b/[oeaLG?mgMgOo5QHF0_o2`/801_nATI7o51@Do`D5
1Oln?SkoIFEUob@T90;o`/;200Ko<30`of1PH?o2`/;o`/;2oc0`<?mPH602
ol;2`P03ogalO?lE5AGo`/;20?oo`/;2ooo2`/8_ol;2`P000_o2`/802_lY
:BWoFUYJol;2`_o2`/;oEEEEo`l?3on_[joo`L71obLW9oln?Sh2okFe]@0>
od10@?lX:2So`L71ol;2`_l`<33o<S8bokFe]Onn_[koGemOo`h>3_nh^;So
`L71obLW9oln?Sh2okFe]@06od10@?lX:2So`L71ol;2`_lY:BWoFUYJ1Oo2
`/801?lc<c?o<30`ojVYZOo2`/82okRh^003ol;2`_l`<33oH61P00;o`/;2
00[oO7aloaDE5Oo2`/;o`/;2ocXj>_lR8R;oNg]koeiNG_lR8R;o3`l?0_o2
`/801_lo?coo@d=3ok^k^omhN7So2`/;ob@T90;o`/;200Ko<30`of1PH?o2
`/;o`/;2oc0`<?mPH602ol;2`P03ogalO?lE5AGo`/;20?oo`/;2ooo2`/8_
ol;2`P000_o2`/802_lY:BWoFUYJol;2`_nCTi?o0@41ohJ6Q_o2`/;oY:BT
o`000?n;Rh/2ol;2`P06oh^;Rol0003oYjNWol;2`_l`<33oH61P0_o2`/80
1_n_[joo0000oh>3PonTY:Co0000oh^;R`;o`/;200KoRh^;o`000?nWYjOo
`/;2obTY:OmJFUX4ol;2`P03ojRXZ?l0003oRh^;00Go`/;200[o<30`of1P
H?o2`/;o`/;2ogalO?lE5AGo`/;2ok^k^ol61PKoS8b<0_o2`/801_mbLW;o
30`<ol;2`_o2`/;o8B4Qofe]K@;o`/;200KoG5aLob@T9?o2`/;o`/;2oc0`
<?mPH602ol;2`P06oc0`<?mPH63o`/;2ol;2`_mlO7co5ADEooo2`/;ool;2
`S3o`/;20002ol;2`P05obTY:OmHF5So]KFeoaXJ6_m?Cdl00_o2`/800on@
T93o0000ojj^[P02ol;2`P06ojf][Ol0003oTY:Bol;2`_l`<33oH61P0oo2
`/801Ol@413oKVi^oi2@T?l0003o[Zj^00;o`/;200So[Jf]o`000?nBTY;o
`/;2obTY:Om2@T;oV9RHok>c/`;o`/;200?oT92@o`000?l^;Rh00ol_;bl0
1?nEUIGo`/;2oc0`<?mPH602ol;2`P06ogalO?lE5AGo`/;2oi>CTol0003o
[Zj^0_o2`/801_n2PX;o30`<ol;2`_o2`/;o8B4Qofm_K`;o`/;200KoK6a/
ob@T9?o2`/;o`/;2oc0`<?mPH602ol;2`P06oc0`<?mPH63o`/;2ol;2`_ml
O7co5ADEooo2`/;ool;2`S3o`/;20002ol;2`P05obTY:Ol20P;o0000o`00
0?nBTY800_o2`/800onWYjOo0000ohR8R002ol;2`P06ohN7Qol0003oZZZZ
ol;2`_l`<33oG5aL0_o2`/801_nd];Co0000oiBDU?nWYjOo0000ohR8R0;o
`/;201CoQhN7o`000?nZZZ[o`/;2obTY:OlF5QKo6ATIo`000?m4A4Co^KVi
ojJVY_l0003oPX:2oifMWOnGUiOo0P82ojj^[_o2`/;o<30`odI6AP;o`/;2
00KoMgMgoaHF5_o2`/;oYJFUo`000?n9RHT2ol;2`P06oh:2P_l<30co`/;2
ol;2`_lQ8B7oKfm_0_o2`/801_m/K6co92@Tol;2`_o2`/;o<30`of1PH0;o
`/;200Ko<30`odI6A_o2`/;o`/;2ogMgMolF5QKool;2`_oo`/;2<?o2`/80
00;o`/;200Ko:BTYoeYJF_n/[:coMGEeo`H61_n<S8`2ol;2`P06oc4a<Olf
=SKoZ:RXojRXZ?lf=SKo<c<c0_o2`/802_l`<33o51@Dog9bL_nWYjOoCdm?
o``<3?no_koo`/;2oc4a<Olf=SH2ojRXZ00@ocHf=_lc<c?o`/;2ol;2`_lY
:BWoFUYJol;2`_nPX:3o2@T9oe1@D?o2`/;o;bl_oe5ADOnk^k_oN7Qhob0P
80;o`/;200Ko<30`o`l?3omIFEWoZ:RXod92@_lj>SX2ol;2`P06ob`/;?le
=CGoZj^[okNg]om1@D7o30`<0_o2`/801_lQ8B7oKfm_ol;2`_o2`/;oK6a/
ob@T90;o`/;200[o<30`of1PH?o2`/;o`/;2oc0`<?l?3`ooFEUIojRXZ?m2
@T;o>SXjooo2`/;ool;2`S3o`/;20002ol;2`P06obTY:OmJFU[o`/;2ol;2
`_lg=cOo?clo0_o2`/801_n`/;3o?Shno`/;2ol;2`_o?clook6a/@;o`/;2
00Ko<30`oeiNG_m<C4co2@T9oa<C4omoOgl2ol;2`P06ok2`/?ln?Sko2`/;
o`/;2olo?coo/K6a0_o2`/803?lY:BWoFUYJol;2`_o2`/;oCTi>oaPH6?o2
`/;o[Zj^ocHf=_l92@Wo5ADEoh^;R`;o`/;200Ko?cloofYZJ_mLG5co3`l?
ob8R8_nEUID2ol;2`P06ojb/[?lc<c?o20P8oalO7omIFEWo7alO0_o2`/80
1_lb<S;oN7Qhol;2`_o2`/;oMGEeocDe=@;o`/;200[o?cloof][Joo2`/;o
`/;2oclo?omZJV[oG5aLo`l?3olR8R;oUIFEooo2`/;ool;2`S3o`/;20002
ol;2`P06obTY:OmJFU[o`/;2ol;2`_lX:2So@4101?o2`/82ol71`@Co`/;2
00Co<30`of1PH?o2`/;o`<301_o2`/82ol71`@Co`/;200Ko:BTYoeYJF_o2
`/;o`/;2oc@d=?lc<c<3ol;2`P03okno_oo2`/;o`/;200Go`/;200?o`L71
ol;2`_o2`/801?o2`/800oo0`<3o`/;2ol;2`P0Bol;2`P03ol71`Oo2`/;o
`/;20?oo`/;2ooo2`/8`ol;2`P000_o2`/801_lY:BWo8b<SodA4A?lJ6Q[o
2@T9oiBDU0[o`/;200?o<30`of1PH?o2`/803Oo2`/801_lY:BWo8b<SodA4
A?lM7Ago0@41ohB4Q23o`/;200?oADE5ofm_Koo2`/80ooo2`/;ool;2`SOo
`/;20002ol;2`P05ohF5QOmeMGGoMGEeohj>S_nm_Kd02oo2`/800ol`<33o
H61Pol;2`P0=ol;2`P05ohF5QOmeMGGoMGEeoh>3PonXZ:P08Oo2`/800on8
R8SoVi^Kol;2`P3ool;2`_oo`/;2=oo2`/8001;o`/;200?o_[jnol30`?o2
`/80ooo2`/;ool;2`Vgo`/;2003ool;2`_oo`/;2P_o2`/800?oo`/;2ooo2
`/:2ol;2`P00ooo2`/;ool;2`X;o`/;2003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo000<ooooo`03onc/k?o_
knoooooo00?ooooo00GolO7aooWinOono_koiNGUooknoP05ooooo`03onc/
k?o_knoooooo00_ooooo00?ok>c/oogmoOooool00_odm?@:ooooo`03oo_k
nooXj>Sooooo00Gooooo00?ok>c/oogmoOooool00_odm?Cooooooooooooo
??ooool000;ooooo00ko=SHfogMgMoooooooooooooKfm_lV9RKoATI6ookn
o_oKfm_o=CDeo`h>3_l<30co>CTiomcLg0;ooooo00Ko@410oeUIFOlV9RKo
6a/KoaDE5Onl_;`2ooooo`06om_Kfole=CGo3Ph>o``<3?li>CWog=cL0_oo
ool00olf=SKoMgMgooooo`04ooooo`09oe5ADOl820So6QXJoibLW?lC4a?o
EeMGoooooom0@43oOgmo00;ooooo00[oXj>Soa`L7?oooooooooookFe]Ol>
3Pko0P82obd];OnCTi?o4A4A0_ooool01_mADE7o20P8oaXJ6_nLW9co4a<C
oeMGEooooooooooooollooooo`000_ooool02_lf=SKoMgMgoooooooooooo
L71`oa@D5?oWinOoo_knoc@d=?mBDU82onk^kP0>oeEEEOle=CGoo_knoooo
oom0@43o@d=3ono_kookno_oOGemoa<C4ooclo?oo_knoc@d=?mBDU82onk^
kP06oeEEEOle=CGoo_knoooooolf=SKoMgMg1?ooool01_o6a/Ko10@4omgM
gOoVi^KoFe]Koa4A4@;ooooo00Ko@410ogmoOooooooooooooj>SXolL71`2
ooooo`0=oc<c<omKFe_okNg]ol[:b_l^;Rko4A4Aooooooo6a/Ko10@4omgM
gOoVi^KoFe]Koa4A4@3ooooooooooooo?Oooool000;ooooo00[o=SHfogMg
Mooooooo`/;2o`820_na/K7oooooomSHf?l0003o]kNg0_ooool01_ng]kOo
0000omcLg?oooooo@410ogmoO`;ooooo00KoinOWo`000?n][Jgof=SHo`00
0?ng]kL2ooooo`06okNg]ol0003og=cLoooooolf=SKoMgMg1?ooool01_oI
fMWo0`<3okfm_OooooooWinOob0P80;ooooo00[o@410ogmoOooooooooooo
oj>SXolL71coooooonSXj?l10@7oaLG50_ooool02On[Zj_o4A4AoooooooI
fMWo0`<3okfm_OooooooWinOob0P803ooooooooooooo?Oooool000;ooooo
00Go=SHfogAdM?o_knoo8b<SofQXJ002ooooo`03okjn__l0003oi^KV00;o
oooo00Koi>CTo`000?o1`L7ooooood10@?moOgl3ooooo`05oaHF5_nATI7o
_[jno`000?oVi^H00_ooool02?oTi>Co0000ol71`Ooooooo=SHfoeMGEoo8
b<Sok>c/0oooool01On][Jgo<S8boc<c<olf=SKo820P00;ooooo00[o@410
ogmoOooooooooooooj>SXolL71cooooool30`?l0003oi^KV0_ooool02On/
[:co4A4Aoooooooooooo[Jf]oc8b<_lc<c?o=SHfob0P803ooooooooooooo
?Oooool000;ooooo00Go=SHfo`<30ol0003o0000ol71`@02ooooo`03omcL
g?l0003o];Bd00;ooooo00Ko/[:bo`000?oPh>3ooooood10@?mjNWX2oooo
o`06ong]kOl0003o`l?3omcLg?l0003o];Bd0_ooool02_nb/[;o0000on3P
h?oooooo=SHfoahN7_lQ8B7o0@41oeYJF_odm?@3ooooo`03oogmoOnDU9Co
8B4Q00;ooooo00[o@410oeeMGOoooooooooooifMWOlM7Agoooooon3Ph?l0
003o/[:b0_ooool00on/[:co4A4Aooooo`03ooooo`03oogmoOnDU9Co8B4Q
0?oooooooooooolmooooo`000_ooool01_lf=SKoMgMgon?ShonJVY[o20P8
okVi^@;ooooo00Ko@D51odQ8B?oNg]kogMgModM7Aom4A4@2ooooo`0>od10
@?lK6a_oUiNGomcLg?mYJFWo4A4Aooclo?oooooo@D51odQ8B?oNg]kogMgM
odM7Aom4A4@2ooooo`0<ocHf=_mgMgOoooooom?Cdol<30coJVYZoooooond
];Cof][Jooclo?mQHF7oE5AD0_ooool01_m0@43o51@DogIfM_oNg]koEeMG
ode=C@;ooooo00Ko@d=3odI6A_oShn?ojn_[oe9BD_lA4A42ooooo`05okBd
]?oJf][oo?clof5QHOmDE5@0ooooooooooooocgooooo0002ooooo`06ocHf
=_mgMgOooooooooooom9BDWoDe=C0_ooool01_oXj>SoDU9Bo`l?3ol?3`oo
E5ADonWYj@;ooooo00Ko@410ogalO?mUIFGo3@d=oaTI6OnXZ:P2ooooo`06
onSXj?mBDU;o3`l?o`l?3omDE5CojNWY0_ooool03?lf=SKoMgMgoooooooo
ooooIfMWob0P8?ooooooRXZ:oc8b<_l@413o>CTiolC4a0;ooooo00KoE5AD
ohb<S?miNGWo51@Dobh^;_o4a<@2ooooo`06onKVi_m4A4Co30`<obPX:?m]
KFgo4A4A0_ooool01On:RX[o<S8boa0@4?li>CWoa<C40?oooooooooooolm
ooooo`000_ooool01_lf=SKoMgMgoooooooooooo=CDeoeEEE@Cooooo0_on
o_h4ooooo`04od10@?moOgoooooooogmo@Kooooo0_ono_h4ooooo`06ocHf
=_mgMgOooooooooooom5ADGoA4A40oooool00oomoOgoooooooooo`05oooo
o`03ookno_oooooooooo00Cooooo00CooOgmoooooon/[:co4A4A1?ooool0
0oomoOgoooooooooo`3ooooooooooooo?Oooool000;ooooo00Ko=SHfobl_
;omJFU[o8b<So``<3?o3`l<:ooooo`03od10@?moOgoooooo00gooooo00Ko
=SHfobl_;omJFU[o9bLWo`820_n^[ZhDooooo`03ojb/[?lA4A7ooooo0?oo
oooooooooom3ooooo`000_ooool01On`/;3oVYZJoiZJV_nk^k_onOWi00_o
oooo00?o@410ogmoOoooool03Oooool01On`/;3oVYZJoi^KVon][Jgog]kN
01Gooooo00?o[:b/oa4A4Oooool0oooooooooooood?ooooo000Booooo`03
oo_knoomoOgooooo02Oooooo00?oo_knoo[jn_ooool0oooooooooooood?o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool003Cooooo00Go`<30oh>3PomQ
HF7oNGUiolk>cP3oooooooooooooBOooool003Cooooo00KoRHV9ogIfM_nU
YJGoHf=So`/;2onl_;coooooooooooooB?ooool000cooooo00?ok>c/ono_
koooool00oooool01OoalO7onOWiookno_oUiNGoo_kn00Gooooo00?ok>c/
ono_koooool03oooool00oo/k>cokno_ooooo`07ooooo`03oeYJF_m7AdOo
oooo0?oooooooooooom7ooooo`000_ooool03_lf=SKoMgMgoooooooooooo
m_KfobHV9_m6ATKoo_knom_Kfole=CGo3Ph>o``<3?li>CWog=cL0_ooool0
1_m0@43oFEUIobHV9_lK6a_o5ADEokbl_0;ooooo00Kofm_KocDe=Ol>3Pko
30`<ocTi>OoLg=`2ooooo`07ocHf=_l0003o0000o`P82?l_;booLg=coo?c
l`03ooooo`06om_Kfole=CGo3Ph>o``<3?li>CWog=cL0_ooool01_oWinOo
GEeMocTi>OmjNW[oWIfMoahN7_oooooooooooom8ooooo`000_ooool02_lf
=SKoMgMgooooooooooooL71`oa@D5?oWinOoo_knoc@d=?mBDU82onk^kP0>
oeEEEOle=CGoo_knoooooom0@43o@d=3ono_kookno_oOGemoa<C4ooclo?o
o_knoc@d=?mBDU82onk^kP0@oeEEEOle=CGoo_knoooooolf=SKoM7Adoooo
oooemOGoc<c<odE5AOlQ8B7ol?3`ooooooono_ko=3@doe9BDP;ok^k^00[o
EEEEocDe=Oono_koooooode=COl^;RkoXZ:RogalO?l];Bgo51@Doooooooo
ooooodSooooo0002ooooo`0:ocHf=_mgMgOooooool;2`_l20P;o/K6aoooo
oooHf=So0000okNg]`;ooooo00Ko]kNgo`000?oLg=cooooood10@?moOgl2
ooooo`06onOWiol0003o[Jf]omSHf?l0003o]kNg0_ooool01_ng]kOo0000
omcLg?oooooo=SHfogAdM0?ooooo00Oon_[joalO7omaLG7oooooomSHf?l0
003o]kNg00;ooooo00Ko]kNgo`000?oLg=com_Kfo`T92Oni^KT2ooooo`03
oiJFU_lA4A7ooooo0?oooooooooooom7ooooo`000_ooool01Olf=SKoM7Ad
ono_kolS8b?oJ6QX00;ooooo00?o_[jno`000?oVi^H00_ooool01_oTi>Co
0000ol71`Ooooooo@410ogmoO`?ooooo00Go5QHFoi6ATOnn_[ko0000onKV
iP02ooooo`06onCTi?l0003o`L71oooooolf=SKoM7Ad1?ooool01_mlO7co
8R8Roooooonn_[ko0000onKViP;ooooo00Koi>CTo`000?o1`L7o`/;2o`00
0?oVi^H2ooooo`03ojb/[?lA4A7ooooo0?oooooooooooom7ooooo`000_oo
ool01Olf=SKo0`<3o`000?l0003o`L7100;ooooo00?og=cLo`000?nd];@0
0_ooool01_nb/[;o0000on3Ph?oooooo@410ogYjNP;ooooo00KokNg]o`00
0?o3`l?og=cLo`000?nd];@2ooooo`06ok:b/_l0003oh>3Poooooolf=SKo
M7Ad1?ooool01_nNWYko0`<3ooWinOoLg=co0000okBd]0;ooooo00Ko/[:b
o`000?oPh>3of][Jo`000?ne]KD2ooooo`03ojb/[?lA4A7ooooo0?oooooo
oooooom7ooooo`000_ooool01_lf=SKoMgMgon?ShonJVY[o20P8okVi^@;o
oooo00Ko@D51odQ8B?oNg]kogMgModM7Aom4A4@2ooooo`0>od10@?lK6a_o
UiNGomcLg?mYJFWo4A4Aooclo?oooooo@D51odQ8B?oNg]kogMgModM7Aom4
A4@2ooooo`03ocHf=_mdM7Cooooo00?ooooo00[oT92@o`D51Ookno_ooooo
od51@Om8B4Sog]kNomgMgOm7AdOoA4A40_ooool01_lk>c_oATI6on;Rh_oa
lO7oEUIFoa4A4Ooooooooooooom8ooooo`000_ooool01_lf=SKoMgMgoooo
ooooooooBDU9oe=CD`;ooooo00Koj>SXoe9BD_l?3`oo3`l?oeADE?oYjNT2
ooooo`06od10@?mlO7coIFEUo`d=3OlI6AWoZ:RX0_ooool01_oXj>SoDU9B
o`l?3ol?3`ooE5ADonWYj@;ooooo00?o=SHfogAdM?ooool00oooool01_mB
DU;o;2`/ooooooooooooj>SXoe9BDP;o3`l?00[oE5ADonWYjOoooooooooo
on?Shom4A4Co2`/;obTY:OmfMWKo:RXZooooooooooooodSooooo0002oooo
o`06ocHf=_mgMgOooooooooooole=CGoEEEE1?ooool2ooknoPCooooo00Co
@410ogmoOooooooooOgm1_ooool2ooknoPCooooo00?o=SHfogAdM?ooool0
0_ooool00onOWioo0@41oj6QX@04ooooo`;oo_kn1_ooool00oomoOgooooo
ooooo`3oooooooooooooBOooool000;ooooo00Ko=SHfobl_;omJFU[o8b<S
o``<3?o3`l<:ooooo`03od10@?moOgoooooo00gooooo00So=SHfobh^;_mT
I6CoCdm?obd];Ol71`OoShn?ookno_oooooooooooomHooooo`000_ooool0
1On`/;3oVYZJoiZJV_nk^k_onOWi00_ooooo00?o@410ogmoOoooool03Ooo
ool01_n`/;3oVYZJoiZJV_nRXZ;oa<C4on_[jooooooooooooomJooooo`00
4_ooool00ookno_ooOgmooooo`3oooooooooooooKOooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
OgmoEomoOgl7oginO_ooOgmo9?moOgl00004on_[jooVi^Koh^;RomkNgPCo
gMgM0ooNg]h0oooMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomcLg?oNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMg@005_oN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kog=cLomgMgOoKfm/2omcL
g00comgMgOoMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN00;og=cL00GofMWIomSHf?oG
emOof=SHomWIfP02omcLg03oomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kN000GomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMh00ooNg]h00ooMgMgog]kNomkNgP03omgMg@7ohN7Q0OoWinL1
on[ZjP0000?ok>c/onKVi_oPh>001ooIfMT01?oHf=Soe]KFom?Cdoo@d=03
olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@
0oo=cLd01?o@d=3odm?ComOGeooHf=P5omWIf@03omSHf?oIfMWofMWI00?o
fMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=SK
omWIf@;of=SH00Koe]KFom?CdooCdm?oe=CDomOGeooHf=P2omWIf@03omSH
f?oIfMWofMWI00;of=SH2OoIfMT00ooHf=SofMWIomWIf@02omSHf003omWI
fOoHf=Sof=SH00;of=SH5ooIfMT01?oHf=Soe]KFom;Bd_o?cll2olg=c@04
olo?cooCdm?oemOGomSHf?oofMWI5_oIfMT00ooHf=SofMWIomWIf@06omWI
f@7og]kN0OoVi^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoPh>3o
h^;R00;ohN7Q00gog]kNomcLg?oCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk
^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?oalO7ok^k
^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoO
om_KfooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_o
gmoO0=[ohN7Q00Woh>3PomoOgooKfm_oe]KFomCDe?oFe]Kof][JomkNg_oP
h>001_oOgml3on3Ph003omoOgooPh>3oh>3P00;oh>3P2?oOgml2omkNgP;o
gmoO0ooPh>02omoOg`;oh>3P0_oOgml=on3Ph005omoOgooMgMgofMWIomGE
eOoCdm<00_oBd]800ooFe]Kog=cLon3Ph03oon7QhASohN7Q00?oh^;Ron7Q
hOoRh^801?oQhN41onCTi07ojNWY0Oo]kNd00003oo3`l?o_knoolO7a00?o
l?3`0?ookno_oo3`l?o^k^kojNWYom_Kfoo1`L7oY:BTohb<S?mkNg_oMgMg
og]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_oNg]kogMgMomk
Ng_oS8b<ojBTY?o2`/;of][Jon[Zj?o]kNgolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ong]kOoZj^[of][Jol;2`_nTY:CoS8b<og]kNomgMgKoNg]k
ohb<S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knl001_olO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo^k^ko
kno_on[Zj_oWinL00_oPh>001ooShn?ojn_Yon_[jooZj^[oi^KVonSXj?oW
inL00_oYjNT04_o^k^cok>c/onc/k?oXj>Sok>c/ong]kOo`l?3ok>c/on[Z
j?oVi^Koj>SXonOWiooYjNWoj>SXon_[jooWinOoinOUonGUi@;ojNWY00oo
k^k^ong]kOo]kNgoj>SXon_[jOo/k>cok^k^onWYjOoZj^[ojn_[ono_koo/
k>cok>cZon[Zj_o^k^h00_o/k>`0oooZj^[okno_onc/k?o/k>[oj^[Zonk^
k_o/k>co[jn_ogIfM_mIFEWoKVi^okNg]_oPh>3ojNWYong]kOoalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_k`00;OoalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNool?3`ono_koo`l?3okno_oo3`l?o_
knool?3`ono_k`04oo3`l00000?ol_;bonk^k_oWinL01?oUiND04?oTi>Co
gmoOom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:
RXWo/K6aom7AdOoNg]h2onCTi003onGUiOoTi>CoiNGT00;oi>CT00oog]kN
om7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o
/K6aom7Ad?oNg]h00_oTi>@0kOoUiNGoi>CTonGUiOoTi>Coi>CSomkNg_oA
dM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a
/OoAdM7og]kNonCThooTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi002onCTi03oolG5aOlX:2SoA4A4oi2@
T?oAdM7og=cKom_KfooGemOoe=CDomKFe_oDe=CoeMGEomWIfOoPh=oog]kN
om[Jf_oDe=CofMWIomkNg_oRh^;og=cLomOGe_oDe=Coe]KFomCDe?oEeMGo
f=SHom_KfooGemOoe]KEomGEeOoGemOof=SHomkNg_oOgmoog=cLomGEeOoG
emKog=cLomgMgOoGemOoe]KFom_KfooQhN7og]kNom_Kf_oJf][og]kNomcL
g?oJf][ofm_Kon3Ph?oOgmoog=cKomWIfOoNg]kogmoOogAdM?mWIfOoSHf=
oeADE?l820SoXZ:RomcLg?oRh^;oiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CT001HonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi0CoiNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o]kNd1oo;b
lP0000?om?Cdong]kOoWinL00_oPh>004ooQhN7ogmoOomkNg_oBd];o];Bd
ohN7QomLG5coKC/eoii>@_o=KeoojH=_ole_GonNCT?oKC/foeaLG?n7QhOo
];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLofeP;?nN
URkocLdoonWYCOo=cCooWYX_ofeS;OmLG5coQhN7okBd]?oBd];og]kN00Go
h>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m7IbkoJ9hcoi7=AonZjEGoTLe7
ofZN=?m9JRooG5aLohN7Qond];Cod];BomkNgP3Ion3Ph006omoOgoo?cloo
VIVIoi:BT_lI6AWoS8b<0_oEeMD07oo?cloo`/;2olk>c_o>c/koaLG5ol[:
b_oJf][of=SHom3@d?o;bl_oclo?omSHf?oJf][oeMGEolo?coo1`L7od=3@
olk>c_o4a<Cobl_;omSHf?oGemOo_[jnok^k^ooAdM7od=3@omGEeOoHf=So
dm?Colc<c?o>c/h00_oEeMD01Oo>c/koc<c<om?CdooJf][of=SH00;od];B
00Cof=SHomOGeooAdM7odm?C0_oIfMT01_oCdm?odM7AomOGeooHf=SodM7A
om3@d0;odM7A00CoATI6od51@OoGemOog]kNoooPh>0Fon3Ph003omoOgooP
h>3ogmoO00;ogmoO0ooPh>000ooQhN7oinOWonc/k001ooCdm00000?om_Kf
oo;bl_o[jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWiooJemOohlf;_o]LF7o
nIf@oofaYOom_:oooKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;Rh_oW
inL00ooXj>P04ooWinOoh^;Rolg=cOnOWiooKVIOoi=b8_o]dDConO=doogm
SOomoIGooOf>ooWhM_o]edOoTg<RofiWGonOWioocLg=on;Rh_oWinL00ooX
j>P04ooWinOoh^;Rolg=cOnOWiooH6QOod]l8onBhD_o_OUkom3mT_oHoI_o
e?fEol3iO_nHj4goCH0Tof1YGonOWioocLg=on;Rh_oWinL0f_oXj>P01?oV
i^KohN7QoeeMGOm=CDd2omgMg@0Ooe1@D?l71`Oo5ADEohB4Q?lF5QKo@d=3
on;Rh_oMgMgoW9bLo`000?n?ShoogMgMon7QhOoKfm_o@410o`P82?lI6AWo
R8R8o`/;2omHF5So]kNgo``<3?l71`Oo8b<SobLW9ommOGgof][JomgMgOoD
e=Co2`/;oeUIF@02omWIf@03oeeMGOl;2`_odm?C00;ogmoO00KoFUYJodi>
C_oNg]kog]kNob<S8on4Q8@2on7Qh@0<ogYjN_l^;RkogMgMomgMgOo2`/;o
D51@oc<c<om^KVkoPh>3ob4Q8OoNg]koi^KVoooXj>POonSXj07ok>c/0Oob
l_81ooKfmP0000?omoOgooShn?ohn?P00oohn?P04oogmoOok^k^olk>c_n@
T93oQBl[onUTE_okTXOooZJKoojaYOoo^:_oo[>VoojXW?okU8WokVQIohTa
:on@T93oc/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93oVFT[
oo2m?Ookh6koo_B2ooknR_oooi;oo_j<ookhPookiG3ol<8noiUZ:on@T93o
c/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93o@W<[ohC>@on]
kg?o`_j8olknT?oFoiOod?jBolKnROnbmGCoR==3odAe:on@T93oc/k>onk^
k_ogmoL0f_ohn?P09Oofm_KolO7aoh61POlO7aookNg]olK6a_l0003o`l?3
om?CdomLG5co20P8on[Zj_o`l?3oj^[Zoe9BD_lD51Co?CdmonWYjOo`l?3o
[jn_o`L71ooBd];ocLg=odi>C_lK6a_ok^k^om_Kfon^[Zkoj>SXonc/k?n^
[Zko0000okBd]?o/k>co/;2`o`/;2olJ6QX00_oTi>@02olS8b?o3Ph>ojBT
Y?o]kNgok^k^of1PH?mDE5Cok^k^ong]kOlV9RKoSHf=00;ol?3`00coPX:2
oc4a<Oo/k>coj^[Zod=3@ol_;booW9bLog=cLolZ:R[o6QXJonk^k_ofm_Ko
ooShn1Son?Sh00?omoOgooShn?ohn?P00_ohn?P01?ogmoOonOWiooOgmoog
moL1ooShn00000?on_[jooGemOo^k^h00_o/k>`0ooo[jn_ojNWYomoOgonj
^[[oNE9Boklb9?oWM6WooHUnoonHS?onXYKoojRLoojTV?ooVXgooXYoonif
J_o3<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/on[Zj_oOgmoo^[Zj
ohQUD_oRTAconL=@oogJHooojW;oo_=nooojP_onmWooonacookNI?ojae7o
hY8LohUVDonj^[[ogmoOon[Zj_o[jn_ok>c/on_[jooZj^[ogmoOokZj^_mB
KE;oDJ<Loi7BEOnVif[o^?Ujol3nP_o7ohWo`oj4okWmNonWk6coU=IGoe:V
7?mBKE;o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k000BOo/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?oYjNWoiNGU
ogYjN_lL71cohN7Rolc<c?l30`?oX:2PomkNg_nDU9Co4a<Con7QhOoPh>7o
d=3@o`H61_nQXJ7o2@T9okno_ooQhN7o^[Zjo`820_nb/[;ogMgMoh20P?lX
:2Sohn?SonOWiooUiNGogmoOom_KfooCdm?o20P8ohF5QOoOgmooJFUYodY:
B_le=CGo[Jf]okfm_Ol71`OoN7QhoeEEEOoOgmooh>3Poe]KFom@D5000_oQ
hN402_lT92CoQHF5omoOgooQhN7oNg]kobl_;ooPh>3oe=CDo`D51OnXZ:P2
on?Sh`3ooginOolF5QKohN7Qon[Zj_o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[000Jonc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jn`6on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT00003
oo_knooclo?okNg]00;oiNGU02[oi^KVonCTi?oIfMWo/[:bogT^;_o8@SCo
hfYLooAjKOomR7cooYN:oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb
/[;of=SHonCTi?oUiNGoi^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^l
A?onc5?ooMQRookSL_onjGGoo^IcookKIOomc5?onl55onjN:onIERko/[:b
omSHf?oTi>@3onGUi@3oonCTi?oHf=Wo/[:bobiR;_mS[B_oQlY8oiOLFOnU
iFWo/_=gokSfNondmGWoYnY[oiSLFOn9cd_oHjh[obiS;_nb/[;of=SIonCT
i?oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVon?ShooOgmooMgMgoa/K6ooLg=cohN7QoijN
W_l_;boo:b/[oc8b<_lB4Q;og=cLom[Jfon4Q8Co820Pon3Ph?mBDU;oJ6QX
0007om[Jf_oNg]koT92@obXZ:_l^;Rko;2`/obLW9`02omkNgP0ComWIfOoC
dmCod=3@oe]KFol0003o_Kfmom[Jf_lX:2SoQhN7ogMgN?mXJ6SoPX:2oc`l
??o2`/;o3`l?omCDe?oJf][oFEUIodi>CP02omcLg03oob<S8on1PH7oeMGE
omOGeomgMgOo;Rh^omcLg?nSXj?o0000olO7aooHf=SofMWIohf=S_lE5AGo
g=cLonCTi?oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGU000VonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNH2onKViP03
onGUiOoVi^Koi^KV00?oi^KV00?oiNGUong]kOodm?@00Ookno/00003oocl
o?ohn?SolO7a00?ok^k^01?ojn_[on7QhOnl_;coNQLGol<o<_oCETWoi6QJ
onmgK?odPgWon8MlooF4N_ocNFgoiFUKomUHB_o4?c;oO1LGokbl_?oQhN7o
k>c/00?ok^k^01?ok>c/on7QhOnl_;coYDLGonJG<_oe[33ooKa1oog9Doom
d63onm=UoogBH?oncECooKe2ooZ_<_oYVc;oYDHGokbl_?oQhN7ok>c/00?o
k^k^01?ok>c/on7QhOnl_;co5eTGoenX<_mf_COoQ/e7oiKFF_nRh6GoXn1Y
oj?QIonGfUcoQ/i7ogNo=omOZc;o5eTGokbl_?oQhN7ok>c/0=[ok^k^02ko
k>c/onOWiomkNg_o71`LonCTi?oYjNWoi^KVon7QhOoNg]koSHf=oa@D5?oV
i^Koi>CTocDe=OmiNGWojn_[ok:b/_lE5AGogmoOonKVi_oTi>CohN7QomgM
gOmjNW[o:BTYonSXj?oUiNGogMgMok6a/OlV9RKo2`/;oi^KVooYjNWoc<c<
o`000?o>c/ko`l?3obDU9Om;Bd_oO7alonSXj?la<C7oYJFUonCTi?mMGEgo
DE5A0_oWinL02_lU9BGoJFUYomoOgooOgmooMgMgoc4a<OoYjNWo`L71o`00
0?nWYjL2omoOg`04oi>CTolF5QKoinOWonc/k?ook^k^7_o^k^h00oo]kNgo
l_;booShn001ooclo0000oomoOd05_olo?cooOgmoogmoOolo?colo?com7A
dOmX1`Oo^3@dolLo<ooBD4?ofV9Eon=^H_oTLVCoi6mRomaTEooCDD?oc44d
okTd=?m[1`Ood];Boo?cloolo?`3oogmo@0Cooclo?oclo?od];Boih[1ooJ
RSCoji/IooFX:Ooh]3oonKe:ooRoCOoj_d[onKPoooJZ:_o_WQWofh/doj8]
1ooBd];olo?cooclo003oogmo@0Cooclo?oclo?od];Bo`M01om=VSCoGj/P
og2h;omo`d?oR/e@ohg=D_n:cU3oPLM4og6i;omR[R3oCY/do`M21ooBd];o
lo?cooclo03Joogmo@0Soo_knoogmoOoQ8B4oahN7_oclo?onOWiok>c/oo@
d=3olo?cofQXJ?m7AdOon_[jomCDe?l0003ogMgMooclo?okno_o9bLWojRX
Z?oinOWoZj^[omGEeOoalO7oE5ADoeiNG_oinOWom?CdoiBDU?l51@Go@410
om7AdOogmoOon?ShoiNGUol[:b/00_ojn_X06olT92Co1`L7olS8b?okno_o
QHF5of=SHoogmoOoHf=SoeMGEoohn?SonOWiobLW9olE5AGoPh>3omOGeom2
@T;oHf=Soo_knoojn_[o=3@dodU9BOoKfm_oiNGUodm?ColG5aOon_[joocl
o03ooogmoAcooOgm00?oo?cloogmoOolo?`00oomoOd0000joogmoOojn_[o
lo?conk^k_o`l?3okno_onk^k_oYjNWodm?Coe/M7OnR=3Co]2PMol4j;Oo7
BCcoceI:om1GBoo@Ed[obTXnol<k;_nf:1goXS@doe`M7OoCdm?oj^[Zonk^
k_o`l?3okno_oo3`koo^k^koj^[Zom?Cdon<9Agob74domV47OoTU1GoiidT
onjX<oo`ZSCokjXconbP9OoWUaGog8PMolQa=?n<9Agodm?Con[Zj_o^k^ko
l?3`ono_koo`l?3ok^k^on[ZjOoCdm?o7CPMocB2=?m7UAgoFZDKofV]:P;o
M;Ph0>;oMKThof^a:omKYacoB9XMocB2=?lM>1godm?Con[ZjOo^k^kol?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`0_o_knl0oooZj^[oOWinoa`L7?oXj>OokNg]ohR8R?l`<33o
3`l?oc4a<Ona/K7ok^k^ohF5Q?m=CDgokno_onk^k_o_knooRXZ:oeUIFOo^
k^koN7Qhob/[:ol?3`oo>3Phokno_oo]kNgoi>CTo`h>3_mYJFWogmoOon?S
hooUiNGojn_[of5QHOmgMgOok^k^ono_k_mfMWKo9RHVong]kOo_knooc<c<
ob`/;?oZj^[oKFe/of9RH_o/k>cokNg]oc/k>onCTi?oHV9Ro`h>3_ld=3Co
a<C4ono_koo^k^kodM7Aoc`l??l:2P[o9bLWofa/K?l/;2cokno_onk^k_o`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
k`00E_o`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_0_o`l?06ono_k`7o
lo?c0OoinOT1ooknoP0000?oo_knooOgmoo`l?001?oYjNT04OoWinOofm_K
of=;Bon1<S;oYSDeokHd;Oo2CD7o`eA9olAEB_o3E4Wo`Te1okHd;OnU=CGo
PC8bof=;BooKfm_oinOW00GojNWY017oinOWom_Kfon9Bd_o[d/boleg=OoF
Rbgoh9`^on2P<_oQX3Coh:0bomnJ;_oFRbgobWDeojm;<_n9Bd_ofm_KonOW
i`03onWYj@0ConSXj?oYjNWoinOWom_Kfom;Bd_o<V0bocZ9=OmCVbgoJj/_
og2]>?m_[S[oL:dhofZZ;omCVbgo>HPeoc9P<_m;Bd_ofm_KonOWi`3KonWY
j@06onSXj?oVi^KoNg]koa`L7?oTi>Coj>SX0_oYjNT00ooWinOojNWYonWY
j@0;onWYj@0<onOWiooYjNWojNWYonSXj?oHf=So2PX:ojj^[_oMgMgog]kN
on3Ph?oUiNGoj>SX2?oYjNT01_oXj>Soi^KVon?ShooShn?oi^KVonSXj0?o
jNWY00?oj>SXonWYjOoYjNT01?oYjNT00ooWinOojNWYonWYj@3oonWYjA_o
jNWY00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07omoOg0Oono_h00005ookn
o_ojn_[om?Cdono_kooalO400_o`l?004Oo_knoojn_[oiFDU?m?8b?oUEAD
ok]cLooCUIGofYbLomZNW?oIW9coe9FEok]cLonEE5CoCb<SoiFDU?oZj^[o
kno_00Gol?3`017okno_on[Zj_nYU9CoPB<SokYZE?oDVW?oi;bEon[7W?oY
aicoj/NLonFlUOoDVW?o^fYDoh4S8onZU9Coj^[Zono_k`05oo3`l00Aono_
kooZj^[oU9BDob<Z8omDNUCoLjEcoik6UOn/cYco[LjLojc>W?nNaYGoLjEc
oeAjE?lS:R?oU9BDon[Zj_o_knl0foo`l?02ono_k`04oh20P?lM7Agok^k^
ono_ka?ol?3`0_o_knl01omTI6Co:BTYoh61POmSHf?o>c/konk^k_o_knl0
2?o`l?001_o_knook^k^og=cLomYJFWok^k^ono_koool?3`;Oo`l?001?oa
lO7ol?3`ooCdm?ojn_X1ooknoP0000Coo_knooooooooooooo_kn0_ooool2
ooknoP3ooogmoOohn?SoKVi^oeXo?onaT93og/W9oo3Ti?oci^Kol>CTomk9
bOnaT93oFSloofe]KOohn?Soo?clooooooono_koooooookno_ooookoo_kn
ooooooolo?con?Shohe]KOn:?coobI6@onW@bOodjNCom^_VooCYi?oYd<Wo
bI6@ohTo?on=KFgon?Sgooclo?ooooooo_knooooooono_koooooookno_oo
ookoo?clooShn?m]KFgo?clooi2MT?o9eLWoi>cTonK^i_oTk>CobMG9oi2M
T?lo?cooKFe]ooShn?olo?coooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_kn000hooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooomoOgod=3@ojFUYOono_goo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_kooooooogmoOo1`L3oLG5aoh61POn_[jl2ooknoP0<
ooooooono_koooonookno_ooooooo_knooooooono_kooooooogmoOo2`/7o
_;bl0_ono_h0ooooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooo`00:Oon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_kn00;ooooo00?oo_knoooooooo
ool00oooool1ooSkoP0000Coooooookno_ojn_[om?Cd1OoalO403Oo_knoo
e]KFof][Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?CgoJf][omKFe_o_
knl02OoalO403Oo_knooemKFoh=[Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<
S?mb?CgoPF][omOFe_o_knl01OoalO404Oo`l?3olO7aoo7alOoalO7okno_
omKFe_m[Jf_o?Cdmohb<S?nj^[[oc<g<okZj^_n<S8co?Cdmof][JooFe]Ko
kno_0?oolO7aoooalO4doo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00?o
m?Cdoo[jn_ono_h00OoZl_`00005ooGemOomoOgon?Shoo3`l?o[jn/00ooZ
j^X03OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWo
Vi^KonSXj?oYjNT02ooZj^X02ooYjNWoj>SXoj2KVomZFEWo@bHVobd92Om2
9RKoJEUIoj2KVooXj>SojNWY00Goj^[Z00?ojNWYon[Zj_oZj^X00ooZj^X0
2ooYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY
0?ooj^[ZoooZj^Xlon[ZjP04on_[joo`l?3on?Shoogmo@7ocmg_00001?o7
alOooOgmoo[jn_odm?@8oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03
ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`l?3ooo7alOoolO7a>_oalO40
0oo`l?3olO7aoo7al@02oo7al@03ooGemOojn_[oinoj007oUjW000000ooD
e=Coc/k>ooooo`3oooooooooooooO?ooool1onS`n`7oY;C80OnI[l/00005
oo;bl_oDe=Coa/K6ooGemOono_h0ooooooooooooogOooooo00Gon?_non[b
o?o?g_3oUjW0oiV`c001ojo8j000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[BoxData[{
    \(\(savedLayout = pane@getLayout[];\)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]\(pane@
          setLayout[\[IndentingNewLine]JavaNew["\<java.awt.GridLayout\>", 2, 
              3, 5, 5]\[IndentingNewLine]];\)\[IndentingNewLine]]\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(strings = {\[IndentingNewLine]JavaNew["\<java.lang.String\>", \
"\<RoboDog\>"], \[IndentingNewLine]JavaNew["\<java.lang.String\>", \
"\<RoboPanda\>"], \[IndentingNewLine]JavaNew["\<java.lang.String\>", \
"\<RoboPenguin\>"]}\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject21179439601680385], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject33020840027095041], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject25762741205598209]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(list = NewJList[pane, strings]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JList"] \[RightGuillemet]\),
      JLink`Objects`JavaObject40040084275201]], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(vector = JavaNew["\<java.util.Vector\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.util.Vector"] \[RightGuillemet]\),
      JLink`Objects`JavaObject16777218]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(list2 = NewJList[pane, vector]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JList"] \[RightGuillemet]\),
      JLink`Objects`JavaObject101490177867777]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]vector@
        addElement[JavaNew["\<java.lang.String\>", "\<RoboLion\>"]]; 
      vector@addElement[JavaNew["\<java.lang.String\>", "\<RoboZebra\>"]]; 
      vector@addElement[
          JavaNew["\<java.lang.String\>", "\<RoboElephant\>"]];\
\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(Do[ReleaseObject[strings[\([i]\)]], {i, 1, 
        Length[strings]}]\), "\[IndentingNewLine]", 
    \(DeleteJObject[pane, list]\)}], "Input"],

Cell[BoxData[{
    \(\(ReleaseObject[vector];\)\), "\[IndentingNewLine]", 
    \(DeleteJObject[pane, list2]\)}], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["<<< SimpleJList (ListSelection) >>>",
  FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004B0000]QP00`40o`00
0?l0003oo`0001<000000003R<2hB928B9280?m8T8P?B9280@00000000>8
`;S8h=R8`;P0ohS0^0j8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^0j8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;SoVIW<2iVIc0:8`;P1B9280@00000000F8`;S8
h=R8`;R8`;RIVL`0olc<o`W<c?l019VIc8S0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hVIW<0?o<c?l9c<co00BIVLb8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^9VIc03oc<co2Lc<o`04VIW<R<2hR<2hB9280@00000000F8
`;S8h=R8`;R8`;RIVL`00P0000C<c?l2000000?<c?l0000000000P0000;<
c?l2000000?<c?l0000000000lc<o`@00002c<co0P0000?<c?l200000/c<
o`@00003c<co1@000003c<co0000000000;<c?l50000c<c<o`04VIW<R<2h
R<2hB9280@00000000F8`;S8h=R8`;R8`;RIVL`00P0000?<c?l2000000?<
c?l0000000000/c<o`8000001Lc<o`00000000000<c<o`02000000?<c?l0
000000000/c<o`8000000lc<o`0000000003c<co0P000003c<co00000000
00;<c?l2000000?<c?l0000000000/c<o`8000001<c<o`0000000<c<o`80
0002c<co0P000<c<c?l019VIc8S0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hVIW<00800003c<co0P000003c<co0000000000;<c?l2000000?<c?l0
000000000/c<o`8000000lc<o`0000000002c<co0P000003c<co00000000
00;<c?l200000/c<o`800002c<co0P000003c<co0000000000;<c?l20000
00C<c?l00000003<c?l200000/c<o`80003<c<co00BIVLb8`;R8`;Q8T8P1
000000001HS0^<SPf8S0^8S0^9VIc00200000/c<o`800002c<co0P0000;<
c?l2000000?<c?l0000000000/c<o`8000000lc<o`0000000002c<co0P00
0003c<co0000000000;<c?l200000/c<o`800002c<co0P0000;<c?l20000
00C<c?l00000003<c?l200000/c<o`8000000lc<o`000000003<c<co00BI
VLb8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^9VIc00600000/c<o`80
0002c<co0P000003c<co0000000000;<c?l2000000?<c?l0000000000/c<
o`8000000lc<o`000000000400000/c<o`800002c<co0P0000?<c?l40000
00?<c?l0000000000lc<o`@0003<c<co00BIVLb8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^9VIc00200000lc<o`800002c<co00<0003<c?o<c?l0
0P000005c<co000000000000c<co00800002c<co00<0003<c?o<c?l00P00
0003c<co0000000000<00004c<co00<0003<c?o<c?l00P000003c<co0000
c<co00;<c?l2000000G<c?l00000003<c?l000000lc<o`80003<c<co00BI
VLb8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^9VIc00200000lc<o`80
0002c<co100000;<c?l2000000?<c?l0000000000lc<o`@00002c<co0P00
0003c<co0000000000C<c?l400000lc<o`@00002c<co0P0000;<c?l40000
cLc<o`04VIW<R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;RIVL`00P00
00?<c?l200002<c<o`80000<c<co0P0000;<c?l200004<c<o`80003Cc<co
00BIVLb8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^9VIc00600002Lc<
o`80000<c<co0P0000?<c?l200003lc<o`80003Cc<co00BIVLb8`;R8`;Q8
T8P1000000001HS0^<SPf8S0^8S0^9VIc03oc<co2Lc<o`04VIW<R<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;RIVL`0olc<o`W<c?l019VIc8S0^8S0
^4R@R04000000005R<2hb>3HR<2hR<2hVIW<0?o<c?l9c<co00BIVLb8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^9VIc03oc<co2Lc<o`04VIW<R<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;SoVIW<2iVIc0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo2oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo2oooo`:8
`;P1B9280@00000000F8`;S8h=R8`;R8`;Soool00P0000Coool2000000?o
ool0000000000P0000;oool2000000?oool0000000000oooo`@00002oooo
0P0000Ooool5000000?oool0000000000_ooo`800002oooo0P000003oooo
0000000000;oool50000bOooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8
`;Soool00P0000?oool2000000?oool0000000000_ooo`8000001Oooo`00
000000000?ooo`02000000?oool0000000000_ooo`8000000oooo`000000
0006oooo0P0000;oool2000000?oool0000000000_ooo`8000001?ooo`00
00000?ooo`<000000oooo`0000000002oooo0P000<Woool2R<2h0DR@R040
00000005R<2hb>3HR<2hR<2hoooo00800003oooo0P000003oooo00000000
00;oool2000000?oool0000000000_ooo`8000000oooo`0000000002oooo
0P000003oooo0000000000Koool200000_ooo`8000000oooo`0000000002
oooo0P000003oooo0000000000;oool2000000?oool0000000000_ooo`80
0039oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^?ooo`0200000_oo
o`800002oooo0P0000;oool2000000?oool0000000000_ooo`8000000ooo
o`0000000002oooo0P000003oooo0000000000@00003oooo0P000004oooo
00000000oooo0P0000;oool2000000?oool0000000000_ooo`800002oooo
0P000003oooo000000000<Woool2R<2h0DR@R04000000005R<2hb>3HR<2h
R<2hoooo00H00002oooo0P0000;oool2000000?oool0000000000_ooo`80
00000oooo`0000000002oooo0P000003oooo0000000000?oool200000ooo
o`@000000oooo`0000000002oooo0P000003oooo0000000000;oool20000
0oooo`@00039oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^?ooo`02
00000oooo`800002oooo00<0003oooooool00P000005oooo000000000000
oooo00800002oooo00<0003oooooool00P000003oooo0000000000?oool2
000000?oool0003oool00_ooo`8000001Oooo`00000000000?ooo`020000
00Coool00000003oool3000000?oool0003oool00_ooo`800039oooo0XS0
^058T8P1000000001HS0^<SPf8S0^8S0^?ooo`0200000oooo`800002oooo
100000;oool2000000?oool0000000000oooo`@00002oooo0P0000?oool2
00000_ooo`@00002oooo0P000003oooo0000000000?oool2000000?oool0
000000000_ooo`@0003:oooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0
^?ooo`0200000oooo`800008oooo0P0000coool200000oooo`80000Coooo
0P000=3oool2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hoooo00H00009
oooo0P0000coool600005?ooo`80003@oooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?ooool;oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?ooool;oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?ooool;oooo
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?ooool;oooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?ooool;oooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?ooool;oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?ooool;oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^2koool40000
f?ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P]oooo00@0003ooooo
ooooool20000eoooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;Soool0
0P0000Coool2000000?oool0000000000P0000;oool2000000?oool00000
00000oooo`@00002oooo1@0000Coool400000oooo`8000000oooo`000000
003Goooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^?ooo`0200000ooo
o`8000000oooo`0000000002oooo0P000005oooo000000000000oooo0080
00000oooo`0000000002oooo0P000003oooo0000000000;oool200000_oo
o`800002oooo0P000004oooo00000000oooo0`000=Ooool2R<2h0DR@R040
00000005R<2hb>3HR<2hR<2hoooo00800003oooo0P000003oooo00000000
00;oool2000000?oool0000000000_ooo`8000000oooo`0000000002oooo
0P000003oooo0000000000?oool2000000?oool0000000000_ooo`800000
0oooo`0000000002oooo0P000=Ooool2R<2h0DR@R04000000005R<2hb>3H
R<2hR<2hoooo00800002oooo0P0000;oool200000_ooo`8000000oooo`00
00000002oooo0P000003oooo0000000000;oool2000000?oool000000000
0oooo`8000000oooo`0000000002oooo0P000003oooo0000000000;oool2
0000eoooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;Soool01P0000;o
ool200000_ooo`8000000oooo`0000000002oooo0P000003oooo00000000
00;oool2000000?oool0000000000oooo`8000000oooo`0000000002oooo
0P000003oooo0000000000;oool20000eoooo`:8`;P1B9280@00000000F8
`;S8h=R8`;R8`;Soool00P0000?oool200000_ooo`030000oooooooo0080
00001Oooo`00000000000?ooo`0200000_ooo`030000oooooooo00800000
0oooo`0000000003oooo0P0000;oool00`000?ooooooo`02000000Coool0
0000003oool30000eoooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;So
ool00P0000?oool200000_ooo`@00002oooo0P000003oooo0000000000?o
ool400000_ooo`800003oooo0P0000;oool400000oooo`8000000oooo`00
0000003Goooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^?ooo`020000
0oooo`800008oooo0P0000coool200000_ooo`80003Voooo0XS0^058T8P1
000000001HS0^<SPf8S0^8S0^?ooo`0600002Oooo`80000<oooo1@000>Oo
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hooooo`_oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hooooo`_oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hooooo`_oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hooooo`_oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hooooo`_o
ool2R<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;P>R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h5000P00;006000:000>100B100F100J200N20@R2
0@V30@Z30@^3008138@06P4=Q04>Q@8?Q@8@Q@8AQP8BQP8CQP8DQ`8EQ`8F
Q`<GR0<HR0<IR0<IR@<JR@<KR@<LRP<MRP@NRP@OR`@PR`@QR`@RS0@SS0@T
S0@US@859Xd030DWSPDXSPDYSPDZS`D[S`D/S`H]T0H^T0H_T0H`T@HaT@Hb
T@86<i806PLdTPLeT`LfT`LgT`LhU0LiU0LjU0LkU@PlU@PmU@PnUPPoUPQ0
UPQ0U`Q1U`Q2U`U3V0U4V0U5V0U6V@U7V@U8V@U9VPU:VPY;VPY<V`8:CI/0
2`Y>W0Y?W0Y@W0YAW@]BW@]CW@]DWP]EWP]FWP]GW`]HW`022eVO00`<FZ0<
Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ8=Hj<=I:<=IJ<23FJT01X=Ij@=J:D>
JJD>JZD>JjH>K:H>KJH>KZL>KjL>L:L?LJP?LZP?LjP?LjT?M:T?MJT?MZX?
MjX@N:X@NJ/@NZ/@Nj/@O:`@OJ`@OZ`@Ojd24H2]00`APJhAPZhAPjhAQ:lA
QJlAQZlBQk0BR;0BRK0BR[4BRk4BS;424Xfb01XCS[8CSk<CT;<CTK<CT[@C
Tk@CU;@CUKDDU[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LEWKPEW[PEWkPEX;TE
XKTEX[TEXkXEY;XFYKXFY[/25ZNk00`FZ;`FZK`FZ[`FZkdG[;dG[KdG[[hG
[khG/;hG/KlG/[lG/klf6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0@008000i^WlC=3YC=3Y@09<d>U1000P00;006000:000>100B100F100J2
00N20@R20@V30@Z30@^3008138@06P4=Q04>Q@8?Q@8@Q@8AQP8BQP8CQP8D
Q`8EQ`8FQ`<GR0<HR0<IR0<IR@<JR@<KR@<LRP<MRP@NRP@OR`@PR`@QR`@R
S0@SS0@TS0@US@859Xd030DWSPDXSPDYSPDZS`D[S`D/S`H]T0H^T0H_T0H`
T@HaT@HbT@86<i806PLdTPLeT`LfT`LgT`LhU0LiU0LjU0LkU@PlU@PmU@Pn
UPPoUPQ0UPQ0U`Q1U`Q2U`U3V0U4V0U5V0U6V@U7V@U8V@U9VPU:VPY;VPY<
V`8:CI/02`Y>W0Y?W0Y@W0YAW@]BW@]CW@]DWP]EWP]FWP]GW`]HW`022eVO
00`<FZ0<Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ8=Hj<=I:<=IJ<23FJT01X=
Ij@=J:D>JJD>JZD>JjH>K:H>KJH>KZL>KjL>L:L?LJP?LZP?LjP?LjT?M:T?
MJT?MZX?MjX@N:X@NJ/@NZ/@Nj/@O:`@OJ`@OZ`@Ojd24H2]00`APJhAPZhA
PjhAQ:lAQJlAQZlBQk0BR;0BRK0BR[4BRk4BS;424Xfb01XCS[8CSk<CT;<C
TK<CT[@CTk@CU;@CUKDDU[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LEWKPEW[PE
WkPEX;TEXKTEX[TEXkXEY;XFYKXFY[/25ZNk00`FZ;`FZK`FZ[`FZkdG[;dG
[KdG[[hG[khG/;hG/KlG/[lG/klf6;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0<008001i^WlOooohij]ZJKa;>YdZRMb;>YdP02YY_400Fl^=g^
k_CZjO7ooolc@jD00`00P00;006000:000>100B100F100J200N20@R20@V3
0@Z30@^3008138@06P4=Q04>Q@8?Q@8@Q@8AQP8BQP8CQP8DQ`8EQ`8FQ`<G
R0<HR0<IR0<IR@<JR@<KR@<LRP<MRP@NRP@OR`@PR`@QR`@RS0@SS0@TS0@U
S@859Xd030DWSPDXSPDYSPDZS`D[S`D/S`H]T0H^T0H_T0H`T@HaT@HbT@86
<i806PLdTPLeT`LfT`LgT`LhU0LiU0LjU0LkU@PlU@PmU@PnUPPoUPQ0UPQ0
U`Q1U`Q2U`U3V0U4V0U5V0U6V@U7V@U8V@U9VPU:VPY;VPY<V`8:CI/02`Y>
W0Y?W0Y@W0YAW@]BW@]CW@]DWP]EWP]FWP]GW`]HW`022eVO00`<FZ0<Fj0<
G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ8=Hj<=I:<=IJ<23FJT01X=Ij@=J:D>JJD>
JZD>JjH>K:H>KJH>KZL>KjL>L:L?LJP?LZP?LjP?LjT?M:T?MJT?MZX?MjX@
N:X@NJ/@NZ/@Nj/@O:`@OJ`@OZ`@Ojd24H2]00`APJhAPZhAPjhAQ:lAQJlA
QZlBQk0BR;0BRK0BR[4BRk4BS;424Xfb01XCS[8CSk<CT;<CTK<CT[@CTk@C
U;@CUKDDU[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LEWKPEW[PEWkPEX;TEXKTE
X[TEXkXEY;XFYKXFY[/25ZNk00`FZ;`FZK`FZ[`FZkdG[;dG[KdG[[hG[khG
/;hG/KlG/[lG/kl26;C08000008H]<0@00000QRd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2002000BKYo7ooom/FZF_YLX2_;SM00[ooOncZM;o
oooooonl^=fGR[bXWLSVi^cooolc@jD2002000/00H000X000h4018401H40
1X801h8128812H<12X<12h<00P4<Q00J0@f40@j50Pn50Q250Q660Q:60Q>6
0QB70QF70QJ70aN80aR80aV80aV90aZ90a^90ab:0af:11j:11n;122;126;
12:<12><12B<12F=0PDVS@0<1BN>1BR>1BV>1BZ?1B^?1Bb?1Rf@1Rj@1Rn@
1S2A1S6A1S:A0PHcTP0J1cBB1cFC1cJC1cNC1cRD1cVD1cZD1c^E23bE23fE
23jF23nF242F242G246G24:G2D>H2DBH2DFH2DJI2DNI2DRI2DVJ2DZJ2T^J
2TbK0PY=V`0;2TjL2TnL2U2L2U6M2e:M2e>M2eBN2eFN2eJN2eNO2eRO008;
FIl030aJX0aKX0aLX0aMX@aNX@aOX@aPXPaQXPeRXPeSX`eTX`eUX`8=IZ@0
6PeWY0eXY@iYY@iZY@i[YPi/YPi]YPi^Y`i_Y`i`Y`maZ0mbZ0mcZ0mcZ@md
Z@meZ@mfZPmgZQ1hZQ1iZa1jZa1kZa1l[11m[11n[11o[@8AP:d03161[Q62
[Q63[Q64[a65[a66[a:7/1:8/1:9/1::/A:;/A:</@8BSK806Q>>/Q>?/a>@
/a>A/a>B]1>C]1>D]1>E]ABF]ABG]ABH]QBI]QBJ]QBJ]aBK]aBL]aFM^1FN
^1FO^1FP^AFQ^AFR^AFS^QFT^QJU^QJV^`8FYk/031JX_1JY_1JZ_1J[_AN/
_AN]_AN^_QN__QN`_QNa_aNb_aNc_`8H]<000lSPf4R@R4R@R00<B92800<0
0038h=Q8T8P03DR@R00400006;C06;C0b>3H3TR@R00300006;C06;C000:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000^KYo7ooonXWLSooonc
ZM9PC9Z>N[IhIJjXWLSooooooOl00oooo`0?<d>U002000200020006000:0
00>100B100F100J200N20@R20@V30@Z30@^3008138@06P4=Q04>Q@8?Q@8@
Q@8AQP8BQP8CQP8DQ`8EQ`8FQ`<GR0<HR0<IR0<IR@<JR@<KR@<LRP<MRP@N
RP@OR`@PR`@QR`@RS0@SS0@TS0@US@859Xd030DWSPDXSPDYSPDZS`D[S`D/
S`H]T0H^T0H_T0H`T@HaT@HbT@86<i806PLdTPLeT`LfT`LgT`LhU0LiU0Lj
U0LkU@PlU@PmU@PnUPPoUPQ0UPQ0U`Q1U`Q2U`U3V0U4V0U5V0U6V@U7V@U8
V@U9VPU:VPY;VPY<V`8:CI/02`Y>W0Y?W0Y@W0YAW@]BW@]CW@]DWP]EWP]F
WP]GW`]HW`022eVO00`<FZ0<Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ8=Hj<=
I:<=IJ<23FJT01X=Ij@=J:D>JJD>JZD>JjH>K:H>KJH>KZL>KjL>L:L?LJP?
LZP?LjP?LjT?M:T?MJT?MZX?MjX@N:X@NJ/@NZ/@Nj/@O:`@OJ`@OZ`@Ojd2
4H2]00`APJhAPZhAPjhAQ:lAQJlAQZlBQk0BR;0BRK0BR[4BRk4BS;424Xfb
01XCS[8CSk<CT;<CTK<CT[@CTk@CU;@CUKDDU[DDUkDDV;HDVKHDV[HDV[LD
VkLDW;LEWKPEW[PEWkPEX;TEXKTEX[TEXkXEY;XFYKXFY[/25ZNk00`FZ;`F
ZK`FZ[`FZkdG[;dG[KdG[[hG[khG/;hG/KlG/[lG/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00
P00>VjOaoooooooofmc/H4bJThFj/jWB_;SMH4bJVHnnYY_4b<?Ooooo<d>U
1000P00:0060oooo00>100B100F100J200N2oooo0@V30@Z31?ooo`0=0@j5
0Pn50Q25oooo0Q:6oooo0QB70QF70QJ7oooo0aR80aV80aV900?oool03P<M
RP@NRP@ORoooo`@QR`@RS0@SS0@TS0@USOooo`DVS@DWSPDXSPDYSPCoool0
2`H^T0H_T?ooo`HaT@HbTOooo`HcTPLdT_ooo`LfT`LgT`03oooo01<7>iD8
?9D8?ID8?YH8?iH8@9H8@9L8@IL8@YL9@iP9A9P9AIP9AYT9AiT9B9T9BIX9
BYX:BiX:C9/00PY=V`0;2TjL2TnL2U2L2U6M2e:M2e>M2eBN2eFN2eJN2eNO
2eRO008;FIl030aJX0aKX0aLX0aMX@aNX@aOX@aPXPaQXPeRXPeSX`eTX`eU
X`8=IZ@06PeWY0eXY@iYY@iZY@i[YPi/YPi]YPi^Y`i_Y`i`Y`maZ0mbZ0mc
Z0mcZ@mdZ@meZ@mfZPmgZQ1hZQ1iZa1jZa1kZa1l[11m[11n[11o[@8AP:d0
3161[Q62[Q63[Q64[a65[a66[a:7/1:8/1:9/1::/A:;/A:</@8BSK806Q>>
/Q>?/a>@/a>A/a>B]1>C]1>D]1>E]ABF]ABG]ABH]QBI]QBJ]QBJ]aBK]aBL
]aFM^1FN^1FO^1FP^AFQ^AFR^AFS^QFT^QJU^QJV^`8FYk/031JX_1JY_1JZ
_1J[_AN/_AN]_AN^_QN__QN`_QNa_aNb_aNc_`8H]<001<SPf8S0^8S0^8S0
^0H00004R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H
]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0<008003Y^WlOoookbhgIV?__ooomKAgM_Lk??nojJKa>k^m8Ef
/9>5^_oooc=3Y@<008002`01P?ooo`03P@04POooo`06PP07P_ooo`49Pooo
o`4;P`020@b404Coool13XD23hGoool24HH24XKoool258L25HL25XOoool3
68P36HSoool36XT36hT378[oool47XX47h_oool48H/48X`48h`498`49Hgo
ool59Xd59hh5:8koool5:Xl5:hl5;8ooool6;Y06;i3oool6<I46<Y7oool6
<i87=9;oool7=Y?oool7>9@7>I@7>YCoool8?9D8?ID8?YH8?iH8@9H8@9L8
@IL8@YL9@iP9A9P9AIP9AYT9AiT9B9T9BIX9BYX:BiX:C9/22TfK00/:CY`:
Ci`:D9`:DId;DYd;Did;E9h;EIh;EYh;Eil;F9l00P]IW`0<35ZP35^P35bP
35fQ35jQ35nQ362R366R3F:R3F>S3FBS3FFS0PeVY00J3FNT3FRU3VVU3VZU
3V^V3VbV3VfV3VjW3VnW3W2W3g6X3g:X3g>X3g>Y3gBY3gFY3gJZ3gNZ47RZ
47V[47Z[47^[47b/47f/47j/47n]0Q60[@0<4H6^4H:^4H>^4HB_4HF_4HJ_
4XN`4XR`4XV`4XZa4X^a4Xba0Q:=/P0J4hjb4hnc4i2c4i6c4i:d4i>d4iBd
4iFe59Je59Ne59Rf59Vf59Zf59Zg59^g59bg5Ifh5Ijh5Inh5J2i5J6i5J:i
5J>j5JBj5ZFj5ZJk0QJW^`0<5ZRl5ZVl5ZZl5Z^m5jbm5jfm5jjn5jnn5k2n
5k6o5k:o5k>o0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P00dR@R0000<SP
f002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<00
1<SPf8S0^8S0^8S0^0800004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000nKYo7ooonISkjGR[cD
dnS_[;?oMW_^Wj]KF:FVVlBFWm9PC9Zl^=gooolc@jD00P00P00;0060oooo
00>100B1oooo00J200N2oooo0@V3oooo0@^3008138@0A?ooo`4>Q@8?QOoo
o`8AQP8BQ_ooo`8DQ`8EQ`8FQoooo`<HR0<IR?ooo`<JR@<KR@<LR_ooo`@N
RP@ORoooo`@QR`@RS0@SS0@TS0@USOooo`DVS@DWSPDXS_ooo`DZS`D[S`D/
Soooo`H^T0H_T?ooo`HaT@HbTOooo`HcTPLdT_ooo`LfToooo`LhU0LiU0Lj
U0LkU@PlU@PmU@PnUPPoUPQ0UPQ0U`Q1U`Q2U`U3V0U4V0U5V0U6V@U7V@U8
V@U9VPU:VPY;VPY<V`8:CI/02`Y>W0Y?W0Y@W0YAW@]BW@]CW@]DWP]EWP]F
WP]GW`]HW`022eVO00`<FZ0<Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ8=Hj<=
I:<=IJ<23FJT01X=Ij@=J:D>JJD>JZD>JjH>K:H>KJH>KZL>KjL>L:L?LJP?
LZP?LjP?LjT?M:T?MJT?MZX?MjX@N:X@NJ/@NZ/@Nj/@O:`@OJ`@OZ`@Ojd2
4H2]00`APJhAPZhAPjhAQ:lAQJlAQZlBQk0BR;0BRK0BR[4BRk4BS;424Xfb
01XCS[8CSk<CT;<CTK<CT[@CTk@CU;@CUKDDU[DDUkDDV;HDVKHDV[HDV[LD
VkLDW;LEWKPEW[PEWkPEX;TEXKTEX[TEXkXEY;XFYKXFY[/25ZNk00`FZ;`F
ZK`FZ[`FZkdG[;dG[KdG[[hG[khG/;hG/KlG/[lG/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028
`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8`;P200000XS0^0800003
R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0P00P00:VjOaooooUhZlNVbZ/lOXZFjPb<?OThFjFdJCVHnn0WQU[P04@RN5
[jG:oooo<d>U0P00P00:0060oooo00>1oooo00F1oooo00N2oooo0@V30@Z3
1?ooo`0N0@j50Pn5oooo0Q660Q:6oooo0QB70QF70QJ7oooo0aR80aV80aV9
0aZ90a^90ab:oooo11j:11n;oooo126;12:<12><12B<12F=oooo1BJ=1BN>
1BR>1BV>1?ooo`0:1Rj@1Rn@oooo1S6A1S:Aoooo1S>B1cBBoooo1cJC1Ooo
o`0B23bE23fE23jF23nF242F242G246G24:G2D>H2DBH2DFH2DJI2DNI2DRI
2DVJ2DZJ2T^J2TbK0PY=V`0;2TjL2TnL2U2L2U6M2e:M2e>M2eBN2eFN2eJN
2eNO2eRO008;FIl030aJX0aKX0aLX0aMX@aNX@aOX@aPXPaQXPeRXPeSX`eT
X`eUX`8=IZ@06PeWY0eXY@iYY@iZY@i[YPi/YPi]YPi^Y`i_Y`i`Y`maZ0mb
Z0mcZ0mcZ@mdZ@meZ@mfZPmgZQ1hZQ1iZa1jZa1kZa1l[11m[11n[11o[@8A
P:d03161[Q62[Q63[Q64[a65[a66[a:7/1:8/1:9/1::/A:;/A:</@8BSK80
6Q>>/Q>?/a>@/a>A/a>B]1>C]1>D]1>E]ABF]ABG]ABH]QBI]QBJ]QBJ]aBK
]aBL]aFM^1FN^1FO^1FP^AFQ^AFR^AFS^QFT^QJU^QJV^`8FYk/031JX_1JY
_1JZ_1J[_AN/_AN]_AN^_QN__QN`_QNa_aNb_aNc_`8H]<000lSPf8S0^8S0
^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0
^8S0^4R@R00000026;C000?8h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0
000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOa
oooooooo00;oool02_n]/?mfNoW=e?g]k_ooojJKa8Ef/;bhgOoooc=3Y@<0
08002`01P?ooo`03POooo`05POooo`07P_ooo`49P`4:P`4;P`020@b400Ko
ool13XD23hGoool24HH24XH2oooo00`25HL25XOoool368P36HP36HT36XT3
6hT378[oool47XX47h/4oooo00d498`49Hgoooooool59hh5:8h5:Hh5:Xl5
:hl5;8ooool6;Y06;i000_ooo`0M1S:Aoooooooo1cBBoooo1cJCoooo1cRD
1cVD1cZDoooo23bE23fE23jF23nF242F242G246G24:G2D>H2DBH2DFH2DJI
2DNI2DRI2DVJ2DZJ2T^J2TbK008:CI/02`Y>W0Y?W0Y@W0YAW@]BW@]CW@]D
WP]EWP]FWP]GW`]HW`022eVO00`<FZ0<Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=
HZ8=Hj<=I:<=IJ<23FJT01X=Ij@=J:D>JJD>JZD>JjH>K:H>KJH>KZL>KjL>
L:L?LJP?LZP?LjP?LjT?M:T?MJT?MZX?MjX@N:X@NJ/@NZ/@Nj/@O:`@OJ`@
OZ`@Ojd24H2]00`APJhAPZhAPjhAQ:lAQJlAQZlBQk0BR;0BRK0BR[4BRk4B
S;424Xfb01XCS[8CSk<CT;<CTK<CT[@CTk@CU;@CUKDDU[DDUkDDV;HDVKHD
V[HDV[LDVkLDW;LEWKPEW[PEWkPEX;TEXKTEX[TEXkXEY;XFYKXFY[/25ZNk
00`FZ;`FZK`FZ[`FZkdG[;dG[KdG[[hG[khG/;hG/KlG/[lG/kl26;C000?8
h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h
00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00B8`;P200001HS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<0
08002Z6/l_W=e>8V??Be_n8V??A]OOcSjOoooog]k_n]/0;oool00c=3Y@00
P000P002002000X00H3oool00h7oool01H7oool01h;oool12H<12X<3oooo
00<13H@13XGoool00_ooo`030Q:6oooo0QB700;oool05@<GR0<HR0<IR0<I
R@<JR@<KR@<LR_ooo`@NRP@ORoooo`@QR`@RS0@SS0@TS0@USOooo`DVSOoo
o`DXSPDYSP03oooo00D6;I06;Y06;i3oool6<I400_ooo`051S>Boooo1cFC
1cJC1cNC00?oool04`LkU@PlU@PmU@PnUPPoUPQ0UPQ0U`Q1U`Q2U`U3V0U4
V0U5V0U6V@U7V@U8V@U9VPU:VPY;VPY<V`022TfK00/:CY`:Ci`:D9`:DId;
DYd;Did;E9h;EIh;EYh;Eil;F9l00P]IW`0<35ZP35^P35bP35fQ35jQ35nQ
362R366R3F:R3F>S3FBS3FFS0PeVY00J3FNT3FRU3VVU3VZU3V^V3VbV3VfV
3VjW3VnW3W2W3g6X3g:X3g>X3g>Y3gBY3gFY3gJZ3gNZ47RZ47V[47Z[47^[
47b/47f/47j/47n]0Q60[@0<4H6^4H:^4H>^4HB_4HF_4HJ_4XN`4XR`4XV`
4XZa4X^a4Xba0Q:=/P0J4hjb4hnc4i2c4i6c4i:d4i>d4iBd4iFe59Je59Ne
59Rf59Vf59Zf59Zg59^g59bg5Ifh5Ijh5Inh5J2i5J6i5J:i5J>j5JBj5ZFj
5ZJk0QJW^`0<5ZRl5ZVl5ZZl5Z^m5jbm5jfm5jjn5jnn5k2n5k6o5k:o5k>o
0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8
`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^003R<2h
100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000fKYo7mkNkR9ScnmOSgRIOdHVkcX:kdHVkooOoo[K3lhnWo
oolc@jD01@00P0060060oooooooo00B100F100J20_ooo`030@V30@Z30@^3
008138@06P4=Q04>Q@8?QOooo`8AQP8BQ_ooo`8DQ`8EQ`8FQ`<GR0<HR0<I
R0<IR@<JR@<KR@<LR_ooo`@NRP@ORoooo`@QR`@RS0@SS0@TS0@US@859Xd0
30DWSPDXSPDYSPDZS`D[S`D/S`H]T0H^T0H_T0H`T@HaT@HbT@86<i806PLd
TPLeT`LfT`LgT`LhU0LiU0LjU0LkU@PlU@PmU@PnUPPoUPQ0UPQ0U`Q1U`Q2
U`U3V0U4V0U5V0U6V@U7V@U8V@U9VPU:VPY;VPY<V`8:CI/02`Y>W0Y?W0Y@
W0YAW@]BW@]CW@]DWP]EWP]FWP]GW`]HW`022eVO00`<FZ0<Fj0<G:0<GJ4<
GZ4<Gj4<H:8<HJ8=HZ8=Hj<=I:<=IJ<23FJT01X=Ij@=J:D>JJD>JZD>JjH>
K:H>KJH>KZL>KjL>L:L?LJP?LZP?LjP?LjT?M:T?MJT?MZX?MjX@N:X@NJ/@
NZ/@Nj/@O:`@OJ`@OZ`@Ojd24H2]00`APJhAPZhAPjhAQ:lAQJlAQZlBQk0B
R;0BRK0BR[4BRk4BS;424Xfb01XCS[8CSk<CT;<CTK<CT[@CTk@CU;@CUKDD
U[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LEWKPEW[PEWkPEX;TEXKTEX[TEXkXE
Y;XFYKXFY[/25ZNk00`FZ;`FZK`FZ[`FZkdG[;dG[KdG[[hG[khG/;hG/KlG
/[lG/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`00
08S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h
00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0P00P003VjOam/S<hRHl00;o[K001mlT;_nT
W_JlaOn]/>ikS?oooc=3Y@06002000H00H3oooooool018401H401X82oooo
00<12H<12X<12h<00P4<Q00J0@f40@j50Pn5oooo0Q660Q:6oooo0QB70QF7
0QJ70aN80aR80aV80aV90aZ90a^90ab:oooo11j:11n;oooo126;12:<12><
12B<12F=0PDVS@0<1BN>1BR>1BV>1BZ?1B^?1Bb?1Rf@1Rj@1Rn@1S2A1S6A
1S:A0PHcTP0J1cBB1cFC1cJC1cNC1cRD1cVD1cZD1c^E23bE23fE23jF23nF
242F242G246G24:G2D>H2DBH2DFH2DJI2DNI2DRI2DVJ2DZJ2T^J2TbK0PY=
V`0;2TjL2TnL2U2L2U6M2e:M2e>M2eBN2eFN2eJN2eNO2eRO008;FIl030aJ
X0aKX0aLX0aMX@aNX@aOX@aPXPaQXPeRXPeSX`eTX`eUX`8=IZ@06PeWY0eX
Y@iYY@iZY@i[YPi/YPi]YPi^Y`i_Y`i`Y`maZ0mbZ0mcZ0mcZ@mdZ@meZ@mf
ZPmgZQ1hZQ1iZa1jZa1kZa1l[11m[11n[11o[@8AP:d03161[Q62[Q63[Q64
[a65[a66[a:7/1:8/1:9/1::/A:;/A:</@8BSK806Q>>/Q>?/a>@/a>A/a>B
]1>C]1>D]1>E]ABF]ABG]ABH]QBI]QBJ]QBJ]aBK]aBL]aFM^1FN^1FO^1FP
^AFQ^AFR^AFS^QFT^QJU^QJV^`8FYk/031JX_1JY_1JZ_1J[_AN/_AN]_AN^
_QN__QN`_QNa_aNb_aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038
h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P00hS0^0800004R<2h
0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000>KYo7icMCgRIL00_ooo`07ojf`hAHdogIkojBNhRHlohUo
<d>U00H008002`01P?ooo`03P@04P@05P@06PP07P_ooo`49P`4:P`4;P`02
0@b401@13H@13XD23hD248D24HH24XKoool258L25HL25XL35hP368P36HP3
6HT36XT36hT378[oool47XX47h/5oooo00l49Hd59Xd59Xd59hh5:8h5:Hh5
:Xl5:hl5;8l6;I06;Y06;i06<946<I46<Y400PHcTP0J1cBB1cFC1cJC1cNC
1cRD1cVD1cZD1c^E23bE23fE23jF23nF242F242G246G24:G2D>H2DBH2DFH
2DJI2DNI2DRI2DVJ2DZJ2T^J2TbK0PY=V`0;2TjL2TnL2U2L2U6M2e:M2e>M
2eBN2eFN2eJN2eNO2eRO008;FIl030aJX0aKX0aLX0aMX@aNX@aOX@aPXPaQ
XPeRXPeSX`eTX`eUX`8=IZ@06PeWY0eXY@iYY@iZY@i[YPi/YPi]YPi^Y`i_
Y`i`Y`maZ0mbZ0mcZ0mcZ@mdZ@meZ@mfZPmgZQ1hZQ1iZa1jZa1kZa1l[11m
[11n[11o[@8AP:d03161[Q62[Q63[Q64[a65[a66[a:7/1:8/1:9/1::/A:;
/A:</@8BSK806Q>>/Q>?/a>@/a>A/a>B]1>C]1>D]1>E]ABF]ABG]ABH]QBI
]QBJ]QBJ]aBK]aBL]aFM^1FN^1FO^1FP^AFQ^AFR^AFS^QFT^QJU^QJV^`8F
Yk/031JX_1JY_1JZ_1J[_AN/_AN]_AN^_QN__QN`_QNa_aNb_aNc_`8H]<00
0lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0
000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008001i^WlOoooo>P[_ARK_ooooN9UoW=e002oooo
00?cX:kooolc@jD01P00P00;006000:000>100B100F100J200N20@R20@V3
0@Z30@^3008138@06P4=Q04>Q@8?Q@8@Q@8AQP8BQP8CQP8DQ`8EQ`8FQ`<G
R0<HR0<IR0<IR@<JR@<KR@<LRP<MRP@NRP@OR`@PR`@QR`@RS0@SS0@TS0@U
S@859Xd030DWSPDXSPDYSPDZS`D[S`D/S`H]T0H^T0H_T0H`T@HaT@HbT@86
<i806PLdTPLeT`LfT`LgT`LhU0LiU0LjU0LkU@PlU@PmU@PnUPPoUPQ0UPQ0
U`Q1U`Q2U`U3V0U4V0U5V0U6V@U7V@U8V@U9VPU:VPY;VPY<V`8:CI/02`Y>
W0Y?W0Y@W0YAW@]BW@]CW@]DWP]EWP]FWP]GW`]HW`022eVO00`<FZ0<Fj0<
G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ8=Hj<=I:<=IJ<23FJT01X=Ij@=J:D>JJD>
JZD>JjH>K:H>KJH>KZL>KjL>L:L?LJP?LZP?LjP?LjT?M:T?MJT?MZX?MjX@
N:X@NJ/@NZ/@Nj/@O:`@OJ`@OZ`@Ojd24H2]00`APJhAPZhAPjhAQ:lAQJlA
QZlBQk0BR;0BRK0BR[4BRk4BS;424Xfb01XCS[8CSk<CT;<CTK<CT[@CTk@C
U;@CUKDDU[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LEWKPEW[PEWkPEX;TEXKTE
X[TEXkXEY;XFYKXFY[/25ZNk00`FZ;`FZK`FZ[`FZkdG[;dG[KdG[[hG[khG
/;hG/KlG/[lG/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00f8
`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0`00P00;VjOaooooohUooooolj2^lI>Q
oooooogolj2^oo_l<d>U00H008002`01P002P003P@04P@05P@06PP07PP48
PP49P`4:P`4;P`020@b401X13H@13XD23hD248D24HH24XH24hH258L25HL2
5XL35hP368P36HP36HT36XT36hT378X37HX47XX47h/488/48H/48X`48h`4
98`49Hd21BJ=00`59hh5:8h5:Hh5:Xl5:hl5;8l6;I06;Y06;i06<946<I46
<Y421S>B01X7=987=I<7=Y<7=i<7>9@7>I@7>Y@7>iD8?9D8?ID8?YH8?iH8
@9H8@9L8@IL8@YL9@iP9A9P9AIP9AYT9AiT9B9T9BIX9BYX:BiX:C9/22TfK
00/:CY`:Ci`:D9`:DId;DYd;Did;E9h;EIh;EYh;Eil;F9l00P]IW`0<35ZP
35^P35bP35fQ35jQ35nQ362R366R3F:R3F>S3FBS3FFS0PeVY00J3FNT3FRU
3VVU3VZU3V^V3VbV3VfV3VjW3VnW3W2W3g6X3g:X3g>X3g>Y3gBY3gFY3gJZ
3gNZ47RZ47V[47Z[47^[47b/47f/47j/47n]0Q60[@0<4H6^4H:^4H>^4HB_
4HF_4HJ_4XN`4XR`4XV`4XZa4X^a4Xba0Q:=/P0J4hjb4hnc4i2c4i6c4i:d
4i>d4iBd4iFe59Je59Ne59Rf59Vf59Zf59Zg59^g59bg5Ifh5Ijh5Inh5J2i
5J6i5J:i5J>j5JBj5ZFj5ZJk0QJW^`0<5ZRl5ZVl5ZZl5Z^m5jbm5jfm5jjn
5jnn5k2n5k6o5k:o5k>o0QRd`0o8h=P00`000<SPf<SPf00=b>3H00<0000H
]<0H]<003lSPf00300006;C06;C000:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P400200i^Wl@06oooolj2^m;Fom[c5nmWJ<d>U1`00P00;006000:0
00>100B100F100J200N20@R20@V30@Z30@^3008138@06P4=Q04>Q@8?Q@8@
Q@8AQP8BQP8CQP8DQ`8EQ`8FQ`<GR0<HR0<IR0<IR@<JR@<KR@<LRP<MRP@N
RP@OR`@PR`@QR`@RS0@SS0@TS0@US@859Xd030DWSPDXSPDYSPDZS`D[S`D/
S`H]T0H^T0H_T0H`T@HaT@HbT@86<i806PLdTPLeT`LfT`LgT`LhU0LiU0Lj
U0LkU@PlU@PmU@PnUPPoUPQ0UPQ0U`Q1U`Q2U`U3V0U4V0U5V0U6V@U7V@U8
V@U9VPU:VPY;VPY<V`8:CI/02`Y>W0Y?W0Y@W0YAW@]BW@]CW@]DWP]EWP]F
WP]GW`]HW`022eVO00`<FZ0<Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ8=Hj<=
I:<=IJ<23FJT01X=Ij@=J:D>JJD>JZD>JjH>K:H>KJH>KZL>KjL>L:L?LJP?
LZP?LjP?LjT?M:T?MJT?MZX?MjX@N:X@NJ/@NZ/@Nj/@O:`@OJ`@OZ`@Ojd2
4H2]00`APJhAPZhAPjhAQ:lAQJlAQZlBQk0BR;0BRK0BR[4BRk4BS;424Xfb
01XCS[8CSk<CT;<CTK<CT[@CTk@CU;@CUKDDU[DDUkDDV;HDVKHDV[HDV[LD
VkLDW;LEWKPEW[PEWkPEX;TEXKTEX[TEXkXEY;XFYKXFY[/25ZNk00`FZ;`F
ZK`FZ[`FZkdG[;dG[KdG[[hG[khG/;hG/KlG/[lG/klf6;C00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^1@008002`01P002P003P@04P@05P@06PP07
PP48PP49P`4:P`4;P`020@b401X13H@13XD23hD248D24HH24XH24hH258L2
5HL25XL35hP368P36HP36HT36XT36hT378X37HX47XX47h/488/48H/48X`4
8h`498`49Hd21BJ=00`59hh5:8h5:Hh5:Xl5:hl5;8l6;I06;Y06;i06<946
<I46<Y421S>B01X7=987=I<7=Y<7=i<7>9@7>I@7>Y@7>iD8?9D8?ID8?YH8
?iH8@9H8@9L8@IL8@YL9@iP9A9P9AIP9AYT9AiT9B9T9BIX9BYX:BiX:C9/2
2TfK00/:CY`:Ci`:D9`:DId;DYd;Did;E9h;EIh;EYh;Eil;F9l00P]IW`0<
35ZP35^P35bP35fQ35jQ35nQ362R366R3F:R3F>S3FBS3FFS0PeVY00J3FNT
3FRU3VVU3VZU3V^V3VbV3VfV3VjW3VnW3W2W3g6X3g:X3g>X3g>Y3gBY3gFY
3gJZ3gNZ47RZ47V[47Z[47^[47b/47f/47j/47n]0Q60[@0<4H6^4H:^4H>^
4HB_4HF_4HJ_4XN`4XR`4XV`4XZa4X^a4Xba0Q:=/P0J4hjb4hnc4i2c4i6c
4i:d4i>d4iBd4iFe59Je59Ne59Rf59Vf59Zf59Zg59^g59bg5Ifh5Ijh5Inh
5J2i5J6i5J:i5J>j5JBj5ZFj5ZJk0QJW^`0<5ZRl5ZVl5ZZl5Z^m5jbm5jfm
5jjn5jnn5k2n5k6o5k:o5k>o=QRd`0:8`;P1B9280@00000000>8`;S8h=R8
`;P0ohS0^0j8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^0j8`;P1B928
0@00000000>8`;S8h=S8h=P0olSPf0k8h=P1B9280@000000ohS0^1:8`;P1
00000000\
\>"], "Graphics",
  ImageSize->{274, 182},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004/0000b2000`400?l0
0000o`00003oooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000
ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`
l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]
oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`
l?0]oo3`l000ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`003?ooool00oo/k>cokno_ooooo`03ooooo`05oo7alOoinOWoo_knonGU
iOono_h01Oooool00oo/k>cokno_ooooo`0=ooooo`03onc/k?o_knoooooo
00Cooooo00?ok>c/oogmoOooool00_odm?@6ooooo`03onc/k?omoOgooooo
00;om?CdjOooool000;ooooo00ko=SHfogMgMoooooooooooooKfm_lV9RKo
ATI6ookno_oKfm_o=CDeo`h>3_l<30co>CTiomcLg0;ooooo00Ko@410oeUI
FOlV9RKo6a/KoaDE5Onl_;`2ooooo`06om_Kfole=CGo3Ph>o``<3?li>CWo
g=cL0_ooool03_lf=SKoRHV9oooooooooooolo?cobl_;olh>3Som_Kfom_K
fole=CGo3Ph>o``<3?li>CWog=cL0_ooool02OmADE7o20P8oaXJ6_nLW9co
4a<CoeMGEooooooo@410ogmoO`02ooooo`06oe5ADOl820So6QXJoibLW?lC
4a?oEeMGjOooool000;ooooo00[o=SHfogMgMoooooooooooog1`L?lD51Co
inOWookno_ld=3CoDU9B0_o^k^h03_mEEEGo=CDeookno_oooooo@410od=3
@oo_knoono_kogemOOlC4a?olo?cookno_ld=3CoDU9B0_o^k^h03_mEEEGo
=CDeookno_oooooo=SHfohV9ROooooooo?clodY:B_lU9BGojn_[ookno_ld
=3CoDU9B0_o^k^h02OmEEEGo=CDeookno_o6a/Ko10@4omgMgOoVi^KoFe]K
oa4A4@02ooooo`09od10@?moOgooooooolK6a_l410CogMgMonKVi_mKFe_o
4A4A0>[ooooo0002ooooo`0:ocHf=_mgMgOooooool;2`_l20P;o/K6aoooo
oooHf=So0000okNg]`;ooooo00Ko]kNgo`000?oLg=cooooood10@?moOgl2
ooooo`06onOWiol0003o[Jf]omSHf?l0003o]kNg0_ooool03_ng]kOo0000
omcLg?oooooo=SHfohV9ROooooooJFUYoaHF5_oLg=coooooomSHf?l0003o
]kNg0_ooool02Ong]kOo0000omcLg?oIfMWo0`<3okfm_OooooooWinOob0P
8002ooooo`09od10@?moOgooooooomWIfOl30`?o_KfmoooooonOWioo820P
0>[ooooo0002ooooo`05ocHf=_mdM7Cokno_ob<S8omXJ6P00_ooool00onn
_[ko0000onKViP02ooooo`06onCTi?l0003o`L71oooooom0@43oOgmo0ooo
ool01OlF5QKoTI6Aokjn__l0003oi^KV00;ooooo00Woi>CTo`000?o1`L7o
ooooocHf=_n9RHWoS8b<o`X:2_o9bLT00_ooool00onn_[ko0000onKViP02
ooooo`09onCTi?l0003o`L71oooooon][Jgo<S8boc<c<olf=SKo820P00;o
oooo00Wo@410ogmoOoooooooooooojf][Olb<S;o<c<cocHf=_lP8200j_oo
ool000;ooooo00Go=SHfo`<30ol0003o0000ol71`@02ooooo`03omcLg?l0
003o];Bd00;ooooo00Ko/[:bo`000?oPh>3ooooood10@?mjNWX2ooooo`06
ong]kOl0003o`l?3omcLg?l0003o];Bd0_ooool02?nb/[;o0000on3Ph?oo
oooo=SHfod=3@ol30`?o/k>c0oooool00ooLg=co0000okBd]002ooooo`03
ok:b/_l0003oh>3P00?ooooo00?ooOgmoiBDU?lQ8B400_ooool00om0@43o
Ogmoooooo`03ooooo`03oogmoOnDU9Co8B4Q0>[ooooo0002ooooo`06ocHf
=_mgMgOohn?SoiZJV_l820So^KVi0_ooool01_m1@D7oB4Q8omkNg_oMgMgo
AdM7odA4A0;ooooo00ko@410oa/K6onGUiOog=cLofUYJOlA4A7oo?cloooo
oom1@D7oB4Q8omkNg_oMgMgoAdM7odA4A0;ooooo00Co=SHfogIfM_lR8R;o
V9RH1?ooool01_m1@D7oB4Q8omkNg_oMgMgoAdM7odA4A0;ooooo00Go];Bd
om[Jf_olo?coHF5QoeADE002ooooo`09od10@?moOgoooooooooooond];Co
f][Jooclo?mQHF7oE5AD0>[ooooo0002ooooo`06ocHf=_mgMgOooooooooo
oom9BDWoDe=C0_ooool01_oXj>SoDU9Bo`l?3ol?3`ooE5ADonWYj@;ooooo
00Ko@410ogalO?mUIFGo3@d=oaTI6OnXZ:P2ooooo`06onSXj?mBDU;o3`l?
o`l?3omDE5CojNWY0_ooool01Olf=SKoRHV9omCDe?lB4Q;o`<3000?ooooo
00Koj>SXoe9BD_l?3`oo3`l?oeADE?oYjNT2ooooo`05ohZ:R_lb<S;o410@
ocTi>Oo4a<@00_ooool02Om0@43oOgmoooooooooooooRXZ:oc8b<_l@413o
>CTiolC4a03Zooooo`000_ooool01_lf=SKoMgMgoooooooooooo=CDeoeEE
E@Cooooo0_ono_h4ooooo`04od10@?moOgoooooooogmo@Kooooo0_ono_h4
ooooo`06ocHf=_n9RHWooooook:b/_lF5QKogmoO1?ooool2ooknoPKooooo
00?ooOgmooooooooool00_ooool00om0@43oOgmoooooo`03ooooo`03oogm
oOoooooooooo0>[ooooo0002ooooo`06ocHf=_l_;booFUYJob<S8ol<30co
`l?32_ooool00om0@43oOgmoooooo`0=ooooo`07ocHf=_n9RHWooooooooo
oon7QhOo;Bd]oo?cl`0@ooooo`03od10@?moOgoooooo0?3ooooo0002oooo
o`05ok2`/?nJVY[oVYZJok^k^ooinOT02oooool00om0@43oOgmoooooo`0=
ooooo`03ok2`/?oAdM7ooooo00;ooooo00?oYJFUom?Cdoooool03oooool0
0om0@43oOgmoooooo`3`ooooo`004_ooool00ookno_ooOgmooooo`0Toooo
o`03oo_knoomoOgooooo0?3ooooo003oooooobgooooo003oooooobgooooo
003oooooobgooooo003oooooobgooooo003oooooobgooooo003oooooobgo
oooo000<ooooo`03onc/k?o_knoooooo00?ooooo00GolO7aooWinOono_ko
iNGUooknoP05ooooo`03onc/k?o_knoooooo00_ooooo00?ok>c/oogmoOoo
ool00_odm?@:ooooo`03oo_knooXj>Sooooo00Gooooo00?ok>c/oogmoOoo
ool00_odm?CVooooo`000_ooool03_lf=SKoMgMgoooooooooooom_KfobHV
9_m6ATKoo_knom_Kfole=CGo3Ph>o``<3?li>CWog=cL0_ooool01_m0@43o
FEUIobHV9_lK6a_o5ADEokbl_0;ooooo00Kofm_KocDe=Ol>3Pko30`<ocTi
>OoLg=`2ooooo`03ocHf=_mgMgOooooo00Cooooo00WoDE5Ao`P82?lJ6Q[o
W9bLoa<C4omGEeOooooood10@?moOgl00_ooool02_nSXj?o71`Loooooooo
oooo]KFeo`h>3_l20P;o;Bd]oi>CTolA4A42ooooo`06oe5ADOl820So6QXJ
oibLW?lC4a?oEeMGi_ooool000;ooooo00[o=SHfogMgMoooooooooooog1`
L?lD51CoinOWookno_ld=3CoDU9B0_o^k^h03_mEEEGo=CDeookno_oooooo
@410od=3@oo_knoono_kogemOOlC4a?olo?cookno_ld=3CoDU9B0_o^k^h0
1_mEEEGo=CDeookno_oooooo=SHfogMgM`Cooooo00Koa/K6o`@41?oMgMgo
i^KVoe]KFolA4A42ooooo`06od10@?moOgoooooooooooonSXj?o71`L0_oo
ool03Olc<c?oFe]Kong]kOo:b/[o;Rh^oa4A4Oooooooa/K6o`@41?oMgMgo
i^KVoe]KFolA4A40ioooool000;ooooo00[o=SHfogMgMooooooo`/;2o`82
0_na/K7oooooomSHf?l0003o]kNg0_ooool01_ng]kOo0000omcLg?oooooo
@410ogmoO`;ooooo00KoinOWo`000?n][Jgof=SHo`000?ng]kL2ooooo`06
okNg]ol0003og=cLoooooolf=SKoMgMg1?ooool01_oIfMWo0`<3okfm_Ooo
ooooWinOob0P80;ooooo00[o@410ogmoOooooooooooooj>SXolL71cooooo
onSXj?l10@7oaLG50_ooool02On[Zj_o4A4AoooooooIfMWo0`<3okfm_Ooo
ooooWinOob0P803Wooooo`000_ooool01Olf=SKoM7Adono_kolS8b?oJ6QX
00;ooooo00?o_[jno`000?oVi^H00_ooool01_oTi>Co0000ol71`Ooooooo
@410ogmoO`?ooooo00Go5QHFoi6ATOnn_[ko0000onKViP02ooooo`08onCT
i?l0003o`L71oooooolf=SKoEeMGolS8b?o/k>`3ooooo`05ojf][Olb<S;o
<c<cocHf=_lP82000_ooool02_m0@43oOgmoooooooooooooXj>Soa`L7?oo
oooo`<30o`000?oVi^H2ooooo`09ojb/[?lA4A7ooooooooooon][Jgo<S8b
oc<c<olf=SKo820P0>Oooooo0002ooooo`05ocHf=_l30`?o0000o`000?o1
`L400_ooool00ooLg=co0000okBd]002ooooo`06ok:b/_l0003oh>3Poooo
oom0@43oNWYj0_ooool01_o]kNgo0000ol?3`ooLg=co0000okBd]0;ooooo
00[o/[:bo`000?oPh>3oooooocHf=_lN7Qko8B4Qo`410OmJFU[om?Cd0ooo
ool00oomoOgoU9BDob4Q8@02ooooo`0:od10@?mMGEgooooooooooonMWIgo
7AdMoooooooPh>3o0000ok:b/P;ooooo00?o[:b/oa4A4Oooool00oooool0
0oomoOgoU9BDob4Q8@3Wooooo`000_ooool01_lf=SKoMgMgon?ShonJVY[o
20P8okVi^@;ooooo00Ko@D51odQ8B?oNg]kogMgModM7Aom4A4@2ooooo`0>
od10@?lK6a_oUiNGomcLg?mYJFWo4A4Aooclo?oooooo@D51odQ8B?oNg]ko
gMgModM7Aom4A4@2ooooo`0<ocHf=_mgMgOoooooom?Cdol<30coJVYZoooo
oond];Cof][Jooclo?mQHF7oE5AD0_ooool01_m0@43o51@DogIfM_oNg]ko
EeMGode=C@;ooooo00Ko@d=3odI6A_oShn?ojn_[oe9BD_lA4A42ooooo`05
okBd]?oJf][oo?clof5QHOmDE5@0ioooool000;ooooo00Ko=SHfogMgMooo
ooooooooodU9BOmCDe<2ooooo`06onSXj?mBDU;o3`l?o`l?3omDE5CojNWY
0_ooool01_m0@43oO7alofEUIOl=3@go6ATIojRXZ0;ooooo00Koj>SXoe9B
D_l?3`oo3`l?oeADE?oYjNT2ooooo`0<ocHf=_mgMgOooooooooooomWIfOo
820Poooooon:RX[o<S8boa0@4?li>CWoa<C40_ooool01_mDE5CoS8b<ogUi
NOlD51Co;Rh^olC4a0;ooooo00Koi^KVodA4A?l<30co:2PXofe]KOlA4A42
ooooo`05ohZ:R_lb<S;o410@ocTi>Oo4a<@0ioooool000;ooooo00Ko=SHf
ogMgMoooooooooooocDe=OmEEED4ooooo`;oo_kn1?ooool01?m0@43oOgmo
ooooooomoOd6ooooo`;oo_kn1?ooool01_lf=SKoMgMgooooooooooooADE5
odA4A0?ooooo00?ooOgmooooooooool01Oooool00oono_koooooooooo`04
ooooo`04oogmoOoooooo[:b/oa4A4@Cooooo00?ooOgmooooooooool0iooo
ool000;ooooo00Ko=SHfobl_;omJFU[o8b<So``<3?o3`l<:ooooo`03od10
@?moOgoooooo00gooooo00Ko=SHfobl_;omJFU[o9bLWo`820_n^[ZhDoooo
o`03ojb/[?lA4A7ooooo0>gooooo0002ooooo`05ok2`/?nJVY[oVYZJok^k
^ooinOT02oooool00om0@43oOgmoooooo`0=ooooo`05ok2`/?nJVY[oVi^K
ojf][OoNg]h05Oooool00on/[:co4A4Aooooo`3]ooooo`004_ooool00ook
no_ooOgmooooo`0Wooooo`03ookno_ojn_[ooooo0>gooooo003oooooobgo
oooo003oooooobgooooo003oooooobgooooo003oogj]fBgoOZgI00000omn
[MWo`/;2ol;2`P0aol;2`P05oi:BT_mSHf?oBDU9oeaLG?nLW9`0l_o2`/81
ogj]f@0000?oOZgIol;2`_o2`/80<Oo2`/801_mXJ6SoFEUIogemOOm;Bd_o
20P8ohn?So7o`/;20Omn[MT00003ogj]fOo2`/;o`/;200Wo`/;200?o/k>c
okFe]Oo2`/800oo2`/801Ong]kOo_Kfmol71`On^[Zko`L7100Go`/;200?o
/k>cokFe]Oo2`/803oo2`/800onc/k?o]KFeol;2`P07ol;2`P03odA4A?lf
=SKo`/;20?3o`/;20Omn[MT00004ogj]fOo2`/;o:BTYoeYJFP;o`/;200[o
^k^koa`L7?le=CGo`L71ojJVY_lX:2So2PX:o`T92Ol[:b_oYjNW0_o2`/80
1_l`<33o@d=3oa`L7?lD51Co3`l?ohn?S`;o`/;200KoYZJVobPX:?l:2P[o
2@T9ob/[:onWYjL2ol;2`P07obTY:Ol0003o0000o`H61_lS8b?oEeMGokRh
^003ol;2`P06ojJVY_lX:2So2PX:o`T92Ol[:b_oYjNW0_o2`/801_n_[joo
ATI6ob/[:omLG5coMgMgoaHF5_7o`/;20Omn[MT00004ogj]fOo2`/;o:BTY
oeYJFP;o`/;200KoEEEEo`l?3on_[joo`L71obLW9oln?Sh2okFe]@0>od10
@?lX:2So`L71ol;2`_l`<33o<S8bokFe]Onn_[koGemOo`h>3_nh^;So`L71
obLW9oln?Sh2okFe]@0@od10@?lX:2So`L71ol;2`_lY:BWoF5QHol;2`_nj
^[[oVi^Koc@d=?lI6AWo][Jfol;2`_o1`L7o9bLWochn?P;o]KFe00[o@410
obPX:?o1`L7o`/;2ocXj>_lR8R;oNg]koeiNG_lR8R;o3`l?lOo2`/81ogj]
f@0000coOZgIol;2`_lY:BWoFUYJol;2`_nCTi?o0@41ohJ6Q_o2`/;oY:BT
o`000?n;Rh/2ol;2`P06oh^;Rol0003oYjNWol;2`_l`<33oH61P0_o2`/80
1_n_[joo0000oh>3PonTY:Co0000oh^;R`;o`/;200KoRh^;o`000?nWYjOo
`/;2obTY:OmHF5P3ol;2`P07okjn__lG5aOoEEEEol;2`_nTY:Co0000oh^;
R`02ol;2`P06oh^;Rol0003oYjNWok^k^ol61PKoS8b<0_o2`/800ombLW;o
30`<ol;2`P3`ol;2`P7oOZgI00001omn[MWo`/;2obTY:OmHF5So]KFeoaXJ
6_m?Cdl00_o2`/800on@T93o0000ojj^[P02ol;2`P06ojf][Ol0003oTY:B
ol;2`_l`<33oH61P0oo2`/801Ol@413oKVi^oi2@T?l0003o[Zj^00;o`/;2
00Ko[Jf]o`000?nBTY;o`/;2obTY:OmHF5P4ol;2`P06oeiNG_lI6AWo`/;2
oi2@T?l0003o[Zj^0_o2`/801_n][Jgo0000oi:BT_nCTi?o0000ojj^[P;o
`/;200?oPX:2o``<3?o2`/80l?o2`/81ogj]f@0000CoOZgIol;2`_lY:BWo
0P820_l000001_nBTY;o`/;2ol;2`_nWYjOo0000ohR8R0;o`/;200KoQhN7
o`000?nZZZ[o`/;2oc0`<?mLG5`2ol;2`P06okBd]?l0003oU9BDojNWYol0
003oR8R80_o2`/801_n7QhOo0000ojZZZ_o2`/;o:BTYoeQHF0Co`/;200Ko
N7Qho`820_nm_KgoYjNWo`000?n8R8P2ol;2`P06ohN7Qol0003oZZZZojFU
YOl0003oRHV90_o2`/800on2PX;o30`<ol;2`P3`ol;2`P7oOZgI00002?mn
[MWo`/;2obTY:OmJFU[o[:b/ogEeMOl61PKoS8b<0_o2`/801_la<C7o=SHf
ojRXZ?nXZ:So=SHfoc<c<`;o`/;200[o<30`oa@D5?mbLW;oYjNWodm?Col<
30co_knool;2`_la<C7o=SHf0_nXZ:P01_lf=SKo<c<col;2`_o2`/;o:BTY
oeQHF0Co`/;200KoKFe]o`<30onn_[ko`/;2oc4a<Olf=SH2ojRXZ00:ocHf
=_lc<c?o`/;2ol;2`_l/;2co=CDeoj^[Zong]kOo@D51o``<3?7o`/;20Omn
[MT00004ogj]fOo2`/;o:BTYoeYJFP;o`/;200Ko=cLgoclo?oo2`/;o`/;2
ok2`/?ln?Sh2o`/;2`0:oclo?ona/K7o`/;2ol;2`_l`<33oGUiNoda<C?l9
2@Wo4a<CogmoO`;o`/;200Ko/;2`ochn?_l;2`_o2`/;oclo?ona/K42ol;2
`P03obTY:OmHF5So`/;200?o`/;200Ko?Shnob4Q8Oo2`/;o`/;2ok2`/?ln
?Sh2o`/;2`0:oclo?ona/K7o`/;2ol;2`_n/[:co<c<co`P82?lO7aooFEUI
oalO7o7o`/;20Omn[MT00004ogj]fOo2`/;o:BTYoeYJFP;o`/;200?o:2PX
od10@?o2`/800oo2`/82ol71`@Co`/;200Co<30`of1PH?o2`/;o`<301_o2
`/82ol71`@Co`/;200?o:BTYoeQHF?o2`/800_o2`/800omhN7So0000ogYj
NP04ol;2`P;o`L711_o2`/800oo0`<3o`/;2ol;2`P3bol;2`P7oOZgI0000
2?mn[MWo`/;2obTY:OlS8b?oA4A4oaXJ6_l92@WoU9BD2_o2`/800ol`<33o
H61Pol;2`P0=ol;2`P08obTY:OlR8R;oC4a<oc`l??lR8R;o1@D5ofa/K?o1
`L7ool;2`P;o`/;20Omn[MT00003ogj]fOo2`/;oQHF500;oMGEe00?oSXj>
okfm_Oo2`/802_o2`/800ol`<33oH61Pol;2`P0=ol;2`P06ohF5QOmeMGGo
MGEeog]kNonEUIGo/[:booo2`/84ol;2`P7oOZgI00000omn[MWo`/;2ol;2
`P0?ol;2`P03okjn__o0`<3o`/;20?oo`/;25oo2`/81ogj]f@0000?oOZgI
ol;2`_o2`/80ooo2`/8Yol;2`P7oOZgI00000omn[MWo`/;2ol;2`P3ool;2
`RWo`/;20Omn[MT00?ooOZgI;Omn[MT00?ooOgmo;OmoOgl00004on_[jooV
i^Koh^;RomkNgPCogMgM0ooNg]h0P_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oM
gMd2omcLg02Aom_KfooMgMgog=cLomgMgOoMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMg@03omkNgP03omgMgOoNg]kog]kN00?ogMgM0OoQhN41onOWi`7oj^[Z
00000oo/k>coi^KVon3Ph007omWIf@04omSHf?oFe]Kodm?Com3@d0?ocLg=
00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=
c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=
cLd01?o@d=3odm?ComOGeooHf=PlomWIf@;of=SH00?ofMWIomSHf?oHf=P0
0ooIfMT2omSHf0GofMWI00?of=SHomKFe_oCdm<00_oCdm<00ooFe]Kof=SH
omSHf00>omWIf@04omSHf?oIfMWofMWIomSHf13ofMWI0_oHf=QXomWIf@03
omSHf?oIfMWofMWI00KofMWI0OoNg]h1onKViP7ok>c/00001oo^k^kojNWY
onCTi?oPh>3ohN7Qon3Ph?oRh^800_oQhN403OoNg]kog=cLom?Cdoo7alOo
^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml02OoQhN403OoO
gmoofm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_K
fooOgml02OoQhN403OoOgmoofm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:b
ok^k^oo7alOodm?Com_KfooOgml0;OoQhN48on3Ph003omoOgooPh>3ogmoO
00;oh>3P1_oOgml2on3Ph0?ogmoO1OoPh>001ooOgmoofm_KomOGeooDe=Co
eMGEomWIfOoMgMd00_oPh>000ooOgmooh>3Pon3Ph002on7Qh@Ooh>3P1_oO
gml00ooPh>3ogmoOon3Ph00;on3Ph004omoOgooNg]kog]kNomoOg`;oh>3P
IooQhN400ooRh^;ohN7Qon;RhP04on7Qh@7oi>CT0OoYjNT1ong]k@0000?o
l?3`ono_kooalO400oo`l?00J_o_knool?3`onk^k_oYjNWofm_Kol71`OnT
Y:CoS8b<og]kNomgMgOoNg]kohb<S?nTY:Co`/;1om[Jf_oZj^[okNg]oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo]kNgoj^[Zom[Jf_o2`/;oY:BT
ohb<RomkNg_oMgMgog]kNon<S8coY:BTol;2`_oJf][oj^[Xong]kOoalO7o
kno_oo7alOo_knoolO7aono_kooalNookNg]on[Zj_oJf][o`/;2ojBTY?n<
S8coNg]kogMgM_mkNg_oS8b<ojBTY?o2`/;of][Jon[Zj_o]kNgolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_koo`l?02onc/k007
on_[joo^k^cok>c/ong]kOo/k>cok^k^on[ZjP02on_[j`0:onk^k?oYjNWo
j>SXonKVi_oYjNWoi^KVon[Zj_o[jn_okNg[onSXj0;ojNWY00OokNg]on[Z
j_o/k>cok>c/ono_kOoZj^[oj>SX00;ohn?S00gogmoOon?ShooXj>SokNg[
on[Zj_o[jn_ok>c/oo3`l?o_knool?3`ong]kOo/k>[oj^[Z00;ok^k^00Ko
kno_on[Zj_oYjNWoi^KVonSXi_oWinL2onWYj@06onc/k?oYjNWok>c/ong]
kOo^k^coj^[Z0_o/k>`02?o^k^koj^[Zonc/k?o/k>cokno]on_[jooYjNWo
i^KV0_oXj>P2ong]k@1]oo3`k_o_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7ol?3`ono_koo`l?3okno_oo3`l?o_knool?3`ono_
k`04oo3`l00000?ol_;bonk^k_oWinL01?oUiND04?oTi>CogmoOom7AdOna
/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RXWo/K6aom7A
dOoNg]h2onCTi003onGUiOoTi>CoiNGT00;oi>CT00oog]kNom7AdOna/K7o
RXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6aom7Ad?oN
g]h00_oTi>@0@_oUiNGoi>CTonGUiOoTi>Coi>CSomkNg_oAdM7o/K6aohZ:
R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM7og]kN
onCThooTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Cohn?S
omkNgP;ofm_K00[og]kMomcLg?oKfm_ofm_KomoOgooKfm_ofMWIomcLg?oM
gMcoemOG0ooEeMD01?oDe=CofMWIomgMgOoMgM`2omOGe`0Bom_KfooMgMgo
f][Jom[Jf_oNg]kohN7Pom_KfooHf=SoATI6oc0`<?mhN7So`/;2om[Jf_oN
g]gof][JomWIfOoMgMgohn?S0_oTi>@05_oOgmoog=cKomWIfOoOgmooh^;R
on7QhOoKfm_oe]KFomCDe?oFe]Goe=CDomKFe_oKfm_og=cLomSHf?oLg=co
gmoOomoOg_oIfMWofm_KomkNg_oOgml2om[JfP1_omgMgOoPh=oofm_KomOG
eooEeMGoemOGomWIfOoOgmooh^;RonCThooTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CT00CoiNGU00Koi>CTonGUiOoUiNGo
iNGUonSXj?o]kNd1oo;blP0000?om?Cdong]kOoWinL00_oPh>004ooQhN7o
gmoOomkNg_oBd];o];BdohN7QomLG5coKC/eoii>@_o=KeoojH=_ole_GonN
CT?oKC/foeaLG?n7QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd
]?n7QhOoG5aLofeP;?nNURkocLdoonWYCOo=cCooWYX_ofeS;OmLG5coQhN7
okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m7Ibko
J9hcoi7=AonZjEGoTLe7ofZN=?m9JRooG5aLohN7Qond];Cod];BomkNgP0[
on3Ph013omkNg_oHf=Sod];BomCDe?oFe]Kod];Bolo?cooBd];oe]KFom?C
dooAdM7oeMGEomKFe_o@d=3oa<C4ol_;boo?cloobLW9olC4a?oHf=SoeMGE
om3@d?o4a<Cod=3@omSHf?oBd];odM7AomSHf?oKfm_oe]KFom7AdOnEUIGo
X:2Pochn?_m;Bd_oe=CDomSHf?oBd];odM7AomSHf?oNg]koh>3PomoOgooJ
f][odm?Com7AdOoHf=SogMgMom[Jf_oCdm?oclo?ol30`?o@d=3ocLg=okno
_ooDe=Coe]KFom7AdOoDe=CofMWIomSHf?oAdM7od];BomSHf?oIfMWodm?C
om7Ad@02omOGe`08om7AdOo?cloob<S8olC4a?oHf=Sofm_KomkNg_oOgmmT
on3Ph003omoOgooPh>3ogmoO00;ogmoO0ooPh>000ooQhN7oinOWonc/k001
ooCdm00000?om_Kfoo;bl_o[jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWioo
JemOohlf;_o]LF7onIf@oofaYOom_:oooKBWooVOToo]M6?oTSL_of]OGonO
WioocLg=on;Rh_oWinL00ooXj>P04ooWinOoh^;Rolg=cOnOWiooKVIOoi=b
8_o]dDConO=doogmSOomoIGooOf>ooWhM_o]edOoTg<RofiWGonOWioocLg=
on;Rh_oWinL00ooXj>P04ooWinOoh^;Rolg=cOnOWiooH6QOod]l8onBhD_o
_OUkom3mT_oHoI_oe?fEol3iO_nHj4goCH0Tof1YGonOWioocLg=on;Rh_oW
inL0:_oXj>P0:OoVi^KogmoOoc0`<?n?Shoofm_KolO7aon8R8SoaLG5om_K
fonUYJGo0@41omgMgOoNg]koKFe]o`P82?lA4A7oLg=coc0`<?lT92CogMgM
om_Kfom;Bd_o30`<of9RH_oQhN7oKFe]ocXj>_oOgmoohn?Sol?3`ol0003o
`L71on7QhOnPX:3o3@d=omOGeooNg]koOGemoaLG5ooMgMgoi>CT00;oi^KV
01Coh^;RogmoOolX:2SogmoOonGUiOoShn?o][JfoalO7ol92@Wo=SHfogAd
M?l820SoUYJFomgMgOl?3`ooUiNGon7QhOoOgmoo@T92ofATI0;oh>3P00co
MGEeoc8b<_oMgMgofm_Kokjn__ll?3co0P82oalO7olE5AGo];BdonKVi_oW
inM]onSXj07ok>c/0Oobl_81ooKfmP0000?omoOgooShn?ohn?P00oohn?P0
4oogmoOok^k^olk>c_n@T93oQBl[onUTE_okTXOooZJKoojaYOoo^:_oo[>V
oojXW?okU8WokVQIohTa:on@T93oc/k>onk^k_ogmoL00oohn?P04oogmoOo
k^k^olk>c_n@T93oVFT[oo2m?Ookh6koo_B2ooknR_oooi;oo_j<ookhPook
iG3ol<8noiUZ:on@T93oc/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>
c_n@T93o@W<[ohC>@on]kg?o`_j8olknT?oFoiOod?jBolKnROnbmGCoR==3
odAe:on@T93oc/k>onk^k_ogmoL0:_ohn?P0;oofm_Kokno_oc<c<onIVIWo
inOWoh>3Pol0003oO7alonSXj?n`/;3o0@41ong]kOoShn?o1PH6oj:RX_oM
gMgoMgMgo`000?o>c/kol?3`ol;2`_l0003odM7AooCdm?oalO7oMGEeochn
?_o^k^kol_;bom3@d?l0003oclo?oo7alOo8b<So0000ol?3`oo^k^koQXJ6
oaTI6OoYjNWokno_oo;bl_odm?ColO7aohR8R?l[:b_ok^k^00;omOGe01co
I6AToclo?ooUiNGo/k>coalO7omWIfOokno_ong]kOl@413oXZ:Roo3`l?o_
knooAdM7of][Joo_knool?3`oginO_le=CGojn_[onSXj?lg=cOoA4A4olk>
c_oWinOogMgMonCTi?oemOGomoOgI_ohn?P00oogmoOon?ShooShn002ooSh
n004ooOgmooinOWomoOgooOgm`7on?Sh00000oojn_[omOGeonk^kP02onc/
k02Yon_[jooYjNWogmoOokZj^_miDU;o_c8TonMdJOomRGkooiR<oojRU_oo
Z9cooZBHoonJSOonRWookWIZol<c9?miDU;o^[ZjomoOgooZj^[ojn_[onc/
k?o[jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3ooMYSoooZL_onlgkoooZ2
ookfOoook7?oo]iToo[7DOoRTQcoRFICokZj^_oOgmooj^[Zon_[joo/k>co
jn_[on[Zj_oOgmoo^[Zjoe9]D_mAXacoTM9EojKWJ_nhnG[o`?j2olOoROo3
oXCo^OekojO/K?nDeUOoDZHLoe9]D_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?oYjNWohn?Soc0`<?n@T93of=SIobd]
;Om0@43o8R8Rom[Jf_nVYZKo0@41on7QhOoShnCo410@ogalO?oOgmoo];Bd
o`000?oAdM7oi>CToiRHVOl?3`ooh>3PonOWiooShn?oKfm_oc/k>ooOgmoo
hN7Rol?3`ol0003oaLG5onCTi?no_koo0000okRh^?oQhN;oOgmooaLG5ooI
fMWogMgMon7QhOoUiNGoi>CToh61POlX:2SogmoOonKVi_oXj>SoM7AdoalO
7ooIfMWog=cMoc/k>om_Kfooi>CTon3Ph?l?3`ooV9RHon7QhOoOgn3o@d=3
ofEUI@02on3Ph01_ogMgMolb<S;oh>3PokRh^Ol0003oZ:RXomcLg?oIfMWo
fm_Kon7QhOoYjNWoj^[[onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/00Oojn_[00Gok>c/on_[joo[jn_ok^k^ooKfmP01ooWin@0000?o
no_koo?cloo]kNd00_oUiND0/?oVi^Koi>CTomWIfOnb/[;oNBh^olQ2=?oS
JUcom7Y]oof8O?onUh[ooY^>oojHRoonRWkom7]]onM[GOo:@SCoNbh^ok:b
/_oHf=Soi>CTonGUiOoVi^KoiNGVonCTi?oHf=So/[:boiIE;_oZW2_onka4
ook<Doomf6;oo^=bookYMOoniW?oo]]Uoog<Dook`DGokYh[oiUF;_nb/[;o
f=SHonCTi?oUiNGoi^KVonGUiOoTi>Cof=SIok:b/_l^HRkoHjd[ohO:B?nG
g5WoYNEYok;cMonhmW_o]?EiojOZJonHg5WoRLm;of>^:ol^Hbko/[:bomSH
fOoTi>CoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Kohn?SomgM
gOl_;booRh^;ok6a/_l0003o]kNgobDU9OnXZ:SoX:2Po`410OoLg=coh>3Q
ok:b/_li>CWo9BDUoc/k>ol0003ocLg=omgMgOnCTiCo410@omKFe_oNg]ko
g=cLofa/K?li>CWoe=CDomKFeonl_;co0000ol;2`_oOgmoo^k^ko`000?nd
];Cog=cLogalO?lG5aOoe]KFom[Jf_oNg]koh>3PomoOgommOGko9bLWomGE
eOoLg=cog]kNom_KfomTI6Co820Poc`l??lC4a?oKFe]on3Ph?oLg=co3`l?
oi>CTooGemOoeMGFod51@OmRHV;oemOGomKFe_mcLg?o<C4aomgMgOnJVY_o
00001?lg=cL0Ionb/[;oi>CTonCTiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiND00_oVi^H00ooUiNGoi^KVonKViP03onKViP03
onGUiOo]kNgom?Cd007ono_k00000oolo?con?Shoo7al@03onk^kP0Con_[
jooQhN7o_;blogXG5oo3?c;odeI9onAXF_o_Mfcom8=iooR7O?oeQ7[olgU]
onEYFooIF4[oa3lbog`G5onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o
_;blojE75ooVUc;omJ``oofl@OombE?ooM1Poo_CIOomdV3oo/eDoofm@_oj
[c;ojI/bojE65onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;bloaMI
5omOZ3;oM[dgohK=AonFeU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg_cOoGj/b
oaMI5onl_;cohN7Qonc/k00Zonk^kP0Wonc/k?oUiNGo<C4aohn?Som^KVko
;2`/onSXj?mmOGgoGUiNojBTY?l10@7ohn?SonWYjOoVi^Koh^;Ron3Ph?n]
[Jgo0000omOGeooTi>CoV9RHoa0@4?oMgMgohn?SonCTi?m`L73o92@TomKF
e_oOgmoo_knoo`000?o;bl_ojNWYol71`Ol0003o^[ZjonCTi?n1PH7o1PH6
00?o?Shn02;obl_;onWYjOn4Q8Co6QXJom[Jf_oRh^;oiNGUonOWiooShn?o
h>3PomSHf?lg=cOoLW9bon[Zj_oWinOo3`l?ohZ:R_oOgmoog]kNod=3@omF
EUKoh>3PomoOgomgMgOo<c<conWYjOnn_[ko0000oj2PX?nf][KoZZZZo`82
0_oIfMWokNg]KOo^k^h00oo]kNgol_;booShn001ooclo0000oomoOd05_ol
o?cooOgmoogmoOolo?colo?com7AdOmX1`Oo^3@dolLo<ooBD4?ofV9Eon=^
H_oTLVCoi6mRomaTEooCDD?oc44dokTd=?m[1`Ood];Boo?cloolo?`3oogm
o@0Cooclo?oclo?od];Boih[1ooJRSCoji/IooFX:Ooh]3oonKe:ooRoCOoj
_d[onKPoooJZ:_o_WQWofh/doj8]1ooBd];olo?cooclo003oogmo@0Coocl
o?oclo?od];Bo`M01om=VSCoGj/Pog2h;omo`d?oR/e@ohg=D_n:cU3oPLM4
og6i;omR[R3oCY/do`M21ooBd];olo?cooclo00Zoogmo@1<oo_knoodm?Co
=3@doiNGUolO7aooQhN7oo[jn_oLg=co4a<CojVYZOl10@7ol_;booWinOo0
`<3oa<C4oo?clon<S8co8B4Qoo[jn_oemOGoWIfMoa0@4?oVi^Kok^k^ooCd
m?mhN7So4A4Aoda<C?o:b/[oRHV9oa@D5?ofm_KonOWiolk>c_l0003oa/K6
oo?clon9RHWo4a<CokJf]_ni^KWo^[Zjong]kOoinOWoShn?o``<3?mGEeOo
dM7Aong]kOo/k>coYZJVonKVi_oTi>Co4Q8Bojf][Ookno_on_[joa0@4?lN
7QkoYJFUomcLg?lJ6Q[o820PogemOOoNg]koAdM7oemOGookno_on_[joc@d
=?maLG7ok^k^ohj>S_le=CGono_kooclo6_ooOgm00?oo?cloogmoOolo?`0
0oomoOd0000joogmoOojn_[olo?conk^k_o`l?3okno_onk^k_oYjNWodm?C
oe/M7OnR=3Co]2PMol4j;Oo7BCcoceI:om1GBoo@Ed[obTXnol<k;_nf:1go
XS@doe`M7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`koo^k^koj^[Zom?Cdon<
9Agob74domV47OoTU1GoiidTonjX<oo`ZSCokjXconbP9OoWUaGog8PMolQa
=?n<9Agodm?Con[Zj_o^k^kol?3`ono_koo`l?3ok^k^on[ZjOoCdm?o7CPM
ocB2=?m7UAgoFZDKofV]:P;oM;Ph07goMKThof^a:omKYacoB9XMocB2=?lM
>1godm?Con[ZjOo^k^kol?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knook^k^onOWiola<C7oGemOo`410OoBd];ok^k^onc/k?m1@D7oHF5Qo`41
0OoVi^Kok^k]oj2PX?li>CWo4A4AobHV9_nHV9Sokno_olG5aOl@413o0@41
oaTI6OmBDU;ojNWYog5aLOlm?CgoUiNGoalO7olH61SoTI6Aonk^k_o]kNgo
`l?3o`000?nl_;coj>SWoh:2P_lH61SogmoOon;Rh_oShn?oinOWon_[jonC
Ti;o?clooi:BT_lG5aOoU9BDon3Ph?m?Cdoo7alOoa4A4Om?Cdooj>SXonk^
k_o_knoo9bLWoj2PX?m>CTko2@T9ocHf=_oPh>3oKVi^o`l?3ol/;2co_[jn
onk^k_o_knkod];Boc`l??l;2`_o7AdMok:b/P02ono_k`1Voo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_0_o`l?06
ono_k`7olo?c0OoinOT1ooknoP0000?oo_knooOgmoo`l?001?oYjNT04OoW
inOofm_Kof=;Bon1<S;oYSDeokHd;Oo2CD7o`eA9olAEB_o3E4Wo`Te1okHd
;OnU=CGoPC8bof=;BooKfm_oinOW00GojNWY017oinOWom_Kfon9Bd_o[d/b
oleg=OoFRbgoh9`^on2P<_oQX3Coh:0bomnJ;_oFRbgobWDeojm;<_n9Bd_o
fm_KonOWi`05onWYj@0AonOWiooKfm_oBd];oc9P<_ljRCGoDi/]of^[;om`
[CSoKjhjog2]>?mZZRooDi/]ocV8=OlbH3;oBd];om_KfooWinL0:ooYjNT0
3OoXj>Soi>CToc0`<?lB4Q;o?3`lonKVi_oXj>SoinOWoi>CTolA4A7o0@41
on?ShooWinL00_oYjNT00ooWinOojNWYonWYj@02onSXj00DoifMWOl@413o
inOWonOWiooTi>CoKfm_oc/k>ooShn?oinOWonSXj?oYjNWoj>SXonOWioo2
`/;o0000okZj^_oTi>CoP820oaLG5ooMgMd2omkNgP03on7QhOoVi^Koj>SX
00;ojNWY00?oj>SXonOWiooYjNT00_oYjNT00ooWinOojNWYonWYj@03onWY
j@03onSXj?oYjNWoj>SX00?ojNWY00?oinOWonWYjOoYjNT01?oYjNT00ooV
i^KojNWYonWYj@1YonWYj@03onSXj?oYjNWojNWY00CojNWY0Oo`l?01ooOg
m`7oo_kn00001Oono_kon_[jooCdm?o_knoolO7a00;ol?3`017okno_on_[
jonEU9CoCb<SoiEDE?nkLg?odiFEomZLW?oJWYcofIbLomBEUOnkLg?oUEAD
odlS8onEU9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oZIBDoh4S8onjJUCo
e9YconBlUOoZaicojLNLon[7W?oU_9Goe9Ycok]ZE?n18b?oZYBDon[Zj_o_
knl01Oo`l?004Oo_knooj^[ZoiBDU?lS:R?oE7YDog>ULonNaYGo[<jLojg>
W?n/cYcoW/JEog>ULomDNUCo8bXSoiBDU?oZj^[okno_02_ol?3`00Gokno_
onk^k_lb<S;o0000oi>CT`03ono_k`05onCTi?l;2`_o0@41onk^k_o_knl0
1oo`l?002OoShn?o_knoono_koo_knook^k^ogAdM?lm?CgokNg]ono_k`03
oo3`l007ono_koo:b/[o0000ol?3`oo^k^koQXJ6o`T92@03oeiNGP03ogUi
NOo^k^kokno_00col?3`00?okno_oo3`l?o`l?00O?o`l?001?oalO7ol?3`
ooCdm?ojn_X1ooknoP000oooool00oono_koooooooooo`02ooknoP1^oogm
oOohn?SoKVi^oeXo?onaT93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSlo
ofe]KOohn?Soo?clooooooono_koooooookno_ooookoo_knooooooolo?co
n?Shohe]KOn:?coobI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo?on=
KFgon?Sgooclo?ooooooo_knooooooono_koooooookno_ooookoo?clooSh
n?m]KFgo?clooi2MT?o9eLWoi>cTonK^i_oTk>CobMG9oi2MT?lo?cooKFe]
ooShn?olo?coooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_oooooooOgmojn_[onHV9SolO7`oogmoOooool2ooknoP0FokBd]?nJ
VY[ooOgmooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_oooooooOgmookno_mlO7co@D51oogmoOono_goo_knooooo`;oo_kn09?o
k^k^oiVIVOo[jn_oo_kmom7AdOnIVIWoV9RHoiVIVOnHV9So[:b/oogmoOoo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_h00_ooool00oono_koooooooooo`03ooooo`7ono_l00001?ooooooo_kn
oo[jn_odm?@5oo7al@0=ono_kooFe]KoJf][od<m?OnKS8coa[ZjomK<c?o7
^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7al@0=ono_kooGe]KoPf][og@m
?OneS8coeKZjon7<c?oF^[[o]Xb<og8m?On1Jf_oemKFono_k`09oo7al@0=
ono_kooFe]KoJf][ocdm?On<S8co^[Zjolc=c?nj^[[oS8b<ocdm?Om[Jf_o
e]KFono_k`0eoo7al@03oo3`l?oalO7olO7a00kolO7a00?ok^k^ong]kOoa
lO40UOoalO401?o`l?3olO7aoo7alOo`l?04oo7al@03ooCdm?ojn_[oo_kn
007on?Sk00001Oodm?CooOgmooShn?o`l?3ojn_[00?oj^[Z00gojNWYon[Z
j_oYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY
00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo@RHVofUIFOnPVi_o
j>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mI
FEWoVi^KonSXj?oYjNT0i_oZj^X01?o[jn_ol?3`ooShn?omoOd1on?Sj@00
00Coa/K6ookno_ojn_[om?Cd2?oalO42oo3`l0?okno_0_o`l?0?oo7al@;o
l?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`>?oalO400oo`l?3o
lO7aoo7al@2Yoo7al@03oo3`l?oalO7olO7a00;olO7a00?omOGeoo[jn_ob
l_H00On][KD00003omGEeOo=cLgooooo0?oooooo9oooool1ooCdn07o^k_2
0Oni^L<00004oo?clooDe=Coa/K6ooGemOoooooo8oooool01OomoOkonOWl
on[ZlOnj^/;o`l?=007og]kZ0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{300, 200},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleJList",
        ButtonData:>{"SimpleJList.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SimpleJList[]\)], "Input"],

Cell[BoxData[
    \({"RoboDog"}\)], "Print"],

Cell[BoxData[
    \({"RoboDog"}\)], "Print"],

Cell[BoxData[
    \({"RoboPanda"}\)], "Print"],

Cell[BoxData[
    \({"RoboPanda"}\)], "Print"],

Cell[BoxData[
    \({"RoboKoala"}\)], "Print"],

Cell[BoxData[
    \({"RoboKoala"}\)], "Print"],

Cell[BoxData[
    \({"RoboDog"}\)], "Print"],

Cell[BoxData[
    \({"RoboDog"}\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["<<< SimpleJList (ListSelection And DoubleClick) >>>",
  FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004n0000^AP00`40o`00
0?l0003oo`0003l000000003R<2hB928B9280?m8T8PkB9280@00000000>8
`;S8h=R8`;P0ohS0^3Z8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^3Z8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo=oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo=oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P/oooo0`000?ooool8oooo0XS0^058T8P10000
000018S0^<SPf8S0^8S0^2koool20000ooooo`Ooool2R<2h0DR@R0400000
0005R<2hb>3HR<2hR<2hoooo00800004oooo0P000003oooo000000000080
0002oooo0P000003oooo0000000000?oool400001?ooo`@00003oooo1000
00?oool300000oooo`@00003oooo0P0000;oool40000loooo`:8`;P1B928
0@00000000F8`;S8h=R8`;R8`;Soool00P0000?oool2000000?oool00000
00000_ooo`8000001Oooo`00000000000?ooo`02000000?oool000000000
0_ooo`800002oooo0P0000;oool2000000?oool0000000000_ooo`800002
oooo0`0000;oool200000_ooo`8000000oooo`0000000002oooo0P0000;o
ool20000l_ooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;Soool00P00
00?oool2000000?oool0000000000_ooo`8000000oooo`0000000002oooo
0P000003oooo0000000000;oool2000000?oool0000000001_ooo`800002
oooo0P000004oooo00000000oooo0P000003oooo0000000000;oool20000
00?oool0000000000_ooo`80003foooo0XS0^058T8P1000000001HS0^<SP
f8S0^8S0^?ooo`0200000_ooo`800002oooo0P0000;oool2000000?oool0
000000000_ooo`8000000oooo`0000000002oooo0P000003oooo00000000
00Koool200000_ooo`8000001?ooo`0000000?ooo`8000000oooo`000000
0002oooo0P000003oooo0000000000;oool60000l_ooo`:8`;P1B9280@00
000000F8`;S8h=R8`;R8`;Soool01P0000;oool200000_ooo`8000000ooo
o`0000000002oooo0P000003oooo0000000000;oool2000000?oool00000
00001_ooo`800002oooo0P000004oooo00000000oooo0P000003oooo0000
000000;oool2000000?oool0000000000_ooo`800002oooo0P000?;oool2
R<2h0DR@R04000000005R<2hb>3HR<2hR<2hoooo00800003oooo0P0000;o
ool00`000?ooooooo`02000000Goool000000000003oool00P0000;oool0
0`000?ooooooo`02000000?oool0000000001oooo`030000oooooooo00@0
0003oooo0P000004oooo0000oooooooo0P000003oooo0000000000;oool2
00000_ooo`80003boooo0XS0^058T8P1000000001HS0^<SPf8S0^8S0^?oo
o`0200000oooo`800002oooo100000;oool2000000?oool0000000000ooo
o`@00002oooo0P0000Ooool4000000?oool0000000000oooo`8000000ooo
o`0000000002000000?oool0000000000P0000;oool40000loooo`:8`;P1
B9280@00000000F8`;S8h=R8`;R8`;Soool00P0000?oool200002?ooo`80
000=oooo0P0000;oool200005Oooo`80003joooo0XS0^058T8P100000000
1HS0^<SPf8S0^8S0^?ooo`0600002Oooo`80000>oooo100001Ooool00`00
0?ooooooo`3hoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooolg
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooolgoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?oooolgoooo0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?oooolgoooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?oooolgoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?nIVL`g
VIW<0XS0^058T8P1000000001HS0^<SPf8S0^8S0^9VIc03oc<co=Lc<o`04
VIW<R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;RIVL`0=<c<o`@0003l
c<co00BIVLb8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^9VIc00cc<co
00@0003<c?o<c?o<c?l20000nlc<o`04VIW<R<2hR<2hB9280@00000000F8
`;S8h=R8`;R8`;RIVL`00P0000C<c?l2000000?<c?l0000000000P0000;<
c?l2000000?<c?l0000000000lc<o`@00002c<co0P0000?<c?l200000/c<
o`D000000lc<o`0000000002c<co0P0000;<c?l2000000?<c?l000000000
0/c<o`D000000lc<o`0000000004c<co100000?<c?l40000h/c<o`04VIW<
R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;RIVL`00P0000?<c?l20000
00?<c?l0000000000/c<o`8000001Lc<o`00000000000<c<o`02000000?<
c?l0000000000/c<o`8000000lc<o`0000000003c<co0P000003c<co0000
000000;<c?l2000000?<c?l0000000000/c<o`8000001<c<o`0000000<c<
o`<000000lc<o`0000000002c<co0P000003c<co0000000000?<c?l20000
0/c<o`8000000lc<o`0000000002c<co0P000>7<c?l019VIc8S0^8S0^4R@
R04000000005R<2hb>3HR<2hR<2hVIW<00800003c<co0P000003c<co0000
000000;<c?l2000000?<c?l0000000000/c<o`8000000lc<o`0000000002
c<co0P000003c<co0000000000;<c?l200000/c<o`800002c<co0P000003
c<co0000000000;<c?l2000000?<c?l0000000000/c<o`8000000lc<o`00
00000002c<co0P000003c<co0000000000?<c?l200000/c<o`8000000lc<
o`0000000002c<co0P000>7<c?l019VIc8S0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hVIW<00800002c<co0P0000;<c?l200000/c<o`8000000lc<
o`0000000002c<co0P000003c<co0000000000;<c?l2000000?<c?l00000
00000/c<o`800003c<co0P000004c<co00000000c<co0P0000;<c?l20000
00?<c?l0000000000/c<o`800002c<co0P000004c<co00000000c<co0P00
00?<c?l200000/c<o`8000000lc<o`0000000002c<co0P000>7<c?l019VI
c8S0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hVIW<00H00002c<co0P00
00;<c?l2000000?<c?l0000000000/c<o`8000000lc<o`0000000002c<co
0P000003c<co0000000000@00004c<co10000003c<co0000000000;<c?l2
000000?<c?l0000000000/c<o`800003c<co10000003c<co0000000000?<
c?l200000/c<o`8000000lc<o`0000000002c<co0P000>7<c?l019VIc8S0
^8S0^4R@R04000000005R<2hb>3HR<2hR<2hVIW<00800003c<co0P0000;<
c?l00`000<c<olc<o`02000000G<c?l000000000003<c?l00P0000;<c?l0
0`000<c<olc<o`02000000?<c?l0000000000`0000?<c?l010000<c<olc<
olc<o`8000001Lc<o`00000000000<c<o`02000000C<c?l00000003<c?l3
000000?<c?l0003<c?l00/c<o`8000000lc<o`0000000004c<co00<0003<
c?o<c?l00P0000;<c?l00`000<c<olc<o`020000hLc<o`04VIW<R<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;RIVL`00P0000?<c?l200000/c<o`@0
0002c<co0P000003c<co0000000000?<c?l400000/c<o`8000000lc<o`00
00000004c<co100000;<c?l2000000?<c?l0000000000lc<o`8000000lc<
o`0000000002c<co100000;<c?l400000/c<o`@00003c<co10000>;<c?l0
19VIc8S0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hVIW<00800003c<co
0P0000S<c?l200003<c<o`800002c<co0P000?o<c?lBc<co00BIVLb8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^9VIc00600002Lc<o`80000<c<co
0P0000?<c?l20000olc<oa7<c?l019VIc8S0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hVIW<0?o<c?lec<co00BIVLb8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^9VIc03oc<co=Lc<o`04VIW<R<2hR<2hB9280@00000000F8
`;S8h=R8`;R8`;RIVL`0olc<ocG<c?l019VIc8S0^8S0^4R@R04000000005
R<2hb>3HR<2hR<2hVIW<0?o<c?lec<co00BIVLb8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^?nIVL`gVIW<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?oooolgoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooolg
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooolgoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?oooolgoooo0XS0^058T8P100000000
1HS0^<SPf8S0^8S0^?ooo`0200001?ooo`8000000oooo`00000000020000
0_ooo`8000000oooo`0000000003oooo100000?oool500000oooo`@00003
oooo1@000003oooo000000000?ooool1oooo0XS0^058T8P1000000001HS0
^<SPf8S0^8S0^?ooo`0200000oooo`8000000oooo`0000000002oooo0P00
0005oooo000000000000oooo008000000oooo`0000000002oooo0P000003
oooo0000000000?oool2000000?oool0000000000_ooo`8000000oooo`00
00000002oooo0P000003oooo000000000?ooool1oooo0XS0^058T8P10000
00001HS0^<SPf8S0^8S0^?ooo`0200000oooo`8000000oooo`0000000002
oooo0P000003oooo0000000000;oool2000000?oool0000000000_ooo`80
0006oooo0P000003oooo0000000000Goool200000_ooo`8000000oooo`00
0000003ooooo0Oooo`:8`;P1B9280@00000000F8`;S8h=R8`;R8`;Soool0
0P0000;oool200000_ooo`800002oooo0P000003oooo0000000000;oool2
000000?oool0000000000_ooo`800004oooo10000003oooo0000000000@0
0002oooo0P000004oooo00000000oooo0P000?ooool1oooo0XS0^058T8P1
000000001HS0^<SPf8S0^8S0^?ooo`0600000_ooo`800002oooo0P000003
oooo0000000000;oool2000000?oool0000000000_ooo`800002oooo1@00
00;oool200000_ooo`800003oooo10000003oooo000000000?ooool1oooo
0XS0^058T8P1000000001HS0^<SPf8S0^8S0^?ooo`0200000oooo`800002
oooo00<0003oooooool00P000005oooo000000000000oooo00800002oooo
00<0003oooooool00P000003oooo0000000000800004oooo0P0000;oool2
000000?oool0003oool00_ooo`8000000oooo`000000003ooooo0Oooo`:8
`;P1B9280@00000000F8`;S8h=R8`;R8`;Soool00P0000?oool200000_oo
o`@00002oooo0P000003oooo0000000000?oool400000_ooo`800007oooo
100000?oool400000_ooo`80003ooooo0Oooo`:8`;P1B9280@00000000F8
`;S8h=R8`;R8`;Soool00P0000?oool200002?ooo`80000<oooo0P0000?o
ool200003oooo`80003ooooo0Oooo`:8`;P1B9280@00000000F8`;S8h=R8
`;R8`;Soool01P0000Woool200003Oooo`D0000@oooo0P000?ooool1oooo
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooolgoooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?oooolgoooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?oooolgoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?oooolgoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooolgoooo
0XS0^058T8P1000000000hS0^<SPf8S0^03oR<2h>XS0^058T8P100000000
18S0^<SPf8S0^8S0^1@008001P01P002P003P@03P@04P@05P@801X801P47
PP48PP49P`49P`4:P`4;Q08138@01P4=Q04>Q@8?Q@8?Q@8@Q@8AQP824XH0
1P8CQP8DQ`8EQ`8EQ`<FR0<GR08368P01`<IR@<JR@<KR@<KR@<LRP<MRP@N
RP0211n;00X488/48H/48X`48X`48h`498`49Hd59Hd59Xd59hd21BR>00H5
:Hh5:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46<I46<Y86<i86=987
=987=I<7=Y<21cNC00L7>9@7>I@7>Y@7>Y@7>iD8?9D8?ID00PPnUP0623nF
242F246G246G24:G24>G0PU4V0062DFH2DJI2DNI2DNI2DRI2DVJ0PU:VP06
2T^J2TbK2TfK2TfK2TjK2TnL0PY@W0062U6M2U:M2e>M2e>M2eBN2eFN0P]F
WP072eNO2eRO2eVO2eVO35ZP35^P35bP008<GJ401PaNX@aOX@aPXPaPXPeQ
XPeRXP8=Hj<01PeTX`eUY0eVY0eVY0eWY0eXY@8>JJD01PiZY@i[YPi/YPi/
YPi]YPi^Y`8>KjL01Pm`Z0maZ0mbZ0mbZ0mcZ@mdZ@8?MJT00`mfZPmgZQ1h
ZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJd24H:^00HA
PjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;8BSK8BS[8C
S[8CSk<CT;<24i6c00LCT[@CTk@CU;@CU;@CUKDDU[DDUkD00QBH]P0659Vf
59Zf59^g59^g59bg59fg0QFN^0065Inh5J2i5J6i5J6i5J:i5J>j0QFT^P06
5ZFj5ZJk5ZNk5ZNk5ZRk5ZVl0QJZ_0065Z^m5Zbm5jfm5jfm5jjn5jnn0QN`
_P035k6o5k:o5k>o03HH]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1000P003VjOa<d>U<d>U00Tc@jD4002000H00H000X000h400h4018401H42
00J200H11h8128812H<12H<12X<12h@20@b400H13H@13XD23hD23hD248D2
4HH20Q:600H24hH258L25HL25HL35XP35hP20aR800L36HT36XT36hT36hT3
78X37HX47XX00P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN=
0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:B
1S>B1SBB1cBB1cFC1cJC0PLgT`071cRD1cVD1cZD1cZD1c^E23bE23fE0088
?YH01PPoUPQ0UPQ1U`Q1U`Q2U`Q3U`89A9P01PU5V0U6V@U7V@U7V@U8V@U9
VP89BYX01PY;VPY<V`Y=V`Y=V`Y>V`Y?W08:D9`01PYAW@YBW@]CW@]CW@]D
WP]EWP8;EYh01`]GW`]HW`]IW`]IW`aJX0aKX0aLX00235fQ00H<GZ4<Gj4<
H:8<H:8=HJ8=HZ823F>S00H=I:<=IJ@=IZ@=IZ@=Ij@=J:D23VVU00H>JZD>
JjH>K:H>K:H>KJH>KZL23VnW00H?L:P?LJP?LZP?LZP?LjT?M:T23gFY00<?
MZX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6]
0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xbb
4Xfb4Xjb4hjb4hnc4i2c0Q>A/`074i:d4i>d4iBd4iBd4iFe59Je59Ne008D
V;H01QBI]QBJ]QBK]aBK]aBL]aBM]`8EW[P01QFO^1FP^AFQ^AFQ^AFR^AFS
^P8EY;X01QJU^QJV^aJW^aJW^aJX^aJY_08FZ[`01QJ[_AJ/_AN]_AN]_AN^
_QN__P8G/;h00aNa_aNb_aNc_`0f6;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0<008001i^WlOooohij]ZJKa;>YdZRMb;>YdP02YY_400Fl^=g^
k_CZjO7ooolc@jD00`00P006006000:000>100>100B100F10P06PP060@N2
0@R20@V30@V30@Z30@^40P4<Q0060@f40@j50Pn50Pn50Q250Q660P8BQP06
0Q>60QB70QF70QF70aJ80aN80P<HR0070aV90aZ90a^90a^90ab:0af:11j:
00847h/02P@PR`@QR`@RS0@RS0@SS0@TS0@US@DUS@DVS@DWS@85:8h01PDY
SPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@HbTPHcTPHdTPLd
TPLeT`LfT`87=i<01`LhU0LiU0LjU0LjU0LkU@PlU@PmU@0223jF00H8?iH8
@9H8@IL8@IL8@YL8@iL22DBH00H9AIP9AYT9AiT9AiT9B9T9BIX22DZJ00H:
BiX:C9/:CI/:CI/:CY/:Ci`22U2L00H:DId:DYd;Did;Did;E9h;EIh22eJN
00L;Eil;F9l;FIl;FIl<FZ0<Fj0<G:000PaMX@0635jQ35nQ362R362R3F6R
3F:R0PeSX`063FBS3FFT3FJT3FJT3FNT3FRU0PiYY@063VZU3V^V3VbV3VbV
3VfV3VjW0Pi_Y`063g2X3g6X3g:X3g:X3g>Y3gBY0PmeZ@033gJZ3gNZ47RZ
008@NJ/02Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[@8APZh01Q63
[Q64[a65[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</Q:=/Q:>/Q>>
/Q>?/a>@/`8CTK<01a>B]1>C]1>D]1>D]1>E]ABF]ABG]@0259Rf00HDVKHD
V[HDVkLDVkLDW;LDWKL25Ijh00HEWkPEX;TEXKTEXKTEX[TEXkX25JBj00HF
YKXFY[/FYk/FYk/FZ;/FZK`25ZZl00HFZkdF[;dG[KdG[KdG[[hG[kh25k2n
00<G/KlG/[lG/kl00QRd`20000026;C04000008H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0P00P004VjOaooooK5ZU[jG:0[bhg@0:oogo/jWB
oooooooo_;SMUhZlZ9g8i^K/oooo<d>U0P00P006006000:000>100>100B1
00F10P06PP060@N20@R20@V30@V30@Z30@^40P4<Q0060@f40@j50Pn50Pn5
0Q250Q660P8BQP060Q>60QB70QF70QF70aJ80aN80P<HR0070aV90aZ90a^9
0a^90ab:0af:11j:00847h/02P@PR`@QR`@RS0@RS0@SS0@TS0@US@DUS@DV
S@DWS@85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`T@HaT@Ha
T@HbTPHcTPHdTPLdTPLeT`LfT`87=i<01`LhU0LiU0LjU0LjU0LkU@PlU@Pm
U@0223jF00H8?iH8@9H8@IL8@IL8@YL8@iL22DBH00H9AIP9AYT9AiT9AiT9
B9T9BIX22DZJ00H:BiX:C9/:CI/:CI/:CY/:Ci`22U2L00H:DId:DYd;Did;
Did;E9h;EIh22eJN00L;Eil;F9l;FIl;FIl<FZ0<Fj0<G:000PaMX@0635jQ
35nQ362R362R3F6R3F:R0PeSX`063FBS3FFT3FJT3FJT3FNT3FRU0PiYY@06
3VZU3V^V3VbV3VbV3VfV3VjW0Pi_Y`063g2X3g6X3g:X3g:X3g>Y3gBY0Pme
Z@033gJZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60
[A61[@8APZh01Q63[Q64[a65[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;
/A:</Q:=/Q:>/Q>>/Q>?/a>@/`8CTK<01a>B]1>C]1>D]1>D]1>E]ABF]ABG
]@0259Rf00HDVKHDV[HDVkLDVkLDW;LDWKL25Ijh00HEWkPEX;TEXKTEXKTE
X[TEXkX25JBj00HFYKXFY[/FYk/FYk/FZ;/FZK`25ZZl00HFZkdF[;dG[KdG
[KdG[[hG[kh25k2n00<G/KlG/[lG/kl00QRd`003b>3HB928B92800a8T8P0
0`000<SPf4R@R00=B92800@0000H]<0H]<38h=P>B92800<0000H]<0H]<00
0XS0^058T8P10000000018S0^<SPf8S0^8S0^08008002i^WlOooojRMb?oo
ok>YdV1<VXij]WQU[ZRMb?ooooomo`03oooo00Hc@jD00800080008000H00
0X0200>100H018401H401X801X811h8128820@V300H12X<12h@138@138@1
3H@13XD20Pn500H248D24HH24XH24XH24hH258L20QF700H35XP35hP368P3
68P36HT36XT20a^900<378X37HX47XX00P@OR`0:122;126;12:<12:<12><
12B<12F=1BF=1BJ=1BN=0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:
1Rn@1S2A1S6A1S6A1S:B1S>B1SBB1cBB1cFC1cJC0PLgT`071cRD1cVD1cZD
1cZD1c^E23bE23fE0088?YH01PPoUPQ0UPQ1U`Q1U`Q2U`Q3U`89A9P01PU5
V0U6V@U7V@U7V@U8V@U9VP89BYX01PY;VPY<V`Y=V`Y=V`Y>V`Y?W08:D9`0
1PYAW@YBW@]CW@]CW@]DWP]EWP8;EYh01`]GW`]HW`]IW`]IW`aJX0aKX0aL
X00235fQ00H<GZ4<Gj4<H:8<H:8=HJ8=HZ823F>S00H=I:<=IJ@=IZ@=IZ@=
Ij@=J:D23VVU00H>JZD>JjH>K:H>K:H>KJH>KZL23VnW00H?L:P?LJP?LZP?
LZP?LjT?M:T23gFY00<?MZX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/
47j/47n]4Gn]4H2]4H6]0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:
4XV`4XZa4X^a4X^a4Xbb4Xfb4Xjb4hjb4hnc4i2c0Q>A/`074i:d4i>d4iBd
4iBd4iFe59Je59Ne008DV;H01QBI]QBJ]QBK]aBK]aBL]aBM]`8EW[P01QFO
^1FP^AFQ^AFQ^AFR^AFS^P8EY;X01QJU^QJV^aJW^aJW^aJX^aJY_08FZ[`0
1QJ[_AJ/_AN]_AN]_AN^_QN__P8G/;h00aNa_aNb_aNc_`026;C000?8h=R8
`;R8`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=
R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0P00P00>VjOaoooooooofmc/H4bJThFj/jWB_;SMH4bJVHnnYY_4b<?Ooooo
<d>U1000P00:0060oooo00>100>100B100F100J2oooo0@N20@R21?ooo`81
38@02`4=Q?ooo`8?QOooo`8@Q@8AQP8BQ_ooo`8CQP8DQ`8EQ`03oooo0P<H
R00<0aV9oooo0a^90a^90ab:0af:11j:oooo11n;122;126;12:<1?ooo`03
1BF=1BJ=oooo0085:8h01_ooo`DZS`D[Soooo`D/S`H]T0?oool02@H`T@Ha
T@HaT@HbTPHcTPHdTPLdTPLeT`LfT`021cNC00L7>9@7>I@7>Y@7>Y@7>iD8
?9D8?ID00PPnUP0623nF242F246G246G24:G24>G0PU4V0062DFH2DJI2DNI
2DNI2DRI2DVJ0PU:VP062T^J2TbK2TfK2TfK2TjK2TnL0PY@W0062U6M2U:M
2e>M2e>M2eBN2eFN0P]FWP072eNO2eRO2eVO2eVO35ZP35^P35bP008<GJ40
1PaNX@aOX@aPXPaPXPeQXPeRXP8=Hj<01PeTX`eUY0eVY0eVY0eWY0eXY@8>
JJD01PiZY@i[YPi/YPi/YPi]YPi^Y`8>KjL01Pm`Z0maZ0mbZ0mbZ0mcZ@md
Z@8?MJT00`mfZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdA
OjdAP:dAPJd24H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4B
Rk4BRk4BS;8BSK8BS[8CS[8CSk<CT;<24i6c00LCT[@CTk@CU;@CU;@CUKDD
U[DDUkD00QBH]P0659Vf59Zf59^g59^g59bg59fg0QFN^0065Inh5J2i5J6i
5J6i5J:i5J>j0QFT^P065ZFj5ZJk5ZNk5ZNk5ZRk5ZVl0QJZ_0065Z^m5Zbm
5jfm5jfm5jjn5jnn0QN`_P035k6o5k:o5k>o008H]<001<SPf8S0^8S0^8S0
^0H00004R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H
]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0<008003Y^WlOoookbhgIV?__ooomKAgM_Lk??nojJKa>k^m8Ef
/9>5^_oooc=3Y@<008002P01P?ooo`03P@03POooo`05P@06P_ooo`47P_oo
o`812H<05P4:Poooo`4<Q04<Q?ooo`4>Q@8?QOooo`8@Q@8AQP8BQ_ooo`8C
QP8DQoooo`8EQ`<FR0<GR?ooo`<HR0<IROooo`836hT03`<LRP<MRP@NR_oo
o`@OR`@PR`@QRoooo`@RS0@SS0@TS?ooo`DUS@DVSOooo`021BR>00Koool5
:Xl5:hooool5;8ooool21Rj@00X6;i3oool6<I46<I46<Y86<i86=987=987
=I<7=Y<21cNC00L7>9@7>I@7>Y@7>Y@7>iD8?9D8?ID00PPnUP0623nF242F
246G246G24:G24>G0PU4V0062DFH2DJI2DNI2DNI2DRI2DVJ0PU:VP062T^J
2TbK2TfK2TfK2TjK2TnL0PY@W0062U6M2U:M2e>M2e>M2eBN2eFN0P]FWP07
2eNO2eRO2eVO2eVO35ZP35^P35bP008<GJ401PaNX@aOX@aPXPaPXPeQXPeR
XP8=Hj<01PeTX`eUY0eVY0eVY0eWY0eXY@8>JJD01PiZY@i[YPi/YPi/YPi]
YPi^Y`8>KjL01Pm`Z0maZ0mbZ0mbZ0mcZ@mdZ@8?MJT00`mfZPmgZQ1hZP02
47V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJd24H:^00HAPjhA
Q:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;8BSK8BS[8CS[8C
Sk<CT;<24i6c00LCT[@CTk@CU;@CU;@CUKDDU[DDUkD00QBH]P0659Vf59Zf
59^g59^g59bg59fg0QFN^0065Inh5J2i5J6i5J6i5J:i5J>j0QFT^P065ZFj
5ZJk5ZNk5ZNk5ZRk5ZVl0QJZ_0065Z^m5Zbm5jfm5jfm5jjn5jnn0QN`_P03
5k6o5k:o5k>o008H]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P00038
h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C0
00C8h=R8`;R8`;R8`;P2000018S0^0800002R<2h00A8T8P0000H]<0H]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00?VjOaooooVHnnUhZl
e=?XkjbcogIkkYn[FeRUYY_4UYoBH4bJ_;SMoooo<d>U008008002P01P?oo
o`03P@03POooo`05P@06P_ooo`47P_ooo`812H<05P4:Poooo`4<Q04<Q?oo
o`4>Q@8?QOooo`8@Q@8AQP8BQ_ooo`8CQP8DQoooo`8EQ`<FR0<GR?ooo`<H
R0<IROooo`836hT03`<LRP<MRP@NR_ooo`@OR`@PR`@QRoooo`@RS0@SS0@T
S?ooo`DUS@DVSOooo`021BR>00Koool5:Xl5:hooool5;8ooool21Rj@00X6
;i06<946<I46<I46<Y86<i86=987=987=I<7=Y<21cNC00L7>9@7>I@7>Y@7
>Y@7>iD8?9D8?ID00PPnUP0623nF242F246G246G24:G24>G0PU4V0062DFH
2DJI2DNI2DNI2DRI2DVJ0PU:VP062T^J2TbK2TfK2TfK2TjK2TnL0PY@W006
2U6M2U:M2e>M2e>M2eBN2eFN0P]FWP072eNO2eRO2eVO2eVO35ZP35^P35bP
008<GJ401PaNX@aOX@aPXPaPXPeQXPeRXP8=Hj<01PeTX`eUY0eVY0eVY0eW
Y0eXY@8>JJD01PiZY@i[YPi/YPi/YPi]YPi^Y`8>KjL01Pm`Z0maZ0mbZ0mb
Z0mcZ@mdZ@8?MJT00`mfZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@
OZ`@OjdAOjdAP:dAPJd24H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XB
RK0BR[4BRk4BRk4BS;8BSK8BS[8CS[8CSk<CT;<24i6c00LCT[@CTk@CU;@C
U;@CUKDDU[DDUkD00QBH]P0659Vf59Zf59^g59^g59bg59fg0QFN^0065Inh
5J2i5J6i5J6i5J:i5J>j0QFT^P065ZFj5ZJk5ZNk5ZNk5ZRk5ZVl0QJZ_006
5Z^m5Zbm5jfm5jfm5jjn5jnn0QN`_P035k6o5k:o5k>o008H]<000lSPf8S0
^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@00
08S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h0P00
00>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2002000ZKYo7ooonGR[ajK:ZcanRYKZ38`mnCQKYKAY>ISkh2N6F^00A2
9hF_YL[ooolc@jD2002000X00H3oool00h7oool0187oool01X;oool11h81
2884oooo0P4<Q00:oooo0@j50Pn5oooo0Q250Q660Q:6oooo0Q>60QB70P8E
Q`060aJ80aN8oooo0aR80aV9oooo0P<KR@080ab:0af:11j:oooo11n;122;
126;12:<1?ooo`031BF=1BJ=oooo0085:8h01Oooo`DZS`D[Soooo`D/S`05
oooo0PHaT@061S:B1S>B1SBB1cBB1cFC1cJC0PLgT`071cRD1cVD1cZD1cZD
1c^E23bE23fE0088?YH01PPoUPQ0UPQ1U`Q1U`Q2U`Q3U`89A9P01PU5V0U6
V@U7V@U7V@U8V@U9VP89BYX01PY;VPY<V`Y=V`Y=V`Y>V`Y?W08:D9`01PYA
W@YBW@]CW@]CW@]DWP]EWP8;EYh01`]GW`]HW`]IW`]IW`aJX0aKX0aLX002
35fQ00H<GZ4<Gj4<H:8<H:8=HJ8=HZ823F>S00H=I:<=IJ@=IZ@=IZ@=Ij@=
J:D23VVU00H>JZD>JjH>K:H>K:H>KJH>KZL23VnW00H?L:P?LJP?LZP?LZP?
LjT?M:T23gFY00<?MZX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/
47n]4Gn]4H2]4H6]0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`
4XZa4X^a4X^a4Xbb4Xfb4Xjb4hjb4hnc4i2c0Q>A/`074i:d4i>d4iBd4iBd
4iFe59Je59Ne008DV;H01QBI]QBJ]QBK]aBK]aBL]aBM]`8EW[P01QFO^1FP
^AFQ^AFQ^AFR^AFS^P8EY;X01QJU^QJV^aJW^aJW^aJX^aJY_08FZ[`01QJ[
_AJ/_AN]_AN]_AN^_QN__P8G/;h00aNa_aNb_aNc_`026;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028
`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8`;P4000018S0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008000i^W
lOooooooo`02oooo00[o[K3oMW_icMCmkNkooonVVlB5M[2l^=gooolc@jD3
002000X00H3oool00h7oool0187oool01X;oool11h8128820@V300L12X?o
ool138@138Coool13XD23hD00_ooo`050Q660Q:6oooo0Q>60QB700825HL0
1@<FR0<GR?ooo`<HR0<IR@04oooo00H37HX47X[oooooool488/48H/212:<
00D48h`498coool59Hd59Xd00_ooo`071BR>oooooooo1B^?oooo1Bb?oooo
0086;Y002PH_T?ooo`HaT@HaT@HbTPHcTPHdTPLdTPLeT`LfT`87=i<01`Lh
U0LiU0LjU0LjU0LkU@PlU@PmU@0223jF00H8?iH8@9H8@IL8@IL8@YL8@iL2
2DBH00H9AIP9AYT9AiT9AiT9B9T9BIX22DZJ00H:BiX:C9/:CI/:CI/:CY/:
Ci`22U2L00H:DId:DYd;Did;Did;E9h;EIh22eJN00L;Eil;F9l;FIl;FIl<
FZ0<Fj0<G:000PaMX@0635jQ35nQ362R362R3F6R3F:R0PeSX`063FBS3FFT
3FJT3FJT3FNT3FRU0PiYY@063VZU3V^V3VbV3VbV3VfV3VjW0Pi_Y`063g2X
3g6X3g:X3g:X3g>Y3gBY0PmeZ@033gJZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l
[11l[11m[11n[11o[A5o[A60[A61[@8APZh01Q63[Q64[a65[a65[a66[a:7
/08BR;002Q:9/1::/A:;/A:;/A:</Q:=/Q:>/Q>>/Q>?/a>@/`8CTK<01a>B
]1>C]1>D]1>D]1>E]ABF]ABG]@0259Rf00HDVKHDV[HDVkLDVkLDW;LDWKL2
5Ijh00HEWkPEX;TEXKTEXKTEX[TEXkX25JBj00HFYKXFY[/FYk/FYk/FZ;/F
ZK`25ZZl00HFZkdF[;dG[KdG[KdG[[hG[kh25k2n00<G/KlG/[lG/kl00QRd
`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P0
1HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^004R<2h0P00
00F8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3002000ZQ[?;icMCR9Scd]KoR9ScdKGglhnWoooomkNko[K02oooo00<c
@jD0080008000P00P00:0060oooo00>1oooo00B1oooo00J2oooo0@N20@R2
0oooo`030@^40@b4oooo00;oool00`8?QOooo`8@Q@02oooo00<24XH24hH2
58L00P8EQ`060aJ80aN8oooo0aR80aV9oooo0P<KR@080ab:0af:11j:oooo
11n;oooo126;12:<0oooo`0512F=1BF=1BJ=oooo1BR>00;oool01@DZSooo
o`D[S`D/S`H]T003oooo00T6<946<I46<I46<Y86<i86=987=987=I<7=Y<0
0PLgT`071cRD1cVD1cZD1cZD1c^E23bE23fE0088?YH01PPoUPQ0UPQ1U`Q1
U`Q2U`Q3U`89A9P01PU5V0U6V@U7V@U7V@U8V@U9VP89BYX01PY;VPY<V`Y=
V`Y=V`Y>V`Y?W08:D9`01PYAW@YBW@]CW@]CW@]DWP]EWP8;EYh01`]GW`]H
W`]IW`]IW`aJX0aKX0aLX00235fQ00H<GZ4<Gj4<H:8<H:8=HJ8=HZ823F>S
00H=I:<=IJ@=IZ@=IZ@=Ij@=J:D23VVU00H>JZD>JjH>K:H>K:H>KJH>KZL2
3VnW00H?L:P?LJP?LZP?LZP?LjT?M:T23gFY00<?MZX?MjX@N:X00Q1iZ`0:
47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6]0Q62[P064H>^4HB_4HF_
4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xbb4Xfb4Xjb4hjb4hnc4i2c
0Q>A/`074i:d4i>d4iBd4iBd4iFe59Je59Ne008DV;H01QBI]QBJ]QBK]aBK
]aBL]aBM]`8EW[P01QFO^1FP^AFQ^AFQ^AFR^AFS^P8EY;X01QJU^QJV^aJW
^aJW^aJX^aJY_08FZ[`01QJ[_AJ/_AN]_AN]_AN^_QN__P8G/;h00aNa_aNb
_aNc_`026;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`00
08S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h
00>8`;P4000018S0^004B92800006;C06;C00XS0^058T8P10000000018S0
^<SPf8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_ARK_omoon]
/?cSjOoooc=3Y@05002000H00H3oooooool00h4018401H42oooo00H11h81
28812H<12H<12X<12h@20@b400Koool13XD23hGoool248D24HH20Q:600X2
4hH258L25HL25HL35XP35hSoool368P36HWoool20a^900<378X37HX47XX0
0P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN=0PDXSP061BV>
1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:B1S>B1SBB1cBB
1cFC1cJC0PLgT`071cRD1cVD1cZD1cZD1c^E23bE23fE0088?YH01PPoUPQ0
UPQ1U`Q1U`Q2U`Q3U`89A9P01PU5V0U6V@U7V@U7V@U8V@U9VP89BYX01PY;
VPY<V`Y=V`Y=V`Y>V`Y?W08:D9`01PYAW@YBW@]CW@]CW@]DWP]EWP8;EYh0
1`]GW`]HW`]IW`]IW`aJX0aKX0aLX00235fQ00H<GZ4<Gj4<H:8<H:8=HJ8=
HZ823F>S00H=I:<=IJ@=IZ@=IZ@=Ij@=J:D23VVU00H>JZD>JjH>K:H>K:H>
KJH>KZL23VnW00H?L:P?LJP?LZP?LZP?LjT?M:T23gFY00<?MZX?MjX@N:X0
0Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6]0Q62[P064H>^
4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xbb4Xfb4Xjb4hjb
4hnc4i2c0Q>A/`074i:d4i>d4iBd4iBd4iFe59Je59Ne008DV;H01QBI]QBJ
]QBK]aBK]aBL]aBM]`8EW[P01QFO^1FP^AFQ^AFQ^AFR^AFS^P8EY;X01QJU
^QJV^aJW^aJW^aJX^aJY_08FZ[`01QJ[_AJ/_AN]_AN]_AN^_QN__P8G/;h0
0aNa_aNb_aNc_`026;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8
`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3H
R<2hR<2h00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOam/S<hRHl00;o[K00
1mlT;_nTW_JlaOn]/>ikS?oooc=3Y@06002000H00H3oooooool00h401840
1H42oooo00H11h8128812H<12H<12X<12h@20@b400Koool13XD23hGoool2
48D24HH20Q:600X24hH258L25HL25HL35XP35hSoool368P36HWoool20a^9
00<378X37HX47XX00P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=
1BN=0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A
1S:B1S>B1SBB1cBB1cFC1cJC0PLgT`071cRD1cVD1cZD1cZD1c^E23bE23fE
0088?YH01PPoUPQ0UPQ1U`Q1U`Q2U`Q3U`89A9P01PU5V0U6V@U7V@U7V@U8
V@U9VP89BYX01PY;VPY<V`Y=V`Y=V`Y>V`Y?W08:D9`01PYAW@YBW@]CW@]C
W@]DWP]EWP8;EYh01`]GW`]HW`]IW`]IW`aJX0aKX0aLX00235fQ00H<GZ4<
Gj4<H:8<H:8=HJ8=HZ823F>S00H=I:<=IJ@=IZ@=IZ@=Ij@=J:D23VVU00H>
JZD>JjH>K:H>K:H>KJH>KZL23VnW00H?L:P?LJP?LZP?LZP?LjT?M:T23gFY
00<?MZX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]
4H6]0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a
4Xbb4Xfb4Xjb4hjb4hnc4i2c0Q>A/`074i:d4i>d4iBd4iBd4iFe59Je59Ne
008DV;H01QBI]QBJ]QBK]aBK]aBL]aBM]`8EW[P01QFO^1FP^AFQ^AFQ^AFR
^AFS^P8EY;X01QJU^QJV^aJW^aJW^aJX^aJY_08FZ[`01QJ[_AJ/_AN]_AN]
_AN^_QN__P8G/;h00aNa_aNb_aNc_`026;C000?8h=R8`;R8`;P02hS0^003
B9280000b>3H00:8`;P900000XS0^005B92800006;C06;C0b>3H00>8`;P2
000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0P00P003VjOanLgDmhVG00;oool01on]/>4F=?mfNonT
W^8V??n9Oc=3Y@06002000X00H3oool00h400h4018401H401X;oool11h81
28820@V300X12X<12h@138@138@13H@13XD23hGoool248D24HH20Q:600T2
4hH258L25HL25HL35XP35hSoool368P36HT01Oooo`0511j:11n;11n;122;
126;00848X`01P@SS0@TS0@US@DUS@DVS@DWS@85:8h01PDYSPDZS`D[S`D[
S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@HbTPHcTPHdTPLdTPLeT`LfT`87
=i<01`LhU0LiU0LjU0LjU0LkU@PlU@PmU@0223jF00H8?iH8@9H8@IL8@IL8
@YL8@iL22DBH00H9AIP9AYT9AiT9AiT9B9T9BIX22DZJ00H:BiX:C9/:CI/:
CI/:CY/:Ci`22U2L00H:DId:DYd;Did;Did;E9h;EIh22eJN00L;Eil;F9l;
FIl;FIl<FZ0<Fj0<G:000PaMX@0635jQ35nQ362R362R3F6R3F:R0PeSX`06
3FBS3FFT3FJT3FJT3FNT3FRU0PiYY@063VZU3V^V3VbV3VbV3VfV3VjW0Pi_
Y`063g2X3g6X3g:X3g:X3g>Y3gBY0PmeZ@033gJZ3gNZ47RZ008@NJ/02Q1j
Za1kZa1l[11l[11m[11n[11o[A5o[A60[A61[@8APZh01Q63[Q64[a65[a65
[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</Q:=/Q:>/Q>>/Q>?/a>@/`8C
TK<01a>B]1>C]1>D]1>D]1>E]ABF]ABG]@0259Rf00HDVKHDV[HDVkLDVkLD
W;LDWKL25Ijh00HEWkPEX;TEXKTEXKTEX[TEXkX25JBj00HFYKXFY[/FYk/F
Yk/FZ;/FZK`25ZZl00HFZkdF[;dG[KdG[KdG[[hG[kh25k2n00<G/KlG/[lG
/kl00QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h2@0000:8
`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P007VjOaoooolj2^m69^oooomhVG
nLgD00;oool00o>P[_oooc=3Y@06002000H00H000X000h400h4018401H42
00J200H11h8128812H<12H<12X<12h@20@b400H13H@13XD23hD23hD248D2
4HH20Q:600H24hH258L25HL25HL35XP35hP20aR800L36HT36XT36hT36hT3
78X37HX47XX00P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN=
0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:B
1S>B1SBB1cBB1cFC1cJC0PLgT`071cRD1cVD1cZD1cZD1c^E23bE23fE0088
?YH01PPoUPQ0UPQ1U`Q1U`Q2U`Q3U`89A9P01PU5V0U6V@U7V@U7V@U8V@U9
VP89BYX01PY;VPY<V`Y=V`Y=V`Y>V`Y?W08:D9`01PYAW@YBW@]CW@]CW@]D
WP]EWP8;EYh01`]GW`]HW`]IW`]IW`aJX0aKX0aLX00235fQ00H<GZ4<Gj4<
H:8<H:8=HJ8=HZ823F>S00H=I:<=IJ@=IZ@=IZ@=Ij@=J:D23VVU00H>JZD>
JjH>K:H>K:H>KJH>KZL23VnW00H?L:P?LJP?LZP?LZP?LjT?M:T23gFY00<?
MZX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6]
0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xbb
4Xfb4Xjb4hjb4hnc4i2c0Q>A/`074i:d4i>d4iBd4iBd4iFe59Je59Ne008D
V;H01QBI]QBJ]QBK]aBK]aBL]aBM]`8EW[P01QFO^1FP^AFQ^AFQ^AFR^AFS
^P8EY;X01QJU^QJV^aJW^aJW^aJX^aJY_08FZ[`01QJ[_AJ/_AN]_AN]_AN^
_QN__P8G/;h00aNa_aNb_aNc_`026;C000?8h=R8`;R8`;P02hS0^003B928
0000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00;VjOaooooohUo
oooolj2^lI>Qoooooogolj2^oo_l<d>U00H008001P01P002P003P@03P@04
P@05P@801X801P47PP48PP49P`49P`4:P`4;Q08138@01P4=Q04>Q@8?Q@8?
Q@8@Q@8AQP824XH01P8CQP8DQ`8EQ`8EQ`<FR0<GR08368P01`<IR@<JR@<K
R@<KR@<LRP<MRP@NRP0211n;00X488/48H/48X`48X`48h`498`49Hd59Hd5
9Xd59hd21BR>00H5:Hh5:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46
<I46<Y86<i86=987=987=I<7=Y<21cNC00L7>9@7>I@7>Y@7>Y@7>iD8?9D8
?ID00PPnUP0623nF242F246G246G24:G24>G0PU4V0062DFH2DJI2DNI2DNI
2DRI2DVJ0PU:VP062T^J2TbK2TfK2TfK2TjK2TnL0PY@W0062U6M2U:M2e>M
2e>M2eBN2eFN0P]FWP072eNO2eRO2eVO2eVO35ZP35^P35bP008<GJ401PaN
X@aOX@aPXPaPXPeQXPeRXP8=Hj<01PeTX`eUY0eVY0eVY0eWY0eXY@8>JJD0
1PiZY@i[YPi/YPi/YPi]YPi^Y`8>KjL01Pm`Z0maZ0mbZ0mbZ0mcZ@mdZ@8?
MJT00`mfZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdA
P:dAPJd24H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4B
Rk4BS;8BSK8BS[8CS[8CSk<CT;<24i6c00LCT[@CTk@CU;@CU;@CUKDDU[DD
UkD00QBH]P0659Vf59Zf59^g59^g59bg59fg0QFN^0065Inh5J2i5J6i5J6i
5J:i5J>j0QFT^P065ZFj5ZJk5ZNk5ZNk5ZRk5ZVl0QJZ_0065Z^m5Zbm5jfm
5jfm5jjn5jnn0QN`_P035k6o5k:o5k>o008H]<0?b>3H00<00038h=S8h=P0
3LSPf00300006;C06;C000o8h=P00`0001Rd`1Rd`002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1000P0>KYo401_oooo>P[_Be_oJlaO_IfS=3Y@L0
08001P01P002P003P@03P@04P@05P@801X801P47PP48PP49P`49P`4:P`4;
Q08138@01P4=Q04>Q@8?Q@8?Q@8@Q@8AQP824XH01P8CQP8DQ`8EQ`8EQ`<F
R0<GR08368P01`<IR@<JR@<KR@<KR@<LRP<MRP@NRP0211n;00X488/48H/4
8X`48X`48h`498`49Hd59Hd59Xd59hd21BR>00H5:Hh5:Xl5:hl5:hl5;8l6
;I021Rj@00X6;i06<946<I46<I46<Y86<i86=987=987=I<7=Y<21cNC00L7
>9@7>I@7>Y@7>Y@7>iD8?9D8?ID00PPnUP0623nF242F246G246G24:G24>G
0PU4V0062DFH2DJI2DNI2DNI2DRI2DVJ0PU:VP062T^J2TbK2TfK2TfK2TjK
2TnL0PY@W0062U6M2U:M2e>M2e>M2eBN2eFN0P]FWP072eNO2eRO2eVO2eVO
35ZP35^P35bP008<GJ401PaNX@aOX@aPXPaPXPeQXPeRXP8=Hj<01PeTX`eU
Y0eVY0eVY0eWY0eXY@8>JJD01PiZY@i[YPi/YPi/YPi]YPi^Y`8>KjL01Pm`
Z0maZ0mbZ0mbZ0mcZ@mdZ@8?MJT00`mfZPmgZQ1hZP0247V[00X@NZ/@Nj/@
O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJd24H:^00HAPjhAQ:lAQJlAQJlAQZlB
Qk024XR`00XBRK0BR[4BRk4BRk4BS;8BSK8BS[8CS[8CSk<CT;<24i6c00LC
T[@CTk@CU;@CU;@CUKDDU[DDUkD00QBH]P0659Vf59Zf59^g59^g59bg59fg
0QFN^0065Inh5J2i5J6i5J6i5J:i5J>j0QFT^P065ZFj5ZJk5ZNk5ZNk5ZRk
5ZVl0QJZ_0065Z^m5Zbm5jfm5jfm5jjn5jnn0QN`_P035k6o5k:o5k>o03HH
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h5000P006006000:000>1
00>100B100F10P06PP060@N20@R20@V30@V30@Z30@^40P4<Q0060@f40@j5
0Pn50Pn50Q250Q660P8BQP060Q>60QB70QF70QF70aJ80aN80P<HR0070aV9
0aZ90a^90a^90ab:0af:11j:00847h/02P@PR`@QR`@RS0@RS0@SS0@TS0@U
S@DUS@DVS@DWS@85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`
T@HaT@HaT@HbTPHcTPHdTPLdTPLeT`LfT`87=i<01`LhU0LiU0LjU0LjU0Lk
U@PlU@PmU@0223jF00H8?iH8@9H8@IL8@IL8@YL8@iL22DBH00H9AIP9AYT9
AiT9AiT9B9T9BIX22DZJ00H:BiX:C9/:CI/:CI/:CY/:Ci`22U2L00H:DId:
DYd;Did;Did;E9h;EIh22eJN00L;Eil;F9l;FIl;FIl<FZ0<Fj0<G:000PaM
X@0635jQ35nQ362R362R3F6R3F:R0PeSX`063FBS3FFT3FJT3FJT3FNT3FRU
0PiYY@063VZU3V^V3VbV3VbV3VfV3VjW0Pi_Y`063g2X3g6X3g:X3g:X3g>Y
3gBY0PmeZ@033gJZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m[11n[11o
[A5o[A60[A61[@8APZh01Q63[Q64[a65[a65[a66[a:7/08BR;002Q:9/1::
/A:;/A:;/A:</Q:=/Q:>/Q>>/Q>?/a>@/`8CTK<01a>B]1>C]1>D]1>D]1>E
]ABF]ABG]@0259Rf00HDVKHDV[HDVkLDVkLDW;LDWKL25Ijh00HEWkPEX;TE
XKTEXKTEX[TEXkX25JBj00HFYKXFY[/FYk/FYk/FZ;/FZK`25ZZl00HFZkdF
[;dG[KdG[KdG[[hG[kh25k2n00<G/KlG/[lG/kl0=QRd`0:8`;P1B9280@00
000000>8`;S8h=R8`;P0ohS0^3Z8`;P1B9280@00000000>8`;S8h=R8`;P0
ohS0^3Z8`;P1B9280@00000000>8`;S8h=S8h=P0olSPf3[8h=P1B9280@00
0000ohS0^3j8`;P100000000\
\>"], "Graphics",
  ImageSize->{318, 185},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004/0000b2000`400?l0
0000o`00003oooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000
ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`
l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]
oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`
l?0]oo3`l000ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00<oooool00ooQhN7oOWinooShn03f
ooooo`00<oooool00ookno_o7AdMojFUY@3fooooo`003?ooool00oo/k>co
kno_ooooo`03ooooo`05oo7alOoinOWoo_knonGUiOono_h01Oooool00oo/
k>cokno_ooooo`06ooooo`03on?ShooFe]Koo_kn00Gooooo00?ok>c/ono_
koooool01?ooool00on;Rh_o?Shnooooo`05ooooo`03onc/k?o_knoooooo
00Gooooo00?oiNGUoogmoOooool00_ooool00oodm?Coj>SXooooo`3Poooo
o`000_ooool03_lf=SKoMgMgoooooooooooom_KfobHV9_m6ATKoo_knom_K
fole=CGo3Ph>o``<3?li>CWog=cL0_ooool01_m0@43oFEUIobHV9_lK6a_o
5ADEokbl_0;ooooo00Kofm_KocDe=Ol>3Pko30`<ocTi>OoLg=`3ooooo`0>
oijNW_lC4a?o2@T9obLW9olK6a_oC4a<omWIfOoooooofm_KocDe=Ol>3Pko
30`<ocTi>OoLg=`3ooooo`03oi:BT_l0003oemOG00?ooooo00Kofm_KocDe
=Ol>3Pko30`<ocTi>OoLg=`2ooooo`0;om?CdolU9BGo7QhNokZj^_oooooo
inOWodY:B_l30`?o8b<SoaLG5oo1`L40goooool000;ooooo00[o=SHfogMg
Moooooooooooog1`L?lD51CoinOWookno_ld=3CoDU9B0_o^k^h03_mEEEGo
=CDeookno_oooooo@410od=3@oo_knoono_kogemOOlC4a?olo?cookno_ld
=3CoDU9B0_o^k^h03omEEEGo=CDeookno_ooooooV9RHo`<30on;Rh_oo?cl
ooooooomoOgo/[:bomSHf?ono_ko=3@doe9BDP02onk^kP03oeEEEOle=CGo
o_kn00;ooooo00?o;bl_o`T92OmaLG400_ooool00oono_ko=3@doe9BDP02
onk^kP07oeEEEOle=CGoo_knoooooomaLG7o@D51ooknoP02ooooo`06odA4
A?m0@43ogmoOoooooooclo?ol_;bgoooool000;ooooo00[o=SHfogMgMooo
oooo`/;2o`820_na/K7oooooomSHf?l0003o]kNg0_ooool01_ng]kOo0000
omcLg?oooooo@410ogmoO`;ooooo00KoinOWo`000?n][Jgof=SHo`000?ng
]kL2ooooo`06okNg]ol0003og=cLooShn?lD51CoHf=S1_ooool00ooHf=So
0000okNg]`02ooooo`0=okNg]ol0003og=cLooooooo<c<co0@41oinOWolC
4a?on?ShoooooooHf=So0000okNg]`02ooooo`06okNg]ol0003og=cLoooo
oom=CDgoLW9b0_ooool00ooMgMgo0000okRh^03Sooooo`000_ooool01Olf
=SKoM7Adono_kolS8b?oJ6QX00;ooooo00?o_[jno`000?oVi^H00_ooool0
1_oTi>Co0000ol71`Ooooooo@410ogmoO`?ooooo00Go5QHFoi6ATOnn_[ko
0000onKViP02ooooo`06onCTi?l0003o`L71omCDe?l0003o`/;21_ooool0
0onn_[ko0000onKViP02ooooo`0=onCTi?l0003o`L71oooooomYJFWo@D51
oooooolX:2SoY:BToooooonn_[ko0000onKViP02ooooo`06onCTi?l0003o
`L71oooooom=CDgoLW9b0_ooool00onn_[ko0000ocdm?@03oclo?`03olC4
a?oooooooooo0=gooooo0002ooooo`05ocHf=_l30`?o0000o`000?o1`L40
0_ooool00ooLg=co0000okBd]002ooooo`06ok:b/_l0003oh>3Poooooom0
@43oNWYj0_ooool01_o]kNgo0000ol?3`ooLg=co0000okBd]0;ooooo00Ko
/[:bo`000?oPh>3o/k>co`000?oRh^86ooooo`03omcLg?l0003o];Bd00;o
oooo00go/[:bo`000?oPh>3om_Kfo`l?3onRXZ;ooooooi2@T?ln?Skooooo
omcLg?l0003o];Bd00;ooooo00Ko/[:bo`000?oPh>3oooooode=COmbLW82
ooooo`07om_Kfol0003oZj^[olo?coo7alOo0`<3onGUi@3Oooooo`000_oo
ool01_lf=SKoMgMgon?ShonJVY[o20P8okVi^@;ooooo00Ko@D51odQ8B?oN
g]kogMgModM7Aom4A4@2ooooo`0Bod10@?lK6a_oUiNGomcLg?mYJFWo4A4A
ooclo?oooooo@D51odQ8B?oNg]kogMgModM7Aom4A4CoooooolO7aol0003o
d];B1oooool08Om1@D7oB4Q8omkNg_oMgMgoAdM7odA4A?ooooooXj>So`h>
3_oemOGoooooonk^k_l92@WoemOGoooooom1@D7oB4Q8omkNg_oMgMgoAdM7
odA4A?oooooonOWiodU9BOm]KFgom?Cdoo_knooooooo?cloof][JoogmoOo
WYjNob/[:`3Pooooo`000_ooool01_lf=SKoMgMgooooooooooooBDU9oe=C
D`;ooooo00Koj>SXoe9BD_l?3`oo3`l?oeADE?oYjNT2ooooo`06od10@?ml
O7coIFEUo`d=3OlI6AWoZ:RX0_ooool02_oXj>SoDU9Bo`l?3ol?3`ooE5AD
onWYjOooooookNg]o`820_nMWId7ooooo`09onSXj?mBDU;o3`l?o`l?3omD
E5CojNWYoooooomJFU[oLG5a00?ooooo00GoK6a/ohF5QOooooooj>SXoe9B
DP02o`l?3`0>oeADE?oYjNWoooooogmoOol820So30`<oa/K6on^[Zkooooo
onKVi_m7AdOo3@d=oa`L7?ng]kOPooooo`000_ooool01_lf=SKoMgMgoooo
oooooooo=CDeoeEEE@Cooooo0_ono_h4ooooo`04od10@?moOgoooooooogm
o@Kooooo0_ono_h4ooooo`03of=SHolU9BGokNg]00Sooooo0_ono_h=oooo
o`;oo_kn1?ooool00om=CDgoLW9booooo`04ooooo`03ooclo?oooooooooo
0>3ooooo0002ooooo`06ocHf=_l_;booFUYJob<S8ol<30co`l?32_ooool0
0om0@43oOgmoooooo`0=ooooo`08on_[jom1@D7o7QhNog]kNonGUiOoM7Ad
oc0`<?nn_[hHooooo`03on3Ph?oNg]kooooo0>Oooooo0002ooooo`05ok2`
/?nJVY[oVYZJok^k^ooinOT02oooool00om0@43oOgmoooooo`0>ooooo`07
ookno_nb/[;oP820ofUYJOn9RHWo[Jf]oo3`l03oooooo`?ooooo000Boooo
o`03oo_knoomoOgooooo0?oooooo6?ooool00?oooooo;Oooool00?oooooo
;Oooool00?oooooo;Oooool00?oooooo;Oooool003Wooooo00Go`<30oh>3
PomQHF7oNGUiolk>cP3^ooooo`00>Oooool01_n9RHWoMWIfojFUYOmSHf?o
2`/;okbl_>gooooo000<ooooo`03onc/k?o_knoooooo00?ooooo00GolO7a
ooWinOono_koiNGUooknoP05ooooo`03onc/k?o_knoooooo00cooooo00?o
k>c/oogmoOooool00_odm?@=ooooo`03oeYJF_m7AdOooooo00;ooooo00?o
k>c/oogmoOooool00_odm?@8ooooo`03onc/k?o_knoooooo00Gooooo00?o
k>c/ono_koooool0d_ooool000;ooooo00ko=SHfogMgMoooooooooooooKf
m_lV9RKoATI6ookno_oKfm_o=CDeo`h>3_l<30co>CTiomcLg0;ooooo00Ko
@410oeUIFOlV9RKo6a/KoaDE5Onl_;`2ooooo`06om_Kfole=CGo3Ph>o``<
3?li>CWog=cL0_ooool04Olf=SKoRHV9oooooooooooolo?cobl_;olh>3So
m_Kfoe5ADOl820So6QXJoibLW?lC4a?oEeMGoooooom0@43oOgmo00;ooooo
00[oXj>Soa`L7?ooooooooooonOWiomMGEgo>CTiogYjN_nMWIgo7QhN0_oo
ool02OmADE7o20P8oaXJ6_nLW9co4a<CoeMGEooooooo@410ogmoO`03oooo
o`06om_Kfole=CGo3Ph>o``<3?li>CWog=cL0_ooool01_oKfm_o=CDeo`h>
3_l<30co>CTiomcLg=7ooooo0002ooooo`0:ocHf=_mgMgOooooooooooom`
L73o51@DonOWioono_ko=3@doe9BDP;ok^k^00koEEEEocDe=Oono_kooooo
od10@?m3@d?okno_oo_knommOGgo4a<Coo?cloono_ko=3@doe9BDP;ok^k^
017oEEEEocDe=Oono_koooooocHf=_n9RHWoooooooclo?m:BT[o9BDUon_[
joo6a/Ko10@4omgMgOoVi^KoFe]Koa4A4@02ooooo`06od10@?moOgoooooo
oooooonSXj?o71`L0_ooool03Om=CDgo;Rh^oj:RX_mlO7co;Bd]oa@D5?oo
ooooa/K6o`@41?oMgMgoi^KVoe]KFolA4A400_ooool01om0@43oOgmooooo
ooooooooo_knoc@d=?mBDU800_o^k^h01_mEEEGo=CDeookno_ono_ko=3@d
oe9BDP;ok^k^00?oEEEEocDe=Oono_h0d?ooool000;ooooo00[o=SHfogMg
Mooooooo`/;2o`820_na/K7oooooomSHf?l0003o]kNg0_ooool01_ng]kOo
0000omcLg?oooooo@410ogmoO`;ooooo00KoinOWo`000?n][Jgof=SHo`00
0?ng]kL2ooooo`0AokNg]ol0003og=cLoooooolf=SKoRHV9oooooomYJFWo
5QHFomcLg?oooooofMWIo`<30onm_KgooooooinOWolP82000_ooool02_m0
@43oOgmoooooooooooooXj>Soa`L7?oooooom_Kfo`T92Oni^KT2ooooo`09
oiJFU_lA4A7oooooomWIfOl30`?o_KfmoooooonOWioo820P00;ooooo00Oo
@410ogmoOoooooooooooomSHf?l0003o]kNg00;ooooo00Ko]kNgo`000?oL
g=cof=SHo`000?ng]kL2ooooo`03okNg]ol0003og=cL0=3ooooo0002oooo
o`05ocHf=_mdM7Cokno_ob<S8omXJ6P00_ooool00onn_[ko0000onKViP02
ooooo`06onCTi?l0003o`L71oooooom0@43oOgmo0oooool01OlF5QKoTI6A
okjn__l0003oi^KV00;ooooo00Woi>CTo`000?o1`L7oooooocHf=_n9RHWo
S8b<o`X:2_o9bLT00oooool01On][Jgo<S8boc<c<olf=SKo820P00;ooooo
00[o@410ogmoOooooooooooooj>SXolL71cooooool;2`_l0003oi^KV0_oo
ool02On/[:co4A4Aoooooooooooo[Jf]oc8b<_lc<c?o=SHfob0P8002oooo
o`07od10@?moOgoooooooooooonn_[ko0000onKViP02ooooo`06onCTi?l0
003o`L71okjn__l0003oi^KV0_ooool00ooTi>Co0000ol71`@3@ooooo`00
0_ooool01Olf=SKo0`<3o`000?l0003o`L7100;ooooo00?og=cLo`000?nd
];@00_ooool01_nb/[;o0000on3Ph?oooooo@410ogYjNP;ooooo00KokNg]
o`000?o3`l?og=cLo`000?nd];@2ooooo`08ok:b/_l0003oh>3Poooooolf
=SKo@d=3o`<30onc/k<6ooooo`03oogmoOnDU9Co8B4Q00;ooooo00[o@410
oeeMGOoooooooooooifMWOlM7Agoooooom[Jf_l0003o]KFe0_ooool00on/
[:co4A4Aooooo`03ooooo`03oogmoOnDU9Co8B4Q00;ooooo00Oo@410ofUY
JOooooooooooomcLg?l0003o];Bd00;ooooo00Ko/[:bo`000?oPh>3og=cL
o`000?nd];@2ooooo`03ok:b/_l0003oh>3P0=3ooooo0002ooooo`06ocHf
=_mgMgOohn?SoiZJV_l820So^KVi0_ooool01_m1@D7oB4Q8omkNg_oMgMgo
AdM7odA4A0;ooooo00ko@410oa/K6onGUiOog=cLofUYJOlA4A7oo?cloooo
oom1@D7oB4Q8omkNg_oMgMgoAdM7odA4A0;ooooo00Co=SHfogIfM_lR8R;o
V9RH1?ooool01Ond];Cof][Jooclo?mQHF7oE5AD00;ooooo00Ko@410oa@D
5?mfMWKog]kNoeMGEom=CDd2ooooo`06oc/k>om6ATKoh^;Roo7alOmFEUKo
4A4A0_ooool01Ond];Cof][Jooclo?mQHF7oE5AD00;ooooo00_o@410oa<C
4onATI7oi>CToogmoOm1@D7oB4Q8omkNg_oMgMgoAdM7odA4A002ooooo`06
od51@Om8B4Sog]kNomgMgOm7AdOoA4A4dOooool000;ooooo00Ko=SHfogMg
MoooooooooooodU9BOmCDe<2ooooo`06onSXj?mBDU;o3`l?o`l?3omDE5Co
jNWY0_ooool01_m0@43oO7alofEUIOl=3@go6ATIojRXZ0;ooooo00Koj>SX
oe9BD_l?3`oo3`l?oeADE?oYjNT2ooooo`05ocHf=_n9RHWoe=CDoa8B4_o0
`<000oooool01On:RX[o<S8boa0@4?li>CWoa<C400;ooooo00KoE5ADohb<
S?miNGWo51@Dobh^;_o4a<@2ooooo`06on?Shom4A4Co2`/;obTY:OmfMWKo
:RXZ0_ooool01On:RX[o<S8boa0@4?li>CWoa<C400;ooooo00OoE5ADohV9
ROmMGEgo2@T9oo3`l?oXj>SoDU9B00;o3`l?00KoE5ADonWYjOoooooooooo
onSXj?mBDU82o`l?3`03oeADE?oYjNWooooo0=3ooooo0002ooooo`06ocHf
=_mgMgOooooooooooole=CGoEEEE1?ooool2ooknoPCooooo00Co@410ogmo
OooooooooOgm1_ooool2ooknoPCooooo00Ko=SHfohV9ROoooooo/[:boaHF
5_oOgml4ooooo`03oogmoOoooooooooo00Gooooo00?oo_knooooooooool0
1?ooool00oomoOgoooooooooo`05ooooo`03oogmoOoooooooooo00Gooooo
00Coo?cloooooooooooooooo0_ono_h6ooooo`;oo_kndoooool000;ooooo
00Ko=SHfobl_;omJFU[o8b<So``<3?o3`l<:ooooo`03od10@?moOgoooooo
00gooooo00Oo=SHfohV9ROooooooooooohN7Qol];Bgolo?c0?oooooo1?oo
ool000;ooooo00Go/;2`oiZJV_nJVY[o^k^kooWin@0;ooooo`03od10@?mo
Ogoooooo00gooooo00?o/;2`om7AdOooool00_ooool00onUYJGodm?Coooo
o`3oooooo`?ooooo000Booooo`03oo_knoomoOgooooo0?oooooo6?ooool0
0?oooooo;Oooool00?oooooo;Oooool00?oooooo;Oooool00?ooOZgI;Omn
[MT00003ogj]fOo2`/;o`/;20?oo`/;2:Oo2`/81ogj]f@0000?oOZgIol;2
`_o2`/80ooo2`/8Yol;2`P7oOZgI00000omn[MWo`/;2ol;2`P09ol;2`P03
ok>c/one]KGo`/;200?o`/;200Go]kNgokfm_Oo1`L7o[Zj^ol71`@05ol;2
`P03ok>c/one]KGo`/;200?o`/;200?o`<30ojNWYon^[Zh01_o2`/800oni
^KWo/;2`ol;2`P03ol;2`P03ok>c/oo0`<3o`/;200;o^KVimOo2`/81ogj]
f@0000CoOZgIol;2`_lY:BWoFUYJ0_o2`/802_nk^k_o71`LocDe=Oo1`L7o
YZJVobPX:?l:2P[o2@T9ob/[:onWYjL2ol;2`P06oc0`<?m3@d?o71`Loa@D
5?l?3`ooShn?0_o2`/803OnVYZKo:2PXo`X:2_l92@Wo:b/[ojNWYoo2`/;o
QHF5o`L71ol92@Wo6a/KobTY:OmoOgl00_o2`/804?n_[joo>3Pho`820_lJ
6Q[o4A4Aoi:BT_o2`/;o?Cdmo`H61_lC4a?oMWIfo`h>3_m2@T;o`/;2oc0`
<?mPH63bol;2`P7oOZgI00001?mn[MWo`/;2obTY:OmJFUX2ol;2`P06oeEE
EOl?3`oo[jn_ol71`OlW9bOo?Shn0_ne]KD03_m0@43o:2PXol71`Oo2`/;o
<30`oc8b<_ne]KGo_[jnoemOGol>3Pko^;Rhol71`OlW9bOo?Shn0_ne]KD0
3om0@43o:2PXol71`OnRXZ;oTI6Aokjn__o2`/;oMgMgo`<30onXZ:So`/;2
oc<c<ol`<33oZJVYol;2`P02okRh^006oiJFU_l30`?oZ:RXojj^[_m5ADGo
30`<0_o2`/800ol`<33oH61Pol;2`P3aol;2`P7oOZgI00003?mn[MWo`/;2
obTY:OmJFU[o`/;2oi>CTol10@7oQXJ6ol;2`_nTY:Co0000oh^;R`;o`/;2
00KoRh^;o`000?nWYjOo`/;2oc0`<?mPH602ol;2`P06ojn_[ol0003oPh>3
ojBTY?l0003oRh^;0_o2`/800on;Rh_o0000ojNWY`04ol;2`P06oj^[Zol0
003oRXZ:ojRXZ?l0003oRh^;1?o2`/801_nUYJGo0P82ohn?Soo2`/;oN7Qh
oaPH60;o`/;200?o<30`of1PH?o2`/80lOo2`/81ogj]f@0000OoOZgIol;2
`_lY:BWoF5QHokFe]OlJ6Q[oCdm?00;o`/;200?oT92@o`000?n^[Zh00_o2
`/801_n][Jgo0000oi:BT_o2`/;o<30`of1PH0?o`/;200Go410@ofi^K_n@
T93o0000ojj^[P02ol;2`P03ojf][Ol0003oTY:B00?o`/;200Oo][Jfoc`l
??l61PKo^;Rhoi2@T?l0003o;Rh^00?o;bl_00?oUIFEol;2`_n3Ph<00_lV
9RH01_lY:BWo61PHol;2`_o2`/;o<30`of1PH?;o`/;20Omn[MT00004ogj]
fOo2`/;o:BTYo`820P;o000000KoTY:Bol;2`_o2`/;oYjNWo`000?n8R8P2
ol;2`P06ohN7Qol0003oZZZZol;2`_l`<33oG5aL0_o2`/801_nd];Co0000
oiBDU?nWYjOo0000ohR8R0;o`/;200?oQhN7o`000?nZZZX00_o2`/803?n:
RX[o5ADEoa4A4On@T93o`/;2ojJVY_l0003oPX:2oifMWOnGUiOo0P82ojj^
[P?o`/;200?o`<30og1`L?lI6AT00_o2`/800ol`<33oH61Pol;2`P3aol;2
`P7oOZgI00002?mn[MWo`/;2obTY:OmJFU[o[:b/ogEeMOl61PKoS8b<0_o2
`/801_la<C7o=SHfojRXZ?nXZ:So=SHfoc<c<`;o`/;200[o<30`oa@D5?mb
LW;oYjNWodm?Col<30co_knool;2`_la<C7o=SHf0_nXZ:P02?lf=SKo<c<c
ol;2`_o2`/;oHV9Ro`000?m1@D7o[Zj^0oo2`/801Ol_;booDE5Aok^k^omh
N7So820P00;o`/;200GoR8R8ojFUYOno_kooBDU9oclo?`02ol;2`P03oc0`
<?mPH63o`/;20?7o`/;20Omn[MT00004ogj]fOo2`/;o:BTYoeYJFP;o`/;2
00Ko=cLgoclo?oo2`/;o`/;2ok2`/?ln?Sh2o`/;2`0:oclo?ona/K7o`/;2
ol;2`_l`<33oGUiNoda<C?l92@Wo4a<CogmoO`;o`/;200[o/;2`ochn?_l;
2`_o2`/;oclo?ona/K7o`/;2ojj^[_l10@7oKfm_1Oo2`/801On^[Zko=SHf
o`T92OlE5AGoRh^;00;o`/;200GoJ6QXobHV9_l<30co:b/[oiFEU@02ol;2
`P03oc0`<?mPH63o`/;20?7o`/;20Omn[MT00004ogj]fOo2`/;o:BTYoeYJ
FP;o`/;200?o:2PXod10@?o2`/800oo2`/82ol71`@Co`/;200Co<30`of1P
H?o2`/;o`<301_o2`/82ol71`@?o`/;200?oY:BTo`410On_[jl01oo2`/80
0ono_koo`/;2ol;2`P04ol;2`P03ol30`?o2`/;o`/;200;o`/;200?o<30`
of1PH?o2`/80lOo2`/81ogj]f@0000SoOZgIol;2`_lY:BWo8b<SodA4A?lJ
6Q[o2@T9oiBDU0[o`/;200?o<30`of1PH?o2`/803Oo2`/801Olh>3So;2`/
ofa/K?m:BT[o@T92013o`/;200?o<30`of1PH?o2`/80lOo2`/81ogj]f@00
00?oOZgIol;2`_n5QHD00_meMGD00on>SXko_Kfmol;2`P0:ol;2`P03oc0`
<?mPH63o`/;200go`/;200Go_[jnohZ:R_mCDe?oIfMWoi6AT@0@ol;2`P03
oc0`<?mPH63o`/;20?7o`/;20Omn[MT00003ogj]fOo2`/;o`/;200oo`/;2
00?o_[jnol30`?o2`/808_o2`/800onn_[ko`<30ol;2`P3aol;2`P7oOZgI
00000omn[MWo`/;2ol;2`P3ool;2`RWo`/;20Omn[MT00003ogj]fOo2`/;o
`/;20?oo`/;2:Oo2`/81ogj]f@00oomn[MT]ogj]f@00oomoOgl]ogmoO`00
00Cojn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP22omgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomgMg@;og=cL097ofm_KomgMgOoLg=cogMgMomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgM00?og]kN00?ogMgMomkNg_oNg]h00ooMgMd1on7Qh@7o
inOW0OoZj^X00003onc/k?oVi^Koh>3P00OofMWI00Cof=SHomKFe_oCdm?o
d=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?C
om3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?C
doo@d=03olg=c@04om3@d?oCdm?oemOGomSHf3cofMWI0_oHf=P00ooIfMWo
f=SHomSHf003omWIf@;of=SH1OoIfMT00ooHf=Soe]KFom?Cd`02om?Cd`03
omKFe_oHf=Sof=SH00kofMWI00Cof=SHomWIfOoIfMWof=SH4?oIfMT2omSH
f6SofMWI00?of=SHomWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007
onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=co
dm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09
on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7
aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:b
ojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`0]on7Qh@Soh>3P00?ogmoO
on3Ph?oOgml00_oPh>06omoOg`;oh>3P0ooOgml5on3Ph007omoOgooKfm_o
emOGomCDe?oEeMGofMWIomgMg@02on3Ph003omoOgooPh>3oh>3P00;ohN7Q
1ooPh>06omoOg`03on3Ph?oOgmooh>3P00_oh>3P00CogmoOomkNg_oNg]ko
gmoO0_oPh>1Won7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoTi>@1onWYj@7o
kNg]00000oo`l?3okno_oo7al@03oo3`l01Zono_koo`l?3ok^k^onWYjOoK
fm_o`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Z
j_o]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][J
ol;2`_nTY:CoS8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^So
kNg]oo7alOo_knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2
`/;oY:BTohb<S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]
kOoalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo3`
l0;ok>c/00Oojn_[onk^k?o/k>cokNg]onc/k?o^k^koj^[Z00;ojn_[00[o
k^k/onWYjOoXj>Soi^KVonWYjOoVi^Koj^[Zon_[joo]kN_oj>SX0_oYjNT0
1oo]kNgoj^[Zonc/k?o/k>cokno]on[Zj_oXj>P00_oShn<03OoOgmoohn?S
onSXj?o]kN_oj^[Zon_[joo/k>col?3`ono_koo`l?3okNg]onc/j_oZj^X0
0_o^k^h01_o_knooj^[ZonWYjOoVi^Koj>SVonOWi`;ojNWY00Kok>c/onWY
jOo/k>cokNg]onk^k?oZj^X2onc/k008onk^k_oZj^[ok>c/onc/k?o_kngo
jn_[onWYjOoVi^H2onSXj0;okNg]06gol?3^ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo`l?3okno_oo3`l?o_knool?3`ono_
koo`l?3okno_00Col?3`00000oobl_;ok^k^onOWi`04onGUi@0@onCTi?oO
gmoodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:
ROna/K7odM7AomkNgP;oi>CT00?oiNGUonCTi?oUiN@00_oTi>@03ooNg]ko
dM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na
/K7odM7@omkNgP02onCTi012onGUiOoTi>CoiNGUonCTi?oTi>?og]kNom7A
dOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6a
om7AdOoNg]koi>CSonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oShn?og]kN0_oKfm/02_oNg]gog=cLom_KfooKfm_ogmoOom_KfooI
fMWog=cLomgMg?oGemL3omGEe@04omCDe?oIfMWogMgMomgMg0;oemOG01;o
fm_KomgMgOoJf][of][JomkNg_oQhN3ofm_KomSHf?m6ATKo<30`ogQhN?o2
`/;of][JomkNgOoJf][ofMWIomgMgOoShn<2onCTi00FomoOgooLg=_ofMWI
omoOgooRh^;ohN7Qom_KfooFe]Koe=CDomKFeOoDe=Coe]KFom_KfooLg=co
f=SHomcLg?oOgmoogmoNomWIfOoKfm_og]kNomoOg`;of][J06oogMgMon3P
gooKfm_oemOGomGEeOoGemOofMWIomoOgooRh^;oi>CSonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>@01?oUiND01_oTi>Co
iNGUonGUiOoUiNGoj>SXong]k@7ol_;b00000oodm?CokNg]onOWi`02on3P
h00Con7QhOoOgmoog]kNom;Bd_nd];CoQhN7oeaLG?m]>cGoWTi2ole_GooY
PfoocFmOoii>@om]>cKoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomkN
g_oBd];o];BdohN7QomLG5coKF0/oijF;_o=cCoojNU=olg=?onNVRooKF<]
oeaLG?n7QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOo
G5aLodMW;_mXWS?oTLe7oj[YEOnAcDOoJYhdodUZ;omLG5coQhN7okBd]?oB
d];og]kN02_oh>3P04?og]kNomSHf?oBd];oe=CDomKFe_oBd];oclo?om;B
d_oFe]Kodm?Com7AdOoEeMGoe]KFom3@d?o4a<Cobl_;olo?coo9bLWoa<C4
omSHf?oEeMGod=3@olC4a?o@d=3of=SHom;Bd_oAdM7of=SHom_KfooFe]Ko
dM7AoiFEUOnPX:3o?Shnod];BooDe=Cof=SHom;Bd_oAdM7of=SHomkNg_oP
h>3ogmoOom[Jf_oCdm?odM7AomSHf?oMgMgof][Jom?Cdoo?cloo`<30om3@
d?o=cLgo_knoomCDe?oFe]KodM7AomCDe?oIfMWof=SHom7AdOoBd];of=SH
omWIfOoCdm?odM7A00;oemOG00SodM7Aolo?coo8b<Soa<C4omSHf?oKfm_o
g]kNomoOgfCoh>3P00?ogmoOon3Ph?oOgml00_oOgml3on3Ph003on7QhOoW
inOok>c/007om?Cd00000oofm_Kol_;bon_[j`03onSXj00ConOWiooRh^;o
cLg=oinOWom[GeooScH^oneaHOoiWI3ooK6Uoofl[oom]:OonInConedHonB
=booJemOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinO
Wom^IUooTg8RongAA?oilgCooOf=oogmUOomoHkonOQfongGAonCLb;oKVMO
oinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWomPJ5oo
Bg`Soi;QBonmnG_od?fBomSmVooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=
cLgoh^;RonOWi`0ZonSXj00YonKVi_oOgmoo<30`ohn?SooKfm_oalO7ohR8
R?o5aLGofm_KojFUYOl10@7ogMgMomkNg_m]KFgo20P8oa4A4OmcLg?o<30`
ob@T9?oMgMgofm_Kod];Bol<30coHV9Ron7QhOm]KFgo>SXjomoOgooShn?o
`l?3o`000?o1`L7ohN7Qoj2PX?l=3@goemOGomkNg_mmOGgo5aLGomgMgOoT
i>@00_oVi^H05?oRh^;oOgmoobPX:?oOgmooiNGUon?Shonf][Ko7alOo`T9
2Olf=SKoM7Ado`P82?nFUYKogMgMo`l?3onGUiOohN7QomoOgom2@T;oI6AT
0_oPh>003?meMGGo<S8bomgMgOoKfm_o_[jnoc`l??l20P;o7alOoaDE5Ond
];Coi^KVonOWifgoj>SX0Oo/k>`1oo;blP7om_Kf00000oogmoOon?ShooSh
n003ooShn00CooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFoo^BQoonYY_oo[6U
oonhZoon/jKooZRLoo^DROo^J5WoRC4[oi2@T?o>c/kok^k^ooOgm`03ooSh
n00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_PK_onm8;oo_j:ooooT_on
oXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOg
moo^k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSoc_j@omKoUoo@oY;oa_j9
ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^ooOgm`0ZooShn00_ooKfm_o_knoo
<c<coiVIVOoWinOoPh>3o`000?mlO7coj>SXok2`/?l10@7okNg]on?Shol6
1PKoXZ:RomgMgOmgMgOo0000olk>c_o`l?3o`/;2o`000?oAdM7om?Cdoo7a
lOmeMGGo?Shnonk^k_obl_;od=3@o`000?o?cloolO7aolS8b?l0003o`l?3
onk^k_n6QXKo6ATIonWYjOo_knool_;booCdm?oalO7oR8R8ob/[:oo^k^h0
0_oemOD07?mTI6Co?cloonGUiOnc/k?o7alOofMWIoo_knookNg]oa0@4?nR
XZ;ol?3`ono_kom7AdOoJf][ono_koo`l?3oOWinocDe=Oo[jn_oj>SXocLg
=om4A4Coc/k>onOWiooMgMgoi>CTooGemOogmoMVooShn003ooOgmoohn?So
n?Sh00;on?Sh00ComoOgooWinOogmoOomoOg0Oohn?P00003oo[jn_oemOGo
k^k^00;ok>c/0:Wojn_[onWYjOoOgmoo^[ZjogUBD_no<RCoigAYoof9O_oo
V8cooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<TogUBD_nj^[[ogmoOon[Z
j_o[jn_ok>c/on_[k?oZj^[ogmoOokZj^_n8IE;ohY4LooW3D?omfV?oonYb
ookcO_oonX;oo_Ioooo/LoongVCon/MAon:B7?n9IU?o^[ZjomoOgooZj^[o
jn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S7?nAdUGoY^MZokSiN_o0
oX;oaon9ol?nQ?nioG_oYna/oiCFEomBYQcoDVeBokZj^_oOgmooj^[Zon_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/onWYjOoShn?o<30`oi2@
T?oHf=Wo;Bd]od10@?lR8R;of][JojJVY_l10@7ohN7Qon?Si?l@413oO7al
omoOgond];Co0000om7AdOoTi>CoV9RIo`l?3ooPh>3oinOWon?Shom_Kfoo
>c/komoOgooQhN;o`l?3o`000?o5aLGoi>CTokno_ol0003o^;Rhon7Qh_mo
Ogoo5aLGomWIfOoMgMgohN7QonGUiOoTi>CoPH61obPX:?oOgmooi^KVonSX
j?mdM7Co7alOomWIfOoLg=go>c/kofm_KooTi>Coh>3Po`l?3onHV9SohN7Q
omoOh?m3@d?oIFEU00;oh>3P06ooMgMgoc8b<_oPh>3o^;Rio`000?nXZ:So
g=cLomWIfOoKfm_ohN7QonWYjOoZj^_ok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>`01oo[jn/01Oo/k>cojn_[on_[joo^k^kom_Kf007o
nOWi00000ookno_olo?cong]k@02onGUi@2`onKVi_oTi>CofMWIok:b/_mi
;Rkob48don=ZG?odNVgooHQloojGR_onVhkooYR;ooj:O_odNfgoif]MolY2
=?mk;Rko/[:bomSHf?oTi>CoiNGUonKVi_oUiNKoi>CTomSHf?nb/[;oUUD^
onZL:ook_4Coo/aCoogHH_onhg;oo^UeookVLoonffGooLaCoo_1AOo^WR_o
VEH^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGUonCTi?oHf=Wo/[:bobiR;_mS
[B_oQlY8oiOLFOnUiFWo/_=gokSfNondmGWoYnY[oiSLFOn9cd_oHjh[obiS
;_nb/[;of=SIonCTi?oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oShn?ogMgMobl_;on;Rh_o/K6bo`000?ng]kOo9BDUojRXZ?nPX:3o0@41
omcLg?oPh>7o/[:bocTi>OlU9BGo>c/ko`000?o=cLgogMgMoi>CU?l@413o
e]KFomkNg_oLg=coK6a/ocTi>OoDe=Coe]KGokbl_?l0003o`/;2omoOgonk
^k_o0000okBd]?oLg=coO7aloaLG5ooFe]Kof][JomkNg_oPh>3ogmoOogem
O_lW9bOoeMGEomcLg?oNg]kofm_KofATI?lP823o?3`loa<C4om]KFgoh>3P
omcLg?l?3`ooTi>ComOGeooEeMKo@D51of9RH_oGemOoe]KFog=cLola<C7o
gMgMoiZJVol00004ocLg=`1Wok:b/_oTi>Coi>CUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUi@02onKViP03onGUiOoVi^Koi^KV
00?oi^KV00?oiNGUong]kOodm?@00Ookno/00003ooclo?ohn?SolO7a00?o
k^k^01?ojn_[on7QhOnl_;coNQLGol<o<_oCETWoi6QJonmgK?odPgWon8Ml
ooF4N_ocNFgoiFUKomUHB_o4?c;oO1LGokbl_?oQhN7ok>c/00?ok^k^01?o
k>c/on7QhOnl_;coYDLGonJG<_oe[33ooKa1oog9Doomd63onm=UoogBH?on
cECooKe2ooZ_<_oYVc;oYDHGokbl_?oQhN7ok>c/00?ok^k^01?ok>c/on7Q
hOnl_;co5eTGoenX<_mf_COoQ/e7oiKFF_nRh6GoXn1Yoj?QIonGfUcoQ/i7
ogNo=omOZc;o5eTGokbl_?oQhN7ok>c/02[ok^k^02Ook>c/onGUiOla<C7o
Shn?ofi^K_l/;2coj>SXogemOOmNGUkoY:BTo`410OoShn?ojNWYonKVi_oR
h^;oh>3Pojf][Ol0003oemOGonCTi?nHV9So410@omgMgOoShn?oi>CTog1`
L?lT92Coe]KFomoOgono_koo0000ol_;booYjNWo`L71o`000?nj^[[oi>CT
oh61POl61PH00oln?Sh08_o;bl_ojNWYohB4Q?lJ6Q[of][Jon;Rh_oUiNGo
inOWon?ShooPh>3of=SHocLg=ombLW;oj^[ZonOWiol?3`ooRXZ:omoOgooN
g]ko@d=3oeIFE_oPh>3ogmoOogMgMolc<c?ojNWYokjn__l0003oX:2PokJf
]_nZZZ[o0P82omWIfOo]kNe]onk^kP03ong]kOobl_;on?Sh007oo?cl0003
oogmo@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@
@ooJHUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];olo?c
ooclo0?ooOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWomJPYooRd?ooi
_D[on;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?oo?cl00?o
oOgm01?oo?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:cE3oSLeB
oh[>D?n1adCoLKT_of:^8?m>VcCo1d87om;Bd_oclo?oo?cl02[ooOgm04co
no_kooCdm?ld=3CoUiNGoalO7on7QhOon_[jomcLg?lC4a?oZJVYo`410Oob
l_;onOWiol30`?o4a<Colo?cohb<S?lQ8B7on_[jooGemOnMWIgo410@onKV
i_o^k^kom?CdogQhN?lA4A7oC4a<ol[:b_n9RHWo51@DooKfm_oinOWoc/k>
o`000?o6a/Kolo?cohV9ROlC4a?o][JfokVi^Onj^[[okNg]ooWinOn?Shoo
30`<oeMGEooAdM7okNg]onc/k?nVYZKoi^KVonCTi?lB4Q;o[Jf]oo_knooj
n_[o410@oahN7_nUYJGog=cLoaXJ6_lP823oOGemomkNg_m7AdOoGemOoo_k
noojn_[o=3@dog5aLOo^k^koSXj>ocDe=Ookno_oo?clJoomoOd00oolo?co
oOgmooclo003oogmo@0003[ooOgmoo[jn_oclo?ok^k^oo3`l?o_knook^k^
onWYjOoCdm?oFadMoj8d=?nd:1go`CX]olM9??o?ET[od5M;om1GB_o:BSko
`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_onk^k_oZ
j^[odm?Coh`U7Oo8LCCofH@MonBD5OoWWBCokZPcoo2Z=?o_ZS?ok:0UonNG
5OoLR1gob74doh`U7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`l?o^k^koj^[Y
om?CdolM>1go=88dodNE7OmJYA_oJJdZ0_md^3P0OOme^CSoJk4[oe^W7?m8
VQgo=88doadh7OoCdm?oj^[Yonk^k_o`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo^k^koinOWoc4a<OmOGeoo0@41om;Bd_o^k^kok>c/od51
@OmQHF7o0@41onKVi_o^k^goX:2PocTi>OlA4A7o9RHVoiRHV?o_knooaLG5
oa0@4?l10@7o6ATIoe9BD_oYjNWoLG5aocdm?OnGUiOo7alOoaPH6?nATI7o
k^k^ong]kOo3`l?o0000okbl_?oXj>OoPX:2oaPH6?oOgmooh^;Ron?ShooW
inOojn_[oi>CT_lo?cooTY:BoaLG5onDU9Coh>3Podm?ColO7aoo4A4Aodm?
CooXj>Sok^k^ono_kolW9bOoX:2Podi>C_l92@Wo=SHfon3Ph?m^KVko3`l?
ob`/;?nn_[kok^k^ono_k_oBd];o?3`lo`/;2olM7Ago/[:b00;okno_06Ko
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knl2oo3`l0Kokno_0Ooclo<1ooWin@7oo_kn00000oono_komoOgoo3`l004
onWYj@0AonOWiooKfm_oHd];oh4b<_nV=CGo]S@]ol9=@Oo3E4Woa5E:ol=D
BOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooWinL01OoYjNT04OoWinOofm_K
ohU;Bon_Bc;ocGLeomJ;;OoPW2koh:0bon6P=?oPX3;ogiX^omJ;;Oo:MCGo
[d/bohU;BooKfm_oinOW00GojNWY017oinOWom_Kfom;Bd_o<V0bocZ9=OmC
VbgoJj/_og2]>?m_[S[oL:dhofZZ;omCVbgo>HPeoc9P<_m;Bd_ofm_KonOW
i`0[onWYj@0=onSXj?oTi>Co<30`oa8B4_ll?3coi^KVonSXj?oWinOoTi>C
oa4A4Ol10@7ohn?SonOWi`02onWYj@03onOWiooYjNWojNWY00;oj>SX01Co
WIfMoa0@4?oWinOoinOWonCTi?m_Kfoo>c/kon?ShooWinOoj>SXonWYjOoX
j>SoinOWol;2`_l0003o^[ZjonCTi?n0P83o5aLGomgMg@;og]kN00?ohN7Q
onKVi_oXj>P00_oYjNT00ooXj>SoinOWonWYj@02onWYj@03onOWiooYjNWo
jNWY00?ojNWY00?oj>SXonWYjOoXj>P00ooYjNT00ooWinOojNWYonWYj@04
onWYj@03onKVi_oYjNWojNWY06WojNWY00?oj>SXonWYjOoYjNT01?oYjNT1
oo3`l07omoOg0Oono_h00005ookno_ojn_[om?Cdono_kooalO400_o`l?00
4Oo_knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZNW?oIW9coe9FE
ok]cLonEE5CoCb<SoiFDU?oZj^[okno_00Gol?3`017okno_on[Zj_nYU9Co
PB<SokYZE?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S8onZ
U9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCoLjEcoik6
UOn/cYco[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Zj_o_knl0:oo`
l?001Oo_knook^k^oc8b<_l0003oTi>C00?okno_00Goi>CTo`/;2ol10@7o
k^k^ono_k`07oo3`l009on?Shono_kookno_ono_koo^k^koM7Adocdm?Oo]
kNgokno_00?ol?3`00Ookno_ol[:b_l0003o`l?3onk^k_n6QXKo2@T900?o
GUiN00?oNGUionk^k_o_knl03?o`l?000oo_knool?3`oo3`l01loo3`l004
oo7alOo`l?3om?Cdoo[jnP7oo_kn0003ooooo`03ookno_oooooooooo00;o
o_kn06kooOgmooShn?m^KVkoFSlook6@T?oNbLWol>CToo?Vi_o`i>Cog/W9
ok6@T?mJ?cooKFe]ooShn?olo?coooooookno_ooooooo_knooooo_ono_ko
ooooooclo?ohn?SoSFe]ohXo?oo9TI3ojM39ooCYi?ofjnKom>WTonW@bOo9
TI3oRCloohe]KOohn?Ooo?clooooooono_koooooookno_ooooooo_knoooo
o_olo?con?Shofe]KOlo?cooT9f@olWEbOoTk>Coi^kVonC/i?o9eLWoT9f@
oclo?om]KFgon?Shooclo?ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooomoOgo[jn_oiRHV?oalO3ooOgmooooo`;oo_kn
01Ko];BdoiZJV_omoOgoooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooomoOgoo_knogalO?m1@D7ooOgmooknoOono_kooooo
0_ono_h0Too^k^koVIVIon_[joono_godM7AoiVIVOnHV9SoVIVIoiRHV?n/
[:cooOgmooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooooknoP02ooooo`03ookno_oooooooooo00?ooooo0Ookno`00004
ooooooono_kon_[jooCdm0GolO7a00gokno_omKFe_m[Jf_o@cdmoi^<S?o6
^[[oe/c<olNj^_nKS8co@cdmof][JooFe]Kokno_00WolO7a00gokno_omOF
e_n3Jf_oM3dmokF<S?oE^[[ohLc<omJj^_nfS8coLSdmoh5[JooGe]Kokno_
00WolO7a00gokno_omKFe_m[Jf_o?Cdmohb<S?nj^[[oc<g<okZj^_n<S8co
?Cdmof][JooFe]Kokno_03GolO7a00?ol?3`oo7alOoalO403_oalO400oo^
k^kokNg]oo7al@2Eoo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00?om?Cd
oo[jn_ono_h00Oobl_800005ooCdm?omoOgon?Shoo3`l?o[jn/00ooZj^X0
3OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^K
onSXj?oYjNT02ooZj^X02ooYjNWoj>SXoj2KVomZFEWo@bHVobd92Om29RKo
JEUIoj2KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nKVi_oFEUIobHV9_l9
2@Wo9RHVoeUIFOnKVi_oj>SXonWYj@3Von[ZjP04on_[joo`l?3on?Shoogm
o@7oj>SW00001?o6a/Koo_knoo[jn_odm?@8oo7al@;ol?3`0oo_knl2oo3`
l0oolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`l?0hoo7a
l@03oo3`l?oalO7olO7a0:WolO7a00?ol?3`oo7alOoalO400_oalO400ooe
mOGon_[jooKfmP01okFe]@0000?oeMGEolg=cOooool0oooooolWooooo`7o
n?Sh0Oo2`/81ol?3``0000Colo?comCDe?o6a/KomOGeoooooolSooooo`05
ookno_olo?col?3`ol;2`_o=cLd00OoZj^X00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{300, 200},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleJList2",
        ButtonData:>{"SimpleJList2.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SimpleJList2[]\)], "Input"],

Cell[BoxData[
    \({"RoboSeal"}\)], "Print"],

Cell[BoxData[
    \({"RoboSeal"}\)], "Print"],

Cell[BoxData[
    \({"RoboKangaroo"}\)], "Print"],

Cell[BoxData[
    \({"RoboKangaroo"}\)], "Print"],

Cell[BoxData[
    \({"RoboCoyote"}\)], "Print"],

Cell[BoxData[
    \({"RoboCoyote"}\)], "Print"],

Cell[BoxData[
    \({"RoboKangaroo"}\)], "Print"],

Cell[BoxData[
    \({"RoboKangaroo"}\)], "Print"],

Cell[BoxData[
    \("RoboKangaroo"\)], "Print"],

Cell[BoxData[
    \("Double clicked."\)], "Print"],

Cell[BoxData[
    \({"RoboSeal"}\)], "Print"],

Cell[BoxData[
    \({"RoboSeal"}\)], "Print"],

Cell[BoxData[
    \("RoboSeal"\)], "Print"],

Cell[BoxData[
    \("Double clicked."\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JComboBox <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30
`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30
N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<30M`000?o0`<3m
`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0G0`<000`000<c<c<c<
c01Sc<c<4?ooo`030000`<30`<300?o0`<3k`<300XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G0`<000`000<c<c<c<c01Rc<c<00=VIVK<c<aVIVH0
3FIVIP03oooo0000`<300?o0`<3l`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^0G0`<000`000<c<c<c<c00Ec<c<100001O<c<`300005Lc<c0<0
000Gc<c<00=VIVKoooo<c<`03<c<c003IVIVoooo00000?o0`<3m`<300XS0
^058T8P10000000018S0^<SPf8S0^8S0^0G0`<000`000<c<c<c<c00Dc<c<
00@0003<c<c<c<c<c<`200006<c<c080000Fc<c<0P0001K<c<`00fIVI_oo
olc<c00<c<c<00=VIVKoool00000ol30`?g0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1L30`0050000c<c<00000000c<c<00800002c<c<0P00
00;<c<`200000/c<c0D00002c<c<0P000004c<c<00000000c<c<0P000003
c<c<0000000000;<c<`200000/c<c0D000000lc<c00000000004c<c<0`00
00G<c<`500001<c<c0D00002c<c<0`0000K<c<`400002lc<c003IVIVoooo
c<c<00c<c<`00fIVI_ooo`00003o`<30oL30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5`<3000D0003<c<`00000003<c<`00P0000;<c<`20000
0/c<c08000000lc<c00000000002c<c<0P000004c<c<00000000c<c<0`00
0004c<c<00000000c<c<0P0000;<c<`2000000?<c<`0000000000/c<c080
00000lc<c00000000004c<c<0`0000G<c<`200000/c<c0800002c<c<0P00
00;<c<`200000/c<c0<00005c<c<0P0000;<c<`200002/c<c003IVIVoooo
c<c<00c<c<`00fIVI_ooo`00003o`<30oL30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5`<3000D0003<c<`00000003<c<`00P0000;<c<`20000
0/c<c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`2
000000C<c<`00000003<c<`200000/c<c08000000lc<c00000000002c<c<
0P000003c<c<0000000000?<c<`2000000?<c<`0000000001<c<c0800003
c<c<0P000003c<c<0000000000;<c<`2000000C<c<`00000003<c<`20000
2<c<c080000:c<c<00=VIVKoooo<c<`01Lc<c0800005c<c<00=VIVKoool0
0000ol30`?g0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1L30`005
0000c<c<00000000c<c<00800002c<c<0P0000;<c<`200000/c<c0800000
1<c<c00000000<c<c0800002c<c<0P000004c<c<00000000c<c<0P0000;<
c<`200000/c<c08000001<c<c00000000<c<c0800003c<c<0P000003c<c<
0000000000C<c<`200000lc<c0800002c<c<0P000004c<c<00000000c<c<
0P000003c<c<0000000000S<c<`200002/c<c003IVIVooooc<c<00C<c<`4
00001<c<c003IVIVoooo00000?o0`<3m`<300XS0^058T8P10000000018S0
^<SPf8S0^8S0^0G0`<001@000<c<c00000000<c<c00200000/c<c0800002
c<c<0P0000?<c<`4000000?<c<`0000000000/c<c08000001<c<c0000000
0<c<c0800002c<c<0P0000?<c<`4000000?<c<`0000000000lc<c0800000
0lc<c00000000004c<c<0P0000?<c<`200000lc<c0@000001<c<c0000000
0<c<c0800004c<c<0P0000;<c<`200002/c<c003IVIVooooc<c<00?<c<`6
00000lc<c003IVIVoooo00000?o0`<3m`<300XS0^058T8P10000000018S0
^<SPf8S0^8S0^0G0`<001@000<c<c00000000<c<c003000000G<c<`00000
0000003<c<`00P000003c<c<0000c<c<00;<c<`2000000C<c<`00000003<
c<`3000000C<c<`00000003<c<`3000000G<c<`00000003<c<`000000lc<
c08000000lc<c00000000002c<c<0P0000?<c<`200000lc<c0800003c<c<
0P000003c<c<0000c<c<00;<c<`400000lc<c0800003c<c<1@0000_<c<`0
0fIVI_ooolc<c002c<c<200000;<c<`00fIVI_ooo`00003o`<30oL30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000D0003<c<`00000003<
c<`00P000003c<c<0000000000;<c<`200000lc<c0@00003c<c<0P000004
c<c<00000000c<c<0P000004c<c<00000000c<c<0P0000?<c<`400000/c<
c0H00003c<c<0P0000?<c<`200000lc<c0800002c<c<10000003c<c<0000
000000?<c<`200000lc<c080000>c<c<00=VIVKoooo<c<`03<c<c003IVIV
oooo00000?o0`<3m`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0G0
`<0010000<c<c000000003W<c<`200000/c<c080000Cc<c<0P0000g<c<`0
0fIVI_ooolc<c00<c<c<00=VIVKoool00000ol30`?g0`<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h1L30`0040000c<c<000000006/c<c080000M
c<c<1@0001C<c<`500002/c<c003IVIVooooc<c<00c<c<`00fIVI_ooo`00
003o`<30oL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000<0
003<c<c<c<`0H/c<c003IVIVooooc<c<00c<c<`00fIVI_ooo`00003o`<30
oL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000<0003<c<c<
c<`0H/c<c003IVIVooooc<c<00c<c<`00fIVI_ooo`00003o`<30oL30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000<0003<c<c<c<`0H/c<
c003IVIVoooooooo00coool00fIVI_ooo`00003o`<30oL30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5`<3000<0003<c<c<c<`0H/c<c003IVIV
c<c<IVIV00eVIVH00oooo`000<30`03o`<30o<30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5`<3000<0003<c<c<c<`0H/c<c003IVIVVIVIc<c<
00c<c<`00fIVI_ooo`00003o`<30oL30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P5`<3000<0002IVLbIVL`0HYVIc003IVIVVIVIc<c<00c<c<`0
0fIVI_ooo`00003o`<30oL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P5`<3000<0002IVLbIVL`0HYVIc003IVIVVIVIc<c<00c<c<`00fIVI_oo
o`00003o`<30oL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<30
00<0002IVLbIVL`05IVIc0@0000GVIW<0`0001FIVL`300005iVIc003IVIV
VIVIc<c<00c<c<`00fIVI_ooo`00003o`<30oL30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5`<3000<0002IVLbIVL`059VIc0040000VIW<VIW<
VIW<0P0001RIVL`200005YVIc080000FVIW<00=VIVJIVIW<c<`03<c<c003
IVIVoooo00000?o0`<3m`<300XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G0`<001@0009VIc000000009VIc00200000YVIc0800002VIW<0P0000:I
VL`500000YVIc080000019VIc000000009VIc08000000iVIc00000000002
VIW<0P0000:IVL`5000000>IVL`00000000019VIc0<00005VIW<1@0000BI
VL`500000YVIc0<00008VIW<0P0000^IVL`00fIVIYVIVLc<c00<c<c<00=V
IVKoool00000ol30`?g0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1L30`0050000VIW<00000000VIW<00800002VIW<0P0000:IVL`2000000>I
VL`0000000000YVIc080000019VIc000000009VIc0<0000019VIc0000000
09VIc0800002VIW<0P000003VIW<0000000000:IVL`2000000>IVL`00000
000019VIc0<00005VIW<0P0000:IVL`200000YVIc0800002VIW<0P0000:I
VL`3000029VIc080000;VIW<00=VIVJIVIW<c<`03<c<c003IVIVoooo0000
0?o0`<3m`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0G0`<001@00
09VIc000000009VIc00200000YVIc0800002VIW<0P000003VIW<00000000
00:IVL`2000000>IVL`0000000000YVIc080000019VIc000000009VIc080
0002VIW<0P000003VIW<0000000000:IVL`2000000>IVL`0000000000iVI
c08000000iVIc00000000004VIW<0P0000>IVL`2000000>IVL`000000000
0YVIc080000019VIc000000009VIc0800004VIW<1P0000ZIVL`00fIVIYVI
VLc<c00<c<c<00=VIVKoool00000ol30`?g0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1L30`0050000VIW<00000000VIW<00800002VIW<0P00
00:IVL`200000YVIc080000019VIc000000009VIc0800002VIW<0P000004
VIW<00000000VIW<0P0000:IVL`200000YVIc080000019VIc000000009VI
c0800003VIW<0P000003VIW<0000000000BIVL`200000iVIc0800002VIW<
0P000004VIW<00000000VIW<0P000003VIW<0000000000BIVL`00`0009VI
c9VIc00200002iVIc003IVIVVIVIc<c<00c<c<`00fIVI_ooo`00003o`<30
oL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000D0002IVL`0
0000002IVL`00P0000:IVL`200000YVIc0800003VIW<10000003VIW<0000
000000:IVL`2000000BIVL`00000002IVL`200000YVIc0800003VIW<1000
0003VIW<0000000000>IVL`2000000>IVL`00000000019VIc0800003VIW<
0P0000>IVL`4000000BIVL`00000002IVL`200001IVIc0040000VIW<0000
00002iVIc003IVIVVIVIc<c<00c<c<`00fIVI_ooo`00003o`<30oL30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000D0002IVL`00000002I
VL`00`000005VIW<000000000000VIW<008000000iVIc00009VIc002VIW<
0P000004VIW<00000000VIW<0`000004VIW<00000000VIW<0`000005VIW<
00000000VIW<000000>IVL`2000000>IVL`0000000000YVIc0800003VIW<
0P0000>IVL`200000iVIc08000000iVIc00009VIc002VIW<100000>IVL`2
000019VIc0040000VIW<000000002iVIc003IVIVVIVIc<c<00c<c<`00fIV
I_ooo`00003o`<30oL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
`<3000D0002IVL`00000002IVL`00P000003VIW<0000000000:IVL`20000
0iVIc0@00003VIW<0P000004VIW<00000000VIW<0P000004VIW<00000000
VIW<0P0000>IVL`400000YVIc0H00003VIW<0P0000>IVL`200000iVIc080
0002VIW<10000003VIW<0000000000>IVL`200001IVIc0<0000;VIW<00=V
IVJIVIW<c<`03<c<c003IVIVoooo00000?o0`<3m`<300XS0^058T8P10000
000018S0^<SPf8S0^8S0^0G0`<00100009VIc000000003VIVL`200000YVI
c080000DVIW<0`0000^IVL`00fIVIYVIVLc<c00<c<c<00=VIVKoool00000
ol30`?g0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1L30`0040000
VIW<000000006YVIc080000MVIW<1@0001JIVL`200002iVIc003IVIVVIVI
c<c<00c<c<`00fIVI_ooo`00003o`<30oL30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5`<3000<0002IVLbIVL`0HYVIc003IVIVVIVIc<c<00c<
c<`00fIVI_ooo`00003o`<30oL30`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P5`<3000<0002IVLbIVL`0HYVIc003IVIVVIVIVIVI00fIVIT00ooo
o`000<30`03o`<30o<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
`<3000<0002IVLbIVL`0HYVIc11VIYT00oooo`000<30`03o`<30o<30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000<0002IVLbIVL`0HYVI
c003IVJIc<coVIW<00bIVL`00fIVVOooo`00003o`<30oL30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5`<3000<0002IVLbIVL`0HYVIc003IVJI
c<coVIW<00bIVL`00fIVVOooo`00003o`<30oL30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5`<3000<0003<c<c<c<`0H/c<c003IVJIc<coVIW<
00bIVL`00fIVVOooo`00003o`<30oL30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P5`<3000<0003<c<c<c<`0H/c<c005IVJIc<coVIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@02VIW<00=VIYWoool00000ol30`?g0
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1L30`0030000c<c<c<c<
01G<c<`400005lc<c0<0000Ec<c<0`0001O<c<`016IVVLc<oiVIc<c<o`>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00=VIYWoool00000ol30`?g0`<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1L30`0030000c<c<c<c<01C<
c<`010000<c<c<c<c<c<c080000Hc<c<0P0001K<c<`200005/c<c003IVJI
c<coVIW<00>IVL`01FIVVIVIc9VIc9VIc6IVV@04VIW<00=VIYWoool00000
ol30`?g0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1L30`0050000
c<c<00000000c<c<00800002c<c<0P0000;<c<`200000/c<c0D00002c<c<
0P000004c<c<00000000c<c<0P000003c<c<0000000000;<c<`200000/c<
c0D000000lc<c00000000004c<c<0`0000G<c<`500001<c<c0D00002c<c<
0`0000K<c<`400002lc<c003IVJIc<coVIW<00:IVL`01Lc<oiVIc9VIc9VI
c<c<o`05VIW<00=VIYWoool00000ol30`?g0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1L30`0050000c<c<00000000c<c<00800002c<c<0P00
00;<c<`2000000?<c<`0000000000/c<c08000001<c<c00000000<c<c0<0
00001<c<c00000000<c<c0800002c<c<0P000003c<c<0000000000;<c<`2
000000?<c<`0000000001<c<c0<00005c<c<0P0000;<c<`200000/c<c080
0002c<c<0P0000;<c<`300001Lc<c0800002c<c<0P0000[<c<`01FIVVLc<
oiVIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00YVIc003IVJIoooo
00000?o0`<3m`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0G0`<00
1@000<c<c00000000<c<c00200000/c<c0800002c<c<0P000003c<c<0000
000000;<c<`2000000?<c<`0000000000/c<c08000001<c<c00000000<c<
c0800002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`000000000
0lc<c08000000lc<c00000000004c<c<0P0000?<c<`2000000?<c<`00000
00000/c<c08000001<c<c00000000<c<c0800008c<c<0P0000[<c<`016IV
VLc<oiVIc<c<o`>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00=VIYWoool0
0000ol30`?g0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1L30`005
0000c<c<00000000c<c<00800002c<c<0P0000;<c<`200000/c<c0800000
1<c<c00000000<c<c0800002c<c<0P000004c<c<00000000c<c<0P0000;<
c<`200000/c<c08000001<c<c00000000<c<c0800003c<c<0P000003c<c<
0000000000C<c<`200000lc<c0800002c<c<0P000004c<c<00000000c<c<
0P000003c<c<0000000000S<c<`200002/c<c003IVJIc<coVIW<00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@04VIW<00=VIYWoool00000ol30`?g0`<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1L30`0050000c<c<00000000c<c<
00800002c<c<0P0000;<c<`200000lc<c0@000000lc<c00000000002c<c<
0P000004c<c<00000000c<c<0P0000;<c<`200000lc<c0@000000lc<c000
00000003c<c<0P000003c<c<0000000000C<c<`200000lc<c0800003c<c<
10000004c<c<00000000c<c<0P0000S<c<`200002/c<c003IVJIc<coVIW<
00:IVL`01Lc<oiVIc9VIc9VIc<c<o`05VIW<00=VIYWoool00000ol30`?g0
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1L30`0050000c<c<0000
0000c<c<00<000001Lc<c000000000000<c<c002000000?<c<`0003<c<`0
0/c<c08000001<c<c00000000<c<c0<000001<c<c00000000<c<c0<00000
1Lc<c00000000<c<c0000003c<c<0P000003c<c<0000000000;<c<`20000
0lc<c0800003c<c<0P0000?<c<`2000000?<c<`0003<c<`00/c<c0@00003
c<c<0P0000G<c<`300002lc<c005IVJIc<coVIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@02VIW<00=VIYWoool00000ol30`?g0`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h1L30`0050000c<c<00000000c<c<0080
00000lc<c00000000002c<c<0P0000?<c<`400000lc<c08000001<c<c000
00000<c<c08000001<c<c00000000<c<c0800003c<c<100000;<c<`60000
0lc<c0800003c<c<0P0000?<c<`200000/c<c0@000000lc<c00000000003
c<c<0P0000O<c<`200002/c<c004IVJIc<coVIW<c<co0iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`00fIVVOooo`00003o`<30oL30`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P5`<3000@0003<c<`00000000ic<c<0P0000;<
c<`200004/c<c0800002c<c<0P0000[<c<`00fIVVLc<oiVIc003VIW<00EV
IYVIVLbIVLbIVLaVIYT019VIc003IVJIoooo00000?o0`<3m`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G0`<0010000<c<c000000001[<c<`2
00007Lc<c0D0000Dc<c<100000_<c<`00fIVVLc<oiVIc002VIW<00G<c?nI
VLbIVLbIVLc<c?l01IVIc003IVJIoooo00000?o0`<3m`<300XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G0`<000`000<c<c<c<c01Rc<c<00EVIYW<
c?nIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00:IVL`00fIVVOoo
o`00003o`<30oL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<30
00<0003<c<c<c<`0H/c<c004IVJIc<coVIW<c<co0iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`00fIVVOooo`00003o`<30oL30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5`<3000<0003<c<c<c<`0H/c<c003IVJIc<coVIW<
00>IVL`01FIVVIVIc9VIc9VIc6IVV@04VIW<00=VIYWoool00000ol30`?g0
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1L30`0030000c<c<c<c<
06;<c<`00fIVVLc<oiVIc002VIW<00G<c?nIVLbIVLbIVLc<c?l01IVIc003
IVJIoooo00000?o0`<3m`<300XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G0`<000`000<c<c<c<c01Rc<c<00EVIYW<c?nIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00:IVL`00fIVVOooo`00003o`<30oL30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5`<3000<0003<c<c<c<`0H/c<c004
IVJIc<coVIW<c<co0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`00fIVVOoo
o`00003o`<30oL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<30
00<0003<c<c<c<`0H/c<c003IVJIc<coVIW<00>IVL`01FIVVIVIc9VIc9VI
c6IVV@04VIW<00=VIYWoool00000ol30`?g0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1L30`0030000c<c<c<c<01G<c<`400005lc<c0<0000E
c<c<0`0001O<c<`00fIVVLc<oiVIc002VIW<00G<c?nIVLbIVLbIVLc<c?l0
1IVIc003IVJIoooo00000?o0`<3m`<300XS0^058T8P10000000018S0^<SP
f8S0^8S0^0G0`<000`000<c<c<c<c00Dc<c<00@0003<c<c<c<c<c<`20000
6<c<c080000Fc<c<0P0001K<c<`01FIVVLc<oiVIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00YVIc003IVJIoooo00000?o0`<3m`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G0`<001@000<c<c00000000<c<c002
00000/c<c0800002c<c<0P0000;<c<`500000/c<c08000001<c<c0000000
0<c<c08000000lc<c00000000002c<c<0P0000;<c<`5000000?<c<`00000
00001<c<c0<00005c<c<1@0000C<c<`500000/c<c0<00005c<c<1P0000[<
c<`016IVVLc<oiVIc<c<o`>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00=V
IYWoool00000ol30`?g0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1L30`0050000c<c<00000000c<c<00800002c<c<0P0000;<c<`2000000?<
c<`0000000000/c<c08000001<c<c00000000<c<c0<000001<c<c0000000
0<c<c0800002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`00000
00001<c<c0<00005c<c<0P0000;<c<`200000/c<c0800002c<c<0P0000;<
c<`300001Lc<c080000>c<c<00=VIYW<c?nIVL`00iVIc005IVJIVIW<VIW<
VIW<IVJI00BIVL`00fIVVOooo`00003o`<30oL30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5`<3000D0003<c<`00000003<c<`00P0000;<c<`2
00000/c<c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<
c<`2000000C<c<`00000003<c<`200000/c<c08000000lc<c00000000002
c<c<0P000003c<c<0000000000?<c<`2000000?<c<`0000000001<c<c080
0003c<c<0P000003c<c<0000000000;<c<`2000000C<c<`00000003<c<`2
00001Lc<c080000=c<c<00=VIYW<c?nIVL`00YVIc005c<coVIW<VIW<VIW<
c<co00FIVL`00fIVVOooo`00003o`<30oL30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5`<3000D0003<c<`00000003<c<`00P0000;<c<`20000
0/c<c0800002c<c<0P000004c<c<00000000c<c<0P0000;<c<`2000000C<
c<`00000003<c<`200000/c<c0800002c<c<0P000004c<c<00000000c<c<
0P0000?<c<`2000000?<c<`0000000001<c<c0800003c<c<0P0000;<c<`2
000000C<c<`00000003<c<`2000000?<c<`0000000001/c<c080000<c<c<
00EVIYW<c?nIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00:IVL`0
0fIVVOooo`00003o`<30oL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P5`<3000D0003<c<`00000003<c<`00P0000;<c<`200000/c<c0800003
c<c<10000003c<c<0000000000;<c<`2000000C<c<`00000003<c<`20000
0/c<c0800003c<c<10000003c<c<0000000000?<c<`2000000?<c<`00000
00001<c<c0800003c<c<0P0000?<c<`4000000C<c<`00000003<c<`20000
1lc<c080000;c<c<00AVIYW<c?nIVLc<c?l3VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc003IVJIoooo00000?o0`<3m`<300XS0^058T8P10000000018S0
^<SPf8S0^8S0^0G0`<001@000<c<c00000000<c<c003000000G<c<`00000
0000003<c<`00P000003c<c<0000c<c<00;<c<`2000000C<c<`00000003<
c<`3000000C<c<`00000003<c<`3000000G<c<`00000003<c<`000000lc<
c08000000lc<c00000000002c<c<0P0000?<c<`200000lc<c0800003c<c<
0P000003c<c<0000c<c<00;<c<`400000lc<c0800007c<c<0P0000[<c<`0
0fIVVLc<oiVIc003VIW<00EVIYVIVLbIVLbIVLaVIYT019VIc003IVJIoooo
00000?o0`<3m`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0G0`<00
1@000<c<c00000000<c<c002000000?<c<`0000000000/c<c0800003c<c<
100000?<c<`2000000C<c<`00000003<c<`2000000C<c<`00000003<c<`2
00000lc<c0@00002c<c<1P0000?<c<`200000lc<c0800003c<c<0P0000;<
c<`4000000?<c<`0000000000lc<c0800007c<c<0P0000[<c<`00fIVVLc<
oiVIc002VIW<00G<c?nIVLbIVLbIVLc<c?l01IVIc003IVJIoooo00000?o0
`<3m`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0G0`<0010000<c<
c000000003W<c<`200000/c<c080000Bc<c<0P0000;<c<`200002/c<c005
IVJIc<coVIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@02VIW<00=V
IYWoool00000ol30`?g0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1L30`0040000c<c<000000006/c<c080000Mc<c<1@0001C<c<`400002lc<
c004IVJIc<coVIW<c<co0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`00fIV
VOooo`00003o`<30oL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
`<3000<0003<c<c<c<`0H/c<c003IVJIc<coVIW<00>IVL`01FIVVIVIc9VI
c9VIc6IVV@04VIW<00=VIYWoool00000ol30`?g0`<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1L30`0030000c<c<c<c<06;<c<`00fIVVLc<oiVI
c002VIW<00G<c?nIVLbIVLbIVLc<c?l01IVIc003IVJIoooo00000?o0`<3m
`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0G0`<000`000<c<c<c<
c01Rc<c<00EVIYW<c?nIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00:IVL`00fIVVOooo`00003o`<30oL30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P5`<3000<0003<c<c<c<`0H/c<c004IVJIc<coVIW<c<co0iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`00fIVVOooo`00003o`<30oL30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000<0003<c<c<c<`0H/c<
c003IVJIc<coVIW<00bIVL`00fIVVOooo`00003o`<30oL30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5`<3000<0003<c<c<c<`0H/c<c003IVJI
c<coVIW<00bIVL`00fIVVOooo`00003o`<30oL30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5`<3000<0003<c<c<c<`0H/c<c003IVJIc<coc<co
00c<c?l00fIVVOooo`00003o`<30oL30`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P5`<3000<0003<c<c<c<`05Lc<c0@0000Gc<c<0`0001G<c<`3
00005lc<c11VIYT00oooo`000<30`03o`<30o<30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5`<3000<0003<c<c<c<`05<c<c0040000c<c<c<c<
c<c<0P0001S<c<`200005/c<c080000Fc<c<00=VIVKoooo<c<`03<c<c003
IVIVoooo00000?o0`<3m`<300XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G0`<001@000<c<c00000000<c<c00200000/c<c0800002c<c<0P0000;<
c<`500000/c<c08000001<c<c00000000<c<c08000000lc<c00000000002
c<c<0P0000;<c<`5000000?<c<`0000000001<c<c0<00005c<c<1@0000C<
c<`500000/c<c0<00008c<c<0P0000_<c<`00fIVI_ooolc<c00<c<c<00=V
IVKoool00000ol30`?g0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1L30`0050000c<c<00000000c<c<00800002c<c<0P0000;<c<`2000000?<
c<`0000000000/c<c08000001<c<c00000000<c<c0<000001<c<c0000000
0<c<c0800002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`00000
00001<c<c0<00005c<c<0P0000;<c<`200000/c<c0800002c<c<0P0000;<
c<`300002<c<c080000;c<c<00=VIVKoooo<c<`03<c<c003IVIVoooo0000
0?o0`<3m`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0G0`<001@00
0<c<c00000000<c<c00200000/c<c0800002c<c<0P000003c<c<00000000
00;<c<`2000000?<c<`0000000000/c<c08000001<c<c00000000<c<c080
0002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000000lc<
c08000000lc<c00000000004c<c<0P0000?<c<`2000000?<c<`000000000
0/c<c08000001<c<c00000000<c<c0800007c<c<0P0000_<c<`00fIVI_oo
olc<c00<c<c<00=VIVKoool00000ol30`?g0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1L30`0050000c<c<00000000c<c<00800002c<c<0P00
00;<c<`200000/c<c08000001<c<c00000000<c<c0800002c<c<0P000004
c<c<00000000c<c<0P0000;<c<`200000/c<c08000001<c<c00000000<c<
c0800003c<c<0P000003c<c<0000000000C<c<`200000lc<c0800002c<c<
0P000004c<c<00000000c<c<0P000003c<c<0000000000O<c<`200002lc<
c003IVIVooooc<c<00c<c<`00fIVI_ooo`00003o`<30oL30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5`<3000D0003<c<`00000003<c<`00P00
00;<c<`200000/c<c0800003c<c<10000003c<c<0000000000;<c<`20000
00C<c<`00000003<c<`200000/c<c0800003c<c<10000003c<c<00000000
00?<c<`2000000?<c<`0000000001<c<c0800003c<c<0P0000?<c<`40000
00C<c<`00000003<c<`200001lc<c080000;c<c<00=VIVKoooo<c<`00/c<
c0P00002c<c<00=VIVKoool00000ol30`?g0`<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1L30`0050000c<c<00000000c<c<00<000001Lc<c000
000000000<c<c002000000?<c<`0003<c<`00/c<c08000001<c<c0000000
0<c<c0<000001<c<c00000000<c<c0<000001Lc<c00000000<c<c0000003
c<c<0P000003c<c<0000000000;<c<`200000lc<c0800003c<c<0P0000?<
c<`2000000?<c<`0003<c<`00/c<c0@00003c<c<0P0000C<c<`010000<c<
c000000000_<c<`00fIVI_ooolc<c003c<c<1P0000?<c<`00fIVI_ooo`00
003o`<30oL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000D0
003<c<`00000003<c<`00P000003c<c<0000000000;<c<`200000lc<c0@0
0003c<c<0P000004c<c<00000000c<c<0P000004c<c<00000000c<c<0P00
00?<c<`400000/c<c0H00003c<c<0P0000?<c<`200000lc<c0800002c<c<
10000003c<c<0000000000?<c<`200001<c<c0@0000;c<c<00=VIVKoooo<
c<`01<c<c0@00004c<c<00=VIVKoool00000ol30`?g0`<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h1L30`0040000c<c<00000000>Lc<c0800002
c<c<0P0001C<c<`300002lc<c003IVIVooooc<c<00G<c<`200001Lc<c003
IVIVoooo00000?o0`<3m`<300XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G0`<0010000<c<c000000001[<c<`200007Lc<c0D0000Fc<c<0P0000_<
c<`00fIVI_ooolc<c00<c<c<00=VIVKoool00000ol30`?g0`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h1L30`0030000c<c<c<c<06;<c<`00fIV
I_ooolc<c00<c<c<00=VIVKoool00000ol30`?g0`<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1L30`0030000c<c<c<c<06;<c<`00fIVI_ooolc<
c00<c<c<00=VIVKoool00000ol30`?g0`<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h1L30`0030000c<c<c<c<06;<c<`00fIVI_ooolc<c00<c<c<
00=VIVKoool00000ol30`?g0`<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1L30`0030000c<c<c<c<06;<c<`00fIVI_ooooooo`0<oooo00?<c<co
ool00000ol30`?g0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1L30
`0030000c<c<c<c<06;<c<`@IVIV00?<c<`00030`<00ol30`?c0`<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1L30`7L0003o`<30oL30`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5`<30G_ooo`03c<c<oooooooo01Ko
oooo`<30oL30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000=V
IVK<c<aVIVH0G6IVIP03c<c<IVIVIVIV01AVIVH00ooool30`<30`03o`<30
nl30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000=VIVKooooo
ool0Foooo`03IVIVooooc<c<01C<c<`00fIVI_oool30`03o`<30o<30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000=VIVKoooooool0Fooo
o`03IVIVooooc<c<01C<c<`00fIVI_oool30`03o`<30o<30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5`<3000=VIVKoooooool0Foooo`03IVIV
ooooc<c<01C<c<`00fIVI_oool30`03o`<30o<30`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5`<3000=VIVKoooooool0FOooo`040000ooooIVIV
oooo5Lc<c003IVIVoooo`<300?o0`<3l`<300XS0^058T8P10000000018S0
^<SPf8S0^8S0^0G0`<000fIVI_ooooooo`0Eoooo100001Ooool300005Ooo
o`<0000>oooo00@0003ooomVIVKooolEc<c<00=VIVKoooo0`<00ol30`?c0
`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1L30`003IVIVoooooooo
01Coool010000?ooooooooooo`80000Hoooo0P0001Koool200003Oooo`04
0000ooooIVIVoooo5Lc<c003IVIVoooo`<300?o0`<3l`<300XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G0`<001FIVI_ooo`0000000?ooo`020000
0_ooo`800002oooo0P0000;oool500000_ooo`8000001?ooo`0000000?oo
o`8000000oooo`0000000002oooo0P0000;oool5000000?oool000000000
1?ooo`<00005oooo1@0000Coool500000_ooo`<00006oooo100000;oool0
10000?ooofIVI_oooaG<c<`00fIVI_oool30`03o`<30o<30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5`<3000EVIVKoool00000003oool00P00
00;oool200000_ooo`8000000oooo`0000000002oooo0P000004oooo0000
0000oooo0`000004oooo00000000oooo0P0000;oool2000000?oool00000
00000_ooo`8000000oooo`0000000004oooo0`0000Goool200000_ooo`80
0002oooo0P0000;oool200000_ooo`<00005oooo0P0000;oool2000000Go
ool0003ooomVIVKoool05Lc<c003IVIVoooo`<300?o0`<3l`<300XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G0`<001FIVI_ooo`0000000?ooo`02
00000_ooo`800002oooo0P000003oooo0000000000;oool2000000?oool0
000000000_ooo`8000001?ooo`0000000?ooo`800002oooo0P000003oooo
0000000000;oool2000000?oool0000000000oooo`8000000oooo`000000
0004oooo0P0000?oool2000000?oool0000000000_ooo`8000001?ooo`00
00000?ooo`800004oooo0P0000;oool2000000Goool0003ooomVIVKoool0
2Lc<c080000:c<c<00=VIVKoooo0`<00ol30`?c0`<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1L30`005IVIVoooo00000000oooo00800002oooo
0P0000;oool200000_ooo`8000001?ooo`0000000?ooo`800002oooo0P00
0004oooo00000000oooo0P0000;oool200000_ooo`8000001?ooo`000000
0?ooo`800003oooo0P000003oooo0000000000Coool200000oooo`800002
oooo0P000004oooo00000000oooo0P000003oooo0000000000Coool20000
0_ooo`8000001Oooo`000?ooofIVI_ooo`08c<c<100000W<c<`00fIVI_oo
ol30`03o`<30o<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<30
00EVIVKoool00000003oool00P0000;oool200000_ooo`800003oooo1000
0003oooo0000000000;oool2000000Coool00000003oool200000_ooo`80
0003oooo10000003oooo0000000000?oool2000000?oool0000000001?oo
o`800003oooo0P0000?oool4000000Coool00000003oool200001?ooo`80
0002oooo0P000005oooo0000ooooIVIVoooo00O<c<`600002<c<c003IVIV
oooo`<300?o0`<3l`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0G0
`<001FIVI_ooo`0000000?ooo`03000000Goool000000000003oool00P00
0003oooo0000oooo00;oool2000000Coool00000003oool3000000Coool0
0000003oool3000000Goool00000003oool000000oooo`8000000oooo`00
00000002oooo0P0000?oool200000oooo`800003oooo0P000003oooo0000
oooo00;oool400000oooo`800003oooo1@0000;oool010000?ooofIVI_oo
o`K<c<`800001lc<c003IVIVoooo`<300?o0`<3l`<300XS0^058T8P10000
000018S0^<SPf8S0^8S0^0G0`<001FIVI_ooo`0000000?ooo`02000000?o
ool0000000000_ooo`800003oooo100000?oool2000000Coool00000003o
ool2000000Coool00000003oool200000oooo`@00002oooo1P0000?oool2
00000oooo`800003oooo0P0000;oool4000000?oool0000000000oooo`80
0003oooo0P0000Goool010000?ooofIVI_ooo`G<c<`:00001/c<c003IVIV
oooo`<300?o0`<3l`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^0G0
`<0016IVI_ooo`00000003Woool200000_ooo`80000Coooo00<0003ooooo
ool00P000005oooo0000ooooIVIVoooo01G<c<`00fIVI_oool30`03o`<30
o<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000AVIVKoool0
0000000Joooo0P0001goool500005Oooo`<00002oooo00@0003ooomVIVKo
oolEc<c<00=VIVKoooo0`<00ol30`?c0`<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h1L30`003IVIVoooooooo05Woool010000?ooofIVI_oooaG<
c<`00fIVI_oool30`03o`<30o<30`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P5`<3000=VIVKoooooool0FOooo`040000ooooIVIVoooo5Lc<c003
IVIVoooo`<300?o0`<3l`<300XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G0`<000fIVI_ooooooo`1Ioooo00@0003ooomVIVKooolEc<c<00=VIVKo
ooo0`<00ol30`?c0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1L30
`003IVIVoooooooo05Woool010000?ooofIVI_oooaG<c<`00fIVI_oool30
`03o`<30o<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000=V
IVKoooooool0Foooo`03IVIVooooc<c<01C<c<`00fIVI_oool30`03o`<30
o<30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000=VIVKooooo
ool0Foooo`03IVIVooooc<c<01C<c<`00fIVI_oool30`03o`<30o<30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5`<3000=VIVKoooooool0Fooo
o`03IVIVoooooooo01Coool00lc<c?oool30`03o`<30o<30`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5`<30MVIVIP03c<c<`<30`<300?o0`<3k
`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000
000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;So`<30ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2hol30`?o0`<1j`<300XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o0`<3o`<30N/30`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So`<30
ol30`7[0`<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2hol30`?o0`<1j
`<300XS0^058T8P10000000018S0^<SPf8S0^8S0^?o0`<3o`<30N/30`0:8
`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h5P00P0<00H0200:000@00X400h400h400h4300B1
0P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V30`4:
P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>6
00@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV8
0aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@4
8h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh0
0`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A
0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`Lf
T`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF
0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP0
0`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:
Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh3
2eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aM
X@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeR
X`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V
0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP3
3g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@
Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P03
4H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4B
R[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb
008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne
11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh
5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<F
Yk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG
[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h1000P003VjOa<d>U<d>U00Tc@jD600200`01
P0800X001002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N2
00<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@3
0@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ7
00@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<M
RP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<5
9Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]
T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B
0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@3
1cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G
0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9
VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;
DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]I
W`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaP
XPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY003
3FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW
0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`me
Z@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@
Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65
[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8B
SK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@C
T[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK
]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ
^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m
5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o
00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P30020
00NKYo7ooon>N[JVVlBcZM:XWLRcZM800ZJKa005_;SMk^kdj^Waoooo<d>U
00D0080300600P02P00400:100>100>100>10`04P@801H401005PP06PP06
PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q003
0@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<K
R@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d4
9Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[
S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO
00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y
00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n
[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64
[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P04
59Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl
00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G
/KhG/KlG/Kl00aNb_`<G/kl26;C08000008H]<0@00000QRd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2002000BKYo7ooom/FZF_YLX2_;SM00[o
oOncZM;ooooooonl^=fGR[bXWLSVi^cooolc@jD400200`01P0800X001002
P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h812881
28800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<2
48D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP3
5hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;
0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DW
SPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@
00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB
1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8
?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H
2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J
0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;
E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P
0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ80
0`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=
J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L0
10m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ
0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60
[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`
0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK82
4Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<C
U;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L2
59fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j
0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/
_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o
0QRd`003b>3HB928B92800a8T8P00`000<SPf4R@R00=B92800@0000H]<0H
]<38h=P>B92800<0000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0
^8S0^08008002i^WlOooojRMb?oook>YdV1<VXij]WQU[ZRMb?ooooomo`03
oooo00<c@jD0080008000`00P0<00H0200:000@00X400h400h400h4300B1
0P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V30`4:
P`030@^30@^40@^400<138@30@f40`4>Q@<23hD20Q250oooo`824HH30Q:6
0P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P0
0`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<4
8X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h3
1BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`
T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLe
T`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF
0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P3
2DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:
CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP03
2eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<
GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R
008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU
10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X
3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@
NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhA
PJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/004
4XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?
/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je
0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN
^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<F
Y[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm
5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8
`;R8`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=
R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0P00P00>VjOaoooooooofmc/H4bJThFj/jWB_;SMH4bJVHnnYY_4b<?Ooooo
<d>U1P00P0?oool200:000<00X7oooooool00_ooo`8018400`05POooo`05
PP0300J21?ooo`030@R20@R3oooo00?oool30@Z300Koool12h@12h@138Co
ool138@20@f400Coool13XGoool13XD20Pn500Coool248Goool248D20Q66
00?oool24HH24XH00P8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<4
7XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd0
0`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6
;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHd
TP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD
0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3
U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9
BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd3
2e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<
FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaP
XP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT
0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_
Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?
MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd2
4Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@A
QZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8B
SK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@0
0a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK
]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<E
X[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m
5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P00dR@R0000<SPf002
R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00>VjOaoooo_;SM
VHnnooooe]7Mfmc/lokoYY_4k^kdQGJ`ThFjoooo<d>U1000P007oooo0060
00600060oooo00:0oooo00<00h401_ooo`04P@04P@05POooo`05PP801X80
2?ooo`07PP07PP47P_ooo`48P_ooo`48P`<12H<01?ooo`4:P`4:Poooo`81
2h@00`4<Q?ooo`4<Q0020@f400Coool13XGoool13XD20Pn500?oool248Go
ool00oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<F
R0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@N
RP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@03
1BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^
T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB
00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@3
1c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G
00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:
VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;
Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJ
X0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R
0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@3
3FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW
0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mf
ZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8A
Ojd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166
[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=
/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]003
4i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g
0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR
^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF
[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb
_`<G/kl26;C000C8h=R8`;R8`;R8`;P6000018S0^003B9280000b>3H00:8
`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`004b>3H
R<2hR<2hR<2h0P0000B8`;P200000XS0^004B92800006;C06;C00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0<008003i^WlOoooiV?_YN:_=CCj>n/
/omfNnjOZe]HYJJKa9JOdV1<V[bhgOoooc=3Y@03002000Ooool00H000H00
0H3oool00X3oool00`03P@06oooo00B100B1oooo00F1oooo0P06PP08oooo
00N200N20@N2oooo0@R2oooo0@R30`49P`09oooo0@Z3oooo0@^3oooo0@^4
oooo0@b4oooo00813H@01?ooo`4>QOooo`4>Q@823hD01?ooo`8@QOooo`8@
Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<G
R0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3
122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>
1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i00
10H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987
=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`Pl
U@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9
A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX3
2TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]D
W@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj02
35bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP03
3F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eX
Y@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`04
3g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX3
47RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]
00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk03
4XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8B
S[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D
]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8D
WKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX3
5JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm
0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl2
6;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0
^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8`;P2
00000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOXZFjPb<?OThFjFdJC
VHnn0WQU[P04@RN5[jG:oooo<d>U1000P0<00H000oooo`02P002P@04oooo
0P04P@03oooo00F1oooo00<01X84oooo00<1288128<128<00`49P`09oooo
0@Z3oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?ooo`4>QOooo`4>Q@82
3hD00oooo`8@QOooo`03oooo0P8AQP<24XH20Q>600@24hL258L258L258L3
0QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^9
0`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@U
S@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?
10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHc
TPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0Lh
U0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G
246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI
0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:
DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil0
0`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<
Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=
IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^
Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT0
10mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/
47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_
4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:<
/@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`03
4i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@D
V[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i
5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`0
11J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa
_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038
h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C0
00?8h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P003VjOaoooooooo00;oool02_n]
/?mfNoW=e?g]k_ooojJKa8Ef/;bhgOoooc=3Y@D00803006000?oool00X00
0X400`03P@03oooo00B1oooo00801H401005P_ooo`06PP06PP801h800`47
P_ooo`48PP020@R30oooo`812X<01oooo`4;Poooo`4;Q?ooo`4<Q?ooo`02
0@f400Coool13XGoooooool20Pn500Koool248Goool248D24HKoool20Q66
0`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP3
0aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<4
8H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP03
1BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46
<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB
0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE
10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH
2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:
CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;
E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX004
35bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeR
XPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU
0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0ma
Z0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@
NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]
4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08B
RK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<C
S[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe
0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@E
WKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<F
YKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd0
0aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003
b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0
^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^004R<2h0P0000F8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3
002000ZQ[?;icMCR9Scd]KoR9ScdKGglhnWoooomkNko[K02oooo00<c@jD0
080008001000P0<00H000oooo`02P002P@03oooo0P04P@05oooo00F100F1
00F2oooo00801X83oooo0P48PP030@R3oooo0@V300812H<20@Z300Coool1
2h<12hCoool20@b400Ooool13H@13HCoool13XGoool13XD00_ooo`030Pn5
0Q250Q2500Coool0108AQP8BQP8BQP8BQP824hH0108CQ`8DQ`8DQ`8DQ`<2
5HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT3
0ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=
0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl4
1Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B
1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD
00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8
@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT3
2DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YA
W@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`03
2eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aO
XPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eU
Y0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW
3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@04
3gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@
OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lA
Q:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba
00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<C
T[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ
]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TE
X;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_004
5Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n
5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SP
f002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<00
0lSPf8S0^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2002000fKYo7mkNkR9ScnmOSgRIOdHVkc
X:kdHVkooOoo[K3lhnWooolc@jD01`00P0<00H000oooo`02P002P@0300>1
0`04P@801H401005PP06PP06PP06PP801h801@47PP48PP48P_ooo`48P`03
0@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<2
4XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<H
R0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;
0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DX
SP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A
1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP02
1cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8
?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4
V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK
0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN
00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aL
X@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=
HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>
JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?
LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[
0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61
[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`
00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb
4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<D
U[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh
5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj
0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G
[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSP
f8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P0
1@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h
0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000>KYo7fb<cR9S`00_n]/007gb@^ojBNm[c5ojf`kW^<oooo
<d>U00P00803006000?oool00X000X400`03P@<0184200F100@01H801X80
1X801X8200N200D11h81288128;oool128<00`49P`04oooo0@Z30@Z30@^3
0P4;Q0<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L2
58L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@3
6XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@T
S@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZ
S`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y40
10HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`Lh
T`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G
246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6
V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:
DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;
Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ42
35nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS
00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH0
10i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?
LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m
[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P03
4HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[43
4X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c
0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH2
59Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^003
5J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY
_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G
/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8
T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P00hS0^080
0004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2002000>KYo7icMCgRIL00_ooo`07ojf`hAHdogIkojBN
hRHlohUo<d>U00P00803006000?oool00X000X400`03P@<0184200F100@0
1H801X801X801X8200N200@11h812881288128<4oooo0`4:P`030@^30@^4
0@^400<138@20@f400Coool13XD13XD13XD30Pn50`8@Q@@24HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00:8`;P900000XS0^005B92800006;C06;C0
b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000NKYo7oooocX:kdHVkoooogRIOicM@00_ooo`03lj2^oooo
<d>U00P0080300600P02P00400:100>100>100>10`04P@801H401005PP06
PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;
Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB7
0QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ9
0`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d4
98d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl0
0`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6
<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7
>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1
U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT0
10U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L
2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO
2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaO
X@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`03
3FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>
KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y
3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0
111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64
[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;
/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<C
TK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ
]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP
^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`4
5ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n
00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B928
0000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00;VjOaooooohUo
oooolj2^lI>Qoooooogolj2^oo_l<d>U00P0080300600P02P00400:100>1
00>100>10`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP02
0@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@2
4HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<G
R0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;
0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>
00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_
T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87
=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8
?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9
A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK
0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]D
WP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP
00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R
3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>
JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X
3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ
0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<A
PJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`
0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[80
0a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<C
UKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL0
11FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj
0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]
_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C0
3lSPf0030000b>3Hb>3H00g8h=P00`0001Rd`1Rd`00?b>3H00<0000H]<0H
]<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0@00803VjOa00Kooooc
X:kd]Kof_<GkfMXc@jD900200`01P0800X001002P@03P@03P@03P@<01842
00F100@01H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z3
00<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0
108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP3
6HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@S
S00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP03
1BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<943
1S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC
0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2
242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V003
2DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?
W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;
EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ
35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S
0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH3
3VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?
LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1k
Z`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<A
PZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::
/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk80
0Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD4
59Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PE
W[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW
^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^
_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;PF00200`01P0800X001002P@03P@03P@03P@<0
184200F100@01H801X801X801X8200N200<11h81288128800P48P`<12H<3
0@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP82
4hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<3
6HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<
10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DY
SP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946
<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<3
1cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8
?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5
V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK
0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]E
WP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ
35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP02
3F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>
JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0ma
Z0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[
0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^
00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9
/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8C
Sk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<D
UkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PE
W[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk
0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^
_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B928
0@00000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000003R<2h
b>3HR<2h0?n8`;SoR<2hOHS0^058T8P1000000000hS0^<SPf<SPf03ob>3H
olSPf7g8h=P1B9280@000000ohS0^?n8`;R1R<2h0@000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:000027b000`400?l0
0000o`00003o00KomOKhooCfmoodm_OomOKhooCfmoodmOL3ooCfm`06ooCe
moodm_Oom?GgooCemoodmOKoloCe6Oooool01Oo3`l?oRXZ:ofYZJ_n0P83o
dM7A01_ooooo00?oh^;RohF5QOohn?P06Oooool00ooShn?oQHF5ooShn03o
ooooo`Sooooo00Soo_knooclo?okno_onocnoo[lo_okoOoonocnoo[loP?o
nocn00Gon_cnoo_lo_ojo?konocnoo_mo`02oo_loP06oo_moooko?kon_cn
oo_moooko?kon_cn0ooko?h01Oojo?konocnoo[lo_oko?konogo00;onocn
00Konogooo_lo_ojo?konogooo_lo_oalO43ooknoP03oogmoOono_kooOgm
00Koo_kn00CooOgmookno_ono_kooOgm0oono_h00oomoOgoo_knoogmo@06
ooknoP04oogmoOono_koo_knoogmo@?oo_kn00[ooOgmookno_omoOgoo_kn
oo_knoogmoOomOGeooOgmookno_ooOgm0_ono_h01oomoOgoo_knookno_om
oOkooOgmookno_omoOd00oono_h01oomoOkoo_knookno_omoOgoo_knoogm
o_omoOd00_ono_h02?omoOkooOgmookno_omoOgoo_knoocloOogmoOooOgm
0_ono_h01?omoOgoo_knoogmo_omoOd2ooknoP04oogmo_omoOgoo_knoogm
o@?oo_kn00OooOgnookno_ono_kooOgmookno_omoOkooOgm00;oo_kn00Co
oOgnooclo?ogmoOooOgm0oono_h01oomoOkoo_knookno_omoOgoo_knoogm
o_omoOd00_ono_h01?omoOkooOgmookno_omoOd3ooknoP07oogmo_ono_ko
o_knoogmoOono_kooOgnoogmo@02ooknoP04oogmo_omoOgoo_knoogmo@?o
o_kn00OooOgnookno_ono_kooOgmookno_omoOkooOgm00;oo_kn00CooOgn
oogmoOono_kooOgm0oono_h01oomoOkoo_knookno_omoOgoo_knoogmo_om
oOd00_ono_h01?omoOkooOgmookno_omoOd3ooknoP07oogmo_ono_koo_kn
oogmoOono_kooOgnoogmo@02ooknoP04oogmo_omoOgoo_knoogmo@?oo_kn
00OooOgnookno_ono_kooOgmookno_omoOkooOgm00;oo_kn00CooOgnoogm
oOono_kooOgm0oono_h08?omoOkoo_knookno_omoOgoo_knoogmo_omoOgo
/[:bojj^[_nn_[oo]KJfok6a/Onb/[;o^[Zjol30`?o4a<Cob/[:om3@d?oD
e=CoemOGomCEeOo;c<cokNg]ofEUI_mXJ6WoJV][ofa]KOm_KfooLG5bog9c
LomeMGGoMGIg0OmgMgP000;oko7b0oo`lO<01_o`l_?oko7boo3aloo`lO;o
l?;coo3al`;oko7b00?oko3aonk_l?ojn_X01Oojn_X00ookno_on_[joo_k
n`02oo[jnP03oo_knoojn_[ono_k00Son_[j00Wono_koo[jn_okno_oSHf=
og]kNonWYjOoJVYZoaTI6Onl_;`01oojn_X00ookno_on_[joo_kn`02oo[j
nP03oo_knoojn_[ono_k00Son_[j00Sono_koo[jn_okno_om_KfobXZ:_nW
YjOon_[joo_kn`Son_[j00?ono_koo[jn_okno/00_ojn_X00ookno_on_[j
oo_kn`07oo[jnP04ooOgmolZ:R[oYZJVoo_kn`;on_[j00?ono_koo[jn_ok
no/02?ojn_X00ookno_on_[joo_kn`02oo[jnP03oo_knoojn_[ono_k00So
n_[j00?ono_koo[jn_okno/00_ojn_X00ookno_on_[joo_kn`08oo[jnP03
oo_knoojn_[ono_k00;on_[j00?ono_koo[jn_okno/02?ojn_X00ookno_o
n_[joo_kn`02oo[jnP03oo_knoojn_[ono_k00Son_[j00?ono_koo[jn_ok
no/00_ojn_X00ookno_on_[joo_kn`08oo[jnP03oo_knoojn_[ono_k00;o
n_[j00?ono_koo[jn_okno/02?ojn_X00ookno_on_[joo_kn`02oo[jnP03
oo_knoojn_[ono_k00Son_[j00?ono_koo[jn_okno/00_ojn_X00ookno_o
n_[joo_kn`08oo[jnP03oo_knoojn_[ono_k00;on_[j00?ono_koo[jn_ok
no/02?ojn_X00ookno_on_[joo_kn`02oo[jnP03oo_knoojn_[ono_k00So
n_[j00?ono_koo[jn_okno/00_ojn_X00ookno_on_[joo_kn`08oo[jnP03
oo_knoojn_[ono_k00;on_[j00?ono_koo[jn_okno/02?ojn_X00ookno_o
n_[joo_kn`02oo[jnP03oo_knoojn_[ono_k00Son_[j00?ono_koo[jn_ok
no/00_ojn_X00ookno_on_[joo_kn`08oo[jnP03oo_knoojn_[ono_k00;o
n_[j00?ono_koo[jn_okno/02?ojn_X00ookno_on_[joo_kn`02oo[jnP0:
oo_knoojn_[ono_koo[jn_oinOWon?ShooKfm_ofmoWom_SjooKgn@;om_Sj
00?om_OiooKhn_ofmoT00_ofn?X01OofmoWom_SjooKgnOofmoWom_Sj00;o
m_Oi00Oom_SjooKgnOofn?[om_SjooKgnOofn?[om_Oi00;om_Sj00Gom_Oi
ooKhn_ofmoWom_OiooKhnP02ooKgn@04ooKhn_ofmoWom_Sjonc/k0Son_[j
00ConOWioo[jn_ojn_[onOWi3?ojn_X01?oinOWon_[joo[jn_oinOT;oo[j
nP06oo?cloobl_;omOGeoo7alOo/k>com_Kf0oojn_X00ooinOWon_[jooWj
nP02oo[jnP09ooWjn_ojn_[onO[jooWinOojn_[onO[jooWinOojn_[onO[j
00;on_[j00?onO[joo[jn_oin_X00_ojn_X02Ooin_[on_[jooWinOo]kNgo
mOGeooWjn_oinOWon_[jooWjnP02oo[jnP03ooWjn_ojn_[onO[j00;on_[j
00WonO[joo[jn_oin_[onOWioo[jn_oin_[onOWioo[jn_oin_X00_ojn_X0
3_oin_[on_[jooWjn_oin_[ok^k^ooCemOojn_[onO[jooWinOojn_[onO[j
ooWinOojn_[onO[j0_ojn_X00ooin_[on_[jooWjnP02oo[jnP09ooWjn_oj
n_[onO[jooWinOojn_[onO[jooWinOojn_[onO[j00;on_[j00?onO[joo[j
n_oin_X00_ojn_X02Ooin_[on_[jooWjn_oinOWon_[jooWjn_oinOWon_[j
ooWjnP02oo[jnP03ooWjn_ojn_[onO[j00;on_[j00WonO[joo[jn_oin_[o
nOWioo[jn_oin_[onOWioo[jn_oin_X00_ojn_X00ooin_[on_[jooWjnP02
oo[jnP09ooWjn_ojn_[onO[jooWinOojn_[onO[jooWinOojn_[onO[j00;o
n_[j00?onO[joo[jn_oin_X00_ojn_X02Ooin_[on_[jooWjn_oinOWon_[j
ooWjn_oinOWon_[jooWjnP02oo[jnP03ooWjn_ojn_[onO[j00;on_[j00Wo
nO[joo[jn_oin_[onOWioo[jn_oin_[onOWioo[jn_oin_X00_ojn_X06Ong
]kOodM7Aono_kooal_;ok>c/on3Ph?oGemOofMWIomkNg_oUiNGoj^[[oo3`
l?oclo?ol?3`onKVi_oWinOoIfMXofY[Jom]KFkoKg1`og9bLomdM7GoMWIg
ogQhNOmiNWX00OmkNg/00006on7Si?oRhnGoh^CUon;TiOoQhnCoh^?T0_oQ
hn@2on;Si@;ohN?T0_oPh^<00ooQh^?ok>c/onc/k002onc/k003ong]kOo/
k>cok>c/00cok>c/00Gofm_Kon_[joo/k>coh^;Ron7Qh@05onc/k003oeaL
G?m<C4cok>c/00Cok>c/00?okNg]onc/k?o/k>`01oo/k>`01ooKfm_oj^[Z
onc/k?oQhN7oh^;Ronc/k?o]kNd01Oo/k>`00on7QhOoA4A4onc/k007onc/
k003ong]kOo/k>cok>c/00Sok>c/00?og=cLon[Zj_o/k>`00_oRh^801?o]
kNgok>c/ohN7Qom4A4@<onc/k003ong]kOo/k>cok>c/00gok>c/00?okNg]
onc/k?o/k>`03Oo/k>`00oo]kNgok>c/onc/k00=onc/k003ong]kOo/k>co
k>c/00gok>c/00?okNg]onc/k?o/k>`03Oo/k>`00oo]kNgok>c/onc/k00=
onc/k003ong]kOo/k>cok>c/00gok>c/00?okNg]onc/k?o/k>`03Oo/k>`0
0oo]kNgok>c/onc/k00=onc/k003ong]kOo/k>cok>c/00gok>c/00?okNg]
onc/k?o/k>`03Oo/k>`00oo]kNgok>c/onc/k00=onc/k003ong]kOo/k>co
k>c/00gok>c/00?okNg]onc/k?o/k>`03Oo/k>`00oo]kNgok>c/onc/k00=
onc/k003ong]kOo/k>cok>c/00Ook>c/0_o[jn/00ooZj^[oj>SXonSYj`02
onSZk0;oj>W[00SoinW[onSYjooXj^coj>W[onOYjooXj^_oinW[onSYj`;o
j>[/0_oXjN/2onSZk0;oj>W[00SoinW[onSYjooXj^coj>W[onOYjooXj^_o
inW[onSYj`;oj>[/0_oXjN/2onSZk003onSYjooMgMgok>c/00ook>c/00Oo
jn_[onc/k?o/k>cok>c/on_[joo/k>cojn_[00Wok>c/0_o[jn/2onc/k0?o
jn_[1?o/k>`00ooShn?oh^;Ronc/k002onc/k008on_[joo[k>cok>c/onc/
k?o[jn_ok>c/on_[joo[k>`2onc/k005on_/k?o/k>cojn_[onc/k?o[k>`0
0_o[jn/02_o[k>cok>c/onc/k?o[jn_ok>c/on_[joo[k>coi^KVon7QhOo[
k>`3onc/k004on_/k?o/k>cojn_[on_/k0;ok>c/00Cojn_[onc/k?o[jn_o
jnc/0_o/k>`01_o[k>cok>c/onc/k?o[jn_ojn_/onc/k0;ojn_[0_o/k>`0
1?oUiNGohN7Qon_[joo[k>`2onc/k008on_/k?o/k>cok>c/onc/k?o[jn_o
j^[ZonWYj_o[k>`2onc/k004on_[joo/k>cojn_[on_/k0;ok>c/00Sojnc/
onc/k?o/k>cok>c/on_/k?o/k>cojn_[on_/k0;ok>c/00Cojn_[onc/k?o[
jn_ojnc/0_o/k>`02?o[k>cok>c/onc/k?o/k>cojnc/onc/k?o[jn_ojnc/
0_o/k>`01?o[jn_ok>c/on_[joo[k>`2onc/k008on_/k?o/k>cok>c/onc/
k?o[k>cok>c/on_[joo[k>`2onc/k004on_[joo/k>cojn_[on_/k0;ok>c/
00Sojnc/onc/k?o/k>cok>c/on_/k?o/k>cojn_[on_/k0;ok>c/00Cojn_[
onc/k?o[jn_ojnc/0_o/k>`02?o[k>cok>c/onc/k?o/k>cojnc/onc/k?o[
jn_ojnc/0_o/k>`01?o[jn_ok>c/on_[joo[k>`2onc/k00Oon_/k?o/k>co
k>c/onc/k?o[k>cok>c/okVj^_oBd];ol_;booOgmoohn?SomoOgonSYjOoM
g]koi>CTonOWj?o^knoom?CeooOhn?oemOGojNWYono_komWJ6SoJV][ofi^
Kom`LG7oLW=cogEeM_mgMgSoNGUjog]kN`01ogalO@000_o`lO<2onoalP;o
l?;c00Gol?7coo3bloo`lO?oko7boo3alP02onoalP06ono`lOo_l?3on_[j
oo[jn_ln?SkoNWYj0_ojn_X01_m9BDWoPh>3oo_knoojn_[oOWinoda<C0;o
n_[j017o];BdoaHF5_ojn_[on_[joeUIFOlE5AGo9RHVoijNW_lP823oGemO
oo_knooShn?oI6ATod=3@omoOgooWYjNobXZ:P02oo[jnP0:odU9BOn3Ph?o
n_[joo[jn_m9BDWoQ8B4oo[jn_okno_oY:BTobPX:0;on_[j00WoFEUIoaDE
5OlV9RKoWYjNob0P8?mOGeoon_[jodU9BOn3Ph<00_ojn_X01Ookno_on_[j
oiFEUOl?3`ooeMGE00Oon_[j00Oo?cloo`l?3ol?3`oo5ADEoc/k>omhN7So
k^k^00?on_[j00KoFEUIoaDE5OlV9RKoWYjNob0P8?mNGUh2oo[jnP03oiJF
U_l?3`ooeMGE00Son_[j00?o9BDUog9bL_ojn_X01?ojn_X00ookno_on_[j
oo[jnP0=oo[jnP03oo_knoojn_[on_[j00gon_[j00?ono_koo[jn_ojn_X0
3Oojn_X00ookno_on_[joo[jnP0=oo[jnP03oo_knoojn_[on_[j00gon_[j
00?ono_koo[jn_ojn_X03Oojn_X00ookno_on_[joo[jnP0=oo[jnP03oo_k
noojn_[on_[j00gon_[j00?ono_koo[jn_ojn_X03Oojn_X00ookno_on_[j
oo[jnP0=oo[jnP03oo_knoojn_[on_[j00gon_[j00?ono_koo[jn_ojn_X0
3Oojn_X00ookno_on_[joo[jnP0=oo[jnP03oo_knoojn_[on_[j00gon_[j
00?ono_koo[jn_ojn_X03Oojn_X00ookno_on_[joo[jnP04oo[jnP04ooWi
nOogmoOom_KfooKgn@;omOOi00Som_OiooKhn_ofmoWom_SjooKgnOoemoWo
m_OiooKhnPCom_Oi00com_SjooKgnOoemoWomOOiooKgnOofn?[om_OiooKh
n_ofmoWomOOiooKgnOofn?X4ooKgn@07ooKhn_ofmoWomOOiooGgnOofmoWo
k>c/ooWin@02oo[jnP07ooWinOojn_[omoOgoo3`l?oinOWon_[jooWin@02
oo[jnP;onOWi0_ojn_X02_o_knoolo?coo[jn_oinOWokno_oo?clooinOWo
n_[joo?cloo_knl2oo[jnP05ooGemOo/k>con_[joo[jn_o`l?000_o]kNd0
:Oodm?CokNg]oo7alOoinOWon?Shoo7alOo_knoolo?cooCdm?o]kNgonOWi
oo[jn_o`l?3olo?coo[jn_oin_[okno_oo?cloojn_[onOWiooCemOo^k^ko
nOWioo[jn_o`l?3ok>c/ong]kOodm?GokNg]oo3alOojn_[okno_oo;bl_oi
n_[on_[jooWinOoin_[om?Cdonc/k?ohn?SonO[j00;onOWi00[onO[joo[j
n_oinOWon_[jono_koo[jncok>c/onc/kOo^k^kol_;b0_oinOT03Oojn_[o
nO[joo3`l?o/k>cokNg^ooCdmOo]kNgolO7aooWjn_oinOWom?Cdonc/k?og
moL00_oin_X00ooinOWon_[jooWjnP02ooWin@09ooCdm?o^k^kok^o_onk_
kooclo?onOWiooWjn_ojn_[onOWi00;onO[j00?onOWioo[jn_oin_X00_oi
nOT02Ooin_[on_[jooWinOojn_[onO[jooWinOoin_[on_[jooWin@02ooWj
nP03ooWinOojn_[onO[j00;onOWi00WonO[joo[jn_oinOWon_[jooWjn_oi
nOWonO[joo[jn_oinOT00_oin_X00ooinOWon_[jooWjnP02ooWin@09ooWj
n_ojn_[onOWioo[jn_oin_[onOWiooWjn_ojn_[onOWi00;onO[j00?onOWi
oo[jn_oin_X00_oinOT02Ooin_[on_[jooWinOojn_[onO[jooWinOoin_[o
n_[jooWin@02ooWjnP03ooWinOojn_[onO[j00;onOWi00WonO[joo[jn_oi
nOWon_[jooWjn_oinOWonO[joo[jn_oinOT00_oin_X00ooinOWon_[jooWj
nP02ooWin@0KooWjn_ojn_[o^[Zjom;Bd_oalO7om_KgooWinOojn_[omOGe
omkNgooUiNGoj^[Zoo7bl_ohn?SonOWiooGfm_o/k>coooooofIVI_mYJV[o
K6a]ofm_KomaLW;oM7AeogEfM_mhN7SoNGYj007oNW]k00000oodmOOomOKh
ooCfm`06ooCfm`06ooGfn?odm_Oom?GgooCfmoocmOKoloCe0_ono_h07Om0
@43oOGemooooooono_koBd];ohJ6Q_ooooooo_knoh:2P_m=CDgoo_knoooo
oonh^;So5aLGookno_o8b<So4a<ComkNg_oWinOoI6AToahN7_ono_kooooo
oeMGEolj>S[oYjNWoh>3Poli>CWo8B4Q00;oo_kn01GoBTY:ohJ6Q_ono_ko
ooooodY:B_n6QXKoo_knoooooonXZ:So:BTYookno_o8b<So4a<ComkNg_oV
i^KoI6AToahN7_ooooooo_knod];Bon6QXH00_ono_h01_ooooooo_knoc/k
>olG5aOoN7Qhooooo`Coo_kn01Woooooookno_m1@D7oNg]kookno_oemOGo
c/k>odm?Col^;Rkol?3`ookno_o9bLWo4Q8BomkNg_oVi^KoI6AToalO7oon
o_koooooookno_lk>c_o5QHFogUiNOono_kooooo00;oo_kn00Soooooookn
o_ono_koo_knofMWIolU9BGono_kooooo`?oo_kn00?oooooookno_ooool0
0_ono_h00oooooooo_knooknoP02ooknoP03ooooooono_kooooo00?oo_kn
00?oooooookno_ooool00_ono_h00oooooooo_knooknoP02ooknoP03oooo
ooono_kooooo00?oo_kn00?oooooookno_ooool00_ono_h00oooooooo_kn
ooknoP02ooknoP03ooooooono_kooooo00?oo_kn00?oooooookno_ooool0
0_ono_h00oooooooo_knooknoP02ooknoP03ooooooono_kooooo00?oo_kn
00?oooooookno_ooool00_ono_h00oooooooo_knooknoP02ooknoP03oooo
ooono_kooooo00?oo_kn00?oooooookno_ooool00_ono_h00oooooooo_kn
ooknoP02ooknoP03ooooooono_kooooo00?oo_kn00?oooooookno_ooool0
0_ono_h00oooooooo_knooknoP02ooknoP03ooooooono_kooooo00?oo_kn
00?oooooookno_ooool00_ono_h00oooooooo_knooknoP02ooknoP03oooo
ooono_kooooo00?oo_kn00?oooooookno_ooool00_ono_h00oooooooo_kn
ooknoP02ooknoP03ooooooono_kooooo00?oo_kn00?oooooookno_ooool0
0_ono_h00oooooooo_knooknoP02ooknoP03ooooooono_kooooo00?oo_kn
00?oooooookno_ooool00_ono_h00oooooooo_knooknoP02ooknoP03oooo
ooono_kooooo00?oo_kn00?oooooookno_ooool00_ono_h00oooooooo_kn
ooknoP02ooknoP03ooooooono_kooooo00?oo_kn00?oooooookno_ooool0
0_ono_h00oooooooo_knooknoP02ooknoP03ooooooono_kooooo00?oo_kn
00?oooooookno_ooool00_ono_h00oooooooo_knooknoP02ooknoP03oooo
ooono_kooooo00?oo_kn00?oooooookno_ooool00_ono_h00oooooooo_kn
ooknoP02ooknoP03ooooooono_kooooo00?oo_kn00?oooooookno_ooool0
0_ono_h01_ooooooo_knoogmoOolo?con_[joo_loP;on_cn00?on_cmoo[l
o_ojo?d00_ojo?h01Ooko?kon_cnoo[loOoko?kon_cn00;on_cm00Oon_cn
oo_lo_ojo?kon_cnoo[loOojo?kon_cm00;on_cn00Gonocnoo[lo_ojo?go
nocnoo[loP02oo[lo@06oo[lo_oko?kon_cnoo[lo_ojo?golO7a0oomoOd0
1_ono_kon_[joo7alOoalO7om?Cdooclo0;ooOgm00?oo_knoogmoOomoOd0
0_omoOd04Ooclo?omoOgoogmoOono_kom?CdooOgmoono_kooOgmooKfm_od
m?CooOgmookno_oinOWolO7aoogmoOojn_[ol?3`00;oo?cl00[omOGeoo7a
lOomoOgoo_knooGemOoclo?on?ShooOgmooclo?olO7a0_omoOd04Ooclo?o
m_KfoogmoOomoOgom?CdooOgmoomoOgooOknooShnOoalO;ooOgmoo[jn_oa
lO7ono_koocko?oemOGolO7a00;ooOgm00[olo?dooOgmoomoOgooOgmoogn
o_omoOgol_;boo3`l?ofm_KooOkn1_omoOd03ooclo?om_OgoogmoOolo?co
no_kooCdm?obl_;oo?cloogmoOokno_ol?7aoo_lo?oknocomOGeoo7al@02
oogmo@04oogmo_oclo?olO7aooOgm`CooOgm00?ooOknoogmoOomoOd00oom
oOd00ookno_ol?3`ooSin@02oogmo@03oogno_omoOgooOgm00;ooOgm00?o
oOknoogmoOomoOd01OomoOd01?omoOkooOgmoogmoOomo_h4oogmo@03oogn
o_omoOgooOgm00GooOgm00CooOgnoogmoOomoOgooOkn1?omoOd00oomo_ko
oOgmoogmo@05oogmo@04oogmo_omoOgooOgmoognoPCooOgm00?ooOknoogm
oOomoOd01OomoOd01?omoOkooOgmoogmoOomo_h4oogmo@03oogno_omoOgo
oOgm00GooOgm00CooOgnoogmoOomoOgooOkn1?omoOd00oomo_kooOgmoogm
o@02oogmo@0Iokbl_?oBd];olO7aooOgmoohn?Son?SiooWinOoOgn3oi^KV
on[Zj_oalO7on?Shoo_knoogmoOok>c]ong]k_mSHf?oIVIVofQYJOm[K6co
KVi_og1`LOmbLW?oLgAdogEeMP01ogMgM`0000Coko7conoal_o`l_?oko7b
0oo`lO<00oo`l_?oko7boo3bl`02onoal`?oko3a0_ojn_X06Olm?CgoNg]k
ooWinOojn_[oBDU9oh>3Poojn_[onOWiogmoOom;Bd_on_[jooWinOnd];Co
5QHFoo[jn_oFe]Ko410@okfm_OoinOWoX:2Pob`/;?ojn_[olO7aoaHF5_ni
^KT00_ojn_X02_nHV9So7QhNoo[jn_ojn_[oBDU9oh>3Poojn_[onOWiodU9
BOn3Ph<2oo[jnP0=ojBTY?lX:2Son_[jomKFe_l@413o_Kfmoo[jn_nPX:3o
;2`/ooWinOojn_[oB4Q8oh>3P`03oo[jnP05ol[:b_l?3`ooX:2PoalO7ooc
lo<01?ojn_X01?oinOWon_[joclo?omiNGT3oo[jnP0AooCdm?l[:b_oMWIf
oo[jn_oFe]Ko410@okfm_Oojn_[oX:2Pob/[:oojn_[onOWiol_;bol>3Pko
X:2PoalO7ooclo<00oojn_X02?oinOWon_[joo[jn_ojn_[obl_;o`h>3_nj
^[[onOWi1?ojn_X01OoinOWon_[joo[jn_ojn_[onOWi00Con_[j00?onOWi
oo[jn_oinOT01?ojn_X01OoinOWon_[joo[jn_ojn_[onOWi00Con_[j00?o
nOWioo[jn_oinOT01?ojn_X01OoinOWon_[joo[jn_ojn_[onOWi00Con_[j
00?onOWioo[jn_oinOT01?ojn_X01OoinOWon_[joo[jn_ojn_[onOWi00Co
n_[j00?onOWioo[jn_oinOT01?ojn_X01OoinOWon_[joo[jn_ojn_[onOWi
00Con_[j00?onOWioo[jn_oinOT01?ojn_X01OoinOWon_[joo[jn_ojn_[o
nOWi00Con_[j00?onOWioo[jn_oinOT01?ojn_X01OoinOWon_[joo[jn_oj
n_[onOWi00Con_[j00?onOWioo[jn_oinOT01?ojn_X01OoinOWon_[joo[j
n_ojn_[onOWi00Con_[j00?onOWioo[jn_oinOT01?ojn_X01OoinOWon_[j
oo[jn_ojn_[onOWi00Con_[j00?onOWioo[jn_oinOT01?ojn_X01OoinOWo
n_[joo[jn_ojn_[onOWi00Con_[j00?onOWioo[jn_oinOT01?ojn_X01Ooi
nOWon_[joo[jn_ojn_[onOWi00Con_[j00?onOWioo[jn_oinOT01?ojn_X0
1OoinOWon_[joo[jn_ojn_[onOWi00Con_[j00?onOWioo[jn_oinOT01?oj
n_X01OoinOWon_[joo[jn_ojn_[onOWi00Con_[j00?onOWioo[jn_oinOT0
1?ojn_X01OoinOWon_[joo[jn_ojn_[onOWi00Con_[j00?onOWioo[jn_oi
nOT01?ojn_X01OoinOWon_[joo[jn_ojn_[onOWi00Con_[j00?onOWioo[j
n_oinOT01?ojn_X01?oinOWon_[joo[jn_ojn_X3ooWin@05ooOgmoofm_Ko
mOOiooKgnOoemoT01?ofmoT01OoemoWom_OiooKgnOofmoWomOOi00Com_Oi
00?omOOiooKgnOoemoT01?ofmoT01OoemoWom_OiooKgnOofmoWomOOi00Co
m_Oi00GomOOiooKgnOoemoWom_Oion_[j`02oo[jnP07ooWinOogmoOokNg]
ono_kooemOGokNg]ono_k`03ooWin@0:oo[jn_oinOWon_[jooWinOo_knoo
l_;booWinOojn_[okno_oo?cl`;onOWi017olo?cono_kooinOWonOWiooKf
m_o/k>con_[jooOgmoo/k>com_KfooWinOoemOGok^k^oo[jn_ohn?SokNg]
ooKfmP02ooWin@0EooCdm?o]kNgonOWioo[jn_o_knoolo?cooWin_oinOWo
l?3`oo;blooinO[onOWiooGemOo]k^konOWiooOgmoo/k>com_GfooWinOod
m?GokNk^00;onOWj00kokno_oo?clooinOWonOWjooWinOogmoOok>c/ooCd
m?o]kNgon?WiooWin_oinOWonOWjooWin@;onOWj00Cok^k^oo;bl_oinOWo
nOWj0_oinOT04Oo^k^kol_;booWinOogmoOok>c/ooGemOoinO[om?Cdonk^
k_oinO[onOWiooOgmoo/k>com?Cdonc/k?oinOWonOWj00?onOWi00ConOWj
ooWinOoinO[onOWi0_oinOX01?o^k^kolO7aooWinOoinOX2ooWin@08ooWi
n_oinOWonOWiooWinOoinO[onOWiooWin_oinOT2ooWinP04ooWinOoinO[o
nOWiooWinP;onOWi00SonOWjooWinOoinOWonOWiooWin_oinOWonOWjooWi
n@;onOWj00ConOWiooWin_oinOWonOWj0_oinOT02?oinO[onOWiooWinOoi
nOWonOWjooWinOoinO[onOWi0_oinOX01?oinOWonOWjooWinOoinOX2ooWi
n@08ooWin_oinOWonOWiooWinOoinO[onOWiooWin_oinOT2ooWinP04ooWi
nOoinO[onOWiooWinP;onOWi00SonOWjooWinOoinOWonOWiooWin_oinOWo
nOWjooWin@;onOWj00ConOWiooWin_oinOWonOWj0_oinOT03OoinO[onOWi
ooWinOoinOWonOWjooWinOoinO[onOWiokfm_OoCdm?olO7aooOgmooinOT0
0_ojn_X04_na/K7oj>SXong^k_odm?ConO[joogmoOohn?Sol?3`onOWiomV
IVKoJFUYof]/K?m_KfooLG5bog=dM?meMWKoN7QhogUiNP7oNW]k00000ooQ
h^Coh^?Uon;Si@05on7Si00;on;SiOoQhnCohN?Ton3Ri?oQh^Coh>;Son3Q
h_o/k>cojn_[oc/k>omdM7@00_o[jn/01_m4A4CoO7alon_[joo/k>coMgMg
odQ8B0;ojn_[00GoZJVYoaHF5_o/k>cojn_[ojBTY002ocXj>P06oc`l??lY
:BWojn_[okJf]_l>3PkoeMGE0_o[jn/02_nSXj?o71`Lon_[joo/k>coA4A4
ogemOOo/k>cojn_[odE5AOmlO7`2on_[j`09oibLW?lV9RKojn_[on_[jonT
Y:Co>CTiocXj>_lm?Cgo:BTY00;ok>c/00?oADE5ogalO?o[jn/00_o[jn/0
1OmYJFWoADE5on_[jol`<33oW9bL00;ojn_[00Kok>c/on_[joo/k>cok>c/
oc`l??mbLW83on_[j`03onc/k?miNGWo:b/[00;ojn_[00coY:BTocTi>Olk
>c_o?3`lobXZ:_o/k>cojn_[ofUYJOm5ADGojn_[oc0`<?nMWId6on_[j`04
onc/k?o[jn_oGEeMoe]KF`Gojn_[00?ok>c/on_[joo[jn/01?o[jn/01?o/
k>cojn_[onc/k?o/k>`5on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Cok>c/
on_[joo/k>cok>c/1Oo[jn/00oo/k>cojn_[on_[j`04on_[j`04onc/k?o[
jn_ok>c/onc/k0Gojn_[00?ok>c/on_[joo[jn/01?o[jn/01?o/k>cojn_[
onc/k?o/k>`5on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Cok>c/on_[joo/
k>cok>c/1Oo[jn/00oo/k>cojn_[on_[j`04on_[j`04onc/k?o[jn_ok>c/
onc/k0Gojn_[00?ok>c/on_[joo[jn/01?o[jn/01?o/k>cojn_[onc/k?o/
k>`5on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Cok>c/on_[joo/k>cok>c/
1Oo[jn/00oo/k>cojn_[on_[j`04on_[j`04onc/k?o[jn_ok>c/onc/k0Go
jn_[00?ok>c/on_[joo[jn/01?o[jn/01?o/k>cojn_[onc/k?o/k>`5on_[
j`03onc/k?o[jn_ojn_[00Cojn_[00Cok>c/on_[joo/k>cok>c/1Oo[jn/0
0oo/k>cojn_[on_[j`04on_[j`04onc/k?o[jn_ok>c/onc/k0Gojn_[00?o
k>c/on_[joo[jn/01?o[jn/01?o/k>cojn_[onc/k?o/k>`5on_[j`03onc/
k?o[jn_ojn_[00Cojn_[00Cok>c/on_[joo/k>cok>c/1Oo[jn/00oo/k>co
jn_[on_[j`04on_[j`04onc/k?o[jn_ok>c/onc/k0Gojn_[00?ok>c/on_[
joo[jn/00oo[jn/00ooZj^[ojNWYonOWi`02onSYj`?oinW[00?oinSZonOY
jooXjN/00_oWjN/01_oWj>[oinW[onOYjooWjN_oj>W[onOXjP;oj>W[0ooW
jN/00ooWj>[oinW[onSYj`02onOYj`06onOXj_oWjN_oinW[onOYjooXjN_o
inSZ0_oXjN/2onOYj`0<omgMgOo[jn_ojn_[onSXj?oNg]kohN7Qon[Zj_o[
jn_oj>SXomkNg_oQhN7oj^[Z0_o/k>`3on_[j`06on3Ph?oTi>Cok>c/on_[
jooQhN7oi>CT0_o[jn/01_oTi>Coh^;Ron_[joo/k>coj>SXomkNgP;ojn_[
00?oi^KVon3Ph?oQhN400_oPh>002?o[jn_oj>SXomkNg_oZj^[ok>c/on_[
jooWinOogmoO0_o[jn/01_oQhN7oi>CTon_[joo[jncohN7QonCTi0;ojn_[
00Goi^KVomoOgoo[jn_ojn_[onOWi`02on3Ph00>on3QhOoOgmoojn[Zon_[
jooQhN7oi>CTon_[joo[j^[ojn_[on?ShooQhN7ojn_[omoOgooWinL6on_[
j`03on7QhOoSi>Cojn_[00?ojn_[00Goi>CTomoOgooZj^[ojn_[onKViP03
on3Ph008omoOgooZj^[ojn_[on;Rh_oPh>3ojn_[on3Ph?oVi^H2on_[j`05
on[Zj_o[jn_ojn_[on[Zj_o[jn/00ooZj^X00ooNg]kohn?Son_[j`05on_[
j`03on[Zj_o[jn_ojn_[00Gojn_[00?ojn_/on_[joo[jn/01?o[jn/01?o[
jncojn_[on_[k?o[jn`2on_[j`?oj^[Z00?ojn_/on[Zj_o[jn/01Oo[jn/0
0ooZj^[ojn_[on_[k003on_[j`;oj^[Z00?ojn_[on[Zj_o[jn/00_o[jn/0
1?oZj^[ojn_[on_[jooZj^X2on_[k0?ojn_[0_oZj^X00oo[jn_oj^[Zon_[
j`05on_[j`03on[Zj_o[jn_ojn_/00;ojn_[0ooZj^X01_o[jn_oj^[Zon_[
jooZj^[ojn_[on[ZjP;ojn_[00?oj^[Zon_[joo[jn`00oo[jn/06Onl_;co
d];Boo7alOogmoOonOWioo[jn_oFe]KoCDe=olC4a?o/k>comOGeoo_knoon
o_kon_[joo3`l?o^knooI6ATofMWIomZJV[oKFe]og9bLomdM7GoMWMgogIf
M_mgMgL00OmiNGT00003onoal_o`lO;oko7b00;ol?7c00?oko7boo3aloo`
lO800_o_lO802Oo`lO?oko3bonoal_o^l?7ok^o`oo[jn_oinOWo?CdmogYj
NP02oo[jnP0;odU9BOmbLW;onOWiooWinOmmOGgo?ShnooShn?ojn_[o/[:b
oaHF5_ojn_X00ooinOT02oohn?SoUiNGob`/;?ojn_[oemOGo`h>3_ne]KGo
n_[jooWinOn][Jgo7AdM00;on_[j017oB4Q8oh>3PooinOWon_[jodU9BOmT
I6Con_[jooWinOnNWYko:BTYoo[jn_oinOWon_[jooWinOohn?SoUiNGob`/
;002ooWin@0;odU9BOm_Kfoon_[joo[jn_oalO7o6a/Koj>SXoojn_[oTi>C
odM7AooinOT00_ojn_X3ooWin@04oclo?omiNGWon_[joo[jnP;onOWi013o
WinOoa0@4?odm?Con_[jooWinOojn_[on?ShoiJFU_l/;2conOWioo7alOlL
71coXj>Soo[jn_nCTi?oATI60_ojn_X00ooinOWon_[jooWin@02oo[jnP04
ooWinOoNg]ko6ATIolG5a@?on_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi
00;on_[j0ooinOT4oo[jnP;onOWi0_ojn_X00ooinOWon_[jooWin@02oo[j
nP?onOWi1?ojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT00_ojn_X3ooWi
n@Con_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi00;on_[j0ooinOT4oo[j
nP;onOWi0_ojn_X00ooinOWon_[jooWin@02oo[jnP?onOWi1?ojn_X2ooWi
n@;on_[j00?onOWioo[jn_oinOT00_ojn_X3ooWin@Con_[j0_oinOT2oo[j
nP03ooWinOojn_[onOWi00;on_[j0ooinOT4oo[jnP;onOWi0_ojn_X00ooi
nOWon_[jooWin@02oo[jnP?onOWi1?ojn_X2ooWin@;on_[j00?onOWioo[j
n_oinOT00_ojn_X3ooWin@Con_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi
00;on_[j0ooinOT4oo[jnP;onOWi0_ojn_X00ooinOWon_[jooWin@02oo[j
nP?onOWi1?ojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT00_ojn_X3ooWi
n@Con_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi00;on_[j0ooinOT4oo[j
nP;onOWi0_ojn_X00ooinOWon_[jooWin@02oo[jnP?onOWi1?ojn_X2ooWi
n@;on_[j00?onOWioo[jn_oinOT00_ojn_X3ooWin@Con_[j0_oinOT2oo[j
nP03ooWinOojn_[onOWi00;on?Sh00GomOGeooGgnOoemoSom_OiooKhn@02
ooKgn@09ooGgnOoemoSom_OiooKgnOoemoWom_OiooGgn?ofmoWom_Si00;o
mOOi00?omOOhooKgnOofn?T00_ofmoT02OoemoWomOOhooKgnOofmoWomOOi
ooKgnOoemoSom_OiooKhn@02ooGgn@04ooGgn?ofmoWom_Sion_[j`;onOWi
00?olo?cono_kooinOT00ooinOT01?ofm_KokNg]ono_koohn?P4ooWin@06
ono_koobl_;onOWiooWinOo_knoolO7a0_oinOT01_obl_;okno_ooWinOoi
nOWomOGeong]k@GonOWi00[om?Cdonk^k_oinOWomoOgon_[jooemOGon_[j
ooWinOoemOGokNg]0_oinOT01_o_knoolo?cooWinOoinOWokno_oo7`l0;o
nOWi00?olo?dong]kOoinOT00_oinOT02?ohn?SonOWiooCdm?o]k^konOWi
ooWhn?o_knoolO7a0_oinOT01ooin?Sok>c/ooCdm?oinOWolo?cono_kooh
nOT01?oinOT00ooin?Sok^k^oo;blP03ooWin@06ooSinOoclo?ok>c/ooSh
nOoinOWon?Sh0_oinOT02oocm?CokNg]ooShn?ohn?SokNg]ooCdm?ohn?So
loCdonk_koohn?SonOWi00?on?Sh0_oinOT02_ogmoOolo?cono_koo/k>co
moShooWinOohn?SonOWiooSinOohn?P3ooWin@03ooShn?oinOWonOWi00Ko
nOWi00Gon?ShooWinOohn?Son?ShooWjnP02ooWin@04ooSinOoinOWonOWi
ooShn0;onOWi0_ohn?P3ooWin@;on?Sh00ConO[jooWinOohn?Son?Sh1?oi
nOT3ooShn0?onOWi00?on?ShooWinOoin_X00_ohn?P01?ohnOWonOWiooWi
nOohn?P3ooWin@04ooShn?oinOWonOWiooWin@;on?Sh00ConO[jooWinOoh
n?Son?Sh0_oinOT00oohn?SonOWiooShn002ooShn0?onOWi0_ohn?P01?oi
n_[onOWiooShn?ohn?P2ooWin@0JooShn?nl_;codM7Boo7alOogmoOon?Sh
ooWin_miNGWoC4a<ofe]KOoZj^[omOGeoo[jn_okno_on_[joo3`l?ono_ko
Hf=SofQXJOm[K6coK6a/ofi^K_mcLgCoMGIfogMhN?mfMWH1ogQhN00000?o
m?KgooGfn?odm_L01?odmOL2ooGfm`;om?Kg00Com?Ggoo?em_ocmOKol_Ce
0_ono_h03_lo?cooOGemookno_ono_koBTY:ob8R8_nBTY;ojNWYodU9BOl[
:b_oJFUYon?ShomiNGWo?Shn0_ono_h03Onh^;Sofm_Koo_knomYJFWoGEeM
ookno_ooooooATI6oe1@D?oRh^;olO7aoemOGolN7Qh00_ono_h02_m;Bd_o
QXJ6ookno_ono_koBTY:ob4Q8OmmOGgogmoOof1PH?mFEUH2ooknoP05okNg
]ooLg=cono_kofUYJOmMGEd00_ono_h02om:BT[o820PoiJFU_oUiNGoYZJV
oa`L7?oemOGoo_knonk^k_lF5QKofMWI00Goo_kn00Co@D51og]kNoono_ko
o_kn0_ooool04OnEUIGo4a<Coo[jn_ono_ko^;Rhom_Kfookno_oJFUYoeeM
GOono_koYjNWoa/K6oodm?Coo_knonk^k_lG5aOof=SH00?oo_kn00?ooooo
ookno_ono_h00_ono_h00onDU9Co?Cdmooclo002ooknoP;ooooo1?ono_h0
0oooooooo_knooknoP07ooknoP;ooooo1?ono_h00oooooooo_knooknoP07
ooknoP;ooooo1?ono_h00oooooooo_knooknoP07ooknoP;ooooo1?ono_h0
0oooooooo_knooknoP07ooknoP;ooooo1?ono_h00oooooooo_knooknoP07
ooknoP;ooooo1?ono_h00oooooooo_knooknoP07ooknoP;ooooo1?ono_h0
0oooooooo_knooknoP07ooknoP;ooooo1?ono_h00oooooooo_knooknoP07
ooknoP;ooooo1?ono_h00oooooooo_knooknoP07ooknoP;ooooo1?ono_h0
0oooooooo_knooknoP07ooknoP;ooooo1?ono_h00oooooooo_knooknoP07
ooknoP;ooooo1?ono_h00oooooooo_knooknoP07ooknoP;ooooo1?ono_h0
0oooooooo_knooknoP07ooknoP;ooooo1?ono_h00oooooooo_knooknoP07
ooknoP;ooooo1?ono_h00oooooooo_knooknoP07ooknoP;ooooo1Oono_h0
0oomoOgoo?cloo[jnP02oo[loP04oo[koOojo?gon__moo[lo@;onocn0_oj
nod01Oojo?kon_cmoo_lo_ojnogon_cm00?on_cn00Con__moo[loOojnogo
n_cm0_oko?h2oo[ko@05oo[lo_ojo?gonocnoo[koOojo?d00oojo?h00ooj
nogon_cmoo7al@03oogmo@09ooclo?omoOgooOgmoogmoOono_kooOgmoo[j
n_oalO7om?Cd00CooOgm00kolo?cooOgmoomoOgooOgmoo?cloobl_;omoOg
ooclo?oclo?ol_;booGemOolo?com_Kfoo?cl`;ooOgm00GonOWiooclo?om
oOgomOGeooCdm002oogmo@;om?Cd00Cono_kooclo?oemOGol_;b0_omoOd0
4Ooclo?om_KfoogmoOomoOgolo?doo7alOofm_Kono_kooGemOodm?CooOcl
oogmoOojn_[ono_kooclo?oemOGom?Cd00;ooOgm00kom?Cdoo7alOogmoOo
o?clooShn?oalO;oo?clooglo?olo?colO7aoo_knooloOgooOgmoocmo@;o
oOgm00?olo?dooKfm_oloOd00oomoOd03Oofm_Kol?3`oogmoOomoOgonOWi
oo_knoomoOgomOGeooCdm?omoOgonOWioo7alOokno/00_olo?`00ooalO7o
n_[jooclo004ooclo006ooWjn_o`l?7olo?cooKfm_olo?coo?cm0_olo?`2
oogmo@;oo?cl0_omoOd2ooclo003oogmoOoloOgooOgm00;ooOgm00?oo?cm
oocmoOomoOd00_omoOd00ooloOgooOgmoogmo@02oogmo@04oocmoOomoOgo
o?clooclo0;ooOgm0_olo?`3oogmo@03ooclo?omoOgooOgm00;ooOgm00Co
o?gmoogmoOolo?coo?cl0_omoOd2ooclo005oogmoOolo?cooOgmoocmoOom
oOd00_olo?`01?omoOgoo?gmooclo?olo?`3oogmo@03oocloOoloOgooOgm
00;ooOgm00?oo?cloogmoOomoOd00_olo?`01?oloOgooOgmooclo?olo?`2
oogmo@;oo?cl0oomoOd00oolo?cooOgmoogmo@02ooclo00LoocmoOomoOgo
o?clokfm_OoCdm?olO7aooKfm_ogmoOo^[ZjoeADE?m<C4coCDe=ojj^[_oc
lo?onOWiooclo?ohn?Wok^k^onc/k?mPH63oIFIVofQYJOmXJ6SoJf][ofm`
L?maLW;oM7AeogEeMP7oM7Ad00001?o`l_?oko7boo3aloo_lO82oo3al`;o
ko7b02Kol?;conoal_o_lO;ol?7conoal_o_l?7ok^o`ooWinOojn_[o?Cdm
og]kNooinOWon_[joeaLG?n>SXkoMGEeoadM7Olc<c?od];BoibLW?lV9RKo
:b/[ojf][OoinOWon_[johf=SOlm?Cgo71`Lod92@_o3`l?on_[jooWinOoP
h>3oC4a<oaPH6?ld=3CoNWYjocDe=@;onOWi00[oG5aLoi2@T?ojn_[onOWi
oeaLG?n?ShooOGemob0P8?li>CWo`l?30_ojn_X03_n=SHgo?3`loa`L7?m2
@T;o`l?3ooWinOojn_[oFe]Kohf=SOmTI6Co5QHFoe]KFomfMWKonOWi0_oj
n_X02OmaLG7oRHV9ooWinOoinOWon_[jooWinOojn_[o?cloogUiN@02oo[j
nP0>ooWinOojn_[oFEUIocLg=oojn_[onOWiohf=SOll?3co71`Lod92@_o3
`l?on_[jof5QHOmfMWH2oo[jnP03ooWinOmbLW;oR8R800;on_[j00WonOWi
oo[jn_oinOWonOWioo[jn_oinOWomoOgocXj>_nIVIT00_ojn_X00ooinOWo
n_[jooWin@02oo[jnP08ooWinOojn_[onOWiooWinOojn_[onOWioo[jn_oi
nOT3oo[jnP03ooWinOojn_[onOWi00;on_[j00SonOWioo[jn_oinOWonOWi
oo[jn_oinOWon_[jooWin@?on_[j00?onOWioo[jn_oinOT00_ojn_X02?oi
nOWon_[jooWinOoinOWon_[jooWinOojn_[onOWi0oojn_X00ooinOWon_[j
ooWin@02oo[jnP08ooWinOojn_[onOWiooWinOojn_[onOWioo[jn_oinOT3
oo[jnP03ooWinOojn_[onOWi00;on_[j00SonOWioo[jn_oinOWonOWioo[j
n_oinOWon_[jooWin@?on_[j00?onOWioo[jn_oinOT00_ojn_X02?oinOWo
n_[jooWinOoinOWon_[jooWinOojn_[onOWi0oojn_X00ooinOWon_[jooWi
n@02oo[jnP08ooWinOojn_[onOWiooWinOojn_[onOWioo[jn_oinOT3oo[j
nP03ooWinOojn_[onOWi00;on_[j00SonOWioo[jn_oinOWonOWioo[jn_oi
nOWon_[jooWin@?on_[j00?onOWioo[jn_oinOT00_ojn_X02?oinOWon_[j
ooWinOoinOWon_[jooWinOojn_[onOWi0oojn_X00ooinOWon_[jooWin@02
oo[jnP08ooWinOojn_[onOWiooWinOojn_[onOWioo[jn_oinOT3oo[jnP03
ooWinOojn_[onOWi00;on_[j00SonOWioo[jn_oinOWonOWioo[jn_oinOWo
n_[jooWin@?on_[j00?onOWioo[jn_oinOT00_ojn_X02?oinOWon_[jooWi
nOoinOWon_[jooWinOojn_[onOWi0oojn_X00ooinOWon_[jooWin@02oo[j
nP08ooWinOojn_[onOWiooWinOojn_[onOWioo[jn_oinOT3oo[jnP03ooWi
nOojn_[onOWi00;on_[j00SonOWioo[jn_oinOWonOWioo[jn_oinOWon_[j
ooWin@?on_[j00?onOWioo[jn_oinOT00_ojn_X02?oinOWon_[jooWinOoi
nOWon_[jooWinOojn_[onOWi0oojn_X00ooinOWon_[jooWin@02oo[jnP;o
nOWi00Kon?ShooOgmoofm_KomOOhooKgnOoemoT3ooKgn@03ooGgn?ofn?Wo
mOOi00;om_Oi00SomOOiooKgnOoemoWomOOhooKgnOoemoSom_OiooGgn@?o
m_Oi00?omOOhooKhnOoemoT00_ofmoT02_oemoWom_OiooGgnOoemoSom_Oi
ooGgn?ofmoWomOOiooKgnOo/k>`2ooWin@03oo[jn_oinOWonOWi00GonOWi
00Com_Kfonc/k?o`l?3on?Sh0_oinOT03_o_knool_;boo[jn_oinOWol?3`
ooCdm?obl_;okNg]onk^k_ofm_Kom?Cdong]kOo^k^komOGe0_oinOT01Ooc
lo?ok^k^ong]kOo_knoom_Kf00;onOWi00Kon?Shono_koo/k>cok^k^oo;b
l_o_knl2ooWin@0Noo3`l?oclo?onOWiooWjn_o`l?3olo?coo;cloo]k>co
k^k^ooKfm_ohn?SonOWioo;bloo_k^ook>c]ono_koofm_KonOWiooShn?oa
lO7olo?coo3`l?o]k>col?3`oo;bl_oinOWon?ShooWinOoalO7olo?c1?oi
nOT00oohn?Sokno_oo;blP04ooWin@0=ono_koo]kNgonOWiooSinOocm?Co
k^k^ong]kOo_knoomOGeooShn?oalO7olO7booShn002ooWin@09oo7alOob
l_;on?ShooWinOohn?SonOWiooShn?ofm_Kok^k^00;on?Sh00?onO[jooWi
nOohn?P00ooinOT2ooShn004ooWinOohnOWonOWiooShn0ConOWi00ConO[j
ooWinOohn?SonOWi0oohn?P2ooWin@04ooSinOoinOWonOWiooWin@?on?Sh
00?onOWiooShn?ohn?P00_oinOT3ooShn003ooWinOohn?SonOWi00;onOWi
0oohn?P00ooinOWon?ShooShn006ooWin@05ooShn?oinOWonOWiooWinOoh
n?P00_oinOT00ooin_[onOWiooWin@02ooWin@;on?Sh0_oinOT01?ohn?So
nOWiooWinOoinOT3ooShn003ooWinOohn?Son?Sh00;onOWi0_ohn?P2ooWi
n@0NooShn?oinOWonOWiooWinOohn?So_Kfmom;Bd_obl_;omoOgonk^k_mW
IfOoE5ADode=COm?CdooG5aLonWYjOojn_[ooOgmooWjn_o`l?3oi^KVof=S
HomXJ6WoJfa/ofa/K?m^KVkoLg=dogEeM_mgN7SoNGUj0OmhN7P000?ohN?T
00?oh^?Uon7Si?oQhn@00ooQhn@01_oRhnGohN;Ton7Ri?oQh^Coh>7Ron3R
h`;ojn_[00?o>c/kogAdM?o[jn/01?o[jn/01ooZj^[ojn_[on_[joo[jn_o
k>c/on[Zj_o/k>`01?o[jn/00ooZj^[ojn_[on_[j`04on_[j`05onWYjOo[
jn_ok>c/on_[joo/k>`02?o[jn/00ooZj^[ojn_[on_[j`02on_[j`03onc/
k?o[jn_oj^[Z00Oojn_[00?ojNWYon_[joo[jn/00oo[jn/00oo/k>cojn_[
onc/k004on_[j`03oc`l??mbLW;ojn_[00;ojn_[00SoV9RHo`h>3_nIVIWo
jn_[onc/k?o[jn_ok>c/onWYj@cojn_[00?ok>c/on_[joo/k>`01?o[jn/0
0onl_;co7alOomWIf@06on_[j`03onc/k?o[jn_ok>c/00gojn_[00?ok>c/
on_[joo/k>`03Oo[jn/00oo/k>cojn_[onc/k00=on_[j`03onc/k?o[jn_o
k>c/00gojn_[00?ok>c/on_[joo/k>`03Oo[jn/00oo/k>cojn_[onc/k00=
on_[j`03onc/k?o[jn_ok>c/00gojn_[00?ok>c/on_[joo/k>`03Oo[jn/0
0oo/k>cojn_[onc/k00=on_[j`03onc/k?o[jn_ok>c/00gojn_[00?ok>c/
on_[joo/k>`03Oo[jn/00oo/k>cojn_[onc/k00=on_[j`03onc/k?o[jn_o
k>c/00gojn_[00?ok>c/on_[joo/k>`03Oo[jn/00oo/k>cojn_[onc/k00=
on_[j`05onc/k?oZj^[ojn_[onWYjOoWinL00_oWjN/00ooXjN_oinW[onOY
j`04onOYj`07onOXj_oWjN_oj>W[onOXj_oXjN_oinW[onOXjP02onOYj`03
onSYjooWjN_oinW[00CoinW[00OoinSZonOYjooXjN_oinSZonSYjooWjN_o
inSZ00;oinW[00?oj>W[onOYjooMgMd01_o[jn/00oo/k>cojn_[onc/k002
on_[j`03onSXj?oNg]koi>CT00;ojn_[00?ohN7QonCTi?o[jn/00oo[jn/0
0oo/k>cojn_[onc/k00=on_[j`03onc/k?o[jn_ok>c/00_ojn_[00Coj^[Z
on_[joo[jn_oj^[Z1?o[jn/01?o[j^[ojn_[on_[joo[j^X8on_[j`05onc/
k?o[jn_ojn_[on_[joo[j^X01Oo[jn/02?oPhN7oi>CTon_[joo[jn_ojn_/
onGVi_oNg]koi^KV0_o[jn/01?oZj^[ojn_[on_[joo[jn/2on[ZjP;ojn_[
0_oZj^X00oo[jncojn_[on_[j`04on[ZjP03on_[jooXj>Soh>3P00;oj^[Z
0_o[jn/2on[ZjP04on_[k?o[jn_ojn_[on[ZjP;ojn_[00?oj^[Zon_[joo[
jn/01oo[jn/00oo[jncojn_[onc/k006on_[j`Koj^[Z00?ojn_[on_[k?oZ
j^X00oo[jn/2on[ZjP;ojn_[0_oZj^X2on_[j`;oj^[Z00Gojn_[on_[k?o[
jn_ok>c/on_[j`02on[ZjP;ojn_[0_oZj^X6on_[j`03on_[k?oZj^[ojn_[
00;ojn_[0_oZj^X2on_[j`Koj^[Z00?ojn_[on_[k?oZj^X00oo[jn/2on[Z
jP;ojn_[01[oj^[Zokfm_OoCdm?ol_;booOgmonTY:CoEEEEoeAEEOm=CDgo
Cdm?oe5ADOnFUYKon_[jookno_ojn_[ol?3`onk^k_mTI6CoJFUYofa]KOm/
K6coKfm_ogAeMOmfMgOoN7UiogMgM`7oNGUi00000oo_lO;ol?7coo3bl`02
onoalP04oo3aloo_lO;ol?7conoalP;ol?7c00Soko3bonoal_o_l?7ok^o`
oo[jn_oinOWo?Shnog]kN`;onOWi00Con_[jooWinOojn_[onOWi0_ojn_X0
1_oinOWon_[joo[jn_oinOWon_[jooWin@;on_[j0_oinOT01?ojn_[onOWi
oo[jn_oinOT2oo[jnP08ooWinOojn_[on_[jooWinOojn_[oHV9RoiFEUOoj
n_X2ooWin@04oo[jn_oinOWon_[jooWin@;on_[j00KonOWioo[jn_ojn_[o
nOWioo[jn_oinOT2oo[jnP;onOWi00Con_[jooWinOojn_[onOWi0_ojn_X0
1_oinOWon_[joo[jn_oinOWon_[jooWin@;on_[j00Oo?cloocPh>?m[Jf_o
EeMGocPh>?lD51CoTY:B00;onOWi0_ojn_X00ooinOWon_[jooWin@02oo[j
nP;onOWi00Con_[jooWinOojn_[onOWi0_ojn_X01OoinOWon_[joo[jn_oi
nOWoSXj>00Co@D5100Go5QHFoiJFU_oinOWon_[jooWin@02oo[jnP06ooWi
nOojn_[on_[jooWinOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oinOWon_[j
ooWin@;on_[j00KonOWioo[jn_ojn_[onOWioo[jn_oinOT2oo[jnP;onOWi
00Con_[jooWinOojn_[onOWi0_ojn_X01_oinOWon_[joo[jn_oinOWon_[j
ooWin@;on_[j0_oinOT01?ojn_[onOWioo[jn_oinOT2oo[jnP06ooWinOoj
n_[on_[jooWinOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oinOWon_[jooWi
n@;on_[j00KonOWioo[jn_ojn_[onOWioo[jn_oinOT2oo[jnP;onOWi00Co
n_[jooWinOojn_[onOWi0_ojn_X01_oinOWon_[joo[jn_oinOWon_[jooWi
n@;on_[j0_oinOT01?ojn_[onOWioo[jn_oinOT2oo[jnP06ooWinOojn_[o
n_[jooWinOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oinOWon_[jooWin@;o
n_[j00KonOWioo[jn_ojn_[onOWioo[jn_oinOT2oo[jnP;onOWi00Con_[j
ooWinOojn_[onOWi0_ojn_X01_oinOWon_[joo[jn_oinOWon_[jooWin@;o
n_[j0_oinOT01?ojn_[onOWioo[jn_oinOT2oo[jnP06ooWinOojn_[on_[j
ooWinOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oinOWon_[jooWin@;on_[j
00KonOWioo[jn_ojn_[onOWioo[jn_oinOT2oo[jnP;onOWi00Con_[jooWi
nOojn_[onOWi0_ojn_X01_oinOWon_[joo[jn_oinOWon_[jooWin@;on_[j
0_oinOT01?ojn_[onOWioo[jn_oinOT2oo[jnP06ooWinOojn_[on_[jooWi
nOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oinOWon_[jooWin@;on_[j00Ko
nOWioo[jn_ojn_[onOWioo[jn_oinOT2oo[jnP;onOWi00Con_[jooWinOoj
n_[onOWi0_ojn_X01_oinOWon_[joo[jn_oinOWon_[jooWin@;on_[j0_oi
nOT01?ojn_[onOWioo[jn_oinOT2oo[jnP06ooWinOojn_[onOWiooShn?og
moOomOGe0_ofmoT2ooGgn004ooKgnOoemoWom_OiooGgn@;om_Oi00KomOOh
ooKgnOofmoWomOOiooKgnOoemoT2ooKgn@;omOOh00Com_OiooGgnOofmoWo
mOOi0_ofmoT01_oemoSom_OiooKgnOoemoWom_OiooGgn@;om_Oi0_oemoP0
0oo/k>conOWiooWin@0:ooWin@06ooOgmoohn?SonOWiooWinOo^k^kol_;b
7OoinOT00ooalO7olo?cooWin@03ooWin@03ooSinOoinOWonOWi00GonOWi
00?on?WiooShn?oinOT01OoinOT00oohnOWonOWiooWin@05ooWin@;on?Wi
0ooinOT02Oo^k^kok^k_oo7alOo_knook^k^onc/k?oclo?onOWiooShn002
ooWin@;on?Wi0ooinOT01Oohn?SonOWiooWinOohnOWonOWi00;on?Sh00Oo
nOWiooShn?oinOWonOWiooSinOoemOGokNg]00?okno_00?om?CdooWinOoh
nOT01?oinOT00oohn?SonOWiooWin@02ooSin@KonOWi00?on?WiooWinOoi
nOT01OoinOT2ooSin@03ooWinOohn?SonOWi00?onOWi00Kon?WiooWinOoi
nOWon?ShooWinOohn?P2ooWin@06ooSinOohn?SonOWiooShn?oinOWon?Sh
0_oinOT00oohn?SonOWiooWin@02ooWin@05ooShn?oinOWonOWiooSinOoh
n?P01_oinOT01_ohnOWonOWiooWinOohn?SonOWiooShn0;onOWi00Kon?Wi
ooShn?oinOWon?ShooWinOohn?P2ooWin@06ooSinOoinOWon?ShooShn?oi
nOWon?Sh0_oinOT2ooSin@05ooWinOnm_Kgodm?Coo;bl_ogmoL00_oinOT0
4oofm_KohN7QonSXj?o^k^kom?Cdoo_knoomoOgonOWiono_koooooooHf=S
ofIVI_mYJFWoK6a/og5aL_mcLg?oMGEfogEeMOmfMWH00OmhN7P000Kom?Kg
00Kom?GgooCfn?odm_Oom?GgooCfmoodmOL2ooCemP07oo;dmOono_koo_kn
ok:b/_o;bl_oo_knooooo`02ooknoP03ooooooono_koo_kn00?oo_kn00?o
ooooookno_ono_h01?ono_h01?ooooooo_knookno_ooool5ooknoP05oooo
ooono_koo_knokNg]oo?cll00_ono_h01?ooooooo_knookno_ooool5ookn
oP03ooooooono_koo_kn00Coo_kn00Coooooookno_ono_kooooo1Oono_h0
0oooooooo_knooknoP03ooknoP06okBd]?nPX:3oWinOojJVY_o7alOojn_[
1?ono_h00oooooooo_knooknoP04ooknoP04ooooooono_koo_knooooo`Go
o_kn00?oooooookno_o7alL01?nOWil01?nPX:3oeMGEookno_ooool5ookn
oP03ooooooono_koo_kn00Coo_kn00Coooooookno_ono_kooooo1Oono_h0
0oooooooo_knooknoP04ooknoP04ooooooono_koo_knooooo`Goo_kn00?o
ooooookno_ono_h01?ono_h01?ooooooo_knookno_ooool5ooknoP03oooo
ooono_koo_kn00Coo_kn00Coooooookno_ono_kooooo1Oono_h00ooooooo
o_knooknoP04ooknoP04ooooooono_koo_knooooo`Goo_kn00?oooooookn
o_ono_h01?ono_h01?ooooooo_knookno_ooool5ooknoP03ooooooono_ko
o_kn00Coo_kn00Coooooookno_ono_kooooo1Oono_h00oooooooo_knookn
oP04ooknoP04ooooooono_koo_knooooo`Goo_kn00?oooooookno_ono_h0
1?ono_h01?ooooooo_knookno_ooool5ooknoP03ooooooono_koo_kn00Co
o_kn00Coooooookno_ono_kooooo1Oono_h00oooooooo_knooknoP04ookn
oP04ooooooono_koo_knooooo`Goo_kn00?oooooookno_ono_h01?ono_h0
1?ooooooo_knookno_ooool5ooknoP03ooooooono_koo_kn00Coo_kn00Co
ooooookno_ono_kooooo1Oono_h00oooooooo_knooknoP04ooknoP04oooo
ooono_koo_knooooo`Goo_kn00?oooooookno_ono_h01?ono_h01?oooooo
o_knookno_ooool6ooknoP0=oogmoOolo?con_[joo[koOojo?gon_cnoo_l
o_ojo?gon__moo_lo_ojo?kon__moo[loP02oo[lo@0>oo_lo_ojnogon_cn
oo[loOojnogon_cmoo[lo_oko?kon_cmoo[koOoko?kon_cnoo[koOojo?h2
oo[lo@09oo_lo_ojnogon_cnoo[loOojnogon_cmoo[lo_oko?kol?3`013o
o_kn00?onOWiooclo?ono_h07?ono_h01Oojn_[ono_kookno_ono_kooOkn
00;oo_kn00?ooOknookno_omo_h00_ono_h01_omo_koo_gmookno_ono_ko
o_gmoogmo@;oo_kn00KooOknookno_onoOgooOknookno_omoOd2ooknoP03
oogno_ono_koo_kn00;oo_kn00CooOknookno_ojn_[on?Sh0_oinOT00ook
no_ooOgmoognoP02ooknoP03oogno_ono_koo_kn00;oo_kn00CooOknookn
o_ono_kooOkn0_ono_h00oomo_koo_knoognoP02ooknoP05oogno_ono_ko
o_knoogmoOohnOT00_ohn?P01ooinOWono_kookno_ono_kooOknookno_om
o_h00_ono_h00oomo_koo_knooknoP02ooknoP04oogno_ono_koo_knoogn
oP;oo_kn00?ooOknookno_omo_h00_ono_h01?omo_koo_knookno_ono_h2
oogmo@;oo_kn0_omoOd01?ono_kooOknookno_omo_h2ooknoP03oogno_on
o_koo_kn00;oo_kn00CooOknookno_ono_kooOkn0_ono_h01?omo_koo_kn
oogno_ono_h2oogmo@?oo_kn0_omoOd2ooknoP;ooOgm00Coo_knoogno_on
o_kooOkn0_ono_h00oomo_koo_knooknoP02ooknoP04oogno_ono_koo_kn
oognoP;oo_kn00?ooOknookno_omoOd00_ono_h00oomo_koo_knooknoP02
ooknoP0Iokfn__oDe=Colo?cooOgmooinOWon_[jooKfm_oRh^;oj>SXonk^
k_odm?Cono_koogmoOojn_[ol?3`onk_komVIVKoJFUZofa/KOm_Kg3oLW9c
ogAdMOmfMgOoN7UiogYjN`01ogalO@000_o`lO<01?o`l_?oko7conoal_o`
l_<2oo3al`07onoal_o`lO?oko7boo3aloo_lO;ok_3aonk_l004oo[jnP;o
nOWi00Kon_[jooWinOojn_[onOWioo[jn_oinOT2oo[jnP03ooWinOojn_[o
n_[j00?on_[j0_oinOT01_ojn_[onOWioo[jn_oinOWon_[jooWin@;on_[j
00?onOWioo[jn_ojn_X00oojn_X2ooWin@06oo[jn_oinOWon_[jooWinOoj
n_[onOWi0_ojn_X00ooinOWon_[joo[jnP03oo[jnP;onOWi00Kon_[jooWi
nOojn_[onOWioo[jn_oinOT2oo[jnP03ooWinOojn_[on_[j00?on_[j0_oi
nOT01_ojn_[onOWioo[jn_oinOWon_[jooWin@;on_[j00?onOWioo[jn_oj
n_X00oojn_X2ooWin@06oo[jn_oinOWon_[jooWinOojn_[onOWi0_ojn_X0
0ooinOWon_[joo[jnP03oo[jnP;onOWi00Kon_[jooWinOojn_[onOWioo[j
n_oinOT2oo[jnP03ooWinOojn_[on_[j00?on_[j0_oinOT01_ojn_[onOWi
oo[jn_oinOWon_[jooWin@;on_[j00?onOWioo[jn_ojn_X00oojn_X2ooWi
n@06oo[jn_oinOWon_[jooWinOojn_[onOWi0_ojn_X00ooinOWon_[joo[j
nP03oo[jnP;onOWi00Kon_[jooWinOojn_[onOWioo[jn_oinOT2oo[jnP03
ooWinOojn_[on_[j00?on_[j0_oinOT01_ojn_[onOWioo[jn_oinOWon_[j
ooWin@;on_[j00?onOWioo[jn_ojn_X00oojn_X2ooWin@06oo[jn_oinOWo
n_[jooWinOojn_[onOWi0_ojn_X00ooinOWon_[joo[jnP03oo[jnP;onOWi
00Kon_[jooWinOojn_[onOWioo[jn_oinOT2oo[jnP03ooWinOojn_[on_[j
00?on_[j0_oinOT01_ojn_[onOWioo[jn_oinOWon_[jooWin@;on_[j00?o
nOWioo[jn_ojn_X00oojn_X2ooWin@06oo[jn_oinOWon_[jooWinOojn_[o
nOWi0_ojn_X00ooinOWon_[joo[jnP03oo[jnP;onOWi00Kon_[jooWinOoj
n_[onOWioo[jn_oinOT2oo[jnP03ooWinOojn_[on_[j00?on_[j0_oinOT0
1_ojn_[onOWioo[jn_oinOWon_[jooWin@;on_[j00?onOWioo[jn_ojn_X0
0oojn_X2ooWin@06oo[jn_oinOWon_[jooWinOojn_[onOWi0_ojn_X00ooi
nOWon_[joo[jnP03oo[jnP;onOWi00Kon_[jooWinOojn_[onOWioo[jn_oi
nOT2oo[jnP03ooWinOojn_[on_[j00?on_[j0_oinOT01_ojn_[onOWioo[j
n_oinOWon_[jooWin@;on_[j00?onOWioo[jn_ojn_X00oojn_X2ooWin@06
oo[jn_oinOWon_[jooWinOojn_[onOWi0_ojn_X00ooinOWon_[joo[jnP03
oo[jnP;onOWi00Kon_[jooWinOojn_[onOWioo[jn_oinOT2oo[jnP0AooWi
nOohn?SomoOgooKfm_ofmoWom_SiooKgnOoemoSom_OiooGgnOofmoWomOOh
ooKgnOoemoWom_SiooKgnOoemoP01?ofmoT03?ofn?Wom_OiooGgn?ofmoWo
mOOiooKgnOoemoSom_OiooGgnOofn?Wom_OiooGgn0Com_Oi00Com_SiooKg
nOoemoSok>c/1OoinOT00oojn_[onOWiooWin@04ooWin@03oo[jn_oinOWo
nOWi00KonOWi00?on_[jooWinOoinOT01?oinOT00oojn_[onOWiooWin@06
ooWin@03oo[jn_oinOWonOWi00ConOWi00?on_[jooWinOoinOT00ooinOT0
1_ohnOWonOWiooWinOoin_[onOWiooSin@ConOWi00?onO[jooWinOohnOT0
0ooinOT01_ohnOWonOWiooWinOoin_[onOWiooSin@ConOWi00?onO[jooWi
nOohnOT00ooinOT01_ohnOWonOWiooWinOoin_[onOWiooSin@ConOWi00?o
nO[jooWinOohnOT00ooinOT01_ohnOWonOWiooWinOoin_[onOWiooSin@Co
nOWi00ConO[jooWinOohnOWonOWi0_ohn?P01_ohnOWonOWiooWinOoin_[o
nOWiooSin@ConOWi00?onO[jooWinOohnOT00ooinOT01_ohnOWonOWiooWi
nOoin_[onOWiooSin@ConOWi00WonO[jooWinOohn?SonOWiooShn?oinOWo
n?ShooWinOohn?P00_oinOT00oohnOWonOWiooWin@02ooWin@03ooWjn_oi
nOWon?Wi00?onOWi00Son?WiooWinOoinOWonO[jooWinOohnOWon?ShooWi
n@;on?Sh0_oinOT00oohnOWonOWiooShn002ooShn005ooWinOohn?SonO[j
ooWinOohnOT01?oinOT00ooin_[onOWiooSin@03ooWin@04ooSinOoinOWo
nOWiooWjnP?on?Sh0ooinOT01ooin_[onOWiooSinOoinOWo_Kfnom?De?ob
l_800_ohn?P05?ojn_[omOGeon7QhOoXj>SokNg]oo?clookno_oo_knooWj
n_o_knooinOWofEUIOmXJFWoJf]/ofi^KomaLG7oLg=dogEeM_mgN7SoNGUj
0OmkNg/000;ohN?T00Koh^?Uon7SiOoQhnCoh^?Ton7Si?oRhnD2on7Si005
on;Si?oQh^CohN;Ton3RhooPhN800oo[jn/00oo/k>cojn_[on_[j`02on_[
j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/k004
on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/
k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[
onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_o
jn_[onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[
jn_ojn_[onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[
joo[jn_ojn_[onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/
on_[joo[jn_ojn_[onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Go
k>c/on_[joo[jn_ojn_[onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[
00Gok>c/on_[joo[jn_ojn_[onc/k004on_[j`03onc/k?o[jn_ojn_[00Co
jn_[00Gok>c/on_[joo[jn_ojn_[onc/k004on_[j`03onc/k?o[jn_ojn_[
00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/k004on_[j`03onc/k?o[jn_o
jn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/k004on_[j`03onc/k?o[
jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/k004on_[j`03onc/
k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/k004on_[j`03
onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/k004on_[
j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/k004
on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/
k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[
onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_o
jn_[onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[
jn_ojn_[onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[
joo[jn_ojn_[onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Coj^[Z
onWYjOoWinOoinWZ0_oXjN/3onOYj`05onSYjooWjN_oinW[onOYjooWj>X0
0_oWjN/01?oXjN_oinW[onOYjooWjNX2onSYj`?oinW[00Goj>W[onOYjooW
jN_oinW[onOXjP02onOYj`04onSYjooWjN_oinW[onOYjP;oj>W[00?oinW[
omkNg_oZj^X0=?oZj^X00ooYj^[oj^[Zon[ZjP03on[ZjP03onWZj_oZj^[o
j^[Z00Ooj^[Z00?ojN[Zon[Zj_oZj^X00ooZj^X00ooYj^[oj^[Zon[ZjP07
on[ZjP03onWZj_oZj^[oj^[Z00?oj^[Z00?ojN[Zon[Zj_oZj^X01ooZj^X0
0ooYj^[oj^[Zon[ZjP03on[ZjP03onWZj_oZj^[oj^[Z00Ooj^[Z00?ojN[Z
on[Zj_oZj^X00ooZj^X00ooYj^[oj^[Zon[ZjP07on[ZjP03onWZj_oZj^[o
j^[Z00?oj^[Z00?ojN[Zon[Zj_oZj^X01ooZj^X00ooYj^[oj^[Zon[ZjP03
on[ZjP03onWZj_oZj^[oj^[Z00Ooj^[Z00?ojN[Zon[Zj_oZj^X00ooZj^X0
0ooYj^[oj^[Zon[ZjP07on[ZjP03onWZj_oZj^[oj^[Z00?oj^[Z00?ojN[Z
on[Zj_oZj^X01ooZj^X00ooYj^[oj^[Zon[ZjP03on[ZjP03onWZj_oZj^[o
j^[Z00;oj^[Z00Co_Kfmom?CdooalO;om_Kf0_ohn?P04ooemOGohN7QonSX
j?o/k>colo?coo[jn_omoOgonOWionk^k_o]k^koHV9SofEUI_mXJ6WoJV][
ofe]K_m_Kg3oLG9bog=cM?meMGH00OmfMgL00008onoal_o`l_?ol?7bonoa
l_o`l_?oko7boo3bloo_lO83oo3al`07ono`l_o_lO;ok_3aonk_l?ojn_[o
nOWioo[jnP02ooWin@04oo[jn_oinOWon_[jooWin@?on_[j00OonOWioo[j
n_oinOWonOWioo[jn_oinOWon_[j00;onOWi00Con_[jooWinOojn_[onOWi
0oojn_X01ooinOWon_[jooWinOoinOWon_[jooWinOojn_X00_oinOT01?oj
n_[onOWioo[jn_oinOT3oo[jnP07ooWinOojn_[onOWiooWinOojn_[onOWi
oo[jnP02ooWin@04oo[jn_oinOWon_[jooWin@?on_[j00OonOWioo[jn_oi
nOWonOWioo[jn_oinOWon_[j00;onOWi00Con_[jooWinOojn_[onOWi0ooj
n_X01ooinOWon_[jooWinOoinOWon_[jooWinOojn_X00_oinOT01?ojn_[o
nOWioo[jn_oinOT3oo[jnP07ooWinOojn_[onOWiooWinOojn_[onOWioo[j
nP02ooWin@04oo[jn_oinOWon_[jooWin@?on_[j00OonOWioo[jn_oinOWo
nOWioo[jn_oinOWon_[j00;onOWi00Con_[jooWinOojn_[onOWi0oojn_X0
1ooinOWon_[jooWinOoinOWon_[jooWinOojn_X00_oinOT01?ojn_[onOWi
oo[jn_oinOT3oo[jnP07ooWinOojn_[onOWiooWinOojn_[onOWioo[jnP02
ooWin@04oo[jn_oinOWon_[jooWin@?on_[j00OonOWioo[jn_oinOWonOWi
oo[jn_oinOWon_[j00;onOWi00Con_[jooWinOojn_[onOWi0oojn_X01ooi
nOWon_[jooWinOoinOWon_[jooWinOojn_X00_oinOT01?ojn_[onOWioo[j
n_oinOT3oo[jnP07ooWinOojn_[onOWiooWinOojn_[onOWioo[jnP02ooWi
n@04oo[jn_oinOWon_[jooWin@?on_[j00OonOWioo[jn_oinOWonOWioo[j
n_oinOWon_[j00;onOWi00Con_[jooWinOojn_[onOWi0oojn_X01ooinOWo
n_[jooWinOoinOWon_[jooWinOojn_X00_oinOT01?ojn_[onOWioo[jn_oi
nOT3oo[jnP07ooWinOojn_[onOWiooWinOojn_[onOWioo[jnP02ooWin@04
oo[jn_oinOWon_[jooWin@?on_[j00OonOWioo[jn_oinOWonOWioo[jn_oi
nOWon_[j00;onOWi00Con_[jooWinOojn_[onOWi0oojn_X01ooinOWon_[j
ooWinOoinOWon_[jooWinOojn_X00_oinOT01?ojn_[onOWioo[jn_oinOT3
oo[jnP07ooWinOojn_[onOWiooWinOojn_[onOWioo[jnP02ooWin@04oo[j
n_oinOWon_[jooWin@?on_[j00OonOWioo[jn_oinOWonOWioo[jn_oinOWo
n_[j00;onOWi00Con_[jooWinOojn_[onOWi0oojn_X01ooinOWon_[jooWi
nOoinOWon_[jooWinOojn_X00_oinOT01?ojn_[onOWioo[jn_oinOT3oo[j
nP07ooWinOojn_[onOWiooWinOojn_[onOWioo[jnP02ooWin@04oo[jn_oi
nOWon_[jooWin@?on_[j00gonOWioo[jn_oinOWon?ShooOgmooemOGom_Oi
ooGgnOoemoSom_OiooGgn?ofmoWomOOh00?om_Oi00gomOOiooKgnOoemoSo
mOOiooKgnOoemoSom_OiooGgnOoemoSom_OiooGgn?ofmoWomOOh00?om_Oi
00_omOOiooKgnOoemoSomOOiooKgnOoemoSom_OiooGgnOoemoSom_Oion_[
j`0aooWin@03ooSinOoinOWonOWi00?onOWi00Con?SiooWinOoinOWon?Si
0_oinOT01Oohn?WonOWiooSinOoinOWon?Wi00GonOWi00Con?SiooWinOoi
nOWon?Si0_oinOT01Oohn?WonOWiooSinOoinOWon?Wi00GonOWi00Con?Si
ooWinOoinOWon?Si0_oinOT01Oohn?WonOWiooSinOoinOWon?Wi00GonOWi
00Con?SiooWinOoinOWon?Si0_oinOT01Oohn?WonOWiooSinOoinOWon?Wi
00GonOWi00Con?SiooWinOoinOWon?Si0_oinOT01Oohn?WonOWiooSinOoi
nOWon?Wi00GonOWi00Con?SiooWinOoinOWon?Si0_oinOT01Oohn?WonOWi
ooSinOoinOWon?Wi00GonOWi00Con?SiooWinOoinOWon?Si0_oinOT01Ooh
n?WonOWiooSinOoinOWon?Wi00GonOWi00Con?SiooWinOoinOWon?Si0_oi
nOT01Oohn?WonOWiooSinOoinOWon?Wi00GonOWi00Con?SiooWinOoinOWo
n?Si0_oinOT01Oohn?WonOWiooSinOoinOWon?Wi00GonOWi00Con?SiooWi
nOoinOWon?Si0_oinOT01oohn?WonOWiooSinOnn_[kodm?Coo;bloohn?P0
0_oinOT04oofm_KohN;RonSXjOo^k^koloCdooclo?omoOgonOWioo3`l?on
o_koIFEUofQXJ?m[JfcoKVi_og1aLOmbLg?oMGEfogMgN?mhNGT00OmjNg/0
0006ooGfn?oem_Oom?KgooGfn?odm_Oom?Gg0oodm_L02?odmOOom?KgooCe
m_odmOOom?Gfoo?dmOono_kooooo0_ono_h00oooooooo_knooknoP07ookn
oP04ooooooono_koo_knooooo`;oo_kn00?oooooookno_ono_h00_ono_h0
1_o3`l?oRHV9ofUYJOn0P83od=3@ooooo`;oo_kn00Coooooookno_ono_ko
oooo2Oono_h01?ooooooo_knookno_ooool2ooknoP03ooooooono_koo_kn
00;oo_kn00?oh^;RohB4Q?ohn?P00_ono_h01?ooooooo_knookno_ooool2
ooknoP03ooooooono_koo_kn00Ooo_kn00Coooooookno_ono_kooooo0_on
o_h01?ooooooh^;RohB4Q?ohn?P6ooknoP04ooooooono_koo_knooooo`;o
o_kn00?oooooookno_ono_h01oono_h01?ooooooo_knookno_ooool2ookn
oP03ooooooono_koo_kn00Ooo_kn00Coooooookno_ono_kooooo0_ono_h0
0oooooooo_knooknoP07ooknoP04ooooooono_koo_knooooo`;oo_kn00?o
ooooookno_ono_h01oono_h01?ooooooo_knookno_ooool2ooknoP03oooo
ooono_koo_kn00Ooo_kn00Coooooookno_ono_kooooo0_ono_h00ooooooo
o_knooknoP07ooknoP04ooooooono_koo_knooooo`;oo_kn00?oooooookn
o_ono_h01oono_h01?ooooooo_knookno_ooool2ooknoP03ooooooono_ko
o_kn00Ooo_kn00Coooooookno_ono_kooooo0_ono_h00oooooooo_knookn
oP07ooknoP04ooooooono_koo_knooooo`;oo_kn00?oooooookno_ono_h0
1oono_h01?ooooooo_knookno_ooool2ooknoP03ooooooono_koo_kn00Oo
o_kn00Coooooookno_ono_kooooo0_ono_h00oooooooo_knooknoP07ookn
oP04ooooooono_koo_knooooo`;oo_kn00?oooooookno_ono_h01oono_h0
1?ooooooo_knookno_ooool2ooknoP03ooooooono_koo_kn00Ooo_kn00Co
ooooookno_ono_kooooo0_ono_h00oooooooo_knooknoP07ooknoP04oooo
ooono_koo_knooooo`;oo_kn00?oooooookno_ono_h02?ono_h02?omoOgo
o?cloo_knoojo?kon__moo_lo_ojo?gon__m0_ojo?h03_ojo?gon__moo[l
o_ojnogon_cnoo_lo_ojo?kon_cmoo_lo_ojo?kon__moo_lo_ojo?gon__m
0_ojo?h03_ojo?gon__moo[lo_ojnogon_cnoo_lo_ojo?kon_cmoo_lo_oj
o?kon__moo_lo_ojo?gokno_9oono_h01Ookno_on?ShooKfm_ogmoOoo?cl
00?oo_kn00OooOgmookno_ono_koo_knoogmo_ono_kooOgn00Koo_kn00Co
oOgnookno_ono_kooOgn0oono_h01oomoOkoo_knoogmo_ono_kooOgmooOg
moomoOd00_ono_h01?omoOkoo_knookno_omoOh3ooknoP03oogmo_ono_ko
oOgn00Koo_kn00CooOgnookno_ono_kooOgn0oono_h00oolo?comoOgoogm
o@06ooknoP04oogmo_ono_koo_knoogmoP?oo_kn00?ooOgnookno_omoOh0
1_ono_h01?omoOkoo_knookno_omoOh3ooknoP03oogmo_ono_kooOgn00Ko
o_kn00CooOgnookno_ono_kooOgn0oono_h00oomoOkoo_knoogmoP06ookn
oP04oogmo_ono_koo_knoogmoP?oo_kn00?ooOgnookno_omoOh01_ono_h0
1?omoOkoo_knookno_omoOh3ooknoP03oogmo_ono_kooOgn00Koo_kn00Co
oOgnookno_ono_kooOgn0oono_h00oomoOkoo_knoogmoP06ooknoP0Aoogm
o_ono_koo_knoogmo_nYZJWo];Bdol;2`_nj^[[o][Jfok>c/ona/K;oY:BT
ojVYZOn_[joo^KViolO7aooAdM400_oMgMd02_o^k^koIVIVofUYJOm/K6go
Kfm_og5bL_mdM7GoMWIgogQiNOmjNW/1og]lO0000_o_lO801oo`l_?oko7b
oo3aloo`lO?oko7boo3aloo_lO800_o`lO<2onoalP03ono`lOo^ko3on_[j
00;onOWi00Oon_[jooWinOojn_[on_[jooWinOojn_[onOWi00;on_[j00Go
nOWioo[jn_oinOWonOWioo[jnP02ooWin@0>oo[jn_oinOWon_[joo[jn_oi
nOWon_[johb<S?mjNW[oYZJVofUYJOlH61So^k^kooWinOojn_X2ooWin@07
oo[jn_oinOWon_[joo[jn_oinOWon_[jooWin@02oo[jnP05ooWinOojn_[o
nOWiooWinOojn_X00_oinOT02oojn_[onOWioo[jn_ojn_[onOWioo[jn_of
m_Ko:BTYojJVY_oinOWon_[j00;onOWi00Gon_[jooWinOoinOWon_[jooWi
n@02oo[jnP03ooWinOojn_[onOWi00;on_[j00GonOWioo[jn_oinOWonOWi
oo[jnP02ooWin@07oo[jn_oinOWom_KfobTY:OnUYJGon_[jooWin@02oo[j
nP05ooWinOojn_[onOWiooWinOojn_X00_oinOT01oojn_[onOWioo[jn_oj
n_[onOWioo[jn_oinOT00_ojn_X01OoinOWon_[jooWinOoinOWon_[j00;o
nOWi00Oon_[jooWinOojn_[on_[jooWinOojn_[onOWi00;on_[j00GonOWi
oo[jn_oinOWonOWioo[jnP02ooWin@07oo[jn_oinOWon_[joo[jn_oinOWo
n_[jooWin@02oo[jnP05ooWinOojn_[onOWiooWinOojn_X00_oinOT01ooj
n_[onOWioo[jn_ojn_[onOWioo[jn_oinOT00_ojn_X01OoinOWon_[jooWi
nOoinOWon_[j00;onOWi00Oon_[jooWinOojn_[on_[jooWinOojn_[onOWi
00;on_[j00GonOWioo[jn_oinOWonOWioo[jnP02ooWin@07oo[jn_oinOWo
n_[joo[jn_oinOWon_[jooWin@02oo[jnP05ooWinOojn_[onOWiooWinOoj
n_X00_oinOT01oojn_[onOWioo[jn_ojn_[onOWioo[jn_oinOT00_ojn_X0
1OoinOWon_[jooWinOoinOWon_[j00;onOWi00Oon_[jooWinOojn_[on_[j
ooWinOojn_[onOWi00;on_[j00GonOWioo[jn_oinOWonOWioo[jnP02ooWi
n@07oo[jn_oinOWon_[joo[jn_oinOWon_[jooWin@02oo[jnP05ooWinOoj
n_[onOWiooWinOojn_X00_oinOT01oojn_[onOWioo[jn_ojn_[onOWioo[j
n_oinOT00_ojn_X01OoinOWon_[jooWinOoinOWon_[j00;onOWi00Oon_[j
ooWinOojn_[on_[jooWinOojn_[onOWi00;on_[j00GonOWioo[jn_oinOWo
nOWioo[jnP02ooWin@07oo[jn_oinOWon_[joo[jn_oinOWon_[jooWin@02
oo[jnP05ooWinOojn_[onOWiooWinOojn_X00_oinOT01oojn_[onOWioo[j
n_ojn_[onOWioo[jn_oinOT00_ojn_X01OoinOWon_[jooWinOoinOWon_[j
00;onOWi00Oon_[jooWinOojn_[on_[jooWinOojn_[onOWi00;on_[j00Go
nOWioo[jn_oinOWonOWioo[jnP02ooWin@07oo[jn_oinOWon_[joo[jn_oi
nOWon_[jooWin@02oo[jnP05ooWinOojn_[onOWiooWinOojn_X00_oinOT0
1oojn_[onOWioo[jn_ojn_[onOWioo[jn_oinOT00_ojn_X02OoinOWon_[j
ooWinOohn?SomoOgooGemOoemoSom_OiooGgn@02ooKgn@03ooGgnOofmoWo
mOOi00;om_Oi00WomOOiooKgnOoemoWomOOhooKgnOoemoWomOOhooKgnOoe
moT00_ofmoT00ooemoWom_OiooGgn@02ooKgn@0;ooGgnOofmoWomOOiooGg
n?ofmoWomOOiooGgn?ofmoWomOOiooKgnOo/k>`09ooinOT01_oclo?olO7a
ooCdm?oalO7ok>c/ooKfmP_onOWi00Con?SiooWinOoinOWon?Si2ooinOT0
1OohnOWokNg]ooCdm?oinOWon?Si00conOWi00Con?SiooWinOoinOWon?Si
2?oinOT01Oo]k^kom?CdooWinOoinOWon?Si00;onOWi00?on?SiooWinOoi
nOT02_oinOT01?ohn?WonOWiooWinOohn?T<ooWin@04ooShnOoinOWonOWi
ooShn@conOWi00Con?SiooWinOoinOWon?Si3?oinOT01?ohn?WonOWiooWi
nOohn?T<ooWin@04ooShnOoinOWonOWiooShn@conOWi00Con?SiooWinOoi
nOWon?Si1?oinOT01?nm_Kgoe=CDoo;bl_ogmoL2ooWin@0CooKfm_oRh^;o
j>SXong]kOodm?Cono_koogmo_oinO[okno_onOWiomTIFGoJ6QXof][Jom^
KVkoL75aog9cLomeMGGoMgMhogQiN@01ogYjN`0000KohN?Ton;SiOoRi>Go
h^CUon7Si?oRhnD2on7Si008on;TiOoQhnGohN?Ton;Si?oQh^?oh>;Son7R
hoo/k>`2on_[j`;ok>c/1?o[jn/00oo/k>cojn_[on_[j`03on_[j`;ok>c/
0_o[jn/01ooKfm_oj^[Zon_[jooQhN7oh>3Pon_[joo/k>`00oo[jn/01?mK
Fe_oBd];onc/k?o/k>`2on_[j`;ok>c/1?o[jn/00oo/k>cojn_[on_[j`02
on_[j`03om[Jf_oZj^[ok>c/00;ohN7Q0_o/k>`4on_[j`03onc/k?n7QhOo
@d=300?ojn_[0_o/k>`2on_[j`;ok>c/1?o[jn/00oo/k>cojn_[on_[j`03
on_[j`03om_KfooZj^[ojn_[00;ohN7Q00Kok>c/on_[jon7QhOo@d=3on_[
joo/k>`5on_[j`;ok>c/00Cojn_[omWIfOo7alOoj>SX1?o[jn/00oo/k>co
jn_[on_[j`03on_[j`;ok>c/0_o[jn/2onc/k0Cojn_[00?ok>c/on_[joo[
jn/00oo[jn/2onc/k0;ojn_[0_o/k>`4on_[j`03onc/k?o[jn_ojn_[00?o
jn_[0_o/k>`2on_[j`;ok>c/1?o[jn/00oo/k>cojn_[on_[j`03on_[j`;o
k>c/0_o[jn/2onc/k0Cojn_[00?ok>c/on_[joo[jn/00oo[jn/2onc/k0;o
jn_[0_o/k>`4on_[j`03onc/k?o[jn_ojn_[00?ojn_[0_o/k>`2on_[j`;o
k>c/1?o[jn/00oo/k>cojn_[on_[j`03on_[j`;ok>c/0_o[jn/2onc/k0Co
jn_[00?ok>c/on_[joo[jn/00oo[jn/2onc/k0;ojn_[0_o/k>`4on_[j`03
onc/k?o[jn_ojn_[00?ojn_[0_o/k>`2on_[j`;ok>c/1?o[jn/00oo/k>co
jn_[on_[j`03on_[j`;ok>c/0_o[jn/2onc/k0Cojn_[00?ok>c/on_[joo[
jn/00oo[jn/2onc/k0;ojn_[0_o/k>`4on_[j`03onc/k?o[jn_ojn_[00?o
jn_[0_o/k>`2on_[j`;ok>c/1?o[jn/00oo/k>cojn_[on_[j`03on_[j`;o
k>c/0_o[jn/2onc/k0Cojn_[00?ok>c/on_[joo[jn/00oo[jn/2onc/k0;o
jn_[0_o/k>`4on_[j`03onc/k?o[jn_ojn_[00?ojn_[0_o/k>`2on_[j`;o
k>c/1?o[jn/00oo/k>cojn_[on_[j`03on_[j`04on[Zj_oYjNWoinOWonOY
j`;oj>W[0_oWjN/02?oWj>[oinW[onSYjooWjN_oinSZonSYjooWj>[oinW[
0_oXjN/2onOYj`;oj>W[0_oWjN/02?oWj>[oinW[onSYjooWjN_oinSZonSY
jooWj>[oinW[0_oXjN/2onOYj`;oj>W[00?oinW[omkNg_oZj^X03?oZj^X0
0oo[jn_oj^[Zon[ZjP0=on[ZjP05on_[jooZj^[oj^[Zon[Zj_oYjNT00_oZ
j^X00ooYjNWoj^[Zon[ZjP04on[ZjP03on;Rh_oQhN7ojn_[00;oj^[Z00Oo
jNWYon[Zj_oZj^[oj^[ZonWYjOoZj^[ojNWZ00Goj^[Z00?ojNWYon[Zj_oZ
j^X00_oYjNT3on[ZjP06onWYjOoZj^[ojNWZon[Zj_oTiNGohN7Q1_oZj^X0
1ooYjN[oj^[Zon[Zj_oZj^[ojNWYon[Zj_oYjNX01_oZj^X00ooYjN[oj^[Z
on[ZjP02onWYj@;oj^[Z00?oi>CTon7QhOoYjNX02OoZj^X01ooYjN[oj^[Z
on[Zj_oZj^[ojNWYon[Zj_oYjNX02OoZj^X01ooYjN[oj^[Zon[Zj_oZj^[o
jNWYon[Zj_oYjNX02OoZj^X01ooYjN[oj^[Zon[Zj_oZj^[ojNWYon[Zj_oY
jNX02OoZj^X01ooYjN[oj^[Zon[Zj_oZj^[ojNWYon[Zj_oYjNX02OoZj^X0
1ooYjN[oj^[Zon[Zj_oZj^[ojNWYon[Zj_oYjNX02OoZj^X01ooYjN[oj^[Z
on[Zj_oZj^[ojNWYon[Zj_oYjNX02OoZj^X06Onl_;cod];Boo;bl_ofm_Ko
moOgooWinOodmOGohN7QonSXj?o]kNgolo?coo_knoomoOgonOWionk^k_o]
k^koHF9RofEUIOmXJ6WoJVY[ofe]KOm_KfooLG5aog=cM?meMGD00OmfMWL0
00;ol?7c0_o_lO82oo3bl`04oo3aloo`l_?ol?7conoalP;ol?7c00_oko3b
ono`lOo_l?3onOWioo[jn_lm?CgoNWYjooWinOojn_[oBDU9oh>3P`02oo[j
nP0IoginO_m<C4con_[jooWinOnd];Co5QHFooWinOojn_[oF5QHoa@D5?lU
9BGoWIfMob0P8?mNGUkon_[jon?ShomSHf?o@T92ogmoOonNWYko:RXZoo[j
n_oinOWoBDU9oh>3P`02ooWin@06odU9BOn3Ph?onOWioo[jn_nTY:Co9bLW
0_ojn_X02omHF5So5ADEobHV9_nMWIgo7alOoeiNG_oinOWoB4Q8oh>3Pooj
n_[onOWi00;on_[j00CoU9BDo`h>3_oDe=ConOWi0_ojn_X02ooinOWon_[j
oo[jn_oinOWo?cloo`h>3_l?3`oo5ADEocXj>_mhN7Sok^k^00;on_[j00ko
nOWioeQHF?lE5AGo9BDUoifMWOlO7aooGUiNooWinOojn_[oUIFEo`h>3_oD
e=Con_[jooWin@;on_[j00_onOWioo[jn_ojn_[om?Cdof5QHOlD51Co<S8b
obXZ:_o;bl_on_[jooWin@02oo[jnP04ooWinOojn_[on_[jooWin@;on_[j
00?onOWioo[jn_ojn_X00_oinOT2oo[jnP04ooWinOojn_[on_[jooWin@;o
n_[j00ConOWioo[jn_ojn_[onOWi0_ojn_X2ooWin@;on_[j00ConOWioo[j
n_ojn_[onOWi0_ojn_X01?oinOWon_[joo[jn_oinOT2oo[jnP;onOWi0_oj
n_X01?oinOWon_[joo[jn_oinOT2oo[jnP04ooWinOojn_[on_[jooWin@;o
n_[j0_oinOT2oo[jnP04ooWinOojn_[on_[jooWin@;on_[j00ConOWioo[j
n_ojn_[onOWi0_ojn_X2ooWin@;on_[j00ConOWioo[jn_ojn_[onOWi0_oj
n_X01?oinOWon_[joo[jn_oinOT2oo[jnP;onOWi0_ojn_X01?oinOWon_[j
oo[jn_oinOT2oo[jnP04ooWinOojn_[on_[jooWin@;on_[j0_oinOT2oo[j
nP04ooWinOojn_[on_[jooWin@;on_[j00ConOWioo[jn_ojn_[onOWi0_oj
n_X2ooWin@;on_[j00ConOWioo[jn_ojn_[onOWi0_ojn_X01?oinOWon_[j
oo[jn_oinOT2oo[jnP;onOWi0_ojn_X01?oinOWon_[joo[jn_oinOT2oo[j
nP04ooWinOojn_[on_[jooWin@;on_[j0_oinOT2oo[jnP04ooWinOojn_[o
n_[jooWin@;on_[j00ConOWioo[jn_ojn_[onOWi0_ojn_X2ooWin@;on_[j
00ConOWioo[jn_ojn_[onOWi0_ojn_X01?oinOWon_[joo[jn_oinOT2oo[j
nP;onOWi0_ojn_X01?oinOWon_[joo[jn_oinOT2oo[jnP04ooWinOojn_[o
n_[jooWin@;on_[j0_oinOT2oo[jnP04ooWinOojn_[on_[jooWin@;on_[j
00ConOWioo[jn_ojn_[onOWi0_ojn_X2ooWin@;on_[j00ConOWioo[jn_oj
n_[onOWi0_ojn_X01?oinOWon_[joo[jn_oinOT2oo[jnP;onOWi0_ojn_X0
1?oinOWon_[joo[jn_oinOT2oo[jnP;onOWi00Con?ShooOgmoofm_Kom_Oi
0_oemoP3ooKgn@03ooKhnOofmoWomOOh00;om_Oi00ComOOiooKgnOofmoWo
mOOi0_ofmoT2ooGgn0?om_Oi00?om_SiooKgnOoemoP00_ofmoT01?oemoWo
m_OiooKgnOoemoT2ooKgn@;omOOh00Com_Oionc/k?oinOWon_[j3_oinOT0
1_o^k^kol_;booWinOoinOWokno_oo?cl`;onOWi00Kol_;bono_kooinOWo
nOWiooGemOo/k>`2ooWin@0=oo3`l?o]kNgokNg]oo?cloo]kNgolO7aooWi
nOohn?SolO7aonk^k_obl_;om?Cdong]k@02ooWin@06ono_koobl_;onOWi
ooWinOo^k^ool_;b0_oinOT03Oodm?CokNg]ooWinOoinOWol?3`on_/k?o/
k>gom?Cdong]kOo`l?3onOWiono_koobl_801?oinOT01_oclo?ojn_[ooOg
mooinOWon?SiooShn0ConOWi00Ook^k_on_[joo/k>cok>c/onk^k_obl_;o
n?Sh00?onOWi00_okno_on_/k?o]kNgom?Cdong]kOoalO7onOWiooShnOoc
lo?ok>c/ooKgm`05ooWin@03ooShnOohn?SonOWi00;onOWi00?on?Shonc/
k?ogn?P02?oinOT00oohn?Won?ShooWin@04ooWin@03ooShnOoinOWonOWi
00KonOWi00?on?SiooShn?oinOT01?oinOT00oohn?WonOWiooWin@06ooWi
n@03ooShnOohn?SonOWi00ConOWi00?on?SiooWinOoinOT01_oinOT00ooh
n?Won?ShooWin@04ooWin@03ooShnOoinOWonOWi00KonOWi00?on?SiooSh
n?oinOT01?oinOT00oohn?WonOWiooWin@06ooWin@0MooShnOohn?SonOWi
ooWinOnm_Kgoe=CDoo;bloogmoOon?Shoo[jn_ofm_Koh^;RonWYjOo]kNgo
m?Cdoo_knoomoOgonOWiono_l?ooooooI6AUofQXJ?m[JfcoKFi^og1`LOmb
Lg?oM7EeogMgMomhN7T00OmjNWX00004ooCfmooem_Som?KgooGfn0?om?Kg
00SomOKhooCfmooem_SomOKgooCemooem_Oom?Gfoo?dm@;oo_kn00Ko?clo
ogemOOono_koo_knodY:B_n5QHD2ooknoP0=oh61POm=CDgoo_knoooooong
]kOo5QHFookno_o8b<So4Q8BomkNg_oWinOoI6AToahN7P02ooknoP06oeIF
E_lj>S[oYZJVoh>3Poli>CWo8B4Q0_ono_h01_m:BT[oQXJ6ookno_ono_ko
BTY:ohJ6QP;oo_kn00goYjNWobTY:Oono_kob<S8oa8B4_oNg]koi^KVof=S
HolN7Qkoooooookno_m;Bd_oQHF500Coo_kn00Co>c/koaLG5omhN7Sooooo
1?ono_h04Oooooooo_knod51@OmkNg_oo_knooCdm?o>c/koCdm?obh^;_o`
l?3oo_knolW9bOlB4Q;og]kNonKVi_mTI6Co7alO00?oo_kn00Go>SXjoaHF
5_miNGWoo_knooooo`02ooknoP0:ooooooono_koo_knohj>S_lc<c?oi>CT
ookno_n@T93o;bl_ooWin@?oo_kn00Coooooookno_ono_kooooo1?ono_h0
0oooooooo_knooknoP05ooknoP04ooooooono_koo_knooooo`Coo_kn00?o
ooooookno_ono_h01Oono_h01?ooooooo_knookno_ooool4ooknoP03oooo
ooono_koo_kn00Goo_kn00Coooooookno_ono_kooooo1?ono_h00ooooooo
o_knooknoP05ooknoP04ooooooono_koo_knooooo`Coo_kn00?oooooookn
o_ono_h01Oono_h01?ooooooo_knookno_ooool4ooknoP03ooooooono_ko
o_kn00Goo_kn00Coooooookno_ono_kooooo1?ono_h00oooooooo_knookn
oP05ooknoP04ooooooono_koo_knooooo`Coo_kn00?oooooookno_ono_h0
1Oono_h01?ooooooo_knookno_ooool4ooknoP03ooooooono_koo_kn00Go
o_kn00Coooooookno_ono_kooooo1?ono_h00oooooooo_knooknoP05ookn
oP04ooooooono_koo_knooooo`Coo_kn00?oooooookno_ono_h01Oono_h0
1?ooooooo_knookno_ooool4ooknoP03ooooooono_koo_kn00Goo_kn00Co
ooooookno_ono_kooooo1?ono_h00oooooooo_knooknoP05ooknoP04oooo
ooono_koo_knooooo`Coo_kn00?oooooookno_ono_h01Oono_h01?oooooo
o_knookno_ooool4ooknoP03ooooooono_koo_kn00Goo_kn01Goooooookn
o_ono_koooooookno_omoOgono_koo[jn_oko?kon_cmoo[lo_ojnogon_cm
oo[koOojo?kon_cmoo_lo_ojo?gon__moo_lo_ojo?d00_ojnod03_ojo?go
nocnoo[loOojo?kon__moo[loOojnogon_cnoo[loOoko?kon_cmoo[koOok
o?kon_cm0_ojnod01_ojo?gonocnoo[loOojo?kon__moo3`l0koo_kn00Co
oOgmookno_oclo?omoOg0_ono_h01_odm?ComoOgookno_ono_kom_KfooCd
m0;oo_kn00Gon_[joo7alOomoOgono_koo3`l002ooclo00>ooKfm_oalO7o
oOgmookno_oemOGol_;booWinOogmoOolo?coo7alOono_kooOgmooCdm?og
moL2ooknoP0CooCdm?ogmoOooOgmookno_oinOWolO7aoogmoOokno_olO7a
ooclo?oloOgomOGeoo7alOomoOgoo_knoo?dm?ogmoOoo_knoogmo@02ookn
oP03oo;bl_o`l?7om_Kf00?oo_kn00oooOgmookno_omoOgoo_knoo?cloog
moOoo_knoogmoOoknocom?Cdoo;bl_omoOgoo_knoo_knoo`l?000_olo?`0
0ooemOGolO7aooknoP02ooknoP04oo?clooalO7omoOgooknoP;ooOgm1?on
o_h02?omoOgoo_knoogmoOolo?gol?3`oogmoOono_kooOgm0_ono_h2oogm
o@Coo_kn00?ooOgmookno_omoOd01?ono_h00oomoOgoo_knooknoP02oogm
o@Coo_kn00?ooOgmookno_omoOd01?ono_h00oomoOgoo_knooknoP02oogm
o@Coo_kn00?ooOgmookno_omoOd01?ono_h00oomoOgoo_knooknoP02oogm
o@Coo_kn00?ooOgmookno_omoOd01?ono_h00oomoOgoo_knooknoP02oogm
o@Coo_kn00?ooOgmookno_omoOd01?ono_h00oomoOgoo_knooknoP02oogm
o@Coo_kn01_ooOgmookno_nm_Kgodm?Doo;bl_ohn?Son?SiooWinOogmoOo
h^;RonSXj?o]kNgom?Cdooclo?omoOkon_[jono_koo^k^koIFEUofUYJOm/
K6coKfm_og5bL_mcLgCoMWIfogQhN?miNWX00OmkNg`00006oo3bloo`lO?o
l?;coo3al_o`l_?ol?7c0_o`l_<01oo_lO;olO;coo3aloo`lO?oko3aono`
l_o^l?000_ojn_X06Olm?CgoNg]kooWinOojn_[oBDU9oh>3Poojn_[onOWi
ogmoOom;Bd_on_[jooWinOnd];Co5QHFoo[jn_oFe]Ko410@okfm_OoinOWo
X:2Pob/[:oojn_[olO7aoaDE5Oni^KT00_ojn_X02_nHV9So7AdMoo[jn_oj
n_[oBDU9oh>3Poojn_[onOWiodU9BOn3Ph<2oo[jnP0=ojBTY?lX:2Son_[j
omKFe_l@413o_;bloo[jn_nPX:3o:b/[ooWinOojn_[oB4Q8oh>3P`03oo[j
nP05ol[:b_l?3`ooX:2PoalO7oobl_801?ojn_X01?oinOWon_[joclo?omi
NGT3oo[jnP0AooCdm?l[:b_oMWIfoo[jn_oEeMGo410@okfm_Oojn_[oX:2P
ob/[:oojn_[onOWiol_;bol>3PkoX:2PoalO7oobl_800oojn_X02_oinOWo
n_[joo[jn_l/;2coOgmoooWinOojn_[oiNGUo`l?3oo=cLd2oo[jnP05ooWi
nOojn_[on_[joo[jn_oinOT01?ojn_X00ooinOWon_[jooWin@04oo[jnP05
ooWinOojn_[on_[joo[jn_oinOT01?ojn_X00ooinOWon_[jooWin@04oo[j
nP05ooWinOojn_[on_[joo[jn_oinOT01?ojn_X00ooinOWon_[jooWin@04
oo[jnP05ooWinOojn_[on_[joo[jn_oinOT01?ojn_X00ooinOWon_[jooWi
n@04oo[jnP05ooWinOojn_[on_[joo[jn_oinOT01?ojn_X00ooinOWon_[j
ooWin@04oo[jnP05ooWinOojn_[on_[joo[jn_oinOT01?ojn_X00ooinOWo
n_[jooWin@04oo[jnP05ooWinOojn_[on_[joo[jn_oinOT01?ojn_X00ooi
nOWon_[jooWin@04oo[jnP05ooWinOojn_[on_[joo[jn_oinOT01?ojn_X0
0ooinOWon_[jooWin@04oo[jnP05ooWinOojn_[on_[joo[jn_oinOT01?oj
n_X00ooinOWon_[jooWin@04oo[jnP05ooWinOojn_[on_[joo[jn_oinOT0
1?ojn_X00ooinOWon_[jooWin@04oo[jnP05ooWinOojn_[on_[joo[jn_oi
nOT01?ojn_X00ooinOWon_[jooWin@04oo[jnP05ooWinOojn_[on_[joo[j
n_oinOT01?ojn_X00ooinOWon_[jooWin@04oo[jnP05ooWinOojn_[on_[j
oo[jn_oinOT01?ojn_X00ooinOWon_[jooWin@04oo[jnP05ooWinOojn_[o
n_[joo[jn_oinOT01?ojn_X00ooinOWon_[jooWin@04oo[jnP05ooWinOoj
n_[on_[joo[jn_oinOT01?ojn_X00ooinOWon_[jooWin@04oo[jnP04ooWi
nOojn_[on_[joo[jnP?onOWi00GomoOgooKfm_oemoWom_OiooGgn004ooKg
n@05ooGgn?ofmoWom_OiooKgnOoemoP01?ofmoT00ooemoWom_OiooGgn004
ooKgn@05ooGgn?ofmoWom_OiooKgnOoemoP01?ofmoT01OoemoWom_OiooGg
n?ofmoWok>c/00gonOWi00gon?ShooWinOoinOWokno_oo;bl_ohn?SonOWi
ono_kooclo?on?ShooWinOobl_;okno_00;onOWi00gomOGeonc/k?oinOWo
moOgonc/k?ofm_Kon?ShooCdm?o]kNgonOWiooShn?o/k>com_Kf00;onOWi
01Golo?cong]kOohn?SonOWiono_koobl_;onOWiooShn?o_ko3ol_;booWi
nOohn?Som?Cdong]kOoinOWomoOgon_[k?ofm_Kon?ShooCdm?o]kNd00_oi
nOT03?o^k^kol_;cooWinOoinOWon?ShooKfmoo/k>com?Cdong]kOohn?So
nOWiooShn0ConOWi01Kok^k^oo;bl_oinOWonOWiooShn?oinOWokNg^oo7a
lOoinOWomoOgonc/k?oemOGonOWiooCdm?o]k^konOWiooShn?ofm_Ook>c/
ooCdm?o/k>con?Wi1OoinOT02_ogmoOom?GeooCdm?oemOGom?Cdon_[jood
m?ComoOgooWinOohn?P6ooWin@03ooShn?oinOWonOWi00;onOWi00Gon?Sh
ooWinOoinOWonOWiooShn006ooWin@03ooShn?oinOWonOWi00;onOWi00Go
n?ShooWinOoinOWonOWiooShn006ooWin@03ooShn?oinOWonOWi00;onOWi
00Gon?ShooWinOoinOWonOWiooShn006ooWin@03ooShn?oinOWonOWi00;o
nOWi00Gon?ShooWinOoinOWonOWiooShn006ooWin@03ooShn?oinOWonOWi
00;onOWi00Gon?ShooWinOoinOWonOWiooShn006ooWin@0LooShn?oinOWo
nOWiokjn__oCdm?ol_;booOgn?ohn?Son_[jooGemOoRh^;ojNWYong]kOod
m?Cono_kookno_oinOWokno_onOWiomTI6GoIfQXofY[Jom]KVkoL71`og9b
L_mdM7GoMWMgogQhN@7oNWYj00004oodm_OomOKhooGfn?odm_OomOKhooGf
moodm_OomOKgooGfn?oem_OomOKhooCemoodm_OoloGfoo?dmOooooooo_kn
oclo?ommOGd00_ono_h01_m:BT[oQHF5ookno_ono_koPH61ode=C@;oo_kn
00go]kNgoaLG5oooooooo_knok6a/Olm?Cgo?Shnod51@Ol/;2coo_knolG5
aOl>3Pkoi^KV00;oo_kn00Ko/;2`oahN7_ono_koooooodY:B_n6QXH2ookn
oP06odY:B_n5QHGoo_knookno_nXZ:So:2PX0_ono_h02Ona/K7o?Cdmochn
?_m1@D7o;2`/ooooooono_koBTY:ohJ6QP03ooknoP05og5aLOm;Bd_oo_kn
oc<c<onYZJT00_ono_h01_ooooooo_knooooooono_ko@D51og]kN`Coo_kn
00WoPh>3obh^;_ono_koo_knok6a/Olm?Cgo?clood51@Ol];Bd00_ono_h0
1OmaLG7oBd];ookno_ld=3CoZJVY00Goo_kn00Son?Sho`h>3_nMWIgooooo
ookno_oHf=So3Ph>omcLg0Woo_kn00?oooooookno_ooool03Oono_h00ooo
ooooo_knooooo`0=ooknoP03ooooooono_kooooo00goo_kn00?oooooookn
o_ooool03Oono_h00oooooooo_knooooo`0=ooknoP03ooooooono_kooooo
00goo_kn00?oooooookno_ooool03Oono_h00oooooooo_knooooo`0=ookn
oP03ooooooono_kooooo00goo_kn00?oooooookno_ooool03Oono_h00ooo
ooooo_knooooo`0=ooknoP03ooooooono_kooooo00goo_kn00?oooooookn
o_ooool03Oono_h00oooooooo_knooooo`0=ooknoP03ooooooono_kooooo
00coo_kn00oooOgmooclo?ojn_[onocnoo[lo_ojo?gon_cnoo[loOojnogo
n_cmoo[lo_ojo?gon_cnoo[koOojo?h00_ojo?d03_oko?kon__moo_lo_oj
o?kon_cmoo[lo_ojo?gon__moo[loOojo?kon_cmoo[lo_ojnogon_cn0_oj
o?d01ooko?kon__moo_lo_ojo?kon_cmoo[lo_oalO401OomoOd00oolo?co
oOgmoogmo@02oogmo@03ooclo?omoOgooOgm00?ooOgm00Kol_;booKfm_om
oOgooOgmooCdm?ofm_H2oogmo@06ooKfm_odm?Coo?cloogmoOoinOWolO7a
0_omoOd03Oohn?Solo?coo?clooclo?ol_;booclo?ojn_[ol?3`oo_knoom
oOgoo?clooWinOoalO400_omoOd09ooclo?om_KfoocmoOomoOgolo?cooOg
moolo?cooOgmooShn?oalO7ooOgmooclo?oinOWolo?coo;clooclo?ol_;b
ooclo?oloOgolo?cooKfm_omoOgoo?cloogmoOoemOGolo?coogmoOobl_;o
nOWioogmoOoloOgooOgmoocmoOolo?coo?gmoo?cloofm_KooOgmooclo002
oogmo@06ooKfm_obl_;oo?cloogmoOoinOWol_;c0_oclo<02ooalO7oo?gm
oogmoOoemOGolo?dooclo?obl_;on?ShoocmoOomoOgoo?cl00;ooOgm00?o
nOWioo3`l?odm?@00_odm?@01?o`l?3om?Cdoo[jn_olo?`2oogmo@03oocm
oOomoOgoo?cl00;ooOgm00Woo?gmoogmoOoloOgoo?cloocmoOomoOgoo?gm
oogmoOolo?`00_omoOd00ooloOgooOgmooclo002oogmo@09oocmoOomoOgo
o?gmooclo?oloOgooOgmoocmoOomoOgoo?cl00;ooOgm00?oo?gmoogmoOol
o?`00_omoOd02OoloOgooOgmoocmoOolo?coo?gmoogmoOoloOgooOgmoocl
o002oogmo@03oocmoOomoOgoo?cl00;ooOgm00Woo?gmoogmoOoloOgoo?cl
oocmoOomoOgoo?gmoogmoOolo?`00_omoOd00ooloOgooOgmooclo002oogm
o@09oocmoOomoOgoo?gmooclo?oloOgooOgmoocmoOomoOgoo?cl00;ooOgm
00?oo?gmoogmoOolo?`00_omoOd02?oloOgooOgmoocmoOnl_;cod];Boo7a
lOofm_KoY:BT0_mCDe<04_m<C4coCTi>oe1@D?nEUYKon_[joocmoOohn?Wo
k^k^ong]kOmQHF7oI6AUofMXJ?mZJV[oK6e]ofi_Kom`LG7oLW=cogAdM07o
MWIf00001Oo`lO?ol?;coo3al_o`l_?olO;c00;ol?;c00Col?7coo3al_o`
l_?ol?;c0_o`lO801_o^l?7ok_3`oo[jn_oinOWo?CdmogYjNP;on_[j00_o
BDU9og9bL_oinOWonOWiogemOOln?Skon?Shoo[jn_nb/[;o5QHFoo[jnP03
ooWin@0;ooShn?nGUiOo;2`/oo[jn_oGemOo3Ph>okFe]Oojn_[onOWiojf]
[OlM7Ad00_ojn_X04Om8B4SoPh>3ooWinOojn_[oBDU9ofATI?ojn_[onOWi
oijNW_lY:BWon_[jooWinOojn_[onOWiooShn?nGUiOo;2`/00;onOWi00_o
BDU9ofm_Koojn_[on_[joo7alOlK6a_oXj>Soo[jn_nCTi?oAdM7ooWin@02
oo[jnP?onOWi00Co?cloogUiNOojn_[on_[j0_oinOT04?nOWioo410@ooCd
m?ojn_[onOWioo[jn_ohn?SoUYJFob`/;?oinOWolO7aoa`L7?nSXj?on_[j
oi>CTom6ATH2oo[jnP0:ooWinOojn_[onOWion7QhOl?3`oo=cLgomGEeOo/
k>coK6a/od=3@`;on_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi00;on_[j
0ooinOT4oo[jnP;onOWi0_ojn_X00ooinOWon_[jooWin@02oo[jnP?onOWi
1?ojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT00_ojn_X3ooWin@Con_[j
0_oinOT2oo[jnP03ooWinOojn_[onOWi00;on_[j0ooinOT4oo[jnP;onOWi
0_ojn_X00ooinOWon_[jooWin@02oo[jnP?onOWi1?ojn_X2ooWin@;on_[j
00?onOWioo[jn_oinOT00_ojn_X3ooWin@Con_[j0_oinOT2oo[jnP03ooWi
nOojn_[onOWi00;on_[j0ooinOT4oo[jnP;onOWi0_ojn_X00ooinOWon_[j
ooWin@02oo[jnP?onOWi1?ojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT0
0_ojn_X3ooWin@Con_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi00;on_[j
0ooinOT4oo[jnP;onOWi0_ojn_X00ooinOWon_[jooWin@02oo[jnP?onOWi
1?ojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT00_ojn_X3ooWin@Con_[j
0_oinOT2oo[jnP03ooWinOojn_[onOWi00;on_[j0ooinOT4oo[jnP;onOWi
0_ojn_X00ooinOWon_[jooWin@02oo[jnP?onOWi1?ojn_X2ooWin@;on_[j
00?onOWioo[jn_oinOT00_ojn_X3ooWin@Con_[j0_oinOT2oo[jnP03ooWi
nOojn_[onOWi00;on?Sh00GomOGeooGgnOoemoSom_OiooKhn@02ooKgn@09
ooGgnOoemoSom_OiooKgnOoemoWom_OiooGgn?ofmoWom_Si00;omOOi00?o
mOOhooKgnOofn?T00_ofmoT02OoemoWomOOhooKgnOofmoWomOOiooKgnOoe
moSom_OiooKhn@02ooGgn@04ooGgn?ofmoWom_Sionc/k0OonOWi00?on?Sh
ooWinOoinOT00_oinOT03_ohn?SonOWiooWinOoinOWokno_oo7alOohn?So
nOWiono_kooalO7onOWiooShn?obl_;okno_0_oinOT00oodm?Cok>c/ooWi
n@03ooWin@07ooShn?oclo?ok^k^ooWinOogmoOojn_[ooGem@02ooWin@0?
ooCdm?o/k>conOWiooWinOo_knool_;booSinOohn?Sokno_oo7alOohnOWo
nOWioo?cloo]kNgonOWi00;on?Wi00Won?ShooWinOodm?CokNg]ooWinOoh
nOWok^k^oo7alOoinOT00_ohnOT01_o/k>com?CdooWinOoclo?okno_ooSh
n0ConOWi00con?Wionk^k_obl_;onOWiooSinOoinOWon?ShooCdm?o/k>co
n?ShooSinOohn?P2ooWin@09oo?cloo]k^kon?WiooShn?o/k>com?CdooSi
nOoclo?ok^k^00;onOWi0_ohnOT03?ohn?SonOWioo3`l?obl_;onOWiooSh
n?o[jn_on?ShooWinOohnOWonOWiooShn0;onOWi0_ohnOT00oohn?SonOWi
ooWin@02ooWin@07ooSinOohn?SonOWiooWinOohnOWonOWiooShn002ooWi
n@;on?Wi00?on?ShooWinOoinOT00_oinOT01oohnOWon?ShooWinOoinOWo
n?WiooWinOohn?P00_oinOT2ooSin@03ooShn?oinOWonOWi00;onOWi00Oo
n?WiooShn?oinOWonOWiooSinOoinOWon?Sh00;onOWi0_ohnOT00oohn?So
nOWiooWin@02ooWin@07ooSinOohn?SonOWiooWinOohnOWonOWiooShn002
ooWin@;on?Wi00?on?ShooWinOoinOT00_oinOT01oohnOWon?ShooWinOoi
nOWon?WiooWinOohn?P00_oinOT2ooSin@0MooShn?oinOWonOWiooWinOnn
_[kod];Boo7alOogmoOokno_ofIVI_mDE5CoCDe=odm?ComMGEgoj>SXoo_k
noomoOgon_[joo3`l?ono_koI6ATofMWJ?mZJV_oKFe^og1`L?mbLW;oM7Ae
ogIfM_mhN7P00OmiNWX00007on;SiOoRi>Goh^CUon7Si?oRi>Goh^?Ton;S
i@02on;Ti@03on;Si?oQhnCoh^?U00;ohN;S00Goh>7Ron_[joo[jn_o>c/k
ogAdM002on_[j`0:odA4A?lP823oR8R8omOGeom4A4Co:2PXof5QHOoBd];o
L71`ocXj>P;ojn_[00goZZZZol_;booXj>SoHV9RoeIFE_o[jn_ok>c/od51
@Om:BT[od];BomoOgomHF5So7AdM00;ojn_[01koADE5ogalO?o[jn_ojn_[
odE5AOlO7aooM7Adolo?comJFU[oD51@on_[joo/k>coZJVYol_;booXj>So
HV9RoeMGEoo/k>cojn_[odA4A?lN7QkoRh^;omCDe?nJVY[o6QXJon;Rh_o[
jn_ogMgMoaDE5Oo9bLT3on_[j`04onc/k?o[jn_o?3`log9bLP;ojn_[0_o/
k>`07?n:RX[o4Q8BonSXj?o[jn_oZZZZol[:b_oXj>SoHV9RoeMGEoo[jn_o
Vi^KoaTI6OoQhN7ojn_[omgMgOlF5QKob<S8on_[joo/k>cojn_[onc/k?oV
i^Ko3Ph>ohR8R?ln?Sko6a/KocPh>?no_kl2on_[j`;ok>c/0_o[jn/00oo/
k>cojn_[onc/k003on_[j`03onc/k?o[jn_ojn_[00?ojn_[0_o/k>`2on_[
j`03onc/k?o[jn_ok>c/00?ojn_[00?ok>c/on_[joo[jn/00oo[jn/2onc/
k0;ojn_[00?ok>c/on_[joo/k>`00oo[jn/00oo/k>cojn_[on_[j`03on_[
j`;ok>c/0_o[jn/00oo/k>cojn_[onc/k003on_[j`03onc/k?o[jn_ojn_[
00?ojn_[0_o/k>`2on_[j`03onc/k?o[jn_ok>c/00?ojn_[00?ok>c/on_[
joo[jn/00oo[jn/2onc/k0;ojn_[00?ok>c/on_[joo/k>`00oo[jn/00oo/
k>cojn_[on_[j`03on_[j`;ok>c/0_o[jn/00oo/k>cojn_[onc/k003on_[
j`03onc/k?o[jn_ojn_[00?ojn_[0_o/k>`2on_[j`03onc/k?o[jn_ok>c/
00?ojn_[00?ok>c/on_[joo[jn/00oo[jn/2onc/k0;ojn_[00?ok>c/on_[
joo/k>`00oo[jn/00oo/k>cojn_[on_[j`03on_[j`;ok>c/0_o[jn/00oo/
k>cojn_[onc/k003on_[j`03onc/k?o[jn_ojn_[00?ojn_[0_o/k>`2on_[
j`03onc/k?o[jn_ok>c/00?ojn_[00?ok>c/on_[joo[jn/00oo[jn/2onc/
k0;ojn_[00?ok>c/on_[joo/k>`00oo[jn/00oo/k>cojn_[on_[j`03on_[
j`;ok>c/0_o[jn/00oo/k>cojn_[onc/k003on_[j`03onc/k?o[jn_ojn_[
00?ojn_[0_o/k>`2on_[j`03onc/k?o[jn_ok>c/00?ojn_[00?ok>c/on_[
joo[jn/00oo[jn/2onc/k0;ojn_[00?ok>c/on_[joo/k>`00oo[jn/00oo/
k>cojn_[on_[j`03on_[j`;ok>c/0_o[jn/03?o/k>cojn_[on_[jooZj^[o
jNWYonOWiooXjN_oinW[onOXj_oWjN_oinSZonOYj`;oj>W[00KoinW[onOX
j_oXjN_oinW[onSYjooWj>X2onOYj`06onSYjooWjN_oinSZonOYjooWj>[o
inW[0_oXjN/01_oWjN_oinSZonSYjooWjN_oj>W[onOXjP;oinW[00Goj>W[
onOYjooWj>[oinW[omgMg@0=on_[j`05on[Zj_o[jn_oj^[Zon3Ph?oTi>@0
0_o[jn/04OoPh>3ogmoOonGUiOoZj^[oh>3PomoOgooShn?oj^[Zon?ShooP
h>3ojn_[on[Zj_oWinOojNWYon_[jooRh^;ohN7Q00;ojn_[0_oQhN402?oY
jNWoj^[Zon;Rh_oNg]koj^[Zon_[jooPh>3oi>CT0_o[jn/01_oPh>7og]kN
onCTi?oYjNWoh^;Ron7Qh@;ojn_[00GoinOWonWYjOoZj^[oh^?Son7Qh@02
on_[j`0>on7QhOoNg]koi>GUon[Zj_oVi^Kog]kNon[Zj_o[jn_oj^[ZomkN
g_oYjNWoj^[Zon_[jooZj^X2on_[j`03on3PhOoShn?oj^[Z00?ojn_[00Oo
i>CUomgMgOo[jn_ojn_[onOWiooXj>Sojn_[00;oh^;R00Sojn_[onKVi_oN
g]koj^[Zon_[jooZj^[og]kNonSXj0Cojn_[0_oZj^X01?oOgmooinOWon_[
jooNg]h2on[ZjP?ojn_[00?oj^[Zon_[joo[jn/00_o[jn/00ooZj^[ojn_[
on[ZjP04on_[j`05on[Zj_o[jn_ojn_[on_[jooZj^X01?o[jn/00ooZj^[o
jn_[on[ZjP04on_[j`05on[Zj_o[jn_ojn_[on_[jooZj^X01?o[jn/00ooZ
j^[ojn_[on[ZjP04on_[j`05on[Zj_o[jn_ojn_[on_[jooZj^X01?o[jn/0
0ooZj^[ojn_[on[ZjP04on_[j`05on[Zj_o[jn_ojn_[on_[jooZj^X01?o[
jn/00ooZj^[ojn_[on[ZjP04on_[j`05on[Zj_o[jn_ojn_[on_[jooZj^X0
1?o[jn/07?oZj^[ojn_[on[Zj_nn_[ooe=CDoo;bl_ogmoOon?Shok^k^omE
EEGoCTi>odm?Con_[joom?Cdoo_knoomo_konOWiono_koo^k^koIFEUofQX
JOm[K6coKVi^og5aLOmcLgCoMGEeogQhN?miNGT1ogYkN`0000Gol?;coo3a
l_oal_Col?;coo7bl`02oo3bl`03oo3al_oal_?ol?7c00;ol?;c02;oko7b
ono`lOo^ko3onOWioo[jn_lm?CgoNg]kooWinOojn_[oG5aLohj>S_meMGGo
7AdMoc<c<ooBd];oW9bLobHV9_l[:b_o[Jf]ooWinOojn_[oSHf=ocdm?OlL
71co@T92ol?3`oojn_[onOWion3Ph?m<C4co61PHoc@d=?mjNW[o=CDe0_oi
nOT02_mLG5coT92@oo[jn_oinOWoG5aLohn?SommOGgo820PocTi>Oo3`l<2
oo[jnP0>ohf=SOll?3co71`Lod92@_o3`l?onOWioo[jn_mKFe_oSHf=ofAT
I?lF5QKoFe]KogIfM_oinOT2oo[jnP09og5aLOn9RHWonOWiooWinOojn_[o
nOWioo[jn_lo?cooNGUi00;on_[j00konOWioo[jn_mIFEWo=cLgoo[jn_oi
nOWoSHf=oc`l??lL71co@T92ol?3`oojn_[oHF5QogIfMP;on_[j00?onOWi
og9bL_n8R8P00_ojn_X01OoinOWon_[jooWinOlZ:R[oVYZJ00?onOWi0ooj
n_X00ooinOWon_[jooWin@02oo[jnP08ooWinOojn_[onOWiooWinOojn_[o
nOWioo[jn_oinOT3oo[jnP03ooWinOojn_[onOWi00;on_[j00SonOWioo[j
n_oinOWonOWioo[jn_oinOWon_[jooWin@?on_[j00?onOWioo[jn_oinOT0
0_ojn_X02?oinOWon_[jooWinOoinOWon_[jooWinOojn_[onOWi0oojn_X0
0ooinOWon_[jooWin@02oo[jnP08ooWinOojn_[onOWiooWinOojn_[onOWi
oo[jn_oinOT3oo[jnP03ooWinOojn_[onOWi00;on_[j00SonOWioo[jn_oi
nOWonOWioo[jn_oinOWon_[jooWin@?on_[j00?onOWioo[jn_oinOT00_oj
n_X02?oinOWon_[jooWinOoinOWon_[jooWinOojn_[onOWi0oojn_X00ooi
nOWon_[jooWin@02oo[jnP08ooWinOojn_[onOWiooWinOojn_[onOWioo[j
n_oinOT3oo[jnP03ooWinOojn_[onOWi00;on_[j00SonOWioo[jn_oinOWo
nOWioo[jn_oinOWon_[jooWin@?on_[j00?onOWioo[jn_oinOT00_ojn_X0
2?oinOWon_[jooWinOoinOWon_[jooWinOojn_[onOWi0oojn_X00ooinOWo
n_[jooWin@02oo[jnP08ooWinOojn_[onOWiooWinOojn_[onOWioo[jn_oi
nOT3oo[jnP03ooWinOojn_[onOWi00;on_[j00SonOWioo[jn_oinOWonOWi
oo[jn_oinOWon_[jooWin@?on_[j00?onOWioo[jn_oinOT00_ojn_X02?oi
nOWon_[jooWinOoinOWon_[jooWinOojn_[onOWi0oojn_X00ooinOWon_[j
ooWin@02oo[jnP08ooWinOojn_[onOWiooWinOojn_[onOWioo[jn_oinOT3
oo[jnP03ooWinOojn_[onOWi00;on_[j00SonOWioo[jn_oinOWonOWioo[j
n_oinOWon_[jooWin@?on_[j00?onOWioo[jn_oinOT00_ojn_X02?oinOWo
n_[jooWinOoinOWon_[jooWinOojn_[onOWi0oojn_X00ooinOWon_[jooWi
n@02oo[jnP;onOWi00Kon?ShooOgmoofm_KomOOhooKgnOoemoT3ooKgn@03
ooGgn?ofn?WomOOi00;om_Oi00SomOOiooKgnOoemoWomOOhooKgnOoemoSo
m_OiooGgn@?om_Oi00?omOOhooKhnOoemoT00_ofmoT02_oemoWom_OiooGg
nOoemoSom_OiooGgn?ofmoWomOOiooKgnOo/k>`9ooWin@03ooShn?oinOWo
n?Sh00ConOWi00kok^k^oo7alOoinOWonOWioo3`l?oclo?olO7aonc/k?o]
kNgom_KfooCdm?o/k>cok^k^ooCdm0;onOWi00Golo?conk^k_o]kNgok^k^
ooKfmP02ooWin@06ooOgmoo_knook>c/onk^k_oalO7ok^k^0_oinOT07oo`
l?3olo?cooShn?oinOWol?3`oo?cloobl_;ok>c]onk^k_oemOGon?ShooWi
nOobl_;okno_onc/k?o_knoom_KfooWinOohn?Sol?3`oo;bl_o`l?3ok>c/
oo3`l?oalO7on?SiooShn?oinOWolO7aoo?cloohn?T00ooinOT00oohn?So
kno_oo7al@02ooWin@0<ooShn?oinOWokno`onk^k_oinOWon?Shoo?cloo^
k^kokNg]ono_koofm_Kon?Sh0_oalO42ooWin@0>ooShn?oalO7ol_;booSh
n?oinOWon?ShooWinOohn?WonOWiooKfm_o]kNgomoOgonc/k?ohn?P2ooWi
n@08ooShn?oinOWon?SiooShn?oinOWon?ShooWinOohn?T3ooWin@03ooSh
n?oinOWon?Si00;onOWi00Son?ShooWinOohn?Won?ShooWinOohn?SonOWi
ooShn@?onOWi00?on?ShooWinOohn?T00_oinOT02?ohn?SonOWiooShnOoh
n?SonOWiooShn?oinOWon?Si0ooinOT00oohn?SonOWiooShn@02ooWin@08
ooShn?oinOWon?SiooShn?oinOWon?ShooWinOohn?T3ooWin@03ooShn?oi
nOWon?Si00;onOWi00Son?ShooWinOohn?Won?ShooWinOohn?SonOWiooSh
n@?onOWi00?on?ShooWinOohn?T00_oinOT02?ohn?SonOWiooShnOohn?So
nOWiooShn?oinOWon?Si0_oinOT06Onl_KgodM7Aoo;bl_ogmoOon?Shoo[j
n_mhN7SoCDe=ofe]KOoYjNWomOGeoo[jn_omoOgonOWiono_kooWinOoI6AT
ofMWIomZJV_oKFe]ofm`L?mbLW;oM7AdogIfM_mgN7P00OmiNGT00003ooGf
mooem_SomOKh00;omOKh00Gom?KgooGfn?oem_OomOKhooGgn003ooGfm`06
oo?em_odmOKoo_knookno_lo?cooOGem1Oono_h00oomoOgoo_knooknoP02
ooknoP03oogmoOooooooo_kn00?oo_kn00?oo?clookno_ono_h01?ono_h0
1Oolo?coo_knookno_ono_kooooo00Soo_kn00?ooOgmookno_ono_h01?on
o_h00oomoOgoo_knooknoP05ooknoP03oo_knoono_koo_kn00Goo_kn00?o
ooooookno_ono_h00_ono_h00om1@D7oNg]kooknoP02ooknoP03ojBTY?l?
3`ooYJFU00?oo_kn00?oooooooclo?ono_h03Oono_h01?ooooooRHV9odM7
AoomoOd<ooknoP03ooooooono_koo_kn00goo_kn00?oooooookno_ono_h0
3Oono_h00oooooooo_knooknoP0=ooknoP03ooooooono_koo_kn00goo_kn
00?oooooookno_ono_h03Oono_h00oooooooo_knooknoP0=ooknoP03oooo
ooono_koo_kn00goo_kn00?oooooookno_ono_h03Oono_h00oooooooo_kn
ooknoP0=ooknoP03ooooooono_koo_kn00goo_kn00?oooooookno_ono_h0
3Oono_h00oooooooo_knooknoP0=ooknoP03ooooooono_koo_kn00goo_kn
00?oooooookno_ono_h03Oono_h00oooooooo_knooknoP0<ooknoP;ooOgm
02Woo?cloo[jn_ojo?kon_cmoo[lo_ojo?gon__moo[lo_ojnogon_cmoo[l
o_ojnogon_cmoo[lo_ojnogonocnoo[lo_ojnogon_cnoo[loOojo?kon_cm
oo[koOojo?kon__moo[loOojo?kon__moo[loOojo?kon__moo_lo_ojo?ko
n__moo[lo_ojo?gon_cnoo[loOoalO7ooOgmooclo002oogmo@04ooclo?om
oOgooOgmooclo0;ooOgm00?oo?cloogmoOolo?`00_omoOd00oolo?colo?c
ooKfmP02oogmo@;oo?cl00OooOgmooclo?omoOgooOgmooclo?omoOgoo?cl
00;ooOgm00Goo?cloogmoOolo?coo?cloogmo@02ooclo007oogmoOolo?co
oOgmoogmoOolo?cooOgmooclo002oogmo@05ooclo?omoOgoo?clooclo?om
oOd00_olo?`01oomoOgoo?cloogmoOomoOgoo?cloogmoOolo?`00_omoOd0
1Oolo?cooOgmooclo?olo?cooOgm00;oo?cl00OooOgmooclo?omoOgooOgm
ooclo?omoOgoo?cl00;ooOgm00Goo?cloogmoOolo?colo?cooKfmP02oocl
o007oogmoOogmoSol?3aooShn?olo?cooOgmooclo002oogmo@05ooclo?om
oOgoo?clooclo?omoOd00_olo?`01oomoOgoo?cloogmoOomoOgoo?cloogm
oOolo?`00_omoOd01?olo?comoOgoo?cloo`l?03ooclo007oogmoOolo?co
oOgmoogmoOolo?cooOgmooclo002oogmo@05ooclo?omoOgoo?clooclo?om
oOd00_olo?`01oomoOgoo?cloogmoOomoOgoo?cloogmoOolo?`00_omoOd0
1Oolo?cooOgmooclo?olo?cooOgm00;oo?cl00OooOgmooclo?omoOgooOgm
ooclo?omoOgoo?cl00;ooOgm00Goo?cloogmoOolo?coo?cloogmo@02oocl
o007oogmoOolo?cooOgmoogmoOolo?cooOgmooclo002oogmo@05ooclo?om
oOgoo?clooclo?omoOd00_olo?`01oomoOgoo?cloogmoOomoOgoo?cloogm
oOolo?`00_omoOd01Oolo?cooOgmooclo?olo?cooOgm00;oo?cl00OooOgm
ooclo?omoOgooOgmooclo?omoOgoo?cl00;ooOgm01[oo?clokbl_?oAdM7o
l?7aooKfm_ogmoOon?ShomKFe_m<C4co`l?3on_[joodm?ConO[jooclo?oi
nOWok^k^ong]kOmQHF7oI6ATofMWIomYJF[oK6a/ofi^K_m`L73oLW9bog=d
M07oMGEf00002oo`lO?olO;coo3bloo`lO?ol?7boo7bloo`l_?olO;coo3a
loo`l_?olO;c00;ol?7b00Koko3bonk_l?ojn_[onOWiochn?_mkNg/2ooWi
n@04oo[jn_oinOWon_[jooWin@;on_[j00KonOWioo[jn_ojn_[onOWioo[j
n_oinOT2oo[jnP;onOWi00Con_[jooWinOojn_[onOWi0_ojn_X02?oinOWo
n_[joo[jn_oinOWon_[jof9RH_nEUIGon_[j0_oinOT01?ojn_[onOWioo[j
n_oinOT2oo[jnP06ooWinOojn_[on_[jooWinOojn_[onOWi0_ojn_X2ooWi
n@04oo[jn_oinOWon_[jooWin@;on_[j00KonOWioo[jn_ojn_[onOWioo[j
n_oinOT2oo[jnP07oclo?olh>3SoJf][oeMGEolh>3So51@Doi:BTP02ooWi
n@;on_[j00?onOWioo[jn_oinOT00_ojn_X2ooWin@04oo[jn_oinOWon_[j
ooWin@;on_[j00konOWioo[jn_ojn_[onOWionc/k?m2@T;oFEUIoj>SXon2
PX;oLG5aoo[jn_oinOWon_[jooWin@;on_[j00KonOWioo[jn_ojn_[onOWi
oo[jn_oinOT2oo[jnP;onOWi00Con_[jooWinOojn_[onOWi0_ojn_X01_oi
nOWon_[joo[jn_oinOWon_[jooWin@;on_[j0_oinOT01?ojn_[onOWioo[j
n_oinOT2oo[jnP06ooWinOojn_[on_[jooWinOojn_[onOWi0_ojn_X2ooWi
n@04oo[jn_oinOWon_[jooWin@;on_[j00KonOWioo[jn_ojn_[onOWioo[j
n_oinOT2oo[jnP;onOWi00Con_[jooWinOojn_[onOWi0_ojn_X01_oinOWo
n_[joo[jn_oinOWon_[jooWin@;on_[j0_oinOT01?ojn_[onOWioo[jn_oi
nOT2oo[jnP06ooWinOojn_[on_[jooWinOojn_[onOWi0_ojn_X2ooWin@04
oo[jn_oinOWon_[jooWin@;on_[j00KonOWioo[jn_ojn_[onOWioo[jn_oi
nOT2oo[jnP;onOWi00Con_[jooWinOojn_[onOWi0_ojn_X01_oinOWon_[j
oo[jn_oinOWon_[jooWin@;on_[j0_oinOT01?ojn_[onOWioo[jn_oinOT2
oo[jnP06ooWinOojn_[on_[jooWinOojn_[onOWi0_ojn_X2ooWin@04oo[j
n_oinOWon_[jooWin@;on_[j00KonOWioo[jn_ojn_[onOWioo[jn_oinOT2
oo[jnP;onOWi00Con_[jooWinOojn_[onOWi0_ojn_X01_oinOWon_[joo[j
n_oinOWon_[jooWin@;on_[j0_oinOT01?ojn_[onOWioo[jn_oinOT2oo[j
nP06ooWinOojn_[on_[jooWinOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oi
nOWon_[jooWin@;on_[j00KonOWioo[jn_ojn_[onOWioo[jn_oinOT2oo[j
nP;onOWi00Con_[jooWinOojn_[onOWi0_ojn_X01_oinOWon_[joo[jn_oi
nOWon_[jooWin@;on_[j0_oinOT01?ojn_[onOWioo[jn_oinOT2oo[jnP06
ooWinOojn_[on_[jooWinOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oinOWo
n_[jooWin@;on_[j00KonOWioo[jn_oinOWon?ShooOgmooemOD2ooKgn@;o
mOOh00Com_OiooGgnOofmoWomOOi0_ofmoT01_oemoSom_OiooKgnOoemoWo
m_OiooGgn@;om_Oi0_oemoP01?ofmoWomOOiooKgnOoemoT2ooKgn@06ooGg
n?ofmoWom_OiooGgnOofmoWomOOi0_ofmoT2ooGgn003onc/k?oinOWonOWi
00?onOWi00?on?ShooWinOoinOT01OoinOT2ooShn004ooWinOo^k^kol_;b
ooShn0;onOWi00Kon?ShooWinOoinOWon?ShooWinOohn?P2ooWin@;on?Sh
00ConOWiooShn?oinOWon?Sh0_oinOT01_ohn?SonOWiooWinOohn?SonOWi
ooShn0;onOWi0_ohn?P01?o`l?3olo?cooWinOohn?P2ooWin@06ooShn?oi
nOWonOWiooShn?oinOWon?Sh0_oinOT2ooShn004ooWinOohn?SonOWiooSh
n0;onOWi00Kon?ShooWinOoinOWon?ShooWinOohn?P2ooWin@;on?Sh00?o
nOWiooShn?oinOT00_o^k^h01ooalO7okno_onk^k_o/k>colo?cooWinOoh
n?P00_oinOT2ooShn004ooWinOohn?SonOWiooShn0;onOWi00Kon?ShooWi
nOoinOWon?ShooWinOohn?P2ooWin@;on?Sh00OonOWiooShn?o_knoojn_[
ooShn?oinOWon?Sh00;onOWi00?on?ShooWinOohn?P00_oinOT2ooShn004
ooWinOohn?SonOWiooShn0;onOWi00Kon?ShooWinOoinOWon?ShooWinOoh
n?P2ooWin@;on?Sh00ConOWiooShn?oinOWon?Sh0_oinOT01_ohn?SonOWi
ooShn?ohn?SonOWiooShn0;onOWi0_ohn?P01?oinOWon?ShooWinOohn?P2
ooWin@06ooShn?oinOWonOWiooShn?oinOWon?Sh0_oinOT2ooShn004ooWi
nOohn?SonOWiooShn0;onOWi00Kon?ShooWinOoinOWon?ShooWinOohn?P2
ooWin@;on?Sh00ConOWiooShn?oinOWon?Sh0_oinOT01_ohn?SonOWiooWi
nOohn?SonOWiooShn0;onOWi0_ohn?P06_oinOWo_;blom?CdooalO7om_Kf
ooShn?oinOWon__kok2`/?oWinOokNg]oo?cm?ojn_[oo?cmooShn?o^k^oo
o_knof=TI?mWIfOoJVYZofe]KOm_Kg3oLG9bogAdM?meMWKoMgMh0OmiNGT0
000?on;SiOoRhnCoh^?Ton;TiOoSi>Koh^CUon;Si?oSi>Goh^?Uon7Si?oR
i>Goh^?Uon7Ri?oQh^?oh>7R00;ojn_[00CoYJFUokbl_?o[jn_ok>c/0_o[
jn/00oo/k>cojn_[on_[j`03on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Co
k>c/on_[joo[jn_ok>c/1Oo[jn/01Oo/k>cojn_[on_[jonYZJWo_kno00;o
jn_[00Cok>c/on_[joo[jn_ok>c/1Oo[jn/00oo/k>cojn_[on_[j`04on_[
j`04onc/k?o[jn_ojn_[onc/k0Gojn_[00?ok>c/on_[joo[jn/00oo[jn/0
1_nWYjOoTi>Coi>CTonJVY[o^;RhomWIf@Cojn_[00?ok>c/on_[joo[jn/0
1?o[jn/01?o/k>cojn_[on_[joo/k>`5on_[j`08onc/k?o[jn_ojn_[onGU
iOnFUYKoJf][ogalO?n^[Zh2on_[j`03onc/k?o[jn_ojn_[00?ojn_[00?o
k>c/on_[joo[jn/01?o[jn/01?o/k>cojn_[on_[joo/k>`5on_[j`03onc/
k?o[jn_ojn_[00Cojn_[00Cok>c/on_[joo[jn_ok>c/1Oo[jn/00oo/k>co
jn_[on_[j`04on_[j`04onc/k?o[jn_ojn_[onc/k0Gojn_[00?ok>c/on_[
joo[jn/01?o[jn/01?o/k>cojn_[on_[joo/k>`5on_[j`03onc/k?o[jn_o
jn_[00Cojn_[00Cok>c/on_[joo[jn_ok>c/1Oo[jn/00oo/k>cojn_[on_[
j`04on_[j`04onc/k?o[jn_ojn_[onc/k0Gojn_[00?ok>c/on_[joo[jn/0
1?o[jn/01?o/k>cojn_[on_[joo/k>`5on_[j`03onc/k?o[jn_ojn_[00Co
jn_[00Cok>c/on_[joo[jn_ok>c/1Oo[jn/00oo/k>cojn_[on_[j`04on_[
j`04onc/k?o[jn_ojn_[onc/k0Gojn_[00?ok>c/on_[joo[jn/01?o[jn/0
1?o/k>cojn_[on_[joo/k>`5on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Co
k>c/on_[joo[jn_ok>c/1Oo[jn/00oo/k>cojn_[on_[j`04on_[j`04onc/
k?o[jn_ojn_[onc/k0Gojn_[00?ok>c/on_[joo[jn/01?o[jn/01?o/k>co
jn_[on_[joo/k>`5on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Cok>c/on_[
joo[jn_ok>c/1Oo[jn/00oo/k>cojn_[on_[j`04on_[j`04onc/k?o[jn_o
jn_[onc/k0Kojn_[00Coj^[ZonWYjOoWinOoinSZ0_oWjN/01_oXjN_oinW[
onOXj_oXjN_oinW[onOXjP?oinW[00Goj>W[onOXj_oWjN_oinW[onOXjP02
onOYj`06onSYjooWjN_oinSZonSYjooWjN_oinSZ0ooWjN/01OoXjN_oinSZ
onOYjooWjN_oinSZ00;oinW[00Koj>W[omgMgOo[jn_ok>c/on_[jooZj^X4
on_[j`04on[Zj_o[jn_ojn_[on[ZjPCojn_[00Coi^KVonSXj?o[jn_oj^[Z
1?o[jn/01?oZj^[ojn_[on_[jooZj^X4on_[j`04on[Zj_o[jn_ojn_[on[Z
jPCojn_[00Coj^[Zon_[joo[jn_oj^[Z0oo[jn/01OoWinOoj>SXon_[joo[
jn_oj^[Z00;ojn_[00Ooj^_[on_[jooZj^[ojn_[on[[jooZj^[oj^_[00;o
jn_[00Goj^_[on[Zj_o[jn_ojn_[on[ZjP02on_[j`07on[[joo[jn_oj^[Z
on_[jooZjn_oj^[Zon[[j`02on_[j`04on[[jooZj^[ojn_[onOWi`;oiNGU
00Soi^KVonOWiooZj^[oj^[Zon_[jooZjn_oj^[Zon[[j`;ojn_[00Goj^_[
on[Zj_o[jn_ojn_[on[ZjP02on_[j`07on[[joo[jn_oj^[Zon_[jooZjn_o
j^[Zon[[j`02on_[j`05on[[jooZj^[oj^[ZonGUiOoZj^X00_o[jn/01ooZ
jn_ojn_[on[Zj_o[jn_oj^_[on[Zj_oZjn/00_o[jn/01OoZjn_oj^[Zon_[
joo[jn_oj^[Z00;ojn_[00Ooj^_[on_[jooZj^[ojn_[on[[jooZj^[oj^_[
00;ojn_[00Goj^_[on[Zj_o[jn_ojn_[on[ZjP02on_[j`07on[[joo[jn_o
j^[Zon_[jooZjn_oj^[Zon[[j`02on_[j`05on[[jooZj^[ojn_[on_[jooZ
j^X00_o[jn/01ooZjn_ojn_[on[Zj_o[jn_oj^_[on[Zj_oZjn/00_o[jn/0
1OoZjn_oj^[Zon_[joo[jn_oj^[Z00;ojn_[00Ooj^_[on_[jooZj^[ojn_[
on[[jooZj^[oj^_[00;ojn_[00Goj^_[on[Zj_o[jn_ojn_[on[ZjP02on_[
j`07on[[joo[jn_oj^[Zon_[jooZjn_oj^[Zon[[j`02on_[j`0Jon[[jonm
_Kgoe]KFoo;bl_ogmoOon?SiooWinOodm?Coh^;RonOWioo]kNgomOGeoo[j
n_omoOgon_[jono`l?o^k^koI6AUofQXJ?m[Jf_oKVi^og1aLOmbLg?oMGEe
ogMgMomhN7T1ogYjNP0000?olO;coo3blooal_@00_o`l_<02?oal_ColO;c
oo7bloo`lO;ol?;coo3aloo`l_?ol?7b0_o_l?44oo[jnP;onOWi00Kon_[j
ooWinOojn_[onOWioo[jn_oinOT2oo[jnP03ooWinOojn_[on_[j00?on_[j
0_oinOT01_ojn_[onOWioo[jn_oinOWon_[jooWin@;on_[j00?onOWioo[j
n_ojn_X00oojn_X2ooWin@06oo[jn_oinOWon_[jooWinOojn_[onOWi0_oj
n_X00ooinOWon_[joo[jnP03oo[jnP;onOWi00Kon_[jooWinOojn_[onOWi
oo[jn_oinOT2oo[jnP03ooWinOojn_[on_[j00?on_[j0_oinOT01_ojn_[o
nOWioo[jn_oinOWon_[jooWin@;on_[j00?onOWioo[jn_ojn_X00oojn_X2
ooWin@06oo[jn_oinOWon_[jooWinOojn_[onOWi0_ojn_X00ooinOWon_[j
oo[jnP03oo[jnP;onOWi00Kon_[jooWinOojn_[onOWioo[jn_oinOT2oo[j
nP03ooWinOojn_[on_[j00?on_[j0_oinOT01_ojn_[onOWioo[jn_oinOWo
n_[jooWin@;on_[j00?onOWioo[jn_ojn_X00oojn_X2ooWin@06oo[jn_oi
nOWon_[jooWinOojn_[onOWi0_ojn_X00ooinOWon_[joo[jnP03oo[jnP;o
nOWi00Kon_[jooWinOojn_[onOWioo[jn_oinOT2oo[jnP03ooWinOojn_[o
n_[j00?on_[j0_oinOT01_ojn_[onOWioo[jn_oinOWon_[jooWin@;on_[j
00?onOWioo[jn_ojn_X00oojn_X2ooWin@06oo[jn_oinOWon_[jooWinOoj
n_[onOWi0_ojn_X00ooinOWon_[joo[jnP03oo[jnP;onOWi00Kon_[jooWi
nOojn_[onOWioo[jn_oinOT2oo[jnP03ooWinOojn_[on_[j00?on_[j0_oi
nOT01_ojn_[onOWioo[jn_oinOWon_[jooWin@;on_[j00?onOWioo[jn_oj
n_X00oojn_X2ooWin@06oo[jn_oinOWon_[jooWinOojn_[onOWi0_ojn_X0
0ooinOWon_[joo[jnP03oo[jnP;onOWi00Kon_[jooWinOojn_[onOWioo[j
n_oinOT2oo[jnP03ooWinOojn_[on_[j00?on_[j0_oinOT01_ojn_[onOWi
oo[jn_oinOWon_[jooWin@;on_[j00?onOWioo[jn_ojn_X00oojn_X2ooWi
n@06oo[jn_oinOWon_[jooWinOojn_[onOWi0_ojn_X00ooinOWon_[joo[j
nP03oo[jnP;onOWi00Kon_[jooWinOojn_[onOWioo[jn_oinOT2oo[jnP03
ooWinOojn_[on_[j00?on_[j0_oinOT01_ojn_[onOWioo[jn_oinOWon_[j
ooWin@;on_[j00?onOWioo[jn_ojn_X00oojn_X2ooWin@06oo[jn_oinOWo
n_[jooWinOojn_[onOWi0_ojn_X00ooinOWon_[joo[jnP03oo[jnP;onOWi
00Kon_[jooWinOojn_[onOWioo[jn_oinOT2oo[jnP0AooWinOohn?SomoOg
ooKfm_ofmoWom_SiooKgnOoemoSom_OiooGgnOofmoWomOOhooKgnOoemoWo
m_SiooKgnOoemoP01?ofmoT03?ofn?Wom_OiooGgn?ofmoWomOOiooKgnOoe
moSom_OiooGgnOofn?Wom_OiooGgn0Com_Oi00Com_SiooKgnOoemoSok>c/
0_oinOT00oohn?SonOWiooWin@02ooWin@03ooShn?oinOWonOWi00?onOWi
0_ohn?P01_oinOWon?ShooWinOohn?SonOWiooShn0;onOWi00?on?ShooWi
nOoinOT00ooinOT2ooShn006ooWinOohn?SonOWiooShn?oinOWon?Sh0_oi
nOT00oohn?SonOWiooWin@03ooWin@;on?Sh00KonOWiooShn?oinOWon?Sh
ooWinOohn?P2ooWin@03ooShn?oinOWonOWi00?onOWi0_ohn?P01_oinOWo
n?ShooWinOohn?SonOWiooShn0;onOWi00?on?ShooWinOoinOT00ooinOT2
ooShn006ooWinOohn?SonOWiooShn?oinOWon?Sh0_oinOT00oohn?SonOWi
ooWin@03ooWin@;on?Sh00KonOWiooShn?oinOWon?ShooWinOohn?P2ooWi
n@;on?Sh0_oinOT02oohn?SonOWiooShn?ohn?SonOWiooShn?oinOWon?Sh
ooWinOohn?SonOWi00;on?Sh0ooinOT01Oohn?SonOWiooShn?ohn?SonOWi
00?on?Sh00ConOWiooShn?oinOWonOWi0_ohn?P4ooWin@;on?Sh00KonOWi
ooShn?ohn?Son?ShooWinOohn?P2ooWin@;on?Sh1?oinOT2ooShn007ooWi
nOohn?SonOWiooShn?oinOWon?ShooWin@02ooShn0GonOWi0_ohn?P01_oi
nOWon?ShooWinOohn?SonOWiooShn0;onOWi00Kon?ShooWinOoinOWonOWi
ooShn?oinOT2ooShn006ooWinOohn?Son?ShooShn?oinOWon?Sh0_oinOT2
ooShn0ConOWi0_ohn?P01OoinOWo_KfmomCDe?oalO7omoOg00;on?Sh01?o
jn_[on7QhOoXj>Sokno_ooGfm_ojn_[oo?clooWinOo^k^koi^KVof=SI?mW
IfOoJFUYofa/K?m^KVkoLG5bog9bL_meMWKoMWIf007oN7Qh00000ooem_So
mOKgooGgn002ooGgn003ooKgn?oem_SomOOh00;omOKh00?omOOhooGfmooe
m_L00_odmOH3ooknoP03ooooooono_koo_kn00;oo_kn00?oooooookno_on
o_h01?ono_h01Oooooooo_knookno_ono_kooooo00Coo_kn00?oooooookn
o_ono_h01?ono_h01Oooooooo_knookno_ono_kooooo00Coo_kn00?ooooo
ookno_ono_h01?ono_h01Oooooooo_knookno_ono_kooooo00Coo_kn00?o
ooooookno_ono_h01?ono_h01Oooooooo_knookno_ono_kooooo00Coo_kn
00?oooooookno_ono_h01?ono_h01Oooooooo_knookno_ono_kooooo00Co
o_kn00?oooooookno_ono_h01?ono_h01Oooooooo_knookno_ono_kooooo
00Coo_kn00?oooooookno_ono_h01?ono_h01Oooooooo_knookno_ono_ko
oooo00Coo_kn00?oooooookno_ono_h01?ono_h01Oooooooo_knookno_on
o_kooooo00Coo_kn00?oooooookno_ono_h01?ono_h01Oooooooo_knookn
o_ono_kooooo00Coo_kn00?oooooookno_ono_h01?ono_h01Oooooooo_kn
ookno_ono_kooooo00Coo_kn00?oooooookno_ono_h01?ono_h01Ooooooo
o_knookno_ono_kooooo00Coo_kn00?oooooookno_ono_h01?ono_h01Ooo
ooooo_knookno_ono_kooooo00Coo_kn00?oooooookno_ono_h01?ono_h0
1Oooooooo_knookno_ono_kooooo00Coo_kn00?oooooookno_ono_h01?on
o_h01Oooooooo_knookno_ono_kooooo00Coo_kn00?oooooookno_ono_h0
1?ono_h01Oooooooo_knookno_ono_kooooo00Coo_kn00?oooooookno_on
o_h01?ono_h01Oooooooo_knookno_ono_kooooo00Coo_kn00?oooooookn
o_ono_h01?ono_h01Oooooooo_knookno_ono_kooooo00Coo_kn00?ooooo
ookno_ono_h01?ono_h01Oooooooo_knookno_ono_kooooo00Coo_kn00?o
ooooookno_ono_h01?ono_h01Oooooooo_knookno_ono_kooooo00Coo_kn
00?oooooookno_ono_h01?ono_h01Oooooooo_knookno_ono_kooooo00Co
o_kn00?oooooookno_ono_h01?ono_h01Oooooooo_knookno_ono_kooooo
00Coo_kn00?oooooookno_ono_h01?ono_h0:?omoOgono_koo[jn_ojnogo
nocnoo[lo_ojo?gon_cnoo[loOoko?kon_cmoo[koOojo?kon__moo[lo_oj
o?gonocnoo[koOojo?gon__moo_lo_ojo?kon_cmoo[lo_ojo?gonocnoo[l
oOojnogon_cnoo[koOojo?kon_cmoo_lo_ojnogon_cmoo[koOoko?kon_cn
oo[loOoalO43oogmo@06ooclo?omoOgoo?cloogmoOolo?cooOgm0oolo?`2
oogmo@04ooclo?omoOgoo?cloogmo@;oo?cl00GooOgmooclo?omoOgoo?cl
oogmo@03ooclo0;ooOgm00Coo?cloogmoOolo?cooOgm0_olo?`01OomoOgo
o?cloogmoOolo?cooOgm00?oo?cl0_omoOd01?olo?cooOgmooclo?omoOd2
ooclo005oogmoOolo?cooOgmooclo?omoOd00oolo?`2oogmo@04ooclo?om
oOgoo?cloogmo@;oo?cl00GooOgmooclo?omoOgoo?cloogmo@03ooclo0;o
oOgm00Coo?cloogmoOolo?cooOgm0_olo?`01OomoOgoo?cloogmoOolo?co
oOgm00?oo?cl0_omoOd01?olo?cooOgmooclo?omoOd4ooclo003oogmoOol
o?cooOgm00?oo?cl0_omoOd01?olo?cooOgmooclo?omoOd2ooclo005oogm
oOolo?cooOgmooclo?omoOd00oolo?`2oogmo@?oo?cl00SooOgmooclo?ol
o?cooOgmooclo?omoOgoo?cloogmo@?oo?cl0_omoOd01?olo?cooOgmoocl
o?omoOd2ooclo005oogmoOolo?cooOgmooclo?omoOd00oolo?`2oogmo@04
ooclo?omoOgoo?cloogmo@;oo?cl00GooOgmooclo?omoOgoo?cloogmo@03
ooclo0;ooOgm00Coo?cloogmoOolo?cooOgm0_olo?`01OomoOgoo?cloogm
oOolo?cooOgm00?oo?cl0_omoOd01?olo?cooOgmooclo?omoOd2ooclo005
oogmoOolo?cooOgmooclo?omoOd00oolo?`2oogmo@05ooclo?omoOgo_;bl
om?Cdoo`l?000_oemOD05?oXj>Sofm_KomoOgooVi^Kok>c/oo?clooinOWo
o?gmooShn?o^k^kokNg]of5QHOmSHf?oIfMWofUYJOm/K6coKFe]ofm`L?mb
LW;oLg=d0OmdM7@00009oo3alooal_?ol?;coo3blooal_Col?;coo7cm?o`
lO?ol?;c00;olO;d00Ool?;coo3aloo_l?7oko3`oo[jn_oinOWon_[j00;o
nOWi00Con_[jooWinOojn_[onOWi0oojn_X01ooinOWon_[jooWinOoinOWo
n_[jooWinOojn_X00_oinOT01?ojn_[onOWioo[jn_oinOT3oo[jnP07ooWi
nOojn_[onOWiooWinOojn_[onOWioo[jnP02ooWin@04oo[jn_oinOWon_[j
ooWin@?on_[j00OonOWioo[jn_oinOWonOWioo[jn_oinOWon_[j00;onOWi
00Con_[jooWinOojn_[onOWi0oojn_X01ooinOWon_[jooWinOoinOWon_[j
ooWinOojn_X00_oinOT01?ojn_[onOWioo[jn_oinOT3oo[jnP07ooWinOoj
n_[onOWiooWinOojn_[onOWioo[jnP02ooWin@04oo[jn_oinOWon_[jooWi
n@?on_[j00OonOWioo[jn_oinOWonOWioo[jn_oinOWon_[j00;onOWi00Co
n_[jooWinOojn_[onOWi0oojn_X01ooinOWon_[jooWinOoinOWon_[jooWi
nOojn_X00_oinOT01?ojn_[onOWioo[jn_oinOT3oo[jnP07ooWinOojn_[o
nOWiooWinOojn_[onOWioo[jnP02ooWin@04oo[jn_oinOWon_[jooWin@?o
n_[j00OonOWioo[jn_oinOWonOWioo[jn_oinOWon_[j00;onOWi00Con_[j
ooWinOojn_[onOWi0oojn_X01ooinOWon_[jooWinOoinOWon_[jooWinOoj
n_X00_oinOT01?ojn_[onOWioo[jn_oinOT3oo[jnP07ooWinOojn_[onOWi
ooWinOojn_[onOWioo[jnP02ooWin@04oo[jn_oinOWon_[jooWin@?on_[j
00OonOWioo[jn_oinOWonOWioo[jn_oinOWon_[j00;onOWi00Con_[jooWi
nOojn_[onOWi0oojn_X01ooinOWon_[jooWinOoinOWon_[jooWinOojn_X0
0_oinOT01?ojn_[onOWioo[jn_oinOT3oo[jnP07ooWinOojn_[onOWiooWi
nOojn_[onOWioo[jnP02ooWin@04oo[jn_oinOWon_[jooWin@?on_[j00Oo
nOWioo[jn_oinOWonOWioo[jn_oinOWon_[j00;onOWi00Con_[jooWinOoj
n_[onOWi0oojn_X01ooinOWon_[jooWinOoinOWon_[jooWinOojn_X00_oi
nOT01?ojn_[onOWioo[jn_oinOT3oo[jnP07ooWinOojn_[onOWiooWinOoj
n_[onOWioo[jnP02ooWin@04oo[jn_oinOWon_[jooWin@?on_[j00OonOWi
oo[jn_oinOWonOWioo[jn_oinOWon_[j00;onOWi00Con_[jooWinOojn_[o
nOWi0oojn_X01ooinOWon_[jooWinOoinOWon_[jooWinOojn_X00_oinOT0
1?ojn_[onOWioo[jn_oinOT3oo[jnP07ooWinOojn_[onOWiooWinOojn_[o
nOWioo[jnP02ooWin@04oo[jn_oinOWon_[jooWin@?on_[j00OonOWioo[j
n_oinOWonOWioo[jn_oinOWon_[j00;onOWi00Con_[jooWinOojn_[onOWi
0oojn_X03OoinOWon_[jooWinOohn?SomoOgooGemOofmoWomOOiooGgn?of
moWomOOhooKgnOoemoP00oofmoT03OoemoWom_OiooGgn?oemoWom_OiooGg
n?ofmoWomOOiooGgn?ofmoWomOOhooKgnOoemoP00oofmoT02ooemoWom_Oi
ooGgn?oemoWom_OiooGgn?ofmoWomOOiooGgn?ofmoWojn_[0=3onOWi01Wo
_Kfmom;Bd_obl_;ol?3`om_Kfoo>c/kod=3@omKFe_oKfm_oh^;Rong]kOof
m_Koo?clooWinOo`l?3oo_knofIVI_mYJFWoK6a/ofm_KombLW;oM7AdogIf
M_mhN7SoNWYj007oNg]k00001_oSi>KohnCUon;TiOoSi>KohnCUon;Si@;o
hnCU0_oRhnD01ooSi>Goh^?Ton;Si?oRhnCohN;Son_[joo/k>`00_o[jn/0
0oo/k>cojn_[on_[j`07on_[j`04onc/k?o[jn_ojn_[onc/k0;ojn_[00?o
k>c/on_[joo[jn/00_o[jn/01_nd];CoOgmoof9RH_mfMWKo`<30onc/k0;o
jn_[00Cok>c/on_[joo[jn_ok>c/2Oo[jn/01?o/k>cojn_[on_[joo/k>`2
on_[j`03onc/k?o[jn_ojn_[00;ojn_[00?odM7Aog]kNooUiND00_o[jn/0
1?o/k>cojn_[on_[joo/k>`2on_[j`03onc/k?o[jn_ojn_[00Oojn_[00Co
k>c/on_[joo[jn_ok>c/0_o[jn/01?o/k>codM7Aog]kNooUiND6on_[j`04
onc/k?o[jn_ojn_[onc/k0;ojn_[00?ok>c/on_[joo[jn/01oo[jn/01?o/
k>cojn_[on_[joo/k>`2on_[j`03onc/k?o[jn_ojn_[00Oojn_[00Cok>c/
on_[joo[jn_ok>c/0_o[jn/00oo/k>cojn_[on_[j`07on_[j`04onc/k?o[
jn_ojn_[onc/k0;ojn_[00?ok>c/on_[joo[jn/01oo[jn/01?o/k>cojn_[
on_[joo/k>`2on_[j`03onc/k?o[jn_ojn_[00Oojn_[00Cok>c/on_[joo[
jn_ok>c/0_o[jn/00oo/k>cojn_[on_[j`07on_[j`04onc/k?o[jn_ojn_[
onc/k0;ojn_[00?ok>c/on_[joo[jn/01oo[jn/01?o/k>cojn_[on_[joo/
k>`2on_[j`03onc/k?o[jn_ojn_[00Oojn_[00Cok>c/on_[joo[jn_ok>c/
0_o[jn/00oo/k>cojn_[on_[j`07on_[j`04onc/k?o[jn_ojn_[onc/k0;o
jn_[00?ok>c/on_[joo[jn/01oo[jn/01?o/k>cojn_[on_[joo/k>`2on_[
j`03onc/k?o[jn_ojn_[00Oojn_[00Cok>c/on_[joo[jn_ok>c/0_o[jn/0
0oo/k>cojn_[on_[j`07on_[j`04onc/k?o[jn_ojn_[onc/k0;ojn_[00?o
k>c/on_[joo[jn/01oo[jn/01?o/k>cojn_[on_[joo/k>`2on_[j`03onc/
k?o[jn_ojn_[00Oojn_[00Cok>c/on_[joo[jn_ok>c/0_o[jn/00oo/k>co
jn_[on_[j`07on_[j`04onc/k?o[jn_ojn_[onc/k0;ojn_[00?ok>c/on_[
joo[jn/02?o[jn/00ooZj^[ojNWYonSXj002onOYj`03onSYjooWjN_oinSZ
00?oinW[00GoinSZonOYjooWjN_oinW[onSYj`02onOYj`06onSYjooWjN_o
inW[onSYjooWjN_oinSZ0ooWjN/01OoWj>[oinW[onOYjooWjN_oj>W[00;o
inW[00Koj>W[onOYjooWjN_oj>W[onOYjooMgMd7on_[j`04onc/k?o[jn_o
jn_[onc/k0;ojn_[00?ok>c/on_[joo[jn/01oo[jn/01?o/k>cojn_[on_[
joo/k>`2on_[j`03onc/k?o[jn_ojn_[00Oojn_[00Ooj>SXonGUiOoShn?o
iNGUonWYjOo[jn_ok>c/00Wojn_[00Cok>c/on_[joo[jn_ok>c/0_o[jn/0
0oo/k>cojn_[on_[j`07on_[j`04on[Zj_oTi>Cojn_[onc/k0;ojn_[00?o
k>c/on_[joo[jn/01oo[jn/01?o/k>cojn_[on_[joo/k>`2on_[j`03onc/
k?o[jn_ojn_[00?ojn_[00GojNWYonCTi?o[jn_ojn_[onc/k002on_[j`04
onc/k?o[jn_ojn_[onc/k0Wojn_[00Cok>c/on_[joo[jn_ok>c/0_o[jn/0
0oo/k>cojn_[on_[j`07on_[j`04onc/k?o[jn_ojn_[onc/k0;ojn_[00?o
k>c/on_[joo[jn/01oo[jn/01?o/k>cojn_[on_[joo/k>`2on_[j`03onc/
k?o[jn_ojn_[00Oojn_[00Cok>c/on_[joo[jn_ok>c/0_o[jn/00oo/k>co
jn_[on_[j`07on_[j`04onc/k?o[jn_ojn_[onc/k0;ojn_[00?ok>c/on_[
joo[jn/01oo[jn/01?o/k>cojn_[on_[joo/k>`2on_[j`0Lonc/k?o[jn_o
jn_[okno_ooDe=Cojn_[ol_;bonOWiooRXZ:og]kNom`L73oMgMgohV9ROn/
[:cogmoOooCdm?ohn?Sokno_onk^k_mVIVKoJVYZofe]KOm`L73oLg=cogEe
MOmgMgOoNWYjog]kN`7oOGem0002oo3bl`?olO;c00ColO;doo3blooal_?o
l?;c0_oal_<2oo3al`03ono`lOo^ko3on_[j00;onOWi00Oon_[jooWinOoj
n_[on_[jooWinOojn_[onOWi00;on_[j00GonOWioo[jn_oinOWonOWioo[j
nP02ooWin@0>oo[jn_oinOWon_[joo[jn_oinOWon_[johb<S?mjNW[oYZJV
ofUYJOlH61So^k^kooWinOojn_X2ooWin@07oo[jn_oinOWon_[joo[jn_oi
nOWon_[jooWin@02oo[jnP05ooWinOojn_[onOWiooWinOojn_X00_oinOT0
2oojn_[onOWioo[jn_ojn_[onOWioo[jn_ofm_Ko:BTYojJVY_oinOWon_[j
00;onOWi00Gon_[jooWinOoinOWon_[jooWin@02oo[jnP03ooWinOojn_[o
nOWi00;on_[j00GonOWioo[jn_oinOWonOWioo[jnP02ooWin@07oo[jn_oi
nOWom_KfobTY:OnUYJGon_[jooWin@02oo[jnP05ooWinOojn_[onOWiooWi
nOojn_X00_oinOT01oojn_[onOWioo[jn_ojn_[onOWioo[jn_oinOT00_oj
n_X01OoinOWon_[jooWinOoinOWon_[j00;onOWi00Oon_[jooWinOojn_[o
n_[jooWinOojn_[onOWi00;on_[j00GonOWioo[jn_oinOWonOWioo[jnP02
ooWin@07oo[jn_oinOWon_[joo[jn_oinOWon_[jooWin@02oo[jnP05ooWi
nOojn_[onOWiooWinOojn_X00_oinOT01oojn_[onOWioo[jn_ojn_[onOWi
oo[jn_oinOT00_ojn_X01OoinOWon_[jooWinOoinOWon_[j00;onOWi00Oo
n_[jooWinOojn_[on_[jooWinOojn_[onOWi00;on_[j00GonOWioo[jn_oi
nOWonOWioo[jnP02ooWin@07oo[jn_oinOWon_[joo[jn_oinOWon_[jooWi
n@02oo[jnP05ooWinOojn_[onOWiooWinOojn_X00_oinOT01oojn_[onOWi
oo[jn_ojn_[onOWioo[jn_oinOT00_ojn_X01OoinOWon_[jooWinOoinOWo
n_[j00;onOWi00Oon_[jooWinOojn_[on_[jooWinOojn_[onOWi00;on_[j
00GonOWioo[jn_oinOWonOWioo[jnP02ooWin@07oo[jn_oinOWon_[joo[j
n_oinOWon_[jooWin@02oo[jnP05ooWinOojn_[onOWiooWinOojn_X00_oi
nOT01oojn_[onOWioo[jn_ojn_[onOWioo[jn_oinOT00_ojn_X01OoinOWo
n_[jooWinOoinOWon_[j00;onOWi00Oon_[jooWinOojn_[on_[jooWinOoj
n_[onOWi00;on_[j00GonOWioo[jn_oinOWonOWioo[jnP02ooWin@07oo[j
n_oinOWon_[joo[jn_oinOWon_[jooWin@02oo[jnP05ooWinOojn_[onOWi
ooWinOojn_X00_oinOT01oojn_[onOWioo[jn_ojn_[onOWioo[jn_oinOT0
0_ojn_X01OoinOWon_[jooWinOoinOWon_[j00;onOWi00Oon_[jooWinOoj
n_[on_[jooWinOojn_[onOWi00;on_[j00GonOWioo[jn_oinOWonOWioo[j
nP02ooWin@07oo[jn_oinOWon_[joo[jn_oinOWon_[jooWin@02oo[jnP05
ooWinOojn_[onOWiooWinOojn_X00_oinOT01oojn_[onOWioo[jn_ojn_[o
nOWioo[jn_oinOT00_ojn_X02OoinOWon_[jooWinOohn?SomoOgooGemOoe
moSom_OiooGgn@02ooKgn@03ooGgnOofmoWomOOi00;om_Oi00WomOOiooKg
nOoemoWomOOhooKgnOoemoWomOOhooKgnOoemoT00_ofmoT00ooemoWom_Oi
ooGgn@02ooKgn@0;ooGgnOofmoWomOOiooGgn?ofmoWomOOiooGgn?ofmoWo
mOOiooKgnOo/k>`09ooinOT01_oclo?ol_;booCdm?oalO7ok>c/ooKfmQ_o
nOWi00?okNg]ooCdm?oinOT06OoinOT00oo^k^kom?CdooWin@1YooWin@0=
okfm_Oo@d=3o_Kfmogf2Som8H9;o:5RUoaYO^olQIKgo=FVXodQWS?mNIVoo
QXJ6olK6aP02ong]k@0:onOWiomUIFGoJFUYofa/K?m_KfooLW9bogAdM?mf
MWKoN7QhogYjNP7oNg]k00001?oem_Som_OhooKgnOofmoT2ooKgn0;omOKg
00Gom_OhooGfn?oem_Oom_OhooCfm`02ooCemP03ooooooono_koo_kn00;o
oooo1?ono_h00oooooooo_knooknoP03ooknoP;ooooo0_ono_h01oo]kNgo
oOgmookno_odm?Colo?cookno_ooool00oono_h01?mRHV;oDE5Aoooooooo
ool2ooknoP;ooooo1?ono_h00oooooooo_knooknoP02ooknoP05onc/k?om
oOgooooooo?cloodm?@00_ooool4ooknoP03oooooonATI7oB4Q800?oo_kn
0_ooool2ooknoP;ooooo1?ono_h00oooooooo_knooknoP03ooknoP03ong]
kOomoOgoo_kn00;om?Cd00Koooooookno_nATI7oB4Q8ookno_ooool5ookn
oP04oooooooinOWof][JomkNgP;ooooo1?ono_h00oooooooo_knooknoP03
ooknoP;ooooo0_ono_h2ooooo`Coo_kn00?oooooookno_ono_h00oono_h2
ooooo`;oo_kn0_ooool4ooknoP03ooooooono_koo_kn00?oo_kn0_ooool2
ooknoP;ooooo1?ono_h00oooooooo_knooknoP03ooknoP;ooooo0_ono_h2
ooooo`Coo_kn00?oooooookno_ono_h00oono_h2ooooo`;oo_kn0_ooool4
ooknoP03ooooooono_koo_kn00?oo_kn0_ooool2ooknoP;ooooo1?ono_h0
0oooooooo_knooknoP03ooknoP;ooooo0_ono_h2ooooo`Coo_kn00?ooooo
ookno_ono_h00oono_h2ooooo`;oo_kn0_ooool4ooknoP03ooooooono_ko
o_kn00?oo_kn0_ooool2ooknoP;ooooo1?ono_h00oooooooo_knooknoP03
ooknoP;ooooo0_ono_h2ooooo`Coo_kn00?oooooookno_ono_h00oono_h2
ooooo`;oo_kn0_ooool4ooknoP03ooooooono_koo_kn00?oo_kn0_ooool2
ooknoP;ooooo1?ono_h00oooooooo_knooknoP03ooknoP;ooooo0_ono_h2
ooooo`Coo_kn00?oooooookno_ono_h00oono_h2ooooo`;oo_kn0_ooool4
ooknoP03ooooooono_koo_kn00?oo_kn0_ooool2ooknoP;ooooo1?ono_h0
0oooooooo_knooknoP02ooknoP;ooOgm00?oo?cloo[jn_ojo?h00_oko?h0
2?ojo?gon_cnoo[koOojnogonocnoo[loOojnogon_cn0_ojnod2oo_loP06
oo[koOojo?konocnoo_lo_ojo?gon_cn0_ojnod01?oko?kon_cmoo[koOoj
o?h2oo[ko@;onocn00Kon__moo[lo_oko?konocnoo[loOo`l?0QooknoP04
oogmoOono_koo_knoogmo@Koo_kn00?om_KfooGemOono_h03_ono_h01Oom
oOgoo_knookno_ono_kooOgm00Ooo_kn00?on?ShooCdm?ono_h04_ono_h0
0oomoOgoo_knooknoP02oogmo@;oo_kn00?on?ShooCdm?ono_h02?ono_h0
0oomoOgono_kooknoP1NooknoP0Iokbl_?nj^[[oLgbGobmDXol>DKgo5V35
ob9/bOlaN<go?8;AodF8dom9MJSoFfUjoh:2P_o9bLWoi^KVono_komVIVKo
JVYZofe]KOm`L73oLg=cogEeMOmgMgOoNGUiog]kN`01ogemO@000_oal_@2
oo7bl`;olO;d00Co^KZlodU:BooUinSol?7c0_oal_<2oo3alP09ono`lOoi
nOWon_[jocdm?OmjNW[onOWioo[jn_m9BDWoPh>300;on_[j01WoOWinoda<
C?ojn_[onOWiokBd]?lF5QKonOWioo[jn_mHF5So51@DobDU9OnMWIgo820P
oeiNG_ojn_[ohn?Sof=SHom2@T;oOgmooijNW_lZ:R[on_[jooWinOm9BDWo
Ph>300;onOWi00KoBDU9oh>3PooinOWon_[jojBTY?lW9bL2oo[jnP0;oeQH
F?lE5AGo9RHVoifMWOlO7aooGUiNooWinOm8B4SoPh>3oo[jn_oinOT00_oj
n_X01?nDU9Co3Ph>omCDe?oinOT2oo[jnP0;ooWinOojn_[on_[jooWinOlo
?coo3Ph>o`l?3olE5AGo>SXjogQhN?o^k^h00_ojn_X03_oinOWoF5QHoaDE
5OlU9BGoWIfMoalO7omNGUkonOWioo[jn_nEUIGo3Ph>omCDe?ojn_[onOWi
0_ojn_X02ooinOWon_[joo[jn_nGUiOo:BTYocdm?Old=3CoPh>3ooWinOoj
n_[onOWi00;on_[j00ConOWioo[jn_ojn_[onOWi0_ojn_X00ooinOWon_[j
oo[jnP02ooWin@;on_[j00ConOWioo[jn_ojn_[onOWi0_ojn_X01?oinOWo
n_[joo[jn_oinOT2oo[jnP;onOWi0_ojn_X01?oinOWon_[joo[jn_oinOT2
oo[jnP04ooWinOojn_[on_[jooWin@;on_[j0_oinOT2oo[jnP04ooWinOoj
n_[on_[jooWin@;on_[j00ConOWioo[jn_ojn_[onOWi0_ojn_X2ooWin@;o
n_[j00ConOWioo[jn_ojn_[onOWi0_ojn_X01?oinOWon_[joo[jn_oinOT2
oo[jnP;onOWi0_ojn_X01?oinOWon_[joo[jn_oinOT2oo[jnP04ooWinOoj
n_[on_[jooWin@;on_[j0_oinOT2oo[jnP04ooWinOojn_[on_[jooWin@;o
n_[j00ConOWioo[jn_ojn_[onOWi0_ojn_X2ooWin@;on_[j00ConOWioo[j
n_ojn_[onOWi0_ojn_X01?oinOWon_[joo[jn_oinOT2oo[jnP;onOWi0_oj
n_X01?oinOWon_[joo[jn_oinOT2oo[jnP04ooWinOojn_[on_[jooWin@;o
n_[j0_oinOT2oo[jnP04ooWinOojn_[on_[jooWin@;on_[j00ConOWioo[j
n_ojn_[onOWi0_ojn_X2ooWin@;on_[j00ConOWioo[jn_ojn_[onOWi0_oj
n_X01?oinOWon_[joo[jn_oinOT2oo[jnP;onOWi0_ojn_X01?oinOWon_[j
oo[jn_oinOT2oo[jnP04ooWinOojn_[on_[jooWin@;on_[j0_oinOT2oo[j
nP04ooWinOojn_[on_[jooWin@;on_[j00ConOWioo[jn_ojn_[onOWi0_oj
n_X2ooWin@;on_[j00ConOWioo[jn_ojn_[onOWi0_ojn_X01?oinOWon_[j
oo[jn_oinOT2oo[jnP;onOWi0_ojn_X01?oinOWon_[joo[jn_oinOT2oo[j
nP04ooWinOojn_[on_[jooWin@;on_[j0_oinOT2oo[jnP04ooWinOojn_[o
n_[jooWin@;on_[j0_oinOT01?ohn?SomoOgooKfm_ofmoT2ooGgn0?om_Oi
00?om_SiooKgnOoemoP00_ofmoT01?oemoWom_OiooKgnOoemoT2ooKgn@;o
mOOh0oofmoT00oofn?Wom_OiooGgn002ooKgn@04ooGgnOofmoWom_OiooGg
n@;om_Oi0_oemoP01?ofmoWok>c/ooWinOojn_X>ooWin@06ono_kooclo?o
nOWiooWinOo_knoolo?c0_oinOT01_obl_;okno_ooWinOoinOWomOGeonc/
k0;onOWi00gol?3`ong]kOo]kNgom?Cdong]kOoalO7onOWiooShn?oalO7o
kno_oo?cloodm?CokNg]00;onOWi00Kokno_oo?cloojn_[onOWiono_kooc
lo<2ooWin@0=ooCdm?o^k^konOWiooWinOo`l?3ok>c/ong]kOodm?CokNg]
oo3`l?ojn_[okno_oo;blP04ooWin@03ooCdm?o/k>comoOg00KonOWi00Oo
n_[jono_koo[jn_ok>c/ong]kOo^k^kol_;b00ConOWi00Kol?3`onc/k?o^
k^kom?Cdong]kOoalO42ooWin@03ooCdm?o/k>comoOg00OonOWi00KolO7a
ong]kOo_knook^k^oo7alOohn?P=ooWin@03oo[jn_oinOWonOWi00gonOWi
00?on_[jooWinOoinOT03OoinOT00oojn_[onOWiooWin@0=ooWin@03oo[j
n_oinOWonOWi00gonOWi00?on_[jooWinOoinOT03?oinOT06Onl_;coS8nN
oc9@Xol>B;_o3e[3oaeXbOl/Mloo>h;CodN9e_m?SmSoEYCLoe9k[?mTJg?o
UYJFomWIfOooooooIVIVofUYJOm/K6coKfm_og9bL_mdM7CoMWIfogQhN?mj
NWX00OmkNg/00003on;TiOoSiNKohnCU00;ohnCU00[o[Zn`oa0@4_l61`So
>CXkomSIf_oSi>Goh^CUon?TiOoRhnCohN;R0_o[jn/01_lk>c_oM7Adon_[
joo[jn_oADE5ogalO0;ojn_[00goN7QhodM7Aoo[jn_ok>c/ojZZZ_lE5AGo
jn_[okVi^OlA4A7ocLg=omGEeOmLG5co71`L00;ojn_[00KoD51@ocHf=_nJ
VY[oNGUiocDe=OlO7al2on_[j`06odA4A?mmOGgojn_[on_[jom4A4CoO7al
0_o[jn/03OnKVi_o9RHVon_[joni^KWo4A4Aolg=cOoDe=CoG5aLoa`L7?o/
k>cojn_[odE5AOmlO7`01?o[jn/01?lg=cOo5QHFog1`L?o/k>`4on_[j`0A
onc/k?o[jn_o?3`log9bL_o[jn_ohN7Qokno_om9BDWo:b/[omkNg_o[jn_o
^[Zjoa4A4Oo=cLgoe=CDoeaLG?lM7Ad00oo[jn/01Olf=SKo5ADEog1`L?o[
jn_ok>c/00;ojn_[00Wok>c/on_[joo[jn_oj>SXon_[joo/k>coa<C4o`l?
3onDU9@01?o[jn/01?o/k>cojn_[on_[joo/k>`4on_[j`03onc/k?o[jn_o
jn_[00Gojn_[00Cok>c/on_[joo[jn_ok>c/1?o[jn/00oo/k>cojn_[on_[
j`05on_[j`04onc/k?o[jn_ojn_[onc/k0Cojn_[00?ok>c/on_[joo[jn/0
1Oo[jn/01?o/k>cojn_[on_[joo/k>`4on_[j`03onc/k?o[jn_ojn_[00Go
jn_[00Cok>c/on_[joo[jn_ok>c/1?o[jn/00oo/k>cojn_[on_[j`05on_[
j`04onc/k?o[jn_ojn_[onc/k0Cojn_[00?ok>c/on_[joo[jn/01Oo[jn/0
1?o/k>cojn_[on_[joo/k>`4on_[j`03onc/k?o[jn_ojn_[00Gojn_[00Co
k>c/on_[joo[jn_ok>c/1?o[jn/00oo/k>cojn_[on_[j`05on_[j`04onc/
k?o[jn_ojn_[onc/k0Cojn_[00?ok>c/on_[joo[jn/01Oo[jn/01?o/k>co
jn_[on_[joo/k>`4on_[j`03onc/k?o[jn_ojn_[00Gojn_[00Cok>c/on_[
joo[jn_ok>c/1?o[jn/00oo/k>cojn_[on_[j`05on_[j`04onc/k?o[jn_o
jn_[onc/k0Cojn_[00?ok>c/on_[joo[jn/01Oo[jn/01?o/k>cojn_[on_[
joo/k>`4on_[j`03onc/k?o[jn_ojn_[00Gojn_[00Cok>c/on_[joo[jn_o
k>c/1?o[jn/00oo/k>cojn_[on_[j`05on_[j`04onc/k?o[jn_ojn_[onc/
k0Cojn_[00?ok>c/on_[joo[jn/01Oo[jn/02Oo/k>cojn_[on_[joo/k>co
jn_[on[Zj_oXj>SoinOWonSYj`04onOYj`04onOXj_oWjN_oinW[onSYj`;o
inW[00Koj>W[onOYjooWj>[oinSZonOYjooXjN/4onOYj`04onOXj_oWjN_o
inW[onSYj`;oinW[00Koj>W[onOYjooWj>[oinSZonOYjooXjN/3onOYj`03
omkNg_oZj^[oj^[Z00Coj^[Z00?ojn_[on[Zj_oZj^X00_oZj^X00oo[jn_o
j^[Zon[ZjP02on[ZjP0Aon3Ph?oTi>Coj^[Zon[Zj_oQhN7oi>CTon_[jooZ
j^[ohn?Son7QhOoZj^[ojn_[onOWiooNg]koj^[ZonOWiooMgMd00_oYjNT0
2_oRh^;ogmoOon[Zj_o[jn_ohN7Qon3Ph?oUiNGoi>CTon3Ph?oOgml2on[Z
jP0Aon7QhOoShn?oj^[Zon[Zj_oQhN7oi>CTon[Zj_o[jn_oi^KVomoOgooZ
j^[oinOWomkNg_oXj>SojNWYon;Rh_oOgml00_oZj^X02_oQhN7oi>CTon[Z
j_oZj^[ojn_[on[Zj_oPh>3og]kNon?Shoo[jn/6on[ZjP0;on3Ph?oTi>Co
j^[ZonWYjOoXj>SohN7QomoOgooYjNWoj^[ZonSXj?oNg]h00_oYjNT00ooR
h^;og]kNon[ZjP02on[ZjP03on3Ph?oNg]koi>CT00Coj^[Z00Cojn_[on[Z
j_oZj^[ojNWY0_oZj^X00ooYjNWog]kNonCTi002on[ZjP03on_[jooZj^[o
j^[Z00;oj^[Z00?ojn_[on[Zj_oZj^X02?oZj^X00oo[jn_oj^[Zon[ZjP02
on[ZjP03on_[jooZj^[oj^[Z00Soj^[Z00?ojn_[on[Zj_oZj^X00_oZj^X0
0oo[jn_oj^[Zon[ZjP08on[ZjP03on_[jooZj^[oj^[Z00;oj^[Z00?ojn_[
on[Zj_oZj^X02?oZj^X00oo[jn_oj^[Zon[ZjP02on[ZjP03on_[jooZj^[o
j^[Z00Soj^[Z00?ojn_[on[Zj_oZj^X00_oZj^X00oo[jn_oj^[Zon[ZjP02
on[ZjP0IokFe]OmKJ:3o3CZaoa5@_OlHHLGo96g:ocAid?m3Q]GoD8oKoeVG
gomRWnGoIJ7VoeI_SOmlO7co_[jnonk^k_mSHf?oIVIVofUYJOm/K6coKVi^
og1`L?mcLg?oMGEeogIfMP01ogQhN00000colO;doo7bloobl_ColO;cok^l
_OlA4Q?o>3TjojVZZol?417o?ChoonKWj?oal_<2oo3alP0Loo3`lOojn_[o
n_[jocdm?OmkNg_onOWioo[jn_m9BDWoPh>3oo[jn_oinOWoOgmood];Booj
n_[onOWiokBd]?lF5QKon_[jomKFe_l@413o_KfmooWinOnPX:3o:b/[oo[j
n_oalO7o5ADEokVi^@;on_[j00[oV9RHoadM7Oojn_[on_[jodU9BOn3Ph?o
n_[jooWinOm9BDWoPh>30_ojn_X03OnTY:Co:2PXoo[jn_oFe]Ko410@okbl
_?ojn_[oX:2Pob/[:ooinOWon_[jodQ8B?n3Ph<00oojn_X01Oo:b/[o3`l?
oj2PX?lO7aool_;b00Con_[j00ConOWioo[jn_lo?cooNGUi0oojn_X04Ood
m?Co:b/[ogIfM_ojn_[oeMGEoa0@4?nm_Kgon_[joj2PX?l[:b_on_[jooWi
nOo;bl_o3Ph>oj2PX?lO7aool_;b00?on_[j00?onOWioo[jn_ojn_X00_oj
n_X01?oinOWon_[jod=3@omWIfL3oo[jnP05ooWinOojn_[on_[joo[jn_oi
nOT01?ojn_X00ooinOWon_[jooWin@04oo[jnP05ooWinOojn_[on_[joo[j
n_oinOT01?ojn_X00ooinOWon_[jooWin@04oo[jnP05ooWinOojn_[on_[j
oo[jn_oinOT01?ojn_X00ooinOWon_[jooWin@04oo[jnP05ooWinOojn_[o
n_[joo[jn_oinOT01?ojn_X00ooinOWon_[jooWin@04oo[jnP05ooWinOoj
n_[on_[joo[jn_oinOT01?ojn_X00ooinOWon_[jooWin@04oo[jnP05ooWi
nOojn_[on_[joo[jn_oinOT01?ojn_X00ooinOWon_[jooWin@04oo[jnP05
ooWinOojn_[on_[joo[jn_oinOT01?ojn_X00ooinOWon_[jooWin@04oo[j
nP05ooWinOojn_[on_[joo[jn_oinOT01?ojn_X00ooinOWon_[jooWin@04
oo[jnP05ooWinOojn_[on_[joo[jn_oinOT01?ojn_X00ooinOWon_[jooWi
n@04oo[jnP05ooWinOojn_[on_[joo[jn_oinOT01?ojn_X00ooinOWon_[j
ooWin@04oo[jnP05ooWinOojn_[on_[joo[jn_oinOT01?ojn_X00ooinOWo
n_[jooWin@04oo[jnP05ooWinOojn_[on_[joo[jn_oinOT01?ojn_X00ooi
nOWon_[jooWin@04oo[jnP05ooWinOojn_[on_[joo[jn_oinOT01?ojn_X0
0ooinOWon_[jooWin@04oo[jnP05ooWinOojn_[on_[joo[jn_oinOT01?oj
n_X00ooinOWon_[jooWin@04oo[jnP05ooWinOojn_[on_[joo[jn_oinOT0
1?ojn_X00ooinOWon_[jooWin@04oo[jnP04ooWinOojn_[on_[joo[jnP?o
nOWi00GomoOgooKfm_oemoWom_OiooGgn004ooKgn@05ooGgn?ofmoWom_Oi
ooKgnOoemoP01?ofmoT00ooemoWom_OiooGgn004ooKgn@05ooGgn?ofmoWo
m_OiooKgnOoemoP01?ofmoT01OoemoWom_OiooGgn?ofmoWok>c/013onOWi
00Kokno_oo;bl_oinOWonOWiono_kooclo<2ooWin@0Aoo?cloo_knoonOWi
ooWinOofm_Kok>c/ooWinOogmoOok>c/ooKfm_oinOWom?Cdonk^k_oinOWo
n?Shong]kOofm_H00_oinOT01_oclo?okNg]ooWinOoinOWokno_oo?cl`;o
nOWi00gol?3`oo?clooinOWonOWiooGemOo^k^konOWiooOgmoo/k>com_Kf
ooWinOodm?Cok^k^00;onOWi00?okno_oo?clooinOT00_oinOT01?ogmoOo
k>c/ooCdm?o]kNd7ooWin@03onk^k_obl_;onOWi00?onOWi00Wok^k^oo;b
l_oinOWomoOgonc/k?oemOGonOWiooCdm?o^k^h00_oinOT01?ogmoOok>c/
ooCdm?o/k>`;ooWin@;ol?3`G?oinOT06On_[joo=4ZUoaQ;_?mGSmOoHY[K
oe2Af_ljP=GoBhgKoeRIiOmUY>goL:geog>an_mSS;koLg=cojn_[ooWinOo
IVIVofUYJOm/K6coKfm_og9bL_mdM7CoMWIfogQhN?mjNWX00OmkNg/0000C
ooGgn?ofmoWom_Ohokjo`OlA4Q?o>S/lonSXj_ofmoSo^kbmoa0A4_ln?d7o
j^_/ooGfmooemOKom?Geooooooono_ko?cloogemO@02ooknoP06odY:B_n5
QHGoo_knookno_n1PH7oCDe=0_ono_h03Ong]kOo5aLGooooooono_ko/K6a
ocdm?Oln?Sko@D51ob`/;?ono_koaLG5o`h>3_oVi^H00_ono_h01_n`/;3o
7QhNookno_ooooooBTY:ohJ6QP;oo_kn00KoBTY:ohF5QOono_koo_knojRX
Z?lX:2P2ooknoP09ok6a/Olm?Cgo?Shnod51@Ol/;2coooooookno_m:BT[o
QXJ600?oo_kn00GoLG5aod];Boono_ko<c<cojVYZ@02ooknoP06ooooooon
o_koooooookno_m1@D7oNg]k1?ono_h02On3Ph?o;Rh^ookno_ono_ko/K6a
ocdm?Olo?coo@D51obd];@02ooknoP05og5aLOm;Bd_oo_knoc@d=?nYZJT0
1_ono_h01_ooooooo_knoooooooalO7o71`Loh61P@[oo_kn00?oooooookn
o_ooool03Oono_h00oooooooo_knooooo`0=ooknoP03ooooooono_kooooo
00goo_kn00?oooooookno_ooool03Oono_h00oooooooo_knooooo`0=ookn
oP03ooooooono_kooooo00goo_kn00?oooooookno_ooool03Oono_h00ooo
ooooo_knooooo`0=ooknoP03ooooooono_kooooo00goo_kn00?oooooookn
o_ooool03Oono_h00oooooooo_knooooo`0=ooknoP03ooooooono_kooooo
00goo_kn00?oooooookno_ooool03Oono_h00oooooooo_knooooo`0=ookn
oP03ooooooono_kooooo00coo_kn00oooOgmooclo?ojn_[onocnoo[lo_oj
o?gon_cnoo[loOojnogon_cmoo[lo_ojo?gon_cnoo[koOojo?h00_ojo?d0
3_oko?kon__moo_lo_ojo?kon_cmoo[lo_ojo?gon__moo[loOojo?kon_cm
oo[lo_ojnogon_cn0_ojo?d01ooko?kon__moo_lo_ojo?kon_cmoo[lo_o`
l?004?ono_h01_oclo?omoOgookno_ono_kom?CdooOgm`;oo_kn00KomoOg
ooGemOono_koo_knoo[jn_oalO42ooknoP09ooWinOoclo?olo?coo?cloob
l_;oo_knoo_knoo`l?3ooOgm00;oo_kn00Kon_[joo;bl_ono_koo_knooCd
m?ogmoL2ooknoP06ooCdm?ogmoOoo_knookno_oinOWol_;b0_ono_h01Ooj
n_[olo?coo?cloodm?Col_;b00;oo_kn00?om?CdooOgmoono_h00_ono_h0
1Oofm_Kom?Cdookno_obl_;on_[j00Koo_kn00?om?CdooOgmoono_h00oon
o_h01OogmoOolo?cookno_ono_kon_[j00?olo?c00Sol_;bookno_ono_ko
m_KfooCdm?ono_kolo?cooWin@Woo_kn00?ooOgmoo;bl_ohn?P0G?ono_h0
6On][Jgo63JXodilc_n>]nGoQ[;Togf^i?m1QmSoDICRof6Sk?m]/?OoNKcn
oh?6oomd[^koJVYZojZZZ_o_knooIVIVofYZJ_m]KFgoL71`og=cLomeMGGo
MgMgogUiNOmkNg/00OmmOGd00007oo7blooal_ColO;coh^<SOli>C[ohnCU
oo;cm002oo7bl`0:okNh^Ol@4A;o?3dnonKWj?o`l?7oko3aoo[jn_oinOWo
?CdmogYjNP;on_[j00_oBDU9og9bL_oinOWonOWiogemOOln?Skon?Shoo[j
n_nb/[;o5QHFoo[jnP03ooWin@0;ooShn?nGUiOo;2`/oo[jn_oGemOo3Ph>
okFe]Oojn_[onOWiojf][OlM7Ad00_ojn_X04Om8B4SoPh>3ooWinOojn_[o
BDU9ofATI?ojn_[onOWioijNW_lY:BWon_[jooWinOojn_[onOWiooShn?nG
UiOo;2`/00;onOWi00_oBDU9ofm_Koojn_[on_[joo7alOlK6a_oXj>Soo[j
n_nCTi?oAdM7ooWin@02oo[jnP?onOWi00Co?cloogUiNOojn_[on_[j0_oi
nOT04?nOWioo410@ooCdm?ojn_[onOWioo[jn_ohn?SoUYJFob`/;?oinOWo
lO7aoa`L7?nSXj?on_[joi>CTom6ATH2oo[jnP0:ooWinOojn_[onOWioo[j
n_o`l?3oclo?oifMWOm@D53o7alOomkNgP;on_[j0_oinOT2oo[jnP03ooWi
nOojn_[onOWi00;on_[j0ooinOT4oo[jnP;onOWi0_ojn_X00ooinOWon_[j
ooWin@02oo[jnP?onOWi1?ojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT0
0_ojn_X3ooWin@Con_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi00;on_[j
0ooinOT4oo[jnP;onOWi0_ojn_X00ooinOWon_[jooWin@02oo[jnP?onOWi
1?ojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT00_ojn_X3ooWin@Con_[j
0_oinOT2oo[jnP03ooWinOojn_[onOWi00;on_[j0ooinOT4oo[jnP;onOWi
0_ojn_X00ooinOWon_[jooWin@02oo[jnP?onOWi1?ojn_X2ooWin@;on_[j
00?onOWioo[jn_oinOT00_ojn_X3ooWin@Con_[j0_oinOT2oo[jnP03ooWi
nOojn_[onOWi00;on_[j0ooinOT4oo[jnP;onOWi0_ojn_X00ooinOWon_[j
ooWin@02oo[jnP?onOWi1?ojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT0
0_ojn_X3ooWin@Con_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi00;on_[j
0ooinOT4oo[jnP;onOWi0_ojn_X00ooinOWon_[jooWin@02oo[jnP?onOWi
1?ojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT00_ojn_X3ooWin@Con_[j
0_oinOT2oo[jnP03ooWinOojn_[onOWi00;on?Sh00GomOGeooGgnOoemoSo
m_OiooKhn@02ooKgn@09ooGgnOoemoSom_OiooKgnOoemoWom_OiooGgn?of
moWom_Si00;omOOi00?omOOhooKgnOofn?T00_ofmoT02OoemoWomOOhooKg
nOofmoWomOOiooKgnOoemoSom_OiooKhn@02ooGgn@04ooGgn?ofmoWom_Si
on_[j`WonOWi00?on_[jooWinOoinOT01?oinOT01_o_knool_;booWinOoi
nOWokno_oo7al@;onOWi00Kol_;bono_kooinOWonOWiooGemOo]kNd5ooWi
n@0:ooCdm?o^k^konOWiooOgmoo[jn_omOGeoo[jn_oinOWomOGeong]k@;o
nOWi00Kokno_oo?clooinOWonOWiono_kooalO42ooWin@03ooCdm?o]kNgo
n_[j00ConOWi00Kom?Cdonk^k_oinOWonOWiono_kooalO43ooWin@05onc/
k?odm?Con_[joo?cloo_knl01_oinOT00oo^k^kol_;booWin@03ooWin@03
ooCdm?o]kNgonOWi00ConOWi00_om?Cdonk^k_oinOWon?Shong]kOoemOGo
nOWiooCdm?o_knoonOWioo[jnP05ooWin@05ooCdm?oalO7ok^k^oo7alOoh
n?P01OoinOT00oojn_[onOWiooWin@0=ooWin@03oo[jn_oinOWonOWi00go
nOWi00?on_[jooWinOoinOT03OoinOT00oojn_[onOWiooWin@0=ooWin@03
oo[jn_oinOWonOWi00gonOWi00?on_[jooWinOoinOT01?oinOT06On/[:co
3S2^og>If_nA^^OoRkOUoh:aiOm3R=_oEY[XofJWlOmg^OooPLCnohW>o_n4
aOkoI6ATojZZZ_ooooooIVIVofUYJOm/K6coKfm_og9bL_mdM7CoMWIfogQh
N?mjNWX00OmlO7`00005on?Ti_oSiNKohnCVon?TiOoNh>400_oSi>D2on?U
iP06on?TiOn[[:go3a0AocPi>_oGf=WohN;R0_o[jn/03_lk>c_oM7Adon_[
joo[jn_oA4A4ob0P8?n8R8SoemOGodA4A?lX:2SoHF5Qom;Bd_m`L73o>SXj
0_o[jn/03OnZZZ[obl_;onSXj?mRHV;oEUIFon_[joo/k>co@D51odY:B_oB
d];ogmoOoeQHF?lL71`00_o[jn/07_m5ADGoO7alon_[joo[jn_oADE5oalO
7omdM7Coclo?oeYJF_m@D53ojn_[onc/k?nYZJWobl_;onSXj?mRHV;oEeMG
onc/k?o[jn_oA4A4oahN7_n;Rh_odm?CoiZJV_lJ6Q[oh^;Ron_[jooLg=co
5ADEolW9b@?ojn_[00Cok>c/on_[joll?3coLW9b0_o[jn/2onc/k00KohZ:
R_lB4Q;oj>SXon_[jonZZZ[ob/[:onSXj?mRHV;oEeMGon_[jonKVi_o6ATI
on7QhOo[jn_og=cLoaHF5_o8b<Sojn_[onc/k?o[jn_ok>c/on_[jonb/[;o
51@DodM7AomaLG7od];B00?ojn_[0_o/k>`2on_[j`03onc/k?o[jn_ok>c/
00?ojn_[00?ok>c/on_[joo[jn/00oo[jn/2onc/k0;ojn_[00?ok>c/on_[
joo/k>`00oo[jn/00oo/k>cojn_[on_[j`03on_[j`;ok>c/0_o[jn/00oo/
k>cojn_[onc/k003on_[j`03onc/k?o[jn_ojn_[00?ojn_[0_o/k>`2on_[
j`03onc/k?o[jn_ok>c/00?ojn_[00?ok>c/on_[joo[jn/00oo[jn/2onc/
k0;ojn_[00?ok>c/on_[joo/k>`00oo[jn/00oo/k>cojn_[on_[j`03on_[
j`;ok>c/0_o[jn/00oo/k>cojn_[onc/k003on_[j`03onc/k?o[jn_ojn_[
00?ojn_[0_o/k>`2on_[j`03onc/k?o[jn_ok>c/00?ojn_[00?ok>c/on_[
joo[jn/00oo[jn/2onc/k0;ojn_[00?ok>c/on_[joo/k>`00oo[jn/00oo/
k>cojn_[on_[j`03on_[j`;ok>c/0_o[jn/00oo/k>cojn_[onc/k003on_[
j`03onc/k?o[jn_ojn_[00?ojn_[0_o/k>`2on_[j`03onc/k?o[jn_ok>c/
00?ojn_[00?ok>c/on_[joo[jn/00oo[jn/2onc/k0;ojn_[00?ok>c/on_[
joo/k>`00oo[jn/00oo/k>cojn_[on_[j`03on_[j`;ok>c/0_o[jn/00oo/
k>cojn_[onc/k003on_[j`03onc/k?o[jn_ojn_[00?ojn_[0_o/k>`2on_[
j`03onc/k?o[jn_ok>c/00?ojn_[00?ok>c/on_[joo[jn/00oo[jn/2onc/
k0;ojn_[00?ok>c/on_[joo/k>`00oo[jn/00oo/k>cojn_[on_[j`03on_[
j`;ok>c/0_o[jn/00oo/k>cojn_[onc/k003on_[j`03onc/k?o[jn_ojn_[
00?ojn_[0_o/k>`2on_[j`0<onc/k?o[jn_ojn_[on[Zj_oYjNWoinOWonSY
jooWjN_oinSZonOYjooWj>[oinW[0_oXjN/01_oWjN_oinSZonSYjooWjN_o
j>W[onOXjP;oinW[00Koj>W[onOYjooWj>[oinW[onOXj_oWjN/2onSYj`06
onOYjooWj>[oj>W[onOYjooXjN_oinSZ0_oWjN/01OoXjN_oinW[onOXj_oW
jN_og]kN013oj^[Z00koh>3PonCTi?oZj^[oj^[Zon3Ph?oOgmooi>CTonWY
jOoPh>3ogmoOon;Rh_oYjNWohn?Son3Ph0;oj^[Z00Goi^KVonWYjOoZj^[o
h^;Ron7Qh@02on[ZjP;ohN7Q00Coj>SXon[Zj_oRh^;ogmoO0_oZj^X02_oP
h>3oi>CTon[Zj_oZj^[ohN7QomkNg_oTi>Coj>SXon;Rh_oQhN42on[ZjP05
onOWiooXj>Soj^[Zon;Rh_oQhN400_oZj^X02ooQhN7og]kNonCTi?oYjNWo
iNGUomoOgooYjNWoj^[ZonWYjOoNg]koj>SX00Goj^[Z00?ohN7Qon?ShooZ
j^X00ooZj^X01ooTi>Cog]kNon[Zj_oZj^[oi^KVonSXj?oZj^X00_oRh^80
2?oZj^[oi^KVomkNg_oYjNWoj^[ZonWYjOoNg]koj>SX1_oZj^X01?oUiNGo
h^;Ron7QhOoWinMMon[ZjP0Iojj^[_l=;:_oNikKoi:hiOn9]NCoP[7UodF:
g?mGV^WoJ:WeogRio_n4b?koS];nohS:o_mRHV;oZj^[ong]kOmSHf?oIVIV
ofUYJOm/K6coKVi^og1`L?mbLW;oMGEeogIfMP01ogQhN00000Col_?doo7b
loobloColO;c0_oblo@08?oaloColO;coo;cm?oal_?olO;dokNh^Ol?417o
>S/lonCUi_oinOWon_[jocdm?OmkNg_onOWioo[jn_mKFe_oSXj>ogEeMOlM
7Ago<c<com;Bd_nLW9co9RHVob/[:on][JgonOWioo[jn_n=SHgo?Cdmoa`L
7?m2@T;o`l?30_oinOT01_oPh>3oC4a<oaPH6?ld=3CoNWYjocDe=@;onOWi
01WoFe]Koi2@T?ojn_[onOWioeaLG?n?ShooOGemoalO7oli>CWo`l?3ooWi
nOojn_[oSHf=oc`l??lL71co@D51ol?3`ooinOWon_[joe]KFon=SHgoI6AT
oaHF5_mKFe_oMWIf00;onOWi00?on_[jog5aLOn9RHT00_oinOT01Oojn_[o
nOWioo[jn_lo?cooNGUi00?onOWi00gon_[joeUIFOlg=cOon_[jooWinOn=
SHgo?3`loa`L7?m2@T;o`/;2oo[jn_mQHF7oMWIf00?onOWi00CoLG5aohR8
R?oinOWon_[j0ooinOT01_nl_;co=3@dooWinOojn_[onOWioo[jnP?onOWi
00Con_[jooWinOoinOWon_[j1?oinOT01Oojn_[onOWioo[jn_oinOWon_[j
00?onOWi00Con_[jooWinOoinOWon_[j1?oinOT01Oojn_[onOWioo[jn_oi
nOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j1?oinOT01Oojn_[onOWi
oo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j1?oinOT01Ooj
n_[onOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j1?oi
nOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWo
n_[j1?oinOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWi
nOoinOWon_[j1?oinOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi00Co
n_[jooWinOoinOWon_[j1?oinOT01Oojn_[onOWioo[jn_oinOWon_[j00?o
nOWi00Con_[jooWinOoinOWon_[j1?oinOT01Oojn_[onOWioo[jn_oinOWo
n_[j00?onOWi00Con_[jooWinOoinOWon_[j1?oinOT01Oojn_[onOWioo[j
n_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j1?oinOT01Oojn_[o
nOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j1?oinOT0
1Oojn_[onOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j
1?oinOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoi
nOWon_[j1?oinOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi00Con_[j
ooWinOoinOWon_[j1?oinOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi
00Con_[jooWinOoinOWon_[j0_oinOT01oohn?SomoOgooKfm_oem_Som_Oi
ooGgnOofmoT00_oemoT01Ooem_Som_OiooGgnOoemoWom_Oi00?omOOi00Ko
mOKhooKgnOoem_Som_OiooGgnOofmoT2ooGgn@05ooGfn?ofmoWomOOiooGg
nOofmoT00ooemoT01ooem_Som_OiooGfn?ofmoWomOOiooKgnOo/k>`00_oi
nOT00oojn_[onOWiooWin@0;ooWin@0>ono_koobl_;on_[jooWinOo`l?3o
m?Cdoo;bl_o]kNgok^k^ooKfm_odm?CokNg]onk^k_oemOD2ooWin@05oo?c
loo^k^kokNg]ono_koofm_H00_oinOT01_ohn?Sokno_onc/k?o^k^kol_;b
ono_k`;onOWi00GolO7aoo?clooinOWon_[joo3`l002oo?cl`03ong]kOo^
k^kom_Kf00;onOWi00Golo?cono_koo]kNgokno_ooKfmP02ooWin@06oo7a
lOoclo?olO7aong]kOo`l?3ol_;b0ooinOT00ooalO7olo?cooWin@04ooWi
n@03ono_koobl_;onOWi00?onOWi00col?3`onk^k_oinOWonOWiooCdm?o^
k^kokNg]ono_koofm_KonOWioo7alOobl_83ooWin@03oo;bl_oclo?onOWi
00OonOWi00?omoOgong]kOogmoL03_oinOT00oojn_[onOWiooWin@0=ooWi
n@03oo[jn_oinOWonOWi00gonOWi00?on_[jooWinOoinOT03OoinOT00ooj
n_[onOWiooWin@0=ooWin@03oo[jn_oinOWonOWi00_onOWi01Wo[jn_o`h[
ZommWmcoT[WUohZgi_n2/^KoAXgOoeVMk_mY[?SoN;gnohO<oonAeokoRLco
ofATI?n/[:coinOWofEUIOmYJFWoK6a/ofi^K_maLG7oLg=cogEeMOmhN7So
NWYj007oNg]k0005ooKgn004ooGgn?ofmoSom_OhooKgn@?om_Oh00?o^[^l
o`l@4Om[K6d00_ono_h00olo?cooOGemooknoP04ooknoP03oogmoOono_ko
o_kn00;oo_kn00?ooOgmookno_ono_h00oono_h00oolo?coo_knooknoP04
ooknoP03ooclo?ono_koo_kn00[oo_kn00?ooOgmookno_ono_h01?ono_h0
0oolo?coo_knooknoP05ooknoP03oo_knoono_koo_kn00[oo_kn00?o@D51
og]kNoono_h00_ono_h00onTY:Co3`l?ojFUY@04ooknoP03ooclo?ono_ko
o_kn00goo_kn00?o`<30oc@d=?ono_h0noono_h2oogmo@04ooclo?ojn_[o
n_cmoo[ko@;on_cm00Gon__moo[loOojnogon__moo[lo@02oo[ko@07oo[l
oOojnogon_cnoo[loOojnogon_cmoo[ko@02oo[lo@05oo[koOojo?gon__m
oo[koOojo?d00_ojnod01oojo?gon__moo[lo_ojo?gon__moo[loOojnod0
0_ojo?d00oo_knooo_knoogmo@02ooknoP04oogmoOono_koo_knoogmo@;o
o_kn00?ooOgmookno_ono_h00_ono_h00oomoOgolo?cooOgm`02ooknoP04
oogmoOono_koo_knoogmo@;oo_kn00?ooOgmookno_ono_h00_ono_h00oom
oOgoo_knoogmo@02ooknoP04oogmoOono_koo_knoogmo@;oo_kn00?ooOgm
ookno_ono_h00_ono_h00oomoOgoo_knoogmo@02ooknoP04oogmoOono_ko
o_knoogmo@;oo_kn00?ooOgmookno_ono_h00_ono_h00oomoOgoo_knoogm
o@02ooknoP04oogmoOono_koo_knoogmo@;oo_kn00?ooOgmookno_ono_h0
0_ono_h01_omoOgoo_knoogmoOodm?ComoOgoogmo@;oo_kn00Con?Shoo7a
lOoinOWooOgm1?ono_h00oomoOgoo_knoogmo@02ooknoP04oogmoOono_ko
o_knoogmo@;oo_kn00?ooOgmookno_ono_h00_ono_h01_omoOgoo_knoogm
oOobl_;onOWioogmo@;oo_kn00CooOgmookno_ono_kooOgm1?ono_h00oom
oOgoo_knoogmo@02ooknoP04oogmoOono_koo_knoogmo@;oo_kn00?ooOgm
ookno_ono_h00_ono_h00oomoOgoo_knoogmo@02ooknoP04oogmoOono_ko
o_knoogmo@;oo_kn00?ooOgmookno_ono_h00_ono_h00oomoOgoo_knoogm
o@02ooknoP04oogmoOono_koo_knoogmo@;oo_kn00?ooOgmookno_ono_h0
0_ono_h00oomoOgoo_knoogmo@02ooknoP04oogmoOono_koo_knoogmo@;o
o_kn00?ooOgmookno_ono_h00_ono_h00oomoOgoo_knoogmo@02ooknoP04
oogmoOono_koo_knoogmo@;oo_kn00?ooOgmookno_ono_h00_ono_h06_om
oOgo[jn_o`hZZ_n0XM_oT[SVohNeiOn0/NOo@hgQoeBJj_mX[OgoMkcoohC9
o_n?e_ooR<onofEUIOn^[Zkok^k^ofIVI_mYJFWoK6a/ofm_KombLW;oM7Ad
ogMgMomhN7SoNg]k0OmlO7`00003oo7bloobloCol_?d00;olO;c00Kol_?d
oo7bloobloColO;coo;cm?oalo@2oo7bl`06okjo`?oRhnConOWiooWinOlm
?CgoNWYj7OoinOT00omQHF7oUIFEooWin@0PooWin@08ochn?_lh>3SoJVYZ
oeIFE_lg=cOo4a<Coi:BT_ohn?PDooWin@06okbl_?lH61SoEEEEoeEEEOmD
E5CoYjNWnOoinOT00oohn?SomoOgooGem@02ooGgn@;omOKh00ComOOiooGf
n?oemoWomOKh0_oemoT01_oem_SomOOiooGgnOoem_SomOOiooGfn0;omOOi
0_oem_P01?oemoWomOKhooGgnOoem_P2ooGgn@06ooGfn?oemoWomOOiooGf
n?oemoWomOKh0_oemoT2ooGfn003onc/k?oinOWonOWi00?onOWi00?on?Sh
ooWinOoinOT01OoinOT2ooShn003ooWinOo^k^kol_;b00?onOWi00?on?Sh
ooWinOoinOT01OoinOT2ooShn0KonOWi00?on?ShooWinOoinOT01OoinOT2
ooShn003oo7alOoclo?onOWi00?onOWi00?on?ShooWinOoinOT01OoinOT2
ooShn0KonOWi00?on?ShooWinOoinOT01OoinOT2ooShn0?onOWi0_o^k^h0
1OoalO7okno_onk^k_o/k>colo?c00ConOWi0_ohn?P6ooWin@03ooShn?oi
nOWonOWi00GonOWi00Won?Shoo?cloobl_;om?Cdoo7alOo/k>con?ShooWi
nOohn?P01ooinOT2ooShn0KonOWi00?on?ShooWinOoinOT01OoinOT2ooSh
n0KonOWi00?on?ShooWinOoinOT01OoinOT2ooShn0KonOWi00?on?ShooWi
nOoinOT01OoinOT2ooShn0KonOWi00?on?ShooWinOoinOT01OoinOT2ooSh
n0KonOWi00?on?ShooWinOoinOT01OoinOT2ooShn00JooWinOn^[Zko3TBf
ogfXgonJ_nOoUkkZohjij_mGV>CoJJW`ogZgo_n;b_koU]Knoj?To_nKf_ko
I6ATojj^[_ooooooI6ATofQXJ?m[Jf_oKVi^og1`L?mbLW;oMGEeogMgMomi
NGT1og]kN`001?ofmoP01_ofmoWom_OhooKgn?ofn?Wom_OhooGgn0;om_Oh
0_oem_L01Oodm?Goo_knoogmoOnb/[;ob/[:00;oo_kn0_omoOd2ooknoP07
oogmoOono_kooOgmoogmoOono_kooOgmooknoP03oogmo@;oo_kn0_omoOd2
ooknoP0:oogmoOono_kooOgmoogmoOono_kooOgmookno_ng]kOoc/k>oogm
o@;oo_kn0_omoOd2ooknoP07oogmoOono_kooOgmoogmoOono_kooOgmookn
oP03oogmo@;oo_kn0_omoOd2ooknoP07oogmoOono_kooOgmoogmoOono_ko
oOgmooknoP03oogmo@08ok>c/onOWiooWYjNojFUYOo6a/Kojn_[oogmoOon
o_h2oogmo@03ookno_omoOgoo_kn00?ooOgm0_ono_h2oogmo@;oo_kn00Oo
oOgmookno_omoOgooOgmookno_omoOgoiNGU00CoWYjN00?od=3@oogmoOom
oOd00_ono_h01oomoOgoo_knoogmoOomoOgoo_knoogmoOono_h00oomoOd2
ooknoP;ooOgm0_ono_h01oomoOgoo_knoogmoOomoOgoo_knoogmoOono_h0
0oomoOd2ooknoP;ooOgm0_ono_h01oomoOgoo_knoogmoOomoOgoo_knoogm
oOono_h00oomoOd2ooknoP;ooOgm0_ono_h01oomoOgoo_knoogmoOomoOgo
o_knoogmoOono_h00oomoOd2ooknoP;ooOgm0_ono_h01oomoOgoo_knoogm
oOomoOgoo_knoogmoOono_h00oomoOd2ooknoP;ooOgm0_ono_h01oomoOgo
o_knoogmoOomoOgoo_knoogmoOono_h00oomoOd2ooknoP;ooOgm0_ono_h0
1oomoOgoo_knoogmoOomoOgoo_knoogmoOono_h00oomoOd2ooknoP;ooOgm
0_ono_h01oomoOgoo_knoogmoOomoOgoo_knoogmoOono_h00oomoOd2ookn
oP;ooOgm0_ono_h01oomoOgoo_knoogmoOomoOgoo_knoogmoOono_h00oom
oOd2ooknoP;ooOgm0_ono_h01oomoOgoo_knoogmoOomoOgoo_knoogmoOon
o_h00oomoOd2ooknoP;ooOgm0_ono_h01oomoOgoo_knoogmoOomoOgoo_kn
oogmoOono_h00oomoOd2ooknoP;ooOgm0_ono_h01oomoOgoo_knoogmoOom
oOgoo_knoogmoOono_h00oomoOd2ooknoP;ooOgm0_ono_h01oomoOgoo_kn
oogmoOomoOgoo_knoogmoOono_h00oomoOd2ooknoP;ooOgm0_ono_h01oom
oOgoo_knoogmoOomoOgoo_knoogmoOono_h00oomoOd2ooknoP;ooOgm0_on
o_h01oomoOgoo_knoogmoOomoOgoo_knoogmoOono_h00oomoOd2ooknoP;o
oOgm0_ono_h02OomoOgoo_knoogmoOomoOgoo_knooclo?okno_on_[jooWk
o@02oo[ko@06oo[loOojnogonO_moo[loOojnogonO_m0oojnod01Oojo?go
nO_moo[koOojnogonO_m00;on__m00Kon_cmoo[koOoinogon_cmoo[koOoi
nod3oo[ko@05oo[loOoinogon__moo[koOoinod00_ojnod00oojo?golO7a
ooclo002oogmo@07ooclo?omoOgoo?clooclo?omoOgoo?cloogmo@03oocl
o0;ooOgm00Koo?clooShn?ojn_[ooOgmooclo?omoOd2ooclo003oogmoOol
o?cooOgm00?oo?cl0_omoOd2ooclo0;ooOgm00Ooo?cloogmoOolo?coo?cl
oogmoOolo?cooOgm00?oo?cl0_omoOd01_oinOWon_[joogmoOomoOgoo?cl
oogmo@;oo?cl00?ooOgmooclo?omoOd00oolo?`2oogmo@;oo?cl0_omoOd0
1oolo?cooOgmooclo?olo?cooOgmooclo?omoOd00oolo?`2oogmo@;oo?cl
00?ooOgmooWinOogmoL00_ohn?P01?ojn_[oo?clooclo?omoOd3ooclo0;o
oOgm0_olo?`2oogmo@07ooclo?omoOgoo?clooclo?omoOgoo?cloogmo@03
ooclo008oogmoOokno_omoOgooGemOohn?Sono_kooclo?omoOd2ooclo003
oogmoOolo?cooOgm00?oo?cl0_omoOd2ooclo0;ooOgm00Ooo?cloogmoOol
o?coo?cloogmoOolo?cooOgm00?oo?cl0_omoOd2ooclo0;ooOgm00Ooo?cl
oogmoOolo?coo?cloogmoOolo?cooOgm00?oo?cl0_omoOd2ooclo0;ooOgm
00Ooo?cloogmoOolo?coo?cloogmoOolo?cooOgm00?oo?cl0_omoOd2oocl
o0;ooOgm00Ooo?cloogmoOolo?coo?cloogmoOolo?cooOgm00?oo?cl0_om
oOd2ooclo0;ooOgm00Ooo?cloogmoOolo?coo?cloogmoOolo?cooOgm00?o
o?cl0_omoOd06_olo?co[Jf]o`e3]OmmY]goU[cUoi:li_n9]^SoDYGSofJV
kOme]?_oQlKmoiCDoOnMgogoUmGmofATI?n^[ZkokNg]of5QHOmTI6CoIfMW
ofUYJOm/K6coKVi^og5aLOmbLW;oM7Ad0OmfMWH000?ol_?d00[olO;doo7b
loobloCol_?doo7cm?oal_?ol_?doo7blooaloCol?;c0_o`l?44ooWin@;o
n?Sh00KonOWiooShn?oinOWon?ShooWinOohn?P2ooWin@03ooShn?oinOWo
nOWi00?onOWi0_ohn?P01_oinOWon?ShooWinOohn?SonOWiooShn0;onOWi
00?on?ShooWinOoinOT00ooinOT2ooShn006ooWinOohn?SonOWiooShn?oi
nOWon?Sh0_oinOT00oohn?SonOWiooWin@03ooWin@;on?Sh00KonOWiooSh
n?oinOWon?ShooWinOohn?P2ooWin@03ooShn?oinOWonOWi00?onOWi0_oh
n?P01_oinOWon?ShooWinOohn?SonOWiooShn0;onOWi00?on?ShooWinOoi
nOT00ooinOT2ooShn006ooWinOohn?SonOWiooShn?oinOWon?Sh0_oinOT0
0oohn?SonOWiooWin@03ooWin@;on?Sh00KonOWiooShn?oinOWon?ShooWi
nOohn?P2ooWin@03ooShn?oinOWonOWi00?onOWi0_ohn?P01_oinOWon?Sh
ooWinOohn?SonOWiooShn0;onOWi00?on?ShooWinOoinOT00ooinOT2ooSh
n006ooWinOohn?SonOWiooShn?oinOWon?Sh0_oinOT00oohn?SonOWiooWi
n@03ooWin@;on?Sh00KonOWiooShn?oinOWon?ShooWinOohn?P2ooWin@03
ooShn?oinOWonOWi00?onOWi0_ohn?P01_oinOWon?ShooWinOohn?SonOWi
ooShn0;onOWi00?on?ShooWinOoinOT00ooinOT2ooShn006ooWinOohn?So
nOWiooShn?oinOWon?Sh0_oinOT00oohn?SonOWiooWin@03ooWin@;on?Sh
00KonOWiooShn?oinOWon?ShooWinOohn?P2ooWin@03ooShn?oinOWonOWi
00?onOWi0_ohn?P01_oinOWon?ShooWinOohn?SonOWiooShn0;onOWi00?o
n?ShooWinOoinOT00ooinOT2ooShn006ooWinOohn?SonOWiooShn?oinOWo
n?Sh0_oinOT00oohn?SonOWiooWin@03ooWin@;on?Sh00KonOWiooShn?oi
nOWon?ShooWinOohn?P2ooWin@03ooShn?oinOWonOWi00?onOWi0_ohn?P0
1_oinOWon?ShooWinOohn?SonOWiooShn0;onOWi00?on?ShooWinOoinOT0
0ooinOT2ooShn006ooWinOohn?SonOWiooShn?oinOWon?Sh0_oinOT00ooh
n?SonOWiooWin@03ooWin@;on?Sh00KonOWiooShn?oinOWon?ShooWinOoh
n?P2ooWin@03ooShn?oinOWonOWi00?onOWi0_ohn?P01_oinOWon?ShooWi
nOohn?SonOWiooShn0;onOWi00?on?ShooWinOoinOT00ooinOT2ooShn006
ooWinOohn?SonOWiooShn?oinOWon?Sh0_oinOT00oohn?SonOWiooWin@03
ooWin@;on?Sh00KonOWiooShn?oinOWon?ShooWinOohn?P2ooWin@;on?Sh
00OomoOgooGemOoem_SomOOiooGfn?odm_SomOOh00;omOKh00Som?KhooGg
n?oem_SomOOiooGfn?odm_SomOKhooGgn0;omOKh00ComOOiooGfn?odm_So
mOOh0_oem_P02?odm_SomOOhooGfn?oemoWomOKhooCfn?oem_SomOOh0_oe
m_P01?oemoWomOKhooCfn?o/k>`3ooShn003ooWinOohn?SonOWi00?on?Sh
00ConOWiooShn?ohn?SonOWi0_ohn?P01ooinOWon?ShooShn?ohn?SonOWi
ooShn?oinOT00oohn?P01?oinOWon?ShooShn?oinOT2ooShn007ooWinOoh
n?Son?ShooShn?oinOWon?ShooWin@03ooShn004ooWinOohn?Son?ShooWi
n@;on?Sh00OonOWiooShn?ohn?Son?ShooWinOohn?SonOWi00?on?Sh00Co
nOWiooShn?ohn?SonOWi0_ohn?P01ooinOWon?ShooShn?ohn?SonOWiooSh
n?oinOT00oohn?P01?oinOWon?ShooShn?oinOT2ooShn007ooWinOohn?So
n?ShooShn?oinOWon?ShooWin@03ooShn004ooWinOohn?Son?ShooWin@;o
n?Sh00OonOWiooShn?ohn?Son?ShooWinOohn?SonOWi00?on?Sh00ConOWi
ooShn?ohn?SonOWi0_ohn?P01ooinOWon?ShooShn?ohn?SonOWiooShn?oi
nOT00oohn?P01?oinOWon?ShooShn?oinOT2ooShn007ooWinOohn?Son?Sh
ooShn?oinOWon?ShooWin@03ooShn004ooWinOohn?Son?ShooWin@;on?Sh
00OonOWiooShn?ohn?Son?ShooWinOohn?SonOWi00?on?Sh00ConOWiooSh
n?ohn?SonOWi0_ohn?P01ooinOWon?ShooShn?ohn?SonOWiooShn?oinOT0
0oohn?P01?oinOWon?ShooShn?oinOT2ooShn007ooWinOohn?Son?ShooSh
n?oinOWon?ShooWin@03ooShn004ooWinOohn?Son?ShooWin@;on?Sh00Oo
nOWiooShn?ohn?Son?ShooWinOohn?SonOWi00?on?Sh00ConOWiooShn?oh
n?SonOWi0_ohn?P06_oinOWo[Zj^o`e3]_mmYMkoU[gWoi6kion8]nOoDIKT
of>Vk_md]OgoQ<Cnoi3Ao_nLgokoU]KnofATI?n^[Zkoi^KVof=SHomVIVKo
JFUYofa/K?m_KfooLG5aog=cLomeMGGoN7Qh0OmiNGT000;ohnCU00?oi>CV
on?Ti_oSi>D00_oSi>D01?oTi>KohnCUon?TiOoSi>D2on;Si003on;ShooR
h^?oj^[Z0?ooj^[ZGooZj^X01?oYjNWoj>SXonKVi_oVj>T2onOXjP04onKX
jOoVj>[oi^SYonOXjP;oi^SY00Goi^SZonKWjOoVj>[oi^SYonOXjP03onKX
j@;oinSZ00Coi^SYonKXj_oVj>WoinSZ0_oVj>T01OoVj>[oi^OYonKXj_oV
j>WoinSZ00?oi^SY0_oWj>X00ooVj>WogMgMon[ZjP3?on[ZjP0Iojj^[_l=
@kKoO:;LoiBkiOn?^>KoR;KWodbAgomPXNcoL[;loh6ooOn>c_goV=_moi?C
o_mTI6Co[Zj^onk^k_mSHf?oIVIVofUYJOm/K6coKfm_og5aLOmdM7CoMWIf
ogQhN001ogYjNP0000OolO;coo;cm?oal_?olO;coo;cm?oal_?ol_?d00;o
lO;c00SolO;doo7bloo`l_;olO;boo3`lOo_l?7on?ShooOgm`;on?Sh00Go
moOgooShn?ogmoOon?ShooOgm`05ooShn004ooOgmoohn?Son?ShooOgm`;o
n?Sh00GomoOgooShn?ogmoOon?ShooOgm`05ooShn004ooOgmoohn?Son?Sh
ooOgm`;on?Sh00GomoOgooShn?ogmoOon?ShooOgm`05ooShn004ooOgmooh
n?Son?ShooOgm`;on?Sh00GomoOgooShn?ogmoOon?ShooOgm`05ooShn004
ooOgmoohn?Son?ShooOgm`;on?Sh00GomoOgooShn?ogmoOon?ShooOgm`05
ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh00GomoOgooShn?ogmoOon?Sh
ooOgm`05ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh00GomoOgooShn?og
moOon?ShooOgm`05ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh00GomoOg
ooShn?ogmoOon?ShooOgm`05ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh
00GomoOgooShn?ogmoOon?ShooOgm`05ooShn004ooOgmoohn?Son?ShooOg
m`;on?Sh00GomoOgooShn?ogmoOon?ShooOgm`05ooShn004ooOgmoohn?So
n?ShooOgm`;on?Sh00GomoOgooShn?ogmoOon?ShooOgm`05ooShn004ooOg
moohn?Son?ShooOgm`;on?Sh00GomoOgooShn?ogmoOon?ShooOgm`05ooSh
n004ooOgmoohn?Son?ShooOgm`;on?Sh00GomoOgooShn?ogmoOon?ShooOg
m`05ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh00GomoOgooShn?ogmoOo
n?ShooOgm`05ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh00GomoOgooSh
n?ogmoOon?ShooOgm`05ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh00Go
moOgooShn?ogmoOon?ShooOgm`05ooShn004ooOgmoohn?Son?ShooOgm`;o
n?Sh00GomoOgooShn?ogmoOon?ShooOgm`05ooShn004ooOgmoohn?Son?Sh
ooOgm`;on?Sh00GomoOgooShn?ogmoOon?ShooOgm`05ooShn004ooOgmooh
n?Son?ShooOgm`;on?Sh00GomoOgooShn?ogmoOon?ShooOgm`05ooShn004
ooOgmoohn?Son?ShooOgm`;on?Sh00GomoOgooShn?ogmoOon?ShooOgm`05
ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh00GomoOgooShn?ogmoOon?Sh
ooOgm`05ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh00GomoOgooShn?og
moOon?ShooOgm`05ooShn0;omoOg00?om_KfooCdm?oem_P00_odmOL01Ooe
m_Som?GgooGfn?odmOOom?Kg00;omOKh00Oom?GgooGfn?odmOOom?GgooGf
n?odmOOomOKh00;om?Gg00GomOKhooCemooem_Som?GgooCfm`02ooGfn007
ooCemooem_Som?GgooCemooem_Som?GgooGfn002ooCem`04ooGfn?o[jn_o
n?ShooOgm`?on?Sh00OomoOgooShn?ogmoOomoOgooShn?ogmoOon?Sh00;o
moOg00Con?ShooOgmoohn?SomoOg0oohn?P01oogmoOon?ShooOgmoogmoOo
n?ShooOgmoohn?P00_ogmoL01?ohn?SomoOgooShn?ogmoL3ooShn007ooOg
moohn?SomoOgooOgmoohn?SomoOgooShn002ooOgm`04ooShn?ogmoOon?Sh
ooOgm`?on?Sh00OomoOgooShn?ogmoOomoOgooShn?ogmoOon?Sh00;omoOg
00Con?ShooOgmoohn?SomoOg0oohn?P01oogmoOon?ShooOgmoogmoOon?Sh
ooOgmoohn?P00_ogmoL01?ohn?SomoOgooShn?ogmoL3ooShn007ooOgmooh
n?SomoOgooOgmoohn?SomoOgooShn002ooOgm`04ooShn?ogmoOon?ShooOg
m`?on?Sh00OomoOgooShn?ogmoOomoOgooShn?ogmoOon?Sh00;omoOg00Co
n?ShooOgmoohn?SomoOg0oohn?P01oogmoOon?ShooOgmoogmoOon?ShooOg
moohn?P00_ogmoL01?ohn?SomoOgooShn?ogmoL3ooShn007ooOgmoohn?So
moOgooOgmoohn?SomoOgooShn002ooOgm`04ooShn?ogmoOon?ShooOgm`?o
n?Sh00OomoOgooShn?ogmoOomoOgooShn?ogmoOon?Sh00;omoOg00Con?Sh
ooOgmoohn?SomoOg0oohn?P01oogmoOon?ShooOgmoogmoOon?ShooOgmooh
n?P00_ogmoL01?ohn?SomoOgooShn?ogmoL3ooShn007ooOgmoohn?SomoOg
ooOgmoohn?SomoOgooShn002ooOgm`04ooShn?ogmoOon?ShooOgm`?on?Sh
00OomoOgooShn?ogmoOomoOgooShn?ogmoOon?Sh00;omoOg01_on?ShooOg
mon^[Zko34:dogbPfonA^^KoS[SUohBci_m:Sn3oFYk[ofb_nOml__goR<gm
oiGKoOn<dOgoHf=Sojj^[_omoOgoHF5Qof=SHomWIfOoJVYZofe]KOm_Kfoo
LG5aogAdM?meMGD00OmhN7P00003ooKhnOofmoSom_Oh00;om_Oh00KomOKg
ooKgn?ofmoSom_OgooGfmoofmoP3ooGfm`03ooCem_olo?cooOgm00;oo?cl
00?ooOgmooclo?olo?`01oolo?`01?omoOgoo?clooclo?omoOd2ooclo003
oogmoOolo?coo?cl00;oo?cl00Ko`L71ohN7QomWIfOoOWinolk>c_omoOd2
ooclo004oogmoOolo?coo?cloogmo@Woo?cl00CooOgmooclo?olo?cooOgm
0_olo?`00oomoOgoo?clooclo002ooclo003on3Ph?n2PX;om_Kf00;oo?cl
00CooOgmooclo?olo?cooOgm0_olo?`00oomoOgoo?clooclo007ooclo004
oogmoOolo?coo?cloogmo@;oo?cl00CooOgmon3Ph?n2PX;om_Kf1_olo?`0
1?omoOgoo?clooclo?omoOd2ooclo003oogmoOolo?coo?cl00Ooo?cl00Co
oOgmooclo?olo?cooOgm0_olo?`00oomoOgoo?clooclo007ooclo004oogm
oOolo?coo?cloogmo@;oo?cl00?ooOgmooclo?olo?`01oolo?`01?omoOgo
o?clooclo?omoOd2ooclo003oogmoOolo?coo?cl00Ooo?cl00CooOgmoocl
o?olo?cooOgm0_olo?`00oomoOgoo?clooclo007ooclo004oogmoOolo?co
o?cloogmo@;oo?cl00?ooOgmooclo?olo?`01oolo?`01?omoOgoo?cloocl
o?omoOd2ooclo003oogmoOolo?coo?cl00Ooo?cl00CooOgmooclo?olo?co
oOgm0_olo?`00oomoOgoo?clooclo007ooclo004oogmoOolo?coo?cloogm
o@;oo?cl00?ooOgmooclo?olo?`01oolo?`01?omoOgoo?clooclo?omoOd2
ooclo003oogmoOolo?coo?cl00Ooo?cl00CooOgmooclo?olo?cooOgm0_ol
o?`00oomoOgoo?clooclo007ooclo004oogmoOolo?coo?cloogmo@;oo?cl
00?ooOgmooclo?olo?`01oolo?`01?omoOgoo?clooclo?omoOd2ooclo003
oogmoOolo?coo?cl00Ooo?cl00CooOgmooclo?olo?cooOgm0_olo?`00oom
oOgoo?clooclo007ooclo004oogmoOolo?coo?cloogmo@;oo?cl00?ooOgm
ooclo?olo?`01oolo?`01?omoOgoo?clooclo?omoOd2ooclo003oogmoOol
o?coo?cl00Soo?cl00Gono_koo[jn_oinOWonO[looWjn`02ooWjo007ooSj
nooin_conO[looWjo?ohn__onO[looSjn`06ooWjo004ooWjnooin_conO[l
ooSjn`?onO[l00?on?[kooWjo?ohn_/01_oin_`01_oin__onO[looWjo?o`
l?3oo?clooWin@;on?Sh00?onOWiooShn?oinOT00_oinOT01Oohn?SonOWi
ooShn?ohn?SonOWi00?on?Sh00?onOWiooShn?ohn?P00oohn?P01?oinOWo
n?ShooShn?oinOT2ooShn005ooWinOohn?Son?ShooShn?oinOT01Oohn?P0
1?oinOWon?ShooShn?oinOT2ooShn005ooWinOohn?Son?ShooShn?oinOT0
1Oohn?P01?oinOWon?ShooShn?oinOT2ooShn005ooWinOohn?Son?ShooSh
n?oinOT01Oohn?P01?oinOWon?ShooShn?oinOT2ooShn005ooWinOohn?So
n?ShooShn?oinOT01Oohn?P01?oinOWon?ShooShn?oinOT2ooShn005ooWi
nOohn?Son?ShooShn?oinOT01Oohn?P01?oinOWon?ShooShn?oinOT2ooSh
n005ooWinOohn?Son?ShooShn?oinOT01Oohn?P01?oinOWon?ShooShn?oi
nOT2ooShn005ooWinOohn?Son?ShooShn?oinOT01Oohn?P01?oinOWon?Sh
ooShn?oinOT2ooShn005ooWinOohn?Son?ShooShn?oinOT01Oohn?P01?oi
nOWon?ShooShn?oinOT2ooShn005ooWinOohn?Son?ShooShn?oinOT01Ooh
n?P01?oinOWon?ShooShn?oinOT2ooShn005ooWinOohn?Son?ShooShn?oi
nOT01Oohn?P01?oinOWon?ShooShn?oinOT2ooShn005ooWinOohn?Son?Sh
ooShn?oinOT01Oohn?P01?oinOWon?ShooShn?oinOT2ooShn00LooWinOoh
n?Son?ShojVYZOl9?[7oN9[Fohbch?n4/N3oO:_Pod28g?mCUnKoHjOcog>i
nOn1aOWoR]7ioh75nOmPH63oZZZZonSXj?mCDe?oEEEEoeMGEomIFEWoFe]K
oeeMGOmNGUkoHF5Qof9RHP7oHf=S000;oo7bl`04oo3al_oalO;oko3aono_
l1WomoOg00KoRHV9ogQhN?nTY:CoIfMWoaDE5Oni^KTJooOgm`03oo?clolV
9RKoY:BT01WomoOg00?olo?cobHV9_nSXj<0ooogmoL8ooOgm`06ooKfm_oe
mOGom?Cdoo?em_odmOOom?Gf0_odmOL00oodmOKom?GgooCemP02ooCem`09
ooCem_odmOOom?Gfoo?em_odmOOom?Gfoo?em_odmOOom?Gf00;om?Gg00?o
m?GfooCemoodmOH00_odmOL03_odmOKom?GgooCem_ocmOKom?GgooCem_oc
mOKom?GgooCem_odmOOok>c/ooKfm_odm?Com_Kf0_ogmoL00oofm_KomoOg
ooKfmP07ooKfmP03ooOgmoofm_KomoOg00;om_Kf00?omoOgooKfm_ogmoL0
2?ofm_H00oogmoOom_KfooOgm`02ooKfmP03ooOgmoofm_KomoOg00Som_Kf
00?omoOgooKfm_ogmoL00_ofm_H00oogmoOom_KfooOgm`08ooKfmP03ooOg
moofm_KomoOg00;om_Kf00?omoOgooKfm_ogmoL02?ofm_H00oogmoOom_Kf
ooOgm`02ooKfmP03ooOgmoofm_KomoOg00Som_Kf00?omoOgooKfm_ogmoL0
0_ofm_H00oogmoOom_KfooOgm`08ooKfmP03ooOgmoofm_KomoOg00;om_Kf
00?omoOgooKfm_ogmoL02?ofm_H00oogmoOom_KfooOgm`02ooKfmP03ooOg
moofm_KomoOg00Som_Kf00?omoOgooKfm_ogmoL00_ofm_H00oogmoOom_Kf
ooOgm`08ooKfmP03ooOgmoofm_KomoOg00;om_Kf00?omoOgooKfm_ogmoL0
2?ofm_H00oogmoOom_KfooOgm`02ooKfmP03ooOgmoofm_KomoOg00Som_Kf
00?omoOgooKfm_ogmoL00_ofm_H00oogmoOom_KfooOgm`08ooKfmP0JooOg
mon/[:co2cF]ogVSf_nD^^CoT;[UohRfiom>TN7oH:7[og>cnOn2`_coSlok
oiOJnon@dOcoHV9Rojf][OoTi>CoG5aLoemOGomRHV;oIFEUofQXJ?mZJV[o
K6a/ofm_Kom`L701og9bLP001?oSi>D02?oSi>CohnCUon;Si?oShnCohnCU
on?Si?oRhnCohn?T0_oQh^<01?oQh^;ojNWYonSXj?oXj>P2onWYj@Coj>SX
00CojNWYonSXj?oXj>SojNWY0_oXj>P2onWYj@;oj>SX00?of=SHonOWiooX
j>P00_oNg]h01ooXj>SojNWYonSXj?oXj>SojNWYoeQHF?m8B4P00_oYjNT2
onSXj0;ojNWY1?oXj>P02?oYjNWoj>SXonSXj?oYjNWoj>SXomOGeooWinOo
jNWY0_oNg]h2onWYj@Coj>SX00CojNWYohB4Q?m0@43ojNWY0_oXj>P2onWY
j@;oj>SX0_oYjNT4onSXj004onWYjOoXj>Soj>SXonWYj@;oj>SX00?of=SH
onOWiooXj>P00_oNg]h01_oYjNWoj>SXohB4Q?m0@43oj>SXonWYj@;oj>SX
00?ojNWYonSXj?oXj>P00_oYjNT2onSXj0;ojNWY1?oXj>P01?oYjNWoj>SX
onSXj?oYjNT2onSXj0;ojNWY0_oXj>P2onWYj@Coj>SX00CojNWYonSXj?oX
j>SojNWY0_oXj>P2onWYj@;oj>SX0_oYjNT4onSXj004onWYjOoXj>Soj>SX
onWYj@;oj>SX0_oYjNT2onSXj0;ojNWY1?oXj>P01?oYjNWoj>SXonSXj?oY
jNT2onSXj0;ojNWY0_oXj>P2onWYj@Coj>SX00CojNWYonSXj?oXj>SojNWY
0_oXj>P2onWYj@;oj>SX0_oYjNT4onSXj004onWYjOoXj>Soj>SXonWYj@;o
j>SX0_oYjNT2onSXj0;ojNWY1?oXj>P01?oYjNWoj>SXonSXj?oYjNT2onSX
j0;ojNWY0_oXj>P2onWYj@Coj>SX00CojNWYonSXj?oXj>SojNWY0_oXj>P2
onWYj@;oj>SX0_oYjNT4onSXj004onWYjOoXj>Soj>SXonWYj@;oj>SX0_oY
jNT2onSXj0;ojNWY1?oXj>P01?oYjNWoj>SXonSXj?oYjNT2onSXj0;ojNWY
0_oXj>P2onWYj@Coj>SX00CojNWYonSXj?oXj>SojNWY0_oXj>P2onWYj@;o
j>SX0_oYjNT4onSXj004onWYjOoXj>Soj>SXonWYj@;oj>SX0_oYjNT2onSX
j0;ojNWY1?oXj>P01?oYjNWoj>SXonSXj?oYjNT2onSXj0;ojNWY0_oXj>P2
onWYj@Coj>SX00CojNWYonSXj?oXj>SojNWY0_oXj>P2onWYj@;oj>SX0_oY
jNT4onSXj004onWYjOoXj>Soj>SXonWYj@;oj>SX0_oYjNT2onSXj0;ojNWY
1?oXj>P01?oYjNWoj>SXonSXj?oYjNT3onSXj005onOWiooUiNGoiNKXonGW
j?oVinP00_oUi^P02?oUi^OoiNKXonGWj?oUi^SoiNKWonGWj?oUi^OoiNKX
0_oUinP2onGVj00<onGWj?oVinSoiNKXonGVj?oUi^OoiNKXonGWj?oUi^So
iNKWonGWj?oUi^OoiNKX0_oUinP2onGVj007onGWj?oVinSoiNKXomgMgOoX
j>SoiNGUonWYj@02onSXj003onWYjOoXj>Soj>SX00;ojNWY0_oXj>P2onWY
j@Coj>SX00CojNWYonSXj?oXj>SojNWY0_oXj>P2onWYj@;oj>SX0_oYjNT4
onSXj004onWYjOoXj>Soj>SXonWYj@;oj>SX0_oYjNT2onSXj0;ojNWY1?oX
j>P01?oYjNWoj>SXonSXj?oYjNT2onSXj0;ojNWY0_oXj>P2onWYj@Coj>SX
00CojNWYonSXj?oXj>SojNWY0_oXj>P2onWYj@;oj>SX0_oYjNT4onSXj004
onWYjOoXj>Soj>SXonWYj@;oj>SX0_oYjNT2onSXj0;ojNWY1?oXj>P01?oY
jNWoj>SXonSXj?oYjNT2onSXj0;ojNWY0_oXj>P2onWYj@Coj>SX00CojNWY
onSXj?oXj>SojNWY0_oXj>P2onWYj@;oj>SX0_oYjNT4onSXj004onWYjOoX
j>Soj>SXonWYj@;oj>SX0_oYjNT2onSXj0;ojNWY1?oXj>P01?oYjNWoj>SX
onSXj?oYjNT2onSXj0;ojNWY0_oXj>P2onWYj@Coj>SX00CojNWYonSXj?oX
j>SojNWY0_oXj>P2onWYj@;oj>SX0_oYjNT4onSXj004onWYjOoXj>Soj>SX
onWYj@;oj>SX0_oYjNT2onSXj0;ojNWY1?oXj>P01?oYjNWoj>SXonSXj?oY
jNT2onSXj0;ojNWY0_oXj>P2onWYj@;oj>SX01Wo[:b/o`/e[omjX]coU[cW
ohnhiOn:]^OoD97Oof6QkOmd/o[oPl7loho?nonJgOcoT/olof=SHon][Jgo
k>c/oeeMGOmPH63oHf=SofIVI_mYJFWoK6a/ofi^K_maLG7oLg=c007oMGEe
0002oo7bl`08oo7al_o`lO;olO;coo7blooal_;olO;coo7al_o`lO82oo7a
lP;ol?3a00Goko3`ooKfm_ofm_Ko>SXjogMgM`02ooKfmP06odE5AOmoOgoo
moOgooKfm_mjNW[oB4Q80_ofm_H04On`/;3o4Q8BooKfm_ofm_KoEEEEoa4A
4OlR8R;oVYZJoa`L7?mKFe_omoOgomoOgomPH63o?cloog]kNonJVY[o9RHV
00;om_Kf00[oADE5ogmoOoofm_Kom_KfodE5AOn0P83om_KfooOgmonPX:3o
92@T0_ofm_H02OmEEEGo4A4Aob8R8_nJVY[o71`Loe]KFoofm_KoADE5oh20
P002ooKfmP05ooOgmoofm_KoTI6Ao`/;2ooAdM401oofm_H01olk>c_o2`/;
o`/;2olA4A7o=cLgogAdM?oZj^X00oofm_H01_mEEEGo4A4Aob8R8_nJVY[o
71`LoeYJFP;om_Kf00?oTY:Bo`/;2ooAdM402_ofm_H00ooLg=co2PX:onKV
iP02ooKfmP03ooOgmoofm_Kom_Kf00gom_Kf00?omoOgooKfm_ofm_H03Oof
m_H00oogmoOom_KfooKfmP0=ooKfmP03ooOgmoofm_Kom_Kf00gom_Kf00?o
moOgooKfm_ofm_H03Oofm_H00oogmoOom_KfooKfmP0=ooKfmP03ooOgmoof
m_Kom_Kf00gom_Kf00?omoOgooKfm_ofm_H03Oofm_H00oogmoOom_KfooKf
mP0=ooKfmP03ooOgmoofm_Kom_Kf00gom_Kf00?omoOgooKfm_ofm_H03Oof
m_H00oogmoOom_KfooKfmP0=ooKfmP03ooOgmoofm_Kom_Kf00gom_Kf00?o
moOgooKfm_ofm_H03Oofm_H00oogmoOom_KfooKfmP0=ooKfmP03ooOgmoof
m_Kom_Kf00Com_Kf00ComOGeooCdm?oclo?oloCf0_ocm?D3oo?dmP03ooCe
m_ocm?KoloCe00;oloCf00ColoCeoo?dm_ocm?KoloCe0_ocm?H2oo?dm@?o
loCf00?om?Gfoo?dm_ocm?D00_ocm?H01?ocm?GoloCfoo?dm_ocm?D2oo?d
mP;oloCe00ColoCfon_[joofm_Kom?Cd3oofm_H00oogmoOom_KfooKfmP0=
ooKfmP03ooOgmoofm_Kom_Kf00gom_Kf00?omoOgooKfm_ofm_H03Oofm_H0
0oogmoOom_KfooKfmP0=ooKfmP03ooOgmoofm_Kom_Kf00gom_Kf00?omoOg
ooKfm_ofm_H03Oofm_H00oogmoOom_KfooKfmP0=ooKfmP03ooOgmoofm_Ko
m_Kf00gom_Kf00?omoOgooKfm_ofm_H03Oofm_H00oogmoOom_KfooKfmP0=
ooKfmP03ooOgmoofm_Kom_Kf00gom_Kf00?omoOgooKfm_ofm_H03?ofm_H0
6On/[:co2cJ_ogVSg?nE^nCoT;STohZeiom@TN7oHZ7[ogBcnOn2`?_oSlol
oiKGnon=b?_oHV9Rojj^[_olo?coG5aLoemOGomRHV;oI6ATofMWIomZJV[o
K6a/ofm_KomaLG400OmdM7@00003ooKgmoofmoSomOKg00OomOKg00GomOKf
ooCem_oem_Kom?Geoo?cm002oo[jnP06oc/k>omiNGWon_[joo[jn_m6ATKo
PH610_ojn_X03OmmOGgoBDU9oo[jn_ojn_[o];Bdoa8B4_ojn_[oa<C4o`h>
3_oJf][ohn?SoemOGolJ6QX00_ojn_X01_mBDU;o=SHfoj>SXomnOWko=CDe
oadM7@;on_[j00KoATI6oh:2P_ojn_[on_[jodI6A_n2PX82oo[jnP09oj>S
XolU9BGon_[jolC4a?l>3Pkof][Jon;Rh_mOGeoo6QXJ00;on_[j00?oATI6
oh61POojn_X00oojn_X00olg=cOo4a<CogAdM007oo[jnP0?ocdm?OmgMgOo
n_[joo3`l?o:b/[oBd];obTY:Oo/k>con_[jolG5aOl>3Pkof][Jon;Rh_mO
Geoo6a/K00?on_[j00?o=SHfoa8B4_meMGD02_ojn_X00ooQhN7o2PX:on[Z
jP3ioo[jnP04ooWinOohn?SomoOgooSinP;omoSj00?omoSiooOhn_ogn?T0
0_ogn?X01OohnO[omoSjooOhnOohnO[omoSj00;omoSi00OomoSjooSin_og
n?[omoSjooOhnOogn?[omoSi00;omoSj00Gon?WjooOhn_ogn?Won?WjooOh
nP02ooOhn@08ooOhn_ohnO[omoSjooOhn_ogn?Wol?3`oo[jn_ohn?S>oo[j
nP0Ioj^[Zol:>;7oK9WHoi:ji?n=]nCoQ;;VodfAhOmOXN_oLK7hognnn_n;
bo[oTM7koh[5nomUIFGo[Zj^on_[jomJFU[oGEeMof1PH?mSHf?oIFEUofQX
J?m[Jf_oKFe]ofm_K`01og9bLP0000[olO;coo7al_oal_?ol?7boo7al_o`
lO;olO7boo3al_o`l?7ol?7b0_o`lO42ono`l00Lono_l?oemOGomOGeocPh
>?mfMWKom?CdooGemOm4A4CoOgmoooGemOodm?CoNWYjodM7AooemOGom?Cd
ojn_[olA4A7omOGeom7AdOl;2`_o^;RhooCdm?nLW9co9bLWooGemOo]kNgo
4A4AokBd]0;omOGe00[oU9BDoaTI6OoemOGomOGeodA4A?mnOWkomOGeooCd
m?m4A4CoOWin0_oemOD02OnOWioo8b<SooGemOoAdM7o2`/;okRh^?oemOGo
Vi^KobLW9`02ooGem@03od=3@omoOgoomOGe00;omOGe00GoaLG5o`X:2_nK
Vi_o6a/Konk^kP06ooGem@03ocXj>_mdM7ComOGe00;omOGe017ol?3`obHV
9_maLG7omOGeom7AdOl<30co^;RhooGemOnLW9co9RHVooGemOodm?Coa/K6
o`X:2_nLW9co6a/Konk^kP03ooGem@03ooCdm?oemOGof][J00?oY:BT00Co
UIFEo`T92OnJVY[ofm_K0_oemOD01Oodm?ComOGeooGemOoemOGom?Cd00Ko
mOGe00?om?CdooGemOoemOD00_oemOD01Oodm?ComOGeooGemOoemOGom?Cd
00KomOGe00?om?CdooGemOoemOD00_oemOD01Oodm?ComOGeooGemOoemOGo
m?Cd00KomOGe00?om?CdooGemOoemOD00_oemOD01Oodm?ComOGeooGemOoe
mOGom?Cd00KomOGe00?om?CdooGemOoemOD00_oemOD01Oodm?ComOGeooGe
mOoemOGom?Cd00KomOGe00?om?CdooGemOoemOD00_oemOD01Oodm?ComOGe
ooGemOoemOGom?Cd00KomOGe00?om?CdooGemOoemOD00_oemOD01Oodm?Co
mOGeooGemOoemOGom?Cd00KomOGe00?om?CdooGemOoemOD00_oemOD01Ood
m?ComOGeooGemOoemOGom?Cd00KomOGe00?om?CdooGemOoemOD00_oemOD0
1Oodm?ComOGeooGemOoemOGom?Cd00KomOGe00?om?CdooGemOoemOD00_oe
mOD01Oodm?ComOGeooGemOoemOGom?Cd00KomOGe00?om?CdooGemOoemOD0
0_oemOD01Oodm?ComOGeooGemOoemOGom?Cd00KomOGe00?om?CdooGemOoe
mOD00_oemOD01Oodm?ComOGeooGemOoemOGom?Cd00KomOGe00?om?CdooGe
mOoemOD00_oemOD01Oodm?ComOGeooGemOoemOGom?Cd00KomOGe00?om?Cd
ooGemOoemOD00_oemOD01Oodm?ComOGeooGemOoemOGom?Cd00KomOGe00?o
m?CdooGemOoemOD00_oemOD01Oodm?ComOGeooGemOoemOGom?Cd00KomOGe
00?om?CdooGemOoemOD00_oemOD03_odm?ComOGeooGemOoemOGom?CdooGe
mOodm?Colo?coo;bl_obloCol_?eoo;cm?obloGol_?d0_obloD01OobloCo
l_?eoo;cm?obloGol_?d00;ol_?e0ooblo@01?obloGol_?doo;cmOoblo@2
oo;cm@05oo;cm?obloGol_?doo;cmOoblo@00_obloD3oo;cm007oo;cmOob
loCol_?eon_[jooemOGolo?cooCdm003ooGem@03ooCdm?oemOGomOGe00Co
mOGe00?om?CdooGemOoemOD00_oemOD01Oodm?ComOGeooGemOoemOGom?Cd
00KomOGe00?om?CdooGemOoemOD00_oemOD01Oodm?ComOGeooGemOoemOGo
m?Cd00KomOGe00?om?CdooGemOoemOD00_oemOD01Oodm?ComOGeooGemOoe
mOGom?Cd00KomOGe00?om?CdooGemOoemOD00_oemOD01Oodm?ComOGeooGe
mOoemOGom?Cd00KomOGe00?om?CdooGemOoemOD00_oemOD01Oodm?ComOGe
ooGemOoemOGom?Cd00KomOGe00?om?CdooGemOoemOD00_oemOD01Oodm?Co
mOGeooGemOoemOGom?Cd00KomOGe00?om?CdooGemOoemOD00_oemOD01Ood
m?ComOGeooGemOoemOGom?Cd00KomOGe00?om?CdooGemOoemOD00_oemOD0
1Oodm?ComOGeooGemOoemOGom?Cd00KomOGe00?om?CdooGemOoemOD00_oe
mOD01Oodm?ComOGeooGemOoemOGom?Cd00KomOGe00?om?CdooGemOoemOD0
0_oemOD01Oodm?ComOGeooGemOoemOGom?Cd00KomOGe00?om?CdooGemOoe
mOD00_oemOD01Oodm?ComOGeooGemOoemOGom?Cd00KomOGe00?om?CdooGe
mOoemOD00_oemOD01Oodm?ComOGeooGemOoemOGom?Cd00KomOGe01com?Cd
ooGemOoemOGo[Jf]oaDn[?m4OL_oRK;Qohbdh_ml[N;oBHkMoe^Li_m/[?Co
NKWjohC5n_n9ao[oNJoYofa/K?nc/k?ohn?SoeQHF?mJFU[oGEeMof1PH?mS
Hf?oIVIVofQXJ?m[Jf_oKVi^0OmaLG400003on;Si?oSi>Gohn?T00;oh^?T
0ooRh^<02ooRhn?ohN;Son7RhooQhN;ohN;Ron3QhOoPh>7oi^KVonGUiOle
=CGoKfm_00;oi^KV01Wo?cloogMgMooVi^Koi^KVog9bL_m2@T;oiNGUonKV
i_nTY:Co410@onKVi_oUiNGoWinOoc@d=?le=CGo=cLgob@T9?oUiNGo/;2`
o`T92Oo?clooi^KVonGUiOnNWYko5aLG00;oi^KV017o?cloogMgMooVi^Ko
i^KVod10@?mgMgOoiNGUonKVi_nFUYKo820PonKVi_oUiNGoWYjNoc@d=?le
=CGo=cLgob@T9002onKViP0:oclo?omgMgOoi^KVonGUiOoVi^KoHf=Sod10
@?oVi^Ko:RXZoiNGU`?oi^KV00OoiNGUonKVi_oVi^Ko=cLgofe]KOoVi^Ko
iNGU00;oi^KV00WoM7AdobHV9_oUiNGoi^KVoijNW_ld=3Co=CDeocLg=olU
9BD00_oVi^H01OmSHf?o@410onGUiOlZ:R[oUiNG00;oi^KV00coiNGUonKV
i_oVi^KoZJVYo`X:2_m;Bd_oCdm?ode=COl92@WoBTY:okFe]OoUiND4onKV
iP03onGUiOoVi^Koi^KV00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooU
iNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV00;oi^KV00?oiNGUonKV
i_oVi^H00ooVi^H00ooUiNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV
00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGoi^KVonKViP02onKV
iP03onGUiOoVi^Koi^KV00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooU
iNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV00;oi^KV00?oiNGUonKV
i_oVi^H00ooVi^H00ooUiNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV
00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGoi^KVonKViP02onKV
iP03onGUiOoVi^Koi^KV00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooU
iNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV00;oi^KV00?oiNGUonKV
i_oVi^H00ooVi^H00ooUiNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV
00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGoi^KVonKViP02onKV
iP03onGUiOoVi^Koi^KV00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooU
iNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV00;oi^KV00?oiNGUonKV
i_oVi^H00ooVi^H00ooUiNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV
00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGoi^KVonKViP02onKV
iP03onGUiOoVi^Koi^KV00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooU
iNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV00;oi^KV00?oiNGUonKV
i_oVi^H00ooVi^H00ooUiNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV
00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGoi^KVonKViP02onKV
iP03onGUiOoVi^Koi^KV00;oiNGU00Gohn?SonCUi_oTiNKohnCUon?TiP03
on?Ti@09onCUi_oSi>GohnCVon?TiOoSi>KohnCUon?Ti_oTiNKohnCU00;o
i>GV00?ohnCUon?Ti_oSi>D00_oSi>D02OoTiNKohnCUon?Ti_oSi>GohnCV
on?TiOoSi>Koi>GVon?Ti@02onCUiP05on?TiOoSi>KogMgMonGUiOoTi>@0
0ooVi^H00ooUiNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV00?oi^KV
00?oiNGUonKVi_oVi^H00_oVi^H00ooUiNGoi^KVonKViP02onKViP03onGU
iOoVi^Koi^KV00?oi^KV00?oiNGUonKVi_oVi^H00_oVi^H00ooUiNGoi^KV
onKViP02onKViP03onGUiOoVi^Koi^KV00?oi^KV00?oiNGUonKVi_oVi^H0
0_oVi^H00ooUiNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV00?oi^KV
00?oiNGUonKVi_oVi^H00_oVi^H00ooUiNGoi^KVonKViP02onKViP03onGU
iOoVi^Koi^KV00?oi^KV00?oiNGUonKVi_oVi^H00_oVi^H00ooUiNGoi^KV
onKViP02onKViP03onGUiOoVi^Koi^KV00?oi^KV00?oiNGUonKVi_oVi^H0
0_oVi^H00ooUiNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV00?oi^KV
00?oiNGUonKVi_oVi^H00_oVi^H00ooUiNGoi^KVonKViP02onKViP03onGU
iOoVi^Koi^KV00?oi^KV00?oiNGUonKVi_oVi^H00_oVi^H00ooUiNGoi^KV
onKViP02onKViP03onGUiOoVi^Koi^KV00?oi^KV00?oiNGUonKVi_oVi^H0
0_oVi^H00ooUiNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV00?oi^KV
00?oiNGUonKVi_oVi^H00_oVi^H00ooUiNGoi^KVonKViP02onKViP03onGU
iOoVi^Koi^KV00?oi^KV00?oiNGUonKVi_oVi^H00_oVi^H00ooUiNGoi^KV
onKViP02onKViP03onGUiOoVi^Koi^KV00?oi^KV00?oiNGUonKVi_oVi^H0
0_oVi^H00ooUiNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV00?oi^KV
01Wo[:b/oc1<YOl@B;OoAhG@oeZEe_m6RMGo?8CFodnBh?mLW^[oJZ[`og:c
nOmf]?[oHX^jog]kNonk^k_ojNWYoeEEEOmHF5SoFe]KoeiNG_mQHF7oHf=S
ofIVI_mYJFWoK6a/007oKfm_0002oo3alP03oo3`lOo`lO;olO7b00;ol?7a
00col?3aono`l?o_l?7ol?3aono_l?o_l?3ok^o_onk^koodm?Colo?cocLg
=omdM7@2ooCdm00;od=3@om/K6colo?coo?clomgMgOo>3Phoo;bl_odm?Co
[:b/oa0@4?odm?@00ooclo<07_obl_;oTI6AobHV9_odm?CodM7Ao`P82?n_
[joom?Cdoo?clonWYjOo5aLGoo?cloodm?Co@T92ogemOOoclo?om?Cdod=3
@omNGUkom?Cdoo?clonHV9So8b<SooCdm?oclo?om?Cdoo?cloobl_;oTI6A
obHV9P;olo?c00[o@d=3ofUYJOoclo?om?Cdon_[jolE5AGoWIfMooCdm?n=
SHgo@D510_oclo<02?odm?Colo?coo?clooclo?o>CTiog=cLooclo?om?Cd
0_oclo<01?nIVIWo2PX:onk^k_odm?@2oo?cl`0>oo;bl_n@T93o9RHVoo?c
loo[jn_o5QHFoifMWOodm?CoSHf=od10@?oclo?om?Cdoo?cloodm?@2oo?c
l`08oeADE?mmOGgolo?conk^k_l820Soi>CToo?cloodm?@3oo?cl`03ooCd
m?oclo?om?Cd00;olo?c00Com?Cdoo?clooclo?olo?c0_odm?@00ooclo?o
m?Cdoo?cl`02oo?cl`03ooCdm?oclo?om?Cd00;olo?c00Com?Cdoo?clooc
lo?olo?c0_odm?@00ooclo?om?Cdoo?cl`02oo?cl`03ooCdm?oclo?om?Cd
00;olo?c00Com?Cdoo?clooclo?olo?c0_odm?@00ooclo?om?Cdoo?cl`02
oo?cl`03ooCdm?oclo?om?Cd00;olo?c00Com?Cdoo?clooclo?olo?c0_od
m?@00ooclo?om?Cdoo?cl`02oo?cl`03ooCdm?oclo?om?Cd00;olo?c00Co
m?Cdoo?clooclo?olo?c0_odm?@00ooclo?om?Cdoo?cl`02oo?cl`03ooCd
m?oclo?om?Cd00;olo?c00Com?Cdoo?clooclo?olo?c0_odm?@00ooclo?o
m?Cdoo?cl`02oo?cl`03ooCdm?oclo?om?Cd00;olo?c00Com?Cdoo?clooc
lo?olo?c0_odm?@00ooclo?om?Cdoo?cl`02oo?cl`03ooCdm?oclo?om?Cd
00;olo?c00Com?Cdoo?clooclo?olo?c0_odm?@00ooclo?om?Cdoo?cl`02
oo?cl`03ooCdm?oclo?om?Cd00;olo?c00Com?Cdoo?clooclo?olo?c0_od
m?@00ooclo?om?Cdoo?cl`02oo?cl`03ooCdm?oclo?om?Cd00;olo?c00Co
m?Cdoo?clooclo?olo?c0_odm?@00ooclo?om?Cdoo?cl`02oo?cl`03ooCd
m?oclo?om?Cd00;olo?c00Com?Cdoo?clooclo?olo?c0_odm?@00ooclo?o
m?Cdoo?cl`02oo?cl`03ooCdm?oclo?om?Cd00;olo?c00Com?Cdoo?clooc
lo?olo?c0_odm?@00ooclo?om?Cdoo?cl`02oo?cl`03ooCdm?oclo?om?Cd
00;olo?c00Com?Cdoo?clooclo?olo?c0_odm?@00ooclo?om?Cdoo?cl`02
oo?cl`03ooCdm?oclo?om?Cd00;olo?c00Com?Cdoo?clooclo?olo?c0_od
m?@00ooclo?om?Cdoo?cl`02oo?cl`03ooCdm?oclo?om?Cd00;olo?c00Co
m?Cdoo?clooclo?olo?c0_odm?@00ooclo?om?Cdoo?cl`02oo?cl`03ooCd
m?oclo?om?Cd00?olo?c00GolO7aoo7blooal_?olO;coo;cm00:oo7bl`03
oo;cm?oal_?olO;c00;olO;c00?ol_?doo7blooal_<02?oal_<00oobloCo
lO;coo7bl`02oo7bl`04oo;cm?o[jn_om?Cdoo7al@;olo?c00?om?Cdoo?c
loodm?@00_oclo<01?odm?Colo?coo?clooclo<2ooCdm003oo?cloodm?Co
lo?c00;olo?c00?om?Cdoo?cloodm?@00_oclo<01?odm?Colo?coo?clooc
lo<2ooCdm003oo?cloodm?Colo?c00;olo?c00?om?Cdoo?cloodm?@00_oc
lo<01?odm?Colo?coo?clooclo<2ooCdm003oo?cloodm?Colo?c00;olo?c
00?om?Cdoo?cloodm?@00_oclo<01?odm?Colo?coo?clooclo<2ooCdm003
oo?cloodm?Colo?c00;olo?c00?om?Cdoo?cloodm?@00_oclo<01?odm?Co
lo?coo?clooclo<2ooCdm003oo?cloodm?Colo?c00;olo?c00?om?Cdoo?c
loodm?@00_oclo<01?odm?Colo?coo?clooclo<2ooCdm003oo?cloodm?Co
lo?c00;olo?c00?om?Cdoo?cloodm?@00_oclo<01?odm?Colo?coo?clooc
lo<2ooCdm003oo?cloodm?Colo?c00;olo?c00?om?Cdoo?cloodm?@00_oc
lo<01?odm?Colo?coo?clooclo<2ooCdm003oo?cloodm?Colo?c00;olo?c
00?om?Cdoo?cloodm?@00_oclo<01?odm?Colo?coo?clooclo<2ooCdm003
oo?cloodm?Colo?c00;olo?c00?om?Cdoo?cloodm?@00_oclo<01?odm?Co
lo?coo?clooclo<2ooCdm003oo?cloodm?Colo?c00;olo?c00?om?Cdoo?c
loodm?@00_oclo<01?odm?Colo?coo?clooclo<2ooCdm003oo?cloodm?Co
lo?c00;olo?c00?om?Cdoo?cloodm?@00_oclo<01?odm?Colo?coo?clooc
lo<2ooCdm003oo?cloodm?Colo?c00;olo?c00?om?Cdoo?cloodm?@00_oc
lo<01?odm?Colo?coo?clooclo<2ooCdm00Joo?clon`/;3oGV^So`Pf[?l9
B;Ko4Ec0oamWa_l_M/oo?h?Eodf>gOmGUn;oGigUoenKh?mGLHkoTi>ColO7
aooinOWoE5ADoeIFE_mIFEWoG5aLoemOGomQHF7oI6ATofMWIomZJVX1ofe]
K@000_oem_L00ooemOKom?GeooCemP02ooCem@05ooCem_odmOGom?Ceoo?d
m?odm?D00_ocm?@01Oobl_?omoOgooShn?li>CWoMgMg00;omoOg01Wo@d=3
oa/K6on<S8coh^;Rod92@_lT92CoHV9RomcLg?mbLW;o=cLgooOgmoohn?So
/K6aomGEeOodm?CoHf=SoeIFE_ogmoOon?Shoclo?om9BDWog=cLon_[jomH
F5So61PH00;omoOg017oA4A4ogmoOoohn?SomoOgodA4A?lJ6Q[oMWIfomWI
fOmJFU[oD51@ooOgmoohn?So/K6aomGEeOodm?CoHf=SoeMGE`02ooShn00;
od=3@olI6AWoT92@omkNg_nOWioo5ADEonk^k_ogmoOoj>SXoa0@4?oBd]80
0_ogmoL3ooShn004ocXj>_mdM7ComoOgooOgm`;on?Sh01coShn?o``<3?od
m?ComoOgok6a/OoDe=Com?Cdof=SHomGEeOon?Shoj2PX?lE5AGok^k^ooOg
mooXj>So410@om;Bd_ogmoOon?ShooOgmoohn?SomoOgonOWiolW9bOo_;bl
oo?clol71`Ooj>SX0_ogmoL2ooShn0;omoOg00?on?ShooOgmoohn?P00_og
moL3ooShn0ComoOg0_ohn?P2ooOgm`03ooShn?ogmoOon?Sh00;omoOg0ooh
n?P4ooOgm`;on?Sh0_ogmoL00oohn?SomoOgooShn002ooOgm`?on?Sh1?og
moL2ooShn0;omoOg00?on?ShooOgmoohn?P00_ogmoL3ooShn0ComoOg0_oh
n?P2ooOgm`03ooShn?ogmoOon?Sh00;omoOg0oohn?P4ooOgm`;on?Sh0_og
moL00oohn?SomoOgooShn002ooOgm`?on?Sh1?ogmoL2ooShn0;omoOg00?o
n?ShooOgmoohn?P00_ogmoL3ooShn0ComoOg0_ohn?P2ooOgm`03ooShn?og
moOon?Sh00;omoOg0oohn?P4ooOgm`;on?Sh0_ogmoL00oohn?SomoOgooSh
n002ooOgm`?on?Sh1?ogmoL2ooShn0;omoOg00?on?ShooOgmoohn?P00_og
moL3ooShn0ComoOg0_ohn?P2ooOgm`03ooShn?ogmoOon?Sh00;omoOg0ooh
n?P4ooOgm`;on?Sh0_ogmoL00oohn?SomoOgooShn002ooOgm`?on?Sh1?og
moL2ooShn0;omoOg00?on?ShooOgmoohn?P00_ogmoL3ooShn0ComoOg0_oh
n?P2ooOgm`03ooShn?ogmoOon?Sh00;omoOg0oohn?P4ooOgm`;on?Sh0_og
moL00oohn?SomoOgooShn002ooOgm`?on?Sh1?ogmoL2ooShn0;omoOg00?o
n?ShooOgmoohn?P00_ofm_H00ooemOGom_KhooGfm`04ooGfm`;om_Kh1?oe
m_L01Oofm_SomOKgooGfmooem_Oom_Kh00GomOKg0_ofm_P4ooGfm`05ooKf
n?oem_OomOKgooGfmoofm_P00ooem_L01?o_knoomoOgooKfm_ohn?P2ooOg
m`03ooShn?ogmoOon?Sh00;omoOg0oohn?P4ooOgm`;on?Sh0_ogmoL00ooh
n?SomoOgooShn002ooOgm`?on?Sh1?ogmoL2ooShn0;omoOg00?on?ShooOg
moohn?P00_ogmoL3ooShn0ComoOg0_ohn?P2ooOgm`03ooShn?ogmoOon?Sh
00;omoOg0oohn?P4ooOgm`;on?Sh0_ogmoL00oohn?SomoOgooShn002ooOg
m`?on?Sh1?ogmoL2ooShn0;omoOg00?on?ShooOgmoohn?P00_ogmoL3ooSh
n0ComoOg0_ohn?P2ooOgm`03ooShn?ogmoOon?Sh00;omoOg0oohn?P4ooOg
m`;on?Sh0_ogmoL00oohn?SomoOgooShn002ooOgm`?on?Sh1?ogmoL2ooSh
n0;omoOg00?on?ShooOgmoohn?P00_ogmoL3ooShn0ComoOg0_ohn?P2ooOg
m`03ooShn?ogmoOon?Sh00;omoOg0oohn?P4ooOgm`;on?Sh0_ogmoL00ooh
n?SomoOgooShn002ooOgm`?on?Sh1?ogmoL2ooShn0;omoOg00?on?ShooOg
moohn?P00_ogmoL3ooShn0ComoOg0_ohn?P2ooOgm`03ooShn?ogmoOon?Sh
00;omoOg0oohn?P3ooOgm`0Iok6a/OnJW:_o<T^Qo`Lj/Ol7C;Wo45g0ob1Z
a_l^ML_o>WoAodB6e?m:RM?oCGNXogMnQOn`/;3oe=CDonSXj?mADE7oE5AD
oeMGEomIFEWoG5aLoemOGomRHV;oIFEUofQXJ001of][J`0000ColO7boo3`
lOo`lO;oko3a0_o`l?400oo_l?3okno`ono`l@02ono_l004ono`l?o^knoo
k^k_ong^kP;ol_;b00ko=SHfogAdM?obl_;ol_;boeADE?n7QhOoKVi^oaDE
5Ol[:b_obl_;oiFEUOlN7Qko92@TojJVYP;ol_;b00GoQXJ6ocDe=OlE5AGo
>c/kokbl_002oo;blP06omSHf?m5ADGo410@obd];OmcLg?o;Rh^0_obl_80
6OmDE5CoR8R8oo?cloobl_;oEEEEohR8R?mfMWKo61PHoc8b<_nk^k_ol_;b
oo?clon6QXKo=CDeoaDE5Olj>S[o_;bloo;bl_oclo?oE5ADohF5QOmMGEgo
3`l?oeADE?m_Kfl00_obl_800ooclo?oJVYZoh61P@04oo;blP03oo?clolh
>3SoLW9b00?ol_;b00golo?coe9BD_l_;boolo?coo;bl_n6QXKo=CDeoaDE
5Olk>c_o^k^koo?clomIFEWoKfm_00?ol_;b00CoJVYZoh61POobl_;olo?c
1?obl_801Onl_;co8R8Rom[Jf_l71`Ooh^;R00?ol_;b00Colo?coo;bl_ob
l_;olo?c1_obl_800ooclo?ol_;boo;blP03oo;blP04oo?cloobl_;ol_;b
oo?cl`Kol_;b00?olo?coo;bl_obl_800oobl_801?oclo?ol_;boo;bl_oc
lo<6oo;blP03oo?cloobl_;ol_;b00?ol_;b00Colo?coo;bl_obl_;olo?c
1_obl_800ooclo?ol_;boo;blP03oo;blP04oo?cloobl_;ol_;boo?cl`Ko
l_;b00?olo?coo;bl_obl_800oobl_801?oclo?ol_;boo;bl_oclo<6oo;b
lP03oo?cloobl_;ol_;b00?ol_;b00Colo?coo;bl_obl_;olo?c1_obl_80
0ooclo?ol_;boo;blP03oo;blP04oo?cloobl_;ol_;boo?cl`Kol_;b00?o
lo?coo;bl_obl_800oobl_801?oclo?ol_;boo;bl_oclo<6oo;blP03oo?c
loobl_;ol_;b00?ol_;b00Colo?coo;bl_obl_;olo?c1_obl_800ooclo?o
l_;boo;blP03oo;blP04oo?cloobl_;ol_;boo?cl`Kol_;b00?olo?coo;b
l_obl_800oobl_801?oclo?ol_;boo;bl_oclo<6oo;blP03oo?cloobl_;o
l_;b00?ol_;b00Colo?coo;bl_obl_;olo?c1_obl_800ooclo?ol_;boo;b
lP03oo;blP04oo?cloobl_;ol_;boo?cl`Kol_;b00?olo?coo;bl_obl_80
0oobl_801?oclo?ol_;boo;bl_oclo<6oo;blP03oo?cloobl_;ol_;b00?o
l_;b00Colo?coo;bl_obl_;olo?c0_obl_83oo7al@03oo3alOoal_;ol?7b
00;olO7b00?ol?7boo3alOoal_800_o`lO800ooal_;ol?7boo3alP02oo3a
lP04oo7al_o`lO7olO;boo3alP;olO7b00?ol?7boo3alOoal_800_o`lO80
0ooal_;ol?7boo3alP02oo3alP09oo7al_o`lO7olO;boo3al_oalO;ojn_[
oo;bl_o`l?3olo?c00;ol_;b00?olo?coo;bl_obl_801?obl_800ooclo?o
l_;boo;blP03oo;blP04oo?cloobl_;ol_;boo?cl`Kol_;b00?olo?coo;b
l_obl_800oobl_801?oclo?ol_;boo;bl_oclo<6oo;blP03oo?cloobl_;o
l_;b00?ol_;b00Colo?coo;bl_obl_;olo?c1_obl_800ooclo?ol_;boo;b
lP03oo;blP04oo?cloobl_;ol_;boo?cl`Kol_;b00?olo?coo;bl_obl_80
0oobl_801?oclo?ol_;boo;bl_oclo<6oo;blP03oo?cloobl_;ol_;b00?o
l_;b00Colo?coo;bl_obl_;olo?c1_obl_800ooclo?ol_;boo;blP03oo;b
lP04oo?cloobl_;ol_;boo?cl`Kol_;b00?olo?coo;bl_obl_800oobl_80
1?oclo?ol_;boo;bl_oclo<6oo;blP03oo?cloobl_;ol_;b00?ol_;b00Co
lo?coo;bl_obl_;olo?c1_obl_800ooclo?ol_;boo;blP03oo;blP04oo?c
loobl_;ol_;boo?cl`Kol_;b00?olo?coo;bl_obl_800oobl_801?oclo?o
l_;boo;bl_oclo<6oo;blP03oo?cloobl_;ol_;b00?ol_;b00Colo?coo;b
l_obl_;olo?c1_obl_804_oclo?ol_;boo;bl_obl_;o/[:bokBd]?n5RjOo
<DjPo`Lo/Ol8CKSo45^noaiX`olXKlGo<7K8od1_Y_m/O8goZZZZolk>cP;o
h>3P00WoD51@oe9BD_mEEEGoEeMGoeYJF_mMGEgoH61Pof=SHomVIVH00OmY
JFT00005on7RhooRh^?ohN;Son7RhooQh^800_oQhN82on3QhP0;on7Qh_oP
h>7oh>3Qon3QhOoOgn3oh>3PonCTi?oShn?o<c<cofa/K?oTi>@01OoShn<0
1OoTi>Cohn?Son?ShooTi>Coh^;R00;oi>CT0ooShn<00ooRh^;ohn?Son?S
h`03on?Sh`05onCTi?oQhN7ohn?SonCTi?oShn<00_oTi>@3on?Sh`07onCT
i?oShn?ohn?Son?ShooRh^;ohn?SonCTi002on?Sh`04onCTi?oShn?oh^;R
onCTi0?ohn?S00Coi>CTon?ShooShn?ohN7Q0_oShn<01OoTi>Cohn?Son?S
hooTi>Cohn?S00;oi>CT0ooShn<00old=3CoJVYZon?Sh`02on?Sh`08oi2@
T?l61PKoTI6Aon?ShooTi>Cohn?SonCTi?oRh^83on?Sh`03onCTi?oShn?o
hn?S00?ohn?S00Goi>CTon?ShooShn?oi>CTon?Sh`02onCTi005on?Shomf
MWKo@D51o`H61_oDe=@01?oShn<01OoTi>Cohn?Son?ShooTi>Cohn?S00;o
i>CT0ooShn<00ooTi>Cohn?Son?Sh`03on?Sh`05onCTi?oShn?ohn?SonCT
i?oShn<00_oTi>@3on?Sh`03onCTi?oShn?ohn?S00?ohn?S00Goi>CTon?S
hooShn?oi>CTon?Sh`02onCTi0?ohn?S00?oi>CTon?ShooShn<00ooShn<0
1OoTi>Cohn?Son?ShooTi>Cohn?S00;oi>CT0ooShn<00ooTi>Cohn?Son?S
h`03on?Sh`05onCTi?oShn?ohn?SonCTi?oShn<00_oTi>@3on?Sh`03onCT
i?oShn?ohn?S00?ohn?S00Goi>CTon?ShooShn?oi>CTon?Sh`02onCTi0?o
hn?S00?oi>CTon?ShooShn<00ooShn<01OoTi>Cohn?Son?ShooTi>Cohn?S
00;oi>CT0ooShn<00ooTi>Cohn?Son?Sh`03on?Sh`05onCTi?oShn?ohn?S
onCTi?oShn<00_oTi>@3on?Sh`03onCTi?oShn?ohn?S00?ohn?S00Goi>CT
on?ShooShn?oi>CTon?Sh`02onCTi0?ohn?S00?oi>CTon?ShooShn<00ooS
hn<01OoTi>Cohn?Son?ShooTi>Cohn?S00;oi>CT0ooShn<00ooTi>Cohn?S
on?Sh`03on?Sh`05onCTi?oShn?ohn?SonCTi?oShn<00_oTi>@3on?Sh`03
onCTi?oShn?ohn?S00?ohn?S00Goi>CTon?ShooShn?oi>CTon?Sh`02onCT
i0?ohn?S00?oi>CTon?ShooShn<00ooShn<01OoTi>Cohn?Son?ShooTi>Co
hn?S00;oi>CT0ooShn<00ooTi>Cohn?Son?Sh`03on?Sh`05onCTi?oShn?o
hn?SonCTi?oShn<00_oTi>@3on?Sh`03onCTi?oShn?ohn?S00?ohn?S00Go
i>CTon?ShooShn?oi>CTon?Sh`02onCTi0?ohn?S00?oi>CTon?ShooShn<0
0ooShn<01?oTi>Cohn?Son?ShooTi>@3on?Sh`0:on7QhOoRh^?ohN;Son;S
hooRh^?ohN;Son;RhooQh^?oh^;Son;Sh`;ohN;S00koh^?Son7RhooRhnCo
h^?Son7RhooRh^?ohN;Son;ShooRh^?ohN;Son;RhooQh^?oh^;Son;Sh`;o
hN;S00koh^?Son7RhooRhnCoh^?Son7RhooRh^?ohN;Son;ShooRh^?ogMgM
on?ShooRh^;ohn?SonCTi0;ohn?S00Coi>CTon?ShooTi>Coi>CT0ooShn<0
0ooTi>Cohn?Son?Sh`03on?Sh`05onCTi?oShn?ohn?SonCTi?oShn<00_oT
i>@3on?Sh`03onCTi?oShn?ohn?S00?ohn?S00Goi>CTon?ShooShn?oi>CT
on?Sh`02onCTi0?ohn?S00?oi>CTon?ShooShn<00ooShn<01OoTi>Cohn?S
on?ShooTi>Cohn?S00;oi>CT0ooShn<00ooTi>Cohn?Son?Sh`03on?Sh`05
onCTi?oShn?ohn?SonCTi?oShn<00_oTi>@3on?Sh`03onCTi?oShn?ohn?S
00?ohn?S00Goi>CTon?ShooShn?oi>CTon?Sh`02onCTi0?ohn?S00?oi>CT
on?ShooShn<00ooShn<01OoTi>Cohn?Son?ShooTi>Cohn?S00;oi>CT0ooS
hn<00ooTi>Cohn?Son?Sh`03on?Sh`05onCTi?oShn?ohn?SonCTi?oShn<0
0_oTi>@3on?Sh`03onCTi?oShn?ohn?S00?ohn?S00Goi>CTon?ShooShn?o
i>CTon?Sh`02onCTi0?ohn?S00?oi>CTon?ShooShn<00ooShn<01OoTi>Co
hn?Son?ShooTi>Cohn?S00;oi>CT0ooShn<00ooTi>Cohn?Son?Sh`03on?S
h`05onCTi?oShn?ohn?SonCTi?oShn<00_oTi>@3on?Sh`03onCTi?oShn?o
hn?S00?ohn?S00Goi>CTon?ShooShn?oi>CTon?Sh`02onCTi0?ohn?S00?o
i>CTon?ShooShn<00ooShn<01OoTi>Cohn?Son?ShooTi>Cohn?S00;oi>CT
0ooShn<01?oTi>Cohn?Son?Shond];@2okRh^00FoinR/?mKKZ;o:U>Soa1>
/_lBEk?o;f>Voe9cV_n6SYSo]KFeom7AdOoPh>3oiNGUonOWiom>CTkoD51@
oe=CDomFEUKoF5QHoe]KFomNGUkoHF5QofEUI@7oJ6QX00001_o`l?7ol?7a
oo3`lOo_l?3okno`ono`l0;okno`00?ok^o_ono_l?o_knl00_o^k^l01_o^
k^kokNg^oo7alOoalO7o=CDeog9bLQgolO7a00?oFUYJohf=SOoalO408?oa
lO402?lf=SKo<30`of9RH_m>CTko<30`o`/;2on:RX[ol?3`5_oalO401?o`
l?3o@D51o`D51OoQhN7ioo7al@;ol?3`00Wokno_oo3`lOo`l?7oko3aono`
l?o`l?7oko3aoo3`lOo_l?400_o`l?401_o_l?3ol?3aono`lOo_l?7ol?3a
ono`l@;ol?3a00Koko3aono`l?o`l?7oko3aoo3`lOo_l?42oo3`l@06ono`
l?o`l?7oko3aono`lOo`l?7oko3a0_o`l?401Oo_l?7oko3`on_[jooalO7o
l?3`0<kolO7a01Wo/k>cokZj^_no_kooa<C4ol;2`_nk^k_o]KFeok6a/One
]KGo`L71olg=cOoNg]koinOWonWYjOoVi^KomoOgoda<C?m?CdooDE5AoeAD
E?mGEeOoFEUIoeeMGOmPH63oHf=S007oIfMW00000oodmOKom?GeooCdm@02
ooCdm@06oo?dm?ocloColoCdoo?cm?oblo?olo?d0ooblo<01ooal_;omOGe
ooGemOnZZZ[o`/;2ooGemOofm_H00_oemOD00oofm_KomOGeooGem@03ooGe
m@03ooKfm_oemOGomOGe00ComOGe00Com_KfooGemOoemOGom_Kf1OoemOD0
1Oofm_KomOGeooGemOn_[jooa/K600;omOGe00Com_KfooGemOoemOGom_Kf
1OoemOD00oofm_KomOGeooGem@04ooGem@04ooKfm_oemOGomOGeooKfmPGo
mOGe00?om_KfooGemOoemOD00ooemOD01_n[Zj_oUiNGoiJFU_nMWIgo_[jn
on?Sh`ComOGe00?om_KfooGemOoemOD01?oemOD01?ofm_KomOGeooGemOof
m_H5ooGem@03ooKfm_oemOGomOGe00;omOGe00?og]kNoiJFU_o`l?000_oe
mOD00oofm_KomOGeooGem@03ooGem@03ooKfm_oemOGomOGe00ComOGe00Co
m_KfooGemOoemOGom_Kf1OoemOD00oofm_KomOGeooGem@04ooGem@04ooKf
m_oemOGomOGeooKfmPGomOGe00?om_KfooGemOoemOD01?oemOD01?ofm_Ko
mOGeooGemOofm_H5ooGem@03ooKfm_oemOGomOGe00ComOGe00Com_KfooGe
mOoemOGom_Kf1OoemOD00oofm_KomOGeooGem@04ooGem@04ooKfm_oemOGo
mOGeooKfmPGomOGe00?om_KfooGemOoemOD01?oemOD01?ofm_KomOGeooGe
mOofm_H5ooGem@03ooKfm_oemOGomOGe00ComOGe00Com_KfooGemOoemOGo
m_Kf1OoemOD00oofm_KomOGeooGem@04ooGem@04ooKfm_oemOGomOGeooKf
mPGomOGe00?om_KfooGemOoemOD01?oemOD01?ofm_KomOGeooGemOofm_H5
ooGem@03ooKfm_oemOGomOGe00ComOGe00Com_KfooGemOoemOGom_Kf1Ooe
mOD00oofm_KomOGeooGem@04ooGem@04ooKfm_oemOGomOGeooKfmPGomOGe
00?om_KfooGemOoemOD01?oemOD01?ofm_KomOGeooGemOofm_H5ooGem@03
ooKfm_oemOGomOGe00ComOGe00Com_KfooGemOoemOGom_Kf1OoemOD00oof
m_KomOGeooGem@04ooGem@04ooKfm_oemOGomOGeooKfmPGomOGe00?om_Kf
ooGemOoemOD01?oemOD01?ofm_KomOGeooGemOofm_H5ooGem@0>ooKfm_oe
mOGomOGeooCdm?ocm?Gom?CeooCemOodmOKom?Ceoo?dmOodmOKom?Geoo?d
mOodmOD2ooCdm@0>ooCem_ocm?Gom?GeooCdmOocm?Gom?CeooCemOodmOKo
m?Ceoo?dmOodmOKom?Geoo?dmOodmOD2ooCdm@0;ooCem_ocm?Gom?GeooCd
mOocm?Gom?CeooCemOodmOKol?3`ooGemOodm?@01OoemOD00oofm_KomOGe
ooGem@04ooGem@04ooKfm_oemOGomOGeooKfmPGomOGe00?om_KfooGemOoe
mOD01?oemOD01?ofm_KomOGeooGemOofm_H5ooGem@03ooKfm_oemOGomOGe
00ComOGe00Com_KfooGemOoemOGom_Kf1OoemOD00oofm_KomOGeooGem@04
ooGem@04ooKfm_oemOGomOGeooKfmPGomOGe00?om_KfooGemOoemOD01?oe
mOD01?ofm_KomOGeooGemOofm_H5ooGem@03ooKfm_oemOGomOGe00ComOGe
00Com_KfooGemOoemOGom_Kf1OoemOD00oofm_KomOGeooGem@04ooGem@04
ooKfm_oemOGomOGeooKfmPGomOGe00?om_KfooGemOoemOD01?oemOD01?of
m_KomOGeooGemOofm_H5ooGem@03ooKfm_oemOGomOGe00ComOGe00Com_Kf
ooGemOoemOGom_Kf1OoemOD00oofm_KomOGeooGem@04ooGem@04ooKfm_oe
mOGomOGeooKfmPGomOGe00?om_KfooGemOoemOD01?oemOD01?ofm_KomOGe
ooGemOofm_H5ooGem@03ooKfm_oemOGomOGe00ComOGe00Com_KfooGemOoe
mOGom_Kf1OoemOD00oofm_KomOGeooGem@04ooGem@0=ooKfm_oemOGo/[:b
okZj^_o2`/;ob/[:olo?cooEeMGoemOGom_KfooPh>3oiNGUon[ZjP02onk^
kP0<on_[jooWinOoi^KVodY:B_m=CDgoCdm?oe9BD_mEEEGoF5QHoe]KFomN
GUkoHV9R0OmUIFD00006oo3alOo_l?7ol?3aono`l?o^knookno`0_o^knl0
1Oo]k^kok^o_onk^k_o^knookNk^00;okNg]0_oalO402oo`l?3olO7aoo3`
l?o`l?3olO7aoo3`l?oalO7ol?3`oo7alOo`l?3olO7a00?ol?3`0_oalO40
2oo`l?3olO7aoo3`l?o`l?3olO7aoo3`l?oalO7ol?3`oo7alOo`l?3olO7a
00?ol?3`0_oalO401?o`l?3ol>o_ono_koo_knl2oo3`l005oo7alOo`l?3o
lO7aoo3`l?oalO400oo`l?02oo7al@0;oo3`l?oalO7ol?3`oo3`l?oalO7o
l?3`oo7alOo`l?3olO7aoo3`l?oalO400oo`l?02oo7al@09oo3`l?oalO7o
l?3`oo3`l?oalO7ol?3`oo7alOo`l?3olO7a00Gol?3`0_oalO402oo`l?3o
lO7aoo3`l?o`l?3olO7aoo3`l?oalO7ol?3`oo7alOo`l?3olO7a00?ol?3`
0_oalO402oo`l?3olO7aoo3`l?o`l?3olO7aoo3`l?oalO7ol?3`oo7alOo`
l?3olO7a00?ol?3`00?olO7aoo3`l?o^k^h00_o_knl02?o`l?3olO7aoo3`
l?oalO7ol?3`oo7alOo`l?3olO7a0oo`l?02oo7al@0;oo3`l?oalO7ol?3`
oo3`l?oalO7ol?3`oo7alOo`l?3olO7aoo3`l?oalO400oo`l?02oo7al@0;
oo3`l?oalO7ol?3`oo3`l?oalO7ol?3`oo7alOo`l?3olO7aoo3`l?oalO40
0oo`l?02oo7al@0;oo3`l?oalO7ol?3`oo3`l?oalO7ol?3`oo7alOo`l?3o
lO7aoo3`l?oalO400oo`l?02oo7al@0;oo3`l?oalO7ol?3`oo3`l?oalO7o
l?3`oo7alOo`l?3olO7aoo3`l?oalO400oo`l?02oo7al@0;oo3`l?oalO7o
l?3`oo3`l?oalO7ol?3`oo7alOo`l?3olO7aoo3`l?oalO400oo`l?02oo7a
l@0;oo3`l?oalO7ol?3`oo3`l?oalO7ol?3`oo7alOo`l?3olO7aoo3`l?oa
lO400oo`l?02oo7al@0;oo3`l?oalO7ol?3`oo3`l?oalO7ol?3`oo7alOo`
l?3olO7aoo3`l?oalO400oo`l?02oo7al@0;oo3`l?oalO7ol?3`oo3`l?oa
lO7ol?3`oo7alOo`l?3olO7aoo3`l?oalO400oo`l?02oo7al@0;oo3`l?oa
lO7ol?3`oo3`l?oalO7ol?3`oo7alOo`l?3olO7aoo3`l?oalO400oo`l?02
oo7al@0;oo3`l?oalO7ol?3`oo3`l?oalO7ol?3`oo7alOo`l?3olO7aoo3`
l?oalO400oo`l?02oo7al@0;oo3`l?oalO7ol?3`oo3`l?oalO7ol?3`oo7a
lOo`l?3olO7aoo3`l?oalO400oo`l?02oo7al@0;oo3`l?oalO7ol?3`oo3`
l?oalO7ol?3`oo7alOo`l?3olO7aoo3`l?oalO400oo`l?02oo7al@0;oo3`
l?oalO7ol?3`oo3`l?oalO7ol?3`oo7alOo`l?3olO7aoo3`l?oalO400oo`
l?02oo7al@0;oo3`l?oalO7ol?3`oo3`l?oalO7ol?3`oo7alOo`l?3olO7a
oo3`l?oalO401?o`l?003oo_knookno`ono`lOo_ko3ok^o`ono`l?o_ko3o
ko3`onk_l?o_l?3okno`ono`lOo_ko3ok^o`ono_l002ono`l00>ono_l?o_
l?7okno`onk_l?o_l?3okno`ono`l?o^ko3oko3`ono_l?o_l?7okno`onk_
l?o_ko02ono`l00;ono_l?o_l?7okno`onk_l?o[jn_ol?3`ono_koo`l?3o
lO7aoo3`l?oalO400oo`l?02oo7al@0;oo3`l?oalO7ol?3`oo3`l?oalO7o
l?3`oo7alOo`l?3olO7aoo3`l?oalO400oo`l?02oo7al@0;oo3`l?oalO7o
l?3`oo3`l?oalO7ol?3`oo7alOo`l?3olO7aoo3`l?oalO400oo`l?02oo7a
l@0;oo3`l?oalO7ol?3`oo3`l?oalO7ol?3`oo7alOo`l?3olO7aoo3`l?oa
lO400oo`l?02oo7al@0;oo3`l?oalO7ol?3`oo3`l?oalO7ol?3`oo7alOo`
l?3olO7aoo3`l?oalO400oo`l?02oo7al@0;oo3`l?oalO7ol?3`oo3`l?oa
lO7ol?3`oo7alOo`l?3olO7aoo3`l?oalO400oo`l?02oo7al@0;oo3`l?oa
lO7ol?3`oo3`l?oalO7ol?3`oo7alOo`l?3olO7aoo3`l?oalO400oo`l?02
oo7al@0;oo3`l?oalO7ol?3`oo3`l?oalO7ol?3`oo7alOo`l?3olO7aoo3`
l?oalO400oo`l?02oo7al@0;oo3`l?oalO7ol?3`oo3`l?oalO7ol?3`oo7a
lOo`l?3olO7aoo3`l?oalO400oo`l?02oo7al@0;oo3`l?oalO7ol?3`oo3`
l?oalO7ol?3`oo7alOo`l?3olO7aoo3`l?oalO400oo`l?02oo7al@0;oo3`
l?oalO7ol?3`oo3`l?oalO7ol?3`oo7alOo`l?3olO7aoo3`l?oalO400oo`
l?02oo7al@0;oo3`l?oalO7ol?3`oo3`l?oalO7ol?3`oo7alOo`l?3olO7a
oo3`l?oalO400oo`l?02oo7al@0;oo3`l?oalO7ol?3`oo3`l?oalO7ol?3`
oo7alOo`l?3olO7aoo3`l?oalO400oo`l?02oo7al@0Noo3`l?oalO7ol?3`
oo3`l?oalO7o/[:bokZj^_o1`L7oc<c<om?CdooKfm_ohN7QonGUiOo[jn_o
l?3`oo7alOobl_;ol?3`on_[jooVi^Kog]kNodU9BOm<C4coCTi>oe5ADOmC
De?oEeMGoeYJF_mMGEgoH61P0OmTI6@00004on7RhooQhN;ohN;Ron7QhP;o
h>7Q00Goh>3Qon3QhOoPh>7ogn3Pon3Ph002omoOh0;ogmoO3?oRh^800ooQ
hN7oh^;Ron;RhP0=on;RhP03on7QhOoRh^;oh^;R00;oh^;R00OohN7Qon3P
h?oPh>3ohN7Qon3Ph?oQhN7ohN7P00?ohN7Q00?oh^;Ron7QhOoRh^803_oR
h^800ooQhN7oh^;Ron;RhP0=on;RhP03omkNg_oPh>3oh^;R00goh^;R00?o
hN7Qon;Rh_oRh^803OoRh^801_oQhN7oh^;Ron;Rh_oRh^;ohN7QomkNgP;o
gmoO00?og]kNomoOgooRh^801OoRh^800ooQhN7oh^;Ron;RhP0=on;RhP03
on7QhOoRh^;oh^;R00goh^;R00?ohN7Qon;Rh_oRh^803OoRh^800ooQhN7o
h^;Ron;RhP0=on;RhP03on7QhOoRh^;oh^;R00goh^;R00?ohN7Qon;Rh_oR
h^803OoRh^800ooQhN7oh^;Ron;RhP0=on;RhP03on7QhOoRh^;oh^;R00go
h^;R00?ohN7Qon;Rh_oRh^803OoRh^800ooQhN7oh^;Ron;RhP0=on;RhP03
on7QhOoRh^;oh^;R00goh^;R00?ohN7Qon;Rh_oRh^803OoRh^800ooQhN7o
h^;Ron;RhP0=on;RhP03on7QhOoRh^;oh^;R00goh^;R00OohN7Qon;Rh_oR
h^;oh^;Ron7QhOoPh>3oh>7Q00;ohN7R00Soh>7Qon3Qh_oPhN7ohN7Ron3Q
h_oPhN7ohN7Ron3Ph@;oh>7R00CohN7Ron3QhOoPhN7oh>7Q0_oQhN802?oP
hN7oh>7Ron3QhOoQhN;oh>7Ron3QhOoQhN;oh>3Q0_oPhN801?oQhN;oh>7Q
on3QhOoPhN42on7QhP04on3QhOoMgMgoh^;Ron7Qh@?oh^;R00?ohN7Qon;R
h_oRh^803OoRh^800ooQhN7oh^;Ron;RhP0=on;RhP03on7QhOoRh^;oh^;R
00goh^;R00?ohN7Qon;Rh_oRh^803OoRh^800ooQhN7oh^;Ron;RhP0=on;R
hP03on7QhOoRh^;oh^;R00goh^;R00?ohN7Qon;Rh_oRh^803OoRh^800ooQ
hN7oh^;Ron;RhP0=on;RhP03on7QhOoRh^;oh^;R00goh^;R00?ohN7Qon;R
h_oRh^803OoRh^800ooQhN7oh^;Ron;RhP0=on;RhP03on7QhOoRh^;oh^;R
00goh^;R00?ohN7Qon;Rh_oRh^802?oRh^802_nb/[;o^KViol30`?o9bLWo
dM7AomWIfOoPh>3oiNGUonc/k?o_knl2oo3`l00=onk^k_oZj^[oi>CTonGU
iOm8B4SoBd];ode=COm?CdooDU9BoeEEEOmHF5SoG5aLof1PH001of=SH`00
00OonOWioo[jn_oinOWonOWioo[jn_oinOWon_[j00;onOWi0_ojn_X00ooi
nOWon_[jooWin@03ooWin@06oo[jn_oinOWonOWioo[jn_oinOWon_[j0_oi
nOT2oo[jnP03ooWinOojn_[onOWi00?onOWi00Kon_[jooWinOoinOWon_[j
ooWinOojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT00ooinOT01_ojn_[o
nOWiooWinOojn_[onOWioo[jnP;onOWi0_ojn_X00ooinOWon_[jooWin@03
ooWin@06oo[jn_oinOWonOWioo[jn_oinOWon_[j0_oinOT2oo[jnP03ooWi
nOojn_[onOWi00?onOWi00Kon_[jooWinOoinOWon_[jooWinOojn_X2ooWi
n@;on_[j00?onOWioo[jn_oinOT00ooinOT01_ojn_[onOWiooWinOojn_[o
nOWioo[jnP;onOWi0_ojn_X00ooinOWon_[jooWin@03ooWin@06oo[jn_oi
nOWonOWioo[jn_oinOWon_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi00?o
nOWi00Kon_[jooWinOoinOWon_[jooWinOojn_X2ooWin@;on_[j00?onOWi
oo[jn_oinOT00ooinOT01_ojn_[onOWiooWinOojn_[onOWioo[jnP;onOWi
0_ojn_X00ooinOWon_[jooWin@03ooWin@06oo[jn_oinOWonOWioo[jn_oi
nOWon_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi00?onOWi00Kon_[jooWi
nOoinOWon_[jooWinOojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT00ooi
nOT01_ojn_[onOWiooWinOojn_[onOWioo[jnP;onOWi0_ojn_X00ooinOWo
n_[jooWin@03ooWin@06oo[jn_oinOWonOWioo[jn_oinOWon_[j0_oinOT2
oo[jnP03ooWinOojn_[onOWi00?onOWi00Kon_[jooWinOoinOWon_[jooWi
nOojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT00ooinOT01_ojn_[onOWi
ooWinOojn_[onOWioo[jnP;onOWi0_ojn_X00ooinOWon_[jooWin@03ooWi
n@06oo[jn_oinOWonOWioo[jn_oinOWon_[j0_oinOT2oo[jnP03ooWinOoj
n_[onOWi00?onOWi00Kon_[jooWinOoinOWon_[jooWinOojn_X2ooWin@;o
n_[j00?onOWioo[jn_oinOT00ooinOT01_ojn_[onOWiooWinOojn_[onOWi
oo[jnP;onOWi0_ojn_X00ooinOWon_[jooWin@03ooWin@06oo[jn_oinOWo
nOWioo[jn_oinOWon_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi00?onOWi
00Kon_[jooWinOoinOWon_[jooWinOojn_X2ooWin@;on_[j00?onOWioo[j
n_oinOT00ooinOT01_ojn_[onOWiooWinOojn_[onOWioo[jnP;onOWi0_oj
n_X00ooinOWon_[jooWin@03ooWin@06oo[jn_oinOWonOWioo[jn_oinOWo
n_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi00?onOWi00Kon_[jooWinOoi
nOWon_[jooWinOojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT00ooinOT0
1_ojn_[onOWiooWinOojn_[onOWioo[jnP;onOWi0_ojn_X00ooinOWon_[j
ooWin@03ooWin@06oo[jn_oinOWonOWioo[jn_oinOWon_[j0_oinOT2oo[j
nP03ooWinOojn_[onOWi00?onOWi00Kon_[jooWinOoinOWon_[jooWinOoj
n_X2ooWin@;on_[j00?onOWioo[jn_oinOT00ooinOT01_ojn_[onOWiooWi
nOojn_[onOWioo[jnP;onOWi0_ojn_X00ooinOWon_[jooWin@03ooWin@06
oo[jn_oinOWonOWioo[jn_oinOWon_[j0_oinOT2oo[jnP03ooWinOojn_[o
nOWi00?onOWi00Kon_[jooWinOoinOWon_[jooWinOojn_X2ooWin@;on_[j
00?onOWioo[jn_oinOT00ooinOT01_ojn_[onOWiooWinOojn_[onOWioo[j
nP;onOWi0_ojn_X00ooinOWon_[jooWin@03ooWin@06oo[jn_oinOWonOWi
oo[jn_oinOWon_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi00?onOWi00Ko
n_[jooWinOoinOWon_[jooWinOojn_X2ooWin@;on_[j00?onOWioo[jn_oi
nOT00ooinOT01_ojn_[onOWiooWinOojn_[onOWioo[jnP;onOWi0_ojn_X0
0ooinOWon_[jooWin@03ooWin@06oo[jn_oinOWonOWioo[jn_oinOWon_[j
0_oinOT2oo[jnP03ooWinOojn_[onOWi00?onOWi00Kon_[jooWinOoinOWo
n_[jooWinOojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT00ooinOT01_oj
n_[onOWiooWinOojn_[onOWioo[jnP;onOWi0_ojn_X00ooinOWon_[jooWi
n@03ooWin@06oo[jn_oinOWonOWioo[jn_oinOWon_[j0_oinOT2oo[jnP03
ooWinOojn_[onOWi00?onOWi01kon_[jooWinOoinOWon_[jooWinOnl_;co
`L71olS8b?oBd];ofMWIon7QhOoYjNWok^k^oo;bl_ogmoOonOWiooKfm_og
moOolo?cong]kOoooooo[jn_okVi^Oo3`l?oc<c<om?CdooJf][ohN7QonOW
ioo/k>`1oo7al@00:?ono_h01Oo3`l?oRHV9ofUYJOmoOgood=3@01_oo_kn
00?ohN7QohB4Q?ogmoL06Oono_h00ooRh^;oQ8B4ooOgm`3oookno_ooo_kn
0Oono_h02onk^k_o`L71olS8b?o@d=3oemOGon3Ph?oVi^KokNg]oo7alOod
m?ComoOg00;omOGe00colO7aon[Zj_o^k^ko/[:bok^k^on`/;3oc<c<omGE
eOoKfm_obl_;onWYjOo]kNd1oo;blP001OoinOT00oojn_[onOWioo[jnP02
ooWin@03oo[jn_oinOWon_[j00SonOWi00?on_[jooWinOojn_X00_oinOT0
0oojn_[onOWioo[jnP08ooWin@09oo[jn_oinOWon_[johb<S?mjNW[oYZJV
ofUYJOlH61So^k^k00OonOWi00?on_[jooWinOojn_X00_oinOT00oojn_[o
nOWioo[jnP08ooWin@08oo[jn_oinOWon_[jooGemOlY:BWoYZJVooWinOoj
n_X8ooWin@03oo[jn_oinOWon_[j00;onOWi00?on_[jooWinOojn_X01ooi
nOT01?ofm_Ko:BTYojFUYOojn_X2ooWin@03oo[jn_oinOWon_[j00SonOWi
00?on_[jooWinOojn_X00_oinOT00oojn_[onOWioo[jnP08ooWin@03oo[j
n_oinOWon_[j00;onOWi00?on_[jooWinOojn_X02?oinOT00oojn_[onOWi
oo[jnP02ooWin@03oo[jn_oinOWon_[j00SonOWi00?on_[jooWinOojn_X0
0_oinOT00oojn_[onOWioo[jnP08ooWin@03oo[jn_oinOWon_[j00;onOWi
00?on_[jooWinOojn_X02?oinOT00oojn_[onOWioo[jnP02ooWin@03oo[j
n_oinOWon_[j00SonOWi00?on_[jooWinOojn_X00_oinOT00oojn_[onOWi
oo[jnP08ooWin@03oo[jn_oinOWon_[j00;onOWi00?on_[jooWinOojn_X0
2?oinOT00oojn_[onOWioo[jnP02ooWin@03oo[jn_oinOWon_[j00SonOWi
00?on_[jooWinOojn_X00_oinOT00oojn_[onOWioo[jnP08ooWin@03oo[j
n_oinOWon_[j00;onOWi00?on_[jooWinOojn_X02?oinOT00oojn_[onOWi
oo[jnP02ooWin@03oo[jn_oinOWon_[j00SonOWi00?on_[jooWinOojn_X0
0_oinOT00oojn_[onOWioo[jnP08ooWin@03oo[jn_oinOWon_[j00;onOWi
00?on_[jooWinOojn_X02?oinOT00oojn_[onOWioo[jnP02ooWin@03oo[j
n_oinOWon_[j00SonOWi00?on_[jooWinOojn_X00_oinOT00oojn_[onOWi
oo[jnP08ooWin@03oo[jn_oinOWon_[j00;onOWi00?on_[jooWinOojn_X0
2?oinOT00oojn_[onOWioo[jnP02ooWin@03oo[jn_oinOWon_[j00SonOWi
00?on_[jooWinOojn_X00_oinOT00oojn_[onOWioo[jnP08ooWin@03oo[j
n_oinOWon_[j00;onOWi00?on_[jooWinOojn_X02?oinOT00oojn_[onOWi
oo[jnP02ooWin@03oo[jn_oinOWon_[j00SonOWi00?on_[jooWinOojn_X0
0_oinOT00oojn_[onOWioo[jnP08ooWin@03oo[jn_oinOWon_[j00;onOWi
00?on_[jooWinOojn_X02?oinOT00oojn_[onOWioo[jnP02ooWin@03oo[j
n_oinOWon_[j00SonOWi00?on_[jooWinOojn_X00_oinOT00oojn_[onOWi
oo[jnP08ooWin@03oo[jn_oinOWon_[j00;onOWi00?on_[jooWinOojn_X0
2?oinOT00oojn_[onOWioo[jnP02ooWin@03oo[jn_oinOWon_[j00SonOWi
00?on_[jooWinOojn_X00_oinOT00oojn_[onOWioo[jnP08ooWin@03oo[j
n_oinOWon_[j00;onOWi00?on_[jooWinOojn_X02?oinOT00oojn_[onOWi
oo[jnP02ooWin@03oo[jn_oinOWon_[j00SonOWi00?on_[jooWinOojn_X0
0_oinOT00oojn_[onOWioo[jnP08ooWin@0<oo[jn_nk^k_o_knoolO7aoo>
c/koe]KFomgMgOoShn?ojNWYonk^k_obl_;olo?c0_obl_803?o]kNgohn?S
onKVi_ne]KGoXj>Sofe]KOnj^[[oemOGokfm_OmnOWkodM7Aonk^kP7ol_;b
000RooknoP05onc/k?olo?coo_knooCdm?oclo<01Oono_h00omRHV;oD51@
ooknoP0>ooknoP05onc/k?olo?coo_knoo?cloodm?@01oono_h00onATI7o
B4Q8ooknoP0BooknoP03onc/k?olo?coo_kn00;om?Cd0_ono_h00onATI7o
B4Q8ooknoP08ooknoP03onSXj?oDe=Coo?cl0?ooo_knm?ono_h02_nh^;So
_[jnolK6a_o<c<cod];BomWIfOoOgmooi>CTon[Zj_o^k^h2oo3`l00=onk^
k_oZj^[oh^;RonSXj?nUYJGo`<30ojb/[?mdM7Co`/;2omoOgoo3`l?oPH61
omOGe`01oo?cl`0000?on_[jooWinOoinOT00_oinOT00oojn_[onOWioo[j
nP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jocdm?OmjNWX00_oi
nOT06Om9BDWoPh>3oo[jn_oinOWoOWinod];Boojn_[onOWiokBd]?lF5QKo
nOWioo[jn_mHF5So51@DobDU9OnMWIgo7alOoeiNG_ojn_[ohn?Sof=SHom2
@T;oOWinoijNW_lY:BT00_oinOT07?m8B4SoPh>3ooWinOoinOWoB4Q8oh>3
PooinOWon_[jojBTY?lW9bOonOWioo[jn_mHF5So5ADEobHV9_nMWIgo7alO
oeiNG_oinOWoB4Q8oh>3Poojn_[onOWioo[jn_oinOWoU9BDo`h>3_oDe=@4
ooWin@04oo[jn_oinOWonOWioclo?`;o3Ph>00go5ADEocXj>_mgMgOok^k^
ooWinOojn_[onOWioeQHF?lE5AGo9BDUoifMWOlO7aooGEeM00;onOWi00?o
UIFEo`h>3_oDe=@00ooinOT03Oojn_[onOWiooWinOoinOWoGEeMoadM7Om0
@43o92@TofYZJ_o]kNgon_[jooWinOojn_X00ooinOT00oojn_[onOWiooWi
n@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWinOojn_X00ooi
nOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?o
n_[jooWinOojn_X00ooinOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oi
nOWonOWi00;onOWi00?on_[jooWinOojn_X00ooinOT00oojn_[onOWiooWi
n@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWinOojn_X00ooi
nOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?o
n_[jooWinOojn_X00ooinOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oi
nOWonOWi00;onOWi00?on_[jooWinOojn_X00ooinOT00oojn_[onOWiooWi
n@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWinOojn_X00ooi
nOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?o
n_[jooWinOojn_X00ooinOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oi
nOWonOWi00;onOWi00?on_[jooWinOojn_X00ooinOT00oojn_[onOWiooWi
n@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWinOojn_X00ooi
nOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?o
n_[jooWinOojn_X00ooinOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oi
nOWonOWi00;onOWi00?on_[jooWinOojn_X00ooinOT00oojn_[onOWiooWi
n@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWinOojn_X00ooi
nOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?o
n_[jooWinOojn_X00ooinOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oi
nOWonOWi00;onOWi00?on_[jooWinOojn_X00ooinOT00oojn_[onOWiooWi
n@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWinOojn_X00ooi
nOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?o
n_[jooWinOojn_X00ooinOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oi
nOWonOWi00;onOWi00?on_[jooWinOojn_X00ooinOT00oojn_[onOWiooWi
n@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWinOojn_X00ooi
nOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?o
n_[jooWinOojn_X00ooinOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oi
nOWonOWi00;onOWi00?on_[jooWinOojn_X00ooinOT00oojn_[onOWiooWi
n@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWinOojn_X00ooi
nOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?o
n_[jooWinOojn_X00ooinOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oi
nOWonOWi00;onOWi00?on_[jooWinOojn_X00ooinOT00oojn_[onOWiooWi
n@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWinOojn_X00ooi
nOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?o
n_[jooWinOojn_X00ooinOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oi
nOWonOWi00;onOWi00?on_[jooWinOojn_X00ooinOT00oojn_[onOWiooWi
n@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWinOojn_X00ooi
nOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oinOWonOWi00;onOWi00?o
n_[jooWinOojn_X00ooinOT00oojn_[onOWiooWin@02ooWin@03oo[jn_oi
nOWonOWi00;onOWi00?on_[jooWinOojn_X00ooinOT00oojn_[onOWiooWi
n@02ooWin@03oo[jn_oinOWonOWi00;onOWi01[on_[jokNg]onk^k_oa<C4
olW9bOoAdM7oemOGomcLg?oQhN7oi^KVonWYjOoZj^[ojNWYonSXj?oShn?o
gmoOoogmoOmXJ6So/K6aolc<c?nd];CoNGUiol[:b_oVi^KobLW9oo3`l07o
lo?c00000oo[jn_ok>c/on_[j`09on_[j`03onc/k?o[jn_ojn_[00;ojn_[
00Ko>c/kog=cLoo[jn_ojn_[odA4A?mlO7`2on_[j`0=ogQhN?m7AdOojn_[
onc/k?nYZJWo5ADEon_[joni^KWo4A4Aolg=cOoEeMGoG5aLoa`L7002on_[
j`06oe1@D?lf=SKoVYZJogUiNOle=CGo7alO0_o[jn/01_m4A4CoO7alon_[
joo[jn_oA4A4ogalO0;ojn_[00goVi^KobHV9_o[jn_o^KVioa4A4Oo=cLgo
e=CDoeaLG?lL71cok>c/on_[jom5ADGoO7al00Cojn_[00Co=cLgoaDE5Om`
L73ok>c/1?o[jn/04Oo/k>cojn_[oc`l??mbLW;ojn_[on7QhOno_kooBDU9
ob/[:ooNg]kojn_[okZj^_lA4A7ocLg=omCDe?mLG5co7AdM00?ojn_[00?o
=SHfoaDE5Om`L7001?o[jn/02Oo/k>cojn_[on_[jooDe=CojNWYonc/k?oD
e=Co6ATIog9bLP07on_[j`03onc/k?o[jn_ojn_[00;ojn_[00?ok>c/on_[
joo[jn/02?o[jn/00oo/k>cojn_[on_[j`02on_[j`03onc/k?o[jn_ojn_[
00Sojn_[00?ok>c/on_[joo[jn/00_o[jn/00oo/k>cojn_[on_[j`08on_[
j`03onc/k?o[jn_ojn_[00;ojn_[00?ok>c/on_[joo[jn/02?o[jn/00oo/
k>cojn_[on_[j`02on_[j`03onc/k?o[jn_ojn_[00Sojn_[00?ok>c/on_[
joo[jn/00_o[jn/00oo/k>cojn_[on_[j`08on_[j`03onc/k?o[jn_ojn_[
00;ojn_[00?ok>c/on_[joo[jn/02?o[jn/00oo/k>cojn_[on_[j`02on_[
j`03onc/k?o[jn_ojn_[00Sojn_[00?ok>c/on_[joo[jn/00_o[jn/00oo/
k>cojn_[on_[j`08on_[j`03onc/k?o[jn_ojn_[00;ojn_[00?ok>c/on_[
joo[jn/02?o[jn/00oo/k>cojn_[on_[j`02on_[j`03onc/k?o[jn_ojn_[
00Sojn_[00?ok>c/on_[joo[jn/00_o[jn/00oo/k>cojn_[on_[j`08on_[
j`03onc/k?o[jn_ojn_[00;ojn_[00?ok>c/on_[joo[jn/02?o[jn/00oo/
k>cojn_[on_[j`02on_[j`03onc/k?o[jn_ojn_[00Sojn_[00?ok>c/on_[
joo[jn/00_o[jn/00oo/k>cojn_[on_[j`08on_[j`03onc/k?o[jn_ojn_[
00;ojn_[00?ok>c/on_[joo[jn/02?o[jn/00oo/k>cojn_[on_[j`02on_[
j`03onc/k?o[jn_ojn_[00Sojn_[00?ok>c/on_[joo[jn/00_o[jn/00oo/
k>cojn_[on_[j`08on_[j`03onc/k?o[jn_ojn_[00;ojn_[00?ok>c/on_[
joo[jn/02?o[jn/00oo/k>cojn_[on_[j`02on_[j`03onc/k?o[jn_ojn_[
00Sojn_[00?ok>c/on_[joo[jn/00_o[jn/00oo/k>cojn_[on_[j`08on_[
j`03onc/k?o[jn_ojn_[00;ojn_[00?ok>c/on_[joo[jn/02?o[jn/00oo/
k>cojn_[on_[j`02on_[j`03onc/k?o[jn_ojn_[00Sojn_[00?ok>c/on_[
joo[jn/00_o[jn/00oo/k>cojn_[on_[j`08on_[j`03onc/k?o[jn_ojn_[
00;ojn_[00?ok>c/on_[joo[jn/02?o[jn/00oo/k>cojn_[on_[j`02on_[
j`03onc/k?o[jn_ojn_[00Sojn_[00?ok>c/on_[joo[jn/00_o[jn/00oo/
k>cojn_[on_[j`08on_[j`03onc/k?o[jn_ojn_[00;ojn_[00?ok>c/on_[
joo[jn/02?o[jn/00oo/k>cojn_[on_[j`02on_[j`03onc/k?o[jn_ojn_[
00Sojn_[00?ok>c/on_[joo[jn/00_o[jn/00oo/k>cojn_[on_[j`08on_[
j`03onc/k?o[jn_ojn_[00;ojn_[00?ok>c/on_[joo[jn/00_o[jn/03Onh
^;So^KViol30`?o5aLGobl_;om7AdOoHf=Sofm_Kon3Ph?oShn?oh^;Ron?S
hooPh>000_oJf]X02_o_knooY:BTofm_Konk^k_oemOGokfm_OmmOGgod=3@
onc/k?o`l?01oo?cl`000_oinOT01?ojn_[onOWioo[jn_oinOT2oo[jnP04
ooWinOojn_[onOWioo[jnP;onOWi02Son_[jooWinOoinOWo?Cdmog]kNooi
nOWon_[jodQ8B?n3Ph?on_[jooWinOmnOWkoBd];oo[jn_oinOWo];BdoaHF
5_oinOWoe]KFoa0@4?nl_;conOWioj2PX?l[:b_on_[joo7alOlE5AGo^KVi
ooWinOojn_[oV9RHoadM7Oojn_[onOWiodQ8B?n3Ph?on_[jooWinOm9BDWo
Ph>30_ojn_X03_nSXj?o:2PXooWinOoFe]Ko410@okbl_?ojn_[oX:2Pob/[
:ooinOWon_[jodQ8B?n3Ph?onOWi0_ojn_X01oo:b/[o3Ph>oj2PX?lO7aoo
l_;booWinOojn_X00ooinOT01?ojn_[o?cloogUiNOoinOT2oo[jnP0DooCd
m?l[:b_oMWIfoo[jn_oEeMGo410@okbl_?oinOWoX:2Pob/[:oojn_[onOWi
ol_;bol>3PkoX:2PoalO7oobl_;on_[jooWinOojn_X2ooWin@08oo[jn_oi
nOWonOWiooWinOojn_[oGemOoda<C?oinOT2oo[jnP04ooWinOojn_[onOWi
oo[jnP;onOWi00Son_[jooWinOoinOWonOWioo[jn_oinOWon_[jooWin@;o
n_[j00ConOWioo[jn_oinOWon_[j0_oinOT02?ojn_[onOWiooWinOoinOWo
n_[jooWinOojn_[onOWi0_ojn_X01?oinOWon_[jooWinOojn_X2ooWin@08
oo[jn_oinOWonOWiooWinOojn_[onOWioo[jn_oinOT2oo[jnP04ooWinOoj
n_[onOWioo[jnP;onOWi00Son_[jooWinOoinOWonOWioo[jn_oinOWon_[j
ooWin@;on_[j00ConOWioo[jn_oinOWon_[j0_oinOT02?ojn_[onOWiooWi
nOoinOWon_[jooWinOojn_[onOWi0_ojn_X01?oinOWon_[jooWinOojn_X2
ooWin@08oo[jn_oinOWonOWiooWinOojn_[onOWioo[jn_oinOT2oo[jnP04
ooWinOojn_[onOWioo[jnP;onOWi00Son_[jooWinOoinOWonOWioo[jn_oi
nOWon_[jooWin@;on_[j00ConOWioo[jn_oinOWon_[j0_oinOT02?ojn_[o
nOWiooWinOoinOWon_[jooWinOojn_[onOWi0_ojn_X01?oinOWon_[jooWi
nOojn_X2ooWin@08oo[jn_oinOWonOWiooWinOojn_[onOWioo[jn_oinOT2
oo[jnP04ooWinOojn_[onOWioo[jnP;onOWi00Son_[jooWinOoinOWonOWi
oo[jn_oinOWon_[jooWin@;on_[j00ConOWioo[jn_oinOWon_[j0_oinOT0
2?ojn_[onOWiooWinOoinOWon_[jooWinOojn_[onOWi0_ojn_X01?oinOWo
n_[jooWinOojn_X2ooWin@08oo[jn_oinOWonOWiooWinOojn_[onOWioo[j
n_oinOT2oo[jnP04ooWinOojn_[onOWioo[jnP;onOWi00Son_[jooWinOoi
nOWonOWioo[jn_oinOWon_[jooWin@;on_[j00ConOWioo[jn_oinOWon_[j
0_oinOT02?ojn_[onOWiooWinOoinOWon_[jooWinOojn_[onOWi0_ojn_X0
1?oinOWon_[jooWinOojn_X2ooWin@08oo[jn_oinOWonOWiooWinOojn_[o
nOWioo[jn_oinOT2oo[jnP04ooWinOojn_[onOWioo[jnP;onOWi00Son_[j
ooWinOoinOWonOWioo[jn_oinOWon_[jooWin@;on_[j00ConOWioo[jn_oi
nOWon_[j0_oinOT02?ojn_[onOWiooWinOoinOWon_[jooWinOojn_[onOWi
0_ojn_X01?oinOWon_[jooWinOojn_X2ooWin@08oo[jn_oinOWonOWiooWi
nOojn_[onOWioo[jn_oinOT2oo[jnP04ooWinOojn_[onOWioo[jnP;onOWi
00Son_[jooWinOoinOWonOWioo[jn_oinOWon_[jooWin@;on_[j00ConOWi
oo[jn_oinOWon_[j0_oinOT02?ojn_[onOWiooWinOoinOWon_[jooWinOoj
n_[onOWi0_ojn_X01?oinOWon_[jooWinOojn_X2ooWin@08oo[jn_oinOWo
nOWiooWinOojn_[onOWioo[jn_oinOT2oo[jnP04ooWinOojn_[onOWioo[j
nP;onOWi00Son_[jooWinOoinOWonOWioo[jn_oinOWon_[jooWin@;on_[j
00ConOWioo[jn_oinOWon_[j0_oinOT02?ojn_[onOWiooWinOoinOWon_[j
ooWinOojn_[onOWi0_ojn_X01?oinOWon_[jooWinOojn_X2ooWin@08oo[j
n_oinOWonOWiooWinOojn_[onOWioo[jn_oinOT2oo[jnP04ooWinOojn_[o
nOWioo[jnP;onOWi00Son_[jooWinOoinOWonOWioo[jn_oinOWon_[jooWi
n@;on_[j00ConOWioo[jn_oinOWon_[j0_oinOT02?ojn_[onOWiooWinOoi
nOWon_[jooWinOojn_[onOWi0_ojn_X01?oinOWon_[jooWinOojn_X2ooWi
n@08oo[jn_oinOWonOWiooWinOojn_[onOWioo[jn_oinOT2oo[jnP04ooWi
nOojn_[onOWioo[jnP;onOWi00Son_[jooWinOoinOWonOWioo[jn_oinOWo
n_[jooWin@;on_[j00ConOWioo[jn_oinOWon_[j0_oinOT02?ojn_[onOWi
ooWinOoinOWon_[jooWinOojn_[onOWi0_ojn_X01?oinOWon_[jooWinOoj
n_X2ooWin@08oo[jn_oinOWonOWiooWinOojn_[onOWioo[jn_oinOT2oo[j
nP04ooWinOojn_[onOWioo[jnP;onOWi027on_[jooWinOoinOWonOWioo[j
n_oinOWon_[jooWinOnl_;co/k>cokVi^Oo1`L7obLW9olk>c_oBd];of=SH
om[Jf_oLg=cof][JomSHf?oEeMGoa/K6on3Ph?oWinOoa/K6ojn_[omeMGGo
`l?3omoOgoo4a<CoPH61omKFe_obl_800Oofm_H0017oo_kn00Ko?cloogem
OOono_koo_knodY:B_n5QHD2ooknoP06oh61POm=CDgoo_knookno_ng]kOo
5QHF0_ono_h02Ona/K7o?Cdmochn?_m1@D7o;2`/ookno_o4a<Co3Ph>onKV
iP02ooknoP06ok2`/?lN7Qkoo_knookno_m:BT[oQXJ60_ono_h01_m:BT[o
QHF5ookno_ono_koZ:RXobPX:0;oo_kn00Go/K6aocdm?Oln?Sko@D51ob`/
;002ooknoP03odY:B_n5QHGoo_kn00;oo_kn00GoLG5aod];Boono_ko<c<c
ojRXZ006ooknoP03od51@OmkNg_oo_kn00?oo_kn00WoPh>3obh^;_ono_ko
o_knok6a/Olm?Cgo?Shnod10@?l/;2`00_ono_h01OmaLG7oBd];ookno_lc
<c?oZJVY00Woo_kn00?om?Cdob0P8?n;Rh/0ooono_kbooknoP0Iokno_onZ
ZZ[o[jn_okZj^_o4a<CoalO7olc<c?o@d=3odm?Com;Bd_o@d=3obLW9ol30
`?o7alOok^k^ono_koo:b/[odM7AokRh^?mjNW[obl_;onKVi_o;bl_oQ8B4
om[JfP01ooKfmP000ooinOT2oo[jnP03ooWinOojn_[onOWi00;onOWi00?o
n_[jooWinOojn_X00_oinOT01?ojn_[onOWiocdm?OmjNWX2oo[jnP0;odQ8
B?mbLW;onOWiooWinOmmOGgo?CdmooShn?ojn_[o/[:boaHF5_ojn_X00ooi
nOT07_ohn?SoUiNGob`/;?ojn_[oe]KFo`d=3One]KGon_[jooWinOn/[:co
7AdMooWinOojn_[oB4Q8oh>3PooinOWon_[jodU9BOmTI6Con_[jooWinOnM
WIgo:2PXoo[jn_oinOWon_[jooWinOogmoOoUiNGob`/;0;onOWi00[oB4Q8
ofm_KooinOWon_[joo7alOlK6a_oXj>Soo[jn_nCTi?oAdM70_oinOT02?oj
n_[onOWiooWinOoinOWo?cloogUiNOoinOWon_[j0_oinOT01?nOWioo410@
oo?cloojn_X2ooWin@0>ooShn?nFUYKo;2`/ooWinOoalO7o71`Loj>SXooj
n_[oTi>CodI6A_oinOWon_[jooWinOojn_X2ooWin@08oo[jn_nRXZ;oIFEU
obl_;om_Kfooj^[ZooWinOojn_X3ooWin@03oo[jn_oinOWon_[j00;onOWi
00Con_[jooWinOoinOWonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@03
oo[jn_oinOWon_[j00;onOWi00Con_[jooWinOoinOWonOWi0_ojn_X00ooi
nOWon_[jooWin@02ooWin@03oo[jn_oinOWon_[j00;onOWi00Con_[jooWi
nOoinOWonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@03oo[jn_oinOWo
n_[j00;onOWi00Con_[jooWinOoinOWonOWi0_ojn_X00ooinOWon_[jooWi
n@02ooWin@03oo[jn_oinOWon_[j00;onOWi00Con_[jooWinOoinOWonOWi
0_ojn_X00ooinOWon_[jooWin@02ooWin@03oo[jn_oinOWon_[j00;onOWi
00Con_[jooWinOoinOWonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@03
oo[jn_oinOWon_[j00;onOWi00Con_[jooWinOoinOWonOWi0_ojn_X00ooi
nOWon_[jooWin@02ooWin@03oo[jn_oinOWon_[j00;onOWi00Con_[jooWi
nOoinOWonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@03oo[jn_oinOWo
n_[j00;onOWi00Con_[jooWinOoinOWonOWi0_ojn_X00ooinOWon_[jooWi
n@02ooWin@03oo[jn_oinOWon_[j00;onOWi00Con_[jooWinOoinOWonOWi
0_ojn_X00ooinOWon_[jooWin@02ooWin@03oo[jn_oinOWon_[j00;onOWi
00Con_[jooWinOoinOWonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@03
oo[jn_oinOWon_[j00;onOWi00Con_[jooWinOoinOWonOWi0_ojn_X00ooi
nOWon_[jooWin@02ooWin@03oo[jn_oinOWon_[j00;onOWi00Con_[jooWi
nOoinOWonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@03oo[jn_oinOWo
n_[j00;onOWi00Con_[jooWinOoinOWonOWi0_ojn_X00ooinOWon_[jooWi
n@02ooWin@03oo[jn_oinOWon_[j00;onOWi00Con_[jooWinOoinOWonOWi
0_ojn_X00ooinOWon_[jooWin@02ooWin@03oo[jn_oinOWon_[j00;onOWi
00Con_[jooWinOoinOWonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@03
oo[jn_oinOWon_[j00;onOWi00Con_[jooWinOoinOWonOWi0_ojn_X00ooi
nOWon_[jooWin@02ooWin@03oo[jn_oinOWon_[j00;onOWi00Con_[jooWi
nOoinOWonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@03oo[jn_oinOWo
n_[j00;onOWi00Con_[jooWinOoinOWonOWi0_ojn_X00ooinOWon_[jooWi
n@02ooWin@03oo[jn_oinOWon_[j00;onOWi00Con_[jooWinOoinOWonOWi
0_ojn_X00ooinOWon_[jooWin@02ooWin@03oo[jn_oinOWon_[j00;onOWi
00Con_[jooWinOoinOWonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@03
oo[jn_oinOWon_[j00;onOWi00Con_[jooWinOoinOWonOWi0_ojn_X00ooi
nOWon_[jooWin@02ooWin@03oo[jn_oinOWon_[j00;onOWi00Con_[jooWi
nOoinOWonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@03oo[jn_oinOWo
n_[j00;onOWi00Con_[jooWinOoinOWonOWi0_ojn_X00ooinOWon_[jooWi
n@02ooWin@03oo[jn_oinOWon_[j00;onOWi00Con_[jooWinOoinOWonOWi
0_ojn_X00ooinOWon_[jooWin@02ooWin@03oo[jn_oinOWon_[j00;onOWi
00Con_[jooWinOoinOWonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@03
oo[jn_oinOWon_[j00;onOWi00Con_[jooWinOoinOWonOWi0_ojn_X00ooi
nOWon_[jooWin@02ooWin@03oo[jn_oinOWon_[j00;onOWi00Con_[jooWi
nOoinOWonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@03oo[jn_oinOWo
n_[j00;onOWi00Con_[jooWinOoinOWonOWi0_ojn_X00ooinOWon_[jooWi
n@02ooWin@03oo[jn_oinOWon_[j00;onOWi00Con_[jooWinOoinOWonOWi
0_ojn_X00ooinOWon_[jooWin@02ooWin@03oo[jn_oinOWon_[j00;onOWi
00Con_[jooWinOoinOWonOWi0_ojn_X02?oinOWo_[jnol;2`_nTY:CoZJVY
ok>c/onm_Kgo`L710_o5aLD04?no_koo^KViok2`/?ne]KGoi^KVoo3`l?oo
ooood=3@omGEeOoKfm_o_knoogmoOooAdM7okNg]olo?coodm?@1ooOgm`00
4Oo[jn/03_lk>c_oM7Adon_[joo[jn_oA4A4ob0P8?n8R8SoemOGodA4A?lX
:2SoHF5Qom7AdOm`L73o>SXj0_o[jn/01OnZZZ[ob/[:onSXj?mRHV;oEUIF
00;ojn_[00Ko@D51odY:B_oAdM7ogmoOoeQHF?lL71`2on_[j`0:odE5AOml
O7cojn_[on_[jom4A4Co7QhNog=cLoo>c/koFEUIoe1@D0;ojn_[00GoZJVY
ol_;booXj>SoHF5QoeMGE`02on_[j`0;odA4A?lN7QkoRh^;om?CdonJVY[o
6QXJon7QhOo[jn_og=cLoaDE5Oo9bLT01Oo[jn/00oll?3coLW9bon_[j`03
on_[j`0AohZ:R_lA4A7oj>SXon_[jonZZZ[ob/[:onSXj?mRHV;oEeMGon_[
jonKVi_o6ATIon7QhOo[jn_og=cLoaHF5_o8b<P01_o[jn/01?nMWIgoHV9R
oclo?on[Zj_oon_[jo?ojn_[00Ko_Kfmom?Cdoo8b<SoWinOoi^KVonVYZH3
ojb/[00@ojFUYOnLW9co/;2`onCTi?ojn_[ol?3`onk^k_oDe=Cof][JomoO
gooShn?ob<S8oh>3PooFe]Kolo?cooGem@7omoOg00001Oojn_[onOWioo[j
n_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j1?oinOT05_ojn_[o
?Cdmog]kNooinOWon_[joe]KFon>SXkoMGEeoadM7Olc<c?od];BoibLW?lV
9RKo:b/[ojf][OoinOWon_[johf=SOll?3co71`Lod92@_o3`l<2ooWin@06
omoOgom<C4co61PHoc@d=?mjNW[o=CDe0_oinOT06OmKFe_oT92@oo[jn_oi
nOWoG5aLohn?SommOGgo7alOocTi>Oo3`l?onOWioo[jn_n=SHgo?3`loa`L
7?m1@D7o`l?3ooWinOojn_[oFe]Kohf=SOmTI6Co5ADEoe]KFomfMWH00_oi
nOT00oojn_[oLG5aohR8R002ooWin@05oo[jn_oinOWon_[joclo?omiNGT0
0ooinOT03Oojn_[oFEUIocLg=oojn_[onOWiohf=SOll?3co71`Lod92@_o2
`/;on_[jof5QHOmfMWH00ooinOT01?maLG7oR8R8ooWinOojn_X4ooWin@05
oo[jn_oinOWofMWIoa0@4?oDe=@00ooinOT01?ojn_[onOWiooWinOojn_X4
ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWi
nOojn_X4ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT01?ojn_[o
nOWiooWinOojn_X4ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT0
1?ojn_[onOWiooWinOojn_X4ooWin@05oo[jn_oinOWon_[jooWinOojn_X0
0ooinOT01?ojn_[onOWiooWinOojn_X4ooWin@05oo[jn_oinOWon_[jooWi
nOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X4ooWin@05oo[jn_oinOWo
n_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X4ooWin@05oo[j
n_oinOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X4ooWi
n@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWinOoj
n_X4ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWi
ooWinOojn_X4ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT01?oj
n_[onOWiooWinOojn_X4ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooi
nOT01?ojn_[onOWiooWinOojn_X4ooWin@05oo[jn_oinOWon_[jooWinOoj
n_X00ooinOT01?ojn_[onOWiooWinOojn_X4ooWin@05oo[jn_oinOWon_[j
ooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X4ooWin@05oo[jn_oi
nOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X4ooWin@05
oo[jn_oinOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X4
ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWi
nOojn_X4ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT01?ojn_[o
nOWiooWinOojn_X4ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT0
1?ojn_[onOWiooWinOojn_X4ooWin@05oo[jn_oinOWon_[jooWinOojn_X0
0ooinOT01?ojn_[onOWiooWinOojn_X4ooWin@05oo[jn_oinOWon_[jooWi
nOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X4ooWin@05oo[jn_oinOWo
n_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X4ooWin@05oo[j
n_oinOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X4ooWi
n@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWinOoj
n_X4ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWi
ooWinOojn_X4ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT01?oj
n_[onOWiooWinOojn_X4ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooi
nOT01?ojn_[onOWiooWinOojn_X4ooWin@05oo[jn_oinOWon_[jooWinOoj
n_X00ooinOT01?ojn_[onOWiooWinOojn_X4ooWin@05oo[jn_oinOWon_[j
ooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X4ooWin@05oo[jn_oi
nOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X4ooWin@05
oo[jn_oinOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X4
ooWin@0Ooo[jn_oinOWon_[jooWinOojn_[onOWiokno_ooDe=Cokno_omCD
e?n][JgoX:2PoiNGUon?ShooV9RHojVYZOo7alOolO7aookno_ojn_[ol?3`
onSXj?oJf][og]kNon?ShooWinOoj^[Zolk>c_n6QXKofm_KooKfmP01ooSh
n0004Oono_h00olo?cooOGemooknoP04ooknoP03oogmoOono_koo_kn00;o
o_kn00?ooOgmookno_ono_h00oono_h00oolo?coo_knooknoP04ooknoP03
ooclo?ono_koo_kn00[oo_kn00?ooOgmookno_ono_h01?ono_h00oolo?co
o_knooknoP05ooknoP03oo_knoono_koo_kn00[oo_kn00?o@D51og]kNoon
o_h00_ono_h00onTY:Co3`l?ojFUY@04ooknoP03ooclo?ono_koo_kn013o
o_kn00?ooOgmobPX:?nSXj<0ooono_kbooknoP0Iokfm_OoBd];ol_;boo;b
l_oNg]koe=CDom[Jf_oQhN7oj>SXong]kOodm?ConOWiookno_ojn_[ol?3`
onk^k_oOgmooh^;RonKVi_oZj^[ok^k^oo3`l?oBd];oQhN7omoOg`01ooWi
n@0000?onOWioo[jn_ojn_X00_oinOT01?ojn_[onOWioo[jn_oinOT2oo[j
nP08ooWinOojn_[onOWiooWinOojn_[onOWiocdm?OmkNg/2ooWin@04oo[j
n_oinOWon_[jooWin@;on_[j00KonOWioo[jn_oinOWonOWioo[jn_oinOT2
oo[jnP;onOWi00Con_[jooWinOojn_[onOWi0_ojn_X02?oinOWon_[jooWi
nOoinOWon_[jof9RH_nEUIGon_[j0_oinOT01?ojn_[onOWioo[jn_oinOT2
oo[jnP06ooWinOojn_[onOWiooWinOojn_[onOWi0_ojn_X2ooWin@04oo[j
n_oinOWon_[jooWin@;on_[j00KonOWioo[jn_oinOWonOWioo[jn_oinOT2
oo[jnP07oclo?olh>3SoJVYZoeIFE_lh>3So4a<Coi:BTP02ooWin@05oo[j
n_oinOWonOWioo[jn_oinOT00_ojn_X2ooWin@04oo[jn_oinOWon_[jooWi
n@;on_[j00konOWioo[jn_oinOWonOWioiJFU_mbLW;oX:2PofMWIolJ6Q[o
jn_[oo[jn_oinOWon_[jooWin@;on_[j00KonOWioo[jn_oinOWonOWioo[j
n_oinOT2oo[jnP;onOWi00Con_[jooWinOojn_[onOWi0_ojn_X01_oinOWo
n_[jooWinOoinOWon_[jooWin@;on_[j0_oinOT01?ojn_[onOWioo[jn_oi
nOT2oo[jnP06ooWinOojn_[onOWiooWinOojn_[onOWi0_ojn_X2ooWin@04
oo[jn_oinOWon_[jooWin@;on_[j00KonOWioo[jn_oinOWonOWioo[jn_oi
nOT2oo[jnP;onOWi00Con_[jooWinOojn_[onOWi0_ojn_X01_oinOWon_[j
ooWinOoinOWon_[jooWin@;on_[j0_oinOT01?ojn_[onOWioo[jn_oinOT2
oo[jnP06ooWinOojn_[onOWiooWinOojn_[onOWi0_ojn_X2ooWin@04oo[j
n_oinOWon_[jooWin@;on_[j00KonOWioo[jn_oinOWonOWioo[jn_oinOT2
oo[jnP;onOWi00Con_[jooWinOojn_[onOWi0_ojn_X01_oinOWon_[jooWi
nOoinOWon_[jooWin@;on_[j0_oinOT01?ojn_[onOWioo[jn_oinOT2oo[j
nP06ooWinOojn_[onOWiooWinOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oi
nOWon_[jooWin@;on_[j00KonOWioo[jn_oinOWonOWioo[jn_oinOT2oo[j
nP;onOWi00Con_[jooWinOojn_[onOWi0_ojn_X01_oinOWon_[jooWinOoi
nOWon_[jooWin@;on_[j0_oinOT01?ojn_[onOWioo[jn_oinOT2oo[jnP06
ooWinOojn_[onOWiooWinOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oinOWo
n_[jooWin@;on_[j00KonOWioo[jn_oinOWonOWioo[jn_oinOT2oo[jnP;o
nOWi00Con_[jooWinOojn_[onOWi0_ojn_X01_oinOWon_[jooWinOoinOWo
n_[jooWin@;on_[j0_oinOT01?ojn_[onOWioo[jn_oinOT2oo[jnP06ooWi
nOojn_[onOWiooWinOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oinOWon_[j
ooWin@;on_[j00KonOWioo[jn_oinOWonOWioo[jn_oinOT2oo[jnP;onOWi
00Con_[jooWinOojn_[onOWi0_ojn_X01_oinOWon_[jooWinOoinOWon_[j
ooWin@;on_[j0_oinOT01?ojn_[onOWioo[jn_oinOT2oo[jnP06ooWinOoj
n_[onOWiooWinOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oinOWon_[jooWi
n@;on_[j00KonOWioo[jn_oinOWonOWioo[jn_oinOT2oo[jnP;onOWi00Co
n_[jooWinOojn_[onOWi0_ojn_X01_oinOWon_[jooWinOoinOWon_[jooWi
n@;on_[j0_oinOT01?ojn_[onOWioo[jn_oinOT2oo[jnP06ooWinOojn_[o
nOWiooWinOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oinOWon_[jooWin@;o
n_[j00KonOWioo[jn_oinOWonOWioo[jn_oinOT2oo[jnP;onOWi00Con_[j
ooWinOojn_[onOWi0_ojn_X01_oinOWon_[jooWinOoinOWon_[jooWin@;o
n_[j0_oinOT01?ojn_[onOWioo[jn_oinOT2oo[jnP06ooWinOojn_[onOWi
ooWinOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oinOWon_[jooWin@;on_[j
00KonOWioo[jn_oinOWonOWioo[jn_oinOT2oo[jnP;onOWi00Con_[jooWi
nOojn_[onOWi0_ojn_X01_oinOWon_[jooWinOoinOWon_[jooWin@;on_[j
0_oinOT01?ojn_[onOWioo[jn_oinOT2oo[jnP06ooWinOojn_[onOWiooWi
nOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oinOWon_[jooWin@;on_[j00Ko
nOWioo[jn_oinOWonOWioo[jn_oinOT2oo[jnP;onOWi00Con_[jooWinOoj
n_[onOWi0_ojn_X01_oinOWon_[jooWinOoinOWon_[jooWin@;on_[j0_oi
nOT01?ojn_[onOWioo[jn_oinOT2oo[jnP06ooWinOojn_[onOWiooWinOoj
n_[onOWi0_ojn_X2ooWin@04oo[jn_oinOWon_[jooWin@;on_[j00KonOWi
oo[jn_oinOWonOWioo[jn_oinOT2oo[jnP;onOWi01[on_[jokjn__oDe=Co
l_;booOgmoofm_Koj^[ZomgMgOoRh^;oj>SXonk^k_odm?ConOWiookno_oj
n_[okno_oooooooTi>Coj>SXon[Zj_o]kNgol?3`oo;bl_oemOGoeMGEooSh
n07ono_k0007on_[j`03onc/k?o[jn_ojn_[00Oojn_[00?oYJFUokbl_?o[
jn/00oo[jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[jn_ojn_[00Ko
jn_[00?oZJVYokno_oo[jn/01?o[jn/00oo/k>cojn_[on_[j`0=on_[j`03
onc/k?o[jn_ojn_[00Wojn_[00KoYZJVoi>CTonCTi?oVYZJokRh^?oIfMT>
on_[j`03onc/k?o[jn_ojn_[00Gojn_[00GoalO7ohZ:R_m[Jf_oTi>Com3@
d003on_[j`03onc/k?o[jn_ojn_[00gojn_[00?ok>c/on_[joo[jn/03Oo[
jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[jn_ojn_[00gojn_[00?o
k>c/on_[joo[jn/03Oo[jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[
jn_ojn_[00gojn_[00?ok>c/on_[joo[jn/03Oo[jn/00oo/k>cojn_[on_[
j`0=on_[j`03onc/k?o[jn_ojn_[00gojn_[00?ok>c/on_[joo[jn/03Oo[
jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[jn_ojn_[00gojn_[00?o
k>c/on_[joo[jn/03Oo[jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[
jn_ojn_[00gojn_[00?ok>c/on_[joo[jn/03Oo[jn/00oo/k>cojn_[on_[
j`0=on_[j`03onc/k?o[jn_ojn_[00gojn_[00?ok>c/on_[joo[jn/03Oo[
jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[jn_ojn_[00gojn_[00?o
k>c/on_[joo[jn/03Oo[jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[
jn_ojn_[00gojn_[00?ok>c/on_[joo[jn/03Oo[jn/00oo/k>cojn_[on_[
j`0=on_[j`03onc/k?o[jn_ojn_[00gojn_[00?ok>c/on_[joo[jn/03Oo[
jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[jn_ojn_[00cojn_[01Oo
_[jnomGEeOobl_;omoOgooShn?ogmoOojn_[on;Rh_oXj>Sokno_ooGemOoh
n?SooOgmoo[jn_o`l?3okno_onSXj?o[jn_ok^k^ono_koobl_;om?CdooKf
mP02ooWin@7ono_k0002ooWin@04oo[jn_oinOWonOWioo[jnP?onOWi00?o
n_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X2ooWin@07oo[j
n_oinOWonOWiooWinOojn_[onOWioo[jnP03ooWin@04oo[jn_oinOWonOWi
oo[jnP;onOWi00Oon_[jooWinOoinOWonOWioo[jn_oinOWon_[j00?onOWi
00Con_[jooWinOoinOWon_[j0_oinOT01oojn_[onOWiooWinOoinOWon_[j
ooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X2ooWin@07oo[jn_oi
nOWonOWiooWinOojn_[onOWioo[jnP03ooWin@04oo[jn_oinOWonOWioo[j
nP;onOWi00Oon_[jooWinOoinOWonOWioo[jn_oinOWon_[j00?onOWi00Co
n_[jooWinOoinOWon_[j0_oinOT01oojn_[onOWiooWinOoinOWon_[jooWi
nOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X2ooWin@07oo[jn_oinOWo
nOWiooWinOojn_[onOWioo[jnP03ooWin@04oo[jn_oinOWonOWioo[jnP;o
nOWi00Oon_[jooWinOoinOWonOWioo[jn_oinOWon_[j00?onOWi00Con_[j
ooWinOoinOWon_[j0_oinOT01oojn_[onOWiooWinOoinOWon_[jooWinOoj
n_X00ooinOT01?ojn_[onOWiooWinOojn_X2ooWin@07oo[jn_oinOWonOWi
ooWinOojn_[onOWioo[jnP03ooWin@04oo[jn_oinOWonOWioo[jnP;onOWi
00Oon_[jooWinOoinOWonOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWi
nOoinOWon_[j0_oinOT01oojn_[onOWiooWinOoinOWon_[jooWinOojn_X0
0ooinOT01?ojn_[onOWiooWinOojn_X2ooWin@07oo[jn_oinOWonOWiooWi
nOojn_[onOWioo[jnP03ooWin@04oo[jn_oinOWonOWioo[jnP;onOWi00Oo
n_[jooWinOoinOWonOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoi
nOWon_[j0_oinOT01oojn_[onOWiooWinOoinOWon_[jooWinOojn_X00ooi
nOT01?ojn_[onOWiooWinOojn_X2ooWin@07oo[jn_oinOWonOWiooWinOoj
n_[onOWioo[jnP03ooWin@04oo[jn_oinOWonOWioo[jnP;onOWi00Oon_[j
ooWinOoinOWonOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWo
n_[j0_oinOT01oojn_[onOWiooWinOoinOWon_[jooWinOojn_X00ooinOT0
1?ojn_[onOWiooWinOojn_X2ooWin@07oo[jn_oinOWonOWiooWinOojn_[o
nOWioo[jnP03ooWin@04oo[jn_oinOWonOWioo[jnP;onOWi00Oon_[jooWi
nOoinOWonOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j
0_oinOT01oojn_[onOWiooWinOoinOWon_[jooWinOojn_X00ooinOT01?oj
n_[onOWiooWinOojn_X2ooWin@07oo[jn_oinOWonOWiooWinOojn_[onOWi
oo[jnP03ooWin@04oo[jn_oinOWonOWioo[jnP;onOWi00Oon_[jooWinOoi
nOWonOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j0_oi
nOT01oojn_[onOWiooWinOoinOWon_[jooWinOojn_X00ooinOT01?ojn_[o
nOWiooWinOojn_X2ooWin@07oo[jn_oinOWonOWiooWinOojn_[onOWioo[j
nP03ooWin@04oo[jn_oinOWonOWioo[jnP;onOWi00Oon_[jooWinOoinOWo
nOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j0_oinOT0
1oojn_[onOWiooWinOoinOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWi
ooWinOojn_X2ooWin@07oo[jn_oinOWonOWiooWinOojn_[onOWioo[jnP03
ooWin@04oo[jn_oinOWonOWioo[jnP;onOWi00Oon_[jooWinOoinOWonOWi
oo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j0_oinOT01ooj
n_[onOWiooWinOoinOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWi
nOojn_X2ooWin@07oo[jn_oinOWonOWiooWinOojn_[onOWioo[jnP03ooWi
n@04oo[jn_oinOWonOWioo[jnP;onOWi00Oon_[jooWinOoinOWonOWioo[j
n_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j0_oinOT01oojn_[o
nOWiooWinOoinOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWinOoj
n_X2ooWin@07oo[jn_oinOWonOWiooWinOojn_[onOWioo[jnP03ooWin@04
oo[jn_oinOWonOWioo[jnP;onOWi00Oon_[jooWinOoinOWonOWioo[jn_oi
nOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j0_oinOT01oojn_[onOWi
ooWinOoinOWon_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X2
ooWin@07oo[jn_oinOWonOWiooWinOojn_[onOWioo[jnP03ooWin@04oo[j
n_oinOWonOWioo[jnP;onOWi00Con_[jokVi^OoBd];ol?3`0oogmoL04ooY
jNWogMgMon?ShooWinOok^k^oo;bl_ofm_Kol_;bonOWiooUiNGobLW9ol_;
boo<c<coclo?om3@d?oBd];odm?ComCDe?oEeMD00OoFe]H00?oooooooooo
oomXooooo`0IokNg]ooAdM7oj>SXonWYjOoTi>Cof=SHolo?cooAdM7oemOG
omgMgOoShn?oj>SXonc/k?oYjNWog]kNonOWiom^KVkoLG5aogEeMOn0P83o
UiNGokJf]_oIfMWokno_ooWin@01ooclo00000Oon_[joo_knoojn_[on_[j
oo_knoojn_[ono_k00;on_[j0_okno/00oojn_[ono_koo[jnP03oo[jnP06
oo_knoojn_[on_[joo_knoojn_[ono_k0_ojn_X2oo_kn`03oo[jn_okno_o
n_[j00?on_[j00Kono_koo[jn_ojn_[ono_koo[jn_okno/2oo[jnP;ono_k
00?on_[joo_knoojn_X00oojn_X01_okno_on_[joo[jn_okno_on_[joo_k
n`;on_[j0_okno/00oojn_[ono_koo[jnP03oo[jnP06oo_knoojn_[on_[j
oo_knoojn_[ono_k0_ojn_X2oo_kn`03oo[jn_okno_on_[j00?on_[j00Ko
no_koo[jn_ojn_[ono_koo[jn_okno/2oo[jnP;ono_k00?on_[joo_knooj
n_X00oojn_X01_okno_on_[joo[jn_okno_on_[joo_kn`;on_[j0_okno/0
0oojn_[ono_koo[jnP03oo[jnP06oo_knoojn_[on_[joo_knoojn_[ono_k
0_ojn_X2oo_kn`03oo[jn_okno_on_[j00?on_[j00Kono_koo[jn_ojn_[o
no_koo[jn_okno/2oo[jnP;ono_k00?on_[joo_knoojn_X00oojn_X01_ok
no_on_[joo[jn_okno_on_[joo_kn`;on_[j0_okno/00oojn_[ono_koo[j
nP03oo[jnP06oo_knoojn_[on_[joo_knoojn_[ono_k0_ojn_X2oo_kn`03
oo[jn_okno_on_[j00?on_[j00Kono_koo[jn_ojn_[ono_koo[jn_okno/2
oo[jnP;ono_k00?on_[joo_knoojn_X00oojn_X01_okno_on_[joo[jn_ok
no_on_[joo_kn`;on_[j0_okno/00oojn_[ono_koo[jnP03oo[jnP06oo_k
noojn_[on_[joo_knoojn_[ono_k0_ojn_X2oo_kn`03oo[jn_okno_on_[j
00?on_[j00Kono_koo[jn_ojn_[ono_koo[jn_okno/2oo[jnP;ono_k00?o
n_[joo_knoojn_X00oojn_X01_okno_on_[joo[jn_okno_on_[joo_kn`;o
n_[j0_okno/00oojn_[ono_koo[jnP03oo[jnP06oo_knoojn_[on_[joo_k
noojn_[ono_k0_ojn_X2oo_kn`03oo[jn_okno_on_[j00?on_[j00Kono_k
oo[jn_ojn_[ono_koo[jn_okno/2oo[jnP;ono_k00?on_[joo_knoojn_X0
0oojn_X01_okno_on_[joo[jn_okno_on_[joo_kn`;on_[j0_okno/00ooj
n_[ono_koo[jnP03oo[jnP06oo_knoojn_[on_[joo_knoojn_[ono_k0_oj
n_X2oo_kn`03oo[jn_okno_on_[j00?on_[j00Kono_koo[jn_ojn_[ono_k
oo[jn_okno/2oo[jnP;ono_k00?on_[joo_knoojn_X00oojn_X01_okno_o
n_[joo[jn_okno_on_[joo_kn`;on_[j0_okno/00oojn_[ono_koo[jnP03
oo[jnP06oo_knoojn_[on_[joo_knoojn_[ono_k0_ojn_X2oo_kn`03oo[j
n_okno_on_[j00?on_[j00Kono_koo[jn_ojn_[ono_koo[jn_okno/2oo[j
nP;ono_k00?on_[joo_knoojn_X00oojn_X01_okno_on_[joo[jn_okno_o
n_[joo_kn`;on_[j0_okno/00oojn_[ono_koo[jnP03oo[jnP06oo_knooj
n_[on_[joo_knoojn_[ono_k0_ojn_X2oo_kn`03oo[jn_okno_on_[j00?o
n_[j00Kono_koo[jn_ojn_[ono_koo[jn_okno/2oo[jnP;ono_k00?on_[j
oo_knoojn_X00oojn_X01_okno_on_[joo[jn_okno_on_[joo_kn`;on_[j
0_okno/00oojn_[ono_koo[jnP03oo[jnP06oo_knoojn_[on_[joo_knooj
n_[ono_k0_ojn_X2oo_kn`03oo[jn_okno_on_[j00?on_[j00Kono_koo[j
n_ojn_[ono_koo[jn_okno/2oo[jnP;ono_k00?on_[joo_knoojn_X00ooj
n_X01_okno_on_[joo[jn_okno_on_[joo_kn`;on_[j0_okno/00oojn_[o
no_koo[jnP03oo[jnP06oo_knoojn_[on_[joo_knoojn_[ono_k0_ojn_X2
oo_kn`03oo[jn_okno_on_[j00?on_[j00Kono_koo[jn_ojn_[ono_koo[j
n_okno/2oo[jnP;ono_k00?on_[joo_knoojn_X00oojn_X01_okno_on_[j
oo[jn_okno_on_[joo_kn`;on_[j0_okno/00oojn_[ono_koo[jnP03oo[j
nP06oo_knoojn_[on_[joo_knoojn_[ono_k0_ojn_X2oo_kn`03oo[jn_ok
no_on_[j00?on_[j00Kono_koo[jn_ojn_[ono_koo[jn_okno/2oo[jnP;o
no_k00?on_[joo_knoojn_X00oojn_X01_okno_on_[joo[jn_okno_on_[j
oo_kn`;on_[j0_okno/00oojn_[ono_koo[jnP03oo[jnP06oo_knoojn_[o
n_[joo_knoojn_[ono_k0_ojn_X2oo_kn`03oo[jn_okno_on_[j00?on_[j
01kono_koo[jn_ojn_[ono_koo[jn_nd];Co[Zj^okZm__nd]kSo[k:cojnc
/onh^k_o_<30ol75aOo7bl_oc=3@om;Ee_oDf=SodMCEolW=cOoko_oo/^Wc
ojoVlonXhOKoU/[QogNL^OmhR9So[:b/om;Bd_oUiND1on_[j`0000Gom?Cd
oo?clonf][Ko][JfokBd]002ok>c/`;o/[:b0ona/K401On`/;3o/K6aok2`
/?n`/;3o/K6a00;o/;2`00?o/K6aok2`/?n`/;001on`/;001?na/K7o/;2`
ok2`/?na/K42ok2`/003ok6a/On`/;3o/;2`00Oo/;2`00Co/K6aok2`/?n`
/;3o/K6a0_n`/;000ona/K7o/;2`ok2`/007ok2`/004ok6a/On`/;3o/;2`
ok6a/@;o/;2`00?o/K6aok2`/?n`/;001on`/;001?na/K7o/;2`ok2`/?na
/K42ok2`/003ok6a/On`/;3o/;2`00Oo/;2`00Co/K6aok2`/?n`/;3o/K6a
0_n`/;000ona/K7o/;2`ok2`/007ok2`/004ok6a/On`/;3o/;2`ok6a/@;o
/;2`00?o/K6aok2`/?n`/;001on`/;001?na/K7o/;2`ok2`/?na/K42ok2`
/003ok6a/On`/;3o/;2`00Oo/;2`00Co/K6aok2`/?n`/;3o/K6a0_n`/;00
0ona/K7o/;2`ok2`/007ok2`/004ok6a/On`/;3o/;2`ok6a/@;o/;2`00?o
/K6aok2`/?n`/;001on`/;001?na/K7o/;2`ok2`/?na/K42ok2`/003ok6a
/On`/;3o/;2`00Oo/;2`00Co/K6aok2`/?n`/;3o/K6a0_n`/;000ona/K7o
/;2`ok2`/007ok2`/004ok6a/On`/;3o/;2`ok6a/@;o/;2`00?o/K6aok2`
/?n`/;001on`/;001?na/K7o/;2`ok2`/?na/K42ok2`/003ok6a/On`/;3o
/;2`00Oo/;2`00Co/K6aok2`/?n`/;3o/K6a0_n`/;000ona/K7o/;2`ok2`
/007ok2`/004ok6a/On`/;3o/;2`ok6a/@;o/;2`00?o/K6aok2`/?n`/;00
1on`/;001?na/K7o/;2`ok2`/?na/K42ok2`/003ok6a/On`/;3o/;2`00Oo
/;2`00Co/K6aok2`/?n`/;3o/K6a0_n`/;000ona/K7o/;2`ok2`/007ok2`
/004ok6a/On`/;3o/;2`ok6a/@;o/;2`00?o/K6aok2`/?n`/;001on`/;00
1?na/K7o/;2`ok2`/?na/K42ok2`/003ok6a/On`/;3o/;2`00Oo/;2`00Co
/K6aok2`/?n`/;3o/K6a0_n`/;000ona/K7o/;2`ok2`/007ok2`/004ok6a
/On`/;3o/;2`ok6a/@;o/;2`00?o/K6aok2`/?n`/;001on`/;001?na/K7o
/;2`ok2`/?na/K42ok2`/003ok6a/On`/;3o/;2`00Oo/;2`00Co/K6aok2`
/?n`/;3o/K6a0_n`/;000ona/K7o/;2`ok2`/007ok2`/004ok6a/On`/;3o
/;2`ok6a/@;o/;2`00?o/K6aok2`/?n`/;001on`/;001?na/K7o/;2`ok2`
/?na/K42ok2`/003ok6a/On`/;3o/;2`00Oo/;2`00Co/K6aok2`/?n`/;3o
/K6a0_n`/;000ona/K7o/;2`ok2`/007ok2`/004ok6a/On`/;3o/;2`ok6a
/@;o/;2`00?o/K6aok2`/?n`/;001on`/;001?na/K7o/;2`ok2`/?na/K42
ok2`/003ok6a/On`/;3o/;2`00Oo/;2`00Co/K6aok2`/?n`/;3o/K6a0_n`
/;000ona/K7o/;2`ok2`/007ok2`/004ok6a/On`/;3o/;2`ok6a/@;o/;2`
00?o/K6aok2`/?n`/;001on`/;001?na/K7o/;2`ok2`/?na/K42ok2`/003
ok6a/On`/;3o/;2`00Oo/;2`00Co/K6aok2`/?n`/;3o/K6a0_n`/;000ona
/K7o/;2`ok2`/007ok2`/004ok6a/On`/;3o/;2`ok6a/@;o/;2`00?o/K6a
ok2`/?n`/;001on`/;001?na/K7o/;2`ok2`/?na/K42ok2`/003ok6a/On`
/;3o/;2`00Oo/;2`00Co/K6aok2`/?n`/;3o/K6a0_n`/;000ona/K7o/;2`
ok2`/007ok2`/004ok6a/On`/;3o/;2`ok6a/@;o/;2`00?o/K6aok2`/?n`
/;001on`/;001?na/K7o/;2`ok2`/?na/K42ok2`/00Lok6a/On`/;3o/;2`
ok2`/?oZj^[oS/S=oj_Pj_n[g^_o[N;[ok7Wk?n_hngo/>G]ok3Vk_nbinoo
/^O`ok;XlOncj_;o]>[bokK]lonhl?Ko]NcgojkYmonUh?SoT]?iofbQf?mh
RIgo_knoom_Kf`7ohn?S00001_ofm_KomOGeokRh^?oclo?om?Cdoo?cl`;o
l_;b0_oalO44oo3`l0?okno_00?ok^k^ono_koo_knl02_o_knl01?o^k^ko
kno_ono_koo^k^h<ono_k`04onk^k_o_knookno_onk^kPcokno_00Cok^k^
ono_koo_knook^k^3?o_knl01?o^k^kokno_ono_koo^k^h<ono_k`04onk^
k_o_knookno_onk^kPcokno_00Cok^k^ono_koo_knook^k^3?o_knl01?o^
k^kokno_ono_koo^k^h<ono_k`04onk^k_o_knookno_onk^kPcokno_00Co
k^k^ono_koo_knook^k^3?o_knl01?o^k^kokno_ono_koo^k^h<ono_k`04
onk^k_o_knookno_onk^kPcokno_00Cok^k^ono_koo_knook^k^3?o_knl0
1?o^k^kokno_ono_koo^k^h<ono_k`04onk^k_o_knookno_onk^kPcokno_
00Cok^k^ono_koo_knook^k^3?o_knl01?o^k^kokno_ono_koo^k^h<ono_
k`04onk^k_o_knookno_onk^kPcokno_00Cok^k^ono_koo_knook^k^3?o_
knl01?o^k^kokno_ono_koo^k^h<ono_k`04onk^k_o_knookno_onk^kPco
kno_00Cok^k^ono_koo_knook^k^3?o_knl01?o^k^kokno_ono_koo^k^h<
ono_k`04onk^k_o_knookno_onk^kPcokno_00Cok^k^ono_koo_knook^k^
3?o_knl01?o^k^kokno_ono_koo^k^h<ono_k`04onk^k_o_knookno_onk^
kPcokno_00Cok^k^ono_koo_knook^k^3?o_knl01?o^k^kokno_ono_koo^
k^h<ono_k`04onk^k_o_knookno_onk^kPcokno_00Cok^k^ono_koo_knoo
k^k^3?o_knl01?o^k^kokno_ono_koo^k^h<ono_k`04onk^k_o_knookno_
onk^kPcokno_00Cok^k^ono_koo_knook^k^3?o_knl01?o^k^kokno_ono_
koo^k^h<ono_k`04onk^k_o_knookno_onk^kPcokno_00Cok^k^ono_koo_
knook^k^3?o_knl01?o^k^kokno_ono_koo^k^h4ono_k`0IokBd]?o`l?3o
RL7AojkRl?n_ho3o[n;`ok3TlOn^h_7o/>CaojoSl_naiO;o/>Gcok3Tm?n^
i?Co[nGfok;Wmonbj?Oo/>Kioj[SnOnUh_[oTm?kogNjnomLQ[Co^k^komoO
g`01on_[j`000_ooool00oo0`<3oooooooooo`3oooooooooooooHoooool0
0oo0`<3ooooooi7<g`02okCZo`[o]N_o00[o/nWookG[oonajOooZnGooj?P
oon@d?ooMk[oodn?e?o4a<ColO7a0OomoOd000;ooooo00?o`<30oooooooo
ool0ooooooooooooof?ooooo00?o`<30oooooon:`ml00onaiOl01?n_i?oo
/NGoojoToonaiOl4ojoTo`0;ok7Uoon^hooo[^GoojkSoonWhOooW=Soohg=
oomd^?ooA8gLokFe]OoPh>000Oo/k>`000;ooooo00?o`<30ooooooooool0
ooooooooooooof?ooooo00Co`<30oooooon1^]ooZn3o0_nZgol01?n/hOoo
Z]ooojcQoonZgol4ojcQo`0;oj[OoonXgoooZ=koojKKoonNeOooV=CoohS7
oom][oSo@X[Kojj^[_oHf=P00OoTi>@000;ooooo00?o`<30ooooooooool0
ooooooooooooof?ooooo00Oo`<30oooooomn]MooYm_oojCHoonVf_ooYM[o
00[oY=Wo00SoX=Kooi_Coon@bOooPl7oofVZlOlnQ]Ko];Bdon3Ph07ok>c/
0002ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`03ol30`?oo
ooooO[GO00ooX=Ko00OoVm?ooi39oon3`OooJJ[aocj6e_o1`L7ol?3`007o
oOgm0002ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`05ol30
`?ooooooMjoOoikCoonMd_l03?nNdol02?nJcoooTlcoohS0oOmk^?WoHZG^
ocMocond];Coh>3P0Oo/k>`000;ooooo00?o`<30ooooooooool0oooooooo
ooooof?ooooo00Co`<30oooooom]YMooUlco0_nFb_l9oiG9o`0:oiK:oonB
aokoS/?johc3o_n2^oWoL[7doeRKi?l`NLWo[Zj^omSHf07oi>CT0002oooo
o`03ol30`?oooooooooo0?oooooooooooomSooooo`0:ol30`?ooooooI9cF
ohk2nOn>`o[oSL7hohk2nOn>`o[oS/;iohk3nPCoS/;i0_n>`oX02On;_oKo
R;geoh6im?mi/NkoJZOZoe2CfolYKl?o];Bdon3Ph001onc/k0000_ooool0
0oo0`<3oooooooooo`3oooooooooooooHoooool01?o0`<3ooooooe^Bcon4
^O42ohNkm0WoQ;Wa00[oQ[[aoh>ilOmo]NkoNK7[og2ZjOmPWn?oAX[Eob1X
_Oo1`L7ol?3`0OomoOd000;ooooo00?o`<30ooooooooool0oooooooooooo
of?ooooo00Go`<30oooooomCR/KoO;7Yog^_i`0:ogbaj@0:og^_jOmg[nWo
Lj_VoffUhomRW]koEI?Hoc]nc?lFGkCo];Bdon3Ph07ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002ooooo`03
ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?ooooooCX?0ogN/
i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_
Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002ooooo`03
ol30`?oooooooooo01Sooooo00Go`<30oh>3PomQHF7oNGUiolk>cP0Koooo
o`03on7QhOmnOWkon?Sh01Wooooo00?ohN7QoginO_ohn?P0oooooooooooo
o`cooooo00Co`<30oooooom>Pl3oMjcT0_mgZn<01?meZ^3oMZ[QogFZh?mf
Z^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^
okFe]OoPh>000Oo/k>`000;ooooo00?o`<30ooooooooool06?ooool01_n9
RHWoMWIfojFUYOmSHf?o2`/;okbl_1[ooooo00?ono_koadM7OnUYJD06Ooo
ool00ookno_o7AdMojFUY@3ooooooooooooo3?ooool01?o0`<3oooooodj3
`?mg[>@2ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mc
Z>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko[Zj^omSHf001onCTi0000_oo
ool00oo0`<3oooooooooo`0Booooo`03onc/k?omoOgooooo00;om?Cd1Ooo
ool00omJFU[oAdM7ooooo`0>ooooo`03onc/k?omoOgooooo00;om?Cd1ooo
ool00on;Rh_o?Shnooooo`0Booooo`03onc/k?omoOgooooo00;om?Cd0_oo
ool00on;Rh_o?Shnooooo`07ooooo`03ooWinOoIfMWogMgM0?oooooooooo
ool1ooooo`04ol30`?ooooooCX?0ogN/i0;oMj_S00KoMJ[PogJZhOmeZ^3o
MZ[QogFZh?m?M9P2ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=
dol`MLCo3EF^okFe]OoPh>000Oo/k>`000;ooooo00Ko`<30oooooooooooo
oooooc@d=?mfMWH2ooooo`06od10@?moOgoooooooooooomjNW[o@d=30_oo
ool04Ond];Co2@T9ooooooooooooDE5Ao`P82?lJ6Q[oW9bLoa<C4omGEeOo
ooooonOWiomMGEgo>CTiogYjN_nMWIgo7QhN00;ooooo00Ko@410ogmoOooo
oooooooood10@?moOgl2ooooo`0=oj>SXolL71cooooooooooomADE7o20P8
oaXJ6_nLW9co4a<CoeMGEooooooo@410ogmoO`04ooooo`03oi:BT_l0003o
emOG00Oooooo00Oo=SHfo`000?l0003o20P8obl_;omcLg?olo?c00?ooooo
00KoDE5Ao`P82?lJ6Q[oW9bLoa<C4omGEeL2ooooo`03oi:BT_l0003oemOG
00Oooooo00KoU9BDoadM7Old=3Co:RXZogmoOoono_kooooooogooooo00Co
`<30oooooom>Pl3oMjcT0_mgZn<04omeZ^3oMZ[QogFZh?mfZ^7oHXjkoa/W
<omRS[_oMJ[PogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^
ol;2`_o`l?000OomoOd000;ooooo00Ko`<30oooooooooooooooooc@d=?mf
MWH2ooooo`06od10@?moOgoooooooooooomjNW[o@d=30_ooool02Ond];Co
2@T9ooooooo6a/Ko10@4omgMgOoVi^KoFe]Koa4A4@02ooooo`06ode=COl^
;RkoXZ:RogalO?l];Bgo51@D0_ooool01_m0@43oOgmooooooooooooo@410
ogmoO`;ooooo00WoXj>Soa`L7?ooooooa/K6o`@41?oMgMgoi^KVoe]KFolA
4A400_ooool00om0@43oOgmoooooo`03ooooo`03obl_;ol92@WoLG5a00Oo
oooo00oo=SHfogAdM?oooooomOGeolc<c?m5ADGo8B4Qoo3`l?ooooooa/K6
o`@41?oMgMgoi^KVoe]KFolA4A400oooool00ol_;boo2@T9og5aL@07oooo
o`06ooclo?ooooooooooom;Bd_l20P;oVi^Kooooooomooooo`04ol30`?oo
ooooCX?0ogN/i0;oMj_S01?oMJ[PogJZhOmeZ^3oMZ[Qoal]>ol0003o7bdk
ogFZh?mfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGo
h>3P007ok>c/0002ooooo`06ol30`?oooooooooooooooold=3CoMWIf0_oo
ool01_m0@43oOgmoooooooooooooNWYjod=3@`;ooooo00go];Bdo`T92Ooo
oooofMWIo`<30onm_KgooooooinOWolP823oooooooKfm_l92@Wo^KVi00;o
oooo00KoUYJFoa4A4Ooooooooooood10@?moOgl2ooooo`0=od10@?moOgoo
oooooooooonSXj?o71`LoooooooIfMWo0`<3okfm_OooooooWinOob0P8002
ooooo`03od10@?moOgoooooo00;ooooo00Goc<c<o`410OnOWioo4a<CooSh
n006ooooo`03ocHf=_mdM7Cooooo00;ooooo00[on_[joalO7omaLG7ooooo
omWIfOl30`?o_KfmoooooonOWioo820P0_ooool01Oo<c<co0@41oinOWolC
4a?on?Sh00[ooooo00?o>c/kof1PH?ooool0ooooooolooooo`04ol30`?oo
ooooCX?0ogN/i0;oMj_S01?oMJ[PogJZhOmeZ^3oD7BIoa/W<ol0003o6bLc
odmdV?mfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zko
f=SH007oi>CT0002ooooo`06ol30`?oooooooooooooooold=3CoMWIf0_oo
ool01_m0@43oOgmoooooooooooooNWYjod=3@`;ooooo00go];Bdo`T92Ooo
ooooooooojf][Olb<S;o<c<cocHf=_lP823ooooool;2`_l0003oi^KV00;o
oooo00Ko[:b/oa4A4Ooooooooooood10@?moOgl2ooooo`06od10@?moOgoo
oooooooooonSXj?o71`L0_ooool01On][Jgo<S8boc<c<olf=SKo820P00;o
oooo00?o@410ogmoOoooool00_ooool01OmYJFWo@D51oooooolX:2SoY:BT
00Kooooo00?o=SHfogAdM?ooool00oooool02OmlO7co8R8Roooooooooooo
[Jf]oc8b<_lc<c?o=SHfob0P8002ooooo`05ofUYJOm1@D7oooooobPX:?nT
Y:@02Oooool00ooalO7o3`l?ogYjNP3ooooooogooooo00Co`<30oooooom>
Pl3oMjcT0_mgZn<01?meZ^3oMZ[Qog2Tf?l?5Qh3o`00000<o`lF7OmaY=Wo
MJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P0Oo/k>`0
00;ooooo00Ko`<30oooooooooooooooooc@d=?mfMWH2ooooo`0:od10@?m]
KFgooooooooooomiNGWo<c<cookno_oooooo/k>co`T92@Cooooo00OooOgm
oiBDU?lQ8B7oooooom[Jf_l0003o]KFe00;ooooo00Ko[:b/oa4A4Ooooooo
oooood10@?moOgl2ooooo`06od10@?mMGEgooooooooooonMWIgo7AdM1?oo
ool00oomoOgoU9BDob4Q8@02ooooo`0:od10@?mYJFWoooooooooooofm_Ko
3`l?oj:RX_ooooooT92@ochn?PKooooo00?o=SHfogAdM?ooool00oooool0
0onNWYko0`<3ooWin@03ooooo`0:oogmoOnDU9Co8B4Qooooooofm_Ko3`l?
oj:RX_ooooooT92@ochn?PKooooo00Kom?Cdom;Bd_nLW9coB4Q8oa<C4ooQ
hN7ooooooogooooo00Co`<30oooooom>Pl3oMjcT0_mgZn<01?meZ^3oMZ[Q
ogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`
MLCo3EF^ol;2`_o`l?000OomoOd000;ooooo00Ko`<30oooooooooooooooo
oc@d=?mfMWH2ooooo`0:od10@?lE5AGoS8b<onSXj?lo?coo7alOof1PH?oR
h^;oLG5aoc<c<`;ooooo00Go];Bdom[Jf_olo?coHF5QoeADE002ooooo`06
oc/k>om6ATKoh^;Roo7alOmFEUKo4A4A0_ooool02_m0@43oOgmooooooooo
oooo@410oa@D5?mfMWKog]kNoeMGEom=CDd2ooooo`05okBd]?oJf][oo?cl
of5QHOmDE5@00_ooool02om0@43o4a<Coi6ATOoTi>CoXJ6Qo`h>3_oemOGo
ooooonk^k_l92@WoemOG00Gooooo00?o=SHfogAdM?ooool00oooool04On@
T93o1@D5oo_knooooooo];Bdom[Jf_olo?coHF5QoeADE?ooooooXj>So`h>
3_oemOGoooooonk^k_l92@WoemOG00Gooooo00Go_Kfmo`L71om2@T;oLW9b
on?Sh`3oooooookooooo00Co`<30oooooom>Pl3oMjcT0_mgZn<01?meZ^3o
MZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=
dol`MLCo3EF^okFe]OoPh>000Oo/k>`000;ooooo00Ko`<30oooooooooooo
oooooc@d=?mfMWH2ooooo`0:oeADE?n;Rh_oLG5aoa0@4?lX:2SoeMGEoiZJ
V_lJ6Q[o820Pojf][@;ooooo00GoRXZ:oc8b<_l@413o>CTiolC4a002oooo
o`06on?Shom4A4Co2`/;obTY:OmfMWKo:RXZ0_ooool02_mDE5CoSHf=oooo
ooooooooE5ADohb<S?miNGWo51@Dobh^;_o4a<@2ooooo`05ohZ:R_lb<S;o
410@ocTi>Oo4a<@00_ooool01_mDE5CoRHV9oeeMGOl92@WoE5ADog5aL@?o
oooo00?oK6a/ohF5QOooool01?ooool00olf=SKoM7Adooooo`03ooooo`0<
oe9BD_l/;2cooooooooooon:RX[o<S8boa0@4?li>CWoa<C4oooooomJFU[o
LG5a0oooool00om/K6coQHF5ooooo`04ooooo`03okfm_OlY:BWooooo0?oo
ooooooooool1ooooo`04ol30`?ooooooCX?0ogN/i0;oMj_S00CoMJ[PogJZ
hOm`Y=So3aHN0ol000003?l?5QgoLJCIogF[i?mcZ>7oKjKOofVRfomOV][o
ChgCoc1ea?l=EJko[Zj^omSHf07oi>CT0002ooooo`06ol30`?oooooooooo
oooooold=3CoMWIf1Oooool00oono_koooooooooo`02ooooo`03ookno_oo
oooooooo00?ooooo00?ooOgmooooooooool01?ooool00oomoOgooooooooo
o`0:ooooo`03ookno_oooooooooo00Cooooo00?ooOgmooooooooool01Ooo
ool00oolo?coooooooooo`0:ooooo`03ocHf=_mdM7Cooooo00;ooooo00?o
WinOo`410OnQXJ401?ooool00oomoOgoooooooooo`0=ooooo`03okfm_OlY
:BWooooo0?ooooooooooool1ooooo`04ol30`?ooooooCX?0ogN/i0;oMj_S
01?oMJ[PogJZhOmeZ^3oD7BIoa/W<ol0003o6bLcodmdV?mfZ^7oMJ_Tog>X
hOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002oooo
o`06ol30`?oooooooooooooooold=3CoMWIf7Oooool00omKFe_oTY:Boooo
o`0Pooooo`08ocHf=_l^;RkoI6ATodm?Col];Bgo1`L7ohn?Soono_hDoooo
o`03okfm_Ol<30coCDe=00;oCDe=00?oYjNWooooooooool0oooooookoooo
o`04ol30`?ooooooCX?0ogN/i0;oMj_S01?oMJ[PogJZhOmeZ^3oMZ[Qoal]
>ol0003o7bdkogFZh?mfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4
o`eE[_o2`/;ol?3`007ooOgm0002ooooo`06ol30`?oooooooooooooooon_
[joobLW97Oooool00ond];CocLg=ooooo`0Pooooo`06ok2`/?nJVY[oVYZJ
oj:RX_o4a<Cojn_[5_ooool00ooUiNGoVYZJoiZJVP02oiZJVP03olk>c_oo
oooooooo0?oooooonoooool01?o0`<3oooooodj3`?mg[>@2ogN[h`0CogFZ
h?mfZ^7oMJ[PogJZhOmRS[_o6bLcof:>^omeZ^3oMZ[QogF[i?mcZ>7oKjKO
ofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k0000_ooool00oo0
`<3oooooooooo`3oooooooooooooHoooool01?o0`<3oooooodj3`?mg[>@2
ogN[h`06ogFZh?mfZ^7oMJ[PogJZhOmeZ^3oCgBH0_meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`04ol30`?oooooo
CX?0ogN/i0;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_T
og>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT0002
ooooo`03ol30`?oooooooooo0?oooooooooooomSooooo`06ol30`?oooooo
Gi73oh:_h?n1[]ooPk7P2On2[ml02_n0[mooOjgNogf/g_mdYM[oKZ;Joe^D
d?lVK;go0DNUokJf]_oPh>01onc/k0000_ooool00oo0`<3oooooooooo`3o
ooooooooooooHoooool01oo0`<3oooooohV]e?nR`^GoX/?Voj;2iOnR`nD0
0onR`nH03onR`nGoX<;Uoj32iOnP`^GoX/;Voj?3i_nO`^KoW<3ToiRlhonB
^=ooMjGHob1W^Ol0?9cobl_;oo;blP01oogmo@000_ooool00oo0`<3ooooo
ooooo`3oooooooooooooHoooool02oo0`<3ooooooijlf_nccNWo//gYok?>
jOnbcNWo/lkYokC?j_ncc^Wo/lgY00?o//gY00_o/lkZok?=jOnbcNOo[l[W
ojc8i_nUa>CoNjKHo`mDZolC>93oalO7onCTi001ong]k@000_oooooool30
`?oo`<30Ioo0`<000oooooooY/7LokW@jP02okW@jP0CokS@j_nid>[o^];Z
ok[@jOnjd^[o^=3ZokS?jOnid>[o^];ZokW@j_nhcnWo]<kWojo:i_nL_N3o
F8k7o`I2Wom5DY7oclo?on3Ph001onGUi@00ooooooooooooof[ooooo00Go
Rj_@oio0h?nO`>3oWl3Poijoh003oio0h003oik0h?nO`>3oW[oP00;oW[oP
00[oW[gPoibmh?nF^McoP:[Foe>:a_lPF:_o9Sn@oifN^?oShn?ok>c/0Oo^
k^h00?oooooooooooomZooooo`So4UJX00oo4UJWoa9FZ?lBEZSo4UJZoa9F
Z?l@EJOo3U6Vo`e>Xol;AIko84NJoeUZYon^/<[om?Cdooclo?ono_h00Ooo
ool00?oooooooooooomZoooooa7oh>3P00GohN7QonCTi?oXj>Sok>c/ong]
k@02onk^kP00ooooooooooooof[ooooo4_oTi>@2onGUi@Coi^KV003oogmo
OeOoOgmo1omnOWkoogmoObCoOgmo00001?o[jn_oi^KVon;Rh_oNg]h4omgM
g@;og]kN0_oMgMd00ooNg]kog=cLomkNgP03omgMg@3oomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kN000?omgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomcLg?oMgMgofm_K00;og=cL03?o
gMgMomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]h00_oLg=`01OoIfMWof=SHomOGeooH
f=SofMWJ00;og=cL07Kog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN0_oMgMd0W_oN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
0ooNg]h00ooMgMgog]kNomkNgP03omgMg@7ohN7Q0OoWinL1on[ZjP0000?o
k>c/onKVi_oPh>001ooIfMT01?oHf=Soe]KFom?Cdoo@d=03olg=c@04om3@
d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@
d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Co
d=3@om?CdooGemOof=SHfooIfMT2omSHf006omKFe_oCdm?odm?ComCDe?oG
emOof=SH0_oIfMT00ooHf=SofMWIomWIf@02omSHf0WofMWI00?of=SHomWI
fOoIfMT00_oHf=P00ooIfMWof=SHomSHf002omSHf1OofMWI00Cof=SHomKF
e_oBd];oclo?0_o=cLd01?o?cloodm?ComOGeooHf=SoomWIfAKofMWI00?o
f=SHomWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWo
i>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omgMgOoLg=codm?ColO7aonk
^k_o/K6aojj^[_nb/[;o^[ZjolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoO
gooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_K
omoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o
^k^kolO7aooCdm?ofm_KomoOg`3Jon7Qh@09on3Ph?oOgmoofm_KomKFe_oD
e=Coe]KFom[Jf_oNg]koh>3P00KogmoO0ooPh>000ooOgmooh>3Pon3Ph002
on3Ph0SogmoO0_oNg]h2omoOg`?oh>3P0_oOgml2on3Ph0;ogmoO3OoPh>00
1OoOgmoogMgMomWIfOoEeMGodm?C00;od];B00?oe]KFomcLg?oPh>00K_oQ
hN400ooPh>3ohN7Qon7Qh@05on7Qh@03on3Ph?oQhN7ohN7Q03;ohN7Q00?o
h>3Pon7QhOoQhN40JOoQhN400ooRh^;ohN7Qon;RhP04on7Qh@7ohn?S0OoY
jNT1ong]k@0000?ol?3`ono_kooalO400oo`l?00ooo_knool?3`onk^k_oY
jNWofm_Kol71`OnTY:CoRh^;og]kNomgMgOoNg]kohb<S?nTY:Co`/;1om[J
f_oZj^[okNg]oo7alOo_knoolO7aono_kooalNookno_oo7alOo]kNgoj^[Z
om[Jf_o2`/;oY:BTohb<RomkNg_oMgMgog]kNon<S8coY:BTol;2`_oJf][o
j^[Xong]kOoalO7okno_oo7alOo_knoolO7aono_kooalNookNg]on[Zj_oJ
f][o`/;2ojBTY?n<S8coNg]kogMgM_mkNg_oS8b<ojBTY?o2`/;of][Jon[Z
j_o]kNgolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_k`006ooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_onk^k_o_knooj^[ZonOWi`02on3Ph007
on?Shoo[jnWojn_[on[Zj_oVi^Koj>SXonOWi`02onWYj@0Bonk^k?o/k>co
k>c/onSXj?o/k>cokNg]oo3`l?o/k>coj^[XonKVi_oXj>SoinOWonWYjOoX
j>Sojn_[onOWiooWinGoiNGU0_oYjNT03oo^k^kokNg]ong]kOoXj>Sojn_Y
onc/k?o^k^kojNWYon[Zj_o[jn_okno_onc/k?o/k>[oj^[Zonk^kP02onc/
k03oon[Zj_o_knook>c/onc/j_oZj^[ok^k^onc/k?n_[jooMWIfoeUIFOm^
KVko]kNfon3Ph?oYjNWokNg]oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_000]oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo`l?3okno_oo3`l?o_knool?3`ono_koo`l?3okno_00Col?3`0000
0oobl_;ok^k^onOWi`04onGUi@0@onCTi?oOgmoodM7Aok6a/On:RX[oIVIV
oe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:ROna/K7odM7AomkNgP;oi>CT
00?oiNGUonCTi?oUiN@00_oTi>@03ooNg]kodM7Aok6a/On:RX[oIVIVoe5A
DOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7@omkNgP02onCTi03]
onGUiOoTi>CoiNGUonCTi?oTi>?og]kNom7AdOna/K7oRXZ:ofIVI_mADE7o
ADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6aom7AdOoNg]koi>CSonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGT00;oi>CT053oaLG5obPX:?m4A4CoT92@om7AdOoLg=_ofm_KomOGeooD
e=Coe]KFomCDe?oEeMGofMWIon3PgooNg]kof][JomCDe?oIfMWog]kNon;R
h_oLg=coemOFomCDe?oFe]Koe=CDomGEeOoHf=Sofm_KomOGeooFe]GoeMGE
omOGeooHf=Sog]kNomoOgooLg=coeMGEomOGe_oLg=cogMgMomOGeooFe]Ko
fm_Kon7QhOoNg]kofm_Jom[Jf_oNg]kog=cLom[Jf_oKfm_oh>3PomoOgooL
g=_ofMWIomkNg_oOgmooM7AdofMWIon=SHgoE5ADo`P82?nRXZ;og=cLon;R
h_oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUi@?oi>CT09goiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGU00?oi>CT06CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CT1?oUiND01_oTi>CoiNGUonGUiOoU
iNGoj>SXong]k@7ol_;b00000oodm?CokNg]onOWi`02on3Ph00Con7QhOoO
gmoog]kNom;Bd_nd];CoQhN7oeaLG?m]>cGoWTi2ole_GooYPfooc6iNoii>
@om]>cKoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomkNg_oBd];o];Bd
ohN7QomLG5coKF0/oijF;_o=cCoojNU=olg=?onNVRooKF<]oeaLG?n7QhOo
];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLodMW;_mX
WS?oTLe7oj[YEOnAcDOoJYhdodUZ;omLG5coQhN7okBd]?oBd];og]kN0=Wo
h>3P00KogmoOolo?conIVIWoTY:BoaTI6On<S8`2omGEe@0Oolo?coo2`/;o
c/k>olk>c_o5aLGob/[:om[Jf_oHf=Sod=3@ol_;boo?cloof=SHom[Jf_oE
eMGoclo?ol71`Oo@d=3oc/k>olC4a?o;bl_of=SHomOGeonn_[ko^k^kom7A
dOo@d=3oeMGEomSHf?oCdm?oc<c<olk>cP02omGEe@05olk>c_o<c<codm?C
om[Jf_oHf=P00_oBd]801?oHf=SoemOGom7AdOoCdm<2omWIf@06om?CdooA
dM7oemOGomSHf?oAdM7od=3@0_oAdM401?m6ATKo@D51omOGeooNg]i`on3P
h003omoOgooPh>3oh>3P00;oh>3P00?ogmoOon3Ph?oPh>00WOoPh>000ooO
gmooh>3PomoOg`02omoOg`?oh>3P00?ohN7QonOWioo/k>`00Ooclo<00003
ooKfm_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgoWYjNof]OGon?=Bgo
kG5QooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=cOoR
h^;oinOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOofiVGonCLR;okM54ooWc
M?omoHgooOfEoogmS_oin7KokMM7oi=c8_m^IeooWinOolg=cOoRh^;oinOW
00?oj>SX01?oinOWon;Rh_o=cLgoWinOof1XGom;O2?oT^5;okgiNoo@oI;o
f?fKomCmUOo0nGkoV>Q=odf09?mPJEooWinOolg=cOoRh^;oinOW0=[oj>SX
00Coi^KVon7QhOmMGEgoCDe=0_oMgMd07om@D53o1`L7oaDE5On4Q8Co5QHF
od=3@ooRh^;ogMgMoibLW?l0003oShn?omgMgOoQhN7ofm_Kod10@?l820So
6ATIohR8R?l;2`_oF5QHokNg]ol<30co1`L7ob<S8olW9bOoOGemom[Jf_oM
gMgoe=CDo`/;2omIFET00_oIfMT00omMGEgo2`/;om?Cd`02omoOg`06oeYJ
F_m>CTkog]kNomkNg_lS8b?oQ8B40_oQhN403?mjNW[o;Rh^omgMgOoMgMgo
`/;2oe1@D?lc<c?oKVi^oh>3PolQ8B7og]kNonKVi_ooj>SX7ooXj>P1onc/
k07ol_;b0Oofm_H00003ooOgmoohn?Son?Sh00?on?Sh01?omoOgonk^k_o>
c/koT92@ohD_:ooYI5Koni:7oojVVoon/:CookR[oojcY_onYiconiB9oniX
FOn9<B_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@
oiUY:oo`_Cgonn1^ookdP_onoX[ooonBooknS?onn8?onnE`oo32?_nIJR_o
T92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@od9c:on4
cT?o[Nmcol;nR?o>oY3oe_nGom3nT_o6oXWo/_EdohSC@om4MB_oT92@olk>
c_o^k^komoOg0=[on?Sh02Gom_Kfoo7alOn1PH7o7alOong]kOo6a/Ko0000
ol?3`ooCdm?oG5aLo`P82?oZj^[ol?3`on[Zj_mBDU;o51@Docdm?OoYjNWo
l?3`ojn_[ol71`Ood];Bolg=cOm>CTko6a/Konk^k_oKfm_o[Zj^onSXj?o/
k>co[Zj^o`000?nd];Cok>c/ok2`/?l;2`_o6QXJ00;oi>CT00_o8b<So`h>
3_nTY:CokNg]onk^k_mPH63oE5ADonk^k_o]kNgo9RHVohf=S@02oo3`l00<
oh:2P_la<C7ok>c/on[Zj_m3@d?o;bl_oibLW?mcLg?o:RXZoaXJ6_o^k^ko
m_KfK_ohn?P00oogmoOon?ShooShn005ooShn003ooOgmoohn?Son?Sh09ko
n?Sh00?omoOgooShn?ohn?P00_ohn?P01?ogmoOonOWiooKfm_ogmoL1ooSh
n00000?on_[jooGemOo^k^h00_o/k>`0ooo[jn_ojNWYomoOgoni^KWoNE9B
okla8ooWM6WooHQnoonHS?onXYKoojRLoojTV?ooVXgooXYoonifJ_o3<bCo
NE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/on[Zj_oOgmoo^[ZjohQUD_oR
TAconL=@oogJHooojW;oo_=nooojP_onmWooonacookNI?ojae7ohY8LohUV
Donj^[[ogmoOon[Zj_o[jn_ok>c/on_[jooZj^[ogmoOokZj^_mBKE;oDJ<L
oi7BEOnVif[o^?Ujol3nP_o7ohWo`oj4okWmNonWk6coU=IGoe:V7?mBKE;o
^[ZjomoOgooZj^[ojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k000BOo/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?oYjNWoiNGUogYjN_lL
71cohN7Rolc<c?l30`?oX:2PomkNg_nDU9Co4a<Con7QhOoPh>7od=3@o`H6
1_nQXJ7o2@T9okno_ooQhN7o^[Zjo`820_nb/[;ogMgMoh20P?lX:2Sohn?S
onOWiooUiNGogmoOom_KfooCdm?o20P8ohF5QOoOgmooJFUYodY:B_le=CGo
[Jf]okfm_Ol71`OoN7QhoeEEEOoOgmooh>3Poe]KFom@D5000_oQhN402_lT
92CoQHF5omoOgooQhN7oNg]kobl_;ooPh>3oe=CDo`D51OnXZ:P2on?Sh`0D
oginOolF5QKohN7Qon[Zj_o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>`3on_[j`2Gonc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k002on_[j`04on_[k?o/k>cojn_[onc/k0?ojn_[
06;ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k0Kojn_[00Gok>c/
on_[joo[jn_ok^k^ooKfmP01ooWin@0000?ono_koo?cloo]kNd00_oUiND0
oooVi^Koi>CTomWIfOnb/[;oN2d]olQ2=?oSJUcom7Y]oof8O?onUh[ooY^>
oojHRoonRWkom7]]onM[GOo:@SCoNbh^ok:b/_oHf=Soi>CTonGUiOoVi^Ko
iNGVonCTi?oHf=So/[:boiIE;_oZW2_onka4ook<Doomf6;oo^=bookYMOon
iW?oo]]Uoog<Dook`DGokYh[oiUF;_nb/[;of=SHonCTi?oUiNGoi^KVonGU
iOoTi>Cof=SIok:b/_l^HRkoHjd[ohO:B?nGg5WoYNEYok;cMonhmW_o]?Ei
ojOZJonHg5WoRLm;of>^:ol^Hbko/[:bomSHfOoTi>CoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUiP00=?oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oShn?ogmoOogMgMolK6a_og=cLon7QhOnNWYko;bl_ob/[:olb
<S;o4Q8BomcLg?oJf]_oQ8B4ob0P8?oPh>3oDU9BofQXJ?oJf][og]kNoi2@
T?lZ:R[o;Rh^ob`/;?lW9bL2omkNgP0ComWIfOoCdmCod=3@oe]KFol0003o
_Kfmom[Jf_lX:2SoQhN7ogMgN?mXJ6SoPX:2oc`l??o2`/;o3`l?omCDe?oJ
f][oFEUIodi>CP02omcLg00Job<S8on1PH7oeMGEomOGeomgMgOo;Rh^omcL
g?nSXj?o0000olO7aooHf=SofMWIohf=S_lE5AGog=cLonCTi?oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^H2onGUi@1RonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^H3onGUi@2TonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNH2onKViP03onGUiOoVi^Koi^KV00?oi^KV00?oiNGU
ong]kOoclo<00Oojn_X00003ooclo?ohn?SolO7a00?ok^k^01?ojn_[on7Q
hOnl_;coNQLGol<o<_oCETWoi6QJonmgK?ocPgSon8MlooF4N_ocNFgoiFUK
omUHB_o4?c;oO1LGokbl_?oQhN7ok>c/00?ok^k^01?ok>c/on7QhOnl_;co
YDLGonJG<_oe[33ooKa1oog9Doomd63onm=UoogBH?oncECooKe2ooZ_<_oY
Vc;oYDHGokbl_?oQhN7ok>c/00?ok^k^01?ok>c/on7QhOnl_;co5eTGoenX
<_mf_COoQ/e7oiKFF_nRh6GoXn1Yoj?QIonGfUcoQ/i7ogNo=omOZc;o5eTG
okbl_?oQhN7ok>c/0=[ok^k^02kok>c/onOWiomkNg_o71`LonCTi?oYjNWo
i^KVon7QhOoNg]koSHf=oa@D5?oVi^Koi>CTocDe=OmiNGWojn_[ok:b/_lE
5AGogmoOonKVi_oTi>CohN7QomgMgOmjNW[o:BTYonSXj?oUiNGogMgMok6a
/OlV9RKo2`/;oi^KVooYjNWoc<c<o`000?o>c/ko`l?3obDU9Om;Bd_oO7al
onSXj?la<C7oYJFUonCTi?mMGEgoDE5A0_oWinL02_lU9BGoJFUYomoOgooO
gmooMgMgoc4a<OoYjNWo`L71o`000?nWYjL2omoOg`04oi>CTolF5QKoinOW
onc/k:_ok^k^00?okNg]onk^k_o^k^h0Koo^k^h00oo]kNgol_;booShn001
ooclo0000oomoOd05_olo?cooOgmoogmoOolo?colo?com7AdOmX1`Oo^3@d
olLo<ooBD4?ofV9Eon=^H_oTLVCoi6mRomaTEooCDD?oc44dokTd=?m[1`Oo
d];Boo?cloolo?`3oogmo@0Cooclo?oclo?od];Boih[1ooJRSCoji/IooFX
:Ooh]3oonKe:ooRoCOoj_d[onKPoooJZ:_o_WQWofh/doj8]1ooBd];olo?c
ooclo003oogmo@0Cooclo?oclo?od];Bo`M01om=VSCoGj/Pog2h;omo`d?o
R/e@ohg=D_n:cU3oPLM4og6i;omR[R3oCY/do`M21ooBd];olo?cooclo03J
oogmo@0Soo_knoogmoOoQ8B4oahN7_oclo?onOWiok>c/oo@d=3olo?cofQX
J?m7AdOon_[jomCDe?l0003ogMgMooclo?okno_o9bLWojRXZ?oinOWoZj^[
omGEeOoalO7oE5ADoeiNG_oinOWom?CdoiBDU?l51@Go@410om7AdOogmoOo
n?ShoiNGUol[:b/00_ojn_X06olT92Co1`L7olS8b?okno_oQHF5of=SHoog
moOoHf=SoeMGEoohn?SonOWiobLW9olE5AGoPh>3omOGeom2@T;oHf=Soo_k
noojn_[o=3@dodU9BOoKfm_oiNGUodm?ColG5aOon_[jooclo03ooogmoAco
oOgm00?oo?cloogmoOolo?`00oomoOd0000joogmoOojn_[olo?conk^k_o`
l?3okno_onk^k_oYjNWodm?Coe/M7OnR=3Co/bLLol4j;Oo7BCcoceI:om1G
Boo@Ed[obTXnol<k;_nf:1goXS@doe`M7OoCdm?oj^[Zonk^k_o`l?3okno_
oo3`koo^k^koj^[Zom?Cdon<9Agob74domV47OoTU1GoiidTonjX<oo`ZSCo
kjXconbP9OoWUaGog8PMolQa=?n<9Agodm?Con[Zj_o^k^kol?3`ono_koo`
l?3ok^k^on[ZjOoCdm?o7CPMocB2=?m7UAgoFZDKofV]:P;oM;Ph0>;oMKTh
of^a:omKYacoB9XMocB2=?lM>1godm?Con[ZjOo^k^kol?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
0_o_knl0C_oZj^[oOWinoa`L7?oXj>OokNg]ohR8R?l`<33o3`l?oc4a<Ona
/K7ok^k^ohF5Q?m=CDgokno_onk^k_o_knooRXZ:oeUIFOo^k^koN7Qhob/[
:ol?3`oo>3Phokno_oo]kNgoi>CTo`h>3_mYJFWogmoOon?ShooUiNGojn_[
of5QHOmgMgOok^k^ono_k_mfMWKo9RHVong]kOo_knooc<c<ob`/;?oZj^[o
KFe/of9RH_o/k>cokNg]oc/k>onCTi?oHV9Ro`h>3_ld=3Coa<C4ono_koo^
k^kodM7Aoc`l??l:2P[o9bLWofa/K?l/;2cokno_onk^k_o`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l0?okno_0?ool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`onk^k_o`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?0000Go
kno_oo3`l?o_knool?3_ono_k`02oo3`l0Kokno_0Ooclo<1ooWin@7oo_kn
00000oono_komoOgoo3`l004onWYj@0AonOWiooKfm_oHd];oh4b<_nV=CGo
]S@]ol9=@Oo3E4Woa5E:ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooW
inL01OoYjNT04OoWinOofm_KohU;Bon_Bc;ocGLeomJ;;OoPW2koh:0bon6P
=?oPX3;ogiX^omJ;;Oo:MCGo[d/bohU;BooKfm_oinOW00GojNWY017oinOW
om_Kfom;Bd_o<V0bocZ9=OmCVbgoJj/_og2]>?m_[S[oL:dhofZZ;omCVbgo
>HPeoc9P<_m;Bd_ofm_KonOWi`3KonWYj@06onSXj?oVi^KoNg]koa`L7?oT
i>Coj>SX0_oYjNT00ooWinOojNWYonWYj@0;onWYj@0<onOWiooYjNWojNWY
onSXj?oHf=So2PX:ojj^[_oMgMgog]kNon3Ph?oUiNGoj>SX2?oYjNT01_oX
j>Soi^KVon?ShooShn?oi^KVonSXj0?ojNWY00?oj>SXonWYjOoYjNT01?oY
jNT00ooWinOojNWYonWYj@3oonWYjA_ojNWY00?oj>SXonWYjOoYjNT01?oY
jNT1oo3`l07om_Kf0Oono_h00005ookno_ojn_[om?Cdono_kooalO400_o`
l?004Oo_knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZNW?oIW9co
e9FEok]cLonEE5CoCb<SoiFDU?oZj^[okno_00Gol?3`017okno_on[Zj_nY
U9CoPB<SokYZE?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S
8onZU9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCoLjEc
oik6UOn/cYco[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Zj_o_knl0
foo`l?02ono_k`04oh20P?lM7Agok^k^ono_ka?ol?3`0_o_knl01omTI6Co
:BTYoh61POmSHf?o>c/konk^k_o_knl02?o`l?001_o_knook^k^og=cLomY
JFWok^k^ono_koool?3`;Oo`l?001?oalO7ol?3`ooCdm?ojn_X1ooknoP00
00Cok>k`ooooooooooooo_kn0_ooool2ooknoP3ooogmoOohn?SoKVi^oeXo
?onaT93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSloofe]KOohn?Soo?cl
ooooooono_koooooookno_ooookoo_knooooooolo?con?Shohe]KOn:?coo
bI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo?on=KFgon?Sgooclo?oo
ooooo_knooooooono_koooooookno_ooookoo?clooShn?m]KFgo?clooi2M
T?o9eLWoi>cTonK^i_oTk>CobMG9oi2MT?lo?cooKFe]ooShn?olo?coooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_kn000hooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooomoOgod=3@ojFUYOono_go
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooooogm
oOo1`L3oLG5aoh61POn_[jl2ooknoP0<ooooooono_koooonookno_oooooo
o_knooooooono_kooooooogmoOo2`/7o_;bl0_ono_h0ooooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooo`00:Oono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_kn00;ooooo00?oo_knooooooooool00oooool1ooWjn`0000Co`<O=
ookno_ojn_[om?Cd1OoalO403Oo_knooe]KFof][Jom3?CgoVhb<olJj^_oF
c<coakZjoi^<S?m3?CgoJf][omKFe_o_knl02OoalO403Oo_knooemKFoh=[
Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<S?mb?CgoPF][omOFe_o_knl02Ooa
lO403Oo_knooe]KFof][Jolm?CgoS8b<okZj^_o<cLco^[Zjohb<S?lm?Cgo
Jf][omKFe_o_knl0oooalO4Xoo7al@03oo3`l?oalO7olO7a0?oolO7a2Ooa
lO401?o`l?3olO7aoo7alOo`l?04oo7al@03ooCdm?ojn_[oo_kn007ojng^
00001On3SiWooOgmooShn?o`l?3ojn_[00?oj^[Z00gojNWYon[Zj_oYjNWo
j>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY00_oj^[Z
00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo@RHVofUIFOnPVi_oj>SXonWY
j@0;on[ZjP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^K
onSXj?oYjNT0oooZj^XXon[ZjP03onWYjOoZj^[oj^[Z0?ooj^[Z4OoZj^X0
1?o[jn_ol?3`ooShn?omoOd1om7Ee`0000Co=TI@okRoaOojn_[om?Cd2?oa
lO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`
l?03ono_k`;ol?3`oooalO4/oo7al@03oo3`l?oalO7olO7a0?oolO7a2ooa
lO400oo`l?3olO7aoo7al@02oo7al@03ooGemOoinOWok>g_007oXZFX0000
0olM;cgoCEQSokVoaP3oooooooooooooO?ooool1ong_l07o[K2c0OnUZJd0
0006oah_?OlK:3Co<Si8ogf8TOnm`lOojnc^ooooooooooooogKooooo00Go
j^c]ok^o`_mjPHOo:cDmoa8P:P01oa@S;`00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 543},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(strings = 
      Table[\[IndentingNewLine]JavaNew["\<java.lang.String\>", \
\[IndentingNewLine]StringJoin["\<Imaginary Day \>", 
            ToString[i]]\[IndentingNewLine]], \[IndentingNewLine]{i, 1, 
          7}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject2242648748326913], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject2242648731549697], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject2242648714772481], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject2242648697995265], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject2242648681218049], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject2242648664440833], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject2242648647663617]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(combo = NewJComboBox[pane, strings]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JComboBox"] \[RightGuillemet]\),
      JLink`Objects`JavaObject19475646644225]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(combo@setMaximumRowCount[5]\)], "Input"],

Cell[BoxData[
    \(combo@setEditable[True]\)], "Input"],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(DeleteJObject[pane, combo]\)], "Input"],

Cell[BoxData[
    \(Do[ReleaseObject[strings[\([i]\)]], {i, 1, Length[strings]}]\)], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["<<< SimpleJComboBox >>>",
  FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005]0000SaP00`40o`00
0?l0003oolc<c6k<c<`000K<c<co0000H`0000G<c<`000K<c<`00`000<c<
c<c<c03oc<c<Clc<c13oool00`000<c<c<c<c003c<c<0006c<c<00<0003<
c<c<c<`0olc<c4k<c<`00fIVI/c<c6IVIP0=IVIV00?oool0003<c<`01<c<
c0001/c<c0030000c<c<c<c<01G<c<`400005lc<c0<0000Ec<c<0`000?o<
c<`3c<c<00=VIVKoooo<c<`03<c<c003IVIVoooo000000G<c<`000K<c<`0
0`000<c<c<c<c00Dc<c<00@0003<c<c<c<c<c<`200006<c<c080000Fc<c<
0P000?o<c<`2c<c<00=VIVKoooo<c<`03<c<c003IVIVoooo000000G<c<`0
00K<c<`01@000<c<c00000000<c<c00200000/c<c0800002c<c<0P0000;<
c<`500000/c<c08000001<c<c00000000<c<c08000000lc<c00000000002
c<c<0P0000;<c<`5000000?<c<`0000000001<c<c0<00005c<c<1@0000C<
c<`500000/c<c0<00006c<c<10000?K<c<`00fIVI_ooolc<c00<c<c<00=V
IVKoool000001Lc<c0001/c<c0050000c<c<00000000c<c<00800002c<c<
0P0000;<c<`2000000?<c<`0000000000/c<c08000001<c<c00000000<c<
c0<000001<c<c00000000<c<c0800002c<c<0P000003c<c<0000000000;<
c<`2000000?<c<`0000000001<c<c0<00005c<c<0P0000;<c<`200000/c<
c0800002c<c<0P0000;<c<`300001Lc<c0800002c<c<0P000?G<c<`00fIV
I_ooolc<c00<c<c<00=VIVKoool000001Lc<c0001/c<c0050000c<c<0000
0000c<c<00800002c<c<0P0000;<c<`2000000?<c<`0000000000/c<c080
00000lc<c00000000002c<c<0P000004c<c<00000000c<c<0P0000;<c<`2
000000?<c<`0000000000/c<c08000000lc<c00000000003c<c<0P000003
c<c<0000000000C<c<`200000lc<c08000000lc<c00000000002c<c<0P00
0004c<c<00000000c<c<0P0000S<c<`20000mLc<c003IVIVooooc<c<00G<
c<`200001Lc<c003IVIVoooo000000G<c<`000K<c<`01@000<c<c0000000
0<c<c00200000/c<c0800002c<c<0P0000;<c<`2000000C<c<`00000003<
c<`200000/c<c08000001<c<c00000000<c<c0800002c<c<0P0000;<c<`2
000000C<c<`00000003<c<`200000lc<c08000000lc<c00000000004c<c<
0P0000?<c<`200000/c<c08000001<c<c00000000<c<c08000000lc<c000
00000008c<c<0P000?G<c<`00fIVI_ooolc<c004c<c<100000C<c<`00fIV
I_ooo`000005c<c<0006c<c<00D0003<c<`00000003<c<`00P0000;<c<`2
00000/c<c0800003c<c<10000003c<c<0000000000;<c<`2000000C<c<`0
0000003<c<`200000/c<c0800003c<c<10000003c<c<0000000000?<c<`2
000000?<c<`0000000001<c<c0800003c<c<0P0000?<c<`4000000C<c<`0
0000003<c<`200001<c<c0800002c<c<0P000?G<c<`00fIVI_ooolc<c003
c<c<1P0000?<c<`00fIVI_ooo`000005c<c<0006c<c<00D0003<c<`00000
003<c<`00`000005c<c<000000000000c<c<008000000lc<c0000<c<c002
c<c<0P000004c<c<00000000c<c<0`000004c<c<00000000c<c<0`000005
c<c<00000000c<c<000000?<c<`2000000?<c<`0000000000/c<c0800003
c<c<0P0000?<c<`200000lc<c08000000lc<c0000<c<c002c<c<100000?<
c<`200000lc<c0D0003fc<c<00=VIVKoooo<c<`00/c<c0P00002c<c<00=V
IVKoool000001Lc<c0001/c<c0050000c<c<00000000c<c<008000000lc<
c00000000002c<c<0P0000?<c<`400000lc<c08000001<c<c00000000<c<
c08000001<c<c00000000<c<c0800003c<c<100000;<c<`600000lc<c080
0003c<c<0P0000?<c<`200000/c<c0@000000lc<c00000000003c<c<0P00
00?<c<`20000nLc<c003IVIVooooc<c<00c<c<`00fIVI_ooo`000005c<c<
0006c<c<00@0003<c<`00000000ic<c<0P0000;<c<`200004lc<c080003h
c<c<00=VIVKoooo<c<`03<c<c003IVIVoooo000000G<c<`000K<c<`01000
0<c<c000000001[<c<`200007Lc<c0D0000Dc<c<1@000?G<c<`00fIVI_oo
olc<c00<c<c<00=VIVKoool000001Lc<c0001/c<c0030000c<c<c<c<0?o<
c<a>c<c<00=VIVKoooo<c<`03<c<c003IVIVoooo000000G<c<`000K<c<`0
0`000<c<c<c<c03oc<c<C/c<c003IVIVooooc<c<00c<c<`00fIVI_ooo`00
0005c<c<0006c<c<00<0003<c<c<c<`0olc<c4k<c<`00fIVI_ooooooo`0<
oooo00=VIVKoool000001Lc<c0001/c<c0030000c<c<c<c<0?o<c<a>c<c<
00=VIVK<c<aVIVH03FIVIP03oooo0000c<c<00C<c<`000K<c<`00`000<c<
c<c<c03oc<c<C/c<c003IVIVVIVIc<c<00c<c<`00fIVI_ooo`000005c<c<
0006c<c<00<0003<c<c<c<`0olc<c4k<c<`00fIVIYVIVLc<c00<c<c<00=V
IVKoool000001Lc<c0001/c<c0030000c<c<c<c<0?o<c<a>c<c<00=VIVJI
VIW<c<`03<c<c003IVIVoooo000000G<c<`000K<c<`00`000<c<c<c<c00E
c<c<100001O<c<`300005Lc<c0<0003oc<c<0lc<c003IVIVVIVIc<c<00c<
c<`00fIVI_ooo`000005c<c<0006c<c<00<0003<c<c<c<`05<c<c0040000
c<c<c<c<c<c<0P0001S<c<`200005/c<c080003oc<c<0/c<c003IVIVVIVI
c<c<00c<c<`00fIVI_ooo`000005c<c<0006c<c<00D0003<c<`00000003<
c<`00P0000;<c<`200000/c<c0800002c<c<1@0000;<c<`2000000C<c<`0
0000003<c<`2000000?<c<`0000000000/c<c0800002c<c<1@000003c<c<
0000000000C<c<`300001Lc<c0D00004c<c<1@0000;<c<`300002<c<c080
003fc<c<00=VIVJIVIW<c<`03<c<c003IVIVoooo000000G<c<`000K<c<`0
1@000<c<c00000000<c<c00200000/c<c0800002c<c<0P000003c<c<0000
000000;<c<`2000000C<c<`00000003<c<`3000000C<c<`00000003<c<`2
00000/c<c08000000lc<c00000000002c<c<0P000003c<c<0000000000C<
c<`300001Lc<c0800002c<c<0P0000;<c<`200000/c<c0800002c<c<0`00
00S<c<`20000m/c<c003IVIVVIVIc<c<00c<c<`00fIVI_ooo`000005c<c<
0006c<c<00D0003<c<`00000003<c<`00P0000;<c<`200000/c<c0800000
0lc<c00000000002c<c<0P000003c<c<0000000000;<c<`2000000C<c<`0
0000003<c<`200000/c<c08000000lc<c00000000002c<c<0P000003c<c<
0000000000?<c<`2000000?<c<`0000000001<c<c0800003c<c<0P000003
c<c<0000000000;<c<`2000000C<c<`00000003<c<`200001<c<c0H0003e
c<c<00=VIVJIVIW<c<`03<c<c003IVIVoooo000000G<c<`000K<c<`01@00
0<c<c00000000<c<c00200000/c<c0800002c<c<0P0000;<c<`2000000C<
c<`00000003<c<`200000/c<c08000001<c<c00000000<c<c0800002c<c<
0P0000;<c<`2000000C<c<`00000003<c<`200000lc<c08000000lc<c000
00000004c<c<0P0000?<c<`200000/c<c08000001<c<c00000000<c<c080
00000lc<c00000000004c<c<00<0003<c<c<c<`00P000?K<c<`00fIVIYVI
VLc<c00<c<c<00=VIVKoool000001Lc<c0001/c<c0050000c<c<00000000
c<c<00800002c<c<0P0000;<c<`200000lc<c0@000000lc<c00000000002
c<c<0P000004c<c<00000000c<c<0P0000;<c<`200000lc<c0@000000lc<
c00000000003c<c<0P000003c<c<0000000000C<c<`200000lc<c0800003
c<c<10000004c<c<00000000c<c<0P0000G<c<`010000<c<c00000000?K<
c<`00fIVIYVIVLc<c00<c<c<00=VIVKoool000001Lc<c0001/c<c0050000
c<c<00000000c<c<00<000001Lc<c000000000000<c<c002000000?<c<`0
003<c<`00/c<c08000001<c<c00000000<c<c0<000001<c<c00000000<c<
c0<000001Lc<c00000000<c<c0000003c<c<0P000003c<c<0000000000;<
c<`200000lc<c0800003c<c<0P0000?<c<`2000000?<c<`0003<c<`00/c<
c0@00003c<c<0P0000C<c<`010000<c<c00000000?K<c<`00fIVIYVIVLc<
c00<c<c<00=VIVKoool000001Lc<c0001/c<c0050000c<c<00000000c<c<
008000000lc<c00000000002c<c<0P0000?<c<`400000lc<c08000001<c<
c00000000<c<c08000001<c<c00000000<c<c0800003c<c<100000;<c<`6
00000lc<c0800003c<c<0P0000?<c<`200000/c<c0@000000lc<c0000000
0003c<c<0P0000G<c<`30000m/c<c003IVIVVIVIc<c<00c<c<`00fIVI_oo
o`000005c<c<0006c<c<00@0003<c<`00000000ic<c<0P0000;<c<`20000
5<c<c0<0003fc<c<00=VIVJIVIW<c<`03<c<c003IVIVoooo000000G<c<`0
00K<c<`010000<c<c000000001[<c<`200007Lc<c0D0000Fc<c<0P000?K<
c<`00fIVIYVIVLc<c00<c<c<00=VIVKoool000001Lc<c0001/c<c0030000
c<c<c<c<0?o<c<a>c<c<00=VIVJIVIW<c<`03<c<c003IVIVoooo000000G<
c<`000K<c<`00`000<c<c<c<c03oc<c<C/c<c003IVIVVIVIVIVI00fIVIT0
0oooo`000<c<c004c<c<0006c<c<00<0003<c<c<c<`0olc<c4k<c<`@IVJI
00?oool0003<c<`01<c<c0001/c<c0030000c<c<c<c<0?o<c<a>c<c<00=V
IYW<c?nIVL`039VIc003IVJIoooo000000G<c<`000K<c<`00`000<c<c<c<
c03oc<c<C/c<c003IVJIc<coVIW<00bIVL`00fIVVOooo`000005c<c<0006
c<c<00<0002IVLbIVL`0oiVIc4jIVL`00fIVVLc<oiVIc00<VIW<00=VIYWo
ool000001Lc<c0001/c<c0030000VIW<VIW<0?nIVLa>VIW<00EVIYW<c?nI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00:IVL`00fIVVOooo`00
0005c<c<0006c<c<00<0002IVLbIVL`05IVIc0@0000GVIW<0`0001FIVL`3
0000oiVIc0>IVL`016IVVLc<oiVIc<c<o`>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00=VIYWoool000001Lc<c0001/c<c0030000VIW<VIW<01BIVL`0
100009VIc9VIc9VIc080000HVIW<0P0001JIVL`20000oiVIc0:IVL`00fIV
VLc<oiVIc003VIW<00EVIYVIVLbIVLbIVLaVIYT019VIc003IVJIoooo0000
00G<c<`000K<c<`01@0009VIc000000009VIc00200000YVIc0800002VIW<
0P0000:IVL`500000YVIc080000019VIc000000009VIc08000000iVIc000
00000002VIW<0P0000:IVL`5000000>IVL`00000000019VIc0<00005VIW<
1@0000BIVL`500000YVIc0<00006VIW<10000?JIVL`00fIVVLc<oiVIc002
VIW<00G<c?nIVLbIVLbIVLc<c?l01IVIc003IVJIoooo000000G<c<`000K<
c<`01@0009VIc000000009VIc00200000YVIc0800002VIW<0P000003VIW<
0000000000:IVL`2000000BIVL`00000002IVL`3000000BIVL`00000002I
VL`200000YVIc08000000iVIc00000000002VIW<0P000003VIW<00000000
00BIVL`300001IVIc0800002VIW<0P0000:IVL`200000YVIc0800002VIW<
0`0000FIVL`200000YVIc080003eVIW<00EVIYW<c?nIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00:IVL`00fIVVOooo`000005c<c<0006c<c<
00D0002IVL`00000002IVL`00P0000:IVL`200000YVIc08000000iVIc000
00000002VIW<0P000003VIW<0000000000:IVL`2000000BIVL`00000002I
VL`200000YVIc08000000iVIc00000000002VIW<0P000003VIW<00000000
00>IVL`2000000>IVL`00000000019VIc0800003VIW<0P000003VIW<0000
000000:IVL`2000000BIVL`00000002IVL`2000029VIc080003eVIW<00AV
IYW<c?nIVLc<c?l3VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc003IVJIoooo
000000G<c<`000K<c<`01@0009VIc000000009VIc00200000YVIc0800002
VIW<0P0000:IVL`2000000BIVL`00000002IVL`200000YVIc080000019VI
c000000009VIc0800002VIW<0P0000:IVL`2000000BIVL`00000002IVL`2
00000iVIc08000000iVIc00000000004VIW<0P0000>IVL`200000YVIc080
000019VIc000000009VIc08000000iVIc00000000008VIW<0P000?FIVL`0
0fIVVLc<oiVIc003VIW<00EVIYVIVLbIVLbIVLaVIYT019VIc003IVJIoooo
000000G<c<`000K<c<`01@0009VIc000000009VIc00200000YVIc0800002
VIW<0P0000>IVL`4000000>IVL`0000000000YVIc080000019VIc0000000
09VIc0800002VIW<0P0000>IVL`4000000>IVL`0000000000iVIc0800000
0iVIc00000000004VIW<0P0000>IVL`200000iVIc0@0000019VIc0000000
09VIc0800008VIW<0P000?FIVL`00fIVVLc<oiVIc002VIW<00G<c?nIVLbI
VLbIVLc<c?l01IVIc003IVJIoooo000000G<c<`000K<c<`01@0009VIc000
000009VIc003000000FIVL`000000000002IVL`00P000003VIW<0000VIW<
00:IVL`2000000BIVL`00000002IVL`3000000BIVL`00000002IVL`30000
00FIVL`00000002IVL`000000iVIc08000000iVIc00000000002VIW<0P00
00>IVL`200000iVIc0800003VIW<0P000003VIW<0000VIW<00:IVL`40000
0iVIc0800005VIW<0`000?JIVL`01FIVVLc<oiVIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00YVIc003IVJIoooo000000G<c<`000K<c<`01@00
09VIc000000009VIc002000000>IVL`0000000000YVIc0800003VIW<1000
00>IVL`2000000BIVL`00000002IVL`2000000BIVL`00000002IVL`20000
0iVIc0@00002VIW<1P0000>IVL`200000iVIc0800003VIW<0P0000:IVL`4
000000>IVL`0000000000iVIc0800007VIW<0P000?FIVL`016IVVLc<oiVI
c<c<o`>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00=VIYWoool000001Lc<
c0001/c<c0040000VIW<00000000>IVIc0800002VIW<0P0001:IVL`20000
0YVIc080003eVIW<00=VIYW<c?nIVL`00iVIc005IVJIVIW<VIW<VIW<IVJI
00BIVL`00fIVVOooo`000005c<c<0006c<c<00@0002IVL`00000000JVIW<
0P0001fIVL`5000059VIc0@0003fVIW<00=VIYW<c?nIVL`00YVIc005c<co
VIW<VIW<VIW<c<co00FIVL`00fIVVOooo`000005c<c<0006c<c<00<0002I
VLbIVL`0oiVIc4jIVL`01FIVVLc<oiVIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00YVIc003IVJIoooo000000G<c<`000K<c<`00`0009VIc9VI
c03oVIW<CYVIc004IVJIc<coVIW<c<co0iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`00fIVVOooo`000005c<c<0006c<c<00<0002IVLbIVL`0oiVIc4jI
VL`00fIVVLc<oiVIc003VIW<00EVIYVIVLbIVLbIVLaVIYT019VIc003IVJI
oooo000000G<c<`000K<c<`00`0009VIc9VIc03oVIW<CYVIc003IVJIc<co
VIW<00:IVL`01Lc<oiVIc9VIc9VIc<c<o`05VIW<00=VIYWoool000001Lc<
c0001/c<c0030000VIW<VIW<0?nIVLa>VIW<00EVIYW<c?nIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00:IVL`00fIVVOooo`000005c<c<0006
c<c<00<0003<c<c<c<`0olc<c4k<c<`016IVVLc<oiVIc<c<o`>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00=VIYWoool000001Lc<c0001/c<c0030000
c<c<c<c<0?o<c<a>c<c<00=VIYW<c?nIVL`00iVIc005IVJIVIW<VIW<VIW<
IVJI00BIVL`00fIVVOooo`000005c<c<0006c<c<00<0003<c<c<c<`05Lc<
c0@0000Gc<c<0`0001G<c<`30000olc<c0?<c<`00fIVVLc<oiVIc002VIW<
00G<c?nIVLbIVLbIVLc<c?l01IVIc003IVJIoooo000000G<c<`000K<c<`0
0`000<c<c<c<c00Dc<c<00@0003<c<c<c<c<c<`200006<c<c080000Fc<c<
0P000?o<c<`2c<c<00EVIYW<c?nIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00:IVL`00fIVVOooo`000005c<c<0006c<c<00D0003<c<`00000
003<c<`00P0000;<c<`200000/c<c0800002c<c<1@0000;<c<`2000000C<
c<`00000003<c<`2000000?<c<`0000000000/c<c0800002c<c<1@000003
c<c<0000000000C<c<`300001Lc<c0D00004c<c<1@0000;<c<`300001Lc<
c0H0003ec<c<00AVIYW<c?nIVLc<c?l3VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc003IVJIoooo000000G<c<`000K<c<`01@000<c<c00000000<c<c002
00000/c<c0800002c<c<0P000003c<c<0000000000;<c<`2000000C<c<`0
0000003<c<`3000000C<c<`00000003<c<`200000/c<c08000000lc<c000
00000002c<c<0P000003c<c<0000000000C<c<`300001Lc<c0800002c<c<
0P0000;<c<`200000/c<c0800002c<c<0`0000G<c<`20000nLc<c003IVJI
c<coVIW<00>IVL`01FIVVIVIc9VIc9VIc6IVV@04VIW<00=VIYWoool00000
1Lc<c0001/c<c0050000c<c<00000000c<c<00800002c<c<0P0000;<c<`2
000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P000004
c<c<00000000c<c<0P0000;<c<`2000000?<c<`0000000000/c<c0800000
0lc<c00000000003c<c<0P000003c<c<0000000000C<c<`200000lc<c080
00000lc<c00000000002c<c<0P000004c<c<00000000c<c<0P0000G<c<`2
0000n<c<c003IVJIc<coVIW<00:IVL`01Lc<oiVIc9VIc9VIc<c<o`05VIW<
00=VIYWoool000001Lc<c0001/c<c0050000c<c<00000000c<c<00800002
c<c<0P0000;<c<`200000/c<c08000001<c<c00000000<c<c0800002c<c<
0P000004c<c<00000000c<c<0P0000;<c<`200000/c<c08000001<c<c000
00000<c<c0800003c<c<0P000003c<c<0000000000C<c<`200000lc<c080
0002c<c<0P000004c<c<00000000c<c<0P000003c<c<0000000000K<c<`2
0000mlc<c005IVJIc<coVIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@02VIW<00=VIYWoool000001Lc<c0001/c<c0050000c<c<00000000c<c<
00800002c<c<0P0000;<c<`200000lc<c0@000000lc<c00000000002c<c<
0P000004c<c<00000000c<c<0P0000;<c<`200000lc<c0@000000lc<c000
00000003c<c<0P000003c<c<0000000000C<c<`200000lc<c0800003c<c<
10000004c<c<00000000c<c<0P0000O<c<`20000m/c<c004IVJIc<coVIW<
c<co0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`00fIVVOooo`000005c<c<
0006c<c<00D0003<c<`00000003<c<`00`000005c<c<000000000000c<c<
008000000lc<c0000<c<c002c<c<0P000004c<c<00000000c<c<0`000004
c<c<00000000c<c<0`000005c<c<00000000c<c<000000?<c<`2000000?<
c<`0000000000/c<c0800003c<c<0P0000?<c<`200000lc<c08000000lc<
c0000<c<c002c<c<100000?<c<`200001lc<c080003ec<c<00=VIYW<c?nI
VL`00iVIc005IVJIVIW<VIW<VIW<IVJI00BIVL`00fIVVOooo`000005c<c<
0006c<c<00D0003<c<`00000003<c<`00P000003c<c<0000000000;<c<`2
00000lc<c0@00003c<c<0P000004c<c<00000000c<c<0P000004c<c<0000
0000c<c<0P0000?<c<`400000/c<c0H00003c<c<0P0000?<c<`200000lc<
c0800002c<c<10000003c<c<0000000000?<c<`200001lc<c080003ec<c<
00=VIYW<c?nIVL`00YVIc005c<coVIW<VIW<VIW<c<co00FIVL`00fIVVOoo
o`000005c<c<0006c<c<00@0003<c<`00000000ic<c<0P0000;<c<`20000
4/c<c0800002c<c<0P000?G<c<`01FIVVLc<oiVIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00YVIc003IVJIoooo000000G<c<`000K<c<`01000
0<c<c000000001[<c<`200007Lc<c0D0000Dc<c<10000?K<c<`016IVVLc<
oiVIc<c<o`>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00=VIYWoool00000
1Lc<c0001/c<c0030000c<c<c<c<0?o<c<a>c<c<00=VIYW<c?nIVL`00iVI
c005IVJIVIW<VIW<VIW<IVJI00BIVL`00fIVVOooo`000005c<c<0006c<c<
00<0003<c<c<c<`0olc<c4k<c<`00fIVVLc<oiVIc002VIW<00G<c?nIVLbI
VLbIVLc<c?l01IVIc003IVJIoooo000000G<c<`000K<c<`00`000<c<c<c<
c03oc<c<C/c<c005IVJIc<coVIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@02VIW<00=VIYWoool000001Lc<c0001/c<c0030000c<c<c<c<0?o<
c<a>c<c<00AVIYW<c?nIVLc<c?l3VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c003IVJIoooo000000G<c<`000K<c<`00`000<c<c<c<c03oc<c<C/c<c003
IVJIc<coVIW<00bIVL`00fIVVOooo`000005c<c<0006c<c<00<0003<c<c<
c<`0olc<c4k<c<`00fIVVLc<oiVIc00<VIW<00=VIYWoool000001Lc<c000
1/c<c0030000c<c<c<c<0?o<c<a>c<c<00=VIYW<c?o<c?l03<c<o`03IVJI
oooo000000G<c<`000K<c<`00`000<c<c<c<c00Ec<c<100001O<c<`30000
5Lc<c0<0003oc<c<0lc<c11VIYT00oooo`000<c<c004c<c<0006c<c<00<0
003<c<c<c<`05<c<c0040000c<c<c<c<c<c<0P0001S<c<`200005/c<c080
003oc<c<0/c<c003IVIVooooc<c<00c<c<`00fIVI_ooo`000005c<c<0006
c<c<00D0003<c<`00000003<c<`00P0000;<c<`200000/c<c0800002c<c<
1@0000;<c<`2000000C<c<`00000003<c<`2000000?<c<`0000000000/c<
c0800002c<c<1@000003c<c<0000000000C<c<`300001Lc<c0D00004c<c<
1@0000;<c<`300002<c<c080003fc<c<00=VIVKoooo<c<`03<c<c003IVIV
oooo000000G<c<`000K<c<`01@000<c<c00000000<c<c00200000/c<c080
0002c<c<0P000003c<c<0000000000;<c<`2000000C<c<`00000003<c<`3
000000C<c<`00000003<c<`200000/c<c08000000lc<c00000000002c<c<
0P000003c<c<0000000000C<c<`300001Lc<c0800002c<c<0P0000;<c<`2
00000/c<c0800002c<c<0`0000S<c<`20000m/c<c003IVIVooooc<c<00c<
c<`00fIVI_ooo`000005c<c<0006c<c<00D0003<c<`00000003<c<`00P00
00;<c<`200000/c<c08000000lc<c00000000002c<c<0P000003c<c<0000
000000;<c<`2000000C<c<`00000003<c<`200000/c<c08000000lc<c000
00000002c<c<0P000003c<c<0000000000?<c<`2000000?<c<`000000000
1<c<c0800003c<c<0P000003c<c<0000000000;<c<`2000000C<c<`00000
003<c<`200001lc<c080003fc<c<00=VIVKoooo<c<`03<c<c003IVIVoooo
000000G<c<`000K<c<`01@000<c<c00000000<c<c00200000/c<c0800002
c<c<0P0000;<c<`2000000C<c<`00000003<c<`200000/c<c08000001<c<
c00000000<c<c0800002c<c<0P0000;<c<`2000000C<c<`00000003<c<`2
00000lc<c08000000lc<c00000000004c<c<0P0000?<c<`200000/c<c080
00001<c<c00000000<c<c08000000lc<c00000000007c<c<0P000?K<c<`0
0fIVI_ooolc<c00<c<c<00=VIVKoool000001Lc<c0001/c<c0050000c<c<
00000000c<c<00800002c<c<0P0000;<c<`200000lc<c0@000000lc<c000
00000002c<c<0P000004c<c<00000000c<c<0P0000;<c<`200000lc<c0@0
00000lc<c00000000003c<c<0P000003c<c<0000000000C<c<`200000lc<
c0800003c<c<10000004c<c<00000000c<c<0P0000O<c<`20000m/c<c003
IVIVooooc<c<00;<c<`800000/c<c003IVIVoooo000000G<c<`000K<c<`0
1@000<c<c00000000<c<c003000000G<c<`000000000003<c<`00P000003
c<c<0000c<c<00;<c<`2000000C<c<`00000003<c<`3000000C<c<`00000
003<c<`3000000G<c<`00000003<c<`000000lc<c08000000lc<c0000000
0002c<c<0P0000?<c<`200000lc<c0800003c<c<0P000003c<c<0000c<c<
00;<c<`400000lc<c0800004c<c<00@0003<c<`00000003fc<c<00=VIVKo
ooo<c<`00lc<c0H00003c<c<00=VIVKoool000001Lc<c0001/c<c0050000
c<c<00000000c<c<008000000lc<c00000000002c<c<0P0000?<c<`40000
0lc<c08000001<c<c00000000<c<c08000001<c<c00000000<c<c0800003
c<c<100000;<c<`600000lc<c0800003c<c<0P0000?<c<`200000/c<c0@0
00000lc<c00000000003c<c<0P0000C<c<`40000m/c<c003IVIVooooc<c<
00C<c<`400001<c<c003IVIVoooo000000G<c<`000K<c<`010000<c<c000
000003W<c<`200000/c<c080000Dc<c<0`000?K<c<`00fIVI_ooolc<c005
c<c<0P0000G<c<`00fIVI_ooo`000005c<c<0006c<c<00@0003<c<`00000
000Jc<c<0P0001g<c<`500005/c<c080003fc<c<00=VIVKoooo<c<`03<c<
c003IVIVoooo000000G<c<`000K<c<`00`000<c<c<c<c03oc<c<C/c<c003
IVIVooooc<c<00c<c<`00fIVI_ooo`000005c<c<0006c<c<00<0003<c<c<
c<`0olc<c4k<c<`00fIVI_ooolc<c00<c<c<00=VIVKoool000001Lc<c000
0/c<c0D0003oc<c<D<c<c003IVIVooooc<c<00c<c<`00fIVI_ooo`000004
00000Lc<c0000/c<c005R<2hB928B928B92800000?o<c<a@c<c<00=VIVKo
ooooool03?ooo`03c<c<oooo000000=8T8P100000Lc<c0000/c<c005R<2h
b>3HR<2hR<2h00000?o<c<a@c<c<46IVIP06c<c<0000R<2hR<2hB9280000
0Lc<c0000/c<c004R<2hb>3HR<2hR<2ho`0006<00002R<2h0DR@R0400001
c<c<0002c<c<00B8`;S8h=R8`;R8`;SoooooBOooo`03c<c<oooooooo01Oo
ool2R<2h0DR@R0400001c<c<0002c<c<00J8`;S8h=R8`;R8`;QVIVK<c<co
IVIVB6IVIP03c<c<IVIVIVIV01EVIVH01OooohS0^8S0^4R@R0000001c<c<
0002c<c<00F8`;S8h=R8`;R8`;QVIVH0ooooodSoool00fIVI_ooolc<c00E
c<c<00IVIVKooon8`;R8`;Q8T8P00001c<c<0002c<c<00F8`;S8h=R8`;R8
`;QVIVH0ooooodSoool00fIVI_ooolc<c00Ec<c<00IVIVKooon8`;R8`;Q8
T8P00001c<c<0002c<c<00F8`;S8h=R8`;R8`;QVIVH0ooooodSoool00fIV
I_ooolc<c00Ec<c<00IVIVKooon8`;R8`;Q8T8P00001c<c<0002c<c<00F8
`;S8h=R8`;R8`;QVIVH0ooooodSoool00fIVI_ooolc<c00Ec<c<00IVIVKo
oon8`;R8`;Q8T8P00001c<c<0002c<c<00F8`;S8h=R8`;R8`;QVIVH05ooo
o`@0000Goooo0`0001Goool30000n_ooo`03IVIVooooc<c<01G<c<`01VIV
I_ooohS0^8S0^4R@R000007<c<`000;<c<`01HS0^<SPf8S0^8S0^6IVIP0F
oooo00@0003oooooooooool200006?ooo`80000Foooo0P000?Woool00fIV
I_ooolc<c00Ec<c<00IVIVKooon8`;R8`;Q8T8P00001c<c<0002c<c<00J8
`;S8h=R8`;R8`;QVIVKoool2000000?oool0000000000_ooo`800002oooo
0P0000;oool500000_ooo`8000001?ooo`0000000?ooo`8000000oooo`00
00000002oooo0P0000;oool5000000?oool0000000001?ooo`<00005oooo
1@0000Coool500000_ooo`<00006oooo10000>koool00fIVI_ooolc<c00E
c<c<00IVIVKooon8`;R8`;Q8T8P00001c<c<0002c<c<00J8`;S8h=R8`;R8
`;QVIVKoool2000000?oool0000000000_ooo`800002oooo0P000003oooo
0000000000;oool2000000Coool00000003oool3000000Coool00000003o
ool200000_ooo`8000000oooo`0000000002oooo0P000003oooo00000000
00Coool300001Oooo`800002oooo0P0000;oool200000_ooo`800002oooo
0`0000Goool200000_ooo`80003]oooo00=VIVKoooo<c<`05Lc<c006IVIV
ooooR<2hR<2hB92800000Lc<c0000/c<c006R<2hb>3HR<2hR<2hIVIVoooo
0P000003oooo0000000000;oool200000_ooo`8000000oooo`0000000002
oooo0P000003oooo0000000000;oool2000000Coool00000003oool20000
0_ooo`8000000oooo`0000000002oooo0P000003oooo0000000000?oool2
000000?oool0000000001?ooo`800003oooo0P000003oooo0000000000;o
ool2000000Coool00000003oool200002?ooo`80003]oooo00=VIVKoooo<
c<`02Lc<c080000:c<c<00IVIVKooon8`;R8`;Q8T8P00001c<c<0002c<c<
00J8`;S8h=R8`;R8`;QVIVKoool2000000?oool0000000000_ooo`800002
oooo0P0000;oool2000000Coool00000003oool200000_ooo`8000001?oo
o`0000000?ooo`800002oooo0P0000;oool2000000Coool00000003oool2
00000oooo`8000000oooo`0000000004oooo0P0000?oool200000_ooo`80
00001?ooo`0000000?ooo`8000000oooo`0000000008oooo0P000>goool0
0fIVI_ooolc<c008c<c<100000W<c<`01VIVI_ooohS0^8S0^4R@R000007<
c<`000;<c<`01XS0^<SPf8S0^8S0^6IVI_ooo`8000000oooo`0000000002
oooo0P0000;oool200000oooo`@000000oooo`0000000002oooo0P000004
oooo00000000oooo0P0000;oool200000oooo`@000000oooo`0000000003
oooo0P000003oooo0000000000Coool200000oooo`800003oooo10000004
oooo00000000oooo0P0000Soool20000kOooo`03IVIVooooc<c<00O<c<`6
00002<c<c006IVIVooooR<2hR<2hB92800000Lc<c0000/c<c006R<2hb>3H
R<2hR<2hIVIVoooo0P000005oooo000000000000oooo00<000001Oooo`00
00000?ooo`000003oooo0P000004oooo00000000oooo0`000004oooo0000
0000oooo0`000005oooo00000000oooo000000?oool2000000?oool00000
00000_ooo`800003oooo0P0000?oool200000oooo`8000000oooo`000?oo
o`02oooo100000?oool200001Oooo`<0003^oooo00=VIVKoooo<c<`01/c<
c0P00007c<c<00IVIVKooon8`;R8`;Q8T8P00001c<c<0002c<c<00J8`;S8
h=R8`;R8`;QVIVKoool2000000Coool00000003oool200000_ooo`800003
oooo100000?oool2000000Coool00000003oool2000000Coool00000003o
ool200000oooo`@00002oooo1P0000?oool200000oooo`800003oooo0P00
00;oool4000000?oool0000000000oooo`800007oooo0P000>goool00fIV
I_ooolc<c005c<c<2P0000K<c<`01VIVI_ooohS0^8S0^4R@R000007<c<`0
00;<c<`01XS0^<SPf8S0^8S0^6IVI_ooo`80000ioooo0P0000;oool20000
4_ooo`800002oooo0P000>goool00fIVI_ooolc<c00Ec<c<00IVIVKooon8
`;R8`;Q8T8P00001c<c<0002c<c<00J8`;S8h=R8`;R8`;QVIVKoool20000
6_ooo`80000Moooo1@0001Coool40000k_ooo`03IVIVooooc<c<01G<c<`0
1VIVI_ooohS0^8S0^4R@R000007<c<`000;<c<`01HS0^<SPf8S0^8S0^6IV
IP3oooooB?ooo`03IVIVooooc<c<01G<c<`01VIVI_ooohS0^8S0^4R@R000
007<c<`000;<c<`01HS0^<SPf8S0^8S0^6IVIP3oooooB?ooo`03IVIVoooo
c<c<01G<c<`01VIVI_ooohS0^8S0^4R@R000007<c<`000;<c<`01HS0^<SP
f8S0^8S0^6IVIP3oooooB?ooo`03IVIVooooc<c<01G<c<`01VIVI_ooohS0
^8S0^4R@R000007<c<`000;<c<`01HS0^<SPf8S0^8S0^6IVIP3oooooB?oo
o`03IVIVooooc<c<01G<c<`01VIVI_ooohS0^8S0^4R@R000007<c<`000;<
c<`01HS0^<SPf8S0^8S0^6IVIP3oooooB?ooo`03IVIVooooc<c<01G<c<`0
1VIVI_ooohS0^8S0^4R@R000007<c<`000;<c<`01HS0^<SPf8S0^8S0^6IV
IP3oooooB?ooo`03IVIVooooc<c<01G<c<`01VIVI_ooohS0^8S0^4R@R000
007<c<`000;<c<`01HS0^<SPf8S0^8S0^6IVIP3oooooB?ooo`03IVIVoooo
c<c<01G<c<`01VIVI_ooohS0^8S0^4R@R000007<c<`000;<c<`01HS0^<SP
f8S0^8S0^6IVIP3oooooB?ooo`03IVIVoooooooo01Goool01/c<c?ooohS0
^8S0^4R@R000007<c<`000;<c<`018S0^<SPf8S0^8S0^?mVIVIRIVIV00G<
c<b8`;R8`;Q8T8P000000Lc<c0000/c<c003R<2hb>3HR<2h0?n8`;QVR<2h
0DR@R0400001c<c<0002c<c<00B8`;S8h=R8`;R8`;PF002000@00X000h40
0h40184300F20P07PP030@R20@R30@V300812X<00`4;Q04<Q04<Q0020@j4
00@13XD23hD23hD248D20Q6600@24XH24hH24hL24hL20QF700<25XL35XP3
5hP00P<HR0040aV90aZ90aZ90aZ90P<LR@837HX010@NRP@OR`@OR`@PR`<4
8H`212><00<498`49Hd59Hd00PDVS@031BN>1BR>1BR>0085:Xh010DZS`D[
S`D/S`D/S`86;I0010H^T0H_T0H`T@H`T@86<I401PHbT@HcTPHcTPHdTPLd
TPLeT`<7=Y<21cRC00<7>I@7>Y@7>Y@00PLkU@0423bE23fF23fF23fF0PPo
UP06242F246G246G24:G24>G2D>H0PU4V089AYP01@U6V@U7V@U8V@U8V@U9
VP022DZJ0PY;VP042TbK2TfK2TfK2TjK0PY?W0042U2L2U6L2U:M2U:M0P]B
W@8;E9d010]EWP]FWP]FWP]GW`8;F9l22eVO00@<FZ0<Fj0<Fj0<G:0235fQ
0PaNX@8<Gj801@aQXPeRXPeRXPeRX`eSX`023FBS00H=IJ@=IZ@=IZ@=IZ@=
J:@=J:D23VVU00@>JZD>JjH>JjH>K:H23VfV00H>KZL>KjL>KjL>L:L?L:P?
LJP23g:X00<?LjT?M:T?M:T00`mfZ@8?MjX00a1hZQ1iZa1iZ`0247Z[0Q1k
[08@OJ`00a1n[11o[A5o[@024H2]00LAPJhAPZhAPZhAPZhAQ:hAQ:lAQJl0
0Q66[`8BQk0011:8/1:9/1::/A::/@8BRk401Q:</A:=/Q:=/Q:>/Q>>/Q>?
/`8CT;<34i:c00<CTk@CU;@CU;@00Q>E]@8DU[D259Nf0QBI]P0659Zf59^g
59^g59bg59fg5Ifh0aFN^0035J2h5J2i5J6i008EX[T00aFS^QFT^QFT^P02
5ZFj00@FY[/FYk/FYk/FZ;/25ZVl00DFZ[`FZk`F[;dF[;dG[;d00aN^_@04
5jnn5k2n5k2n5k6o0QNb_`035k>o6;C06;C003@H]<02R<2h0DR@R0400001
c<c<0002c<c<00B8`;S8h=R8`;R8`;P4002000>KYo4c@jDc@jD02C=3Y@H0
08001002P003P@03P@04P@<01H8200N200<1288128<12H<00P4:P`030@^4
0@b40@b400813X@0104>Q@8?Q@8?Q@8@Q@824HH0108BQP8CQP8CQ`8CQ`82
5HL00`8FQ`<FR0<GR0020aR800@36HT36XT36XT36XT20ab90P<MRP0411j:
11n;11n;122;0`@QS0848h`00`@TS0@US@DUS@021BJ=00<59hh5:8h5:8h0
0PDZSP041BZ?1B^?1Bb?1Bb?0PH]T0041Rj@1Rn@1S2A1S2A0PHaT@061S:A
1S>B1S>B1SBB1cBB1cFC0`LfT`87>9<00`LiU0LjU0LjU0021c^E00@8?9D8
?IH8?IH8?IH223nF00H8@9H8@IL8@IL8@YL8@iL9@iP22DBH0PU6V0052DJI
2DNI2DRI2DRI2DVJ0089BYX22T^J00@:C9/:CI/:CI/:CY/22TnL00@:D9`:
DI`:DYd:DYd22e:M0P]DW@042eFN2eJN2eJN2eNO0P]HW`8;FIl010aJX0aK
X0aKX0aLX08<GJ4235jQ0PaOXP05366R3F:R3F:R3F:S3F>S008=I:<01PeU
Y0eVY0eVY0eVY0eXY0eXY@8>JJD010iZY@i[YPi[YPi/YP8>KJH01Pi^Y`i_
Y`i_Y`i`Y`m`Z0maZ08?LZP00`mcZ@mdZ@mdZ@033gJY0PmgZP0347RZ47V[
47V[008@NZ/247^/0Q1m[00347j/47n]4Gn]008AP:d01a61[Q62[Q62[Q62
[Q64[Q64[a65[`024HJ_0Q:7/0044XR`4XV`4XZa4XZa0Q:;/@064Xba4Xfb
4Xfb4Xjb4hjb4hnc0Q>@/`<CT[<00a>C]1>D]1>D]0024iFe0QBF]@8DUkH2
59Vf00HDV[HDVkLDVkLDW;LDWKLEWKP35Ijh00<EX;PEX;TEXKT00QFR^@03
5J>j5JBj5JBj008FYKX011JV^aJW^aJW^aJX^`8FZK`01AJZ_1J[_1J/_AJ/
_AN/_@035jjm00@G[khG/;hG/;hG/Kl25k:o00<G/klH]<0H]<00=1Rd`0:8
`;P1B9280@00007<c<`000;<c<`018S0^<SPf8S0^8S0^0<008001i^WlOoo
ohij]ZJKa;>YdZRMb;>YdP02YY_400Fl^=g]k??]k??ooolc@jD01@00P004
00:000>100>100B10`05PP801h800`48PP48P`49P`020@Z300<12h@138@1
38@00P4>Q0040@j50Pn50Pn50Q250P8AQP040Q:60Q>60Q>70Q>70P8EQ`03
0QJ70aJ80aN8008368P010<IR@<JR@<JR@<JR@8378T20af:00@47XX47h/4
7h/488/3126<0P@SS00312B<12F=1BF=00859Xd00`DWSPDXSPDXSP021BZ>
00@5:Xl5:hl5;8l5;8l21Rf@00@6;Y06;i06<946<9421S6A00H6<Y46<i86
<i86=987=987=I<31cJC0PLhT`031cVD1cZD1cZD0087>iD010PlU@PmUPPm
UPPmUP88?iH01PQ0UPQ1U`Q1U`Q2U`Q3U`U3V089A9P22DJH00D9AYT9AiT9
B9T9B9T9BIX00PU:VP8:BiX010Y<V`Y=V`Y=V`Y>V`8:Ci`010Y@W0YAW0YB
W@YBW@8;DYd22eBM00@;EIh;EYh;EYh;Eil22eRO0P]IW`0435ZP35^P35^P
35bP0PaMX@8<GZ4235nR00D<HJ8=HZ8=HZ8=HZ<=Hj<00PeTX`063FFT3FJT
3FJT3FJT3FRT3FRU0PiYY@043VZU3V^V3V^V3VbV0Pi]YP063VjW3VnW3VnW
3W2W3g2X3g6X0PmbZ0033g>Y3gBY3gBY00<?MZT23gNZ00<@N:X@NJ/@NJ/0
0Q1jZ`8@Nj`247f/00<@OZ`@OjdAOjd00Q60[@074H6^4H:^4H:^4H:^4HB^
4HB_4HF_008AQZl24XN`00@BR;0BRK0BR[4BR[424X^a00HBS;4BSK8BSK8B
S[8CS[8CSk<24i2c0a>B/`034i>d4iBd4iBd008CUKD259Je0QBG]P8DVKH0
1QBJ]QBK]aBK]aBL]aBM]aFM^0<EW[P00aFP^1FP^AFQ^@025J:i00<EXkXE
Y;XEY;X00QJU^P045ZJk5ZNk5ZNk5ZRk0QJY_0055ZZl5Z^l5Zbm5Zbm5jbm
00<G[[d011N__QN`_QN`_QNa_`8G/[l00aNc_aRd`1Rd`00P00000QRd`100
00026;C00XS0^058T8P100000Lc<c0000/c<c004R<2hb>3HR<2hR<2h0P00
P004VjOaooooK5ZU[jG:0[bhg@0:oogo/jWBoooooooo_;SMUhZlZ9g8i^K/
oooo<d>U1000P00400:000>100>100B10`05PP801h800`48PP48P`49P`02
0@Z300<12h@138@138@00P4>Q0040@j50Pn50Pn50Q250P8AQP040Q:60Q>6
0Q>70Q>70P8EQ`030QJ70aJ80aN8008368P010<IR@<JR@<JR@<JR@8378T2
0af:00@47XX47h/47h/488/3126<0P@SS00312B<12F=1BF=00859Xd00`DW
SPDXSPDXSP021BZ>00@5:Xl5:hl5;8l5;8l21Rf@00@6;Y06;i06<946<942
1S6A00H6<Y46<i86<i86=987=987=I<31cJC0PLhT`031cVD1cZD1cZD0087
>iD010PlU@PmUPPmUPPmUP88?iH01PQ0UPQ1U`Q1U`Q2U`Q3U`U3V089A9P2
2DJH00D9AYT9AiT9B9T9B9T9BIX00PU:VP8:BiX010Y<V`Y=V`Y=V`Y>V`8:
Ci`010Y@W0YAW0YBW@YBW@8;DYd22eBM00@;EIh;EYh;EYh;Eil22eRO0P]I
W`0435ZP35^P35^P35bP0PaMX@8<GZ4235nR00D<HJ8=HZ8=HZ8=HZ<=Hj<0
0PeTX`063FFT3FJT3FJT3FJT3FRT3FRU0PiYY@043VZU3V^V3V^V3VbV0Pi]
YP063VjW3VnW3VnW3W2W3g2X3g6X0PmbZ0033g>Y3gBY3gBY00<?MZT23gNZ
00<@N:X@NJ/@NJ/00Q1jZ`8@Nj`247f/00<@OZ`@OjdAOjd00Q60[@074H6^
4H:^4H:^4H:^4HB^4HB_4HF_008AQZl24XN`00@BR;0BRK0BR[4BR[424X^a
00HBS;4BSK8BSK8BS[8CS[8CSk<24i2c0a>B/`034i>d4iBd4iBd008CUKD2
59Je0QBG]P8DVKH01QBJ]QBK]aBK]aBL]aBM]aFM^0<EW[P00aFP^1FP^AFQ
^@025J:i00<EXkXEY;XEY;X00QJU^P045ZJk5ZNk5ZNk5ZRk0QJY_0055ZZl
5Z^l5Zbm5Zbm5jbm00<G[[d011N__QN`_QN`_QNa_`8G/[l011Nc_aRd`1Rd
`<SPf0i8T8P00`000<SPf4R@R00=B92800@0000H]<0H]<38h=P>B92800<0
000H]<0H]<000XS0^058T8P100000Lc<c0000/c<c004R<2hb>3HR<2hR<2h
0P00P00;VjOaooooZ9g8oooo/jWBH4bJSWZfN6F^Z9g8oooooogo00?oool0
0c=3Y@00P000P003002000@00X000h400h40184300F20P07PP030@R20@R3
0@V300812X<00`4;Q04<Q04<Q0020@j400@13XD23hD23hD248D20Q6600@2
4XH24hH24hL24hL20QF700<25XL35XP35hP00P<HR0040aV90aZ90aZ90aZ9
0P<LR@837HX010@NRP@OR`@OR`@PR`<48H`212><00<498`49Hd59Hd00PDV
S@031BN>1BR>1BR>0085:Xh010DZS`D[S`D/S`D/S`86;I0010H^T0H_T0H`
T@H`T@86<I401PHbT@HcTPHcTPHdTPLdTPLeT`<7=Y<21cRC00<7>I@7>Y@7
>Y@00PLkU@0423bE23fF23fF23fF0PPoUP06242F246G246G24:G24>G2D>H
0PU4V089AYP01@U6V@U7V@U8V@U8V@U9VP022DZJ0PY;VP042TbK2TfK2TfK
2TjK0PY?W0042U2L2U6L2U:M2U:M0P]BW@8;E9d010]EWP]FWP]FWP]GW`8;
F9l22eVO00@<FZ0<Fj0<Fj0<G:0235fQ0PaNX@8<Gj801@aQXPeRXPeRXPeR
X`eSX`023FBS00H=IJ@=IZ@=IZ@=IZ@=J:@=J:D23VVU00@>JZD>JjH>JjH>
K:H23VfV00H>KZL>KjL>KjL>L:L?L:P?LJP23g:X00<?LjT?M:T?M:T00`mf
Z@8?MjX00a1hZQ1iZa1iZ`0247Z[0Q1k[08@OJ`00a1n[11o[A5o[@024H2]
00LAPJhAPZhAPZhAPZhAQ:hAQ:lAQJl00Q66[`8BQk0011:8/1:9/1::/A::
/@8BRk401Q:</A:=/Q:=/Q:>/Q>>/Q>?/`8CT;<34i:c00<CTk@CU;@CU;@0
0Q>E]@8DU[D259Nf0QBI]P0659Zf59^g59^g59bg59fg5Ifh0aFN^0035J2h
5J2i5J6i008EX[T00aFS^QFT^QFT^P025ZFj00@FY[/FYk/FYk/FZ;/25ZVl
00DFZ[`FZk`F[;dF[;dG[;d00aN^_@045jnn5k2n5k2n5k6o0QNb_`045k>o
6;C06;C0b>3H3HS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SP
f00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400001c<c<0002c<c<00B8
`;S8h=R8`;R8`;P2002000jKYo7ooooooooIfN]PC9ZCQKZcZM:l^=ePC9ZI
SkjVVlC8`moooolc@jD5002000Woool00X000h400h4018401H;oool01H80
1h801?ooo`812X<02@4;Q?ooo`4<Q?ooo`4>Q04>Q@8?QOooo`8@Q@020Q66
0oooo`060Q>70QF70QF7oooo0aJ80aN80P<HR0040aV9oooo0aZ90aZ90P<L
R@Coool00`@OR`@PRoooo`02126<00Koool48h`498coool59Hd59Xd3oooo
00D5:8h5:Xh5:Xh5:Xl5:hl00PD/S`86;I0010H^T0H_T0H`T@H`T@86<I40
1PHbT@HcTPHcTPHdTPLdTPLeT`<7=Y<21cRC00<7>I@7>Y@7>Y@00PLkU@04
23bE23fF23fF23fF0PPoUP06242F246G246G24:G24>G2D>H0PU4V089AYP0
1@U6V@U7V@U8V@U8V@U9VP022DZJ0PY;VP042TbK2TfK2TfK2TjK0PY?W004
2U2L2U6L2U:M2U:M0P]BW@8;E9d010]EWP]FWP]FWP]GW`8;F9l22eVO00@<
FZ0<Fj0<Fj0<G:0235fQ0PaNX@8<Gj801@aQXPeRXPeRXPeRX`eSX`023FBS
00H=IJ@=IZ@=IZ@=IZ@=J:@=J:D23VVU00@>JZD>JjH>JjH>K:H23VfV00H>
KZL>KjL>KjL>L:L?L:P?LJP23g:X00<?LjT?M:T?M:T00`mfZ@8?MjX00a1h
ZQ1iZa1iZ`0247Z[0Q1k[08@OJ`00a1n[11o[A5o[@024H2]00LAPJhAPZhA
PZhAPZhAQ:hAQ:lAQJl00Q66[`8BQk0011:8/1:9/1::/A::/@8BRk401Q:<
/A:=/Q:=/Q:>/Q>>/Q>?/`8CT;<34i:c00<CTk@CU;@CU;@00Q>E]@8DU[D2
59Nf0QBI]P0659Zf59^g59^g59bg59fg5Ifh0aFN^0035J2h5J2i5J6i008E
X[T00aFS^QFT^QFT^P025ZFj00@FY[/FYk/FYk/FZ;/25ZVl00DFZ[`FZk`F
[;dF[;dG[;d00aN^_@045jnn5k2n5k2n5k6o0QNb_`045k>o6;C06;C0b>3H
0hS0^0H00004R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H
]<0H]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P100000Lc<c000
0/c<c004R<2hb>3HR<2hR<2h0`00P00>VjOaoooo_;SMVHnnooooe]7MfMW[
nO[lYY_4kNccQGJ`ThFjoooo<d>U1000P00=oooo00:000>1oooo00B100F2
oooo00F2oooo00N20@R20@R3oooo00812X<03oooo`4<Q04<Q?ooo`4>Q04>
Q@8?QOooo`8@Q@8AQ_ooo`8BQP8CQP8CQoooo`020QF700?oool35XP35hP0
0P<HR0060aV9oooo0aZ90aZ90ab9oooo0P<MRP0511j:oooo11n;122;oooo
00848H`02_ooo`@SS0@TS?ooo`DUSOooo`DVS@DWSPDXS_ooo`85:Xh010DZ
S`D[S`D/S`D/S`86;I0010H^T0H_T0H`T@H`T@86<I401PHbT@HcTPHcTPHd
TPLdTPLeT`<7=Y<21cRC00<7>I@7>Y@7>Y@00PLkU@0423bE23fF23fF23fF
0PPoUP06242F246G246G24:G24>G2D>H0PU4V089AYP01@U6V@U7V@U8V@U8
V@U9VP022DZJ0PY;VP042TbK2TfK2TfK2TjK0PY?W0042U2L2U6L2U:M2U:M
0P]BW@8;E9d010]EWP]FWP]FWP]GW`8;F9l22eVO00@<FZ0<Fj0<Fj0<G:02
35fQ0PaNX@8<Gj801@aQXPeRXPeRXPeRX`eSX`023FBS00H=IJ@=IZ@=IZ@=
IZ@=J:@=J:D23VVU00@>JZD>JjH>JjH>K:H23VfV00H>KZL>KjL>KjL>L:L?
L:P?LJP23g:X00<?LjT?M:T?M:T00`mfZ@8?MjX00a1hZQ1iZa1iZ`0247Z[
0Q1k[08@OJ`00a1n[11o[A5o[@024H2]00LAPJhAPZhAPZhAPZhAQ:hAQ:lA
QJl00Q66[`8BQk0011:8/1:9/1::/A::/@8BRk401Q:</A:=/Q:=/Q:>/Q>>
/Q>?/`8CT;<34i:c00<CTk@CU;@CU;@00Q>E]@8DU[D259Nf0QBI]P0659Zf
59^g59^g59bg59fg5Ifh0aFN^0035J2h5J2i5J6i008EX[T00aFS^QFT^QFT
^P025ZFj00@FY[/FYk/FYk/FZ;/25ZVl00DFZ[`FZk`F[;dF[;dG[;d00aN^
_@045jnn5k2n5k2n5k6o0QNb_`045k>o6;C06;C0b>3H0hS0^0H00004R<2h
00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@
R00000026;C000C8h=R8`;R8`;R8`;P2000018S0^0800002R<2h00A8T8P0
000H]<0H]<02R<2h0DR@R0400001c<c<0002c<c<00B8`;S8h=R8`;R8`;P3
002000nKYo7ooonISkjGR[cIfN__[;?oMW_^Wj]KF:FVVlBFWm9PC9Zl^=go
oolc@jD00`00P00=oooo00:000>1oooo00B100F2oooo00F2oooo00N20@R2
0@R3oooo00812X<03oooo`4<Q04<Q?ooo`4>Q04>Q@8?QOooo`8@Q@8AQ_oo
o`8BQP8CQP8CQoooo`020QF700?oool35XP35hP00P<HR0060aV9oooo0aZ9
0aZ90ab9oooo0P<MRP0511j:oooo11n;122;oooo00848H`02?ooo`@SS0@T
S?ooo`DUSOooo`DVS@DWSP85:8h21BZ>00@5:Xl5:hl5;8l5;8l21Rf@00@6
;Y06;i06<946<9421S6A00H6<Y46<i86<i86=987=987=I<31cJC0PLhT`03
1cVD1cZD1cZD0087>iD010PlU@PmUPPmUPPmUP88?iH01PQ0UPQ1U`Q1U`Q2
U`Q3U`U3V089A9P22DJH00D9AYT9AiT9B9T9B9T9BIX00PU:VP8:BiX010Y<
V`Y=V`Y=V`Y>V`8:Ci`010Y@W0YAW0YBW@YBW@8;DYd22eBM00@;EIh;EYh;
EYh;Eil22eRO0P]IW`0435ZP35^P35^P35bP0PaMX@8<GZ4235nR00D<HJ8=
HZ8=HZ8=HZ<=Hj<00PeTX`063FFT3FJT3FJT3FJT3FRT3FRU0PiYY@043VZU
3V^V3V^V3VbV0Pi]YP063VjW3VnW3VnW3W2W3g2X3g6X0PmbZ0033g>Y3gBY
3gBY00<?MZT23gNZ00<@N:X@NJ/@NJ/00Q1jZ`8@Nj`247f/00<@OZ`@OjdA
Ojd00Q60[@074H6^4H:^4H:^4H:^4HB^4HB_4HF_008AQZl24XN`00@BR;0B
RK0BR[4BR[424X^a00HBS;4BSK8BSK8BS[8CS[8CSk<24i2c0a>B/`034i>d
4iBd4iBd008CUKD259Je0QBG]P8DVKH01QBJ]QBK]aBK]aBL]aBM]aFM^0<E
W[P00aFP^1FP^AFQ^@025J:i00<EXkXEY;XEY;X00QJU^P045ZJk5ZNk5ZNk
5ZRk0QJY_0055ZZl5Z^l5Zbm5Zbm5jbm00<G[[d011N__QN`_QN`_QNa_`8G
/[l011Nc_aRd`1Rd`<SPf0f8`;P00dR@R0000<SPf002R<2h00<00028`;R8
`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^002R<2h
0P0000:8`;P200000hS0^004B92800006;C06;C00XS0^058T8P100000Lc<
c0000/c<c004R<2hb>3HR<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOXZFjP
b<?OThFjFdJCVHnn0WQU[P04@RN5[jG:oooo<d>U0`00P009oooo00:0oooo
00>1oooo00F2oooo00F200N200Coool20@Z300Woool138@138Coool13X@1
3XD23hGoool248D00P8AQP040Q:60Q>60Q>7oooo0P8EQ`03oooo0aJ80aN8
008368P010<IROooo`<JR@<JR@8378T4oooo00<47h/488_oool00P@QS005
oooo12><12B<oooo1BF=00Goool21BZ>00@5:Xl5:hl5;8l5;8l21Rf@00@6
;Y06;i06<946<9421S6A00H6<Y46<i86<i86=987=987=I<31cJC0PLhT`03
1cVD1cZD1cZD0087>iD010PlU@PmUPPmUPPmUP88?iH01PQ0UPQ1U`Q1U`Q2
U`Q3U`U3V089A9P22DJH00D9AYT9AiT9B9T9B9T9BIX00PU:VP8:BiX010Y<
V`Y=V`Y=V`Y>V`8:Ci`010Y@W0YAW0YBW@YBW@8;DYd22eBM00@;EIh;EYh;
EYh;Eil22eRO0P]IW`0435ZP35^P35^P35bP0PaMX@8<GZ4235nR00D<HJ8=
HZ8=HZ8=HZ<=Hj<00PeTX`063FFT3FJT3FJT3FJT3FRT3FRU0PiYY@043VZU
3V^V3V^V3VbV0Pi]YP063VjW3VnW3VnW3W2W3g2X3g6X0PmbZ0033g>Y3gBY
3gBY00<?MZT23gNZ00<@N:X@NJ/@NJ/00Q1jZ`8@Nj`247f/00<@OZ`@OjdA
Ojd00Q60[@074H6^4H:^4H:^4H:^4HB^4HB_4HF_008AQZl24XN`00@BR;0B
RK0BR[4BR[424X^a00HBS;4BSK8BSK8BS[8CS[8CSk<24i2c0a>B/`034i>d
4iBd4iBd008CUKD259Je0QBG]P8DVKH01QBJ]QBK]aBK]aBL]aBM]aFM^0<E
W[P00aFP^1FP^AFQ^@025J:i00<EXkXEY;XEY;X00QJU^P045ZJk5ZNk5ZNk
5ZRk0QJY_0055ZZl5Z^l5Zbm5Zbm5jbm00<G[[d011N__QN`_QN`_QNa_`8G
/[l011Nc_aRd`1Rd`<SPf0f8`;P00dR@R0000<SPf002R<2h00<00028`;R8
`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^003R<2h
100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00007<c<`000;<c<`0
18S0^<SPf8S0^8S0^08008000i^WlOooooooo`02oooo00[o[K3oMW_icMCm
kNkooonVVlB5M[2l^=gooolc@jD4002000Soool00X3oool00h7oool01H;o
ool01H8200N200<1288128?oool00P4:P`03oooo0@b40@b400;oool0104>
Q@8?QOooo`8@Q@824HH0108BQP8CQP8CQoooo`825HL4oooo00D368P36HWo
ooooool36XT00P<LR@837HX010@NR_ooo`@OR`@PR`;oool02`@QS?oooooo
o`@TS?ooo`DUSOooo`DVS@DWSPDXS_ooo`021BZ>00@5:Xl5:hl5;8l5;8l2
1Rf@00@6;Y06;i06<946<9421S6A00H6<Y46<i86<i86=987=987=I<31cJC
0PLhT`031cVD1cZD1cZD0087>iD010PlU@PmUPPmUPPmUP88?iH01PQ0UPQ1
U`Q1U`Q2U`Q3U`U3V089A9P22DJH00D9AYT9AiT9B9T9B9T9BIX00PU:VP8:
BiX010Y<V`Y=V`Y=V`Y>V`8:Ci`010Y@W0YAW0YBW@YBW@8;DYd22eBM00@;
EIh;EYh;EYh;Eil22eRO0P]IW`0435ZP35^P35^P35bP0PaMX@8<GZ4235nR
00D<HJ8=HZ8=HZ8=HZ<=Hj<00PeTX`063FFT3FJT3FJT3FJT3FRT3FRU0PiY
Y@043VZU3V^V3V^V3VbV0Pi]YP063VjW3VnW3VnW3W2W3g2X3g6X0PmbZ003
3g>Y3gBY3gBY00<?MZT23gNZ00<@N:X@NJ/@NJ/00Q1jZ`8@Nj`247f/00<@
OZ`@OjdAOjd00Q60[@074H6^4H:^4H:^4H:^4HB^4HB_4HF_008AQZl24XN`
00@BR;0BRK0BR[4BR[424X^a00HBS;4BSK8BSK8BS[8CS[8CSk<24i2c0a>B
/`034i>d4iBd4iBd008CUKD259Je0QBG]P8DVKH01QBJ]QBK]aBK]aBL]aBM
]aFM^0<EW[P00aFP^1FP^AFQ^@025J:i00<EXkXEY;XEY;X00QJU^P045ZJk
5ZNk5ZNk5ZRk0QJY_0055ZZl5Z^l5Zbm5Zbm5jbm00<G[[d011N__QN`_QN`
_QNa_`8G/[l011Nc_aRd`1Rd`<SPf0f8`;P00dR@R0000<SPf002R<2h00<0
0028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0
^004R<2h0P0000F8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00007<c<`0
00;<c<`018S0^<SPf8S0^8S0^0<008002Z6/l_W=e>8V??Be_n8V??A]OOcS
jOoooog]k_n]/0;oool00c=3Y@00P000P003002000Woool00X3oool00h7o
ool01H;oool01H801h800oooo`030@V30@Z3oooo00;oool00`4<Q?ooo`4>
Q002oooo00P23hD248D24HH24HH24XH24hH24hOoool20QF700?oool35XP3
5hP00P<HR0040aV9oooo0aZ9oooo0P<LR@?oool211n;00<488_oool48H`0
0_ooo`0512><oooo12F=1BF=1BJ=00?oool01@DXSPDZSPDZSPDZS`D[S`02
1Bb?0PH]T0041Rj@1Rn@1S2A1S2A0PHaT@061S:A1S>B1S>B1SBB1cBB1cFC
0`LfT`87>9<00`LiU0LjU0LjU0021c^E00@8?9D8?IH8?IH8?IH223nF00H8
@9H8@IL8@IL8@YL8@iL9@iP22DBH0PU6V0052DJI2DNI2DRI2DRI2DVJ0089
BYX22T^J00@:C9/:CI/:CI/:CY/22TnL00@:D9`:DI`:DYd:DYd22e:M0P]D
W@042eFN2eJN2eJN2eNO0P]HW`8;FIl010aJX0aKX0aKX0aLX08<GJ4235jQ
0PaOXP05366R3F:R3F:R3F:S3F>S008=I:<01PeUY0eVY0eVY0eVY0eXY0eX
Y@8>JJD010iZY@i[YPi[YPi/YP8>KJH01Pi^Y`i_Y`i_Y`i`Y`m`Z0maZ08?
LZP00`mcZ@mdZ@mdZ@033gJY0PmgZP0347RZ47V[47V[008@NZ/247^/0Q1m
[00347j/47n]4Gn]008AP:d01a61[Q62[Q62[Q62[Q64[Q64[a65[`024HJ_
0Q:7/0044XR`4XV`4XZa4XZa0Q:;/@064Xba4Xfb4Xfb4Xjb4hjb4hnc0Q>@
/`<CT[<00a>C]1>D]1>D]0024iFe0QBF]@8DUkH259Vf00HDV[HDVkLDVkLD
W;LDWKLEWKP35Ijh00<EX;PEX;TEXKT00QFR^@035J>j5JBj5JBj008FYKX0
11JV^aJW^aJW^aJX^`8FZK`01AJZ_1J[_1J/_AJ/_AN/_@035jjm00@G[khG
/;hG/;hG/Kl25k:o00@G/klH]<0H]<38h=P=R<2h00=8T8P00038h=P00XS0
^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8
`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400001
c<c<0002c<c<00B8`;S8h=R8`;R8`;P2002000fKYo7mkNkR9SconocgRIOd
HVkcX:kdHVkooOoo[K3lhnWooolc@jD01P00P0;oool200>100@0187ooooo
ool01H8200N200<1288128<12H<00P4:P`06oooo0@b40@b4oooo0@j40@j5
0P8?Q@070Q250Q660Q660Q:60Q>60Q>7oooo00825HL00oooo`<FR0<GR002
0aR800@36HT36XT36XT36XT20ab90P<MRP0411j:11n;11n;122;0`@QS084
8h`00`@TS0@US@DUS@021BJ=00<59hh5:8h5:8h00PDZSP041BZ?1B^?1Bb?
1Bb?0PH]T0041Rj@1Rn@1S2A1S2A0PHaT@061S:A1S>B1S>B1SBB1cBB1cFC
0`LfT`87>9<00`LiU0LjU0LjU0021c^E00@8?9D8?IH8?IH8?IH223nF00H8
@9H8@IL8@IL8@YL8@iL9@iP22DBH0PU6V0052DJI2DNI2DRI2DRI2DVJ0089
BYX22T^J00@:C9/:CI/:CI/:CY/22TnL00@:D9`:DI`:DYd:DYd22e:M0P]D
W@042eFN2eJN2eJN2eNO0P]HW`8;FIl010aJX0aKX0aKX0aLX08<GJ4235jQ
0PaOXP05366R3F:R3F:R3F:S3F>S008=I:<01PeUY0eVY0eVY0eVY0eXY0eX
Y@8>JJD010iZY@i[YPi[YPi/YP8>KJH01Pi^Y`i_Y`i_Y`i`Y`m`Z0maZ08?
LZP00`mcZ@mdZ@mdZ@033gJY0PmgZP0347RZ47V[47V[008@NZ/247^/0Q1m
[00347j/47n]4Gn]008AP:d01a61[Q62[Q62[Q62[Q64[Q64[a65[`024HJ_
0Q:7/0044XR`4XV`4XZa4XZa0Q:;/@064Xba4Xfb4Xfb4Xjb4hjb4hnc0Q>@
/`<CT[<00a>C]1>D]1>D]0024iFe0QBF]@8DUkH259Vf00HDV[HDVkLDVkLD
W;LDWKLEWKP35Ijh00<EX;PEX;TEXKT00QFR^@035J>j5JBj5JBj008FYKX0
11JV^aJW^aJW^aJX^`8FZK`01AJZ_1J[_1J/_AJ/_AN/_@035jjm00@G[khG
/;hG/;hG/Kl25k:o00@G/klH]<0H]<38h=P=R<2h00=8T8P00038h=P00XS0
^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8
`;R8`;P00XS0^0800002R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00007<c<`000;<c<`018S0^<SPf8S0^8S0^08008000i^WlOW=e>8V
?002ojf`00OO92koY9kf_<Go[K3^Nhcooolc@jD01`00P0;oool200>100@0
187oooooool01H8200N200<1288128<12H<00P4:P`06oooo0@b40@b4oooo
0@j40@j50P8?Q@070Q250Q660Q660Q:60Q>60Q>7oooo00825HL00oooo`<F
R0<GR0020aR800@36HT36XT36XT36XT20ab90P<MRP0411j:11n;11n;122;
0`@QS0848h`00`@TS0@US@DUS@021BJ=00<59hh5:8h5:8h00PDZSP041BZ?
1B^?1Bb?1Bb?0PH]T0041Rj@1Rn@1S2A1S2A0PHaT@061S:A1S>B1S>B1SBB
1cBB1cFC0`LfT`87>9<00`LiU0LjU0LjU0021c^E00@8?9D8?IH8?IH8?IH2
23nF00H8@9H8@IL8@IL8@YL8@iL9@iP22DBH0PU6V0052DJI2DNI2DRI2DRI
2DVJ0089BYX22T^J00@:C9/:CI/:CI/:CY/22TnL00@:D9`:DI`:DYd:DYd2
2e:M0P]DW@042eFN2eJN2eJN2eNO0P]HW`8;FIl010aJX0aKX0aKX0aLX08<
GJ4235jQ0PaOXP05366R3F:R3F:R3F:S3F>S008=I:<01PeUY0eVY0eVY0eV
Y0eXY0eXY@8>JJD010iZY@i[YPi[YPi/YP8>KJH01Pi^Y`i_Y`i_Y`i`Y`m`
Z0maZ08?LZP00`mcZ@mdZ@mdZ@033gJY0PmgZP0347RZ47V[47V[008@NZ/2
47^/0Q1m[00347j/47n]4Gn]008AP:d01a61[Q62[Q62[Q62[Q64[Q64[a65
[`024HJ_0Q:7/0044XR`4XV`4XZa4XZa0Q:;/@064Xba4Xfb4Xfb4Xjb4hjb
4hnc0Q>@/`<CT[<00a>C]1>D]1>D]0024iFe0QBF]@8DUkH259Vf00HDV[HD
VkLDVkLDW;LDWKLEWKP35Ijh00<EX;PEX;TEXKT00QFR^@035J>j5JBj5JBj
008FYKX011JV^aJW^aJW^aJX^`8FZK`01AJZ_1J[_1J/_AJ/_AN/_@035jjm
00@G[khG/;hG/;hG/Kl25k:o00@G/klH]<0H]<38h=P=R<2h00=8T8P00038
h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P00hS0^0800004R<2h
0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00007<c<`000;<c<`0
18S0^<SPf8S0^8S0^08008000i^WlOW=e?N9U`02oooo00Oo[K3Q5SCoMW_o
Y9kR9ScoRGlc@jD01`00P008oooo00:000>100>100B100F2oooo00F20P07
PP030@R20@R30@V300812X<01P4;Q04<Q04<Q?ooo`4>Q04>Q@823hD01`8@
Q@8AQP8AQP8BQP8CQP8CQoooo`020QF71Oooo`040aV90aZ90aZ90aZ90P<L
R@837HX010@NRP@OR`@OR`@PR`<48H`212><00<498`49Hd59Hd00PDVS@03
1BN>1BR>1BR>0085:Xh010DZS`D[S`D/S`D/S`86;I0010H^T0H_T0H`T@H`
T@86<I401PHbT@HcTPHcTPHdTPLdTPLeT`<7=Y<21cRC00<7>I@7>Y@7>Y@0
0PLkU@0423bE23fF23fF23fF0PPoUP06242F246G246G24:G24>G2D>H0PU4
V089AYP01@U6V@U7V@U8V@U8V@U9VP022DZJ0PY;VP042TbK2TfK2TfK2TjK
0PY?W0042U2L2U6L2U:M2U:M0P]BW@8;E9d010]EWP]FWP]FWP]GW`8;F9l2
2eVO00@<FZ0<Fj0<Fj0<G:0235fQ0PaNX@8<Gj801@aQXPeRXPeRXPeRX`eS
X`023FBS00H=IJ@=IZ@=IZ@=IZ@=J:@=J:D23VVU00@>JZD>JjH>JjH>K:H2
3VfV00H>KZL>KjL>KjL>L:L?L:P?LJP23g:X00<?LjT?M:T?M:T00`mfZ@8?
MjX00a1hZQ1iZa1iZ`0247Z[0Q1k[08@OJ`00a1n[11o[A5o[@024H2]00LA
PJhAPZhAPZhAPZhAQ:hAQ:lAQJl00Q66[`8BQk0011:8/1:9/1::/A::/@8B
Rk401Q:</A:=/Q:=/Q:>/Q>>/Q>?/`8CT;<34i:c00<CTk@CU;@CU;@00Q>E
]@8DU[D259Nf0QBI]P0659Zf59^g59^g59bg59fg5Ifh0aFN^0035J2h5J2i
5J6i008EX[T00aFS^QFT^QFT^P025ZFj00@FY[/FYk/FYk/FZ;/25ZVl00DF
Z[`FZk`F[;dF[;dG[;d00aN^_@045jnn5k2n5k2n5k6o0QNb_`045k>o6;C0
6;C0b>3H3HS0^003B9280000b>3H00:8`;P900000XS0^005B92800006;C0
6;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00007<c<`000;<
c<`018S0^<SPf8S0^8S0^08008001i^WlOoooo>P[_ARK_ooooN9UoW=e002
oooo00?cX:kooolc@jD02000P00400:000>100>100B10`05PP801h800`48
PP48P`49P`020@Z300<12h@138@138@00P4>Q0040@j50Pn50Pn50Q250P8A
QP040Q:60Q>60Q>70Q>70P8EQ`030QJ70aJ80aN8008368P010<IR@<JR@<J
R@<JR@8378T20af:00@47XX47h/47h/488/3126<0P@SS00312B<12F=1BF=
00859Xd00`DWSPDXSPDXSP021BZ>00@5:Xl5:hl5;8l5;8l21Rf@00@6;Y06
;i06<946<9421S6A00H6<Y46<i86<i86=987=987=I<31cJC0PLhT`031cVD
1cZD1cZD0087>iD010PlU@PmUPPmUPPmUP88?iH01PQ0UPQ1U`Q1U`Q2U`Q3
U`U3V089A9P22DJH00D9AYT9AiT9B9T9B9T9BIX00PU:VP8:BiX010Y<V`Y=
V`Y=V`Y>V`8:Ci`010Y@W0YAW0YBW@YBW@8;DYd22eBM00@;EIh;EYh;EYh;
Eil22eRO0P]IW`0435ZP35^P35^P35bP0PaMX@8<GZ4235nR00D<HJ8=HZ8=
HZ8=HZ<=Hj<00PeTX`063FFT3FJT3FJT3FJT3FRT3FRU0PiYY@043VZU3V^V
3V^V3VbV0Pi]YP063VjW3VnW3VnW3W2W3g2X3g6X0PmbZ0033g>Y3gBY3gBY
00<?MZT23gNZ00<@N:X@NJ/@NJ/00Q1jZ`8@Nj`247f/00<@OZ`@OjdAOjd0
0Q60[@074H6^4H:^4H:^4H:^4HB^4HB_4HF_008AQZl24XN`00@BR;0BRK0B
R[4BR[424X^a00HBS;4BSK8BSK8BS[8CS[8CSk<24i2c0a>B/`034i>d4iBd
4iBd008CUKD259Je0QBG]P8DVKH01QBJ]QBK]aBK]aBL]aBM]aFM^0<EW[P0
0aFP^1FP^AFQ^@025J:i00<EXkXEY;XEY;X00QJU^P045ZJk5ZNk5ZNk5ZRk
0QJY_0055ZZl5Z^l5Zbm5Zbm5jbm00<G[[d011N__QN`_QN`_QNa_`8G/[l0
11Nc_aRd`1Rd`<SPf0f8`;P00dR@R0000<SPf00=R<2h00E8T8P0000H]<0H
]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P100000Lc<c0000/c<
c004R<2hb>3HR<2hR<2h0`00P00;VjOaooooohUooooolj2^lI>Qoooooogo
lj2^oo_l<d>U00P008001002P003P@03P@04P@<01H8200N200<1288128<1
2H<00P4:P`030@^40@b40@b400813X@0104>Q@8?Q@8?Q@8@Q@824HH0108B
QP8CQP8CQ`8CQ`825HL00`8FQ`<FR0<GR0020aR800@36HT36XT36XT36XT2
0ab90P<MRP0411j:11n;11n;122;0`@QS0848h`00`@TS0@US@DUS@021BJ=
00<59hh5:8h5:8h00PDZSP041BZ?1B^?1Bb?1Bb?0PH]T0041Rj@1Rn@1S2A
1S2A0PHaT@061S:A1S>B1S>B1SBB1cBB1cFC0`LfT`87>9<00`LiU0LjU0Lj
U0021c^E00@8?9D8?IH8?IH8?IH223nF00H8@9H8@IL8@IL8@YL8@iL9@iP2
2DBH0PU6V0052DJI2DNI2DRI2DRI2DVJ0089BYX22T^J00@:C9/:CI/:CI/:
CY/22TnL00@:D9`:DI`:DYd:DYd22e:M0P]DW@042eFN2eJN2eJN2eNO0P]H
W`8;FIl010aJX0aKX0aKX0aLX08<GJ4235jQ0PaOXP05366R3F:R3F:R3F:S
3F>S008=I:<01PeUY0eVY0eVY0eVY0eXY0eXY@8>JJD010iZY@i[YPi[YPi/
YP8>KJH01Pi^Y`i_Y`i_Y`i`Y`m`Z0maZ08?LZP00`mcZ@mdZ@mdZ@033gJY
0PmgZP0347RZ47V[47V[008@NZ/247^/0Q1m[00347j/47n]4Gn]008AP:d0
1a61[Q62[Q62[Q62[Q64[Q64[a65[`024HJ_0Q:7/0044XR`4XV`4XZa4XZa
0Q:;/@064Xba4Xfb4Xfb4Xjb4hjb4hnc0Q>@/`<CT[<00a>C]1>D]1>D]002
4iFe0QBF]@8DUkH259Vf00HDV[HDVkLDVkLDW;LDWKLEWKP35Ijh00<EX;PE
X;TEXKT00QFR^@035J>j5JBj5JBj008FYKX011JV^aJW^aJW^aJX^`8FZK`0
1AJZ_1J[_1J/_AJ/_AN/_@035jjm00@G[khG/;hG/;hG/Kl25k:o00<G/klH
]<0H]<003lSPf0030000b>3Hb>3H00g8h=P00`0001Rd`1Rd`00?b>3H00<0
000H]<0H]<000XS0^058T8P100000Lc<c0000/c<c004R<2hb>3HR<2hR<2h
1000P0>KYo401_oooo>P[_Be_oJlaOWAdc=3Y@T008001002P003P@03P@04
P@<01H8200N200<1288128<12H<00P4:P`030@^40@b40@b400813X@0104>
Q@8?Q@8?Q@8@Q@824HH0108BQP8CQP8CQ`8CQ`825HL00`8FQ`<FR0<GR002
0aR800@36HT36XT36XT36XT20ab90P<MRP0411j:11n;11n;122;0`@QS084
8h`00`@TS0@US@DUS@021BJ=00<59hh5:8h5:8h00PDZSP041BZ?1B^?1Bb?
1Bb?0PH]T0041Rj@1Rn@1S2A1S2A0PHaT@061S:A1S>B1S>B1SBB1cBB1cFC
0`LfT`87>9<00`LiU0LjU0LjU0021c^E00@8?9D8?IH8?IH8?IH223nF00H8
@9H8@IL8@IL8@YL8@iL9@iP22DBH0PU6V0052DJI2DNI2DRI2DRI2DVJ0089
BYX22T^J00@:C9/:CI/:CI/:CY/22TnL00@:D9`:DI`:DYd:DYd22e:M0P]D
W@042eFN2eJN2eJN2eNO0P]HW`8;FIl010aJX0aKX0aKX0aLX08<GJ4235jQ
0PaOXP05366R3F:R3F:R3F:S3F>S008=I:<01PeUY0eVY0eVY0eVY0eXY0eX
Y@8>JJD010iZY@i[YPi[YPi/YP8>KJH01Pi^Y`i_Y`i_Y`i`Y`m`Z0maZ08?
LZP00`mcZ@mdZ@mdZ@033gJY0PmgZP0347RZ47V[47V[008@NZ/247^/0Q1m
[00347j/47n]4Gn]008AP:d01a61[Q62[Q62[Q62[Q64[Q64[a65[`024HJ_
0Q:7/0044XR`4XV`4XZa4XZa0Q:;/@064Xba4Xfb4Xfb4Xjb4hjb4hnc0Q>@
/`<CT[<00a>C]1>D]1>D]0024iFe0QBF]@8DUkH259Vf00HDV[HDVkLDVkLD
W;LDWKLEWKP35Ijh00<EX;PEX;TEXKT00QFR^@035J>j5JBj5JBj008FYKX0
11JV^aJW^aJW^aJX^`8FZK`01AJZ_1J[_1J/_AJ/_AN/_@035jjm00@G[khG
/;hG/;hG/Kl25k:o00<G/klH]<0H]<00=1Rd`0:8`;P1B9280@00007<c<`0
00;<c<`018S0^<SPf8S0^8S0^1H008001002P003P@03P@04P@<01H8200N2
00<1288128<12H<00P4:P`030@^40@b40@b400813X@0104>Q@8?Q@8?Q@8@
Q@824HH0108BQP8CQP8CQ`8CQ`825HL00`8FQ`<FR0<GR0020aR800@36HT3
6XT36XT36XT20ab90P<MRP0411j:11n;11n;122;0`@QS0848h`00`@TS0@U
S@DUS@021BJ=00<59hh5:8h5:8h00PDZSP041BZ?1B^?1Bb?1Bb?0PH]T004
1Rj@1Rn@1S2A1S2A0PHaT@061S:A1S>B1S>B1SBB1cBB1cFC0`LfT`87>9<0
0`LiU0LjU0LjU0021c^E00@8?9D8?IH8?IH8?IH223nF00H8@9H8@IL8@IL8
@YL8@iL9@iP22DBH0PU6V0052DJI2DNI2DRI2DRI2DVJ0089BYX22T^J00@:
C9/:CI/:CI/:CY/22TnL00@:D9`:DI`:DYd:DYd22e:M0P]DW@042eFN2eJN
2eJN2eNO0P]HW`8;FIl010aJX0aKX0aKX0aLX08<GJ4235jQ0PaOXP05366R
3F:R3F:R3F:S3F>S008=I:<01PeUY0eVY0eVY0eVY0eXY0eXY@8>JJD010iZ
Y@i[YPi[YPi/YP8>KJH01Pi^Y`i_Y`i_Y`i`Y`m`Z0maZ08?LZP00`mcZ@md
Z@mdZ@033gJY0PmgZP0347RZ47V[47V[008@NZ/247^/0Q1m[00347j/47n]
4Gn]008AP:d01a61[Q62[Q62[Q62[Q64[Q64[a65[`024HJ_0Q:7/0044XR`
4XV`4XZa4XZa0Q:;/@064Xba4Xfb4Xfb4Xjb4hjb4hnc0Q>@/`<CT[<00a>C
]1>D]1>D]0024iFe0QBF]@8DUkH259Vf00HDV[HDVkLDVkLDW;LDWKLEWKP3
5Ijh00<EX;PEX;TEXKT00QFR^@035J>j5JBj5JBj008FYKX011JV^aJW^aJW
^aJX^`8FZK`01AJZ_1J[_1J/_AJ/_AN/_@035jjm00@G[khG/;hG/;hG/Kl2
5k:o00<G/klH]<0H]<00=1Rd`0:8`;P1B9280@00007<c<`000;<c<`00hS0
^<SPf8S0^03oR<2hIXS0^058T8P100000Lc<c0000/c<c003R<2hb>3HR<2h
0?n8`;QVR<2h0DR@R0400001c<c<0002c<c<00>8`;S8h=S8h=P0olSPf6K8
h=P1B9280@00007<c<`000;<c<coR<2hJXS0^0400001c<c<003oc<c<K/c<
c000\
\>"], "Graphics",
  ImageSize->{365, 143},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004/00011b000`400?l00000o`00003o00Ko@7C2
od1e`_m0M<;o@7G2ocmd`Om0ML82od1d`P06od1e`_loM<7o@7G2od1e`_m0M<;o@7G20_loM<401_m0
M<;o@7G2od1d`_m0ML;o?gC1od1e`P;o@7C200Ko@7G2ocmd`Om0ML;o@7G2od1d`_m0ML82ocmd`@06
od1d`_m0ML;o@7C2od1e`_loM<7o@7G20_m0M<801_m_Um7oW;ONokK;j?nT_N;oI8o=od1e`P;o?gC1
00Ko@7C2od1e`_m0M<;o@7G2ocmd`Om0ML82od1d`P06od1e`_loM<7o@7G2od1e`_m0M<;o@7G20_lo
M<401_m0M<;o@7G2od1d`_m0ML;o?gC1od1e`P;o@7C200KoEXG9oinjgom5NL?o@7G2od1d`_m0ML82
ocmd`@06od1d`_m0ML;o@7C2od1e`_loM<7o@7G20_m0M<801_m0ML;o?gC1od1e`_m0ML;o@7C2od1e
`P;o?gC100[o@7C2od1e`_m0M<;o@7G2oeF4b?nP^^3oA7S3od1d`_m0ML;o?gC10_m0ML802_m0M<;o
@7G2ocmd`OloM<7o@7C2od1e`_m0M<;o@7G2ocmd`Om0ML82od1d`P06od1e`_loM<7o@7G2od1e`_m0
M<;o@7G20_loM<401_m0M<;o@7G2od1d`_m0ML;o?gC1od1e`P;o@7C200Ko@7G2ocmd`Om0ML;o@7G2
od1d`_m0ML82ocmd`@06od1d`_m0ML;o@7C2od1e`_loM<7o@7G20_m0M<801_m0ML;o?gC1od1e`_m0
ML;o@7C2od1e`P;o?gC100Ko@7C2od1e`_m0M<;o@7G2ocmd`Om0ML82od1d`P06od1e`_loM<7o@7G2
od1e`_m0M<;o@7G20_loM<401_m0M<;o@7G2od1d`_m0ML;o?gC1od1e`P;o@7C200Ko@7G2ocmd`Om0
ML;o@7G2od1d`_m0ML82ocmd`@06od1d`_m0ML;o@7C2od1e`_loM<7o@7G20_m0M<801_m0ML;o?gC1
od1e`_m0ML;o@7C2od1e`P;o?gC100Ko@7C2od1e`_m0M<;o@7G2ocmd`Om0ML82od1d`P06od1e`_lo
M<7o@7G2od1e`_m0M<;o@7G20_loM<401_m0M<;o@7G2od1d`_m0ML;o?gC1od1e`P;o@7C200Ko@7G2
ocmd`Om0ML;o@7G2od1d`_m0ML82ocmd`@06od1d`P3oool0oooo041e`P0oM<40oooo0P0000001P3o
ool0?gC1041e`P10ML80@7C2041e`P80?gC100H0@7C2od1e`_m0M<;o@7G2ocmd`Om0ML82od1d`P06
od1e`_loM<7o@7G2od1e`_m0M<;o@7G20_loM<406om0M<;o@7G2ok>c/on_[joo_knookNg]onb/[;o
/k>cok^k^oo0`<3oa/K6ol_;booAdM7oeMGEomSHf?oEeMGocLg=ono_komZJV[oKFe]ofm_KombLW;o
M7AdogMgMomiNGWoNg]kogalO001oginOP000_m2N<801om3N<?o@gW3od9h`_m3NL?o@WS2od=h`om3
NL<00om2N<82od=i``0;od=h`om3NL?o@WS2od9h`_m3N<?o@gW3od9h`_m3NL?o@WS2od=h`om3NL<0
0om2N<82od=i``0Bod=h`om3NL?o@WS2od9h`_m3N<?o@gW3od9h`_m3NL?o@WS2od=h`onJ]]koY[oQ
ohBWeondbNKom_SkogBLd_m3N<?o@gW30_m2N<801om3N<?o@gW3od9h`_m3NL?o@WS2od=h`om3NL<0
0om2N<82od=i``0>od=h`om3NL?o@WS2od9h`_m3N<?o@gW3od9h`_m3NL?o@WS2od=h`om6Nl?oj>kf
ohBWeom2N<82od=i``0;od=h`om3NL?o@WS2od9h`_m3N<?o@gW3od9h`_m3NL?o@WS2od=h`om3NL<0
0om2N<82od=i``0;od=h`om3NL?o@WS2od9h`_m3N<?o@gW3odEj`_oXk_OoQ:OGod=h`om3NL<00om2
N<82od=i``0;od=h`om3NL?o@WS2od9h`_m3N<?o@gW3od9h`_m3NL?o@WS2od=h`om3NL<00om2N<82
od=i``0;od=h`om3NL?o@WS2od9h`_m3N<?o@gW3od9h`_m3NL?o@WS2od=h`om3NL<00om2N<82od=i
``0;od=h`om3NL?o@WS2od9h`_m3N<?o@gW3od9h`_m3NL?o@WS2od=h`om3NL<00om2N<82od=i``0;
od=h`om3NL?o@WS2od9h`_m3N<?o@gW3od9h`_m3NL?o@WS2od=h`om3NL<00om2N<82od=i``0;od=h
`om3NL?o@WS2od9h`_m3N<?o@gW3od9h`_m3NL?o@WS2od=h`om3NL<00om2N<82od=i``0;od=h`om3
NL?o@WS2od9h`_m3N<?o@gW3od9h`_m3NL?o@WS2od=h`om3NL<00om2N<82od=i``0;od=h`om3NL?o
@WS2od9h`_m3N<?o@gW3od9h`_m3NL?o@WS2od=h`om3NL<00om2N<82od=i``0;od=h`om3NL?o@WS2
od9h`_m3N<?o@gW3od9h`_m3NL?o@WS2od=h`om3NL<00om2N<82od=i``08od=h`om3NL?o@WS20?oo
o`000000oooo049h`P3oool2000000040?ooo`12N<80@WS2049h`P80@gW300/0@gS304=i``12N<;o
@WS2od=h`om3NL?o@WS2od=i`om2N<;o@gS3od=i``03od9h`P;o@gW301go@gS3od=i`om2N<;o@WS2
okJf]_o@d=3okno_oo7alOo[jn_oh>3PomOGeooHf=Sog]kNonCTi?oZj^[ol?3`oo?cloo`l?3oiNGU
onKVi_mVIVKoJFUYof][Jom^KVkoL71`og9bL_mdM7CoMWIfogMgM`01ogQhN00000?o?g?1ocmc`?ln
Ll000olnLl000oloLl7o?W?0ocic`007ocic`003ocmc`OloLl3o?W?000?o?W?000?o?g?1ocic`?ln
Ll001olnLl001oloLl7o?g?0odala?loM<3o?W?0odEh`_m6NL801OlnLl001_nic>Oob=O[ocic`?ln
Ll3o?g?1ocmc`0Co?W?000?o?g?1ocic`?lnLl001?lnLl000om<O<Co?gC0ocic`002odIi`PCo?W?0
00Go?g?1ocic`?lnLl3oUK7KolkLk`05ocic`003ocmc`OloLl3o?W?000?o?W?000?o?g?1ocic`?ln
Ll001OlnLl001Om<O<Co?gC0ocmc`Om6NL;oAGS200;o?W?000?oUK7KolkLkolnLl002?lnLl000olo
Ll7o?g?0ocic`003ocic`003ocmc`OlnLl3o?W?000Oo?W?000?o?g?1ocmc`?lnLl000olnLl000olo
Ll7o?W?0ocic`007ocic`003ocmc`OloLl3o?W?000?o?W?000?o?g?1ocic`?lnLl001olnLl000olo
Ll7o?g?0ocic`003ocic`003ocmc`OlnLl3o?W?000Oo?W?000?o?g?1ocmc`?lnLl000olnLl000olo
Ll7o?W?0ocic`007ocic`003ocmc`OloLl3o?W?000?o?W?000?o?g?1ocic`?lnLl001olnLl000olo
Ll7o?g?0ocic`003ocic`003ocmc`OlnLl3o?W?000Oo?W?000?o?g?1ocmc`?lnLl000olnLl000olo
Ll7o?W?0ocic`007ocic`005ocmc`@3oool000000000003oool00P0000000`3oool0?W?003ic`006
03ic`00303mc`OloLl3o?W?000?o?W?000?o?g?1ocic`?lnLl001olnLl006oloLl7o?g?0okRh^?oA
dM7olO7aooKfm_ogmoOomOGeonSXj?oLg=coh^;RonKVi_o]kNgolo?cooGemOoclo?oj>SXonk^k_mS
Hf?oIVIVofUYJOm[Jf_oKVi^ofm_KombLW;oLg=cogEeM@01ogIfMP0000?o?W?0ocmd`OloLl400olo
M<401om[Tlooa]G/odMi`oloM<7o?W?0ocmd`OloLl400_loM<402?loLl7o?W?0omORlOnU_N3o?g?1
ocmd`Oo>fnkoW[SO0_lnLl00;_nR^n3ob]W/ocmd`OlnLl3oMYcCooKhnoloLl7o?W?0ol7Bj_ognO_o
j_3gohRYf?o_loWo_<kXocic`?m@OlKo]l_Wom;NkonR^n3oR:SGonO]m_loM<7o?g?1olgJkOnN^Moo
?W?0ocmc`Oo>fnkoW[SOocmc`OlnLl3oPjGFonS^m_lnLl3o?gC1ol3Aj_ognO_oj_3gohRYf?o^loWo
_<kYocic`?o>fnkoW[SOocic`?loLl42ocic`004oi2^f_omoOgoG8W:ocic`0;o?gC100Go?g?1ocic
`?loM<7o?W?0omGPl@02ooknoP0GooOinooJho;oYkkQodMia?lnLl3o?gC1ocic`?o1d^[omoWkon[`
mon8Z=OokoCjokc>j?loLl7o?gC1ohn^f_ono_koG8W:ocic`?loM<7o?W?0ocmd`OlnLl000_loM<40
2?loLl7oj_3gojc3i?lnLl3o?g?1ocmd`OlnLl3o?g?10_lnLl001?loM<7o?W?0ocmd`OlnLl02ocmd
`@08ocmc`OlnLl3o?gC1ocic`?loLl7o?gC1ocic`?loLl42ocic`004ocmd`OlnLl3o?gC1ocic`0;o
?gC100So?g?1ocic`?loM<7o?W?0ocmc`OloM<7o?W?0ocmc`@;o?W?000Co?gC1ocic`?loM<7o?W?0
0_loM<402?loLl7o?W?0ocmd`OlnLl3o?g?1ocmd`OlnLl3o?g?10_lnLl001?loM<7o?W?0ocmd`Oln
Ll02ocmd`@08ocmc`OlnLl3o?gC1ocic`?loLl7o?gC1ocic`?loLl42ocic`004ocmd`OlnLl3o?gC1
ocic`0;o?gC100So?g?1ocic`?loM<7o?W?0ocmc`OloM<7o?W?0ocmc`@;o?W?000Co?gC1ocic`?lo
M<7o?W?00_loM<402?loLl7o?W?0ocmd`OlnLl3o?g?1ocmd`OlnLl3o?g?10_lnLl001?loM<7o?W?0
ocmd`OlnLl02ocmd`@08ocmc`OlnLl3o?gC1ocic`?loLl7o?gC1ocic`?loLl42ocic`004ocmd`Oln
Ll3o?gC1ocic`0;o?gC100?o?g?1ocic`03oool01@0000050?ooo`0;03ic`00oM<40?gC103mc`@0n
Ll3o?gC1ocic`?loLl7o?gC1ocic`?loLl400_lnLl001?loM<7o?W?0ocmd`OlnLl02ocmd`@0Locmc
`OlnLl3o?gC1okZj^_oBd];olO7aooKfm_ohn?SonOWiooCdm?oNg]koi>CTon_[joo`l?3on?ShooWi
nOoemOGojn_[ookno_mTI6CoJ6QXofYZJ_m]KFgoKfm_og9bL_mdM7CoMGEeogMgM`7oN7Qh00002olo
M<7o@7G2od1e`_loM<7o@7C2ofbEd?oen?_oooooom;Nl?m8N/Co@7G200;o@7C20_loM<401?m0M<7o
?gC1omORlOnV_^82ocmd`@0holoLkonN^=oo@7C2od1d`OnR^n3oc=[^ocmd`Om0M<7oMigCooOhnom0
M<7oJY;>oo_ko?mIQ/WoDH77ok[<j?obmO[o?gC1od1d`_o4e>cofnGcohFVeonQ^n3ogNKconocnOlo
M<7o@7C1olkKk_nN^Moo@7C1ocmd`Oo>fnkoWkWPocmd`Om0M<;oQ:KGonS^mom0M<7oJY;>oo_loOmI
Q/WoDH77ok[=j?oamO[o?gC1od1d`Oo>fnkoW[WOod1d`OloM<7o@7C2od1d`OoJi??omoWloj[0hom0
M<42ocmd`@0Dod1d`OloM<7o?gC1od1d`OoEh?7oYkoRod1d`Om6N<?oIY3>ol_Ik_oUjoKoBWc4ocmd
`OmZT/oonocmoeV6b?mAPLOo^/cXoo7en_m0M<42ocmd`@08om_Tloogn?_oZ/7Tod1d`OloM<7o@7C1
ocmd`Om0M<42ocmd`@04od1d`Onhb^SokO7iod5e`@;o?gC100So@7C1ocmd`Om0M<;o@7C1ocmd`Om0
M<7o?gC1od1d`@;o?gC100Co@7C1ocmd`OloM<7o@7C10_loM<402?m0M<7o?gC1od1d`_m0M<7o?gC1
od1d`OloM<7o@7C10_loM<401?m0M<7o?gC1ocmd`Om0M<42ocmd`@08od1d`OloM<7o@7C2od1d`Olo
M<7o@7C1ocmd`Om0M<42ocmd`@04od1d`OloM<7o?gC1od1d`@;o?gC100So@7C1ocmd`Om0M<;o@7C1
ocmd`Om0M<7o?gC1od1d`@;o?gC100Co@7C1ocmd`OloM<7o@7C10_loM<402?m0M<7o?gC1od1d`_m0
M<7o?gC1od1d`OloM<7o@7C10_loM<401?m0M<7o?gC1ocmd`Om0M<42ocmd`@08od1d`OloM<7o@7C2
od1d`OloM<7o@7C1ocmd`Om0M<42ocmd`@04od1d`OloM<7o?gC1od1d`@;o?gC100So@7C1ocmd`Om0
M<;o@7C1ocmd`Om0M<7o?gC1od1d`@;o?gC100Co@7C1ocmd`OloM<7o@7C10_loM<402?m0M<7o?gC1
od1d`_m0M<7o?gC1od1d`OloM<7o@7C10_loM<400om0M<7o?gC10?ooo`08000000030?ooo`0oM<40
@7C10080?gC100@0@7C103md`OloM<7o@7C10_loM<402?m0M<7o?gC1od1d`_m0M<7o?gC1od1d`Olo
M<7o@7C10_loM<407?m0M<7o?gC1ocmd`Onn_[kodm?Coo;bl_ohn?SonOWioo_knoojn_[oh>3PonOW
ioo/k>colo?cooWinOolo?con?Shonk^k_o_knooJ6QXofYZJ_m^KVkoLG5aog=cLomfMWKoN7QhogYj
N_mkNg/1ogemO@0002[o>6VlocMY_?lhJKco>6VlofB;booemo[odmg_og>Fcooen?[ocm[^od1`_olg
JKco=fVkocIX^olgJKco=fRkocMY_?oDg^ooXKSOocMY_?lfJ;_oc=S]oiZcg?lgJ;_o=fVloijfgOo9
e^co=fVlocIX^omaTlkom_SkocMX^omDOlGon__lofZ>cOlgJKcoPJ3DonC[mOlgJKco?FfmooKhnom/
TLd2ocMY_006ohNVe_o_loSo=fVlocMX^oo<f>goVK?L0_lgJK`04Oo;encoV[?MocMY_?lgJ;_oOioC
onO/m_lgJKcoE7o5oo[ko?mYS/co=fVloh6Pe?oTjoGo=fRkocMY_?o<f>goVK?L00;o=fVl00ko=fRk
oen6bOolo?coPJ3Donobn?lkK;co=VRkocMY_?lgJ;_o=fVlocMX^olgJKcodmk`oj>ig`;o=fVl00_o
=fRkoc]/_OoUjoGoYK_OocMY_?mDO/Con__lofZ>cOlgJ;_oPJ3DonCZm@02ocMY_006oej5b?omoOgo
PJ3Donkbn?llKKgo=fVk0_lgJK`2ocIX^`07ocMY_?lgJ;_oGXG8ooclo?m]T<go=fVlocIX^`02ocMY
_003ocMX^olgJKco=fVk00;o=fVl0_lfJ;/01?lgJKco=fRkocMY_?lgJ;/2ocMY_006ocIX^olgJKco
=fVlocMX^olgJKco=fVk0_lgJK`2ocIX^`04ocMY_?lgJ;_o=fVlocMX^`;o=fVl00Ko=VRkocMY_?lg
JKco=fRkocMY_?lgJK/2ocMY_0;o=VRk00Co=fVlocMX^olgJKco=fRk0_lgJK`01_lfJ;_o=fVlocMY
_?lgJ;_o=fVlocMY^`;o=fVl0_lfJ;/01?lgJKco=fRkocMY_?lgJ;/2ocMY_006ocIX^olgJKco=fVl
ocMX^olgJKco=fVk0_lgJK`2ocIX^`04ocMY_?lgJ;_o=fVlocMX^`;o=fVl00Ko=VRkocMY_?lgJKco
=fRkocMY_?lgJK/2ocMY_0;o=VRk00Co=fVlocMX^olgJKco=fRk0_lgJK`01_lfJ;_o=fVlocMY_?lg
J;_o=fVlocMY^`;o=fVl0_lfJ;/01?lgJKco=fRkocMY_?lgJ;/2ocMY_006ocIX^olgJKco=fVlocMX
^olgJKco=fVk0_lgJK`2ocIX^`04ocMY_?lgJ;_o=fVl0?ooo`L0000000<0oooo03MY_00gJK`00P0f
J;/0100gJK`0=fRk03MY_?lgJ;/2ocMY_006ocIX^olgJKco=fVlocMX^olgJKco=fVk0_lgJK`2ocIX
^`0MocMY_?lgJ;_o=fVlocMX^onm_Kgodm?Coo7alOofm_Kon?ShooWinOojn_[o/;2`onSXj?o]kNgo
lo?cooWinOolo?con?Shono_kooVi^KoI6ATofMWIomYJFWoKFe]ofm_KomaLG7oM7AdogEeMOmgMgL0
0OmhN7P0000<ocmc`OlnLl3o?W?0ofZCc_odmoWoe=o_odUk`olnLl3oKIG?ooGgn_o@g>koAWS20_ln
Ll00@_lnL/3o?G:oocic`?oEhO3oY;_Oocic`?lnL[ooc=[]oifgg_lmL[oo?W?0oj2jg_o:f>_o?W:o
ocic`?mfVm;omOOjoceb_olnLl3oNioBomOQl?oFhO7oe=o_onC[m?lnLl3oJY?=oogmoOm@OlGo?G:o
ocib_omlWmCol?Chocib_olmL[oocM[]oifgg_lmL[oo?W?0olgJkOnM]mgo?W?0oceb_on3Y=Goinge
oceb_olnL[ooNioComSRlOoFh?3oe=k_onG[mOlnLl3o?G:oolgJkOnM]mko?W:oocic`?lmL[oo[/CS
olcIkOlmL[oog^Kboh:SeOlnLl3o?W:ooceb_`;o?W?001[o?G:oomCOl?nU_^7o?W:oocic`?lmL[oo
?W?0oinig_oRjOCo?W:oocic`?mkWm?oen7`omKPl?oEgo3oi>_doceb_olnLl3o[/?SolcIkOlnLl3o
g^Kboh:SeOlnL[oo?G:oocib_`;o?W?000Ko?W:ooceb_olnLl3o^<_Vok[<iolnLl02ocib_`06ocic
`?lmL[oo?W?0ocib_olmL[oo?W:o0_lnLl001_lnL[oo?G:oocic`?lnLl3o?G:oocic`0;o?W:o00Ko
?W?0oceb_olnLl3o?W:ooceb_olnL[l2ocic`006ocib_olmL[oo?W?0ocic`?lmL[oo?W?00_lnL[l0
1_lnLl3o?G:oocic`?lnL[oo?G:oocib_`;o?W?000Ko?W:ooceb_olnLl3o?W?0oceb_olnLl02ocib
_`06ocic`?lmL[oo?W?0ocib_olmL[oo?W:o0_lnLl001_lnL[oo?G:oocic`?lnLl3o?G:oocic`0;o
?W:o00Ko?W?0oceb_olnLl3o?W:ooceb_olnL[l2ocic`006ocib_olmL[oo?W?0ocic`?lmL[oo?W?0
0_lnL[l01_lnLl3o?G:oocic`?lnL[oo?G:oocib_`;o?W?000Ko?W:ooceb_olnLl3o?W?0oceb_oln
Ll02ocib_`06ocic`?lmL[oo?W?0ocib_olmL[oo?W:o0_lnLl001_lnL[oo?G:oocic`?lnLl3o?G:o
ocic`0;o?W:o00Ko?W?0oceb_olnLl3o?W:ooceb_olnL[l2ocic`004ocib_olmL[oo?W?00?ooo`H0
000000@0oooo03ib_`0mL[l0?W:o0P0nLl001P0nL[l0?G:o03ic`?lnLl3o?G:oocic`0;o?W:o00Ko
?W?0oceb_olnLl3o?W:ooceb_olnL[l2ocic`008ocib_olmL[oo?W?0ocic`?nk^k_od];Boo3`l?of
m_H2ooShn00ComKFe_m<C4co`l?3on_[jooemOGon_[jooclo?ohn?Sokno_ong]kOmRHV;oIFEUofQX
J?mZJV[oKFe]ofm_KomaLG7oLg=cogEeM@01ogIfMP0000KoA7[4od=j`om4N/CoU;;LomKQlOm>P/H2
od=j``0?odAja?maV];omOOkom;Ol?m;OlGo@gW3od=j`om3NL?o@g[3omKRlOnW`>;o@gW3od=j`oo>
g>ko[LCS00;o@g[3017oYKkQomSSlOm3N/?o@gW3ogZPdoognO_o@gW3od=j`om2NL;o@g[3odAj`onA
/McoiNceod9i`_mMS<[oo_knogVOd`02od=j``0>ognTe_o`loSo@g[3od=i`oo>g>koX;_Pod=j`om3
NL?ocmc_okW<j?m2NL;o@g[3oh^/fOoXk_H2od=j``0Kod=i`om2NL;oA7_3oi6`fooUk?Go@WW2od=j
`oo>fnko/LOUod=j`om2NL;oB7g5oo;en_n7Z]So@g[3oiBbg?o?g>ko@WW2od=j`om3NL?o@g[3od9i
`_m3N/?oe^7`ojS1h_m3N/?o@WW200;o@g[3013oRZcIoo[ko?m7OLCo@gW3od9i`_m3N/?oA7[3oi6`
g?oUjoCo@g[3odQmaOobmO[oQj[Hod9i`_nD/]_od=g^0om3N/<02?m3NL?o@WW2od=j`om3NL?o@g[3
oeN7bOocm_[oK9O?0_m3N/<00om2NL;o@g[3od=j``03od=j``08od=i`om2NL;o@g[3od=i`om3N/?o
@WW2od=j`om3NL<2od=j``03od9i`_m3N/?o@g[300?o@g[300So@gW3od9i`_m3N/?o@gW3od=j`om2
NL;o@g[3od=i``;o@g[300?o@WW2od=j`om3N/<00om3N/<02?m3NL?o@WW2od=j`om3NL?o@g[3od9i
`_m3N/?o@gW30_m3N/<00om2NL;o@g[3od=j``03od=j``08od=i`om2NL;o@g[3od=i`om3N/?o@WW2
od=j`om3NL<2od=j``03od9i`_m3N/?o@g[300?o@g[300So@gW3od9i`_m3N/?o@gW3od=j`om2NL;o
@g[3od=i``;o@g[300?o@WW2od=j`om3N/<00om3N/<02?m3NL?o@WW2od=j`om3NL?o@g[3od9i`_m3
N/?o@gW30_m3N/<00om2NL;o@g[3od=j``03od=j``08od=i`om2NL;o@g[3od=i`om3N/?o@WW2od=j
`om3NL<2od=j``03od9i`_m3N/?o@g[300?o@g[300Ko@gW3od9i`_m3N/?o@gW3od=j``3oool50000
00030?ooo`13N/<0@g[30080@g[300P0@gW3049i`P13N/<0@gW304=j`om2NL;o@g[3od=i``;o@g[3
00?o@WW2od=j`om3N/<00om3N/<07om3NL?o@WW2od=j`om3NL?o@g[3od9i`_nm_KgodM7Aoo;bl_og
moOon?ShooWinOmiNGWoCDe=ofe]KOoZj^[omOGeoo[jn_olo?conOWiono_koomoOgoHf=SofIVI_mZ
JV[oK6a/ofm_KomaLG7oLg=cogEeMOmgMgL00OmhN7P0000>od1e`_m0M<;o?gC1od1e`_m2M/;o@7G2
od1d`_m0ML;o?gC1od1d`_m^U]3omoSlom;Nkom8NL@3ocmd`@0>omORlOnU_N7o?gC1ocmc`Oo>fnko
k_;hoiFbgOm@P<Goc]_^onK]m_nfb^OoEH?8ojW0hooHh_82ocmd`@05ogJLdomJQlWo@GG1okC9i_no
d>T00_loM<401_oBgNoobMS]oeB3aom:O<Co_LoYoo7en@;o?gC1017ocmc^oijhgoloM<7o?gC1olkK
k_o_loWoYKgQoeR6bOnlc^Soa=C[ocmc`OloM<7oMigCoeZ7bOm1ML7o]LWVoko@jP02ocmd`@0;olkL
k_o_loWoTJoKoe>2aon4Y]OoloGjodIh`oloLl7oC7g5ooOinomLRLX01OloM<400ooFh?7oY[oQocmd
`@03ocmd`@0Boi:_foojnoco@WK2ocmd`OmfW=?oFXS:od5e`Oneb^Oo_m3Yocmd`On4Y]Ool_GjodIi
`oloM<7oC7g5ooKhnomLRL[o?g?11oloM<400onC/M_ofN?bod1d`@05ocmd`@03ocmc`OloM<7o?gC1
00Oo?gC100?o?g?1ocmd`OloM<400oloM<400oloLl7o?gC1ocmd`@07ocmd`@03ocmc`OloM<7o?gC1
00?o?gC100?o?g?1ocmd`OloM<401oloM<400oloLl7o?gC1ocmd`@03ocmd`@03ocmc`OloM<7o?gC1
00Oo?gC100?o?g?1ocmd`OloM<400oloM<400oloLl7o?gC1ocmd`@07ocmd`@03ocmc`OloM<7o?gC1
00?o?gC100?o?g?1ocmd`OloM<401oloM<400oloLl7o?gC1ocmd`@03ocmd`@03ocmc`OloM<7o?gC1
00Oo?gC100?o?g?1ocmd`OloM<400oloM<400oloLl7o?gC1ocmd`@04ocmd`@030?ooo`0000000000
0080000000D0oooo03md`@0oM<40?gC103mc`@0603md`@?o?gC100?o?g?1ocmd`OloM<400oloM<40
0oloLl7o?gC1ocmd`@05ocmd`@0Iokno_ooDe=Col_;booShn?oinOWo^k^koeEEEOm>CTkoD51@ok2`
/?oemOGono_kookno_ojn_[ol?3`ono_komVIVKoJVYZofe]KOm`L73oLg=cogEeMOmhN7SoNWYjog]k
N`01ogemO@000_lgJK`01?lhJ[co>6VlocMY_?lhJK`2ocMY_00NocQY_?lgJKco>6VlofR>c?odm_Wo
d=_^ocm___lgJKco=VRkomCNkonQ^=oo=fVlocIX^onlc>OoT:_HojBjgoo`m?WogNGboeN1a_n5XmGo
j>geonC[mOmeUm3o=fVlocIX^onA[=Woe^7`oo3dnOo@fnkoI8_;0_lfJ;/02_m<NL;oamC[ooCgn_oM
iO;oX;ONomgTl_lfJ;_o=fVlok_;i_n?Z]T2ocMY_00Rok_;i_n@[=WoW[KMongamooIh_7oHh[:ocMY
_?lfJ;_oT:cIomKPl?o`loSod=c_of>:b_lgJK_o=fVlokc;ionB[MWo]LOUooGgn_njbnKoYK[OocIX
^olgJKco=VRkojRnh?nE[m_o=VRkocMY_?lfJ;_o=fVkocMY_?oCgNooXkWOocMY_0;o=VRk00?o=fVk
okg=iooKho400_lfJ;/02OnA[M[oeN3`oo7dnOo@fnkoI8_;ocMY_?ngbNKoY;[OocMY_002ocIX^`03
ojVnhOnD[m[o=fVl00;o=VRk00Wo=fVlocIX^olgJKco=VRkocMY^oliJ[cof>7`ohNUeOlgJK`00_lf
J;/00olgJK_o=VRkocMY_002ocIX^`05ocMY_?lfJ;_o=fVlocIX^olgJK/00_lgJK`01olfJ;_o=fVl
ocIX^olfJ;_o=fVkocIX^olgJK`00_lfJ;/01OlgJKco=VRkocMY_?lfJ;_o=fVk00;o=fVl00Oo=VRk
ocMY_?lfJ;_o=VRkocMY^olfJ;_o=fVl00;o=VRk00Go=fVlocIX^olgJKco=VRkocMY^`02ocMY_007
ocIX^olgJKco=VRkocIX^olgJK_o=VRkocMY_002ocIX^`05ocMY_?lfJ;_o=fVlocIX^olgJK/00_lg
JK`01olfJ;_o=fVlocIX^olfJ;_o=fVkocIX^olgJK`00_lfJ;/01OlgJKco=VRkocMY_?lfJ;_o=fVk
00;o=fVl00Oo=VRkocMY_?lfJ;_o=VRkocMY^olfJ;_o=fVl00;o=VRk00Go=fVlocIX^olgJKco=VRk
ocMY^`02ocMY_007ocIX^olgJKco=VRkocIX^olgJK_o=VRkocMY_002ocIX^`05ocMY_?lfJ;_o=fVl
ocIX^olgJK/00_lgJK`01olfJ;_o=fVlocIX^olfJ;_o=fVkocIX^olgJK`00_lfJ;/01OlgJKco=VRk
ocMY_?lfJ;/0oooo00<0000000H0oooo03IX^`0fJ;/0=fVk03IX^`0gJK`203IX^`0503MY_00fJ;/0
=fVl03IX^olgJK/00_lgJK`01olfJ;_o=fVlocIX^olfJ;_o=fVkocIX^olgJK`00_lfJ;/07_lgJKco
=VRkocMY_?lfJ;_o=fVkokjn__oBd];olO7aooOgmoo^k^koIVIVoeADE?m<C4coCdm?oeaLG?oXj>So
no_koogmoOoinOWok^k^onKVi_mSHf?oIVIVofUYJOm/K6coKfm_og5aLOmcLg?oMGEeogMgM`7oN7Qh
0006ocic`004ocmd`OlnLl3o?W?0ocmc`@;o?W?000?oKIG?ooCfn_nZ`N800_lnL/003_oEh>ooY;_O
ocib_olmL[oo?W;0ocic`?lnL/3o?W:oocic`?lnL/3o?G:oocic`?lnL[oo?G:o0_lnL/003_lnL[oo
?G:oocmc_olmL[oo?W;0ocic`?lnL/3o?W:oocic`?loLl3o?G:oocic`?lnL[oo?G:o0_lnL/003_ln
L[oo?G:oocib_olmL[oo?W;0ocic`?lnL/3o?W:oocic`?lnL/3o?G:oocic`?lnL[oo?W>o0_lnL/00
3_lnL[oo?G:oocib_olmL[oo?W;0od1d`?lnL/3o?W:oocic`?lnL/3o?G:oocic`?lnL[oo?G:o0_ln
L/007_lnL[oo?G:oomCOl?nU_N3o?W;0ocic`?lnL/3oQJKFooclo?n3YMGo?G:oocic`?lnL[oo?G:o
ocmc`?lnL/3o?W:ooceb_olnL[oo?G:oocib`?lnLl3o?W;0ocib_olnLl3o?W;0oceb_olnLl3o?W:o
oceb_`;o?W;000ko?W:ooceb_omUT<cokO7godama?lnLl3o?W;0ocib_olnLl3o?W;0oceb_olnLl3o
?W:ooceb_`;o?W;000ko?W:ooceb_olnL[oo?G:oocib`?lnLl3o?W;0ocib_olnLl3o?W;0oceb_oln
Ll3o?W:ooceb_`;o?W;000ko?W:ooceb_olnL[oo?G:oocib`?lnLl3o?W;0ocib_olnLl3o?W;0oceb
_olnLl3o?W:ooceb_`;o?W;000ko?W:ooceb_olnL[oo?G:oocib`?lnLl3o?W;0ocib_olnLl3o?W;0
oceb_olnLl3o?W:ooceb_`;o?W;000ko?W:ooceb_olnL[oo?G:oocib`?lnLl3o?W;0ocib_olnLl3o
?W;0oceb_olnLl3o?W:ooceb_`;o?W;000ko?W:ooceb_olnL[oo?G:oocib`?lnLl3o?W;0ocib_oln
Ll3o?W;0oceb_olnLl3o?W:ooceb_`;o?W;000ko?W:ooceb_olnL[oo?G:oocib`?lnLl3o?W;0ocib
_olnLl3o?W;0oceb_olnLl3o?W:ooceb_`;o?W;000ko?W:ooceb_olnL[oo?G:oocib`?lnLl3o?W;0
ocib_olnLl3o?W;0oceb_olnLl3o?W:ooceb_`;o?W;000h0oooo000000000000oooo03ib`00nLl00
?W;003ib_`0nLl00?W;003eb_`0nLl00?W:o03eb_`80?W;000ko?W:ooceb_olnL[oo?G:oocib`?ln
Ll3o?W;0ocib_olnLl3o?W;0oceb_olnLl3o?W:ooceb_`;o?W;001[o?W:ookbl_?oBd];ol?3`ooOg
monTY:CoE5ADoe=CDom=CDgoCdm?oe1@D?nFUYKonOWiooclo?oinOWok^k^ong]kOmRHV;oIFEUofQX
J?mZJV[oKFe]ofm_KomaLG7oLg=cogEeM@7oMWIf00001_m4N/Co@g[3odAja?m4N/Co@g[3odAja0;o
@g[300?oA7[4od=j`om3N/<00_m3N/<04?mZULooC836od=i`om3N/?oe^;aojO0h_m3N/?o@gW3od=j
`om3NL?o@WW2od=j`om3NL?o@WW2od=j`om3NL<2od=j``03od=i`om3N/?o@WW200;o@g[300Wo@gW3
od=j`om3NL?o@WW2od=j`om3NL?o@WW2od=j`om3NL<00_m3N/<00om3NL?o^loXoi:af`02od=j``09
od=i`om3N/?o@gW3od9i`_m3N/?o@gW3od9i`_m3N/?o@gW300;o@g[300?o@gW3od=j`om2NL800_m3
N/<02Om3NL?o@g[3od=i`om2NL;o@g[3od=i`om2NL;o@g[3od=i``02od=j``0>od=i`om3N/?o@WW2
od=j`ooFhO3ofnGbokC:i_o3e>[og>GbooSjnonC/mco@WW2od=j`om3NL<2od=j``03od=i`om3N/?o
@WW200;o@g[300Wo@gW3od=j`om3NL?o@WW2od=j`om3NL?o@WW2od=j`om3NL<00_m3N/<03_nG]Mgo
e>3`om?Pl?oDh?3oe>7`ooKgn_nA/Mco@gW3od9i`_m3N/?o@gW3od9i`_m3N/?o@gW30_m3N/<00om3
NL?o@g[3od9i`P02od=j``09od=i`om3N/?o@gW3od9i`_m3N/?o@gW3od9i`_m3N/?o@gW300;o@g[3
00?o@gW3od=j`om2NL800_m3N/<02Om3NL?o@g[3od=i`om2NL;o@g[3od=i`om2NL;o@g[3od=i``02
od=j``03od=i`om3N/?o@WW200;o@g[300Wo@gW3od=j`om3NL?o@WW2od=j`om3NL?o@WW2od=j`om3
NL<00_m3N/<00om3NL?o@g[3od9i`P02od=j``09od=i`om3N/?o@gW3od9i`_m3N/?o@gW3od9i`_m3
N/?o@gW300;o@g[300?o@gW3od=j`om2NL800_m3N/<02Om3NL?o@g[3od=i`om2NL;o@g[3od=i`om2
NL;o@g[3od=i``02od=j``03od=i`om3N/?o@WW200;o@g[300Wo@gW3od=j`om3NL?o@WW2od=j`om3
NL?o@WW2od=j`om3NL<00_m3N/<00om3NL?o@g[3od9i`P02od=j``09od=i`om3N/?o@gW3od9i`_m3
N/?o@gW3od9i`_m3N/?o@gW300;o@g[300ko@gW3od=j``3oool000000?ooo`13NL<0@g[304=i``12
NL80@g[304=i``12NL80@g[304=i``80@g[300<0@gW304=j`om2NL800_m3N/<02Om3NL?o@g[3od=i
`om2NL;o@g[3od=i`om2NL;o@g[3od=i``02od=j``0Lod=i`om3N/?o@WW2okfm_OoCdm?ol_;booOg
moohn?SonOWiooGemOoQhN7oj>SXong]kOoclo?ono_koogmoOoinOWokno_ookno_mSHf?oIfMWofUY
JOm/K6coKfm_og5aLOmcLg?oMGEeogMgM`7oN7Qh00001OloM<7o@7G2od1d`_loM<7o@7G200;o?gC1
0_m0ML801?loM<7o@7G2od1e`_m0ML82ocmd`@;o?g?100GoNioDofNAcOloLl7o?gC1ocmc`003ocmd
`@03ocmc`OloM<7o?gC100?o?gC10_loLl42ocmd`@03ocmc`OloM<7o?g?000?o?gC100?o?g?1ocmd
`OloM<400oloM<401oloLl7oMYcCofB>c?loM<7o?g?1ocmd`OloLl000oloM<400oloLl7o?gC1ocmd
`@03ocmd`@;o?g?10_loM<400oloLl7o?gC1ocmc`003ocmd`@03ocmc`OloM<7o?gC100?o?gC10_lo
Ll42ocmd`@07ogVNe?n;ZmWoRZ[HohBUe_m[U=3oCWo6ocmc`@05ocmd`@;o?g?10_loM<400oloLl7o
?gC1ocmc`003ocmd`@03ocmc`OloM<7o?gC100?o?gC100?oJYC?ohZZf?n;ZmT00_n:Z]P00on;ZmWo
H8_;ocmd`@02ocmd`@03ocmc`OloM<7o?gC100?o?gC10_loLl42ocmd`@03ocmc`OloM<7o?g?000?o
?gC100?o?g?1ocmd`OloM<400oloM<42ocmc`@;o?gC100?o?g?1ocmd`OloLl000oloM<400oloLl7o
?gC1ocmd`@03ocmd`@;o?g?10_loM<400oloLl7o?gC1ocmc`003ocmd`@03ocmc`OloM<7o?gC100?o
?gC10_loLl42ocmd`@03ocmc`OloM<7o?g?000?o?gC100?o?g?1ocmd`OloM<400oloM<42ocmc`@;o
?gC100?o?g?1ocmd`OloLl000oloM<400oloLl7o?gC1ocmd`@03ocmd`@;o?g?10_loM<400oloLl7o
?gC1ocmc`003ocmd`@03ocmc`OloM<7o?gC100?o?gC10_loLl42ocmd`@03ocmc`OloM<7o?g?000?o
?gC100?o?g?1ocmd`OloM<400oloM<42ocmc`@80oooo00<0?g?103md`@0oLl000`0oM<400`0oLl40
?gC103md`@0303md`@80?g?10_loM<400oloLl7o?gC1ocmc`003ocmd`@03ocmc`OloM<7o?gC100?o
?gC10_loLl406_loM<7o_[jnomCDe?oclo?omoOgooWinOojn_[omoOgon;Rh_oYjNWok^k^ooGemOol
o?coo_knoo[jn_o`l?3okno_ofMWIomZJV[oKFe]og1`L?mcLg?oMGEeogQhN?mjNW[oNg]k0OmmOGd0
0005ocQZ_?lgJKco=fVlocMY_?lhJK`01?lgJK`01?lhJKco=fVlocMX^olfJ;/2ocMY_007ocMY^olg
JKco=fVkocIX^olgJK_o=fVlocIX^`02ocMY^`03ocIX^olgJKco=fVk00;o=VRk00Wo=fVkocMY_?lg
JK_o=fVlocMY^olfJ;_o=fVkocMY_?lfJ;/00_lgJK/00olfJ;_o=fVlocMY^`02ocIX^`09ocMY^olg
JKco=fVkocMY_?lgJK_o=VRkocMY^olgJKco=VRk00;o=fVk00?o=VRkocMY_?lgJK/00_lfJ;/02Olg
JK_o=fVlocMY^olgJKco=fVkocIX^olgJK_o=fVlocIX^`02ocMY^`03ocIX^olgJKco=fVk00;o=VRk
00Wo=fVkocMY_?lgJK_o=fVlocMY^olfJ;_o=fVkocMY_?lfJ;/00_lgJK/00olfJ;_o=fVlocMY^`02
ocIX^`09ocMY^olgJKco=fVkocMY_?lgJK_o=VRkocMY^olgJKco=VRk00;o=fVk00?o=VRkocMY_?lg
JK/00_lfJ;/02OlgJK_o=fVlocMY^olgJKco=fVkocIX^olgJK_o=fVlocIX^`02ocMY^`03ocIX^olg
JKco=fVk00;o=VRk00Wo=fVkocMY_?lgJK_o=fVlocMY^olfJ;_o=fVkocMY_?lfJ;/00_lgJK/00olf
J;_o=fVlocMY^`02ocIX^`09ocMY^olgJKco=fVkocMY_?lgJK_o=VRkocMY^olgJKco=VRk00;o=fVk
00?o=VRkocMY_?lgJK/00_lfJ;/02OlgJK_o=fVlocMY^olgJKco=fVkocIX^olgJK_o=fVlocIX^`02
ocMY^`03ocIX^olgJKco=fVk00;o=VRk00Wo=fVkocMY_?lgJK_o=fVlocMY^olfJ;_o=fVkocMY_?lf
J;/00_lgJK/00olfJ;_o=fVlocMY^`02ocIX^`09ocMY^olgJKco=fVkocMY_?lgJK_o=VRkocMY^olg
JKco=VRk00;o=fVk00?o=VRkocMY_?lgJK/00_lfJ;/02OlgJK_o=fVlocMY^olgJKco=fVkocIX^olg
JK_o=fVlocIX^`02ocMY^`03ocIX^olgJKco=fVk00;o=VRk00Wo=fVkocMY_?lgJK_o=fVlocMY^olf
J;_o=fVkocMY_?lfJ;/00_lgJK/00olfJ;_o=fVlocMY^`02ocIX^`09ocMY^olgJKco=fVkocMY_?lg
JK_o=VRkocMY^olgJKco=VRk00;o=fVk00?o=VRkocMY_?lgJK/00_lfJ;/02OlgJK_o=fVlocMY^olg
JKco=fVkocIX^olgJK_o=fVlocIX^`02ocMY^`03ocIX^olgJKco=fVk00;o=VRk01ko=fVkocMY_?lg
JK_o=fVlocMY^onm_Kgodm?Coo;bl_ogmoOon?ShooWinOoemOGoh^;RonSXj?o/k>colo?coo_knoom
oOgonOWiono_kooVi^KoHf=SofIVI_mZJV[oK6a/ofm_KomaLG7oLg=cogEeMOmgMgL1ogQhN0000_ln
Ll001?loLl7o?W?0ocic`?loM<44ocic`00=ocmc`OlnLl3o?W?0oceb_olnL[oo?G:oocib`?lnL[oo
?W?0ocib_olmL[oo?W?0ocib_`02oceb_`0>ocib_olnLl3o?W:oocib`?lmL[oo?W:ooceb_olnL/3o
?W:oocic`?lnL[oo?G:oocic`?lnL[l2oceb_`0>ocib_olnLl3o?W:oocib`?lmL[oo?W:ooceb_oln
L/3o?W:oocic`?lnL[oo?G:oocic`?lnL[l2oceb_`0>ocib_olnLl3o?W:oocib`?lmL[oo?W:ooceb
_olnL/3o?W:oocic`?lnL[oo?G:oocic`?lnL[l2oceb_`0>ocib_olnLl3o?W:oocib`?lmL[oo?W:o
oceb_olnL/3o?W:oocic`?lnL[oo?G:oocic`?lnL[l2oceb_`0>ocib_olnLl3o?W:oocib`?lmL[oo
?W:ooceb_olnL/3o?W:oocic`?lnL[oo?G:oocic`?lnL[l2oceb_`0>ocib_olnLl3o?W:oocib`?lm
L[oo?W:ooceb_olnL/3o?W:oocic`?lnL[oo?G:oocic`?lnL[l2oceb_`0>ocib_olnLl3o?W:oocib
`?lmL[oo?W:ooceb_olnL/3o?W:oocic`?lnL[oo?G:oocic`?lnL[l2oceb_`0>ocib_olnLl3o?W:o
ocib`?lmL[oo?W:ooceb_olnL/3o?W:oocic`?lnL[oo?G:oocic`?lnL[l2oceb_`0>ocib_olnLl3o
?W:oocib`?lmL[oo?W:ooceb_olnL/3o?W:oocic`?lnL[oo?G:oocic`?lnL[l2oceb_`0>ocib_oln
Ll3o?W:oocib`?lmL[oo?W:ooceb_olnL/3o?W:oocic`?lnL[oo?G:oocic`?lnL[l2oceb_`0>ocib
_olnLl3o?W:oocib`?lmL[oo?W:ooceb_olnL/3o?W:oocic`?lnL[oo?G:oocic`?lnL[l2oceb_`0>
ocib_olnLl3o?W:oocib`?lmL[oo?W:ooceb_olnL/3o?W:oocic`?lnL[oo?G:oocic`?lnL[l2oceb
_`0>ocib_olnLl3o?W:oocib`?lmL[oo?W:ooceb_olnL/3o?W:oocic`?lnL[oo?G:oocic`?lnL[l2
oceb_`0>ocib_olnLl3o?W:oocib`?lmL[oo?W:ooceb_olnL/3o?W:oocic`?lnL[oo?G:oocic`?ln
L[l2oceb_`0>ocib_olnLl3o?W:oocib`?lmL[oo?W:ooceb_olnL/3o?W:oocic`?lnL[oo?G:oocic
`?lnL[l2oceb_`0<ocib_olnLl3o?W:oocib`?lmL[oo?W:ooceb_olnL/3o?W:ookfm_OoBd];olO7a
0_ogmoL05?ohn?SomOGeon7QhOoXj>Sok>c/oo?cloojn_[oo?clooShn?o^k^kokNg]of9RH_mUIFGo
J6QXof][Jom]KFgoKfm_og5aLOmcLg?oMGEe0OmfMWH00006odAja?m3N/?oA7[4od=j`om4N/Co@g[3
0_m4N/@01Om3N/?oA7[4od=j`om4N/Co@gW300Co@g[300Go@WW2od=j`om3N/?o@g[3od9i`P04od=j
``03od=i`om3N/?o@WW200Co@g[300Go@WW2od=j`om3N/?o@g[3od9i`P04od=j``03od=i`om3N/?o
@WW200Co@g[300Go@WW2od=j`om3N/?o@g[3od9i`P04od=j``03od=i`om3N/?o@WW200Co@g[300Go
@WW2od=j`om3N/?o@g[3od9i`P04od=j``03od=i`om3N/?o@WW200Co@g[300Go@WW2od=j`om3N/?o
@g[3od9i`P04od=j``03od=i`om3N/?o@WW200Co@g[300Go@WW2od=j`om3N/?o@g[3od9i`P04od=j
``03od=i`om3N/?o@WW200Co@g[300Go@WW2od=j`om3N/?o@g[3od9i`P04od=j``03od=i`om3N/?o
@WW200Co@g[300Go@WW2od=j`om3N/?o@g[3od9i`P04od=j``03od=i`om3N/?o@WW200Co@g[300Go
@WW2od=j`om3N/?o@g[3od9i`P04od=j``03od=i`om3N/?o@WW200Co@g[300Go@WW2od=j`om3N/?o
@g[3od9i`P04od=j``03od=i`om3N/?o@WW200Co@g[300Go@WW2od=j`om3N/?o@g[3od9i`P04od=j
``03od=i`om3N/?o@WW200Co@g[300Go@WW2od=j`om3N/?o@g[3od9i`P04od=j``03od=i`om3N/?o
@WW200Co@g[300Go@WW2od=j`om3N/?o@g[3od9i`P04od=j``03od=i`om3N/?o@WW200Co@g[300Go
@WW2od=j`om3N/?o@g[3od9i`P04od=j``03od=i`om3N/?o@WW200Co@g[300Go@WW2od=j`om3N/?o
@g[3od9i`P04od=j``03od=i`om3N/?o@WW200Co@g[300Go@WW2od=j`om3N/?o@g[3od9i`P04od=j
``03od=i`om3N/?o@WW200Co@g[301[o@WW2okjn__oCdm?ol_;booKfm_ohn?SonOWiooGemOoRh^;o
j>SXong]kOoclo?ono_koogmoOoinOWokno_oogmoOmSHf?oIVIVofYZJ_m/K6coKfm_og5aLOmcLg?o
MGEeogMgM`7oN7Qh000<ooooo`coo_kn00?oooooookno_ooool03Oono_h01Oo3`l?oRHV9ofYZJ_n0
P83od=3@00_oo_kn00?oooooookno_ooool03Oono_h00ooRh^;oQ8B4ooShn00=ooknoP03ooooooon
o_kooooo00Woo_kn00OohN7QohF5QOogmoOoo_knooooooono_kooooo00goo_kn00?oooooookno_oo
ool03Oono_h00oooooooo_knooooo`0=ooknoP03ooooooono_kooooo00goo_kn00?oooooookno_oo
ool03Oono_h00oooooooo_knooooo`0=ooknoP03ooooooono_kooooo00goo_kn00?oooooookno_oo
ool03Oono_h00oooooooo_knooooo`0=ooknoP03ooooooono_kooooo00goo_kn00?oooooookno_oo
ool01oono_h03OnYZJWo];Bdol;2`_nk^k_o][Jfok>c/onb/[;oXj>SojZZZ_n_[joo^KViolO7aooA
dM400_oMgMd02_o_knooIVIVofYZJ_m]KFgoL71`og=cLomeMGGoN7QhogYjN_mkNg/1ogemO@002?oi
nOT00oojn_[onOWiooWin@05ooWin@;on?Sh0_oinOT00oohn?SonOWiooShn002ooWin@?on?Sh1?oi
nOT2ooShn0;onOWi00[on?ShooWinOohn?SonOWiohb<S?miNGWoYJFUofQXJ?lG5aOo^k^k0_oinOT2
ooShn0;onOWi00?on?ShooWinOohn?P00_oinOT3ooShn0ConOWi0_ohn?P2ooWin@08ooShn?oinOWo
n?ShooWinOoemOGo9bLWojFUYOohn?P4ooWin@;on?Sh0_oinOT00oohn?SonOWiooShn002ooWin@?o
n?Sh1?oinOT2ooShn0;onOWi00?omOGeobPX:?nTY:@00_oinOT3ooShn0ConOWi0_ohn?P2ooWin@03
ooShn?oinOWon?Sh00;onOWi0oohn?P4ooWin@;on?Sh0_oinOT00oohn?SonOWiooShn002ooWin@?o
n?Sh1?oinOT2ooShn0;onOWi00?on?ShooWinOohn?P00_oinOT3ooShn0ConOWi0_ohn?P2ooWin@03
ooShn?oinOWon?Sh00;onOWi0oohn?P4ooWin@;on?Sh0_oinOT00oohn?SonOWiooShn002ooWin@?o
n?Sh1?oinOT2ooShn0;onOWi00?on?ShooWinOohn?P00_oinOT3ooShn0ConOWi0_ohn?P2ooWin@03
ooShn?oinOWon?Sh00;onOWi0oohn?P4ooWin@;on?Sh0_oinOT00oohn?SonOWiooShn002ooWin@?o
n?Sh1?oinOT2ooShn0;onOWi00?on?ShooWinOohn?P00_oinOT3ooShn0ConOWi0_ohn?P2ooWin@03
ooShn?oinOWon?Sh00;onOWi0oohn?P4ooWin@;on?Sh01Wo_Kfmom?Cdoobl_;omoOgooShn?oinOWo
m_Kfon7QhOoXj>SokNg]ooCdm?okno_ooOgmooWinOo_knooi^KVof=SHomWIfOoJFUYofa/K?m_Kfoo
LG5aog=cLomeMGGoMgMg007oN7Qh0002on_[j`;oj^[Z00?ojn_[on[Zj_o[jn/00_oZj^X2on_[j`?o
j^[Z00?ojNWYon[Zj_oZj^X00_oZj^X01OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Coj^[Z00?ojNWYon[Z
j_oYjNT00ooZj^X01_oIfMWoj>SXon[Zj_oOgmooh>3PonWYj@Coj^[Z00?oFEUIodY:B_oYjNT01?oZ
j^X01OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Coj^[Z00CojNWYomWIfOoXj>Soj^[Z0_oPh>000ooZj^[o
jNWYon[ZjP02on[ZjP08onWYjOoZj^[oQHF5od=3@ooZj^[ojNWYon[Zj_oYjNT4on[ZjP05onWYjOoZ
j^[oj^[Zon[Zj_oYjNT01?oZj^X03?oYjNWoj^[ZomWIfOoXj>Soj^[Zon3Ph?oOgmoojNWYon[Zj_n5
QHGo@d=3onWYj@Coj^[Z00?ojNWYon[Zj_oYjNT00_oZj^X00ooGemOoaLG5onKViP03on[ZjP03onWY
jOoZj^[oj^[Z00;oj^[Z00?ojNWYon[Zj_oYjNT01?oZj^X01OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Co
j^[Z00?ojNWYon[Zj_oYjNT01?oZj^X01OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Coj^[Z00?ojNWYon[Z
j_oYjNT01?oZj^X01OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Coj^[Z00?ojNWYon[Zj_oYjNT01?oZj^X0
1OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Coj^[Z00?ojNWYon[Zj_oYjNT01?oZj^X01OoYjNWoj^[Zon[Z
j_oZj^[ojNWY00Coj^[Z00?ojNWYon[Zj_oYjNT01?oZj^X01OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Co
j^[Z00?ojNWYon[Zj_oYjNT01?oZj^X01OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Coj^[Z00?ojNWYon[Z
j_oYjNT01?oZj^X01OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Coj^[Z00?ojNWYon[Zj_oYjNT01?oZj^X0
1OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Coj^[Z00?ojNWYon[Zj_oYjNT00ooZj^X01?nl_;cod];Boo;b
l_ofm_H2ooShn00CooGemOoQhN7oj>SXong]kOoclo?on_[jooclo?oinOWokno_onk^k_mRHV;oIFEU
ofQXJ?mZJV[oKFe]ofm_KomaLG7oLg=cogEeM@01ogIfMP0000?onOWioo[jn_oinOT03OoinOT00ooh
n?So?CdmogUiN@02ooWin@0IodM7Aon2PX;on?ShooShn?mnOWkoBTY:ooWinOohn?So/k>coaDE5Ooi
nOWon?ShoeQHF?lD51Co9BDUoifMWOlN7QkoGEeMooShn?oRh^;oHf=Sod51@OmnOWkoWIfMobTY:@02
ooWin@0GodM7Aon2PX;on?ShooWinOm8B4SoPX:2ooWinOohn?SoXj>SobLW9oohn?SonOWioeMGEolD
51Co9BDUoibLW?lN7QkoGUiNooShn?m8B4SoPX:2ooShn?oinOT00_ohn?P01?nDU9Co3@d=om?Cdooh
n?P3ooWin@0CooShn?oinOWon?Shochn?_l>3Pko3@d=oa@D5?lh>3SoMWIfonk^k_ohn?SonOWiooSh
n?mHF5So51@DobDU9OnLW9co7alOoeeMG@02ooWin@08oiBDU?l=3@godm?CooShn?oinOWon?ShooWi
nOohn?P2ooWin@08oo?clomPH63o4a<Coc8b<_lY:BWob/[:ooShn?oinOT2ooShn004ooWinOohn?So
nOWiooShn0?onOWi00?on?ShooWinOohn?P00_oinOT02?ohn?SonOWiooShn?ohn?SonOWiooShn?oi
nOWon?Sh0ooinOT00oohn?SonOWiooShn002ooWin@08ooShn?oinOWon?ShooShn?oinOWon?ShooWi
nOohn?P3ooWin@03ooShn?oinOWon?Sh00;onOWi00Son?ShooWinOohn?Son?ShooWinOohn?SonOWi
ooShn0?onOWi00?on?ShooWinOohn?P00_oinOT02?ohn?SonOWiooShn?ohn?SonOWiooShn?oinOWo
n?Sh0ooinOT00oohn?SonOWiooShn002ooWin@08ooShn?oinOWon?ShooShn?oinOWon?ShooWinOoh
n?P3ooWin@03ooShn?oinOWon?Sh00;onOWi00Son?ShooWinOohn?Son?ShooWinOohn?SonOWiooSh
n0?onOWi00?on?ShooWinOohn?P00_oinOT02?ohn?SonOWiooShn?ohn?SonOWiooShn?oinOWon?Sh
0ooinOT00oohn?SonOWiooShn002ooWin@08ooShn?oinOWon?ShooShn?oinOWon?ShooWinOohn?P3
ooWin@03ooShn?oinOWon?Sh00;onOWi00Son?ShooWinOohn?Son?ShooWinOohn?SonOWiooShn0?o
nOWi01_on?ShooWinOnm_Kgodm?Coo?cloogmoOon?ShooWinOoemOGoh^;RonSXj?o]kNgolo?coo_k
noomoOgonOWionk^k_ono_koHf=SofIVI_mZJV[oK6a/ofm_KomaLG7oLg=cogEeMOmgMgL00OmhN7P0
00gooooo1?ono_h02_lo?cooOGemookno_ono_koBd];ohF5QOooooooo_knoh61POm=CDd2ooknoP0A
okRh^?lF5QKoo_knolS8b?lB4Q;og]kNonKVi_mTI6Co7QhNookno_ooooooEeMGocTi>OnWYjOoPh>3
ocTi>OlQ8B400_ono_h04Om:BT[oQXJ6ookno_ono_koBTY:ohJ6Q_ono_koooooojRXZ?lX:2Soo_kn
olS8b?lB4Q;og]kNonKVi_mTI6Co7QhN00;oo_kn00WoBTY:ohJ6Q_ono_koo_knooooooono_ko>SXj
oaLG5omhN7P01oono_h03om1@D7oNg]kookno_odm?Coclo?odm?Col];Bgol?3`ookno_o9bLWo4Q8B
omkNg_oWinOoI6AToahN7P03ooknoP03oc/k>olF5QKoNGUi00Ooo_kn00WoSXj>oc<c<ooTi>Coo_kn
ohn?Sol_;boon_[jookno_ooool03oono_h00oooooooo_knooknoP0=ooknoP03ooooooono_koo_kn
00goo_kn00?oooooookno_ono_h03Oono_h00oooooooo_knooknoP0=ooknoP03ooooooono_koo_kn
00goo_kn00?oooooookno_ono_h03Oono_h00oooooooo_knooknoP0=ooknoP03ooooooono_koo_kn
00goo_kn00?oooooookno_ono_h02?ono_h06Onn_[kodm?Coo?cloohn?SonOWioo[jn_ogmoOoh^;R
onWYjOo^k^komOGeooclo?ono_kon_[joo3`l?o_knooIfMWofYZJ_m]KFgoL71`og=cLomeMGGoN7Qh
ogYjN_mkNg/00OmmOGd000conOWi0_ohn?P07?oinOWon?ShooWinOll?3coNWYjooWinOohn?SoB4Q8
oh:2P_ohn?SonOWiogemOOm;Bd_onOWiooShn?nb/[;o5ADEooShn?oEeMGo3`l?okbl_?oinOWoWinO
ob/[:ooinOWol?3`oaDE5Ong]kL2ooWin@06oiNGUolL71conOWiooShn?m8B4SoPX:20_oinOT04Om7
AdOoPX:2ooWinOohn?SoXj>SobLW9ooinOWoeMGEo`l?3onk^k_onOWioinOWol[:b_on?ShooWinOm8
B4SoPX:200;onOWi00kon?Shol[:b_l=3@goWinOoahN7_obl_;on?ShooWinOohn?SonOWiooShn?oi
nOWo?cloogMgM`;onOWi00_on?ShooCdm?lY:BWoMGEeooWinOoDe=Co3`l?okbl_?ohn?SoWinOobXZ
:P02ooWin@06olW9bOl>3PkoWinOoahN7_obl_;on?Sh0_oinOT2ooShn00<ooWinOl[:b_oOgmoooSh
n?oinOWoiNGUo`d=3Oo=cLgonOWiooShn?oinOWon?Sh0_oinOT2ooShn004ooWinOohn?SonOWiooSh
n0;onOWi00Kon?ShooWinOoinOWon?ShooWinOohn?P2ooWin@;on?Sh00ConOWiooShn?oinOWon?Sh
0_oinOT01_ohn?SonOWiooWinOohn?SonOWiooShn0;onOWi0_ohn?P01?oinOWon?ShooWinOohn?P2
ooWin@06ooShn?oinOWonOWiooShn?oinOWon?Sh0_oinOT2ooShn004ooWinOohn?SonOWiooShn0;o
nOWi00Kon?ShooWinOoinOWon?ShooWinOohn?P2ooWin@;on?Sh00ConOWiooShn?oinOWon?Sh0_oi
nOT01_ohn?SonOWiooWinOohn?SonOWiooShn0;onOWi0_ohn?P01?oinOWon?ShooWinOohn?P2ooWi
n@06ooShn?oinOWonOWiooShn?oinOWon?Sh0_oinOT2ooShn004ooWinOohn?SonOWiooShn0;onOWi
00Kon?ShooWinOoinOWon?ShooWinOohn?P2ooWin@;on?Sh00ConOWiooShn?oinOWon?Sh0_oinOT0
1_ohn?SonOWiooWinOohn?SonOWiooShn0;onOWi0_ohn?P01?oinOWon?ShooWinOohn?P2ooWin@06
ooShn?oinOWonOWiooShn?oinOWon?Sh0_oinOT2ooShn00MooWinOohn?SonOWiooShn?nn_[kodm?C
oo;bl_ogmoOon?ShooWinOofm_Koh^;RonSXj?o]kNgolo?coo_knoomoOgonOWiono_kooVi^KoHf=S
ofMWIomYJFWoK6a/ofm_KomaLG7oLg=cogEeMOmgMgL00OmhN7P000;oo_kn00OooOgmookno_omoOgo
oOgmookno_omoOgoo_kn00KooOgm00Coo?cloogmoOln?SkoNg]k0_omoOd01_m9BDWoQHF5ooclo?om
oOgoOgmood];B`;ooOgm02So]kNgoaDE5Oolo?cooOgmok2`/?lk>c_o?Cdmoclo?ol[:b_ooOgmol?3
`ol=3@goiNGUooclo?omoOgo[jn_oadM7OomoOgoo?clodU9BOn4Q8Coo?cloogmoOm9BDWoQ8B4oogm
oOolo?coYZJVobLW9oolo?cooOgmok2`/?ll?3co?Cdmoclo?ol[:b_ooOgmooclo?m9BDWoQ8B40_om
oOd01_olo?coL71`odY:B_olo?co<S8bojNWY`;ooOgm00Koo?cloogmoOomoOgoo?clod10@?mjNWX2
oogmo@04ooclo?omoOgoPH61ob`/;0;ooOgm00ko/;2`oc`l??ll?3co@410ob/[:oolo?cooOgmog1`
L?m:BT[ooOgmoc8b<_nWYjOooOgmooclo0?ooOgm00[omoOgo``<3?nLW9cooOgmooclo?oGemOo3@d=
om_KfoomoOgoo?cl0_omoOd00oolo?cooOgmoogmo@02oogmo@04ooclo?omoOgooOgmooclo0CooOgm
00Coo?cloogmoOomoOgoo?cl1?omoOd01?olo?cooOgmoogmoOolo?`4oogmo@04ooclo?omoOgooOgm
ooclo0CooOgm00Coo?cloogmoOomoOgoo?cl1?omoOd01?olo?cooOgmoogmoOolo?`4oogmo@04oocl
o?omoOgooOgmooclo0CooOgm00Coo?cloogmoOomoOgoo?cl1?omoOd01?olo?cooOgmoogmoOolo?`4
oogmo@04ooclo?omoOgooOgmooclo0CooOgm00Coo?cloogmoOomoOgoo?cl1?omoOd01?olo?cooOgm
oogmoOolo?`4oogmo@04ooclo?omoOgooOgmooclo0CooOgm00Coo?cloogmoOomoOgoo?cl1?omoOd0
1?olo?cooOgmoogmoOolo?`4oogmo@04ooclo?omoOgooOgmooclo0CooOgm00Coo?cloogmoOomoOgo
o?cl1?omoOd01?olo?cooOgmoogmoOolo?`4oogmo@0Looclo?omoOgooOgmokbl_?oBd];ol?3`ooKf
m_nTY:CoE5ADoe=CDom<C4coCTi>oe1@D?nFUYKon_[jooclo?ohn?Sokno_ong]kOmRHV;oIFEUofQX
J?mZJV[oKFe]ofm_KomaLG7oLg=cogEeM@7oMWIf0004ooWin@03oo[jn_oinOWonOWi00ConOWi00co
n_[jooWinOohn?SonOWiooShn?oinOWo?3`logYjN_ohn?SonOWiodQ8B?maLG42ooWin@0AogalO?ll
?3con?ShooShn?na/K7o5ADEooShn?oinOWon?ShooWinOofm_KoUYJFob`/;?ohn?Soe]KFo`h>3_nd
];@00_oinOT03_n[Zj_o71`LooWinOohn?SoB4Q8oh:2P_oinOWon?ShodQ8B?mSHf?on?ShooWinOnN
WYko:2PX0_oinOT2ooShn00IooOgmonFUYKo;2`/ooShn?oinOWoAdM7ofi^K_oinOWon?Shoo3`l?lK
6a_oXZ:RooWinOnBTY;oATI6ooShn?oinOWon?ShooWinOohn?SonOWiochn?_mhN7SonOWiooShn002
ooWin@03oijNW_l?3`oolo?c00;on?Sh00_onOWiooKfm_nFUYKo:b/[ooWinOo`l?3o6a/Koj:RX_oh
n?SoTY:BodI6AP03ooWin@;on?Sh00Woh>3Po`d=3Olg=cOodm?Conc/k?mZJV[o@T92ooWinOohn?P0
1OoinOT2ooShn006ooWinOohn?SonOWiooShn?oinOWon?Sh0_oinOT00oohn?SonOWiooWin@03ooWi
n@;on?Sh00KonOWiooShn?oinOWon?ShooWinOohn?P2ooWin@03ooShn?oinOWonOWi00?onOWi0_oh
n?P01_oinOWon?ShooWinOohn?SonOWiooShn0;onOWi00?on?ShooWinOoinOT00ooinOT2ooShn006
ooWinOohn?SonOWiooShn?oinOWon?Sh0_oinOT00oohn?SonOWiooWin@03ooWin@;on?Sh00KonOWi
ooShn?oinOWon?ShooWinOohn?P2ooWin@03ooShn?oinOWonOWi00?onOWi0_ohn?P01_oinOWon?Sh
ooWinOohn?SonOWiooShn0;onOWi00?on?ShooWinOoinOT00ooinOT2ooShn006ooWinOohn?SonOWi
ooShn?oinOWon?Sh0_oinOT00oohn?SonOWiooWin@03ooWin@;on?Sh00KonOWiooShn?oinOWon?Sh
ooWinOohn?P2ooWin@03ooShn?oinOWonOWi00?onOWi0_ohn?P01_oinOWon?ShooWinOohn?SonOWi
ooShn0;onOWi00?on?ShooWinOoinOT00ooinOT2ooShn00MooWinOohn?SonOWiooShn?nn_[kod];B
oo;bl_ogmoOok^k^ofIVI_mDE5CoCDe=odm?ComLG5coj>SXoo_knoomoOgonOWiono_koomoOgoHf=S
ofIVI_mZJV[oK6a/ofm_KomaLG7oLg=cogEeMOmgMgL00OmhN7P000gok>c/0oo[jn/00oo/k>co>SXj
ogAdM002on_[j`0IodE5AOlP823oR8R8omKFe_m5ADGo:2PXof5QHOoBd];oL71`oc/k>oo[jn_ok>c/
ojVYZOo:b/[ojNWYof5QHOmGEeOojn_[onc/k?m1@D7oBTY:om;Bd_oOgmooFEUIoa`L7002on_[j`0A
odE5AOmlO7cojn_[on_[jom4A4Co7alOogAdM?o?clooFEUIoe1@D?o[jn_ok>c/ojZZZ_o:b/[ojNWY
of9RH_mGEeL00_o[jn/02om5ADGo7QhNohb<S?oDe=CoVYZJoaTI6OoRh^;ojn_[omgMgOlF5QKob<S8
00;ojn_[00Gok>c/on_[joo[jn_o?3`log5aL@02on_[j`0Eonc/k?o[jn_oRXZ:oa8B4_oXj>Sojn_[
ojVYZOo;bl_oj>SXof9RH_mGEeOojn_[oibLW?lI6AWoh^;Ron_[jooMgMgo5ADEolS8b?o[jn_ok>c/
00;ojn_[00OoinOWo`h>3_n8R8So?Shnoa/K6oli>CWo_kno00;ojn_[00Gok>c/on_[joo[jn_ojn_[
onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/k004on_[j`03
onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/k004on_[j`03onc/k?o[jn_ojn_[
00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/
on_[joo[jn_ojn_[onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[
onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/k004on_[j`03
onc/k?o[jn_ojn_[00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/k004on_[j`03onc/k?o[jn_ojn_[
00Cojn_[00Gok>c/on_[joo[jn_ojn_[onc/k004on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Gok>c/
on_[joo[jn_ojn_[onc/k004on_[j`0Konc/k?o[jn_o_knoomCDe?obl_;on?ShooWinOnk^k_oEEEE
odi>C_m@D53o/;2`ooGemOokno_oo_knoo[jn_o`l?3okno_ofIVI_mZJV[oKFe]og1`L?mcLg?oMGEe
ogQhN?mjNW[oNg]k007oOGem000<ooWin@0JooShn?oinOWon?ShooWinOohn?So?3`logYjN_oinOWo
n?Shoe]KFon=SHgoMGEeoa`L7?la<C7odM7AoiZJV_lT92Co:b/[ojb/[?oinOWon?Shohb<S?ll?3co
71`Lod51@Oo2`/82ooShn00:omkNg_m;Bd_o5aLGoc<c<omiNGWo=3@dooShn?oinOWoFUYJohn?S`;o
nOWi00goFUYJohn?SomlO7co7alOocPh>?o2`/;onOWiooShn?n<S8co?3`loa/K6om1@D7o`/;200;o
nOWi00koFe]Koh^;RomSHf?o51@DoeYJF_meMGGon?ShooWinOohn?SoL71`ohR8R?ohn?SonOWiooSh
n0;onOWi00?o?ShnogMgMooinOT00_ohn?P00ooinOWoF5QHocHf=P02ooShn009ohf=SOlk>c_o71`L
od51@Oo2`/;onOWiof1PH?meMGGonOWi00;on?Sh00?oL71`ohN7QooinOT00_ohn?P02OoinOWon?Sh
obXZ:_nHV9SonOWiooShn?oinOWon?ShooWin@02ooShn003ooWinOohn?SonOWi00;on?Sh00ConOWi
ooShn?oinOWon?Sh0ooinOT01oohn?SonOWiooShn?ohn?SonOWiooShn?oinOT00_ohn?P01?oinOWo
n?ShooWinOohn?P3ooWin@07ooShn?oinOWon?ShooShn?oinOWon?ShooWin@02ooShn004ooWinOoh
n?SonOWiooShn0?onOWi00Oon?ShooWinOohn?Son?ShooWinOohn?SonOWi00;on?Sh00ConOWiooSh
n?oinOWon?Sh0ooinOT01oohn?SonOWiooShn?ohn?SonOWiooShn?oinOT00_ohn?P01?oinOWon?Sh
ooWinOohn?P3ooWin@07ooShn?oinOWon?ShooShn?oinOWon?ShooWin@02ooShn004ooWinOohn?So
nOWiooShn0?onOWi00Oon?ShooWinOohn?Son?ShooWinOohn?SonOWi00;on?Sh00ConOWiooShn?oi
nOWon?Sh0ooinOT01oohn?SonOWiooShn?ohn?SonOWiooShn?oinOT00_ohn?P01?oinOWon?ShooWi
nOohn?P3ooWin@07ooShn?oinOWon?ShooShn?oinOWon?ShooWin@02ooShn004ooWinOohn?SonOWi
ooShn0?onOWi00Oon?ShooWinOohn?Son?ShooWinOohn?SonOWi00;on?Sh01konOWiooShn?oinOWo
n?ShooWinOnm_KgodM7Aoo7alOogmoOon?ShooWinOmiNGWoC4a<ofe]KOoYjNWom?Cdoo[jn_olo?co
nOWionk^k_oVi^KoHf=SofIVI_mYJFWoK6a/ofm_KomaLG7oLg=cogEeMOmgMgL1ogQhN00000Goo_kn
oogmoOomoOgoo_knoogmo@03ooknoP03oogmoOono_kooOgm00?ooOgm00Ooo?cloogmoOomoOgo?Shn
og]kNoomoOgoo?cl00?ooOgm00Goo?cloogmoOomoOgoo?cloogmo@02ooclo0?ooOgm00?oo?cloo_k
noolo?`01OomoOd01Ookno_oo?cloogmoOomoOgoo?cl00?ooOgm00?oo?cloogmoOolo?`00_omoOd0
1Oolo?cooOgmoogmoOomoOgoo?cl00;ooOgm00Won_[joogmoOomoOgooOgmooclo?omoOgoo?cloogm
oOojn_X01?omoOd01?olo?cooOgmoogmoOolo?`3oogmo@03ooclo?lo?cooNWYj00?ooOgm00CoXZ:R
o`h>3_nTY:Coo?cl0_omoOd01oolo?cono_koogmoOomoOgoo?cloogmoOolo?`01_omoOd01_olo?co
oOgmoogmoOolo?coQhN7odI6AP;oo?cl00?ooOgmooclo?omoOd01OomoOd01?olo?cooOgmoogmoOol
o?`3oogmo@03ooclo?omoOgoo?cl00KooOgm00Coo?cloogmoOomoOgoo?cl0oomoOd00oolo?cooOgm
ooclo006oogmo@04ooclo?omoOgooOgmooclo0?ooOgm00?oo?cloogmoOolo?`01_omoOd01?olo?co
oOgmoogmoOolo?`3oogmo@03ooclo?omoOgoo?cl00KooOgm00Coo?cloogmoOomoOgoo?cl0oomoOd0
0oolo?cooOgmooclo006oogmo@04ooclo?omoOgooOgmooclo0?ooOgm00?oo?cloogmoOolo?`01_om
oOd01?olo?cooOgmoogmoOolo?`3oogmo@03ooclo?omoOgoo?cl00KooOgm00Coo?cloogmoOomoOgo
o?cl0oomoOd00oolo?cooOgmooclo006oogmo@04ooclo?omoOgooOgmooclo0?ooOgm00?oo?cloogm
oOolo?`01_omoOd01?olo?cooOgmoogmoOolo?`3oogmo@0Iok^k^ooAdM7ol?3`ooOgmoohn?SonOWi
omKFe_m=CDgo`l?3on_[jooemOGonOWiooclo?oinOWok^k^ong]kOmRHV;oIFEUofQXJ?mZJV[oKFe]
ofm_KomaLG7oLg=cogEeM@01ogIfMP003ooinOT01oohn?SonOWioc`l??mjNW[onOWiooShn?oinOT0
0_ohn?P01OoinOWon?ShooShn?oinOWon?Sh00;onOWi00?on?ShooWinOohn?P00_oinOT01Oohn?So
nOWiooShn?ohn?SonOWi00;on?Sh00OonOWiooShn?oinOWonOWiooShn?mQHF7oTi>C00;onOWi00Go
n?ShooWinOohn?Son?ShooWin@02ooShn007ooWinOohn?SonOWiooWinOohn?SonOWiooShn002ooWi
n@05ooShn?oinOWon?ShooShn?oinOT00_ohn?P04_oinOWon?ShooWinOoinOWon?ShooWinOohn?So
nOWioclo?olg=cOoJVYZoeIFE_lf=SKo4a<Coi6ATOogmoOonOWiooShn0;onOWi00?on?ShooWinOoh
n?P00_oinOT01Oohn?SonOWiooShn?ohn?SonOWi00;on?Sh00_onOWiooShn?oinOWonOWion[Zj_m1
@D7oEeMGoj:RX_n1PH7oL71`ooWin@02ooShn005ooWinOohn?Son?ShooWinOohn?P00_oinOT00ooh
n?SonOWiooShn002ooWin@05ooShn?oinOWon?ShooShn?oinOT00_ohn?P01ooinOWon?ShooWinOoi
nOWon?ShooWinOohn?P00_oinOT01Oohn?SonOWiooShn?ohn?SonOWi00;on?Sh00OonOWiooShn?oi
nOWonOWiooShn?oinOWon?Sh00;onOWi00Gon?ShooWinOohn?Son?ShooWin@02ooShn007ooWinOoh
n?SonOWiooWinOohn?SonOWiooShn002ooWin@05ooShn?oinOWon?ShooShn?oinOT00_ohn?P01ooi
nOWon?ShooWinOoinOWon?ShooWinOohn?P00_oinOT01Oohn?SonOWiooShn?ohn?SonOWi00;on?Sh
00OonOWiooShn?oinOWonOWiooShn?oinOWon?Sh00;onOWi00Gon?ShooWinOohn?Son?ShooWin@02
ooShn007ooWinOohn?SonOWiooWinOohn?SonOWiooShn002ooWin@05ooShn?oinOWon?ShooShn?oi
nOT00_ohn?P01ooinOWon?ShooWinOoinOWon?ShooWinOohn?P00_oinOT01Oohn?SonOWiooShn?oh
n?SonOWi00;on?Sh00OonOWiooShn?oinOWonOWiooShn?oinOWon?Sh00;onOWi00Gon?ShooWinOoh
n?Son?ShooWin@02ooShn00PooWinOohn?SonOWiooWinOohn?SonOWiooShn?nl_;cod];Boo7alOof
m_Kon?ShooWinOojn_[o/;2`onOWioo]kNgolo?cooWinOolo?con?Shono_koono_koHf=SofMWIomY
JFWoK6a/ofm_KomaLG7oLg=cogEeMOmgMgL1ogQhN0003Oo/k>`4on_[j`03ojJVY_nl_;cojn_[00?o
jn_[0_o/k>`2on_[j`;ok>c/1?o[jn/00oo/k>cojn_[on_[j`03on_[j`;ok>c/0_o[jn/2onc/k0?o
jn_[00?oZJVYokno_oo[jn/01?o[jn/2onc/k0;ojn_[0_o/k>`4on_[j`03onc/k?o[jn_ojn_[00?o
jn_[0_o/k>`2on_[j`;ok>c/1?o[jn/02?o/k>cojn_[ojJVY_nCTi?oTY:BoiZJV_nh^;Sof][J0_o[
jn/2onc/k0Cojn_[00?ok>c/on_[joo[jn/00oo[jn/2onc/k0;ojn_[0_o/k>`3on_[j`05onGUiOnG
UiOoJf][ogalO?n][Jd00_o[jn/2onc/k0;ojn_[0_o/k>`4on_[j`03onc/k?o[jn_ojn_[00?ojn_[
0_o/k>`2on_[j`;ok>c/1?o[jn/00oo/k>cojn_[on_[j`03on_[j`;ok>c/0_o[jn/2onc/k0Cojn_[
00?ok>c/on_[joo[jn/00oo[jn/2onc/k0;ojn_[0_o/k>`4on_[j`03onc/k?o[jn_ojn_[00?ojn_[
0_o/k>`2on_[j`;ok>c/1?o[jn/00oo/k>cojn_[on_[j`03on_[j`;ok>c/0_o[jn/2onc/k0Cojn_[
00?ok>c/on_[joo[jn/00oo[jn/2onc/k0;ojn_[0_o/k>`4on_[j`03onc/k?o[jn_ojn_[00?ojn_[
0_o/k>`2on_[j`;ok>c/1?o[jn/00oo/k>cojn_[on_[j`03on_[j`;ok>c/0_o[jn/2onc/k0Cojn_[
00?ok>c/on_[joo[jn/00oo[jn/2onc/k0;ojn_[0_o/k>`4on_[j`0Jonc/k?nn_[koeMGEoo?cloog
moOonOWioo[jn_oemOGoh^;RonSXj?o^k^kom_Kfoo_knoono_kon_[joo3`l?o_knooIfMWofYZJ_m]
KFgoL71`og=cLomeMGGoN7QhogYjN_mkNg/1ogemO@0000?on_[jooWinOoinOT02OoinOT01?ohn?So
nOWiooWinOohn?P2ooWin@04ooShn?oinOWonOWiooShn0;onOWi00?on?ShooWinOoinOT00_ohn?P2
ooWin@04ooShn?oinOWonOWiooShn0;onOWi00Con?ShooWinOoinOWon?Sh0_oinOT2ooShn0;onOWi
00Con?ShooWinOoinOWon?Sh0_oinOT01?ohn?SonOWiooWinOohn?P2ooWin@;on?Sh0_oinOT01?oh
n?SonOWiooWinOohn?P2ooWin@04ooShn?oinOWonOWiooShn0;onOWi0_ohn?P2ooWin@04ooShn?oi
nOWonOWiooShn0;onOWi00Con?ShooWinOoinOWon?Sh0_oinOT2ooShn0;onOWi00Con?ShooWinOoi
nOWon?Sh0_oinOT01?ohn?SonOWiooWinOohn?P2ooWin@;on?Sh0_oinOT01?ohn?SonOWiooWinOoh
n?P2ooWin@04ooShn?oinOWonOWiooShn0;onOWi0_ohn?P2ooWin@04ooShn?oinOWonOWiooShn0;o
nOWi00Con?ShooWinOoinOWon?Sh0_oinOT2ooShn0;onOWi00Con?ShooWinOoinOWon?Sh0_oinOT0
1?ohn?SonOWiooWinOohn?P2ooWin@;on?Sh0_oinOT01?ohn?SonOWiooWinOohn?P2ooWin@04ooSh
n?oinOWonOWiooShn0;onOWi0_ohn?P2ooWin@04ooShn?oinOWonOWiooShn0;onOWi00Con?ShooWi
nOoinOWon?Sh0_oinOT2ooShn0;onOWi00Con?ShooWinOoinOWon?Sh0_oinOT01?ohn?SonOWiooWi
nOohn?P2ooWin@;on?Sh0_oinOT01?ohn?SonOWiooWinOohn?P2ooWin@04ooShn?oinOWonOWiooSh
n0;onOWi0_ohn?P2ooWin@04ooShn?oinOWonOWiooShn0;onOWi00Con?ShooWinOoinOWon?Sh0_oi
nOT2ooShn0;onOWi00Con?ShooWinOoinOWon?Sh0_oinOT01?ohn?SonOWiooWinOohn?P2ooWin@;o
n?Sh0_oinOT01?ohn?SonOWiooWinOohn?P2ooWin@04ooShn?oinOWonOWiooShn0;onOWi0_ohn?P2
ooWin@0LooShn?oinOWonOWiokfm_OoDe=ColO7aooOgmoohn?SomoOgon_[jooRh^;oj>SXonk^k_oe
mOGon_[jooclo?oinOWokno_onKVi_mSHf?oIVIVofYZJ_m/K6coKfm_og5aLOmcLg?oMGEeogMgM`7o
N7Qh00000oono_kooOgmooknoP02oogmo@03ookno_omoOgooOgm00;ooOgm00Koo_knoogmoOomoOgo
o?cloogmoOolo?`4oogmo@03ooclo?omoOgooOgm00;oo?cl1?omoOd00oolo?cooOgmooclo004oogm
o@03ooclo?omoOgooOgm00;oo?cl1?omoOd00oolo?cooOgmooclo004oogmo@03ooclo?omoOgooOgm
00;oo?cl1?omoOd00oolo?cooOgmooclo004oogmo@03ooclo?omoOgooOgm00;oo?cl1?omoOd00ool
o?cooOgmooclo004oogmo@03ooclo?omoOgooOgm00;oo?cl1?omoOd00oolo?cooOgmooclo004oogm
o@03ooclo?omoOgooOgm00;oo?cl1?omoOd00oolo?cooOgmooclo004oogmo@03ooclo?omoOgooOgm
00;oo?cl1?omoOd00oolo?cooOgmooclo004oogmo@03ooclo?omoOgooOgm00;oo?cl1?omoOd00ool
o?cooOgmooclo004oogmo@03ooclo?omoOgooOgm00;oo?cl1?omoOd00oolo?cooOgmooclo004oogm
o@03ooclo?omoOgooOgm00;oo?cl1?omoOd00oolo?cooOgmooclo004oogmo@03ooclo?omoOgooOgm
00;oo?cl1?omoOd00oolo?cooOgmooclo004oogmo@03ooclo?omoOgooOgm00;oo?cl1?omoOd00ool
o?cooOgmooclo004oogmo@03ooclo?omoOgooOgm00;oo?cl1?omoOd00oolo?cooOgmooclo004oogm
o@03ooclo?omoOgooOgm00;oo?cl1?omoOd00oolo?cooOgmooclo004oogmo@03ooclo?omoOgooOgm
00;oo?cl1?omoOd00oolo?cooOgmooclo004oogmo@03ooclo?omoOgooOgm00;oo?cl1?omoOd00ool
o?cooOgmooclo002oogmo@0Iokfm_OoBd];ol?3`ooKfm_oemOGoj>SXom_KfooOgmooi^KVonc/k?oc
lo?onOWiooclo?ohn?Sok^k^ong]kOmRHV;oIFEUofQXJ?m[Jf_oKFe]ofm_KomaLG7oLg=cogEeM@01
ogIfMP003?oinOT00oohn?SonOWiooWin@02ooWin@05ooShn?oinOWonOWiooWinOohn?P01?oinOT0
0oohn?SonOWiooShn004ooWin@05ooShn?oinOWonOWiooWinOohn?P01?oinOT00oohn?SonOWiooSh
n004ooWin@05ooShn?oinOWonOWiooWinOohn?P01?oinOT00oohn?SonOWiooShn004ooWin@05ooSh
n?oinOWonOWiooWinOohn?P01?oinOT00oohn?SonOWiooShn004ooWin@05ooShn?oinOWonOWiooWi
nOohn?P01?oinOT00oohn?SonOWiooShn004ooWin@05ooShn?oinOWonOWiooWinOohn?P01?oinOT0
0oohn?SonOWiooShn004ooWin@05ooShn?oinOWonOWiooWinOohn?P01?oinOT00oohn?SonOWiooSh
n004ooWin@05ooShn?oinOWonOWiooWinOohn?P01?oinOT00oohn?SonOWiooShn004ooWin@05ooSh
n?oinOWonOWiooWinOohn?P01?oinOT00oohn?SonOWiooShn004ooWin@05ooShn?oinOWonOWiooWi
nOohn?P01?oinOT00oohn?SonOWiooShn004ooWin@05ooShn?oinOWonOWiooWinOohn?P01?oinOT0
0oohn?SonOWiooShn004ooWin@05ooShn?oinOWonOWiooWinOohn?P01?oinOT00oohn?SonOWiooSh
n004ooWin@05ooShn?oinOWonOWiooWinOohn?P01?oinOT00oohn?SonOWiooShn004ooWin@05ooSh
n?oinOWonOWiooWinOohn?P01?oinOT00oohn?SonOWiooShn004ooWin@05ooShn?oinOWonOWiooWi
nOohn?P01?oinOT00oohn?SonOWiooShn004ooWin@05ooShn?oinOWonOWiooWinOohn?P01?oinOT0
0oohn?SonOWiooShn004ooWin@0JooShn?nm_Kgod];Boo7alOo_knoof][Jolk>c_o?clooe]KFom_K
fooQhN7ok>c/ooKfm_okno_onOWiono_koomoOgoHf=SofIVI_mZJV[oK6a/ofm_KomaLG7oLg=cogEe
MOmgMgL1ogQhN0003?o/k>`5on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Cok>c/on_[joo/k>cok>c/
1Oo[jn/00oo/k>cojn_[on_[j`04on_[j`05okBd]?moOgooHV9RogMgMoo0`<001?o[jn/00oo/k>co
jn_[on_[j`04on_[j`04onc/k?o[jn_ok>c/onc/k0Gojn_[00?ok>c/on_[joo[jn/01?o[jn/01?oA
dM7oNg]konGUiOo/k>`5on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Cok>c/on_[joo/k>cok>c/1Oo[
jn/02Oo/k>cojn_[on_[joo@d=3oNg]konGUiOo[jn_ok>c/on_[j`02onc/k0Gojn_[00?ok>c/on_[
joo[jn/01?o[jn/01?o/k>cojn_[onc/k?o/k>`5on_[j`03onc/k?o[jn_ojn_[00Cojn_[00Cok>c/
on_[joo/k>cok>c/1Oo[jn/00oo/k>cojn_[on_[j`04on_[j`04onc/k?o[jn_ok>c/onc/k0Gojn_[
00?ok>c/on_[joo[jn/01?o[jn/01?o/k>cojn_[onc/k?o/k>`5on_[j`03onc/k?o[jn_ojn_[00Co
jn_[00Cok>c/on_[joo/k>cok>c/1Oo[jn/00oo/k>cojn_[on_[j`04on_[j`04onc/k?o[jn_ok>c/
onc/k0Gojn_[00?ok>c/on_[joo[jn/01?o[jn/01?o/k>cojn_[onc/k?o/k>`5on_[j`03onc/k?o[
jn_ojn_[00Cojn_[00Cok>c/on_[joo/k>cok>c/1Oo[jn/00oo/k>cojn_[on_[j`04on_[j`04onc/
k?o[jn_ok>c/onc/k0Gojn_[00?ok>c/on_[joo[jn/01?o[jn/01?o/k>cojn_[onc/k?o/k>`5on_[
j`0?onc/k?no_kooe=CDon_[joo<c<coWYjNohZ:R_mkNg_oKfm_ogQhN?n9RHWoZj^[omoOgoodm?Co
moOg00;okno_00WoIVIVofYZJ_m]KFgoL71`og=cLomeMGGoN7QhogYjN_mkNg/00OmmOGd000SonOWi
00?on_[jooWinOoinOT01OoinOT2ooShn0;onOWi00?on?ShooWinOohn?P00_oinOT3ooShn0ConOWi
0_ohn?P2ooWin@0:ooShn?oinOWon?ShooWinOn<S8coNGUiojFUYOmXJ6So5aLGok^k^`;onOWi0_oh
n?P2ooWin@03ooShn?oinOWon?Sh00;onOWi0oohn?P4ooWin@;on?Sh0_oinOT02?ohn?SonOWiooSh
n?oinOWomOGeobLW9onUYJGon?Sh1?oinOT2ooShn0;onOWi00?on?ShooWinOohn?P00_oinOT3ooSh
n0ConOWi0_ohn?P2ooWin@03ooGemOlX:2SoY:BT00;onOWi0oohn?P4ooWin@;on?Sh0_oinOT00ooh
n?SonOWiooShn002ooWin@?on?Sh1?oinOT2ooShn0;onOWi00?on?ShooWinOohn?P00_oinOT3ooSh
n0ConOWi0_ohn?P2ooWin@03ooShn?oinOWon?Sh00;onOWi0oohn?P4ooWin@;on?Sh0_oinOT00ooh
n?SonOWiooShn002ooWin@?on?Sh1?oinOT2ooShn0;onOWi00?on?ShooWinOohn?P00_oinOT3ooSh
n0ConOWi0_ohn?P2ooWin@03ooShn?oinOWon?Sh00;onOWi0oohn?P4ooWin@;on?Sh0_oinOT00ooh
n?SonOWiooShn002ooWin@?on?Sh1?oinOT2ooShn0;onOWi00?on?ShooWinOohn?P00_oinOT3ooSh
n0ConOWi0_ohn?P2ooWin@03ooShn?oinOWon?Sh00;onOWi0oohn?P4ooWin@;on?Sh0_oinOT00ooh
n?SonOWiooShn002ooWin@?on?Sh1?oinOT2ooShn00Iokbl_?o@d=3o_;blogf2Som7GY3o:5NUoaYN
^olPI;co=6VXodMVRomNIVooQXJ6olK6a_o]kNgok>c/onKVi_mSHf?oIfMWofUYJOm/K6coKfm_og5a
LOmcLg?oMGEeogMgM`01ogQhN0000_ono_h2oogmo@03ookno_omoOgoo_kn00;ooOgm00?oo_knoogm
oOomoOd00_omoOd01?olo?cooOgmoogmoOomoOd2ooclo0?ooOgm00?oo?cloogmoOomoOd00_omoOd0
0oolo?cooOgmooclo003oogmo@06on_[joojn_[ooOgmoo;bl_oclo?oo?cl1?omoOd00omQHF7oD51@
ooclo003oogmo@;oo?cl0oomoOd00oolo?cooOgmoogmo@02oogmo@04ooclo?o[jn_on_[joogmo@;o
lo?c0_olo?`3oogmo@08ooclo?omoOgoT92@odM7AoomoOgoo?cloogmoOolo?`3oogmo@;oo?cl0oom
oOd00oolo?cooOgmoogmo@02oogmo@0<ooclo?omoOgoj^[Zoo_knoomoOgolo?coo;bl_olo?cooOgm
ohn?Som8B4Soo?cl1?omoOd01_olo?cooOgmooclo?ogmoOofMWIomgMg@;oo?cl0oomoOd00oolo?co
oOgmoogmo@02oogmo@03ooclo?omoOgoo?cl00?ooOgm0_olo?`3oogmo@03ooclo?omoOgooOgm00;o
oOgm00?oo?cloogmoOolo?`00oomoOd2ooclo0?ooOgm00?oo?cloogmoOomoOd00_omoOd00oolo?co
oOgmooclo003oogmo@;oo?cl0oomoOd00oolo?cooOgmoogmo@02oogmo@03ooclo?omoOgoo?cl00?o
oOgm0_olo?`3oogmo@03ooclo?omoOgooOgm00;ooOgm00?oo?cloogmoOolo?`00oomoOd2ooclo0?o
oOgm00?oo?cloogmoOomoOd00_omoOd00oolo?cooOgmooclo003oogmo@;oo?cl0oomoOd00oolo?co
oOgmoogmo@02oogmo@03ooclo?omoOgoo?cl00?ooOgm0_olo?`3oogmo@03ooclo?omoOgooOgm00;o
oOgm00?oo?cloogmoOolo?`00oomoOd2ooclo0?ooOgm00?oo?cloogmoOomoOd00_omoOd00oolo?co
oOgmooclo003oogmo@;oo?cl0oomoOd00oolo?cooOgmoogmo@02oogmo@03ooclo?omoOgoo?cl00?o
oOgm01Wo^[ZjokVi^OmbNYKo;U:Qo`e@_OlCG/;o8F[8oc1gc?lkP<oo@hKAodMdY_mJJ7WoP820olO7
aooUiNGok^k^of9RH_mUIFGoJ6QXofYZJ_m]KFgoKfm_og5aLOmcLg?oMGEe007oMWIf00000ooinOWo
n_[jooWin@0=ooWin@03ooShn?lm?CgoNGUi00;onOWi01WoAdM7oh:2P_ohn?Son?ShoginO_m:BT[o
nOWiooShn?nc/k?o5ADEooWinOohn?SoF5QHoa@D5?lU9BGoWIfMoahN7_mMGEgon?Shon;Rh_mSHf?o
@D51oginO_nMWIgo:BTY00;onOWi01OoAdM7oh:2P_ohn?SonOWiodQ8B?n2PX;onOWiooShn?nSXj?o
9bLWooShn?oinOWoEeMGoa@D5?lU9BGoW9bLoahN7_mNGUkon?ShodQ8B?n2PX;on?ShooWin@02ooSh
n004oiBDU?l=3@godm?CooShn0?onOWi01?on?ShooWinOohn?So?Shno`h>3_l=3@go51@DocPh>?mf
MWKok^k^ooShn?oinOWon?ShoeQHF?lD51Co9BDUoibLW?lO7aooGEeM00;onOWi00SoU9BDo`d=3OoC
dm?on?ShooWinOohn?SonOWiooShn0;onOWi00GoUYJFobLW9olm?Cgo=3@doh:2PP02ooShn007ooWi
nOohn?Son?ShooWinOohn?SonOWiooShn003ooWin@03ooShn?oinOWon?Sh00;onOWi00Son?ShooWi
nOohn?Son?ShooWinOohn?SonOWiooShn0?onOWi00?on?ShooWinOohn?P00_oinOT02?ohn?SonOWi
ooShn?ohn?SonOWiooShn?oinOWon?Sh0ooinOT00oohn?SonOWiooShn002ooWin@08ooShn?oinOWo
n?ShooShn?oinOWon?ShooWinOohn?P3ooWin@03ooShn?oinOWon?Sh00;onOWi00Son?ShooWinOoh
n?Son?ShooWinOohn?SonOWiooShn0?onOWi00?on?ShooWinOohn?P00_oinOT02?ohn?SonOWiooSh
n?ohn?SonOWiooShn?oinOWon?Sh0ooinOT00oohn?SonOWiooShn002ooWin@08ooShn?oinOWon?Sh
ooShn?oinOWon?ShooWinOohn?P3ooWin@03ooShn?oinOWon?Sh00;onOWi00Son?ShooWinOohn?So
n?ShooWinOohn?SonOWiooShn0?onOWi00?on?ShooWinOohn?P00_oinOT02?ohn?SonOWiooShn?oh
n?SonOWiooShn?oinOWon?Sh0ooinOT00oohn?SonOWiooShn002ooWin@08ooShn?oinOWon?ShooSh
n?oinOWon?ShooWinOohn?P3ooWin@0KooShn?oinOWo^k^kohb>WOlbD:?o3DRjo`mJ`_lLIlSo;7K>
ocZ1d_m6R=GoChoHoeFCfomBNZ_oI6]coiFEUOoHf=Soo_knof=SHomVIVKoJVYZofa/K?m_KfooLG5a
og=cLomeMGGoMgMg007oN7Qh0007onc/k003ong]kOo/k>cok>c/00?ok>c/1?o[jn/02_lj>S[oM7Ad
on_[joo[jn_oADE5ogalO?o/k>cojn_[ogMgMom7AdL2on_[j`0AojZZZ_lE5AGojn_[okVi^OlA4A7o
cLg=omCDe?mLG5co7AdMon_[joo/k>coD51@ocDe=OnJVY[oNGUiocDe=OlO7al00_o[jn/04Om4A4Co
O7alon_[joo[jn_oADE5ogalO?o[jn_ok>c/oibLW?lU9BGojn_[okVi^OlA4A7ocLg=omCDe?mMGEgo
71`L00;ojn_[00WoA4A4ogalO?o/k>cojn_[onc/k?o[jn_o=SHfoaHF5_m`L7001oo[jn/03oll?3co
LW9bonc/k?oQhN7o_knoodY:B_lZ:R[og]kNon_[jonj^[[o4A4Aolg=cOoEeMGoG5aLoa`L7003on_[
j`03ocLg=olE5AGoL71`00Oojn_[00WojNWYon_[joo[jn_oa<C4o`l?3onDU9Cok>c/on_[joo/k>`0
3Oo[jn/00oo/k>cojn_[onc/k00=on_[j`03onc/k?o[jn_ok>c/00gojn_[00?ok>c/on_[joo/k>`0
3Oo[jn/00oo/k>cojn_[onc/k00=on_[j`03onc/k?o[jn_ok>c/00gojn_[00?ok>c/on_[joo/k>`0
3Oo[jn/00oo/k>cojn_[onc/k00=on_[j`03onc/k?o[jn_ok>c/00gojn_[00?ok>c/on_[joo/k>`0
2_o[jn/06Ong]kOoG6VQo`hk/_lADKko66;6obI^c?leN]7oA8OFoe:Ag?mJV>7oI:7WofJRi_mGL8ko
OGemokno_oo_knooIfMWofYZJ_m]KFgoL71`og=cLomeMGGoN7QhogYjN_mkNg/00OmmOGd000conOWi
0_ohn?P07?oinOWon?ShooWinOll?3coNWYjooWinOohn?SoB4Q8oh:2P_ohn?SonOWiogemOOm;Bd_o
nOWiooShn?nb/[;o5ADEooShn?oEeMGo3`l?okbl_?oinOWoWinOob/[:ooinOWol?3`oaDE5Ong]kL2
ooWin@06oiNGUolL71conOWiooShn?m8B4SoPX:20_oinOT04Om7AdOoPX:2ooWinOohn?SoXj>SobLW
9ooinOWoeMGEo`l?3onk^k_onOWioinOWol[:b_on?ShooWinOm8B4SoPX:200;onOWi00kon?Shol[:
b_l=3@goWinOoahN7_obl_;on?ShooWinOohn?SonOWiooShn?oinOWo?cloogMgM`;onOWi00_on?Sh
ooCdm?lY:BWoMGEeooWinOoDe=Co3`l?okbl_?ohn?SoWinOobXZ:P02ooWin@06olW9bOl>3PkoWinO
oahN7_obl_;on?Sh0_oinOT2ooShn007ooWinOohn?SonOWiooShn?oinOWo@d=3ofEUI@02ooWin@03
ooShn?oinOWon?Sh00;onOWi0_ohn?P01?oinOWon?ShooWinOohn?P2ooWin@06ooShn?oinOWonOWi
ooShn?oinOWon?Sh0_oinOT2ooShn004ooWinOohn?SonOWiooShn0;onOWi00Kon?ShooWinOoinOWo
n?ShooWinOohn?P2ooWin@;on?Sh00ConOWiooShn?oinOWon?Sh0_oinOT01_ohn?SonOWiooWinOoh
n?SonOWiooShn0;onOWi0_ohn?P01?oinOWon?ShooWinOohn?P2ooWin@06ooShn?oinOWonOWiooSh
n?oinOWon?Sh0_oinOT2ooShn004ooWinOohn?SonOWiooShn0;onOWi00Kon?ShooWinOoinOWon?Sh
ooWinOohn?P2ooWin@;on?Sh00ConOWiooShn?oinOWon?Sh0_oinOT01_ohn?SonOWiooWinOohn?So
nOWiooShn0;onOWi0_ohn?P01?oinOWon?ShooWinOohn?P2ooWin@06ooShn?oinOWonOWiooShn?oi
nOWon?Sh0_oinOT2ooShn004ooWinOohn?SonOWiooShn0;onOWi00Kon?ShooWinOoinOWon?ShooWi
nOohn?P2ooWin@;on?Sh00ConOWiooShn?oinOWon?Sh0_oinOT01_ohn?SonOWiooWinOohn?SonOWi
ooShn0;onOWi0_ohn?P07OoinOWon?ShooWinOohn?So[Zj^oc=:Y?lGB[_oEXkFof6Jfom>SmWo>X3E
odZ<f_mGV>CoIJC/ofn/m?mb/?WoHX^mog9bL_n^[Zkoi^KVof=SHomWIfOoJFUYofa/K?m_KfooLG5a
og=cLomeMGGoMgMg007oN7Qh0002ooknoP07oogmoOono_kooOgmoogmoOono_kooOgmooknoP06oogm
o@04ooclo?omoOgo?Shnog]kN`;ooOgm00KoBDU9ohF5QOolo?cooOgmogmoOom;Bd/2oogmo@0XokNg
]olE5AGoo?cloogmoOn`/;3o>c/kocdm?Olo?coo:b/[oogmoOo3`l?o3@d=onGUiOolo?cooOgmojn_
[olM7AgooOgmooclo?m9BDWoQ8B4ooclo?omoOgoBDU9ohB4Q?omoOgoo?clojJVY_lW9bOoo?cloogm
oOn`/;3o?3`locdm?Olo?coo:b/[oogmoOolo?coBDU9ohB4Q0;ooOgm00Koo?clog1`L?m:BT[oo?cl
oc8b<_nWYjL2oogmo@06ooclo?omoOgooOgmooclo?m0@43oNWYj0_omoOd01?olo?cooOgmoh61POl/
;2`2oogmo@0>ok2`/?ll?3co?3`lod10@?l[:b_oo?cloogmoOm`L73oBTY:oogmoOlb<S;oYjNWoogm
oOolo?`4oogmo@06ooclo?omoOgooOgmono_kolK6a_oOgmo0_omoOd01?olo?cooOgmoogmoOolo?`4
oogmo@04ooclo?omoOgooOgmooclo0CooOgm00Coo?cloogmoOomoOgoo?cl1?omoOd01?olo?cooOgm
oogmoOolo?`4oogmo@04ooclo?omoOgooOgmooclo0CooOgm00Coo?cloogmoOomoOgoo?cl1?omoOd0
1?olo?cooOgmoogmoOolo?`4oogmo@04ooclo?omoOgooOgmooclo0CooOgm00Coo?cloogmoOomoOgo
o?cl1?omoOd01?olo?cooOgmoogmoOolo?`4oogmo@04ooclo?omoOgooOgmooclo0CooOgm00Coo?cl
oogmoOomoOgoo?cl1?omoOd01?olo?cooOgmoogmoOolo?`4oogmo@04ooclo?omoOgooOgmooclo0Co
oOgm00Coo?cloogmoOomoOgoo?cl1?omoOd01?olo?cooOgmoogmoOolo?`4oogmo@04ooclo?omoOgo
oOgmooclo0CooOgm00Coo?cloogmoOomoOgoo?cl1?omoOd01?olo?cooOgmoogmoOolo?`4oogmo@0L
ooclo?omoOgooOgmoj^[ZolG=:OoCG_=ohfehon5/N?oO:gSocn5eom@Tn7oGj7Zof^^mOmh^okoP/Cn
og:/k?mXJ6SoZJVYong]kOmRHV;oIFEUofQXJ?mZJV[oKFe]ofm_KomaLG7oLg=cogEeM@7oMWIf0004
ooWin@03oo[jn_oinOWonOWi00ConOWi00con_[jooWinOohn?SonOWiooShn?oinOWo?3`logYjN_oh
n?SonOWiodQ8B?maLG42ooWin@0AogalO?ll?3con?ShooShn?na/K7o5ADEooShn?oinOWon?ShooWi
nOofm_KoUYJFob`/;?ohn?Soe]KFo`h>3_nd];@00_oinOT03_n[Zj_o71`LooWinOohn?SoB4Q8oh:2
P_oinOWon?ShodQ8B?mSHf?on?ShooWinOnNWYko:2PX0_oinOT2ooShn00IooOgmonFUYKo;2`/ooSh
n?oinOWoAdM7ofi^K_oinOWon?Shoo3`l?lK6a_oXZ:RooWinOnBTY;oATI6ooShn?oinOWon?ShooWi
nOohn?SonOWiochn?_mhN7SonOWiooShn002ooWin@03oijNW_l?3`oolo?c00;on?Sh00_onOWiooKf
m_nFUYKo:b/[ooWinOo`l?3o6a/Koj:RX_ohn?SoTY:BodI6AP03ooWin@;on?Sh00WonOWionk^k_o>
c/koW9bLodm?ColN7QkogMgMooWinOohn?P01OoinOT2ooShn006ooWinOohn?SonOWiooShn?oinOWo
n?Sh0_oinOT00oohn?SonOWiooWin@03ooWin@;on?Sh00KonOWiooShn?oinOWon?ShooWinOohn?P2
ooWin@03ooShn?oinOWonOWi00?onOWi0_ohn?P01_oinOWon?ShooWinOohn?SonOWiooShn0;onOWi
00?on?ShooWinOoinOT00ooinOT2ooShn006ooWinOohn?SonOWiooShn?oinOWon?Sh0_oinOT00ooh
n?SonOWiooWin@03ooWin@;on?Sh00KonOWiooShn?oinOWon?ShooWinOohn?P2ooWin@03ooShn?oi
nOWonOWi00?onOWi0_ohn?P01_oinOWon?ShooWinOohn?SonOWiooShn0;onOWi00?on?ShooWinOoi
nOT00ooinOT2ooShn006ooWinOohn?SonOWiooShn?oinOWon?Sh0_oinOT00oohn?SonOWiooWin@03
ooWin@;on?Sh00KonOWiooShn?oinOWon?ShooWinOohn?P2ooWin@03ooShn?oinOWonOWi00?onOWi
0_ohn?P01_oinOWon?ShooWinOohn?SonOWiooShn0;onOWi00?on?ShooWinOoinOT00ooinOT2ooSh
n00MooWinOohn?SonOWiooShn?n/[:co3Bn]ogBIf_n@^NKoRKKToh6ai?m2R=_oEY[XofFVl?mf^?ko
PL?nohS>oOn4aOkoI6ATojVYZOomoOgoHf=SofIVI_mZJV[oK6a/ofm_KomaLG7oLg=cogEeMOmgMgL0
0OmhN7P000gok>c/0oo[jn/00oo/k>co>SXjogAdM002on_[j`0IodE5AOlP823oR8R8omKFe_m5ADGo
:2PXof5QHOoBd];oL71`ocXj>_o[jn_ok>c/ojVYZOo:b/[ojNWYof5QHOmGEeOojn_[onc/k?m1@D7o
BTY:om;Bd_oOgmooFEUIoa`L7002on_[j`0AodE5AOmlO7cojn_[on_[jom4A4Co7alOogAdM?o?cloo
FEUIoe1@D?o[jn_ok>c/ojZZZ_o:b/[ojNWYof9RH_mGEeL00_o[jn/02om5ADGo7QhNoh^;RooDe=Co
VYZJoaTI6OoRh^;ojn_[omcLg?lF5QKob<S800;ojn_[00Gok>c/on_[joo[jn_o?3`log5aL@02on_[
j`0Eonc/k?o[jn_oRXZ:oa8B4_oXj>Sojn_[ojVYZOo;bl_oj>SXof9RH_mGEeOojn_[oibLW?lI6AWo
h^;Ron_[jooLg=co5ADEolS8b?o[jn_ok>c/00?ojn_[00Go/[:boa@D5?m7AdOoLG5aom?Cd`03on_[
j`05onc/k?o[jn_ojn_[on_[joo/k>`01?o[jn/00oo/k>cojn_[on_[j`04on_[j`05onc/k?o[jn_o
jn_[on_[joo/k>`01?o[jn/00oo/k>cojn_[on_[j`04on_[j`05onc/k?o[jn_ojn_[on_[joo/k>`0
1?o[jn/00oo/k>cojn_[on_[j`04on_[j`05onc/k?o[jn_ojn_[on_[joo/k>`01?o[jn/00oo/k>co
jn_[on_[j`04on_[j`05onc/k?o[jn_ojn_[on_[joo/k>`01?o[jn/00oo/k>cojn_[on_[j`04on_[
j`05onc/k?o[jn_ojn_[on_[joo/k>`01?o[jn/00oo/k>cojn_[on_[j`04on_[j`05onc/k?o[jn_o
jn_[on_[joo/k>`01?o[jn/00oo/k>cojn_[on_[j`04on_[j`05onc/k?o[jn_ojn_[on_[joo/k>`0
1?o[jn/00oo/k>cojn_[on_[j`04on_[j`05onc/k?o[jn_ojn_[on_[joo/k>`01?o[jn/00oo/k>co
jn_[on_[j`04on_[j`05onc/k?o[jn_ojn_[on_[joo/k>`01?o[jn/06oo/k>cojn_[ojn_[ol>;J_o
NioKoi>ji_n;]nKoPk;WodJ;g_mHVn[oJJ_fogZkoon6bOooSm;oohW;oomSHf?o[:b/ono_komVIVKo
JVYZofe]KOm`L73oLg=cogEeMOmhN7SoNWYjog]kN`01ogemO@003?oinOT06_ohn?SonOWiooShn?oi
nOWon?Shoc`l??mjNW[onOWiooShn?mKFe_oSHf=ogAdM?lK6a_o<C4aom7AdOnJVY[o92@Tob/[:on/
[:conOWiooShn?n<S8co?3`loa/K6om1@D7o`/;20_ohn?P02_oNg]koBd];oaLG5olc<c?oNGUioc@d
=?ohn?SonOWioeYJF_n?Shl2ooWin@0LoeYJF_n>SXkoO7aloalO7olh>3So`L71ooWinOohn?SoS8b<
oc`l??lK6a_o@D51ol71`Oohn?SonOWioe]KFon;Rh_oHf=Soa@D5?mJFU[oMGEeooShn?oinOWon?Sh
ofm_Kon8R8Son?ShooWin@;on?Sh00ConOWiochn?_mgMgOonOWi0_ohn?P00ooinOWoF5QHocHf=P02
ooShn009ohf=SOlk>c_o71`Lod51@Oo2`/;onOWiof1PH?mdM7ConOWi00;on?Sh00?oL71`ohN7Qooi
nOT00_ohn?P01OoinOWon?Shokbl_?lb<S;on?Sh00;onOWi00Oon?ShooWinOohn?Son?ShooWinOoh
n?SonOWi00;on?Sh00?onOWiooShn?oinOT00_ohn?P2ooWin@07ooShn?oinOWon?ShooShn?oinOWo
n?ShooWin@02ooShn003ooWinOohn?SonOWi00;on?Sh0_oinOT01oohn?SonOWiooShn?ohn?SonOWi
ooShn?oinOT00_ohn?P00ooinOWon?ShooWin@02ooShn0;onOWi00Oon?ShooWinOohn?Son?ShooWi
nOohn?SonOWi00;on?Sh00?onOWiooShn?oinOT00_ohn?P2ooWin@07ooShn?oinOWon?ShooShn?oi
nOWon?ShooWin@02ooShn003ooWinOohn?SonOWi00;on?Sh0_oinOT01oohn?SonOWiooShn?ohn?So
nOWiooShn?oinOT00_ohn?P00ooinOWon?ShooWin@02ooShn0;onOWi00Oon?ShooWinOohn?Son?Sh
ooWinOohn?SonOWi00;on?Sh00?onOWiooShn?oinOT00_ohn?P2ooWin@07ooShn?oinOWon?ShooSh
n?oinOWon?ShooWin@02ooShn003ooWinOohn?SonOWi00;on?Sh0_oinOT01oohn?SonOWiooShn?oh
n?SonOWiooShn?oinOT00_ohn?P00ooinOWon?ShooWin@02ooShn0;onOWi00Oon?ShooWinOohn?So
n?ShooWinOohn?SonOWi00;on?Sh00?onOWiooShn?oinOT00_ohn?P06On^[Zko3Bb/og^NfonB^NGo
R;KUoh2`iOm5SMooF9c]ofR/n?mh_OkoQ/_moi7Fo_n8bogoI6AToj^[ZooVi^KoHf=SofIVI_mYJFWo
K6a/ofi^K_m`L73oLg=cogEeMOmgMgL00OmhN7P000KooOgm00Coo_knoogmoOomoOgoo_kn1?omoOd0
1oolo?cooOgmoogmoOlm?CgoNg]koogmoOolo?`00oomoOd01ookno_ooOgmoogmoOolo?cooOgmoo_k
noolo?`00_omoOd2ooclo003oo_knoolo?cooOgm00;ooOgm00Goo?cloogmoOokno_oo?cloogmo@02
ooclo0;ooOgm0_olo?`01?omoOgoo?cloogmoOomoOd2ooclo0;ooOgm00Coo?cloogmoOolo?con_[j
0_omoOd2ooclo006oogmoOolo?cooOgmoo[jn_omoOgoo?cl0_omoOd01?olo?cooOgmooclo?olo?`2
oogmo@;oo?cl00?o?cloogUiNOomoOd00_omoOd01OnRXZ;o3Ph>ojBTY?olo?cooOgm00;oo?cl00Ko
no_koogmoOolo?coo?cloogmoOolo?`3oogmo@05ooclo?omoOgooOgmooclo?omoOd00_olo?`01_nn
_[ko<c<cooclo?olo?cooOgmooclo0?ooOgm00Goo?cloogmoOomoOgoo?cloogmo@02ooclo0;ooOgm
0_olo?`00oomoOgoo?cloogmo@02oogmo@05ooclo?omoOgooOgmooclo?omoOd00_olo?`2oogmo@;o
o?cl00?ooOgmooclo?omoOd00_omoOd01Oolo?cooOgmoogmoOolo?cooOgm00;oo?cl0_omoOd2oocl
o003oogmoOolo?cooOgm00;ooOgm00Goo?cloogmoOomoOgoo?cloogmo@02ooclo0;ooOgm0_olo?`0
0oomoOgoo?cloogmo@02oogmo@05ooclo?omoOgooOgmooclo?omoOd00_olo?`2oogmo@;oo?cl00?o
oOgmooclo?omoOd00_omoOd01Oolo?cooOgmoogmoOolo?cooOgm00;oo?cl0_omoOd2ooclo003oogm
oOolo?cooOgm00;ooOgm00Goo?cloogmoOomoOgoo?cloogmo@02ooclo0;ooOgm0_olo?`00oomoOgo
o?cloogmo@02oogmo@05ooclo?omoOgooOgmooclo?omoOd00_olo?`2oogmo@;oo?cl00?ooOgmoocl
o?omoOd00_omoOd01Oolo?cooOgmoogmoOolo?cooOgm00;oo?cl0_omoOd2ooclo003oogmoOolo?co
oOgm00;ooOgm00Goo?cloogmoOomoOgoo?cloogmo@02ooclo0;ooOgm01[oo?clojf][Ol<:JWoOYoJ
oi2fi?n7]NGoOk3Vod:;gomCV^[oIj_kogFjoOn3b?koSMGmohK=oOmTI6Co[:b/ong]kOmQHF7oI6AT
ofMWIomZJV[oK6a/ofi^K_m`L73oLW9bogAdM07oMGEe0007ooWin@05ooShn?oinOWonOWiooShn?oi
nOT01Oohn?P00oll?3coNGUiooShn00LooShn003of5QHOnCTi?on?Sh023on?Sh00So?ShnocLg=omY
JFWoEEEEocHf=_lB4Q;oTI6AooOgmaCon?Sh00?o^k^koaPH6?mCDe<00_mDE5@00onVYZKon?ShooSh
n02KooShn00Iojj^[_l=@kKoOJOOoiZnionF_NWoSKSYoeJGhomXZNooNKKmoh[9o_nFeOgoX^?noi[I
o_mTI6Co[Zj^oogmoOmRHV;oIFEUofQXJ?m[Jf_oKVi^ofm_KombLW;oM7AdogIfMP01ogMgM`0000?o
o_knooooooono_h01?ono_h2ooooo`Koo_kn0_omoOd01?nc/k?obl_;oogmoOono_h2oogmo@;oo_kn
00KooOgmookno_ono_koo_knoogmoOono_h2oogmo@04ookno_omoOgooOgmooknoP;ooOgm0_ono_h0
2OomoOgoo_knookno_ono_kooOgmookno_omoOgo]kNgolo?c`02oogmo@03ookno_omoOgooOgm00;o
o_kn00KooOgmookno_ono_koo_knoogmoOono_h2oogmo@04ookno_omoOgooOgmooknoP;ooOgm0_on
o_h01_omoOgoo_knookno_ono_kooOgmooknoP;ooOgm00Woo_knoogmoOnc/k?oWinOoijNW_nVYZKo
a/K6on_[joomoOd00oono_h01OomoOgoo_knoogmoOomoOgoo_kn00;ooOgm00?oo_knoogmoOomoOd0
0_ono_h02OomoOgoo_knookno_ono_kooOgmookno_oUiNGoWYjNoinOW`02oijNWP03om3@d?omoOgo
oOgm00;oo_kn00KooOgmookno_ono_koo_knoogmoOono_h2oogmo@04ookno_omoOgooOgmooknoP;o
oOgm0_ono_h01_omoOgoo_knookno_ono_kooOgmooknoP;ooOgm00Coo_knoogmoOomoOgoo_kn0_om
oOd2ooknoP06oogmoOono_koo_knookno_omoOgoo_kn0_omoOd01?ono_kooOgmoogmoOono_h2oogm
o@;oo_kn00KooOgmookno_ono_koo_knoogmoOono_h2oogmo@04ookno_omoOgooOgmooknoP;ooOgm
0_ono_h01_omoOgoo_knookno_ono_kooOgmooknoP;ooOgm00Coo_knoogmoOomoOgoo_kn0_omoOd2
ooknoP06oogmoOono_koo_knookno_omoOgoo_kn0_omoOd01?ono_kooOgmoogmoOono_h2oogmo@;o
o_kn00KooOgmookno_ono_koo_knoogmoOono_h2oogmo@04ookno_omoOgooOgmooknoP;ooOgm0_on
o_h01_omoOgoo_knookno_ono_kooOgmooknoP;ooOgm00Coo_knoogmoOomoOgoo_kn0_omoOd2ookn
oP06oogmoOono_koo_knookno_omoOgoo_kn0_omoOd01?ono_kooOgmoogmoOono_h2oogmo@;oo_kn
00KooOgmookno_ono_koo_knoogmoOono_h2oogmo@0Jookno_n^[Zko3D>fogjWgonG_NKoTkgWoh^h
j_mDUnCoIZK^ogNfo?n8aoooU]KooioQo_nIeokoI6ATojn_[oo_knooI6ATofQXJ?m[Jf_oKVi^og5a
LOmcLg?oMGEeogQhN?mjNWX1ogalO0000_oinOT00oohn?SonOWiooWin@04ooShn004ooWinOohn?So
n?ShooOgm`;on?Sh00ComoOgooShn?ohn?SomoOg0_ohn?P01?ogmoOon?ShooShn?ogmoL2ooShn0;o
moOg0_ohn?P01?ogmoOon?ShooShn?ogmoL2ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh0_ogmoL2
ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh00ComoOgooShn?ohn?SomoOg0_ohn?P2ooOgm`;on?Sh
00ComoOgooShn?ohn?SomoOg0_ohn?P01?ogmoOon?ShooShn?ogmoL2ooShn0;omoOg0_ohn?P01?og
moOon?ShooShn?ogmoL2ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh0_ogmoL2ooShn004ooOgmooh
n?Son?ShooOgm`;on?Sh00ComoOgooShn?ohn?SomoOg0_ohn?P2ooOgm`;on?Sh00ComoOgooShn?oh
n?SomoOg0_ohn?P01?ogmoOon?ShooShn?ogmoL2ooShn0;omoOg0_ohn?P01?ogmoOon?ShooShn?og
moL2ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh0_ogmoL2ooShn004ooOgmoohn?Son?ShooOgm`;o
n?Sh00ComoOgooShn?ohn?SomoOg0_ohn?P2ooOgm`;on?Sh00ComoOgooShn?ohn?SomoOg0_ohn?P0
1?ogmoOon?ShooShn?ogmoL2ooShn0;omoOg0_ohn?P01?ogmoOon?ShooShn?ogmoL2ooShn004ooOg
moohn?Son?ShooOgm`;on?Sh0_ogmoL2ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh00ComoOgooSh
n?ohn?SomoOg0_ohn?P2ooOgm`;on?Sh00ComoOgooShn?ohn?SomoOg0_ohn?P01?ogmoOon?ShooSh
n?ogmoL2ooShn0;omoOg0_ohn?P01?ogmoOon?ShooShn?ogmoL2ooShn004ooOgmoohn?Son?ShooOg
m`;on?Sh0_ogmoL2ooShn004ooOgmoohn?Son?ShooOgm`;on?Sh00ComoOgooShn?ohn?SomoOg0_oh
n?P2ooOgm`;on?Sh00ComoOgooShn?ohn?SomoOg0_ohn?P01?ogmoOon?ShooShn?ogmoL2ooShn0;o
moOg0_ohn?P07?ogmoOon?ShooShn?n][Jgo3D:eogfUg_nE_>KoTK_VohNeiom@UN?oHjK^ogBeo?n2
`_goSlomoi_OoOnEeOgoI6ATojj^[_oUiNGoH61Pof=SHomWIfOoJFUYofa/K?m^KVkoL71`og9bL_md
M7@1ogIfMP001?oZj^X00ooYjNWoj^[Zon[ZjP03onWYj@03on[Zj_oYjNWojNWY00;ojNWY00?oj>SX
onWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SXonWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SX
onWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SXonWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SX
onWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SXonWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SX
onWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SXonWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SX
onWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SXonWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SX
onWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SXonWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SX
onWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SXonWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SX
onWYjOoYjNT01OoYjNT2onSXj0KojNWY00?oj>SXonWYjOoYjNT01OoYjNT2onSXj0KojNWY01coj>SX
onWYjOoYjNWo[Jf]o`a1]?mjX=_oU;[UohjfiOn6]>GoBXkNoenPj_m`/?_oP;klohc=o?nFfOcoTM;l
of9RH_n][Jgok>c/oeiNG_mQHF7oI6ATofMWIomYJFWoJf][ofe]KOm_KfooLW9b0OmcLg<00003ooWi
nOohn?SonOWi00Won?ShooogmoL7ooOgm`0Iojf][Ol<@KCoNj3Kohnii?n=^>GoQ;?VodR>gomJWN[o
JjkhogbnoOn7cOcoU=_mohc@o?mSHf?o[Zj^ooclo?mOGeooHF5QofEUIOmWIfOoJVYZofa/K?m^KVko
LG5aog9bLP01ogEeM@000_ono_h00oomoOgoo_knoogmo@07oogmo@coo?cl00?ooOgmooclo?omoOd0
3Oolo?`01Oo1`L7oQhN7ofQXJ?mnOWkoc/k>00_oo?cl00?ooOgmooclo?omoOd03Oolo?`00ooPh>3o
PX:2ooKfmP0=ooclo003oogmoOolo?cooOgm00Woo?cl00OogmoOoh>3PooemOGoo?cloogmoOolo?co
oOgm00goo?cl00?ooOgmooclo?omoOd03Oolo?`00oomoOgoo?cloogmo@0=ooclo003oogmoOolo?co
oOgm00goo?cl00?ooOgmooclo?omoOd03Oolo?`00oomoOgoo?cloogmo@0=ooclo003oogmoOolo?co
oOgm00goo?cl00?ooOgmooclo?omoOd03Oolo?`00oomoOgoo?cloogmo@0=ooclo003oogmoOolo?co
oOgm00goo?cl00?ooOgmooclo?omoOd01oolo?`06On][Jgo34:eogbNfOn@^>CoR;GToh2_i?m5S>3o
EY[YofN[momg_OgoQ<WmohkEoOn5bOgoHf=Sojj^[_o]kNgoH61Pof=SHomVIVKoJFUYofa/K?m_Kfoo
LG5aogAdM?mfMWH00OmhN7P00006ooShn?ogmoOon?ShooShn?ogmoOon?Sh0_ogmoL01?ohn?SomoOg
ooOgmoofm_H2ooOgm`03ooKfm_ogmoOom_Kf00;om_Kf00?omoOgooKfm_ogmoL00_ofm_H01?ogmoOo
m_KfooKfm_ofm_H2ooOgm`03ooKfm_ogmoOom_Kf00;om_Kf00?omoOgooKfm_ogmoL00_ofm_H02?n9
RHWoMgMgoj:RX_mVIVKo5ADEokVi^Oofm_KomoOg0oofm_H00oogmoOom_KfooOgm`02ooKfmP04ooOg
moofm_Kom_KfooKfmP;omoOg00?om_KfooOgmoofm_H00_ofm_H00oogmoOom_KfooOgm`02ooKfmP04
oo?clolU9BGoXZ:RooKfmP;omoOg00?om_KfooOgmoofm_H00_ofm_H00oogmoOom_KfooOgm`02ooKf
mP04ooOgmoofm_Kom_KfooKfmP;omoOg00?om_KfooOgmoofm_H00_ofm_H01_ogmoOol_;bobHV9_nR
XZ;om_KfooOgm`?om_Kf0_ogmoL00oofm_KomoOgooKfmP02ooKfmP03ooOgmoofm_KomoOg00;om_Kf
00ComoOgooKfm_ofm_Kom_Kf0_ogmoL00oofm_KomoOgooKfmP02ooKfmP03ooOgmoofm_KomoOg00;o
m_Kf00ComoOgooKfm_ofm_Kom_Kf0_ogmoL00oofm_KomoOgooKfmP02ooKfmP03ooOgmoofm_KomoOg
00;om_Kf00ComoOgooKfm_ofm_Kom_Kf0_ogmoL00oofm_KomoOgooKfmP02ooKfmP03ooOgmoofm_Ko
moOg00;om_Kf00ComoOgooKfm_ofm_Kom_Kf0_ogmoL00oofm_KomoOgooKfmP02ooKfmP03ooOgmoof
m_KomoOg00;om_Kf00ComoOgooKfm_ofm_Kom_Kf0_ogmoL00oofm_KomoOgooKfmP02ooKfmP03ooOg
moofm_KomoOg00;om_Kf00ComoOgooKfm_ofm_Kom_Kf0_ogmoL00oofm_KomoOgooKfmP02ooKfmP03
ooOgmoofm_KomoOg00;om_Kf00ComoOgooKfm_ofm_Kom_Kf0_ogmoL00oofm_KomoOgooKfmP02ooKf
mP03ooOgmoofm_KomoOg00;om_Kf00ComoOgooKfm_ofm_Kom_Kf0_ogmoL00oofm_KomoOgooKfmP02
ooKfmP03ooOgmoofm_KomoOg00;om_Kf00ComoOgooKfm_ofm_Kom_Kf0_ogmoL00oofm_KomoOgooKf
mP02ooKfmP03ooOgmoofm_KomoOg00;om_Kf00ComoOgooKfm_ofm_Kom_Kf0_ogmoL07Oofm_KomoOg
ooKfm_ofm_Ko[:b/o`/e[OmiXm[oU;_Toi2ii?n8]^OoCi;Rof2Qjomc/oWoP/;koho?o?nHfocoT=7l
of=SHon][Jgoi>CToeaLG?mOGeooHV9RofEUIOmWIfOoJFUYofa/K?m^KVkoL71`007oLW9b0003onWY
j@04onSXj?oYjNWoj>SXonWYj@Goj>SX1?oWinL2onSXj0;oinOW00?oj>SXonOWiooXj>P00ooWinL0
0ooXj>SoinOWonOWi`03onOWi`;oj>SX00?oe]KFonGUiOoXj>P00_oMgMd3onOWi`04onSXj?oWinOo
EeMGodM7A`;oinOW0_oXj>P2onOWi`03onSXj?oWinOoj>SX00?oinOW00Koj>SXonOWiooWinOoe]KF
onGUiOoWinL2omgMg@;oinOW00?oj>SXonOWiooXj>P00_oWinL00on3Ph?o@410onOWi`04onOWi`;o
j>SX0_oWinL00ooXj>SoinOWonSXj003onOWi`07onSXj?oWinOoinOWonOWiooFe]KoiNGUonSXj002
omgMg@04onOWiooXj>SoPX:2od10@0?oinOW00?oj>SXonOWiooWinL00ooWinL2onSXj0;oinOW00?o
j>SXonOWiooXj>P00ooWinL00ooXj>SoinOWonOWi`03onOWi`;oj>SX0_oWinL00ooXj>SoinOWonSX
j003onOWi`03onSXj?oWinOoinOW00?oinOW0_oXj>P2onOWi`03onSXj?oWinOoj>SX00?oinOW00?o
j>SXonOWiooWinL00ooWinL2onSXj0;oinOW00?oj>SXonOWiooXj>P00ooWinL00ooXj>SoinOWonOW
i`03onOWi`;oj>SX0_oWinL00ooXj>SoinOWonSXj003onOWi`03onSXj?oWinOoinOW00?oinOW0_oX
j>P2onOWi`03onSXj?oWinOoj>SX00?oinOW00?oj>SXonOWiooWinL00ooWinL2onSXj0;oinOW00?o
j>SXonOWiooXj>P00ooWinL00ooXj>SoinOWonOWi`03onOWi`;oj>SX0_oWinL00ooXj>SoinOWonSX
j003onOWi`03onSXj?oWinOoinOW00?oinOW0_oXj>P2onOWi`03onSXj?oWinOoj>SX00?oinOW00?o
j>SXonOWiooWinL00ooWinL2onSXj0;oinOW00?oj>SXonOWiooXj>P00ooWinL00ooXj>SoinOWonOW
i`03onOWi`;oj>SX01WoZj^[o`Xd[OmhXM_oU;_Uohjhi?n8]NGoCi3Nof2Pk?mb/OWoPKokohk>n_nI
g?_oT<gjof5QHOn/[:cojn_[oeUIFOmLG5coGemOof5QHOmTI6CoIVIVofUYJOm[Jf_oKFe]007oKfm_
00000oogmoOon?ShooOgm`02ooOgm`Oom_Kf00?omOGeooKfm_oemOD00_oemOD01_lj>S[oMWIfooGe
mOofm_KoA4A4ogmoO`;omOGe00KoNWYjodM7Aoofm_KomOGeok2`/?lB4Q82ooGem@0=oeEEEOl@413o
8B4QoiVIVOlK6a_oFUYJooGemOoNg]koH61Pocdm?OmjNW[oVYZJobHV9P02ooGem@06odA4A?moOgoo
mOGeooGemOm5ADGoOgmo0_oemOD03OnOWioo92@TooGemOofm_KoE5ADoa4A4OlR8R;oVIVIoaXJ6_mJ
FU[omOGeodA4A?moOgl01?oemOD01OnATI7o2PX:om3@d?oemOGom_Kf00?omOGe00?om_KfooGemOlk
>c/00_l:2PX06?lA4A7o=CDeog=cLooZj^[omOGeooKfm_oemOGoEEEEoa4A4OlQ8B7oV9RHoa/K6omJ
FU[omOGeooKfm_n@T93o2PX:om3@d?oemOGom_KfooGemOofm_KomOGeooKfmP?omOGe00Com_KfomcL
g?l:2P[oi^KV1?oemOD01Oofm_KomOGeooKfm_oemOGom_Kf00?omOGe00Com_KfooGemOoemOGom_Kf
1?oemOD01Oofm_KomOGeooKfm_oemOGom_Kf00?omOGe00Com_KfooGemOoemOGom_Kf1?oemOD01Oof
m_KomOGeooKfm_oemOGom_Kf00?omOGe00Com_KfooGemOoemOGom_Kf1?oemOD01Oofm_KomOGeooKf
m_oemOGom_Kf00?omOGe00Com_KfooGemOoemOGom_Kf1?oemOD01Oofm_KomOGeooKfm_oemOGom_Kf
00?omOGe00Com_KfooGemOoemOGom_Kf1?oemOD01Oofm_KomOGeooKfm_oemOGom_Kf00?omOGe00Co
m_KfooGemOoemOGom_Kf1?oemOD01Oofm_KomOGeooKfm_oemOGom_Kf00?omOGe00Com_KfooGemOoe
mOGom_Kf1?oemOD01Oofm_KomOGeooKfm_oemOGom_Kf00?omOGe00Com_KfooGemOoemOGom_Kf1?oe
mOD01Oofm_KomOGeooKfm_oemOGom_Kf00?omOGe00Com_KfooGemOoemOGom_Kf1?oemOD01Oofm_Ko
mOGeooKfm_oemOGom_Kf00?omOGe01[om_Kfoj^[Zol:=:koNJ?KoiBji?n?^>CoR;CVodn@h?mQX>_o
Lk;hoh70non>c_[oUMOkohg8nomQHF7o[:b/oo_knomIFEWoG5aLoemOGomQHF7oI6ATofIVI_mYJFWo
Jf][ofe]K@7oL71`0006ooclo003oo_knoolo?cono_k00;ono_k00?on_[joo_knoojn_X00oojn_X0
1_lk>c_oNGUioo[jn_ojn_[oATI6oh61P@;on_[j00goOGemodU9BOojn_[on_[jokBd]?lB4Q;on_[j
olC4a?l>3Pkof][Jon;Rh_mOGeoo6QXJ00;on_[j00KoDe=CocDe=OnSXj?oOgmoocDe=OlM7Ad2oo[j
nP06odI6A_n2PX;on_[joo[jn_m6ATKoPX:20_ojn_X02OnTY:Co92@Too[jn_o4a<Co3Ph>om[Jf_oR
h^;oH61PoaXJ6P02oo[jnP03odI6A_n2PX;on_[j00?on_[j00?o=SHfoa<C4omdM7@01oojn_X03olm
?CgoMgMgoo[jn_o`l?3obl_;od];BolY:BWok>c/oo[jn_o5aLGo3Ph>om[Jf_oShn?oGemOoaXJ6P03
oo[jnP03ocLg=olB4Q;oMGEe00[on_[j00?ohN7Qo`X:2_oZj^X0WOojn_X06On[Zj_o2SR`ofbIf?nB
^NCoSKOSohBbi_m=T>7oGj7Zog6anOmo__[oS<ckoi3@non9aO[oIFEUojj^[_o[jn_oFUYJoeeMGOmP
H63oHf=SofEUIOmXJ6SoJf][ofe]KOm`L7000OmbLW800006ooOgmoofm_KomoOgooKfm_oemOGom_Kf
1_oemOD5ooCdm006ocPh>?meMGGom?CdooCdm?m4A4CoOWin0_odm?@04OmiNGWoATI6ooCdm?odm?Co
[Zj^oa4A4Oodm?CodM7Ao`X:2_ng]kOom?CdoiZJV_lV9RKom?Cdon_[jolA4A7o/k>c00;om?Cd00Ko
Ti>CoaLG5oodm?Com?CdodA4A?mmOGd2ooCdm00=od=3@omnOWkom?CdooCdm?nOWioo8R8RooCdm?oA
dM7o2PX:okNg]oodm?CoVi^KobHV9P02ooCdm003odA4A?mmOGgom?Cd00;om?Cd00GoaLG5o`T92OnK
Vi_o6QXJong]k@06ooCdm003ocXj>_mcLg?om?Cd00;om?Cd00[ol?3`obDU9OmaLG7om?Cdom3@d?l:
2P[o]kNgooCdm?nKVi_o9RHV0_odm?@01Oo5aLGo2@T9oi^KVolI6AWok^k^00Gom?Cd00SofMWIoj>S
XonSXj?oXj>SoiBDU?l92@WoVIVIom[JfYcom?Cd01Wo[:b/oaDnZom4O<[oR;;Poh^dh_mk[>7oBHkN
oeZKi_m[Zo?oNKWjoh?4nOn8a_WoNJkYofa/K?nb/[;oh^;RoeEEEOmHF5SoFe]KoeeMGOmPH63oHV9R
ofEUIOmXJ6SoJVYZ007oKFe]0002onSXj0?oinOW00?oi^KVonOWiooVi^H00_oVi^H3onGUi@06onKV
i_oUiNGoiNGUonKVi_ld=3CoKFe]0_oUiND01_ln?SkoMWIfonGUiOoUiNGoLG5aod51@@;oiNGU00go
Y:BTo`l?3ooUiNGoi^KVoijNW_lc<c?o=3@docHf=_lS8b?oiNGUojn_[ol820Soc/k>00;oiNGU00Ko
WIfMoaHF5_oUiNGoiNGUoclo?omfMWH2onGUi@06ochn?_mfMWKoiNGUonGUiOnEUIGo7alO0_oUiND0
1OnNWYko=3@doc@d=?lf=SKo92@T00;oiNGU00?o?cloogIfM_oUiND00_oUiND01_mRHV;o?cloonGU
iOlZ:R[oUYJFonKViP;oiNGU00Goi^KVonGUiOoUiNGo=SHfofa/K004onGUi@09og=cLolU9BGoiNGU
onGUiOnNWYko<c<coc@d=?lf=SKo8b<S00;oiNGU00GoHV9Roclo?ooUiNGo:BTYoiJFUP04onGUi@09
onKVi_nXZ:So2@T9od];Bom=CDgoBd];o`P82?m9BDWo];Bd00OoiNGU00Coi^KVonGUiOoUiNGoi^KV
3?oUiND01?oVi^KoiNGUonGUiOoVi^H<onGUi@04onKVi_oUiNGoiNGUonKViPcoiNGU00Coi^KVonGU
iOoUiNGoi^KV3?oUiND01?oVi^KoiNGUonGUiOoVi^H<onGUi@04onKVi_oUiNGoiNGUonKViPcoiNGU
00Coi^KVonGUiOoUiNGoi^KV3?oUiND01?oVi^KoiNGUonGUiOoVi^H<onGUi@04onKVi_oUiNGoiNGU
onKViPcoiNGU01koi^KVonGUiOoUiNGoi^KVonGUiOn[Zj_o<4^To`i7]_m6Q<ooFICEodF8e?lkPmKo
CY7Ooe^MjOmYZ>ooL[?hogFcnOmQR[WoNWYjokZj^_oYjNWoDU9BoeEEEOmGEeOoFUYJoeeMGOmOGeoo
HV9RofATI?mVIVH1ofUYJ@0000?om_KfooGemOofm_H00ooemOD6ooCdm0Golo?c00Ko=SHfogAdM?oc
lo?olo?cod92@_m[Jf/2oo?cl`06ogMgMolg=cOol_;boo?clon/[:co3`l?0_oclo<02Oobl_;olo?c
oo7alOn@T93o9RHVoo;bl_o@d=3o20P8ojj^[P02oo?cl`06ojJVY_lF5QKolo?coo?clom2@T;oO7al
0_oclo<01_m2@T;oGEeMoo;bl_oclo?oV9RHob8R8P?olo?c017ol_;boo7alOn@T93o9RHVoo;bl_oc
lo?o@T92ofQXJ?oclo?ol_;bon[Zj_lE5AGoWIfMoo?clon=SHgo@410oo;blP03oo?cl`06oo;bl_oc
lo?o>3Phog9bL_oclo?ol_;b0_oclo<04?nIVIWo2PX:onk^k_oclo?ol_;boo?clooalO7oT92@obDU
9Ooclo?oj^[ZoaDE5OnMWIgol_;bohb<S?m0@404oo?cl`0:oo;bl_oclo?oDe=CogemOOobl_;ok^k^
o`L71ooShn?olo?coo;blPKolo?c00Gol_;boo?clooclo?olo?coo;blP04oo?cl`03oo;bl_oclo?o
lo?c00Colo?c00Gol_;boo?clooclo?olo?coo;blP04oo?cl`03oo;bl_oclo?olo?c00Colo?c00Go
l_;boo?clooclo?olo?coo;blP04oo?cl`03oo;bl_oclo?olo?c00Colo?c00Gol_;boo?clooclo?o
lo?coo;blP04oo?cl`03oo;bl_oclo?olo?c00Colo?c00Gol_;boo?clooclo?olo?coo;blP04oo?c
l`03oo;bl_oclo?olo?c00Colo?c00Gol_;boo?clooclo?olo?coo;blP04oo?cl`03oo;bl_oclo?o
lo?c00Colo?c00Gol_;boo?clooclo?olo?coo;blP04oo?cl`03oo;bl_oclo?olo?c00Colo?c00Go
l_;boo?clooclo?olo?coo;blP04oo?cl`03oo;bl_oclo?olo?c00Colo?c00Gol_;boo?clooclo?o
lo?coo;blP04oo?cl`03oo;bl_oclo?olo?c00Colo?c01kol_;boo?clooclo?olo?coo;bl_n_[joo
GFZRo`Pf[?l9B;Ko45ZooamWaOl_MLko?h?Eodf>g?mGUn;oGigToejKgomGLHkoTY:BolK6a_ohn?So
DE5AoeADE?mGEeOoFEUIoeaLG?mNGUkoHF5QofATI?mVIVH1ofUYJ@0000Coo?cloo_knoojn_[on_[j
1?oinOT5ooShn00dooOgmoohn?SomoOgooShn?lh>3SoMWIfooShn?ogmoOoA4A4oa/K6on<S8coh^;R
od=3@olT92CoHV9RomcLg?mbLW;o>3PhooOgmoohn?So/K6aomCDe?oemOGoHV9RoeMGEoogmoOon?Sh
oclo?om9BDWog=cLon_[jomIFEWo5aLGooShn?ogmoOoA4A4ogmoOoogmoOon?Shod=3@olJ6Q[oMWIf
omWIfOmIFEWoD51@ooOgmoohn?So/K6aomCDe?oemOGoHf=SoeMGE`;omoOg00koA4A4oaTI6On@T93o
g]kNoinOWolD51Cok^k^ooOgmooXj>So410@om;Bd_ohn?SomoOgooShn0;omoOg01So>SXjogAdM?oh
n?SomoOgooShn?ogmoOoShn?o``<3?odm?Con?Shok6a/OoEeMGom?Cdof=SHomGEeOomoOgoj6QXOlD
51Cok^k^ooOgmooXj>So410@om;Bd_ogmoL2ooShn00;ooOgmoohn?SoinOWobLW9onl_;colo?co`P8
2?oWinOon?ShooOgmoohn?P00oogmoL2ooShn004ooOgmoohn?SomoOgooShn0;omoOg00Gon?ShooOg
moohn?SomoOgooShn003ooOgm`;on?Sh00ComoOgooShn?ogmoOon?Sh0_ogmoL01Oohn?SomoOgooSh
n?ogmoOon?Sh00?omoOg0_ohn?P01?ogmoOon?ShooOgmoohn?P2ooOgm`05ooShn?ogmoOon?ShooOg
moohn?P00oogmoL2ooShn004ooOgmoohn?SomoOgooShn0;omoOg00Gon?ShooOgmoohn?SomoOgooSh
n003ooOgm`;on?Sh00ComoOgooShn?ogmoOon?Sh0_ogmoL01Oohn?SomoOgooShn?ogmoOon?Sh00?o
moOg0_ohn?P01?ogmoOon?ShooOgmoohn?P2ooOgm`05ooShn?ogmoOon?ShooOgmoohn?P00oogmoL2
ooShn004ooOgmoohn?SomoOgooShn0;omoOg00Gon?ShooOgmoohn?SomoOgooShn003ooOgm`;on?Sh
00ComoOgooShn?ogmoOon?Sh0_ogmoL01Oohn?SomoOgooShn?ogmoOon?Sh00?omoOg0_ohn?P01?og
moOon?ShooOgmoohn?P2ooOgm`05ooShn?ogmoOon?ShooOgmoohn?P00oogmoL2ooShn00NooOgmooh
n?SomoOgooShn?ogmoOo/K6aoiZLZ_laBj3o23^ao`Q<^Ol@GL7o86[6obeeboljOm7oA8KDodZ9dom<
MjSoMgj5ok2`/?oEeMGoj>SXoe5ADOmDE5CoEeMGoeUIFOmLG5coGemOof9RH_mUIFGoJ6QX0Om[Jf/0
00ComOGe0_odm?@3oo?cl`03oo;bl_oclo?ol_;b00;ol_;b00GolO7aoo;bl_oalO7o=SHfog=cL`02
oo;blP0MoeADE?n6QXKoKVi^oaDE5Ol[:b_obl_;oiBDU?lM7Ago92@TojFUYOobl_;olO7aohJ6Q_le
=CGo5ADEocXj>_nk^k_olO7aoo;bl_oHf=SoA4A4oa0@4?l/;2coLW9bobd];OoalO7ol_;boe=CDon8
R8P00_obl_801_mCDe?oR8R8ogEeMOlH61So<C4aok^k^`;ol_;b00GoQHF5ocDe=OlD51Co>c/kok^k
^`02oo;blP07oeADE?n4Q8CoGEeMo`h>3_mCDe?oKVi^oo7al@02oo;blP05ofUYJOn1PH7olO7aoo;b
l_oalO400_obl_801?lh>3SoLG5aoo;bl_oalO42oo;blP0Aoe5ADOl_;bool_;boo7alOn6QXKo=3@d
oaDE5Olj>S[o^k^koo;bl_mIFEWoKVi^oo;bl_oalO7ol_;bofYZJ_n0P8000_obl_802ooalO7ol_;b
oo7alOobl_;o^k^kob8R8_oJf][o1`L7on7QhOobl_;olO7a00;ol_;b00SolO7aoo;bl_obl_;olO7a
oo;bl_oalO7ol_;boo7al@Gol_;b00ColO7aoo;bl_obl_;olO7a0_obl_801OoalO7ol_;boo7alOob
l_;olO7a00Gol_;b00ColO7aoo;bl_obl_;olO7a0_obl_801OoalO7ol_;boo7alOobl_;olO7a00Go
l_;b00ColO7aoo;bl_obl_;olO7a0_obl_801OoalO7ol_;boo7alOobl_;olO7a00Gol_;b00ColO7a
oo;bl_obl_;olO7a0_obl_801OoalO7ol_;boo7alOobl_;olO7a00Gol_;b00ColO7aoo;bl_obl_;o
lO7a0_obl_801OoalO7ol_;boo7alOobl_;olO7a00Gol_;b00ColO7aoo;bl_obl_;olO7a0_obl_80
1OoalO7ol_;boo7alOobl_;olO7a00Gol_;b00ColO7aoo;bl_obl_;olO7a0_obl_801OoalO7ol_;b
oo7alOobl_;olO7a00Gol_;b00ColO7aoo;bl_obl_;olO7a0_obl_801OoalO7ol_;boo7alOobl_;o
lO7a00Gol_;b00ColO7aoo;bl_obl_;olO7a0_obl_807ooalO7ol_;boo7alOobl_;olO7aoo;bl_nb
/[;o];BdohB:Y_laCZ3o1Sj`o`I<]ol?Fkgo7FO2obQ_aOl`M/So?fjTofelSOnXZ:Soc/k>omkNg_oP
h>3oCTi>oe1@D?mCDe?oEEEEoeMGEomJFU[oGEeMof1PH?mSHf<00OmVIVH00003onOWiooVi^KoiNGU
00CoiNGU1?oTi>@01?oShn?oi>CTon?ShooRh^82on?Sh`03oc8b<_m[Jf_ohn?S00Cohn?S00?oh^;R
on?ShooShn<00_oShn<2on;RhP?ohn?S00?oh^;Ron7QhOoShn<01OoShn<01OoQhN7ohn?Son?ShooS
hn?oh^;R00?ohn?S00?oh^;Ron?ShooShn<00_oShn<00ooRh^;ohn?Son?Sh`04on?Sh`05on3Ph?oS
hn?ohn?Son?ShooRh^800ooShn<00ooPh>3ohn?Son?Sh`05on?Sh`07on;Rh_oShn?ohn?Son?ShooR
h^;o=3@dofUYJ@03on?Sh`03ohn?Sol61PKoTI6A00?ohn?S00Goh^;Ron7QhOoShn?ohn?Son;RhP0;
on?Sh`07on;Rh_oShn?ohn?SogEeMOm1@D7o1PH6om?Cd`09on?Sh`05on;Rh_oShn?ohn?Son?ShooR
h^802ooShn<01OoRh^;ohn?Son?ShooShn?oh^;R00_ohn?S00Goh^;Ron?ShooShn?ohn?Son;RhP0;
on?Sh`05on;Rh_oShn?ohn?Son?ShooRh^802ooShn<01OoRh^;ohn?Son?ShooShn?oh^;R00_ohn?S
00Goh^;Ron?ShooShn?ohn?Son;RhP0;on?Sh`05on;Rh_oShn?ohn?Son?ShooRh^802ooShn<01OoR
h^;ohn?Son?ShooShn?oh^;R00_ohn?S00Goh^;Ron?ShooShn?ohn?Son;RhP0;on?Sh`0Mon;Rh_oS
hn?ohn?Son?Shonb/[;o^;RhokNg]onNXJooFfjSobYBX_l?CK7o4UNcobeRYOmALYSoQXnHokBd]?o@
d=3oh>3PonGUiOoVi^KoBd];odi>C_m@D53oDU9BoeEEEOmGEeOoFUYJoeeMGOmPH6000OmSHf<00004
ooGemOodm?Com?CdooCdm0;olo?c0oobl_88oo7al@03oc@d=?mbLW;olO7a00?olO7a00Col?3`oo7a
lOoalO7ol?3`3?oalO401?o`l?3olO7aoo7alOo`l?05oo7al@03oeYJF_n<S8colO7a00ColO7a00Co
l?3`oo7alOoalO7ol?3`3?oalO401?o`l?3olO7aoo7alOo`l?08oo7al@08ocLg=ol`<33oHV9Rodi>
C_l^;Rko2`/;ohV9ROo_knl<oo7al@04oo3`l?oalO7olO7aoo3`l0KolO7a00Cokno_od10@?l61PKo
h>3P0_oalO401?o`l?3olO7aoo7alOo`l?0<oo7al@04oo3`l?oalO7olO7aoo3`l0colO7a00Col?3`
oo7alOoalO7ol?3`3?oalO401?o`l?3olO7aoo7alOo`l?0<oo7al@04oo3`l?oalO7olO7aoo3`l0co
lO7a00Col?3`oo7alOoalO7ol?3`3?oalO401?o`l?3olO7aoo7alOo`l?0<oo7al@04oo3`l?oalO7o
lO7aoo3`l0colO7a00Col?3`oo7alOoalO7ol?3`3?oalO401?o`l?3olO7aoo7alOo`l?07oo7al@0I
ok>c/onj^[[o_knoolC4a?o1`L7o^k^kokFe]Ona/K7o];Bdol30`?o=cLgogMgMonOWiooXj>Soi^KV
ooKfm_m;Bd_oCDe=odm?ComBDU;oE5ADoeMGEomJFU[oGEeMof1PH001of=SH`000_ojn_X00ooinOWo
n?ShooShn004ooOgm`Com_Kf00KomOGeooKfm_oemOGomOGeojZZZ_o2`/84ooGem@;om_Kf0_oemOD2
ooKfmPComOGe00?om_KfooGemOoemOD00ooemOD2ooKfmP;omOGe0_ofm_H3ooGem@03ojn_[oo7alOo
mOGe00ComOGe0_ofm_H2ooGem@;om_Kf1?oemOD00oofm_KomOGeooGem@03ooGem@;om_Kf0_oemOD2
ooKfmPComOGe00Som_KfooGemOn[Zj_oUiNGoiJFU_nNWYko_[jnon?Sh`;omOGe0_ofm_H4ooGem@03
ooKfm_oemOGomOGe00?omOGe0_ofm_H2ooGem@;om_Kf1?oemOD01?ofm_Kog]kNoiJFU_o`l?02ooGe
m@;om_Kf0_oemOD2ooKfmPComOGe00?om_KfooGemOoemOD00ooemOD2ooKfmP;omOGe0_ofm_H4ooGe
m@03ooKfm_oemOGomOGe00?omOGe0_ofm_H2ooGem@;om_Kf1?oemOD00oofm_KomOGeooGem@03ooGe
m@;om_Kf0_oemOD2ooKfmPComOGe00?om_KfooGemOoemOD00ooemOD2ooKfmP;omOGe0_ofm_H4ooGe
m@03ooKfm_oemOGomOGe00?omOGe0_ofm_H2ooGem@;om_Kf1?oemOD00oofm_KomOGeooGem@03ooGe
m@;om_Kf0_oemOD2ooKfmPComOGe00?om_KfooGemOoemOD00ooemOD2ooKfmP;omOGe0_ofm_H4ooGe
m@03ooKfm_oemOGomOGe00?omOGe0_ofm_H2ooGem@;om_Kf1?oemOD00oofm_KomOGeooGem@03ooGe
m@;om_Kf0_oemOD2ooKfmPComOGe00com_Kfok:b/_nj^[[o`/;2ol[:b_o?clooeMGEomSHf?oKfm_o
h>3PonGUiOo[jn/2onk^kP0<on_[jooWinOoi^KVodY:B_m=CDgoD51@oe9BD_mEEEGoF5QHoe]KFomN
GUkoHV9R0OmUIFD00003ooGemOodm?Colo?c00;olo?c0_obl_84oo7al@Gol?3`00?olO7aoo3`l?o`
l?003Oo`l?000ooalO7ol?3`oo3`l00=oo3`l003oo7alOo`l?3ol?3`00gol?3`00?olO7aoo3`l?o`
l?003Oo`l?000ooalO7ol?3`oo3`l00=oo3`l003oo7alOo`l?3ol?3`00gol?3`00?olO7aoo3`l?o`
l?003Oo`l?000ooalO7ol?3`oo3`l00=oo3`l003oo7alOo`l?3ol?3`00gol?3`00?olO7aoo3`l?o`
l?003Oo`l?000ooalO7ol?3`oo3`l00=oo3`l003oo7alOo`l?3ol?3`00gol?3`00?olO7aoo3`l?o`
l?003Oo`l?000ooalO7ol?3`oo3`l00=oo3`l003oo7alOo`l?3ol?3`00gol?3`00?olO7aoo3`l?o`
l?003Oo`l?006ooalO7ol?3`ok6a/Oni^KWo`L71ol_;booCdm?ofm_Kon7QhOoVi^Koj^[Zono_koo`
l?3ol_;bono_koo[jn_oinOWomkNg_m8B4SoBTY:ode=COm?CdooDE5AoeADE?mGEeOoFUYJoeeMG@01
of5QH@0000Ooi^KVonGUiOoUiNGoi>CTon?ShooTi>Cohn?S00Goh^;R1_oQhN401?oRh^;ohN7Qon7Q
hOoRh^84on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00Coh^;Ron7QhOoQhN7oh^;R1?oQhN400ooRh^;o
hN7Qon7Qh@05on7Qh@04on;Rh_oQhN7ohN7Qon;RhPCohN7Q00?oh^;Ron7QhOoQhN401OoQhN401?oR
h^;ohN7Qon7QhOoRh^84on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00Coh^;Ron7QhOoQhN7oh^;R1?oQ
hN400ooRh^;ohN7Qon7Qh@05on7Qh@04on;Rh_oQhN7ohN7Qon;RhPCohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN401?oRh^;ohN7Qon7QhOoRh^84on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00Coh^;Ron7QhOoQ
hN7oh^;R1?oQhN400ooRh^;ohN7Qon7Qh@05on7Qh@04on;Rh_oQhN7ohN7Qon;RhPCohN7Q00?oh^;R
on7QhOoQhN401OoQhN401?oRh^;ohN7Qon7QhOoRh^84on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00Co
h^;Ron7QhOoQhN7oh^;R1?oQhN400ooRh^;ohN7Qon7Qh@05on7Qh@04on;Rh_oQhN7ohN7Qon;RhPCo
hN7Q00?oh^;Ron7QhOoQhN401OoQhN401?oRh^;ohN7Qon7QhOoRh^84on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00Coh^;Ron7QhOoQhN7oh^;R1?oQhN400ooRh^;ohN7Qon7Qh@05on7Qh@04on;Rh_oQhN7o
hN7Qon;RhPCohN7Q00?oh^;Ron7QhOoQhN401OoQhN401?oRh^;ohN7Qon7QhOoRh^84on7Qh@03on;R
h_oQhN7ohN7Q00GohN7Q00[o/[:bokRh^?no_koobLW9om3@d?oIfMWogmoOonGUiOo[jn_ok^k^0_o_
knl03Oo]kNgojNWYonCTi?oTi>CoAdM7odQ8B?m:BT[oCDe=odm?ComBDU;oEEEEoeQHF?mKFe/00OmO
Gel00005oo[jn_oinOWon_[jooWinOojn_X00_oinOT02?ojn_[onOWiooWinOoinOWon_[jooWinOoj
n_[onOWi0_ojn_X01?oinOWon_[jooWinOojn_X2ooWin@08oo[jn_oinOWonOWiooWinOojn_[onOWi
oo[jn_oinOT2oo[jnP04ooWinOojn_[onOWioo[jnP;onOWi00Son_[jooWinOoinOWonOWioo[jn_oi
nOWon_[jooWin@;on_[j00ConOWioo[jn_oinOWon_[j0_oinOT02?ojn_[onOWiooWinOoinOWon_[j
ooWinOojn_[onOWi0_ojn_X01?oinOWon_[jooWinOojn_X2ooWin@08oo[jn_oinOWonOWiooWinOoj
n_[onOWioo[jn_oinOT2oo[jnP04ooWinOojn_[onOWioo[jnP;onOWi00Son_[jooWinOoinOWonOWi
oo[jn_oinOWon_[jooWin@;on_[j00ConOWioo[jn_oinOWon_[j0_oinOT02?ojn_[onOWiooWinOoi
nOWon_[jooWinOojn_[onOWi0_ojn_X01?oinOWon_[jooWinOojn_X2ooWin@08oo[jn_oinOWonOWi
ooWinOojn_[onOWioo[jn_oinOT2oo[jnP04ooWinOojn_[onOWioo[jnP;onOWi00Son_[jooWinOoi
nOWonOWioo[jn_oinOWon_[jooWin@;on_[j00ConOWioo[jn_oinOWon_[j0_oinOT02?ojn_[onOWi
ooWinOoinOWon_[jooWinOojn_[onOWi0_ojn_X01?oinOWon_[jooWinOojn_X2ooWin@08oo[jn_oi
nOWonOWiooWinOojn_[onOWioo[jn_oinOT2oo[jnP04ooWinOojn_[onOWioo[jnP;onOWi00Son_[j
ooWinOoinOWonOWioo[jn_oinOWon_[jooWin@;on_[j00ConOWioo[jn_oinOWon_[j0_oinOT02?oj
n_[onOWiooWinOoinOWon_[jooWinOojn_[onOWi0_ojn_X01?oinOWon_[jooWinOojn_X2ooWin@08
oo[jn_oinOWonOWiooWinOojn_[onOWioo[jn_oinOT2oo[jnP04ooWinOojn_[onOWioo[jnP;onOWi
00Son_[jooWinOoinOWonOWioo[jn_oinOWon_[jooWin@;on_[j00ConOWioo[jn_oinOWon_[j0_oi
nOT02?ojn_[onOWiooWinOoinOWon_[jooWinOojn_[onOWi0_ojn_X01?oinOWon_[jooWinOojn_X2
ooWin@08oo[jn_oinOWonOWiooWinOojn_[onOWioo[jn_oinOT2oo[jnP0JooWinOnl_;co`/;2olS8
b?oAdM7ofMWIon;Rh_oXj>Sok^k^oo;bl_ogmoOonOWiooShn?ogmoOolo?conc/k?ono_koYJFUojj^
[_nh^;So_knoolK6a_o>c/kodm?Com[Jf_oNg]h1on?Sh`00:?ono_h01Oo3`l?oRHV9ofYZJ_n0P83o
d=3@01_oo_kn00?oh^;RohB4Q?ohn?P06Oono_h00ooQhN7oQHF5ooOgm`2[ooknoP0Iok^k^oo1`L7o
b<S8om7AdOoGemOoh>3PonKVi_o/k>colO7aooGemOofm_KomoOgooCdm?o_knooj^[Zonk^k_nWYjOo
/;2`okVi^Oo1`L7ob<S8olk>c_oFe]Kof][Jon3Ph001onCTi0000ooinOT00oojn_[onOWioo[jnP02
ooWin@04oo[jn_oinOWonOWiooWin@;on_[j00?onOWioo[jn_oinOT00_oinOT00oojn_[onOWioo[j
nP02ooWin@04oo[jn_oinOWonOWiooWin@;on_[j00?onOWioo[jn_oinOT00_oinOT00oojn_[onOWi
oo[jnP02ooWin@08ohf=SOmjNW[oYZJVofUYJOlH61So_;blooWinOojn_X3ooWin@03oo[jn_oinOWo
n_[j00;onOWi00Con_[jooWinOoinOWonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@03oo[jn_oi
nOWon_[j00;onOWi00Com_KfobPX:?nVYZKonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@03oo[j
n_oinOWon_[j00;onOWi00Con_[jooWinOoinOWonOWi0_ojn_X00ooinOWon_[jooWin@02ooWin@06
oo[jn_oemOGo:BTYojFUYOoinOWon_[j0ooinOT2oo[jnP03ooWinOojn_[onOWi00;onOWi00?on_[j
ooWinOojn_X00_oinOT01?ojn_[onOWiooWinOoinOT2oo[jnP03ooWinOojn_[onOWi00;onOWi00?o
n_[jooWinOojn_X00_oinOT01?ojn_[onOWiooWinOoinOT2oo[jnP03ooWinOojn_[onOWi00;onOWi
00?on_[jooWinOojn_X00_oinOT01?ojn_[onOWiooWinOoinOT2oo[jnP03ooWinOojn_[onOWi00;o
nOWi00?on_[jooWinOojn_X00_oinOT01?ojn_[onOWiooWinOoinOT2oo[jnP03ooWinOojn_[onOWi
00;onOWi00?on_[jooWinOojn_X00_oinOT01?ojn_[onOWiooWinOoinOT2oo[jnP03ooWinOojn_[o
nOWi00;onOWi00?on_[jooWinOojn_X00_oinOT01?ojn_[onOWiooWinOoinOT2oo[jnP03ooWinOoj
n_[onOWi00;onOWi00?on_[jooWinOojn_X00_oinOT01?ojn_[onOWiooWinOoinOT2oo[jnP03ooWi
nOojn_[onOWi00;onOWi00?on_[jooWinOojn_X00_oinOT01?ojn_[onOWiooWinOoinOT2oo[jnP03
ooWinOojn_[onOWi00;onOWi00?on_[jooWinOojn_X00_oinOT01?ojn_[onOWiooWinOoinOT2oo[j
nP03ooWinOojn_[onOWi00;onOWi00?on_[jooWinOojn_X00_oinOT01?ojn_[onOWiooWinOoinOT2
oo[jnP0>ooWinOojn_[onOWiooWinOnk^k_o_knoolO7aoo>c/koeMGEomgMgOoShn?ojNWYonk^k_oa
lO42ooCdm00=oo7alOo^k^koj>SXonKVi_n[Zj_o/k>cok^k^oo3`l?obLW9om3@d?oGemOof][Jon3P
h001on?Sh`008_ono_h01Oo/k>coo?clookno_oclo?om?Cd00Goo_kn00?oHV9Roe5ADOono_h03_on
o_h00oo/k>coo?clooknoP02ooCdm0Ooo_kn00?oTI6AodQ8B?ono_h04_ono_h01Oo/k>coo?clookn
o_odm?Colo?c00;oo_kn00?oT92@odU9BOono_h02?ono_h00ooYjNWoe=CDooclo02OooknoP0IokRh
^?nn_[koa/K6olc<c?oCdm?ofMWIon3Ph?oUiNGoj^[Zonk^k_o_knoolO7aong]kOoXj>Soi>CTonk^
k_n][Jgo]KFeokjn__o5aLGoc<c<om7AdOoGemOog=cLon7Qh@01onCTi00000GonOWioo[jn_oinOWo
nOWioo[jnP04ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT01_ln?SkoNWYjooWinOojn_[o
B4Q8oh>3P`;onOWi00KoOWinod];Boojn_[onOWiokBd]?lF5QH2ooWin@0=oeUIFOlE5AGo9RHVoijN
W_lO7aooGUiNooWinOoRh^;oI6ATod51@OmnOWkoWYjNobXZ:P02ooWin@06odQ8B?n3Ph?onOWiooWi
nOm9BDWoPh>30_oinOT03OnSXj?o:2PXooWinOojn_[oF5QHoaDE5OlV9RKoWIfMoahN7_mNGUkonOWi
odQ8B?n3Ph<01?oinOT01OnEUIGo3Ph>omCDe?oinOWon_[j00?onOWi00?on_[jooWinOlo?cl00_l>
3Ph07olE5AGo>CTiogMgMoo^k^konOWioo[jn_oinOWoFEUIoaDE5OlV9RKoWIfMoalO7omNGUkonOWi
oo[jn_nEUIGo3Ph>omCDe?oinOWon_[jooWinOojn_[onOWioo[jn_oinOWoGEeMoadM7Om0@43o92@T
ofYZJ_o^k^h01?oinOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j
1?oinOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j1?oinOT01Ooj
n_[onOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j1?oinOT01Oojn_[onOWioo[j
n_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j1?oinOT01Oojn_[onOWioo[jn_oinOWon_[j
00?onOWi00Con_[jooWinOoinOWon_[j1?oinOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi00Co
n_[jooWinOoinOWon_[j1?oinOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoi
nOWon_[j1?oinOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j1?oi
nOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j1?oinOT01Oojn_[o
nOWioo[jn_oinOWon_[j00?onOWi00[on_[jokNg]onj^[[oa<C4olW9bOoAdM7oe]KFomcLg?oQhN7o
iNGU0ooZj^X03OoXj>Sohn?SomgMgOoooooo/K6aokVi^Oo0`<3oalO7olk>c_oCdm?ofMWIomkNg_oQ
hN400OoVi^H000Oojn_[00?ok>c/on_[joo[jn/01oo[jn/02_lj>S[oM7Adon_[joo[jn_oADE5ogal
O?o/k>cojn_[ogMgMom7AdL2on_[j`0AojVYZOlE5AGojn_[okVi^OlA4A7ocLg=omCDe?mLG5co71`L
on_[joo/k>coD51@ocDe=OnJVY[oNGUiocDe=OlO7al00_o[jn/04Om4A4CoO7alon_[joo[jn_oA4A4
ogalO?o[jn_ok>c/oi^KVolU9BGojn_[okVi^OlA4A7ocLg=omCDe?mLG5co71`L00;ojn_[00WoA4A4
ogalO?o[jn_ojn_[onc/k?o[jn_o=SHfoaDE5Om`L7001oo[jn/03oll?3coLW9bon_[jooQhN7o_kno
odU9BOlZ:R[og]kNon_[joni^KWo4A4Aolg=cOoEeMGoG5aLoa`L7003on_[j`03ocLg=olE5AGoL71`
00Oojn_[00KoeMGEonWYjOo[jn_oe=CDoaTI6OmbLW82on_[j`03onc/k?o[jn_ojn_[00gojn_[00?o
k>c/on_[joo[jn/03Oo[jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[jn_ojn_[00gojn_[00?o
k>c/on_[joo[jn/03Oo[jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[jn_ojn_[00gojn_[00?o
k>c/on_[joo[jn/03Oo[jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[jn_ojn_[00Sojn_[00Wo
^;RhokVi^Oo0`<3oaLG5ol_;booBd];of=SHom_KfooPh>000_oShn<03_oTi>CogmoOomWIfOoIfMWo
k^k^okJf]_nl_;co`l?3ol[:b_o@d=3oe]KFom[Jf_oNg]kohn?S0OoUiND00006oo[jn_oinOWon_[j
oo[jn_oinOWon_[j0_oinOT01?ojn_[onOWioo[jn_ojn_X2ooWin@0Loo[jn_oinOWon_[jocdm?Omk
Ng_on_[jooWinOm9BDWoPh>3ooWinOojn_[oOWinod];Boojn_[onOWiok>c/olF5QKonOWiomKFe_l@
413o_;bloo[jn_nPX:3o:b/[ooWinOoalO7o5QHFokRh^0;on_[j00KoV9RHoadM7Oojn_[onOWiodU9
BOn3Ph<2oo[jnP0BodQ8B?n3Ph?onOWiooWinOnTY:Co9bLWoo[jn_oFe]Ko410@okbl_?ojn_[oX:2P
ob/[:ooinOWon_[jodU9BOn2PX;on_[j0_oinOT03_o;bl_o3Ph>oj2PX?lO7aool_;booWinOojn_[o
nOWioo[jn_oinOWon_[joclo?omhN7Son_[j0_oinOT02_oemOGo:RXZogIfM_ojn_[oeMGEo`l?3onl
_;conOWioj2PX?l[:b/2oo[jnP06ol[:b_l>3PkoX:2PoalO7ooclo?onOWi0_ojn_X2ooWin@08oo[j
n_oinOWon_[jooWinOojn_[oH61Pod];Boojn_X2ooWin@04oo[jn_oinOWon_[joo[jnP;onOWi00Co
n_[jooWinOojn_[onOWi0_ojn_X01_oinOWon_[jooWinOoinOWon_[jooWin@;on_[j0_oinOT01?oj
n_[onOWioo[jn_oinOT2oo[jnP06ooWinOojn_[onOWiooWinOojn_[onOWi0_ojn_X2ooWin@04oo[j
n_oinOWon_[jooWin@;on_[j00KonOWioo[jn_oinOWonOWioo[jn_oinOT2oo[jnP;onOWi00Con_[j
ooWinOojn_[onOWi0_ojn_X01_oinOWon_[jooWinOoinOWon_[jooWin@;on_[j0_oinOT01?ojn_[o
nOWioo[jn_oinOT2oo[jnP06ooWinOojn_[onOWiooWinOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oi
nOWon_[jooWin@;on_[j00KonOWioo[jn_oinOWonOWioo[jn_oinOT2oo[jnP;onOWi00Con_[jooWi
nOojn_[onOWi0_ojn_X01_oinOWon_[jooWinOoinOWon_[jooWin@;on_[j0_oinOT01?ojn_[onOWi
oo[jn_oinOT2oo[jnP06ooWinOojn_[onOWiooWinOojn_[onOWi0_ojn_X2ooWin@04oo[jn_oinOWo
n_[jooWin@;on_[j00KonOWioo[jn_oinOWonOWioo[jn_oinOT2oo[jnP;onOWi01gon_[jooWinOoj
n_[onOWiokbl_?nc/k?o^KViol71`Oo9bLWoc/k>om?CdooGemOofMWIomcLg?oJf][ofMWIomCDe?o5
aLGogmoOonKVi_nj^[[o`<30olO7aoo=cLgod];BomOGeooLg=coh>3PonCTi001onOWi`004Oono_h0
1_lo?cooOGemookno_ono_koBTY:ohJ6QP;oo_kn00KoPH61ode=COono_koo_knokRh^?lF5QH2ookn
oP09ok6a/Olm?Cgo?Shnod51@Ol/;2coo_knolC4a?l>3Pkoi^KV00;oo_kn00Ko/;2`oahN7_ono_ko
o_knod];Bon6QXH2ooknoP06odY:B_n5QHGoo_knookno_nWYjOo:2PX0_ono_h01Ona/K7o?Cdmochn
?_m0@43o;Bd]00;oo_kn00?oBTY:ohF5QOono_h00_ono_h01OmaLG7oBd];ookno_lc<c?oZ:RX00Ko
o_kn00?o@D51og]kNoono_h00oono_h02On3Ph?o;Rh^ookno_ono_ko/K6aocdm?Oln?Sko@D51ob`/
;002ooknoP05og5aLOm;Bd_oo_knoc<c<onXZ:P02Oono_h00ooclo?o820Poh^;R`2MooknoP09okno
_onZZZ[o[jn_okZj^_o4a<CoalO7olc<c?o@d=3od];B00;odM7A00?obl_;okno_oo6a/H00_o^k^h0
2Onn_[koaLG5ol_;boo@d=3oeMGEomWIfOoMgMgohN7QonCTi001onOWi`000_oinOT00oojn_[onOWi
oo[jnP03ooWin@04oo[jn_oinOWonOWioo[jnP;onOWi00gon_[jooWinOoinOWo?Cdmog]kNooinOWo
n_[jodQ8B?maLG7onOWioo[jn_mmOGgo?Cdm00;onOWi00?o/[:boaHF5_oinOT00_oinOT05?ojn_[o
moOgoiNGUol/;2conOWiomKFe_l>3Pko]KFeooWinOojn_[o[:b/oadM7Oojn_[onOWiodQ8B?n2PX;o
n_[jooWinOm9BDWoI6AT0_oinOT01?nNWYko:BTYooWinOojn_X2ooWin@07ooShn?nFUYKo;2`/ooWi
nOojn_[oB4Q8ofm_K`02ooWin@08oo7alOlL71coXj>SooWinOnCTi?oATI6ooWinOojn_X3ooWin@03
oo[jn_lo?cooNGUi00?onOWi00Con_[joinOWol@413om?Cd0_oinOT02oojn_[omoOgoiNGUol/;2co
n_[joo7alOlL71coXj>SooWinOnCTi?oAdM700;onOWi00[on_[jooWinOoinOWon_[jooWinOnSXj?o
I6AToc0`<?m_Kfooj^[Z0ooinOT01?ojn_[onOWiooWinOojn_X2ooWin@07oo[jn_oinOWonOWiooWi
nOojn_[onOWioo[jnP03ooWin@04oo[jn_oinOWonOWioo[jnP;onOWi00Oon_[jooWinOoinOWonOWi
oo[jn_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j0_oinOT01oojn_[onOWiooWinOoinOWo
n_[jooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X2ooWin@07oo[jn_oinOWonOWiooWinOoj
n_[onOWioo[jnP03ooWin@04oo[jn_oinOWonOWioo[jnP;onOWi00Oon_[jooWinOoinOWonOWioo[j
n_oinOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j0_oinOT01oojn_[onOWiooWinOoinOWon_[j
ooWinOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X2ooWin@07oo[jn_oinOWonOWiooWinOojn_[o
nOWioo[jnP03ooWin@04oo[jn_oinOWonOWioo[jnP;onOWi00Oon_[jooWinOoinOWonOWioo[jn_oi
nOWon_[j00?onOWi00Con_[jooWinOoinOWon_[j0_oinOT01oojn_[onOWiooWinOoinOWon_[jooWi
nOojn_X00ooinOT01?ojn_[onOWiooWinOojn_X2ooWin@0Moo[jn_oinOWonOWiooWinOnn_[ko`/;2
ojFUYOnZZZ[o/[:bokfm_Oo1`L7oa/K6olG5aOno_koo^KViok6a/One]KGoiNGUono_koono_koa<C4
olW9bOo?cloodm?ComOGeooKfm_oh>3Pon?ShooUiND00OoXj>P0017ojn_[00ko>SXjog=cLoo[jn_o
jn_[odE5AOlP823oR8R8omKFe_m4A4Co:2PXof5QHOoBd];oL71`ocXj>P;ojn_[00GoZJVYol[:b_oX
j>SoHF5QoeIFEP02on_[j`06od10@?m:BT[odM7AomoOgomIFEWo71`L0_o[jn/02_m5ADGoO7alon_[
joo[jn_oA4A4oalO7omcLg?oc/k>oeUIFOm@D502on_[j`05ojZZZ_o:b/[oj>SXof5QHOmGEeL00_o[
jn/02om5ADGo7AdMoh^;RooDe=CoVYZJoaTI6OoQhN7ojn_[omcLg?lF5QKob<S800Gojn_[00?o?3`l
og5aLOo[jn/00oo[jn/04On:RX[o4A4AonSXj?o[jn_oZJVYol[:b_oXj>SoHV9RoeIFE_o[jn_oVi^K
oaTI6OoRh^;ojn_[omcLg?lE5AGob<S800Kojn_[00CoWIfMof9RH_lo?cooZj^[W_o[jn/01_nm_Kgo
dm?ColO7aonOWiooVi^KojJVYP?o[:b/013oYZJVoibLW?na/K7ohn?SooWinOo_knook^k^olS8b?o>
c/kodM7AomKFe_oKfm_og]kNon7QhOoTi>CoinOW0OoYjNT000;onOWi0_ojn_X00ooinOWon_[jooWi
n@03ooWin@0Loo[jn_oinOWonOWioo[jn_oinOWon_[jooWinOlm?CgoNg]koo[jn_oinOWoG5aLohj>
S_meMGGo71`Loc8b<_oBd];oVi^KobDU9Ol[:b_o[Jf]oo[jn_oinOWoSHf=oc`l??lL71co@T92ol?3
``;onOWi00[ogmoOoda<C?lH61So<c<cogYjN_le=CGonOWioo[jn_mKFe_oT92@0_ojn_X07?mKFe_o
Shn?ogemOOlP823o>CTiol;2`_ojn_[onOWiohf=SOll?3co71`Lod92@_o2`/;onOWioo[jn_mKFe_o
S8b<ofATI?lE5AGoFe]KogIfM_oinOWon_[jooWinOm`L73oRHV9ooWinOojn_X2ooWin@04oo[jn_lo
?cooN7Qhoo[jnP?onOWi00goFEUIocLg=ooinOWonOWiohf=SOll?3co7AdMod51@Oo3`l?on_[jof5Q
HOmeMGGon_[j00;onOWi00?oLG5aohR8R?ojn_X00_oinOT00oojn_[onOWioo[jnP02ooWin@04omWI
fOl@413odm?Coo[jnPConOWi00Kon_[jooWinOoinOWon_[jooWinOojn_X2ooWin@;on_[j00?onOWi
oo[jn_oinOT00ooinOT01_ojn_[onOWiooWinOojn_[onOWioo[jnP;onOWi0_ojn_X00ooinOWon_[j
ooWin@03ooWin@06oo[jn_oinOWonOWioo[jn_oinOWon_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi
00?onOWi00Kon_[jooWinOoinOWon_[jooWinOojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT00ooi
nOT01_ojn_[onOWiooWinOojn_[onOWioo[jnP;onOWi0_ojn_X00ooinOWon_[jooWin@03ooWin@06
oo[jn_oinOWonOWioo[jn_oinOWon_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi00?onOWi00Kon_[j
ooWinOoinOWon_[jooWinOojn_X2ooWin@;on_[j00?onOWioo[jn_oinOT00ooinOT01_ojn_[onOWi
ooWinOojn_[onOWioo[jnP;onOWi0_ojn_X00ooinOWon_[jooWin@03ooWin@06oo[jn_oinOWonOWi
oo[jn_oinOWon_[j0_oinOT2oo[jnP03ooWinOojn_[onOWi00?onOWi00Kon_[jooWinOoinOWon_[j
ooWinOojn_X2ooWin@0Iokno_ooEeMGok^k^omCDe?n][JgoX:2PoiRHV?n>SXkoVIVIojVYZOo6a/Ko
lo?coogmoOojn_[ok^k^onKVi_o>c/kod];BomGEeOoJf][og=cLon3Ph?oTi>CoiNGUonSXj001onWY
j@004Oono_h00olo?cooOGemooknoP04ooknoP03oogmoOono_koo_kn00;oo_kn00?ooOgmookno_on
o_h00oono_h00oolo?coo_knooknoP04ooknoP03ooclo?ono_koo_kn00[oo_kn00?ooOgmookno_on
o_h01?ono_h00oolo?coo_knooknoP05ooknoP03ooclo?ono_koo_kn00[oo_kn00?o@D51og]kNoon
o_h00_ono_h00onTY:Co3`l?ojJVYP04ooknoP03ooclo?ono_koo_kn013oo_kn00?ooOgmobLW9onR
XZ80WOono_h06Onm_Kgodm?Coo7alOobl_;ogmoOomGEeOoJf][oh^;RonOWioo]kNgomOGeoo[jn_om
oOgonOWiono_koo^k^kodM7AomGEeOoIfMWog=cLon3Ph?oRh^;oiNGUonSXj?oYjNT00OoZj^X00006
oo[jn_oinOWonOWioo[jn_oinOWon_[j2?oinOT02?ojn_[onOWioo[jn_lm?CgoNWYjoo[jn_oinOWo
n_[j2?oinOT00oojn_[onOWioo[jnP02ooWin@03oo[jn_oinOWon_[j00SonOWi00Son_[jooWinOmR
HV;oU9BDooWinOojn_[onOWioo[jnPSonOWi00?on_[jooWinOojn_X00_oinOT00oojn_[onOWioo[j
nP08ooWin@03oo[jn_oinOWon_[j00;onOWi00So?cloocPh>?mZJV[oEUIFocLg=olD51CoTY:BooSh
n0?onOWi00?on_[jooWinOojn_X00_oinOT00oojn_[onOWioo[jnP08ooWin@08oo[jn_nEUIGoLg=c
oj2PX?mWIfOo6a/Kon_[joojn_X8ooWin@03oo[jn_oinOWon_[j00;onOWi00?on_[jooWinOojn_X0
2?oinOT00oojn_[onOWioo[jnP02ooWin@03oo[jn_oinOWon_[j00SonOWi00?on_[jooWinOojn_X0
0_oinOT00oojn_[onOWioo[jnP08ooWin@03oo[jn_oinOWon_[j00;onOWi00?on_[jooWinOojn_X0
2?oinOT00oojn_[onOWioo[jnP02ooWin@03oo[jn_oinOWon_[j00SonOWi00?on_[jooWinOojn_X0
0_oinOT00oojn_[onOWioo[jnP08ooWin@03oo[jn_oinOWon_[j00;onOWi00?on_[jooWinOojn_X0
2?oinOT00oojn_[onOWioo[jnP02ooWin@03oo[jn_oinOWon_[j00SonOWi00?on_[jooWinOojn_X0
0_oinOT00oojn_[onOWioo[jnP08ooWin@0Koo[jn_oinOWon_[jooWinOnn_[koe=CDoo;bl_ogmoOo
mOGeon[Zj_oMgMgohN7QonSXj?o^k^kom?Cdoo[jn_omoOgonOWiono_koono_koe]KFom[Jf_oLg=co
gmoOon;Rh_oTi>Coi^KV00;ojNWY0Oo[jn/000cojn_[00?ok>c/on_[joo[jn/00_o[jn/00onVYZKo
_;blon_[j`08on_[j`03onc/k?o[jn_ojn_[00gojn_[00Kok>c/on_[joo[jn_ojn_[ojVYZOno_kl:
on_[j`03onc/k?o[jn_ojn_[00gojn_[00?ok>c/on_[joo[jn/01?o[jn/01_nVYZKoTi>Coi:BT_nJ
VY[o^;RhomWIf@?ojn_[00?ok>c/on_[joo[jn/03Oo[jn/02?o/k>cojn_[on_[joo6a/KoRXZ:of][
JonDU9Cod=3@2?o[jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[jn_ojn_[00gojn_[00?ok>c/
on_[joo[jn/03Oo[jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[jn_ojn_[00gojn_[00?ok>c/
on_[joo[jn/03Oo[jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[jn_ojn_[00gojn_[00?ok>c/
on_[joo[jn/03Oo[jn/00oo/k>cojn_[on_[j`03on_[j`04okjn__oDe=Col_;booOgm`;on?Sh01?o
jn_[on7QhOoXj>Sokno_ooKfm_ojn_[oo?clooWinOo_knook^k^om_KfooLg=coh>3Pon7QhOoShn?o
i^KVonSXj?oYjNWojn_[007okNg]00001Oojn_[onOWiooWinOoinOWon_[j00ConOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT00oojn_[onOWioo[jnP03ooWin@03oo[jn_oinOWonOWi00;onOWi00?on_[jooWi
nOoinOT00_oinOT02?ojn_[onOWioo[jn_oinOWo^KViom;Bd_oalO7om_Kf0_ogmoL04OoXj>SogMgM
on?ShooVi^Kok^k^ooCdm?ogmoOom?CdonWYjOoVi^Kog]kNon3Ph?oRh^;oi>CTonKVi_oXj>SojNWY
00;ojn_[0Oo/k>`00007oocmo_omo_kooOkooogno_omoOkooOkooognoP02oogmoP07oogno_omo_oo
oOknoogno_omoOkooOknoogmoP02oognoP05oognooomo_kooOgnoognooomo_h00_omoOh01oomo_ko
oOkooogno_omo_kooOgnoogno_omoOh00_omo_h01Oomo_oooOknoogmo_omo_oooOkn00;ooOgn00Oo
oOknoognooomo_kooOknoogmo_omo_kooOgn00;ooOkn00GooOkooogno_omoOkooOkooognoP02oogm
oP07oogno_omo_oooOknoogno_omoOkooOknoogmoP02oognoP05oognooomo_kooOgnoognooomo_h0
0_omoOh01oomo_kooOkooogno_omo_kooOgnoogno_omoOh00_omo_h01Oomo_oooOknoogmo_omo_oo
oOkn00;ooOgn00OooOknoognooomo_kooOknoogmo_omo_kooOgn00;ooOkn00GooOkooogno_omoOko
oOkooognoP02oogmoP07oogno_omo_oooOknoogno_omoOkooOknoogmoP02oognoP05oognooomo_ko
oOgnoognooomo_h00_omoOh01oomo_kooOkooogno_omo_kooOgnoogno_omoOh00_omo_h01Oomo_oo
oOknoogmo_omo_oooOkn00;ooOgn00OooOknoognooomo_kooOknoogmo_omo_kooOgn00;ooOkn00Go
oOkooogno_omoOkooOkooognoP02oogmoP07oogno_omo_oooOknoogno_omoOkooOknoogmoP02oogn
oP05oognooomo_kooOgnoognooomo_h00_omoOh01oomo_kooOkooogno_omo_kooOgnoogno_omoOh0
0_omo_h01Oomo_oooOknoogmo_omo_oooOkn00;ooOgn00OooOknoognooomo_kooOknoogmo_omo_ko
oOgn00;ooOkn00GooOkooogno_omoOkooOkooognoP02oogmoP07oogno_omo_oooOknoogno_omoOko
oOknoogmoP02oognoP05oognooomo_kooOgnoognooomo_h00_omoOh01oomo_kooOkooogno_omo_ko
oOgnoogno_omoOh00_omo_h01Oomo_oooOknoogmo_omo_oooOkn00;ooOgn00OooOknoognooomo_ko
oOknoogmo_omo_kooOgn00;ooOkn00GooOkooogno_omoOkooOkooognoP02oogmoP07oogno_omo_oo
oOknoogno_omoOkooOknoogmoP02oognoP05oognooomo_kooOgnoognooomo_h00_omoOh01oomo_ko
oOkooogno_omo_kooOgnoogno_omoOh00_omo_h06Onf][Ooclo@onSXj?oZj^[oi>CTomSHf?o?cloo
dM7AomOGeooMgMgohn?SonSXj?o[jn_oj>SXomkNg_oWinOoKfm_og5aLOmeMGGoPH61oiNGUonf][Ko
f=SHono_kooinOT00Oolo?`00006ooGfmoobmOSoloKhoo?en?ocm_Sol_Gh0_ocm_P2oo?en005oo;e
n?ocm_Sol_Ghoo?fn?ocmOP00_ocm_P01OobmOSoloKhoo?en?ocm_Sol_Gh00;oloKh0_ocmOP01Oob
mOSoloKhoo;en?ocm_SoloGh00;oloKh00Gol_Ghoo?fn?ocmOSoloKhoo;en002oo?fn0;oloGh00Go
l_Ghoo?fn?obmOSoloKhoo?en002oo?fn005oo;en?ocm_SoloGhoo?fn?obmOP00_ocm_P2oo?en005
oo;en?ocm_Sol_Ghoo?fn?ocmOP00_ocm_P01OobmOSoloKhoo?en?ocm_Sol_Gh00;oloKh0_ocmOP0
1OobmOSoloKhoo;en?ocm_SoloGh00;oloKh00Gol_Ghoo?fn?ocmOSoloKhoo;en002oo?fn0;oloGh
00Gol_Ghoo?fn?obmOSoloKhoo?en002oo?fn005oo;en?ocm_SoloGhoo?fn?obmOP00_ocm_P2oo?e
n005oo;en?ocm_Sol_Ghoo?fn?ocmOP00_ocm_P01OobmOSoloKhoo?en?ocm_Sol_Gh00;oloKh0_oc
mOP01OobmOSoloKhoo;en?ocm_SoloGh00;oloKh00Gol_Ghoo?fn?ocmOSoloKhoo;en002oo?fn0;o
loGh00Gol_Ghoo?fn?obmOSoloKhoo?en002oo?fn005oo;en?ocm_SoloGhoo?fn?obmOP00_ocm_P2
oo?en005oo;en?ocm_Sol_Ghoo?fn?ocmOP00_ocm_P01OobmOSoloKhoo?en?ocm_Sol_Gh00;oloKh
0_ocmOP01OobmOSoloKhoo;en?ocm_SoloGh00;oloKh00Gol_Ghoo?fn?ocmOSoloKhoo;en002oo?f
n0;oloGh00Gol_Ghoo?fn?obmOSoloKhoo?en002oo?fn005oo;en?ocm_SoloGhoo?fn?obmOP00_oc
m_P2oo?en005oo;en?ocm_Sol_Ghoo?fn?ocmOP00_ocm_P01OobmOSoloKhoo?en?ocm_Sol_Gh00;o
loKh0_ocmOP01OobmOSoloKhoo;en?ocm_SoloGh00;oloKh00Gol_Ghoo?fn?ocmOSoloKhoo;en002
oo?fn0;oloGh00Gol_Ghoo?fn?obmOSoloKhoo?en002oo?fn005oo;en?ocm_SoloGhoo?fn?obmOP0
0_ocm_P2oo?en005oo;en?ocm_Sol_Ghoo?fn?ocmOP00_ocm_P01OobmOSoloKhoo?en?ocm_Sol_Gh
00;oloKh0_ocmOP01OobmOSoloKhoo;en?ocm_SoloGh00;oloKh01[ol_Ghojf_/_nWZZgo^[jnok>f
]on_/[?o/;>dokNk^onm`<7o`LG5olS;c?o<d=3od]GFomGHfOoBeMKobLg=oo_noonbjO?o/>KdojWQ
m_nEbN3oMibiogR8VOn/[:codm?ConGUi@7ojn_[00001?nR[KOoN:G?ogNScOmoYlh2ogjVc008ogfU
bomlY<_oO:C:ogbSbOmlY<WoO:?9og^Rb?mkXlP3og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00=og^Sb?mkX/SoNj?8og^Rb?mkXlSoNj;8
og^Sb?mkXlWoNj;8og^SbOmkXlSoNj;8og^Sb003og^Rb00Jog^Sb?mcW/OoM9o7ohk8c?n/h>[oZmk[
ojgRjonainco[^;/ok3UkOn`i^ko/NK_ok;Wl?nbj?7o/nWaokCZl_ngk_Co^?3eokG/mon^j?OoY^7h
oi7CnOm]XMSoN8VMokjn__oKfm/1on?Sh`0000?oY:niogVVd?n2Zm800_o/k>`01Oo[jn_oj^[Zong]
kOo]kNgok>c/00?ojn_[00?ok>c/on_[joo[jn/00ooZj^X00oo[jn_oj^[Zon_[j`02on[ZjP04on_[
jooZj^[oj^[Zon[ZjP;ojn_[00?oj^[Zon_[jooZj^X00_oZj^X00oo[jn_oj^[Zon_[j`02on[ZjP04
on_[jooZj^[oj^[Zon[ZjP;ojn_[00?oj^[Zon_[jooZj^X00_oZj^X00oo[jn_oj^[Zon_[j`02on[Z
jP04on_[jooZj^[oj^[Zon[ZjP;ojn_[00?oj^[Zon_[jooZj^X00_oZj^X00oo[jn_oj^[Zon_[j`02
on[ZjP04on_[jooZj^[oj^[Zon[ZjP;ojn_[00?oj^[Zon_[jooZj^X00_oZj^X00oo[jn_oj^[Zon_[
j`02on[ZjP04on_[jooZj^[oj^[Zon[ZjP;ojn_[00?oj^[Zon_[jooZj^X00_oZj^X00oo[jn_oj^[Z
on_[j`02on[ZjP04on_[jooZj^[oj^[Zon[ZjP;ojn_[00?oj^[Zon_[jooZj^X00_oZj^X00oo[jn_o
j^[Zon_[j`02on[ZjP04on_[jooZj^[oj^[Zon[ZjP;ojn_[00?oj^[Zon_[jooZj^X00_oZj^X00oo[
jn_oj^[Zon_[j`02on[ZjP04on_[jooZj^[oj^[Zon[ZjP;ojn_[00?oj^[Zon_[jooZj^X00_oZj^X0
0oo[jn_oj^[Zon_[j`02on[ZjP04on_[jooZj^[oj^[Zon[ZjP;ojn_[00?oj^[Zon_[jooZj^X00_oZ
j^X00oo[jn_oj^[Zon_[j`02on[ZjP04on_[jooZj^[oj^[Zon[ZjP;ojn_[00?oj^[Zon_[jooZj^X0
0_oZj^X00oo[jn_oj^[Zon_[j`02on[ZjP04on_[jooZj^[oj^[Zon[ZjP;ojn_[00?oj^[Zon_[jooZ
j^X00_oZj^X00oo[jn_oj^[Zon_[j`02on[ZjP04on_[jooZj^[oj^[Zon[ZjP;ojn_[00?oj^[Zon_[
jooZj^X00_oZj^X00oo[jn_oj^[Zon_[j`02on[ZjP04on_[jooZj^[oj^[Zon[ZjP;ojn_[00?oj^[Z
on_[jooZj^X00_oZj^X00oo[jn_oj^[Zon_[j`02on[ZjP04on_[jooZj^[oj^[Zon[ZjP;ojn_[00?o
j^[Zon_[jooZj^X00_oZj^X00oo[jn_oj^[Zon_[j`02on[ZjP04on_[jooZj^[oj^[Zon[ZjP;ojn_[
00?oj^[Zon_[jooZj^X00_oZj^X00oo[jn_oj^[Zon_[j`02on[ZjP08on_[jooZj^[oj^[Zon[Zj_o[
jn_oj>SXonOWiooXj>P2onOWi`0=ogfUbomgXlcoRL;BojkRl?n^h^oo[n?`ok3TlOn^hO7o/>CbojoS
lOnai_?o/NKdok3Tm002ojoUm@0:ok7Vm_ncj?Oo/>Kioj[SnOnUh__oT];kogNjnomLQ[Co^k^komoO
g`7ojn_[00000onZ]L3oOZgIohNbf`3oooooo`oooooo00ComoOgohF`fOmn[MWoTLcO0_ndj_l:okG[
o`0:ok?Yoonejooo/NWooj_UoonSh?ooT=3oogNjoom?SmCoa<C4oo7al@7ooOgm00000onZ]L3oOZgI
ohNbf`3oooooo`oooooo00ComoOgohF`fOmn[MWoR/?O0onaiOl01?n_i?oo/NGoojoToonaiOl4ojoT
o`0;ok7Uoon^hooo[^GoojkSoonWhOooW=Soohg=oomd^?ooA8gLokFe]OoPh>000Oo/k>`00003ojZe
`?mn[MWoQk;K0?oooooo3oooool01OogmoOoQK3Iogj]fOn1^]ooZn3o00;oZ]oo00Co[>7ooj[Ooon/
hOooZ]oo1?n/hOl02onZgoooZ=ooojSNoonVfoooW]GooiSDoon8aoooKJohod::fon^[Zkof=SH007o
i>CT00000onZ]L3oOZgIohNbf`3oooooo`oooooo00SomoOgohF`fOmn[MWoO[GOojOKoonTf?ooY][o
ojGJo`[oY=Wo00SoX=Kooi_Coon@bOooPl7oofVZlOlnQ]Ko];Bdon3Ph07ok>c/00000onZ]L3oOZgI
ohNbf`3oooooo`oooooo00Con_[johF`fOmn[MWoO[GO3onPe_l01onKdoooT<Wooh?1oomYZ_7o?XKF
ol71`Oo`l?000OomoOd00003ojZe`?mn[MWoQk;K0?oooooo3oooool01_ojn_[oQK3Iogj]fOmg[moo
W]?ooigBo`coW]?o00SoV/oooi?<oon8`?goNkSiof:Uk_lgOloo];Bdon3Ph07ok>c/00000onZ]L3o
OZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoKJGOoiO<o`02oiK:o`WoULWo00[oU/[ooi;7
o_n>`o[oS<?noh:knOmb/OCoF9_Toc1ibOn^[Zkof=SH0OoTi>@00003ojZe`?mn[MWoQk;K0?oooooo
3oooool02oojn_[oQK3Iogj]fOmTW=KoS/;iohk3n_n=`OSoS/;iohk3n_n>`_WoS/?j00CoS/;i0_n>
`oX02On;_oKoR;geoh6im?mi/NkoJZOZoe2CfolYKl?o];Bdon3Ph001onc/k00000?oZ[G0ogj]fOn7
/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIoe^Bcon4^O400_n7^o@9ohBil@0:ohJjlOn3^O7oOkG^
ogVajom`Z^WoH9oSodJ:eOlPJ;go`L71oo3`l07ooOgm00000onZ]L3oOZgIohNbf`3oooooo`oooooo
00Kon_[johF`fOmn[MWoDh[6ogbajOmk[nL:ogbaj@0:og^_jOmg[nWoLj_VoffUhomRW]koEI?Hoc]n
c?lFGkCo];Bdon3Ph07ok>c/00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWo
CX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomO
V][oChgCoc1ea?l=EJko[Zj^omSHf001onCTi00000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[j
n_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQ
ofnVgomYX]_oGi[Jodn=dol`MLCo3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo
3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omf
Z^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm00000onZ]L3oOZgI
ohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZ
h@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k000
00?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3o
MZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ojj^[_oH
f=P00OoTi>@00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;o
Mj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4
o`eE[_ne]KGoh>3P007ok>c/00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWo
CX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomO
V][oChgCoc1ea?l=EJko`/;2oo3`l001oogmo@0000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[j
n_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQ
ofnVgomYX]_oGi[Jodn=dol`MLCo3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo
3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omf
Z^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT00000onZ]L3oOZgI
ohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZ
h@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k000
00?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3o
MZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ol;2`_o`
l?000OomoOd00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;o
Mj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4
o`eE[_ne]KGoh>3P007ok>c/00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWo
CX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomO
V][oChgCoc1ea?l=EJko[Zj^omSHf001onCTi00000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[j
n_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQ
ofnVgomYX]_oGi[Jodn=dol`MLCo3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo
3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omf
Z^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm00000onZ]L3oOZgI
ohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZ
h@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k000
00?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3o
MZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ojj^[_oH
f=P00OoTi>@00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;o
Mj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4
o`eE[_ne]KGoh>3P007ok>c/00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWo
CX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomO
V][oChgCoc1ea?l=EJko`/;2oo3`l001oogmo@0000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[j
n_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQ
ofnVgomYX]_oGi[Jodn=dol`MLCo3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo
3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omf
Z^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT00000onZ]L3oOZgI
ohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZ
h@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k000
00?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3o
MZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ol;2`_o`
l?000OomoOd00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;o
Mj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4
o`eE[_ne]KGoh>3P007ok>c/00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWo
CX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomO
V][oChgCoc1ea?l=EJko[Zj^omSHf001onCTi00000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[j
n_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQ
ofnVgomYX]_oGi[Jodn=dol`MLCo3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo
3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omf
Z^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm00000onZ]L3oOZgI
ohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZ
h@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k000
00?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3o
MZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ojj^[_oH
f=P00OoTi>@00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;o
Mj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4
o`eE[_ne]KGoh>3P007ok>c/00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWo
CX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomO
V][oChgCoc1ea?l=EJko`/;2oo3`l001oogmo@0000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[j
n_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQ
ofnVgomYX]_oGi[Jodn=dol`MLCo3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo
3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omf
Z^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT00000onZ]L3oOZgI
ohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZ
h@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k000
00?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3o
MZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ol;2`_o`
l?000OomoOd00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;o
Mj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4
o`eE[_ne]KGoh>3P007ok>c/00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWo
CX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomO
V][oChgCoc1ea?l=EJko[Zj^omSHf001onCTi00000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[j
n_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQ
ofnVgomYX]_oGi[Jodn=dol`MLCo3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo
3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omf
Z^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm00000onZ]L3oOZgI
ohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZ
h@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k000
00?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3o
MZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ojj^[_oH
f=P00OoTi>@00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;o
Mj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4
o`eE[_ne]KGoh>3P007ok>c/00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWo
CX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomO
V][oChgCoc1ea?l=EJko`/;2oo3`l001oogmo@0000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[j
n_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQ
ofnVgomYX]_oGi[Jodn=dol`MLCo3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo
3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omf
Z^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT00000onZ]L3oOZgI
ohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZ
h@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k000
00?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3o
MZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ol;2`_o`
l?000OomoOd00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;o
Mj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4
o`eE[_ne]KGoh>3P007ok>c/00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWo
CX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomO
V][oChgCoc1ea?l=EJko[Zj^omSHf001onCTi00000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[j
n_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQ
ofnVgomYX]_oGi[Jodn=dol`MLCo3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo
3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omf
Z^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm00000onZ]L3oOZgI
ohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZ
h@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k000
00?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3o
MZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ojj^[_oH
f=P00OoTi>@00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;o
Mj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4
o`eE[_ne]KGoh>3P007ok>c/00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWo
CX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomO
V][oChgCoc1ea?l=EJko`/;2oo3`l001oogmo@0000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[j
n_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQ
ofnVgomYX]_oGi[Jodn=dol`MLCo3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo
3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omf
Z^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT00000onZ]L3oOZgI
ohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZ
h@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k000
00?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3o
MZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ol;2`_o`
l?000OomoOd00003ojZe`?mn[MWoQk;K01[ooooo00Go`<30oh>3PomQHF7oNGUiolk>cP0Kooooo`03
on7QhOmnOWkon?Sh01Wooooo00?ohN7QoginO_ohn?P0]Oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT
00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o
<7G4o`eE[_ne]KGoh>3P007ok>c/00000onZ]L3oOZgIohNbf`0Jooooo`06ohV9ROmfMWKoYJFUof=S
Hol;2`_o_;bl6_ooool00ookno_o7AdMojFUY@0Iooooo`03oo_knolM7AgoYJFU0;Gooooo00Gon_[j
ohF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7o
KjKOofVRfomOV][oChgCoc1ea?l=EJko[Zj^omSHf001onCTi00000?oZ[G0ogj]fOn7/]/05?ooool0
0oo/k>cooOgmooooo`02ooCdm0Gooooo00?oFUYJodM7Aoooool03_ooool00oo/k>cooOgmooooo`02
ooCdm0Oooooo00?oRh^;ochn?_ooool04_ooool00oo/k>cooOgmooooo`02ooCdm0;ooooo00?oRh^;
ochn?_ooool0]?ooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00KoMJ[PogJZhOmeZ^3oMZ[Q
ogFZh?m?M9P2ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^okFe]OoPh>00
0Oo/k>`00003ojZe`?mn[MWoQk;K00?ooooo00Ko=3@dogIfM_oooooooooood10@?moOgl2ooooo`06
ogYjN_m3@d?ooooooooooond];Co2@T90_ooool03OmADE7o20P8oaXJ6_nLW9co4a<CoeMGEooooooo
inOWoeeMGOli>CWoNWYjoifMWOlN7Qh00_ooool01_m0@43oOgmooooooooooooo@410ogmoO`;ooooo
00goXj>Soa`L7?oooooooooooe5ADOl820So6QXJoibLW?lC4a?oEeMGoooooom0@43oOgmo00Cooooo
00?oTY:Bo`000?oGemL01oooool01olf=SKo0000o`000?l820So;bl_og=cLooclo<00oooool01_mA
DE7o20P8oaXJ6_nLW9co4a<CoeMGE`;ooooo00?oTY:Bo`000?oGemL02?ooool00olH61SoKFe]oooo
o`2Yooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<04omeZ^3oMZ[QogFZh?mfZ^7oHXjkoa/W
<omRS[_oMJ[PogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ol;2`_o`l?000OomoOd0
0003ojZe`?mn[MWoQk;K00?ooooo00Ko=3@dogIfM_oooooooooood10@?moOgl2ooooo`0=ogYjN_m3
@d?ooooooooooond];Co2@T9ooooooo6a/Ko10@4omgMgOoVi^KoFe]Koa4A4@02ooooo`06ode=COl^
;RkoXZ:RogalO?l];Bgo51@D0_ooool01_m0@43oOgmooooooooooooo@410ogmoO`;ooooo00WoXj>S
oa`L7?ooooooa/K6o`@41?oMgMgoi^KVoe]KFolA4A400_ooool00om0@43oOgmoooooo`03ooooo`03
obl_;ol92@WoLG5a00Oooooo00oo=SHfogAdM?oooooomOGeolc<c?m5ADGo8B4Qoo3`l?ooooooa/K6
o`@41?oMgMgoi^KVoe]KFolA4A400oooool00ol_;boo2@T9og5aL@08ooooo`03oeiNG_lG5aOoo?cl
0:Wooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`0CogFZh?mfZ^7oMJ[PogJZhOlO;C_o0000
oal]>omeZ^3oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k000
00?oZ[G0ogj]fOn7/]/00oooool01_ld=3CoMWIfoooooooooooo@410ogmoO`;ooooo017oNWYjod=3
@ooooooooooookBd]?l92@WoooooomWIfOl30`?o_KfmoooooonOWioo820Pooooooofm_Ko2@T9okVi
^@02ooooo`06oiJFU_lA4A7ooooooooooom0@43oOgmo0_ooool03Om0@43oOgmoooooooooooooXj>S
oa`L7?oooooofMWIo`<30onm_KgooooooinOWolP82000_ooool00om0@43oOgmoooooo`02ooooo`05
olc<c?l10@7oWinOoa<C4oohn?P01_ooool00olf=SKoM7Adooooo`02ooooo`0:oo[jn_lO7aooLG5a
oooooooIfMWo0`<3okfm_OooooooWinOob0P80;ooooo00Goc<c<o`410OnOWioo4a<CooShn007oooo
o`03olg=cOl10@7o^[Zj0:Wooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`0CogFZh?mfZ^7o
MJ[Poe1dVOlK9c?o0000oa/W<om?M9SoMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko
[Zj^omSHf001onCTi00000?oZ[G0ogj]fOn7/]/00oooool01_ld=3CoMWIfoooooooooooo@410ogmo
O`;ooooo00KoNWYjod=3@ooooooooooookBd]?l92@T2ooooo`09ojf][Olb<S;o<c<cocHf=_lP823o
oooool;2`_l0003oi^KV00;ooooo00Ko[:b/oa4A4Ooooooooooood10@?moOgl2ooooo`06od10@?mo
OgoooooooooooonSXj?o71`L0_ooool01On][Jgo<S8boc<c<olf=SKo820P00;ooooo00?o@410ogmo
Ooooool00_ooool01OmYJFWo@D51oooooolX:2SoY:BT00Kooooo00?o=SHfogAdM?ooool00oooool0
2OmlO7co8R8Roooooooooooo[Jf]oc8b<_lc<c?o=SHfob0P8002ooooo`05ofUYJOm1@D7oooooobPX
:?nTY:@02?ooool00omKFe_oF5QHooooo`2Xooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<0
1?meZ^3oMZ[Qog2Tf?l?5Qh3o`00000<o`lF7OmaY=WoMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4
o`eE[_ne]KGoh>3P0Oo/k>`00003ojZe`?mn[MWoQk;K00?ooooo00Ko=3@dogIfM_oooooooooood10
@?m]KFd2ooooo`06ogUiNOlc<c?oo_knoooooonc/k?o2@T91?ooool01oomoOgoU9BDob4Q8Ooooooo
f][Jo`000?ne]KD00_ooool01_n/[:co4A4Aoooooooooooo@410ogmoO`;ooooo00Ko@410oeeMGOoo
oooooooooifMWOlM7Ad4ooooo`03oogmoOnDU9Co8B4Q00;ooooo00[o@410ofUYJOooooooooooooKf
m_l?3`ooXZ:Roooooon@T93o?Shn1_ooool00olf=SKoM7Adooooo`03ooooo`03oijNW_l30`?onOWi
00?ooooo00[ooOgmoiBDU?lQ8B7oooooooKfm_l?3`ooXZ:Roooooon@T93o?Shn2?ooool00ooRh^;o
3@d=olK6aP2Xooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44
ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ol;2`_o`l?000OomoOd00003
ojZe`?mn[MWoQk;K00?ooooo00ko=3@dogIfM_oooooooooood10@?lE5AGoS8b<onSXj?lo?coo7alO
of1PH?oRh^;oLG5aoc<c<`;ooooo00Go];Bdom[Jf_olo?coHF5QoeADE002ooooo`06oc/k>om6ATKo
h^;Roo7alOmFEUKo4A4A0_ooool02_m0@43oOgmooooooooooooo@410oa@D5?mfMWKog]kNoeMGEom=
CDd2ooooo`05okBd]?oJf][oo?clof5QHOmDE5@00_ooool02om0@43o4a<Coi6ATOoTi>CoXJ6Qo`h>
3_oemOGoooooonk^k_l92@WoemOG00Gooooo00?o=SHfogAdM?ooool00oooool04On@T93o1@D5oo_k
nooooooo];Bdom[Jf_olo?coHF5QoeADE?ooooooXj>So`h>3_oemOGoooooonk^k_l92@WoemOG00So
oooo00?oSXj>oc8b<_omoOd0Yoooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZ
hOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P
007ok>c/00000onZ]L3oOZgIohNbf`03ooooo`0>oc@d=?mfMWKooooooooooomDE5CoRh^;og5aLOl@
413o:2PXomGEeOnJVY[o6QXJob0P8?n][Jd2ooooo`05ohZ:R_lb<S;o410@ocTi>Oo4a<@00_ooool0
1_oShn?oA4A4o`/;2olY:BWoMWIfobXZ:P;ooooo00[oE5ADohf=SOoooooooooooeADE?n<S8coNGUi
oa@D5?l^;Rkoa<C40_ooool01On:RX[o<S8boa0@4?li>CWoa<C400;ooooo00KoE5ADohV9ROmMGEgo
2@T9oeADE?maLG43ooooo`03ofa/K?n5QHGooooo00Cooooo00?o=SHfogAdM?ooool00oooool03?mB
DU;o;2`/ooooooooooooRXZ:oc8b<_l@413o>CTiolC4a?ooooooFUYJog5aL@?ooooo00?oK6a/ohF5
QOooool01oooool00oolo?co<30`oiJFUP2Wooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<0
1?meZ^3oMZ[Qog2Tf?l?5Qh3o`00000<o`lF7OmaY=WoMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4
o`eE[_n^[Zkof=SH0OoTi>@00003ojZe`?mn[MWoQk;K00?ooooo00?o=3@dogIfM_ooool01?ooool0
0oono_koooooooooo`02ooooo`03ookno_oooooooooo00?ooooo00?ooOgmooooooooool01?ooool0
0oomoOgoooooooooo`0:ooooo`03ookno_oooooooooo00Cooooo00?ooOgmooooooooool01Oooool0
0oolo?coooooooooo`0:ooooo`03ocHf=_mdM7Cooooo00;ooooo00?oWinOo`410OnQXJ401?ooool0
0oomoOgoooooooooo`0Aooooo`03olW9bOlD51Cojn_[0:Kooooo00Gon_[johF`fOmn[MWoCX?0ogN/
i002ogN[h`0CogFZh?mfZ^7oMJ[Poe1dVOlK9c?o0000oa/W<om?M9SoMZ[QogF[i?mcZ>7oKjKOofVR
fomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k00000?oZ[G0ogj]fOn7/]/00oooool00old=3Co
MWIfooooo`0Looooo`03oe]KFonBTY;ooooo023ooooo00So=SHfobh^;_mTI6CoCdm?obd];Ol71`Oo
Shn?ooknoQCooooo00?oRXZ:ocPh>?lh>3P00_lh>3P00ol:2P[oTi>Cooooo`2Uooooo`05oo[jn_n5
/=WoOZgIodj3`?mg[>@00_mgZn<04omeZ^3oMZ[QogFZh?mfZ^7o7bdko`000?lO;C_oMJ[PogJZhOme
ZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ol;2`_o`l?000OomoOd00003ojZe`?mn[MWoQk;K
00?ooooo00?o[jn_olW9bOooool07?ooool00ond];CocLg=ooooo`0Pooooo`06ok2`/?nJVY[oVYZJ
oj:RX_o4a<Cojn_[5_ooool00oo4a<CoVYZJoiZJVP03oiZJVP03om?Cdooooooooooo0:Cooooo00Go
n_[johF`fOmn[MWoCX?0ogN/i002ogN[h`0CogFZh?mfZ^7oMJ[PogJZhOmRS[_o6bLcof:>^omeZ^3o
MZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k00000?oZ[G0ogj]
fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01_meZ^3oMZ[QogFZh?mf
Z^7oMJ[PodmdV0;oMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko[Zj^omSH
f001onCTi00000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mg
Zn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo
3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>
Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJ
f_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[j
ohF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7o
KjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k00000?oZ[G0ogj]fOn7/]/0ooooool?
ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZ
hOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ojj^[_oHf=P00OoTi>@00003ojZe`?mn[MWo
Qk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q
1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0000
0onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mf
Z^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko`/;2oo3`
l001oogmo@0000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mg
Zn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo
3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>
Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJ
f_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[j
ohF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7o
KjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k00000?oZ[G0ogj]fOn7/]/0ooooool?
ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZ
hOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ol;2`_o`l?000OomoOd00003ojZe`?mn[MWo
Qk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q
1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0000
0onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mf
Z^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko[Zj^omSH
f001onCTi00000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mg
Zn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo
3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>
Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJ
f_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[j
ohF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7o
KjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k00000?oZ[G0ogj]fOn7/]/0ooooool?
ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZ
hOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ojj^[_oHf=P00OoTi>@00003ojZe`?mn[MWo
Qk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q
1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0000
0onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mf
Z^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko`/;2oo3`
l001oogmo@0000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mg
Zn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo
3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>
Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJ
f_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[j
ohF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7o
KjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k00000?oZ[G0ogj]fOn7/]/0ooooool?
ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZ
hOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ol;2`_o`l?000OomoOd00003ojZe`?mn[MWo
Qk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q
1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0000
0onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mf
Z^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko[Zj^omSH
f001onCTi00000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mg
Zn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo
3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>
Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJ
f_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[j
ohF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7o
KjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k00000?oZ[G0ogj]fOn7/]/0ooooool?
ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZ
hOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ojj^[_oHf=P00OoTi>@00003ojZe`?mn[MWo
Qk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q
1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0000
0onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mf
Z^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko`/;2oo3`
l001oogmo@0000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mg
Zn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo
3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>
Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJ
f_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[j
ohF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7o
KjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k00000?oZ[G0ogj]fOn7/]/0ooooool?
ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZ
hOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ol;2`_o`l?000OomoOd00003ojZe`?mn[MWo
Qk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q
1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0000
0onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mf
Z^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko[Zj^omSH
f001onCTi00000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mg
Zn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo
3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>
Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJ
f_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[j
ohF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7o
KjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k00000?oZ[G0ogj]fOn7/]/0ooooool?
ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZ
hOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ojj^[_oHf=P00OoTi>@00003ojZe`?mn[MWo
Qk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q
1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0000
0onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mf
Z^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko`/;2oo3`
l001oogmo@0000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mg
Zn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo
3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>
Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJ
f_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[j
ohF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7o
KjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k00000?oZ[G0ogj]fOn7/]/0ooooool?
ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZ
hOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ol;2`_o`l?000OomoOd00003ojZe`?mn[MWo
Qk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q
1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0000
0onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mf
Z^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko[Zj^omSH
f001onCTi00000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mg
Zn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo
3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>
Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJ
f_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[j
ohF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7o
KjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k00000?oZ[G0ogj]fOn7/]/0ooooool?
ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZ
hOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ojj^[_oHf=P00OoTi>@00003ojZe`?mn[MWo
Qk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q
1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0000
0onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mf
Z^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko`/;2oo3`
l001oogmo@0000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mg
Zn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo
3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>
Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJ
f_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[j
ohF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7o
KjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k00000?oZ[G0ogj]fOn7/]/0ooooool?
ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZ
hOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ol;2`_o`l?000OomoOd00003ojZe`?mn[MWo
Qk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q
1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0000
0onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mf
Z^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko[Zj^omSH
f001onCTi00000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mg
Zn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo
3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>
Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJ
f_m?SM?o<7G4o`eE[_o2`/;ol?3`007ooOgm00000onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[j
ohF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7o
KjKOofVRfomOV][oChgCoc1ea?l=EJko]KFeon3Ph001onc/k00000?oZ[G0ogj]fOn7/]/0ooooool?
ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mgZn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZ
hOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ojj^[_oHf=P00OoTi>@00003ojZe`?mn[MWo
Qk;K0?oooooo3oooool01Oojn_[oQK3Iogj]fOm>Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q
1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_ne]KGoh>3P007ok>c/0000
0onZ]L3oOZgIohNbf`3oooooo`oooooo00Gon_[johF`fOmn[MWoCX?0ogN/i002ogN[h`04ogFZh?mf
Z^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko`/;2oo3`
l001oogmo@0000?oZ[G0ogj]fOn7/]/0ooooool?ooooo`05oo[jn_n5/=WoOZgIodj3`?mg[>@00_mg
Zn<01?meZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo
3EF^okFe]OoPh>000Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo3oooool01OogmoOoQK3Iogj]fOm>
Pl3oMjcT00;oMj_S00CoMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJ
f_m?SM?o<7G4o`eE[_n^[Zkof=SH007oi>CT00000onZ]L3oOZgIohNbf`3oooooo`oooooo00OomoOg
ohF`fOmn[MWoGi73oh:_h?n1[]ooPk7P00WoPZoO00[oP:oOogn]g_mm[=koM:GJofjRf_mKU=3o9Vbm
o`57YOnf][Koh>3P0Oo/k>`00003ojZe`?mn[MWoQk;K0?oooooo3oooool02?ogmoOoQK3Iogj]fOn9
[MCoX/;Uoj;3i_nR`^GoX/?U0onR`nH03onR`nGoX<;Uoj32iOnP`^GoX/;Voj?3i_nO`^KoW<3ToiRl
honB^=ooMjGHob1W^Ol0?9cobl_;oo;blP01oogmo@0000?oZ[G0ogj]fOn7/]/01?oooooooo[jnPOo
n_[j1?ooool03?ogmoOoQK3Iogj]fOnN_=[o/lgYok;=jOncc^Wo//gYok?>jOndcn[o/lkYok?=j@?o
//gY00_o/lkZok?=jOnbcNOo[l[Wojc8i_nUa>CoNjKHo`mDZolC>93oalO7onCTi001ong]k@0000?o
Z[G0ogj]fOmn[=T0oon6/MX@ohJafP03ogj/fOmn[MWoY/7L00?o^M3Z01?o^=3ZokW@j_njd^[o^]3Y
ok[Bj_nhd>[o^<oYokW@j_njd^[o^M3ZokS?jOndc^Oo[l[Voibmh?mHS/Oo1T:OodEBTOo?clooh>3P
007oiNGU00000onCWZWoOZgIogj]f@3oogj]fA;oOZgI00GoRj_@oio0h?nO`>3oWl3Poijoh003oio0
h003oik0h?nO`>3oW[oP00;oW[oP00[oW[gPoibmh?nF^McoP:[Foe>:a_lPF:_o9Sn@oifN^?oShn?o
k>c/0Oo^k^h00003og:5V?miQ8ooO8NB0?ooO8NB4?mlQi800omiQ8ooKWV4oa9FZ007oa9FZ00?oa9F
YolBEZSo4UJXoa9FZ_lBEZSo45FWo`iAY_l=CZ?o2dFNob17V_mIJZOo[[3:ooCdm?olo?coo_kn007o
oooo003ooooooaGooooo4OoPh>001OoQhN7oi>CTonSXj?o/k>cokNg]00;ok^k^003ooooooaGooooo
4_oTi>@2onGUi@Coi^KV003oogmoObgoOgmo00001?o[jn_oi^KVon;Rh_oNg]h4omgMg@?og]kN08;o
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkogMgM0_oLg=`0TOoKfm_ogMgMomcLg?oM
gMgogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMd00ooNg]h00ooMgMgog]kNomkNgP03omgMg@7ohN7Q0OoW
inL1on[ZjP0000?ok>c/onKVi_oPh>001ooIfMT01?oHf=Soe]KFom?Cdoo@d=03olg=c@04om3@d?oC
dm?oemOGomSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWI
f@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH??oIfMT2omSHf003omWIfOoH
f=Sof=SH00?ofMWI0_oHf=P5omWIf@03omSHf?oFe]Kodm?C00;odm?C00?oe]KFomSHf?oHf=P03_oI
fMT01?oHf=SofMWIomWIfOoHf=P@omWIf@;of=SHJ?oIfMT00ooHf=SofMWIomWIf@06omWIf@7og]kN
0OoVi^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoPh>3oh^;R00;ohN7Q00gog]kNomcLg?oC
dm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooC
dm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooC
dm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO02gohN7Q2_oPh>000ooOgmoo
h>3Pon3Ph006omoOg`;oh>3P0ooOgml5on3Ph007omoOgooKfm_oemOGomCDe?oEeMGofMWIomgMg@02
on3Ph003omoOgooPh>3oh>3P00;ohN7Q1ooPh>06omoOg`03on3Ph?oOgmooh>3P00_oh>3P00CogmoO
omkNg_oNg]kogmoO0_oPh>1Won7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoTi>@1onWYj@7okNg]0000
0oo`l?3okno_oo7al@03oo3`l01Zono_koo`l?3ok^k^onWYjOoKfm_o`L71ojBTY?n<S8coNg]kogMg
MomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aong]
kOoZj^[of][Jol;2`_nTY:CoS8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<S?mkNg_oMgMfog]k
Non<S8coY:BTol;2`_oJf][oj^[Zong]kOoalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo3`l0;ok>c/00Oojn_[onk^k?o/k>cokNg]onc/k?o^k^koj^[Z
00;ojn_[00[ok^k/onWYjOoXj>Soi^KVonWYjOoVi^Koj^[Zon_[joo]kN_oj>SX0_oYjNT01oo]kNgo
j^[Zonc/k?o/k>cokno]on[Zj_oXj>P00_oShn<03OoOgmoohn?SonSXj?o]kN_oj^[Zon_[joo/k>co
l?3`ono_koo`l?3okNg]onc/j_oZj^X00_o^k^h01_o_knooj^[ZonWYjOoVi^Koj>SVonOWi`;ojNWY
00Kok>c/onWYjOo/k>cokNg]onk^k?oZj^X2onc/k008onk^k_oZj^[ok>c/onc/k?o_kngojn_[onWY
jOoVi^H2onSXj0;okNg]06gol?3^ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo`l?3okno_oo3`l?o_knool?3`ono_koo`l?3okno_00Col?3`00000oobl_;ok^k^onOWi`04onGU
i@0@onCTi?oOgmoodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:ROna/K7o
dM7AomkNgP;oi>CT00?oiNGUonCTi?oUiN@00_oTi>@03ooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5
ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7@omkNgP02onCTi012onGUiOoTi>CoiNGUonCTi?oT
i>?og]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6aom7AdOoN
g]koi>CSonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oS
hn?og]kN0_oKfm/02_oNg]gog=cLom_KfooLg=cogmoOom_KfooIfMWog=cLomgMg?oGemL3omGEe@04
omCDe?oIfMWogMgMomgMg0;oemOG01;ofm_KomgMgOoJf][of][JomkNg_oQhN3ofm_KomSHf?m6ATKo
<30`ogQhN?o2`/;of][JomkNgOoJf][ofMWIomgMgOoShn<2onCTi00FomoOgooLg=_ofMWIomoOgooR
h^;ohN7Qom_KfooFe]Koe=CDomKFeOoDe=Coe]KFom_KfooLg=cof=SHomcLg?oOgmoogmoNomWIfOoK
fm_og]kNomoOg`;of][J06oogMgMon3PgooKfm_oemOGomGEeOoGemOofMWIomoOgooRh^;oi>CSonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>@01?oUiND01_oTi>CoiNGUonGU
iOoUiNGoj>SXong]k@7ol_;b00000oodm?CokNg]onOWi`02on3Ph00Con7QhOoOgmoog]kNom;Bd_nd
];CoQhN7oeaLG?m]>cGoWTi2ole_GooYPfoocFmOoii>@om]>cKoG5aLohN7Qond];Cod];BomkNgP05
on3Ph00AomkNg_oBd];o];BdohN7QomLG5coKF0/oijF;_o=cCoojNU=olg=?onNVRooKF<]oeaLG?n7
QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLodMW;_mXWS?oTLe7oj[YEOnA
cDOoJYhdodUZ;omLG5coQhN7okBd]?oBd];og]kN02_oh>3P04?og]kNomSHf?oBd];oe=CDomKFe_oB
d];oclo?om;Bd_oFe]Kodm?Com7AdOoEeMGoe]KFom3@d?o4a<Cobl_;olo?coo9bLWoa<C4omSHf?oE
eMGod=3@olC4a?o@d=3of=SHom;Bd_oAdM7of=SHom_KfooFe]KodM7AoiFEUOnPX:3o?Shnod];BooD
e=Cof=SHom;Bd_oAdM7of=SHomkNg_oPh>3ogmoOom[Jf_oCdm?odM7AomSHf?oMgMgof][Jom?Cdoo?
cloo`<30om3@d?o=cLgo_knoomCDe?oFe]KodM7AomCDe?oIfMWof=SHom7AdOoBd];of=SHomWIfOoC
dm?odM7A00;oemOG00SodM7Aolo?coo8b<Soa<C4omSHf?oKfm_og]kNomoOgfCoh>3P00?ogmoOon3P
h?oOgml00_oOgml3on3Ph003on7QhOoWinOok>c/007om?Cd00000oofm_Kol_;bon_[j`03onSXj00C
onOWiooRh^;ocLg=oinOWom[GeooScH^oneaHOoiWI3ooK6Uoofl[oom]:OonInConedHonB=booJemO
oinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWom^IUooTg8RongAA?oilgCooOf=
oogmUOomoHkonOQfongGAonCLb;oKVMOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=
oinOWomPJ5ooBg`Soi;QBonmnG_od?fBomSmVooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=cLgoh^;R
onOWi`0ZonSXj00YonKVi_oOgmoo<30`ohn?SooKfm_oalO7ohR8R?o5aLGofm_KojFUYOl10@7ogMgM
omkNg_m]KFgo20P8oa4A4OmcLg?o<30`ob@T9?oMgMgofm_Kod];Bol<30coHV9Ron7QhOm]KFgo>SXj
omoOgooShn?o`l?3o`000?o1`L7ohN7Qoj2PX?l=3@goemOGomkNg_mmOGgo5aLGomgMgOoTi>@00_oV
i^H05?oRh^;oOgmoobPX:?oOgmooiNGUon?Shonf][Ko7alOo`T92Olf=SKoM7Ado`P82?nFUYKogMgM
o`l?3onGUiOohN7QomoOgom2@T;oI6AT0_oPh>003?meMGGo<S8bomgMgOoKfm_o_[jnoc`l??l20P;o
7alOoaDE5Ond];Coi^KVonOWifgoj>SX0Oo/k>`1oo;blP7om_Kf00000oogmoOon?ShooShn003ooSh
n00CooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFoo^BQoonYY_oo[6UoonhZoon/jKooZRLoo^DROo^J5Wo
RC4[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_PK_onm8;o
o_j:ooooT_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^ko
c/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSoc_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[oi2@T?o>c/ko
k^k^ooOgm`0ZooShn00_ooKfm_o_knoo<c<coiVIVOoWinOoPh>3o`000?mlO7coj>SXok2`/?l10@7o
kNg]on?Shol61PKoXZ:RomgMgOmgMgOo0000olk>c_o`l?3o`/;2o`000?oAdM7om?Cdoo7alOmeMGGo
?Shnonk^k_obl_;od=3@o`000?o?cloolO7aolS8b?l0003o`l?3onk^k_n6QXKo6ATIonWYjOo_knoo
l_;booCdm?oalO7oR8R8ob/[:oo^k^h00_oemOD07?mTI6Co?cloonGUiOnc/k?o7alOofMWIoo_knoo
kNg]oa0@4?nRXZ;ol?3`ono_kom7AdOoJf][ono_koo`l?3oOWinocDe=Oo[jn_oj>SXocLg=om4A4Co
c/k>onOWiooMgMgoi>CTooGemOogmoMVooShn003ooOgmoohn?Son?Sh00;on?Sh00ComoOgooWinOog
moOomoOg0Oohn?P00003oo[jn_oemOGok^k^00;ok>c/0:Wojn_[onWYjOoOgmoo^[ZjogUBD_no<RCo
igAYoof9O_ooV8cooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<TogUBD_nj^[[ogmoOon[Zj_o[jn_o
k>c/on_[k?oZj^[ogmoOokZj^_n8IE;ohY4LooW3D?omfV?oonYbookcO_oonX;oo_Ioooo/LoongVCo
n/MAon:B7?n9IU?o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S7?nAdUGo
Y^MZokSiN_o0oX;oaon9ol?nQ?nioG_oYna/oiCFEomBYQcoDVeBokZj^_oOgmooj^[Zon_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/onWYjOoShn?o<30`oi2@T?oHf=Wo
;Bd]od10@?lS8b?of][JojJVY_l10@7ohN7Qon?Si?l@413oO7alomoOgond];Co0000om7AdOoTi>Co
V9RIo`l?3ooPh>3oinOWon?Shom_Kfoo>c/komoOgooQhN;o`l?3o`000?o5aLGoi>CTokno_ol0003o
^;Rhon7Qh_moOgoo5aLGomWIfOoMgMgohN7QonGUiOoTi>CoPH61obPX:?oOgmooi^KVonSXj?mdM7Co
7alOomWIfOoLg=go>c/kofm_KooTi>Coh>3Po`l?3onHV9SohN7QomoOh?m3@d?oIFEU00;oh>3P06oo
MgMgoc8b<_oPh>3o^;Rio`000?nXZ:Sog=cLomWIfOoKfm_ohN7QonWYjOoZj^_ok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>`01oo[jn/01Oo/k>cojn_[on_[joo^k^kom_Kf007onOWi0000
0ookno_olo?cong]k@02onGUi@2`onKVi_oTi>CofMWIok:b/_mi;Rkob48don=ZG?odNVgooHQloojG
R_onVhkooYR;ooj:O_odNfgoif]MolY2=?mk;Rko/[:bomSHf?oTi>CoiNGUonKVi_oUiNKoi>CTomSH
f?nb/[;oUUD^onZL:ook_4Coo/aCoogHH_onhg;oo^UeookVLoonffGooLaCoo_1AOo^WR_oVEH^ok:b
/_oHf=Soi>CTonGUiOoVi^KoiNGUonCTi?oHf=Wo/[:bobiR;_mS[B_oQlY8oiOLFOnUiFWo/_=gokSf
NondmGWoYnY[oiSLFOn9cd_oHjh[obiS;_nb/[;of=SIonCTi?oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oShn?ogMgMobl_;on;Rh_o/K6bo`000?ng]kOo9BDUojRX
Z?nPX:3o0@41omcLg?oPh>7o/[:bocTi>OlU9BGo>c/ko`000?o=cLgogMgMoi>CU?l@413oe]KFomkN
g_oLg=coK6a/ocTi>OoDe=Coe]KGokbl_?l0003o`/;2omoOgonk^k_o0000okBd]?oLg=coO7aloaLG
5ooFe]Kof][JomkNg_oPh>3ogmoOogemO_lW9bOoeMGEomcLg?oNg]kofm_KofATI?lP823o?3`loa<C
4om]KFgoh>3PomcLg?l?3`ooTi>ComOGeooEeMKo@D51of9RH_oGemOoe]KFog=cLola<C7ogMgMoiZJ
Vol00004ocLg=`1Wok:b/_oTi>Coi>CUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUi@02onKViP03onGUiOoVi^Koi^KV00?oi^KV00?oiNGUong]kOodm?@00Ookno/00003ooclo?oh
n?SolO7a00?ok^k^01?ojn_[on7QhOnl_;coNQLGol<o<_oCETWoi6QJonmgK?odPgWon8MlooF4N_oc
NFgoiFUKomUHB_o4?c;oO1LGokbl_?oQhN7ok>c/00?ok^k^01?ok>c/on7QhOnl_;coYDLGonJG<_oe
[33ooKa1oog9Doomd63onm=UoogBH?oncECooKe2ooZ_<_oYVc;oYDHGokbl_?oQhN7ok>c/00?ok^k^
01?ok>c/on7QhOnl_;co5eTGoenX<_mf_COoQ/e7oiKFF_nRh6GoXn1Yoj?QIonGfUcoQ/i7ogNo=omO
Zc;o5eTGokbl_?oQhN7ok>c/02[ok^k^02Ook>c/onGUiOla<C7oShn?ofi^K_l/;2coj>SXogemOOmN
GUkoY:BTo`410OoShn?ojNWYonKVi_oRh^;oh>3Pojf][Ol0003oemOGonCTi?nHV9So410@omgMgOoS
hn?oi>CTog1`L?lT92Coe]KFomoOgono_koo0000ol_;booYjNWo`L71o`000?nj^[[oi>CToh61POl6
1PH00oln?Sh08_o;bl_ojNWYohB4Q?lJ6Q[of][Jon;Rh_oUiNGoinOWon?ShooPh>3of=SHocLg=omb
LW;oj^[ZonOWiol?3`ooRXZ:omoOgooNg]ko@d=3oeIFE_oPh>3ogmoOogMgMolc<c?ojNWYokjn__l0
003oX:2PokJf]_nZZZ[o0P82omWIfOo]kNe]onk^kP03ong]kOobl_;on?Sh007oo?cl0003oogmo@0F
ooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@@ooJHUGohfiRonAbI?oTKf;og6AG
om=A@oo<@CCo^C@dof/71ooBd];olo?cooclo0?ooOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWo
mJPYooRd?ooi_D[on;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?oo?cl00?ooOgm01?o
o?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:cE3oSLeBoh[>D?n1adCoLKT_of:^8?m>VcCo
1d87om;Bd_oclo?oo?cl02[ooOgm04cono_kooCdm?ld=3CoUiNGoalO7on7QhOon_[jomgMgOlC4a?o
ZJVYo`410Oobl_;onOWiol30`?o4a<Colo?cohb<S?lQ8B7on_[jooGemOnMWIgo410@onKVi_o^k^ko
m?CdogQhN?lA4A7oC4a<ol[:b_n9RHWo51@DooKfm_oinOWoc/k>o`000?o6a/Kolo?cohV9ROlC4a?o
][JfokVi^Onj^[[okNg]ooWinOn?Shoo30`<oeMGEooAdM7okNg]onc/k?nVYZKoi^KVonCTi?lB4Q;o
[Jf]oo_knoojn_[o410@oahN7_nUYJGog=cLoaXJ6_lP823oOGemomkNg_m7AdOoGemOoo_knoojn_[o
=3@dog5aLOo^k^koSXj>ocDe=Ookno_oo?clJoomoOd00oolo?cooOgmooclo003oogmo@0003[ooOgm
oo[jn_oclo?ok^k^oo3`l?o_knook^k^onWYjOoCdm?oFadMoj8d=?nd:1go`CX]olM9??o?ET[od5M;
om1GB_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_onk^k_oZj^[odm?C
oh`U7Oo8LCCofH@MonBD5OoWWBCokZPcoo2Z=?o_ZS?ok:0UonNG5OoLR1gob74doh`U7OoCdm?oj^[Z
onk^k_o`l?3okno_oo3`l?o^k^koj^[Yom?CdolM>1go=88dodNE7OmJYA_oJJdZ0_md^3P0OOme^CSo
Jk4[oe^W7?m8VQgo=88doadh7OoCdm?oj^[Yonk^k_o`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo^k^koinOWoc4a<OmOGeoo0@41om;Bd_o^k^kok>c/od51@OmQHF7o
0@41onKVi_o^k^goX:2PocTi>OlA4A7o9RHVoiRHV?o_knooaLG5oa0@4?l10@7o6ATIoe9BD_oYjNWo
LG5aocdm?OnGUiOo7alOoaPH6?nATI7ok^k^ong]kOo3`l?o0000okbl_?oXj>OoPX:2oaPH6?oOgmoo
h^;Ron?ShooWinOojn_[oi>CT_lo?cooTY:BoaLG5onDU9Coh>3Podm?ColO7aoo4A4Aodm?CooXj>So
k^k^ono_kolW9bOoX:2Podi>C_l92@Wo=SHfon3Ph?m^KVko3`l?ob`/;?nn_[kok^k^ono_k_oBd];o
?3`lo`/;2olM7Ago/[:b00;okno_06Kol?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knl2oo3`l0Kokno_0Ooclo<1ooWin@7oo_kn00000oono_komoOgoo3`l004onWYj@0A
onOWiooKfm_oHd];oh4b<_nV=CGo]S@]ol9=@Oo3E4Woa5E:ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];
om_KfooWinL01OoYjNT04OoWinOofm_KohU;Bon_Bc;ocGLeomJ;;OoPW2koh:0bon6P=?oPX3;ogiX^
omJ;;Oo:MCGo[d/bohU;BooKfm_oinOW00GojNWY017oinOWom_Kfom;Bd_o<V0bocZ9=OmCVbgoJj/_
og2]>?m_[S[oL:dhofZZ;omCVbgo>HPeoc9P<_m;Bd_ofm_KonOWi`0[onWYj@0=onSXj?oTi>Co<30`
oa8B4_ll?3coi^KVonSXj?oWinOoTi>Coa4A4Ol10@7ohn?SonOWi`02onWYj@03onOWiooYjNWojNWY
00;oj>SX01CoWIfMoa0@4?oWinOoinOWonCTi?m_Kfoo>c/kon?ShooWinOoj>SXonWYjOoXj>SoinOW
ol;2`_l0003o^[ZjonCTi?n0P83o5aLGomgMg@;og]kN00?ohN7QonKVi_oXj>P00_oYjNT00ooXj>So
inOWonWYj@02onWYj@03onOWiooYjNWojNWY00GojNWY00Goj>SXonWYjOoYjNWojNWYonOWi`06onWY
j@03onKVi_oYjNWojNWY06WojNWY00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07omoOg0Oono_h00005
ookno_ojn_[om?Cdono_kooalO400_o`l?004Oo_knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbL
omZNW?oIW9coe9FEok]cLonEE5CoCb<SoiFDU?oZj^[okno_00Gol?3`017okno_on[Zj_nYU9CoPB<S
okYZE?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S8onZU9Coj^[Zono_k`05oo3`l00A
ono_kooZj^[oU9BDob<Z8omDNUCoLjEcoik6UOn/cYco[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BD
on[Zj_o_knl0:oo`l?001Oo_knook^k^oc8b<_l0003oTi>C00?okno_00Goi>CTo`/;2ol10@7ok^k^
ono_k`07oo3`l009on?Shono_kookno_ono_koo^k^koM7Adocdm?Oo]kNgokno_00?ol?3`00Ookno_
ol[:b_l0003o`l?3onk^k_n6QXKo2@T900?oGUiN00?oNGUionk^k_o_knl0Roo`l?001?oalO7ol?3`
ooCdm?ojn_X1ooknoP0000CooOgmooooooooooooo_kn0_ooool2ooknoP1^oogmoOohn?SoKVi^oeXo
?onaT93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSloofe]KOohn?Soo?clooooooono_koooooookn
o_ooookoo_knooooooolo?con?Shohe]KOn:?coobI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo
?on=KFgon?Sgooclo?ooooooo_knooooooono_koooooookno_ooookoo?clooShn?m]KFgo?clooi2M
T?o9eLWoi>cTonK^i_oTk>CobMG9oi2MT?lo?cooKFe]ooShn?olo?coooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooooOgmojn_[onHV9SolO7`oogm
oOooool2ooknoP0FokBd]?nJVY[ooOgmooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_oooooooOgmookno_mlO7co@D51oogmoOono_goo_knooooo`;oo_kn09?ok^k^oiVIVOo[jn_o
o_kmom7AdOnIVIWoV9RHoiVIVOnHV9So[:b/oogmoOooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_h00_ooool00oono_koooooooooo`03oooo
o`7ooOgm00001?ohn?Soo_knoo[jn_odm?@5oo7al@0=ono_kooFe]KoJf][od<m?OnKS8coa[ZjomK<
c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7al@0=ono_kooGe]KoPf][og@m?OneS8coeKZjon7<
c?oF^[[o]Xb<og8m?On1Jf_oemKFono_k`09oo7al@0=ono_kooFe]KoJf][ocdm?On<S8co^[Zjolc=
c?nj^[[oS8b<ocdm?Om[Jf_oe]KFono_k`16oo7al@03onk^k_o]kNgolO7a09GolO7a00Col?3`oo7a
lOoalO7ol?3`1?oalO400oodm?Con_[jooknoP01ooOgm`0000Gojn_[oogmoOohn?Sol?3`on_[j`03
on[ZjP0=onWYjOoZj^[ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0;
on[ZjP0;onWYjOoXj>SoX9^KofYIFOm39RKo;@T9od8V9_mYFEWoX9^KonSXj?oYjNT02ooZj^X02ooY
jNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY0>Koj^[Z00Cojn_[oo3`l?oh
n?SooOgm0Oo/k>`00004olK6a_ono_kon_[jooCdm0SolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`
l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l>ColO7a00?ol?3`oo7alOoalO400_oalO400ooe
mOGon_[jooknoP01olK6aP0000?oa/K6ol?3`oojn_X0oooooolWooooo`7onOWi0Oo4a<@1olK6aP00
00Kofm_Kokno_one]KGoinOWooOgmoolo?coooooob7ooooo00GooOgmooOgmooWinOo]KFeokno_`01
om[JfP00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{300, 263},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleJComboBox",
        ButtonData:>{"SimpleJComboBox.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SimpleJComboBox[]\)], "Input"],

Cell[BoxData[
    \("Imaginary Day 4"\)], "Print"],

Cell[BoxData[
    \("Imaginary Day 2"\)], "Print"],

Cell[BoxData[
    \("Imaginary Day 7"\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JTable <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?nIVIWoVIVINYVIV@:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;SBoooo00>IVIWoooooool0d?ooo`03VIVIoooo
oooo0<ooool019VIVHS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2hd_oo
o`03VIVIoooooooo0=3oool00iVIVOooooooo`3?oooo00BIVIV8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^=;oool00iVIVOooooooo`3@oooo00>I
VIWoooooool0coooo`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;P2oooo00<0003oooooool01Oooo`<00004oooo0`0000Coool2000000?o
ool0003oool01oooo`030000oooooooo00?oool00`000?ooooooo`2Uoooo
00BIVIWoooooool00007oooo0`0000Coool300001?ooo`8000000oooo`00
0?ooo`07oooo00@0003oooooooooool50000YOooo`04VIVIoooooooo0000
1oooo`<00004oooo0`0000Coool2000000?oool0003oool01oooo`030000
oooooooo00;oool30000YOooo`04VIVIR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;P2oooo00<0003oooooool01?ooo`050000oooooooooooo0000
00;oool01@000?ooooooooooo`000002oooo00<0003oooooool00P0000So
ool00`000?ooooooo`03oooo00<0003oooooool0YOooo`04VIVIoooooooo
00001_ooo`050000oooooooooooo000000;oool01@000?ooooooooooo`00
0002oooo00<0003oooooool00P0000Soool00`000?ooooooo`02oooo00<0
003oooooool0Y_ooo`04VIVIoooooooo00001_ooo`050000oooooooooooo
000000;oool01@000?ooooooooooo`000002oooo00<0003oooooool00P00
00Soool01@000?ooooooooooo`000003oooo00<0003oooooool0X_ooo`04
VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P2oooo00<0003ooooo
ool01?ooo`050000oooooooooooo000000;oool01@000?ooooooooooo`00
0002oooo00D0003oooooooooool000001Oooo`D00004oooo00<0003ooooo
ool0YOooo`04VIVIoooooooo00001_ooo`050000oooooooooooo000000;o
ool01@000?ooooooooooo`000002oooo00D0003oooooooooool000001Ooo
o`D00004oooo00<0003oooooool0YOooo`04VIVIoooooooo00001_ooo`05
0000oooooooooooo000000;oool01@000?ooooooooooo`000002oooo00D0
003oooooooooool000001Oooo`D00006oooo00<0003oooooool0X_ooo`04
VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P2oooo00<0003ooooo
ool01?ooo`050000oooooooooooo000000;oool01@000?ooooooooooo`00
0002oooo00D0003oooooooooool000001Oooo`040000oooooooo00001Ooo
o`030000oooooooo0:Goool019VIVOooooooo`0000Koool01@000?oooooo
ooooo`000002oooo00D0003oooooooooool000000_ooo`050000oooooooo
oooo000000Goool010000?ooooooo`0000Koool00`000?ooooooo`2Toooo
00BIVIWoooooool00006oooo00D0003oooooooooool000000_ooo`050000
oooooooooooo000000;oool01@000?ooooooooooo`000005oooo00@0003o
ooooool00007oooo00<0003oooooool0X_ooo`04VIVIR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P2oooo100000?oool01@000?ooooooooooo`00
0002oooo00D0003oooooooooool000000_ooo`050000oooooooooooo0000
00Koool00`000?ooo`000005oooo00<0003oooooool0YOooo`03VIVIoooo
oooo00@00003oooo00D0003oooooooooool000000_ooo`050000oooooooo
oooo000000;oool01@000?ooooooooooo`000006oooo00<0003oool00000
1_ooo`030000oooooooo0:Coool00iVIVOooooooo`0400000oooo`050000
oooooooooooo000000;oool01@000?ooooooooooo`000002oooo00D0003o
ooooooooool000001_ooo`030000oooo000000Goool20000YOooo`04VIVI
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P2oooo00<0003oooooool0
1?ooo`050000oooooooooooo000000;oool01@000?ooooooooooo`000002
oooo00<0003oooooool00P0000Koool00`000?ooo`000005oooo00<0003o
ooooool0YOooo`04VIVIoooooooo00001_ooo`050000oooooooooooo0000
00;oool01@000?ooooooooooo`000002oooo00<0003oooooool00P0000Ko
ool00`000?ooo`000007oooo00<0003oooooool0Xoooo`04VIVIoooooooo
00001_ooo`050000oooooooooooo000000;oool01@000?ooooooooooo`00
0002oooo00<0003oooooool00P0000Koool00`000?ooo`000007oooo00<0
003oooooool0X_ooo`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;P2oooo00<0003oooooool01Oooo`<00004oooo0`0000Coool2000000?o
ool0003oool01_ooo`800003oooo00<0003oool00000Yoooo`04VIVIoooo
oooo00001oooo`<00004oooo0`0000Coool2000000?oool0003oool01_oo
o`800007oooo00<0003oooooool0Xoooo`04VIVIoooooooo00001oooo`<0
0004oooo0`0000Coool2000000?oool0003oool01_ooo`800007oooo00<0
003oooooool0X_ooo`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;P2oooo00<0003oooooool05_ooo`030000oooooooo00Goool200001?oo
o`80002Woooo00BIVIWoooooool0000Hoooo00<0003oooooool01Oooo`80
0003oooo00D0003oooooooooool00000YOooo`04VIVIoooooooo00006?oo
o`030000oooooooo00Goool200000oooo`050000oooooooooooo00000:Co
ool019VIVHS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h0_ooo`D0000D
oooo00<0003oooooool01_ooo`030000oooooooo00?oool00`000?oooooo
o`2Uoooo00>IVIWoooooool01@0001Coool00`000?ooooooo`06oooo00<0
003oooooool00_ooo`<0002Voooo00>IVIWoooooool01@0001Coool00`00
0?ooooooo`06oooo00<0003oooooool00_ooo`<0002Uoooo00BIVIV8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^=;oool00iVIVOooooooo`3@oooo
00>IVIWoooooool0coooo`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8
`;R8`;SBoooo00>IVIWoooooool0d?ooo`03VIVIoooooooo0<ooool019VI
VHS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2hd_ooo`03VIVIoooooooo
0=3oool00iVIVOooooooo`3?oooo00BIVIV8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^?nIVIWoVIVINYVIV@:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;SBoooo00>IVIWoooooool0d?ooo`03VIVIoooooooo0<ooool019VI
VHS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2hd_ooo`03VIVIoooooooo
0=3oool00iVIVOooooooo`3?oooo00BIVIV8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^=;oool00iVIVOooooooo`3@oooo00>IVIWoooooool0cooo
o`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P2oooo00<0003o
ooooool01Oooo`<00004oooo0`0000Coool2000000?oool0003oool01Ooo
o`<00005oooo00<0003oooooool0YOooo`04VIVIoooooooo00001oooo`<0
0004oooo0`0000Coool2000000?oool0003oool01Oooo`<00003oooo1@00
0:Goool019VIVOooooooo`0000Ooool300001?ooo`<00004oooo0P000003
oooo0000oooo00Goool300001?ooo`<0002Uoooo00BIVIV8`;R8`;Q8T8P1
0000000018S0^<SPf8S0^8S0^0;oool00`000?ooooooo`04oooo00D0003o
ooooooooool000000_ooo`050000oooooooooooo000000;oool00`000?oo
ooooo`0200001Oooo`050000oooooooooooo000000Coool00`000?oooooo
o`2Uoooo00BIVIWoooooool00006oooo00D0003oooooooooool000000_oo
o`050000oooooooooooo000000;oool00`000?ooooooo`0200001Oooo`05
0000oooooooooooo000000?oool00`000?ooooooo`2Voooo00BIVIWooooo
ool00006oooo00D0003oooooooooool000000_ooo`050000oooooooooooo
000000;oool00`000?ooooooo`0200001Oooo`050000oooooooooooo0000
00;oool01@000?ooooooooooo`00002Toooo00BIVIV8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^0;oool00`000?ooooooo`04oooo00D0003ooooo
ooooool000000_ooo`050000oooooooooooo000000;oool01@000?oooooo
ooooo`000009oooo00<0003oooooool00_ooo`030000oooooooo0:Goool0
19VIVOooooooo`0000Koool01@000?ooooooooooo`000002oooo00D0003o
ooooooooool000000_ooo`050000oooooooooooo000000Woool00`000?oo
ooooo`02oooo00<0003oooooool0YOooo`04VIVIoooooooo00001_ooo`05
0000oooooooooooo000000;oool01@000?ooooooooooo`000002oooo00D0
003oooooooooool000002Oooo`030000oooooooo00Coool00`000?oooooo
o`2Roooo00BIVIV8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0;oool0
0`000?ooooooo`04oooo00D0003oooooooooool000000_ooo`050000oooo
oooooooo000000;oool01@000?ooooooooooo`000009oooo00<0003ooooo
ool00_ooo`030000oooooooo0:Goool019VIVOooooooo`0000Koool01@00
0?ooooooooooo`000002oooo00D0003oooooooooool000000_ooo`050000
oooooooooooo000000Woool00`000?ooooooo`03oooo00<0003oooooool0
Y?ooo`04VIVIoooooooo00001_ooo`050000oooooooooooo000000;oool0
1@000?ooooooooooo`000002oooo00D0003oooooooooool000002Oooo`03
0000oooooooo00Coool00`000?ooooooo`2Roooo00BIVIV8`;R8`;Q8T8P1
0000000018S0^<SPf8S0^8S0^0;oool400000oooo`050000oooooooooooo
000000;oool01@000?ooooooooooo`000002oooo00D0003oooooooooool0
00001oooo`800005oooo00<0003oooooool0YOooo`03VIVIoooooooo00@0
0003oooo00D0003oooooooooool000000_ooo`050000oooooooooooo0000
00;oool01@000?ooooooooooo`000007oooo0P0000Koool00`000?oooooo
o`2Toooo00>IVIWoooooool0100000?oool01@000?ooooooooooo`000002
oooo00D0003oooooooooool000000_ooo`050000oooooooooooo000000Oo
ool200001Oooo`80002Uoooo00BIVIV8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^0;oool00`000?ooooooo`04oooo00D0003oooooooooool00000
0_ooo`050000oooooooooooo000000;oool00`000?ooooooo`0200002Ooo
o`030000oooooooo00;oool00`000?ooooooo`2Uoooo00BIVIWoooooool0
0006oooo00D0003oooooooooool000000_ooo`050000oooooooooooo0000
00;oool00`000?ooooooo`0200002Oooo`030000oooooooo00Coool00`00
0?ooooooo`2Soooo00BIVIWoooooool00006oooo00D0003oooooooooool0
00000_ooo`050000oooooooooooo000000;oool00`000?ooooooo`020000
2Oooo`030000oooooooo00Coool00`000?ooooooo`2Roooo00BIVIV8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^0;oool00`000?ooooooo`05oooo
0`0000Coool300001?ooo`8000000oooo`000?ooo`08oooo00H0003ooooo
ool0003oool0002Woooo00BIVIWoooooool00007oooo0`0000Coool30000
1?ooo`8000000oooo`000?ooo`08oooo00<0003oooooool01?ooo`030000
oooooooo0:?oool019VIVOooooooo`0000Ooool300001?ooo`<00004oooo
0P000003oooo0000oooo00Soool00`000?ooooooo`04oooo00<0003ooooo
ool0X_ooo`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P2oooo
00<0003oooooool05_ooo`030000oooooooo00?oool01@000?oooooooooo
o`000003oooo0P000:Ooool019VIVOooooooo`0001Soool00`000?oooooo
o`03oooo00D0003oooooooooool000000_ooo`050000oooooooooooo0000
0:Goool019VIVOooooooo`0001Soool00`000?ooooooo`03oooo00D0003o
ooooooooool000000_ooo`050000oooooooooooo00000:Coool019VIVHS0
^8S0^4R@R04000000004R<2hb>3HR<2hR<2h0_ooo`D0000Doooo00<0003o
ooooool01?ooo`<00005oooo00<0003oooooool0YOooo`03VIVIoooooooo
00D0000Doooo00<0003oooooool01?ooo`<00004oooo0`000:Koool00iVI
VOooooooo`0500005?ooo`030000oooooooo00Coool300001?ooo`<0002U
oooo00BIVIV8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^=;oool00iVI
VOooooooo`3@oooo00>IVIWoooooool0coooo`04VIVIR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;SBoooo00>IVIWoooooool0d?ooo`03VIVIoooo
oooo0<ooool019VIVHS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2hd_oo
o`03VIVIoooooooo0=3oool00iVIVOooooooo`3?oooo00BIVIV8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^?nIVIWoVIVINYVIV@:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;SBoooo00>IVIWoooooool0d?ooo`03VIVIoooo
oooo0<ooool019VIVHS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2hd_oo
o`03VIVIoooooooo0=3oool00iVIVOooooooo`3?oooo00BIVIV8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^=;oool00iVIVOooooooo`3@oooo00>I
VIWoooooool0coooo`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;P2oooo00<0003oooooool01Oooo`<00004oooo0`0000Coool2000000?o
ool0003oool01?ooo`D00004oooo00<0003oooooool0YOooo`04VIVIoooo
oooo00001oooo`<00004oooo0`0000Coool2000000?oool0003oool01?oo
o`D00002oooo1@000:Goool019VIVOooooooo`0000Ooool300001?ooo`<0
0004oooo0P000003oooo0000oooo00Coool500000oooo`<0002Uoooo00BI
VIV8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0;oool00`000?oooooo
o`04oooo00D0003oooooooooool000000_ooo`050000oooooooooooo0000
00;oool00`000?ooooooo`0200001_ooo`030000oooooooo00Goool00`00
0?ooooooo`2Uoooo00BIVIWoooooool00006oooo00D0003oooooooooool0
00000_ooo`050000oooooooooooo000000;oool00`000?ooooooo`020000
1_ooo`030000oooooooo00Coool00`000?ooooooo`2Voooo00BIVIWooooo
ool00006oooo00D0003oooooooooool000000_ooo`050000oooooooooooo
000000;oool00`000?ooooooo`0200001_ooo`030000oooooooo00?oool0
1@000?ooooooooooo`00002Toooo00BIVIV8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^0;oool00`000?ooooooo`04oooo00D0003oooooooooool0
00000_ooo`050000oooooooooooo000000;oool01@000?ooooooooooo`00
0007oooo00<0003oooooool01?ooo`030000oooooooo0:Goool019VIVOoo
ooooo`0000Koool01@000?ooooooooooo`000002oooo00D0003ooooooooo
ool000000_ooo`050000oooooooooooo000000Ooool00`000?ooooooo`04
oooo00<0003oooooool0YOooo`04VIVIoooooooo00001_ooo`050000oooo
oooooooo000000;oool01@000?ooooooooooo`000002oooo00D0003ooooo
ooooool000001oooo`030000oooooooo00Koool00`000?ooooooo`2Roooo
00BIVIV8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0;oool00`000?oo
ooooo`04oooo00D0003oooooooooool000000_ooo`050000oooooooooooo
000000;oool01@000?ooooooooooo`000008oooo00<0003oooooool00ooo
o`030000oooooooo0:Goool019VIVOooooooo`0000Koool01@000?oooooo
ooooo`000002oooo00D0003oooooooooool000000_ooo`050000oooooooo
oooo000000Soool00`000?ooooooo`04oooo00<0003oooooool0Y?ooo`04
VIVIoooooooo00001_ooo`050000oooooooooooo000000;oool01@000?oo
ooooooooo`000002oooo00D0003oooooooooool000002?ooo`030000oooo
oooo00Goool00`000?ooooooo`2Roooo00BIVIV8`;R8`;Q8T8P100000000
18S0^<SPf8S0^8S0^0;oool400000oooo`050000oooooooooooo000000;o
ool01@000?ooooooooooo`000002oooo00D0003oooooooooool000002?oo
o`030000oooooooo00?oool00`000?ooooooo`2Uoooo00>IVIWoooooool0
100000?oool01@000?ooooooooooo`000002oooo00D0003oooooooooool0
00000_ooo`050000oooooooooooo000000Soool00`000?ooooooo`04oooo
00<0003oooooool0Y?ooo`03VIVIoooooooo00@00003oooo00D0003ooooo
ooooool000000_ooo`050000oooooooooooo000000;oool01@000?oooooo
ooooo`000008oooo00<0003oooooool00oooo`80002Uoooo00BIVIV8`;R8
`;Q8T8P10000000018S0^<SPf8S0^8S0^0;oool00`000?ooooooo`04oooo
00D0003oooooooooool000000_ooo`050000oooooooooooo000000;oool0
0`000?ooooooo`0200002Oooo`030000oooooooo00;oool00`000?oooooo
o`2Uoooo00BIVIWoooooool00006oooo00D0003oooooooooool000000_oo
o`050000oooooooooooo000000;oool00`000?ooooooo`0200002Oooo`03
0000oooooooo00Coool00`000?ooooooo`2Soooo00BIVIWoooooool00006
oooo00D0003oooooooooool000000_ooo`050000oooooooooooo000000;o
ool00`000?ooooooo`0200002Oooo`030000oooooooo00Coool00`000?oo
ooooo`2Roooo00BIVIV8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0;o
ool00`000?ooooooo`05oooo0`0000Coool300001?ooo`8000000oooo`00
0?ooo`08oooo00H0003oooooool0003oool0002Woooo00BIVIWoooooool0
0007oooo0`0000Coool300001?ooo`8000000oooo`000?ooo`08oooo00<0
003oooooool01?ooo`030000oooooooo0:?oool019VIVOooooooo`0000Oo
ool300001?ooo`<00004oooo0P000003oooo0000oooo00Soool00`000?oo
ooooo`04oooo00<0003oooooool0X_ooo`04VIVIR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P2oooo00<0003oooooool05_ooo`030000oooooooo
00?oool01@000?ooooooooooo`000003oooo0P000:Ooool019VIVOoooooo
o`0001Soool00`000?ooooooo`03oooo00D0003oooooooooool000000_oo
o`050000oooooooooooo00000:Goool019VIVOooooooo`0001Soool00`00
0?ooooooo`03oooo00D0003oooooooooool000000_ooo`050000oooooooo
oooo00000:Coool019VIVHS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h
0_ooo`D0000Doooo00<0003oooooool01?ooo`<00005oooo00<0003ooooo
ool0YOooo`03VIVIoooooooo00D0000Doooo00<0003oooooool01?ooo`<0
0004oooo0`000:Koool00iVIVOooooooo`0500005?ooo`030000oooooooo
00Coool300001?ooo`<0002Uoooo00BIVIV8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^=;oool00iVIVOooooooo`3@oooo00>IVIWoooooool0cooo
o`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;SBoooo00>IVIWo
ooooool0d?ooo`03VIVIoooooooo0<ooool019VIVHS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2hd_ooo`03VIVIoooooooo0=3oool00iVIVOoooooo
o`3?oooo00BIVIV8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?nIVIWo
VIVINYVIV@:8`;P1B9280@00000000B8`;S8h=R8`;R8`;SBoooo00>IVIWo
ooooool0d?ooo`03VIVIoooooooo0<ooool019VIVHS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2hd_ooo`03VIVIoooooooo0=3oool00iVIVOoooooo
o`3?oooo00BIVIV8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^=;oool0
0iVIVOooooooo`3@oooo00>IVIWoooooool0coooo`04VIVIR<2hR<2hB928
0@00000000B8`;S8h=R8`;R8`;P2oooo00<0003oooooool01Oooo`<00004
oooo0`0000Coool2000000?oool0003oool01_ooo`030000oooooooo00Co
ool00`000?ooooooo`2Uoooo00BIVIWoooooool00007oooo0`0000Coool3
00001?ooo`8000000oooo`000?ooo`06oooo00<0003oooooool00_ooo`D0
002Uoooo00BIVIWoooooool00007oooo0`0000Coool300001?ooo`800000
0oooo`000?ooo`06oooo00<0003oooooool00oooo`<0002Uoooo00BIVIV8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0;oool00`000?ooooooo`04
oooo00D0003oooooooooool000000_ooo`050000oooooooooooo000000;o
ool00`000?ooooooo`0200001oooo`030000oooooooo00Coool00`000?oo
ooooo`2Uoooo00BIVIWoooooool00006oooo00D0003oooooooooool00000
0_ooo`050000oooooooooooo000000;oool00`000?ooooooo`0200001ooo
o`030000oooooooo00?oool00`000?ooooooo`2Voooo00BIVIWoooooool0
0006oooo00D0003oooooooooool000000_ooo`050000oooooooooooo0000
00;oool00`000?ooooooo`0200001oooo`030000oooooooo00;oool01@00
0?ooooooooooo`00002Toooo00BIVIV8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^0;oool00`000?ooooooo`04oooo00D0003oooooooooool00000
0_ooo`050000oooooooooooo000000;oool01@000?ooooooooooo`000007
oooo00<0003oooooool01?ooo`030000oooooooo0:Goool019VIVOoooooo
o`0000Koool01@000?ooooooooooo`000002oooo00D0003oooooooooool0
00000_ooo`050000oooooooooooo000000Ooool00`000?ooooooo`04oooo
00<0003oooooool0YOooo`04VIVIoooooooo00001_ooo`050000oooooooo
oooo000000;oool01@000?ooooooooooo`000002oooo00D0003ooooooooo
ool000001oooo`030000oooooooo00Koool00`000?ooooooo`2Roooo00BI
VIV8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0;oool00`000?oooooo
o`04oooo00D0003oooooooooool000000_ooo`050000oooooooooooo0000
00;oool01@000?ooooooooooo`000007oooo00<0003oooooool01?ooo`03
0000oooooooo0:Goool019VIVOooooooo`0000Koool01@000?oooooooooo
o`000002oooo00D0003oooooooooool000000_ooo`050000oooooooooooo
000000Ooool00`000?ooooooo`05oooo00<0003oooooool0Y?ooo`04VIVI
oooooooo00001_ooo`050000oooooooooooo000000;oool01@000?oooooo
ooooo`000002oooo00D0003oooooooooool000001oooo`030000oooooooo
00Koool00`000?ooooooo`2Roooo00BIVIV8`;R8`;Q8T8P10000000018S0
^<SPf8S0^8S0^0;oool400000oooo`050000oooooooooooo000000;oool0
1@000?ooooooooooo`000002oooo00D0003oooooooooool000001oooo`03
0000oooooooo00Coool00`000?ooooooo`2Uoooo00>IVIWoooooool01000
00?oool01@000?ooooooooooo`000002oooo00D0003oooooooooool00000
0_ooo`050000oooooooooooo000000Ooool00`000?ooooooo`05oooo00<0
003oooooool0Y?ooo`03VIVIoooooooo00@00003oooo00D0003ooooooooo
ool000000_ooo`050000oooooooooooo000000;oool01@000?oooooooooo
o`000007oooo00<0003oooooool01?ooo`80002Uoooo00BIVIV8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^0;oool00`000?ooooooo`04oooo00D0
003oooooooooool000000_ooo`050000oooooooooooo000000;oool00`00
0?ooooooo`0200001oooo`030000oooooooo00Coool00`000?ooooooo`2U
oooo00BIVIWoooooool00006oooo00D0003oooooooooool000000_ooo`05
0000oooooooooooo000000;oool00`000?ooooooo`0200001oooo`030000
oooooooo00Koool00`000?ooooooo`2Soooo00BIVIWoooooool00006oooo
00D0003oooooooooool000000_ooo`050000oooooooooooo000000;oool0
0`000?ooooooo`0200001oooo`030000oooooooo00Koool00`000?oooooo
o`2Roooo00BIVIV8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0;oool0
0`000?ooooooo`05oooo0`0000Coool300001?ooo`8000000oooo`000?oo
o`04oooo00<0003oool000001?ooo`030000oooo00000:Ooool019VIVOoo
ooooo`0000Ooool300001?ooo`<00004oooo0P000003oooo0000oooo00Co
ool00`000?ooo`000008oooo00<0003oooooool0Xoooo`04VIVIoooooooo
00001oooo`<00004oooo0`0000Coool2000000?oool0003oool01?ooo`03
0000oooo000000Soool00`000?ooooooo`2Roooo00BIVIV8`;R8`;Q8T8P1
0000000018S0^<SPf8S0^8S0^0;oool00`000?ooooooo`0Foooo00<0003o
ooooool01?ooo`800005oooo0P000:Ooool019VIVOooooooo`0001Soool0
0`000?ooooooo`04oooo0P0000Coool01@000?ooooooooooo`00002Uoooo
00BIVIWoooooool0000Hoooo00<0003oooooool01?ooo`800004oooo00D0
003oooooooooool00000Y?ooo`04VIVIR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;P2oooo1@0001Coool00`000?ooooooo`05oooo00<0003ooooo
ool01?ooo`030000oooooooo0:Goool00iVIVOooooooo`0500005?ooo`03
0000oooooooo00Goool00`000?ooooooo`03oooo0`000:Koool00iVIVOoo
ooooo`0500005?ooo`030000oooooooo00Goool00`000?ooooooo`03oooo
0`000:Goool019VIVHS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2hd_oo
o`03VIVIoooooooo0=3oool00iVIVOooooooo`3?oooo00BIVIV8`;R8`;Q8
T8P10000000018S0^<SPf8S0^8S0^=;oool00iVIVOooooooo`3@oooo00>I
VIWoooooool0coooo`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;SBoooo00>IVIWoooooool0d?ooo`03VIVIoooooooo0<ooool019VIVHS0
^8S0^4R@R04000000005R<2hb>3HR<2hR<2hc<c<0=5VIVH2c<c<dFIVIP;<
c<c@IVIV00C<c<b8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3@
c<c<00=VIVK<c<coool0OLc<c0@0001?c<c<00=VIVK<c<coool0clc<c005
IVIVc<c<R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hoooo0=3<c<`0
0fIVI/c<c?ooo`21c<c<00<0003<c<c<c<`0C<c<c003IVIVc<c<oooo0<o<
c<`01FIVI/c<c8S0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^?ooo`18
c<c<00<0003<c<c<c<`00lc<c0040000c<c<c<c<c<c<0`0000?<c<`01000
0<c<c000000000C<c<`300000lc<c0030000c<c<c<c<00K<c<`2000000G<
c<`0003<c<c<c<`000000lc<c0040000c<c<c<c<c<c<0P000003c<c<0000
c<c<00;<c<`2000000?<c<`0003<c<`0Alc<c003IVIVc<c<oooo04o<c<`0
0`000<c<c<c<c003c<c<00@0003<c<c<c<c<c<`300000lc<c0040000c<c<
000000001<c<c0<00003c<c<1@0000G<c<`300001<c<c08000000lc<c000
0<c<c01=c<c<00=VIVK<c<coool0C/c<c0030000c<c<c<c<00?<c<`01000
0<c<c<c<c<c<c0<00003c<c<00@0003<c<`000000004c<c<0`0000?<c<`5
00000lc<c0040000c<c<c<c<00001<c<c08000000lc<c0000<c<c01>c<c<
00EVIVK<c<b8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;Soool0B<c<
c0030000c<c<c<c<00;<c<`01@000<c<c<c<c<c<c0000003c<c<00<0003<
c<c<c<`00P0000;<c<`010000<c<c<c<c00000?<c<`010000<c<c<c<c000
00O<c<`00`000<c<c<c<c00200000/c<c0050000c<c<c<c<c<c<000000;<
c<`00`000<c<c<c<c00200000/c<c0030000c<c<c<c<00800018c<c<00=V
IVK<c<coool0Clc<c0030000c<c<c<c<00;<c<`01@000<c<c<c<c<c<c000
0003c<c<00<0003<c<c<c<`00P0000;<c<`010000<c<c<c<c00000?<c<`0
10000<c<c<c<c00000C<c<`01@000<c<c<c<c<c<c0000003c<c<00@0003<
c<c<c<`00002c<c<0P0004k<c<`00fIVI/c<c?ooo`1>c<c<00<0003<c<c<
c<`00/c<c0050000c<c<c<c<c<c<000000?<c<`00`000<c<c<c<c0020000
0/c<c0040000c<c<c<c<00000lc<c0040000c<c<c<c<00001<c<c0040000
c<c<c<c<00000/c<c0050000c<c<c<c<c<c<000000;<c<`20000Clc<c005
IVIVc<c<R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hoooo04S<c<`0
0`000<c<c<c<c002c<c<00D0003<c<c<c<c<c<`000000lc<c0040000c<c<
c<c<00000lc<c0040000c<c<c<c<00000lc<c0040000c<c<c<c<00001lc<
c0050000c<c<c<c<c<c<000000;<c<`01@000<c<c<c<c<c<c0000002c<c<
00D0003<c<c<c<c<c<`000000/c<c0050000c<c<c<c<c<c<000004S<c<`0
0fIVI/c<c?ooo`1?c<c<00<0003<c<c<c<`00/c<c0050000c<c<c<c<c<c<
000000?<c<`010000<c<c<c<c00000?<c<`010000<c<c<c<c00000?<c<`0
10000<c<c<c<c00000G<c<`010000<c<c<c<c00000?<c<`010000<c<c<c<
c00000?<c<`00`000<c<c<c<c01<c<c<00=VIVK<c<coool0C/c<c0030000
c<c<c<c<00;<c<`01@000<c<c<c<c<c<c0000003c<c<00@0003<c<c<c<`0
0003c<c<00@0003<c<c<c<`00003c<c<00@0003<c<c<c<`00004c<c<00@0
003<c<c<c<`00002c<c<00D0003<c<c<c<c<c<`000000lc<c0030000c<c<
c<c<04g<c<`01FIVI/c<c8S0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^?ooo`18c<c<00D0003<c<c<c<c<c<`000001<c<c0050000c<c<c<c<c<c<
000000;<c<`01@000<c<c<c<c<c<c0000002c<c<00D0003<c<c<c<c<c<`0
00000/c<c0030000c<c<c<c<00K<c<`400000/c<c0050000c<c<c<c<c<c<
000000;<c<`01@000<c<c<c<c<c<c0000003c<c<100004S<c<`00fIVI/c<
c?ooo`1?c<c<00D0003<c<c<c<c<c<`000001<c<c0050000c<c<c<c<c<c<
000000;<c<`01@000<c<c<c<c<c<c0000002c<c<00D0003<c<c<c<c<c<`0
00000/c<c0030000c<c<c<c<00?<c<`010000<c<c<c<c00000?<c<`01000
0<c<c<c<c00000?<c<`00`000<c<c<c<c01<c<c<00=VIVK<c<coool0C/c<
c0050000c<c<c<c<c<c<000000C<c<`01@000<c<c<c<c<c<c0000002c<c<
00D0003<c<c<c<c<c<`000000/c<c0050000c<c<c<c<c<c<000000;<c<`0
0`000<c<c<c<c002c<c<00@0003<c<c<c<`00002c<c<00D0003<c<c<c<c<
c<`000000lc<c0030000c<c<c<c<04g<c<`01FIVI/c<c8S0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^?ooo`18c<c<1P0000?<c<`01@000<c<c<c<
c<c<c0000002c<c<00D0003<c<c<c<c<c<`000000/c<c0050000c<c<c<c<
c<c<000000;<c<`500001lc<c0040000c<c<c<c<00000lc<c0040000c<c<
c<c<00000lc<c0030000c<c<c<c<00C<c<`00`000<c<c<c<c016c<c<00=V
IVK<c<coool0Clc<c0H00003c<c<00D0003<c<c<c<c<c<`000000/c<c005
0000c<c<c<c<c<c<000000;<c<`01@000<c<c<c<c<c<c0000002c<c<00<0
003<c<c<c<`00lc<c0040000c<c<c<c<00000lc<c0040000c<c<c<c<0000
0lc<c0030000c<c<c<c<04c<c<`00fIVI/c<c?ooo`1>c<c<1P0000?<c<`0
1@000<c<c<c<c<c<c0000002c<c<00D0003<c<c<c<c<c<`000000/c<c005
0000c<c<c<c<c<c<000000;<c<`500000lc<c0040000c<c<c<c<00000lc<
c0050000c<c<c<c<c<c<000004o<c<`01FIVI/c<c8S0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^?ooo`18c<c<00<0003<c<c<c<`00lc<c0040000
c<c<c<c<00000lc<c0030000c<c<c<c<00800002c<c<00@0003<c<c<c<`0
0003c<c<00@0003<c<c<c<`00004c<c<00@0003<c<c<c<`00003c<c<00<0
003<c<c<c<`00P0000;<c<`010000<c<c<c<c00000;<c<`200000/c<c005
0000c<c<c<c<c<c<000004S<c<`00fIVI/c<c?ooo`1?c<c<00<0003<c<c<
c<`00lc<c0040000c<c<c<c<00000lc<c0030000c<c<c<c<00800002c<c<
00@0003<c<c<c<`00003c<c<00@0003<c<c<c<`00005c<c<00@0003<c<c<
c<`00003c<c<00@0003<c<c<c<`00002c<c<0P0004k<c<`00fIVI/c<c?oo
o`1>c<c<00<0003<c<c<c<`00lc<c0040000c<c<c<c<00000lc<c0030000
c<c<c<c<00800002c<c<00@0003<c<c<c<`00003c<c<00@0003<c<c<c<`0
0004c<c<00@0003<c<c<c<`00002c<c<0P0000;<c<`00`000<c<c<c<c002
0000Clc<c005IVIVc<c<R<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
oooo04S<c<`00`000<c<c<c<c003c<c<00@0003<c<c<c<c<c<`300000lc<
c0040000c<c<000000001<c<c0<00003c<c<00<0003<c<c<c<`00/c<c004
0000c<c<c<c<c<c<0`0000?<c<`010000<c<c000000000C<c<`2000000?<
c<`0003<c<`00/c<c0<00019c<c<00=VIVK<c<coool0Clc<c0030000c<c<
c<c<00?<c<`010000<c<c<c<c<c<c0<00003c<c<00@0003<c<`000000004
c<c<0`0000?<c<`00`000<c<c<c<c003c<c<00@0003<c<c<c<c<c<`30000
1<c<c08000000lc<c0000<c<c01=c<c<00=VIVK<c<coool0C/c<c0030000
c<c<c<c<00?<c<`010000<c<c<c<c<c<c0<00003c<c<00@0003<c<`00000
0004c<c<0`0000?<c<`00`000<c<c<c<c002c<c<00@0003<c<c<c<`00002
c<c<00<0003<c<`000000/c<c08000000lc<c0000<c<c01>c<c<00EVIVK<
c<b8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;Soool0B<c<c0030000
c<c<c<c<00?<c<`00`000<c<c<c<c007c<c<00<0003<c<c<c<`02lc<c003
0000c<c<c<c<00;<c<`00`000<c<c<c<c00Bc<c<00<0003<c<c<c<`0CLc<
c003IVIVc<c<oooo04o<c<`00`000<c<c<c<c003c<c<00<0003<c<c<c<`0
1lc<c0030000c<c<c<c<00_<c<`00`000<c<c<c<c002c<c<00<0003<c<c<
c<`0Flc<c003IVIVc<c<oooo04k<c<`00`000<c<c<c<c003c<c<00<0003<
c<c<c<`01lc<c0030000c<c<c<c<00_<c<`00`000<c<c<c<c002c<c<00<0
003<c<c<c<`02lc<c0030000c<c<c<c<04g<c<`01FIVI/c<c8S0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^?ooo`18c<c<1P0000[<c<`00`000<c<
c<c<c00;c<c<1@0001G<c<`00`000<c<c<c<c01=c<c<00=VIVK<c<coool0
Clc<c0H0000:c<c<00<0003<c<c<c<`02lc<c0D0001Nc<c<00=VIVK<c<co
ool0C/c<c0H0000:c<c<00<0003<c<c<c<`02lc<c0D00003c<c<00<0003<
c<c<c<`02<c<c0030000c<c<c<c<04g<c<`01FIVI/c<c8S0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^?ooo`3@c<c<00=VIVK<c<coool0d<c<c003
IVIVc<c<oooo0<o<c<`01FIVI/c<c8S0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^?ooo`3@c<c<00=VIVK<c<coool0d<c<c003IVIVc<c<oooo0<o<
c<`01FIVI/c<c8S0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^?ooo`3@
c<c<00=VIVK<c<coool0d<c<c003IVIVc<c<oooo0<o<c<`01FIVI/c<c8S0
^8S0^4R@R0010000000018S0^<SPf8S0^8S0^=7oool00fIVI/c<c?ooo`3@
oooo00=VIVK<c<coool0coooo`05IVIVc<c<R<2hR<2hB928004000000003
R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058T8P10000000018S0^<SPf8S0^8S0
^1H0080300600P02P00400:100>100>100>10`04P@801H401005PP06PP06
PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q003
0@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<K
R@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d4
9Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[
S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO
00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y
00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n
[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64
[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P04
59Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl
00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G
/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P10000000018S0^<SPf8S0
^8S0^0@008000i^WlC=3YC=3Y@09<d>U1P00P0<00H0200:000@00X400h40
0h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R20081
28<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108A
QP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN8
0`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3
126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh0
0`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA
1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLe
TP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`Pm
U@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4
V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/3
2TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN
2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:00
10aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=
HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iY
Y@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?
LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X3
47V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61
[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;02
4XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P03
4hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E
]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`04
5Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X3
5ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm
00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P007VjOaooooSWZfYY_4
/jWBZ9g8/jWB00:VVl@01KbhgNk^m>[YlOoooc=3Y@0500200`01P0800X00
1002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h81
288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?
Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP3
5hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX3
11n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DW
S@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y02
1Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP03
1cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`Lk
U@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`04
2D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX3
2T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M
00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ03
35^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<
HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eW
Y0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>
L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX3
3gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]
0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl3
4XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8B
SK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C
]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<D
W;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T3
5J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm
0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l3
5k>o0QRd`20000026;C04000008H]<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0P00P004VjOaooooK5ZU[jG:0[bhg@0:oogo/jWBoooooooo_;SM
UhZlZ9g8i^K/oooo<d>U1000P0<00H0200:000@00X400h400h400h4300B1
0P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V30`4:
P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>6
00@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV8
0aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@4
8h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh0
0`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A
0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`Lf
T`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF
0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP0
0`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:
Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh3
2eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aM
X@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeR
X`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V
0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP3
3g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@
Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P03
4H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4B
R[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb
008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne
11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh
5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<F
Yk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG
[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf4R@R4R@
R00<B92800<00038h=Q8T8P03DR@R00400006;C06;C0b>3H3TR@R0030000
6;C06;C000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000^KYo7o
oonXWLSoooncZM9PC9Z>N[IhIJjXWLSooooooOl00oooo`03<d>U00200020
00<0080300600P02P00400:100>100>100>10`04P@801H401005PP06PP06
PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q003
0@b40`4=Q0<13XD30Pn50P8@Q@?oool20Q660`8BQP824hH0108CQ`8DQ`8D
Q`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<J
R@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=
12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?
00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@04
1S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC
1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8
@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI
00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YA
W0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]G
W`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<
Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<0
0`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP04
3VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mc
Z@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/
00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<A
Q:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<B
Rk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<3
4i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8D
V[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<E
X;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl
11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`
_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@
R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008003Y^WlOoooooo
om_Lk61<VY>5^[>Yd[bhgF1<VYV?_ZJKa<S3gooooc=3Y@H00803oooo0P02
P00300:1oooooooo00;oool200B100<01H7oool01H800`06PPCoool00`48
PP48Poooo`03oooo0`4:P`06oooo0@^40@^40@b4oooo0@b40P4=Q004oooo
0@j5oooo0@j50P8?Q@04oooo0Q25oooo0Q250P8AQP03oooo0Q660Q:60082
4XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<H
R0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;
0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DX
SP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A
1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP02
1cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8
?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4
V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK
0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN
00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aL
X@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=
HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>
JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?
LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[
0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61
[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`
00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb
4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<D
U[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh
5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj
0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G
[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<001<SP
f8S0^8S0^8S0^0H00004R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8
T8P0000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0<008003Y^WlOoookbhgIV?__ooomKAgM_Lk??n
ojJKa>k^m8Ef/9>5^_oooc=3Y@@008001oooo`01P001P001P?ooo`02P?oo
o`0300>100Koool0184018401H7oool01H8200J200Soool01h801h811h;o
ool128;oool128<30@V300Coool12X<12X?oool20@^400<138Coool138@0
0P4=Q004oooo0@j5oooo0@j50P8?Q@03oooo0Q25oooo00?oool20Q660`8B
QP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR8
00<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/3
12:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>
0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946
<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087
=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10Pn
UP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH
0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/3
2TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h0
0`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ
35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeR
XP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZ
Y@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0ma
Z0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/3
47Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^
4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK00
11:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8C
Sk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF
]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPE
W[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX3
5ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^
_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`004b>3H
R<2hR<2hR<2h1P0000B8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P0
1HS0^0050000R<2hR<2hB9280000008H]<001<SPf8S0^8S0^8S0^0800004
R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3002000nKYo7ooonISkjGR[cDdnS_[;?oMW_^Wj]KF:FVVlBF
Wm9PC9Zl^=gooolc@jD00`00P007oooo006000600060oooo00:0oooo00<0
0h401_ooo`04P@04POooo`05POooo`801X802?ooo`07PP07PP47P_ooo`48
P_ooo`48P`<12H<02Oooo`4:Poooo`4;Poooo`4;Q?ooo`4<Q?ooo`020@f4
00Coool13XGoool13XD20Pn500Coool248Goool248D40Q660`8BQP824hH0
108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP3
6HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@S
S00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP03
1BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<943
1S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC
0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2
242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V003
2DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?
W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;
EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ
35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S
0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH3
3VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?
LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1k
Z`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<A
PZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::
/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk80
0Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD4
59Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PE
W[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW
^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^
_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h
00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2h
R<2hB9280000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08002Y^WlOoooiN:_7Y/Z[?7j:U^X<S3gi>5^U]6TiV?_P9hIJh0148WQJnU
b_oooc=3Y@@00803006000?oool00X000X401?ooo`8018400oooo`05POoo
o`0300J21?ooo`030@R20@R30@R300<12H<02Oooo`4:Poooo`4;Poooo`4;
Q?ooo`4<Q?ooo`020@f400Coool13XGoool13XD20Pn500?oool248Goool0
0oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<4
7h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=
1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086
;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7
=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9
@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:
BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<
Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`
Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?
MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd3
4H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<B
Qk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d
0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL
]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d2
5jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G
/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0
^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8
`;P4000018S0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^08008000i^WlOooooooo`02oooo00[o[K3oMW_icMCmkNkooonV
VlB5M[2l^=gooolc@jD500200`01P003oooo00:000:100<00h400oooo`04
POooo`0200F100@01H;oool01X801X8200N200<11h;oool128800P48P`?o
ool20@Z300Ooool12h?oool12hCoool138Coool00P4=Q004oooo0@j5oooo
oooo0P8?Q@06oooo0Q25oooo0Q250Q66oooo0P8AQP<24XH20Q>600@24hL2
58L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV9
00@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@T
S0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZ
S`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86
<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<0
0`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04
242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6
V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L
00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;
Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<
GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<3
3FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>
KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?
LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/
111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63
[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4B
R[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<3
4i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<D
VKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO
^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk
0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN_
_P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h
00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@
R00000026;C000?8h=R8`;R8`;P018S0^0800005R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00:XJcbnLgDhRHl
m;FohRHlm6emo>?YoooooNg^ojf`0_ooo`03<d>U0020002000@008030060
00?oool00X000X400oooo`8018401Oooo`05P@05P@05P_ooo`0200J20ooo
o`8128800`48Poooo`49P`020@V30P4:P`04oooo0@^30@^4oooo0P4<Q007
oooo0@f40@f4oooo0@j5oooo0@j500;oool00`8?Q@8@Q@8@Q@04oooo00@2
4HH24XH24XH24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN8
0aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@O
R`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd5
9hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_
T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`Ld
TPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD3
23bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3
V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;
VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@03
2eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aK
X08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R
00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@3
3FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W
00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mg
ZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<A
P:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7
/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb
0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@3
4iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg
0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS
^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G
[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc
_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2h
R<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00hS0
^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0P00P00=VjOaoNg^hRHlo_GhmhVGm69^lj2^m69^oogoojf`o>?Y
oooo<d>U00L00803006000?oool00X000X400`03P@<0184200F100@01H80
1X801X801X8200N200D11h81288128;oool128<00`49P`<12X<00`4;P`4;
Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@04
0aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`4
98d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5
:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A
00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7
>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9
AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN
2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ
0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X
3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@
OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh0
0a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@
/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf
0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<F
ZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003
B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P0
00000QRd`003b>3HR<2hR<2h00:8`;P200000XS0^0800003R<2h00A8T8P0
000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOa
m/S<hRHl00;o[K001mlT;_nTW_JlaOn]/>ikS?oooc=3Y@0800200`01P003
oooo00:000:100<00h4300B10P05P@0400F200J200J200J20P07PP050@N2
0@R20@R2oooo0@R300<12H<01?ooo`4:P`4:P`4;P`812h@30@b40`4=Q0<1
3XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:
0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DV
S@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@
0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i82
1SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7
>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL2
24>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ
0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]B
W@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO
0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R
362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=
IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL3
3VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o
[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_
1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=
/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B
]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g
59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i
0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdF
ZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl0
0aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P9
00000XS0^005B92800006;C06;C0b>3H00>8`;P2000018S0^0800002R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00
P003VjOanLgDmhVG00;oool01on]/>4F=?mfNonTW^8V??n9Oc=3Y@080020
0`01P003oooo00:000:100<00h4300B10P05P@0400F200J200J200J20P07
PP040@N20@R20@R20@R31?ooo`<12X<00`4;P`4;Q04;Q0030@b40P4=Q004
oooo0@j50@j50@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<3
6hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=
12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5
:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9
AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YA
W@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]G
W`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW
3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mc
Z@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@
OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hA
Q:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H0
11BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ
_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P03
5k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R000
0<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0
000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P007VjOa
oooolj2^m69^oooomhVGnLgD00;oool00o>P[_oooc=3Y@0800200`01P080
0X001002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<1
1h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j5
0`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<4
7XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd0
0`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6
;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHd
TP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD
0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3
U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9
BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd3
2e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<
FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaP
XP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT
0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_
Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?
MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd2
4Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@A
QZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8B
SK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@0
0a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK
]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<E
X[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m
5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf00=R<2h00E8
T8P0000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0<008002i^WlOoooon9Oooooo>P[_6CXOooooom
oo>P[_oko3=3Y@0800200`01P0800X001002P@03P@03P@03P@<0184200F1
00@01H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<1
2h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108C
Q`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT3
6HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS004
12B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>
1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A
0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`Lg
T`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F
00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH
2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:
D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh0
0`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ
0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eS
X`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP0
0`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@
O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh3
4H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::
/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?
/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf
0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P3
5Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<F
Z;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P03
5jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`0o8h=P00`000<SPf<SP
f00=b>3H00<0000H]<0H]<003lSPf00300006;C06;C000:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P400200i^Wl@06oooolj2^m;Fom[c5nmWJ<d>U
2@00P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J200J2
00J20P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<1
38@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L3
0QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^9
0`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@U
S@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?
10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHc
TPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0Lh
U0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G
246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI
0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:
DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil0
0`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<
Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=
IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^
Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT0
10mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/
47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_
4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:<
/@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`03
4i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@D
V[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i
5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`0
11J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa
_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h5P00P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J2
00J200J20P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^4
00<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L2
58L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT3
0a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@T
S@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`03
1B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010Hb
TPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`Lh
U0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G
246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@04
2DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:
DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;
Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ
00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=
IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]
Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?
LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[004
47j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^
4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a
0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A
/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf
00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h
5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@F
Z[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h0
0aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R04000000003R<2hb>3H
R<2h0?n8`;SoR<2hOHS0^058T8P1000000000hS0^<SPf8S0^03oR<2hohS0
^7f8`;P1B9280@00000000>8`;S8h=S8h=P0olSPf?o8h=Qmb>3H0DR@R040
00000?n8`;SoR<2hPHS0^04000000001\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?oo
l?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`
l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003o
oo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;o
l?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
2_ooool00ooWinOon_[jooooo`04ooooo`03onOWioojn_[ooooo00?ooooo
00?om_Kfoo7alOooool0aOooool00ooWinOon_[jooooo`04ooooo`03onOW
ioojn_[ooooo00?ooooo00?om_Kfoo7alOooool0a_ooool00ooWinOon_[j
ooooo`04ooooo`03onOWioojn_[ooooo00?ooooo00?om_Kfoo7alOooool0
4?ooool00oono_kohn?Son3Ph02Xooooo`000_ooool00olN7QkoYZJVoooo
o`03ooooo`05ol30`?lL71co9BDUo`X:2_miNGT00_ooool01Oo0`<3o71`L
obDU9Ol:2P[oNGUi00;ooooo00KoU9BDo`@41?l@413oJ6QXoc`l??nJVYX9
ooooo`03ohB4Q?mVIVKooooo00;ooooo00Koe=CDob4Q8OlB4Q;o2PX:ob4Q
8OnOWinWooooo`03oahN7_nVYZKooooo00?ooooo00Go`<30oa`L7?lU9BGo
2PX:ogUiN@02ooooo`05ol30`?lL71co9BDUo`X:2_miNGT00_ooool01_nD
U9Co10@4oa0@4?mXJ6So?3`loiZJVPWooooo00?oQ8B4ofIVI_ooool00_oo
ool5o`000003omOGeooooooooooo0:Kooooo00?o7QhNojJVY_ooool00ooo
ool01Oo0`<3o71`LobDU9Ol:2P[oNGUi00;ooooo00Go`<30oa`L7?lU9BGo
2PX:ogUiN@02ooooo`06oiBDU?l410Co410@ofQXJ?ll?3coVYZJ2Oooool0
0on4Q8CoIVIVooooo`02ooooo`05ocdm?Ol^;Rko>CTiobh^;_nOWil0Y_oo
ool000;ooooo00?o7QhNojJVY_ooool00_ooool05Ooclo?o5aLGoi6ATOoo
ooooh^;Roa@D5?n[Zj_olo?coaLG5onATI7oooooon;Rh_lD51CoZj^[oogm
oOlE5AGoVi^Kookno_n^[Zko3`l?oiZJVP09ooooo`03ohB4Q?mVIVKooooo
00Cooooo00?oRXZ:ode=COooool0Z?ooool00olN7QkoYZJVooooo`02oooo
o`0Eoo?clolG5aOoTI6AoooooooRh^;o51@Doj^[Zooclo?o5aLGoi6ATOoo
ooooh^;Roa@D5?n[Zj_ooOgmoaDE5OnKVi_oo_knojj^[_l?3`ooVYZJ00Wo
oooo00?oQ8B4ofIVI_ooool00_ooool00om<C4coH61Pooclo002ooclo:Wo
oooo00?o7QhNojJVY_ooool00_ooool05Ooclo?o5aLGoi6ATOooooooh^;R
oa@D5?n[Zj_olo?coaLG5onATI7oooooon;Rh_lD51CoZj^[oogmoOlE5AGo
Vi^Kookno_n^[Zko3`l?oiZJVP09ooooo`03ohB4Q?mVIVKooooo00;ooooo
00KomOGeooooooooooooYZJVo`@41?oVi^JUooooo`000_ooool00olN7Qko
YZJVooooo`02ooooo`03ol30`?l20P;ok^k^00;ooooo00GoDe=Cof5QHOo0
`<3o0P82onk^kP02ooooo`05oe=CDomQHF7ob/[:o`D51OogmoL00_ooool0
0olm?CgoVYZJooooo`04ooooo`07ol[:b_mdM7CoM7AdogAdM?ll?3co;Rh^
oiFEU@04ooooo`03ohZ:R_m=CDgooooo0:Sooooo00?o7QhNojJVY_ooool0
0_ooool00oo0`<3o0P82onk^kP02ooooo`05oe=CDomQHF7o`<30o`820_o^
k^h00_ooool01OmCDe?oHF5Qol[:b_l51@GomoOg00;ooooo00?o?CdmoiZJ
V_ooool01?ooool01oo:b/[oM7AdogAdM?mdM7Co?3`lobh^;_nEUID00_oo
ool00ooTi>Co8b<SokFe]@2[ooooo`03oahN7_nVYZKooooo00;ooooo00?o
`<30o`820_o^k^h00_ooool01OmCDe?oHF5Qol30`?l20P;ok^k^00;ooooo
00GoDe=Cof5QHOo:b/[o1@D5ooOgm`02ooooo`03ocdm?OnJVY[ooooo00Co
oooo00Oob/[:ogAdM?mdM7CoM7Adoc`l??l^;RkoUIFE00Gooooo00?oj^[Z
o`000?o=cLd0YOooool000;ooooo00So7QhNoibLW?o`l?3ol?3`ooWinOnc
/k?o2`/;ooclo0;ooooo00GoJFUYoeADE?nc/k?o2`/;ooclo002ooooo`05
ofUYJOmDE5CocLg=o`X:2_okno/00_ooool00olm?CgoVYZJooooo`04oooo
o`07olG5aOl=3@goTi>CoiVIVOmKFe_o?Cdmok:b/P04ooooo`03ohZ:R_m=
CDgooooo0:Sooooo00So7QhNoibLW?o`l?3ol?3`ooWinOnc/k?o2`/;oocl
o0;ooooo00GoJFUYoeADE?nc/k?o2`/;ooclo002ooooo`05ofUYJOmDE5Co
cLg=o`X:2_okno/00_ooool00olm?CgoVYZJooooo`04ooooo`07olG5aOl=
3@goTi>CoiVIVOmKFe_o?Cdmok:b/P03ooooo`03om_KfolU9BGo/k>c0:[o
oooo00So7QhNoibLW?o`l?3ol?3`ooWinOnc/k?o2`/;ooclo0;ooooo00Go
JFUYoeADE?nc/k?o2`/;ooclo002ooooo`05ofUYJOmDE5CocLg=o`X:2_ok
no/00_ooool00olm?CgoVYZJooooo`04ooooo`07olG5aOl=3@goTi>CoiVI
VOmKFe_o?Cdmok:b/P04ooooo`04ooCdm?mdM7Co8B4QooknoZGooooo0002
ooooo`08oahN7_lI6AWo9bLWobLW9on/[:coh>3Po`820_o;bl/2ooooo`05
ob`/;?n4Q8Coh>3Po`820_o;bl/00_ooool01Ol/;2coQ8B4ookno_lI6AWo
bl_;00;ooooo00?o=SHfoiVIVOooool01Oooool01OmhN7SoL71`oooooonH
V9SoIVIV00Gooooo00?oRXZ:ode=COooool0Z?ooool02?lN7Qko6ATIobLW
9olW9bOo[:b/on3Ph?l20P;obl_;0_ooool01Ol/;2coQ8B4on3Ph?l20P;o
bl_;00;ooooo00Go;2`/ohB4Q?ono_ko6ATIol_;b`02ooooo`03ocHf=_nI
VIWooooo00Gooooo00GoN7Qhog1`L?ooooooV9RHofIVIP05ooooo`03on3P
h?lM7Ago^KVi0:Wooooo00So7QhNoaTI6OlW9bOo9bLWojb/[?oPh>3o0P82
ol_;b`;ooooo00Go;2`/ohB4Q?oPh>3o0P82ol_;b`02ooooo`05ob`/;?n4
Q8Coo_knoaTI6Oo;bl/00_ooool00olf=SKoVIVIooooo`05ooooo`05ogQh
N?m`L73ooooooiRHV?mVIVH01?ooool01?lc<c?o10@4oeYJF_o]kNfVoooo
o`000_ooool00olN7QkoYZJVooooo`03ooooo`0DogMgMolN7QkoPX:2odE5
AOlX:2SolO7aoooooomgMgOo7QhNoh:2P_m5ADGo:2PXoo7alOooooooNg]k
oa`L7?n2PX;o=SHfoa0@4?nJVYX6ooooo`05oo_knoli>CWo/[:boiRHV?mV
IVH01Oooool00on:RX[oCDe=ooooo`2Xooooo`03oahN7_nVYZKooooo00?o
oooo01CoMgMgoahN7_n2PX;oADE5obPX:?oalO7oooooogMgMolN7QkoPX:2
odE5AOlX:2SolO7aoooooomkNg_o71`Loh:2P_lf=SKo410@oiZJVPKooooo
00Gono_kocTi>Onb/[;oV9RHofIVIP06ooooo`03ojf][OlD51CooOgm0:So
oooo00?o7QhNojJVY_ooool00oooool05?mgMgOo7QhNoh:2P_m5ADGo:2PX
oo7alOooooooMgMgoahN7_n2PX;oADE5obPX:?oalO7oooooog]kNolL71co
PX:2ocHf=_l@413oVYZJ1_ooool01Ookno_o>CTiok:b/_nHV9SoIVIV00Co
oooo00Com_Kfokno_om1@D7oYJFUY_ooool000;ooooo00?o7QhNojJVY_oo
ool01?ooool01?o1`L7oS8b<ojBTY?oemOD3ooooo`04ol71`On<S8coY:BT
ooGem@?ooooo00Go];Bdohf=SOo@d=3o?CdmoiZJVP07ooooo`04omoOgolR
8R;oNg]kofIVIPGooooo00?oRXZ:ode=COooool0Z?ooool00olN7QkoYZJV
ooooo`04ooooo`04ol71`On<S8coY:BTooGem@?ooooo00Co`L71ohb<S?nT
Y:ComOGe0oooool01Ond];CoSHf=om3@d?lm?CgoVYZJ00Oooooo00CogmoO
ob8R8_mkNg_oIVIV1_ooool00ooShn?o0000on?Sh`2Xooooo`03oahN7_nV
YZKooooo00Cooooo00Co`L71ohb<S?nTY:ComOGe0oooool01?o1`L7oS8b<
ojBTY?oemOD3ooooo`05okBd]?n=SHgod=3@ocdm?OnJVYX01oooool01?oO
gmoo8R8Rog]kNomVIVH6ooooo`03ok:b/_lV9RKooooo0:Gooooo0002oooo
o`05oahN7_mmOGgo`<30ol30`?o2`/804oooool00olm?CgoVYZJooooo`07
ooooo`03ojVYZOl61PKoIFEU00?ooooo00CogMgMog=cLomHF5SoCDe=ZOoo
ool01OlN7QkoOGemol30`?o0`<3o`/;201?ooooo00?o?CdmoiZJV_ooool0
1oooool00onYZJWo1PH6ofEUI@03ooooo`05oi6ATOno_kook>c/og9bL_lj
>SX0ZOooool01OlN7QkoOGemol30`?o0`<3o`/;201?ooooo00?o?CdmoiZJ
V_ooool01oooool00onYZJWo1PH6ofEUI@03ooooo`05okno_ooDe=Cok^k^
of][Jom<C4`0Y_ooool000;ooooo00GoJ6QXoe=CDomCDe?oDe=CoeYJFP0C
ooooo`03ocdm?OnJVY[ooooo00Sooooo00?oPX:2oiRHV?ooool00_ooool0
1?ofm_KoZ:RXofUYJOm`L72Yooooo`05ofQXJ?mCDe?oDe=Coe=CDomJFUX0
4oooool00olm?CgoVYZJooooo`08ooooo`03oh:2P_nHV9Sooooo00;ooooo
00GoYjNWoeUIFOl_;booLW9bomSHf02Yooooo`05ofQXJ?mCDe?oDe=Coe=C
DomJFUX04oooool00olm?CgoVYZJooooo`08ooooo`03oh:2P_nHV9Sooooo
00;ooooo00GoVIVIod51@Ol^;RkoJf][omSHf02Vooooo`006_ooool00oo>
c/koi^KVooooo`3Booooo`03olk>c_oVi^Kooooo0=?ooooo00?oc/k>onKV
i_ooool0^?ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00=GoooooeOmn[MWFooooo`00eOooool00omn
[MWo0000o`00003Ao`000003ogj]fOoooooooooo0=Cooooo000:ooooo`03
onOWioojn_[ooooo00Cooooo00?oinOWoo[jn_ooool00oooool00oofm_Ko
lO7aooooo`08ooooo`03ookno_oShn?oh>3P0;3ooooo00?oOZgIo`000?l0
00001ol000000olB4Q;o0`<3o`000004o`000003oa8B4_l30`?o000000?o
000000?o1PH6o`X:2_l000002Ol000000olE5AGo5aLGo`00002^o`000003
ogj]fOoooooooooo00Wooooo00?oinOWoo[jn_ooool01?ooool00ooWinOo
n_[jooooo`03ooooo`03ooKfm_oalO7ooooo00Sooooo00?oo_knon?ShooP
h>001Oooool00oono_kohn?Son3Ph02Xooooo`000_ooool00olN7QkoYZJV
ooooo`03ooooo`05ol30`?lL71co9BDUo`X:2_miNGT00_ooool01Oo0`<3o
71`LobDU9Ol:2P[oNGUi00;ooooo00KoU9BDo`@41?l@413oJ6QXoc`l??nJ
VYX6ooooo`05ocdm?Ol^;Rko>CTiobh^;_nOWil00oooool01_oDe=Co8B4Q
oa8B4_l:2P[o8B4QoinOWjGooooo00CoOZgIo`000?n[Zj_o@d=31?l00000
1Ol_;boo[:b/ojFUYOnj^[[oIFEU00;o000000Go;bl_ojb/[?nUYJGo^[Zj
ofEUI@02o`000006oe5ADOnn_[ko]KFeog9bL_nDU9CoC4a<1_l000001OnC
Ti?oWinOoiJFU_nOWiooBDU900?o00001Oo2`/800olN7Qko0000o`00002R
o`000006ogj]fOoooooooooooooooolN7QkoYZJV1?ooool01Oo0`<3o71`L
obDU9Ol:2P[oNGUi00;ooooo00Go`<30oa`L7?lU9BGo2PX:ogUiN@02oooo
o`06oiBDU?l410Co410@ofQXJ?ll?3coVYZJ1_ooool01Olm?Cgo;Rh^ocTi
>Ol^;RkoWinO00?ooooo00Go?Cdmobh^;_li>CWo;Rh^oinOW`2Vooooo`00
0_ooool00olN7QkoYZJVooooo`02ooooo`0Eoo?clolG5aOoTI6AoooooooR
h^;o51@Doj^[Zooclo?o5aLGoi6ATOooooooh^;Roa@D5?n[Zj_ooOgmoaDE
5OnKVi_oo_knojj^[_l?3`ooVYZJ00Kooooo00KomOGeooooooooooooYZJV
o`@41?oVi^H4ooooo`03ohZ:R_m=CDgooooo0:Kooooo00CoOZgIo`000?n[
Zj_o@d=30ol000005Ol92@Wo/;2`oe=CDol0003o5QHFok:b/_lo?coo2@T9
ok2`/?mCDe?o0000oaHF5_nb/[;o?cloo`410Onb/[;oC4a<o`000?lm?Cgo
][Jfoda<C006o`000006o`L71ol0003o0000od=3@onn_[ko4a<C0_l00000
0on8R8SoN7Qho`820P02o`820ZGo000000KoOZgIoooooooooooooooooahN
7_nVYZH3ooooo`0Eoo?clolG5aOoTI6AoooooooRh^;o51@Doj^[Zooclo?o
5aLGoi6ATOooooooh^;Roa@D5?n[Zj_ooOgmoaDE5OnKVi_oo_knojj^[_l?
3`ooVYZJ00Kooooo00KomOGeooooooooooooYZJVo`@41?oVi^H2ooooo`06
ooGemOooooooooooojJVY_l410Coi^KVYOooool000;ooooo00?o7QhNojJV
Y_ooool00_ooool00oo0`<3o0P82onk^kP02ooooo`05oe=CDomQHF7o`<30
o`820_o^k^h00_ooool01OmCDe?oHF5Qol[:b_l51@GomoOg00;ooooo00?o
?CdmoiZJV_ooool02?ooool00ooZj^[o0000olg=c@04ooooo`03ohZ:R_m=
CDgooooo0:Kooooo00CoOZgIo`000?n[Zj_o@d=30ol000000ol_;boo`<30
o``<3002o`000005oh:2P_mhN7So;bl_ol30`?l<30`00_l000001On2PX;o
N7QhobPX:?nn_[ko1PH600;o000000?oTi>Coda<C?l000002?l000000ol?
3`oo`/;2obHV9P02o`000003oa@D5?nWYjOo>3Ph0:Oo000000KoOZgIoooo
oooooooooooooahN7_nVYZH3ooooo`03ol30`?l20P;ok^k^00;ooooo00Go
De=Cof5QHOo0`<3o0P82onk^kP02ooooo`05oe=CDomQHF7ob/[:o`D51Oog
moL00_ooool00olm?CgoVYZJooooo`08ooooo`03on[Zj_l0003ocLg=00Go
oooo00?oj^[Zo`000?o=cLd0YOooool000;ooooo00So7QhNoibLW?o`l?3o
l?3`ooWinOnc/k?o2`/;ooclo0;ooooo00GoJFUYoeADE?nc/k?o2`/;oocl
o002ooooo`05ofUYJOmDE5CocLg=o`X:2_okno/00_ooool00olm?CgoVYZJ
ooooo`07ooooo`04ooCdm?mdM7Co8B4QooknoPCooooo00?oRXZ:ode=COoo
ool0Y_ooool01?mn[MWo0000oj^[Zom;Bd/2o`/;2`04o`@41?li>CWo^KVi
o`820P;o000000GoLW9boh:2P_li>CWo^KVio`820P02o`000005og9bL_n2
PX;o9RHVokZj^_l30`<00_l000000onCTi?oC4a<o`000007o`000003o`P8
2?mYJFWoZ:RX00Co000000?o6a/KojFUYOli>CT0Y_l000001_mn[MWooooo
oooooooooooo7QhNoibLW0;ol?3`00ConOWiok>c/ol;2`_oo?cl0_ooool0
1OmYJFWoE5ADok>c/ol;2`_oo?cl00;ooooo00GoJFUYoeADE?o=cLgo2PX:
oo_kn`02ooooo`03ocdm?OnJVY[ooooo00Oooooo00Com?CdogAdM?lQ8B7o
o_kn1?ooool01?odm?CoM7Adob4Q8Oono_jUooooo`000_ooool02?lN7Qko
6ATIobLW9olW9bOo[:b/on3Ph?l20P;obl_;0_ooool01Ol/;2coQ8B4on3P
h?l20P;obl_;00;ooooo00Go;2`/ohB4Q?ono_ko6ATIol_;b`02ooooo`03
ocHf=_nIVIWooooo00Kooooo00Co<c<co`@41?mJFU[okNg]1Oooool00on:
RX[oCDe=ooooo`2Vooooo`04ogj]fOl0003oZj^[ojj^[P;oY:BT00Co?clo
oaLG5oo0`<3o9bLW0_l000001OnPX:3oGEeMoaLG5oo0`<3o9bLW00;o0000
00GoX:2PoeeMGOl0003o[Zj^obLW9`02o`000003oiRHV?m=CDgo000000Ko
000000CoVi^Kokjn__mmOGgo3@d=1Ol000000olG5aOoZj^[ocDe=@2Uo`00
0006ogj]fOoooooooooooooooolN7Qko6ATI0_lW9bL01?n/[:coh>3Po`82
0_o;bl/2ooooo`05ob`/;?n4Q8Coh>3Po`820_o;bl/00_ooool01Ol/;2co
Q8B4ookno_lI6AWobl_;00;ooooo00?o=SHfoiVIVOooool01_ooool01?lc
<c?o10@4oeYJF_o]kNd4ooooo`04oc<c<ol410CoFUYJong]kJKooooo0002
ooooo`03oahN7_nVYZKooooo00?ooooo01CoMgMgoahN7_n2PX;oADE5obPX
:?oalO7oooooogMgMolN7QkoPX:2odE5AOlX:2SolO7aoooooomkNg_o71`L
oh:2P_lf=SKo410@oiZJVPOooooo00Com_Kfokno_om1@D7oYJFU1Oooool0
0on:RX[oCDe=ooooo`2Vooooo`04ogj]fOl0003oZj^[od=3@`Co000001Co
IfMWoj^[ZomOGeooSHf=oj>SXol:2P[o0000ofMWIon[Zj_oGemOohf=SOnS
Xj?o2PX:o`000?mTI6Co[:b/oemOGonHV9So]KFeoda<C0Oo000000Co1PH6
oc0`<?n@T93oA4A41_l000000oln?Sko/[:bo`410@2To`000006ogj]fOoo
oooooooooooooolN7QkoYZJV1?ooool05?mgMgOo7QhNoh:2P_m5ADGo:2PX
oo7alOooooooMgMgoahN7_n2PX;oADE5obPX:?oalO7oooooog]kNolL71co
PX:2ocHf=_l@413oVYZJ1oooool01?ofm_Ko_knood51@OnUYJD4ooooo`04
ooKfm_no_koo@D51ojFUYJKooooo0002ooooo`03oahN7_nVYZKooooo00Co
oooo00Co`L71ohb<S?nTY:ComOGe0oooool01?o1`L7oS8b<ojBTY?oemOD3
ooooo`05okBd]?n=SHgod=3@ocdm?OnJVYX02Oooool00onb/[;o9RHVoooo
o`04ooooo`03ohZ:R_m=CDgooooo0:Kooooo00CoOZgIo`000?n[Zj_o@d=3
1Ol000001?l_;booEeMGodE5AOl71`L3o`000004obl_;omGEeOoADE5o`L7
1`?o000000Go>CTioeIFE_lS8b?oTi>Coda<C009o`000003ocXj>_nUYJGo
000000Go000000?o5ADEol;2`_lE5AD0Y?l000001_mn[MWooooooooooooo
oooo7QhNojJVYPGooooo00Co`L71ohb<S?nTY:ComOGe0oooool01?o1`L7o
S8b<ojBTY?oemOD3ooooo`05okBd]?n=SHgod=3@ocdm?OnJVYX02Oooool0
0onb/[;o9RHVooooo`05ooooo`03ok:b/_lV9RKooooo0:Gooooo0002oooo
o`05oahN7_mmOGgo`<30ol30`?o2`/804oooool00olm?CgoVYZJooooo`05
ooooo`05okno_ooDe=Cok^k^of][Jom<C4`00oooool01?oMgMgoLg=coeQH
F?m=CDfWooooo`04ogj]fOl0003oZj^[of9RHP;o;bl_00?o;Rh^o`000?l0
00004Ol000000onCTi?oC4a<o`000005o`000005oc0`<?lP823o30`<og1`
L?n8R8P00ol000001OmCDe?o<30`o`h>3_m[Jf_oUIFE0:Go000000KoOZgI
oooooooooooooooooahN7_mmOGd2ol30`003ol;2`_oooooooooo017ooooo
00?o?CdmoiZJV_ooool01Oooool01Ono_kooe=CDonk^k_m[Jf_oC4a<00?o
oooo00Go_knoomCDe?o^k^koJf][oda<C02Vooooo`000_ooool01OmXJ6So
De=Coe=CDomCDe?oFUYJ01?ooooo00?o?CdmoiZJV_ooool01Oooool01OnI
VIWo@D51obh^;_m[Jf_of=SH00?ooooo00Com_KfojRXZ?mYJFWoL71`Yooo
ool00omn[MWo0000og9bLP03oh:2PP03ogemOOl0003o0000017o000000?o
Ti>Coda<C?l000001Ol000001Om=CDgoT92@oinOWom`L73o7AdM00?o0000
00Go@T92oginO_nNWYkoJf][oadM7@2Uo`000005ogj]fOoooooooooooooo
oomXJ6P00omCDe<00omJFU[oooooooooo`0Aooooo`03ocdm?OnJVY[ooooo
00Gooooo00GoVIVIod51@Ol^;RkoJf][omSHf003ooooo`05oiVIVOm1@D7o
;Rh^of][JooHf=P0Y_ooool001[ooooo00?oc/k>onKVi_ooool0^?ooool0
0omn[MWo0000o`00000Go`000003obDU9OlC4a?o00000;Oo000000?oOZgI
ooooooooool06Oooool00oo>c/koi^KVooooo`2hooooo`00eOooool00omn
[MWo0000o`00003Ao`000003ogj]fOoooooooooo0=Cooooo003EooooomGo
OZgIe_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool000[ooooo00?oinOWoo[jn_ooool01?ooool00ooW
inOon_[jooooo`03ooooo`03ooKfm_oalO7ooooo0<Gooooo00?oinOWoo[j
n_ooool01?ooool00ooWinOon_[jooooo`03ooooo`03ooKfm_oalO7ooooo
0<Kooooo00?oinOWoo[jn_ooool01?ooool00ooWinOon_[jooooo`03oooo
o`03ooKfm_oalO7ooooo013ooooo00?oo_knon?ShooPh>00Z?ooool000;o
oooo00?o7QhNojJVY_ooool00oooool01Oo0`<3o71`LobDU9Ol:2P[oNGUi
00;ooooo00Go`<30oa`L7?lU9BGo2PX:ogUiN@02ooooo`06oiBDU?l410Co
410@ofQXJ?ll?3coVYZJ1_ooool5o`000009omOGeoooooooooooomCDe?lQ
8B7o4Q8Bo`X:2_lQ8B7oWinO0:Oooooo00?o7QhNojJVY_ooool00oooool0
1Oo0`<3o71`LobDU9Ol:2P[oNGUi00;ooooo00Go`<30oa`L7?lU9BGo2PX:
ogUiN@02ooooo`06oiBDU?l410Co410@ofQXJ?ll?3coVYZJ1_ooool5o`00
0003omOGeooooooooooo00Go000000?oemOGooooooooool0Y_ooool00olN
7QkoYZJVooooo`03ooooo`05ol30`?lL71co9BDUo`X:2_miNGT00_ooool0
1Oo0`<3o71`LobDU9Ol:2P[oNGUi00;ooooo00KoU9BDo`@41?l@413oJ6QX
oc`l??nJVYX6ooooo`Go000000SoemOGoooooooooooo?Cdmobh^;_li>CWo
;Rh^oinOWjKooooo0002ooooo`03oahN7_nVYZKooooo00;ooooo01Golo?c
oaLG5onATI7oooooon;Rh_lD51CoZj^[oo?clolG5aOoTI6AoooooooRh^;o
51@Doj^[ZoomoOgo5ADEoi^KVoono_ko[Zj^o`l?3onJVYX01_ooool00om<
C4coH61Pooclo002ooclo0Gooooo00?oRXZ:ode=COooool0Z?ooool00olN
7QkoYZJVooooo`02ooooo`0Eoo?clolG5aOoTI6AoooooooRh^;o51@Doj^[
Zooclo?o5aLGoi6ATOooooooh^;Roa@D5?n[Zj_ooOgmoaDE5OnKVi_oo_kn
ojj^[_l?3`ooVYZJ00Kooooo00?oC4a<of1PH?olo?`00_olo?`3ooooo`03
oda<C?mPH63oo?cl00;oo?clZOooool00olN7QkoYZJVooooo`02ooooo`0E
oo?clolG5aOoTI6AoooooooRh^;o51@Doj^[Zooclo?o5aLGoi6ATOoooooo
h^;Roa@D5?n[Zj_ooOgmoaDE5OnKVi_oo_knojj^[_l?3`ooVYZJ00Kooooo
00?oC4a<of1PH?olo?`00_olo?`3ooooo`06ooGemOooooooooooojJVY_l4
10Coi^KVYOooool000;ooooo00?o7QhNojJVY_ooool00_ooool00oo0`<3o
0P82onk^kP02ooooo`05oe=CDomQHF7o`<30o`820_o^k^h00_ooool01OmC
De?oHF5Qol[:b_l51@GomoOg00;ooooo00?o?CdmoiZJV_ooool01Oooool0
0ooTi>Co8b<SokFe]@07ooooo`03ohZ:R_m=CDgooooo0:Sooooo00?o7QhN
ojJVY_ooool00_ooool00oo0`<3o0P82onk^kP02ooooo`05oe=CDomQHF7o
`<30o`820_o^k^h00_ooool01OmCDe?oHF5Qol[:b_l51@GomoOg00;ooooo
00?o?CdmoiZJV_ooool01Oooool00ooTi>Co8b<SokFe]@05ooooo`03onCT
i?lS8b?o]KFe0:_ooooo00?o7QhNojJVY_ooool00_ooool00oo0`<3o0P82
onk^kP02ooooo`05oe=CDomQHF7o`<30o`820_o^k^h00_ooool01OmCDe?o
HF5Qol[:b_l51@GomoOg00;ooooo00?o?CdmoiZJV_ooool01Oooool00ooT
i>Co8b<SokFe]@08ooooo`03on[Zj_l0003ocLg=0:Gooooo0002ooooo`08
oahN7_nLW9col?3`oo3`l?oinOWo/k>co`/;2oolo?`2ooooo`05ofUYJOmD
E5Co/k>co`/;2oolo?`00_ooool01OmYJFWoE5ADolg=cOl:2P[ono_k00;o
oooo00?o?CdmoiZJV_ooool01_ooool00ooKfm_o9BDUok>c/`06ooooo`03
ohZ:R_m=CDgooooo0:Sooooo00So7QhNoibLW?o`l?3ol?3`ooWinOnc/k?o
2`/;ooclo0;ooooo00GoJFUYoeADE?nc/k?o2`/;ooclo002ooooo`05ofUY
JOmDE5CocLg=o`X:2_okno/00_ooool00olm?CgoVYZJooooo`06ooooo`03
om_KfolU9BGo/k>c00Gooooo00?ofm_KobDU9Onc/k<0Z_ooool02?lN7Qko
W9bLoo3`l?o`l?3onOWiok>c/ol;2`_oo?cl0_ooool01OmYJFWoE5ADok>c
/ol;2`_oo?cl00;ooooo00GoJFUYoeADE?o=cLgo2PX:oo_kn`02ooooo`03
ocdm?OnJVY[ooooo00Kooooo00?ofm_KobDU9Onc/k<01_ooool01?odm?Co
M7Adob4Q8Oono_jUooooo`000_ooool02?lN7Qko6ATIobLW9olW9bOo[:b/
on3Ph?l20P;obl_;0_ooool01Ol/;2coQ8B4on3Ph?l20P;obl_;00;ooooo
00Go;2`/ohB4Q?ono_ko6ATIol_;b`02ooooo`03ocHf=_nIVIWooooo00Oo
oooo00?oh>3PoadM7Oni^KT01Oooool00on:RX[oCDe=ooooo`2Xooooo`08
oahN7_lI6AWo9bLWobLW9on/[:coh>3Po`820_o;bl/2ooooo`05ob`/;?n4
Q8Coh>3Po`820_o;bl/00_ooool01Ol/;2coQ8B4ookno_lI6AWobl_;00;o
oooo00?o=SHfoiVIVOooool01oooool00ooPh>3o7AdMokVi^@05ooooo`03
on3Ph?lM7Ago^KVi0:Wooooo00So7QhNoaTI6OlW9bOo9bLWojb/[?oPh>3o
0P82ol_;b`;ooooo00Go;2`/ohB4Q?oPh>3o0P82ol_;b`02ooooo`05ob`/
;?n4Q8Coo_knoaTI6Oo;bl/00_ooool00olf=SKoVIVIooooo`07ooooo`03
on3Ph?lM7Ago^KVi00Cooooo00Co<c<co`@41?mJFU[okNg]Y_ooool000;o
oooo00?o7QhNojJVY_ooool00oooool05?mgMgOo7QhNoh:2P_m5ADGo:2PX
oo7alOooooooMgMgoahN7_n2PX;oADE5obPX:?oalO7oooooog]kNolL71co
PX:2ocHf=_l@413oVYZJ2Oooool00on][Jgo51@Doogmo@04ooooo`03ohZ:
R_m=CDgooooo0:Sooooo00?o7QhNojJVY_ooool00oooool05?mgMgOo7QhN
oh:2P_m5ADGo:2PXoo7alOooooooMgMgoahN7_n2PX;oADE5obPX:?oalO7o
ooooog]kNolL71coPX:2ocHf=_l@413oVYZJ2Oooool00on][Jgo51@Doogm
o@05ooooo`03ojf][OlD51CooOgm0:Sooooo00?o7QhNojJVY_ooool00ooo
ool05?mgMgOo7QhNoh:2P_m5ADGo:2PXoo7alOooooooMgMgoahN7_n2PX;o
ADE5obPX:?oalO7oooooog]kNolL71coPX:2ocHf=_l@413oVYZJ2Oooool0
0on][Jgo51@Doogmo@03ooooo`04ooKfm_no_koo@D51ojFUYJKooooo0002
ooooo`03oahN7_nVYZKooooo00Cooooo00Co`L71ohb<S?nTY:ComOGe0ooo
ool01?o1`L7oS8b<ojBTY?oemOD3ooooo`05okBd]?n=SHgod=3@ocdm?OnJ
VYX02Oooool00ooShn?o0000on?Sh`04ooooo`03ohZ:R_m=CDgooooo0:So
oooo00?o7QhNojJVY_ooool01?ooool01?o1`L7oS8b<ojBTY?oemOD3oooo
o`04ol71`On<S8coY:BTooGem@?ooooo00Go];Bdohf=SOo@d=3o?CdmoiZJ
VP09ooooo`03on?Shol0003ohn?S00Gooooo00?ohn?So`000?oShn<0Z?oo
ool00olN7QkoYZJVooooo`04ooooo`04ol71`On<S8coY:BTooGem@?ooooo
00Co`L71ohb<S?nTY:ComOGe0oooool01Ond];CoSHf=om3@d?lm?CgoVYZJ
00Wooooo00?ohn?So`000?oShn<01Oooool00onb/[;o9RHVooooo`2Uoooo
o`000_ooool01OlN7QkoOGemol30`?o0`<3o`/;201?ooooo00?o?CdmoiZJ
V_ooool01Oooool01OnATI7o_knoonc/k?mbLW;o>SXj00?ooooo00CogMgM
og=cLomHF5SoCDe=ZOooool01OlN7QkoOGemol30`?o0`<3o`/;201?ooooo
00?o?CdmoiZJV_ooool01Oooool01OnATI7o_knoonc/k?mbLW;o>SXj00?o
oooo00GoTI6Aokno_oo/k>coLW9bocXj>P2Yooooo`05oahN7_mmOGgo`<30
ol30`?o2`/804oooool00olm?CgoVYZJooooo`05ooooo`05oi6ATOno_koo
k>c/og9bL_lj>SX00oooool01Ono_kooe=CDonk^k_m[Jf_oC4a<0:Kooooo
0002ooooo`05ofQXJ?mCDe?oDe=Coe=CDomJFUX04oooool00olm?CgoVYZJ
ooooo`05ooooo`05ojNWYomIFEWo;bl_og9bL_oHf=P00oooool01?ofm_Ko
Z:RXofUYJOm`L72Yooooo`05ofQXJ?mCDe?oDe=Coe=CDomJFUX04oooool0
0olm?CgoVYZJooooo`05ooooo`05ojNWYomIFEWo;bl_og9bL_oHf=P00ooo
ool01OnWYjOoFEUIobl_;ombLW;of=SH0:Wooooo00GoJ6QXoe=CDomCDe?o
De=CoeYJFP0Cooooo`03ocdm?OnJVY[ooooo00Gooooo00GoYjNWoeUIFOl_
;booLW9bomSHf003ooooo`05oiVIVOm1@D7o;Rh^of][JooHf=P0Y_ooool0
01[ooooo00?oc/k>onKVi_ooool0d_ooool00oo>c/koi^KVooooo`3Coooo
o`03olk>c_oVi^Kooooo0;Sooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`002_ooool00ooWinOon_[jooooo`04ooooo`03
onOWioojn_[ooooo00?ooooo00?om_Kfoo7alOooool0aOooool00ooWinOo
n_[jooooo`04ooooo`03onOWioojn_[ooooo00?ooooo00?om_Kfoo7alOoo
ool0a_ooool00ooWinOon_[jooooo`04ooooo`03onOWioojn_[ooooo00?o
oooo00?om_Kfoo7alOooool04?ooool00oono_kohn?Son3Ph02Xooooo`00
0_ooool00olN7QkoYZJVooooo`03ooooo`05ol30`?lL71co9BDUo`X:2_mi
NGT00_ooool01Oo0`<3o71`LobDU9Ol:2P[oNGUi00;ooooo00KoU9BDo`@4
1?l@413oJ6QXoc`l??nJVYX6ooooo`06omCDe?lQ8B7o4Q8Bo`X:2_lQ8B7o
WinO0_ooool01_oDe=Co8B4Qoa8B4_l:2P[o8B4QoinOWjOooooo00?o7QhN
ojJVY_ooool00oooool01Oo0`<3o71`LobDU9Ol:2P[oNGUi00;ooooo00Go
`<30oa`L7?lU9BGo2PX:ogUiN@02ooooo`06oiBDU?l410Co410@ofQXJ?ll
?3coVYZJ1_ooool01_oDe=Co8B4Qoa8B4_l:2P[o8B4QoinOW`;ooooo1Ol0
00000ooGemOoooooooooo`2Vooooo`03oahN7_nVYZKooooo00?ooooo00Go
`<30oa`L7?lU9BGo2PX:ogUiN@02ooooo`05ol30`?lL71co9BDUo`X:2_mi
NGT00_ooool01_nDU9Co10@4oa0@4?mXJ6So?3`loiZJVPKooooo00Koe=CD
ob4Q8OlB4Q;o2PX:ob4Q8OnOWil2ooooo`05ocdm?Ol^;Rko>CTiobh^;_nO
Wil0Y_ooool000;ooooo00?o7QhNojJVY_ooool00_ooool05Ooclo?o5aLG
oi6ATOooooooh^;Roa@D5?n[Zj_olo?coaLG5onATI7oooooon;Rh_lD51Co
Zj^[oogmoOlE5AGoVi^Kookno_n^[Zko3`l?oiZJVP08ooooo`03ohZ:R_m=
CDgooooo00Gooooo00?oRXZ:ode=COooool0Z?ooool00olN7QkoYZJVoooo
o`02ooooo`0Eoo?clolG5aOoTI6AoooooooRh^;o51@Doj^[Zooclo?o5aLG
oi6ATOooooooh^;Roa@D5?n[Zj_ooOgmoaDE5OnKVi_oo_knojj^[_l?3`oo
VYZJ00Sooooo00?oRXZ:ode=COooool00oooool00om<C4coH61Pooclo002
ooclo:Wooooo00?o7QhNojJVY_ooool00_ooool05Ooclo?o5aLGoi6ATOoo
ooooh^;Roa@D5?n[Zj_olo?coaLG5onATI7oooooon;Rh_lD51CoZj^[oogm
oOlE5AGoVi^Kookno_n^[Zko3`l?oiZJVP08ooooo`03ohZ:R_m=CDgooooo
00?ooooo00KomOGeooooooooooooYZJVo`@41?oVi^JUooooo`000_ooool0
0olN7QkoYZJVooooo`02ooooo`03ol30`?l20P;ok^k^00;ooooo00GoDe=C
of5QHOo0`<3o0P82onk^kP02ooooo`05oe=CDomQHF7ob/[:o`D51OogmoL0
0_ooool00olm?CgoVYZJooooo`07ooooo`03ohZ:R_m=CDgooooo00Gooooo
00?oRXZ:ode=COooool0Z?ooool00olN7QkoYZJVooooo`02ooooo`03ol30
`?l20P;ok^k^00;ooooo00GoDe=Cof5QHOo0`<3o0P82onk^kP02ooooo`05
oe=CDomQHF7ob/[:o`D51OogmoL00_ooool00olm?CgoVYZJooooo`07oooo
o`03ohZ:R_m=CDgooooo00?ooooo00?oi>CTob<S8one]KD0Zoooool00olN
7QkoYZJVooooo`02ooooo`03ol30`?l20P;ok^k^00;ooooo00GoDe=Cof5Q
HOo0`<3o0P82onk^kP02ooooo`05oe=CDomQHF7ob/[:o`D51OogmoL00_oo
ool00olm?CgoVYZJooooo`07ooooo`03ohZ:R_m=CDgooooo00Kooooo00?o
j^[Zo`000?o=cLd0YOooool000;ooooo00So7QhNoibLW?o`l?3ol?3`ooWi
nOnc/k?o2`/;ooclo0;ooooo00GoJFUYoeADE?nc/k?o2`/;ooclo002oooo
o`05ofUYJOmDE5CocLg=o`X:2_okno/00_ooool00olm?CgoVYZJooooo`07
ooooo`03ohZ:R_m=CDgooooo00Gooooo00?oRXZ:ode=COooool0Z?ooool0
2?lN7QkoW9bLoo3`l?o`l?3onOWiok>c/ol;2`_oo?cl0_ooool01OmYJFWo
E5ADok>c/ol;2`_oo?cl00;ooooo00GoJFUYoeADE?o=cLgo2PX:oo_kn`02
ooooo`03ocdm?OnJVY[ooooo00Oooooo00?oRXZ:ode=COooool01?ooool0
0ooKfm_o9BDUok>c/`2Zooooo`08oahN7_nLW9col?3`oo3`l?oinOWo/k>c
o`/;2oolo?`2ooooo`05ofUYJOmDE5Co/k>co`/;2oolo?`00_ooool01OmY
JFWoE5ADolg=cOl:2P[ono_k00;ooooo00?o?CdmoiZJV_ooool01oooool0
0on:RX[oCDe=ooooo`05ooooo`04ooCdm?mdM7Co8B4QooknoZGooooo0002
ooooo`08oahN7_lI6AWo9bLWobLW9on/[:coh>3Po`820_o;bl/2ooooo`05
ob`/;?n4Q8Coh>3Po`820_o;bl/00_ooool01Ol/;2coQ8B4ookno_lI6AWo
bl_;00;ooooo00?o=SHfoiVIVOooool01oooool00on:RX[oCDe=ooooo`05
ooooo`03ohZ:R_m=CDgooooo0:Sooooo00So7QhNoaTI6OlW9bOo9bLWojb/
[?oPh>3o0P82ol_;b`;ooooo00Go;2`/ohB4Q?oPh>3o0P82ol_;b`02oooo
o`05ob`/;?n4Q8Coo_knoaTI6Oo;bl/00_ooool00olf=SKoVIVIooooo`07
ooooo`03ohZ:R_m=CDgooooo00Gooooo00?oh>3PoadM7Oni^KT0ZOooool0
2?lN7Qko6ATIobLW9olW9bOo[:b/on3Ph?l20P;obl_;0_ooool01Ol/;2co
Q8B4on3Ph?l20P;obl_;00;ooooo00Go;2`/ohB4Q?ono_ko6ATIol_;b`02
ooooo`03ocHf=_nIVIWooooo00Oooooo00?oRXZ:ode=COooool01?ooool0
1?lc<c?o10@4oeYJF_o]kNfVooooo`000_ooool00olN7QkoYZJVooooo`03
ooooo`0DogMgMolN7QkoPX:2odE5AOlX:2SolO7aoooooomgMgOo7QhNoh:2
P_m5ADGo:2PXoo7alOooooooNg]koa`L7?n2PX;o=SHfoa0@4?nJVYX8oooo
o`03ohZ:R_m=CDgooooo00Gooooo00?oRXZ:ode=COooool0Z?ooool00olN
7QkoYZJVooooo`03ooooo`0DogMgMolN7QkoPX:2odE5AOlX:2SolO7aoooo
oomgMgOo7QhNoh:2P_m5ADGo:2PXoo7alOooooooNg]koa`L7?n2PX;o=SHf
oa0@4?nJVYX8ooooo`03ohZ:R_m=CDgooooo00Kooooo00?o[Jf]oa@D5?om
oOd0Z?ooool00olN7QkoYZJVooooo`03ooooo`0DogMgMolN7QkoPX:2odE5
AOlX:2SolO7aoooooomgMgOo7QhNoh:2P_m5ADGo:2PXoo7alOooooooNg]k
oa`L7?n2PX;o=SHfoa0@4?nJVYX8ooooo`03ohZ:R_m=CDgooooo00Cooooo
00Com_Kfokno_om1@D7oYJFUY_ooool000;ooooo00?o7QhNojJVY_ooool0
1?ooool01?o1`L7oS8b<ojBTY?oemOD3ooooo`04ol71`On<S8coY:BTooGe
m@?ooooo00Go];Bdohf=SOo@d=3o?CdmoiZJVP08ooooo`03ohZ:R_m=CDgo
oooo00Gooooo00?oRXZ:ode=COooool0Z?ooool00olN7QkoYZJVooooo`04
ooooo`04ol71`On<S8coY:BTooGem@?ooooo00Co`L71ohb<S?nTY:ComOGe
0oooool01Ond];CoSHf=om3@d?lm?CgoVYZJ00Sooooo00?oRXZ:ode=COoo
ool01_ooool00ooShn?o0000on?Sh`2Xooooo`03oahN7_nVYZKooooo00Co
oooo00Co`L71ohb<S?nTY:ComOGe0oooool01?o1`L7oS8b<ojBTY?oemOD3
ooooo`05okBd]?n=SHgod=3@ocdm?OnJVYX02?ooool00on:RX[oCDe=oooo
o`06ooooo`03ok:b/_lV9RKooooo0:Gooooo0002ooooo`05oahN7_mmOGgo
`<30ol30`?o2`/804oooool00olm?CgoVYZJooooo`05ooooo`04omgMgOmc
Lg?oF5QHode=C@Cooooo00CogMgMog=cLomHF5SoCDe=ZOooool01OlN7Qko
OGemol30`?o0`<3o`/;201?ooooo00?o?CdmoiZJV_ooool01Oooool01?oM
gMgoLg=coeQHF?m=CDd4ooooo`05oi6ATOno_kook>c/og9bL_lj>SX0ZOoo
ool01OlN7QkoOGemol30`?o0`<3o`/;201?ooooo00?o?CdmoiZJV_ooool0
1Oooool01?oMgMgoLg=coeQHF?m=CDd4ooooo`05okno_ooDe=Cok^k^of][
Jom<C4`0Y_ooool000;ooooo00GoJ6QXoe=CDomCDe?oDe=CoeYJFP0Coooo
o`03ocdm?OnJVY[ooooo00Gooooo00Com_KfojRXZ?mYJFWoL71`1?ooool0
1?ofm_KoZ:RXofUYJOm`L72Yooooo`05ofQXJ?mCDe?oDe=Coe=CDomJFUX0
4oooool00olm?CgoVYZJooooo`05ooooo`04ooKfm_nXZ:SoJFUYog1`L0Co
oooo00GoYjNWoeUIFOl_;booLW9bomSHf02Yooooo`05ofQXJ?mCDe?oDe=C
oe=CDomJFUX04oooool00olm?CgoVYZJooooo`05ooooo`04ooKfm_nXZ:So
JFUYog1`L0Cooooo00GoVIVIod51@Ol^;RkoJf][omSHf02Vooooo`006_oo
ool00oo>c/koi^KVooooo`3Booooo`03olk>c_oVi^Kooooo0=?ooooo00?o
c/k>onKVi_ooool0^?ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo00000on2PX;oVIVIoiVIV@3@oiVIV@03oo3`l?n2PX;oVIVI0=?o
VIVI00?ol?3`oh:2P_nIVIT0d_nIVIT1oo3`l07oPX:200000ooIfMWooooo
ooooo`3@ooooo`03oo3`l?oIfMWooooo0=?ooooo00?ol?3`omWIfOooool0
d_ooool1oo3`l07ofMWI00000ooIfMWoooooooooo`3@ooooo`03oo3`l?oI
fMWooooo07oooooo00Cof][Jojb/[?nFUYKo_KfmD?ooool00oo`l?3ofMWI
ooooo`3Booooo`7ol?3`0OoIfMT00003omWIfOoooooooooo0=3ooooo00?o
l?3`omWIfOooool0Ooooool01OmTI6CoIFEUogalO?lW9bOoE5AD04oooooo
00?ol?3`omWIfOooool0d_ooool1oo3`l07ofMWI00000ooHf=Soo_knookn
oP1AooknoP03onKVi_oinOWoo_kn00;oo_kn00Cokno_oo_knoohn?Sok>c/
1_ono_h00ooVi^KonOWiooknoP0:ooknoP04onc/k?ono_koo_knon_[j`[o
o_kn00?omOGeoo3`l?ono_h01Oono_h01?o/k>coo_knookno_o[jn]9ookn
oP03oo3`l?oHf=Soo_kn05_oo_kn00?oi^KVooWinOono_h00_ono_h01?o_
knoono_kooShn?o/k>`6ooknoP03onKVi_oinOWoo_kn00goo_kn00?oi^KV
ooWinOono_h01Oono_h00ooYjNWo0P82om3@d01>ooknoP03oo3`l?oHf=So
o_kn05[oo_kn00?oi^KVooWinOono_h00_ono_h01?o_knoono_kooShn?o/
k>`6ooknoP03onKVi_oinOWoo_kn01;oo_kn00?omOGeoo3`l?ono_h0DOon
o_h1oo3`l07of=SH00000ooFe]KooOgmoogmo@17oogmo@0=oadM7OnWYjOo
oOgmoogmoOnKVi_o2PX:omOGeoomoOgo_[jnoa/K6olT92Co2@T9ogQhN002
oogmo@06obHV9_mKFe_o6a/Koa8B4_m;Bd_olo?c0_omoOd01Onn_[ko6a/K
ob@T9?l92@WoN7Qh00;ooOgm00?o7AdMojNWYoomoOd00oomoOd02_ogmoOo
=cLgoaDE5Olc<c?oMGEeoaHF5_o<c<cooOgmobHV9_n_[jl2oogmo@0Aoc<c
<onRXZ;ooOgmoi:BT_l30`?o3`l?ofMWIolk>c_oV9RHoogmoOogmoOo=cLg
oaDE5Olc<c?oMGEeoaHF5_o<c<`0B?omoOd00oo`l?3oe]KFoogmo@1Aoogm
o@0=oadM7OnWYjOooOgmoogmoOnKVi_o2PX:omOGeoomoOgo_[jnoa/K6olT
92Co2@T9ogQhN002oogmo@06obHV9_mKFe_o6a/Koa8B4_m;Bd_olo?c0_om
oOd01Onn_[ko6a/Kob@T9?l92@WoN7Qh00;ooOgm00Ko7AdMo``<3?lC4a?o
5QHFocdm?Onc/k<3oogmo@05okjn__lK6a_o92@To`T92OmhN7P00_omoOd0
1_o<c<coATI6ochn?_nWYjOo<S8bojj^[TkooOgm00?ol?3`omKFe_omoOd0
D?omoOd03OlM7AgoYjNWoogmoOomoOgoVi^Ko`X:2_oGemOooOgmokjn__lK
6a_o92@To`T92OmhN7P00_omoOd01_lV9RKoFe]Koa/K6olB4Q;oBd];oo?c
l`;ooOgm00Go_[jnoa/K6olT92Co2@T9ogQhN002oogmo@05oadM7Ol;2`_o
2PX:oaXJ6_mnOWh00_omoOd01OlV9RKo[jn_oogmoOlV9RKo[jn_00?ooOgm
00KoTY:Bo`<30ol?3`ooIfMWoc/k>onHV9Q?oogmo@7ol?3`0OoFe]H00003
om3@d?ogmoOomoOg04OomoOg023o7AdMoj>SXoogmoOof][Jo`d=3OnEUIGo
moOgon_[jolF5QKoS8b<ooOgmooJf][o4a<CojFUYOogmoOo9BDUofi^K_o]
kNgoj>SXoc8b<_nOWioomoOgon_[jolF5QKoS8b<ooOgmooJf][o4a<CojFU
YOogmoOo7AdMoj>SX`ComoOg00Ko[:b/oaXJ6_oclo?of=SHobPX:?n4Q8@2
ooOgm`0DobDU9On[Zj_omoOgooOgmolb<S;oWYjNooGemOlD51CoUYJFooKf
m_nXZ:So3Ph>oiFEUOogmoOo[:b/oaXJ6_oclo?of=SHobPX:?n4Q8A9ooOg
m`03oo3`l?o@d=3omoOg057omoOg03Co7AdMoj>SXoogmoOof][Jo`d=3OnE
UIGomoOgon_[jolF5QKoS8b<ooOgmooJf][o4a<CojFUYOogmoOo9BDUofi^
K_o]kNgoj>SXoc8b<_nOWioomoOgon_[jolF5QKoS8b<ooOgmooJf][o4a<C
ojFUYOogmoOo7AdMoj2PX?ogmoOolO7aok:b/_lG5aOoTi>CooOgmoo[jn_o
5QHFohb<S?ogmoOof][Joa<C4onUYJGomoOgobPX:?mOGeoo^k^kofMWIolC
4a?oVIVIC_ogmoL00oo`l?3od=3@ooOgm`1@ooOgm`0ZoadM7OnSXj?omoOg
om[Jf_l=3@goUIFEooOgmoo[jn_o5QHFohb<S?ogmoOof][Joa<C4onUYJGo
moOgobDU9Om^KVkokNg]onSXj?lb<S;oWinOooOgmoo[jn_o5QHFohb<S?og
moOof][Joa<C4onUYJGomoOgoadM7OnSXj?omoOgoi6ATOl0003oc<c<ooOg
molU9BGoZj^[ooOgmolU9BGoZj^[0_ogmoL01ooemOGo51@DoiJFU_ofm_Ko
Z:RXo`h>3_nEUID0CoogmoL1oo3`l07od=3@00000oo:b/[ol_;boo;blP17
oo;blP05oa`L7?nPX:3ol_;bod92@_m<C4`00_obl_800onf][Ko0@41on7Q
h@02oo;blP05odi>C_mLG5col_;bobDU9OnWYjL00_obl_801_mhN7SoEEEE
oo;bl_nf][Ko0@41on7Qh@;ol_;b00GoCTi>oeaLG?obl_;o71`Loj2PX004
oo;blP06olo?col<30coYjNWonc/k?m0@43oS8b<0_obl_802OlU9BGoYjNW
oo;bl_obl_;o<C4aoi^KVono_koo10@4on[ZjP02oo;blP09ocTi>OnBTY;o
l_;bolo?col<30coYjNWonc/k?m0@43oS8b<04Wol_;b00?ol?3`ol[:b_ob
l_80DOobl_801OlL71coX:2Poo;bl_m2@T;oC4a<00;ol_;b00?o][Jfo`41
0OoQhN400_obl_801Om>CTkoG5aLoo;bl_lU9BGoYjNW00;ol_;b00KoN7Qh
oeEEEOobl_;o][Jfo`410OoQhN42oo;blP05odi>C_mLG5col_;boa`L7?nM
WId00oobl_801_mlO7co3`l?onGUiOnf][Ko0@41on7Qh@;ol_;b00GoCTi>
oeaLG?oAdM7o0@41on;RhP02oo;blP03oc<c<onBTY;ol_;b04gol_;b00?o
l?3`ol[:b_obl_80D?obl_801OlL71coX:2Poo;bl_m2@T;oC4a<00;ol_;b
00?o][Jfo`410OoQhN400_obl_801Om>CTkoG5aLoo;bl_lU9BGoYjNW00;o
l_;b00KoN7QhoeEEEOobl_;o][Jfo`410OoQhN42oo;blP0?odi>C_mLG5co
l_;boa`L7?nPX:3ol_;bomoOgol30`?o/;2`oo;bl_lU9BGoYjNWoo;bl_lU
9BGoYjNW00;ol_;b00?o_knoo`@41?oZj^X00_obl_800oli>CWoTY:Boo;b
lP1>oo;blP7ol?3`0Oo:b/X00003ol?3`ooYjNWojNWY04OojNWY00Go6a/K
ofMWIom^KVko5aLGomSHf002onWYj@03oj>SXol:2P[oi^KV00;ojNWY00Go
GemOoda<C?oYjNWo8b<Soj6QX@02onWYj@06ohb<S?lX:2SojNWYoj>SXol:
2P[oi^KV0_oYjNT01omOGeooC4a<onWYjOlK6a_oADE5oi>CTooFe]H00ooY
jNT01Oo5aLGoQHF5oeQHF?lD51CoQhN700;ojNWY00Wo8b<Soj6QXOoYjNWo
jNWYobl_;onEUIGo^k^ko`T92OoUiND00_oYjNT02Olg=cOoS8b<onWYjOoY
jNWoaLG5ohF5QOmHF5So51@DohN7Q`19onWYj@03oo3`l?o3`l?ojNWY057o
jNWY00Go6a/KofMWIom^KVko5aLGomSHf002onWYj@03oj>SXol:2P[oi^KV
00;ojNWY00GoGemOoda<C?oYjNWo8b<Soj6QX@02onWYj@06ohb<S?lX:2So
jNWYoj>SXol:2P[oi^KV0_oYjNT01OmOGeooC4a<onWYjOlK6a_oUiNG00?o
jNWY00Ko^k^ko`000?nd];CoXj>So`X:2_oVi^H2onWYj@05oemOGom<C4co
/;2`o`X:2_oWinL00_oYjNT00olg=cOoS8b<onWYj@1=onWYj@03oo3`l?o3
`l?ojNWY053ojNWY00Go6a/KofMWIom^KVko5aLGomSHf002onWYj@03oj>S
Xol:2P[oi^KV00;ojNWY00GoGemOoda<C?oYjNWo8b<Soj6QX@02onWYj@06
ohb<S?lX:2SojNWYoj>SXol:2P[oi^KV0_oYjNT03omOGeooC4a<onWYjOlK
6a_oVYZJolC4a?mADE7o<30`onKVi_oYjNWo8b<Soj6QXOoYjNWo8b<Soj6Q
X@02onWYj@03ok^k^ol92@WoiNGU00;ojNWY00?o=cLgohb<S?oYjNT0C_oY
jNT1oo3`l07o`l?300000onm_Kgoh>3Pon3Ph017on3Ph005oaXJ6_lj>S[o
;bl_oaLG5onYZJT00_oPh>000oo4a<Co0@41ok:b/P02on3Ph005obHV9_mc
Lg?oh>3Pob8R8_mbLW800_oPh>001_mHF5SoGEeMon3Ph?o4a<Co0@41ok:b
/P;oh>3P00So9RHVog=cLooPh>3o6QXJoe]KFomNGUko6QXJoe=CD`Goh>3P
00go<S8bohZ:R_oPh>3oh>3Pob8R8_m<C4cog]kNon3Ph?lN7QkoUiNGomoO
golE5AGo/[:b00;oh>3P00?o;bl_ohJ6Q_oPh>001?oPh>000olb<S;oRXZ:
on3Ph018on3Ph003oo3`l?nm_Kgoh>3P057oh>3P00Go6QXJocXj>_l_;boo
5aLGojVYZ@02on3Ph003olC4a?l10@7o/[:b00;oh>3P00Go9RHVog=cLooP
h>3o8R8Rog9bLP02on3Ph006oeQHF?mMGEgoh>3PolC4a?l10@7o/[:b0_oP
h>001OlV9RKoLg=con3Ph?lJ6Q[oTI6A00?oh>3P00Kofm_Ko`820_nCTi?o
a<C4o`410Onb/[82on3Ph005obHV9_mcLg?ogMgMoa4A4Onb/[800_oPh>00
0ol`<33oQXJ6on3Ph01=on3Ph003oo3`l?nm_Kgoh>3P053oh>3P00Go6QXJ
ocXj>_l_;boo5aLGojVYZ@02on3Ph003olC4a?l10@7o/[:b00;oh>3P00Go
9RHVog=cLooPh>3o8R8Rog9bLP02on3Ph006oeQHF?mMGEgoh>3PolC4a?l1
0@7o/[:b0_oPh>002?lV9RKoLg=con3Ph?lJ6Q[o6a/Ko`000?m8B4Sog]kN
0_oPh>001OlR8R;oVi^Kon3Ph?lR8R;oGEeM00;oh>3P00?ogmoOoaDE5Onb
/[800_oPh>000ol_;booQXJ6on3Ph01>on3Ph07ol?3`0Onm_Kd00003ojn_
[ooIfMWofMWI04OofMWI00Ko6ATIohn?SooIfMWoT92@o`P82?o@d=02omWI
f@0=ofEUIOlI6AWoKVi^ocXj>_lR8R;ocLg=omWIfOlQ8B7o@T92ochn?_m6
ATKo10@4oj>SX`02omWIf@0CofEUIOlI6AWoKVi^ocXj>_lR8R;ocLg=omWI
fOlI6AWoShn?omWIfOn[Zj_o0000ojBTY?oIfMWoA4A4of=SHom^KVko1@D5
ol?3``02omWIf@0=ob4Q8Om:BT[o<C4aoe=CDol61PKoc<c<omWIfOmXJ6So
5aLGofi^K_l];Bgo3@d=oh>3P`02omWIf@05odA4A?mSHf?oKVi^o`D51Oo3
`l<0BOoIfMT00oo`l?3o[jn_omWIf@1AomWIf@06oaTI6On?ShoofMWIoi2@
T?l820Sod=3@0_oIfMT03OmUIFGo6ATIofi^K_lj>S[o8R8Rolg=cOoIfMWo
8B4Qod92@_ln?SkoATI6o`@41?nSXj<00_oIfMT02OmUIFGo6ATIofi^K_lj
>S[o8R8Rolg=cOoIfMWo6ATIohf=S@03omWIf@0Aoj2PX?l0003oYJFUomWI
fOmUIFGo6ATIofi^K_lj>S[o8R8Rolg=cOoIfMWoIVIVoaLG5om^KVko;bl_
o`d=3On3Ph<0C_oIfMT00oo`l?3o[jn_omWIf@1@omWIf@06oaTI6On?Shoo
fMWIoi2@T?l820Sod=3@0_oIfMT03OmUIFGo6ATIofi^K_lj>S[o8R8Rolg=
cOoIfMWo8B4Qod92@_ln?SkoATI6o`@41?nSXj<00_oIfMT03?mUIFGo6ATI
ofi^K_lj>S[o8R8Rolg=cOoIfMWo6ATIohn?Soo7alOo@d=3of9RHP;ofMWI
00ko8B4QoiJFU_oIfMWo8B4Qochn?_ll?3coRHV9omWIfOmXJ6So5aLGofi^
K_l];Bgo3@d=oh>3PdoofMWI0Oo`l?01ojn_[`0000?oZZZZomCDe?oDe=@0
AooDe=@01_lH61SoS8b<omCDe?o5aLGo0000oj:RXP?oe=CD00CoX:2PogAd
M?n8R8Sobl_;0_oDe=@01OlP823oTi>Coj:RX_meMGGoYjNW00Coe=CD00Co
X:2PogAdM?n8R8Sobl_;0_oDe=@02olH61SoS8b<omCDe?o=cLgo1`L7ohf=
SOoDe=Co_[jnohn?SomjNW[o];Bd00?oe=CD00GoTi>Cokbl_?n/[:coNWYj
okRh^003omCDe005oiFEUOmeMGGo[:b/oc8b<_n0P8000_oDe=@01?nn_[ko
Shn?ogYjN_nd];A:omCDe003oo3`l?nZZZ[oe=CD057oe=CD00Ko61PHohb<
S?oDe=CoaLG5o`000?nRXZ83omCDe004oj2PX?mdM7CoR8R8ol_;b`;oe=CD
00Go820Poi>CTonRXZ;oMGEeojNWY`04omCDe004oj2PX?mdM7CoR8R8ol_;
b`;oe=CD00?o61PHohZ:R_oDe=@00_oDe=@00omGEeOo4a<Col[:bP02omCD
e004oj2PX?mdM7CoR8R8ol_;b`?oe=CD00GoUYJFogEeMOn/[:coVIVIokFe
]@1>omCDe003oo3`l?nZZZ[oe=CD053oe=CD00Ko61PHohb<S?oDe=CoaLG5
o`000?nRXZ83omCDe004oj2PX?mdM7CoR8R8ol_;b`;oe=CD00Go820Poi>C
TonRXZ;oMGEeojNWY`04omCDe004oj2PX?mdM7CoR8R8ol_;b`;oe=CD00ko
61PHohb<S?oDe=CoShn?o``<3?oCdm?oe=CDoi>CTonl_;coe=CDoi>CTonl
_;coWIfMoi2@T0;oe=CD00GoUIFEogEeMOn/[:co<S8boh20P01?omCDe07o
l?3`0OnZZZX00003ok2`/?oHf=Sof=SH04Oof=SH00Ko6ATIof][Jon?Shoo
A4A4oaHF5_oDe=@9omSHf003ob4Q8OnEUIGof=SH00cof=SH00Ko6ATIof][
Jon@T93oCDe=o`/;2oo?cllComSHf003oc<c<on2PX;of=SH04oof=SH00?o
l?3`ok2`/?oHf=P0DOoHf=P01_lI6AWoJf][ohn?Som4A4Co5QHFomCDe0Wo
f=SH00?o8B4QoiFEUOoHf=P03?oHf=P01olI6AWoJFUYoijNW_n9RHWoCdm?
o`/;2onEUID0GOoHf=P00oo`l?3o/;2`omSHf01@omSHf006oaTI6Om[Jf_o
Shn?odA4A?lF5QKoe=CD2OoHf=P00olQ8B7oUIFEomSHf00<omSHf005oaTI
6OmZJV[oPh>3obPX:?m1@D400_oHf=P00omoOgoo]kNgomSHf009omSHf003
oc<c<on2PX;of=SH04kof=SH0Oo`l?01ok2`/00000?o/k>comcLg?oLg=`0
AooLg=`01OmIFEWoAdM7odY:B_mgMgOo_;bl00[og=cL00?o8B4QoiRHV?oL
g=`03?oLg=`01OmIFEWoAdM7od];BomNGUkoZJVY01Cog=cL00?o=3@dohB4
Q?oLg=`0CooLg=`00oo`l?3o/k>comcLg01AomcLg005oeUIFOm7AdOoBTY:
ogMgMonl_;`02_oLg=`00olQ8B7oV9RHomcLg00<omcLg006oeUIFOm7AdOo
AdM7oeMGEomeMGGo_KfmG_oLg=`00oo`l?3o/k>comcLg01@omcLg005oeUI
FOm7AdOoBTY:ogMgMonl_;`02_oLg=`00olQ8B7oV9RHomcLg00<omcLg005
oeUIFOm7AdOoDU9BohF5QOo8b<P00_oLg=`00omNGUko[Zj^omcLg009omcL
g003oc@d=?n4Q8Cog=cL04kog=cL0Oo`l?01ok>c/`0000?o];BdomcLg?oL
g=`0E_oLg=`00on][Jgobl_;omcLg00UomcLg003ok6a/Oo6a/Kog=cL04oo
g=cL00?ol?3`okBd]?oLg=`0H?oLg=`00on][Jgobl_;omcLg01`omcLg003
oo3`l?nd];Cog=cL05oog=cL00?o[Jf]ol_;booLg=`07ooLg=`00ona/K7o
a/K6omcLg01>omcLg07ol?3`0Ond];@00003ok6a/OoIfMWofMWI0=3ofMWI
00?ol?3`ok6a/OoIfMT0dooIfMT00oo`l?3o/K6aomWIf@3BomWIf@7ol?3`
0Ona/K400003ojNWYoo@d=3od=3@0=3od=3@00?ol?3`ojNWYoo@d=00doo@
d=000oo`l?3oYjNWom3@d03Bom3@d07ol?3`0OnWYjL00003oiNGUonn_[ko
_[jn0=3o_[jn00?ol?3`oiNGUonn_[h0donn_[h00oo`l?3oUiNGokjn_P3B
okjn_P7ol?3`0OnGUiL00=?oUIFE00?ol?3`oiFEUOnEUID0donEUID00oo`
l?3oUIFEoiFEU@3BoiFEU@7ol?3`0OnEUID00?ooOgmoEomoOgl7oginO_oo
Ogmo9?moOgl00004on_[jooVi^Koh^;RomkNgPCogMgM0_oNg]h2omgMg@03
omkNg_oLg=cog]kN00?ogMgM0?oog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]h000oogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kog=cLomgMgOoKfm/00_oLg=`0<ooMgMgogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNgP02omcLg005omWIfOoHf=SoemOGomSHf?oIfMX00_oLg=`0
M_oNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMh2omgMg@2NomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMh3omkNgP03omgMgOoN
g]kog]kN00?ogMgM0OoQhN41onOWi`7oj^[Z00000oo/k>coi^KVon3Ph007
omWIf@04omSHf?oFe]Kodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH
2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSH
f0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooH
f=SKomWIf@;of=SH00Koe]KFom?CdooCdm?oe=CDomOGeooHf=P2omWIf@03
omSHf?oIfMWofMWI00;of=SH2OoIfMT00ooHf=SofMWIomWIf@02omSHf003
omWIfOoHf=Sof=SH00;of=SH5ooIfMT01?oHf=Soe]KFom;Bd_o?cll2olg=
c@04olo?cooCdm?oemOGomSHf?oofMWI5_oIfMT00ooHf=SofMWIomWIf@06
omWIf@7og]kN0OoVi^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoP
h>3oh^;R00;ohN7Q00gogMgMomcLg?oCdm?oalO7ok^k^ona/K7o[Zj^ok:b
/_nj^[[oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?oalO7
ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00go
gmoOom_KfooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooK
fm_ogmoO0=[ohN7Q00Woh>3PomoOgooKfm_oe]KFomCDe?oFe]Kof][JomkN
g_oPh>001_oOgml3on3Ph003omoOgooPh>3oh>3P00;oh>3P2?oOgml2omkN
gP;ogmoO0ooPh>02omoOg`;oh>3P0_oOgml=on3Ph005omoOgooMgMgofMWI
omGEeOoCdm<00_oBd]800ooFe]Kog=cLon3Ph01^on7Qh@03on3Ph?oQhN7o
hN7Q00GohN7Q00?oh>3Pon7QhOoQhN40<_oQhN400ooPh>3ohN7Qon7Qh@1Y
on7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoShn<1onWYj@7okNg]00000oo`
l?3okno_oo7al@03oo3`l03oono_koo`l?3ok^k^onWYjOoKfm_o`L71ojBT
Y?n;Rh_oNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7a
ono_kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2`_nTY:Co
S8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<
S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]kOoalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_000Koo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNook^k^ono_kooZj^[oinOW00;oh>3P00Oohn?Son_[jOo[jn_o
j^[ZonKVi_oXj>SoinOW00;ojNWY01;ok^k/onc/k?o/k>coj>SXonc/k?o]
kNgol?3`onc/k?oZj^Soi^KVonSXj?oWinOojNWYonSXj?o[jn_oinOWonOW
iOoUiND2onWYj@0?onk^k_o]kNgokNg]onSXj?o[jnWok>c/onk^k_oYjNWo
j^[Zon_[joo_knook>c/onc/j_oZj^[ok^k^00;ok>c/0?ooj^[Zono_koo/
k>cok>cZon[Zj_o^k^kok>c/ojn_[omfMWKoFEUIofi^K_ng]kKoh>3PonWY
jOo]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knl002golO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knl01?o`l?000003oo;bl_o^k^koinOW
00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;o
ADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@00ooUiNGoi>CTonGU
i002onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5
oe5ADOmVIVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT0>goiNGUonCTi?oUiNGo
i>CTonCThooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmA
DE7oIVIVohZ:R_na/K7odM7AomkNg_oTi>?oi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiN@00_oTi>@0D?o5
aLGo:2PXodA4A?n@T93odM7AomcLfooKfm_oemOGomCDe?oFe]Koe=CDomGE
eOoIfMWoh>3OomkNg_oJf][oe=CDomWIfOoNg]koh^;RomcLg?oGemKoe=CD
omKFe_oDe=CoeMGEomSHf?oKfm_oemOGomKFeOoEeMGoemOGomSHf?oNg]ko
gmoOomcLg?oEeMGoemOFomcLg?oMgMgoemOGomKFe_oKfm_ohN7QomkNg_oK
fm[of][JomkNg_oLg=cof][Jom_KfooPh>3ogmoOomcLfooIfMWog]kNomoO
gomdM7CoIfMWohf=SOmDE5Co20P8oj:RX_oLg=coh^;RonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGU0ooTi>@0WOoUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiND00ooTi>@0I?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>@4onGUi@06onCTi?oUiNGoiNGUonGUiOoXj>SokNg]0Oob
l_800003ooCdm?o]kNgoinOW00;oh>3P01?ohN7QomoOgooNg]kod];BokBd
]?n7QhOoG5aLofdk=OnNCT;ocFmOonV3Koo<KUkoWTi3ofdk=_mLG5coQhN7
okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m]H2co
WYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aLohN7Qond];Cod];BomkNgP05
on3Ph00AomkNg_oBd];o];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=
AomZWSCoBFX_oeaLG?n7QhOo];Bdom;Bd_oNg]h0fOoPh>001_oOgmooclo?
oiVIVOnBTY;o6ATIohb<S0;oeMGE01ooclo?ol;2`_o>c/koc/k>olG5aOo:
b/[of][JomSHf?o@d=3obl_;olo?cooHf=Sof][JomGEeOo?cloo`L71om3@
d?o>c/koa<C4ol_;booHf=SoemOGokjn__nk^k_odM7Aom3@d?oEeMGof=SH
om?Cdoo<c<coc/k>00;oeMGE00Goc/k>olc<c?oCdm?of][JomSHf002om;B
dP04omSHf?oGemOodM7Aom?Cd`;ofMWI00Kodm?Com7AdOoGemOof=SHom7A
dOo@d=02om7Ad@04odI6A_m1@D7oemOGomkNgW3oh>3P00?ogmoOon3Ph?oP
h>000_oPh>000ooOgmooh>3Pon3Ph02Mon3Ph003omoOgooPh>3ogmoO00;o
gmoO0ooPh>000ooQhN7oinOWonc/k001oo?cl`0000?om_Kfoo;bl_o[jn/0
0ooXj>P04ooWinOoh^;Rolg=cOnNWYkoJemOohle;Oo]LF7onIf@oofaYOom
_:oooKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;Rh_oWinL00ooXj>P0
4ooWinOoh^;Rolg=cOnOWiooKVIOoi=b8_o]dDConO=doogmSOomoIGooOf>
ooWhM_o]edOoTg<RofiWGonOWioocLg=on;Rh_oWinL00ooXj>P04ooWinOo
h^;Rolg=cOnOWiooH6QOod]l8onBhD_o_OUkom3mT_oHoI_oe?fEol3iO_nH
j4goCH0Tof1YGonOWioocLg=on;Rh_oWinL0f_oXj>P01?oVi^KohN7QoeeM
GOm=CDd2omgMg@0Ooe1@D?l71`Oo5ADEohB4Q?lF5QKo@d=3on;Rh_oMgMgo
W9bLo`000?n?ShoogMgMon7QhOoKfm_o@410o`P82?lI6AWoR8R8o`/;2omH
F5So]kNgo``<3?l71`Oo8b<SobLW9ommOGgof][JomgMgOoDe=Co2`/;oeUI
F@02omWIf@03oeeMGOl;2`_odm?C00;ogmoO00KoFUYJodi>C_oNg]kog]kN
ob<S8on4Q8@2on7Qh@0<ogYjN_l^;RkogMgMomgMgOo2`/;oD51@oc<c<om^
KVkoPh>3ob4Q8OoNg]koi^KVoooXj>POonSXj07ok>c/0Oobl_81ooKfmP00
00?omoOgooShn?ohn?P00oohn?P04oogmoOok^k^olk>c_n@T93oQBl[onUT
E_okTXOooZJKooj`Y?oo^:_oo[>VoojWW?okU8WokVQIohTa:on@T93oc/k>
onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93oVFT[oo2m?Ookh6ko
o_B2ooknR_oooi;oo_j<ookhPookiG3ol<8noiUZ:on@T93oc/k>onk^k_og
moL00oohn?P04oogmoOok^k^olk>c_n@T93o@W<[ohC>@on]kg?o`_j8olkn
T?oFoiOod?jBolKnROnbmGCoR==3odAe:on@T93oc/k>onk^k_ogmoL0f_oh
n?P09Oofm_KolO7aoh61POlO7aookNg]olK6a_l0003o`l?3om?CdomLG5co
20P8on[Zj_o`l?3oj^[Zoe9BD_lD51Co?CdmonWYjOo`l?3o[jn_o`L71ooB
d];ocLg=odi>C_lK6a_ok^k^om_Kfon^[Zkoj>SXonc/k?n^[Zko0000okBd
]?o/k>co/;2`o`/;2olJ6QX00_oTi>@02olS8b?o3Ph>ojBTY?o]kNgok^k^
of1PH?mDE5Cok^k^ong]kOlV9RKoSHf=00;ol?3`00coPX:2oc4a<Oo/k>co
j^[Zod=3@ol_;booW9bLog=cLolZ:R[o6QXJonk^k_ofm_I^ooShn003ooOg
moohn?Son?Sh00Gon?Sh00?omoOgooShn?ohn?P0W_ohn?P00oogmoOon?Sh
ooShn002ooShn004ooOgmooinOWom_KfooOgm`7on?Sh00000oojn_[omOGe
onk^kP02onc/k03oon_[jooYjNWogmoOokVi^OmiDU;o_c4SonMdJOomR7ko
oiR<oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c9?miDU;o^[ZjomoOgooZ
j^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3ooMYSoooZ
L_onlgkoooZ2ookfOoook7?oo]iToo[7DOoRTQcoRFICokZj^_oOgmooj^[Z
on_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]D_mAXacoTM9EojKWJ_nhnG[o
`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]D_nj^[[ogmoOon[Zj_o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/0019
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/onWYjOoUiNGoNWYjoa`L7?oQhN;oc<c<o`<3
0onPX:3og]kNoiBDU?lC4a?ohN7Qon3PhOo@d=3o1PH6oj6QXOl92@Wo_kno
on7QhOnj^[[o0P82ok:b/_oMgMgoP820obPX:?oShn?oinOWonGUiOoOgmoo
fm_Kom?Cdol820SoQHF5omoOgomYJFWoBTY:ocDe=On][Jgo_Kfmo`L71omh
N7SoEEEEomoOgooPh>3oFe]Koe1@D002on7Qh@0:ob@T9?n5QHGogmoOon7Q
hOmkNg_o;bl_on3Ph?oDe=Co1@D5ojRXZ0;ohn?S01CoOWiooaHF5_oQhN7o
j^[Zon_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k0?ojn_[09Ook>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/00;ojn_[00Cojn_/onc/k?o[jn_ok>c/0oo[jn/0H_o/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/1_o[jn/01Oo/k>cojn_[on_[joo^k^ko
m_Kf007onOWi00000ookno_olo?cong]k@02onGUi@3oonKVi_oTi>CofMWI
ok:b/_mh;Bgob48don=ZG?odNVgooHQloojGR_onVhkooYR;ooj:O_odNfgo
if]MolY2=?mk;Rko/[:bomSHf?oTi>CoiNGUonKVi_oUiNKoi>CTomSHf?nb
/[;oUUD^onZL:ook_4Coo/aCoogHH_onhg;oo^UeookVLoonffGooLaCoo_1
AOo^WR_oVEH^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGUonCTi?oHf=Wo/[:b
obiR;_mS[B_oQlY8oiOLFOnUiFWo/_=gokSfNondmGWoYnY[oiSLFOn9cd_o
Hjh[obiS;_nb/[;of=SIonCTi?oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGV000donKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVon?ShooO
gmooMgMgoa/K6ooLg=cohN7QoijNW_l_;boo:b/[oc8b<_lB4Q;og=cLom[J
fon4Q8Co820Pon3Ph?mBDU;oJ6QXom[Jf_oNg]koT92@obXZ:_l^;Rko;2`/
obLW9`;og]kN01?ofMWIom?Ce?o@d=3oFe]Ko`000?nm_Kgof][JobPX:?n7
QhOoMgMhofQXJ?n2PX;o?3`lol;2`_l?3`ooe=CDom[Jf_mIFEWoCTi>00;o
g=cL07ko8b<Soh61POoEeMGoemOGogMgMol^;Rkog=cLoj>SXol0003oalO7
omSHf?oIfMWoSHf>oaDE5OoLg=cohn?SonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^H3onGUi@2TonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNH2onKViP03onGUiOoVi^Koi^KV00?oi^KV00?oiNGUong]kOoclo<00Ooj
n_X00003ooclo?ohn?SolO7a00?ok^k^01?ojn_[on7QhOnl_;coNQLGol<o
<_oCETWoi6QJonmgK?ocPgSon8MlooF4N_ocNFgoiFUKomUHB_o4?c;oO1LG
okbl_?oQhN7ok>c/00?ok^k^01?ok>c/on7QhOnl_;coYDLGonJG<_oe[33o
oKa1oog9Doomd63onm=UoogBH?oncECooKe2ooZ_<_oYVc;oYDHGokbl_?oQ
hN7ok>c/00?ok^k^01?ok>c/on7QhOnl_;co5eTGoenX<_mf_COoQ/e7oiKF
F_nRh6GoXn1Yoj?QIonGfUcoQ/i7ogNo=omOZc;o5eTGokbl_?oQhN7ok>c/
0=[ok^k^02kok>c/onOWiomkNg_o71`LonCTi?oYjNWoi^KVon7QhOoNg]ko
SHf=oa@D5?oVi^Koi>CTocDe=OmiNGWojn_[ok:b/_lE5AGogmoOonKVi_oT
i>CohN7QomgMgOmjNW[o:BTYonSXj?oUiNGogMgMok6a/OlV9RKo2`/;oi^K
VooYjNWoc<c<o`000?o>c/ko`l?3obDU9Om;Bd_oO7alonSXj?la<C7oYJFU
onCTi?mMGEgoDE5A0_oWinL02_lU9BGoJFUYomoOgooOgmooMgMgoc4a<OoY
jNWo`L71o`000?nWYjL2omoOg`04oi>CTolF5QKoinOWonc/k:_ok^k^00?o
kNg]onk^k_o^k^h0Koo^k^h00oo]kNgol_;booShn001ooclo0000oomoOd0
5_olo?cooOgmoogmoOolo?colo?com7AdOmX1`Oo^3@dolLo<ooBD4?ofV9E
on=^H_oTLVCoi6mRomaTEooCDD?oc44dokTd=?m[1`Ood];Boo?cloolo?`3
oogmo@0Cooclo?oclo?od];Boih[1ooJRSCoji/IooFX:Ooh]3oonKe:ooRo
COoj_d[onKPoooJZ:_o_WQWofh/doj8]1ooBd];olo?cooclo003oogmo@0C
ooclo?oclo?od];Bo`M01om=VSCoGj/Pog2h;omo`d?oR/e@ohg=D_n:cU3o
PLM4og6i;omR[R3oCY/do`M21ooBd];olo?cooclo03Joogmo@0Soo_knoog
moOoQ8B4oahN7_oclo?onOWiok>c/oo@d=3olo?cofQXJ?m7AdOon_[jomCD
e?l0003ogMgMooclo?okno_o9bLWojRXZ?oinOWoZj^[omGEeOoalO7oE5AD
oeiNG_oinOWom?CdoiBDU?l51@Go@410om7AdOogmoOon?ShoiNGUol[:b/0
0_ojn_X06olT92Co1`L7olS8b?okno_oQHF5of=SHoogmoOoHf=SoeMGEooh
n?SonOWiobLW9olE5AGoPh>3omOGeom2@T;oHf=Soo_knoojn_[o=3@dodU9
BOoKfm_oiNGUodm?ColG5aOon_[jooclo03ooogmoAcooOgm00?oo?cloogm
oOolo?`00oomoOd0000joogmoOojn_[olo?conk^k_o`l?3okno_onk^k_oY
jNWodm?Coe/M7OnR=3Co/bLLol4j;Oo7BCcoceI:om1GBoo@Ed[obTXnol<k
;_nf:1goXS@doe`M7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`koo^k^koj^[Z
om?Cdon<9Agob74domV47OoTU1GoiidTonjX<oo`ZSCokjXconbP9OoWUaGo
g8PMolQa=?n<9Agodm?Con[Zj_o^k^kol?3`ono_koo`l?3ok^k^on[ZjOoC
dm?o7CPMocB2=?m7UAgoFZDKofV]:P;oM;Ph0>;oMKThof^a:omKYacoB9XM
ocB2=?lM>1godm?Con[ZjOo^k^kol?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`0_o_knl0C_oZj^[o
OWinoa`L7?oXj>OokNg]ohR8R?l`<33o3`l?oc4a<Ona/K7ok^k^ohF5Q?m=
CDgokno_onk^k_o_knooRXZ:oeUIFOo^k^koN7Qhob/[:ol?3`oo>3Phokno
_oo]kNgoi>CTo`h>3_mYJFWogmoOon?ShooUiNGojn_[of5QHOmgMgOok^k^
ono_k_mfMWKo9RHVong]kOo_knooc<c<ob`/;?oZj^[oKFe/of9RH_o/k>co
kNg]oc/k>onCTi?oHV9Ro`h>3_ld=3Coa<C4ono_koo^k^kodM7Aoc`l??l:
2P[o9bLWofa/K?l/;2cokno_onk^k_o`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l0?okno_0?oo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`onk^
k_o`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?0000Gokno_oo3`l?o_knoo
l?3_ono_k`02oo3`l0Kokno_0Ooclo<1ooWin@7oo_kn00000oono_komoOg
oo3`l004onWYj@0AonOWiooKfm_oHd];oh4b<_nV=CGo]S@]ol9=@Oo3E4Wo
a5E:ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooWinL01OoYjNT04OoW
inOofm_KohU;Bon_Bc;ocGLeomJ;;OoPW2koh:0bon6P=?oPX3;ogiX^omJ;
;Oo:MCGo[d/bohU;BooKfm_oinOW00GojNWY017oinOWom_Kfom;Bd_o<V0b
ocZ9=OmCVbgoJj/_og2]>?m_[S[oL:dhofZZ;omCVbgo>HPeoc9P<_m;Bd_o
fm_KonOWi`3KonWYj@06onSXj?oVi^KoNg]koa`L7?oTi>Coj>SX0_oYjNT0
0ooWinOojNWYonWYj@0;onWYj@0<onOWiooYjNWojNWYonSXj?oHf=So2PX:
ojj^[_oMgMgog]kNon3Ph?oUiNGoj>SX2?oYjNT01_oXj>Soi^KVon?ShooS
hn?oi^KVonSXj0?ojNWY00?oj>SXonWYjOoYjNT01?oYjNT00ooWinOojNWY
onWYj@3oonWYjA_ojNWY00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07om_Kf
0Oono_h00005ookno_ojn_[om?Cdono_kooalO400_o`l?004Oo_knoojn_[
oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZNW?oIW9coe9FEok]cLonEE5Co
Cb<SoiFDU?oZj^[okno_00Gol?3`017okno_on[Zj_nYU9CoPB<SokYZE?oD
VW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S8onZU9Coj^[Zono_
k`05oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCoLjEcoik6UOn/cYco[LjL
ojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Zj_o_knl0foo`l?02ono_k`04
oh20P?lM7Agok^k^ono_ka?ol?3`0_o_knl01omTI6Co:BTYoh61POmSHf?o
>c/konk^k_o_knl02?o`l?001_o_knook^k^og=cLomYJFWok^k^ono_kooo
l?3`;Oo`l?001?oalO7ol?3`ooCdm?ojn_X1ooknoP0000Cok>k`oooooooo
ooooo_kn0_ooool2ooknoP3ooogmoOohn?SoKVi^oeXo?onaT93og/W9oo3T
i?oci^Kol>CTomk9bOnaT93oFSloofe]KOohn?Soo?clooooooono_kooooo
ookno_ooookoo_knooooooolo?con?Shohe]KOn:?coobI6@onW@bOodjNCo
m^_VooCYi?oYd<WobI6@ohTo?on=KFgon?Sgooclo?ooooooo_knooooooon
o_koooooookno_ooookoo?clooShn?m]KFgo?clooi2MT?o9eLWoi>cTonK^
i_oTk>CobMG9oi2MT?lo?cooKFe]ooShn?olo?coooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_kn000hooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooomoOgod=3@ojFUYOono_goo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_kooooooogmoOo1`L3oLG5aoh61
POn_[jl2ooknoP0<ooooooono_koooonookno_ooooooo_knooooooono_ko
oooooogmoOo2`/7o_;bl0_ono_h0ooooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooo`00:Oono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn00;ooooo
00?oo_knooooooooool00oooool1ooWjn`0000Co`<O=ookno_ojn_[om?Cd
1OoalO403Oo_knooe]KFof][Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3
?CgoJf][omKFe_o_knl02OoalO403Oo_knooemKFoh=[Jomd?Cgo]Hb<omFj
^_oQc<coe[ZjokJ<S?mb?CgoPF][omOFe_o_knl02OoalO403Oo_knooe]KF
of][Jolm?CgoS8b<okZj^_o<cLco^[Zjohb<S?lm?CgoJf][omKFe_o_knl0
oooalO4Loo7al@03oo3`l?oalO7olO7a0?oolO7a5OoalO401?o`l?3olO7a
oo7alOo`l?04oo7al@03ooCdm?ojn_[oo_kn007ojng^00001On3SiWooOgm
ooShn?o`l?3ojn_[00?oj^[Z00gojNWYon[Zj_oYjNWoj>SXoi^KVomIFEWo
9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nP
Vi_oJUUIod<V9_l]2@Wo@RHVofUIFOnPVi_oj>SXonWYj@0;on[ZjP0;onWY
jOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT0oooZ
j^XLon[ZjP03onWYjOoZj^[oj^[Z0?ooj^[Z7OoZj^X01?o[jn_ol?3`ooSh
n?omoOd1om7Ee`0000Co=TI@okRoaOojn_[om?Cd2?oalO42oo3`l0?okno_
0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`
oooalO4Poo7al@03oo3`l?oalO7olO7a0?oolO7a5ooalO400oo`l?3olO7a
oo7al@02oo7al@03ooGemOoinOWok>g_007oXZFX00000olM;cgoCEQSokVo
aP3oooooooooooooO?ooool1ong_l07o[K2c0OnUZJd00006oah_?OlK:3Co
<Si8ogf8TOnm`lOojnc^ooooooooooooogKooooo00Goj^c]ok^o`_mjPHOo
:cDmoa8P:P01oa@S;`00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<javax.swing.Box\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["javax.swing.Box", 87]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(base = javax`swing`Box`createVerticalBox[]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.Box"] \[RightGuillemet]\),
      JLink`Objects`JavaObject95500124553217]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(pane@add[base]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.Box"] \[RightGuillemet]\),
      JLink`Objects`JavaObject95500124553217]], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(rowData = 
      Table[\[IndentingNewLine]JavaNew["\<java.lang.String\>", 
          StringJoin["\<Food \>", ToString[i], 
            ToString[j]]], \[IndentingNewLine]{i, 4}, {j, 3}]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"{", 
          RowBox[{
            
            InterpretationBox[\(\[LeftGuillemet]JavaObject[
                  "java.lang.String"] \[RightGuillemet]\),
              JLink`Objects`JavaObject16510562988982273], ",", 
            
            InterpretationBox[\(\[LeftGuillemet]JavaObject[
                  "java.lang.String"] \[RightGuillemet]\),
              JLink`Objects`JavaObject16510563005759489], ",", 
            
            InterpretationBox[\(\[LeftGuillemet]JavaObject[
                  "java.lang.String"] \[RightGuillemet]\),
              JLink`Objects`JavaObject16510563022536705]}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{
            
            InterpretationBox[\(\[LeftGuillemet]JavaObject[
                  "java.lang.String"] \[RightGuillemet]\),
              JLink`Objects`JavaObject16510563509075969], ",", 
            
            InterpretationBox[\(\[LeftGuillemet]JavaObject[
                  "java.lang.String"] \[RightGuillemet]\),
              JLink`Objects`JavaObject16510563525853185], ",", 
            
            InterpretationBox[\(\[LeftGuillemet]JavaObject[
                  "java.lang.String"] \[RightGuillemet]\),
              JLink`Objects`JavaObject16510563542630401]}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{
            
            InterpretationBox[\(\[LeftGuillemet]JavaObject[
                  "java.lang.String"] \[RightGuillemet]\),
              JLink`Objects`JavaObject16510564029169665], ",", 
            
            InterpretationBox[\(\[LeftGuillemet]JavaObject[
                  "java.lang.String"] \[RightGuillemet]\),
              JLink`Objects`JavaObject16510564045946881], ",", 
            
            InterpretationBox[\(\[LeftGuillemet]JavaObject[
                  "java.lang.String"] \[RightGuillemet]\),
              JLink`Objects`JavaObject16510564062724097]}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{
            
            InterpretationBox[\(\[LeftGuillemet]JavaObject[
                  "java.lang.String"] \[RightGuillemet]\),
              JLink`Objects`JavaObject16510564549263361], ",", 
            InterpretationBox[\(\[LeftGuillemet]JavaObject[
                  "java.lang.String"] \[RightGuillemet]\),
              JLink`Objects`JavaObject16510564566040577], ",", 
            
            InterpretationBox[\(\[LeftGuillemet]JavaObject[
                  "java.lang.String"] \[RightGuillemet]\),
              JLink`Objects`JavaObject16510564582817793]}], "}"}]}], 
      "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(header = {\[IndentingNewLine]JavaNew["\<java.lang.String\>", \
"\<RoboPanda\>"], \[IndentingNewLine]JavaNew["\<java.lang.String\>", \
"\<RoboDog\>"], \[IndentingNewLine]JavaNew["\<java.lang.String\>", \
"\<RoboBird\>"]\[IndentingNewLine]}\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject33020840027095041], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject21179439601680385], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject8045370269499393]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(table = NewJTable[pane, rowData, header]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JTable"] \[RightGuillemet]\),
      JLink`Objects`JavaObject110149888901121]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(\(l = Flatten[rowData];\)\), "\[IndentingNewLine]", 
    \(Do[ReleaseObject[l[\([i]\)]], {i, 1, 
        Length[l]}]\), "\[IndentingNewLine]", 
    \(\(l =. ;\)\)}], "Input"],

Cell[BoxData[
    \(Do[ReleaseObject[header[\([i]\)]], {i, 1, Length[header]}]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(h = table@getTableHeader[]\), "\n", 
    \(table@remove[h]\), "\n", 
    \(ReleaseObject[h]\), "\n", 
    \(h =. \)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.table.JTableHeader"] \[RightGuillemet]\),
      JLink`Objects`JavaObject28489793142785]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(DeleteJObject[pane, table]\)], "Input"],

Cell[BoxData[
    \(DeleteJObject[pane, base]\)], "Input"],

Cell["\<\
Although components added to create JTable were removed explicitly \
in the above expressions, JTableHeader still remains on the pane. So we tries \
to remove all components on the pane.\
\>", "Text"],

Cell[BoxData[{
    \(\(l = pane@getComponents[];\)\), "\n", 
    \(Do[\[IndentingNewLine]pane@
        remove[l[\([i]\)]]; \[IndentingNewLine]ReleaseObject[
        l[\([i]\)]];, \[IndentingNewLine]{i, 1, 
        Length[l]}\[IndentingNewLine]]\), "\n", 
    \(l =. \)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["<<< SimpleJTable >>>",
  FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004j0000RaP00`40o`00
0?l0003oo`0003/000000003R<2hB928B9280?m8T8PgB9280@00000000>8
`;S8h=R8`;P0ohS0^3J8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^3J8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo<oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo<oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo<oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo<oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo<oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
oooo<oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Sooooo<oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;SoVIVI<iVIV@:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QU
oooo00>IVIWoooooool0Hoooo`03VIVIoooooooo06?oool019VIVHS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2hIOooo`03VIVIoooooooo06?oool0
0iVIVOooooooo`1Soooo00BIVIV8`;R8`;Q8T8P10000000018S0^<SPf8S0
^8S0^6Goool00iVIVOooooooo`1Soooo00>IVIWoooooool0Hoooo`04VIVI
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P2oooo00<0003oooooool0
1Oooo`<00004oooo0`0000Coool2000000?oool0003oool01oooo`030000
oooooooo00?oool00`000?ooooooo`0hoooo00BIVIWoooooool00007oooo
0`0000Coool300001?ooo`8000000oooo`000?ooo`07oooo00@0003ooooo
ooooool50000>?ooo`04VIVIoooooooo00001oooo`<00004oooo0`0000Co
ool2000000?oool0003oool01oooo`030000oooooooo00;oool30000>Ooo
o`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P2oooo00<0003o
ooooool01?ooo`050000oooooooooooo000000;oool01@000?oooooooooo
o`000002oooo00<0003oooooool00P0000Soool00`000?ooooooo`03oooo
00<0003oooooool0>?ooo`04VIVIoooooooo00001_ooo`050000oooooooo
oooo000000;oool01@000?ooooooooooo`000002oooo00<0003oooooool0
0P0000Soool00`000?ooooooo`02oooo00<0003oooooool0>Oooo`04VIVI
oooooooo00001_ooo`050000oooooooooooo000000;oool01@000?oooooo
ooooo`000002oooo00<0003oooooool00P0000Soool01@000?oooooooooo
o`000003oooo00<0003oooooool0=_ooo`04VIVIR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P2oooo00<0003oooooool01?ooo`050000oooooooo
oooo000000;oool01@000?ooooooooooo`000002oooo00D0003ooooooooo
ool000001Oooo`D00004oooo00<0003oooooool0>?ooo`04VIVIoooooooo
00001_ooo`050000oooooooooooo000000;oool01@000?ooooooooooo`00
0002oooo00D0003oooooooooool000001Oooo`D00004oooo00<0003ooooo
ool0>?ooo`04VIVIoooooooo00001_ooo`050000oooooooooooo000000;o
ool01@000?ooooooooooo`000002oooo00D0003oooooooooool000001Ooo
o`D00006oooo00<0003oooooool0=_ooo`04VIVIR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P2oooo00<0003oooooool01?ooo`050000oooooooo
oooo000000;oool01@000?ooooooooooo`000002oooo00D0003ooooooooo
ool000001Oooo`040000oooooooo00001Oooo`030000oooooooo03Soool0
19VIVOooooooo`0000Koool01@000?ooooooooooo`000002oooo00D0003o
ooooooooool000000_ooo`050000oooooooooooo000000Goool010000?oo
ooooo`0000Koool00`000?ooooooo`0goooo00BIVIWoooooool00006oooo
00D0003oooooooooool000000_ooo`050000oooooooooooo000000;oool0
1@000?ooooooooooo`000005oooo00@0003oooooool00007oooo00<0003o
ooooool0=_ooo`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P2
oooo100000?oool01@000?ooooooooooo`000002oooo00D0003ooooooooo
ool000000_ooo`050000oooooooooooo000000Koool00`000?ooo`000005
oooo00<0003oooooool0>?ooo`03VIVIoooooooo00@00003oooo00D0003o
ooooooooool000000_ooo`050000oooooooooooo000000;oool01@000?oo
ooooooooo`000006oooo00<0003oool000001_ooo`030000oooooooo03Oo
ool00iVIVOooooooo`0400000oooo`050000oooooooooooo000000;oool0
1@000?ooooooooooo`000002oooo00D0003oooooooooool000001_ooo`03
0000oooo000000Goool20000>Oooo`04VIVIR<2hR<2hB9280@00000000B8
`;S8h=R8`;R8`;P2oooo00<0003oooooool01?ooo`050000oooooooooooo
000000;oool01@000?ooooooooooo`000002oooo00<0003oooooool00P00
00Koool00`000?ooo`000005oooo00<0003oooooool0>?ooo`04VIVIoooo
oooo00001_ooo`050000oooooooooooo000000;oool01@000?oooooooooo
o`000002oooo00<0003oooooool00P0000Koool00`000?ooo`000007oooo
00<0003oooooool0=_ooo`04VIVIoooooooo00001_ooo`050000oooooooo
oooo000000;oool01@000?ooooooooooo`000002oooo00<0003oooooool0
0P0000Koool00`000?ooo`000007oooo00<0003oooooool0=_ooo`04VIVI
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P2oooo00<0003oooooool0
1Oooo`<00004oooo0`0000Coool2000000?oool0003oool01_ooo`800003
oooo00<0003oool00000>_ooo`04VIVIoooooooo00001oooo`<00004oooo
0`0000Coool2000000?oool0003oool01_ooo`800007oooo00<0003ooooo
ool0=_ooo`04VIVIoooooooo00001oooo`<00004oooo0`0000Coool20000
00?oool0003oool01_ooo`800007oooo00<0003oooooool0=_ooo`04VIVI
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P2oooo00<0003oooooool0
5_ooo`030000oooooooo00Goool200001?ooo`80000joooo00BIVIWooooo
ool0000Hoooo00<0003oooooool01Oooo`800003oooo00D0003ooooooooo
ool00000>?ooo`04VIVIoooooooo00006?ooo`030000oooooooo00Goool2
00000oooo`050000oooooooooooo000003Soool019VIVHS0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h0_ooo`D0000Doooo00<0003oooooool01_oo
o`030000oooooooo00?oool00`000?ooooooo`0hoooo00>IVIWoooooool0
1@0001Coool00`000?ooooooo`06oooo00<0003oooooool00_ooo`<0000i
oooo00>IVIWoooooool01@0001Coool00`000?ooooooo`06oooo00<0003o
ooooool00_ooo`<0000ioooo00BIVIV8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^6Goool00iVIVOooooooo`1Soooo00>IVIWoooooool0Hoooo`04
VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;QUoooo00>IVIWooooo
ool0Hoooo`03VIVIoooooooo06?oool019VIVHS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2hIOooo`03VIVIoooooooo06?oool00iVIVOooooooo`1S
oooo00BIVIV8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^?nIVITcVIVI
0XS0^058T8P10000000018S0^<SPf8S0^8S0^6Goool00iVIVOooooooo`1S
oooo00>IVIVIVLbIVL`0HiVIc004VIVIR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;QUoooo00>IVIWoooooool0Hoooo`03VIVIVIW<oooo06;oool0
1IVIc9VIVHS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^6Goool00iVI
VOooooooo`1Soooo00>IVIVIVLcoool0H_ooo`05VIW<VIVIR<2hR<2hB928
004000000004R<2hb>3HR<2hR<2h0_ooo`030000oooooooo00Goool30000
1?ooo`<00004oooo0P000003oooo0000oooo00Goool300001Oooo`030000
oooooooo03Soool019VIVOooooooo`0000Ooool300001?ooo`<00004oooo
0P000003oooo0000oooo00Goool300000oooo`D0000hoooo00BIVIVIVLco
ool00007oooo0`0000Coool300001?ooo`8000000oooo`000?ooo`05oooo
0`0000Coool30000>?ooo`05VIW<VIVIR<2hR<2hB928004000000004R<2h
b>3HR<2hR<2h0_ooo`030000oooooooo00Coool01@000?ooooooooooo`00
0002oooo00D0003oooooooooool000000_ooo`030000oooooooo00800005
oooo00D0003oooooooooool000001?ooo`030000oooooooo03Soool019VI
VOooooooo`0000Koool01@000?ooooooooooo`000002oooo00D0003ooooo
ooooool000000_ooo`030000oooooooo00800005oooo00D0003ooooooooo
ool000000oooo`030000oooooooo03Woool019VIVIVIc?ooo`0000Koool0
1@000?ooooooooooo`000002oooo00D0003oooooooooool000000_ooo`03
0000oooooooo00800005oooo00D0003oooooooooool000000_ooo`050000
oooooooooooo000003Ooool01IVIc9VIVHS0^8S0^4R@R0010000000018S0
^<SPf8S0^8S0^0;oool00`000?ooooooo`04oooo00D0003oooooooooool0
00000_ooo`050000oooooooooooo000000;oool01@000?ooooooooooo`00
0009oooo00<0003oooooool00_ooo`030000oooooooo03Soool019VIVOoo
ooooo`0000Koool01@000?ooooooooooo`000002oooo00D0003ooooooooo
ool000000_ooo`050000oooooooooooo000000Woool00`000?ooooooo`02
oooo00<0003oooooool0>?ooo`04VIVIVIW<oooo00001_ooo`050000oooo
oooooooo000000;oool01@000?ooooooooooo`000002oooo00D0003ooooo
ooooool000002Oooo`030000oooooooo00Coool00`000?ooooooo`0eoooo
00FIVLbIVIV8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P2oooo00<0
003oooooool01?ooo`050000oooooooooooo000000;oool01@000?oooooo
ooooo`000002oooo00D0003oooooooooool000002Oooo`030000oooooooo
00;oool00`000?ooooooo`0hoooo00BIVIWoooooool00006oooo00D0003o
ooooooooool000000_ooo`050000oooooooooooo000000;oool01@000?oo
ooooooooo`000009oooo00<0003oooooool00oooo`030000oooooooo03Oo
ool019VIVIVIc?ooo`0000Koool01@000?ooooooooooo`000002oooo00D0
003oooooooooool000000_ooo`050000oooooooooooo000000Woool00`00
0?ooooooo`04oooo00<0003oooooool0=Oooo`05VIW<VIVIR<2hR<2hB928
004000000004R<2hb>3HR<2hR<2h0_ooo`@00003oooo00D0003ooooooooo
ool000000_ooo`050000oooooooooooo000000;oool01@000?oooooooooo
o`000007oooo0P0000Goool00`000?ooooooo`0hoooo00>IVIWoooooool0
100000?oool01@000?ooooooooooo`000002oooo00D0003oooooooooool0
00000_ooo`050000oooooooooooo000000Ooool200001_ooo`030000oooo
oooo03Ooool00iVIVIVIc?ooo`0400000oooo`050000oooooooooooo0000
00;oool01@000?ooooooooooo`000002oooo00D0003oooooooooool00000
1oooo`800005oooo0P0003Soool01IVIc9VIVHS0^8S0^4R@R00100000000
18S0^<SPf8S0^8S0^0;oool00`000?ooooooo`04oooo00D0003ooooooooo
ool000000_ooo`050000oooooooooooo000000;oool00`000?ooooooo`02
00002Oooo`030000oooooooo00;oool00`000?ooooooo`0hoooo00BIVIWo
ooooool00006oooo00D0003oooooooooool000000_ooo`050000oooooooo
oooo000000;oool00`000?ooooooo`0200002Oooo`030000oooooooo00Co
ool00`000?ooooooo`0foooo00BIVIVIVLcoool00006oooo00D0003ooooo
ooooool000000_ooo`050000oooooooooooo000000;oool00`000?oooooo
o`0200002Oooo`030000oooooooo00Coool00`000?ooooooo`0eoooo00FI
VLbIVIV8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P2oooo00<0003o
ooooool01Oooo`<00004oooo0`0000Coool2000000?oool0003oool02?oo
o`060000oooooooo0000oooo0000>_ooo`04VIVIoooooooo00001oooo`<0
0004oooo0`0000Coool2000000?oool0003oool02?ooo`030000oooooooo
00Coool00`000?ooooooo`0foooo00BIVIVIVLcoool00007oooo0`0000Co
ool300001?ooo`8000000oooo`000?ooo`08oooo00<0003oooooool01?oo
o`030000oooooooo03Goool01IVIc9VIVHS0^8S0^4R@R0010000000018S0
^<SPf8S0^8S0^0;oool00`000?ooooooo`0Foooo00<0003oooooool00ooo
o`050000oooooooooooo000000?oool20000>_ooo`04VIVIoooooooo0000
6?ooo`030000oooooooo00?oool01@000?ooooooooooo`000002oooo00D0
003oooooooooool00000>?ooo`04VIVIVIW<oooo00006?ooo`030000oooo
oooo00?oool01@000?ooooooooooo`000002oooo00D0003oooooooooool0
0000=oooo`05VIW<VIVIR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h
0_ooo`D0000Doooo00<0003oooooool01?ooo`<00005oooo00<0003ooooo
ool0>?ooo`03VIVIoooooooo00D0000Doooo00<0003oooooool01?ooo`<0
0004oooo0`0003Woool00iVIVIVIc?ooo`0500005?ooo`030000oooooooo
00Coool300001?ooo`<0000hoooo00FIVLbIVIV8`;R8`;Q8T8P00@000000
00B8`;S8h=R8`;R8`;QUoooo00>IVIWoooooool0Hoooo`03VIVIVIW<oooo
06;oool01IVIc9VIVHS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^6Go
ool00iVIVOooooooo`1Soooo00>IVIVIVLcoool0H_ooo`05VIW<VIVIR<2h
R<2hB928004000000004R<2hb>3HR<2hR<2hIOooo`03VIVIoooooooo06?o
ool00iVIVIVIc9VIc01SVIW<00BIVIV8`;R8`;Q8T8P10000000018S0^<SP
f8S0^8S0^?nIVITcVIVI0XS0^058T8P10000000018S0^<SPf8S0^8S0^6Go
ool00iVIVOooooooo`1Soooo00>IVIWoooooool0Hoooo`04VIVIR<2hR<2h
B9280@00000000B8`;S8h=R8`;R8`;QUoooo00>IVIWoooooool0Hoooo`03
VIVIoooooooo06?oool019VIVHS0^8S0^4R@R04000000004R<2hb>3HR<2h
R<2hIOooo`03VIVIoooooooo06?oool00iVIVOooooooo`1Soooo00BIVIV8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0;oool00`000?ooooooo`05
oooo0`0000Coool300001?ooo`8000000oooo`000?ooo`04oooo1@0000Co
ool00`000?ooooooo`0hoooo00BIVIWoooooool00007oooo0`0000Coool3
00001?ooo`8000000oooo`000?ooo`04oooo1@0000;oool50000>?ooo`04
VIVIoooooooo00001oooo`<00004oooo0`0000Coool2000000?oool0003o
ool01?ooo`D00003oooo0`0003Woool019VIVHS0^8S0^4R@R04000000004
R<2hb>3HR<2hR<2h0_ooo`030000oooooooo00Coool01@000?oooooooooo
o`000002oooo00D0003oooooooooool000000_ooo`030000oooooooo0080
0006oooo00<0003oooooool01Oooo`030000oooooooo03Soool019VIVOoo
ooooo`0000Koool01@000?ooooooooooo`000002oooo00D0003ooooooooo
ool000000_ooo`030000oooooooo00800006oooo00<0003oooooool01?oo
o`030000oooooooo03Woool019VIVOooooooo`0000Koool01@000?oooooo
ooooo`000002oooo00D0003oooooooooool000000_ooo`030000oooooooo
00800006oooo00<0003oooooool00oooo`050000oooooooooooo000003So
ool019VIVHS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h0_ooo`030000
oooooooo00Coool01@000?ooooooooooo`000002oooo00D0003ooooooooo
ool000000_ooo`050000oooooooooooo000000Ooool00`000?ooooooo`04
oooo00<0003oooooool0>?ooo`04VIVIoooooooo00001_ooo`050000oooo
oooooooo000000;oool01@000?ooooooooooo`000002oooo00D0003ooooo
ooooool000001oooo`030000oooooooo00Coool00`000?ooooooo`0hoooo
00BIVIWoooooool00006oooo00D0003oooooooooool000000_ooo`050000
oooooooooooo000000;oool01@000?ooooooooooo`000007oooo00<0003o
ooooool01_ooo`030000oooooooo03Koool019VIVHS0^8S0^4R@R0400000
0004R<2hb>3HR<2hR<2h0_ooo`030000oooooooo00Coool01@000?oooooo
ooooo`000002oooo00D0003oooooooooool000000_ooo`050000oooooooo
oooo000000Soool00`000?ooooooo`03oooo00<0003oooooool0>?ooo`04
VIVIoooooooo00001_ooo`050000oooooooooooo000000;oool01@000?oo
ooooooooo`000002oooo00D0003oooooooooool000002?ooo`030000oooo
oooo00Coool00`000?ooooooo`0goooo00BIVIWoooooool00006oooo00D0
003oooooooooool000000_ooo`050000oooooooooooo000000;oool01@00
0?ooooooooooo`000008oooo00<0003oooooool01Oooo`030000oooooooo
03Koool019VIVHS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h0_ooo`@0
0003oooo00D0003oooooooooool000000_ooo`050000oooooooooooo0000
00;oool01@000?ooooooooooo`000008oooo00<0003oooooool00oooo`03
0000oooooooo03Soool00iVIVOooooooo`0400000oooo`050000oooooooo
oooo000000;oool01@000?ooooooooooo`000002oooo00D0003ooooooooo
ool000002?ooo`030000oooooooo00Coool00`000?ooooooo`0goooo00>I
VIWoooooool0100000?oool01@000?ooooooooooo`000002oooo00D0003o
ooooooooool000000_ooo`050000oooooooooooo000000Soool00`000?oo
ooooo`03oooo0P0003Woool019VIVHS0^8S0^4R@R04000000004R<2hb>3H
R<2hR<2h0_ooo`030000oooooooo00Coool01@000?ooooooooooo`000002
oooo00D0003oooooooooool000000_ooo`030000oooooooo00800009oooo
00<0003oooooool00_ooo`030000oooooooo03Soool019VIVOooooooo`00
00Koool01@000?ooooooooooo`000002oooo00D0003oooooooooool00000
0_ooo`030000oooooooo00800009oooo00<0003oooooool01?ooo`030000
oooooooo03Koool019VIVOooooooo`0000Koool01@000?ooooooooooo`00
0002oooo00D0003oooooooooool000000_ooo`030000oooooooo00800009
oooo00<0003oooooool01?ooo`030000oooooooo03Koool019VIVHS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2h0_ooo`030000oooooooo00Goool3
00001?ooo`<00004oooo0P000003oooo0000oooo00Soool01P000?oooooo
o`000?ooo`0003[oool019VIVOooooooo`0000Ooool300001?ooo`<00004
oooo0P000003oooo0000oooo00Soool00`000?ooooooo`04oooo00<0003o
ooooool0=_ooo`04VIVIoooooooo00001oooo`<00004oooo0`0000Coool2
000000?oool0003oool02?ooo`030000oooooooo00Coool00`000?oooooo
o`0foooo00BIVIV8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0;oool0
0`000?ooooooo`0Foooo00<0003oooooool00oooo`050000oooooooooooo
000000?oool20000>_ooo`04VIVIoooooooo00006?ooo`030000oooooooo
00?oool01@000?ooooooooooo`000002oooo00D0003oooooooooool00000
>?ooo`04VIVIoooooooo00006?ooo`030000oooooooo00?oool01@000?oo
ooooooooo`000002oooo00D0003oooooooooool00000>?ooo`04VIVIR<2h
R<2hB9280@00000000B8`;S8h=R8`;R8`;P2oooo1@0001Coool00`000?oo
ooooo`04oooo0`0000Goool00`000?ooooooo`0hoooo00>IVIWoooooool0
1@0001Coool00`000?ooooooo`04oooo0`0000Coool30000>Oooo`03VIVI
oooooooo00D0000Doooo00<0003oooooool01?ooo`<00004oooo0`0003Wo
ool019VIVHS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2hIOooo`03VIVI
oooooooo06?oool00iVIVOooooooo`1Soooo00BIVIV8`;R8`;Q8T8P10000
000018S0^<SPf8S0^8S0^6Goool00iVIVOooooooo`1Soooo00>IVIWooooo
ool0Hoooo`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;QUoooo
00>IVIWoooooool0Hoooo`03VIVIoooooooo06?oool019VIVHS0^8S0^4R@
R04000000004R<2hb>3HR<2hR<2hoiVIVC>IVIT2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hIOooo`03VIVIoooooooo06?oool00iVIVOooooooo`1S
oooo00BIVIV8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^6Goool00iVI
VOooooooo`1Soooo00>IVIWoooooool0Hoooo`04VIVIR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;QUoooo00>IVIWoooooool0Hoooo`03VIVIoooo
oooo06?oool019VIVHS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h0_oo
o`030000oooooooo00Goool300001?ooo`<00004oooo0P000003oooo0000
oooo00Koool00`000?ooooooo`04oooo00<0003oooooool0>?ooo`04VIVI
oooooooo00001oooo`<00004oooo0`0000Coool2000000?oool0003oool0
1_ooo`030000oooooooo00;oool50000>?ooo`04VIVIoooooooo00001ooo
o`<00004oooo0`0000Coool2000000?oool0003oool01_ooo`030000oooo
oooo00?oool30000>Oooo`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8
`;R8`;P2oooo00<0003oooooool01?ooo`050000oooooooooooo000000;o
ool01@000?ooooooooooo`000002oooo00<0003oooooool00P0000Ooool0
0`000?ooooooo`04oooo00<0003oooooool0>?ooo`04VIVIoooooooo0000
1_ooo`050000oooooooooooo000000;oool01@000?ooooooooooo`000002
oooo00<0003oooooool00P0000Ooool00`000?ooooooo`03oooo00<0003o
ooooool0>Oooo`04VIVIoooooooo00001_ooo`050000oooooooooooo0000
00;oool01@000?ooooooooooo`000002oooo00<0003oooooool00P0000Oo
ool00`000?ooooooo`02oooo00D0003oooooooooool00000>?ooo`04VIVI
R<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P2oooo00<0003oooooool0
1?ooo`050000oooooooooooo000000;oool01@000?ooooooooooo`000002
oooo00D0003oooooooooool000001oooo`030000oooooooo00Coool00`00
0?ooooooo`0hoooo00BIVIWoooooool00006oooo00D0003oooooooooool0
00000_ooo`050000oooooooooooo000000;oool01@000?ooooooooooo`00
0007oooo00<0003oooooool01?ooo`030000oooooooo03Soool019VIVOoo
ooooo`0000Koool01@000?ooooooooooo`000002oooo00D0003ooooooooo
ool000000_ooo`050000oooooooooooo000000Ooool00`000?ooooooo`06
oooo00<0003oooooool0=_ooo`04VIVIR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;P2oooo00<0003oooooool01?ooo`050000oooooooooooo0000
00;oool01@000?ooooooooooo`000002oooo00D0003oooooooooool00000
1oooo`030000oooooooo00Coool00`000?ooooooo`0hoooo00BIVIWooooo
ool00006oooo00D0003oooooooooool000000_ooo`050000oooooooooooo
000000;oool01@000?ooooooooooo`000007oooo00<0003oooooool01Ooo
o`030000oooooooo03Ooool019VIVOooooooo`0000Koool01@000?oooooo
ooooo`000002oooo00D0003oooooooooool000000_ooo`050000oooooooo
oooo000000Ooool00`000?ooooooo`06oooo00<0003oooooool0=_ooo`04
VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P2oooo100000?oool0
1@000?ooooooooooo`000002oooo00D0003oooooooooool000000_ooo`05
0000oooooooooooo000000Ooool00`000?ooooooo`04oooo00<0003ooooo
ool0>?ooo`03VIVIoooooooo00@00003oooo00D0003oooooooooool00000
0_ooo`050000oooooooooooo000000;oool01@000?ooooooooooo`000007
oooo00<0003oooooool01Oooo`030000oooooooo03Ooool00iVIVOoooooo
o`0400000oooo`050000oooooooooooo000000;oool01@000?oooooooooo
o`000002oooo00D0003oooooooooool000001oooo`030000oooooooo00Co
ool20000>Oooo`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P2
oooo00<0003oooooool01?ooo`050000oooooooooooo000000;oool01@00
0?ooooooooooo`000002oooo00<0003oooooool00P0000Ooool00`000?oo
ooooo`04oooo00<0003oooooool0>?ooo`04VIVIoooooooo00001_ooo`05
0000oooooooooooo000000;oool01@000?ooooooooooo`000002oooo00<0
003oooooool00P0000Ooool00`000?ooooooo`06oooo00<0003oooooool0
=_ooo`04VIVIoooooooo00001_ooo`050000oooooooooooo000000;oool0
1@000?ooooooooooo`000002oooo00<0003oooooool00P0000Ooool00`00
0?ooooooo`06oooo00<0003oooooool0=_ooo`04VIVIR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P2oooo00<0003oooooool01Oooo`<00004oooo
0`0000Coool2000000?oool0003oool01?ooo`030000oooo000000Coool0
0`000?ooo`00000joooo00BIVIWoooooool00007oooo0`0000Coool30000
1?ooo`8000000oooo`000?ooo`04oooo00<0003oool000002?ooo`030000
oooooooo03Koool019VIVOooooooo`0000Ooool300001?ooo`<00004oooo
0P000003oooo0000oooo00Coool00`000?ooo`000008oooo00<0003ooooo
ool0=_ooo`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;P2oooo
00<0003oooooool05_ooo`030000oooooooo00Coool200001Oooo`80000j
oooo00BIVIWoooooool0000Hoooo00<0003oooooool01?ooo`800004oooo
00D0003oooooooooool00000>?ooo`04VIVIoooooooo00006?ooo`030000
oooooooo00Coool200001?ooo`050000oooooooooooo000003Soool019VI
VHS0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h0_ooo`D0000Doooo00<0
003oooooool01Oooo`030000oooooooo00Coool00`000?ooooooo`0hoooo
00>IVIWoooooool01@0001Coool00`000?ooooooo`05oooo00<0003ooooo
ool00oooo`<0000ioooo00>IVIWoooooool01@0001Coool00`000?oooooo
o`05oooo00<0003oooooool00oooo`<0000ioooo00BIVIV8`;R8`;Q8T8P1
0000000018S0^<SPf8S0^8S0^6Goool00iVIVOooooooo`1Soooo00>IVIWo
ooooool0Hoooo`04VIVIR<2hR<2hB9280@00000000B8`;S8h=R8`;R8`;QU
oooo00>IVIWoooooool0Hoooo`03VIVIoooooooo06?oool019VIVHS0^8S0
^4R@R04000000004R<2hb>3HR<2hR<2hIOooo`03VIVIoooooooo06?oool0
0iVIVOooooooo`1Soooo00BIVIV8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^<c<c01TIVIV0/c<c6AVIVH2c<c<I6IVIP04c<c<R<2hR<2hB9280@00
000000F8`;S8h=R8`;R8`;Soool0Hlc<c003IVIVc<c<oooo04K<c<`40000
6Lc<c003IVIVc<c<oooo06?<c<`01FIVI/c<c8S0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^?ooo`1Sc<c<00=VIVK<c<coool0B/c<c0030000c<c<
c<c<01K<c<`00fIVI/c<c?ooo`1Sc<c<00EVIVK<c<b8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;Soool04Lc<c0030000c<c<c<c<00?<c<`01000
0<c<c<c<c<c<c0<00003c<c<00@0003<c<`000000004c<c<0`0000?<c<`0
0`000<c<c<c<c006c<c<0P000005c<c<0000c<c<c<c<000000?<c<`01000
0<c<c<c<c<c<c08000000lc<c0000<c<c002c<c<0P000003c<c<0000c<c<
017<c<`00fIVI/c<c?ooo`0Hc<c<00<0003<c<c<c<`00lc<c0040000c<c<
c<c<c<c<0`0000?<c<`010000<c<c000000000C<c<`300000lc<c0D00005
c<c<0`0000C<c<`2000000?<c<`0003<c<`05lc<c003IVIVc<c<oooo01S<
c<`00`000<c<c<c<c003c<c<00@0003<c<c<c<c<c<`300000lc<c0040000
c<c<000000001<c<c0<00003c<c<1@0000?<c<`010000<c<c<c<c00000C<
c<`2000000?<c<`0003<c<`06<c<c005IVIVc<c<R<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hoooo017<c<`00`000<c<c<c<c002c<c<00D0003<
c<c<c<c<c<`000000lc<c0030000c<c<c<c<00800002c<c<00@0003<c<c<
c<`00003c<c<00@0003<c<c<c<`00007c<c<00<0003<c<c<c<`00P0000;<
c<`01@000<c<c<c<c<c<c0000002c<c<00<0003<c<c<c<`00P0000;<c<`0
0`000<c<c<c<c00200004/c<c003IVIVc<c<oooo01S<c<`00`000<c<c<c<
c002c<c<00D0003<c<c<c<c<c<`000000lc<c0030000c<c<c<c<00800002
c<c<00@0003<c<c<c<`00003c<c<00@0003<c<c<c<`00004c<c<00D0003<
c<c<c<c<c<`000000lc<c0040000c<c<c<c<00000/c<c080000Hc<c<00=V
IVK<c<coool06<c<c0030000c<c<c<c<00;<c<`01@000<c<c<c<c<c<c000
0003c<c<00<0003<c<c<c<`00P0000;<c<`010000<c<c<c<c00000?<c<`0
10000<c<c<c<c00000C<c<`010000<c<c<c<c00000;<c<`01@000<c<c<c<
c<c<c0000002c<c<0P0001W<c<`01FIVI/c<c8S0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^?ooo`0Ac<c<00<0003<c<c<c<`00/c<c0050000c<c<
c<c<c<c<000000?<c<`010000<c<c<c<c00000?<c<`010000<c<c<c<c000
00?<c<`010000<c<c<c<c00000O<c<`01@000<c<c<c<c<c<c0000002c<c<
00D0003<c<c<c<c<c<`000000/c<c0050000c<c<c<c<c<c<000000;<c<`0
1@000<c<c<c<c<c<c000000Bc<c<00=VIVK<c<coool06<c<c0030000c<c<
c<c<00;<c<`01@000<c<c<c<c<c<c0000003c<c<00@0003<c<c<c<`00003
c<c<00@0003<c<c<c<`00003c<c<00@0003<c<c<c<`00005c<c<00@0003<
c<c<c<`00003c<c<00@0003<c<c<c<`00003c<c<00<0003<c<c<c<`05/c<
c003IVIVc<c<oooo01S<c<`00`000<c<c<c<c002c<c<00D0003<c<c<c<c<
c<`000000lc<c0040000c<c<c<c<00000lc<c0040000c<c<c<c<00000lc<
c0040000c<c<c<c<00001<c<c0040000c<c<c<c<00000/c<c0050000c<c<
c<c<c<c<000000?<c<`00`000<c<c<c<c00Gc<c<00EVIVK<c<b8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;Soool04Lc<c0050000c<c<c<c<c<c<
000000C<c<`01@000<c<c<c<c<c<c0000002c<c<00D0003<c<c<c<c<c<`0
00000/c<c0050000c<c<c<c<c<c<000000;<c<`00`000<c<c<c<c006c<c<
100000;<c<`01@000<c<c<c<c<c<c0000002c<c<00D0003<c<c<c<c<c<`0
00000lc<c0@0000Bc<c<00=VIVK<c<coool06<c<c0050000c<c<c<c<c<c<
000000C<c<`01@000<c<c<c<c<c<c0000002c<c<00D0003<c<c<c<c<c<`0
00000/c<c0050000c<c<c<c<c<c<000000;<c<`00`000<c<c<c<c003c<c<
00@0003<c<c<c<`00003c<c<00@0003<c<c<c<`00003c<c<00<0003<c<c<
c<`05/c<c003IVIVc<c<oooo01S<c<`01@000<c<c<c<c<c<c0000004c<c<
00D0003<c<c<c<c<c<`000000/c<c0050000c<c<c<c<c<c<000000;<c<`0
1@000<c<c<c<c<c<c0000002c<c<00<0003<c<c<c<`00/c<c0040000c<c<
c<c<00000/c<c0050000c<c<c<c<c<c<000000?<c<`00`000<c<c<c<c00G
c<c<00EVIVK<c<b8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;Soool0
4Lc<c0H00003c<c<00D0003<c<c<c<c<c<`000000/c<c0050000c<c<c<c<
c<c<000000;<c<`01@000<c<c<c<c<c<c0000002c<c<1@0000O<c<`01000
0<c<c<c<c00000?<c<`010000<c<c<c<c00000?<c<`00`000<c<c<c<c004
c<c<00<0003<c<c<c<`04<c<c003IVIVc<c<oooo01S<c<`600000lc<c005
0000c<c<c<c<c<c<000000;<c<`01@000<c<c<c<c<c<c0000002c<c<00D0
003<c<c<c<c<c<`000000/c<c0030000c<c<c<c<00?<c<`010000<c<c<c<
c00000?<c<`010000<c<c<c<c00000?<c<`00`000<c<c<c<c00Fc<c<00=V
IVK<c<coool06<c<c0H00003c<c<00D0003<c<c<c<c<c<`000000/c<c005
0000c<c<c<c<c<c<000000;<c<`01@000<c<c<c<c<c<c0000002c<c<1@00
00?<c<`010000<c<c<c<c00000?<c<`01@000<c<c<c<c<c<c000000Ic<c<
00EVIVK<c<b8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;Soool04Lc<
c0030000c<c<c<c<00?<c<`010000<c<c<c<c00000?<c<`00`000<c<c<c<
c00200000/c<c0040000c<c<c<c<00000lc<c0040000c<c<c<c<00001<c<
c0040000c<c<c<c<00000lc<c0030000c<c<c<c<00800002c<c<00@0003<
c<c<c<`00002c<c<0P0000;<c<`01@000<c<c<c<c<c<c000000Bc<c<00=V
IVK<c<coool06<c<c0030000c<c<c<c<00?<c<`010000<c<c<c<c00000?<
c<`00`000<c<c<c<c00200000/c<c0040000c<c<c<c<00000lc<c0040000
c<c<c<c<00001Lc<c0040000c<c<c<c<00000lc<c0040000c<c<c<c<0000
0/c<c080000Hc<c<00=VIVK<c<coool06<c<c0030000c<c<c<c<00?<c<`0
10000<c<c<c<c00000?<c<`00`000<c<c<c<c00200000/c<c0040000c<c<
c<c<00000lc<c0040000c<c<c<c<00001<c<c0040000c<c<c<c<00000/c<
c0800002c<c<00<0003<c<c<c<`00P0001W<c<`01FIVI/c<c8S0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^?ooo`0Ac<c<00<0003<c<c<c<`00lc<
c0040000c<c<c<c<c<c<0`0000?<c<`010000<c<c000000000C<c<`30000
0lc<c0030000c<c<c<c<00;<c<`010000<c<c<c<c<c<c0<00003c<c<00@0
003<c<`000000004c<c<0P000003c<c<0000c<c<00;<c<`300004lc<c003
IVIVc<c<oooo01S<c<`00`000<c<c<c<c003c<c<00@0003<c<c<c<c<c<`3
00000lc<c0040000c<c<000000001<c<c0<00003c<c<00<0003<c<c<c<`0
0lc<c0040000c<c<c<c<c<c<0`0000C<c<`2000000?<c<`0003<c<`05lc<
c003IVIVc<c<oooo01S<c<`00`000<c<c<c<c003c<c<00@0003<c<c<c<c<
c<`300000lc<c0040000c<c<000000001<c<c0<00003c<c<00<0003<c<c<
c<`00/c<c0040000c<c<c<c<00000/c<c0030000c<c<000000;<c<`20000
00?<c<`0003<c<`06<c<c005IVIVc<c<R<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hoooo017<c<`00`000<c<c<c<c003c<c<00<0003<c<c<c<`0
1lc<c0030000c<c<c<c<00_<c<`00`000<c<c<c<c002c<c<00<0003<c<c<
c<`04/c<c0030000c<c<c<c<01O<c<`00fIVI/c<c?ooo`0Hc<c<00<0003<
c<c<c<`00lc<c0030000c<c<c<c<00O<c<`00`000<c<c<c<c00;c<c<00<0
003<c<c<c<`00/c<c0030000c<c<c<c<02G<c<`00fIVI/c<c?ooo`0Hc<c<
00<0003<c<c<c<`00lc<c0030000c<c<c<c<00O<c<`00`000<c<c<c<c00;
c<c<00<0003<c<c<c<`00/c<c0030000c<c<c<c<00_<c<`00`000<c<c<c<
c00Gc<c<00EVIVK<c<b8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;So
ool04Lc<c0H0000:c<c<00<0003<c<c<c<`02lc<c0D0000Ec<c<00<0003<
c<c<c<`05lc<c003IVIVc<c<oooo01S<c<`600002/c<c0030000c<c<c<c<
00_<c<`50000:<c<c003IVIVc<c<oooo01S<c<`600002/c<c0030000c<c<
c<c<00_<c<`500000lc<c0030000c<c<c<c<00S<c<`00`000<c<c<c<c00G
c<c<00EVIVK<c<b8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;Soool0
Hlc<c003IVIVc<c<oooo06?<c<`00fIVI/c<c?ooo`1Sc<c<00EVIVK<c<b8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;Soool0Hlc<c003IVIVc<c<
oooo06?<c<`00fIVI/c<c?ooo`1Sc<c<00EVIVK<c<b8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;Soool0Hlc<c003IVIVc<c<oooo06?<c<`00fIV
I/c<c?ooo`1Sc<c<00EVIVK<c<b8`;R8`;Q8T8P00@00000000B8`;S8h=R8
`;R8`;QToooo00=VIVK<c<coool0Hoooo`03IVIVc<c<oooo06?oool01FIV
I/c<c8S0^8S0^4R@R001000000000hS0^<SPf8S0^03oR<2h=XS0^058T8P1
0000000018S0^<SPf8S0^8S0^1@008001P01P002P003P@03P@04P@05P@80
1X801`47PP48P`49P`49P`4:P`4;Q04<Q0020@f400/13XD23hD248D248H2
4HH24XH24hH24hL258L25HL25XL00P<GR0060aR80aV90aZ90aZ90a^90ab:
0P<MRP0@11j:11n;122;126;126<12:<12><12B<12B=1BF=1BJ=1BN=1BN>
1BR>1BV>1BZ?0PD[S`061Bb?1Rf@1Rj@1Rj@1Rn@1S2A0PHaT@0;1S:B1S>B
1SBB1cFB1cFC1cJC1cNC1cRC1cRD1cVD1cZD0087>iD00`PlU@PmU@PnUP02
23nF00H8@9H8@IL8@YL8@YL9@iP9A9P22DFH00L9AYT9AiT9B9T9BIT9BIX9
BYX:BiX00PY<V`072TfK2TjK2TnL2TnL2U2L2U6L2U:M008;Did01P]DWP]E
WP]FWP]FWP]GW`]HW`8;FIl00`aJX0aKX0aLX00235fQ00H<GZ4<Gj4<H:8<
H:8=HJ8=HZ<23F>S00<=I:<=IJ@=IZ@00PeWY00;3FRU3VVU3VZU3VZV3V^V
3VbV3VfV3VfW3VjW3VnW3W2W008?LJP01PmbZ0mcZ@mdZ@mdZ@meZ@mfZP8?
MjX0411hZQ1iZa1jZa1kZa1k[11l[11m[11n[11n[A5o[A60[A61[A61[Q62
[Q63[Q64[`8AQJl01Q66[a:7/1:8/1:8/1:9/1::/@8BRk402a:</Q:=/Q:>
/Q>?/Q>?/a>@/a>A/a>B/a>B]1>C]1>D]0024iFe00<DU[DDUkDDV;H00QBI
]P0659Zf59^g59bg59bg5Ifh5Ijh0QFO^0075J2i5J6i5J:i5J>i5J>j5JBj
5ZFj008FY[/01aJW^aJX^aJY_1JY_1JZ_1J[_1J/_@025jfm00LG[[hG[khG
/;hG/;hG/KlG/[lG/kl0=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P4002000>KYo4c@jDc@jD02C=3Y@@008001P01P002P003P@03P@04P@05
P@801X801`47PP48P`49P`49P`4:P`4;Q04<Q0020@f400/13XD23hD248D2
48H24HH24XH24hH24hL258L25HL25XL00P<GR0060aR80aV90aZ90aZ90a^9
0ab:0P<MRP0@11j:11n;122;126;126<12:<12><12B<12B=1BF=1BJ=1BN=
1BN>1BR>1BV>1BZ?0PD[S`061Bb?1Rf@1Rj@1Rj@1Rn@1S2A0PHaT@0;1S:B
1S>B1SBB1cFB1cFC1cJC1cNC1cRC1cRD1cVD1cZD0087>iD00`PlU@PmU@Pn
UP0223nF00H8@9H8@IL8@YL8@YL9@iP9A9P22DFH00L9AYT9AiT9B9T9BIT9
BIX9BYX:BiX00PY<V`072TfK2TjK2TnL2TnL2U2L2U6L2U:M008;Did01P]D
WP]EWP]FWP]FWP]GW`]HW`8;FIl00`aJX0aKX0aLX00235fQ00H<GZ4<Gj4<
H:8<H:8=HJ8=HZ<23F>S00<=I:<=IJ@=IZ@00PeWY00;3FRU3VVU3VZU3VZV
3V^V3VbV3VfV3VfW3VjW3VnW3W2W008?LJP01PmbZ0mcZ@mdZ@mdZ@meZ@mf
ZP8?MjX0411hZQ1iZa1jZa1kZa1k[11l[11m[11n[11n[A5o[A60[A61[A61
[Q62[Q63[Q64[`8AQJl01Q66[a:7/1:8/1:8/1:9/1::/@8BRk402a:</Q:=
/Q:>/Q>?/Q>?/a>@/a>A/a>B/a>B]1>C]1>D]0024iFe00<DU[DDUkDDV;H0
0QBI]P0659Zf59^g59bg59bg5Ifh5Ijh0QFO^0075J2i5J6i5J:i5J>i5J>j
5JBj5ZFj008FY[/01aJW^aJX^aJY_1JY_1JZ_1J[_1J/_@025jfm00LG[[hG
[khG/;hG/;hG/KlG/[lG/kl0=QRd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P3002000NKYo7ooon>N[JVVlBcZM:XWLRcZM800ZJKa005_;SMk^kd
j^Waoooo<d>U00<008001P01P002P003P@03P@04P@05P@801X801`47PP48
P`49P`49P`4:P`4;Q04<Q0020@f400/13XD23hD248D248H24HH24XH24hH2
4hL258L25HL25XL00P<GR0060aR80aV90aZ90aZ90a^90ab:0P<MRP0@11j:
11n;122;126;126<12:<12><12B<12B=1BF=1BJ=1BN=1BN>1BR>1BV>1BZ?
0PD[S`061Bb?1Rf@1Rj@1Rj@1Rn@1S2A0PHaT@0;1S:B1S>B1SBB1cFB1cFC
1cJC1cNC1cRC1cRD1cVD1cZD0087>iD00`PlU@PmU@PnUP0223nF00H8@9H8
@IL8@YL8@YL9@iP9A9P22DFH00L9AYT9AiT9B9T9BIT9BIX9BYX:BiX00PY<
V`072TfK2TjK2TnL2TnL2U2L2U6L2U:M008;Did01P]DWP]EWP]FWP]FWP]G
W`]HW`8;FIl00`aJX0aKX0aLX00235fQ00H<GZ4<Gj4<H:8<H:8=HJ8=HZ<2
3F>S00<=I:<=IJ@=IZ@00PeWY00;3FRU3VVU3VZU3VZV3V^V3VbV3VfV3VfW
3VjW3VnW3W2W008?LJP01PmbZ0mcZ@mdZ@mdZ@meZ@mfZP8?MjX0411hZQ1i
Za1jZa1kZa1k[11l[11m[11n[11n[A5o[A60[A61[A61[Q62[Q63[Q64[`8A
QJl01Q66[a:7/1:8/1:8/1:9/1::/@8BRk402a:</Q:=/Q:>/Q>?/Q>?/a>@
/a>A/a>B/a>B]1>C]1>D]0024iFe00<DU[DDUkDDV;H00QBI]P0659Zf59^g
59bg59bg5Ifh5Ijh0QFO^0075J2i5J6i5J:i5J>i5J>j5JBj5ZFj008FY[/0
1aJW^aJX^aJY_1JY_1JZ_1J[_1J/_@025jfm00LG[[hG[khG/;hG/;hG/KlG
/[lG/kl00QRd`20000026;C04000008H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0P00P004VjOaooooK5ZU[jG:0[bhg@0:oogo/jWBoooooooo
_;SMUhZlZ9g8i^K/oooo<d>U0P00P006006000:000>100>100B100F10P06
PP070@N20@R30@V30@V30@Z30@^40@b400813H@02`4>Q@8?Q@8@Q@8@QP8A
QP8BQP8CQP8CQ`8DQ`8EQ`8FQ`020aN800H368P36HT36XT36XT36hT378X2
0af:01047XX47h/488/48H/48H`48X`48h`498`498d59Hd59Xd59hd59hh5
:8h5:Hh5:Xl21B^?00H5;8l6;I06;Y06;Y06;i06<9421S6A00/6<Y86<i86
=987=I87=I<7=Y<7=i<7>9<7>9@7>I@7>Y@00PLkU@0323bE23fE23jF0088
?iH01PQ0UPQ1U`Q2U`Q2U`U3V0U4V089AIP01`U6V@U7V@U8V@U9V@U9VPU:
VPY;VP022TbK00L:CI/:CY/:Ci`:Ci`:D9`:DI`:DYd00P]CW@062eBN2eFN
2eJN2eJN2eNO2eRO0P]IW`0335ZP35^P35bP008<GJ401PaNX@aOX@aPXPaP
XPeQXPeRX`8=Hj<00`eTX`eUY0eVY0023FNT00/=J:D>JJD>JZD>JZH>JjH>
K:H>KJH>KJL>KZL>KjL>L:L00PmaZ0063g:X3g>Y3gBY3gBY3gFY3gJZ0Pmg
ZP0@47RZ47V[47Z[47^[47^/47b/47f/47j/47j]4Gn]4H2]4H6]4H6^4H:^
4H>^4HB_0Q65[`064HJ_4XN`4XR`4XR`4XV`4XZa0Q:;/@0;4Xbb4Xfb4Xjb
4hnb4hnc4i2c4i6c4i:c4i:d4i>d4iBd008CUKD00aBF]ABG]ABH]P0259Vf
00HDV[HDVkLDW;LDW;LEWKPEW[P25Inh00LEX;TEXKTEX[TEXkTEXkXEY;XF
YKX00QJV^`075ZNk5ZRk5ZVl5ZVl5ZZl5Z^l5Zbm008G[Kd01aN^_QN__QN`
_QN`_QNa_aNb_aNc_`026;C000?8h=Q8T8Q8T8P034R@R0030000b>3HB928
00e8T8P0100001Rd`1Rd`<SPf0i8T8P00`0001Rd`1Rd`002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0P00P00;VjOaooooZ9g8oooo/jWBH4bJSWZf
N6F^Z9g8oooooogo00?oool01S=3Y@00P000P000P001P002P0800h401P04
P@05P@06PP06PP47PP48P`812H<00`4:P`4;Q04<Q0020@f400/13XD23hD2
48D248H24HH24XH24hH24hL258L25HL25XL00P<GR0060aR80aV90aZ90aZ9
0a^90ab:0P<MRP0@11j:11n;122;126;126<12:<12><12B<12B=1BF=1BJ=
1BN=1BN>1BR>1BV>1BZ?0PD[S`061Bb?1Rf@1Rj@1Rj@1Rn@1S2A0PHaT@0;
1S:B1S>B1SBB1cFB1cFC1cJC1cNC1cRC1cRD1cVD1cZD0087>iD00`PlU@Pm
U@PnUP0223nF00H8@9H8@IL8@YL8@YL9@iP9A9P22DFH00L9AYT9AiT9B9T9
BIT9BIX9BYX:BiX00PY<V`072TfK2TjK2TnL2TnL2U2L2U6L2U:M008;Did0
1P]DWP]EWP]FWP]FWP]GW`]HW`8;FIl00`aJX0aKX0aLX00235fQ00H<GZ4<
Gj4<H:8<H:8=HJ8=HZ<23F>S00<=I:<=IJ@=IZ@00PeWY00;3FRU3VVU3VZU
3VZV3V^V3VbV3VfV3VfW3VjW3VnW3W2W008?LJP01PmbZ0mcZ@mdZ@mdZ@me
Z@mfZP8?MjX0411hZQ1iZa1jZa1kZa1k[11l[11m[11n[11n[A5o[A60[A61
[A61[Q62[Q63[Q64[`8AQJl01Q66[a:7/1:8/1:8/1:9/1::/@8BRk402a:<
/Q:=/Q:>/Q>?/Q>?/a>@/a>A/a>B/a>B]1>C]1>D]0024iFe00<DU[DDUkDD
V;H00QBI]P0659Zf59^g59bg59bg5Ifh5Ijh0QFO^0075J2i5J6i5J:i5J>i
5J>j5JBj5ZFj008FY[/01aJW^aJX^aJY_1JY_1JZ_1J[_1J/_@025jfm00LG
[[hG[khG/;hG/;hG/KlG/[lG/kl00QRd`003b>3HR<2hR<2h00^8`;P00dR@
R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008003Y^WlOoooooo
om_Lk61<VY>5^[>Yd[bhgF1<VYV?_ZJKa<S3gooooc=3Y@@008002P01P?oo
o`03P@03P@04P@05P@06P_ooo`47PP48P`Coool03@4<Q04=Q04=Q?ooo`8?
QOooo`8@QP8AQP8BQ_ooo`8CQ`8DQ`8EQ`03oooo00H368P36HT36XWoool3
6hT378X20af:00H47X[oool488/48H/48H`48X`4oooo00H59Xd59hgoool5
:8h5:Hkoool21B^?00?oool6;I06;Y000oooo`86<I402`HbTPHcTPHdTPLe
TPLeT`LfT`LgT`LhT`LhU0LiU0LjU0021c^E00<8?9D8?ID8?YH00PPoUP06
242F246G24:G24:G2D>H2DBH0PU5V0072DJI2DNI2DRI2DVI2DVJ2DZJ2T^J
008:C9/01`Y=V`Y>V`Y?W0Y?W0Y@W0YAW0YBW@022e>M00H;E9h;EIh;EYh;
EYh;Eil;F9l22eVO00<<FZ0<Fj0<G:000PaMX@0635jQ35nQ362R362R3F6R
3F:S0PeSX`033FBS3FFT3FJT008=Ij@02`eXY@iYY@iZY@iZYPi[YPi/YPi]
YPi]Y`i^Y`i_Y`i`Y`023g6X00H?LZP?LjT?M:T?M:T?MJT?MZX23gNZ010@
N:X@NJ/@NZ/@Nj/@Nj`@O:`@OJ`@OZ`@OZdAOjdAP:dAPJdAPJhAPZhAPjhA
Q:l24HF_00HAQZlBQk0BR;0BR;0BRK0BR[424X^a00/BS;8BSK8BS[8CSk8C
Sk<CT;<CTK<CT[<CT[@CTk@CU;@00Q>E]@0359Je59Ne59Rf008DVKH01QBJ
]QBK]aBL]aBL]aFM^1FN^08EWkP01aFP^AFQ^AFR^AFS^AFS^QFT^QJU^P02
5ZJk00LFYk/FZ;/FZK`FZK`FZ[`FZk`F[;d00QN]_@075jjn5jnn5k2n5k2n
5k6o5k:o5k>o008H]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P00038
h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B9280000
6;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008003Y^WlOoo
okbhgIV?__ooomKAgM_Lk??nojJKa>k^m8Ef/9>5^_oooc=3Y@<008002P01
P?ooo`03P@03POooo`05P@06P_ooo`47P_ooo`812H<0404:Poooo`4<Q04=
Q?ooo`4>Q@8?QOooo`8@QP8AQP8BQ_ooo`8CQ`8DQoooo`8FQ`835hP01_oo
o`<IR@<JROooo`<KR@<LRP837HX040@NR_ooo`@PR`@QR`@QS?ooo`@SS0@T
S0@TSOooo`DVS@DWSOooo`DXSPDYS_ooo`85:hl04oooo`H]T?ooo`H^T0H_
T0H`TOooo`HaT@HbTPHcTPHdTPLeTPLeT`LfT`LgT`LhT`LhU0LiU0LjU002
1c^E00<8?9D8?ID8?YH00PPoUP06242F246G24:G24:G2D>H2DBH0PU5V007
2DJI2DNI2DRI2DVI2DVJ2DZJ2T^J008:C9/01`Y=V`Y>V`Y?W0Y?W0Y@W0YA
W0YBW@022e>M00H;E9h;EIh;EYh;EYh;Eil;F9l22eVO00<<FZ0<Fj0<G:00
0PaMX@0635jQ35nQ362R362R3F6R3F:S0PeSX`033FBS3FFT3FJT008=Ij@0
2`eXY@iYY@iZY@iZYPi[YPi/YPi]YPi]Y`i^Y`i_Y`i`Y`023g6X00H?LZP?
LjT?M:T?M:T?MJT?MZX23gNZ010@N:X@NJ/@NZ/@Nj/@Nj`@O:`@OJ`@OZ`@
OZdAOjdAP:dAPJdAPJhAPZhAPjhAQ:l24HF_00HAQZlBQk0BR;0BR;0BRK0B
R[424X^a00/BS;8BSK8BS[8CSk8CSk<CT;<CTK<CT[<CT[@CTk@CU;@00Q>E
]@0359Je59Ne59Rf008DVKH01QBJ]QBK]aBL]aBL]aFM^1FN^08EWkP01aFP
^AFQ^AFR^AFS^AFS^QFT^QJU^P025ZJk00LFYk/FZ;/FZK`FZK`FZ[`FZk`F
[;d00QN]_@075jjn5jnn5k2n5k2n5k6o5k:o5k>o008H]<001<SPf8S0^8S0
^8S0^0H00004R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P0
1@0008S0^8S0^4R@R00000026;C000C8h=R8`;R8`;R8`;P2000018S0^080
0002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0`00P00?VjOaooooVHnnUhZle=?XkjbcogIkkYn[FeRUYY_4UYoBH4bJ
_;SMoooo<d>U008008002P01P?ooo`03P@03POooo`05P@06P_ooo`47P_oo
o`812H<0404:Poooo`4<Q04=Q?ooo`4>Q@8?QOooo`8@QP8AQP8BQ_ooo`8C
Q`8DQoooo`8FQ`835hP01_ooo`<IR@<JROooo`<KR@<LRP837HX040@NR_oo
o`@PR`@QR`@QS?ooo`@SS0@TS0@TSOooo`DVS@DWSOooo`DXSPDYS_ooo`85
:hl01_ooo`H]T?ooo`H^T0H_T0H`T@86<I402`HbTPHcTPHdTPLeTPLeT`Lf
T`LgT`LhT`LhU0LiU0LjU0021c^E00<8?9D8?ID8?YH00PPoUP06242F246G
24:G24:G2D>H2DBH0PU5V0072DJI2DNI2DRI2DVI2DVJ2DZJ2T^J008:C9/0
1`Y=V`Y>V`Y?W0Y?W0Y@W0YAW0YBW@022e>M00H;E9h;EIh;EYh;EYh;Eil;
F9l22eVO00<<FZ0<Fj0<G:000PaMX@0635jQ35nQ362R362R3F6R3F:S0PeS
X`033FBS3FFT3FJT008=Ij@02`eXY@iYY@iZY@iZYPi[YPi/YPi]YPi]Y`i^
Y`i_Y`i`Y`023g6X00H?LZP?LjT?M:T?M:T?MJT?MZX23gNZ010@N:X@NJ/@
NZ/@Nj/@Nj`@O:`@OJ`@OZ`@OZdAOjdAP:dAPJdAPJhAPZhAPjhAQ:l24HF_
00HAQZlBQk0BR;0BR;0BRK0BR[424X^a00/BS;8BSK8BS[8CSk8CSk<CT;<C
TK<CT[<CT[@CTk@CU;@00Q>E]@0359Je59Ne59Rf008DVKH01QBJ]QBK]aBL
]aBL]aFM^1FN^08EWkP01aFP^AFQ^AFR^AFS^AFS^QFT^QJU^P025ZJk00LF
Yk/FZ;/FZK`FZK`FZ[`FZk`F[;d00QN]_@075jjn5jnn5k2n5k2n5k6o5k:o
5k>o008H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000
R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P0
0XS0^0800002R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000ZKYo7ooonGR[ajK:ZcanRYKZ38`mnC
QKYKAY>ISkh2N6F^00A29hF_YL[ooolc@jD2002000X00H3oool00h7oool0
187oool01X;oool11h8128<4oooo00h138@13HCoool13XD23hGoool248H2
4HH24XKoool24hL258L25HL25XL20aN800Koool36HT36XWoool36hT378X2
0af:00H47X[oool488/48H/48H`48X`4oooo00H59Xd59hgoool5:8h5:Hko
ool21B^?00?oool6;I3oool01?ooo`0<1S6A1S:B1S>B1SBB1cFB1cFC1cJC
1cNC1cRC1cRD1cVD1cZD0PLkU@0323bE23fE23jF0088?iH01PQ0UPQ1U`Q2
U`Q2U`U3V0U4V089AIP01`U6V@U7V@U8V@U9V@U9VPU:VPY;VP022TbK00L:
CI/:CY/:Ci`:Ci`:D9`:DI`:DYd00P]CW@062eBN2eFN2eJN2eJN2eNO2eRO
0P]IW`0335ZP35^P35bP008<GJ401PaNX@aOX@aPXPaPXPeQXPeRX`8=Hj<0
0`eTX`eUY0eVY0023FNT00/=J:D>JJD>JZD>JZH>JjH>K:H>KJH>KJL>KZL>
KjL>L:L00PmaZ0063g:X3g>Y3gBY3gBY3gFY3gJZ0PmgZP0@47RZ47V[47Z[
47^[47^/47b/47f/47j/47j]4Gn]4H2]4H6]4H6^4H:^4H>^4HB_0Q65[`06
4HJ_4XN`4XR`4XR`4XV`4XZa0Q:;/@0;4Xbb4Xfb4Xjb4hnb4hnc4i2c4i6c
4i:c4i:d4i>d4iBd008CUKD00aBF]ABG]ABH]P0259Vf00HDV[HDVkLDW;LD
W;LEWKPEW[P25Inh00LEX;TEXKTEX[TEXkTEXkXEY;XFYKX00QJV^`075ZNk
5ZRk5ZVl5ZVl5ZZl5Z^l5Zbm008G[Kd01aN^_QN__QN`_QN`_QNa_aNb_aNc
_`026;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0
^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8
`;P4000018S0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^08008000i^WlOooooooo`02oooo00[o[K3oMW_icMCmkNkooonV
VlB5M[2l^=gooolc@jD3002000X00H3oool00h7oool0187oool01X;oool1
1h8128<20@V300L12X?oool138@13HCoool13XD23hD00_ooo`070Q660Q:6
oooo0Q>70QB70QF70QJ700835hP00oooo`<IR@<JR@04oooo00d37HX47X[o
ooooool48H/48H`48X`48h`498`498goool59Xd59hd00_ooo`0G1BV>oooo
oooo1B^?oooo1Rf@oooo1Rj@1Rn@1S2Aoooo1S6A1S:B1S>B1SBB1cFB1cFC
1cJC1cNC1cRC1cRD1cVD1cZD0087>iD00`PlU@PmU@PnUP0223nF00H8@9H8
@IL8@YL8@YL9@iP9A9P22DFH00L9AYT9AiT9B9T9BIT9BIX9BYX:BiX00PY<
V`072TfK2TjK2TnL2TnL2U2L2U6L2U:M008;Did01P]DWP]EWP]FWP]FWP]G
W`]HW`8;FIl00`aJX0aKX0aLX00235fQ00H<GZ4<Gj4<H:8<H:8=HJ8=HZ<2
3F>S00<=I:<=IJ@=IZ@00PeWY00;3FRU3VVU3VZU3VZV3V^V3VbV3VfV3VfW
3VjW3VnW3W2W008?LJP01PmbZ0mcZ@mdZ@mdZ@meZ@mfZP8?MjX0411hZQ1i
Za1jZa1kZa1k[11l[11m[11n[11n[A5o[A60[A61[A61[Q62[Q63[Q64[`8A
QJl01Q66[a:7/1:8/1:8/1:9/1::/@8BRk402a:</Q:=/Q:>/Q>?/Q>?/a>@
/a>A/a>B/a>B]1>C]1>D]0024iFe00<DU[DDUkDDV;H00QBI]P0659Zf59^g
59bg59bg5Ifh5Ijh0QFO^0075J2i5J6i5J:i5J>i5J>j5JBj5ZFj008FY[/0
1aJW^aJX^aJY_1JY_1JZ_1J[_1J/_@025jfm00LG[[hG[khG/;hG/;hG/KlG
/[lG/kl00QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<0
0028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0
^004R<2h0P0000F8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P3002000ZQ[?;icMCR9Scd]KoR9ScdKGglhnWoooomkNko
[K02oooo00<c@jD0080008000P00P00:0060oooo00>1oooo00B1oooo00J2
oooo0@N20@R30oooo`030@^40@b4oooo00;oool00`8?QOooo`8@QP02oooo
00D24hH24hL258L25HL25XL00P<GR006oooo0aV90aZ9oooo0a^90ab:0P<M
RP0611j:oooo122;oooo126<12:<0oooo`051BF=1BJ=1BN=oooo1BR>00;o
ool01@D[Soooo`D/S`H]T0H^T003oooo0PHaT@0;1S:B1S>B1SBB1cFB1cFC
1cJC1cNC1cRC1cRD1cVD1cZD0087>iD00`PlU@PmU@PnUP0223nF00H8@9H8
@IL8@YL8@YL9@iP9A9P22DFH00L9AYT9AiT9B9T9BIT9BIX9BYX:BiX00PY<
V`072TfK2TjK2TnL2TnL2U2L2U6L2U:M008;Did01P]DWP]EWP]FWP]FWP]G
W`]HW`8;FIl00`aJX0aKX0aLX00235fQ00H<GZ4<Gj4<H:8<H:8=HJ8=HZ<2
3F>S00<=I:<=IJ@=IZ@00PeWY00;3FRU3VVU3VZU3VZV3V^V3VbV3VfV3VfW
3VjW3VnW3W2W008?LJP01PmbZ0mcZ@mdZ@mdZ@meZ@mfZP8?MjX0411hZQ1i
Za1jZa1kZa1k[11l[11m[11n[11n[A5o[A60[A61[A61[Q62[Q63[Q64[`8A
QJl01Q66[a:7/1:8/1:8/1:9/1::/@8BRk402a:</Q:=/Q:>/Q>?/Q>?/a>@
/a>A/a>B/a>B]1>C]1>D]0024iFe00<DU[DDUkDDV;H00QBI]P0659Zf59^g
59bg59bg5Ifh5Ijh0QFO^0075J2i5J6i5J:i5J>i5J>j5JBj5ZFj008FY[/0
1aJW^aJX^aJY_1JY_1JZ_1J[_1J/_@025jfm00LG[[hG[khG/;hG/;hG/KlG
/[lG/kl00QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<0
0028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0
^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2002000fKYo7mkNkR9ScnmOSgRIOdHVkcX:kdHVkooOoo
[K3lhnWooolc@jD01@00P0060060oooooooo00>100B100F10_ooo`0D0@N2
0@R30@V30@V30@Z30@^40@b40@f4oooo0@j50Pn5oooo0Q260Q660Q:60Q>6
0Q>70QB70QF70QJ70P<GR006oooo0aV90aZ9oooo0a^90ab:0P<MRP0@11j:
11n;122;126;126<12:<12><12B<12B=1BF=1BJ=1BN=1BN>1BR>1BV>1BZ?
0PD[S`061Bb?1Rf@1Rj@1Rj@1Rn@1S2A0PHaT@0;1S:B1S>B1SBB1cFB1cFC
1cJC1cNC1cRC1cRD1cVD1cZD0087>iD00`PlU@PmU@PnUP0223nF00H8@9H8
@IL8@YL8@YL9@iP9A9P22DFH00L9AYT9AiT9B9T9BIT9BIX9BYX:BiX00PY<
V`072TfK2TjK2TnL2TnL2U2L2U6L2U:M008;Did01P]DWP]EWP]FWP]FWP]G
W`]HW`8;FIl00`aJX0aKX0aLX00235fQ00H<GZ4<Gj4<H:8<H:8=HJ8=HZ<2
3F>S00<=I:<=IJ@=IZ@00PeWY00;3FRU3VVU3VZU3VZV3V^V3VbV3VfV3VfW
3VjW3VnW3W2W008?LJP01PmbZ0mcZ@mdZ@mdZ@meZ@mfZP8?MjX0411hZQ1i
Za1jZa1kZa1k[11l[11m[11n[11n[A5o[A60[A61[A61[Q62[Q63[Q64[`8A
QJl01Q66[a:7/1:8/1:8/1:9/1::/@8BRk402a:</Q:=/Q:>/Q>?/Q>?/a>@
/a>A/a>B/a>B]1>C]1>D]0024iFe00<DU[DDUkDDV;H00QBI]P0659Zf59^g
59bg59bg5Ifh5Ijh0QFO^0075J2i5J6i5J:i5J>i5J>j5JBj5ZFj008FY[/0
1aJW^aJX^aJY_1JY_1JZ_1J[_1J/_@025jfm00LG[[hG[khG/;hG/;hG/KlG
/[lG/kl00QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<0
0028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0
^002R<2h0P0000:8`;P200000hS0^004B92800006;C06;C00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^08008000i^WlOK8c>8V?002ojf`00OO92ko
Y9kf_<Go[K3^Nhcooolc@jD01P00P0060060oooooooo00>100B100F10_oo
o`0D0@N20@R30@V30@V30@Z30@^40@b40@f4oooo0@j50Pn5oooo0Q260Q66
0Q:60Q>60Q>70QB70QF70QJ70P<GR006oooo0aV90aZ9oooo0a^90ab:0P<M
RP0@11j:11n;122;126;126<12:<12><12B<12B=1BF=1BJ=1BN=1BN>1BR>
1BV>1BZ?0PD[S`061Bb?1Rf@1Rj@1Rj@1Rn@1S2A0PHaT@0;1S:B1S>B1SBB
1cFB1cFC1cJC1cNC1cRC1cRD1cVD1cZD0087>iD00`PlU@PmU@PnUP0223nF
00H8@9H8@IL8@YL8@YL9@iP9A9P22DFH00L9AYT9AiT9B9T9BIT9BIX9BYX:
BiX00PY<V`072TfK2TjK2TnL2TnL2U2L2U6L2U:M008;Did01P]DWP]EWP]F
WP]FWP]GW`]HW`8;FIl00`aJX0aKX0aLX00235fQ00H<GZ4<Gj4<H:8<H:8=
HJ8=HZ<23F>S00<=I:<=IJ@=IZ@00PeWY00;3FRU3VVU3VZU3VZV3V^V3VbV
3VfV3VfW3VjW3VnW3W2W008?LJP01PmbZ0mcZ@mdZ@mdZ@meZ@mfZP8?MjX0
411hZQ1iZa1jZa1kZa1k[11l[11m[11n[11n[A5o[A60[A61[A61[Q62[Q63
[Q64[`8AQJl01Q66[a:7/1:8/1:8/1:9/1::/@8BRk402a:</Q:=/Q:>/Q>?
/Q>?/a>@/a>A/a>B/a>B]1>C]1>D]0024iFe00<DU[DDUkDDV;H00QBI]P06
59Zf59^g59bg59bg5Ifh5Ijh0QFO^0075J2i5J6i5J:i5J>i5J>j5JBj5ZFj
008FY[/01aJW^aJX^aJY_1JY_1JZ_1J[_1J/_@025jfm00LG[[hG[khG/;hG
/;hG/KlG/[lG/kl00QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002
R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf003R<2h0P0000B8`;P20000
0XS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^08008000i^WlOW=e?N9U`02oooo00Oo[K3Q5SCoMW_oY9kR9ScoRGlc@jD0
1P00P00:0060oooo00>100>100B100F100J2oooo0@N20@R30P49P`030@Z3
0@^40@b400813H@02`4>Q@8?QOooo`8@QP8AQP8BQP8CQP8CQ`8DQ`8EQ`8F
Q`020aN800?oool36HT36XT01Oooo`0@11j:11n;122;126;126<12:<12><
12B<12B=1BF=1BJ=1BN=1BN>1BR>1BV>1BZ?0PD[S`061Bb?1Rf@1Rj@1Rj@
1Rn@1S2A0PHaT@0;1S:B1S>B1SBB1cFB1cFC1cJC1cNC1cRC1cRD1cVD1cZD
0087>iD00`PlU@PmU@PnUP0223nF00H8@9H8@IL8@YL8@YL9@iP9A9P22DFH
00L9AYT9AiT9B9T9BIT9BIX9BYX:BiX00PY<V`072TfK2TjK2TnL2TnL2U2L
2U6L2U:M008;Did01P]DWP]EWP]FWP]FWP]GW`]HW`8;FIl00`aJX0aKX0aL
X00235fQ00H<GZ4<Gj4<H:8<H:8=HJ8=HZ<23F>S00<=I:<=IJ@=IZ@00PeW
Y00;3FRU3VVU3VZU3VZV3V^V3VbV3VfV3VfW3VjW3VnW3W2W008?LJP01Pmb
Z0mcZ@mdZ@mdZ@meZ@mfZP8?MjX0411hZQ1iZa1jZa1kZa1k[11l[11m[11n
[11n[A5o[A60[A61[A61[Q62[Q63[Q64[`8AQJl01Q66[a:7/1:8/1:8/1:9
/1::/@8BRk402a:</Q:=/Q:>/Q>?/Q>?/a>@/a>A/a>B/a>B]1>C]1>D]002
4iFe00<DU[DDUkDDV;H00QBI]P0659Zf59^g59bg59bg5Ifh5Ijh0QFO^007
5J2i5J6i5J:i5J>i5J>j5JBj5ZFj008FY[/01aJW^aJX^aJY_1JY_1JZ_1J[
_1J/_@025jfm00LG[[hG[khG/;hG/;hG/KlG/[lG/kl00QRd`003b>3HR<2h
R<2h00^8`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd
`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0P00P007VjOaoooolj2^m69^oooomhVGnLgD00;oool00o>P[_oo
oc=3Y@06002000H00H000X000h400h4018401H4200J200L11h8128<12H<1
2H<12X<12h@138@00P4=Q00;0@j50Pn50Q250Q260Q660Q:60Q>60Q>70QB7
0QF70QJ700835hP01P<HR0<IR@<JR@<JR@<KR@<LRP837HX040@NRP@OR`@P
R`@QR`@QS0@RS0@SS0@TS0@TS@DUS@DVS@DWS@DWSPDXSPDYSPDZS`85:hl0
1PD/S`H]T0H^T0H^T0H_T0H`T@86<I402`HbTPHcTPHdTPLeTPLeT`LfT`Lg
T`LhT`LhU0LiU0LjU0021c^E00<8?9D8?ID8?YH00PPoUP06242F246G24:G
24:G2D>H2DBH0PU5V0072DJI2DNI2DRI2DVI2DVJ2DZJ2T^J008:C9/01`Y=
V`Y>V`Y?W0Y?W0Y@W0YAW0YBW@022e>M00H;E9h;EIh;EYh;EYh;Eil;F9l2
2eVO00<<FZ0<Fj0<G:000PaMX@0635jQ35nQ362R362R3F6R3F:S0PeSX`03
3FBS3FFT3FJT008=Ij@02`eXY@iYY@iZY@iZYPi[YPi/YPi]YPi]Y`i^Y`i_
Y`i`Y`023g6X00H?LZP?LjT?M:T?M:T?MJT?MZX23gNZ010@N:X@NJ/@NZ/@
Nj/@Nj`@O:`@OJ`@OZ`@OZdAOjdAP:dAPJdAPJhAPZhAPjhAQ:l24HF_00HA
QZlBQk0BR;0BR;0BRK0BR[424X^a00/BS;8BSK8BS[8CSk8CSk<CT;<CTK<C
T[<CT[@CTk@CU;@00Q>E]@0359Je59Ne59Rf008DVKH01QBJ]QBK]aBL]aBL
]aFM^1FN^08EWkP01aFP^AFQ^AFR^AFS^AFS^QFT^QJU^P025ZJk00LFYk/F
Z;/FZK`FZK`FZ[`FZk`F[;d00QN]_@075jjn5jnn5k2n5k2n5k6o5k:o5k>o
008H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P03HS0^005B9280000
6;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P3002000^KYo7oooooRGooooocX:kaTj7ooooooOocX:ko
no`c@jD01P00P006006000:000>100>100B100F10P06PP070@N20@R30@V3
0@V30@Z30@^40@b400813H@02`4>Q@8?Q@8@Q@8@QP8AQP8BQP8CQP8CQ`8D
Q`8EQ`8FQ`020aN800H368P36HT36XT36XT36hT378X20af:01047XX47h/4
88/48H/48H`48X`48h`498`498d59Hd59Xd59hd59hh5:8h5:Hh5:Xl21B^?
00H5;8l6;I06;Y06;Y06;i06<9421S6A00/6<Y86<i86=987=I87=I<7=Y<7
=i<7>9<7>9@7>I@7>Y@00PLkU@0323bE23fE23jF0088?iH01PQ0UPQ1U`Q2
U`Q2U`U3V0U4V089AIP01`U6V@U7V@U8V@U9V@U9VPU:VPY;VP022TbK00L:
CI/:CY/:Ci`:Ci`:D9`:DI`:DYd00P]CW@062eBN2eFN2eJN2eJN2eNO2eRO
0P]IW`0335ZP35^P35bP008<GJ401PaNX@aOX@aPXPaPXPeQXPeRX`8=Hj<0
0`eTX`eUY0eVY0023FNT00/=J:D>JJD>JZD>JZH>JjH>K:H>KJH>KJL>KZL>
KjL>L:L00PmaZ0063g:X3g>Y3gBY3gBY3gFY3gJZ0PmgZP0@47RZ47V[47Z[
47^[47^/47b/47f/47j/47j]4Gn]4H2]4H6]4H6^4H:^4H>^4HB_0Q65[`06
4HJ_4XN`4XR`4XR`4XV`4XZa0Q:;/@0;4Xbb4Xfb4Xjb4hnb4hnc4i2c4i6c
4i:c4i:d4i>d4iBd008CUKD00aBF]ABG]ABH]P0259Vf00HDV[HDVkLDW;LD
W;LEWKPEW[P25Inh00LEX;TEXKTEX[TEXkTEXkXEY;XFYKX00QJV^`075ZNk
5ZRk5ZVl5ZVl5ZZl5Z^l5Zbm008G[Kd01aN^_QN__QN`_QN`_QNa_aNb_aNc
_`026;C03lSPf0030000b>3Hb>3H00g8h=P00`0001Rd`1Rd`00?b>3H00<0
000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0@00803VjOa
00KoooocX:kd]Kof_<GkfMXc@jD7002000H00H000X000h400h4018401H42
00J200L11h8128<12H<12H<12X<12h@138@00P4=Q00;0@j50Pn50Q250Q26
0Q660Q:60Q>60Q>70QB70QF70QJ700835hP01P<HR0<IR@<JR@<JR@<KR@<L
RP837HX040@NRP@OR`@PR`@QR`@QS0@RS0@SS0@TS0@TS@DUS@DVS@DWS@DW
SPDXSPDYSPDZS`85:hl01PD/S`H]T0H^T0H^T0H_T0H`T@86<I402`HbTPHc
TPHdTPLeTPLeT`LfT`LgT`LhT`LhU0LiU0LjU0021c^E00<8?9D8?ID8?YH0
0PPoUP06242F246G24:G24:G2D>H2DBH0PU5V0072DJI2DNI2DRI2DVI2DVJ
2DZJ2T^J008:C9/01`Y=V`Y>V`Y?W0Y?W0Y@W0YAW0YBW@022e>M00H;E9h;
EIh;EYh;EYh;Eil;F9l22eVO00<<FZ0<Fj0<G:000PaMX@0635jQ35nQ362R
362R3F6R3F:S0PeSX`033FBS3FFT3FJT008=Ij@02`eXY@iYY@iZY@iZYPi[
YPi/YPi]YPi]Y`i^Y`i_Y`i`Y`023g6X00H?LZP?LjT?M:T?M:T?MJT?MZX2
3gNZ010@N:X@NJ/@NZ/@Nj/@Nj`@O:`@OJ`@OZ`@OZdAOjdAP:dAPJdAPJhA
PZhAPjhAQ:l24HF_00HAQZlBQk0BR;0BR;0BRK0BR[424X^a00/BS;8BSK8B
S[8CSk8CSk<CT;<CTK<CT[<CT[@CTk@CU;@00Q>E]@0359Je59Ne59Rf008D
VKH01QBJ]QBK]aBL]aBL]aFM^1FN^08EWkP01aFP^AFQ^AFR^AFS^AFS^QFT
^QJU^P025ZJk00LFYk/FZ;/FZK`FZK`FZ[`FZk`F[;d00QN]_@075jjn5jnn
5k2n5k2n5k6o5k:o5k>o03HH]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h5000P006006000:000>100>100B100F10P06PP070@N20@R30@V30@V3
0@Z30@^40@b400813H@02`4>Q@8?Q@8@Q@8@QP8AQP8BQP8CQP8CQ`8DQ`8E
Q`8FQ`020aN800H368P36HT36XT36XT36hT378X20af:01047XX47h/488/4
8H/48H`48X`48h`498`498d59Hd59Xd59hd59hh5:8h5:Hh5:Xl21B^?00H5
;8l6;I06;Y06;Y06;i06<9421S6A00/6<Y86<i86=987=I87=I<7=Y<7=i<7
>9<7>9@7>I@7>Y@00PLkU@0323bE23fE23jF0088?iH01PQ0UPQ1U`Q2U`Q2
U`U3V0U4V089AIP01`U6V@U7V@U8V@U9V@U9VPU:VPY;VP022TbK00L:CI/:
CY/:Ci`:Ci`:D9`:DI`:DYd00P]CW@062eBN2eFN2eJN2eJN2eNO2eRO0P]I
W`0335ZP35^P35bP008<GJ401PaNX@aOX@aPXPaPXPeQXPeRX`8=Hj<00`eT
X`eUY0eVY0023FNT00/=J:D>JJD>JZD>JZH>JjH>K:H>KJH>KJL>KZL>KjL>
L:L00PmaZ0063g:X3g>Y3gBY3gBY3gFY3gJZ0PmgZP0@47RZ47V[47Z[47^[
47^/47b/47f/47j/47j]4Gn]4H2]4H6]4H6^4H:^4H>^4HB_0Q65[`064HJ_
4XN`4XR`4XR`4XV`4XZa0Q:;/@0;4Xbb4Xfb4Xjb4hnb4hnc4i2c4i6c4i:c
4i:d4i>d4iBd008CUKD00aBF]ABG]ABH]P0259Vf00HDV[HDVkLDW;LDW;LE
WKPEW[P25Inh00LEX;TEXKTEX[TEXkTEXkXEY;XFYKX00QJV^`075ZNk5ZRk
5ZVl5ZVl5ZZl5Z^l5Zbm008G[Kd01aN^_QN__QN`_QN`_QNa_aNb_aNc_`0f
6;C00XS0^058T8P1000000000hS0^<SPf8S0^03oR<2h=XS0^058T8P10000
00000hS0^<SPf8S0^03oR<2h=XS0^058T8P1000000000hS0^<SPf<SPf03o
b>3H=/SPf058T8P10000003oR<2h>XS0^04000000001\
\>"], "Graphics",
  ImageSize->{314, 139},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004/0000b2000`400?l0
0000o`00003oooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000
ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`
l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]
oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`
l?0]oo3`l000ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00I?oooomSogj]
fFGooooo001Tooooo`03ogj]fOl0003o000005oo000000?oOZgIoooooooo
ool0Hoooool000[ooooo00?oinOWoo[jn_ooool01?ooool00ooWinOon_[j
ooooo`03ooooo`03ooKfm_oalO7ooooo04[ooooo00?oOZgIo`000?l00000
1ol000000olB4Q;o0`<3o`000004o`000003oa8B4_l30`?o000000?o0000
00?o1PH6o`X:2_l00000B?l000000omn[MWoooooooooo`09ooooo`03onOW
ioojn_[ooooo00Cooooo00?oinOWoo[jn_ooool00oooool00oofm_KolO7a
ooooo`0@ooooo`03ookno_oShn?oh>3P03Oooooo0002ooooo`03oahN7_nV
YZKooooo00?ooooo00Go`<30oa`L7?lU9BGo2PX:ogUiN@02ooooo`05ol30
`?lL71co9BDUo`X:2_miNGT00_ooool01_nDU9Co10@4oa0@4?mXJ6So?3`l
oiZJVPWooooo00?oQ8B4ofIVI_ooool00_ooool01_oDe=Co8B4Qoa8B4_l:
2P[o8B4QoinOWcCooooo00CoOZgIo`000?n[Zj_o@d=31?l000001Ol_;boo
[:b/ojFUYOnj^[[oIFEU00;o000000Go;bl_ojb/[?nUYJGo^[ZjofEUI@02
o`000006oe5ADOnn_[ko]KFeog9bL_nDU9CoC4a<2Ol000000omMGEgoM7Ad
o`000002o`0000Go`/;200?o7QhNo`000?l00000<?l000001_mn[MWooooo
oooooooooooo7QhNojJVYPCooooo00Go`<30oa`L7?lU9BGo2PX:ogUiN@02
ooooo`05ol30`?lL71co9BDUo`X:2_miNGT00_ooool01_nDU9Co10@4oa0@
4?mXJ6So?3`loiZJVPWooooo00?oQ8B4ofIVI_ooool00_ooool01Olm?Cgo
;Rh^ocTi>Ol^;RkoWinO03Gooooo0002ooooo`03oahN7_nVYZKooooo00;o
oooo01Golo?coaLG5onATI7oooooon;Rh_lD51CoZj^[oo?clolG5aOoTI6A
oooooooRh^;o51@Doj^[ZoomoOgo5ADEoi^KVoono_ko[Zj^o`l?3onJVYX0
2Oooool00on4Q8CoIVIVooooo`04ooooo`03ohZ:R_m=CDgooooo03Gooooo
00CoOZgIo`000?n[Zj_o@d=30ol000005Ol92@Wo/;2`oe=CDol0003o5QHF
ok:b/_lo?coo2@T9ok2`/?mCDe?o0000oaHF5_nb/[;o?cloo`410Onb/[;o
C4a<o`000?lm?Cgo][Jfoda<C009o`000003oeeMGOmdM7Co000000;o0000
00?oR8R8ogQhN?l20P800_l20P8co`000006ogj]fOoooooooooooooooolN
7QkoYZJV0oooool05Ooclo?o5aLGoi6ATOooooooh^;Roa@D5?n[Zj_olo?c
oaLG5onATI7oooooon;Rh_lD51CoZj^[oogmoOlE5AGoVi^Kookno_n^[Zko
3`l?oiZJVP09ooooo`03ohB4Q?mVIVKooooo00;ooooo00KomOGeoooooooo
ooooYZJVo`@41?oVi^Hdooooo`000_ooool00olN7QkoYZJVooooo`02oooo
o`03ol30`?l20P;ok^k^00;ooooo00GoDe=Cof5QHOo0`<3o0P82onk^kP02
ooooo`05oe=CDomQHF7ob/[:o`D51OogmoL00_ooool00olm?CgoVYZJoooo
o`04ooooo`07ol[:b_mdM7CoM7AdogAdM?ll?3co;Rh^oiFEU@04ooooo`03
ohZ:R_m=CDgooooo03Gooooo00CoOZgIo`000?n[Zj_o@d=30ol000000ol_
;boo`<30o``<3002o`000005oh:2P_mhN7So;bl_ol30`?l<30`00_l00000
1On2PX;oN7QhobPX:?nn_[ko1PH600;o000000?oTi>Coda<C?l000001?l0
00001olX:2SoJFUYofUYJOmYJFWoU9BDoinOWom@D5000_l000000olD51Co
YjNWocPh>00eo`000006ogj]fOoooooooooooooooolN7QkoYZJV0oooool0
0oo0`<3o0P82onk^kP02ooooo`05oe=CDomQHF7o`<30o`820_o^k^h00_oo
ool01OmCDe?oHF5Qol[:b_l51@GomoOg00;ooooo00?o?CdmoiZJV_ooool0
1?ooool01oo:b/[oM7AdogAdM?mdM7Co?3`lobh^;_nEUID01Oooool00ooZ
j^[o0000olg=c@0dooooo`000_ooool02?lN7QkoW9bLoo3`l?o`l?3onOWi
ok>c/ol;2`_oo?cl0_ooool01OmYJFWoE5ADok>c/ol;2`_oo?cl00;ooooo
00GoJFUYoeADE?o=cLgo2PX:oo_kn`02ooooo`03ocdm?OnJVY[ooooo00Co
oooo00OoaLG5o`d=3OnCTi?oVIVIoe]KFolm?Cgo/[:b00Cooooo00?oRXZ:
ode=COooool0=Oooool01?mn[MWo0000oj^[Zom;Bd/2o`/;2`04o`@41?li
>CWo^KVio`820P;o000000GoLW9boh:2P_li>CWo^KVio`820P02o`000005
og9bL_n2PX;o9RHVokZj^_l30`<00_l000000onCTi?oC4a<o`000004o`00
0007ob`/;?nh^;SoDU9Bode=COmlO7coTi>CocXj>P03o`000003oa/K6onU
YJGo>CTi03Co000000KoOZgIoooooooooooooooooahN7_nLW9`2oo3`l004
ooWinOnc/k?o2`/;ooclo0;ooooo00GoJFUYoeADE?nc/k?o2`/;ooclo002
ooooo`05ofUYJOmDE5CocLg=o`X:2_okno/00_ooool00olm?CgoVYZJoooo
o`04ooooo`07olG5aOl=3@goTi>CoiVIVOmKFe_o?Cdmok:b/P04ooooo`04
ooCdm?mdM7Co8B4QooknoSCooooo0002ooooo`08oahN7_lI6AWo9bLWobLW
9on/[:coh>3Po`820_o;bl/2ooooo`05ob`/;?n4Q8Coh>3Po`820_o;bl/0
0_ooool01Ol/;2coQ8B4ookno_lI6AWobl_;00;ooooo00?o=SHfoiVIVOoo
ool01Oooool01OmhN7SoL71`oooooonHV9SoIVIV00Gooooo00?oRXZ:ode=
COooool0=Oooool01?mn[MWo0000oj^[Zon^[Zh2ojBTY004oclo?olG5aOo
`<30obLW9`;o000000GoX:2PoeeMGOlG5aOo`<30obLW9`02o`000005oj2P
X?mMGEgo0000ojj^[_lW9bL00_l000000onHV9SoCDe=o`000005o`000005
ofIVI_m/K6co0000odi>C_mdM7@01Ol000000olG5aOoZj^[ocDe=@0co`00
0006ogj]fOoooooooooooooooolN7Qko6ATI0_lW9bL01?n/[:coh>3Po`82
0_o;bl/2ooooo`05ob`/;?n4Q8Coh>3Po`820_o;bl/00_ooool01Ol/;2co
Q8B4ookno_lI6AWobl_;00;ooooo00?o=SHfoiVIVOooool01Oooool01Omh
N7SoL71`oooooonHV9SoIVIV00Cooooo00Co<c<co`@41?mJFU[okNg]=Ooo
ool000;ooooo00?o7QhNojJVY_ooool00oooool05?mgMgOo7QhNoh:2P_m5
ADGo:2PXoo7alOooooooMgMgoahN7_n2PX;oADE5obPX:?oalO7oooooog]k
NolL71coPX:2ocHf=_l@413oVYZJ1_ooool01Ookno_o>CTiok:b/_nHV9So
IVIV00Gooooo00?oRXZ:ode=COooool0=Oooool01?mn[MWo0000oj^[Zom3
@d<4o`00000DofMWIon[Zj_oGemOohf=SOnSXj?o2PX:o`000?mWIfOoZj^[
oemOGon=SHgoXj>So`X:2_l0003oI6ATojb/[?mOGeooV9RHokFe]Om<C4`6
o`000005o`<30onFUYKo>SXjodi>C_mdM7@01_l000000oln?Sko/[:bo`41
0@0bo`000006ogj]fOoooooooooooooooolN7QkoYZJV1?ooool05?mgMgOo
7QhNoh:2P_m5ADGo:2PXoo7alOooooooMgMgoahN7_n2PX;oADE5obPX:?oa
lO7oooooog]kNolL71coPX:2ocHf=_l@413oVYZJ1_ooool01Ookno_o>CTi
ok:b/_nHV9SoIVIV00Cooooo00Com_Kfokno_om1@D7oYJFU=Oooool000;o
oooo00?o7QhNojJVY_ooool01?ooool01?o1`L7oS8b<ojBTY?oemOD3oooo
o`04ol71`On<S8coY:BTooGem@?ooooo00Go];Bdohf=SOo@d=3o?CdmoiZJ
VP07ooooo`04omoOgolR8R;oNg]kofIVIPGooooo00?oRXZ:ode=COooool0
=Oooool01?mn[MWo0000oj^[Zom3@d<5o`000004obl_;omGEeOoADE5o`L7
1`?o000000Co;bl_oeMGEom5ADGo1`L70ol000001Oli>CWoEUIFob<S8onC
Ti?oC4a<00Oo000000Co61PHojRXZ?mTI6CoM7Ad1_l000000olE5AGo`/;2
oaDE5@0bo`000006ogj]fOoooooooooooooooolN7QkoYZJV1Oooool01?o1
`L7oS8b<ojBTY?oemOD3ooooo`04ol71`On<S8coY:BTooGem@?ooooo00Go
];Bdohf=SOo@d=3o?CdmoiZJVP07ooooo`04omoOgolR8R;oNg]kofIVIPKo
oooo00?o/[:bobHV9_ooool0=?ooool000;ooooo00Go7QhNogemOOo0`<3o
`<30ol;2`P0Cooooo`03ocdm?OnJVY[ooooo00Oooooo00?oZJVYo`H61_mU
IFD00oooool01?oMgMgoLg=coeQHF?m=CDdfooooo`04ogj]fOl0003oZj^[
of9RHP;o;bl_00?o;Rh^o`000?l000004Ol000000onCTi?oC4a<o`000007
o`000003od51@Onm_KgoMGEe00?o000000GoDe=Coc0`<?l>3PkoJf][oiFE
U@0co`000006ogj]fOoooooooooooooooolN7QkoOGem0_o0`<000oo2`/;o
ooooooooo`0Aooooo`03ocdm?OnJVY[ooooo00Oooooo00?oZJVYo`H61_mU
IFD00oooool01Ono_kooe=CDonk^k_m[Jf_oC4a<03Gooooo0002ooooo`05
ofQXJ?mCDe?oDe=Coe=CDomJFUX04oooool00olm?CgoVYZJooooo`08oooo
o`03oh:2P_nHV9Sooooo00;ooooo00Com_KfojRXZ?mYJFWoL71`=_ooool0
0omn[MWo0000og9bLP03oh:2PP03ogemOOl0003o0000017o000000?oTi>C
oda<C?l000002?l000000omOGeooCTi>o`000002o`000005od92@_mnOWko
WYjNof][JolM7Ad0<ol000001Omn[MWoooooooooooooooooJ6QX00?oDe=C
00?oFUYJooooooooool04Oooool00olm?CgoVYZJooooo`08ooooo`03oh:2
P_nHV9Sooooo00;ooooo00GoVIVIod51@Ol^;RkoJf][omSHf00eooooo`00
6_ooool00oo>c/koi^KVooooo`17ooooo`03ogj]fOl0003o000001Oo0000
00?o9BDUoa<C4ol00000AOl000000omn[MWoooooooooo`0Iooooo`03olk>
c_oVi^Kooooo04Oooooo001Tooooo`03ogj]fOl0003o000005oo000000?o
OZgIooooooooool0Hoooool006CoooooHomn[MUUooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`002_ooool00ooWinOon_[joooo
o`04ooooo`03onOWioojn_[ooooo00?ooooo00?om_Kfoo7alOooool02?oo
ool00oono_kohn?Son3Ph019ooooo`03onOWioojn_[ooooo00Cooooo00?o
inOWoo[jn_ooool00oooool00oofm_KolO7aooooo`08ooooo`03ookno_oS
hn?oh>3P04Wooooo00?oinOWoo[jn_ooool01?ooool00ooWinOon_[joooo
o`03ooooo`03ooKfm_oalO7ooooo00Sooooo00?oo_knon?ShooPh>001Ooo
ool00oono_kohn?Son3Ph00gooooo`000_ooool00olN7QkoYZJVooooo`03
ooooo`05ol30`?lL71co9BDUo`X:2_miNGT00_ooool01Oo0`<3o71`LobDU
9Ol:2P[oNGUi00;ooooo00KoU9BDo`@41?l@413oJ6QXoc`l??nJVYX6oooo
o`05ocdm?Ol^;Rko>CTiobh^;_nOWil00oooool01_oDe=Co8B4Qoa8B4_l:
2P[o8B4QoinOWcKooooo00?o7QhNojJVY_ooool00oooool01Oo0`<3o71`L
obDU9Ol:2P[oNGUi00;ooooo00Go`<30oa`L7?lU9BGo2PX:ogUiN@02oooo
o`06oiBDU?l410Co410@ofQXJ?ll?3coVYZJ1_ooool01Olm?Cgo;Rh^ocTi
>Ol^;RkoWinO00?ooooo1Ol000000ooGemOoooooooooo`0dooooo`03oahN
7_nVYZKooooo00?ooooo00Go`<30oa`L7?lU9BGo2PX:ogUiN@02ooooo`05
ol30`?lL71co9BDUo`X:2_miNGT00_ooool01_nDU9Co10@4oa0@4?mXJ6So
?3`loiZJVPKooooo00Go?Cdmobh^;_li>CWo;Rh^oinOW`03ooooo`05ocdm
?Ol^;Rko>CTiobh^;_nOWil0=Oooool000;ooooo00?o7QhNojJVY_ooool0
0_ooool05Ooclo?o5aLGoi6ATOooooooh^;Roa@D5?n[Zj_olo?coaLG5onA
TI7oooooon;Rh_lD51CoZj^[oogmoOlE5AGoVi^Kookno_n^[Zko3`l?oiZJ
VP06ooooo`06ooGemOooooooooooojJVY_l410Coi^KV1?ooool00on:RX[o
CDe=ooooo`0gooooo`03oahN7_nVYZKooooo00;ooooo01Golo?coaLG5onA
TI7oooooon;Rh_lD51CoZj^[oo?clolG5aOoTI6AoooooooRh^;o51@Doj^[
ZoomoOgo5ADEoi^KVoono_ko[Zj^o`l?3onJVYX01_ooool01_oemOGooooo
oooooonVYZKo10@4onKViP;ooooo00?oC4a<of1PH?olo?`00_olo?`goooo
o`03oahN7_nVYZKooooo00;ooooo01Golo?coaLG5onATI7oooooon;Rh_lD
51CoZj^[oo?clolG5aOoTI6AoooooooRh^;o51@Doj^[ZoomoOgo5ADEoi^K
Voono_ko[Zj^o`l?3onJVYX01_ooool01_oemOGooooooooooonVYZKo10@4
onKViP;ooooo00KomOGeooooooooooooYZJVo`@41?oVi^Hdooooo`000_oo
ool00olN7QkoYZJVooooo`02ooooo`03ol30`?l20P;ok^k^00;ooooo00Go
De=Cof5QHOo0`<3o0P82onk^kP02ooooo`05oe=CDomQHF7ob/[:o`D51Oog
moL00_ooool00olm?CgoVYZJooooo`08ooooo`03on[Zj_l0003ocLg=00Co
oooo00?oRXZ:ode=COooool0=oooool00olN7QkoYZJVooooo`02ooooo`03
ol30`?l20P;ok^k^00;ooooo00GoDe=Cof5QHOo0`<3o0P82onk^kP02oooo
o`05oe=CDomQHF7ob/[:o`D51OogmoL00_ooool00olm?CgoVYZJooooo`08
ooooo`03on[Zj_l0003ocLg=00;ooooo00?oi>CTob<S8one]KD0>Oooool0
0olN7QkoYZJVooooo`02ooooo`03ol30`?l20P;ok^k^00;ooooo00GoDe=C
of5QHOo0`<3o0P82onk^kP02ooooo`05oe=CDomQHF7ob/[:o`D51OogmoL0
0_ooool00olm?CgoVYZJooooo`08ooooo`03on[Zj_l0003ocLg=00Gooooo
00?oj^[Zo`000?o=cLd0=?ooool000;ooooo00So7QhNoibLW?o`l?3ol?3`
ooWinOnc/k?o2`/;ooclo0;ooooo00GoJFUYoeADE?nc/k?o2`/;ooclo002
ooooo`05ofUYJOmDE5CocLg=o`X:2_okno/00_ooool00olm?CgoVYZJoooo
o`07ooooo`04ooCdm?mdM7Co8B4QooknoPCooooo00?oRXZ:ode=COooool0
=oooool02?lN7QkoW9bLoo3`l?o`l?3onOWiok>c/ol;2`_oo?cl0_ooool0
1OmYJFWoE5ADok>c/ol;2`_oo?cl00;ooooo00GoJFUYoeADE?o=cLgo2PX:
oo_kn`02ooooo`03ocdm?OnJVY[ooooo00Oooooo00Com?CdogAdM?lQ8B7o
o_kn0oooool00ooKfm_o9BDUok>c/`0hooooo`08oahN7_nLW9col?3`oo3`
l?oinOWo/k>co`/;2oolo?`2ooooo`05ofUYJOmDE5Co/k>co`/;2oolo?`0
0_ooool01OmYJFWoE5ADolg=cOl:2P[ono_k00;ooooo00?o?CdmoiZJV_oo
ool01oooool01?odm?CoM7Adob4Q8Oono_h4ooooo`04ooCdm?mdM7Co8B4Q
ooknoSCooooo0002ooooo`08oahN7_lI6AWo9bLWobLW9on/[:coh>3Po`82
0_o;bl/2ooooo`05ob`/;?n4Q8Coh>3Po`820_o;bl/00_ooool01Ol/;2co
Q8B4ookno_lI6AWobl_;00;ooooo00?o=SHfoiVIVOooool01_ooool01?lc
<c?o10@4oeYJF_o]kNd5ooooo`03ohZ:R_m=CDgooooo03Oooooo00So7QhN
oaTI6OlW9bOo9bLWojb/[?oPh>3o0P82ol_;b`;ooooo00Go;2`/ohB4Q?oP
h>3o0P82ol_;b`02ooooo`05ob`/;?n4Q8Coo_knoaTI6Oo;bl/00_ooool0
0olf=SKoVIVIooooo`06ooooo`04oc<c<ol410CoFUYJong]k@Gooooo00?o
h>3PoadM7Oni^KT0=oooool02?lN7Qko6ATIobLW9olW9bOo[:b/on3Ph?l2
0P;obl_;0_ooool01Ol/;2coQ8B4on3Ph?l20P;obl_;00;ooooo00Go;2`/
ohB4Q?ono_ko6ATIol_;b`02ooooo`03ocHf=_nIVIWooooo00Kooooo00Co
<c<co`@41?mJFU[okNg]1?ooool01?lc<c?o10@4oeYJF_o]kNdeooooo`00
0_ooool00olN7QkoYZJVooooo`03ooooo`0DogMgMolN7QkoPX:2odE5AOlX
:2SolO7aoooooomgMgOo7QhNoh:2P_m5ADGo:2PXoo7alOooooooNg]koa`L
7?n2PX;o=SHfoa0@4?nJVYX7ooooo`04ooKfm_no_koo@D51ojFUY@Gooooo
00?oRXZ:ode=COooool0=oooool00olN7QkoYZJVooooo`03ooooo`0DogMg
MolN7QkoPX:2odE5AOlX:2SolO7aoooooomgMgOo7QhNoh:2P_m5ADGo:2PX
oo7alOooooooNg]koa`L7?n2PX;o=SHfoa0@4?nJVYX7ooooo`04ooKfm_no
_koo@D51ojFUY@Kooooo00?o[Jf]oa@D5?omoOd0=_ooool00olN7QkoYZJV
ooooo`03ooooo`0DogMgMolN7QkoPX:2odE5AOlX:2SolO7aoooooomgMgOo
7QhNoh:2P_m5ADGo:2PXoo7alOooooooNg]koa`L7?n2PX;o=SHfoa0@4?nJ
VYX7ooooo`04ooKfm_no_koo@D51ojFUY@Cooooo00Com_Kfokno_om1@D7o
YJFU=Oooool000;ooooo00?o7QhNojJVY_ooool01?ooool01?o1`L7oS8b<
ojBTY?oemOD3ooooo`04ol71`On<S8coY:BTooGem@?ooooo00Go];Bdohf=
SOo@d=3o?CdmoiZJVP09ooooo`03ok:b/_lV9RKooooo00Cooooo00?oRXZ:
ode=COooool0=oooool00olN7QkoYZJVooooo`04ooooo`04ol71`On<S8co
Y:BTooGem@?ooooo00Co`L71ohb<S?nTY:ComOGe0oooool01Ond];CoSHf=
om3@d?lm?CgoVYZJ00Wooooo00?o/[:bobHV9_ooool01Oooool00ooShn?o
0000on?Sh`0fooooo`03oahN7_nVYZKooooo00Cooooo00Co`L71ohb<S?nT
Y:ComOGe0oooool01?o1`L7oS8b<ojBTY?oemOD3ooooo`05okBd]?n=SHgo
d=3@ocdm?OnJVYX02Oooool00onb/[;o9RHVooooo`05ooooo`03ok:b/_lV
9RKooooo03Cooooo0002ooooo`05oahN7_mmOGgo`<30ol30`?o2`/804ooo
ool00olm?CgoVYZJooooo`05ooooo`05okno_ooDe=Cok^k^of][Jom<C4`0
0oooool01?oMgMgoLg=coeQHF?m=CDdhooooo`05oahN7_mmOGgo`<30ol30
`?o2`/804oooool00olm?CgoVYZJooooo`05ooooo`05okno_ooDe=Cok^k^
of][Jom<C4`00oooool01OnATI7o_knoonc/k?mbLW;o>SXj03Oooooo00Go
7QhNogemOOo0`<3o`<30ol;2`P0Cooooo`03ocdm?OnJVY[ooooo00Gooooo
00Go_knoomCDe?o^k^koJf][oda<C003ooooo`05okno_ooDe=Cok^k^of][
Jom<C4`0=Oooool000;ooooo00GoJ6QXoe=CDomCDe?oDe=CoeYJFP0Coooo
o`03ocdm?OnJVY[ooooo00Gooooo00GoVIVIod51@Ol^;RkoJf][omSHf003
ooooo`04ooKfm_nXZ:SoJFUYog1`L3Sooooo00GoJ6QXoe=CDomCDe?oDe=C
oeYJFP0Cooooo`03ocdm?OnJVY[ooooo00Gooooo00GoVIVIod51@Ol^;Rko
Jf][omSHf003ooooo`05ojNWYomIFEWo;bl_og9bL_oHf=P0=oooool01OmX
J6SoDe=Coe=CDomCDe?oFUYJ01?ooooo00?o?CdmoiZJV_ooool01Oooool0
1OnIVIWo@D51obh^;_m[Jf_of=SH00?ooooo00GoVIVIod51@Ol^;RkoJf][
omSHf00eooooo`006_ooool00oo>c/koi^KVooooo`1Qooooo`03olk>c_oV
i^Kooooo067ooooo00?oc/k>onKVi_ooool0Aoooool00?oooooo;Oooool0
0?oooooo;Oooool00?oooooo;Oooool00?oooooo;Oooool00?oooooo;Ooo
ool000[ooooo00?oinOWoo[jn_ooool01?ooool00ooWinOon_[jooooo`03
ooooo`03ooKfm_oalO7ooooo05Cooooo00?oinOWoo[jn_ooool01?ooool0
0ooWinOon_[jooooo`03ooooo`03ooKfm_oalO7ooooo05Cooooo00?oinOW
oo[jn_ooool01?ooool00ooWinOon_[jooooo`03ooooo`03ooKfm_oalO7o
oooo013ooooo00?oo_knon?ShooPh>00=oooool000;ooooo00?o7QhNojJV
Y_ooool00oooool01Oo0`<3o71`LobDU9Ol:2P[oNGUi00;ooooo00Go`<30
oa`L7?lU9BGo2PX:ogUiN@02ooooo`06oiBDU?l410Co410@ofQXJ?ll?3co
VYZJ1_ooool5o`000009omOGeoooooooooooomCDe?lQ8B7o4Q8Bo`X:2_lQ
8B7oWinO03Kooooo00?o7QhNojJVY_ooool00oooool01Oo0`<3o71`LobDU
9Ol:2P[oNGUi00;ooooo00Go`<30oa`L7?lU9BGo2PX:ogUiN@02ooooo`06
oiBDU?l410Co410@ofQXJ?ll?3coVYZJ1_ooool5o`000003omOGeooooooo
oooo00Go000000?oemOGooooooooool0=?ooool00olN7QkoYZJVooooo`03
ooooo`05ol30`?lL71co9BDUo`X:2_miNGT00_ooool01Oo0`<3o71`LobDU
9Ol:2P[oNGUi00;ooooo00KoU9BDo`@41?l@413oJ6QXoc`l??nJVYX6oooo
o`Go000000SoemOGoooooooooooo?Cdmobh^;_li>CWo;Rh^oinOWcGooooo
0002ooooo`03oahN7_nVYZKooooo00;ooooo01Golo?coaLG5onATI7ooooo
on;Rh_lD51CoZj^[oo?clolG5aOoTI6AoooooooRh^;o51@Doj^[ZoomoOgo
5ADEoi^KVoono_ko[Zj^o`l?3onJVYX01_ooool00om<C4coH61Pooclo002
ooclo0Gooooo00?oRXZ:ode=COooool0=oooool00olN7QkoYZJVooooo`02
ooooo`0Eoo?clolG5aOoTI6AoooooooRh^;o51@Doj^[Zooclo?o5aLGoi6A
TOooooooh^;Roa@D5?n[Zj_ooOgmoaDE5OnKVi_oo_knojj^[_l?3`ooVYZJ
00Kooooo00?oC4a<of1PH?olo?`00_olo?`3ooooo`03oda<C?mPH63oo?cl
00;oo?cl=oooool00olN7QkoYZJVooooo`02ooooo`0Eoo?clolG5aOoTI6A
oooooooRh^;o51@Doj^[Zooclo?o5aLGoi6ATOooooooh^;Roa@D5?n[Zj_o
oOgmoaDE5OnKVi_oo_knojj^[_l?3`ooVYZJ00Kooooo00?oC4a<of1PH?ol
o?`00_olo?`3ooooo`06ooGemOooooooooooojJVY_l410Coi^KV=?ooool0
00;ooooo00?o7QhNojJVY_ooool00_ooool00oo0`<3o0P82onk^kP02oooo
o`05oe=CDomQHF7o`<30o`820_o^k^h00_ooool01OmCDe?oHF5Qol[:b_l5
1@GomoOg00;ooooo00?o?CdmoiZJV_ooool01Oooool00ooTi>Co8b<SokFe
]@07ooooo`03ohZ:R_m=CDgooooo03Oooooo00?o7QhNojJVY_ooool00_oo
ool00oo0`<3o0P82onk^kP02ooooo`05oe=CDomQHF7o`<30o`820_o^k^h0
0_ooool01OmCDe?oHF5Qol[:b_l51@GomoOg00;ooooo00?o?CdmoiZJV_oo
ool01Oooool00ooTi>Co8b<SokFe]@05ooooo`03onCTi?lS8b?o]KFe03Wo
oooo00?o7QhNojJVY_ooool00_ooool00oo0`<3o0P82onk^kP02ooooo`05
oe=CDomQHF7o`<30o`820_o^k^h00_ooool01OmCDe?oHF5Qol[:b_l51@Go
moOg00;ooooo00?o?CdmoiZJV_ooool01Oooool00ooTi>Co8b<SokFe]@08
ooooo`03on[Zj_l0003ocLg=03Cooooo0002ooooo`08oahN7_nLW9col?3`
oo3`l?oinOWo/k>co`/;2oolo?`2ooooo`05ofUYJOmDE5Co/k>co`/;2ool
o?`00_ooool01OmYJFWoE5ADolg=cOl:2P[ono_k00;ooooo00?o?CdmoiZJ
V_ooool01_ooool00ooKfm_o9BDUok>c/`06ooooo`03ohZ:R_m=CDgooooo
03Oooooo00So7QhNoibLW?o`l?3ol?3`ooWinOnc/k?o2`/;ooclo0;ooooo
00GoJFUYoeADE?nc/k?o2`/;ooclo002ooooo`05ofUYJOmDE5CocLg=o`X:
2_okno/00_ooool00olm?CgoVYZJooooo`06ooooo`03om_KfolU9BGo/k>c
00Gooooo00?ofm_KobDU9Onc/k<0>?ooool02?lN7QkoW9bLoo3`l?o`l?3o
nOWiok>c/ol;2`_oo?cl0_ooool01OmYJFWoE5ADok>c/ol;2`_oo?cl00;o
oooo00GoJFUYoeADE?o=cLgo2PX:oo_kn`02ooooo`03ocdm?OnJVY[ooooo
00Kooooo00?ofm_KobDU9Onc/k<01_ooool01?odm?CoM7Adob4Q8Oono_hd
ooooo`000_ooool02?lN7Qko6ATIobLW9olW9bOo[:b/on3Ph?l20P;obl_;
0_ooool01Ol/;2coQ8B4on3Ph?l20P;obl_;00;ooooo00Go;2`/ohB4Q?on
o_ko6ATIol_;b`02ooooo`03ocHf=_nIVIWooooo00Oooooo00?oh>3PoadM
7Oni^KT01Oooool00on:RX[oCDe=ooooo`0gooooo`08oahN7_lI6AWo9bLW
obLW9on/[:coh>3Po`820_o;bl/2ooooo`05ob`/;?n4Q8Coh>3Po`820_o;
bl/00_ooool01Ol/;2coQ8B4ookno_lI6AWobl_;00;ooooo00?o=SHfoiVI
VOooool01oooool00ooPh>3o7AdMokVi^@05ooooo`03on3Ph?lM7Ago^KVi
03Oooooo00So7QhNoaTI6OlW9bOo9bLWojb/[?oPh>3o0P82ol_;b`;ooooo
00Go;2`/ohB4Q?oPh>3o0P82ol_;b`02ooooo`05ob`/;?n4Q8Coo_knoaTI
6Oo;bl/00_ooool00olf=SKoVIVIooooo`07ooooo`03on3Ph?lM7Ago^KVi
00Cooooo00Co<c<co`@41?mJFU[okNg]=Oooool000;ooooo00?o7QhNojJV
Y_ooool00oooool05?mgMgOo7QhNoh:2P_m5ADGo:2PXoo7alOooooooMgMg
oahN7_n2PX;oADE5obPX:?oalO7oooooog]kNolL71coPX:2ocHf=_l@413o
VYZJ2Oooool00on][Jgo51@Doogmo@04ooooo`03ohZ:R_m=CDgooooo03Oo
oooo00?o7QhNojJVY_ooool00oooool05?mgMgOo7QhNoh:2P_m5ADGo:2PX
oo7alOooooooMgMgoahN7_n2PX;oADE5obPX:?oalO7oooooog]kNolL71co
PX:2ocHf=_l@413oVYZJ2Oooool00on][Jgo51@Doogmo@05ooooo`03ojf]
[OlD51CooOgm03Kooooo00?o7QhNojJVY_ooool00oooool05?mgMgOo7QhN
oh:2P_m5ADGo:2PXoo7alOooooooMgMgoahN7_n2PX;oADE5obPX:?oalO7o
ooooog]kNolL71coPX:2ocHf=_l@413oVYZJ2Oooool00on][Jgo51@Doogm
o@03ooooo`04ooKfm_no_koo@D51ojFUYCGooooo0002ooooo`03oahN7_nV
YZKooooo00Cooooo00Co`L71ohb<S?nTY:ComOGe0oooool01?o1`L7oS8b<
ojBTY?oemOD3ooooo`05okBd]?n=SHgod=3@ocdm?OnJVYX02Oooool00ooS
hn?o0000on?Sh`04ooooo`03ohZ:R_m=CDgooooo03Oooooo00?o7QhNojJV
Y_ooool01?ooool01?o1`L7oS8b<ojBTY?oemOD3ooooo`04ol71`On<S8co
Y:BTooGem@?ooooo00Go];Bdohf=SOo@d=3o?CdmoiZJVP09ooooo`03on?S
hol0003ohn?S00Gooooo00?ohn?So`000?oShn<0=_ooool00olN7QkoYZJV
ooooo`04ooooo`04ol71`On<S8coY:BTooGem@?ooooo00Co`L71ohb<S?nT
Y:ComOGe0oooool01Ond];CoSHf=om3@d?lm?CgoVYZJ00Wooooo00?ohn?S
o`000?oShn<01Oooool00onb/[;o9RHVooooo`0dooooo`000_ooool01OlN
7QkoOGemol30`?o0`<3o`/;201?ooooo00?o?CdmoiZJV_ooool01Oooool0
1OnATI7o_knoonc/k?mbLW;o>SXj00?ooooo00CogMgMog=cLomHF5SoCDe=
>?ooool01OlN7QkoOGemol30`?o0`<3o`/;201?ooooo00?o?CdmoiZJV_oo
ool01Oooool01OnATI7o_knoonc/k?mbLW;o>SXj00?ooooo00GoTI6Aokno
_oo/k>coLW9bocXj>P0gooooo`05oahN7_mmOGgo`<30ol30`?o2`/804ooo
ool00olm?CgoVYZJooooo`05ooooo`05oi6ATOno_kook>c/og9bL_lj>SX0
0oooool01Ono_kooe=CDonk^k_m[Jf_oC4a<03Gooooo0002ooooo`05ofQX
J?mCDe?oDe=Coe=CDomJFUX04oooool00olm?CgoVYZJooooo`05ooooo`05
ojNWYomIFEWo;bl_og9bL_oHf=P00oooool01?ofm_KoZ:RXofUYJOm`L70h
ooooo`05ofQXJ?mCDe?oDe=Coe=CDomJFUX04oooool00olm?CgoVYZJoooo
o`05ooooo`05ojNWYomIFEWo;bl_og9bL_oHf=P00oooool01OnWYjOoFEUI
obl_;ombLW;of=SH03Oooooo00GoJ6QXoe=CDomCDe?oDe=CoeYJFP0Coooo
o`03ocdm?OnJVY[ooooo00Gooooo00GoYjNWoeUIFOl_;booLW9bomSHf003
ooooo`05oiVIVOm1@D7o;Rh^of][JooHf=P0=Oooool001[ooooo00?oc/k>
onKVi_ooool0HOooool00oo>c/koi^KVooooo`1Qooooo`03olk>c_oVi^Ko
oooo04Oooooo003oooooobgooooo003oooooobgooooo003oooooobgooooo
003oooooobgooooo003oooooobgooooo000:ooooo`03onOWioojn_[ooooo
00Cooooo00?oinOWoo[jn_ooool00oooool00oofm_KolO7aooooo`1Doooo
o`03onOWioojn_[ooooo00Cooooo00?oinOWoo[jn_ooool00oooool00oof
m_KolO7aooooo`1Dooooo`03onOWioojn_[ooooo00Cooooo00?oinOWoo[j
n_ooool00oooool00oofm_KolO7aooooo`0@ooooo`03ookno_oShn?oh>3P
03Oooooo0002ooooo`03oahN7_nVYZKooooo00?ooooo00Go`<30oa`L7?lU
9BGo2PX:ogUiN@02ooooo`05ol30`?lL71co9BDUo`X:2_miNGT00_ooool0
1_nDU9Co10@4oa0@4?mXJ6So?3`loiZJVPKooooo00Koe=CDob4Q8OlB4Q;o
2PX:ob4Q8OnOWil2ooooo`06omCDe?lQ8B7o4Q8Bo`X:2_lQ8B7oWinO=_oo
ool00olN7QkoYZJVooooo`03ooooo`05ol30`?lL71co9BDUo`X:2_miNGT0
0_ooool01Oo0`<3o71`LobDU9Ol:2P[oNGUi00;ooooo00KoU9BDo`@41?l@
413oJ6QXoc`l??nJVYX6ooooo`06omCDe?lQ8B7o4Q8Bo`X:2_lQ8B7oWinO
0_ooool5o`000003omOGeooooooooooo03Cooooo00?o7QhNojJVY_ooool0
0oooool01Oo0`<3o71`LobDU9Ol:2P[oNGUi00;ooooo00Go`<30oa`L7?lU
9BGo2PX:ogUiN@02ooooo`06oiBDU?l410Co410@ofQXJ?ll?3coVYZJ1_oo
ool01_oDe=Co8B4Qoa8B4_l:2P[o8B4QoinOW`;ooooo00Go?Cdmobh^;_li
>CWo;Rh^oinOW`0eooooo`000_ooool00olN7QkoYZJVooooo`02ooooo`0E
oo?clolG5aOoTI6AoooooooRh^;o51@Doj^[Zooclo?o5aLGoi6ATOoooooo
h^;Roa@D5?n[Zj_ooOgmoaDE5OnKVi_oo_knojj^[_l?3`ooVYZJ00Sooooo
00?oRXZ:ode=COooool01Oooool00on:RX[oCDe=ooooo`0gooooo`03oahN
7_nVYZKooooo00;ooooo01Golo?coaLG5onATI7oooooon;Rh_lD51CoZj^[
oo?clolG5aOoTI6AoooooooRh^;o51@Doj^[ZoomoOgo5ADEoi^KVoono_ko
[Zj^o`l?3onJVYX02?ooool00on:RX[oCDe=ooooo`03ooooo`03oda<C?mP
H63oo?cl00;oo?cl=oooool00olN7QkoYZJVooooo`02ooooo`0Eoo?clolG
5aOoTI6AoooooooRh^;o51@Doj^[Zooclo?o5aLGoi6ATOooooooh^;Roa@D
5?n[Zj_ooOgmoaDE5OnKVi_oo_knojj^[_l?3`ooVYZJ00Sooooo00?oRXZ:
ode=COooool00oooool01_oemOGooooooooooonVYZKo10@4onKViSCooooo
0002ooooo`03oahN7_nVYZKooooo00;ooooo00?o`<30o`820_o^k^h00_oo
ool01OmCDe?oHF5Qol30`?l20P;ok^k^00;ooooo00GoDe=Cof5QHOo:b/[o
1@D5ooOgm`02ooooo`03ocdm?OnJVY[ooooo00Oooooo00?oRXZ:ode=COoo
ool01Oooool00on:RX[oCDe=ooooo`0gooooo`03oahN7_nVYZKooooo00;o
oooo00?o`<30o`820_o^k^h00_ooool01OmCDe?oHF5Qol30`?l20P;ok^k^
00;ooooo00GoDe=Cof5QHOo:b/[o1@D5ooOgm`02ooooo`03ocdm?OnJVY[o
oooo00Oooooo00?oRXZ:ode=COooool00oooool00ooTi>Co8b<SokFe]@0i
ooooo`03oahN7_nVYZKooooo00;ooooo00?o`<30o`820_o^k^h00_ooool0
1OmCDe?oHF5Qol30`?l20P;ok^k^00;ooooo00GoDe=Cof5QHOo:b/[o1@D5
ooOgm`02ooooo`03ocdm?OnJVY[ooooo00Oooooo00?oRXZ:ode=COooool0
1_ooool00ooZj^[o0000olg=c@0dooooo`000_ooool02?lN7QkoW9bLoo3`
l?o`l?3onOWiok>c/ol;2`_oo?cl0_ooool01OmYJFWoE5ADok>c/ol;2`_o
o?cl00;ooooo00GoJFUYoeADE?o=cLgo2PX:oo_kn`02ooooo`03ocdm?OnJ
VY[ooooo00Oooooo00?oRXZ:ode=COooool01Oooool00on:RX[oCDe=oooo
o`0gooooo`08oahN7_nLW9col?3`oo3`l?oinOWo/k>co`/;2oolo?`2oooo
o`05ofUYJOmDE5Co/k>co`/;2oolo?`00_ooool01OmYJFWoE5ADolg=cOl:
2P[ono_k00;ooooo00?o?CdmoiZJV_ooool01oooool00on:RX[oCDe=oooo
o`04ooooo`03om_KfolU9BGo/k>c03Sooooo00So7QhNoibLW?o`l?3ol?3`
ooWinOnc/k?o2`/;ooclo0;ooooo00GoJFUYoeADE?nc/k?o2`/;ooclo002
ooooo`05ofUYJOmDE5CocLg=o`X:2_okno/00_ooool00olm?CgoVYZJoooo
o`07ooooo`03ohZ:R_m=CDgooooo00Gooooo00Com?CdogAdM?lQ8B7oo_kn
=?ooool000;ooooo00So7QhNoaTI6OlW9bOo9bLWojb/[?oPh>3o0P82ol_;
b`;ooooo00Go;2`/ohB4Q?oPh>3o0P82ol_;b`02ooooo`05ob`/;?n4Q8Co
o_knoaTI6Oo;bl/00_ooool00olf=SKoVIVIooooo`07ooooo`03ohZ:R_m=
CDgooooo00Gooooo00?oRXZ:ode=COooool0=oooool02?lN7Qko6ATIobLW
9olW9bOo[:b/on3Ph?l20P;obl_;0_ooool01Ol/;2coQ8B4on3Ph?l20P;o
bl_;00;ooooo00Go;2`/ohB4Q?ono_ko6ATIol_;b`02ooooo`03ocHf=_nI
VIWooooo00Oooooo00?oRXZ:ode=COooool01Oooool00ooPh>3o7AdMokVi
^@0gooooo`08oahN7_lI6AWo9bLWobLW9on/[:coh>3Po`820_o;bl/2oooo
o`05ob`/;?n4Q8Coh>3Po`820_o;bl/00_ooool01Ol/;2coQ8B4ookno_lI
6AWobl_;00;ooooo00?o=SHfoiVIVOooool01oooool00on:RX[oCDe=oooo
o`04ooooo`04oc<c<ol410CoFUYJong]kCGooooo0002ooooo`03oahN7_nV
YZKooooo00?ooooo01CoMgMgoahN7_n2PX;oADE5obPX:?oalO7oooooogMg
MolN7QkoPX:2odE5AOlX:2SolO7aoooooomkNg_o71`Loh:2P_lf=SKo410@
oiZJVPSooooo00?oRXZ:ode=COooool01Oooool00on:RX[oCDe=ooooo`0g
ooooo`03oahN7_nVYZKooooo00?ooooo01CoMgMgoahN7_n2PX;oADE5obPX
:?oalO7oooooogMgMolN7QkoPX:2odE5AOlX:2SolO7aoooooomkNg_o71`L
oh:2P_lf=SKo410@oiZJVPSooooo00?oRXZ:ode=COooool01_ooool00on]
[Jgo51@Doogmo@0fooooo`03oahN7_nVYZKooooo00?ooooo01CoMgMgoahN
7_n2PX;oADE5obPX:?oalO7oooooogMgMolN7QkoPX:2odE5AOlX:2SolO7a
oooooomkNg_o71`Loh:2P_lf=SKo410@oiZJVPSooooo00?oRXZ:ode=COoo
ool01?ooool01?ofm_Ko_knood51@OnUYJDeooooo`000_ooool00olN7Qko
YZJVooooo`04ooooo`04ol71`On<S8coY:BTooGem@?ooooo00Co`L71ohb<
S?nTY:ComOGe0oooool01Ond];CoSHf=om3@d?lm?CgoVYZJ00Sooooo00?o
RXZ:ode=COooool01Oooool00on:RX[oCDe=ooooo`0gooooo`03oahN7_nV
YZKooooo00Cooooo00Co`L71ohb<S?nTY:ComOGe0oooool01?o1`L7oS8b<
ojBTY?oemOD3ooooo`05okBd]?n=SHgod=3@ocdm?OnJVYX02?ooool00on:
RX[oCDe=ooooo`06ooooo`03on?Shol0003ohn?S03Kooooo00?o7QhNojJV
Y_ooool01?ooool01?o1`L7oS8b<ojBTY?oemOD3ooooo`04ol71`On<S8co
Y:BTooGem@?ooooo00Go];Bdohf=SOo@d=3o?CdmoiZJVP08ooooo`03ohZ:
R_m=CDgooooo00Kooooo00?o/[:bobHV9_ooool0=?ooool000;ooooo00Go
7QhNogemOOo0`<3o`<30ol;2`P0Cooooo`03ocdm?OnJVY[ooooo00Gooooo
00CogMgMog=cLomHF5SoCDe=1?ooool01?oMgMgoLg=coeQHF?m=CDdhoooo
o`05oahN7_mmOGgo`<30ol30`?o2`/804oooool00olm?CgoVYZJooooo`05
ooooo`04omgMgOmcLg?oF5QHode=C@Cooooo00GoTI6Aokno_oo/k>coLW9b
ocXj>P0gooooo`05oahN7_mmOGgo`<30ol30`?o2`/804oooool00olm?Cgo
VYZJooooo`05ooooo`04omgMgOmcLg?oF5QHode=C@Cooooo00Go_knoomCD
e?o^k^koJf][oda<C00eooooo`000_ooool01OmXJ6SoDe=Coe=CDomCDe?o
FUYJ01?ooooo00?o?CdmoiZJV_ooool01Oooool01?ofm_KoZ:RXofUYJOm`
L704ooooo`04ooKfm_nXZ:SoJFUYog1`L3Sooooo00GoJ6QXoe=CDomCDe?o
De=CoeYJFP0Cooooo`03ocdm?OnJVY[ooooo00Gooooo00Com_KfojRXZ?mY
JFWoL71`1?ooool01OnWYjOoFEUIobl_;ombLW;of=SH03Oooooo00GoJ6QX
oe=CDomCDe?oDe=CoeYJFP0Cooooo`03ocdm?OnJVY[ooooo00Gooooo00Co
m_KfojRXZ?mYJFWoL71`1?ooool01OnIVIWo@D51obh^;_m[Jf_of=SH03Go
oooo000Jooooo`03olk>c_oVi^Kooooo067ooooo00?oc/k>onKVi_ooool0
HOooool00oo>c/koi^KVooooo`17ooooo`00ooooool]ooooo`00ooooool]
ooooo`0000?oPX:2oiVIVOnIVIT0GonIVIT00oo`l?3oPX:2oiVIV@1QoiVI
V@03oo3`l?n2PX;oVIVI067oVIVI0Oo`l?01oh:2PP0000?ofMWIoooooooo
ool0Goooool00oo`l?3ofMWIooooo`1Qooooo`03oo3`l?oIfMWooooo067o
oooo0Oo`l?01omWIf@0000?ofMWIooooooooool0Goooool00oo`l?3ofMWI
ooooo`16ooooo`04om[Jf_n/[:coUYJFokfm_AOooooo00?ol?3`omWIfOoo
ool0HOooool1oo3`l07ofMWI00000ooIfMWoooooooooo`1Oooooo`03oo3`
l?oIfMWooooo04Kooooo00GoI6ATofEUIOmlO7co9bLWoeADE00Fooooo`03
oo3`l?oIfMWooooo067ooooo0Oo`l?01omWIf@0000?of=SHookno_ono_h0
6Oono_h00ooVi^KonOWiooknoP02ooknoP04ono_kookno_on?Shonc/k0Ko
o_kn00?oi^KVooWinOono_h02_ono_h01?o/k>coo_knookno_o[jn/:ookn
oP03ooGemOo`l?3oo_kn00Goo_kn00Cok>c/ookno_ono_kojn_[4?ono_h0
0oo`l?3of=SHooknoP0RooknoP03onKVi_oinOWoo_kn00;oo_kn00Cokno_
oo_knoohn?Sok>c/1_ono_h00ooVi^KonOWiooknoP0=ooknoP03onKVi_oi
nOWoo_kn00Goo_kn00?ojNWYo`820_o@d=005Oono_h00oo`l?3of=SHookn
oP0RooknoP03onKVi_oinOWoo_kn00;oo_kn00Cokno_oo_knoohn?Sok>c/
1_ono_h00ooVi^KonOWiooknoP0BooknoP03ooGemOo`l?3oo_kn01Soo_kn
0Oo`l?01omSHf00000?oe]KFoogmoOomoOd03oomoOd03OlM7AgoYjNWoogm
oOomoOgoVi^Ko`X:2_oGemOooOgmokjn__lK6a_o92@To`T92OmhN7P00_om
oOd01_lV9RKoFe]Koa/K6olB4Q;oBd];oo?cl`;ooOgm00Go_[jnoa/K6olT
92Co2@T9ogQhN002oogmo@03oadM7OnWYjOooOgm00?ooOgm00[omoOgocLg
=olE5AGo<c<cogEeMOlF5QKoc<c<oogmoOlV9RKo[jn_0_omoOd04Olc<c?o
XZ:RoogmoOnBTY;o0`<3o`l?3omWIfOo>c/koiRHV?omoOgomoOgocLg=olE
5AGo<c<cogEeMOlF5QKoc<c<00oooOgm00?ol?3`omKFe_omoOd06?omoOd0
3OlM7AgoYjNWoogmoOomoOgoVi^Ko`X:2_oGemOooOgmokjn__lK6a_o92@T
o`T92OmhN7P00_omoOd01_lV9RKoFe]Koa/K6olB4Q;oBd];oo?cl`;ooOgm
00Go_[jnoa/K6olT92Co2@T9ogQhN002oogmo@06oadM7Ol<30co4a<CoaHF
5_lm?Cgo/k>c0oomoOd01Onn_[ko6a/Kob@T9?l92@WoN7Qh00;ooOgm00Ko
c<c<odI6A_ln?SkoYjNWoc8b<_n^[ZhEoogmo@03oo3`l?oFe]KooOgm01So
oOgm00go7AdMojNWYoomoOgooOgmoi^KVol:2P[oemOGoogmoOnn_[ko6a/K
ob@T9?l92@WoN7Qh00;ooOgm00Ko9RHVoe]KFolK6a_o4Q8Bod];Booclo<2
oogmo@05okjn__lK6a_o92@To`T92OmhN7P00_omoOd01OlM7Ago2`/;o`X:
2_lJ6Q[oOWin00;ooOgm00Go9RHVojn_[oomoOgo9RHVojn_[`03oogmo@06
oi:BT_l30`?o3`l?ofMWIolk>c_oV9RH5_omoOd1oo3`l07oe]KF00000oo@
d=3omoOgooOgm`0?ooOgm`0PoadM7OnSXj?omoOgom[Jf_l=3@goUIFEooOg
moo[jn_o5QHFohb<S?ogmoOof][Joa<C4onUYJGomoOgobDU9Om^KVkokNg]
onSXj?lb<S;oWinOooOgmoo[jn_o5QHFohb<S?ogmoOof][Joa<C4onUYJGo
moOgoadM7OnSXj<4ooOgm`06ojb/[?lJ6Q[olo?comSHf?lX:2SoQ8B40_og
moL05?lU9BGoZj^[ooOgmoogmoOo<S8boijNW_oemOGo51@DoiJFU_ofm_Ko
Z:RXo`h>3_nEUIGomoOgojb/[?lJ6Q[olo?comSHf?lX:2SoQ8B44?ogmoL0
0oo`l?3od=3@ooOgm`0HooOgm`0doadM7OnSXj?omoOgom[Jf_l=3@goUIFE
ooOgmoo[jn_o5QHFohb<S?ogmoOof][Joa<C4onUYJGomoOgobDU9Om^KVko
kNg]onSXj?lb<S;oWinOooOgmoo[jn_o5QHFohb<S?ogmoOof][Joa<C4onU
YJGomoOgoadM7OnPX:3omoOgoo7alOnb/[;o5aLGoi>CToogmoOojn_[oaHF
5_n<S8comoOgom[Jf_lC4a?oYJFUooOgmolX:2SoGemOok^k^omWIfOo4a<C
oiVIVAGomoOg00?ol?3`om3@d?ogmoL06?ogmoL0:_lM7AgoXj>SooOgmooJ
f][o3@d=oiFEUOogmoOojn_[oaHF5_n<S8comoOgom[Jf_lC4a?oYJFUooOg
molU9BGoKVi^ong]kOoXj>So<S8boinOWoogmoOojn_[oaHF5_n<S8comoOg
om[Jf_lC4a?oYJFUooOgmolM7AgoXj>SooOgmonATI7o0000olc<c?ogmoOo
9BDUoj^[ZoogmoOo9BDUoj^[Z`;omoOg00OomOGeoa@D5?nFUYKom_KfojRX
Z?l>3PkoUIFE01KomoOg0Oo`l?01om3@d00000?ob/[:oo;bl_obl_803oob
l_801OlL71coX:2Poo;bl_m2@T;oC4a<00;ol_;b00?o][Jfo`410OoQhN40
0_obl_801Om>CTkoG5aLoo;bl_lU9BGoYjNW00;ol_;b00KoN7QhoeEEEOob
l_;o][Jfo`410OoQhN42oo;blP05odi>C_mLG5col_;boa`L7?nPX:001?ob
l_801_o?cloo30`<ojNWYoo/k>co@410ohb<S0;ol_;b00Wo9BDUojNWYoob
l_;ol_;boc4a<OnKVi_o_knoo`@41?oZj^X00_obl_802Oli>CWoTY:Boo;b
l_o?cloo30`<ojNWYoo/k>co@410ohb<S00@oo;blP03oo3`l?o:b/[ol_;b
01Sol_;b00Go71`Loj2PX?obl_;o@T92oda<C002oo;blP03okJf]_l10@7o
hN7Q00;ol_;b00GoCTi>oeaLG?obl_;o9BDUojNWY`02oo;blP06ogQhN?mE
EEGol_;bokJf]_l10@7ohN7Q0_obl_801Om>CTkoG5aLoo;bl_lL71coWIfM
00?ol_;b00KoO7alo`l?3ooUiNGo][Jfo`410OoQhN42oo;blP05odi>C_mL
G5codM7Ao`410OoRh^800_obl_800olc<c?oTY:Boo;blP0Doo;blP03oo3`
l?o:b/[ol_;b01Sol_;b00Go71`Loj2PX?obl_;o@T92oda<C002oo;blP03
okJf]_l10@7ohN7Q00;ol_;b00GoCTi>oeaLG?obl_;o9BDUojNWY`02oo;b
lP06ogQhN?mEEEGol_;bokJf]_l10@7ohN7Q0_obl_803om>CTkoG5aLoo;b
l_lL71coX:2Poo;bl_oOgmoo0`<3ok2`/?obl_;o9BDUojNWYoobl_;o9BDU
ojNWY`02oo;blP03okno_ol410Coj^[Z00;ol_;b00?o>CTioi:BT_obl_80
5Oobl_81oo3`l07ob/[:00000oo3`l?ojNWYonWYj@0?onWYj@05oa/K6omW
IfOoKVi^oaLG5ooHf=P00_oYjNT00onSXj?o2PX:onKViP02onWYj@05oemO
Gom<C4cojNWYob<S8onQXJ400_oYjNT01_n<S8co:2PXonWYjOnSXj?o2PX:
onKViP;ojNWY00OoGemOoda<C?oYjNWo6a/KodE5AOnCTi?oe]KF00?ojNWY
00GoaLG5ohF5QOmHF5So51@DohN7Q`02onWYj@09ob<S8onQXJ7ojNWYonWY
jOl_;booUIFEok^k^ol92@WoiNGU00;ojNWY00Wo=cLgohb<S?oYjNWojNWY
olG5aOn5QHGoF5QHoa@D5?n7QhL04?oYjNT00oo`l?3o`l?3onWYj@0HonWY
j@05oa/K6omWIfOoKVi^oaLG5ooHf=P00_oYjNT00onSXj?o2PX:onKViP02
onWYj@05oemOGom<C4cojNWYob<S8onQXJ400_oYjNT01_n<S8co:2PXonWY
jOnSXj?o2PX:onKViP;ojNWY00GoGemOoda<C?oYjNWo6a/KoiNGU`03onWY
j@06ok^k^ol0003o];Bdoj>SXol:2P[oi^KV0_oYjNT01OmOGeooC4a<ok2`
/?l:2P[oinOW00;ojNWY00?o=cLgohb<S?oYjNT05?oYjNT00oo`l?3o`l?3
onWYj@0HonWYj@05oa/K6omWIfOoKVi^oaLG5ooHf=P00_oYjNT00onSXj?o
2PX:onKViP02onWYj@05oemOGom<C4cojNWYob<S8onQXJ400_oYjNT01_n<
S8co:2PXonWYjOnSXj?o2PX:onKViP;ojNWY00ooGemOoda<C?oYjNWo6a/K
oiZJV_o4a<CoDE5Aoc0`<?oVi^KojNWYob<S8onQXJ7ojNWYob<S8onQXJ40
0_oYjNT00onk^k_o2@T9onGUi@02onWYj@03ocLg=on<S8cojNWY01GojNWY
0Oo`l?01ol?3``0000?o_Kfmon3Ph?oPh>003ooPh>001OlJ6Q[o>SXjobl_
;olG5aOoZJVY00;oh>3P00?oa<C4o`410Onb/[800_oPh>001OlV9RKoLg=c
on3Ph?lR8R;oLW9b00;oh>3P00KoF5QHoeeMGOoPh>3oa<C4o`410Onb/[82
on3Ph008obHV9_mcLg?oh>3PoaXJ6_mKFe_oGUiNoaXJ6_mCDe<5on3Ph00=
oc8b<_n:RX[oh>3Pon3Ph?lR8R;oC4a<omkNg_oPh>3o7QhNoiNGUooOgmoo
5ADEok:b/P02on3Ph003obl_;on6QXKoh>3P00Coh>3P00?o<S8bohZ:R_oP
h>003ooPh>000oo`l?3o_Kfmon3Ph00Hon3Ph005oaXJ6_lj>S[o;bl_oaLG
5onYZJT00_oPh>000oo4a<Co0@41ok:b/P02on3Ph005obHV9_mcLg?oh>3P
ob8R8_mbLW800_oPh>001_mHF5SoGEeMon3Ph?o4a<Co0@41ok:b/P;oh>3P
00Go9RHVog=cLooPh>3o6QXJoi6AT@03on3Ph006om_Kfol20P;oTi>ColC4
a?l10@7o/[:b0_oPh>001OlV9RKoLg=comgMgOlA4A7o/[:b00;oh>3P00?o
<30`ohJ6Q_oPh>005?oPh>000oo`l?3o_Kfmon3Ph00Hon3Ph005oaXJ6_lj
>S[o;bl_oaLG5onYZJT00_oPh>000oo4a<Co0@41ok:b/P02on3Ph005obHV
9_mcLg?oh>3Pob8R8_mbLW800_oPh>001_mHF5SoGEeMon3Ph?o4a<Co0@41
ok:b/P;oh>3P00So9RHVog=cLooPh>3o6QXJoa/K6ol0003oB4Q8omkNgP;o
h>3P00Go8R8Roi^KVooPh>3o8R8RoeeMG@02on3Ph003omoOgolE5AGo/[:b
00;oh>3P00?o;bl_ohJ6Q_oPh>005OoPh>01oo3`l07o_Kfm00000on_[joo
fMWIomWIf@0?omWIf@06oaTI6On?ShoofMWIoi2@T?l820Sod=3@0_oIfMT0
3OmUIFGo6ATIofi^K_lj>S[o8R8Rolg=cOoIfMWo8B4Qod92@_ln?SkoATI6
o`@41?nSXj<00_oIfMT04omUIFGo6ATIofi^K_lj>S[o8R8Rolg=cOoIfMWo
6ATIohn?SooIfMWoZj^[o`000?nTY:CofMWIodA4A?mSHf?oKVi^o`D51Oo3
`l<00_oIfMT03OlQ8B7oBTY:oc4a<OmCDe?o1PH6olc<c?oIfMWoJ6QXoaLG
5om^KVko;Bd]o`d=3On3Ph<00_oIfMT01Om4A4CoHf=Sofi^K_l51@Go`l?3
013ofMWI00?ol?3`ojn_[ooIfMT06?oIfMT01_lI6AWoShn?omWIfOn@T93o
20P8om3@d0;ofMWI00goIFEUoaTI6Om^KVko>SXjob8R8_o=cLgofMWIob4Q
8Om2@T;o?ShnodI6A_l410CoXj>S00;ofMWI00WoIFEUoaTI6Om^KVko>SXj
ob8R8_o=cLgofMWIoaTI6On=SHd00ooIfMT04OnPX:3o0000ojFUYOoIfMWo
IFEUoaTI6Om^KVko>SXjob8R8_o=cLgofMWIofIVI_lG5aOoKVi^obl_;ol=
3@goPh>301GofMWI00?ol?3`ojn_[ooIfMT06?oIfMT01_lI6AWoShn?omWI
fOn@T93o20P8om3@d0;ofMWI00goIFEUoaTI6Om^KVko>SXjob8R8_o=cLgo
fMWIob4Q8Om2@T;o?ShnodI6A_l410CoXj>S00;ofMWI00coIFEUoaTI6Om^
KVko>SXjob8R8_o=cLgofMWIoaTI6On?ShooalO7od=3@omRHV82omWIf@0>
ob4Q8OnFUYKofMWIob4Q8Oln?Sko?3`lohV9ROoIfMWoJ6QXoaLG5om^KVko
;Bd]o`d=3On3Ph<FomWIf@7ol?3`0On_[jl00003ojZZZ_oDe=Coe=CD00oo
e=CD00Ko61PHohb<S?oDe=CoaLG5o`000?nRXZ83omCDe004oj2PX?mdM7Co
R8R8ol_;b`;oe=CD00Go820Poi>CTonRXZ;oMGEeojNWY`04omCDe004oj2P
X?mdM7CoR8R8ol_;b`;oe=CD00_o61PHohb<S?oDe=CocLg=o`L71on=SHgo
e=CDokjn__n?ShooNWYjokBd]003omCDe005oi>CTonl_;co[:b/ogYjN_nh
^;P00ooDe=@01OnEUIGoMGEeojb/[?lb<S;oP82000;oe=CD00Co_[jnohn?
SomjNW[o];Bd4OoDe=@00oo`l?3oZZZZomCDe00HomCDe006oaPH6?n<S8co
e=CDolG5aOl0003oXZ:R0ooDe=@01?nPX:3oM7AdohR8R?o;bl/2omCDe005
ob0P8?nCTi?oXZ:RogEeMOnWYjL01?oDe=@01?nPX:3oM7AdohR8R?o;bl/2
omCDe003oaPH6?n:RX[oe=CD00;oe=CD00?oEeMGoa<C4oo:b/X00_oDe=@0
1?nPX:3oM7AdohR8R?o;bl/3omCDe005oiJFU_meMGGo[:b/oiVIVOne]KD0
5OoDe=@00oo`l?3oZZZZomCDe00HomCDe006oaPH6?n<S8coe=CDolG5aOl0
003oXZ:R0ooDe=@01?nPX:3oM7AdohR8R?o;bl/2omCDe005ob0P8?nCTi?o
XZ:RogEeMOnWYjL01?oDe=@01?nPX:3oM7AdohR8R?o;bl/2omCDe00>oaPH
6?n<S8coe=CDohn?Sol<30codm?ComCDe?nCTi?o_;blomCDe?nCTi?o_;bl
oifMWOn@T902omCDe005oiFEUOmeMGGo[:b/oc8b<_n0P8005_oDe=@1oo3`
l07oZZZZ00000on`/;3of=SHomSHf00?omSHf006oaTI6Om[Jf_oShn?odA4
A?lF5QKoe=CD2OoHf=P00olQ8B7oUIFEomSHf00<omSHf006oaTI6Om[Jf_o
T92@ode=COl;2`_oclo?4ooHf=P00olc<c?oPX:2omSHf00FomSHf003oo3`
l?n`/;3of=SH01Sof=SH00Ko6ATIof][Jon?ShooA4A4oaHF5_oDe=@9omSH
f003ob4Q8OnEUIGof=SH00cof=SH00Oo6ATIofUYJOnNWYkoRHV9odm?Col;
2`_oUIFE02Cof=SH00?ol?3`ok2`/?oHf=P06?oHf=P01_lI6AWoJf][ohn?
Som4A4Co5QHFomCDe0Wof=SH00?o8B4QoiFEUOoHf=P03?oHf=P01OlI6AWo
JVYZoh>3PolX:2So@D5100;of=SH00?oOgmookNg]ooHf=P02OoHf=P00olc
<c?oPX:2omSHf00EomSHf07ol?3`0On`/;000003ok>c/ooLg=cog=cL00oo
g=cL00GoFEUIodM7Aom:BT[oMgMgokbl_00:omcLg003ob4Q8OnHV9Sog=cL
00cog=cL00GoFEUIodM7Aom;Bd_oGUiNojVYZ@0DomcLg003oc@d=?n4Q8Co
g=cL01Kog=cL00?ol?3`ok>c/ooLg=`06?oLg=`01OmIFEWoAdM7odY:B_mg
MgOo_;bl00[og=cL00?o8B4QoiRHV?oLg=`03?oLg=`01_mIFEWoAdM7odM7
AomGEeOoMGEeokfm_BGog=cL00?ol?3`ok>c/ooLg=`06?oLg=`01OmIFEWo
AdM7odY:B_mgMgOo_;bl00[og=cL00?o8B4QoiRHV?oLg=`03?oLg=`01OmI
FEWoAdM7oe9BD_n5QHGob<S800;og=cL00?oGUiNojj^[_oLg=`02OoLg=`0
0old=3CoQ8B4omcLg00EomcLg07ol?3`0Onc/k<00003okBd]?oLg=cog=cL
01kog=cL00?o[Jf]ol_;booLg=`09OoLg=`00ona/K7oa/K6omcLg00FomcL
g003oo3`l?nd];Cog=cL02Oog=cL00?o[Jf]ol_;booLg=`0=ooLg=`00oo`
l?3o];BdomcLg00WomcLg003ojf][Oo;bl_og=cL01oog=cL00?o/K6aolK6
a_oLg=`05OoLg=`1oo3`l07o];Bd00000ona/K7ofMWIomWIf@1OomWIf@03
oo3`l?na/K7ofMWI067ofMWI00?ol?3`ok6a/OoIfMT0HOoIfMT1oo3`l07o
/K6a00000onWYjOod=3@om3@d01Oom3@d003oo3`l?nWYjOod=3@067od=3@
00?ol?3`ojNWYoo@d=00HOo@d=01oo3`l07oYjNW00000onGUiOo_[jnokjn
_P1Ookjn_P03oo3`l?nGUiOo_[jn067o_[jn00?ol?3`oiNGUonn_[h0HOnn
_[h1oo3`l07oUiNG001RoiFEU@03oo3`l?nEUIGoUIFE067oUIFE00?ol?3`
oiFEUOnEUID0HOnEUID1oo3`l07oUIFE003oogmoObgoOgmo00001?o[jn_o
i^KVon;Rh_oNg]h4omgMg@?og]kN08;ogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
gMgM0_oLg=`0TOoKfm_ogMgMomcLg?oMgMgogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMd00ooNg]h00ooMgMgog]kNomkNgP03omgMg@7ohN7Q0OoWinL1on[Z
jP0000?ok>c/onKVi_oPh>001ooIfMT01?oHf=Soe]KFom?Cdoo@d=03olg=
c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=
cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?Com3@d0?o
cLg=00Cod=3@om?CdooGemOof=SH??oIfMT2omSHf003omWIfOoHf=Sof=SH
00?ofMWI0_oHf=P5omWIf@03omSHf?oFe]Kodm?C00;odm?C00?oe]KFomSH
f?oHf=P03_oIfMT01?oHf=SofMWIomWIfOoHf=P@omWIf@;of=SHJ?oIfMT0
0ooHf=SofMWIomWIf@06omWIf@7og]kN0OoVi^H1onc/k00000Ook^k^onWY
jOoTi>Coh>3Pon7QhOoPh>3oh^;R00;ohN7Q00gog]kNomcLg?oCdm?oalO7
ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00go
gmoOom_KfooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooK
fm_ogmoO00WohN7Q00gogmoOom_KfooCdm?oalO7ok^k^onb/[;o[Zj^ok:b
/_nk^k_oalO7om?CdooKfm_ogmoO02gohN7Q2_oPh>000ooOgmooh>3Pon3P
h006omoOg`;oh>3P0ooOgml5on3Ph007omoOgooKfm_oemOGomCDe?oEeMGo
fMWIomgMg@02on3Ph003omoOgooPh>3oh>3P00;ohN7Q1ooPh>06omoOg`03
on3Ph?oOgmooh>3P00_oh>3P00CogmoOomkNg_oNg]kogmoO0_oPh>1Won7Q
h@03on;Rh_oQhN7oh^;R00CohN7Q0OoTi>@1onWYj@7okNg]00000oo`l?3o
kno_oo7al@03oo3`l01Zono_koo`l?3ok^k^onWYjOoKfm_o`L71ojBTY?n<
S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7aono_
kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2`_nTY:CoS8b;
og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<S?mk
Ng_oMgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]kOoalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo3`l0;ok>c/00Oojn_[
onk^k?o/k>cokNg]onc/k?o^k^koj^[Z00;ojn_[00[ok^k/onWYjOoXj>So
i^KVonWYjOoVi^Koj^[Zon_[joo]kN_oj>SX0_oYjNT01oo]kNgoj^[Zonc/
k?o/k>cokno]on[Zj_oXj>P00_oShn<03OoOgmoohn?SonSXj?o]kN_oj^[Z
on_[joo/k>col?3`ono_koo`l?3okNg]onc/j_oZj^X00_o^k^h01_o_knoo
j^[ZonWYjOoVi^Koj>SVonOWi`;ojNWY00Kok>c/onWYjOo/k>cokNg]onk^
k?oZj^X2onc/k008onk^k_oZj^[ok>c/onc/k?o_kngojn_[onWYjOoVi^H2
onSXj0;okNg]06gol?3^ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo`l?3okno_oo3`l?o_knool?3`ono_koo`l?3okno_00Co
l?3`00000oobl_;ok^k^onOWi`04onGUi@0@onCTi?oOgmoodM7Aok6a/On:
RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:ROna/K7odM7AomkN
gP;oi>CT00?oiNGUonCTi?oUiN@00_oTi>@03ooNg]kodM7Aok6a/On:RX[o
IVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7@omkNgP02
onCTi012onGUiOoTi>CoiNGUonCTi?oTi>?og]kNom7AdOna/K7oRXZ:ofIV
I_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6aom7AdOoNg]koi>CS
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oShn?og]kN
0_oKfm/02_oNg]gog=cLom_KfooLg=cogmoOom_KfooIfMWog=cLomgMg?oG
emL3omGEe@04omCDe?oIfMWogMgMomgMg0;oemOG01;ofm_KomgMgOoJf][o
f][JomkNg_oQhN3ofm_KomSHf?m6ATKo<30`ogQhN?o2`/;of][JomkNgOoJ
f][ofMWIomgMgOoShn<2onCTi00FomoOgooLg=_ofMWIomoOgooRh^;ohN7Q
om_KfooFe]Koe=CDomKFeOoDe=Coe]KFom_KfooLg=cof=SHomcLg?oOgmoo
gmoNomWIfOoKfm_og]kNomoOg`;of][J06oogMgMon3PgooKfm_oemOGomGE
eOoGemOofMWIomoOgooRh^;oi>CSonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>@01?oUiND01_oTi>CoiNGUonGUiOoUiNGo
j>SXong]k@7ol_;b00000oodm?CokNg]onOWi`02on3Ph00Con7QhOoOgmoo
g]kNom;Bd_nd];CoQhN7oeaLG?m]>cGoWTi2ole_GooYPfoocFmOoii>@om]
>cKoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomkNg_oBd];o];BdohN7
QomLG5coKF0/oijF;_o=cCoojNU=olg=?onNVRooKF<]oeaLG?n7QhOo];Bd
om;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLodMW;_mXWS?o
TLe7oj[YEOnAcDOoJYhdodUZ;omLG5coQhN7okBd]?oBd];og]kN02_oh>3P
04?og]kNomSHf?oBd];oe=CDomKFe_oBd];oclo?om;Bd_oFe]Kodm?Com7A
dOoEeMGoe]KFom3@d?o4a<Cobl_;olo?coo9bLWoa<C4omSHf?oEeMGod=3@
olC4a?o@d=3of=SHom;Bd_oAdM7of=SHom_KfooFe]KodM7AoiFEUOnPX:3o
?Shnod];BooDe=Cof=SHom;Bd_oAdM7of=SHomkNg_oPh>3ogmoOom[Jf_oC
dm?odM7AomSHf?oMgMgof][Jom?Cdoo?cloo`<30om3@d?o=cLgo_knoomCD
e?oFe]KodM7AomCDe?oIfMWof=SHom7AdOoBd];of=SHomWIfOoCdm?odM7A
00;oemOG00SodM7Aolo?coo8b<Soa<C4omSHf?oKfm_og]kNomoOgfCoh>3P
00?ogmoOon3Ph?oOgml00_oOgml3on3Ph003on7QhOoWinOok>c/007om?Cd
00000oofm_Kol_;bon_[j`03onSXj00ConOWiooRh^;ocLg=oinOWom[Geoo
ScH^oneaHOoiWI3ooK6Uoofl[oom]:OonInConedHonB=booJemOoinOWoo=
cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWom^IUooTg8RongA
A?oilgCooOf=oogmUOomoHkonOQfongGAonCLb;oKVMOoinOWoo=cLgoh^;R
onOWi`03onSXj00ConOWiooRh^;ocLg=oinOWomPJ5ooBg`Soi;QBonmnG_o
d?fBomSmVooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=cLgoh^;RonOWi`0Z
onSXj00YonKVi_oOgmoo<30`ohn?SooKfm_oalO7ohR8R?o5aLGofm_KojFU
YOl10@7ogMgMomkNg_m]KFgo20P8oa4A4OmcLg?o<30`ob@T9?oMgMgofm_K
od];Bol<30coHV9Ron7QhOm]KFgo>SXjomoOgooShn?o`l?3o`000?o1`L7o
hN7Qoj2PX?l=3@goemOGomkNg_mmOGgo5aLGomgMgOoTi>@00_oVi^H05?oR
h^;oOgmoobPX:?oOgmooiNGUon?Shonf][Ko7alOo`T92Olf=SKoM7Ado`P8
2?nFUYKogMgMo`l?3onGUiOohN7QomoOgom2@T;oI6AT0_oPh>003?meMGGo
<S8bomgMgOoKfm_o_[jnoc`l??l20P;o7alOoaDE5Ond];Coi^KVonOWifgo
j>SX0Oo/k>`1oo;blP7om_Kf00000oogmoOon?ShooShn003ooShn00CooOg
moo^k^koc/k>oi2@T?n5;b_ojFAFoo^BQoonYY_oo[6UoonhZoon/jKooZRL
oo^DROo^J5WoRC4[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^ko
c/k>oi2@T?nIJB_ol;dmoo_PK_onm8;oo_j:ooooT_onoXcoo_R3oo_UL?o`
`SkoVFX[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@
T?m2Lb_oQ<i3ojg_Loo2oXSoc_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[
oi2@T?o>c/kok^k^ooOgm`0ZooShn00_ooKfm_o_knoo<c<coiVIVOoWinOo
Ph>3o`000?mlO7coj>SXok2`/?l10@7okNg]on?Shol61PKoXZ:RomgMgOmg
MgOo0000olk>c_o`l?3o`/;2o`000?oAdM7om?Cdoo7alOmeMGGo?Shnonk^
k_obl_;od=3@o`000?o?cloolO7aolS8b?l0003o`l?3onk^k_n6QXKo6ATI
onWYjOo_knool_;booCdm?oalO7oR8R8ob/[:oo^k^h00_oemOD07?mTI6Co
?cloonGUiOnc/k?o7alOofMWIoo_knookNg]oa0@4?nRXZ;ol?3`ono_kom7
AdOoJf][ono_koo`l?3oOWinocDe=Oo[jn_oj>SXocLg=om4A4Coc/k>onOW
iooMgMgoi>CTooGemOogmoMVooShn003ooOgmoohn?Son?Sh00;on?Sh00Co
moOgooWinOogmoOomoOg0Oohn?P00003oo[jn_oemOGok^k^00;ok>c/0:Wo
jn_[onWYjOoOgmoo^[ZjogUBD_no<RCoigAYoof9O_ooV8cooZ:FoonXW?on
Y9SooiZ=ooj:Ooo^MV[o`c<TogUBD_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[
k?oZj^[ogmoOokZj^_n8IE;ohY4LooW3D?omfV?oonYbookcO_oonX;oo_Io
ooo/LoongVCon/MAon:B7?n9IU?o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_o
j^[ZomoOgonj^[[oDVeBoe6S7?nAdUGoY^MZokSiN_o0oX;oaon9ol?nQ?ni
oG_oYna/oiCFEomBYQcoDVeBokZj^_oOgmooj^[Zon_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/onWYjOoShn?o<30`oi2@T?oHf=Wo;Bd]od10
@?lS8b?of][JojJVY_l10@7ohN7Qon?Si?l@413oO7alomoOgond];Co0000
om7AdOoTi>CoV9RIo`l?3ooPh>3oinOWon?Shom_Kfoo>c/komoOgooQhN;o
`l?3o`000?o5aLGoi>CTokno_ol0003o^;Rhon7Qh_moOgoo5aLGomWIfOoM
gMgohN7QonGUiOoTi>CoPH61obPX:?oOgmooi^KVonSXj?mdM7Co7alOomWI
fOoLg=go>c/kofm_KooTi>Coh>3Po`l?3onHV9SohN7QomoOh?m3@d?oIFEU
00;oh>3P06ooMgMgoc8b<_oPh>3o^;Rio`000?nXZ:Sog=cLomWIfOoKfm_o
hN7QonWYjOoZj^_ok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>`01oo[jn/01Oo/k>cojn_[on_[joo^k^kom_Kf007onOWi00000ookno_o
lo?cong]k@02onGUi@2`onKVi_oTi>CofMWIok:b/_mi;Rkob48don=ZG?od
NVgooHQloojGR_onVhkooYR;ooj:O_odNfgoif]MolY2=?mk;Rko/[:bomSH
f?oTi>CoiNGUonKVi_oUiNKoi>CTomSHf?nb/[;oUUD^onZL:ook_4Coo/aC
oogHH_onhg;oo^UeookVLoonffGooLaCoo_1AOo^WR_oVEH^ok:b/_oHf=So
i>CTonGUiOoVi^KoiNGUonCTi?oHf=Wo/[:bobiR;_mS[B_oQlY8oiOLFOnU
iFWo/_=gokSfNondmGWoYnY[oiSLFOn9cd_oHjh[obiS;_nb/[;of=SIonCT
i?oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oShn?ogMgMobl_
;on;Rh_o/K6bo`000?ng]kOo9BDUojRXZ?nPX:3o0@41omcLg?oPh>7o/[:b
ocTi>OlU9BGo>c/ko`000?o=cLgogMgMoi>CU?l@413oe]KFomkNg_oLg=co
K6a/ocTi>OoDe=Coe]KGokbl_?l0003o`/;2omoOgonk^k_o0000okBd]?oL
g=coO7aloaLG5ooFe]Kof][JomkNg_oPh>3ogmoOogemO_lW9bOoeMGEomcL
g?oNg]kofm_KofATI?lP823o?3`loa<C4om]KFgoh>3PomcLg?l?3`ooTi>C
omOGeooEeMKo@D51of9RH_oGemOoe]KFog=cLola<C7ogMgMoiZJVol00004
ocLg=`1Wok:b/_oTi>Coi>CUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUi@02onKViP03onGUiOoVi^Koi^KV00?oi^KV00?oiNGU
ong]kOodm?@00Ookno/00003ooclo?ohn?SolO7a00?ok^k^01?ojn_[on7Q
hOnl_;coNQLGol<o<_oCETWoi6QJonmgK?odPgWon8MlooF4N_ocNFgoiFUK
omUHB_o4?c;oO1LGokbl_?oQhN7ok>c/00?ok^k^01?ok>c/on7QhOnl_;co
YDLGonJG<_oe[33ooKa1oog9Doomd63onm=UoogBH?oncECooKe2ooZ_<_oY
Vc;oYDHGokbl_?oQhN7ok>c/00?ok^k^01?ok>c/on7QhOnl_;co5eTGoenX
<_mf_COoQ/e7oiKFF_nRh6GoXn1Yoj?QIonGfUcoQ/i7ogNo=omOZc;o5eTG
okbl_?oQhN7ok>c/02[ok^k^02Ook>c/onGUiOla<C7oShn?ofi^K_l/;2co
j>SXogemOOmNGUkoY:BTo`410OoShn?ojNWYonKVi_oRh^;oh>3Pojf][Ol0
003oemOGonCTi?nHV9So410@omgMgOoShn?oi>CTog1`L?lT92Coe]KFomoO
gono_koo0000ol_;booYjNWo`L71o`000?nj^[[oi>CToh61POl61PH00oln
?Sh08_o;bl_ojNWYohB4Q?lJ6Q[of][Jon;Rh_oUiNGoinOWon?ShooPh>3o
f=SHocLg=ombLW;oj^[ZonOWiol?3`ooRXZ:omoOgooNg]ko@d=3oeIFE_oP
h>3ogmoOogMgMolc<c?ojNWYokjn__l0003oX:2PokJf]_nZZZ[o0P82omWI
fOo]kNe]onk^kP03ong]kOobl_;on?Sh007oo?cl0003oogmo@0Fooclo?om
oOgooOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@@ooJHUGohfiRonAb
I?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];olo?cooclo0?ooOgm01?o
o?cloo?clooBd];oWR/7omZ:=?o[VaWomJPYooRd?ooi_D[on;m=ooZoB_oi
^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?oo?cl00?ooOgm01?oo?cloo?c
looBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:cE3oSLeBoh[>D?n1adCoLKT_
of:^8?m>VcCo1d87om;Bd_oclo?oo?cl02[ooOgm04cono_kooCdm?ld=3Co
UiNGoalO7on7QhOon_[jomgMgOlC4a?oZJVYo`410Oobl_;onOWiol30`?o4
a<Colo?cohb<S?lQ8B7on_[jooGemOnMWIgo410@onKVi_o^k^kom?CdogQh
N?lA4A7oC4a<ol[:b_n9RHWo51@DooKfm_oinOWoc/k>o`000?o6a/Kolo?c
ohV9ROlC4a?o][JfokVi^Onj^[[okNg]ooWinOn?Shoo30`<oeMGEooAdM7o
kNg]onc/k?nVYZKoi^KVonCTi?lB4Q;o[Jf]oo_knoojn_[o410@oahN7_nU
YJGog=cLoaXJ6_lP823oOGemomkNg_m7AdOoGemOoo_knoojn_[o=3@dog5a
LOo^k^koSXj>ocDe=Ookno_oo?clJoomoOd00oolo?cooOgmooclo003oogm
o@0003[ooOgmoo[jn_oclo?ok^k^oo3`l?o_knook^k^onWYjOoCdm?oFadM
oj8d=?nd:1go`CX]olM9??o?ET[od5M;om1GB_o:BSko`c/^okHX7OnR=3Co
G1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_onk^k_oZj^[odm?Coh`U7Oo8
LCCofH@MonBD5OoWWBCokZPcoo2Z=?o_ZS?ok:0UonNG5OoLR1gob74doh`U
7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`l?o^k^koj^[Yom?CdolM>1go=88d
odNE7OmJYA_oJJdZ0_md^3P0OOme^CSoJk4[oe^W7?m8VQgo=88doadh7OoC
dm?oj^[Yonk^k_o`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo^
k^koinOWoc4a<OmOGeoo0@41om;Bd_o^k^kok>c/od51@OmQHF7o0@41onKV
i_o^k^goX:2PocTi>OlA4A7o9RHVoiRHV?o_knooaLG5oa0@4?l10@7o6ATI
oe9BD_oYjNWoLG5aocdm?OnGUiOo7alOoaPH6?nATI7ok^k^ong]kOo3`l?o
0000okbl_?oXj>OoPX:2oaPH6?oOgmooh^;Ron?ShooWinOojn_[oi>CT_lo
?cooTY:BoaLG5onDU9Coh>3Podm?ColO7aoo4A4Aodm?CooXj>Sok^k^ono_
kolW9bOoX:2Podi>C_l92@Wo=SHfon3Ph?m^KVko3`l?ob`/;?nn_[kok^k^
ono_k_oBd];o?3`lo`/;2olM7Ago/[:b00;okno_06Kol?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knl2oo3`l0Kokno_
0Ooclo<1ooWin@7oo_kn00000oono_komoOgoo3`l004onWYj@0AonOWiooK
fm_oHd];oh4b<_nV=CGo]S@]ol9=@Oo3E4Woa5E:ol=DBOo2CD7o]S@]ojDe
=On1<S;oHd];om_KfooWinL01OoYjNT04OoWinOofm_KohU;Bon_Bc;ocGLe
omJ;;OoPW2koh:0bon6P=?oPX3;ogiX^omJ;;Oo:MCGo[d/bohU;BooKfm_o
inOW00GojNWY017oinOWom_Kfom;Bd_o<V0bocZ9=OmCVbgoJj/_og2]>?m_
[S[oL:dhofZZ;omCVbgo>HPeoc9P<_m;Bd_ofm_KonOWi`0[onWYj@0=onSX
j?oTi>Co<30`oa8B4_ll?3coi^KVonSXj?oWinOoTi>Coa4A4Ol10@7ohn?S
onOWi`02onWYj@03onOWiooYjNWojNWY00;oj>SX01CoWIfMoa0@4?oWinOo
inOWonCTi?m_Kfoo>c/kon?ShooWinOoj>SXonWYjOoXj>SoinOWol;2`_l0
003o^[ZjonCTi?n0P83o5aLGomgMg@;og]kN00?ohN7QonKVi_oXj>P00_oY
jNT00ooXj>SoinOWonWYj@02onWYj@03onOWiooYjNWojNWY00GojNWY00Go
j>SXonWYjOoYjNWojNWYonOWi`06onWYj@03onKVi_oYjNWojNWY06WojNWY
00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07omoOg0Oono_h00005ookno_oj
n_[om?Cdono_kooalO400_o`l?004Oo_knoojn_[oiFDU?m?8b?oUEADok]c
LooCUIGofYbLomZNW?oIW9coe9FEok]cLonEE5CoCb<SoiFDU?oZj^[okno_
00Gol?3`017okno_on[Zj_nYU9CoPB<SokYZE?oDVW?oi;bEon[7W?oYaico
j/NLonFlUOoDVW?o^fYDoh4S8onZU9Coj^[Zono_k`05oo3`l00Aono_kooZ
j^[oU9BDob<Z8omDNUCoLjEcoik6UOn/cYco[LjLojc>W?nNaYGoLjEcoeAj
E?lS:R?oU9BDon[Zj_o_knl0:oo`l?001Oo_knook^k^oc8b<_l0003oTi>C
00?okno_00Goi>CTo`/;2ol10@7ok^k^ono_k`07oo3`l009on?Shono_koo
kno_ono_koo^k^koM7Adocdm?Oo]kNgokno_00?ol?3`00Ookno_ol[:b_l0
003o`l?3onk^k_n6QXKo2@T900?oGUiN00?oNGUionk^k_o_knl0Roo`l?00
1?oalO7ol?3`ooCdm?ojn_X1ooknoP0000CooOgmooooooooooooo_kn0_oo
ool2ooknoP1^oogmoOohn?SoKVi^oeXo?onaT93og/W9oo3Ti?oci^Kol>CT
omk9bOnaT93oFSloofe]KOohn?Soo?clooooooono_koooooookno_ooooko
o_knooooooolo?con?Shohe]KOn:?coobI6@onW@bOodjNCom^_VooCYi?oY
d<WobI6@ohTo?on=KFgon?Sgooclo?ooooooo_knooooooono_koooooookn
o_ooookoo?clooShn?m]KFgo?clooi2MT?o9eLWoi>cTonK^i_oTk>CobMG9
oi2MT?lo?cooKFe]ooShn?olo?coooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_oooooooOgmojn_[onHV9SolO7`oogmoOooool2
ooknoP0FokBd]?nJVY[ooOgmooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_oooooooOgmookno_mlO7co@D51oogmoOono_goo_kn
ooooo`;oo_kn09?ok^k^oiVIVOo[jn_oo_kmom7AdOnIVIWoV9RHoiVIVOnH
V9So[:b/oogmoOooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_h00_ooool00oono_koooooooooo`03ooooo`7ooOgm
00001?ohn?Soo_knoo[jn_odm?@5oo7al@0=ono_kooFe]KoJf][od<m?OnK
S8coa[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7al@0=ono_
kooGe]KoPf][og@m?OneS8coeKZjon7<c?oF^[[o]Xb<og8m?On1Jf_oemKF
ono_k`09oo7al@0=ono_kooFe]KoJf][ocdm?On<S8co^[Zjolc=c?nj^[[o
S8b<ocdm?Om[Jf_oe]KFono_k`16oo7al@03onk^k_o]kNgolO7a09GolO7a
00Col?3`oo7alOoalO7ol?3`1?oalO400oodm?Con_[jooknoP01ooOgm`00
00Gojn_[oogmoOohn?Sol?3`on_[j`03on[ZjP0=onWYjOoZj^[ojNWYonSX
j?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0;on[ZjP0;
onWYjOoXj>SoX9^KofYIFOm39RKo;@T9od8V9_mYFEWoX9^KonSXj?oYjNT0
2ooZj^X02ooYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooX
j>SojNWY0>Koj^[Z00Cojn_[oo3`l?ohn?SooOgm0Oo/k>`00004olK6a_on
o_kon_[jooCdm0SolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_
0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l>ColO7a00?ol?3`oo7alOoalO40
0_oalO400ooemOGon_[jooknoP01olK6aP0000?oa/K6ol?3`oojn_X0oooo
oolWooooo`7onOWi0Oo4a<@1olK6aP0000Kofm_Kokno_one]KGoinOWooOg
moolo?coooooob7ooooo00GooOgmooOgmooWinOo]KFeokno_`01om[JfP00
\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{300, 200},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[TextData[{
  "To respond to the list selection, ListSelectionListener should be \
implemented. For J/Link, ",
  StyleBox["MathSwingListSelectionListener",
    FontFamily->"\.82l\.82r \.83S\.83V\.83b\.83N",
    FontSize->10],
  " was defined by extending MathListener."
}], "Text"],

Cell[TextData[StyleBox["package JLinkProgramming.JavaSwing;\n\nimport \
com.wolfram.jlink.*;\nimport javax.swing.event.*;\n\npublic class \
MathSwingListSelectionListener extends MathListener implements \
ListSelectionListener {\n\n\tpublic MathSwingListSelectionListener() {\n\t\t\
super();\n\t}\n\n\tpublic MathSwingListSelectionListener(KernelLink ml) {\n\t\
\tsuper(ml);\n\t}\n\n\tpublic MathSwingListSelectionListener(String func) {\n\
\t\tthis();\n\t\tsetHandler(\"valueChanged\", func);\n\t}\n\n\tpublic void \
valueChanged(ListSelectionEvent e) {\n\t\tExpr result = \
callMathHandler(\"valueChanged\", new Object[]{e});\n\t\tif (result != null)\n\
\t\t\tresult.dispose();\n\t}\n\t\n}",
  FontFamily->"\.82l\.82r \.83S\.83V\.83b\.83N"]], "Text",
  FontFamily->"Courier New",
  Background->GrayLevel[0.900008]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleJTable",
        ButtonData:>{"SimpleJTable.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SimpleJTable[]\)], "Input"],

Cell[BoxData[
    \({{0, 0}}\)], "Print"],

Cell[BoxData[
    \({{2, 0}}\)], "Print"],

Cell[BoxData[
    \({{1, 2}}\)], "Print"],

Cell[BoxData[
    \({{3, 1}}\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JTextField <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000005R<2hb>3HR<2hR<2hc<c<
0?ooooooooooNOooo`:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVK<
c<coIVIVofIVIWMVIVH01?ooohS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01Ooool40000oooo
oooooomLoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH06oooo`030000oooooooo0?ooooooooooFOooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool600000_ooo`80
00000oooo`000?ooo`02oooo0P000003oooo0000oooo00;oool2000000Go
ool0003oooooool000000oooo`030000oooooooo00Goool300001Oooo`80
00001?ooo`000?ooooooo`800004oooo1P0000;oool300001?ooo`800000
0oooo`000?ooo`02oooo0P000003oooo0000oooo0?oooooooooo7_ooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool0
0`000?ooooooo`04oooo00<0003oooooool00P0000;oool00`000?oooooo
o`0200000_ooo`030000oooooooo00800002oooo00D0003oooooooooool0
00001_ooo`050000oooooooooooo000000?oool00`000?ooooooo`020000
0_ooo`030000oooooooo00?oool00`000?ooooooo`04oooo00D0003ooooo
ooooool000000_ooo`030000oooooooo00800002oooo00<0003oooooool0
0P000?oooooooooo7oooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00;oool00`000?ooooooo`04oooo00D0003ooooooooo
ool000000_ooo`050000oooooooooooo000000;oool01@000?oooooooooo
o`000002oooo00D0003oooooooooool000001Oooo`030000oooooooo00?o
ool010000?ooooooo`0000?oool010000?ooooooo`0000Goool00`000?oo
ooooo`04oooo00D0003oooooooooool000000_ooo`050000oooooooooooo
000000;oool01@000?ooooooooooo`00003ooooooooooaooool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00<0003o
ooooool01Oooo`@00002oooo00D0003oooooooooool000000_ooo`050000
oooooooooooo000000;oool01@000?ooooooooooo`000005oooo00<0003o
ooooool00oooo`040000oooooooo00000oooo`040000oooooooo00001Ooo
o`030000oooooooo00Coool01@000?ooooooooooo`000002oooo00D0003o
ooooooooool000000_ooo`050000oooooooooooo00000?oooooooooo7ooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;o
ool00`000?ooooooo`08oooo00@0003oooooool00003oooo00@0003ooooo
ool00003oooo00@0003oooooool00003oooo00<0003oooooool00oooo`03
0000oooooooo00?oool010000?ooooooo`0000?oool010000?ooooooo`00
00Goool00`000?ooooooo`04oooo00D0003oooooooooool000000_ooo`05
0000oooooooooooo000000;oool01@000?ooooooooooo`00003ooooooooo
oaooool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP02oooo00<0003oooooool01?ooo`050000oooooooooooo000000;oool0
1@000?ooooooooooo`000002oooo00<0003oooooool00P0000;oool20000
0_ooo`030000oooooooo00?oool00`000?ooooooo`03oooo00@0003ooooo
ool00003oooo00@0003oooooool00005oooo00<0003oooooool01?ooo`05
0000oooooooooooo000000;oool01@000?ooooooooooo`000002oooo00<0
003oooooool00P000?oooooooooo7oooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00;oool00`000?ooooooo`05oooo0`00
00?oool01@000?ooooooooooo`000003oooo0P000006oooo0000oooooooo
0000oooo0P0000Koool00`000?ooooooo`03oooo00@0003oooooool00003
oooo00<0003oool000000P0000Coool00`000?ooooooo`05oooo0`0000?o
ool01@000?ooooooooooo`000003oooo0P000003oooo0000oooo0?oooooo
oooo7_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00;oool00`000?ooooooo`0Ioooo00<0003oooooool02?ooo`050000
oooooooooooo000000[oool00`000?ooooooo`03oooo00<0003oooooool0
5_ooo`030000oooooooo0?oooooooooo7Oooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00;oool00`000?ooooooo`0Ioooo
00<0003oooooool02Oooo`<0000;oooo00<0003oooooool00oooo`030000
oooooooo01Koool00`000?ooooooo`3ooooooooooagoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01Lc<c?ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0
^?mVIVKoIVIVNFIVIP04c<c<R<2hR<2hB9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P1000000001HS0^<SPf8S0^8S0^<c<c03oooooooooogWoool2R<2h0DR@
R04000000006R<2hb>3HR<2hR<2hIVIVc<c<ofIVI_mVIVIgIVIV00Cooon8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP1<oooo00<0003oooooool0oooooooooolXoooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0COooo`03
0000oooooooo0?oooooooooo9oooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Coool300001_ooo`<00006oooo0`0000Co
ool500001oooo`D00003oooo00<0003oooooool00oooo`050000oooooooo
oooo000000Coool00`000?ooooooo`03oooo00<0003oooooool01?ooo`03
0000oooooooo0?oooooooooo9oooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00?oool01@000?ooooooooooo`000004oooo
00D0003oooooooooool000001?ooo`050000oooooooooooo000000?oool0
0`000?ooooooo`02oooo00<0003oooooool01?ooo`030000oooooooo00;o
ool010000?ooooooo`0000Goool01@000?ooooooooooo`00000Boooo00<0
003oooooool0oooooooooolVoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH00_ooo`030000oooooooo00?oool010000?oo
ooooo`0000Goool010000?ooooooo`0000Goool010000?ooooooo`0000Go
ool00`000?ooooooo`03oooo00<0003oooooool00oooo`040000oooooooo
00000oooo`030000oooooooo00;oool00`000?ooooooo`02oooo00<0003o
ooooool02oooo`030000oooooooo0?oooooooooo9_ooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool00`000?oooooo
o`03oooo00@0003oooooool00005oooo00@0003oooooool00005oooo00@0
003oooooool00005oooo00<0003oooooool00oooo`030000oooooooo00?o
ool00`000?ooooooo`0500001?ooo`030000oooooooo00;oool00`000?oo
ooooo`05oooo0`0000?oool00`000?ooooooo`3oooooooooobKoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00@0
003oooooooooool300000_ooo`030000oooooooo00?oool010000?oooooo
o`0000Goool010000?ooooooo`0000Goool00`000?ooooooo`03oooo00<0
003oooooool00oooo`040000oooooooo00000oooo`030000oooooooo00;o
ool00`000?ooooooo`02oooo00<0003oooooool02oooo`030000oooooooo
0?oooooooooo9_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00;oool00`000?ooooooo`06oooo00<0003oooooool00ooo
o`040000oooooooo00001Oooo`040000oooooooo00001Oooo`030000oooo
oooo00?oool00`000?ooooooo`03oooo00L0003oooooooooool0003oool0
00001?ooo`030000oooo000000?oool00`000?ooooooo`0;oooo00<0003o
ooooool0oooooooooolVoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH00_ooo`030000oooooooo00?oool010000?oooooo
o`0000Goool010000?ooooooo`0000Goool010000?ooooooo`0000Goool0
0`000?ooooooo`03oooo00<0003oooooool00oooo`070000oooooooooooo
0000oooo000000?oool01@000?ooooooooooo`000002oooo00<0003ooooo
ool00oooo`030000oooooooo00Coool00`000?ooooooo`3oooooooooobOo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP03
oooo00D0003oooooooooool000001?ooo`050000oooooooooooo000000Co
ool01@000?ooooooooooo`000003oooo00<0003oooooool00_ooo`030000
oooooooo00Coool00`000?ooooooo`02oooo00<0003oooooool00_ooo`03
0000oooo000000?oool01@000?ooooooooooo`000002oooo00<0003ooooo
ool02_ooo`030000oooooooo0?oooooooooo9oooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Coool300001_ooo`<00006
oooo0`0000Coool500001oooo`D00006oooo00D0003oooooooooool00000
1Oooo`030000oooo000000_oool00`000?ooooooo`3oooooooooobSoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01Lc<c?ooohS0^8S0^4R@R0010000000018S0
^<SPf8S0^8S0^?mVIVKoIVIVNFIVIP04c<c<R<2hR<2hB9280@00000000>8
`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2h
5P00P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J200J2
00J20P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<1
38@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L3
0QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^9
0`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@U
S@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?
10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHc
TPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0Lh
U0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G
246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI
0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:
DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil0
0`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<
Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=
IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^
Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT0
10mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/
47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_
4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:<
/@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`03
4i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@D
V[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i
5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`0
11J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa
_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1000P003VjOa<d>U<d>U00Tc@jD600200`01P0800X001002P@03P@03
P@03P@<0184200F100@01H801X801X801X8200N200<11h81288128800P48
P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q66
0`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP3
0aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<4
8H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP03
1BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46
<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB
0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE
10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH
2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:
CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;
E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX004
35bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeR
XPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU
0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0ma
Z0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@
NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]
4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08B
RK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<C
S[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe
0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@E
WKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<F
YKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd0
0aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000NKYo7ooon>N[JVVlBc
ZM:XWLRcZM800ZJKa005_;SMk^kdj^Waoooo<d>U00D0080300600P02P004
00:100>100>100>10`04P@801H401005PP06PP06PP06PP801h800`47PP48
PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn5
0`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<4
7h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=
1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086
;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7
=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9
@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:
BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<
Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`
Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?
MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd3
4H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<B
Qk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d
0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL
]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d2
5jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G
/kl26;C08000008H]<0@00000QRd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000BKYo7ooom/FZF_YLX2_;SM00[ooOncZM;ooooooonl^=fG
R[bXWLSVi^cooolc@jD400200`01P0800X001002P@03P@03P@03P@<01842
00F100@01H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z3
00<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0
108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP3
6HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@S
S00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP03
1BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<943
1S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC
0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2
242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V003
2DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?
W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;
EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ
35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S
0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH3
3VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?
LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1k
Z`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<A
PZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::
/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk80
0Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD4
59Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PE
W[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW
^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^
_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HB928B928
00a8T8P00`000<SPf4R@R00=B92800@0000H]<0H]<38h=P>B92800<0000H
]<0H]<000XS0^058T8P10000000018S0^<SPf8S0^8S0^08008002i^WlOoo
ojRMb?oook>YdV1<VXij]WQU[ZRMb?ooooomo`03oooo00<c@jD008000800
0`00P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J200J2
00J20P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<1
38@30@f40`4>Q@<23hD20Q250oooo`824HH30Q:60P8CQP040Q>70QB70QB7
0QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ9
0`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d4
98d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl0
0`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6
<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7
>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1
U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT0
10U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L
2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO
2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaO
X@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`03
3FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>
KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y
3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0
111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64
[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;
/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<C
TK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ
]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP
^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`4
5ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n
00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B928
0000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00>VjOaoooooooo
fmc/H4bJThFj/jWB_;SMH4bJVHnnYY_4b<?Ooooo<d>U1P00P0?oool200:0
00<00X7oooooool00_ooo`8018400`05POooo`05PP0300J21?ooo`030@R2
0@R3oooo00?oool30@Z300Koool12h@12h@138Coool138@20@f400Coool1
3XGoool13XD20Pn500Coool248Goool248D20Q6600?oool24HH24XH00P8B
QP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR8
00<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/3
12:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>
0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946
<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087
=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10Pn
UP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH
0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/3
2TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h0
0`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ
35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeR
XP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZ
Y@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0ma
Z0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/3
47Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^
4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK00
11:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8C
Sk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF
]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPE
W[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX3
5ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^
_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`004b>3H
R<2hR<2hR<2h1P0000B8`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@
R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0`00P00>VjOaoooo_;SMVHnnooooe]7Mfmc/loko
YY_4k^kdQGJ`ThFjoooo<d>U1000P007oooo006000600060oooo00:0oooo
00<00h401_ooo`04P@04P@05POooo`05PP801X802?ooo`07PP07PP47P_oo
o`48P_ooo`48P`<12H<01?ooo`4:P`4:Poooo`812h@00`4<Q?ooo`4<Q002
0@f400Coool13XGoool13XD20Pn500?oool248Goool00oooo`824HH30Q:6
0P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P0
0`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<4
8X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h3
1BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`
T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLe
T`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF
0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P3
2DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:
CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP03
2eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<
GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R
008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU
10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X
3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@
NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhA
PJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/004
4XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?
/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je
0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN
^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<F
Y[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm
5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000C8h=R8
`;R8`;R8`;P6000018S0^003B9280000b>3H00:8`;P00`0008S0^8S0^005
R<2h00D00028`;R8`;Q8T8P000000QRd`004b>3HR<2hR<2hR<2h0P0000B8
`;P200000XS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0<008003i^WlOoooiV?_YN:_=CCj>n//omfNnjOZe]HYJJKa9JO
dV1<V[bhgOoooc=3Y@03002000Ooool00H000H000H3oool00X3oool00`03
P@06oooo00B100B1oooo00F1oooo0P06PP08oooo00N200N20@N2oooo0@R2
oooo0@R30`49P`09oooo0@Z3oooo0@^3oooo0@^4oooo0@b4oooo00813H@0
1?ooo`4>QOooo`4>Q@823hD01?ooo`8@QOooo`8@Q@@24HH30Q:60P8CQP04
0Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<I
R@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><
00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5
:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6
<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<3
1cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88
@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9
AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL
10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]F
WP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<
GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<3
3F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>
K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mb
Z0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[
0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62
[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa
4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P02
4hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@D
V;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN
^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk
0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn
00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P0
2hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8
`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8`;P200000XS0^0800003R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00
P00:VjOaooooUhZlNVbZ/lOXZFjPb<?OThFjFdJCVHnn0WQU[P04@RN5[jG:
oooo<d>U1000P0<00H000oooo`02P002P@04oooo0P04P@03oooo00F1oooo
00<01X84oooo00<1288128<128<00`49P`09oooo0@Z3oooo0@^3oooo0@^4
oooo0@b4oooo00813H@01?ooo`4>QOooo`4>Q@823hD00oooo`8@QOooo`03
oooo0P8AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN8
0aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@O
R`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd5
9hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_
T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`Ld
TPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD3
23bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3
V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;
VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@03
2eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aK
X08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R
00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@3
3FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W
00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mg
ZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<A
P:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7
/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb
0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@3
4iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg
0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS
^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G
[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc
_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2h
R<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00hS0
^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0P00P003VjOaoooooooo00;oool02_n]/?mfNoW=e?g]k_ooojJK
a8Ef/;bhgOoooc=3Y@D00803006000?oool00X000X400`03P@03oooo00B1
oooo00801H401005P_ooo`06PP06PP801h800`47P_ooo`48PP020@R30ooo
o`812X<01oooo`4;Poooo`4;Q?ooo`4<Q?ooo`020@f400Coool13XGooooo
ool20Pn500Koool248Goool248D24HKoool20Q660`8BQP824hH0108CQ`8D
Q`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT0
10<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<
12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?
1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHb
T@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`03
1cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8
@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI
2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`0
10YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]G
WP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aN
X@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=
I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]
YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mc
Z0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`4
47f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^
00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::
/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<C
T;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI
]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh
00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/3
5ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn
0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P0
0dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB928
0000008H]<000lSPf8S0^8S0^004R<2h0P0000F8`;P014R@R00001Rd`1Rd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000ZQ[?;icMCR9Scd
]KoR9ScdKGglhnWoooomkNko[K02oooo00<c@jD0080008001000P0<00H00
0oooo`02P002P@03oooo0P04P@05oooo00F100F100F2oooo00801X83oooo
0P48PP030@R3oooo0@V300812H<20@Z300Coool12h<12hCoool20@b400Oo
ool13H@13HCoool13XGoool13XD00_ooo`030Pn50Q250Q2500Coool0108A
QP8BQP8BQP8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP3
5hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;
0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DW
SPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@
00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB
1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8
?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H
2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J
0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;
E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P
0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ80
0`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=
J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L0
10m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ
0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60
[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`
0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK82
4Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<C
U;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L2
59fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j
0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/
_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o
0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8
`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^003R<2h
100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000fKYo7mkNkR9ScnmOSgRIOdHVkcX:kdHVkooOoo[K3lhnWo
oolc@jD01`00P0<00H000oooo`02P002P@0300>10`04P@801H401005PP06
PP06PP06PP801h801@47PP48PP48P_ooo`48P`030@V30`4:P`030@^30@^4
0@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L2
58L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@3
6XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@T
S@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZ
S`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y40
10HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`Lh
T`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G
246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6
V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:
DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;
Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ42
35nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS
00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH0
10i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?
LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m
[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P03
4HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[43
4X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c
0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH2
59Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^003
5J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY
_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G
/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8
T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R000
00026;C000?8h=R8`;R8`;P00XS0^0800002R<2h0P0000>8`;P014R@R000
01Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7f
b<cR9S`00_n]/007gb@^ojBNm[c5ojf`kW^<oooo<d>U00P00803006000?o
ool00X000X400`03P@<0184200F100@01H801X801X801X8200N200D11h81
288128;oool128<00`49P`04oooo0@Z30@Z30@^30P4;Q0<138@30@f40`4>
Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`04
0aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX3
11j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=
00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I03
1Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86
=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`Lj
U0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88
@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX3
2DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M
0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl3
35ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<
H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eV
Y0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>
KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT3
3gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]
0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl4
4HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb
4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d
00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLD
VkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT3
5J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[
_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`03
5k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0T0
0002R<2h00E8T8P0000H]<0H]<38h=P00hS0^0800004R<2h0P0000:8`;P0
14R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P20020
00>KYo7icMCgRIL00_ooo`07ojf`hAHdogIkojBNhRHlohUo<d>U00P00803
006000?oool00X000X400`03P@<0184200F100@01H801X801X801X8200N2
00@11h812881288128<4oooo0`4:P`030@^30@^40@^400<138@20@f400Co
ool13XD13XD13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<K
R@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d4
9Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[
S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO
00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y
00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n
[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64
[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P04
59Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl
00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G
/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000
b>3H00:8`;P900000XS0^005B92800006;C06;C0b>3H00f8`;P014R@R000
01Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000NKYo7o
ooocX:kdHVkoooogRIOicM@00_ooo`03lj2^oooo<d>U00P0080300600P02
P00400:100>100>100>10`04P@801H401005PP06PP06PP06PP801h800`47
PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD3
0Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<F
R0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@N
RP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@03
1BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^
T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB
00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@3
1c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G
00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:
VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;
Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJ
X0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R
0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@3
3FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW
0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mf
ZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8A
Ojd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166
[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=
/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]003
4i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g
0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR
^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF
[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb
_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00f8`;P01DR@
R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0`00P00;VjOaooooohUooooolj2^lI>Qoooooogo
lj2^oo_l<d>U00P0080300600P02P00400:100>100>100>10`04P@801H40
1005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;
P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>7
0QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<I
R@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@4
98`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5
:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I42
1S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC
00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H0
10Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9
AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@
W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP03
2eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ43
35jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S
0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H2
3VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ003
3g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l
[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<A
Pjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa
4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc
0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H3
59Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<E
WkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX
^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G
[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C03lSPf0030000b>3Hb>3H
00g8h=P00`0001Rd`1Rd`00?b>3H00<0000H]<0H]<000XS0^058T8P10000
000018S0^<SPf8S0^8S0^0@00803VjOa00KoooocX:kd]Kof_<GkfMXc@jD9
00200`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X801X80
1X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<
Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<2
5HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT3
0ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=
0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl4
1Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B
1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD
00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8
@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT3
2DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YA
W@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`03
2eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aO
XPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eU
Y0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW
3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@04
3gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@
OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lA
Q:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba
00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<C
T[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ
]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TE
X;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_004
5Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n
5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PF00200`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X80
1X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@0
0`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<3
6hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=
12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5
:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9
AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YA
W@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]G
W`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW
3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mc
Z@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@
OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hA
Q:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H0
11BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ
_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P03
5k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000>8`;S8h=R8
`;P0ohS0^?n8`;QmR<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;SoR<2h
OHS0^058T8P1000000000hS0^<SPf<SPf03ob>3HolSPf7g8h=P1B9280@00
0000ohS0^?n8`;R1R<2h0@000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?oo
l?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`
l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003o
oo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;o
l?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l00000?o];Bd
olo?coo?cll0ooo?clooolo?cggoclo?0Oo5aLD1okBd]00000?o^KViomgM
gOo/k>`01?o/k>coonk^k_ook^k^M?o^k^h5onc/k07ogMgM0Oni^KT00003
okVi^OoShn?omOGe00ComoOgooojn_[ooo[jnWCon_[j1OogmoL1on?Sh`7o
^KVi00000oni^KWohn?SooGem@3oooooooooooooO?ooool1ooOgm`7ohn?S
0Oni^KT00003okVi^OoShn?omOGe0?oooooooooooomlooooo`7omoOg0OoS
hn<1okVi^@0000?o^KVion?ShooemOD0ooooooooooooogcooooo0OogmoL1
on?Sh`7o^KVi00000oni^KWohn?SooGem@3oooooooooooooO?ooool1ooOg
m`7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7o
n_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo
0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?oo
ool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?ooooooooooooml
ooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooooooo
ogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooo
ooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooo
oooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooo
ooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3o
ooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j
0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shooj
n_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?S
oo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoS
hn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVi
on?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni
^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003
okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@00
00?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi
00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni
^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1
okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?S
h`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7o
hn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j
0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Ooj
n_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1
oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomloooo
o`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogco
oooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooooooo
O?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooo
oomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooo
ooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooo
ooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oo
oooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0
ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[j
nP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?o
n_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?S
hoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWo
hn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi
^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o
^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi0000
0oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT0
0003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi
^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o
^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S
0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoS
hn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1
on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[j
nP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7o
n_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo
0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?oo
ool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?ooooooooooooml
ooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooooooo
ogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooo
ooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooo
oooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooo
ooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3o
ooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j
0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shooj
n_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?S
oo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoS
hn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVi
on?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni
^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003
okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@00
00?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi
00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni
^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1
okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?S
h`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7o
hn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j
0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Ooj
n_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1
oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomloooo
o`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogco
oooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooooooo
O?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooo
oomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooo
ooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooo
ooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oo
oooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0
ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[j
nP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?o
n_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?S
hoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWo
hn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi
^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o
^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi0000
0oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT0
0003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi
^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o
^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S
0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoS
hn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1
on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[j
nP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7o
n_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo
0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?oo
ool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?ooooooooooooml
ooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooooooo
ogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP0Gooooo`04
om[Jf_n/[:coUYJFokfm_OoooooooooooomQooooo`7on_[j0OoShn<1okVi
^@0000?o^KVion?Shoojn_X05oooool01OmTI6CoIFEUogalO?lW9bOoE5AD
0?oooooooooooomPooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shooj
n_X02_ooool01?o]kNgoooooooooooo/k>`3ooooo`03ooGemOoinOWooooo
00Kooooo00?oj^[Zo`<30ooAdM403_ooool00ooinOWoeMGEoo3`l005oooo
o`03ooGemOoinOWooooo00Cooooo00?on_[jonc/k?ooool03?ooool00ooW
inOon_[jooooo`03ooooo`03ooGemOoinOWooooo00Cooooo00?om_Kfoo7a
lOooool0ooooooooooooob?ooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWo
hn?Soo[jnP03ooooo`03oahN7_l=3@go51@D00;o51@D01So_knoocPh>?lF
5QKo=3@dogIfM_lG5aOoc/k>oooooonRXZ;o410@oaPH6?nBTY;o8R8RokJf
]_ooooooc/k>odM7Aolo?cooZJVYoc<c<on`/;3oooooobLW9ona/K42oooo
o`03oc@d=?nTY:Cooooo00Cooooo00Oon_[jog=cLolD51Co?CdmoahN7_m0
@43oh>3P00;ooooo00[oXZ:Roa0@4?lH61SoTY:Bob8R8_nf][KooooookJf
]_lI6AWo>SXj1Oooool00olN7Qko3@d=oa@D5002oa@D5006olC4a?o0`<3o
71`LobDU9Ol:2P[oNGUi0_ooool03OnRXZ;o410@oaPH6?nBTY;o8R8RokJf
]_ooooooU9BDo`@41?l@413oJ6QXoc`l??nJVYX0ooooooooooooob7ooooo
0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP03ooooo`03oahN7_nV
YZKooooo00;ooooo00Ko/[:boa/K6ookno_oh>3PobXZ:_n9RHT2ooooo`0@
oc4a<OnIVIWon?Shog1`L?l410Co][JfoooooolZ:R[oHf=Sol;2`_m[Jf_o
51@DoijNW_oooooo9bLWok6a/@;ooooo00?o=3@dojBTY?ooool01?ooool0
4_maLG7o<30`on_[joooooooo_knog1`L?lS8b?onOWioooooola<C7oVIVI
ooShn?m`L73o10@4okJf]_ooooooCDe=oh:2PPKooooo00?o7QhNojJVY_oo
ool00_ooool05Ooclo?o5aLGoi6ATOooooooh^;Roa@D5?n[Zj_ooooooc4a
<OnIVIWon?Shog1`L?l410Co][JfoogmoOlE5AGoVi^Kookno_n^[Zko3`l?
oiZJVP3ooooooooooooo8Oooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoS
hn?on_[j00?ooooo00?o7QhNojJVY_ooool00_ooool01_oKfm_o3@d=ok2`
/?oinOWoA4A4oiBDU0;ooooo00Wo5ADEol;2`_ooooooo_knoa`L7?nf][Ko
gMgMo`820_o_knl00_ooool01Olf=SKoVYZJoooooolW9bOo/K6a00;ooooo
00?o=3@dojBTY?ooool00oooool00ooXj>So1@D5oiFEU@03ooooo`0=onSX
j?l0003oVIVIoooooolE5AGo`/;2ooooooono_ko71`LokJf]_oooooo<c<c
ojFUY@06ooooo`03oahN7_nVYZKooooo00;ooooo00?o`<30o`820_o^k^h0
0_ooool03?mCDe?oHF5QoooooolE5AGo`/;2ooooooono_ko71`LokJf]_o:
b/[o1@D5ooOgm`;ooooo00?o?CdmoiZJV_ooool0ooooooooooooob3ooooo
0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP03ooooo`03oahN7_nV
YZKooooo00?ooooo00Gof=SHoi:BT_mQHF7o5QHFoiBDU002ooooo`09oaDE
5Oo3`l?ooooooooooolR8R;o][Jfol71`Ol<30cooOgm00;ooooo00Go?Cdm
oiZJV_oooooo9bLWok6a/@02ooooo`03oc@d=?nTY:Cooooo00?ooooo00?o
^k^ko`000?oJf]X01?ooool01Ol];BgoJ6QXoooooolE5AGo`l?300;ooooo
00Go8R8RokJf]_oooooo<c<cojFUY@06ooooo`03oahN7_nVYZKooooo00;o
oooo00?o/k>co`/;2oolo?`00_ooool01OmYJFWoE5ADoooooolE5AGo`l?3
00;ooooo00Go8R8RokJf]_o=cLgo2PX:oo_kn`02ooooo`03ocdm?OnJVY[o
oooo0?oooooooooooolPooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?S
hoojn_X00oooool00olN7QkoYZJVooooo`06ooooo`06ocXj>_nNWYkooooo
oooooolE5AGo`l?30_ooool01OlR8R;o][Jfooclo?lD51Cobl_;00;ooooo
00Wo=cLgoiVIVOoooooo9bLWoeMGEoomoOgoooooob<S8on/[:`01?ooool0
0onVYZKo1PH6ooclo004ooooo`05oeIFE_mBDU;ooooooaDE5Oo3`l<00_oo
ool01OlR8R;o][Jfoooooolc<c?oYJFU00Kooooo00?o7QhNojJVY_ooool0
0_ooool00ooPh>3o0P82ol_;b`02ooooo`05ob`/;?n4Q8CooooooaDE5Oo3
`l<00_ooool01OlR8R;o][Jfookno_lI6AWobl_;00;ooooo00?o=SHfoiVI
VOooool0ooooooooooooob3ooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWo
hn?Soo[jnP03ooooo`03oahN7_nVYZKooooo00?ooooo00GoDE5AogEeMOn2
PX;o1PH6onKViP02ooooo`0DoaDE5Oo3`l?ooooooooooolR8R;o][Jfoooo
oomhN7So71`Loh:2P_lh>3So410@oiZJV_oooooo9bLWoeMGEolj>S[oHV9R
o`P82?o`l?04ooooo`03olO7aol0003oaLG500Cooooo00Go6QXJog=cLooo
oooo5ADEol?3``02ooooo`07ob8R8_nf][Ko/k>coaTI6OmADE7oOgmooogm
o@04ooooo`03oahN7_nVYZKooooo00?ooooo00WoMgMgoahN7_n2PX;oADE5
obPX:?oalO7ooooooaDE5Oo3`l<00_ooool02OlR8R;o][JfoooooomkNg_o
71`Loh:2P_lf=SKo410@oiZJVP3ooooooooooooo8Oooool1oo[jnP7ohn?S
0Oni^KT00003okVi^OoShn?on_[j00?ooooo00?o7QhNojJVY_ooool00ooo
ool01?oUiNGo[Jf]oi>CTooIfMT3ooooo`06ojZZZ_oYjNWooooooooooon_
[jooiNGU0_ooool02one]KGoSHf=om3@d?ni^KWof][JoooooolW9bOo/K6a
olo?conCTi?og]kN00Gooooo00?om_KfoaXJ6_moOgl00oooool01_oBd];o
0000okbl_?ooooooZZZZonWYj@;ooooo00Oo[jn_onGUiOo8b<So820PofUY
JOnRXZ;oo_kn00Cooooo00?o7QhNojJVY_ooool01?ooool01?o1`L7oS8b<
ojBTY?oemOD2ooooo`06ojZZZ_oYjNWooooooooooon_[jooiNGU0_ooool0
1Ond];CoSHf=om3@d?lm?CgoVYZJ0?oooooooooooolQooooo`7on_[j0OoS
hn<1okVi^@0000?o^KVion?Shoojn_X00oooool00olN7QkoYZJVooooo`0H
ooooo`03obLW9ona/K7ooooo00Sooooo00OoZZZZoa8B4_nUYJGojNWYolS8
b?lc<c?oFEUI00Wooooo00?oSXj>olS8b?ooool01Oooool00olN7QkoYZJV
ooooo`0Eooooo`03ocdm?OnJVY[ooooo0?oooooooooooolPooooo`7on_[j
0OoShn<1okVi^@0000?o^KVion?Shoojn_X00oooool00omXJ6So`l?3oooo
o`0Hooooo`03obLW9ona/K7ooooo00Wooooo00KoaLG5oeADE?lY:BWoA4A4
oi>CToono_hAooooo`03ofQXJ?o3`l?ooooo01Gooooo00?o?CdmoiZJV_oo
ool0ooooooooooooob3ooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?S
oo[jnP0Nooooo`03olW9bOo/k>cooooo03Sooooo00?oc/k>onKVi_ooool0
ooooooooooooob3ooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[j
nP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?o
n_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?S
hoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWo
hn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi
^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o
^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi0000
0oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT0
0003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi
^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o
^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S
0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoS
hn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1
on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[j
nP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7o
n_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo
0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?oo
ool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?ooooooooooooml
ooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooooooo
ogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooo
ooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooo
oooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooo
ooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3o
ooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j
0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shooj
n_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?S
oo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoS
hn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVi
on?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni
^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003
okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@00
00?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi
00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni
^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1
okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?S
h`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7o
hn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j
0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Ooj
n_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1
oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomloooo
o`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogco
oooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooooooo
O?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooo
oomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooo
ooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooo
ooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oo
oooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0
ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[j
nP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?o
n_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?S
hoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWo
hn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi
^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o
^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi0000
0oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT0
0003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi
^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o
^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S
0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoS
hn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1
on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[j
nP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7o
n_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo
0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?oo
ool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?ooooooooooooml
ooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooooooo
ogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooo
ooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooo
oooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooo
ooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3o
ooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j
0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shooj
n_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?S
oo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoS
hn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVi
on?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni
^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003
okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@00
00?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi
00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni
^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1
okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?S
h`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7o
hn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j
0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Ooj
n_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1
oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomloooo
o`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogco
oooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooooooo
O?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooo
oomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooo
ooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooo
ooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oo
oooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0
ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[j
nP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?o
n_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?S
hoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWo
hn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi
^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o
^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi0000
0oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT0
0003okVi^OoShn?omOGe0?oooooooooooomlooooo`7omoOg0OoShn<1okVi
^@0000?o^KVion?ShooemOD0ooooooooooooogcooooo0OogmoL1on?Sh`7o
^KVi00000oni^KWohn?SooGem@3oooooooooooooO?ooool1ooOgm`7ohn?S
0Oni^KT00003okVi^OoShn?omOGe00Coooooooojn_[ooo[jnWCon_[j1?oo
ool1ooOgm`7ohn?S0Oni^KT00003okVi^OoMgMgoj^[Z00Coj^[Zooo`l?3o
oo3`l7Col?3`1OoZj^X1omgMg@7o^KVi00000onJVY[o^KViol;2`P04ol;2
`_oo`l?3ooo3`l=dol?3``Go`/;20Oni^KT1oiZJVP0000?oJFUYogMgMomk
Ng/01?mkNg_oogalO?ooO7alM?mlO7`5og]kN`7oMgMg0OmYJFT00?ook^k^
ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0
0?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^00000ond];Coclo?
olo?c`3oolo?coooclo?OOo?cll1olG5a@7o];Bd00000oni^KWogMgMonc/
k004onc/k?ook^k^ooo^k^idonk^kPGok>c/0OoMgMd1okVi^@0000?o^KVi
on?ShooemOD01?ogmoOooo[jn_oon_[jM?ojn_X5ooOgm`7ohn?S0Oni^KT0
0003okVi^OoShn?omOGe0?oooooooooooomlooooo`7omoOg0OoShn<1okVi
^@0000?o^KVion?ShooemOD0ooooooooooooogcooooo0OogmoL1on?Sh`7o
^KVi00000oni^KWohn?SooGem@3oooooooooooooO?ooool1ooOgm`7ohn?S
0Oni^KT00003okVi^OoShn?omOGe0?oooooooooooomlooooo`7omoOg0OoS
hn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1
on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[j
nP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7o
n_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo
0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?oo
ool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?ooooooooooooml
ooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooooooo
ogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooo
ooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooo
oooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooo
ooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3o
ooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j
0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shooj
n_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?S
oo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoS
hn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVi
on?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni
^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003
okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@00
00?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi
00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni
^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1
okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?S
h`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7o
hn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j
0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Ooj
n_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1
oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomloooo
o`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogco
oooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooooooo
O?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooo
oomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooo
ooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooo
ooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oo
oooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0
ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[j
nP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?o
n_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?S
hoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWo
hn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi
^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o
^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi0000
0oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT0
0003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi
^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o
^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S
0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoS
hn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1
on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[j
nP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7o
n_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo
0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?oo
ool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?ooooooooooooml
ooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooooooo
ogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooo
ooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooo
oooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooo
ooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3o
ooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j
0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shooj
n_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?S
oo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoS
hn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVi
on?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni
^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003
okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@00
00?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi
00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni
^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1
okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?S
h`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7o
hn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j
0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Ooj
n_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1
oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomloooo
o`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogco
oooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooooooo
O?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooo
oomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooo
ooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooo
ooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oo
oooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0
ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[j
nP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?o
n_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?S
hoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWo
hn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi
^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o
^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi0000
0oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT0
0003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi
^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o
^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S
0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoS
hn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1
on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[j
nP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7o
n_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo
0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?oo
ool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?ooooooooooooml
ooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0EOooool00oo5
aLGoooooooooo`3ooooooooooooo9?ooool1oo[jnP7ohn?S0Oni^KT00003
okVi^OoShn?on_[j00Gooooo00?ono_komWIfOoRh^801_ooool00ooinOWo
eMGEoo3`l006ooooo`03ooWinOoEeMGol?3`03_ooooo00?o/k>coh:2P_oo
ool0ooooooooooooobCooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?S
oo[jnP03ooooo`07ooKfm_maLG7o30`<oc4a<Olj>S[o6ATIog]kN`02oooo
o`07oo[jn_mcLg?o51@Docdm?OlN7Qko@410on3Ph002ooooo`07oo[jn_mc
Lg?o51@Docdm?OlN7Qko@410on3Ph002ooooo`06oahN7_l=3@go51@DoaLG
5oln?Sko]KFe1oooool01_lN7Qko3@d=oa@D5?lG5aOo?ShnokFe]@;ooooo
00?oC4a<ohn?Soooool00oooool01onNWYko51@DooWinOooooooo_kno`00
0?o6a/H00oooool00omADE7oQhN7ooooo`05ooooo`03oe5ADOn7QhOooooo
00Sooooo00?oCdm?ok:b/_ooool0ooooooooooooob?ooooo0Oojn_X1on?S
h`7o^KVi00000oni^KWohn?Soo[jnP03ooooo`03ofIVI_lT92CoemOG00;o
oooo01goJFUYoeeMGOooooooooooog5aLOl`<33ojn_[ooooooono_koL71`
ob<S8ooinOWoooooog5aLOl`<33ojn_[ooooooono_koL71`ob<S8ooinOWo
oooooahN7_nVYZKoooooooWinOnh^;So61PHoiRHV006ooooo`0:oahN7_nV
YZKoooooooWinOnh^;So61PHoiRHV?oooooo/K6aobTY:@Cooooo00Oo>CTi
og5aLOooooooooooookno_l0003oa/K600?ooooo00?oiNGUong]kOooool0
1Oooool00ooUiNGokNg]ooooo`08ooooo`03okJf]_mIFEWooooo0?oooooo
oooooolSooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X00_oo
ool00ooTi>Co0P82okBd]003ooooo`06ofUYJOmMGEgoooooonSXj?l51@Go
UIFE0oooool01_oXj>So0000oiVIVOoXj>So1@D5oiFEU@?ooooo00Koj>SX
o`000?nIVIWooooooahN7_nVYZH3ooooo`03oh>3Pol@413ol_;b00Gooooo
00?o7QhNojJVY_ooool00_ooool01_n3Ph?o410@oo;bl_olo?co6QXJoeYJ
FP;oIVIV00?oHF5Qo`000?oEeMD00_ooool00oono_ko0000olK6aP03oooo
o`03oj2PX?o3`l?ooooo013ooooo00?ofMWIoadM7Oooool0oooooooooooo
ob?ooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP02ooooo`03
okZj^_l10@7omoOg00?ooooo00KoShn?ohN7Qooooooo^k^ko`000?oJf]X4
ooooo`05obd];OmXJ6So^k^ko`000?oJf]X01?ooool01Ol];BgoJ6QXoooo
oolN7QkoYZJV00?ooooo00?ocLg=o`000?o6a/H01Oooool00olN7QkoYZJV
ooooo`02ooooo`06olg=cOl0003oa/K6oooooomlO7co=SHf0_n^[Zh00om2
@T;o>3Phooooo`02ooooo`03oo?clol0003o_;bl00?ooooo00?oKFe]oj6Q
XOooool02?ooool00ooRh^;o8B4Qob4Q8@02ob4Q8@06og9bL_oooooooooo
ooWinOl0003oi>CTooooooooooooob?ooooo0Oojn_X1on?Sh`7o^KVi0000
0oni^KWohn?Soo[jnP02ooooo`03ojJVY_l820Son_[j00Kooooo00?oYZJV
o`H61_olo?`01?ooool01OmFEUKoDU9BojJVY_l61PKoo?cl00Cooooo00Go
EUIFoe9BD_oooooo7QhNojJVYP03ooooo`03oo[jn_l30`?oZ:RX00Gooooo
00?o7QhNojJVY_ooool00_ooool02_ojn_[o0`<3ojRXZ?ooooooh>3Po`/;
2oo`l?3on?Shoa8B4_nLW9`3ooooo`03ogemOOl92@Wo@41000?ooooo00?o
IFEUoiVIVOooool04?ooool00oo[jn_o1PH6ooOgm`3ooooooooooooo8ooo
ool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j00;ooooo00?oalO7
o`000?nn_[h01_ooool00oo7alOo0000olG5a@04ooooo`05oaXJ6_mcLg?o
alO7o`000?o5aLD01?ooool01OlJ6Q[oLg=coooooolN7QkoYZJV00?ooooo
00?o_Kfmo`000?o2`/801Oooool00olN7QkoYZJVooooo`02ooooo`03okfm
_Ol0003o`/;200;ooooo00GoAdM7oiBDU?nVYZKo3@d=ooCdm002ooooo`05
on7QhOl92@WoZJVYocPh>?nQXJ400_ooool00omMGEgoTY:Booooo`05oooo
o`03ogAdM?nOWioooooo00Sooooo00?obLW9ocXj>_ooool0oooooooooooo
ob?ooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP02ooooo`03
ooCdm?lG5aOoM7Ad00Kooooo00?om_KfoaXJ6_moOgl00oooool01_oBd];o
0000okbl_?ofm_Ko6QXJogmoO`?ooooo00Kod];Bo`000?nl_;cooooooahN
7_nVYZH3ooooo`03ofUYJOlG5aOom?Cd00Gooooo00?o7QhNojJVY_ooool0
0_ooool00omYJFWo5aLGooCdm002ooooo`04ojf][Ol^;Rko@D51ofATI0?o
oooo00WoF5QHoclo?ooooooodM7AoaTI6Oo^k^kooooooeEEEOn:RXX01_oo
ool00oo0`<3oe=CDooooo`08ooooo`03oi>CTomgMgOooooo0?oooooooooo
oolSooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X00oooool0
1onVYZKo3@d=oiNGUooTi>Cohn?Sojn_[onXZ:P00_ooool01onZZZ[o4Q8B
ojFUYOoYjNWob<S8oc<c<omIFET00_ooool01onZZZ[o4Q8BojFUYOoYjNWo
b<S8oc<c<omIFET00_ooool01olN7QkoOGemok^k^onRXZ;oGUiNo`d=3On`
/;001_ooool01olN7QkoOGemok^k^onRXZ;oGUiNo`d=3On`/;000oooool0
1?ojn_[o5aLGo`000?o8b<P2ooooo`03olC4a?l30`?oclo?00;ooooo00Go
M7AdofIVI_ooooooDE5AohN7Q`0@ooooo`03onk^k_li>CWok>c/0?oooooo
oooooolTooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X01?oo
ool01_o8b<SoEeMGobd];Olc<c?oEeMGojVYZ@?ooooo00KoaLG5oeADE?lY
:BWoA4A4oi>CToono_h3ooooo`06olG5aOmDE5Co:BTYodA4A?nCTi?oo_kn
0_ooool01_mXJ6SoDe=Coe=CDomUIFGoR8R8omcLg0Oooooo00KoJ6QXoe=C
DomCDe?oIFEUohR8R?oLg=`5ooooo`03oiVIVOmWIfOooooo00;ooooo00?o
QXJ6ohN7Qoooool00_ooool01Oodm?CoG5aLon[Zj_n:RX[o[Zj^013ooooo
00?oTI6AomWIfOooool0ooooooooooooobCooooo0Oojn_X1on?Sh`7o^KVi
00000oni^KWohn?Soo[jnP1Eooooo`03ooWinOoooooooooo0?oooooooooo
oolTooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooo
ooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooo
ooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oo
oooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0
ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[j
nP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?o
n_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?S
hoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWo
hn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi
^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o
^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi0000
0oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT0
0003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi
^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o
^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S
0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoS
hn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1
on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[j
nP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7o
n_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo
0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?oo
ool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?ooooooooooooml
ooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooooooo
ogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooo
ooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooo
oooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooo
ooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3o
ooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j
0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shooj
n_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?S
oo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoS
hn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVi
on?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni
^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003
okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@00
00?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi
00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni
^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1
okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?S
h`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7o
hn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j
0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Ooj
n_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1
oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomloooo
o`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogco
oooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooooooo
O?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooo
oomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooo
ooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooo
ooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oo
oooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0
ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[j
nP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?o
n_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?S
hoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWo
hn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi
^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o
^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi0000
0oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT0
0003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi
^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o
^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S
0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoS
hn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1
on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[j
nP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7o
n_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo
0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?oo
ool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?ooooooooooooml
ooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooooooo
ogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooo
ooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooo
oooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooo
ooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3o
ooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j
0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shooj
n_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?S
oo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoS
hn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVi
on?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni
^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003
okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@00
00?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi
00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni
^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j0OoShn<1
okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Oojn_X1on?S
h`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1oo[jnP7o
hn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomlooooo`7on_[j
0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogcooooo0Ooj
n_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3oooooooooooooO?ooool1
oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooooomloooo
o`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0ooooooooooooogco
oooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooooooooooo
O?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oooooooooo
oomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0oooooooo
ooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[jnP3ooooo
ooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?on_[j0?oo
oooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?Shoojn_X0
ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWohn?Soo[j
nP3oooooooooooooO?ooool1oo[jnP7ohn?S0Oni^KT00003okVi^OoShn?o
n_[j0?oooooooooooomlooooo`7on_[j0OoShn<1okVi^@0000?o^KVion?S
hoojn_X0ooooooooooooogcooooo0Oojn_X1on?Sh`7o^KVi00000oni^KWo
hn?SooGem@3oooooooooooooO?ooool1ooOgm`7ohn?S0Oni^KT00003okVi
^OoShn?omOGe0?oooooooooooomlooooo`7omoOg0OoShn<1okVi^@0000?o
^KVion?ShooemOD0ooooooooooooogcooooo0OogmoL1on?Sh`7o^KVi0000
0oni^KWohn?SooGem@04oooooooon_[jooojn_Ydoo[jnPCooooo0OogmoL1
on?Sh`7o^KVi00000oni^KWogMgMon[ZjP04on[Zj_ool?3`ooo`l?1doo3`
l0Goj^[Z0OoMgMd1okVi^@0000?oVYZJokVi^Oo2`/801?o2`/;ool?3`ooo
`l?3M?o3`l<5ol;2`P7o^KVi0OnJVYX00003ofUYJOmgMgOoNg]k00CoNg]k
oomlO7coogalO7CoO7al1OmkNg/1ogMgM`7oJFUY003oogmoOeOoOgmo1omn
OWkoogmoObCoOgmo00001?o[jn_oi^KVon;Rh_oNg]h4omgMg@;og]kN0_oM
gMd00ooNg]kog=cLomkNgP03omgMg@3oomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kN000?omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomcLg?oMgMgofm_K00;og=cL03?ogMgMomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]h00_oLg=`01OoIfMWof=SHomOGeooHf=SofMWJ00;o
g=cL07Kog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN0_oMgMd0W_oNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN0ooNg]h00ooM
gMgog]kNomkNgP03omgMg@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oP
h>001ooIfMT01?oHf=Soe]KFom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOG
omSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOG
eooHf=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooG
emOof=SHfooIfMT2omSHf006omKFe_oCdm?odm?ComCDe?oGemOof=SH0_oI
fMT00ooHf=SofMWIomWIf@02omSHf0WofMWI00?of=SHomWIfOoIfMT00_oH
f=P00ooIfMWof=SHomSHf002omSHf1OofMWI00Cof=SHomKFe_oBd];oclo?
0_o=cLd01?o?cloodm?ComOGeooHf=SoomWIfAKofMWI00?of=SHomWIfOoI
fMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWoi>CTon3Ph?oQ
hN7oh>3Pon;RhP02on7Qh@0=omgMgOoLg=codm?ColO7aonk^k_o/K6aojj^
[_nb/[;o^[ZjolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?C
olO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Q
h@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooC
dm?ofm_KomoOg`3Jon7Qh@09on3Ph?oOgmoofm_KomKFe_oDe=Coe]KFom[J
f_oNg]koh>3P00KogmoO0ooPh>000ooOgmooh>3Pon3Ph002on3Ph0SogmoO
0_oNg]h2omoOg`?oh>3P0_oOgml2on3Ph0;ogmoO3OoPh>001OoOgmoogMgM
omWIfOoEeMGodm?C00;od];B00?oe]KFomcLg?oPh>00K_oQhN400ooPh>3o
hN7Qon7Qh@05on7Qh@03on3Ph?oQhN7ohN7Q03;ohN7Q00?oh>3Pon7QhOoQ
hN40JOoQhN400ooRh^;ohN7Qon;RhP04on7Qh@7ohn?S0OoYjNT1ong]k@00
00?ol?3`ono_kooalO400oo`l?00ooo_knool?3`onk^k_oYjNWofm_Kol71
`OnTY:CoRh^;og]kNomgMgOoNg]kohb<S?nTY:Co`/;1om[Jf_oZj^[okNg]
oo7alOo_knoolO7aono_kooalNookno_oo7alOo]kNgoj^[Zom[Jf_o2`/;o
Y:BTohb<RomkNg_oMgMgog]kNon<S8coY:BTol;2`_oJf][oj^[Xong]kOoa
lO7okno_oo7alOo_knoolO7aono_kooalNookNg]on[Zj_oJf][o`/;2ojBT
Y?n<S8coNg]kogMgM_mkNg_oS8b<ojBTY?o2`/;of][Jon[Zj_o]kNgolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_k`006ooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_onk^k_o_knooj^[ZonOWi`02on3Ph007on?Shoo[jnWo
jn_[on[Zj_oVi^Koj>SXonOWi`02onWYj@0Bonk^k?o/k>cok>c/onSXj?o/
k>cokNg]oo3`l?o/k>coj^[XonKVi_oXj>SoinOWonWYjOoXj>Sojn_[onOW
iooWinGoiNGU0_oYjNT03oo^k^kokNg]ong]kOoXj>Sojn_Yonc/k?o^k^ko
jNWYon[Zj_o[jn_okno_onc/k?o/k>[oj^[Zonk^kP02onc/k03oon[Zj_o_
knook>c/onc/j_oZj^[ok^k^onc/k?n_[jooMWIfoeUIFOm^KVko]kNfon3P
h?oYjNWokNg]oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_000]oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l?3okno_00Col?3`00000oobl_;ok^k^
onOWi`04onGUi@0@onCTi?oOgmoodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo
@T92odE5AOmADE7oIVIVohZ:ROna/K7odM7AomkNgP;oi>CT00?oiNGUonCT
i?oUiN@00_oTi>@03ooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92
odE5AOmADE7oIVIVohZ:R_na/K7odM7@omkNgP02onCTi03]onGUiOoTi>Co
iNGUonCTi?oTi>?og]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5
ADGoDE5AofIVI_n:RX[o/K6aom7AdOoNg]koi>CSonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT00;oi>CT
053oaLG5obPX:?m4A4CoT92@om7AdOoLg=_ofm_KomOGeooDe=Coe]KFomCD
e?oEeMGofMWIon3PgooNg]kof][JomCDe?oIfMWog]kNon;Rh_oLg=coemOF
omCDe?oFe]Koe=CDomGEeOoHf=Sofm_KomOGeooFe]GoeMGEomOGeooHf=So
g]kNomoOgooLg=coeMGEomOGe_oLg=cogMgMomOGeooFe]Kofm_Kon7QhOoN
g]kofm_Jom[Jf_oNg]kog=cLom[Jf_oKfm_oh>3PomoOgooLg=_ofMWIomkN
g_oOgmooM7AdofMWIon=SHgoE5ADo`P82?nRXZ;og=cLon;Rh_oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUi@?oi>CT09goiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGU00?oi>CT06CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CT1?oUiND01_oTi>CoiNGUonGUiOoUiNGoj>SXong]
k@7ol_;b00000oodm?CokNg]onOWi`02on3Ph00Con7QhOoOgmoog]kNom;B
d_nd];CoQhN7oeaLG?m]>cGoWTi2ole_GooYPfooc6iNoii>@om]>cKoG5aL
ohN7Qond];Cod];BomkNgP05on3Ph00AomkNg_oBd];o];BdohN7QomLG5co
KF0/oijF;_o=cCoojNU=olg=?onNVRooKF<]oeaLG?n7QhOo];Bdom;Bd_oN
g]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLodMW;_mXWS?oTLe7oj[Y
EOnAcDOoJYhdodUZ;omLG5coQhN7okBd]?oBd];og]kN0=Woh>3P00KogmoO
olo?conIVIWoTY:BoaTI6On<S8`2omGEe@0Oolo?coo2`/;oc/k>olk>c_o5
aLGob/[:om[Jf_oHf=Sod=3@ol_;boo?cloof=SHom[Jf_oEeMGoclo?ol71
`Oo@d=3oc/k>olC4a?o;bl_of=SHomOGeonn_[ko^k^kom7AdOo@d=3oeMGE
omSHf?oCdm?oc<c<olk>cP02omGEe@05olk>c_o<c<codm?Com[Jf_oHf=P0
0_oBd]801?oHf=SoemOGom7AdOoCdm<2omWIf@06om?CdooAdM7oemOGomSH
f?oAdM7od=3@0_oAdM401?m6ATKo@D51omOGeooNg]i`on3Ph003omoOgooP
h>3oh>3P00;oh>3P00?ogmoOon3Ph?oPh>00WOoPh>000ooOgmooh>3PomoO
g`02omoOg`?oh>3P00?ohN7QonOWioo/k>`00Ooclo<00003ooKfm_obl_;o
jn_[00?oj>SX01?oinOWon;Rh_o=cLgoWYjNof]OGon?=BgokG5QooVMT?om
/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=cOoRh^;oinOW00?o
j>SX01?oinOWon;Rh_o=cLgoWinOofiVGonCLR;okM54ooWcM?omoHgooOfE
oogmS_oin7KokMM7oi=c8_m^IeooWinOolg=cOoRh^;oinOW00?oj>SX01?o
inOWon;Rh_o=cLgoWinOof1XGom;O2?oT^5;okgiNoo@oI;of?fKomCmUOo0
nGkoV>Q=odf09?mPJEooWinOolg=cOoRh^;oinOW0=[oj>SX00Coi^KVon7Q
hOmMGEgoCDe=0_oMgMd07om@D53o1`L7oaDE5On4Q8Co5QHFod=3@ooRh^;o
gMgMoibLW?l0003oShn?omgMgOoQhN7ofm_Kod10@?l820So6ATIohR8R?l;
2`_oF5QHokNg]ol<30co1`L7ob<S8olW9bOoOGemom[Jf_oMgMgoe=CDo`/;
2omIFET00_oIfMT00omMGEgo2`/;om?Cd`02omoOg`06oeYJF_m>CTkog]kN
omkNg_lS8b?oQ8B40_oQhN403?mjNW[o;Rh^omgMgOoMgMgo`/;2oe1@D?lc
<c?oKVi^oh>3PolQ8B7og]kNonKVi_ooj>SX7ooXj>P1onc/k07ol_;b0Oof
m_H00003ooOgmoohn?Son?Sh00?on?Sh01?omoOgonk^k_o>c/koT92@ohD_
:ooYI5Koni:7oojVVoon/:CookR[oojcY_onYiconiB9oniXFOn9<B_oT92@
olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@oiUY:oo`_Cgo
nn1^ookdP_onoX[ooonBooknS?onn8?onnE`oo32?_nIJR_oT92@olk>c_o^
k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@od9c:on4cT?o[Nmcol;n
R?o>oY3oe_nGom3nT_o6oXWo/_EdohSC@om4MB_oT92@olk>c_o^k^komoOg
0=[on?Sh02Gom_Kfoo7alOn1PH7o7alOong]kOo6a/Ko0000ol?3`ooCdm?o
G5aLo`P82?oZj^[ol?3`on[Zj_mBDU;o51@Docdm?OoYjNWol?3`ojn_[ol7
1`Ood];Bolg=cOm>CTko6a/Konk^k_oKfm_o[Zj^onSXj?o/k>co[Zj^o`00
0?nd];Cok>c/ok2`/?l;2`_o6QXJ00;oi>CT00_o8b<So`h>3_nTY:CokNg]
onk^k_mPH63oE5ADonk^k_o]kNgo9RHVohf=S@02oo3`l00<oh:2P_la<C7o
k>c/on[Zj_m3@d?o;bl_oibLW?mcLg?o:RXZoaXJ6_o^k^kom_KfK_ohn?P0
0oogmoOon?ShooShn005ooShn003ooOgmoohn?Son?Sh09kon?Sh00?omoOg
ooShn?ohn?P00_ohn?P01?ogmoOonOWiooKfm_ogmoL1ooShn00000?on_[j
ooGemOo^k^h00_o/k>`0ooo[jn_ojNWYomoOgoni^KWoNE9Bokla8ooWM6Wo
oHQnoonHS?onXYKoojRLoojTV?ooVXgooXYoonifJ_o3<bCoNE9BokZj^_oO
gmooj^[Zon_[joo/k>cojn_/on[Zj_oOgmoo^[ZjohQUD_oRTAconL=@oogJ
HooojW;oo_=nooojP_onmWooonacookNI?ojae7ohY8LohUVDonj^[[ogmoO
on[Zj_o[jn_ok>c/on_[jooZj^[ogmoOokZj^_mBKE;oDJ<Loi7BEOnVif[o
^?Ujol3nP_o7ohWo`oj4okWmNonWk6coU=IGoe:V7?mBKE;o^[ZjomoOgooZ
j^[ojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k000BOo/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?oYjNWoiNGUogYjN_lL71cohN7Rolc<
c?l30`?oX:2PomkNg_nDU9Co4a<Con7QhOoPh>7od=3@o`H61_nQXJ7o2@T9
okno_ooQhN7o^[Zjo`820_nb/[;ogMgMoh20P?lX:2Sohn?SonOWiooUiNGo
gmoOom_KfooCdm?o20P8ohF5QOoOgmooJFUYodY:B_le=CGo[Jf]okfm_Ol7
1`OoN7QhoeEEEOoOgmooh>3Poe]KFom@D5000_oQhN402_lT92CoQHF5omoO
gooQhN7oNg]kobl_;ooPh>3oe=CDo`D51OnXZ:P2on?Sh`0DoginOolF5QKo
hN7Qon[Zj_o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>`3on_[j`2Gonc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k002on_[j`04on_[k?o/k>cojn_[onc/k0?ojn_[06;ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k0Kojn_[00Gok>c/on_[joo[jn_o
k^k^ooKfmP01ooWin@0000?ono_koo?cloo]kNd00_oUiND0oooVi^Koi>CT
omWIfOnb/[;oN2d]olQ2=?oSJUcom7Y]oof8O?onUh[ooY^>oojHRoonRWko
m7]]onM[GOo:@SCoNbh^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGVonCTi?oH
f=So/[:boiIE;_oZW2_onka4ook<Doomf6;oo^=bookYMOoniW?oo]]Uoog<
Dook`DGokYh[oiUF;_nb/[;of=SHonCTi?oUiNGoi^KVonGUiOoTi>Cof=SI
ok:b/_l^HRkoHjd[ohO:B?nGg5WoYNEYok;cMonhmW_o]?EiojOZJonHg5Wo
RLm;of>^:ol^Hbko/[:bomSHfOoTi>CoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUiP00=?oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oS
hn?ogmoOogMgMolK6a_og=cLon7QhOnNWYko;bl_ob/[:olb<S;o4Q8BomcL
g?oJf]_oQ8B4ob0P8?oPh>3oDU9BofQXJ?oJf][og]kNoi2@T?lZ:R[o;Rh^
ob`/;?lW9bL2omkNgP0ComWIfOoCdmCod=3@oe]KFol0003o_Kfmom[Jf_lX
:2SoQhN7ogMgN?mXJ6SoPX:2oc`l??o2`/;o3`l?omCDe?oJf][oFEUIodi>
CP02omcLg01nob<S8on1PH7oeMGEomOGeomgMgOo;Rh^omcLg?nSXj?o0000
olO7aooHf=SofMWIohf=S_lE5AGog=cLon?ShooUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KV0ooUiND0Y?oVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGV0_oVi^H00ooUiNGoi^KVonKViP03onKViP03onGUiOo]kNgolo?c
007on_[j00000oolo?con?Shoo7al@03onk^kP0Con_[jooQhN7o_;blogXG
5oo3?c;odeI9onAXF_o_Mfcolh=hooR7O?oeQ7[olgU]onEYFooIF4[oa3lb
og`G5onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;blojE75ooVUc;o
mJ``oofl@OombE?ooM1Poo_CIOomdV3oo/eDoofm@_oj[c;ojI/bojE65onl
_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;bloaMI5omOZ3;oM[dgohK=
AonFeU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg_cOoGj/boaMI5onl_;cohN7Q
onc/k03Jonk^kP0^onc/k?oWinOoNg]koa`L7?oTi>CojNWYonKVi_oQhN7o
g]kNohf=SOlD51Coi^KVonCTi?le=CGoNGUion_[jonb/[;o5ADEomoOgooV
i^Koi>CTon7QhOoMgMgoNWYjobTY:OoXj>SoiNGUomgMgOna/K7o9RHVo`/;
2onKVi_ojNWYolc<c?l0003oc/k>ol?3`olU9BGoBd];ogalO?oXj>So<C4a
ojFUYOoTi>CoGEeMoe5AD@;oinOW00[o9BDUofUYJOoOgmoogmoOogMgMola
<C7ojNWYol71`Ol0003oYjNW0_oOgml01?nCTi?o5QHFonOWioo/k>b[onk^
kP03ong]kOo^k^kok^k^06ook^k^00?okNg]oo;bl_ohn?P00Oolo?`000?o
oOgm01Koo?cloogmoOomoOgoo?cloo?clooAdM7oJ0L7okPd=?o7?c?odU13
omYREOoSKV;oi79TonA_H_oLI5Oode53ola1=?ni=3CoJ`L7om;Bd_oclo?o
o?cl0oomoOd04oolo?colo?com;Bd_nN:`OofXXdon^K6OoeZ2Won;@oooVm
B_oh_dgon[m:ooVh?oofZR[okihIom^;=?nR;@Ood];Boo?cloolo?`00oom
oOd04oolo?colo?com;Bd_l7@0OoCIXdoen[8?m`^2ooOl=3oh[=D?n=cE;o
R/i@oh77A?ma^BooHZhPodjK=?l7@POod];Boo?cloolo?`0f_omoOd08ook
no_omoOgohB4Q?lN7Qkolo?cooWinOnc/k?od=3@oo?clomXJ6SoAdM7oo[j
n_oDe=Co0000omgMgOolo?cono_kobLW9onXZ:SonOWioj^[ZooEeMGolO7a
oeADE?mNGUkonOWiooCdm?nDU9Co1@D5od10@?oAdM7omoOgooShn?nGUiOo
:b/[00;on_[j01_o92@To`L71oo8b<Sono_kohF5QOmSHf?omoOgof=SHomG
EeOon?ShooWinOlW9bOo5ADEoh>3PooGemOo@T92of=SHookno_on_[joc@d
=?m9BDWofm_KonGUiOm?Cdoo5aLGoo[jn_olo?`0ooomoOdLoogmo@03oocl
o?omoOgoo?cl00?ooOgm0000>_omoOgon_[joo?cloo^k^kol?3`ono_koo^
k^kojNWYom?CdomK7AgoXS@dok<W7?o1>RgoadTlolmFB_o@Ed_od5M:olY:
?_o3>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>ook^k^
on[Zj_oCdm?oS2DMolQa=?oIQ1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/X2Go
iiLEomb87Oo8LCCoS2DMom?CdooZj^[ok^k^oo3`l?o_knool?3`onk^k_oZ
j^Wodm?Coadh7OldPSCoAiDMoeZU6omY[BX2ogBh>03RogFi>?m[/B_oFjLL
odRJ7OldPSCo7CPMom?CdooZj^Wok^k^oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l0;okno_04ko
j^[ZoginO_lL71coj>SWong]kOn8R8So<30`o`l?3ola<C7o/K6aonk^k_n5
QHCoCDe=ono_koo^k^kokno_ohZ:R_mIFEWok^k^ogQhN?l[:b_o3`l?ocPh
>?no_kookNg]onCTi?l>3PkoJFUYomoOgooShn?oiNGUon_[jomQHF7oMgMg
onk^k_o_knkoMWIfobHV9_o]kNgokno_olc<c?l/;2coj^[Zofe]K?mRHV;o
k>c/ong]kOlk>c_oTi>Cof9RH_l>3Pko=3@dolC4a?o_knook^k^om7AdOll
?3co2PX:obLW9om/K6co;2`/ono_koo^k^kol?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?03ono_
k`3ooo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o^k^kol?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`0005ono_koo`l?3o
kno_oo3`koo_knl00_o`l?06ono_k`7olo?c0OoinOT1ooknoP0000?oo_kn
ooOgmoo`l?001?oYjNT04OoWinOofm_Kof=;Bon1<S;oYSDeokHd;Oo2CD7o
`eA9olAEB_o3E4Wo`Te1okHd;OnU=CGoPC8bof=;BooKfm_oinOW00GojNWY
017oinOWom_Kfon9Bd_o[d/boleg=OoFRbgoh9`^on2P<_oQX3Coh:0bomnJ
;_oFRbgobWDeojm;<_n9Bd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oBd];
oc9P<_ljRCGoDi/]of^[;om`[CSoKjhjog2]>?mZZRooDi/]ocV8=OlbH3;o
Bd];om_KfooWinL0fooYjNT01_oXj>Soi^KVog]kNolL71coi>CTonSXj0;o
jNWY00?oinOWonWYjOoYjNT02ooYjNT03?oWinOojNWYonWYjOoXj>Sof=SH
o`X:2_n^[ZkogMgMomkNg_oPh>3oiNGUonSXj0SojNWY00Koj>SXonKVi_oS
hn?ohn?SonKVi_oXj>P3onWYj@03onSXj?oYjNWojNWY00CojNWY00?oinOW
onWYjOoYjNT0oooYjNTKonWYj@03onSXj?oYjNWojNWY00CojNWY0Oo`l?01
ooKfmP7oo_kn00001Oono_kon_[jooCdm?o_knoolO7a00;ol?3`017okno_
on_[jonEU9CoCb<SoiEDE?nkLg?odiFEomZLW?oJWYcofIbLomBEUOnkLg?o
UEADodlS8onEU9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oZIBDoh4S8onj
JUCoe9YconBlUOoZaicojLNLon[7W?oU_9Goe9Ycok]ZE?n18b?oZYBDon[Z
j_o_knl01Oo`l?004Oo_knooj^[ZoiBDU?lS:R?oE7YDog>ULonNaYGo[<jL
ojg>W?n/cYcoW/JEog>ULomDNUCo8bXSoiBDU?oZj^[okno_0=_ol?3`0_o_
knl01?n0P83o7AdMonk^k_o_knlCoo3`l0;okno_00OoI6ATobTY:On1PH7o
Hf=Soc/k>oo^k^kokno_00Sol?3`00Kokno_onk^k_mcLg?oJFUYonk^k_o_
knoooo3`l2gol?3`00ColO7aoo3`l?odm?Con_[j0Oono_h00004onc^l?oo
ooooooooooknoP;ooooo0_ono_h0ooomoOgon?Shofi^K_mJ?coo/I2@omk9
bOo`i>ColnKVoo3Ti?oNbLWo/I2@oeXo?om]KFgon?Shooclo?ooooooo_kn
ooooooono_koooonookno_ooooooo?clooShn?n=KFgoRSloolVAT?oYd<Wo
m>WTooK[i_odjNCojM39olVAT?n9?cooSFe]ooShmoolo?coooooookno_oo
ooooo_knooooooono_koooonooclo?ohn?SoKFe]oclo?on@WI3obMG9onC/
i?oVk^Koi>cTolWEbOn@WI3o?cloofe]KOohn?Soo?clooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooooknoP00>?ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_oooooooOgmom3@d?nUYJGoo_kmookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooomoOgo`L70og5a
LOn1PH7o[jn_0_ono_h03?ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooomoOgo`/;1okbl_0;oo_kn0?ooooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooool002Woo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooooknoP02
ooooo`03ookno_oooooooooo00?ooooo0Ooin_/00004ol37cOono_kon_[j
ooCdm0GolO7a00gokno_omKFe_m[Jf_o@cdmoi^<S?o6^[[oe/c<olNj^_nK
S8co@cdmof][JooFe]Kokno_00WolO7a00gokno_omOFe_n3Jf_oM3dmokF<
S?oE^[[ohLc<omJj^_nfS8coLSdmoh5[JooGe]Kokno_00WolO7a00gokno_
omKFe_m[Jf_o?Cdmohb<S?nj^[[oc<g<okZj^_n<S8co?Cdmof][JooFe]Ko
kno_0?oolO7a7?oalO400oo`l?3olO7aoo7al@3ooo7alAGolO7a00Col?3`
oo7alOoalO7ol?3`1?oalO400oodm?Con_[jooknoP01on_]kP0000GoPhnI
oogmoOohn?Sol?3`on_[j`03on[ZjP0=onWYjOoZj^[ojNWYonSXj?nKVi_o
FEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0;on[ZjP0;onWYjOoX
j>SoX9^KofYIFOm39RKo;@T9od8V9_mYFEWoX9^KonSXj?oYjNT02ooZj^X0
2ooYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY
0?ooj^[Z7?oZj^X00ooYjNWoj^[Zon[ZjP3oon[ZjQgoj^[Z00Cojn_[oo3`
l?ohn?SooOgm0OoAeML00004ocI6D?nh_lGon_[jooCdm0SolO7a0_o`l?03
ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2
oo3`l?oolO7a8?oalO400oo`l?3olO7aoo7al@3ooo7alAOolO7a00?ol?3`
oo7alOoalO400_oalO400ooemOGonOWionc]k`01oj:UZ00000?o7BlmodeH
Honi_lH0ooooooooooooogcooooo0Oo]ko01ojf`/`7oYJV]00001_lN;cgo
6bPdoc8nB?mmR97o_L?7on_/k_oooooooooooomfooooo`05on[/kOnk_l;o
NX67ob/e?OlB82X00OlD8bl00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[BoxData[{
    \(\(savedLayout = pane@getLayout[];\)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]\(pane@
          setLayout[\[IndentingNewLine]JavaNew["\<java.awt.GridLayout\>", 2, 
              3, 5, 5]\[IndentingNewLine]];\)\[IndentingNewLine]]\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(txtFld = NewJTextField[pane, "\<GOOD DAY! :-)\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JTextField"] \[RightGuillemet]\),
      JLink`Objects`JavaObject71366300663809]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(txtFld2 = NewJTextField[pane, "\<Laugh Out Loud\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JTextField"] \[RightGuillemet]\),
      JLink`Objects`JavaObject71383178543105]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(DeleteJObject[pane, txtFld]\), "\[IndentingNewLine]", 
    \(DeleteJObject[pane, txtFld2]\)}], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JPasswordField <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P1000000001HS0^<SPf8S0^8S0^<c<c03oooooooooogWoool2R<2h0DR@
R04000000006R<2hb>3HR<2hR<2hIVIVc<c<ofIVI_mVIVIgIVIV00Cooon8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00<0003oool0
00000_ooo`030000oooo000000;oool00`000?ooo`000002oooo00<0003o
ool000000_ooo`030000oooo000000;oool00`000?ooo`000002oooo00<0
003oool000000_ooo`030000oooo000000;oool00`000?ooo`000002oooo
00<0003oool000000_ooo`030000oooo000000;oool00`000?ooo`000002
oooo00<0003oool00000oooooooooolfoooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH00oooo`030000oooooooo00;oool0
0`000?ooooooo`02oooo00<0003oooooool00_ooo`030000oooooooo00;o
ool00`000?ooooooo`02oooo00<0003oooooool00_ooo`030000oooooooo
00;oool00`000?ooooooo`02oooo00<0003oooooool00_ooo`030000oooo
oooo00;oool00`000?ooooooo`02oooo00<0003oooooool00_ooo`030000
oooooooo0?oooooooooo=Oooo`05IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVoooo@@000?oooooooooo=Oooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00?oool00`000?oooooo
o`02oooo00<0003oooooool00_ooo`030000oooooooo00;oool00`000?oo
ooooo`02oooo00<0003oooooool00_ooo`030000oooooooo00;oool00`00
0?ooooooo`02oooo00<0003oooooool00_ooo`030000oooooooo00;oool0
0`000?ooooooo`02oooo00<0003oooooool00_ooo`030000oooooooo00;o
ool00`000?ooooooo`3oooooooooocGoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool0
1Lc<c?ooohS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^?mVIVKoIVIV
NFIVIP04c<c<R<2hR<2hB9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;Qm
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h5P00P0<00H0200:000@00X40
0h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2
008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25
108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN8
0aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<4
88/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh5
9hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T004
1RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLe
TPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE
0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4
V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:
C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM
2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<
G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=
HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU
0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?
L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@
N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d0
0a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<B
R;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>
/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd
0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM
]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<E
Y;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d3
5jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1000P003VjOa<d>U<d>U
00Tc@jD600200`01P0800X001002P@03P@03P@03P@<0184200F100@01H80
1X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@1
2h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8D
Q`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<J
R@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=
12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?
00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@04
1S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC
1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8
@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI
00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YA
W0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]G
W`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<
Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<0
0`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP04
3VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mc
Z@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/
00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<A
Q:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<B
Rk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<3
4i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8D
V[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<E
X;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl
11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`
_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3002000NKYo7ooon>N[JVVlBcZM:XWLRcZM800ZJKa005_;SM
k^kdj^Waoooo<d>U00D0080300600P02P00400:100>100>100>10`04P@80
1H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<0
0`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP04
0Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<I
R@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><
00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5
:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6
<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<3
1cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88
@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9
AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL
10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]F
WP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<
GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<3
3F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>
K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mb
Z0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[
0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62
[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa
4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P02
4hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@D
V;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN
^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk
0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn
00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C08000008H]<0@0000
0QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000BKYo7ooom/
FZF_YLX2_;SM00[ooOncZM;ooooooonl^=fGR[bXWLSVi^cooolc@jD40020
0`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X801X801X82
00N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<1
3H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL2
0QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:
0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDU
S@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?
0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B
1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7
>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL3
24:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI
0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YB
W@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO
10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaP
XPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eU
Y0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW
3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY
0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@
OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l0
0a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@B
S;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<C
T[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK
]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T0
11FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l
5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o
5k6o00<G/[l35k>o0QRd`003b>3HB928B92800a8T8P00`000<SPf4R@R00=
B92800@0000H]<0H]<38h=P>B92800<0000H]<0H]<000XS0^058T8P10000
000018S0^<SPf8S0^8S0^08008002i^WlOooojRMb?oook>YdV1<VXij]WQU
[ZRMb?ooooomo`03oooo00<c@jD0080008000`00P0<00H0200:000@00X40
0h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2
008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD20Q25
0oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<4
7h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=
1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086
;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7
=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9
@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:
BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<
Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`
Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?
MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd3
4H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<B
Qk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d
0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL
]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d2
5jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G
/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00f8`;P01DR@R000
01Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0P00P00>VjOaoooooooofmc/H4bJThFj/jWB_;SMH4bJ
VHnnYY_4b<?Ooooo<d>U1P00P0?oool200:000<00X7oooooool00_ooo`80
18400`05POooo`05PP0300J21?ooo`030@R20@R3oooo00?oool30@Z300Ko
ool12h@12h@138Coool138@20@f400Coool13XGoool13XD20Pn500Coool2
48Goool248D20Q6600?oool24HH24XH00P8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<3
6hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=
12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5
:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9
AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YA
W@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]G
W`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW
3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mc
Z@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@
OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hA
Q:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H0
11BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ
_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P03
5k6n5k6o5k6o00<G/[l35k>o0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P0
0dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00
P00>VjOaoooo_;SMVHnnooooe]7Mfmc/lokoYY_4k^kdQGJ`ThFjoooo<d>U
1000P007oooo006000600060oooo00:0oooo00<00h401_ooo`04P@04P@05
POooo`05PP801X802?ooo`07PP07PP47P_ooo`48P_ooo`48P`<12H<01?oo
o`4:P`4:Poooo`812h@00`4<Q?ooo`4<Q0020@f400Coool13XGoool13XD2
0Pn500?oool248Goool00oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<K
R@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d4
9Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[
S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO
00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y
00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n
[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64
[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P04
59Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl
00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G
/KhG/KlG/Kl00aNb_`<G/kl26;C000C8h=R8`;R8`;R8`;P6000018S0^003
B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P0
00000QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0^004B9280000
6;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008003i^WlOoo
oiV?_YN:_=CCj>n//omfNnjOZe]HYJJKa9JOdV1<V[bhgOoooc=3Y@030020
00Ooool00H000H000H3oool00X3oool00`03P@06oooo00B100B1oooo00F1
oooo0P06PP08oooo00N200N20@N2oooo0@R2oooo0@R30`49P`09oooo0@Z3
oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?ooo`4>QOooo`4>Q@823hD0
1?ooo`8@QOooo`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`82
5XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X3
0af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=
0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l3
1Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86
<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`Li
U0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8
@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T3
2DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M
0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l4
2eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R
362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT
00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>
KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T3
3gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n
[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`03
4HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:<
/Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B
]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g
59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@04
5J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`F
ZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG
/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8
`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3H
R<2hR<2h00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOX
ZFjPb<?OThFjFdJCVHnn0WQU[P04@RN5[jG:oooo<d>U1000P0<00H000ooo
o`02P002P@04oooo0P04P@03oooo00F1oooo00<01X84oooo00<1288128<1
28<00`49P`09oooo0@Z3oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?oo
o`4>QOooo`4>Q@823hD00oooo`8@QOooo`03oooo0P8AQP<24XH20Q>600@2
4hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV9
0aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`0
10@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZ
SPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`Ha
T@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7
=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0
UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6
V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`4
2U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN
00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aM
X@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=
Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/
YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X
00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/3
47b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^
0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4B
R[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008C
Sk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH
]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh
0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/3
5ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;
R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0
^4R@R00000026;C000?8h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H
]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOaoooo
oooo00;oool02_n]/?mfNoW=e?g]k_ooojJKa8Ef/;bhgOoooc=3Y@D00803
006000?oool00X000X400`03P@03oooo00B1oooo00801H401005P_ooo`06
PP06PP801h800`47P_ooo`48PP020@R30oooo`812X<01oooo`4;Poooo`4;
Q?ooo`4<Q?ooo`020@f400Coool13XGoooooool20Pn500Koool248Goool2
48D24HKoool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<4
7XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd0
0`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6
;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHd
TP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD
0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3
U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9
BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd3
2e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<
FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaP
XP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT
0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_
Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?
MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd2
4Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@A
QZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8B
SK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@0
0a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK
]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<E
X[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m
5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<0
0028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0
^004R<2h0P0000F8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P3002000ZQ[?;icMCR9Scd]KoR9ScdKGglhnWoooomkNko
[K02oooo00<c@jD0080008001000P0<00H000oooo`02P002P@03oooo0P04
P@05oooo00F100F100F2oooo00801X83oooo0P48PP030@R3oooo0@V30081
2H<20@Z300Coool12h<12hCoool20@b400Ooool13H@13HCoool13XGoool1
3XD00_ooo`030Pn50Q250Q2500Coool0108AQP8BQP8BQP8BQP824hH0108C
Q`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT3
6HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS004
12B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>
1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A
0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`Lg
T`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F
00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH
2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:
D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh0
0`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ
0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eS
X`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP0
0`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@
O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh3
4H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::
/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?
/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf
0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P3
5Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<F
Z;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P03
5jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8
`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2h
B9280000008H]<000lSPf8S0^8S0^003R<2h100000B8`;P014R@R00001Rd
`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000fKYo7mkNkR
9ScnmOSgRIOdHVkcX:kdHVkooOoo[K3lhnWooolc@jD01`00P0<00H000ooo
o`02P002P@0300>10`04P@801H401005PP06PP06PP06PP801h801@47PP48
PP48P_ooo`48P`030@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<2
3hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ8
0aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:
0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<5
9hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@
0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=980
0`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7
>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL0
10U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ
0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]C
W@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP
0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82
366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=
Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL2
3W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ
0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o
[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_
0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb
4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<C
Tk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL3
59bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i
0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/
_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o
0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000
R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P0
0XS0^0800002R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000>KYo7fb<cR9S`00_n]/007gb@^ojBN
m[c5ojf`kW^<oooo<d>U00P00803006000?oool00X000X400`03P@<01842
00F100@01H801X801X801X8200N200D11h81288128;oool128<00`49P`04
oooo0@Z30@Z30@^30P4;Q0<138@30@f40`4>Q@<23hD30Q25108AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR003
0aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A
1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC
0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH3
23nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9
AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>
V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aM
X@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ80
0PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD4
3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?
LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1j
Z`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61
[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@B
RK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb
4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D3
59Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh
5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0
^8S0^00;R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H
]<38h=P00hS0^0800004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7icMCgRIL00_ooo`07
ojf`hAHdogIkojBNhRHlohUo<d>U00P00803006000?oool00X000X400`03
P@<0184200F100@01H801X801X801X8200N200@11h812881288128<4oooo
0`4:P`030@^30@^40@^400<138@20@f400Coool13XD13XD13XD30Pn50`8@
Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<G
R0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3
122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>
1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i00
10H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987
=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`Pl
U@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9
A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX3
2TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]D
W@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj02
35bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP03
3F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eX
Y@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`04
3g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX3
47RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]
00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk03
4XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8B
S[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D
]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8D
WKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX3
5JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm
0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl2
6;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P900000XS0^005
B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000NKYo7oooocX:kdHVkoooogRIOicM@0
0_ooo`03lj2^oooo<d>U00P0080300600P02P00400:100>100>100>10`04
P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<1
2X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00
P00;VjOaooooohUooooolj2^lI>Qoooooogolj2^oo_l<d>U00P008030060
0P02P00400:100>100>100>10`04P@801H401005PP06PP06PP06PP801h80
0`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<1
3XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:
0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DV
S@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@
0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i82
1SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7
>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL2
24>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ
0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]B
W@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO
0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R
362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=
IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL3
3VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o
[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_
1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=
/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B
]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g
59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i
0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdF
ZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl0
0aNb_`<G/kl26;C03lSPf0030000b>3Hb>3H00g8h=P00`0001Rd`1Rd`00?
b>3H00<0000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0@0
0803VjOa00KoooocX:kd]Kof_<GkfMXc@jD900200`01P0800X001002P@03
P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h8128812880
0P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D4
0Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP3
5hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@P
R`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDW
SP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6
;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB
1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D3
23fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH
2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<
V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;
E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaL
X00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQ
XPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D3
3VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`
Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1h
ZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@03
4H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8
/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb
00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@3
4iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg
00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT
^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G
[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PF00200`01P0800X001002
P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h812881
28800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<2
48D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP3
5hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;
0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DW
SPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@
00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB
1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8
?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H
2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J
0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;
E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P
0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ80
0`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=
J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L0
10m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ
0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60
[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`
0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK82
4Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<C
U;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L2
59fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j
0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/
_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o
=QRd`0:8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@
R04000000003R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058T8P1000000000hS0
^<SPf<SPf03ob>3HolSPf7g8h=P1B9280@000000ohS0^?n8`;R1R<2h0@00
0000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?oo
l?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`
l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003o
oo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;o
l?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool0
0?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_oo
k^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003o
onKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;o
oooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^ko
onk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00
oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2
ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^
ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0
0?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooooooo
P_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^
k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^
003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooo
oh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooo
oon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?oo
k^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^
k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003o
onk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;o
k^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00003ojJa_?mn[MWoOZgI0?ooOZgIoomn
[MUoogj]f@0000?oZ[G0ogj]fOmn[=T0oon6/M[oohJafWgoQ[7J0Omn[=T1
ogj]f@0000?oZ[G0ogj]fOn7/]/01?ogmoOooo[jn_oon_[jM?ojn_X5ooOg
m`7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7o
moOg0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo
0OogmoL1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?oo
ool1ooOgm`7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?ooooooooooooml
ooooo`7omoOg0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooooooooooo
ogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3ooooooooo
ooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooo
oooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooo
ooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3o
ooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K
0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7
/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgI
ohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn
[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0
ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ
]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003
ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@00
00?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI
00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn
[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1
ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`
f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7o
QK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j
0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Ooj
n_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1
oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomloooo
o`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogco
oooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3ooooooooooooo
O?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooo
oomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooooooo
ooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3ooooo
ooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oo
oooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0
ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNb
f`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWo
Qk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]
fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3o
OZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe
`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?o
Z[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI0000
0onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT0
0003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]
f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7o
OZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I
0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5
/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1
ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[j
nP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7o
n_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo
0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?oo
ool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?ooooooooooooml
ooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooooooooooo
ogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3ooooooooo
ooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooo
oooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooo
ooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3o
ooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K
0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7
/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgI
ohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn
[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0
ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ
]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003
ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@00
00?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI
00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn
[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1
ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`
f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7o
QK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j
0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Ooj
n_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1
oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomloooo
o`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogco
oooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3ooooooooooooo
O?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooo
oomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooooooo
ooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3ooooo
ooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oo
oooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0
ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNb
f`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWo
Qk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]
fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3o
OZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe
`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?o
Z[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI0000
0onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT0
0003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]
f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7o
OZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I
0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5
/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1
ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[j
nP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7o
n_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo
0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?oo
ool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?ooooooooooooml
ooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooooooooooo
ogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3ooooooooo
ooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooo
oooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooo
ooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3o
ooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K
0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7
/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgI
ohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn
[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0
ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ
]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003
ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@00
00?oZ[G0ogj]fOn7/]/01Oooool00ooNg]kono_kooooo`04ooooo`03omkN
g_okno_ooooo00Cooooo00?og]kNoo_knoooool01?ooool00ooNg]kono_k
ooooo`04ooooo`03omkNg_okno_ooooo00Cooooo00?og]kNoo_knoooool0
1?ooool00ooNg]kono_kooooo`04ooooo`03omkNg_okno_ooooo00Cooooo
00?og]kNoo_knoooool01?ooool00ooNg]kono_kooooo`04ooooo`03omkN
g_okno_ooooo00Cooooo00?og]kNoo_knoooool01?ooool00ooNg]kono_k
ooooo`04ooooo`03omkNg_okno_ooooo0?oooooooooooolIooooo`7on_[j
0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/00oooool01Ooclo?ooooooa@D
5?oWinOolo?c00;ooooo00Golo?coooooolD51CoinOWoo?cl`02ooooo`05
oo?clooooooo51@DonOWiooclo<00_ooool01Ooclo?ooooooa@D5?oWinOo
lo?c00;ooooo00Golo?coooooolD51CoinOWoo?cl`02ooooo`05oo?clooo
oooo51@DonOWiooclo<00_ooool01Ooclo?ooooooa@D5?oWinOolo?c00;o
oooo00Golo?coooooolD51CoinOWoo?cl`02ooooo`05oo?clooooooo51@D
onOWiooclo<00_ooool01Ooclo?ooooooa@D5?oWinOolo?c00;ooooo00Go
lo?coooooolD51CoinOWoo?cl`02ooooo`05oo?clooooooo51@DonOWiooc
lo<00_ooool01Ooclo?ooooooa@D5?oWinOolo?c00;ooooo00Golo?coooo
oolD51CoinOWoo?cl`3ooooooooooooo6Oooool1oo[jnP7oQK3I0Omn[MT0
0003ojZe`?mn[MWoQk;K00?ooooo067o<c<cog9bL_lM7AgoRHV9oaPH6?o`
l?3ooooooc<c<ombLW;o7AdMohV9ROlH61Sol?3`oooooolc<c?oLW9boadM
7On9RHWo61PHoo3`l?oooooo<c<cog9bL_lM7AgoRHV9oaPH6?o`l?3ooooo
oc<c<ombLW;o7AdMohV9ROlH61Sol?3`oooooolc<c?oLW9boadM7On9RHWo
61PHoo3`l?oooooo<c<cog9bL_lM7AgoRHV9oaPH6?o`l?3ooooooc<c<omb
LW;o7AdMohV9ROlH61Sol?3`oooooolc<c?oLW9boadM7On9RHWo61PHoo3`
l?oooooo<c<cog9bL_lM7AgoRHV9oaPH6?o`l?3ooooooc<c<ombLW;o7AdM
ohV9ROlH61Sol?3`oooooolc<c?oLW9boadM7On9RHWo61PHoo3`l?oooooo
<c<cog9bL_lM7AgoRHV9oaPH6?o`l?3ooooooc<c<ombLW;o7AdMohV9ROlH
61Sol?3`0?oooooooooooolHooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0
ogj]fOn7/]/00oooool01OoalO7oB4Q8o`000?lX:2SogmoO00;ooooo00Go
lO7aodQ8B?l0003o:2PXomoOg`02ooooo`05oo7alOm8B4So0000obPX:?oO
gml00_ooool01OoalO7oB4Q8o`000?lX:2SogmoO00;ooooo00GolO7aodQ8
B?l0003o:2PXomoOg`02ooooo`05oo7alOm8B4So0000obPX:?oOgml00_oo
ool01OoalO7oB4Q8o`000?lX:2SogmoO00;ooooo00GolO7aodQ8B?l0003o
:2PXomoOg`02ooooo`05oo7alOm8B4So0000obPX:?oOgml00_ooool01Ooa
lO7oB4Q8o`000?lX:2SogmoO00;ooooo00GolO7aodQ8B?l0003o:2PXomoO
g`02ooooo`05oo7alOm8B4So0000obPX:?oOgml00_ooool01OoalO7oB4Q8
o`000?lX:2SogmoO00;ooooo00GolO7aodQ8B?l0003o:2PXomoOg`3ooooo
oooooooo6Oooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K00?o
oooo067oBDU9ocdm?OlF5QKoE5ADobLW9oo`l?3oooooodU9BOlm?Cgo5QHF
oeADE?lW9bOol?3`oooooom9BDWo?CdmoaHF5_mDE5Co9bLWoo3`l?oooooo
BDU9ocdm?OlF5QKoE5ADobLW9oo`l?3oooooodU9BOlm?Cgo5QHFoeADE?lW
9bOol?3`oooooom9BDWo?CdmoaHF5_mDE5Co9bLWoo3`l?ooooooBDU9ocdm
?OlF5QKoE5ADobLW9oo`l?3oooooodU9BOlm?Cgo5QHFoeADE?lW9bOol?3`
oooooom9BDWo?CdmoaHF5_mDE5Co9bLWoo3`l?ooooooBDU9ocdm?OlF5QKo
E5ADobLW9oo`l?3oooooodU9BOlm?Cgo5QHFoeADE?lW9bOol?3`oooooom9
BDWo?CdmoaHF5_mDE5Co9bLWoo3`l?ooooooBDU9ocdm?OlF5QKoE5ADobLW
9oo`l?3oooooodU9BOlm?Cgo5QHFoeADE?lW9bOol?3`0?oooooooooooolH
ooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/00oooool01Oo@
d=3ooOgmoaLG5oo/k>cocLg=00;ooooo00God=3@oogmoOlG5aOok>c/olg=
c@02ooooo`05om3@d?omoOgo5aLGonc/k?o=cLd00_ooool01Oo@d=3ooOgm
oaLG5oo/k>cocLg=00;ooooo00God=3@oogmoOlG5aOok>c/olg=c@02oooo
o`05om3@d?omoOgo5aLGonc/k?o=cLd00_ooool01Oo@d=3ooOgmoaLG5oo/
k>cocLg=00;ooooo00God=3@oogmoOlG5aOok>c/olg=c@02ooooo`05om3@
d?omoOgo5aLGonc/k?o=cLd00_ooool01Oo@d=3ooOgmoaLG5oo/k>cocLg=
00;ooooo00God=3@oogmoOlG5aOok>c/olg=c@02ooooo`05om3@d?omoOgo
5aLGonc/k?o=cLd00_ooool01Oo@d=3ooOgmoaLG5oo/k>cocLg=00;ooooo
00God=3@oogmoOlG5aOok>c/olg=c@3ooooooooooooo6Oooool1oo[jnP7o
QK3I0Omn[MT00003ojZe`?mn[MWoQk;K00Gooooo00?oYjNWooCdm?ooool0
1?ooool00onWYjOom?Cdooooo`04ooooo`03ojNWYoodm?Cooooo00Cooooo
00?oYjNWooCdm?ooool01?ooool00onWYjOom?Cdooooo`04ooooo`03ojNW
Yoodm?Cooooo00Cooooo00?oYjNWooCdm?ooool01?ooool00onWYjOom?Cd
ooooo`04ooooo`03ojNWYoodm?Cooooo00Cooooo00?oYjNWooCdm?ooool0
1?ooool00onWYjOom?Cdooooo`04ooooo`03ojNWYoodm?Cooooo00Cooooo
00?oYjNWooCdm?ooool01?ooool00onWYjOom?Cdooooo`3ooooooooooooo
6Oooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooo
oomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooooooo
ooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3ooooo
ooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oo
oooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0
ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNb
f`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWo
Qk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]
fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3o
OZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe
`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?o
Z[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI0000
0onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT0
0003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]
f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7o
OZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I
0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5
/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1
ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[j
nP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7o
n_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo
0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?oo
ool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?ooooooooooooml
ooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooooooooooo
ogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3ooooooooo
ooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooo
oooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooo
ooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3o
ooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K
0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7
/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgI
ohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn
[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0
ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ
]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003
ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@00
00?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI
00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn
[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1
ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`
f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7o
QK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j
0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Ooj
n_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1
oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomloooo
o`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogco
oooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3ooooooooooooo
O?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooo
oomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooooooo
ooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3ooooo
ooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oo
oooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0
ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNb
f`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWo
Qk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]
fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3o
OZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe
`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?o
Z[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI0000
0onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT0
0003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]
f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7o
OZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I
0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5
/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1
ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[j
nP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7o
n_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo
0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?oo
ool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?ooooooooooooml
ooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooooooooooo
ogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3ooooooooo
ooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooo
oooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooo
ooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3o
ooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K
0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7
/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgI
ohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn
[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0
ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ
]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003
ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1ogj]f@00
00?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI
00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn
[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j0On5/=T1
ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Oojn_X1ohF`
f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1oo[jnP7o
QK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomlooooo`7on_[j
0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogcooooo0Ooj
n_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3oooooooooooooO?ooool1
oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooooomloooo
o`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0ooooooooooooogco
oooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3ooooooooooooo
O?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oooooooooo
oomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0oooooooo
ooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNbf`3ooooo
ooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWoQk;K0?oo
oooooooooomlooooo`7on_[j0On5/=T1ogj]f@0000?oZ[G0ogj]fOn7/]/0
ooooooooooooogcooooo0Oojn_X1ohF`f@7oOZgI00000onZ]L3oOZgIohNb
f`3oooooooooooooO?ooool1oo[jnP7oQK3I0Omn[MT00003ojZe`?mn[MWo
Qk;K0?oooooooooooomlooooo`7omoOg0On5/=T1ogj]f@0000?oZ[G0ogj]
fOn7/]/0ooooooooooooogcooooo0OogmoL1ohF`f@7oOZgI00000onZ]L3o
OZgIohNbf`3oooooooooooooO?ooool1ooOgm`7oQK3I0Omn[MT00003ojZe
`?mn[MWoQk;K00Coooooooojn_[ooo[jnWCon_[j1?ooool1ooOgm`7oQK3I
0Omn[MT00003ojZe`?mn[MWoOZcI0?ooQ[7Joon6/MYmohJafP7oOZcI0Omn
[MT00003oi>NZOmn[MWoOZgI0?ooOZgIoomn[MUoogj]f@0000?oLXFHogV4
SomlQi80oomlQi;oogb7TWgoO8NB0OmiQ8l1ofiiQ000oomoOgmGogmoO`Oo
OWinoomoOglTogmoO`0000Cojn_[onKVi_oRh^;og]kN1?oMgMd2omkNgP;o
gMgM00?og]kNomcLg?oNg]h00ooMgMd0oooNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNgP003ooMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oLg=cogMgMom_Kf`02omcLg00comgMgOoMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kN00;og=cL00GofMWIomSHf?oGemOof=SHomWIfP02
omcLg01fomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMgP;ogMgM09kog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMgP?og]kN00?o
gMgMomkNg_oNg]h00ooMgMd1on7Qh@7oinOW0OoZj^X00003onc/k?oVi^Ko
h>3P00OofMWI00Cof=SHomKFe_oCdm?od=3@0oo=cLd01?o@d=3odm?ComOG
eooHf=P3omWIf@03omSHf?oIfMWofMWI00GofMWI00Cof=SHomOGeooCdm?o
d=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?C
om3@d0?ocLg=00Cod=3@om?CdooGemOof=SH0ooIfMT00ooHf=SofMWIomWI
f@3EomWIf@;of=SH00Koe]KFom?CdooCdm?oe=CDomOGeooHf=P2omWIf@03
omSHf?oIfMWofMWI00;of=SH2OoIfMT00ooHf=SofMWIomWIf@02omSHf003
omWIfOoHf=Sof=SH00;of=SH5ooIfMT01?oHf=Soe]KFom;Bd_o?cll2olg=
c@04olo?cooCdm?oemOGomSHf?oofMWI5_oIfMT00ooHf=SofMWIomWIf@06
omWIf@7og]kN0OoVi^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoP
h>3oh^;R00;ohN7Q00gogMgMomcLg?oCdm?oalO7ok^k^ona/K7o[Zj^ok:b
/_nj^[[oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?oalO7
ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00go
gmoOom_KfooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooK
fm_ogmoO0=[ohN7Q00Woh>3PomoOgooKfm_oe]KFomCDe?oFe]Kof][JomkN
g_oPh>001_oOgml3on3Ph003omoOgooPh>3oh>3P00;oh>3P2?oOgml2omkN
gP;ogmoO0ooPh>02omoOg`;oh>3P0_oOgml=on3Ph005omoOgooMgMgofMWI
omGEeOoCdm<00_oBd]800ooFe]Kog=cLon3Ph01^on7Qh@03on3Ph?oQhN7o
hN7Q00GohN7Q00?oh>3Pon7QhOoQhN40<_oQhN400ooPh>3ohN7Qon7Qh@1Y
on7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoShn<1onWYj@7okNg]00000oo`
l?3okno_oo7al@03oo3`l03oono_koo`l?3ok^k^onWYjOoKfm_o`L71ojBT
Y?n;Rh_oNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7a
onk^k_oalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2`_nTY:Co
S8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo3`l?o_
knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<
S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]kOoalNook^k^
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_000Koo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNook^k^ono_kooZj^[oinOW00;oh>3P00Oohn?Son_[jOo[jn_o
j^[ZonKVi_oXj>SoinOW00;ojNWY01;ok^k/onc/k?o/k>coj>SXonc/k?o]
kNgol?3`onc/k?oZj^Soi^KVonSXj?oWinOojNWYonSXj?o[jn_oinOWonOW
iOoUiND2onWYj@0?onk^k_o]kNgokNg]onSXj?o[jnWok>c/onk^k_oYjNWo
j^[Zon_[joo_knook>c/onc/j_oZj^[ok^k^00;ok>c/0?ooj^[Zono_koo/
k>cok>cZon[Zj_o^k^kok>c/ojn_[omfMWKoFEUIofi^K_ng]kKoh>3PonWY
jOo]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knl002golO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knl01?o`l?000003oo;bl_o^k^koinOW
00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;o
ADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@00ooUiNGoi>CTonGU
i002onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5
oe5ADOmVIVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT0>goiNGUonCTi?oUiNGo
i>CTonCThooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmA
DE7oIVIVohZ:R_na/K7odM7AomkNg_oTi>?oi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiN@00_oTi>@0D?o5
aLGo:2PXodA4A?n@T93odM7AomcLfooKfm_oemOGomCDe?oFe]Koe=CDomGE
eOoIfMWoh>3OomkNg_oJf][oe=CDomWIfOoNg]koh^;RomcLg?oGemKoe=CD
omKFe_oDe=CoeMGEomSHf?oKfm_oemOGomKFeOoEeMGoemOGomSHf?oNg]ko
gmoOomcLg?oEeMGoemOFomcLg?oMgMgoemOGomKFe_oKfm_ohN7QomkNg_oK
fm[of][JomkNg_oLg=cof][Jom_KfooPh>3ogmoOomcLfooIfMWog]kNomoO
gomdM7CoIfMWohf=SOmDE5Co20P8oj:RX_oLg=coh^;RonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGU0ooTi>@0WOoUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiND00ooTi>@0I?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>@4onGUi@06onCTi?oUiNGoiNGUonGUiOoXj>SokNg]0Oob
l_800003ooCdm?o]kNgoinOW00;oh>3P01?ohN7QomoOgooNg]kod];BokBd
]?n7QhOoG5aLofdk=OnNCT;ocFmOonV3Koo<KUkoWTi3ofdk=_mLG5coQhN7
okBd]?oBd];ogMgM00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m]H2co
WYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aLohN7Qond];Cod];BomkNgP05
on3Ph00AomkNg_oBd];o];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=
AomZWSCoBFX_oeaLG?n7QhOo];Bdom;Bd_oMgMd0fOoPh>001_oOgmooclo?
oiVIVOnBTY;o6ATIohb<S0;oeMGE01ooclo?ol;2`_o>c/koc/k>olG5aOo:
b/[of][JomSHf?o@d=3obl_;olo?cooHf=Sof][JomGEeOo?cloo`L71om3@
d?o>c/koa<C4ol_;booHf=SoemOGokjn__nk^k_odM7Aom3@d?oEeMGof=SH
om?Cdoo<c<coc/k>00;oeMGE00Goc/k>olc<c?oCdm?of][JomSHf002om;B
dP04omSHf?oGemOodM7Aom?Cd`;ofMWI00Kodm?Com7AdOoGemOof=SHom7A
dOo@d=02om7Ad@04odI6A_m1@D7oemOGomkNgW3oh>3P00?ogmoOon3Ph?oP
h>000_oPh>000ooOgmooh>3Pon3Ph02Mon3Ph003omoOgooPh>3ogmoO00;o
gmoO0ooPh>000ooQhN7oinOWonc/k001oo?cl`0000?om_Kfoo;bl_o[jn/0
0ooXj>P04ooWinOoh^;Rolg=cOnNWYkoJemOohle;Oo]LF7onIf@oofaYOom
_:oooKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;Rh_oWinL00ooXj>P0
4ooWinOoh^;Rolg=cOnOWiooKVIOoi=b8_o]dDConO=doogmSOomoIGooOf>
ooWhM_o]edOoTg<RofiWGonOWioocLg=on;Rh_oWinL00ooXj>P04ooWinOo
h^;Rolg=cOnOWiooH6QOod]l8onBhD_o_OUkom3mT_oHoI_oe?fEol3iO_nH
j4goCH0Tof1YGonOWioocLg=on;Rh_oWinL0f_oXj>P01?oVi^KohN7QoeeM
GOm=CDd2omgMg@0Ooe1@D?l71`Oo5ADEohB4Q?lF5QKo@d=3on;Rh_oMgMgo
W9bLo`000?n?ShoogMgMon7QhOoKfm_o@410o`P82?lI6AWoR8R8o`/;2omH
F5So]kNgo``<3?l71`Oo8b<SobLW9ommOGgof][JomgMgOoDe=Co2`/;oeUI
F@02omWIf@03oeeMGOl;2`_odm?C00;ogmoO00KoFUYJodi>C_oNg]kog]kN
ob<S8on4Q8@2on7Qh@0<ogYjN_l^;RkogMgMomgMgOo2`/;oD51@oc<c<om^
KVkoPh>3ob4Q8OoNg]koi^KVoooXj>POonSXj07ok>c/0Oobl_81ooKfmP00
00?omoOgooShn?ohn?P00oohn?P04oogmoOok^k^olk>c_n@T93oQBl[onUT
E_okTXOooZJKooj`Y?oo^:_oo[>VoojWW?okU8WokVQIohTa:on@T93oc/k>
onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93oVFT[oo2m?Ookh6ko
o_B2ooknR_oooi;oo_j<ookhPookiG3ol<8noiUZ:on@T93oc/k>onk^k_of
m_H00oohn?P04oogmoOok^k^olk>c_n@T93o@W<[ohC>@on]kg?o`_j8olkn
T?oFoiOod?jBolKnROnbmGCoR==3odAe:on@T93oc/k>onk^k_ogmoL0f_oh
n?P09Oofm_KolO7aoh61POlO7aookNg]olK6a_l0003o`l?3om?CdomLG5co
20P8on[Zj_o`l?3oj^[Zoe9BD_lD51Co?CdmonWYjOo`l?3o[jn_o`L71ooB
d];ocLg=odi>C_lK6a_ok^k^om_Kfon^[Zkoj>SXonc/k?n^[Zko0000okBd
]?o/k>co/;2`o`/;2olJ6QX00_oTi>@02olS8b?o3Ph>ojBTY?o]kNgok^k^
of1PH?mDE5Cok^k^ong]kOlV9RKoSHf=00;ol?3`00coPX:2oc4a<Oo/k>co
j^[Zod=3@ol_;booW9bLog=cLolZ:R[o6QXJonk^k_ofm_I^ooShn003ooOg
moohn?Son?Sh00Gon?Sh00?omoOgooShn?ohn?P0W_ohn?P00oogmoOon?Sh
ooShn002ooShn004ooOgmooinOWom_KfooOgm`7on?Sh00000oojn_[omOGe
onk^kP02onc/k03oon_[jooXj>SogmoOokZj^_miDU;o_c4SonMdJOomR7ko
oiR<oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c9?miDU;o^[ZjomoOgooZ
j^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3ooMYSoooZ
L_onlgkoooZ2ookfOoook7?oo]iToo[7DOoRTQcoRFICokVi^OoOgmooj^[Z
on_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]D_mAXacoTM9EojKWJ_nhnG[o
`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]D_nj^[[ogmoOon[Zj_o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/0019
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/onWYjOoUiNGoNWYjoa`L7?oQhN;oc<c<o`<3
0onPX:3og]kNoiBDU?lC4a?ohN7Qon3PhOo@d=3o1PH6oj6QXOl92@Wo_kno
on7QhOnj^[[o0P82ok:b/_oMgMgoP820obPX:?oShn?oinOWonGUiOoOgmoo
fm_Kom?Cdol820SoQHF5omoOgomYJFWoBTY:ocDe=On][Jgo_Kfmo`L71omh
N7SoEEEEomoOgooPh>3oFe]Koe1@D002on7Qh@0:ob@T9?n5QHGogmoOon7Q
hOmkNg_o;bl_on3Ph?oDe=Co1@D5ojRXZ0;ohn?S01CoOWiooaHF5_oQhN7o
j^[Zon_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k0?ojn_[09Ook>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/00;ojn_[00Cojn_/onc/k?o[jn_ok>c/0oo[jn/0H_o/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/1_o[jn/01Oo/k>cojn_[on_[joo^k^ko
m_Kf007onOWi00000ookno_olo?cong]k@02onGUi@3oonKVi_oTi>CofMWI
ok:b/_mh;Bgob48don=ZG?odNVgooHQloojGR_onVhkooYR;ooj:O_odNfgo
if]MolY2=?mk;Rko/K6aomSHf?oTi>CoiNGUonKVi_oUiNKoi>CTomSHf?nb
/[;oUUD^onZL:ook_4Coo/aCoogHH_onhg;oo^UeookVLoonffGooLaCoo_1
AOo^WR_oVEH^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGUonCTi?oHf=Wo/[:b
obiR;_mS[B_oQlY8oiOLFOnUiFWo/_=gokSfNondmGWoYnY[oiSLFOn9cd_o
Hjh[obiS;_na/K7of=SIonCTi?oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGV000donKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVon?ShooO
gmooMgMgoa/K6ooLg=cohN7QoijNW_l_;boo:b/[oc8b<_lB4Q;og=cLom[J
fon4Q8Co820Pon3Ph?mBDU;oJ6QXom[Jf_oNg]koT92@obXZ:_l^;Rko;2`/
obLW9`;og]kN01?ofMWIom?Ce?o@d=3oFe]Ko`000?nm_Kgof][JobPX:?n7
QhOoMgMhofQXJ?n2PX;o?3`lol;2`_l?3`ooe=CDom[Jf_mIFEWoCTi>00;o
g=cL07ko8b<Soh61POoEeMGoemOGogMgMol^;Rkog=cLoj>SXol0003oalO7
omSHf?oIfMWoSHf>oaDE5OoLg=cohn?SonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^H3onGUi@2TonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNH2onKViP03onGUiOoVi^Koi^KV00?oi^KV00?oiNGUong]kOoclo<00Ooj
n_X00003ooclo?ohn?SolO7a00?ok^k^01?oj^[Zon7QhOnl_;coNQLGol<o
<_oCETWoi6QJonmgK?ocPgSon8MlooF4N_ocNFgoiFUKomUHB_o4?c;oO1LG
okbl_?oPh>3ok>c/00?ok^k^01?ok>c/on7QhOnl_;coYDLGonJG<_oe[33o
oKa1oog9Doomd63onm=UoogBH?oncECooKe2ooZ_<_oYVc;oYDHGokbl_?oQ
hN7ojn_[00?ok^k^01?ok>c/on7QhOnl_;co5eTGoenX<_mf_COoQ/e7oiKF
F_nRh6GoXn1Yoj?QIonGfUcoQ/i7ogNo=omOZc;o5eTGokbl_?oQhN7ok>c/
0=[ok^k^02kok>c/onOWiomkNg_o71`LonCTi?oYjNWoi^KVon7QhOoNg]ko
SHf=oa@D5?oVi^Koi>CTocDe=OmiNGWojn_[ok:b/_lE5AGogmoOonKVi_oT
i>CohN7QomgMgOmjNW[o:BTYonSXj?oUiNGogMgMok6a/OlV9RKo2`/;oi^K
VooYjNWoc<c<o`000?o>c/ko`l?3obDU9Om;Bd_oO7alonSXj?la<C7oYJFU
onCTi?mMGEgoDE5A0_oWinL02_lU9BGoJFUYomoOgooOgmooMgMgoc4a<OoY
jNWo`L71o`000?nWYjL2omoOg`04oi>CTolF5QKoinOWonc/k:_ok^k^00?o
kNg]onk^k_o^k^h0Koo^k^h00oo]kNgol_;booShn001ooclo0000oomoOd0
5_olo?cooOgmoogmoOolo?colo?com7AdOmX1`Oo^3@dolLo<ooBD4?ofV9E
on=^H_oTLVCoi6mRomaTEooCDD?oc44dokTd=?m[1`Ood];Boo?cloolo?`3
oogmo@0Cooclo?oclo?od];Boih[1ooJRSCoji/IooFX:Ooh]3oonKe:ooRo
COoj_d[onKPoooJZ:_o_WQWofh/doj8]1ooBd];olo?cooclo003oogmo@0C
ooclo?oclo?od];Bo`M01om=VSCoGj/Pog2h;omo`d?oR/e@ohg=D_n:cU3o
PLM4og6i;omR[R3oCY/do`M21ooBd];ol_;booclo03Joogmo@0Soo_knoog
moOoQ8B4oahN7_oclo?onOWiok>c/oo@d=3olo?cofQXJ?m7AdOon_[jomCD
e?l0003ogMgMooclo?okno_o9bLWojRXZ?oinOWoZj^[omGEeOoalO7oE5AD
oeiNG_oinOWom?CdoiBDU?l51@Go@410om7AdOogmoOon?ShoiNGUol[:b/0
0_ojn_X06olT92Co1`L7olS8b?okno_oQHF5of=SHoogmoOoHf=SoeMGEooh
n?SonOWiobLW9olE5AGoPh>3omOGeom2@T;oHf=Soo_knoojn_[o=3@dodU9
BOoKfm_oiNGUodm?ColG5aOon_[jooclo03ooogmoAcooOgm00?oo?cloogm
oOolo?`00oomoOd0000joogmoOojn_[olo?conk^k_o`l?3okno_ong]kOoY
jNWodm?Coe/M7OnR=3Co/bLLol4j;Oo7BCcoceI:om1GBoo@Ed[obTXnol<k
;_nf:1goXS@doe`M7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`koo^k^koj^[Z
om?Cdon<9Agob74domV47OoTU1GoiidTonjX<oo`ZSCokjXconbP9OoWUaGo
g8PMolQa=?n<9Agodm?Con[Zj_o^k^kol?3`ono_koo`l?3ok^k^on[ZjOoC
dm?o7CPMocB2=?m7UAgoFZDKofV]:P;oM;Ph0>;oMKThof^a:omKYacoB9XM
ocB2=?lM>1godm?Con[ZjOo^k^kol?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`0_o_knl0C_oZj^[o
OWinoa`L7?oXj>OokNg]ohR8R?l`<33o3`l?oc4a<Ona/K7ok^k^ohF5Q?m=
CDgokno_onk^k_o_knooRXZ:oeUIFOo^k^koN7Qhob/[:ol?3`oo>3Phokno
_oo]kNgoi>CTo`h>3_mYJFWogmoOon?ShooUiNGojn_[of5QHOmgMgOok^k^
ono_k_mfMWKo9RHVong]kOo_knooc<c<ob`/;?oZj^[oKFe/of9RH_o/k>co
kNg]oc/k>onCTi?oHV9Ro`h>3_ld=3Coa<C4ono_koo^k^kodM7Aoc`l??l:
2P[o9bLWofa/K?l/;2cokno_onk^k_o`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l0?okno_0?oo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`onk^
k_o`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?0000Gokno_oo3`l?o_knoo
l?3_ono_k`02oo3`l0Kokno_0Ooclo<1ooWin@7oo_kn00000oono_komoOg
oo3`l004onWYj@0AonOWiooJf][oHd];oh4b<_nV=CGo]S@]ol9=@Oo3E4Wo
a5E:ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooWinL01OoYjNT04OoW
inOofm_KohU;Bon_Bc;ocGLeomJ;;OoPW2koh:0bon6P=?oPX3;ogiX^omJ;
;Oo:MCGo[d/bohU;BooKfm_oinOW00GojNWY017oinOWom_Kfom;Bd_o<V0b
ocZ9=OmCVbgoJj/_og2]>?m_[S[oL:dhofZZ;omCVbgo>HPeoc9P<_m;Bd_o
fm_KonOWi`3KonWYj@06onSXj?oVi^KoNg]koa`L7?oTi>Coj>SX0_oYjNT0
0ooWinOojNWYonWYj@0;onWYj@0<onOWiooYjNWojNWYonSXj?oHf=So2PX:
ojj^[_oMgMgog]kNon3Ph?oUiNGoj>SX2?oYjNT01_oXj>Soi^KVon?ShooS
hn?oi^KVonSXj0?ojNWY00?oj>SXonWYjOoYjNT01?oYjNT00ooWinOojNWY
onWYj@3oonWYjA_ojNWY00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07om_Kf
0Oono_h00005ookno_ojn_[om?Cdono_kooalO400_o`l?004Oo_knoojn_[
oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZNW?oIW9coe9FEok]cLonEE5Co
Cb<SoiFDU?oZj^[okno_00Gol?3`013okno_on[Zj_nYU9CoPB<SokYZE?oD
VW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S8onZU9Coj^[Z0_o_
knl4oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCoLjEcoik6UOn/cYco[LjL
ojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Zj_o^k^h0foo`l?02ono_k`04
oh20P?lM7Agok^k^ono_ka?ol?3`0_o_knl01omTI6Co:BTYoh61POmSHf?o
>c/konk^k_o_knl02?o`l?001_o_knook^k^og=cLomYJFWok^k^ono_kooo
l?3`;Oo`l?001?oalO7ol?3`ooCdm?ojn_X1ooknoP0000Cok>k`oooooooo
ooooo_kn0_ooool2ooknoP0?oogmoOohn?SoKVi^oeXo?onaT93og/W9oo3T
i?oci^Kol>CTomk9bOnaT93oFSloofe]KOohn?Soo?cl00?ooooo0?ooo_kn
ooooo_ono_koooooooclo?ohn?SoSFe]ohXo?oo9TI3ojM39ooCYi?ofjnKo
m>WTonW@bOo9TI3oRCloohe]KOohn?Ooo?clooooooono_koooooookno_oo
ooooo_knooooo_olo?con?Shofe]KOlo?cooT9f@olWEbOoTk>Coi^kVonC/
i?o9eLWoT9f@oclo?om]KFgon?Shooclo?ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_h002Koooooookno_ooookoo_kn
ooooooono_kooooooogmoOo@d=3oYJFUooknoOono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_oooooooOgmol71`?maLG7oPH61ojn_
[`;oo_kn00coooooookno_ooookoo_knooooooono_koooooookno_oooooo
oOgmol;2`Onl_;`2ooknoP3oooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
oooo000Yookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_h00_ooool00oon
o_koooooooooo`03ooooo`7onO[k00001?o0algoo_knoo[jn_odm?@5oo7a
l@0=ono_kooFe]KoJf][od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<od<m?Om[
Jf_oe]KFono_k`09oo7al@0?ono_kooGe]KoPf][og@m?OneS8coeKZjon7<
c?oF^[[o]Xb<og8m?On1Jf_oemKFono_kooalO7ol?3`00OolO7a00gokno_
omKFe_m[Jf_o?Cdmohb<S?nj^[[oc<g<okZj^_n<S8co?Cdmof][JooFe]Ko
kno_0?oolO7a7?oalO400oo`l?3olO7aoo7al@3ooo7alAGolO7a00Col?3`
oo7alOoalO7ol?3`1?oalO400oodm?Con_[jooknoP01on_]kP0000GoPhnI
oogmoOohn?Sol?3`on_[j`03on[ZjP0=onWYjOoZj^[ojNWYonSXj?nKVi_o
FEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0;on[ZjP0;onWYjOoX
j>SoX9^KofYIFOm39RKo;@T9od8V9_mYFEWoX9^KonSXj?oYjNT02ooZj^X0
2ooYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY
00?oj^[Z00?ojNWYon[Zj_oZj^X0oooZj^XFon[ZjP03onWYjOoZj^[oj^[Z
0?ooj^[Z7OoZj^X01?o[jn_ol?3`ooShn?omoOd1om7Ee`0000Co=TI@okRo
aOojn_[om?Cd2?oalO42oo3`l0?okno_0_o`l?03oo7al@03oo3`l?oalO7o
lO7a00WolO7a0_o`l?03ono_k`;ol?3`1OoalO400oo`l?3olO7aoo7al@07
oo7al@;ol?3`0oo_knl2oo3`l?oolO7a8?oalO400oo`l?3olO7aoo7al@3o
oo7alAOolO7a00?ol?3`oo7alOoalO400_oalO400ooemOGonOWionc]k`01
oj:UZ00000?o7BlmodeHHoni_lH0ooooooooooooogcooooo0Oo]ko01ojf`
/`7oYJV]00001_lN;cgo6bPdoc8nB?mmR97o_L?7on_/k_oooooooooooomf
ooooo`05on[/kOnk_l;oNX67ob/e?OlB82X00OlD8bl00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[BoxData[{
    \(\(savedLayout = pane@getLayout[];\)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]\(pane@
          setLayout[\[IndentingNewLine]JavaNew["\<java.awt.GridLayout\>", 2, 
              3, 5, 5]\[IndentingNewLine]];\)\[IndentingNewLine]]\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(passwd = NewJPasswordField[pane]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JPasswordField"] \[RightGuillemet]\),
      JLink`Objects`JavaObject45318162874369]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(passwd@getText[]\)], "Input"],

Cell[BoxData[
    \("secretpassword"\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(DeleteJObject[pane, passwd]\)], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JTextArea <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soooooooooog[oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooooooooomjoooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?ooooooooooN_ooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P/oooo=lc<oooooooooooo5oooo`:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P/oooo=lc<oooooooooooo5oooo`:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P/oooo=lc<oooooooooooo5oooo`:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;Soool00006oooo00@0003ooooo
ooooool300001?ooo`050000oooooooooooo000000Coool300000oooo`03
0000oooooooo00;oool300000_ooo`03c<co0000c<co00G<c?l010000<c<
olc<o`0000C<c?l300001<c<o`050000c<coc<coc<co000000C<c?l30000
0lc<o`050000c<coc<coc<co000000?<c?l00`000<c<olc<o`0300000lc<
oooooooooooo5oooo`:8`;P1B9280@00000000J8`;S8h=R8`;R8`;Soool0
0006oooo00@0003oooooool00003oooo00D0003oooooooooool000000ooo
o`050000oooooooooooo000000?oool010000?ooooooo`0000?oool02000
0?ooooooooooo`000?ooolc<o`0000K<c?l010000<c<olc<o`0000?<c?l0
1@000<c<olc<olc<o`000003c<co00D0003<c?o<c?o<c?l000000lc<o`05
0000c<coc<coc<co000000;<c?l01@000<c<olc<olc<o`000002c<co00@0
003<c?o<c?l00003c<co00<0003<c?o<c?l0oooooooooolGoooo0XS0^058
T8P1000000001XS0^<SPf8S0^8S0^?ooo`0000Koool010000?ooooooo`00
00?oool02P000?ooooooo`000?ooo`000?ooo`000?ooo`0000;oool00`00
0?ooooooo`04oooo00<0003oooooool01Oooo`040000ooooc<co00001/c<
o`040000c<coc<co00000lc<o`030000c<coc<co00C<c?l01`000<c<o`00
0<c<o`000<c<o`000002c<co00D0003<c?o<c?o<c?l000000/c<o`050000
c<coc<coc<co000000;<c?l00`000<c<olc<o`04c<co00<0003<c?o<c?l0
oooooooooolGoooo0XS0^058T8P1000000001XS0^<SPf8S0^8S0^?ooo`00
00Koool010000?ooooooo`0000?oool02P000?ooooooo`000?ooo`000?oo
o`000?ooo`0000;oool500000_ooo`030000oooooooo00;oool300000_oo
o`03c<co0000c<co00G<c?l010000<c<olc<o`0000?<c?l500000/c<o`07
0000c<co0000c<co0000c<co000000;<c?l01@000<c<olc<olc<o`000002
c<co00@0003<c?o<c?o<c?l300001<c<o`<00003c<cooooooooooolGoooo
0XS0^058T8P1000000001HS0^<SPf8S0^8S0^?ooo`0400000oooo`040000
oooooooo00000oooo`0:0000oooooooo0000oooo0000oooo0000oooo0000
0_ooo`050000oooooooooooo000000;oool01@000?ooooooooooo`000005
oooo00?<c?l0000000000P0000?<c?l010000<c<olc<o`0000?<c?l01@00
0<c<olc<olc<o`000002c<co00L0003<c?l0003<c?l0003<c?l000000/c<
o`050000c<coc<coc<co000000;<c?l01`000<c<olc<olc<o`000<c<o`00
0003c<co00<0003<c?o<c?l01<c<oooooooooooo5oooo`:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;Soool00006oooo00@0003oooooool00003oooo
00<0003oool000000oooo`070000oooooooooooo0000oooo000000?oool0
0`000?ooooooo`0200000_ooo`080000oooooooooooo0000ooooc<co0000
1/c<o`030000c<coc<co00800002c<co00L0003<c?o<c?o<c?l0003<c?l0
00000lc<o`070000c<coc<coc<co0000c<co000000?<c?l00`000<c<olc<
o`0200000/c<o`040000c<coc<co00000/c<o`050000c<coc<coc<co0000
00;<c?oooooooooooaOoool2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
oooo00001_ooo`040000oooooooooooo0`0000;oool01@000?oooooooooo
o`000003oooo00<0003oooooool00`0000?oool00`000?ooo`000002oooo
0`0000;oool00lc<o`000<c<o`05c<co00H0003<c?o<c?l0003<c?l00002
c<co0`0000;<c?l01@000<c<olc<olc<o`000003c<co00<0003<c?o<c?l0
0`0000?<c?l01@000<c<o`000<c<o`000003c<co00<0003<c?o<c?l00`00
00?<c?oooooooooooaOoool2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
oooo00001_ooo`030000oooooooo027oool00lc<o`000<c<o`0Wc<co00<0
003<c?o<c?l02/c<oooooooooooo5oooo`:8`;P1B9280@00000000F8`;S8
h=R8`;R8`;Soool01@0000;oool00`000?ooooooo`0Qoooo00?<c?l00000
00000`0000;<c?l00`000<c<olc<o`0Oc<co00<0003<c?o<c?l02/c<oooo
oooooooo5oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P/oooo=lc<
oooooooooooo5oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P/oooo
=lc<oooooooooooo5oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P/
oooo=lc<oooooooooooo5oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P/oooo=lc<oooooooooooo5oooo`:8`;P1B9280@00000000>8`;S8h=R8
`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2h5P00P0<0
0H0200:000@00X400h400h400h4300B10P05P@0400F200J200J200J20P07
PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f4
0`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8F
Q`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<3
7HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd3
1BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6
;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHc
TP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9
BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd2
2e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;
FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<
H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]
47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<A
QJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d
4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLD
VkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[
_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1000
P003VjOa<d>U<d>U00Tc@jD600200`01P0800X001002P@03P@03P@03P@<0
184200F100@01H801X801X801X8200N200<11h81288128800P48P`<12H<3
0@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP82
4hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<3
6HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<
10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DY
SP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946
<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<3
1cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8
?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5
V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK
0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]E
WP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ
35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP02
3F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>
JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0ma
Z0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[
0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^
00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9
/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8C
Sk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<D
UkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PE
W[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk
0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^
_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P3002000NKYo7ooon>N[JVVlBcZM:XWLRc
ZM800ZJKa005_;SMk^kdj^Waoooo<d>U00D0080300600P02P00400:100>1
00>100>10`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP02
0@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@2
4HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<G
R0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;
0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>
00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_
T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87
=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8
?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9
A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK
0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]D
WP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP
00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R
3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>
JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X
3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ
0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<A
PJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`
0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[80
0a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<C
UKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL0
11FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj
0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]
_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C0
8000008H]<0@00000QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
002000BKYo7ooom/FZF_YLX2_;SM00[ooOncZM;ooooooonl^=fGR[bXWLSV
i^cooolc@jD400200`01P0800X001002P@03P@03P@03P@<0184200F100@0
1H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<1
2h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8D
Q`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT0
10<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<
12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?
1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHb
T@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`03
1cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8
@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI
2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`0
10YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]G
WP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aN
X@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=
I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]
YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mc
Z0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`4
47f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^
00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::
/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<C
T;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI
]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh
00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/3
5ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn
0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HB928B92800a8T8P0
0`000<SPf4R@R00=B92800@0000H]<0H]<38h=P>B92800<0000H]<0H]<00
0XS0^058T8P10000000018S0^<SPf8S0^8S0^08008002i^WlOooojRMb?oo
ok>YdV1<VXij]WQU[ZRMb?ooooomo`03oooo00<c@jD0080008000`00P0<0
0H0200:000@00X400h400h400h4300B10P05P@0400F200J200J200J20P07
PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f4
0`4>Q@<23hD20Q250oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB70`8E
Q`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<3
78X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd2
1BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5
;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86
<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@0
0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1
U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9
B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M
2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;
F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR
362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT
3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>
KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?
M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n
[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64
[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;40
11:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B
/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg
59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP
^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@F
Zk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG
/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H
00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00>VjOaoooooooofmc/H4bJ
ThFj/jWB_;SMH4bJVHnnYY_4b<?Ooooo<d>U1P00P0?oool200:000<00X7o
ooooool00_ooo`8018400`05POooo`05PP0300J21?ooo`030@R20@R3oooo
00?oool30@Z300Koool12h@12h@138Coool138@20@f400Coool13XGoool1
3XD20Pn500Coool248Goool248D20Q6600?oool24HH24XH00P8BQP824hH0
108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP3
6HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@S
S00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP03
1BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<943
1S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC
0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2
242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V003
2DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?
W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;
EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ
35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S
0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH3
3VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?
LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1k
Z`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<A
PZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::
/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk80
0Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD4
59Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PE
W[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW
^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^
_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`004b>3HR<2hR<2h
R<2h1P0000B8`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd
`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0`00P00>VjOaoooo_;SMVHnnooooe]7Mfmc/lokoYY_4k^kd
QGJ`ThFjoooo<d>U1000P007oooo006000600060oooo00:0oooo00<00h40
1_ooo`04P@04P@05POooo`05PP801X802?ooo`07PP07PP47P_ooo`48P_oo
o`48P`<12H<01?ooo`4:P`4:Poooo`812h@00`4<Q?ooo`4<Q0020@f400Co
ool13XGoool13XD20Pn500?oool248Goool00oooo`824HH30Q:60P8CQP04
0Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<I
R@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><
00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5
:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6
<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<3
1cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88
@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9
AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL
10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]F
WP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<
GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<3
3F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>
K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mb
Z0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[
0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62
[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa
4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P02
4hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@D
V;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN
^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk
0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn
00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000C8h=R8`;R8`;R8
`;P6000018S0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D0
0028`;R8`;Q8T8P000000QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P20000
0XS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0<008003i^WlOoooiV?_YN:_=CCj>n//omfNnjOZe]HYJJKa9JOdV1<V[bh
gOoooc=3Y@03002000Ooool00H000H000H3oool00X3oool00`03P@06oooo
00B100B1oooo00F1oooo0P06PP08oooo00N200N20@N2oooo0@R2oooo0@R3
0`49P`09oooo0@Z3oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?ooo`4>
QOooo`4>Q@823hD01?ooo`8@QOooo`8@Q@@24HH30Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@04
0aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`4
98d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5
:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A
00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7
>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9
AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN
2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ
0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X
3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@
OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh0
0a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@
/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf
0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<F
ZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003
B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P0
00000QRd`003b>3HR<2hR<2h00:8`;P200000XS0^0800003R<2h00A8T8P0
000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00:VjOa
ooooUhZlNVbZ/lOXZFjPb<?OThFjFdJCVHnn0WQU[P04@RN5[jG:oooo<d>U
1000P0<00H000oooo`02P002P@04oooo0P04P@03oooo00F1oooo00<01X84
oooo00<1288128<128<00`49P`09oooo0@Z3oooo0@^3oooo0@^4oooo0@b4
oooo00813H@01?ooo`4>QOooo`4>Q@823hD00oooo`8@QOooo`03oooo0P8A
QP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN8
0`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3
126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh0
0`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA
1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLe
TP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`Pm
U@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4
V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/3
2TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN
2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:00
10aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=
HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iY
Y@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?
LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X3
47V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61
[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;02
4XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P03
4hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E
]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`04
5Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X3
5ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm
00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<00
0lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8
`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00hS0^0@00004
R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0P00P003VjOaoooooooo00;oool02_n]/?mfNoW=e?g]k_ooojJKa8Ef/;bh
gOoooc=3Y@D00803006000?oool00X000X400`03P@03oooo00B1oooo0080
1H401005P_ooo`06PP06PP801h800`47P_ooo`48PP020@R30oooo`812X<0
1oooo`4;Poooo`4;Q?ooo`4<Q?ooo`020@f400Coool13XGoooooool20Pn5
00Koool248Goool248D24HKoool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<3
6hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=
12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5
:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9
AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YA
W@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]G
W`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW
3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mc
Z@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@
OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hA
Q:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H0
11BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ
_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P03
5k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R000
0<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H
]<000lSPf8S0^8S0^004R<2h0P0000F8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3002000ZQ[?;icMCR9Scd]KoR9Scd
KGglhnWoooomkNko[K02oooo00<c@jD0080008001000P0<00H000oooo`02
P002P@03oooo0P04P@05oooo00F100F100F2oooo00801X83oooo0P48PP03
0@R3oooo0@V300812H<20@Z300Coool12h<12hCoool20@b400Ooool13H@1
3HCoool13XGoool13XD00_ooo`030Pn50Q250Q2500Coool0108AQP8BQP8B
QP8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP3
0aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<4
8H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP03
1BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46
<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB
0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE
10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH
2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:
CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;
E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX004
35bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeR
XPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU
0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0ma
Z0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@
NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]
4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08B
RK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<C
S[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe
0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@E
WKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<F
YKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd0
0aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003
b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0
^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^003R<2h100000B8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
002000fKYo7mkNkR9ScnmOSgRIOdHVkcX:kdHVkooOoo[K3lhnWooolc@jD0
1`00P0<00H000oooo`02P002P@0300>10`04P@801H401005PP06PP06PP06
PP801h801@47PP48PP48P_ooo`48P`030@V30`4:P`030@^30@^40@^400<1
38@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L3
0QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^9
0`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@U
S@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?
10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHc
TPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0Lh
U0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G
246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI
0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:
DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil0
0`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<
Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=
IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^
Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT0
10mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/
47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_
4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:<
/@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`03
4i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@D
V[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i
5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`0
11J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa
_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038
h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C0
00?8h=R8`;R8`;P00XS0^0800002R<2h0P0000>8`;P014R@R00001Rd`1Rd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7fb<cR9S`0
0_n]/007gb@^ojBNm[c5ojf`kW^<oooo<d>U00P00803006000?oool00X00
0X400`03P@<0184200F100@01H801X801X801X8200N200D11h81288128;o
ool128<00`49P`04oooo0@Z30@Z30@^30P4;Q0<138@30@f40`4>Q@<23hD3
0Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN8
0aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@O
R`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd5
9hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_
T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`Ld
TPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD3
23bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3
V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;
VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@03
2eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aK
X08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R
00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@3
3FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W
00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mg
ZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<A
P:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7
/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb
0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@3
4iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg
0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS
^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G
[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc
_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0T00002R<2h
00E8T8P0000H]<0H]<38h=P00hS0^0800004R<2h0P0000:8`;P014R@R000
01Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7i
cMCgRIL00_ooo`07ojf`hAHdogIkojBNhRHlohUo<d>U00P00803006000?o
ool00X000X400`03P@<0184200F100@01H801X801X801X8200N200@11h81
2881288128<4oooo0`4:P`030@^30@^40@^400<138@20@f400Coool13XD1
3XD13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`82
5XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X3
0af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=
0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l3
1Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86
<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`Li
U0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8
@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T3
2DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M
0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l4
2eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R
362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT
00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>
KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T3
3gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n
[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`03
4HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:<
/Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B
]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g
59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@04
5J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`F
ZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG
/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8
`;P900000XS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000NKYo7oooocX:kd
HVkoooogRIOicM@00_ooo`03lj2^oooo<d>U00P0080300600P02P00400:1
00>100>100>10`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48
PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@
Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<G
R0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3
122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>
1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i00
10H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987
=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`Pl
U@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9
A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX3
2TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]D
W@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj02
35bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP03
3F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eX
Y@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`04
3g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX3
47RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]
00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk03
4XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8B
S[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D
]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8D
WKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX3
5JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm
0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl2
6;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd
`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0`00P00;VjOaooooohUooooolj2^lI>Qoooooogolj2^oo_l
<d>U00P0080300600P02P00400:100>100>100>10`04P@801H401005PP06
PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;
Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB7
0QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ9
0`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d4
98d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl0
0`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6
<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7
>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1
U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT0
10U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L
2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO
2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaO
X@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`03
3FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>
KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y
3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0
111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64
[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;
/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<C
TK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ
]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP
^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`4
5ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n
00<G/KhG/KlG/Kl00aNb_`<G/kl26;C03lSPf0030000b>3Hb>3H00g8h=P0
0`0001Rd`1Rd`00?b>3H00<0000H]<0H]<000XS0^058T8P10000000018S0
^<SPf8S0^8S0^0@00803VjOa00KoooocX:kd]Kof_<GkfMXc@jD900200`01
P0800X001002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N2
00<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@3
0@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ7
00@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<M
RP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<5
9Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]
T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B
0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@3
1cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G
0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9
VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;
DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]I
W`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaP
XPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY003
3FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW
0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`me
Z@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@
Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65
[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8B
SK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@C
T[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK
]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ
^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m
5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o
00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PF0020
0`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X801X801X82
00N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<1
3H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL2
0QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:
0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDU
S@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?
0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B
1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7
>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL3
24:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI
0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YB
W@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO
10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaP
XPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eU
Y0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW
3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY
0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@
OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l0
0a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@B
S;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<C
T[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK
]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T0
11FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l
5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o
5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0
^?n8`;QmR<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058
T8P1000000000hS0^<SPf<SPf03ob>3HolSPf7g8h=P1B9280@000000ohS0
^?n8`;R1R<2h0@000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l7?ol?3`00?ofMWIooooooooool03?ooool0
0?ool?3`ooo`l?1coo3`l004omWIfOooooooooooonGUi@?ooooo00GoiNGU
ooooooooooooooooonGUi@03ooooo`00ooo`l?3ooo3`l7?ol?3`00gofMWI
oooooooJf][oSHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgo
iNGU00;ooooo003ooo3`l?ool?3`Loo`l?003_oIfMWooooooooooooJf][o
SHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU0Oooool0
0?ool?3`ooo`l?1coo3`l00=omWIfOoooooooooooooooooJf][oSHf=onGU
iOoooooof][Johf=SOoUiNGoooooom[JfP02ooooo`00ooo`l?3ooo3`l7?o
l?3`00?ofMWIooooooooool00_ooool01ooJf][oSHf=onGUiOoooooof][J
ohf=SOoUiND00oooool00?ool?3`ooo`l?1coo3`l003omWIfOoooooooooo
00?ooooo00Oof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003o
oo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`04ooooo`07om[Jf_n=SHgo
iNGUoooooooLg=coSHf=onGUi@01ooooo`00ooo`l?3ooo3`l7?ol?3`00?o
fMWIooooooooool01Oooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo
003ooo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`06ooooo`03omcLg?n=
SHgoiNGU00?ooooo003ooo3`l?ool?3`Loo`l?000ooIfMWoooooooooo`07
ooooo`03omcLg?n=SHgoiNGU00;ooooo003ooo3`l?ool?3`Loo`l?000ooI
fMWoooooooooo`08ooooo`03omcLg?n=SHgoiNGU007ooooo003ooo3`l?oo
l?3`Loo`l?000ooIfMWoooooooooo`09ooooo`7og=cL0Oooool1ooooo`00
ooo`l?3ooo3`l7?ol?3`00?ofMWIooooooooool03?ooool00?ool?3`ooo`
l?1coo3`l0oofMWI003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00
oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2
ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooo
oooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool0
0?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooooooo
P_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooo
ooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo
003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooo
oh;ooooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooo
oooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooooon2oooo
o`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oooooooooo
oon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_ooool00?oo
oooooooooon2ooooo`00oooooooooooooh;ooooo003oooooooooooooP_oo
ool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003ooooooooo
ooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;ooooo003o
ooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooooooooh;o
oooo003oooooooooooooP_ooool00?oooooooooooon2ooooo`00oooooooo
oooooh;ooooo000aoooood3o`/;2oooooooooooooa7ooooo000aoooood3o
`/;2oooooooooooooa7ooooo000aoooood3o`/;2oooooooooooooa7ooooo
000aoooood3o`/;2oooooooooooooa7ooooo000@ooooo`03oogmoOoNg]ko
n?Sh00cooooo00?oj^[Zoo?cloooool02_ooool00oomoOgoh>3Poogmo@02
oooooaSo`/;200?o/[:bokRh^?o2`/802_o2`/800oo0`<3oZ:RXokbl_00B
ol;2`P03ol30`?nZZZ[o`<3000?o`/;2oooooooooooooa7ooooo00000ooo
ooooE5ADogalO006ooooo`04ojZZZ_l51@Go5aLGodE5A@;ooooo00Go/k>c
oa<C4olU9BGo20P8ohb<S002ooooo`0@oaXJ6_nPX:3oooooomWIfOl0003o
i^KVooooooo/k>co>c/kob@T9?lU9BGo>3PholS8b?ooooooMgMgog9bLPCo
oooo00[ooOgmocdm?OlV9RKo>c/kobHV9_m`L73ooooool;2`_lo?cooGUiN
1_o2`/801?n@T93o0P82oa4A4Om>CTh2ol;2`P03oeYJF_mFEUKo`/;200Co
`/;201?o/k>cob`/;?lK6a_o71`LobXZ:_nHV9So`/;2oa<C4omiNGWo`/;2
ojFUYOl0003o[Zj^ol;2`_n8R8So3Ph>oa`L7?l61PKoJVYZ00;o`/;200?o
FUYJoeIFE_o2`/801?o2`/803?lV9RKoRHV9ol;2`_n^[Zko5aLGoeiNG_o0
`<3o;Rh^oa`L7?l/;2co71`LoeEEE@;o`/;2oooooooooooooa7ooooo0000
0oooooooE5ADogalO006ooooo`03ojZZZ_ln?Skooooo00;ooooo017oinOW
o``<3?n[Zj_oooooomCDe?l;2`_o`<30ono_kol51@GoGUiNoooooon=SHgo
1PH6okfm_OooooooA4A4ogIfMP02ooooo`05om?CdooNg]koooooogMgMomb
LW801?ooool02_ono_ko^KViookno_oooooomoOgoa0@4?oFe]Ko`/;2oclo
?omNGUh6ol;2`P03oi2@T?lP823o`/;200?o`/;200?oFUYJoeIFE_o2`/80
1?o2`/805olc<c?oFEUIol;2`_o2`/;oX:2PojRXZ?ne]KGo0`<3odM7Aoo2
`/;oJf][o`@41?n?Shoo[jn_o`T92On2PX;o`/;2oj6QXOl820SoTY:Bol;2
`_mJFU[oEUIF00Go`/;200ko9RHVohV9ROne]KGo8R8Rodi>C_o2`/;o`L71
ohb<S?o1`L7o`/;2ok^k^ol<30coXZ:Rol;2`_oooooooooooolAooooo`00
00?ooooooeADE?mlO7`01_ooool00onZZZ[o?Shnooooo`02ooooo`03oj6Q
XOlH61Sooooo00;ooooo00coBd];ofe]KOo6a/Ko>c/kobl_;ooooooo@410
oe=CDonCTi?okno_o`<30oo]kNd5ooooo`03ogMgMombLW;ooooo00Kooooo
00OoeMGEof5QHOl=3@gol?3`ol;2`_lo?cooGUiN00Ko`/;200?oT92@ob0P
8?o2`/800oo2`/800omJFU[oEUIFol;2`P03ol;2`P03okFe]Ol20P;o];Bd
00Co`/;200WoUYJFob`/;?lS8b?o`/;2oc0`<?lo?cooKfm_ogYjN_lB4Q80
0oo2`/801Oli>CWoDU9Bol;2`_mJFU[oEUIF00Go`/;200Go9RHVoh>3Pol^
;Rko?clool30`004ol;2`P05oj:RX_m9BDWo2@T9okJf]_o2`/80oooooooo
oooooa7ooooo00000oooooooE5ADogalO006ooooo`03ojZZZ_ln?Skooooo
00;ooooo00?oSXj>ocTi>Oooool00_ooool02om/K6coFUYJoibLW?mUIFGo
DE5Aol[:b_l>3Pko^[ZjofYZJ_oEeMGo0@4100?o;bl_00Go7QhNoinOWooo
ooooMgMgofi^KP05ooooo`09omSHf?m3@d?o2`/;of=SHooShn?ooooool;2
`_lo?cooGUiN00Ko`/;200?oT92@ob0P8?o2`/800oo2`/800omJFU[oDe=C
ol;2`P03ol;2`P03oj:RX_l0003o8b<S00;o8b<S00_o5QHFogQhN?mfMWKo
C4a<ocdm?OnIVIWo2PX:ohf=SOm@D53oK6a/ob/[:`03ol;2`P05oe9BD_m4
A4Co`/;2oeYJF_mCDe<01Oo2`/801?lV9RKo;bl_o``<3?ng]kL3ol;2`P05
ojBTY?lb<S;o20P8od];Bon/[:`00_o2`/;ooooooooooooo4Oooool00003
oooooomDE5Co5QHF00;o;bl_00Ko=SHfooooooooooooooooojZZZ_ln?Sh3
ooooo`03okVi^Ol51@Gol_;b00;ooooo00co:b/[ohJ6Q_mcLg?oS8b<oiBD
U?m;Bd_oC4a<on_[jom0@43ooOgmo`h>3_nh^;P2ooooo`0=ob0P8?nb/[;o
ooooogMgMol=3@goemOGoooooomcLg?o/K6aoooooom;Bd_oF5QHonk^kP03
ooooo`03ol;2`_lo?coo410@00;o8b<S00Ko:BTYol;2`_o2`/;o`/;2oi2@
T?lP8204ol;2`P09oeYJF_l92@WoXj>Sol;2`_mGEeOoQXJ6ol30`?l:2P[o
Rh^;00;o`/;200Go61PHohN7QomGEeOoJVYZog1`L002ocTi>@05ok:b/_l`
<33oS8b<o`<30onh^;P00_o2`/803olP823oIFEUol;2`_mJFU[o2@T9oj>S
Xoo2`/;oEeMGohJ6Q_o2`/;o9RHVohF5QOm0@43o=3@dokZj^P02ol;2`P03
ocTi>Om2@T;o]KFe00Co`/;2oooooooooooooa7ooooo00000oooooooE5AD
og5aL@02onSXj006onWYjOoooooooooooooooonZZZ[o?Shn0oooool09_on
o_ko?Cdmod=3@on`/;3oHF5QoaXJ6_o^k^koBDU9okBd]?oGemOo0P82oiRH
V?oooooo:RXZoooooonKVi_o:2PXoj^[ZomlO7co6QXJooKfm_ooooooMgMg
odY:B_ld=3CoT92@ocXj>_nOWiooooooogEeMOm;Bd_o_knoojj^[_nKVi_o
oooool;2`_lo?cooEEEE0_n`/;001_na/K7o`/;2okfm_OmlO7coG5aLob0P
80Co`/;202ooFUYJocPh>?lW9bOoKFe]ob`/;?mhN7So`/;2ogEeMOlN7Qko
PX:2oeiNG_lC4a?o^k^kocLg=on8R8SoXj>So`410OmcLg?o`/;2oalO7oo1
`L7o;Rh^oc8b<_n5QHGoBDU9oa<C4one]KGo`/;2oeYJF_lh>3So9bLWofe]
KOl/;2coN7Qhol;2`_lV9RKoRHV9okno_om6ATKo;bl_okRh^?o2`/;oFEUI
ocTi>OnATI7oQ8B4ogEeM@02ol;2`_oooooooooooolAooooo`0000?ooooo
oeADE?mlO7`01_ooool00onZZZ[o?Shnooooo`03ooooo`0CooKfm_n4Q8Co
De=Cog=cLooWinOooooooh^;RooWinOoooooog]kNooWinOooooooi2@T?ol
o?cooooook>c/omRHV;oIVIVomcLg002ooooo`0@okFe]Onb/[;ofMWIogIf
M_mDE5Cob<S8oooooooalO7oW9bLoeaLG?mPH63oW9bLooooooo2`/;o?clo
oeiNGPCo`/;200Co^[ZjoeQHF?mHF5SoJFUY1?o2`/801_n9RHWoQhN7ojFU
YOmIFEWo?clooiRHV0;o`/;201;oR8R8odY:B_m=CDgoYjNWol;2`_mYJFWo
[jn_ol;2`_mMGEgo[jn_ol;2`_m]KFgo_knook^k^omTI6Co?clooeMGEon_
[jl2ol;2`P0CohV9ROn7QhOoYJFUoeUIFOlo?cooV9RHol;2`_lV9RKoRHV9
ol;2`_o0`<3oJFUYoh:2P_o2`/;o]kNgogIfM_m5ADGoBDU9ogIfMP02ol;2
`_oooooooooooolAooooo`0000?ooooooeADE?mlO7`01_ooool00onZZZ[o
?Shnooooo`0Uooooo`03ol;2`_lo?cooGUiN02oo`/;200?o9RHVohV9ROo2
`/802oo2`/;ooooooooooooo4Oooool00003oooooomDE5Co5QHF00?o;Rh^
00Go^k^komgMgOn;Rh_oG5aLochn?P0Vooooo`03ol;2`_lo?coo410@00?o
8R8R00GoSXj>ol;2`_o2`/;oV9RHod92@P0Wol;2`P03obHV9_n9RHWo`/;2
00_o`/;2oooooooooooooa7ooooo00000oooooookno_onOWi`03onOWi`05
ooShn?oMgMgoRXZ:ohZ:R_nWYjL09_ooool00oo2`/;o]KFeojn_[`03ojn_
[`05okbl_?o2`/;o`/;2ojNWYomUIFD09oo2`/800omkNg_oZ:RXol;2`P0;
ol;2`_oooooooooooolAooooo`00<Ooooom0ol;2`_oooooooooooolAoooo
o`00<Ooooom0ol;2`_oooooooooooolAooooo`00oomoOgmGogmoO`OoOWin
oomoOglTogmoO`0000Cojn_[onKVi_oRh^;og]kN1?oMgMd2omkNgP;ogMgM
00?og]kNomcLg?oNg]h00ooMgMd0oooNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNgP003ooMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oLg=cogMgMom_Kf`02omcLg00comgMgOoMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kN00;og=cL00GofMWIomSHf?oGemOof=SHomWIfP02omcL
g01fomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMgP;ogMgM09kog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMgP?og]kN00?ogMgM
omkNg_oNg]h00ooMgMd1on7Qh@7oinOW0OoZj^X00003onc/k?oVi^Koh>3P
00OofMWI00Cof=SHomKFe_oCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooH
f=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOo
f=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOG
omSHf=_ofMWI0_oHf=P01_oFe]Kodm?Com?CdooDe=CoemOGomSHf0;ofMWI
00?of=SHomWIfOoIfMT00_oHf=P9omWIf@03omSHf?oIfMWofMWI00;of=SH
00?ofMWIomSHf?oHf=P00_oHf=PGomWIf@04omSHf?oFe]Kod];Bolo?c`;o
cLg=00Coclo?om?CdooGemOof=SHoooIfMTFomWIf@03omSHf?oIfMWofMWI
00KofMWI0OoNg]h1onKViP7ok>c/00001oo^k^kojNWYonCTi?oPh>3ohN7Q
on3Ph?oRh^800_oQhN403OoMgMgog=cLom?Cdoo7alOo^k^kok6a/On^[Zko
/[:bokZj^_o7alOodm?Com_KfooOgml02OoQhN403OoOgmoofm_Kom?Cdoo7
alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml02OoQhN40
3OoOgmoofm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?C
om_KfooOgml0f_oQhN402OoPh>3ogmoOom_KfooFe]Koe=CDomKFe_oJf][o
g]kNon3Ph006omoOg`?oh>3P00?ogmoOon3Ph?oPh>000_oPh>08omoOg`;o
g]kN0_oOgml3on3Ph0;ogmoO0_oPh>02omoOg`goh>3P00GogmoOomgMgOoI
fMWoeMGEom?Cd`02om;BdP03omKFe_oLg=coh>3P06kohN7Q00?oh>3Pon7Q
hOoQhN401OoQhN400ooPh>3ohN7Qon7Qh@0bon7Qh@03on3Ph?oQhN7ohN7Q
06WohN7Q00?oh^;Ron7QhOoRh^801?oQhN41on?Sh`7ojNWY0Oo]kNd00003
oo3`l?o_knoolO7a00?ol?3`0?ookno_oo3`l?o^k^kojNWYom_Kfoo1`L7o
Y:BToh^;RomkNg_oMgMgog]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBT
Y?n<S8_oNg]kogMgMomkNg_oS8b<ojBTY?o2`/;of][Jon[Zj?o]kNgolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ong]kOoZj^[of][Jol;2`_nTY:Co
S8b<og]kNomgMgKoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knl001_olO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo^k^kokno_on[Zj_oWinL00_oPh>001ooShn?ojn_Yon_[
jooZj^[oi^KVonSXj?oWinL00_oYjNT04_o^k^cok>c/onc/k?oXj>Sok>c/
ong]kOo`l?3ok>c/on[Zj?oVi^Koj>SXonOWiooYjNWoj>SXon_[jooWinOo
inOUonGUi@;ojNWY00ook^k^ong]kOo]kNgoj>SXon_[jOo/k>cok^k^onWY
jOoZj^[ojn_[ono_koo/k>cok>cZon[Zj_o^k^h00_o/k>`0oooZj^[okno_
onc/k?o/k>[oj^[Zonk^k_o/k>co[jn_ogIfM_mIFEWoKVi^okNg]_oPh>3o
jNWYong]kOoalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_k`00;OoalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNool?3`ono_
koo`l?3okno_oo3`l?o_knool?3`ono_k`04oo3`l00000?ol_;bonk^k_oW
inL01?oUiND04?oTi>CogmoOom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92
@_m5ADGoDE5AofIVI_n:RXWo/K6aom7AdOoNg]h2onCTi003onGUiOoTi>Co
iNGT00;oi>CT00oog]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5
ADGoDE5AofIVI_n:RX[o/K6aom7Ad?oNg]h00_oTi>@0kOoUiNGoi>CTonGU
iOoTi>Coi>CSomkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5
oe5ADOmVIVKoRXZ:ok6a/OoAdM7og]kNonCThooTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi002onCTi01@
olG5aOlX:2SoA4A4oi2@T?oAdM7og=cKom_KfooGemOoe=CDomKFe_oDe=Co
eMGEomWIfOoPh=oog]kNom[Jf_oDe=CofMWIomkNg_oRh^;og=cLomOGe_oD
e=Coe]KFomCDe?oEeMGof=SHom_KfooGemOoe]KEomGEeOoGemOof=SHomkN
g_oOgmoog=cLomGEeOoGemKog=cLomgMgOoGemOoe]KFom_KfooQhN7og]kN
om_Kf_oJf][og]kNomcLg?oJf][ofm_Kon3Ph?oOgmoog=cKomWIfOoNg]ko
gmoOogAdM?mWIfOoSHf=oeADE?l820SoXZ:RomcLg?oRh^;oiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiND3onCTi02MonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUi@03onCTi01TonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi0CoiNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o]kNd1
oo;blP0000?om?Cdong]kOoWinL00_oPh>004ooQhN7ogmoOomkNg_oBd];o
];BdohN7QomLG5coKC/eoii>@_o=KeoojH=_ola^G_nNCT?oKC/foeaLG?n7
QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLofeP
;?nNURkocLdoonWYCOo=cCooWYX_ofeS;OmLG5coQhN7okBd]?oBd];og]kN
00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m7IbkoJ9hcoi7=AonZjEGo
TLe7ofZN=?m9JRooG5aLohN7Qond];Cod];BomkNgP3Ion3Ph006omoOgoo?
clooVIVIoi:BT_lI6AWoS8b<0_oEeMD07oo?cloo`/;2olk>c_o>c/koaLG5
ol[:b_oJf][of=SHom3@d?o;bl_oclo?omSHf?oJf][oeMGEolo?coo1`L7o
d=3@olk>c_o4a<Cobl_;omSHf?oGemOo_[jnok^k^ooAdM7od=3@omGEeOoH
f=Sodm?Colc<c?o>c/h00_oEeMD01Oo>c/koc<c<om?CdooJf][of=SH00;o
d];B00Cof=SHomOGeooAdM7odm?C0_oIfMT01_oCdm?odM7AomOGeooHf=So
dM7Aom3@d0;odM7A00CoATI6od51@OoGemOog]kNL?oPh>000ooOgmooh>3P
on3Ph002on3Ph003omoOgooPh>3oh>3P09goh>3P00?ogmoOon3Ph?oOgml0
0_oOgml3on3Ph003on7QhOoWinOok>c/007olo?c00000oofm_Kol_;bon_[
j`03onSXj00ConOWiooRh^;ocLg=oijNW_m[GeooScD]oneaHOoiWI3ooK6U
oofl[oom]:OonInConedHonB=booJemOoinOWoo=cLgoh^;RonOWi`03onSX
j00ConOWiooRh^;ocLg=oinOWom^IUooTg8RongAA?oilgCooOf=oogmUOom
oHkonOQfongGAonCLb;oKVMOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOW
iooRh^;ocLg=oinOWomPJ5ooBg`Soi;QBonmnG_od?fBomSmVooDoIGo`?Un
oiSXCOm=P2CoH6UOoinOWoo=cLgoh^;RonOWi`3JonSXj004onKVi_oQhN7o
GEeMode=C@;ogMgM01ooD51@o`L71olE5AGoQ8B4oaHF5_m3@d?oh^;RomgM
gOnLW9co0000ohn?SooMgMgohN7Qom_Kfom0@43o20P8oaTI6On8R8So2`/;
oeQHF?ng]kOo30`<o`L71olS8b?o9bLWogemOOoJf][ogMgMomCDe?l;2`_o
FEUI00;ofMWI00?oGEeMo`/;2ooCdm<00_oOgml01_mJFU[oCTi>omkNg_oN
g]ko8b<SohB4Q0;ohN7Q00coNWYjobh^;_oMgMgogMgMol;2`_m@D53o<c<c
ofi^K_n3Ph?o8B4QomkNg_oVi^KoonSXj1ooj>SX0Oo/k>`1oo;blP7om_Kf
00000oogmoOon?ShooShn003ooShn00CooOgmoo^k^koc/k>oi2@T?n5;b_o
jFAFoo^BQoonYY_oo[2ToonhZoon/jKooZNLoo^DROo^J5WoRC4[oi2@T?o>
c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_P
K_onm8;oo_j:ooooT_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^
ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSo
c_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^ooOgm`3J
ooShn00UooKfm_oalO7oPH61oalO7oo]kNgoa/K6o`000?o3`l?odm?CoeaL
G?l820Soj^[Zoo3`l?oZj^[oDU9Boa@D5?lm?CgojNWYoo3`l?n_[joo1`L7
om;Bd_o=cLgoCTi>oa/K6oo^k^kofm_Kojj^[_oXj>Sok>c/ojj^[_l0003o
];Bdonc/k?n`/;3o2`/;oaXJ6P02onCTi00;ob<S8ol>3PkoY:BTong]kOo^
k^koH61PoeADE?o^k^kokNg]obHV9_n=SHd00_o`l?003?n2PX;o<C4aonc/
k?oZj^[o@d=3obl_;onLW9coLg=cobXZ:_lJ6Q[ok^k^ooKfmVkon?Sh00?o
moOgooShn?ohn?P01Oohn?P00oogmoOon?ShooShn02NooShn003ooOgmooh
n?Son?Sh00;on?Sh00ComoOgooWinOofm_KomoOg0Oohn?P00003oo[jn_oe
mOGok^k^00;ok>c/0?oojn_[onWYjOoOgmoo^KViogUBD_no<B?oigAYoof8
O_ooV8cooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<TogUBD_nj^[[ogmoO
on[Zj_o[jn_ok>c/on_[k?oZj^[ogmoOokZj^_n8IE;ohY4LooW3D?omfV?o
onYbookcO_oonX;oo_Ioooo/LoongVCon/MAon:B7?n9IU?o^[ZjomoOgooZ
j^[ojn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S7?nAdUGoY^MZokSi
N_o0oX;oaon9ol?nQ?nioG_oYna/oiCFEomBYQcoDVeBokZj^_oOgmooj^[Z
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jn`0
04Wok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojNWYonGUiOmjNW[o71`Lon7Qh_o<c<co
0`<3oj2PX?oNg]koU9BDoa<C4ooQhN7oh>3Qom3@d?l61PKoXJ6Qo`T92Ono
_koohN7QokZj^_l20P;o/[:bomgMgOn0P83o:2PXon?ShooWinOoiNGUomoO
gooKfm_odm?Co`P82?n5QHGogmoOofUYJOm:BT[o=CDeojf][Onm_Kgo1`L7
ogQhN?mEEEGogmoOon3Ph?mKFe_oD51@00;ohN7Q00[o92@TohF5QOoOgmoo
hN7Qog]kNol_;booh>3PomCDe?l51@GoZ:RX0_oShn<05?mnOWoo5QHFon7Q
hOoZj^[ojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/0oo[jn/0Uoo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>`00_o[jn/01?o[jncok>c/on_[joo/k>`3on_[j`1Ronc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jn`6on_[j`05onc/k?o[jn_ojn_[onk^
k_ofm_H00OoinOT00003oo_knooclo?okNg]00;oiNGU0?ooi^KVonCTi?oI
fMWo/[:bogP];Oo8@SCohfYLooAjKOomR7cooYN:oojKS_onV8_ooXYnooAk
KOoWJegobT8dog/^;_nb/[;of=SHonCTi?oUiNGoi^KVonGUi_oTi>Cof=SH
ok:b/_nFEBkojY`[oo^lA?onc5?ooMQRookSL_onjGGoo^IcookKIOomc5?o
nl55onjN:onIERko/[:bomSHf?oTi>CoiNGUonKVi_oUiNGoi>CTomSHfOnb
/[;o;V8^of>]:on7bTSoUmaIojGUJOnblgOo^?IkokCeNOnWjV_oV=aIohW?
BomS[R_o;V<^ok:b/_oHf=Woi>CTonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNH003Coi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Kohn?S
omoOgomgMgOo6a/KomcLg?oQhN7oWYjNobl_;ol[:b_o<S8boa8B4_oLg=co
f][KohB4Q?lP823oh>3Poe9BD_mXJ6Sof][JomkNg_n@T93o:RXZobh^;_l/
;2co9bLW0_oNg]h04ooIfMWodm?Dom3@d?mKFe_o0000okfm_OoJf][o:2PX
ohN7QomgMgSoJ6QXoh:2P_ll?3co`/;2o`l?3ooDe=Cof][JoeUIFOm>CTh0
0_oLg=`0O_lS8b?oPH61omGEeOoGemOoMgMgobh^;_oLg=coXj>So`000?o7
alOof=SHomWIfOn=SHko5ADEomcLg?oShn?oiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKViP?oiNGU0:Coi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUiP;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGokNg]oo?cl`01
oo[jnP0000?oo?clooShn?oalO400oo^k^h04oo[jn_ohN7Qokbl_?mj5aOo
`clbom=FBOoTJ5[okgM/oo>3N?ohQgcomHAjoo=iKOoUJE_ofEQ:ol@o<_ml
5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?nUAaOoiYLbooF/
<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlbonVK<_nUAQOo_;bl
on7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOoGjPbogJm=on6cDOo
U]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lGFAOo_;blon7QhOo/
k>`0f_o^k^h0;_o/k>coinOWog]kNolL71coi>CTonWYjOoVi^KohN7QomkN
g_n=SHgo51@DonKVi_oTi>Co=CDeogUiNOo[jn_o/[:boaDE5OoOgmooi^KV
onCTi?oQhN7ogMgMogYjN_lY:BWoj>SXonGUiOoMgMgo/K6aobHV9_l;2`_o
Vi^KonWYjOo<c<co0000olk>c_o3`l?o9BDUod];BomlO7coj>SXoc4a<OnU
YJGoi>CToeeMGOmADE42onOWi`0:obDU9OmYJFWogmoOomoOgomgMgOo<C4a
onWYjOo1`L7o0000ojNWY`;ogmoO00CoTi>CoaHF5_oWinOok>c/Zoo^k^h0
0oo]kNgok^k^onk^kP1_onk^kP03ong]kOobl_;on?Sh007oo?cl0003oogm
o@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@@ooJ
HUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];olo?coocl
o0?ooOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWomJPYooRd?ooi_D[o
n;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?oo?cl00?ooOgm
01?oo?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:cE3oSLeBoh[>
D?n1adCoLKT_of:^8?m>VcCo1d87om;Bd_oclo?oo?cl0=[ooOgm02?ono_k
ooOgmon4Q8Co7QhNoo?clooinOWo/k>com3@d?oclo?oJ6QXodM7Aoojn_[o
e=CDo`000?oMgMgoo?cloo_knolW9bOoZ:RXooWinOn[Zj_oeMGEoo7alOmD
E5CoGUiNooWinOodm?CoU9BDo`D51Om0@43odM7AooOgmoohn?SoUiNGob/[
:`02oo[jnP0Kob@T9?l71`Oob<S8oo_knon5QHGoHf=SooOgmomSHf?oEeMG
ooShn?oinOWo9bLWoaDE5On3Ph?oemOGod92@_mSHf?ono_koo[jn_ld=3Co
BDU9om_KfooUiNGoCdm?oaLG5oojn_[oo?cl0?oooOgm7?omoOd00oolo?co
oOgmooclo003oogmo@0003[ooOgmoo[jn_oclo?ok^k^oo3`l?o_knook^k^
onWYjOoCdm?oFadMoj8d=?nc9aco`CX]olM9??o?ET[od5M;om1GB_o:BSko
`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_onk^k_oZ
j^[odm?Coh`U7Oo8LCCofH@MonBD5OoWWBCokZPcoo2Z=?o_ZS?ok:0UonNG
5OoLR1gob74doh`U7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`l?o^k^koj^[Y
om?CdolM>1go=88dodNE7OmJYA_oJJdZ0_md^3P0h_me^CSoJk4[oe^W7?m8
VQgo=88doadh7OoCdm?oj^[Yonk^k_o`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?02ono_k`1>on[Z
j_mnOWko71`LonSXioo]kNgoR8R8oc0`<?l?3`oo<C4aok6a/Oo^k^koQHF4
ode=COo_knook^k^ono_kon:RX[oFEUIonk^k_mhN7So:b/[o`l?3olh>3So
_knoong]kOoTi>Co3Ph>ofUYJOoOgmoohn?SonGUiOo[jn_oHF5QogMgMoo^
k^kokno^ogIfM_lV9RKokNg]ono_koo<c<co;2`/on[Zj_m]KFcoHV9Ronc/
k?o]kNgo>c/koi>CTomRHV;o3Ph>oc@d=?o4a<Cokno_onk^k_oAdM7o?3`l
o`X:2_lW9bOoK6a/ob`/;?o_knook^k^oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`0oo_knl0
ooo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
k^k^oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l0001Oo_knool?3`ono_
koo`l>ookno_00;ol?3`1_o_knl1oo?cl`7onOWi0Oono_h00003ookno_og
moOol?3`00CojNWY017oinOWom_KfomSBd_oPC8bojHe=Onf=2go`Te1ol=D
BOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mSBd_ofm_KonOWi`05onWYj@0A
onOWiooKfm_oRD];ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRko
eX/]olYe=On_Bc;oRD];om_KfooWinL01OoYjNT04OoWinOofm_Kod];Bolb
H3;o>XTeoe>K;Om[ZbooL:dhofn^>_m`[CSoJZX_oe>K;OliR3Go<V0bod];
BooKfm_oinOW0=_ojNWY00Koj>SXonKVi_mkNg_o71`LonCTi?oXj>P2onWY
j@03onOWiooYjNWojNWY00_ojNWY00coinOWonWYjOoYjNWoj>SXomSHf?l:
2P[o[Zj^omgMgOoNg]koh>3PonGUiOoXj>P8onWYj@06onSXj?oVi^Kohn?S
on?ShooVi^Koj>SX0ooYjNT00ooXj>SojNWYonWYj@04onWYj@03onOWiooY
jNWojNWY0?oojNWY6ooYjNT00ooXj>SojNWYonWYj@04onWYj@7ol?3`0Oof
m_H1ooknoP0000Goo_knoo[jn_odm?Cokno_oo7al@02oo3`l00Aono_koo[
jn_oUIBDodlS8onEE5Co^g=com>EUOoJW9cofYjLomVLW?oDUIGo^g=coiED
E?m?8b?oUIBDon[Zj_o_knl01Oo`l?004Oo_knooj^[ZojVDU?n18b?o^VYD
omBJLooT_9Goj/NLonW7W?oZaicoiKbEomBJLonkJUCoPB<SojZDU?oZj^[o
kno_00Gol?3`017okno_on[Zj_nDU9Co8bXSoeAjE?mcYG?oW/JEojc>W?n]
cYco[<jLoik6UOmcYG?oE7YDob<Z8onDU9Coj^[Zono_k`3Koo3`l0;okno_
00CoP820oadM7Oo^k^kokno_4oo`l?02ono_k`07ofATI?lY:BWoPH61of=S
Holk>c_ok^k^ono_k`08oo3`l006ono_koo^k^koLg=cofUYJOo^k^kokno_
ooo`l?0]oo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn00001?o/k_3ooooo
ooooooono_h2ooooo`;oo_kn0?oooOgmooShn?m^KVkoFSlook6@T?oNbLWo
l>CToo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?coooooookno_oo
ooooo_knooooo_ono_koooooooclo?ohn?SoSFe]ohXo?oo9TI3ojM39ooCY
i?ofjnKom>WTonW@bOo9TI3oRCloohe]KOohn?Ooo?clooooooono_kooooo
ookno_ooooooo_knooooo_olo?con?Shofe]KOlo?cooT9f@olWEbOoTk>Co
i^kVonC/i?o9eLWoT9f@oclo?om]KFgon?Shooclo?ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_h003Soooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_kooooooogmoOo@d=3oYJFUooknoOono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_oooooooOgmol71`?maLG7o
PH61ojn_[`;oo_kn00coooooookno_ooookoo_knooooooono_koooooookn
o_oooooooOgmol;2`Onl_;`2ooknoP3oooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_kooooo000Yookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_h00_oo
ool00oono_koooooooooo`03ooooo`7onO[k00001?o0algoo_knoo[jn_od
m?@5oo7al@0=ono_kooFe]KoJf][od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<
od<m?Om[Jf_oe]KFono_k`09oo7al@0=ono_kooGe]KoPf][og@m?OneS8co
eKZjon7<c?oF^[[o]Xb<og8m?On1Jf_oemKFono_k`09oo7al@0=ono_kooF
e]KoJf][ocdm?On<S8co^[Zjolc=c?nj^[[oS8b<ocdm?Om[Jf_oe]KFono_
k`3ooo7alAcolO7a00?ol?3`oo7alOoalO40oooalO4Eoo7al@04oo3`l?oa
lO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_ono_h00Oo[kNh00005oh>?VOom
oOgon?Shoo3`l?o[jn/00ooZj^X03OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUI
FOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT02ooZj^X02ooYjNWoj>SX
oj2KVomZFEWo@bHVobd92Om29RKoJEUIoj2KVooXj>SojNWY00_oj^[Z00_o
jNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@3o
on[ZjQcoj^[Z00?ojNWYon[Zj_oZj^X0oooZj^XMon[ZjP04on_[joo`l?3o
n?Shoogmo@7odMGG00001?lfAU3o^;o5oo[jn_odm?@8oo7al@;ol?3`0oo_
knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`
l?3ooo7alB3olO7a00?ol?3`oo7alOoalO40oooalO4Goo7al@03oo3`l?oa
lO7olO7a00;olO7a00?omOGeooWinOo/kNl00OnRYJP00003oad_?Om=F6?o
^Ko60?oooooooooooomlooooo`7okNo`0On]/;<1ojFY[@0000Ko7Rlmoa/X
=?lb?TSoOHRAokg3aoo[k>koooooooooooooM_ooool01OoZk>go^ko2ogZ1
Qol[=Cgo4R0Z007o52<_0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(str = JavaNew["\<java.lang.String\>", "\<Fireworks\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.lang.String"] \[RightGuillemet]\),
      JLink`Objects`JavaObject29188421314412545]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(txtArea = NewJTextArea[pane, str]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JTextArea"] \[RightGuillemet]\),
      JLink`Objects`JavaObject117179374632961]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(txtArea@getCaretPosition[]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JTextAreaInsert[txtArea, "\<Flowers\>"]\)], "Input"],

Cell[BoxData[
    \(JTextAreaDelete[txtArea]\)], "Input"],

Cell["\<\
Cut, Copy, and Paste operations are available by calling \
JTextArea's methods.
By default, ctrl+x, ctrl+c, and ctrl+v are shortcuts for these \
commands.\
\>", "Text"],

Cell[BoxData[
    \(JTextAreaCut[txtArea]\)], "Input"],

Cell[BoxData[
    \(JTextAreaPaste[txtArea]\)], "Input"],

Cell[BoxData[
    \(JTextAreaCopy[txtArea]\)], "Input"],

Cell[BoxData[
    \(JTextAreaPaste[txtArea]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(ReleaseObject[str]\), "\[IndentingNewLine]", 
    \(DeleteJObject[pane, txtArea]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JEditorPane <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2hoooo
oooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^?oooooooooo
N_ooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soooooooooog[oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?oool2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3oM<30
o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo`<3o
M<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?oo
`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?oo`<3oM<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?lG`<3o04FW_M:a`<>SIVjXEVbBFFb]^k^EZZ==G5U6DeUKI5m2AC`i
?3=>D4E@DDTn@CXi?3=:B3]HDCiMG4YPHE5OHE<g?C4l@c/nAChl@c]4BD92
ACa=CSicJT^4Of^UYiaLHEXb?3@d?cLc?SHoASm8ASYSCRmRD3QZIU]aLg2B
Th^WZ9[>bJ_Ug[3NejWBdk?monc]m>:la;VRZJ98D58Y<3Pd>THc>DLdAUXj
DfTjEfU8JWJ4Yj^jfM?=i=cNjm[Lgl[ZfK_cg;[bg;GhhkSlikX0ol30oaS0
`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o5l30
o`0G]<KD/<?9`l72LEiRNfaa/l72O9ZJ=T]<>4Q8@di:?TDm>SlhCe9;@TM1
>Sli@DI0B4PnIf5AIfIDD551A4HiAD/o@TU10090Acl0;3m4?Ce0=dQ9>fmX
BiZHPhf@QD57?Cm9@3a6?D9<@d56?d15?dE@@UEKCI29NHA_FYAjHIV4JHZ4
JZbmZYjo]YW0aI>kaIW0ai^m_ijm_ceFDbi1>b0`9RDb:2<b;ad/;ada<R0h
>Q`f=b]0@CA6ATE@C5QMEeISG5Y[HgZ:P;G1]MCLcoo0`?lH`<3o0oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P3oooool30oaO0`?l0AKG8ck;@
fYC;b4YWHe=SH[W;cfZ?V3eAF4ABDce8@Se4?CU0>DQ=ATE:A3Dn>Ca2?TM8
@5aIBUUJC51BADU=?dI9?SXo>3i5?D=8@Ci3?3`o>4E5>G5[DJFTTU=FBdI<
@Sa4>DM?@T98?4I7?dQ7@TE7@TQ9@EYMC6ITBg=bE7imHI^OTKO6bjo<gYk<
hiC8gXZibhjb`72AVRm4AbLc;bld;C0c:SXl;c/o<CPn<S4k<c4j>CDo@C<m
?cU3ACa4Aca:BT9BDD1CCd1CCD]OEP3o`<3o6<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?lG`<3o03R`cmBRc]NSd]b[^LJ_
]lBdcmZ7[KQGHfm8CeDnA40h?cLl@SQ5B3m>Dddj?cTl@C]8BSmDDD1@DTE:
CD94Aca4AchoAC/i?SLoA3dn@c`k?SLn@3EkNFBk_:i@DdY<CdQ:D4I<D493
ACM5@cM8@SIIDCi@BSY1Ace:EDmbOWYfPWjJYZC1cm;0dmVof=fdd=BkdmMS
LWDoCDhf?T0e=SPm>chn>Ce9B4<2@Chi00]1@3a4@cm<CDM5B44oAcXmBSU5
DDM7DDU3CDA@F4eFGU<0ol30oaS0`?l3oooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0?ooooo`<3o5l30o`0eZLoLXloJ]/cQ^L;O^LWSSk?1YlS=
JWV0FF1ZADM2>cd`AdLkDU96E5A:>Sdd@44iDU13H5U7B4Xm@4Hl@DLm?T@j
>che?d8i?d8k?D0i>d0j?3lfOGi^^K^`DeI?CU=<CE17ADLj@T@fBTPkDTi2
EeI2EE=4?chiCD]<Hf5RLG5a/KbhaM_H_mWHa=WL`M3Ca]CDAE5=?TU3=d<i
=d<g008f@SH03SM0>cm3@T=5@T11?4I5@4Q8?4e>?TmD?TUB=d9=?cm9@55H
D5ELE6M]Hoo0`?lH`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3oooool30oaO0`?l0=jW=iJgAhK7>h9o?iH6ebTU[MiFb[Hb]YUMTJU1C
C51A@dA2=E]GBf9RESho=d53>55?@V=LBE1CB4=:@Se2>cTn=c/n=DI7?dA7
@4=5@456@3e2>h24MZJYX55FD4aABdA7?Si0<ci0<Ta<@5MCB5QBA59>@d8o
>TU5@VERGGimN<K@b<GJeL3LgL7LiLGMijVn`ca<C3Q4@S<n>3I0=cM1>3U3
>P02=T<i00`jAS`oAca6BCi<CT5<CT1?DD=@Dd9FDdAEDT=EDDEKG4ieNF[o
`<3o6<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?lG`<3o04FZc^J/c^NLdN=OWj/[HFdiAe1BIejD^:aGIfI]LV];CD97Ac]B
DTQPHETg?3Hi?SQBE4UKF4M5BT=0BT8j@CXi?SM<CDE@DDU1@S`m?cY0ACm0
ACj5RgmoQ7i@EE57C4Q2Ad10ASY0@cQ1@SY8BSeHFTAEETA4@CQ<A49VGUb2
OG[=dm76g=W1gmo1gN71f=jBXJA1BD/e>c/k>ce1?d8m>T4m>3ll@c/g@S@i
A3HmACQ1BCi4BT15Bd5=D4U@DD]>DDIDEda?D4QCE4ifMg40ol30oaS0`?l3
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o5l30o`15
Y]7TY=?]MkG<DVmoJg>0G4mFDUiJGG1Z<T4jAe9:@DQ0@DLm@dQ1B4i:<C`h
=d0mBU59CDm2=chg?TM2>3lhB4e6DeA<C4e5>c`f?3hi?T<o@4DoTIN=IFYT
A4Q7?D<o>d8j?4@i?DDj@TM0A4DmEE8oEEA2A4Pi?dDgGF=INWmhbmGGbmgY
bMo]c>3Wd=oR[KNf@DM3@dQ2>Sdf?d8k>Sli>3di>SPi?3Xk?Cdk?44k@TU1
@D]0A4a1ATa0Ce97D5=:EUU@F5]DBe1:LWQd0?o0`?lH`<3o0oooo`:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3oooool30oaO0`?l0?9cEj9[?hG2N
Zf^2R71kOfATI5aPGca2@457AC]5ASQ1?3Po>5MJCc]1<cDm<3<j<SXl>C`j
?cDj=TA;A3/m<UEEBDa>@DA5?CPm>CHk=d96AD56@XbCReMMFDI:BCPl>c`n
>D13>Sm5>d97@D12?EMEAUECA5IGADa=?emNFGYjN=3HflcQi<OSilOOjm7S
klKAddUBCc]1?CPo>3Y1>Sa1>Sm2>c/k>cTi>cTi>D94?cm5>`96C3h01d]?
@E1DADiAB59DCeaQFdaABW5hL03o`<3o6<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?lG`<3o04FFd>JOe>IhX:YXPHEfR8QI
HUm/LFe8CDU6BTToBDXl@T0j?cUJGU1JGTdnACDh?S8l?3Xl=chd>3LmA3dm
?cA?Cd=6B3e1A3/h?CTf>SU3ADA5BTJ1R85=De51ADHm?chl?STo@SU1A3]2
Ad50@SeJF4UFE4EEE499AcYEDDigMGK@f=_<h^34h^;:i?7=h>j`^km4CD`l
AD8h@C`j@3`l?STm?SPm?chl?Sdj?3Tn@CY>DDQ:CT1=DD=GFdaHG4eEF55E
Ee9FFeE:CdQfNg@0ol30oaS0`?l3oooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0?ooooo`<3o5l30o`0gX]SdX=;YW/SFMiJIDF]ZCF5HNhMmCUE=
A4]3B55<AT]5@4<lB4PnJfaNEEU;ADPm@D8l>3Hg>Si1>Clo<cPdDU=>>S/f
>3Xe>S`i=SHd@D0l@44lJ79ZD5ID@DE6?3hm>S`g@TDlAdY1@dQ2?T0kHEeA
De52BT/iBD/nDeEBRhnBb]OMaMgQanCXa=oZcN7/RYFG?dE1?48n>44l>Clk
>Slk?d0k0092A4403453?S/n=eYME75dJFiaIV]^HfIYGU=EDU=EE5UKFTmA
CV]`K?o0`?lH`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3
oooool30oaO0`?l0AJ7BlZ?Bk:OEiHZc^GZPXG:ARhFJTEi[HUYVG4=:@dA5
?cdl=d8n=F=QEFU[GUULDDI8?DM7?cLg=DmAD3dn@3Xk?Cdo?SPh=S`m>3@e
;d50>cTj=7j9PeMPGcm4AcLk?3`n>d15?TQ>A497@C/m>5UEBEQFAe1A@DU?
@e9LFjBb]L[NilOOjlORkLWTklcPifIbL3]2>cPo>3a3?3]1?CXo>ci0>d94
?d53?TE8@D54?Ci1>4A7?4Q;@TI9@4A7@51BDE1ADeAEEde>D6Y[K@3o`<3o
6<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?lG
`<3o02>NbnZXeo6Md>>Se>:Rd]b;];Z_c]64VIi]OXE0BDI4AD0n?CQ6?cU:
ACmkOG9cMFQ4ASUIFTa>ASUGCd9KF552A453B4A3AD8k?3Hg>S=0ACi=E4fN
ZZIDGUdnATQ0ATHoA40k@3U0AS`00SXo>@0PGUY?IF=FDeA4CUI;Cf9P//O<
an7^bN;fa^3aa>3[bn3SDUiJ?D@m?d@m=chg>Clk>Slk?Clj@dHoA4M0@D@m
@D@k@TDl@dHm@TDn@48m?d4lB4Y7Bde:E5ICBde:J6YWol30oaS0`?l3oooo
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o5l30o`15WlgW
XM?/WmK[XM[]XMS/Y=OZZM;VXl7IB69kJWQkBU1>?T0mBDA1AT4kK6iSPXIh
?d<dF5Y<Je]2LF14Q7e[@4<lHVMQHVAO@TDl=C/aA4i5C5U@Z[VfEV9R?4I8
?TI8?dA0>Slh>d0i?D@m>SliBDToKVaPJFMJEE]ADFET^=7F`N7^aN7fan;e
b>C`dnS]CUYH?D8l>d0i>3dg=S`h>Chj?3hi>Slh?T<l@DHo@4Hl@DLmATa2
@dQ1A4U3>d0lA4M0DEA=EeYCEEQAJVmY0?o0`?lH`<3o0oooo`:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P3oooool30oaO0`?l0AIg?j:7EkI_EkIcH
lY_GlJ7Im:_Jn:O@kWRL_5I/NE1KGe1HFTa;BChn=Si1=T16>3Y0=4U<@hUj
GJ:?Kk2[V4E<ADeFDF9WHEUICCdn<4Q>@TIBA[30_D=ADDA>D3Y2A3i4@3Po
=cLn=SY1>SLn=bha:6EUFfQTFE=DC3m?CjO0a<;Sl/;RmlGQm/?Pk]3WkdA@
D3e2?SXl=cPj=CLm>CTo>cXo>D97@Cm4?T97@D97@416?415?TM<AD97@D97
@dM:@DiAAU=ICeQOEfQbJ@3o`<3o6<30o`?oool2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0oooooo0`?lG`<3o03:Jd>bIdNbIeO6Mf?JKe_BNf_JQ
fO:Vf>nWenfV`m=4EV13D5IIGEa2AC`k@C<k@cHh?cL`=Bn=PFV^XXRg^Ji>
FE/h@T=DEU=cJei@AcISGDeYJejR]K=WMgLjADLmAdTlAD8h?cPh?cLj@CTg
?CT]=2a4ACeJDDQDCdTmBd]dS92nh^k2io[0goC1g_3>i>m9E5Pn@T42>S`i
00Lk@3`mA3dm@S/m@Shk@3`n@cm0ACl00T=8@@08AT]4A4U3@4Do@4DnADY3
DEQAF65LI6mYol30oaS0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0?ooooo`<3o5l30o`03VM3^VmCbU]7_00:Ke_@079[Fl9cFk:;KkZ;J
jjW<h4=EHdQEGE]PG4]@BE1FB4]?@D95?3Li>40m;WYgI[k7a3U8Cci7C4I7
BGY^HX9aGGe]E7=ZFIf[[:^j_D5?DSa7BCi7@P8l@SP04Sa1>SDk=ce4?CDf
<6QOEVMNEf=[KEe`M[OKikgVn<3SmlKUnLSPk4UDFS`m?cTk>S]0?3a2?P90
Ad003T15@Cm4@3i3?c]0>T15?T97@3i3?4I;A3e2?456@TA9AE5CCUUOGFQc
MOo0`?lH`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3oooo
ol30oaO0`?l00iWBl9WDlY[El`02VmCa03>Qf_NMennTg_JNe^elWk]0CU]8
CeENGeU4BD9UJE]QGe1GDD<o@3]7B49:CDJnalI8DeTmADPm@D1hL6F:NV>>
NEZAPFZJXjRhalhkCE4jBD`nB41CEdTm?c93ASde>cLh>STl?cQXIUUOFDeI
GEiIJ6fmho2ag_6lh_Nlgo?@j?A6DELm@D0l@Cdk@3`m@cllAShoASll@C/0
0Se2?00;?44k@4Do@DI0@TM1A4U3?d@n?d=4AdQ:Ee9>GEeKLh290?o0`?lH
`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3oooool30oaO0
`?l0=iODliGBlIKCl9cGmIkImi[FlYcHm:7JmigFlhZbeGnFZ6UhOeUNF5UK
EUeNEVaZGG=aHUMIET15?d56?diDD3i4@STn>SDg<V1MCYZ>MZZINjjSSKC5
c<KJhceAF3=5BCDo=fATF5mODd52>T53@STg>SDg<V9SEEiFBeQHFWJ0RKcP
l;GRmK[PmKgPm<[Qkd5>E3/o?SXl>CPm>C]1?Ce3?c]2>`03?44k00/n@ce2
Ad59CTQ<DD]7C4Hn@cde?Se3AdQIE4iPHF=nTJ80ol30oaS0`?l3oooo0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o5l30o`0fT]7bU=?d
UMCeUmKgVMKeW]_jVmSeW=WfWm[jXm?iQJ_2EWJ3I6i_BdM8C4U4HV9HH6IJ
Ee]J@dTo@4Hh@dLiBDdo?ShbC4do?3X[PGaYc<J``/Jg_=kW_MkW?5EL>DaC
?D=3D4e6I65JE5=>>c/k>SDi?C`hIfMKKVMOLg9gV::/^mka]n3f`^Gk_]kc
aMcZ?daB>S`k=SHd>3Xg?D8n@4E10Se2?0@l@C/02Cm4?T15?d=8@SXo>C<o
>d5>Ae=FCE1KGgjL]03o`<3o6<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?lG`<3o00N@d?BCdoNEeORDe?NCdoJGe_NJfOX0
0YWHn@0[WMCkXmKaL9j^=DI=Fe9GFU9@HF9LAe=9CU==?d<eDEE6L7=REUE3
B4DdAT<bB4Tk>C`cZk:Z^Lc:[N3a]Mo_AV1]@E=M=c/nBDI1HEaFHF5GCdm7
?CTj>CXeF5Y=GeaEEU]QRi^X^=ka]nCk_>3h_N3fb>;a@TmG>c`n>3Ph>SXh
008o@Ch00d12?Cm4?Sm4?P02@4Do00Xk@3XoA3hoA3i2Ad4k@3Xa@CM1DDI?
Eda<FV><[lgo`<3o6<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?lG`<3o03N=c_BAd_RAdoJDe?RFe_ZEeOVGeoZFe_VFeORG
dOJQf_F2]LYOMXA/JG1jMGUgNgXf@CUSIEYEEdaIG55EETQ[J5M^J5QUHU=3
A3i5CdjS/[Ned=^Xh?VhhOM2EfQ8EV<h>Ci2?cY@CT9YJ5A`Kee7@d0m@3M>
EDEDEe1>Ff><Xk6]g>jbiOZegoFggO;1g>dmBU<i>S`j>3Tm?3Xk>c]1@d13
AD000T15@@0<?dA0?T<o@4E1@DI2@TM3@DI2=c`h;S/b>dTlF5]BDUmXQJK7
ol30oaS0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo
`<3o5l30o`03T=7gTM;hT=7g00:Ad_P0=9GEnIKFnYWIoISHo9oLnj7Jn:7F
mI6dbZVkaj:_^7R5SUYTIEeMDFMXHU=ED492>UiLCeUEBF5ODd15?d1;CiV[
]K[Fi:cKmK;CiTQHIC4j@cdn@3`m=D51=G=eGg=aFVeVG5aMCD]B@4aCBeAW
KZ6nc:gQmZ[SmkCTn[CQm[gMk3M5CSLh?3`l?3dk?3Lg=d56@TI;ACm4@3e2
?P8l@Cd3@DI200M2Ad<m@She@3PnB3mJFU9LHf]eSZ`0ol30oaS0`?l3oooo
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o5l30o`:?d?H0
>Y3Ami;BmY;BmY?Cmi;BmYSFniWHni?Dl9_EnYgBnZKGn:KEjK?HjgB>YCI0
C6Y/HFIYHUIHDdm@B5UICE=EB5MICT=:@cU5AHFGVkgDg;7BhD1CFSm7BDY>
Cc/m?34f<Se0>EmPD81iIWa/G7M`GG9dGUiTFUY/M[WFiZoVnjcVo:oQn;7Q
mlCXn4AFH3Pl?cXj?3`j>c<e=3a1?Ci5?SXo>ci3?d15@Cm4@415@@91AT80
1cm4@3Xo>b`i<SU4?5iNE69WJVj5U`3o`<3o6<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?lG`<3o03^>coF>c_BAdONBd_JA
dOFCdoNEdoREe?NHeoZCf?FLeonKdOnGe?nFg_NFcnYCNY/U<DU7CTI5B459
BdHf>C1KGe53AcQCEdU0B3e1CTM`OgbZ_K]0E5=>FE=4ACe8B40n@3d`=SH]
<c<g>3=jL6JEOfZCPfb2OFMnOWJBX:^of^^_ho^Zh_^`h?NZg?>bfNXkCePc
>3/j>cdj>SXj?3/e>cLc>S<j?c/m@Shn@cloA4000d56@P07@4E1>Slk=T90
>DE1FUa?JW1/H7Ao0?o0`?lH`<3o0oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3oooool30oaO0`?l0>8W<mXc?nI;AnY?AnY?An9;@miGCnYKF
nYGEniCFn9OFnIWEnISGnYCJo9CDmhNlg3UCHV=VGg9QFY^8PIf@OhN1Je=@
?EYFBV1LFEYLFfmeMKc5`T==A3m2>DQ8?T=0>CTh<cTk>2/`;3@j=S/n<iN=
LYB9Lj2FS:Z[/;oJjkGNlZSRn:SPmjkNm:kPmic3e355CRdb=Bd_;STi=cLl
>3M1>CQ2>SI0>08l@c`02ca2?T98AT=7AT=7AT53@3/m>2hl?3Q4@UEECF1R
HEi^O@3o`<3o6<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?lG`<3o00>9c_N<coV?d?P00Y7?n006T]3iU=CjU]KlU=GkUMKl
U]Ki0YOFm@0[U=SmUmSnS/WYFg^:IV]WLf5MPFiW[9n>SHU`Ee8nGEM9JVEQ
H61PI6YX`<W4C598AdY1ATHlAT<l?Shf9bPR:bdX:c@_;CL/U99iUHik]JfZ
/;S3]m[^[mgdYN7iZN7h/>3f/>3gW/CG<4A=;S<f<38a>C/h>d4m>D<k=T4i
=d4h008l@c`02ce3?d57ADA8Ad=7AT94@C/m>2Le=C<o?EUFCFIVIVAbO`3o
`<3o6<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?lG`<3o00>9c_N;c_R=c_P00Xk=mP10T]7jTm;kTmCjT]?iT]GoU=GmUMGi
UMGhTMGlT=?mW=OoU;cEUjVeX[2aWZfZY[>ZHVeOLGETHfABJfaLGF=IBEQA
a=7:@TM0E5M>FUYBEeA;BTLn>SXb@44i<cPa<3H/=3HYE5Y@a=;E`Mk^/^3j
[^7nYn3mZ>3k[>3h/=oiZ/gQ<dE?=SXk>cdl>c/i>3di>T@l>dDm?4<k>d8k
?4<l?TA0?T91@4A3?d=2@TA1=cTd=40l?DQ2GE]>JfaVL7j7ol30oaS0`?l3
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o5l30o`05
QlceR<gfRlkhT=7kTM;l00:@dOT0?Y7BnXoCnX_BoXoBoI7BnY?Cmi7Eo97D
oiSHoi[@lZ7;i:?Bi:3Ah;KLkd]QKc]4@fi_Ig5bHUUQEUATI;O7ad97@4e@
BEYJDVAQF6i/H69PE5UFCE9DBDM8@STn@TmNHk3Dh[[/ojGLnjGKoJOLo:ON
o:SNn:_Ilk7BiCE6CSLk?3/k>C`m>3/m>STo>cY1>Se4?3a3>c]2>Se2?3m4
@455A415@D=5@STk>3Q0@dE:CV9MFVm^M7n@Y?o0`?lH`<3o0oooo`:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3oooool30oaO0`?l01HC;mHK;mHO<
mX[?n8_@n@02Rlkh0XgAn00lS=?oS]?lS];iTM7eS];gS]?lUM[oUMKlU=3d
TmSiU]cnWM;l@Uj3=3]=>3LlCTXoGEiHHFYcRI>L@TM1ADQ1GEeEGeaCG5Q=
HEeALFeQQ81eF5E@D5APAUQV/=oaX^;mY]omZmgn/Mko[=kiZ=cd[mcc_M[/
@DmH?T0o?Cdk>c`g>C/h?dA0BDi8@DLm@DHo?d@m?T<mAT]7@4E1?dA0?Cll
=3HcA4U3EEQ?KVYNK71_OiBUol30oaS0`?l3oooo0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0?ooooo`<3o5l30o`03Q<_gQLchQlkh00>7c_P0?h[?
n8cAnXg@nX[BnXcBmXkBmi3BmHkBmHoEnI;Ho8oGoI3Io97MoH_FmYcHoD5U
RBhkBc8e>V]WG79_IVQ/KH^@Td15@Ci1>Ti?AeADBUA@AGA`I7McIgYdJ5YE
Ce5EH4QJJ:oNlZKRoZOMnJoNn[?HlkGOmkcYol7Wo]7/oD1=EC`n?Chn?3ho
>T12?ce2?T56@5QKDT=6?D13>T=6?d94?d53@412?cLl>3@i=DY?BEIID7Ea
IV]eMY>_a@3o`<3o6<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0oooooo0`?lG`<3o00^3b_J2boJ3c?N5d?Z6dO^6coR:dO^=d_b<dO^?
doZ>d_L00XgAn00hS];iSm?fSm?fTMOiSmSkSmWfTM_dU=C_Xm?ZJ8B@N8^A
OhV1NGmeH6MOD5E?@dE2?T0kFEYBGUiFBdPoK6YNK6QMOGU^DTe7Ce9GC5YU
/mO][^3k]N?m_>Kn`NGk_^Ck^>3i`>ClbnGfBUMM@TI5?Cll@48m@DI2?dA0
@TM1H69GEUQ=BTa1@4<l>S`g@TA1@D=0=S/g?44mCe=BFUaIKVeXGF]dXLKQ
ol30oaS0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo
`<3o5l30o`:2boP0@h;=mh7>n87>n8C?nHK?n8O>n8W>n8k=mXk?nHc?nXgA
ohoBoi7BnY;Bn97CmY7En9GIo93Dmi[OoYSHlI?3fXN`aXnX_8:DWSm>DD1<
C3Ph=TM8@eYKEDm@B4M7?F5QEf=SFF]XHE=BCE]THei[Ll3Lm;ONoKOQn[WS
nKWSlkWRn;SMmk_OmmKaodeLHD16@T=8@T15?ci5?Se3?ca1>eUKCUiPDeAF
BD52>T94?cdo?3Xl>C<h=4=8A55GDeaQFfQ[H5ecLIk>g03o`<3o6<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?lG`<3o04F0
b_N1boR0cOUoc?J0boF3c_R5c_V8coV;d?Z=c?N>c_Z=d?f=dOn=conAd?^C
d_^@d?BBe?NBeOnEf?n9c_F>e?JIeobJcoNOa^f`cN]LMXM5EV1>CDTo?SU6
ASi5ACdl?CMJGEIYJVATHeiVIf5XLG1LJG;3foFdeoFcgoRdh_VfhoRhi?ff
h?VggoRog_19F5doAD50ACi3Bd0nB3m1B44j@CUHFTmSIEYVJ5e>CdM1@S`n
@3dj?c/k@3a7C4QKH6=UJFaRIVUVOXZLcn@0ol30oaS0`?l3oooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o5l30o`0:NlSdOL[fP<[g
P/ggQLkiPlcgQLchQlkhQ/ggR<_f0X[=n00iRlkiT];nT]?kTM;hSm3fT=Cg
S]?jSMGkTMOiU=WhUmShVMGgX=;cZ];/QJ6fLhJDGUYGKVYQD4a1BDHmATM2
D5ACFEeLFU]FG5eEIfa_FF=_`=Sd^Mkh]N?j/n?j]>?o[mkl[]gg]nWoanco
CUeT@4DoBdi5@Tdo@4ho@di0ATa0DUE>HF9JG5iCH61D@T<k@4Do?TA0=3Xh
BDm=HfIOJ6UTJVYdKhFJX=;Y0?o0`?lH`<3o0oooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P3oooool30oaO0`?l0AG[;n7g;nGo9mX7:mh;;n8C=
nXG<n8C=n8K?nX[AoH[?nH_@nXg@nho@nXo@n93AnHkBmhoCn9GFoYCEni?C
mYSInIkOoi_KoY[Fn:GFm:_Ck:g<gYZNXIjMV71]I6=PEd93?TY>CDeAD65T
GF5RFVE[JeQTL;_Ilk3LmJ_OmJSNn:WMojOLo:OMmJWLmkSKlDaFH4Q8AT=4
?TA<?d9@@dI@ADE=@U5FD6AUGF][GfUWF4e=@Ci3?3i4@3]1?DmDD6U/HFe^
IVM[MgbJ]9cElP3o`<3o6<30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooooo0`?lG`<3o00IgbOQjboYmb_R2c?^3cOb2c?T2PL_h01N4
c_^5cob4cOR7c_Z<dO^<coZ=c_R>coVAd_Z>d_VBco^FdOfOfOnPg?nJg?nF
f_nKg?nLf?ZVfoZ]fO:U^LAiQ8I?DD`00V1OFP0TFeeHFE]FF5YEEeYAHV]X
F6I_/mG^X]S`Xn7jW]kjX=coWm[jX]S`[=Sa^M;XDeYTCTa=CTe9Be19@Da4
A4e8AD]7BTm9JfeRJV]MK6UHJV]KAD/o?TDm@dQ2FeiGLg=WLG9ZHfmkR[??
UmWkol30oaS0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?o
oooo`<3o5l30o`07MLWhMlWiNLOgNlOhO<SiP/ckPL_j009nboT01go<nX?@
o8K@oHW@o8c@oH_>nHg=n@02Sm3j03>Bco^Dco^Ed?RFeORFf?^Be_^Ae_fD
e?RPfo^TfORaenb0VZM3CDm0A4=ZJV9`LFUWJ61/KVU:C4MXLFaKK7>]d^bG
dnnKg_^GfOVIeobPfONVe^ZgenbCYK=BEEYGEU9?CdM;CTM5CTU2CDU4CDY7
C4E]KF5^K5e_K5UdLf5PI5I?EDU0@cYTIEehM6UcLf]^PXfEb>FAf_d0ol30
oaS0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o
5l30o`03L/KeM<KfN<Si009kbOT0@7o;o7k:ngc9mg[7mGc:n83=nh7>o87:
mh[>nhc?o93@o9?Coi3AnhkBnHc@miGGnI_Lo9;GmXoCmYGIo9WHnj3FnZ;H
nZ?JnDIZPSU;EcDn@d13?5YLDGYlLFe^J5IGDV]`JTeJHjG:iigHnYGGnIOG
niS?mYk=jJC8e[36deEPI4e@BDQ6>Ta=?e1DATA;@ce7?d9=ADE:@fQZGFm]
GVeZEfMVE6IZFeePEEmREg5cJ8f9P8F7PXFS[Y;=ji7Kooo0`?lH`<3o0ooo
o`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3oooool30oaO0`?l00gG9
n7K8n7S9n002O<Si041oboakb?Ikb?Imb_R1c_b1boR4cOZ5c?Z;c_^?cof@
d?b?d?Z>dO^=eOf;eOZCf?VGf_NFf?RGg?fGfObLe_^Pe?VNe?RCdoU6Li@h
DFLfAU<nA48o@SM5Aca`KFQLF5EPHV5IIG6Zd?BEd?RAdONIeOZTd_IGMhi6
GF=9EeY:D4a=DD9@DCmADT1=D3m;DDE1Bd12CT95C4ALGU=_Kf=_KUaUHeAW
JeeXJf1WJV5jNW26QXJ6SiJE`=6BeoJ;eO[o`<3o6<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?lG`<3o00EcaOAea_EiaoMn
b_]obo`00Wk8m`0nP<[iOlchPL[gPLSfQ/[iRLciS<cjTM7mT];nSM3jSm;l
S];oSM7nT]?iTM7dTmGgU=KiU=GkWm_oX=SmV]CjTmKoT<7Z=5=b<4IM>dI:
@4HlBD]0KVUUG5ABKWAdDF5`W<K/UMCmU=GkV=Ci[MGh?U=TADm@>3hn>3dg
CEA4CU<mD5<nC4lnA4LlA4a1@Ta1@T]6DUE>JV]SJFYLI6EGJVeRIfeSK75Z
N7UaNH:ASjRnUM7[RMWjSm[ool30oaS0`?l3oooo0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0?ooooo`<3o5l30o`0@MLOfMLKeN<KdO/SgOlWhPL_j
O/OdO/SeOlWfQ<_iS<olS]7nS<cjSLgiSlokSm3j0XgAn00cSlcoS/_oTlgm
T/ggSlkgT=7iS<oiT=7iTLofSloeRlkhVlkiK8jcDFZ8?4YCF5mHL75YQgek
M6YYKgYlEfamX];jS=7jSmCkT<kc[=?`@E9L?T<m@D94>3di?THgATdkBThm
CDm2A4M0@TU1@D]2?dY6Ada8FUeFK6aPIfULHfQQIfaVPXN1S8f7VJg6W/;V
RM?fO]KnR=Oo0?o0`?lH`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P3oooool30oaO0`?l02X74kX?6l8?6l8kAo8[?nGo6lWk5lH7:mH?<
mhk>nP:Ad?/00i3?nXg>n8g=n@02S<oj03B9c_R;boV=cO^;boV@doj<coZ8
cON;c_^>c_Z?c_Z>cOV@cOVDb_RJaNn>/=EmSZ:;SY>DU9J?SI2:TI^1Wk^<
[lnIcOF>dof9d?ZAd_RLb^@cBE@c?3/i?Ca0ACm2Ad0l?cI2ACa1A3]6Ad52
ACa1A3/jBDHk@3U@CT:BRWmoO7EkOGR5Qh:PYZJT/[fJcNb@dON8d_N8doZ=
eOgo`<3o6<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?lG`<3o00^6a>^<b_>?c_NJfonFfOn3b_B2bO>3c?N4cOR:boF=c?L0
0Xk?n@0XRlkiR<_fRLciRlkkRLgjRlkkSM3kR<ggR/kkQl_hRLgjRlkkSLgk
SlglSlkjSlkiT<gjV<_fU;kVT:S2Uj6]W:F^WjVbW;;0UK_PUl7WU/gfS]7l
R<oiT=7iWLcV=4aF<c`k=C/g>Sli?T<m>3/d>C`eA4M0AdQ20TA5?@0>=4<n
?dDkAD<gUhj5SY2=RiBCTibKY;6iY/7FTM3cR]CiR=;gRM7gSM;iol30oaS0
`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o5l30
o`0?T=7kS<oiR/ggS=7kR<oiOlScO/WcNlSdO<KcPLSfQLWhQl_jRLglQlkj
QLcj00>6b_T08hG9n8O;n8K=nHG<n8S?nhO>nXW=nX_>nhk>o8g@nhWCnXSA
o8_@nY7@niS:jiS4gic8hIg=i9W?jiK<kYG=l97@nHkAoXo?ni7?mY2jdcI8
DSPl>cHj>CHk=ca1?Cm1?3Xl=cm1?413?002@D8l00hiAD4m@S]5ASiNI6BR
^<FM`=>P`mJMamnFb_6<dOZ9doZ;eOb:d_Z;do_o`<3o6<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?lG`<3o00^4boEnaNmk
a>mlaO1ka_1jao=jbOAib_MkbOMkaoQlb?X00Wc8n@0=O/SgP<[iPLWiP/[j
Pl_kQ<clPlciQ<kkPL_hQ<kkPlkhQLkiQlkj00:9cOX0:HO@nHKAnhS@ohW@
oX_>nhg=nHc<n8K=nHSCoHcBm8cBmXcAnhc@oHo<nIS=mGbP^SY9D3Li>3Tm
?3Di>3@h=cHk=cLl>453@4A6@D=5@412?C@o>CPm=cPn>RDiA9W8i8c;kXg=
lHkBnH??ohG@nXC>mHSBnHG?mX_Eo03o`<3o6<30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooooo0`?lG`<3o00Ee_naf`>ehaO5d`nic
`^d00WC5lP04M<KeMLOfN<[lNLWl0WS8n`0XNlWjO<SjOLWjO/[kOLOhPlgl
OL[hOlcjO/_iO/_gOL[fPlgjQ/olQLcjQ/[iS<chS<cjRl_kS<clS/knS<_n
RlgoS]7oQLgmR]CkR];jR/kkS/klULkkVLgdG7nE<dE9?48n=c/j<3@e>Cdl
=CTh>3`k>Cdl?44m0T15@@0>@dY3@DI0@4U8945CSLO]R=;oR]GoQM3jQ=Ko
R=GoQm3iRMClQM3hS=Oool30oaS0`?l3oooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0?ooooo`<3o5l30o`03L[o]L/3^Ll7_009b`o001GC5lW;4
lgG7mWK8mgG8nP02M<Ok00IgbO]fa_Uhb?UkbOYiaoMkbOT2O<[j00enc?am
c_]nc?YmboV1boR5c_^9d?j:dOn9d?b<coZ<cON=c?R=cOT00X_>n`0NS/kj
T=7kRm3jRlkiS<cjS/ckTlcgV<caA6Yo<dQ9>D<k=3Xh<cLh>3`m=SXi>3`k
>Shm@4A3@TM3?dA0?TDm@DI0>dE4<4mQRlW`QLolQLkgRm7eQLkgQM3h0XOB
nP03PlkfPm7h`<3o0?o0`?lG`<3o0oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3oooool30oaO0`?l2Kkg[011`_^a_`>e``NidaO9a`^mcaOAd
a_EeaoMeaOQda_Ifa_MeaOIfa_MeaOIgaoQibOX3N<Si00UhbOQib_UgaO>4
c_f5c_^2bON0b_MlcOZ2cOD00XO?m@05QM3hQM3jQ/ohRm3gT=3f00:=cO/0
6Xc<nXk>o9?>mY?9jcaRMB`n@SLl=SLk>SLk?3Pl>cDi>3Pl>cHl>TA:AT16
@S]1?Ca3>ca1>ci8AcaKKHW4k8?<mhG:lhc>lHO;lX;=m`:1c_P00h;?nHGB
o<30o`3o`<3o5l30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0oooooo0`?lG`<3o00=__>Y`_N]a_nd00W6ok@07Ll7_LKo]M<;`LlCaM<;`
M<;bML?a009ha_H01GK7mWK6mgK6mgK6mgK6n@02MlOj00ahb?UhbOQocOf1
boYob?F5c?Z7commc_f3c?F8cOJ5cOF3d?`2PLoo0226cOV<cON9c?V;c_^;
cob8cON=bo:Ne?Q0H7DZ<CTo>cXe=cHj?Sdi?C`b>3He>cTe>cLm@clkA3lk
ACdmAchj@CY1BdY5I7R4`^^4c_f2boJ4boF2b_Z1d?^1d?Uoc_L2Olcfol30
oaS0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o
5l30o`0=K;WWL;g[L[o]L;g[KkcZL[o]LKo]M<?^M<;`M/?aML;`ML;^MlCb
009e`o<04WO8mgO7n7G7mgK6nGO7nW[:oG_;o7[:ng[8n7g:n8C<o8O;nXG;
o8;8nhG7mhc<n8_;nHC<oP:3c?l018W<ohg=nhcAnh_@nP:8coT02H[8kiS=
kbm;HCTl@d4h>CHf=SDi>30e<C0f<P02>3hj00hi@c/lAShlAShe@CLl@Shg
@TI7Jh64aNmobob0b_V2coekboj1cof1d?/2Pm3l00>1c_[0`?o0`?l0ol30
oaK0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o
5l30o`0EKK_YKkg[KK[XL[k_Lko`LKg^LKo_L<7^L<7`L;c]M/;cM/?aL/3`
N<KgML?dM<;cM/KiN<SkNLKjMlChN/Ok009ibOX02W[;nWg9nX;:nXK<oHO=
oXC<o8;9mhK:mhO;nXW?o`:5cOd08XC;nHg@nhW:lX_<m8_@mh[=mi3:l9W:
jcMBIcm4B3He<B/];3Dk>Bdc<C<i=C<l=cQ1?3U3>cY4?3M1>3I2=3Y0@3I3
C3YXP7o9kX79nH?:n83=nGg;nGg:mX?=nXG?oX3:nH?=o?o0`?lH`<3o0ooo
o`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3oooool30oaO0`?l02VZf
ig2lkG6kk76kk6nijW:lkG6mkW6okg;0l7>ol09d`?403W?1lGC2lgK4mGO5
mWC4mGG5n7W6nWS5nG_9nWK6mgS8nGK7mWW7mgk8n@9oaoL0:H7;nWo9n879
nH;;n87:mhC;nHO>o8K=nH_?o8S;mXG:m8C=mXC;mI3;lho1i3UHK3I1@b`^
:A`Q7BT_;Bhd<2dc;c4g<cLm>CY0?4=:@c]2>cDo=3]0@cI2CSQWPg_9kH7:
mhG9n7o<n7o>nH3=ngk;nGc9mgk<nWW7m`3o`<3o6<30o`?oool2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0oooooo0`?lG`<3o00MX]>EY]NI]]nQb
^^aa^N]b^^ab_>d00W>mkP09L[k_L;c]LKg^M<;bL/3`Ll7bML?dL/;cLl?d
009da?D02WS8nGC6mWS:nWS:nG[;nWg;ngg9nWc8nGc:n7g:n0:2c?/058G>
nhC;nHG<nX;9mhG<nX;:nWo9n83>o87;n8S7l9C<keUlT3E7BC0g;c0g<2/a
;CPn>SHl>3Lm>CTo>`8l@Cd03cDi>38l<Ce0ACa6DTEdT7g;kgo8mHG9nX;?
ngg<mgg>ng_>nWW<n7S:nGG9m`3o`<3o6<30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooooo0`?lG`<3o00AY^NYW]nQZ^>U`_>d2LK_/
00A`_>ea_Nia_Nib_nd2LKk/0W6ok`06ML?cML?dM<CeM<CeM<KfLlGe0WG7
m`04M/ShM/SgMLOfM/Of0WO8m`0ENlckN/_jO<[jO<WgO/SgPLWiPl_kPl[h
Q/cmPL[mO/[kO<glOlcjS<geS<CWU;W<JWalHVYODUUA@dY3<CPa008b=c<0
4SHk=cHj>CLk>S@h>C]2>T54BDE>GEZ9YGS6k8;:nX;8ngk;nGc=nWG7mWK:
n7W=ngS<nWW=noo0`?lH`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P3oooool30oaO0`?l02VBlk6:hjFBhif^kk6Ngj6jlk6fnkFZkjVnm
kG2mj`9a_^`0176okG;0l7C2lWC2lP9b`_<2M<Ke02ea`o9da_EcaOAgbOUd
a_IcaOEhb_Yhc?]ebOQkcOelcOalb_Z0c?enb?MobOR2b_Z6c?ena_Inb?N0
cO^2cON6a>^AanUVQiIIJ6ERJ5YQJEhf@3P^=Bh_=C4^=30e>SHo@d8`=3<`
=3E1B450@dY:EVIYV[QhanimaoR0b?Yib_UhboMgbOP00WO9n@03NL_kN/cl
`<3o0?o0`?lG`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3
oooool30oaO0`?l02UbhjEnjjF6gj6Fij6FgifRhjFRij6ZkjVZkj72mj`9a
_^`2LKo]0W?1l@9b`o802773lW;4lg?5m7K7mW72lGC4mGG7mgG9n09db?L0
6GK:nGG7mgK8n7S8nG_9nG[6mgc8nGo9nX79nH37mGo8mH3:mh39lXc8kIC7
iS=@H3e8A4iBA38i<BHa:B`e<2df<Bhg<SDk=cHl>002=SXi00hiA3a2ATln
Be]KSZeibo5kaoQkaoUfb?Mcb_MgbOUgbO]gaoYhb?UibO[o`<3o6<30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?lG`<3o00IM
]nUQ^N]T]nUT]^QU]NQ]^N/2KKWZ00A^^nU__>Q`_N]`_N/2L;k/03Ab`>ib
`?1a`_5b`o9^`Neca_9ca?=b`?1ha_IgaOIda?Eba_EaaoQca_QgbO]iboej
c?akboaocomhbOQjb?QiaoMlb?V0b?QobOQoc?R3c?N8a^f=`^@`Cf<g@d<b
=B`^>C4X=30X=Bh/=c4_>S@g@3/c?3Le?3Dh?SXe@SU2BE4lC5aSV[Q_`^Yh
b?UibOYdb_Ubb_QcbOYeb?X2M<Oi00=ebOS0`?o0`?l0ol30oaK0`?l3oooo
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o5l30o`0:GkGX
G[7UIkO/JKGYK;GZK[GYK[CWKkGXKkGVLK_X0Vnlj007Kkg[L;k/LKo]LKo_
L<7`L/?bKl3]009b`o00<7C2lWO3m7O5mW?3m7;4mW36mg77n7C6n7K8nWO9
ngK8n7O9nGG7mgS:nWW:nGc:nWc8nG[8nGW:nGg:n8_:mHo4k3=CJS0m@cDk
=bhj=R@c;RXi=2/h<BXg<3<n>3Q2>SDo=cPo=cY:@4YCG4=DI62I]g38kWC8
mgK8nW;:n6o<n73;nVo9nfo:nG;:nW?;noo0`?lH`<3o0oooo`:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P3oooool30oaO0`?l05U^ejU^bif2ejf>f
jV>eifRfifbhjVZfifjhjG2lkFjlk6nmjfjkjFnlj7:ojg70jfo0kFk1kG72
lG?1lGC2lW?1l@9d`_<0:G;2lg;2mG73mG73lgG6lgK8mgK:nGO:o7[=ogO9
nGO7n7_9mg_:mGS9m7S9mWS:nWS:o7c4mXK6lRQELR]4Bb/j<b/k;RLf;al]
;Rlj?2`h>3U4?3m;@CM0?C0h>Si7@Sa?ECeJJ6nXaWW3jWO6lGW7mG?9n6[9
nFo;o002K/[i00=`c?]`bo[0`?l0ol30oaO0`?l3oooo0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0?ooooo`<3o5l30o`03F;?XFK?WGKCY009N]>L0
4VJhjVRhjFZhjFfijVbjjfbjjVjlk72mjg:ojg6njW2ojVo0kFo2kW;0l7?1
lGC2lW?1lGG3m09b`_<2L/;e02Eb`_=fao9fbOEebOQeb?Ygb_agaoQgb?Mm
boUncOQjboIib_Mibo]gb_ilb_^4boU1MYDWAe8Y?3HX>R`W=bdN;2l[=SP_
>CXmBCm0C48g@3l^=SU0AT@kCeHiFFQ]YLIl`nehaO5hao9bbOI/bo/00Vk:
n@03Kl[iLLckL<_j0?o0`?lH`<3o0oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3oooool30oaO0`?l055B`he^ejEjejV2fjF6gjVJhjVJfif^i
jVfijfjlkFfijVnkk6jkjG:ljFnlj72mjG2nk731kW2nkW6ok`9c`O403GG3
m7;2lg;2lg?3m7C4mgC4mGC5lWC6mGC8mg?7mWO;nWO7n7O8m`02NlWg01]j
boQhbOIeaoIdaoUfaoIi`o1l]mTTBUlT?D8N<BdU<R/X<blU;RT]=S54CTHi
@c/c?SPc?SY4B4U2E68hEfaXX/Ye_nica?5daO9bao1`boL00W38n003LLOh
M<[kLlWj0?o0`?lH`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3oooool30oaO0`?l00eJbiEZdj5^ci@02Fk7T00aS]^QT]^QW]nQZ^>U^
^^a/^>Y]^N]_^NYb_>]c_NY`_N]__N/2L;k^00Ea_nmb`?1b`?1d`_9a`O80
0W;2l`9c`o@08W?4lGC6mGG7mWC8mgO9nGO8mgS9n7[;nW_9nGW9nWO8mgK8
mgK:n7O9n7C2l7g0jT1bUAm2F1lc?28a;S4m<bdc9bdc:Ce2?3m5@CA0=SA2
=D=5A4EEI3UGKfnZe7G3m7;4m7C6m@9bao001GC8mg?6n7?6n7K8nWG7n@3o
`<3o6<30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?lG`<3o00=F/^EE/N9K]NL00Ungj@08GkGVI;OYHkGWIKOWKK[^JkOYK;SZ
K[SY0W:lj`9`_N/01g2nkW6okG6okG;0kW6okg;0l772l@04LL7b00Eea_Ee
aoIda_Eda_EcaO@00WC5m00RM/OfM<CeMlOlM/KiMlSeM<OcMl_iL/CcMl7`
M[?P:EIm9dEM8cHl:3D[=S`^>C`a=CLd?dE3>dPn>T/kBDa3A5MN<eAUKZkD
L<;bKlGdLLGcL<?]M<OaMLWhL/SiLLOhL/SiL<Kgol30oaS0`?l3oooo0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o5l30o`0:DjoPEk?T
E[3RGKGWFK7SH;KWHKOXI;OYIKSZJ;S[0VZhj@0BK;SYKkWXK[SWKK[XLKg^
LKo_Kkg[L;k/LKo]L/3^L/3`Kl3_LL;aLL7bL/;cLL7bL/CcMLKe0WC5m00N
MLKeMLOfMLOfMLOfMlWiMLKkMlOjMlSeM/WcM<SfLLOfN<SkO/KhFYG1>6B7
73e>93Xh;cXb<CP`=SPeC59@>dPo<d<fBE=8@5YK>V9/NKkMKlC]KlKcL/Kb
0WG6l`05LLOfL<ShL<ShKlOgL<Sh0?o0`?lH`<3o0oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P3oooool30oaO0`?l04U6]gU>_h5>_h5VciERb
i5ZbhUjdiEneiV2fif6diVFej6Rhjffkk6jjjffjj6jjjfnmkFfkk09`_^`0
0g6okG;0kW;0kP02L<7`02a_`>mca?=b`o9a`o=faoIb`o9e`o5gb?EcaOAd
a_EebOMbaOMdao]eaOQha_IhbOIba_EgcOadaoU``O1h_n]]Zm@_H7hP@E8Y
>clZ=SI5BTICFELhAd@a@ChoDE4kGFLiJ7Yc_=ebaNmba_9dao5faoAeaoI`
b?Q]b?M/aoI`b?Q]aOGo`<3o6<30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?lG`<3o00i@[meE/N1F/^5F/N1E/=mH/^AM]NMQ
^N]Q]nYR]NUX^^aW^N]U]NI[^NT2J[SX00EZ^nY[^na^_>Y__^Ua_nd00W?1
k`0@L<7^L/?bLL;aLlCcL/?bLL?cLL;aM<;`M/CbML?aLlCaLlKbLlOfK/Ce
M<OiMLOi0WO5m@0IMLOgMl_jM<[iLlOcN/cdO<WeIZG@@Vf?BF1bE69]IfeY
IFiYB5IG@E1GA5Ya?FJ6B7bSL;WVLL?bM<OaMLO_M<G`LLGcLlKhL<Kg009b
aOL00g74m/30ol30o`3o`<3o5/30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?lG`<3o00MA/=iB[]eC[miF/N1H/n9H/^AL]>H0
0UR`hP0?H;KYHKCVH[GWIkWYJK[YJ[_ZJK[YJk_/KKo_L;k/L;oZLL3[L/3^
LKo]K[o/009a`_409g;3lW31l732m731l7K4lWG4kg?2kGK7m7G8m7;6mG;8
nGC7nGK8nWc8nG_9nGG7nGC7nGS?o7;:l7;6jgC8mWg5mg:QcFR2WFQjR79m
MfiiLF9_MEQVLcE?LTihZ6RMcfjgk7K8nWC5l7K5kWG7kg?7lg73m@02L/Cf
00=a`OAc`oK0`?l0ol30oaO0`?l3oooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0
`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30
ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o
ol30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo
`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?o
oooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0?ooooo`<3o5l30o`<00003`<3o0`0000?0`?l3000000?0
`?l0000000000`0000?0`?l00`000<30ol30o`02`<3o1`0000C0`?l40000
1l30o`<00002`<3o0`0000C0`?l30000ol30oa_0`?l3oooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0?ooooo`<3o5l30o`<00003`<3o0`0000?0
`?l300000l30o`800004`<3o0P0000G0`?l300001L30o`<00002`<3o0P00
00C0`?l5000000?0`?l0000000000`000003`<3o0000000000<0003o`<3o
6/30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?lG
`<3o0`0000?0`?l300000l30o`<00004`<3o00<00030`?o0`?l00/30o`<0
0004`<3o100000C0`?l300000/30o`<00003`<3o0`0000;0`?l400000/30
o`030000`<3o0000008000000l30o`000<30o`3o`<3o6<30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?lZ`<3o00<00030`?o0
`?l00/30o`@00004`<3o0`0000C0`?l300000l30o`<00002`<3o0`0000?0
`?l400000l30o`<0003o`<3o6l30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?lZ`<3o00<00030`?o0`?l00/30o`@00004`<3o
0`0000C0`?l300000l30o`<00002`<3o0`0000?0`?l400001<30o`80003o
`<3o6l30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0
`?l[`<3o00@00030`?o0`?o0`?l3000000?0`?l00030`?l00/30o`<00004
`<3o100000;0`?l400000/30o`800004`<3o0`0000C0`?l30000ol30oa[0
`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o:l30
o`040000`<3o`<3o`<3o0`0000;0`?l010000<30ol30ol30o`<00004`<3o
0`0000?0`?l300000/30o`<00003`<3o0`0000C0`?l30000ol30oa[0`?l3
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o:l30o`04
0000`<3o`<3o`<3o0`0000?0`?l00`000<30ol30o`0300001<30o`<00003
`<3o0`0000?0`?l200001<30o`<00004`<3o0P000?o0`?lJ`<3o0oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P3oooool30obc0`?l00`000<30
ol30o`0300000l30o`030000`<3o`<3o00<00005`<3o0`0000;0`?l30000
0l30o`<00003`<3o0`0000C0`?l30000ol30oaW0`?l3oooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0?ooooo`<3o;<30o`030000`<3o000000<0
0004`<3o00<00030`?o0`?l00`0000G0`?l200000/30o`<00004`<3o0`00
0003`<3o0000000000800003`<3o10000?o0`?lI`<3o0oooo`:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P3oooool30obc0`?l00`000<30o`000003
00001L30o`030000`<3o000000800007`<3o100000O0`?l3000000C0`?l0
000000000004`<3o0P000?o0`?lI`<3o0oooo`:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P3oooool30obg0`?l400001l30o`@0003o`<3o><30o`?o
ool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0oooooo0`?l]`<3o1000
00O0`?l50000ol30ocO0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0?ooooo`<3o;L30o`@00008`<3o100001c0`?l30000ol30oaS0`?l3
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o;L30o`@0
0009`<3o100001_0`?l30000ol30oaS0`?l3oooo0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0?ooooo`<3o:l30o`H0000:`<3o1@0001W0`?l30000
ol30oaS0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo
`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?o
oooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0
`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30
ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o
ol30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo
`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?o
oooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3oooo
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0`?l3
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30ogC0
`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3ool30
ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3o
ol30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo
`<3ool30ogC0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?o
oooo`<3oI/30o`D0003o`<3o2L30o`?oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0oooooo0`?mW`<3o0`000?o0`?l:`<3o0oooo`:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P3oooool30ofO0`?l30000ol30o`[0`?l3
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooo`<3oIl30o`<0
003o`<3o2/30o`?oool2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0ooo
ooo0`?mW`<3o0`000?o0`?l:`<3o0oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3ooooi/30o`030000`<3o`<3o00K0`?l00`000<30ol30o`09
`<3o0`0000_0`?l500000/30o`D00006`<3o00<00030`?o0`?l01l30o`<0
000;`<3o1@0000;0`?l5000000?0`?l0000000000`0000W0`?l500001l30
o`<00003`<3o0P0000C0`?l3000000?0`?l0000000000P0000G0`?l30000
0l30o`800003`<3o1@000003`<3o0000000000<00002`<3o0`000>C0`?l3
oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooU`<3o0P0000O0
`?l200002L30o`L0000:`<3o0`0000C0`?l300001/30o`800007`<3o1`00
00[0`?l300001<30o`<00003`<3o0`0000W0`?l00`000<30ol30o`02`<3o
0`0000C0`?l5000000?0`?l0000000000P0000?0`?l400000/30o`<00003
`<3o1@000003`<3o0000000000800003`<3o0`0000?0`?l300000l30o`<0
003T`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3ooooiL30
o`<00006`<3o0`0000S0`?l300000l30o`030000`<3o`<3o00S0`?l30000
1<30o`<00006`<3o0`0000K0`?l300000l30o`030000`<3o`<3o00S0`?l3
00001<30o`<00003`<3o0`0000S0`?l200001L30o`<00003`<3o0`0000;0
`?l400001<30o`<00004`<3o0P0000?0`?l300000/30o`@00004`<3o0`00
00?0`?l300000l30o`<0003T`<3o0oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3ooooiL30o`<00006`<3o0`0000O0`?l400001<30o`030000
`<3o`<3o00O0`?l300001<30o`<00005`<3o100000G0`?l400001<30o`03
0000`<3o`<3o00O0`?l300001<30o`<00003`<3o0`0000S0`?l300001<30
o`<00003`<3o0`0000?0`?l300001<30o`<00004`<3o0`0000;0`?l30000
0l30o`<00004`<3o0`0000?0`?l30000j/30o`?oool2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0oooonC0`?l3000000?0`?l00030`?l00l30o`@0
0007`<3o0`0000o0`?l300001<30o`<00005`<3o0`000003`<3o0000`<3o
00?0`?l300003l30o`<00004`<3o0`0000?0`?l300002<30o`<00004`<3o
0`0000C0`?l300000/30o`<00004`<3o0`0000C0`?l300000l30o`<00002
`<3o0`0000C0`?l300000l30o`<0003Z`<3o0oooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P3ooooi<30o`<000000l30o`000<30o`03`<3o0`00
0003`<3o0000`<3o00G0`?l300003l30o`<00004`<3o0`0000G0`?l30000
00?0`?l00030`?l00l30o`<0000?`<3o0`0000C0`?l300000l30o`<0000?
`<3o0`0000K0`?l2000000C0`?l0000000000004`<3o0`0000C0`?l30000
1L30o`8000001<30o`000000000000C0`?l300000l30o`<0003Z`<3o0ooo
o`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3oooohl30o`@000000l30
o`000<30o`03`<3o0`000003`<3o0000`<3o00G0`?l900002L30o`<00004
`<3o0`0000C0`?l400000/30o`040000`<3o`<3o`<3o2@0000W0`?l30000
1<30o`<00003`<3o0`0000o0`?l300002<30o`@00004`<3o0`0000C0`?l3
00001l30o`@00004`<3o0`0000?0`?l30000j/30o`?oool2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0oooon?0`?l300000l30o`030000`<3o`<3o
00<00002`<3o00<00030`?o0`?l01<30o`<00003`<3o0`0000W0`?l30000
1<30o`<00004`<3o0`0000?0`?l010000<30ol30ol30o`<00003`<3o0`00
00W0`?l300001<30o`<00003`<3o0`0000o0`?l300000l30o`<00003`<3o
0`0000C0`?l300001<30o`<00002`<3o0`0000?0`?l300001<30o`<00003
`<3o0`000>[0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?o
oooS`<3o0`0000?0`?l00`000<30ol30o`0300000l30o`030000`<3o`<3o
00C0`?l200000l30o`80000:`<3o0`0000C0`?l300001<30o`<00004`<3o
00@00030`?o0`?o0`?l200000l30o`80000:`<3o0`0000C0`?l400000/30
o`<0000?`<3o0`0000?0`?l300000l30o`<00004`<3o0`0000C0`?l20000
0l30o`<00003`<3o0`0000C0`?l400000/30o`<0003Z`<3o0oooo`:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3ooooh/30o`@00003`<3o00<00030
`?o0`?l00`0000?0`?l00`000<30ol30o`04`<3o0`0000;0`?l200002/30
o`<00004`<3o0`0000?0`?l300001L30o`040000`<3o`<3o`<3o0`0000;0
`?l200002/30o`<00004`<3o0`000003`<3o0000000000<0000?`<3o0`00
00C0`?l200000l30o`<00004`<3o100000;0`?l300001<30o`800003`<3o
0`0000C0`?l3000000?0`?l0000000000`000>[0`?l3oooo0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0?ooooR`<3o0`0000G0`?l400001<30o`03
0000`<3o`<3o00K0`?l400002l30o`<00003`<3o100000;0`?l500000l30
o`<00004`<3o100000[0`?l400000l30o`@00002`<3o0`000130`?l30000
1L30o`D00005`<3o10000003`<3o0000000000800006`<3o1@0000G0`?l4
00000/30o`<0003[`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3ooooh/30o`<00005`<3o100000G0`?l00`000<30ol30o`0D`<3o0`00
04K0`?l30000ol30oag0`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0?ooooQ`<3o0`0000O0`?l300001L30o`030000`<3o`<3o01C0`?l3
0000A/30o`<0003o`<3o7L30o`?oool2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0oooon70`?l300001/30o`<00006`<3o00<00030`?o0`?l05<30
o`<00004`<3o0`000230`?l300007<30o`<0003o`<3o7L30o`?oool2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0oooon30`?l400001L30o`@00006
`<3o0P0001G0`?l300001<30o`<0000P`<3o0`0001c0`?l30000ol30oag0
`?l3oooo0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?ooooO`<3o1P00
00?0`?l700000l30o`@0000C`<3o100000C0`?l300008<30o`<0000J`<3o
1`000?o0`?lK`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3
oooool30ooo0`?md`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3oooool30ooo0`?md`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P3oooool30ooo0`?md`<3o0oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3oooool30ooo0`?md`<3o0oooo`:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P3oooool30ooo0`?md`<3o0oooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P3oooool30ooo0`?md`<3o0oooo`:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P3oooool30ooo0`?md`<3o0oooo`:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P3oooool30ooo0`?md`<3o0oooo`:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3oooool30ooo0`?md`<3o0oooo`:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P3oooool30ooo0`?md`<3o0ooo
o`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3oooool30ooo0`?md`<3o
0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3oooool30ooo0`?md
`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3oooool30ooo0
`?md`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3oooool30
ooo0`?md`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3oooo
ol30ooo0`?md`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3
oooool30ooo0`?md`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3oooool30ooo0`?md`<3o0oooo`:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P3oooool30ooo0`?md`<3o0oooo`:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3oooool30ooo0`?md`<3o0oooo`:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P3oooool30ooo0`?md`<3o0oooo`:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soooooooooog[oool2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hoooooooooomjoooo0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?ooooooooooN_ooo`:8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0
^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2h5P00P0<00H0200:0
00@00X400h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N2
0@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<2
3hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ8
0aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:
0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<5
9hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@
0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=980
0`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7
>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL0
10U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ
0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]C
W@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP
0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82
366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=
Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL2
3W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ
0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o
[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_
0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb
4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<C
Tk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL3
59bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i
0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/
_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o
0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1000P003VjOa
<d>U<d>U00Tc@jD600200`01P0800X001002P@03P@03P@03P@<0184200F1
00@01H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<1
2h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108C
Q`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT3
6HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS004
12B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>
1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A
0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`Lg
T`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F
00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH
2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:
D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh0
0`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ
0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eS
X`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP0
0`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@
O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh3
4H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::
/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?
/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf
0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P3
5Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<F
Z;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P03
5jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P3002000NKYo7ooon>N[JVVlBcZM:XWLRcZM800ZJK
a005_;SMk^kdj^Waoooo<d>U00D0080300600P02P00400:100>100>100>1
0`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49
P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:6
0P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P0
0`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<4
8X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h3
1BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`
T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLe
T`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF
0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P3
2DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:
CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP03
2eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<
GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R
008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU
10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X
3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@
NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhA
PJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/004
4XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?
/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je
0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN
^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<F
Y[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm
5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C08000008H
]<0@00000QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000BK
Yo7ooom/FZF_YLX2_;SM00[ooOncZM;ooooooonl^=fGR[bXWLSVi^cooolc
@jD400200`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X80
1X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@0
0`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<3
6hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=
12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5
:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9
AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YA
W@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]G
W`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW
3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mc
Z@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@
OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hA
Q:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H0
11BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ
_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P03
5k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HB928B92800a8T8P00`000<SP
f4R@R00=B92800@0000H]<0H]<38h=P>B92800<0000H]<0H]<000XS0^058
T8P10000000018S0^<SPf8S0^8S0^08008002i^WlOooojRMb?oook>YdV1<
VXij]WQU[ZRMb?ooooomo`03oooo00<c@jD0080008000`00P0<00H0200:0
00@00X400h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N2
0@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<2
3hD20Q250oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:
0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DV
S@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@
0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i82
1SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7
>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL2
24>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ
0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]B
W@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO
0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R
362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=
IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL3
3VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o
[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_
1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=
/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B
]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g
59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i
0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdF
ZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl0
0aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00f8`;P0
1DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0P00P00>VjOaoooooooofmc/H4bJThFj/jWB
_;SMH4bJVHnnYY_4b<?Ooooo<d>U1P00P0?oool200:000<00X7oooooool0
0_ooo`8018400`05POooo`05PP0300J21?ooo`030@R20@R3oooo00?oool3
0@Z300Koool12h@12h@138Coool138@20@f400Coool13XGoool13XD20Pn5
00Coool248Goool248D20Q6600?oool24HH24XH00P8BQP824hH0108CQ`8D
Q`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT0
10<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<
12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?
1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHb
T@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`03
1cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8
@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI
2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`0
10YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]G
WP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aN
X@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=
I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]
YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mc
Z0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`4
47f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^
00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::
/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<C
T;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI
]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh
00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/3
5ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn
0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`004b>3HR<2hR<2hR<2h1P00
00B8`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SP
f00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0`00P00>VjOaoooo_;SMVHnnooooe]7Mfmc/lokoYY_4k^kdQGJ`ThFj
oooo<d>U1000P007oooo006000600060oooo00:0oooo00<00h401_ooo`04
P@04P@05POooo`05PP801X802?ooo`07PP07PP47P_ooo`48P_ooo`48P`<1
2H<01?ooo`4:P`4:Poooo`812h@00`4<Q?ooo`4<Q0020@f400Coool13XGo
ool13XD20Pn500?oool248Goool00oooo`824HH30Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@04
0aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`4
98d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5
:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A
00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7
>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9
AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN
2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ
0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X
3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@
OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh0
0a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@
/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf
0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<F
ZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000C8h=R8`;R8`;R8`;P60000
18S0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8
`;Q8T8P000000QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0^004
B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<00800
3i^WlOoooiV?_YN:_=CCj>n//omfNnjOZe]HYJJKa9JOdV1<V[bhgOoooc=3
Y@03002000Ooool00H000H000H3oool00X3oool00`03P@06oooo00B100B1
oooo00F1oooo0P06PP08oooo00N200N20@N2oooo0@R2oooo0@R30`49P`09
oooo0@Z3oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?ooo`4>QOooo`4>
Q@823hD01?ooo`8@QOooo`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<K
R@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d4
9Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[
S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO
00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y
00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n
[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64
[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P04
59Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl
00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G
/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000
b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd
`003b>3HR<2hR<2h00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00:VjOaooooUhZl
NVbZ/lOXZFjPb<?OThFjFdJCVHnn0WQU[P04@RN5[jG:oooo<d>U1000P0<0
0H000oooo`02P002P@04oooo0P04P@03oooo00F1oooo00<01X84oooo00<1
288128<128<00`49P`09oooo0@Z3oooo0@^3oooo0@^4oooo0@b4oooo0081
3H@01?ooo`4>QOooo`4>Q@823hD00oooo`8@QOooo`03oooo0P8AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR003
0aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A
1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC
0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH3
23nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9
AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>
V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aM
X@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ80
0PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD4
3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?
LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1j
Z`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61
[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@B
RK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb
4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D3
59Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh
5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0
^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@00
08S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00hS0^0@00004R<2h00A8
T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003
VjOaoooooooo00;oool02_n]/?mfNoW=e?g]k_ooojJKa8Ef/;bhgOoooc=3
Y@D00803006000?oool00X000X400`03P@03oooo00B1oooo00801H401005
P_ooo`06PP06PP801h800`47P_ooo`48PP020@R30oooo`812X<01oooo`4;
Poooo`4;Q?ooo`4<Q?ooo`020@f400Coool13XGoooooool20Pn500Koool2
48Goool248D24HKoool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL2
0QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:
0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDU
S@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?
0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B
1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7
>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL3
24:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI
0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YB
W@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO
10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaP
XPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eU
Y0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW
3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY
0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@
OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l0
0a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@B
S;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<C
T[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK
]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T0
11FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l
5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o
5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002
R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSP
f8S0^8S0^004R<2h0P0000F8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P3002000ZQ[?;icMCR9Scd]KoR9ScdKGglhnWo
ooomkNko[K02oooo00<c@jD0080008001000P0<00H000oooo`02P002P@03
oooo0P04P@05oooo00F100F100F2oooo00801X83oooo0P48PP030@R3oooo
0@V300812H<20@Z300Coool12h<12hCoool20@b400Ooool13H@13HCoool1
3XGoool13XD00_ooo`030Pn50Q250Q2500Coool0108AQP8BQP8BQP8BQP82
4hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<3
6HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<
10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DY
SP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946
<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<3
1cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8
?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5
V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK
0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]E
WP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ
35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP02
3F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>
JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0ma
Z0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[
0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^
00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9
/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8C
Sk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<D
UkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PE
W[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk
0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^
_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2h
R<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000
R<2hR<2hB9280000008H]<000lSPf8S0^8S0^003R<2h100000B8`;P014R@
R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000fK
Yo7mkNkR9ScnmOSgRIOdHVkcX:kdHVkooOoo[K3lhnWooolc@jD01`00P0<0
0H000oooo`02P002P@0300>10`04P@801H401005PP06PP06PP06PP801h80
1@47PP48PP48P_ooo`48P`030@V30`4:P`030@^30@^40@^400<138@30@f4
0`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8F
Q`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<3
7HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd3
1BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6
;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHc
TP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9
BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd2
2e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;
FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<
H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]
47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<A
QJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d
4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLD
VkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[
_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0
^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8
`;R8`;P00XS0^0800002R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7fb<cR9S`00_n]/007
gb@^ojBNm[c5ojf`kW^<oooo<d>U00P00803006000?oool00X000X400`03
P@<0184200F100@01H801X801X801X8200N200D11h81288128;oool128<0
0`49P`04oooo0@Z30@Z30@^30P4;Q0<138@30@f40`4>Q@<23hD30Q25108A
QP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN8
0`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3
126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh0
0`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA
1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLe
TP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`Pm
U@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4
V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/3
2TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN
2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:00
10aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=
HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iY
Y@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?
LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X3
47V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61
[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;02
4XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P03
4hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E
]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`04
5Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X3
5ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm
00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<00
0lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0
000H]<0H]<38h=P00hS0^0800004R<2h0P0000:8`;P014R@R00001Rd`1Rd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7icMCgRIL0
0_ooo`07ojf`hAHdogIkojBNhRHlohUo<d>U00P00803006000?oool00X00
0X400`03P@<0184200F100@01H801X801X801X8200N200@11h8128812881
28<4oooo0`4:P`030@^30@^40@^400<138@20@f400Coool13XD13XD13XD3
0Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<F
R0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@N
RP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@03
1BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^
T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB
00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@3
1c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G
00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:
VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;
Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJ
X0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R
0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@3
3FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW
0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mf
ZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8A
Ojd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166
[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=
/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]003
4i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g
0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR
^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF
[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb
_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P90000
0XS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2002000NKYo7oooocX:kdHVkoooog
RIOicM@00_ooo`03lj2^oooo<d>U00P0080300600P02P00400:100>100>1
00>10`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R3
0`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH3
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8
h=R8`;R8`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SP
f00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0`00P00;VjOaooooohUooooolj2^lI>Qoooooogolj2^oo_l<d>U00P0
080300600P02P00400:100>100>100>10`04P@801H401005PP06PP06PP06
PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b4
0`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8E
Q`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<3
78X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd2
1BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5
;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86
<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@0
0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1
U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9
B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M
2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;
F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR
362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT
3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>
KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?
M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n
[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64
[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;40
11:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B
/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg
59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP
^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@F
Zk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG
/KlG/Kl00aNb_`<G/kl26;C03lSPf0030000b>3Hb>3H00g8h=P00`0001Rd
`1Rd`00?b>3H00<0000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0
^8S0^0@00803VjOa00KoooocX:kd]Kof_<GkfMXc@jD900200`01P0800X00
1002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h81
288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?
Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP3
5hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX3
11n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DW
S@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y02
1Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP03
1cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`Lk
U@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`04
2D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX3
2T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M
00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ03
35^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<
HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eW
Y0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>
L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX3
3gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]
0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl3
4XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8B
SK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C
]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<D
W;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T3
5J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm
0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l3
5k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PF00200`01P080
0X001002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<1
1h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j5
0`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<4
7XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd0
0`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6
;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHd
TP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD
0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3
U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9
BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd3
2e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<
FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaP
XP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT
0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_
Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?
MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd2
4Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@A
QZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8B
SK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@0
0a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK
]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<E
X[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m
5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o=QRd`0:8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;Qm
R<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058T8P10000
00000hS0^<SPf<SPf03ob>3HolSPf7g8h=P1B9280@000000ohS0^?n8`;R1
R<2h0@000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?oo
l?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`
l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003o
oo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;o
l?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo0`?oo
ol30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00
ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2
ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3o
ooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l0
0?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3o
P_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30
oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o
003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30
oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0
`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30
o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0
`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo
`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0
`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo
`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003o
ol30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o
`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oo
ol30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00
ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2
ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3o
ooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l0
0?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3o
P_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30
oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o
003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30
oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0
`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30
o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0
`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo
`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0
`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo
`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003o
ol30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o
`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oo
ol30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00
ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2
ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3o
ooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l0
0?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3o
P_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30
oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o
003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30
oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0
`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30
o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0
`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo
`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0
`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo
`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003o
ol30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o
`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oo
ol30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00
ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2
ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3o
ooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l0
0?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3o
P_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30
oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o
003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30
oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0
`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30
o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0
`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo
`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0
`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo
`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003o
ol30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o
`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oo
ol30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00
ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2
ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3o
ooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l0
0?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3o
P_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30
oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o
003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30
oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0
`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30
o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0
`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo
`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0
`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo
`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003o
ol30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o
`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oo
ol30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00
ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2
ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3o
ooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l0
0?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3o
P_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30
oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o
003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30
oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0
`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30
o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0
`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo
`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0
`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo
`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003o
ol30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o
`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oo
ol30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00
ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2
ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3o
ooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l0
0?oo`<3o7_o0`?l0AOn/`=?o/Ko3ojmlPonSFfkoV71nok2n__nDZZGoH75^
odABEomFGe[o@DLnocm1>?m>D4OoCU59oci2>_m0@SWoAdDhoeUB?omQGdco
GEm?oeQJC?lj@3Co@4Hooci6?_lmA3co@dQ1od14??mACckoLfY;ohb7L_nV
YYSoDEM?oc<m=Olc?cOo>D4jod15@?m6AC[oGdhcofMMBOm`K67oKfiXoh>1
MonKUhGo]:nBomcH[_oIfK3o`<N_om[Te?oOj]coen?KolC=b_m9E5Go:c@h
obTa>OlX<3Wo:S]<oba4E_l^Be_o=UIQoeQiOOmnViOoTjNNojRdY?nn`[3o
g=:hon_J_?o^gkgoln>mooKW_`3ool30oaoo`<3o003ool30oako`<3o01Oo
]<GBok35bonna<CoMfi`ogifNOnc`L;oOYbNodeVIolkBT[o@Ta8oci4?Oln
@S_oCDm9od56@?lj@3Wo@4Dnoda<@OmXHe;oJ6ECoe5B@om4AcWoATa0od16
?`02od18@00/ocm3?Oll?cOoCTdmofmWBonFTgkoWInBod57?Om0BD3o?DLn
odE<A?m2Acoo@4E0od5=@OmPIEOoRhEdoh=_FOn@N5goVhQ]ohj9L?n[_Jgo
W[jgoiFobOnB_L[oU[o9oiVm`_nE];Oo>E=Aobe1>_lO;bGo9C8WobHc;_lP
;Bko7C4aob0g>?lM=SOo:3`mocE4AOm3C4[oDUMDoeERGOmEJF;oK7ieoj6_
YOnia;[ool30oaoo`<3o003ool30oako`<3o04Go/lO?ok7@f_nDc<WoG7mk
ofAcM?njc=7oL9FModeTKOm5DE;o?DM2oce4?Oll@C_oB4e6odI;AOlg?c[o
?D<nodU9@?mKEdSoFEY;odiA@om8CCooATPnoca1>OloASko@dM0oci3??lk
@3SoBDPhog9/D_nSXXooPHAgodM<@_lmACWoAdm2od55>_m7B43oB4M1odQ9
@om=CTCoF5]9ofASBomdM5SoPH9YoiZOTOnhalco/L_Loik=honFbMooSK_=
ohjb`?mRPHWo<4A7obTd<Ola>37o<SD/ocXl;olk?boo=3X`oc8l=Olb>SWo
=Clooc@n@?ljA4Go?4E7oca9BOm2DU3o@5=?od5DCOm:GU@0ooo0`?lOol30
o`00ooo0`?lNol30o`15ojg>donRc]OoXm;Lojboc?nb_<Oo]<oJohFZ]OmZ
NhSoATmCoci4@?lh@3So?d<jodI8@Om>Ddgo>d4joce3??m9Bd3oE550oe5B
A?m9C47oA4LlodA7?_lnA3[o>T0iocm4?Oln@cco>clhod=4=omkNFCo]KJX
oeiQEom<D4SoBU16oda@@_m2@cGoAD<hodQ2=_mID3koBTLhod58?_m:EDoo
JWIbogJ2O_nJYZCo`LoBol;Df_nmemco]=3Dok_CeomeQHSo@4a>ocHn@?le
=cSo?ci0oclj?_m9B4?o@Cliod90>om1?ccoA4<ooda=B?m2ASko?dPjoce:
>Om4D4KoAU18od==A?m@F4goEEeB0?oo`<3o7oo0`?l00?oo`<3o7_o0`?l0
AOnXcm_oXloJokK<hOnja>7o]/WRohnc`OnN_lGoR9bQoeIMI_m5Ad;o>ch`
ode=@OmADDKoE5A:oc`o=_m2A3[oDU13of1IAom:Bcco@4Hlod57?OlnA3[o
?Clfod13>_lo@S_o?D0ioci1??m1A3[oOGi^okNi[OmHFU?oCU=;ode@Aom6
B3[oA4@fodY8??mBCT;oEeI1odi=?om0?c[oCD]<oemMGomdMGCo/KbholGK
f?o0f]Soa][Mol7@doo6e=CoEF9Noce8@_lg@cWo=d<hocI2=_lg@SOo=d0k
ocm3@Om3AD7o@44lodI5@?m7AccoCU0modmD?_m9DSOo@dhnod=<@omAF53o
EEaDofM/H`3ool30oaoo`<3o003ool30oako`<3o03OoZLgTojgAhOnac^3o
Y=3Uog^]`_m9JgOoSZZVoiRl/omJIF_oD5=<odmA@om?CCooG5U=of9RE_m0
@CWo@d@hoe9@@_mSG4WoDUA6od98@?lm@S_o>Chgoc/n=?m6AcooA4M0od=5
@?m1ASoo@DHnoh24M_nZ[:?oEeYEodaABom4Acko?d0cod52=Om=CD3oEe=8
oeMBA?m<BCoo@T0jodU5@_mNG5KoQ8=nolK@b?o5f]Go`=cLol3KiOo5gNOo
ZKk3od1@DOlg@d7o<chhocHo=olg@CSo>D<j00;o=T<i00co>dHlod17??m6
BCkoC4m1oda>@?m@DD?oD5=2oeEC@omFDdGoEE55oe]LC_mcMVSool30oaoo
`<3o003ool30oako`<3o04GoZ/kVojc>ionNdN?oJjZgobmOK?lhBE7oDfMO
oi2dYomGIVGoK75ZodmAAOm8B3_oE5=9of1QFOlj?cWo?D<joe9DAomLF4So
B4a2oci8@?lj@C[o>3hgodQ9@?m=CTKo@D8moci0>_lnA3ko@TQ1ohF:Oon;
ShWoE5YFodM<Aom2Acoo@4Hiocm2=om2@c_oBD/ooeMHA?m@D47oA40hoda4
@_mPFEOoQhB0olgCd?o6g=So`MoOol7MhOo1f=ooTj>Wod5;C_lf>cco>S/m
oclo@?lo?D7o?CPooca3>olg@SCo>d@hoce5>?m1BCkoADY0odQ=@om?D4Wo
D55:odm@A_mDEd_oD4m7oeAEC_maLVX0ooo0`?lOol30o`00ooo0`?lNol30
o`15ojG?honUdngoNkS>od]dQ?mNIg;oEdiEoe1MEom[P7[o=dI0odiHD?m5
Bd;o?d<jodA7?om;DDco<chjoca4?om<DDSoCe53oca1>OlmAT3o>40hodI;
A?mADDWoBT]3oc`l=oll?SWo?d<ood=7@_n@UhcoLgUbod]?ColnA3oo?4<k
oce4>_loACco@DHood=5??mEE43oDU90od=6=om1ACWoFEeCoh:6POo<eMOo
bmgWolSOk?o;gnGoc]kQojNa/Om7CT[o@DA0oc/l>?m0@3go?SlmocPk>_lj
>CWo>c/joc`o>_ll@S_o@TU0od5;?om4Bd3oB4]1oe1BBOm@E4_oE5Q?oeIJ
D_m=D4_oJfm[0?oo`<3o7oo0`?l00?oo`<3o7_o0`?l0AOnPe^SoVLkSog6U
]_mPNHCoKW9hoeeGFOmKHF3o@4M6oce6@Olh@T3o=d4joc]1>OmBEDgo?4<h
oc8k<Olf?SSo?D4mod50@?lg?3Oo@4Q0ocXm=?mCE4[oCe56odE7?olf>SGo
=SXfocm3@Om4BD?oSiJ>ofQ]JOm8C4_o>d0ooca0>olm@SSo@DHnod=8@om0
@SgoEeA5oeACA?m?DD3oAT/loeUKD_n3R8Coc]OJol_Ni_o7gnSobMgYom3Q
jOo7d];oCeIBoce2??lh?cKo>T8goc]2>Oll@C[o>cXkoc/j?Oll?C_o?d0l
od16?Om4BckoB4i0odY@@Om?DdGoD5=8oe=FD?mJGeSoBU19ofQ`J03ool30
oaoo`<3o003ool30oako`<3o03OoVM;XoioCi_mmYK3oJHJ:ofenOOmEGeco
Jg5/odmECom6BTSo@4U:oc]2@?lk?SOoFUe?oeiQDOm1B3So>3hdoc`l>_lk
=cgo=STkoca3?Olm@3GoD515odU;@?ln@S[o>3`iocHj>?m1@T3oAT]6ogb4
OOmJGegoATY<ocdo?_lk?SWo?d8iod55?_m1Ad7o?d8moeYGB?mDDd7oDU50
odU8>om@C4SoQHF7oloGg?o;hN3oa>;RolSQk_o=h>koZkJjodI@Colk@d3o
>44locY0>olk?SWo?Chh00;o?D0n00co>Sdhod12>omBEDcoCE53oe1DAomH
G4koFemAoeIIDOmCEU7oEe]Fod]@B?m/LF[ool30oaoo`<3o003ool30oako
`<3o04GoX]Sdoj3Bj_nOb=OoP:6UodmYIom@IE_oNhQnoeMOEom5C4CoB55<
odM<Aolo@3WoBTY1of]/G_mGFDco?d<hod52??lh=cSo>Cdnoc]1@Olc=cCo
DE9>oc`m>Olh>SGo>S`iocHf=?lo?S[o@48mofQcJomNIV?oBTi>ocXn??lj
?3Oo@DDlodQ;A?m2Ad;o?SlkoemLD?mCDT7oBT/iodQ;?_m@DdooVInRol[H
g_o5gN7ob>CXolCNj_o=h>coQi>Eod=9A_lk@Sko>44locU0>olj?c_o@40k
od94@Om2A3oo?d8loca0>OmGFU7oKG5UofmbI_m_LFOoIfUOoeMJEOmCE5?o
F5YIodm@C_mUJFL0ooo0`?lOol30o`00ooo0`?lNol30o`0]oj7BlOnSd^co
YmGUohni`?mcV9SoLY6;ohNMU?mTM6[oF6AJod=:@om5AT7o@3`god=0=omS
HEGoJ6YModiAA_m7B3koAdLoocPh=Om?DE3o?Ci0ocXk?Oli?3_o>3Pgoc`m
>?ld=Boo@3ljoca0>OmnRH?oIFe]od97B_lh>cco?3hkocm5?_m8CTKo@DI0
oc/m>?mGDdOoF5M8odm@@?m9Cd?oDEUHojfl`?o:g^Ooamo[00;obN?^01Ko
c>3WofIbL?loAT3o>D0ioca3??lk@Cgo>T0locm0>om2A3oo@D<nodE8@Om0
A3go?T4hodA7??m8C4;oATQ0odA7@?m=CdgoD55DoeAEEom=CU3oIFIWooo0
`?lOol30o`00ooo0`?lNol30o`15oj3=k?nXeo7oWM3Soj;Ch_nOcmOoRkBj
ok3?d_nJ/[KoJGZ0od19A_m5Ad7oA48modDo>?m:ACooNG]`of9UEom6BC_o
FEY<oda5=omIDDGoFeQAod94@Om7BdSo@D8ooc/l=_lg>S?o?48koe1HD_nN
ZZKoHfi/odE=ColoATKo?dA0oc]0>Om0ACgo>CliocXo>OmKEdgoGE]=oe9C
A?m>ET_oBeeIokS>doo7hNkobN;folOPl_o5hNcobn3Soe9NF_loASoo?D8k
ocLn=oli?c_o>Slkoce0>_m3ASooA4Q0od53??m1A3_o@TDlod=6?Om1ACgo
?d8mocm1??m5B4CoCTm<oeAFDom;CD[oHfER0?oo`<3o7oo0`?l00?oo`<3o
7_o0`?l0AOnPc^SoXM?/oioFjonQf^goXMO[ojCGj_nYdnOoZL[QodQRN_mZ
N7_oBe5@od11?om8A43oAT4kofMYG_mWJego@4<doeQJC?mZGDKoLV97ohAm
Jom0@ccoGV=MoeiPFom2ACco=C/aod5;@Om<FU;oZ[VfofE`L?m3CDoo?dM8
ocm4@?lj@3So?44koce4?Olj?cWoAdLnofaZGOmXIeWoEE]AodmRGonkeM_o
`N7^olGQm_o7h_Goan?]om?XkOm>FUSo?T@noc/o>Olh?COo=S`hocTm>Oll
?SWo>Slhoci3??m2AT3o?dHlod57?Om6C4;o@dM1odA8@olk@3co@DDnoe=E
ComGFU?oEEQAofAXHP3ool30oaoo`<3o003ool30oako`<3o027oWM3Xoj7E
kOnKeNgoW=OaoicHl_nQfOCoZ]Sgoj[Cl_maU;?oEfehodiIG_mAEEOoC4Y7
ochn=_m0@cSo?48docTo=?m:CDCoPGEKoin>L?n]Z9GoADa5odiFDOmRIf3o
EeM;oc`n;om5BckoAU=:ok30_OmCHF7oAE1BocY3A?lnA4000_lh@3P08_lj
@C[o>3hhoc0c:_m^KV?oIfEIoe=ECOm2D4oo[lW?ol;Sl_o2h_OoaN7golCP
kOo?inooA51@oce3?olj>cOo=cXeocLm>Oli?c_o>Sliod57@?loA3ko@TM1
od57?om0ASco@4HoodM<AOm2B47o@DM3od96?Om@DdWoDeU?oeMOEomSKFCo
ol30oaoo`<3o003ool30oako`<3o04GoVm3/oi[Ak?nIeO3oWMSfoi_FlonO
f_KoXMScojGFkonRd>KoVkS7od]MIOm;EEWoEe]Iod=5??lm@CCo>d8focHn
=Olb=c;oOgEPojfRROng]jcoBeIGoci8B_mJGESoLFYMode6=OmLEdOoHVQL
ojBg]Om/O7coA4mBoce7B?llAD;o>40hocU0>?lj@CWo>3hioble;OmGEDco
G5=9oe=@BOm0Bd_oRjBYokoSkoo2io[o`>3eol;Pkoo?iO3oBE=God14@_lk
>cWo>S/ioc/o>olk@cko?48koci3?_ll@3co?dA0od15?om3Ad3o@TLoodI<
A?m3B4?o@4E0oce3??m9CTKoDEMAoeMQFomPK6@0ooo0`?lOol30o`00ooo0
`?lNol30o`15oiW@k_nKd_3oUm;`oi_Gm?nLeoCoVmOboigGk_nPf^goY=[[
ojg>h?m:GV[oBEEJoeYNG?m6BT;oBE12od16>OloACco=3LeoeEB@_nBSWco
_<Food=AFOljAD[oDE1@ogY^H_mhJ5GoN6]Dog1]H?nL[JcoXk:eod=@Dolk
AdSo?4I1ocY0>?lj@CSo>D0iocDk=olh?cOoATDmof=JD?mRFE?oFf9RogR=
U?nigNWo_nKhokoRm_o4hoGob=o/odQCF?ll?T7o>S/ioc`o>oll@3go?TDn
ocm7?oloA43o?T=0oce3?_lm@Sco@TM0od=7@?m0ASkoAD]3oce2??m0ACoo
Ada6oe5ED?mHH5goHfm^0?oo`<3o7oo0`?l00?oo`<3o7_o0`?l0>?nHd_3o
V=?aoiWElonKeO;oWMGcoioHmOnNeo7oX]ceoicDkOm^Tk;oEVIeoeMLGOmL
GUOo@DM0of5UF?mVHe;oHea>odM7@om2A43oEEUCoj:/Z_m9DeOo>3m3oci2
?Om^J5goRW]SoiJ2HonHS7WoYJjdol7Af?m;GF?o=dQ:oca6?OmIG4oo@d@g
ocm3>Olj?c_o>CXkoci2>OmUIEOoGUQ<oeYJFOmfQhko_^Caok?Olonkh_Oo
_^3colkUl_m4D5Ko>d0oocTn>_lk?c_o?D<ooc]4?_lnA3ko?44k0olm@S`0
2_m1AT3oA4M2odI:A?m5BTCo@4@noce1@_m:BT_oFU9>of1OG_m`NhOool30
oaoo`<3o003ool30oako`<3o03SoUm?coiGBlOnFdo3oVmOdoigGm_nKeo?o
VmScoioImonNe_CoTK[Noh2J[?mPKG7oFf1KoeMIE?mIFE?oKfiOofi]GomH
FUOo@4A1odE;@om;D4_o?dA1ocTn>_lg>3;oFUM9oiV>Mon[Vh3oZjJDokG8
coo5f^?oF6ieocI6B_lf?cSoGEeCoe]JD?m2@cco?d91ocTg>_ln@3WoHf=F
of1HC_mNG5goSYVUok_Okoneh_Go_>;gokkPloo:h>oo@DiDoc]0?oli>cOo
>3`hoc]0?Olm@coo?48loca1>`;o>d4k00_o?T<lod57@?m7CDOoBTm9odM:
A_lm@cco=SlmodM:BOmHE4koGF1SogB7U`3ool30oaoo`<3o003ool30oako
`<3o03KoT]7boiCCm?nEe?GoUmKgoiWGm_nNfoWoVmSgoi_Im_nPf_[oXmCi
ohZbb_m?JG?oH6Y[ode:B_m=B4GoIFMKoeiVFOmGFUWo@TQ0od57>?m5BC_o
BDdooclo<_m8B3Wo?3X[ogYfHoo3_jWo_LRmok_Oj?nlg^OoKh^DocQ;DOlm
@d?oCTa5ofERFomBDDko?3`locXf>Om7Ad7oJ6MKofiWGom_KG3oXk2lok_N
lOngh?Ko_n?jokoNloo5g>[o@4aBocTl?Olg=cGo>3Xhoci1?_m0AD02oce2
?0Co?44k00Wo?d@nod56@?m3Ad;o>T0ioc@n>_m4DDSoDeI=odmKH?mcSZH0
ooo0`?lOol30o`00ooo0`?lNol30o`07oi3@m?nCdoOoUMGhoiCDn?nDe?Oo
UmKgoi[InP02oiWHn@0^oigDnonRe_;oD7N5ocU8ComKDUOoFU9@oe]OE_m9
E4[oCU==od55>?mFFT[oL7=RoeIE@om9ASGoAd@dodQ9>oli?3?oVInGokO@
dOn]h?7o]=o_ogjKZ_m0DU_o=c/nodM5@?mTGeSoH65Godm?Aoln>S_oA4Dn
oeUKComOG5GoEeYNoiN[^?nhg_7o]nCkok_Pn?nnh?Kob>;aod9?Eolk?Coo
>CPhocXj>?lo@3ko@48nod12?@;o?d@n00co@4I0ocm5?olk@3[o@4@nod15
?om2Ad3o>d0joc50=om4DTOoCeM<odaJHomlW[Wool30oaoo`<3o003ool30
oako`<3o00CoSLodoi7Bn?nAdoKoTmCg0_nEeOT0<OnHf?[oU]KioiKEmonG
dOKoX]_fof>AXomRMhCoK6U`ogUdN?mXL6co>T@lof=UF_mDET[oDeI;oeEF
B?m[J5OoKFIFof9PD_m3A3koADm>oi2OXonbd^3oZ>3iokKPmomfTJ?oAUAP
ocPi?_m2@3_oH5i@ofYXEOm`KegoBDE1od55>_m>EDGoE5M@oe5LH_nH]<;o
[Mc^ok;Un_ndh?Go^]odol7LkOlmBU?o>C`ooc/i>Olm?3[o>c/kocm1?_m3
AD000_m0AD403?ln@coo?T=0od15@Om0AT;o@TM3od16@Olg?3So;SXaod9>
@OmHFe;oDUmXogJF]Ooo`<3o7oo0`?l00?oo`<3o7_o0`?l0AOn@dOOoTM;h
oi3AmonAd_OoT]?hoiGEnOnFe_[oV=SloiOGo?nOg?_oX=Wgoik>k?nB]L[o
ZK_7oj>`^OmQKgKoFVAToeeMDOmVIUkoCTm9od92>_mNG4ooG5Q<oeiMD_m0
ACoo@4]?ohJHXOngenOo[=_eok;DiomCIgKo<S]4ocdn@?lk?3GoBd/log9d
G_mcLE[oKfQMoeQKB_m:DCooC5=;oeAUJ_nUa]Co[N7foj[Smonah_Wo]^7f
okgMk?lgADko>3Xnoc/k>olm>cco>3Phoci1?Om6BdGo?dA0oce2?_lk@Cgo
?44nod56@_m0AT;o@DI2od97@olm@Sko=ClhodA;@_mJFU;oG6=[of^3WP3o
ol30oaoo`<3o003ool30oako`<3o0_n@d?H0@on@dOOoT];foi;BmonCdoSo
T];hoiKEn_nHeo_oTmC`oi_GnOnOdOWoY]KeojODionbe^OoFg65oci7D_mZ
K63oIfQPoe5CC_m>CTKoF5Q=oe5BAOmFF4ko@dY3ocU6A_mdQXWo^mCNok3B
h_mAIfooAe5EodM=C_ll?Sgo<SPcod12>?mSHe?oOgQVog]/G?mfLEgoKW5L
oeeRF?mHJ77o]]OXojoVnon/i_co[n7hok7PmOo4ioOoA5IOocLm@Oli>C_o
?3Xkoc@f=Olh?CWo?dDoocY0>oln@coo?dE0ocm4@?m0AD7o@DI2od55@Olo
A43o>T0kobhi<oloB3ooGUiDof5WJ_mYOY00ooo0`?lOol30o`00ooo0`?lN
ol30o`0kohk?mOn>c_CoTM7goi;Bmon@d?CoTm?goiCCn?nEdoOoUmSjoiCH
m?nJeokoW=;ooiWEoonIg_OoV];/odQWQ_lZ=4WoCeE=od]>A_m7BDCo=cT`
oeaODOm5BC[oDEE8od17?OloC4KoI7Aaoib`/?mBIfWoBEIBodA8@_m5ACko
?Chloc4f=_ld=cKo@40jogabIonAOFWoS7mXogmkIomjNW;oQ96Iok[Ik?n_
ho_oZn?lojoPn?n/gOCo]=_/oc]?Eolc>Cgo>c`mocXj>_lh>S[o=S`hoc@k
=?lj?c_o?D8nocm4@?m0A4000_m1AT802?m1AD7o?dE1oc]0??lf@3ko?4M0
oe]LD?mZKfcoGg=mooo0`?lOol30o`00ooo0`?lNol30o`15ohc>mon<coSo
TM7hoi;An?nBd?KoT]7goiKDn_nEeOSoUmKkoi;Em_nMfO_oV=CkoiSGo?n?
f?SoUmSioe^4Y?liCEkoF5aFofINEOmjKVOoPg]]og5^FomBDSooEeM:oeAE
ComFFeWoIFi/oi2MV?m3CdSo@DHnodE6??m6A3co?3`hocTm>olc>3Ko<SLb
oe9?AOnBQ6_oU8UdoiZBQOnMWYko[l7?okSOlon/ho[oYmohojkOmOn^h?Oo
V<3@oc14C?l_=CWo<S@bocPh=olj?c_o>T4locQ1>Olg@3So>d8loca1??ln
@Soo@TQ5od=7A?m0AT?o?d<oocPl=ol^>S[o>dI1oeMHC_mSIVCoGfik0?oo
`<3o7oo0`?l00?oo`<3o7_o0`?l0AOn9c_SoRloioho?n?n?coSoT=3hoi;@
nOnDdo_oU]Kkoi?EnonDe_coU]KioiSFmOnGe_KoTmOloiKGo_n7_=WoHh>B
ofQ^K?mfJFCoPW=[ojVPSon7QFcoFeM2oeeIB_mXHegoHF9PoeiUHOnQZJCo
Be57odY>AOm9BCooAdDlochn=_l`<B[o<cLaob/d;ol]=b_oMgMOoiF?P?ne
/:ko];o;okOHjon^g_GoYN7iojWQn?n_h?Oo/N3hoj35fOl`A4go<3Hjoc<e
=?li>cSo>d0moc]4??lg@CWo>44hoca3??ll@cgo?TA0od57A?m3AdOo@TI5
od94@?lk?3Oo:SHdocQ2?OmHET_oIVMUofIbO@3ool30oaoo`<3o003ool30
oako`<3o04GoRLkgoh_>mon=c_SoS/khoho?n?nBdO[oTm;koi?Dn_n@doWo
TMGooiCEoOnFeOWoUMGhoi7Eo?n@d_goVM7foiJne_nJ[K[oY;Bgoj6b[onX
]jooHFeQofM/GOmVIeCoK6eMoeeSFOm;FE?oYk:/od98@?mAETcoFUYBoeME
C?m=Bd;o?3`dod53??ld>37o<CL]ocDh:_mkPggo`]7GokgMkOnag_Oo[Mon
ojOPoOnWgo_oZmohok;Pn?nZcN7o<dE?ocDk?Oll?C_o>c/hocPm=oli@S_o
>dDmoca3>olk@S_o?4<moci4@?ln@T3o@4A3od14@_m1A43o>3Tdoc8l>_m2
BDCoGea@ofa]J?m^O8D0ooo0`?lOol30o`00ooo0`?lNol30o`15ohO<mOn8
cOKoRlkhoho@nonAd__oT=7iohoAnOnAd_[oSm?joh_Bo_n?d_goT];ioi?C
n?nAeOcoTMCooiGDo?nKd?;oXL_Toj?@honOcmko]]c_od]QKoli@dCoKg1V
og5bH_mIHEKoE6=RoibZZOm2Ad3oC4i8oeMGComUHESoKVaPof5ODomBD4Oo
D597odM8@_lj?d;oOI2GojoDh_njk?ooXm[iojGLoOnWg?coYmklojONn?n^
f_Co/M;UocE6C_lf>cco?3`ioc`m>?lk?C[o>ClkocY1>_lmA3co?4<koca2
>olm@Sco?dA0od55A?m1AT;o@TE1ocTk>?lg?T7oB4a>of9MF_m_KWCoNhVL
0?oo`<3o7oo0`?l00?oo`<3o7_o0`?l01On4boGoQ/_eohO<m_n:coSoS<oi
00;oRlkh03koSM7gohgAn?n<doooS]?lohoAn?nAdOGoS];gohoCo?nDfOoo
U]KloiC@m?nDeoSoVMgnoigBo?m2GX?o<SeAoc/j??m>BSooGEiHof5ZLOmf
P8Ko@TM1odE7@?mJFU;oH5eCoeaHCOmPG53oLViSoh5mL_mHEE3oD5AOogVB
XOn]g_3oX^;mojGPoOn]gOko/MkoojcNnOnXg?Go/]cdokgJk?m1CeSo?D10
oc`l>_lk?3Oo>C/hoca1?Om:CdSo@DLmod56?oln@cgo?d<nodI;Aom0AD7o
?dA0oc`o>old=S?o@4E0oeQID?m^JUkoK71_ogV<W?oo`<3o7oo0`?l00?oo
`<3o7_o0`?l00on4boOoQLchohO>n003ohO>n00ooh[?n?n;dOWoSM3joh[B
n_n<d_OoS];foi3BmOn>d_GoSmGhoi7Ho?n?f?goT=Wloi7LoOn=e_SoW=Sm
od5UROl_?e;o>C/nof]WG?mbKfKoJFa/og]oP_m0AD7o?T4jodi@BOmEE4[o
E515og5/HOmkMV[oN7=VoeYEComAE5koNi>SojkNl_nVh_koZ=ojok7Mn_nc
f??o]Mogok_Xooo2iogodNcmod1=EOlk?coo?cllocho>_m0@Soo?T8nod=9
@_mHFe;oA4Pnod54??m3AT3o@T@ood53@?m0@Soo=c/goc@i=Om7C4KoFeeC
ogEaI_m[MGKoQj6e0?oo`<3o7oo0`?l00?oo`<3o7_o0`?l0AOn3b_KoP/_f
oh?<n?n5co[oQ]3johK?mon9d?_oSM;lohcAnon?do[oS];gohgAmon=dOSo
S];hohoCmon@e?SoSmSiohoHnon?fOOoTM_eoiCDl?nMcNCoJ8JCogJ7R_mo
QgkoNGmdofAZHomCEe?o@dE1ocm0>omDEDkoGEeDod]8?omZIecoL6aRog]e
K?mBCDSoD55Gog^?W?naf>ko[^3kok3Pnonmi_ko`>GkokkTnonhh?[o_n;i
olcVmom9Eeco@4I5oci0??m0@Sgo@DI2od14@?m4BT?oH69HoeIHCOm5B3ko
?d<locXl>?m2A47o@48nocHj=olk@3coCE9@oeiOG?m_KVSoGV]eoi:fc`3o
ol30oaoo`<3o003ool30oako`<3o0_n2boP0@on2cOOoP/khoh;?n?n4d?Wo
Qm3hohS?n?n9coOoSlkgohk?n?n<d?_oS]7ooi3BoonAd_[oT];goi7Dn?nA
eOSoTmSkoi7FmonIg_coVmWboiC2fOn4Yk_oSJ>doh6AVOmAGEoo?dU8ocPh
=_m<C4OoIFEOodm@B?m8B3goHf=HofITFomZIEooDe5<oe]QH_n7Uj?o_]_d
okOOoOnhh_co^N?hokWRlonih_Oo^MoiokoRnOoEkoooCE]Qoci6@om2AD3o
@4E0od16@?lnA43o?T8moeYLComNH5?oCDm5od12>om1@cko?d0mocTj>?lc
>3Co@dM3odmEDOmNHecoJ6]Poe]aKonD`Lh0ooo0`?lOol30o`00ooo0`?lN
ol30o`03oh3:mon1boSoPLgi00;oP<cg043oP/khohG>nOn7c_SoR/oiohg<
m_n>cOSoSLonohgAoon>d?ooT<okoi?An_n@d?CoT]ChoiCEoonBe?ooSmCj
ohoDm_nIe_WoWLoeojS<lOn]an;oCfMfod=?E_m6AT;o?CdhodQ8@_m6Acoo
@T<loeUKDomXJV?oJFQSof=UGomSK6_oNXZGol?Km_nef?Oo]=ohokKTnOnj
i_So^^ClokGMmonjgoKoanCeodYIG_m1BDKoA4U2od58?_loAd3o@DQ2oca4
??mGFDgoH69Foe]MDom8BT;o@T8moce0??li?3Wo>ChiodI;AomGG5ooIf]]
ofAXJ?mUOHGoV<OJooo0`?lOol30o`00ooo0`?lNol30o`15ogg:m_moboOo
P<[hoh;<n?n5cOWoQLchohK<n?n7cOOoQ/ggohW=mon;c_WoR/khohk?nOnA
d_goTM?koi7Amon>d?KoT=Cgoi3En_n?e__oT=KgoiCIm_nHf_WoVMOhoikD
m?nZeNooUkS>ohFFX_mjMgGoPWmgof]WGOm>BT;o@dA0odmCDomMH5ooEeUD
oeiPE_mWJVgoMX>DokkHl_nfg?Go]>;hok3Qn_nahOoo[MgmojgOn?n`ho_o
`^Kkod]IHOm6BdKoAdY1od5<?Om1Ccoo@dm1odI<@?mCEe3oHV=MofIVFomR
HEGoADLmocm4?Olk@Sko>40lodQ>C?mPHecoJF]VofY[M_mbRZ7oW/oW0?oo
`<3o7oo0`?l00?oo`<3o7_o0`?l0AOmiboSoO<_hogo9m_n0b_OoP/choh?<
nOn4boSoPlcgohO@n_n:dOgoRLoioh_@n_n=co_oSlojoho?n?n@dOWoS];h
ohoCn?nCe?coU=GkoiKEn?nIf_[oW]oooi_Lo_nJeoWoXmKdoj[DkOnZa]Oo
VYnSoiNHUOmmNg;oHUmGodM8@om>D4ooDeICoemQFomMGeOoHfUXogF4Toni
f?;o[]_dojcPm_nWg_WoZ=goojKKnonVfoCo[MghokSJl?m=Ef7oBDY;odI7
@Om5CD7o@Tm3odE@AOm5CD?oDEI?ofAVG_m[JUgoJFMHoe1AA?m1ACgo>T8m
oce2?omAEU7oJ6YQofa^J?mVJgOoOIfgoi_Bl@3ool30oaoo`<3o003ool30
oako`<3o00KoN<Whog[;n_mmb_SoP<_koh?<non2c?T2oh7;n00mohC>non5
cocoQ<ghohS@non<dO_oS=3johg>n?n>d?WoTM;johkBnOnAd?_oV=7moioH
oonOg?ooVm_ooiKKoonJg?ooW=OjojGKn_naf_;oY[[6og^9S?mJGU_oH61I
of5QFomMGeWoF5YEoeUKE_mHFU7oHV]VogB7U?nbeo3oX]S`oj;OnOnNgO_o
WmcooioJn_nQf?7o[=C]okSAi_mCFFCoDDmAodm>BOm:CdSo@Da4od==B?m5
BdOoBDm8of]]H_m/JekoK6UHof]/G?m:CT;o?T@lodE9@_mKGeOoLG9Vog1b
K?mSL7coR[CAoiSGn@3ool30oaoo`<3o003ool30oako`<3o04GoMLWhogO9
nOmiaoOoNlOgogg9n_n2c?_oPL_jogk<n_mnboWoOlcjoh??o?n7d?koRM3l
ohc@oOn;c_WoS/kioi3@n_n?d?[oTLokoiC?nonEd?SoU]GhoiKGnonBeoco
TMKmoiCDn?nNfo_oYMSfok7Gk?n4WjgoEVAYod55@omZJV;oL75Yofa]I_mZ
K6OoBTa7ofM_J_meRYKo[=;]oiOCkonJg?WoUmSioiWGo?nPfOOoYMO[okKD
ionCYK?oDUEJoeIED_m>CdOoBdi7odI>BOm2CDWoA4e:odM<AOm[JeooKVaL
ofm/F?mdLf7oHVIHodI<@Om2ACcoI6EMogMdJOmcMG3oKX:=oiG8iOnAf?/0
ooo0`?lOol30o`00ooo0`?lNol30o`15og;6mOmda_KoN<Siog_9nOmlbO[o
Ol_logk:nomlb_SoN/Oeogc:n?mocO_oP/cjoh7:n?n:c__oS<oloi7AoOnC
doooT=7kohkAnOn<d?OoUMOioi_Lo?nCf?OoT=CgoiGIo?nIf?_oW]Kjoj3F
n?nSf_WoCgB=odEKJolf?T;o@4<loeMIC_mmOgKoJfaUoeIGD_mZKVSoLXBC
ojC:j?nMf?[oUMOioiWHo?nHcoKoW/gYoj78f?nL/KgoEF1Tode@BOm;BSoo
CTm2oe1DA_m5Bd?o?TPood=>A_m5BT?oIVQLog1^GOm]JEOoIfIDofMZFomK
GeCoH6=Hog5cJ?n:QggoPhV5ohFS[_nBcN_oT=Wm0?oo`<3o7oo0`?l00?oo
`<3o7_o0`?l0AOmebOSoM/ShogS9n?mkb?WoOLWjogo;o?mkb?OoNlOeogg:
n?n1c_coPL_hohC=n_n6c?[oRlkkoho?oOn@d?coSm3johkAnon=e?goS=Gj
oi?HnOnGf_OoU]SgoiOKoOnGfOcoW=KkoioDnOnNe_WoTm?ioe5nX?lhEVoo
=TEAoci4@_lo@SSoD557ofm]IomLF5GoHF=Qog:4U_nYd?GoUM3hoi3AmonI
e?[oY=;foeMgS_m6GfOoAeAFodY@C?m=DD;oD590oe1A?om=D3ooBe55odA=
@_m2Cd;oADa4oeYLDOmaL6;oKfiLofESE?mWJUcoIFYOofQ[HOmjNW3oQXJ5
ohNDW?nE`=7oT]Ofoh_Dn@3ool30oaoo`<3o003ool30oako`<3o04GoLlGd
ogG6mOmiaoOoOL[kogo;nomob?SoO/Sgogo9mon0c?SoPL[hoh78m_n6boWo
RLciohc<n_n@d?goTM;mohg?n_n?d_coSm?oohgAo_nBdoWoTM7doi?DmonD
eoWoU=KkoioKoonPf?goV=Ckoi?Foon=`>Wo@FB5oc57FolkATWo?dHmoe9B
BOm]IfCoFe=Aofe`L?mbQi_oW<S^oiGCo?nCe?_oUm7eojgEn?m0EFOo@Tm@
ocY0@?li?cWoCE=3odmC?Om?DcooC4lnodI8?Om3BT7o@Ta1od9;A_m?E4co
JV]QofUZG?mSIEOoJ6aPofM/I?m]L6WoN7UaogZ1RonA[LCoUM3ZohWIn_n?
f?l0ooo0`?lOol30o`00ooo0`?lNol30o`0@ogG7m_mea_GoN<Kdogg7mon0
bOSoP<_iogk8m?mmb?GoP<Wgoh?;n?n9c__oS/omoh_<n_n=cOWoSloloi3@
n`;oSM7h03?oSlgoohk<oonCc_coT/gfoi3?mon?dOWoSM3ioi;Bn_nDd?So
Sm3fohc?n?nJcOSoN9k5odURO?ljB57oDEQAogAcK?n5NgWoL6MVog1iN_md
SZGoWlohohkBnon=d_WoTlocojkFl_m1Dego?4<oocm1@_lg?3So@TXkodQ?
?Om<D3ooCE12odA8@?m3B43o@Da2od5;Aom8CDSoHfEMofa/GomXJEcoIFYR
ofebJon0QGooR8Z4oi:R]OnLa>KoRm?eogoFoOn7eol0ooo0`?lOol30o`00
ooo0`?lNol30o`15ogg5l?mna_7oPLObohS?n_n6c_WoOlOcogg5l_mob?Co
Plcioh_=n_n@dOgoTm7mohk>nOn=cOSoS/kjohc>nOn<co[oRlkhohc<non>
bogoS/cloi3@non<coWoR/oioh[>n_n=c_WoSloioho?n_nBdOcoU/cioiO3
k_mjVK_oK7b=ohB8Ron>S8_oSHR8oh^<TomhSZ7oQJW8oic?n?n=d_coS=;j
oi;@lonScn[o>dmIocDm??lj?Cco@DI1oce4>_lm@cOo@DDiodI8?om7B4;o
@dDnod16?_ljB4Go?d<nof=OEOn4OWCoN7I^og9fL?n4R8?oVJ2NoinY[onP
a=koTlodohWDnOn6eocoRmOn0?oo`<3o7oo0`?l00?oo`<3o7_o0`?l0AOn8
a^koS<_eoi3@nOnIfoooTmOnoh?:m?n2bOCoP/_goh;<n?n9boGoS<_gohk?
n?n=coWoRlkiohS;m_n8c?[oR/gkohW=n_n:cO[oRlokohS=n?n9c__oR<ch
ohS=n_n;c__oS<gkoho=o?n>c_WoS/oioho?nonDc?[oU;oVoi6]b?nGYKCo
WJ^foin_^OnM]lKoV;oRoiO6k?nEcOOoS]7lohS@n_nAd?KoW<[UocA;E_lb
?3go=C/gocTo>Oln@cgo>3`eocXn=_m2ASooATM1odA6?_m4ACoo=4<nocm7
?OmACD;oU8j6oi:FUOn?VIcoVZNYoj>e`?nU`m[oULkaoh[DnOn8doSoRM7h
oh_Bn@3ool30oaoo`<3o003ool30oako`<3o013oSm7koh_?n?n9c?KoR/oj
ohG=momob??oO/Scogg8mOmlb??oP<SfohG9n?n7c?[oR<glohO>n_n5c?[o
QL[i0_n6b_T0<on5bOSoR<chohK=nOn5c?SoQlokohO>n_n8cO[oRlkkohg>
non;co_oRM?johSAo?n8co[oT<ojoiO;k?nHaN;oW<_Uoic>ionGd>coULc_
oiC?l_n?d?WoS]7noho@o?nCcoKoSkSBocM8D_lg?3go=SXiocHk>?lk@3co
?d0loc/m>Om0@Cgo@4<mod52??lo@Cco>4E0oc]1>_m5Ad3oGFEWoj6haonM
`=GoWlGJoic8honEb_;oSM3iohSDnOn;eOcoR];joh_Cn`3ool30oaoo`<3o
003ool30oako`<3o00ooPl_dogk5komka>ooNlG_ogc7lOmjao?oN/Sdog_:
n?mkbOSoNlOhogc7n_mlb?[oO<Siogk8momob_T00_n2b_X2oh?;n`0QohC<
nOn4c__oPL_hoh?>non4c_SoQLkiohO>n_n9cO[oRLkjohO@nOn6dO_oR=3o
ohW?o_n;c__oSLgioh[<mon6c_WoR=?mohcBm?n<dOOoS=7kohc@oOn?c?[o
VlkdogbP^_ljBE3o>3XjocPl>ole>CSo=3PgocHk=olj?CWo@D=000;oA4I1
00oo?d8moc@o>Olh?SSo=clnob]0COnIb>CoSL_^oho@mOn=dOWoPlooohGA
non4c_GoR=;iohG?m_n:e?/0ooo0`?lOol30o`00ooo0`?lNol30o`05ogFo
k?mf`>goN<GaogC4k_me`nl00_mdaO801?mda_KoMLSgogS:o?mibO`2ogS8
n`0Aog_9n_mlb?[oO/[jogk:nommaoSoPL_jogg:momoc?[oO/_iogk;momm
boOoPlgjohK?o?n5c?[oR<_johc<n?n<c?X00_n<c?`05On>c_koS<_nohc>
oon>dOooQLgmoh[Dnon:d?WoR/kkohk>o?nCc__oVlcaoeaoUOlcADWo>d<o
ocHj>Ol`=3Go>CdlocDi>?lh?3co>Cdloca0?@02ocm5@@0>od=:@om0ASoo
=dE7oba:G_n=angoQm7nohOCoOn6d?[oQ=KoohKDoon7d?WoRMClohG@n?n:
e_kool30oaoo`<3o003ool30oako`<3o01;oL[o]og;0k_mc`NooL/?_og;3
l?mdaO;oL/CcogC6mOmfaoOoMLSjogC7nomeaocoMlSkogK6nOmgaoWoNlWi
ogW7momkbOT2ogc:nP0aogk<o?mmc__oO/cjogg;nOn1boSoQLkkohS?o_n:
dOooRM3lohc@n_n<cOSoSLchohg=nOn;c__oSLkloho>n_n@dO_oRm3joh_=
nOn<c?[oS/ckoi;<n?nHb^koA6Yooc=8BOlhA3go=3Xioc<g>?lh?3go=c/j
ocPl??lj?Sgo?dA2od98A?loA3oo?TDmod16?oliAd[o=5IYoh_9l?n5co_o
QLgeoh_AmOn5c_OoQM3iohSBn_n7d_[oPlkfoh?@m`3ool30oaoo`<3o003o
ol30oako`<3o0_m`_N/03?m`_^coL;o]og32komdaO;oLL;`og;4l_mda_Go
MLShogG5momea_SoM/OhogG5mP;oM/Kh00?oN<ShogW9n_mhb?T00_mhb?T0
4?mhbOSoNL[iogS6m?n4c_goQLkkoh;9n?moc?SoOLkjoh7=mOn6coKoQloe
ohG?n?n5co[oQlohoh_@mon@d?H2ohg=n`0=ohc<n_n>c_coTlohoiC8jOll
HWGo;Cm2ocLm>?lh?3[o=c/locPl>olf>CSo>3`locLl>P02od=9A@0;oc]1
?Oll@c_o?D8locY8C?loH7CoRLC/oh?<mon6b_;oS<kaohO;l_n3cOL00_n1
coP00on2coWoQM;kol30o`3ool30oako`<3o003ool30oako`<3o00coL;cZ
og2mjoma_ngoLKo]og70kOmd`O3oLL3^og?2komda?7oLl?`ogC2lomfa?<2
ogS6mP05ogK7m_mfa_OoM/KhogO7n?mgaoX00_mhb?X0;_mhb?WoN<Whogo<
o?n2c?_oPLWfoh?;n?n4c_koO<kmoh?<m_n7cOGoQ/kfoh?@non1d?ooPlom
ohO=mon<cOOoR/chohc>o?n<cocoR<ghohc<lonGb^co@65fobXc>_ln>c_o
=cTiocXn?Oli?C_o=3PhocHl>_le>cOo?T<ooce5@OlkACgo?DLnocY1>_li
Ad[oBVZ0ohC2jon4c_coP/[dohG<m?n2b_WoPloloh7@nOn0c_P2ogo;m_oo
`<3o7oo0`?l00?oo`<3o7_o0`?l0AOm/^^SoL;g[og:okOm`_^coL;c[og;0
k_mb`>goLl;]ogC3kome`o3oML;_ogK3l?mga?;oM/CcogK4m?mgb?OoMlOg
ogG7momea_WoMlOiogS8o?mjb_[oN<Sjog_9nOmmb?OoPL[hohO;n_n5bogo
PLSlohG7mon;boKoR<[hohC<o_n2c?ooQ<goohW<o_n>cO[oR/okoh[?n_n7
coWoQlkhoh_;l_n9^mko<e1Woc@g?olo=3Oo=CHfocLk>Olb>3Co<3HbocHk
=olg?CWo>D<koc]5?OllASko=d<ioc]3?OlkBU;oCW:9ohC4komobocoP<_i
oh;>o?mmbokoOlkloh3>n_n2co_oPm3loh;@o03ool30oaoo`<3o003ool30
oako`<3o04GoK;_Xofnmjom^^^SoL;g]og:nk_ma_NkoLKo_og71l?m``_3o
L;g^ogG1l_md`O7oL/3`ogO5m_me`o?oM<;dogG5n?mfa_[oN<KjogS4n?mj
ao_oNLWiogS8nOmiboWoO<Wioh7:nOn4bo_oQLcmoh;:n_n1bOSoQL_iohO<
n_n7cOcoQLgkohK=non6c?WoSM7loh[:l_n;cOGoR/ogohW=monAbo;oQK;C
oceHK?lk@TGo=cLcobX];?la=cGo<SPfocDk>?ld?3So=d4kocU4??lnB43o
>D<jocM2=?lj@43o=DYIod1cSOmmbNgoP/[hoh?:n?moc?SoO/ghoh3;mon4
c__oQ<kmogk:nOmob_P0ooo0`?lOol30o`00ooo0`?lNol30o`07of^gj?m_
^ncoL;_[og6kk?m`^N_oL[_/og6lkP02og:ok`0log>ol?mc_nooLl3`ogC1
lOmc`_?oM/CeogO5m_mda?GoMLGhogO6n_mhaOWoNlWjogK6momgaoSoM/Sf
ogW8n?mnb?WoOlShoh39nOn1c?[oP<Whoh79nOn2boOoP/_hohC<nOn7c__o
Q/choh[?non8boSoPl[eoh?=mon3boGoSL_cogj^coliF6go=d=5ob/_:_lN
9B7o:S4^obhd<?l/<boo<cXfocLm>Oli?cco@TY2ocU0>_ld?c?o?413oc=7
F?m1M93oO<W]oh3:mon5b_SoOlchogo>n?moc?_oO<_gog_9momnc?[oNLSh
ooo0`?lOol30o`00ooo0`?lNol30o`0BofRdiOmX]NKoKKOWog:jjoma^N_o
L[[/og:lkOmc_NgoLkg^og:nkom`_>goL[o_ogC2l_mb`?3oLl7bogG3m?mb
`_?oLl?d0_mda?D0<OmgaoWoM<KfogO:n_mhb_WoN/_jogg;nommbO[oO<Si
ogc:n?mmb_SoP<_joh;<non5c__oQ<_hohG;nOn2bOSoQLcjoh;:n_moboWo
Olkloh3;n?n6b?3oSlGWoef1U?lhBT_o<c/doc0g<?l/<Rko=chiocHl>?lg
?3Oo>3lkoc`o?Olm@Soo=CTgoc<l<Olm@4Co>DaModeoVommb^ooOlOfohK;
non1co_oOLchogg=n_mkc_[oNLchogO:nOmfbOP0ooo0`?lOol30o`00ooo0
`?lNol30o`0<ofVij_mW]nSoJ[SYofnkkOma^n_oLK_/og2lkOma_NgoLKg^
og:okOma_^coLKk]0_ma_nl01_me`o?oML?dogC4mOmda?GoM<Kfog?5m@;o
MLOg0_mfaoL06OmeaoKoM/OfogO7momhbOSoNlckog[;n_mlb_[oO<Wgogk8
mon0bOSoQ<_joh?:n?n6c?goPL[mogk;o?mlcOcoOlcjoh[=m_n?aNOoU;W<
ofYlO?mRJf7oDEQ@od=:@ola>3400_lb=c<04_lf>cOo=SXiocPl>old>3Wo
>d8jod14Aom2E6OoGY2]ogS6k?n2b_[oPLSjogk;nOmlcO[oMlWgogO;n?mi
cO_oN<cjogW=nooo`<3o7oo0`?l00?oo`<3o7_o0`?l02_mT_>coH[SYofBh
iom[_>coJ;SXofjlk?m^_^goJk_Zog2nk_m`_N/2og6nk004og6okOmb`?3o
M<;bogC2lP;oL/;c03?oLlGdog?6mOma`o;oM<KeogC5m?mgbOWoM<Kfog?5
mOmgb_WoM/[jogG9n?mkcOgoO<glogc:n_n0c?goO/Shoh7:nOn2b_[oQ/cm
ogk6m_mnbOSoP<gkoh;=mon5aNgoTlOVofJ7U_mIJ6GoI6YMoeaTF_lf@3So
;SD^oble<?l`=C7o=CXfocm2@Olf>S[o<CHgod58@Olo@dSoB5eaof^O_Omh
ankoOLOgogo8n_mib_WoN<_gogS:n?mhbOWoMlWiogW;nomjbo/0ooo0`?lO
ol30o`00ooo0`?lNol30o`0:oebhjOmO^^WoHKOXofBij?mV^>SoJ;SYofNi
iomY^nWoJ[_Xog2mj`;oLKk/0_ma_nd2og?1l@;oL/?b00SoLL?bog;4m?mc
aOCoM/Ofog;3l_mda?GoMLOgogG9n0;oM<Sh02WoM/[iogG8n?meaoOoN<Si
og_9nOmja_OoO/Wjogo9n_n1bOWoP<Oeogo8m_n0b_OoP<WbohW7kOn:^mSo
<e1Poce8A?mAEDSo<3P`obHa:Ol/=C3o;CHaoc0h<ole>cOo=S`gocLk>olg
>cWo>D@lod56C_lgCV?oGiFdogW;lOmkaoOoNlSiogK8momcb_OoMlWhogO8
nomgao[oN<SiogW9nP3ool30oaoo`<3o003ool30oako`<3o00[oGKSYof2i
jomT^>WoI;OXofNfj?m]^N_oKKWZoffijOm^^nWoL;cX0_m`_N/2og2nk00d
og;0komb`?3oLL;aog;3l_m``NooM<Kcog?4lomb`?3oMlKfogO5m_mda?Go
L/Ofog78momdaoSoMlWkogO;oOmibo_oNl_logo?oomhbOSoN/ShogW7n?ml
b?WoP<Shogo9momoc?OoPlcgohO7k_mk[<co<4mRocQ3@ole>C3o;STaobPd
<?lX=Bko:cL`oc0j=?lh?c_o=3`hocHk=olh?c[o=T8iod57C_lhDFKoIYnn
og32j_mgb?SoNL[jogC:mombb_OoLlWjogG8nP;oM<Si00?oMLWhol30ooo0
`?l0ooo0`?lMol30o`00ooo0`?lNol30o`15oendiomO/^KoIkS[ofNejOm/
]N[oK[GYofjdj?m_]NSoKkGVog2lj?m__>SoKkcYog2mjom`_^coLKo]og;0
l?m``O3oL/?bog30k_mca?3oL/?`og?1lOmga?CoMlGfog?3m?mba?KoL<Kg
og77momda_SoMlSkogS9nomgb?SoN<WiogG7n?mib_[oNL[iogc:n_mlb?Wo
N/Siog[:nOmnboSoRL[dognae_lcDfWo<Ci3ocHm>Ol[>3Co93<^obXh<ol[
>37o;3P`oc@n>?lg@3[o=d4iocQ1>OliBCkoBE9Ioc]FJomSWKgoL<O^ogC8
momgb?[oLL[hog3;n?m`bo[oL<Wkog3:nOmbb_[oLl_k0?oo`<3o7oo0`?l0
0?oo`<3o7_o0`?l0AOmK/nSoFk3Uof>fk?mV]^_oJ;KYof^ej?m/]NSoK[KY
ofngjOm`^n_oK[c[ofnmjom^_>[oL;gZog6ok?ma_ngoKl3_ofo2koma`O3o
L/;`og?2lOme`o?oM<7bogG3m?mb`_CoL/?fog74m_mba?GoMLKeogK7momf
bO[oM/SiogW<oOmhb_[oN/[jog_;nOmkbOOoN/[hogS:n?mhbO[oN/[kogk6
m_n3_NOo;EIaobXoAol/=c?o:cX`ob@b;OlT<S7o;3Phobdi=_lh@c_o?DPo
ocU2?Old>c[o?TU2oci?EOllGG7oKJS6ogC2jOmfa_?oMlSfog79mom/b_Wo
Kl_kofk:n_m^b_WoL<ckog7<n`3ool30oaoo`<3o003ool30oako`<3o01Oo
Ek?WoeVdj?mM]>WoG[CXof2dj?mV^>[oIkOYofZhjOm]^N[oJk[[ofbjj_m_
_>_oL;g[og>ojoma_^[oL;oZog30kOm``^koL/7`og?1lOmc`_;oLl7aogG3
l`02og;2l`;oL/;e02[oLl?dogK7lomfbOGoMLWgogG7nOmgb__oMlShogW8
n?mmboWoO/ghog[<momib_SoN<_kogO:oOmjb_coPLObodZ0WolVAe?o9c`j
obLi:olW=bco7b`_obPc=Ola>SWo?TY1ocm;@Oli@Soo<3Tiod16A?lmCeKo
=UeaofjWb_mk`ngoN<G`ogK7l_mab?GoK<ckofk;n_m^b_WoL<[iog7;nom`
bo[ool30oaoo`<3o003ool30oako`<3o01CoE;3Toe^ejOmN]N[oGkKYof:h
j_mV]n[oI[KXofZhjOm]^N_oKkc]offij_m`^ncoK[_Xog:ljOm`_>SoKkkY
ofnnk?m_`NkoL;o^og70l0;oLl7a02ooML?cog;2lomb`_?oLl?dog?3momd
a?GoM<GbogC6mOmdaoOoLlSfogS;n_mhb?SoNLShog_9momkb?OoN/_hogO8
m_meb?KoM<SiogK8momi`nkoOKWKobE<H_lS?TOo838^obDb:olX=33o9BlY
oc0i<_m4CTKo>T@locDo>?ld@C_oA4M9od=CH?liGg[oJJG>ogFokomca?7o
LlKaog;8l?m`boOoL<Whog37n?maaoSoM<[kogC8nP3ool30oaoo`<3o003o
ol30oako`<3o01CoE[;UoeZdj?mK/nGoFk7ToefbiOmS]^SoI;KXofNgiomZ
^>WoK[[/ofbhj_m^^N_oL;WZog:ljomc_N[oL;g[ofnmjom`_^koKkk^og70
l0;oL/3`00CoLl;bog71l_mb`_?oL/;c0_mc`o<09Omca?7oM<KeogG7m_md
b?OoMlWiogO8n?mhb_SoN/_jog_9nOmibO[oMlSgogK8n?mfb_SoMlWhogK3
l?mm`>[o@7:Eoam4G?lP<cWo8S4^oc4m<ol^=BWo;C@Zoce2??m0AT7o>TDl
ocE3=om3ADCoAUARod1VPoma[=SoML?dog;4m?mda_?oL/O_og;7l?mcaoH0
0_mca_P00omfb?[oMLOiol30o`3ool30oako`<3o003ool30oako`<3o00go
E[;UoeFah_mK]NOoGkOYoenfj?mO]NKoI;OYof>eiomV^>SoKK[^of^hjOm]
^>WoK[SY00;oL[c[00WoKkg[og2mjom`_^koLKo]og70kOmb`>koLKo_og;0
l?ma`_400oma`O80:_mb`_?oMLKeogG7m_mda_KoM<Keog?5m?mdaOCoMLKe
ogK7m_mda?GoN<SlogK7n?mgb?GoM<OcogK:momda_GoMl7`ogJch?l_GXOo
9T5Gob<f??lX=B_o=3X]ocLi<?le=cCo?dE3od=>A_lkC3coBDa3odEGGOln
IgooKk7Gog32l_m`aOCoLLGbog33kOmdao7oMLWgog;7nOmaaoSoL/Siog36
n?oo`<3o7oo0`?l00?oo`<3o7_o0`?l02_mD/>7oEk?ToeJ`h_mL]NOoF[;T
of2fiomQ]nOoHkOYofFhj_mX^>/2ofZgj@0BofbhjOm_^NSoKkSXofnkjOma
_NkoLKo_og2nkOm`_^coLKo]og;0k_mb`?3oL<3`og72lOma`O;oL/;cog71
l_mba??oMLKe0_mdaO@07_mea_GoMLOfogG7m_meb?KoMlWiogG6nomgb?So
MlSeogK9lomdb?KoL/SgogS8nomna_SoHYo=ocANOolL?Dko93Xhobhj<_l`
=Rko=SPeod]@C_m3CDSo=4@godUCB?m0FEWoCgj>ogRog_m_a>goKlKcog?6
lP;oMLKc00?oL/Ofog38n?m`b?P00_m_aoOool30oaoo`<3o003ool30oako
`<3o01OoDJkOoe>`h?mC[n3oF;?UoeRbhomJ/^;oGkCUoeneiOmP]nSoHKGW
ofFej?mZ^N_oKK_/ofjjjom]^^SoKk_/ofnmkOm^^ncoKkk/og2nk?ma_ngo
L/3^og:okP02og31l00/ofo0komc`o?oLL?bog73lomfaoKoLlCcogG3lOmg
b?GoLlGdogG7m_mebOSoL/GhogC7nomea_KoN<OfogO9m_mcb?GoM/ckogC7
nOma`O3oMko]of>NaOl]G7[o7d1@obPl@?l^>3Oo@dQ5oe9GE_m1Cd[o<D4n
oci?C_lmGVKoCH>Iog>mgomaaNooL/KbogC8l_mfb?CoMLSfog78n?m]aoOo
K<Sfofo8mom]aOGool30oaoo`<3o003ool30oako`<3o01GoD;3MoeFagomF
/^7oE[7PoeJ`hOmG/^?oGKGWof2hjomQ]n[oH[CXofNijomW^>[oIkKWofbi
jOm[^>SoK;WYof^kj_m[^n_oK[c[og2nj_ma_nd00_mc`Nl04?m``NooL/?b
og72lOmc`o?oL/?bog73lomb`o;oM<7`ogK3l_mea?7oLlCaogC7mOmdaoKo
K/CeogC7nOmea_P2ogO5m@0LogC7momfb_WoM<[iog?7lomib_?oN<?^of2M
a_lmIXOo@EY]oe5NI_mTJFGoHV]VodmLG?m0CeOoA5Y^ocmWQ?mIT[[oL;[V
og74l_mdao7oMLO_ogC5l?maaOCoLlOgog36momaaOOoL/Ghog34m_oo`<3o
7oo0`?l00?oo`<3o7_o0`?l01_mA/=koDZkNoeB`gomF/N3oEk;QoeRbi0;o
G;CV00KoF[;Tof2fj_mS]^SoI;KWofNhj?mY^NT2ofVjj@05of^kjom]_noo
L;k]og2ojOma`>/00_mb`>h0:_m_`>coLL;aog72lOmba?;oL<?aog32m?m`
`O3oML?bogK4komc`^goMLObogC7mOmba_GoLLOhogC8nOmfaoWoN/Ohog[8
n?mfb?SoM<SjogK=nombb?3oM<O^ogC7m?mi_o3oIiK0of5lV?mUMX7oKgYd
ofehKomQKG3oD61/odAMO_llIY;oIj3Dog>ml?mda_OoM<G`ogG6kOmeao3o
LlOdog74mP;oL/Cf00?oLL;dog?3m_o0`?l0ooo0`?lNol30o`00ooo0`?oo
ol30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00
ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2
ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3o
ooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l0
0?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3o
P_o0`?l00?oo`<3o8?o0`?l00onWYmkoTI71ojNWgP03ol30o`03ojNWg_nA
TL7oYjON00?o`<3o00?oYjONoi6A`OnWYmh06_o0`?l01?nh^?GoRXZhog]k
Y?nTY=X7ol30o`07oj>SfOnOWmCo_;cjol30ooni^OKoZZ[Sok6ak03ool30
obOo`<3o003ool30oaoo`<3o01CoZJWQo`410_l0003o0@42ojVYhOo0`?oo
ZJWQo`410_l0003o0@42ojVYhOo0`?ooZJWQo`410_l0003o0@42ojVYhOnB
T/;o>3Q;o`<310;o000000Oo4a<IofMWROo0`?oo`<3oohF5/Olm?E7oF5Qe
00;o`<3o00?oMGFLoalO:Ol000000ol000003?lH627oLG6Gol30ooo0`?oo
DE5/o`410Ol0003o3@dAoa`L9_lK6bGoCDeWokVimP;o`<3o00goV9S:oaXJ
8_l0003o0000o`<31?mJFWWo;2`lo`000?l10@7oA4ALok>ck_mLG7_o2PX>
00?o000000?oDU9]okFelOo0`?l0ooo0`?lMol30o`00ooo0`?lOol30o`0A
ojb/iOl410Ko0000o`@41_n/[>Go`<3oojb/iOl410Ko0000o`@41_n/[>Go
`<3oojb/iOl410Ko0000o`@41_n/[>D00_o0`?l01?nOWmCo0000o`000?nX
Z>03ol30o`04oeEELOl0007o0@42oiJFb0?o`<3o00GoHf>4o`000?l0003o
0000okVimP02ol30o`0<oemOOol0003o0000ob<S;onl_?_o`<3oof9RPolH
623o;2`kokJfl_o0`?ooAdMO0_l000001?lA4AOoF5QfobTY=ol51@L2o`00
0004obd]?OmJFWSo`<3oohR8]@;o000000?o61PQol30ooo0`?l0ooo0`?lN
ol30o`00ooo0`?lPol30o`03ojj^j?nNW]?o[ZkX00?o`<3o00?o[ZkXoijN
don^[^P00oo0`?l00on^[^SoWYkCojj^j004ol30o`03oa`L9_lF5QgoUYK8
00?o`<3o00Go92@`o`000?l0003o7AdVokVim`02ol30o`08oj6Qe_l0003o
0000o`000?nWYmoo`<3ookfmo?l>3Q<2o`000009ogmoZOo0`?oo`<3ookno
o_lY:COo20P;obDU<_ni^OKoDU9]00;o000000CoEEEaol30oonm_Oco=cM:
0_l000002?n2PZko_;cjoknoo_nk^oWo1PH9o`000?l51@Oo_[kmooo0`?lO
ol30o`00ooo0`?lcol30o`03odQ8H?lZ:SSoLG6G00;o`<3o00Ko/k?^o`00
0?l0003o0000o`/;3omHF7D2ol30o`07oknoo_l:2Pko0000o`000?n3Pjoo
`<3ooj2Pe@03o`000005oj6Qe_o0`?oo`<3ool30oomdM9/00_l000001Omb
LYSoWYkCo`000Ol0003o?3a@00;o`<3o00CoJf^?o`000?l0003oH6200oo0
`?l01?l];Cco0000o`000?nMWM7ool30oaoo`<3o003ool30oc?o`<3o00?o
L72EobXZ>Om9BF800_o0`?l01on4Q;3o0000o`000?l0003o5ADMoa@D6onF
U/P00_o0`?l01_lc<dGo0000o`000?mKFg[o`<3oojFUg0?o000000GoZZ[S
ol30ooo0`?oo`<3oojb/i@02o`000008oadM9_no_okoRh^io`X:3ol92@co
KfnDol30oonCTl@2o`000005ocTiC?o0`?oo`<3ool30oomEEG400_l00000
0omeMIco`<3ool30o`3ool30oago`<3o003ool30oc?o`<3o00?oV9S:oaXJ
8olQ8Bd00_o0`?l02_mDE73o0000o`000?lJ6R?oSHfloaHF7_lM7BOo^KWg
ol30oomKFgX2o`000004oc<cAOo0`?oo^KWfo`/;3`;o000000?oUiO9ol30
ooo0`?l00_o0`?l03Ol51@Oo0000o`000?n>S[go`<3ooj^[i?lo?eCo5ADL
ob/[>On;Rk[o0@42o`000?lA4AL00oo0`?l01?mlO:Ko0000o`000?m=CFOo
ol30oaoo`<3o003ool30oc?o`<3o00Ko^k_io`D51ol51@Oo^KWfol30oolS
8bl2o`000007oda<IOo0`?ooCDeWob<S;omHF7Ko`<3ooh>3[`02o`000004
o``<4Oo0`?oo`<3ooeYJN0;o000000?oMGFLol30ooo0`?l00_o0`?l01?lF
5Qko0000o`000?miNJ43ol30o`04ojf]iomNGWgo8R8]o`820`;o000000Co
ZZ[Rol30ooo0`?ooY:CK0_l000000olU9C;o`<3ool30o`3ool30oago`<3o
003ool30ocCo`<3o00Co9bLeoahN:?nBT/;o/[;]0ol000001omlO:Ko`<3o
okJfl_lF5Qoo4a<IoiJFb?n[Zn@00ol000001_nTY=[o`<3oojf]i_l30`Go
0@41obl_?`Co`<3o00So4Q8Io`000?l0003oNGVRol30oom<C6Go;blnogMg
W`;o`<3o00CoATIMo`000?l0003oPh>^0_o0`?l01Ono_oko20P<o`000?l3
0`Co^[[h0?oo`<3o7_o0`?l00?oo`<3o=?o0`?l01?m?Cf[o;2`jofYZSOn3
Pjl3o`000008ojn_jOo0`?oo`<3oohb<^_lE5Ago7AdWokZjn?lB4QP2o`00
0007ogalYOo0`?oo`<3oog1`UOl10@7o0@42oinOe002ol30o`0<oj6Qeol0
003o0000o`820on`/>[o`<3ooaDE7?l0007o1`L9ok^knOo0`?ooHF610_l0
00001OmTI8Go`<3ool30ooo0`?oo92@a00;o000000?oUIG7ol30ooo0`?l0
ooo0`?lLol30o`00ooo0`?ldol30o`04ogMgWolY:CKo@T9Hoe9BKP;o0000
00?o7QhYol30ooo0`?l00_o0`?l01?m<C6Go8R8^oeQHM_lk>dl2o`00000:
oeADL?o0`?oo`<3ool30oomnOZSo3`lEoaDE7?nSXmWo_konod92F@;o0000
00WoGemool30ooo0`?ooP82[o`820_l10@;oK6b@okfmo?m2@UL00_l00000
1OmbLYSo`<3ooj^[i?m>CVWo10@500;o000000?oKFfBol30ooo0`?l0ooo0
`?lLol30o`00ooo0`?ldol30o`04oinOe?lE5Ago6QXSob8R;P;o000000?o
D51[ol30ooo0`?l00_o0`?l01?ne]O7o5QHNoa8B6Om=CFL2o`000003ob`/
>oo0`?oo`<3o00;o`<3o00OoUIG7ocloEOlM7BKo20P<o`D51olG5akoKFfA
00Co`<3o00SoUIG7ob`/??l>3Q?o1PH8o`@41Ol=3A7oD51Zokfmo0;o`<3o
00Go];C`ofa/T?lI6B;o3`lDodI6G@3ool30oako`<3o003ool30ocCo`<3o
00?o_[kmo`L72_l71`T00ol000000on1PJco`<3ool30o`03ol30o`03ohZ:
^?lE5Ago5ADL00;o000000?o1`L9okjnoOo0`?l01Oo0`?l2okjno@Wo`<3o
0_nl_?/8ol30o`;o^[[hooo0`?lNol30o`00ooo0`?leol30o`03obl_?olB
4QWo000000;o000000?o/k?^ol30ooo0`?l01?o0`?l00om:BV?o7AdWo`00
0002o`000003oibLd?o0`?oo`<3o0?oo`<3o>Oo0`?l00?oo`<3o=Oo0`?l0
1Om<C6Go0P83o`000?l0003o8b<_00Oo`<3o00?o];C`oaDE7Ol000000_l0
00000om`L9Go`<3ool30o`3ool30ocWo`<3o003ool30ocGo`<3o00GoC4aV
o`000?l0003o0000oeADL008ol30o`06ohV9]_l0003o0000o`000?l/;3_o
_;cj6Oo0`?l01?nRX]So?SiCoc/kConJV/gool30oago`<3o003ool30oc?o
`<3o00OoXJ7Fod92F?l92@go0P83o`820_l>3Q?oRHVg00Wo`<3o00OoCdmZ
o`P82ol20P;o0`<5oa<C6OmOGgko^;Se01Oo`<3o00CoMGFLo`000?l0003o
:BTgooo0`?lMol30o`00ooo0`?mQol30o`04ok^knOmNGWgo?SiCogalY_oo
`<3o7Oo0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003o
ol30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o
`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oo
ol30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00
ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2
ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3o
ooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l0
0?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3o
P_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30
oooo`<3oP_o0`?l00?oo`<3oJoo0`?l00onn__goYJGLoi6A`@03oi6A`@03
oiZJc_nb/^go`<3o0?oo`<3o3_o0`?l00?oo`<3oJoo0`?l00onk^oWoMWJM
oa`L9@02o`000003o`410_m>CVSoW9c@0?oo`<3o3oo0`?l00?oo`<3oKOo0
`?l01?n=SKco0000o`000?lZ:SWool30oa7o`<3o003ool30ofgo`<3o00Co
UIG7o`000?l0003o<c=5ooo0`?lAol30o`00ooo0`?m]ol30o`04oiJFb?l0
003o0000oc@dA_oo`<3o4Oo0`?l00?;o`<3o0_nIVL`6ol30o`;oUIG72_o0
`?l01On/[>GoO7bVogIfW_nTY=[o_kon01_o`<3o00?o][KboiZJcOnSXmT0
2?o0`?l01On/[>GoO7bVogIfW_nTY=[o_kon02;o`<3o00Go_Kglohn?__m[
JhooR8ReokRhm@06ol30o`07oj>SfOnOWmCo_;cjol30ooni^OOoZZ[Sok2`
j`02ol30o`08oiJFb?l0003o0000oc<cA?nEULOoL72Eoh61[?n`/>/6ol30
o`07oj>SfOnOWmCo_;cjol30ooni^OOoZZ[Sok2`j`0?ol30o`03ojNWg_nA
TL7oYjON0>go`<3o003bol30o`03oaTI8_lE5AcoX:3E00Co`<3o00?oU9C5
oaDE7OlL72H02?o0`?l00on^[^So;Rhno`000003o`000003obLW=?nZZ^;o
`<3o00Ko`<3o00?o^KWfoeUIMol30`D00_l000001Ol51@OoDe=_ojNWgomF
EWCo10@500;o000000?o1@D7oeUIMoni^OH01?o0`?l00omZJXko71`Voc<c
A@06ol30o`03ojj^j?l^;Sko000000?o000000?o9bLdojZZh_o0`?l01_o0
`?l00one]O7oEUIdo`@41@02o`000004o`D51omIFGOoO7bUoaPH80?o0000
00?o;2`jog1`UOm1@EH00ol000000ol?3aGoJf^?ol30o`04ol30o`07ok2`
j_l?3aGo0000o`000?l:2Pgo8B4/oiRHb`03ol30o`0<ohb<^_lE5Ago0000
o`000?l51@KoJf^>oaTI8_l0003o0@41oeEEL_o0`?ooUYK80_l000001ol5
1@Oo3`lDobPX=_lG5b3o3`lDochnDonf]_800_o0`?l03?n<S;[o5ADMo`00
0?l0003o1@D6of][S_lI6B;o0000o`410OmEEG;oPH6/oaPH80?o000000?o
;2`jog1`UOm1@EH00ol000001ol?3aGoJf^?ojVYhOl10@;o0000o`410_nY
ZN40k?o0`?l00?7o`<3o00CoUIG6o`000?l0003oFe]j1?o0`?l01?m?Cf[o
0000o`000?nJV/d6ol30o`03okVim_lG5aoo000000;o000000Go3@dAo`H6
2?l20P?o6a/TokRhm@08ol30o`04odY:Hol0003o0000oeMGM0?o`<3o00Co
C4aUo`000?l0003oEEEa1Oo0`?l01Ono_oko6ATRo`000?l0003oY:CJ00Co
`<3o00?o^KWfoaLG7ol000000_l000001Ol=3A7o1PH8o`820olK6bCo^;Se
00So`<3o00CoC4aUo`000?l0003oEEEa0_o0`?l01?nEULOo0000o`000?l<
3103ol30o`04oc0`@?l0003o0000ogUiXPKo`<3o00SoLW:Ho`000?l0003o
4Q8Iof5QP_l>3Q?o6ATRokNgm0;o`<3o00Ko:b/jo`000?l0003o<310odi>
J?lL72H2o`000004o`L72Om7AeooLg>JoiJFb0;o000000[o0@41oi>Ca?o0
`?oo_;ckob`/>ol:2Pgo;2`joknoo_o0`?oo:b/j0_l000000ol`<43oCTiX
oa`L9P02o`000004o`L72Om7AeooLg>JoiFEa`;o000000Go30`@ol30ooo0
`?oo`<3ooc0`@002o`000007ogUiX_o0`?oo[:cUo`@41_l0003o10@6ojb/
i@3/ol30o`00lOo0`?l01?m?Cf[o0000o`000?lH6203ol30o`05okbln_l=
3A;o0000o`000?mHF7D01_o0`?l02_mNGWko0000o`000?l61PSoPh>^ol30
oono_okoKfnDocLgB_mOGgl8ol30o`04oeeMO?l0003o0000ofUYS0?o`<3o
00CoGemoo`000?l0003oIfN91Oo0`?l01On8R;Go0000o`000?l61POoEEEa
00Co`<3o00[oGUino`000?l0003o1PH8oh>3[_o0`?oo_konofm_U?lg=d[o
Gemo2?o0`?l01?mOGgoo0000o`000?mWIhT2ol30o`04ok:bkOl0003o0000
oaHF7P?o`<3o00Co?3aAo`000?l0003oSHfl1_o0`?l01On_[nWoCTiYod51
EonBT/?oP82[00;o000000?oGemool30oonc/nh00_l000001?l410Ko/k?_
ol30oonBT/82o`000004obPX=_nl_?[o_;cjoiJFb0;o000000Go:2Pfol30
ooo0`?oo`<3oohb<^P02o`000008ogUiX_nc/nko0000o`000?l410Ko/k?_
ol30oonBT/82o`000004obPX=_nl_?[o_;cjok:bk@;o000000Go5QHNol30
ooo0`?oo`<3ooc`lD@02o`000006ohf=_?o0`?oo`<3oojj^j?nNW]?o[ZkX
kOo0`?l00?3o`<3o00Ko_;cjo`h>4ol0003o0000o`@41_nCTl@2ol30o`05
ohN7]?l0003o0000o`000?lF5Qh01_o0`?l01?lL72Ko0000o`000?m`L9H4
ol30o`;oEeMd2?o0`?l01?mOGgoo0000o`000?m[Jhl3ol30o`04of5QP_l0
003o0000ofUYS0Go`<3o00Ko=SI9o`000?l0003o5QHMob4Q;?ni^OL3ol30
o`04oa`L9_l0003o0000og1`UPCo`<3o0_mGEg@8ol30o`04of5QP_l0003o
0000ofUYS0;o`<3o00Co][Kbo`000?l0003o5aLO0oo0`?l01?lm?E;o0000
o`000?n?Skl:ol30o`04oh:2[Ol0003o0000oc`lD@;o`<3o00Ko51@Ko`41
0Ol;2`oo_;cjol30oonPX=D2o`000004ob`/>oo0`?oo`<3ooiJFb0;o0000
00Go<c=4ol30ooo0`?oo`<3ookJfl`02o`000008ob<S;oo0`?oo51@Ko`41
0Ol;2`oo_;cjol30oonPX=D2o`000004ob`/>oo0`?oo`<3ookJflP;o0000
00Go5aLOol30ooo0`?oo`<3oocdmDP02o`000003ohn?_oo0`?oo`<3o0?3o
`<3o003`ol30o`06ohJ6/ol0003o0000o`@41OlY:COoCdmZ0_o0`?l01_m3
@eWo0000o`000?l>3Q?o7alZoi>Ca0Co`<3o00Go_;cko`820ol0003o4a<J
okbln`04ol30o`;o_;cj2?o0`?l01?mOGgoo0000o`000?m[Jhl3ol30o`04
of5QP_l0003o0000ofUYS0Co`<3o00OoY:CKo`000?l0003o4a<IoemOOoll
?53oMWJM00;o`<3o00Go_;cko`820ol0003o4a<Jokbln`04ol30o`;o_;cj
2?o0`?l01?mQHH;o0000o`000?mYJH`2ol30o`04okJfl_l0003o0000oaLG
7`?o`<3o00Co?CeBo`000?l0003oShno2_o0`?l01?n2PZgo0000o`000?lS
8bl2ol30o`06oiRHb_l;2a3o20P:of9RPoo0`?ooX:3E0_l000001?l];Cco
`<3ool30oonFU/P2o`000003oc@dA_o0`?oo`<3o00;o`<3o00[o2`/?o`00
0?l51@Ko_[kmoiRHb_l;2a3o20P:of9RPoo0`?ooX:3E0_l000001?l];Cco
`<3ool30oonf]_82o`000005oaLG7oo0`?oo`<3ool30oolm?E800_l00000
0on?Skoo`<3ool30o`3`ol30o`00l?o0`?l02Om1@EOo0000o`000?ll?53o
3PhCoa0@5Onl_?_o][Kco`D52002o`000003od];I?l/;3coD51[00Co`<3o
00Co];C`o`000?l0003o=SI93oo0`?l01?mOGgoo0000o`000?m[Jhl3ol30
o`04of5QP_l0003o0000ofUYS0Co`<3o00OoE5A`o`000?l0003oH620ojf]
i_lU9C;o:RXh00;o`<3o00Co];C`o`000?l0003o=SI93oo0`?l01?mQHH;o
0000o`000?mYJH`2ol30o`04okJfl_l0003o0000oaLG7`?o`<3o00Co?CeB
o`000?l0003oShno2_o0`?l01?n2PZgo0000o`000?l?3a@3ol30o`05ojBT
fol_;coo4Q8HocDeAon6Q[<00_l000001?l];Cco`<3ool30oonFU/P2o`00
0006oc@dA_o0`?oo`<3ool30oonl_?[o00010_l000001onWYmko`<3oojBT
fol_;coo4Q8HocDeAon6Q[<00_l000001?l];Cco`<3ool30oonf]_82o`00
0005oaLG7oo0`?oo`<3ool30oolm?E800_l000000on?Skoo`<3ool30o`3`
ol30o`00koo0`?l02Onf]_;o1@D8o`000?l0003oQXJcoc8b@olS8booQhNd
ogUiXP02o`000005o`h>4_nYZN7o410Eoa4A5onn__d01?o0`?l00ol=3A;o
0`<4ob@T<005oe]KN@03oeeMO?n8R;Go`<3o00Oo`<3o00CoGemoo`000?l0
003oJf^?0oo0`?l01?mQHH7o0000o`000?mXJ8/3ol30o`09okNgm?l:2Pko
0000o`<31?n][NOo`<3oochnDola<D7oV9S:00;o`<3o00?o3@dBo`<31?lT
93001OmKFgT00omMGGcoR8Reol30o`07ol30o`04of5QPOl0003o0000ofQX
R`;o`<3o00Co]KGao`000?l0003o5QHN0oo0`?l01?ll?57o0000o`000?n?
Skh:ol30o`04oh:2[Ol0003o0000o`h>4`Go`<3o00?oVi_?od10EOlC4aT0
0_l000001?l/;3_o`<3ool30oonFU/P2o`000005oc@dA_o0`?oo`<3ool30
oonUYM`00ol000001onc/nko`<3ool30ooo0`?ooVi_?od10EOlC4aT00_l0
00001?l/;3_o`<3ool30oone]O42o`000005oaHF7_o0`?oo`<3ool30ooll
?5400_l000000on?Skko`<3ool30o`3`ol30o`00koo0`?l02OmhN:3o0000
o`000?l=3A7o_;cjogEeW?lX:3Oo@d=JocDeA`02o`000005odi>J?o0`?oo
<310ob<S;_n<S;X01?o0`?l00ol];Cgo20P;oaLG7`03od];I004ob<S;ol0
003o0000oahN:0So`<3o00CoGemoo`000?l0003oJf^?0oo0`?l01?mNGWgo
0000o`000?mXJ8/3ol30o`04og9bV?l0003o0000od92F0;o`<3o00?oS8bk
oc@dA_m8B6000_o0`?l00ol];Cgo20P;oaLG7`03od];I004ob<S;ol0003o
0000oahN:0So`<3o00CoGUimo`000?l0003oJ6R;0_o0`?l01?nc/nko0000
o`000?lF5Qh3ol30o`04oc<cA?l0003o0000oi^KcP[o`<3o00CoPX:]o`00
0?l0003o3PhC0_o0`?l01_n6Q[;o;Rhnod51E_nk^oWo`<3ooi^KcP;o0000
00Co;Rhnol30ooo0`?ooUIG60_l000001Ol`<47o`<3ool30ooo0`?ooGEel
00;o000000So3PhCol30oon6Q[;o;Rhnod51E_nk^oWo`<3ooi^KcP;o0000
00Co;Rhnol30ooo0`?oo/k?^0_l000001OlF5Qko`<3ool30ooo0`?oo<c=4
00;o000000?oVi_>ol30ooo0`?l0l?o0`?l00>oo`<3o00Wo<c=4o`000?l0
003oC4aVol30oonc/nko2`/?o`/;3_l000400_l000001OnBT/;o`<3oog=c
VOl[:c[oBDUR00Co`<3o00CoRHVgo`@41_l61PSo/[;]0_o0`?l01?lm?E;o
0000o`000?m9BF48ol30o`04oemOOol0003o0000of][S`?o`<3o00CoDU9]
o`000?l0003oJ6R;0_o0`?l01Ono_oko820[o`000?l0003oShno00;o`<3o
00Wo_konob0P:olN7RWo/k?^ol30oon9RKOo10@6o`H62?nb/^d00_o0`?l0
1?lm?E;o0000o`000?m9BF48ol30o`04oe9BKOl0003o0000ofQXR`;o`<3o
00SoYjONo`000?l0003o10@5og=cV_o0`?oo_[kmoa4A5`;o000000?o/K7/
ol30ooo0`?l02?o0`?l01?n2PZgo0000o`000?l>3Q<2ol30o`06od51Eol0
003o0000oiFEaoo0`?ooSXjm0_l000001?lg=d[o`<3ool30oon9RKH2o`00
0005o`T93?m/K93o`<3ooifMdOl820/00_l000000omBDVgo`<3ood51E`02
o`000003oiFEaoo0`?ooSXjm00;o000000Co=cM:ol30ooo0`?ooYjON0_l0
00001Ol410GoLg>Jol30oonn__go4A4G00;o000000?o/K7/ol30ooo0`?l0
l?o0`?l00>ko`<3o00Go[JgVo`000Ol0003o0000oi2@`002ol30o`05ocXj
C_l=3A7o0000o`000?lF5Qh00_o0`?l01?na/Nco3@dBo`h>4onl_?X4ol30
o`09odU9HOlK6bCo@41Fojf]ion0P:_o0001o`000?l:2Pko[:cU00So`<3o
00SoGemoo`000?l0003oJf^?ol30oon[ZnCoC4aVo`H62@;o000000CoJ6R;
ol30ooo0`?ooM7BK0ol000001onc/nko`<3ool30ooo0`?ooD51[ob4Q;?m?
CfX00_o0`?l02Om9BF7o6a/Tod10E_n][NOoP82[o`000Ol0003o2PX>ojb/
i@06ol30o`03oj^[i?m<C6Ko1PH900;o000000CoJ6R;ol30oom`L9Ko7alY
0_l000001?l>3Q?o8b<_oadM9_lA4AL2o`000003obl_?oo0`?oo`<3o00Wo
`<3o00CoPX:]o`000?l0003o3PhC0_o0`?l01_n6Q[?o0001o`000OmWIh[o
_;cjodM7G`;o000000CoKFfAol30oomTI8Go4A4G0_l000001?lF5Qko3@dA
o`P82ol10@82o`000004o`d=4_na/Nco`<3oohJ6/`;o000100?oIfN:okbl
n_m7Ael00_l000001?m]KI7o`<3oog1`U_lO7bT2o`000004o`h>4olS8boo
7AdVoa4A5`;o000000?o;blool30ooo0`?l0lOo0`?l00>ko`<3o00GoJVZ=
o`000?l0003o51@KoknooP02ol30o`05ogemYol0003o0000o`000?mHF7H0
0oo0`?l00olf=TWo9RHbohF5/@05ol30o`07ogEeW?lJ6R?o1PH8o`410_l3
0`Co<C52ojNWgP09ol30o`04oemOOol0003o0000of][S`;o`<3o01?o[joY
oeeMO?l=3A;o3@dBofQXRoo0`?ooKFfBoadM9ol=3A;o3@dAoaDE7?m8B63o
Zj_Tol30oon0P:[o:2Pfoa0@5_lM7BOoKVjC00;o`<3o00OoMGFLoaXJ8ol6
1PSo0@42o`<31?la<D;oYjON00So`<3o017o[joYoeeMO?l=3A;o3@dBofQX
Roo0`?oo_[kmohJ6/olX:3Ko1`L:oaTI8_n<S;[o92@`o`410_l10@7o:BTg
ojRXh00;ol30o`04oh:2[Ol0003o0000o`h>4`?o`<3o00OoR8ReoadM:?l:
2Pko1@D7o`@41_lE5AcoI6B500;o`<3o00_o_[kmohN7]OlZ:SSo410FocHf
B?mUIHOo410Eo`000Ol10@;o;BdlojNWgP03ol30o`07ohR8]OlM7BSo2PX>
o`D51ol410Ko5ADLofATQ@02ol30o`0;okjnoOn6Q[?o:2Pfo`L72_lI6B;o
S8bjob@T<?l10@;o0@41obTY=onXZ>00loo0`?l00>ko`<3o00Co92@ao`00
0?l0003oEeMd0oo0`?l01OnLW=3o0000o`000?l0003oWIgA00?o`<3o00?o
NGVRobTY=om2@UP01oo0`?l2okbln`co`<3o00CoGemoo`000?l0003oJf^?
1?o0`?l00ono_oko^k_iokblnP0Bol30o`;o_;ck3Oo0`?l00ono_oko^k_i
okblnP04ol30o`;o^[[h0_o0`?l2okjno@go`<3o00CoPX:]o`000?l0003o
3PhC1_o0`?l2okfmo0_o`<3o0_nn__d8ol30o`;o_Kgl1oo0`?l2okZjn0;o
`<3o0_nn__geol30o`00kOo0`?l01OnQXMKo0000o`000?l0003oVY[=00?o
`<3o00GoGUimo`000?l0003o7QhXoknooP03ol30o`04okJfl_l<317o30`A
okNgm1Co`<3o00CoGUimo`000?l0003oJVZ>@_o0`?l01?n2PZgo0000o`00
0?l>3Q?ool30ob;o`<3o003]ol30o`04oe]KNOl0003o0000oaPH80?o`<3o
00Go_[kmoaTI8_l0003o0000oeQHMP05ol30o`03ocHfB?lS8bkoO7bV01Co
`<3o00CoFe]io`000?l0003oJVZ>@_o0`?l01?mnOZSo0000o`000?l92@co
ol30ob;o`<3o003/ol30o`05ok>ckol@41Oo0000o`000?ld=4H00oo0`?l0
1OmfMYko0000o`000?l0003oJVZ=00Go`<3o00CoCTiXo`h>4olS8boo^KWg
4Oo0`?l2oknooP04od10E_l0003o0000ofYZSP?o`<3o00CoW9c@oc`lD?ln
?U;oX:3E8?o0`?l01?nLW=3o?3a@ochnD_nPX=DGol30o`05of9RPol0003o
0000o`000?n[Zn@0ooo0`?lQol30o`00joo0`?l06?mnOZSo7alZo`D51_l2
0P;o0P83o`X:3Om<C6KoY:CKoe9BKol;2`oo0P83o`820_l30`Go4Q8HoemO
Oonl_?[o`<3oojNWgom;BfCo2`/?o`820ol51@Oo:b/joiFEaQ3o`<3o00?o
[joYod92FOl10@400_l000001OmZJXko`<3ool30ooo0`?ooBTYS00;o0000
00?oE5A`ol30ooo0`?l07_o0`?l01?m:BV?o0000o`000?mDE70Eol30o`09
ohf=_?lk>doo2PX=o`820ol20P;o0`<4o`h>4omEEG7o[joY0?oo`<3o7oo0
`?l00?oo`<3o5_o0`?l01?n/[>GoEeMcodA4Fon7Qk@3ol30o`04oj2PeOm6
AUgoB4QPojBTfb3o`<3o00CoX:3EodI6GOm8B63oY:CKooo0`?lmol30o`00
ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3oooo0`?n2
ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l00?oo`<3o
ooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3oP_o0`?l0
0?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30oooo`<3o
P_o0`?l00?oo`<3oooo0`?n2ol30o`00ooo0`?oool30oh;o`<3o003ool30
oooo`<3oP_o0`?l00?oo`<3oooo0`?n2ol30o`00oomoOgmGogmoO`OoOWin
oomoOglTogmoO`0000Cojn_[onKVi_oRh^;og]kN1?oMgMd2omkNgP;ogMgM
00?og]kNomcLg?oNg]h00ooMgMd0oooNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNgP003ooMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oLg=cogMgMom_Kf`02omcLg00comgMgOoMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kN00;og=cL00GofMWIomSHf?oGemOof=SHomWIfP02omcL
g01fomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMgP;ogMgM09kog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMgP?og]kN00?ogMgM
omkNg_oNg]h00ooMgMd1on7Qh@7oinOW0OoZj^X00003onc/k?oVi^Koh>3P
00OofMWI00Cof=SHomKFe_oCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooH
f=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOo
f=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOG
omSHf=_ofMWI0_oHf=P01_oFe]Kodm?Com?CdooDe=CoemOGomSHf0;ofMWI
00?of=SHomWIfOoIfMT00_oHf=P9omWIf@03omSHf?oIfMWofMWI00;of=SH
00?ofMWIomSHf?oHf=P00_oHf=PGomWIf@04omSHf?oFe]Kod];Bolo?c`;o
cLg=00Coclo?om?CdooGemOof=SHoooIfMTFomWIf@03omSHf?oIfMWofMWI
00KofMWI0OoNg]h1onKViP7ok>c/00001oo^k^kojNWYonCTi?oPh>3ohN7Q
on3Ph?oRh^800_oQhN403OoMgMgog=cLom?Cdoo7alOo^k^kok6a/On^[Zko
/[:bokZj^_o7alOodm?Com_KfooOgml02OoQhN403OoOgmoofm_Kom?Cdoo7
alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml02OoQhN40
3OoOgmoofm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?C
om_KfooOgml0f_oQhN402OoPh>3ogmoOom_KfooFe]Koe=CDomKFe_oJf][o
g]kNon3Ph006omoOg`?oh>3P00?ogmoOon3Ph?oPh>000_oPh>08omoOg`;o
g]kN0_oOgml3on3Ph0;ogmoO0_oPh>02omoOg`goh>3P00GogmoOomgMgOoI
fMWoeMGEom?Cd`02om;BdP03omKFe_oLg=coh>3P06kohN7Q00?oh>3Pon7Q
hOoQhN401OoQhN400ooPh>3ohN7Qon7Qh@0bon7Qh@03on3Ph?oQhN7ohN7Q
06WohN7Q00?oh^;Ron7QhOoRh^801?oQhN41on?Sh`7ojNWY0Oo]kNd00003
oo3`l?o_knoolO7a00?ol?3`0?ookno_oo3`l?o^k^kojNWYom_Kfoo1`L7o
Y:BToh^;RomkNg_oMgMgog]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBT
Y?n<S8_oNg]kogMgMomkNg_oS8b<ojBTY?o2`/;of][Jon[Zj?o]kNgolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ong]kOoZj^[of][Jol;2`_nTY:Co
S8b<og]kNomgMgKoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knl001_olO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo^k^kokno_on[Zj_oWinL00_oPh>001ooShn?ojn_Yon_[
jooZj^[oi^KVonSXj?oWinL00_oYjNT04_o^k^cok>c/onc/k?oXj>Sok>c/
ong]kOo`l?3ok>c/on[Zj?oVi^Koj>SXonOWiooYjNWoj>SXon_[jooWinOo
inOUonGUi@;ojNWY00ook^k^ong]kOo]kNgoj>SXon_[jOo/k>cok^k^onWY
jOoZj^[ojn_[ono_koo/k>cok>cZon[Zj_o^k^h00_o/k>`0oooZj^[okno_
onc/k?o/k>[oj^[Zonk^k_o/k>co[jn_ogIfM_mIFEWoKVi^okNg]_oPh>3o
jNWYong]kOoalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_k`00;OoalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNool?3`ono_
koo`l?3okno_oo3`l?o_knool?3`ono_k`04oo3`l00000?ol_;bonk^k_oW
inL01?oUiND04?oTi>CogmoOom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92
@_m5ADGoDE5AofIVI_n:RXWo/K6aom7AdOoNg]h2onCTi003onGUiOoTi>Co
iNGT00;oi>CT00oog]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5
ADGoDE5AofIVI_n:RX[o/K6aom7Ad?oNg]h00_oTi>@0kOoUiNGoi>CTonGU
iOoTi>Coi>CSomkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5
oe5ADOmVIVKoRXZ:ok6a/OoAdM7og]kNonCThooTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi002onCTi01@
olG5aOlX:2SoA4A4oi2@T?oAdM7og=cKom_KfooGemOoe=CDomKFe_oDe=Co
eMGEomWIfOoPh=oog]kNom[Jf_oDe=CofMWIomkNg_oRh^;og=cLomOGe_oD
e=Coe]KFomCDe?oEeMGof=SHom_KfooGemOoe]KEomGEeOoGemOof=SHomkN
g_oOgmoog=cLomGEeOoGemKog=cLomgMgOoGemOoe]KFom_KfooQhN7og]kN
om_Kf_oJf][og]kNomcLg?oJf][ofm_Kon3Ph?oOgmoog=cKomWIfOoNg]ko
gmoOogAdM?mWIfOoSHf=oeADE?l820SoXZ:RomcLg?oRh^;oiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiND3onCTi02MonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUi@03onCTi01TonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi0CoiNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o]kNd1
oo;blP0000?om?Cdong]kOoWinL00_oPh>004ooQhN7ogmoOomkNg_oBd];o
];BdohN7QomLG5coKC/eoii>@_o=KeoojH=_ola^G_nNCT?oKC/foeaLG?n7
QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLofeP
;?nNURkocLdoonWYCOo=cCooWYX_ofeS;OmLG5coQhN7okBd]?oBd];og]kN
00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m7IbkoJ9hcoi7=AonZjEGo
TLe7ofZN=?m9JRooG5aLohN7Qond];Cod];BomkNgP3Ion3Ph006omoOgoo?
clooVIVIoi:BT_lI6AWoS8b<0_oEeMD07oo?cloo`/;2olk>c_o>c/koaLG5
ol[:b_oJf][of=SHom3@d?o;bl_oclo?omSHf?oJf][oeMGEolo?coo1`L7o
d=3@olk>c_o4a<Cobl_;omSHf?oGemOo_[jnok^k^ooAdM7od=3@omGEeOoH
f=Sodm?Colc<c?o>c/h00_oEeMD01Oo>c/koc<c<om?CdooJf][of=SH00;o
d];B00Cof=SHomOGeooAdM7odm?C0_oIfMT01_oCdm?odM7AomOGeooHf=So
dM7Aom3@d0;odM7A00CoATI6od51@OoGemOog]kNL?oPh>000ooOgmooh>3P
on3Ph002on3Ph003omoOgooPh>3oh>3P09goh>3P00?ogmoOon3Ph?oOgml0
0_oOgml3on3Ph003on7QhOoWinOok>c/007olo?c00000oofm_Kol_;bon_[
j`03onSXj00ConOWiooRh^;ocLg=oijNW_m[GeooScD]oneaHOoiWI3ooK6U
oofl[oom]:OonInConedHonB=booJemOoinOWoo=cLgoh^;RonOWi`03onSX
j00ConOWiooRh^;ocLg=oinOWom^IUooTg8RongAA?oilgCooOf=oogmUOom
oHkonOQfongGAonCLb;oKVMOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOW
iooRh^;ocLg=oinOWomPJ5ooBg`Soi;QBonmnG_od?fBomSmVooDoIGo`?Un
oiSXCOm=P2CoH6UOoinOWoo=cLgoh^;RonOWi`3JonSXj004onKVi_oQhN7o
GEeMode=C@;ogMgM01ooD51@o`L71olE5AGoQ8B4oaHF5_m3@d?oh^;RomgM
gOnLW9co0000ohn?SooMgMgohN7Qom_Kfom0@43o20P8oaTI6On8R8So2`/;
oeQHF?ng]kOo30`<o`L71olS8b?o9bLWogemOOoJf][ogMgMomCDe?l;2`_o
FEUI00;ofMWI00?oGEeMo`/;2ooCdm<00_oOgml01_mJFU[oCTi>omkNg_oN
g]ko8b<SohB4Q0;ohN7Q00coNWYjobh^;_oMgMgogMgMol;2`_m@D53o<c<c
ofi^K_n3Ph?o8B4QomkNg_oVi^KoonSXj1ooj>SX0Oo/k>`1oo;blP7om_Kf
00000oogmoOon?ShooShn003ooShn00CooOgmoo^k^koc/k>oi2@T?n5;b_o
jFAFoo^BQoonYY_oo[2ToonhZoon/jKooZNLoo^DROo^J5WoRC4[oi2@T?o>
c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_P
K_onm8;oo_j:ooooT_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^
ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSo
c_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^ooOgm`3J
ooShn00UooKfm_oalO7oPH61oalO7oo]kNgoa/K6o`000?o3`l?odm?CoeaL
G?l820Soj^[Zoo3`l?oZj^[oDU9Boa@D5?lm?CgojNWYoo3`l?n_[joo1`L7
om;Bd_o=cLgoCTi>oa/K6oo^k^kofm_Kojj^[_oXj>Sok>c/ojj^[_l0003o
];Bdonc/k?n`/;3o2`/;oaXJ6P02onCTi00;ob<S8ol>3PkoY:BTong]kOo^
k^koH61PoeADE?o^k^kokNg]obHV9_n=SHd00_o`l?003?n2PX;o<C4aonc/
k?oZj^[o@d=3obl_;onLW9coLg=cobXZ:_lJ6Q[ok^k^ooKfmVkon?Sh00?o
moOgooShn?ohn?P01Oohn?P00oogmoOon?ShooShn02NooShn003ooOgmooh
n?Son?Sh00;on?Sh00ComoOgooWinOofm_KomoOg0Oohn?P00003oo[jn_oe
mOGok^k^00;ok>c/0?oojn_[onWYjOoOgmoo^KViogUBD_no<B?oigAYoof8
O_ooV8cooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<TogUBD_nj^[[ogmoO
on[Zj_o[jn_ok>c/on_[k?oZj^[ogmoOokZj^_n8IE;ohY4LooW3D?omfV?o
onYbookcO_oonX;oo_Ioooo/LoongVCon/MAon:B7?n9IU?o^[ZjomoOgooZ
j^[ojn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S7?nAdUGoY^MZokSi
N_o0oX;oaon9ol?nQ?nioG_oYna/oiCFEomBYQcoDVeBokZj^_oOgmooj^[Z
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jn`0
04Wok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojNWYonGUiOmjNW[o71`Lon7Qh_o<c<co
0`<3oj2PX?oNg]koU9BDoa<C4ooQhN7oh>3Qom3@d?l61PKoXJ6Qo`T92Ono
_koohN7QokZj^_l20P;o/[:bomgMgOn0P83o:2PXon?ShooWinOoiNGUomoO
gooKfm_odm?Co`P82?n5QHGogmoOofUYJOm:BT[o=CDeojf][Onm_Kgo1`L7
ogQhN?mEEEGogmoOon3Ph?mKFe_oD51@00;ohN7Q00[o92@TohF5QOoOgmoo
hN7Qog]kNol_;booh>3PomCDe?l51@GoZ:RX0_oShn<05?mnOWoo5QHFon7Q
hOoZj^[ojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/0oo[jn/0Uoo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>`00_o[jn/01?o[jncok>c/on_[joo/k>`3on_[j`1Ronc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jn`6on_[j`05onc/k?o[jn_ojn_[onk^
k_ofm_H00OoinOT00003oo_knooclo?okNg]00;oiNGU0?ooi^KVonCTi?oI
fMWo/[:bogP];Oo8@SCohfYLooAjKOomR7cooYN:oojKS_onV8_ooXYnooAk
KOoWJegobT8dog/^;_nb/[;of=SHonCTi?oUiNGoi^KVonGUi_oTi>Cof=SH
ok:b/_nFEBkojY`[oo^lA?onc5?ooMQRookSL_onjGGoo^IcookKIOomc5?o
nl55onjN:onIERko/[:bomSHf?oTi>CoiNGUonKVi_oUiNGoi>CTomSHfOnb
/[;o;V8^of>]:on7bTSoUmaIojGUJOnblgOo^?IkokCeNOnWjV_oV=aIohW?
BomS[R_o;V<^ok:b/_oHf=Woi>CTonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNH003Coi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Kohn?S
omoOgomgMgOo6a/KomcLg?oQhN7oWYjNobl_;ol[:b_o<S8boa8B4_oLg=co
f][KohB4Q?lP823oh>3Poe9BD_mXJ6Sof][JomkNg_n@T93o:RXZobh^;_l/
;2co9bLW0_oNg]h04ooIfMWodm?Dom3@d?mKFe_o0000okfm_OoJf][o:2PX
ohN7QomgMgSoJ6QXoh:2P_ll?3co`/;2o`l?3ooDe=Cof][JoeUIFOm>CTh0
0_oLg=`0O_lS8b?oPH61omGEeOoGemOoMgMgobh^;_oLg=coXj>So`000?o7
alOof=SHomWIfOn=SHko5ADEomcLg?oShn?oiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKViP?oiNGU0:Coi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUiP;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGokNg]oo?cl`01
oo[jnP0000?oo?clooShn?oalO400oo^k^h04oo[jn_ohN7Qokbl_?mj5aOo
`clbom=FBOoTJ5[okgM/oo>3N?ohQgcomHAjoo=iKOoUJE_ofEQ:ol@o<_ml
5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?nUAaOoiYLbooF/
<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlbonVK<_nUAQOo_;bl
on7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOoGjPbogJm=on6cDOo
U]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lGFAOo_;blon7QhOo/
k>`0f_o^k^h0;_o/k>coinOWog]kNolL71coi>CTonWYjOoVi^KohN7QomkN
g_n=SHgo51@DonKVi_oTi>Co=CDeogUiNOo[jn_o/[:boaDE5OoOgmooi^KV
onCTi?oQhN7ogMgMogYjN_lY:BWoj>SXonGUiOoMgMgo/K6aobHV9_l;2`_o
Vi^KonWYjOo<c<co0000olk>c_o3`l?o9BDUod];BomlO7coj>SXoc4a<OnU
YJGoi>CToeeMGOmADE42onOWi`0:obDU9OmYJFWogmoOomoOgomgMgOo<C4a
onWYjOo1`L7o0000ojNWY`;ogmoO00CoTi>CoaHF5_oWinOok>c/Zoo^k^h0
0oo]kNgok^k^onk^kP1_onk^kP03ong]kOobl_;on?Sh007oo?cl0003oogm
o@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@@ooJ
HUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];olo?coocl
o0?ooOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWomJPYooRd?ooi_D[o
n;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?oo?cl00?ooOgm
01?oo?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:cE3oSLeBoh[>
D?n1adCoLKT_of:^8?m>VcCo1d87om;Bd_oclo?oo?cl0=[ooOgm02?ono_k
ooOgmon4Q8Co7QhNoo?clooinOWo/k>com3@d?oclo?oJ6QXodM7Aoojn_[o
e=CDo`000?oMgMgoo?cloo_knolW9bOoZ:RXooWinOn[Zj_oeMGEoo7alOmD
E5CoGUiNooWinOodm?CoU9BDo`D51Om0@43odM7AooOgmoohn?SoUiNGob/[
:`02oo[jnP0Kob@T9?l71`Oob<S8oo_knon5QHGoHf=SooOgmomSHf?oEeMG
ooShn?oinOWo9bLWoaDE5On3Ph?oemOGod92@_mSHf?ono_koo[jn_ld=3Co
BDU9om_KfooUiNGoCdm?oaLG5oojn_[oo?cl0?oooOgm7?omoOd00oolo?co
oOgmooclo003oogmo@0003[ooOgmoo[jn_oclo?ok^k^oo3`l?o_knook^k^
onWYjOoCdm?oFadMoj8d=?nc9aco`CX]olM9??o?ET[od5M;om1GB_o:BSko
`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_onk^k_oZ
j^[odm?Coh`U7Oo8LCCofH@MonBD5OoWWBCokZPcoo2Z=?o_ZS?ok:0UonNG
5OoLR1gob74doh`U7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`l?o^k^koj^[Y
om?CdolM>1go=88dodNE7OmJYA_oJJdZ0_md^3P0h_me^CSoJk4[oe^W7?m8
VQgo=88doadh7OoCdm?oj^[Yonk^k_o`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?02ono_k`1>on[Z
j_mnOWko71`LonSXioo]kNgoR8R8oc0`<?l?3`oo<C4aok6a/Oo^k^koQHF4
ode=COo_knook^k^ono_kon:RX[oFEUIonk^k_mhN7So:b/[o`l?3olh>3So
_knoong]kOoTi>Co3Ph>ofUYJOoOgmoohn?SonGUiOo[jn_oHF5QogMgMoo^
k^kokno^ogIfM_lV9RKokNg]ono_koo<c<co;2`/on[Zj_m]KFcoHV9Ronc/
k?o]kNgo>c/koi>CTomRHV;o3Ph>oc@d=?o4a<Cokno_onk^k_oAdM7o?3`l
o`X:2_lW9bOoK6a/ob`/;?o_knook^k^oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`0oo_knl0
ooo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
k^k^oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l0001Oo_knool?3`ono_
koo`l>ookno_00;ol?3`1_o_knl1oo?cl`7onOWi0Oono_h00003ookno_og
moOol?3`00CojNWY017oinOWom_KfomSBd_oPC8bojHe=Onf=2go`Te1ol=D
BOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mSBd_ofm_KonOWi`05onWYj@0A
onOWiooKfm_oRD];ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRko
eX/]olYe=On_Bc;oRD];om_KfooWinL01OoYjNT04OoWinOofm_Kod];Bolb
H3;o>XTeoe>K;Om[ZbooL:dhofn^>_m`[CSoJZX_oe>K;OliR3Go<V0bod];
BooKfm_oinOW0=_ojNWY00Koj>SXonKVi_mkNg_o71`LonCTi?oXj>P2onWY
j@03onOWiooYjNWojNWY00_ojNWY00coinOWonWYjOoYjNWoj>SXomSHf?l:
2P[o[Zj^omgMgOoNg]koh>3PonGUiOoXj>P8onWYj@06onSXj?oVi^Kohn?S
on?ShooVi^Koj>SX0ooYjNT00ooXj>SojNWYonWYj@04onWYj@03onOWiooY
jNWojNWY0?oojNWY6ooYjNT00ooXj>SojNWYonWYj@04onWYj@7ol?3`0Oof
m_H1ooknoP0000Goo_knoo[jn_odm?Cokno_oo7al@02oo3`l00Aono_koo[
jn_oUIBDodlS8onEE5Co^g=com>EUOoJW9cofYjLomVLW?oDUIGo^g=coiED
E?m?8b?oUIBDon[Zj_o_knl01Oo`l?004Oo_knooj^[ZojVDU?n18b?o^VYD
omBJLooT_9Goj/NLonW7W?oZaicoiKbEomBJLonkJUCoPB<SojZDU?oZj^[o
kno_00Gol?3`017okno_on[Zj_nDU9Co8bXSoeAjE?mcYG?oW/JEojc>W?n]
cYco[<jLoik6UOmcYG?oE7YDob<Z8onDU9Coj^[Zono_k`3Koo3`l0;okno_
00CoP820oadM7Oo^k^kokno_4oo`l?02ono_k`07ofATI?lY:BWoPH61of=S
Holk>c_ok^k^ono_k`08oo3`l006ono_koo^k^koLg=cofUYJOo^k^kokno_
ooo`l?0]oo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn00001?o/k_3ooooo
ooooooono_h2ooooo`;oo_kn0?oooOgmooShn?m^KVkoFSlook6@T?oNbLWo
l>CToo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?coooooookno_oo
ooooo_knooooo_ono_koooooooclo?ohn?SoSFe]ohXo?oo9TI3ojM39ooCY
i?ofjnKom>WTonW@bOo9TI3oRCloohe]KOohn?Ooo?clooooooono_kooooo
ookno_ooooooo_knooooo_olo?con?Shofe]KOlo?cooT9f@olWEbOoTk>Co
i^kVonC/i?o9eLWoT9f@oclo?om]KFgon?Shooclo?ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_h003Soooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_kooooooogmoOo@d=3oYJFUooknoOono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_oooooooOgmol71`?maLG7o
PH61ojn_[`;oo_kn00coooooookno_ooookoo_knooooooono_koooooookn
o_oooooooOgmol;2`Onl_;`2ooknoP3oooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_kooooo000Yookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_h00_oo
ool00oono_koooooooooo`03ooooo`7onO[k00001?o0algoo_knoo[jn_od
m?@5oo7al@0=ono_kooFe]KoJf][od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<
od<m?Om[Jf_oe]KFono_k`09oo7al@0=ono_kooGe]KoPf][og@m?OneS8co
eKZjon7<c?oF^[[o]Xb<og8m?On1Jf_oemKFono_k`09oo7al@0=ono_kooF
e]KoJf][ocdm?On<S8co^[Zjolc=c?nj^[[oS8b<ocdm?Om[Jf_oe]KFono_
k`3ooo7alAcolO7a00?ol?3`oo7alOoalO40oooalO4Eoo7al@04oo3`l?oa
lO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_ono_h00Oo[kNh00005oh>?VOom
oOgon?Shoo3`l?o[jn/00ooZj^X03OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUI
FOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT02ooZj^X02ooYjNWoj>SX
oj2KVomZFEWo@bHVobd92Om29RKoJEUIoj2KVooXj>SojNWY00_oj^[Z00_o
jNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@3o
on[ZjQcoj^[Z00?ojNWYon[Zj_oZj^X0oooZj^XMon[ZjP04on_[joo`l?3o
n?Shoogmo@7odMGG00001?lfAU3o^;o5oo[jn_odm?@8oo7al@;ol?3`0oo_
knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`
l?3ooo7alB3olO7a00?ol?3`oo7alOoalO40oooalO4Goo7al@03oo3`l?oa
lO7olO7a00;olO7a00?omOGeooWinOo/kNl00OnRYJP00003oad_?Om=F6?o
^Ko60?oooooooooooomlooooo`7okNo`0On]/;<1ojFY[@0000Ko7Rlmoa/X
=?lb?TSoOHRAokg3aoo[k>koooooooooooooM_ooool01OoZk>go^ko2ogZ1
Qol[=Cgo4R0Z007o52<_0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create 1", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<java.net.URL\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["java.net.URL", 90]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(html = 
      JavaNew["\<java.net.URL\>", \n
        StringJoin["\<file://\>", $JavaSwingMaterial, "\<index.html\>"]]\)], \
"Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.net.URL"] \[RightGuillemet]\),
      JLink`Objects`JavaObject30091569688215553]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(editorP = NewJEditorPane[pane, html]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JEditorPane"] \[RightGuillemet]\),
      JLink`Objects`JavaObject138685685170177]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose 1", "Subsection"],

Cell[BoxData[{
    \(DeleteJObject[pane, editorP]\), "\n", 
    \(ReleaseObject[html]\)}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create 2", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(str = 
      JavaNew["\<java.lang.String\>", \n
        StringJoin["\<file://\>", $JavaSwingMaterial, "\<index.html\>"]]\)], \
"Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.lang.String"] \[RightGuillemet]\),
      JLink`Objects`JavaObject9146135490854913]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(editorP2 = NewJEditorPane[pane, str]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JEditorPane"] \[RightGuillemet]\),
      JLink`Objects`JavaObject112979903250433]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose 2", "Subsection"],

Cell[BoxData[{
    \(DeleteJObject[pane, editorP2]\), "\n", 
    \(ReleaseObject[str]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JTextPane <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000005R<2hb>3HR<2hR<2hc<c<
0?ooooooooooNOooo`:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVK<
c<coIVIVofIVIWMVIVH01?ooohS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooMooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?oooomKoooo00<0003oooooool0oooooaWoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooG?ooo`030000
oooooooo0?oooolHoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH0oooooaGoool4000000?oool0003oool00oooo`030000
oooooooo00Ooool400001Oooo`@000000oooo`0000000006oooo0`0000Ko
ool200004oooo`030000oooooooo0?oooolGoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooaCoool00`000?oooooo
o`02oooo0P0000Coool00`000?ooooooo`06oooo00<0003oooooool00_oo
o`050000oooooooooooo000000Coool200001_ooo`030000oooooooo00Oo
ool200004oooo`030000oooooooo0?oooolGoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooa?oool00`000?oooooo
o`04oooo00<0003oooooool00_ooo`030000oooooooo00Goool00`000?oo
ooooo`04oooo00@0003oooooool00005oooo00<0003oooooool01?ooo`03
0000oooooooo01goool00`000?ooooooo`3ooooo5_ooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oooolCoooo00<0003o
ooooool01?ooo`030000oooooooo00;oool00`000?ooooooo`05oooo00<0
003oooooool01oooo`030000oooooooo00?oool00`000?ooooooo`04oooo
00<0003oooooool07Oooo`030000oooooooo0?oooolFoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooa?oool00`00
0?ooooooo`04oooo00<0003oooooool00_ooo`030000oooooooo00Goool0
0`000?ooooooo`08oooo00<0003oooooool00_ooo`030000oooooooo00Co
ool00`000?ooooooo`0Moooo00<0003oooooool0oooooaKoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo4oooo`03
0000oooooooo00Coool00`000?ooooooo`02oooo00<0003oooooool01Ooo
o`P00004oooo1@0000Koool00`000?ooooooo`0Moooo00<0003oooooool0
oooooaKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3ooooo4oooo`030000oooooooo00;oool300001?ooo`030000oooo
oooo00Goool00`000?ooooooo`04oooo00<0003oooooool01_ooo`030000
oooooooo00Coool00`000?ooooooo`0Moooo00<0003oooooool0oooooaKo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
oooo4oooo`030000oooooooo00Woool00`000?ooooooo`05oooo00<0003o
ooooool01?ooo`040000oooooooo00001Oooo`030000oooooooo00Coool0
0`000?ooooooo`0?oooo1`0000Ooool00`000?ooooooo`3ooooo5_ooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oooolC
oooo00<0003oooooool02Oooo`800007oooo00<0003oooooool00_ooo`03
0000oooooooo00;oool00`000?ooooooo`02oooo00<0003oooooool01?oo
o`030000oooooooo00Ooool200005?ooo`030000oooooooo0?oooolFoooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooo
oa?oool00`000?ooooooo`09oooo00<0003oool000000P0000Goool40000
1_ooo`@00005oooo1P0000Koool200005?ooo`030000oooooooo0?oooolF
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
oooooa?oool00`000?ooooooo`04oooo00<0003oooooool08Oooo`030000
oooooooo01goool00`000?ooooooo`3ooooo5_ooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV0?oooolCoooo00<0003ooooo
ool01?ooo`030000oooooooo027oool00`000?ooooooo`0Moooo00<0003o
ooooool0oooooaKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP3ooooo4oooo`030000oooooooo00Coool00`000?oooooo
o`0Qoooo00<0003oooooool07?ooo`030000oooooooo0?oooolGoooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooaCo
ool00`000?ooooooo`02oooo00<0003oooooool08_ooo`030000oooooooo
01coool00`000?ooooooo`3ooooo5oooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV0?oooolEoooo100004?oool00`000?oo
ooooo`3ooooo6?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV0?oooomKoooo00<0003oooooool0oooooaWoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP38ooooiOl00<Soool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooY_ooo`Go003;oooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0bOooo`Co
0003oooo1?l00003ooooo`00o`0000?o0006oooo3Ol000[oool8o`001Ooo
o`Go0005oooo1Ol000[oool7o`001Oooo`Go0002oooo1Ol000;oool5o`00
1Oooo`go000:oooo2?l000[oool5o`003oooo`Ko000;oooo3Ol000Woool5
o`00boooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0<Woool5o`000_ooo`Co00000oooool00?l00003o`001Oooo`go000:
oooo2ol000?oool5o`001_ooo`Go0007oooo2_l000Goool5o`0000?ooooo
003o00000ol000;oool5o`001?ooo`go000:oooo2ol000Soool5o`003Ooo
o`[o0008oooo3Ol00=[oool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3:oooo1?l000;oool4o`000_ooo`Go0003oooo3_l0
00Woool<o`000oooo`Go0006oooo1Ol000Koool<o`001?ooo`Go00000ooo
ool00?l00003o`000_ooo`Go0003oooo3_l000Woool<o`002?ooo`Go000<
oooo3?l000Koool>o`00f_ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0<[oool4o`000_ooo`Go00000oooool00?l00003
o`000oooo`Go0004oooo1Ol000Woool5o`001?ooo`?o0003oooo1Ol000Ko
ool5o`001_ooo`Go0003oooo1Ol000?oool5o`0000?ooooo003o00000ol0
00;oool5o`000oooo`Go0004oooo1Ol000Woool5o`001?ooo`?o0009oooo
1Ol000_oool5o`000oooo`Go0005oooo1Ol000Coool5o`00f_ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0<[oool4o`00
0_ooo`Go00000oooool00?l00003o`000_ooo`Ko0005oooo1Ol000Soool5
o`001_ooo`04o`00oooooooooooo1Ol000Koool5o`001_ooo`Go0004oooo
1Ol000;oool5o`000_ooo`Go00000oooool00?l00003o`000_ooo`Ko0005
oooo1Ol000Soool5o`001_ooo`03o`00oooooooo00Ooool5o`002_ooo`Ko
0004oooo1Ol000?oool6o`001Oooo`Go003Ioooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0b_ooo`Co0002oooo1Ol00003
ooooo`00o`0000?o0003oooo1Ol000Koool4o`002?ooo`Go000;oooo1Ol0
00Goool5o`001Oooo`Go0005oooo1Ol000;oool5o`000_ooo`Go0002oooo
1Ol000;oool5o`001_ooo`Co0008oooo1Ol0013oool5o`002_ooo`Go0005
oooo1Ol000Coool5o`001_ooo`Co003Ioooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0b_ooo`Co0002oooo1Ol00003oooo
o`00o`0000?o0003oooo1Ol000Koool4o`002Oooo`Go000:oooo1Ol000Go
ool5o`001Oooo`Go0006oooo1Ol00003ooooo`00o`0000?o0002oooo1Ol0
00;oool5o`000_ooo`Go0006oooo1?l000Woool5o`003oooo`Go000:oooo
1Ol000Koool5o`000oooo`Go0006oooo1?l000_oool4o`00b_ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0<[oool5o`00
00?ooooo003o00002Ol000?oool6o`001Oooo`Co0009oooo1Ol000[oool5
o`001_ooo`Go0004oooo1Ol000goool5o`0000?ooooo003o00000ol000;o
ool5o`000_ooo`Ko0005oooo1?l000Woool5o`003oooo`Go000:oooo1Ol0
00Koool5o`000oooo`Ko0005oooo1?l000_oool4o`00b_ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0<_oool4o`0000?o
oooo003o00001?l00003ooooo`00o`0000?o0003oooo1ol000?oool4o`00
2Oooo`Go000:oooo1Ol000Koool5o`001?ooo`Go000=oooo1Ol00003oooo
o`00o`0000?o0002oooo1Ol000?oool7o`000oooo`Co0009oooo1Ol000oo
ool5o`002_ooo`Go000?oooo1ol000?oool4o`002oooo`Co003:oooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0boooo`Co
00000oooool00?l00004o`0000?ooooo003o00000ol000Goool<o`002Ooo
o`Go000:oooo1Ol000Koool5o`001?ooo`Go000=oooo1Ol000;oool5o`00
00?ooooo003o00000ol000Goool<o`002Oooo`Go000@oooo1Ol000Woool5
o`004Oooo`co000;oooo1Ol00<Woool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP3;oooo1?l00003ooooo`00o`0000;o0000
0oooool00?ooo`05o`001_ooo`co0008oooo1Ol000_oool5o`001Oooo`Go
0005oooo3ol000;oool5o`000_ooo`Go00000oooool00?l00003o`001_oo
o`co0008oooo1Ol0013oool5o`002Oooo`Ko000Aoooo3?l000[oool5o`00
bOooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
0<_oool4o`0000?ooooo003o00000_l00003ooooo`00o`0000Go0009oooo
2Ol000Woool5o`002_ooo`Go0005oooo1Ol000Goool@o`0000?ooooo003o
00000ol000;oool5o`000_ooo`Go0008oooo2Ol000Woool5o`003oooo`Go
000:oooo1Ol001Coool9o`002_ooo`Go0039oooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0boooo`Co00000oooool00?l0
0002o`0000?ooooo003o00001Ol000coool6o`002Oooo`Go000:oooo1Ol0
00Koool4o`001Oooo`Go0007oooo1?l00003ooooo`00o`0000?o0002oooo
1Ol000;oool5o`002oooo`Ko0009oooo1Ol000ooool5o`002_ooo`Go000G
oooo1_l000_oool4o`00bOooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0<_oool9o`0000Cooooo003o003oool5o`000ooo
o`Go0004oooo1Ol000Woool5o`002_ooo`Ko0005oooo1Ol000Goool5o`00
1_ooo`Co0002oooo1Ol00003ooooo`00o`0000?o0002oooo1Ol000?oool5
o`001?ooo`Go0009oooo1Ol000ooool5o`002_ooo`Ko0005oooo1Ol000Co
ool5o`001?ooo`Go000;oooo1Ol00<Soool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3<oooo2?l00004ooooo`00o`00oooo
1Ol000?oool5o`001Oooo`Co0009oooo1Ol000[oool6o`001Oooo`Go0005
oooo1Ol000Koool4o`000_ooo`Go00000oooool00?l00004o`0000?ooooo
003o00000ol000?oool5o`001Oooo`Co0009oooo1Ol0013oool5o`002_oo
o`Go0004oooo1_l000Coool5o`001Oooo`Co000;oooo1Ol00<Soool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3<oooo2?l0
00;oool7o`001?ooo`Go0003oooo1Ol000Woool5o`002_ooo`Oo0004oooo
1Ol000Koool5o`001?ooo`Co0003oooo1_l00003ooooo`00o`0000?o0000
0oooool00?l00003o`001?ooo`Go0003oooo1Ol000Woool5o`004?ooo`Go
000;oooo1Ol000?oool5o`001_ooo`Go0003oooo1Ol000_oool5o`00b?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0<co
ool8o`000_ooo`Oo0004oooo1_l00003ooooo`00o`0000Co0009oooo1Ol0
00_oool8o`0000?ooooo003o00001?l000Ooool6o`0000?ooooo003o0000
0ol000?ooolBo`001?ooo`Ko00000oooool00?l00004o`002Oooo`Go000@
oooo1Ol000coool<o`001_ooo`Ko00000oooool00?l00004o`002oooo`Go
0038oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH0c?ooo`So0002oooo1ol000Goool<o`001Ooooa3o0004oooo3_l000Wo
ool:o`001?oooa;o0005oooo3?l000Goool@o`002Oooo`Go000=oooo2_l0
00Soool<o`002oooo`Go0038oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH0c?ooo`So0002oooo1ol000Ooool8o`002?oo
o`oo0004oooo1Ol00003ooooo`00o`0000Go000<oooo1_l000OooolAo`00
1oooo`So0008oooo3ol000Woool5o`003oooo`Oo000;oooo2?l000goool6
o`00aoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0<goool7o`000oooo`Oo000Joooo1Ol000[oool5o`00COooo`Go001;
oooo1Ol00<Ooool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3=oooo1ol000?oool7o`006_ooo`Go000:oooo1Ol004goool5
o`00Boooo`Go0037oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH0cOooo`Oo0003oooo1ol001[oool5o`002_ooo`Go001=
oooo1Ol004_oool5o`00aoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0<goool7o`000oooo`Oo000Joooo1Ol000_oool4
o`00COooo`Go001;oooo1Ol00<Ooool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP3=oooo1ol000Coool6o`006oooo`Go000:
oooo1Ol004goool5o`003oooo`Go000foooo1_l00<Koool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3=oooo1ol000Coool6
o`006oooo`Go000:oooo1Ol004goool5o`003oooo`Go000foooo1_l00<Ko
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3>
oooo1_l000Coool7o`00:Oooo`Go001Qoooo1Ol003Koool6o`00a_ooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0<koool6
o`001?ooo`Oo000Yoooo1Ol006;oool5o`00=Oooo`Ko0036oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomg
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
oooooooooomgoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomgoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH0oooooooooomgoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomgoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomg
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
oooooooooomgoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomgoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH0oooooooooomgoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomgoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomg
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
oooooooooomgoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomgoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH0oooooooooomgoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomgoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomg
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
c_ooo`co003oooooW?ooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV0<goool>o`00oooooi_oool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP0`ooooool00?oo000Go`00<?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0<co
ool5o`002?ooo`Co003oooooVOooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV03Koool7o`002?ooo`Go000Doooo1ol001oo
ool8o`002Oooo`Go0002oooo1Ol000[oool5o`002_ooo`Go0006oooo1Ol0
00?oool4o`002?ooo`Co000Loooo1Ol000koool7o`007_ooo`go0009oooo
1Ol000coool=o`002Oooo`Go000>oooo1Ol000coool=o`001?ooo`Co0000
0oooool00?l00004o`003Oooo`Go000?oooo1ol001ooool5o`003?ooo`Go
000@oooo1ol000Ooool5o`000_ooo`Go0002oooo1Ol003Woool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0eoooo2_l000Ko
ool5o`004oooo`Wo000Loooo2ol000Soool5o`000_ooo`Go000:oooo1Ol0
00[oool5o`001_ooo`Go0004oooo1?l000Ooool4o`007?ooo`Go000=oooo
2_l001_oool=o`002_ooo`Ko000:oooo3Ol000[oool5o`003_ooo`Go000;
oooo3Ol000Goool=o`002oooo`Go000=oooo2_l001koool5o`003?ooo`Go
000?oooo2_l000Koool5o`0000?ooooo003o00000ol000;oool5o`00>Ooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV03Co
ool<o`001Oooo`Go000Boooo3?l001[oool=o`001_ooo`Go0002oooo1Ol0
00[oool5o`002_ooo`Go0006oooo1Ol000Goool=o`007Oooo`Go000<oooo
3?l001Woool>o`002_ooo`Ko0009oooo3_l000[oool5o`003oooo`Go0009
oooo3_l000Goool>o`002oooo`Go000;oooo3?l001goool5o`003?ooo`Go
000>oooo3?l000Goool5o`0000?ooooo003o00000ol000;oool5o`00>Ooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV03Co
ool5o`000_ooo`Ko0005oooo1Ol0013oool6o`0000?ooooo003o00001?l0
01Woool6o`000_ooo`Oo0005oooo1Ol000;oool6o`002_ooo`Go0009oooo
1Ol000Koool5o`001Oooo`go000Noooo1Ol000[oool6o`000oooo`Go000H
oooo1Ol000Coool5o`002_ooo`Oo0008oooo1Ol000Coool5o`002oooo`Go
000>oooo1Ol000Woool5o`001?ooo`Go0005oooo1ol000Coool4o`002_oo
o`Go000;oooo1Ol000?oool5o`007Oooo`Go000;oooo1Ol000goool6o`00
1?ooo`Co0004oooo1Ol00003ooooo`00o`0000?o0002oooo1Ol003Woool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0coooo
1_l000?oool6o`001?ooo`Go000@oooo1Ol000Coool5o`006?ooo`Go0005
oooo1Ol000Goool5o`000_ooo`Ko000:oooo1Ol000[oool5o`001Oooo`Go
0004oooo1_l002Koool5o`002_ooo`Go0005oooo1Ol001Koool6o`001Ooo
o`Go0009oooo1ol000Ooool6o`001Oooo`Go000:oooo1Ol000koool5o`00
2?ooo`Ko0005oooo1Ol000Coool6o`001_ooo`Co0009oooo1Ol000_oool5
o`001?ooo`Go000Loooo1Ol000_oool5o`003Oooo`Go0006oooo1?l000?o
ool5o`000_ooo`Go00000oooool00?l00003o`00>Oooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV03?oool5o`001Oooo`Go
0004oooo1Ol0013oool5o`001?ooo`Ko000Goooo1Ol000Koool5o`001?oo
o`Ko00000oooool00?l00004o`002_ooo`Go000:oooo1Ol000Goool5o`00
1?ooo`Go000Woooo1Ol000[oool5o`001Oooo`Go000Goooo1Ol000Koool4
o`002?ooo`Go00001?ooool00?l00?l000Ooool5o`001_ooo`Co000:oooo
1Ol000koool5o`002Oooo`Go0006oooo1?l000Coool6o`001_ooo`Co0009
oooo1Ol000[oool5o`001Oooo`Go000Loooo1Ol000_oool5o`003Oooo`Go
0006oooo1?l000?oool5o`000_ooo`Go0002oooo1Ol003Soool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0coooo1Ol000Go
ool5o`001?ooo`Go000?oooo1_l000Goool5o`005oooo`Go0006oooo1Ol0
00Coool6o`0000?ooooo003o00001Ol000Woool5o`002_ooo`Go0006oooo
1Ol000?oool5o`009oooo`Go000:oooo1Ol000Goool5o`005oooo`Go0006
oooo1?l000Soool5o`0000Cooooo003o003o0007oooo1Ol000Koool4o`00
2_ooo`Go000>oooo1Ol000Woool5o`001_ooo`Co0005oooo1Ol000Ooool3
o`002Oooo`Go000:oooo1Ol000Koool5o`006oooo`Go000<oooo1Ol000co
ool5o`001oooo`Co0002oooo1Ol000;oool5o`000_ooo`Go000hoooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0<oooo`Go
0006oooo1Ol000?oool5o`003oooo`Go0006oooo1Ol001Ooool5o`001_oo
o`Go0004oooo1_l00003ooooo`00o`0000Go0009oooo1Ol000[oool5o`00
1_ooo`Go0004oooo2Ol002;oool5o`002_ooo`Go0004oooo1_l001Ooool6
o`001Oooo`Co0008oooo1Ol00003ooooo`00o`0000;o0006oooo1_l000Go
ool4o`002_ooo`Go000>oooo1Ol000Woool6o`001Oooo`Co0005oooo1Ol0
00Ooool4o`002?ooo`Go000:oooo1Ol002Koool5o`003?ooo`Go000<oooo
1Ol000Ooool4o`000oooo`Go00000oooool00?l00003o`000_ooo`Go000h
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
=?ooo`Go0005oooo1Ol000?oool5o`003oooo`Go0006oooo1_l001Koool5
o`001_ooo`Go0004oooo1?l00003ooooo`00oooo00Oo0009oooo1Ol000[o
ool5o`001_ooo`Go0006oooo2Ol0023oool5o`004_ooo`Oo000Hoooo1ol0
00?oool4o`002?ooo`Go0002oooo0ol000Ooool7o`000oooo`Co000:oooo
1Ol000ooool5o`002Oooo`Oo0003oooo1?l000Goool5o`001oooo`Co0009
oooo1Ol000Woool5o`009oooo`Go000;oooo1Ol000coool5o`001oooo`Co
0003oooo1Ol00003ooooo`00o`0000?o0002oooo1Ol003Soool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0doooo1Ol000Go
ool5o`001?ooo`Go000>oooo1Ol000Ooool5o`008Oooo`Go0004oooo1?l0
0003ooooo`00oooo00Co00001?ooool00?l00?l000Woool5o`002Oooo`Go
0006oooo1Ol000Goool;o`008?ooo`Go000>oooo2?l001coool<o`002?oo
o`Go0002oooo1?l000Soool<o`002oooo`Go000>oooo1Ol000_oool<o`00
1Oooo`Go0008oooo0ol000Woool5o`002Oooo`Go000Woooo1Ol000_oool5
o`003?ooo`Go0008oooo1?l000;oool5o`000_ooo`Go00000oooool00?l0
0003o`00>?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV03Coool5o`001Oooo`Go0004oooo1Ol000koool5o`001oooo`Go
000Poooo1_l000Coool4o`0000?ooooo003o00001?l00004ooooo`00o`00
o`002Oooo`Go000:oooo1Ol000Goool5o`001Oooo`Go0003oooo1?l001oo
ool5o`003Oooo`So000Noooo3?l000Ooool5o`000_ooo`Co0009oooo3?l0
00[oool5o`003_ooo`Go000<oooo3?l000Coool5o`002?ooo`?o0009oooo
1Ol000[oool?o`007?ooo`Go000;oooo1Ol000coool5o`002?ooo`Co0002
oooo1Ol000;oool5o`0000?ooooo003o00000ol003Soool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0noooo1Ol000Coool5
o`003_ooo`Ko000Zoooo1ol000Coool4o`0000?ooooo003o00001?l00003
ooooo`00o`0000;o0008oooo1Ol000[oool5o`001Oooo`Go0005oooo1Ol0
00Coool4o`007_ooo`Go000<oooo1_l002Coool9o`001oooo`Co0004oooo
1?l000_oool9o`002_ooo`Go000>oooo1Ol000ooool9o`001Oooo`Go0007
oooo1?l000Soool5o`002_oooa3o000Koooo1Ol000_oool6o`002oooo`Go
0008oooo1?l000;oool5o`000_ooo`Go0002oooo1Ol003Ooool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0ooooo1Ol000?o
ool>o`001_ooo`Go000Xoooo2?l000Goool4o`0000?ooooo003o00001?l0
0003ooooo`00o`0000;o0008oooo1Ol000[oool5o`001_ooo`Go0004oooo
1Ol000Coool4o`007_ooo`Go000;oooo1_l002Soool6o`001oooo`Co0004
oooo1?l000koool6o`002_ooo`Go000>oooo1Ol001;oool6o`001Oooo`Go
0007oooo1?l000Soool5o`002_ooo`Go0007oooo1?l001_oool5o`003?oo
o`Ko000;oooo1Ol000Ooool4o`000_ooo`Go0002oooo1Ol000;oool5o`00
=oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
03ooool5o`000oooo`ko0006oooo1Ol002Ooool7o`001oooo`Co00000ooo
ool00?l00004o`0000?ooooo003o00000_l000Soool5o`002_ooo`Ko0005
oooo1Ol000Coool5o`001?ooo`Co000Noooo1Ol000_oool5o`001?ooo`Go
000Hoooo1Ol000Coool5o`001_ooo`Go0004oooo1Ol000Goool5o`001?oo
o`Go000:oooo1Ol000ooool4o`002_ooo`Go0004oooo1Ol000Goool5o`00
1oooo`Co0009oooo1?l000_oool5o`001_ooo`Co000Koooo1Ol000coool7
o`002_ooo`Go0007oooo1?l000?oool5o`0000?ooooo003o00000ol000;o
ool5o`00=oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV03ooool5o`000oooo`ko0006oooo1Ol002Koool7o`002?ooo`Co
0002oooo1Ol000;oool4o`002?ooo`Go0009oooo1ol000Coool5o`001?oo
o`Go0004oooo1?l001ooool5o`002_ooo`Go0004oooo1Ol001Soool5o`00
1Oooo`Co0006oooo1Ol000Goool4o`001Oooo`Go0005oooo1?l000_oool5
o`003_ooo`Go0009oooo1Ol000Goool4o`001Oooo`Ko0006oooo1?l000Wo
ool5o`002_ooo`Go0006oooo1?l001coool5o`002oooo`So000:oooo1Ol0
00Koool4o`000oooo`Go00000oooool00?l00004o`0000?ooooo003o0000
0ol003Ooool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP0ooooo1Ol000Coool5o`003_ooo`Go000Uoooo1ol000Woool4o`00
0_ooo`Go0002oooo1?l000Soool5o`002_ooo`Oo0003oooo1Ol000Goool5
o`000oooo`Co000Ooooo1Ol000_oool5o`000oooo`Go000Ioooo1Ol000?o
ool5o`001_ooo`Go0005oooo1Ol000Goool5o`000oooo`Go000;oooo1Ol0
00koool5o`002_ooo`Go0003oooo1Ol000Goool7o`001?ooo`Co000:oooo
1Ol000_oool5o`001?ooo`Co000Moooo1Ol000_oool=o`001Oooo`Ko0004
oooo1?l000Coool6o`0000?ooooo003o00000ol00003ooooo`00o`0000?o
000goooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH0?oooo`Go0004oooo1Ol000koool6o`008oooo`Oo000:oooo1?l000;o
ool5o`000_ooo`Co0008oooo1Ol000[oool8o`0000?ooooo003o00001?l0
00Koool5o`0000?ooooo003o00001_l001coool5o`002oooo`Ko00000ooo
ool00?l00004o`006Oooo`Ko00000oooool00?l00004o`001_ooo`Go0005
oooo1Ol000Goool6o`0000?ooooo003o00001?l000_oool5o`003_ooo`Go
000:oooo1_l00003ooooo`00o`0000Co0005oooo2?l00003ooooo`00o`00
00Co000:oooo1Ol000coool6o`0000?ooooo003o00000ol001goool5o`00
2oooo`go0006oooo1_l00003ooooo`00o`0000Co0004oooo4_l003Ooool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP10oooo
1Ol000?oool5o`003oooo`Go000Soooo1_l000_oool4o`000_ooo`Go0002
oooo1Ol000Ooool5o`002_ooo`ko0007oooo3_l001coool5o`003?ooo`_o
000Koooo3?l000Koool5o`001_ooo`Co0006oooo3?l000_oool5o`003_oo
o`Go000;oooo3?l000Koool=o`002oooo`Go000=oooo2_l001[oool?o`00
1_ooo`Co00000oooool00?l00005o`001oooo`_o0005oooo4_l003Ooool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP10oooo
1Ol000?oool5o`003oooo`Go0006oooo1_l001Ooool5o`003?ooo`Co0002
oooo1Ol000;oool5o`001oooo`Go000:oooo1Ol000;oool6o`002_ooo`go
000Koooo1Ol000koool7o`007oooo`So0008oooo1Ol000Koool5o`001ooo
o`So000=oooo1Ol000koool5o`003Oooo`So0008oooo1?l00003ooooo`00
o`0000Go000<oooo1Ol000ooool6o`007?ooo`oo0006oooo1Ol00003oooo
o`00o`0000Co000:oooo1_l000SooolAo`00=oooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV043oool5o`000oooo`Go000@
oooo1Ol000Koool5o`005oooo`Go003loooo1Ol001coool5o`005?ooo`Go
000doooo1Ol007Soool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP10oooo1Ol000Coool5o`003oooo`Go0006oooo1Ol001Oo
ool5o`001Oooo`Go003boooo1Ol001coool5o`005?ooo`Go000eoooo1Ol0
07Ooool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP10oooo1Ol000Coool5o`004?ooo`Go0004oooo1_l001Ooool5o`001Ooo
o`Go003boooo1Ol001coool5o`005?ooo`Go000eoooo1Ol007Ooool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP10oooo1Ol0
00Coool5o`004?ooo`Go0004oooo1Ol001Woool5o`001?ooo`Go003boooo
1Ol001coool5o`005?ooo`Go000eoooo1Ol000Koool00ol00?ooooooo`1^
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
@Oooo`Go0003oooo1Ol0017oool5o`000oooo`Go000Ioooo1_l000;oool6
o`007?ooo`Go0019oooo1Ol0073oool5o`003_ooo`Go000Moooo1?l001Co
ool5o`00=Oooo`Go0004oooo0ol0073oool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP11oooo1Ol000?oool@o`001oooo`co
000Joooo3?l001goool5o`00BOooo`Go001`oooo1Ol000koool5o`007Ooo
o`Go000Coooo1Ol003Koool;o`00L?ooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV047oool5o`000ooooa7o0007oooo2_l0
01coool;o`007Oooo`Go0019oooo1Ol0073oool5o`003oooo`Go000Loooo
1Ol001Coool5o`00=_ooo`[o001`oooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH0@Oooo`Go0004oooo4?l000Woool6o`00
8?ooo`Oo000Poooo1Ol004Woool5o`00L?ooo`Go000>oooo1Ol001coool5
o`005?ooo`Go000hoooo2?l0073oool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooooooo
ogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooooooo
ogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooooooo
ogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooooooo
ogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooooooo
ogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP3Poooo1P00017oool30000ooooogcoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3Noooo
2P00013oool300004_ooobH00009oooo400000?oool@00001?oooa000002
oooo400000Goool?0000g?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0=goool700000oooo`<0000>oooo0`0001KooolR
00003?ooo`X00009oooo2P0000[oool:00002?ooo`X0000:oooo3@000=co
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3L
oooo200000?oool400003Oooo`<0000Hoooo2P0000ooool800003?ooo`P0
000;oooo200000coool800002_ooo`P0000;oooo2P000=ooool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3Loooo1`0000Go
ool400003Oooo`<0000Goooo2@0001?oool500003Oooo`H0000=oooo1P00
00koool600003?ooo`H0000<oooo20000>7oool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP3Loooo1`0000Goool400003Ooo
o`<0000Hoooo1`0001Goool400003Oooo`H0000=oooo1P0000koool60000
3?ooo`H0000;oooo20000>;oool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3Loooo1P0000Koool500003?ooo`<0000Hoooo
1`0001Koool400003?ooo`H0000=oooo1P0000koool600003?ooo`H0000;
oooo1`000>?oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3Moooo1@0000Koool500003Oooo`<0000Goooo1`0001Ooool3
00003?ooo`H0000=oooo1P0000koool600003?ooo`H0000:oooo1`000>Co
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3N
oooo0`0000Ooool600003?ooo`<0000Goooo1`0001Ooool300003?ooo`H0
000=oooo1P0000koool600003?ooo`H00009oooo1`000>Goool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3Xoooo1P0000co
ool300005oooo`L0000Hoooo0`0000_oool600003Oooo`H0000>oooo1P00
00coool600002?ooo`P0003Uoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH0j?ooo`H0000=oooo0`0001Koool700006?oo
o`<0000;oooo1P0000goool600003_ooo`H0000<oooo1P0000Ooool80000
i_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
0>Soool700003?ooo`<0000Foooo1`0001Woool200002oooo`H0000=oooo
1P0000koool600003?ooo`H00007oooo1`000>Ooool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3Xoooo1`0000coool30000
5_ooo`L0000Ioooo0`0000[oool600003Oooo`H0000>oooo1P0000coool6
00001_ooo`L0003Xoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH0j?ooo`L0000=oooo0`0001Goool700006_ooo`80000:
oooo1P0000goool600003_ooo`H0000<oooo1P0000Goool70000jOooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0>Soool7
00003Oooo`<0000Eoooo1`0002Koool600003Oooo`H0000>oooo1P0000co
ool600001?ooo`P0003Yoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH0j?ooo`L0000=oooo0`0001Goool700009_ooo`H0
000=oooo1P0000koool600003?ooo`H00003oooo20000>[oool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3Xoooo1`0000ko
ool300005?ooo`L0000Voooo1P0000goool600003_ooo`H0000<oooo1P00
00?oool70000joooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV0>Soool700003_ooo`<0000Doooo1`0002Koool600003Ooo
o`H0000>oooo1P0000coool600000_ooo`L0003/oooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0j?ooo`L0000>oooo0`00
01Coool700009_ooo`H0000=oooo1P0000koool600003?ooo`H000000ooo
o`00000000050000kOooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV0>Soool700003oooo`<0000Coooo1`0002Koool60000
3Oooo`H0000>oooo1P0000coool>0000kOooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0>Soool700003oooo`<0000Coooo
1`0002Koool600003Oooo`H0000>oooo1P0000coool6000000?oool00000
000010000>koool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3Xoooo1`0000ooool300004oooo`L0000Voooo1P0000goool6
00003_ooo`H0000<oooo1P0000;oool40000koooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV0>Soool700004?ooo`<0000B
oooo1`0002Koool600003Oooo`H0000>oooo1P0000coool600000oooo`<0
003_oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH0j?ooo`L0000@oooo0`0001;oool700009_ooo`H0000=oooo1P0000ko
ool600003?ooo`H00004oooo0`000>koool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3Xoooo1`00013oool300004_ooo`L0
000Voooo1P0000goool600003_ooo`H0000<oooo1P0000Goool30000kOoo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0>So
ool700004Oooo`<0000Aoooo1`0002Koool600003Oooo`H0000>oooo1P00
00coool600001_ooo`<0003/oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH0j?ooo`L0000Aoooo0`00017oool700009_oo
o`H0000=oooo1P0000koool600003?ooo`H00007oooo0`000>_oool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3Xoooo1`00
017oool300004Oooo`L0000Voooo1P0000goool600003_ooo`H0000<oooo
1P0000Woool20000j_ooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV0>Soool700004_ooo`<0000@oooo1`0002Koool60000
3Oooo`L0000<oooo1`0000coool600002_ooo`80003Yoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0j?ooo`L0000Boooo
0`00013oool700009_ooo`H0000=oooo2@0000[oool600003Oooo`H0000;
oooo0P000>Soool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3Xoooo1`0001;oool300004?ooo`L0000Uoooo1`0000coool7
000000Coool0000000000008oooo1`0000goool600003?ooo`<0003Voooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0j?oo
o`L0000Coooo0`0000ooool700008Oooo`8000000oooo`00000000060000
2?ooo`8000000oooo`000000000600000_ooo`@00005oooo200000goool6
00003?ooo`@0003Uoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH0j?ooo`L0000Coooo0`0000ooool700008_ooo`X00009
oooo2P0000?oool?00003_ooo`H0000<oooo1P000>?oool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3Xoooo1`0001?oool3
00003oooo`L0000Uoooo1`0000coool700001Oooo``0000?oooo1P0000_o
ool90000hOooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0>Soool700005?ooo`<0000>oooo1`0002Ooool500003_ooo`D0
0006oooo2P00013oool600002_ooo`h0003Moooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0j?ooo`L0000Doooo0`0000ko
ool70000:Oooo`<0000@oooo0`0000Soool600004_ooo`H0003eoooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0j?ooo`L0
000Doooo0`0000koool70000Goooo`H0003eoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0j?ooo`L0000Eoooo0`0000go
ool70000Goooo`H0003eoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH0j?ooo`L0000Eoooo0`0000goool70000Goooo`H0
003eoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH0j?ooo`L0000Eoooo0`0000goool70000Goooo`H0003eoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0j?ooo`L0000F
oooo0`0000coool70000Goooo`H0003eoooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0j?ooo`L0000Foooo0`0000coool7
0000Goooo`H0003eoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH0j?ooo`L0000Foooo0`0000coool70000Goooo`H0003e
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
j?ooo`L0000Goooo0`0000_oool70000Goooo`H0003eoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0j?ooo`L0000Goooo
0`0000_oool70000Goooo`H0003eoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH0j?ooo`L0000Goooo0`0000_oool70000
9oooo`@0000doooo1P000?Goool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3Xoooo1`0001Soool300002_ooo`L0000Voooo
1P0003?oool60000mOooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV0>Ooool900005oooo`<00009oooo2@0002Coool80000
<Oooo`L0003eoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0ioooo`T0000Goooo0`0000Woool900009?ooo`P0000]oooo
0P000003oooo0000000000H0003eoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH0iOooo`d0000Foooo0`0000Koool=0000
8_ooo`P0000^oooo2P000?Goool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3Qoooo5@0001;oool300000_oooaD0000Noooo
2000037oool70000mOooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV0?ooool9oooo100003Goool60000=?ooo`D0003eoooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooo
o`[oool30000=_ooo`@0000goooo0`000?Goool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooogOo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oooooooooogOoool01Lc<c?ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@
R0010000000018S0^<SPf8S0^8S0^?mVIVKoIVIVNFIVIP04c<c<R<2hR<2h
B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004
R<2hb>3HR<2hR<2h5P00P0<00H0200:000@00X400h400h400h4300B10P05
P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V30`4:P`03
0@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@2
4hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV9
0aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`0
10@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZ
SPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`Ha
T@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7
=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0
UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6
V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`4
2U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN
00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aM
X@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=
Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/
YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X
00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/3
47b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^
0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4B
R[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008C
Sk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH
]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh
0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/3
5ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1000P003VjOa<d>U<d>U00Tc@jD600200`01P080
0X001002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<1
1h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j5
0`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<4
7XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd0
0`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6
;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHd
TP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD
0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3
U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9
BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd3
2e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<
FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaP
XP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT
0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_
Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?
MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd2
4Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@A
QZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8B
SK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@0
0a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK
]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<E
X[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m
5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000NK
Yo7ooon>N[JVVlBcZM:XWLRcZM800ZJKa005_;SMk^kdj^Waoooo<d>U00D0
080300600P02P00400:100>100>100>10`04P@801H401005PP06PP06PP06
PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b4
0`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8E
Q`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<3
78X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd2
1BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5
;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86
<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@0
0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1
U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9
B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M
2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;
F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR
362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT
3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>
KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?
M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n
[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64
[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;40
11:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B
/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg
59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP
^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@F
Zk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG
/KlG/Kl00aNb_`<G/kl26;C08000008H]<0@00000QRd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000BKYo7ooom/FZF_YLX2_;SM00[ooOnc
ZM;ooooooonl^=fGR[bXWLSVi^cooolc@jD400200`01P0800X001002P@03
P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h8128812880
0P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D4
0Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP3
5hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@P
R`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDW
SP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6
;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB
1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D3
23fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH
2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<
V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;
E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaL
X00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQ
XPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D3
3VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`
Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1h
ZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@03
4H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8
/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb
00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@3
4iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg
00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT
^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G
[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd
`003b>3HB928B92800a8T8P00`000<SPf4R@R00=B92800@0000H]<0H]<38
h=P>B92800<0000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0^8S0
^08008002i^WlOooojRMb?oook>YdV1<VXij]WQU[ZRMb?ooooomo`03oooo
00<c@jD0080008000`00P0<00H0200:000@00X400h400h400h4300B10P05
P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V30`4:P`03
0@^30@^40@^400<138@30@f40`4>Q@<23hD20Q250oooo`824HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00
P00>VjOaoooooooofmc/H4bJThFj/jWB_;SMH4bJVHnnYY_4b<?Ooooo<d>U
1P00P0?oool200:000<00X7oooooool00_ooo`8018400`05POooo`05PP03
00J21?ooo`030@R20@R3oooo00?oool30@Z300Koool12h@12h@138Coool1
38@20@f400Coool13XGoool13XD20Pn500Coool248Goool248D20Q6600?o
ool24HH24XH00P8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP3
5hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX3
11n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DW
S@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y02
1Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP03
1cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`Lk
U@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`04
2D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX3
2T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M
00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ03
35^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<
HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eW
Y0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>
L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX3
3gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]
0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl3
4XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8B
SK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C
]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<D
W;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T3
5J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm
0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l3
5k>o0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P00dR@R0000<SPf002R<2h
2@0000:8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00>VjOaoooo_;SMVHnn
ooooe]7Mfmc/lokoYY_4k^kdQGJ`ThFjoooo<d>U1000P007oooo00600060
0060oooo00:0oooo00<00h401_ooo`04P@04P@05POooo`05PP801X802?oo
o`07PP07PP47P_ooo`48P_ooo`48P`<12H<01?ooo`4:P`4:Poooo`812h@0
0`4<Q?ooo`4<Q0020@f400Coool13XGoool13XD20Pn500?oool248Goool0
0oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<4
7h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=
1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086
;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7
=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9
@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:
BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<
Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`
Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?
MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd3
4H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<B
Qk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d
0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL
]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d2
5jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G
/kl26;C000C8h=R8`;R8`;R8`;P6000018S0^003B9280000b>3H00:8`;P0
0`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`004b>3HR<2h
R<2hR<2h0P0000B8`;P200000XS0^004B92800006;C06;C00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0<008003i^WlOoooiV?_YN:_=CCj>n//omf
NnjOZe]HYJJKa9JOdV1<V[bhgOoooc=3Y@03002000Ooool00H000H000H3o
ool00X3oool00`03P@06oooo00B100B1oooo00F1oooo0P06PP08oooo00N2
00N20@N2oooo0@R2oooo0@R30`49P`09oooo0@Z3oooo0@^3oooo0@^4oooo
0@b4oooo00813H@01?ooo`4>QOooo`4>Q@823hD01?ooo`8@QOooo`8@Q@@2
4HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<G
R0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;
0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>
00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_
T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87
=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8
?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9
A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK
0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]D
WP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP
00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R
3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>
JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X
3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ
0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<A
PJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`
0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[80
0a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<C
UKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL0
11FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj
0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]
_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C0
00?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005
R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8`;P20000
0XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOXZFjPb<?OThFjFdJCVHnn
0WQU[P04@RN5[jG:oooo<d>U1000P0<00H000oooo`02P002P@04oooo0P04
P@03oooo00F1oooo00<01X84oooo00<1288128<128<00`49P`09oooo0@Z3
oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?ooo`4>QOooo`4>Q@823hD0
0oooo`8@QOooo`03oooo0P8AQP<24XH20Q>600@24hL258L258L258L30QF7
0P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<L
RP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@85
9Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/
S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHc
TPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU003
1cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G
0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8
V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:
DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]H
W`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<
H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=
IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^
Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010md
Z@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]
47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_
00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@04
4Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c
4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LD
VkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i
00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[
_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa
_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P0
0XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8
h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0P00P003VjOaoooooooo00;oool02_n]/?mf
NoW=e?g]k_ooojJKa8Ef/;bhgOoooc=3Y@D00803006000?oool00X000X40
0`03P@03oooo00B1oooo00801H401005P_ooo`06PP06PP801h800`47P_oo
o`48PP020@R30oooo`812X<01oooo`4;Poooo`4;Q?ooo`4<Q?ooo`020@f4
00Coool13XGoooooool20Pn500Koool248Goool248D24HKoool20Q660`8B
QP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR8
00<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/3
12:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>
0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946
<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087
=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10Pn
UP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH
0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/3
2TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h0
0`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ
35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeR
XP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZ
Y@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0ma
Z0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/3
47Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^
4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK00
11:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8C
Sk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF
]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPE
W[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX3
5ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^
_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3H
R<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^005
0000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^004R<2h0P0000F8`;P0
14R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P30020
00ZQ[?;icMCR9Scd]KoR9ScdKGglhnWoooomkNko[K02oooo00<c@jD00800
08001000P0<00H000oooo`02P002P@03oooo0P04P@05oooo00F100F100F2
oooo00801X83oooo0P48PP030@R3oooo0@V300812H<20@Z300Coool12h<1
2hCoool20@b400Ooool13H@13HCoool13XGoool13XD00_ooo`030Pn50Q25
0Q2500Coool0108AQP8BQP8BQP8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL2
0QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:
0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDU
S@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?
0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B
1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7
>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL3
24:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI
0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YB
W@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO
10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaP
XPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eU
Y0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW
3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY
0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@
OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l0
0a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@B
S;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<C
T[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK
]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T0
11FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l
5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o
5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002
R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSP
f8S0^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000fKYo7mkNkR9ScnmOSgRIOdHVkcX:kd
HVkooOoo[K3lhnWooolc@jD01`00P0<00H000oooo`02P002P@0300>10`04
P@801H401005PP06PP06PP06PP801h801@47PP48PP48P_ooo`48P`030@V3
0`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR003
0aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A
1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC
0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH3
23nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9
AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>
V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aM
X@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ80
0PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD4
3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?
LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1j
Z`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61
[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@B
RK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb
4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D3
59Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh
5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0
^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@00
08S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h0P00
00>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2002000>KYo7fb<cR9S`00_n]/007gb@^ojBNm[c5ojf`kW^<oooo<d>U
00P00803006000?oool00X000X400`03P@<0184200F100@01H801X801X80
1X8200N200D11h81288128;oool128<00`49P`04oooo0@Z30@Z30@^30P4;
Q0<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L2
58L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT3
0a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@T
S@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`03
1B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010Hb
TPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`Lh
U0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G
246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@04
2DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:
DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;
Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ
00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=
IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]
Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?
LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[004
47j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^
4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a
0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A
/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf
00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h
5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@F
Z[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h0
0aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P0
0038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P00hS0^0800004
R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2002000>KYo7icMCgRIL00_ooo`07ojf`hAHdogIkojBNhRHl
ohUo<d>U00P00803006000?oool00X000X400`03P@<0184200F100@01H80
1X801X801X8200N200@11h812881288128<4oooo0`4:P`030@^30@^40@^4
00<138@20@f400Coool13XD13XD13XD30Pn50`8@Q@@24HH30Q:60P8CQP04
0Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<I
R@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><
00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5
:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6
<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<3
1cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88
@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9
AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL
10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]F
WP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<
GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<3
3F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>
K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mb
Z0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[
0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62
[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa
4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P02
4hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@D
V;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN
^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk
0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn
00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P0
2hS0^003B9280000b>3H00:8`;P900000XS0^005B92800006;C06;C0b>3H
00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2002000NKYo7oooocX:kdHVkoooogRIOicM@00_ooo`03lj2^oooo<d>U
00P0080300600P02P00400:100>100>100>10`04P@801H401005PP06PP06
PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q003
0@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<K
R@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d4
9Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[
S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO
00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y
00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n
[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64
[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P04
59Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl
00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G
/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000
b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00;VjOaooooohUooooo
lj2^lI>Qoooooogolj2^oo_l<d>U00P0080300600P02P00400:100>100>1
00>10`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R3
0`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH3
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C03lSP
f0030000b>3Hb>3H00g8h=P00`0001Rd`1Rd`00?b>3H00<0000H]<0H]<00
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0@00803VjOa00KoooocX:kd
]Kof_<GkfMXc@jD900200`01P0800X001002P@03P@03P@03P@<0184200F1
00@01H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<1
2h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108C
Q`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT3
6HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS004
12B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>
1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A
0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`Lg
T`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F
00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH
2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:
D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh0
0`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ
0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eS
X`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP0
0`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@
O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh3
4H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::
/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?
/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf
0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P3
5Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<F
Z;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P03
5jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;PF00200`01P0800X001002P@03P@03P@03P@<01842
00F100@01H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z3
00<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0
108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP3
6HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@S
S00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP03
1BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<943
1S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC
0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2
242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V003
2DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?
W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;
EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ
35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S
0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH3
3VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?
LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1k
Z`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<A
PZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::
/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk80
0Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD4
59Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PE
W[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW
^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^
_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00
000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000003R<2hb>3H
R<2h0?n8`;SoR<2hOHS0^058T8P1000000000hS0^<SPf<SPf03ob>3HolSP
f7g8h=P1B9280@000000ohS0^?n8`;R1R<2h0@000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?oo
l?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`
l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003o
oo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;o
l?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h000?oi^KVooo?clooolo?cggo
clo?0_oVi^H000?ok^k^00?o^KVionk^k_o^k^h0ooo^k^koonk^kWWok^k^
0Oni^KT1onk^kP7ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooo
oomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?o
oooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi
00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03
onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooo
oooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003
onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o
^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^
0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oS
hn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomg
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo
0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;o
k^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooo
oomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?o
oooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^
kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03
onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoS
hn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o
^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo
0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomg
ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03
okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007o
oooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^
k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?o
oooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003oooo
o`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo
007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooo
oooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003
ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni
^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomg
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo
0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;o
k^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?S
honi^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooo
oomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^
kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi
00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03
on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoS
hn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o
^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV
0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomh
ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03
okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^
k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooo
oomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?o
oooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi
00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03
onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooo
oooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003
onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o
^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^
0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oS
hn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomg
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo
0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;o
k^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooo
oomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?o
oooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^
kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03
onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoS
hn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o
^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo
0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomg
ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03
okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007o
oooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^
k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?o
oooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003oooo
o`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo
007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooo
oooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003
ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni
^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomg
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo
0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;o
k^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?S
honi^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooo
oomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^
kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi
00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03
on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoS
hn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o
^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV
0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomh
ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03
okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^
k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooo
oomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?o
oooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi
00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03
onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooo
oooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003
onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o
^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^
0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oS
hn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomg
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo
0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;o
k^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooo
oomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?o
oooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^
kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03
onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoS
hn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o
^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo
0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomg
ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03
okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007o
oooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^
k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?o
oooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003oooo
o`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo
007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooo
oooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003
ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni
^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomg
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo
0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;o
k^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?S
honi^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooo
oomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^
kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi
00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03
on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoS
hn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o
^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV
0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomh
ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03
okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^
k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooo
oomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?o
oooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi
00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03
onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooo
oooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003
onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o
^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^
0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oS
hn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomg
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo
0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;o
k^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooo
oomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?o
oooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^
kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03
onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoS
hn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o
^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007ooooo
0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomg
ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03
okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo007o
oooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^
k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?o
oooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003oooo
o`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWooooo
007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooo
oooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003
ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?Shoni
^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomg
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo
0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;o
k^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhooooo`03on?S
honi^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooo
oomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^
kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi
00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?ooooooH?ooool01?ni^KWo
S8b<okbl_?ogmoOooooooaCooooo00?ohn?SokVi^Oooool00Oooool000?o
k^k^00?o^KVion?Shoooool0oooooomPooooo`06oi2@T?l0003o0000oa/K
6onGUiOono_koooooolAooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?ooooooHOooool01_oTi>CoVYZJoaXJ6_l0003o
CTi>ooShn?oooooo4?ooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h0
0oni^KWohn?Sooooo`3ooooooa3ooooo00Kojn_[ok:b/_nDU9CoZj^[omCD
e?oinOTBooooo`04oo3`l?nl_;cod];BooCdm0Kooooo00?okNg]ol?3`oof
m_H03?ooool01?o_knoo_knoolO7aoojn_X7ooooo`03okno_oo0`<3ooooo
01Cooooo00Gom?Cdochn?_l0003oBTY:ooknoP3oooooo`oooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0ooooool>oooo
o`03ooOgmomZJV[o20P800Co000000OoH61Pooooooooooooooooog5aLOl0
003o_[jn00[ooooo00?o_knooc/k>ol410@00_l000000ol71`OoDe=ColK6
aP03ooooo`09oi2@T?l51@Go0000o`/;2omMGEgom_Kfoo?clol0003o9BDU
00Gooooo00?okno_odA4A?l10@400_l000000olB4Q;oTi>Cooooo`04oooo
o`04oj^[Zol0003o0000ojf][AGooooo00Coi^KVoaPH6?l0003oW9bLoooo
ool@ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?o
oooo0?oooooo3Oooool02OoemOGo?3`lo`000?lc<c?oWYjNom[Jf_nIVIWo
0000of1PH003ooooo`03og5aLOl0003o_[jn00Wooooo00Wod=3@o`h>3_l@
413oN7QhokNg]onYZJWoNWYjoa/K6omYJFT00_ooool02_nn_[ko0000o`82
0_mZJV[oKfm_o`d=3Om5ADGob<S8o`000?m6ATH5ooooo`07oc<c<ol0003o
GEeMokJf]_n`/;3oLg=cofe]K@05ooooo`04oi2@T?l0003o0000oi:BTQKo
oooo00Co_knoo`<30olB4Q;ol?3`ooooool>ooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooo3Oooool01?mjNW[o
0000oc8b<_o`l?02ooooo`03ojNWYol0003oH61P00?ooooo00?oLG5ao`00
0?nn_[h02?ooool01?odm?Co6ATIo`L71oo1`L44ooooo`07oo[jn_oIfMWo
oooooooooom7AdOo0000ogAdM002ooooo`05omoOgolJ6Q[o71`Lo`000?mV
IVH01?ooool00ooBd];o0000ocPh>00:ooooo`04oo?clomkNg_oO7alooCd
m1Oooooo00?oJVYZo`000?nLW9`0ooooool>ooooo`03onKVi_oShn?o^KVi
00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooo3?ooool01?o[jn_o
1PH6o`000?oHf=P3ooooo`03ojNWYol0003oH61P00?ooooo00?oLG5ao`00
0?nn_[h02?ooool00onk^k_o0000ofEUI@09ooooo`03oahN7_l0003o^[Zj
00?ooooo00Coa/K6o`H61_l0003oOGem1?ooool00one]KGo0000ofYZJP0U
ooooo`03olC4a?l0003o@4100?oooooo3_ooool00oo^k^kohn?SokVi^@02
onk^kP000oooool00oni^KWohn?Sooooo`3oooooo`cooooo00?oWYjNo`00
0?lo?cl01?ooool00onWYjOo0000of1PH003ooooo`03og5aLOl0003o_[jn
00Sooooo00?oOGemo`000?nPX:002Oooool00ol92@Wo0@41ooGem@04oooo
o`03ohR8R?l0003oOWin00Cooooo00?oZJVYo`000?n5QHD09Oooool00oon
o_ko1`L7o`X:2P3oooooo`oooooo00?ohn?SokVi^Oooool00Oooool000?o
k^k^00?o^KVion?Shoooool0ooooool<ooooo`03oe]KFol0003oSXj>00?o
oooo00CooOgmojBTY?l0003oH61P0oooool00omaLG7o0000okjn_P08oooo
o`03oeADE?l0003o7QhN00Ko9bLW00KoHV9Roooooooooooo=cLgo`000?o[
jn/4ooooo`03ojj^[_l0003oOWin00Cooooo00?oZJVYo`000?n5QHD05?oo
ool00on3Ph?oHF5Qof5QH@04of5QH@03oh:2P_oooooooooo00Sooooo00?o
8B4Qo`000?o[jn/0ooooool=ooooo`03onk^k_oShn?o^KVi00;ok^k^0003
onKViP03okVi^OoShn?ooooo0?oooooo3?ooool00om0@43o0000ojj^[P03
ooooo`04ob<S8ol0003o0000of1PH0?ooooo00?oLG5ao`000?nHV9P01?oo
ool01ooinOWono_kooooooooooooQ8B4o`000?m5ADD01?mlO7`00omMGEgo
0000oeiNGP02ooooo`03ofi^K_l0003o`l?300Cooooo00?o[Zj^o`000?mn
OWh01?ooool00onYZJWo0000ohF5Q@0Dooooo`03oda<C?lJ6Q[o6QXJ00Co
6QXJ00?oBDU9ooooooooool02?ooool00ol[:b_o0000omoOg`3oooooo`go
oooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0
ooooool<ooooo`03obd];Ol0003oaLG500?ooooo00CoTI6AogmoOomoOgoo
[jn_0oooool01?maLG7o0000oa4A4OoShn<2ooooo`03on3Ph?l0003oH61P
00;ooooo00?o_knoo`000?ld=3@01?ooool00on<S8co0000ogalO002oooo
o`03ojJVY_l0003oDE5A00Cooooo00?o[Zj^o`000?mnOWh01?ooool00onY
ZJWo0000ohF5Q@0Vooooo`03oa4A4Ol20P;ono_k0?oooooo3Oooool00oo^
k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`3oooooo`co
oooo00?o?3`lo`000?nTY:@02_ooool02OmaLG7o0000oa/K6olX:2Sohn?S
oooooooPh>3o0000of1PH002ooooo`04ooOgmolZ:R[o0000okRh^0?ooooo
00?o>c/ko`000?o5aLD00_ooool01?olo?coADE5o`000?n>SXh3ooooo`05
ojj^[_l0003oOWinooooooogmoL00_mlO7`00omBDU;o0000od10@004ogal
O003omCDe?oooooooooo00?ooooo00CohN7Qoc`l??ll?3coh^;R5oooool0
0ooVi^Ko0000ob8R8P3oooooo`oooooo00?ohn?SokVi^Oooool00Oooool0
00?ok^k^00?o^KVion?Shoooool0ooooool<ooooo`03oeEEEOl0003oMgMg
00[ooooo00WoLG5ao`000?nc/k?o?Cdmo`d=3OmWIfOoLG5ao`000?mOGel0
0oooool02?oPh>3o61PHo``<3?moOgooUiNGobl_;ol0003oB4Q81?ooool0
2oo^k^ko9BDUo`000?lg=cOoMGEeogAdM?lj>S[o0000ogemOOooooool?3`
00Wo000000?oZj^[ooooooooool00oooool01?n3Ph?o0000o`000?n5QHDG
ooooo`03oi:BT_l0003oMGEe0?oooooo3_ooool00oo^k^kohn?SokVi^@02
onk^kP000ooVi^H00oni^KWohn?Sooooo`3oooooo`cooooo00?oTI6Ao`00
0?m:BTX02_ooool01_mnOWko5aLGolC4a?obl_;oI6AToa/K6`;o000000?o
IfMWooooooooool00_ooool01oo@d=3oFEUIoa8B4_l0003o1PH6of1PH?oe
mOD01Oooool02?oRh^;oI6AToaHF5_l0003o0@41oa4A4OlG5aOoRHV91?oo
ool00onYZJWo0000ohF5Q@0:ooooo`04olW9bOl<30co3@d=ol_;baKooooo
00ColO7aob<S8ol0003odM7Aooooool>ooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooo3?ooool01?oPh>3o0@41
o`H61_oBd]8?ooooo`03om_Kfoo[jn_ooooo00Kooooo00?oo?clomWIfOoi
nOT02_ooool00oogmoOoo?clooooo`06ooooo`03ojVYZOl0003oQHF500_o
oooo0_obl_8Gooooo`03oe9BD_l0003oFEUI0?oooooo3oooool00oo^k^ko
hn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`3oooooo`gooooo
00CoHf=So`000?lb<S;ono_k;Oooool00onYZJWo0000ohF5Q@0Sooooo`04
ohj>S_l0003o410@onSXj?oooooo4?ooool00ooShn?o^KViooooo`01oooo
o`000oo^k^h00oni^KWohn?Sooooo`3oooooo`gooooo00Wojn_[obDU9Ol0
003oF5QHon?ShooooooolO7aoj^[ZonDU9@0:?ooool00onYZJWo0000ohF5
Q@0Qooooo`05ooCdm?mlO7co10@4o`l?3oo6a/H0ooooool@ooooo`03onk^
k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooo3_oo
ool01OoZj^[oADE5o`000?l0003o3@d=00;o000000?oHV9Rooooooooool0
9_ooool00ooMgMgoVYZJolo?c`0Oooooo`06ol;2`_mADE7o4a<Co`000?l/
;2cocLg=oooooolAooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooo4?ooool01_o;bl_oRHV9ofe]KOnDU9CobLW9
ooShn4[ooooo00GoR8R8oahN7_m>CTkoYjNWoogmo@3ooooooa;ooooo00?o
k^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0oooooomP
ooooo`03oogmoOoooooooooo0?oooooo5Oooool00ooShn?o^KViooooo`01
ooooo`000oo^k^h00oni^KWohn?Sooooo`3oooooooooooooMoooool00oo^
k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`3ooooooooo
ooooMoooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?S
ooooo`3oooooooooooooMoooool00oo^k^kohn?SokVi^@02onk^kP000ooo
ool00oni^KWohn?Sooooo`3oooooooooooooN?ooool00ooShn?o^KVioooo
o`01ooooo`000oo^k^h00oni^KWohn?Sooooo`3oooooooooooooMoooool0
0oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`3ooooo
ooooooooMoooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWo
hn?Sooooo`3oooooooooooooMoooool00oo^k^kohn?SokVi^@02onk^kP00
0oooool00oni^KWohn?Sooooo`3oooooooooooooN?ooool00ooShn?o^KVi
ooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`3oooooooooooooMooo
ool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`3o
ooooooooooooMoooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni
^KWohn?Sooooo`3oooooooooooooMoooool00oo^k^kohn?SokVi^@02onk^
kP000oooool00oni^KWohn?Sooooo`3oooooooooooooN?ooool00ooShn?o
^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`2loooooogoo`00
_?ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Soooo
o`3Fooooo`07oooknoooa/Koog1`oomBD_ooL73ooknoooomo@0Dooooo`07
oooNg_ooShoooe9Boom:B_ooJFWoojf]ooocl`0Pooooo`08oooWioooWIgo
oemOoom5AOooCTkoogAdoonVY_oogmlOooooo`07oooknoooa/Koog1`oomB
D_ooL73ooknoooomo@0Dooooo`07oooNg_ooShoooe9Boom:B_ooJFWoojf]
ooocl`0Qooooo`09ooo^k_oo[:coofm_oom<C?ooATKooe]KoomlO?oo]kOo
ooCd00Sooooo00Oooo_kooo6a_ooL73ooe9Boom`L?oo_koooogm017ooooo
00KoooOgoon@T?oo;Bgooc8boonOWooon?S4ooooo`03onKVi_oShn?o^KVi
00;oi^KV0003onk^kP03okVi^OoShn?ooooo0;cooooo00Goooknool;2ooo
003oo`00oolV9P0;ooooo`03oooemOoo003oo`0000;oo`0000KoomWIoooo
oooooooooooooooYjOoo;Bd5ool00005oolA4OooQHGoooOgoooooooocLd0
1?oo00000oooiNGoooooooooo`06ooooo`03ooolo?ooNGWoo`X:00Koo`00
00?oo`41oolh>?oo]KD00oooool01_oo`L7oo`00ool00?oo003ooa4Aooon
oPOooooo00Googalool00?oo003oo`00oomEE@07ooooo`03ooo[joooHV;o
o`8200Ooo`0000?ooa4AoomVI_oodm<00oooool01OooDE7oo`00ool00?oo
003oonKV00?ooooo00Cood=3ool00?oo003ooa8B1?ooool01?oo5AGoo`00
ool00?oo7al4ooooo`03oooYjOoo;Bgoo`0000Coo`0000Gooa4Aoon5QOoo
moOoooooooo=c@04ool00003oooUiOoooooooooo00Kooooo00?ooocloomi
NOoo2PX01_oo00000ooo0@7oocPhoone]@09ooooo`03oolG5ooo003oo`00
00Koo`0000?oofMWooooooooool02?ooool00oooi>Coof5Qool41007ool0
0003ool10Ooo7AgoohF500Gooooo00?oonWYool];Ooo00001?oo00001Ooo
4A7oohF5ooogmoooooooolg=00Coo`0000?oonGUooooooooool01_ooool0
0oooXj?oo`00ool00002ool00003oom^K_oooooooooo0<;ooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0_Oooool01Ooo
ADGoo`00ool00?oo003ooo;b00_ooooo00Goobh^ool00?oo003oo`00oonS
X`02ooooo`03ooobl_oo8R;oo`0000Ooo`0000?oob4Qooo<c?ooe=@01?oo
00000oooj>Soooooooooo`06ooooo`03oomRH_oo003oo`0000Soo`0000Go
oa@Dooooooooooooooooooocl`04ool00003oooLg?oooooooooo00Gooooo
00Gook6aool00?oo003oo`00oolP8006ooooo`03ooo]kOoo:R[oo`0000_o
o`0000Cood92ooooooooooooohJ60ooo00001Ooo/;3ooooooooooooooooo
ogQh00?oo`0000GoomcLoooooooooooooooooom<C003ool00005ooo[jooo
ooooooooooobl_oo8R802?oo00000ooo8B7oolc<oooDe004ool00003oooX
j?oooooooooo00Kooooo00?oof9Rool00?oo00002?oo00000ooo51Cooooo
ooooo`07ooooo`03oom?Cooo003oo`0000Koo`0000?ooc8booooooooool0
1oooool00oooe]KooaHFool0000:ool00003ool20_oom_Kooooo00;ooooo
00?ooo;boolR8_oo00001ooo00000ooo8B7oolc<oooDe004ool00003oooX
j?oooooooooo00Kooooo00?oogYjool00?oo00000_oo00000ooo0@7oomKF
ooooo`33ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0;gooooo00GoogYjool00?oo003oo`00oonl_00;ooooo`05oomS
Hooo003oo`00ool00?ooKVh00_ooool00oooXj?oo`00ool00003ool00003
oolL7?oo51Coo`0000;oo`0000?oo`82oonDU?oo00000ooo00000oooiNGo
ooooooooo`05ooooo`03oooEeOoo003oo`0000;oo`0000Koo`@4oomOGooo
Vi_ooi6AoomKFooo5QH2ool00005oooNg_oooooooooooooooooo:b/00ooo
00000oooYZKoooooooooo`05ooooo`03oooVi_oo003oo`0000;oo`0000?o
onc/ooooooooool00oooool00oooA4Coo`00ool00002ool00007oolJ6_oo
O7coojNWoon?SoooFU[oobd]ool30`02ool00004ool10Oool_;ooooooonk
^`?oo`0000Goog]koooooooooooooooooon^[P03ool00005oonWYooooooo
ooooooooooooPH400ooo00001?oo];CoooooooooooooXj<5ool00003oolL
7?oo51Coo`0000;oo`0000?oo`82oonDU?oo00000ooo00000oooiNGooooo
ooooo`05ooooo`03oooEeOoo003oo`0000;oo`0000Koo`@4oomOGoooVi_o
oi6AoomKFooo5QH2ool00003oooNg_oooooooooo00Kooooo00GoohB4ool0
0?oo003oo`00ool71`03oolO7`03oolQ8OooGeoooooo00Oooooo00?oonSX
oolB4_oo00000ooo00001ooo0@7ooaHFoolm?OooCTkooc`loolK6ooo0@40
0_oo00001Oooa<Cooooooooooooooooooj>S00Goo`0000?ooa`LoolD5?oo
00000_oo00000ooo0P;ooiBDool00003ool00003oooUiOoooooooooo00Ko
oooo00?oon3Pool92Ooo00000ooo00000oooh>3oooooooooo`31ooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0;gooooo
00Goojn_ool00?oo003oo`00oon7Q`0;ooooo`05oonHV?oo003oo`00ool0
0?oo>CT00_ooool00oooC4coo`00ool00002ool00005oon6Q_oooooooooo
oonn__oo8B400_oo0002ool10@?oo`0000?ool?3ooooooooool01Oooool0
0oooYjOoo`00ool00002ool00003oonWYooooooooooo00?ooooo00?oolG5
oonYZOoofm/00oooool01OooH63oo`00ool00?oo003oog5a00Sooooo00Go
oa/Kool00?oo003oo`00oonf]P04ooooo`03ooo7aooo003oo`0000;oo`00
00?oode=ooojn_ooool01?ooool01oool?3ooh^;oolK6ooo8b?ooknooooo
ooooknl00ooo00001OooADGoooooooooooooooooon?S00?oo`0000Goog9b
oooooooooooooooooong]`03ool00004oomoOooooooooooooom<C0Coo`00
00GoohJ6oooooooooooookjnoolQ8@02ool000;oo`410ooo00000ooo`l?o
ooooooooo`05ooooo`03oonWYooo003oo`0000;oo`0000?oojNWoooooooo
ool00oooool00oooaLGoojVYoooKf`08ooooo`06ooni^Ooo003oo`00ool0
0?oo5aOooogm3?ooool00oooKFgoo`00ool00002ool00003oolD5?oofMWo
oooo00Cooooo00Cooo?coonUYOooRHWool[:0oooool00oooC4coo`00ool0
0002ool00005oon6Q_oooooooooooonn__oo8B400_oo0002ool10@?oo`00
00?ool?3ooooooooool01oooool01Ooo/k?oobPXool20_oo10Coof][0<Co
oooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0
_Oooool01Oooi>Coo`00ool00?oo003ooe9B00_ooooo00Goolg=ool00?oo
003oo`00ool92@02ooooo`06oolL7?oo003oo`00ool00?oo3@gooogm0ooo
ool00ooono_oofATool00005ool00003oonLW?oooooooooo00Gooooo00Go
oi:Bool00?oo003oo`00oolJ6P0<ooooo`05oonEUOoo003oo`00ool00?oo
?3`02?ooool01OooDE7oo`00ool00?oo003ooh6100Cooooo00KooeeMool0
0?oo003oo`00ool=3Oool?09ooooo`;oooOg0_ooool01?oo9RKoo`00ool0
0?oo4A44ooooo`04oolF5_oo003oo`00ooll?0?ooooo00Goon_[ool00?oo
003oo`00oom:BP02ooooo`06oolL7?oo003oo`00ool00?oo3@gooogm0ooo
ool00ooono_oofATool00005ool00003oonLW?oooooooooo00Gooooo00Go
oi:Bool00?oo003oo`00oolJ6P0Aooooo`03ooo^k_oo003oo`0000;oo`00
00?oon?Sooooooooool02Oooool00oool?3oo`D5ool00002ool00003ool<
3?ooeMGooooo00cooooo00Kooa`Lool00?oo003oo`00ool=3OoooOd3oooo
o`03oooknoooI6Coo`0000Goo`0000?ooibLooooooooool02Oooool2oooi
nLGooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shooo
ool0__ooool01?oo5AGoo`00ool00?oo7Ad3ooooo`06ooni^Ooo=cOooaHF
oolF5_oo>c_oolO70_ooool00ooon_[oo`@4ool00002ool00003ooo?cooo
ooooobl_00?oo`0000?oodE5ooooooooool01?ooool00oooRh_oo`00ool0
0003ool00003oomeMOoooooooooo00Gooooo00Goojj^ool00?oo003oo`00
oolT900<ooooo`06ooo;booo003oo`00ool00?oo2@Woookn1oooool01Ooo
QXKoo`00ool00?oo003ooda<00Cooooo00Goobd]ool00?oo003oo`00oomV
IP0>ooooo`05oomKFooo003oo`00ool00?oofm/00oooool01OooCDgoo`00
ool00?oo2P[oookn00?ooooo00Ooob4Qool00?oo003ooa@DooomoOoooooo
obl_00?oo`0000?oodE5ooooooooool01?ooool00oooRh_oo`00ool00003
ool00003oomeMOoooooooooo00Gooooo00Goojj^ool00?oo003oo`00oolT
900Booooo`05oolT9?oo003oo`00ool00?oo[Jd02oooool00ooo`l?oo`00
ool00002ool00003oomOGooooooooooo00cooooo00Goobl_ool00?oo003o
o`00oom5A@06ooooo`03oon;Rooo003oo`0000?oo`0000?oogEeoooooooo
ool0dOooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?S
ooooo`2nooooo`05oom?Cooo003oo`00ool00?ooj^X00_ooool00oooNg_o
o`00ool00002ool00005oolf=_oooooooooooooooooo>3P00ooo00000ooo
VIWooooooom3@`03ool00003oom4A?oooooooooo00Gooooo00?ooh61ool0
0?oo00000_oo00000ooo@T;oooooooooo`05ooooo`06ooo?cooo003oo`00
ool00?oo1@Gooocl2oooool00ooonOWoo`41ool00002ool00003oooBd_oo
oooooooo00Gooooo00Kook^kool00?oo003oo`00oolF5_ooo_h2ooooo`03
ooomoOoo1@Goo`0000;oo`0000?ooi>Cooooooooool03?ooool01OooT93o
o`00ool00?oo003oojJV00?ooooo00Gooh:2ool00?oo003oo`00oooBdP03
ooooo`07oomFE_oo003oo`00ool00?ooh>3ooooooom3@`03ool00003oom4
A?oooooooooo00Gooooo00?ooh61ool00?oo00000_oo00000ooo@T;ooooo
ooooo`05ooooo`06ooo?cooo003oo`00ool00?oo1@Gooocl4Oooool01Ooo
FEWoo`00ool00?oo003oogQh00_ooooo00?ooiJFool00?oo00000_oo0000
0oooZj_oooooooooo`0<ooooo`05oom3@ooo003oo`00ool00?ooA4@01ooo
ool00oooPH7oo`00ool00002ool00003oom2@_oooooooooo0=3ooooo00?o
k^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0__ooool0
1OooQ8Coo`00ool00?oo003ook:b00;ooooo00?ooeEEool00?oo00000ooo
00001?ooYJGoooooooooooooKFd3ool00003oomTI?oooooooeQH00?oo`00
00?oobXZooooooooool01_ooool01OooH63oo`00ool00?oo003oo`l?00Oo
oooo00?oooCdool10Ooo00000_oo00000ooofMWoooooooooo`0:ooooo`05
oole=Ooo003oo`00ool00?ooW9`01oooool00oooknooo`00ool00002ool0
0005oooQhOooooooooooooono_oo0P800ooo00000oooXJ7oooooooooo`0<
ooooo`05ooo5aOoo003oo`00ool00?ooLG400oooool01Ooo^;Soo`00ool0
0?oo003ooifM00?ooooo00Oooh^;ool00?oo003oo`00oonZZ_oooooooeQH
00?oo`0000?oobXZooooooooool01_ooool01OooH63oo`00ool00?oo003o
o`l?00Oooooo00?oooCdool10Ooo00000_oo00000ooofMWoooooooooo`0?
ooooo`05oon>S_oo003oo`00ool00?oo@d<02oooool00oooV9Soo`00ool0
0002ool00003oooFe_oooooooooo00cooooo00GooeQHool00?oo003oo`00
oolZ:P08ooooo`05oomPH?oo003oo`00ool00?oo3`l02_ooool01Ooof=So
ogMgoom=COooNGWoom_K0<?ooooo00?oi^KVon?Shoni^KT00_oVi^H000?o
k^k^00?o^KVion?Shoooool0__ooool01Ooo^KWoo`00ool00?oo003oogem
00;ooooo00?oobh^ool00?oo00000ooo00001?oo7AgoooOgooooooooXZ83
ool00003ool_;ooooooooiBD00?oo`0000?oo`P8ooodm?ooool01_ooool0
0oool_;oo`00ool00002ool00003oooGeooooooooooo00Gooooo00Goobd]
ool00?oo003oo`00oonUY@0<ooooo`05oomZJ_oo003oo`00ool00?ooIfL0
2?ooool01Ooo9BGoo`00ool00?oo003oojb/00?ooooo00GooaXJool00?oo
003oo`00oon9R@0>ooooo`05ooofm_oo003oo`00ool00?oo>c/00oooool0
1Oook>coo`00ool00?oo003oofQX00?ooooo00Oool71ool00?oo003oo`00
oomeMOoooooooiBD00?oo`0000?oo`P8ooodm?ooool01_ooool00oool_;o
o`00ool00002ool00003oooGeooooooooooo00Gooooo00Goobd]ool00?oo
003oo`00oonUY@0Aooooo`06ooo3`ooo003oo`00ool00?oo3Pkoookn2_oo
ool00ooo/;3oo`00ool00002ool00003ooo:b_oooooooooo00cooooo00Ko
oiBDool00?oo003oo`00ool82?oom?@7ooooo`03ooobl_oo003oo`0000;o
o`0000?oomOGooooooooool01oooool01OooaLGoo`00ool00?oo003ooh20
0<?ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shooo
ool0__ooool02?ookNgoo`00ool00?oo003oodQ8ooooooooo_koo`L71_oo
00000oooQXKooooooooGe`03ool00003ool30ooon_[oon;R00Coo`0000?o
ojNWooooooooool01_ooool01Ooo:b_oo`00ool00?oo003ooj:R00Oooooo
00Goof9Rool00?oo003oo`00oom_K`0<ooooo`05oonOWooo003oo`00ool0
0?oo<S802?ooool01OooFU[oo`00ool00?oo003oogMg00?ooooo00?oocTi
ool00?oo00003Ooo00001Ooo0@7ooclooooooooooooooc0`00;oo`0000?o
o`T9ooomoOooool00_ooool01?oo8R;oo`00ool00?oo<c<3ooooo`07oooc
looo003oo`00ool00?oo@43ooooooooRhP04ool00003oonWYooooooooooo
00Kooooo00Goob/[ool00?oo003oo`00oonRXP07ooooo`05oomRH_oo003o
o`00ool00?ooKfl04Oooool00ooomOGoo`00ool00002ool00003oooIfOoo
oooooooo00Sooooo00?oom3@ool00?oo00000_oo00000ooo^[[ooooooooo
o`0<ooooo`03oooRh_oo003oo`0000;oo`0000?oojNWooooooooool01_oo
ool01Ooo:b_oo`00ool00?oo003ooj:R00Wooooo00Goono_ool00?oo003o
o`00oom0@034ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi
^OoShn?ooooo0;oooooo00Koob<Sool00?oo003ooa8BooomoOooh^84ool0
0007ool];Ooo003oo`00ool;2ooojNWoooknool;2`03ool00003ooo5aOoo
oooooc8b00?oo`0000?oodi>ooooooooool01_ooool01OooH63oo`00ool0
0?oo003oofe]00Oooooo00GooiNGool00?oo003oo`00oolj>P0<ooooo`06
oooEeOoo003oo`00ool00?oo10CoooWi1oooool01OooT93oo`00ool00?oo
003ood9200?ooooo00?oohB4ool00?oo00003_oo00001?oo71cooooooooo
ooooIFD3ool00005oooAdOooooooooooooooooooEeL00_oo00000ooo10Co
oo7aooooo`02ooooo`04ool[:ooo003oo`00ool=3@;ooooo00Gooc8bool0
0?oo003oo`00oom>CP08ooooo`05oomPH?oo003oo`00ool00?ooKFd01ooo
ool01OooUiOoo`00ool00?oo003oocXj01;ooooo00Goobh^ool00?oo003o
o`00oonSX`0;ooooo`05oolX:?oo003oo`00ool00?ooN7P03oooool01Ooo
<S;oo`00ool00?oo003oodi>00Sooooo00Goof1Pool00?oo003oo`00oom]
K@0:ooooo`05oolJ6_oo003oo`00ool71ooon?P0`_ooool00oo^k^kohn?S
okVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`2oooooo`06oomIFOoo
003oo`00ool00?oogMgook^k1?oo00001ooo^KWoo`00ool00?oo003oofMW
oooooooo@T800ooo00000oooShoooooooonSX`03ool00003ool51Ooojn_o
oooo00Kooooo00GooiFEool00?oo003oo`00oolh>007ooooo`06ooo<c?oo
003oo`00ool00?oo20Sooocl2oooool00ooooOgoo`L7ool00002ool00003
oon8R?oooooooooo00Gooooo00Gool;2ool00?oo003oo`00ool@4003oooo
o`03oooFe_oo003oo`0000;oo`0000?ooc/koomKFoooFe/01OooFe/01Ooo
AdOoo`00ool00?oo003oo`H600;ooooo00GooiZJool00?oo003oo`00oomW
I`03ooooo`05oon<S?oo003oo`00ool00?ooK6`00oooool01oooH63oo`00
ool00?oo003oomKFooooooooXj<00ooo00000ooo1@Goon_[ooooo`06oooo
o`05oonEUOoo003oo`00ool00?oo>3P01oooool01_ooc<coo`00ool00?oo
003oo`P8ooolo17ooooo00Goof=Sool00?oo003oo`00oom^KP0;ooooo`06
oon:R_oo003oo`00ool00?oo8R;ooogm3_ooool01_ooXj?oo`00ool00?oo
003oo`D5ooo[j`Oooooo00GooiFEool00?oo003oo`00oolh>00:ooooo`05
oom4A?oo003oo`00ool00?oo`<00`_ooool00ooVi^Kohn?SokVi^@02onKV
iP000oo^k^h00oni^KWohn?Sooooo`2oooooo`06oon>S_oo003oo`00ool0
0?ooZ:SooiFE0ooo00000ooo3`ooooknoomIF@02ool00003ool20_ooe=Co
ogMg00?oo`0000CooeYJooooooooo_kooc0`0ooo00000oooCTkooooooooo
o`05ooooo`06ooo:b_oo003oo`00ool00?oo1`Oooocl1_ooool00ooon_[o
o`D5ool00002ool00003ooo@d?oooooooooo00[ooooo00?oocloool00?oo
00000_oo00000ooo[Jgoooooooooo`04ooooo`03ooo_kooo003oo`0000;o
o`0000GoomkNoooooooooooooooooom3@`03ool00003oolh>?oooooooooo
00Gooooo00?oom_Kool00?oo00000_oo00000oookNgoooooooo?c`04ool0
0004ooo2`_ooooooooooooo2`P?oo`0000Goo`82ooo@d?oooooooooooonE
U@03ool00004oonQXOooooooooknool`<0?oo`0000?oodi>ooooooooool0
1Oooool01_oob/[oo`00ool00?oo003oo`L7ooolo0Kooooo00?ooo[jool5
1Ooo00000_oo00000oood=3oooooooooo`0?ooooo`05oonHV?oo003oo`00
ool00?oo>CT02oooool00oooj>Soo`<3ool00002ool00003oonNW_oooooo
oooo00cooooo00?oooknool`<?oo00000_oo00000oooCTkoooooooooo`05
ooooo`06ooo:b_oo003oo`00ool00?oo1`Oooocl2Oooool01OooKfooo`00
ool00?oo003ooh200<;ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo
00?o^KVion?Shoooool0_oooool01_oo`l?oo`00ool00?oo003oog=coom^
KP?oo`0000Cooc@dooooooooh>3oo`H60_oo00000oooAdOoojb/ool00002
ool00004oolU9Ooooooooooooonm_@Coo`0000?ooh^;ooooooooool01?oo
ool00ooonOWoo`@4ool00002ool00003ooo>c_oooooooooo00Gooooo00Go
ocLgool00?oo003oo`00oonKV`0<ooooo`03oomdM?oo003oo`0000;oo`00
00?oo`L7oong]oooool01Oooool01Ooo5aOoo`00ool00?oo003ook2`00?o
oooo00?oom7Aool10Ooo00000_oo00000ooo[jooooooooooo`04ooooo`03
ooo^k_oo003oo`0000;oo`0000CoomKFoooooooono_oo`D50ooo00001?oo
8R;ooo7aooooooooknl4ool00004oolc<ooonOWoooooooo9b@?oo`0000Co
of][oooooooooooookfm1?oo00000oooRh_oooooooooo`04ooooo`03oooi
nOoo10Coo`0000;oo`0000?oolk>ooooooooool01Oooool01Ooo=cOoo`00
ool00?oo003ooi^K017ooooo00Koolg=ool00?oo003oo`00ool82?oooOd;
ooooo`06oomOGooo003oo`00ool00?oo5aOoon[Z3_ooool00ooo_Kgoo`00
ool00002ool00003oon;Rooooooooooo00Cooooo00?oooWiool41?oo0000
0_oo00000oooc/koooooooooo`07ooooo`05oonIVOoo003oo`00ool00?oo
@400`oooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?S
ooooo`2oooooo`06ooodm?oo003oo`00ool00?oo?SkoodQ80ooo00001?oo
F5SoooooooooooooMgL3ool00003oonRX_oo003oo`0000;oo`0000Cooo?c
oooooooooooooh:20ooo00000ooo0P;oojJVooooo`05ooooo`05oole=Ooo
003oo`00ool00?ooV9P00_ooool00ooom_Koom7Aoonh^002oonh^005oom:
B_oo003oo`00ool00?ooC4`01ooo^;P00ooodm?oooShooooo`02ooooo`03
oonYZOoo003oo`0000?oo`0000?oo`41oonATOooool01?ooool01Ooo8R;o
o`00ool00?oo003oohj>00Cooooo00Koofa/ool00?oo003oo`00ool?3ooo
e]H5ooooo`03ooo:b_oo003oo`0000;oo`0000CoonGUooooooooooooocXj
0ooo00001Ooo0@7ooe5AoooooooooooooaDE00?oo`0000Coo`<3oomYJOoo
ooooooGe0ooo00001Ooo>S[ooooooooooooooooooh:200?oo`0000?oo`82
oonVY_ooool01Oooool01Ooo=CGoo`00ool00?oo003ooiRH00;ooooo00?o
ooKfoooAdOoo^;P00_oo^;P01OooBT[oo`00ool00?oo003ooda<00OookRh
00?oom?Cooohn?ooool01oooool00ooon_[oo`@4ool00002ool00003ooo?
cooooooooooo00Wooooo00?oooKfoold=?oo00000_oo00000ooo>3SoooSh
ooooo`0=ooooo`06oon2P_oo003oo`00ool00?oo0P;oojJV1_ooool01Ooo
=CGoo`00ool00?oo003ooiRH00Wooooo00KoolC4ool00?oo003oo`00ool7
1ooon?S1ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoS
hn?ooooo0<3ooooo00Goobd]ool00?oo003oo``<oolR8P03ool00005oomm
OOooooooooooooo`l?oo4Q800_oo00000ooo:R[ooa<Cool00002ool00005
oonk^oooooooooooooooooooFUX01?oo00000oooBT[oonWYooooo`03oooo
o`05oomZJ_oo003oo`00ool00?ooHf<00_ooool00ooog=coo`00ool0000?
ool00005oonb/_oooooooooooooooooogml01ooo00001Ooo@d?oom[Joooo
oooooooool[:00Coo`0000?ooi2@ooooooooool00_ooool00ooon_[ood10
ool00002ool00003oolH6?ood];ooooo00?ooooo00GoofMWool00?oo003o
o`00ool`<003ooooo`03oom_Kooo003oo`0000?oo`0000?oof=SooomoOoo
51@01Ooo00000oooN7SoooGeool20P02ool00003oolH6?oooooooooo00;o
oooo00?ooeYJool00?oo00000_oo00000oooBT[oonWYooooo`03ooooo`05
oomZJ_oo003oo`00ool00?ooHf<00_ooool00ooog=coo`00ool0000?ool0
0003oonb/_oooooooooo00Oooooo00GoocPhool00?oo003oo`00oonIV@0<
ooooo`03oooXj?oo7Agoo`0000;oo`0000?oobd]oooHf?ooool01Oooool0
0ooom?CooiZJoonQX@05ooooo`03oomJF_oo003oo`0000;oo`0000?oodY:
oooYjOooool00oooool01OooJV[oo`00ool00?oo003oof=S00Wooooo00?o
onk^ool00?oo00000_oo00000ooo`<3oooooooooo`2oooooo`03onKVi_oS
hn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0<3ooooo00Goof=S
ool00?oo003oo`00ool10@03ool00005oonQXOooooooooooooooooooUID0
0ooo00001Ooo;Bgoo`00ool00?oo003oohJ600?ooooo00?oooWioomUIOoo
00000ooo00001_oo10Coob<SoomADOooG5coocTiool@40?oo`0000Goobh^
oooooooooooooooooolB4P0@ool00003oommOOoooooooooo00;ooooo00Go
oa0@ool00?oo003oo`00oomIF@03ool00004ool10Ooo<S;ooda<ool?3`Co
o`0000?ooj^[ooooooooool00oooool00oooknooob`/ool00002ool00005
ool10OooDU;oojn_oonj^_ooEED01?oo00001OooNg_ooooooooooooooooo
ojBT00?oo`0000CoocTiool00?oo003oo`X:1?oo00001?oo>3Soo`00ool0
0?oo30`4ool00006ooogmooooooooooooooooooonOWoofEU1?oo00001_oo
10Coob<SoomADOooG5coocTiool@40?oo`0000Goobh^oooooooooooooooo
oolB4P0@ool00003oommOOoooooooooo00;ooooo00?oohZ:ooll??oo<C40
0_oo<C401Ooo4Q;oo`00ool00?oo003oofAT00gooooo00?oomGEoolB4_oo
00000_oo00002?oo0P;ood92oonOWooocloookfmoon7Qooo@T;oo`D50_oo
00000ooofm_oooooooooo`02ooooo`03oooinOooIFGoo`0000?oo`0000Ko
o`@4oolS8oooDE7ooeaLooli>Ooo4103ool00003ool^;_oooooooooo00So
oooo00GooaTIool00?oo003oo`00oon0P031ooooo`03onk^k_oShn?o^KVi
00;ok^k^0003ooooo`03okVi^OoShn?ooooo0<3ooooo00?ooiRHool00?oo
00001Ooo00001_ooa/Kooooooooooooooooooo_koolV9P;oo`0000Goo`/;
ool00?oo003oo`00oom@D005ooooo`03oonOWooo1PKoo`0000[oo`0000Ko
o`82ooogmooooooooooooonMWOooCTh3oolo?`05ool51Ooo003oo`00ool0
0?oo;Bd01_oo?cl00oooE5CoojZZooooo`03ooooo`07oom9BOoo003oo`00
ool00?ooR8SoojJVool:2P08ool00003oolA4Ooolo?ooooo00Gooooo00?o
ooOgoomTI?oo00002Ooo00000ooo8R;oon?Sooooo`02ooooo`06oooIfOoo
003oo`00ool00?ooFEWoodI61_oo00000ooobl_oobPXool00004ool00003
ool61_oon_[ooooo00Cooooo00?ooinOool61_oo00002_oo00001_oo0P;o
ooOgoooooooooooooifMoom>CP?ooclo00Goo`D5ool00?oo003oo`00ool]
;@06oolo?`03oomDE?ooZZ[ooooo00?ooooo00?ooeIFool00?oo00001_oo
00000ooo;booooooooooo`0<ooooo`03ooo_koooHf?oo`0000_oo`0000?o
ojFUooooooooool01?ooool00oooWiooo`H6ool0000:ool00003ool20_oo
moOooooo00Sooooo00GoodA4ool00?oo003oo`00oom0@032ooooo`03on?S
honi^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0<3ooooo00?o
olg=ool00?oo00001Ooo00000oooj^[oooooooooo`02ooooo`03oonb/_oo
003oo`0000Coo`0000?ooa/Kooooooooool01?ooool00oook^kooh20ool@
400:ool00003ooo4a?oooooooooo00Gooooo00Good51ool00?oo003oo`00
oon@T00<ooooo`09oomnO_oo003oo`00ool00?ooDe?ooooooooQhOooEUKo
o`8200Goo`0000?ooa0@ooo7aoooool02?ooool00ooo^;Sooc8bool00006
ool00003oola<Ooojn_ooooo00?ooooo00Ooooknool<3?oo003oo`00oolW
9ooon?SooeEE00Coo`0000Cooc`loooooooolO7ood=31?oo00000oooBT[o
ooooooooo`05ooooo`03ooo^k_ooP83ooa0@00[oo`0000?oolC4oooooooo
ool01Oooool01Ooo@D7oo`00ool00?oo003ooi2@00cooooo00?ooh^;ool0
0?oo00001_oo00000ooo0`?oooShooooo`0>ooooo`03ooo=cOoo;Rkoo`00
00Soo`0000?oob<Soonb/_ooool01_ooool00oook^kooh20ool@400:ool0
0003ooo4a?oooooooooo00Oooooo00Koofi^ool00?oo003oo`00ool71ooo
n?S0ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0<3ooooo00?ooo[jool20_oo00001?oo00000ooo3Pkoooknooooo`04
ooooo`03oom1@Ooo003oo`0000Coo`0000?oon[Zooooooooool01_ooool0
2oooj^[ookRhoon6Q_ooLW;ooh20oonQXOoo`l?oom?CoooDe?ooh^;oooSh
00Oooooo00GoogIfool00?oo003oo`00oomKF`0<ooooo`05oonc/ooo003o
o`00ool00?oo7Qh00oooool01ooojNWooi:Boom;Booo=3CoodA4oonDU?oo
m?@03?ooool02?oofm_oohZ:oom?Cooo=SKood=3oon1POoocloooocl1_oo
ool01?ookNgoomSHoooEeOooj^X2ooooo`05oonn__ooEeOoochnoomnO_oo
k^h00oooool01OoocLgoofIVoom3@oooP83ooo;b00[ooooo00_oon[Zoonh
^?ooQXKoog9boon0P?ooXJ7ool?3oooCdoooe=Coon;Rooohn007ooooo`05
oomfM_oo003oo`00ool00?ooFe/03?ooool00ooon?Soon;RoooDe006oooD
e003oooVi_ooo?cooooo013ooooo00Wooo7aoong]oooKfooocdmoolb<_oo
@d?oof5QoonOWooojn/03?ooool02oooj^[ookRhoon6Q_ooLW;ooh20oonQ
XOoo`l?oom?CoooDe?ooh^;oooSh00Wooooo00?ooiVIool00?oo00000_oo
00000ooo`<3oooooooooo`2nooooo`03onKVi_oShn?o^KVi00;oi^KV0003
onk^kP03okVi^OoShn?ooooo0<7ooooo00?oocLgool00?oo00000ooo0000
0ooo<c?oooooooooo`04ooooo`03ooo>c_oo003oo`0000Coo`0000?ook6a
ooooooooool06?ooool01OooZj_oo`00ool00?oo003oobHV00cooooo00?o
onSXool00?oo00000_oo00000oooj^[oooooooooo`1@ooooo`05oon[Zooo
003oo`00ool00?oo9RH0DOooool00ooo`l?oo`00ool00002ool00003oon0
P?oooooooooo0;kooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o
^KVion?Shoooool0`Oooool00oooKFgoo`00ool00003ool00003oomGEooo
oooooooo00Gooooo00?ooemOool00?oo00000ooo00000oooO7cooooooooo
o`0Hooooo`03oooPh?oo003oo`0000;oo`0000?ooo3`ooooooooool02_oo
ool01Ooo7Qkoo`00ool00?oo003ook>c05;ooooo00?oon3Pool00?oo0000
0_oo00000oool?3oooooooooo`1>ooooo`03ooo]kOoo003oo`0000;oo`00
00?oocloooooooooool0_oooool00ooShn?o^KViooooo`01ooooo`000oo^
k^h00oni^KWohn?Sooooo`31ooooo`03oonRX_oo003oo`0000?oo`0000?o
ogalooooooooool01Oooool00oooi>Coo`P8ool00003ool00003oom6A_oo
oooooooo01Wooooo00GooaDEool00?oo003oo`00oonl_00<ooooo`05oomC
Dooo003oo`00ool00?ooOWh0Doooool01Ooo5AGoo`00ool00?oo003ookbl
057ooooo00KooaTIool00?oo003oo`00ool61_oon?Roooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0<7ooooo00?oomOG
ool00?oo00000ooo00000oooX:3oooooooooo`06ooooo`03oommOOoo003o
o`0000;oo`0000?ooa4Aooolo?ooool06Oooool01OooBd_oo`00ool00?oo
003oohJ600cooooo00GoohR8ool00?oo003oo`00oom9B@1Cooooo`05oom;
Booo003oo`00ool00?ooQXH04oooool2oooblScooooo00?ood=3ool00?oo
00000_oo00000ooo_kooooooooooo`2mooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0<7ooooo00?oooknool92Ooo0000
0ooo00000oooaLGoooooooooo`06ooooo`03oooclooo5AGoo`0000?oo`00
00?oomcLooooooooool06?ooool01OooP83oo`00ool00?oo003ooe5A00co
oooo00Kookfmool00?oo003oo`00oolC4oooo_iBooooo`05oon0P?oo003o
o`00ool00?ooDE404Oooool01_oooOgooeEEool00?oo003oobPXoooFeS[o
oooo00?oofi^ool00?oo00000_oo00000oooOgooooooooooo`2mooooo`03
onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0<;ooooo
00?ood51ool00?oo00000_oo00000ooojNWoooooooooo`07ooooo`03oonJ
V_oo003oo`0000;oo`0000?oojNWooooooooool06?ooool01OookNgool30
oonXZ?oo[jooomSH00cooooo00?ooo3`ool00?oo00000_oo00000ooogmoo
ooooooooo`1@ooooo`05ooo]kOoo`<3oojRXoon_[ooof=P04Oooool00ooo
gMgoo`00ool00002ool00003oold=?ooo?cooooo03Sooooo00?ooiRHool0
0?oo00000_oo00000ooo?cooooooooooo`2nooooo`03on?Shoni^KWooooo
007ooooo0003onk^kP03okVi^OoShn?ooooo0<;ooooo00Kook6aoomCDooo
>CWooc/koomlO?ooo_h9ooooo`06ooolo?ooOWkooc`looli>OooFEWookbl
;?ooool01Ooo:2Soo`00ool00?oo003oojVY06Sooooo00?ooogmooli>Ooo
00000ooo00000ooogmooooooooooo`0gooooo`06oooJf_ooIfOoocTiooli
>Ooo?Cgooh61_oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni
^KWohn?Sooooo`3oooooo`Cooooo00GooiZJoom0@?oo;2cood];oone]@1Y
ooooo`06oooIfOoo;Rkoo`41ool10OooGEgoookno_ooool00ooVi^Kohn?S
okVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`3oooooogCooooo0_oo
moOoooooo`7ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVi
on?Shoooool0ooooooooooooogSooooo00?ohn?SokVi^Oooool00Oooool0
00?ok^k^00?o^KVion?Shoooool0ooooooooooooogOooooo00?ok^k^on?S
honi^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ooooooooooooogOo
oooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0
ooooooooooooogOooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o
^KVion?Shoooool0ooooooooooooogSooooo00?ohn?SokVi^Oooool00Ooo
ool000?ok^k^00?o^KVion?Shoooool0ooooooooooooogOooooo00?ok^k^
on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0oooooooooooo
ogOooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shooo
ool0ooooooooooooogOooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo
00?o^KVion?Shoooool0ooooooooooooogSooooo00?ohn?SokVi^Oooool0
0Oooool000?ok^k^00?o^KVion?Shoooool0ooooooooooooogOooooo00?o
k^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0__ooool0
1OoooOgook2`oom<C?oo823oo``<00;oo`<300Goo`d=oolN7_ooCTkookZj
ooomo@3oooooojcooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o
^KVion?Shoooool0_?ooool00ooolO7oogalool?3`0:ool00003ool@4?oo
Ph?ooo_k0?ooooooZ_ooool00oo^k^kohn?SokVi^@02onk^kP000oooool0
0oni^KWohn?Sooooo`2looooo`03oooOgooo003oo`0000Goo`0000?oo`X:
ool30ooo00001?oo00000ooo<33oomoOooooo`3oooooojWooooo00?ohn?S
okVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0_Oooool01ooo
51Coo`00ool00?oo4a?oogMgooo8b?oonOT00_ooool00oooi^Koog=cool5
1@03ool00003ool=3OoofMWooooo0?ooooooYoooool00oo^k^kohn?SokVi
^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`2mooooo`04oomLG?oo<c?o
ohZ:oooin@Oooooo00?oonKVoolk>ooo00000_oo00000ooo=3Cooo_koooo
o`3oooooojKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVi
on?Shoooool0bOooool00oook>cooaTIool00002ool00003oon6Q_oooooo
oooo0?ooooooYOooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni
^KWohn?Sooooo`0Dooooooooo`00oooo001?ool001Gooooo00?ohn?SokVi
^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool05oooool02ooono_o
okBdoomHF?oo;RkooaPHool@4?oo5AGoobPXoomKFoooaLGoookn02Gooooo
00[oon[Zoon6Q_oo?SkooahNoolA4Ooo5AGoobTYoomDE?oo[JgoooGe6ooo
ool03?oonOWook>coomDE?oo:BWooaPHool?3ooo51Coob/[oom9BOooLg?o
oknoooonoT[ooooo00KoomKFoon0P?ooDe?oof9Roon][OoomOD2ooooo`03
ooono_oo61Soo`0000;oo`0000?oojj^ooooooooool0;oooool02_oojNWo
ok:boon0P?ooG5coodI6oom=COooKFgooiBDooo=cOoono/Oooooo`07oook
noooa/Koog1`oomBD_ooL73ooknoooomo@0Sooooo`07oooknoooa/Koog1`
oomBD_ooL73ooknoooomo@0hooooo`07oooknoooa/Koog1`oomBD_ooL73o
oknoooomo@0>ooooo`07ooomoOooi^KookfmoonLW?ooUIGookFeoooXj00V
ooooo`08oooWioooWIgooemOoom5AOooCTkoogAdoonVY_oogmm;ooooo`08
ooono_oofMWoohf=oomFE_ooFU[ooiFEoooKfoooo_i5ooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Kooooo00?oofe]
ool82?oo00002?oo00000ooo6Q[ookZjooooo`08ooooo`03ooogmooo003o
o`0000;oo`0000?ooi2@ooooooooool04Oooool00oook^koofm_ool51@08
ool00003ool30oooKfoooooo01Oooooo00?oong]oomADOoo10@02_oo0000
0ooo823ook2`ooooo`06ooooo`06oomiNOoo003oo`00ool00?oo=cOoookn
1Oooool01OooR8Soo`00ool00?oo003ood=300[ooooo00?ooaLGool00?oo
00001_oo00000oooIfOoooooooooo`03ooooo`06ooo1`Ooo003oo`00ool0
0?oo4A7oookn1oooool01OooO7coo`00ool00?oo003ooeEE00Gooooo00?o
ooWioomDE?oo00001?oo00001Ooo1`OoofUYoooYjOooooooofIV00?oo`00
00?oof1Pooooooooool07?ooool00ooo5aOoo`00ool00006ool00003oomW
Iooooooooooo00Cooooo00?oomoOoomjN_oo7al02Ooo00000ooo3`ooogmo
ooo^kP0Looooo`03oooYjOoo;Bgoo`0000Coo`0000Gooa4Aoon5QOoomoOo
ooooooo=c@04ool00003oooUiOoooooooooo00Kooooo00?ookblool00?oo
00000_oo00000oooTi?oooooooooo`09ooooo`03oooYjOoo;Bgoo`0000Co
o`0000Gooa4Aoon5QOoomoOoooooooo=c@04ool00003oooUiOoooooooooo
00Kooooo00?ooaLGool00?oo00001_oo00000oooIfOoooooooooo`08oooo
o`03oooQhOoo003oo`0000Ooo`0000?oo`<3ooofm_ooool01Oooool00ooo
jNWoobd]ool00004ool00005oolA4OooQHGoooOgoooooooocLd01?oo0000
1?ooiNGoooooooooooooPh<9ool00003ool20_oo>CWookfm00gooooo00?o
on7Qool00?oo00001ooo00000ooo0`?oooKfooooo`07ooooo`03ooo[jooo
HV;oo`8200Ooo`0000?ooa4AoomVI_oodm<07_ooool01Ooo<S;oo`00ool0
0?oo003ooinO00gooooo00Goof1Pool00?oo003oo`00oomaL@0Booooo`03
oon2P_oo1`Ooo`0000Goo`0000?oo`D5oomGEoook>`01Oooool01OooDE7o
o`00ool00?oo003oonKV00?ooooo00Cood=3ool00?oo003ooa8B1?ooool0
1?oo5AGoo`00ool00?oo7alZooooo`03onKVi_oShn?o^KVi00;oi^KV0003
onk^kP03okVi^OoShn?ooooo01Kooooo00?ooc4aool00?oo00002_oo0000
0oooMGGoooooooooo`07ooooo`05oola<Ooo003oo`00ool00?ooFe/04_oo
ool00ooolO7oobd]ool0000:ool00003oolH6?oooooooooo01Kooooo00?o
ooShool41?oo00003?oo00000ooo;RkoonCTooooo`04ooooo`03oon5QOoo
003oo`0000;oo`0000?ool71ooooooooool00oooool01_ooLG7oo`00ool0
0?oo003oo`41oooSh`Wooooo00?oodm?ool00?oo00001_oo00000ooo<S;o
ooooooooo`03ooooo`03oooclooo003oo`0000;oo`0000?oomcLoooooooo
ool01Oooool01Ooo/K7oo`00ool00?oo003oob0P00Gooooo00?ood];ool0
0?oo00001_oo00000ooo3Pkoojf]oona/@03ool00003oolR8_oooooooooo
01cooooo00?oodm?ool00?oo00001_oo00000ooo<S;oooooooooo`04oooo
o`03ool^;_oo003oo`0000_oo`0000?oo`d=ooo<c?ooool06Oooool00ooo
l_;oob8Rool00007ool00003oolQ8Oooc<coomCD00Coo`0000?oonSXoooo
ooooool01_ooool00oooPX;oo`00ool00002ool00003ool:2_ooh^;ooooo
00Sooooo00?ooo;boolR8_oo00001ooo00000ooo8B7oolc<oooDe004ool0
0003oooXj?oooooooooo00Kooooo00?oodm?ool00?oo00001_oo00000ooo
<S;oooooooooo`09ooooo`03oolC4ooo003oo`0000Ooo`0000?oolC4oooo
ooooool00oooool00oool_;oob8Rool00007ool00003oolQ8Oooc<coomCD
00Coo`0000CoonSXoooooooooooookVi3?oo00000ooo:R[oomWIooooo`0;
ooooo`03oolC4ooo003oo`0000Ooo`0000?oolC4ooooooooool01Oooool0
0oookNgoobXZool0000;ool00003oom2@_oooooooooo01_ooooo00GoofMW
ool00?oo003oo`00oomZJP0=ooooo`05oonEUOoo003oo`00ool00?oo?3`0
4?ooool00ooono_oof5Qool00009ool00003ool>3_ooZ:Sooooo00?ooooo
00GoohJ6ool00?oo003oo`00oon`/003ooooo`05oomhN?oo003oo`00ool0
0?oog=`00oooool01OooC4coo`00ool00?oo003oon_[02Wooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool05_ooool02_oo
IVKoo`00ool00?oo2@Woof=Soonk^oool_;oonk^oon][Ooo;Bd4ool00003
oon0P?oooooooooo00Kooooo00GoofIVool00?oo003oo`00oolU9@0Aoooo
o`03ooohn?oo?Skoo`0000?oo`0000[ooa@DoonZZ_oomOGooogmoooMgOoo
UIGooc0`ool00?oo0@7oon;R6?ooool03?oo<c?oo`00ool00?oo1@GoodY:
oonJV_ooe=Cooo[joooalOoo][KooeMGool10@?oo`0000?oobTYooo_kooo
ool00oooool00oooT93oo`00ool00002ool00003oom9BOoooooooooo00?o
oooo00?ooeYJool00?oo00000_oo00000oooQHGoooooooooo`07ooooo`05
oon4Q?oo003oo`00ool00?oo1`L00ooo7al00ooo8B7ooemOooooo`05oooo
o`05ool[:ooo003oo`00ool00?ooYZH01oooool00oooi^Koo`00ool00002
ool00005ooo/k?oooooooooooooooooof=P01Ooo00000ooo5AGooaXJool0
0003ool00003oom[Jooo003oo`0000;oo`0000?oonSXooooooooool06ooo
ool01OooQ8Coo`00ool00?oo003oo`L700?ooalO00?oob4QoomOGoooool0
1Oooool03?ooI6Coo`00ool00?oo003oo`82ool^;_ooFEWoohZ:oon/[?oo
WIgoofAToolC4`?oo`0000?oo`d=ooo>c_ooool06?ooool00oooXj?oo`00
ool00003ool00003oolL7?oo51Coo`0000;oo`0000?oo`82oonDU?oo0000
0ooo00000oooiNGoooooooooo`06ooooo`03oom9BOoo003oo`0000?oo`00
00?oodU9ooooooooool01oooool00oooXj?oo`00ool00003ool00003oolL
7?oo51Coo`0000;oo`0000?oo`82oonDU?oo00000ooo00000oooiNGooooo
ooooo`06ooooo`05oon4Q?oo003oo`00ool00?oo1`L00ooo7al00ooo8B7o
oemOooooo`0:ooooo`05oom<C?oo003oo`00ool00?oo3Ph01?oo7al00ooo
@D7ookfmooooo`04ooooo`03oonSXooo003oo`0000?oo`0000?ooa`LoolD
5?oo00000_oo00000ooo0P;ooiBDool00003ool00004oooUiOoooooooooo
ooo]k@Coo`0000Gooa0@ool/;?ooADGooc4aool=3@04ool00003ool92Ooo
[joooooo00[ooooo00Gooda<ool00?oo003oo`00ool>3P04oolO7`03oom1
@Ooo_Kgooooo00Kooooo00?oodA4ool00?oo00000_oo00001ooo6Q[oogal
oonWYoooShoooeYJool];Ooo0`<00_oo00000ooo0@7ooo;booooo`0Koooo
o`05oonLW?oo003oo`00ool00?oo=CD03Oooool01_oobl_oo`00ool00?oo
003oo`T9ooonoPoooooo00?oofYZool00?oo00000_oo00001Ooo61Soofi^
oonHV?ooKFgoob<S00Coo`0000GooemOoooooooooooooooooonk^`03ool0
0005oomkNooooooooooooooooooo[Zh00ooo00001OooYjOooooooooooooo
oooooh6100?oo`0000?ookBdooooooooool0:?ooool00ooShn?o^KVioooo
o`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0Fooooo`04oon_[oooHV;o
ohR8ooodm0Gooooo00?ooo[joomSHooo00000ooo00000oooaLGooooooooo
o`05ooooo`03oonKVooo003oo`0000;oo`0000?ooo7aooooooooool03_oo
ool00oooVIWoo`00ool00002ool00003oolU9Oool_;ooooo00Gooooo00?o
on3Pooo:b_ooinL06?ooool01?ooShoooeIFoonCTooom?@7ooooo`03ooo6
a_oo71coo`0000;oo`0000?ooc/koooinOooool00_ooool00oooW9coo`00
ool00003ool00003oooBd_oooooooooo00;ooooo00?ood=3ool00?oo0000
0_oo00000ooo9bOoooooooooo`07ooooo`06ooni^Ooo003oo`00ool00?oo
5aOooogm2_ooool01OooH63oo`00ool00?oo003oog5a00Sooooo00Gooa/K
ool00?oo003oo`00oonf]P03ooooo`03oon0P?oo003oo`0000;oo`0000Go
oe9Booono_ooooooomOGooll?003ool00005ool?3ooo003oo`00ool00?oo
[jl07Oooool01_oo^KWoo`00ool00?oo003ooaLGooomo@[ooooo00GooiVI
ool61_oo10CoofEUoooTi006ooooo`03ooogmoooBd_oo`0000;oo`0000?o
ocXjooooooooool05oooool00oooC4coo`00ool00002ool00005oon6Q_oo
oooooooooonn__oo8B400_oo0002ool10@?oo`0000?ool?3ooooooooool0
1Oooool00oooo_koo`/;ool00005ool00003oonSXooooooooooo00Kooooo
00?ooda<ool00?oo00000_oo00001OooQXKooooooooooooo_[koob4Q00;o
o`000_oo0@43ool00003ooo3`ooooooooooo00Kooooo00KookViool00?oo
003oo`00oolG5ooooOd?ooooo`05oon1POoo003oo`00ool00?ooD5002ooo
ool00oooC4coo`00ool00002ool00005oon6Q_oooooooooooonn__oo8B40
0_oo0002ool10@?oo`0000Gool?3oooooooooooooooooolS8`03ool00003
oon^[_oooooooooo00;ooooo00?ook^koolF5_oo00000ooo00000oooZZ[o
ooooooooo`08ooooo`05oon1POoo003oo`00ool00?ooD5003?ooool00ooo
alOoo`00ool00002ool00003oom=COoon_[ooooo00Cooooo00Gooo3`oon;
Rooo6a_oob<Soono_`0Looooo`06oooBd_oo003oo`00ool00?oo1@Gooo_k
3?ooool00ooonOWoo`82ool00002ool00003oooBd_oooooooooo00cooooo
00?oooGeool;2ooo00000_oo00000ooo:b_oong]ooooo`02ooooo`03ooon
o_ooS8coo`<300?oo`0000Coohf=ooooooooooooono_0ooo00001OooADGo
ooooooooooooooooon?S00?oo`0000Goog9boooooooooooooooooong]`03
ool00003oomoOooooooooooo02Oooooo00?ok^k^on?Shoni^KT00_o^k^h0
00?oi^KV00?o^KVion?Shoooool08Oooool01OooAdOoo`00ool00?oo003o
odA400Oooooo00?oom3@ool00?oo00000_oo00000ooo^k_oooooooooo`0>
ooooo`06oolc<ooo003oo`00ool00?oo0P;ool[:;_ooool00ooof=Soo`82
ool00002ool00005oonTY?ooooooooooooooooooYjL01Ooo00000oooFe_o
ooooooooo`02ooooo`03ool/;?oo003oo`0000?oo`0000?oolS8oooooooo
ool01_ooool00oook^koo`00ool00002ool00003oooShooooooooooo00So
oooo00GooiFEool00?oo003oo`00ooll?008ooooo`05oomADOoo003oo`00
ool00?ooPH400oooool00oooDE7oo`00ool00002ool00003oooFe_oooooo
oooo00;ooooo00?ooi:Bool10Ooo00001?oo00000oooNGWoooooooooo`0K
ooooo`03ooo^k_oo003oo`0000;oo`0000?oon?Sooooooooool02?ooool0
0oooj^[oomSHooo/k009ooooo`03oooVi_oo0`?oo`0000;oo`0000?oolo?
ooooooooool05_ooool01_oo71coo`00ool00?oo003oo`d=ooomo@?ooooo
00?ooo_koomTI?oo00001Ooo00000oooW9coooooooooo`05ooooo`03oooE
eOoo003oo`0000Goo`0000?ooa8Booo[joooool01_ooool01_oo71coo`00
ool00?oo003oo`d=ooomo@?ooooo00?ooo_koomTI?oo00001Ooo00000ooo
W9coooooooooo`06ooooo`03ooo^k_oo003oo`0000;oo`0000?oon?Soooo
ooooool03Oooool01Ooo][Koo`00ool00?oo003ooa/K00_ooooo00Kooa`L
ool00?oo003oo`00ool=3OoooOd3ooooo`03oooknoooI6Coo`0000Goo`00
00GooibLoooooooooooooooooomHF003ool00003oomiNOoooooooooo00?o
oooo00?ooo;boomIFOoo00000_oo00000ooo1`Oool[:ooooo`08ooooo`05
oonf]_oo003oo`00ool00?oo6a/03?ooool01_ooGEgoo`00ool00?oo003o
o`d=ooo`l0Wooooo0_oomoLLooooo`03ooolo?oo1`Ooo`0000;oo`0000?o
ol_;ooooooooool02oooool01Ooo=CGoo`00ool00?oo003ooibL00kooooo
00?oojFUool00?oo00000_oo00000oooclooooooooooo`04ooooo`06oon^
[_oo003oo`00ool00?oo0`?ool710_ooool01?oo9RKoo`00ool00?oo4A44
ooooo`04oolF5_oo003oo`00ooll?0?ooooo00Goon_[ool00?oo003oo`00
oom:BP0Yooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoS
hn?ooooo027ooooo00?ooknoool00?oo00000_oo00000ooob/[ooooooooo
o`04ooooo`03oooknooo10Coo`0000;oo`0000?oohJ6ooooooooool03Ooo
ool00oooclooo`00ool00002ool00003oom5AOoooooooooo02kooooo00Go
oeiNool00?oo003oo`00ooll?003ooooo`03oonc/ooo003oo`0000?oo`00
00?oo`<3oooPh?ooool00_ooool01?oo5AGoo`00ool00?oo0P82ool00003
oomYJOoooooooooo00Oooooo00Goob@Tool00?oo003oo`00oon][@0:oooo
o`06ooo:b_oo003oo`00ool00?oo2@Woookn1oooool01OooQXKoo`00ool0
0?oo003ooda<00?ooooo00GoofATool00?oo003oo`00oolB4P06ooooo`03
oone]Ooo1`Ooo`0000?oo`0000?ood=3ooooooooool07?ooool01Ooo92Co
o`00ool00?oo003oojf]01Kooooo00?oooGeool10Ooo00000_oo00000ooo
R8Soooooooooo`0Fooooo`05ool_;ooo003oo`00ool00?ooADD01_ooool0
0oooRh_oo`00ool00003ool00003oomeMOoooooooooo00Gooooo00?ooi^K
ool00?oo00000_oo00001OooHV;oo`00ool00?oo003ooeUI00Oooooo00Go
obl_ool00?oo003oo`00oom5A@06ooooo`03oon;Rooo003oo`0000?oo`00
00?oogEeooooooooool01oooool01Ooo92Coo`00ool00?oo003oojf]00oo
oooo00?oon[Zool00?oo00000_oo00000oooj^[oooooooooo`08ooooo`05
ool_;ooo003oo`00ool00?ooADD01_ooool00oooRh_oo`00ool00003ool0
0005oomeMOooooooooooooooooooSHd00ooo00000oooA4Coooooooooo`04
ooooo`03ooolo?oo?cooo`0000;oo`0000?ooaLGoooalOooool01oooool0
0oooj^[oo`00ool00002ool00003oooZj_oooooooooo00Wooooo00Goobd]
ool00?oo003oo`00oomVIP0Yooooo`05ooll??oo003oo`00ool00?ooUID0
3Oooool01OooJV[oo`00ool00?oo003oofMW00kooooo00Kooe9Bool00?oo
003oo`00oolE5Oooo_h7ooooo`08oomOGooo003oo`00ool00?oo5QKooo3`
ooooooooFe/3ool00005oooKfoooooooooooooooooooCDd00_oo00000ooo
2P[oooknooooo`02ooooo`05oolQ8Ooo003oo`00oolD5?oooOd0:?ooool0
0oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Roooo
o`05oolJ6_oo003oo`00ool00?ooO7`01oooool01Ooo>c_oo`00ool00?oo
003ooe5A00oooooo00?ooi^Kool00?oo00000_oo00000oooTi?ooooooooo
o`0^ooooo`03oonc/ooo003oo`0000;oo`0000CoomWIoooooooooooookjn
0ooo00001?oo5QKoo`00ool00?ooK6`2ooooo`05ooolo?oo003oo`00ool0
0?oo1`L00_oo00000ooo4A7oooWiooooo`07ooooo`05oomIFOoo003oo`00
ool00?ooN7P02_ooool00ooonOWoo`82ool00002ool00003oooBd_oooooo
oooo00Gooooo00Kook^kool00?oo003oo`00oolF5_ooo_h2ooooo`05oomh
N?oo003oo`00ool00?oo3`l01oooool00ooo/k?oo`82ool00002ool00003
ool?3ooooooooooo01cooooo00GooeUIool00?oo003oo`00oomhN00Eoooo
o`03ooohn?ooJf_oo`0000?oo`0000?oogmoooooooooool05_ooool01Ooo
@d?oo`00ool00?oo003oodA400Oooooo00?ooh61ool00?oo00000_oo0000
0ooo@T;oooooooooo`05ooooo`07oomQHOoo003oo`00ool00?oo9BGooo;b
oolK6`03ool00003oond]?oooooooooo00Cooooo00Good=3ool00?oo003o
o`00oom4A007ooooo`03oon1POoo003oo`0000;oo`0000?ood92oooooooo
ool01oooool01OooFEWoo`00ool00?oo003oogQh013ooooo00Goob0Pool0
0?oo003oo`00oona/@0:ooooo`05oom3@ooo003oo`00ool00?ooA4@01ooo
ool00oooPH7oo`00ool00002ool00005oom2@_oooooooooooooooooo`l<0
0ooo00000ooo413oooooooooo`05ooooo`03oooWiooo51Coo`0000;oo`00
00?oogUiooooooooool01oooool01Ooo823oo`00ool00?oo003ook6a00[o
oooo00?ooogmool51Ooo00000_oo00000oooTi?oooooooooo`0Wooooo`05
oomaLOoo003oo`00ool00?ooH6003Oooool01OooWiooo`00ool00?oo003o
oc8b00kooooo00Goodm?ool00?oo003oo`00oom=C@08ooooo`03oooalOoo
3`ooo`0000;oo`0000?ooiZJooooooooT9000ooo00001OooYZKooooooooo
oooooooooh:200?oo`0000Goom;BoooooooooooooooooomFEP03ool00003
oooPh?oooooooooo02Oooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^
00?o^KVion?Shoooool08_ooool01OooFe_oo`00ool00?oo003oocHf00Oo
oooo00Goog1`ool00?oo003oo`00oolL700?ooooo`03oon1POoo003oo`00
00;oo`0000?oom;Booooooooool0;_ooool00ooo/K7oo`00ool00002ool0
0004oond]?ooooooooooooo:bP?oo`0000OoocDeool00?oo003oo`T9ooo/
k?ooooooonOW00?oo`0000Gooa4Aool30ooo003oo`00oon/[008ooooo`05
oon>S_oo003oo`00ool00?oo@d<02oooool01Ooo=CGoo`00ool00?oo003o
oibL00Oooooo00?oono_ool00?oo00000_oo00001?oohN7ooooooooooooo
SHd4ool00003ooofm_oooooooooo00Gooooo00?ooiBDool00?oo00000_oo
00000ooof=Soooooooooo`0Kooooo`05oon>S_oo003oo`00ool00?oo@d<0
4oooool00ooom?Coohb<ool@4005ool00003oonm_Ooooooooooo01Kooooo
00GooeQHool00?oo003oo`00oolZ:P08ooooo`05oomPH?oo003oo`00ool0
0?oo3`l01oooool01ooo9bOoo`00ool00?oo003ooeiNoooooooo]KD00ooo
00000ooo6Q[ooo?cooooo`04ooooo`05oomHF?oo003oo`00ool00?oo:RX0
2?ooool01OooH63oo`00ool00?oo003oo`l?00Wooooo00Goohj>ool00?oo
003oo`00oom3@`0@ooooo`05oomEEOoo003oo`00ool00?ooO7`02_ooool0
1OooF5Soo`00ool00?oo003oobXZ00Sooooo00Goof1Pool00?oo003oo`00
ool?3`03ooooo`03ooodm?oo003oo`0000;oo`0000?oom[Jooooooooool0
1Oooool01_ooZj_oo`00ool00?oo003oo`P8oooSh`Sooooo00GooeEEool0
0?oo003oo`00oomlO00:ooooo`03ooono_oo0P;oo`0000;oo`0000?ooj6Q
ooooooooool09oooool01OooYZKoo`00ool00?oo003oob/[00gooooo00Ko
omCDool00?oo003oo`00ool41?oonOT=ooooo`05oomLG?oo003oo`00ool0
0?oo@4002Oooool01oooGeooo`00ool00?oo003oocdmooooooooaLD00ooo
00001OooLG7ooooooooooooooooookRh00?oo`0000GooifMoooooooooooo
oooooon;R`03ool00003oonZZ_oooooooooo02Kooooo00?ok^k^on?Shoni
^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool08_ooool01_ooWIgoo`00
ool00?oo003oo`41ooo]k@Kooooo00?oojFUool00?oo00000_oo00000ooo
j>Soooooooooo`0<ooooo`03oomWIooo003oo`0000;oo`0000?oonSXoooo
ooooool0;_ooool00oooHF7oo`00ool00002ool00004oonYZOoooooooooo
oooEe@?oo`0000OoodI6oolJ6_oo003oo`00oommOOooooooom3@00?oo`00
00GoobPXoom=COoo003oo`00oom=C@08ooooo`06ooo3`ooo003oo`00ool0
0?oo3Pkoookn2_ooool01OooJV[oo`00ool00?oo003oofMW00Sooooo00Go
obDUool00?oo003oo`00oon/[002ooooo`03ooo8b?oo003oo`0000;oo`00
00?oolW9ooooooooool01_ooool01Ooo:R[oo`00ool00?oo003ooj>S01go
oooo00Kool?3ool00?oo003oo`00ool>3_ooo_h@ooooo`03oooPh?ooIFGo
o`L700Koo`0000?ooeIFooooooooool05oooool01_ooU9Coo`00ool00?oo
003oo`P8ooodm0Oooooo00?ooo;bool00?oo00000_oo00000oooemOooooo
ooooo`03ooooo`03ooo/k?oo003oo`0000;oo`0000CooiRHoooooooooooo
oeaL0ooo00000oooJFWoooooooooo`03ooooo`06oonDU?oo003oo`00ool0
0?oo20SoooCd1oooool00oool_;oo`00ool00002ool00003oooGeooooooo
oooo00Kooooo00Kool?3ool00?oo003oo`00ool>3_ooo_h?ooooo`05oon;
Rooo003oo`00ool00?ooATH02_ooool01_ooU9Coo`00ool00?oo003oo`P8
ooodm0Oooooo00?ooo;bool00?oo00000_oo00001OooemOooooooooooooo
ooooobd]00?oo`0000?oojFUooooooooool01Oooool00ooonOWoo`l?ool0
0002ool00003oomfM_oooooooooo00Kooooo00Gooh^;ool00?oo003oo`00
oom6AP0;ooooo`05oolJ6_oo003oo`00ool00?ooRHT0:Oooool01_oofm_o
o`00ool00?oo003oo`41oooem@cooooo00?ooogmool82?oo00000_oo0000
0ooob<Soooooooooo`0;ooooo`05oomZJ_oo003oo`00ool00?oo:RX02Ooo
ool00ooo];Coo`00ool00002ool00003oooOgooom_Koo`0000;oo`0000Go
oc/kooooooooooooooooooo/k003ool00005oomXJ?oooooooooooooooooo
`L400ooo00000oooMGGoooooooooo`0Vooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo02;ooooo00?oomcLool00?oo0000
0_oo00000ooo[jooooooooooo`04ooooo`03oooJf_oo003oo`0000;oo`00
00?ook6aooooooooool03?ooool00oooFEWoo`00ool00002ool00003oook
nooooooooooo02gooooo00?oojj^ool00?oo00000ooo00001?oofm_ooooo
oooooooohN43ool00007oolk>oooSXkoo`00ool00?oo4A7oooGeooni^@03
ool00006ooln?_ooZZ[oo`00ool00?oo0`?oon_[1oooool00ooomOGoo`00
ool00002ool00003oooIfOoooooooooo00Sooooo00GooinOool00?oo003o
o`00oolb<P08ooooo`05oomJF_oo003oo`00ool00?ooMgL00_ooool00ooo
o_kooaPHool00002ool00003oombL_oooooooooo00Kooooo00GooemOool0
0?oo003oo`00oom^KP0Mooooo`03oooemOoo003oo`0000;oo`0000?oomWI
ooooooooool03?ooool00oooh^;ooe]Kool20P06ool00003ool51OooOWko
oogm01Wooooo00?oon;Rool00?oo00000_oo00000oooYjOoooooooooo`06
ooooo`05ool[:ooo003oo`00ool00?ooXZ801Oooool00ooo/k?oo`00ool0
0002ool00005oooBd_ooooooooooooo/k?oo4a<00ooo00000ooo`l?ooooo
ooooo`02ooooo`03oooRh_oo003oo`0000;oo`0000?oojNWooooooooool0
1_ooool01Ooo:b_oo`00ool00?oo003ooj:R00Sooooo00?oooGeool00?oo
00000_oo00000ooofMWoooooooooo`0=ooooo`06ooo0`?oo003oo`00ool0
0?oo4A7ooocl2Oooool00oooh^;oo`00ool00002ool00003oonWYooooooo
oooo00Kooooo00Goob/[ool00?oo003oo`00oonRXP03ooooo`05oomRH_oo
003oo`00ool00?ooKfl02?ooool01OooHf?oo`00ool00?oo003oobHV00So
oooo00Kool30ool00?oo003oo`00oolA4Oooo?`:ooooo`03ooli>Ooo003o
o`0000goo`0000?oo`41oolo?oooool07?ooool01Ooo3`ooo`00ool00?oo
003ool7100gooooo00Goocloool00?oo003oo`00oonCT`0=ooooo`06oon0
P?oo003oo`00ool00?oo3`ooookn2?ooool00ooonOWoo`L7ool00002ool0
0003oon<S?oooooooc0`00;oo`0000?oo`T9ooomoOooool00_ooool01?oo
8R;oo`00ool00?oo<c<3ooooo`05oooclooo003oo`00ool00?oo@400:?oo
ool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0S
ooooo`05ool@4?oo003oo`00ool00?ooNWX01_ooool00oooo_koo`/;ool0
0002ool00003oomlO?oooooooooo00cooooo00KoogAdool00?oo003oo`00
ool10Ooono/^ooooo`03oonHV?oo10Coo`0000?oo`0000Gooc4aoooooooo
ooooooooooo/k003ool00003ool];Ooom?Cooa0@00;oo`0000?oohn?oonR
X_oo00000_oo00000oooEEGoooShool>3P02ool00003oon@T?oooooooooo
00Kooooo00Goobh^ool00?oo003oo`00oonSX`0:ooooo`06oooDe?oo003o
o`00ool00?oo10CoooWi1oooool01OooT93oo`00ool00?oo003ood9200?o
oooo00KoofMWool00?oo003oo`00oolJ6_ooo_h7ooooo`05oonDU?oo003o
o`00ool00?oo>CT07_ooool01Ooo;Rkoo`00ool00?oo003ooj>S00gooooo
00?ooj>Sool41?oo00001Ooo00000ooo2@Woog1`ooo[j`0Looooo`05oolb
<_oo003oo`00ool00?ooCTh02?ooool01OooH63oo`00ool00?oo003oofe]
00Gooooo00KoogYjool00?oo003oo`00ool=3Oooo_h3ooooo`06oonYZOoo
003oo`00ool00?oo9RKoooWi1?ooool01Ooo<S;oo`00ool00?oo003oodi>
00Sooooo00Goof1Pool00?oo003oo`00oom]K@09ooooo`05ool^;_oo003o
o`00ool00?ooXj<03oooool00oool_;oo`00ool00002ool00003oooLg?oo
oooooooo00Sooooo00Gooc8bool00?oo003oo`00oom>CP08ooooo`05oomP
H?oo003oo`00ool00?ooKFd00oooool01OooUiOoo`00ool00?oo003oocXj
00Sooooo00?ook^kool00?oo00000_oo00000oooemOoooooooooo`05oooo
o`03ooobl_oo003oo`0000;oo`0000?oomcLooooooooool02?ooool00ooo
Q8Coo`00ool0000>ool00003oolL7?oooooooooo01_ooooo00GoodI6ool0
0?oo003oo`00oon;R`0=ooooo`05oomdM?oo003oo`00ool00?ooGEd03Ooo
ool00oood=3oo`00ool00002ool00003ooo3`ooooooooooo00Oooooo00Oo
ob4Qool00?oo003oo`00oombL_ooooooofEU00?oo`0000Goom7Aoooooooo
oooooooooomGE`02ool00003ool41?oolO7ooooo00;ooooo00Coob/[ool0
0?oo003oo`d=:Oooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni
^KWohn?Sooooo`0Sooooo`05oom6A_oo003oo`00ool00?ooADD01oooool0
1OooADGoo`00ool00?oo003oodM700kooooo00?ooi6Aool00?oo00000_oo
00000ooog]koooooooooo`0Zooooo`03ooo]kOooDU;oo`0000Coo`0000?o
o`82ooo<c?ooool00_ooool01ooon?Soo`00ool00?oo003oob0Poooooooo
Ogl00_oo00000ooo71coohR8ool00002ool00003oom[JoooooooofEU00;o
o`0000?ooc4aooooooooool01_ooool01OooHf?oo`00ool00?oo003oofi^
00[ooooo00?ooogmool82?oo00000_oo00000oooR8Soooooooooo`05oooo
o`05ooo2`_oo003oo`00ool00?oo5AD00oooool00oooe=Coo`82ool00002
ool00003oonm_Ooooooooooo00Gooooo00KoolW9ool00?oo003oo`00ool7
1ooooOdMooooo`05oomSHooo003oo`00ool00?ooKVh03?ooool00ooo][Ko
o`00ool00004ool00003oolW9oooY:CoooWi01kooooo00Kooj>Sool00?oo
003oo`00ool51Ooojn/7ooooo`05oonEUOoo003oo`00ool00?oo>3P01Ooo
ool01Ooo@43oo`00ool00?oo003oodE500Gooooo00Goodm?ool00?oo003o
o`00oomiN@04ooooo`06oonSXooo003oo`00ool00?oo1@Goon_[1oooool0
1OooUIGoo`00ool00?oo003oocPh00Wooooo00Goof=Sool00?oo003oo`00
oom^KP0@ooooo`05oolZ:_oo003oo`00ool00?ooYjL02_ooool01_ooXj?o
o`00ool00?oo003oo`D5ooo[j`Oooooo00GooiFEool00?oo003oo`00oolh
>003ooooo`06ooo=cOoo003oo`00ool00?oo0@7ook2`1oooool00oook>co
o`00ool00002ool00003oonGUooooooooooo00Kooooo00GoobXZool00?oo
003oo`00oonWY`0:ooooo`03oooFe_oo003oo`0000;oo`0000?ooc/koomK
FoooFe/01OooFe/01OooAdOoo`00ool00?oo003oo`H601gooooo00Goog]k
ool00?oo003oo`00oomFEP0=ooooo`06oonYZOoo003oo`00ool00?oo2`_o
om?C3Oooool01Ooo;Bgoo`00ool00?oo003oofi^00Wooooo00OoocLgool0
0?oo003oo`00oomTI?oooooooiZJ00?oo`0000GoofMWoooooooooooooooo
oon<S003ool00005oom/K?ooooooooooooooooooH6000ooo00000oooe]Ko
ooooooooo`0Uooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi
^OoShn?ooooo02?ooooo00Koogalool00?oo003oo`00ool@4?oooOd6oooo
o`05oomjN_oo003oo`00ool00?oo0@402Ooo2PX00ooo=3CoooWiooooo`02
ooooo`03oon_[ooo003oo`0000;oo`0000?ooknoooooooooool0:Oooool0
0ooo[Jgooa0@ool00004ool00003ool61_oo[joooooo00Cooooo0ooo0000
1?oo4a?oooooooo/k?oo20P2ool00007oom>C_oo003oo`00ool00?ooPH7o
ooooooo3``03ool00003oooCdooooooooooo00Gooooo00GooiRHool00?oo
003oo`00ooli>@0;ooooo`03oolo?ooo003oo`0000;oo`0000?oojf]oooo
ooooool01?ooool00oooknooo`00ool00002ool00005oooYjOoooooooooo
ooooooooI6@00ooo00000ooo92Cooo;booooo`05ooooo`03ooohn?oo0`?o
o`0000;oo`0000?oolk>ooooooooool06oooool01OooV9Soo`00ool00?oo
003oocTi00cooooo00?ooeUIool00?oo00000_oo00000ooo:R[oolO7oooo
o`0Pooooo`03ooono_oo<33oo`0000;oo`0000?oodi>ooooooooool01Ooo
ool01_oob/[oo`00ool00?oo003oo`L7ooolo0?ooooo00?ooo_kool51Ooo
00000_oo00000oooOWkoooooooooo`03ooooo`06oooUiOoo3@goo`00ool0
0?oo0`?oom3@0oooool00oooo_kooc0`ool00002ool00003oom>C_oooooo
oooo00Gooooo00Kool[:ool00?oo003oo`00ool71oooo?`8ooooo`05oonH
V?oo003oo`00ool00?oo>CT04?ooool01OooGeooo`00ool00?oo003oog9b
00[ooooo00?oooknool`<?oo00000_oo00000oooCTkoooooooooo`05oooo
o`06ooo:b_oo003oo`00ool00?oo1`Oooocl0_ooool00ooon_[oo`82ool0
0002ool00003ool71ooobLWooooo00Kooooo00Goo`H6ool00?oo003oo`00
oon1P@08ooooo`05oomOGooo003oo`00ool00?ooLW802oooool01Ooo@d?o
o`00ool00?oo003oocPh00Oooooo00?oom_Kool00?oo00000_oo00000ooo
kNgoooooooooo`0Jooooo`05oon`/?oo003oo`00ool00?oo8B403Oooool0
0ooog]koo`00ool00002ool00003oolI6Oooi>Cooooo00Cooooo00Gooe=C
ool@4?oo2P[oobXZoooDe002ooooo`06oon:R_oo003oo`00ool00?oo6Q[o
ooWi2?ooool01oooAdOoo`00ool00?oo003ooeMGoooooooocll01?oo0000
1?oo`/;ooooooooooooo`/83ool00005ool20_ood=3oooooooooooooUID0
0ooo00000oooXJ7oooooooooo`0Uooooo`03onKVi_oShn?o^KVi00;oi^KV
0003onk^kP03okVi^OoShn?ooooo02?ooooo00?ook6aool00?oo00000_oo
00000ooof][oooooooooo`04ooooo`03oon_[ooo003oo`0000coo`0000Go
ol_;oooooooooooooooooooJfP04ool00003oonDU?oooooooooo02Oooooo
00?oooCdoomCDooo00001Ooo00000ooo71coolW9ooooo`05ooooo`07ool?
3ooo003oo`00ool51Oooo_kooooooom_K`02ool00008oolK6ooo003oo`00
ool00?ooV9Soooooooono_oo8202ool00003oomdM?oooooooooo00Gooooo
00Koolg=ool00?oo003oo`00ool82?oooOd:ooooo`03oomdM?oo003oo`00
00;oo`0000?oo`L7oong]oooool01Oooool01Ooo5aOoo`00ool00?oo003o
okjn00?ooooo00?oonKVool;2ooo00000_oo00000oooEeOoooooooooo`05
ooooo`05oold=?oo003oo`00ool00?ooVIT07Oooool01_oocLgoo`00ool0
0?oo003oo`P8ooomo@_ooooo00Kooe5Aool00?oo003oo`00oolN7_oomODS
ooooo`03oonm_Ooo003oo`0000;oo`0000?ooh^;ooooooooool01?ooool0
0ooonOWoo`@4ool00002ool00005ooo>c_ooooooooooooooooooc<`01?oo
00000ooo^;Soooooooooo`04ooooo`06oonLW?oo003oo`00ool00?oo<S;o
oogm0oooool00ooo_Kgoo`00ool00002ool00003oon;Rooooooooooo00Co
oooo00?oooWiool41?oo00000_oo00000oooc/koooooooooo`06ooooo`06
ooo=cOoo003oo`00ool00?oo20Sooogm3oooool01OooUIGoo`00ool00?oo
003oocdm00_ooooo00?ookfmool00?oo00000_oo00000oooRh_ooooooooo
o`04ooooo`03oooinOoo10Coo`0000;oo`0000Goolk>oooooooooooooooo
oolg=`04ool00003ool@4?ooc<cooooo00Cooooo00?oooknool=3Ooo0000
0_oo00000oooKFgoooooooooo`06ooooo`05oonEUOoo003oo`00ool00?oo
?Cd02oooool00ooodM7oo`41ool00002ool00003oon_[ooooooooooo00Co
oooo00?oonk^ool00?oo00000_oo00000oooe]Koooooooooo`0Jooooo`03
oooUiOoo003oo`0000;oo`0000?oong]ooooooooool02oooool00ooo4A7o
o`00ool00002ool00003oolZ:_ooj^[ooooo00?ooooo00GooeMGool00?oo
003oo`00oonIV@02ooooo`03oooVi_oo2P[oo`0000;oo`0000?oogIfoooo
ooooool01Oooool00oooo_kooaDEool00002ool00004oomDE?oooooooo_k
ool51@?oo`0000Coob8RoooalOooooooono_1?oo00001?oo<c?oooWioooo
oooobLT3ool00003oom[Jooooooooooo02Gooooo00?ok^k^on?Shoni^KT0
0_o^k^h000?ooooo00?o^KVion?Shoooool08oooool00oooi^Koo`00ool0
0002ool00003oonUYOoooooooooo00Cooooo00?oonCTool00?oo00000_oo
00000ooo0`?oo`D5ool51@06ool51@03oolI6OooZJWooooo00?ooooo00Go
ob@Tool00?oo003oo`00oom:BP0Xooooo`03oooUiOoo;2coo`0000Goo`00
00?oofIVoooemOooool01_ooool02?oo6Q[oo`00ool00?oo003oooShoooo
ooooh^;oo`<31Ooo00001?oo[ZkoooooooooooooOWh2ool00003oolH6?oo
oOgooooo00Gooooo00?ooo[jool41?oo00000_oo00000ooocloooooooooo
o`08ooooo`03oonYZOoo003oo`0000?oo`0000?oo`41oonATOooool01?oo
ool01Ooo8R;oo`00ool00?oo003ooinO00Cooooo00?ookBdool10Ooo0000
0_oo00000oooN7Sooo_kooooo`04ooooo`05oomYJOoo003oo`00ool00?oo
I6@07Oooool00ooon_[oo`@4ool00002ool00003ooo?cooooooooooo00Wo
oooo00Goog]kool00?oo003oo`00oolb<P0Uooooo`06oon2P_oo003oo`00
ool00?oo0P;oojJV1_ooool01Ooo=CGoo`00ool00?oo003ooiRH00?ooooo
00Kooi:Bool00?oo003oo`00ool10Ooolo<7ooooo`05oom3@ooo003oo`00
ool00?ooRHT01?ooool01_ooPX;oo`00ool00?oo003oo`82oonVYPKooooo
00GoocDeool00?oo003oo`00oonHV008ooooo`03ooojn_oo10Coo`0000;o
o`0000?oolo?ooooooooool03Oooool01Ooob/[oo`00ool00?oo003oo`/;
00cooooo00Kooh:2ool00?oo003oo`00ool20_ooYZH6ooooo`05oole=Ooo
003oo`00ool00?ooV9P00oooool00oooK6coo`00ool00003ool00003ool6
1_oo[joooooo00?ooooo00?oomCDool00?oo00000_oo00000oooFEWooooo
ooooo`06ooooo`05ooo:b_oo003oo`00ool00?oo2`/03?ooool01_ooK6co
o`00ool00?oo003oo`l?oooFePGooooo00?ool[:ool00?oo00000_oo0000
0oooiNGoooooooooo`0Fooooo`03ooono_oof=SookRh00;ookRh00Gooa0@
ool00?oo003oo`00oon7Q`05oonh^003oonj^_oofm_ooooo00Gooooo00?o
odU9ool00?oo00000ooo00000ooo6a_oomKFooooo`02ooooo`05oon<S?oo
003oo`00ool00?ooI6@00oooool01_ooZZ[oo`00ool00?oo003oo`41ooo4
a0Kooooo00?oolo?ool00?oo00000_oo00001?ooXZ;ooooooooooooo>SX3
ool00005ool10OooDE7ooooooooooooo5AD00ooo00001?oo0`?oofUYoooo
oooomOD3ool00003oolj>_oooooooooo02Kooooo00?ohn?SokVi^Oooool0
0Oooool000?ok^k^00?o^KVion?Shoooool09?ooool01Ooo6a_oo`00ool0
0?oo003oog1`00Oooooo00GooaDEool00?oo003oo`00oombLP0>ooooo`06
oomaLOoo003oo`00ool00?oo20SoooKf9_ooool00ooooOgoocXjool00004
ool00003oolB4_oo^;Sooooo00Sooooo00GoobHVool00?oo003oo`00ooo[
j`02ooooo`03oomOGooo003oo`0000?oo`0000CoolG5ooooooooooooom_K
0ooo00000ooo]kOoooooooooo`05ooooo`05oolh>?oo003oo`00ool00?oo
VIT02_ooool00ooog]koo`00ool00005ool00005oom3@ooof][ooooooooo
oooob/X01?oo00000oooVY[oooooooooo`03ooooo`03oon>S_oo003oo`00
00;oo`0000?oobXZoooCdoooool00oooool01OooWYkoo`00ool00?oo003o
obl_01kooooo00GoocPhool00?oo003oo`00oonIV@0;ooooo`03oooQhOoo
0P;oo`0000;oo`0000?oojNWooooooooool01Oooool00oooo?coooGeoooh
n00Kooooo`03oomJF_oo003oo`0000;oo`0000?oodY:oooYjOooool00ooo
ool01OooJV[oo`00ool00?oo003oof=S00?ooooo00GooeQHool00?oo003o
o`00ool[:`08ooooo`06oooNg_oo20Soo`00ool00?oo1`OoomcL1?ooool0
0oooFU[oo`00ool00002ool00003oom:B_oojNWooooo00?ooooo00GoofYZ
ool00?oo003oo`00oomSH`09ooooo`05oolh>?oo003oo`00ool00?ooVIT0
3oooool00ooon?Soo`41ool00002ool00003oooBd_oooooooooo00[ooooo
00?ooeYJool00?oo00000_oo00000oooBT[oonWYooooo`03ooooo`05oomZ
J_oo003oo`00ool00?ooHf<00oooool01OooXJ7oo`00ool00?oo003ooa0@
00?oo`0000GooeaLoooZj_oooooooooooomLG004ool00003oon1POoooooo
oooo00Kooooo00?oooShool10Ooo00000_oo00000oood];oooooooooo`09
ooooo`03ooojn_oo@43oo`0000;oo`0000?ooaPHoooBd_ooool00oooool0
1OooIfOoo`00ool00?oo003ooc0`01[ooooo00?ooa<Cool00?oo00003Ooo
00000oook^koooooooooo`03ooooo`05oomnO_oo003oo`00ool00?oo30`0
0_oo00001Ooo20Sooi:Booojn_oooooool7100?oo`0000?oobl_oooooooo
ool00_ooool01_ooLW;oo`00ool00?oo003oo`X:oonYZ@Cooooo00?ooo?c
oolf=_oo00000_oo00001Ooo2P[oooCdooooooooooooofm_00Goo`0000?o
of=SooomoOoo51@01Ooo00000oooN7SoooGeool20P02ool00003oolH6?oo
oooooooo02Gooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVi
on?Shoooool09?ooool01OooD53oo`00ool00?oo003ooc/k00Oooooo00Go
odm?ool00?oo003oo`00ooll?00>ooooo`03oonn__oo003oo`0000;oo`00
00?oojVYooooooooool09?ooool00oooUYKoo`00ool00003ool00003oola
<OoojNWooooo00Wooooo00Gooc4aool00?oo003oo`00oooNgP02ooooo`03
oooFe_oo003oo`0000?oo`0000Goom_Kooooooooooooooooooli>@02ool0
0005oomHF?oooooooooooon:R_oo?3`00ooo<C401Ooo4Q;oo`00ool00?oo
003oofAT00_ooooo00Gooa4Aool00?oo003oo`00oomIF@03ool00004ool1
0Ooo<S;ooda<ool?3`Coo`0000?oojZZooooooooool01?ooool00oooTI7o
o`82ool00002ool00006ool10Ooo71coodU9oomOGooo@D7ooaTI0ooo0000
0ooo0`?oooShooooo`0Gooooo`03oon:R_oo?3cooc4a00;ooc4a00Gooa8B
ool00?oo003oo`00oomTI00<ooooo`03oom^K_oo003oo`0000;oo`0000[o
obTYoomUIOoo/K7oolo?oon/[?ooO7coocLgool51Ooo2`_oojJV6oooool0
0ooonOWoofEUool00003ool00006ool41?oo8b?ooe5AoomLG?oo>CWooa0@
0ooo00001Ooo;RkooooooooooooooooooahN00?oo`0000?oofEUoooooooo
ool01oooool01OooT93oo`00ool00?oo003ood1000Cooooo00?oooWioomU
IOoo00000ooo00001_oo10Coob<SoomADOooG5coocTiool@40?oo`0000?o
obh^ooooooooool00_ooool00oooRX[ooc`loola<@02oola<@05oolB4_oo
003oo`00ool00?ooI6@04?ooool01Ooo=3Coo`00ool00?oo003ooifM00co
oooo00?oooWioomUIOoo00000ooo00001_oo10Coob<SoomADOooG5coocTi
ool@40?oo`0000Goobh^oooooooooooooooooooFeP03ool00003ool30ooo
De?oo`0000;oo`0000?oo`D5ool/;?oo8R801Ooo00000ooof=Sooooooooo
o`07ooooo`05oold=?oo003oo`00ool00?ooWId03?ooool00oooknooob`/
ool00002ool00005ool10OooDU;oojn_oonj^_ooEED01?oo00000oooNg_o
ooooooooo`0Hooooo`03oom8B?oo003oo`0000goo`0000?ookZjoooooooo
ool00oooool01_oo/k?oo`00ool00?oo003ooa/KoolZ:P?oo`0000?ooa0@
oom:B_ooG5`00ooo00000ooo0P;oooOgooooo`02ooooo`03oooknooo@D7o
o`0000?oo`0000GoocPhoon?Sooo_Kgoohf=oolS8`04ool00005oomRH_oo
ooooooooooooooooY:@00ooo00001?oo>CWoo`00ool00?oo2PX4ool00004
oolh>?oo003oo`00ool<30Coo`0000?oooOgooooooooool09?ooool00ooV
i^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0Tooooo`06
oon6Q_oo003oo`00ool00?oo2@Woookn1_ooool01_ooQ8Coo`00ool00?oo
003oo`X:ooonoPgooooo00?ooo_koolQ8Ooo00000_oo00000ooo<33ooooo
ooooo`0Tooooo`03oom3@ooo003oo`0000;oo`0000?oodU9oooemOooool0
2_ooool01Ooo?Cgoo`00ool00?oo003oom3@00?ooooo00?ooe1@ool00?oo
00000_oo00001Oool_;ooooooooooooooooooiJF00;oo`0000Coo`L7oooa
lOoooooooeIF2?oo00000ooo;booooooooooo`09ooooo`07oom9BOoo003o
o`00ool00?ooR8SoojJVool:2P08ool00003oolC4ooomOGooooo00Kooooo
00?ool?3oolD5?oo00002ooo00000oooa<Coooooooooo`0Fooooo`03oomF
E_oo003oo`0000Koo`0000?oobl_ooooooooool02_ooool00oooo_koof=S
ool0000;ool00003oomaLOoooooooooo01_ooooo00?ooinOool61_oo0000
2_oo00001?oo0P;oooOgooooooooi>@4ool00003oonOWooooooooooo00Oo
oooo00?ooogmoolg=ooo00000_oo00000oooVY[oooooooooo`03ooooo`03
oonOWooo1PKoo`0000[oo`0000?oo`82ooogmoooool00_ooool00oooEUKo
o`00ool00006ool00003ool_;ooooooooooo00kooooo00GoofUYool00?oo
003oo`00oomXJ00>ooooo`03oonOWooo1PKoo`0000[oo`0000Koo`82ooog
moooooooooooooomoOoo20P3ool00003ooo4a?ooShooo`D500Soo`0000?o
odA4ooooooooool02?ooool01OooJFWoo`00ool00?oo003oofQX00gooooo
00?oooOgoomTI?oo00002Ooo00000ooo8R;oon?Sooooo`0Iooooo`05oonh
^?ooFe_ooclooolo?ooo<C400ooo00000ooo0P;ooclooolo?`04oolo?`03
oomTI?oobLWooooo00Cooooo00?oonSXool00?oo00000_oo00000ooogMgo
oeaLool00008ool00003ooo4a?oooooooooo00;ooooo00?ooocloon9ROoo
10@02_oo00000oooCdooooOgooooo`02ooooo`06oooIfOoo003oo`00ool0
0?ooFEWoodI61_oo00000ooobl_oobPXool00004ool00003ool61_oon_[o
oooo02Gooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?S
hoooool09?ooool00ooo^k_oo`00ool00002ool00003ooo@d?oooooooooo
00Cooooo00?ookViool00?oo00000_oo00000oood];oooooooooo`0<oooo
o`03oonQXOoo003oo`0000;oo`0000?ook>cooooooooool08oooool01_oo
4Q;oo`00ool00?oo003ooa<Cooogm`cooooo00GoodQ8ool00?oo003oo`00
ooo3``03ooooo`05ooo8b?oo003oo`00ool00?oo20P01?ooool01oookNgo
o`D5ool00?oo003ooiZJooooooooRh/02?oo00000ooo0`?oooShooooo`09
ooooo`09oomnO_oo003oo`00ool00?ooDe?ooooooooQhOooEUKoo`8200Go
o`0000?ooa4Aooo9bOooool02?ooool00ooonOWooifMoolO7`0:ool00003
oon?Sooooooooooo01Kooooo00?ooh^;ool00?oo00001_oo00000ooo0`?o
ooShooooo`0;ooooo`03ooono_oo[:coobXZ00[oo`0000?oof5Qoooooooo
ool07?ooool00oook^kooh20ool@400:ool00003ooo4a?oooooooj^[00Co
o`0000?oomSHooooooooool02?ooool01_ooeMGoo`D5ool00?oo003oo`d=
oooViPGooooo00?oonk^oon0P?oo41002_oo00001Oooa<Cooooooooooooo
oooooh^;00Soo`0000?oo`<3ooohn?ooool03_ooool01OooWiooo`00ool0
0?oo003ooc<c00oooooo00?oonk^oon0P?oo41002_oo00001Oooa<Cooooo
oooooooooooood5100?oo`0000Gooi2@oooooooof=SoodY:ool10@05ool0
0003oom8B?oomOGooooo00Wooooo00GooinOool00?oo003oo`00oolc<`0?
ooooo`03oonh^?oo<S;oo`0000Koo`0000?ooc4aooo[joooool07_ooool0
0oool?3oo`41ool00002ool00003oooQhOoooooooooo00_ooooo00SooahN
ool00?oo003oo`00oonc/ooooooook>coolY:@Ooo`0000?oohn?oooooooo
ool01?ooool00ooog=cooc/kool00006ool00003ool10OooKVkooogm00Co
oooo00Ooooknool<3?oo003oo`00oolW9ooon?SooeEE00Coo`0000Cooc`l
oooooooolO7ood=31?oo00000oooBT[oooooooooo`0Vooooo`03on?Shoni
^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo02Cooooo00?oono_
ool00?oo00000_oo00000oooVi_oooooooooo`04ooooo`03ooo]kOoo003o
o`0000;oo`0000?ooifMooooooooool03?ooool00oooo?coobLWool00002
ool00003oolY:OoomoOooooo02?ooooo00GooahNool00?oo003oo`00oomE
E@0=ooooo`05ooo`l?oofm_oomCDoooShooonOT01?ooool01?ooj^[oomGE
oooEeOooj^X5ooooo`07ooo/k?ooemOoomgMooobl_ooooooooShoooRhP07
oooDe003oooVi_ooo?cooooo00Wooooo00GoooOgoooQhOooe=CoomWIooo^
kP03ooooo`07oooYjOooTY;ood];oole=OooADGooiFEooodm00=ooooo`0;
ooo`l?oo`l?oohj>oomcLoooNg_ooiVIoonn__oodm?oomCDoooNg_oolo<0
6?ooool00ooon?Soon;RoooDe006oooDe003oooVi_ooo?cooooo00kooooo
00[oomGEoon>S_ooGeoood51ool_;ooo<C7ood=3oomQHOooYJGoonk^8_oo
ool03_ooj^[ookRhoon6Q_ooLW;ooh20oonQXOoo`l?oom?CoooDe?ooh^;o
ooShoooooooomOGoomoO0_ooe=@00ooojNWoooooooooo`0:ooooo`05ooo^
k_oofMWoomCDoooPh?oom_H02?ooool02oooj^[ookRhoon6Q_ooLW;ooh20
oonQXOoo`l?oom?CoooDe?ooh^;oooSh00?ooooo00?oooShoooRh_ooe=@0
1_ooe=@00oooi^Koooclooooo`0>ooooo`06oooDe?oo003oo`00ool00?oo
10Cooocl4Oooool02oooj^[ookRhoon6Q_ooLW;ooh20oonQXOoo`l?oom?C
oooDe?ooh^;oooSh00?ooooo00GoogIfool00?oo003oo`00oomKF`03oooo
o`07oooVi_ooS8coodI6oolk>oooIFGooknoooolo00;ooooo`06oooDe?oo
003oo`00ool00?oo10Cooocl4?ooool02?oofm_oohZ:oom?Cooo=SKood=3
oon1POoocloooocl8Oooool01Ooo=cOoo`00ool00?oo003ooj2P00gooooo
00Goonk^oooIfOooe=Coon3PooofmP03ooooo`08oooEeOooOgooodQ8oolc
<ooo@43oofi^oon^[_ook>`8ooooo`08ooobl_oo^[[oog9boom0@?oo?Sko
ofi^oonk^ooom?@7ooooo`04ooo]kOoof=SoomGEoooZjP;ooooo00Gookjn
oomGEooo?Skooginooo^kP03ooooo`05ooo=cOooIVKood=3oon0P?ool_80
9oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Soooo
o`0Uooooo`05oolU9Ooo003oo`00ool00?ooIVH01oooool01Ooo8b?oo`00
ool00?oo003oofQX00oooooo00?oojj^ool00?oo00000_oo00000oooK6co
ooooooooo`0Rooooo`05oom7Aooo003oo`00ool00?ooBd/0oooooolAoooo
o`03ooomoOoo1`Ooo`0000;oo`0000?oolS8ooooooooool07Oooool01Ooo
Zj_oo`00ool00?oo003oobHV01Gooooo00?ooogmool71ooo00000_oo0000
0ooob<Soooooooooo`0gooooo`05oommOOoo003oo`00ool00?ooFUX0K_oo
ool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0U
ooooo`05oomJF_oo003oo`00ool00?oo<C401oooool01OooFEWoo`00ool0
0?oo003ooc8b013ooooo00?oofa/ool00?oo00000_oo00000oooZJWooooo
ooooo`0Qooooo`06oonZZ_oo003oo`00ool00?oo20Soonc/oooooolAoooo
o`05ooln?_oo003oo`00ool00?ooTi<07oooool00oooh>3oo`00ool00002
ool00003oooalOoooooooooo01?ooooo00Goochnool00?oo003oo`00oonC
T`0iooooo`06ooo6a_oo003oo`00ool00?oo4Q;oooGeKOooool00oo^k^ko
hn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Uooooo`06oon@
T?oo003oo`00ool00?oo0`?ooo[j1_ooool01_ooSXkoo`00ool00?oo003o
o`@4oooin@oooooo00?ooo_kooln?_oo00000_oo00000ooo0@7ooibLoooo
o`0Qooooo`03oooinOoo51Coo`0000;oo`0000?ooe]KooomoOooool0oooo
ool?ooooo`05oomcLooo003oo`00ool00?ooGUh08?ooool01Ooo4Q;oo`00
ool00?oo003ook^k01Gooooo00Goog=cool00?oo003oo`00oomNGP0joooo
o`05oolf=_oo003oo`00ool00?ooS8`0K_ooool00ooShn?o^KViooooo`01
ooooo`000oo^k^h00oni^KWohn?Sooooo`0Oooooo`03ooolo?oof=Sookbl
00?ookbl00?oohf=ool00?oo00000_oo00000oooa/Koooooooooo`04oooo
o`03ooo3`ooo003oo`0000;oo`0000?ooiJFoonl_?oo_;`01ooo_;`00ooo
c/kooo3`ooooo`04ooooo`03ooo[jooo:2Soo`0000?oo`0000?ooeaLoooU
iOooool00oooool01?ookNgoogIfoom:B_ooUIDIooooo`03oonb/_oo0P;o
o`0000;oo`0000?oode=oooUiOooool01?ooool00ooolO7oojFUoon_[`0Q
ooooo`;ooo;bD_ooool2oooblWcooooo0_ool_8Aooooo`05oonXZ?oo003o
o`00ool00?oo:BT08?ooool01OooBd_oo`00ool00?oo003oohJ601Gooooo
00GoojRXool00?oo003oo`00oolY:@0jooooo`06oonc/ooo003oo`00ool0
0?oo1`Oook2`K?ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni
^KWohn?Sooooo`0Oooooo`03oooknooo1`Ooo`0000Soo`0000?ooi6Aoooo
ooooool01?ooool00ooom?Coo`00ool0000=ool00003oombL_oooooooooo
00Cooooo00?oooGeoomLG?oo00000ooo00001_oo0`?oobl_oomBD_ooBT[o
obHVool30`;oo`0000?oodm?ooooooooool06?ooool00oooVIWoo`00ool0
0002ool00007ool20_oo<33ooeEEoomIFOoo?cooob0Pool10@02ool00003
oooWiooooooooooo01cooooo00KooogmoomEEOoo003oo`00oolX:?ooe]I>
ooooo`06ooomoOooEEGoo`00ool00?oo:2SoomKFN?ooool01_oooOgooeEE
ool00?oo003oobPXoooFeP[ooooo00?ooo3`oooLg?ooe]H00_ooe]H01_oo
^;Soo`00ool00?oo003oo`41oooemAoooooo00Gooh20ool00?oo003oo`00
oomAD@0@ooooo`03ooo`l?oog=coomKF00;oomKF00KookRhool00?oo003o
o`00ool10OoomODjooooo`03oon1POoo003oo`0000;oo`0000?ooh>3oooi
nOooool00_ooool00ooon_[ookjnooo2`P1Tooooo`03onKVi_oShn?o^KVi
00;oi^KV0003onk^kP03okVi^OoShn?ooooo023ooooo00?oocTiool00?oo
00001ooo00000oooG5coooooooooo`05ooooo`03ool];Ooo003oo`0000co
o`0000?oocdmooooooooool01_ooool00oooWioooa0@ool00009ool00003
oolJ6_oooooooooo01Wooooo00?oojFUoolE5Ooo00002_oo00000ooo/K7o
ooooooooo`0Looooo`03oooMgOoo003oo`0000;oo`0000?ooc@dooolo?oo
ool0C?ooool00ooogMgoo`00ool00002ool00003oold=?ooo?cooooo07Ko
oooo00?oomgMool00?oo00000_oo00000ooo=3Coooclooooo`08ooooo`03
oomNG_oo003oo`0000Ooo`0000?ookjnooooooooool07Oooool01Ooo]KGo
o`00ool00?oo003ooa`L013ooooo00?ooeiNool00?oo00001ooo00000ooo
_[koooooooooo`0iooooo`03oonGUooo0@7oo`0000;oo`0000Goo`41oolC
4ooo92CooaPHool30`02ool00003oooOgooooooooooo067ooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool08?ooool00ooo
[Jgooe9Booli>@06ooli>@03oom6A_ooUIGooooo00Kooooo00?oojNWoom?
Cooo>CT02ooo>CT00ooo?cooohF5ooooo`08ooooo`04oooknoooYZKoobTY
ool10@Goo`0000?oo`82ool^;_ooW9`07?ooool01?oon_[ooiFEoolL7?oo
0P86ool00003ool20_oo<S;ookjn01kooooo00?ooogmooli>Ooo00000ooo
00000ooogmooooooooooo`1;ooooo`03ooomoOoo>CWoo`0000?oo`0000?o
omoOooooooooool0MOooool00ooooOgoocTiool00003ool00003oooOgooo
oooooooo00Oooooo00?ooi>Cool00?oo00001ooo00000oooRHWooooooooo
o`0Mooooo`03oooZj_oo003oo`0000;oo`0000?oonSXooooooooool03Ooo
ool00oooTi?oo`00ool00007ool00003oon9ROoooooooooo03[ooooo00?o
oj^[ool41?oo00002?oo00000oooZZ[oooooooooo`1Rooooo`03on?Shoni
^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo04kooooo00Oooocl
oooKfoooXZ;oohV9oonOWoood];oooOg02;ooooo00OoonWYoonf]_ooShoo
oi2@oon][Ooof=Sooo_k027ooooo00KoomWIool^;_oo0@7oo`41oomMGOoo
o_i>ooooo`06oooIfOoo;Rkoo`41ool10OooGEgoooknN?ooool01_oofMWo
obh^ool10Ooo0@7ooeeMooonoPWooooo00?oomWIoomJF_oo;2`01_oo;2`0
0ooo@d?ooj:Rooooo`0Oooooo`05oomfM_oo<C7oob`/oomIFOoof=P03ooo
ool00ooofMWooeYJool/;006ool/;003oom3@oooXZ;ooooo03cooooo00Co
onSXoomnO_oo6a_oo`<31?oo00000ooo1`OoobLWoonWY`1Sooooo`03onk^
k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0:7ooooo0_oo
moMBooooo`;oooOgO?ooool2ooogmiKooooo00?oooGeoooShoookNd0Iooo
ool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`3o
ooooooooooooMoooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni
^KWohn?Sooooo`3oooooooooooooN?ooool00ooShn?o^KViooooo`01oooo
o`000oo^k^h00oni^KWohn?Sooooo`3oooooooooooooMoooool00oo^k^ko
hn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`3ooooooooooooo
Moooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Soooo
o`3oooooooooooooMoooool00oo^k^kohn?SokVi^@02onk^kP000oooool0
0oni^KWohn?Sooooo`3oooooooooooooN?ooool00ooShn?o^KViooooo`01
ooooo`000oo^k^h00oni^KWohn?Sooooo`3oooooooooooooMoooool00oo^
k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`3ooooooooo
ooooMoooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?S
ooooo`3oooooooooooooMoooool00oo^k^kohn?SokVi^@02onk^kP000ooo
ool00oni^KWohn?Sooooo`3oooooooooooooN?ooool00ooShn?o^KVioooo
o`01ooooo`000oo^k^h00oni^KWohn?Sooooo`3oooooooooooooMoooool0
0oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`3ooooo
ooooooooMoooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWo
hn?Sooooo`3oooooooooooooMoooool00oo^k^kohn?SokVi^@02onk^kP00
0oooool00oni^KWohn?Sooooo`3oooooooooooooN?ooool00ooShn?o^KVi
ooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`3oooooooooooooMooo
ool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`3o
ooooooooooooMoooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni
^KWohn?Sooooo`3oooooooooooooMoooool00oo^k^kohn?SokVi^@02onk^
kP000oooool00oni^KWohn?Sooooo`3oooooooooooooN?ooool00ooShn?o
^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`3ooooooooooooo
Moooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Soooo
o`3oooooooooooooMoooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h0
0oni^KWohn?Sooooo`3oooooooooooooMoooool00oo^k^kohn?SokVi^@02
onk^kP000oooool00oni^KWohn?Sooooo`3oooooooooooooN?ooool00ooS
hn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`3ooooooooo
ooooMoooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?S
ooooo`3Qooooo`03ong]kOoclo?ooooo01;ooooo00?on_[jooWinOoinOT0
oooooommooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoS
hn?ooooo0=gooooo00[ol_;bogemOOlc<c?o410@o`000?l10@7o7alOodU9
BOmcLg?of][J3oooool01?m;Bd_o0000o`000?o6a/Koooooogcooooo00?o
k^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0g?ooool0
0onVYZKo5ADEo`000007o`000003o`H61_mfMWKol_;b00gooooo00CoXJ6Q
o`000?l0003oL71`4_ooool00on0P83o0000o`00000To`000003on;Rh_oo
oooooooo00Gooooo00?o]KFeo`000?l000003_l000000oono_kooooooogm
o@0@o`000004ofa/K?oooooooooooiBDU13o000000?oe=CDoinOWol00000
3ol000001Om?CdooooooooooooooooooY:BT00oo000000?o3`l?oooooooo
ool0f_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?S
ooooo`3Kooooo`03okfm_Ol410Co000000Go000000Oo1`L7oeeMGOmFEUKo
0@41o`000?lI6AWo_kno00cooooo00Gol?3`o`000?l0003o71`LooShn00A
ooooo`06om;Bd_nUYJGoVi^Kofi^K_lm?Cgo1@D58Ol000000onBTY;ooooo
ooooo`05ooooo`05onOWionRXZ;oTY:BoeUIFOl410@02?l000001?lA4A7o
IfMWoiFEUOnVYZH3ooooo`04ojf][On@T93oJ6QXo`/;2`So000000Go1`L7
oeMGEon?ShooWinOolk>cP02ooooo`05omgMgOnXZ:SoTY:BofEUIOl<30`0
2?l000002_l:2P[oG5aLoi>CTonSXj?olO7aomoOgonNWYkoS8b<oeMGEol?
3`l8o`000005o`<30omCDe?oRXZ:oibLW?o4a<@00oooool00ooQhN7oUIFE
ocHf=P0:o`000004ob/[:omjNW[oW9bLojj^[]_ooooo00?ok^k^on?Shoni
^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0f_ooool00ooinOWo4a<C
o`000006o`000004ojFUYOooooooooooohb<S0;o000000?o3@d=olc<c?oo
ool02oooool01?m?Cdoo0000o`000?o2`/8Fooooo`03okjn__lA4A7o0000
01oo000000?o@T92ooooooooool02Oooool00onJVY[o0000o`000005o`00
0003o``<3?o>c/kooooo00Sooooo00?oemOGoa/K6ol000001Ol000000ol2
0P;o[Jf]ooooo`09ooooo`03om;Bd_l410Co000000Go000000?o1PH6okZj
^_ooool01oooool00ooQhN7o7AdMo`000006o`000003oiVIVOoooooooooo
00Oooooo00?og=cLo`000?l000001_l000000ol71`OoUIFEoogmo@3Noooo
o`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0=[o
oooo00?oa<C4o`000?l000001Ol000001_m5ADGooooooooooooooooon_[j
oaHF5P;o000000?o5QHFom[Jf_ooool02_ooool01?nUYJGo0000o`000?m/
K6`Gooooo`03om?Cdol0003o000000Oo000000KoF5QHojNWYoo0`<3oc<c<
omCDe?oGemL4omWIf@08omOGeooAdM7obl_;ok^k^onYZJWoRXZ:of9RH_lR
8R85o`000003o`@41?o]kNgooooo00[ooooo00?oE5ADo`000?l000001?l0
00000onJVY[oooooooooo`09ooooo`03oginO_l0003o000000Co000000?o
M7Adooooooooool02_ooool00omeMGGo0000o`000004o`000003ogYjN_oo
oooooooo00Sooooo00?o];Bdo`000?l000001?l000000om=CDgooooooooo
o`08ooooo`03ol_;bol0003o000000Go000000?o4a<Col;2`_ooool0gooo
ool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`3J
ooooo`03oiFEUOl0003o000000Go000000?oaLG5ooooooooool00_ooool0
1_mTI6Co0000o`000?l0003o:2PXoo_kn`[ooooo00Gol_;bo`000?l0003o
6ATIooWin@0Gooooo`03oc8b<_l0003o000000Go000000?oPH61oooooooo
ool04?ooool00onj^[[o=3@do`000003o`000003oj2PX?oooooooooo00Wo
oooo00?oVYZJo`000?l000001?l000000ooNg]koooooooooo`09ooooo`03
om7AdOl0003o000000Co000000?o]KFeooooooooool02_ooool00ooRh^;o
0000o`000004o`000003ok^k^ooooooooooo00Sooooo00?olo?co`<30ol0
00001?l000000on:RX[oooooooooo`07ooooo`03ookno_m3@d?o000000Go
000000?o3`l?olo?coooool0hOooool00ooShn?o^KViooooo`01ooooo`00
0oo^k^h00oni^KWohn?Sooooo`3Jooooo`03ok2`/?l0003o000000Co0000
00?o@D51ooooooooool00oooool00ommOGgo0000o`000002o`000003oifM
WOoooooooooo00Wooooo00CoDU9Bo`000?l0003o_kno5oooool00omaLG7o
0000o`000004o`000003o`D51Ooclo?ooooo01?ooooo00GoRh^;o`410Ol0
003o0000oe1@D00;ooooo`03okfm_Ol0003o000000Co00003?ooool00oo]
kNgo0000o`000004o`000003olg=cOoooooooooo00[ooooo00?omoOgo`00
0?l000001?l000000ooKfm_oooooooooo`09ooooo`03oaHF5_l0003o0000
00?o000000?oYJFUooooooooool01oooool00onATI7o0000o`000004o`00
0003o`D51Onm_Kgooooo0>7ooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
i^KV00?o^KVion?Shoooool0f_ooool00ooalO7o6ATIo`000003o`000003
o`L71oo?cloooooo00Cooooo00?oTY:Bo`000?l000000_l000000olP823o
n_[jooooo`09ooooo`04ojVYZOl0003o0000ofQXJ1Oooooo00?oPh>3o`00
0?l000001?l000000ol_;booooooooooo`0Dooooo`05oj>SXol51@Go0000
o`T92OoemOD02_ooool00oo9bLWo0000o`000003o`000003o`T92Ooooooo
oooo00[ooooo00?ooOgmo`410Ol000001?l000000ooFe]Koooooooooo`0:
ooooo`03oo_knol0003o000000Co000000?oinOWooooooooool02Oooool0
0olT92Co0000o`000003o`000003ok2`/?oooooooooo00Kooooo00?oa/K6
o`D51Ol000001Ol000000onKVi_oooooooooo`3Qooooo`03onKVi_oShn?o
^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0=_ooooo00Kobl_;obXZ
:_l0003o0000ob<S8onXZ:P6ooooo`03oibLW?l0003o000000?o000000?o
WinOooooooooool02?ooool01Oodm?Co0P82o`000?lF5QKon_[j01Kooooo
00?oTI6Ao`000?l000001?l000000om0@43oooooooooo`0Eooooo`04oh^;
Rol0003o0000ojj^[P[ooooo00?oe=CDo`000?l000000ol000000olC4a?o
ooooooooo`0;ooooo`03oa4A4Ol0003o000000?o000000?ogmoOoooooooo
ool02oooool6o`000003oo;bl_oooooooooo00Wooooo00?o;bl_o`000?l0
00000ol000000oni^KWoooooooooo`05ooooo`03onSXj?lK6a_o000000Go
000000?oKfm_ooooooooool0h_ooool00oo^k^kohn?SokVi^@02onk^kP00
0oooool00oni^KWohn?Sooooo`3Looooo`03ooclo?oEeMGob/[:00Sooooo
00?oW9bLo`000?l000000ol000000omKFe_oooooooooo`09ooooo`04oeIF
E_l0003o0000ok^k^aKooooo00?oWinOo`000?l000001?l000000om>CTko
ooooooooo`0Eooooo`04oogmoOln?Sko0000oeeMG@[ooooo00?oe]KFo`00
0?l000000ol000000olE5AGoooooooooo`0;ooooo`03oa@D5?l0003o0000
00?o000000?oh>3Pooooooooool02oooool6o`000003ooCdm?oooooooooo
00Wooooo00?o<30`o`000?l000000ol000000onk^k_oooooooooo`04oooo
o`03oo_knolo?coo000000Go000000?o@T92ooclo?ooool0i?ooool00ooS
hn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`3Wooooo`03
oibLW?l0003o000000?o000000?o820Pooooooooool02Oooool01?n][Jgo
0000o`000?mTI6@Fooooo`03ojBTY?l0003o000000Co000000?oDe=Coooo
ooooool05_ooool01?oOgmoo2`/;oa4A4Ookno/9ooooo`03omKFe_l0003o
000000?o000000?o5ADEooooooooool02oooool00olD51Co0000o`000003
o`000003on3Ph?oooooooooo00_ooooo1_l000000oodm?Coooooooooo`09
ooooo`03oc0`<?l0003o000000?o000000?o^k^kooooooooool01?ooool0
0omcLg?o0000o`000004o`000003ob0P8?o/k>cooooo0>Cooooo00?ok^k^
on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ioooool00onL
W9co0000o`000004o`000003onKVi_oooooooooo00Sooooo00Gom_Kfo`@4
1?l0003o4a<Coo_kn`0Eooooo`03ojBTY?l0003o000000Co000000?oDe=C
ooooooooool05oooool00omcLg?o0000okbl_009ooooo`03omKFe_l0003o
000000?o000000?o5ADEooooooooool02oooool00olD51Co0000o`000003
o`000003on3Ph?oooooooooo00_ooooo1_l000000oodm?Coooooooooo`09
ooooo`03oc0`<?l0003o000000?o000000?o^k^kooooooooool00oooool0
0onZZZ[o0000o`000004o`000003o`T92Oo?cloooooo0>Gooooo00?oi^KV
on?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0ioooool00onL
W9co0000o`000004o`000003ok2`/?oooooooooo00Wooooo00CoFUYJo`00
0?l0003o]kNg5Oooool00onTY:Co0000o`000004o`000003oe=CDooooooo
oooo01Oooooo00?oi^KVo`L71om[Jf/02Oooool00ooFe]Ko0000o`000003
o`000003oaDE5Ooooooooooo00_ooooo00?o51@Do`000?l000000ol00000
0ooPh>3oooooooooo`0;ooooo`Ko000000?om?Cdooooooooool02Oooool0
0ol`<33o0000o`000003o`000003ok^k^ooooooooooo00;ooooo00?oe]KF
o``<3?l000001Ol000000onSXj?oooooooooo`3Uooooo`03onk^k_oShn?o
^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0>Oooooo00?oW9bLo`00
0?l000001?l000000onJVY[oooooooooo`09ooooo`04ok6a/Ol0003o0000
of1PH1Gooooo00?oY:BTo`000?l000001?l000000omCDe?oooooooooo`0H
ooooo`03ofMWIolL71cooooo00Sooooo00?oe]KFo`000?l000000ol00000
0olE5AGoooooooooo`0;ooooo`03oa@D5?l0003o000000?o000000?oh>3P
ooooooooool02oooool6o`000003ooCdm?oooooooooo00Wooooo00?o<30`
o`000?l000000ol000001_nk^k_oooooooooooooooool_;bobLW9`Ko0000
00?oKFe]ooooooooool0ioooool00ooShn?o^KViooooo`01ooooo`000oo^
k^h00oni^KWohn?Sooooo`3Wooooo`03oibLW?l0003o000000Co000000?o
Rh^;ooooooooool02Oooool01Oohn?So1PH6o`000?lA4A7ooOgm01Cooooo
00?oY:BTo`000?l000001?l000000omCDe?oooooooooo`0Hooooo`03omgM
gOmOGeookno_00Sooooo00?oe]KFo`000?l000000ol000000olE5AGooooo
ooooo`0;ooooo`03oa@D5?l0003o000000?o000000?oh>3Pooooooooool0
2oooool6o`000003ooCdm?oooooooooo00Wooooo00?o<30`o`000?l00000
0ol000001Onk^k_oooooooooooooooooDU9B00Ko000000?o?Cdmoo_knooo
ool0ioooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?S
ooooo`3Wooooo`03oibLW?l0003o000000Co000000?oNg]kooooooooool0
2_ooool01?mNGUko0000o`000?nc/k<Dooooo`03ojBTY?l0003o000000Co
000000?oDe=Cooooooooool08oooool00ooFe]Ko0000o`000003o`000003
oaDE5Ooooooooooo00_ooooo00?o51@Do`000?l000000ol000000ooPh>3o
ooooooooo`0;ooooo`Ko000000?om?Cdooooooooool02Oooool00ol`<33o
0000o`000003o`000004ok^k^oooooooooooohV9R@Ko000000?o6QXJonSX
j?ooool0j?ooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWo
hn?Sooooo`3Wooooo`03oibLW?l0003o000000Co000000?oK6a/oooooooo
ool02_ooool01?ne]KGo0000o`000?mLG5`Dooooo`03ojBTY?l0003o0000
00Co000000?oDe=Cooooooooool08oooool00ooFe]Ko0000o`000003o`00
0003oaDE5Ooooooooooo00_ooooo00?o51@Do`000?l000000ol000000ooP
h>3oooooooooo`0;ooooo`Ko000000?om?Cdooooooooool02Oooool00ol`
<33o0000o`000003o`000004ok^k^ooooooo_Kfmo`<30`Go000000?o1PH6
olO7aoooool0jOooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni
^KWohn?Sooooo`3Wooooo`03oibLW?l0003o000000Co000000?oGUiNoooo
ooooool02_ooool01?oinOWo20P8o`000?l?3`lDooooo`03ojBTY?l0003o
000000Co000000?oDe=Cooooooooool08oooool00ooFe]Ko0000o`000003
o`000003oaDE5Ooooooooooo00_ooooo00?o51@Do`000?l000000ol00000
0ooPh>3oooooooooo`0;ooooo`Ko000000?om?Cdooooooooool02Oooool0
0ol`<33o0000o`000003o`000003ok^k^ooShn?o5ADE00Ko000000?oUiNG
ooooooooool0j_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni
^KWohn?Sooooo`3Wooooo`03oibLW?l0003o000000Co000000?oFe]Koooo
ooooool02oooool01?mRHV;o0000o`000?n_[jlCooooo`03ojBTY?l0003o
000000Co000000?oDe=Cooooooooool08oooool00ooFe]Ko0000o`000003
o`000003oaDE5Ooooooooooo00_ooooo00?o51@Do`000?l000000ol00000
0ooPh>3oooooooooo`0;ooooo`Ko000000?om?Cdooooooooool02Oooool0
0ol`<33o0000o`000003o`000003okBd]?lg=cOo000000Go000000?oHV9R
ooooooooool0j_ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni
^KWohn?Sooooo`3Wooooo`03oibLW?l0003o000000Co000000?oFe]Koooo
ooooool02oooool01?ni^KWo0000o`000?mHF5PCooooo`03ojBTY?l0003o
000000Co000000?oDe=Cooooooooool08oooool00ooFe]Ko0000o`000003
o`000003oaDE5Ooooooooooo00_ooooo00?o51@Do`000?l000000ol00000
0ooPh>3oooooooooo`0;ooooo`Ko000000?om?Cdooooooooool02Oooool0
0ol`<33o0000o`000003o`000003oc`l??l0003o000000Co000000?o=3@d
ooShn?ooool0joooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni
^KWohn?Sooooo`3Wooooo`03oibLW?l0003o000000Co000000?oFe]Koooo
ooooool02oooool01?okno_o2`/;o`000?l<30`Cooooo`03ojBTY?l0003o
000000Co000000?oDe=Cooooooooool08oooool00ooFe]Ko0000o`000003
o`000003oaDE5Ooooooooooo00_ooooo00?o51@Do`000?l000000ol00000
0ooPh>3oooooooooo`0;ooooo`Ko000000?om?Cdooooooooool02Oooool0
0ol`<33o0000o`000003o`000003ojZZZ_lk>c_o000000?o000000?o5ADE
on;Rh_ooool0k?ooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni
^KWohn?Sooooo`3Wooooo`03oibLW?l0003o000000Co000000?oFe]Koooo
ooooool03?ooool01?mVIVKo0000o`000?n[Zj/Booooo`03ojBTY?l0003o
000000Co000000?oDe=Cooooooooool08oooool00ooEeMGo0000o`000003
o`000003oaDE5Ooooooooooo00_ooooo00?o4a<Co`000?l000000ol00000
0ooPh>3oooooooooo`0;ooooo`Ko000000?om?Cdooooooooool02Oooool0
0ol`<33o0000o`000003o`000003ok^k^oofm_KoC4a<00?o000000?oQhN7
ooooooooool0kOooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni
^KWohn?Sooooo`3Wooooo`03oibLW?l0003o000000Co000000?oFe]Koooo
ooooool03?ooool01?nl_;co0000o`000?mEEEDBooooo`03ojBTY?l0003o
000000Co000000?oDe=Cooooooooool08oooool00ooDe=Co0000o`000003
o`000003oaDE5Ooooooooooo00_ooooo00?o4A4Ao`000?l000000ol00000
0ooPh>3oooooooooo`0:ooooo`03oo_knol0003o000000Co000000?om?Cd
ooooooooool02Oooool00ol`<33o0000o`000003o`000004ok^k^ooooooo
no_koemOG`;o000000?o1PH6ojVYZOooool0k?ooool00oo^k^kohn?SokVi
^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`3Wooooo`03oibLW?l0003o
000000Co000000?oFe]Kooooooooool03?ooool01Oolo?co3Ph>o`000?l:
2P[ooOgm017ooooo00?oY:BTo`000?l000001?l000000omCDe?ooooooooo
o`0Sooooo`03om;Bd_l0003o000000?o000000?o5ADEooooooooool02ooo
ool00ol@413o0000o`000003o`000003on3Ph?oooooooooo00[ooooo00?o
jNWYo`000?l000001?l0000<ooooo`03oc0`<?l0003o000000?o000000Go
^k^kooooooooooooo_knogAdM002o`000003o`820_nHV9Sooooo0>_ooooo
00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0iooo
ool00onLW9co0000o`000004o`000003oe]KFooooooooooo00gooooo00Co
JVYZo`000?l0003oYjNW4Oooool00onTY:Co0000o`000004o`000003oe=C
Dooooooooooo02?ooooo00?oc<c<o`000?l000000ol000000olE5AGooooo
ooooo`0;ooooo`03o`/;2ol0003o000000?o000000?oh>3Pooooooooool0
2_ooool00ooEeMGo0000o`000003o`000003o`T92Ooooooooooo00[ooooo
00?o<30`o`000?l000000ol000000onk^k_oooooooooo`02ooooo`05ohZ:
R_l0003o0000o`000?n5QHD0joooool00oo^k^kohn?SokVi^@02onk^kP00
0oooool00oni^KWohn?Sooooo`3Wooooo`03oibLW?l0003o000000Co0000
00?oFe]Kooooooooool03Oooool01?o0`<3o0000o`000?mADE4Aooooo`03
ojBTY?l0003o000000Co000000?oDe=Cooooooooool08oooool00oo5aLGo
0000o`000003o`000003oaDE5Ooooooooooo00_ooooo00?o1@D5o`000?l0
00000ol000000ooPh>3oooooooooo`0:ooooo`03ol;2`_l0003o000000?o
000000?o5QHFooooooooool02_ooool00ol`<33o0000o`000003o`000003
ok^k^ooooooooooo00?ooooo00KoWinOo`<30ol0003o0000og5aLOono_kZ
ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo
0>Oooooo00?oW9bLo`000?l000001?l000000omKFe_oooooooooo`0=oooo
o`05oogmoOlA4A7o0000o`T92Oojn_X04?ooool00onTY:Co0000o`000004
o`000003oe=CDooooooooooo02?ooooo00?o^;Rho`000?l000000ol00000
0olE5AGoooooooooo`0:ooooo`03ooWinOl0003o000000Co000000?oVIVI
ooooooooool02_ooool00onMWIgo0000o`000003o`000003ob@T9?oooooo
oooo00[ooooo00?o<30`o`000?l000000ol000000onk^k_oooooooooo`04
ooooo`06ok:b/_l820So0000o`000?mOGeooo?clj?ooool00oo^k^kohn?S
okVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`3Wooooo`03oibLW?l0
003o000000Co000000?oFe]Kooooooooool03_ooool01?m^KVko0000o`00
0?nSXj<@ooooo`03ojBTY?l0003o000000Co000000?oDe=Cooooooooool0
8oooool00onUYJGo0000o`000003o`000003oaDE5Ooooooooooo00[ooooo
00?oj>SXo`000?l000001?l000000ol10@7oUiNGooooo`0:ooooo`03od];
Bol0003o000000?o000000?oC4a<ooooooooool02_ooool00ol`<33o0000
o`000003o`000003ok^k^ooooooooooo00Gooooo00Ko`/;2o`l?3ol0003o
0000odi>C_ogmoOWooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0>Oooooo00?oW9bLo`000?l000001?l000000omKFe_o
ooooooooo`0>ooooo`04olC4a?l0003o0000ode=CA3ooooo00?oY:BTo`00
0?l000001?l000000omCDe?oooooooooo`0Sooooo`03ogalO?l0003o0000
00?o000000?o5ADEooooooooool02_ooool00oo1`L7o0000o`000004o`00
0004obLW9ol0003oO7aloo_kn`Sooooo00?okno_o`H61_l000001?l00000
0on3Ph?oooooooooo`0:ooooo`03oc0`<?l0003o000000?o000000?o^k^k
ooooooooool01_ooool01_o<c<co51@Do`000?l0003o?clooo7alNKooooo
00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0iooo
ool00onLW9co0000o`000004o`000003oe]KFooooooooooo00kooooo00Go
o_knoa@D5?l0003o1`L7ooShn00?ooooo`03ojBTY?l0003o000000Co0000
00?oDe=Cooooooooool08_ooool00ooemOGo5QHFo`000004o`000003oaDE
5Ooooooooooo00[ooooo00?oIfMWo`000?l000001?l000001Oo@d=3o<30`
o`000?ld=3Codm?C00Kooooo00?omoOgodU9BOl000001Ol000000oo0`<3o
ooooooooo`0:ooooo`03oc0`<?l0003o000000?o000000?o^k^koooooooo
ool01oooool01_oEeMGo5ADEo`000?l0003o<C4aon?ShnKooooo00?ohn?S
okVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0ioooool00onL
W9co0000o`000004o`000003oe]KFooooooooooo00oooooo00CoLG5ao`00
0?l0003oX:2P3oooool00onTY:Co0000o`000004o`000003oe=CDooooooo
oooo01kooooo00GoVIVIodU9BOn2PX;oShn?ocXj>P06o`000003oaDE5Ooo
oooooooo00Gooooo00Kodm?CocXj>_mcLg?oUiNGoeADE?l10@46o`00000<
on3Ph?oYjNWo9RHVo`000?l10@7oADE5ojVYZOoIfMWonOWion7QhOnZZZ[o
?clo1_l000000olc<c?oooooooooo`0;ooooo`03oc0`<?l0003o000000?o
000000?o^k^kooooooooool02?ooool01_o9bLWo0P82o`000?l0003o5aLG
ol;2`^Cooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?S
hoooool0ioooool00onLW9co0000o`000004o`000003oe]KFooooooooooo
00oooooo00Cob<S8o`000?l0003oBDU93oooool00onTY:Co0000o`000004
o`000003oe=CDooooooooooo01kooooo00?oShn?oa8B4_l000002?l00000
0olE5AGoooooooooo`05ooooo`03ok^k^olT92Co000000Wo000000Coh>3P
oooooooQhN7o9bLW1?l000000ol10@7o0000o`000007o`000003okFe]Ooo
oooooooo00_ooooo00?o<30`o`000?l000000ol000000onk^k_ooooooooo
o`09ooooo`07ob@T9?l0003o0000o`000?l51@GoOWinooCdm03Rooooo`03
onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0>Oooooo
00?oW9bLo`000?l000001?l000000omKFe_oooooooooo`0?ooooo`05ookn
o_lG5aOo0000o`D51Oofm_H03_ooool00onTY:Co0000o`000004o`000003
oe=CDooooooooooo01oooooo00?omoOgoj:RX_lj>SX01ol000000olE5AGo
ooooooooo`06ooooo`04ookno_nk^k_oDe=Co`@410Oo000000Goh>3Poooo
ooooooool_;boe9BDP0<o`000003oe5ADOoooooooooo00cooooo00?o<30`
o`000?l000000ol000000onk^k_oooooooooo`08ooooo`03ok6a/Ol0003o
000000Co000000?o6ATIohR8R?oCdm<0h?ooool00oo^k^kohn?SokVi^@02
onk^kP000oooool00oni^KWohn?Sooooo`3Wooooo`03oibLW?l0003o0000
00Co000000?oFe]Kooooooooool04?ooool01?meMGGo0000o`000?nLW9`>
ooooo`03ojBTY?l0003o000000Co000000?oDe=Cooooooooool08_ooool0
0ooBd];oJVYZo`h>3P04o`000003oaDE5Ooooooooooo00Wooooo00?oi^KV
oh>3PolN7Qh01Ol000000ooPh>3oooooooooo`02ooooo`03ohZ:R_l92@Wo
000000So000000?oBTY:ooWinOooool03Oooool00ol`<33o0000o`000003
o`000003ok^k^ooooooooooo00Kooooo00?o`L71oadM7Ol000002Ol00000
1?lG5aOo=CDeode=COoLg=cMooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0>Oooooo00?oW9bLo`000?l000001?l00000
0omKFe_oooooooooo`0@ooooo`04olc<c?l0003o0000odE5A@kooooo00?o
Y:BTo`000?l000001?l000000omCDe?oooooooooo`0Tooooo`03ooCdm?nJ
VY[o<S8b00;o000000?o5ADEooooooooool02oooool01?omoOgo/k>cod];
Bol20P82o`000003on3Ph?oooooooooo00?ooooo00?oj>SXogMgMol=3@d0
1Ol000000olL71coShn?ooShn00?ooooo`03oc0`<?l0003o000000?o0000
00?o^k^kooooooooool01_ooool00oo>c/koM7AdogAdM00<ogAdM003on7Q
hOoooooooooo0=[ooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o
^KVion?Shoooool0ioooool00onLW9co0000o`000004o`000003oe]KFooo
oooooooo017ooooo00Co6a/Ko`000?l410Colo?c3Oooool00onTY:Co0000
o`000004o`000003oe=CDooooooooooo02Oooooo00?ob/[:ogalO?n2PX80
4?ooool01?oQhN7oQXJ6ogMgMoo_knl7ooooo`07oo?cloo5aLGoVi^Koh61
POnNWYko`L71ooWin@0Aooooo`03oc0`<?l0003o000000?o000000?o^k^k
ooooooooool0l_ooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni
^KWohn?Sooooo`3Wooooo`03oibLW?l0003o000000Co000000?oFe]Koooo
ooooool04Oooool01?miNGWo0000o`000?nHV9P=ooooo`03ojBTY?l0003o
000000Co000000?oDe=Cooooooooool0GOooool00ol`<33o0000o`000003
o`000003ok^k^ooooooooooo0?;ooooo00?ok^k^on?Shoni^KT00_o^k^h0
00?ooooo00?o^KVion?Shoooool0ioooool00onLW9co0000o`000004o`00
0003oe]KFooooooooooo017ooooo00Cod=3@o`000?l0003o@D513Oooool0
0onTY:Co0000o`000004o`000003oe=CDooooooooooo05gooooo00?o<30`
o`000?l000000ol000000onk^k_oooooooooo`3cooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0>Oooooo00?oW9bLo`00
0?l000001?l000000omKFe_oooooooooo`0Booooo`04oahN7_l0003o0`<3
oo3`l0cooooo00?oY:BTo`000?l000001?l000000omCDe?oooooooooo`1M
ooooo`03oc0`<?l0003o000000?o000000?o^k^kooooooooool0l_ooool0
0oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`3Woooo
o`03oibLW?l0003o000000Co000000?oFe]Kooooooooool04_ooool01?mm
OGgo0000o`000?nDU9@<ooooo`03ojBTY?l0003o000000Co000000?oDe=C
ooooooooool0GOooool00ol_;boo0000o`000003o`000003ok^k^ooooooo
oooo0?;ooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?S
hoooool0ioooool00onLW9co0000o`000004o`000003oe]KFooooooooooo
01;ooooo00Cod];Bo`000?l0003o?Cdm3?ooool00onTY:Co0000o`000004
o`000003oe=CDooooooooooo05gooooo00?o;Bd]o`000?l000000ol00000
0onk^k_oooooooooo`3booooo`03onk^k_oShn?o^KVi00;ok^k^0003oooo
o`03okVi^OoShn?ooooo0>Oooooo00?oW9bLo`000?l000001?l000000omK
Fe_oooooooooo`0Cooooo`04ob8R8_l0003o0P82ong]k@_ooooo00?oY:BT
o`000?l000001?l000000omADE7oooooooooo`1Mooooo`03ob/[:ol0003o
000000?o000000?o^k^kooooooooool0loooool00ooShn?o^KViooooo`01
ooooo`000oo^k^h00oni^KWohn?Sooooo`3Wooooo`03oiJFU_l0003o0000
00Co000000?oEUIFooooooooool04oooool01?n1PH7o0000o`000?n@T90;
ooooo`03oinOWol0003o000000Co000000?oC4a<ooooooooool0GOooool0
0olV9RKo0000o`000003o`000003ok^k^ooooooooooo0?;ooooo00?ok^k^
on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ioooool00on<
S8co0000o`000004o`000003oe1@D?oooooooooo01?ooooo00Coe]KFo`00
0?l0003o>CTi2oooool00onGUiOo0000o`000004o`000003od92@_oooooo
oooo05gooooo00?o7alOo`000?l000000ol000000onk^k_oooooooooo`3b
ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0>Oooooo00?oPh>3o`000?l000001?l000000olm?Cgoooooooooo`0Doooo
o`04obh^;_l0003o0@41on[ZjP[ooooo00?oQ8B4o`000?l000001?l00000
0ol_;booooooooooo`1Mooooo`03oa<C4ol0003o000000?o000000?o^k^k
ooooooooool0l_ooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni
^KWohn?Sooooo`3Wooooo`03ofEUIOl0003o000000Co000000?o7alOoooo
ooooool05?ooool01?n5QHGo0000o`000?n<S8`:ooooo`03ofEUIOl0003o
000000Co000000?o3@d=ookno_ooool09Oooool01?o[jn_o]kNgol;2`_oe
mODcooooo`03oo_knol20P;o000000Co000000?o^k^kooooooooool0looo
ool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`3W
ooooo`03oc8b<_l0003o000000Go000000?oi^KVooooooooool04oooool0
1?oJf][o0000o`000?lf=SH:ooooo`03obXZ:_l0003o000000Go000000?o
`<30ooooooooool08oooool01_nEUIGo2@T9o`000?l0003o7AdMol?3`c;o
oooo00?obLW9o`000?l000001?l000000onk^k_oooooooooo`3booooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0>Kooooo
00?oZj^[o`000?l000001_l000000omTI6Coo?clooooo`0Dooooo`04oc8b
<_l0003o0000onKViPSooooo00?o[Zj^o`000?l000001_l000000olQ8B7o
iNGUooooo`0Rooooo`03okRh^?l0003o000000?o000000?o51@Don[Zj_oo
ool0;?ooool01OoBd];on_[jooooooofm_KoD51@00Ko000000?o^k^koooo
ooooool0l_ooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWo
hn?Sooooo`3Tooooo`03omgMgOm_Kfoo0P8200Wo000000?o@410om[Jf_oo
ool04oooool01?n9RHWo0000o`000?n8R8P6ooooo`03oo7alOmcLg?o0P82
00Wo000000?o410@ohb<S?oHf=P08Oooool00om?Cdoo0000o`000004o`00
0003oiNGUooooooooooo02[ooooo00Gof=SHo`820_l<30co?Cdmo`/;2`07
o`000003ok^k^ooooooooooo0?;ooooo00?ok^k^on?Shoni^KT00_o^k^h0
00?ooooo00?o^KVion?Shoooool0h?ooool01OnQXJ7oCDe=odA4A?lU9BGo
0@4100go000000Co3Ph>ocTi>Om=CDgoNWYj4?ooool01?oMgMgo0000o`00
0?lb<S82ooooo`05ojNWYom=CDgoADE5oahN7_l10@403_l000001?lG5aOo
;Rh^ocXj>_m9BDTMooooo`03oc4a<Ol0003o000000Co000000?oNGUioooo
ooooool0:_ooool00oojn_[oZZZZod10@009o`000003ok^k^ooooooooooo
0??ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shooo
ool0h?ooool00onVYZKoEeMGoeMGE`0BoeMGE`03oh:2P_oooooooooo00oo
oooo00Ko=SHfo`000?l0003ohn?Soooooon[Zj/EoeMGE`03oeUIFOoooooo
oooo01_ooooo00?oGEeMo`000?l000001?l000000onUYJGoooooooooo`0]
ooooo`03omKFe_m^KVko3`l?00Ko000000?o^k^kooooooooool0l_ooool0
0oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`3ooooo
o`Sooooo00CoSHf=o`000?l0003oQ8B4=Oooool00ooIfMWo2@T9o`000003
o`000003oc0`<?ojn_[ooooo033ooooo00?omOGeoi^KVola<C401?l00000
0onk^k_oooooooooo`3booooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^
kP03okVi^OoShn?ooooo0?oooooo2?ooool01?oQhN7o0000o`000?l^;Rhf
ooooo`06olc<c?li>CWo1@D5o``<3?mJFU[ojn_[=Oooool01Oo8b<SoGUiN
o`P82?l0003o^k^k0?Cooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo
00?o^KVion?Shoooool0ooooool9ooooo`04onk^k_o/k>cok>c/ooKfmSOo
oooo00?on_[jookno_ooool0>?ooool00oofm_Kok>c/oo[jnP3eooooo`03
on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoS
hn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o
^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomhoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;oi^KV
0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomh
ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03
okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onk^
k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooo
oomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?o
oooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03onKVi_oShn?o^KVi
00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomgooooo`03
onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooo
oooooomhooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomgooooo`03onk^k_oShn?o^KVi00;ok^k^0003
onKViP03okVi^Oo3`l?o`l?30?oo`l?3ooo3`l=iol?3``7o^KVi0OoVi^H1
onKViP000oo^k^koogalO?ooO7alOOmlO7`2onk^kP00oooooooooooooh;o
oooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00oomoOgmG
ogmoO`OoOWinoomoOglTogmoO`0000Cojn_[onKVi_oRh^;og]kN1?oMgMd2
omkNgP;ogMgM00?og]kNomcLg?oNg]h00ooMgMd0oooNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNgP003ooMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oLg=cogMgMom_Kf`02omcLg00comgM
gOoMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kN00;og=cL00GofMWIomSHf?oGemOof=SH
omWIfP02omcLg01fomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMgP;ogMgM09kog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMgP?o
g]kN00?ogMgMomkNg_oNg]h00ooMgMd1on7Qh@7oinOW0OoZj^X00003onc/
k?oVi^Koh>3P00OofMWI00Cof=SHomKFe_oCdm?od=3@0oo=cLd01?o@d=3o
dm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@
om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@
d?oCdm?oemOGomSHf=_ofMWI0_oHf=P01_oFe]Kodm?Com?CdooDe=CoemOG
omSHf0;ofMWI00?of=SHomWIfOoIfMT00_oHf=P9omWIf@03omSHf?oIfMWo
fMWI00;of=SH00?ofMWIomSHf?oHf=P00_oHf=PGomWIf@04omSHf?oFe]Ko
d];Bolo?c`;ocLg=00Coclo?om?CdooGemOof=SHoooIfMTFomWIf@03omSH
f?oIfMWofMWI00KofMWI0OoNg]h1onKViP7ok>c/00001oo^k^kojNWYonCT
i?oPh>3ohN7Qon3Ph?oRh^800_oQhN403OoMgMgog=cLom?Cdoo7alOo^k^k
ok6a/On^[Zko/[:bokZj^_o7alOodm?Com_KfooOgml02OoQhN403OoOgmoo
fm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooO
gml02OoQhN403OoOgmoofm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k
^oo7alOodm?Com_KfooOgml0f_oQhN402OoPh>3ogmoOom_KfooFe]Koe=CD
omKFe_oJf][og]kNon3Ph006omoOg`?oh>3P00?ogmoOon3Ph?oPh>000_oP
h>08omoOg`;og]kN0_oOgml3on3Ph0;ogmoO0_oPh>02omoOg`goh>3P00Go
gmoOomgMgOoIfMWoeMGEom?Cd`02om;BdP03omKFe_oLg=coh>3P06kohN7Q
00?oh>3Pon7QhOoQhN401OoQhN400ooPh>3ohN7Qon7Qh@0bon7Qh@03on3P
h?oQhN7ohN7Q06WohN7Q00?oh^;Ron7QhOoRh^801?oQhN41on?Sh`7ojNWY
0Oo]kNd00003oo3`l?o_knoolO7a00?ol?3`0?ookno_oo3`l?o^k^kojNWY
om_Kfoo1`L7oY:BToh^;RomkNg_oMgMgog]kNon<S8coY:BTol;2`OoJf][o
j^[Zong]kOoalO7okno_oo7alOo_knoolO7_ono_kooalO7okNg]on[Zj_oJ
f][o`/;2ojBTY?n<S8_oNg]kogMgMomkNg_oS8b<ojBTY?o2`/;of][Jon[Z
j?o]kNgolO7aono_kooalO7okno_oo7alOo_knoolO7_ong]kOoZj^[of][J
ol;2`_nTY:CoS8b<og]kNomgMgKoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^[o
kNg]oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knl001_olO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo^k^kokno_on[Zj_oWinL00_oPh>001ooS
hn?ojn_Yon_[jooZj^[oi^KVonSXj?oWinL00_oYjNT04_o^k^cok>c/onc/
k?oXj>Sok>c/ong]kOo`l?3ok>c/on[Zj?oVi^Koj>SXonOWiooYjNWoj>SX
on_[jooWinOoinOUonGUi@;ojNWY00ook^k^ong]kOo]kNgoj>SXon_[jOo/
k>cok^k^onWYjOoZj^[ojn_[ono_koo/k>cok>cZon[Zj_o^k^h00_o/k>`0
oooZj^[okno_onc/k?o/k>[oj^[Zonk^k_o/k>co[jn_ogIfM_mIFEWoKVi^
okNg]_oPh>3ojNWYong]kOoalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_k`00;OoalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNool?3`ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`04oo3`l00000?o
l_;bonk^k_oWinL01?oUiND04?oTi>CogmoOom7AdOna/K7oRXZ:ofIVI_mA
DE7oADE5od92@_m5ADGoDE5AofIVI_n:RXWo/K6aom7AdOoNg]h2onCTi003
onGUiOoTi>CoiNGT00;oi>CT00oog]kNom7AdOna/K7oRXZ:ofIVI_mADE7o
ADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6aom7Ad?oNg]h00_oTi>@0kOoU
iNGoi>CTonGUiOoTi>Coi>CSomkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5
AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM7og]kNonCThooTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i002onCTi01@olG5aOlX:2SoA4A4oi2@T?oAdM7og=cKom_KfooGemOoe=CD
omKFe_oDe=CoeMGEomWIfOoPh=oog]kNom[Jf_oDe=CofMWIomkNg_oRh^;o
g=cLomOGe_oDe=Coe]KFomCDe?oEeMGof=SHom_KfooGemOoe]KEomGEeOoG
emOof=SHomkNg_oOgmoog=cLomGEeOoGemKog=cLomgMgOoGemOoe]KFom_K
fooQhN7og]kNom_Kf_oJf][og]kNomcLg?oJf][ofm_Kon3Ph?oOgmoog=cK
omWIfOoNg]kogmoOogAdM?mWIfOoSHf=oeADE?l820SoXZ:RomcLg?oRh^;o
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiND3onCTi02MonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUi@03onCTi01TonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi0CoiNGU00Koi>CTonGUiOoUiNGoiNGU
onSXj?o]kNd1oo;blP0000?om?Cdong]kOoWinL00_oPh>004ooQhN7ogmoO
omkNg_oBd];o];BdohN7QomLG5coKC/eoii>@_o=KeoojH=_ola^G_nNCT?o
KC/foeaLG?n7QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7
QhOoG5aLofeP;?nNURkocLdoonWYCOo=cCooWYX_ofeS;OmLG5coQhN7okBd
]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m7IbkoJ9hc
oi7=AonZjEGoTLe7ofZN=?m9JRooG5aLohN7Qond];Cod];BomkNgP3Ion3P
h006omoOgoo?clooVIVIoi:BT_lI6AWoS8b<0_oEeMD07oo?cloo`/;2olk>
c_o>c/koaLG5ol[:b_oJf][of=SHom3@d?o;bl_oclo?omSHf?oJf][oeMGE
olo?coo1`L7od=3@olk>c_o4a<Cobl_;omSHf?oGemOo_[jnok^k^ooAdM7o
d=3@omGEeOoHf=Sodm?Colc<c?o>c/h00_oEeMD01Oo>c/koc<c<om?CdooJ
f][of=SH00;od];B00Cof=SHomOGeooAdM7odm?C0_oIfMT01_oCdm?odM7A
omOGeooHf=SodM7Aom3@d0;odM7A00CoATI6od51@OoGemOog]kNL?oPh>00
0ooOgmooh>3Pon3Ph002on3Ph003omoOgooPh>3oh>3P09goh>3P00?ogmoO
on3Ph?oOgml00_oOgml3on3Ph003on7QhOoWinOok>c/007olo?c00000oof
m_Kol_;bon_[j`03onSXj00ConOWiooRh^;ocLg=oijNW_m[GeooScD]onea
HOoiWI3ooK6Uoofl[oom]:OonInConedHonB=booJemOoinOWoo=cLgoh^;R
onOWi`03onSXj00ConOWiooRh^;ocLg=oinOWom^IUooTg8RongAA?oilgCo
oOf=oogmUOomoHkonOQfongGAonCLb;oKVMOoinOWoo=cLgoh^;RonOWi`03
onSXj00ConOWiooRh^;ocLg=oinOWomPJ5ooBg`Soi;QBonmnG_od?fBomSm
VooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=cLgoh^;RonOWi`3JonSXj004
onKVi_oQhN7oGEeMode=C@;ogMgM01ooD51@o`L71olE5AGoQ8B4oaHF5_m3
@d?oh^;RomgMgOnLW9co0000ohn?SooMgMgohN7Qom_Kfom0@43o20P8oaTI
6On8R8So2`/;oeQHF?ng]kOo30`<o`L71olS8b?o9bLWogemOOoJf][ogMgM
omCDe?l;2`_oFEUI00;ofMWI00?oGEeMo`/;2ooCdm<00_oOgml01_mJFU[o
CTi>omkNg_oNg]ko8b<SohB4Q0;ohN7Q00coNWYjobh^;_oMgMgogMgMol;2
`_m@D53o<c<cofi^K_n3Ph?o8B4QomkNg_oVi^KoonSXj1ooj>SX0Oo/k>`1
oo;blP7om_Kf00000oogmoOon?ShooShn003ooShn00CooOgmoo^k^koc/k>
oi2@T?n5;b_ojFAFoo^BQoonYY_oo[2ToonhZoon/jKooZNLoo^DROo^J5Wo
RC4[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nI
JB_ol;dmoo_PK_onm8;oo_j:ooooT_onoXcoo_R3oo_UL?o``SkoVFX[oi2@
T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?m2Lb_oQ<i3
ojg_Loo2oXSoc_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[oi2@T?o>c/ko
k^k^ooOgm`3JooShn00UooKfm_oalO7oPH61oalO7oo]kNgoa/K6o`000?o3
`l?odm?CoeaLG?l820Soj^[Zoo3`l?oZj^[oDU9Boa@D5?lm?CgojNWYoo3`
l?n_[joo1`L7om;Bd_o=cLgoCTi>oa/K6oo^k^kofm_Kojj^[_oXj>Sok>c/
ojj^[_l0003o];Bdonc/k?n`/;3o2`/;oaXJ6P02onCTi00;ob<S8ol>3Pko
Y:BTong]kOo^k^koH61PoeADE?o^k^kokNg]obHV9_n=SHd00_o`l?003?n2
PX;o<C4aonc/k?oZj^[o@d=3obl_;onLW9coLg=cobXZ:_lJ6Q[ok^k^ooKf
mVkon?Sh00?omoOgooShn?ohn?P01Oohn?P00oogmoOon?ShooShn02NooSh
n003ooOgmoohn?Son?Sh00;on?Sh00ComoOgooWinOofm_KomoOg0Oohn?P0
0003oo[jn_oemOGok^k^00;ok>c/0?oojn_[onWYjOoOgmoo^KViogUBD_no
<B?oigAYoof8O_ooV8cooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<TogUB
D_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[k?oZj^[ogmoOokZj^_n8IE;ohY4L
ooW3D?omfV?oonYbookcO_oonX;oo_Ioooo/LoongVCon/MAon:B7?n9IU?o
^[ZjomoOgooZj^[ojn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S7?nA
dUGoY^MZokSiN_o0oX;oaon9ol?nQ?nioG_oYna/oiCFEomBYQcoDVeBokZj
^_oOgmooj^[Zon_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jn`004Wok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojNWYonGUiOmjNW[o71`L
on7Qh_o<c<co0`<3oj2PX?oNg]koU9BDoa<C4ooQhN7oh>3Qom3@d?l61PKo
XJ6Qo`T92Ono_koohN7QokZj^_l20P;o/[:bomgMgOn0P83o:2PXon?ShooW
inOoiNGUomoOgooKfm_odm?Co`P82?n5QHGogmoOofUYJOm:BT[o=CDeojf]
[Onm_Kgo1`L7ogQhN?mEEEGogmoOon3Ph?mKFe_oD51@00;ohN7Q00[o92@T
ohF5QOoOgmoohN7Qog]kNol_;booh>3PomCDe?l51@GoZ:RX0_oShn<05?mn
OWoo5QHFon7QhOoZj^[ojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/0oo[jn/0Uoo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>`00_o[jn/01?o[jncok>c/on_[joo/k>`3on_[j`1R
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jn`6on_[j`05onc/k?o[
jn_ojn_[onk^k_ofm_H00OoinOT00003oo_knooclo?okNg]00;oiNGU0?oo
i^KVonCTi?oIfMWo/[:bogP];Oo8@SCohfYLooAjKOomR7cooYN:oojKS_on
V8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;of=SHonCTi?oUiNGoi^KVonGU
i_oTi>Cof=SHok:b/_nFEBkojY`[oo^lA?onc5?ooMQRookSL_onjGGoo^Ic
ookKIOomc5?onl55onjN:onIERko/[:bomSHf?oTi>CoiNGUonKVi_oUiNGo
i>CTomSHfOnb/[;o;V8^of>]:on7bTSoUmaIojGUJOnblgOo^?IkokCeNOnW
jV_oV=aIohW?BomS[R_o;V<^ok:b/_oHf=Woi>CTonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNH003Coi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^Kohn?SomoOgomgMgOo6a/KomcLg?oQhN7oWYjNobl_;ol[:b_o<S8b
oa8B4_oLg=cof][KohB4Q?lP823oh>3Poe9BD_mXJ6Sof][JomkNg_n@T93o
:RXZobh^;_l/;2co9bLW0_oNg]h04ooIfMWodm?Dom3@d?mKFe_o0000okfm
_OoJf][o:2PXohN7QomgMgSoJ6QXoh:2P_ll?3co`/;2o`l?3ooDe=Cof][J
oeUIFOm>CTh00_oLg=`0O_lS8b?oPH61omGEeOoGemOoMgMgobh^;_oLg=co
Xj>So`000?o7alOof=SHomWIfOn=SHko5ADEomcLg?oShn?oiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKViP?oiNGU0:Coi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUiP;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGo
kNg]oo?cl`01oo[jnP0000?oo?clooShn?oalO400oo^k^h04oo[jn_ohN7Q
okbl_?mj5aOo`clbom=FBOoTJ5[okgM/oo>3N?ohQgcomHAjoo=iKOoUJE_o
fEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?nU
AaOoiYLbooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlbonVK
<_nUAQOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOoGjPb
ogJm=on6cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lGFAOo
_;blon7QhOo/k>`0f_o^k^h0;_o/k>coinOWog]kNolL71coi>CTonWYjOoV
i^KohN7QomkNg_n=SHgo51@DonKVi_oTi>Co=CDeogUiNOo[jn_o/[:boaDE
5OoOgmooi^KVonCTi?oQhN7ogMgMogYjN_lY:BWoj>SXonGUiOoMgMgo/K6a
obHV9_l;2`_oVi^KonWYjOo<c<co0000olk>c_o3`l?o9BDUod];BomlO7co
j>SXoc4a<OnUYJGoi>CToeeMGOmADE42onOWi`0:obDU9OmYJFWogmoOomoO
gomgMgOo<C4aonWYjOo1`L7o0000ojNWY`;ogmoO00CoTi>CoaHF5_oWinOo
k>c/Zoo^k^h00oo]kNgok^k^onk^kP1_onk^kP03ong]kOobl_;on?Sh007o
o?cl0003oogmo@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Co
aclcom9@@ooJHUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooB
d];olo?cooclo0?ooOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWomJPY
ooRd?ooi_D[on;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?o
o?cl00?ooOgm01?oo?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:
cE3oSLeBoh[>D?n1adCoLKT_of:^8?m>VcCo1d87om;Bd_oclo?oo?cl0=[o
oOgm02?ono_kooOgmon4Q8Co7QhNoo?clooinOWo/k>com3@d?oclo?oJ6QX
odM7Aoojn_[oe=CDo`000?oMgMgoo?cloo_knolW9bOoZ:RXooWinOn[Zj_o
eMGEoo7alOmDE5CoGUiNooWinOodm?CoU9BDo`D51Om0@43odM7AooOgmooh
n?SoUiNGob/[:`02oo[jnP0Kob@T9?l71`Oob<S8oo_knon5QHGoHf=SooOg
momSHf?oEeMGooShn?oinOWo9bLWoaDE5On3Ph?oemOGod92@_mSHf?ono_k
oo[jn_ld=3CoBDU9om_KfooUiNGoCdm?oaLG5oojn_[oo?cl0?oooOgm7?om
oOd00oolo?cooOgmooclo003oogmo@0003[ooOgmoo[jn_oclo?ok^k^oo3`
l?o_knook^k^onWYjOoCdm?oFadMoj8d=?nc9aco`CX]olM9??o?ET[od5M;
om1GB_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knoo
l?3_onk^k_oZj^[odm?Coh`U7Oo8LCCofH@MonBD5OoWWBCokZPcoo2Z=?o_
ZS?ok:0UonNG5OoLR1gob74doh`U7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`
l?o^k^koj^[Yom?CdolM>1go=88dodNE7OmJYA_oJJdZ0_md^3P0h_me^CSo
Jk4[oe^W7?m8VQgo=88doadh7OoCdm?oj^[Yonk^k_o`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?02
ono_k`1>on[Zj_mnOWko71`LonSXioo]kNgoR8R8oc0`<?l?3`oo<C4aok6a
/Oo^k^koQHF4ode=COo_knook^k^ono_kon:RX[oFEUIonk^k_mhN7So:b/[
o`l?3olh>3So_knoong]kOoTi>Co3Ph>ofUYJOoOgmoohn?SonGUiOo[jn_o
HF5QogMgMoo^k^kokno^ogIfM_lV9RKokNg]ono_koo<c<co;2`/on[Zj_m]
KFcoHV9Ronc/k?o]kNgo>c/koi>CTomRHV;o3Ph>oc@d=?o4a<Cokno_onk^
k_oAdM7o?3`lo`X:2_lW9bOoK6a/ob`/;?o_knook^k^oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`0oo_knl0ooo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3ok^k^oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l0001Oo_
knool?3`ono_koo`l>ookno_00;ol?3`1_o_knl1oo?cl`7onOWi0Oono_h0
0003ookno_ogmoOol?3`00CojNWY017oinOWom_KfomSBd_oPC8bojHe=Onf
=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mSBd_ofm_KonOW
i`05onWYj@0AonOWiooKfm_oRD];ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0d
on2P<_oOVRkoeX/]olYe=On_Bc;oRD];om_KfooWinL01OoYjNT04OoWinOo
fm_Kod];BolbH3;o>XTeoe>K;Om[ZbooL:dhofn^>_m`[CSoJZX_oe>K;Oli
R3Go<V0bod];BooKfm_oinOW0=_ojNWY00Koj>SXonKVi_mkNg_o71`LonCT
i?oXj>P2onWYj@03onOWiooYjNWojNWY00_ojNWY00coinOWonWYjOoYjNWo
j>SXomSHf?l:2P[o[Zj^omgMgOoNg]koh>3PonGUiOoXj>P8onWYj@06onSX
j?oVi^Kohn?Son?ShooVi^Koj>SX0ooYjNT00ooXj>SojNWYonWYj@04onWY
j@03onOWiooYjNWojNWY0?oojNWY6ooYjNT00ooXj>SojNWYonWYj@04onWY
j@7ol?3`0Oofm_H1ooknoP0000Goo_knoo[jn_odm?Cokno_oo7al@02oo3`
l00Aono_koo[jn_oUIBDodlS8onEE5Co^g=com>EUOoJW9cofYjLomVLW?oD
UIGo^g=coiEDE?m?8b?oUIBDon[Zj_o_knl01Oo`l?004Oo_knooj^[ZojVD
U?n18b?o^VYDomBJLooT_9Goj/NLonW7W?oZaicoiKbEomBJLonkJUCoPB<S
ojZDU?oZj^[okno_00Gol?3`017okno_on[Zj_nDU9Co8bXSoeAjE?mcYG?o
W/JEojc>W?n]cYco[<jLoik6UOmcYG?oE7YDob<Z8onDU9Coj^[Zono_k`3K
oo3`l0;okno_00CoP820oadM7Oo^k^kokno_4oo`l?02ono_k`07ofATI?lY
:BWoPH61of=SHolk>c_ok^k^ono_k`08oo3`l006ono_koo^k^koLg=cofUY
JOo^k^kokno_ooo`l?0]oo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn0000
1?o/k_3oooooooooooono_h2ooooo`;oo_kn0?oooOgmooShn?m^KVkoFSlo
ok6@T?oNbLWol>CToo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?co
ooooookno_ooooooo_knooooo_ono_koooooooclo?ohn?SoSFe]ohXo?oo9
TI3ojM39ooCYi?ofjnKom>WTonW@bOo9TI3oRCloohe]KOohn?Ooo?cloooo
ooono_koooooookno_ooooooo_knooooo_olo?con?Shofe]KOlo?cooT9f@
olWEbOoTk>Coi^kVonC/i?o9eLWoT9f@oclo?om]KFgon?Shooclo?ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_h003Soooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_kooooooogmoOo@d=3oYJFUooknoOon
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooooOgm
ol71`?maLG7oPH61ojn_[`;oo_kn00coooooookno_ooookoo_knooooooon
o_koooooookno_oooooooOgmol;2`Onl_;`2ooknoP3oooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_kooooo000Yookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_h00_ooool00oono_koooooooooo`03ooooo`7onO[k00001?o0algo
o_knoo[jn_odm?@5oo7al@0=ono_kooFe]KoJf][od<m?OnKS8coa[ZjomK<
c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7al@0=ono_kooGe]KoPf][
og@m?OneS8coeKZjon7<c?oF^[[o]Xb<og8m?On1Jf_oemKFono_k`09oo7a
l@0=ono_kooFe]KoJf][ocdm?On<S8co^[Zjolc=c?nj^[[oS8b<ocdm?Om[
Jf_oe]KFono_k`3ooo7alAcolO7a00?ol?3`oo7alOoalO40oooalO4Eoo7a
l@04oo3`l?oalO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_ono_h00Oo[kNh0
0005oh>?VOomoOgon?Shoo3`l?o[jn/00ooZj^X03OoYjNWoj^[ZonWYjOoX
j>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT02ooZj^X0
2ooYjNWoj>SXoj2KVomZFEWo@bHVobd92Om29RKoJEUIoj2KVooXj>SojNWY
00_oj^[Z00_ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_o
j>SXonWYj@3oon[ZjQcoj^[Z00?ojNWYon[Zj_oZj^X0oooZj^XMon[ZjP04
on_[joo`l?3on?Shoogmo@7odMGG00001?lfAU3o^;o5oo[jn_odm?@8oo7a
l@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`
l0?okno_0_o`l?3ooo7alB3olO7a00?ol?3`oo7alOoalO40oooalO4Goo7a
l@03oo3`l?oalO7olO7a00;olO7a00?omOGeooWinOo/kNl00OnRYJP00003
oad_?Om=F6?o^Ko60?oooooooooooomlooooo`7okNo`0On]/;<1ojFY[@00
00Ko7Rlmoa/X=?lb?TSoOHRAokg3aoo[k>koooooooooooooM_ooool01OoZ
k>go^ko2ogZ1Qol[=Cgo4R0Z007o52<_0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(txtP = NewJTextPane[pane]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JTextPane"] \[RightGuillemet]\),
      JLink`Objects`JavaObject67113796501505]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(\(centerAlign = 
      JavaNew["\<javax.swing.text.SimpleAttributeSet\>"]\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(\(LoadJavaClass["\<javax.swing.text.StyleConstants\>"];\)\), "\
\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]\(javax`swing`text`StyleConstants`\
setAlignment[\[IndentingNewLine]centerAlign, \
\[IndentingNewLine]javax`swing`text`StyleConstants`ALIGNUCENTER\
\[IndentingNewLine]];\)\[IndentingNewLine]]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.text.SimpleAttributeSet"] \[RightGuillemet]\),
      JLink`Objects`JavaObject1]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(\(charStyle1 = 
      JavaNew["\<javax.swing.text.SimpleAttributeSet\>"]\)\(\
\[IndentingNewLine]\)
    \)\), "\n", 
    \(JavaBlock[\[IndentingNewLine]javax`swing`text`StyleConstants`\
setFontFamily[\[IndentingNewLine]charStyle1, \[IndentingNewLine]"\<Serif\>"\
\[IndentingNewLine]]; \
\[IndentingNewLine]javax`swing`text`StyleConstants`setFontSize[\
\[IndentingNewLine]charStyle1, \[IndentingNewLine]75\[IndentingNewLine]];\
\[IndentingNewLine]]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.text.SimpleAttributeSet"] \[RightGuillemet]\),
      JLink`Objects`JavaObject2]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(\(charStyle2 = 
      JavaNew["\<javax.swing.text.SimpleAttributeSet\>"]\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]javax`swing`text`StyleConstants`\
setFontSize[\[IndentingNewLine]charStyle2, \[IndentingNewLine]35\
\[IndentingNewLine]]; \
\[IndentingNewLine]javax`swing`text`StyleConstants`setUnderline[\
\[IndentingNewLine]charStyle2, \[IndentingNewLine]True\[IndentingNewLine]]; \
\[IndentingNewLine]LoadJavaClass["\<java.awt.Color\>"]; \
\[IndentingNewLine]javax`swing`text`StyleConstants`setForeground[\
\[IndentingNewLine]charStyle2, \[IndentingNewLine]java`awt`Color`red\
\[IndentingNewLine]]; \
\[IndentingNewLine]javax`swing`text`StyleConstants`setBold[\[IndentingNewLine]\
charStyle2, \[IndentingNewLine]True\[IndentingNewLine]]; \
\[IndentingNewLine]javax`swing`text`StyleConstants`setItalic[\
\[IndentingNewLine]charStyle2, \[IndentingNewLine]True\[IndentingNewLine]];\
\[IndentingNewLine]]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.text.SimpleAttributeSet"] \[RightGuillemet]\),
      JLink`Objects`JavaObject3]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(\(charStyle3 = 
      JavaNew["\<javax.swing.text.SimpleAttributeSet\>"]\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]\(javax`swing`text`StyleConstants`\
setFontSize[\[IndentingNewLine]charStyle3, \[IndentingNewLine]20\
\[IndentingNewLine]];\)\[IndentingNewLine]]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.text.SimpleAttributeSet"] \[RightGuillemet]\),
      JLink`Objects`JavaObject4]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(contentModel = txtP@getDocument[]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.text.DefaultStyledDocument"] \[RightGuillemet]\),
      JLink`Objects`JavaObject94604489654273]], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[BoxData[
    \(txtP@setCaretPosition[contentModel@getLength[]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(icon = 
      JavaNew["\<javax.swing.ImageIcon\>", 
        StringJoin[$JavaSwingMaterial, "\<javalogo.gif\>"]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject94297835700225]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(txtP@insertIcon[icon]\)], "Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[BoxData[
    \(txtP@setCharacterAttributes[charStyle1, False]\)], "Input"],

Cell[BoxData[
    \(txtP@setParagraphAttributes[centerAlign, True]\)], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]\(contentModel@
          insertString[\[IndentingNewLine]contentModel@
              getLength[], \[IndentingNewLine]JavaNew["\<java.lang.String\>", \
"\<J/Link\n\>"], \[IndentingNewLine]charStyle1\[IndentingNewLine]];\)\
\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[BoxData[
    \(txtP@setCharacterAttributes[charStyle2, True]\)], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]\(contentModel@
          insertString[\[IndentingNewLine]contentModel@
              getLength[], \[IndentingNewLine]JavaNew["\<java.lang.String\>", \
"\<JFC Swing is available from Mathematica!\n\>"], \
\[IndentingNewLine]charStyle2\[IndentingNewLine]];\)\[IndentingNewLine]]\)], \
"Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[BoxData[
    \(txtP@setCharacterAttributes[charStyle3, True]\)], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]\(contentModel@
          insertString[\[IndentingNewLine]contentModel@
              getLength[], \[IndentingNewLine]JavaNew["\<java.lang.String\>", \
"\<Great:-)\n\>"], \[IndentingNewLine]charStyle3\[IndentingNewLine]];\)\
\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(pane@remove[txtP]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(scrl = NewJScrollPane[pane, txtP]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JScrollPane"] \[RightGuillemet]\),
      JLink`Objects`JavaObject80781003194369]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(ReleaseObject[icon]\), "\n", 
    \(ReleaseObject[contentModel]\), "\n", 
    \(ReleaseObject[charStyle3]\), "\n", 
    \(ReleaseObject[charStyle2]\), "\n", 
    \(ReleaseObject[charStyle1]\), "\n", 
    \(ReleaseObject[centerAlign]\)}], "Input"],

Cell[BoxData[
    \(DeleteJObject[pane, txtP]\)], "Input"],

Cell[BoxData[{
    \(scrl@removeAll[]\), "\n", 
    \(DeleteJObject[pane, scrl]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JScrollBar <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000005R<2hb>3HR<2hR<2hc<c<
0?ooooooooooNOooo`:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVK<
c<coIVIVofIVIWMVIVH01?ooohS0^8S0^4R@R04000000006R<2hb>3HR<2h
R<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoooooc<c<>lc<c080003oc<c<>Lc<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c3[<c<`40000olc<c3S<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_oo
ooo<c<`ic<c<1P000?o<c<`gc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoooooc<c<><c<c0P0003oc<c<=/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP3oooooooooogOoool01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI/c<c?mVIVKoIVIVMfIVIP04ooooR<2hR<2hB9280@000000
00J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
IYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
VIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJI
VIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVI
VOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVI
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
IYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
VIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJI
VIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVI
VOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVI
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
IYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
VIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJI
VIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVI
VOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVI
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
IYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
VIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJI
VIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVI
VOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVI
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
IYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
VIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJI
VIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVI
VOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVI
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
IYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
VIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJI
VIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVI
VOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVI
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP3oVIVIoiVIVGRIVIT01?ooohS0^8S0^4R@R04000000004R<2hb>3HR<2h
R<2hofIVVOmVIYUiIVJI00Cooon8`;R8`;Q8T8P1000000001XS0^<SPf8S0
^8S0^6IVVLc<oonIVLcoVIW<MYVIc005IVJIooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVJIc<cooiVIc?nIVLafVIW<00EVIYWooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIYW<c?ooVIW<oiVIc7JIVL`0
1FIVVOooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVVLc<o`:I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`016IVVIVIc6IVVOooo`:8`;P1B9280@00000000R8`;S8h=R8
`;R8`;QVIYW<c?nIVLc<c?l3VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`02VIW<00EVIYWooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIYW<c?l4VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYWooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIYW<c?l3VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`04VIW<
00EVIYWooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIYW<c?l2
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00AVIYVIVLaVIYWoool2R<2h0DR@R04000000008R<2hb>3H
R<2hR<2hIVJIc<coVIW<c<co0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00YVIc005IVJIooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVJIc<co19VIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVJIc<co0iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l019VI
c005IVJIooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVJIc<co
0YVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc004IVJIVIW<IVJIoooo0XS0^058T8P10000000028S0^<SP
f8S0^8S0^6IVVLc<oiVIc<c<o`>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00:IVL`01FIVVOooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVVLc<o`BIVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVOoo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVVLc<o`>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00BI
VL`01FIVVOooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVVLc<
o`:IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`016IVVIVIc6IVVOooo`:8`;P1B9280@00000000R8`;S8
h=R8`;R8`;QVIYW<c?nIVLc<c?l3VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`02VIW<00EVIYWooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIYW<c?l4VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYWo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIYW<c?l3VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`04
VIW<00EVIYWooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIYW<
c?l2VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00AVIYVIVLaVIYWoool2R<2h0DR@R04000000008R<2h
b>3HR<2hR<2hIVJIc<coVIW<c<co0iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00YVIc005IVJIooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVJIc<co19VIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVJIc<co0iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
19VIc005IVJIooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVJI
c<co0YVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc004IVJIVIW<IVJIoooo0XS0^058T8P10000000028S0
^<SPf8S0^8S0^6IVVLc<oiVIc<c<o`>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00:IVL`01FIVVOooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVVLc<o`BIVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VOooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVVLc<o`>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00BIVL`01FIVVOooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
VLc<o`:IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`016IVVIVIc6IVVOooo`:8`;P1B9280@00000000R8
`;S8h=R8`;R8`;QVIYW<c?nIVLc<c?l3VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`02VIW<00EVIYWooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIYW<c?l4VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYWooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIYW<c?l3VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`04VIW<00EVIYWooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IYW<c?l2VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00AVIYVIVLaVIYWoool2R<2h0DR@R04000000008
R<2hb>3HR<2hR<2hIVJIc<coVIW<c<co0iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00YVIc005IVJIooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVJIc<co19VIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVJIc<co0iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l019VIc005IVJIooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVJIc<co0YVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVI
c9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<
VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbI
VLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VI
c6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<
IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03
VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>I
VL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<
00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005IVJI
VIW<VIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EVIYVI
VLbIVLbIVLaVIYT00iVIc004IVJIVIW<IVJIoooo0XS0^058T8P100000000
28S0^<SPf8S0^8S0^6IVVLc<oiVIc<c<o`>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VI
c9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbI
VLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<
c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<
c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<
o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co
00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>I
VL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVI
c005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
1Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005
c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<
c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<
oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nI
VLbIVLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00>IVL`01Lc<oiVI
c9VIc9VIc<c<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00G<c?nIVLbI
VLbIVLc<c?l00iVIc005c<coVIW<VIW<VIW<c<co00:IVL`01FIVVOooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVVLc<oonIVLcoVIW<MYVI
c005IVJIooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVJIc<co
oiVIc?nIVLafVIW<00EVIYWooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIYT0olc<ooo<c?mgc<co00EVIYWooon8`;R8`;Q8T8P00@000000
00B8`;S8h=R8`;R8`;SoIVJIofIVVGUVIYT01?ooohS0^8S0^4R@R0400000
0006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
IYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
VIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJI
VIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVI
VOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVI
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWo
c<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<
c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<
c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<
olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<co
c<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<
c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<
c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
IYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
VIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<af
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJI
VIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVI
VOo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVVIVIolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIVI
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVJIVIWoc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVIYVIVOo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?nIVIWoVIVIMiVIV@05
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVc<c<ofIV
I_mVIVIgIVIV00Cooon8`;R8`;Q8T8P1000000001XS0^<SPf8S0^8S0^6IV
I_ooooo<c<coc<c<M/c<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<
M/c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
ooooolc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoooooc<c<><c<c0P0003oc<c<=/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c3W<c<`60000
olc<c3O<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooooo<c<`jc<c<10000?o<c<`hc<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoooooc<c<>lc<c080003oc<c<>Lc<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
olc<c?o<c<afc<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoooooc<c<olc<c7K<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooooo<c<coc<c<M/c<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVooooolc<c?o<c<afc<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooo
oooooomgoooo00G<c<cooon8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8
`;SoIVIVofIVIWUVIVH01<c<c8S0^8S0^4R@R04000000003R<2hb>3HR<2h
0?n8`;SoR<2hOHS0^058T8P10000000018S0^<SPf8S0^8S0^1H008030060
0P02P00400:100>100>100>10`04P@801H401005PP06PP06PP06PP801h80
0`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<1
3XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:
0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DV
S@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@
0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i82
1SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7
>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL2
24>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ
0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]B
W@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO
0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R
362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=
IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL3
3VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o
[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_
1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=
/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B
]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g
59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i
0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdF
ZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl0
0aNb_`<G/klf6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0@00800
0i^WlC=3YC=3Y@09<d>U1P00P0<00H0200:000@00X400h400h400h4300B1
0P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V30`4:
P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>6
00@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV8
0aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@4
8h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh0
0`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A
0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`Lf
T`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF
0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP0
0`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:
Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh3
2eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aM
X@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeR
X`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V
0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP3
3g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@
Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P03
4H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4B
R[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb
008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne
11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh
5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<F
Yk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG
[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0`00P007VjOaooooSWZfYY_4/jWBZ9g8/jWB
00:VVl@01KbhgNk^m>[YlOoooc=3Y@0500200`01P0800X001002P@03P@03
P@03P@<0184200F100@01H801X801X801X8200N200<11h81288128800P48
P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q66
0`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP3
0aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<4
8H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP03
1BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46
<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB
0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE
10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH
2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:
CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;
E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX004
35bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeR
XPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU
0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0ma
Z0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@
NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]
4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08B
RK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<C
S[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe
0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@E
WKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<F
YKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd0
0aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`200
00026;C04000008H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00
P004VjOaooooK5ZU[jG:0[bhg@0:oogo/jWBoooooooo_;SMUhZlZ9g8i^K/
oooo<d>U1000P0<00H0200:000@00X400h400h400h4300B10P05P@0400F2
00J200J200J20P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^4
0@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L2
58L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@3
6XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@T
S@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZ
S`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y40
10HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`Lh
T`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G
246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6
V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:
DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;
Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ42
35nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS
00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH0
10i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?
LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m
[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P03
4HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[43
4X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c
0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH2
59Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^003
5J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY
_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G
/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf4R@R4R@R00<B92800<0
0038h=Q8T8P03DR@R00400006;C06;C0b>3H3TR@R00300006;C06;C000:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000^KYo7ooonXWLSooonc
ZM9PC9Z>N[IhIJjXWLSooooooOl00oooo`03<d>U0020002000<008030060
0P02P00400:100>100>100>10`04P@801H401005PP06PP06PP06PP801h80
0`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<1
3XD30Pn50P8@Q@?oool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL2
0QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:
0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDU
S@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?
0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B
1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7
>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL3
24:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI
0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YB
W@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO
10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaP
XPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eU
Y0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW
3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY
0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@
OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l0
0a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@B
S;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<C
T[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK
]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T0
11FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l
5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o
5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf00=
R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0^058
T8P10000000018S0^<SPf8S0^8S0^08008003Y^WlOooooooom_Lk61<VY>5
^[>Yd[bhgF1<VYV?_ZJKa<S3gooooc=3Y@H00803oooo0P02P00300:1oooo
oooo00;oool200B100<01H7oool01H800`06PPCoool00`48PP48Poooo`03
oooo0`4:P`06oooo0@^40@^40@b4oooo0@b40P4=Q004oooo0@j5oooo0@j5
0P8?Q@04oooo0Q25oooo0Q250P8AQP03oooo0Q660Q:600824XH20Q>600@2
4hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV9
0aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`0
10@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZ
SPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`Ha
T@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7
=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0
UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6
V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`4
2U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN
00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aM
X@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=
Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/
YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X
00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/3
47b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^
0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4B
R[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008C
Sk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH
]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh
0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/3
5ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<001<SPf8S0^8S0^8S0
^0H00004R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H
]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0<008003Y^WlOoookbhgIV?__ooomKAgM_Lk??nojJKa>k^m8Ef
/9>5^_oooc=3Y@@008001oooo`01P001P001P?ooo`02P?ooo`0300>100Ko
ool0184018401H7oool01H8200J200Soool01h801h811h;oool128;oool1
28<30@V300Coool12X<12X?oool20@^400<138Coool138@00P4=Q004oooo
0@j5oooo0@j50P8?Q@03oooo0Q25oooo00?oool20Q660`8BQP824hH0108C
Q`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT3
6HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS004
12B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>
1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A
0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`Lg
T`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F
00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH
2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:
D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh0
0`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ
0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eS
X`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP0
0`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@
O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh3
4H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::
/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?
/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf
0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P3
5Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<F
Z;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P03
5jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`004b>3HR<2hR<2hR<2h
1P0000B8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000
R<2hR<2hB9280000008H]<001<SPf8S0^8S0^8S0^0800004R<2h0P0000:8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3
002000nKYo7ooonISkjGR[cDdnS_[;?oMW_^Wj]KF:FVVlBFWm9PC9Zl^=go
oolc@jD00`00P007oooo006000600060oooo00:0oooo00<00h401_ooo`04
P@04POooo`05POooo`801X802?ooo`07PP07PP47P_ooo`48P_ooo`48P`<1
2H<02Oooo`4:Poooo`4;Poooo`4;Q?ooo`4<Q?ooo`020@f400Coool13XGo
ool13XD20Pn500Coool248Goool248D40Q660`8BQP824hH0108CQ`8DQ`8D
Q`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<J
R@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=
12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?
00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@04
1S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC
1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8
@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI
00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YA
W0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]G
W`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<
Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<0
0`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP04
3VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mc
Z@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/
00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<A
Q:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<B
Rk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<3
4i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8D
V[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<E
X;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl
11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`
_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@
R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000
008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0^004B9280000
6;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008002Y^WlOoo
oiN:_7Y/Z[?7j:U^X<S3gi>5^U]6TiV?_P9hIJh0148WQJnUb_oooc=3Y@@0
0803006000?oool00X000X401?ooo`8018400oooo`05POooo`0300J21?oo
o`030@R20@R30@R300<12H<02Oooo`4:Poooo`4;Poooo`4;Q?ooo`4<Q?oo
o`020@f400Coool13XGoool13XD20Pn500?oool248Goool00oooo`824HH3
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8
h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h
00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8`;P4000018S0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08000i^WlOooooooo`02oooo00[o[K3oMW_icMCmkNkooonVVlB5M[2l^=go
oolc@jD500200`01P003oooo00:000:100<00h400oooo`04POooo`0200F1
00@01H;oool01X801X8200N200<11h;oool128800P48P`?oool20@Z300Oo
ool12h?oool12hCoool138Coool00P4=Q004oooo0@j5oooooooo0P8?Q@06
oooo0Q25oooo0Q250Q66oooo0P8AQP<24XH20Q>600@24hL258L258L258L3
0QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^9
0`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@U
S@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?
10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHc
TPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0Lh
U0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G
246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI
0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:
DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil0
0`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<
Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=
IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^
Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT0
10mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/
47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_
4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:<
/@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`03
4i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@D
V[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i
5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`0
11J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa
_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038
h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C0
00?8h=R8`;R8`;P018S0^0800005R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0`00P00:XJcbnLgDhRHlm;FohRHlm6em
o>?YoooooNg^ojf`0_ooo`03<d>U0020002000@00803006000?oool00X00
0X400oooo`8018401Oooo`05P@05P@05P_ooo`0200J20oooo`8128800`48
Poooo`49P`020@V30P4:P`04oooo0@^30@^4oooo0P4<Q007oooo0@f40@f4
oooo0@j5oooo0@j500;oool00`8?Q@8@Q@8@Q@04oooo00@24HH24XH24XH2
4XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<H
R0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;
0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DX
SP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A
1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP02
1cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8
?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4
V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK
0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN
00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aL
X@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=
HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>
JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?
LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[
0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61
[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`
00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb
4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<D
U[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh
5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj
0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G
[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSP
f8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P0
1@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00hS0^0@00004R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00
P00=VjOaoNg^hRHlo_GhmhVGm69^lj2^m69^oogoojf`o>?Yoooo<d>U00L0
0803006000?oool00X000X400`03P@<0184200F100@01H801X801X801X82
00N200D11h81288128;oool128<00`49P`<12X<00`4;P`4;Q04;Q0030@b4
0`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8E
Q`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<3
78X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd2
1BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5
;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86
<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@0
0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1
U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9
B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M
2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;
F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR
362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT
3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>
KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?
M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n
[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64
[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;40
11:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B
/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg
59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP
^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@F
Zk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG
/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H
00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003
b>3HR<2hR<2h00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOam/S<hRHl00;o
[K001mlT;_nTW_JlaOn]/>ikS?oooc=3Y@0800200`01P003oooo00:000:1
00<00h4300B10P05P@0400F200J200J200J20P07PP050@N20@R20@R2oooo
0@R300<12H<01?ooo`4:P`4:P`4;P`812h@30@b40`4=Q0<13XD30Pn50`8@
Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<G
R0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3
122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>
1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i00
10H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987
=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`Pl
U@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9
A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX3
2TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]D
W@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj02
35bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP03
3F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eX
Y@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`04
3g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX3
47RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]
00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk03
4XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8B
S[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D
]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8D
WKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX3
5JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm
0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl2
6;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P900000XS0^005
B92800006;C06;C0b>3H00>8`;P2000018S0^0800002R<2h00A8T8P0000H
]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOanLgD
mhVG00;oool01on]/>4F=?mfNonTW^8V??n9Oc=3Y@0800200`01P003oooo
00:000:100<00h4300B10P05P@0400F200J200J200J20P07PP040@N20@R2
0@R20@R31?ooo`<12X<00`4;P`4;Q04;Q0030@b40P4=Q004oooo0@j50@j5
0@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ7
00@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<M
RP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<5
9Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]
T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B
0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@3
1cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G
0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9
VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;
DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]I
W`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaP
XPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY003
3FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW
0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`me
Z@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@
Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65
[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8B
SK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@C
T[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK
]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ
^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m
5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o
00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h
2@0000:8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P007VjOaoooolj2^m69^
oooomhVGnLgD00;oool00o>P[_oooc=3Y@0800200`01P0800X001002P@03
P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h8128812880
0P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D4
0Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP3
5hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@P
R`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDW
SP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6
;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB
1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D3
23fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH
2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<
V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;
E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaL
X00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQ
XPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D3
3VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`
Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1h
ZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@03
4H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8
/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb
00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@3
4iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg
00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT
^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G
[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd
`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf00=R<2h00E8T8P0000H]<0H
]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0<008002i^WlOoooon9Oooooo>P[_6CXOooooomoo>P[_oko3=3
Y@0800200`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X80
1X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@0
0`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<3
6hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=
12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5
:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9
AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YA
W@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]G
W`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW
3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mc
Z@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@
OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hA
Q:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H0
11BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ
_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P03
5k6n5k6o5k6o00<G/[l35k>o0QRd`0o8h=P00`000<SPf<SPf00=b>3H00<0
000H]<0H]<003lSPf00300006;C06;C000:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P400200i^Wl@06oooolj2^m;Fom[c5nmWJ<d>U2@00P0<00H02
00:000@00X400h400h400h4300B10P05P@0400F200J200J200J20P07PP03
0@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>
Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`04
0aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX3
11j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=
00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I03
1Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86
=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`Lj
U0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88
@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX3
2DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M
0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl3
35ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<
H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eV
Y0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>
KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT3
3gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]
0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl4
4HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb
4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d
00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLD
VkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT3
5J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[
_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`03
5k:o0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h5P00P0<0
0H0200:000@00X400h400h400h4300B10P05P@0400F200J200J200J20P07
PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f4
0`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8F
Q`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<3
7HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd3
1BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6
;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHc
TP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9
BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd2
2e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;
FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<
H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]
47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<A
QJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d
4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLD
VkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[
_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_cHH]<02R<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;So
R<2hOHS0^058T8P1000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B928
0@00000000>8`;S8h=S8h=P0olSPf?o8h=Qmb>3H0DR@R04000000?n8`;So
R<2hPHS0^04000000001\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:30001hR000`400?l0
0000o`00003oooo`l?3ooo3`l8Gol?3`003ooo3`l?ool?3`QOo`l?000?oo
l?3`ooo`l?25oo3`l000ooo`l?3ooo3`l8Gol?3`003ooo3`l?ool?3`QOo`
l?000?ool?3`ooo`l?25oo3`l000ooo`l?3ooo3`l8Gol?3`003ooo3`l?oo
l?3`QOo`l?000?ool?3`ooo`l?25oo3`l000ooo`l?3ooo3`l8Gol?3`003o
oo3`l?ool?3`QOo`l?000?ool?3`ooo`l?25oo3`l000ooo`l?3ooo3`l8Go
l?3`003ooo3`l?ool?3`QOo`l?000?ool?3`ooo`l?25oo3`l00000oo[jn_
ojZZZ_nl_;co/k>cojj^[_n_[joo]kNgokfm_Oo2`/;ob<S8olk>c_oCdm?o
e]KFom?Cdoo:b/X0ooooooooooooogKooooo00003onc/k?oc/k>ono_kooa
lO7ojn_[omoOgooEeMGoemOGomgMgOoTi>Coj^[Zoo3`l?oclo?ol?3`onGU
i@3oonk^k_ook^k^M_o^k^h0000?okJf]_o@d=3olO7aooOgmoohn?SomoOg
onSXj?oLg=coh^;RonKVi_o^k^kom?CdooOgmoodm?Coj>SX0?ooi^KVoooV
i^IfonKViP0000oo]kNgom3@d?oalO7omoOgooWinOojn_[omOGeomgMgOoT
i>Coj^[Zoo7alOohn?Son_[jooKfm_o[jn/0ooo^k^koonk^kWKok^k^0000
1Onj^[[odM7Aoo;bl_ohn?SonOWi00;on_[j00SogmoOonKVi_o[jn_ol_;b
ooWinOolo?con?Shong]kOoooooooooooomfooooo`0000oo^[Zjom7AdOob
l_;omoOgooWinOojn_[ono_kojb/[?oWinOokNg]ooCdm?ojn_[ooOgmooWi
nOo_knl0ooo^k^koonk^kWKok^k^00003onj^[[odM7Aoo;bl_ohn?SonOWi
oo[jn_oEeMGo@d=3ol71`Oo/k>com_Kfoo_knoono_kon_[jono_k`3oonKV
i_ooi^KVM_oVi^H0000?okZj^_o@d=3ol_;booShn?oinOWon_[jog5aLOm3
@d?oIFEUonWYjOoemOGono_koogmoOojn_[okno_0?ook^k^ooo^k^ifonk^
kP0000oo_;blom;Bd_obl_;on?ShooWinOng]kOoBd];od=3@om5ADGoZj^[
ooCdm?okno_oo_knoo[jn_o_knl0ooooooooooooogKooooo00003onk^k_o
dM7Aoo;bl_ohn?Sokno_oeiNG_m:BT[o@d=3odE5AOmCDe?oj>SXooclo?on
o_kon_[jono_k`3oonk^k_ook^k^M_o^k^h0000?ok^k^ooBd];ol_;booSh
n?nPX:3oBd];odY:B_m3@d?oADE5odM7AonATI7ono_kookno_ojn_[okno_
0?ooi^KVoooVi^IfonKViP0000oo^k^kom;Bd_oclo?on?ShooWinOojn_[o
m_Kfon7QhOoXj>SokNg]ooCdm?olo?coo_knoo[jn_o_knl0ooo^k^koonk^
kWKok^k^00003onk^k_od];Boo?cloohn?SonOWioo[jn_ofm_KohN7QonSX
j?o]kNgom?Cdooclo?ono_kon_[jono_k`3oooooooooooooM_ooool0000?
ok^k^ooBd];olo?cooShn?oinOWon_[jooKfm_oQhN7oj>SXong]kOodm?Co
o?clookno_ojn_[okno_0?ook^k^ooo^k^ifonk^kP0000oo^k^kom;Bd_oc
lo?on?ShooWinOojn_[om_Kfon7QhOoXj>SokNg]ooCdm?olo?coo_knoo[j
n_o_knl0oooVi^KoonKViWKoi^KV00003onk^k_od];Boo?cloohn?SonOWi
oo[jn_ofm_KohN7QonSXj?o]kNgom?Cdooclo?ono_kon_[jono_k`3oonk^
k_ook^k^M_o^k^h0000=ojFUYOn`/;3o_knookNg]onb/[;o[jn_ojf][OnN
WYkoY:BTojZZZ_ne]KGoa<C4olo?c`02om_Kfooooooooooooomfooooo`00
00oo^k^kom;Bd_oclo?on?ShooWinOojn_[om_Kfon7QhOoXj>SokNg]ooCd
m?olo?coo_knoo[jn_o_knl0ooo^k^koonk^kWKok^k^00003onk^k_od];B
oo?cloohn?SonOWioo[jn_ofm_KohN7QonSXj?o]kNgom?Cdooclo?ono_ko
n_[jono_k`3oonKVi_ooi^KVM_oVi^H0000?ok^k^ooBd];olo?cooShn?oi
nOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?clookno_ojn_[okno_0?oo
k^k^ooo^k^ifonk^kP0000oo^k^kom;Bd_oclo?on?ShooWinOojn_[om_Kf
on7QhOoXj>SokNg]ooCdm?olo?coo_knoo[jn_o_knl0ooooooooooooogKo
oooo00003onk^k_od];Boo?cloohn?SonOWioo[jn_ofm_KohN7QonSXj?o]
kNgom?Cdooclo?ono_kon_[jono_k`3oonk^k_ook^k^M_o^k^h0000?ok^k
^ooBd];ol_;booShn?nPX:3oBd];odY:B_m3@d?oADE5odM7AonATI7ono_k
ookno_ojn_[okno_0?ooi^KVoooVi^IfonKViP0000oo^k^kom7AdOobl_;o
n?Shono_komNGUkoBTY:od=3@om5ADGoDe=ConSXj?olo?coo_knoo[jn_o_
knl0ooo^k^koonk^kWKok^k^00003onl_;cod];Boo;bl_ohn?SonOWiokNg
]om;Bd_o@d=3odE5AOn[Zj_om?Cdoo_knoono_kon_[jono_k`3ooooooooo
ooooM_ooool0000?okZj^_o@d=3ol_;booShn?oinOWon_[jog5aLOm3@d?o
IFEUonWYjOoemOGono_koogmoOojn_[okno_0?ook^k^ooo^k^ifonk^kP00
00oo^[Zjom7AdOobl_;on?ShooWinOojn_[oeMGEod=3@oo1`L7ok>c/ooKf
m_okno_oo_knoo[jn_o_knl0oooVi^KoonKViWKoi^KV00003onj^[[odM7A
oo;bl_ogmoOonOWioo[jn_okno_o[:b/onOWioo]kNgom?Cdoo[jn_omoOgo
nOWiono_k`3oonk^k_ook^k^M_o^k^h0000?ok^k^ooDe=Colo?cooShn?oi
nOWon_[jooCdm?oQhN7oinOWong]kOoemOGono_kookno_ojn_[okno_0?oo
oooooooooomfooooo`0000oo^k^kom?Cdoobl_;on?ShooWinOohn?Sojn_[
on7QhOoXj>Sokno_ooKfm_okno_ooOgmoo[jn_o_knl0ooo^k^koonk^kWKo
k^k^00003onk^k_od];Boo;bl_ogmoOom_Kfon[Zj_oLg=cohN7QonSXj?o^
k^komOGeoo_knoono_kon_[jono_k`3oonKVi_ooi^KVM_oVi^H0000?okZj
^_oAdM7ol_;boo;bl_oNg]kodm?ComWIfOoQhN7oinOWong]kOoemOGono_k
ookno_ojn_[okno_0?ook^k^ooo^k^ifonk^kP0000oo_;blom?Cdoo^k^ko
d];BojVYZOnKVi_oTY:BohV9ROnCTi?oYJFUolC4a?oclo?oo_knoo[jn_o_
knl0ooooooooooooogKooooo00001_nj^[[odM7AolG5aOnJVY[oUYJFoj6Q
X@?oZ:RX00KoXJ6QoiNGUon][Jgoh^;Roo[jn_o_knooonk^k_ook^k^M_o^
k^h0000?ok^k^ono_kooX:2PojFUYOn_[joo^[Zjokjn__o3`l?o`/;2okbl
_?nf][Ko[Zj^ok6a/OoTi>Cokno_0?ooi^KVoooVi^IfonKViP0000oo_Kfm
ojJVY_n[Zj_o]kNgol71`Oo5aLGob/[:olk>c_oAdM7od=3@olo?coo8b<So
_;blolC4a?o]kNd0ooo^k^koonk^kWKok^k^00003oni^KWo[jn_okJf]_nn
_[koalO7olc<c?oAdM7oe]KFomSHf?oKfm_ofMWIomSHf?oBd];o`l?3omkN
gP3oooooooooooooM_ooool0000=okFe]Onf][Ko_Kfmol;2`_o9bLWod=3@
omKFe_oJf][ogmoOon?ShooRh^;ohn?SomkNgP02omSHf?ook^k^ooo^k^if
onk^kP0000[o];BdokNg]oo1`L7oalO7olo?cooEeMGofm_Kon3Ph?oUiNGo
jNWY0_oZj^X00ooWinOoh^;RomgMg@3oonKVi_ooi^KVM_oVi^H0000?okFe
]Onk^k_o`l?3ol[:b_oAdM7of=SHomoOgooTi>Coj^[Zonk^k_o`l?3olO7a
ong]kOoXj>Sohn?S0?ook^k^ooo^k^ifonk^kP0000[o^;Rhokbl_?o5aLGo
c<c<omCDe?oLg=coh^;RonWYjOo^k^kol_;b0_odm?@00ooalO7ok^k^onSX
j03oooooooooooooM_ooool0000:okRh^?nn_[koa/K6olo?cooFe]KogmoO
onGUiOo/k>colO7aooGem@;omoOg00?omOGeoo3`l?oZj^X0ooo^k^koonk^
kWKok^k^00003onh^;So_knoolK6a_o@d=3of=SHon7QhOoXj>Sok^k^oo?c
loogmoOon_[jooShn?ogmoOolo?conc/k03oonKVi_ooi^KVM_oVi^H0000:
okRh^?no_kooalO7om7AdOoIfMWoh^;RonWYjOo_knoomOGeooWin@;on_[j
00?on?Shoo?cloo]kNd0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oooooooooooooM_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^
ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?oooooooooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KV
M_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooooooooooooogKooooo00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KV
oooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oooooooooooooM_ooool0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^
M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?oooooooooooomfooooo`0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^
ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooooooooooooogKooooo
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooooooooooo
M_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oooooo
oooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooooooooooooogKooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^
M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oooooooooooooM_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^
ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?oooooooooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KV
M_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooooooooooooogKooooo00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KV
oooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oooooooooooooM_ooool0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^
M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?oooooooooooomfooooo`0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^
ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooooooooooooogKooooo
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooooooooooo
M_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oooooo
oooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooooooooooooogKooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^
M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oooooooooooooM_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^
ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?oooooooooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KV
M_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooooooooooooogKooooo00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KV
oooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oooooooooooooM_ooool0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^
M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?oooooooooooomfooooo`0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^
ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooooooooooooogKooooo
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooooooooooo
M_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oooooo
oooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooooooooooooogKooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^
M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oooooooooooooM_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^
ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?oooooooooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KV
M_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooooooooooooogKooooo00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KV
oooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oooooooooooooM_ooool0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^
M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?oooooooooooomfooooo`0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^
ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooooooooooooogKooooo
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooooooooooo
M_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oooooo
oooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooooooooooooogKooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^
M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oooooooooooooM_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^
ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?oooooooooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KV
M_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooooooooooooogKooooo00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KV
oooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oooooooooooooM_ooool0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^
M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?oooooooooooomfooooo`0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^
ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooooooooooooogKooooo
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooooooooooo
M_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oooooo
oooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooooooooooooogKooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^
M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oooooooooooooM_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^
ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?oooooooooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KV
M_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooooooooooooogKooooo00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KV
oooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oooooooooooooM_ooool0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^
M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?oooooooooooomfooooo`0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^
ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooooooooooooogKooooo
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooooooooooo
M_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oooooo
oooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooooooooooooogKooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^
M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oooooooooooooM_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^
ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?oooooooooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KV
M_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooooooooooooogKooooo00003onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KV
oooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^
00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`3oooooooooooooM_ooool0000?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^
M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_0?oooooooooooomfooooo`0000oo
^;Rhol30`?o8b<Sodm?Com_KfooShn?oj^[Zono_koodm?ConOWioo[jn_ol
o?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00002onh^;So`<30olS8
b?oAdM7oe]KFomcLg?oOgmoohn?SonSXj?o]kNgolo?c00;omoOg00?om?Cd
ono_kooVi^H0oooVi^KoonKViWGoi^KV00003_nh^;So_knoolG5aOo:b/[o
alO7ol71`Onj^[[o][JfokZj^_o6a/Koe=CDonGUiOo_knoolO7aooo^k^ko
onk^kWOok^k^00003onh^;So_Kfmokfm_OnRY[GoFW2XobIFZ_l<E;So4e^i
oc1VZomEMIgoRI6KokVi^OoGemOoinOWonc/k03oooooooooooooM_ooool0
000?okJf]_nh^;SoQXb[obe=YOl0?KSo04fmo`aJ`olKJ<So9W7<oc1icoln
KjWoKGf?ojb/[?oCdm?oiNGU0?ook^k^ooo^k^ifonk^kP0000oo];Bdoi^M
[Ol]AZ3o03Bao`17^_l6E/7o5VC7obEacOlbNm3o?8;Cod:7eOm7M:WoMGf5
ok>c/ooIfMT0oooVi^KoonKViWKoi^KV00003onb/[;oFfFRo`0XZol3?kSo
0e;0o`iOa_lNKLco;g_Bocf4f?m7SMkoD9GToe>Ghom@KXgoTi>Col[:bP3o
onk^k_ook^k^M_o^k^h0000?ojj^[_lZ>Yko2cNcodf1d?m@T=So?X;DobEa
c_lgOmGoAHcOoe>HjOmMXo7oHJOeoe>3^_miNGWo_;bl0?oooooooooooomf
ooooo`0000oo[Jf]o``RX_m4KLWoR:kSogN[hOm^YN7o:WODocb7gom<UNWo
FZ?eofNaoom_^oooHJ7/ofUYJOnc/k<0ooo^k^koonk^kWKok^k^00003on[
Zj_o01RSofb<eOn;/NCoOJgSog:WhOl[NMCo@HcSoe6Jk_mQZoooKKWoogK2
ooma^_ooH61Pojj^[P3oonKVi_ooi^KVM_oVi^H0000?oj^[Zol07jOoM9SJ
ohfeiOn1/^GoMjcUocJ3g?m:U>WoG:Gfoffdoomj`oooP/ooogg7oomLG5co
[:b/0?ook^k^ooo^k^ifonk^kP0000ooZj^[o`0SZ?meW=_oS;KUohNdiOmn
[^Go?hSNoe>Kk_mTZ_SoMKcooh?<oon>fOooQlgooeaLG?n[Zj/0oooooooo
ooooogKooooo00003on[Zj_o02Z/ogVRg?n@^^OoR[KWoh:cjOm4S^CoEYk/
ofbaooml`?ooRM3ooiCNoon>e?ooG5aLoj^[Z`3oonk^k_ook^k^M_o^k^h0
000?oj^[Zol0>K?oMZ?OoiJmjOnA^nWoRKSZodjDiOmPY>ooL[CoohC7oonC
e_ooWN7ooi?EoomLG5coZj^[0?ooi^KVoooVi^IfonKViP0000ooZj^[o`0i
/omjYmooU[gWoi6jion:^>[oD9?SofBVl?mf]_ooQlOooiCFoonRi_ooV]Wo
oeaLG?n[Zj/0ooo^k^koonk^kWKok^k^00003on[Zj_o03VcogZZh?nE_NWo
U;gZoh^ij_mCUnGoJ:[cogZjoon;c?ooV][ooj?WoonJf_ooG5aLoj^[Z`3o
ooooooooooooM_ooool0000?oj^[Zol0>K?oMJOPoiJojOnE_NWoS[_[oeNK
iom/Zo?oO;_oohg<oonKf_ooYn_ooioPoomLG5coZj^[0?ook^k^ooo^k^if
onk^kP0000ooZj^[o`0i/omfYn3oV<3YoiJoj_n=^^_oE9OVofNXl?mi^Ooo
RlgooiSIoonSioooVm_ooeaLG?n[Zj/0oooVi^KoonKViWKoi^KV00003on[
Zj_o03VcogJUg_nG_nWoTkcZoh^hj_m@Tn?oHjG_ogFeo_n8b?ooU]Wooj;T
oonJf_ooG5aLoj^[Z`3oonk^k_ook^k^M_o^k^h0000?oj^[Zol0>K?oMjCO
oiFlionA^n[oR;KZodfBhomQYO3oLkCoohC7oonAe?ooW^?ooiGHoomLG5co
Zj^[0?oooooooooooomfooooo`0000ooZj^[o`0i/omgXmkoT[_Vohjjion4
]>WoBY7SoejRk_m_/_goPLCooi3DoonJh?ooTmGooeaLG?n[Zj/0ooo^k^ko
onk^kWKok^k^00003on[Zj_o03VcogNRg_nA^nOoS;WWoh:ciom7TNCoFj;_
offbo_mm`OooR/oooiOOoon@e?ooG5aLoj^[Z`3oonKVi_ooi^KVM_oVi^H0
000?oj^[Zol0>K?oMYkLoi2ii_n:]NKoP[?Wod:;gomHWNcoJZkmog^moon8
cOooTm[oohgBoomLG5coZj^[0?ook^k^ooo^k^ifonk^kP0000ooZj^[o`0i
/omfWMcoS;SVohVfi_mo/NOo@8[Poe:Jk?mU[?_oM[cooh?=oon@foooQm3o
oeaLG?n[Zj/0ooooooooooooogKooooo00003on[Zj_o03VcogNKf_n<]^Go
Pk?Uog^]iOlkQn3oCYO[of2XnOma^oooOlSoohWEoon0b?ooG5aLoj^[Z`3o
onk^k_ook^k^M_o^k^h0000?oj^[Zol0>K?oNIkLohZfiOn8]NKoO:kVocn:
h?mCVnkoI:cmogBloon2b?ooSMSoohK<oomLG5coZj^[0?ooi^KVoooVi^If
onKViP0000ooZj^[o`0i/omfW]coT;WVohRdi_n0/NKo@X[OoeFKjomY[O_o
N[ooohO<oonCf_ooRLgooeaLG?n[Zj/0ooo^k^koonk^kWKok^k^00003on[
Zj_o03VcogJPg?nA^nOoSKWWoh:cjOm7S^7oFj3^offcoomm`?ooRm3ooiOO
oon@doooG5aLoj^[Z`3oooooooooooooM_ooool0000?oj^[Zol0>K?oMJKP
oiNojOnC_>[oS;WZoe6Gi_mTYo7oM[SoohS8oonEf?ooWnCooiSHoomLG5co
Zj^[0?ook^k^ooo^k^ifonk^kP0000ooZj^[o`0g/_meY]ooV/3Zoi:kjOn=
^^[oDYOTofFWlOmg]_koR<KooiGHoonRiOooV=KooeaLG?n[Zj/0oooVi^Ko
onKViWKoi^KV00003on[Zj_o03FbogFTgonE_NWoT;[YohNhj_m<U>GoGj?_
og6doon0`_ooTMGooiOKoon>cOooG5aLojb/[03oonk^k_ook^k^M_o^k^h0
000?oj^[Zol0=;7oJ9GIohfhi_n9]NKoOk7Wod:;h?mFWNcoJZckogNkoon6
bOooRloooh?3oomPH63o[Zj^0?oooooooooooomfooooo`0000oo[Jf]o``h
[?loL/goPJkSoh:biOmaYnCo>HCOodbDiomNY?GoKKCoogVooomm`_ooKZW]
ofUYJOnc/k<0ooo^k^koonk^kWKok^k^00003on^[Zko:TVVo`Li]?m2OM3o
C8gFocR0eOl/NmGo@8[PodjGjomLXo7oIjknofZ^nomGQ[WoNGUiokbl_03o
onKVi_ooi^KVM_oVi^H0000?ok:b/_mKK:Ko02V[o`4m]_l2DL3o3Eo7oai_
colaO]So?hWOodVCi_mBV>WoDiOSoe1^SOnCTi?ob/[:0?ook^k^ooo^k^if
onk^kP0000oo];Bdoi^N[_l]@Ioo02b]o`10^?l1DL3o45o6oam]c?l]Mm;o
=goEocf2e?m3LJSoMGf5ok>c/ooIfMT0ooooooooooooogKooooo00003onf
][Ko^;RhohJ9ZOl]AJ7o036ao`12^?l1D<3o3Ek4oaQXb?lRKl[o=FVWofYk
S_n/[:codm?ConGUi@3oonk^k_ook^k^M_o^k^h0000?okRh^?nm_Kgo_Kfm
oj:T]?mJJ:;o9TRRo`Y4/Ol8C;?o8U^Wod]^V_n7T9[o^KViomOGeooWinOo
k>c/0?ooi^KVoooVi^IfonKViP0000ko^;Rhokno_oo5aLGob/[:olO7aoo1
`L7o^[ZjokJf]_nj^[[oa/K6omCDe?oUiNGokno_oo7alOook^k^ooo^k^ig
onk^kP0000_o^;Rhol30`?o8b<SodM7AomKFe_oLg=cogmoOon?ShooXj>So
kNg]oo?cl`02ooOgm`03ooCdm?o_knoooooo0?oooooooooooomeooooo`00
00oo^;Rhol30`?o8b<Sodm?Com_KfooShn?oj^[Zono_koodm?ConOWioo[j
n_olo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oo
k^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooooooooooooogKo
oooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_oj
n_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh
^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?cl
ooWinOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCT
i?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooooooo
ooooM_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7o
m_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP00
00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_k
noolo?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV00003onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oo
oooooooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKo
k^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_oj
n_[ono_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh
^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?cl
ooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl0ooooooooooooogKooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCT
i?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_oo
k^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7o
m_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KVoooVi^IfonKViP00
00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_k
noolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`3oooooooooooooM_ooool0000?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oo
k^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0oooVi^KoonKViWKo
i^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_oj
n_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh
^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?cl
ooWinOodm?Cokno_0?oooooooooooomfooooo`0000oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCT
i?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKVi_oo
i^KVM_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7o
m_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP00
00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_k
noolo?conOWiooCdm?o_knl0ooooooooooooogKooooo00003onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oo
i^KVoooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKo
k^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_oj
n_[ono_kooclo?oinOWom?Cdono_k`3oooooooooooooM_ooool0000?okRh
^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?cl
ooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl0oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCT
i?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_oo
k^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7o
m_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oooooooooooomfooooo`00
00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_k
noolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oo
k^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooooooooooooogKo
oooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_oj
n_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh
^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?cl
ooWinOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCT
i?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooooooo
ooooM_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7o
m_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP00
00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_k
noolo?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV00003onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oo
oooooooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKo
k^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_oj
n_[ono_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh
^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?cl
ooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl0ooooooooooooogKooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCT
i?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_oo
k^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7o
m_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KVoooVi^IfonKViP00
00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_k
noolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`3oooooooooooooM_ooool0000?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oo
k^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0oooVi^KoonKViWKo
i^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_oj
n_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh
^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?cl
ooWinOodm?Cokno_0?oooooooooooomfooooo`0000oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCT
i?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKVi_oo
i^KVM_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7o
m_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP00
00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_k
noolo?conOWiooCdm?o_knl0ooooooooooooogKooooo00003onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oo
i^KVoooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKo
k^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_oj
n_[ono_kooclo?oinOWom?Cdono_k`3oooooooooooooM_ooool0000?okRh
^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?cl
ooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl0oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCT
i?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_oo
k^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7o
m_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oooooooooooomfooooo`00
00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_k
noolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oo
k^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooooooooooooogKo
oooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_oj
n_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh
^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?cl
ooWinOodm?Cokno_0?ooi^KVoooVi^IfonKViP0000oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCT
i?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooooooo
ooooM_ooool0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7o
m_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP00
00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_k
noolo?conOWiooCdm?o_knl0oooVi^KoonKViWKoi^KV00003onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oo
oooooooooomfooooo`0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKo
k^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_oj
n_[ono_kooclo?oinOWom?Cdono_k`3oonKVi_ooi^KVM_oVi^H0000?okRh
^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?cl
ooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl0ooooooooooooogKooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCT
i?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_oo
k^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7o
m_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ooi^KVoooVi^IfonKViP00
00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_k
noolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`3oooooooooooooM_ooool0000?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oo
k^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0oooVi^KoonKViWKo
i^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_oj
n_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh
^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?cl
ooWinOodm?Cokno_0?oooooooooooomfooooo`0000oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCT
i?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKVi_oo
i^KVM_oVi^H0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7o
m_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP00
00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_k
noolo?conOWiooCdm?o_knl0ooooooooooooogKooooo00003onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`3oonk^k_ook^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oo
i^KVoooVi^IfonKViP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKo
k^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_oj
n_[ono_kooclo?oinOWom?Cdono_k`3oooooooooooooM_ooool0000?okRh
^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?cl
ooWinOodm?Cokno_0?ook^k^ooo^k^ifonk^kP0000oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl0oooVi^KoonKViWKoi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCT
i?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^k_oo
k^k^M_o^k^h0000?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7o
m_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0?oooooooooooomfooooo`00
00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_k
noolo?conOWiooCdm?o_knl0ooo^k^koonk^kWKok^k^00003onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`3oonKVi_ooi^KVM_oVi^H0000:okRh^?no_kooalO7om7AdOoI
fMWoh^;RonWYjOo_knoomOGeooWin@;on_[j00?on?Shoo?cloo]kNd0ooo^
k^koonk^kWKok^k^00003onh^;So_knoolK6a_o@d=3of=SHon7QhOoXj>So
k^k^oo?cloogmoOon_[jooShn?ogmoOolo?conc/k03oooooooooooooM_oo
ool0000:okRh^?nn_[koa/K6olo?cooFe]KogmoOonGUiOo/k>colO7aooGe
m@;omoOg00?omOGeoo3`l?oZj^X0ooo^k^koonk^kWKok^k^00002_nh^;So
_;blolG5aOo<c<coe=CDomcLg?oRh^;ojNWYonk^k_obl_82ooCdm003oo7a
lOo^k^koj>SX0?ooi^KVoooVi^IfonKViP0000oo]KFeok^k^oo3`l?ob/[:
om7AdOoHf=SogmoOonCTi?oZj^[ok^k^oo3`l?oalO7okNg]onSXj?oShn<0
ooo^k^koonk^kWKok^k^00002_nd];Co]kNgol71`Oo7alOoclo?omGEeOoK
fm_oh>3PonGUiOoYjNT2on[ZjP03onOWiooRh^;ogMgM0?oooooooooooomf
ooooo`0000go]KFeokJf]_nm_Kgo`/;2olW9bOo@d=3oe]KFom[Jf_oOgmoo
hn?Son;Rh_oShn?og]kN00;of=SHooo^k^koonk^kWKok^k^00003oni^KWo
[jn_okJf]_nn_[koalO7olc<c?oAdM7oe]KFomSHf?oKfm_ofMWIomSHf?oB
d];o`l?3omkNgP3oonKVi_ooi^KVM_oVi^H0000?okfm_OnVYZKoZj^[okNg
]oo1`L7oaLG5ol[:b_o>c/kodM7Aom3@d?o?cloob<S8okbl_?o4a<CokNg]
0?ook^k^ooo^k^ifonk^kP0000oo^k^kokno_onPX:3oYJFUojn_[onj^[[o
_[jnol?3`oo2`/;o_;blokJf]_n^[Zko/K6aonCTi?o_knl0oooooooooooo
ogKooooo00001_nj^[[odM7AolG5aOnJVY[oUYJFoj6QX@?oZ:RX00KoXJ6Q
oiNGUon][Jgoh^;Roo[jn_o_knooonk^k_ook^k^M_o^k^h0000?okbl_?oC
dm?ok^k^om;Bd_nYZJWoVi^Koi:BT_n9RHWoTi>CojFUYOo4a<Colo?cookn
o_ojn_[okno_0?ooi^KVoooVi^IfonKViP0000oo^[Zjom7AdOobl_;ol_;b
omkNg_oCdm?ofMWIon7QhOoWinOokNg]ooGemOokno_oo_knoo[jn_o_knl0
ooo^k^koonk^kWKok^k^00003onk^k_od];Boo;bl_ogmoOom_Kfon[Zj_oL
g=cohN7QonSXj?o^k^komOGeoo_knoono_kon_[jono_k`1doooooa00oooo
oooooooaooooo`0000oo^k^kom?Cdoobl_;on?ShooWinOohn?Sojn_[on7Q
hOoXj>Sokno_ooKfm_okno_ooOgmoo[jn_o_knl0M?o^k^h50>k^kP040?oo
o`00000000000?ooo`L0k^k^ooo^k^kaonk^kP0000oo][Jfom3@d?oalO7o
moOgooShn?ogmoOoj>SXomcLg?oRh^;oi^KVonk^k_odm?ComoOgooCdm?oX
j>P0M?oVi^H00`3oool0i^KV0>KViP020>KViP040?ooo`00000000000?oo
o`L0i^KVoooVi^KaonKViP0000oo/k>colk>c_o_knoolO7aon_[jooOgmoo
eMGEomOGeooMgMgoi>CTon[Zj_o`l?3olo?coo3`l?oUiND0M?o^k^h20?oo
o`80k^k^00@0oooo000000000000oooo203^k^koonk^k_7ok^k^00003on_
[jooZZZZokbl_?nc/k?o[Zj^ojn_[ong]kOo_Kfmol;2`_o8b<Soc/k>om?C
dooFe]Kodm?Col[:bP1dooooo`030?ooo`000000oooo0080oooo0P000009
0?oooooooooolOooool008?oOgmo00@0oooo000000000000oooo0P000000
0`3oool0Ogmo07moO`0707moOlCoOgmo1omnOWkoogmoObKoOgmo00001?o[
jn_oi^KVon;Rh_oNg]h4omgMg@?og]kN07WogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]h0oooo00D000001@3oool0S`3Ng]h0gMgM0=kNgP3MgMd0
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kN00;ogMgM0_oLg=`0=?oKfm_ogMgMomcLgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]h2omgMg@07om_KfooJf][oemOGomSHf?oGemSof][Jom_K
f`02omgMg@3oomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN000GomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMd0
1?oNg]h00ooMgMgog]kNomkNgP03omgMg@7ohN7Q0OoWinL1on[ZjP0000?o
k>c/onKVi_oPh>001ooIfMT01?oHf=SoeMGEom?Cdoo@d=03olg=c@04om3@
d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@
d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Co
d=3@om?CdooGemOof=SH@_oIfMT00`3oool0000000000006000000030?oo
o`3IfMT0fMWI00@0fMWIR_oIfMT2omSHf006omKFe_oCdm?odm?ComCDe?oG
emOof=SH0_oIfMT00ooHf=SofMWIomWIf@02omSHf0WofMWI00?of=SHomWI
fOoIfMT00_oHf=P00ooIfMWof=SHomSHf002omSHf1OofMWI00Cof=SHomKF
e_oBd];oclo?0_o=cLd01?o?cloodm?ComOGeooHf=Q/omWIf@03omSHf?oI
fMWofMWI0:SofMWI00?of=SHomWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/
k>`00007onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkN
g_oLg=codm?ColO7aonk^k_o/K6aojj^[_nb/[;o^k^kolO7aooCdm?ofm_K
omoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o
^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk
^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`11on7Qh@030?oo
o`000000000000D0000000<0oooo0>7Qh@3QhN401@3QhN6:on7Qh@09on3P
h?oOgmoofm_KomKFe_oDe=Coe]KFom[Jf_oNg]koh>3P00KogmoO0ooPh>00
0ooOgmooh>3Pon3Ph002on3Ph0SogmoO0_oNg]h2omoOg`?oh>3P0_oOgml2
on3Ph0;ogmoO3OoPh>001OoOgmoogMgMomWIfOoEeMGodm?C00;od];B00?o
e]KFomcLg?oPh>00oooQhN4Jon7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoT
i>@1onWYj@7ok>c/00000oo`l?3okno_oo7al@03oo3`l0;okno_07cok^k^
onWYjOoJf][o`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7o
f][Jon[Zj_o]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aong]kOoZ
j^[of][Jol;2`_nTY:CoS8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[J
f_oZj^SokNg]oo7alOo_knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Z
om[Jf_o2`/;oY:BTohb<S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJf][o
j^[Zong]kOoalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knl0oooo1P00
0000W03oool0lO7_0>o_k`3alO40kno_0?7al@3_knl0lO7a0>o_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_koo`l?3okNg]onc/k?oUiNGoh^;RomoOgooUiN?ojNWYong]k@;o
j>SX00Koi^KVonWYjOoWinOojn_Yonc/k?o^k^h3on[ZjP03ono_koo^k^ko
k^k/00;oj>SX00Ooi^KVonWYjOoWinOoj^[ZonWYjOoYjNOoiNGU00;oinOW
00[ojn_[onc/k?o_knoojn_[on[Zj?oYjNWok^k^onc/k?o[jn_oj>SX0_o]
kNd02_o^k^coj^[Zonc/k?o/k>cok^k^on[Zj_o/k>cokNg]onk^k?oZj^X2
onc/k008onk^k_n][JgoMgMgoeUIFOm_Kfko][Jfon7QhOoWinL2ono_k`3o
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_koo`
l?3okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7a000Oono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3`ono_k`04oo3`l00000?ol_;bonk^k_oWinL0
1?oUiND04?oTi>CogmoOom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5
ADGoDE5AofIVI_n:RXWo/K6aom7AdOoNg]h2onCTi003onGUiOoTi>CoiNGT
00;oi>CT00oog]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGo
DE5AofIVI_n:RX[o/K6aom7Ad?oNg]h00_oTi>@0EOoUiNGoi>CTonGUiOoT
i>Coi>CSomkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5A
DOmVIVKoRXZ:ok6a/OoAdM7og]kNonCThooTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi03oool01@000000WP3oool0i>CT0>GUi03Ti>@0iNGU0>CTi03U
iND0i>CT0>GUi@3Ti>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUon?Shoo6a/Ko:2PXodE5
AOn?Shood];Aom_KfooLg=coe]KF0ooEeMD02ooDe=Cof][IomoOgooOgmoo
fMWIomGEeOoHf=SogmoOon7QhOoMgMcoe]KF00?oeMGE00Goe=CDomWIfOoJ
f][of=SGomGEe@02omKFeP0?omWIfOoMgMgoh>3Pom_KfooFe]Goe]KFomgM
gOoLg=cof=SHomGEeOoLg=coh>3PomoOg_oJf][ofm_K00;ogMgM0?oofMWI
omcLg?oOgmooh>3Oom_KfooJf][ogMgMon3Ph?mcLg?oJ6QXohf=SOmDE5Co
20P8oj>SXooKfm_ohn?SonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>@002OoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiND00_oTi>@4onGUi@06onCTi?oUiNGoiNGUonGUiOoXj>SokNg]0Oob
l_800003ooCdm?o]kNgoinOW00;oh>3P01?ohN7QomkNg_oNg]kod];BokBd
]?n7QhOoG5aLofdk=OnNCT;ocFiNonV3Koo=KeooWTi3ofdk=_mLG5coQhN7
okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m]H2co
WYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aLohN7Qond];Cod];BomkNgP05
on3Ph00AomkNg_oBd];o];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=
AomZWSCoBFX_oeaLG?n7QhOo];Bdom;Bd_oNg]h0?ooPh>000`3oool00000
00000002000000030?ooo`3Ph>00h>3P00P0h>3PRooPh>001_oOgmooclo?
oiVIVOnBTY;o6ATIohb<S0;oeMGE01ooclo?ol;2`_o>c/koc/k>olG5aOo:
b/[of][JomSHf?o@d=3obl_;olo?cooHf=Sof][JomGEeOo?cloo`L71om3@
d?o>c/koa<C4ol_;booHf=SoemOGokjn__nk^k_odM7Aom3@d?oEeMGof=SH
om?Cdoo<c<coc/k>00;oeMGE00Goc/k>olc<c?oCdm?of][JomSHf002om;B
dP04omSHf?oGemOodM7Aom?Cd`;ofMWI00Kodm?Com7AdOoGemOof=SHom7A
dOo@d=02om7Ad@04odI6A_m1@D7oemOGomkNgV[oh>3P00?ogmoOon3Ph?oP
h>001OoPh>000ooOgmooh>3Pon3Ph00bon3Ph003omoOgooPh>3oh>3P06go
h>3P00?ogmoOon3Ph?oOgml00_oOgml3on3Ph003on7QhOoWinOok>c/007o
lo?c00000oofm_Kol_;bon_[j`03onSXj00ConOWiooRh^;ocLg=oinOWomZ
GUkoScH^oneaHOoiWI3ooK6Uoofl[oom]:OonInConedHonB=booJemOoinO
Woo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWom^IUooTg8R
ongAA?oilgCooOf=oogmUOomoHkonOQfongGAonCLb;oKVMOoinOWoo=cLgo
h^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWomPJ5ooBg`Soi;QBonm
nG_od?fBomSmVooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=cLgoh^;RonOW
i`0nonSXj0050?ooo`00000000000000003oool02`3Xj>R=onSXj004onKV
i_oQhN7oGEeMode=C@;ogMgM01ooD51@o`L71olE5AGoQ8B4oaHF5_m3@d?o
h^;RomgMgOnLW9co0000ohn?SooMgMgohN7Qom_Kfom0@43o20P8oaTI6On8
R8So2`/;oeQHF?ng]kOo30`<o`L71olS8b?o9bLWogemOOoJf][ogMgMomCD
e?l;2`_oFEUI00;ofMWI00?oGEeMo`/;2ooCdm<00_oOgml01_mJFU[oCTi>
omkNg_oNg]ko8b<SohB4Q0;ohN7Q00coNWYjobh^;_oMgMgogMgMol;2`_m@
D53o<c<cofi^K_n3Ph?o8B4QomkNg_oVi^KoonSXj27oj>SX0Oo/k>`1oo;b
lP7om_Kf00000oogmoOon?ShooShn003ooShn00CooOgmoo^k^koc/k>oi2@
T?n5;b_ojFAFooZBQoonYY_oo[2UoonhZoon/jKooZRLoo^DROo^J5WoRC4[
oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_o
l;dmoo_PK_onm8;oo_j:ooooT_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>
c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?m2Lb_oQ<i3ojg_
Loo2oXSoc_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^
ooOgm`0nooShn0040?ooo`00000000000?ooo``0n?ShSOohn?P09Oofm_Ko
lO7aoh61POlO7aookNg]olK6a_l0003o`l?3om?CdomLG5co20P8on[Zj_o`
l?3oj^[Zoe9BD_lD51Co?CdmonWYjOo`l?3o[jn_o`L71ooBd];ocLg=odi>
C_lK6a_ok^k^om_Kfon^[Zkoj>SXonc/k?n^[Zko0000okBd]?o/k>co/;2`
o`/;2olJ6QX00_oTi>@02olS8b?o3Ph>ojBTY?o]kNgok^k^of1PH?mDE5Co
k^k^ong]kOlV9RKoSHf=00;ol?3`00coPX:2oc4a<Oo/k>coj^[Zod=3@ol_
;booW9bLog=cLolZ:R[o6QXJonk^k_ofm_H<ooShn003ooOgmoohn?Son?Sh
05_on?Sh00?omoOgooShn?ohn?P01Oohn?P00oogmoOon?ShooShn00gooSh
n003ooOgmoohn?Son?Sh06[on?Sh00?omoOgooShn?ohn?P00_ohn?P00oog
moOonOWiooOgm`02ooOgm`0000?on_[jooGemOo^k^h00_o/k>`0ooo[jn_o
jNWYomoOgonj^[[oNE9Bokla8ooWM6WooHUnoonGRoonXYKoojRLoojTV?oo
VXgooXYoonifJ_o3<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/on[Z
j_oOgmoo^[ZjohQUD_oRTAconL=@oogJHooojW;oo_=nooojP_onmWooonac
ookNI?ojae7ohY8LohUVDonj^[[ogmoOon[Zj_o[jn_ok>c/on_[jooZj^[o
gmoOokZj^_mBKE;oDJ<Loi7BEOnVif[o^?Ujol3nP_o7ohWo`oj4okWmNonW
k6coU=IGoe:V7?mBKE;o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k03oool000000?ooo`3/k>`0jn_[0>c/k03[jn/0k>c/0>_[k03/k>`0
jn_[0>c/k03[jn/0k>c/0>_[j`3/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k000b?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_oj^[ZonCTi?mjNW[o71`Lon;Rh_o;bl_o0`<3oinOWooOgmooU9BD
oa<C4ooPh>7ohN7Qom3@d?l61PKoXJ6Qo`T92Onn_[koh^;RokVi^_l20P;o
/K6aomkNg_n0P83o:BTYon;Rh_oXj>Soi>CUomoOgooJf][oe=CDo`P82?n6
QXKogmoOofYZJ_m9BD[o=CDeojb/[?nn_[ko1`L7ogQhN?mEEEGogmoOomoO
h?mKFe_oCdm?on;Rh_oPh>3o92@TohB4Q?oPh>3oh>3Qog]kNol_;boohN7Q
omCDe?l51@GoYjNWonCTi?oRh^?oOgmooaDE5OoRh^;ojNWYonc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/0_o[jn/0ZOo/k>cojn_[onc/k?oZj^[ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>`01_o[jn/01Oo/k>cojn_[on_[
joo^k^kom_Kf007onOWi00000ookno_olo?cong]k@02onGUi@1nonKVi_oS
hn?ofMWIok6a/Omi;Rkob48don=ZG?odNVgooHQloojGR_onVhkooYR;ooj:
O_odNfgoif]MolY2=?mk;Rko/[:bomSHf?oTi>CoiNGUonKVi_oUiNKoi>CT
omSHf?nb/[;oUUD^onZL:ook_4Coo/aCoogHH_onhg;oo^UeookVLoonffGo
oLaCoo_1AOo^WR_oVEH^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGUonCTi?oH
f=Wo/[:bobiR;_mS[B_oQlY8oiOLFOnUiFWo/_=gokSfNondmGWoYnY[oiSL
FOn9cd_oHjh[obiS;_nb/[;of=SIonCTi?oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KV0P3oool0o`3UiND0i^KV0>GUi@3Vi^H0iNGU0>KViP3UiNH0i^KV0>GU
i@3Vi^H0iNGU0>KViP3UiND0i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onCTi?oNg]koMgMgoa/K6ooLg=coh>3PoijNW_l^;Rko:b/[oc8b<_lB4Q;o
fm_Lom_Kfon4Q8Co8B4QomoOgomCDe?oIfMWom_KfooMgMkoT92@obTY:Ol_
;boo;2`/obPX:?oMgMgogmoOomSHfOoDe=Coclo?oe]KFol0003o_[jnomWI
fOlX:2SoQXJ7ogQhN?mXJ6SoPX:2oc`l??o3`l?o3`l?omGEeOoIfM[oFEUI
odi>C_oMgMgog=cLob<S8on1PH7oe]KFomKFeomgMgOo;Rh^omgMgOnRXZ;o
0000olK6a_oIfMWof=SIohj>S_lE5AGogMgMon?ShooVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUiP00l_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGU0ooVi^H00ooUiNGoi^KVonKViP03onKV
iP03onGUiOo]kNgom?Cd007ono_k00000oolo?con?Shoo7al@03onk^kP0C
on_[jooQhN7o_;blogXG5oo3?c;odeE9onAXF_o_Mfcolh=hooR7O?oeQ7[o
lgU]onEYFooIF4[oa3lbog`G5onl_;cohN7Qonc/k003onk^kP0Conc/k?oQ
hN7o_;blojE75ooVUc;omJ``oofl@OombE?ooM1Poo_CIOomdV3oo/eDoofm
@_oj[c;ojI/bojE65onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;bl
oaMI5omOZ3;oM[dgohK=AonFeU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg_cOo
Gj/boaMI5onl_;cohN7Qonc/k03Konk^kP0^onc/k?oWinOoNg]koa`L7?oT
i>CojNWYonKVi_oQhN7og]kNohf=SOlD51Coi^KVonCTi?le=CGoNGUion_[
jonb/[;o5ADEomoOgooVi^Koi>CTon7QhOoMgMgoNWYjobTY:OoXj>SoiNGU
omgMgOna/K7o9RHVo`/;2onKVi_ojNWYolc<c?l0003oc/k>ol?3`olU9BGo
Bd];ogalO?oXj>So<C4aojFUYOoTi>CoGEeMoe5AD@;oinOW00[o9BDUofUY
JOoOgmoogmoOogMgMola<C7ojNWYol71`Ol0003oYjNW0_oOgml01?nCTi?o
5QHFonOWioo/k>aZonk^kP03ong]kOo^k^kok^k^00Gok^k^00?okNg]onk^
k_o^k^h0Z_o^k^h00oo]kNgol_;booShn001ooclo0000oomoOd05_olo?co
oOgmoogmoOolo?col_;bom7AdOmW1PKo^3@dolLo<ooBD4?ofV9Eon=^H_oT
LVCoi6mRomaTEooCDD?oc44dokTd=?m[1`Ood];Boo?cloolo?`3oogmo@0C
ooclo?oclo?od];Boih[1ooJRSCoji/IooFX:Ooh]3oonKe:ooRoCOoj_d[o
nKPoooJZ:_o_WQWofh/doj8]1ooBd];olo?cooclo003oogmo@0Cooclo?oc
lo?od];Bo`M01om=VSCoGj/Pog2h;omo`d?oR/e@ohg=D_n:cU3oPLM4og6i
;omR[R3oCY/do`M21ooBd];olo?cooclo03Koogmo@0Soo_knoogmoOoQ8B4
oahN7_oclo?onOWiok>c/oo@d=3olo?cofQXJ?m7AdOon_[jomCDe?l0003o
gMgMooclo?okno_o9bLWojRXZ?oinOWoZj^[omGEeOoalO7oE5ADoeiNG_oi
nOWom?CdoiBDU?l51@Go@410om7AdOogmoOon?ShoiNGUol[:b/00_ojn_X0
6olT92Co1`L7olS8b?okno_oQHF5of=SHoogmoOoHf=SoeMGEoohn?SonOWi
obLW9olE5AGoPh>3omOGeom2@T;oHf=Soo_knoojn_[o=3@dodU9BOoKfm_o
iNGUodm?ColG5aOon_[jooclo03ooogmoAkooOgm00?oo?cloogmoOolo?`0
0oomoOd00004oogmoOojn_[olo?conk^kP;okno_03CokNg]onWYjOoCdm?o
FadMoj8d=?nd:1go`CX]olM9??o?ET[od5M;om1GB_o:BSko`c/^okHX7OnR
=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_onk^k_oZj^[odm?Coh`U
7Oo8LCCofH@MonBD5OoWWBCokZPcoo2Z=?o_ZS?ok:0UonNG5OoLR1gob74d
oh`U7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`l?o^k^koj^[Yom?CdolM>1go
=88dodNE7OmJYA_oJJdZ0_md^3P0oome^CSoJk4[oe^W7?m8VQgo=88doadh
7OoCdm?oj^[Yonk^k_o`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o^k^kojn_[ogem
OOlL71coinOWonk^k_n8R8So<30`o`h>3_la<C7o/;2`ono_k_n4Q8CoCDe=
onk^k_o_knook^k^ohZ:R_mIFEWokno^ogQhN?l/;2co3Ph>ocPh>?nn_[ko
k^k^on?Sh`003?l>3PkoJFUYon3Ph?oRh^;oi^KVon[Zj_mQHF7oMWIfono_
k_o^k^koMgMgobHV9P;ok^k^01KocLg=ob`/;?o[jn[oK6a/of=SHoo[jn_o
k^k^ocXj>_nDU9CoHV9Ro`h>3_ld=3Coa<C4onk^k_o_knoodM7Aoc`l??l:
2P[o9bLWofa/K?l/;2cok^k^0_o_knl01Oo`l?3okno_oo3`koo_knool?3`
00?okno_0?ool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo_knko
k^k^oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?0000kokno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l0;okno_0_o`l?06ono_k`7olo?c0OoinOT1ooknoP0000?oo_kn
ooOgmoo`l?001?oYjNT04OoWinOofm_Kof=;Bon1<S;oYS@dokHd;Oo2CD7o
`eA9olAEB_o3E4Wo`Te1okHd;OnU=CGoPC8bof=;BooKfm_oinOW00GojNWY
017oinOWom_Kfon9Bd_o[d/boleg=OoFRbgoh9`^on2P<_oQX3Coh:0bomnJ
;_oFRbgobWDeojm;<_n9Bd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oBd];
oc9P<_ljRCGoDi/]of^[;om`[CSoKjhjog2]>?mZZRooDi/]ocV8=OlbH3;o
Bd];om_KfooWinL0g?oYjNT01_oXj>Soi^KVog]kNolL71coi>CTonSXj0;o
jNWY00?oinOWonWYjOoYjNT02ooYjNT03?oWinOojNWYonWYjOoXj>Sof=SH
o`X:2_n^[ZkogMgMomkNg_oPh>3oiNGUonSXj0SojNWY00Koj>SXonKVi_oS
hn?ohn?SonKVi_oXj>P3onWYj@03onSXj?oYjNWojNWY00CojNWY00?oinOW
onWYjOoYjNT0Z_oYjNT00ooXj>SojNWYonWYj@1_onWYj@03onSXj?oYjNWo
jNWY00CojNWY0Oo`l?01ooOgm`7oo_kn00001?ono_kon_[jooCdm?o_knl3
oo3`l00Aono_koo[jn_oUIBDodlS8onEE5Co^g=com>EUOoJW9cofYjLomVL
W?oDUIGo^g=coiEDE?m?8b?oUIBDon[Zj_o_knl01Oo`l?004Oo_knooj^[Z
ojVDU?n18b?o^VYDomBJLooT_9Goj/NLonW7W?oZaicoiKbEomBJLonkJUCo
PB<SojZDU?oZj^[okno_00Gol?3`017okno_on[Zj_nDU9Co8bXSoeAjE?mc
YG?oW/JEojc>W?n]cYco[<jLoik6UOmcYG?oE7YDob<Z8onDU9Coj^[Zono_
k`3Loo3`l0;okno_00CoP820oadM7Oo^k^kokno_4oo`l?02ono_k`07ofAT
I?lY:BWoPH61of=SHolk>c_ok^k^ono_k`08oo3`l006ono_koo^k^koLg=c
ofUYJOo^k^kokno_5Oo`l?000oo_knool?3`oo3`l005oo3`l003ono_koo`
l?3ol?3`09gol?3`00?okno_oo3`l?o`l?00K_o`l?001?oalO7ol?3`ooCd
m?ojn_X1ooknoP0000Cok>oaooooooooooooo_kn0_ooool2ooknoP3ooogm
oOohn?SoKVi^oeXo?onaT93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSlo
ofe]KOohn?Soo?clooooooono_koooooookno_ooookoo_knooooooolo?co
n?Shohe]KOn:?coobI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo?on=
KFgon?Sgooclo?ooooooo_knooooooono_koooooookno_ooookoo?clooSh
n?m]KFgo?clooi2MT?o9eLWoi>cTonK^i_oTk>CobMG9oi2MT?lo?cooKFe]
ooShn?olo?coooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_kn000Iooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooo`02ookn
oP3oolo?conVYZGooOgmooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ono_go`<30og5aLOn0P83o/;2`oogmoOooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koo_kmol71`Onm_Kgo
oOgmooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_kn001Eooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooo`02ooknoP05ooooooono_koooooooooooono_h0
1Oooool1oo[kn`0000Ko`l_Bookno_ojn_[om?Cdoo7alOo`l?03oo7al@0=
ono_kooFe]KoJf][od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_o
e]KFono_k`09oo7al@0=ono_kooGe]KoPf][og@m?OneS8coeKZjon7<c?oF
^[[o]Xb<og8m?On1Jf_oemKFono_k`09oo7al@0=ono_kooFe]KoJf][ocdm
?On<S8co^[Zjolc=c?nj^[[oS8b<ocdm?Om[Jf_oe]KFono_k`3ooo7alOoo
lO7a=ooalO401?o`l?3olO7aoo7alOo`l?04oo7al@03ooCdm?ojn_[oo_kn
007oko7b00001On6U:3ooOgmooOgmoo`l?3ojn_[00?oj^[Z00gojNWYon[Z
j_oYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY
00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo@RHVofUIFOnPVi_o
j>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mI
FEWoVi^KonSXj?oYjNT0oooZj^[oon[ZjSooj^[Z00Cojn_[oo3`l?ohn?So
oOgm0OoJg^400004ocU:F_nj`l[on_[jooCdm0SolO7a0_o`l?03ono_k`;o
l?3`3ooalO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l?oo
lO7aoooalO4moo7al@08oo3`l?oalO7olO7aoo7alOo`l?3omOGeoo[jn_oZ
k>h1oibQY00000?o8CQ9odmNJ_nj`LP0ooooooooooooogoooooo0OoYjn`1
ojBXZ`7oVIjR00001_lT?U3o8CE4ocU6Don4SYWo`<K<on_]kooooooooooo
oomiooooo`05ooWin_o/k^oodMCGoi^OX_nMXJH00Ond^Kd00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{643, 482},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(scrlBr = NewJScrollBar[pane]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JScrollBar"] \[RightGuillemet]\),
      JLink`Objects`JavaObject115124819984385]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(DeleteJObject[pane, scrlBr]\)], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["<<< SimpleJScrollBar >>>",
  FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003]0000ZaP00`40o`00
0?l0003ok@00000000>8`;Q8T8Q8T8P0jDR@R04000000003R<2hb>3HR<2h
0>R8`;P1B9280@00000000>8`;S8h=R8`;P0j8S0^058T8P1000000001HS0
^<SPf8S0^8S0^<c<c00@ooooe<c<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVK<c<`>IVIV00?oooo<c<c<c<`0d/c<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVKoool=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVKoool=c<c<00=VIVKoooo<c<`0
dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKoool=c<c<00=V
IVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKo
ool=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVKoool6c<c<0P0000G<c<`00fIVI_ooolc<c03Cc<c<0XS0^058
T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooo`G<c<`400001<c<c003IVIV
ooooc<c<0=?<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo
1<c<c0H00003c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8
`;S8h=R8`;R8`;QVIVKoool3c<c<200000;<c<`00fIVI_ooolc<c03Cc<c<
0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooo`g<c<`00fIVI_oo
olc<c03Cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooo`g<
c<`00fIVI_ooolc<c03Cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0
^6IVI_ooo`g<c<`00fIVI_ooolc<c03Cc<c<0XS0^058T8P1000000001XS0
^<SPf8S0^8S0^6IVI_ooo`g<c<`00fIVI_ooolc<c03Cc<c<0XS0^058T8P1
000000001XS0^<SPf8S0^8S0^6IVI_ooo`g<c<`00fIVI_ooolc<c03Cc<c<
0XS0^058T8P1000000001HS0^<SPf8S0^8S0^6IVIP0>oooo00=VIVKoooo<
c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVK<c<`>IVIV
00?oooo<c<c<c<`0d/c<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QV
IVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<
c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<
00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QV
IVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<
c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<
00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QV
IVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<
c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<
00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QV
IVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<
c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<
00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QV
IVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<
c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<
00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QV
IVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00
000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8
`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH03iVIV@03ooooc<c<c<c<
0=;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h46IVV@03ooooc<c<
c<c<0=;<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVJIc<co3IVI
c003IVJIooooc<c<0=?<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
IVJIc<co3IVIc003IVJIooooc<c<0=?<c<`2R<2h0DR@R04000000006R<2h
b>3HR<2hR<2hIVJIc<co0YVIc005IVJIVIW<VIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc6IVVOooo`3Dc<c<0XS0^058T8P10000000028S0^<SPf8S0^8S0
^6IVVLc<oiVIc<c<o`>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00=VIYWo
ooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIYW<c?l4
VIW<00EVIYVIVLbIVLbIVLaVIYT019VIc003IVJIooooc<c<0=?<c<`2R<2h
0DR@R04000000006R<2hb>3HR<2hR<2hIVJIc<co0iVIc005c<coVIW<VIW<
VIW<c<co00FIVL`00fIVVOooolc<c03Cc<c<0XS0^058T8P1000000001XS0
^<SPf8S0^8S0^6IVVLc<o`:IVL`01FIVVIVIc9VIc9VIc6IVV@03VIW<00EV
IYVIVLbIVLaVIYWoool0e<c<c0:8`;P1B9280@00000000R8`;S8h=R8`;R8
`;QVIYW<c?nIVLc<c?l3VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc003IVJI
ooooc<c<0=?<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVJIc<co
19VIc005IVJIVIW<VIW<VIW<IVJI00BIVL`00fIVVOooolc<c03Cc<c<0XS0
^058T8P1000000001XS0^<SPf8S0^8S0^6IVVLc<o`>IVL`01Lc<oiVIc9VI
c9VIc<c<o`05VIW<00=VIYWoooo<c<`0dlc<c0:8`;P1B9280@00000000J8
`;S8h=R8`;R8`;QVIYW<c?l2VIW<00EVIYVIVLbIVLbIVLaVIYT00iVIc005
IVJIVIW<VIW<IVJIoooo0=C<c<`2R<2h0DR@R04000000008R<2hb>3HR<2h
R<2hIVJIc<coVIW<c<co0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`00fIV
VOooolc<c03Cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVVLc<
o`fIVL`00fIVVOooolc<c03Cc<c<0XS0^058T8P1000000001XS0^<SPf8S0
^8S0^6IVVLc<o`fIVL`00fIVVOooolc<c03Cc<c<0XS0^058T8P100000000
1HS0^<SPf8S0^8S0^6IVV@0>c<co00=VIYWoooo<c<`0dlc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P@IVJI00?oooo<c<c<c<`0d/c<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0
dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=V
IVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJI
VIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0100000?<c<`3
0000bLc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<
00AVIVKoool000000002c<c<0P000003c<c<0000000000;<c<`00`000<c<
c<c<c036c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVIYVIV@g<
c<`016IVI_ooo`00000000;<c<`200001Lc<c0800037c<c<0XS0^058T8P1
000000001XS0^<SPf8S0^8S0^6IVIYVIV@g<c<`016IVI_ooo`00000000;<
c<`200000/c<c0D00037c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0
^6IVIYVIV@g<c<`016IVI_ooo`00000000;<c<`2000000?<c<`000000000
0/c<c0800037c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVIYVI
V@g<c<`00fIVI_ooo`00000400000/c<c0800002c<c<0P000<O<c<`2R<2h
0DR@R04000000006R<2hb>3HR<2hR<2hIVIVVIVI3Lc<c004IVIVoooo0000
00001Lc<c0800002c<c<0P000<O<c<`2R<2h0DR@R04000000006R<2hb>3H
R<2hR<2hIVIVVIVI3Lc<c004IVIVooooc<c<00000/c<c08000000lc<c000
00000002c<c<0P000<O<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h
IVIVVIVI3Lc<c004IVIVooooc<c<c<c<0`0000?<c<`40000b<c<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0
dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=V
IVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJI
VIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0
dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=V
IVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJI
VIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0
dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=V
IVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJI
VIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0
dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=V
IVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJI
VIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0
dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=V
IVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJI
VIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0
dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=V
IVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJI
VIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0
dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=V
IVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJI
VIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0
dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=V
IVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJI
VIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0
dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=V
IVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJI
VIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0
dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=V
IVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVJI
VIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8
`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@000000
00J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1
B9280@00000000J8`;S8h=R8`;R8`;QVIVJIVIT=c<c<00=VIVKoooo<c<`0
dlc<c0:8`;P1B9280@00000000F8`;S8h=R8`;R8`;QVIVH03YVIV@03IVIV
ooooc<c<0=?<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVc<c<
3VIVIP03ooooc<c<c<c<0=;<c<`2R<2h0DR@R04000000006R<2hb>3HR<2h
R<2hIVIVoooo3Lc<c003IVIVooooc<c<0=?<c<`2R<2h0DR@R04000000006
R<2hb>3HR<2hR<2hIVIVoooo3Lc<c003IVIVooooc<c<0=?<c<`2R<2h0DR@
R04000000006R<2hb>3HR<2hR<2hIVIVoooo3Lc<c003IVIVooooc<c<0=?<
c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo3Lc<c003IVIV
ooooc<c<0=?<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2hIVIVoooo
3Lc<c003IVIVooooc<c<0=?<c<`2R<2h0DR@R04000000006R<2hb>3HR<2h
R<2hIVIVoooo0lc<c0P00002c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B928
0@00000000J8`;S8h=R8`;R8`;QVIVKoool4c<c<1P0000?<c<`00fIVI_oo
olc<c03Cc<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^6IVI_ooo`G<
c<`400001<c<c003IVIVooooc<c<0=?<c<`2R<2h0DR@R04000000006R<2h
b>3HR<2hR<2hIVIVoooo1/c<c0800005c<c<00=VIVKoooo<c<`0dlc<c0:8
`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKoool=c<c<00=VIVKoooo<
c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVKoool=c<c<
00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QV
IVKoool=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00000000J8`;S8
h=R8`;R8`;QVIVKoool=c<c<00=VIVKoooo<c<`0dlc<c0:8`;P1B9280@00
000000F8`;S8h=R8`;R8`;QVIVH03_ooo`03c<c<ooooc<c<0=?<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h46IVI]G<c<`2R<2h0DR@R0400000
0003R<2hb>3HR<2h0>R8`;P1B9280@00000000B8`;S8h=R8`;R8`;PC0020
09`00H000X000h4018401H801X8128812H<12X<12h@138@13H@13XD248D2
4HH24XH24hH258L25HL35XP368P36HP36XT36hT378X37HX47X/488/48H/4
8X`48h`498d59Hd59Xd5:8h5:Hh5:Xl5:hl5;8l6;I06;i06<946<I46<Y46
<i87=987=I<7=i<7>9<7>I@7>Y@7>iD8?9D8?IH8?iH8@9H8@IL8@YL9@iP9
A9P9AIP9AiT9B9T9BIX9BYX:BiX:C9/:CI/:Ci`:D9`:DI`;DYd;Did;E9h;
EIh;Eih;F9l;FIl<FZ0<Fj0<G:4<GZ4<Gj4<H:8<HJ8=HZ<=Hj<=I:<=IZ@=
Ij@=J:D>JJD>JZD>JjH>K:H>KZL>KjL>L:L?LJP?LZP?LjT?M:T?MZT?MjX@
N:X@NJ/@NZ/@Nj`@O:`@OZ`@OjdAP:dAPJhAPZhAPjhAQ:lAQZlBQk0BR;0B
RK0BR[4BRk4BSK8BS[8CSk8CT;<CTK<CT[@CTk@CUK@DU[DDUkDDV;HDVKHD
V[LDVkLDWKLEW[PEWkPEX;TEXKTEX[TEXkXFYKXFY[/FYk/FZ;/FZK`FZ[`F
ZkdG[KdG[[dG[khG/;hG/KlG/[lf6;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0@008000i^WlC=3YC=3Y@09<d>U0`00P02L006000:000>100B1
00F200J20@R20@V30@Z30@^40@b40@f40@j50Q250Q660Q:60Q>60QB70QF7
0aJ80aR80aV80aZ90a^90ab:0af:11j;122;126;12:<12><12B=1BF=1BJ=
1BR>1BV>1BZ?1B^?1Bb?1Rf@1Rn@1S2A1S6A1S:A1S>B1cBB1cFC1cNC1cRC
1cVD1cZD1c^E23bE23fF23nF242F246G24:G2D>H2DBH2DFH2DNI2DRI2DVJ
2DZJ2T^J2TbK2TfK2TnL2U2L2U6L2e:M2e>M2eBN2eFN2eNN2eRO2eVO35ZP
35^P35bQ35jQ35nQ362R366R3F:S3F>S3FBS3FJT3FNT3FRU3VVU3VZU3V^V
3VbV3VjW3VnW3W2W3g6X3g:X3g>Y3gBY3gJY3gNZ47RZ47V[47Z[47^/47b/
47j/47n]4H2]4H6^4H:^4H>^4HB_4HJ_4XN`4XR`4XV`4XZa4X^a4Xfb4Xjb
4hnb4i2c4i6c4i:d4i>d4iFd59Je59Ne59Rf59Vf59Zg59^g59fg5Ijh5Inh
5J2i5J6i5J:i5J>j5ZFj5ZJk5ZNk5ZRk5ZVl5ZZl5Z^m5jfm5jjm5jnn5k2n
5k6o5k:o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000NK
Yo7ooon>N[JVVlBcZM:XWLRcZM800ZJKa005_;SMk^kdj^Waoooo<d>U0080
0800W001P002P003P@04P@05PP06PP48PP49P`4:P`4;Q04<Q04=Q04>Q@8@
Q@8AQP8BQP8CQP8DQ`8EQ`<FR0<HR0<IR0<JR@<KR@<LRP<MRP@NR`@PR`@Q
R`@RS0@SS0@TS@DUS@DVS@DXSPDYSPDZS`D[S`D/S`H]T0H_T0H`T@HaT@Hb
T@HcTPLdTPLeT`LgT`LhT`LiU0LjU0LkU@PlU@PmUPPoUPQ0UPQ1U`Q2U`U3
V0U4V0U5V0U7V@U8V@U9VPU:VPY;VPY<V`Y=V`Y?W0Y@W0YAW0]BW@]CW@]D
WP]EWP]GWP]HW`]IW`aJX0aKX0aLX@aNX@aOX@aPXPaQXPeRX`eSX`eTX`eV
Y0eWY0eXY@iYY@iZY@i[YPi/YPi^Y`i_Y`i`Y`maZ0mbZ0mcZ@mdZ@mfZ@mg
ZQ1hZQ1iZa1jZa1k[11l[11n[11o[A60[A61[Q62[Q63[Q64[a66[a:7/1:8
/1:9/1::/A:;/A:=/Q:>/Q>?/Q>@/a>A/a>B]1>C]1>E]1BF]ABG]ABH]QBI
]QBJ]aBK]aBM]aFN^1FO^1FP^AFQ^AFR^AFS^QJU^QJV^aJW^aJX^aJY_1JZ
_1J[_AN]_AN^_AN__QN`_QNa_aNb_`8H]<0P00000QRd`10000026;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^080080019^WlOooofaJYJnUbP:l
^=d0Yoomok>Yd_oooooookbhgIN:_:RMb>KVk?oooc=3Y@00P001P002P003
P@04P@05PP06PP48PP49P`4:P`4;Q04<Q04=Q04>Q@8@Q@8AQP8BQP8CQP8D
Q`8EQ`<FR0<HR0<IR0<JR@<KR@<LRP<MRP@NR`@PR`@QR`@RS0@SS0@TS@DU
S@DVS@DXSPDYSPDZS`D[S`D/S`H]T0H_T0H`T@HaT@HbT@HcTPLdTPLeT`Lg
T`LhT`LiU0LjU0LkU@PlU@PmUPPoUPQ0UPQ1U`Q2U`U3V0U4V0U5V0U7V@U8
V@U9VPU:VPY;VPY<V`Y=V`Y?W0Y@W0YAW0]BW@]CW@]DWP]EWP]GWP]HW`]I
W`aJX0aKX0aLX@aNX@aOX@aPXPaQXPeRX`eSX`eTX`eVY0eWY0eXY@iYY@iZ
Y@i[YPi/YPi^Y`i_Y`i`Y`maZ0mbZ0mcZ@mdZ@mfZ@mgZQ1hZQ1iZa1jZa1k
[11l[11n[11o[A60[A61[Q62[Q63[Q64[a66[a:7/1:8/1:9/1::/A:;/A:=
/Q:>/Q>?/Q>@/a>A/a>B]1>C]1>E]1BF]ABG]ABH]QBI]QBJ]aBK]aBM]aFN
^1FO^1FP^AFQ^AFR^AFS^QJU^QJV^aJW^aJX^aJY_1JZ_1J[_AN]_AN^_AN_
_QN`_QNa_aNb_`026;C000?8h=Q8T8Q8T8P034R@R0030000b>3HB92800e8
T8P0100001Rd`1Rd`<SPf0i8T8P00`0001Rd`1Rd`002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0P00P00;VjOaooooZ9g8oooo/jWBH4bJSWZfN6F^
Z9g8oooooogo00?oool0Wc=3Y@00P000P001P002P003P@04P@05PP06PP48
PP49P`4:P`4;Q04<Q04=Q04>Q@8@Q@8AQP8BQP8CQP8DQ`8EQ`<FR0<HR0<I
R0<JR@<KR@<LRP<MRP@NR`@PR`@QR`@RS0@SS0@TS@DUS@DVS@DXSPDYSPDZ
S`D[S`D/S`H]T0H_T0H`T@HaT@HbT@HcTPLdTPLeT`LgT`LhT`LiU0LjU0Lk
U@PlU@PmUPPoUPQ0UPQ1U`Q2U`U3V0U4V0U5V0U7V@U8V@U9VPU:VPY;VPY<
V`Y=V`Y?W0Y@W0YAW0]BW@]CW@]DWP]EWP]GWP]HW`]IW`aJX0aKX0aLX@aN
X@aOX@aPXPaQXPeRX`eSX`eTX`eVY0eWY0eXY@iYY@iZY@i[YPi/YPi^Y`i_
Y`i`Y`maZ0mbZ0mcZ@mdZ@mfZ@mgZQ1hZQ1iZa1jZa1k[11l[11n[11o[A60
[A61[Q62[Q63[Q64[a66[a:7/1:8/1:9/1::/A:;/A:=/Q:>/Q>?/Q>@/a>A
/a>B]1>C]1>E]1BF]ABG]ABH]QBI]QBJ]aBK]aBM]aFN^1FO^1FP^AFQ^AFR
^AFS^QJU^QJV^aJW^aJX^aJY_1JZ_1J[_AN]_AN^_AN__QN`_QNa_aNb_`02
6;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd
`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0P00P00>VjOaoooooooofmc/H4bJThFj/jWB_;SMH4bJVHnn
YY_4b<?Ooooo<d>U0`00P00;006000:0oooo00B100F200J20@R20@V3oooo
0@^40@b400Coool03@8BQP8CQP8DQoooo`<FR?ooo`<IR0<JR@<KROooo`<M
RP@NR`@PR`03oooo00h498d59Hd59Xgoool5:Hh5:Xl5:hl5;8l6;I3oool6
<946<I46<Y46<i84oooo00/7>I@7>YCoool8?9D8?IKoool8@9H8@IOoool9
@iP9A9P00oooo`1M2DVJ2DZJ2T^J2TbK2TfK2TnL2U2L2U6L2e:M2e>M2eBN
2eFN2eNN2eRO2eVO35ZP35^P35bQ35jQ35nQ362R366R3F:S3F>S3FBS3FJT
3FNT3FRU3VVU3VZU3V^V3VbV3VjW3VnW3W2W3g6X3g:X3g>Y3gBY3gJY3gNZ
47RZ47V[47Z[47^/47b/47j/47n]4H2]4H6^4H:^4H>^4HB_4HJ_4XN`4XR`
4XV`4XZa4X^a4Xfb4Xjb4hnb4i2c4i6c4i:d4i>d4iFd59Je59Ne59Rf59Vf
59Zg59^g59fg5Ijh5Inh5J2i5J6i5J:i5J>j5ZFj5ZJk5ZNk5ZRk5ZVl5ZZl
5Z^m5jfm5jjm5jnn5k2n5k6o5k:o008H]<001<SPf8S0^8S0^8S0^0H00004
R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P0
3HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0<008003Y^WlOoookbhgIV?__ooomKAgM_Lk??nojJKa>k^m8Ef/9>5^_oo
oc=3Y@800800W001P002P?ooo`04P@05P_ooo`48PP49Poooo`4;Q?ooo`4=
Q04>Q@8@QOooo`8BQP8CQ_ooo`8EQ`<FR?ooo`<IR0<JR@<KROooo`<MRP@N
Roooo`@QR`@RS0@SS?ooo`DUS@DVSOooo`DYSPDZS`D[S`D/S`H]T?ooo`H`
T@HaT@HbTOooo`LdTPLeT`LgToooo`LiU0LjU?ooo`PlU@PmU_ooo`Q0UPQ1
Uoooo`U3V?ooo`U5V0U7V@U8VOooo`U:VPY;VPY<V`Y=V`Y?W0Y@W0YAW0]B
W@]CW@]DWP]EWP]GWP]HW`]IW`aJX0aKX0aLX@aNX@aOX@aPXPaQXPeRX`eS
X`eTX`eVY0eWY0eXY@iYY@iZY@i[YPi/YPi^Y`i_Y`i`Y`maZ0mbZ0mcZ@md
Z@mfZ@mgZQ1hZQ1iZa1jZa1k[11l[11n[11o[A60[A61[Q62[Q63[Q64[a66
[a:7/1:8/1:9/1::/A:;/A:=/Q:>/Q>?/Q>@/a>A/a>B]1>C]1>E]1BF]ABG
]ABH]QBI]QBJ]aBK]aBM]aFN^1FO^1FP^AFQ^AFR^AFS^QJU^QJV^aJW^aJX
^aJY_1JZ_1J[_AN]_AN^_AN__QN`_QNa_aNb_`8H]<001<SPf8S0^8S0^8S0
^0H00004R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@00
08S0^8S0^4R@R00000026;C000C8h=R8`;R8`;R8`;P2000018S0^0800002
R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0`00P02/VjOaooooVHnnUhZle=?XkjbcogIkkYn[FeRUYY_4UYoBH4bJ_;SM
oooo<d>U0020006000:0oooo00B100F2oooo0@R20@V3oooo0@^4oooo0@f4
0@j50Q25oooo0Q:60Q>6oooo0QF70aJ8oooo0aV80aZ90a^9oooo0af:11j;
oooo126;12:<12><oooo1BF=1BJ=oooo1BV>1BZ?1B^?1Bb?1Rf@oooo1S2A
1S6A1S:Aoooo1cBB1cFC1cNCoooo1cVD1cZDoooo23bE23fFoooo242F246G
oooo2D>Hoooo2DFH2DNI2DRI2DVJ2DZJ2T^J2TbK2TfK2TnL2U2L2U6L2e:M
2e>M2eBN2eFN2eNN2eRO2eVO35ZP35^P35bQ35jQ35nQ362R366R3F:S3F>S
3FBS3FJT3FNT3FRU3VVU3VZU3V^V3VbV3VjW3VnW3W2W3g6X3g:X3g>Y3gBY
3gJY3gNZ47RZ47V[47Z[47^/47b/47j/47n]4H2]4H6^4H:^4H>^4HB_4HJ_
4XN`4XR`4XV`4XZa4X^a4Xfb4Xjb4hnb4i2c4i6c4i:d4i>d4iFd59Je59Ne
59Rf59Vf59Zg59^g59fg5Ijh5Inh5J2i5J6i5J:i5J>j5ZFj5ZJk5ZNk5ZRk
5ZVl5ZZl5Z^m5jfm5jjm5jnn5k2n5k6o5k:o0QRd`003b>3HR<2hR<2h00^8
`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2h
B9280000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0^004
B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0800800
2Y^WlOoooiN:_7Y/Z[?7j:U^X<S3gi>5^U]6TiV?_P9hIJh0448WQJnUb_oo
oc=3Y@00P001P002P?ooo`04POooo`06P_ooo`49Poooo`4;Q04<Q0Coool0
7P8BQP8CQ_ooo`8EQ`<FR?ooo`<IR0<JR@<KROooo`<MRP@NR`@PR`@QR`@R
S0@SS?ooo`DUS@DVSOooo`DYSPDZS`D[S`D/S`H]T?ooo`H`T@HaT@HbT@Hc
TPCoool02PLiU0LjU?ooo`PlU@PmU_ooo`Q0UPQ1Uoooo`U3V0Goool0G0U:
VPY;VPY<V`Y=V`Y?W0Y@W0YAW0]BW@]CW@]DWP]EWP]GWP]HW`]IW`aJX0aK
X0aLX@aNX@aOX@aPXPaQXPeRX`eSX`eTX`eVY0eWY0eXY@iYY@iZY@i[YPi/
YPi^Y`i_Y`i`Y`maZ0mbZ0mcZ@mdZ@mfZ@mgZQ1hZQ1iZa1jZa1k[11l[11n
[11o[A60[A61[Q62[Q63[Q64[a66[a:7/1:8/1:9/1::/A:;/A:=/Q:>/Q>?
/Q>@/a>A/a>B]1>C]1>E]1BF]ABG]ABH]QBI]QBJ]aBK]aBM]aFN^1FO^1FP
^AFQ^AFR^AFS^QJU^QJV^aJW^aJX^aJY_1JZ_1J[_AN]_AN^_AN__QN`_QNa
_aNb_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000
R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P0
0hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0P00P003VjOaoooooooo00;oool02_n]/?mfNoW=e?g]k_oo
ojJKa8Ef/;bhgOoooc=3Y@8008005001P002P?ooo`04POooo`06P_ooo`49
Poooo`4;Q04<Q04=Q04>Q@8@QOooo`8BQP8CQ_ooo`8EQ`<FR0;oool030<J
R@<KROooo`<MRP@NR`@PR`@QR`@RS0@SS?ooo`DUS@DVS@Coool03@D/S`H]
T?ooooooo`HaT@HbT@HcTPLdTPLeT`LgToooo`LiU0LjU002oooo06L8?IKo
ooooool8@IOoool9@iSoool9AIP9AiT9B9Woool9BYX:BiX:C9/:CI/:Ci`:
D9`:DI`;DYd;Did;E9h;EIh;Eih;F9l;FIl<FZ0<Fj0<G:4<GZ4<Gj4<H:8<
HJ8=HZ<=Hj<=I:<=IZ@=Ij@=J:D>JJD>JZD>JjH>K:H>KZL>KjL>L:L?LJP?
LZP?LjT?M:T?MZT?MjX@N:X@NJ/@NZ/@Nj`@O:`@OZ`@OjdAP:dAPJhAPZhA
PjhAQ:lAQZlBQk0BR;0BRK0BR[4BRk4BSK8BS[8CSk8CT;<CTK<CT[@CTk@C
UK@DU[DDUkDDV;HDVKHDV[LDVkLDWKLEW[PEWkPEX;TEXKTEX[TEXkXFYKXF
Y[/FYk/FZ;/FZK`FZ[`FZkdG[KdG[[dG[khG/;hG/KlG/[l00QRd`003b>3H
R<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^005
0000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^004R<2h0P0000F8`;P0
14R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P30020
00ZQ[?;icMCR9Scd]KoR9ScdKGglhnWoooomkNko[K02oooo00lc@jD00800
080008000H000X3oool0187oool01X;oool12H?oool12h@138@00oooo`03
0Q660Q:6oooo00;oool00`<FR?ooo`<IR002oooo01D378X37HX47X/488/4
8H/48X`48hcoool59Hd59Xgoool5:Hh5:Xl5:hl5;8l6;I3oool6<97oool6
<Y46<i800oooo`051cRC1cVD1cZDoooo23bE00;oool01@Q0U_ooo`Q2U`U3
V0U4V003oooo05d9BIX9BYX:BiX:C9/:CI/:Ci`:D9`:DI`;DYd;Did;E9h;
EIh;Eih;F9l;FIl<FZ0<Fj0<G:4<GZ4<Gj4<H:8<HJ8=HZ<=Hj<=I:<=IZ@=
Ij@=J:D>JJD>JZD>JjH>K:H>KZL>KjL>L:L?LJP?LZP?LjT?M:T?MZT?MjX@
N:X@NJ/@NZ/@Nj`@O:`@OZ`@OjdAP:dAPJhAPZhAPjhAQ:lAQZlBQk0BR;0B
RK0BR[4BRk4BSK8BS[8CSk8CT;<CTK<CT[@CTk@CUK@DU[DDUkDDV;HDVKHD
V[LDVkLDWKLEW[PEWkPEX;TEXKTEX[TEXkXFYKXFY[/FYk/FZ;/FZK`FZ[`F
ZkdG[KdG[[dG[khG/;hG/KlG/[l00QRd`003b>3HR<2hR<2h00^8`;P00dR@
R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000
008H]<000lSPf8S0^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000fKYo7mkNkR9ScnmOSg
RIOdHVkcX:kdHVkooOoo[K3lhnWooolc@jD01000P007006000:0oooooooo
00F200J20@R200;oool0T`4;Q04<Q04=Q04>Q@8@Q@8AQP8BQP8CQ_ooo`8E
Q`<FR?ooo`<IR0<JR@<KR@<LRP<MRP@NR`@PR`@QR`@RS0@SS?ooo`DUS@DV
SOooo`DYSPDZS`D[S`D/S`H]T0H_T0H`T@HaT@HbT@HcTPLdTPLeT`LgT`Lh
T`LiU0LjU0LkU@PlU@PmUPPoUPQ0UPQ1U`Q2U`U3V0U4V0U5V0U7V@U8V@U9
VPU:VPY;VPY<V`Y=V`Y?W0Y@W0YAW0]BW@]CW@]DWP]EWP]GWP]HW`]IW`aJ
X0aKX0aLX@aNX@aOX@aPXPaQXPeRX`eSX`eTX`eVY0eWY0eXY@iYY@iZY@i[
YPi/YPi^Y`i_Y`i`Y`maZ0mbZ0mcZ@mdZ@mfZ@mgZQ1hZQ1iZa1jZa1k[11l
[11n[11o[A60[A61[Q62[Q63[Q64[a66[a:7/1:8/1:9/1::/A:;/A:=/Q:>
/Q>?/Q>@/a>A/a>B]1>C]1>E]1BF]ABG]ABH]QBI]QBJ]aBK]aBM]aFN^1FO
^1FP^AFQ^AFR^AFS^QJU^QJV^aJW^aJX^aJY_1JZ_1J[_AN]_AN^_AN__QN`
_QNa_aNb_`026;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P0
0`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2h
R<2h00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P003VjOam/S<hRHl00;o[K001mlT
;_nTW_JlaOn]/>ikS?oooc=3Y@05002000L00H000X3oooooool01H801X81
28800_ooo`2C0@^40@b40@f40@j50Q250Q660Q:60Q>6oooo0QF70aJ8oooo
0aV80aZ90a^90ab:0af:11j;122;126;12:<12><oooo1BF=1BJ=oooo1BV>
1BZ?1B^?1Bb?1Rf@1Rn@1S2A1S6A1S:A1S>B1cBB1cFC1cNC1cRC1cVD1cZD
1c^E23bE23fF23nF242F246G24:G2D>H2DBH2DFH2DNI2DRI2DVJ2DZJ2T^J
2TbK2TfK2TnL2U2L2U6L2e:M2e>M2eBN2eFN2eNN2eRO2eVO35ZP35^P35bQ
35jQ35nQ362R366R3F:S3F>S3FBS3FJT3FNT3FRU3VVU3VZU3V^V3VbV3VjW
3VnW3W2W3g6X3g:X3g>Y3gBY3gJY3gNZ47RZ47V[47Z[47^/47b/47j/47n]
4H2]4H6^4H:^4H>^4HB_4HJ_4XN`4XR`4XV`4XZa4X^a4Xfb4Xjb4hnb4i2c
4i6c4i:d4i>d4iFd59Je59Ne59Rf59Vf59Zg59^g59fg5Ijh5Inh5J2i5J6i
5J:i5J>j5ZFj5ZJk5ZNk5ZRk5ZVl5ZZl5Z^m5jfm5jjm5jnn5k2n5k6o5k:o
008H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0T00002R<2h
00E8T8P0000H]<0H]<38h=P00hS0^0800004R<2h0P0000:8`;P014R@R000
01Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7i
cMCgRIL00_ooo`07ojf`hAHdogIkojBNhRHlohUo<d>U00D008008P01P002
P?ooo`04P@05PP06PP48PP49Poooo`4;Q04<Q04=Q04>Q@8@Q@8AQP8BQP8C
QP8DQ`8EQ`<FR?ooo`<IR0<JR@<KR@<LRP<MRP@NR`@PR`@QR`@RS0@SS?oo
o`DUS@DVS@Goool0M@H]T0H_T0H`T@HaT@HbT@HcTPLdTPLeT`LgT`LhT`Li
U0LjU0LkU@PlU@PmUPPoUPQ0UPQ1U`Q2U`U3V0U4V0U5V0U7V@U8V@U9VPU:
VPY;VPY<V`Y=V`Y?W0Y@W0YAW0]BW@]CW@]DWP]EWP]GWP]HW`]IW`aJX0aK
X0aLX@aNX@aOX@aPXPaQXPeRX`eSX`eTX`eVY0eWY0eXY@iYY@iZY@i[YPi/
YPi^Y`i_Y`i`Y`maZ0mbZ0mcZ@mdZ@mfZ@mgZQ1hZQ1iZa1jZa1k[11l[11n
[11o[A60[A61[Q62[Q63[Q64[a66[a:7/1:8/1:9/1::/A:;/A:=/Q:>/Q>?
/Q>@/a>A/a>B]1>C]1>E]1BF]ABG]ABH]QBI]QBJ]aBK]aBM]aFN^1FO^1FP
^AFQ^AFR^AFS^QJU^QJV^aJW^aJX^aJY_1JZ_1J[_AN]_AN^_AN__QN`_QNa
_aNb_`026;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P90000
0XS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2002000NKYo7oooocX:kdHVkoooog
RIOicM@00_ooo`03lj2^oooo<d>U00D00800W001P002P003P@04P@05PP06
PP48PP49P`4:P`4;Q04<Q04=Q04>Q@8@Q@8AQP8BQP8CQP8DQ`8EQ`<FR0<H
R0<IR0<JR@<KR@<LRP<MRP@NR`@PR`@QR`@RS0@SS0@TS@DUS@DVS@DXSPDY
SPDZS`D[S`D/S`H]T0H_T0H`T@HaT@HbT@HcTPLdTPLeT`LgT`LhT`LiU0Lj
U0LkU@PlU@PmUPPoUPQ0UPQ1U`Q2U`U3V0U4V0U5V0U7V@U8V@U9VPU:VPY;
VPY<V`Y=V`Y?W0Y@W0YAW0]BW@]CW@]DWP]EWP]GWP]HW`]IW`aJX0aKX0aL
X@aNX@aOX@aPXPaQXPeRX`eSX`eTX`eVY0eWY0eXY@iYY@iZY@i[YPi/YPi^
Y`i_Y`i`Y`maZ0mbZ0mcZ@mdZ@mfZ@mgZQ1hZQ1iZa1jZa1k[11l[11n[11o
[A60[A61[Q62[Q63[Q64[a66[a:7/1:8/1:9/1::/A:;/A:=/Q:>/Q>?/Q>@
/a>A/a>B]1>C]1>E]1BF]ABG]ABH]QBI]QBJ]aBK]aBM]aFN^1FO^1FP^AFQ
^AFR^AFS^QJU^QJV^aJW^aJX^aJY_1JZ_1J[_AN]_AN^_AN__QN`_QNa_aNb
_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P03HS0^005B9280000
6;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P3002000^KYo7oooooRGooooocX:kaTj7ooooooOocX:ko
no`c@jD01@00P02L006000:000>100B100F200J20@R20@V30@Z30@^40@b4
0@f40@j50Q250Q660Q:60Q>60QB70QF70aJ80aR80aV80aZ90a^90ab:0af:
11j;122;126;12:<12><12B=1BF=1BJ=1BR>1BV>1BZ?1B^?1Bb?1Rf@1Rn@
1S2A1S6A1S:A1S>B1cBB1cFC1cNC1cRC1cVD1cZD1c^E23bE23fF23nF242F
246G24:G2D>H2DBH2DFH2DNI2DRI2DVJ2DZJ2T^J2TbK2TfK2TnL2U2L2U6L
2e:M2e>M2eBN2eFN2eNN2eRO2eVO35ZP35^P35bQ35jQ35nQ362R366R3F:S
3F>S3FBS3FJT3FNT3FRU3VVU3VZU3V^V3VbV3VjW3VnW3W2W3g6X3g:X3g>Y
3gBY3gJY3gNZ47RZ47V[47Z[47^/47b/47j/47n]4H2]4H6^4H:^4H>^4HB_
4HJ_4XN`4XR`4XV`4XZa4X^a4Xfb4Xjb4hnb4i2c4i6c4i:d4i>d4iFd59Je
59Ne59Rf59Vf59Zg59^g59fg5Ijh5Inh5J2i5J6i5J:i5J>j5ZFj5ZJk5ZNk
5ZRk5ZVl5ZZl5Z^m5jfm5jjm5jnn5k2n5k6o5k:o0QRd`0o8h=P00`000<SP
f<SPf00=b>3H00<0000H]<0H]<003lSPf00300006;C06;C000:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P400200i^Wl@06oooolj2^m;Fom[c5nmWJ
<d>U1P00P02L006000:000>100B100F200J20@R20@V30@Z30@^40@b40@f4
0@j50Q250Q660Q:60Q>60QB70QF70aJ80aR80aV80aZ90a^90ab:0af:11j;
122;126;12:<12><12B=1BF=1BJ=1BR>1BV>1BZ?1B^?1Bb?1Rf@1Rn@1S2A
1S6A1S:A1S>B1cBB1cFC1cNC1cRC1cVD1cZD1c^E23bE23fF23nF242F246G
24:G2D>H2DBH2DFH2DNI2DRI2DVJ2DZJ2T^J2TbK2TfK2TnL2U2L2U6L2e:M
2e>M2eBN2eFN2eNN2eRO2eVO35ZP35^P35bQ35jQ35nQ362R366R3F:S3F>S
3FBS3FJT3FNT3FRU3VVU3VZU3V^V3VbV3VjW3VnW3W2W3g6X3g:X3g>Y3gBY
3gJY3gNZ47RZ47V[47Z[47^/47b/47j/47n]4H2]4H6^4H:^4H>^4HB_4HJ_
4XN`4XR`4XV`4XZa4X^a4Xfb4Xjb4hnb4i2c4i6c4i:d4i>d4iFd59Je59Ne
59Rf59Vf59Zg59^g59fg5Ijh5Inh5J2i5J6i5J:i5J>j5ZFj5ZJk5ZNk5ZRk
5ZVl5ZZl5Z^m5jfm5jjm5jnn5k2n5k6o5k:o=QRd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;PC002009`00H000X000h4018401H801X8128812H<1
2X<12h@138@13H@13XD248D24HH24XH24hH258L25HL35XP368P36HP36XT3
6hT378X37HX47X/488/48H/48X`48h`498d59Hd59Xd5:8h5:Hh5:Xl5:hl5
;8l6;I06;i06<946<I46<Y46<i87=987=I<7=i<7>9<7>I@7>Y@7>iD8?9D8
?IH8?iH8@9H8@IL8@YL9@iP9A9P9AIP9AiT9B9T9BIX9BYX:BiX:C9/:CI/:
Ci`:D9`:DI`;DYd;Did;E9h;EIh;Eih;F9l;FIl<FZ0<Fj0<G:4<GZ4<Gj4<
H:8<HJ8=HZ<=Hj<=I:<=IZ@=Ij@=J:D>JJD>JZD>JjH>K:H>KZL>KjL>L:L?
LJP?LZP?LjT?M:T?MZT?MjX@N:X@NJ/@NZ/@Nj`@O:`@OZ`@OjdAP:dAPJhA
PZhAPjhAQ:lAQZlBQk0BR;0BRK0BR[4BRk4BSK8BS[8CSk8CT;<CTK<CT[@C
Tk@CUK@DU[DDUkDDV;HDVKHDV[LDVkLDWKLEW[PEWkPEX;TEXKTEX[TEXkXF
YKXFY[/FYk/FZ;/FZK`FZ[`FZkdG[KdG[[dG[khG/;hG/KlG/[lf6;C00XS0
^058T8P1000000000hS0^<SPf8S0^03XR<2h0DR@R04000000003R<2hb>3H
R<2h0>R8`;P1B9280@00000000>8`;S8h=S8h=P0j<SPf058T8P10000003/
R<2h0@000000\
\>"], "Graphics",
  ImageSize->{237, 171},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004/0000b2000`400?l0
0000o`00003oooo`l?0Noo3`l003omWIfOoooooooooo00cooooo003ooo3`
l1kol?3`00CofMWIooooooooooooiNGU0oooool01OoUiNGooooooooooooo
ooooiNGU00?ooooo003ooo3`l1kol?3`00gofMWIoooooooJf][oSHf=onGU
iOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003ooo3`
l1kol?3`00kofMWIoooooooooooof][Johf=SOoUiNGoooooom[Jf_n=SHgo
iNGUoooooooJf][oSHf=onGUi@7ooooo003ooo3`l1kol?3`00gofMWIoooo
ooooooooooooom[Jf_n=SHgoiNGUoooooooJf][oSHf=onGUiOoooooof][J
00;ooooo003ooo3`l1kol?3`00?ofMWIooooooooool00_ooool01ooJf][o
SHf=onGUiOoooooof][Johf=SOoUiND00oooool00?ool?3`7_o`l?000ooI
fMWoooooooooo`03ooooo`07om[Jf_n=SHgoiNGUoooooooJf][oSHf=onGU
i@02ooooo`00ooo`l?0Noo3`l003omWIfOoooooooooo00Cooooo00Oof][J
ohf=SOoUiNGoooooomcLg?n=SHgoiNGU007ooooo003ooo3`l1kol?3`00?o
fMWIooooooooool01Oooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo
003ooo3`l1kol?3`00?ofMWIooooooooool01_ooool00ooLg=coSHf=onGU
i@03ooooo`00ooo`l?0Noo3`l003omWIfOoooooooooo00Oooooo00?og=cL
ohf=SOoUiND00_ooool00?ool?3`7_o`l?000ooIfMWoooooooooo`08oooo
o`03omcLg?n=SHgoiNGU007ooooo003ooo3`l1kol?3`00?ofMWIoooooooo
ool02Oooool1omcLg07ooooo0Oooool00?ool?3`7_o`l?000ooIfMWooooo
ooooo`0<ooooo`00ooo`l?0Noo3`l0oofMWI00003on_[jooZZZZokbl_?nc
/k?o[Zj^ojn_[ong]kOo_Kfmol;2`_o8b<Soc/k>om?CdooFe]Kodm?Col[:
bP3ooooooakooooo00003onc/k?oc/k>ono_kooalO7ojn_[omoOgooEeMGo
emOGomgMgOoTi>Coj^[Zoo3`l?oclo?ol?3`onGUi@3oonk^kQkok^k^0000
3onf][Kod=3@oo7alOogmoOon?ShooOgmooXj>Sog=cLon;Rh_oVi^Kok^k^
ooCdm?ogmoOom?CdonSXj03oonKViQkoi^KV00003ong]kOod=3@oo7alOog
moOonOWioo[jn_oemOGogMgMonCTi?oZj^[olO7aooShn?ojn_[om_Kfon_[
j`3oonk^kQkok^k^00001Onj^[[odM7Aoo;bl_ohn?SonOWi00;on_[j00So
gmoOonKVi_o[jn_ol_;booWinOolo?con?Shong]kOoooooo7_ooool0000?
okZj^_oAdM7ol_;booOgmooinOWon_[joo_knon/[:coinOWong]kOodm?Co
n_[joogmoOoinOWokno_0?ook^k^7_o^k^h0000?okZj^_oAdM7ol_;booSh
n?oinOWon_[jomGEeOm3@d?o`L71onc/k?ofm_Kono_kookno_ojn_[okno_
0?ooi^KV7_oVi^H0000?okZj^_o@d=3ol_;booShn?oinOWon_[jog5aLOm3
@d?oIFEUonWYjOoemOGono_koogmoOojn_[okno_0?ook^k^7_o^k^h0000?
okbl_?oBd];ol_;booShn?oinOWo]kNgod];Bom3@d?oADE5oj^[Zoodm?Co
no_kookno_ojn_[okno_0?oooooo7_ooool0000?ok^k^ooAdM7ol_;booSh
n?o_knooGUiNodY:B_m3@d?oADE5oe=CDooXj>Soo?clookno_ojn_[okno_
0?ook^k^7_o^k^h0000?ok^k^ooBd];ol_;booShn?nPX:3oBd];odY:B_m3
@d?oADE5odM7AonATI7ono_kookno_ojn_[okno_0?ooi^KV7_oVi^H0000?
ok^k^ooBd];olo?cooShn?oinOWon_[jooKfm_oQhN7oj>SXong]kOodm?Co
o?clookno_ojn_[okno_0?ook^k^7_o^k^h0000?ok^k^ooBd];olo?cooSh
n?oinOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?clookno_ojn_[okno_
0?oooooo7_ooool0000?ok^k^ooBd];olo?cooShn?oinOWon_[jooKfm_oQ
hN7oj>SXong]kOodm?Coo?clookno_ojn_[okno_0?ook^k^7_o^k^h0000?
ok^k^ooBd];olo?cooShn?oinOWon_[jooKfm_oQhN7oj>SXong]kOodm?Co
o?clookno_ojn_[okno_0?ooi^KV7_oVi^H0000?ok^k^ooBd];olo?cooSh
n?oinOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?clookno_ojn_[okno_
0?ook^k^7_o^k^h0000=ojFUYOn`/;3o_knookNg]onb/[;o[jn_ojf][OnN
WYkoY:BTojZZZ_ne]KGoa<C4olo?c`02om_Kfooooooo7_ooool0000?ok^k
^ooBd];olo?cooShn?oinOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?cl
ookno_ojn_[okno_0?ook^k^7_o^k^h0000?ok^k^ooBd];olo?cooShn?oi
nOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?clookno_ojn_[okno_0?oo
i^KV7_oVi^H0000?ok^k^ooBd];olo?cooShn?oinOWon_[jooKfm_oQhN7o
j>SXong]kOodm?Coo?clookno_ojn_[okno_0?ook^k^7_o^k^h0000?ok^k
^ooBd];olo?cooShn?oinOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?cl
ookno_ojn_[okno_0?oooooo7_ooool0000?ok^k^ooBd];olo?cooShn?oi
nOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?clookno_ojn_[okno_0?oo
k^k^7_o^k^h0000?ok^k^ooBd];ol_;booShn?nPX:3oBd];odY:B_m3@d?o
ADE5odM7AonATI7ono_kookno_ojn_[okno_0?ooi^KV7_oVi^H0000?ok^k
^ooAdM7ol_;booShn?o_knooGUiNodY:B_m3@d?oADE5oe=CDooXj>Soo?cl
ookno_ojn_[okno_0?ook^k^7_o^k^h0000?okbl_?oBd];ol_;booShn?oi
nOWo]kNgod];Bom3@d?oADE5oj^[Zoodm?Cono_kookno_ojn_[okno_0?oo
oooo7_ooool0000?okZj^_o@d=3ol_;booShn?oinOWon_[jog5aLOm3@d?o
IFEUonWYjOoemOGono_koogmoOojn_[okno_0?ook^k^7_o^k^h0000?okZj
^_oAdM7ol_;booShn?oinOWon_[jomGEeOm3@d?o`L71onc/k?ofm_Kono_k
ookno_ojn_[okno_0?ooi^KV7_oVi^H0000?okZj^_oAdM7ol_;booOgmooi
nOWon_[joo_knon/[:coinOWong]kOodm?Con_[joogmoOoinOWokno_0?oo
k^k^7_o^k^h0000?ok^k^ooDe=Colo?cooShn?oinOWon_[jooCdm?oQhN7o
inOWong]kOoemOGono_kookno_ojn_[okno_0?oooooo7_ooool0000?ok^k
^ooCdm?ol_;booShn?oinOWon?Shon_[jooQhN7oj>SXono_koofm_Kono_k
oogmoOojn_[okno_0?ook^k^7_o^k^h0000?ok^k^ooBd];ol_;booOgmoof
m_Koj^[ZomcLg?oQhN7oj>SXonk^k_oemOGono_kookno_ojn_[okno_0?oo
i^KV7_oVi^H0000?okZj^_oAdM7ol_;boo;bl_oNg]kodm?ComWIfOoQhN7o
inOWong]kOoemOGono_kookno_ojn_[okno_0?ook^k^7_o^k^h0000?okbl
_?oCdm?ok^k^om;Bd_nYZJWoVi^Koi:BT_n9RHWoTi>CojFUYOo4a<Colo?c
ookno_ojn_[okno_0?oooooo7_ooool00006okZj^_oAdM7oaLG5oiZJV_nF
UYKoXJ6Q0onXZ:P01_nQXJ7oUiNGojf][OoRh^;on_[jono_koook^k^7_o^
k^h0000?ok^k^ono_kooX:2PojFUYOn_[joo^[Zjokjn__o3`l?o`/;2okbl
_?nf][Ko[Zj^ok6a/OoTi>Cokno_0?ooi^KV7_oVi^H0000?okfm_OnVYZKo
Zj^[okNg]oo1`L7oaLG5ol[:b_o>c/kodM7Aom3@d?o?cloob<S8okbl_?o4
a<CokNg]0?ook^k^7_o^k^h0000?okVi^On_[joo][Jfokjn__o7alOoc<c<
om7AdOoFe]Kof=SHom_KfooIfMWof=SHom;Bd_o3`l?og]kN0?oooooo7_oo
ool0000=okFe]Onf][Ko_Kfmol;2`_o9bLWod=3@omKFe_oJf][ogmoOon?S
hooRh^;ohn?SomkNgP02omSHf?ook^k^7_o^k^h0000:okBd]?ng]kOo`L71
olO7aoo?clooeMGEom_KfooPh>3oiNGUonWYj@;oj^[Z00?oinOWon;Rh_oM
gMd0oooVi^HNonKViP0000oo]KFeok^k^oo3`l?ob/[:om7AdOoHf=SogmoO
onCTi?oZj^[ok^k^oo3`l?oalO7okNg]onSXj?oShn<0ooo^k^hNonk^kP00
00[o^;Rhokbl_?o5aLGoc<c<omCDe?oLg=coh^;RonWYjOo^k^kol_;b0_od
m?@00ooalO7ok^k^onSXj03ooooooakooooo00002_nh^;So_[jnolK6a_o?
clooe]KFomoOgooUiNGok>c/oo7alOoemOD2ooOgm`03ooGemOo`l?3oj^[Z
0?ook^k^7_o^k^h0000?okRh^?no_kooa/K6om3@d?oHf=SohN7QonSXj?o^
k^kolo?cooOgmoojn_[on?ShooOgmooclo?ok>c/0?ooi^KV7_oVi^H0000:
okRh^?no_kooalO7om7AdOoIfMWoh^;RonWYjOo_knoomOGeooWin@;on_[j
00?on?Shoo?cloo]kNd0ooo^k^hNonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
oooooolNooooo`0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^hNonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0oooVi^HNonKViP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^hNonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0oooooolNooooo`0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooo^k^hNonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
oooVi^HNonKViP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^hNonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0oooooolNooooo`0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
ooo^k^hNonk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0oooVi^HNonKViP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0ooo^k^hNonk^kP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
oooooolNooooo`0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0ooo^k^hNonk^kP0000oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl0oooVi^HNonKViP0000oo^;Rhol30`?o8b<Sodm?C
om_KfooShn?oj^[Zono_koodm?ConOWioo[jn_olo?conOWiooCdm?o_knl0
ooo^k^hNonk^kP0000_o^;Rhol30`?o8b<SodM7AomKFe_oLg=cogmoOon?S
hooXj>SokNg]oo?cl`02ooOgm`03ooCdm?o_knoooooo0?oooooo7Oooool0
000>okRh^?no_kooaLG5ol[:b_o7alOo`L71okZj^_nf][Ko^[ZjolK6a_oD
e=CoiNGUono_kooalO7oonk^kQook^k^00003onh^;So_Kfmokfm_OnRY[Go
FW2XobIDZ_l:DKSo4EZiobiTZomCM9goRI6KokVi^OoGemOoinOWonc/k03o
onKViQkoi^KV00003onf][Ko^;RhohJ<Z_l]Bj?o03^do`1:^ol9F<7o66G6
ob=_bOl/M/go?6jWofalS_n/[:codm?ConGUi@3oonk^kQkok^k^00003ond
];CoVif]obe4X?l0<[7o04Bjo`AD`OlCH/Oo8Vo=obmjd?liP=?o?hCEodEd
ZOmeOHGo/k>comWIf@3ooooooakooooo00003onb/[;oFf>Po`0SZ?l3>[Co
0djmo`]K`olLJLWo;7K?ocZ1eOm3R]_oCI;Qoe6DhOm@K8coTi>Col[:bP3o
onk^kQkok^k^00003on^[Zko:SRNo`/d/om=Om3oCXkHocV0e?lPKlko<ggE
od6:gom>UnWoEj3aoejUmOmBP[[oNGUiokbl_03oonKViQkoi^KV00003on]
[Jgo31jOodAZaon8[>7oM:SPof^Sh?lUM=?o=h?LodNBiomFX??oHZgoofZf
oomMWnSoJFUYok>c/`3oonk^kQkok^k^00003on[Zj_o01bVofb@f?n;/nGo
P:oSogFZhol_O=KoA93VoeFMkomT[oooL[coog_6oome_oooH61Pojj^[P3o
oooooakooooo00003on[Zj_o026WogBJf_n=]^GoQ;?Uog^]iOlkQ=coCYGY
of2Vm_ma]_ooO/KoohS@oon2b?ooG5aLojb/[03oonk^kQkok^k^00003on[
Zj_o02R[ogFNg?n>^NKoRKGVoh2ai_m2Rn3oEYk_ofV^nomj_oooR<oooi;K
oon9coooG5aLoj^[Z`3oonKViQkoi^KV00003on[Zj_o02b/ogVTg?nA^nOo
RkWWohBdjOm8T>CoFYo/ofncoomn`_ooSM;ooiOOoonAeOooG5aLoj^[Z`3o
onk^kQkok^k^00003on[Zj_o03VcogFWh?nH`>WoUKgZohjjj_mDV>KoIjSa
ogZioon;b_ooV=Wooj;UoonKfOooG5aLoj^[Z`3ooooooakooooo00003on[
Zj_o03BbogFUgonG_n[oT;_YohZij_m?U>CoHZKaogBeo_n4a?ooTmKooikT
oonEeOooG5aLoj^[Z`3oonk^kQkok^k^00003on[Zj_o02f^ogFRg_nC^nOo
SKSWohJdjOm9S^?oG9o^ofnboOmn`?ooS=3ooi?Ioon:bOooG5aLojb/[03o
onKViQkoi^KV00003on[Zj_o02V]ofRDfOn<^>KoR;GVogf_iom0R>3oDi[/
ofF[nome^OooP/SoohS>oon0`_ooH61Pojj^[P3oonk^kQkok^k^00003on]
[Jgo32^Uocm`b_n1[N7oP:oTofnVholfP]_oBI7VoeZSm?mZ/oooM;coog[1
oomZZ>coJFUYok>c/`3ooooooakooooo00003on^[Zko:SjPo`Lf]?m2O=3o
BX_FocEoeOlYMmGo?HSPod^FjomHX_7oHjcnofN]nomDQKWoNGUiokbl_003
onk^kP03oaHF5_mUIFGok^k^00Cok^k^00?o4Q8Bo`000?l000000_l00000
0om>CTkok^k^onk^kP3oonk^kPcok^k^00003onb/[;oFf>Po`0TZ?l1>;?o
0Tbmo`]Ka?lLJ/go;W[Eocb6g?m6T>CoCiGVoe6DhOm@K8coTi>Col[:bP03
onKViP03oeADE?lD51Cohn?S00Coi^KV00?oBd];obTY:Oo?cll00_o?cll0
0ooGemOoi^KVonKViP3oonKViPcoi^KV00003ond];CoVib/obdoWol0:Zgo
03jho`1?`?l<GLKo6f[<obQed_lcOMGo>H7Dod1_Z?mdO8Go/k>comWIf@03
onk^kP03okno_ol0003o[Jf]00Cok^k^00?oeMGEoaPH6?nGUiL0ooo^k^hA
onk^kP0000oo][JfokRh^?n6RJWo;D6Oo`0/[_l0?KGo04blo`UJ`_lEHlOo
7Vc8oc=WYOmYNXko[:b/om?CdooUiND01?ooool00omKFe_oF5QHooooo`04
ooooo`03omOGeolJ6Q[oZZZZ0?oooooo4?ooool0000?okRh^?nm_Kgo_Kfm
oj:T]?mJJZCo9T^Vo`Y6]?l8CkGo95fXode`Von7T9_o^KViomOGeooWinOo
k>c/00Cok^k^00?od];Bo``<3?nh^;P01Oo^k^h00oo;bl_o6ATIoi^KV`3o
onk^kPook^k^00003onh^;So_knoolG5aOo:b/[oalO7ol71`Onj^[[o][Jf
okZj^_o6a/Koe=CDonGUiOo_knoolO7aonk^kP05onKViP03oh20P?l];Bgo
i>CT00Goi^KV00?o]KFeo`P82?nb/[80oooVi^H>onKViP0000_o^;Rhol30
`?o8b<SodM7AomKFe_oLg=cogmoOon?ShooXj>SokNg]oo?cl`02ooOgm`03
ooCdm?o_knook^k^00Cok^k^00?ojn_[ob`/;?n<S8`01_o^k^h00olj>S[o
IFEUonk^kP3oonk^kPgok^k^00003onh^;So`<30olS8b?oCdm?ofm_Kon?S
hooZj^[okno_ooCdm?oinOWon_[jooclo?oinOWom?Cdono_k`06ooooo`05
olW9bOlD51Cojn_[ooooooono_h00oooool00olb<S;oNg]kooooo`3ooooo
o`gooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`02onk^kP03oh20P?ld=3Co=3@d
00;o=3@d00Wo2@T9ohV9ROo^k^koE5ADoda<C?n?ShooFEUIo`D51OoCdm<0
ooo^k^h>onk^kP0000oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00_oVi^H00on`/;3oRXZ:
ohZ:RP03ohZ:RP07okjn__oVi^Kodm?CoibLW?mWIfOoRh^;omCDe03oonKV
iPooi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3ooooooakooooo00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^
kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKViQkoi^KV00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooo
oakooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3oonKViQkoi^KV00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^
kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooooakooooo00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKV
iQkoi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3ooooooakooooo00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^
kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKViQkoi^KV00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooo
oakooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3oonKViQkoi^KV00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^
kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooooakooooo00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKV
iQkoi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3ooooooakooooo00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^
kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKViQkoi^KV00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooo
oakooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3oonKViQkoi^KV00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^
kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooooakooooo00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKV
iQkoi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3ooooooakooooo00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^
kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKViQkoi^KV00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooo
oakooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3oonKViQkoi^KV00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^
kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooooakooooo00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKV
iQkoi^KV00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3ooooooakooooo00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^
kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonKViQkoi^KV00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooo
oakooooo00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^kQkok^k^00003onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`3oonKViQkoi^KV00003onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`3oonk^
kQkok^k^00003onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`3ooooooakooooo00002_nh^;So
_knoolO7aooAdM7ofMWIon;Rh_oYjNWokno_ooGemOoinOT2oo[jnP03ooSh
n?oclo?okNg]0?ook^k^7_o^k^h0000?okRh^?no_kooa/K6om3@d?oHf=So
hN7QonSXj?o^k^kolo?cooOgmoojn_[on?ShooOgmooclo?ok>c/0?ooi^KV
7_oVi^H0000:okRh^?nn_[koa/K6olo?cooFe]KogmoOonGUiOo/k>colO7a
ooGem@;omoOg00?omOGeoo3`l?oZj^X0ooo^k^hNonk^kP0000[o^;Rhokbl
_?o5aLGoc<c<omCDe?oLg=coh^;RonWYjOo^k^kol_;b0_odm?@00ooalO7o
k^k^onSXj03ooooooakooooo00003one]KGo^k^kol?3`oo:b/[odM7AomSH
f?oOgmooi>CTon[Zj_o^k^kol?3`oo7alOo]kNgoj>SXon?Sh`3oonk^kQko
k^k^00002_nd];Co]kNgol71`Oo7alOoclo?omGEeOoKfm_oh>3PonGUiOoY
jNT2on[ZjP03onOWiooRh^;ogMgM0?ooi^KV7_oVi^H0000=okFe]Onf][Ko
_Kfmol;2`_o9bLWod=3@omKFe_oJf][ogmoOon?ShooRh^;ohn?SomkNgP02
omSHf?ook^k^7_o^k^h0000?okVi^On_[joo][Jfokjn__o7alOoc<c<om7A
dOoFe]Kof=SHom_KfooIfMWof=SHom;Bd_o3`l?og]kN0?oooooo7_ooool0
000?okfm_OnVYZKoZj^[okNg]oo1`L7oaLG5ol[:b_o>c/kodM7Aom3@d?o?
cloob<S8okbl_?o4a<CokNg]0?ook^k^7_o^k^h0000?ok^k^ono_kooX:2P
ojFUYOn_[joo^[Zjokjn__o3`l?o`/;2okbl_?nf][Ko[Zj^ok6a/OoTi>Co
kno_0?ooi^KV7_oVi^H00006okZj^_oAdM7oaLG5oiZJV_nFUYKoXJ6Q0onX
Z:P01_nQXJ7oUiNGojf][OoRh^;on_[jono_koook^k^7_o^k^h0000?okbl
_?oCdm?ok^k^om;Bd_nYZJWoVi^Koi:BT_n9RHWoTi>CojFUYOo4a<Colo?c
ookno_ojn_[okno_0?oooooo7_ooool0000?okZj^_oAdM7ol_;boo;bl_oN
g]kodm?ComWIfOoQhN7oinOWong]kOoemOGono_kookno_ojn_[okno_0?oo
k^k^7_o^k^h0000?ok^k^ooBd];ol_;booOgmoofm_Koj^[ZomcLg?oQhN7o
j>SXonk^k_oemOGono_kookno_ojn_[okno_0?ooi^KV7_oVi^H0000?ok^k
^ooCdm?ol_;booShn?oinOWon?Shon_[jooQhN7oj>SXono_koofm_Kono_k
oogmoOojn_[okno_0?ook^k^7_o^k^h0000?okJf]_o@d=3olO7aooOgmooh
n?SomoOgonSXj?oLg=coh^;RonKVi_o^k^kom?CdooOgmoodm?Coj>SX0?oo
oooo7_ooool0000?ok>c/oo>c/kokno_oo7alOo[jn_ogmoOomGEeOoGemOo
gMgMonCTi?oZj^[ol?3`oo?cloo`l?3oiNGU0?ook^k^7_o^k^h0000?ojn_
[onZZZ[o_;blok>c/on^[Zko[jn_okNg]onm_Kgo`/;2olS8b?o>c/kodm?C
omKFe_oCdm?ob/[:0?ooi^KV7_oVi^H00?ooOgmo;OmoOgl00004on_[jooV
i^Koh^;RomkNgPCogMgM0ooNg]h0P_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oM
gMd2omcLg02Aom_KfooMgMgog=cLomgMgOoMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMg@03omkNgP03omgMgOoNg]kog]kN00?ogMgM0OoQhN41onOWi`7oj^[Z
00000oo/k>coi^KVon3Ph007omWIf@04omSHf?oFe]Kodm?Com3@d0?ocLg=
00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=
c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=
cLd01?o@d=3odm?ComOGeooHf=PlomWIf@;of=SH00?ofMWIomSHf?oHf=P0
0ooIfMT2omSHf0GofMWI00?of=SHomKFe_oCdm<00_oCdm<00ooFe]Kof=SH
omSHf00>omWIf@04omSHf?oIfMWofMWIomSHf13ofMWI0_oHf=QXomWIf@03
omSHf?oIfMWofMWI00KofMWI0OoNg]h1onKViP7ok>c/00001oo^k^kojNWY
onCTi?oPh>3ohN7Qon3Ph?oRh^800_oQhN403OoNg]kog=cLom?Cdoo7alOo
^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml02OoQhN403OoO
gmoofm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_K
fooOgml02OoQhN403OoOgmoofm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:b
ok^k^oo7alOodm?Com_KfooOgml0;OoQhN4:on3Ph003omoOgooPh>3oh>3P
00KogmoO0_oPh>03omoOg`Goh>3P00OogmoOom_KfooGemOoe=CDomGEeOoI
fMWogMgM00;oh>3P00?ogmoOon3Ph?oPh>000_oQhN47on3Ph0KogmoO00?o
h>3PomoOgooPh>002ooPh>001?oOgmoog]kNomkNg_oOgml2on3Ph6OohN7Q
00?oh^;Ron7QhOoRh^801?oQhN41onCTi07ojNWY0Oo]kNd00003oo3`l?o_
knoolO7a00?ol?3`06[okno_oo3`l?o^k^kojNWYom_Kfoo1`L7oY:BTohb<
S?mkNg_oMgMgog]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_
oo7alOo_knoolO7_ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_o
Ng]kogMgMomkNg_oS8b<ojBTY?o2`/;of][Jon[Zj?o]kNgolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ong]kOoZj^[of][Jol;2`_nTY:CoS8b<og]k
NomgMgKoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knool?3`0_o/k>`01oo[jn_o
k^k/onc/k?o]kNgok>c/onk^k_oZj^X00_o[jn/02_o^k^cojNWYonSXj?oV
i^KojNWYonKVi_oZj^[ojn_[ong]jooXj>P2onWYj@07ong]kOoZj^[ok>c/
onc/k?o_kngoj^[ZonSXj002on?Sh`0=omoOgooShn?oj>SXong]jooZj^[o
jn_[onc/k?o`l?3okno_oo3`l?o]kNgok>cZon[ZjP02onk^kP06ono_kooZ
j^[ojNWYonKVi_oXj>KoinOW0_oYjNT01_o/k>cojNWYonc/k?o]kNgok^k/
on[ZjP;ok>c/00Sok^k^on[Zj_o/k>cok>c/ono_kOo[jn_ojNWYonKViP;o
j>SX0_o]kNd0KOo`l>kokno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aoo3`l?o_knool?3`ono_koo`l?3okno_oo3`l?o_knl01?o`
l?000003oo;bl_o^k^koinOW00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:
R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN
0_oTi>@00ooUiNGoi>CTonGUi002onCTi00?omkNg_oAdM7o/K6aohZ:R_mV
IVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM3og]kN00;o
i>CT04;oiNGUonCTi?oUiNGoi>CTonCThooNg]kodM7Aok6a/On:RX[oIVIV
oe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7AomkNg_oTi>?o
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTon?ShooNg]h2
om_Kf`0:omkNgOoLg=cofm_KomcLg?oOgmoofm_KomWIfOoLg=cogMgLomOG
e`?oeMGE00Coe=CDomWIfOoMgMgogMgL0_oGemL04_oKfm_ogMgMom[Jf_oJ
f][og]kNon7Qh?oKfm_of=SHodI6A_l`<33oN7Qhol;2`_oJf][og]kMom[J
f_oIfMWogMgMon?Sh`;oi>CT01KogmoOomcLfooIfMWogmoOon;Rh_oQhN7o
fm_KomKFe_oDe=Coe]KEomCDe?oFe]Kofm_KomcLg?oHf=Sog=cLomoOgooO
gmkofMWIom_KfooNg]kogmoO0_oJf]X0KooMgMgoh>3Oom_KfooGemOoeMGE
omOGeooIfMWogmoOon;Rh_oTi>?oi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi004onGUi@06onCTi?oUiNGoiNGUonGUiOoX
j>SokNg]0Oobl_800003ooCdm?o]kNgoinOW00;oh>3P01?ohN7QomoOgooN
g]kod];BokBd]?n7QhOoG5aLofdk=OnNCT;ocFmOonV3Koo=KeooWTi3ofdk
=_mLG5coQhN7okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7
oeaLG?m]H2coWYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aLohN7Qond];Co
d];BomkNgP05on3Ph00AomkNg_oBd];o];BdohN7QomLG5coAfL^ofRN<onA
cDOoZ^UEoi7=AomZWSCoBFX_oeaLG?n7QhOo];Bdom;Bd_oNg]h0:ooPh>00
@ooNg]kof=SHom;Bd_oDe=Coe]KFom;Bd_o?clood];BomKFe_oCdm?odM7A
omGEeOoFe]Kod=3@olC4a?o;bl_oclo?olW9bOo4a<Cof=SHomGEeOo@d=3o
a<C4om3@d?oHf=Sod];Bom7AdOoHf=Sofm_KomKFe_oAdM7oUIFEoj2PX?ln
?SkoBd];omCDe?oHf=Sod];Bom7AdOoHf=Sog]kNon3Ph?oOgmoof][Jom?C
dooAdM7of=SHomgMgOoJf][odm?Colo?coo0`<3od=3@olg=cOno_kooe=CD
omKFe_oAdM7oe=CDomWIfOoHf=SodM7Aom;Bd_oHf=SofMWIom?CdooAdM40
0_oGemL02?oAdM7oclo?olS8b?o4a<Cof=SHom_KfooNg]kogmoOI?oPh>00
0ooOgmooh>3PomoOg`02omoOg`?oh>3P00?ohN7QonOWioo/k>`00Oodm?@0
0003ooKfm_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgoWinOof]OGon?
=RkokG5QooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=
cOoRh^;oinOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOofiVGonCLR;okM54
ooWcM?omoHgooOfEoogmS_oin7KokMM7oi=c8_m^IeooWinOolg=cOoRh^;o
inOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOof1XGom;O2?oT^5;okgiNoo@
oI;of?fKomCmUOo0nGkoV>Q=odf09?mPJEooWinOolg=cOoRh^;oinOW02[o
j>SX02Woi^KVomoOgol`<33oShn?om_Kfoo7alOoR8R8olG5aOoKfm_oYJFU
o`410OoMgMgog]kNofe]KOl820So4A4Aog=cLol`<33o92@TomgMgOoKfm_o
Bd];o``<3?mRHV;ohN7Qofe]KOlj>S[ogmoOon?Shoo3`l?o0000ol71`OoQ
hN7oX:2Po`d=3OoGemOog]kNogemOOlG5aOogMgMonCTi002onKViP0Don;R
h_moOgoo:2PXomoOgooUiNGohn?SokJf]_lO7aoo2@T9ocHf=_mdM7Co20P8
oiJFU_oMgMgo3`l?oiNGUooQhN7ogmoOod92@_mTI6@2on3Ph00<ogEeMOlb
<S;ogMgMom_Kfonn_[ko?3`lo`820_lO7aoo5ADEokBd]?oVi^KoinOWKOoX
j>P1onc/k07ol_;b0Oofm_H00003ooOgmoohn?Son?Sh00?on?Sh01?omoOg
onk^k_o>c/koT92@ohD_:ooYI5Koni:7oojVVoon/JGookR[oojcY_onZ9co
niB9oniXFOn9<B_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>
c/koT92@oiUY:oo`_Cgonn1^ookdP_onoX[ooonBooknS?onn8?onnE`oo32
?_nIJR_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@
od9c:on4cT?o[Nmcol;nR?o>oY3oe_nGom3nT_o6oXWo/_EdohSC@om4MB_o
T92@olk>c_o^k^komoOg02[on?Sh02oom_Kfono_kolc<c?oVIVIonOWion3
Ph?o0000ogalO?oXj>So/;2`o`410Oo]kNgohn?So`H61_nRXZ;ogMgMogMg
Mol0003oc/k>oo3`l?o2`/;o0000om7AdOodm?ColO7aogEeMOln?Skok^k^
oo;bl_o@d=3o0000olo?cooalO7ob<S8o`000?o3`l?ok^k^ohJ6Q_lI6AWo
jNWYono_koobl_;om?Cdoo7alOn8R8So:b/[onk^kP02ooGem@0LofATI?lo
?cooiNGUok>c/olO7aooIfMWono_koo]kNgo410@oj:RX_o`l?3okno_odM7
Aom[Jf_okno_oo3`l?mnOWko=CDeon_[jooXj>So=cLgodA4A?o>c/koinOW
omgMgOoTi>ComOGeooOgmfKon?Sh00?omoOgooShn?ohn?P00_ohn?P01?og
moOonOWiooOgmoogmoL1ooShn00000?on_[jooGemOo^k^h00_o/k>`0ZOo[
jn_ojNWYomoOgonj^[[oNE9Boklb9?oWM6WooHUnoonHS?onXYKoojRLoojT
V?ooVXgooXYoonifJ_o3<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/
on[Zj_oOgmoo^[ZjohQUD_oRTAconL=@oogJHooojW;oo_=nooojP_onmWoo
onacookNI?ojae7ohY8LohUVDonj^[[ogmoOon[Zj_o[jn_ok>c/on_[jooZ
j^[ogmoOokZj^_mBKE;oDJ<Loi7BEOnVif[o^?Ujol3nP_o7ohWo`oj4okWm
NonWk6coU=IGoe:V7?mBKE;o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojNWYon?Shol`<33oT92@omSHfOl];Bgo@410
ob<S8ooJf][oYZJVo`410OoQhN7ohn?Toa0@4?mlO7cogmoOokBd]?l0003o
dM7AonCTi?nHV9Wo3`l?on3Ph?oWinOohn?Sofm_Kolk>c_ogmoOon7Qh_o3
`l?o0000olG5aOoTi>Co_knoo`000?nh^;SohN7RogmoOolG5aOofMWIomgM
gOoQhN7oiNGUonCTi?n1PH7o:2PXomoOgooVi^Koj>SXogAdM?lO7aoofMWI
omcLgOlk>c_oKfm_onCTi?oPh>3o3`l?oiRHV?oQhN7ogmoPod=3@omUIFD0
0_oPh>00KomgMgOo<S8bon3Ph?nh^;Wo0000ojRXZ?oLg=cofMWIom_KfooQ
hN7ojNWYon[Zjoo/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k007on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT00003oo_knooc
lo?okNg]00;oiNGU0;3oi^KVonCTi?oIfMWo/[:bogT^;_o8@SCohfYLooAj
KOomR7cooYN:oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;of=SH
onCTi?oUiNGoi^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^lA?onc5?o
oMQRookSL_onjGGoo^IcookKIOomc5?onl55onjN:onIERko/[:bomSHf?oT
i>CoiNGUonKVi_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on7bTSoUmaIojGU
JOnblgOo^?IkokCeNOnWjV_oV=aIohW?BomS[R_o;V<^ok:b/_oHf=Woi>CT
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVon?ShooMgMgo;bl_
oh^;Rona/K;o0000okNg]olU9BGoZ:RXoj2PX?l10@7og=cLon3PhOnb/[;o
>CTiobDU9Olk>c_o0000olg=cOoMgMgoTi>Doa0@4?oFe]Kog]kNomcLg?m/
K6co>CTiomCDe?oFe]Oo_;blo`000?o2`/;ogmoOok^k^ol0003o];BdomcL
g?mlO7co5aLGomKFe_oJf][og]kNon3Ph?oOgmooOGenobLW9ooEeMGog=cL
omkNg_oKfm_oI6ATob0P8?ll?3co4a<Cofe]KOoPh>3og=cLo`l?3onCTi?o
emOGomGEe_m1@D7oHV9RomOGeooFe]KoLg=coc4a<OoMgMgoVYZKo`0000Co
=cLg06Oo/[:bonCTi?oTi>Goi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGU00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGo
kNg]ooCdm001oo_kn`0000?oo?clooShn?oalO400oo^k^h04oo[jn_ohN7Q
okbl_?mj5aOo`clbom=FBOoTJ5[okgM/ooB3NOohQgcomHAjoo=iKOoUJE_o
fEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?nU
AaOoiYLbooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlbonVK
<_nUAQOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOoGjPb
ogJm=on6cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lGFAOo
_;blon7QhOo/k>`0:_o^k^h09oo/k>coiNGUoc4a<On?ShooKVi^ob`/;?oX
j>SoOGemoeiNG_nTY:Co0@41on?ShooYjNWoi^KVon;Rh_oPh>3o[Jf]o`00
0?oGemOoi>CToiRHV?l@413ogMgMon?ShooTi>CoL71`ob@T9?oFe]KogmoO
okno_ol0003obl_;onWYjOo1`L7o0000okZj^_oTi>CoPH61o`H61P03ochn
?P0Rol_;booYjNWoQ8B4oaXJ6_oJf][oh^;RonGUiOoWinOohn?Son3Ph?oH
f=So=cLgog9bL_oZj^[oinOWo`l?3on9RHWogmoOomkNg_m3@d?oEUIFon3P
h?oOgmooMgMgoc<c<ooYjNWo_[jno`000?nPX:3o][JfojZZZ_l20P;ofMWI
ong]kFgok^k^00?okNg]oo;bl_ohn?P00Oolo?`000?ooOgm01Koo?cloogm
oOomoOgoo?cloo?clooAdM7oJ0L7okPd=?o7?c?odU13omYREOoSKV;oi79T
onA_H_oLI5Oode53ola1=?ni=3CoJ`L7om;Bd_oclo?oo?cl0oomoOd04ool
o?colo?com;Bd_nN:`OofXXdon^K6OoeZ2Won;@oooVmB_oh_dgon[m:ooVh
?oofZR[okihIom^;=?nR;@Ood];Boo?cloolo?`00oomoOd04oolo?colo?c
om;Bd_l7@0OoCIXdoen[8?m`^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^Boo
HZhPodjK=?l7@POod];Boo?cloolo?`0:_omoOd0C?okno_om?Cdoc@d=?nG
UiOo7alOohN7Qoojn_[ogMgMoa<C4onYZJWo0@41oo;bl_oinOWo`<30olC4
a?oclo?oS8b<ob4Q8Oojn_[omOGeoifMWOl@413oi^KVonk^k_odm?CoN7Qh
oa4A4Om<C4cob/[:ohV9ROlD51Com_KfooWinOo>c/ko0000olK6a_oclo?o
RHV9oa<C4onf][Ko^KViokZj^_o]kNgonOWiohn?Sol<30coEeMGom7AdOo]
kNgok>c/ojJVY_oVi^Koi>CToa8B4_n][Jgono_koo[jn_l@413o7QhNojFU
YOoLg=co6QXJob0P8?mmOGgog]kNodM7AomOGeoono_koo[jn_ld=3CoLG5a
onk^k_n>SXko=CDeoo_knoolo?a[oogmo@03ooclo?omoOgoo?cl00?ooOgm
0000>_omoOgon_[joo?cloo^k^kol?3`ono_koo^k^kojNWYom?CdomK7Ago
XS@dok@X7Oo1>RgoadTlolmFB_o@Ed_od5M:olY:?_o3>bko]RPMoj8d=?mL
7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>ook^k^on[Zj_oCdm?oS2DMolQa
=?oIQ1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/X2GoiiLEomb87Oo8LCCoS2DM
om?CdooZj^[ok^k^oo3`l?o_knool?3`onk^k_oZj^Wodm?Coadh7OldPSCo
AiDMoeZU6omY[BX2ogBh>01mogFi>?m[/B_oFjLLodRJ7OldPSCo7CPMom?C
dooZj^Wok^k^oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_onk^
k_oWinOo<C4aoemOGol10@7od];Bonk^k_o/k>co@D51of5QHOl10@7oi^KV
onk^kOnPX:3o>CTioa4A4OlV9RKoV9RHono_koo5aLGo410@o`410OlI6AWo
DU9BonWYjOmaLG7o?CdmoiNGUolO7aoo61PHoi6ATOo^k^kokNg]ol?3`ol0
003o_;blonSXion2PX;o61PHomoOgooRh^;ohn?SonOWioo[jn_oTi>Boclo
?onBTY;o5aLGoiBDU?oPh>3oCdm?oalO7olA4A7oCdm?onSXj?o^k^kokno_
obLW9onPX:3oCTi>o`T92Olf=SKoh>3Pofi^K_l?3`oo;2`/okjn__o^k^ko
kno^om;Bd_ll?3co2`/;oadM7Onb/[800_o_knl0I_o`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_k`;ol?3`1_o_knl1
oo?cl`7onOWi0Oono_h00003ookno_ogmoOol?3`00CojNWY017oinOWom_K
fomSBd_oPC8bojHe=Onf=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDe
oh4b<_mSBd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oRD];ojm;<_o=McGo
eX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;oRD];om_KfooW
inL01OoYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[ZbooL:dhofn^
>_m`[CSoJZX_oe>K;OliR3Go<V0bod];BooKfm_oinOW02_ojNWY00goj>SX
onCTi?l`<33o4Q8Boc`l??oVi^Koj>SXonOWionCTi?o4A4Ao`410OoShn?o
inOW00;ojNWY00?oinOWonWYjOoYjNT00_oXj>P05?nMWIgo410@onOWiooW
inOoi>CTofm_Kolk>c_ohn?SonOWiooXj>SojNWYonSXj?oWinOo`/;2o`00
0?nj^[[oi>CToh20P?lG5aOogMgM0_oNg]h00ooQhN7oi^KVonSXj002onWY
j@03onSXj?oWinOojNWY00;ojNWY00?oinOWonWYjOoYjNT00ooYjNT00ooX
j>SojNWYonSXj003onWYj@03onOWiooYjNWojNWY00CojNWY00?oi^KVonWY
jOoYjNT0JOoYjNT00ooXj>SojNWYonWYj@04onWYj@7ol?3`0OogmoL1ookn
oP0000Goo_knoo[jn_odm?Cokno_oo7al@02oo3`l00Aono_koo[jn_oUIBD
odlS8onEE5Co^g=com>EUOoJW9cofYjLomVLW?oDUIGo^g=coiEDE?m?8b?o
UIBDon[Zj_o_knl01Oo`l?004Oo_knooj^[ZojVDU?n18b?o^VYDomBJLooT
_9Goj/NLonW7W?oZaicoiKbEomBJLonkJUCoPB<SojZDU?oZj^[okno_00Go
l?3`017okno_on[Zj_nDU9Co8bXSoeAjE?mcYG?oW/JEojc>W?n]cYco[<jL
oik6UOmcYG?oE7YDob<Z8onDU9Coj^[Zono_k`0[oo3`l005ono_koo^k^ko
<S8bo`000?nCTi<00oo_knl01OoTi>Co2`/;o`410Oo^k^kokno_00Ool?3`
00Wohn?Sokno_oo_knookno_onk^k_mdM7Co?Cdmong]kOo_knl00oo`l?00
1oo_knoob/[:o`000?o3`l?ok^k^ohJ6Q_l92@T00omNGUh00omiNGWok^k^
ono_k`0<oo3`l003ono_koo`l?3ol?3`07col?3`00ColO7aoo3`l?odm?Co
n_[j0Oono_h00004oogmoOooooooooooooknoP;ooooo0_ono_h0K_omoOgo
n?Shofi^K_mJ?coo/I2@omk9bOo`i>ColnKVoo3Ti?oNbLWo/I2@oeXo?om]
KFgon?Shooclo?ooooooo_knooooooono_koooonookno_ooooooo?clooSh
n?n=KFgoRSloolVAT?oYd<Wom>WTooK[i_odjNCojM39olVAT?n9?cooSFe]
ooShmoolo?coooooookno_ooooooo_knooooooono_koooonooclo?ohn?So
KFe]oclo?on@WI3obMG9onC/i?oVk^Koi>cTolWEbOn@WI3o?cloofe]KOoh
n?Soo?clooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_kooooooogmoOn_[jooV9RHoo7al?omoOgooooo0_ono_h05_nd];CoVYZJ
oogmoOooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
oooooogmoOono_koO7alod51@OomoOgoo_kmookno_ooool2ooknoP2Conk^
k_nIVIWojn_[ooknoOoAdM7oVIVIoiRHV?nIVIWoV9RHojb/[?omoOgoooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
00;ooooo00?oo_knooooooooool00oooool1ooSkoP0000Con_[jookno_oj
n_[om?Cd1OoalO403Oo_knooe]KFof][Jom3?CgoVhb<olJj^_oFc<coakZj
oi^<S?m3?CgoJf][omKFe_o_knl02OoalO403Oo_knooemKFoh=[Jomd?Cgo
]Hb<omFj^_oQc<coe[ZjokJ<S?mb?CgoPF][omOFe_o_knl02OoalO403Oo_
knooe]KFof][Jolm?CgoS8b<okZj^_o<cLco^[Zjohb<S?lm?CgoJf][omKF
e_o_knl0A_oalO400oo^k^kokNg]oo7al@2Eoo7al@04oo3`l?oalO7olO7a
oo3`l0ColO7a00?om?Cdoo[jn_ono_h00OoZl_`00005ooCdm?omoOgon?Sh
oo3`l?o[jn/00ooZj^X03OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUIFOlV9RKo
2@T9obHV9_mIFEWoVi^KonSXj?oYjNT02ooZj^X02ooYjNWoj>SXoj2KVomZ
FEWo@bHVobd92Om29RKoJEUIoj2KVooXj>SojNWY00_oj^[Z00_ojNWYonSX
j?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@3Von[ZjP04
on_[joo`l?3on?Shoogmo@7ocmk`00001?nk^k_on?Shoo[jn_odm?@8oo7a
l@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`
l0?okno_0_o`l?3Too7al@03oo3`l?oalO7olO7a00;olO7a00?omOGeoo[j
n_oWl?X00OnGZL000003ol30`?nn_[komoOg0?oooooo9oooool1onSan`7o
Y;C80OnI/<`00006on;Rh_o6a/Ko^k^kon_[joojn_[ooOgmoooooolQoooo
o`05ooWko_oZlO_ocmg_oiNY_onI[l/00On^b>P00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{300, 200},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleJScrollBar",
        ButtonData:>{"SimpleJScrollBar.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[BoxData[
    \(SimpleJScrollBar[]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JScrollPane <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000005R<2hb>3HR<2hR<2hc<c<
0?ooooooooooNOooo`:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVK<
c<coIVIVofIVIWMVIVH01?ooohS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooJ?ooo`03IVIVc<c<IVIV00eVIVH01?ooohS0^8S0
^4R@R04000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIV
ooooc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oooooooooofSoool00fIVI_ooolc<c00<c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo
00=VIVKoooo<c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVooooc<c<00c<c<`01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooooooo
ofSoool00fIVI_ooolc<c004c<c<0P0000K<c<`01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVI_oo
olc<c003c<c<100000G<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVI_ooolc<c002c<c<1P00
00C<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP3oooooooooofSoool016IVI_ooolc<c<c<c0P00003c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo
00=VIVKoooo<c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVooooc<c<00c<c<`01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooooooo
ofSoool00fIVI_ooolc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVKoooo<c<`03<c<
c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooJ?ooo`03IVIVooooc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVI_oooooo
o`0<oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH0oooooooooomXoooo00=VIVK<c<aVIVH03FIVIP04ooooR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooo
oomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?oo
o`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool20000
0_ooo`800002oooo100000;oool200000_ooo`800002oooo0P0000Ooool2
00000oooo`@0003oooooooooocooool00fIVIYVIVLc<c00<c<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool2000000?o
ool0000000000_ooo`800002oooo0P000003oooo0000000000;oool20000
0_ooo`800007oooo0P0000;oool200000_ooo`80003oooooooooockoool0
0fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoool2000000?oool0000000000_ooo`800005oooo0P00
00;oool200000_ooo`800007oooo0P0000;oool200000_ooo`80003ooooo
ooooockoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoool2000000?oool0000000000_ooo`H0
00000oooo`0000000002oooo0P0000;oool200001oooo`800002oooo0P00
00;oool20000oooooooooolnoooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo0P000003oooo
0000000000;oool200000_ooo`8000000oooo`0000000002oooo0P0000;o
ool200001oooo`800002oooo0P0000;oool20000oooooooooolnoooo00=V
IVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo0P000003oooo0000000000;oool200000_ooo`800000
1Oooo`00000000000?ooo`03000000?oool0000000001Oooo`040000oooo
000000000_ooo`800002oooo0P000?oooooooooo?_ooo`03IVIVVIVIc<c<
00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooo`H00002oooo100000;oool2000000?oool0000000000_ooo`800006
oooo100000;oool200000_ooo`80003oooooooooockoool00fIVIYVIVLc<
c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVKoool2000000?oool0000000006Oooo`<00002oooo0P0000;oool20000
oooooooooolnoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo0P0000;oool00`000?oooooo
o`0Hoooo0P0000?oool40000oooooooooolooooo00=VIVJIVIW<c<`03<c<
c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<
c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIV
VIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo
00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooooooo
ofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
0P0000;oool200000_ooo`@00002oooo0P0000;oool200000_ooo`800005
oooo0`000?ooooooooooAoooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooo`8000000oooo`00
00000002oooo0P0000;oool2000000?oool0000000000_ooo`800002oooo
0P0000Coool200000_ooo`030000oooooooo0?ooooooooooA?ooo`03IVIV
VIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVI_ooo`8000000oooo`0000000002oooo0P0000Goool200000_oo
o`800002oooo0P0000Soool20000oooooooooom5oooo00=VIVJIVIW<c<`0
3<c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIV
oooo0P000003oooo0000000000;oool6000000?oool0000000000_ooo`80
0002oooo0P0000Goool50000oooooooooom5oooo00=VIVJIVIW<c<`03<c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
0P000003oooo0000000000;oool200000_ooo`8000000oooo`0000000002
oooo0P0000;oool200001?ooo`800002oooo0P000?ooooooooooAOooo`03
IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SP
f8S0^8S0^6IVI_ooo`8000000oooo`0000000002oooo0P0000;oool20000
00Goool000000000003oool00`000003oooo0000000000Coool200000_oo
o`80003oooooooooodGoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool600000_ooo`@00002
oooo0P000003oooo0000000000;oool200001Oooo`800002oooo0P000?oo
ooooooooAOooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooo`8000000oooo`000000000Goooo
0P0000;oool20000oooooooooom5oooo00=VIVJIVIW<c<`03<c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo0P0000;o
ool00`000?ooooooo`0Foooo10000?ooooooooooA_ooo`03IVIVVIVIc<c<
00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJI
VIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool0
0fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oooooooooo
J?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooo
oooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<
00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
I_ooo`800002oooo0P0000;oool400000_ooo`800002oooo0P0000;oool2
00001Oooo`@0003oooooooooodKoool00fIVIYVIVLc<c00<c<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool2000000?o
ool0000000000_ooo`800002oooo0P000003oooo0000000000;oool20000
0_ooo`800004oooo0P0000;oool20000oooooooooom5oooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVoooo0P000003oooo0000000000;oool200001Oooo`800002oooo0P00
00;oool200001?ooo`800002oooo0P000?ooooooooooAOooo`03IVIVVIVI
c<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVI_ooo`8000000oooo`0000000002oooo1P000003oooo0000000000;o
ool200000_ooo`800004oooo0P0000;oool20000oooooooooom5oooo00=V
IVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo0P000003oooo0000000000;oool200000_ooo`800000
0oooo`0000000002oooo0P0000;oool200001Oooo`@0003oooooooooodKo
ool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoool2000000?oool0000000000_ooo`800002oooo
0P000005oooo000000000000oooo00<000000oooo`0000000004oooo0P00
00;oool20000oooooooooom5oooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo1P0000;oool4
00000_ooo`8000000oooo`0000000002oooo0P0000Goool200000_ooo`80
003oooooooooodGoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool2000000?oool000000000
5oooo`800002oooo0P000?ooooooooooAOooo`03IVIVVIVIc<c<00c<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooo`80
0002oooo00<0003oooooool05_ooo`@0003oooooooooodKoool00fIVIYVI
VLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03
IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomX
oooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`0
3<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVI
VLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoool200000_ooo`800002oooo100000;oool200000_ooo`800002
oooo0P0000Goool20000oooooooooom8oooo00=VIVJIVIW<c<`03<c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo0P00
0003oooo0000000000;oool200000_ooo`8000000oooo`0000000002oooo
0P0000;oool200001Oooo`80003oooooooooodSoool00fIVIYVIVLc<c00<
c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKo
ool2000000?oool0000000000_ooo`800005oooo0P0000;oool200000_oo
o`800005oooo0P000?ooooooooooB?ooo`03IVIVVIVIc<c<00c<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooo`800000
0oooo`0000000002oooo1P000003oooo0000000000;oool200000_ooo`80
0006oooo0P000?ooooooooooAoooo`03IVIVVIVIc<c<00c<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooo`8000000ooo
o`0000000002oooo0P0000;oool2000000?oool0000000000_ooo`800002
oooo0P0000Koool20000oooooooooom7oooo00=VIVJIVIW<c<`03<c<c005
IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo0P00
0003oooo0000000000;oool200000_ooo`8000001Oooo`00000000000?oo
o`03000000?oool0000000001oooo`80003oooooooooodKoool00fIVIYVI
VLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8
`;QVIVKoool600000_ooo`@00002oooo0P000003oooo0000000000;oool2
00002?ooo`80003oooooooooodKoool00fIVIYVIVLc<c00<c<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool2000000?o
ool0000000006oooo`80003oooooooooodGoool00fIVIYVIVLc<c00<c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool2
00000_ooo`030000oooooooo01Goool60000oooooooooom5oooo00=VIVJI
VIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool0
0fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oooooooooo
J?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooo
oooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<
00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJI
VIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2h
R<2hIVIVoooo0P0000;oool200000_ooo`@00002oooo0P0000;oool20000
0_ooo`800005oooo10000?ooooooooooA_ooo`03IVIVVIVIc<c<00c<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooo`80
00000oooo`0000000002oooo0P0000;oool2000000?oool0000000000_oo
o`800002oooo0P0000Coool200000_ooo`80003oooooooooodGoool00fIV
IYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoool2000000?oool0000000000_ooo`800005oooo0P0000;o
ool200000_ooo`800004oooo0P0000;oool20000oooooooooom5oooo00=V
IVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo0P000003oooo0000000000;oool6000000?oool00000
00000_ooo`800002oooo0P0000Coool200000_ooo`80003oooooooooodGo
ool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoool2000000?oool0000000000_ooo`800002oooo
0P000003oooo0000000000;oool200000_ooo`800004oooo0P0000;oool2
0000oooooooooom5oooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVoooo0P000003oooo00000000
00;oool200000_ooo`8000001Oooo`00000000000?ooo`03000000?oool0
000000001?ooo`D0003oooooooooodKoool00fIVIYVIVLc<c00<c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool60000
0_ooo`@00002oooo0P000003oooo0000000000;oool200001Oooo`80003o
ooooooooodWoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000J8`;S8h=R8`;R8`;QVIVKoool2000000?oool0000000006?oo
o`030000oooooooo0080003oooooooooodGoool00fIVIYVIVLc<c00<c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool2
00000_ooo`030000oooooooo01Ooool30000oooooooooom6oooo00=VIVJI
VIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool0
0fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oooooooooo
J?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oiVI
c?nIVLaXVIW<00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB9280040
00000006R<2hb>3HR<2hR<2hIVIVVIW<olc<ooo<c?mVc<co00>IVLaVIVJI
VIT03Lc<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVVIW<olc<ooo<c?mVc<co00>IVLaVIVJIVIT03Lc<c005IVIVooooR<2h
R<2hB928004000000006R<2hb>3HR<2hR<2hIVIVVIW<olc<ooo<c?mVc<co
00>IVLaVIVJIVIT03Lc<c005IVIVooooR<2hR<2hB928004000000006R<2h
b>3HR<2hR<2hIVIVVIW<0P0000;<c?l200000/c<o`@00002c<co0P0000;<
c?l200000/c<o`800005c<co10000?o<c?ooc<coALc<o`03VIW<IVIVVIVI
00g<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IV
IYVIc08000000lc<o`0000000002c<co0P0000;<c?l2000000?<c?l00000
00000/c<o`800002c<co0P0000C<c?l200000/c<o`80003oc<coolc<odC<
c?l00iVIc6IVIYVIV@0=c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVJIVL`2000000?<c?l0000000000/c<o`800005c<co
0P0000;<c?l200000/c<o`800008c<co0P000?o<c?ooc<coA<c<o`03VIW<
IVIVVIVI00g<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0
^8S0^6IVIYVIc08000000lc<o`0000000002c<co1P000003c<co00000000
00;<c?l200000/c<o`800008c<co0P000?o<c?ooc<coA<c<o`03VIW<IVIV
VIVI00g<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0
^6IVIYVIc08000000lc<o`0000000002c<co0P0000;<c?l2000000?<c?l0
000000000/c<o`800002c<co0P0000C<c?l200000/c<o`80003oc<coolc<
odC<c?l00iVIc6IVIYVIV@0=c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVJIVL`2000000?<c?l0000000000/c<o`800002
c<co0P000005c<co000000000000c<co00<000000lc<o`0000000004c<co
1@000?o<c?ooc<coALc<o`03VIW<IVIVVIVI00g<c<`01FIVI_ooohS0^8S0
^4R@R001000000001XS0^<SPf8S0^8S0^6IVIYVIc0H00002c<co100000;<
c?l2000000?<c?l0000000000/c<o`800005c<co0P000?o<c?ooc<coB<c<
o`03VIW<IVIVVIVI00g<c<`01FIVI_ooohS0^8S0^4R@R001000000001XS0
^<SPf8S0^8S0^6IVIYVIc08000000lc<o`000000000Hc<co0P000?o<c?oo
c<coAlc<o`03VIW<IVIVVIVI00g<c<`01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVIYVIc0800002c<co00<0003<c?o<c?l05/c<
o`D0003oc<coolc<odC<c?l00iVIc6IVIYVIV@0=c<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVLcoc<coolc<ofK<c?l0
0iVIc6IVIYVIV@0=c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVJIVLcoc<coolc<ofK<c?l00iVIc6IVIYVIV@0=c<c<00EV
IVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVJIVLcoc<co
olc<ofK<c?l00iVIc6IVIYVIV@0=c<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVJIVLcoc<coolc<ofK<c?l00iVIc6IVIYVI
V@0=c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH0oiVIc?nIVLaXVIW<00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIV
VIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo
00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIV
I_ooohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooo`800002
oooo0P0000;oool400000_ooo`800002oooo0P0000;oool200001oooo`80
003oooooooooodKoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool2000000?oool000000000
0_ooo`800002oooo0P000003oooo0000000000;oool200000_ooo`800007
oooo0P000?ooooooooooA_ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooo`8000000oooo`00
00000002oooo0P0000Goool200000_ooo`800002oooo0P0000Coool60000
oooooooooom5oooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo0P000003oooo0000000000;o
ool6000000?oool0000000000_ooo`800002oooo0P0000Coool00`000?oo
ooooo`020000oooooooooom6oooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo0P000003oooo
0000000000;oool200000_ooo`8000000oooo`0000000002oooo0P0000;o
ool200001Oooo`040000oooo00000000oooooooooom6oooo00=VIVJIVIW<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2h
IVIVoooo0P000003oooo0000000000;oool200000_ooo`8000001Oooo`00
000000000?ooo`03000000?oool0000000001Oooo`040000oooo00000000
oooooooooom6oooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB928
004000000006R<2hb>3HR<2hR<2hIVIVoooo1P0000;oool400000_ooo`80
00000oooo`0000000002oooo0P0000Ooool30000oooooooooom6oooo00=V
IVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo0P000003oooo0000000001Woool30000oooooooooom6
oooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000006
R<2hb>3HR<2hR<2hIVIVoooo0P0000;oool00`000?ooooooo`0Hoooo0P00
0?ooooooooooA_ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVI
VLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03
IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomX
oooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooo
ooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`0
3<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooo`800002oooo0P0000;oool4
00000_ooo`800002oooo0P0000;oool200001Oooo`@0003oooooooooodKo
ool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoool2000000?oool0000000000_ooo`800002oooo
0P000003oooo0000000000;oool200000_ooo`800004oooo0P0000;oool2
0000oooooooooom5oooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVoooo0P000003oooo00000000
00;oool200001Oooo`800002oooo0P0000;oool200002?ooo`80003ooooo
ooooodGoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00
000000J8`;S8h=R8`;R8`;QVIVKoool2000000?oool0000000000_ooo`H0
00000oooo`0000000002oooo0P0000;oool200002?ooo`80003ooooooooo
odGoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00J8`;S8h=R8`;R8`;QVIVKoool2000000?oool0000000000_ooo`800002
oooo0P000003oooo0000000000;oool200000_ooo`800008oooo0P000?oo
ooooooooAOooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001
000000001XS0^<SPf8S0^8S0^6IVI_ooo`8000000oooo`0000000002oooo
0P0000;oool2000000Goool000000000003oool00`000003oooo00000000
00Koool30000oooooooooom6oooo00=VIVJIVIW<c<`03<c<c005IVIVoooo
R<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo1P0000;oool4
00000_ooo`8000000oooo`0000000002oooo0P0000Woool20000oooooooo
oom5oooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVoooo0P000003oooo0000000001Ooool20000
0_ooo`80003oooooooooodGoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool200000_ooo`03
0000oooooooo01Koool40000oooooooooom6oooo00=VIVJIVIW<c<`03<c<
c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<
c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIV
VIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo
00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooooooo
ofSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
0P0000;oool200000_ooo`@00002oooo0P0000;oool200000_ooo`800004
oooo1P000?ooooooooooAOooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooo`8000000oooo`00
00000002oooo0P0000;oool2000000?oool0000000000_ooo`800002oooo
0P0000Coool20000oooooooooom9oooo00=VIVJIVIW<c<`03<c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo0P000003
oooo0000000000;oool200001Oooo`800002oooo0P0000;oool200001Ooo
o`80003oooooooooodSoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8
`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool2000000?oool00000
00000_ooo`H000000oooo`0000000002oooo0P0000;oool200001_ooo`80
003oooooooooodOoool00fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool2000000?oool000000000
0_ooo`800002oooo0P000003oooo0000000000;oool200000_ooo`800007
oooo0P000?ooooooooooA_ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooo`8000000oooo`00
00000002oooo0P0000;oool2000000Goool000000000003oool00`000003
oooo0000000000Soool20000oooooooooom5oooo00=VIVJIVIW<c<`03<c<
c005IVIVooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo
1P0000;oool400000_ooo`8000000oooo`0000000002oooo0P0000Woool2
0000oooooooooom5oooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2h
B928004000000006R<2hb>3HR<2hR<2hIVIVoooo0P000003oooo00000000
01Ooool200000_ooo`80003oooooooooodGoool00fIVIYVIVLc<c00<c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool2
00000_ooo`030000oooooooo01Koool40000oooooooooom6oooo00=VIVJI
VIW<c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool0
0fIVIYVIVLc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oooooooooo
J?ooo`03IVIVVIVIc<c<00c<c<`01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVIYVIVLc<c00<c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooo
oooooomXoooo00=VIVJIVIW<c<`03<c<c005IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooJ?ooo`03IVIVVIVIVIVI
00bIVIT01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP3oooooooooofSoool00fIVI/c<c6IVIP0=IVIV00Cooon8`;R8`;Q8T8P1
000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIVI_ooolc<
c00<c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QV
IVKoool200000_ooo`800002oooo100000;oool200000_ooo`800002oooo
0P0000Ooool20000oooooooooom6oooo00=VIVKoooo<c<`03<c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo0P000003
oooo0000000000;oool200000_ooo`8000000oooo`0000000002oooo0P00
00;oool200001oooo`80003oooooooooodKoool00fIVI_ooolc<c00<c<c<
00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKoool2
000000?oool0000000000_ooo`800005oooo0P0000;oool200000_ooo`80
0007oooo0P000?ooooooooooA_ooo`03IVIVooooc<c<00c<c<`01FIVI_oo
ohS0^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooo`8000000ooo
o`0000000002oooo1P000003oooo0000000000;oool200000_ooo`800007
oooo0P000?ooooooooooA_ooo`03IVIVooooc<c<00c<c<`01FIVI_ooohS0
^8S0^4R@R001000000001XS0^<SPf8S0^8S0^6IVI_ooo`8000000oooo`00
00000002oooo0P0000;oool2000000?oool0000000000_ooo`800002oooo
0P0000Ooool20000oooooooooom6oooo00=VIVKoooo<c<`03<c<c005IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVoooo0P000003
oooo0000000000;oool200000_ooo`8000001Oooo`00000000000?ooo`03
000000?oool0000000001Oooo`040000oooo00000000oooooooooom6oooo
00AVIVKoooo<c<c<c<`800000lc<c005IVIVooooR<2hR<2hB92800400000
0006R<2hb>3HR<2hR<2hIVIVoooo1P0000;oool400000_ooo`8000000ooo
o`0000000002oooo0P0000Koool40000oooooooooom6oooo00=VIVKoooo<
c<`00/c<c0H00004c<c<00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8
h=R8`;R8`;QVIVKoool2000000?oool0000000006Oooo`<0003ooooooooo
odKoool00fIVI_ooolc<c003c<c<100000G<c<`01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_ooo`800002oooo00<0003ooooo
ool06?ooo`80003oooooooooodKoool00fIVI_ooolc<c004c<c<0P0000K<
c<`01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3o
ooooooooofSoool00fIVI_ooolc<c00<c<c<00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooomXoooo00=VIVKoooo<
c<`03<c<c005IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooJ?ooo`03IVIVooooc<c<00c<c<`01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooooooofSoool00fIV
I_ooolc<c00=c<c<00Cooon8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0
^6IVIP3oooooooooofSoool00fIVI_ooooooo`0<oooo00EVIVKooon8`;R8
`;Q8T8P00@00000000B8`;S8h=R8`;R8`;SoIVIVofIVIWUVIVH01<c<c8S0
^8S0^4R@R04000000003R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058T8P10000
000018S0^<SPf8S0^8S0^1H0080300600P02P00400:100>100>100>10`04
P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<1
2X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0@008000i^WlC=3YC=3Y@09<d>U1P00P0<0
0H0200:000@00X400h400h400h4300B10P05P@0400F200J200J200J20P07
PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f4
0`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8F
Q`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<3
7HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd3
1BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6
;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHc
TP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9
BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd2
2e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;
FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<
H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]
47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<A
QJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d
4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLD
VkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[
_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00
P007VjOaooooSWZfYY_4/jWBZ9g8/jWB00:VVl@01KbhgNk^m>[YlOoooc=3
Y@0500200`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X80
1X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@0
0`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<3
6hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=
12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5
:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9
AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YA
W@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]G
W`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW
3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mc
Z@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@
OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hA
Q:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H0
11BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ
_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P03
5k6n5k6o5k6o00<G/[l35k>o0QRd`20000026;C04000008H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P004VjOaooooK5ZU[jG:0[bhg@0:
oogo/jWBoooooooo_;SMUhZlZ9g8i^K/oooo<d>U1000P0<00H0200:000@0
0X400h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R2
0@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD3
0Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN8
0aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@O
R`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd5
9hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_
T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`Ld
TPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD3
23bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3
V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;
VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@03
2eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aK
X08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R
00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@3
3FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W
00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mg
ZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<A
P:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7
/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb
0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@3
4iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg
0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS
^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G
[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc
_`8H]<000lSPf4R@R4R@R00<B92800<00038h=Q8T8P03DR@R00400006;C0
6;C0b>3H3TR@R00300006;C06;C000:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000^KYo7ooonXWLSoooncZM9PC9Z>N[IhIJjXWLSooooooOl0
0oooo`03<d>U0020002000<0080300600P02P00400:100>100>100>10`04
P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<1
2X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50P8@Q@?oool20Q660`8B
QP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR8
00<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/3
12:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>
0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946
<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087
=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10Pn
UP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH
0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/3
2TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h0
0`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ
35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeR
XP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZ
Y@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0ma
Z0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/3
47Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^
4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK00
11:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8C
Sk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF
]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPE
W[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX3
5ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^
_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3H
R<2hR<2h00^8`;P00dR@R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P0
3HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^08008003Y^WlOooooooom_Lk61<VY>5^[>Yd[bhgF1<VYV?_ZJKa<S3gooo
oc=3Y@H00803oooo0P02P00300:1oooooooo00;oool200B100<01H7oool0
1H800`06PPCoool00`48PP48Poooo`03oooo0`4:P`06oooo0@^40@^40@b4
oooo0@b40P4=Q004oooo0@j5oooo0@j50P8?Q@04oooo0Q25oooo0Q250P8A
QP03oooo0Q660Q:600824XH20Q>600@24hL258L258L258L30QF70P8FQ`04
0aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX3
11j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=
00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I03
1Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86
=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`Lj
U0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88
@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX3
2DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M
0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl3
35ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<
H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eV
Y0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>
KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT3
3gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]
0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl4
4HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb
4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d
00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLD
VkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT3
5J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[
_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`03
5k:o0aNc_`8H]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P00038h=P0
0XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008003Y^WlOoookbh
gIV?__ooomKAgM_Lk??nojJKa>k^m8Ef/9>5^_oooc=3Y@@008001oooo`01
P001P001P?ooo`02P?ooo`0300>100Koool0184018401H7oool01H8200J2
00Soool01h801h811h;oool128;oool128<30@V300Coool12X<12X?oool2
0@^400<138Coool138@00P4=Q004oooo0@j5oooo0@j50P8?Q@03oooo0Q25
oooo00?oool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<4
7XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd0
0`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6
;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHd
TP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD
0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3
U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9
BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd3
2e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<
FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaP
XP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT
0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_
Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?
MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd2
4Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@A
QZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8B
SK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@0
0a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK
]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<E
X[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m
5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P00dR@R0000<SPf002
R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<001<SP
f8S0^8S0^8S0^0800004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3002000nKYo7ooonISkjGR[cDdnS_
[;?oMW_^Wj]KF:FVVlBFWm9PC9Zl^=gooolc@jD00`00P007oooo00600060
0060oooo00:0oooo00<00h401_ooo`04P@04POooo`05POooo`801X802?oo
o`07PP07PP47P_ooo`48P_ooo`48P`<12H<02Oooo`4:Poooo`4;Poooo`4;
Q?ooo`4<Q?ooo`020@f400Coool13XGoool13XD20Pn500Coool248Goool2
48D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP3
5hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;
0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DW
SPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@
00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB
1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8
?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H
2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J
0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;
E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P
0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ80
0`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=
J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L0
10m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ
0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60
[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`
0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK82
4Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<C
U;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L2
59fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j
0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/
_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o
0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8
`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^002R<2h
0P0000:8`;P200000hS0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008002Y^WlOoooiN:_7Y/Z[?7j:U^X<S3gi>5^U]6
TiV?_P9hIJh0148WQJnUb_oooc=3Y@@00803006000?oool00X000X401?oo
o`8018400oooo`05POooo`0300J21?ooo`030@R20@R30@R300<12H<02Ooo
o`4:Poooo`4;Poooo`4;Q?ooo`4<Q?ooo`020@f400Coool13XGoool13XD2
0Pn500?oool248Goool00oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<K
R@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d4
9Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[
S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO
00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y
00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n
[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64
[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P04
59Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl
00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G
/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000
b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd
`003b>3HR<2hR<2h00>8`;P4000018S0^004B92800006;C06;C00XS0^058
T8P10000000018S0^<SPf8S0^8S0^08008000i^WlOooooooo`02oooo00[o
[K3oMW_icMCmkNkooonVVlB5M[2l^=gooolc@jD500200`01P003oooo00:0
00:100<00h400oooo`04POooo`0200F100@01H;oool01X801X8200N200<1
1h;oool128800P48P`?oool20@Z300Ooool12h?oool12hCoool138Coool0
0P4=Q004oooo0@j5oooooooo0P8?Q@06oooo0Q25oooo0Q250Q66oooo0P8A
QP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN8
0`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3
126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh0
0`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA
1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLe
TP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`Pm
U@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4
V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/3
2TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN
2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:00
10aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=
HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iY
Y@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?
LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X3
47V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61
[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;02
4XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P03
4hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E
]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`04
5Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X3
5ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm
00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<00
0lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8
`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P018S0^0800005
R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0`00P00:XJcbnLgDhRHlm;FohRHlm6emo>?YoooooNg^ojf`0_ooo`03<d>U
0020002000@00803006000?oool00X000X400oooo`8018401Oooo`05P@05
P@05P_ooo`0200J20oooo`8128800`48Poooo`49P`020@V30P4:P`04oooo
0@^30@^4oooo0P4<Q007oooo0@f40@f4oooo0@j5oooo0@j500;oool00`8?
Q@8@Q@8@Q@04oooo00@24HH24XH24XH24XH20Q>600@24hL258L258L258L3
0QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^9
0`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@U
S@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?
10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHc
TPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0Lh
U0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G
246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI
0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:
DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil0
0`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<
Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=
IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^
Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT0
10mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/
47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_
4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:<
/@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`03
4i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@D
V[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i
5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`0
11J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa
_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038
h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C0
00?8h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P00=VjOaoNg^hRHlo_GhmhVGm69^
lj2^m69^oogoojf`o>?Yoooo<d>U00L00803006000?oool00X000X400`03
P@<0184200F100@01H801X801X801X8200N200D11h81288128;oool128<0
0`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH3
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8
h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h
00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8`;P200000XS0
^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0P00P003VjOam/S<hRHl00;o[K001mlT;_nTW_JlaOn]/>ikS?oo
oc=3Y@0800200`01P003oooo00:000:100<00h4300B10P05P@0400F200J2
00J200J20P07PP050@N20@R20@R2oooo0@R300<12H<01?ooo`4:P`4:P`4;
P`812h@30@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@04
0aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`4
98d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5
:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A
00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7
>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9
AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN
2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ
0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X
3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@
OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh0
0a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@
/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf
0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<F
ZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003
B9280000b>3H00:8`;P900000XS0^005B92800006;C06;C0b>3H00>8`;P2
000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0P00P003VjOanLgDmhVG00;oool01on]/>4F=?mfNonT
W^8V??n9Oc=3Y@0800200`01P003oooo00:000:100<00h4300B10P05P@04
00F200J200J200J20P07PP040@N20@R20@R20@R31?ooo`<12X<00`4;P`4;
Q04;Q0030@b40P4=Q004oooo0@j50@j50@j50`8?Q@<248D40Q660`8BQP82
4hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<3
6HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<
10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DY
SP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946
<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<3
1cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8
?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5
V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK
0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]E
WP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ
35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP02
3F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>
JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0ma
Z0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[
0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^
00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9
/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8C
Sk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<D
UkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PE
W[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk
0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^
_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2h
R<2h00^8`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd
`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0P00P007VjOaoooolj2^m69^oooomhVGnLgD00;oool00o>P[_oo
oc=3Y@0800200`01P0800X001002P@03P@03P@03P@<0184200F100@01H80
1X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@1
2h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8D
Q`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<J
R@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=
12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?
00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@04
1S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC
1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8
@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI
00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YA
W0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]G
W`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<
Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<0
0`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP04
3VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mc
Z@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/
00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<A
Q:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<B
Rk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<3
4i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8D
V[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<E
X;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl
11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`
_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@
R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008002i^WlOoooon9
Oooooo>P[_6CXOooooomoo>P[_oko3=3Y@0800200`01P0800X001002P@03
P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h8128812880
0P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D4
0Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP3
5hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@P
R`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDW
SP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6
;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB
1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D3
23fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH
2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<
V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;
E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaL
X00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQ
XPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D3
3VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`
Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1h
ZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@03
4H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8
/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb
00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@3
4iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg
00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT
^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G
[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd
`0o8h=P00`000<SPf<SPf00=b>3H00<0000H]<0H]<003lSPf00300006;C0
6;C000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P400200i^Wl@06oooo
lj2^m;Fom[c5nmWJ<d>U2@00P0<00H0200:000@00X400h400h400h4300B1
0P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V30`4:
P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>6
00@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV8
0aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@4
8h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh0
0`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A
0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`Lf
T`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF
0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP0
0`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:
Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh3
2eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aM
X@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeR
X`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V
0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP3
3g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@
Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P03
4H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4B
R[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb
008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne
11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh
5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<F
Yk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG
[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h5P00P0<00H0200:000@00X400h400h400h43
00B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V3
0`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR003
0aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A
1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC
0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH3
23nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9
AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>
V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aM
X@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ80
0PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD4
3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?
LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1j
Z`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61
[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@B
RK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb
4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D3
59Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh
5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@
R04000000003R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058T8P1000000000hS0
^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8h=S8h=P0olSP
f?o8h=Qmb>3H0DR@R04000000?n8`;SoR<2hPHS0^04000000001\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:30001hR000`400?l0
0000o`00003oooo`l?3ooo3`l7Kol?3`00?ofMWIooooooooool03?ooool0
0?ool?3`ooo`l?1foo3`l004omWIfOooooooooooonGUi@?ooooo00GoiNGU
ooooooooooooooooonGUi@03ooooo`00ooo`l?3ooo3`l7Kol?3`00gofMWI
oooooooJf][oSHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgo
iNGU00;ooooo003ooo3`l?ool?3`M_o`l?003_oIfMWooooooooooooJf][o
SHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU0Oooool0
0?ool?3`ooo`l?1foo3`l00=omWIfOoooooooooooooooooJf][oSHf=onGU
iOoooooof][Johf=SOoUiNGoooooom[JfP02ooooo`00ooo`l?3ooo3`l7Ko
l?3`00?ofMWIooooooooool00_ooool01ooJf][oSHf=onGUiOoooooof][J
ohf=SOoUiND00oooool00?ool?3`ooo`l?1foo3`l003omWIfOoooooooooo
00?ooooo00Oof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003o
oo3`l?ool?3`M_o`l?000ooIfMWoooooooooo`04ooooo`07om[Jf_n=SHgo
iNGUoooooooLg=coSHf=onGUi@01ooooo`00ooo`l?3ooo3`l7Kol?3`00?o
fMWIooooooooool01Oooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo
003ooo3`l?ool?3`M_o`l?000ooIfMWoooooooooo`06ooooo`03omcLg?n=
SHgoiNGU00?ooooo003ooo3`l?ool?3`M_o`l?000ooIfMWoooooooooo`07
ooooo`03omcLg?n=SHgoiNGU00;ooooo003ooo3`l?ool?3`M_o`l?000ooI
fMWoooooooooo`08ooooo`03omcLg?n=SHgoiNGU007ooooo003ooo3`l?oo
l?3`M_o`l?000ooIfMWoooooooooo`09ooooo`7og=cL0Oooool1ooooo`00
ooo`l?3ooo3`l7Kol?3`00?ofMWIooooooooool03?ooool00?ool?3`ooo`
l?1foo3`l0oofMWI003oooooooooooooQOooool00?ook^k^ooo^k^j5onk^
kP000ooVi^Koogj]fOooOZgIP?mn[MT2onKViP000oo^k^h00omn[MWok^k^
onk^kP3oonk^k_ook^k^O?o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?o
OZgIooooooooool0ooooooooooooogcooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo00Oooooo00?oiNGUoogmoOooool00_ooool0
0oodm?Coj>SXooooo`0Looooo`03onWYjOoOgmoooooo0?ooooooooooooll
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`06ogj]fOoooooooooooooooold=3CoMWIf0_ooool03_oCdm?o9BDU
oahN7_nj^[[oooooonOWiom:BT[o0`<3ob<S8olG5aOo`L71oooooom0@43o
Ogmo0_ooool01_mjNW[o@d=3oooooooooooo];Bdo`T92@Kooooo00KomOGe
o`l?3ol<30co0000o`h>3_lF5QH2ooooo`06oogmoOmRHV;o7alOob`/;?lj
>S[ok^k^oooooooooooooc_ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooT
i>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oooool1
ogj]f@7ooooo0Oooool000?ok^k^00KoOZgIonk^k_oooooooooooc@d=?mf
MWH2ooooo`03og5aLOm1@D7oo_kn00;ooooo00WoA4A4od10@?oOgmoooooo
oo?cloobl_;ooooood10@?moOgl00_ooool01_mjNW[o@d=3oooooooooooo
];Bdo`T92@Sooooo00?oeMGEo`000?oXj>P00oooool01_nBTY;o<c<cooWi
nOooooooHF5QoeMGEooooooooooooolkooooo`0?okRh^?o0`<3ob<S8om?C
dooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_
00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP06ogj]fOoVi^Kooooooooo
oold=3CoMWIf0_ooool01om=CDgoLW9boooooooooooogMgMo`000?nh^;P0
1Oooool01_m0@43oOgmoooooooooooooNWYjod=3@`;ooooo00?o];Bdo`T9
2Oooool01oooool00ooEeMGo0000onSXj003ooooo`07obLW9onFUYKooooo
ooooooo?cloo10@4onOWi`3ooooooooooooo>_ooool03onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cd
ono_k`03onKViP7oOZgI0OoVi^H1onKViP000oo^k^h01_mn[MWok^k^oooo
oooooooo=3@dogIfMP;ooooo00OoCDe=og9bL_oooooooooookjn__l0003o
?Cdm00?o?clo00Coa<C4oooooom0@43oOgmo0_ooool01_mjNW[o@d=3oooo
oooooooo];Bdo`T92@Sooooo00?oeMGEo`000?oXj>P00_ooool00ooemOGo
0000ol;2`P02ooooo`03oo_knol10@7o_;bl0?ooooooooooooljooooo`0?
okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_o
o?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`06
ogj]fOoooooooooooooooold=3CoMWIf0_ooool03_m=CDgoLW9boooooooo
oooofm_Ko`000?n[Zj_oclo?olO7aol30`?oiNGUoooooom0@43oKFe]0_oo
ool01_miNGWo<c<cookno_oooooo/k>co`T92@Sooooo00?oeMGEo`000?oX
j>P00_ooool00ooKfm_o0000om;BdP03ooooo`03o`d=3OnQXJ7ooooo0?oo
ooooooooooliooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooa
lO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1oooo
o`7ooooo0003onk^kP0Bogj]fOo^k^kooooooooooold=3CoMWIfoooooooi
nOWoBDU9ofe]KOodm?Cono_koooooolo?cooJf][ooOgmonNWYko:b/[0_oo
ool02_m0@43o5ADEohb<S?oXj>So?clooalO7omPH63oh^;Rog5aLOlc<c<8
ooooo`03omGEeOl0003oj>SX00;ooooo00?oj^[Zo`000?o9bLT00oooool0
0ol51@Go[jn_ooooo`3ooooooooooooo>Oooool03onh^;So`<30olS8b?oC
dm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_
k`03onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H04_mn[MWoi^KVoooooooo
oooo=3@dogIfM_ooooooOgmoo`P82?l<30co6a/Kojj^[_ooooooi^KVodM7
Aol=3@go71`LokNg]`;ooooo00[oE5ADoh^;RomaLG7o410@obPX:?oEeMGo
VYZJoaXJ6_lP823o[Jf]2?ooool00ooEeMGo0000onSXj003ooooo`07o`X:
2_n^[Zkoooooooooooo[jn_o0000om3@d03ooooooooooooo>_ooool03onh
^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_koocl
o?oinOWom?Cdono_k`03onKViP7oOZgI0OoVi^H1onKViP000oo^k^h01_mn
[MWok^k^oooooooooooo=3@dogIfMP;ooooo00?oCDe=og9bL_ooool01?oo
ool00oolo?coooooooooo`05ooooo`03ookno_oooooooooo00;ooooo00?o
o_knooooooooool01Oooool01Oono_kon_[jomGEeOl0003oj>SX00?ooooo
00KoI6ATof9RH_oooooooooooinOWol[:b_ooooooooooooo>oooool03onh
^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_koocl
o?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000oooool01_mn
[MWooooooooooooooooo=3@dogIfMP;ooooo00?oh>3PomkNg_ooool06Ooo
ool01Oofm_Ko51@DocDe=Ol0003oj>SX00?ooooo00KogmoOoadM7OmjNW[o
Ti>CoaTI6Oni^KWooooooooooooo>oooool03onh^;So`<30olS8b?oCdm?o
fm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03
ooooo`7oOZgI0Oooool1ooooo`000oo^k^h01_mn[MWok^k^oooooooooooo
[jn_olW9bAoooooo00ConOWiolC4a?n4Q8ColO7a1?ooool01?oRh^;oQXJ6
ogQhN?o<c<cooooooooooooo??ooool03onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^
kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`3ooooooooo
ooooJ_ooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`03onKViP7oOZgI0OoVi^H1onKV
iP000oo^k^h00omn[MWok^k^ooooo`3oooooooooooooJ_ooool03onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWo
ooooooooo`3oooooooooooooJ_ooool03onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03oooo
o`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^ooooo`3ooooooooo
ooooJ_ooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^
kP000ooVi^H00omn[MWoi^KVooooo`3oooooooooooooJ_ooool03onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`03onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWo
k^k^ooooo`3oooooooooooooJ_ooool03onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^
kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`3ooooooooo
ooooJ_ooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`03ooooo`7oOZgI0Oooool1oooo
o`000oo^k^h00omn[MWok^k^ooooo`07ooooo`03onGUiOomoOgooooo00;o
oooo00?om?CdonSXj?ooool04oooool00ooVi^KodM7AooWin@3ooooooooo
ooooAOooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^
kP000ooVi^H01_mn[MWoi^KVoooooooooooo=3@dogIfMP;ooooo00kodm?C
obDU9OlN7Qko^[ZjoooooooWinOoBTY:o`<30olS8b?o5aLGol71`Ooooooo
@410ogmoO`;ooooo00KoNWYjod=3@ooooooooooookBd]?l92@T6ooooo`05
ogemOOlG5aOo?CdmoaPH6?n3Ph<0ooooooooooooodCooooo00oo^;Rhol30
`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWi
ooCdm?o_knl00ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00KoOZgIonk^
k_oooooooooooc@d=?mfMWH2ooooo`03og5aLOm1@D7oo_kn00;ooooo00Wo
A4A4od10@?oOgmoooooooo?cloobl_;ooooood10@?moOgl00_ooool01_mj
NW[o@d=3oooooooooooo];Bdo`T92@Kooooo00KomoOgooooooooooook>c/
obXZ:_n@T93ooooooooooooo@oooool03onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^
kP7oOZgI0Oo^k^h1onk^kP000oooool01_mn[MWooooooooooooooooo=3@d
ogIfMP;ooooo00OoCDe=og9bL_ooooooooooomgMgOl0003o^;Rh00Gooooo
00Ko@410ogmoOoooooooooooogYjN_m3@d<2ooooo`03okBd]?l92@Wooooo
00Wooooo00?oQXJ6oaTI6OoinOT0oooooooooooood;ooooo00oo^;Rhol30
`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWi
ooCdm?o_knl00oooool1ogj]f@7ooooo0Oooool000?ok^k^00KoOZgIonk^
k_oooooooooooc@d=?mfMWH2ooooo`07ode=COmbLW;ooooooooooonn_[ko
0000ocdm?@03oclo?`04olC4a?oooooo@410ogmoO`;ooooo00KoNWYjod=3
@ooooooooooookBd]?l92@T7ooooo`06ok2`/?mLG5coMGEeojb/[?l0003o
d=3@oooooooooooood;ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Co
jn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oo^k^h1ogj]
f@7ok^k^0Oo^k^h000?oi^KV00KoOZgIonKVi_oooooooooooc@d=?mfMWH2
ooooo`0>ode=COmbLW;ooooooooooooKfm_o0000oj^[Zoo?clooalO7o`<3
0ooUiNGooooood10@?m]KFd2ooooo`06ogUiNOlc<c?oo_knoooooonc/k?o
2@T91_ooool01onKVi_o4Q8Bohb<S?nQXJ7o@T92o`000?n`/;00oooooooo
oooood;ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOof
m_Kon_[joo_knoolo?conOWiooCdm?o_knl00ooVi^H1ogj]f@7oi^KV0OoV
i^H000?ok^k^01;oOZgIonk^k_oooooooooooc@d=?mfMWKoooooooWinOm9
BDWoKFe]ooCdm?okno_ooooooclo?om[Jf_omoOgoijNW_l[:b/2ooooo`0:
od10@?lE5AGoS8b<onSXj?lo?coo7alOof1PH?oRh^;oLG5aoc<c<`Kooooo
00Oo8R8RogMgMooooooooooookjn__l0003o[Jf]0?oooooooooooom2oooo
o`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_ok
no_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003oooo
o`0Bogj]fOoooooooooooooooold=3CoMWIfoooooomoOgoo20P8o``<3?lK
6a_o[Zj^oooooooVi^KoAdM7o`d=3OlL71co]kNg0_ooool02_mDE5CoRh^;
og5aLOl@413o:2PXomGEeOnJVY[o6QXJob0P8?n][Jd6ooooo`07o`T92On_
[joooooooooooooGemOo0000ol_;b`3ooooooooooooo@_ooool03onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`03ooooo`7oOZgI0Oooool1ooooo`000oo^k^h01_mn[MWo
k^k^oooooooooooo=3@dogIfMP;ooooo00?oCDe=og9bL_ooool01?ooool0
0oolo?coooooooooo`05ooooo`03ookno_oooooooooo00;ooooo00?oo_kn
ooooooooool01Oooool01oli>CWoN7QhooooooooooooShn?oadM7Ookno/0
oooooooooooood;ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oo^k^h1ogj]f@7o
k^k^0Oo^k^h000?oi^KV00KoOZgIonKVi_oooooooooooc@d=?mfMWH2oooo
o`03on3Ph?oNg]kooooo01Wooooo00Ko`l?3oaHF5_mhN7SoLG5ao``<3?nX
Z:Sooooooooooooo@oooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onKViP7oOZgI
0OoVi^H1onKViP000oo^k^h01_mn[MWok^k^oooooooooooo[jn_olW9bAoo
oooo00Coe]KFog]kNomgMgOoa/K6ooooooooooooodCooooo00oo^;Rhol30
`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWi
ooCdm?o_knl00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIoooo
ooooool0ooooooooooooof[ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooT
i>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oooool1
ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_ooool0oooooooooooo
of[ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Ko
n_[joo_knoolo?conOWiooCdm?o_knl00oo^k^h1ogj]f@7ok^k^0Oo^k^h0
00?oi^KV00?oOZgIonKVi_ooool0ooooooooooooof[ooooo00oo^;Rhol30
`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWi
ooCdm?o_knl00ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^
k_ooool0ooooooooooooof[ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooT
i>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oo^k^h1
ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool0oooooooooooo
of[ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Ko
n_[joo_knoolo?conOWiooCdm?o_knl00oooool1ogj]f@7ooooo0Oooool0
00?ok^k^00?oOZgIonk^k_ooool0ooooooooooooof[ooooo00oo^;Rhol30
`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWi
ooCdm?o_knl00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKV
i_ooool0ooooooooooooof[ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooT
i>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00ooVi^H1
ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool01oooool00ooU
iNGooOgmooooo`02ooooo`03ooCdm?oXj>Sooooo01Cooooo00?om?CdomoO
goooool0ooooooooooooodCooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooT
i>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oo^k^h1
ogj]f@7ok^k^0Oo^k^h000?ooooo00KoOZgIoooooooooooooooooc@d=?mf
MWH2ooooo`0>om?CdolU9BGo7QhNokZj^_ooooooinOWodY:B_l30`?o8b<S
oaLG5oo1`L7ooooood10@?moOgl2ooooo`06ogYjN_m3@d?ooooooooooond
];Co2@T91_ooool01_oPh>3oCDe=oaHF5_lb<S;o;bl_oi^KVooooooooooo
oom3ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo
0003onk^kP06ogj]fOo^k^kooooooooooold=3CoMWIf0_ooool00omaLG7o
@D51ooknoP02ooooo`09odA4A?m0@43ogmoOoooooooclo?ol_;boooooom0
@43oOgmo00;ooooo00KoNWYjod=3@ooooooooooookBd]?l92@T6ooooo`07
oe1@D?lf=SKom_Kfooooooo0`<3o0@41om7Ad@3ooooooooooooo@_ooool0
3onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_k
ooclo?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H0
1_mn[MWoi^KVoooooooooooo=3@dogIfMP;ooooo00OoCDe=og9bL_oooooo
ooooomgMgOl0003o^;Rh00Gooooo00Ko@410ogmoOoooooooooooogYjN_m3
@d<2ooooo`03okBd]?l92@Wooooo00Gooooo00Oo=3@doh^;Rooooooooooo
ooShn?l92@WoZj^[0?oooooooooooom2ooooo`0?okRh^?o0`<3ob<S8om?C
dooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_
00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP06ogj]fOo^k^kooooooooo
oold=3CoMWIf0_ooool01om=CDgoLW9boooooooooooo_[jno`000?lm?Cd0
0olo?cl01?o4a<Cooooood10@?moOgl2ooooo`06ogYjN_m3@d?ooooooooo
oond];Co2@T91_ooool01ommOGgoDE5AoooooooemOGoGUiNo`P82?o`l?00
oooooooooooood;ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oo^k^h1ogj]f@7o
k^k^0Oo^k^h000?ooooo00KoOZgIoooooooooooooooooc@d=?mfMWH2oooo
o`0>ode=COmbLW;ooooooooooooKfm_o0000oj^[Zoo?clooalO7o`<30ooU
iNGooooood10@?m]KFd2ooooo`06ogUiNOlc<c?oo_knoooooonc/k?o2@T9
1_ooool01_ohn?SoEEEEoeYJF_lT92Co7QhNolK6a_oooooooooooom3oooo
o`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_ok
no_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^
kP0Bogj]fOo^k^kooooooooooold=3CoMWIfoooooooinOWoBDU9ofe]KOod
m?Cono_koooooolo?cooJf][ooOgmonNWYko:b/[0_ooool02_m0@43o5ADE
ohb<S?oXj>So?clooalO7omPH63oh^;Rog5aLOlc<c<7ooooo`05oi2@T?l1
0@7oBTY:oe1@D?ogmoL0oooooooooooood?ooooo00oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV01;oOZgIonKVi_oooooo
oooooc@d=?mfMWKoooooogmoOol820So30`<oa/K6on^[ZkoooooonKVi_m7
AdOo3@d=oa`L7?ng]kL2ooooo`0:oeADE?n;Rh_oLG5aoa0@4?lX:2SoeMGE
oiZJV_lJ6Q[o820Pojf][@Kooooo00Kod=3@o`410Ond];CoooooohJ6Q_mO
Geoooooooooooooo@oooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onKViP7oOZgI
0OoVi^H1onKViP000oo^k^h01_mn[MWok^k^oooooooooooo=3@dogIfMP;o
oooo00?oCDe=og9bL_ooool01?ooool00oolo?coooooooooo`05ooooo`03
ookno_oooooooooo00;ooooo00?oo_knooooooooool01Oooool01_o0`<3o
8b<Soooooooooooob/[:oa4A4Ooooooooooooom3ooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`06ogj]fOoooooo
oooooooooold=3CoMWIf0_ooool00ooPh>3og]kNooooo`0Jooooo`05obl_
;om[Jf_oVYZJocLg=omXJ6P0oooooooooooood?ooooo00oo^;Rhol30`?o8
b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCd
m?o_knl00oooool1ogj]f@7ooooo0Oooool000?ok^k^00KoOZgIonk^k_oo
ooooooooojn_[oo9bLTOooooo`05ooGemOn[Zj_oLG5aojn_[oofm_H0oooo
oooooooood?ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oo^k^h1ogj]f@7ok^k^
0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool0ooooooooooooof[ooooo00oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl00ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?o
OZgIonk^k_ooool0ooooooooooooof[ooooo00oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
0oo^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool0oooo
ooooooooof[ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oooool1ogj]f@7ooooo
0Oooool000?ok^k^00?oOZgIonk^k_ooool0ooooooooooooof[ooooo00oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?o
OZgIonKVi_ooool0ooooooooooooof[ooooo00oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
0ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool0oooo
ooooooooof[ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oo^k^h1ogj]f@7ok^k^
0Oo^k^h000?ooooo00?oOZgIooooooooool0ooooooooooooof[ooooo00oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl00oooool1ogj]f@7ooooo0Oooool000?ok^k^00?o
OZgIonk^k_ooool01oooool00ooUiNGooOgmooooo`02ooooo`03ooCdm?oX
j>Sooooo0?oooooooooooomKooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^
0Omn[MT1onk^kP7ok^k^0003onKViP06ogj]fOoVi^Kooooooooooold=3Co
MWIf0_ooool03_oCdm?o9BDUoahN7_nj^[[oooooonOWiom:BT[o0`<3ob<S
8olG5aOo`L71oooooom0@43oOgmo0_ooool01_mjNW[o@d=3oooooooooooo
];Bdo`T92@Oooooo00?o61PHofe]KOooool0ooooooooooooodGooooo00oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl00ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00Ko
OZgIonk^k_oooooooooooc@d=?mfMWH2ooooo`03og5aLOm1@D7oo_kn00;o
oooo00WoA4A4od10@?oOgmoooooooo?cloobl_;ooooood10@?moOgl00_oo
ool01_mjNW[o@d=3oooooooooooo];Bdo`T92@Oooooo00?oGUiNoaLG5ool
o?`0ooooooooooooodGooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Co
jn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oo^k^h1ogj]
f@7ok^k^0Oo^k^h000?ooooo00KoOZgIoooooooooooooooooc@d=?mfMWH2
ooooo`07ode=COmbLW;ooooooooooooMgMgo0000okRh^005ooooo`06od10
@?moOgoooooooooooomjNW[o@d=30_ooool00ond];Co2@T9ooooo`06oooo
o`03olg=cOl10@7o^[Zj0?oooooooooooom5ooooo`0?okRh^?o0`<3ob<S8
om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Co
kno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP06ogj]fOo^k^kooooo
oooooold=3CoMWIf0_ooool01om=CDgoLW9boooooooooooo_[jno`000?lm
?Cd00olo?cl01?o4a<Cooooood10@?moOgl2ooooo`06ogYjN_m3@d?ooooo
oooooond];Co2@T92?ooool00omKFe_oF5QHooooo`3oooooooooooooA?oo
ool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000ooV
i^H01_mn[MWoi^KVoooooooooooo=3@dogIfMP;ooooo00koCDe=og9bL_oo
ooooooooom_Kfol0003oZj^[olo?coo7alOo0`<3onGUiOoooooo@410ofe]
K@;ooooo00KoNGUioc<c<oono_kooooook>c/ol92@T8ooooo`03on;Rh_l=
3@goa/K60?oooooooooooom4ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV
0Omn[MT1onKViP7oi^KV0003onk^kP0Bogj]fOo^k^kooooooooooold=3Co
MWIfoooooooinOWoBDU9ofe]KOodm?Cono_koooooolo?cooJf][ooOgmonN
WYko:b/[0_ooool02_m0@43o5ADEohb<S?oXj>So?clooalO7omPH63oh^;R
og5aLOlc<c<9ooooo`03ohj>S_lb<S;ooOgm0?oooooooooooom3ooooo`0?
okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_o
o?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`0B
ogj]fOoooooooooooooooold=3CoMWIfoooooomoOgoo20P8o``<3?lK6a_o
[Zj^oooooooVi^KoAdM7o`d=3OlL71co]kNg0_ooool02_mDE5CoRh^;og5a
LOl@413o:2PXomGEeOnJVY[o6QXJob0P8?n][Jd9ooooo`03ooclo?l`<33o
UYJF0?oooooooooooom3ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP06ogj]fOo^k^kooooooooooold=3CoMWIf
0_ooool00om=CDgoLW9booooo`04ooooo`03ooclo?oooooooooo00Gooooo
00?oo_knooooooooool00_ooool00oono_koooooooooo`09ooooo`03olW9
bOlD51Cojn_[0?oooooooooooom2ooooo`0?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?o
k^k^0Omn[MT1onk^kP7ok^k^0003onKViP06ogj]fOoVi^Kooooooooooold
=3CoMWIf0_ooool00ooPh>3og]kNooooo`0Iooooo`03ohZ:R_lh>3So>3Ph
00;o>3Ph00?o2PX:oi>CToooool0oooooooooooood7ooooo00oo^;Rhol30
`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWi
ooCdm?o_knl00ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00KoOZgIonk^
k_ooooooooooojn_[oo9bLTNooooo`03olC4a?nJVY[oVYZJ00?oVYZJ00?o
dm?Cooooooooool0oooooooooooood3ooooo00oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
0oo^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool0oooo
ooooooooof[ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oooool1ogj]f@7ooooo
0Oooool000?ok^k^00?oOZgIonk^k_ooool0ooooooooooooof[ooooo00oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?o
OZgIonKVi_ooool0ooooooooooooof[ooooo00oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
0ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool0oooo
ooooooooof[ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oo^k^h1ogj]f@7ok^k^
0Oo^k^h000?ooooo00?oOZgIooooooooool0ooooooooooooof[ooooo00oo
^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl00oooool1ogj]f@7ooooo0Oooool000?ok^k^00?o
OZgIonk^k_ooool0ooooooooooooof[ooooo00oo^;Rhol30`?o8b<Sodm?C
om_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl0
0oo^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool0oooo
ooooooooof[ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00ooVi^H1ogj]f@7oi^KV
0OoVi^H000?ok^k^00?oOZgIonk^k_ooool01oooool00ooUiNGooOgmoooo
o`02ooooo`03ooCdm?oXj>Sooooo01Cooooo00?oj^[ZomGEeOokno/0oooo
ooooooooodCooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oo^k^h1ogj]f@7ok^k^
0Oo^k^h000?ooooo00KoOZgIoooooooooooooooooc@d=?mfMWH2ooooo`0>
om?CdolU9BGo7QhNokZj^_ooooooinOWodY:B_l30`?o8b<SoaLG5oo1`L7o
oooood10@?moOgl2ooooo`06ogYjN_m3@d?ooooooooooond];Co2@T91_oo
ool01_oinOWoFUYJo`L71olX:2So7alOolc<c?oooooooooooom3ooooo`0?
okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_o
o?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP06
ogj]fOo^k^kooooooooooold=3CoMWIf0_ooool00omaLG7o@D51ooknoP02
ooooo`09odA4A?m0@43ogmoOoooooooclo?ol_;boooooom0@43oOgmo00;o
oooo00KoNWYjod=3@ooooooooooookBd]?l92@T6ooooo`07ohR8R?lW9bOo
hn?Soooooon:RX[o8b<Soo[jnP3ooooooooooooo@_ooool03onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H01_mn[MWoi^KV
oooooooooooo=3@dogIfMP;ooooo00OoCDe=og9bL_ooooooooooomgMgOl0
003o^;Rh00Gooooo00Ko@410ogmoOoooooooooooogYjN_m3@d<2ooooo`03
okBd]?l92@Wooooo00Gooooo00Oo8B4Qog]kNoooooooooooon[Zj_l0003o
d=3@0?oooooooooooom2ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP06ogj]fOo^k^kooooooooooold=3CoMWIf
0_ooool01om=CDgoLW9boooooooooooo_[jno`000?lm?Cd00olo?cl01?o4
a<Cooooood10@?moOgl2ooooo`06ogYjN_m3@d?ooooooooooond];Co2@T9
1Oooool00ooinOWo0000oiRHV002ooooo`03omOGeol0003ofm_K0?oooooo
oooooom2ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7o
m_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7o
k^k^0003ooooo`06ogj]fOoooooooooooooooold=3CoMWIf0_ooool03_m=
CDgoLW9boooooooooooofm_Ko`000?n[Zj_oclo?olO7aol30`?oiNGUoooo
oom0@43oKFe]0_ooool01_miNGWo<c<cookno_oooooo/k>co`T92@Gooooo
00OoiNGUo`000?l];Bgof=SHoo7alOmUIFGo>SXj0?oooooooooooom3oooo
o`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_ok
no_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^
kP0Bogj]fOo^k^kooooooooooold=3CoMWIfoooooooinOWoBDU9ofe]KOod
m?Cono_koooooolo?cooJf][ooOgmonNWYko:b/[0_ooool02_m0@43o5ADE
ohb<S?oXj>So?clooalO7omPH63oh^;Rog5aLOlc<c<5ooooo`07oo[jn_l1
0@7oS8b<ocPh>?l@413o<C4aolc<c03ooooooooooooo@oooool03onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H04_mn[MWo
i^KVoooooooooooo=3@dogIfM_ooooooOgmoo`P82?l<30co6a/Kojj^[_oo
ooooi^KVodM7Aol=3@go71`LokNg]`;ooooo00[oE5ADoh^;RomaLG7o410@
obPX:?oEeMGoVYZJoaXJ6_lP823o[Jf]1_ooool01?lO7aooUiNGooooooon
o_koooooooooooooAOooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onKViP7oOZgI
0OoVi^H1onKViP000oo^k^h01_mn[MWok^k^oooooooooooo=3@dogIfMP;o
oooo00?oCDe=og9bL_ooool01?ooool00oolo?coooooooooo`05ooooo`03
ookno_oooooooooo00;ooooo00?oo_knooooooooool01Oooool00on2PX;o
?CdmooknoP3oooooooooooooA_ooool03onh^;So`<30olS8b?oCdm?ofm_K
onCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^
kP7oOZgI0Oo^k^h1onk^kP000oooool01_mn[MWooooooooooooooooo=3@d
ogIfMP;ooooo00?oh>3PomkNg_ooool06Oooool01_o`l?3o>CTioe5ADOnR
XZ;oOWinofa/K?oooooooooooom3ooooo`0?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?o
oooo0Omn[MT1ooooo`7ooooo0003onk^kP06ogj]fOo^k^kooooooooooon_
[joobLW97oooool01Oohn?SoWYjNofa/K?moOgoo^;Rh0?oooooooooooom3
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZ
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
OZgI0?ooOZgIoomn[MUZogj]f@0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^koOZgI0?oo`/;2ooo2`/9Y
ol;2`P0@ogj]fOnh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`?ok^k^0Omn[MT1onk^kP7ok^k^
0003ooooo`03ogj]fOooooooOZgI0?oo`/;2ooo2`/9Yol;2`P0@ogj]fOnh
^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_koocl
o?oinOWom?Cdono_k`?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]
fOo^k^koOZgI00Oo`/;200?o[Zj^ol30`?o2`/800_o2`/800oni^KWo/;2`
ol;2`P0Bol;2`P03okfm_OnUYJGoZ:RX0?oo`/;2ooo2`/95ol;2`P0@ogj]
fOnh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_k
ooclo?oinOWom?Cdono_k`?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP06
ogj]fOoVi^KoOZgIol;2`_lW9bOoFEUI0_o2`/803_nPX:3o71`LoaHF5_n=
SHgo`/;2ojn_[olh>3So0P82oaXJ6_lA4A7oTY:Bol;2`_l`<33oH61P0_o2
`/801_mLG5co<S8bol;2`_o2`/;oR8R8o`H61PKo`/;200KoL71`oaHF5_lW
9bOo7alOof1PH?o1`L7ool;2`_oo`/;2@_o2`/804?mn[MWo^;Rhol30`?o8
b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCd
m?o_knl3onKViP7oOZgI0OoVi^H1onKViP000oo^k^h01_mn[MWok^k^ogj]
fOo2`/;o9bLWoeUIF@;o`/;200?oEEEEoc4a<Oo1`L400_o2`/801?lc<c?o
<30`ojVYZOo2`/82okRh^003ol;2`_l`<33oH61P00;o`/;200KoG5aLoc8b
<_o2`/;o`/;2ohR8R?l61PH6ol;2`P06okno_oo2`/;o`/;2oinOWol10@7o
MGEeooo2`/;ool;2`T;o`/;2013oOZgIokRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_0oo^k^h1
ogj]f@7ok^k^0Oo^k^h000?ooooo00KoOZgIoooooomn[MWo`/;2obLW9omI
FET2ol;2`P07ocXj>_mFEUKo`/;2ol;2`_nXZ:So0000oh^;R`05ol;2`P06
oc0`<?mPH63o`/;2ol;2`_mLG5co<S8b0_o2`/800on8R8So1PH6ol;2`P09
ol;2`P03ob`/;?m9BDWo`/;20?oo`/;2ooo2`/91ol;2`P0@ogj]fOnh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP06ogj]fOo^
k^koOZgIol;2`_lW9bOoFEUI0_o2`/801olj>S[oEUIFol;2`_o2`/;oT92@
o`000?l^;Rh00ol_;bl01?nEUIGo`/;2oc0`<?mPH602ol;2`P06oeaLG?lb
<S;o`/;2ol;2`_n8R8So1PH62Oo2`/800ong]kOo2`/;oeaLG03ool;2`_oo
`/;2@_o2`/804?mn[MWo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl3onk^kP7oOZgI0Oo^k^h1
onk^kP000ooVi^H01_mn[MWoi^KVogj]fOo2`/;o9bLWoeUIF@;o`/;200ko
>SXjoeIFE_o2`/;o`/;2ojJVY_l0003oPX:2oifMWOnGUiOo0P82ojj^[_o2
`/;o<30`oe9BDP;o`/;200KoG5aLobHV9_o1`L7o`/;2ohR8R?l61PH6ol;2
`P06okVi^OnOWiooMWIfocHf=_l>3PkoZj^[ooo2`/;ool;2`T;o`/;2013o
OZgIokRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_ok
no_oo?clooWinOodm?Cokno_0ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^
01;oOZgIonk^k_mn[MWo`/;2obLW9omIFEWo`/;2okfm_Olg=cOoDU9BokVi
^Onn_[ko`/;2obl_;omADE7o^k^kogQhN?lP8202ol;2`P0:oc0`<?l?3`oo
JVYZok2`/?l_;boo5aLGodU9BOn[Zj_oEEEEobHV9PKo`/;200GoShn?o`D5
1Olb<S;oEUIFojb/[03ool;2`_oo`/;2@oo2`/804?mn[MWo^;Rhol30`?o8
b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCd
m?o_knl3onk^kP7oOZgI0Oo^k^h1onk^kP000oooool04_mn[MWoooooogj]
fOo2`/;o9bLWoeUIFOo2`/;oH61Po`H61_l92@Wo51@DohB4Q?o2`/;o[Zj^
ocHf=_l92@Wo5ADEoh^;R`;o`/;200[o?cloofUYJOmEEEGo30`<oahN7_nR
XZ;oMGEeoa<C4olH61SoPh>31_o2`/800on?Shoo7alOol;2`P3ool;2`_oo
`/;2AOo2`/804?mn[MWo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl3ooooo`7oOZgI0Oooool1
ooooo`000oo^k^h01_mn[MWok^k^ogj]fOo2`/;o9bLWoeUIF@;o`/;200?o
>SXjoeIFE_o2`/801?o2`/800ono_koo`/;2ol;2`P05ol;2`P03ol71`Oo2
`/;o`/;200;o`/;200?o`L71ol;2`_o2`/801Oo2`/800on?Shoo7alOol;2
`P3ool;2`_oo`/;2AOo2`/804?mn[MWo^;Rhol30`?o8b<Sodm?Com_KfooT
i>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl3onk^kP7o
OZgI0Oo^k^h1onk^kP000ooVi^H01_mn[MWoi^KVogj]fOo2`/;o9bLWoeUI
F@;o`/;200?oZZZZojRXZ?o2`/806Oo2`/800on?Shoo2@T9ocXj>P02ocXj
>P03ogmoOoo2`/;o`/;20?oo`/;2ooo2`/90ol;2`P0@ogj]fOnh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP06ogj]fOo^k^ko
OZgIol;2`_n5QHGoV9RH7_o2`/800on^[ZkoMGEeogEeM@02ogEeM@03oibL
W?o2`/;o`/;20?oo`/;2ooo2`/90ol;2`P0@ogj]fOnh^;So`<30olS8b?oC
dm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_
k`?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOooooooOZgI0?oo
`/;2ooo2`/9Yol;2`P0@ogj]fOnh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`?ooooo0Omn[MT1
ooooo`7ooooo0003onk^kP03ogj]fOo^k^koOZgI0?oo`/;2ooo2`/9Yol;2
`P0@ogj]fOnh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_oj
n_[ono_kooclo?oinOWom?Cdono_k`?ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^KoOZgI0?oo`/;2ooo2`/9Yol;2`P0@ogj]fOnh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^
k^koOZgI0?ooOZgIoomn[MUZogj]f@0?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^
0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooo
oomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kf
oo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo
0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0
`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoV
i^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV
0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo00Oooooo00?o
iNGUoogmoOooool00_ooool00oodm?Coj>SXooooo`3oooooooooooooFooo
ool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000ooo
ool01_mn[MWooooooooooooooooo=3@dogIfMP;ooooo00kodm?CobDU9OlN
7Qko^[ZjoooooooWinOoBTY:o`<30olS8b?o5aLGol71`Ooooooo@410ogmo
O`;ooooo00KoNWYjod=3@ooooooooooookBd]?l92@T9ooooo`03onCTi?l0
003ok^k^0?oooooooooooom3ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo
0Omn[MT1ooooo`7ooooo0003onk^kP06ogj]fOo^k^kooooooooooold=3Co
MWIf0_ooool00omaLG7o@D51ooknoP02ooooo`09odA4A?m0@43ogmoOoooo
oooclo?ol_;boooooom0@43oOgmo00;ooooo00KoNWYjod=3@ooooooooooo
okBd]?l92@T9ooooo`03onCTi?l0003ok^k^0?oooooooooooom3ooooo`0?
okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_o
o?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP06
ogj]fOoVi^Kooooooooooold=3CoMWIf0_ooool01om=CDgoLW9boooooooo
oooogMgMo`000?nh^;P01Oooool01_m0@43oOgmoooooooooooooNWYjod=3
@`;ooooo00?o];Bdo`T92Oooool01?ooool02?oRh^;oZ:RXojRXZ?nXZ:So
UiNGo`000?nMWIgohn?Soooooooooooood;ooooo00oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl00ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00KoOZgIonk^k_oooooo
oooooc@d=?mfMWH2ooooo`07ode=COmbLW;ooooooooooonn_[ko0000ocdm
?@03oclo?`04olC4a?oooooo@410ogmoO`;ooooo00KoNWYjod=3@ooooooo
oooookBd]?l92@T5ooooo`08okVi^Ol20P;oCTi>oe5ADOm?Cdoo0000od];
Boo7alOooooooooooooo@_ooool03onh^;So`<30olS8b?oCdm?ofm_KonCT
i?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^kP7o
OZgI0Oo^k^h1onk^kP000oooool01_mn[MWooooooooooooooooo=3@dogIf
MP;ooooo00koCDe=og9bL_ooooooooooom_Kfol0003oZj^[olo?coo7alOo
0`<3onGUiOoooooo@410ofe]K@;ooooo00KoNGUioc<c<oono_kooooook>c
/ol92@T6ooooo`06oe9BD_n0P83ooooooo[jn_l0003ok^k^oooooooooooo
od?ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Ko
n_[joo_knoolo?conOWiooCdm?o_knl00oooool1ogj]f@7ooooo0Oooool0
00?ok^k^01;oOZgIonk^k_oooooooooooc@d=?mfMWKoooooooWinOm9BDWo
KFe]ooCdm?okno_ooooooclo?om[Jf_omoOgoijNW_l[:b/2ooooo`0:od10
@?lE5AGoS8b<onSXj?lo?coo7alOof1PH?oRh^;oLG5aoc<c<`Kooooo00Ko
k^k^ob4Q8Oo0`<3on_[jo`000?o^k^kooooooooooooo@oooool03onh^;So
`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H04_mn[MWo
i^KVoooooooooooo=3@dogIfM_ooooooOgmoo`P82?l<30co6a/Kojj^[_oo
ooooi^KVodM7Aol=3@go71`LokNg]`;ooooo00[oE5ADoh^;RomaLG7o410@
obPX:?oEeMGoVYZJoaXJ6_lP823o[Jf]1oooool01Oo4a<Co7QhNonGUiOl0
003ok^k^0?oooooooooooom3ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_o
i>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV
0Omn[MT1onKViP7oi^KV0003onk^kP06ogj]fOo^k^kooooooooooold=3Co
MWIf0_ooool00om=CDgoLW9booooo`04ooooo`03ooclo?oooooooooo00Go
oooo00?oo_knooooooooool00_ooool00oono_koooooooooo`07ooooo`04
oh:2P_m5ADGo0000onk^k_oooooooooooom3ooooo`0?okRh^?o0`<3ob<S8
om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Co
kno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`06ogj]fOoooooooooo
oooooold=3CoMWIf0_ooool00ooPh>3og]kNooooo`0Kooooo`04oogmoOm0
@43o0000onk^k_oooooooooooom3ooooo`0?okRh^?o0`<3ob<S8om?CdooK
fm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?o
oooo0Omn[MT1ooooo`7ooooo0003onk^kP06ogj]fOo^k^kooooooooooon_
[joobLW98Oooool00ooVi^KoVYZJooWin@3ooooooooooooo@oooool03onh
^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_koocl
o?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn
[MWoi^KVooooo`3oooooooooooooJ_ooool03onh^;So`<30olS8b?oCdm?o
fm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03
onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`3ooooo
ooooooooJ_ooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7a
ooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1
onk^kP000oooool00omn[MWoooooooooo`3oooooooooooooJ_ooool03onh
^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_koocl
o?oinOWom?Cdono_k`03ooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn
[MWok^k^ooooo`3oooooooooooooJ_ooool03onh^;So`<30olS8b?oCdm?o
fm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03
onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`3ooooo
ooooooooJ_ooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7a
ooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onKViP7oOZgI0OoVi^H1
onKViP000oo^k^h00omn[MWok^k^ooooo`3oooooooooooooJ_ooool03onh
^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_koocl
o?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn
[MWoooooooooo`3oooooooooooooJ_ooool03onh^;So`<30olS8b?oCdm?o
fm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03
ooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^ooooo`07oooo
o`03onGUiOomoOgooooo00;ooooo00?om?CdonSXj?ooool04oooool00ooX
j>Sod];Boogmo@3oooooooooooooAOooool03onh^;So`<30olS8b?oCdm?o
fm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03
onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H01_mn[MWoi^KVoooooooooooo
=3@dogIfMP;ooooo00kodm?CobDU9OlN7Qko^[ZjoooooooWinOoBTY:o`<3
0olS8b?o5aLGol71`Ooooooo@410ogmoO`;ooooo00KoNWYjod=3@ooooooo
oooookBd]?l92@T6ooooo`06oeIFE_lA4A7o=cLgoaTI6OmTI6Col_;boooo
oooooooood?ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00ooVi^H1ogj]f@7oi^KV
0OoVi^H000?ok^k^00KoOZgIonk^k_oooooooooooc@d=?mfMWH2ooooo`03
og5aLOm1@D7oo_kn00;ooooo00WoA4A4od10@?oOgmoooooooo?cloobl_;o
oooood10@?moOgl00_ooool01_mjNW[o@d=3oooooooooooo];Bdo`T92@Ko
oooo00KoiNGUoogmoOooooooi>CTo`h>3_mdM7Cooooooooooooo@oooool0
3onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_k
ooclo?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000oooool0
1_mn[MWooooooooooooooooo=3@dogIfMP;ooooo00OoCDe=og9bL_oooooo
ooooomgMgOl0003o^;Rh00Gooooo00Ko@410ogmoOoooooooooooogYjN_m3
@d<2ooooo`03okBd]?l92@Wooooo00Wooooo00?oFEUIod=3@oooool0oooo
oooooooood;ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oooool1ogj]f@7ooooo
0Oooool000?ok^k^00KoOZgIonk^k_oooooooooooc@d=?mfMWH2ooooo`07
ode=COmbLW;ooooooooooonn_[ko0000ocdm?@03oclo?`04olC4a?oooooo
@410ogmoO`;ooooo00KoNWYjod=3@ooooooooooookBd]?l92@T9ooooo`03
ooCdm?lC4a?oQHF50?oooooooooooom3ooooo`0?okRh^?o0`<3ob<S8om?C
dooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_
00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP06ogj]fOoVi^Kooooooooo
oold=3CoMWIf0_ooool03_m=CDgoLW9boooooooooooofm_Ko`000?n[Zj_o
clo?olO7aol30`?oiNGUoooooom0@43oKFe]0_ooool01_miNGWo<c<cookn
o_oooooo/k>co`T92@Oooooo00GoXZ:RoeiNG_lU9BGoJVYZonk^kP3ooooo
oooooooo@oooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7a
ooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onKViP7oOZgI0OoVi^H1
onKViP000oo^k^h04_mn[MWok^k^oooooooooooo=3@dogIfM_oooooonOWi
odU9BOm]KFgom?Cdoo_knooooooo?cloof][JoogmoOoWYjNob/[:`;ooooo
00[o@410oaDE5On<S8coj>SXoclo?olO7aooH61Pon;Rh_maLG7o<c<c1ooo
ool01?nVYZKoHF5QocTi>Onf][KoooooooooooooA?ooool03onh^;So`<30
olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000oooool04_mn[MWooooo
oooooooooooo=3@dogIfM_ooooooOgmoo`P82?l<30co6a/Kojj^[_oooooo
i^KVodM7Aol=3@go71`LokNg]`;ooooo00[oE5ADoh^;RomaLG7o410@obPX
:?oEeMGoVYZJoaXJ6_lP823o[Jf]2Oooool00ooLg=co0`<3omOGe`3ooooo
oooooooo@oooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7a
ooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03ooooo`7oOZgI0Oooool1
ooooo`000oo^k^h01_mn[MWok^k^oooooooooooo=3@dogIfMP;ooooo00?o
CDe=og9bL_ooool01?ooool00oolo?coooooooooo`05ooooo`03ookno_oo
oooooooo00;ooooo00?oo_knooooooooool02?ooool00oono_ko6a/KoijN
WP3ooooooooooooo@oooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^kP7oOZgI
0Oo^k^h1onk^kP000ooVi^H01_mn[MWoi^KVoooooooooooo=3@dogIfMP;o
oooo00?oh>3PomkNg_ooool06Oooool01_nCTi?oKVi^oinOWomPH63o3Ph>
oo3`l?oooooooooooom3ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP06ogj]fOo^k^kooooooooooon_[joobLW9
7_ooool01OoEeMGoT92@ofa/K?nKVi_oh>3P0?oooooooooooom4ooooo`0?
okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_o
o?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03
ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?C
dooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_
00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oo
oooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooa
lO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^
kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?
okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_o
o?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03
ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?C
dooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_
00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oo
oooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooa
lO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1oooo
o`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?
okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_o
o?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03
ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?C
dooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_
00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo00Oo
oooo00?oiNGUoogmoOooool00_ooool00oodm?Coj>SXooooo`3ooooooooo
ooooFoooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^
kP000oooool01_mn[MWooooooooooooooooo=3@dogIfMP;ooooo00kodm?C
obDU9OlN7Qko^[ZjoooooooWinOoBTY:o`<30olS8b?o5aLGol71`Ooooooo
@410ogmoO`;ooooo00KoNWYjod=3@ooooooooooookBd]?l92@T6ooooo`03
oa@D5?l0003o000000;o000000?oE5ADooooooooool0oooooooooooood7o
oooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[j
oo_knoolo?conOWiooCdm?o_knl00oooool1ogj]f@7ooooo0Oooool000?o
k^k^00KoOZgIonk^k_oooooooooooc@d=?mfMWH2ooooo`03og5aLOm1@D7o
o_kn00;ooooo00WoA4A4od10@?oOgmoooooooo?cloobl_;ooooood10@?mo
Ogl00_ooool01_mjNW[o@d=3oooooooooooo];Bdo`T92@Kooooo00?oE5AD
obh^;_oVi^H00_oVi^H00oo_knooooooooooo`3ooooooooooooo@Oooool0
3onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_k
ooclo?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H0
1_mn[MWoi^KVoooooooooooo=3@dogIfMP;ooooo00OoCDe=og9bL_oooooo
ooooomgMgOl0003o^;Rh00Gooooo00Ko@410ogmoOoooooooooooogYjN_m3
@d<2ooooo`03okBd]?l92@Wooooo00Gooooo00?oiNGUoaXJ6_nRXZ80oooo
ooooooooodKooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00ooVi^H1ogj]f@7oi^KV
0OoVi^H000?ok^k^00KoOZgIonk^k_oooooooooooc@d=?mfMWH2ooooo`07
ode=COmbLW;ooooooooooonn_[ko0000ocdm?@03oclo?`04olC4a?oooooo
@410ogmoO`;ooooo00KoNWYjod=3@ooooooooooookBd]?l92@T7ooooo`03
omOGeolJ6Q[oZZZZ0?oooooooooooom5ooooo`0?okRh^?o0`<3ob<S8om?C
dooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_
00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`06ogj]fOoooooooooooooo
oold=3CoMWIf0_ooool03_m=CDgoLW9boooooooooooofm_Ko`000?n[Zj_o
clo?olO7aol30`?oiNGUoooooom0@43oKFe]0_ooool01_miNGWo<c<cookn
o_oooooo/k>co`T92@Sooooo00?of][Joa/K6onWYjL0ooooooooooooodCo
oooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[j
oo_knoolo?conOWiooCdm?o_knl00oooool1ogj]f@7ooooo0Oooool000?o
k^k^01;oOZgIonk^k_oooooooooooc@d=?mfMWKoooooooWinOm9BDWoKFe]
ooCdm?okno_ooooooclo?om[Jf_omoOgoijNW_l[:b/2ooooo`0:od10@?lE
5AGoS8b<onSXj?lo?coo7alOof1PH?oRh^;oLG5aoc<c<`Wooooo00?obLW9
o`T92Oo6a/H0oooooooooooood?ooooo00oo^;Rhol30`?o8b<Sodm?Com_K
fooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oo^
k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV01;oOZgIonKVi_oooooooooooc@d
=?mfMWKoooooogmoOol820So30`<oa/K6on^[ZkoooooonKVi_m7AdOo3@d=
oa`L7?ng]kL2ooooo`0:oeADE?n;Rh_oLG5aoa0@4?lX:2SoeMGEoiZJV_lJ
6Q[o820Pojf][@[ooooo00?o?cloofe]KOooool0oooooooooooood;ooooo
00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_k
noolo?conOWiooCdm?o_knl00ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^
00KoOZgIonk^k_oooooooooooc@d=?mfMWH2ooooo`03ode=COmbLW;ooooo
00Cooooo00?oo?clooooooooool01Oooool00oono_koooooooooo`02oooo
o`03ookno_oooooooooo00Gooooo00Koo_knoooooooooooooooooc8b<_mk
Ng_ooooooooooooo@oooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[
jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^kP7oOZgI
0Oo^k^h1onk^kP000oooool01_mn[MWooooooooooooooooo=3@dogIfMP;o
oooo00?oh>3PomkNg_ooool06Oooool01_mJFU[oDU9BoiZJV_mPH63o1PH6
on?Shooooooooooooom3ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP06ogj]fOo^k^kooooooooooon_[joobLW9
7_ooool01OoZj^[o[Jf]og=cLonKVi_ok>c/0?oooooooooooom4ooooo`0?
okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_o
o?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03
ogj]fOoVi^Kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?C
dooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_
00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oo
oooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooa
lO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^
kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomZooooo`0?
okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_o
o?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03
ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?C
dooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_
00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oo
oooooooooomZooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooa
lO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKV
iP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomZooooo`0?
okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_o
o?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03
ogj]fOoooooooooo0?oooooooooooomZooooo`0?okRh^?o0`<3ob<S8om?C
dooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_
00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo00Oo
oooo00?oiNGUoogmoOooool00_ooool00oodm?Coj>SXooooo`3ooooooooo
ooooFoooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^
kP000ooVi^H01_mn[MWoi^KVoooooooooooo=3@dogIfMP;ooooo00kodm?C
obDU9OlN7Qko^[ZjoooooooWinOoBTY:o`<30olS8b?o5aLGol71`Ooooooo
@410ogmoO`;ooooo00KoNWYjod=3@ooooooooooookBd]?l92@T6ooooo`06
ooGemOl?3`oo30`<o`000?l>3Pko5QHFoooooooooooood?ooooo00oo^;Rh
ol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?co
nOWiooCdm?o_knl00ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00KoOZgI
onk^k_oooooooooooc@d=?mfMWH2ooooo`03og5aLOm1@D7oo_kn00;ooooo
00WoA4A4od10@?oOgmoooooooo?cloobl_;ooooood10@?moOgl00_ooool0
1_mjNW[o@d=3oooooooooooo];Bdo`T92@Sooooo00?oeMGEo`000?oXj>P0
ooooooooooooodCooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[
oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oo^k^h1ogj]f@7o
k^k^0Oo^k^h000?ooooo00KoOZgIoooooooooooooooooc@d=?mfMWH2oooo
o`07ode=COmbLW;ooooooooooooMgMgo0000okRh^005ooooo`06od10@?mo
OgoooooooooooomjNW[o@d=30_ooool00ond];Co2@T9ooooo`07ooooo`03
omGEeOl0003oj>SX0?oooooooooooom4ooooo`0?okRh^?o0`<3ob<S8om?C
dooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_
00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP06ogj]fOo^k^kooooooooo
oold=3CoMWIf0_ooool01om=CDgoLW9boooooooooooo_[jno`000?lm?Cd0
0olo?cl01?o4a<Cooooood10@?moOgl2ooooo`06ogYjN_m3@d?ooooooooo
oond];Co2@T92?ooool00ooEeMGo0000onSXj03oooooooooooooA?ooool0
3onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_k
ooclo?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H0
1_mn[MWoi^KVoooooooooooo=3@dogIfMP;ooooo00koCDe=og9bL_oooooo
ooooom_Kfol0003oZj^[olo?coo7alOo0`<3onGUiOoooooo@410ofe]K@;o
oooo00KoNGUioc<c<oono_kooooook>c/ol92@T8ooooo`03omGEeOl0003o
j>SX0?oooooooooooom4ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CT
on_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP0Bogj]fOo^k^kooooooooooold=3CoMWIf
oooooooinOWoBDU9ofe]KOodm?Cono_koooooolo?cooJf][ooOgmonNWYko
:b/[0_ooool02_m0@43o5ADEohb<S?oXj>So?clooalO7omPH63oh^;Rog5a
LOlc<c<8ooooo`03omGEeOl0003oj>SX0?oooooooooooom4ooooo`0?okRh
^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?cl
ooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`0Bogj]
fOoooooooooooooooold=3CoMWIfoooooomoOgoo20P8o``<3?lK6a_o[Zj^
oooooooVi^KoAdM7o`d=3OlL71co]kNg0_ooool02_mDE5CoRh^;og5aLOl@
413o:2PXomGEeOnJVY[o6QXJob0P8?n][Jd8ooooo`03omGEeOl0003oj>SX
0?oooooooooooom4ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[
jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1
ooooo`7ooooo0003onk^kP06ogj]fOo^k^kooooooooooold=3CoMWIf0_oo
ool00om=CDgoLW9booooo`04ooooo`03ooclo?oooooooooo00Gooooo00?o
o_knooooooooool00_ooool00oono_koooooooooo`05ooooo`05ookno_oj
n_[oeMGEo`000?oXj>P0ooooooooooooodCooooo00oo^;Rhol30`?o8b<So
dm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_
knl00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00KoOZgIonKVi_oooooo
oooooc@d=?mfMWH2ooooo`03on3Ph?oNg]kooooo01Wooooo00Gom_Kfoa@D
5?le=CGo0000onSXj03oooooooooooooA?ooool03onh^;So`<30olS8b?oC
dm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_
k`03onKViP7oOZgI0OoVi^H1onKViP000oo^k^h01_mn[MWok^k^oooooooo
oooo[jn_olW9bAoooooo00ConOWiolC4a?n4Q8ColO7aooooooooooooodCo
oooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[j
oo_knoolo?conOWiooCdm?o_knl00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?o
oooo00?oOZgIooooooooool0ooooooooooooof[ooooo00oo^;Rhol30`?o8
b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCd
m?o_knl00oooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_oo
ool0ooooooooooooof[ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Co
jn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oo^k^h1ogj]
f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool0ooooooooooooof[o
oooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[j
oo_knoolo?conOWiooCdm?o_knl00ooVi^H1ogj]f@7oi^KV0OoVi^H000?o
k^k^00?oOZgIonk^k_ooool0ooooooooooooof[ooooo00oo^;Rhol30`?o8
b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCd
m?o_knl00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIoooooooo
ool0ooooooooooooogcooooo0Omn[MT1ooooo`7ooooo0003onk^k_ooOZgI
oomn[MV0ogj]f@;ok^k^003oonKVi_ooi^KVQOoVi^H00?ook^k^ooo^k^j5
onk^kP00ooooooooooooohGooooo003oogmoOeSoOgmo1omnOWkoogmoObKo
Ogmo00001?o[jn_oi^KVon;Rh_oNg]h4omgMg@?og]kN0?oogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMd001?og]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kN00;ogMgM0_oLg=`0=?oKfm_ogMgMomcLgOoNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]h2omgMg@07om_KfooJf][oemOGomSHf?oGemSof][Jom_Kf`02omgM
g@3oomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN000GomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMd01?oNg]h0
0ooMgMgog]kNomkNgP03omgMg@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKV
i_oPh>001ooIfMT01?oHf=SoeMGEom?Cdoo@d=03olg=c@04om3@d?oCdm?o
emOGomSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?C
omOGeooHf=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?C
dooGemOof=SHg?oIfMT2omSHf006omKFe_oCdm?odm?ComCDe?oGemOof=SH
0_oIfMT00ooHf=SofMWIomWIf@02omSHf0WofMWI00?of=SHomWIfOoIfMT0
0_oHf=P00ooIfMWof=SHomSHf002omSHf1OofMWI00Cof=SHomKFe_oBd];o
clo?0_o=cLd01?o?cloodm?ComOGeooHf=Q/omWIf@03omSHf?oIfMWofMWI
0:SofMWI00?of=SHomWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007
onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=co
dm?ColO7aonk^k_o/K6aojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09
on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7
aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:b
ojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`3Kon7Qh@09on3Ph?oOgmoo
fm_KomKFe_oDe=Coe]KFom[Jf_oNg]koh>3P00KogmoO0ooPh>000ooOgmoo
h>3Pon3Ph002on3Ph0SogmoO0_oNg]h2omoOg`?oh>3P0_oOgml2on3Ph0;o
gmoO3OoPh>001OoOgmoogMgMomWIfOoEeMGodm?C00;od];B00?oe]KFomcL
g?oPh>00oooQhN4Jon7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoTi>@1onWY
j@7ok>c/00000oo`l?3okno_oo7al@03oo3`l0;okno_0?ook^k^onWYjOoJ
f][o`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Z
j_o]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][J
ol;2`_nTY:CoS8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^So
kNg]oo7alOo_knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2
`/;oY:BTohb<S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]
kOoalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knl001oolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo3`l?o]kNgok>c/onGUiOoRh^;ogmoO
onGUhooYjNWokNg]00;oj>SX00Koi^KVonWYjOoWinOojn_Yonc/k?o^k^h3
on[ZjP03ono_koo^k^kok^k/00;oj>SX00Ooi^KVonWYjOoWinOoj^[ZonWY
jOoYjNOoiNGU00;oinOW00[ojn_[onc/k?o_knoojn_[on[Zj?oYjNWok^k^
onc/k?o[jn_oj>SX0_o]kNd02_o^k^coj^[Zonc/k?o/k>cok^k^on[Zj_o/
k>cokNg]onk^k?oZj^X2onc/k008onk^k_n][JgoMgMgoeUIFOm_Kfko][Jf
on7QhOoWinL2ono_k`3ooo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_koo`l?3okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
000Oono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`04oo3`l000
00?ol_;bonk^k_oWinL01?oUiND04?oTi>CogmoOom7AdOna/K7oRXZ:ofIV
I_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RXWo/K6aom7AdOoNg]h2onCT
i003onGUiOoTi>CoiNGT00;oi>CT00oog]kNom7AdOna/K7oRXZ:ofIVI_mA
DE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6aom7Ad?oNg]h00_oTi>@0
n?oUiNGoi>CTonGUiOoTi>Coi>CSomkNg_oAdM7o/K6aohZ:R_mVIVKoDE5A
odE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM7og]kNonCThooTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUon?Shoo6a/Ko:2PXodE5AOn?Shood];Aom_KfooLg=co
e]KF0ooEeMD02ooDe=Cof][IomoOgooOgmoofMWIomGEeOoHf=SogmoOon7Q
hOoMgMcoe]KF00?oeMGE00Goe=CDomWIfOoJf][of=SGomGEe@02omKFeP0?
omWIfOoMgMgoh>3Pom_KfooFe]Goe]KFomgMgOoLg=cof=SHomGEeOoLg=co
h>3PomoOg_oJf][ofm_K00;ogMgM0?oofMWIomcLg?oOgmooh>3Oom_KfooJ
f][ogMgMon3Ph?mcLg?oJ6QXohf=SOmDE5Co20P8oj>SXooKfm_ohn?SonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>@002OoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiND00_oTi>@4onGUi@06
onCTi?oUiNGoiNGUonGUiOoXj>SokNg]0Oobl_800003ooCdm?o]kNgoinOW
00;oh>3P01?ohN7QomkNg_oNg]kod];BokBd]?n7QhOoG5aLofdk=OnNCT;o
cFiNonV3Koo=KeooWTi3ofdk=_mLG5coQhN7okBd]?oBd];og]kN00Goh>3P
017og]kNom;Bd_nd];CoQhN7oeaLG?m]H2coWYH^olg=?ooYjDgocLdooijJ
;om]HbgoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomkNg_oBd];o];Bd
ohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=AomZWSCoBFX_oeaLG?n7QhOo
];Bdom;Bd_oNg]h0f_oPh>001_oOgmooclo?oiVIVOnBTY;o6ATIohb<S0;o
eMGE01ooclo?ol;2`_o>c/koc/k>olG5aOo:b/[of][JomSHf?o@d=3obl_;
olo?cooHf=Sof][JomGEeOo?cloo`L71om3@d?o>c/koa<C4ol_;booHf=So
emOGokjn__nk^k_odM7Aom3@d?oEeMGof=SHom?Cdoo<c<coc/k>00;oeMGE
00Goc/k>olc<c?oCdm?of][JomSHf002om;BdP04omSHf?oGemOodM7Aom?C
d`;ofMWI00Kodm?Com7AdOoGemOof=SHom7AdOo@d=02om7Ad@04odI6A_m1
@D7oemOGomkNgV[oh>3P00?ogmoOon3Ph?oPh>001OoPh>000ooOgmooh>3P
on3Ph00bon3Ph003omoOgooPh>3oh>3P06goh>3P00?ogmoOon3Ph?oOgml0
0_oOgml3on3Ph003on7QhOoWinOok>c/007olo?c00000oofm_Kol_;bon_[
j`03onSXj00ConOWiooRh^;ocLg=oinOWomZGUkoScH^oneaHOoiWI3ooK6U
oofl[oom]:OonInConedHonB=booJemOoinOWoo=cLgoh^;RonOWi`03onSX
j00ConOWiooRh^;ocLg=oinOWom^IUooTg8RongAA?oilgCooOf=oogmUOom
oHkonOQfongGAonCLb;oKVMOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOW
iooRh^;ocLg=oinOWomPJ5ooBg`Soi;QBonmnG_od?fBomSmVooDoIGo`?Un
oiSXCOm=P2CoH6UOoinOWoo=cLgoh^;RonOWi`3KonSXj004onKVi_oQhN7o
GEeMode=C@;ogMgM01ooD51@o`L71olE5AGoQ8B4oaHF5_m3@d?oh^;RomgM
gOnLW9co0000ohn?SooMgMgohN7Qom_Kfom0@43o20P8oaTI6On8R8So2`/;
oeQHF?ng]kOo30`<o`L71olS8b?o9bLWogemOOoJf][ogMgMomCDe?l;2`_o
FEUI00;ofMWI00?oGEeMo`/;2ooCdm<00_oOgml01_mJFU[oCTi>omkNg_oN
g]ko8b<SohB4Q0;ohN7Q00coNWYjobh^;_oMgMgogMgMol;2`_m@D53o<c<c
ofi^K_n3Ph?o8B4QomkNg_oVi^KoonSXj27oj>SX0Oo/k>`1oo;blP7om_Kf
00000oogmoOon?ShooShn003ooShn00CooOgmoo^k^koc/k>oi2@T?n5;b_o
jFAFooZBQoonYY_oo[2UoonhZoon/jKooZRLoo^DROo^J5WoRC4[oi2@T?o>
c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_P
K_onm8;oo_j:ooooT_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^
ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSo
c_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^ooOgm`3K
ooShn00UooKfm_oalO7oPH61oalO7oo]kNgoa/K6o`000?o3`l?odm?CoeaL
G?l820Soj^[Zoo3`l?oZj^[oDU9Boa@D5?lm?CgojNWYoo3`l?n_[joo1`L7
om;Bd_o=cLgoCTi>oa/K6oo^k^kofm_Kojj^[_oXj>Sok>c/ojj^[_l0003o
];Bdonc/k?n`/;3o2`/;oaXJ6P02onCTi00;ob<S8ol>3PkoY:BTong]kOo^
k^koH61PoeADE?o^k^kokNg]obHV9_n=SHd00_o`l?003?n2PX;o<C4aonc/
k?oZj^[o@d=3obl_;onLW9coLg=cobXZ:_lJ6Q[ok^k^ooKfmPcon?Sh00?o
moOgooShn?ohn?P0Foohn?P00oogmoOon?ShooShn005ooShn003ooOgmooh
n?Son?Sh03Oon?Sh00?omoOgooShn?ohn?P0J_ohn?P00oogmoOon?ShooSh
n002ooShn003ooOgmooinOWomoOg00;omoOg00000oojn_[omOGeonk^kP02
onc/k03oon_[jooYjNWogmoOokZj^_miDU;o_c4SonMdJOomRGkooiN;oojR
U_ooZ9cooZBHoonJSOonRWookWIZol<c9?miDU;o^[ZjomoOgooZj^[ojn_[
onc/k?o[jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3ooMYSoooZL_onlgko
ooZ2ookfOoook7?oo]iToo[7DOoRTQcoRFICokZj^_oOgmooj^[Zon_[joo/
k>cojn_[on[Zj_oOgmoo^[Zjoe9]D_mAXacoTM9EojKWJ_nhnG[o`?j2olOo
ROo3oXCo^OekojO/K?nDeUOoDZHLoe9]D_nj^[[ogmoOon[Zj_o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/0038onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[jooZj^[oi>CTogYjN_lL71coh^;Rol_;bol30`?o
WinOomoOgonDU9Co4a<Con3PhOoQhN7od=3@o`H61_nQXJ7o2@T9okjn__oR
h^;o^KVjo`820_na/K7og]kNoh20P?lY:BWoh^;RonSXj?oTi>GogmoOom[J
f_oDe=Co20P8ohJ6Q_oOgmooJVYZodU9B_le=CGo[:b/okjn__l71`OoN7Qh
oeEEEOoOgmoogmoPoe]KFom?Cdooh^;Ron3Ph?lT92CoQ8B4on3Ph?oPh>7o
Ng]kobl_;ooQhN7oe=CDo`D51OnWYjOoi>CTon;RhomoOgoo5ADEon;Rh_oY
jNWok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jn`2on_[j`2Yonc/k?o[jn_o
k>c/on[Zj_o/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k006on_[j`05
onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT00003oo_knooclo?okNg]00;o
iNGU0?ooi^KVon?ShooIfMWo/K6aogT^;_o8@SCohfYLooAjKOomR7cooYN:
oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;of=SHonCTi?oUiNGo
i^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^lA?onc5?ooMQRookSL_on
jGGoo^IcookKIOomc5?onl55onjN:onIERko/[:bomSHf?oTi>CoiNGUonKV
i_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on7bTSoUmaIojGUJOnblgOo^?Ik
okCeNOnWjV_oV=aIohW?BomS[R_o;V<^ok:b/_oHf=Woi>CTonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNH00?ooi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonCTi?oNg]koMgMgoa/K6ooLg=coh>3PoijNW_l^
;Rko:b/[oc8b<_lB4Q;ofm_Lom_Kfon4Q8Co8B4QomoOgomCDe?oIfMWom_K
fooMgMkoT92@obTY:Ol_;boo;2`/obPX:?oMgMgogmoOomSHfOoDe=Coclo?
oe]KFol0003o_[jnomWIfOlX:2SoQXJ7ogQhN?mXJ6SoPX:2oc`l??o3`l?o
3`l?omGEeOoIfM[oFEUIodi>C_oMgMgog=cLob<S8on1PH7oe]KFomKFeomg
MgOo;Rh^omgMgOnRXZ;o0000olK6a_oIfMWof=SIohj>S_lE5AGogMgMon?S
hooVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^H007?oiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU00?oi^KV00?o
iNGUonKVi_oVi^H00ooVi^H00ooUiNGokNg]ooCdm001oo_kn`0000?oo?cl
ooShn?oalO400oo^k^h04oo[jn_ohN7Qokbl_?mj5aOo`clbom=EBOoTJ5[o
kgM/oo>3N?ohQgcomHAjoo=iKOoUJE_ofEQ:ol@o<_ml5aOo_;blon7QhOo/
k>`00oo^k^h04oo/k>cohN7Qokbl_?nUAaOoiYLbooF/<?om_47ooLUCoog@
H?okdfGooM9Pook=E?om_D;onZlbonVK<_nUAQOo_;blon7QhOo/k>`00oo^
k^h04oo/k>cohN7Qokbl_?lGFAOoGjPbogJm=on6cDOoU]IJoj;PIOnSh6Wo
Xn5WoiOJG?n6cTOoMklgoen[<_lGFAOo_;blon7QhOo/k>`0foo^k^h0;_o/
k>coinOWog]kNolL71coi>CTonWYjOoVi^KohN7QomkNg_n=SHgo51@DonKV
i_oTi>Co=CDeogUiNOo[jn_o/[:boaDE5OoOgmooi^KVonCTi?oQhN7ogMgM
ogYjN_lY:BWoj>SXonGUiOoMgMgo/K6aobHV9_l;2`_oVi^KonWYjOo<c<co
0000olk>c_o3`l?o9BDUod];BomlO7coj>SXoc4a<OnUYJGoi>CToeeMGOmA
DE42onOWi`0:obDU9OmYJFWogmoOomoOgomgMgOo<C4aonWYjOo1`L7o0000
ojNWY`;ogmoO00CoTi>CoaHF5_oWinOok>c/J_o^k^h00oo]kNgok^k^onk^
kP05onk^kP03ong]kOo^k^kok^k^0:[ok^k^00?okNg]oo;bl_ohn?P00Ool
o?`000?ooOgm01Koo?cloogmoOomoOgoo?cloo;bl_oAdM7oI`H6okPd=?o7
?c?odU13omYREOoSKV;oi79TonA_H_oLI5Oode53ola1=?ni=3CoJ`L7om;B
d_oclo?oo?cl0oomoOd04oolo?colo?com;Bd_nN:`OofXXdon^K6OoeZ2Wo
n;@oooVmB_oh_dgon[m:ooVh?oofZR[okihIom^;=?nR;@Ood];Boo?clool
o?`00oomoOd04oolo?colo?com;Bd_l7@0OoCIXdoen[8?m`^2ooOl=3oh[=
D?n=cE;oR/i@oh77A?ma^BooHZhPodjK=?l7@POod];Boo?cloolo?`0foom
oOd08ookno_omoOgohB4Q?lN7Qkolo?cooWinOnc/k?od=3@oo?clomXJ6So
AdM7oo[jn_oDe=Co0000omgMgOolo?cono_kobLW9onXZ:SonOWioj^[ZooE
eMGolO7aoeADE?mNGUkonOWiooCdm?nDU9Co1@D5od10@?oAdM7omoOgooSh
n?nGUiOo:b/[00;on_[j01_o92@To`L71oo8b<Sono_kohF5QOmSHf?omoOg
of=SHomGEeOon?ShooWinOlW9bOo5ADEoh>3PooGemOo@T92of=SHookno_o
n_[joc@d=?m9BDWofm_KonGUiOm?Cdoo5aLGoo[jn_olo?`0ooomoOdNoogm
o@03ooclo?omoOgoo?cl00?ooOgm00001?omoOgon_[joo?cloo^k^h2ono_
k`0dong]kOoYjNWodm?Coe/M7OnR=3Co]2PMol4j;Oo7BCcoceI:om1GBoo@
Ed[obTXnol<k;_nf:1goXS@doe`M7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`
koo^k^koj^[Zom?Cdon<9Agob74domV47OoTU1GoiidTonjX<oo`ZSCokjXc
onbP9OoWUaGog8PMolQa=?n<9Agodm?Con[Zj_o^k^kol?3`ono_koo`l?3o
k^k^on[ZjOoCdm?o7CPMocB2=?m7UAgoFZDKofV]:P;oM;Ph0?ooMKThof^a
:omKYacoB9XMocB2=?lM>1godm?Con[ZjOo^k^kol?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3ok^k^on_[jommOGgo71`LonOWioo^k^koR8R8oc0`<?l>3Pko<C4a
ok2`/?o_knkoQ8B4ode=COo^k^kokno_onk^k_n:RX[oFEUIono_k_mhN7So
;2`/o`h>3_lh>3So_[jnonk^k_oShn<000co3Ph>ofUYJOoPh>3oh^;RonKV
i_oZj^[oHF5QogIfM_o_knkok^k^ogMgMolV9RH2onk^kP0Folg=cOl/;2co
jn_Zofa/K?mSHf?ojn_[onk^k_lj>S[oU9BDof9RH_l>3Pko=3@dolC4a?o^
k^kokno_om7AdOll?3co2PX:obHV9_m/K6co;2`/onk^kP;okno_0?ool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_ono_k_o^k^kol?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?0001Kokno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`0_o_knl2oo3`l0Kokno_0Ooc
lo<1ooWin@7oo_kn00000oono_komoOgoo3`l004onWYj@0AonOWiooKfm_o
Hd];oh4b<_nV=3Co]S@]ol9=@Oo3E4Woa5E:ol=DBOo2CD7o]S@]ojDe=On1
<S;oHd];om_KfooWinL01OoYjNT04OoWinOofm_KohU;Bon_Bc;ocGLeomJ;
;OoPW2koh:0bon6P=?oPX3;ogiX^omJ;;Oo:MCGo[d/bohU;BooKfm_oinOW
00GojNWY017oinOWom_Kfom;Bd_o<V0bocZ9=OmCVbgoJj/_og2]>?m_[S[o
L:dhofZZ;omCVbgo>HPeoc9P<_m;Bd_ofm_KonOWi`3LonWYj@06onSXj?oV
i^KoNg]koa`L7?oTi>Coj>SX0_oYjNT00ooWinOojNWYonWYj@0;onWYj@0<
onOWiooYjNWojNWYonSXj?oHf=So2PX:ojj^[_oMgMgog]kNon3Ph?oUiNGo
j>SX2?oYjNT01_oXj>Soi^KVon?ShooShn?oi^KVonSXj0?ojNWY00?oj>SX
onWYjOoYjNT01?oYjNT00ooWinOojNWYonWYj@2ZonWYj@03onSXj?oYjNWo
jNWY06oojNWY00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07omoOg0Oono_h0
0004ookno_ojn_[om?Cdono_k`?ol?3`017okno_on_[jonEU9CoCb<SoiED
E?nkLg?odiFEomZLW?oJWYcofIbLomBEUOnkLg?oUEADodlS8onEU9Coj^[Z
ono_k`05oo3`l00Aono_kooZj^[oZIBDoh4S8onjJUCoe9YconBlUOoZaico
jLNLon[7W?oU_9Goe9Ycok]ZE?n18b?oZYBDon[Zj_o_knl01Oo`l?004Oo_
knooj^[ZoiBDU?lS:R?oE7YDog>ULonNaYGo[<jLojg>W?n/cYcoW/JEog>U
LomDNUCo8bXSoiBDU?oZj^[okno_0=col?3`0_o_knl01?n0P83o7AdMonk^
k_o_knlCoo3`l0;okno_00OoI6ATobTY:On1PH7oHf=Soc/k>oo^k^kokno_
00Sol?3`00Kokno_onk^k_mcLg?oJFUYonk^k_o_knl9oo3`l003ono_koo`
l?3ol?3`017ol?3`00?okno_oo3`l?o`l?00WOo`l?000oo_knool?3`oo3`
l01^oo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn00001?o/ko7ooooooooo
ooono_h2ooooo`;oo_kn0?oooOgmooShn?m^KVkoFSlook6@T?oNbLWol>CT
oo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?coooooookno_oooooo
o_knooooo_ono_koooooooclo?ohn?SoSFe]ohXo?oo9TI3ojM39ooCYi?of
jnKom>WTonW@bOo9TI3oRCloohe]KOohn?Ooo?clooooooono_koooooookn
o_ooooooo_knooooo_olo?con?Shofe]KOlo?cooT9f@olWEbOoTk>Coi^kV
onC/i?o9eLWoT9f@oclo?om]KFgon?Shooclo?ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_h001Woooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_kooooo00;oo_kn0?ooclo?ojJVYOomoOgoooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooknoOo0`<3oLG5a
oh20P?n`/;3ooOgmooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ono_go`L71okfm_OomoOgoooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_h005Goooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_kooooo00;oo_kn00Go
ooooookno_ooooooooooooknoP05ooooo`7on__k00001_o3bm;oo_knoo[j
n_odm?ColO7aoo3`l0?olO7a00gokno_omKFe_m[Jf_o@cdmoi^<S?o6^[[o
e/c<olNj^_nKS8co@cdmof][JooFe]Kokno_00WolO7a00gokno_omOFe_n3
Jf_oM3dmokF<S?oE^[[ohLc<omJj^_nfS8coLSdmoh5[JooGe]Kokno_00Wo
lO7a00gokno_omKFe_m[Jf_o?Cdmohb<S?nj^[[oc<g<okZj^_n<S8co?Cdm
of][JooFe]Kokno_0?oolO7aoooalO4goo7al@04oo3`l?oalO7olO7aoo3`
l0ColO7a00?om?Cdoo[jn_ono_h00Oo_lO800005ohJDX?omoOgomoOgoo3`
l?o[jn/00ooZj^X03OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9
obHV9_mIFEWoVi^KonSXj?oYjNT02ooZj^X02ooYjNWoj>SXoj2KVomZFEWo
@bHVobd92Om29RKoJEUIoj2KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nK
Vi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@3oon[Zj_ooj^[Z
?ooZj^X01?o[jn_ol?3`ooShn?omoOd1om[Nh@0000Co>DYJok[3b_ojn_[o
m?Cd2?oalO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l0oo
lO7a0_o`l?03ono_k`;ol?3`oooalO7ooo7alCgolO7a00Sol?3`oo7alOoa
lO7olO7aoo3`l?oemOGon_[jon[/kP7oW:6T00000olQ>4WoCeiZok[1b03o
ooooooooooooOoooool1onW[k07oY:R[0OnIWZ800006ob@nD?lQ=DCo>DIC
ohB>VOo0a/cojng_ooooooooooooogWooooo00GonOWjonc^kooAe=OoVinR
oifQYP01okBi_@00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{643, 482},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(strings = 
      Table[\[IndentingNewLine]JavaNew["\<java.lang.String\>", \
\[IndentingNewLine]StringJoin["\<Item \>", 
            ToString[i]]\[IndentingNewLine]], \[IndentingNewLine]{i, 1, 
          10}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject35144847585181697], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject35144847568404481], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject35144847551627265], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject35144847534850049], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject35144847518072833], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject35144847501295617], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject35144847484518401], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject35144847467741185], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject35144847450963969], ",", 
        InterpretationBox[\(\[LeftGuillemet]JavaObject[
              "java.lang.String"] \[RightGuillemet]\),
          JLink`Objects`JavaObject8626363766407169]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(list = NewJList[Null, strings]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JList"] \[RightGuillemet]\),
      JLink`Objects`JavaObject19063044571137]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<javax.swing.ScrollPaneConstants\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["javax.swing.ScrollPaneConstants", 54]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?javax`swing`ScrollPaneConstants`*\)\)], "Input"],

Cell[BoxData[GridBox[{
        {
          StyleBox["javax`swing`ScrollPaneConstants`",
            FontFamily->"Helvetica",
            FontSize->12,
            FontWeight->"Bold"]},
        {GridBox[{
              {
                ButtonBox[
                  StyleBox["COLUMNUHEADER",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`COLUMNUHEADER"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"], 
                ButtonBox[
                  StyleBox["LOWERULEFTUCORNER",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`LOWERULEFTUCORNER"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"], 
                ButtonBox[
                  StyleBox["UPPERUTRAILINGUCORNER",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`UPPERUTRAILINGUCORNER"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"]},
              {
                ButtonBox[
                  StyleBox["HORIZONTALUSCROLLBAR",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`HORIZONTALUSCROLLBAR"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"], 
                ButtonBox[
                  StyleBox["LOWERURIGHTUCORNER",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`LOWERURIGHTUCORNER"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"], 
                ButtonBox[
                  StyleBox["VERTICALUSCROLLBAR",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`VERTICALUSCROLLBAR"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"]},
              {
                ButtonBox[
                  StyleBox["HORIZONTALUSCROLLBARUALWAYS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`\
HORIZONTALUSCROLLBARUALWAYS"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"], 
                ButtonBox[
                  StyleBox["LOWERUTRAILINGUCORNER",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`LOWERUTRAILINGUCORNER"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"], 
                ButtonBox[
                  StyleBox["VERTICALUSCROLLBARUALWAYS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`\
VERTICALUSCROLLBARUALWAYS"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"]},
              {
                ButtonBox[
                  StyleBox["HORIZONTALUSCROLLBARUASUNEEDED",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`\
HORIZONTALUSCROLLBARUASUNEEDED"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"], 
                ButtonBox[
                  StyleBox["ROWUHEADER",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`ROWUHEADER"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"], 
                ButtonBox[
                  StyleBox["VERTICALUSCROLLBARUASUNEEDED",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`\
VERTICALUSCROLLBARUASUNEEDED"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"]},
              {
                ButtonBox[
                  StyleBox["HORIZONTALUSCROLLBARUNEVER",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`\
HORIZONTALUSCROLLBARUNEVER"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"], 
                ButtonBox[
                  StyleBox["UPPERULEADINGUCORNER",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`UPPERULEADINGUCORNER"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"], 
                ButtonBox[
                  StyleBox["VERTICALUSCROLLBARUNEVER",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`\
VERTICALUSCROLLBARUNEVER"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"]},
              {
                ButtonBox[
                  StyleBox["HORIZONTALUSCROLLBARUPOLICY",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`\
HORIZONTALUSCROLLBARUPOLICY"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"], 
                ButtonBox[
                  StyleBox["UPPERULEFTUCORNER",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`UPPERULEFTUCORNER"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"], 
                ButtonBox[
                  StyleBox["VERTICALUSCROLLBARUPOLICY",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`\
VERTICALUSCROLLBARUPOLICY"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"]},
              {
                ButtonBox[
                  StyleBox["LOWERULEADINGUCORNER",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`LOWERULEADINGUCORNER"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"], 
                ButtonBox[
                  StyleBox["UPPERURIGHTUCORNER",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`UPPERURIGHTUCORNER"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"], 
                ButtonBox[
                  StyleBox["VIEWPORT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240732788-4853428", 
                    "javax`swing`ScrollPaneConstants`VIEWPORT"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`ScrollPaneConstants`"]}
              },
            RowMinHeight->{1, 1, 1, 1, 1, 1, 1.05}]}
        },
      RowSpacings->{2, 3},
      ColumnAlignments->{Left},
      ColumnsEqual->True]], "Print",
  CellMargins->{{20, Inherited}, {Inherited, Inherited}},
  ShowCellLabel->False,
  CellFrameMargins->{{Inherited, Inherited}, {14, 14}},
  Background->GrayLevel[0.930022],
  ButtonBoxOptions->{Active->True}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(scroll = 
      NewJScrollPane[\[IndentingNewLine]pane, \[IndentingNewLine]list, \
\[IndentingNewLine]javax`swing`ScrollPaneConstants`VERTICALUSCROLLBARUALWAYS]\
\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JScrollPane"] \[RightGuillemet]\),
      JLink`Objects`JavaObject118363695087617]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(Do[\[IndentingNewLine]ReleaseObject[
        strings[\([i]\)]], \[IndentingNewLine]{i, 1, 
        Length[strings]}\[IndentingNewLine]]\), "\n", 
    \(scroll@removeAll[]\), "\n", 
    \(ReleaseObject[list]\), "\n", 
    \(DeleteJObject[pane, scroll]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JSlider <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P8c<c<100003O<c<`200000lc<c0@0000ac<c<1P0000;<c<`40000<lc<
c0@00003c<c<100003C<c<`200000lc<c0@0000bc<c<100000?<c<`40000
</c<c0@00003c<c<100003;<c<`200001Lc<c0@0000cc<c<100000?<c<`4
0000</c<c0<00004c<c<1000033<c<`200000lc<c0@00003c<c<100000;<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1lc<c0800002c<c<0P00
03K<c<`200000/c<c0800002c<c<0P00033<c<`200001Lc<c0800002c<c<
0P00037<c<`200000/c<c08000000lc<c00000000002c<c<0P0003?<c<`2
00000/c<c0800002c<c<0P00033<c<`200000/c<c08000000lc<c0000000
0002c<c<0P00033<c<`200000/c<c08000000lc<c00000000002c<c<0P00
037<c<`200001<c<c0800002c<c<0P00037<c<`200000/c<c08000000lc<
c00000000002c<c<0P00033<c<`200000/c<c0030000c<c<c<c<00800002
c<c<0P0002o<c<`200000/c<c0800002c<c<0P000003c<c<0000000000;<
c<`2000000C<c<b8`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0O<c<`2
00000/c<c080000fc<c<0P0000;<c<`200000/c<c080000ac<c<0P0000C<
c<`200000/c<c080000ec<c<0P000003c<c<0000000000;<c<`20000<<c<
c0H000000lc<c00000000002c<c<0P0003C<c<`2000000?<c<`000000000
0/c<c080000`c<c<0P0000;<c<`2000000?<c<`0000000000/c<c080000a
c<c<0P0000C<c<`200000/c<c080000ac<c<0P0000;<c<`2000000?<c<`0
000000000/c<c080000dc<c<0P000003c<c<0000000000;<c<`20000;lc<
c0800002c<c<0P0000;<c<`2000000?<c<`0000000000/c<c08000001<c<
c8S0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1lc<c0800002c<c<0P00
03K<c<`200000/c<c0800002c<c<0P0003;<c<`200000lc<c0800002c<c<
0P0003G<c<`2000000?<c<`0000000000/c<c080000`c<c<00<0003<c<c<
c<`00P0000;<c<`200000/c<c080000dc<c<0P000003c<c<0000000000;<
c<`20000<<c<c0800002c<c<0P000003c<c<0000000000;<c<`20000</c<
c0800003c<c<0P0000;<c<`20000<Lc<c0800002c<c<0P000003c<c<0000
000000;<c<`20000<Lc<c0D000000lc<c00000000002c<c<0P0002o<c<`2
00000/c<c0800002c<c<0P000003c<c<0000000000;<c<`2000000C<c<b8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0O<c<`200000/c<c080000f
c<c<0P0000;<c<`200000/c<c080000cc<c<0P0000;<c<`200000/c<c080
000ec<c<0P000003c<c<0000000000;<c<`20000<Lc<c0040000c<c<0000
00000/c<c0800002c<c<0P00033<c<`200000/c<c08000000lc<c0000000
0002c<c<0P00033<c<`200000/c<c08000000lc<c00000000002c<c<0P00
03;<c<`200000lc<c0800002c<c<0P0003;<c<`400000/c<c0800002c<c<
0P00033<c<`200000/c<c08000000lc<c00000000002c<c<0P0002o<c<`2
00000/c<c0800002c<c<0P000003c<c<0000000000;<c<`2000000C<c<b8
`;R8`;Q8T8P10000000018S0^<SPf8S0^8S0^0O<c<`200000/c<c080000d
c<c<00@0003<c<`000000002c<c<0P0000;<c<`20000=<c<c08000000lc<
c00000000002c<c<0P0003?<c<`300000/c<c0800002c<c<0P00037<c<`0
10000<c<c000000000;<c<`200000/c<c080000`c<c<1@0000;<c<`20000
0/c<c080000`c<c<1@0000;<c<`200000/c<c080000cc<c<0P0000;<c<`2
00000/c<c080000ac<c<0P0000;<c<`2000000?<c<`0000000000/c<c080
000`c<c<0P0000;<c<`2000000?<c<`0000000000/c<c080000]c<c<00@0
003<c<`000000002c<c<0P0000;<c<`2000000?<c<`0000000000/c<c080
00001<c<c8S0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h1lc<c0800002
c<c<0P0003C<c<`400000/c<c0800002c<c<0P0003C<c<`2000000?<c<`0
000000000/c<c080000ec<c<0P000003c<c<0000000000;<c<`20000</c<
c0<00002c<c<0P0000;<c<`20000<<c<c0800005c<c<0P0000;<c<`20000
<<c<c0800005c<c<0P0000;<c<`20000<lc<c0800002c<c<0P0000;<c<`2
0000<Lc<c0800002c<c<0P000003c<c<0000000000;<c<`20000<<c<c080
0002c<c<0P000003c<c<0000000000;<c<`20000;Lc<c0@00002c<c<0P00
00;<c<`2000000?<c<`0000000000/c<c08000001<c<c8S0^8S0^4R@R040
00000004R<2hb>3HR<2hR<2h1lc<c0800002c<c<0P0003G<c<`300000/c<
c0800002c<c<0P00033<c<`200000/c<c08000000lc<c00000000002c<c<
0P00037<c<`200000/c<c08000000lc<c00000000002c<c<0P0003;<c<`3
00000/c<c0800002c<c<0P00037<c<`200001<c<c0800002c<c<0P00037<
c<`00`000<c<c<c<c002000000?<c<`0000000000/c<c080000dc<c<0P00
0003c<c<0000000000;<c<`20000<Lc<c0800002c<c<0P000003c<c<0000
000000;<c<`20000<<c<c0800002c<c<0P000003c<c<0000000000;<c<`2
0000;/c<c0<00002c<c<0P0000;<c<`2000000?<c<`0000000000/c<c080
00001<c<c8S0^8S0^4R@R04000000004R<2hb>3HR<2hR<2h2<c<c0@0000g
c<c<0P0000?<c<`40000</c<c0@00003c<c<100003?<c<`400000lc<c0@0
000dc<c<0P0000?<c<`40000</c<c0D00002c<c<100003?<c<`300000lc<
c0@0000ac<c<1P0000;<c<`40000<lc<c0@00003c<c<100003;<c<`40000
0lc<c0@0000`c<c<0P0000?<c<`400000lc<c0@00002c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h2/c<c003
VIW<c<c<c<c<03[<c<`00iVIc<c<c<c<c00jc<c<00>IVLc<c<c<c<`0>lc<
c003VIW<c<c<c<c<03[<c<`00iVIc<c<c<c<c00jc<c<00>IVLc<c<c<c<`0
>/c<c003VIW<c<c<c<c<03[<c<`00iVIc<c<c<c<c00kc<c<00>IVLc<c<c<
c<`0>/c<c003VIW<c<c<c<c<03W<c<`00iVIc<c<c<c<c008c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0[<c<`00iVIc<c<c<c<c00jc<c<00>I
VLc<c<c<c<`0>/c<c003VIW<c<c<c<c<03_<c<`00iVIc<c<c<c<c00jc<c<
00>IVLc<c<c<c<`0>/c<c003VIW<c<c<c<c<03[<c<`00iVIc<c<c<c<c00j
c<c<00>IVLc<c<c<c<`0>lc<c003VIW<c<c<c<c<03[<c<`00iVIc<c<c<c<
c00ic<c<00>IVLc<c<c<c<`02<c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P:c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVI
c<c<c<c<c00:c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`0
0iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02/c<c003VIW<c<c<c<c<00W<
c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<
00[<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<
c<c<00W<c<`00iVIc<c<c<c<c00:c<c<00>IVLc<c<c<c<`02Lc<c003VIW<
c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02/c<c003
VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02Lc<
c003VIW<c<c<c<c<00[<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`0
2Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<
c<`02/c<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>IVLc<
c<c<c<`02Lc<c003VIW<c<c<c<c<00[<c<`00iVIc<c<c<c<c009c<c<00>I
VLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c00:c<c<
00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c009
c<c<00>IVLc<c<c<c<`02/c<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<
c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00[<c<`00iVIc<c<
c<c<c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVI
c<c<c<c<c00:c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00S<c<`0
0iVIc<c<c<c<c008c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0[<
c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<
00[<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<
c<c<00W<c<`00iVIc<c<c<c<c00:c<c<00>IVLc<c<c<c<`02Lc<c003VIW<
c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02/c<c003
VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02Lc<
c003VIW<c<c<c<c<00[<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`0
2Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c00:c<c<00>IVLc<c<c<
c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>IVLc<
c<c<c<`02/c<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>I
VLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c00:c<c<
00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c009
c<c<00>IVLc<c<c<c<`02/c<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<
c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00[<c<`00iVIc<c<
c<c<c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVI
c<c<c<c<c00:c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`0
0iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02/c<c003VIW<c<c<c<c<00W<
c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<
00[<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02<c<c003VIW<c<c<
c<c<00S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h2/c<c003VIW<
c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02/c<c003
VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02Lc<
c003VIW<c<c<c<c<00[<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`0
2Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c00:c<c<00>IVLc<c<c<
c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>IVLc<
c<c<c<`02/c<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>I
VLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00[<c<`00iVIc<c<c<c<c009c<c<
00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c00:
c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<
c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00[<c<`00iVIc<c<
c<c<c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVI
c<c<c<c<c00:c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`0
0iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02/c<c003VIW<c<c<c<c<00W<
c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<
00[<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<
c<c<00W<c<`00iVIc<c<c<c<c00:c<c<00>IVLc<c<c<c<`02Lc<c003VIW<
c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02/c<c003
VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c008c<c<00>IVLc<c<c<c<`02<c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P:c<c<00>IVLc<c<c<c<`0
2Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c00:c<c<00>IVLc<c<c<
c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>IVLc<
c<c<c<`02/c<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>I
VLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00[<c<`00iVIc<c<c<c<c009c<c<
00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c00:
c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<
c009c<c<00>IVLc<c<c<c<`02/c<c003VIW<c<c<c<c<00W<c<`00iVIc<c<
c<c<c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00[<c<`00iVI
c<c<c<c<c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<00W<c<`0
0iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02/c<c003VIW<c<c<c<c<00W<
c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<c<c<
00[<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02Lc<c003VIW<c<c<
c<c<00W<c<`00iVIc<c<c<c<c00:c<c<00>IVLc<c<c<c<`02Lc<c003VIW<
c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02/c<c003
VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`02Lc<
c003VIW<c<c<c<c<00[<c<`00iVIc<c<c<c<c009c<c<00>IVLc<c<c<c<`0
2Lc<c003VIW<c<c<c<c<00W<c<`00iVIc<c<c<c<c00:c<c<00>IVLc<c<c<
c<`02Lc<c003VIW<c<c<c<c<00S<c<`00iVIc<c<c<c<c008c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<NLc<c0030000c<c<c<c<0?g<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c7S<c<`00`0009VIc000003nc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^?o<c<agc<c<00D0002IVLbIVLbIVL`00000oLc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<M/c<c0030000VIW<
VIW<00>IVL`00`000<c<c<c<c03jc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0_<c<coooooJ_ooo`030000VIW<VIW<00FIVL`00`000?oooooo
o`3_oooo2/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P:c<c<ofIV
IVYVIVH00`0009VIc9VIc007VIW<00<0001VIVIVIVH0kFIVIP03ooooc<c<
c<c<00S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h2/c<c003IVIV
VIVIc<c<0?o<c<aVc<c<00<0002IVLbIVL`02IVIc0030000c<c<c<c<0>_<
c<`00fIVI_ooolc<c009c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0[<c<`00fIVIYVIVLc<c03oc<c<ILc<c0030000c<coVIW<00^IVL`00`00
0<c<c<c<c03Zc<c<00=VIVKoooo<c<`02Lc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P:c<c<00=VIVJIVIW<c<`0olc<c6G<c<`010000<c<oiVI
c6IVV@>IVL`01FIVVIVIc9VIc9VIc6IVV@02VIW<00<0003<c<c<c<`0j/c<
c003IVIVooooc<c<00W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
2/c<c003IVIVVIVIVIVI0?nIVIUUVIVI00<0003<c?o<c?l00iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`00`0009VIVIVIV@3ZVIVI00=VIVKoooo<c<`0
2Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P:c<c<ofIVIVQVIVH0
0`000<c<oiVIc002VIW<00EVIYVIVLbIVLbIVLaVIYT019VIc0030000IVIV
IVIV0>]VIVH;c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<ab
c<c<00D0003<c?nIVLbIVLc<c?l00iVIc003c<coVIW<VIW<00>IVL`00`00
0<c<c<c<c03fc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<ab
c<c<00@0003<c?nIVLaVIYT3VIW<00EVIYVIVLbIVLbIVLaVIYT00YVIc003
0000c<c<c<c<0?K<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c7;<c<`00`000<c<olc<o`03VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc003
0000c<c<c<c<0?K<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c7;<c<`00`000<c<olc<o`0;c<co00<0003<c<c<c<`0m/c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;Soc<c<Llc<c0d0003ic<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<
c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000B8`;S8
h=R8`;R8`;PF00200`01P0800X001002P@03P@03P@03P@<0184200F100@0
1H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<1
2h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8D
Q`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT0
10<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<
12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?
1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHb
T@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`03
1cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8
@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI
2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`0
10YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]G
WP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aN
X@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=
I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]
YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mc
Z0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`4
47f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^
00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::
/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<C
T;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI
]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh
00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/3
5ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn
0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P4002000>KYo4c@jDc@jD02C=3Y@H0080300600P02P004
00:100>100>100>10`04P@801H401005PP06PP06PP06PP801h800`47PP48
PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn5
0`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<4
7h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=
1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086
;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7
=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9
@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:
BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<
Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`
Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?
MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd3
4H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<B
Qk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d
0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL
]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d2
5jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G
/klf6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008001i^WlOoo
ohij]ZJKa;>YdZRMb;>YdP02YY_400Fl^=g^k_CZjO7ooolc@jD01@00P0<0
0H0200:000@00X400h400h400h4300B10P05P@0400F200J200J200J20P07
PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@30@f4
0`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8F
Q`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<3
7HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd3
1BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6
;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHc
TP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9
BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd2
2e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;
FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<
H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]
47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<A
QJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d
4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLD
VkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[
_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_`8H]<0P00000QRd`10000026;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^080080019^WlOooofaJYJnUbP:l^=d02_omok>Yd_oo
oooookbhgIN:_:RMb>KVk?oooc=3Y@@0080300600P02P00400:100>100>1
00>10`04P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R3
0`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH3
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8
h=Q8T8Q8T8P034R@R0030000b>3HB92800e8T8P0100001Rd`1Rd`<SPf0i8
T8P00`0001Rd`1Rd`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00
P00;VjOaooooZ9g8oooo/jWBH4bJSWZfN6F^Z9g8oooooogo00?oool00c=3
Y@00P000P00300200`01P0800X001002P@03P@03P@03P@<0184200F100@0
1H801X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<1
2h@12h@00`4<Q0<13H@30@j50`8?Q@8248D3oooo0P8AQP<24XH20Q>600@2
4hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV9
0aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`0
10@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZ
SPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`Ha
T@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7
=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0
UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6
V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`4
2U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN
00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aM
X@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=
Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/
YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X
00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/3
47b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^
0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4B
R[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008C
Sk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH
]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh
0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/3
5ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;
R<2h00=8T8P00038h=P03HS0^005B92800006;C06;C0b>3H00f8`;P014R@
R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000jK
Yo7ooooooooKg>aPC9ZCQKZcZM:l^=ePC9ZISkjVVlC8`moooolc@jD60020
0oooo`800X000`02POooooooo`02oooo0P04P@0300F1oooo00F200<01X84
oooo00<1288128?oool00oooo`<12X<01_ooo`4;Q04;Q04<Q?ooo`4<Q081
3H@01?ooo`4>QOooo`4>Q@823hD01?ooo`8@QOooo`8@Q@824HH00oooo`8A
QP8BQP020Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<G
R0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3
122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>
1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i00
10H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987
=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`Pl
U@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9
A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX3
2TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]D
W@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj02
35bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP03
3F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eX
Y@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`04
3g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX3
47RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]
00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk03
4XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8B
S[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D
]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8D
WKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX3
5JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm
0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl2
6;C000C8h=R8`;R8`;R8`;P6000018S0^003B9280000b>3H00:8`;P90000
0XS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3002000jKYo7ooonl^=fISkkooooF
dMgKg>cco_nVVlC^k_B5M[2CQK[ooolc@jD4002000Ooool00H000H000H3o
ool00X3oool00`03P@06oooo00B100B100F1oooo00F20P06PP08oooo00N2
00N20@N2oooo0@R2oooo0@R30`49P`04oooo0@Z30@Z3oooo0P4;Q0030@b4
oooo0@b400813H@01?ooo`4>QOooo`4>Q@823hD00oooo`8@QOooo`03oooo
0P8AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN8
0aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<4
88/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh5
9hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T004
1RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLe
TPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE
0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4
V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:
C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM
2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<
G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=
HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU
0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?
L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@
N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d0
0a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<B
R;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>
/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd
0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM
]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<E
Y;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d3
5jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H
]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P00038h=P00XS0^0030000
R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000C8h=R8`;R8`;R8
`;P2000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0`00P00?VjOaooooVHnnUhZle=?XkjbcogIkkYn[
FeRUYY_4UYoBH4bJ_;SMoooo<d>U00<008001oooo`01P001P001P?ooo`02
P?ooo`0300>100Koool01840187oool01H7oool200J200Soool01h801h81
1h;oool128;oool128<30@V300Woool12X?oool12h?oool12hCoool138Co
ool00P4=Q004oooo0@j5oooo0@j50P8?Q@04oooo0Q25oooo0Q25108AQP<2
4XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<H
R0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;
0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DX
SP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A
1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP02
1cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8
?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4
V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK
0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN
00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aL
X@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=
HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>
JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?
LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[
0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61
[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`
00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb
4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<D
U[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh
5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj
0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G
[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSP
f8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P0
1@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h
0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000ZKYo7ooonGR[ajK:ZcanRYKZ38`mnCQKYKAY>ISkh2N6F^
00A29hF_YL[ooolc@jD400200`01P003oooo00:000:100Coool200B100?o
ool01H7oool00`06PPCoool00`48PP48P`48P`030@V300Woool12X?oool1
2h?oool12hCoool138Coool00P4=Q004oooo0@j5oooo0@j50P8?Q@03oooo
0Q25oooo00?oool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ7
00@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<M
RP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<5
9Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]
T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B
0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@3
1cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G
0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9
VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;
DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]I
W`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaP
XPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY003
3FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW
0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`me
Z@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@
Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65
[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8B
SK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@C
T[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK
]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ
^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m
5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o
00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h
00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0
^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2002000>KYo7oooooool00_ooo`0:ojf`ogIknLgD
oNg^ooooYY_4QGJ`_;SMoooo<d>U1@00P0<00H000oooo`02P002P@0300>1
00?oool0187oool00P05P@0400F2oooo00J200J20P07PP030@N2oooo0@R2
008128<3oooo0P4:P`07oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?oo
o`4>QOooooooo`823hD01_ooo`8@QOooo`8@Q@8AQ_ooo`824HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028
`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00B8`;P200001HS0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008002Z6/
l_W=e>8V??Be_n8V??A]OOcSjOoooog]k_n]/0;oool00c=3Y@00P000P004
00200`01P003oooo00:000:100?oool200B100Goool01H401H401H;oool0
0P06PP?oool20@R200<128?oool12H<00P49P`812X<01?ooo`4;P`4;Q?oo
o`8138@01oooo`4=Q04=Q?ooo`4>QOooo`4>Q@02oooo00<23hD248D248D0
1?ooo`040Q660Q:60Q:60Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:
0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DV
S@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@
0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i82
1SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7
>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL2
24>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ
0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]B
W@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO
0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R
362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=
IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL3
3VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o
[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_
1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=
/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B
]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g
59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i
0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdF
ZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl0
0aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P0
0`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2h
R<2h00>8`;P4000018S0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_ARK_om
oon]/?cSjOoooc=3Y@0700200`01P003oooo00:000:100<00h4300B10P05
P@0400F200J200J200J20P07PP050@N20@R20@R2oooo0@R300<12H<30@Z3
00<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0
108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP3
6HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@S
S00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP03
1BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<943
1S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC
0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2
242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V003
2DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?
W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;
EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ
35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S
0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH3
3VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?
LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1k
Z`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<A
PZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::
/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk80
0Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD4
59Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PE
W[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW
^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^
_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h
00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2h
R<2hB9280000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08000i^WlOK8c>8V?002ojf`00OO92koY9kf_<Go[K3^Nhcooolc@jD02000
P0<00H000oooo`02P002P@0300>10`04P@801H401005PP06PP06PP06PP80
1h801@47PP48PP48P_ooo`48P`030@V300Coool12X<12X<12h<20@^40`4<
Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<2
5HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT3
0ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=
0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl4
1Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B
1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD
00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8
@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT3
2DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YA
W@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`03
2eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aO
XPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eU
Y0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW
3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@04
3gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@
OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lA
Q:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba
00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<C
T[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ
]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TE
X;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_004
5Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n
5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SP
f002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf003R<2h0P0000B8`;P2
00000XS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0
^8S0^08008000i^WlOW=e?N9U`02oooo00Oo[K3Q5SCoMW_oY9kR9ScoRGlc
@jD02000P0<00H000oooo`02P002P@0300>10`04P@801H401005PP06PP06
PP06PP801h801047PP48PP48PP48P`Coool30@Z300<12h<12h@12h@00`4<
Q0813H@01?ooo`4>Q@4>Q@4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL2
58L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV9
00@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@T
S0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZ
S`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86
<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<0
0`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04
242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6
V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L
00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;
Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<
GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<3
3FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>
KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?
LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/
111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63
[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4B
R[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<3
4i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<D
VKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO
^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk
0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN_
_P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h
00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08001i^WlOoooo>P[_ARK_ooooN9UoW=e002oooo00?cX:kooolc@jD02000
P0<00H0200:000@00X400h400h400h4300B10P05P@0400F200J200J200J2
0P07PP030@N20@R20@R2008128<30@V30`4:P`030@^30@^40@^400<138@3
0@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF7
0P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<L
RP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@85
9Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/
S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHc
TPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU003
1cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G
0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8
V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:
DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]H
W`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<
H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=
IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^
Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010md
Z@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]
47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_
00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@04
4Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c
4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LD
VkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i
00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[
_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa
_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P0
3HS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3002000^KYo7oooooRGooooocX:ka
Tj7ooooooOocX:kono`c@jD02000P0<00H0200:000@00X400h400h400h43
00B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<30@V3
0`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR003
0aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A
1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC
0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH3
23nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9
AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>
V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aM
X@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ80
0PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD4
3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?
LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1j
Z`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61
[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@B
RK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb
4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D3
59Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh
5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<0?b>3H00<0
0038h=S8h=P03LSPf00300006;C06;C000o8h=P00`0001Rd`1Rd`002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1000P0>KYo401_oooo>P[_Be_oJl
aO_IfS=3Y@T0080300600P02P00400:100>100>100>10`04P@801H401005
PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;
Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@04
0aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`4
98d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5
:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A
00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7
>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9
AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN
2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ
0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X
3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@
OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh0
0a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@
/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf
0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<F
ZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P10000000018S0
^<SPf8S0^8S0^1H0080300600P02P00400:100>100>100>10`04P@801H40
1005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;
P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>7
0QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<I
R@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@4
98`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5
:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I42
1S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC
00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H0
10Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9
AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@
W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP03
2eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ43
35jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S
0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H2
3VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ003
3g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l
[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<A
Pjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa
4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc
0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H3
59Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<E
WkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX
^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G
[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P100000000
0hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8h=R8`;P0
ohS0^?n8`;QmR<2h0DR@R04000000003R<2hb>3Hb>3H0?o8h=Sob>3HOLSP
f058T8P10000003oR<2hohS0^868`;P100000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:30001hR000`400?l0
0000o`00003oooo`l?3ooo3`l8Gol?3`003ooo3`l?ool?3`QOo`l?000?oo
l?3`ooo`l?25oo3`l000ooo`l?3ooo3`l8Gol?3`003ooo3`l?ool?3`QOo`
l?000?ool?3`ooo`l?25oo3`l000ooo`l?3ooo3`l8Gol?3`003ooo3`l?oo
l?3`QOo`l?000?ool?3`ooo`l?25oo3`l000ooo`l?3ooo3`l8Gol?3`003o
oo3`l?ool?3`QOo`l?000?ool?3`ooo`l?25oo3`l000ooo`l?3ooo3`l8Go
l?3`003ooo3`l?ool?3`QOo`l?000?ool?3`ooo`l?25oo3`l000oooooooo
ooooohGooooo003oonk^k_ook^k^QOo^k^h00?ooi^KVoooVi^J5onKViP00
ooo^k^koonk^kXGok^k^003oooooooooooooQOooool00?ook^k^ooo^k^j5
onk^kP00oooVi^KoonKViXGoi^KV003oonk^k_ook^k^QOo^k^h00?oooooo
oooooon5ooooo`00ooo^k^koonk^kXGok^k^003oonKVi_ooi^KVQOoVi^H0
0?ook^k^ooo^k^j5onk^kP00ooooooooooooohGooooo003oonk^k_ook^k^
QOo^k^h00?ooi^KVoooVi^J5onKViP00ooo^k^koonk^kXGok^k^003ooooo
ooooooooQOooool00?ook^k^ooo^k^j5onk^kP00oooVi^KoonKViXGoi^KV
003oonk^k_ook^k^QOo^k^h00?oooooooooooon5ooooo`00ooo^k^koonk^
kXGok^k^003oonKVi_ooi^KVQOoVi^H00?ook^k^ooo^k^j5onk^kP00oooo
ooooooooohGooooo003oonk^k_ook^k^QOo^k^h00?ooi^KVoooVi^J5onKV
iP00ooo^k^koonk^kXGok^k^003oooooooooooooQOooool00?ook^k^ooo^
k^j5onk^kP00oooVi^KoonKViXGoi^KV003oonk^k_ook^k^QOo^k^h00?oo
oooooooooon5ooooo`00ooo^k^koonk^kXGok^k^003oonKVi_ooi^KVQOoV
i^H00?ook^k^ooo^k^j5onk^kP00ooooooooooooohGooooo003oonk^k_oo
k^k^QOo^k^h00?ooi^KVoooVi^J5onKViP00ooo^k^koonk^kXGok^k^003o
ooooooooooooQOooool00?ook^k^ooo^k^j5onk^kP00oooVi^KoonKViXGo
i^KV003oonk^k_ook^k^QOo^k^h00?oooooooooooon5ooooo`00ooo^k^ko
onk^kXGok^k^003oonKVi_ooi^KVQOoVi^H00?ook^k^ooo^k^j5onk^kP00
ooooooooooooohGooooo003oonk^k_ook^k^QOo^k^h00?ooi^KVoooVi^J5
onKViP00ooo^k^koonk^kXGok^k^003oooooooooooooQOooool00?ook^k^
ooo^k^j5onk^kP00oooVi^KoonKViXGoi^KV003oonk^k_ook^k^QOo^k^h0
0?oooooooooooon5ooooo`00ooo^k^koonk^kXGok^k^003oonKVi_ooi^KV
QOoVi^H00?ook^k^ooo^k^j5onk^kP00ooooooooooooohGooooo003oonk^
k_ook^k^QOo^k^h00?ooi^KVoooVi^J5onKViP00ooo^k^koonk^kXGok^k^
003oooooooooooooQOooool00?ook^k^ooo^k^j5onk^kP00oooVi^KoonKV
iXGoi^KV003oonk^k_ook^k^QOo^k^h00?oooooooooooon5ooooo`00ooo^
k^koonk^kXGok^k^003oonKVi_ooi^KVQOoVi^H00?ook^k^ooo^k^j5onk^
kP00ooooooooooooohGooooo003oonk^k_ook^k^QOo^k^h00?ooi^KVoooV
i^J5onKViP00ooo^k^koonk^kXGok^k^003oooooooooooooQOooool00?oo
k^k^ooo^k^j5onk^kP00oooVi^KoonKViXGoi^KV003oonk^k_ook^k^QOo^
k^h00?oooooooooooon5ooooo`00ooo^k^koonk^kXGok^k^003oonKVi_oo
i^KVQOoVi^H00?ook^k^ooo^k^j5onk^kP00ooooooooooooohGooooo003o
onk^k_ook^k^QOo^k^h00?ooi^KVoooVi^J5onKViP00ooo^k^koonk^kXGo
k^k^003oooooooooooooQOooool00?ook^k^ooo^k^j5onk^kP00oooVi^Ko
onKViXGoi^KV003oonk^k_ook^k^QOo^k^h00?oooooooooooon5ooooo`00
ooo^k^koonk^kXGok^k^003oonKVi_ooi^KVQOoVi^H00?ook^k^ooo^k^j5
onk^kP00ooooooooooooohGooooo003oonk^k_ook^k^QOo^k^h00?ooi^KV
oooVi^J5onKViP00ooo^k^koonk^kXGok^k^003oooooooooooooQOooool0
0?ook^k^ooo^k^j5onk^kP00oooVi^KoonKViXGoi^KV003oonk^k_ook^k^
QOo^k^h00?oooooooooooon5ooooo`00ooo^k^koonk^kXGok^k^003oonKV
i_ooi^KVQOoVi^H00?ook^k^ooo^k^j5onk^kP00ooooooooooooohGooooo
003oonk^k_ook^k^QOo^k^h00?ooi^KVoooVi^J5onKViP00ooo^k^koonk^
kXGok^k^003oooooooooooooQOooool00?ook^k^ooo^k^j5onk^kP00oooV
i^KoonKViXGoi^KV003oonk^k_ook^k^QOo^k^h00?oooooooooooon5oooo
o`00ooo^k^koonk^kXGok^k^003oonKVi_ooi^KVQOoVi^H00?ook^k^ooo^
k^j5onk^kP00ooooooooooooohGooooo003oonk^k_ook^k^QOo^k^h00?oo
i^KVoooVi^J5onKViP00ooo^k^koonk^kXGok^k^003oooooooooooooQOoo
ool00?ook^k^ooo^k^j5onk^kP00oooVi^KoonKViXGoi^KV003oonk^k_oo
k^k^QOo^k^h00?oooooooooooon5ooooo`00ooo^k^koonk^kXGok^k^003o
onKVi_ooi^KVQOoVi^H00?ook^k^ooo^k^j5onk^kP00ooooooooooooohGo
oooo003oonk^k_ook^k^QOo^k^h00?ooi^KVoooVi^J5onKViP00ooo^k^ko
onk^kXGok^k^003oooooooooooooQOooool00?ook^k^ooo^k^j5onk^kP00
oooVi^KoonKViXGoi^KV003oonk^k_ook^k^QOo^k^h00?oooooooooooon5
ooooo`00ooo^k^koonk^kXGok^k^003oonKVi_ooi^KVQOoVi^H00?ook^k^
ooo^k^j5onk^kP00ooooooooooooohGooooo003oonk^k_ook^k^QOo^k^h0
0?ooi^KVoooVi^J5onKViP00ooo^k^koonk^kXGok^k^003ooooooooooooo
QOooool00?ook^k^ooo^k^j5onk^kP00oooVi^KoonKViXGoi^KV003oonk^
k_ook^k^QOo^k^h00?oooooooooooon5ooooo`00ooo^k^koonk^kXGok^k^
003oonKVi_ooi^KVQOoVi^H00?ook^k^ooo^k^j5onk^kP00oooooooooooo
ohGooooo003oonk^k_ook^k^QOo^k^h00?ooi^KVoooVi^J5onKViP00ooo^
k^koonk^kXGok^k^003oooooooooooooQOooool00?ook^k^ooo^k^j5onk^
kP00oooVi^KoonKViXGoi^KV003oonk^k_ook^k^QOo^k^h00?oooooooooo
oon5ooooo`00ooo^k^koonk^kXGok^k^003oonKVi_ooi^KVQOoVi^H00?oo
k^k^ooo^k^j5onk^kP00ooooooooooooohGooooo003oonk^k_ook^k^QOo^
k^h00?ooi^KVoooVi^J5onKViP00ooo^k^koonk^kXGok^k^003ooooooooo
ooooQOooool00?ook^k^ooo^k^j5onk^kP00oooVi^KoonKViXGoi^KV003o
onk^k_ook^k^QOo^k^h00?oooooooooooon5ooooo`00ooo^k^koonk^kXGo
k^k^003oonKVi_ooi^KVQOoVi^H00?ook^k^ooo^k^j5onk^kP00oooooooo
ooooohGooooo003oonk^k_ook^k^QOo^k^h00?ooi^KVoooVi^J5onKViP00
ooo^k^koonk^kXGok^k^003oooooooooooooQOooool00?ook^k^ooo^k^j5
onk^kP00oooVi^KoonKViXGoi^KV003oonk^k_ook^k^QOo^k^h00?oooooo
oooooon5ooooo`00ooo^k^koonk^kXGok^k^003oonKVi_ooi^KVQOoVi^H0
0?ook^k^ooo^k^j5onk^kP00ooooooooooooohGooooo003oonk^k_ook^k^
QOo^k^h00?ooi^KVoooVi^J5onKViP00ooo^k^koonk^kXGok^k^003ooooo
ooooooooQOooool00?ook^k^ooo^k^j5onk^kP00oooVi^KoonKViXGoi^KV
003oonk^k_ook^k^QOo^k^h00?oooooooooooon5ooooo`00ooo^k^koonk^
kXGok^k^003oonKVi_ooi^KVQOoVi^H00?ook^k^ooo^k^j5onk^kP00oooo
ooooooooohGooooo003oonk^k_ook^k^QOo^k^h00?ooi^KVoooVi^J5onKV
iP00ooo^k^koonk^kXGok^k^003oooooooooooooQOooool00?ook^k^ooo^
k^j5onk^kP00oooVi^KoonKViXGoi^KV003oonk^k_ook^k^QOo^k^h00?oo
oooooooooon5ooooo`00ooo^k^koonk^kXGok^k^003oonKVi_ooi^KVQOoV
i^H00?ook^k^ooo^k^j5onk^kP00ooooooooooooohGooooo003oonk^k_oo
k^k^QOo^k^h00?ooi^KVoooVi^J5onKViP00ooo^k^koonk^kXGok^k^003o
ooooooooooooQOooool00?ook^k^ooo^k^j5onk^kP00oooVi^KoonKViXGo
i^KV003oonk^k_ook^k^QOo^k^h00?oooooooooooon5ooooo`00oomn[MWo
ogj]fHGoOZgI003oogj]fOooOZgIQOmn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7o
oooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooV
i^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7o
i^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooo
oooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7o
oooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooV
i^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7o
i^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooo
oooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7o
oooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooV
i^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7o
i^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooo
oooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7o
oooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooV
i^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7o
i^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooo
oooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7o
oooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooV
i^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7o
i^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooo
oooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7o
oooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooV
i^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7o
i^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooo
oooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7o
oooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooV
i^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7o
i^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooo
oooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7o
oooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooV
i^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7o
i^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooo
oooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7o
oooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooV
i^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT0
00;oOZgIoooooooooooooh7ooooo0_mn[MT000;oOZgIooo^k^koonk^kX7o
k^k^0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgIooo^
k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooooooooooooh7ooooo0_mn[MT0
00;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgIoooVi^KoonKViX7o
i^KV0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^0_mn[MT000;oOZgI1ooo
ool00ooemOGojNWYooooo`0nooooo`03ooGemOoYjNWooooo03_ooooo00?o
mOGeonWYjOooool0=Oooool00ooinOWog]kNooclo004ooooo`03ooGemOoY
jNWooooo03_ooooo00?omOGeonWYjOooool0=?ooool00oo`l?3oh>3Poooo
o`04ooooo`03ooGemOoYjNWooooo03Gooooo00?om_Kfong]kOooool00ooo
ool00ooemOGojNWYooooo`0kooooo`03ooGemOoYjNWooooo03Kooooo00?o
no_kon[Zj_ooool00oooool00ooemOGojNWYooooo`0dooooo`03ooWinOoM
gMgon_[j00Cooooo00?omOGeonWYjOooool0>?ooool00ooemOGojNWYoooo
o`03ooooo`04ooGemOoYjNWoooooooooo`;oOZgI0002ogj]f@Kok^k^00Co
Xj>Soa`L7?lc<c?oGEeM=oo^k^h02_nIVIWo?Shno`D51Om1@D7o/;2`onk^
k_nSXj?o71`Loc<c<omMGEdconk^kP03olO7aol0003o8b<S00;o92@T00Ko
dm?Conk^k_nSXj?o71`Loc<c<omMGEdeonk^kP04obh^;_mKFe_o=SHfoh20
P0;ok^k^00CoXj>Soa`L7?lc<c?oGEeM=_o^k^h02?nf][KoCdm?onk^k_o^
k^koXj>Soa`L7?lc<c?oGEeM=?o^k^h01?mRHV;oG5aLoc`l??nJVYX2onk^
kP04oj>SXolL71co<c<coeeMGCCok^k^00[oW9bLoahN7_mCDe?oGEeMon_[
joo^k^koXj>Soa`L7?lc<c?oGEeM=?o^k^h00onIVIWo<S8bonk^kP03onk^
kP04oj>SXolL71co<c<coeeMGCGok^k^00[oQHF5ocPh>?mGEeOoA4A4omSH
f?o^k^koXj>Soa`L7?lc<c?oGEeM=?o^k^h01?mADE7oFe]Koa`L7?nDU9@2
onk^kP04oj>SXolL71co<c<coeeMGC7ok^k^00[oVIVIochn?_l51@Go@D51
ok2`/?o^k^koXj>Soa`L7?lc<c?oGEeM0_o^k^h01OnSXj?o71`Loc<c<omM
GEgok^k^00;oOZgI0002ogj]f@Koi^KV00Go:RXZom?CdooTi>Co?3`lol71
`@0gonKViP03om_KfolB4Q;oi^KV00;oi^KV00Go:RXZom?CdooTi>Co?3`l
ol71`@0bonKViP03onGUiOlg=cOoWYjN00Coi^KV00Go:RXZom?CdooTi>Co
?3`lol71`@0fonKViP09om[Jf_lE5AGof=SHonKVi_lZ:R[odm?ConCTi?ll
?3co`L7103Goi^KV00Wo[jn_oda<C?oVi^Koi^KVobXZ:_oCdm?oi>CToc`l
??o1`L40=OoVi^H02Oo;bl_o71`Lon?ShooVi^Ko:RXZom?CdooTi>Co?3`l
ol71`@0conKViP0;obLW9ooDe=Coi^KVof9RH_nVYZKoi^KVobXZ:_oCdm?o
i>CToc`l??o1`L40<ooVi^H00ooCdm?o2@T9olK6aP03onKViP05obXZ:_oC
dm?oi>CToc`l??o1`L40<ooVi^H03?oLg=co5aLGom_KfooVi^KoPh>3ofi^
K_oVi^Ko:RXZom?CdooTi>Co?3`lol71`CGoi^KV00WofMWIob4Q8Oo5aLGo
i^KVobXZ:_oCdm?oi>CToc`l??o1`L40<OoVi^H00ooKfm_o4Q8BonKViP02
onKViP0;obXZ:_oCdm?oi>CToc`l??o1`L7oi^KVobXZ:_oCdm?oi>CToc`l
??o1`L400_mn[MT000;oOZgI1Oo^k^h01_oIfMWo9RHVonk^k_o^k^koLg=c
ohb<S3Ook^k^00Koh^;Roa<C4oo^k^kok^k^omWIfOlV9RH2onk^kP03og=c
Lon<S8cok^k^03;ok^k^00?ofMWIoc@d=?no_kl00_o^k^h01_oIfMWo9RHV
onk^k_o^k^koLg=cohb<S3Kok^k^00Gofm_Ko`h>3_oMgMgofMWIobHV9P02
onk^kP03og=cLon<S8cok^k^037ok^k^00SoPh>3oadM7Olb<S;o:BTYoa0@
4?mgMgOofMWIobHV9P;ok^k^00?oLg=cohb<S?o^k^h0=?o^k^h01OoGemOo
6ATIonOWiooIfMWo9RHV00;ok^k^00?oLg=cohb<S?o^k^h0<Oo^k^h02?oH
f=So92@Tonk^k_o^k^koOgmoogAdM?oIfMWo9RHV0_o^k^h00omcLg?oS8b<
onk^kP0conk^kP06og1`L?mgMgOok^k^onk^k_oIfMWo9RHV0_o^k^h00omc
Lg?oS8b<onk^kP0bonk^kP08ong]kOlP823oiNGUonKVi_m8B4SoOGemomWI
fOlV9RH2onk^kP03og=cLon<S8cok^k^03;ok^k^00OokNg]ojb/[?nRXZ;o
FUYJogQhN?oIfMWo9RHV00;ok^k^00?oLg=cohb<S?o^k^h0<?o^k^h01_oR
h^;o4a<Conk^k_o^k^kofMWIobHV9P;ok^k^00CoLg=cohb<S?oIfMWo9RHV
0_o^k^h00omcLg?oS8b<ogj]f@01ogj]f@000_mn[MT5ooooo`06ok>c/om<
C4cooooooooooonPX:3oGemO=oooool01_oclo?o5ADEoooooooooooo/k>c
oda<C0;ooooo00?oX:2PoemOGoooool0<oooool01_oXj>So>3Pholg=cOoo
oooo/k>coda<C0;ooooo00?oX:2PoemOGoooool0<oooool01ooHf=SoJ6QX
od10@?nTY:Cooooook>c/om<C4`00_ooool00onPX:3oGemOooooo`0aoooo
o`08ong]kOlk>c_ok^k^omCDe?mEEEGooooook>c/om<C4`2ooooo`03oj2P
X?mOGeoooooo03;ooooo00Ood];BoiNGUom1@D7oQXJ6oooooonc/k?oC4a<
00;ooooo00?oX:2PoemOGoooool0<Oooool02?nf][Ko20P8oijNW_o=cLgo
;Bd]olk>c_nc/k?oC4a<0_ooool00onPX:3oGemOooooo`0cooooo`06oo;b
l_lY:BWoinOWoooooonc/k?oC4a<0_ooool00onPX:3oGemOooooo`0coooo
o`07ol71`Om;Bd_o:2PXof9RH_ofm_Ko/k>coda<C002ooooo`03oj2PX?mO
Geoooooo03;ooooo00OoDE5AogQhN?nNWYko;Bd]of1PH?nc/k?oC4a<00;o
oooo00?oX:2PoemOGoooool0<?ooool01_oclo?o5ADEoooooooooooo/k>c
oda<C0;ooooo00CoX:2PoemOGonc/k?oC4a<0_ooool00onPX:3oGemOogj]
f@01ogj]f@000_mn[MT5onk^kP04olc<c?l^;Rkok^k^onk^kP;oOWin=oo^
k^h01_oRh^;o4a<Conk^k_o^k^koc<c<obh^;P;ok^k^0_mnOWheonk^kP05
olS8b?lJ6Q[okNg]olc<c?l^;Rh00_o^k^h2oginOSCok^k^00OohN7Qoj^[
ZomLG5coV9RHonk^k_o<c<co;Rh^00;ok^k^0_mnOWhconk^kP07okFe]Om>
CTkoa<C4odm?Coo^k^koc<c<obh^;P02onk^kP;oOWin<oo^k^h00om@D53o
O7alomKFeP02onk^kP04olc<c?l^;Rkok^k^onk^kP;oOWin<_o^k^h02?nl
_;co71`LoifMWOmZJV[o^k^konk^k_o<c<co;Rh^0_o^k^h2oginOSGok^k^
00GoWinOoeIFE_o^k^koc<c<obh^;P02onk^kP;oOWin=?o^k^h01onXZ:So
7alOohF5QOmMGEgoj^[Zolc<c?l^;Rh00_o^k^h2oginOS;ok^k^00Coe=CD
ob0P8?o^k^kok^k^0_mdM7@01?o<c<co;Rh^onk^k_o^k^h2oginOS7ok^k^
00Koh^;Roa<C4oo^k^kok^k^olc<c?l^;Rh2onk^kP;oOWin00Coc<c<obh^
;_o^k^kok^k^0_mnOWh2ogj]f@000_mn[MT6onKViP05ob8R8_oTi>Coi^KV
oe9BD_nd];@0=ooVi^H00ooKfm_o4Q8BonKViP02onKViP05ob8R8_oTi>Co
i^KVoe9BD_nd];@0=OoVi^H02OoTi>Co410@omCDe?oVi^Ko8R8RonCTi?oV
i^KoDU9BokBd]00fonKViP09om7AdOlK6a_oi^KVonKVi_lR8R;oi>CTonKV
i_mBDU;o];Bd03Coi^KV00?oLg=coeaLG?m<C4`00_oVi^H01OlR8R;oi>CT
onKVi_mBDU;o];Bd03?oi^KV00?oCDe=okbl_?oVi^H00ooVi^H01OlR8R;o
i>CTonKVi_mBDU;o];Bd03;oi^KV00?ogMgMoa8B4_oCdm<01?oVi^H01OlR
8R;oi>CTonKVi_mBDU;o];Bd03Koi^KV00So@d=3ojn_[ooVi^Ko8R8RonCT
i?oVi^KoDU9BokBd]3Coi^KV00_oBTY:ojj^[_oVi^KoHf=SojFUYOoVi^Ko
8R8RonCTi?oVi^KoDU9BokBd]00bonKViP0<omcLg?lY:BWoi^KVonKVi_mA
DE7o[Jf]onKVi_lR8R;oi>CTonKVi_mBDU;o];Bd<OoVi^H00ooKfm_o4Q8B
onKViP02onKViP0;ob8R8_oTi>Coi^KVoe9BD_nd];Coi^KVob8R8_oTi>Co
i^KVoe9BD_nd];@00_mn[MT000;oOZgI1_o^k^h01OmlO7co>3PhofQXJ?ld
=3Coj^[Z03Kok^k^00?oUYJFodM7AolC4a<00oo^k^h01OmlO7co>3PhofQX
J?ld=3Coj^[Z03?ok^k^00Co@T92ohV9ROmMGEgoC4a<0_o^k^h01OmlO7co
>3PhofQXJ?ld=3Coj^[Z03Cok^k^00CoKVi^oi2@T?mKFe_oEUIF0_o^k^h0
1OmlO7co>3PhofQXJ?ld=3Coj^[Z03Cok^k^00?ojn_[ocXj>_m>CTh00_o^
k^h01OmlO7co>3PhofQXJ?ld=3Coj^[Z03?ok^k^00CoD51@odY:B_mLG5co
G5aL0_o^k^h01OmlO7co>3PhofQXJ?ld=3Coj^[Z03?ok^k^00_oUYJFobDU
9On;Rh_oL71`olS8b?o^k^koO7alocPh>?mXJ6So=3@don[ZjP0conk^kP0;
oeYJF_m<C4coC4a<ocHf=_m9BDWok^k^ogalO?lh>3SoJ6QXoc@d=?oZj^X0
=?o^k^h02onOWiooCTi>ohj>S_lU9BGod];Bonk^k_mlO7co>3PhofQXJ?ld
=3Coj^[Z03?ok^k^00_oKfm_ofATI?m`L73o;bl_onSXj?o^k^koO7alocPh
>?mXJ6So=3@don[ZjP0`onk^kP03oiJFU_m7AdOo4a<C00?ok^k^00_oO7al
ocPh>?mXJ6So=3@don[Zj_o^k^koO7alocPh>?mXJ6So=3@don[ZjP02ogj]
f@000_mn[MT7ooooo`03olC4a?n_[joom?Cd03Sooooo00?okno_ok^k^ooo
ool00oooool00oo4a<Co[jn_ooCdm00dooooo`03onc/k?na/K7obLW900Co
oooo00?oa<C4ojn_[oodm?@0=Oooool01?oCdm?oYZJVolS8b?olo?`3oooo
o`03olC4a?n_[joom?Cd03Kooooo00?okNg]omWIfOooool00_ooool00oo4
a<Co[jn_ooCdm00dooooo`04omWIfOo5aLGoaLG5olK6aP?ooooo00?oa<C4
ojn_[oodm?@0=Oooool01?oIfMWoXj>Sokbl_?ofm_H2ooooo`03olC4a?n_
[joom?Cd03Cooooo00Gob/[:olG5aOo5aLGoaLG5omKFeP02ooooo`03olC4
a?n_[joom?Cd03Kooooo00?ohN7Qoj^[ZooXj>P00oooool00oo4a<Co[jn_
ooCdm00eooooo`03omcLg?n^[Zkol_;b00?ooooo00?oa<C4ojn_[oodm?@0
<_ooool00oo_knoo^k^kooooo`03ooooo`03olC4a?n_[joom?Cd00?ooooo
00Coa<C4ojn_[oodm?Cooooo0_mn[MT000;oOZgIooo^k^koonk^kX7ok^k^
0_mn[MT000;oOZgIoooVi^KoonKViX7oi^KV0_mn[MT000;oOZgI1oo^k^ko
oo3`l?ool?3`LOo`l?09onk^kP;oOZgI0002ogj]f@Ooooooooo`l?3ooo3`
l77ol?3`2Oooool2ogj]f@000_mn[MT7onk^k_ool?3`ooo`l?1aoo3`l0Wo
k^k^0_mn[MT000;oOZgI1ooVi^H00omgMgOol?3`oo3`l00koo3`l003ogMg
Moo`l?3ol?3`03_ol?3`00?oMgMgoo3`l?o`l?00??o`l?000omgMgOol?3`
oo3`l00koo3`l003ogMgMoo`l?3ol?3`03_ol?3`00?oMgMgoo3`l?o`l?00
>oo`l?000omgMgOol?3`oo3`l00koo3`l003ogMgMoo`l?3ol?3`03col?3`
00?oMgMgoo3`l?o`l?00>oo`l?000omgMgOol?3`oo3`l00koo3`l003ogMg
MooVi^Koi^KV00Ooi^KV0_mn[MT000;oOZgI1oo^k^h00omgMgOol?3`oo3`
l00koo3`l003ogMgMoo`l?3ol?3`03_ol?3`00?oMgMgoo3`l?o`l?00??o`
l?000omgMgOol?3`oo3`l00koo3`l003ogMgMoo`l?3ol?3`03_ol?3`00?o
MgMgoo3`l?o`l?00>oo`l?000omgMgOol?3`oo3`l00koo3`l003ogMgMoo`
l?3ol?3`03col?3`00?oMgMgoo3`l?o`l?00>oo`l?000omgMgOol?3`oo3`
l00koo3`l003ogMgMoo^k^kok^k^00Ook^k^0_mn[MT000;oOZgI1oooool0
0omgMgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMg
oo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003ogMgMoo`l?3o
l?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omgMgOol?3`oo3`l009
oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMgoo3`l?o`l?002Oo`l?00
0omgMgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMg
oo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003ogMgMoo`l?3o
l?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omgMgOol?3`oo3`l009
oo3`l003ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?00
0omgMgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMg
oo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003ogMgMoo`l?3o
l?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omgMgOol?3`oo3`l009
oo3`l003ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?00
0omgMgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMg
oo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003ogMgMoo`l?3o
l?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omgMgOol?3`oo3`l009
oo3`l003ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?00
0omgMgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMg
oo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003ogMgMoo`l?3o
l?3`00Wol?3`00?oMgMgoo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:
oo3`l003ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?00
0omgMgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMg
oo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003ogMgMoo`l?3o
l?3`00Wol?3`00?oMgMgooooooooool01oooool2ogj]f@000_mn[MT7onk^
kP03ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omg
MgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMgoo3`
l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003ogMgMoo`l?3ol?3`
00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omgMgOol?3`oo3`l009oo3`
l003ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omg
MgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMgoo3`
l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003ogMgMoo`l?3ol?3`
00Wol?3`00?oMgMgoo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`
l003ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omg
MgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMgoo3`
l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003ogMgMoo`l?3ol?3`
00Wol?3`00?oMgMgoo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`
l003ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omg
MgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMgoo3`
l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003ogMgMoo`l?3ol?3`
00Wol?3`00?oMgMgoo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`
l003ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omg
MgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMgoo3`
l?o`l?002Oo`l?000omgMgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`
00[ol?3`00?oMgMgoo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`
l003ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omg
MgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMgoo3`
l?o`l?002Oo`l?000omgMgOok^k^onk^kP07onk^kP;oOZgI0002ogj]f@Oo
i^KV00?oMgMgoo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003
ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omgMgOo
l?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMgoo3`l?o`
l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003ogMgMoo`l?3ol?3`00Wo
l?3`00?oMgMgoo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003
ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omgMgOo
l?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMgoo3`l?o`
l?002Oo`l?000omgMgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[o
l?3`00?oMgMgoo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003
ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omgMgOo
l?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMgoo3`l?o`
l?002Oo`l?000omgMgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[o
l?3`00?oMgMgoo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003
ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omgMgOo
l?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[ol?3`00?oMgMgoo3`l?o`
l?002Oo`l?000omgMgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[o
l?3`00?oMgMgoo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003
ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omgMgOo
l?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`
l?002_o`l?000omgMgOol?3`oo3`l009oo3`l003ogMgMoo`l?3ol?3`00[o
l?3`00?oMgMgoo3`l?o`l?002Oo`l?000omgMgOol?3`oo3`l00:oo3`l003
ogMgMoo`l?3ol?3`00Wol?3`00?oMgMgoo3`l?o`l?002_o`l?000omgMgOo
l?3`oo3`l009oo3`l003ogMgMooVi^Koi^KV00Ooi^KV0_mn[MT000;oOZgI
ooo^k^k;onk^kP07on_[jooPh>3obl_;olG5aOoAdM7oi>CTonc/k02^onk^
kP;oOZgI0002ogj]fOoooooob_ooool02Ookno_ol?3`olo?conLW9coTiFE
ojf][OoIfMWom?Cdoogmo@2]ooooo`;oOZgI0002ogj]fOook^k^bOo^k^h0
2ooZj^[oh>3Pol30`?n9RHWoSiBDon_emOmjO7coVi^KolW9bOoTi>Cok>c/
0:cok^k^0_mn[MT000;oOZgIoooVi^K8onKViP0=on?ShooHf=So^[ZjohB4
Q?n3SHgoiogmon_no_oIjn_oLgMgoiJFU_o2`/;og=cLonCTi02[onKViP;o
OZgI0002ogj]fOook^k^aoo^k^h03ooZj^[oh>3Pol71`On9RHWoPXf=omok
nooRo_kog__konOoooo@jNWoLWQhoibLW?o;bl_oi>CTong]k@2Zonk^kP;o
OZgI0002ogj]fOooooooa_ooool04Oolo?col?3`olo?conDU9CoPI6@omGj
nOoIooooe_kmomSooooEoOcofoooolOZj_mdO7_oZJVYom[Jf_oemOGooOgm
0:Wooooo0_mn[MT000;oOZgIooo^k^k5onk^kP0Con_[jooPh>3o`l?3ohZ:
R_meQH[obOCjol_go_o9m?gob_Koolgiooo:mOooa_7kolcgo_njh>[oJW5c
oi^KVoo;bl_oi>CTong]k@2Xonk^kP;oOZgI0002ogj]fOooi^KVaOoVi^H0
4ooOgmooaLG5ohZ:R_m^OHSo^nGjol7Zo_nnj?ko`>WookoYoonmi_oo_^So
ol3Yoonli?ko`ncnojcDj_mTJg7oW9bLolk>c_oQhN40Z?oVi^H2ogj]f@00
0_mn[MWoonk^k/Gok^k^00cohN7Qok>c]?mkSZ?oZMSoojkGnonaf?oo/][o
ok;Kooncfooo/]Wook?Jooncg?l2ok3IoP05ojkHoOnZdocoOhRCol?3`ooQ
hN40Z?o^k^h2ogj]f@000_mn[MT01?oooooog]kNol_;boo3`l?ool[:b/7o
b/[:01?o_[jnohB6ROmkX/coV/Gfoio8m_nVc__oYLghojW=nOnYdOcoYlok
ojS?n_nVc?SoY/ghojG<monQb_GoX/gjoh2K^onFUYKo`<300:;ob/[:00?o
aLG5om3@d?oRh^800oooool2ogj]f@000_mn[MT01?o:b/[oXZ:Rojn_[onl
_;cool?3`l7o`l?301?o]kNgogMkP?miZ^;oSKKVoiO0k?nH`NcoVl;]oi_1
kOnK`ngoV<3/oi_4konL`ngoVl?]oiS0jonE_N[oU;g[oh>Xd_n9RX[o^KVi
0:;o`l?300Co_;blokJf]_nZZZ[oclo:0_o^k^h2ogj]f@000_mn[MT01?nM
WIgoV9RHoj>SXona/K7ookJf]/7o][Jf01?oZJVYof]`M_m^X]goOJWJohNa
h?n:]N7oRkGQoh^fh_n:/n3oR;CQohbfiOn=]^CoSKGRoh^eh_n6/>7oQk7R
og^Sd_mlOGko[:b/0:;o][Jf00Co/K6aojRXZ?nMWIgoXj>M0_oVi^H2ogj]
f@000_mn[MT01?miNGWoQHF5oiVIVOnOWiooojRXZ<7oZ:RX01?oW9bLof1W
KOmRW]koIiC9og2OeOmgY=KoMJ7DogFTeomhY=KoMZCGogNVeomeY=KoMZ?G
ogJTeOmeXmCoLJ3DofnQeombLgCoWYjN0:;oZ:RX00CoXZ:RoiBDU?n;Rh_o
Ng]i0_o^k^h2ogj]f@000_mn[MT01?n>SXkoL71`oh61POn6QXKooi>CTl7o
Ti>C01?oRHV9oe9IH?m8QlkoDHBnoeV=b?mQTl_oGY;:of2Dc?mRTl_oHiC;
of6Cc?mQUL_oH9C:of2CbOmMT<WoFho9oe>;b?mTI6KoRXZ:0:;oTi>C00Co
Q8B4ogmoOom`L73oT92>0_ooool2ogj]f@000_mn[MT01?nc/k?oGEeMofEU
IOmZJV[oog=cLl7oLg=c01?oJf][oci5C_lYKL3oCh:loef?a_mQT/WoH9?9
of:CaomTULSoIIK8ofJFbomSTl[oHiC;of6Bb?mQT/WoG8k7oc=^^Om=CToo
K6a/0:;oLg=c00CoJ6QXof5QHOmKFe_o/K6c0_o^k^h2ogj]f@000_mn[MT0
1?oVi^KoZ:RXogAdM?m@D53ooe=CDl7oDe=C01?oCTi>ob`_>_lGEK7oJ9K5
oh2Ydon0Ym;oP:ODoh2Xdon1Z]?oPZWCoh6Xe?n3Z]?oPJWDognWe?moZ=Co
Ji_<oa9DYolh>3[oCTi>0:;oDe=C00?oDE5Aog9bL_nXZ:P00ooVi^H2ogj]
f@000_mn[MWoonk^k/Gok^k^01?oh^;RohR8T_lM>IooR9g:oijdfOnK/]Wo
W;KJoi^dfOnK]=[oW;CJoiVafOnK]=WoVkCJoiRbf?nJ/]SoR:?Ao`heU?n[
Zjcohn?S0:Sok^k^0_mn[MT000;oOZgIooooooo5ooooo`07oo_knonZZZoo
5AMooh:;`_n_^M[oZ[7Hoj^be`02ojVbf00:ojfgfon[]M[oZkGJoj^cfOnX
/=Ko[KKJogZ3`OlJ8GcocLg=ooWinJSooooo0_mn[MT000;oOZgIooo^k^k5
onk^kP0Conc/k?o5aLOo@T:4od]:X_n;SLKoTiC<oi:Bc?nCV<koTYC<oi>G
c?nBTlgoTIC<oi:Ec?nEULcoPX;0oclnVOmIFHcof=SHon_[j`2Xonk^kP;o
OZgI0002ogj]fOooi^KVa_oVi^H04OoOgmoo];Bmof5QR?ld=6go;2a[obd]
K_l/;6co;2a[ob`/Iol/;6go;2a[obd]K?l[:fSo>CU[ofm_S_o1`LKohN7Q
0:Woi^KV0_mn[MT00?ooOZgIoomn[MV5ogj]f@00oomn[MWoogj]fHGoOZgI
003oogmoOeSoOgmo1omnOWkoogmoObKoOgmo00001?o[jn_oi^KVon;Rh_oN
g]h4omgMg@?og]kN0?oogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMd0
01?og]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN00;ogMgM0_oLg=`0
=?oKfm_ogMgMomcLgOoNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]h2omgMg@07om_KfooJf][o
emOGomSHf?oGemSof][Jom_Kf`02omgMg@3oomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kN000GomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMd01?oNg]h00ooMgMgog]kNomkNgP03omgMg@7o
hN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>001ooIfMT01?oHf=SoeMGE
om?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOG
eooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oG
emOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SHg?oIfMT2omSHf006
omKFe_oCdm?odm?ComCDe?oGemOof=SH0_oIfMT00ooHf=SofMWIomWIf@02
omSHf0WofMWI00?of=SHomWIfOoIfMT00_oHf=P00ooIfMWof=SHomSHf002
omSHf1OofMWI00Cof=SHomKFe_oBd];oclo?0_o=cLd01?o?cloodm?ComOG
eooHf=Q/omWIf@03omSHf?oIfMWofMWI0:SofMWI00?of=SHomWIfOoIfMT0
1_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWoi>CTon3Ph?oQhN7o
h>3Pon;RhP02on7Qh@0=omkNg_oLg=codm?ColO7aonk^k_o/K6aojj^[_nb
/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7
aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=
omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?o
fm_KomoOg`3Kon7Qh@09on3Ph?oOgmoofm_KomKFe_oDe=Coe]KFom[Jf_oN
g]koh>3P00KogmoO0ooPh>000ooOgmooh>3Pon3Ph002on3Ph0SogmoO0_oN
g]h2omoOg`?oh>3P0_oOgml2on3Ph0;ogmoO3OoPh>001OoOgmoogMgMomWI
fOoEeMGodm?C00;od];B00?oe]KFomcLg?oPh>00oooQhN4Jon7Qh@03on;R
h_oQhN7oh^;R00CohN7Q0OoTi>@1onWYj@7ok>c/00000oo`l?3okno_oo7a
l@03oo3`l0;okno_0?ook^k^onWYjOoJf][o`L71ojBTY?n<S8coNg]kogMg
MomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7aono_kooalO7okno_
oo7akoo_knoolO7aong]kOoZj^[of][Jol;2`_nTY:CoS8b;og]kNomgMgOo
Ng]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<S?mkNg_oMgMfog]k
Non<S8coY:BTol;2`_oJf][oj^[Zong]kOoalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knl0
01oolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo3`l?o]kNgok>c/onGUiOoRh^;ogmoOonGUhooYjNWokNg]00;oj>SX00Ko
i^KVonWYjOoWinOojn_Yonc/k?o^k^h3on[ZjP03ono_koo^k^kok^k/00;o
j>SX00Ooi^KVonWYjOoWinOoj^[ZonWYjOoYjNOoiNGU00;oinOW00[ojn_[
onc/k?o_knoojn_[on[Zj?oYjNWok^k^onc/k?o[jn_oj>SX0_o]kNd02_o^
k^coj^[Zonc/k?o/k>cok^k^on[Zj_o/k>cokNg]onk^k?oZj^X2onc/k008
onk^k_n][JgoMgMgoeUIFOm_Kfko][Jfon7QhOoWinL2ono_k`3ooo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_koo`l?3okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7a000Oono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3`ono_k`04oo3`l00000?ol_;bonk^k_oWinL01?oUiND0
4?oTi>CogmoOom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5A
ofIVI_n:RXWo/K6aom7AdOoNg]h2onCTi003onGUiOoTi>CoiNGT00;oi>CT
00oog]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIV
I_n:RX[o/K6aom7Ad?oNg]h00_oTi>@0n?oUiNGoi>CTonGUiOoTi>Coi>CS
omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKo
RXZ:ok6a/OoAdM7og]kNonCThooTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUon?Shoo6a/Ko
:2PXodE5AOn?Shood];Aom_KfooLg=coe]KF0ooEeMD02ooDe=Cof][IomoO
gooOgmoofMWIomGEeOoHf=SogmoOon7QhOoMgMcoe]KF00?oeMGE00Goe=CD
omWIfOoJf][of=SGomGEe@02omKFeP0?omWIfOoMgMgoh>3Pom_KfooFe]Go
e]KFomgMgOoLg=cof=SHomGEeOoLg=coh>3PomoOg_oJf][ofm_K00;ogMgM
0?oofMWIomcLg?oOgmooh>3Oom_KfooJf][ogMgMon3Ph?mcLg?oJ6QXohf=
SOmDE5Co20P8oj>SXooKfm_ohn?SonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>@002OoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiND00_oTi>@4onGUi@06onCTi?oUiNGoiNGUonGUiOoXj>So
kNg]0Oobl_800003ooCdm?o]kNgoinOW00;oh>3P01?ohN7QomkNg_oNg]ko
d];BokBd]?n7QhOoG5aLofdk=OnNCT;ocFiNonV3Koo=KeooWTi3ofdk=_mL
G5coQhN7okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaL
G?m]H2coWYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aLohN7Qond];Cod];B
omkNgP05on3Ph00AomkNg_oBd];o];BdohN7QomLG5coAfL^ofRN<onAcDOo
Z^UEoi7=AomZWSCoBFX_oeaLG?n7QhOo];Bdom;Bd_oNg]h0f_oPh>001_oO
gmooclo?oiVIVOnBTY;o6ATIohb<S0;oeMGE01ooclo?ol;2`_o>c/koc/k>
olG5aOo:b/[of][JomSHf?o@d=3obl_;olo?cooHf=Sof][JomGEeOo?cloo
`L71om3@d?o>c/koa<C4ol_;booHf=SoemOGokjn__nk^k_odM7Aom3@d?oE
eMGof=SHom?Cdoo<c<coc/k>00;oeMGE00Goc/k>olc<c?oCdm?of][JomSH
f002om;BdP04omSHf?oGemOodM7Aom?Cd`;ofMWI00Kodm?Com7AdOoGemOo
f=SHom7AdOo@d=02om7Ad@04odI6A_m1@D7oemOGomkNgV[oh>3P00?ogmoO
on3Ph?oPh>001OoPh>000ooOgmooh>3Pon3Ph00bon3Ph003omoOgooPh>3o
h>3P06goh>3P00?ogmoOon3Ph?oOgml00_oOgml3on3Ph003on7QhOoWinOo
k>c/007olo?c00000oofm_Kol_;bon_[j`03onSXj00ConOWiooRh^;ocLg=
oinOWomZGUkoScH^oneaHOoiWI3ooK6Uoofl[oom]:OonInConedHonB=boo
JemOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWom^
IUooTg8RongAA?oilgCooOf=oogmUOomoHkonOQfongGAonCLb;oKVMOoinO
Woo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWomPJ5ooBg`S
oi;QBonmnG_od?fBomSmVooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=cLgo
h^;RonOWi`3KonSXj004onKVi_oQhN7oGEeMode=C@;ogMgM01ooD51@o`L7
1olE5AGoQ8B4oaHF5_m3@d?oh^;RomgMgOnLW9co0000ohn?SooMgMgohN7Q
om_Kfom0@43o20P8oaTI6On8R8So2`/;oeQHF?ng]kOo30`<o`L71olS8b?o
9bLWogemOOoJf][ogMgMomCDe?l;2`_oFEUI00;ofMWI00?oGEeMo`/;2ooC
dm<00_oOgml01_mJFU[oCTi>omkNg_oNg]ko8b<SohB4Q0;ohN7Q00coNWYj
obh^;_oMgMgogMgMol;2`_m@D53o<c<cofi^K_n3Ph?o8B4QomkNg_oVi^Ko
onSXj27oj>SX0Oo/k>`1oo;blP7om_Kf00000oogmoOon?ShooShn003ooSh
n00CooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFooZBQoonYY_oo[2UoonhZoon
/jKooZRLoo^DROo^J5WoRC4[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOg
moo^k^koc/k>oi2@T?nIJB_ol;dmoo_PK_onm8;oo_j:ooooT_onoXcoo_R3
oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^ko
c/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSoc_j@omKoUoo@oY;oa_j9ok;eM?n8
dd?oA7D[oi2@T?o>c/kok^k^ooOgm`3KooShn00UooKfm_oalO7oPH61oalO
7oo]kNgoa/K6o`000?o3`l?odm?CoeaLG?l820Soj^[Zoo3`l?oZj^[oDU9B
oa@D5?lm?CgojNWYoo3`l?n_[joo1`L7om;Bd_o=cLgoCTi>oa/K6oo^k^ko
fm_Kojj^[_oXj>Sok>c/ojj^[_l0003o];Bdonc/k?n`/;3o2`/;oaXJ6P02
onCTi00;ob<S8ol>3PkoY:BTong]kOo^k^koH61PoeADE?o^k^kokNg]obHV
9_n=SHd00_o`l?003?n2PX;o<C4aonc/k?oZj^[o@d=3obl_;onLW9coLg=c
obXZ:_lJ6Q[ok^k^ooKfmPcon?Sh00?omoOgooShn?ohn?P0Foohn?P00oog
moOon?ShooShn005ooShn003ooOgmoohn?Son?Sh03Oon?Sh00?omoOgooSh
n?ohn?P0J_ohn?P00oogmoOon?ShooShn002ooShn003ooOgmooinOWomoOg
00;omoOg00000oojn_[omOGeonk^kP02onc/k03oon_[jooYjNWogmoOokZj
^_miDU;o_c4SonMdJOomRGkooiN;oojRU_ooZ9cooZBHoonJSOonRWookWIZ
ol<c9?miDU;o^[ZjomoOgooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[o
R6EBon:A7?oi`e3ooMYSoooZL_onlgkoooZ2ookfOoook7?oo]iToo[7DOoR
TQcoRFICokZj^_oOgmooj^[Zon_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]
D_mAXacoTM9EojKWJ_nhnG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHL
oe9]D_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/0038onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[jooZj^[o
i>CTogYjN_lL71coh^;Rol_;bol30`?oWinOomoOgonDU9Co4a<Con3PhOoQ
hN7od=3@o`H61_nQXJ7o2@T9okjn__oRh^;o^KVjo`820_na/K7og]kNoh20
P?lY:BWoh^;RonSXj?oTi>GogmoOom[Jf_oDe=Co20P8ohJ6Q_oOgmooJVYZ
odU9B_le=CGo[:b/okjn__l71`OoN7QhoeEEEOoOgmoogmoPoe]KFom?Cdoo
h^;Ron3Ph?lT92CoQ8B4on3Ph?oPh>7oNg]kobl_;ooQhN7oe=CDo`D51OnW
YjOoi>CTon;RhomoOgoo5ADEon;Rh_oYjNWok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jn`2on_[j`2Yonc/k?o[jn_ok>c/on[Zj_o/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k006on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H0
0OoinOT00003oo_knooclo?okNg]00;oiNGU0?ooi^KVon?ShooIfMWo/K6a
ogT^;_o8@SCohfYLooAjKOomR7cooYN:oojKS_onV8_ooXYnooAkKOoWJego
bT8dog/^;_nb/[;of=SHonCTi?oUiNGoi^KVonGUi_oTi>Cof=SHok:b/_nF
EBkojY`[oo^lA?onc5?ooMQRookSL_onjGGoo^IcookKIOomc5?onl55onjN
:onIERko/[:bomSHf?oTi>CoiNGUonKVi_oUiNGoi>CTomSHfOnb/[;o;V8^
of>]:on7bTSoUmaIojGUJOnblgOo^?IkokCeNOnWjV_oV=aIohW?BomS[R_o
;V<^ok:b/_oHf=Woi>CTonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNH00?ooi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonCTi?oN
g]koMgMgoa/K6ooLg=coh>3PoijNW_l^;Rko:b/[oc8b<_lB4Q;ofm_Lom_K
fon4Q8Co8B4QomoOgomCDe?oIfMWom_KfooMgMkoT92@obTY:Ol_;boo;2`/
obPX:?oMgMgogmoOomSHfOoDe=Coclo?oe]KFol0003o_[jnomWIfOlX:2So
QXJ7ogQhN?mXJ6SoPX:2oc`l??o3`l?o3`l?omGEeOoIfM[oFEUIodi>C_oM
gMgog=cLob<S8on1PH7oe]KFomKFeomgMgOo;Rh^omgMgOnRXZ;o0000olK6
a_oIfMWof=SIohj>S_lE5AGogMgMon?ShooVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^H007?oiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGU00?oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooU
iNGokNg]ooCdm001oo_kn`0000?oo?clooShn?oalO400oo^k^h04oo[jn_o
hN7Qokbl_?mj5aOo`clbom=EBOoTJ5[okgM/oo>3N?ohQgcomHAjoo=iKOoU
JE_ofEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl
_?nUAaOoiYLbooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlb
onVK<_nUAQOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOo
GjPbogJm=on6cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lG
FAOo_;blon7QhOo/k>`0foo^k^h0;_o/k>coinOWog]kNolL71coi>CTonWY
jOoVi^KohN7QomkNg_n=SHgo51@DonKVi_oTi>Co=CDeogUiNOo[jn_o/[:b
oaDE5OoOgmooi^KVonCTi?oQhN7ogMgMogYjN_lY:BWoj>SXonGUiOoMgMgo
/K6aobHV9_l;2`_oVi^KonWYjOo<c<co0000olk>c_o3`l?o9BDUod];Boml
O7coj>SXoc4a<OnUYJGoi>CToeeMGOmADE42onOWi`0:obDU9OmYJFWogmoO
omoOgomgMgOo<C4aonWYjOo1`L7o0000ojNWY`;ogmoO00CoTi>CoaHF5_oW
inOok>c/J_o^k^h00oo]kNgok^k^onk^kP05onk^kP03ong]kOo^k^kok^k^
0:[ok^k^00?okNg]oo;bl_ohn?P00Oolo?`000?ooOgm01Koo?cloogmoOom
oOgoo?cloo;bl_oAdM7oI`H6okPd=?o7?c?odU13omYREOoSKV;oi79TonA_
H_oLI5Oode53ola1=?ni=3CoJ`L7om;Bd_oclo?oo?cl0oomoOd04oolo?co
lo?com;Bd_nN:`OofXXdon^K6OoeZ2Won;@oooVmB_oh_dgon[m:ooVh?oof
ZR[okihIom^;=?nR;@Ood];Boo?cloolo?`00oomoOd04oolo?colo?com;B
d_l7@0OoCIXdoen[8?m`^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^BooHZhP
odjK=?l7@POod];Boo?cloolo?`0foomoOd08ookno_omoOgohB4Q?lN7Qko
lo?cooWinOnc/k?od=3@oo?clomXJ6SoAdM7oo[jn_oDe=Co0000omgMgOol
o?cono_kobLW9onXZ:SonOWioj^[ZooEeMGolO7aoeADE?mNGUkonOWiooCd
m?nDU9Co1@D5od10@?oAdM7omoOgooShn?nGUiOo:b/[00;on_[j01_o92@T
o`L71oo8b<Sono_kohF5QOmSHf?omoOgof=SHomGEeOon?ShooWinOlW9bOo
5ADEoh>3PooGemOo@T92of=SHookno_on_[joc@d=?m9BDWofm_KonGUiOm?
Cdoo5aLGoo[jn_olo?`0ooomoOdNoogmo@03ooclo?omoOgoo?cl00?ooOgm
00001?omoOgon_[joo?cloo^k^h2ono_k`0dong]kOoYjNWodm?Coe/M7OnR
=3Co]2PMol4j;Oo7BCcoceI:om1GBoo@Ed[obTXnol<k;_nf:1goXS@doe`M
7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`koo^k^koj^[Zom?Cdon<9Agob74d
omV47OoTU1GoiidTonjX<oo`ZSCokjXconbP9OoWUaGog8PMolQa=?n<9Ago
dm?Con[Zj_o^k^kol?3`ono_koo`l?3ok^k^on[ZjOoCdm?o7CPMocB2=?m7
UAgoFZDKofV]:P;oM;Ph0?ooMKThof^a:omKYacoB9XMocB2=?lM>1godm?C
on[ZjOo^k^kol?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3ok^k^on_[jommOGgo71`L
onOWioo^k^koR8R8oc0`<?l>3Pko<C4aok2`/?o_knkoQ8B4ode=COo^k^ko
kno_onk^k_n:RX[oFEUIono_k_mhN7So;2`/o`h>3_lh>3So_[jnonk^k_oS
hn<000co3Ph>ofUYJOoPh>3oh^;RonKVi_oZj^[oHF5QogIfM_o_knkok^k^
ogMgMolV9RH2onk^kP0Folg=cOl/;2cojn_Zofa/K?mSHf?ojn_[onk^k_lj
>S[oU9BDof9RH_l>3Pko=3@dolC4a?o^k^kokno_om7AdOll?3co2PX:obHV
9_m/K6co;2`/onk^kP;okno_0?ool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_ono_k_o^
k^kol?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?0001Kokno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`0_o_knl2oo3`l0Kokno_0Ooclo<1ooWin@7oo_kn00000oono_ko
moOgoo3`l004onWYj@0AonOWiooKfm_oHd];oh4b<_nV=3Co]S@]ol9=@Oo3
E4Woa5E:ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooWinL01OoYjNT0
4OoWinOofm_KohU;Bon_Bc;ocGLeomJ;;OoPW2koh:0bon6P=?oPX3;ogiX^
omJ;;Oo:MCGo[d/bohU;BooKfm_oinOW00GojNWY017oinOWom_Kfom;Bd_o
<V0bocZ9=OmCVbgoJj/_og2]>?m_[S[oL:dhofZZ;omCVbgo>HPeoc9P<_m;
Bd_ofm_KonOWi`3LonWYj@06onSXj?oVi^KoNg]koa`L7?oTi>Coj>SX0_oY
jNT00ooWinOojNWYonWYj@0;onWYj@0<onOWiooYjNWojNWYonSXj?oHf=So
2PX:ojj^[_oMgMgog]kNon3Ph?oUiNGoj>SX2?oYjNT01_oXj>Soi^KVon?S
hooShn?oi^KVonSXj0?ojNWY00?oj>SXonWYjOoYjNT01?oYjNT00ooWinOo
jNWYonWYj@2ZonWYj@03onSXj?oYjNWojNWY06oojNWY00?oj>SXonWYjOoY
jNT01?oYjNT1oo3`l07omoOg0Oono_h00004ookno_ojn_[om?Cdono_k`?o
l?3`017okno_on_[jonEU9CoCb<SoiEDE?nkLg?odiFEomZLW?oJWYcofIbL
omBEUOnkLg?oUEADodlS8onEU9Coj^[Zono_k`05oo3`l00Aono_kooZj^[o
ZIBDoh4S8onjJUCoe9YconBlUOoZaicojLNLon[7W?oU_9Goe9Ycok]ZE?n1
8b?oZYBDon[Zj_o_knl01Oo`l?004Oo_knooj^[ZoiBDU?lS:R?oE7YDog>U
LonNaYGo[<jLojg>W?n/cYcoW/JEog>ULomDNUCo8bXSoiBDU?oZj^[okno_
0=col?3`0_o_knl01?n0P83o7AdMonk^k_o_knlCoo3`l0;okno_00OoI6AT
obTY:On1PH7oHf=Soc/k>oo^k^kokno_00Sol?3`00Kokno_onk^k_mcLg?o
JFUYonk^k_o_knl9oo3`l003ono_koo`l?3ol?3`017ol?3`00?okno_oo3`
l?o`l?00WOo`l?000oo_knool?3`oo3`l01^oo3`l004oo7alOo`l?3om?Cd
oo[jnP7oo_kn00001?o/ko7oooooooooooono_h2ooooo`;oo_kn0?oooOgm
ooShn?m^KVkoFSlook6@T?oNbLWol>CToo?Vi_o`i>Cog/W9ok6@T?mJ?coo
KFe]ooShn?olo?coooooookno_ooooooo_knooooo_ono_koooooooclo?oh
n?SoSFe]ohXo?oo9TI3ojM39ooCYi?ofjnKom>WTonW@bOo9TI3oRCloohe]
KOohn?Ooo?clooooooono_koooooookno_ooooooo_knooooo_olo?con?Sh
ofe]KOlo?cooT9f@olWEbOoTk>Coi^kVonC/i?o9eLWoT9f@oclo?om]KFgo
n?Shooclo?ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_h001Woooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_kooooo00;oo_kn
0?ooclo?ojJVYOomoOgoooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooknoOo0`<3oLG5aoh20P?n`/;3ooOgmooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ono_go`L71okfm_Oom
oOgoooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_h005Goooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_kooooo00;oo_kn00Goooooookno_ooooooooooooknoP05
ooooo`7on__k00001_o3bm;oo_knoo[jn_odm?ColO7aoo3`l0?olO7a00go
kno_omKFe_m[Jf_o@cdmoi^<S?o6^[[oe/c<olNj^_nKS8co@cdmof][JooF
e]Kokno_00WolO7a00gokno_omOFe_n3Jf_oM3dmokF<S?oE^[[ohLc<omJj
^_nfS8coLSdmoh5[JooGe]Kokno_00WolO7a00gokno_omKFe_m[Jf_o?Cdm
ohb<S?nj^[[oc<g<okZj^_n<S8co?Cdmof][JooFe]Kokno_0?oolO7aoooa
lO4goo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_ono_h0
0Oo_lO800005ohJDX?omoOgomoOgoo3`l?o[jn/00ooZj^X03OoYjNWoj^[Z
onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT0
2ooZj^X02ooYjNWoj>SXoj2KVomZFEWo@bHVobd92Om29RKoJEUIoj2KVooX
j>SojNWY00_oj^[Z00_ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUI
FOnKVi_oj>SXonWYj@3oon[Zj_ooj^[Z?ooZj^X01?o[jn_ol?3`ooShn?om
oOd1om[Nh@0000Co>DYJok[3b_ojn_[om?Cd2?oalO42oo3`l0?okno_0_o`
l?0?oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`oooa
lO7ooo7alCgolO7a00Sol?3`oo7alOoalO7olO7aoo3`l?oemOGon_[jon[/
kP7oW:6T00000olQ>4WoCeiZok[1b03oooooooooooooOoooool1onW[k07o
Y:R[0OnIWZ800006ob@nD?lQ=DCo>DICohB>VOo0a/cojng_oooooooooooo
ogWooooo00GonOWjonc^kooAe=OoVinRoifQYP01okBi_@00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{643, 482},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[BoxData[{
    \(\(savedLayout = pane@getLayout[];\)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]\(pane@
          setLayout[\[IndentingNewLine]JavaNew["\<java.awt.GridLayout\>", 2, 
              3, 5, 5]\[IndentingNewLine]];\)\[IndentingNewLine]]\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(LoadJavaClass["\<javax.swing.JSlider\>"]\)], "Input"],

Cell[BoxData[
    \(JavaClass["javax.swing.JSlider", 56]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?javax`swing`JSlider`*\)\)], "Input"],

Cell[BoxData[GridBox[{
        {
          StyleBox["javax`swing`JSlider`",
            FontFamily->"Helvetica",
            FontSize->12,
            FontWeight->"Bold"]},
        {GridBox[{
              {
                ButtonBox[
                  StyleBox["ABORT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`ABORT"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["LEADING",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`LEADING"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["SOUTHUWEST",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`SOUTHUWEST"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"]},
              {
                ButtonBox[
                  StyleBox["ALLBITS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`ALLBITS"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["LEFT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`LEFT"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["TOOLUTIPUTEXTUKEY",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`TOOLUTIPUTEXTUKEY"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"]},
              {
                ButtonBox[
                  StyleBox["BOTTOM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`BOTTOM"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["LEFTUALIGNMENT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`LEFTUALIGNMENT"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["TOP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`TOP"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"]},
              {
                ButtonBox[
                  StyleBox["BOTTOMUALIGNMENT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`BOTTOMUALIGNMENT"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["NORTH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`NORTH"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["TOPUALIGNMENT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`TOPUALIGNMENT"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"]},
              {
                ButtonBox[
                  StyleBox["CENTER",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`CENTER"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["NORTHUEAST",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`NORTHUEAST"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["TRAILING",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`TRAILING"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"]},
              {
                ButtonBox[
                  StyleBox["CENTERUALIGNMENT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`CENTERUALIGNMENT"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["NORTHUWEST",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`NORTHUWEST"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["UNDEFINEDUCONDITION",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`UNDEFINEDUCONDITION"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"]},
              {
                ButtonBox[
                  StyleBox["EAST",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`EAST"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["PROPERTIES",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`PROPERTIES"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["VERTICAL",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`VERTICAL"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"]},
              {
                ButtonBox[
                  StyleBox["ERROR",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`ERROR"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["RIGHT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`RIGHT"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["WEST",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`WEST"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"]},
              {
                ButtonBox[
                  StyleBox["FRAMEBITS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`FRAMEBITS"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["RIGHTUALIGNMENT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`RIGHTUALIGNMENT"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["WHENUANCESTORUOFUFOCUSEDUCOMPONENT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`WHENUANCESTORUOFUFOCUSEDUCOMPONENT"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"]},
              {
                ButtonBox[
                  StyleBox["HEIGHT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`HEIGHT"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["SOMEBITS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`SOMEBITS"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["WHENUFOCUSED",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`WHENUFOCUSED"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"]},
              {
                ButtonBox[
                  StyleBox["HORIZONTAL",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`HORIZONTAL"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["SOUTH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`SOUTH"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["WHENUINUFOCUSEDUWINDOW",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`WHENUINUFOCUSEDUWINDOW"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"]},
              {
                ButtonBox[
                  StyleBox["isLightweightComponent",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`isLightweightComponent"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["SOUTHUEAST",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`SOUTHUEAST"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"], 
                ButtonBox[
                  StyleBox["WIDTH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3240733019-6623482", 
                    "javax`swing`JSlider`WIDTH"},
                  ButtonFrame->"None",
                  ButtonNote->"javax`swing`JSlider`"]}
              },
            RowMinHeight->{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.05}]}
        },
      RowSpacings->{2, 3},
      ColumnAlignments->{Left},
      ColumnsEqual->True]], "Print",
  CellMargins->{{20, Inherited}, {Inherited, Inherited}},
  ShowCellLabel->False,
  CellFrameMargins->{{Inherited, Inherited}, {14, 14}},
  Background->GrayLevel[0.930022],
  ButtonBoxOptions->{Active->True}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(sldr = NewJSlider[pane]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JSlider"] \[RightGuillemet]\),
      JLink`Objects`JavaObject76404012089345]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(DeleteJObject[pane, sldr]\)], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["<<< SimpleJSlider >>>",
  FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell["\<\
MathSwingChangeListener was defined. See SimpleJTable \
section.\
\>", "Text"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005V0001EAP00`40o`00
0?l0003oo`0006L000000003R<2hB928B9280?m8T8QSB9280@00000000>8
`;S8h=R8`;P0ohS0^6:8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^6:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<Glc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<Glc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<Glc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<Glc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PNc<c<10000?o<
c<`mc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1g<c<`200000/c<
c080003oc<c<?<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PMc<c<
0P0000;<c<`20000olc<c3c<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h7Lc<c0800002c<c<0P000?o<c<`lc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0K<c<`6oooo2<c<c0NIVL`2c<c<0P0000;<c<`20000olc<
c3c<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c0IVIVH00ooo
olc<c<c<c00?c<c<0P0000;<c<`20000olc<c3c<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<
c00@c<c<0P0000;<c<`20000olc<c3c<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c00@c<c<
0P0000;<c<`20000olc<c3c<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c00Ac<c<10000?o<
c<`mc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVI
VLc<c002c<c<00=VIVKoooo<c<`01lc<c0BIVLcoc<c<Alc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIV
ooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIV
I_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=V
IVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c007c<c<19VIc?o<c<a7
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<
c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<
D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<
c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<
c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVI
c<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<00O<
c<`4VIW<olc<c4O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<
c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIV
ooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIV
I_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=V
IVKoooo<c<`01lc<c0BIVLcoc<c<Alc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aB
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<
c002c<c<00=VIVKoooo<c<`04lc<c0800003c<c<10000?o<c<`fc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<
00=VIVKoooo<c<`04lc<c0800002c<c<0P0000;<c<`20000olc<c3G<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<
c<`00fIVI_ooolc<c00Cc<c<0P0000;<c<`200000/c<c080003oc<c<=Lc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`0
0/c<c003IVIVooooc<c<01?<c<`200000/c<c0800002c<c<0P000?o<c<`e
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<
c002c<c<00=VIVKoooo<c<`01lc<c0NIVL`5c<c<0P0000;<c<`200000/c<
c080003oc<c<=Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<
00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<017<c<`010000<c<c0000000
00;<c<`200000/c<c080003oc<c<=Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<017<c<`4
00000/c<c0800002c<c<0P000?o<c<`ec<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`04/c<
c0<00002c<c<0P0000;<c<`20000olc<c3G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c00C
c<c<0P0000?<c<`40000olc<c3K<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`0
0/c<c003IVIVooooc<c<00O<c<`4VIW<olc<c4O<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<
c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<
c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVoooo
c<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`0
0fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`01lc<c0BIVLcoc<c<Alc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<
c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<
c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002
c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c007c<c<19VI
c?o<c<a7c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIV
IYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<
c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<
c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVoooo
c<c<00O<c<`4VIW<olc<c4O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<
c003IVIVooooc<c<013<c<`600000/c<c0@0003oc<c<=/c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIV
ooooc<c<013<c<`200001Lc<c0800002c<c<0P000?o<c<`ec<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=V
IVKoooo<c<`04Lc<c0800004c<c<0P0000;<c<`20000olc<c3G<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`0
0fIVI_ooolc<c00Bc<c<0P0000?<c<`200000/c<c080003oc<c<=Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<
c003IVIVooooc<c<00O<c<`7VIW<1Lc<c0800002c<c<0P0000;<c<`20000
olc<c3G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
VIVIc<c<00;<c<`00fIVI_ooolc<c00Dc<c<0P000003c<c<0000000000;<
c<`20000olc<c3G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<
c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c00Dc<c<0P000003c<c<0000
000000;<c<`20000olc<c3G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c00@c<c<0P0000;<
c<`2000000?<c<`0000000000/c<c080003oc<c<=Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVoooo
c<c<017<c<`400000lc<c0@0003oc<c<=/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<
c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVI
VLc<c002c<c<00=VIVKoooo<c<`01lc<c0BIVLcoc<c<Alc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIV
ooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIV
I_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=V
IVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c007c<c<19VIc?o<c<a7
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<
c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<
D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<
c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<
c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVI
c<c<00;<c<`00fIVI_ooolc<c007c<c<19VIc?o<c<a7c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKo
ooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<
c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIV
ooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIV
I_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<00O<c<`4VIW<olc<c4O<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<
00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<017<c<`4
00000lc<c0@0003oc<c<=/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<013<c<`200000/c<
c08000000lc<c00000000002c<c<0P000?o<c<`ec<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<
c<`05<c<c08000000lc<c00000000002c<c<0P000?o<c<`ec<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=V
IVKoooo<c<`05<c<c08000000lc<c00000000002c<c<0P000?o<c<`ec<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002
c<c<00=VIVKoooo<c<`01lc<c0NIVL`6c<c<0P000003c<c<0000000000;<
c<`20000olc<c3G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<
c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c00Bc<c<0`0000;<c<`20000
0/c<c080003oc<c<=Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<01C<c<`2000000?<c<`0
000000000/c<c080003oc<c<=Lc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<013<c<`20000
0/c<c08000000lc<c00000000002c<c<0P000?o<c<`ec<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKo
ooo<c<`04Lc<c0@00003c<c<10000?o<c<`fc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0
olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
VIVIc<c<00;<c<`00fIVI_ooolc<c007c<c<19VIc?o<c<a7c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=V
IVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003
IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`0
0fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<00O<c<`4VIW<olc<
c4O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVI
c<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<
c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVI
VLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03o
c<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJI
VIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0
1lc<c0BIVLcoc<c<Alc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=V
IVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003
IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`0
0fIVI_ooolc<c007c<c<19VIc?o<c<a7c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<
c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVI
c<c<00;<c<`00fIVI_ooolc<c00Cc<c<0P0000?<c<`40000olc<c3K<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<
c<`00fIVI_ooolc<c00Cc<c<0P0000;<c<`200000/c<c080003oc<c<=Lc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`0
0/c<c003IVIVooooc<c<013<c<`6000000?<c<`0000000000/c<c080003o
c<c<=Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJI
VIW<c<`00/c<c003IVIVooooc<c<013<c<`00`000<c<c<c<c00200000/c<
c0800002c<c<0P000?o<c<`ec<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`01lc<c0NIVL`3
c<c<00@0003<c<`000000002c<c<0P0000;<c<`20000olc<c3G<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`0
0fIVI_ooolc<c00Ac<c<00@0003<c<`000000002c<c<0P0000;<c<`20000
olc<c3G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
VIVIc<c<00;<c<`00fIVI_ooolc<c00Bc<c<0`0000;<c<`200000/c<c080
003oc<c<=Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVJIVIW<c<`00/c<c003IVIVooooc<c<01;<c<`300000/c<c0800002c<c<
0P000?o<c<`ec<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`0
0fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`04lc<c0800003c<c<10000?o<
c<`fc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVI
VLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c007
c<c<19VIc?o<c<a7c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIV
I_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=V
IVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003
IVIVooooc<c<00O<c<`4VIW<olc<c4O<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<
D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<
c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<
c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVI
c<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<
c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVI
VLc<c002c<c<00=VIVKoooo<c<`01lc<c0BIVLcoc<c<Alc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIV
ooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIV
I_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=V
IVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c007c<c<19VIc?o<c<a7
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<
c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c00Ac<c<
100000?<c<`400002/c<c0800005c<c<0P000?o<c<`Sc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKo
ooo<c<`04<c<c0800002c<c<0P000003c<c<0000000000;<c<`200002Lc<
c0800005c<c<0P000?o<c<`Sc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`05<c<c0800000
0lc<c00000000002c<c<0P0000W<c<`200001Lc<c080003oc<c<8lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<
c003IVIVooooc<c<01C<c<`2000000?<c<`0000000000/c<c080000:c<c<
0P0000G<c<`20000olc<c2;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c007c<c<1iVIc0;<
c<`200000/c<c08000000lc<c00000000002c<c<0P0000[<c<`200001Lc<
c080003oc<c<8/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<
00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<013<c<`500000/c<c0800002
c<c<0P0000_<c<`200001Lc<c080003oc<c<8Lc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<
013<c<`200001Lc<c0800002c<c<0P0000_<c<`200001Lc<c080003oc<c<
8Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<
c<`00/c<c003IVIVooooc<c<017<c<`200001<c<c0800002c<c<0P0000c<
c<`200001Lc<c080003oc<c<8<c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<017<c<`50000
0/c<c0@00009c<c<1P000003c<c<0000000000@0003oc<c<8<c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003
IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`01lc<c0BIVLcoc<c<
Alc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<
c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<
c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVI
c<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<
c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVI
VLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c007
c<c<19VIc?o<c<a7c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIV
I_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=V
IVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003
IVIVooooc<c<00O<c<`4VIW<olc<c4O<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<
D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<
c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<
c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVI
c<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<
c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVI
VLc<c002c<c<00=VIVKoooo<c<`01lc<c0BIVLcoc<c<Alc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIV
ooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`04Lc<c0@00003c<c<1000
0?o<c<`fc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIV
IYVIVLc<c002c<c<00=VIVKoooo<c<`04<c<c0800002c<c<0P000003c<c<
0000000000;<c<`20000olc<c3G<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c00@c<c<0P00
00;<c<`2000000?<c<`0000000000/c<c080003oc<c<=Lc<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIV
ooooc<c<013<c<`200000/c<c08000000lc<c00000000002c<c<0P000?o<
c<`ec<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVI
VLc<c002c<c<00=VIVKoooo<c<`01lc<c0NIVL`2c<c<0P0000;<c<`20000
00?<c<`0000000000/c<c080003oc<c<=Lc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<013<
c<`500000/c<c0800002c<c<0P000?o<c<`ec<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0
4<c<c0800005c<c<0P0000;<c<`20000olc<c3G<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<
c00Ac<c<00<0003<c<c<c<`00P000003c<c<0000000000;<c<`20000olc<
c3G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVI
c<c<00;<c<`00fIVI_ooolc<c00Bc<c<0`0000?<c<`40000olc<c3K<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<
c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<00O<c<`4VIW<
olc<c4O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
VIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<
0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIV
IYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<
c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<
c<`01lc<c0BIVLcoc<c<Alc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<
00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<
c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<
c<`00fIVI_ooolc<c007c<c<19VIc?o<c<a7c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0
olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
VIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<
0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIV
IYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<
c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVJIVIW<c<`00/c<c003IVIVooooc<c<00O<c<`4VIW<olc<c4O<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`0
0fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<017<c<`200001Lc<
c0@0003oc<c<=/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<
00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<017<c<`200001<c<c0800002
c<c<0P000?o<c<`ec<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`04Lc<c0800004c<c<0P00
00;<c<`20000olc<c3G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c00Bc<c<0P0000?<c<`2
00000/c<c080003oc<c<=Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<00O<c<`7VIW<1<c<
c0800003c<c<0P0000;<c<`20000olc<c3G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c00C
c<c<0P0000;<c<`200000/c<c080003oc<c<=Lc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<
01?<c<`200000/c<c0800002c<c<0P000?o<c<`ec<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<
c<`05<c<c08000000lc<c00000000002c<c<0P000?o<c<`ec<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=V
IVKoooo<c<`04<c<c0H00002c<c<10000?o<c<`fc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<
c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c007c<c<19VIc?o<c<a7c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<
00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<
c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<
c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<00O<c<`4VIW<
olc<c4O<c<`2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hc<c<00P00000
0lc<c6IVI_ooo`3oc<c<Dlc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8
`;P0003<c?l7VIW<00<0001VIVKoool0olc<c5?<c<`2R<2h0DR@R0400000
0006R<2hb>3HR<2hR<2h0000c<co29VIc0030000ooooc<c<0?o<c<aBc<c<
0XS0^058T8P10000000028S0^<SPf8S0^8S0^0000<c<oiVIc6IVV@>IVL`0
1FIVVIVIc9VIc9VIc000003oc<c<Dlc<c0:8`;P1B9280@00000000F8`;S8
h=R8`;R8`;P000000/c<o`>IVL`00lc<oiVIc9VIc003VIW<00<0003<c<c<
c<`01Lc<c0BIVLcoc<c<Alc<c0:8`;P1B9280@00000000J8`;S8h=R8`;R8
`;P0003<c?l3VIW<00=VIYVIVLbIVL`01IVIc0030000c<c<c<c<0?o<c<a?
c<c<0XS0^058T8P1000000001XS0^<SPf8S0^8S0^0000<c<o`:IVL`00lc<
oiVIc9VIc007VIW<00<0003<c<c<c<`0olc<c4k<c<`2R<2h0DR@R0400000
0008R<2hb>3HR<2hR<2h0000c<coVIW<IVJI0iVIc003IVJIVIW<VIW<00FI
VL`00`000<c<c<c<c03oc<c<CLc<c0:8`;P1B9280@00000000F8`;S8h=R8
`;R8`;P000000/c<o`>IVL`00lc<oiVIc9VIc005VIW<00<0003<c<c<c<`0
olc<c4k<c<`2R<2h0DR@R04000000006R<2hb>3HR<2hR<2h0000c<co0iVI
c003IVJIVIW<VIW<00FIVL`00`000<c<c<c<c03oc<c<Clc<c0:8`;P1B928
0@00000000J8`;S8h=R8`;R8`;P0003<c?l2VIW<00?<c?nIVLbIVL`01IVI
c0030000c<c<c<c<00G<c<`4VIW<olc<c4O<c<`2R<2h0DR@R04000000008
R<2hb>3HR<2hR<2h0000c<coVIW<IVJI0iVIc005IVJIVIW<VIW<VIW<0000
0?o<c<aCc<c<0XS0^058T8P1000000001HS0^<SPf8S0^8S0^0000002c<co
0iVIc006c<coVIW<VIW<VIW<0000oooo4/c<c0@00003c<c<10000?o<c<`f
c<c<0XS0^058T8P1000000001HS0^<SPf8S0^8S0^0000008c<co00<0001V
IVKoool04Lc<c0800002c<c<0P000003c<c<0000000000;<c<`20000olc<
c3G<c<`2R<2h0DR@R04000000005R<2hb>3HR<2hR<2hc<c<00P000000lc<
c6IVI_ooo`0Ac<c<0P0000;<c<`2000000?<c<`0000000000/c<c080003o
c<c<=Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJI
VIW<c<`00/c<c003IVIVooooc<c<013<c<`200000/c<c08000000lc<c000
00000002c<c<0P000?o<c<`ec<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`01lc<c0NIVL`3
c<c<100000;<c<`200000/c<c080003oc<c<=Lc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<
013<c<`200000/c<c08000000lc<c00000000002c<c<0P000?o<c<`ec<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002
c<c<00=VIVKoooo<c<`04<c<c0800002c<c<0P000003c<c<0000000000;<
c<`20000olc<c3G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<
c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c00@c<c<0P0000;<c<`20000
00?<c<`0000000000/c<c080003oc<c<=Lc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<017<
c<`400000lc<c0@0003oc<c<=/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002
c<c<00=VIVKoooo<c<`01lc<c0BIVLcoc<c<Alc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<
0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIV
IYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<
c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<
c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c007c<c<19VIc?o<c<a7c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<
00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<
c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<
c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<00O<c<`4VIW<
olc<c4O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
VIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<
0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIV
IYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<
c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=V
IVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<
c<`01lc<c0BIVLcoc<c<Alc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<
00=VIVKoooo<c<`04Lc<c0<00004c<c<10000?o<c<`fc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKo
ooo<c<`04<c<c0800002c<c<00<0003<c<c<c<`00P0000;<c<`20000olc<
c3G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVI
c<c<00;<c<`00fIVI_ooolc<c00Dc<c<0P000003c<c<0000000000;<c<`2
0000olc<c3G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003
IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c00Ac<c<1@000003c<c<00000000
00;<c<`20000olc<c3G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c007c<c<1iVIc0;<c<`2
00000/c<c08000000lc<c00000000002c<c<0P000?o<c<`ec<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=V
IVKoooo<c<`04<c<c0800002c<c<0P000003c<c<0000000000;<c<`20000
olc<c3G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
VIVIc<c<00;<c<`00fIVI_ooolc<c00@c<c<0P0000;<c<`2000000?<c<`0
000000000/c<c080003oc<c<=Lc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<013<c<`20000
0/c<c08000000lc<c00000000002c<c<0P000?o<c<`ec<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKo
ooo<c<`04Lc<c0@00003c<c<10000?o<c<`fc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0
olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIV
VIVIc<c<00;<c<`00fIVI_ooolc<c007c<c<19VIc?o<c<a7c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=V
IVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003
IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`0
0fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<00O<c<`4VIW<olc<
c4O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVI
c<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<
c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVI
VLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03o
c<c<D/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJI
VIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0
1lc<c0BIVLcoc<c<Alc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5
c<c<00=VIVJIVIW<c<`00/c<c003IVIVooooc<c<0?o<c<aBc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=V
IVKoooo<c<`0olc<c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c03oc<c<D/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJIVIW<c<`00/c<c003
IVIVooooc<c<0?o<c<aBc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<c5;<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`0
0fIVI_ooolc<c007c<c<19VIc?o<c<a7c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0G<c<`00fIVIYVIVLc<c002c<c<00=VIVKoooo<c<`0olc<
c5;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVI
c<c<00;<c<`00fIVI_ooolc<c00Cc<c<0P0000?<c<`400000lc<c0@0003o
c<c<;lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00=VIVJI
VIW<c<`00/c<c003IVIVooooc<c<01?<c<`200000/c<c0800002c<c<0P00
0003c<c<0000000000;<c<`20000olc<c2k<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1Lc<c003IVIVVIVIc<c<00;<c<`00fIVI_ooolc<c00C
c<c<0P0000;<c<`200000/c<c08000000lc<c00000000002c<c<0P000?o<
c<`^c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVIYVI
VIVIV@02VIVI00=VIVKoooo<c<`04lc<c0800002c<c<0P0000;<c<`20000
00?<c<`0000000000/c<c080003oc<c<;/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<1VIVIPW<c<`7VIW<1Lc<c0800002c<c<0P0000;<
c<`2000000?<c<`0000000000/c<c080003oc<c<;/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;PNc<c<00@0003<c<`000000002c<c<0P0000;<
c<`2000000?<c<`0000000000/c<c080003oc<c<;/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;PNc<c<100000;<c<`200000/c<c08000000lc<
c00000000002c<c<0P000?o<c<`^c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^1o<c<`300000/c<c0800002c<c<0P000003c<c<0000000000;<
c<`20000olc<c2k<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h8<c<
c0800003c<c<100000?<c<`40000olc<c2o<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c5o<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2holc<c5o<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c5o<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c5o<c<`2R<2h0DR@
R04000000003R<2hb>3HR<2h0?n8`;QRR<2h0DR@R04000000004R<2hb>3H
R<2hR<2h5000P0800H002P02P003P@03P@04P@05P@05PP06PP07PP47PP48
PP812H<00`4:P`4;P`4;Q0020@b400@13H@13XD13XD23hD20Q2500@24HH2
4XH24XH24hH20QB700<25HL25XL35XP00P<GR0040aR80aV80aV90aZ90P<K
R@040ab:0af:0af:11j:0P@OR`03122;126;126;00848X`010@SS0@TS0@T
S@DUS@859Xd01`DWSPDXSPDXSPDYSPDZSPDZS`D[S`021Bb?0PH]T0041Rj@
1Rn@1RnA1S2A0PHaT@071S:A1S>B1S>B1SBB1cFB1cFC1cJC0087=i<21cRD
00@7>I@7>Y@7>Y@7>iD223bE00L8?ID8?YH8?YH8?iH8@9H8@9L8@IL00PQ2
U`0324>G2D>H2DBH0089AIP010U6V@U7V@U7V@U8V@89BIX010U:VPY;VPY;
VPY<V`8:CI/00`Y>V`Y>W0Y?W0022U2L00L:DId:DYd;DYd;Did;E9d;E9h;
EIh00P]FWP032eNO2eRO2eRO008;FIl010aJX0aKX0aKX0aLX08<GJ401`aN
X@aOX@aOXPaPXPaQXPeQXPeRXP023F>S00<=I:<=IJ<=IJ@00PeVY0043FNT
3FRU3FRU3VVU0PiZY@043V^V3VbV3VbV3VfV0Pi^Y`033VnW3W2W3g2X008?
LJP010mbZ0mcZ0mcZ@mdZ@8?MJT010mfZPmgZPmgZQ1hZP8@NJ/00a1jZa1k
Za1kZ`0247b/00@@OJ`@OZ`@OZdAOjd24H2]00LAPJhAPZhAPZhAPjhAQ:hA
Q:lAQJl00Q66[`8BQk0011:8/1:9/1:9/A::/@8BRk401a:</A:=/Q:=/Q:>
/Q>?/Q>?/a>@/`024i6c0Q>B]0044i>d4iBd4iBd4iFe0QBF]@0759Ne59Rf
59Rf59Vf59Zf59Zg59^g008DW;L00aBM]aFM^1FN^0025Inh00@EX;TEXKTE
XKTEX[T25J>j00@EY;XFYKXFYKXFY[/25ZNk00<FZ;/FZ;`FZK`00QJZ_007
5Z^m5Zbm5jbm5jfm5jjm5jjn5jnn008G/;h011Na_aNb_aNb_aNc_cHH]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1000P003VjOa<d>U<d>U00Tc
@jD400200P01P00:00:000>100>100B100F100F200J200N20@N20@R20P49
P`030@Z30@^30@^4008138@0104=Q04>Q@4>Q@8?Q@8248D0108AQP8BQP8B
QP8CQP8258L00`8EQ`8FQ`<FR0020aN800@368P36HP36HT36XT20a^900@3
78X37HX37HX47XX211n;00<488/48H/48H/00P@RS00412><12B<12B=1BF=
0PDVS@071BN>1BR>1BR>1BV>1BZ>1BZ?1B^?0085;8l21Rf@00@6;Y06;i06
;i46<9421S6A00L6<Y46<i86<i86=987=I87=I<7=Y<00PLgT`87>9@010Li
U0LjU0LjU0LkU@88?9D01`PmU@PnUPPnUPPoUPQ0UPQ0U`Q1U`0224:G00<8
@iL9@iP9A9P00PU5V0042DJI2DNI2DNI2DRI0PU9VP042DZJ2T^J2T^J2TbK
0PY=V`032TjK2TjL2TnL008:D9`01`YAW@YBW@]BW@]CW@]DW@]DWP]EWP02
2eJN00<;Eil;F9l;F9l00P]IW`0435ZP35^P35^P35bP0PaMX@0735jQ35nQ
35nR362R366R3F6R3F:R008=Hj<00`eTX`eUX`eUY0023FJT00@=Ij@=J:D=
J:D>JJD23VZU00@>JjH>K:H>K:H>KJH23VjW00<>KjL>L:L?L:P00PmaZ004
3g:X3g>X3g>Y3gBY0PmeZ@043gJZ3gNZ3gNZ47RZ0Q1iZ`0347Z[47^[47^[
008@O:`0111m[11n[11n[A5o[@8AP:d01a61[Q62[Q62[Q63[Q64[Q64[a65
[`024HJ_0Q:7/0044XR`4XV`4XVa4XZa0Q:;/@074Xba4Xfb4Xfb4Xjb4hnb
4hnc4i2c008CTK<24i:d00@CTk@CU;@CU;@CUKD259Je00LDUkDDV;HDV;HD
VKHDV[HDV[LDVkL00QBL]`0359fg5Ifh5Ijh008EWkP011FP^AFQ^AFQ^AFR
^@8EXkX011FT^QJU^QJU^QJV^`8FYk/00aJX^aJX_1JY_0025ZZl00LFZkdF
[;dG[;dG[KdG[[dG[[hG[kh00QN`_P045k6o5k:o5k:o5k>o=QRd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3002000NKYo7ooon>N[JVVlBcZM:X
WLRcZM800ZJKa005_;SMk^kdj^Waoooo<d>U00<00802006000X00X000h40
0h4018401H401H801X801h811h8128820@V300<12X<12h<12h@00P4<Q004
0@f40@j50@j50Pn50P8@Q@040Q660Q:60Q:60Q>60P8DQ`030QF70QJ70aJ8
00835hP010<HR0<IR0<IR@<JR@836hT010<LRP<MRP<MRP@NRP847h/00`@P
R`@QR`@QR`0212:<00@48h`498`498d59Hd21BJ=00L59hh5:8h5:8h5:Hh5
:Xh5:Xl5:hl00PD/S`86;I0010H^T0H_T0H_T@H`T@86<I401`HbT@HcTPHc
TPHdTPLeTPLeT`LfT`021cNC0PLhU0041cVD1cZD1cZD1c^E0PPlU@0723fE
23jF23jF23nF242F242G246G0088@YL00`Q3U`U3V0U4V0022DFH00@9AYT9
AiT9AiT9B9T22DVJ00@9BYX:BiX:BiX:C9/22TfK00<:CY/:CY`:Ci`00PY@
W0072U6M2U:M2e:M2e>M2eBM2eBN2eFN008;EYh00`]GW`]HW`]HW`022eVO
00@<FZ0<Fj0<Fj0<G:0235fQ00L<GZ4<Gj4<Gj8<H:8<HJ8=HJ8=HZ800PeS
X`033FBS3FFS3FFT008=IZ@010eWY0eXY@eXY@iYY@8>JZD010i[YPi/YPi/
YPi]YP8>KZL00`i_Y`i`Y`m`Z0023g6X00@?LZP?LjP?LjT?M:T23gFY00@?
MZX?MjX?MjX@N:X247V[00<@NZ/@Nj/@Nj/00Q1l[00447f/47j/47j]4Gn]
0Q60[@074H6^4H:^4H:^4H>^4HB^4HB_4HF_008AQZl24XN`00@BR;0BRK0B
RK4BR[424X^a00LBS;4BSK8BSK8BS[8CSk8CSk<CT;<00Q>A/`8CT[@011>C
]1>D]1>D]1>E]@8DU[D01aBG]ABH]QBH]QBI]QBJ]QBJ]aBK]`0259bg00<D
WKLEWKPEW[P00QFO^0045J2i5J6i5J6i5J:i0QFS^P045JBj5ZFj5ZFj5ZJk
0QJW^`035ZRk5ZRl5ZVl008FZ[`01aJ[_AJ/_AN/_AN]_AN^_AN^_QN__P02
5k2n00@G/KlG/[lG/[lG/kl26;C08000008H]<0@00000QRd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2002000BKYo7ooom/FZF_YLX2_;SM00[o
oOncZM;ooooooonl^=fGR[bXWLSVi^cooolc@jD200200P01P00:00:000>1
00>100B100F100F200J200N20@N20@R20P49P`030@Z30@^30@^4008138@0
104=Q04>Q@4>Q@8?Q@8248D0108AQP8BQP8BQP8CQP8258L00`8EQ`8FQ`<F
R0020aN800@368P36HP36HT36XT20a^900@378X37HX37HX47XX211n;00<4
88/48H/48H/00P@RS00412><12B<12B=1BF=0PDVS@071BN>1BR>1BR>1BV>
1BZ>1BZ?1B^?0085;8l21Rf@00@6;Y06;i06;i46<9421S6A00L6<Y46<i86
<i86=987=I87=I<7=Y<00PLgT`87>9@010LiU0LjU0LjU0LkU@88?9D01`Pm
U@PnUPPnUPPoUPQ0UPQ0U`Q1U`0224:G00<8@iL9@iP9A9P00PU5V0042DJI
2DNI2DNI2DRI0PU9VP042DZJ2T^J2T^J2TbK0PY=V`032TjK2TjL2TnL008:
D9`01`YAW@YBW@]BW@]CW@]DW@]DWP]EWP022eJN00<;Eil;F9l;F9l00P]I
W`0435ZP35^P35^P35bP0PaMX@0735jQ35nQ35nR362R366R3F6R3F:R008=
Hj<00`eTX`eUX`eUY0023FJT00@=Ij@=J:D=J:D>JJD23VZU00@>JjH>K:H>
K:H>KJH23VjW00<>KjL>L:L?L:P00PmaZ0043g:X3g>X3g>Y3gBY0PmeZ@04
3gJZ3gNZ3gNZ47RZ0Q1iZ`0347Z[47^[47^[008@O:`0111m[11n[11n[A5o
[@8AP:d01a61[Q62[Q62[Q63[Q64[Q64[a65[`024HJ_0Q:7/0044XR`4XV`
4XVa4XZa0Q:;/@074Xba4Xfb4Xfb4Xjb4hnb4hnc4i2c008CTK<24i:d00@C
Tk@CU;@CU;@CUKD259Je00LDUkDDV;HDV;HDVKHDV[HDV[LDVkL00QBL]`03
59fg5Ifh5Ijh008EWkP011FP^AFQ^AFQ^AFR^@8EXkX011FT^QJU^QJU^QJV
^`8FYk/00aJX^aJX_1JY_0025ZZl00LFZkdF[;dG[;dG[KdG[[dG[[hG[kh0
0QN`_P045k6o5k:o5k:o5k>o0QRd`003b>3HB928B92800a8T8P00`000<SP
f4R@R00=B92800@0000H]<0H]<38h=P>B92800<0000H]<0H]<000XS0^058
T8P10000000018S0^<SPf8S0^8S0^08008002i^WlOooojRMb?oook>YdV1<
VXij]WQU[ZRMb?ooooomo`03oooo00@c@jD0080008000802006000X00X00
0h400h4018401H401H801X801h811h8128820@V300<12X<12h<12h@00P4<
Q0040@f40@j50@j50Pn50P8@Q@040Q660Q:60Q:60Q>60P8DQ`030QF70QJ7
0aJ800835hP010<HR0<IR0<IR@<JR@836hT010<LRP<MRP<MRP@NRP847h/0
0`@PR`@QR`@QR`0212:<00@48h`498`498d59Hd21BJ=00L59hh5:8h5:8h5
:Hh5:Xh5:Xl5:hl00PD/S`86;I0010H^T0H_T0H_T@H`T@86<I401`HbT@Hc
TPHcTPHdTPLeTPLeT`LfT`021cNC0PLhU0041cVD1cZD1cZD1c^E0PPlU@07
23fE23jF23jF23nF242F242G246G0088@YL00`Q3U`U3V0U4V0022DFH00@9
AYT9AiT9AiT9B9T22DVJ00@9BYX:BiX:BiX:C9/22TfK00<:CY/:CY`:Ci`0
0PY@W0072U6M2U:M2e:M2e>M2eBM2eBN2eFN008;EYh00`]GW`]HW`]HW`02
2eVO00@<FZ0<Fj0<Fj0<G:0235fQ00L<GZ4<Gj4<Gj8<H:8<HJ8=HJ8=HZ80
0PeSX`033FBS3FFS3FFT008=IZ@010eWY0eXY@eXY@iYY@8>JZD010i[YPi/
YPi/YPi]YP8>KZL00`i_Y`i`Y`m`Z0023g6X00@?LZP?LjP?LjT?M:T23gFY
00@?MZX?MjX?MjX@N:X247V[00<@NZ/@Nj/@Nj/00Q1l[00447f/47j/47j]
4Gn]0Q60[@074H6^4H:^4H:^4H>^4HB^4HB_4HF_008AQZl24XN`00@BR;0B
RK0BRK4BR[424X^a00LBS;4BSK8BSK8BS[8CSk8CSk<CT;<00Q>A/`8CT[@0
11>C]1>D]1>D]1>E]@8DU[D01aBG]ABH]QBH]QBI]QBJ]QBJ]aBK]`0259bg
00<DWKLEWKPEW[P00QFO^0045J2i5J6i5J6i5J:i0QFS^P045JBj5ZFj5ZFj
5ZJk0QJW^`035ZRk5ZRl5ZVl008FZ[`01aJ[_AJ/_AN/_AN]_AN^_AN^_QN_
_P025k2n00@G/KlG/[lG/[lG/kl26;C000?8h=R8`;R8`;P02hS0^003B928
0000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00>VjOaoooooooo
fmc/H4bJThFj/jWB_;SMH4bJVHnnYY_4b<?Ooooo<d>U1000P0030060oooo
00:000800h401@04P@05POooo`06PP07PP04oooo00H12X<12h<12hCoool1
38Coool20@j500D23hGoool248D24HH24XH00oooo`040QB70QF70QJ7oooo
0P<GR0040aR80aV80aV9oooo0P<KR@030ab:0af:oooo00?oool00`@PR`@Q
Roooo`0212:<00Coool498`498goool21BJ=0oooo`041BV>1BZ>1BZ?1B^?
0PD/S`86;I0010H^T0H_T0H_T@H`T@86<I401`HbT@HcTPHcTPHdTPLeTPLe
T`LfT`021cNC0PLhU0041cVD1cZD1cZD1c^E0PPlU@0723fE23jF23jF23nF
242F242G246G0088@YL00`Q3U`U3V0U4V0022DFH00@9AYT9AiT9AiT9B9T2
2DVJ00@9BYX:BiX:BiX:C9/22TfK00<:CY/:CY`:Ci`00PY@W0072U6M2U:M
2e:M2e>M2eBM2eBN2eFN008;EYh00`]GW`]HW`]HW`022eVO00@<FZ0<Fj0<
Fj0<G:0235fQ00L<GZ4<Gj4<Gj8<H:8<HJ8=HJ8=HZ800PeSX`033FBS3FFS
3FFT008=IZ@010eWY0eXY@eXY@iYY@8>JZD010i[YPi/YPi/YPi]YP8>KZL0
0`i_Y`i`Y`m`Z0023g6X00@?LZP?LjP?LjT?M:T23gFY00@?MZX?MjX?MjX@
N:X247V[00<@NZ/@Nj/@Nj/00Q1l[00447f/47j/47j]4Gn]0Q60[@074H6^
4H:^4H:^4H>^4HB^4HB_4HF_008AQZl24XN`00@BR;0BRK0BRK4BR[424X^a
00LBS;4BSK8BSK8BS[8CSk8CSk<CT;<00Q>A/`8CT[@011>C]1>D]1>D]1>E
]@8DU[D01aBG]ABH]QBH]QBI]QBJ]QBJ]aBK]`0259bg00<DWKLEWKPEW[P0
0QFO^0045J2i5J6i5J6i5J:i0QFS^P045JBj5ZFj5ZFj5ZJk0QJW^`035ZRk
5ZRl5ZVl008FZ[`01aJ[_AJ/_AN/_AN]_AN^_AN^_QN__P025k2n00@G/KlG
/[lG/[lG/kl26;C000C8h=R8`;R8`;R8`;P6000018S0^003B9280000b>3H
00:8`;P900000XS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd
`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000jKYo7ooonl
^=fISkkooooFdMgKg>cco_nVVlC^k_B5M[2CQK[ooolc@jD3002001400H3o
ool00X000h7oool018401H7oool01X;oool11h8128812H?oool12X<12h?o
ool00P4<Q00?oooo0@j50@j50Pn5oooo0Q250Q66oooo0Q:60Q>60QB7oooo
0QF70QJ7oooo00835hP010<HR0<IR0<IROooo`836hT02@<LR_ooo`<MRP@N
RP@ORoooo`@PR`@QRoooo`0212:<00Ooool498`498goool59Xgoool59hh0
0PDXSP04oooo1BZ>1BZ?1B^?0PD/S`86;I0010H^T0H_T0H_T@H`T@86<I40
1`HbT@HcTPHcTPHdTPLeTPLeT`LfT`021cNC0PLhU0041cVD1cZD1cZD1c^E
0PPlU@0723fE23jF23jF23nF242F242G246G0088@YL00`Q3U`U3V0U4V002
2DFH00@9AYT9AiT9AiT9B9T22DVJ00@9BYX:BiX:BiX:C9/22TfK00<:CY/:
CY`:Ci`00PY@W0072U6M2U:M2e:M2e>M2eBM2eBN2eFN008;EYh00`]GW`]H
W`]HW`022eVO00@<FZ0<Fj0<Fj0<G:0235fQ00L<GZ4<Gj4<Gj8<H:8<HJ8=
HJ8=HZ800PeSX`033FBS3FFS3FFT008=IZ@010eWY0eXY@eXY@iYY@8>JZD0
10i[YPi/YPi/YPi]YP8>KZL00`i_Y`i`Y`m`Z0023g6X00@?LZP?LjP?LjT?
M:T23gFY00@?MZX?MjX?MjX@N:X247V[00<@NZ/@Nj/@Nj/00Q1l[00447f/
47j/47j]4Gn]0Q60[@074H6^4H:^4H:^4H>^4HB^4HB_4HF_008AQZl24XN`
00@BR;0BRK0BRK4BR[424X^a00LBS;4BSK8BSK8BS[8CSk8CSk<CT;<00Q>A
/`8CT[@011>C]1>D]1>D]1>E]@8DU[D01aBG]ABH]QBH]QBI]QBJ]QBJ]aBK
]`0259bg00<DWKLEWKPEW[P00QFO^0045J2i5J6i5J6i5J:i0QFS^P045JBj
5ZFj5ZFj5ZJk0QJW^`035ZRk5ZRl5ZVl008FZ[`01aJ[_AJ/_AN/_AN]_AN^
_AN^_QN__P025k2n00@G/KlG/[lG/[lG/kl26;C000C8h=R8`;R8`;R8`;P6
000018S0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028
`;R8`;Q8T8P000000QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<0
08003i^WlOoooiV?_YN:_=CCj>n//omfNnjOZe]HYJJKa9JOdV1<V[bhgOoo
oc=3Y@02002001400H3oool00X000h7oool018401H7oool01X;oool11h81
28812H?oool12X<12h?oool00P4<Q00?oooo0@j50@j50Pn5oooo0Q250Q66
oooo0Q:60Q>60QB7oooo0QF70QJ7oooo00835hP010<HR0<IR0<IROooo`83
6hT02@<LR_ooo`<MRP@NRP@ORoooo`@PR`@QRoooo`0212:<00Ooool498`4
98goool59Xgoool59hh00PDXSP041BV>1BZ>1BZ?1B^?0PD/S`86;I0010H^
T0H_T0H_T@H`T@86<I401`HbT@HcTPHcTPHdTPLeTPLeT`LfT`021cNC0PLh
U0041cVD1cZD1cZD1c^E0PPlU@0723fE23jF23jF23nF242F242G246G0088
@YL00`Q3U`U3V0U4V0022DFH00@9AYT9AiT9AiT9B9T22DVJ00@9BYX:BiX:
BiX:C9/22TfK00<:CY/:CY`:Ci`00PY@W0072U6M2U:M2e:M2e>M2eBM2eBN
2eFN008;EYh00`]GW`]HW`]HW`022eVO00@<FZ0<Fj0<Fj0<G:0235fQ00L<
GZ4<Gj4<Gj8<H:8<HJ8=HJ8=HZ800PeSX`033FBS3FFS3FFT008=IZ@010eW
Y0eXY@eXY@iYY@8>JZD010i[YPi/YPi/YPi]YP8>KZL00`i_Y`i`Y`m`Z002
3g6X00@?LZP?LjP?LjT?M:T23gFY00@?MZX?MjX?MjX@N:X247V[00<@NZ/@
Nj/@Nj/00Q1l[00447f/47j/47j]4Gn]0Q60[@074H6^4H:^4H:^4H>^4HB^
4HB_4HF_008AQZl24XN`00@BR;0BRK0BRK4BR[424X^a00LBS;4BSK8BSK8B
S[8CSk8CSk<CT;<00Q>A/`8CT[@011>C]1>D]1>D]1>E]@8DU[D01aBG]ABH
]QBH]QBI]QBJ]QBJ]aBK]`0259bg00<DWKLEWKPEW[P00QFO^0045J2i5J6i
5J6i5J:i0QFS^P045JBj5ZFj5ZFj5ZJk0QJW^`035ZRk5ZRl5ZVl008FZ[`0
1aJ[_AJ/_AN/_AN]_AN^_AN^_QN__P025k2n00@G/KlG/[lG/[lG/kl26;C0
00?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005
R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8`;P20000
0XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOXZFjPb<?OThFjFdJCVHnn
0WQU[P04@RN5[jG:oooo<d>U0P00P00:0060oooo00:0oooo00>1oooo00F1
oooo00J200N21?ooo`030@Z30@^3oooo008138@01oooo`4>Q@4>Q@8?QOoo
o`8@Q@8AQP020Q:600H24hH258Ooool25HL25XOoool20aN800@368P36HP3
6HWoool20a^900<378X37H[oool00oooo`03122;126;oooo00848X`01Ooo
o`@TS0@TSOooo`DVS@05oooo00<5:Xh5:Xl5:hl00PD/S`86;I0010H^T0H_
T0H_T@H`T@86<I401`HbT@HcTPHcTPHdTPLeTPLeT`LfT`021cNC0PLhU004
1cVD1cZD1cZD1c^E0PPlU@0723fE23jF23jF23nF242F242G246G0088@YL0
0`Q3U`U3V0U4V0022DFH00@9AYT9AiT9AiT9B9T22DVJ00@9BYX:BiX:BiX:
C9/22TfK00<:CY/:CY`:Ci`00PY@W0072U6M2U:M2e:M2e>M2eBM2eBN2eFN
008;EYh00`]GW`]HW`]HW`022eVO00@<FZ0<Fj0<Fj0<G:0235fQ00L<GZ4<
Gj4<Gj8<H:8<HJ8=HJ8=HZ800PeSX`033FBS3FFS3FFT008=IZ@010eWY0eX
Y@eXY@iYY@8>JZD010i[YPi/YPi/YPi]YP8>KZL00`i_Y`i`Y`m`Z0023g6X
00@?LZP?LjP?LjT?M:T23gFY00@?MZX?MjX?MjX@N:X247V[00<@NZ/@Nj/@
Nj/00Q1l[00447f/47j/47j]4Gn]0Q60[@074H6^4H:^4H:^4H>^4HB^4HB_
4HF_008AQZl24XN`00@BR;0BRK0BRK4BR[424X^a00LBS;4BSK8BSK8BS[8C
Sk8CSk<CT;<00Q>A/`8CT[@011>C]1>D]1>D]1>E]@8DU[D01aBG]ABH]QBH
]QBI]QBJ]QBJ]aBK]`0259bg00<DWKLEWKPEW[P00QFO^0045J2i5J6i5J6i
5J:i0QFS^P045JBj5ZFj5ZFj5ZJk0QJW^`035ZRk5ZRl5ZVl008FZ[`01aJ[
_AJ/_AN/_AN]_AN^_AN^_QN__P025k2n00@G/KlG/[lG/[lG/kl26;C000?8
h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h
00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8`;P4000018S0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08000i^WlOooooooo`02oooo00[o[K3oMW_icMCmkNkooonVVlB5M[2l^=go
oolc@jD3002001400H3oool00X3oool00h7oool01H7oool01X801h811h81
28812H?oool12X<12h?oool00P4<Q0;oool01@4>Q@8?QOooo`8@Q@8AQP02
0Q:600D24hH258Ooool25HL25XL01?ooo`060aV80aV9oooooooo0a^90ab:
0P<MRP0511j:11n;oooo122;126;00;oool020@RS?ooooooo`@TSOooo`DV
SOooo`DWSP85:8h01?ooo`DZSPDZS`D[S`85;8l21Rf@00@6;Y06;i06;i46
<9421S6A00L6<Y46<i86<i86=987=I87=I<7=Y<00PLgT`87>9@010LiU0Lj
U0LjU0LkU@88?9D01`PmU@PnUPPnUPPoUPQ0UPQ0U`Q1U`0224:G00<8@iL9
@iP9A9P00PU5V0042DJI2DNI2DNI2DRI0PU9VP042DZJ2T^J2T^J2TbK0PY=
V`032TjK2TjL2TnL008:D9`01`YAW@YBW@]BW@]CW@]DW@]DWP]EWP022eJN
00<;Eil;F9l;F9l00P]IW`0435ZP35^P35^P35bP0PaMX@0735jQ35nQ35nR
362R366R3F6R3F:R008=Hj<00`eTX`eUX`eUY0023FJT00@=Ij@=J:D=J:D>
JJD23VZU00@>JjH>K:H>K:H>KJH23VjW00<>KjL>L:L?L:P00PmaZ0043g:X
3g>X3g>Y3gBY0PmeZ@043gJZ3gNZ3gNZ47RZ0Q1iZ`0347Z[47^[47^[008@
O:`0111m[11n[11n[A5o[@8AP:d01a61[Q62[Q62[Q63[Q64[Q64[a65[`02
4HJ_0Q:7/0044XR`4XV`4XVa4XZa0Q:;/@074Xba4Xfb4Xfb4Xjb4hnb4hnc
4i2c008CTK<24i:d00@CTk@CU;@CU;@CUKD259Je00LDUkDDV;HDV;HDVKHD
V[HDV[LDVkL00QBL]`0359fg5Ifh5Ijh008EWkP011FP^AFQ^AFQ^AFR^@8E
XkX011FT^QJU^QJU^QJV^`8FYk/00aJX^aJX_1JY_0025ZZl00LFZkdF[;dG
[;dG[KdG[[dG[[hG[kh00QN`_P045k6o5k:o5k:o5k>o0QRd`003b>3HR<2h
R<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000
R<2hR<2hB9280000008H]<000lSPf8S0^8S0^004R<2h0P0000F8`;P014R@
R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000ZQ
[?;icMCR9Scd]KoR9ScdKGglhnWoooomkNko[K02oooo00<c@jD008000800
0P00P00:0060oooo00:0oooo00>1oooo00F1oooo00J200N20oooo`030@V3
0@Z3oooo00;oool00`4<Q?ooo`4>Q@02oooo0P8@Q@090Q660Q:60Q:60Q>6
0QB7oooo0QF70QJ7oooo00835hP020<HR0<IR0<IROooo`<KROooo`<LRP<M
RP?oool01@@OR`@PR`@QRoooo`@RS002oooo00<498coool59Hd00PDVS@?o
ool010DYSPDZSPDZS`D[S`85;8l21Rf@00@6;Y06;i06;i46<9421S6A00L6
<Y46<i86<i86=987=I87=I<7=Y<00PLgT`87>9@010LiU0LjU0LjU0LkU@88
?9D01`PmU@PnUPPnUPPoUPQ0UPQ0U`Q1U`0224:G00<8@iL9@iP9A9P00PU5
V0042DJI2DNI2DNI2DRI0PU9VP042DZJ2T^J2T^J2TbK0PY=V`032TjK2TjL
2TnL008:D9`01`YAW@YBW@]BW@]CW@]DW@]DWP]EWP022eJN00<;Eil;F9l;
F9l00P]IW`0435ZP35^P35^P35bP0PaMX@0735jQ35nQ35nR362R366R3F6R
3F:R008=Hj<00`eTX`eUX`eUY0023FJT00@=Ij@=J:D=J:D>JJD23VZU00@>
JjH>K:H>K:H>KJH23VjW00<>KjL>L:L?L:P00PmaZ0043g:X3g>X3g>Y3gBY
0PmeZ@043gJZ3gNZ3gNZ47RZ0Q1iZ`0347Z[47^[47^[008@O:`0111m[11n
[11n[A5o[@8AP:d01a61[Q62[Q62[Q63[Q64[Q64[a65[`024HJ_0Q:7/004
4XR`4XV`4XVa4XZa0Q:;/@074Xba4Xfb4Xfb4Xjb4hnb4hnc4i2c008CTK<2
4i:d00@CTk@CU;@CU;@CUKD259Je00LDUkDDV;HDV;HDVKHDV[HDV[LDVkL0
0QBL]`0359fg5Ifh5Ijh008EWkP011FP^AFQ^AFQ^AFR^@8EXkX011FT^QJU
^QJU^QJV^`8FYk/00aJX^aJX_1JY_0025ZZl00LFZkdF[;dG[;dG[KdG[[dG
[[hG[kh00QN`_P045k6o5k:o5k:o5k>o0QRd`003b>3HR<2hR<2h00^8`;P0
0dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB928
0000008H]<000lSPf8S0^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000fKYo7mkNkR9Scn
mOSgRIOdHVkcX:kdHVkooOoo[K3lhnWooolc@jD01@00P0030060oooooooo
00800h401`04POooooooo`06PP07PP47PP48PP020@V300<12X<12h?oool0
0P4<Q004oooo0@j50@j50Pn50P8@Q@090Q660Q:60Q:60Q>60QB7oooo0QF7
0QJ7oooo00835hP010<HR0<IR0<IR@<JR@836hT010<LRP<MRP<MRP@NRP84
7h/00`@PR`@QR`@QR`0212:<00@48h`498`498d59Hd21BJ=00L59hh5:8h5
:8h5:Hh5:Xh5:Xl5:hl00PD/S`86;I0010H^T0H_T0H_T@H`T@86<I401`Hb
T@HcTPHcTPHdTPLeTPLeT`LfT`021cNC0PLhU0041cVD1cZD1cZD1c^E0PPl
U@0723fE23jF23jF23nF242F242G246G0088@YL00`Q3U`U3V0U4V0022DFH
00@9AYT9AiT9AiT9B9T22DVJ00@9BYX:BiX:BiX:C9/22TfK00<:CY/:CY`:
Ci`00PY@W0072U6M2U:M2e:M2e>M2eBM2eBN2eFN008;EYh00`]GW`]HW`]H
W`022eVO00@<FZ0<Fj0<Fj0<G:0235fQ00L<GZ4<Gj4<Gj8<H:8<HJ8=HJ8=
HZ800PeSX`033FBS3FFS3FFT008=IZ@010eWY0eXY@eXY@iYY@8>JZD010i[
YPi/YPi/YPi]YP8>KZL00`i_Y`i`Y`m`Z0023g6X00@?LZP?LjP?LjT?M:T2
3gFY00@?MZX?MjX?MjX@N:X247V[00<@NZ/@Nj/@Nj/00Q1l[00447f/47j/
47j]4Gn]0Q60[@074H6^4H:^4H:^4H>^4HB^4HB_4HF_008AQZl24XN`00@B
R;0BRK0BRK4BR[424X^a00LBS;4BSK8BSK8BS[8CSk8CSk<CT;<00Q>A/`8C
T[@011>C]1>D]1>D]1>E]@8DU[D01aBG]ABH]QBH]QBI]QBJ]QBJ]aBK]`02
59bg00<DWKLEWKPEW[P00QFO^0045J2i5J6i5J6i5J:i0QFS^P045JBj5ZFj
5ZFj5ZJk0QJW^`035ZRk5ZRl5ZVl008FZ[`01aJ[_AJ/_AN/_AN]_AN^_AN^
_QN__P025k2n00@G/KlG/[lG/[lG/kl26;C000?8h=R8`;R8`;P02hS0^003
B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P0
00000QRd`003b>3HR<2hR<2h00:8`;P200000XS0^0800003R<2h00A8T8P0
000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOa
m/S<hRHl00;o[K001mlT;_nTW_JlaOn]/>ikS?oooc=3Y@06002000<00H3o
ooooool00P03P@0700B1oooooooo00J200N20@N20@R200812H<00`4:P`4;
Poooo`020@b400Coool13XD13XD23hD20Q2500T24HH24XH24XH24hH258Oo
ool25HL25XOoool00P<GR0040aR80aV80aV90aZ90P<KR@040ab:0af:0af:
11j:0P@OR`03122;126;126;00848X`010@SS0@TS0@TS@DUS@859Xd01`DW
SPDXSPDXSPDYSPDZSPDZS`D[S`021Bb?0PH]T0041Rj@1Rn@1RnA1S2A0PHa
T@071S:A1S>B1S>B1SBB1cFB1cFC1cJC0087=i<21cRD00@7>I@7>Y@7>Y@7
>iD223bE00L8?ID8?YH8?YH8?iH8@9H8@9L8@IL00PQ2U`0324>G2D>H2DBH
0089AIP010U6V@U7V@U7V@U8V@89BIX010U:VPY;VPY;VPY<V`8:CI/00`Y>
V`Y>W0Y?W0022U2L00L:DId:DYd;DYd;Did;E9d;E9h;EIh00P]FWP032eNO
2eRO2eRO008;FIl010aJX0aKX0aKX0aLX08<GJ401`aNX@aOX@aOXPaPXPaQ
XPeQXPeRXP023F>S00<=I:<=IJ<=IJ@00PeVY0043FNT3FRU3FRU3VVU0PiZ
Y@043V^V3VbV3VbV3VfV0Pi^Y`033VnW3W2W3g2X008?LJP010mbZ0mcZ0mc
Z@mdZ@8?MJT010mfZPmgZPmgZQ1hZP8@NJ/00a1jZa1kZa1kZ`0247b/00@@
OJ`@OZ`@OZdAOjd24H2]00LAPJhAPZhAPZhAPjhAQ:hAQ:lAQJl00Q66[`8B
Qk0011:8/1:9/1:9/A::/@8BRk401a:</A:=/Q:=/Q:>/Q>?/Q>?/a>@/`02
4i6c0Q>B]0044i>d4iBd4iBd4iFe0QBF]@0759Ne59Rf59Rf59Vf59Zf59Zg
59^g008DW;L00aBM]aFM^1FN^0025Inh00@EX;TEXKTEXKTEX[T25J>j00@E
Y;XFYKXFYKXFY[/25ZNk00<FZ;/FZ;`FZK`00QJZ_0075Z^m5Zbm5jbm5jfm
5jjm5jjn5jnn008G/;h011Na_aNb_aNb_aNc_`8H]<000lSPf8S0^8S0^00;
R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P0
0hS0^0800004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000>KYo7icMCgRIL00_ooo`07ojf`hAHd
ogIkojBNhRHlohUo<d>U00H008000`01P?ooo`02P00200>100L018401H7o
ool01X801h811h8128800P49P`030@Z30@^30@^4008138@01?ooo`4>Q@4>
Q@8?Q@8248D0208AQP8BQP8BQP8CQP8DQoooo`8EQ`8FQ`Goool01@<IR@<J
R@<KR@<KR@<LRP020af:00@47XX47h/47h/488/2126;0P@RS00412><12B<
12B=1BF=0PDVS@071BN>1BR>1BR>1BV>1BZ>1BZ?1B^?0085;8l21Rf@00@6
;Y06;i06;i46<9421S6A00L6<Y46<i86<i86=987=I87=I<7=Y<00PLgT`87
>9@010LiU0LjU0LjU0LkU@88?9D01`PmU@PnUPPnUPPoUPQ0UPQ0U`Q1U`02
24:G00<8@iL9@iP9A9P00PU5V0042DJI2DNI2DNI2DRI0PU9VP042DZJ2T^J
2T^J2TbK0PY=V`032TjK2TjL2TnL008:D9`01`YAW@YBW@]BW@]CW@]DW@]D
WP]EWP022eJN00<;Eil;F9l;F9l00P]IW`0435ZP35^P35^P35bP0PaMX@07
35jQ35nQ35nR362R366R3F6R3F:R008=Hj<00`eTX`eUX`eUY0023FJT00@=
Ij@=J:D=J:D>JJD23VZU00@>JjH>K:H>K:H>KJH23VjW00<>KjL>L:L?L:P0
0PmaZ0043g:X3g>X3g>Y3gBY0PmeZ@043gJZ3gNZ3gNZ47RZ0Q1iZ`0347Z[
47^[47^[008@O:`0111m[11n[11n[A5o[@8AP:d01a61[Q62[Q62[Q63[Q64
[Q64[a65[`024HJ_0Q:7/0044XR`4XV`4XVa4XZa0Q:;/@074Xba4Xfb4Xfb
4Xjb4hnb4hnc4i2c008CTK<24i:d00@CTk@CU;@CU;@CUKD259Je00LDUkDD
V;HDV;HDVKHDV[HDV[LDVkL00QBL]`0359fg5Ifh5Ijh008EWkP011FP^AFQ
^AFQ^AFR^@8EXkX011FT^QJU^QJU^QJV^`8FYk/00aJX^aJX_1JY_0025ZZl
00LFZkdF[;dG[;dG[KdG[[dG[[hG[kh00QN`_P045k6o5k:o5k:o5k>o0QRd
`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@
R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0P00P007VjOaoooolj2^m69^oooomhVGnLgD00;o
ool00o>P[_oooc=3Y@0600200P01P00:00:000>100>100B100F100F200J2
00N20@N20@R20P49P`030@Z30@^30@^4008138@0104=Q04>Q@4>Q@8?Q@82
48D0108AQP8BQP8BQP8CQP8258L00`8EQ`8FQ`<FR0020aN800@368P36HP3
6HT36XT20a^900@378X37HX37HX47XX211n;00<488/48H/48H/00P@RS004
12><12B<12B=1BF=0PDVS@071BN>1BR>1BR>1BV>1BZ>1BZ?1B^?0085;8l2
1Rf@00@6;Y06;i06;i46<9421S6A00L6<Y46<i86<i86=987=I87=I<7=Y<0
0PLgT`87>9@010LiU0LjU0LjU0LkU@88?9D01`PmU@PnUPPnUPPoUPQ0UPQ0
U`Q1U`0224:G00<8@iL9@iP9A9P00PU5V0042DJI2DNI2DNI2DRI0PU9VP04
2DZJ2T^J2T^J2TbK0PY=V`032TjK2TjL2TnL008:D9`01`YAW@YBW@]BW@]C
W@]DW@]DWP]EWP022eJN00<;Eil;F9l;F9l00P]IW`0435ZP35^P35^P35bP
0PaMX@0735jQ35nQ35nR362R366R3F6R3F:R008=Hj<00`eTX`eUX`eUY002
3FJT00@=Ij@=J:D=J:D>JJD23VZU00@>JjH>K:H>K:H>KJH23VjW00<>KjL>
L:L?L:P00PmaZ0043g:X3g>X3g>Y3gBY0PmeZ@043gJZ3gNZ3gNZ47RZ0Q1i
Z`0347Z[47^[47^[008@O:`0111m[11n[11n[A5o[@8AP:d01a61[Q62[Q62
[Q63[Q64[Q64[a65[`024HJ_0Q:7/0044XR`4XV`4XVa4XZa0Q:;/@074Xba
4Xfb4Xfb4Xjb4hnb4hnc4i2c008CTK<24i:d00@CTk@CU;@CU;@CUKD259Je
00LDUkDDV;HDV;HDVKHDV[HDV[LDVkL00QBL]`0359fg5Ifh5Ijh008EWkP0
11FP^AFQ^AFQ^AFR^@8EXkX011FT^QJU^QJU^QJV^`8FYk/00aJX^aJX_1JY
_0025ZZl00LFZkdF[;dG[;dG[KdG[[dG[[hG[kh00QN`_P045k6o5k:o5k:o
5k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf00=R<2h00E8T8P0
000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0<008002i^WlOoooon9Oooooo>P[_6CXOooooomoo>P
[_oko3=3Y@0600200P01P00:00:000>100>100B100F100F200J200N20@N2
0@R20P49P`030@Z30@^30@^4008138@0104=Q04>Q@4>Q@8?Q@8248D0108A
QP8BQP8BQP8CQP8258L00`8EQ`8FQ`<FR0020aN800@368P36HP36HT36XT2
0a^900@378X37HX37HX47XX211n;00<488/48H/48H/00P@RS00412><12B<
12B=1BF=0PDVS@071BN>1BR>1BR>1BV>1BZ>1BZ?1B^?0085;8l21Rf@00@6
;Y06;i06;i46<9421S6A00L6<Y46<i86<i86=987=I87=I<7=Y<00PLgT`87
>9@010LiU0LjU0LjU0LkU@88?9D01`PmU@PnUPPnUPPoUPQ0UPQ0U`Q1U`02
24:G00<8@iL9@iP9A9P00PU5V0042DJI2DNI2DNI2DRI0PU9VP042DZJ2T^J
2T^J2TbK0PY=V`032TjK2TjL2TnL008:D9`01`YAW@YBW@]BW@]CW@]DW@]D
WP]EWP022eJN00<;Eil;F9l;F9l00P]IW`0435ZP35^P35^P35bP0PaMX@07
35jQ35nQ35nR362R366R3F6R3F:R008=Hj<00`eTX`eUX`eUY0023FJT00@=
Ij@=J:D=J:D>JJD23VZU00@>JjH>K:H>K:H>KJH23VjW00<>KjL>L:L?L:P0
0PmaZ0043g:X3g>X3g>Y3gBY0PmeZ@043gJZ3gNZ3gNZ47RZ0Q1iZ`0347Z[
47^[47^[008@O:`0111m[11n[11n[A5o[@8AP:d01a61[Q62[Q62[Q63[Q64
[Q64[a65[`024HJ_0Q:7/0044XR`4XV`4XVa4XZa0Q:;/@074Xba4Xfb4Xfb
4Xjb4hnb4hnc4i2c008CTK<24i:d00@CTk@CU;@CU;@CUKD259Je00LDUkDD
V;HDV;HDVKHDV[HDV[LDVkL00QBL]`0359fg5Ifh5Ijh008EWkP011FP^AFQ
^AFQ^AFR^@8EXkX011FT^QJU^QJU^QJV^`8FYk/00aJX^aJX_1JY_0025ZZl
00LFZkdF[;dG[;dG[KdG[[dG[[hG[kh00QN`_P045k6o5k:o5k:o5k>o0QRd
`0o8h=P00`000<SPf<SPf00=b>3H00<0000H]<0H]<003lSPf00300006;C0
6;C000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P400200i^Wl@06oooo
lj2^m;Fom[c5nmWJ<d>U1`00P0800H002P02P003P@03P@04P@05P@05PP06
PP07PP47PP48PP812H<00`4:P`4;P`4;Q0020@b400@13H@13XD13XD23hD2
0Q2500@24HH24XH24XH24hH20QB700<25HL25XL35XP00P<GR0040aR80aV8
0aV90aZ90P<KR@040ab:0af:0af:11j:0P@OR`03122;126;126;00848X`0
10@SS0@TS0@TS@DUS@859Xd01`DWSPDXSPDXSPDYSPDZSPDZS`D[S`021Bb?
0PH]T0041Rj@1Rn@1RnA1S2A0PHaT@071S:A1S>B1S>B1SBB1cFB1cFC1cJC
0087=i<21cRD00@7>I@7>Y@7>Y@7>iD223bE00L8?ID8?YH8?YH8?iH8@9H8
@9L8@IL00PQ2U`0324>G2D>H2DBH0089AIP010U6V@U7V@U7V@U8V@89BIX0
10U:VPY;VPY;VPY<V`8:CI/00`Y>V`Y>W0Y?W0022U2L00L:DId:DYd;DYd;
Did;E9d;E9h;EIh00P]FWP032eNO2eRO2eRO008;FIl010aJX0aKX0aKX0aL
X08<GJ401`aNX@aOX@aOXPaPXPaQXPeQXPeRXP023F>S00<=I:<=IJ<=IJ@0
0PeVY0043FNT3FRU3FRU3VVU0PiZY@043V^V3VbV3VbV3VfV0Pi^Y`033VnW
3W2W3g2X008?LJP010mbZ0mcZ0mcZ@mdZ@8?MJT010mfZPmgZPmgZQ1hZP8@
NJ/00a1jZa1kZa1kZ`0247b/00@@OJ`@OZ`@OZdAOjd24H2]00LAPJhAPZhA
PZhAPjhAQ:hAQ:lAQJl00Q66[`8BQk0011:8/1:9/1:9/A::/@8BRk401a:<
/A:=/Q:=/Q:>/Q>?/Q>?/a>@/`024i6c0Q>B]0044i>d4iBd4iBd4iFe0QBF
]@0759Ne59Rf59Rf59Vf59Zf59Zg59^g008DW;L00aBM]aFM^1FN^0025Inh
00@EX;TEXKTEXKTEX[T25J>j00@EY;XFYKXFYKXFY[/25ZNk00<FZ;/FZ;`F
ZK`00QJZ_0075Z^m5Zbm5jbm5jfm5jjm5jjn5jnn008G/;h011Na_aNb_aNb
_aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h5000P0800H00
2P02P003P@03P@04P@05P@05PP06PP07PP47PP48PP812H<00`4:P`4;P`4;
Q0020@b400@13H@13XD13XD23hD20Q2500@24HH24XH24XH24hH20QB700<2
5HL25XL35XP00P<GR0040aR80aV80aV90aZ90P<KR@040ab:0af:0af:11j:
0P@OR`03122;126;126;00848X`010@SS0@TS0@TS@DUS@859Xd01`DWSPDX
SPDXSPDYSPDZSPDZS`D[S`021Bb?0PH]T0041Rj@1Rn@1RnA1S2A0PHaT@07
1S:A1S>B1S>B1SBB1cFB1cFC1cJC0087=i<21cRD00@7>I@7>Y@7>Y@7>iD2
23bE00L8?ID8?YH8?YH8?iH8@9H8@9L8@IL00PQ2U`0324>G2D>H2DBH0089
AIP010U6V@U7V@U7V@U8V@89BIX010U:VPY;VPY;VPY<V`8:CI/00`Y>V`Y>
W0Y?W0022U2L00L:DId:DYd;DYd;Did;E9d;E9h;EIh00P]FWP032eNO2eRO
2eRO008;FIl010aJX0aKX0aKX0aLX08<GJ401`aNX@aOX@aOXPaPXPaQXPeQ
XPeRXP023F>S00<=I:<=IJ<=IJ@00PeVY0043FNT3FRU3FRU3VVU0PiZY@04
3V^V3VbV3VbV3VfV0Pi^Y`033VnW3W2W3g2X008?LJP010mbZ0mcZ0mcZ@md
Z@8?MJT010mfZPmgZPmgZQ1hZP8@NJ/00a1jZa1kZa1kZ`0247b/00@@OJ`@
OZ`@OZdAOjd24H2]00LAPJhAPZhAPZhAPjhAQ:hAQ:lAQJl00Q66[`8BQk00
11:8/1:9/1:9/A::/@8BRk401a:</A:=/Q:=/Q:>/Q>?/Q>?/a>@/`024i6c
0Q>B]0044i>d4iBd4iBd4iFe0QBF]@0759Ne59Rf59Rf59Vf59Zf59Zg59^g
008DW;L00aBM]aFM^1FN^0025Inh00@EX;TEXKTEXKTEX[T25J>j00@EY;XF
YKXFYKXFY[/25ZNk00<FZ;/FZ;`FZK`00QJZ_0075Z^m5Zbm5jbm5jfm5jjm
5jjn5jnn008G/;h011Na_aNb_aNb_aNc_cHH]<02R<2h0DR@R04000000003
R<2hb>3HR<2h0?n8`;QRR<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;QR
R<2h0DR@R04000000003R<2hb>3Hb>3H0?o8h=QRb>3H0DR@R04000000?n8
`;QVR<2h0@000000\
\>"], "Graphics",
  ImageSize->{358, 341},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004/0000b2000`400?l0
0000o`00003oooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000
ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`
l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]
oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`
l?0]oo3`l000>?mn[MWdooooo`00>?mn[MWdonk^kP000_mn[MTdonKViP;o
OZgIm?oVi^H000;oOZgI1Oo^k^h01Onc/k?oRHV9ogUiNOnPX:3ob/[:02[o
k^k^0_mn[MWdonk^kP000_mn[MT4ooooo`07okRh^?mNGUkoL71`ohF5QOnH
V9SoXj>SomkNgP0Yooooo`;oOZgIm?ooool000;oOZgI1?o^k^h01omgMgOo
IFEUoh61POnIVIWoXj>Sojn_[oo6a/H04oo^k^h00ooTi>CofMWIonk^kP0C
onk^kP;oOZgIm?o^k^h000;oOZgI1?oVi^H01om@D53oJVYZohJ6Q_nOWioo
/K6aokbl_?o1`L404_oVi^H01?nMWIgo6a/Koc4a<OmJFUXConKViP;oOZgI
m?oVi^H000;oOZgI1?o^k^h01omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9
bLT04_o^k^h01Ol[:b_ofm_Konc/k?ln?Skob<S801;ok^k^0_mn[MWdonk^
kP000_mn[MT4ooooo`07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9b@0A
ooooo`06onWYjOlY:BWooooooooooomlO7coUiNG4_ooool2ogj]fOCooooo
0002ogj]f@Cok^k^00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW9017o
k^k^00KoYjNWodI6A_o^k^kok^k^oiFEUOmHF5PBonk^kP;oOZgIm?o^k^h0
00;oOZgI1?oVi^H01omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02OoV
i^H5ogMgM`?ol?3`00KoaLG5obd];OoVi^Koi^KVogYjN_miNGTBonKViP;o
OZgIm?oVi^H000;oOZgI1?o^k^h01omDE5CoLG5aoi2@T?nWYjOo^;Rhol30
`?o9bLT02Oo^k^h8oo3`l006onk^k_lS8b?ok>c/onk^k_mEEEGo^[Zj4_o^
k^h2ogj]fOCok^k^0002ogj]f@Cooooo00OoE5ADog5aLOn@T93oYjNWokRh
^?o0`<3obLW900Wooooo2?o`l?001_ooooooQHF5ocdm?Om`L73o>3Phoo_k
na;ooooo0_mn[MWdooooo`000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNW
Yonh^;So`<30olW9b@09onk^kP?oMgMg1Oo`l?02onk^kP03okJf]_nSXj?o
hn?S01?ok^k^0_mn[MWdonk^kP000_mn[MT4onKViP07oeADE?maLG7oT92@
ojNWYonh^;So`<30olW9b@09onKViPSol?3`6?oVi^H2ogj]fOCoi^KV0002
ogj]f@Cok^k^00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wok^k^
2?o`l?0Honk^kP;oOZgIm?o^k^h000;oOZgI1?ooool01omDE5CoLG5aoi2@
T?nWYjOo^;Rhol30`?o9bLT02Oooool3ogMgM`Gol?3`6?ooool2ogj]fOCo
oooo0002ogj]f@Cok^k^00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW9
00Wok^k^2?o`l?0Honk^kP;oOZgIm?o^k^h000;oOZgI1?oVi^H01omDE5Co
LG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02OoVi^H8oo3`l1Soi^KV0_mn[MWd
onKViP000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9
b@09onk^kP?oMgMg1Oo`l?08onk^kP03onCTi?oIfMWok^k^00gok^k^0_mn
[MWdonk^kP000_mn[MT4ooooo`07oeADE?maLG7oT92@ojNWYonh^;So`<30
olW9b@09ooooo`Sol?3`00_oooooojBTY?m3@d?o1PH6odI6A_nm_Kgooooo
ojn_[olO7aoo=cLgofATI00=ooooo`;oOZgIm?ooool000;oOZgI1?o^k^h0
1omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02Oo^k^h3ogMgM`Gol?3`
0_o^k^h00ooRh^;o4a<Conk^kP02onk^kP05ob/[:ooKfm_ok>c/ochn?_o8
b<P03?o^k^h2ogj]fOCok^k^0002ogj]f@Coi^KV00OoE5ADog5aLOn@T93o
YjNWokRh^?o0`<3obLW900Woi^KV2?o`l?02onKViP06om_KfolB4Q;oi^KV
onKVi_oBd];o92@T0_oVi^H00om_KfooR8R8onKViP0;onKViP;oOZgIm?oV
i^H000;oOZgI1?o^k^h01omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9bLT0
2Oo^k^h8oo3`l0;ok^k^00Koh^;Roa<C4oo^k^kok^k^ojNWYom6ATH2onk^
kP03oiFEUOmHF5Sok^k^00_ok^k^0_mn[MWdonk^kP000_mn[MT4ooooo`07
oeADE?maLG7oT92@ojNWYonh^;So`<30olW9b@09ooooo`GoMgMg0oo`l?02
ooooo`06oo?clolE5AGooooooooooooKfm_o<S8b0_ooool00on8R8SoQhN7
ooooo`0;ooooo`;oOZgIm?ooool000;oOZgI1?o^k^h01omDE5CoLG5aoi2@
T?nWYjOo^;Rhol30`?o9bLT02Oo^k^h8oo3`l0;ok^k^00?oh^;Roa<C4oo^
k^h00_o^k^h01OlS8b?ok>c/onk^k_mEEEGo^[Zj00cok^k^0_mn[MWdonk^
kP000_mn[MT4onKViP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9b@09
onKViPSol?3`00Coi^KVoi6ATOm5ADGo4Q8B0ooVi^H01OmgMgOo=cLgofEU
IOlb<S;oh^;R00coi^KV0_mn[MWdonKViP000_mn[MT4onk^kP07oeADE?ma
LG7oT92@ojNWYonh^;So`<30olW9b@09onk^kP?oMgMg1Oo`l?02onk^kP03
omoOgon^[Zkok^k^00?ok^k^00?o][Jfoj>SXooShn<03Oo^k^h2ogj]fOCo
k^k^0002ogj]f@Cooooo00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW9
00Wooooo2?o`l?0Hooooo`;oOZgIm?ooool000;oOZgI1?o^k^h01omDE5Co
LG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02Oo^k^h8oo3`l1Sok^k^0_mn[MWd
onk^kP000_mn[MT4onKViP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9
b@09onKViP?oMgMg1Oo`l?0HonKViP;oOZgIm?oVi^H000;oOZgI1?o^k^h0
1omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02Oo^k^h8oo3`l1Sok^k^
0_mn[MWdonk^kP000_mn[MT4ooooo`07oeADE?maLG7oT92@ojNWYonh^;So
`<30olW9b@09ooooo`Sol?3`6?ooool2ogj]fOCooooo0002ogj]f@Cok^k^
00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wok^k^0omgMgL5oo3`
l0Sok^k^00?oi>CTomWIfOo^k^h03Oo^k^h2ogj]fOCok^k^0002ogj]f@Co
i^KV00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Woi^KV2?o`l?00
0oo1`L7o0000ob8R8P02ob<S8`06olc<c?oVi^KoWIfMoa/K6ola<C7oFUYJ
3OoVi^H2ogj]fOCoi^KV0002ogj]f@Cok^k^00OoE5ADog5aLOn@T93oYjNW
okRh^?o0`<3obLW900Wok^k^2?o`l?000oo]kNgo>CTiojBTY004onk^kP05
ob/[:ooKfm_ok>c/ochn?_o8b<P03?o^k^h2ogj]fOCok^k^0002ogj]f@Co
oooo00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wooooo0omgMgL5
oo3`l004oooooooYjNWo>3Pholg=c@;ooooo00KojNWYobTY:Ooooooooooo
ogalO?nGUiL<ooooo`;oOZgIm?ooool000;oOZgI1?o^k^h01omDE5CoLG5a
oi2@T?nWYjOo^;Rhol30`?o9bLT02Oo^k^h8oo3`l0;ok^k^00Kof=SHoc@d
=?no_kook^k^ojNWYom6ATH2onk^kP03oiFEUOmHF5Sok^k^00_ok^k^0_mn
[MWdonk^kP000_mn[MT4onKViP07oeADE?maLG7oT92@ojNWYonh^;So`<30
olW9b@09onKViPGoMgMg0oo`l?03onKViP05ol71`OlI6AWoiNGUolG5aOl]
;Bd00_oVi^H00omjNW[oNGUionKViP0;onKViP;oOZgIm?oVi^H000;oOZgI
1?o^k^h01omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02Oo^k^h8oo3`
l0?ok^k^00Wok>c/oa0@4?oLg=cok^k^ob<S8oo/k>cok^k^oeEEEOnj^[X0
3?o^k^h2ogj]fOCok^k^0002ogj]f@Cooooo00OoE5ADog5aLOn@T93oYjNW
okRh^?o0`<3obLW900Wooooo2?o`l?001OooooooAdM7oi>CTomTI6CoDU9B
00;ooooo00GoQHF5ocdm?Om`L73o>3Phoo_kn`0<ooooo`;oOZgIm?ooool0
00;oOZgI1?o^k^h01omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02Oo^
k^h3ogMgM`Gol?3`00Cok^k^omcLg?nUYJGo^k^k1?o^k^h00onf][KoXj>S
on?Sh`0=onk^kP;oOZgIm?o^k^h000;oOZgI1?oVi^H01omDE5CoLG5aoi2@
T?nWYjOo^;Rhol30`?o9bLT02OoVi^H8oo3`l1Soi^KV0_mn[MWdonKViP00
0_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9b@09onk^
kPSol?3`6?o^k^h2ogj]fOCok^k^0002ogj]f@Cooooo00OoE5ADog5aLOn@
T93oYjNWokRh^?o0`<3obLW900Wooooo0omgMgL5oo3`l1Sooooo0_mn[MWd
ooooo`000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9
b@09onk^kPSol?3`6?o^k^h2ogj]fOCok^k^0002ogj]f@Coi^KV00OoE5AD
og5aLOn@T93oYjNWokRh^?o0`<3obLW900Woi^KV2?o`l?0HonKViP;oOZgI
m?oVi^H000;oOZgI1?o^k^h01omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9
bLT02Oo^k^h3ogMgM`Gol?3`6?o^k^h2ogj]fOCok^k^0002ogj]f@Cooooo
00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wooooo2?o`l?001?oo
oooonOWiomkNg_olo?`4ooooo`03ooGemOoYjNWooooo00gooooo0_mn[MWd
ooooo`000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9
b@09onk^kPSol?3`00Gok^k^obh^;_mKFe_o=SHfoh20P002onk^kP04oj>S
XolL71co<c<coeeMG@gok^k^0_mn[MWdonk^kP000_mn[MT4onKViP07oeAD
E?maLG7oT92@ojNWYonh^;So`<30olW9b@09onKViP?oMgMg1Oo`l?03onKV
iP09om[Jf_lE5AGof=SHonKVi_lZ:R[odm?ConCTi?ll?3co`L7100coi^KV
0_mn[MWdonKViP000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh^;So
`<30olW9b@09onk^kPSol?3`0oo^k^h01OoKfm_o3Ph>omgMgOoIfMWo9RHV
00;ok^k^00?oLg=cohb<S?o^k^h02oo^k^h2ogj]fOCok^k^0002ogj]f@Co
oooo00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wooooo2?o`l?00
2?oooooof=SHofQXJ?m0@43oY:BToooooonc/k?oC4a<0_ooool00onPX:3o
GemOooooo`0;ooooo`;oOZgIm?ooool000;oOZgI1?o^k^h01omDE5CoLG5a
oi2@T?nWYjOo^;Rhol30`?o9bLT02Oo^k^h5ogMgM`?ol?3`00Sok^k^on7Q
hOn[Zj_oG5aLoiRHV?o^k^koc<c<obh^;P;ok^k^0_mnOWh<onk^kP;oOZgI
m?o^k^h000;oOZgI1?oVi^H01omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9
bLT02OoVi^H8oo3`l0?oi^KV00WodM7Aoa/K6ooVi^Koi^KVob8R8_oTi>Co
i^KVoe9BD_nd];@03?oVi^H2ogj]fOCoi^KV0002ogj]f@Cok^k^00OoE5AD
og5aLOn@T93oYjNWokRh^?o0`<3obLW900Wok^k^0omgMgL5oo3`l005onk^
k_m^KVkoT92@oe]KFomFEUH00_o^k^h01OmlO7co>3PhofQXJ?ld=3Coj^[Z
00cok^k^0_mn[MWdonk^kP000_mn[MT4ooooo`07oeADE?maLG7oT92@ojNW
Yonh^;So`<30olW9b@09ooooo`Sol?3`00Goooooom?CdonVYZKob<S8oocl
o003ooooo`03olC4a?n_[joom?Cd00gooooo0_mn[MWdooooo`000_mn[MT4
onk^kP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9b@09onk^kPSol?3`
6?o^k^h2ogj]fOCok^k^0002ogj]f@Coi^KV00OoE5ADog5aLOn@T93oYjNW
okRh^?o0`<3obLW900Woi^KV0omgMgL5oo3`l1Soi^KV0_mn[MWdonKViP00
0_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9b@09onk^
kPSol?3`6?o^k^h2ogj]fOCok^k^0002ogj]f@Cooooo00OoE5ADog5aLOn@
T93oYjNWokRh^?o0`<3obLW900Wooooo2?o`l?0Hooooo`;oOZgIm?ooool0
00;oOZgI1?o^k^h01omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02Oo^
k^h3ogMgM`Gol?3`6?o^k^h2ogj]fOCok^k^0002ogj]f@Coi^KV00OoE5AD
og5aLOn@T93oYjNWokRh^?o0`<3obLW900Woi^KV2?o`l?08onKViP03omcL
g?oBd];oi^KV00goi^KV0_mn[MWdonKViP000_mn[MT4onk^kP07oeADE?ma
LG7oT92@ojNWYonh^;So`<30olW9b@09onk^kPSol?3`0oo^k^h02?nf][Ko
Cdm?onk^k_o^k^koXj>Soa`L7?lc<c?oGEeM3Oo^k^h2ogj]fOCok^k^0002
ogj]f@Cooooo00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wooooo
0omgMgL5oo3`l0?ooooo00Wo`l?3oeEEEOooooooooooobl_;oo[jn_ooOgm
od=3@ooGemL03?ooool2ogj]fOCooooo0002ogj]f@Cok^k^00OoE5ADog5a
LOn@T93oYjNWokRh^?o0`<3obLW900Wok^k^2?o`l?002?n3Ph?o7AdMoc8b
<_lY:BWo410@ogMgMooIfMWo9RHV0_o^k^h00omcLg?oS8b<onk^kP0;onk^
kP;oOZgIm?o^k^h000;oOZgI1?oVi^H01omDE5CoLG5aoi2@T?nWYjOo^;Rh
ol30`?o9bLT02OoVi^H8oo3`l008omGEeOle=CGoe]KFokno_om<C4coi^KV
oj6QXOm4A4@2onKViP03oi2@T?mEEEGoi^KV00_oi^KV0_mn[MWdonKViP00
0_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9b@09onk^
kPGoMgMg0oo`l?002?o^k^ko]KFeodi>C_o4a<CoCdm?onk^k_o<c<co;Rh^
0_o^k^h2oginOPcok^k^0_mn[MWdonk^kP000_mn[MT4ooooo`07oeADE?ma
LG7oT92@ojNWYonh^;So`<30olW9b@09ooooo`Sol?3`0_ooool00on0P83o
IfMWoeEEE@02ooooo`05obHV9_omoOgooooooeaLG?o8b<P03?ooool2ogj]
fOCooooo0002ogj]f@Cok^k^00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3o
bLW900Wok^k^2?o`l?02onk^kP03on_[jolj>S[oCTi>00;ok^k^00GoO7al
ocPh>?mXJ6So=3@don[ZjP0<onk^kP;oOZgIm?o^k^h000;oOZgI1?oVi^H0
1omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02OoVi^H3ogMgM`Gol?3`
0ooVi^H00ooEeMGo`l?3onKViP02onKViP03ok2`/?nMWIgog=cL00goi^KV
0_mn[MWdonKViP000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh^;So
`<30olW9b@09onk^kPSol?3`6?o^k^h2ogj]fOCok^k^0002ogj]f@Cooooo
00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wooooo0omgMgL5oo3`
l1Sooooo0_mn[MWdooooo`000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNW
Yonh^;So`<30olW9b@09onk^kPSol?3`6?o^k^h2ogj]fOCok^k^0002ogj]
f@Coi^KV00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Woi^KV2?o`
l?0HonKViP;oOZgIm?oVi^H000;oOZgI1?o^k^h01omDE5CoLG5aoi2@T?nW
YjOo^;Rhol30`?o9bLT02Oo^k^h3ogMgM`Gol?3`6?o^k^h2ogj]fOCok^k^
0002ogj]f@Cooooo00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wo
oooo2?o`l?000oooooool?3`on3Ph005ooooo`03ooGemOoYjNWooooo00go
oooo0_mn[MT3ooooo`03ooCdm?oOgmoooooo00Gooooo00?ojNWYomoOgooo
ool0i_ooool000;oOZgI1?o^k^h01omDE5CoLG5aoi2@T?nWYjOo^;Rhol30
`?o9bLT02Oo^k^h8oo3`l005onk^k_mRHV;oG5aLoc`l??nJVYX00_o^k^h0
1?nSXj?o71`Loc<c<omMGEd=onk^kP;oOZgI00Ook^k^om7AdOm7AdOo51@D
obh^;_l[:b_oT92@00;ok^k^00Kok>c/oe]KFolL71co:BTYocHf=_oNg]kU
onk^kP000_mn[MT4onKViP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9
b@09onKViP?oMgMg1Oo`l?03onKViP09ol_;bolL71cohn?SonKVi_lZ:R[o
dm?ConCTi?ll?3co`L7100coi^KV0_mn[MT03ooVi^KoB4Q8oc0`<?oMgMgo
i^KVojf][Ol0003o_;blonKVi_n3Ph?o;Rh^on3Ph?oVi^KoEeMGodi>CP3U
onKViP000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9
b@09onk^kPSol?3`0oo^k^h01OoGemOo6ATIonOWiooIfMWo9RHV00;ok^k^
00?oLg=cohb<S?o^k^h02oo^k^h2ogj]f@03onk^k_l`<33oPH6100;ok^k^
00KoinOWo`P82?nOWiook^k^ob@T9?n<S8`2onk^kP03ol71`Ol30`?oemOG
0>Cok^k^0002ogj]f@Cooooo00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3o
bLW900Wooooo2?o`l?002?ooooood];BoiNGUom1@D7oQXJ6oooooonc/k?o
C4a<0_ooool00onPX:3oGemOooooo`0;ooooo`;oOZgI00_oooooogemOOmA
DE7oooooooGemOmNGUko20P8oo3`l?oemOGo0000ol;2`P02ooooo`03oo_k
nol10@7o_;bl0>Cooooo0002ogj]f@Cok^k^00OoE5ADog5aLOn@T93oYjNW
okRh^?o0`<3obLW900Wok^k^1OmgMgL3oo3`l004onk^k_m@D53oO7alomKF
eP;ok^k^00Coc<c<obh^;_o^k^kok^k^0_mnOWh<onk^kP;oOZgI00_ok^k^
onOWiom?CdooE5ADob4Q8OlL71co^;Rhonk^k_o<c<co0000olC4a003onk^
kP03o``<3?nFUYKok^k^0>?ok^k^0002ogj]f@Coi^KV00OoE5ADog5aLOn@
T93oYjNWokRh^?o0`<3obLW900Woi^KV2?o`l?000ooVi^KoCDe=okbl_004
onKViP05ob8R8_oTi>Coi^KVoe9BD_nd];@03?oVi^H2ogj]f@;oi^KV00Wo
PH61o`000?m2@T;oB4Q8omkNg_oVi^Kodm?Co`000?ne]KD00ooVi^H00ol4
10CoWIfMonKViP3SonKViP000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNW
Yonh^;So`<30olW9b@09onk^kPSol?3`00?ok^k^oe1@D?m:BTX00_mLG5`2
onk^kP05ogalO?lh>3SoJ6QXoc@d=?oZj^X03?o^k^h2ogj]f@07onk^k_o2
`/;o0000ojRXZ?o^k^koOGemoeQHF002onk^kP07o`T92OnRXZ;ok^k^onk^
k_oKfm_o0000ol;2`P3Tonk^kP000_mn[MT4ooooo`07oeADE?maLG7oT92@
ojNWYonh^;So`<30olW9b@09ooooo`?oMgMg1Oo`l?001OoooooofMWIolG5
aOo5aLGoa/K600?ooooo00?oa<C4ojn_[oodm?@03Oooool2ogj]f@03oooo
ooo0`<3o8b<S00;ooooo00Kob/[:oa4A4OooooooooooofATI?mRHV82oooo
o`03oinOWol[:b_ooooo0>Cooooo0002ogj]f@Cok^k^00OoE5ADog5aLOn@
T93oYjNWokRh^?o0`<3obLW900Wok^k^2?o`l?0Honk^kP;oOZgI0_o^k^h0
1Ol[:b_oHf=Sohn?Solc<c?oHF5Q00;ok^k^00Kod=3@oa/K6omaLG7oRHV9
oaLG5on/[:cUonk^kP000_mn[MT4onKViP07oeADE?maLG7oT92@ojNWYonh
^;So`<30olW9b@09onKViPSol?3`6?oVi^H2ogj]f@;oi^KV00Gog=cLoiZJ
V_mUIFGoWIfMomgMg@03onKViP04ol_;bomhN7SoK6a/okRh^>Koi^KV0002
ogj]f@Cok^k^00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wok^k^
0omgMgL5oo3`l1Sok^k^0_mn[MWdonk^kP000_mn[MT4ooooo`07oeADE?ma
LG7oT92@ojNWYonh^;So`<30olW9b@09ooooo`Sol?3`6?ooool2ogj]fOCo
oooo0002ogj]f@Cok^k^00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW9
00Wok^k^2?o`l?0Honk^kP;oOZgIm?o^k^h000;oOZgI1?oVi^H01omDE5Co
LG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02OoVi^H3ogMgM`Gol?3`0_oVi^H0
0ooMgMgoeMGEonKViP03onKViP03omcLg?oBd];oi^KV00goi^KV0_mn[MWd
onKViP000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9
b@09onk^kPSol?3`00_ok^k^oibLW?lN7QkoDe=CoeeMGOo[jn_ok^k^oj>S
XolL71co<c<coeeMG@0=onk^kP;oOZgIm?o^k^h000;oOZgI1?ooool01omD
E5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02Oooool3ogMgM`Gol?3`00co
ooooob`/;?o/k>coooooofe]KOni^KWoooooobl_;oo[jn_ooOgmod=3@ooG
emL<ooooo`;oOZgIm?ooool000;oOZgI1?o^k^h01omDE5CoLG5aoi2@T?nW
YjOo^;Rhol30`?o9bLT02Oo^k^h8oo3`l008omSHf?lT92Cok^k^onk^k_mo
OgooM7AdomWIfOlV9RH2onk^kP03og=cLon<S8cok^k^00_ok^k^0_mn[MWd
onk^kP000_mn[MT4onKViP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9
b@09onKViPSol?3`00SoY:BTo`L71on>SXko^;RhobPX:?ni^KWoXJ6QodA4
A0;oi^KV00?oT92@oeEEEOoVi^H02ooVi^H2ogj]fOCoi^KV0002ogj]f@Co
k^k^00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wok^k^1OmgMgL3
oo3`l008okbl_?lL71coWIfMofYZJ_nk^k_ok^k^olc<c?l^;Rh2onk^kP;o
OWin3?o^k^h2ogj]fOCok^k^0002ogj]f@Cooooo00OoE5ADog5aLOn@T93o
YjNWokRh^?o0`<3obLW900Wooooo2?o`l?000oofm_Ko51@Don[ZjP04oooo
o`05obHV9_omoOgooooooeaLG?o8b<P03?ooool2ogj]fOCooooo0002ogj]
f@Cok^k^00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wok^k^2?o`
l?003?o^k^koUYJFobDU9On;Rh_oL71`olS8b?o^k^koO7alocPh>?mXJ6So
=3@don[ZjPcok^k^0_mn[MWdonk^kP000_mn[MT4onKViP07oeADE?maLG7o
T92@ojNWYonh^;So`<30olW9b@09onKViP?oMgMg1Oo`l?02onKViP04ol?3
`onCTi?oZJVYomgMg@;oi^KV00?o/;2`oifMWOoLg=`03OoVi^H2ogj]fOCo
i^KV0002ogj]f@Cok^k^00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW9
00Wok^k^2?o`l?0Honk^kP;oOZgIm?o^k^h000;oOZgI1?ooool01omDE5Co
LG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02Oooool8oo3`l1Sooooo0_mn[MWd
ooooo`000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9
b@09onk^kP?oMgMg1Oo`l?0Honk^kP;oOZgIm?o^k^h000;oOZgI1?oVi^H0
1omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02OoVi^H8oo3`l1Soi^KV
0_mn[MWdonKViP000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh^;So
`<30olW9b@09onk^kPSol?3`6?o^k^h2ogj]fOCok^k^0002ogj]f@Cooooo
00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wooooo0omgMgL5oo3`
l0Sooooo00?omOGeonWYjOooool03Oooool2ogj]fOCooooo0002ogj]f@Co
k^k^00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wok^k^2?o`l?00
0oo^k^koVIVIoc8b<P04onk^kP04oj>SXolL71co<c<coeeMG@gok^k^0_mn
[MWdonk^kP000_mn[MT4onKViP07oeADE?maLG7oT92@ojNWYonh^;So`<30
olW9b@09onKViPSol?3`00Coi^KVom?Cdol92@Woa/K60ooVi^H01OlZ:R[o
dm?ConCTi?ll?3co`L7100coi^KV0_mn[MWdonKViP000_mn[MT4onk^kP07
oeADE?maLG7oT92@ojNWYonh^;So`<30olW9b@09onk^kP?oMgMg1Oo`l?02
onk^kP06og1`L?mgMgOok^k^onk^k_oIfMWo9RHV0_o^k^h00omcLg?oS8b<
onk^kP0;onk^kP;oOZgIm?o^k^h000;oOZgI1?ooool01omDE5CoLG5aoi2@
T?nWYjOo^;Rhol30`?o9bLT02Oooool8oo3`l0;ooooo00Kol_;bobTY:OoW
inOooooook>c/om<C4`2ooooo`03oj2PX?mOGeoooooo00_ooooo0_mn[MWd
ooooo`000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9
b@09onk^kPGoMgMg0oo`l?03onk^kP05oinOWomFEUKok^k^olc<c?l^;Rh0
0_o^k^h2oginOPcok^k^0_mn[MWdonk^kP000_mn[MT4onKViP07oeADE?ma
LG7oT92@ojNWYonh^;So`<30olW9b@09onKViPSol?3`1?oVi^H02?m3@d?o
[jn_onKVi_lR8R;oi>CTonKVi_mBDU;o];Bd3?oVi^H2ogj]fOCoi^KV0002
ogj]f@Cok^k^00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wok^k^
2?o`l?003?o^k^koFUYJoda<C?m<C4co=SHfodU9BOo^k^koO7alocPh>?mX
J6So=3@don[ZjPcok^k^0_mn[MWdonk^kP000_mn[MT4ooooo`07oeADE?ma
LG7oT92@ojNWYonh^;So`<30olW9b@09ooooo`?oMgMg1Oo`l?000ooooooo
b/[:olG5a@02olG5a@06omKFe_ooooooooooolC4a?n_[joom?Cd3Oooool2
ogj]fOCooooo0002ogj]f@Cok^k^00OoE5ADog5aLOn@T93oYjNWokRh^?o0
`<3obLW900Wok^k^2?o`l?0Honk^kP;oOZgIm?o^k^h000;oOZgI00coi>CT
on;Rh_oOgmoog]kNoe5ADOm]KFgoRXZ:oj6QXOnb/[;o^[ZjolC4a?oShn<8
onKViPSol?3`6?oVi^H2ogj]fOCoi^KV0002ogj]f@0=on;Rh_oDe=CoaLG5
okjn__m2@T;oF5QHog1`L?n4Q8CoTi>CoijNW_n][Jgofm_KonKViP07onk^
kP?oMgMg1Oo`l?0Honk^kP;oOZgIm?o^k^h000;oOZgI00koemOGojb/[?n4
Q8CoKfm_ob8R8_l];Bgo>SXjodA4A?m@D53oGUiNogEeMOnk^k_oh>3PooOg
m`Kooooo2?o`l?0Hooooo`;oOZgIm?ooool000;oOZgI00ooX:6Rog^9T?nG
^;oo]M_Pok3GgOn_eMko/]OMokSPhonXbl[oZ/30ohnIVOmiNW[oXJ6Qom7A
dOoVi^H01Oo^k^h8oo3`l1Sok^k^0_mn[MWdonk^kP000_mn[MT04?moR9;o
[=GbolOcooo7m?goaoGoolSdooo:m_ooc?Soom3moooGoooogoooom[/k?m]
KFgoWYjNol[:b_oNg]h4onKViP?oMgMg1Oo`l?0HonKViP;oOZgIm?oVi^H0
00;oOZgI017oP92Sok?Nooneh?go]^7nokSQo_nggoko^^CnokkVo_o0ioko
aNonol_ko_oMooooaMSGog1aLOnUYJGod];BonGUi@03onk^kPSol?3`0_o^
k^h00ooZj^[of][Jonk^kP03onk^kP03onCTi?oIfMWok^k^00gok^k^0_mn
[MWdonk^kP000_mn[MT01On5VJoo[=OoojWCnon]e_ko[MKo00;o/=So00_o
]=_ookOOoonhhOoo_nOoolG`o_oEoooo^]GFogMkNOnb/[;ohN7QooKfmP02
ooooo`Sol?3`00_oooooohn?Soll?3coGUiNodU9BOoXj>Soooooojn_[olO
7aoo=cLgofATI00=ooooo`;oOZgIm?ooool000;oOZgI01CoO92Yoj7;oOnL
a_7oW/Seoj?;monSboSoYLcgojS@nOn[dOco[]Cmok?Jo_ngg_oo_>CmolSe
oon/cM?oKW9cojNWYooAdM7oi^KVonk^kP?oMgMg1Oo`l?003?oTi>Co61PH
on;Rh_o^k^koR8R8og5aLOo^k^ko:b/[om_Kfoo/k>co?ShnolS8b0cok^k^
0_mn[MWdonk^kP000_mn[MT05?meRj?oUlCeoi2iionC_^[oUKk[oiW0kOnJ
`NcoW<C_oik5konRb?7oYL_cojS>n?n^eO_o[]Kjok_VoonM`=3oK75cojBT
Y?o>c/koh^;R2?o`l?002?oUiNGo7alOomgMgOoNg]koATI6ogQhN?oBd];o
92@T0_oVi^H00om_KfooR8R8onKViP0;onKViP;oOZgIm?oVi^H000;oOZgI
01CoLHVQohZhkOn5[]goR[CQohVch?n>]^CoT;OUoi6ii?nD_>OoVKoYoi[0
jOnL`^WoX<K^ojC;mOnPao?oZmOooh^adon5RHgobLW9on;RhPSol?3`00So
k^k^okBd]?m6ATKo9BDUoe]KFooUiNGoYjNWodI6AP;ok^k^00?oUIFEoeQH
F?o^k^h02oo^k^h2ogj]fOCok^k^0002ogj]f@0Dog28X_mk[>;oNZKDog^W
fOmmZMWoOj[Ioh:[fOn3[=WoQk3Loh^cgon>]MooT;ORoi>jiOnA^NGoTK_Y
ohjij_nA`?GoQ[;SokNj_oo[jn/5ogMgM`?ol?3`00SooooookBd]?lR8R;o
Shn?ofATI?okno_ofm_Koc8b<P;ooooo00?oR8R8ohN7Qoooool02oooool2
ogj]fOCooooo0002ogj]f@0Dof=nVomWWMSoIiO7ofVJc_mXV/ooK9_?ofjL
dOm`W]7oLYoAogJRdomiYMGoO:SFogj[fOmlZ=OoMjGHogJSe_maYMooQ:31
om3Ad_oXj>P8oo3`l00<onk^k_m=CDgo];Bdonk^k_mVIVKoZZZZonk^k_lS
8b?ok>c/onk^k_mEEEGo^[Zj3?o^k^h2ogj]fOCok^k^0002ogj]f@0:oe9a
Tom9Q/_oBH2lodb3`OmAQlCoDHK1oe>9a?mDRLCoEX_4oeb=a`;oH97800So
HY?:oej@bomKS/KoE8k>og2<[?oDe=GohN7QonKViP?oMgMg1Oo`l?003?oV
i^KoVYZJod];Bon:RX[o92@Tol_;booVi^KoMgMgocLg=omUIFGo<S8bon;R
hPcoi^KV0_mn[MWdonKViP000_mn[MT01olkGXWoAX?9oeN9`?mFRLGoFXc3
oeV<a?mNTLP00_mLS/D02OmUU<WoH9;7oef?a_mMSlKoGHo5odEo`omLOZGo
f][Kon[ZjP02onk^kPSol?3`0_o^k^h00ooBd];oWinOomSHf003onk^kP03
okJf]_nSXj?ohn?S00gok^k^0_mn[MWdonk^kP000_mn[MT04OljBh7oGH[<
ogfTcomhXLooO:KBogfUdOn2Z=?oOZGBogjUdomjY=?oOZKAog^Td?miX/oo
BGc0oe5]W_o[jncon_[j00?ooooo2?o`l?0Hooooo`;oOZgIm?ooool000;o
OZgI013o>SYbogB3a_nR[mCoUJ[CoiJ]eOnF[=GoUZ[CoiBUd_nGZ=?oUZWC
oiV^eOnLZMCoH6nfodUAROoJf][ojNWY1?o^k^h3ogMgM`Gol?3`6?o^k^h2
ogj]fOCok^k^0002ogj]f@0?oeEEN?mLH:ooZ:kEojnhf?n^]]Ko[;CEojng
f?n`]mSoZk7FojB[e?nLWlgoI6>_odM7O?oBd];oh>3P00Goi^KV2?o`l?0H
onKViP;oOZgIm?oVi^H000;oOZgI00koY:BaocloT?mFEZOoMGJoogEj`?me
N<7oMW_0ogQi_omWIkGoG62_ocm0V?ln?X;oe=CDonSXj0Kok^k^2?o`l?0H
onk^kP;oOZgIm?o^k^h000;oOZgI00golo?cokblaomjNY?oGen2oahN@_lY
:Dko=CEGoc`lGOm=CF_oF5QcogYjSOoYjN_onOWi00Oooooo0omgMgL5oo3`
l1Sooooo0_mn[MWdooooo`000_mn[MT03?o]kNgoi>CTonCTi?oTi>CoD51@
ofa/K?n:RX[oX:2Pok2`/?nh^;So`L71onc/k0Sok^k^2?o`l?001?o^k^ko
j>SXolk>c_oYjNT4onk^kP03onCTi?oIfMWok^k^00gok^k^0_mn[MWdonk^
kP000_mn[MT4onKViP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9b@09
onKViPSol?3`00Goi^KVodi>C_mHF5So6a/Kohn?S`02onKViP04oifMWOlK
6a_o<C4aoeYJFPgoi^KV0_mn[MWdonKViP000_mn[MT4onk^kP07oeADE?ma
LG7oT92@ojNWYonh^;So`<30olW9b@09onk^kP?oMgMg1Oo`l?03onk^kP09
on3Ph?lR8R;oc<c<onk^k_l[:b_ofm_Konc/k?ln?Skob<S800cok^k^0_mn
[MWdonk^kP000_mn[MT4ooooo`07oeADE?maLG7oT92@ojNWYonh^;So`<30
olW9b@09ooooo`Sol?3`00Soooooookno_ni^KWo[Zj^of5QHOn1PH7ojNWY
obTY:@;ooooo00?oO7aloiNGUoooool02oooool2ogj]fOCooooo0002ogj]
f@Cok^k^00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wok^k^2?o`
l?002?o^k^koBd];og1`L?nCTi?o:RXZoeUIFOnWYjOoATI60_o^k^h00onE
UIGoF5QHonk^kP0;onk^kP;oOZgIm?o^k^h000;oOZgI1?oVi^H01omDE5Co
LG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02OoVi^H5ogMgM`?ol?3`00CocLg=
oalO7ooVi^Koi^KV0_m`L7001_o5aLGo;Bd]onKVi_oVi^KoNWYjogUiN@co
i^KV0_mn[MWdonKViP000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh
^;So`<30olW9b@09onk^kPSol?3`00cohn?SobXZ:_o^k^kok^k^oeADE?nc
/k?ok^k^ob<S8oo/k>cok^k^oeEEEOnj^[X<onk^kP;oOZgIm?o^k^h000;o
OZgI1?ooool01omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9bLT02Oooool8
oo3`l00<oooooomgMgOoK6a/ogQhN?lc<c?onOWioooooon5QHGo?Cdmog1`
L?lh>3Sono_k3?ooool2ogj]fOCooooo0002ogj]f@Cok^k^00OoE5ADog5a
LOn@T93oYjNWokRh^?o0`<3obLW900Wok^k^0omgMgL5oo3`l0;ok^k^00?o
cLg=oj:RX_oQhN400oo^k^h00onf][KoXj>Son?Sh`0=onk^kP;oOZgIm?o^
k^h000;oOZgI1?oVi^H01omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9bLT0
2OoVi^H8oo3`l1Soi^KV0_mn[MWdonKViP000_mn[MT4onk^kP07oeADE?ma
LG7oT92@ojNWYonh^;So`<30olW9b@09onk^kP?oMgMg1Oo`l?0Honk^kP;o
OZgIm?o^k^h000;oOZgI1?ooool01omDE5CoLG5aoi2@T?nWYjOo^;Rhol30
`?o9bLT02Oooool8oo3`l1Sooooo0_mn[MWdooooo`000_mn[MT4onk^kP07
oeADE?maLG7oT92@ojNWYonh^;So`<30olW9b@09onk^kPSol?3`6?o^k^h2
ogj]fOCok^k^0002ogj]f@Coi^KV00OoE5ADog5aLOn@T93oYjNWokRh^?o0
`<3obLW900Woi^KV0omgMgL5oo3`l1Soi^KV0_mn[MWdonKViP000_mn[MT4
onk^kP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9b@09onk^kPSol?3`
2?o^k^h00ooTi>CofMWIonk^kP03onk^kP03onCTi?oIfMWok^k^00Ook^k^
0_mn[MWdonk^kP000_mn[MT4ooooo`07oeADE?maLG7oT92@ojNWYonh^;So
`<30olW9b@09ooooo`Sol?3`00_oooooojBTY?m3@d?o1PH6odI6A_nm_Kgo
ooooojn_[olO7aoo=cLgofATI002ooooo`04ojn_[olO7aoo=cLgofATI0Oo
oooo0_mn[MWdooooo`000_mn[MT4onk^kP07oeADE?maLG7oT92@ojNWYonh
^;So`<30olW9b@09onk^kP?oMgMg1Oo`l?02onk^kP03on;Rh_lC4a?ok^k^
00;ok^k^00_o:b/[om_Kfoo/k>co?ShnolS8b?o^k^ko:b/[om_Kfoo/k>co
?ShnolS8b006onk^kP;oOZgIm?o^k^h000;oOZgI1?oVi^H01omDE5CoLG5a
oi2@T?nWYjOo^;Rhol30`?o9bLT02OoVi^H8oo3`l0;oi^KV00Kofm_Koa8B
4_oVi^Koi^KVom;Bd_lT92@2onKViP04ofm_Kon8R8Sod];Bob@T90;oi^KV
00?oKfm_ohR8R?oVi^H01OoVi^H2ogj]fOCoi^KV0002ogj]f@Cok^k^00Oo
E5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW900Wok^k^2?o`l?02onk^kP06
on;Rh_lC4a?ok^k^onk^k_nWYjOoATI60_o^k^h01?nEUIGoF5QHojNWYom6
ATH2onk^kP03oiFEUOmHF5Sok^k^00Gok^k^0_mn[MWdonk^kP000_mn[MT4
ooooo`07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9b@09ooooo`GoMgMg
1Oooool01_oclo?o5ADEoooooooooooofm_Koc8b<P;ooooo00CoR8R8ohN7
QooKfm_o<S8b0_ooool00on8R8SoQhN7ooooo`05ooooo`;oOZgIm?ooool0
00;oOZgI1?o^k^h01omDE5CoLG5aoi2@T?nWYjOo^;Rhol30`?o9bLT04oo^
k^h00ooRh^;o4a<Conk^kP02onk^kP0;ob<S8oo/k>cok^k^oeEEEOnj^[[o
k^k^ob<S8oo/k>cok^k^oeEEEOnj^[X01_o^k^h2ogj]fOCok^k^0002ogj]
f@Coi^KV00OoE5ADog5aLOn@T93oYjNWokRh^?o0`<3obLW901;oi^KV00?o
TI6AodE5AOlB4Q800ooVi^H02omgMgOo=cLgofEUIOlb<S;oh^;RonKVi_mg
MgOo=cLgofEUIOlb<S;oh^;R00Koi^KV0_mn[MWdonKViP000_mn[MT4onk^
kP07oeADE?maLG7oT92@ojNWYonh^;So`<30olW9b@0Conk^kP03omoOgon^
[Zkok^k^00?ok^k^00?o][Jfoj>SXooShn<00oo^k^h00onf][KoXj>Son?S
h`07onk^kP;oOZgIm?o^k^h000;oOZgI1?ooool01omCDe?oJ6QXohB4Q?nR
XZ;o/K6aokbl_?o5aLD0:Oooool2ogj]fOCooooo0002ogj]f@Cok^k^00Oo
MGEeof5QHOmoOgooU9BDojRXZ?nf][Kobl_;02Wok^k^0_mn[MWdonk^kP00
0_mn[MT4onKViP07ojRXZ?mKFe_oL71`oh^;RonMWIgoZZZZom;BdP0YonKV
iP;oOZgIm?oVi^H000;oOZgI1Oo^k^h01Ona/K7oRh^;og]kNonVYZKoclo?
02[ok^k^0_mn[MWdonk^kP000_mn[MTdooooo`;oOZgIm?ooool003SoOZgI
m?o^k^h003SoOZgIm?oVi^H00?ooOgmo;OmoOgl00004on_[jooVi^Koh^;R
omkNgPCogMgM0ooNg]h0P_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oMgMd2omcL
g02Aom_KfooMgMgog=cLomgMgOoMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMg@03
omkNgP03omgMgOoNg]kog]kN00?ogMgM0OoQhN41onOWi`7oj^[Z00000oo/
k>coi^KVon3Ph007omWIf@04omSHf?oFe]Kodm?Com3@d0?ocLg=00Cod=3@
om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@
d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@
d=3odm?ComOGeooHf=PlomWIf@;of=SH00?ofMWIomSHf?oHf=P00ooIfMT2
omSHf0GofMWI00?of=SHomKFe_oCdm<00_oCdm<00ooFe]Kof=SHomSHf00>
omWIf@04omSHf?oIfMWofMWIomSHf13ofMWI0_oHf=QXomWIf@03omSHf?oI
fMWofMWI00KofMWI0OoNg]h1onKViP7ok>c/00001oo^k^kojNWYonCTi?oP
h>3ohN7Qon3Ph?oRh^800_oQhN403OoNg]kog=cLom?Cdoo7alOo^k^kok:b
/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml02OoQhN403OoOgmoofm_K
om?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml0
2OoQhN403OoOgmoofm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7
alOodm?Com_KfooOgml0;OoQhN4:on3Ph003omoOgooPh>3oh>3P00KogmoO
0_oPh>03omoOg`Goh>3P00OogmoOom_KfooGemOoe=CDomGEeOoIfMWogMgM
00;oh>3P00?ogmoOon3Ph?oPh>000_oQhN47on3Ph0KogmoO00?oh>3PomoO
gooPh>002ooPh>001?oOgmoog]kNomkNg_oOgml2on3Ph6OohN7Q00?oh^;R
on7QhOoRh^801?oQhN41onCTi07ojNWY0Oo]kNd00003oo3`l?o_knoolO7a
00?ol?3`06[okno_oo3`l?o^k^kojNWYom_Kfoo1`L7oY:BTohb<S?mkNg_o
MgMgog]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7alOo_
knoolO7_ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_oNg]kogMg
MomkNg_oS8b<ojBTY?o2`/;of][Jon[Zj?o]kNgolO7aono_kooalO7okno_
oo7alOo_knoolO7_ong]kOoZj^[of][Jol;2`_nTY:CoS8b<og]kNomgMgKo
Ng]kohb<S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knool?3`0_o/k>`01oo[jn_ok^k/onc/
k?o]kNgok>c/onk^k_oZj^X00_o[jn/02_o^k^cojNWYonSXj?oVi^KojNWY
onKVi_oZj^[ojn_[ong]jooXj>P2onWYj@07ong]kOoZj^[ok>c/onc/k?o_
kngoj^[ZonSXj002on?Sh`0=omoOgooShn?oj>SXong]jooZj^[ojn_[onc/
k?o`l?3okno_oo3`l?o]kNgok>cZon[ZjP02onk^kP06ono_kooZj^[ojNWY
onKVi_oXj>KoinOW0_oYjNT01_o/k>cojNWYonc/k?o]kNgok^k/on[ZjP;o
k>c/00Sok^k^on[Zj_o/k>cok>c/ono_kOo[jn_ojNWYonKViP;oj>SX0_o]
kNd0KOo`l>kokno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aoo3`l?o_knool?3`ono_koo`l?3okno_oo3`l?o_knl01?o`l?000003
oo;bl_o^k^koinOW00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mVIVKo
DE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@0
0ooUiNGoi>CTonGUi002onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5A
odE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT04;o
iNGUonCTi?oUiNGoi>CTonCThooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5
ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7AomkNg_oTi>?oi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTon?ShooNg]h2om_Kf`0:
omkNgOoLg=cofm_KomcLg?oOgmoofm_KomWIfOoLg=cogMgLomOGe`?oeMGE
00Coe=CDomWIfOoMgMgogMgL0_oGemL04_oKfm_ogMgMom[Jf_oJf][og]kN
on7Qh?oKfm_of=SHodI6A_l`<33oN7Qhol;2`_oJf][og]kMom[Jf_oIfMWo
gMgMon?Sh`;oi>CT01KogmoOomcLfooIfMWogmoOon;Rh_oQhN7ofm_KomKF
e_oDe=Coe]KEomCDe?oFe]Kofm_KomcLg?oHf=Sog=cLomoOgooOgmkofMWI
om_KfooNg]kogmoO0_oJf]X0KooMgMgoh>3Oom_KfooGemOoeMGEomOGeooI
fMWogmoOon;Rh_oTi>?oi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi004onGUi@06onCTi?oUiNGoiNGUonGUiOoXj>SokNg]
0Oobl_800003ooCdm?o]kNgoinOW00;oh>3P01?ohN7QomoOgooNg]kod];B
okBd]?n7QhOoG5aLofdk=OnNCT;ocFmOonV3Koo=KeooWTi3ofdk=_mLG5co
QhN7okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m]
H2coWYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aLohN7Qond];Cod];BomkN
gP05on3Ph00AomkNg_oBd];o];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UE
oi7=AomZWSCoBFX_oeaLG?n7QhOo];Bdom;Bd_oNg]h0:ooPh>00@ooNg]ko
f=SHom;Bd_oDe=Coe]KFom;Bd_o?clood];BomKFe_oCdm?odM7AomGEeOoF
e]Kod=3@olC4a?o;bl_oclo?olW9bOo4a<Cof=SHomGEeOo@d=3oa<C4om3@
d?oHf=Sod];Bom7AdOoHf=Sofm_KomKFe_oAdM7oUIFEoj2PX?ln?SkoBd];
omCDe?oHf=Sod];Bom7AdOoHf=Sog]kNon3Ph?oOgmoof][Jom?CdooAdM7o
f=SHomgMgOoJf][odm?Colo?coo0`<3od=3@olg=cOno_kooe=CDomKFe_oA
dM7oe=CDomWIfOoHf=SodM7Aom;Bd_oHf=SofMWIom?CdooAdM400_oGemL0
2?oAdM7oclo?olS8b?o4a<Cof=SHom_KfooNg]kogmoOI?oPh>000ooOgmoo
h>3PomoOg`02omoOg`?oh>3P00?ohN7QonOWioo/k>`00Oodm?@00003ooKf
m_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgoWinOof]OGon?=RkokG5Q
ooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=cOoRh^;o
inOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOofiVGonCLR;okM54ooWcM?om
oHgooOfEoogmS_oin7KokMM7oi=c8_m^IeooWinOolg=cOoRh^;oinOW00?o
j>SX01?oinOWon;Rh_o=cLgoWinOof1XGom;O2?oT^5;okgiNoo@oI;of?fK
omCmUOo0nGkoV>Q=odf09?mPJEooWinOolg=cOoRh^;oinOW02[oj>SX02Wo
i^KVomoOgol`<33oShn?om_Kfoo7alOoR8R8olG5aOoKfm_oYJFUo`410OoM
gMgog]kNofe]KOl820So4A4Aog=cLol`<33o92@TomgMgOoKfm_oBd];o``<
3?mRHV;ohN7Qofe]KOlj>S[ogmoOon?Shoo3`l?o0000ol71`OoQhN7oX:2P
o`d=3OoGemOog]kNogemOOlG5aOogMgMonCTi002onKViP0Don;Rh_moOgoo
:2PXomoOgooUiNGohn?SokJf]_lO7aoo2@T9ocHf=_mdM7Co20P8oiJFU_oM
gMgo3`l?oiNGUooQhN7ogmoOod92@_mTI6@2on3Ph00<ogEeMOlb<S;ogMgM
om_Kfonn_[ko?3`lo`820_lO7aoo5ADEokBd]?oVi^KoinOWKOoXj>P1onc/
k07ol_;b0Oofm_H00003ooOgmoohn?Son?Sh00?on?Sh01?omoOgonk^k_o>
c/koT92@ohD_:ooYI5Koni:7oojVVoon/JGookR[oojcY_onZ9coniB9oniX
FOn9<B_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@
oiUY:oo`_Cgonn1^ookdP_onoX[ooonBooknS?onn8?onnE`oo32?_nIJR_o
T92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@od9c:on4
cT?o[Nmcol;nR?o>oY3oe_nGom3nT_o6oXWo/_EdohSC@om4MB_oT92@olk>
c_o^k^komoOg02[on?Sh02oom_Kfono_kolc<c?oVIVIonOWion3Ph?o0000
ogalO?oXj>So/;2`o`410Oo]kNgohn?So`H61_nRXZ;ogMgMogMgMol0003o
c/k>oo3`l?o2`/;o0000om7AdOodm?ColO7aogEeMOln?Skok^k^oo;bl_o@
d=3o0000olo?cooalO7ob<S8o`000?o3`l?ok^k^ohJ6Q_lI6AWojNWYono_
koobl_;om?Cdoo7alOn8R8So:b/[onk^kP02ooGem@0LofATI?lo?cooiNGU
ok>c/olO7aooIfMWono_koo]kNgo410@oj:RX_o`l?3okno_odM7Aom[Jf_o
kno_oo3`l?mnOWko=CDeon_[jooXj>So=cLgodA4A?o>c/koinOWomgMgOoT
i>ComOGeooOgmfKon?Sh00?omoOgooShn?ohn?P00_ohn?P01?ogmoOonOWi
ooOgmoogmoL1ooShn00000?on_[jooGemOo^k^h00_o/k>`0ZOo[jn_ojNWY
omoOgonj^[[oNE9Boklb9?oWM6WooHUnoonHS?onXYKoojRLoojTV?ooVXgo
oXYoonifJ_o3<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/on[Zj_oO
gmoo^[ZjohQUD_oRTAconL=@oogJHooojW;oo_=nooojP_onmWooonacookN
I?ojae7ohY8LohUVDonj^[[ogmoOon[Zj_o[jn_ok>c/on_[jooZj^[ogmoO
okZj^_mBKE;oDJ<Loi7BEOnVif[o^?Ujol3nP_o7ohWo`oj4okWmNonWk6co
U=IGoe:V7?mBKE;o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojNWYon?Shol`<33oT92@omSHfOl];Bgo@410ob<S8ooJ
f][oYZJVo`410OoQhN7ohn?Toa0@4?mlO7cogmoOokBd]?l0003odM7AonCT
i?nHV9Wo3`l?on3Ph?oWinOohn?Sofm_Kolk>c_ogmoOon7Qh_o3`l?o0000
olG5aOoTi>Co_knoo`000?nh^;SohN7RogmoOolG5aOofMWIomgMgOoQhN7o
iNGUonCTi?n1PH7o:2PXomoOgooVi^Koj>SXogAdM?lO7aoofMWIomcLgOlk
>c_oKfm_onCTi?oPh>3o3`l?oiRHV?oQhN7ogmoPod=3@omUIFD00_oPh>00
KomgMgOo<S8bon3Ph?nh^;Wo0000ojRXZ?oLg=cofMWIom_KfooQhN7ojNWY
on[Zjoo/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k007on_[
j`05onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT00003oo_knooclo?okNg]
00;oiNGU0;3oi^KVonCTi?oIfMWo/[:bogT^;_o8@SCohfYLooAjKOomR7co
oYN:oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;of=SHonCTi?oU
iNGoi^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^lA?onc5?ooMQRookS
L_onjGGoo^IcookKIOomc5?onl55onjN:onIERko/[:bomSHf?oTi>CoiNGU
onKVi_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on7bTSoUmaIojGUJOnblgOo
^?IkokCeNOnWjV_oV=aIohW?BomS[R_o;V<^ok:b/_oHf=Woi>CTonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVon?ShooMgMgo;bl_oh^;Rona
/K;o0000okNg]olU9BGoZ:RXoj2PX?l10@7og=cLon3PhOnb/[;o>CTiobDU
9Olk>c_o0000olg=cOoMgMgoTi>Doa0@4?oFe]Kog]kNomcLg?m/K6co>CTi
omCDe?oFe]Oo_;blo`000?o2`/;ogmoOok^k^ol0003o];BdomcLg?mlO7co
5aLGomKFe_oJf][og]kNon3Ph?oOgmooOGenobLW9ooEeMGog=cLomkNg_oK
fm_oI6ATob0P8?ll?3co4a<Cofe]KOoPh>3og=cLo`l?3onCTi?oemOGomGE
e_m1@D7oHV9RomOGeooFe]KoLg=coc4a<OoMgMgoVYZKo`0000Co=cLg06Oo
/[:bonCTi?oTi>Goi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGU00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGokNg]ooCd
m001oo_kn`0000?oo?clooShn?oalO400oo^k^h04oo[jn_ohN7Qokbl_?mj
5aOo`clbom=FBOoTJ5[okgM/ooB3NOohQgcomHAjoo=iKOoUJE_ofEQ:ol@o
<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?nUAaOoiYLb
ooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlbonVK<_nUAQOo
_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOoGjPbogJm=on6
cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lGFAOo_;blon7Q
hOo/k>`0:_o^k^h09oo/k>coiNGUoc4a<On?ShooKVi^ob`/;?oXj>SoOGem
oeiNG_nTY:Co0@41on?ShooYjNWoi^KVon;Rh_oPh>3o[Jf]o`000?oGemOo
i>CToiRHV?l@413ogMgMon?ShooTi>CoL71`ob@T9?oFe]KogmoOokno_ol0
003obl_;onWYjOo1`L7o0000okZj^_oTi>CoPH61o`H61P03ochn?P0Rol_;
booYjNWoQ8B4oaXJ6_oJf][oh^;RonGUiOoWinOohn?Son3Ph?oHf=So=cLg
og9bL_oZj^[oinOWo`l?3on:RX[ogmoOomkNg_m3@d?oEUIFon3Ph?oOgmoo
MgMgoc<c<ooYjNWo_[jno`000?nPX:3o][JfojZZZ_l20P;ofMWIong]kFgo
k^k^00?okNg]oo;bl_ohn?P00Oolo?`000?ooOgm01Koo?cloogmoOomoOgo
o?cloo?clooAdM7oJ0L7okPd=?o7?c?odU13omYREOoSKV;oi79TonA_H_oL
I5Oode53ola1=?ni=3CoJ`L7om;Bd_oclo?oo?cl0oomoOd04oolo?colo?c
om;Bd_nN:`OofXXdon^K6OoeZ2Won;@oooVmB_oh_dgon[m:ooVh?oofZR[o
kihIom^;=?nR;@Ood];Boo?cloolo?`00oomoOd04oolo?colo?com;Bd_l7
@0OoCIXdoen[8?m`^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^BooHZhPodjK
=?l7@POod];Boo?cloolo?`0:_omoOd0C?okno_om?Cdoc@d=?nGUiOo7alO
ohN7Qoojn_[ogMgMoa<C4onYZJWo0@41oo;bl_oinOWo`<30olC4a?oclo?o
S8b<ob4Q8Oojn_[omOGeoifMWOl@413oi^KVonk^k_odm?CoN7Qhoa4A4Om<
C4cob/[:ohV9ROlD51Com_KfooWinOo>c/ko0000olK6a_oclo?oRHV9oa<C
4onf][Ko^KViokZj^_o]kNgonOWiohn?Sol<30coEeMGom7AdOo]kNgok>c/
ojJVY_oVi^Koi>CToa8B4_n][Jgono_koo[jn_l@413o7QhNojFUYOoLg=co
6QXJob0P8?mmOGgog]kNodM7AomOGeoono_koo[jn_ld=3CoLG5aonk^k_n>
SXko=CDeoo_knoolo?a[oogmo@03ooclo?omoOgoo?cl00?ooOgm0000>_om
oOgon_[joo?cloo^k^kol?3`ono_koo^k^kojNWYom?CdomK7AgoXS@dok@X
7Oo1>RgoadTlolmFB_o@Ed_od5M:olY:?_o3>bko]RPMoj8d=?mL7Agodm?C
on[Zj_o^k^kol?3`ono_koo`l>ook^k^on[Zj_oCdm?oS2DMolQa=?oIQ1go
i9@EonNM9?o^Z3?ol:XdonnZ<oo/X2GoiiLEomb87Oo8LCCoS2DMom?CdooZ
j^[ok^k^oo3`l?o_knool?3`onk^k_oZj^Wodm?Coadh7OldPSCoAiDMoeZU
6omY[BX2ogBh>01mogFi>?m[/B_oFjLLodRJ7OldPSCo7CPMom?CdooZj^Wo
k^k^oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_onk^k_oWinOo
<C4aoemOGol10@7od];Bonk^k_o/k>co@D51of5QHOl10@7oi^KVonk^kOnP
X:3o>CTioa4A4OlV9RKoV9RHono_koo5aLGo410@o`410OlI6AWoDU9BonWY
jOmaLG7o?CdmoiNGUolO7aoo61PHoi6ATOo^k^kokNg]ol?3`ol0003o_;bl
onSXion2PX;o61PHomoOgooRh^;ohn?SonOWioo[jn_oTi>Boclo?onBTY;o
5aLGoiBDU?oPh>3oCdm?oalO7olA4A7oCdm?onSXj?o^k^kokno_obLW9onP
X:3oCTi>o`T92Olf=SKoh>3Pofi^K_l?3`oo;2`/okjn__o^k^kokno^om;B
d_ll?3co2`/;oadM7Onb/[800_o_knl0I_o`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_k`;ol?3`1_o_knl1oo?cl`7o
nOWi0Oono_h00003ookno_ogmoOol?3`00CojNWY017oinOWom_KfomSBd_o
PC8bojHe=Onf=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mS
Bd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oRD];ojm;<_o=McGoeX/]on2L
;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;oRD];om_KfooWinL01OoY
jNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[ZbooL:dhofn^>_m`[CSo
JZX_oe>K;OliR3Go<V0bod];BooKfm_oinOW02_ojNWY00goj>SXonCTi?l`
<33o4Q8Boc`l??oVi^Koj>SXonOWionCTi?o4A4Ao`410OoShn?oinOW00;o
jNWY00?oinOWonWYjOoYjNT00_oXj>P05?nMWIgo410@onOWiooWinOoi>CT
ofm_Kolk>c_ohn?SonOWiooXj>SojNWYonSXj?oWinOo`/;2o`000?nj^[[o
i>CToh20P?lG5aOogMgM0_oNg]h00ooQhN7oi^KVonSXj002onWYj@03onSX
j?oWinOojNWY00;ojNWY00?oinOWonWYjOoYjNT01OoYjNT01OoXj>SojNWY
onWYjOoYjNWoinOW00KojNWY00?oi^KVonWYjOoYjNT0JOoYjNT00ooXj>So
jNWYonWYj@04onWYj@7ol?3`0OogmoL1ooknoP0000Goo_knoo[jn_odm?Co
kno_oo7al@02oo3`l00Aono_koo[jn_oUIBDodlS8onEE5Co^g=com>EUOoJ
W9cofYjLomVLW?oDUIGo^g=coiEDE?m?8b?oUIBDon[Zj_o_knl01Oo`l?00
4Oo_knooj^[ZojVDU?n18b?o^VYDomBJLooT_9Goj/NLonW7W?oZaicoiKbE
omBJLonkJUCoPB<SojZDU?oZj^[okno_00Gol?3`017okno_on[Zj_nDU9Co
8bXSoeAjE?mcYG?oW/JEojc>W?n]cYco[<jLoik6UOmcYG?oE7YDob<Z8onD
U9Coj^[Zono_k`0[oo3`l005ono_koo^k^ko<S8bo`000?nCTi<00oo_knl0
1OoTi>Co2`/;o`410Oo^k^kokno_00Ool?3`00Wohn?Sokno_oo_knookno_
onk^k_mdM7Co?Cdmong]kOo_knl00oo`l?001oo_knoob/[:o`000?o3`l?o
k^k^ohJ6Q_l92@T00omNGUh00omiNGWok^k^ono_k`2;oo3`l004oo7alOo`
l?3om?Cdoo[jnP7oo_kn00001?omoOgoooooooooooono_h2ooooo`;oo_kn
06kooOgmooShn?m^KVkoFSlook6@T?oNbLWol>CToo?Vi_o`i>Cog/W9ok6@
T?mJ?cooKFe]ooShn?olo?coooooookno_ooooooo_knooooo_ono_kooooo
ooclo?ohn?SoSFe]ohXo?oo9TI3ojM39ooCYi?ofjnKom>WTonW@bOo9TI3o
RCloohe]KOohn?Ooo?clooooooono_koooooookno_ooooooo_knooooo_ol
o?con?Shofe]KOlo?cooT9f@olWEbOoTk>Coi^kVonC/i?o9eLWoT9f@oclo
?om]KFgon?Shooclo?ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooomoOgo[jn_oiRHV?oalO3ooOgmooooo`;oo_kn01Ko
];BdoiZJV_omoOgoooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooomoOgoo_knogalO?m1@D7ooOgmooknoOono_kooooo0_on
o_h0Too^k^koVIVIon_[joono_godM7AoiVIVOnHV9SoVIVIoiRHV?n/[:co
oOgmooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooooknoP02ooooo`03ookno_oooooooooo00?ooooo0Oolo?`00004oo[j
n_ono_kon_[jooCdm0GolO7a00gokno_omKFe_m[Jf_o@cdmoi^<S?o6^[[o
e/c<olNj^_nKS8co@cdmof][JooFe]Kokno_00WolO7a00gokno_omOFe_n3
Jf_oM3dmokF<S?oE^[[ohLc<omJj^_nfS8coLSdmoh5[JooGe]Kokno_00Wo
lO7a00gokno_omKFe_m[Jf_o?Cdmohb<S?nj^[[oc<g<okZj^_n<S8co?Cdm
of][JooFe]Kokno_04KolO7a00?ok^k^ong]kOoalO40UOoalO401?o`l?3o
lO7aoo7alOo`l?04oo7al@03ooCdm?ojn_[oo_kn007on_[j00001Oodm?Co
oOgmooShn?o`l?3ojn_[00?oj^[Z00gojNWYon[Zj_oYjNWoj>SXoi^KVomI
FEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY00_oj^[Z00_ojNWYonSX
j?nPVi_oJUUIod<V9_l]2@Wo@RHVofUIFOnPVi_oj>SXonWYj@0;on[ZjP0;
onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT0
i_oZj^X01?o[jn_ol?3`ooShn?omoOd1ooGem@0000Co^k^kooShn?ojn_[o
m?Cd2?oalO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l0oo
lO7a0_o`l?03ono_k`;ol?3`i?oalO400oo`l?3olO7aoo7al@02oo7al@03
ooGemOojn_[on?Sh007o^k^k00000oo0`<3o_[jnooOgm`3oooooobOooooo
0OogmoL1okno_`7o`<3000001_oRh^;oa/K6ok^k^oo[jn_on_[joogmoOoo
oooo8Oooool01Oono_konOWionc/k?nk^k_oa/K6007oh^;R0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{300, 200},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleJSlider",
        ButtonData:>{"SimpleJSlider.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[BoxData[
    \(SimpleJSlider[]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JMenuBar,\nJMenu,\nJMenuItem,\n\
JCheckBoxMenuItem,\nJRadioButtonMenuItem <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<amIVJIolc<c?[<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<07W<c<`00fIV
VLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00=VIYWoooo<c<`0NLc<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c01ic<c<00=V
IYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003IVJIooooc<c<07W<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`02<c<c0RI
VIUYc<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003IVJIooooc<c<027<c<`2VIVIE/c<c003IVJIc<c<
c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0fIVVOooolc<c00Qc<c<0YVIVEK<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`02Lc<
c0FIVIT2c<c<0YVIV@;<c<`4VIVI0lc<c0BIVIT2c<c<0YVIV@03c<c<VIVI
VIVI05?<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`02<c<c0:IVIT3c<c<0YVIV@04
c<c<VIVIVIVIc<c<0YVIV@;<c<`2VIVI00?<c<bIVIVIVIT00/c<c0:IVIT0
1Lc<c9VIVIVIVIVIVLc<c002VIVID/c<c003IVJIc<c<c<c<0?o<c<chc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c00=
c<c<0YVIV@04c<c<VIVIVIVIc<c<0YVIV@G<c<`2VIVI1Lc<c0:IVIT2c<c<
0YVIVE;<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`02lc<c0BIVIT01<c<c9VIVIVI
VLc<c0JIVIT00lc<c9VIVIVIV@04VIVI00?<c<bIVIVIVIT00/c<c0:IVIUB
c<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c003IVJIooooc<c<00W<c<`5VIVI0/c<c0:IVIT00lc<c9VI
VIVIV@02c<c<0YVIV@03c<c<VIVIVIVI00;<c<`2VIVI00?<c<bIVIVIVIT0
0/c<c0:IVIUBc<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<00S<c<`4VIVI1<c<c0:I
VIT00lc<c9VIVIVIV@02c<c<0YVIV@03c<c<VIVIVIVI00;<c<`2VIVI00G<
c<bIVIVIVIVIVIW<c<`00YVIVE;<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`02<c<
c0:IVIT6c<c<0YVIV@;<c<`4VIVI0lc<c0BIVIT2c<c<0YVIV@03c<c<VIVI
VIVI05?<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`02<c<c0:IVIT3c<c<0YVIV@03
c<c<VIVIVIVI06O<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`02Lc<c0FIVIT2c<c<
0YVIVFO<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0NLc<c003IVJIc<c<c<c<0?o<
c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOoo
olc<c01ic<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<07W<c<`00fIVVLc<c<c<c03o
c<c<n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWo
ooo<c<`0NLc<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c01ic<c<00=VIYW<c<c<c<`0
olc<c?S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJI
ooooc<c<07W<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0NLc<c003IVJIc<c<c<c<
0?o<c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIV
VOooolc<c01ic<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<07W<c<`00fIVVLc<c<c<
c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=V
IYWoooo<c<`04/c<c003ooooR8R8A4A400I4A4@00c<c<dA4A4A4A003A4A4
00>IVIW<c<c<c<`07lc<c0L0000_c<c<00=VIYW<c<c<c<`0olc<c?S<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<01;<
c<`00oooodA4A6IVIP03MgMg00=VIVIgMgMgMgL01GMgM`03<c<cc<c<c<c<
05K<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00=VIYWoooo<c<`04/c<c00<oooo<c<ck^k^k^k^^k^k
MgMgZZZZooook^k^gMgMMgMggMgM0^k^kP03MgMgc<c<c<c<05K<c<`00fIV
VLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00=VIYWoooo<c<`01/c<c0Koool6c<c<00Kooolc<c?oooo^k^igMgL0
<l`2<c<000Q4A4@c03<0029V06IgMgOooomgMgNk^k/4c<c<0P0000C<c<`2
000000?<c<`0000000000P0000;<c<`2000000?<c<`0000000000lc<c0@0
0002c<c<1P000003c<c<0000000000;<c<`400000/c<c0800002c<c<0P00
01o<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00=VIYWoooo<c<`01Lc<c003ooooIVIVIVIV00=VIVH0
0lc<c?ooolc<c004c<c<00oooomgMgO^k^k^k^iVIVH0I_l0I/a4A4@c03<c
<c=gMgLc03>8R8S^k^iVIVH01Lc<c0800003c<c<0P000003c<c<00000000
00;<c<`2000000G<c<`000000000003<c<`00P000003c<c<0000000000;<
c<`2000000?<c<`0000000001Lc<c08000000lc<c00000000002c<c<0P00
0003c<c<0000000000;<c<`200007lc<c003IVJIc<c<c<c<0?o<c<chc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c005
c<c<00=VIVK<c<c<c<`00lc<c003IVIVc<c<oooo00C<c<`01Ooooc<c<nk^
k]gMgA4A4@0206Ko00PcI/`R8R:8R8RIVITR8R;MgMg^k^igMgL5c<c<0P00
00?<c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<
0P000003c<c<0000000000;<c<`2000000?<c<`0000000001Lc<c0800000
0lc<c00000000002c<c<0P000003c<c<0000000000;<c<`200007lc<c003
IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00fIVVOooolc<c004c<c<00=VIVKoooo<c<`01Lc<c003IVIVoooo
c<c<00?<c<`01_oooc<c<nk^kS<c<c<0<`004@8R8R80200c<c<0<a400000
03<c<k^k^gMgMk^k^`C<c<`200000/c<c0800002c<c<0P0000;<c<`20000
00?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P000003c<c<
0000000000G<c<`2000000?<c<`0000000000/c<c08000000lc<c0000000
0002c<c<0P0001o<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`01<c<c003IVIVoooo
c<c<00G<c<`00fIVI_ooolc<c003c<c<00oooomgMgMV<fIV<fIgMgN8R8QV
IVHc<`00<l`0I/`c06H0001V<fHc<c=gMgL01Lc<c0H00002c<c<0P0000;<
c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P00
0003c<c<0000000000G<c<`2000000?<c<`0000000000/c<c08000000lc<
c00000000002c<c<0P0001o<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`01<c<c003
IVIVooooc<c<00G<c<`00fIVI_ooolc<c003c<c<00Wooom4A4@c03?<0<aV
<fIVIVHA002IIP3<V@000P1Vc0:I09T00k^k^gMgMlc<c004c<c<0P0000?<
c<`200000/c<c0030000c<c<c<c<008000001Lc<c000000000000<c<c002
00000/c<c0030000c<c<c<c<008000000lc<c00000000005c<c<0P0000;<
c<`00`000<c<c<c<c002000000G<c<`000000000003<c<`00P0001o<c<`0
0fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00=VIYWoooo<c<`01<c<c003IVIVooooc<c<00G<c<`00fIVI_oo
olc<c003c<c<00Cooolc<c?<c<a4A4@2000000Xc03=VIP3oc02IIP1V06K<
0?mV06IV<fIgMgNk^k/4c<c<0P0000?<c<`200000/c<c0@00002c<c<0P00
0003c<c<0000000000?<c<`400000/c<c0800005c<c<0P0000;<c<`40000
0/c<c08000000lc<c0000000000Pc<c<00=VIYW<c<c<c<`0olc<c?S<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<00C<
c<`00fIVI/c<c?ooo`05c<c<00=VIVKoooo<c<`00lc<c007ooooMgMgk^k^
k^k^8R8RV@2IIS=V009V06H01S<0<iUV014A4Lc<c>k^kWMgM`G<c<`20000
0lc<c0800008c<c<0P0000c<c<`20000=<c<c003IVJIc<c<c<c<0?o<c<ch
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<
c005c<c<00=VIVK<c<coool00oooo`03IVIVooooc<c<00C<c<`01_ooodA4
A>k^kYVIVA4A4DA4A0;<0<`019T0V@0cI/bI07MgM`;^k^h00gMgMlc<c<c<
c003c<c<1P0000W<c<`200003<c<c0800005c<c<0P0002g<c<`00fIVVLc<
c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00=VIYWoooo<c<`01/c<c0EVIVH7c<c<00Wooolc<c?^k^igMgLc<c=VIVHc
<c?<0<a4A4@00P0cIP05MgMgk^k^k^k^MgMg^k^k05O<c<`00fIVVLc<c<c<
c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=V
IYWoooo<c<`04/c<c003ooooMgMgk^k^00?^k^h01[^k^fHcI_ooonk^kYVI
VHR8R0;^k^h00gMgMlc<c<c<c01Fc<c<00=VIYW<c<c<c<`0olc<c?S<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<01;<
c<`00ooooc<c<oooo`0;k^k^00=gMgO<c<c<c<`0E/c<c003IVJIc<c<c<c<
0?o<c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIV
VOooolc<c00Bc<c<00?ooolc<c=gMgL037MgM`03ooooc<c<c<c<05G<c<`0
0fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00=VIYWoooo<c<`0NLc<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c01ic<c<
00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003IVJIooooc<c<07W<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0NLc<
c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00fIVVOooolc<c01ic<c<00=VIYW<c<c<c<`0olc<c?S<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<01;<
c<`00oooohR8R4A4A006A4A400<c<c=4A4A4A4@00dA4A003VIVIc<c<c<c<
01o<c<`80000;/c<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c00Bc<c<00?ooom4A4AV
IVH00gMgM`03IVIVMgMgMgMg00EgMgL00c<c<lc<c<c<c01Fc<c<00=VIYW<
c<c<c<`0olc<c?S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003IVJIooooc<c<01;<c<`03?oooc<c<nk^k^k^k[^k^gMgMjZZZ_ooonk^
k]gMgGMgMmgMg@;^k^h00gMgMlc<c<c<c01Fc<c<00=VIYW<c<c<c<`0olc<
c?S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIoooo
c<c<00K<c<`6oooo1/c<c006oooo<c<cooook^k^MgMg03?<0S<c0008A4A4
<`0c000RIP1VMgMgooooMgMg^k^k1<c<c0800004c<c<0P000003c<c<0000
000000800002c<c<0P000003c<c<0000000000?<c<`400001<c<c0@00003
c<c<1@0000;<c<`200009<c<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c005c<c<00?o
oomVIVIVIVH00fIVIP03c<c<ooooc<c<00C<c<`03oooogMgMnk^k^k^kVIV
IP1Vo`1Vc4A4A3<0<c<c<gMgMc<0<hR8R>k^kVIVIP05c<c<0P0000?<c<`2
000000?<c<`0000000000/c<c08000001Lc<c000000000000<c<c0020000
00?<c<`0000000000/c<c0800002c<c<0P0000;<c<`2000000?<c<`00000
00000/c<c08000000lc<c0000000000Uc<c<00=VIYW<c<c<c<`0olc<c?S<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<
00G<c<`00fIVI/c<c<c<c003c<c<00=VIVK<c<coool01<c<c005oooo<c<c
k^k^gMgM4A4A0080I_l023=Vc28R8XR8R9VIVB8R8]gMgNk^kWMgM`G<c<`2
00000lc<c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<
c<`2000000?<c<`0000000000/c<c08000000lc<c00000000006c<c<0P00
00;<c<`2000000?<c<`0000000009Lc<c003IVJIc<c<c<c<0?o<c<chc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c004
c<c<00=VIVKoooo<c<`00`0000;<c<`00fIVI_ooolc<c003c<c<00Kooolc
<c?^k^hc<c<c03<001428R8R00P0<c<c03<A0000000c<c>k^k]gMgNk^k/4
c<c<0P0000;<c<`200000/c<c0800002c<c<0P000003c<c<0000000000;<
c<`2000000?<c<`0000000000/c<c08000000lc<c00000000007c<c<0P00
0004c<c<00000000c<c<0P0002G<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`01<c<
c003IVIVoooo000000@000000lc<c6IVI_ooo`04c<c<00oooomgMgMV<fIV
<fIgMgN8R8QVIVHc<`00<l`0I/`c06H0001V<fHc<c=gMgL01Lc<c0H00002
c<c<0P0000;<c<`2000000?<c<`0000000000/c<c08000000lc<c0000000
0002c<c<0P000003c<c<0000000000S<c<`4000000?<c<`0000000009Lc<
c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00fIVVOooolc<c004c<c<00=VIVKoool0000010000003c<c<
IVIVoooo00C<c<`02OooodA4A3<0<l`0c6HcIVIVIQ4009UV0<bI000206K<
0YT0V@03^k^kMgMgc<c<00C<c<`200000lc<c0800002c<c<00<0003<c<c<
c<`00P000005c<c<000000000000c<c<00800002c<c<00<0003<c<c<c<`0
0P000003c<c<0000000000K<c<`010000<c<c<c<c<c<c08000000lc<c000
0000000Uc<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<00C<c<`00fIVI_ooo`000004
000000?<c<aVIVKoool01<c<c004oooo<c<cc<c<A4A40P00000:<`0cIVH0
ol`0VFH0IP1Vc03oIP1VIS=VMgMg^k^k1<c<c0800003c<c<0P0000;<c<`4
00000/c<c08000000lc<c00000000003c<c<100000;<c<`200001lc<c0@0
00000lc<c0000000000200009<c<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c004c<c<
00=VIVK<c<coool00`0000;<c<`00fIVI_ooolc<c003c<c<00OooomgMgO^
k^k^k^hR8R:I09UV<fH00VH0IP06<`0cVFH04A4Ac<c<k^k^MgMg1Lc<c080
0003c<c<0P0000S<c<`200003Lc<c0800002c<c<0P0000S<c<`200009Lc<
c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00fIVVOooolc<c005c<c<00=VIVK<c<coool00oooo`03IVIV
ooooc<c<00C<c<`01_ooodA4A>k^kYVIVA4A4DA4A0;<0<`019T0V@0cI/bI
07MgM`;^k^h00gMgMlc<c<c<c003c<c<1P0000W<c<`200003/c<c0@0000:
c<c<00<0003<c<c<c<`08lc<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c006c<c<1FIV
IPO<c<`02Ooooc<c<nk^kWMgMc<c<fIVIS<c<l`0c4A4A00203=V00EgMgO^
k^k^k^igMgNk^k/0Elc<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c00Bc<c<00?ooomg
MgO^k^h00nk^kP06^k^kIS=Vooook^k^VIVIR8R80^k^kP03MgMgc<c<c<c<
05K<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00=VIYWoooo<c<`04/c<c003oooo<c<coooo00_^k^h0
0gMgMlc<c<c<c01Fc<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<01;<c<`00ooooc<c
<gMgM`0<MgMg00?oooo<c<c<c<`0ELc<c003IVJIc<c<c<c<0?o<c<chc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c01i
c<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c003IVJIooooc<c<07W<c<`00fIVVLc<c<c<c03oc<c<n<c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0
NLc<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00fIVVOooolc<c01ic<c<00=VIYW<c<c<c<`0olc<c?S<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<
07W<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00=VIYWoooo<c<`04/c<c003ooooR8R8A4A400I4A4@0
0c<c<dA4A4A4A003A4A400>IVIW<c<c<c<`04Lc<c0L0000mc<c<00=VIYW<
c<c<c<`0olc<c?S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003IVJIooooc<c<01;<c<`00oooodA4A6IVIP03MgMg00=VIVIgMgMgMgL0
1GMgM`03<c<cc<c<c<c<05K<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`04/c<c00<
oooo<c<ck^k^k^k^^k^kMgMgZZZZooook^k^gMgMMgMggMgM0^k^kP03MgMg
c<c<c<c<05K<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`01/c<c0Koool6c<c<00Ko
oolc<c?oooo^k^igMgL0<l`2<c<000Q4A4@c03<0029V06IgMgOooomgMgNk
^k/4c<c<0P0000C<c<`2000000?<c<`0000000000P0000;<c<`2000000?<
c<`0000000000lc<c0@00002c<c<1P0000?<c<`400000lc<c0D000000lc<
c0000000000Nc<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<00G<c<`00oooofIVIVIV
IP03IVIV00?<c<coooo<c<`01<c<c00?ooooMgMgk^k^k^k^IVIV06Ko06K<
A4A4<`0c<c<cMgMg<`0cR8R8k^k^IVIV00G<c<`200000lc<c08000000lc<
c00000000002c<c<0P000005c<c<000000000000c<c<008000000lc<c000
00000002c<c<0P000003c<c<0000000000?<c<`2000000?<c<`000000000
0/c<c08000000lc<c00000000002c<c<0P000003c<c<0000000001k<c<`0
0fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00=VIYWoooo<c<`01Lc<c003IVIVc<c<c<c<00?<c<`00fIVI/c<
c?ooo`04c<c<00Gooolc<c?^k^kMgMdA4A400P1Vo`08<fK<8R8RR8R8VIVI
8R8RgMgMk^k^MgMg1Lc<c0800003c<c<0P000003c<c<0000000000;<c<`2
000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P000003
c<c<0000000000?<c<`2000000?<c<`0000000001Lc<c0800002c<c<0P00
0003c<c<0000000001k<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`01<c<c003IVIV
ooooc<c<00G<c<`00fIVI_ooolc<c003c<c<00Kooolc<c?^k^hc<c<c03<0
01428R8R00P0<c<c03<A0000000c<c>k^k]gMgNk^k/4c<c<0P0000;<c<`2
00000/c<c0800002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0
000000000/c<c08000000lc<c00000000003c<c<0P000003c<c<00000000
00@00002c<c<0P000004c<c<00000000c<c<0P0001k<c<`00fIVVLc<c<c<
c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=V
IYWoooo<c<`01<c<c003IVIVooooc<c<00G<c<`00fIVI_ooolc<c003c<c<
00oooomgMgMV<fIV<fIgMgN8R8QVIVHc<`00<l`0I/`c06H0001V<fHc<c=g
MgL01Lc<c0H00002c<c<0P0000;<c<`2000000?<c<`0000000000/c<c080
00000lc<c00000000002c<c<0P000003c<c<0000000000@00002c<c<0P00
00;<c<`200000lc<c0@000000lc<c0000000000Nc<c<00=VIYW<c<c<c<`0
olc<c?S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJI
ooooc<c<00C<c<`00fIVI_ooolc<c005c<c<00=VIVKoooo<c<`00lc<c009
ooooA4A4<`0cc03<IS=VIVIV4@00VFH0c9T00080I/`2V@2I00>k^k]gMgO<
c<`01<c<c0800003c<c<0P0000;<c<`00`000<c<c<c<c002000000G<c<`0
00000000003<c<`00P0000;<c<`00`000<c<c<c<c002000000?<c<`00000
00000lc<c08000000lc<c00000000002c<c<0P000003c<c<0000c<c<00;<
c<`2000000?<c<`0000000007/c<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c004c<c<
00=VIVKoooo<c<`01Lc<c003IVIVooooc<c<00?<c<`01?oooc<c<lc<c4A4
A08000002S<0<fIV0?o<09UV06H0I/`0ofH0IVHcIWMgMk^k^`C<c<`20000
0lc<c0800002c<c<100000;<c<`2000000?<c<`0000000000lc<c0@00002
c<c<0P0000?<c<`200000/c<c0@00003c<c<100000;<c<`400007<c<c003
IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00fIVVOooolc<c004c<c<00=VIVK<c<coool01Lc<c003IVIVoooo
c<c<00?<c<`01oooogMgMnk^k^k^kR8R8YT0VFHcIP02IP1V00Hc03>IIP0A
4A7<c<c^k^igMgL5c<c<0P0000?<c<`200002<c<c080000<c<c<0P0000?<
c<`20000;lc<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c005c<c<00=VIVK<c<coool0
0oooo`03IVIVooooc<c<00C<c<`01_ooodA4A>k^kYVIVA4A4DA4A0;<0<`0
19T0V@0cI/bI07MgM`;^k^h00gMgMlc<c<c<c003c<c<1P0000W<c<`20000
3<c<c0H0000`c<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<00K<c<`5IVIV1lc<c009
oooo<c<ck^k^MgMg<c<cIVIV<c<cc03<A4A40080<fH01GMgMnk^k^k^kWMg
Mk^k^`1Gc<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<01;<c<`00oooogMgMnk^kP03
k^k^00Jk^k]V<fKoooo^k^jIVIV8R8P2k^k^00=gMgO<c<c<c<`0E/c<c003
IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00fIVVOooolc<c00Bc<c<00?ooolc<c?oool02nk^kP03MgMgc<c<
c<c<05K<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`04/c<c003oooo<c<cMgMg00ag
MgL00oooolc<c<c<c01Ec<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<07W<c<`00fIV
VLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00=VIYWoooo<c<`0NLc<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c01ic<c<00=V
IYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003IVJIoooooooo07Woool00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<OFIVVOo<c<cjc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c01ic<c<00=V
IYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003IVJIooooc<c<07W<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0NLc<c003
IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00fIVVOooolc<c01ic<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<01;<c<`0
0oooohR8R4A4A006A4A400<c<c=4A4A4A4@00dA4A003VIVIc<c<c<c<01o<
c<`80000;/c<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c00Bc<c<00?ooom4A4AVIVH0
0gMgM`03IVIVMgMgMgMg00EgMgL00c<c<lc<c<c<c01Fc<c<00=VIYW<c<c<
c<`0olc<c?S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
IVJIooooc<c<01;<c<`03?oooc<c<nk^k^k^k[^k^gMgMjZZZ_ooonk^k]gM
gGMgMmgMg@;^k^h00gMgMlc<c<c<c01Fc<c<00=VIYW<c<c<c<`0olc<c?S<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<
00G<c<`9oooo1<c<c006oooo<c<cooook^k^MgMg03?<0S<c0008A4A4<`0c
000RIP1VMgMgooooMgMg^k^k1<c<c0800004c<c<0P000003c<c<00000000
00800002c<c<0P000003c<c<0000000000?<c<`400000/c<c0800007c<c<
1@000003c<c<0000000000;<c<`200000/c<c08000000lc<c00000000002
c<c<1@0001?<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`01<c<c003IVIVc<c<IVIV
00IVIVH00oooolc<c<c<c002c<c<00oooomgMgO^k^k^k^iVIVH0I_l0I/a4
A4@c03<c<c=gMgLc03>8R8S^k^iVIVH01Lc<c0800003c<c<0P000003c<c<
0000000000;<c<`2000000G<c<`000000000003<c<`00P000003c<c<0000
000000;<c<`2000000?<c<`0000000001/c<c0800002c<c<0P000003c<c<
0000000000;<c<`2000000C<c<`00000003<c<`3000000?<c<`000000000
0/c<c080000Cc<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<00C<c<`00fIVI_ooolc<
c005c<c<00=VIVKoooo<c<`00lc<c005oooo<c<ck^k^gMgM4A4A0080I_l0
23=Vc28R8XR8R9VIVB8R8]gMgNk^kWMgM`G<c<`200000lc<c08000000lc<
c00000000002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`00000
00000/c<c08000000lc<c00000000006c<c<0P0000;<c<`2000000?<c<`0
000000000/c<c08000000lc<c00000000002c<c<0P000003c<c<00000000
00;<c<`200004lc<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c004c<c<00AVIVKoool0
00000004c<c<00=VIVKoooo<c<`00lc<c006oooo<c<ck^k^<c<c<`0c000A
0R8R8P0803<c<`0c4@000000<c<c^k^kMgMg^k^k1<c<c0800002c<c<0P00
00;<c<`200000/c<c08000000lc<c00000000002c<c<0P000003c<c<0000
000000;<c<`2000000?<c<`000000000100000?<c<`2000000C<c<`00000
003<c<`200000/c<c08000000lc<c00000000002c<c<0P0000;<c<`20000
00?<c<`0000000004lc<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c004c<c<00=VIVKo
ool000000P0000?<c<`00fIVI_ooolc<c003c<c<00oooomgMgMV<fIV<fIg
MgN8R8QVIVHc<`00<l`0I/`c06H0001V<fHc<c=gMgL01Lc<c0H00002c<c<
0P0000;<c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002
c<c<0P000003c<c<0000000000?<c<`200000lc<c0@000000lc<c0000000
0002c<c<0P000003c<c<0000000000;<c<`200000lc<c0@0000Cc<c<00=V
IYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003IVJIooooc<c<00C<c<`00fIVI_ooo`00000300000/c<c003IVIV
ooooc<c<00?<c<`02OooodA4A3<0<l`0c6HcIVIVIQ4009UV0<bI000206K<
0YT0V@03^k^kMgMgc<c<00C<c<`200000lc<c0800002c<c<00<0003<c<c<
c<`00P000005c<c<000000000000c<c<00800002c<c<00<0003<c<c<c<`0
0P000003c<c<0000000000?<c<`2000000?<c<`0003<c<`00/c<c0800000
1Lc<c000000000000<c<c002000000C<c<`00000003<c<`3000000?<c<`0
003<c<`00/c<c080000Cc<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<00C<c<`01FIV
I_ooo`0000000<c<c002000000?<c<aVIVKoool01<c<c004oooo<c<cc<c<
A4A40P00000:<`0cIVH0ol`0VFH0IP1Vc03oIP1VIS=VMgMg^k^k1<c<c080
0003c<c<0P0000;<c<`400000/c<c08000000lc<c00000000003c<c<1000
00;<c<`200000lc<c0800002c<c<100000;<c<`2000000?<c<`000000000
0lc<c08000000lc<c00000000002c<c<100001C<c<`00fIVVLc<c<c<c03o
c<c<n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWo
ooo<c<`01<c<c004IVIVoooo000000000/c<c08000000fIVI_ooolc<c003
c<c<00OooomgMgO^k^k^k^hR8R:I09UV<fH00VH0IP06<`0cVFH04A4Ac<c<
k^k^MgMg1Lc<c0800003c<c<0P0000S<c<`200003<c<c0800003c<c<0P00
01?<c<`200006/c<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c004c<c<00=VIVKooooo
ool01?ooo`8000000oooolc<c<c<c002c<c<00Kooom4A4C^k^jIVITA4A54
A4@2c03<00BI09T0<fK<V@1gMgL2k^k^00=gMgO<c<c<c<`00lc<c0H00009
c<c<0P0000c<c<`600005<c<c080000Jc<c<00=VIYW<c<c<c<`0olc<c?S<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<
00C<c<`8IVIV0P0000C<c<`02Ooooc<c<nk^kWMgMc<c<fIVIS<c<l`0c4A4
A00203=V00EgMgO^k^k^k^igMgNk^k/0Elc<c003IVJIc<c<c<c<0?o<c<ch
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<
c00Bc<c<00?ooomgMgO^k^h00nk^kP06^k^kIS=Vooook^k^VIVIR8R80^k^
kP03MgMgc<c<c<c<05K<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`04/c<c003oooo
<c<coooo00_^k^h00gMgMlc<c<c<c01Fc<c<00=VIYW<c<c<c<`0olc<c?S<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<
01;<c<`00ooooc<c<gMgM`0<MgMg00?oooo<c<c<c<`0ELc<c003IVJIc<c<
c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0fIVVOooolc<c01ec<c<LfIVVOo<c<b<c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c01ec<c<00=VIYWoooo<c<`0Klc<
c003IVJIc<c<c<c<0?o<c<b:c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00fIVVOooooooo`1eoooo00=VIYWoooooool0Koooo`03IVJI
c<c<c<c<0?o<c<b:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00fIVVIVIc9VIc01eVIW<00=VIYVIVLbIVL`0KiVIc003IVJIc<c<c<c<
0?o<c<b:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIV
VIVIc9VIc01eVIW<00=VIYVIVLbIVL`0KiVIc003IVJIc<c<c<c<0?o<c<b:
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVIVIc9VI
c008VIW<00?ooon8R8Q4A4@01TA4A003<c<cA4A4A4A400=4A4@00iVIVIVI
c9VIc01KVIW<00=VIYVIVLbIVL`029VIc003ooooR8R8A4A400I4A4@00c<c
<dA4A4A4A003A4A400>IVIVIVLbIVL`0EIVIc003IVJIc<c<c<c<0?o<c<b:
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVIVIc9VI
c008VIW<00?ooom4A4AVIVH00gMgM`03IVIVMgMgMgMg00EgMgL00c<c<lc<
c9VIc00hVIW<0`00026IVL`00fIVVIVIc9VIc008VIW<00?ooom4A4AVIVH0
0gMgM`03IVIVMgMgMgMg00EgMgL00c<c<lc<c9VIc00_VIW<0P0000FIVL`2
000019VIc0<0000GVIW<00=VIYW<c<c<c<`0olc<c8[<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0/c<c003IVJIVIW<VIW<00RIVL`03?oooc<c
<nk^k^k^k[^k^gMgMjZZZ_ooonk^k]gMgGMgMmgMg@;^k^h00gMgMlc<c9VI
c00jVIW<0P00022IVL`00fIVVIVIc9VIc008VIW<00cooolc<c?^k^k^k^jk
^k]gMgNZZZ[oooo^k^kMgMegMgOMgMd2k^k^00=gMgO<c<bIVL`0;iVIc080
0005VIW<0P0000JIVL`200005YVIc003IVJIc<c<c<c<0?o<c<b:c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVIVIc9VIc008VIW<
00Kooolc<c?oooo^k^igMgL0<l`2<c<000Q4A4@c03<0029V06IgMgOooomg
MgNk^k/4VIW<0P0000BIVL`2000000>IVL`0000000000P0000:IVL`20000
00>IVL`0000000000iVIc0@00002VIW<0P0000>IVL`2000000>IVL`00000
00000YVIc08000000iVIc00000000002VIW<0P000003VIW<0000000000:I
VL`300007iVIc003IVJIVIW<VIW<00RIVL`01_oooc<c<oooonk^kWMgM`0c
c08c<`0024A4A3<0<`008VH0IWMgMoooogMgMk^k^`BIVL`2000019VIc080
00000iVIc0000000000200000YVIc08000000iVIc00000000003VIW<1000
00:IVL`200001iVIc080000019VIc000000009VIc08000000iVIc0000000
0002VIW<0P000003VIW<0000000000>IVL`300005IVIc003IVJIc<c<c<c<
0?o<c<b:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIV
VIVIc9VIc008VIW<013ooomgMgO^k^k^k^iVIVH0I_l0I/a4A4@c03<c<c=g
MgLc03>8R8S^k^iVIVK<c<`4VIW<0P0000>IVL`2000000>IVL`000000000
0YVIc08000001IVIc0000000000009VIc002000000>IVL`0000000000YVI
c08000000iVIc00000000003VIW<0P000004VIW<00000000VIW<0P000005
VIW<000000000000VIW<0080000019VIc0000000000000:IVL`300006IVI
c0030000VIW<VIW<00>IVL`00fIVVIVIc9VIc008VIW<013ooomgMgO^k^k^
k^iVIVH0I_l0I/a4A4@c03<c<c=gMgLc03>8R8S^k^iVIVK<c<`4VIW<0P00
00>IVL`2000000>IVL`0000000000YVIc08000001IVIc0000000000009VI
c002000000>IVL`0000000000YVIc08000000iVIc00000000006VIW<0P00
0005VIW<000000000000VIW<00<0000019VIc000000009VIc0<000000iVI
c00000000002VIW<0`0001FIVL`00fIVVLc<c<c<c03oc<c<R/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYVIVLbIVL`029VIc005
oooo<c<ck^k^gMgM4A4A0080I_l02C=Vc28R8XR8R9VIVB8R8]gMgNk^kWMg
Mlc<c004VIW<0P0000>IVL`2000000>IVL`0000000000YVIc08000000iVI
c00000000002VIW<0P000003VIW<0000000000:IVL`2000000>IVL`00000
00000YVIc0800002VIW<0P000003VIW<0000000000:IVL`2000000>IVL`0
000000000YVIc080000019VIc000000009VIc080000HVIW<0P0000BIVL`0
0fIVVIVIc9VIc008VIW<00Gooolc<c?^k^kMgMdA4A400P1Vo`09<fK<8R8R
R8R8VIVI8R8RgMgMk^k^MgMgc<c<00BIVL`200000iVIc08000000iVIc000
00000002VIW<0P000003VIW<0000000000:IVL`2000000>IVL`000000000
0YVIc08000000iVIc00000000006VIW<0P0000:IVL`2000000>IVL`00000
00000YVIc08000000iVIc00000000002VIW<0P000004VIW<00000000VIW<
0P0001BIVL`00fIVVLc<c<c<c03oc<c<R/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00=VIYVIVLbIVL`029VIc006oooo<c<ck^k^<c<c
<`0c000A0R8R8P0803<c<`0c4@000000<c<c^k^kMgMg^k^k19VIc0800002
VIW<0P0000:IVL`200000YVIc08000000iVIc00000000002VIW<0P000003
VIW<0000000000:IVL`2000000>IVL`0000000000YVIc0800002VIW<0P00
0003VIW<0000000000:IVL`2000000>IVL`0000000000YVIc080000019VI
c000000009VIc080000HVIW<0`0000>IVL`00fIVVIVIc9VIc008VIW<00Ko
oolc<c?^k^hc<c<c03<001428R8R00P0<c<c03<A0000000c<c>k^k]gMgNk
^k/4VIW<0P0000:IVL`200000YVIc0800002VIW<0P000003VIW<00000000
00:IVL`2000000>IVL`0000000000YVIc08000000iVIc000000000040000
0YVIc0800002VIW<0P000003VIW<0000000000:IVL`2000000>IVL`00000
00000YVIc080000019VIc000000009VIc080000DVIW<00=VIYW<c<c<c<`0
olc<c8[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJI
VIW<VIW<00RIVL`04?ooogMgMfHcIVHcIWMgMhR8R6IVIS<c000cc01Vc3<0
IP0006HcIS<c<gMgMlc<c0BIVL`600000YVIc0800002VIW<0P000003VIW<
0000000000:IVL`2000000>IVL`0000000000YVIc08000000iVIc0000000
000400000YVIc08000000iVIc00000000002VIW<0P000003VIW<00000000
00:IVL`2000000BIVL`00000002IVL`2000069VIc0@00002VIW<00=VIYVI
VLbIVL`029VIc00@ooooMgMgIS=VIS=VMgMgR8R8IVIV<c<003?<06K<<`1V
0000IS=V<c<cMgMgc<c<19VIc0H00002VIW<0P0000:IVL`2000000>IVL`0
000000000YVIc08000000iVIc00000000002VIW<0P000003VIW<00000000
00>IVL`2000000>IVL`0000000000YVIc08000000iVIc00000000002VIW<
0P000003VIW<0000000000:IVL`2000000BIVL`00000002IVL`2000059VI
c003IVJIc<c<c<c<0?o<c<b:c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00fIVVIVIc9VIc008VIW<00Wooom4A4@c03?<0<aV<fIVIVHA
002IIP3<V@000P1Vc0:I09T00k^k^gMgMlc<c004VIW<0P0000>IVL`20000
0YVIc0030000VIW<VIW<008000001IVIc0000000000009VIc00200000YVI
c0030000VIW<VIW<008000000iVIc0000000000300000iVIc080000019VI
c000000009VIc0<0000019VIc000000009VIc0D00003VIW<0P0001NIVL`4
00000YVIc003IVJIVIW<VIW<00RIVL`02OooodA4A3<0<l`0c6HcIVIVIQ40
09UV0<bI000206K<0YT0V@03^k^kMgMgc<c<00BIVL`200000iVIc0800002
VIW<00<0002IVLbIVL`00P000005VIW<000000000000VIW<00800002VIW<
00<0002IVLbIVL`00P000003VIW<0000000000>IVL`2000000>IVL`00000
00000YVIc08000001IVIc0000000000009VIc002000000FIVL`000000000
002IVL`0100000>IVL`200004iVIc003IVJIc<c<c<c<0?o<c<b:c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVIVIc9VIc008VIW<
00Cooolc<c?<c<a4A4@2000000Xc03=VIP3oc02IIP1V06K<0?mV06IV<fIg
MgNk^k/4VIW<0P0000>IVL`200000YVIc0@00002VIW<0P000003VIW<0000
000000>IVL`400000YVIc08000000iVIc00000000003VIW<0P0000:IVL`2
000000>IVL`0000000000YVIc08000000iVIc0000000000200000iVIc080
000GVIW<0`0000>IVL`00fIVVIVIc9VIc008VIW<00Cooolc<c?<c<a4A4@2
000000Xc03=VIP3oc02IIP1V06K<0?mV06IV<fIgMgNk^k/4VIW<0P0000>I
VL`200000YVIc0@00002VIW<0P000003VIW<0000000000>IVL`400000YVI
c0800003VIW<0P000003VIW<0000000000:IVL`2000000BIVL`00000002I
VL`200000YVIc080000019VIc000000009VIc0800003VIW<0P0001>IVL`0
0fIVVLc<c<c<c03oc<c<R/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00=VIYVIVLbIVL`029VIc007ooooMgMgk^k^k^k^8R8RV@2IIS=V
009V06H01c<0<iUV014A4Lc<c>k^kWMgMlc<c004VIW<0P0000>IVL`20000
29VIc080000<VIW<0P0000:IVL`200002IVIc0800005VIW<0P0001jIVL`2
000019VIc003IVJIVIW<VIW<00RIVL`01oooogMgMnk^k^k^kR8R8YT0VFHc
IP02IP1V00Lc03>IIP0A4A7<c<c^k^igMgO<c<`019VIc0800003VIW<0P00
00RIVL`2000039VIc0800003VIW<0P0002nIVL`00fIVVLc<c<c<c03oc<c<
R/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYVIVLbI
VL`029VIc006ooooA4A4k^k^VIVI4A4AA4A40/`0c004V@2I03=Vc9T0MgMg
0^k^kP03MgMgc<c<VIW<00>IVL`600002IVIc080000<VIW<0P0000>IVL`2
000000>IVL`0000000001IVIc0800005VIW<0P0001jIVL`00`0009VIc9VI
c003VIW<00=VIYVIVLbIVL`029VIc006ooooA4A4k^k^VIVI4A4AA4A40/`0
c004V@2I03=Vc9T0MgMg0^k^kP03MgMgc<c<VIW<00>IVL`600002IVIc080
000<VIW<1P00032IVL`00fIVVLc<c<c<c03oc<c<R/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00=VIYVIVLbIVL`029VIc009oooo<c<c
k^k^MgMg<c<cIVIV<c<cc03<A4A40080<fH01GMgMnk^k^k^kWMgMk^k^`1M
VIW<00=VIYVIVLbIVL`029VIc009oooo<c<ck^k^MgMg<c<cIVIV<c<cc03<
A4A40080<fH01GMgMnk^k^k^kWMgMk^k^`1GVIW<00=VIYW<c<c<c<`0olc<
c8[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIVIW<
VIW<00RIVL`00oooogMgMnk^kP03k^k^00Jk^k]V<fKoooo^k^jIVIV8R8P2
k^k^00=gMgO<c<bIVL`0G9VIc003IVJIVIW<VIW<00RIVL`00oooogMgMnk^
kP03k^k^00Jk^k]V<fKoooo^k^jIVIV8R8P2k^k^00=gMgO<c<bIVL`0EYVI
c003IVJIc<c<c<c<0?o<c<b:c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00fIVVIVIc9VIc008VIW<00?ooolc<c?oool02nk^kP03MgMg
c<c<VIW<05bIVL`00fIVVIVIc9VIc008VIW<00?ooolc<c?oool02nk^kP03
MgMgc<c<VIW<05JIVL`00fIVVLc<c<c<c03oc<c<R/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00=VIYVIVLbIVL`029VIc003oooo<c<c
MgMg00agMgL00ooooiVIc9VIc01KVIW<00=VIYVIVLbIVL`029VIc003oooo
<c<cMgMg00agMgL00ooooiVIc9VIc01EVIW<00=VIYW<c<c<c<`0olc<c8[<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIVIW<VIW<
07FIVL`00fIVVIVIc9VIc01_VIW<00=VIYW<c<c<c<`0olc<c8[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c>]VIYWoc<c<S<c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0MLc<c003
IVJIooooc<c<06o<c<`00fIVVLc<c<c<c03oc<c<R/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0MLc<c003IVJIoooo
oooo06ooool00fIVVLc<c<c<c03oc<c<R/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0MLc<c7=VIYWoc<c<S<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`02<c<
c003ooooR8R8A4A400I4A4@00c<c<dA4A4A4A003A4A400>IVIW<c<c<c<`0
7lc<c0P0000hc<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<00S<c<`00oooodA4A6IV
IP03MgMg00=VIVIgMgMgMgL01GMgM`03<c<cc<c<c<c<033<c<`40000;<c<
c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00fIVVOooolc<c008c<c<00cooolc<c?^k^k^k^jk^k]gMgNZ
ZZ[oooo^k^kMgMegMgOMgMd2k^k^00=gMgO<c<c<c<`0;lc<c0040000c<c<
c<c<c<c<0P0002_<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`02<c<c006oooo<c<c
ooook^k^MgMg03?<0S<c0008A4A4<`0c000RIP1VMgMgooooMgMg^k^k1<c<
c0800004c<c<0P000003c<c<0000000000800002c<c<0P000003c<c<0000
000000?<c<`400000/c<c0D00004c<c<100000?<c<`2000000?<c<`00000
0000:lc<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c008c<c<00oooomgMgO^k^k^k^iV
IVH0I_l0I/a4A4@c03<c<c=gMgLc03>8R8S^k^iVIVH01Lc<c0800003c<c<
0P000003c<c<0000000000;<c<`2000000G<c<`000000000003<c<`00P00
0003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c0800002c<c<
0P0000;<c<`2000000C<c<`00000003<c<`30000:lc<c003IVJIc<c<c<c<
0?o<c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIV
VOooolc<c008c<c<00Gooolc<c?^k^kMgMdA4A400P1Vo`08<fK<8R8RR8R8
VIVI8R8RgMgMk^k^MgMg1Lc<c0800003c<c<0P000003c<c<0000000000;<
c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P00
0003c<c<0000000000?<c<`2000000?<c<`0000000000/c<c08000000lc<
c00000000002c<c<0P0002_<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`02<c<c006
oooo<c<ck^k^<c<c<`0c000A0R8R8P0803<c<`0c4@000000<c<c^k^kMgMg
^k^k1<c<c0800002c<c<0P0000;<c<`200000/c<c08000000lc<c0000000
0002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000000lc<
c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`20000
:lc<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00fIVVOooolc<c008c<c<00oooomgMgMV<fIV<fIgMgN8
R8QVIVHc<`00<l`0I/`c06H0001V<fHc<c=gMgL01Lc<c0H00002c<c<0P00
00;<c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<
0P000003c<c<0000000000?<c<`2000000?<c<`0000000000/c<c0800000
0lc<c00000000002c<c<0P0002_<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`02<c<
c009ooooA4A4<`0cc03<IS=VIVIV4@00VFH0c9T00080I/`2V@2I00>k^k]g
MgO<c<`01<c<c0800003c<c<0P0000;<c<`00`000<c<c<c<c002000000G<
c<`000000000003<c<`00P0000;<c<`00`000<c<c<c<c002000000?<c<`0
000000000lc<c0800002c<c<00<0003<c<c<c<`00P000004c<c<00000000
c<c<0`0002_<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`02<c<c004oooo<c<cc<c<
A4A40P00000:<`0cIVH0ol`0VFH0IP1Vc03oIP1VIS=VMgMg^k^k1<c<c080
0003c<c<0P0000;<c<`400000/c<c08000000lc<c00000000003c<c<1000
00;<c<`200000lc<c0800002c<c<100000?<c<`2000000?<c<`000000000
:lc<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00fIVVOooolc<c008c<c<00OooomgMgO^k^k^k^hR8R:I
09UV<fH00VH0IP06<`0cVFH04A4Ac<c<k^k^MgMg1Lc<c0800003c<c<0P00
00S<c<`200003<c<c0800002c<c<0P0003[<c<`00fIVVLc<c<c<c03oc<c<
n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<
c<`02<c<c006ooooA4A4k^k^VIVI4A4AA4A40/`0c004V@2I03=Vc9T0MgMg
0^k^kP03MgMgc<c<c<c<00?<c<`600002Lc<c080000<c<c<1@0003_<c<`0
0fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00=VIYWoooo<c<`02<c<c009oooo<c<ck^k^MgMg<c<cIVIV<c<c
c03<A4A40080<fH01GMgMnk^k^k^kWMgMk^k^`1Qc<c<00=VIYW<c<c<c<`0
olc<c?S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJI
ooooc<c<00S<c<`00oooogMgMnk^kP03k^k^00Jk^k]V<fKoooo^k^jIVIV8
R8P2k^k^00=gMgO<c<c<c<`0H<c<c003IVJIc<c<c<c<0?o<c<chc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c008c<c<
00?ooolc<c?oool02nk^kP03MgMgc<c<c<c<063<c<`00fIVVLc<c<c<c03o
c<c<n<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWo
ooo<c<`02<c<c003oooo<c<cMgMg00agMgL00oooolc<c<c<c01Oc<c<00=V
IYW<c<c<c<`0olc<c?S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003IVJIooooc<c<07W<c<`00fIVVLc<c<c<c03oc<c<n<c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0NLc<c003
IVJIc<c<c<c<0?o<c<chc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00fIVVOooolc<c01ic<c<00=VIYW<c<c<c<`0olc<c?S<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0V=SH`03IVJIoooooooo07Woool0
0fIVVF=SHf=SH`3oHf=Sn6=SH`:8`;P1B9280@00000000J8`;S8h=R8`;R8
`;Sooon>SXimIVJIohj>S_V>SXh016=SHhS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2h0_ooo`03IVIVVIW<VIW<05JIVL`00fIVI_ooolc<c03oc<c<
olc<c1[<c<`01Hj>SV=SHhS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0
^0;oool00fIVIYVIc9VIc01FVIW<00=VIVKoooo<c<`0olc<c?o<c<`Jc<c<
00F>SXiSHf>8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P2oooo00=V
IVJIVLbIVL`0EYVIc003IVIVooooc<c<0?o<c<coc<c<6/c<c005SXj>Hf=S
R<2hR<2hB928004000000004R<2hb>3HR<2hR<2h0_ooo`03IVIVVIW<VIW<
00>IVL`00oooohR8R4A4A006A4A400<c<c=4A4A4A4@00dA4A003VIVIVIW<
VIW<00:IVL`80000=iVIc003IVIVooooc<c<0?o<c<coc<c<6/c<c005SXj>
Hf=SR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h0_ooo`03IVIVVIW<
VIW<00>IVL`00oooodA4A6IVIP03MgMg00=VIVIgMgMgMgL01GMgM`03<c<c
c<c<VIW<04:IVL`00fIVI_ooolc<c03oc<c<olc<c1[<c<`01Hj>SV=SHhS0
^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0;oool00fIVIYVIc9VIc003
VIW<00cooolc<c?^k^k^k^jk^k]gMgNZZZ[oooo^k^kMgMegMgOMgMd2k^k^
00=gMgO<c<bIVL`0@YVIc003IVIVooooc<c<0?o<c<coc<c<6/c<c005SXj>
Hf=SR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h0_ooo`03IVIVVIW<
VIW<00>IVL`01_oooc<c<oooonk^kWMgM`0cc08c<`0024A4A3<0<`008VH0
IWMgMoooogMgMk^k^`BIVL`2000019VIc08000000iVIc000000000020000
0YVIc08000000iVIc00000000003VIW<100000:IVL`6000000>IVL`00000
00000YVIc0<00003VIW<100000>IVL`400001YVIc003IVIVooooc<c<00G<
c<`5VIVI0lc<c0:IVIT2c<c<19VIV@?<c<`5VIVI00C<c<bIVIVIVIW<c<`2
VIVI0/c<c0:IVIT2c<c<19VIV@?<c<`2VIVI00?<c<bIVIVIVIT0olc<c>C<
c<`01Hj>SV=SHhS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0;oool0
0fIVIYVIc9VIc003VIW<013ooomgMgO^k^k^k^iVIVH0I_l0I/a4A4@c03<c
<c=gMgLc03>8R8S^k^iVIVK<c<`4VIW<0P0000>IVL`2000000>IVL`00000
00000YVIc08000001IVIc0000000000009VIc002000000>IVL`000000000
0YVIc08000000iVIc00000000005VIW<0P0000:IVL`300000YVIc0800002
VIW<0P000003VIW<0000000000:IVL`200001IVIc003IVIVooooc<c<00G<
c<`2VIVI0/c<c0:IVIT2c<c<0YVIV@03c<c<VIVIVIVI00;<c<`2VIVI00?<
c<bIVIVIVIT00/c<c0:IVIT01Lc<c9VIVIVIVIVIVLc<c002VIVI00C<c<bI
VIVIVIW<c<`2VIVI0/c<c0:IVIT01<c<c9VIVIVIVLc<c0>IVIWoc<c<i<c<
c005SXj>Hf=SR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h0_ooo`03
IVIVVIW<VIW<00>IVL`01Ooooc<c<nk^k]gMgA4A4@0206Ko00TcI/`R8R:8
R8RIVITR8R;MgMg^k^igMgO<c<`019VIc0800003VIW<0P000003VIW<0000
000000:IVL`2000000>IVL`0000000000YVIc08000000iVIc00000000002
VIW<0P000003VIW<0000000000FIVL`2000000BIVL`00000002IVL`20000
00>IVL`00000000029VIc0<00005VIW<00=VIVKoooo<c<`01Lc<c0:IVIT3
c<c<0YVIV@03c<c<VIVIVIVI00C<c<`3VIVI00?<c<bIVIVIVIT00/c<c0:I
VIT00lc<c9VIVIVIV@02c<c<0YVIV@04c<c<VIVIVIVIc<c<0YVIV@G<c<`2
VIVI0/c<c0:IVIWoc<c<i<c<c005SXj>Hf=SR<2hR<2hB928004000000004
R<2hb>3HR<2hR<2h0_ooo`03IVIVVIW<VIW<00>IVL`01_oooc<c<nk^kS<c
<c<0<`004@8R8R80200c<c<0<a40000003<c<k^k^gMgMk^k^`BIVL`20000
0YVIc0800002VIW<0P0000:IVL`2000000>IVL`0000000000YVIc0800000
0iVIc00000000002VIW<0P000003VIW<0000000000FIVL`2000000BIVL`0
0000002IVL`2000000>IVL`000000000100000:IVL`400001YVIc003IVIV
ooooc<c<00G<c<`2VIVI0lc<c0:IVIT00lc<c9VIVIVIV@02c<c<19VIV@?<
c<`2VIVI00C<c<bIVIVIVIW<c<`2VIVI0/c<c0:IVIT01<c<c9VIVIVIVLc<
c0JIVIT00lc<c9VIVIVIV@02c<c<0YVIVOo<c<cTc<c<00F>SXiSHf>8`;R8
`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P2oooo00=VIVJIVLbIVL`00iVI
c00@ooooMgMgIS=VIS=VMgMgR8R8IVIV<c<003?<06K<<`1V0000IS=V<c<c
MgMgc<c<19VIc0H00002VIW<0P0000:IVL`2000000>IVL`0000000000YVI
c08000000iVIc00000000002VIW<0P000003VIW<0000000000FIVL`20000
00BIVL`00000002IVL`2000000>IVL`0000000000YVIc080000019VIc000
0000000000RIVL`00fIVI_ooolc<c005c<c<0YVIV@?<c<`2VIVI00C<c<bI
VIVIVIW<c<`3VIVI1/c<c0BIVIT00lc<c9VIVIVIV@02c<c<0YVIV@04c<c<
VIVIVIVIc<c<0YVIV@;<c<`2VIVI00?<c<bIVIVIVIT00/c<c0:IVIWoc<c<
i<c<c005SXj>Hf=SR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h0_oo
o`03IVIVVIW<VIW<00>IVL`02OooodA4A3<0<l`0c6HcIVIVIQ4009UV0<bI
000206K<0YT0V@03^k^kMgMgc<c<00BIVL`200000iVIc0800002VIW<00<0
002IVLbIVL`00P000005VIW<000000000000VIW<00800002VIW<00<0002I
VLbIVL`00P000003VIW<0000000000FIVL`400000iVIc0@00002VIW<0P00
0003VIW<0000000000:IVL`200001IVIc003IVIVooooc<c<00G<c<`2VIVI
0lc<c0:IVIT01<c<c9VIVIVIVLc<c0:IVIT2c<c<0YVIV@03c<c<VIVIc<c<
00;<c<`2VIVI00G<c<bIVIVIVIVIVIW<c<`00YVIV@04c<c<VIVIVIVIc<c<
0YVIV@;<c<`2VIVI00C<c<bIVIVIVIW<c<`3VIVIolc<c>C<c<`01Hj>SV=S
HhS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0;oool00fIVIYVIc9VI
c003VIW<00Cooolc<c?<c<a4A4@2000000Xc03=VIP3oc02IIP1V06K<0?mV
06IV<fIgMgNk^k/4VIW<0P0000>IVL`200000YVIc0@00002VIW<0P000003
VIW<0000000000>IVL`400000YVIc0800005VIW<100000>IVL`2000000>I
VL`0000000000P0000>IVL`400001YVIc003IVIVooooc<c<00G<c<`2VIVI
0lc<c0:IVIT00lc<c9VIVIVIV@02c<c<19VIV@?<c<`4VIVI0/c<c0:IVIT0
0lc<c9VIVIVIV@02c<c<0YVIV@;<c<`4VIVI0lc<c0:IVIT00lc<c9VIVIVI
V@3oc<c<i<c<c005SXj>Hf=SR<2hR<2hB928004000000004R<2hb>3HR<2h
R<2h0_ooo`03IVIVVIW<VIW<00>IVL`01oooogMgMnk^k^k^kR8R8YT0VFHc
IP02IP1V00Lc03>IIP0A4A7<c<c^k^igMgO<c<`019VIc0800003VIW<0P00
00RIVL`2000039VIc080000PVIW<00=VIVKoooo<c<`01Lc<c0:IVIT2c<c<
0YVIVA?<c<`2VIVI1Lc<c0:IVIT<c<c<0YVIVOo<c<cTc<c<00F>SXiSHf>8
`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P2oooo00=VIVJIVLbIVL`0
0iVIc006ooooA4A4k^k^VIVI4A4AA4A40/`0c004V@2I03=Vc9T0MgMg0^k^
kP03MgMgc<c<VIW<00>IVL`600002IVIc080000<VIW<0P0000FIVL`20000
6IVIc003IVIVooooc<c<00G<c<`5VIVI0lc<c0:IVIT?c<c<0YVIV@G<c<`2
VIVI3<c<c0:IVIWoc<c<i<c<c005SXj>Hf=SR<2hR<2hB928004000000004
R<2hb>3HR<2hR<2h0_ooo`03IVIVVIW<VIW<00>IVL`02Ooooc<c<nk^kWMg
Mc<c<fIVIS<c<l`0c4A4A00203=V00EgMgO^k^k^k^igMgNk^k/0@iVIc003
IVIVooooc<c<0?o<c<coc<c<6/c<c005SXj>Hf=SR<2hR<2hB92800400000
0004R<2hb>3HR<2hR<2h0_ooo`03IVIVVIW<VIW<00>IVL`00oooogMgMnk^
kP03k^k^00Jk^k]V<fKoooo^k^jIVIV8R8P2k^k^00=gMgO<c<bIVL`0@YVI
c003IVIVooooc<c<0?o<c<coc<c<6/c<c005SXj>Hf=SR<2hR<2hB9280040
00000004R<2hb>3HR<2hR<2h0_ooo`03IVIVVIW<VIW<00>IVL`00ooooc<c
<oooo`0;k^k^00=gMgO<c<bIVL`0@YVIc003IVIVooooc<c<0?o<c<coc<c<
6/c<c005SXj>Hf=SR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h0_oo
o`03IVIVVIW<VIW<00>IVL`00ooooc<c<gMgM`0<MgMg00?ooonIVLbIVL`0
@IVIc003IVIVooooc<c<0?o<c<coc<c<6/c<c005SXj>Hf=SR<2hR<2hB928
004000000004R<2hb>3HR<2hR<2h0_ooo`03IVIVVIW<VIW<05NIVL`00ooo
olc<c<c<c03oc<c<olc<c1W<c<`01Hj>SV=SHhS0^8S0^4R@R00100000000
18S0^<SPf8S0^8S0^0;ooomJIVIVolc<c?o<c<`Lc<c<00F>SXiSHf>8`;R8
`;Q8T8P00@00000000B8`;S8h=R8`;R8`;SoooooooooogSoool01Hj>SV=S
HhS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^?ooooooooooNOooo`04
Hf=SR<2hR<2hB9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@
R04000000004R<2hb>3HR<2hR<2h5P00P0<00H0200:000@00X400h400h40
0h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<3
0@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25108AQP<2
4XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<H
R0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;
0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DX
SP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A
1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP02
1cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8
?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4
V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK
0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN
00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aL
X@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=
HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>
JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?
LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[
0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61
[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`
00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb
4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<D
U[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh
5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj
0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G
[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1000P003VjOa<d>U<d>U00Tc@jD6
00200`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X801X80
1X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<
Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<2
5HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT3
0ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=
0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl4
1Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B
1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD
00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8
@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT3
2DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YA
W@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`03
2eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aO
XPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eU
Y0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW
3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@04
3gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@
OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lA
Q:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba
00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<C
T[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ
]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TE
X;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_004
5Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n
5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3002000NKYo7ooon>N[JVVlBcZM:XWLRcZM800ZJKa005_;SMk^kdj^Wa
oooo<d>U00D0080300600P02P00400:100>100>100>10`04P@801H401005
PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;
Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@04
0aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`4
98d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5
:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A
00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7
>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9
AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN
2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ
0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X
3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@
OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh0
0a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@
/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf
0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<F
ZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C08000008H]<0@00000QRd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000BKYo7ooom/FZF_YLX2
_;SM00[ooOncZM;ooooooonl^=fGR[bXWLSVi^cooolc@jD400200`01P080
0X001002P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<1
1h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j5
0`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<4
7XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd0
0`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6
;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHd
TP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD
0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3
U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9
BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd3
2e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<
FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaP
XP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT
0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_
Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?
MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd2
4Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@A
QZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8B
SK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@0
0a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK
]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<E
X[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m
5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o0QRd`003b>3HB928B92800a8T8P00`000<SPf4R@R00=B92800@0
000H]<0H]<38h=P>B92800<0000H]<0H]<000XS0^058T8P10000000018S0
^<SPf8S0^8S0^08008002i^WlOooojRMb?oook>YdV1<VXij]WQU[ZRMb?oo
ooomo`03oooo00<c@jD0080008000`00P0<00H0200:000@00X400h400h40
0h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2008128<3
0@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD20Q250oooo`82
4HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<G
R0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;
0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>
00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_
T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87
=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8
?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9
A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK
0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]D
WP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP
00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R
3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>
JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X
3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ
0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<A
PJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`
0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[80
0a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<C
UKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL0
11FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj
0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]
_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C0
00?8h=R8`;R8`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd
`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0P00P00>VjOaoooooooofmc/H4bJThFj/jWB_;SMH4bJVHnnYY_4
b<?Ooooo<d>U1P00P0?oool200:000<00X7oooooool00_ooo`8018400`05
POooo`05PP0300J21?ooo`030@R20@R3oooo00?oool30@Z300Koool12h@1
2h@138Coool138@20@f400Coool13XGoool13XD20Pn500Coool248Goool2
48D20Q6600?oool24HH24XH00P8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL2
0QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:
0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDU
S@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?
0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B
1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7
>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL3
24:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI
0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YB
W@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO
10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaP
XPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eU
Y0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW
3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY
0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@
OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l0
0a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@B
S;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<C
T[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK
]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T0
11FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l
5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o
5k6o00<G/[l35k>o0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P00dR@R000
0<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0
000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00>VjOa
oooo_;SMVHnnooooe]7Mfmc/lokoYY_4k^kdQGJ`ThFjoooo<d>U1000P007
oooo006000600060oooo00:0oooo00<00h401_ooo`04P@04P@05POooo`05
PP801X802?ooo`07PP07PP47P_ooo`48P_ooo`48P`<12H<01?ooo`4:P`4:
Poooo`812h@00`4<Q?ooo`4<Q0020@f400Coool13XGoool13XD20Pn500?o
ool248Goool00oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`82
5XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X3
0af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=
0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l3
1Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86
<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`Li
U0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8
@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T3
2DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M
0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l4
2eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R
362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT
00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>
KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T3
3gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n
[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`03
4HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:<
/Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B
]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g
59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@04
5J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`F
ZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG
/Kl00aNb_`<G/kl26;C000C8h=R8`;R8`;R8`;P6000018S0^003B9280000
b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd
`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0^004B92800006;C06;C0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008003i^WlOoooiV?_YN:
_=CCj>n//omfNnjOZe]HYJJKa9JOdV1<V[bhgOoooc=3Y@03002000Ooool0
0H000H000H3oool00X3oool00`03P@06oooo00B100B1oooo00F1oooo0P06
PP08oooo00N200N20@N2oooo0@R2oooo0@R30`49P`09oooo0@Z3oooo0@^3
oooo0@^4oooo0@b4oooo00813H@01?ooo`4>QOooo`4>Q@823hD01?ooo`8@
QOooo`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<F
R0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@N
RP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@03
1BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^
T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB
00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@3
1c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G
00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:
VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;
Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJ
X0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R
0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@3
3FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW
0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mf
ZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8A
Ojd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166
[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=
/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]003
4i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g
0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR
^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF
[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb
_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`00
08S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h
00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOXZFjPb<?O
ThFjFdJCVHnn0WQU[P04@RN5[jG:oooo<d>U1000P0<00H000oooo`02P002
P@04oooo0P04P@03oooo00F1oooo00<01X84oooo00<1288128<128<00`49
P`09oooo0@Z3oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?ooo`4>QOoo
o`4>Q@823hD00oooo`8@QOooo`03oooo0P8AQP<24XH20Q>600@24hL258L2
58L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV90aV900@3
6XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`010@TS0@T
S@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZ
S`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y40
10HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`Lh
T`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G
246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6
V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:
DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;
Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ42
35nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS
00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH0
10i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?
LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m
[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^0a63[P03
4HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[43
4X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c
0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH2
59Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^003
5J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY
_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G
/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8
T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R000
00026;C000?8h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOaoooooooo00;o
ool02_n]/?mfNoW=e?g]k_ooojJKa8Ef/;bhgOoooc=3Y@D00803006000?o
ool00X000X400`03P@03oooo00B1oooo00801H401005P_ooo`06PP06PP80
1h800`47P_ooo`48PP020@R30oooo`812X<01oooo`4;Poooo`4;Q?ooo`4<
Q?ooo`020@f400Coool13XGoooooool20Pn500Koool248Goool248D24HKo
ool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP3
5hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;
0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DW
SPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@
00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB
1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8
?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H
2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J
0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;
E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P
0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ80
0`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=
J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L0
10m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ
0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60
[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`
0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK82
4Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<C
U;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L2
59fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j
0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/
_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o
0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8
`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^004R<2h
0P0000F8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P3002000ZQ[?;icMCR9Scd]KoR9ScdKGglhnWoooomkNko[K02oooo
00<c@jD0080008001000P0<00H000oooo`02P002P@03oooo0P04P@05oooo
00F100F100F2oooo00801X83oooo0P48PP030@R3oooo0@V300812H<20@Z3
00Coool12h<12hCoool20@b400Ooool13H@13HCoool13XGoool13XD00_oo
o`030Pn50Q250Q2500Coool0108AQP8BQP8BQP8BQP824hH0108CQ`8DQ`8D
Q`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<J
R@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=
12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?
00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@04
1S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC
1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8
@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI
00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YA
W0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]G
W`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<
Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<0
0`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP04
3VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mc
Z@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/
00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<A
Q:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<B
Rk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<3
4i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8D
V[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<E
X;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl
11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`
_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@
R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000
008H]<000lSPf8S0^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000fKYo7mkNkR9ScnmOSg
RIOdHVkcX:kdHVkooOoo[K3lhnWooolc@jD01`00P0<00H000oooo`02P002
P@0300>10`04P@801H401005PP06PP06PP06PP801h801@47PP48PP48P_oo
o`48P`030@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25
108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN8
0aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<4
88/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh5
9hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T004
1RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLe
TPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE
0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4
V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:
C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM
2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<
G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=
HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU
0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?
L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@
N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d0
0a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<B
R;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>
/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd
0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM
]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<E
Y;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d3
5jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H
]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h
00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^080
0002R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2002000>KYo7fb<cR9S`00_n]/007gb@^ojBNm[c5ojf`
kW^<oooo<d>U00P00803006000?oool00X000X400`03P@<0184200F100@0
1H801X801X801X8200N200D11h81288128;oool128<00`49P`04oooo0@Z3
0@Z30@^30P4;Q0<138@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@2
4hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV9
0aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`0
10@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZ
SPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`Ha
T@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7
=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0
UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6
V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`4
2U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN
00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aM
X@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=
Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/
YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X
00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/3
47b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^
0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4B
R[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008C
Sk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH
]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh
0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/3
5ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;
R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P0
0hS0^0800004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000>KYo7icMCgRIL00_ooo`07ojf`hAHd
ogIkojBNhRHlohUo<d>U00P00803006000?oool00X000X400`03P@<01842
00F100@01H801X801X801X8200N200@11h812881288128<4oooo0`4:P`03
0@^30@^40@^400<138@20@f400Coool13XD13XD13XD30Pn50`8@Q@@24HH3
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<3
68P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@Q
R`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5
:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=
V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<
G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R
3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD3
3VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X
3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdA
PJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD3
59Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM
^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8
h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P900000XS0^005B9280000
6;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2002000NKYo7oooocX:kdHVkoooogRIOicM@00_ooo`03
lj2^oooo<d>U00P0080300600P02P00400:100>100>100>10`04P@801H40
1005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<00`4;
P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>7
0QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<I
R@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@4
98`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5
:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I42
1S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC
00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H0
10Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9
AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@
W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP03
2eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ43
35jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S
0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H2
3VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ003
3g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l
[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<A
Pjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa
4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc
0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H3
59Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<E
WkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX
^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G
[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0
^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0
000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00;VjOa
ooooohUooooolj2^lI>Qoooooogolj2^oo_l<d>U00P0080300600P02P004
00:100>100>100>10`04P@801H401005PP06PP06PP06PP801h800`47PP48
PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn5
0`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<4
7h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=
1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086
;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7
=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9
@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:
BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<
Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`
Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?
MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd3
4H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<B
Qk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d
0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL
]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d2
5jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G
/kl26;C03lSPf0030000b>3Hb>3H00g8h=P00`0001Rd`1Rd`00?b>3H00<0
000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0@00803VjOa
00KoooocX:kd]Kof_<GkfMXc@jD900200`01P0800X001002P@03P@03P@03
P@<0184200F100@01H801X801X801X8200N200<11h81288128800P48P`<1
2H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8B
QP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR8
00<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/3
12:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>
0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946
<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087
=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10Pn
UP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH
0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/3
2TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h0
0`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ
35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeR
XP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZ
Y@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0ma
Z0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/3
47Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^
4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK00
11:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8C
Sk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF
]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPE
W[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX3
5ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^
_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;PF00200`01P0800X001002P@03P@03
P@03P@<0184200F100@01H801X801X801X8200N200<11h81288128800P48
P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D40Q66
0`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP3
0aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<4
8H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP03
1BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46
<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB
0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE
10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH
2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:
CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;
E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX004
35bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeR
XPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU
0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0ma
Z0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@
NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]
4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08B
RK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<C
S[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe
0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@E
WKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<F
YKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd0
0aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8
`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@R0400000
0003R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058T8P1000000000hS0^<SPf<SP
f03ob>3HolSPf7g8h=P1B9280@000000ohS0^?n8`;R1R<2h0@000000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?oo
l?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`
l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003o
oo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;o
l?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool0
0?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_oo
k^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003o
onKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;o
oooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^ko
onk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00
oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2
ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^
ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0
0?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooooooo
P_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^
k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^
003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooo
oh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooo
oon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?oo
k^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^
k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003o
onk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;o
k^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP004Oo^k^i_ong]kOook^k^
ooo^k^h2onk^kP001Oono_h4oogmo@03ookno_omoOgooOgm00?ooOgm0_on
o_h2oogmo@;oo_kn1?omoOd00oono_kooOgmoogmo@03oogmo@;oo_kn0_om
oOd2ooknoPCooOgm00?oo_knoogmoOomoOd00oomoOd2ooknoP;ooOgm0_on
o_h4oogmo@03ookno_omoOgooOgm00?ooOgm0_ono_h2oogmo@;oo_kn1?om
oOd00oono_kooOgmoogmo@03oogmo@;oo_kn0_omoOd2ooknoPCooOgm00?o
o_knoogmoOomoOd00oomoOd2ooknoP;ooOgm0_ono_h4oogmo@03ookno_om
oOgooOgm00?ooOgm0_ono_h2oogmo@;oo_kn1?omoOd00oono_kooOgmoogm
o@03oogmo@;oo_kn0_omoOd2ooknoPCooOgm00?oo_knoogmoOono_h01Oon
o_kooooooo3ooooo00000oo/k>cokNg]onc/k002on_[j`;ok>c/0oo[jn/0
1?oZj^[ojn_[on_[jooZj^X2on_[j`?oj^[Z0_oYjNT5on[ZjP03onWYjOoZ
j^[oj^[Z00Koj^[Z0_oYjNT5on[ZjP03onWYjOoZj^[oj^[Z00Koj^[Z0_oY
jNT5on[ZjP03onWYjOoZj^[oj^[Z00Koj^[Z0_oYjNT5on[ZjP03onWYjOoZ
j^[oj^[Z00Koj^[Z0_oYjNT5on[ZjP03onWYjOoZj^[oj^[Z00Koj^[Z0_oY
jNT5on[ZjP03onWYjOoZj^[oj^[Z00Koj^[Z0_oYjNT5on[ZjP03onWYjOoZ
j^[oj^[Z00;oj^[Z00Cojn_[on[Zj_o[jn_ojn_[0_oZj^X4on_[j`03onc/
k?o[jn_ok>c/00?ok>c/00?okNg]onc/k?o]kNd00oo]kNgoonk^k^cok^k^
0004on?Sh`;oh^;R0ooQhN400ooPh>3ohN7Qon3Ph003on3Ph0?ogmoO0ooP
h>001OoOgmooh>3PomoOgooPh>3ogmoO00;oh>3P00?ogmoOon3Ph?oPh>00
0ooOgml3on3Ph005omoOgooPh>3ogmoOon3Ph?oOgml00_oPh>000ooOgmoo
h>3Pon3Ph003omoOg`?oh>3P00GogmoOon3Ph?oOgmooh>3PomoOg`02on3P
h003omoOgooPh>3oh>3P00?ogmoO0ooPh>001OoOgmooh>3PomoOgooPh>3o
gmoO00;oh>3P00?ogmoOon3Ph?oPh>000ooOgml3on3Ph005omoOgooPh>3o
gmoOon3Ph?oOgml00_oPh>000ooOgmooh>3Pon3Ph003omoOg`?oh>3P00Go
gmoOon3Ph?oOgmooh>3PomoOg`02on3Ph003omoOgooPh>3oh>3P00?ogmoO
0ooPh>001OoOgmooh>3PomoOgooPh>3ogmoO00;oh>3P00?ogmoOon3Ph?oP
h>000ooOgml5on3Ph0?ohN7Q0_oRh^85on?Sh`03onCTi?oUiNGoi>CT00Co
iNGUoooVi^KYonKViP0000Koj^[ZonWYjOoYjNWojNWYonOWiooXj>P2onOW
i`?oi^KV0ooUiND00ooTi>CoiNGUonCTi009onCTi003onGUiOoTi>Coi>CT
00;oi>CT00?oiNGUonCTi?oTi>@02?oTi>@00ooUiNGoi>CTonCTi002onCT
i003onGUiOoTi>Coi>CT00Soi>CT00?oiNGUonCTi?oTi>@00_oTi>@00ooU
iNGoi>CTonCTi008onCTi003onGUiOoTi>Coi>CT00;oi>CT00?oiNGUonCT
i?oTi>@02?oTi>@00ooUiNGoi>CTonCTi002onCTi003onGUiOoTi>Coi>CT
00Soi>CT00?oiNGUonCTi?oTi>@00_oTi>@00ooUiNGoi>CTonCTi008onCT
i003onGUiOoTi>Coi>CT00;oi>CT00?oiNGUonCTi?oTi>@00ooUiND3onKV
iP04onOWiooVi^Koj>SXonOWi`?ojNWY00Koj^[Zon_[joo[jn_ojn_[ong]
kOo/k>`3ong]kOook^k^jOo^k^h00004ooWinOohn?SomoOgooKfmP;omOGe
00Com?Cdoo?clooclo?olo?c0_obl_85oo7al@03oo3`l?oalO7ol?3`00co
l?3`00?olO7aoo3`l?oalO403Oo`l?000ooalO7ol?3`oo7al@0=oo3`l003
oo7alOo`l?3olO7a00gol?3`00?olO7aoo3`l?oalO403Oo`l?000ooalO7o
l?3`oo7al@0=oo3`l003oo7alOo`l?3olO7a00col?3`1OoalO42oo;blP05
oo?cloobl_;om?CdooGemOodm?@00_ofm_H00oogmoOon?ShooWin@02oo[j
nP?oo?cl0_omoOd2ookno_ooooooj?ooool00003onOWiooVi^Koi>CT00;o
hn?S00Coh^;Ron7QhOoQhN7ogmoO0ooNg]h2omgMg@;og=cL00?ogMgMomcL
g?oLg=`00_oLg=`00ooMgMgog=cLomgMg@03omcLg003omgMgOoLg=cogMgM
00;og=cL00?ogMgMomcLg?oLg=`00_oLg=`00ooMgMgog=cLomgMg@03omcL
g003omgMgOoLg=cogMgM00;og=cL00?ogMgMomcLg?oLg=`00_oLg=`00ooM
gMgog=cLomgMg@03omcLg003omgMgOoLg=cogMgM00;og=cL00?ogMgMomcL
g?oLg=`00_oLg=`00ooMgMgog=cLomgMg@03omcLg003omgMgOoLg=cogMgM
00;og=cL00?ogMgMomcLg?oLg=`00_oLg=`00ooMgMgog=cLomgMg@03omcL
g003omgMgOoLg=cogMgM00;og=cL00?ogMgMomcLg?oLg=`00_oLg=`00ooM
gMgog=cLomgMg@03omcLg003omgMgOoLg=cogMgM00;og=cL00?ogMgMomcL
g?oLg=`00_oLg=`00ooMgMgog=cLomgMg@03omcLg003omgMgOoLg=cogMgM
00;og=cL00CogMgMomcLg?oMgMgogMgM0_oNg]h01OoOgmooh>3Pon3Ph?oQ
hN7oh^;R00;ohn?S00?oi>CTonKVi_oWinL00_oXj>P00ooYjNWoj^[Zon_[
j`02onc/k0?okNg]ooo^k^kWonk^kP000_oLg=`01OoJf][ofMWIomOGeooF
e]KoeMGE00;oe=CD00Codm?Com7AdOoAdM7odM7A1?o@d=07olo?c`03om3@
d?o?clooclo?00goclo?00?od=3@olo?coo?cll03Oo?cll00oo@d=3oclo?
olo?c`0=olo?c`03om3@d?o?clooclo?00goclo?00?od=3@olo?coo?cll0
3Oo?cll00oo@d=3oclo?olo?c`0=olo?c`03om3@d?o?clooclo?00Coclo?
1?o@d=02om7Ad@04om;Bd_oCdm?odm?ComGEe@;oe]KF00?of=SHomWIfOoJ
f]X00_oLg=`01OoNg]koh>3Pon7QhOoQhN7oh^;R00;ohn?S00Goi>CTonGU
iOoUiNGoi^KVonGUi@3oonKVi^Goi^KV00002?oRh^;oh>3PomkNg_oMgMgo
fm_Kom[Jf_oIfMWoemOG0_oEeMD2omCDe004om?CdooBd];od];Bom;BdW7o
dM7A0_oBd]82om?Cd`;oeMGE013oe]KFomOGeooIfMWof][Jom_KfooMgMgo
gmoOon3Ph?oShn?oi>CTonGUiOoVi^Koj>SXonWYjOoZj^[ojn_[0_o/k>`0
0oo^k^kokNg]onk^kP3oonk^k^Gok^k^00003?o_knookNg]on_[jooXj>So
inOWonGUiOoShn?oh^;Ron3Ph?oNg]kogMgMomcLg0;ofm_K00CofMWIom[J
f_oIfMWof=SH2OoIfMT01?oHf=SofMWIomWIfOoHf=P2omWIf@03omSHf?oI
fMWofMWI00OofMWI00Cof=SHomWIfOoIfMWof=SH0_oIfMT00ooHf=SofMWI
omWIf@07omWIf@04omSHf?oIfMWofMWIomSHf0;ofMWI00?of=SHomWIfOoI
fMT01ooIfMT01?oHf=SofMWIomWIfOoHf=P2omWIf@03omSHf?oIfMWofMWI
00OofMWI00Cof=SHomWIfOoIfMWof=SH0_oIfMT00ooHf=SofMWIomWIf@07
omWIf@04omSHf?oIfMWofMWIomSHf0;ofMWI00?of=SHomWIfOoIfMT01ooI
fMT02OoHf=SofMWIomWIfOoHf=SofMWIom[Jf_oIfMWofm_KomcLg002omgM
g@0?omkNg_oPh>3ohN7Qon?ShooUiNGoi^KVonSXj?o[jn_okNg]oo3`l?oa
lO7olo?cooKfm_ogmoOon?Sh00;on_[j00Coo?cloogmoOomoOgoo_knoooo
oooVooooo`0000[ogMgMom_KfooHf=SoeMGEom;Bd_o@d=3oclo?olg=cOo<
c<cobLW90_o8b<P00oo5aLGoa/K6olG5a@02olC4a0;o`l?300Ooa<C4ol?3
`oo3`l?oa<C4ol?3`oo4a<Co`l?300;oa<C400Go`l?3olC4a?o3`l?o`l?3
olC4a002ol?3``07olC4a?o3`l?o`l?3olC4a?o3`l?oa<C4ol?3``02olC4
a005ol?3`oo4a<Co`l?3ol?3`oo4a<@00_o3`l<01oo4a<Co`l?3ol?3`oo4
a<Co`l?3olC4a?o3`l<00_o4a<@01Oo3`l?oa<C4ol?3`oo3`l?oa<C400;o
`l?300Ooa<C4ol?3`oo3`l?oa<C4ol?3`oo4a<Co`l?300;oa<C400Go`l?3
olC4a?o3`l?o`l?3olC4a002ol?3``07olC4a?o3`l?o`l?3olC4a?o3`l?o
a<C4ol?3``02olC4a005ol?3`oo4a<Co`l?3ol?3`oo4a<@00_o3`l<01oo4
a<Co`l?3ol?3`oo4a<Co`l?3olC4a?o3`l<00_o4a<@01Oo3`l?oa<C4ol?3
`oo3`l?oa<C400;o`l?300Ooa<C4ol?3`oo3`l?oa<C4ol?3`oo4a<Co`l?3
00;oa<C400?o`l?3olC4a?o3`l<00_o4a<@00oo5aLGoa/K6olK6aP02olO7
a`0Bol[:b_o;bl_ocLg=olk>c_oAdM7odm?ComGEeOoHf=Sofm_KomcLg?oP
h>3ohN7Qon?ShooUiNGoi^KVonSXj?oYjNWoj^[Z0_o/k>`00oo]kNgok^k^
onk^kP3oonk^k^Cok^k^00001ooCdm?oclo?olc<c?o9bLWoalO7olG5aOo2
`/800_no_kl01?nl_;co^k^kokZj^_ni^KT2okNg]`03okFe]Onf][Ko]KFe
00;o]KFe0_nf][H2okFe]@;o][Jf00Oo]KFeokJf]_ne]KGo]KFeokJf]_ne
]KGo][Jf00?o]KFe0_nf][H2okFe]@;o][Jf00Oo]KFeokJf]_ne]KGo]KFe
okJf]_ne]KGo][Jf00?o]KFe0_nf][H2okFe]@;o][Jf00Oo]KFeokJf]_ne
]KGo]KFeokJf]_ne]KGo][Jf00?o]KFe0_nf][H2okFe]@;o][Jf00Oo]KFe
okJf]_ne]KGo]KFeokJf]_ne]KGo][Jf00?o]KFe0_nf][H2okFe]@;o][Jf
00Oo]KFeokJf]_ne]KGo]KFeokJf]_ne]KGo][Jf00?o]KFe0_nf][H2okFe
]@;o][Jf00Oo]KFeokJf]_ne]KGo]KFeokJf]_ne]KGo][Jf00?o]KFe0_nf
][H2okFe]@;o][Jf00Ko]KFeokJf]_ne]KGo]KFeokJf]_ne]KD2okJf]P0C
okNg]oni^KWo^[Zjok^k^onl_;co_[jnol30`?o2`/;oa<C4olO7aoo9bLWo
c<c<olo?cooBd];oeMGEomOGeooIfMWog=cLomgMg@02on3Ph004on;Rh_oS
hn?oi>CTonGUiOooi^KVi_oVi^H0000;omKFe_oCdm?oclo?olc<c?o8b<So
aLG5ol?3`oo0`<3o_[jnokbl_?nj^[X00_nh^;P01?nf][Ko];BdokBd]?nd
];@2ok>c/`03okBd]?nc/k?o/k>c00Ko/k>c00?o];Bdok>c/onc/k<01?nc
/k<00ond];Co/k>cok>c/`06ok>c/`03okBd]?nc/k?o/k>c00Co/k>c00?o
];Bdok>c/onc/k<01_nc/k<00ond];Co/k>cok>c/`04ok>c/`03okBd]?nc
/k?o/k>c00Ko/k>c00?o];Bdok>c/onc/k<01?nc/k<00ond];Co/k>cok>c
/`06ok>c/`03okBd]?nc/k?o/k>c00Co/k>c00?o];Bdok>c/onc/k<01_nc
/k<00ond];Co/k>cok>c/`04ok>c/`03okBd]?nc/k?o/k>c00Ko/k>c00?o
];Bdok>c/onc/k<00_nd];@05one]KGo][JfokRh^?nh^;So^KViokbl_?nm
_Kgo`<30ol;2`_o6a/Kob<S8olc<c?o?clood];BomKFe_oIfMWog=cLomoO
gooRh^;oi>CTonGUiOoXj>SojNWY00;ojn_[0_o]kNgoonk^k^Gok^k^0000
3?oQhN7ogMgMomWIfOoEeMGodM7Aolg=cOo:b/[oa/K6olC4a?o1`L7o_[jn
okfm_@;o^[Zj0_nh^;P3okJf]P;o]kNg00Co][JfokNg]onf][Ko]kNg0_nf
][H01Ong]kOo][JfokNg]onf][Ko]kNg00?o][Jf0_ng]kL01?nf][Ko]kNg
okJf]_ng]kL2okJf]P05okNg]onf][Ko]kNgokJf]_ng]kL00onf][H2okNg
]`04okJf]_ng]kOo][JfokNg]`;o][Jf00Go]kNgokJf]_ng]kOo][JfokNg
]`03okJf]P;o]kNg00Co][JfokNg]onf][Ko]kNg0_nf][H01Ong]kOo][Jf
okNg]onf][Ko]kNg00?o][Jf0_ng]kL01?nf][Ko]kNgokJf]_ng]kL2okJf
]P05okNg]onf][Ko]kNgokJf]_ng]kL00onf][H2okNg]`04okJf]_ng]kOo
][JfokNg]`;o][Jf00Go]kNgokJf]_ng]kOo][JfokNg]`03okJf]P;o]kNg
00Co][JfokNg]onf][Ko]kNg0_nf][H01?ng]kOo][JfokNg]onf][H2okNg
]`0KokRh^?ni^KWo^k^kokfm_Onn_[ko`L71ol?3`oo6a/KobLW9olg=cOoA
dM7oe=CDomWIfOoMgMgoh^;RonGUiOoYjNWojn_[oo3`l?oclo?om?CdooOg
mooinOWono_kooclo?omoOgoo_kn0?ooooooiOooool0000?olo?coo9bLWo
aLG5ol71`Onl_;co^KViokBd]?nb/[;o[Zj^ojb/[?nZZZ[oYjNWojFUYOnT
Y:CoXZ:R00;oXJ6Q00SoX:2Poj6QXOnQXJ7oX:2Poj6QXOnPX:3oXJ6Qoj2P
X0?oXJ6Q00KoX:2Poj6QXOnPX:3oX:2Poj6QXOnPX:02oj6QX@05oj2PX?nQ
XJ7oX:2Poj6QXOnPX:000onQXJ401_nPX:3oXJ6Qoj2PX?nPX:3oXJ6Qoj2P
X0;oXJ6Q00GoX:2Poj6QXOnPX:3oXJ6Qoj2PX003oj6QX@06oj2PX?nQXJ7o
X:2Poj2PX?nQXJ7oX:2P0_nQXJ401OnPX:3oXJ6Qoj2PX?nQXJ7oX:2P00?o
XJ6Q00KoX:2Poj6QXOnPX:3oX:2Poj6QXOnPX:02oj6QX@05oj2PX?nQXJ7o
X:2Poj6QXOnPX:000onQXJ401_nPX:3oXJ6Qoj2PX?nPX:3oXJ6Qoj2PX0;o
XJ6Q00GoX:2Poj6QXOnPX:3oXJ6Qoj2PX003oj6QX@06oj2PX?nQXJ7oX:2P
oj2PX?nQXJ7oX:2P0_nQXJ401OnPX:3oXJ6Qoj2PX?nQXJ7oX:2P00?oXJ6Q
00CoX:2Poj6QXOnPX:3oX:2P0_nRXZ806?nTY:CoYJFUojNWYonZZZ[o[:b/
ojn_[ona/K7o]KFeokVi^Onl_;co`L71olG5aOo9bLWoc/k>om?CdooFe]Ko
fm_KomkNg_oPh>3oi>CTonKVi_oXj>SojNWYon_[j`;okNg]ooo^k^kUonk^
kP0000goa<C4okno_onj^[[o];Bdok2`/?n/[:coYjNWojFUYOnQXJ7oWYjN
oi^KVonIVIWoUYJF00;oUIFE00?oU9BDoi>CTonBTY801?nBTY801OnATI7o
TY:Boi:BT_nBTY;oTI6A00_oTY:B00GoTI6Aoi:BT_nBTY;oTY:Boi6AT@0;
oi:BTP05oi6ATOnBTY;oTY:Boi:BT_nATI402onBTY801OnATI7oTY:Boi:B
T_nBTY;oTI6A00_oTY:B00GoTI6Aoi:BT_nBTY;oTY:Boi6AT@0;oi:BTP05
oi6ATOnBTY;oTY:Boi:BT_nATI402onBTY801OnATI7oTY:Boi:BT_nBTY;o
TI6A00CoTY:B0_nCTi<2oiFEU@0IoiJFU_nIVIWoVi^KoifMWOnQXJ7oYJFU
ojNWYon[Zj_o[jn_okBd]?nj^[[o_knoolC4a?o8b<SocLg=om3@d?oDe=Co
f=SHom[Jf_oLg=cogmoOon7QhOoShn?oi>CTonGUi@3oonKVi^Goi^KV0000
4Oo7alOo`L71okZj^_nf][Ko/;2`oj^[ZonWYjOoXZ:RoinOWonKVi_oV9RH
oiJFU_nCTi?oTY:Boi2@T?n?ShooSXj>00OoSHf=00CoSXj>ohf=SOn=SHgo
SXj>3?n=SHd01?n>SXkoSHf=ohf=SOn>SXh<ohf=S@04ohj>S_n=SHgoSHf=
ohj>SPcoSHf=00CoSXj>ohf=SOn=SHgoSXj>3?n=SHd01?n>SXkoSHf=ohf=
SOn>SXh<ohf=S@04ohj>S_n=SHgoSHf=ohj>SPcoSHf=00CoSXj>ohf=SOn=
SHgoSXj>0on=SHd07On>SXkoShn?oi2@T?nATI7oTi>CoiFEUOnHV9SoVi^K
oijNW_nRXZ;oYZJVoj^[Zon`/;3o]KFeok^k^oo1`L7oa/K6olc<c?oAdM7o
eMGEomWIfOoMgMgoh>3PonCTi?oVi^KojNWYon[Zj_o/k>cokNg]0?ook^k^
iOo^k^h0000?om7AdOo:b/[o`l?3okfm_Ong]kOo/;2`oj^[ZonVYZKoXJ6Q
oinOWonJVY[oUiNGoiFEUOnBTY;oT92@00;oShn?3?n>SXh00on=SHgoSXj>
ohj>SP0=ohj>SP03ohf=SOn>SXkoSXj>00goSXj>00?oSHf=ohj>S_n>SXh0
3On>SXh00on=SHgoSXj>ohj>SP0=ohj>SP03ohf=SOn>SXkoSXj>00goSXj>
00?oSHf=ohj>S_n>SXh03On>SXh07on=SHgoSXj>ohn?Son?ShooT92@oi:B
T_nEUIGoV9RHoiZJV_nNWYkoXJ6QojJVY_n/[:co/;2`okJf]_nm_Kgo`/;2
ol[:b_oAdM7oemOGomcLg?oRh^;oinOWonc/k?o_knoolo?cooKfm_ohn?So
no_kooclo?ono_h0oooooooUooooo`00013o_knookVi^Onb/[;oZj^[ojBT
Y?nOWiooVYZJoiBDU?nATI7oS8b<ohR8R?n5QHGoPh>3oh20P?moOgooOGem
0_mlO7`3og]kN`;oO7al00CoNg]kogalO?mlO7coNg]k0_mlO7`01OmkNg_o
O7alogalO?mkNg_oO7al00?oNg]k0_mlO7`01?mkNg_oO7alogalO?mkNg/2
ogalO005og]kNomlO7coO7alog]kNomlO7`00omkNg/2ogalO004og]kNoml
O7coO7alog]kN`;oO7al00GoNg]kogalO?mlO7coNg]kogalO003og]kN`;o
O7al00CoNg]kogalO?mlO7coNg]k0_mlO7`01OmkNg_oO7alogalO?mkNg_o
O7al00?oNg]k0_mlO7`01?mkNg_oO7alogalO?mkNg/2ogalO005og]kNoml
O7coO7alog]kNomlO7`00omkNg/2ogalO004og]kNomlO7coO7alog]kN`;o
O7al00GoNg]kogalO?mlO7coNg]kogalO003og]kN`;oO7al00CoNg]kogal
O?mlO7coNg]k0_mlO7`07omkNg_oO7alogalO?mmOGgoOgmooh20P?n2PX;o
QHF5ohV9ROn<S8coT92@oiFEUOnJVY[oWYjNojFUYOn[Zj_o/K6aokVi^Ono
_kooa/K6ol_;booAdM7oeMGEom[Jf_oNg]koh^;RonCTi?oXj>Soj^[Zon_[
joo/k>`0ooo^k^kUonk^kP0001?o]KFeojj^[_nXZ:SoXJ6QoiZJV_nDU9Co
Shn?ohZ:R_n6QXKoPH61oginO_mjNW[oMgMgogIfM_mcLg?oLW9bog5aLOm`
L73oLG5a00OoL71`00CoLG5aog1`L?m`L73oLG5a1?m`L7000omaLG7oL71`
og1`L005og1`L004og5aLOm`L73oL71`og5aL@CoL71`00?oLG5aog1`L?m`
L7001Om`L7001?maLG7oL71`og1`L?maLG44og1`L003og5aLOm`L73oL71`
00GoL71`00CoLG5aog1`L?m`L73oLG5a1?m`L7000omaLG7oL71`og1`L005
og1`L004og5aLOm`L73oL71`og5aL@CoL71`00?oLG5aog1`L?m`L7001Om`
L7001?maLG7oL71`og1`L?maLG44og1`L003og5aLOm`L73oL71`00GoL71`
023oLG5aog1`L?m`L73oLG5aog1`L?maLG7oLW9bog=cLomeMGGoMgMgog]k
NommOGgoPH61ohF5QOn:RX[oSXj>oiBDU?nJVY[oX:2PojRXZ?n_[joo]KFe
ok^k^oo2`/;ob<S8olg=cOoBd];oeMGEomWIfOoLg=cogmoOon7Qh@;oi>CT
oooVi^KUonKViP0000go^KViok:b/_nYZJWoXZ:RoiZJV_nEUIGoShn?ohV9
ROn4Q8CoOgmoogalO?mhN7SoMGEe00;oLG5a00?oKfm_ofi^K_m]KFd02?m]
KFd00om^KVkoKFe]ofe]K@0=ofe]K@03ofi^K_m]KFgoKFe]00goKFe]00?o
KVi^ofe]KOm]KFd03Om]KFd00om^KVkoKFe]ofe]K@0=ofe]K@03ofi^K_m]
KFgoKFe]00goKFe]00?oKVi^ofe]KOm]KFd03Om]KFd00om^KVkoKFe]ofe]
K@02ofe]K@0Mofi^K_m_KfooL71`og9bL_meMGGoMgMgogalO?n0P83oQ8B4
ohV9ROn?ShooUIFEoi^KVonRXZ;oZJVYok:b/_ni^KWo`<30olO7aoo=cLgo
dm?ComOGeooLg=coh>3PonCTi?oWinOojNWYon_[joo/k>`0ooo^k^kUonk^
kP0000ooa<C4ok^k^onb/[;oZZZZoj6QXOnJVY[oU9BDohf=SOn8R8SoPh>3
ogemOOmjNW[oMWIfogAdM?maLG400_m_Kfm^ofi^KP0Mofm_Kom`L73oLG5a
ogAdM?mgMgOoNWYjoginO_n2PX;oR8R8ohf=SOnDU9CoVYZJoj:RX_nYZJWo
/[:bok^k^oo3`l?obl_;om?CdooJf][oh>3PonKVi_oZj^[okno_oo;bl_of
m_Kon_[joo_knoomoOd0oooooooUooooo`00017o];Bdojb/[?nSXj?oVi^K
oi>CTon<S8coQHF5oh20P?mjNW[oMGEeog1`L?m]KFgoJFUYofMWIomTI6Co
Hf=Sof9RHP08of5QH@03of1PH?mQHF7oHF5Q00goHF5Q00?oH61Pof5QHOmQ
HF403OmQHF400omPH63oHF5Qof5QH@0=of5QH@03of1PH?mQHF7oHF5Q00go
HF5Q00?oH61Pof5QHOmQHF403OmQHF400omPH63oHF5Qof5QH@0=of5QH@03
of1PH?mQHF7oHF5Q00?oHF5Q01goHV9Rof=SHomTI6CoIfMWofUYJOm]KFgo
LG5aogEeMOmjNW[oOgmoohF5QOn<S8coTi>Coi^KVonSXj?oZj^[okBd]?nm
_Kgo`l?3ol[:b_o?clooe]KFom_KfooOgmoohn?SonKVi_oXj>Sojn_[ong]
k@3oonk^k^Gok^k^00001?n/[:coY:BTooclo?olo?`4oo_kn`;oo?cl0_ok
no/00oolo?cono_kooclo002oo_kn`?oo?cl1?okno/2ooclo0;ono_k00?o
o?cloo_knoolo?`00_okno/3ooclo0Cono_k0_olo?`2oo_kn`03ooclo?ok
no_oo?cl00;ono_k0oolo?`4oo_kn`;oo?cl0_okno/00oolo?cono_koocl
o002oo_kn`?oo?cl1?okno/2ooclo0;ono_k00?oo?cloo_knoolo?`00_ok
no/3ooclo0Cono_k0_olo?`2oo_kn`03ooclo?okno_oo?cl00;ono_k0ool
o?`4oo_kn`;oo?cl0_okno/00oolo?cono_kooclo002oo_kn`?oo?cl1?ok
no/2ooclo0;ono_k00?oo?cloo_knoolo?`00_okno/3ooclo0Cono_k0_ol
o?`2oo_kn`0@ooclo?okno_oY:BTojb/[?nd];Co^k^kol71`Oo8b<Soc<c<
om;Bd_oFe]Kof][JomkNg_oQhN7ohn?SonCTi0?oi^KV00?oiNGUonKVi_oV
i^H0oooVi^KOonKViP0000Ko/K6aojNWYoohn?SonOWiooShn?oinOT3ooSh
n004ooWinOohn?Son?ShooWin@Con?Sh00GonOWiooShn?oinOWon?ShooWi
n@03ooShn004ooWinOohn?Son?ShooWin@Con?Sh00GonOWiooShn?oinOWo
n?ShooWin@03ooShn004ooWinOohn?Son?ShooWin@Con?Sh00GonOWiooSh
n?oinOWon?ShooWin@03ooShn004ooWinOohn?Son?ShooWin@Con?Sh00Go
nOWiooShn?oinOWon?ShooWin@03ooShn004ooWinOohn?Son?ShooWin@Co
n?Sh00GonOWiooShn?oinOWon?ShooWin@03ooShn004ooWinOohn?Son?Sh
ooWin@Con?Sh00GonOWiooShn?oinOWon?ShooWin@03ooShn004ooWinOoh
n?Son?ShooWin@Con?Sh00GonOWiooShn?oinOWon?ShooWin@03ooShn004
ooWinOohn?Son?ShooWin@Con?Sh00GonOWiooShn?oinOWon?ShooWin@03
ooShn00CooWinOohn?Son?ShooWinOohn?SoYjNWok6a/Onh^;So`<30olO7
aoo>c/kodm?ComWIfOoNg]koh^;RonGUiOoYjNWoj^[Zonc/k03oonk^k^Go
k^k^00001?nl_;co/K6aonk^k_o]kNd2onk^kP03ong]kOo^k^kokNg]00;o
k^k^0_o]kNd01oo^k^kokNg]onk^k_o^k^kokNg]onk^k_o]kNd00_o^k^h0
0oo]kNgok^k^ong]k@02onk^kP;okNg]00Ook^k^ong]kOo^k^kok^k^ong]
kOo^k^kokNg]00;ok^k^00?okNg]onk^k_o]kNd00_o^k^h2ong]k@07onk^
k_o]kNgok^k^onk^k_o]kNgok^k^ong]k@02onk^kP03ong]kOo^k^kokNg]
00;ok^k^0_o]kNd01oo^k^kokNg]onk^k_o^k^kokNg]onk^k_o]kNd00_o^
k^h00oo]kNgok^k^ong]k@02onk^kP;okNg]00Ook^k^ong]kOo^k^kok^k^
ong]kOo^k^kokNg]00;ok^k^00?okNg]onk^k_o]kNd00_o^k^h2ong]k@07
onk^k_o]kNgok^k^onk^k_o]kNgok^k^ong]k@02onk^kP03ong]kOo^k^ko
kNg]00;ok^k^0_o]kNd01oo^k^kokNg]onk^k_o^k^kokNg]onk^k_o]kNd0
0_o^k^h00oo]kNgok^k^ong]k@02onk^kP;okNg]00Ook^k^ong]kOo^k^ko
k^k^ong]kOo^k^kokNg]00;ok^k^00?okNg]onk^k_o]kNd00_o^k^h2ong]
k@0?onk^k_na/K7o_;blolC4a?o=cLgoeMGEomcLg?oRh^;oj>SXonc/k?oa
lO7omOGeooWinOolo?cooOgm0?ooooooiOooool00004ojj^[_nTY:ConOWi
ooWin@;on?Sh00ConOWiooShn?oinOWon?Sh0_oinOT00oohn?SonOWiooSh
n005ooShn0;omoOg1_ohn?P00oogmoOon?ShooShn005ooShn0;omoOg1_oh
n?P00oogmoOon?ShooShn005ooShn0;omoOg1_ohn?P00oogmoOon?ShooSh
n005ooShn0;omoOg1_ohn?P00oogmoOon?ShooShn005ooShn0;omoOg1_oh
n?P00oogmoOon?ShooShn005ooShn0;omoOg1_ohn?P00oogmoOon?ShooSh
n005ooShn0;omoOg1_ohn?P00oogmoOon?ShooShn003ooShn0;onOWi0_oh
n?P01?oinOWon?ShooWinOohn?P2ooWin@0@ooShn?oinOWoY:BTojf][Onf
][Ko_KfmolK6a_o=cLgod];BomSHf?oMgMgohN7QonGUiOoWinOojn_[ong]
kOook^k^iOo^k^h00003ojJVY_nMWIgom?Cd00ComOGe00Com?CdooGemOoe
mOGom?Cd1?oemOD00ooclo?om?Cdoo?cl`03oo?cl`04ooCdm?oclo?olo?c
ooCdm0Golo?c00?om?Cdoo?clooclo<01?oclo<01?odm?Colo?coo?clood
m?@5oo?cl`03ooCdm?oclo?olo?c00Colo?c00Com?Cdoo?clooclo?om?Cd
1Ooclo<00oodm?Colo?coo?cl`04oo?cl`04ooCdm?oclo?olo?cooCdm0Go
lo?c00?om?Cdoo?clooclo<01?oclo<01?odm?Colo?coo?cloodm?@5oo?c
l`03ooCdm?oclo?olo?c00Colo?c00Com?Cdoo?clooclo?om?Cd1Ooclo<0
0oodm?Colo?coo?cl`04oo?cl`04ooCdm?oclo?olo?cooCdm0Golo?c00?o
m?Cdoo?cloodm?@00_odm?@4ooGem@04ooCdm?oemOGomOGeooCdm0?omOGe
00koWYjNojJVY_n_[joo]kNgokjn__o5aLGobl_;om7AdOoEeMGofMWIomgM
gOoPh>3oh^;RonCTi0?oi^KV00?oiNGUonKVi_oVi^H0oooVi^KOonKViP00
00?o[:b/oj:RX_oZj^X00_oZj^X02OoYjNWoj^[Zon[Zj_oZj^[ojNWYon[Z
j_oYjNWoj^[ZonWYj@06onSXj0;oXj>S00KoY:BToj>SXonTY:CoXj>SojBT
Y?nSXj<2onSXj003onOWiooXj>Soj>SX00Coj>SX00OoinOWonSXj?oXj>So
j>SXonOWiooXj>SoinOW00;oj>SX00GoinOWonSXj?oXj>SobLW9olK6aP02
onSXj007onOWiooXj>Soj>SXonSXj?oWinOoj>SXonOWi`02onSXj003onOW
iooXj>Soj>SX00Coj>SX00OoinOWonSXj?oXj>Soj>SXonOWiooXj>SoinOW
00;oj>SX00?oinOWonSXj?oXj>P01?oXj>P01ooWinOoj>SXonSXj?oXj>So
inOWonSXj?oWinL00_oXj>P00ooWinOoj>SXonSXj004onSXj007onOWiooX
j>Soj>SXonSXj?oWinOoj>SXonOWi`02onSXj003onOWiooXj>Soj>SX00Co
j>SX00OoinOWonSXj?oXj>Soj>SXonOWiooXj>SoinOW00;oj>SX00?oinOW
onSXj?oYjNT00_oYjNT2on[ZjP07onWYjOoZj^[oj^[Zon[Zj_oYjNWoj^[Z
onWYj@02on[ZjP0>oj:RX_n/[:co];Bdokfm_Oo4a<Coc<c<om;Bd_oGemOo
g=cLon7QhOoTi>CoinOWon_[joo/k>`2onk^kP03ong]kOo^k^kok^k^0?oo
k^k^h?o^k^h00003okNg]on][Jgon_[j00;ono_k00Con_[joo_knoojn_[o
no_k0_ojn_X00ookno_on_[joo[jnP02ooWin@?on?Sh00?onOWiooShn?oh
n?P00_ohn?P00ooinOWon?ShooShn004ooShn005ooWinOohn?Son?ShooSh
n?oinOT01?ohn?P00ooinOWon?ShooShn004ooShn005ooWinOohn?So`L71
okno_ooinOT01?ohn?P00ooinOWon?ShooShn004ooShn005ooWinOohn?So
n?ShooShn?oinOT01?ohn?P00ooinOWon?ShooShn004ooShn005ooWinOoh
n?Son?ShooShn?oinOT01?ohn?P00ooinOWon?ShooShn004ooShn005ooWi
nOohn?Son?ShooShn?oinOT01?ohn?P00ooinOWon?ShooShn004ooShn005
ooWinOohn?Son?ShooShn?oinOT01?ohn?P00ooinOWon?ShooShn004ooSh
n004ooWinOohn?SonOWiooWin@;ono_k00Con_[joo_knoojn_[ono_k0_oj
n_X04Ookno_on_[joo_knon][Jgo^;Rhol30`?o9bLWod];BomWIfOoPh>3o
inOWonc/k?oalO7omOGeooShn?okno_ooOgm0?ooooooiOooool00003oj^[
ZonPX:3ono_k00[ono_k00Kon_[jooWinOoinOWonOWiooShn?oinOT2ooSh
n004ooWinOo^k^kojn_[ooShn0?onOWi00gon?ShooWinOohn?Son?ShooWi
nOohn?SonOWiooOgmoo]kNgomoOgooShn?oinOWon?Sh00;onOWi00?omoOg
ong]kOogmoL00_ohn?P02OoinOWo`<30okfm_Oohn?Sol?3`ooGemOohn?So
nOWiooShn003ooWin@07ooShn?oinOWon?ShooShn?oinOWon?ShooWin@02
ooShn004ooWinOohn?SonOWiooShn0?onOWi00Oon?ShooWinOohn?Son?Sh
ooWinOohn?SonOWi00;on?Sh00ConOWiooShn?oinOWon?Sh0ooinOT01ooh
n?SonOWiooShn?ohn?SonOWiooShn?oinOT00_ohn?P01?oinOWon?ShooWi
nOohn?P3ooWin@07ooShn?oinOWon?ShooShn?oinOWon?ShooWin@02ooSh
n004ooWinOohn?SonOWiooShn0?onOWi00?on?ShooWinOohn?P00ooinOT0
0oojn_[ono_koo_kn`09oo_kn`0>oj2PX?nZZZ[o];Bdokbl_?o4a<Cob/[:
om3@d?oHf=Sog=cLon;Rh_oTi>CoinOWon_[joo]kNd2onk^kP03ong]kOo^
k^kok^k^0?ook^k^h?o^k^h00003ojFUYOnLW9comOGe00?omOGe00Kom?Cd
ooGemOoemOGomOGeooCdm?oemOD3ooCdm0Colo?c00col_;bomgMgOnVYZKo
XZ:RojZZZ_n/[:coa/K6ono_kooclo?ol_;bokfm_Onk^k/2oo?cl`06oo3`
l?o6a/KoXj>SojRXZ?nUYJGo_Kfm0_oclo<01_o`l?3oaLG5ojBTY?nWYjOo
YJFUokjn_P;olo?c00So_[jnokBd]?nf][KoZJVYoj>SXoo2`/;olO7aoo?c
l`;ol_;b00?olo?coo;bl_oclo<01Ooclo<01?obl_;olo?coo;bl_obl_82
oo?cl`;ol_;b00?olo?coo;bl_oclo<01Ooclo<01?obl_;olo?coo;bl_ob
l_82oo?cl`;ol_;b00?olo?coo;bl_oclo<01Ooclo<01?obl_;olo?coo;b
l_obl_82oo?cl`;ol_;b00?olo?coo;bl_oclo<01Ooclo<01?obl_;olo?c
oo;bl_obl_82oo?cl`;ol_;b00?olo?coo;bl_oclo<00ooclo<3ooCdm0;o
mOGe01Kom?CdooGemOoemOGomOGeooCdm?oemOGom?CdooGemOnLW9coYJFU
ojj^[_nf][Ko_[jnol?3`oo:b/[od=3@omCDe?oIfMWogMgMomoOgooRh^;o
i>CToooVi^KUonKViP0000GoZZZZoj2PX?oYjNWoj^[ZonWYj@02on[ZjP03
onWYjOoZj^[ojNWY00;oj^[Z0_oYjNT00ooXj>SoinOWonOWi`03onOWi`0;
om_Kfoo>c/kohN7QonOWiooLg=coYJFUol;2`_oXj>SoinOWok^k^onh^;P0
0_oWinL03_o1`L7oZ:RXom;Bd_oUiNGoi>CTomcLg?oWinOoj>SXol71`OnY
ZJWodm?ConGUiOoTi>Cog=cL0_oWinL02Onj^[[oZJVYomOGeooWinOoe=CD
ojRXZ?o8b<Soj>SXonOWi`02onSXj003onOWiooXj>SoinOW00KoinOW0_oX
j>P00ooWinOoj>SXonOWi`02onSXj003onOWiooXj>SoinOW00KoinOW0_oX
j>P00ooWinOoj>SXonOWi`02onSXj003onOWiooXj>SoinOW00KoinOW0_oX
j>P00ooWinOoj>SXonOWi`02onSXj003onOWiooXj>SoinOW00KoinOW0_oX
j>P00ooWinOoj>SXonOWi`02onSXj004onOWiooXj>SoinOWonOWi`?oj>SX
00Ooj^[ZonWYjOoZj^[oj^[ZonWYjOoZj^[ojNWY00;oj^[Z013ojNWYon[Z
j_nQXJ7oZZZZokBd]?nl_;coa<C4ol[:b_oAdM7of=SHomcLg?oQhN7oi>CT
onOWioo[jn_okNg]0oo^k^h00oo]kNgok^k^onk^kP3oonk^k]ook^k^0000
0ong]kOo[:b/oo_kn`02oo_kn`05oo[jn_okno_on_[joo[jn_okno/00_oj
n_X00ookno_onOWiooWin@02ooWin@?on?Sh00?onOWiooShn?ohn?P00_oh
n?P03?nm_Kgo^;RhooShn?ohn?So`L71okno_oohn?SomOGeojJVY_o=cLgo
n?ShooWin@?on?Sh00?om?CdojJVY_o<c<`01_ohn?P01oo1`L7o_knoooSh
n?oinOWon?Shokno_onb/[803?ohn?P00ooinOWon?ShooShn00=ooShn003
ooWinOohn?Son?Sh00gon?Sh00?onOWiooShn?ohn?P03Oohn?P00ooinOWo
n?ShooShn008ooShn0?onOWi00Gon_[joo_knookno_on_[joo_kn`02oo[j
nP0Coo_knoojn_[on_[joo_knoojn_[o[:b/okNg]oo1`L7obLW9om;Bd_oI
fMWoh>3PonOWioo/k>colO7aooCdm?ohn?Sono_koogmo@3oooooonGooooo
00000onZZZ[oXJ6Qoo_kn`05oo_kn`03ooclo?okno_ono_k00;ono_k0_oj
n_X4ooWin@;on?Sh0_oinOT01?ohn?SojNWYojNWYoo7alL2ooWin@07ol30
`?nm_KgonOWionSXj?nSXj?oa<C4olc<c002olg=c@05omKFe_ohn?SojNWY
oj>SXoo3`l<00oo=cLd01OoFe]KonOWiooShn?o1`L7o_Kfm00;on?Sh00Ko
nOWiom;Bd_nUYJGon?ShooWinOohn?P2ooWin@04ooShn?oinOWonOWiooSh
n0;onOWi0_ohn?P2ooWin@04ooShn?oinOWonOWiooShn0;onOWi00Con?Sh
ooWinOoinOWon?Sh0_oinOT2ooShn0;onOWi00Con?ShooWinOoinOWon?Sh
0_oinOT01?ohn?SonOWiooWinOohn?P2ooWin@;on?Sh0_oinOT01?ohn?So
nOWiooWinOohn?P2ooWin@04ooShn?oinOWonOWiooShn0;onOWi0_ohn?P2
ooWin@04ooShn?oinOWonOWiooShn0;onOWi00Con?ShooWinOoinOWonOWi
0oojn_X4oo_kn`03ooclo?okno_ono_k00?ono_k00koXJ6Qoj^[Zond];Co
_;blolC4a?o:b/[odM7AomSHf?oMgMgohN7QonGUiOoWinOoj^[Zonc/k?oo
k^k^iOo^k^h00003ojBTY?nKVi_omOGe00ComOGe00?om?CdooGemOoemOD0
0_oemOD2ooCdm00=oo?cloobl_;ol_;boo;bl_oclo?ol_;boo?cloobl_;o
lO7aolg=cOnUYJGo[Zj^onSXj002oo;blP06okjn__nk^k_ol_;bonSXj?nR
XZ;o_kno0_o9bLT01_nb/[;o][Jfoo;bl_oXj>SoXZ:Rokno_`;obLW900ko
/[:bokJf]_obl_;ol_;bokfm_Onk^k_ol_;boo?cloobl_;oa/K6oj^[Zooc
lo?ol_;boo?cl`;ol_;b0_oclo<3oo;blP03oo?cloobl_;olo?c00?ol_;b
00?olo?coo;bl_oclo<00_obl_82oo?cl`?ol_;b00?olo?coo;bl_oclo<0
0oobl_800ooclo?ol_;boo?cl`02oo;blP;olo?c0oobl_800ooclo?ol_;b
oo?cl`03oo;blP03oo?cloobl_;olo?c00;ol_;b0_oclo<3oo;blP03oo?c
loobl_;olo?c00?ol_;b00?olo?coo;bl_oclo<00_obl_82oo?cl`;ol_;b
00?olo?cooCdm?odm?@00ooemOD00oodm?ComOGeooGem@02ooGem@0@ooCd
m?oemOGoVi^KojBTY?n][Jgo]KFeokjn__o4a<Cob/[:om3@d?oEeMGofMWI
omgMgOoOgmoohn?SonCTi?ooi^KViOoVi^H00005ojZZZ_nQXJ7ojNWYon[Z
j_oYjNT01?oZj^X01?oYjNWoj^[Zon[Zj_oZj^X3onSXj0?oinOW02_oj>SX
onOWiooQhN7o];Bdoj>SXonl_;coi>CTonSXj?oWinOoj>SXokZj^_nh^;So
j>SXonKVi_n/[:co`l?3onSXj?oWinOo/k>cokno_ooXj>SoinOWojb/[?o4
a<CoinOWonSXj?nb/[;o_knoonSXj?oWinOo^[ZjojZZZ_oKfm_oinOWonKV
i_na/K7o_knoonSXj?oWinOoj>SXonOWiooXj>SoinOW00;oj>SX0ooWinL0
1?oXj>SoinOWonSXj?oWinL2onSXj005onOWiooXj>SoinOWonSXj?oWinL0
0_oXj>P3onOWi`04onSXj?oWinOoj>SXonOWi`;oj>SX00GoinOWonSXj?oW
inOoj>SXonOWi`02onSXj0?oinOW00Coj>SXonOWiooXj>SoinOW0_oXj>P0
1OoWinOoj>SXonOWiooXj>SoinOW00;oj>SX0ooWinL01?oXj>SoinOWonSX
j?oWinL2onSXj005onOWiooXj>SoinOWonSXj?oWinL01?oXj>P00ooYjNWo
j^[ZonWYj@04on[ZjP0EonWYjOoZj^[oj^[Zon[Zj_oYjNWoXJ6Qoj^[Zond
];Co_;blolC4a?o;bl_odM7AomSHf?oLg=cohN7QonCTi?oWinOojn_[onc/
k?o^k^kokNg]0?ook^k^hoo^k^h00006okNg]on/[:cono_koo_knoojn_[o
no_k0oojn_X00ookno_on_[joo_kn`02oo[jnP03ooWinOohn?SonOWi00Co
n?Sh00?o/k>cojf][OoRh^801Oohn?P02_o2`/;o_knoooShn?ohn?Soh>3P
oj^[Zoo7alOo`<30oj^[Zoo[jn/2ooShn006on7QhOnZZZ[oalO7ol30`?n[
Zj_ojn_[0_ohn?P01oo1`L7o^KViokJf]_nn_[ko/;2`ojNWYooRh^80B?oh
n?P2ooWin@04oo[jn_okno_on_[joo_kn`?on_[j01?ono_koo[jn_okno_o
n_[joo_knon/[:co][Jfol71`Oo9bLWod];BomWIfOoPh>3oinOWonc/k?oa
lO7om?CdooShn?okno_ooOgm0?ooooooiOooool00003oj^[ZonPX:3ono_k
00[ono_k00Con_[jooWinOoinOWonOWi0oohn?P01?o[jn_oY:BTon7QhOoi
nOT2ooShn0;onOWi00?on?Shol71`Onm_Kd00_oinOT01Oohn?Soj^[Zolk>
c_o?clook>c/00;onOWi0_ohn?P01OoZj^[oclo?olo?coo[jn_on?Sh00;o
nOWi00OohN7QomoOgooalO7oe]KFolg=cOoVi^KonOWi00;on?Sh0_oinOT0
0oohn?SonOWiooShn002ooWin@?on?Sh1?oinOT2ooShn0;onOWi00?on?Sh
ooWinOohn?P00_oinOT3ooShn0ConOWi0_ohn?P2ooWin@03ooShn?oinOWo
n?Sh00;onOWi0oohn?P4ooWin@;on?Sh0_oinOT00oohn?SonOWiooShn002
ooWin@?on?Sh1?oinOT2ooShn0;onOWi00?on?ShooWinOohn?P00ooinOT2
oo[jnP[ono_k00koX:2PojZZZ_nd];Co_;blolC4a?o:b/[odM7AomSHf?oL
g=coh^;RonCTi?oWinOojn_[ong]k@;ok^k^00?okNg]onk^k_o^k^h0ooo^
k^kPonk^kP0000OoY:BToi^KVooemOGomOGeooCdm?oemOGom?Cd00ComOGe
00Com?CdooGemOodm?Com?Cd0_obl_83oo?cl`0;on[Zj_nSXj?odM7Aoo;b
l_oclo?ojn_[ong]kOobl_;olo?cokfm_Onk^k/00_obl_83oo?cl`Col_;b
0_oclo<2oo;blP03oo?cloobl_;olo?c00;ol_;b0ooclo<4oo;blP;olo?c
0_obl_800ooclo?ol_;boo?cl`02oo;blP?olo?c1?obl_82oo?cl`;ol_;b
00?olo?coo;bl_oclo<00_obl_83oo?cl`Col_;b0_oclo<2oo;blP03oo?c
loobl_;olo?c00;ol_;b0ooclo<4oo;blP;olo?c0_obl_800ooclo?ol_;b
oo?cl`02oo;blP?olo?c1?obl_82oo?cl`;ol_;b00Colo?coo;bl_oclo?o
l_;b0_oclo<01Oodm?ComOGeooCdm?oemOGom?Cd00ComOGe017om?CdooGe
mOoemOGoVi^KojBTY?n^[Zko][Jfokjn__o4a<CobLW9om3@d?oDe=CofMWI
omgMgOoPh>3ohn?SonCTi003onKViP03onGUiOoVi^Koi^KV0?ooi^KVgooV
i^H00005ojZZZ_nQXJ7ojNWYon[Zj_oYjNT00ooZj^X00ooYjNWoj^[ZonWY
j@02on[ZjP0BonWYjOoXj>SoinOWonOWiooXj>SoinOWonSXj?oWinOobl_;
ojVYZOn`/;3o[jn_ojBTY?oIfMWoinOWonSXj?nj^[[o^;Rh0_oWinL01?oX
j>SoinOWonSXj?oWinL2onSXj0;oinOW00Coj>SXonOWiooWinOoj>SX1?oW
inL01?oXj>SoinOWonSXj?oWinL2onSXj0;oinOW00Coj>SXonOWiooWinOo
j>SX1?oWinL01?oXj>SoinOWonSXj?oWinL2onSXj0;oinOW00Coj>SXonOW
iooWinOoj>SX1?oWinL01?oXj>SoinOWonSXj?oWinL2onSXj0;oinOW00Co
j>SXonOWiooWinOoj>SX1?oWinL01?oXj>SoinOWonSXj?oWinL2onSXj0;o
inOW00Coj>SXonOWiooWinOoj>SX1?oWinL01?oXj>SoinOWonSXj?oWinL2
onSXj0;oinOW00Coj>SXonOWiooWinOoj>SX1?oWinL2onSXj003on[Zj_oY
jNWoj^[Z00;oj^[Z00?ojNWYon[Zj_oYjNT00ooZj^X03_nQXJ7oZZZZok>c
/onl_;coa<C4ol_;booAdM7of=SHomcLg?oQhN7oi>CTonSXj?oZj^[ok>c/
ooo^k^kUonk^kP0000Co]kNgojb/[?okno_on_[j0_okno/01Oojn_[ono_k
oo[jn_ojn_[ono_k00?on_[j0_oinOT6ooShn004ooKfm_oRh^;oh^;Roo3`
l0?on?Sh00?oc/k>ol_;boohn?P0Goohn?P3ooWin@;on_[j0_okno/01Ooj
n_[ono_koo[jn_ojn_[ono_k00;on_[j00oono_kojb/[?ng]kOo`L71olW9
bOoBd];ofMWIon3Ph?oWinOojn_[oo7alOodm?Con?Shooclo?omoOd0oooo
oooUooooo`0000?oZj^[oj6QXOokno/02Ookno/3oo[jnP;onOWi00?on?Sh
ooWinOoinOT00_ohn?P01?oinOWon?ShooWinOohn?P2ooWin@06ooShn?oi
nOWonOWiooShn?oinOWon?Sh0_oinOT2ooShn004ooWinOohn?SonOWiooSh
n0;onOWi00Kon?ShooWinOoinOWon?ShooWinOohn?P2ooWin@;on?Sh00Co
nOWiooShn?oinOWon?Sh0_oinOT01_ohn?SonOWiooWinOohn?SonOWiooSh
n0;onOWi0_ohn?P01?oinOWon?ShooWinOohn?P2ooWin@06ooShn?oinOWo
nOWiooShn?oinOWon?Sh0_oinOT2ooShn004ooWinOohn?SonOWiooShn0;o
nOWi00Kon?ShooWinOoinOWon?ShooWinOohn?P2ooWin@;on?Sh00ConOWi
ooShn?oinOWon?Sh0_oinOT01_ohn?SonOWiooWinOohn?SonOWiooShn0;o
nOWi0_ohn?P01?oinOWon?ShooWinOohn?P2ooWin@03ooShn?oinOWonOWi
00?onOWi00?on_[joo_knookno/02Ookno/03_nQXJ7oZZZZokBd]?nl_;co
a<C4ol_;booAdM7oemOGomcLg?oQhN7oi>CTonOWioo[jn_okNg]ooo^k^kU
onk^kP0000?oYJFUoi^KVoodm?@01?oemOD01Oodm?ComOGeooGemOodm?Co
mOGe00?om?Cd00?ol_;boo?cloobl_800_obl_82oo?cl`;ol_;b0_oclo<0
1oobl_;olo?coo;bl_obl_;olo?coo;bl_oclo<00oobl_82oo?cl`;ol_;b
0_oclo<01oobl_;olo?coo;bl_obl_;olo?coo;bl_oclo<00oobl_82oo?c
l`;ol_;b0_oclo<01oobl_;olo?coo;bl_obl_;olo?coo;bl_oclo<00oob
l_82oo?cl`;ol_;b0_oclo<01oobl_;olo?coo;bl_obl_;olo?coo;bl_oc
lo<00oobl_82oo?cl`;ol_;b0_oclo<01oobl_;olo?coo;bl_obl_;olo?c
oo;bl_oclo<00oobl_82oo?cl`;ol_;b0_oclo<01oobl_;olo?coo;bl_ob
l_;olo?coo;bl_oclo<00oobl_82oo?cl`;ol_;b0_oclo<01_obl_;olo?c
oo;bl_obl_;olo?coo;blP?olo?c00Gom?CdooGemOoemOGomOGeooCdm002
ooGem@0BooCdm?oemOGomOGeooGemOnKVi_oY:BTojj^[_ne]KGo_Kfmol?3
`oo:b/[odM7AomGEeOoIfMWogMgMon3Ph?oRh^;oi>CT0ooVi^H00ooUiNGo
i^KVonKViP3oonKVi]ooi^KV00000on[Zj_oXJ6Qon[ZjP02on[ZjP09onWY
jOoZj^[oj^[Zon[Zj_oYjNWoj^[ZonWYjOoZj^[ojNWY00Coj>SX00[oinOW
onSXj?oWinOoinOWonSXj?oWinOoj>SXonOWiooXj>SoinOW0_oXj>P2onOW
i`;oj>SX00[oinOWonSXj?oWinOoinOWonSXj?oWinOoj>SXonOWiooXj>So
inOW0_oXj>P2onOWi`;oj>SX00[oinOWonSXj?oWinOoinOWonSXj?oWinOo
j>SXonOWiooXj>SoinOW0_oXj>P2onOWi`;oj>SX00[oinOWonSXj?oWinOo
inOWonSXj?oWinOoj>SXonOWiooXj>SoinOW0_oXj>P2onOWi`;oj>SX00[o
inOWonSXj?oWinOoinOWonSXj?oWinOoj>SXonOWiooXj>SoinOW0_oXj>P2
onOWi`;oj>SX00[oinOWonSXj?oWinOoinOWonSXj?oWinOoj>SXonOWiooX
j>SoinOW0_oXj>P2onOWi`;oj>SX00[oinOWonSXj?oWinOoinOWonSXj?oW
inOoj>SXonOWiooXj>SoinOW0_oXj>P2onOWi`;oj>SX00CojNWYon[Zj_oZ
j^[ojNWY0ooZj^X00ooYjNWoj^[ZonWYj@02on[ZjP0>oj2PX?nZZZ[o];Bd
okbl_?o4a<Cobl_;om7AdOoGemOog=cLon7QhOoTi>CoinOWon_[joo/k>`2
onk^kP03ong]kOo^k^kok^k^0?ook^k^h?o^k^h00003okJf]_n/[:con_[j
00;ono_k00Con_[joo_knoojn_[ono_k0_ojn_X00ookno_on_[joo[jnP02
ooWinFoon?Sh00ConOWiooShn?oinOWonOWi0_okno/01?ojn_[ono_koo[j
n_okno/2oo[jnP0Aoo_knoojn_[ono_kojb/[?ng]kOo`<30olW9bOoBd];o
fMWIon3Ph?oWinOok>c/oo7alOoemOGon?Shoo_knoomoOd0oooooooUoooo
o`0000?oZj^[oj2PX?ogmoL00_ofm_H01?ogmoOom_KfooOgmoofm_H3ooOg
m`;om_Kf00GomOGeooCdm?oemOGom?CdooGem@02ooCdm003ooGemOodm?Co
mOGe00;om?Cd0_oemOD01oodm?ComOGeooCdm?odm?ComOGeooCdm?oemOD0
0_odm?@00ooemOGom?CdooGem@02ooCdm0;omOGe00Oom?CdooGemOodm?Co
m?CdooGemOodm?ComOGe00;om?Cd00?omOGeooCdm?oemOD00_odm?@2ooGe
m@07ooCdm?oemOGom?CdooCdm?oemOGom?CdooGem@02ooCdm003ooGemOod
m?ComOGe00;om?Cd0_oemOD01oodm?ComOGeooCdm?odm?ComOGeooCdm?oe
mOD00_odm?@00ooemOGom?CdooGem@02ooCdm0;omOGe00Oom?CdooGemOod
m?Com?CdooGemOodm?ComOGe00;om?Cd00?omOGeooCdm?oemOD00_odm?@2
ooGem@07ooCdm?oemOGom?CdooCdm?oemOGom?CdooGem@02ooCdm003ooGe
mOodm?ComOGe00;om?Cd0_oemOD01?odm?ComOGeooCdm?odm?@2ooGem@?o
m_Kf00ComoOgooKfm_ogmoOom_Kf0oogmoL04?ofm_KomoOgoj2PX?nZZZ[o
];Bdokbl_?o4a<Cob/[:om3@d?oHf=Sog=cLon;Rh_oTi>CoinOWon_[joo]
kNd2onk^kP03ong]kOo^k^kok^k^0?ook^k^h?o^k^h00003ojFUYOnLW9co
j>SX00?oj>SX00KoinOWonSXj?oXj>Soj>SXonOWiooXj>P3onOWi`Coi^KV
00CoiNGUonKVi_oVi^KoiNGU0_oVi^H2onGUi@03onKVi_oUiNGoi^KV00Go
i^KV00CoiNGUonKVi_oVi^KoiNGU0_oVi^H2onGUi@03onKVi_oUiNGoi^KV
00Goi^KV00CoiNGUonKVi_oVi^KoiNGU0_oVi^H2onGUi@03onKVi_oUiNGo
i^KV00Goi^KV00CoiNGUonKVi_oVi^KoiNGU0_oVi^H2onGUi@04onKVi_lN
7Qko7QhNoalO7`;o7QhN00?o7alOoahN7_oUiND00_oVi^H00ooUiNGoi^KV
onKViP02onGUi@03onKVi_oUiNGoi^KV00Goi^KV00CoiNGUonKVi_oVi^Ko
iNGU0_oVi^H2onGUi@03onKVi_oUiNGoi^KV00Goi^KV00CoiNGUonKVi_oV
i^KoiNGU0_oVi^H2onGUi@03onKVi_oUiNGoi^KV00?oi^KV0ooWinL2onSX
j005onOWiooXj>Soj>SXonSXj?oWinL00ooXj>P03_nLW9coYJFUojj^[_nf
][Ko_[jnol?3`oo:b/[od=3@omCDe?oIfMWogMgMomoOgooRh^;oi>CToooV
i^KUonKViP0000GoZZZZoj2PX?ofm_KomoOgooKfmP02ooOgm`03ooKfm_og
moOom_Kf00;omoOg0_ofm_H00ooemOGom?CdooCdm003ooCdm003oo_knonE
UIGoFUYJ00KoFUYJ00?oBd];oeYJF_mIFET00omJFUX01_nSXj?om?CdooCd
m?oemOGom?CdooGem@;om?Cd00?omOGeooCdm?oemOD02?odm?@00ooemOGo
m?CdooGem@02ooCdm003ooGemOodm?ComOGe00Som?Cd00?omOGeooCdm?oe
mOD00_odm?@00ooemOGom?CdooGem@08ooCdm003ooGemOodm?ComOGe00;o
m?Cd00?omOGeooCdm?oemOD02?odm?@00ooemOGom?CdooGem@02ooCdm003
ooGemOodm?ComOGe00Som?Cd00?omOGeooCdm?oemOD00_odm?@00ooemOGo
m?CdooGem@02ooCdm0?omOGe00OomoOgooKfm_ogmoOomoOgooKfm_ogmoOo
m_Kf00;omoOg013om_KfooOgmonQXJ7oZZZZokBd]?nl_;coa<C4ol[:b_oA
dM7of=SHomcLg?oQhN7oi>CTonOWioo[jn_okNg]0oo^k^h00oo]kNgok^k^
onk^kP3oonk^k]ook^k^00000ong]kOo[:b/ooooo`0:ooooo`04ookno_om
oOgooOgmoogmo@;oo?cl00CooOgmookno_mLG5coNGUi0on8R8P01?miNGWo
R8R8ohR8R?n7QhL4ohR8R003odi>C_oBd];ooOgm00Coo?cl00?ooOgmoocl
o?olo?`00oolo?`2oogmo@;oo?cl00?ooOgmooCdm?oShn<00oolo?`02?om
oOgoo?cloo7alOoclo?oo?clonWYjOobl_;ooOgm0_olo?`2oogmo@05oocl
o?odm?Cohn?Soo_knoomoOd01Oolo?`2oogmo@;oo?cl0_omoOd4ooclo003
oogmoOodm?Cohn?S00?oo?cl0_omoOd2ooclo0;ooOgm1?olo?`00oomoOgo
o?clooclo003ooclo0;ooOgm0_olo?`2oogmo@Coo?cl00?ooOgmooclo?ol
o?`00oolo?`3oogmo@03ookno_oooooooooo00Wooooo00ko[:b/okNg]oo1
`L7obLW9om;Bd_oIfMWoh>3PonOWioo/k>colO7aooCdm?ohn?Sono_koogm
oOooooooiOooool00003ojZZZ_nQXJ7omoOg00;om_Kf1OogmoL01?ofm_Ko
moOgooOgmoofm_H2ooGem@06ooCdm?oemOGom?CdooCdm?okno_oBd];0_o]
kNd03Oo1`L7oQXJ6ok6a/Ookno_okNg]omkNg_n6QXKog]kNonc/k?o]kNgo
QXJ6olo?coodm?@00_oemOD04_odm?ComOGeof1PH?mIFEWom?CdooGemOod
m?CoXJ6QoalO7onYZJWomOGeonOWiomUIFGo820PobXZ:_l];BgoXJ6QooGe
m@;om?Cd00OoJ6QXoe]KFomCDe?o;bl_ob8R8_mcLg?ol?3`00;om?Cd00Ko
i^KVofIVI_lQ8B7o:RXZobd];OnQXJ42ooCdm003ooGemOmPH63o7alO00Co
7alO00_o]KFeofQXJ?mPH63omOGeooCdm?oWinOoIVIVob0P8?lZ:R[o;Bd]
oj6QX@03ooCdm008ofUYJOmPH63om?CdooCdm?oemOGo;Rh^oi^KVooemOD3
ooCdm003ooGemOodm?Com?Cd00;om?Cd00ComOGeooCdm?odm?Com?Cd0_oe
mOD00oodm?ComOGeooCdm002ooCdm003ooGemOodm?Com?Cd00;om?Cd00Co
mOGeooKfm_ofm_Kom_Kf1OogmoL04_ofm_KomoOgooOgmoofm_KoXJ6Qoj^[
Zond];Co_;blolC4a?o:b/[odM7AomSHf?oMgMgohN7QonGUiOoWinOoj^[Z
onc/k?ook^k^iOo^k^h00003ojBTY?nKVi_oj>SX00Coj>SX00?oinOWonSX
j?oXj>P00_oXj>P2onOWi`;oi^KV0_oUiND2onKViP06oo[jn_m:BT[on_[j
on_[jon5QHGo7T[>0_m:BQh02OmHF5SoBQm:oahN>omf7WKoQ8B4oo[jn_n5
QHGo_knoonKViP03onGUi@03onKVi_mKFe_oEEEE00;oiNGU00?oc/k>obPX
:?mVIVH00_oUiND04?mUIFGo>SXjokVi^OoOgmooTY:BoahN7_nc/k?oiNGU
onKVi_mSHf?o<S8bokNg]ooVi^KoZj^[obTY:On;Rh/2onKViP07ofEUIOlj
>S[o^;RhomoOgonBTY;o7QhNokBd]002onGUi@04oeaLG?m=CDgof=SHomOG
e`;of=SH00?ohN7Qof=SHomKFe/00_oUiND01omUIFGo>SXjokVi^OoOgmoo
TY:BoalO7onc/k<00_oUiND02_mSHf?oG5aLonKVi_oVi^KoiNGUob/[:onB
TY;oi^KVonGUiOoVi^H2onGUi@;oi^KV0ooUiND3onKViP?oiNGU00?oi^KV
onGUiOoVi^H00_oUiND2onKViP;oiNGU00?oi^KVonOWiooXj>P00ooXj>P0
0ooWinOoj>SXonSXj004onSXj00>oi^KVonTY:Co[Jf]okFe]Onn_[koa<C4
ol[:b_o@d=3oeMGEomWIfOoMgMgogmoOon?ShooTi>CoonKVi^Goi^KV0000
1OnZZZ[oXJ6QooKfm_ogmoOom_Kf00ComoOg00Com_KfooOgmoogmoOomoOg
0ooemOD3ooCdm003ooGemOokno_oQXJ600;okNg]00ooMgMgoamgnolPMm3o
FUYJod/OBom;Bd_oQXJ6od`PC?nDU9CokNg]ogMgMoo@d=3om?CdooGemOod
m?@00_oemOD05OmPH63oFUYJooCdm?oemOGoF5QHocXj>_oYjNWom?CdonOW
iolO7aooR8R8ooCdm?oemOGom?CdocHf=_mXJ6Som?CdooGemOmXJ6SoH61P
ooCdm002ooGem@07of9RH_m0@43om?CdonSXj?lO7aooR8R8ooCdm002ooGe
m@07ocDe=OmXJ6Som?CdooGemOmOGeooEeMGooGem@03ooCdm00KooGemOmX
J6SoH61PooCdm?oXj>So7alOohR8R?oemOGom?CdooGemOle=CGoJ6QXooGe
mOodm?CoJ6QXof1PH?oemOGom?CdooGemOl^;RkoW9bLooGemOodm?ComOGe
ooCdm?oemOGom?Cd00;omOGe0oodm?@01?oemOGom?CdooGemOodm?@2ooGe
m@05ooCdm?oemOGom?CdooGemOodm?@01?oemOD00oofm_KomoOgooKfmP04
ooOgm`0EooKfm_ogmoOomoOgooOgmoofm_KoXJ6Qoj^[Zond];Co_;blolC4
a?o;bl_odM7AomSHf?oLg=cohN7QonCTi?oWinOojn_[onc/k?o^k^kokNg]
0?ook^k^hoo^k^h00003okNg]on/[:cooooo00Wooooo0_ono_h3oogmo@0C
ooclo?omoOgoo?cloogmoOm=CDgokno_on3Ph?l`<33o8WWmob5ioOm>NM;o
?ShnoiNGUonUYJGo?cloon3Ph?o^k^koR8R8om;BdP05ooclo00;ofEUIOmL
G5coo?cloj>SXolT92Cob/[:ooclo?omoOgodM7Aob8R8_o1`L400oolo?`0
1_m[Jf_oCTi>ooclo?olo?coKFe]ofATI0?oo?cl00KoUiNGob@T9?ojn_[o
d];Bob4Q8Oo1`L43ooclo00Aof][Jom>CTkoo?clooclo?mTI6CoFUYJoocl
o?omoOgoo?cloogmoOolo?coKFe]ofATI?olo?codM7Aob4Q8Oo1`L400ool
o?`01_m[Jf_oCTi>ooclo?omoOgoK6a/ofEUI@?oo?cl00?o<C4aoj6QXOol
o?`01oolo?`00oomoOgoo?cloogmo@0=ooclo0;ooOgm00?oo_knoooooooo
ool02Oooool03_n/[:co][Jfol71`Oo9bLWod];BomWIfOoPh>3oinOWonc/
k?oalO7om?CdooShn?okno_ooOgmoooooooUooooo`0000CoZj^[oj2PX?of
m_Kom_Kf1?ogmoL2ooKfmP;omoOg0_ofm_H3ooGem@?om?Cd00Kono_koda<
C?o]kNgoC4a<od/OBolO7bd2ocdm?@08oam;Bom<7dco;AlOoalO7om<C4co
`<30ohJ6Q_o0`<02ooGem@08ooCdm?oemOGom?CdoemOGol_;booFUYJobPX
:?mjNWX2ooCdm004ooGemOoJf][o7alOoj6QX@;omOGe00?om?Cdodi>C_mI
FET00_odm?@00omYJFWoH61PooGem@02ooCdm00Aoh:2P_lg=cOom?Cdom[J
f_lO7aooXZ:RooCdm?oemOGom?Cdode=COmIFEWomOGeooCdm?mPH63oEUIF
ooCdm?oemOD00oodm?@04?mYJFWoH61PooCdm?oKfm_o7alOoj6QXOodm?Co
mOGeooCdm?m>CTkoFEUIooCdm?oemOGoJ6QXoeeMGOodm?@2ooGem@03obd]
;OnLW9com?Cd00;om?Cd00?omOGeooCdm?oemOD00_odm?@01?oemOGom?Cd
ooCdm?odm?@2ooGem@03ooCdm?oemOGom?Cd00;om?Cd00?omOGeooCdm?oe
mOD00_odm?@2ooGem@;om_Kf1?ogmoL2ooKfmP;omoOg013om_KfooOgmonP
X:3oZZZZokBd]?nl_;coa<C4ol[:b_oAdM7of=SHomcLg?oRh^;oi>CTonOW
ioo[jn_okNg]0_o^k^h00oo]kNgok^k^onk^kP3oonk^k^3ok^k^00001onT
Y:CoVi^KonSXj?oXj>SoinOWonSXj?oWinL01?oXj>P01?oWinOoj>SXonOW
iooWinL2onGUi@?oi^KV01;on_[johF5QOmfBWKoMTYfohF5QOnDU9CoMWIf
odY:7_lNB/ko7WK>odXNM_lN7QkoMTYfodY:B_n5QHGoc/k>onGUiOoVi^H2
onGUi@07onKVi_mKFe_o@D51ohj>S_mKFe_o;Bd]oijNWP02onGUi@0EonCT
i?li>CWoI6ATonGUiOoVi^KofMWIob4Q8On7QhOoi^KVonGUiOmRHV;o<S8b
ol71`OoVi^KohN7QodQ8B?m]KFgoi^KVonCTi?lh>3SoI6AT00;oiNGU00Oo
f][Job8R8_n6QXKoiNGUonKVi_mKFe_oDU9B00;oiNGU0ooVi^H01_mRHV;o
Fe]KonGUiOoTi>Co>CTiofATI0;oiNGU00?of][Job4Q8On7QhL00_oUiND0
1omSHf?o820Poj6QXOoUiNGofMWIoahN7_nRXZ800_oVi^H2onGUi@03onKV
i_oUiNGoi^KV00;oiNGU0ooVi^H01?oUiNGoi^KVonGUiOoUiND2onKViP;o
iNGU00Coi^KVonGUiOoVi^KoiNGU0_oVi^H01OoWinOoj>SXonOWiooXj>So
inOW00Coj>SX017oinOWonSXj?oXj>SoVi^KojBTY?n^[Zko][Jfokjn__o4
a<CobLW9om3@d?oDe=CofMWIomgMgOoPh>3ohn?SonCTi003onKViP03onGU
iOoVi^Koi^KV0?ooi^KVgooVi^H00005ojZZZ_nQXJ7om_KfooOgmoofm_H0
0oogmoL00oofm_KomoOgooKfmP02ooOgm`0@ooKfm_oemOGom?CdooCdm?oe
mOGom?CdooGemOokno_oFUYJod/OBoo?7looMd]gogQhN?l^7aooXgLOom2T
80;o7gO?0_nS7j<01?o1`L7oQHF5om3@d?odm?@2ooGem@;om?Cd02KoH61P
oeUIFOodm?ComOGeohJ6Q_lT92Coj>SXooCdm?oemOGo^[ZjobTY:Om<C4co
Ogmooc0`<?m<C4cokNg]ooGemOodm?CoJ6QXoe=CDom;Bd_oGemOocTi>OlR
8R;o_KfmooCdm?oemOGo^[ZjobTY:Om<C4coOgmoobl_;om<C4cokNg]ooCd
m?oemOGoH61PoeIFEP;om?Cd00komOGeooCdm?oemOGoJ6QXof1PH?oemOGo
m?CdokZj^_lY:BWoC4a<ogmoOol`<33oBd];ong]k@;om?Cd00WoJFUYoeAD
E?mBDU;oDe=Code=COlX:2Soj^[ZooCdm?oemOD00_odm?@00ooemOGom?Cd
ooCdm002ooCdm004ooGemOodm?ComOGeooCdm0;omOGe0_odm?@01?oemOGo
m?CdooCdm?oemOD4ooCdm0;omOGe00?omoOgooKfm_ogmoL00_ogmoL00oof
m_KomoOgooKfmP02ooOgm`0?ooKfm_nQXJ7oZZZZok>c/onl_;coa<C4ol_;
booAdM7of=SHomcLg?oQhN7oi>CTonSXj?oZj^[ok>c/0?ook^k^iOo^k^h0
0003okNg]on/[:cooooo00[ooooo00Coo_knoogmoOomoOgooOgm0oolo?`0
1?omoOgoCDe=om7AdOmLG5`2ob4Q8@0:odhRC_miNB7ooM4QojIi8_mi8GWo
dR;nogTRNOmiCGWoR8R8ol?3``Goo?cl00OoI6AToeeMGOolo?coo?clolg=
cOlQ8B7o_[jn00?oo?cl00GogmoOoi^KVon7QhOo[Jf]ooWin@03ooclo006
ofa/K?mTI6Cojn_[oj>SXon<S8cocLg=1?olo?`01OoOgmooVYZJohN7Qon]
[JgonOWi00?oo?cl00?oIFEUoeUIFOomoOd01?olo?`00oo0`<3o_;bloocl
o002ooclo00>omoOgonKVi_oQXJ6ojf][OoinOWoo?cloogmoOolo?co`<30
okbl_?oclo?o[:b/oiBDU?oQhN48ooclo003oogmoOolo?coo?cl00goo?cl
0oomoOd00oono_koooooooooo`09ooooo`0>ojb/[?ng]kOo`L71olW9bOoB
d];ofMWIon3Ph?oWinOojn_[oo7alOodm?Con?Shooclo?omoOgoooooonGo
oooo00001?n[Zj_oXJ6QooOgmoogmoL2ooKfmP04ooOgmoofm_KomoOgooKf
mP;omoOg0_ofm_H01?oemOGom?CdooGemOodm?@2ooGem@0@oo_knon5QHGo
kNg]onc/k?lm?CgoXanSogM;Momg87OoMamgod`OC?nSMaoo;Rh^om3@d?o]
kNgoQXJ6om3@d0;om?Cd00comOGeooCdm?oemOGoH61PoeUIFOoemOGodm?C
ofMWIolY:BWojNWYooGemOodm?@2ooGem@;om?Cd00SomOGeooCdm?oemOGo
m?CdooGemOmYJFWoH61PooGem@;om?Cd00ComOGeooCdm?oemOGomOGe0_od
m?@01?oemOGom?CdooGemOodm?@2ooGem@06ooCdm?mPH63oEUIFooCdm?oe
mOGom?Cd0_oemOD01_oCdm?od];BooGemOodm?ComOGeooCdm0;omOGe00Ko
m?CdooGemOodm?Com?CdooGemOodm?@2ooGem@;om?Cd00ComOGeooCdm?oe
mOGom?Cd0_oemOD01_odm?ComOGeooCdm?odm?ComOGeooCdm0;omOGe0_od
m?@01?oemOGom?CdooGemOodm?@2ooGem@04ooCdm?oemOGom?CdooCdm0;o
mOGe00Som_KfooOgmoofm_Kom_KfooOgmoofm_KomoOgooKfmP;omoOg013o
m_KfooOgmonQXJ7oZZZZokBd]?nl_;coa<C4ol_;booAdM7oemOGomcLg?oQ
hN7oi>CTonOWioo[jn_okNg]ooo^k^kUonk^kP0000?oYJFUoi^KVooWinL0
1?oXj>P01?oWinOoj>SXonSXj?oWinL2onSXj0;oinOW00?oiNGUonKVi_oU
iND00_oUiND01_ojn_[oFEUIon_[jonRXZ;o;Bd]oeUIF@;ocQk>00CoXQjR
oai:M_o>XQkoQ8B40_o[jn/01?n4Q8Coc/k>onKVi_oVi^H2onGUi@09onKV
i_mKFe_o820Pob@T9?lO7aooAdM7oiVIVOoUiNGoi^KV00?oiNGU0_oVi^H2
onGUi@;oi^KV00OoiNGUof=SHomKFe_oiNGUonKVi_oUiNGoi^KV00?oiNGU
0_oVi^H2onGUi@;oi^KV00OoiNGUonKVi_oVi^KoFe]Koe9BD_oUiNGoi^KV
00?oiNGU00CoHf=SoeaLG?oUiNGoiNGU0_oVi^H01ooUiNGoi^KVonKVi_oU
iNGoi^KVonGUiOoVi^H00ooUiND2onKViP;oiNGU0_oVi^H01ooUiNGoi^KV
onKVi_oUiNGoi^KVonGUiOoVi^H00ooUiND2onKViP;oiNGU0_oVi^H01_oU
iNGoi^KVonKVi_oUiNGoi^KVonGUi@?oi^KV00GoinOWonSXj?oXj>Soj>SX
onOWi`02onSXj00BonOWiooXj>Soj>SXonSXj?nKVi_oY:BTojj^[_ne]KGo
_Kfmol?3`oo:b/[odM7AomGEeOoIfMWogMgMon3Ph?oRh^;oi>CT0ooVi^H0
0ooUiNGoi^KVonKViP3oonKVi]ooi^KV00000on[Zj_oXJ6QooOgm`02ooOg
m`09ooKfm_ogmoOom_KfooOgmoofm_KomoOgooKfm_ogmoOom_Kf00?omOGe
0_odm?@02_oemOGono_kod];Boo]kNgoQXJ6od];BomgMgOoC4a<ollOcomJ
FUX2oam;M`05ohJ6Q_o]kNgokNg]ohJ6Q_o1`L400_odm?@01ooemOGom?Cd
ooCdm?oShn?ofm_Kom[Jf_oWinL00oodm?@01?oemOGom?CdooCdm?oemOD2
ooCdm007ooGemOodm?Com?CdooCdm?oemOGoQXJ6oh20P003ooCdm004ooGe
mOodm?Com?CdooGem@;om?Cd00_omOGeooCdm?odm?Com?CdooGemOodm?Co
mOGeon?ShooQhN7om?CdooGem@02ooCdm004ooGemOoTi>Cohn?SooGem@?o
m?Cd00?omOGeooCdm?oemOD00oodm?@01?oemOGom?CdooCdm?oemOD2ooCd
m007ooGemOodm?Com?CdooCdm?oemOGom?CdooGem@03ooCdm004ooGemOod
m?Com?CdooGem@;om?Cd00OomOGeooCdm?odm?Com?CdooGemOodm?ComOGe
00?om?Cd0_oemOD02_ofm_KomoOgooOgmoofm_KomoOgooKfm_ogmoOom_Kf
ooOgmoofm_H2ooOgm`0>oj2PX?nZZZ[o];Bdokbl_?o4a<Cobl_;om7AdOoG
emOog=cLon7QhOoTi>CoinOWon_[joo/k>`2onk^kP03ong]kOo^k^kok^k^
0?ook^k^h?o^k^h00003okJf]_n/[:cooooo00Wooooo0_ono_h2oogmo@?o
o?cl0_omoOd00on8R8Sokno_ono_k`02ono_k`06ol;2`_miCWWooOgmono_
konUYJGoUiNG0_o_knl00on8R8Sod];Booclo003ooclo003oogmoOolo?co
o?cl00Coo?cl00GooOgmooclo?olo?coo?cloogmo@04ooclo003oogmoOol
o?coo?cl00Coo?cl00GooOgmooclo?olo?coo?cloogmo@04ooclo003oogm
oOolo?coo?cl00Coo?cl00GooOgmooclo?olo?coo?cloogmo@04ooclo003
oogmoOolo?coo?cl00Coo?cl00GooOgmooclo?olo?coo?cloogmo@04oocl
o003oogmoOolo?coo?cl00Coo?cl00GooOgmooclo?olo?coo?cloogmo@04
ooclo003oogmoOolo?coo?cl00Coo?cl00CooOgmooclo?omoOgoo_kn2ooo
ool03_n/[:co]kNgol30`?o9bLWod];BomWIfOoPh>3oinOWonc/k?oalO7o
mOGeooShn?okno_ooOgmoooooooUooooo`0000?oZj^[oj2PX?ogmoL00_of
m_H01?ogmoOom_KfooOgmoofm_H3ooOgm`;om_Kf00_omOGeooCdm?oemOGo
m?CdooGemOodm?Cono_koda<C?okno_okNg]onc/k003ong]k@0<onc/k?o]
kNgok>c/onc/k?o]kNgok>c/ohJ6Q_o?cloom?CdooGemOodm?ComOGe0_od
m?@2ooGem@07ooCdm?oemOGom?CdooCdm?oemOGom?CdooGem@02ooCdm003
ooGemOodm?ComOGe00;om?Cd0_oemOD01oodm?ComOGeooCdm?odm?ComOGe
ooCdm?oemOD00_odm?@00ooemOGom?CdooGem@02ooCdm0;omOGe00Oom?Cd
ooGemOodm?Com?CdooGemOodm?ComOGe00;om?Cd00?omOGeooCdm?oemOD0
0_odm?@2ooGem@07ooCdm?oemOGom?CdooCdm?oemOGom?CdooGem@02ooCd
m003ooGemOodm?ComOGe00;om?Cd0_oemOD01oodm?ComOGeooCdm?odm?Co
mOGeooCdm?oemOD00_odm?@00ooemOGom?CdooGem@02ooCdm0;omOGe00Co
m?CdooGemOodm?Com?Cd0_oemOD3ooKfmP04ooOgmoofm_KomoOgooKfmP?o
moOg013om_KfooOgmonPX:3oZZZZokBd]?nl_;coa<C4ol[:b_o@d=3of=SH
omcLg?oRh^;oi>CTonOWioo[jn_okNg]0_o^k^h00oo]kNgok^k^onk^kP3o
onk^k^3ok^k^00000onUYJGoW9bLonSXj003onSXj006onOWiooXj>Soj>SX
onSXj?oWinOoj>SX0ooWinL4onKViP04onGUiOojn_[oBTY:ohB4Q0?oQHF5
00?oQ8B4ohF5QOn4Q8@01_n5QHD01?ojn_[oi^KVonKVi_oUiND2onKViP;o
iNGU00?oi^KVonGUiOoVi^H01OoVi^H01?oUiNGoi^KVonKVi_oUiND2onKV
iP;oiNGU00?oi^KVonGUiOoVi^H01OoVi^H01?oUiNGoi^KVonKVi_oUiND2
onKViP;oiNGU00?oi^KVonGUiOoVi^H01OoVi^H01?oUiNGoi^KVonKVi_oU
iND2onKViP;oiNGU00?oi^KVonGUiOoVi^H01OoVi^H01?oUiNGoi^KVonKV
i_oUiND2onKViP;oiNGU00?oi^KVonGUiOoVi^H01OoVi^H01?oUiNGoi^KV
onKVi_oUiND2onKViP;oiNGU00?oi^KVonGUiOoVi^H00ooVi^H3onOWi`;o
j>SX00GoinOWonSXj?oXj>Soj>SXonOWi`03onSXj00>oibLW?nUYJGo[Zj^
okJf]_nn_[ko`l?3ol[:b_o@d=3oe=CDomWIfOoMgMgogmoOon;Rh_oTi>Co
onKVi^Goi^KV00001OnZZZ[oX:2PooKfm_ogmoOom_Kf00;omoOg00?om_Kf
ooOgmoofm_H00_ogmoL2ooKfmP03ooGemOodm?Com?Cd00Gom?Cd00?omOGe
ooCdm?oemOD00_odm?@00ooemOGom?CdooGem@08ooCdm003ooGemOodm?Co
mOGe00;om?Cd00?omOGeooCdm?oemOD02?odm?@00ooemOGom?CdooGem@02
ooCdm003ooGemOodm?ComOGe00Som?Cd00?omOGeooCdm?oemOD00_odm?@0
0ooemOGom?CdooGem@08ooCdm003ooGemOodm?ComOGe00;om?Cd00?omOGe
ooCdm?oemOD02?odm?@00ooemOGom?CdooGem@02ooCdm003ooGemOodm?Co
mOGe00Som?Cd00?omOGeooCdm?oemOD00_odm?@00ooemOGom?CdooGem@02
ooCdm0?omOGe00OomoOgooKfm_ogmoOomoOgooKfm_ogmoOom_Kf00;omoOg
013om_KfooOgmonQXJ7oZZZZokBd]?nl_;coa<C4ol[:b_oAdM7of=SHomcL
g?oQhN7oi>CTonOWioo[jn_okNg]0oo^k^h00oo]kNgok^k^onk^kP3oonk^
k]ook^k^00000ong]kOo[:b/oo_kn`02oo_kn`05oo[jn_okno_on_[joo[j
n_okno/00_ojn_X00ookno_onOWiooWin@02ooWin@?on?Sh00?onOWiooSh
n?ohn?P03Oohn?P00ooinOWon?ShooShn00=ooShn003ooWinOohn?Son?Sh
00gon?Sh00?onOWiooShn?ohn?P03Oohn?P00ooinOWon?ShooShn00=ooSh
n003ooWinOohn?Son?Sh00gon?Sh00?onOWiooShn?ohn?P02?ohn?P3ooWi
n@05oo[jn_okno_ono_koo[jn_okno/00_ojn_X04ookno_on_[joo[jn_ok
no_on_[jojb/[?ng]kOo`L71olW9bOoBd];ofMWIon3Ph?oWinOok>c/oo7a
lOodm?Con?Shoo_knoomoOd0oooooooUooooo`0000?oZZZZoj6QXOoZj^X0
0_oYjNT5on[ZjP04onWYjOoZj^[oj^[ZonWYj@;oj>SX00?oinOWonSXj?oW
inL00_oWinL2onSXj003onOWiooXj>SoinOW00;oinOW00Koj>SXonOWiooW
inOoj>SXonOWiooXj>P3onOWi`;oj>SX00?oinOWonSXj?oWinL00_oWinL0
1_oXj>SoinOWonOWiooXj>SoinOWonSXj0?oinOW0_oXj>P00ooWinOoj>SX
onOWi`02onOWi`06onSXj?oWinOoinOWonSXj?oWinOoj>SX0ooWinL2onSX
j003onOWiooXj>SoinOW00;oinOW2_lO7al00ooXj>SoinOWonSXj003onOW
i`06onSXj?oWinOoinOWonSXj?oWinOoj>SX0ooWinL2onSXj003onOWiooX
j>SoinOW00;oinOW00Koj>SXonOWiooWinOoj>SXonOWiooXj>P3onOWi`;o
j>SX00?oinOWonSXj?oWinL00_oWinL01_oXj>SoinOWonOWiooXj>SoinOW
onSXj0?ojNWY1OoZj^X04_oYjNWoj^[Zon[Zj_oYjNWoXJ6Qoj^[Zond];Co
_;blolC4a?o:b/[odM7AomSHf?oMgMgohN7QonGUiOoWinOoj^[Zonc/k?oo
k^k^iOo^k^h00003ojBTY?nKVi_omOGe00ComOGe00?om?CdooGemOoemOD0
0_oemOD2ooCdm00<oo?cloobl_;ol_;boo;bl_oclo?ol_;boo[jn_nCTi?o
FEUIoeQHF?mIFEWoF5QH0_mIFET00omHF5SoBTY:oeUIF@03oeQHF003oeUI
FOnRXZ;olo?c00?ol_;b00?olo?coo;bl_oclo<00_obl_82oo?cl`?ol_;b
00?olo?coo;bl_oclo<00oobl_800ooclo?ol_;boo?cl`02oo;blP;olo?c
0oobl_800ooclo?ol_;boo?cl`03oo;blP03oo?cloobl_;olo?c00;ol_;b
0_oclo<3oo;blP03oo?cloobl_;olo?c00?ol_;b00?olo?coo;bl_oclo<0
0_obl_82oo?cl`?ol_;b00?olo?coo;bl_oclo<00oobl_800ooclo?ol_;b
oo?cl`02oo;blP;olo?c0oobl_800ooclo?ol_;boo?cl`03oo;blP03oo?c
loobl_;olo?c00;ol_;b0_oclo<2oo;blP03oo?cloodm?Com?Cd00?omOGe
00?om?CdooGemOoemOD00_oemOD04?odm?ComOGeoi^KVonTY:Co[Jf]okFe
]Onn_[koa<C4ol[:b_o@d=3oeMGEomWIfOoMgMgogmoOon?ShooTi>CoonKV
i^Goi^KV00000onZZZ[oXJ6Qoo_kn`0:oo_kn`;on_[j0ooinOT01Oohn?So
nOWioo_knomJFU[oMgMg00;oQXJ600GoQHF5ogMgMon6QXKoQXJ6ohF5Q@04
ohJ6QP03od];Boo@d=3on?Sh00ConOWi00Gon?ShooWinOoinOWonOWiooSh
n004ooWin@05ooShn?oinOWol?3`on3Ph?ohn?P00_oinOT01oohn?SonOWi
ong]kOo_knoon?ShonKVi_o_knl00_oinOT01_ohn?SonOWiooShn?oinOWo
l?3`on3Ph0;on?Sh0ooinOT02?ohn?SonOWiooWinOo[jn_oc<c<on_[jooi
nOWon?Sh0ooinOT01_o/k>col?3`ooWinOoinOWoh^;RooShn0?onOWi00Co
hn?Soo7alOoinOWon?Sh1?oinOT01Oohn?SonOWiooWinOoinOWon?Sh00Co
nOWi00?on?ShooWinOohn?P01?oinOT01Oohn?SonOWiooWinOoinOWon?Sh
00?onOWi0_ojn_X;oo_kn`0@oj6QXOn[Zj_o];Bdokbl_?o4a<Cobl_;om7A
dOoHf=Sog=cLon7QhOoTi>CoinOWon_[joo/k>cok^k^ong]kOook^k^hoo^
k^h00006okNg]on/[:cono_koo_knoojn_[ono_k0oojn_X00ookno_on_[j
oo_kn`02oo[jnP03ooWinOohn?SonOWi00?on?Sh013ooOgmode=COo_knoo
k^k^ol?3`on8R8So];BdoogmoOo^k^koh>3PohR8R?oPh>3okno_onk^k_n8
R8Sod];B1Oohn?P00omSHf?oFe]KooShn002ooShn00:ojBTY?lQ8B7o[Jf]
ooShn?o[jn_oJFUYob<S8ol];Bgo;bl_ojBTY0?on?Sh00OoJf][oeeMGOmF
EUKo<C4aob@T9?mgMgOolo?c00;on?Sh00Koj^[ZofUYJOlS8b?o;2`/obl_
;onUYJD4ooShn007ol[:b_m7AdOo8R8Robl_;ol/;2coBDU9ohJ6QP02ooSh
n00<oginO_lW9bOo:BTYohF5QOmfMWKo:RXZokno_oohn?SojNWYoe9BD_lW
9bOoO7al7Oohn?P2ooWin@04oo[jn_okno_on_[joo_kn`?on_[j01?ono_k
oo[jn_okno_on_[joo_knon/[:co][Jfol71`Oo9bLWod];BomWIfOoPh>3o
inOWonc/k?oalO7om?CdooShn?okno_ooOgm0?ooooooiOooool00004oj^[
ZonPX:3oj^[ZonWYj@Coj^[Z00CoTI6AogUiNOoZj^[oj^[Z0_oYjNT3onSX
j0?oinOW013ono_koda<C?okno_okNg]ohJ6Q_lOBlooBd/Ooda<8?mJFU[o
C1m<oalO??mg7gOoQXJ6oo_knon6QXKo`<300_oXj>P04ooWinOoj>SXonOW
iomLG5coEUIFonSXj?oWinOod=3@obTY:OmXJ6Soj>SXonOWiomVIVKo>c/k
okZj^_oRh^;oU9BDob0P8?ne]KD00_oWinL01omUIFGo<c<cokVi^OoWinOo
[Jf]ob`/;?n=SHd00_oWinL07_mVIVKo?3`lokZj^_oRh^;oU9BDoalO7one
]KGoj>SXonOWionk^k_o8B4Qoe5ADOo:b/[oinOWonKVi_o4a<CoPH61onSX
j?o;bl_o820PoijNW_oGemOoQhN7ob0P8?nEUIGoj>SXonOWionGUiOo:BTY
omWIf@;oinOW0_oXj>P00ooWinOoj>SXonOWi`02onOWi`04onSXj?oWinOo
j>SXonOWi`;oj>SX0ooWinL2onSXj003onOWiooXj>SoinOW00;oinOW00Co
j>SXonOWiooXj>SoinOW0ooXj>P2onWYj@Goj^[Z01?ojNWYon[Zj_oZj^[o
jNWYon[Zj_nPX:3oZZZZokBd]?nl_;coa<C4ol[:b_oAdM7of=SHomcLg?oR
h^;oi>CTonOWioo[jn_okNg]00;ok^k^00?okNg]onk^k_o^k^h0ooo^k^kP
onk^kP0000SoY:BToi^KVooemOGomOGeooCdm?oemOGom?CdoiJFUP;o820P
00?oOWinooCdm?oemOD00_odm?@2oo;blP?olo?c013on_[johF5QOo[jn_o
jn_[ogIfM_lNM_[o7WK>oeQHF?m:7T[oBTY:ohF5QOm97TWoTi>Con_[jomf
MWKoc/k>1?obl_803?oclo?oGemOoeQHF?obl_;olo?coeMGEolj>S[oi^KV
oo;bl_oVi^Ko7QhNohN7Q`?ol_;b00oo=3@dofIVI_oclo?ol_;bofMWIomO
Geool_;boo?cloobl_;oH61Pochn?_oclo?oi^KVoahN7_n6QXH00_obl_80
2Ooclo?o=3@dofIVI_obl_;olo?cod];Bolg=cOok>c/oo;blP03oo?cl`;o
l_;b00_oe=CDoahN7_na/K7olo?conk^k_lN7Qko[Zj^oo;bl_oclo?oLW9b
oe5AD@03oo?cl`Col_;b0_oclo<2oo;blP03oo?cloobl_;olo?c00;ol_;b
0ooclo<4oo;blP;olo?c0_obl_801?oclo?ol_;boo?cloobl_82oo?cl`05
ooCdm?oemOGom?CdooGemOodm?@01?oemOD04Oodm?ComOGeooGemOnKVi_o
Y:BTojj^[_nf][Ko_[jnolC4a?o9bLWod=3@omCDe?oIfMWogMgMon3Ph?oS
hn?oi>CT00?oi^KV00?oiNGUonKVi_oVi^H0oooVi^KOonKViP0000?oZZZZ
oj6QXOokno/00ookno/00onJVY[o8B4Qob0P8002ob4Q8@0Joh61POokno_o
n_[joo[jn_oinOWon?ShooWinOohn?SonOWioo_knom<C4cokNg]omkNg_l]
;Bgo87Sloamgnom;Mloo?CdmoiBDU?nSXj?o?3`lomkNg_o]kNgoQHF5om3@
d?ohn?P3ooWin@07ooShn?mRHV;oFUYJooWinOnPX:3o8R8RolO7a`02ooSh
n004olk>c_lO7aoo_[jnooShn0;onOWi00ooJ6QXod];BooinOWon?ShofYZ
J_mRHV;on?ShooWinOohn?SoU9BDob<S8oofm_Koc/k>oalO7onn_[h00_oi
nOT01oohn?SoJFUYod];BooinOWoj^[ZoalO7onCTi<00_ohn?P01?oinOWo
n?ShooWinOohn?P2ooWin@0>oi2@T?ld=3CoL71`oiVIVOlO7aoo/k>cooSh
n?oinOWoMWIfoeEEEOoinOWon?ShooWinOohn?P3ooWin@03ooShn?oinOWo
n?Sh00;onOWi00Son?ShooWinOohn?Son?ShooWinOohn?SonOWiooShn0?o
nOWi00?on?ShooWinOohn?P00_oinOT01?ohn?SonOWiooWinOohn?P2oo[j
nPKono_k00?oo?cloo_knookno/00_okno/03_nQXJ7oZZZZok>c/onl_;co
a<C4ol_;booAdM7of=SHomcLg?oQhN7oi>CTonSXj?oZj^[ok>c/ooo^k^kU
onk^kP0000Ko]kNgojb/[?okno_on_[joo_knon/[:`5ob<S8`03ob8R8_nD
U9Con_[j00;onOWi1?ohn?P04?omoOgoCDe=onk^k_m>CTkoCB5=ob4Q<?lo
?coo?Shnob5=COm>8Tko<24Qob8R8_m>CTko`/;2ohR8R?o3`l<5ooShn005
of=SHolb<S;oG5aLob/[:omlO7`00oohn?P00ooNg]ko8B4QojBTY003ooSh
n006oe5ADOmKFe_on?ShooShn?m[Jf_oHV9R0oohn?P01_n4Q8Co>CTiooSh
n?oNg]ko8R8RojFUY@?on?Sh00KoD51@oeaLG?ohn?Sobl_;ob8R8_ne]KD9
ooShn005onWYjOnm_KgoYjNWob4Q8Onb/[800_ohn?P00omhN7SoF5QHooSh
n00MooShn0?onOWi0_ojn_X2oo_kn`05oo[jn_okno_on_[joo[jn_okno/0
0_ojn_X03ookno_o[:b/okNg]oo1`L7obLW9om;Bd_oIfMWoh>3PonOWioo[
jn_olO7aooCdm?ohn?Soo?cloogmo@3oooooonGooooo00001on[Zj_oXJ6Q
on[Zj_oZj^[ojNWYomcLg?m9BDT00_lQ8B402OlP823o8B4Qoc/k>ooBd];o
jNWYonSXj?oWinOoj>SXonOWi`02onSXj00@oo_knon5QHGoMd]gogM;Mon6
QXKoU9BDogMgMom<C23o7d_?oamgd?m;7gOo7alOogM<Mom;Bd_oQXJ6om3@
d0;oinOW00koj>SXonOWiooXj>SoG5aLod92@_n@T93oG5aLobl_;onOWioo
inOWonSXj?oVi^Ko>SXjofEUI@;oinOW01cofm_Kob8R8_n8R8SoinOWonSX
j?mUIFGo<S8bol?3`ooWinOohn?SodU9BOm^KVkoj>SXonKVi_li>CWoI6AT
onSXj?oWinOog=cLob8R8_n8R8Soj>SXokZj^_lO7aoo[Jf]onOWiooXj>So
inOW0_oXj>P2onOWi`0<onSXj?oUiNGoj>SXonOWiooAdM7o820PokRh^?oX
j>SoinOWofm_KomBDU;oinOW0_oXj>P2onOWi`04onSXj?oWinOoj>SXonOW
i`;oj>SX00KoinOWonSXj?oWinOoinOWonSXj?oWinL2onSXj0;oinOW00Co
j>SXonOWiooXj>SoinOW0_oXj>P01?oWinOoj>SXonOWiooWinL2onSXj008
onWYjOoZj^[ojNWYonWYjOoZj^[ojNWYon[Zj_oYjNT2on[ZjP0@onWYjOoZ
j^[oXJ6QojZZZ_nd];Co_;blolC4a?o;bl_odM7AomOGeooLg=cohN7QonCT
i?oWinOojn_[ong]kOook^k^iOo^k^h00003ojFUYOnKVi_om?Cd00?omOGe
00KoinOWodY:B_lP823o7alOoc/k>ooLg=`3ooCdm003oo;bl_oclo?ol_;b
00;ol_;b00Won_[joeUIFOm:7T[ocQk>ogI:M_mfMWKo;1hNoj9f7_o>XQh0
0_lNM/h2oj8NXP03okno_on4Q8Coc/k>00;olo?c0_obl_806_oclo?oGemO
oeQHF?oclo?ol_;bohB4Q?lS8b?oi^KVoo?cloobl_;o^;RhobLW9om;Bd_o
OWinobh^;_m:BT[ok>c/oo?cloobl_;oIfMWoe5ADOm:BT[oGUiNocPh>?lQ
8B7o^k^k0_obl_803Oni^KWo:2PXod];BommOGgo;bl_odY:B_o[jn_olo?c
on;Rh_lN7QkoVIVIoo;bl_oclo<00oobl_82oo?cl`0>oo;bl_m[Jf_oDU9B
ohN7QomADE7o<S8boo7alOobl_;o/K6aod51@Olc<c?oMGEeoibLW?obl_82
oo?cl`;ol_;b0_oclo<01oobl_;olo?coo;bl_obl_;olo?coo;bl_oclo<0
0oobl_82oo?cl`;ol_;b0_oclo<01_obl_;olo?coo;bl_obl_;olo?coo;b
lP?olo?c00Gom?CdooGemOoemOGomOGeooCdm002ooGem@0BooCdm?oemOGo
mOGeooGemOnKVi_oY:BTojj^[_ne]KGo_Kfmol?3`oo:b/[odM7AomGEeOoI
fMWogMgMon3Ph?oRh^;oi>CT0ooVi^H00ooUiNGoi^KVonKViP3oonKVi]oo
i^KV00001?n[Zj_oXJ6Qoo_knoolo?`3oo_kn`04onc/k?m<C4co?Cdmon;R
hP;ono_k00?on_[jooWinOoinOT01?oinOT01?okno_oBd];olo?comJFUX2
oalO7`0:od`OC?mgMaoonm0Poj=g7omg7gOocaokogLPMomgBgOoQXJ6ol71
`@;on?Sh00[onOWiooShn?oinOWoHF5QoeYJF_ohn?SonOWiol[:b_lO7aoo
^[Zj0ooinOT03_oLg=coUiNGoh>3PonZZZ[omOGeooWinOohn?SonOWiofYZ
J_mRHV;oj>SXoj2PX?n9RHWob/[:0ooinOT02oohn?Sofm_KoiNGUon4Q8Co
ZZZZooGemOoinOWon?ShooWinOm5ADGoC4a<00GonOWi0_ohn?P01_oinOWo
j^[Zok^k^on<S8coXJ6Qon;RhP;onOWi00KoalO7oe5ADOlo?cooWIfMokZj
^_oinOT2ooShn006ooWinOohn?SonOWiooShn?oinOWon?Sh0_oinOT00ooh
n?SonOWiooWin@03ooWin@;on?Sh00KonOWiooShn?oinOWon?ShooWinOoh
n?P2ooWin@03ooShn?oinOWonOWi00;on_[j2ookno/03_nPX:3oZZZZokBd
]?nl_;coa<C4ol_;booAdM7oemOGomcLg?oQhN7oi>CTonOWioo[jn_ok>c/
0_o^k^h00oo]kNgok^k^onk^kP3oonk^k^3ok^k^00000onf][Ko[:b/oo[j
nP02oo_kn`07oo[jn_okno_on_[jong]kOoRh^;on_[joo_kn`02oo[jnP;o
nOWi1?ohn?P04?omoOgoR8R8ono_koo_knoo?cloojDQYOmiCGWoNB9iogTQ
NOm>8DkoYGTQoc0`<?oAdM7okno_ohR8R?oBd]85ooShn007of=SHomKFe_o
n?ShomOGeomYJFWo:b/[ong]k@0;ooShn003of][JomRHV;on?Sh00oon?Sh
00Co`<30ob4Q8On3Ph?om?Cd0_ohn?P00oo_knoo`<30ooShn009ooShn003
oi6ATOm]KFgon?Sh01gon?Sh00ConOWiooShn?oinOWonOWi0_okno/01?oj
n_[ono_koo[jn_okno/2oo[jnP0Aoo_knoojn_[ono_kojb/[?ng]kOo`<30
olW9bOoBd];ofMWIon3Ph?oWinOok>c/oo7alOoemOGon?Shoo_knoomoOd0
oooooooUooooo`0000?oZj^[oj2PX?oZj^X00_oYjNT01?oZj^[ojNWYon[Z
j_oYjNT3on[ZjP;ojNWY02Goj>SXonOWiooXj>SoinOWonSXj?oWinOono_k
oeYJF_o/k>coY:BTobd];OmJFU[od23@ollOconS7j?o7dagolnS7on5QHGo
kNg]onc/k?n6QXKoclo?onOWiooXj>SoinOWonSXj?oWinOoG5aLob8R8_lU
9BGo820PodU9BOnJVY[oinOWonSXj?oWinOoj>SX00;oinOW00?oj>SXonOW
iooXj>P00_oWinL01?oXj>SoI6AToeaLG?oXj>P2onOWi`03onSXj?oWinOo
j>SX00;oinOW00?oj>SXonOWiooXj>P00_oWinL2onSXj00<onOWiooXj>So
[:b/oc<c<ol];BgoCdm?odE5AOlT92Co=cLgonSXj?oWinOoj>SX0_oWinL2
onSXj007onOWiooXj>SoinOWonOWiooXj>SoinOWonSXj002onOWi`03onSX
j?oWinOoj>SX00;oinOW0_oXj>P01ooWinOoj>SXonOWiooWinOoj>SXonOW
iooXj>P00_oWinL00ooXj>SoinOWonSXj002onOWi`;oj>SX00CoinOWonSX
j?oWinOoinOW0_oXj>P3onWYj@04on[Zj_oYjNWoj^[ZonWYj@?oj^[Z013o
jNWYon[Zj_nPX:3oZZZZokBd]?nl_;coa<C4ol[:b_o@d=3of=SHomcLg?oR
h^;oi>CTonOWioo[jn_okNg]0_o^k^h00oo]kNgok^k^onk^kP3oonk^k^3o
k^k^00000onUYJGoW9bLooGem@03ooGem@06ooCdm?oemOGomOGeooGemOod
m?ComOGe0oodm?@4oo?cl`0Boo;bl_ojn_[oBTY:on_[jon5QHGoBTY:ogIf
M_m9BDWocQk>oeQHF?lNBWKo7dYfohF5QOo[jn_ok>c/ohF5QOno_koolo?c
0_obl_82oo?cl`04on7QhOoHf=SofMWIonGUi@Kolo?c00Col_;boo?cloob
l_;ol_;b0_oclo<2oo;blP03ohF5QOmnOWkolo?c00Golo?c00Col_;boo?c
loobl_;ol_;b0_oclo<2oo;blP0:oo?cloobl_;olo?coo?cloo^k^koclo?
ojj^[_nk^k_ofMWIoo7al@;ol_;b0_oclo<2oo;blP03oo?cloobl_;olo?c
00Golo?c00Col_;boo?cloobl_;ol_;b0_oclo<2oo;blP03oo?cloobl_;o
lo?c00Golo?c00Col_;boo?cloobl_;ol_;b0_oclo<2oo;blP03oo?cloob
l_;olo?c00?olo?c0oodm?@2ooGem@0FooCdm?oemOGomOGeooGemOodm?Co
mOGeooCdm?oemOGoW9bLojFUYOn^[Zko][Jfokjn__o3`l?ob/[:om3@d?oD
e=CofMWIomgMgOoOgmooh^;RonCTi?ooi^KViOoVi^H00003ojZZZ_nPX:3o
no_k00[ono_k00Con_[jooWinOohn?SonOWi0_ohn?P04_oinOWono_kohJ6
Q_o]kNgok>c/ong]kOo/k>co`L71ogM<Mookno_okNg]oj>SXonDU9CokNg]
onc/k?n5QHGoclo?ooShn0;onOWi00?on?ShooWinOohn?P00_oinOT01Ooh
n?SonOWiooShn?ohn?SonOWi00;on?Sh00OonOWiooShn?oinOWonOWiooSh
n?oinOWon?Sh00;onOWi00Gon?ShooWinOohn?Son?ShooWin@02ooShn007
ooWinOohn?SonOWiooWinOohn?SonOWiooShn002ooWin@05ooShn?oinOWo
n?ShooShn?oinOT00_ohn?P01ooinOWon?ShooWinOoinOWon?ShooWinOoh
n?P00_oinOT01Oohn?SonOWiooShn?ohn?SonOWi00;on?Sh00OonOWiooSh
n?oinOWonOWiooShn?oinOWon?Sh00;onOWi00Gon?ShooWinOohn?Son?Sh
ooWin@02ooShn007ooWinOohn?SonOWiooWinOohn?SonOWiooShn002ooWi
n@04ooShn?oinOWon?ShooShn0;onOWi00?on_[joo_knookno/02Ookno/0
3_nQXJ7oZZZZokBd]?nl_;coa<C4ol[:b_oAdM7of=SHomcLg?oQhN7oi>CT
onOWioo[jn_okNg]0oo^k^h00oo]kNgok^k^onk^kP3oonk^k]ook^k^0000
0ong]kOo[:b/oo_kn`02oo_kn`05oo[jn_okno_on_[joo[jn_okno/00_oj
n_X00ookno_onOWiooWin@02ooWin@?on?Sh00Coo_knode=COomoOgok^k^
0oo_knl00oo^k^kokno_onk^kP04ono_k`03ohR8R?oBd];onOWi00oon?Sh
00?onOWiooShn?ohn?P03Oohn?P00ooinOWon?ShooShn00=ooShn003ooWi
nOohn?Son?Sh00gon?Sh00?onOWiooShn?ohn?P03Oohn?P00ooinOWon?Sh
ooShn008ooShn0?onOWi00Gon_[joo_knookno_on_[joo_kn`02oo[jnP0C
oo_knoojn_[on_[joo_knoojn_[o[:b/okNg]oo1`L7obLW9om;Bd_oIfMWo
h>3PonOWioo/k>colO7aooCdm?ohn?Sono_koogmo@3oooooonGooooo0000
0onZZZ[oXJ6Qon[ZjP02onWYj@Goj^[Z00CojNWYon[Zj_oZj^[ojNWY0_oX
j>P01_oWinOoj>SXonOWiooWinOono_kod];B`CoQXJ600?oQHF5ohJ6Q_n6
QXH01_n6QXH01_okno_oinOWonSXj?oXj>SoinOWonSXj0?oinOW00Koj>SX
onOWiooWinOoj>SXonOWiooXj>P3onOWi`;oj>SX00?oinOWonSXj?oWinL0
0_oWinL01_oXj>SoinOWonOWiooXj>SoinOWonSXj0?oinOW0_oXj>P00ooW
inOoj>SXonOWi`02onOWi`06onSXj?oWinOoinOWonSXj?oWinOoj>SX0ooW
inL2onSXj003onOWiooXj>SoinOW00;oinOW00Koj>SXonOWiooWinOoj>SX
onOWiooXj>P3onOWi`;oj>SX00?oinOWonSXj?oWinL00_oWinL01_oXj>So
inOWonOWiooXj>SoinOWonSXj0?oinOW0_oXj>P00ooWinOoj>SXonOWi`02
onOWi`06onSXj?oWinOoinOWonSXj?oWinOoj>SX0ooYjNT5on[ZjP0BonWY
jOoZj^[oj^[ZonWYjOnQXJ7oZj^[okBd]?nl_;coa<C4ol[:b_oAdM7of=SH
omgMgOoQhN7oiNGUonOWiooZj^[ok>c/ooo^k^kUonk^kP0000?oY:BToi^K
VooemOD01?oemOD00oodm?ComOGeooGem@02ooGem@;om?Cd00Oolo?coo;b
l_obl_;ol_;boo?cloobl_;olo?c00?ol_;b00?olo?coo;bl_oclo<00_ob
l_82oo?cl`?ol_;b00?olo?coo;bl_oclo<00oobl_800ooclo?ol_;boo?c
l`02oo;blP;olo?c0oobl_800ooclo?ol_;boo?cl`03oo;blP03oo?cloob
l_;olo?c00;ol_;b0_oclo<3oo;blP03oo?cloobl_;olo?c00?ol_;b00?o
lo?coo;bl_oclo<00_obl_82oo?cl`?ol_;b00?olo?coo;bl_oclo<00oob
l_800ooclo?ol_;boo?cl`02oo;blP;olo?c0oobl_800ooclo?ol_;boo?c
l`03oo;blP03oo?cloobl_;olo?c00;ol_;b0_oclo<3oo;blP03oo?cloob
l_;olo?c00?ol_;b00?olo?coo;bl_oclo<00_obl_82oo?cl`;ol_;b00?o
lo?cooCdm?odm?@00ooemOD00oodm?ComOGeooGem@02ooGem@0@ooCdm?oe
mOGoVi^KojBTY?n][Jgo]KFeokjn__o4a<Cob/[:om3@d?oEeMGofMWIomgM
gOoOgmoohn?SonCTi?ooi^KViOoVi^H00005ojZZZ_nQXJ7om_KfooOgmoof
m_H01?ogmoL01?ofm_KomoOgooOgmoogmoL3ooGem@?om?Cd00ComOGeooCd
m?oemOGom?Cd0_oemOD01Oodm?ComOGeooCdm?oemOGom?Cd00;omOGe0ood
m?@01?oemOGom?CdooGemOodm?@2ooGem@05ooCdm?oemOGom?CdooGemOod
m?@00_oemOD3ooCdm004ooGemOodm?ComOGeooCdm0;omOGe00Gom?CdooGe
mOodm?ComOGeooCdm002ooGem@?om?Cd00ComOGeooCdm?oemOGom?Cd0_oe
mOD01Oodm?ComOGeooCdm?oemOGom?Cd00;omOGe0oodm?@01?oemOGom?Cd
ooGemOodm?@2ooGem@05ooCdm?oemOGom?CdooGemOodm?@00_oemOD3ooCd
m004ooGemOodm?ComOGeooCdm0;omOGe00Gom?CdooGemOodm?ComOGeooCd
m002ooGem@?om?Cd00ComOGeooCdm?oemOGom?Cd0_oemOD01Oodm?ComOGe
ooCdm?oemOGom?Cd00ComOGe00?om_KfooOgmoofm_H01?ogmoL05Oofm_Ko
moOgooOgmoogmoOom_Kfoj6QXOn[Zj_o];Bdokbl_?o4a<Cobl_;om7AdOoH
f=Sog=cLon7QhOoTi>CoinOWon_[joo/k>cok^k^ong]k@3oonk^k^?ok^k^
00001_ng]kOo[:b/onk^k_o^k^kokNg]onk^kP?okNg]00?ok^k^ong]kOo^
k^h00_o]kNd3onc/k2Wojn_[1_lQ8B400olR8R;o8B4Qob8R8P0mon_[j`;o
k>c/00CokNg]onk^k_o]kNgok^k^0oo]kNd04oo^k^kokNg]onk^k_o]kNgo
k^k^ojb/[?nf][Ko`L71olW9bOoBd];ofMWIon3Ph?oWinOok>c/oo7alOod
m?Con?Shoo_knoomoOd0oooooooUooooo`0000CoZj^[oj2PX?ofm_Kom_Kf
1?ogmoL2ooKfmP;omoOg0_ofm_H3ooGem@?om?Cd00?ono_koiFEUOmJFUX0
0_mJFUX01OmIFEWoFUYJoeYJF_mJFU[oC4a<00GoFUYJ00GoXj>SooGemOoe
mOGom?CdooGem@03ooCdm003ooGemOodm?ComOGe00;om?Cd00ComOGeooCd
m?odm?Com?Cd0_oemOD00oodm?ComOGeooCdm002ooCdm003ooGemOodm?Co
mOGe00;om?Cd00ComOGeooCdm?odm?Com?Cd0_oemOD00oodm?ComOGeooCd
m002ooCdm003ooGemOodm?ComOGe00;om?Cd00ComOGeooCdm?odm?Com?Cd
0_oemOD00oodm?ComOGeooCdm002ooCdm003ooGemOodm?ComOGe00;om?Cd
00ComOGeooCdm?odm?Com?Cd0_oemOD00oodm?ComOGeooCdm002ooCdm003
ooGemOodm?ComOGe00;om?Cd00ComOGeooCdm?odm?Com?Cd0_oemOD00ood
m?ComOGeooCdm002ooCdm003ooGemOodm?ComOGe00;om?Cd0_oemOD2ooKf
mPComoOg0_ofm_H2ooOgm`0@ooKfm_ogmoOoX:2PojZZZ_nd];Co_;blolC4
a?o:b/[odM7AomSHf?oLg=coh^;RonCTi?oWinOojn_[ong]k@;ok^k^00?o
kNg]onk^k_o^k^h0ooo^k^kPonk^kP0000?oY:BToi^KVooinOT02_oinOT2
ooShn0GomoOg00?on_[joeUIFOmfMWH00on5QHD01_mfMWKoQ8B4ohF5QOn4
Q8CoQHF5ohB4Q0;oQHF500GoBTY:olk>c_ofm_KomoOgooKfmP03ooOgm`;o
m_Kf0oogmoL00oofm_KomoOgooOgm`02ooOgm`03onk^k_oNg]komOGe00?o
moOg00Kom_Kfon_[joo^k^komoOgonCTi?o/k>`4ooOgm`06ooKfm_ogmoOo
k^k^omkNg_ofm_KomoOg0_ofm_H3ooOgm`03ooKfm_ogmoOomoOg00;omoOg
00Kom_KfooOgmoofm_Kolo?comcLg?odm?@2ooKfmP;omoOg00Woj^[Zono_
koogmoOomoOgon7QhOogmoOom_KfooOgmoofm_H00oogmoL2ooKfmP?omoOg
00?om_KfooOgmoogmoL00_ogmoL00oofm_KomoOgooKfmP03ooOgm`;om_Kf
1OogmoL00oohn?SonOWiooWin@0:ooWin@0>oi^KVonTY:Co[Zj^okJf]_nn
_[koa<C4olW9bOo@d=3oe=CDomWIfOoMgMgoh>3Pon?ShooTi>@3onKViP03
onGUiOoVi^Koi^KV0?ooi^KVgooVi^H00005ojZZZ_nQXJ7om_KfooOgmoof
m_H00oogmoL00oofm_KomoOgooKfmP02ooOgm`09ooKfm_oemOGom?CdooCd
m?oemOGom?CdooGemOokno_oC4a<00;okNg]00go`<30ohJ6Q_nb/[;ono_k
ong]kOoNg]koQXJ6omkNg_o/k>cokNg]ohF5QOo@d=3om?Cd00;omOGe0_od
m?@08OmPH63oFEUIooCdm?oemOGom?Cdoj6QXOlO7aooZJVYooGemOoVi^Ko
IVIVob0P8?lZ:R[o;Bd]oj6QXOodm?ComOGeooCdm?mXJ6SoFe]Koe=CDol_
;boo8R8Rog=cLoo`l?3om?CdooGemOoVi^KoIVIVob4Q8OlZ:R[o;2`/oj:R
XP02ooCdm00KooGemOmPH63o7alOoalO7olU9BGo@D51ojJVY_oemOGom?Cd
onk^k_mlO7co92@Tob/[:olY:BWoJ6QXooCdm?oemOGoNg]kobDU9OlV9RKo
PX:2ogAdM?lX:2So_;blooCdm?mYJFWoH61P00;om?Cd00ComOGeooCdm?od
m?ComOGe1?odm?@01?oemOGom?CdooGemOodm?@2ooGem@;om?Cd00ComOGe
ooCdm?odm?ComOGe1?odm?@2ooGem@03ooOgmoofm_KomoOg00;omoOg00?o
m_KfooOgmoofm_H00_ogmoL03oofm_KoXJ6QojZZZ_nc/k?o_;blolC4a?o;
bl_odM7AomSHf?oLg=cohN7QonCTi?oXj>Soj^[Zonc/k03oonk^k^Gok^k^
00001?ng]kOo[:b/onk^k_o]kNd2onk^kP03ong]kOo^k^kokNg]00;ok^k^
0oo]kNd2onc/k0Cojn_[013ooOgmode=COomoOgokno_ohR8R?lQCM7oCThR
ode=8OmLG5coCR9>ob4Q?_mj8W[oR8R8oogmoOn8R8So`l?31Oo[jn/01omO
GeooFEUIon_[joo[jn_odm?Cob/[:om[Jf/00_o[jn/01omYJFWo?Shnokjn
__oUiNGoUiNGob4Q8Onh^;P00_o[jn/01omVIVKo=SHfokbl_?o[jn_o/K6a
obd];On?Shl00_o[jn/01omYJFWo?Shnokfm_OoUiNGoUiNGob4Q8Onh^;P0
0_o[jn/05_mOGeooE5ADomWIfOo:b/[oJVYZob8R8_oCdm?ojn_[ogYjN_lb
<S;o[Jf]onOWiooRh^;obLW9on_[joo?cloo8R8Roj6QXOoKfm_oRXZ:ob4Q
8OnHV9P2on_[j`03ofMWIomOGeoojn_[00Oojn_[00?ok>c/on_[joo[jn/0
3Oo[jn/3onc/k0;okNg]0_o^k^h00oo]kNgok^k^ong]k@02onk^kP;okNg]
00ook^k^ojb/[?ng]kOo`L71olW9bOoBd];ofMWIon3Ph?oWinOojn_[oo7a
lOodm?Con?Shooclo?omoOd0oooooooUooooo`0000CoZj^[oj6QXOogmoOo
moOg0_ofm_H01?ogmoOom_KfooOgmoofm_H2ooOgm`;om_Kf00ComOGeooCd
m?oemOGom?Cd0_oemOD04?okno_oQHF5ong]kOo/k>coMgMgoamgnolOMloo
FUYJod/OBom<C4coQXJ6od/OBonEUIGokNg]ogMgMoo@d=02ooCdm00>ooGe
mOodm?ComOGeof1PH?mIFEWomOGeooCdm?mHF5So>SXjonSXj?oemOGoinOW
oalO7on8R8P2ooCdm008ooGemOle=CGoJ6QXooCdm?oemOGoJFUYof1PH?oe
mOD2ooCdm00Jof9RH_lo?coomOGeonSXj?lO7aooQhN7ooGemOodm?ComOGe
ocDe=OmXJ6SomOGeooCdm?mPH63oFEUIooCdm?oemOGofm_KoalO7onSXj?o
jn_[ob4Q8On3Ph?om?CdooGemOodm?@2ooGem@0>omKFe_lO7aoo/k>cooCd
m?o`l?3o7alOojn_[ooemOGom?CdofQXJ?mPH63om?CdooGemOodm?@2ooGe
m@06ooCdm?oemOGom?CdooCdm?oemOGom?Cd0_oemOD2ooCdm004ooGemOod
m?ComOGeooCdm0;omOGe00Com?CdooGemOodm?Com?Cd0_oemOD02?ofm_Ko
moOgooKfm_ofm_KomoOgooKfm_ogmoOom_Kf0_ogmoL04?ofm_KomoOgoj6Q
XOnZZZ[o];Bdokbl_?o4a<Cobl_;om7AdOoGemOog=cLon7QhOoTi>CoinOW
on_[joo]kNgoonk^k^Gok^k^00000onUYJGoVi^KooWin@0:ooWin@;on?Sh
0oogmoL01oofm_KomoOgoo[jn_m:BT[ojn_[omcLg?l];Bd00_lNM_X02Om:
M/ko>c/koi>CTonRXZ;o>c/komgMgOo[jn_oQ8B4olk>cP03ooOgm`0=ooKf
m_ogmoOoH61PoeQHF?ogmoOoWYjNob0P8?o6a/Kom_KfooOgmoo<c<co7QhN
okbl_003ooOgm`06ofMWIom;Bd_omoOgooKfm_mYJFWoH61P0_ogmoL03?of
m_KoTi>Cob4Q8Oodm?Coc<c<oahN7_nl_;comoOgooKfm_ogmoOoIfMWodY:
BP;omoOg00[oH61PoeUIFOofm_KomoOgojj^[_lN7QkogMgMolk>c_lO7aoo
LG5a0on:RXX02OnNWYkomoOgooOgmon?Shoo=3@dofe]KOnHV9So7QhNok6a
/@02ooOgm`03ofUYJOmPH63om_Kf00;omoOg00?om_KfooOgmoogmoL00_og
moL01?ofm_KomoOgooOgmoofm_H4ooOgm`04ooKfm_ogmoOomoOgooKfmPOo
moOg00?on?ShooWinOoinOT02OoinOT03_nKVi_oY:BTojj^[_ne]KGo_Kfm
ol?3`oo:b/[odM7AomGEeOoIfMWogMgMon3Ph?oRh^;oi>CT0ooVi^H00ooU
iNGoi^KVonKViP3oonKVi]ooi^KV00000on[Zj_oXJ6QooOgm`02ooOgm`09
ooKfm_ogmoOom_KfooOgmoofm_KomoOgooKfm_ogmoOom_Kf00?omOGe0_od
m?@04OoemOGono_kod];Boo]kNgoBd];od/OBolO7bgo?Cdmoc`l??lPC4co
Bam;obdO7olO7aooC4a<ol71`On6QXKo`L7100;om?Cd00SomOGeooCdm?od
m?CoH61Poc0`<?mJFU[o:BTYogYjNP;om?Cd00ComOGeom_KfolO7aooXZ:R
0_odm?@01ooemOGoCTi>oeUIFOodm?ComOGeofQXJ?mPH6000oodm?@01on2
PX;o=cLgooCdm?oKfm_o7alOoj6QXOoemOD00_odm?@03_m>CTkoFEUIooCd
m?oemOGoH61Pod];Bon[Zj_oK6a/ocTi>OnQXJ7omOGeomWIfOlO7aooJVYZ
0_n6QXH03_m8B4SoDe=CooCdm?oemOGom?CdonGUiOnj^[[oY:BToalO7on_
[joomOGeooCdm?mXJ6SoH61P0oodm?@00ooemOGom?CdooGem@03ooCdm004
ooGemOodm?Com?CdooGem@;om?Cd00OomOGeooCdm?odm?Com?CdooGemOod
m?ComOGe00?om?Cd0_oemOD02_ofm_KomoOgooOgmoofm_KomoOgooKfm_og
moOom_KfooOgmoofm_H2ooOgm`0>oj2PX?nZZZ[o];Bdokbl_?o4a<Cobl_;
om7AdOoGemOog=cLon7QhOoTi>CoinOWon_[joo/k>`2onk^kP03ong]kOo^
k^kok^k^0?ook^k^h?o^k^h00003okJf]_n/[:cokNg]00;ok^k^00CokNg]
onk^k_o]kNgok^k^0_o]kNd00oo^k^kokNg]ong]k@02onc/k0Cojn_[013o
oOgmohR8R?miCWWoNDeiohR8R?nGUiOoNGUiodi>8_lQCM7o8GWBoddQNOlR
8R;oNDeiode=COn8R8Sod];B1Oo[jn/01_mOGeooA4A4oi>CTomOGeoo<C4a
oj:RXP;ojn_[00?ojNWYoc`l??mXJ6P00_o[jn/00ooOgmoo9BDUoh^;R`02
on_[j`0;ofMWIole=CGoa/K6on_[jooWinOoBd];og5aLOo[jn_oj^[Zoc`l
??mXJ6P00_o[jn/00ooOgmoo9BDUoh^;R`02on_[j`05oemOGolb<S;oDE5A
obDU9On@T9000_o[jn/00ooYjNWo?3`loh:2PP02on_[j`05odm?ComdM7Co
jn_[on_[jooYjNT00_o[jn/00ooDe=Co8B4Qok^k^`02on_[j`03ofMWIolW
9bOo_;bl01Oojn_[00Cok>c/on_[joo/k>cok>c/0_o^k^h01?o]kNgok^k^
ong]kOo^k^h2ong]k@0Aonk^k_o]kNgok^k^ojb/[?ng]kOo`<30olW9bOoB
d];ofMWIon3Ph?oWinOok>c/oo7alOoemOGon?Shoo_knoomoOd0oooooooU
ooooo`0000?oZj^[oj2PX?ogmoL00_ofm_H01?ogmoOom_KfooOgmoofm_H3
ooOgm`;om_Kf017omOGeooCdm?oemOGom?CdooGemOodm?Cono_koeYJF_m;
7d_od23@ogM;MomgMgOo;R0Poj=g7oo?Xaoo7gO@oamgc`02oj<OX`0bol30
`?n6QXKoclo?ooCdm?oemOGom?CdooGemOodm?CoH61PoeYJF_oemOGom?Cd
ohN7QolT92Coj>SXooGemOodm?Co^k^kobPX:?m<C4coOgmoobl_;om<C4co
kNg]ooCdm?oemOGoJFUYoe9BD_m<C4coGUiNocTi>OlS8b?o_;blooGemOod
m?Co^[ZjobTY:Om<C4coOgmoobl_;om<C4cok^k^ooGemOodm?CoH61PoeUI
FOodm?Coj>SXocXj>_moOgl2ooCdm00>okVi^Ol];BgoMGEeofATI?l/;2co
e=CDooGemOodm?CoKFe]oe=CDon8R8SoDU9Boc<c<ooclo<2ooCdm005ofUY
JOmBDU;oAdM7oeiNG_ne]KD00_oemOD01oodm?ComOGeooCdm?odm?ComOGe
ooCdm?oemOD00_odm?@00ooemOGom?CdooGem@02ooCdm0;omOGe00Com?Cd
ooGemOodm?Com?Cd0_oemOD3ooKfmP04ooOgmoofm_KomoOgooKfmP?omoOg
013om_KfooOgmonPX:3oZZZZokBd]?nl_;coa<C4ol[:b_o@d=3of=SHomcL
g?oRh^;oi>CTonOWioo[jn_okNg]0_o^k^h00oo]kNgok^k^onk^kP3oonk^
k^3ok^k^00000onUYJGoW9bLooWin@0:ooWin@;on?Sh1OogmoL01?ojn_[o
BTY:olk>c_mIFET2oahN7P0:odTNBOmfMQkon/hNoj9f7_mf7gKocQkjogHN
M_mfBWKoQHF5okno_`;omoOg00[om_KfooOgmoogmoOoH61PoeQHF?ogmoOo
m_KfolS8b?lO7aoo^KVi0oogmoL01OoIfMWoUYJFoh:2P_nXZ:Solo?c00;o
moOg00Oom_KfofUYJOmPH63oi^KVoj2PX?n8R8Sob<S800ComoOg00[of][J
oiFEUOn2PX;oZJVYoo?cloofm_KomoOgooKfm_mPH63oFEUI0_ogmoL00on6
QXKo;Rh^ooCdm002ooOgm`0<om;Bd_n<S8coS8b<omKFe_ofm_KomoOgooKf
m_oXj>So^[Zjoh^;RonOWioohN7Q0oogmoL02?nk^k_o]kNgon;Rh_nHV9So
_knoooKfm_ogmoOom_Kf2OogmoL01oofm_KomoOgooOgmoogmoOom_KfooOg
moofm_H01?ogmoL2ooShn0_onOWi00koW9bLojFUYOn^[Zko][Jfokjn__o3
`l?ob/[:om3@d?oDe=CofMWIomgMgOoOgmooh^;RonCTi?ooi^KViOoVi^H0
0005ojZZZ_nPX:3om_KfooOgmoofm_H00_ogmoL00oofm_KomoOgooKfmP02
ooOgm`;om_Kf00?omOGeooCdm?odm?@00oodm?@04?okno_oQXJ6ong]kOo/
k>co?Cdmoj<OXomgBgOoMb1gogLOMom;7d_oXgLOobd];Oo?clook>c/ohF5
QOo?cll2ooCdm00:ooGemOodm?ComOGeof1PH?mIFEWomOGeomCDe?mWIfOo
:BTYonWYj@Kom?Cd00?omOGeooCdm?oemOD00_odm?@00omYJFWoH61PooGe
m@08ooCdm003ooGemOodm?ComOGe00;om?Cd00WomOGeooCdm?mPH63oFEUI
onk^k_o6a/Ko>SXjobl_;ooclo<00_odm?@00ooemOGom?CdooGem@02ooCd
m003ooGemOodm?ComOGe00Som?Cd00?omOGeooCdm?oemOD00_odm?@00ooe
mOGom?CdooGem@08ooCdm003ooGemOodm?ComOGe00;om?Cd00?omOGeooCd
m?oemOD00_odm?@3ooGem@07ooOgmoofm_KomoOgooOgmoofm_KomoOgooKf
mP02ooOgm`0@ooKfm_ogmoOoXJ6QojZZZ_nd];Co_;blolC4a?o:b/[odM7A
omSHf?oLg=cohN7QonCTi?oWinOojn_[ong]k@?ok^k^00?okNg]onk^k_o^
k^h0ooo^k^kOonk^kP0000?o]kNgojb/[?o^k^h00_o^k^h01?o]kNgok^k^
ong]kOo]kNd2onk^kP03ong]kOo^k^kok>c/00?ok>c/0oo[jn/01_ono_ko
G5aLono_konUYJGo<30`oeaLG0;odB7A00CoYR:Vob5=NOoAYB7oR8R80_o_
knl00on8R8Sod];Bonc/k004on_[j`06oemOGolT92Co9bLWob8R8_m;Bd_o
WYjN1Oo[jn/00oo/k>cojn_[on_[j`04on_[j`03ofIVI_mOGeoojn_[00Ko
jn_[00?ok>c/on_[joo[jn/01_o[jn/02?mOGeoo92@TobDU9OlZ:R[oF5QH
okBd]?o[jn_ok>c/3oo[jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[
jn_ojn_[00Sojn_[0oo/k>`01Oo]kNgok^k^onk^k_o]kNgok^k^00;okNg]
0_o^k^h04Oo]kNgok^k^ong]kOn/[:co]kNgol71`Oo9bLWod];BomWIfOoP
h>3oinOWonc/k?oalO7om?CdooShn?okno_ooOgm0?ooooooiOooool00003
ojZZZ_nQXJ7omoOg00;om_Kf1OogmoL01?ofm_KomoOgooOgmoofm_H2ooGe
m@0=ooCdm?oemOGom?CdooCdm?okno_oBd];ong]kOn6QXKoC4a<ogMgMom;
Bd_ocao?oeYJFP02oam;M`06ohJ6Q_o/k>cokNg]ohJ6Q_o0`<3om?Cd0_oe
mOD01_odm?ComOGeon?ShooJf][ofm_KonOWi`Com?Cd00ComOGeooCdm?od
m?Com?Cd0_oemOD01_odm?ComOGeooCdm?odm?CoQXJ6oh20P0Com?Cd00Co
mOGeooCdm?odm?Com?Cd0_oemOD00oodm?ComOGeooCdm002ooCdm006ooGe
mOoShn?ofm_KomcLg?o`l?3omOGe0oodm?@2ooGem@03ooCdm?oemOGom?Cd
00;om?Cd00?omOGeooCdm?odm?@00_odm?@01?oemOGom?CdooCdm?odm?@2
ooGem@03ooCdm?oemOGom?Cd00;om?Cd00?omOGeooCdm?odm?@00_odm?@0
1?oemOGom?CdooCdm?odm?@2ooGem@03ooCdm?oemOGom?Cd00;om?Cd00?o
mOGeooCdm?odm?@00_odm?@01?oemOGom_KfooKfm_ofm_H5ooOgm`0BooKf
m_ogmoOomoOgooKfm_nQXJ7oZj^[okBd]?nl_;coa<C4ol[:b_oAdM7of=SH
omgMgOoQhN7oiNGUonOWiooZj^[ok>c/ooo^k^kUonk^kP0000?oY:BToi^K
VooinOT02ooinOT6ooOgm`03oo[jn_n4Q8Cojn_[00?ojn_[00Ko`<30ogI:
M_ojn_[ok>c/oj:RX_nCTi<2on_[j`03ohF5QOo>c/komoOg00;omoOg00?o
m_KfooOgmoogmoL00_ogmoL00oofm_KomoOgooOgm`02ooKfmPKomoOg00?o
m_KfooOgmoogmoL00_ogmoL00oofm_KomoOgooOgm`02ooKfmPKomoOg00?o
m_KfooOgmoogmoL00_ogmoL00oofm_KomoOgooOgm`02ooKfmPKomoOg00?o
m_KfooOgmoogmoL00_ogmoL00oofm_KomoOgooOgm`02ooKfmPKomoOg00?o
m_KfooOgmoogmoL00_ogmoL00oofm_KomoOgooOgm`02ooKfmPKomoOg00?o
m_KfooOgmoogmoL00_ogmoL00oofm_KomoOgooOgm`03ooOgm`conOWi00ko
Vi^KojBTY?n][Jgo]KFeokjn__o4a<Cob/[:om3@d?oEeMGofMWIomgMgOoO
gmoohn?SonCTi?ooi^KViOoVi^H00005ojZZZ_nQXJ7om_KfooOgmoofm_H0
1?ogmoL01?ofm_KomoOgooOgmoogmoL3ooGem@?om?Cd00ComOGeoo_knom<
C4cono_k0_o]kNd01Oo/k>cokNg]ong]kOo]kNgok>c/00CokNg]00GoQXJ6
om3@d?odm?ComOGeooCdm002ooGem@05ooCdm?oemOGom?CdooGemOodm?@0
0_oemOD3ooCdm004ooGemOodm?ComOGeooCdm0;omOGe00Gom?CdooGemOod
m?ComOGeooCdm002ooGem@?om?Cd00ComOGeooCdm?oemOGom?Cd0_oemOD0
1Oodm?ComOGeooCdm?oemOGom?Cd00;omOGe0oodm?@01?oemOGom?CdooGe
mOodm?@2ooGem@05ooCdm?oemOGom?CdooGemOodm?@00_oemOD3ooCdm004
ooGemOodm?ComOGeooCdm0;omOGe00Gom?CdooGemOodm?ComOGeooCdm002
ooGem@?om?Cd00ComOGeooCdm?oemOGom?Cd0_oemOD01Oodm?ComOGeooCd
m?oemOGom?Cd00ComOGe00?om_KfooOgmoofm_H01?ogmoL05Oofm_KomoOg
ooOgmoogmoOom_Kfoj6QXOn[Zj_o];Bdokbl_?o4a<Cobl_;om7AdOoHf=So
g=cLon7QhOoTi>CoinOWon_[joo/k>cok^k^ong]k@3oonk^k^?ok^k^0000
1_ng]kOo[:b/onk^k_o^k^kokNg]onk^kP?okNg]00?ok^k^ong]kOo^k^h0
0_o]kNd3onc/k0?ojn_[00?ooOgmode=COn8R8P03?n8R8P00oomoOgojn_[
on_[j`1Jon_[j`;ok>c/00CokNg]onk^k_o]kNgok^k^0oo]kNd04oo^k^ko
kNg]onk^k_o]kNgok^k^ojb/[?nf][Ko`L71olW9bOoBd];ofMWIon3Ph?oW
inOok>c/oo7alOodm?Con?Shoo_knoomoOd0oooooooUooooo`0000CoZj^[
oj2PX?ofm_Kom_Kf1?ogmoL2ooKfmP;omoOg0_ofm_H3ooGem@?om?Cd0_oe
mOD00oodm?ComOGeooCdm002ooCdm003ooGemOodm?ComOGe00;om?Cd00Co
mOGeooCdm?odm?Com?Cd0_oemOD00oodm?ComOGeooCdm002ooCdm003ooGe
mOodm?ComOGe00;om?Cd00ComOGeooCdm?odm?Com?Cd0_oemOD00oodm?Co
mOGeooCdm002ooCdm003ooGemOodm?ComOGe00;om?Cd00ComOGeooCdm?od
m?Com?Cd0_oemOD00oodm?ComOGeooCdm002ooCdm003ooGemOodm?ComOGe
00;om?Cd00ComOGeooCdm?odm?Com?Cd0_oemOD00oodm?ComOGeooCdm002
ooCdm003ooGemOodm?ComOGe00;om?Cd00ComOGeooCdm?odm?Com?Cd0_oe
mOD00oodm?ComOGeooCdm002ooCdm003ooGemOodm?ComOGe00;om?Cd00Co
mOGeooCdm?odm?Com?Cd0_oemOD00oodm?ComOGeooCdm002ooCdm003ooGe
mOodm?ComOGe00;om?Cd0_oemOD2ooKfmPComoOg0_ofm_H2ooOgm`0@ooKf
m_ogmoOoX:2PojZZZ_nd];Co_;blolC4a?o:b/[odM7AomSHf?oLg=coh^;R
onCTi?oWinOojn_[ong]k@;ok^k^00?okNg]onk^k_o^k^h0ooo^k^kPonk^
kP0000CoY:BToi^KVooemOGomOGe1?odm?@2ooGem@;om?Cd00?omOGeooCd
m?odm?@0L_oclo<2ooCdm003ooGemOodm?Com?Cd00;om?Cd0_oemOD2ooCd
m00AooGemOodm?CoVi^KojBTY?n^[Zko][Jfokjn__o4a<CobLW9om3@d?oD
e=CofMWIomgMgOoPh>3ohn?SonCTi?oVi^H0HooUiNGoonKViX7oi^KV0000
0onZZZ[oXJ6Qoo_kn`05ooclo003oo_knoolo?coo?cl00;oo?cl0_okno/2
oo[jnP05oo_knoojn_[ono_koo[jn_okno/00oojn_X01?okno_on_[joo[j
n_okno/4oo[jnP05oo_knoojn_[ono_koo[jn_okno/00oojn_X01?okno_o
n_[joo[jn_okno/4oo[jnP05oo_knoojn_[ono_koo[jn_okno/00oojn_X0
1?okno_on_[joo[jn_okno/4oo[jnP05oo_knoojn_[ono_koo[jn_okno/0
0oojn_X01?okno_on_[joo[jn_okno/4oo[jnP05oo_knoojn_[ono_koo[j
n_okno/00oojn_X01?okno_on_[joo[jn_okno/4oo[jnP05oo_knoojn_[o
no_koo[jn_okno/00oojn_X01?okno_on_[joo[jn_okno/4oo[jnP05oo_k
noojn_[ono_koo[jn_okno/00oojn_X01?okno_on_[joo[jn_okno/4oo[j
nP;ono_k1Oolo?`00ookno_oo?clooclo003oo_kn`0?oj2PX?nYZJWo/k>c
ok^k^oo2`/;ob/[:olo?cooFe]Kofm_KomoOgooRh^;oi^KVonWYjOo[jn_o
kNg]00Cok>c/00CokNg]onc/k?o]kNgok>c/0_o]kNd2onc/k004ong]kOo/
k>cok>c/ong]k@Cok>c/00CokNg]onc/k?o]kNgok>c/0_o]kNd2onc/k004
ong]kOo/k>cok>c/ong]k@Cok>c/00CokNg]onc/k?o]kNgok>c/0_o]kNd2
onc/k004ong]kOo/k>cok>c/ong]k@Cok>c/00CokNg]onc/k?o]kNgok>c/
0_o]kNd2onc/k004ong]kOo/k>cok>c/ong]k@Cok>c/00CokNg]onc/k?o]
kNgok>c/0_o]kNd2onc/k004ong]kOo/k>cok>c/ong]k@Cok>c/00CokNg]
onc/k?o]kNgok>c/0_o]kNd2onc/k004ong]kOo/k>cok>c/ong]k@Cok>c/
00CokNg]onc/k?o]kNgok>c/0_o]kNd2onc/k004ong]kOo/k>cokNg]onk^
kPCokNg]00?ok^k^ong]kOo^k^h0ooo^k^i]onk^kP0000Co]kNgojb/[?ok
no_on_[j0_okno/01Oojn_[ono_koo[jn_ojn_[ono_k00?on_[j00?onOWi
oo[jn_oinOT0K_oinOT00oojn_[onOWiooWin@02oo[jnP;ono_k1Oojn_X0
4Oohn?SonOWiooWinOnZZZ[o]KFeokno_oo7alOod=3@omKFe_oMgMgoi>CT
onWYjOo^k^kolO7aooGemOohn?SonOWi00;ono_k00Kon_[joo_knookno_o
n_[joo_knoojn_X2oo_kn`05oo[jn_okno_on_[joo[jn_okno/00_ojn_X0
1ookno_on_[joo_knookno_on_[joo_knoojn_X00_okno/01Oojn_[ono_k
oo[jn_ojn_[ono_k00;on_[j00Oono_koo[jn_okno_ono_koo[jn_okno_o
n_[j00;ono_k00Gon_[joo_knoojn_[on_[joo_kn`02oo[jnP07oo_knooj
n_[ono_koo_knoojn_[ono_koo[jnP02oo_kn`05oo[jn_okno_on_[joo[j
n_okno/00_ojn_X01ookno_on_[joo_knookno_on_[joo_knoojn_X00_ok
no/01Oojn_[ono_koo[jn_ojn_[ono_k00;on_[j00Oono_koo[jn_okno_o
no_koo[jn_okno_on_[j00;ono_k00Gon_[joo_knoojn_[on_[joo_kn`02
oo[jnP07oo_knoojn_[oo?clooclo?okno_oo?cloo_kn`02ooclo003oo_k
noolo?cono_k00Coo?cl0_omoOd00oono_kooOgmooknoP03ookno_oooooo
K?ooool00004oj^[ZonQXJ7ojn_[on_[j`;oj^[Z00Cojn_[on[Zj_o[jn_o
j^[Z0_o[jn/3on[ZjW7ojNWY0ooZj^X01?o[jn_oj^[ZonWYjOoZj^X4onWY
j@?oj>SX013oWYjNojRXZ?na/K7o^KViol30`?o7alOoc<c<om;Bd_oGemOo
g=cLomoOgooQhN7oiNGUonKVi_oWinOoj>SX0_oWinL01?oXj>SoinOWonSX
j?oXj>P2onOWi`04onSXj?oWinOoj>SXonOWi`;oj>SX00KoinOWonSXj?oW
inOoinOWonSXj?oWinL2onSXj0;oinOW00Coj>SXonOWiooXj>SoinOW0_oX
j>P01_oWinOoj>SXonOWiooWinOoj>SXonOWi`;oj>SX0_oWinL01?oXj>So
inOWonSXj?oWinL2onSXj006onOWiooXj>SoinOWonOWiooXj>SoinOW0_oX
j>P2onOWi`04onSXj?oWinOoj>SXonOWi`;oj>SX00KoinOWonSXj?oWinOo
inOWonSXj?oWinL2onSXj0;oinOW00Coj>SXonOWiooXj>SoinOW0_oXj>P0
1_oWinOoj>SXonOWiooWinOoj>SXonOWi`;oj>SX0_oWinL01?oXj>SoinOW
onSXj?oWinL2onSXj008onOWiooXj>SoinOWonOWiooXj>SoinOWonSXj?oY
jNT2onSXj0CojNWY0ooZj^X3on_[j`;ok>c/1Oo]kNgoonk^kV[ok^k^0000
1?nUYJGoVi^KooCdm?odm?@2ooGem@;om?Cd0_oemOD00oodm?ComOGeooCd
m002ooCdm7;olo?c1Oodm?@01?oclo?ol_;boo?cloobl_82oo7al@0Eoo3`
l?o_knooV9RHoj2PX?nYZJWo/K6aokNg]onn_[ko`l?3olW9bOo>c/kodM7A
omGEeOoGemOofMWIom_KfooMgMgog=cLomgMgOoLg=cogMgM00?og=cL0_oM
gMd2omcLg0;ogMgM00Oog=cLomgMgOoMgMgog=cLomgMgOoLg=cogMgM00?o
g=cL0_oMgMd2omcLg0;ogMgM00Oog=cLomgMgOoMgMgog=cLomgMgOoLg=co
gMgM00?og=cL0_oMgMd2omcLg0;ogMgM00Oog=cLomgMgOoMgMgog=cLomgM
gOoLg=cogMgM00?og=cL0_oMgMd2omcLg0;ogMgM00Oog=cLomgMgOoMgMgo
g=cLomgMgOoLg=cogMgM00?og=cL0_oMgMd2omcLg0;ogMgM00Oog=cLomgM
gOoMgMgog=cLomgMgOoLg=cogMgM00?og=cL0_oMgMd2omcLg0;ogMgM00So
g=cLomgMgOoMgMgog=cLomgMgOoLg=cogMgMomcLg0?ogMgM00?ogmoOomkN
g_oNg]h00ooOgml2on3Ph0;ohN7Q00Coh^;Ron?ShooShn?ohn?S0_oTi>@3
onGUiOooi^KVJOoVi^H00003oj^[ZonQXJ7oo?cl00;oo?cl00Gono_koocl
o?olo?coo?cloo_kn`03ooclo004oo_knoojn_[ono_koo_kn`;on_[j00Co
no_koo[jn_ojn_[ono_k0oojn_X00ookno_on_[joo_kn`03oo[jnP04oo_k
noojn_[on_[joo_kn`;on_[j00Oono_koo[jn_ojn_[on_[joo_knoojn_[o
no_k00?on_[j00Cono_koo[jn_ojn_[ono_k0_ojn_X01ookno_on_[joo[j
n_ojn_[ono_koo[jn_okno/00oojn_X01?okno_on_[joo[jn_okno/2oo[j
nP07oo_knoojn_[on_[joo[jn_okno_on_[joo_kn`03oo[jnP04oo_knooj
n_[on_[joo_kn`;on_[j00Oono_koo[jn_ojn_[on_[joo_knoojn_[ono_k
00?on_[j00Cono_koo[jn_ojn_[ono_k0_ojn_X01ookno_on_[joo[jn_oj
n_[ono_koo[jn_okno/00oojn_X01?okno_on_[joo[jn_okno/2oo[jnP07
oo_knoojn_[on_[joo[jn_okno_on_[joo_kn`02oo[jnPKono_k0_ojn_X0
1?oinOWon?ShooShn?ohn?P2ooKfmP0@ooGemOnKVi_oYJFUojj^[_nd];Co
_;blol;2`_o7alOocLg=om7AdOoFe]Kof=SHom_KfooNg]kogmoOon;RhP?o
h>3P00CohN7Qon3Ph?oPh>3ohN7Q2?oPh>001OoQhN7oh>3Pon3Ph?oPh>3o
hN7Q00;oh>3P00?ohN7Qon3Ph?oPh>001_oPh>001OoQhN7oh>3Pon3Ph?oP
h>3ohN7Q00;oh>3P00?ohN7Qon3Ph?oPh>001_oPh>001OoQhN7oh>3Pon3P
h?oPh>3ohN7Q00;oh>3P00?ohN7Qon3Ph?oPh>001_oPh>001OoQhN7oh>3P
on3Ph?oPh>3ohN7Q00;oh>3P00?ohN7Qon3Ph?oPh>001_oPh>001OoQhN7o
h>3Pon3Ph?oPh>3ohN7Q00;oh>3P00?ohN7Qon3Ph?oPh>001_oPh>001OoQ
hN7oh>3Pon3Ph?oQhN7oh^;R00;ohN7Q0_oRh^800ooQhN7ohn?Son?Sh`03
onCTi005onGUiOoVi^KoinOWonOWiooXj>P00_oZj^X2on_[j`;ok>c/1?o]
kNgoonk^kVOok^k^00000onf][Ko[:b/oo[jnP02oo_kn`04oo[jn_okno_o
n_[joo_kn`;on_[j00Gono_koo[jn_ojn_[onOWioo[jnP1_ooWin@05oo[j
n_oinOWonOWiooWinOojn_X00_oinOT01?ohn?SomoOgooOgmooemOD2ooCd
m00Aoo?cloobl_;oYJFUojn_[ong]kOo_knoolK6a_o=cLgod];BomSHf?oL
g=cohN7Qon?ShooVi^KojNWYon[Zj_o[jn/01Oo/k>`00oo[jn_ok>c/onc/
k007onc/k003on_[joo/k>cok>c/00?ok>c/00?ojn_[onc/k?o/k>`01oo/
k>`00oo[jn_ok>c/onc/k003onc/k003on_[joo/k>cok>c/00Ook>c/00?o
jn_[onc/k?o/k>`00oo/k>`00oo[jn_ok>c/onc/k007onc/k003on_[joo/
k>cok>c/00?ok>c/00?ojn_[onc/k?o/k>`01oo/k>`00oo[jn_ok>c/onc/
k003onc/k003on_[joo/k>cok>c/00Ook>c/00?ojn_[onc/k?o/k>`01?o/
k>`00oo]kNgok^k^ong]k@02ono_k`;olO7a00Ool_;boo?clooclo?omOGe
ooKfm_ogmoOon?Sh00;onOWi00?ono_kooclo?olo?`00_omoOd2ookno_oo
ooooIoooool00003oj^[ZonPX:3ojn_[00;oj^[Z00?ojn_[on[Zj_o[jn/0
0_oZj^X2on_[j`;oj^[Z2OoYjNT01?oZj^[ojNWYonWYjOoZj^X<onWYj@04
on[Zj_oYjNWojNWYon[ZjPcojNWY00Coj^[ZonWYjOoYjNWoj^[Z3?oYjNT0
1?oZj^[ojNWYonWYjOoZj^X<onWYj@04on[Zj_oYjNWojNWYon[ZjPcojNWY
00Coj^[ZonWYjOoYjNWoj^[Z3?oYjNT01?oZj^[ojNWYonWYjOoZj^X5onWY
j@04on[Zj_oYjNWojNWYonWYj@;oj>SX0_oWinL3onGUi@0Aon?ShooQhN7o
h>3PoiRHV?nPX:3oZJVYojn_[onf][Ko^k^kol30`?o6a/Kob<S8olk>c_o?
clood];BomGEeOoFe]H00_oGemL2omKFeP03omOGeooFe]KoemOG00;oe]KF
00CoemOGomKFe_oGemOoe]KF0ooGemL01ooFe]KoemOGomKFe_oFe]KoemOG
omKFe_oGemL00_oFe]H01?oGemOoe]KFomOGeooFe]H3omOGe`07omKFe_oG
emOoe]KFomKFe_oGemOoe]KFomOGe`02omKFeP04omOGeooFe]KoemOGomKF
eP?oemOG00Ooe]KFomOGeooFe]Koe]KFomOGeooFe]KoemOG00;oe]KF00Co
emOGomKFe_oGemOoe]KF0ooGemL01ooFe]KoemOGomKFe_oFe]KoemOGomKF
e_oGemL00_oFe]H01?oGemOoe]KFomOGeooFe]H3omOGe`07omKFe_oGemOo
e]KFomKFe_oGemOoe]KFomOGe`02omKFeP04omOGeooFe]KoemOGomKFeP?o
emOG00Koe]KFomOGeooFe]KoemOGomSHf?oGemL3omSHf006omWIfOoJf][o
fm_KomcLg?oMgMgog]kN0_oPh>001OoRh^;ohn?SonCTi?oVi^KoinOW00?o
jNWY0_o[jn/00oo]kNgok>c/ong]k@3oonk^kVOok^k^00000onUYJGoW9bL
ooOgm`0<ooOgm`Oom_Kf00OomOGeooKfm_ofm_Kom_KfooGemOofm_KomOGe
00Wom_Kf00OomOGeooKfm_ofm_Kom_KfooGemOofm_KomOGe00Wom_Kf00Oo
mOGeooKfm_ofm_Kom_KfooGemOofm_KomOGe00Wom_Kf00OomOGeooKfm_of
m_Kom_KfooGemOofm_KomOGe00Wom_Kf00OomOGeooKfm_ofm_Kom_KfooGe
mOofm_KomOGe00Wom_Kf00OomOGeooKfm_ofm_Kom_KfooGemOofm_KomOGe
00Wom_Kf00OomOGeooKfm_ofm_Kom_KfooGemOofm_KomOGe00Kom_Kf0_oe
mOD01Oodm?Colo?coo;bl_oalO7okno_00;okNg]013ojn_[onWYjOnBTY;o
VIVIoj2PX?nWYjOo[Jf]ok6a/Onf][Ko^[Zjokfm_Oo1`L7o`l?3olK6a_o7
alOobLW92_o:b/X01Oo9bLWob/[:ol[:b_o:b/[obLW900_ob/[:00GobLW9
ol[:b_o:b/[ob/[:olW9b@0;ol[:bP05olW9bOo:b/[ob/[:ol[:b_o9bLT0
2oo:b/X01Oo9bLWob/[:ol[:b_o:b/[obLW900_ob/[:00GobLW9ol[:b_o:
b/[ob/[:olW9b@0;ol[:bP05olW9bOo:b/[ob/[:ol[:b_o9bLT01Oo:b/X2
ol_;b`03olc<c?o;bl_ocLg=00;ocLg=00_oc/k>om3@d?oBd];od];BomCD
e?oEeMGoemOGomWIfOoKfm_ogMgMomkNgP02omoOg`?oh^;R00Coi>CTonGU
iOoUiNGoiNGUoooVi^IVonKViP0000?oZZZZoj2PX?okno/02Oolo?`01Ook
no_oo?cloo_knoojn_[ono_k00Gon_[j00?ono_koo[jn_okno/00_ojn_X0
0ookno_on_[joo_kn`08oo[jnP03oo_knoojn_[ono_k00;on_[j00?ono_k
oo[jn_okno/02?ojn_X00ookno_on_[joo_kn`02oo[jnP03oo_knoojn_[o
no_k00Son_[j00?ono_koo[jn_okno/00_ojn_X00ookno_on_[joo_kn`08
oo[jnP03oo_knoojn_[ono_k00;on_[j00?ono_koo[jn_okno/02?ojn_X0
0ookno_on_[joo_kn`02oo[jnP03oo_knoojn_[ono_k00Son_[j00?ono_k
oo[jn_okno/00_ojn_X00ookno_on_[joo_kn`02oo[jnP04oo_knoojn_[o
nOWioo[jnP;on?Sh01GomoOgooGemOodm?Col_;boo7alOo^k^kok>c/on_[
jonDU9CoVi^Koj>SXonYZJWo[Zj^ok>c/ong]kOo_;blokno_oo2`/;oaLG5
olK6a_o9bLT00_o:b/X01?o;bl_ob/[:ol[:b_o;bl/4ol[:bP;obl_;00?o
b/[:ol_;boo:b/X00_o;bl/01Oo:b/[obl_;ol[:b_o:b/[obl_;00Cob/[:
0_o;bl/00oo:b/[obl_;ol[:bP02ol_;b`05ol[:b_o;bl_ob/[:ol[:b_o;
bl/01?o:b/X2ol_;b`03ol[:b_o;bl_ob/[:00;obl_;00Gob/[:ol_;boo:
b/[ob/[:ol_;b`04ol[:bP;obl_;00?ob/[:ol_;boo:b/X00_o;bl/01Oo:
b/[obl_;ol[:b_o:b/[obl_;00Cob/[:0_o;bl/00oo:b/[obl_;ol[:bP02
ol_;b`05ol[:b_o;bl_ob/[:ol[:b_o;bl/01?o:b/X2ol_;b`03ol[:b_o;
bl_ob/[:00;obl_;00Cob/[:ol_;boo:b/[ob/[:0_o;bl/00oo<c<cocLg=
olk>cP02olo?c`0<om7AdOoCdm?oe=CDomKFe_oHf=SofMWIomcLg?oNg]ko
gmoOon7QhOoShn?oiNGU0_oWinL01_oYjNWoj^[Zon[Zj_o]kNgok>c/ong]
kOook^k^I_o^k^h00005okNg]on/[:con?ShooShn?oinOT02?ohn?P4ooOg
m`06ooKfm_ogmoOomoOgooOgmoofm_KomoOg0_ofm_H01?ogmoOom_KfooKf
m_ogmoL2ooKfmP;omoOg00Kom_KfooOgmoogmoOomoOgooKfm_ogmoL2ooKf
mP04ooOgmoofm_Kom_KfooOgm`;om_Kf0_ogmoL01_ofm_KomoOgooOgmoog
moOom_KfooOgm`;om_Kf00ComoOgooKfm_ofm_KomoOg0_ofm_H2ooOgm`06
ooKfm_ogmoOomoOgooOgmoofm_KomoOg0_ofm_H01?ogmoOom_KfooKfm_og
moL2ooKfmP;omoOg00Kom_KfooOgmoogmoOomoOgooKfm_ogmoL2ooKfmP04
ooOgmoofm_Kom_KfooOgm`;om_Kf0_ogmoL01_ofm_KomoOgooOgmoogmoOo
m_KfooOgm`;om_Kf00ComoOgooKfm_ofm_KomoOg0_ofm_H2ooOgm`06ooKf
m_ogmoOomoOgooOgmoofm_KomoOg0_ofm_H01?ogmoOom_KfooKfm_ogmoL2
ooKfmP;omoOg0oofm_H05_oemOGolo?coo;bl_o`l?3okno_ong]kOo[jn_o
j>SXonKVi_oShn?oW9bLojBTY?n[Zj_o/;2`okJf]_nk^k_o`<30ol?3`oo7
alOob/[:ol_;boo>c/h2om3@d003om;Bd_oAdM7odM7A00;od];B0ooAdM40
0ooBd];odM7Aom7Ad@08om7Ad@;od];B0ooAdM400ooBd];odM7Aom7Ad@08
om7Ad@;od];B0ooAdM400ooBd];odM7Aom7Ad@08om7Ad@;od];B0ooAdM40
0ooBd];odM7Aom7Ad@08om7Ad@;od];B0ooAdM400ooBd];odM7Aom7Ad@08
om7Ad@;od];B0ooAdM400ooBd];odM7Aom7Ad@08om7Ad@;od];B00?odm?C
omCDe?oDe=@00_oFe]H04ooHf=SofMWIom_KfooMgMgoh>3Pon7QhOoTi>Co
i^KVon[Zj_o/k>col?3`oo7alOoclo?om_KfooShn?oinOWon_[joo_knool
o?`00_ono_koooooofKooooo00000onZZZ[oXJ6Qon[ZjP02on[ZjP;ojn_[
00?oj^[Zon_[jooZj^X00_oZj^X01?o[jn_oj^[Zon[Zj_oZj^X8onWYj@03
on[Zj_oYjNWojNWY00gojNWY00?oj^[ZonWYjOoYjNT03OoYjNT00ooZj^[o
jNWYonWYj@0=onWYj@03on[Zj_oYjNWojNWY00gojNWY00?oj^[ZonWYjOoY
jNT03OoYjNT00ooZj^[ojNWYonWYj@0=onWYj@03on[Zj_oYjNWojNWY00Oo
jNWY01[oj>SXonOWiooVi^KoiNGUonCTi?oRh^;ohN7QomkNg_oKfm_ofMWI
omOGeooCdm?oShn?oiFEUOnLW9coXJ6QojJVY_nXZ:So[:b/ok2`/?nd];Co
][JfokRh^?ni^KWo^[Zjok^k^fGo_;bl0_nm_Kd06?no_koo`<30ol;2`_o3
`l?oaLG5olO7aoo9bLWobl_;olk>c_oAdM7odm?ComKFe_oJf][og=cLomoO
gooQhN7ohn?SonGUiOoXj>SojNWYon[Zj_o[jn_ok>c/ong]kOook^k^I_o^
k^h00003ojBTY?nKVi_omOGe00ComOGe00?om?CdooGemOoemOD00_oemOD2
ooCdm007oo?cloobl_;ol_;boo;bl_oclo?ol_;boo?cl`03oo;blP03oo?c
loobl_;olo?c00;ol_;b0_oclo<3oo;blP03oo?cloobl_;olo?c00?ol_;b
00?olo?coo;bl_oclo<00_obl_82oo?cl`?ol_;b00?olo?coo;bl_oclo<0
0oobl_800ooclo?ol_;boo?cl`02oo;blP;olo?c0oobl_800ooclo?ol_;b
oo?cl`03oo;blP03oo?cloobl_;olo?c00;ol_;b0_oclo<3oo;blP03oo?c
loobl_;olo?c00?ol_;b00?olo?coo;bl_oclo<00_obl_82oo?cl`?ol_;b
00?olo?coo;bl_oclo<00oobl_800ooclo?ol_;boo?cl`02oo;blP;olo?c
0oobl_800ooclo?ol_;boo?cl`03oo;blP03oo?cloobl_;olo?c00;ol_;b
0_oclo<4oo;blP0Eoo7alOo`l?3ok^k^onc/k?oZj^[oj>SXonKVi_oShn?o
gmoOomcLg?oIfMWoQhN7ohb<S?nBTY;oUiNGoi^KVonNWYkoXJ6QojBTY?nV
YZKoZ:RX00;oZZZZ0_n][Jd2ojj^[PCo[Jf]00?o[Zj^ojf][On][Jd02?n]
[Jd00on^[Zko[Jf]ojf][@02ojf][@03ojj^[_n][Jgo[Jf]00So[Jf]00?o
[Zj^ojf][On][Jd00_n][Jd00on^[Zko[Jf]ojf][@08ojf][@03ojj^[_n]
[Jgo[Jf]00;o[Jf]00?o[Zj^ojf][On][Jd02?n][Jd00on^[Zko[Jf]ojf]
[@02ojf][@03ojj^[_n][Jgo[Jf]00So[Jf]00?o[Zj^ojf][On][Jd00_n]
[Jd00on^[Zko[Jf]ojf][@08ojf][@0Kojj^[_n][Jgo[Jf]ojf][On^[Zko
/;2`ok6a/Onb/[;o/k>cokFe]Ong]kOo^[Zjokbl_?no_koo`L71olC4a?o9
bLWobl_;olk>c_oAdM7oe=CDomSHf?oIfMWogMgMomkNg_oPh>3ohN7Q00;o
hn?S0_oUiNGoonKViVGoi^KV00001OnZZZ[oXJ6QonWYjOoZj^[ojNWY00Co
j^[Z00CojNWYon[Zj_oZj^[oj^[Z0ooXj>P3onOWi`04onSXj?oWinOoj>SX
onOWi`;oj>SX00GoinOWonSXj?oWinOoj>SXonOWi`02onSXj0?oinOW00Co
j>SXonOWiooXj>SoinOW0_oXj>P01OoWinOoj>SXonOWiooXj>SoinOW00;o
j>SX0ooWinL01?oXj>SoinOWonSXj?oWinL2onSXj005onOWiooXj>SoinOW
onSXj?oWinL00_oXj>P3onOWi`04onSXj?oWinOoj>SXonOWi`;oj>SX00?o
inOWonSXj?oWinL00olO7al00olP823o7alOoalO7`02oalO7`03onOWiooX
j>SoinOW00;oj>SX00GoinOWonSXj?oWinOoj>SXonOWi`02onSXj0?oinOW
00Coj>SXonOWiooXj>SoinOW0_oXj>P01OoWinOoj>SXonOWiooXj>SoinOW
00;oj>SX0ooWinL01?oXj>SoinOWonSXj?oWinL2onSXj005onOWiooXj>So
inOWonSXj?oWinL00_oXj>P2onOWi`;oi^KV01?oi>CTon?ShooPh>3ogmoO
omcLg?oHf=Soe]KFom;Bd_o?cloobl_;ohV9ROn>SXkoTi>CoiNGUonKVi_o
WIfMoj2PX?nSXj?oY:BT00;oYjNW00GoZJVYojZZZ_nZZZ[oZj^[ojZZZP02
oj^[Z`?oZZZZ00CoZj^[ojZZZ_n[Zj_oZZZZ0_n[Zj/01OnZZZ[oZj^[ojZZ
Z_n[Zj_oZZZZ00;oZj^[0onZZZX01?n[Zj_oZZZZoj^[ZonZZZX2oj^[Z`05
ojZZZ_n[Zj_oZZZZoj^[ZonZZZX00_n[Zj/3ojZZZP04oj^[ZonZZZ[oZj^[
ojZZZP;oZj^[00GoZZZZoj^[ZonZZZ[oZj^[ojZZZP02oj^[Z`?oZZZZ00Co
Zj^[ojZZZ_n[Zj_oZZZZ0_n[Zj/01OnZZZ[oZj^[ojZZZ_n[Zj_oZZZZ00;o
Zj^[0onZZZX01?n[Zj_oZZZZoj^[ZonZZZX2oj^[Z`05ojZZZ_n[Zj_oZZZZ
oj^[ZonZZZX00_n[Zj/3ojZZZP04oj^[ZonZZZ[oZj^[ojZZZP;oZj^[00Go
ZZZZoj^[ZonZZZ[oZj^[ojZZZP03oj^[Z`0Iojb/[?n][Jgo[jn_ojn_[onb
/[;o];BdokNg]oni^KWo_;blol30`?o2`/;oalO7ol[:b_o?cloodm?ComKF
e_oJf][og=cLon3Ph?oRh^;oi>CTonOWiooYjNWoj^[Zon_[j`02ong]kOoo
k^k^IOo^k^h00006okNg]on/[:cono_koo_knoojn_[ono_k0oojn_X00ook
no_on_[joo_kn`02oo[jnP03ooWinOohn?SonOWi00?on?Sh00?ooOgmoiNG
UomLG5`01_mLG5`00om=CDgoG5aLoeaLG002oeaLG003oeeMGOnVYZKon?Sh
05con?Sh0_ogmoL05_oemOGom?Cdoo;bl_o_knook>c/onWYjOoWinOoh^;R
omkNg_oIfMWoe=CDohj>S_nDU9CoVIVIoibLW?nPX:3oXZ:RojBTY?nWYjOo
Z:RXojVYZOnZZZX2oj^[ZfGo[:b/0_n][Jd06_n`/;3o/K6aok>c/onf][Ko
^;RhokZj^_nn_[ko`/;2olK6a_o:b/[oc/k>om?CdooHf=SogMgMon;Rh_oU
iNGoj^[Zonk^k_o`l?3om?CdooKfm_ohn?Son_[jooclo?omoOgoo_knoooo
oomUooooo`0000?oZj^[oj2PX?okno/02_okno/01?ojn_[onOWiooWinOoi
nOT3ooShn003oo_knomJFU[oMgMg00;oQXJ600?oQHF5ogMgMon6QXH00_n6
QXH01_n5QHGoQXJ6ohJ6Q_n5QHGoBd];olo?c`ConOWi0_ohn?P2ooWin@03
ooShn?oinOWon?Sh00;onOWi0oohn?P01?o`l?3oh>3PooShn?oinOT2ooSh
n007ooWinOo^k^kokno_ooWinOoUiNGok^k^ooWin@03ooShn0;onOWi00Co
l?3`on3Ph?ogmoOon?Sh0_oinOT00oohn?SonOWiooShn002ooWin@?on?Sh
0_oinOT02Oo/k>colO7aooShn?ohn?Soh^;RooWinOohn?SonOWiooShn002
ooWin@?on?Sh0ooinOT00oohn?SohN7QooKfmP02ooWin@06ooShn?oinOWo
n?ShooWinOo/k>colO7a0_ohn?P01?oRh^;onOWiooWinOoinOT2ooShn0;o
nOWi00?on?ShooWinOohn?P00_oinOT05oohn?Som_KfooGemOodm?ColO7a
onk^k_o[jn_oinOWon?ShooOgmoofm_KomKFe_oAdM7oPH61ohJ6Q_n:RX[o
S8b<ohn?SonATI7oTY:BoiBDU?nEUIGoUYJF00;oUIFE00?oUiNGoiRHV?nH
V9P03?nGUiL00onFUYKoUiNGoiNGU`0=oiNGU`03oiJFU_nGUiOoUiNG00go
UiNG00?oUYJFoiNGUonGUiL03OnGUiL00onFUYKoUiNGoiNGU`0=oiNGU`03
oiJFU_nGUiOoUiNG00goUiNG00?oUYJFoiNGUonGUiL00onGUiL03_nHV9So
VIVIoiVIVOnJVY[oVi^KoijNW_nQXJ7oXj>S0:NWY`2ZZZX0[Jf]0;:b/P2f
][H0^[Zj0`3oool0303@d=00dm?C0=OGe`3Kfm/0gmoO0>;RhP3Ti>CoinOW
onWYjOoZj^[ok>c/ong]kOook^k^IOo^k^h00007ojBTY?nKVi_omOGeooGe
mOodm?ComOGeooCdm004ooGem@04ooCdm?oemOGom?CdooCdm0;ol_;b0ooc
lo<03?ojn_[oBTY:on_[joo[jn_o`<30ohF5QOna/K7on_[jonc/k?oLg=co
QHF5omcLg0;ojn_[00?oQHF5olk>c_obl_800oobl_804?oclo?oGemOoeQH
F?obl_;olo?coo;bl_nOWioo7QhNojNWYooclo?oiNGUofEUIOlO7aoo:BTY
ob/[:onPX:02oo?cl`08oo;bl_mWIfOoFUYJoe9BD_l^;Rko820Pog9bL_o^
k^h2oo?cl`06onCTi?mUIFGo7alOobTY:Ol/;2coX:2P0_obl_800ooclo?o
GUiNoeQHF002oo;blP?olo?c00_ol_;bogYjN_lS8b?o9BDUoh:2P_mbLW;o
9bLWokZj^_oclo?oIfMWoemOG`02oo;blP03oo?clol];BgoVYZJ00;ol_;b
013obl_;ocLg=olN7Qko;Bd]ojb/[?le=CGoTI6Aoo;bl_oclo?oNGUiob@T
9?lU9BGoPH61og9bL_lW9bOo^[Zj0_obl_82oo?cl`;ol_;b00?olo?coo;b
l_oclo<00_obl_82oo7al@0@ono_koo/k>coj^[ZonKVi_oShn?oh>3Pom_K
fooGemOod];Bolc<c?o6a/KoNWYjogemOOn0P83oPh>3ohF5Q@;oQXJ60_n7
QhL00on8R8SoRHV9ohV9R@03ohV9R@04ohR8R?n9RHWoR8R8ohR8R0?oRHV9
1?n8R8P2ohV9R@;oR8R800?oRHV9ohR8R?n9RHT00_n8R8P3ohV9R@CoR8R8
0_n9RHT2ohR8R003ohV9ROn8R8SoRHV900;oR8R80on9RHT4ohR8R0;oRHV9
0_n8R8P00on9RHWoR8R8ohV9R@02ohR8R0?oRHV91?n8R8P2ohV9R@;oR8R8
00?oRHV9ohR8R?n9RHT00_n8R8P3ohV9R@CoR8R80_n9RHT2ohR8R003ohV9
ROn8R8SoRHV900;oR8R80on9RHT4ohR8R0;oRHV90_n8R8P04On9RHWoR8R8
ohV9ROn9RHWoRXZ:oh^;Ron=SHgoSXj>oi2@T?nCTi?oUIFE09VIV@2MWId0
XJ6Q0:FUY@2ZZZX0oooo0080000000X0oooo0<G5a@3:b/X0c/k>0=;BdP3E
eMD0fMWI0=cLg?oNg]kohN7Q0_oShn<00ooUiNGoi^KVonKViP3oonKViV?o
i^KV00001OnZZZ[oXJ6QonWYjOoZj^[ojNWY00?oj^[Z00?o^[Zjoe]KFooP
h>000_oZj^X03OoYjNWoj>SXonOWiooWinOoj>SXonOWiooXj>Sono_koda<
C?okno_okNg]ohF5QOlPC=000_m;Bal02OmJFU[oBam;oalO?Omg7gOoQHF5
oo_knon5QHGo`L71onOWi`02onSXj0;oinOW02KoGEeMoeIFE_oWinOoj>SX
olo?colY:BWoIfMWonOWiooXj>SoIFEUoc`l??nj^[[ohN7QoiBDU?lO7aoo
]KFeonSXj?oWinOoI6AToc@d=?nh^;SoinOWojf][Ol[:b_oSHf=onOWiooX
j>SoIVIVoc`l??nj^[[ohN7Qoi>CTolP823o]KFeonOWiooXj>SoG5aLoeIF
EP;oinOW00koj>SXonOWiooXj>Sobl_;ob0P8?nNWYkoemOGohN7QolP823o
UIFEonOWiooXj>SoI6AToeaLG0;oinOW01Coj>SXob`/;?nDU9CoinOWonSX
j?mQHF7o@D51okZj^_o6a/KoHF5QobHV9_n:RX[oinOWol_;bolP823oWYjN
omOGeon7QhOo820PoiBDU0;oj>SX0_oWinL01?oXj>SoinOWonOWiooXj>P4
onOWi`0BonKVi_oTi>Coi>CTon;Rh_oOgmoog=cLomSHf?oCdm?oclo?ol[:
b_o5aLGo_knookVi^OmkNg_oOWinoh20P?n2PX;oPh>30_n4Q8@00on6QXKo
QHF5ohJ6QP04ohF5Q@03ohJ6Q_n4Q8CoQHF500;oQ8B400CoQHF5ohB4Q?n5
QHGoQ8B40on5QHD00on4Q8CoQHF5ohB4Q002ohF5Q@08ohB4Q?n5QHGoQ8B4
ohB4Q?n5QHGoQ8B4ohF5QOn4Q8@3ohF5Q@03ohB4Q?n5QHGoQ8B400;oQHF5
00SoQ8B4ohF5QOn4Q8CoQ8B4ohF5QOn4Q8CoQHF5ohB4Q0?oQHF500?oQ8B4
ohF5QOn4Q8@00_n5QHD02?n4Q8CoQHF5ohB4Q?n4Q8CoQHF5ohB4Q?n5QHGo
Q8B40on5QHD00on4Q8CoQHF5ohB4Q002ohF5Q@08ohB4Q?n5QHGoQ8B4ohB4
Q?n5QHGoQ8B4ohF5QOn4Q8@3ohF5Q@03ohB4Q?n5QHGoQ8B400;oQHF500So
Q8B4ohF5QOn4Q8CoQ8B4ohF5QOn4Q8CoQHF5ohB4Q0?oQHF500?oQ8B4ohF5
QOn4Q8@00_n5QHD04?n4Q8CoQHF5ohF5QOn5QHGoQhN7ohR8R?n;Rh_oSHf=
oi2@T?nDU9@0oooo09ZJVP2PX:00Y:BT0:ZZZP3oool20000000=0?ooo`38
b<P0c/k>0=;BdP3Hf=P0fm_K0>3Ph03Shn?oi^KVonOWiooZj^[ojn_[ong]
k@3oonk^kVGok^k^00001?ng]kOo[:b/oo_knoojn_X2oo_kn`06oo[jn_o8
b<So;Bd]ob<S8omFEUKol?3`0_ojn_X2ooWin@Con?Sh013ooOgmohR8R?o^
k^kokno_ogUiNOlQNOgo8WWBoeaLG?m=8DgoCTi>ohR8R?m>8TkoUiNGonk^
k_miNGWodM7A1Oohn?P02omSHf?oG5aLooShn?ohn?SoFe]Koc`l??o/k>co
n?Shon_[jolQ8B7oRh^;00?on?Sh00Ko>3PhofYZJ_ohn?Son?Shof][JomR
HV83ooShn006ofEUIOm2@T;on?Shon_[jolR8R;oRh^;0oohn?P01_lh>3So
JVYZooShn?ohn?SoHf=Soe]KF`Gon?Sh00Oof][Job4Q8One]KGon?ShooCd
m?lQ8B7o/k>c00;on?Sh00?oJf][of9RH_ohn?P00_ohn?P01_l`<33oWYjN
ooShn?oemOGo;Bd]oiZJVP;on?Sh00_omOGeocDe=OnEUIGon?ShomWIfOlR
8R;o][JfooShn?odm?Co8B4Qok>c/`0:ooShn00AooWinOogmoOom_KfooGe
mOoclo?ol?3`onk^k_oYjNWoiNGUon7QhOoLg=coe]KFom3@d?o9bLWo`l?3
oh20P?n4Q8@00_n6QXH2ohN7Q`04ohR8R?n7QhOoQhN7ohN7Q`?oQXJ60on5
QHD01on4Q8CoQHF5ohF5QOn4Q8CoQHF5ohB4Q?n5QHD00_n4Q8@01?n5QHGo
Q8B4ohB4Q?n5QHD2ohB4Q008ohF5QOn4Q8CoQHF5ohF5QOn4Q8CoQHF5ohB4
Q?n5QHD2ohB4Q004ohF5QOn4Q8CoQ8B4ohF5Q@;oQ8B400SoQHF5ohB4Q?n5
QHGoQHF5ohB4Q?n5QHGoQ8B4ohF5Q@;oQ8B400CoQHF5ohB4Q?n4Q8CoQHF5
0_n4Q8@02?n5QHGoQ8B4ohF5QOn5QHGoQ8B4ohF5QOn4Q8CoQHF50_n4Q8@0
1?n5QHGoQ8B4ohB4Q?n5QHD2ohB4Q008ohF5QOn4Q8CoQHF5ohF5QOn4Q8Co
QHF5ohB4Q?n5QHD2ohB4Q004ohF5QOn4Q8CoQ8B4ohF5Q@;oQ8B400SoQHF5
ohB4Q?n5QHGoQHF5ohB4Q?n5QHGoQ8B4ohF5Q@;oQ8B400CoQHF5ohB4Q?n4
Q8CoQHF50_n4Q8@02_n5QHGoQ8B4ohJ6Q_n6QXKoR8R8ohV9ROn<S8coShn?
oi:BT_nEUID20?ooo`030:BTY02ZZZX0oooo0080000000h0oooo0<g=c@3D
e=@0fMWI0>3Ph03UiND0j^[Z0>k^kP3bl_;omOGeooShn?ojn_[oo?cloogm
oOooooooIOooool00003oj^[ZonQXJ7ono_k00?ono_k00OobLW9ob/[:om@
D53o^;RhobXZ:_mDE5Col?3`00;on_[j0_oinOT02?ohn?SonOWiooWinOok
no_oBd];ong]kOoNg]ko;Rh^0_lOMo/02Om<Mm3o?3`loiFEUOnSXj?o?3`l
omkNg_o]kNgoQXJ6om3@d002ooShn00>ooWinOohn?SonOWiof5QHOmJFU[o
nOWioj2PX?lR8R;oalO7ooShn?oinOWoc/k>oalO7onn_[h2ooShn007ooWi
nOmXJ6SoC4a<ooShn?oinOWoJVYZof5QH@02ooWin@0CooShn?nDU9Co8R8R
ooKfm_o>c/ko7alOokfm_OoinOWon?ShooWinOmXJ6SoC4a<ooWinOohn?So
HV9RoeYJF_ohn?SonOWiooShn002ooWin@0IooShn?n@T93o=CDeofm_KonI
VIWo7alOok>c/ooinOWon?ShofYZJ_mRHV;on?ShooWinOohn?So;bl_oijN
W_ohn?Soclo?oalO7oo2`/;onOWiooShn?oinOWo=cLgoiBDU002ooWin@0;
oi2@T?le=CGoKfm_oiVIVOlO7aoo/[:booShn?oinOWon?ShooWinOohn?P0
0_oinOT05?ohn?SonOWiooWinOoinOWon?ShooOgmooemOGolo?coo7alOo]
kNgojNWYonGUiOoPh>3of][JomCDe?o>c/koa/K6okno_omeMGGoMgMg0_mi
NGT2ogYjNP06ogUiNOmhN7SoNGUiogQhN?mgMgOoMWIf1?meMGD2ogAdM004
ogEeMOmdM7CoMGEeogEeM@;oM7Ad00CoMGEeogAdM?meMGGoM7Ad0_meMGD0
1_mdM7CoMGEeogAdM?mdM7CoMGEeogAdM0;oMGEe0_mdM7@01?meMGGoM7Ad
ogEeMOmdM7@2ogEeM@06ogAdM?meMGGoM7AdogAdM?meMGGoM7Ad0_meMGD2
ogAdM004ogEeMOmdM7CoMGEeogAdM0;oMGEe00KoM7AdogEeMOmdM7CoM7Ad
ogEeMOmdM7@2ogEeM@;oM7Ad00CoMGEeogAdM?meMGGoM7Ad0_meMGD01_md
M7CoMGEeogAdM?mdM7CoMGEeogAdM0;oMGEe0_mdM7@01?meMGGoM7AdogEe
MOmdM7@2ogEeM@06ogAdM?meMGGoM7AdogAdM?meMGGoM7Ad0_meMGD2ogAd
M004ogEeMOmdM7CoMGEeogAdM0;oMGEe013oM7AdogEeMOmdM7CoMGEeogIf
M_mgMgOoNGUiogalO?mnOWkoPH61ohJ6QP3oool000000?ooo`2JVYX0oooo
0P0000003P3oool0_;bl0<?3``39bLT0clo?0=GEe@3IfMT0g=cL0>7QhOoT
i>CoinOWonWYjOo/k>cokNg]ooo^k^iUonk^kP0000?oYJFUoi^KVoodm?@0
0_oemOD03?o4a<Co:BTYode=COoXj>SomOGeol30`?lY:BWoDU9BonWYjOod
m?Col_;boo?cl`?ol_;b013on_[jodY:B_o[jn_oBTY:odXOB_lN7Rgo>c/k
oc`l??lNBT[oBQi:obdN7_lN7QkoBTY:okno_on4Q8Co_kno0_oclo<2oo;b
lP0<oo?clomOGeoo;Rh^oeUIFOlW9bOoN7Qhoo?cloobl_;olo?comWIfOlN
7QkoX:2P0_oclo<04?obl_;oC4a<oeQHF?oclo?ol_;bofMWIomOGeool_;b
oo?cloobl_;oP820ocHf=_obl_;ofMWIoahN7_nPX:02oo;blP0<oo?clom=
CDgoF5QHoo?cloobl_;oGUiNoalO7olW9bOo@T92oh20P?oTi>Col_;b0_oc
lo<04_oTi>Co^;Rhoj:RX_lN7Qko[Jf]oo?cloobl_;oIfMWoeaLG?obl_;o
lo?coo;bl_l[:b_oVYZJoo?clooMgMgo7QhNoifMW@;olo?c00col_;bocHf
=_nATI7ol_;boo?cloobl_;oi>CTokRh^?nQXJ7o7QhNojj^[_oclo<2oo;b
lP;olo?c01Kol_;boo?cloobl_;ol_;boo?cloobl_;olO7aoo3`l?o_knoo
kNg]on[Zj_oWinOoh^;RomgMgOoIfMWodm?Colg=cOo6a/Ko_[jnokJf]_m_
KfooL71`0omaLG43og1`L003ofi^K_m]KFgoKFe]00;oJf][0_mZJVX00omY
JFWoJVYZofUYJ@05ofUYJ@04ofYZJ_mYJFWoJFUYofYZJPGoJFUY00?oJVYZ
ofUYJOmYJFT01?mYJFT01?mZJV[oJFUYofUYJOmZJVX5ofUYJ@03ofYZJ_mY
JFWoJFUY00CoJFUY00CoJVYZofUYJOmYJFWoJVYZ1OmYJFT00omZJV[oJFUY
ofUYJ@04ofUYJ@04ofYZJ_mYJFWoJFUYofYZJPGoJFUY00?oJVYZofUYJOmY
JFT01?mYJFT01?mZJV[oJFUYofUYJOmZJVX5ofUYJ@03ofYZJ_mYJFWoJFUY
00CoJFUY00CoJVYZofUYJOmYJFWoJVYZ1OmYJFT2ofYZJP08of][Jom/K6co
KVi^og5aLOmdM7CoN7Qhog]kN`3oool20000000B0?ooo`00000000000?oo
o`2/[:`0/[:b0;Zj^P30`<00a/K60<_;b`3@d=00eMGE0=SHf?oKfm_ogmoO
on7QhOoRh^;oi>CToooVi^IUonKViP0000?oZj^[oj6QXOoZj^X00_oZj^X0
2_nATI7oC4a<omkNg_oZj^[ojNWYon[Zj_nh^;So:BTYodm?CooNg]h3onSX
j004onOWiooXj>Sono_kohF5Q@;oMd]g00coQXJ6oiBDU?mgMgOoBd/Oob1<
d?lOMlooBamgoalO7omgC7OoBd];ohJ6Q_o@d=02onOWi`0>onSXj?oWinOo
j>SXoeaLG?m2@T;oShn?oeeMGOl^;RkoWYjNonOWiooXj>Soi^KVocXj>_mU
IFD2onOWi`0jom_KfolR8R;oR8R8onOWiooXj>SoI6AToc<c<oo3`l?oinOW
on?Shom9BDWoKfm_onOWiooVi^Ko>CTiofATI?oXj>SoinOWom_KfolR8R;o
R8R8onOWiooXj>SoGEeModm?Coo4a<CoS8b<ocLg=om8B4Sohn?SonOWiooU
iNGoj>SXonOWiooAdM7o7alOokVi^OoWinOoj>SXofATI?lP823oXZ:RonSX
j?oKfm_o820PojBTY?oWinOoi^KVod10@?mSHf?oj>SXonOWiooMgMgo;Rh^
ohZ:R_oXj>SoinOWonKViP;oj>SX00[odM7Aob0P8?nh^;SoinOWonSXj?oW
inOoj>SXonOWiooXj>SoinOW0_oXj>P3onOWi`0?onGUiOoTi>Coh^;RomoO
gooKfm_oemOGom?Cdoo=cLgoalO7ol;2`_nj^[[o];Bdojb/[?m`L73oLG5a
00?oLW9b00KoLG5aofm_Kom^KVkoKFe]ofa/K?mZJVX2ofUYJ@04ofMWIomX
J6SoIfMWofIVIPKoIfMW00OoIVIVofMWIomWIfOoIfMWofIVI_mWIfOoIVIV
00;oIfMW00?oIVIVofMWIomWIfL01?mWIfL01omVIVKoIfMWofMWIomWIfOo
IVIVofMWIomVIVH00_mWIfL00omVIVKoIfMWofMWI`04ofMWI`07ofIVI_mW
IfOoIfMWofMWIomVIVKoIfMWofIVIP02ofMWI`03ofIVI_mWIfOoIfMW00Co
IfMW00OoIVIVofMWIomWIfOoIfMWofIVI_mWIfOoIVIV00;oIfMW00?oIVIV
ofMWIomWIfL01?mWIfL01omVIVKoIfMWofMWIomWIfOoIVIVofMWIomVIVH0
0_mWIfL00omVIVKoIfMWofMWI`04ofMWI`07ofIVI_mWIfOoIfMWofMWIomV
IVKoIfMWofIVIP02ofMWI`0:ofIVI_mWIfOoJFUYofYZJ_m/K6coKfm_og9b
L_meMGGoNWYj0?ooo`D000001@3oool02P3;bl/0dM7A0=KFeP3Jf]X0h>3P
on?ShooVi^KojNWYon_[joo/k>coonk^kVGok^k^00000onf][Ko[:b/oo[j
nP02oo_kn`04oo[jn_ofm_Kon_[joo_kn`;on_[j00Gono_kolG5aOl/;2co
E5ADonk^kP04ooShn00@oogmoOmLG5coCR5>om4QdOmjCW[oNGUioc0Q8OnU
NB;odJDQob5id_lQNM7oYR:VojDQYOo3`l?oR8R8om;BdPGon?Sh00OoHf=S
oe]KFoohn?Son?ShohV9ROlV9RKok>c/00;on?Sh00Oo_Kfmob/[:om?Cdoo
PH61oc8b<_m>CTkolO7a00;on?Sh00OoJf][oeADE?m>CTkoHV9Roc`l??lU
9BGo`<3000;on?Sh00Oo_[jnob/[:om?CdooPH61oc8b<_m>CTkolO7a00;o
n?Sh00koHf=SoeaLG?ohn?Son?ShojNWYolQ8B7o][JfooShn?m_KfooEUIF
oh^;RomEEEGo=SHfooKfmP;on?Sh00OoJf][oeMGEomDE5CoEEEEodm?ColZ
:R[ok^k^00;on?Sh00Oo_KfmobLW9omDE5CoRHV9odY:B_lZ:R[oUIFE00;o
n?Sh00KoL71`oeEEEOn;Rh_oEEEEocHf=_ofm_H:ooShn00@ooWinOofm_Ko
mOGeoo?cloobl_;okno_on[Zj_oVi^KohN7Qom_KfooDe=CocLg=olK6a_nm
_Kgo]KFeogIfMP;oMgMg00_oMWIfogEeMOmeMGGoLg=cog5aLOm_KfooKVi^
ofa/K?m[Jf_oJVYZofUYJ@0@ofQXJ003ofMWIomXJ6SoJ6QX00goJ6QX00?o
IfMWofQXJ?mXJ6P03OmXJ6P00omWIfOoJ6QXofQXJ00=ofQXJ003ofMWIomX
J6SoJ6QX00goJ6QX00?oIfMWofQXJ?mXJ6P03OmXJ6P00omWIfOoJ6QXofQX
J002ofUYJ@07of][Jom^KVkoLG5aogAdM?mhN7SoOWin0?ooo`080000000<
0?ooo`3AdM40f=SH0=kNgP3UiND0j^[Z0>o_kooclo?omoOgooWinOokno_o
oOgmoooooomUooooo`0000?oZj^[oj2PX?okno/02_okno/02oo4a<Co:BTY
oe5ADOo_knoon?ShooWinOohn?Sono_koda<C?o?clooFUYJ00;o7alO01oo
C21<ogMg7ookcaooXgLOogLOMoo?7o_oMamgogM;Mon6QXKo`<30ooShn?oi
nOWon?ShooWinOohn?SoHV9RoeYJF_oinOWon?Shol[:b_lO7aoo^[ZjooWi
nOohn?SonOWiom_KfonGUiOoQ8B4ojZZZ_ofm_Kon?Sh00;onOWi00SoJVYZ
of5QHOoXj>SoX:2PohR8R?o:b/[on?ShooWin@;on?Sh00Gog=cLoiNGUon4
Q8CoZZZZooGem@02ooWin@0>ooShn?mRHV;oFUYJooShn?oinOWog=cLoalO
7onNWYkon?Shon[Zj_nk^k_oSHf=oj2PX?oRh^82ooWin@07ooShn?nm_Kgo
^;Rhono_konYZJWoT92@omkNgP02ooShn00DooWinOohn?Sod];Bohf=SOnC
Ti?ogmoOocLg=onDU9ConOWiooShn?oZj^[o^k^kohb<S?nQXJ7oh^;RooSh
n?oinOWon?ShooWinOohn?P3ooWin@0DooShn?oinOWon?ShooWinOohn?So
m_KfooCdm?obl_;ok^k^on[Zj_oUiNGoh>3PomWIfOoCdm?ocLg=olG5aOnl
_;co/k>coo;bl_oclo<2ooGem@03ooOgmoohn?Son?Sh00;on_[j0_okno/2
ooclo003oogmoOolo?cooOgm00;oo?cl00?ooOgmooclo?omoOd00_olo?`0
1?omoOgoo?cloogmoOolo?`3oogmo@07ooclo?omoOgoo?clooclo?omoOgo
o?cloogmo@02ooclo004oogmoOolo?cooOgmooclo0?ooOgm00Ooo?cloogm
oOolo?coo?cloogmoOolo?cooOgm00;oo?cl00CooOgmooclo?omoOgoo?cl
0oomoOd01oolo?cooOgmooclo?olo?cooOgmooclo?omoOd00_olo?`01?om
oOgoo?cloogmoOolo?`3oogmo@07ooclo?omoOgoo?clooclo?omoOgoo?cl
oogmo@02ooclo004oogmoOolo?cooOgmooclo0?ooOgm00Ooo?cloogmoOol
o?coo?cloogmoOolo?cooOgm00;oo?cl00CooOgmooclo?omoOgoo?cl0oom
oOd01oolo?cooOgmooclo?olo?cooOgmooclo?omoOd00_olo?`00oomoOgo
o?cl0?ooo`070000000=0?ooo`2j^[X0`L710<S8b03>c/h0e=CD0=[JfP3N
g]koh^;RonGUiOoXj>Sojn_[ong]k@02onk^kP03ong]kOo^k^kok^k^0?oo
k^k^H?o^k^h00003ojFUYOnLW9comOGe00?omOGe00Kom?CdooGemOoemOGo
mOGeooCdm?oemOD2ooCdm003ol30`?lX:2SoN7Qh00;olo?c00?ol_;boo[j
n_n5QHD00_o[jn/00oll?3coXQjRogI9MP02ogHNMP08odXNB_nSMQoo;Bd]
olk>c_o/k>coQHF5olk>c_oclo<2oo;blP;olo?c00OoGemOoeMGEooclo?o
d];BofEUIOlY:BWoinOW00?olo?c00Col_;boo?cloobl_;ol_;b0_oclo<2
oo;blP03ofMWIomNGUkolo?c00Golo?c00Col_;boo?cloobl_;ol_;b0_oc
lo<2oo;blP0:oo?cloobl_;oGemOoeQHF?oclo?odm?Cog9bL_lQ8B7og]kN
oo?cl`;ol_;b0_oclo<2oo;blP03oo?cloobl_;olo?c00Golo?c00Col_;b
oo?cloobl_;ol_;b0_oclo<2oo;blP03ocHf=_n@T93olo?c00Golo?c00Co
l_;boo?cloobl_;ol_;b0_oclo<2oo;blP03oo?cloobl_;olo?c00;olo?c
0_oalO404?o^k^kojn_[onWYjOoTi>CogmoOomWIfOoDe=CocLg=olG5aOnn
_[ko]KFeojb/[?o]kNgok^k^ono_kooalO42oo;blP?om?Cd1?ofm_I/ooOg
m`030?ooo`000000000000@0000000h0oooo0:^[Z`2c/k<0^[Zj0<71`@36
a/H0cLg=0=;BdP3Fe]Kof][JomkNg_oPh>3oh^;RonCTi?ooi^KVIOoVi^H0
0005ojZZZ_nPX:3ojNWYon[Zj_oYjNT00_oZj^X00ooYjNWoj^[ZonWYj@02
on[ZjP;ojNWY00?oj>SXokfm_OoLg=`00ooWinL04Ookno_oFUYJong]kOnS
Xj?o;Rh^oeYJF_o?7lood23@oj<OXolOBgOocj<OohF5QOo]kNgok>c/ohF5
QOo?clooinOW00;oj>SX00SoinOWonSXj?mLG5co8R8RobHV9_lP823oBDU9
oi^KV`KoinOW0_oXj>P01ooWinOoj>SXonOWiooXj>SoIFEUoeaLG?oXj>P0
1ooWinL2onSXj003onOWiooXj>SoinOW00;oj>SX00OoinOWoeeMGOlR8R;o
9BDUoalO7olX:2SoPh>300;oinOW0_oXj>P00ooWinOoj>SXonOWi`02onSX
j003onOWiooXj>SoinOW00KoinOW0_oXj>P01ooWinOoj>SXonOWiooXj>So
=SHfoh^;RooXj>P01ooWinL2onSXj003onOWiooXj>SoinOW00;oj>SX01[o
inOWonSXj?oWinOoinOWonKVi_oUiNGohn?Son7QhOoMgMgofMWIomGEeOo?
cloob/[:ol?3`onl_;co];Bdojb/[?nSXj?ohN7Qon;Rh_oShn?oi>CTonGU
iOoVi^KoinOWonSXj0;ojNWY0_oZj^Y[on_[j`;ok>c/00<0oooo00000000
00000`0000003`3oool0YJFU0:n_[`2g]kL0_kno0<K6aP3=cLd0d];B0=SH
f03MgMgohN7QonGUiOoXj>Sojn_[ong]k@03onk^kP03ong]kOo^k^kok^k^
0?ook^k^Goo^k^h00003okNg]on/[:cono_k00;ono_k00Gon_[joo_knooj
n_[on_[joo_kn`02oo[jnP03oo_knooinOWonOWi00;onOWi0oohn?P02Oon
o_koCDe=ono_kon8R8SoCDe=ogYjN_m=CDgodB7AoeaLG002ob5=N@06ohR8
R?o_knookno_ohR8R?o3`l?onOWi1?ohn?P01?oWinOog]kNomkNg_oZj^X7
ooShn003ooWinOohn?Son?Sh00Con?Sh00?oRHV9oh>3Poohn?P01_ohn?P0
0ooinOWon?ShooShn006ooShn004onKVi_oNg]kogmoOon[ZjP?on?Sh00?o
nOWiooShn?ohn?P03Oohn?P00ooinOWon?ShooShn004ooShn003of5QHOnY
ZJWon?Sh00Kon?Sh00?onOWiooShn?ohn?P02?ohn?P05OoinOWomoOgooGe
mOoclo?olO7aonk^k_oYjNWoi>CTomgMgOoGemOod=3@olS8b?no_koo]kNg
ojb/[?o_knoolO7aoo;bl_oclo?omOGeooKfmP02ooOgm`;on?Sh00?onOWi
oo[jn_ojn_X0IOojn_X00ookno_on_[joo_kn`02oo_kn`03oo[jn_okno/0
oooo00@000000100oooo0?[jnP2_[jl0^[Zj0<?3``3;bl/0e=CD0=_Kf`3R
h^80inOW0>g]kOoalO7omOGeooShn?okno_ooOgmoooooomUooooo`0000?o
ZZZZoj6QXOokno/01Ookno/00oolo?cono_koo_kn`02oo_kn`;on_[j1?oi
nOT00oohn?Sono_kohJ6QP04ong]k@0;ol30`?mgBgOono_konc/k?nSXj?o
UIFEonc/k?o]kNgoQXJ6olo?coohn?P00_oinOT01?ohn?SonOWiooWinOoh
n?P2ooWin@04ooShn?oinOWonOWiooShn0;onOWi0_ohn?P2ooWin@04ooSh
n?oinOWonOWiooShn0;onOWi00Con?ShooWinOoinOWon?Sh0_oinOT2ooSh
n0;onOWi00Con?ShooWinOoinOWon?Sh0_oinOT01?ohn?SonOWiooWinOoh
n?P2ooWin@;on?Sh0_oinOT01?ohn?SonOWiooWinOohn?P2ooWin@04ooSh
n?oinOWonOWiooShn0;onOWi0_ohn?P2ooWin@04ooShn?oinOWonOWiooSh
n0;onOWi00Con?ShooWinOoinOWon?Sh0_oinOT2ooShn0;onOWi00Con?Sh
ooWinOoinOWon?Sh0_oinOT05Oohn?SonOWiooWinOogmoOom_Kfoo?cloo`
l?3okNg]onWYjOoTi>CogMgMomSHf?o@d=3ob<S8ol30`?nf][Ko[:b/od=c
^_m4MK_oAGJlodMg_P02odQh_`04odUi`?m;Nl;oBgc2odal``;oCGg400Co
C7g3odema?m=OLCoC7g41Om=OL@2odam``GoCGg400CoC7g3odema?m=OLCo
C7g41Om=OL@2odam``GoCGg400CoC7g3odema?m=OLCoC7g41Om=OL@2odam
``GoCGg400CoC7g3odema?m=OLCoC7g41Om=OL@2odam``GoCGg400CoC7g3
odema?m=OLCoC7g41Om=OL@2odam``GoCGg400CoC7g3odema?m=OLCoC7g4
1Om=OL@2odam``GoCGg400CoC7g3odema?m=OLCoC7g40om=OL@2odena0;o
CGg40_m>O/D05@3oool00000000000000000oooo04ina@1=O/@0Xj>S0:f]
[@2e]KD0_[jn0<G5a@3<c<`0dM7A0=SHf03MgMgohN7QonGUiOoWinOoj^[Z
onc/k03oonk^kVGok^k^00000onTY:CoVi^KooGem@04ooGem@03ooCdm?oe
mOGomOGe00;omOGe0_odm?@02Ooclo?ol_;boo;bl_obl_;olo?coo;bl_oj
n_[oBTY:oo[jnP03on_[j`04onc/k?o[jn_ojn_[onc/k0Cojn_[00?oQHF5
olk>c_oclo<00oobl_800ooclo?ol_;boo?cl`02oo;blP;olo?c0oobl_80
0ooclo?ol_;boo?cl`03oo;blP03oo?cloobl_;olo?c00;ol_;b0_oclo<3
oo;blP03oo?cloobl_;olo?c00?ol_;b00?olo?coo;bl_oclo<00_obl_82
oo?cl`?ol_;b00?olo?coo;bl_oclo<00oobl_800ooclo?ol_;boo?cl`02
oo;blP;olo?c0oobl_800ooclo?ol_;boo?cl`03oo;blP03oo?cloobl_;o
lo?c00;ol_;b0_oclo<3oo;blP03oo?cloobl_;olo?c00?ol_;b00?olo?c
oo;bl_oclo<00_obl_82oo?cl`0Eoo;bl_oalO7ol?3`onk^k_oZj^[oj>SX
on;Rh_oNg]koemOGom;Bd_o:b/[o`l?3okZj^_na/K7oZ:RXod9b^Om3Lk[o
A7FkodEf_Om7MkkoB7Ro00;oBGW000GoBW[1odYk`Om;Nl;oBgc2odal``02
od]l`P0Bodal`om;O<;oBg_2od]k`_m;O<;oC7c3od]l`_m<O<?oBg_2od]l
`_m;Nl;oBgc3od]l`_m<O<?oBgc2od]k`_m<O<?oBgc20_m;Nl803_m;O<;o
C7c3od]l`_m<O<?oBg_2od]l`_m;Nl;oBgc3od]l`_m<O<?oBgc2od]k`_m<
O<?oBgc20_m;Nl803_m;O<;oC7c3od]l`_m<O<?oBg_2od]l`_m;Nl;oBgc3
od]l`_m<O<?oBgc2od]k`_m<O<?oBgc20_m;Nl803_m;O<;oC7c3od]l`_m<
O<?oBg_2od]l`_m;Nl;oBgc3od]l`_m<O<?oBgc2od]k`_m<O<?oBgc20_m;
Nl803_m;O<;oC7c3od]l`_m<O<?oBg_2od]l`_m;Nl;oBgc3od]l`_nL]]co
X;WMod]k`_m<O<?oBgc20_m;Nl803_m;O<;oC7c3oibeg?nP^MgoBg_2od]l
`_m;Nl;oBgc3od]l`_m<O<?oBgc2oeF2aOo5dnWoLYO?0_m;O<801?m<O<?o
CGg4odal`om<OL@2odal``040?ooo`00000000000?ooo`80C7c300l0CGg4
09jNWP2VYZH0[Zj^0;Ng]`2o_kl0aLG50<_;b`3@d=00eMGEomWIfOoMgMgo
gmoOon?ShooTi>@0oooVi^IUonKViP0000GoZZZZoj6QXOoYjNWoj^[ZonWY
j@04on[ZjP04onWYjOoZj^[oj^[Zon[ZjP?oj>SX0ooWinL00ooXj>Sono_k
oda<C003ohJ6QP05ohF5QOn6QXKoQXJ6ohJ6Q_n5QHD01On6QXH01?okno_o
inOWonSXj?oWinL2onSXj005onOWiooXj>SoinOWonSXj?oWinL00_oXj>P3
onOWi`04onSXj?oWinOoj>SXonOWi`;oj>SX00GoinOWonSXj?oWinOoj>SX
onOWi`02onSXj0?oinOW00Coj>SXonOWiooXj>SoinOW0_oXj>P01OoWinOo
j>SXonOWiooXj>SoinOW00;oj>SX0ooWinL01?oXj>SoinOWonSXj?oWinL2
onSXj005onOWiooXj>SoinOWonSXj?oWinL00_oXj>P3onOWi`04onSXj?oW
inOoj>SXonOWi`;oj>SX00GoinOWonSXj?oWinOoj>SXonOWi`02onSXj0?o
inOW00Coj>SXonOWiooXj>SoinOW0_oXj>P01OoWinOoj>SXonOWiooXj>So
inOW00;oj>SX01?oi^KVonGUiOoRh^;oh>3PomgMgOoIfMWoe=CDolk>c_o9
bLWo`L71ok^k^onb/[;oZZZZoj2PX?llJ[Ko?V^gocm/^?m0KKWo@Fjj00;o
@W2l00?oA76modAb__m5Lkl00_m5Lkl01?m6M<3oAWBoodId`?m5Lkl2odId
`005ooclo?nEUIGoFUYJoe]KFomJFUX01?mKFe/01om;Bd_oFe]KoeYJF_mK
Fe_oFUYJoe]KFonTY:@00_m6M<000om6LkooAWC0odEc_`04odId`005odEc
_om6M<3oAWBoodId`?m5Lkl01?m6M<000om6LkooAWC0odEc_`04odId`005
odEc_om6M<3oAWBoodId`?m5Lkl01?m6M<000om6LkooAWC0odEc_`04odId
`005odEc_om6M<3oAWBoodId`?m5Lkl01?m6M<000om6LkooAWC0odEc_`04
odId`005odEc_onmcNOoa=7YodId`?m5Lkl01?m6M<000om6Lkoo_LgVol?A
j004odId`006odEc_om6M<3oAWBoodId`?o2dNSo_/gW1?m6M<006om7ML7o
AWC0odMe`Om7M<00oooo0000003oool0AgG104Id`017ML40AWC00:>SX`2]
[Jd0][Jf0;jn_P35aLD0cLg=0=7Ad@3Hf=P0g=cLon7QhOoTi>CoinOWon_[
joo/k>cok^k^ong]k@3oonk^kV?ok^k^00001_ng]kOo[:b/oo_knookno_o
n_[joo_kn`?on_[j00?ono_koo[jn_okno/00_ojn_X00ooinOWon?ShooWi
n@1_ooShn00@ooOgmooemOGolo?coo7alOo]kNgojNWYon?ShooNg]koemOG
om3@d?o7alOo_knookJf]_n][JgoA7FkodIf_@;oB7Ro00OoBW[1od]k`_m;
O<;oC7g3odema?m>O/GoCWo500;oCgo600?oCh36odmoa_m?P<H00_m?OlH0
0oooooooG5aLog]kN`03ohV9R@03ogYjN_n9RHWoRHV900GoRHV900SoCTi>
om;Bd_m?P<OoCgo6oe20aom?P<KoCgo6odn0aP?oCgo600GoCh36odmoa_m?
P<KoCgo6odn0aP02odmoaP0>oeF4b?mSSLcoD837odn0a_m?OlKoCh36odmo
a_mHQLSoEXG8odn0a_mNRL[oEhG9odmoa_m?P<H2odmoaP06odn0aom?OlKo
EXC8of>=c?m?OlKoCh360om?OlH01Om?P<KoCgo6odn0a_m?OlKoCh3600;o
Cgo600KoCh37odmoa_m@P<OoGX[;odmoa_m?P<H3odmoaP0Iodn0a_o1d^[o
b=S]odmoa_mNR/[oEhG9odmoa_m?P<OoCgo6oe20aoo1dn_ob=O]odn0a_mN
RL[oEhC8odmoa_m?P<KoCgo6odn0a_m?OlKoNYkCoo[ko?mMR/_oD837odn0
aP04oe20a`0Fodn0aP3oool0oooo0520a`1?P<H0D83704n0aP1@P<L0[jn_
0;Zj^P33`l<0bl_;0=CDe03Kfm/0hN7Q0>SXj03]kNgolO7aooGemOohn?So
no_koogmoOooooooIOooool00004oj^[ZonPX:3oCGk4odema0CoCWk500Co
CGk4odema?m=O/CoCWk50_m=O/@00om<O<?oC7g3odema003odal``;oC7g3
00SoC7c3odam`om<O<?oBgc3odal`om<OL?oC7c3odam``;oC7c300CoC7g3
odal`om<O<?oC7c30_m<OL<02?m<O<?oC7g3odal`om;O<?oC7c3odam`om<
O<?oC7g30_m<O<<01?m<OL?oC7c3odal`om<O<<2odam``08odal`om<OL?o
C7c3od]l`om<O<?oC7g3odal`om<OL<2odal``04odam`om<O<?oC7c3odal
``;oC7g300SoC7c3odam`om<O<?oBgc3odal`om<OL?oC7c3odam``;oC7c3
00CoC7g3odal`om<O<?oC7c30_m<OL<02?m<O<?oC7g3odal`om;O<?oC7c3
odam`om<O<?oC7g30_m<O<<01?m<OL?oC7c3odal`om<O<<2odam``08odal
`om<OL?oC7c3od]l`om<O<?oC7g3odal`om<OL<2odal``04odam`om<O<?o
C7c3odal``;oC7g3027oC7c3odam`om<O<?oBgc3odal`om<OL?oC7c3odam
`om<O<?oC7g3odal`_m;Nl7oBgZoodYi_Om9Mk[oB7FgodIb/om5L:ko@fbY
od1XXolnIIko?66HocULTOlfF8WoAgVlodUk__m:O;ooBgg0odan`Om=Ol;o
CX33odn1a?m?PLD00_m@P/H00om@PlKoDH?7oe:4a`02oe:4a`04oe63aomB
Q<OooOgmoda<C0;ok^k^00So`/;2ohR8R?nc/k?ooOgmonk^k_oOgmooQhN7
on3Ph0;ok^k^00WoQhN7om7AdOmBQ<OoDH?7oe:4aomAPlOoDXC7olSHkOo>
g>h00_mBQ<L02omAPlKoU;;LoogmoOn=[]WoDXC7oef;b_o4e>[ono_loo?e
nOo`m?SoTk;K00?oDXC700oo`M?ZolcJkOoBg^kol??hoo[ko?nhc>OoEHK8
oe63aomBQ<OoGHc;ol?Dj_okno_oloGioo7dn?nD/m`00omBQ<L00oo7enco
c]c^oe:4a`02oe:4a`0Loe63aomBQ<OoDXC7ofZEc_oNio?oo?clon?[m?m`
V]7ooOgmoh^/fOmBQ<OoDH?6ol7Bj_oGh_7od]k^oo3cn?oin__o^<cWoeF6
b?mAPlOoDXC7ol7BjOoGh_7odmo_oo3cn?ojnoco^<cWoeB5a`?oDXC700Oo
MIgCooclo?nP^mooDXC7oe63aomBQ<OoDH?700GoDXC700?oDH?6oe:4aomB
Q<L00_mBQ<L03_nUYJGo[jn_okRh^?no_kooa/K6olg=cOoCdm?ofMWIomgM
gOoRh^;oiNGUonSXj?o[jn_okNg]0_o^k^h00oo]kNgok^k^onk^kP3oonk^
kV3ok^k^00001?nTY:CoVi^Kodama?m<OL@4odal``07odema?m<OLCoC7c3
odal`om<OL?oBgc2odal``05od]k`P04odYk`_m;Nl;oBg_2od]k`P;oBgc2
1?m;Nl800om;O<;oBW_2od]k`P03od]k`P04odYk`_m;Nl;oBg_2od]k`P;o
Bgc21?m;Nl800om;O<;oBW_2od]k`P03od]k`P04odYk`_m;Nl;oBg_2od]k
`P;oBgc21?m;Nl800om;O<;oBW_2od]k`P03od]k`P04odYk`_m;Nl;oBg_2
od]k`P;oBgc21?m;Nl800om;O<;oBW_2od]k`P03od]k`P04odYk`_m;Nl;o
Bg_2od]k`P;oBgc21?m;Nl800om;O<;oBW_2od]k`P03od]k`P04odYk`_m;
Nl;oBg_2od]k`P;oBgc20_m;Nl801?mEP/Go`m;Xog:Gc_m:Nl84od]k`P04
odYk`_m;Nl;oBg_2od]k`P;oBgc21?m;Nl805Om;O<;oBW_2od]j`Om;N/3o
BWZnodYh_?m8M[WoAgBfodEa/_m4Kjgo@VbYod1YY?lmI9go>f2GocUMTOle
EhWo@W>iod=c^_m5MKcoAWJmodMg_P02odQh_`04odUj`?m:N/7oBg_2od]l
``?oC7c300[oC7g4odal`om=OLCoC7c3oo_knom<C4coo?clong]kOn6QXKo
7d_?0_m;Bal02OmJFU[oC21<oalO??mg7gOoQXJ6oo_knon7QhOo`<30odal
``03odama00Aodal`oo5eN[oc=W[odal`om=OLCoH8_:oo;dn?nkcNKoC7g4
odal`onncnSoh^Wbog>HcomBP<GoU[;Kooclo?mgVm400_m<O<<06?nncnOo
j^ofogFJdOm<O<?oOZ3Coo7cmonK]McoCGg4odal`onmc^Ooh^Wcog>Hd?mA
P<GoUK7Joo_knomgVm7oC7c3odema?o5eN[oc=W/odal`om<OLCoC7c3odem
a0;oC7c3013oZKoQon;YlomNR/WoOIoBomcUlOokno_oQZOEodema?m<OLCo
_/oWonW^mOmeV]7oC7c3ognQdoo`l_OoVkGL0_m<OL@01onncnSojNkeogFJ
d?m<O<?oOZ7Coo7cmonK]]d00_m<O<<01Om<OLCo]LSUoo[jnooRjO;oC7c3
00?oC7g41?m<O<<05?m=OLCoC7g4odal`om<O<?oC7g4odal`onRXZ;oZZZZ
ok:b/_nj^[[o`L71olO7aoo<c<cod];BomKFe_oJf][og]kNon7QhOoShn?o
i>CT0ooVi^H00ooUiNGoi^KVonKViP3oonKViUooi^KV00005_nZZZ[oXJ6Q
odId`?m7ML7oAWC0odMe`Om7ML3oAgC0odId`?m7ML7oAWC0odMd`?m7ML3o
AWBoodIc_om5LkooAG>nodEc_om5L[koAG>ooo_knonEUID2oeYJFP03oeUI
FOmJFU[oFUYJ00;oFUYJ00?oBd];oeYJF_mJFUX00omJFUX00onTY:CoAG>o
odEc_`02odEc_`03odEb__m5LkooAG>o00GoAG>o00?oAG:nodEc_om5L[h0
1Om5Lkl00om5L[koAG>oodEc_`05odEc_`03odEb__m5LkooAG:n00GoAG>o
00?oAG:nodEc_om5Lkl01Om5Lkl00om5L[koAG>oodEb_P05odEc_`03odEb
__m5LkooAG>o00GoAG>o00?oAG:nodEc_om5L[h01Om5Lkl00om5L[koAG>o
odEc_`02odEc_`06ol;Aj?nmcNKoAG>oodEb__m5LkooAG:n1Om5Lkl00om5
L[koAG>oodEc_`05odEc_`0AodAb_Om5L[goA76kodAa^_m3K[Ko@Vfcod5[
/?loJ:_o?FBVocaRX_liGico=e^GocEHT?lbDhWo?6Zfoce[]olnK;P00_m0
K[X2od9`_004odAa_Om4L[koAG>oodEc_P?oAWC004?oAgG1odId`?m7M<3o
AWC0ooclo?n8R8SokNg]onk^k_mhN7So8GWmob5idOmKFe_oC21<ode=COn7
QhOoCB5=oiJFU_o^k^koNGUiom7AdOm6M<3oAgG1odId`?m7ML7oAWC0olGC
j_o;f>coAgC0odId`?o<f>goi>[doe1k`om7ML7oDGc4oogmoOnR^=koAWC0
odMe`Om6M<3ojNkfokk>j?m7ML7oAgG0okk=ioo4d^WoAgG1odId`?m7M<3o
`m;Zon7Xlom7M<3oDGc4ooclo?nR^MooAWC0odMe`Om6M<3ojNkfoko>j?m7
M<3oAWC0olGCj_o:encoAgC0odMe`Om6M<3oAgC000;oAWC003_oc=S/ok[:
i_m7ML7oAWC0ofR>boomoOgoPj7DodId`?m7ML7o_LgWolGBj_m7ML7oAWC0
odMd`?o3dNWohNScodMe`Om6M<3o_/kXolCBjOm7ML7oAgG0odMd`?o2dNWo
hNSdodId`?m7M<3oCW[2oo;enOnS^Mkom_SjogFFcom7ML7oAWC0odMe`Om6
M<3oAgG1odMe`?m7M<3oAWC0odMe`Om6M<3oAgC0odMe`Om6M<3oZJVYok:b
/_nj^[[o`/;2olS8b?o?clooe=CDom[Jf_oNg]koh^;RonGUiOoYjNWoj^[Z
onc/k03oonk^kVGok^k^00000ong]kOo[:b/oe20a`03oe20a`03odn0a_m@
P<OoCh3600;oD83700?oCh36oe20aom?P<H00om?OlH01_m>O/GoCWo5odin
aOomoOgoG5aLogUiN@?oR8R800?oNGUiohR8R?n8R8P01On8R8P00om=CDgo
dM7Aodioa@02odina@04odioaOm>O/GoCWk5odioa@;oCWk500_oCWo5odin
aOm?OlKoCWo5odinaOm>OlGoCWk5oeB3aomRS<_oCWk5odioa@02odina@0>
odioaOmFQ<SoEHC7odioaOmLRLWoEXC8odioaOm>O/GoCWo5odinaOm>OlGo
CWk5oeB2aomRSL`2odina@0;odioaOm>O/GoCWk5odioaOm>O/GoCgo6odio
aOm>O/GoCWo5odinaOm>OlD00_m>O/D04Om>OlGoCWk5odinaOm>OlGoCWk5
of6<bom?P<GoCWk5odmoa_m>OlGoCWk5odioaOm>O/GoCWo5of6<bom?OlGo
CWo500;oCWk500_oCWo5odinaOm>O/GoNIgBooWjnomMRL[oCWo5odinaOm>
OlGoCWk5odioa@02odina@04odioaOm>O/GoCWk5odioa@;oCWk501[oCWo5
odinaOm?OlKoCWk4odem`om=OL;oCGc0odaj__m;N;[oBGFfodQc/om5Kjgo
A6fYod9YXoloIIgo?66FocYMT?m4M;_oAWJmodMh__m8N;ooBW[1odYk`_m<
O<?oC7g3odema0;oCWk500?oCgo6odn0aom?OlH00_m@P<L01om?P<KoD837
oooooom>CTkol?3`on7QhOlb<S800_lSNol02om?Nm?o@410oiRHV?nWYjOo
@410on7QhOoalO7oRHV9om?Cdom@P<OoCh3600?oD83701Cob=S^oloLkom@
P<OoU[?Moocmo_mhWM?oCh36oe20aombV=7oooooognRe_m@P<OoCh36oe20
aoo3e>cofnGcoe20aom?P<Ko`]?[olSHk@;oD83700OoCh36oj2kh?olo?go
DH76og:Id_ooooooOZ7E00?oD83700Oo`mC/om[Ul_m@P<OoCh36olSHk_o@
gNooCh3600;oD83700GoCh36oe20aom@P<Ood=g_ok_=j@02oe20a`07oe61
aoooooooRZ[Iodn0a_m@P<Oo`]?[olSHk@02oe20a`0Dodn0a_nP^n7oo?cm
oe61a_m@P<Oo`]?[olWHk_m@P<OoCh36oe20aonP^n3onocmoe:1aom?P<Ko
T:kKoocloOmLRL_o_m3[ol?Dk?m?P<H4oe20a`03odn0a_m@P<OoCh3600;o
D837017oCh36oe20aom@P<Oo^;Rhol71`Oo:b/[odM7AomSHf?oNg]koiNGU
on[Zj_o^k^kolo?cooKfm_oinOWoo?cloogmo@3oooooofGooooo00001_n[
Zj_oXJ6Qoe:4aomBQ<OoDH?7oe63aP?oDXC700SoDHC7oe:4aomBQ<OoDH?7
oe:4aomAPlKoD8;6oe63aP;oD8;600goDH?6oo_knom;Bd_okNg]onc/k?o1
`L7oQXJ6ok:b/_okno_ok>c/omkNg_n6QXKog]kN00;okNg]03ooQXJ6om3@
d?m@P/GoD8;5oe23a_m@P/KoDH?6olKFjoo=fngoDH?6oe22aOmAPlKoTk7J
oo_knon<[MSoD8;6oeb:bOo3dnWonOWjoo7dmoo_loOoT[7Joe63a_m@P/Ko
D8?6ol3Aj?o:f>_odMg^onkbmoohnO[o]l_Voe>4a_m@P/KoDH?6oe^:bOo2
d^Won_[koo7dn?o_loOoT[7Joe23a_mAPlKoD8;5olOGjonodNSoD8;6oe63
a_m@P/KoSZkIoo_knonM^=goD8;5ol3Aj?o6e^_oDH?6oe22a_m`V<ooi^ce
oo_knoo_loOoR:[GonS]mOnO^]h00_m@P/H03_m`V=3oiN_doo_knoo_loOo
R:[GonS^mOnO^MkoD8?6oe63a_m@P/GoM9cAoo_knonN^MkoDH?60_m@P/H0
2omAPlKoD8;5oe22aOm@PlKoD8;6oe63a_m@P/KoD8?6oe63a_m@P/GoDH?6
00;oD8;601?oD8;5oe21`om@PL?oX[[Jodim_Om<Nk_oBgVgodYg/om8M:oo
AW2ZodA]YOm2JIoo?VFHocaQTom7NKgoB7ZnodYl_om;OL3oC7k100;oCGo3
00?oCX33odn2aOm@P/D00_mAPlH00omAQ<OoDXC7oe63a`02oe:4a`07oe64
aoomoOgoC4a<onk^k_m=CDgoC21<ob0P;`02ochn?P08ob5=COm<84co<24Q
ob4Q8Om<C4co`/;2ohN7Qoo2`/84oe:4a`06oe63aoo7encol??iolcKkOoe
mo[o/lWU0_mBQ<L01?mAPlOoIi?>oogmoOnC/]`3oe:4a`07omORlOo=fngo
DH?6oe:4aoo1d^Wob=S/oe64a`02oe:4a`06ojg4hooZkoOoDXC7ofJBcOom
oOgoTk;L0_mBQ<L00omAPlOoe^7`olgKk@02oe:4a`0DolSGk?olo?comOOj
omoXlon]aNCoGH_:oe64aomBQ<Oocmg^ok[=iomBQ<OoDH?7oe:4a_omoOgo
Rj_Hoe:4aomAQ<Oo`M;ZolSHk?mAPlL2oe:4a`07ojg4hooZkoOoDXC7oe:4
aoo1dn[ob=O/oe63aP02oe:4a`0:ojg5i?oYkoKoDXC7oe:4aooCgnooa]G/
oe:4aomhW];onOWkof2=b`;oDXC700?oDH?7oe63a_mBQ<L00_mBQ<L04omA
Q<OoDXC7oe:4aomAPlOoDXC7ojn_[onf][Ko_[jnolG5aOo;bl_odM7AomKF
e_oJf][oh>3Pon?ShooVi^KojNWYon_[joo]kNd0ooo^k^iUonk^kP0000Ko
YJFUoi^KVom<O<?oC7c3odama?m=OL@2odal``07odema?m<OLCoC7c3odam
a?m<O<?oBgc2odal``05od]k`P06oo[jn_m:BT[on_[jon_[jon5QHGo7T[>
0_m:BQh02_mIFEWoBQi:oahN??mf7WKoQHF5oo[jn_n4Q8Co_knood]k`_m;
O<82od]k`P03od]l`_o4dnWob]OZ00;oBg_200?oGh[8oo7cmonjbnD00_m;
Nl801onlcNKohNSaog:Gc_mAOlCoU;3Ioo[jn_mfVm000_m;Nl801onmc^Ko
j>gdog>Hcom;O<;oOIoAonobm_nI]=/00_m;Nl801onlcNKoh^Sbog:Gc_m@
O/?oUK3Joo[jn_mfV/l00_m;Nl805?o3dnWo_LgWod]k`_m;Nl;oMIW?ooGf
n?n^`^7oBg_2od]l`_nmc^Ko`m?Xod]l`_m;Nl;o`=3Wom_Tl?mbUlkoJI7;
ol7Aioocm?OoW;KL0_m;Nl801oo0d>OofnC`og:GcomYTL_o`=3Woo?en?nL
]]`00om;Nl800oncan?onOWjon7Wl@05od]k`P04od]l`_m;Nl;oBg_2od]l
`PGoBg_201OoBgc2od]k`_m;Nl7oBW[0odYi_oodm?CoW;?EodQf^?m7LkGo
AG2`odA_[Om2JjSo@6RSociUW_lkHISo>EfAod9c^Om3Lk[oAGFlodIf_Om6
MkgoAgRoodUi`002odYj`@05odYk`Om;O<?oBgc3odal`om<OL<00_m<O<<0
1?m<OLCoC7c3ooclo?n6QXH2ogM;M`0=ohJ6Q_nEUIGoMgMgod];7olPC=3o
7gS?od/OMolO7aooMd]god];Bon7QhOoclo?odama003odal``0Nodama?o5
eN[og>GaoiVcfoo5eN_ok_;goh^Zeom<OLCoC7c3odem`ooTj_Co_/kWodam
a?m<O<?oEXC6ooSin_nO^=goCGg4odal`onncnOojnofof^CcOm<O<?oCgk4
omKPkoneb>GoC7g4odem`ooSj_Co_/kW0_m<O<<07OmGQLOon?WjoinhgOm<
O<?oCGg4olGEj_o@g>goJi;=oiffg?oWk?Coen;`odmoa?m<OLCocM[/okO9
iOm<O<?oC7g4odina?okno_oQZKEodema?m<OLCo_/oWon[_mOm[TlgoC7c3
odmoaOoFh>oo]/WU00;oC7c300oo_/oWon[_mOm/U<goC7c3odina?oGh?3o
]/SUodal`omVSl_ono_kognQdom<OLCoC7c3omcTlOnL]md00_m<O<<02?m<
OLCoCGg4odal`om<O<?oCGg4odama?m<O<?oC7g40_m<O<<03_n/[:co/[:b
okZj^_o0`<3oa/K6ol_;boo@d=3oeMGEomSHf?oKfm_ogmoOon7QhOoRh^;o
i>CT0ooVi^H00ooUiNGoi^KVonKViP3oonKViUooi^KV00001?n[Zj_oXJ6Q
odMd`?m7ML42odId`008odMe`?m6M<3oAgC0odId`?m7ML7oAWC0odMe`?m6
M<02odEc_`06odIc_om5LkooAG>oodEc_ookno_oQHF50_o]kNd03_mgMgOo
7gOkoamgcomJFU[oC21<od];Bon5QHGoBam;oiFEUOo]kNgoMgMgom3@d?m5
LkooAG:n0om5Lkl07Oo3dNSob]K[odEc_om5Lkoob]K[on;Yl_m?N/7oAG>o
oe1k`_okno_oXKSModEc_om5L[koAG>oonO]m?nmcNOoAG:nodEc_onlc>Go
`m7YodEc_om4L[koAG>ool;@jOoPio;oAG>ooe1k`ookno_oX;OM00?oAG>o
01?oincdokg=iom5LkooAG>ool?Aj?nkb^GoAG>oof68b?o^l_Oo`LoWodId
_om5LkooAG:nokc<i_o3dNSoAG>oodMd_ooam?SoU:kI00;oAG>o00coAW>n
on[^mOnI/]_oAG>oodQe`?oam?SoU:kIodEb__m5LkooAgBoon[^mOnI/MX2
odEc_`05odai`OoaloSoXKOLooGgnOmdU/l01?m5Lkl01Om5L[koAG>oodEc
_om5LkooAG:n00CoAG>o01GoA7:nodEc_om5LkkoAG>modEa_?oemOGol_;b
oiR^d_m2K;?o@6Z_ocmX[?lmIJOo?6:RocUOWOlhG9So=UVBocaY]OlmJkOo
?ffiod1^^Om1Kk/00_m2L;`00om3LKgoA7:nodEc_P02odEc_`;oAWC001Go
AgG1odMd`?m6M<3oAWC0oogmoOmKFe_oC25<om4QdOmiC7WoN7Qhoc0Q8OnU
N27odJDQob1hd?lQNM7oY22TojDQYOo2`/;oQhN7om7AdOm7ML400_m7M<00
6om7ML7oAWC0olCBjOo;f>coAWC0odMd`?nT^]oonOWkoe1k`om7ML7oAgC0
ogNHcoodmoWoe^3`oj^ohOo_l_Ooen7`odai`_m6M<3oAgG0okg=ioo@fngo
e^3_olOCjooUjoGon__kogFGd002odId`00QogRId?odmoWoe]o`oj_0hOo_
l_Ooe^3_odei`_m6M<3oAgC0olCBjOo;f>coAWC0odMe`On;YmOoo?clogjN
d_m7ML7oc=W/okK7i?m7ML7oAWC0odMe`?omoOgoPj7DodMd`?m6M<3o_/kW
om3KkOoGhO3oa]?[onG[m?oin__oMIO@00;oAgC000_o_/kXom3KkOoFh>oo
a]?[onG[mOoin__oMIK?odMe`OnW_N3ojnogodQe`002odId`004oi:]f_oS
jOCoAgC0odMe`@;oAWC001CoAgG0odId`?m7M<3oAWC0odMe`Om6M<3oAgG1
odMd`?nd];Co_;blol?3`oo9bLWoc/k>omGEeOoIfMWogMgMon7QhOoTi>Co
inOWonWYj@;ok>c/0_o^k^h00oo]kNgok^k^onk^kP3oonk^kV3ok^k^0000
0onf][Ko[:b/odn0aP02oe20a`03odn0aom@P<OoCh3600;oD83700CoCh36
oe20aom?P<KoCh360_m?OlH3odina@06odioa_omoOgoCDe=ono_kooPh>3o
<30`0_lQNOd07_m>NM;o?ShnoiNGUonUYJGo?cloon3Ph?o_knooR8R8om;B
d_m>OlGoCWk5odioaOm>O/GoCgo6olOGk?o>fnkoCWo5oiBafooko?goMY_A
odmoa_m>O/GoL9O@oogmoOmmX=CoCWo5odinaOm>OlGo`];ZomWTlP;oCWk5
03Ko`=;ZolOFk?m>OlGoCWk5odmoa_nN^Moon__loe1oaOm`Um3ooOgmogfP
e?m>OlGoCWk5odmoa_o2d^[ofN?aodioaOm>O/GoamO/ol3@jOmKR<[oiN_e
omGPl?mCP/OoCWo6odioaOm>O/Go`=7ZolOFk?m?OlKoKiK@oogmoOmiW]?o
CWk5odioaOm>O/Goj^ogoijigom>O/GoKiK?ookno_miW]?oCWk5odioaOm>
O/Goj^ogoijigom>O/GoCWo5ohn]fOojnocoFhS:okg>jOo1d^X2odina@06
odioa_m>OlGoCWk5odioaOm>O/GoCgo60_m>O/D01Om>OlGoCWk5odioaOm>
O/GoCgo600;oCWk401KoCWg3ooShn?oemOGol_;boibbdom9MKKoB7>codI`
[_m4KJ[o@VZUod1VWolnHi[oA7FkodIf_Om7MkkoB7VoodUj`?m;Nl;oC7c3
odam`om=O/CoCWk50om?OlH00om@P<OoCh36oe20a`02oe20a`04oooooom?
Cdoodm?CoeiNGP;o8b<S00goCb=?og]k8ooodb?oYg/Sog/SNooC8oooNb9k
og]?Non9RHWoaLG5odn0a_m@P<OoCh3600;oD83700Sob=S]om3Lkom?P<Ko
D837ogFKdoooooooPZCGodn0aP;oD83700koIi7>oifhh?n^`nCoSZgJoe>2
b?m@P<OoCh37oe20aoo2dn_obMS^oef9bonE/mgoZ/7SogBJdP?oD83701?o
Ch36ofN@c_nM^>3o[/CTohn^fomBP/SoD837odn0a_m@P<Oob=S]oloLkom@
P<OoCh36ofJAc_ooooooV;GNodn0a_n5YmSoO:7D00;oD83700?oCh37oiVf
g_mXTLh00_m@P<L04omoX]GoPjGGoeb9bonF/mgoZL7SogFKdom?P<KoD837
odn0a_n0XmKoPjGGoeb9bonF/mgoZL7SogFKdom@P<OoCh36oh^[f_moX]D0
0om@P<L00omHQ/WoVKGNoeV7b@02oe20a`03odn0aom@P<OoCh3600;oD837
01;oCh36oe20aom?P<KoD837olK6a_o=cLgodm?Com[Jf_oPh>3oiNGUonWY
jOo]kNgol_;booCdm?ohn?Son_[jooclo?omoOgoooooofGooooo00002On[
Zj_oX:2Poe:4aomBQ<OoDH?7oe:4aomAPlOoDXC7oe63a`03oe:4a`0>oe64
aomBQ<OoDH?6oe22a_mAPlKoD8;5oe63a_m@P/Kono_koda<C?o/k>coC4a<
od/OBolO7bh2ocdm?@0Boam;Bom<7dco;AlOoalO7om;Bd_o`<30ohJ6Q_o0
`<3oD8;5oe63a_m@P/GoDH?6oe22aOo7e^_ok_;gol_Jk?ocmOSo//ST0_m@
P/D03_m@P/KoII3;oo_knonB/M[oD8;5oe63a_m@P/Goe^7`ol_Ijom@P/Ko
DH?6ol3Aj?o6e^_oDH?60_m@P/D02on/`n;oj>geoe63a_mUTLcono_koi:a
fom@P/GoDH?6oe22aOoEh>ooc=[/00;oD8;602koamO[olCEjOoDgnoohNSc
oeb:bOmAPlKoD8;6oe22aOmAPlKo_m7XolOGjom@P/GoHXo;oo_knonE/m_o
D8;6oe63a_m@P/Goj>geoinjg_m@P/GoHXo;oo_knonD/][oDH?6oe22aOmA
PlKoj>geoinjg_mAPlKoD8;6om7Nk_o4e>[oD8;5ogJMdOogn?[oGX_9oe63
a_m@P/KoD8;5oe63a_m@P/GoDH?6oe22aOm@P/KoDH?60_m@P/H06?mAPlKo
D8;5oe22aOm@P/GoCh74oe21a?oemOGom?Cdoo7alOo]kNgoVk;AodYg]?m8
MK3oAg:]odE`Z?m3Jj;o@FVNodMi_?m8N[koBWboodYm`?m<O/;oCGo2odeo
``;oCh7400?oD8;6oe22aOmAPlH00_mBQ<L01_mAQ<OoDXC7oe63aomAQ<Oo
oOgmohN7Q`;ok^k^00ko?ShnojDQYOmhC7SoNB5iogPPN?m=8DgoYGTQoc0`
<?o@d=3ok^k^ohN7Qoo@d=3oDXC7oe63a`;oDXC700koDH?7olSHk?o>g>go
DXC7of^Fcoo4e>[om?Ojoe^:b_mAQ<OoDXC7oe63aomAQ<OoDXC7oe63a`;o
DXC700GoDH?7oe:4aomAPlOo`M?ZolSGk003oe:4a`06oe64aomBQ<OoDH?7
oe64aomBQ<OoDH?70_mBQ<L03_mAPlOoDXC7oe63aomBQ<OoDH?7olSHk?o>
g>koDXC7ofZEc_nicNOonO[kof:?c?mBQ<OoDH?70_mBQ<L01OmAPlOoDXC7
oe63aomBQ<OoDH?700?oDXC700KoDHC7oe:4aomAPlOoDHC7oe:4aomAPlL2
oe:4a`05oe63aomBQ<OoDH?7oe:4aomAPlL00omBQ<L01_mAQ<OoDXC7oe63
aomAQ<OoDXC7oe63a`;oDXC700GoDH?7oe:4aomAPlOoDXC7oe63a`03oe:4
a`0@oe64aomBQ<Oo_;blol;2`_o9bLWocLg=om?CdooGemOofm_Kon3Ph?oR
h^;oi^KVonOWiooZj^[ok>c/ong]k@;ok^k^00?okNg]onk^k_o^k^h0ooo^
k^iPonk^kP0000GoYJFUoibLW?m<OLCoC7c3odema002odal``05odam`om<
OLCoC7c3odal`om<OL<00om<O<<00om;O<;oBg_2od]l`P02od]k`P0Coo[j
n_n5QHGoMTUfogI:M_n5QHGoTi>CogIfM_m:BQko7T[>oaifc_m:7gKo7QhN
ogI:M_m:BT[oQHF5olk>c_m;O<;oBg_2odYk`@02od]k`P06olCCjOoJhnoo
V;?Jol?CjOo/lOKoRZ[F0_m;Nl806_m<O<;oh^Wbokc=i_m;O<;oBg_2oeF2
aOogn?SoW[OLod]k`_m:Nl;o_LkVonW]m?mZT/_oBgc2odim`ooEg^ko]LST
od]k`_m;O<;oh^Wcokg=i_m:Nl7oBg_2oeF3a_ofmoSoWKKK0_m;Nl801Oo4
dnWod]c]onc`mOnM]mcoBgc200;oBg_200CoBgc2od]k`_nlc^Koa=?Y0_m;
Nl806?oMiO3o_/kVod]k`_m;Nl;oE8;5oncam_nL]]coBgc2od]k`_oMiO3o
_/oWod]k`_m:Nl7oE874oncam_nL]]coBW_2ofF=b_ojn_[oOZ3Bod]l`_m;
Nl;of^?`oibfg0;oBg_200?oBgc2od]k`_m:Nl400om;Nl801_m:Nl;oBg_2
od]k`_m;Nl;oBgc2od]k`P;oBg_101GoBg_0ooGemOoclo?ol?3`ong]kOoZ
j^[oUJ_<odA_[om3KJ_o@F^XocmXXolnIIko@W>iod=d^om5MKcoAWJmodMg
__m7N;koBGW0odUj`?m9N/400_m;Nl803Om;O<;oBgc3odam`om<O<?oC7g4
odema?m<OLCono_koe]KFoo]kNgoXj>Sobh^;_mJFUX00_o?7ll07OnT8:Co
7d]golnS7on6QXKok>c/ong]kOn7QhOod=3@odal`om=OLCoC7g4odal`om=
OLCoaMGZooSin_oemoWono_komKPkon?[=SoC7g3odal`om<OLCoCGg4odam
a?m<O<?oCGg4odama?m<O<?oCGg400;oC7c300ko_/oXolGEj_m<O<?oC7c3
odam`om<O<?oC7g4odema?m<OLCoC7c3odema?m<OLCoC7c3odema0;oC7c3
00koC7g3odama?o5eN[on?WjooGgnOokno_oloGhojBlgom<OLCoC7c3odem
a?m<OLCoC7c3odema0;oC7c300koC7g3odama?m<O<?oC7c3odam`om<O<?o
C7g4odema?m<OLCoC7c3odema?m<OLCoC7c3odema0;oC7c300koC7g3odam
a?m<O<?oC7c3odam`om<O<?oC7g4odema?m<OLCoC7c3odema?m<OLCoC7c3
odema0;oC7c301;oC7g3odama?m<O<?oC7c3odam`om<O<?oC7g4ok^k^oo0
`<3oaLG5ol[:b_o>c/kodM7AomKFe_oIfMWofm_KomkNg_oQhN42on?Sh`03
onGUiOoVi^Koi^KV0?ooi^KVHooVi^H00003ojZZZ_nPX:3oAWC000;oAWC0
00OoAgC0odMe`Om6M<3oAgG1odId`?m7ML3oAgG100;oAWC000ooAW>oodEc
_om5LkooAG>oodEb__m5Lkoono_koeYJF_m;7d_ocao?ogM<MomgMgOo;QlO
ojAg8?o?Xal00_lOMll2oj<OX`03ol30`?n5QHGoclo?00GoAG>o00Oo`m7X
olWFjom5LkooAG>ooj>ig_ogn?WoCWW100;oAG>o00OoMYO>oo?en?oDg^ko
ZKkPonkam_oEg^koC7O100;oAG>o013o_LcVolkIjooEgnkoaM;Yon?Ylooh
nO[oLiG>odEb__m5LkooMYO>oo?en?oEg^koZKkOonkam_oEg^koBgO10_m5
Lkl01_o3dNSo^l_Vog:DcOocmOWoL9;<odEb_P?oAG>o01go_LcVol?Aj?m5
LkooAG>oogNHcooemoWod=[/oj>ig_oHh>ooloGhoiVbf_m5LkooAG:nogNH
cooemoSod=_]oj>ig_oGh>oom?GioiVbf_m5LkooY[cOonW]mOm7M;ooAG>o
odEb__n@ZmSohNObodEb_P0<odEc_`;oAG>n01goAG:nodEb_OogmoOomOGe
oo;bl_o`l?3ojN[[ohNObOm0JJko?fR[ociVZ?llHj?o>f6PocaZ]OlmJkKo
?fbhod1]^Om0K[[o@Vnkod9`_?m4LKgoA7:nodEb__m6LkooAG>oodId`?m7
M<3oAWC0odMe`@02odId`00<oogmoOm<C4cokNg]ohN7Qom<C4coNGUiode=
COoA8=7oG5aLob1<N?lQCGWoR8R80_o^k^h00on7QhOo`/;2odMd`004odId
`009oeEoaOmKQ<OoFhC7oe=ma?m6M<3oAgG0odMe`Om6M<3oAgG100;oAWC0
00?oAgC0odId`?m6M<000_m6M<002Om7M<3oAgG1ojBjgonZ_n7oAWC0odMe
`?m7ML7oAWC0odMe`@02odId`003odMd`?m6M<3oAWC000;oAWC000WoAgC0
odMe`Om6M<3oAgG1oeAna?mKQ<OoG8C7oe=na?m7ML400_m6M<000om7M<3o
AWC0odId`002odId`009odMd`?m7ML7oAWC0odMe`Om6M<3oAgG0odMe`Om6
M<3oAgG100;oAWC000?oAgC0odId`?m6M<000_m6M<002Om7M<3oAgG1odId
`?m7ML7oAWC0odMe`?m7ML7oAWC0odMe`@02odId`003odMd`?m6M<3oAWC0
00;oAWC001GoAgC0odMe`Om6M<3oAgG1odId`?m7ML3oAgG1odId`?m7ML7o
a/K6ol[:b_o?cloodm?ComOGeooKfm_og]kNon;Rh_oTi>Coi^KVonWYjOoZ
j^X00_o]kNd3onk^kP03ong]kOo^k^kok^k^0?ook^k^Goo^k^h00003okNg
]on/[:coD83700;oD83700CoCh36oe20aom?P<KoCh360_m@P<L00om?P<Ko
D837odmoaP03odmoaP0FodinaOm>OlGoCWo6ookno_m=CDgodM7AoeaLG?lQ
8B7o8R8RoddQCOmiNB7ooM8RojEi8Omi8GWodR;nogXRN_miCGWoR8R8ol?3
`om?OlKoCWk5odioa@;oCWk5027oamO/olkKk_m>O/GoCWo5og>IdOomoOgo
PJ?Eodmoa_m>O/GoCWo5ofJ?c?nL]moo[<;Rohf/fOmAP<KoCWk5odioa_m>
O/Go`=7YolOGk?mKQlWoU;7KojS0h_mdV];oCWk5odioaOm>OlKoCgo6ofF?
c?nL]mko[<7Rohf/fOmAPLL00_m>O/D08Om>OlGoa]K/ol3@jOm?OlKoUK;L
onobn?mSSLcoCWo6odmoa_m>O/GoOZ7Doh6SeOm>O/GoCWo6odinaOm]ULko
YKgQoinigomRSL_oj^ogoinjgom>O/GoCWo5odioa_m^ULooY;gQoinigomR
SL_ojNofoinjgom>O/GoRJWHogjQe002odina@08odmoa_mGQLSoUkCLoeR6
b?m>OlKoCgo6odinaOm>OlD2odina@04odioa_m>O/GoCWk5odioa@;oCWk5
017oCgo6odmoaOm>O/CoCWk4oo[jn_oinOWom_KfonS[l?mgV<WoBWNiodYf
]om8Lk?oAW6`odE_[Om3K:SoA7FkodIf_@02odQh_`05odYj`Om;Nl;oC7c3
odam`om=O/@00_m>O/D01?m?P<KoCgo6odmoa_m@P<L2odn0aP04oe20aooo
ooooRHV9oo3`l0;olO7a00Ool?3`olC4a?mkCg_ooooooo7alOnWYjOoV9RH
00;ol?3`00CoRHV9om?Cdom@P<OoCh360om@P<L01?m?P<KoD837odn0a_m?
P<H2oe20a`04odn0a_m@P<OoCh36odn0aP;oD83700KoCh36oe20aom@P<Oo
D837odn0a_m@P<L2odn0aP;oD83700CoCh36oe20aom?P<KoCh360_m@P<L0
1_m?P<KoD837oe20aom@P<OoCh36oe20a`;oCh360_m@P<L01?m?P<KoD837
odn0a_m?P<H2oe20a`06odn0a_m@P<OoD837oe20aom?P<KoD8370_m?P<H2
oe20a`04odn0a_m@P<OoCh36odn0aP;oD83700KoCh36oe20aom@P<OoD837
odn0a_m@P<L2odn0aP;oD83700CoCh36oe20aom?P<KoCh360_m@P<L01_m?
P<KoD837oe20aom@P<OoCh36oe20a`;oCh360_m@P<L04Om?P<KoD837odn0
a_oHf=Sog]kNon;Rh_oVi^Koj^[Zonk^k_oalO7om?CdooKfm_ohn?SonOWi
ooclo?omoOgoo_kn0?ooooooIOooool00005ojZZZ_nQXJ7oDXC7oe63a_mA
PlL01OmBQ<L00omAPlOoDXC7oe:4a`03oe63aP?oD8;600?oD8;5oo_knon6
QXH00_o]kNd00olm?CgoXanSogM;M`02ogLOM`0Cod/OBonSMaoo;Rh^olo?
coo]kNgoQXJ6olo?com@P/GoD8;6oe63a_m@P/KoDH?6olOFjoo<f^coD8;6
ofZEc_o2d^WoloGioeV9b003oe22aP;oD8;500SoD8;6oe63a_m@P/KoDH?6
oe22a_m@P/Go`=7XolOGj`KoD8;60_m@P/D02_m@P/KoDH?6oe22a_mAPlKo
D8;6oe22aOm@P/KoDH?6olKFjonodNP2oe22aP0<okC8iOoKiO7oEhO7oe22
aOm@P/KoJYC>of^DcOmAPlKoD8;6oe22aOm@P/KoDH?60_m@P/H01?oXk_Go
WkWNoe22a_m@P/H2oe22a@08oe22a_mAPlKoD8;6onW^m_nO^]koD8;5oe22
a_mAPlH6oe22aP;oD8;500SoD8;6oe63a_m@P/KoDH?6oe22a_m@P/GoD8;6
oe63aP;oD8;601OoDH?6oe22aOm@P/GoD8;4ooShn?ofm_Kog>C]ofN?aom>
OKgoCGblodaj^?m:N;KoBWJcodUe/?m7LZgoAWRlodQi_Om9N[koBWbood]l
`?m;OL7oCGk2odio``02odn0a0?oD87500?oDH;6oe62aomAP/H00_mAP/H0
0oolo?coCDe=ooclo002ong]k@Gok^k^00KokNg]onk^k_o^k^kok^k^ohN7
QooAdM43oe62aP06oe22a_mAP/KoDH;6oe62aomAP/KoDH;70omAP/H00omA
P/OoDH;6oe62aP04oe62aP06oe22a_mAP/KoDH;6oe62aomAP/KoDH;70omA
P/H00omAP/OoDH;6oe62aP04oe62aP06oe22a_mAP/KoDH;6oe62aomAP/Ko
DH;70omAP/H00omAP/OoDH;6oe62aP04oe62aP06oe22a_mAP/KoDH;6oe62
aomAP/KoDH;70omAP/H00omAP/OoDH;6oe62aP04oe62aP06oe22a_mAP/Ko
DH;6oe62aomAP/KoDH;70omAP/H00omAP/OoDH;6oe62aP04oe62aP06oe22
a_mAP/KoDH;6oe62aomAP/KoDH;70omAP/H03OmAP/OoDH;6olo?cooCdm?o
e]KFom[Jf_oLg=cogmoOon;Rh_oTi>CoinOWonSXj?oZj^X00_o/k>`00oo]
kNgok^k^onk^kP3oonk^kV?ok^k^00001OnTY:CoVi^Kodema?m<O<?oC7g4
00?oC7c300?oC7g4odal`om=OL@00om<O<<04_m;O<;oBg_2odYk`_m;Nl;o
Bgc2od]k`_ojn_[oF5QHon_[jonRXZ;o;Bd]oeQHF?o?7/oocQk>oj8NX_lO
BWOocZ8NohB4Q0;ojn_[00?oQHF5olk>c_m;Nl801?m;Nl802_o4dnWon?Wj
ooCfmooinOWoeN3_ohj/eom;Nl;oBW_2od]k`_m;O<87od]k`P04od]l`_nm
c^Ko`m?Yod]l`P;oBg_200?oBW_2od]k`_m;O<801om;Nl802_m;O<;oBg_2
od]k`_o4e>Wo_LgVod]k`_m:Nl;oCGg2olkJk?o1dNP2od]k`P05okg>i_o3
dnSoBg_2od]k`_m;O<800_m;Nl801_m;O<;oBg_2onK[lonK]M_oBg_2od]l
`PGoBg_200?oi^_coi^fg?m;O<800_m;Nl801_m;O<;oBg_2od]k`_m:Nl;o
Bg_2od]l`POoBg_200CoBgc2od]k`_m;Nl;oBgc20_m;Nl805?m:Nl7oBg_1
od]k`Oohn?Sob=CWoeF0`Om:N;goBGNkodQf^Om8MKOoAgBeodEa/_m4L:oo
A6n]od9b^Om3Lk[oA7FkodEf_Om7MkkoB7Ro0_m9NL001Om:N/7oBW_1od]k
`_m;O<;oC7g300;oC7c300KoCGg4odal`om<O<?ono_kod];Bon7QhL7ohJ6
QP06ohN7Qon6QXKoQXJ6ohN7Qon6QXKono_k0_m<O<<00om=OLCoC7c3odam
a003odal``03odama?m<O<?oCGg400;oC7c300?oCGg4odal`om<O<<00_m<
O<<00om=OLCoC7c3odama003odal``03odama?m<O<?oCGg400;oC7c300?o
CGg4odal`om<O<<00_m<O<<00om=OLCoC7c3odama003odal``03odama?m<
O<?oCGg400;oC7c300?oCGg4odal`om<O<<00_m<O<<00om=OLCoC7c3odam
a003odal``03odama?m<O<?oCGg400;oC7c300?oCGg4odal`om<O<<00_m<
O<<00om=OLCoC7c3odama003odal``03odama?m<O<?oCGg400;oC7c300?o
CGg4odal`om<O<<00_m<O<<00om=OLCoC7c3odama003odal``03odama?m<
O<?oCGg400;oC7c300_oCGg4ol_;boo>c/kodM7AomCDe?oHf=SofMWIomgM
gOoNg]koh>3Pon7Qh@02on?Sh`;oiNGUoooVi^IUonKViP00013oZZZZoj6Q
XOm6M<3oAgG1odId`?m7ML7oAgC0odMe`Om7ML3oAWC0odMe`Om6M<3oAgC0
odIc_om6M;ooAW>o1?m5Lkl02Ookno_oC4a<ong]kOn6QXKoBd];ogMgMom<
C4cocao?oeYJFP02oam;M`06ohJ6Q_o]kNgokNg]ohJ6Q_o1`L7oAG:n1?m5
Lkl01OmCOL?oFX?6oeZ2a_mAO<?oAG:n00KoAG>o00?oAG:nodEc_om5Lkl0
0_m5Lkl01Om5L[koAG>ooj>ig_nY_N3oAG:n00KoAG>o00?oAG:nodEc_om5
Lkl00_m5Lkl01_m5L[koAG>oodEc_om5LkooDgg3oe9l``?oAG>o00SoBgO0
oeZ3a_m7M;ooAG>ooe9l`omCO/?oAG>oodEb_P?oAG>o00CoAG:nodEc_oo5
dn[oQjGD0om5Lkl01_m5L[koAG>oodEc_om5LkooaM?YohNUe0?oAG>o00?o
AG:nodEc_om5Lkl01?m5Lkl00om5L[koAG>oodEc_`02odEc_`0JodEb__m5
LkooAG>oodEc_om5L[koAG>oodIc_om5LkooAW>oodEc__n^`N3oB7BmodEb
_?m5LK_oA72iodA_^?m2KKGo@Vfdod5//_m1Jk3o?fR]od=c^_m5MKcoAGJm
odMg__m8N;l2odUi`0;oBg_200OoC7c3odam`om<O<?oCGk4odema?m>O/Go
CGg400;oCWk500GoCGk4odinaOm=O/CoCWk5odema004odina@05odema?m>
O/GoCGk4odinaOm=OL@00_m>O/D01Om=O/CoCWk5odena?m>O/GoCGg400Co
CWk500GoCGg4odinaOm=O/CoCWk5odema002odina@05odena?m>O/GoCGk4
odinaOm=OL@01?m>O/D01Om=OLCoCWk5odena?m>O/GoCGg400;oCWk500Go
CGk4odinaOm=O/CoCWk5odema004odina@05odema?m>O/GoCGk4odinaOm=
OL@00_m>O/D01Om=O/CoCWk5odena?m>O/GoCGg400CoCWk500GoCGg4odin
aOm=O/CoCWk5odema002odina@05odena?m>O/GoCGk4odinaOm=OL@01?m>
O/D01Om=OLCoCWk5odena?m>O/GoCGg400;oCWk500GoCGk4odinaOm=O/Co
CWk5odema004odina@0<odema?m>O/GoCGk4odinaOm=OLCoemOGom[Jf_oL
g=cogmoOon7QhOoTi>CoiNGU0_oXj>P00ooZj^[ojn_[onc/k003onk^kP03
ong]kOo^k^kok^k^0?ook^k^HOo^k^h00003okNg]on/[:coD83700?oD837
0_m?P<H2oe20a`0>odn0a_m@P<OoCh36odn0a_m?OlKoCWo5odmoa_m>O/Go
Cgo6odioaOomoOgoR8R8ono_koo^k^h2ono_k`0<ol?3`omiCWWooOgmono_
konUYJGoUiNGono_koo^k^koR8R8om;Bd_m>O/GoCWo50om>O/D01Om>OlGo
CWk5odioaOm>O/GoCWo500;oCWk500KoCWo6odinaOm?OlKoCWo5odinaOm>
OlD3odina@05odioaOm>O/GoCWo5odinaOm>OlD00_m>O/D01_m>OlKoCWk5
odmoa_m>OlGoCWk5odioa@?oCWk500GoCWo5odinaOm>OlGoCWk5odioa@02
odina@06odioa_m>O/GoCgo6odioaOm>O/GoCWo50om>O/D01Om>OlGoCWk5
odioaOm>O/GoCWo500;oCWk500KoCWo6odinaOm?OlKoCWo5odinaOm>OlD3
odina@05odioaOm>O/GoCWo5odinaOm>OlD00_m>O/D01_m>OlKoCWk5odmo
a_m>OlGoCWk5odioa@?oCWk500WoCWo5odinaOm>OlGoCWk5odioaOm>O/Go
CWo5odmoa_m>O/D00_m?OlD03_m?O/CoCWk3odim`_m=O<3oCG^oodaj__m;
NKcoBgRkodUf^?m9M[Ookno_oo3`l?obl_;olo?c0_oemOD01Oofm_KomoOg
ooShn?ohn?SonOWi00Con_[j00Gono_koo[jn_ojn_[ono_koo[jnP02oo_k
n`03oo[jn_okno_on_[j00;on_[j00Gono_koo[jn_okno_on_[joo_kn`02
oo[jnP06oo_knoojn_[ono_koo_knoojn_[ono_k0oojn_X01Ookno_on_[j
oo_knoojn_[ono_k00;on_[j00Kono_koo[jn_okno_ono_koo[jn_okno/3
oo[jnP05oo_knoojn_[ono_koo[jn_okno/00_ojn_X01_okno_on_[joo_k
nookno_on_[joo_kn`?on_[j00Gono_koo[jn_okno_on_[joo_kn`02oo[j
nP06oo_knoojn_[ono_koo_knoojn_[ono_k0oojn_X01Ookno_on_[joo_k
noojn_[ono_k00;on_[j00Kono_koo[jn_okno_ono_koo[jn_okno/3oo[j
nP05oo_knoojn_[ono_koo[jn_okno/00_ojn_X01_okno_on_[joo_knook
no_on_[joo_kn`?on_[j01;ono_koo[jn_okno_on_[joo_knooZj^[ok>c/
oo3`l?oalO7olo?cooKfm_ogmoOonOWioo[jn_okno_oo?cloogmoOono_ko
ooooofKooooo00000on[Zj_oX:2Poe62aP02oe62aP07oe62aomAP/KoDH;7
oe62a_m@P/KoDH;6oe62a`02oe62aP?oD87500KoCh34odn0aOm?P<Cono_k
oda<C?okno/2ong]k@06onc/k?o]kNgokNg]onc/k?o]kNgok>c/0_o]kNd0
0oo/k>coQXJ6olo?c`04oe21a@07odn0aOm?P<CoCh75oe21aOm?P<GoD875
odn0a002oe21a@03odn0a?m?P<GoCh3400CoD87500OoCh35odn0a?m?PLGo
D875odn0aOm@PLGoCh3400;oD87500?oCh34odn0aOm?P<@01?m@PLD01om?
P<GoCh34odn1aOm@PLGoCh35oe21aOm?P<@00_m@PLD00om?P<CoCh35odn0
a004oe21a@07odn0aOm?P<CoCh75oe21aOm?P<GoD875odn0a002oe21a@03
odn0a?m?P<GoCh3400CoD87500OoCh35odn0a?m?PLGoD875odn0aOm@PLGo
Ch3400;oD87500?oCh34odn0aOm?P<@01?m@PLD01om?P<GoCh34odn1aOm@
PLGoCh35oe21aOm?P<@00_m@PLD03om?P<CoD834oe21a?m@PLCoD833odn0
`_m?Ol7oCWk0odem__m=O;koCG^lodaj^_m<N[Woh>3Pon;RhP02onCTi0;o
i^KV00?oj>SXonWYjOoYjNT00ooZj^X3on_[j`04onc/k?o[jn_ojn_[onc/
k0?ojn_[0_o/k>`00oo[jn_ok>c/on_[j`02on_[j`03onc/k?o[jn_ok>c/
00;ojn_[00Cok>c/on_[joo[jn_ojn_[0_o/k>`00oo[jn_ok>c/on_[j`02
on_[j`03onc/k?o[jn_ok>c/00;ojn_[00Cok>c/on_[joo[jn_ojn_[0_o/
k>`00oo[jn_ok>c/on_[j`02on_[j`03onc/k?o[jn_ok>c/00;ojn_[00Co
k>c/on_[joo[jn_ojn_[0_o/k>`00oo[jn_ok>c/on_[j`02on_[j`03onc/
k?o[jn_ok>c/00;ojn_[00Cok>c/on_[joo[jn_ojn_[0_o/k>`00oo[jn_o
k>c/on_[j`02on_[j`03onc/k?o[jn_ok>c/00;ojn_[00Cok>c/on_[joo[
jn_ojn_[0_o/k>`00oo[jn_ok>c/on_[j`02on_[j`03onc/k?o[jn_ok>c/
00;ojn_[00Cok>c/on_[joo[jn_ojn_[0_o/k>`00oo[jn_ok>c/on_[j`02
on_[j`0:onc/k?o[jn_ok>c/omkNg_oPh>3oh^;Ron?ShooUiNGoi^KVonSX
j0;oj^[Z00Cojn_[onc/k?o/k>cokNg]0oo^k^h00oo]kNgok^k^onk^kP3o
onk^kV3ok^k^00001?nTY:CoVi^Kodama?m<OL@4odal``07odema?m<OLCo
C7c3odal`om<OL?oBgc2odal``05od]k`P03oo[jn_m:BT[oQ8B400?oQHF5
0_n4Q8@01?n5QHGoQ8B4ohF5QOn4Q8@3ohF5Q@03oo[jn_m:Nl;oBg_200;o
Bg_20_m;O<84od]k`P03od]l`_m:Nl;oBg_200?oBg_200CoBW_2od]k`_m;
Nl;oBg_20_m;O<84od]k`P03od]l`_m:Nl;oBg_200?oBg_200CoBW_2od]k
`_m;Nl;oBg_20_m;O<84od]k`P03od]l`_m:Nl;oBg_200?oBg_200CoBW_2
od]k`_m;Nl;oBg_20_m;O<84od]k`P03od]l`_m:Nl;oBg_200?oBg_200Co
BW_2od]k`_m;Nl;oBg_20_m;O<84od]k`P03od]l`_m:Nl;oBg_200?oBg_2
00CoBW_2od]k`_m;Nl;oBg_20_m;O<84od]k`P04od]l`_m:Nl;oBg_2od]k
`P;oC7c20_m;Nl403Om;N/3oBgZood]j__m:NKkoBGRlodUg^om9Mk[oB7Fh
ong]kOo^k^kokno_oo7alOobl_800_oclo<2ooCdm004ooGemOofm_KomoOg
ooKfmW?omoOg00OofMWIom[Jf_oLg=cogMgMomoOgooPh>3ohN7Q00;oh^;R
00?ohn?SonGUiOoUiND00_oUiND3onKViP03onGUiOoVi^Koi^KV0?ooi^KV
GooVi^H00005ojZZZ_nQXJ7oCGg4odinaOm=O/@00om>O/D00om=OLCoCWk5
odena002odina@;oCGg40_m<O<<01Om<OL?oC7c3odam`om<O<?oC7g300?o
C7c300CoC7g3odal`om<O<?oC7g31?m<O<<01Om<OL?oC7c3odam`om<O<?o
C7g300?oC7c300CoC7g3odal`om<O<?oC7g31?m<O<<01Om<OL?oC7c3odam
`om<O<?oC7g300?oC7c300CoC7g3odal`om<O<?oC7g31?m<O<<01Om<OL?o
C7c3odam`om<O<?oC7g300?oC7c300CoC7g3odal`om<O<?oC7g31?m<O<<0
1Om<OL?oC7c3odam`om<O<?oC7g300?oC7c300CoC7g3odal`om<O<?oC7g3
1?m<O<<01Om<OL?oC7c3odam`om<O<?oC7g300?oC7c300CoC7g3odal`om<
O<?oC7g31?m<O<<01Om<OL?oC7c3odam`om<O<?oC7g300?oC7c300CoC7g3
odal`om<O<?oC7g31?m<O<<00om=OLCoC7c3odem``02odem``0;odel`_m<
O<7oC7_0odak`?m;N[ooBgZnod]i_Om:N;col_;boo?cloodm?@00_ofm_H2
ooShn0;on_[j0_okno/3ooclo003oogmoOolo?cooOgm00;oo?cl00CooOgm
ooclo?omoOgoo?cl0oomoOd00oolo?cooOgmooclo002oogmo@08ooclo?om
oOgoo?clooclo?omoOgoo?cloogmoOolo?`3oogmo@03ooclo?omoOgoo?cl
00;ooOgm00Soo?cloogmoOolo?coo?cloogmoOolo?cooOgmooclo0?ooOgm
00?oo?cloogmoOolo?`00_omoOd02?olo?cooOgmooclo?olo?cooOgmoocl
o?omoOgoo?cl0oomoOd00oolo?cooOgmooclo002oogmo@08ooclo?omoOgo
o?clooclo?omoOgoo?cloogmoOolo?`3oogmo@03ooclo?omoOgoo?cl00;o
oOgm00Soo?cloogmoOolo?coo?cloogmoOolo?cooOgmooclo0?ooOgm00?o
o?cloogmoOolo?`00_omoOd02?olo?cooOgmooclo?olo?cooOgmooclo?om
oOgoo?cl0oomoOd00oolo?cooOgmooclo002oogmo@04ooclo?oShn?oi>CT
onKViP;oj>SX0_oZj^X01?o[jn_ok>c/onc/k?o/k>coonk^kVSok^k^0000
1?ng]kOo[:b/oo_knoojn_X2oo_kn`05oo[jn_okno_on_[joo[jn_okno/0
0oojn_X3ooWin@kon?Sh00?onOWiooShn?ohn?P03Oohn?P00ooinOWon?Sh
ooShn00=ooShn003ooWinOohn?Son?Sh00gon?Sh00?onOWiooShn?ohn?P0
3Oohn?P00ooinOWon?ShooShn00=ooShn003ooWinOohn?Son?Sh00gon?Sh
1?oinOT01Oojn_[onOWiooWinOohn?SomoOg00;om_Kf01;omOGeoo?clooc
lo?ol_;bojFUYOn`/;3o^;Rhokno_oo7alOoc<c<om;Bd_oHf=Sog=cLon7Q
hOoShn?oi^KVonWYjOoZj^X2onc/k004on_[joo/k>cok>c/on_[j`Cok>c/
00?ojn_[onc/k?o/k>`00_o/k>`01?o[jn_ok>c/onc/k?o[jn/2onc/k003
on_[joo/k>cok>c/00;ok>c/00?ojn_[onc/k?o/k>`00_o/k>`01?o[jn_o
k>c/onc/k?o[jn/2onc/k003on_[joo/k>cok>c/00;ok>c/00?ojn_[onc/
k?o/k>`00_o/k>`01?o[jn_ok>c/onc/k?o[jn/2onc/k003on_[joo/k>co
k>c/00;ok>c/00?ojn_[onc/k?o/k>`00_o/k>`01?o[jn_ok>c/onc/k?o[
jn/2onc/k003on_[joo/k>cok>c/00;ok>c/00?ojn_[onc/k?o/k>`00_o/
k>`01?o[jn_ok>c/onc/k?o[jn/2onc/k003on_[joo/k>cok>c/00;ok>c/
00?ojn_[onc/k?o/k>`00_o/k>`01?o[jn_ok>c/onc/k?o[jn/2onc/k003
on_[joo]kNgokNg]00?ok^k^00?okno_oo3`l?oalO400_obl_801?odm?Co
mOGeooKfm_ogmoL2ooShn0;on_[j0_olo?`2oogmo@;oo_knoooooomWoooo
o`0000Co[:b/oj:RX_oZj^[oj^[Z0_oYjNT01?oZj^[ojNWYon[Zj_oYjNT2
on[ZjP?ojNWY1OoXj>P2onOWi`04onSXj?oWinOoj>SXonOWi`;oj>SX00Co
inOWonSXj?oXj>SoinOW1?oXj>P2onOWi`04onSXj?oWinOoj>SXonOWi`;o
j>SX00CoinOWonSXj?oXj>SoinOW1?oXj>P2onOWi`04onSXj?oWinOoj>SX
onOWi`;oj>SX00CoinOWonSXj?oXj>SoinOW1?oXj>P2onOWi`04onSXj?oW
inOoj>SXonOWi`;oj>SX00Ko7alOob0P8?lO7aoo7alOob0P8?lO7al2ob0P
80;o7alO00Coj>SXonOWiooXj>SoinOW0_oXj>P03_oWinOoj>SXonSXj?oW
inOoZZZZofIVI_m7AdOoCTi>ogMgMooHf=Soj>SXonOWiooXj>SoinOW0_oX
j>P01?oWinOoj>SXonSXj?oWinL4onSXj0;oinOW00Coj>SXonOWiooXj>So
inOW0_oXj>P00ooWinOoj>SXonSXj002onSXj0CojNWY0_oXj>P2onOWi`;o
i^KV01;oiNGUonCTi?oTi>CoWIfMojJVY_n^[Zko]KFeokbl_?o3`l?oalO7
olg=cOoAdM7oe]KFomSHf?oKfm_og]kNon3Ph?oQhN43on3Ph003on7QhOoP
h>3oh>3P00Soh>3P00?ohN7Qon3Ph?oPh>000_oPh>000ooQhN7oh>3Pon3P
h008on3Ph003on7QhOoPh>3oh>3P00;oh>3P00?ohN7Qon3Ph?oPh>002?oP
h>000ooQhN7oh>3Pon3Ph002on3Ph003on7QhOoPh>3oh>3P00Soh>3P00?o
hN7Qon3Ph?oPh>000_oPh>000ooQhN7oh>3Pon3Ph008on3Ph003on7QhOoP
h>3oh>3P00;oh>3P00?ohN7Qon3Ph?oPh>002?oPh>001_oQhN7oh>3Pon3P
h?oPh>3ohN7Qon;RhP?ohN7Q00Coh^;Ron7QhOoShn?ohn?S0ooTi>@2onKV
iP;oinOW00?oj>SXonWYjOoZj^X00oo[jn/01?o/k>cokNg]ong]kOo]kNgo
onk^kVSok^k^00000onVYZKoWIfMooCdm004ooGem@04ooCdm?oemOGomOGe
ooCdm0ComOGe00?olo?cooCdm?oclo<00_oclo<01Ookno_oU9BDoeUIFOmI
FEWoFUYJ00CoFEUI00CoBTY:oeYJF_mIFEWoFUYJ0_mIFET00onRXZ;olo?c
ooCdm002oo?cl`03ooCdm?oclo?olo?c00?olo?c00?om?Cdoo?clooclo<0
1?oclo<01?odm?Colo?coo?cloodm?@5oo?cl`03ooCdm?oclo?olo?c00Co
lo?c00Com?Cdoo?clooclo?om?Cd1Ooclo<00oodm?Colo?coo?cl`04oo?c
l`04ooCdm?oclo?olo?cooCdm0Golo?c00Kom?Cdoo?clon][JgoShn?ol71
`OnRXZ82odQ8B003oo;bl_oclo?om?Cd00Golo?c00?om?Cdoo?clooclo<0
1?oclo<01?odm?Colo?coo?cloodm?@5oo?cl`03ooCdm?oclo?om?Cd00;o
m?Cd1?oemOD01?odm?ComOGeooGemOodm?@3ooGem@0>oijNW_nVYZKo[jn_
okNg]onn_[koaLG5ol_;booAdM7oeMGEomWIfOoMgMgoh>3Pon;Rh_oTi>@3
onKViP03onGUiOoVi^Koi^KV0?ooi^KVgooVi^H00004ojj^[_nTY:Cono_k
ooclo0_ono_k00Son_[joo_knoojn_[on_[joo_knoolo?coFUYJogQhN0;o
QhN700?oQXJ6ogQhN?n7QhL00_n7QhL01_n6QXKoQhN7ohN7Qon7QhOoC4a<
om3@d0Son_[j00?ono_koo[jn_ojn_X01?ojn_X01?okno_ol_;bon7QhOoi
nOT4oo[jnP05ono_kooalO7on_[jonOWioo`l?000oojn_X01_okno_on_[j
oo[jn_obl_;ohN7QooWin@?on_[j00?ono_koo[jn_ojn_X01?ojn_X00ook
no_on_[joo[jnP03oo[jnP04oo7alOoQhN7onOWioo_kn`Kon_[j00Cono_k
ol[:b_lP823o`l?31Oojn_X00ookno_on_[joo[jnP04oo[jnP03oo_knooj
n_[on_[j00Kon_[j00Cono_koo[jn_ojn_[on_[j0ookno/00oolo?cono_k
oo_kn`08oo_kn`0>oj>SXon^[Zko][Jfokjn__o6a/KocLg=om;Bd_oHf=So
gMgMon7QhOoUiNGoinOWon_[joo/k>`2onk^kP03ong]kOo^k^kok^k^0?oo
k^k^h?o^k^h00003ok^k^ona/K7on_[j00;ono_k00Con_[joo_knoojn_[o
no_k0_ojn_X01Ookno_on_[joo_knoojn_[ono_k00?on_[j00?ono_koooo
oom>CTh00_o`l?002?o5aLGoRHV9okFe]Oooooool?3`on7QhOn9RHWoh^;R
0_o`l?005on9RHWodm?Coo_knoojn_[ono_koo[jn_okno_oI6AToeeMGOok
no_on_[joo_knonVYZKo8b<Sojj^[_ojn_[ok>c/of][JolU9BGo;Rh^oc4a
<OnWYjOono_k00;on_[j01?oKFe]oemOGomGEeOo<c<cobHV9_mhN7Som_Kf
oo[jn_okno_okNg]ofYZJ_lU9BGo;Rh^oc4a<OnWYjOon_[joo_knoojn_[o
I6AT00;o8b<S01Wo92@Tochn?_mSHf?obLW9oo_knoojn_[ono_konc/k?m[
Jf_o9BDUobh^;_la<C7oYZJVoo_knoojn_[ono_kooCdm?n8R8SoEEEEogQh
N?oKfm_o<30`oj:RX_ojn_[ono_k00;on_[j00Gono_koo[jn_okno_on_[j
oo_kn`03oo[jnP;ono_k00Con_[joo_knoojn_[ono_k0_ojn_X01Ookno_o
n_[joo_knoojn_[ono_k00?on_[j0_okno/01?ojn_[ono_koo[jn_okno/2
oo[jnP0Aoo_knoojn_[ono_kok6a/Onl_;coa<C4olg=cOoDe=Cog=cLon;R
h_oWinOokNg]oo7alOofm_KonOWioo_knoomoOd0oooooooUooooo`0000?o
/K6aojNWYooZj^X00_oYjNT01?oZj^[ojNWYon[Zj_oYjNT3on[ZjP0>onWY
jOoZj^[ojNWYonWYjOoZj^[ojNWYon[Zj_oYjNWoo?clode=COolo?cok^k^
ohN7QolQCM42ode=8@0Moe]KFom=8Dgo820nogPPN?n7QhOoo?clohR8R?o2
`/;ojNWYon[Zj_oYjNWoj^[ZonWYjOmNGUkoF5QHon[Zj_oYjNWod];BobXZ
:_mYJFWoj^[ZonWYjOmXJ6So?Cdmokbl_?oTi>CoUIFEob4Q8Ong]kL00_oZ
j^X08omVIVKo=CDeok^k^ooYjNWo[jn_obd];On>SXkoj^[ZonWYjOmWIfOo
?Cdmokbl_?oTi>CoUIFEob4Q8Onh^;Soj^[ZonWYjOmNGUkoD51@omcLg?oI
fMWo_[jnoh20P?lU9BGoShn?on[Zj_oYjNWoJ6QXoc`l??nl_;coi>CToiJF
U_lP823o^;Rh00;ojNWY00WoNg]kobTY:OmlO7coQ8B4odm?Col_;booShn?
on[Zj_oYjNT00ooZj^X01ooYjNWoj^[ZonWYjOoYjNWoj^[ZonWYjOoZj^X0
0_oYjNT01?oZj^[ojNWYon[Zj_oYjNT3on[ZjP07onWYjOoZj^[ojNWYonWY
jOoZj^[ojNWYon[ZjP02onWYj@04on[Zj_oYjNWoj^[ZonWYj@?oj^[Z013o
jNWYon[Zj_nWYjOo/K6aokVi^Oo0`<3ob<S8olk>c_oCdm?ofMWIomkNg_oR
h^;oiNGUonSXj?o[jn_okNg]0_o^k^h00oo]kNgok^k^onk^kP3oonk^k^3o
k^k^00000on/[:coY:BTooGem@03ooGem@07ooCdm?oemOGomOGeooGemOod
m?ComOGeooCdm007ooGem@0@ooclo?n6QXKok>c/ong]kOmhN7So7gOkoamg
comJFU[oBam;od];Bon7QhOoC21<oiFEUOo]kNgoN7Qholo?c`;omOGe00ko
m?CdooGemOoemOGoH61PoeUIFOoemOGom?CdoeUIFOlk>c_ojNWYooGemOoX
j>So7alOohR8R0;omOGe00Oom?CdocHf=_mXJ6SomOGeooCdm?mYJFWoH61P
00?omOGe00OoHV9Rod10@?oemOGoj>SXob0P8?n8R8Som?Cd00;omOGe00Ko
=CDeofMWIooemOGom?Cdof1PH?mGEeL4ooGem@0;oiBDU?lV9RKof=SHonOW
iolO7aooRHV9ooGemOodm?ComOGeocDe=OmXJ6P00_oemOD01olk>c_oS8b<
ooGemOoemOGof][Job/[:onBTY800ooemOD00oodm?ComOGeooCdm009ooGe
m@07ooCdm?oemOGomOGeooGemOodm?ComOGeooCdm009ooGem@0FooCdm?oe
mOGomOGeooGemOodm?ComOGeooCdm?oemOGoY:BTojb/[?nd];Co^k^kol71
`Oo7alOocLg=om;Bd_oFe]Kof][JomkNg_oPh>3oh^;RonCTi?ooi^KViOoV
i^H00003okBd]?n/[:cono_k017ono_k013oo?clode=COo^k^kogmoOoc0`
<?lPN?co8GWmodeidOln?SkoUYJFojFUYOln?SkogmoOonk^k_n7QhOodM7A
1Ookno/01_mSHf?oG5aLoo_knonRXZ;o8b<SolW9b@;ono_k00?od=3@ob0P
8?o0`<000ookno/01_mZJV[oCDe=oo_knookno_oK6a/of=SH`?ono_k00Ko
UYJFob@T9?ohn?Sod=3@ob0P8?o0`<03oo_kn`06ofYZJ_m=CDgono_koo_k
nomTI6CoFEUI1?okno/01_oclo?o:2PXohf=SOo@d=3o820Pol30`0?ono_k
00KoJVYZode=COokno_of][Job4Q8Oo0`<03oo_kn`03ocTi>OnFUYKono_k
02Kono_k00ko[:b/ok>c/onl_;co`l?3olW9bOo?clooe]KFom_KfooOgmoo
h^;RonKVi_oXj>Sojn_[ong]k@?ok^k^00?okNg]onk^k_o^k^h0ooo^k^kO
onk^kP0000?oa<C4ok^k^ookno/00_okno/01Oojn_[ono_koo[jn_ojn_[o
no_k00;on_[j00?ono_koo[jn_ojn_X00_okno/02Oojn_[ono_koo_knooo
ooooCdm?oo3`l?m?CdooCb=?ob<S<P02od10@00;ob=?Com>8Tko<B<Sob<S
8om?Cdooa<C4ohZ:R_o5aLGono_koo[jn_okno/00_ojn_X01_mUIFGo<c<c
oeiNG_l/;2coOWinoo[jnP;ono_k00coh>3Pob<S8onWYjOono_koo[jn_ok
no_oDU9BoeeMGOokno_on_[jofe]KOmUIFD2oo[jnP08oo_knon7QhOo>c/k
oo_knooQhN7o8b<SojNWYookno/2oo[jnP06oe=CDomNGUkon_[joo_knomT
I6CoFe]K0_okno/02Oojn_[ono_koo_knom7AdOoK6a/on7QhOlR8R;oYjNW
oo_kn`02oo[jnP06oe=CDomMGEgon_[jomoOgolS8b?oZJVY0ookno/01Olk
>c_oUiNGoo[jn_ojn_[ono_k00;on_[j00?ono_koo[jn_ojn_X00_okno/0
1_ojn_[ono_koo_knookno_on_[joo_kn`;on_[j00Cono_koo[jn_ojn_[o
no_k0_ojn_X2oo_kn`06oo[jn_okno_ono_koo_knoojn_[ono_k0_ojn_X0
4ookno_on_[joo[jn_okno_on_[jok^k^oo4a<Coc<c<om?CdooJf][oh>3P
onKVi_oZj^[okno_oo;bl_ofm_Kon_[joo_knoomoOd0oooooooUooooo`00
00?o^KViok:b/_oZj^X00_oYjNT5on[ZjP04onWYjOoZj^[oj^[ZonWYj@;o
j^[Z01GojNWYon[Zj_oZj^[ojNWYooclo?n7QhOoNDeiogQ<N?n8R8SoUYJF
ogQhN?m=CB7o8DgAob1hd?m=8GWo8B4QogQ<N?m=CDgoQhN7om3@d?oYjNT0
1?oZj^X07OmNGUko@d=3oi6ATOmNGUko<30`oj6QXOoZj^[ojNWYonSXj?lk
>c_oIVIVonWYjOoZj^[og]kNob@T9?n:RX[oj^[ZonWYjOmVIVKo=CDeolG5
aOoZj^[oi^KVodY:B_m`L73oj^[ZonSXj?lk>c_oIfMW00;oj^[Z00?og]kN
ob@T9?n9RHT00_oZj^X01?mNGUkoEEEEon[Zj_oYjNT2on[ZjP0DonWYjOm8
B4SoEeMGonSXj?lk>c_oIfMWon[Zj_oYjNWog]kNob@T9?n:RX[oj^[ZonOW
ioli>CWoIFEUon[Zj_oYjNWohN7Qoc0`<?n<S8`3on[ZjP04onWYjOoZj^[o
j^[ZonWYj@;oj^[Z00?ojNWYon[Zj_oZj^X00_oYjNT5on[ZjP04onWYjOoZ
j^[oj^[ZonWYj@;oj^[Z00?ojNWYon[Zj_oZj^X00_oYjNT5on[ZjP0BonWY
jOoZj^[oj^[ZonWYjOnb/[;o^KViol30`?o7alOocLg=om;Bd_oGemOog=cL
on7QhOoShn?oinOWonWYjOoZj^[ok>c/ooo^k^kUonk^kP0000?o]KFeojj^
[_oemOD01?oemOD00oodm?ComOGeooGem@02ooGem@03ooCdm?oemOGomOGe
00;om?Cd0ooemOD02oolo?coFUYJod/OBoo?7looN4]hogMgMol^823oXgLO
olnS7olPN=3o7gO?00;oXanS00?o`L71ohN7Qoo?cll00ooemOD04_odm?Co
mOGeof1PH?mJFU[omOGeooCdm?n7QhOo9BDUonSXj?odm?ComOGeok^k^olY
:BWoCDe=ogmoOol_;booBd];onk^kP;omOGe00OoJFUYoe9BD_m<C4coGemO
ocTi>OlR8R;o_Kfm00;omOGe00_o^k^kobTY:Om=CDgoOgmooc0`<?m<C4co
k^k^ooGemOodm?CoHF5QoeMGE`02ooCdm0;omOGe01Golo?cob`/;?mdM7Co
mOGeokZj^_lY:BWoCDe=ogmoOol_;booBd];onk^k_oemOGom?Cdok>c/olU
9BGoDE5AohN7Qom>CTko:2PXoi>CToodm?@01?oemOD00oodm?ComOGeooGe
m@02ooCdm0KomOGe00?om?CdooGemOoemOD00_oemOD00oodm?ComOGeooGe
m@02ooCdm0KomOGe00?om?CdooGemOoemOD00_oemOD03_odm?ComOGeojn_
[one]KGo^k^kol;2`_o8b<SocLg=om;Bd_oEeMGofMWIomcLg?oOgmoohN7Q
0_oTi>CoonKVi^Goi^KV00000ono_koo^KVioo_kn`0Aoo_kn`0@ooclo?m=
CDgodM7AoeaLG?lQ8B7o820PoddQCOmiNB7ooM4QojAh8?mi8GWodB7mogTQ
NOmiCGWoQhN7ol;2`PGono_k00OoHf=SoeaLG?okno_ono_kolc<c?lQ8B7o
_Kfm00?ono_k00Gog]kNoiVIVOn6QXKo[:b/ooShn003oo_kn`06ofa/K?mT
I6CojNWYoj>SXon;Rh_oc<c<1?okno/01OoNg]koVIVIohJ6Q_n/[:comoOg
00?ono_k00?oHf=SoeUIFOokno/00ookno/00on[Zj_o820PokFe]@02oo_k
n`05omkNg_nIVIWoQXJ6ojb/[?ohn?P01?okno/01_oEeMGoT92@oiFEUOoQ
hN7oZJVYom3@d2Oono_k00co^KViol30`?o6a/Kobl_;om7AdOoFe]KofMWI
omkNg_oRh^;oi>CTonSXj?oZj^X2onc/k003onk^k_o]kNgok^k^0?ook^k^
h_o^k^h00006om7AdOo:b/[ono_koo_knoojn_[ono_k0oojn_X01Ookno_o
n_[joo_knoojn_[ono_k00;on_[j00Kono_koo[jn_okno_ono_koooooon9
RHT2oo3`l00>od10@?nW8jOoNdmkog/SNomk8W_oCb=?ojMk8ola<C7odm?C
oo3`l?n:RX[odm?Coo[jn_okno/3oo[jnP09ofEUIOmMGEgono_komWIfOm[
Jf_o;Bd]ono_kookno_on_[j00;ono_k00?on_[joo_knoojn_X00_ojn_X0
1Ookno_on_[jofe]KOmTI6Cono_k00;on_[j00Kono_koo[jn_okno_ono_k
oo[jn_okno/3oo[jnP0=oo_knoojn_[ono_koo[jn_mTI6CoFe]Koo[jn_og
moOoh>3Poi^KVolZ:R[oGEeMoo_kn`03oo[jnP05oo_knoojn_[ono_koo[j
n_okno/00_ojn_X01_okno_on_[joo_knookno_on_[joo_kn`?on_[j00Go
no_koo[jn_okno_on_[joo_kn`02oo[jnP06oo_knoojn_[ono_koo_knooj
n_[ono_k0oojn_X01Ookno_on_[joo_knoojn_[ono_k00;on_[j00Kono_k
oo[jn_okno_ono_koo[jn_okno/3oo[jnP0Coo_knoojn_[ono_koo[jn_ok
no_ob/[:om3@d?oGemOog=cLon;Rh_oWinOojn_[ono_kooclo?om_KfooSh
n?okno_oo?clooknoP3oooooonGooooo00001?o7alOo`<30on[Zj_oYjNT5
on[ZjP06onWYjOoZj^[oj^[ZonWYjOoZj^[ojNWY0_oZj^X02OoYjNWoj^[Z
onWYjOomoOgoG5aLonk^k_nUYJGo;bl_oe]KF`02om4Qd@04oj@PY?lQCGWo
d:@PohN7Q`;ok^k^00?oQhN7om3@d?oZj^X01?oZj^X01_mNGUko8b<SobLW
9olQ8B7oBd];oibLW0;oj^[Z00?ojNWYon[Zj_oYjNT01OoZj^X01_oYjNWo
j^[ZofIVI_mNGUkoj^[ZonWYj@;oj^[Z00?ojNWYon[Zj_oYjNT01OoZj^X0
3?oYjNWoj^[Zon[Zj_oYjNWoGUiNob8R8_lY:BWo8R8Rob@T9?lk>c_oQXJ6
onOWi`Coj^[Z00KojNWYon[Zj_oZj^[ojNWYon[Zj_oYjNT2on[ZjP03onWY
jOoZj^[ojNWY00Goj^[Z00KojNWYon[Zj_oZj^[ojNWYon[Zj_oYjNT2on[Z
jP03onWYjOoZj^[ojNWY00Goj^[Z00KojNWYon[Zj_oZj^[ojNWYon[Zj_oY
jNT2on[ZjP03onWYjOoZj^[ojNWY00Goj^[Z01?ojNWYon[Zj_oZj^[ojNWY
on[Zj_o0`<3oalO7olg=cOoAdM7oeMGEomWIfOoMgMgohN7Qon?ShooVi^Ko
j>SXon[Zj_o/k>cokNg]00;ok^k^00?okNg]onk^k_o^k^h0ooo^k^kPonk^
kP0000Ooa<C4okno_ooemOGomOGeooCdm?oemOGom?Cd00ComOGe00Gom?Cd
ooGemOoemOGomOGeooCdm004ooGem@0<oo_knom;Bd_ok>c/ohJ6Q_m<C4co
N7Qhod];Boo?7looFUYJoam;MolPC7SoQXJ60_o]kNd01On6QXKo`L71ooCd
m?oemOGom?Cd00;omOGe00Coi>CTom_KfooKfm_oinOW0_oemOD00oodm?Co
mOGeooGem@02ooGem@03ooCdm?oemOGom?Cd00ComOGe00GoQXJ6oh20P?oe
mOGomOGeooCdm004ooGem@03ooCdm?oemOGom?Cd00ComOGe00?om?CdooGe
mOoShn<00_oKfm/01ooMgMgolO7aooGemOoemOGom?CdooGemOodm?@01?oe
mOD01Oodm?ComOGeooGemOoemOGom?Cd00ComOGe00?om?CdooGemOodm?@0
1?oemOD01Oodm?ComOGeooGemOoemOGom?Cd00ComOGe00?om?CdooGemOod
m?@01?oemOD01Oodm?ComOGeooGemOoemOGom?Cd00ComOGe00?om?CdooGe
mOodm?@01?oemOD04Oodm?ComOGeooGemOno_koo`l?3olS8b?o<c<cod=3@
omCDe?oGemOof][JomcLg?oOgmoohN7Qon?ShooTi>CoiNGU00?oi^KV00?o
iNGUonKVi_oVi^H0oooVi^KOonKViP0000?oc/k>ol[:b_okno/01_okno/0
0oolo?cono_koo_kn`08oo_kn`0<ooclo?n8R8Sok^k^onk^k_o]kNgok^k^
ol;2`_miCGWooOgmonk^k_nUYJGoUYJF0_o^k^h00on7QhOodM7Aoo_kn`04
oo_kn`03ooclo?okno_ono_k00gono_k00?oo?cloo_knookno/03Ookno/0
0oolo?cono_koo_kn`0=oo_kn`03ooclo?okno_ono_k00gono_k00?oo?cl
oo_knookno/03Ookno/00oolo?cono_koo_kn`0=oo_kn`03ooclo?okno_o
no_k00;ono_k00kob/[:olk>c_oBd];oemOGom[Jf_oNg]koh>3PonCTi?oV
i^KoinOWonWYjOo[jn_ok>c/ong]kOook^k^iOo^k^h00004on;Rh_oMgMgo
no_koo[jnP;ono_k00Gon_[joo_knoojn_[on_[joo_kn`02oo[jnP0:oo_k
noojn_[ono_koo_knoojn_[ono_koo[jn_ooooooCdm?ooooo`Kol?3`00?o
lO7aoo3`l?oalO400_o`l?001_n9RHWodm?Coo_knookno_on_[joo_kn`;o
n_[j00Gono_koo[jn_ojn_[ono_koo[jnP02oo_kn`03oo[jn_okno_on_[j
00;ono_k00Gon_[joo_knoojn_[on_[joo_kn`02oo[jnP07oo_knoojn_[o
no_koo_knoojn_[ono_koo[jnP02oo_kn`05oo[jn_okno_on_[joo[jn_ok
no/00_ojn_X01ookno_on_[joo_knookno_on_[joo_knoojn_X00_okno/0
1Oojn_[ono_koo[jn_ojn_[ono_k00;on_[j00Oono_koo[jn_okno_ono_k
oo[jn_okno_on_[j00;ono_k00Gon_[joo_knoojn_[on_[joo_kn`02oo[j
nP07oo_knoojn_[ono_koo_knoojn_[ono_koo[jnP02oo_kn`05oo[jn_ok
no_on_[joo[jn_okno/00_ojn_X01ookno_on_[joo_knookno_on_[joo_k
noojn_X00_okno/01Oojn_[ono_koo[jn_ojn_[ono_k00;on_[j00oono_k
omgMgOoRh^;oiNGUonWYjOo/k>cokno_oo?clooemOGomoOgooWinOojn_[o
o?cloogmoOono_h0oooooooUooooo`0000Coe]KFom;Bd_oZj^[oj^[Z0_oY
jNT01?oZj^[ojNWYon[Zj_oYjNT2on[ZjP04onWYjOoZj^[oj^[ZonWYj@Co
j^[Z00Goo?cloda<C?n8R8SoQhN7ohR8R002ohN7Q`03ohR8R?n7QhOoR8R8
00;oQhN700CoR8R8ohN7Qon7QhOooOgm0_oYjNT01?oZj^[ojNWYon[Zj_oY
jNT2on[ZjP04onWYjOoZj^[oj^[ZonWYj@Coj^[Z0_oYjNT01?oZj^[ojNWY
on[Zj_oYjNT2on[ZjP04onWYjOoZj^[oj^[ZonWYj@Coj^[Z0_oYjNT01?oZ
j^[ojNWYon[Zj_oYjNT2on[ZjP04onWYjOoZj^[oj^[ZonWYj@Coj^[Z0_oY
jNT01?oZj^[ojNWYon[Zj_oYjNT2on[ZjP04onWYjOoZj^[oj^[ZonWYj@Co
j^[Z0_oYjNT01?oZj^[ojNWYon[Zj_oYjNT2on[ZjP04onWYjOoZj^[oj^[Z
onWYj@Coj^[Z0_oYjNT01?oZj^[ojNWYon[Zj_oYjNT2on[ZjP04onWYjOoZ
j^[oj^[ZonWYj@Coj^[Z0_oYjNT01?oZj^[ojNWYon[Zj_oYjNT2on[ZjP0<
onWYjOoZj^[od];BomGEeOoIfMWog=cLon3Ph?oQhN7oi>CTonGUiOoXj>So
jNWY0_o[jn/2ong]kOook^k^iOo^k^h00003om?Cdoo?cloom?Cd00ComOGe
00Com?CdooGemOoemOGom?Cd1?oemOD01?odm?ComOGeooGemOodm?@4ooGe
m@04ooCdm?oemOGomOGeooCdm0ComOGe00Com?CdooGemOoemOGom?Cd1?oe
mOD01?odm?ComOGeooGemOodm?@4ooGem@04ooCdm?oemOGomOGeooCdm0Co
mOGe00Com?CdooGemOoemOGom?Cd1?oemOD01?odm?ComOGeooGemOodm?@4
ooGem@04ooCdm?oemOGomOGeooCdm0ComOGe00Com?CdooGemOoemOGom?Cd
1?oemOD01?odm?ComOGeooGemOodm?@4ooGem@04ooCdm?oemOGomOGeooCd
m0ComOGe00Com?CdooGemOoemOGom?Cd1?oemOD01?odm?ComOGeooGemOod
m?@4ooGem@04ooCdm?oemOGomOGeooCdm0ComOGe00Com?CdooGemOoemOGo
m?Cd1?oemOD01?odm?ComOGeooGemOodm?@3ooGem@07olo?cooBd];oeMGE
omOGeooIfMWog=cLomgMg@02on3Ph004on;Rh_oShn?oi>CTonGUi@Coi^KV
00?oiNGUonKVi_oVi^H0oooVi^KOonKViP0000CogMgMom_Kfoohn?SonOWi
0_ohn?P01ooinOWon?ShooShn?ohn?SonOWiooShn?oinOT00oohn?P01?oi
nOWon?ShooShn?oinOT2ooShn007ooWinOohn?Son?ShooShn?oinOWon?Sh
ooWin@03ooShn004ooWinOohn?Son?ShooWin@;on?Sh00OonOWiooShn?oh
n?Son?ShooWinOohn?SonOWi00?on?Sh00ConOWiooShn?ohn?SonOWi0_oh
n?P01ooinOWon?ShooShn?ohn?SonOWiooShn?oinOT00oohn?P01?oinOWo
n?ShooShn?oinOT2ooShn007ooWinOohn?Son?ShooShn?oinOWon?ShooWi
n@03ooShn004ooWinOohn?Son?ShooWin@;on?Sh00OonOWiooShn?ohn?So
n?ShooWinOohn?SonOWi00?on?Sh00ConOWiooShn?ohn?SonOWi0_ohn?P0
1ooinOWon?ShooShn?ohn?SonOWiooShn?oinOT00oohn?P01?oinOWon?Sh
ooShn?oinOT2ooShn007ooWinOohn?Son?ShooShn?oinOWon?ShooWin@03
ooShn004ooWinOohn?Son?ShooWin@;on?Sh01;onOWiooShn?ohn?Son?Sh
ooWinOohn?SonOWiooShn?oJf][og=cLon3Ph?oQhN7ohn?SonKVi_oWinOo
j>SXonWYjOo[jn/2onc/k005ong]kOo^k^kok^k^onk^k_o]kNd0ooo^k^kR
onk^kP0000?okno_ong]kOo]kNd00_o^k^h01?o]kNgok^k^ong]kOo^k^h2
ong]k@05onk^k_o]kNgok^k^ong]kOo^k^h00oo]kNd2onk^kP04ong]kOo^
k^kokNg]onk^kP;okNg]00Gok^k^ong]kOo^k^kokNg]onk^kP03ong]k@;o
k^k^00CokNg]onk^k_o]kNgok^k^0_o]kNd01Oo^k^kokNg]onk^k_o]kNgo
k^k^00?okNg]0_o^k^h01?o]kNgok^k^ong]kOo^k^h2ong]k@05onk^k_o]
kNgok^k^ong]kOo^k^h00oo]kNd2onk^kP04ong]kOo^k^kokNg]onk^kP;o
kNg]00Gok^k^ong]kOo^k^kokNg]onk^kP03ong]k@;ok^k^00CokNg]onk^
k_o]kNgok^k^0_o]kNd01Oo^k^kokNg]onk^k_o]kNgok^k^00?okNg]0_o^
k^h01?o]kNgok^k^ong]kOo^k^h2ong]k@05onk^k_o]kNgok^k^ong]kOo^
k^h00oo]kNd2onk^kP04ong]kOo^k^kokNg]onk^kP;okNg]00Gok^k^ong]
kOo^k^kokNg]onk^kP03ong]k@;ok^k^00CokNg]onk^k_o]kNgok^k^0_o]
kNd02oo^k^kokNg]onk^k_o]kNgol?3`oo7alOodm?ComOGeooOgmoohn?So
n_[j00;ono_k00?oo_knoogmoOono_h0oooooooVooooo`0000?olo?cof][
JooWinL01?oWinL01?oXj>SoinOWonOWiooXj>P<onOWi`04onSXj?oWinOo
inOWonSXj0coinOW00Coj>SXonOWiooWinOoj>SX3?oWinL01?oXj>SoinOW
onOWiooXj>P<onOWi`04onSXj?oWinOoinOWonSXj0coinOW00Coj>SXonOW
iooWinOoj>SX3?oWinL01?oXj>SoinOWonOWiooXj>P<onOWi`04onSXj?oW
inOoinOWonSXj0coinOW00Coj>SXonOWiooWinOoj>SX0ooWinL01?m[Jf_o
K6a/ofi^K_m]KFd3ofm_K`;oL71`0_maLG45og9bLP03og5aLOmbLW;oLW9b
0?ooLW9bh?mbLW8000;om?Cd0_obl_800ooclo?ol_;boo;blP07oo;blP04
oo?cloobl_;ol_;boo?cl`;ol_;b00?olo?coo;bl_obl_801oobl_801?oc
lo?ol_;boo;bl_oclo<2oo;blP03oo?cloobl_;ol_;b00Ool_;b00Colo?c
oo;bl_obl_;olo?c0_obl_800ooclo?ol_;boo;blP07oo;blP04oo?cloob
l_;ol_;boo?cl`;ol_;b00?olo?coo;bl_obl_801oobl_801?oclo?ol_;b
oo;bl_oclo<2oo;blP03oo?cloobl_;ol_;b00Ool_;b00Colo?coo;bl_ob
l_;olo?c0_obl_800ooclo?ol_;boo;blP07oo;blP04oo?cloobl_;ol_;b
oo?cl`;ol_;b00?olo?coo;bl_obl_801oobl_801?oclo?ol_;boo;bl_oc
lo<2oo;blP03oo?cloobl_;ol_;b00Ool_;b0_nLW9`01?nMWIgoWinOoinO
WonOWil3oj6QX@?oXZ:R1?nSXj<00onRXZ;oXj>Soj>SX`3ooj>SXmooXj>S
0OmbLW800003ooOgmoofm_Ko5CnS00;o5CnS0_lE?j800olD?Z7o5CjQoa@m
X002oaDnX003oa@mW_lE?Yoo53fN00Wo53fN00Co5CfOoa@mW_lD?Iko5CfO
3?lD?Ih01?lE?Ioo53fNoa@mW_lE?Il<oa@mWP04oaDmWolD?Iko53fNoaDm
W`co53fN00Co5CfOoa@mW_lD?Iko5CfO3?lD?Ih01?lE?Ioo53fNoa@mW_lE
?Il<oa@mWP04oaDmWolD?Iko53fNoaDmW`Oo53fN4?m/K6`3ofe]K@CoKVi^
00CoKfm_og1`L?m`L73oL71`0_maLG43og9bLP;oLg=c0omdM7@00omeMGGo
M7AdogEeM@0[ogEeMOoooooo^Oooool1oj>SX`7oLW9b00000ooinOWon?Sh
obAD[P02obAD[P06ob=C[?lSDjgo8e>/ob=BZolSDjco8e:[0_lSDZX01OlR
DZ[o8e:Zob=CZ_lSDj[o8e:Y00?o8e:Z00Co8e:Yob=BZ_lRDZWo8e:Y0_lS
DZX01?lSDZWo8e:Zob9AZOlSDZT2ob=BZP08ob=BZOlSDZ[o8e:Zob=BZ_lS
DZWo8e:Zob9BZOlSDZT2ob=BZP04ob=BZOlSDZ[o8U6Yob=BZ@;o8e:Z00So
8e:Yob=BZ_lSDZ[o8e:Zob=BZOlSDZ[o8U:Yob=BZ@;o8e:Z00Co8e:Yob=B
Z_lRDJWo8e:Y0_lSDZX02?lSDZWo8e:Zob=BZ_lSDZ[o8e:Yob=BZ_lRDZWo
8e:Y0_lSDZX01?lSDZWo8e:Zob9AZOlSDZT2ob=BZP08ob=BZOlSDZ[o8e:Z
ob=BZ_lSDZWo8e:Zob9BZOlSDZT2ob=BZP04ob=BZOlSDZ[o8U6Yob=BZ@;o
8e:Z00So8e:Yob=BZ_lSDZ[o8e:Zob=BZOlSDZ[o8U:Yob=BZ@;o8e:Z00Co
8e:Yob=BZ_lRDJWo8e:Y0_lSDZX01_lSDZWo8e:ZolS8b?o8b<SoalO7olS8
b0;oalO70_o8b<P01?o7alOob<S8olO7aoo7alL2olW9b@05olS8b?o9bLWo
bLW9ol[:b_o9bLT00oo:b/X2ol_;b`05olc<c?o=cLgocLg=olk>c_o?cll0
0_o@d=02om7Ad@?od];B0_oCdm<]omCDe?oojNWY^OoYjNT1oj>SX`7oLW9b
0002ooooob3o<fZm2Ooooom8oc=Z_E?on_[joomeMGFiogEeM@7oXj>S0Omb
LW8000;ooooo3?liLl400oooooooR8R8odA4A006odA4A003oc<c<om4A4Co
A4A400?oA4A400?oVIVIocUc`OliLl40DoliLl5Cooooooooe=CD^OoDe=@1
oj>SX`7oLW9b0002ooooo`co<fZm00?oooooodA4A?mVIVH00omgMgL00omV
IVKoMgMgogMgM`05ogMgM`03oc<c<oo<c<co<fZm00oo<fZm00?o>fnoodYj
a?lcJ[d01?lcJ[d01OlmLL3o>g2ooc=Z_Om4M/;o?77000Ko<fZm00?o>fno
odYja?lcJ[d06?lcJ[d00olfK;koC7c5ocI/_P04oc=Z_@03ocU^_om4M/;o
<fZm00ko<fZm7?ojn_X00oofm_KolO7aoo[jnP04oo[jnP05ooCdm?ofm_Ko
n_[joo[jn_o`l?000_ojn_X2ooGem@03oo[jn_oalO7omOGe00[on_[j00?o
n?Shong]kOohn?P01?ojn_X00ooinOWokno_ooWin@3ooo[jn/Won_[j0OnS
Xj<1og9bLP000_ooool<obQL]`0<oooooolc<c?ok^k^onk^k_nk^k_oMgMg
ojZZZ_ooooook^k^omgMgOmgMgOogMgM0_o^k^h00omgMgOoc<c<obQL]`04
obQL]`03okg=j?o4d^_o:5bg00;o:5bg00[oO9_CoooooomcUM3o:5bgocIV
^onhbNOooOgnooCfnoo`m?[oNi_B0olXG;L01onda^Ko`]3ZolWFkOo^l_Wo
o?gnojVnh_l/GkP00_lXG;L01_lfI[_o^<WWoogmo_odm__ol?Cjog^KdP?o
:5bg00?o_LgXooooooooool00oooool00omWRlco]<KVokg=j003obQL]`03
ofR=c?ooooooPj7E00?o:5bg00Ko;V6ioj6hgooinogol_GjooGgnonda^H2
obQL]`05olgIk_ojnogok_;iom?Ml?mKP/P03OlXG;L=onWYj@07ok6a/OnI
VIWoVIVIoiVIVOnSXj?o/;2`omKFeP03onWYj@09okBd]?na/K7ojNWYonWY
jOn[Zj_oVYZJoinOWonYZJWoeMGE00;ojNWY00oo^k^koi^KVonKVi_o_[jn
okRh^?nLW9codm?ConWYjOnd];Co[jn_ojb/[?nNWYkoVIVIokRh^?oWinL0
0_oYjNT02_nd];Co/K6aonWYjOoYjNWoi^KVok^k^onJVY[oWIfMoibLW?nd
];@2onWYj@07om[Jf_nRXZ;oVIVIoijNW_o>c/koXJ6Qol?3``0=onWYjOoo
oooo^Oooool1oj>SX`7oLW9b0002ooooo`co<fZm00Kooooooc<c<ooooooo
k^k^ogMgMol0<l`2oc<c0008odA4A?lc03?o000RofH0I_mgMgOoooooogMg
Monk^k/5oc=Z_@07ol3Aj_o7e^go<fZmoc=Z_Om;NlCom?OkokG9i`02oc=Z
_@07okO:iooRjOGoH8_;ocU^_on8Z=SoooooofJ?c@02oc=Z_@07okS;j?oZ
koSoHhg<oc=Z_Om]U<ool_Gjohn]fP02oc=Z_@07okO:iooRjOGoH8_;ocU^
_on8Z=SoooooofJ?c@02oc=Z_@03ol3Aj_o>fnoo@GC100?o@GC100?o=fbn
okS;j?o0dNX00olcJ[d00onlc^WomOOkom_Tl`03oc=Z_@06ojJnh_o^l_Wo
LIOAocM/__lkKkooEX?80_lcJ[d01OmgW=?oAWS3oc=Z_OnN^=ooe>3a00go
<fZm3Oojn_X02?nf][Ko/;2`oo?clooalO7oiNGUolK6a_nJVY[oc/k>0_oj
n_X04Onj^[[o][Jfoo[jn_ojn_[ofMWIoo3`l?ojn_[oalO7ojf][Oojn_[o
k>c/oiVIVOoFe]Kol_;bol_;bonIVIWod];B00;on_[j00Oo^[Zjoj:RX_oS
hn?on_[jomkNg_nOWiooc/k>00;on_[j00[o^[ZjokJf]_ojn_[on_[jol?3
`onPX:3og=cLooShn?ofm_KojNWY0_ojn_X01onh^;SoZJVYonCTi?oYjNWo
^;RhoibLW?o<c<`0ooojn_[6oo[jnP7oXj>S0OmbLW8000;ooooo3?liLl40
4?ooooooMgMgonk^k_o^k^koIVIVo`1Vool0I/coA4A4oc<0<olc<c?oMgMg
oc<0<on8R8Sok^k^ofIVI_o<c<`5ocUc`@0;ol;Dk?o9fNko>G?1ocUc`Oo:
fNkoiNcfod=ja?liLl7oA7_4oooooonM^N000oliLl401_oZl?So^loYocUc
`OliLl7o^/kYol;Dk0?o>G?100Ko`=?[on7ZmOliLl7oA7_4oooooonM^N03
ocUc`@06on[`n?nkcnWo>G?1ocUc`Oo2e>cobm[^1OliLl403Onjc^Wo`]C/
ocUc`OliLl7oAWc5oo_loOn3YmSon?[mofBAc_liLl7o@7S3oocmo_nR_N80
2?liLl401?llML7o//SVon[`n?ljM<4<ocUc`@gooooo00?o^;Rhok>c/ooo
ool00oooool01_o@d=3oVi^Koo7alOoooooo_;blokRh^0Cooooo00_ooOgm
ol30`?nSXj?oo_knoo3`l?nIVIWogmoOooooooomoOgoVIVIomkNgP02oooo
o`03okbl_?nh^;Sooooo00;ooooo00[o^KViojRXZ?oooooooooookbl_?nh
^;Sooooooo_knonJVY[ob<S81Oooool00oomoOgoWYjNom;BdP02ooooo`03
oogmoOnRXZ;oclo?00gooooooooYjNVionWYj@7oXj>S0OmbLW8000;ooooo
3?lcJ[d01Ooooooo<c<conk^k_oMgMgo4A4A00;o06Ko00Wo<fK<ob8R8_n8
R8SoVIVIob8R8_oMgMgok^k^ogMgMoo<c<`01OlcJ[d01_o0dN[oamK]oc=Z
_On6Y]Ooo?gnof6;c0;o<fZm00?oFhO9oooooomZT/h00olcJ[d01_njc>So
eN3aoc=Z_OlcJ[go^<_Xol3AjP?o<fZm00KoTJkKoo_loOleJkgoFhO9oooo
oomZT/h3oc=Z_@06ok[<j?oEh?7o<fZmoc=Z_Oo0dN[ob]S]1OlcJ[d03Onh
bnSo`=7Zoc=Z_OlcJ[goQjOHonkbnOlfK;ko]LWWok35iOlcJ[goFHK9oooo
oon`aND00onI]=h02?n6Y]Oo<fZmoc=Z_OlcJ[goMicCon7YmOocm__oNYkD
3?lcJ[d00olbJKgon_[joo[jnP0;oo[jnP03okJf]_nb/[;on_[j00?on_[j
00Kom_KfoibLW?o8b<Son_[jokZj^_nf][H3oo[jnP04omWIfOnWYjOoWYjN
omSHf0;on_[j00Kobl_;oj:RX_nl_;coclo?oiVIVOoJf]X2oo[jnP03okZj
^_nf][Kon_[j00;on_[j00[ocLg=oiZJV_ohn?Son_[jokZj^_nf][Kon_[j
onOWionIVIWo_[jn0oo9bLT01OoBd];on_[jonOWionIVIWohN7Q00?on_[j
00?oXj>Solg=cOojn_X0ooojn_[5oo[jnP7oXj>S0OmbLW8000;ooooo3?lX
G;L01_oooooo<c<conk^k_lc<c?o<`0co`004@;o8R8R00So03<coc<0<olA
003o0000oc<c<onk^k_oMgMgok^k^`Go:5bg00Go_LgXonkbnOo3dN[omOOk
oj>ih003obQL]`03od9__oooooooNi_B00?o:5bg00Kocm__ol?BjolXG;Oo
:5bgokC6i_nmcNP3obQL]`06oi^cgOoWkOOo:5bgod9__oooooooNi_B0olX
G;L01_o?fnoo`m;[obQL]olXG;Oo_LgXolODk0Go:5bg00go]<KVokg=j?lX
G;Oo:5bgom;Ml?nQ^=oo:5bgoef4b?oemo_o<VBjod=a`?oooooo/lGU00;o
UZoK00Soe=o`olWFkOlXG;Oo:5bgohfXf?oko?goY;[Poce/_Pko:5bg3OoY
jNT00ona/K7o[Jf]onWYj@04onWYj@05ojJVY_nd];CojNWYokBd]?na/K40
0_oYjNT01?o3`l?oVYZJokZj^_oPh>04onWYj@05on?ShooCdm?ob/[:oiVI
VOo?cll00_oYjNT00ond];Co/K6aonWYj@02onWYj@0:okjn__nQXJ7ojNWY
onWYjOnd];Co/K6aonWYjOoNg]koVIVIokFe]@;o_kno00KoZ:RXojb/[?oY
jNWoh>3PoiVIVOo9bLT3onWYj@03oj6QXOo3`l?ojNWY00cojNWYooooooni
ooooo`7oXj>S0OmbLW8000;ooooo3?lcJ[d04?ooooooMgMgofHcI_mV<fKo
MgMgohR8R?mVIVKo<c<0o`0cc?l0I/co<`1Vo`000?mV<fKo<c<cogMgMoo<
c<`5oc=Z_@06ol3Aj_oKi??oS:_Iol3Aj_o_lo[oO9oD0_lcJ[d00oldJkgo
hn_fokO:i`02oc=Z_@03ocmc`Ooko?goTk3L00;o<fZm00_o^<_Xon_`n?mG
Q<So<fZmocM/__oCgo7o[/?Toc=Z_OldJkgohn_fokO:i`02oc=Z_@03ocmc
`Ooko?goTk3L00;o<fZm00?o`=7Zol[HkOlcJ[d01?lcJ[d01_nhbnSo`=7Z
oc=Z_OmCPLOooooooeV6b@;o<fZm00Goh>SeohFVeoldJkgohn_foijhg`02
oc=Z_@06om7Ml?n[`N?o<fZmoc=Z_OoCg_3oWkWP4?lcJ[d=oo[jnP03okJf
]_nb/[;on_[j00Con_[j00Go[:b/ok:b/_ojn_[o^[ZjokJf]P02oo[jnP03
ojf][Oo6a/Kon_[j00Con_[j00KonOWioo[jn_ojn_[okno_oiVIVOoShn<2
oo[jnP07okZj^_nRXZ;oj>SXoo[jn_ohn?So[Jf]okno_`02oo[jnP06okZj
^_nf][Kon_[jooWinOnUYJGoalO70_ojn_X01_n^[Zko`<30oo[jn_oinOWo
Z:RXokZj^P;on_[j00?omOGeoj2PX?o<c<`0ooojn_[6oo[jnP7oXj>S0Omb
LW8000;ooooo3?liLl402OooooooA4A4oc<0<oo<0<coIS=VofIVI_lA003o
VFH0olbI0002o`1Vc0;oV@2I00?o^k^kogMgMoo<c<`01OliLl401oo2e>co
bMW^ocUc`OliLl7oWk_Qoo[koOm3N/@00_liLl401om^V=7om_SlomGQlOnV
`>?ol?CjomGQl_loMl<00_liLl401onjc^Woc]c_omGQl_o3eNcoi^ggoo_l
o_m/Um400_liLl401om^V=7om_SlomGQlOnV`>?ol?CjomGQl_loMl<00_li
Ll400oo2e>cobm[^ocUc`@04ocUc`@05ok[>jOo2e>co>G?1oj:mh_oJiO<0
0oliLl402OnC/mgoen?bocUc`Om`V];olOGjojo7i_nndN[oloKkoeN8bP02
ocUc`@05ohn`g?oVkOOoV[SOoj[3i?moY=L03OliLl4=ooooo`03okRh^?nc
/k?ooooo00?ooooo00Koo_knoinOWoo1`L7ooooookbl_?nh^;P2ooooo`05
om;Bd_nUYJGoc<c<olC4a?oJf]X00_ooool01_nn_[ko/[:bol_;bona/K7o
Xj>SooknoP;ooooo00Oo_;blok6a/On^[Zko]kNgojFUYOnJVY[oi>CT00;o
oooo00[o_;blokRh^?ooooooooooon;Rh_nPX:3o`L71okZj^_nOWiookno_
0_ooool01ooRh^;oW9bLok6a/Oo:b/[o[:b/oifMWOo?cll03OooooooonWY
jKWojNWY0OnSXj<1og9bLP000_ooool<oc=Z_@04oooooolc<c?oc<c<odA4
A0;o000000[o<`0cofIV0?ooc03oVFH0ofH0I_o<0?ooIP1VofHcI_mgMgOo
^k^k1OlcJ[d01oo0dN[oamK]oc=Z_OlcJ[goGh[;oooooom]U<l00olcJ[d0
1Om>OLGoSZcJoj2jh?mlWmCo=Vbn00?o<fZm00Ko^<_Xol3Aj_m3ML;oQJKG
oi^fg_mOR//4oc=Z_@05odimaOn>[=[oX;[PogbOe?lfK;h00olcJ[d00oo0
dN[ob]S]oc=Z_@04oc=Z_@05of^Bcom_UM3o<fZmogNLdomRS<`00olcJ[d0
1Om2ML7oRJWHocU^_olcJ[goEH?800;oUk?M00WoDX37oc=Z_OlcJ[go<fZm
ocE[_OmSSLcoVkKNoiRdgOmLR<X03OlcJ[d=oo[jnP03okJf]_nb/[;on_[j
00?on_[j00Koe]KFoiVIVOoJf][on_[jomoOgooMgMd2oo[jnP05ooShn?oS
hn?ob<S8olW9bOoVi^H00_ojn_X01Ooclo?og]kNolW9bOoBd];ol?3`00?o
n_[j00Ko^[ZjokJf]_obl_;od];BolS8b?oUiND3oo[jnP03okZj^_nf][Ko
n_[j00;on_[j00CojNWYol[:b_o:b/[ojn_[1?ojn_X01_oXj>Sob/[:olc<
c?o^k^koXj>Solg=cOoon_[ja_ojn_X1oj>SX`7oLW9b0002ooooo`co:5bg
00OoooooogMgMoo^k^kok^k^ob8R8_nI09WoIS=V00;oIP1V00Oo<`0coiUV
0?lA4A7oc<c<onk^k_mgMgOoc<c<00Go:5bg00Oo_LgXolCBjolXG;OoB7C2
okO8ioodmo_o<VBj00_o:5bg00?o]<KVokg=j?lXG;L03olXG;L00onmcNSo
amC/obQL]`04obQL]`03odQd`Om9ML;o:5bg02;o:5bg3OoYjNT02?na/K7o
[Jf]onWYjOoWinOogmoOolG5aOnKVi_o[Zj^0_oYjNT00ooMgMgog=cLonWY
j@0@onWYj@03okBd]?na/K7ojNWY00KojNWY00?o];Bdok6a/OoYjNT03_oY
jNT00onQXJ7o`l?3onWYj@0<onWYjOoooooo^Oooool1oj>SX`7oLW9b0002
ooooo`co<fZm00KoooooodA4A?o^k^koVIVIoa4A4Om4A4@2ol`0c004oiT0
VOl0<fKoc9T0ogMgM`;ok^k^00?oMgMgolc<c?lcJ[d01?lcJ[d01_o0dN[o
o?gnooSjo?ono_koe>3aoh6SePco<fZm00?o^<_Xol3Aj_lcJ[d03olcJ[d0
0oo0dN[ob]S]oc=Z_@04oc=Z_@03okS;j?o0dN[o<fZm02;o<fZm3Oojn_X0
2?nf][KoVIVIoifMWOnIVIWoVYZJojFUYOo:b/[on?Sh0_ojn_X00onj^[[o
][Jfoo[jnP0@oo[jnP03okZj^_nf][Kon_[j00Kon_[j00?o^[ZjokJf]_oj
n_X03_ojn_X00onSXj?ocLg=oo[jnP3ooo[jn/Gon_[j0OnSXj<1og9bLP00
0_ooool<ocQa`009oooooolc<c?ok^k^ogMgMolc<c?oIVIVoc<c<oo<0<co
A4A400;o03=V00GoMgMgonk^k_o^k^koMgMgok^k^`05ocQa`004odMla?m?
PLOoCh77odEja0ko>77000?oWk[PojFnh_lhLL003olhLL000om7O<CoBGg5
ocQa`004ocQa`003odIka?m7O<Co>77002;o>7703Oooool01OogmoOolo?c
oo?clooclo?ooOgm00Gooooo0_ogmoLAooooo`03ol[:b_o7alOooooo00Ko
oooo00?ob/[:olO7aoooool03_ooool00ong]kOofMWIooooo`0<oooooooo
jNWY^OoYjNT1oj>SX`7oLW9b0002ooooo`co<fZm00?oooooogMgMoo^k^h0
0oo^k^h01_nk^k_oIS=Vooooooo^k^koVIVIohR8R0;ok^k^00?oMgMgolc<
c?lcJ[d0E?lcJ[gooo[jn_oon_[j3Oojn_X1oj>SX`7oLW9b0002ooooo`co
:5bg00?ooooooc<c<oooool02oo^k^h00omgMgOoc<c<obQL]`1DobQL]e?o
jNWYooooooniooooo`7oXj>S0OmbLW8000;ooooo3?lcJ[d00ooooooo<c<c
ogMgM`0<ogMgM`03oooooolcJ[go<fZm05?o<fZmooojn_[ooo[jnPgon_[j
0OnSXj<1og9bLP000_oooomaocUc`E?ooooooooYjNVionWYj@7oXj>S0Omb
LW8000;oooooLOldK;iCoooooooon_[j^Oojn_X1oj>SX`7oLW9b0002oooo
og7o:5bgDooYjNWooooookWooooo0OnSXj<1og9bLP00oooooooooooooh7o
oooo0OmbLW800?oooooooooooon2ooooo`00oomoOgmGogmoO`OoOWinoomo
OglTogmoO`0000Cojn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP3oomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgM000FomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oLg=cogMgMom_Kf`;og=cL03?ogMgMomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]h00_oLg=`01OoIfMWof=SHomOGeooHf=SofMWJ00;og=cL
02?og]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNgP02omgMg@3aomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMgP03omkNgP03omgM
gOoNg]kog]kN00?ogMgM0OoQhN41onOWi`7oj^[Z00000oo/k>coi^KVon3P
h007omWIf@04omSHf?oFe]Kodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOo
f=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOG
omSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOG
eooHf=SKomWIf@;of=SH00Koe]KFom?CdooCdm?oe=CDomOGeooHf=P2omWI
f@03omSHf?oIfMWofMWI00;of=SH2OoIfMT00ooHf=SofMWIomWIf@02omSH
f003omWIfOoHf=Sof=SH00;of=SH5ooIfMT01?oHf=Soe]KFom;Bd_o?cll2
olg=c@04olo?cooCdm?oemOGomSHf?oofMWI5_oIfMT00ooHf=SofMWIomWI
f@06omWIf@7og]kN0OoVi^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7Q
hOoPh>3oh^;R00;ohN7Q00gog]kNomcLg?oCdm?oalO7ok^k^onb/[;o[Zj^
ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?o
alO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q
00gogmoOom_KfooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?C
dooKfm_ogmoO0=[ohN7Q00Woh>3PomoOgooKfm_oe]KFomCDe?oFe]Kof][J
omkNg_oPh>001_oOgml3on3Ph003omoOgooPh>3oh>3P00;oh>3P2?oOgml2
omkNgP;ogmoO0ooPh>02omoOg`;oh>3P0_oOgml=on3Ph005omoOgooMgMgo
fMWIomGEeOoCdm<00_oBd]800ooFe]Kog=cLon3Ph03oon7QhASohN7Q00?o
h^;Ron7QhOoRh^801?oQhN41onCTi07ojNWY0Oo]kNd00003oo3`l?o_knoo
lO7a00?ol?3`0?ookno_oo3`l?o^k^kojNWYom_Kfoo1`L7oY:BTohb<S?mk
Ng_oMgMgog]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_oNg]k
ogMgMomkNg_oS8b<ojBTY?o2`/;of][Jon[Zj?o]kNgolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ong]kOoZj^[of][Jol;2`_nTY:CoS8b<og]kNomg
MgKoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knl001_o
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo^k^kokno_on[Zj_oWinL00_oPh>001ooShn?ojn_Yon_[jooZj^[oi^KV
onSXj?oWinL00_oYjNT04_o^k^cok>c/onc/k?oXj>Sok>c/ong]kOo`l?3o
k>c/on[Zj?oVi^Koj>SXonOWiooYjNWoj>SXon_[jooWinOoinOUonGUi@;o
jNWY00ook^k^ong]kOo]kNgoj>SXon_[jOo/k>cok^k^onWYjOoZj^[ojn_[
ono_koo/k>cok>cZon[Zj_o^k^h00_o/k>`0oooZj^[okno_onc/k?o/k>[o
j^[Zonk^k_o/k>co[jn_ogIfM_mIFEWoKVi^okNg]_oPh>3ojNWYong]kOoa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aonk^k_oalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_k`00;OoalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNool?3`ono_koo`l?3okno_
oo3`l?o_knool?3`ono_k`04oo3`l00000?ol_;bonk^k_oWinL01?oUiND0
4?oTi>CogmoOom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5A
ofIVI_n:RXWo/K6aom7AdOoNg]h2onCTi003onGUiOoTi>CoiNGT00;oi>CT
00oog]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIV
I_n:RX[o/K6aom7Ad?oNg]h00_oTi>@0kOoUiNGoi>CTonGUiOoTi>Coi>CS
omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKo
RXZ:ok6a/OoAdM7og]kNonCThooTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi002onCTi03oolG5aOlX:2So
A4A4oi2@T?oAdM7og=cKom_KfooGemOoe=CDomKFe_oDe=CoeMGEomWIfOoP
h=oog]kNom[Jf_oDe=CofMWIomgMgOoRh^;og=cLomOGe_oDe=Coe]KFomCD
e?oEeMGof=SHom_KfooGemOoe]KEomGEeOoGemOof=SHomkNg_oOgmoog=cL
omGEeOoGemKog=cLomgMgOoGemOoe]KFom_KfooQhN7og]kNom_Kf_oJf][o
g]kNomcLg?oJf][ofm_Kon3Ph?oOgmoog=cKomWIfOoNg]kogmoOogAdM?mW
IfOoSHf=oeADE?l820SoXZ:RomcLg?oRh^;oiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CT001HonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi0CoiNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o]
kNd1oo;blP0000?om?Cdong]kOoWinL00_oPh>004ooQhN7ogmoOomkNg_oB
d];o];BdohN7QomLG5coKC/eoii>@_o=KeoojH=_ole_GonNCT?oKC/foeaL
G?n7QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aL
ofeP;?nNURkocLdoonWYCOo=cCooWYX_ofeS;OmLG5coQhN7okBd]?oBd];o
g]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m7IbkoJ9hcoi7=AonZ
jEGoTLe7ofZN=?m9JRooG5aLohN7Qond];Cod];BomkNgP3Ion3Ph006omoO
goo?clooVIVIoi:BT_lI6AWoS8b<0_oEeMD07oo?cloo`/;2olk>c_o>c/ko
aLG5ol[:b_oJf][of=SHom3@d?o;bl_oclo?omSHf?oJf][oeMGEolo?coo1
`L7od=3@olk>c_o4a<Cobl_;omSHf?oGemOo_[jnok^k^ooAdM7od=3@omGE
eOoHf=Sodm?Colc<c?o>c/h00_oEeMD01Oo>c/koc<c<om?CdooJf][of=SH
00;od];B00Cof=SHomOGeooAdM7odm?C0_oIfMT01_oCdm?odM7AomOGeooH
f=SodM7Aom3@d0;odM7A00CoATI6od51@OoGemOog]kN8ooPh>000ooOgmoo
h>3Pon3Ph003on3Ph003omoOgooPh>3oh>3P0>Woh>3P00?ogmoOon3Ph?oO
gml00_oOgml3on3Ph003on7QhOoWinOok>c/007om?Cd00000oofm_Kol_;b
on_[j`03onSXj00ConOWiooRh^;ocLg=oinOWom[GeooScH^oneaHOoiWI3o
oK6Uoofl[oom]:OonInConedHonB=booJemOoinOWoo=cLgoh^;RonOWi`03
onSXj00ConOWiooRh^;ocLg=oinOWom^IUooTg8RongAA?oilgCooOf=oogm
UOomoHkonOQfongGAonCLb;oKVMOoinOWoo=cLgoh^;RonOWi`03onSXj00C
onOWiooRh^;ocLg=oinOWomPJ5ooBg`Soi;QBonmnG_od?fBomSmVooDoIGo
`?UnoiSXCOm=P2CoH6UOoinOWoo=cLgoh^;RonOWi`3JonSXj004onKVi_oQ
hN7oGEeMode=C@;ogMgM01ooD51@o`L71olE5AGoQ8B4oaHF5_m3@d?oh^;R
omgMgOnLW9co0000ohn?SooMgMgohN7Qom_Kfom0@43o20P8oaTI6On8R8So
2`/;oeQHF?ng]kOo30`<o`L71olS8b?o9bLWogemOOoJf][ogMgMomCDe?l;
2`_oFEUI00;ofMWI00?oGEeMo`/;2ooCdm<00_oOgml01_mJFU[oCTi>omkN
g_oNg]ko8b<SohB4Q0;ohN7Q00coNWYjobh^;_oMgMgogMgMol;2`_m@D53o
<c<cofi^K_n3Ph?o8B4QomkNg_oVi^KoonSXj1ooj>SX0Oo/k>`1oo;blP7o
m_Kf00000oogmoOon?ShooShn003ooShn00CooOgmoo^k^koc/k>oi2@T?n5
;b_ojFAFoo^BQoonYY_oo[6UoonhZoon/jKooZRLoo^DROo^J5WoRC4[oi2@
T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dm
oo_PK_onm8;oo_j:ooooT_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/ko
k^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2
oXSoc_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^ooOg
m`3JooShn00UooKfm_oalO7oPH61oalO7oo]kNgoa/K6o`000?o3`l?odm?C
oeaLG?l820Soj^[Zoo3`l?oZj^[oDU9Boa@D5?lm?CgojNWYoo3`l?n_[joo
1`L7om;Bd_o=cLgoCTi>oa/K6oo^k^kofm_Kojj^[_oXj>Sok>c/ojj^[_l0
003o];Bdonc/k?n`/;3o2`/;oaXJ6P02onCTi00;ob<S8ol>3PkoY:BTong]
kOo^k^koH61PoeADE?o^k^kokNg]obHV9_n=SHd00_o`l?003?n2PX;o<C4a
onc/k?oZj^[o@d=3obl_;onLW9coLg=cobXZ:_lJ6Q[ok^k^ooKfm_oon?Sh
6?ohn?P00oogmoOon?ShooShn002ooShn004ooOgmooinOWomoOgooOgm`7o
n?Sh00000oojn_[omOGeonk^kP02onc/k03oon_[jooYjNWogmoOokZj^_mi
DU;o_c8TonMdJOomRGkooiR<oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c
9?miDU;o^[ZjomoOgooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EB
on:A7?oi`e3ooMYSoooZL_onlgkoooZ2ookfOoook7?oo]iToo[7DOoRTQco
RFICokZj^_oOgmooj^[Zon_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]D_mA
XacoTM9EojKWJ_nhnG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]
D_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/0019onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/onWYjOoUiNGoNWYj
oa`L7?oQhN;oc<c<o`<30onPX:3og]kNoiBDU?lC4a?ohN7Qon3PhOo@d=3o
1PH6oj6QXOl92@Wo_knoon3Ph?nj^[[o0P82ok:b/_oMgMgoP820obPX:?oS
hn?oinOWonGUiOoOgmoofm_Kom?Cdol820SoQHF5omoOgomYJFWoBTY:ocDe
=On][Jgo_Kfmo`L71omhN7SoEEEEomoOgooPh>3oFe]Koe1@D002on7Qh@0:
ob@T9?n5QHGogmoOon7QhOmkNg_o;bl_on3Ph?oDe=Co1@D5ojRXZ0;ohn?S
0?ooOWiooaHF5_oQhN7oj^[Zon_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn/001[ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k0Kojn_[00Gok>c/on_[joo[jn_ok^k^ooKfmP01ooShn00000?ono_k
oo?cloo]kNd00_oUiND0oooVi^Koi>CTomWIfOnb/[;oNBh^olQ2=?oSJUco
m7Y]oof8O?onUh[ooY^>oojHRoonRWkom7]]onM[GOo:@SCoNbh^ok:b/_oH
f=Soi>CTonGUiOoVi^KoiNGVonCTi?oHf=So/[:boiIE;_oZW2_onka4ook<
Doomf6;oo^=bookYMOoniW?oo]]Uoog<Dook`DGokYh[oiUF;_nb/[;of=SH
onCTi?oUiNGoi^KVonGUiOoTi>Cof=SIok:b/_l^HRkoHjd[ohO:B?nGg5Wo
YNEYok;cMonhmW_o]?EiojOZJonHg5WoRLm;of>^:ol^Hbko/[:bomSHfOoT
i>CoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
iP00=?oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oShn?ogmoOogMgMolK6a_og=cLon7Q
hOnNWYko;bl_ob/[:olb<S;o4Q8BomcLg?oJf]_oQ8B4ob0P8?oPh>3oDU9B
ofQXJ?oJf][og]kNoi2@T?lZ:R[o;Rh^ob`/;?lW9bL2omkNgP0ComWIfOoC
dmCod=3@oe]KFol0003o_Kfmom[Jf_lX:2SoQhN7ogMgN?mXJ6SoPX:2oc`l
??o2`/;o3`l?omCDe?oJf][oFEUIodi>CP02omcLg00iob<S8on1PH7oeMGE
omOGeomgMgOo;Rh^omcLg?nSXj?o0000olO7aooHf=SofMWIohf=S_lE5AGo
g=cLonCTi?oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Koi>CT00;oiNGU0>[o
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNH2onKViP03onGU
iOoVi^Koi^KV00?oi^KV00?oiNGUong]kOoclo<00Ookno/00003ooclo?oh
n?SolO7a00?ok^k^01?ojn_[on7QhOnl_;coNQLGol<o<_oCETWoi6QJonmg
K?odPgWon8MlooF4N_ocNFgoiFUKomUHB_o4?c;oO1LGokbl_?oQhN7ok>c/
00?ok^k^01?ok>c/on7QhOnl_;coYDLGonJG<_oe[33ooKa1oog9Doomd63o
nm=UoogBH?oncECooKe2ooZ_<_oYVc;oYDHGokbl_?oQhN7ok>c/00?ok^k^
01?ok>c/on7QhOnl_;co5eTGoenX<_mf_COoQ/e7oiKFF_nRh6GoXn1Yoj?Q
IonGfUcoQ/i7ogNo=omOZc;o5eTGokbl_?oQhN7ok>c/0=[ok^k^02kok>c/
onOWiomkNg_o71`LonCTi?oYjNWoi^KVon7QhOoNg]koSHf=oa@D5?oVi^Ko
i>CTocDe=OmiNGWojn_[ok:b/_lE5AGogmoOonKVi_oTi>CohN7QomgMgOmj
NW[o:BTYonSXj?oUiNGogMgMok6a/OlV9RKo2`/;oi^KVooYjNWoc<c<o`00
0?o>c/ko`l?3obDU9Om;Bd_oO7alonSXj?la<C7oYJFUonCTi?mMGEgoDE5A
0_oWinL02_lU9BGoJFUYomoOgooOgmooMgMgoc4a<OoYjNWo`L71o`000?nW
YjL2omoOg`04oi>CTolF5QKoinOWonc/k?ook^k^7_o^k^h00oo]kNgol_;b
ooShn001ooclo0000oomoOd05_olo?cooOgmoogmoOolo?colo?com7AdOmX
1`Oo^3@dolLo<ooBD4?ofV9Eon=^H_oTLVCoi6mRomaTEooCDD?oc44dokTd
=?m[1`Ood];Boo?cloolo?`3oogmo@0Cooclo?oclo?od];Boih[1ooJRSCo
ji/IooFX:Ooh]3oonKe:ooRoCOoj_d[onKPoooJZ:_o_WQWofh/doj8]1ooB
d];olo?cooclo003oogmo@0Cooclo?oclo?od];Bo`M01om=VSCoGj/Pog2h
;omo`d?oR/e@ohg=D_n:cU3oPLM4og6i;omR[R3oCY/do`M21ooBd];olo?c
ooclo03Joogmo@0Soo_knoogmoOoQ8B4oahN7_oclo?onOWiok>c/oo@d=3o
lo?cofQXJ?m7AdOon_[jomCDe?l0003ogMgMooclo?okno_o9bLWojNWYooi
nOWoZj^[omGEeOoalO7oE5ADoeiNG_oinOWom?CdoiBDU?l51@Go@410om7A
dOogmoOon?ShoiNGUol[:b/00_ojn_X06olT92Co1`L7olS8b?okno_oQHF5
of=SHoogmoOoHf=SoeMGEoohn?SonOWiobLW9olE5AGoPh>3omOGeom2@T;o
Hf=Soo_knoojn_[o=3@dodU9BOoKfm_oiNGUodm?ColG5aOon_[jooclo03o
oogmoAcooOgm00?oo?cloogmoOolo?`00oomoOd0000joogmoOojn_[olo?c
onk^k_o`l?3okno_onk^k_oYjNWodm?Coe/M7OnR=3Co]2PMol4j;Oo7BCco
ceI:om1GBoo@Ed[obTXnol<k;_nf:1goXS@doe`M7OoCdm?oj^[Zonk^k_o`
l?3okno_oo3`koo^k^koj^[Zom?Cdon<9Agob74domV47OoTU1GoiidTonjX
<oo`ZSCokjXconbP9OoWUaGog8PMolQa=?n<9Agodm?Con[Zj_o^k^kol?3`
ono_koo`l?3ok^k^on[ZjOoCdm?o7CPMocB2=?m7UAgoFZDKofV]:P;oM;Ph
0>;oMKThof^a:omKYacoB9XMocB2=?lM>1godm?Con[ZjOo^k^kol?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`0_o_knl0oooZj^[oOWinoa`L7?oXj>OokNg]ohR8R?l`<33o3`l?
oc4a<Ona/K7ok^k^ohF5Q?m=CDgokno_onk^k_o_knooRXZ:oeUIFOo^k^ko
N7Qhob/[:ol?3`oo>3Phokno_oo]kNgoi>CTo`h>3_mYJFWogmoOon?ShooU
iNGojn_[of5QHOmgMgOok^k^ono_k_mfMWKo9RHVong]kOo_knooc<c<ob`/
;?oZj^[oKFe/of9RH_o/k>cokNg]oc/k>onCTi?oHV9Ro`h>3_ld=3Coa<C4
ono_koo^k^kodM7Aoc`l??l:2P[o9bLWofa/K?l/;2cokno_onk^k_o`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_k`00
E_o`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_0_o`l?06ono_k`7olo?c
0OoinOT1ooknoP0000?oo_knooOgmoo`l?001?oYjNT04OoWinOofm_Kof=;
Bon1<S;oYSDeokHd;Oo2CD7o`eA9olAEB_o3E4Wo`Te1okHd;OnU=CGoPC8b
of=;BooKfm_oinOW00GojNWY017oinOWom_Kfon9Bd_o[d/boleg=OoFRbgo
h9`^on2P<_oQX3Coh:0bomnJ;_oFRbgobWDeojm;<_n9Bd_ofm_KonOWi`05
onWYj@0AonOWiooKfm_oBd];oc9P<_ljRCGoDi/]of^[;om`[CSoKjhjog2]
>?mZZRooDi/]ocV8=OlbH3;oBd];om_KfooWinL0fooYjNT01_oXj>Soi^KV
og]kNolL71coi>CTonSXj0;ojNWY00?oinOWonWYjOoYjNT02ooYjNT03?oW
inOojNWYonWYjOoXj>Sof=SHo`X:2_n^[ZkogMgMomkNg_oPh>3oiNGUonSX
j0SojNWY00Koj>SXonKVi_oShn?ohn?SonKVi_oXj>P3onWYj@03onSXj?oY
jNWojNWY00CojNWY00?oinOWonWYjOoYjNT09_oYjNT00ooXj>SojNWYonWY
j@3aonWYj@03onSXj?oYjNWojNWY00CojNWY0Oo_knl1ooOgm`7oo_kn0000
1Oono_kon_[jooCdm?o_knoolO7a00;ol?3`017okno_on_[jonEU9CoCb<S
oiEDE?nkLg?odiFEomZLW?oJWYcofIbLomBEUOnkLg?oUEADodlS8onEU9Co
j^[Zono_k`05oo3`l00Aono_kooZj^[oZIBDoh4S8onjJUCoe9YconBlUOoZ
aicojLNLon[7W?oU_9Goe9Ycok]ZE?n18b?oZYBDon[Zj_o_knl01Oo`l?00
4Oo_knooj^[ZoiBDU?lS:R?oE7YDog>ULonNaYGo[<jLojg>W?n/cYcoW/JE
og>ULomDNUCo8bXSoiBDU?oZj^[okno_0=_ol?3`0_o_knl01?n0P83o7AdM
onk^k_o_knlCoo3`l0;okno_00OoI6ATobTY:On1PH7oHf=Soc/k>oo^k^ko
kno_00Sol?3`00Kokno_onk^k_mcLg?oJFUYonk^k_o_knlioo3`l003ono_
koo`l?3ol?3`0?3ol?3`00ColO7aoo3`l?odm?ConOWi0Oono_h00004oocl
o?ooooooooooooknoP;ooooo0_ono_h0ooomoOgon?Shofi^K_mJ?coo/I2@
omk9bOo`i>ColnKVoo3Ti?oNbLWo/I2@oeXo?om]KFgon?Shooclo?oooooo
o_knooooooono_koooonookno_ooooooo?clooShn?n=KFgoRSloolVAT?oY
d<Wom>WTooK[i_odjNCojM39olVAT?n9?cooSFe]ooShmoolo?coooooookn
o_ooooooo_knooooooono_koooonooclo?ohn?SoKFe]oclo?on@WI3obMG9
onC/i?oVk^Koi>cTolWEbOn@WI3o?cloofe]KOohn?Soo?clooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooooknoP00>?ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_oooooooOgmom3@d?nUYJGoo_kmookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooomoOgo`L70
og5aLOn1PH7o[jn_0_ono_h03?ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooomoOgo`/;1okbl_0;oo_kn0?ooooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooool002Woo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
oP02ooooo`03ookno_oooooooooo00?ooooo0Oo/k^l00004ooGfm_ono_ko
n_[jooCdm0GolO7a00gokno_omKFe_m[Jf_o@cdmoi^<S?o6^[[oe/c<olNj
^_nKS8co@cdmof][JooFe]Kokno_00WolO7a00gokno_omOFe_n3Jf_oM3dm
okF<S?oE^[[ohLc<omJj^_nfS8coLSdmoh5[JooGe]Kokno_00WolO7a00go
kno_omKFe_m[Jf_o?Cdmohb<S?nj^[[oc<g<okZj^_n<S8co?Cdmof][JooF
e]Kokno_0?oolO7a@OoalO400oo`l?3olO7aoo7al@3_oo7al@04oo3`l?oa
lO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_ono_h00OnoaLX00005onKWj?om
oOgon?Shoo3`l?o[jn/00ooZj^X03OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUI
FOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT02ooZj^X02ooYjNWoj>SX
oj2KVomZFEWo@bHVobd92Om29RKoJEUIoj2KVooXj>SojNWY00_oj^[Z00_o
jNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@3o
on[Zj_ooj^[Z??oZj^X01?o[jn_ol?3`ooShn?omoOd1oh2<UP0000Co_[jo
ooWjn_oinOWom?Cd2?oalO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_
knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`oooalO7ooo7alC[olO7a00?o
l?3`oo7alOoalO400_oalO400ooemOGon_[jokNm`P01ocA0C00000?obL[;
olG6aoojno/0ooooooooooooogcooooo0Oni_/<1odaFG`7o7B/h00001_l@
72Ko3aTQobP_=omgOH?o^[g0onWZjooooooooooooomfooooo`05on_/kOnm
`/OoOXN>oc8mA_lJ:3@00OlN;SX00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell["menubar is created and set to the Frame", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(menubar = NewJMenuBar[frame]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JMenuBar"] \[RightGuillemet]\),
      JLink`Objects`JavaObject45444914741249]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["menu which will be added to the menubar is created", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(menu = NewJMenu[menubar, "\<RoboLives\>", "\<R\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JMenu"] \[RightGuillemet]\),
      JLink`Objects`JavaObject106865748869121]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ghostmenu = 
      NewJMenu[menubar, "\<Disabled\>", "\<?\>", False]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JMenu"] \[RightGuillemet]\),
      JLink`Objects`JavaObject52857105547265]], "Output"]
}, Open  ]],

Cell["menu is removable", "Text"],

Cell[BoxData[{
    \(menubar@remove[menu]\), "\[IndentingNewLine]", 
    \(frame@repaint[]\), "\[IndentingNewLine]", 
    \(JavaShow[frame]\)}], "Input"],

Cell["\<\
by default, menu is added to the last location in the menubar\
\>", \
"Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(menubar@add[menu]\), "\n", 
    \(frame@repaint[]\), "\[IndentingNewLine]", 
    \(JavaShow[frame]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JMenu"] \[RightGuillemet]\),
      JLink`Objects`JavaObject106865748869121]], "Output"]
}, Open  ]],

Cell["\<\
adding the same menu object twice to the menubar can change the \
location of the menu in the menubar\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(menubar@add[menu, 0]\), "\[IndentingNewLine]", 
    \(frame@repaint[]\), "\[IndentingNewLine]", 
    \(JavaShow[frame]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JMenu"] \[RightGuillemet]\),
      JLink`Objects`JavaObject106865748869121]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["more settings for the menu", "Subsubsection"],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"],

Cell["menuitem", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(item0 = NewJMenuItem[menu, "\<RoboDog\>", "\<D\>"]\), "\n", 
    \(item1 = 
      NewJCheckBoxMenuItem[menu, "\<RoboPanda\>", "\<P\>", True]\), "\n", 
    \(item2 = 
      NewJRadioButtonMenuItem[menu, "\<RoboBear\>", "\<B\>"]\), "\n", 
    \(item3 = NewJRadioButtonMenuItem[menu, "\<RoboCat\>", "\<C\>"]\), "\n", 
    \(item4 = 
      NewJRadioButtonMenuItem[menu, "\<RoboLion\>", "\<L\>"]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JMenuItem"] \[RightGuillemet]\),
      JLink`Objects`JavaObject71103334580225]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JCheckBoxMenuItem"] \[RightGuillemet]\),
      JLink`Objects`JavaObject69572849827841]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JRadioButtonMenuItem"] \[RightGuillemet]\),
      JLink`Objects`JavaObject139956190183425]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JRadioButtonMenuItem"] \[RightGuillemet]\),
      JLink`Objects`JavaObject25910883385345]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JRadioButtonMenuItem"] \[RightGuillemet]\),
      JLink`Objects`JavaObject53017277628417]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(group = JavaNew["\<javax.swing.ButtonGroup\>"]\), "\n", 
    \(group@add[item2]\), "\n", 
    \(group@add[item3]\), "\n", 
    \(group@add[item4]\), "\n", 
    \(item3@setSelected[True]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ButtonGroup"] \[RightGuillemet]\),
      JLink`Objects`JavaObject89977635471361]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(item5 = NewJMenuItem[menu, "\<Sleep\>", "\<S\>", False]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JMenuItem"] \[RightGuillemet]\),
      JLink`Objects`JavaObject88510014947329]], "Output"]
}, Open  ]],

Cell["imageicon", "Text"],

Cell[BoxData[
    \(\(icon = 
        JavaNew["\<javax.swing.ImageIcon\>", 
          StringJoin[$JavaSwingMaterial, "\<NB(S).GIF\>"]];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(width = icon@getIconWidth[]\), "\[IndentingNewLine]", 
    \(height = icon@getIconHeight[]\)}], "Input"],

Cell[BoxData[
    \(16\)], "Output"],

Cell[BoxData[
    \(16\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(item0@setIcon[icon]\), "\n", 
    \(item1@setIcon[icon]\), "\n", 
    \(item2@setIcon[icon]\), "\n", 
    \(item3@setIcon[icon]\), "\n", 
    \(item4@setIcon[icon]\), "\n", 
    \(menu@setIcon[icon]\)}], "Input"],

Cell[BoxData[
    \(menu@insertSeparator[2]\)], "Input"],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"],

Cell["menu@addSeparator[]", "Text"],

Cell["menu@add[JavaNew[\"javax.swing.JSeparator\"]]", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["submenu can be treated just like a menuitem for the menu.", \
"Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(submenu = NewJMenu[Null, "\<RoboKiddy\>", "\<\>", True]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JMenu"] \[RightGuillemet]\),
      JLink`Objects`JavaObject101490177867777]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(submenuitem = NewJMenuItem[submenu, "\<RoboPuppy\>"]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JMenuItem"] \[RightGuillemet]\),
      JLink`Objects`JavaObject77705152299009]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(menu@insert[submenu, 1]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JMenu"] \[RightGuillemet]\),
      JLink`Objects`JavaObject101490177867777]], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(submenu@setIcon[icon]\), "\[IndentingNewLine]", 
    \(submenuitem@setIcon[icon]\)}], "Input"],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(ReleaseObject[icon]\)], "Input"],

Cell[BoxData[{
    \(DeleteJObject[menu, item0]\), "\n", 
    \(DeleteJObject[menu, item1]\), "\n", 
    \(DeleteJObject[menu, item2]\), "\n", 
    \(DeleteJObject[menu, item3]\), "\n", 
    \(DeleteJObject[menu, item4]\), "\n", 
    \(DeleteJObject[menu, item5]\)}], "Input"],

Cell[BoxData[
    \(DeleteJObject[submenu, submenuitem]\)], "Input"],

Cell[BoxData[
    \(DeleteJObject[menu, submenu]\)], "Input"],

Cell[BoxData[
    \(DeleteJObject[menubar, menu]\)], "Input"],

Cell[BoxData[
    \(DeleteJObject[menubar, ghostmenu]\)], "Input"],

Cell[BoxData[
    \(ReleaseObject[group]\)], "Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[BoxData[
    \(ReleaseObject[menubar]\)], "Input"],

Cell["\<\
Although the menubar is released, the frame still contains and \
draws empty menubar.
We have to erase the menubar by setting Null.\
\>", "Text"],

Cell[BoxData[{
    \(frame@setJMenuBar[Null]\), "\[IndentingNewLine]", 
    \(frame@repaint[]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["<<< SimpleJMenu >>>",
  FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006@0001;1P00`40o`00
0?l0003oo`00094000000003R<2hB928B9280?m8T8R=B9280@00000000>8
`;S8h=R8`;P0ohS0^8b8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^8b8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<RLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<RLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<LfIVVOo<c<`Dc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c01_c<c<
00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003IVJIooooc<c<06o<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0Klc<
c003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00fIVVOooolc<c01_c<c<00=VIYW<c<c<c<`0olc<c1;<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<01;<
c<`70000E/c<c003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c01_c<c<00=VIYW<c<c<c<`0
olc<c1;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJI
ooooc<c<06o<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`01/c<c0Koool6c<c<1P00
0004c<c<00000000c<c<0P0000;<c<`200000/c<c08000001<c<c0000000
0<c<c0800002c<c<0P0003o<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`01Lc<c003
ooooIVIVIVIV00=VIVH00lc<c?ooolc<c004c<c<0P0000G<c<`2000000?<
c<`0000000000/c<c08000001<c<c00000000<c<c0<000000lc<c0000000
0002c<c<0P0003o<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`01Lc<c003IVIVc<c<
c<c<00?<c<`00fIVI/c<c?ooo`04c<c<0P0000G<c<`2000000?<c<`00000
00000/c<c08000000lc<c00000000002c<c<0P0000;<c<`40000@<c<c003
IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00fIVVOooolc<c004c<c<00=VIVKoooo<c<`01Lc<c003IVIVoooo
c<c<00?<c<`200001Lc<c08000000lc<c00000000002c<c<0P000003c<c<
0000000000;<c<`200000lc<c0800011c<c<00=VIYW<c<c<c<`0olc<c1;<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<
00C<c<`00fIVI_ooolc<c005c<c<00=VIVKoooo<c<`00lc<c0800005c<c<
0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c0800002
c<c<1000043<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`01<c<c003IVIVooooc<c<
00G<c<`00fIVI_ooolc<c003c<c<0P0000G<c<`2000000G<c<`000000000
003<c<`00P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<
c080000oc<c<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<00C<c<`00fIVI_ooolc<c005
c<c<00=VIVKoooo<c<`00lc<c0800005c<c<0P000004c<c<00000000c<c<
0P0000;<c<`200000/c<c08000000lc<c00000000002c<c<0P0003o<c<`0
0fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00=VIYWoooo<c<`01<c<c003IVIVc<c<oooo00G<c<`00fIVI_oo
olc<c003c<c<0P0005_<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`01Lc<c003IVIV
c<c<oooo00?oool00fIVI_ooolc<c004c<c<0P0000G<c<`20000E<c<c003
IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00fIVVOooolc<c006c<c<1FIVIVC<c<`00fIVVLc<c<c<c03oc<c<
4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<
c<`0Klc<c003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c01_c<c<00=VIYW<c<c<c<`0olc<
c1;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIoooo
c<c<06o<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0Klc<c003IVJIc<c<c<c<0?o<
c<`Bc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOoo
olc<c01_c<c<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003IVJIoooooooo06ooool00fIVVLc<c<c<c03o
c<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYVI
VLbIVL`0KiVIc003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00fIVVIVIc9VIc01_VIW<00=VIYW<c<c<c<`0
olc<c1;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJI
VIW<VIW<01:IVL`<0000DIVIc003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVIVIc9VIc01_VIW<00=V
IYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003IVJIVIW<VIW<06nIVL`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYVIVLbIVL`01YVIc0K<
c?l7VIW<0`0000>IVL`300000YVIc08000000iVIc00000000002VIW<0P00
00:IVL`2000000>IVL`0000000000YVIc0@00003VIW<0`0000:IVL`20000
0iVIc0@0000ZVIW<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003IVJIVIW<VIW<00FIVL`00lc<o`000000
0003000000>IVLc<c?nIVL`01IVIc0<00003VIW<0`0000:IVL`2000000>I
VL`0000000000YVIc080000019VIc000000009VIc0<000000iVIc0000000
0002VIW<0P0000:IVL`3000000BIVL`0000000000002VIW<0P0000:IVL`2
0000:IVIc003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00fIVVIVIc9VIc005VIW<00<0002IVLbIVL`00iVI
c0030000VIW<c<co00FIVL`300000iVIc0<00002VIW<0P000003VIW<0000
000000:IVL`2000000>IVL`0000000000YVIc08000000iVIc00000000002
VIW<0P0000:IVL`3000000BIVL`0000000000005VIW<0`0002VIVL`00fIV
VLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00=VIYVIVLbIVL`019VIc0030000c<coVIW<00FIVL`00`000<c<oiVI
c003VIW<0P000004VIW<00000000VIW<0P000004VIW<00000000VIW<0P00
0003VIW<0000000000:IVL`2000000>IVL`0000000000YVIc08000000iVI
c00000000002VIW<0P000008VIW<00000000VIW<0000VIW<0000VIW<0P00
00:IVL`40000:YVIc003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00fIVVIVIc9VIc004VIW<00<0003<c?nI
VL`01IVIc0030000c<coVIW<00>IVL`2000000BIVL`00000002IVL`20000
00BIVL`00000002IVL`2000000>IVL`0000000000YVIc08000000iVIc000
00000002VIW<0P000003VIW<0000000000:IVL`2000000BIVL`00000002I
VL`3000000BIVL`00000002IVL`30000;9VIc003IVJIc<c<c<c<0?o<c<`B
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVIVIc9VI
c004VIW<00<0003<c?nIVL`01IVIc0030000c<coVIW<00>IVL`2000000BI
VL`00000002IVL`2000000BIVL`00000002IVL`2000000FIVL`000000000
002IVL`00P000004VIW<00000000VIW<0`0000:IVL`00`0009VIc9VIc002
000000BIVL`00000002IVL`3000000BIVL`00000002IVL`200000YVIc080
000YVIW<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003IVJIVIW<VIW<00BIVL`00`000<c<oiVIc005VIW<
00<0003<c?nIVL`00iVIc08000000iVIc0000000000200000YVIc0800000
19VIc000000009VIc08000000iVIc00000000003VIW<0P000003VIW<0000
000000:IVL`400000YVIc0800002VIW<00<0002IVLbIVL`00P0000:IVL`4
0000:YVIc003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00fIVVIVIc9VIc004VIW<00<0002IVLc<c?l01IVI
c0030000c<coVIW<00:IVL`200000iVIc0<00003VIW<0P0000jIVL`20000
@IVIc003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00fIVVIVIc9VIc005VIW<00<0002IVLc<c?l00lc<o`03
0000c<coVIW<00>IVL`200000iVIc0<00003VIW<100000bIVL`20000@IVI
c003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00fIVVIVIc9VIc006VIW<1@0006BIVL`00fIVVLc<c<c<c03o
c<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYVI
VLbIVL`0KiVIc003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00fIVVIVIc9VIc01_VIW<00=VIYW<c<c<c<`0
olc<c1;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJI
VIW<VIW<06nIVL`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00=VIYVIVLbIVL`0KiVIc003IVJIc<c<c<c<
0?o<c<`Bc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<acIVJI
olc<c1C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJI
ooooc<c<06o<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0Klc<c003IVJIc<c<c<c<
0?o<c<`Bc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIV
VOooolc<c01_c<c<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<03k<c<`80000:Lc<c003
IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00fIVVOooolc<c01_c<c<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<06o<c<`0
0fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00=VIYWoooo<c<`01/c<c0Koool6c<c<0P0000;<c<`00`000<c<
c<c<c00200000/c<c0D00002c<c<100000C<c<`400001<c<c0D00005c<c<
0P0000?<c<`20000:/c<c003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c005c<c<00?ooomV
IVIVIVH00fIVIP03c<c<ooooc<c<00C<c<`2000000G<c<`000000000003<
c<`00P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c080
0002c<c<0P0000;<c<`200000/c<c0800003c<c<0P0000C<c<`200000/c<
c0<0000Zc<c<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<00G<c<`00fIVI/c<c<c<c003
c<c<00=VIVK<c<coool01<c<c08000001Lc<c000000000000<c<c0020000
00?<c<`0000000000/c<c08000000lc<c00000000005c<c<0P0000C<c<`2
00001/c<c0800005c<c<0P000003c<c<0000000002_<c<`00fIVVLc<c<c<
c03oc<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=V
IYWoooo<c<`01<c<c003IVIVooooc<c<00<00002c<c<00=VIVKoooo<c<`0
0lc<c08000001Lc<c0000<c<c0000<c<c00200000/c<c08000001<c<c000
00000<c<c0800005c<c<0P0000C<c<`200001<c<c0@00005c<c<1@0002_<
c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00=VIYWoooo<c<`01<c<c003IVIVoooo000000@000000lc<
c6IVI_ooo`04c<c<0P000005c<c<0000c<c<0000c<c<00800003c<c<1000
0003c<c<0000000000G<c<`200001<c<c0800002c<c<1@0000O<c<`30000
;<c<c003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00fIVVOooolc<c004c<c<00=VIVKoool0000010000003
c<c<IVIVoooo00C<c<`4000000?<c<`0000000000P000003c<c<0000c<c<
00;<c<`2000000?<c<`0000000000/c<c08000000lc<c00000000004c<c<
0P000003c<c<0000000000800008c<c<1@0002_<c<`00fIVVLc<c<c<c03o
c<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWo
ooo<c<`01<c<c003IVIVoooo000000@000000lc<c6IVI_ooo`04c<c<1000
0003c<c<0000000000800002c<c<100000?<c<`400000/c<c0800004c<c<
0P000003c<c<0000000000[<c<`2000000?<c<`000000000:lc<c003IVJI
c<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00fIVVOooolc<c004c<c<00=VIVK<c<coool00`0000;<c<`00fIVI_oo
olc<c003c<c<0`0000?<c<`300004<c<c0800002c<c<0P0000;<c<`20000
0lc<c0800004c<c<0P0000;<c<`30000:/c<c003IVJIc<c<c<c<0?o<c<`B
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<
c005c<c<00=VIVK<c<coool00oooo`03IVIVooooc<c<00C<c<`300000lc<
c0<0000Ac<c<100000C<c<`500001Lc<c0800003c<c<0P0002[<c<`00fIV
VLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00=VIYWoooo<c<`01/c<c0EVIVITc<c<00=VIYW<c<c<c<`0olc<c1;<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<
06o<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0Klc<c003IVJIc<c<c<c<0?o<c<`B
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<
c01_c<c<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003IVJIooooc<c<06o<c<`00fIVVLc<c<c<c03oc<c<
4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<
c<`0Klc<c003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c01_c<c<00=VIYW<c<c<c<`0olc<
c1;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIoooo
c<c<06o<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0Klc<c003IVJIc<c<c<c<0?o<
c<`Bc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOoo
olc<c00Bc<c<1`0005K<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0Klc<c003IVJI
c<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00fIVVOooolc<c01_c<c<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<00G<c<`9oooo
1Lc<c0@00003c<c<1@0000;<c<`300000lc<c0D00013c<c<00=VIYW<c<c<
c<`0olc<c1;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
IVJIooooc<c<00C<c<`00fIVI/c<c6IVIP06IVIV00?oooo<c<c<c<`00/c<
c0800002c<c<0P000003c<c<0000000000;<c<`200000/c<c0<00002c<c<
0P0000;<c<`20000@lc<c003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c004c<c<00=VIVKo
ooo<c<`01Lc<c003IVIVooooc<c<00?<c<`200000/c<c08000000lc<c000
00000002c<c<0P000004c<c<00000000c<c<0P000003c<c<0000000000;<
c<`20000@lc<c003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c004c<c<00=VIVKoooo<c<`0
1Lc<c003IVIVooooc<c<00O<c<`200000/c<c08000001<c<c00000000<c<
c08000000lc<c00000000002c<c<0P000003c<c<0000000004?<c<`00fIV
VLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00=VIYWoooo<c<`01<c<c003IVIVooooc<c<00G<c<`00fIVI_ooolc<
c007c<c<0P0000?<c<`4000000C<c<`00000003<c<`200000lc<c0@00013
c<c<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c003IVJIooooc<c<00C<c<`00fIVI_ooolc<c005c<c<00=V
IVKoooo<c<`01lc<c08000000lc<c0000<c<c002c<c<100000?<c<`30000
0lc<c0800013c<c<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<00C<c<`00fIVI_ooolc<
c005c<c<00=VIVKoooo<c<`01lc<c0800002c<c<10000003c<c<00000000
00?<c<`2000000?<c<`0000000000P0004C<c<`00fIVVLc<c<c<c03oc<c<
4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<
c<`01<c<c003IVIVooooc<c<00G<c<`00fIVI_ooolc<c007c<c<0P0005O<
c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00=VIYWoooo<c<`01<c<c003IVIVoooooooo00Goool00lc<
c?ooolc<c007c<c<0P0005O<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`01<c<c0UV
IVIRc<c<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003IVJIooooc<c<06o<c<`00fIVVLc<c<c<c03oc<c<
4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<
c<`0Klc<c003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c01_c<c<00=VIYW<c<c<c<`0olc<
c1;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIoooo
c<c<06o<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0Klc<c003IVJIc<c<c<c<0?o<
c<`Bc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOoo
olc<c01_c<c<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<06o<c<`00fIVVLc<c<c<c03o
c<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWo
ooo<c<`0Klc<c003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c008c<c<2P0005g<c<`00fIV
VLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00=VIYWoooo<c<`0Klc<c003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c01_c<c<00=V
IYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003IVJIooooc<c<00S<c<`200000/c<c0030000c<c<c<c<00800002
c<c<1@0000;<c<`2000000?<c<`0000000000/c<c0800002c<c<100000;<
c<`200000/c<c0800002c<c<0P0000;<c<`500000/c<c08000000lc<c000
00000002c<c<100000?<c<`500007/c<c003IVJIc<c<c<c<0?o<c<`Bc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c008
c<c<0P000005c<c<000000000000c<c<008000000lc<c00000000002c<c<
0P000003c<c<0000000000;<c<`200000/c<c08000000lc<c00000000002
c<c<0P000003c<c<0000000000;<c<`200000/c<c08000000lc<c0000000
0002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<
c08000000lc<c00000000002c<c<0P0001k<c<`00fIVVLc<c<c<c03oc<c<
4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<
c<`02<c<c08000001Lc<c000000000000<c<c002000000?<c<`000000000
0/c<c08000000lc<c00000000002c<c<0P0000;<c<`2000000?<c<`00000
00001Lc<c0800002c<c<0P0000;<c<`2000000?<c<`0000000000/c<c080
00000lc<c00000000002c<c<0P000003c<c<0000000000G<c<`200000/c<
c080000Nc<c<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<00S<c<`2000000G<c<`0003<
c<`0003<c<`00P0000;<c<`2000000C<c<`00000003<c<`200000/c<c080
0002c<c<0P000003c<c<0000000000@000000lc<c00000000002c<c<0P00
00;<c<`200000/c<c08000001<c<c00000000<c<c0800002c<c<0P000003
c<c<0000000000K<c<`2000000?<c<`0000000007/c<c003IVJIc<c<c<c<
0?o<c<`Bc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIV
VOooolc<c008c<c<0P000005c<c<0000c<c<0000c<c<00800003c<c<1000
0003c<c<0000000000;<c<`200000/c<c08000000lc<c00000000002c<c<
0P000003c<c<0000000000;<c<`200000/c<c0800003c<c<10000003c<c<
0000000000;<c<`2000000?<c<`0000000001lc<c0@0000Nc<c<00=VIYW<
c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003IVJIooooc<c<00S<c<`4000000?<c<`0000000000P000003c<c<0000
c<c<00;<c<`2000000?<c<`0000000000/c<c0<000001<c<c00000000<c<
c0800002c<c<0P000005c<c<000000000000c<c<00<000001Lc<c0000000
0<c<c0000003c<c<0P000003c<c<0000000000;<c<`2000000?<c<`00000
00000/c<c08000000lc<c0000<c<c002c<c<0P0001k<c<`00fIVVLc<c<c<
c03oc<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=V
IYWoooo<c<`02<c<c0@000000lc<c0000000000200000/c<c0@000000lc<
c00000000002000000C<c<`00000003<c<`200000lc<c0@00002c<c<0P00
0003c<c<0000000000;<c<`200000lc<c0@000000lc<c000000000020000
00?<c<`0000000000/c<c0@00003c<c<100001o<c<`00fIVVLc<c<c<c03o
c<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWo
ooo<c<`02<c<c0<00003c<c<0`0000S<c<`200000/c<c080000Nc<c<0P00
033<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00=VIYWoooo<c<`02<c<c0<00003c<c<0`0000W<c<`0
0`000<c<c<c<c00200007lc<c0030000c<c<c<c<0080000/c<c<00=VIYW<
c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003IVJIooooc<c<06o<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIYWoooo<c<`0Klc<c003IVJI
c<c<c<c<0?o<c<`Bc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00fIVVOooolc<c01_c<c<00=VIYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003IVJIooooc<c<06o<c<`00fIV
VLc<c<c<c03oc<c<4/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
c<c<00=VIYWoooo<c<`0Klc<c003IVJIc<c<c<c<0?o<c<`Bc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVVOooolc<c01_c<c<00=V
IYW<c<c<c<`0olc<c1;<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003IVJIooooc<c<06o<c<`00fIVVLc<c<c<c03oc<c<4/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2Hf=S00=VIYWoooooool0Koooo`03
IVJIHf=SHf=S0?mSHf<BHf=S0XS0^058T8P1000000001XS0^<SPf8S0^8S0
^?ooohj>SW=VIYWoSXj>4hj>SP04Hf=SR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;P2oooo00=VIVJIVLbIVL`0:YVIc003IVIVooooc<c<0?o<c<aE
c<c<00F>SXiSHf>8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P2oooo
00=VIVJIVLbIVL`0:YVIc003IVIVooooc<c<0?o<c<aEc<c<00F>SXiSHf>8
`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P2oooo00=VIVJIVLbIVL`0
:YVIc003IVIVooooc<c<0?o<c<aEc<c<00F>SXiSHf>8`;R8`;Q8T8P00@00
000000B8`;S8h=R8`;R8`;P2oooo00=VIVJIVLbIVL`07YVIc0L00005VIW<
00=VIVKoooo<c<`0olc<c5G<c<`01Hj>SV=SHhS0^8S0^4R@R00100000000
18S0^<SPf8S0^8S0^0;oool00fIVIYVIc9VIc00ZVIW<00=VIVKoooo<c<`0
olc<c5G<c<`01Hj>SV=SHhS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0
^0;oool00fIVIYVIc9VIc00ZVIW<00=VIVKoooo<c<`0olc<c5G<c<`01Hj>
SV=SHhS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0;oool00fIVIYVI
c9VIc004VIW<100000:IVL`00`0009VIc9VIc006000000BIVL`00000002I
VL`200000YVIc08000000iVIc00000000002VIW<0P0000JIVL`00fIVI_oo
olc<c03oc<c<ELc<c005SXj>Hf=SR<2hR<2hB928004000000004R<2hb>3H
R<2hR<2h0_ooo`03IVIVVIW<VIW<00>IVL`200000YVIc080000019VIc000
09VIc9VIc0800005VIW<0P000003VIW<0000000000:IVL`2000000>IVL`0
000000000YVIc0800006VIW<00=VIVKoooo<c<`0olc<c5G<c<`01Hj>SV=S
HhS0^8S0^4R@R0010000000018S0^<SPf8S0^8S0^0;oool00fIVIYVIc9VI
c003VIW<0P0000:IVL`200000YVIc0040000VIW<000000001IVIc0800000
0iVIc00000000002VIW<0P000004VIW<00000000VIW<0P0000NIVL`00fIV
I_ooolc<c03oc<c<ELc<c005SXj>Hf=SR<2hR<2hB928004000000004R<2h
b>3HR<2hR<2h0_ooo`03IVIVVIW<VIW<00NIVL`200000YVIc0040000VIW<
000000001IVIc08000000iVIc00000000002VIW<0P000003VIW<00000000
00<00007VIW<00=VIVKoooo<c<`0olc<c5G<c<`01Hj>SV=SHhS0^8S0^4R@
R0010000000018S0^<SPf8S0^8S0^0;oool00fIVIYVIc9VIc007VIW<0P00
00:IVL`0100009VIc000000000FIVL`2000000>IVL`0000000000YVIc080
00000iVIc00000000002000029VIc003IVIVooooc<c<0?o<c<aEc<c<00F>
SXiSHf>8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P2oooo00=VIVJI
VLbIVL`01iVIc0800002VIW<00@0002IVL`000000005VIW<0P000005VIW<
000000000000VIW<0080000019VIc000000009VIc0800007VIW<00=VIVKo
ooo<c<`0olc<c5G<c<`01Hj>SV=SHhS0^8S0^4R@R0010000000018S0^<SP
f8S0^8S0^0;oool00fIVIYVIc9VIc007VIW<0P0000:IVL`0100009VIc000
000000FIVL`2000000BIVL`00000002IVL`200000YVIc0800002VIW<0P00
00JIVL`00fIVI_ooolc<c03oc<c<ELc<c005SXj>Hf=SR<2hR<2hB9280040
00000004R<2hb>3HR<2hR<2h0_ooo`03IVIVVIW<VIW<00NIVL`200000iVI
c0<0000?VIW<0P0000ZIVL`00fIVI_ooolc<c03oc<c<ELc<c005SXj>Hf=S
R<2hR<2hB928004000000004R<2hb>3HR<2hR<2h0_ooo`03IVIVVIW<VIW<
00NIVL`200000iVIc0<00005VIW<0P0000RIVL`200002YVIc003IVIVoooo
c<c<0?o<c<aEc<c<00F>SXiSHf>8`;R8`;Q8T8P00@00000000B8`;S8h=R8
`;R8`;P2oooo00=VIVJIVLbIVL`0:YVIc003IVIVooooc<c<0?o<c<aEc<c<
00F>SXiSHf>8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P2oooo00=V
IVJIVLbIVL`0:YVIc003IVIVooooc<c<0?o<c<aEc<c<00F>SXiSHf>8`;R8
`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P2oooo00=VIVJIVLbIVL`0:YVI
c003IVIVooooc<c<0?o<c<aEc<c<00F>SXiSHf>8`;R8`;Q8T8P00@000000
00B8`;S8h=R8`;R8`;P2oooo00=VIVJIVLbIVL`0:YVIc003IVIVooooc<c<
0?o<c<aEc<c<00F>SXiSHf>8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8
`;P2oooo00=VIVJIVLbIVL`0:iVIc003ooooc<c<c<c<0?o<c<aDc<c<00F>
SXiSHf>8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;P2oooo;VIVI_o<
c<aGc<c<00F>SXiSHf>8`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;So
ooooQoooo`05SXj>Hf=SR<2hR<2hB928004000000004R<2hb>3HR<2hR<2h
ooooohSoool016=SHhS0^8S0^4R@R04000000003R<2hb>3HR<2h0?n8`;R<
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h5000P0800H0200:00P03P@03
00B100F100F100801X800`07PP47PP48PP020@V30P4:P`070@^30@^40@b4
0@b40@f40@j40@j500823hD20Q2500<24HH24XH24XH00P8CQP8258L20QF7
00<25XL35hP35hP00P<HR0030aV80aV90aZ900836hT010<LR@<LRP<MRP<M
RP847XX00`@OR`@PR`@PR`02126;0P@RS00512><12B<12B<12F=1BF=0085
9Xd00`DWS@DWSPDXSP021BV>00L5:Xh5:Xl5:hl5:hl5;8l5;Hl6;I000PH^
T086;i021S2A00<6<I46<Y46<Y400PHcTP031SBB1cBB1cFB0087=Y<21cNC
00L7>9<7>9@7>I@7>I@7>Y@7>i@7>iD00PPlU@88?ID00`PnUPPoUPPoUP02
242F0PQ1U`88@YL00`Q3U`U4V0U4V0022DFH00<9AYP9AYT9AiT00PU8V@04
2DVI2DVJ2DZJ2DZJ0PY;VP032TbK2TfK2TfK008:CY/22TnL00D:D9`:DI`:
DI`:DYd;DYd00P]CW@032eBM2eBN2eFN008;EYh01`]GWP]GW`]HW`]HW`]I
W`]JW`aJX00235^P0PaLX08<GJ400`aNX@aOX@aOX@02362R00<<HJ8=HJ8=
HZ800PeSX`8=I:<01`eUX`eUY0eVY0eVY0eWY0eXY0eXY@023VVU0PiZY@03
3V^V3VbV3VbV008>KJH23VjW0Pi_Y`033W2W3g6X3g6X008?LZP00`mcZ0mc
Z@mdZ@023gFY00@?MZT?MZX?MjX?MjX247RZ00<@NJ/@NZ/@NZ/00Q1kZ`8@
O:`01A1m[11n[11n[11o[A5o[@024H2]00<APJdAPJhAPZh00Q63[P074HB^
4HB_4HF_4HF_4HJ_4HN_4XN`008BR;024XV`0Q::/@034X^a4Xba4Xba008B
SK800a:>/Q>>/Q>?/P024i2c0Q>A/`074i:c4i:d4i>d4i>d4iBd4iFd4iFe
008DU[D259Ne00<DV;HDVKHDVKH00QBJ]P8DVkL259bg00<DWKLEW[PEW[P0
0QFO^0035J2h5J2i5J6i008EX[T011FS^AFS^QFT^QFT^P8FYKX00aJV^aJW
^aJW^`025ZRk0QJY_0055ZZl5Z^l5Z^l5Zbm5jbm008G[Kd00aN^_AN^_QN_
_P025k2n00DG/KhG/KlG/[lG/[lG/kl0=QRd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P4002000>KYo4c@jDc@jD02C=3Y@@0080200600P02P080
0h400`04P@05P@05P@0200J200<01h811h8128800P49P`812X<01`4;P`4;
Q04<Q04<Q04=Q04>Q04>Q@020Pn50P8@Q@030Q660Q:60Q:600824hH20QB7
0P8EQ`030QJ70aN80aN8008368P00`<IR0<IR@<JR@020a^900@378T378X3
7HX37HX211j:00<47h/488/488/00P@QR`848X`01@@SS0@TS0@TS0@US@DU
S@021BJ=00<59hd59hh5:8h00PDYSP071BZ>1BZ?1B^?1B^?1Bb?1Bf?1Rf@
0086;Y021Rn@0PH`T@031S6A1S:A1S:A0086<i800`HdTPLdTPLeTP021cJC
0PLgT`071cRC1cRD1cVD1cVD1cZD1c^D1c^E0088?9D223fE00<8?YH8?iH8
?iH00PQ0UP88@IL224:G00<8@iL9A9P9A9P00PU5V0032DJH2DJI2DNI0089
B9T010U9V@U9VPU:VPU:VP8:BiX00`Y<V`Y=V`Y=V`022TjK0PY?W0052U2L
2U6L2U6L2U:M2e:M008;Did00`]DW@]DWP]EWP022eJN00L;Eih;Eil;F9l;
F9l;FIl;FYl<FZ000PaKX08<G:0235fQ00<<GZ4<Gj4<Gj400PaPXP03366R
3F6R3F:R008=Hj<23FBS00L=IJ<=IJ@=IZ@=IZ@=Ij@=J:@=J:D00PiYY@8>
JZD00`i[YPi/YPi/YP023VfV0Pi^Y`8>KjL00`i`Y`maZ0maZ0023g:X00<?
LjP?LjT?M:T00PmeZ@043gJY3gJZ3gNZ3gNZ0Q1hZP0347V[47Z[47Z[008@
Nj/247b/00D@OJ`@OZ`@OZ`@OjdAOjd00Q60[@034H6]4H6^4H:^008APjh0
1a64[Q64[a65[a65[a66[a67[a:7/0024XR`0Q:9/08BR[400a:;/A:</A:<
/@024Xfb00<BS[8CS[8CSk800Q>@/`8CTK<01a>B/a>B]1>C]1>C]1>D]1>E
]1>E]@0259Je0QBG]@0359Rf59Vf59Vf008DV[H259^g0QBL]`0359fg5Ijh
5Ijh008EWkP00aFP^1FP^AFQ^@025J:i00@EXkTEXkXEY;XEY;X25ZFj00<F
Y[/FYk/FYk/00QJX^`8FZK`01AJZ_1J[_1J[_1J/_AN/_@025jfm00<G[[dG
[[hG[kh00QN`_P055k6n5k6o5k:o5k:o5k>o03HH]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0`00P007VjOaooooSWZfYY_4/jWBZ9g8/jWB00:V
Vl@01KbhgNk^m>[YlOoooc=3Y@0300200P01P0800X0200>100<018401H40
1H400P06PP0300N20@N20@R200812H<20@Z300L12h<12h@138@138@13H@1
3X@13XD00P8?Q@8248D00`8AQP8BQP8BQP020Q>60P8DQ`825HL00`8FQ`<G
R0<GR0020aR800<36HP36HT36XT00P<KR@040ab90ab:0af:0af:0P@NRP03
11n;122;122;00848H/212:<00D48h`498`498`49Hd59Hd00PDVS@031BN=
1BN>1BR>0085:Hh01`DZSPDZS`D[S`D[S`D/S`D]S`H]T0021Rj@0PH_T086
<9400`HaT@HbT@HbT@021S>B00<6=987=987=I800PLfT`87=i<01`LhT`Lh
U0LiU0LiU0LjU0LkU0LkU@0223bE0PPmU@0323jF23nF23nF0088@9H2246G
0PQ2U`0324>G2DBH2DBH0089AIP00`U6V0U6V@U7V@022DRI00@9BIT9BIX9
BYX9BYX22T^J00<:C9/:CI/:CI/00PY>V`8:Ci`01@Y@W0YAW0YAW0YBW@]B
W@022e>M00<;E9d;E9h;EIh00P]FWP072eNN2eNO2eRO2eRO2eVO2eZO35ZP
008<Fj0235bP0PaMX@0335jQ35nQ35nQ008<H:800`aQXPeQXPeRXP023F>S
0PeTX`073FFS3FFT3FJT3FJT3FNT3FRT3FRU008>JJD23VZU00<>JjH>K:H>
K:H00Pi]YP8>KZL23VnW00<>L:L?LJP?LJP00PmbZ0033g>X3g>Y3gBY008?
MJT010mfZ@mfZPmgZPmgZP8@N:X00a1iZa1jZa1jZ`0247^[0Q1l[00547f/
47j/47j/47n]4Gn]008AP:d00a61[A61[Q62[P024H>^00LAQ:hAQ:lAQJlA
QJlAQZlAQjlBQk000Q:8/08BRK024XZa00<BRk4BS;4BS;400Q:=/P034Xjb
4hjb4hnb008CT;<24i6c00LCT[<CT[@CTk@CTk@CU;@CUK@CUKD00QBF]@8D
UkD00aBH]QBI]QBI]P0259Zf0QBK]`8DW;L00aBM]aFN^1FN^0025Inh00<E
X;PEX;TEXKT00QFR^@045J>i5J>j5JBj5JBj0QJU^P035ZJk5ZNk5ZNk008F
Z;/25ZVl00DFZ[`FZk`FZk`F[;dG[;d00QN]_@035jjm5jjn5jnn008G/;h0
1ANa_QNa_aNb_aNb_aNc_`026;C08000008H]<0@00000QRd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2002000BKYo7ooom/FZF_YLX2_;SM00[o
oOncZM;ooooooonl^=fGR[bXWLSVi^cooolc@jD200200P01P0800X0200>1
00<018401H401H400P06PP0300N20@N20@R200812H<20@Z300L12h<12h@1
38@138@13H@13X@13XD00P8?Q@8248D00`8AQP8BQP8BQP020Q>60P8DQ`82
5HL00`8FQ`<GR0<GR0020aR800<36HP36HT36XT00P<KR@040ab90ab:0af:
0af:0P@NRP0311n;122;122;00848H/212:<00D48h`498`498`49Hd59Hd0
0PDVS@031BN=1BN>1BR>0085:Hh01`DZSPDZS`D[S`D[S`D/S`D]S`H]T002
1Rj@0PH_T086<9400`HaT@HbT@HbT@021S>B00<6=987=987=I800PLfT`87
=i<01`LhT`LhU0LiU0LiU0LjU0LkU0LkU@0223bE0PPmU@0323jF23nF23nF
0088@9H2246G0PQ2U`0324>G2DBH2DBH0089AIP00`U6V0U6V@U7V@022DRI
00@9BIT9BIX9BYX9BYX22T^J00<:C9/:CI/:CI/00PY>V`8:Ci`01@Y@W0YA
W0YAW0YBW@]BW@022e>M00<;E9d;E9h;EIh00P]FWP072eNN2eNO2eRO2eRO
2eVO2eZO35ZP008<Fj0235bP0PaMX@0335jQ35nQ35nQ008<H:800`aQXPeQ
XPeRXP023F>S0PeTX`073FFS3FFT3FJT3FJT3FNT3FRT3FRU008>JJD23VZU
00<>JjH>K:H>K:H00Pi]YP8>KZL23VnW00<>L:L?LJP?LJP00PmbZ0033g>X
3g>Y3gBY008?MJT010mfZ@mfZPmgZPmgZP8@N:X00a1iZa1jZa1jZ`0247^[
0Q1l[00547f/47j/47j/47n]4Gn]008AP:d00a61[A61[Q62[P024H>^00LA
Q:hAQ:lAQJlAQJlAQZlAQjlBQk000Q:8/08BRK024XZa00<BRk4BS;4BS;40
0Q:=/P034Xjb4hjb4hnb008CT;<24i6c00LCT[<CT[@CTk@CTk@CU;@CUK@C
UKD00QBF]@8DUkD00aBH]QBI]QBI]P0259Zf0QBK]`8DW;L00aBM]aFN^1FN
^0025Inh00<EX;PEX;TEXKT00QFR^@045J>i5J>j5JBj5JBj0QJU^P035ZJk
5ZNk5ZNk008FZ;/25ZVl00DFZ[`FZk`FZk`F[;dG[;d00QN]_@035jjm5jjn
5jnn008G/;h01ANa_QNa_aNb_aNb_aNc_`026;C000?8h=Q8T8Q8T8P034R@
R0030000b>3HB92800e8T8P0100001Rd`1Rd`<SPf0i8T8P00`0001Rd`1Rd
`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00;VjOaooooZ9g8
oooo/jWBH4bJSWZfN6F^Z9g8oooooogo00?oool013=3Y@00P000P000P080
0H0200:00P03P@0300B100F100F100801X800`07PP47PP48PP020@V30P4:
P`070@^30@^40@b40@b40@f40@j40@j500?oool0108@Q@8AQP8BQP8BQP82
4hH20QB70P8EQ`030QJ70aN80aN8008368P00`<IR0<IR@<JR@020a^900@3
78T378X37HX37HX211j:00<47h/488/488/00P@QR`848X`01@@SS0@TS0@T
S0@US@DUS@021BJ=00<59hd59hh5:8h00PDYSP071BZ>1BZ?1B^?1B^?1Bb?
1Bf?1Rf@0086;Y021Rn@0PH`T@031S6A1S:A1S:A0086<i800`HdTPLdTPLe
TP021cJC0PLgT`071cRC1cRD1cVD1cVD1cZD1c^D1c^E0088?9D223fE00<8
?YH8?iH8?iH00PQ0UP88@IL224:G00<8@iL9A9P9A9P00PU5V0032DJH2DJI
2DNI0089B9T010U9V@U9VPU:VPU:VP8:BiX00`Y<V`Y=V`Y=V`022TjK0PY?
W0052U2L2U6L2U6L2U:M2e:M008;Did00`]DW@]DWP]EWP022eJN00L;Eih;
Eil;F9l;F9l;FIl;FYl<FZ000PaKX08<G:0235fQ00<<GZ4<Gj4<Gj400PaP
XP03366R3F6R3F:R008=Hj<23FBS00L=IJ<=IJ@=IZ@=IZ@=Ij@=J:@=J:D0
0PiYY@8>JZD00`i[YPi/YPi/YP023VfV0Pi^Y`8>KjL00`i`Y`maZ0maZ002
3g:X00<?LjP?LjT?M:T00PmeZ@043gJY3gJZ3gNZ3gNZ0Q1hZP0347V[47Z[
47Z[008@Nj/247b/00D@OJ`@OZ`@OZ`@OjdAOjd00Q60[@034H6]4H6^4H:^
008APjh01a64[Q64[a65[a65[a66[a67[a:7/0024XR`0Q:9/08BR[400a:;
/A:</A:</@024Xfb00<BS[8CS[8CSk800Q>@/`8CTK<01a>B/a>B]1>C]1>C
]1>D]1>E]1>E]@0259Je0QBG]@0359Rf59Vf59Vf008DV[H259^g0QBL]`03
59fg5Ijh5Ijh008EWkP00aFP^1FP^AFQ^@025J:i00@EXkTEXkXEY;XEY;X2
5ZFj00<FY[/FYk/FYk/00QJX^`8FZK`01AJZ_1J[_1J[_1J/_AN/_@025jfm
00<G[[dG[[hG[kh00QN`_P055k6n5k6o5k:o5k:o5k>o008H]<000lSPf8S0
^8S0^00;R<2h00=8T8P00038h=P03HS0^005B92800006;C06;C0b>3H00f8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
002000jKYo7ooooooooKg>aPC9ZCQKZcZM:l^=ePC9ZISkjVVlC8`moooolc
@jD4002000<00H3oooooool00_ooo`0400>100B100F1oooo0P06PP0300N2
oooo0@R200812H<01?ooo`4:Poooo`4;Q08138@00oooo`4>Q?ooo`020Pn5
00<248Goool24HH00P8BQP?oool00`8DQ`8EQ`8EQ`04oooo00l368P36HSo
ool36XWoool36hT378T378[oool37H[oool47XX47h/488_oool00P@QR`84
8X`01@@SS0@TS0@TS0@US@DUS@021BJ=00<59hd59hh5:8h00PDYSP071BZ>
1BZ?1B^?1B^?1Bb?1Bf?1Rf@0086;Y021Rn@0PH`T@031S6A1S:A1S:A0086
<i800`HdTPLdTPLeTP021cJC0PLgT`071cRC1cRD1cVD1cVD1cZD1c^D1c^E
0088?9D223fE00<8?YH8?iH8?iH00PQ0UP88@IL224:G00<8@iL9A9P9A9P0
0PU5V0032DJH2DJI2DNI0089B9T010U9V@U9VPU:VPU:VP8:BiX00`Y<V`Y=
V`Y=V`022TjK0PY?W0052U2L2U6L2U6L2U:M2e:M008;Did00`]DW@]DWP]E
WP022eJN00L;Eih;Eil;F9l;F9l;FIl;FYl<FZ000PaKX08<G:0235fQ00<<
GZ4<Gj4<Gj400PaPXP03366R3F6R3F:R008=Hj<23FBS00L=IJ<=IJ@=IZ@=
IZ@=Ij@=J:@=J:D00PiYY@8>JZD00`i[YPi/YPi/YP023VfV0Pi^Y`8>KjL0
0`i`Y`maZ0maZ0023g:X00<?LjP?LjT?M:T00PmeZ@043gJY3gJZ3gNZ3gNZ
0Q1hZP0347V[47Z[47Z[008@Nj/247b/00D@OJ`@OZ`@OZ`@OjdAOjd00Q60
[@034H6]4H6^4H:^008APjh01a64[Q64[a65[a65[a66[a67[a:7/0024XR`
0Q:9/08BR[400a:;/A:</A:</@024Xfb00<BS[8CS[8CSk800Q>@/`8CTK<0
1a>B/a>B]1>C]1>C]1>D]1>E]1>E]@0259Je0QBG]@0359Rf59Vf59Vf008D
V[H259^g0QBL]`0359fg5Ijh5Ijh008EWkP00aFP^1FP^AFQ^@025J:i00@E
XkTEXkXEY;XEY;X25ZFj00<FY[/FYk/FYk/00QJX^`8FZK`01AJZ_1J[_1J[
_1J/_AN/_@025jfm00<G[[dG[[hG[kh00QN`_P055k6n5k6o5k:o5k:o5k>o
008H]<001<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P00038h=P00XS0^0T0
0002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0<008003Y^WlOoookbhgIV?__oo
omKAgM_Lk??nojJKa>k^m8Ef/9>5^_oooc=3Y@<008002Oooo`01P002P002
P003POooo`04P@05POooo`0200J200<01h;oool128800P49P`04oooo0@Z3
oooo0@^40P4<Q003oooo0@j4oooo00?oool0108@Q@8AQP8BQ_ooo`824hH0
1@8DQoooo`8EQ`8EQoooo`020aN80P<HR00>0aV8oooo0aZ9oooo0a^90ab9
0ab:oooo0af:oooo11j:11n;oooo122;0P@QR`848X`01@@SS0@TS0@TS0@U
S@DUS@021BJ=00<59hd59hh5:8h00PDYSP071BZ>1BZ?1B^?1B^?1Bb?1Bf?
1Rf@0086;Y021Rn@0PH`T@031S6A1S:A1S:A0086<i800`HdTPLdTPLeTP02
1cJC0PLgT`071cRC1cRD1cVD1cVD1cZD1c^D1c^E0088?9D223fE00<8?YH8
?iH8?iH00PQ0UP88@IL224:G00<8@iL9A9P9A9P00PU5V0032DJH2DJI2DNI
0089B9T010U9V@U9VPU:VPU:VP8:BiX00`Y<V`Y=V`Y=V`022TjK0PY?W005
2U2L2U6L2U6L2U:M2e:M008;Did00`]DW@]DWP]EWP022eJN00L;Eih;Eil;
F9l;F9l;FIl;FYl<FZ000PaKX08<G:0235fQ00<<GZ4<Gj4<Gj400PaPXP03
366R3F6R3F:R008=Hj<23FBS00L=IJ<=IJ@=IZ@=IZ@=Ij@=J:@=J:D00PiY
Y@8>JZD00`i[YPi/YPi/YP023VfV0Pi^Y`8>KjL00`i`Y`maZ0maZ0023g:X
00<?LjP?LjT?M:T00PmeZ@043gJY3gJZ3gNZ3gNZ0Q1hZP0347V[47Z[47Z[
008@Nj/247b/00D@OJ`@OZ`@OZ`@OjdAOjd00Q60[@034H6]4H6^4H:^008A
Pjh01a64[Q64[a65[a65[a66[a67[a:7/0024XR`0Q:9/08BR[400a:;/A:<
/A:</@024Xfb00<BS[8CS[8CSk800Q>@/`8CTK<01a>B/a>B]1>C]1>C]1>D
]1>E]1>E]@0259Je0QBG]@0359Rf59Vf59Vf008DV[H259^g0QBL]`0359fg
5Ijh5Ijh008EWkP00aFP^1FP^AFQ^@025J:i00@EXkTEXkXEY;XEY;X25ZFj
00<FY[/FYk/FYk/00QJX^`8FZK`01AJZ_1J[_1J[_1J/_AN/_@025jfm00<G
[[dG[[hG[kh00QN`_P055k6n5k6o5k:o5k:o5k>o008H]<001<SPf8S0^8S0
^8S0^0H00004R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P0
1@0008S0^8S0^4R@R00000026;C000C8h=R8`;R8`;R8`;P2000018S0^080
0002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0`00P00?VjOaooooVHnnUhZle=?XkjbcogIkkYn[FeRUYY_4UYoBH4bJ
_;SMoooo<d>U008008003_ooo`01P002P002P003POooo`04POooo`05POoo
o`06P_ooo`47P_ooo`812H<01?ooo`4:Poooo`4;Q08138@00oooo`4>Q?oo
o`020Pn50P8@Q@030Q660Q:6oooo00824hH01@8DQoooo`8EQ`8EQoooo`02
0aN80P<HR00<0aV8oooo0aZ9oooo0a^90ab90ab:oooo0af:oooo11j:oooo
0P@PR`848H/212:<00D48h`498`498`49Hd59Hd00PDVS@031BN=1BN>1BR>
0085:Hh01`DZSPDZS`D[S`D[S`D/S`D]S`H]T0021Rj@0PH_T086<9400`Ha
T@HbT@HbT@021S>B00<6=987=987=I800PLfT`87=i<01`LhT`LhU0LiU0Li
U0LjU0LkU0LkU@0223bE0PPmU@0323jF23nF23nF0088@9H2246G0PQ2U`03
24>G2DBH2DBH0089AIP00`U6V0U6V@U7V@022DRI00@9BIT9BIX9BYX9BYX2
2T^J00<:C9/:CI/:CI/00PY>V`8:Ci`01@Y@W0YAW0YAW0YBW@]BW@022e>M
00<;E9d;E9h;EIh00P]FWP072eNN2eNO2eRO2eRO2eVO2eZO35ZP008<Fj02
35bP0PaMX@0335jQ35nQ35nQ008<H:800`aQXPeQXPeRXP023F>S0PeTX`07
3FFS3FFT3FJT3FJT3FNT3FRT3FRU008>JJD23VZU00<>JjH>K:H>K:H00Pi]
YP8>KZL23VnW00<>L:L?LJP?LJP00PmbZ0033g>X3g>Y3gBY008?MJT010mf
Z@mfZPmgZPmgZP8@N:X00a1iZa1jZa1jZ`0247^[0Q1l[00547f/47j/47j/
47n]4Gn]008AP:d00a61[A61[Q62[P024H>^00LAQ:hAQ:lAQJlAQJlAQZlA
QjlBQk000Q:8/08BRK024XZa00<BRk4BS;4BS;400Q:=/P034Xjb4hjb4hnb
008CT;<24i6c00LCT[<CT[@CTk@CTk@CU;@CUK@CUKD00QBF]@8DUkD00aBH
]QBI]QBI]P0259Zf0QBK]`8DW;L00aBM]aFN^1FN^0025Inh00<EX;PEX;TE
XKT00QFR^@045J>i5J>j5JBj5JBj0QJU^P035ZJk5ZNk5ZNk008FZ;/25ZVl
00DFZ[`FZk`FZk`F[;dG[;d00QN]_@035jjm5jjn5jnn008G/;h01ANa_QNa
_aNb_aNb_aNc_`026;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8
`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3H
R<2hR<2h00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOX
ZFjPb<?OThFjFdJCVHnn0WQU[P04@RN5[jG:oooo<d>U0P00P0800H0200:0
00X00h7oool0187oool01H7oool01X;oool11h;oool20@V300Coool12X?o
ool12h@20@b400?oool13XCoool00oooo`040Q250Q660Q:60Q:60P8CQP05
0QB7oooo0QF70QF7oooo00835hP20aR800T36HSoool36XWoool36hT378T3
78[oool37HX00_ooo`0311n;122;122;00848H/212:<00D48h`498`498`4
9Hd59Hd00PDVS@031BN=1BN>1BR>0085:Hh01`DZSPDZS`D[S`D[S`D/S`D]
S`H]T0021Rj@0PH_T086<9400`HaT@HbT@HbT@021S>B00<6=987=987=I80
0PLfT`87=i<01`LhT`LhU0LiU0LiU0LjU0LkU0LkU@0223bE0PPmU@0323jF
23nF23nF0088@9H2246G0PQ2U`0324>G2DBH2DBH0089AIP00`U6V0U6V@U7
V@022DRI00@9BIT9BIX9BYX9BYX22T^J00<:C9/:CI/:CI/00PY>V`8:Ci`0
1@Y@W0YAW0YAW0YBW@]BW@022e>M00<;E9d;E9h;EIh00P]FWP072eNN2eNO
2eRO2eRO2eVO2eZO35ZP008<Fj0235bP0PaMX@0335jQ35nQ35nQ008<H:80
0`aQXPeQXPeRXP023F>S0PeTX`073FFS3FFT3FJT3FJT3FNT3FRT3FRU008>
JJD23VZU00<>JjH>K:H>K:H00Pi]YP8>KZL23VnW00<>L:L?LJP?LJP00Pmb
Z0033g>X3g>Y3gBY008?MJT010mfZ@mfZPmgZPmgZP8@N:X00a1iZa1jZa1j
Z`0247^[0Q1l[00547f/47j/47j/47n]4Gn]008AP:d00a61[A61[Q62[P02
4H>^00LAQ:hAQ:lAQJlAQJlAQZlAQjlBQk000Q:8/08BRK024XZa00<BRk4B
S;4BS;400Q:=/P034Xjb4hjb4hnb008CT;<24i6c00LCT[<CT[@CTk@CTk@C
U;@CUK@CUKD00QBF]@8DUkD00aBH]QBI]QBI]P0259Zf0QBK]`8DW;L00aBM
]aFN^1FN^0025Inh00<EX;PEX;TEXKT00QFR^@045J>i5J>j5JBj5JBj0QJU
^P035ZJk5ZNk5ZNk008FZ;/25ZVl00DFZ[`FZk`FZk`F[;dG[;d00QN]_@03
5jjm5jjn5jnn008G/;h01ANa_QNa_aNb_aNb_aNc_`026;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028
`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8`;P4000018S0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008000i^W
lOooooooo`02oooo00[o[K3oMW_icMCmkNkooonVVlB5M[2l^=gooolc@jD3
00200P01P0?oool02@03P@04POooo`05POooo`06P_ooo`47P_ooo`020@V3
00Coool12X?oooooool20@b400?oool13XCoool00P8?Q@03oooo0Q250Q66
00824XH20Q>600D258Ooool25HL25HOoool00P<GR08368P00`<IR?ooo`<J
R@02oooo00L378T378[oool37H[oool47X[oool00P@PR`848H/212:<00D4
8h`498`498`49Hd59Hd00PDVS@031BN=1BN>1BR>0085:Hh01`DZSPDZS`D[
S`D[S`D/S`D]S`H]T0021Rj@0PH_T086<9400`HaT@HbT@HbT@021S>B00<6
=987=987=I800PLfT`87=i<01`LhT`LhU0LiU0LiU0LjU0LkU0LkU@0223bE
0PPmU@0323jF23nF23nF0088@9H2246G0PQ2U`0324>G2DBH2DBH0089AIP0
0`U6V0U6V@U7V@022DRI00@9BIT9BIX9BYX9BYX22T^J00<:C9/:CI/:CI/0
0PY>V`8:Ci`01@Y@W0YAW0YAW0YBW@]BW@022e>M00<;E9d;E9h;EIh00P]F
WP072eNN2eNO2eRO2eRO2eVO2eZO35ZP008<Fj0235bP0PaMX@0335jQ35nQ
35nQ008<H:800`aQXPeQXPeRXP023F>S0PeTX`073FFS3FFT3FJT3FJT3FNT
3FRT3FRU008>JJD23VZU00<>JjH>K:H>K:H00Pi]YP8>KZL23VnW00<>L:L?
LJP?LJP00PmbZ0033g>X3g>Y3gBY008?MJT010mfZ@mfZPmgZPmgZP8@N:X0
0a1iZa1jZa1jZ`0247^[0Q1l[00547f/47j/47j/47n]4Gn]008AP:d00a61
[A61[Q62[P024H>^00LAQ:hAQ:lAQJlAQJlAQZlAQjlBQk000Q:8/08BRK02
4XZa00<BRk4BS;4BS;400Q:=/P034Xjb4hjb4hnb008CT;<24i6c00LCT[<C
T[@CTk@CTk@CU;@CUK@CUKD00QBF]@8DUkD00aBH]QBI]QBI]P0259Zf0QBK
]`8DW;L00aBM]aFN^1FN^0025Inh00<EX;PEX;TEXKT00QFR^@045J>i5J>j
5JBj5JBj0QJU^P035ZJk5ZNk5ZNk008FZ;/25ZVl00DFZ[`FZk`FZk`F[;dG
[;d00QN]_@035jjm5jjn5jnn008G/;h01ANa_QNa_aNb_aNb_aNc_`026;C0
00?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005
R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00B8`;P20000
1HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0<008002Z6/l_W=e>8V??Be_n8V??A]OOcSjOoooog]k_n]/0;oool00c=3
Y@00P000P002002000@00H3oool00X000X0200>100P0187oool01H401X;o
ool01h811h;oool20@V300Coool12X?oool12h@2oooo00<13H@13X@13XD0
1?ooo`030Q660Q:60Q:600824hH01@8DQoooo`8EQ`8EQoooo`020aN80P<H
R0050aV8oooo0aZ9oooo0a^900;oool20af:00Goool47XX47h_oool488/0
0P@QR`848X`01@@SS0@TS0@TS0@US@DUS@021BJ=00<59hd59hh5:8h00PDY
SP071BZ>1BZ?1B^?1B^?1Bb?1Bf?1Rf@0086;Y021Rn@0PH`T@031S6A1S:A
1S:A0086<i800`HdTPLdTPLeTP021cJC0PLgT`071cRC1cRD1cVD1cVD1cZD
1c^D1c^E0088?9D223fE00<8?YH8?iH8?iH00PQ0UP88@IL224:G00<8@iL9
A9P9A9P00PU5V0032DJH2DJI2DNI0089B9T010U9V@U9VPU:VPU:VP8:BiX0
0`Y<V`Y=V`Y=V`022TjK0PY?W0052U2L2U6L2U6L2U:M2e:M008;Did00`]D
W@]DWP]EWP022eJN00L;Eih;Eil;F9l;F9l;FIl;FYl<FZ000PaKX08<G:02
35fQ00<<GZ4<Gj4<Gj400PaPXP03366R3F6R3F:R008=Hj<23FBS00L=IJ<=
IJ@=IZ@=IZ@=Ij@=J:@=J:D00PiYY@8>JZD00`i[YPi/YPi/YP023VfV0Pi^
Y`8>KjL00`i`Y`maZ0maZ0023g:X00<?LjP?LjT?M:T00PmeZ@043gJY3gJZ
3gNZ3gNZ0Q1hZP0347V[47Z[47Z[008@Nj/247b/00D@OJ`@OZ`@OZ`@OjdA
Ojd00Q60[@034H6]4H6^4H:^008APjh01a64[Q64[a65[a65[a66[a67[a:7
/0024XR`0Q:9/08BR[400a:;/A:</A:</@024Xfb00<BS[8CS[8CSk800Q>@
/`8CTK<01a>B/a>B]1>C]1>C]1>D]1>E]1>E]@0259Je0QBG]@0359Rf59Vf
59Vf008DV[H259^g0QBL]`0359fg5Ijh5Ijh008EWkP00aFP^1FP^AFQ^@02
5J:i00@EXkTEXkXEY;XEY;X25ZFj00<FY[/FYk/FYk/00QJX^`8FZK`01AJZ
_1J[_1J[_1J/_AN/_@025jfm00<G[[dG[[hG[kh00QN`_P055k6n5k6o5k:o
5k:o5k>o008H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^003
0000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8
`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0P00P00=VjOaoNg^hRHlo_GhmhVGm69^lj2^m69^oogo
ojf`o>?Yoooo<d>U00D008001?ooo`01P002P002P0800h400`04P@05P@05
P@0200J200<01h811h8128800P49P`812X<01`4;P`4;Q04<Q04<Q04=Q04>
Q04>Q@020Pn50P8@Q@030Q660Q:60Q:600824hH01@8DQoooo`8EQ`8EQooo
o`020aN80P<HR0030aV80aV90aZ900836hT01`<LR@<LRP<MRP<MR_ooo`@N
RP@OR`02122;0P@QR`848X`01@@SS0@TS0@TS0@US@DUS@021BJ=00<59hd5
9hh5:8h00PDYSP071BZ>1BZ?1B^?1B^?1Bb?1Bf?1Rf@0086;Y021Rn@0PH`
T@031S6A1S:A1S:A0086<i800`HdTPLdTPLeTP021cJC0PLgT`071cRC1cRD
1cVD1cVD1cZD1c^D1c^E0088?9D223fE00<8?YH8?iH8?iH00PQ0UP88@IL2
24:G00<8@iL9A9P9A9P00PU5V0032DJH2DJI2DNI0089B9T010U9V@U9VPU:
VPU:VP8:BiX00`Y<V`Y=V`Y=V`022TjK0PY?W0052U2L2U6L2U6L2U:M2e:M
008;Did00`]DW@]DWP]EWP022eJN00L;Eih;Eil;F9l;F9l;FIl;FYl<FZ00
0PaKX08<G:0235fQ00<<GZ4<Gj4<Gj400PaPXP03366R3F6R3F:R008=Hj<2
3FBS00L=IJ<=IJ@=IZ@=IZ@=Ij@=J:@=J:D00PiYY@8>JZD00`i[YPi/YPi/
YP023VfV0Pi^Y`8>KjL00`i`Y`maZ0maZ0023g:X00<?LjP?LjT?M:T00Pme
Z@043gJY3gJZ3gNZ3gNZ0Q1hZP0347V[47Z[47Z[008@Nj/247b/00D@OJ`@
OZ`@OZ`@OjdAOjd00Q60[@034H6]4H6^4H:^008APjh01a64[Q64[a65[a65
[a66[a67[a:7/0024XR`0Q:9/08BR[400a:;/A:</A:</@024Xfb00<BS[8C
S[8CSk800Q>@/`8CTK<01a>B/a>B]1>C]1>C]1>D]1>E]1>E]@0259Je0QBG
]@0359Rf59Vf59Vf008DV[H259^g0QBL]`0359fg5Ijh5Ijh008EWkP00aFP
^1FP^AFQ^@025J:i00@EXkTEXkXEY;XEY;X25ZFj00<FY[/FYk/FYk/00QJX
^`8FZK`01AJZ_1J[_1J[_1J/_AN/_@025jfm00<G[[dG[[hG[kh00QN`_P05
5k6n5k6o5k:o5k:o5k>o008H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038
h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C0
00?8h=R8`;R8`;P00XS0^0800002R<2h0P0000>8`;P014R@R00001Rd`1Rd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7fb<cR9S`0
0_n]/007gb@^ojBNm[c5ojf`kW^<oooo<d>U00H008001oooo`01P002P002
P003POooo`04P@0200F10P06PP0300N20@N20@R200812H<20@Z300L12h<1
2h@138@138@13H@13X@13XD00P8?Q@8248D00`8AQP8BQP8BQP020Q>600D2
58Ooool25HL25HOoool00P<GR08368P00`<IR0<IR@<JR@020a^900L378T3
78X37HX37H[oool47XX47h/00P@PR`848H/212:<00D48h`498`498`49Hd5
9Hd00PDVS@031BN=1BN>1BR>0085:Hh01`DZSPDZS`D[S`D[S`D/S`D]S`H]
T0021Rj@0PH_T086<9400`HaT@HbT@HbT@021S>B00<6=987=987=I800PLf
T`87=i<01`LhT`LhU0LiU0LiU0LjU0LkU0LkU@0223bE0PPmU@0323jF23nF
23nF0088@9H2246G0PQ2U`0324>G2DBH2DBH0089AIP00`U6V0U6V@U7V@02
2DRI00@9BIT9BIX9BYX9BYX22T^J00<:C9/:CI/:CI/00PY>V`8:Ci`01@Y@
W0YAW0YAW0YBW@]BW@022e>M00<;E9d;E9h;EIh00P]FWP072eNN2eNO2eRO
2eRO2eVO2eZO35ZP008<Fj0235bP0PaMX@0335jQ35nQ35nQ008<H:800`aQ
XPeQXPeRXP023F>S0PeTX`073FFS3FFT3FJT3FJT3FNT3FRT3FRU008>JJD2
3VZU00<>JjH>K:H>K:H00Pi]YP8>KZL23VnW00<>L:L?LJP?LJP00PmbZ003
3g>X3g>Y3gBY008?MJT010mfZ@mfZPmgZPmgZP8@N:X00a1iZa1jZa1jZ`02
47^[0Q1l[00547f/47j/47j/47n]4Gn]008AP:d00a61[A61[Q62[P024H>^
00LAQ:hAQ:lAQJlAQJlAQZlAQjlBQk000Q:8/08BRK024XZa00<BRk4BS;4B
S;400Q:=/P034Xjb4hjb4hnb008CT;<24i6c00LCT[<CT[@CTk@CTk@CU;@C
UK@CUKD00QBF]@8DUkD00aBH]QBI]QBI]P0259Zf0QBK]`8DW;L00aBM]aFN
^1FN^0025Inh00<EX;PEX;TEXKT00QFR^@045J>i5J>j5JBj5JBj0QJU^P03
5ZJk5ZNk5ZNk008FZ;/25ZVl00DFZ[`FZk`FZk`F[;dG[;d00QN]_@035jjm
5jjn5jnn008G/;h01ANa_QNa_aNb_aNb_aNc_`026;C000?8h=R8`;R8`;P0
2hS0^003B9280000b>3H00:8`;P900000XS0^005B92800006;C06;C0b>3H
00>8`;P2000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0P00P003VjOanLgDmhVG00;oool01on]/>4F
=?mfNonTW^8V??n9Oc=3Y@06002000<00H3oooooool00_ooo`0400>100B1
00F100F10P06PP0300N20@N20@R200812H<01?ooo`4:P`4;P`4;Q08138@0
0`4=Q04>Q04>Q@020Pn50P8@Q@030Q660Q:60Q:600824hH01@8DQoooo`8E
Q`8EQoooo`020aN80P<HR0030aV8oooo0aZ900836hT01`<LR@<LRP<MRP<M
R_ooo`@NRP@OR`02122;0P@QR`848X`01@@SS0@TS0@TS0@US@DUS@021BJ=
00<59hd59hh5:8h00PDYSP071BZ>1BZ?1B^?1B^?1Bb?1Bf?1Rf@0086;Y02
1Rn@0PH`T@031S6A1S:A1S:A0086<i800`HdTPLdTPLeTP021cJC0PLgT`07
1cRC1cRD1cVD1cVD1cZD1c^D1c^E0088?9D223fE00<8?YH8?iH8?iH00PQ0
UP88@IL224:G00<8@iL9A9P9A9P00PU5V0032DJH2DJI2DNI0089B9T010U9
V@U9VPU:VPU:VP8:BiX00`Y<V`Y=V`Y=V`022TjK0PY?W0052U2L2U6L2U6L
2U:M2e:M008;Did00`]DW@]DWP]EWP022eJN00L;Eih;Eil;F9l;F9l;FIl;
FYl<FZ000PaKX08<G:0235fQ00<<GZ4<Gj4<Gj400PaPXP03366R3F6R3F:R
008=Hj<23FBS00L=IJ<=IJ@=IZ@=IZ@=Ij@=J:@=J:D00PiYY@8>JZD00`i[
YPi/YPi/YP023VfV0Pi^Y`8>KjL00`i`Y`maZ0maZ0023g:X00<?LjP?LjT?
M:T00PmeZ@043gJY3gJZ3gNZ3gNZ0Q1hZP0347V[47Z[47Z[008@Nj/247b/
00D@OJ`@OZ`@OZ`@OjdAOjd00Q60[@034H6]4H6^4H:^008APjh01a64[Q64
[a65[a65[a66[a67[a:7/0024XR`0Q:9/08BR[400a:;/A:</A:</@024Xfb
00<BS[8CS[8CSk800Q>@/`8CTK<01a>B/a>B]1>C]1>C]1>D]1>E]1>E]@02
59Je0QBG]@0359Rf59Vf59Vf008DV[H259^g0QBL]`0359fg5Ijh5Ijh008E
WkP00aFP^1FP^AFQ^@025J:i00@EXkTEXkXEY;XEY;X25ZFj00<FY[/FYk/F
Yk/00QJX^`8FZK`01AJZ_1J[_1J[_1J/_AN/_@025jfm00<G[[dG[[hG[kh0
0QN`_P055k6n5k6o5k:o5k:o5k>o008H]<000lSPf8S0^8S0^00;R<2h00=8
T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004
B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0800800
1i^WlOoooo>P[_ARK_ooooN9UoW=e002oooo00?cX:kooolc@jD01P00P080
0H0200:00P03P@0300B100F100F100801X800`07PP47PP48PP020@V30P4:
P`070@^30@^40@b40@b40@f40@j40@j500823hD20Q2500<24HH24XH24XH0
0P8CQP8258L20QF700<25XL35hP35hP00P<HR0030aV80aV90aZ900836hT0
10<LR@<LRP<MRP<MRP847XX00`@OR`@PR`@PR`02126;0P@RS00512><12B<
12B<12F=1BF=00859Xd00`DWS@DWSPDXSP021BV>00L5:Xh5:Xl5:hl5:hl5
;8l5;Hl6;I000PH^T086;i021S2A00<6<I46<Y46<Y400PHcTP031SBB1cBB
1cFB0087=Y<21cNC00L7>9<7>9@7>I@7>I@7>Y@7>i@7>iD00PPlU@88?ID0
0`PnUPPoUPPoUP02242F0PQ1U`88@YL00`Q3U`U4V0U4V0022DFH00<9AYP9
AYT9AiT00PU8V@042DVI2DVJ2DZJ2DZJ0PY;VP032TbK2TfK2TfK008:CY/2
2TnL00D:D9`:DI`:DI`:DYd;DYd00P]CW@032eBM2eBN2eFN008;EYh01`]G
WP]GW`]HW`]HW`]IW`]JW`aJX00235^P0PaLX08<GJ400`aNX@aOX@aOX@02
362R00<<HJ8=HJ8=HZ800PeSX`8=I:<01`eUX`eUY0eVY0eVY0eWY0eXY0eX
Y@023VVU0PiZY@033V^V3VbV3VbV008>KJH23VjW0Pi_Y`033W2W3g6X3g6X
008?LZP00`mcZ0mcZ@mdZ@023gFY00@?MZT?MZX?MjX?MjX247RZ00<@NJ/@
NZ/@NZ/00Q1kZ`8@O:`01A1m[11n[11n[11o[A5o[@024H2]00<APJdAPJhA
PZh00Q63[P074HB^4HB_4HF_4HF_4HJ_4HN_4XN`008BR;024XV`0Q::/@03
4X^a4Xba4Xba008BSK800a:>/Q>>/Q>?/P024i2c0Q>A/`074i:c4i:d4i>d
4i>d4iBd4iFd4iFe008DU[D259Ne00<DV;HDVKHDVKH00QBJ]P8DVkL259bg
00<DWKLEW[PEW[P00QFO^0035J2h5J2i5J6i008EX[T011FS^AFS^QFT^QFT
^P8FYKX00aJV^aJW^aJW^`025ZRk0QJY_0055ZZl5Z^l5Z^l5Zbm5jbm008G
[Kd00aN^_AN^_QN__P025k2n00DG/KhG/KlG/[lG/[lG/kl00QRd`003b>3H
R<2hR<2h00^8`;P00dR@R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P0
3HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0<008002i^WlOoooon9Oooooo>P[_6CXOooooomoo>P[_oko3=3Y@060020
0P01P0800X0200>100<018401H401H400P06PP0300N20@N20@R200812H<2
0@Z300L12h<12h@138@138@13H@13X@13XD00P8?Q@8248D00`8AQP8BQP8B
QP020Q>60P8DQ`825HL00`8FQ`<GR0<GR0020aR800<36HP36HT36XT00P<K
R@040ab90ab:0af:0af:0P@NRP0311n;122;122;00848H/212:<00D48h`4
98`498`49Hd59Hd00PDVS@031BN=1BN>1BR>0085:Hh01`DZSPDZS`D[S`D[
S`D/S`D]S`H]T0021Rj@0PH_T086<9400`HaT@HbT@HbT@021S>B00<6=987
=987=I800PLfT`87=i<01`LhT`LhU0LiU0LiU0LjU0LkU0LkU@0223bE0PPm
U@0323jF23nF23nF0088@9H2246G0PQ2U`0324>G2DBH2DBH0089AIP00`U6
V0U6V@U7V@022DRI00@9BIT9BIX9BYX9BYX22T^J00<:C9/:CI/:CI/00PY>
V`8:Ci`01@Y@W0YAW0YAW0YBW@]BW@022e>M00<;E9d;E9h;EIh00P]FWP07
2eNN2eNO2eRO2eRO2eVO2eZO35ZP008<Fj0235bP0PaMX@0335jQ35nQ35nQ
008<H:800`aQXPeQXPeRXP023F>S0PeTX`073FFS3FFT3FJT3FJT3FNT3FRT
3FRU008>JJD23VZU00<>JjH>K:H>K:H00Pi]YP8>KZL23VnW00<>L:L?LJP?
LJP00PmbZ0033g>X3g>Y3gBY008?MJT010mfZ@mfZPmgZPmgZP8@N:X00a1i
Za1jZa1jZ`0247^[0Q1l[00547f/47j/47j/47n]4Gn]008AP:d00a61[A61
[Q62[P024H>^00LAQ:hAQ:lAQJlAQJlAQZlAQjlBQk000Q:8/08BRK024XZa
00<BRk4BS;4BS;400Q:=/P034Xjb4hjb4hnb008CT;<24i6c00LCT[<CT[@C
Tk@CTk@CU;@CUK@CUKD00QBF]@8DUkD00aBH]QBI]QBI]P0259Zf0QBK]`8D
W;L00aBM]aFN^1FN^0025Inh00<EX;PEX;TEXKT00QFR^@045J>i5J>j5JBj
5JBj0QJU^P035ZJk5ZNk5ZNk008FZ;/25ZVl00DFZ[`FZk`FZk`F[;dG[;d0
0QN]_@035jjm5jjn5jnn008G/;h01ANa_QNa_aNb_aNb_aNc_`026;C03lSP
f0030000b>3Hb>3H00g8h=P00`0001Rd`1Rd`00?b>3H00<0000H]<0H]<00
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0@00803VjOa00KoooocX:kd
]Kof_<GkfMXc@jD700200P01P0800X0200>100<018401H401H400P06PP03
00N20@N20@R200812H<20@Z300L12h<12h@138@138@13H@13X@13XD00P8?
Q@8248D00`8AQP8BQP8BQP020Q>60P8DQ`825HL00`8FQ`<GR0<GR0020aR8
00<36HP36HT36XT00P<KR@040ab90ab:0af:0af:0P@NRP0311n;122;122;
00848H/212:<00D48h`498`498`49Hd59Hd00PDVS@031BN=1BN>1BR>0085
:Hh01`DZSPDZS`D[S`D[S`D/S`D]S`H]T0021Rj@0PH_T086<9400`HaT@Hb
T@HbT@021S>B00<6=987=987=I800PLfT`87=i<01`LhT`LhU0LiU0LiU0Lj
U0LkU0LkU@0223bE0PPmU@0323jF23nF23nF0088@9H2246G0PQ2U`0324>G
2DBH2DBH0089AIP00`U6V0U6V@U7V@022DRI00@9BIT9BIX9BYX9BYX22T^J
00<:C9/:CI/:CI/00PY>V`8:Ci`01@Y@W0YAW0YAW0YBW@]BW@022e>M00<;
E9d;E9h;EIh00P]FWP072eNN2eNO2eRO2eRO2eVO2eZO35ZP008<Fj0235bP
0PaMX@0335jQ35nQ35nQ008<H:800`aQXPeQXPeRXP023F>S0PeTX`073FFS
3FFT3FJT3FJT3FNT3FRT3FRU008>JJD23VZU00<>JjH>K:H>K:H00Pi]YP8>
KZL23VnW00<>L:L?LJP?LJP00PmbZ0033g>X3g>Y3gBY008?MJT010mfZ@mf
ZPmgZPmgZP8@N:X00a1iZa1jZa1jZ`0247^[0Q1l[00547f/47j/47j/47n]
4Gn]008AP:d00a61[A61[Q62[P024H>^00LAQ:hAQ:lAQJlAQJlAQZlAQjlB
Qk000Q:8/08BRK024XZa00<BRk4BS;4BS;400Q:=/P034Xjb4hjb4hnb008C
T;<24i6c00LCT[<CT[@CTk@CTk@CU;@CUK@CUKD00QBF]@8DUkD00aBH]QBI
]QBI]P0259Zf0QBK]`8DW;L00aBM]aFN^1FN^0025Inh00<EX;PEX;TEXKT0
0QFR^@045J>i5J>j5JBj5JBj0QJU^P035ZJk5ZNk5ZNk008FZ;/25ZVl00DF
Z[`FZk`FZk`F[;dG[;d00QN]_@035jjm5jjn5jnn008G/;h01ANa_QNa_aNb
_aNb_aNc_`0f6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^1@00802
00600P02P0800h400`04P@05P@05P@0200J200<01h811h8128800P49P`81
2X<01`4;P`4;Q04<Q04<Q04=Q04>Q04>Q@020Pn50P8@Q@030Q660Q:60Q:6
00824hH20QB70P8EQ`030QJ70aN80aN8008368P00`<IR0<IR@<JR@020a^9
00@378T378X37HX37HX211j:00<47h/488/488/00P@QR`848X`01@@SS0@T
S0@TS0@US@DUS@021BJ=00<59hd59hh5:8h00PDYSP071BZ>1BZ?1B^?1B^?
1Bb?1Bf?1Rf@0086;Y021Rn@0PH`T@031S6A1S:A1S:A0086<i800`HdTPLd
TPLeTP021cJC0PLgT`071cRC1cRD1cVD1cVD1cZD1c^D1c^E0088?9D223fE
00<8?YH8?iH8?iH00PQ0UP88@IL224:G00<8@iL9A9P9A9P00PU5V0032DJH
2DJI2DNI0089B9T010U9V@U9VPU:VPU:VP8:BiX00`Y<V`Y=V`Y=V`022TjK
0PY?W0052U2L2U6L2U6L2U:M2e:M008;Did00`]DW@]DWP]EWP022eJN00L;
Eih;Eil;F9l;F9l;FIl;FYl<FZ000PaKX08<G:0235fQ00<<GZ4<Gj4<Gj40
0PaPXP03366R3F6R3F:R008=Hj<23FBS00L=IJ<=IJ@=IZ@=IZ@=Ij@=J:@=
J:D00PiYY@8>JZD00`i[YPi/YPi/YP023VfV0Pi^Y`8>KjL00`i`Y`maZ0ma
Z0023g:X00<?LjP?LjT?M:T00PmeZ@043gJY3gJZ3gNZ3gNZ0Q1hZP0347V[
47Z[47Z[008@Nj/247b/00D@OJ`@OZ`@OZ`@OjdAOjd00Q60[@034H6]4H6^
4H:^008APjh01a64[Q64[a65[a65[a66[a67[a:7/0024XR`0Q:9/08BR[40
0a:;/A:</A:</@024Xfb00<BS[8CS[8CSk800Q>@/`8CTK<01a>B/a>B]1>C
]1>C]1>D]1>E]1>E]@0259Je0QBG]@0359Rf59Vf59Vf008DV[H259^g0QBL
]`0359fg5Ijh5Ijh008EWkP00aFP^1FP^AFQ^@025J:i00@EXkTEXkXEY;XE
Y;X25ZFj00<FY[/FYk/FYk/00QJX^`8FZK`01AJZ_1J[_1J[_1J/_AN/_@02
5jfm00<G[[dG[[hG[kh00QN`_P055k6n5k6o5k:o5k:o5k>o03HH]<02R<2h
0DR@R04000000003R<2hb>3HR<2h0?n8`;R<R<2h0DR@R04000000003R<2h
b>3HR<2h0?n8`;R<R<2h0DR@R04000000003R<2hb>3Hb>3H0?o8h=R<b>3H
0DR@R04000000?n8`;R@R<2h0@000000\
\>"], "Graphics",
  ImageSize->{400, 300},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006@0001;2000`400?l0
0000o`00003oooo`l?2Aoo3`l000ooo`l?2Aoo3`l000ooo`l?2Aoo3`l000
ooo`l?2Aoo3`l000ooo`l?2Aoo3`l000ooo`l?2Aoo3`l000ooo`l?2Aoo3`
l000ooo`l?2Aoo3`l000ooo`l?2Aoo3`l000ooo`l?2Aoo3`l000ooo`l?2A
oo3`l000ooo`l?2Aoo3`l000ooo`l?2Aoo3`l000ooo`l?2Aoo3`l000ooo`
l?2Aoo3`l000oooooonAooooo`00ooo^k^jAonk^kP00oooVi^JAonKViP00
ooo^k^jAonk^kP00oooooonAooooo`00ooo^k^jAonk^kP00oooVi^JAonKV
iP00ooo^k^jAonk^kP00oooooonAooooo`00ooo^k^jAonk^kP00oooVi^JA
onKViP00ooo^k^jAonk^kP00oooooonAooooo`00ooo^k^jAonk^kP00oooV
i^JAonKViP00ooo^k^jAonk^kP00oooooonAooooo`00ooo^k^jAonk^kP00
oooVi^JAonKViP00ooo^k^jAonk^kP00oooooonAooooo`00ooo^k^jAonk^
kP00oooVi^JAonKViP00ooo^k^jAonk^kP00oooooonAooooo`00ooo^k^jA
onk^kP00oooVi^JAonKViP00ooo^k^jAonk^kP00oooooonAooooo`00ooo^
k^jAonk^kP00oooVi^JAonKViP00ooo^k^jAonk^kP00oooooonAooooo`00
ooo^k^jAonk^kP00oooVi^JAonKViP00ooo^k^jAonk^kP00oooooonAoooo
o`00ooo^k^jAonk^kP00oooVi^JAonKViP00ooo^k^jAonk^kP00oooooonA
ooooo`00ooo^k^jAonk^kP00oooVi^JAonKViP00ooo^k^jAonk^kP00oooo
oonAooooo`00ooo^k^jAonk^kP00oooVi^JAonKViP00ooo^k^jAonk^kP00
oooooonAooooo`00ooo^k^jAonk^kP00oooVi^JAonKViP00ooo^k^jAonk^
kP00oooooonAooooo`00ooo^k^jAonk^kP00oooVi^JAonKViP00ooo^k^jA
onk^kP00oooooonAooooo`00ooo^k^jAonk^kP00oooVi^JAonKViP00ooo^
k^jAonk^kP00oooooonAooooo`00ooo^k^jAonk^kP00oooVi^JAonKViP00
ooo^k^jAonk^kP00oooooonAooooo`00ooo^k^jAonk^kP00oooVi^JAonKV
iP00ooo^k^jAonk^kP00oooooonAooooo`00ooo^k^jAonk^kP00oooVi^JA
onKViP00ooo^k^jAonk^kP00oooooonAooooo`00ooo^k^jAonk^kP00oooV
i^JAonKViP00ooo^k^jAonk^kP00oooooonAooooo`00ooo^k^jAonk^kP00
oooVi^JAonKViP00ooo^k^jAonk^kP00oooooonAooooo`00ooo^k^jAonk^
kP00oooVi^JAonKViP00ooo^k^jAonk^kP00oooooonAooooo`00ooo^k^jA
onk^kP00oooVi^JAonKViP00ooo^k^jAonk^kP00oooooonAooooo`00ooo^
k^jAonk^kP00oooVi^JAonKViP00ooo^k^jAonk^kP00oooooonAooooo`00
ooo^k^jAonk^kP00oooVi^JAonKViP00ooo^k^jAonk^kP00oooooonAoooo
o`00ooo^k^jAonk^kP00oooVi^JAonKViP00ooo^k^jAonk^kP00oooooonA
ooooo`00ooo^k^jAonk^kP00oooVi^JAonKViP00ooo^k^jAonk^kP00oooo
oonAooooo`00ooo^k^jAonk^kP00oooVi^JAonKViP00ooo^k^jAonk^kP00
oooooonAooooo`00ooo^k^jAonk^kP00oooVi^JAonKViP00ooo^k^jAonk^
kP00oooooonAooooo`004Oo^k^iGong]kOook^k^:Oo^k^h000CoiNGU00Co
i^KVonCTi?oTi>CoiNGU1OoTi>@00ooUiNGoi>CTonCTi004onCTi004onGU
iOoTi>Coi>CTonGUi@Goi>CT00?oiNGUonCTi?oTi>@01?oTi>@01?oUiNGo
i>CTonCTi?oUiND5onCTi003onGUiOoTi>Coi>CT00Coi>CT00CoiNGUonCT
i?oTi>CoiNGU1OoTi>@00ooUiNGoi>CTonCTi004onCTi004onGUiOoTi>Co
i>CTonGUi@Goi>CT00?oiNGUonCTi?oTi>@01?oTi>@01?oUiNGoi>CTonCT
i?oUiND5onCTi003onGUiOoTi>Coi>CT00Coi>CT00CoiNGUonCTi?oTi>Co
iNGU1OoTi>@00ooUiNGoi>CTonCTi004onCTi004onKVi_oUiNGoiNGUonKV
iP;oiNGUoooVi^HGonKViP0000GokNg]onc/k?o]kNgok>c/on_[j`02onc/
k004on_[jooZj^[ojn_[on[ZjP;ojn_[00Coj^[Zon_[joo[jn_ojn_[0ooZ
j^X01OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Coj^[Z00?ojNWYon[Zj_oZj^X0
1?oZj^X01OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Coj^[Z00?ojNWYon[Zj_oZ
j^X01?oZj^X01OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Coj^[Z00?ojNWYon[Z
j_oZj^X01?oZj^X01OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Coj^[Z00?ojNWY
on[Zj_oZj^X01?oZj^X01OoYjNWoj^[Zon[Zj_oZj^[ojNWY00Coj^[Z00?o
jNWYon[Zj_oZj^X01?oZj^X00ooYjNWoj^[Zon[ZjP02on[ZjP05on_[jooZ
j^[ojn_[on_[jooZj^X01?o[jn/2onc/k005on_[joo/k>cok>c/ong]kOo/
k>`00_o]kNd00oo^k^kokNg]ong]k@3oonk^kQ?ok^k^00001_olo?cono_k
ooclo?olo?con_[joo_kn`?on_[j00Con?ShooWinOohn?SonOWiGoohn?P3
ooWin@08ooShn?ojn_[onOWioo[jn_okno_on_[jooclo?okno/3ooclo0?o
oOgm0oono_kooooooa7ooooo0003onWYj@;oj>SX0_oWinL4onKViP?oiNGU
2?oTi>@01?oUiNGoi>CTonCTi?oUiND<onCTi004onGUiOoTi>Coi>CTonGU
i@coi>CT00CoiNGUonCTi?oTi>CoiNGU3?oTi>@01?oUiNGoi>CTonCTi?oU
iND<onCTi004onGUiOoTi>Coi>CTonGUi@coi>CT00GoiNGUonCTi?oTi>Co
iNGUonCTi003onGUi@;oi^KV00CoiNGUonOWiooWinOoinOW0_oXj>P00ooZ
j^[ojNWYon[ZjP03on_[j`03ong]kOo/k>cok>c/00;okNg]0_o^k^h00oo]
kNgok^k^onk^kP3oonk^kP_ok^k^00002OoQhN7oh>3PomoOgooOgmoogMgM
omcLg?oMgMgog=cLom_Kf`03om[JfP07omWIfOoJf][of][JomWIfOoJf][o
fMWIomSHf002omWIf@07omSHf?oIfMWofMWIomWIfOoHf=SofMWIomSHf006
omWIf@04omSHf?oIfMWofMWIomSHf0?ofMWI00?of=SHomWIfOoHf=P01_oI
fMT01?oHf=SofMWIomWIfOoHf=P3omWIf@03omSHf?oIfMWof=SH00KofMWI
00Cof=SHomWIfOoIfMWof=SH0ooIfMT00ooHf=SofMWIomSHf006omWIf@04
omSHf?oIfMWofMWIomSHf0?ofMWI00?of=SHomWIfOoHf=P01_oIfMT01?oH
f=SofMWIomWIfOoHf=P7omWIf@04om_KfooJf][ofm_Kom_Kf`;og=cL0_oM
gMd01_oNg]kogmoOon3Ph?oPh>3ohN7Qon;RhP;ohn?S0ooTi>@00ooVi^Ko
iNGUonKViP3oonKViPkoi^KV00000ooVi^KoiNGUonCTi002on?Sh`03on;R
h_oQhN7oh>3P00;ogmoO0_oNg]h2omgMg@Wog=cL00CogMgMomcLg?oLg=co
gMgM3?oLg=`01?oMgMgog=cLomcLg?oMgMd<omcLg004omgMgOoLg=cog=cL
omgMg@cog=cL00CogMgMomcLg?oLg=cogMgM3?oLg=`01?oMgMgog=cLomcL
g?oMgMd<omcLg003omgMgOoLg=cog=cL00?ogMgM00Sog]kNomgMgOoOgmoo
gmoOon3Ph?oQhN7oh^;Ron?Sh`;oi>CT0_oVi^H00ooXj>SojNWYonWYj@02
on[ZjP03on_[joo/k>cok>c/00;okNg]ooo^k^h>onk^kP000_odm?@01?ob
l_;olO7aono_koo^k^h2onc/k0;oj^[Z00?oj>SXonWYjOoWinL01?oWinL5
onKViP07onGUiOoVi^Koi^KVonKVi_oUiNGoi^KVonGUi@09onKViP07onGU
iOoVi^Koi^KVonKVi_oUiNGoi^KVonGUi@09onKViP07onGUiOoVi^Koi^KV
onKVi_oUiNGoi^KVonGUi@09onKViP07onGUiOoVi^Koi^KVonKVi_oUiNGo
i^KVonGUi@09onKViP07onGUiOoVi^Koi^KVonKVi_oUiNGoi^KVonGUi@09
onKViP05onGUiOoVi^KoinOWonOWiooVi^H00_oWinL03_oXj>SojNWYon[Z
j_oZj^[ok>c/ong]kOo^k^kokno_oo3`l?obl_;olo?cooGemOofm_Kon?Sh
0_oinOT00oojn_[oo?cloogmo@02oogmo@03ookno_oooooooooo0?oooooo
3?ooool00009on?ShooPh>3og]kNomgMgOoLg=cof][JomWIfOoHf=Soe]KF
00?oe=CD00Cod];Bom?CdooBd];od];B0_oAdM400oo@d=3odM7Aom7Ad@0=
om7Ad@03om3@d?oAdM7odM7A00godM7A00?od=3@om7AdOoAdM403OoAdM40
0oo@d=3odM7Aom7Ad@0=om7Ad@03om3@d?oAdM7odM7A00godM7A00?od=3@
om7AdOoAdM401OoAdM400ooBd];odm?Com;BdP02omCDe00<omGEeOoFe]Ko
emOGomSHf?oJf][og=cLomgMgOoOgmoohN7Qon?ShooTi>CoiNGU0_oWinL0
0ooYjNWoj^[Zon[ZjP02onc/k0;okNg]ooo^k^h=onk^kP0000_of=SHomOG
eooDe=Cod];Bom3@d?o>c/koc<c<ol_;boo:b/[obLW9olO7a`02olK6aP04
olG5aOo4a<Coa<C4ol?3``?oa<C400?o`l?3olC4a?o3`l<01?o4a<@00oo3
`l?oa<C4olC4a003ol?3``?oa<C400?o`l?3olC4a?o3`l<01?o4a<@00oo3
`l?oa<C4olC4a003ol?3``?oa<C400?o`l?3olC4a?o3`l<01?o4a<@00oo3
`l?oa<C4olC4a003ol?3``?oa<C400?o`l?3olC4a?o3`l<01?o4a<@00oo3
`l?oa<C4olC4a003ol?3``?oa<C400?o`l?3olC4a?o3`l<01?o4a<@00oo3
`l?oa<C4olC4a003ol?3``?oa<C400?o`l?3olC4a?o3`l<00_o4a<@01?o5
aLGoa<C4olG5aOo6a/H2olO7a`0EolS8b?o:b/[oc<c<olg=cOo?clood=3@
om;Bd_oCdm?oe]KFomSHf?oJf][og=cLomgMgOoOgmooh>3Pon7QhOoRh^;o
hn?SonGUiOoTi>CoiNGU0?ooi^KV3OoVi^H0000?omcLg?oJf][of=SHomCD
e?oCdm?odM7Aolo?coo=cLgobl_;ol[:b_o8b<SoalO7olG5aOo6a/KoaLG5
00;oa<C400Ko`l?3olC4a?o3`l?oa<C4ol?3`oo4a<@2ol?3``03olC4a?o3
`l?oa<C400;o`l?300Woa<C4ol?3`oo3`l?o`l?3olC4a?o3`l?oa<C4ol?3
`oo4a<@00_o3`l<00oo4a<Co`l?3olC4a002ol?3``09olC4a?o3`l?o`l?3
ol?3`oo4a<Co`l?3olC4a?o3`l?oa<C400;o`l?300?oa<C4ol?3`oo4a<@0
0_o3`l<02Oo4a<Co`l?3ol?3`oo3`l?oa<C4ol?3`oo4a<Co`l?3olC4a002
ol?3``03olC4a?o3`l?oa<C400;o`l?300Woa<C4ol?3`oo3`l?o`l?3olC4
a?o3`l?oa<C4ol?3`oo4a<@00_o3`l<00oo4a<Co`l?3olC4a002ol?3``0:
olC4a?o3`l?o`l?3ol?3`oo4a<Co`l?3olC4a?o3`l?oa<C4ol?3``;oa<C4
01CoaLG5olK6a_o5aLGoalO7olS8b?o:b/[obl_;olg=cOo?cloodM7Aom?C
dooEeMGof=SHom_KfooLg=coh>3Pon7QhOoShn?oiNGUonOWi`;ojNWY0_o[
jn/2ong]kOook^k^3Oo^k^h00009onWYjOoVi^Kohn?SomoOgooLg=cof][J
omOGeooEeMGodm?C00;od=3@0_o=cLd01?o;bl_ob/[:ol[:b_o9bLT2ol[:
bPGobLW900Gob/[:olW9bOo:b/[obLW9ol[:bP02olW9b@04ol[:b_o9bLWo
b/[:ol[:bPGobLW900Gob/[:olW9bOo:b/[obLW9ol[:bP02olW9b@04ol[:
b_o9bLWob/[:ol[:bPGobLW900Gob/[:olW9bOo:b/[obLW9ol[:bP02olW9
b@04ol[:b_o9bLWob/[:ol[:bPGobLW900Gob/[:olW9bOo:b/[obLW9ol[:
bP02olW9b@04ol[:b_o9bLWob/[:ol[:bPGobLW900Gob/[:olW9bOo:b/[o
bLW9ol[:bP02olW9b@04ol[:b_o9bLWob/[:ol[:bPGobLW901cob/[:olW9
bOo:b/[obl_;olg=cOo>c/koclo?om7AdOoCdm?oeMGEomOGeooJf][og=cL
omoOgooRh^;oi^KVon[Zj_o/k>cokno_oo7alOodm?ComOGeooShn?oinOWo
n_[jooclo?omoOgoo_knooooool=ooooo`0000goeMGEom;Bd_o?cloobl_;
olS8b?o6a/Ko`l?3ol30`?nm_Kgo_;blokZj^_nh^;So]kNg00;o]KFe0_nd
];@3ok>c/`03okBd]?nc/k?o/k>c00So/k>c00?o];Bdok>c/onc/k<00_nc
/k<00ond];Co/k>cok>c/`08ok>c/`03okBd]?nc/k?o/k>c00;o/k>c00?o
];Bdok>c/onc/k<02?nc/k<00ond];Co/k>cok>c/`02ok>c/`03okBd]?nc
/k?o/k>c00So/k>c00?o];Bdok>c/onc/k<00_nc/k<00ond];Co/k>cok>c
/`08ok>c/`03okBd]?nc/k?o/k>c00;o/k>c00?o];Bdok>c/onc/k<00_nc
/k<01_nd];Co]KFeokFe]Ong]kOo^;RhokZj^P;o_Kfm013o`<30ol;2`_o6
a/Kob<S8ol_;boo@d=3od];BomGEeOoIfMWogMgMomoOgooQhN7oi>CTonKV
i_oXj>SojNWY0_o[jn/00oo]kNgok^k^onk^kP02onk^kP03ong]kOo^k^ko
k^k^0?ook^k^1_o^k^h0000<olc<c?o8b<Soa<C4okno_onl_;co^;RhokFe
]Onc/k?o/K6aojj^[_n[Zj_oZZZZ0_nXZ:P00onVYZKoYJFUojFUY@02ojFU
Y@04ojBTY?nUYJGoY:BTojBTY0;oYJFU0_nTY:@00onUYJGoY:BTojFUY@02
ojBTY0?oYJFU00CoY:BTojFUYOnTY:CoY:BT0_nUYJD2ojBTY003ojFUYOnT
Y:CoYJFU00;oY:BT0onUYJD01?nTY:CoYJFUojBTY?nTY:@2ojFUY@;oY:BT
00?oYJFUojBTY?nUYJD00_nTY:@3ojFUY@04ojBTY?nUYJGoY:BTojBTY0;o
YJFU0_nTY:@00onUYJGoY:BTojFUY@02ojBTY0?oYJFU00CoY:BTojFUYOnT
Y:CoY:BT0_nUYJD2ojBTY003ojFUYOnTY:CoYJFU00;oY:BT0onUYJD01?nT
Y:CoYJFUojBTY?nTY:@3ojFUY@0HojJVY_nXZ:SoZ:RXojZZZ_n[Zj_o[Zj^
ok2`/?nc/k?o][JfokRh^?nl_;co_knoolC4a?o8b<Soc<c<olk>c_oBd];o
eMGEomSHf?oKfm_og=cLomoOgooPh>3oh^;R0_oTi>@2onGUiOooi^KV2ooV
i^H0000?olo?coo9bLWoaLG5ol71`Onl_;co^KViokFe]Ona/K7o[jn_ojb/
[?nYZJWoZ:RXojFUYOnTY:CoXZ:R00;oXJ6Q00?oX:2Poj6QXOnPX:000onQ
XJ400onPX:3oXJ6Qoj6QX@05oj6QX@05oj2PX?nQXJ7oX:2Poj6QXOnPX:00
0onQXJ400onPX:3oXJ6Qoj6QX@05oj6QX@05oj2PX?nQXJ7oX:2Poj6QXOnP
X:000onQXJ400onPX:3oXJ6Qoj6QX@05oj6QX@05oj2PX?nQXJ7oX:2Poj6Q
XOnPX:000onQXJ400onPX:3oXJ6Qoj6QX@05oj6QX@05oj2PX?nQXJ7oX:2P
oj6QXOnPX:000onQXJ400onPX:3oXJ6Qoj6QX@05oj6QX@05oj2PX?nQXJ7o
X:2Poj6QXOnPX:000onQXJ407_nPX:3oXJ6Qoj6QXOnRXZ;oY:BTojFUYOnW
YjOoZJVYojb/[?n_[joo/K6aokFe]Oni^KWo_;blol71`Oo5aLGobLW9olo?
cooBd];oemOGom_KfooNg]koh>3Pon?ShooVi^Koj>SXonWYjOo[jn_ok>c/
ong]k@;ok^k^00?okNg]onk^k_o^k^h0ooo^k^h7onk^kP0000gof=SHomCD
e?o>c/kob<S8ol;2`_nn_[ko^[ZjokJf]_nb/[;o[jn_ojb/[?nYZJWoYjNW
00;oYJFU00CoY:BToj:RX_nRXZ;oXJ6Q0_nRXZ800onQXJ7oXZ:Roj6QX@02
oj:RXP;oXJ6Q00OoXZ:Roj6QXOnRXZ;oXZ:Roj6QXOnRXZ;oXJ6Q00;oXZ:R
00?oXJ6Qoj:RX_nQXJ400_nRXZ82oj6QX@07oj:RX_nQXJ7oXZ:Roj:RX_nQ
XJ7oXZ:Roj6QX@02oj:RXP03oj6QXOnRXZ;oXJ6Q00;oXZ:R0_nQXJ401onR
XZ;oXJ6Qoj:RX_nRXZ;oXJ6Qoj:RX_nQXJ400_nRXZ800onQXJ7oXZ:Roj6Q
X@02oj:RXP;oXJ6Q00OoXZ:Roj6QXOnRXZ;oXZ:Roj6QXOnRXZ;oXJ6Q00;o
XZ:R00?oXJ6Qoj:RX_nQXJ400_nRXZ82oj6QX@07oj:RX_nQXJ7oXZ:Roj:R
X_nQXJ7oXZ:Roj6QX@02oj:RXP04oj6QXOnRXZ;oXJ6Qoj>SX`;oY:BT01[o
YJFUojNWYonYZJWo[Jf]ojn_[onb/[;o]kNgokZj^_nn_[ko`/;2olO7aoo>
c/kodm?ComWIfOoNg]koh^;RonOWioo[jn_ok^k^oo;bl_oemOGomoOgoo[j
n_okno_ooOgmookno_oooooo3?ooool0000>olK6a_o1`L7o^k^kokFe]On_
[jooZj^[ojJVY_nRXZ;oWYjNoi^KVonHV9SoUIFEoi>CTonATI42ohn?S`03
ohj>S_n=SHgoSXj>00CoSHf=00KoSXj>ohf=SOn=SHgoSXj>ohf=SOn>SXh2
ohf=S@04ohj>S_n=SHgoSHf=ohj>SPCoSHf=00KoSXj>ohf=SOn=SHgoSXj>
ohf=SOn>SXh2ohf=S@04ohj>S_n=SHgoSHf=ohj>SPCoSHf=00KoSXj>ohf=
SOn=SHgoSXj>ohf=SOn>SXh2ohf=S@04ohj>S_n=SHgoSHf=ohj>SPCoSHf=
00KoSXj>ohf=SOn=SHgoSXj>ohf=SOn>SXh2ohf=S@04ohj>S_n=SHgoSHf=
ohj>SPCoSHf=00KoSXj>ohf=SOn=SHgoSXj>ohf=SOn>SXh2ohf=S@0408j>
SP2=SHd0SHf=08j>SP80SHf=0`3oool06P2>SXh0Shn?092@T02ATI40Ti>C
09FEU@2GUiOoVi^KoijNW_nRXZ;oYjNWoj^[Zon_[joo][JfokZj^_o1`L7o
a/K6olc<c?oAdM7oeMGEomWIfOoMgMgoh>3PonCTi?oVi^KojNWY0_o[jn/0
0oo]kNgok^k^onk^kP3oonk^kP[ok^k^00003onl_;co][Jfojn_[onZZZ[o
YJFUoinOWonJVY[oUYJFoi:BT_n>SXkoRh^;ohR8R?n6QXKoQ8B4oh:2PP02
oh61PDkoP8201@20P800803oool000000000003oool0PH610820P022PX80
Q8B408J6QP29RHT0RXZ:ohn?SonBTY;oUIFEoiZJV_nOWiooYJFUojZZZ_n_
[joo]kNgokbl_?o2`/;oalO7ol_;boo@d=3oe=CDomSHf?oKfm_og]kNomoO
gooRh^;oi>CT0_oVi^H00ooUiNGoi^KVonKViP3oonKViPSoi^KV00004?no
_koo^KViok:b/_n[Zj_oY:BToinOWonIVIWoUIFEoi2@T?n<S8coR8R8ohJ6
Q_n3Ph?oP820ogmoOomnOWh3ogalO0;oNg]k00KoO7alog]kNomlO7coNg]k
ogalO?mkNg/2ogalO003og]kNomlO7coO7al00?oO7al0_mkNg/01_mlO7co
Ng]kogalO?mkNg_oO7alog]kN`;oO7al00?oNg]kogalO?mlO7`00omlO7`2
og]kN`06ogalO?mkNg_oO7alog]kNomlO7coNg]k0_mlO7`00omkNg_oO7al
ogalO003ogalO0;oNg]k00KoO7alog]kNomlO7coNg]kogalO?mkNg/2ogal
O003og]kNomlO7coO7al00?oO7al0_mkNg/01_mlO7coNg]kogalO?mkNg_o
O7alog]kN`;oO7al00?oNg]kogalO03oool00`1lO7`0801kNg/0oooo0000
00000000oooo07alO01nOWh0Ogmo0861P@23Ph<0QHF508R8R?n<S8coTI6A
oiBDU?nJVY[oWinOojBTY?n[Zj_o/[:bokVi^Ono_kooa/K6ol_;booAdM7o
e]KFomWIfOoNg]koh^;RonCTi?oWinOoj^[Z0_o/k>`3onk^kP03ong]kOo^
k^kok^k^0?ook^k^1_o^k^h0000BolW9bOo1`L7o^[Zjok:b/_n[Zj_oY:BT
oijNW_nIVIWoU9BDohj>S_n;Rh_oR8R8ohF5QOn2PX;oP820oginO_mmOGgo
O7al0_mmOGd01?mlO7coOGemogalO?mmOGd2ogalO005ogemOOmlO7coOGem
ogalO?mmOGd00omlO7`2ogemO@04ogalO?mmOGgoO7alogemO@;oO7al00Go
OGemogalO?mmOGgoO7alogemO@03ogalO0;oOGem00CoO7alogemOOmlO7co
OGem0_mlO7`01OmmOGgoO7alogemOOmlO7coOGem00?oO7al0_mmOGd01?ml
O7coOGemogalO?mmOGd2ogalO005ogemOOmlO7coOGemogalO?mmOGd00oml
O7`2ogemO@04ogalO?mmOGgoO7alogemO@;oO7al00GoOGemogalO?mmOGgo
O7alogemO@020?ooo`0307alO01mOGd0oooo0080000001l0oooo07emO@1m
OGd0OWin07moO`21PH40QHF508R8R02<S8coSXj>oiBDU?nIVIWoWinOojFU
YOn[Zj_o/[:bokZj^_o2`/;obLW9om3@d?oGemOogMgMon?ShooXj>SokNg]
oo7alOodm?ComoOgoo[jn_olo?cooOgm0?oooooo3?ooool0000@okRh^?nb
/[;oZJVYoj:RX_nKVi_oU9BDohn?Son8R8SoQ8B4oh20P?mlO7coMgMgogEe
MOmaLG7oL71`ofm_K`KoKFe]00CoKVi^ofe]KOm]KFgoKVi^3?m]KFd01?m^
KVkoKFe]ofe]KOm^KVh<ofe]K@04ofi^K_m]KFgoKFe]ofi^KPcoKFe]00Co
KVi^ofe]KOm]KFgoKVi^3?m]KFd01?m^KVkoKFe]ofe]KOm^KVh5ofe]K@05
0?ooo`000000oooo06e]K@3oool00P0000007P3oool0KFe]06i^KP1_Kfl0
LG5a079bLP1eMGD0MgMg07]kNon0P83oPh>3ohV9ROn?ShooU9BDoi^KVonR
XZ;oZZZZok6a/Oni^KWo`<30olO7aoo=cLgodm?ComOGeooLg=coh>3Pon?S
hooWinOojNWYon[ZjP;okNg]00?ok^k^ong]kOo^k^h0ooo^k^h8onk^kP00
017o/K6aojVYZOnPX:3oVIVIoi:BT_n:RX[oQHF5ogmoOomjNW[oMGEeog5a
LOm^KVkoJf][ofUYJOmVIVKoIFEUofATI002of=SH`03ofATI?mSHf?oHf=S
00OoHf=S00CoI6ATof=SHomSHf?oI6AT0_mSHf<00omTI6CoHf=Sof=SH`07
of=SH`04ofATI?mSHf?oHf=SofATI0;oHf=S00?oI6ATof=SHomSHf<01omS
Hf<01?mTI6CoHf=Sof=SHomTI6@2of=SH`03ofATI?mSHf?oHf=S00OoHf=S
00CoI6ATof=SHomSHf?oI6AT0_mSHf<00omTI6CoHf=Sof=SH`07of=SH`03
ofATI?mSHf<0oooo0080000000@0oooo000000000000oooo0P1SHf<206AT
I00L06IVIP1XJ6P0Jf][06m_K`1aLG7oMWIfog]kNomoOgooQHF5oh^;RonB
TY;oV9RHoj6QXOnYZJWo/;2`okNg]onn_[koa<C4ol[:b_o@d=3odm?ComSH
f?oKfm_og]kNon7QhOoShn?oi>CTonGUiOooi^KV2ooVi^H0000BokBd]?n[
Zj_oXj>Soi^KVonCTi?oS8b<ohF5QOn0P83oNWYjogEeMOmaLG7oK6a/ofUY
JOmWIfOoI6ATof=SHomRHV;oH61P3?mQHF401?mPH63oHF5Qof5QHOmPH60<
of5QH@04of1PH?mQHF7oHF5Qof1PH0coHF5Q00CoH61Pof5QHOmQHF7oH61P
3?mQHF401?mPH63oHF5Qof5QHOmPH60<of5QH@03of1PH03oool0000000@0
00001@3oool06`1UIFD0IVIV06UYJ@1/K6`0L71`ogEeMOmjNW[oOgmoohF5
QOn<S8coTi>Coi^KVonSXj?o[:b/okBd]?nl_;coa<C4ol[:b_o?clooe]KF
om[Jf_oOgmooh^;RonGUiOoXj>Soj^[Zong]k@3oonk^kPcok^k^00000ono
_koo][Jfooooo`1Looooo`030?ooo`000000000000H000001`3oool8oooo
o`0>okFe]Ono_koob<S8olo?cooGemOogMgMon?ShooZj^[ok^k^oo;bl_of
m_KonOWiooclo?omoOgoooooo`cooooo00000ona/K7oYjNWooShn002ooSh
n003ooWinOohn?SonOWi00?on?Sh00?onOWiooShn?ohn?P00_ohn?P00ooi
nOWon?ShooShn002ooShn003ooWinOohn?SonOWi00?on?Sh00?onOWiooSh
n?ohn?P00_ohn?P00ooinOWon?ShooShn002ooShn003ooWinOohn?SonOWi
00?on?Sh00?onOWiooShn?ohn?P00_ohn?P00ooinOWon?ShooShn002ooSh
n003ooWinOohn?SonOWi00?on?Sh00?onOWiooShn?ohn?P00_ohn?P00ooi
nOWon?ShooShn002ooShn003ooWinOohn?SonOWi00?on?Sh00?onOWiooSh
n?ohn?P00_ohn?P00ooinOWon?ShooShn002ooShn003ooWinOohn?SonOWi
00?on?Sh00GonOWiooShn?ohn?Son?Sh0?ooo`07000000050?ooo`3hn?P0
n?Sh0?Shn03inOT00`3hn?P00oohn?SonOWiooShn003ooShn00@ooWinOoh
n?SoZ:RXok6a/Onh^;So`<30olS8b?o=cLgoe=CDomWIfOoNg]koh^;RonGU
iOoXj>Soj^[Zong]kOook^k^3?o^k^h00003ojVYZOnPX:3oj^[Z00Woj^[Z
00?ojn_[on[Zj_oZj^X00_oZj^X00oo[jn_oj^[Zon[ZjP08on[ZjP03on_[
jooZj^[oj^[Z00;oj^[Z00?ojn_[on[Zj_oZj^X02?oZj^X00oo[jn_oj^[Z
on[ZjP02on[ZjP03on_[jooZj^[oj^[Z00Soj^[Z00?ojn_[on[Zj_oZj^X0
0_oZj^X00oo[jn_oj^[Zon[ZjP08on[ZjP03on_[jooZj^[oj^[Z00;oj^[Z
00?ojn_[on[Zj_oZj^X02?oZj^X01?o[jn_oj^[Zon[ZjP3oool600000003
0?ooo`3Zj^X0j^[Z00<0j^[Z00<0jn_[0>[ZjP3Zj^X00_oZj^X00oo[jn_o
j^[Zon[ZjP03on[ZjP0@oj2PX?nYZJWo/K6aokVi^Ono_kooa/K6ol_;booA
dM7oeMGEomWIfOoNg]koh>3Pon?ShooTi>Coi^KVonGUiOooi^KV2_oVi^H0
0006ojj^[_nTY:ConOWiooShn?oinOWon?Sh0_oinOT01?ohn?SonOWiooSh
n?oinOT2ooShn003ooWinOohn?Son?Sh00;on?Sh00?omoOgooShn?ohn?P0
0_ohn?P01OogmoOon?ShooShn?ohn?SomoOg00Kon?Sh00?omoOgooShn?oh
n?P00_ohn?P01OogmoOon?ShooShn?ohn?SomoOg00Kon?Sh00?omoOgooSh
n?ohn?P00_ohn?P01OogmoOon?ShooShn?ohn?SomoOg00Kon?Sh00?omoOg
ooShn?ohn?P00_ohn?P01OogmoOon?ShooShn?ohn?SomoOg00Kon?Sh00?o
moOgooShn?ohn?P00_ohn?P01OogmoOon?ShooShn?ohn?SomoOg00;on?Sh
00<0oooo0000000000000`000000103oool0n?Sh0?Shn03gmoL20?Shn004
0?Win@3hn?P0n?Sh0?Win@?on?Sh01?onOWiooShn?oinOWon?ShooWinOnT
Y:Co[Jf]okJf]_nm_Kgoa/K6olc<c?oCdm?ofMWIomgMgOoQhN7oiNGUonSX
j?oZj^[okNg]00?ok^k^00?okNg]onk^k_o^k^h0ooo^k^h6onk^kP0000?o
^;Rhojn_[om@P<L00_m@P<L2odn0aP;oD83700?oCh36oe20aom?P<H00_m@
P<L01?m?P<KoCh37odmoa_m?P<H9odmoaP07odioa_m?OlKoCgo6odmoa_m?
P<KoCgo6odn0aP09odmoaP07odioa_m?OlKoCgo6odmoa_m?P<KoCgo6odn0
aP09odmoaP07odioa_m?OlKoCgo6odmoa_m?P<KoCgo6odn0aP09odmoaP07
odioa_m?OlKoCgo6odmoa_m?P<KoCgo6odn0aP09odmoaP05odioa_m?OlKo
Cgo6odmoaP3oool0100000000`3oool0Cgo604moaP0304moaP030520a`1?
P<H0D8370080D83700?oD837odn0a_m@P<L00om@P<L2odn0aP0>ojj^[_nh
^;So`/;2ol_;booBd];ofm_Kon3Ph?oWinOok>c/oo7alOoemOGon?Shoo_k
noomoOgoooooo`cooooo00000on/[:coXZ:Rodema004odina@06odena?m=
OLCoCGk4odinaOm=O/CoCWk50om=OL@3odal``04odama?olo?cono_koocl
o0?ono_k00Koo?clodal`om=OLCoC7c3odam`om=OL@3odal``04odama?m=
OLCoC7g3odema0;oC7c300OoC7g3odema?m<O<?oCGg4odal`om<OL?oCGg4
00?oC7c300CoC7g4odema?m<OL?oCGg40_m<O<<01om<OL?oCGg4odal`om=
OLCoC7c3odam`om=OL@00om<O<<01?m<OLCoCGg4odam`om=OL@2odal``07
odam`om=OLCoC7c3odema?m<O<?oC7g3odema003odal``04odama?m=OLCo
C7g3odema0;oC7c300OoC7g3odema?m<O<?oCGg4odal`om<OL<0oooo00<0
000000@0oooo04ema01<OL<0CGg40P1<O<<02P1<OL@0CGg404ema01>O/D0
CGg404inaOm>O/GoCGg4odena?m=OL@4odina@0>oj:RX_n[Zj_o];Bdokfm
_Oo4a<Coc<c<om7AdOoHf=SogMgMon7QhOoTi>CoinOWon_[joo]kNd3onk^
kP03ong]kOo^k^kok^k^0?ook^k^1_o^k^h00003ojFUYOnLW9coAW>o00Co
AG>o0_m6Lkl2odEc_`03odIc_om5LkooAG>o00GoA7:n00SoA76modAb__m4
LKgoA7:nodEb__m4L[koA7:modAa_@;oA7:n00?oAG:nodAa_Om4L[h00om4
L[h02?m4LKgoA7:nodAa_Om4L[koAG:nodAb__m4L[goA76m0_m4L[h00om5
L[koA76modAb_P03odAb_P08odAa_Om4L[koA76modAb__m5L[koA7:nodAb
_Om4LKd2odAb_P03odEb__m4LKgoA7:n00?oA7:n00SoA76modAb__m4LKgo
A7:nodEb__m4L[koA7:modAa_@;oA7:n00?oAG:nodAa_Om4L[h00om4L[h0
2?m4LKgoA7:nodAa_Om4L[koAG:nodAb__m4L[goA76m0_m4L[h00om5L[ko
A76m0?ooo`02000000060?ooo`14LKd0A7:n04Aa_@14L[h0AG:n0`14L[h2
04Ec_`0304Ic_`15LkooAG>o00?oAW>o1?m5Lkl03onLW9coYZJVojj^[_ne
]KGo_[jnol?3`oo:b/[od=3@omGEeOoIfMWogMgMon3Ph?oRh^;oi>CTonGU
i@3oonKViP_oi^KV00001?n[Zj_oX:2PodinaOm=O/@3odina@03odema?m>
O/GoCGk400;oCWk500WoCGk4odema?m<OLCoC7c3odema?m<O<?oC7g3odal
`om<OL<00om<O<<01?m<OL?oC7c3odal`om<OL<4odal``05odam`om<O<?o
C7g3odal`om<OL<00om<O<<01?m<OL?oC7c3odal`omKQlP4odal``05odam
`om<O<?oC7g3odal`om<OL<00om<O<<01?m<OL?oC7c3odal`om<OL<4odal
``05odam`om<O<?oC7g3odal`om<OL<00om<O<<01?m<OL?oC7c3odal`om<
OL<4odal``05odam`om<O<?oC7g3odal`om<OL<00om<O<<01?m<OL?oC7c3
odal`om<OL<3odal``060?ooo`000000oooo04am``1<O<<0C7g30`1<O<<0
0`1=OL@0C7c304ema00204ena00704ina@1=O/CoCGg4odinaOm=OLCoCWk5
odena003odina@0>oj2PX?n[Zj_o];Bdokbl_?o4a<Cob/[:om7AdOoGemOo
g=cLon7QhOoTi>Coj>SXon[Zj_o]kNd2onk^kP03ong]kOo^k^kok^k^0?oo
k^k^1oo^k^h00004okJf]_n/[:coE8K9oeB6bP;oE8K900CoE8K:oeB6bOmD
Q/WoE8K:0omDQ/T02OmCQLSoE8K9oe>5b?mBQ<SoDXG8oe:4b?mCQLSoDXC8
olSHk@05oogmo@03ohBXeoo2dn_ob=S]00;oDhG800Oo`M?ZolWHkOmBQ<So
DhG8oe:4b?oam?WoV[ON00;oDXC800_oK9K@omoWloomoOgoi>ceog2JdOon
o_koS:cIoe:4b?mTTLgokoCiohV/f@02oe:4b004ofFBcOo_m?Wo/lWVoe>5
b0;oDXC800SoDhG8oe:4b?mCQLSoDhG8oe:4b?mBQLSoDXC8oe>5b0;oDXC8
00CoDhG8oe:4b?mBQ<SoDhG80_mBQ<P02?mCQLSoDXC8oe>5b?mCQLSoDXC8
oe:5b?mBQ<SoDhG80_mBQ<P01?mCQLSoDXC8oe:4b?mCQLP2oe:4b003oe>5
b?mBQ<SoDhG80080oooo00<0DXG805:4b01CQLP00P1BQ<P00`1CQLP0DXC8
05>5b00205>5b00505>5b@1DQ/T0E8K905F6b_mDQ/X00omDQ/T04_mDQ/[o
E8K9oeB6bOmDQ/[o[:b/okNg]oo1`L7obLW9om;Bd_oIfMWogmoOonOWioo/
k>colO7aooGemOohn?Soo?cloogmoOoooooo3?ooool00003ojZZZ_nQXJ7o
CWk500;oCGg400CoCWk5odena?m>O/GoCGk40_m>O/D01_m=OLCoCWk5odem
a?m<OLCoCGg4odal``;oC7g302KoC7c3od]l`_o5eN[odMc]oeV5aomHQLKo
F8G7oeV5aom>O/Co_]3XolGDj_m<O<?oC7g3okk?ioo5eN[oC7g3odal`om;
O<;ok_;goiBaf_m<OL?oC7c3ojVohOoRj??oGXW8ogjPdooLiO7ono_kohJW
e_m<O<?oC7g3oh2Re?o_l_KoH8[9odmna?oCg^koeMo^odina0;oC7g300Ko
C7c3odam`om<O<?oC7c3odam`om<O<<2odam``06odal`om;O<;oC7g3odal
`om<OL?oC7c30_m<OL<01_m<O<?oC7g3odal`om<O<?oC7g3odal``;oC7g3
00KoC7c3od]l`_m<OL?oC7c3odam`om<O<<2odam``06odal`om<OL?oC7c3
odal`om<OL?oC7c30_m<OL<01om<O<?oBgc2odam`om<O<?oC7g3odal`om<
OL@00_m=OL@01Om>O/GoCGk4odena?m>O/GoCGk400;oCWk50_m=OL@04?m>
O/GoCGk4oj6QXOnZZZ[o];Bdokbl_?o4a<Cobl_;om7AdOoGemOogMgMon7Q
hOoTi>Coj>SXon[Zj_o/k>coonk^kPcok^k^00000onTY:CoVi^KodEc_`02
odIc_`;oAG>o0_m6Lkl00om5LkooAW>oodEc_`02odEc_`?oA7:n00KoA76m
odAb__m4L[koA7:nol;@ioo:e^T2odAb_P09odAa_Om4L[koA7:nok_:i?o2
d>OoA76modAb__nkbnCo`/oW00?oA7:n01GokO3fohnYe_m4L[koA7:nolWE
jOnhb>CoA7:nodAb_OmURlSon_[joh6Od_m4L[koA76modAb__nY_MkodM_]
ojZngoo/koCoF874odAb__m4LKd00_m4L[h00om4L[goA7:nodAa_@02odAb
_P03odAa_Om4L[koA7:n00;oA7:n00CoA76modAb__m4L[koA76m0_m4L[h0
0om4L[goA7:nodAa_@02odAb_P03odAa_Om4L[koA7:n00;oA7:n00CoA76m
odAb__m4L[koA76m0_m4L[h00om4L[goA7:nodAa_@02odAb_P03odAa_Om4
L[koA7:n00;oA7:n00CoA76modAb__m4L[koA7:n0_m5L[h01?m5LkooAW>o
odEc_om6Lkl3odEc_`;oAW>o0_m5Lkl04?nLW9coYJFUojf][Onf][Ko_Kfm
ol?3`oo:b/[od=3@omGEeOoIfMWog=cLomoOgooShn?oiNGUonKVi_oUiNGo
onKViP[oi^KV00002on[Zj_oXJ6QodinaOm=O/CoCGg4odinaOm=O/CoCWk5
odema?m>O/GoCGk400;oCWk500KoC7g3odama?m=OLCoC7g3odal`om<OL<2
odal``0>olGEj_o=fNgoC7c3odal`om<OL?oC7c3odam`onncnSoa=CYodal
`om<OL?o_/oXolGDj_m<OL<2odal``0;onkbmonD/M[oC7c3odal`oo=f^co
]lWTodam`om<O<?oC7g3oo_knon6YmH00_m<O<<01Om<OL?oCgo4om_Sl?ok
no_oRZWG00;oC7c300OoC7g3odal`om<OL?oC7c3od]l`om<O<?oC7g300;o
C7c300?oC7g3odal`om<O<<01?m<O<<01om<OL?oC7c3odam`om<O<?oBgc3
odal`om<OL<00_m<O<<00om<OL?oC7c3odal``04odal``07odam`om<O<?o
C7g3odal`om;O<?oC7c3odam``02odal``03odam`om<O<?oC7c300CoC7c3
00KoCGg4odama?m=O/CoCWk5odema?m=O/@2odina@0DodenaOm>O/GoCGk4
odema?m>O/GoCGk4oj6QXOnZZZ[o];Bdokbl_?o4a<Cobl_;om3@d?oGemOo
gMgMon7QhOoTi>Coj>SXon_[joo/k>`3onk^kP03ong]kOo^k^kok^k^0?oo
k^k^1_o^k^h00008okJf]_n/[:coE8K:oeB6b_mDQ/WoE8K:oeB6bOmEQ/X2
oeB6b@08oeB6b_mDQ/WoE8K9oe>5bOmCQ/WoDXC8oe>5b?mBQ<P2oe>5b004
oe:4b?o9f>god=g_oe>5b0;oDXC800SoDhG8oe:4b?o2dn[obMS]oe>5b?mB
Q<So`]?Zol_Jk@;oDhG800SoDXC8oo7enOnI]]goDhG8oe:4b?o?gNoo^lkX
oe:4b0;oDhG800[oo_knoh^/fOmBQ<SoDXC8oe>5b?mZULoom?KjonK]m_o>
fnkoDhG80_mBQ<P01OmCQLSoDXC8oe>5b?mBQ<SoDhG800?oDXC80_mCQLP0
1?mBQ<SoDXG8oe:4b?mCQLP2oe:4b005oe>5b?mBQ<SoDhG8oe:4b?mCQLP0
0omBQ<P2oe>5b004oe:4b?mBQLSoDXC8oe>5b0;oDXC800GoDhG8oe:4b?mC
QLSoDXC8oe>5b003oe:4b0;oDhG800?oDXC8oe:5b?mBQ<P00_mCQLP00omB
Q<SoDhG9oe>5b002oeB6b@04oeB6b_mDQ/WoE8K9oeB6b@;oE8K:017oE8K9
oeB6b_mDQ/Wo[:b/okJf]_o0`<3ob/[:om7AdOoIfMWoh>3PonOWioo/k>co
lO7aooCdm?ohn?Soo?cloogmo@3oooooo`cooooo00002?nZZZ[oXJ6Qoden
a?m=OLCoCWk5odema?m>O/GoCGg40om>O/D01om=O/CoCWk5odema?m<OLCo
C7g3odal`om<OL<00_m<O<<00om<OL?oa=CZolkJk@02odal``;oC7g300?o
C7c3okk@j?o4e>T00_m<O<<01onmcnOon_[kohRWe_m<O<?oEXC6oo[jn_n7
YmH00_m<O<<04?o=f^co]lWUodal`om<OL?oCGg3oo_knon6YmGoBgc3odam
`omAP<Gof^;`olcIk?mEPlGohn[doi>`fOm<O<<2odam``03odal`om<OL?o
C7c300;oC7c300OoBgc3odam`om<O<?oC7c3odam`om<O<?oC7g300;oC7c3
0_m<OL<00om<O<?oC7g3odal``02odal``07od]l`om<OL?oC7c3odal`om<
OL?oC7c3odam``02odal``;oC7g300?oC7c3odam`om<O<<00_m<O<<02Om;
O<?oC7g3odal`om<O<?oC7g3odal`om<OL?oC7c3odam``03odema00Hodin
aOm=OLCoCGk4odinaOm=OLCoCWk5odena?m=OLCoCWk5odema?m>O/GoX:2P
ojZZZ_nd];Co_;blolC4a?o;bl_odM7AomOGeooLg=cohN7QonCTi?oWinOo
j^[Z0_o]kNd00oo^k^kokNg]onk^kP3oonk^kPSok^k^00001?nUYJGoVi^K
odEc_om6Lkl3odEc_`03odIc_om5LkooAG>o00CoAG>o00GoAG:nodAb__m5
L[koA7:nodAb_@02odAb_P09ol7?ioo;en[oA7:nodAb__m4LKgoA7:nodAa
_OnkbnGo`]3X00;oA7:n00Oo^l_UolgHjoo?fN_ocMS[om?MkOobm?OoC7S0
00;oA7:n00OobMGYok?4h_m4LKgoA7:nodEc__ojn_[oP9oA00;oA7:n00[o
/lCRonS/lomDOL?o@g6mofjAboo`l_OoG8C5odAa_Om4L[koA76m1_m4L[h0
1?m4L[goA7:nodAb__m3LKd3odAb_P03odAa_Om4L[koA76m00KoA7:n00Co
A7:modAb__m4L[ko@g6m0om4L[h00om4LKgoA7:nodAa_@06odAb_P04odAb
_Om4L[koA7:nod=a_@GoA7:n00GoAG:nodEc_om6M;ooAW>oodEc_`02odIc
_`03odEc_om6LkooAG>o00;oAG>o00ooVi^KojBTY?n][Jgo][Jfokfm_Oo4
a<Cob/[:om3@d?oEeMGof][JomgMgOoOgmoohn?SonCTi?oUiND0oooVi^H;
onKViP0000CoZZZZoj2PX?m=O/GoCGk40_m>O/D00om=O/CoCWk5odena002
odina@05odena?m>O/GoCGg4odal`om<OL<01Om<O<<00oo5eN[ocMW/odam
``02odal``04odam`om<O<?oO9oBognQd`;oC7c301goNioBognQdomCP/Go
S:_Goj2ig_mQRlWoC7c3odam`om<O<?oPZ?EogVNdOm<O<?oC7g3odal`onE
/M[oI8g;odal`omFQ<KoUK;JoffDcOm<O<?oC7g3odal`on2XmGoMY[@odal
`om<OL?oC7c3odam``08odal``03odam`om<O<?oC7g300;oC7c300?oC7g3
odal`om<OL<02?m<O<<00om<OL?oC7c3odam``02odal``03odam`om<O<?o
C7g300SoC7c300GoC7g3odal`om<OL?oC7c3odam``02odema008odinaOm=
O/CoCGg4odenaOm=O/CoCGg4odenaOm=O/@2odina@0?odena?nQXJ7oZZZZ
okBd]?nl_;coa<C4ol_;booAdM7oemOGomcLg?oQhN7oi>CTonOWiooZj^[o
kNg]0?ook^k^3?o^k^h00006okJf]_n/[:coE8K:oeF6b_mDQ/WoE8K:0_mD
Q/T02OmDQ/[oE8K9oeB6bOmDQ/[oDhG9oe>5b?mDQ/WoDhG9oe:4b003oe>5
b005oe:4b?o9f>god=g^oe:4b?mCQLP00_mBQ<P00omCQLSoJiG?offFc`02
oe>5b006oe:4b?mCQLSoDhG8oe>5b?mBQ<SoDXG80_mBQ<P01_mCQLSoDXC8
oe:4b?mCQLSoDXC7oe:4b0;oDhG800KoDXC8oe>5b?mCQLSoDhG8oe:4b?mB
QLP2oe:4b006oe>5b?mBQ<SoDXC8oe>5b?mBQ<OoDXC80_mCQLP01_mBQ<So
DhG8oe>5b?mCQLSoDXC8oe:5b0;oDXC800KoDhG8oe:4b?mBQ<SoDhG8oe:4
aomBQ<P2oe>5b006oe:4b?mCQLSoDhG8oe>5b?mBQ<SoDXG80_mBQ<P01_mC
QLSoDXC8oe:4b?mCQLSoDXC7oe:4b0;oDhG800KoDXC8oe>5b?mCQLSoDhG8
oe:4b?mBQLP2oe:4b0?oDhG800?oE8K9oe>5bOmDQ/T00_mEQ/X05OmDQ/Wo
E8K:oeB6b_mEQ/[oE8K9oeB6b_mDQ/Wo[:b/okNg]oo1`L7obLW9om;Bd_oH
f=Soh>3PonOWioo/k>colO7aooGemOohn?Soo?cloogmo@3oooooo`cooooo
00001?n[Zj_oXJ6Qodema?m=OL@2odina@04odena?m>O/GoCWk5odema0;o
CWk500OoCGk4odema?m=OLCoC7c3odam`om<O<?oBgc300;oC7c300?oaMGZ
olgIkOm<OL<00om<O<<00om<OL?o_/oWolGEjP02odal``03odam`om<O<?o
Bgc300;oC7c300?oC7g3odal`om<OL<00om<O<<00om<OL?oC7c3odal``02
odal``03odam`om<O<?oBgc300;oC7c300?oC7g3odal`om<OL<00om<O<<0
0om<OL?oC7c3odal``02odal``03odam`om<O<?oBgc300;oC7c300?oC7g3
odal`om<OL<00om<O<<00om<OL?oC7c3odal``02odal``03odam`om<O<?o
Bgc300;oC7c300?oC7g3odal`om<OL<00om<O<<00om<OL?oC7c3odal``02
odal``03odam`om<O<?oBgc300;oC7c300KoC7g3odal`om<OL?oC7g3odal
`om=OL@2odena0;oCWk500?oCGk4odinaOm=O/@00_m=OL@2odina@0?oden
a?nQXJ7oZZZZok>c/onl_;coa<C4ol[:b_oAdM7of=SHomcLg?oQhN7oi>CT
onOWiooZj^[okNg]0?ook^k^3?o^k^h00004ojBTY?nLW9coAG>oodIc_`?o
AG>o00?oAW>oodEc_om6Lkl00_m5Lkl00om6M;ooAG>nodAb_P05odAb_P03
odAb_OmBO<;oDgg200CoA7:n00?oA7:moe5l`_mBO<800_m4LKd4odAb_P03
odAb_Om4L[koA76m00CoA7:n00?oA7:modAb__m4L[h00_m4LKd4odAb_P03
odAb_Om4L[koA76m00CoA7:n00?oA7:modAb__m4L[h00_m4LKd4odAb_P03
odAb_Om4L[koA76m00CoA7:n00?oA7:modAb__m4L[h00_m4LKd4odAb_P03
odAb_Om4L[koA76m00CoA7:n00?oA7:modAb__m4L[h00_m4LKd4odAb_P03
odAb_Om4L[koA76m00;oA7:n00CoAG:nodAb__m5L[koAWBo1?m5Lkl00om6
LkooAG>oodIc_`03odEc_`0@oi^KVonTY:Co[Zj^okFe]Onm_Kgoa<C4ol[:
b_o@d=3oe=CDomWIfOoMgMgoh>3Pon?ShooTi>Coi^KVonGUiOooi^KV2_oV
i^H00004ojZZZ_nPX:3oCWk5odema0CoCWk500CoCGg4odinaOm=O/CoCWk5
0om=OL@2odam``05odal`om<OL?oC7c3odam`om<O<<00_m<OL<01?m<O<?o
C7g3odal`om<OL<2odal``08odam`om<O<?oC7c3odal`om<OL?oC7c3odam
`om<O<<2odam``04odal`om<OL?oC7c3odam``;oC7c300SoC7g3odal`om<
O<?oC7c3odam`om<O<?oC7g3odal``;oC7g300CoC7c3odam`om<O<?oC7g3
0_m<O<<02?m<OL?oC7c3odal`om<O<?oC7g3odal`om<OL?oC7c30_m<OL<0
1?m<O<?oC7g3odal`om<OL<2odal``08odam`om<O<?oC7c3odal`om<OL?o
C7c3odam`om<O<<2odam``04odal`om<OL?oC7c3odam``;oC7c300SoC7g3
odal`om<O<?oC7c3odam`om<O<?oC7g3odal``;oC7g300GoC7c3odema?m<
OLCoCGk4odema002odina@05odena?m>O/GoCGk4odinaOm=OL@00om>O/D0
3_nQXJ7oZZZZokBd]?nl_;coa<C4ol[:b_oAdM7of=SHomcLg?oQhN7oi>CT
onSXj?oZj^[okNg]0oo^k^h00oo]kNgok^k^onk^kP3oonk^kPKok^k^0000
0onf][Ko[:b/oe>5b@05oe>4b006oe>5bOmCQ<SoDhG9oe>4b?mCQ<WoDXC8
0_mBPlP5oe:3a`;oDH;70_mBPlL01OmAPlOoDX?7oe62aomBPlOoDH?700;o
DX?700?oDH;7oe:3aomBPlL00_mBPlL2oe62a`;oDX?700GoDH?7oe:3aomA
P/OoDX?7oe63a`02oe:3a`03oe62aomBPlOoDX?700;oDX?70_mAP/L2oe:3
a`05oe63aomBPlOoDH;7oe:3aomAPlL00_mBPlL00omAP/OoDX?7oe:3a`02
oe:3a`;oDH;70_mBPlL01OmAPlOoDX?7oe62aomBPlOoDH?700;oDX?700?o
DH;7oe:3aomBPlL00_mBPlL2oe62a`;oDX?700GoDH?7oe:3aomAP/OoDX?7
oe63a`02oe:3a`03oe62aomBPlOoDX?700;oDX?70_mAP/L3oe:3a`03oe:4
b?mBPlSoDhC900;oDhC800CoDhG9oe>4b?mDQLWoDhG91?mCQ<P03_n/[:co
]kNgol71`Oo:b/[odM7AomWIfOoPh>3oinOWonc/k?oalO7omOGeooShn?ok
no_ooOgmooooool<ooooo`0000?oZZZZoj6QXOm=OL@01?m>O/D01_m=O/Co
CGg4odena?m>O/GoCGk4odina@?oCGg40om<O<<2odam``08odal`om<OL?o
C7c3od]l`om<O<?oC7g3odal`om<OL<2odal``04odam`om<O<?oC7c3odal
``;oC7g300SoC7c3odam`om<O<?oBgc3odal`om<OL?oC7c3odam``;oC7c3
00CoC7g3odal`om<O<?oC7c30_m<OL<02?m<O<?oC7g3odal`om;O<?oC7c3
odam`om<O<?oC7g30_m<O<<01?m<OL?oC7c3odal`om<O<<2odam``08odal
`om<OL?oC7c3od]l`om<O<?oC7g3odal`om<OL<2odal``04odam`om<O<?o
C7c3odal``;oC7g300SoC7c3odam`om<O<?oBgc3odal`om<OL?oC7c3odam
``;oC7c300CoC7g3odal`om<O<?oC7c30_m<OL<01Om<O<?oC7g3odal`om<
O<?oC7g300;oCGg400OoCWk5odema?m>O/GoCWk5odema?m=O/CoCGg400Co
CWk500koXJ6QojZZZ_nd];Co_;blolC4a?o;bl_odM7AomSHf?oMgMgohN7Q
onCTi?oWinOojn_[ong]k@?ok^k^00?okNg]onk^k_o^k^h0ooo^k^h6onk^
kP0000?oYJFUoi^KVom<OL@01?m<O<<01Om=OLCoC7g4odal`om<O<?oC7g4
00;oC7c31Om;Nl801?m:Nl;oBg_2od]k`_m;Nl82od]l`PCoBg_200?oBgc2
odYk`_m;Nl800om;Nl801?m:Nl;oBg_2od]k`_m;Nl82od]l`PCoBg_200?o
Bgc2odYk`_m;Nl800om;Nl801?m:Nl;oBg_2od]k`_m;Nl82od]l`PCoBg_2
00?oBgc2odYk`_m;Nl800om;Nl801?m:Nl;oBg_2od]k`_m;Nl82od]l`PCo
Bg_200?oBgc2odYk`_m;Nl800om;Nl801?m:Nl;oBg_2od]k`_m;Nl82od]l
`PCoBg_200?oBgc2odYk`_m;Nl800om;Nl801?m:Nl;oBg_2od]k`_m;Nl82
od]l`P;oBg_20_m<O<<00om=OLCoC7c3odal``03odama0CoC7c300ooVi^K
ojFUYOn^[Zko]KFeokjn__o3`l?ob/[:om3@d?oEeMGofMWIomgMgOoPh>3o
h^;RonCTi?oUiND0oooVi^H;onKViP0000CoZj^[oj2PX?ogmoOom_Kf0oog
moL00oofm_KomoOgooKfmP02ooOgm`;om_Kf00KomOGeooCdm?oemOGom?Cd
ooGemOodm?@2ooGem@;om?Cd00ComOGeooCdm?odm?ComOGe1?odm?@01?oe
mOGom?CdooGemOodm?@2ooGem@;om?Cd00ComOGeooCdm?odm?ComOGe1?od
m?@01?oemOGom?CdooGemOodm?@2ooGem@;om?Cd00ComOGeooCdm?odm?Co
mOGe1?odm?@01?oemOGom?CdooGemOodm?@2ooGem@;om?Cd00ComOGeooCd
m?odm?ComOGe1?odm?@01?oemOGom?CdooGemOodm?@2ooGem@;om?Cd00Co
mOGeooCdm?odm?ComOGe1?odm?@01?oemOGom?CdooGemOodm?@2ooGem@;o
m?Cd00?omOGeooCdm?oemOD00_ofm_H01oogmoOom_KfooKfm_ogmoOom_Kf
ooOgmoofm_H00oogmoL03_nPX:3oZj^[okBd]?nl_;coa<C4ol[:b_oAdM7o
emOGomcLg?oQhN7oi>CTonSXj?oZj^[okNg]0_o^k^h00oo]kNgok^k^onk^
kP3oonk^kPOok^k^00000onf][Ko[:b/ong]k@02onk^kP03ong]kOo^k^ko
kNg]00;ok^k^0_o]kNd01?o^k^kok>c/ong]kOo/k>`4on_[j`Go8B4Q00Go
8R8Rob4Q8OlQ8B7o8R8Rob4Q8@02ob8R8Pkojn_[00?ok>c/on_[joo[jn/0
3Oo[jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[jn_ojn_[00gojn_[
00?ok>c/on_[joo[jn/02?o[jn/3onc/k007onk^k_o]kNgok^k^onk^k_o]
kNgok^k^ong]k@02onk^kP0@ong]kOo^k^ko[:b/okNg]oo1`L7obLW9om;B
d_oIfMWogmoOonOWioo/k>colO7aooGemOohn?Soo?cloogmoOoooooo3?oo
ool00003ojZZZ_nQXJ7omoOg00;om_Kf00ComoOgooKfm_ogmoOom_Kf0_og
moL00oofm_KomoOgooKfmP02ooGem@03ooCdm?oemOGomOGe00;om?Cd00Co
mOGeooCdm?oemOGom?Cd0_oemOD01_odm?ComOGeooCdm?odm?ComOGeooCd
m0;omOGe0_odm?@01?oemOGom?CdooGemOodm?@2ooGem@06ooCdm?oemOGo
m?CdooCdm?oemOGom?Cd0_oemOD2ooCdm004ooGemOodm?ComOGeooCdm0;o
mOGe00Kom?CdooGemOodm?Com?CdooGemOodm?@2ooGem@;om?Cd00ComOGe
ooCdm?oemOGom?Cd0_oemOD01_odm?ComOGeooCdm?odm?ComOGeooCdm0;o
mOGe0_odm?@01?oemOGom?CdooGemOodm?@2ooGem@06ooCdm?oemOGom?Cd
ooCdm?oemOGom?Cd0_oemOD2ooCdm004ooGemOodm?ComOGeooCdm0?omOGe
0_ogmoL00oofm_KomoOgooKfmP02ooOgm`;om_Kf013omoOgooKfm_nQXJ7o
ZZZZokBd]?nl_;coa<C4ol_;booAdM7oemOGomgMgOoQhN7oi>CTonSXj?oZ
j^[ok>c/ooo^k^h<onk^kP0000?oY:BToi^KVooinOT02ooinOT3ooOgm`03
ooKfm_ogmoOomoOg00;omoOg00Com_KfooOgmoogmoOom_Kf1?ogmoL01?of
m_KomoOgooOgmoofm_H4ooOgm`04ooKfm_ogmoOomoOgooKfmPComoOg0_of
m_H00ooOgmoomOGeooOgm`03ooOgm`06ooKfm_ogmoOomoOgonk^k_oNg]ko
m_Kf0_ogmoL01?ofm_KomoOgooOgmoofm_H4ooOgm`04ooKfm_ogmoOomoOg
ooKfmP;omoOg00?ol?3`onCTi?ofm_H00_ogmoL00oofm_KomoOgooOgm`02
ooOgm`04ooKfm_ogmoOomoOgooKfmPComoOg00Com_KfooOgmoogmoOom_Kf
1?ogmoL01?ofm_KomoOgooOgmoogmoL2ooShn0_onOWi013oW9bLojFUYOn]
[Jgo][Jfokfm_Oo3`l?ob/[:om3@d?oEeMGofMWIomcLg?oOgmoohn?SonGU
iOoVi^KoiNGUoooVi^H:onKViP0000_oZj^[oj6QXOogmoOomoOgooKfm_og
moOom_KfooOgmoofm_KomoOgooKfmP02ooOgm`?omOGe0_odm?@04OoemOGo
m?CdooCdm?oemOGoQhN7oalO7ooCdm?omOGeooCdm?nJVY[o7alOokbl_?od
m?ComOGeooCdm?mXJ6SoH61P00;om?Cd00OoJFUYof1PH?odm?Com?CdooGe
mOl];BgoW9bL00;om?Cd00oocLg=ocTi>OlO7aoo;Rh^ojj^[_lg=cOoTY:B
ooGemOodm?CoinOWofIVI_lQ8B7o:RXZobd];OnRXZ800_odm?@01?oemOGo
lo?cobd];OmJFUX2ooCdm00;olG5aOlO7aooUiNGooCdm?oemOGom?Cdoe5A
DOlT92Co<30`odY:B_o1`L400_odm?@01?oemOGom?CdooCdm?oemOD3ooCd
m003ooGemOodm?ComOGe00?om?Cd00ComOGeooCdm?odm?ComOGe0_odm?@0
1?oemOGom?CdooCdm?odm?@2ooGem@03ooKfm_ogmoOom_Kf00KomoOg017o
m_KfooOgmoofm_KoXJ6QojZZZ_nd];Co_;blolC4a?o;bl_od=3@omOGeooM
gMgohN7QonCTi?oXj>Sojn_[onc/k003onk^kP03ong]kOo^k^kok^k^0?oo
k^k^1_o^k^h0000=okJf]_n/[:cok^k^onk^k_o]kNgok^k^ong]kOo^k^ko
U9BDogalO?o^k^kokNg]onk^kP02onc/k0Oojn_[00?oCdm?ob8R8_nJVYX0
0_o[jn/00omVIVKo8B4QogemO@03on_[j`06ofMWIomOGeoojn_[on_[jomW
IfOoGemO0oo[jn/02ol_;booUYJFon_[joo[jn_oI6ATod=3@onm_Kgob<S8
ofATI?lY:BWoS8b<00;ojn_[00OoJFUYochn?_nm_KgoiNGUoiJFU_lQ8B7o
^;Rh00;ojn_[00So_[jnob8R8_l[:b_oh>3Pon_[jon8R8So9bLWoe9BDP?o
jn_[00GoYjNWomSHf?o[jn_oPX:2od];B`0Jon_[j`;ok>c/00?ok^k^ong]
kOo^k^h00oo]kNd2onk^kP0Aong]kOo^k^kokNg]ojb/[?nf][Ko`<30ol[:
b_oAdM7ofMWIon3Ph?oWinOok>c/oo7alOodm?Con?Shooclo?omoOd0oooo
ool<ooooo`0000SoZZZZoj6QXOofm_Kom_KfooOgmoofm_KomoOgoiNGU`;o
8B4Q00?oP820ooKfm_ogmoL00ooemOD02Oodm?ComOGeooCdm?odm?ComOGe
on_[jolS8b?oAdM7ofe]K@02ooGem@0<ocPh>?m0@43oA4A4ooCdm?oemOGo
m?CdofUYJOmPH63om?CdooGemOmXJ6SoH61P0_odm?@04?oemOGo;Rh^oi^K
VooemOGol?3`ob/[:onGUiOom?CdooGemOoalO7o<S8boi:BT_odm?Coj>SX
oalO7on8R8P2ooGem@0>ooCdm?lf=SKoIfMWooCdm?oemOGoQhN7od];BomJ
FU[oZj^[ooGemOm@D53oQHF5ob<S8ooQhN42ooGem@07ooCdm?oemOGol?3`
og9bL_le=CGol_;booGem@02ooCdm003ooGemOodm?ComOGe00;om?Cd0_oe
mOD01oodm?ComOGeooCdm?odm?ComOGeooCdm?oemOD00_odm?@00ooemOGo
m?CdooGem@02ooCdm0;omOGe00Oom_KfooOgmoofm_Kom_KfooOgmoofm_Ko
moOg00;om_Kf013omoOgooKfm_ogmoOoX:2PojZZZ_nd];Co_;blolC4a?o;
bl_odM7AomOGeooLg=cohN7QonCTi?oWinOoj^[Z0_o]kNd00oo^k^kokNg]
onk^kP3oonk^kPSok^k^00000onUYJGoVi^KooWin@03ooWin@03oiVIVOlP
823o7alO00;o7alO00CoP820ooWinOoinOWon?Sh1_ogmoL02_ni^KWo7QhN
ok>c/olh>3Som_KfomoOgolN7QkoZJVYob0P8?oRh^82ooOgm`06ofUYJOmP
H63omoOgooOgmomXJ6SoH61P0_ogmoL01oofm_Ko;Bd]oibLW?ogmoOoc/k>
oahN7_o0`<000oogmoL02olf=SKoTY:BooKfm_o<c<co7QhNokbl_?ofm_Ko
moOgooKfm_mWIfOoBd];00;omoOg013oBd];ohR8R?nMWIgoJVYZon_[jolQ
8B7od=3@oeMGEonMWIgom_KfooOgmoofm_Ko[Zj^ochn?_lZ:R[oZj^[1Oog
moL01oofm_KomoOgooOgmoogmoOom_KfooOgmoofm_H02OogmoL00oofm_Ko
moOgooOgm`02ooOgm`;on?Sh2ooinOT03onKVi_oY:BTojf][Onf][Ko_Kfm
olC4a?o:b/[od=3@omGEeOoJf][ogMgMomoOgooShn?oi>CTonGUi@3oonKV
iP_oi^KV00002OnZZZ[oX:2PooOgmoofm_KomoOgojVYZOlP823o8B4Qob0P
8002ob4Q8@03ob0P8?nATI7om_Kf00;omOGe1Oodm?@02_n1PH7o?clooo7a
lOlX:2Sog=cLojf][OlQ8B7ojn_[odU9BOnSXj<2ooCdm007ofQXJ?mPH63o
m?CdooCdm?mYJFWoGEeMooGem@02ooCdm006obd];OnKVi_omOGeomkNg_lO
7aooWinO0oodm?@07?lg=cOoTY:BooGemOoJf][o820Poj6QXOodm?ComOGe
ooCdm?m>CTkoFEUIooCdm?oQhN7o7alOol?3`ooLg=co;2`/ojj^[_lc<c?o
m?CdoifMWOmFEUKom?CdooGemOn@T93o8b<SogQhN?oNg]h6ooCdm003ooGe
mOodm?ComOGe00;om?Cd00?omOGeooCdm?oemOD02?odm?@01?oemOGom?Cd
ooGemOodm?@2ooGem@05ooKfm_ogmoOom_KfooKfm_ogmoL00_ofm_H04oog
moOom_KfooOgmoogmoOom_Kfoj6QXOnZZZ[o];Bdokbl_?o4a<Cobl_;om7A
dOoGemOog=cLon7QhOoTi>CoinOWon[Zj_o]kNd0ooo^k^h<onk^kP0000Oo
][Jfojb/[?o^k^kok^k^ong]kOoQhN7oBd];00Co8b<S00?o?ShnomKFe_o/
k>`00_o/k>`3on_[j`0<onc/k?o[jn_oBTY:og=cLoo[jn_oFEUIojBTY?mh
N7SoAdM7on_[jon2PX;oIFEU0_o[jn/03omWIfOoGemOonc/k?o[jn_oIfMW
ob<S8onUYJGojn_[omoOgolR8R;oYjNWon_[jooZj^[o@T92ofIVIP02on_[
j`07on7QhOla<C7oS8b<on_[jooYjNWo?3`lofQXJ002on_[j`0BomoOgolT
92CoRh^;on_[jonQXJ7o;Rh^onWYjOo[jn_oBDU9od92@_mYJFWojn_[omSH
f?lV9RKofm_Kon_[jom=CDgoOgmo1_o[jn/00oo/k>cojn_[on_[j`0=on_[
j`03onc/k?o[jn_ojn_[00;ojn_[0oo/k>`3ong]k@;ok^k^01GokNg]onk^
k_o^k^kok^k^ong]kOo^k^kokNg]ojb/[?ng]kOo`L71olW9bOoBd];of=SH
on3Ph?oWinOok>c/oo7alOoemOGon?Shooclo?omoOd0ooooool<ooooo`00
00CoZj^[oj6QXOofm_Kom_Kf0_ogmoL01_oYjNWoC4a<ob4Q8OlP823o?Cdm
omkNgP;om_Kf00?omOGeooCdm?oemOD00oodm?@06?oXj>So820Pojf][Ooe
mOGoS8b<ogEeMOm;Bd_oN7QhooCdm?o2`/;o;Rh^oo;bl_oemOGoJ6QXoemO
Goodm?ComOGeofUYJOmEEEGoDU9Boe=CDom<C4co:2PXon[ZjP;om?Cd01?o
^KViobDU9OmBDU;oQXJ6odM7AolW9bOoTY:BooGemOodm?Co^k^kobPX:?m<
C4coOgmooc0`<?m;Bd_okNg]ooCdm?mXJ6SoIfMW00;om?Cd00koRXZ:oalO
7onTY:Com?CdooGemOmBDU;oXJ6QooCdm?nGUiOo>3Phoh^;RomjNW[oZ:RX
ooGem@?om?Cd0_oemOD00oodm?ComOGeooCdm002ooCdm003ooGemOodm?Co
m?Cd00;om?Cd00ComOGeooCdm?odm?Com?Cd0_oemOD01Oodm?ComOGeooCd
m?odm?ComOGe00;om_Kf0_ogmoL00oofm_KomoOgooOgm`02ooKfmP?omoOg
00koXJ6QojZZZ_nc/k?o_;blolC4a?o:b/[odM7AomSHf?oLg=cohN7QonCT
i?oWinOoj^[Zong]kOook^k^3?o^k^h00003ojBTY?nLW9conOWi00ConOWi
00Cojn_[od];Bolm?Cgoh>3P0_oinOT00oohn?SomoOgooOgm`04ooOgm`0?
ok>c/olO7aooi^KVooOgmoo0`<3o>SXjob0P8?nZZZ[omoOgoo?clolZ:R[o
alO7ooOgmonl_;co]kNg00;omoOg00Oo^k^kokNg]oo]kNgoYjNWohn?SooL
g=com_Kf00;omoOg01?om_Kfolo?con;Rh_oTY:BomgMgOlf=SKoTY:BooOg
moofm_KomoOgomWIfOnFUYKoPX:2ojRXZ?odm?ComoOgooKfm_nXZ:Soc<c<
00;omoOg00gogMgMoi^KVooUiNGom_KfooOgmoo6a/Ko_[jnooOgmoodm?Co
a<C4ohN7Qon:RX[ob/[:00KomoOg00?om_KfooOgmoogmoL00_ogmoL00oof
m_KomoOgooOgm`02ooKfmPKomoOg00?om_KfooOgmoogmoL00_ogmoL00ooh
n?SonOWiooWin@09ooWin@0@oi^KVonTY:Co[Zj^okFe]Onm_Kgoa<C4ol[:
b_o@d=3oe=CDomWIfOoMgMgoh>3Pon?ShooTi>Coi^KVonGUiOooi^KV2_oV
i^H00004ojZZZ_nPX:3omoOgooKfmPComoOg00CojNWYomoOgoogmoOomoOg
0_ofm_H2ooGem@;om?Cd00ComOGeooCdm?mkNg_oATI60_oemOD02Oo]kNgo
8b<SoalO7ooKfm_om?CdooGemOmVIVKoRHV9ooCdm002om?Cd`03ooCdm?oe
mOGom?Cd00;omOGe00Gom?CdooGemOodm?ComOGeooCdm002ooGem@?om?Cd
00ComOGeocLg=onBTY;om?Cd0_oemOD01Oodm?ComOGeooCdm?oemOGom?Cd
00;omOGe0oodm?@01?oemOGom?CdooGemOodm?@2ooGem@05ooCdm?oemOGo
m?CdooGemOodm?@00_oemOD3ooCdm004ooGemOodm?ComOGeooCdm0;omOGe
00Gom?CdooGemOodm?ComOGeooCdm002ooGem@?om?Cd00ComOGeooCdm?oe
mOGom?Cd0_oemOD00oodm?ComOGeooGem@02ooKfmPComoOg00?om_KfooOg
moofm_H00oogmoL03_nQXJ7oZZZZokBd]?nl_;coa<C4ol[:b_oAdM7of=SH
omcLg?oQhN7oi>CTonSXj?oZj^[okNg]0oo^k^h00oo]kNgok^k^onk^kP3o
onk^kPKok^k^00001Onf][Ko[:b/onk^k_o]kNgok^k^00?okNg]00Gok^k^
ong]kOo^k^kokNg]onk^kP03onc/k0Cojn_[00?oA4A4ogYjN_o[jn/00_o[
jn/00om?Cdoo=SHfon[ZjP02on_[j`05oifMWOm=CDgojn_[ofMWIomOGel0
4?o[jn/00olg=cOoSXj>on_[j`0bon_[j`05onc/k?o[jn_ok>c/onc/k?o^
k^h00_o]kNd01_o^k^kokNg]onk^k_o^k^kokNg]onk^kP;okNg]00ko[:b/
okNg]oo1`L7ob/[:om7AdOoIfMWoh>3PonOWioo/k>colO7aooGemOohn?So
no_koogmoOoooooo3?ooool00003ojZZZ_nQXJ7om_Kf00ComoOg0_ofm_H2
ooOgm`03ooKfm_ogmoOomOGe00;omOGe0oodm?@01?oemOGog=cLon[Zj_oe
mOD2ooCdm00:onCTi?oQhN7om?CdooGemOodm?Cokno_omgMgOodm?Coi>CT
on?Sh`;omOGe00?om?CdooGemOodm?@00_odm?@00ooemOGom?CdooGem@02
ooCdm008ooGemOodm?Com?CdooCdm?mNGUkoYZJVooCdm?oemOD3ooCdm003
ooGemOodm?ComOGe00;om?Cd00ComOGeooCdm?odm?Com?Cd0_oemOD00ood
m?ComOGeooCdm002ooCdm003ooGemOodm?ComOGe00;om?Cd00ComOGeooCd
m?odm?Com?Cd0_oemOD00oodm?ComOGeooCdm002ooCdm003ooGemOodm?Co
mOGe00;om?Cd00ComOGeooCdm?odm?Com?Cd0_oemOD01?odm?ComOGeooCd
m?odm?@2ooGem@03ooKfm_ogmoOom_Kf00;omoOg0oofm_H4ooOgm`0>oj6Q
XOnZZZ[o];Bdokbl_?o4a<Cobl_;om7AdOoHf=SogMgMon7QhOoTi>CoinOW
on_[joo]kNd3onk^kP03ong]kOo^k^kok^k^0?ook^k^1_o^k^h00003ojFU
YOnKVi_onOWi00_onOWi1OogmoL00oofm_KomoOgooKfmP03ooOgm`;om_Kf
0oogmoL00oofm_KomoOgooOgm`02ooOgm`03ooKfm_ogmoOom_Kf00?omoOg
0_ofm_H3ooOgm`03ooKfm_ogmoOomoOg00;omoOg00?om_KfooOgmoofm_H0
0oogmoL2ooKfmP?omoOg00?om_KfooOgmoogmoL00_ogmoL00oofm_KomoOg
ooKfmP03ooOgm`;om_Kf0oogmoL00oofm_KomoOgooOgm`02ooOgm`03ooKf
m_ogmoOom_Kf00?omoOg0_ofm_H3ooOgm`03ooKfm_ogmoOomoOg00;omoOg
00?om_KfooOgmoofm_H01OogmoL00oohn?SonOWiooWin@09ooWin@0?oi^K
VonUYJGo[Zj^okFe]Onn_[ko`l?3ol[:b_o@d=3oeMGEomWIfOoMgMgoh>3P
on;Rh_oTi>CoiNGU0?ooi^KV2ooVi^H00004oj^[ZonPX:3omoOgooKfmP?o
moOg00?om_KfooOgmoofm_H00_ogmoL2ooKfmP06ooGemOodm?ComOGeooCd
m?oemOGom?Cd0_oemOD2ooCdm004ooGemOodm?Com?CdooGem@Com?Cd00Co
mOGeooCdm?oemOGom?Cd0_oemOD2ooCdm004ooGemOodm?Com?CdooGem@Co
m?Cd00ComOGeooCdm?oemOGom?Cd0_oemOD2ooCdm004ooGemOodm?Com?Cd
ooGem@Com?Cd00ComOGeooCdm?oemOGom?Cd0_oemOD2ooCdm004ooGemOod
m?Com?CdooGem@Com?Cd00ComOGeooCdm?oemOGom?Cd0_oemOD2ooCdm004
ooGemOodm?Com?CdooGem@Com?Cd00ComOGeooCdm?oemOGom?Cd0_oemOD2
ooCdm003ooGemOodm?ComOGe00;om_Kf00OomoOgooKfm_ofm_KomoOgooKf
m_ogmoOom_Kf00?omoOg00koX:2Poj^[Zond];Co_;blolC4a?o:b/[odM7A
omOGeooLg=cohN7QonCTi?oXj>Soj^[Zong]k@;ok^k^00?okNg]onk^k_o^
k^h0ooo^k^h7onk^kP0000?o][Jfojb/[?o]kNd00_o^k^h00oo]kNgok^k^
ong]k@02onk^kP;okNg]00Cok^k^onc/k?o]kNgok>c/3_o[jn/00oo/k>co
jn_[on_[j`0=on_[j`03onc/k?o[jn_ojn_[00gojn_[00?ok>c/on_[joo[
jn/03Oo[jn/00oo/k>cojn_[on_[j`0=on_[j`03onc/k?o[jn_ojn_[00So
jn_[0oo/k>`01oo^k^kokNg]onk^k_o^k^kokNg]onk^k_o]kNd00_o^k^h0
4?o]kNgok^k^ojb/[?ng]kOo`L71olW9bOoBd];ofMWIomoOgooWinOok>c/
oo7alOoemOGon?Shooclo?omoOgoooooo`cooooo00000onZZZ[oXJ6QooOg
m`02ooKfmP04ooOgmoofm_KomoOgooKfmP;omoOg00?om_KfooOgmoofm_H0
0_oemOD00oodm?ComOGeooGem@02ooCdm004ooGemOodm?ComOGeooCdm0;o
mOGe00Kom?CdooGemOodm?Com?CdooGemOodm?@2ooGem@;om?Cd00ComOGe
ooCdm?oemOGom?Cd0_oemOD01_odm?ComOGeooCdm?odm?ComOGeooCdm0;o
mOGe0_odm?@01?oemOGom?CdooGemOodm?@2ooGem@06ooCdm?oemOGom?Cd
ooCdm?oemOGom?Cd0_oemOD2ooCdm004ooGemOodm?ComOGeooCdm0;omOGe
00Kom?CdooGemOodm?Com?CdooGemOodm?@2ooGem@;om?Cd00ComOGeooCd
m?oemOGom?Cd0_oemOD01_odm?ComOGeooCdm?odm?ComOGeooCdm0;omOGe
0_odm?@01?oemOGom?CdooGemOodm?@3ooGem@;omoOg00?om_KfooOgmoof
m_H00_ogmoL2ooKfmP0@ooOgmoofm_KoXJ6QojZZZ_nd];Co_;blolC4a?o;
bl_odM7AomOGeooMgMgohN7QonCTi?oXj>Soj^[Zonc/k?ook^k^3?o^k^h0
0003ojBTY?nKVi_omOGe00?omOGe00Com?CdooGemOoemOGom?Cd0_oemOD2
ooCdm0;olo?c0oobl_82oo?cl`;ol_;b0_oclo<01oobl_;olo?coo;bl_ob
l_;olo?coo;bl_oclo<00oobl_82oo?cl`;ol_;b0_oclo<01oobl_;olo?c
oo;bl_obl_;olo?coo;bl_oclo<00oobl_82oo?cl`;ol_;b0_oclo<01oob
l_;olo?coo;bl_obl_;olo?coo;bl_oclo<00oobl_82oo?cl`;ol_;b0_oc
lo<01oobl_;olo?coo;bl_obl_;olo?coo;bl_oclo<00oobl_82oo?cl`;o
l_;b0_oclo<01oobl_;olo?coo;bl_obl_;olo?coo;bl_oclo<00oobl_82
oo?cl`;ol_;b0_oclo<01_obl_;olo?cooCdm?odm?ComOGeooCdm0;omOGe
00?om?CdooGemOoemOD00_oemOD04Oodm?CoW9bLojFUYOn][Jgo][Jfokfm
_Oo3`l?ob/[:om3@d?oEeMGofMWIomcLg?oOgmoohn?SonGUiOoVi^KoiNGU
0?ooi^KV2_oVi^H00005oj^[ZonQXJ7oj^[Zon[Zj_oYjNT00ooZj^X00ooY
jNWoj^[ZonWYj@02on[ZjPCoj>SX00[oinOWonSXj?oWinOoinOWonSXj?oW
inOoj>SXonOWiooXj>SoinOW0_oXj>P2onOWi`;oj>SX00[oinOWonSXj?oW
inOoinOWonSXj?oWinOoj>SXonOWiooXj>SoinOW0_oXj>P2onOWi`;oj>SX
00[oinOWonSXj?oWinOoinOWonSXj?oWinOoj>SXonOWiooXj>SoinOW0_oX
j>P2onOWi`;oj>SX00GoinOWonSXj?oWinOoinOWonSXj005oalO7`04ob0P
8?lO7aoo7alOoalO7`;oj>SX00[oinOWonSXj?oWinOoinOWonSXj?oWinOo
j>SXonOWiooXj>SoinOW0_oXj>P2onOWi`;oj>SX00SoinOWonSXj?oWinOo
inOWonSXj?oWinOoj>SXonOWi`;oj>SX00?ojNWYon[Zj_oYjNT01_oZj^X0
4OoYjNWoj^[Zon[Zj_nQXJ7oZZZZokBd]?nl_;coa<C4ol_;boo@d=3oemOG
omgMgOoQhN7oi>CTonSXj?o[jn_ok>c/00?ok^k^00?okNg]onk^k_o^k^h0
ooo^k^h6onk^kP0000So][Jfojb/[?okno_ono_koo[jn_okno_on_[joo_k
n`;on_[j00?ono_koo[jn_okno/00_oinOUKooShn0;onOWi00?ono_koo[j
n_okno/00oojn_X2oo_kn`0Aoo[jn_okno_on_[jojb/[?nf][Ko`<30ol[:
b_oAdM7ofMWIon3Ph?oWinOok>c/oo7alOodm?Con?Shooclo?omoOd0oooo
ool<ooooo`0000?oZZZZoj6QXOokno/02_okno/01Oojn_[onOWiooWinOoh
n?SonOWi00;on?Sh00ConOWiooShn?oinOWon?Sh0ooinOT03Oohn?SonOWi
ooShn?ohn?SonOWiooShn?oinOWojn_[oo3`l?oinOWon?Shon?Shoohn?P0
0ooinOT03OoalO7oh>3PooOgmoohn?SonOWiooShn?oinOWon?ShonKVi_o=
cLgokNg]ooWinOohn?P00ooinOT01oohn?SogmoOomCDe?ohn?SonOWiooSh
n?oinOT00_ohn?P01?oinOWon?ShooWinOohn?P3ooWin@07ooShn?oinOWo
n?ShooShn?oinOWon?ShooWin@02ooShn004ooWinOohn?SonOWiooShn0?o
nOWi00Oon?ShooWinOohn?Son?ShooWinOohn?SonOWi00;on?Sh00ConOWi
ooShn?oinOWon?Sh0_oinOT2oo[jnP_ono_k00goX:2PojZZZ_nd];Co_;bl
olC4a?o;bl_odM7AomOGeooLg=cohN7QonCTi?oWinOoj^[Z00;okNg]00?o
k^k^ong]kOo^k^h0ooo^k^h8onk^kP0000?oYJFUoi^KVooemOD00_oemOD0
2Oodm?ComOGeooGemOoemOGom?CdooGemOodm?ComOGeooCdm004oo?cl`0=
oo;bl_oclo?ol_;boeiNG_n0P83olo?coo;bl_nj^[[o`l?3oo;bl_oclo?o
N7Qhoe5AD@02oo?cl`0>ogYjN_lT92Co9BDUoh61POmbLW;o9bLWokZj^_ob
l_;ojn_[og5aLOlQ8B7o8R8RobXZ:_nLW9`2oo?cl`07ol[:b_m1@D7o8b<S
ocPh>?lP823oDE5AomOGe`02oo;blP0:okZj^_lZ:R[o7QhNoc@d=?lh>3So
Ng]kong]kOoclo?ol_;boo?cl`;ol_;b00WoO7alod];Boo`l?3ol_;boo?c
loobl_;oKVi^obPX:?oIfMT00ooclo<01?obl_;olo?coo;bl_obl_82oo?c
l`;ol_;b00?olo?coo;bl_oclo<01Ooclo<01?obl_;olo?coo;bl_obl_82
oo?cl`;ol_;b0_oclo<9ooGem@0AooCdm?oemOGoVi^KojBTY?n][Jgo][Jf
okfm_Oo4a<Cob/[:om3@d?oEeMGof][JomgMgOoOgmoohn?SonCTi?oUiND0
oooVi^H;onKViP0000CoZZZZoj2PX?oZj^[ojNWY0_oZj^X00ooYjNWoj^[Z
onWYj@02on[ZjP03onWYjOoZj^[ojNWY00;oj>SX1?oWinL0;OoXj>SoGEeM
og]kNooXj>Sof=SHob<S8ol`<33oi>CTonSXj?mbLW;oCTi>onOWioo;bl_o
7alOoijNW_oGemOoQhN7oalO7onDU9Coj>SXonOWiomcLg?o:2PXoiBDU?oO
gmooc<c<olO7aooWinOo`/;2ob@T9?m`L73oh>3PonSXj?oKfm_oGEeMob/[
:ooBd];oj>SXol?3`onJVY[odm?ConOWioo6a/Ko9RHVog]kN`03onOWi`;o
j>SX00?og]kNoc/k>on;Rh/00_oXj>P00onb/[;o7alOohn?S`06onOWi`;o
j>SX00?oinOWonSXj?oWinL00_oXj>P00ooWinOoj>SXonOWi`06onOWi`;o
j>SX00CoinOWonSXj?oWinOoj>SX0_oYjNT2on[ZjP06onWYjOoZj^[ojNWY
onWYjOoZj^[ojNWY0_oZj^X03ooYjNWoXJ6QojZZZ_nd];Co_;blolC4a?o;
bl_odM7AomOGeooLg=cohN7QonCTi?oWinOoj^[Zong]k@3oonk^kPcok^k^
00001_nf][Ko[:b/oo_knookno_on_[joo_kn`;on_[j00Gono_koo[jn_oj
n_[ono_koo[jnP03ooWin@?on?Sh01SonOWiooShn?mSHf?oQ8B4ooShn?nQ
XJ7o9bLWod92@_ng]kOon?Shog]kNomEEEGon?Shom[Jf_lR8R;o][JfooWi
nOodm?Co8B4Qok:b/_ohn?Sokno_ob@T9?mYJFT5ooShn004oeUIFOm9BDWo
n?ShooWin@;on?Sh00?ol_;bocDe=OmaLG401_ohn?P01OmMGEgoD51@ooSh
n?ohn?SonOWi00?on?Sh00Ooa<C4obTY:OoFe]KolO7aochn?_m=CDgom_Kf
00Gon?Sh00?onOWiooShn?ohn?P03Oohn?P00ooinOWon?ShooShn002ooSh
n003ooWinOohn?SonOWi00?on_[j0_okno/05Oojn_[ono_koo_knookno_o
n_[joo_knoojn_[o[:b/okNg]oo1`L7obLW9om;Bd_oHf=Soh>3PonOWioo/
k>colO7aooGemOohn?Soo?cloogmo@3oooooo`cooooo00000on[Zj_oXJ6Q
oo_kn`04oo_kn`03ooclo?okno_ono_k00?ono_k0_ojn_X3ooWin@;on?Sh
01WonOWiof9RH_n4Q8ConOWioe9BD_mXJ6SoUIFEofIVI_ohn?SoNWYjoe=C
Doohn?SonOWioi2@T?ld=3CoKfm_oiVIVOlP823o/k>cooWinOo@d=3o7alO
ojRXZ?oinOWon?Sh00;onOWi00?ok>c/oalO7onIVIT00_ohn?P2ooWin@04
ooShn?n1PH7o;2`/ooShn0;onOWi00Kon?ShooWinOo@d=3o:BTYogalO?oi
nOT2ooShn0;onOWi00Oon?ShooWinOmkNg_oCTi>oh20P?lS8b?oclo?00;o
nOWi00?on?ShooWinOoinOT00_ohn?P2ooWin@04ooShn?oinOWonOWiooSh
n0;onOWi00Con?ShooWinOoinOWon?Sh0_oinOT2ooShn0;onOWi00Con?Sh
ooWinOoinOWon?Sh0_ojn_X;oo_kn`0>oj6QXOnZZZ[o/k>cokbl_?o4a<Co
b/[:om7AdOoHf=Sog=cLon7QhOoTi>CoinOWon[Zj_o]kNgoonk^kPcok^k^
00000onTY:CoW9bLooGem@03ooGem@03ooCdm?oemOGomOGe00;omOGe00Co
m?CdooGemOodm?Colo?c0_obl_803_oclo?ol_;boo?cloobl_;oGemOogmo
OooHf=So7QhNok:b/_oNg]ko9BDUonGUiOmgMgOoDE5A0_obl_802ooclo?o
i>CTokVi^OnQXJ7o7QhNojf][Ooclo?of=SHoahN7_n5QHGol_;b00;olo?c
00Kol_;bolO7aolN7Qko/[:boo;bl_oclo<3oo;blP03oiRHV?lN7Qkoh>3P
00;ol_;b00Sol?3`oi6ATOlT92Co?cloomKFe_oclo?ol_;boo?cl`?ol_;b
00Golo?conWYjOli>CWo7QhNogmoO`02oo?cl`?ol_;b00?olo?coo;bl_oc
lo<00oobl_800ooclo?ol_;boo?cl`02oo;blP;olo?c0oobl_800ooclo?o
l_;boo?cl`03oo;blP05oo?cloobl_;olo?coo?cloodm?@00_oemOD2ooCd
m0KomOGe017om?Cdoi^KVonTY:Co[Zj^okFe]Onm_Kgoa<C4ol[:b_o@d=3o
e=CDomWIfOoMgMgoh>3Pon?ShooTi>Coi^KVonGUi@3oonKViP[oi^KV0000
1?nZZZ[oX:2Pon[Zj_oYjNT4on[ZjP04onWYjOoZj^[oj^[Zon[ZjP?ojNWY
013oj>SXonOWiooWinOoj>SXonOWiooXj>SoGEeMog]kNon7QhOo;Rh^onCT
i?oWinOoEeMGoiBDU?mcLg?oCdm?0_oWinL03?oUiNGoj>SXonOWiooAdM7o
7alOokVi^OoXj>SoiNGUocPh>?m0@43ohN7QonOWi`;oj>SX017o^[ZjoalO
7on][Jgoj>SXonOWiooXj>SoinOWonSXj?nGUiOo7alOom?CdooWinOoe=CD
odm?ColO7aooJFUYomkNgP02onOWi`04onSXj?oWinOoj>SXonOWi`;oj>SX
00GoiNGUodQ8B?lO7aoo[Jf]onOWi`02onSXj0?oinOW00Coj>SXonOWiooX
j>SoinOW0_oXj>P01OoWinOoj>SXonOWiooXj>SoinOW00;oj>SX0ooWinL0
1?oXj>SoinOWonSXj?oWinL2onSXj003onOWiooXj>Soj>SX00;ojNWY1?oZ
j^X00ooYjNWoj^[ZonWYj@03on[ZjP0>oj6QXOnZZZ[o];Bdokbl_?o4a<Co
b/[:om7AdOoHf=Sog=cLon7QhOoTi>Coj>SXon[Zj_o]kNd3onk^kP03ong]
kOo^k^kok^k^0?ook^k^1_o^k^h00005okJf]_n/[:cono_koo[jn_okno/0
0oojn_X01Ookno_on_[joo_knoojn_[ono_k00?onOWi1Oohn?P01?mRHV;o
Q8B4od=3@omiNGT2ooShn004ojf][Om@D53oNg]koeEEE@;on?Sh00KoL71`
oeIFE_n;Rh_oEEEEocHf=_ofm_H2ooShn009okfm_Ol/;2co=CDeohJ6Q_md
M7Co][JfonSXj?lQ8B7oX:2P00Gon?Sh00OoQhN7ob/[:oogmoOon?ShodA4
A?lf=SKo_Kfm00[on?Sh00GoVi^Kob4Q8OmUIFGo?3`lono_k`0MooShn0;o
nOWi00Gono_koo[jn_ojn_[ono_koo[jnP02oo_kn`0Boo[jn_okno_on_[j
oo[jn_n/[:co]kNgol71`Oo:b/[odM7AomWIfOoPh>3oinOWonc/k?oalO7o
mOGeooShn?okno_ooOgmooooool<ooooo`0000?oZZZZoj6QXOokno/02_ok
no/2oo[jnP;onOWi0_ohn?P2ooWin@04of9RH_mJFU[o7alOolK6aP;onOWi
00colO7aobXZ:_mJFU[oDe=CooWinOohn?Soj^[Zok^k^on<S8coXJ6Qon;R
h_oinOT2ooShn00:ooWinOoPh>3oVi^Koh61POnDU9CoemOGooWinOm8B4So
De=CooShn0?onOWi00Som_Kfocdm?OmRHV;onOWiomCDe?lO7aoo_KfmooSh
n0;onOWi0oohn?P4ooWin@07on3Ph?lY:BWoKFe]ooKfm_m>CTkoNg]kooSh
n002ooWin@?on?Sh1?oinOT2ooShn0;onOWi00?on?ShooWinOohn?P00_oi
nOT3ooShn0ConOWi0_ohn?P00ooinOWon_[joo[jnP03oo_kn`03ooclo?ok
no_ono_k00Gono_k00koXJ6QojZZZ_nd];Co_;blolC4a?o;bl_odM7AomSH
f?oMgMgohN7QonCTi?oWinOojn_[ong]k@?ok^k^00?okNg]onk^k_o^k^h0
ooo^k^h6onk^kP0000KoYJFUoi^KVooemOGom?CdooGemOodm?@4ooGem@04
ooCdm?oemOGom?CdooCdm0Golo?c0_obl_801?mNGUko820PocXj>_oclo<2
oo;blP05oo?clom_Kfoo820Poe1@D?obl_800ooclo<4oo;blP;olo?c0_ob
l_800ooclo?ol_;boo?cl`02oo;blP03ol30`?lO7aooS8b<00;ol_;b00co
kno_ogIfM_lS8b?od];Boo;bl_oOgmoo820PoiZJV_oclo?ol_;bomkNg_oV
i^H2oo?cl`Col_;b00OoGUiNobl_;ooQhN7ol_;bom7AdOlU9BGo_kno00;o
l_;b0ooclo<4oo;blP;olo?c0_obl_800ooclo?ol_;boo?cl`02oo;blP?o
lo?c1?obl_84oo?cl`;om?Cd00?omOGeooCdm?oemOD00ooemOD04oodm?Co
mOGeooCdm?oemOGoVi^KojFUYOn^[Zko]KFeokjn__o3`l?ob/[:om3@d?oE
eMGofMWIomgMgOoPh>3oh^;RonCTi?oUiND0oooVi^H;onKViP0000CoZj^[
oj2PX?oZj^[ojNWY0ooZj^X00ooYjNWoj^[ZonWYj@03on[ZjP0<onWYjOoX
j>SoinOWonSXj?oWinOoj>SXonOWiooXj>SoGEeMoalO7omoOgooj>SX0_oW
inL02OoXj>So]kNgoalO7om?CdooinOWonSXj?oWinOoj>SXonOWi`02onSX
j0;oinOW00Coj>SXonOWiooWinOoj>SX1?oWinL02OoXj>So[Jf]oc4a<Olc
<c?oD51@oc0`<?lj>S[o^k^konSXj002onOWi`09oi>CTol`<33oADE5odA4
A?lP823o_[jnonOWiooXj>SoinOW00;oj>SX00?oYJFUoalO7onOWil00_oW
inL02OoXj>SoS8b<ocXj>_oOgmooinOWonSXj?oWinOoj>SXonOWi`02onSX
j0;oinOW00Coj>SXonOWiooWinOoj>SX1?oWinL01?oXj>SoinOWonSXj?oW
inL2onSXj0;oinOW00Coj>SXonOWiooXj>SojNWY0_oZj^X2onWYj@04on[Z
j_oYjNWoj^[ZonWYj@?oj^[Z00koX:2Poj^[Zond];Co_;blolC4a?o:b/[o
dM7AomOGeooLg=cohN7QonCTi?oXj>Soj^[Zong]k@;ok^k^00?okNg]onk^
k_o^k^h0ooo^k^h7onk^kP0000?o][Jfojb/[?ojn_X00_okno/01Oojn_[o
no_koo[jn_ojn_[ono_k00;on_[j00Cono_kooWinOoinOWonOWi1Oohn?P0
0ooWinOog]kNoo7al@04ooShn003ooOgmooNg]koi^KV01?on?Sh00Golo?c
olo?conc/k?odm?CooGem@05ooShn004ooGemOnn_[ko`/;2onCTi0Kon?Sh
00?oinOWomoOgoohn?P00oohn?P00oogmoOog]kNoo;blP0JooShn0?onOWi
00Oono_koo[jn_okno_ono_koo[jn_okno_on_[j00;ono_k013on_[joo_k
non/[:co]kNgol71`Oo9bLWod];BomWIfOoOgmooinOWonc/k?oalO7omOGe
ooShn?olo?cooOgmooooool<ooooo`0000?oZZZZoj6QXOokno/02_okno/0
0oojn_[onOWiooWin@03ooWin@;on?Sh00ConOWiooShn?oinOWon?Sh0_oi
nOT01_ohn?SonOWiooWinOohn?SonOWiooShn0;onOWi0_ohn?P01?oinOWo
n?ShooWinOohn?P2ooWin@06ooShn?oinOWonOWiooShn?oinOWon?Sh0_oi
nOT2ooShn004ooWinOohn?SonOWiooShn0;onOWi00Kon?ShooWinOoinOWo
n?ShooWinOohn?P2ooWin@;on?Sh00ConOWiooShn?oinOWon?Sh0_oinOT0
1_ohn?SonOWiooWinOohn?SonOWiooShn0;onOWi0_ohn?P01?oinOWon?Sh
ooWinOohn?P2ooWin@06ooShn?oinOWonOWiooShn?oinOWon?Sh0_oinOT2
ooShn003ooWinOohn?SonOWi00;onOWi0_ojn_X;oo_kn`0>oj6QXOnZZZ[o
];Bdokbl_?o4a<Cobl_;om7AdOoGemOogMgMon7QhOoTi>Coj>SXon[Zj_o/
k>coonk^kPcok^k^00000onTY:CoVi^KooGem@03ooGem@04ooCdm?oemOGo
mOGeooCdm0;omOGe0_odm?@2oo?cl`?ol_;b0_oclo<2oo;blP;olo?c00Oo
l_;boo?cloobl_;ol_;boo?cloobl_;olo?c00?ol_;b0_oclo<2oo;blP;o
lo?c00Ool_;boo?cloobl_;ol_;boo?cloobl_;olo?c00?ol_;b0_oclo<2
oo;blP;olo?c00Ool_;boo?cloobl_;ol_;boo?cloobl_;olo?c00?ol_;b
0_oclo<2oo;blP;olo?c00Ool_;boo?cloobl_;ol_;boo?cloobl_;olo?c
00?ol_;b0_oclo<2oo;blP;olo?c00Ool_;boo?cloobl_;ol_;boo?cloob
l_;olo?c00?ol_;b0_oclo<2oo;blP;olo?c00Kol_;boo?cloodm?Com?Cd
ooGemOodm?@2ooGem@03ooCdm?oemOGomOGe00;omOGe017om?CdoibLW?nU
YJGo[Jf]okJf]_nm_Kgo`l?3ol[:b_o@d=3oeMGEomWIfOoLg=cogmoOon?S
hooUiNGoi^KVonGUi@3oonKViP[oi^KV00001On[Zj_oXJ6Qon[Zj_oZj^[o
jNWY00?oj^[Z00?ojNWYon[Zj_oYjNT00_oZj^X4onSXj00:onOWiooXj>So
inOWonOWiooXj>SoinOWonSXj?oWinOoj>SXonOWi`;oj>SX0_oWinL2onSX
j00:onOWiooXj>SoinOWonOWiooXj>SoinOWonSXj?oWinOoj>SXonOWi`;o
j>SX0_oWinL2onSXj00:onOWiooXj>SoinOWonOWiooXj>SoinOWonSXj?oW
inOoj>SXonOWi`;oj>SX0_oWinL2onSXj00:onOWiooXj>SoinOWonOWiooX
j>SoinOWonSXj?oWinOoj>SXonOWi`;oj>SX0_oWinL2onSXj00:onOWiooX
j>SoinOWonOWiooXj>SoinOWonSXj?oWinOoj>SXonOWi`;oj>SX0_oWinL2
onSXj008onOWiooXj>SoinOWonOWiooXj>SoinOWonSXj?oWinL2onSXj003
onWYjOoZj^[ojNWY00Koj^[Z017ojNWYon[Zj_oZj^[oXJ6QojZZZ_nd];Co
_;blolC4a?o;bl_od=3@omOGeooMgMgohN7QonCTi?oXj>Sojn_[onc/k003
onk^kP03ong]kOo^k^kok^k^0?ook^k^1_o^k^h00008okJf]_n/[:cono_k
oo_knoojn_[ono_koo[jn_okno/2oo[jnP03oo_knoojn_[ono_k00;onOWi
Foohn?P2ooWin@03oo_knoojn_[ono_k00?on_[j0_okno/04Oojn_[ono_k
oo[jn_n/[:co][Jfol30`?o:b/[odM7AomWIfOoPh>3oinOWonc/k?oalO7o
m?CdooShn?olo?cooOgm0?oooooo3?ooool00008ojZZZ_nQXJ7om_KfooKf
m_ogmoOom_KfooOgmoofm_H3ooOgm`03ooKfm_ogmoOomOGe00;omOGe00Oo
m?CdooGemOodm?Com?CdooGemOodm?ComOGe00;om?Cd0_oemOD01oodm?Co
mOGeooCdm?odm?ComOGeooCdm?oemOD00_odm?@00ooemOGom?CdooGem@02
ooCdm0;omOGe00Oom?CdooGemOodm?Com?CdooGemOodm?ComOGe00;om?Cd
00?omOGeooCdm?oemOD00_odm?@2ooGem@07ooCdm?oemOGom?CdooCdm?oe
mOGom?CdooGem@02ooCdm003ooGemOodm?ComOGe00;om?Cd0_oemOD01ood
m?ComOGeooCdm?odm?ComOGeooCdm?oemOD00_odm?@00ooemOGom?CdooGe
m@02ooCdm0;omOGe00Oom?CdooGemOodm?Com?CdooGemOodm?ComOGe00;o
m?Cd00?omOGeooCdm?oemOD00_odm?@2ooGem@07ooKfm_ogmoOom_KfooKf
m_ogmoOom_KfooOgm`02ooKfmP0@ooOgmoofm_KomoOgoj2PX?nZZZ[o];Bd
okbl_?o4a<Cobl_;om7AdOoGemOog=cLon7QhOoTi>CoinOWon[ZjP;okNg]
00?ok^k^ong]kOo^k^h0ooo^k^h8onk^kP0000?oYJFUoi^KVooXj>P00_oX
j>P01OoWinOoj>SXonSXj?oXj>SoinOW00?oj>SX00?oinOWonKVi_oVi^H0
0_oVi^H00ooUiNGoi^KVoahN7P03oahN7P;oiNGU00?oi^KVonGUiOoVi^H0
1OoVi^H01?oUiNGoi^KVonKVi_oUiND2onKViP;oiNGU00?oi^KVonGUiOoV
i^H01OoVi^H01?oUiNGoi^KVonKVi_oUiND2onKViP;oiNGU00?oi^KVonGU
iOoVi^H01OoVi^H01?oUiNGoi^KVonKVi_oUiND2onKViP;oiNGU00?oi^KV
onGUiOoVi^H01OoVi^H01?oUiNGoi^KVonKVi_oUiND2onKViP;oiNGU00?o
i^KVonGUiOoVi^H01OoVi^H01?oUiNGoi^KVonKVi_oUiND2onKViP;oiNGU
00?oi^KVonOWiooXj>P02?oXj>P04OoWinOoj>SXoi^KVonTY:Co[Jf]okJf
]_nm_Kgoa<C4ol[:b_o@d=3oeMGEom[Jf_oMgMgogmoOon?ShooTi>CoiNGU
0?ooi^KV2ooVi^H00004ojZZZ_nPX:3omoOgooKfmP;omoOg00?om_KfooOg
moofm_H00_ogmoL00oofm_KomoOgooKfmP02ooGem@;om?Cd00Koa<C4obHV
9_l[:b_oHV9RomoOgooemOD2ooCdm003ooGemOodm?ComOGe00Som?Cd00?o
mOGeooCdm?oemOD00_odm?@00ooemOGom?CdooGem@08ooCdm003ooGemOod
m?ComOGe00;om?Cd00?omOGeooCdm?oemOD02?odm?@00ooemOGom?CdooGe
m@02ooCdm003ooGemOodm?ComOGe00Som?Cd00?omOGeooCdm?oemOD00_od
m?@00ooemOGom?CdooGem@08ooCdm004ooGemOodm?ComOGeooCdm0;omOGe
00Gom_KfooOgmoofm_Kom_KfooOgm`02ooKfmP0CooOgmoofm_KomoOgooOg
moofm_KoXJ6QojZZZ_nd];Co_;blolC4a?o;bl_odM7AomOGeooLg=cohN7Q
onCTi?oWinOoj^[Zong]k@3oonk^kPcok^k^00000onf][Ko[:b/ooooo`09
ooooo`?oo_kn00gooOgmooclo?olo?coj>SXolK6a_o3`l?oB4Q8of5QHOol
o?cooOgmooclo?o_knoomOGe00;oo?cl00Coi^KVoogmoOolo?coo?cl0_om
oOd4ooclo003oogmoOo_knoom?Cd00;oo?cl00?oi^KVoogmoOomoOd00_ol
o?`2oogmo@Coo?cl00?ooOgmooclo?olo?`00oolo?`2oogmo@;oo?cl0_om
oOd4ooclo003oogmoOolo?coo?cl00?oo?cl0_omoOd2ooclo0;ooOgm1?ol
o?`00oomoOgoo?clooclo003ooclo0;ooOgm0_olo?`2oogmo@Coo?cl0oom
oOd2ooknoP[ooooo00ko[:b/okNg]oo1`L7obLW9om;Bd_oHf=Soh>3PonOW
ioo/k>colO7aooGemOohn?Soo?cloogmoOoooooo3?ooool00004oj^[ZonQ
XJ7om_KfooKfmPGomoOg00?om_KfooOgmoogmoL00_ofm_H00ooemOGom?Cd
ooGem@03ooCdm00MooGemOn=SHgo8b<Soo?cloodm?CoNg]kobDU9OlV9RKo
Ph>3ogAdM?lY:BWo_;blooGemOodm?Co/k>coalO7onJVY[omOGeooCdm?oe
mOGoNg]kobDU9OlV9RKoPh>3og=cLolX:2So_;blooCdm?oemOD00oodm?@2
ooGem@03ooCdm?oemOGom?Cd00;om?Cd00?omOGeooCdm?odm?@00_odm?@0
1?oemOGom?CdooCdm?odm?@2ooGem@03ooCdm?oemOGom?Cd00;om?Cd00?o
mOGeooCdm?odm?@00_odm?@01?oemOGom?CdooCdm?odm?@2ooGem@03ooCd
m?oemOGom?Cd00;om?Cd00?omOGeooCdm?odm?@00_odm?@01?oemOGom?Cd
ooCdm?odm?@2ooGem@05ooCdm?oemOGom?CdooCdm?oemOD00_ofm_H2ooOg
m`03ooKfm_ogmoOomoOg00;om_Kf0oogmoL03_nQXJ7oZZZZok>c/onl_;co
a<C4ol[:b_oAdM7of=SHomcLg?oQhN7oi>CTonOWiooZj^[okNg]ooo^k^h<
onk^kP0000?oY:BToibLW?oXj>P00ooXj>P01OoWinOoj>SXokVi^OmJFU[o
g]kN00;oj>SX00CoinOWonKVi_oUiNGoiNGU0ooVi^H02ooUiNGoXJ6QoahN
7_oDe=CobLW9oalO7onLW9coeMGEohJ6Q_lN7QkoTi>C00;oiNGU00Coi^KV
oemOGolW9bOo@D510_oUiND01oo9bLWo7alOoifMWOoEeMGoQHF5oalO7onC
Ti<00ooUiND3onKViP?oiNGU00?oi^KVonGUiOoVi^H00_oUiND2onKViP?o
iNGU0ooVi^H3onGUi@03onKVi_oUiNGoi^KV00;oiNGU0_oVi^H3onGUi@?o
i^KV0ooUiND00ooVi^KoiNGUonKViP02onGUi@;oi^KV0ooUiND3onKViP?o
iNGU00Goi^KVonGUiOoVi^Koi^KVonOWi`02onSXj0;oinOW1_oXj>P04OoW
inOoVi^KojBTY?n^[Zko]KFeokfm_Oo4a<Cob/[:om3@d?oDe=CofMWIomgM
gOoPh>3ohn?SonCTi?oVi^KoiNGU0?ooi^KV2_oVi^H00004ojZZZ_nPX:3o
moOgooKfmP?omoOg00Goa<C4ob/[:olQ8B7oDe=Cong]k@02ooKfmP;omOGe
0_odm?@03OoemOGom?CdooGemOn][Jgo7alOon7QhOoFe]Ko820Pok>c/ooe
mOGokno_oalO7on_[jl00_odm?@03_oUiNGo92@TojBTY?lU9BGoaLG5ooGe
mOoGemOo7alOok>c/oodm?Col?3`oalO7on_[joomOGe0oodm?@01?oemOGo
m?CdooGemOodm?@2ooGem@05ooCdm?oemOGom?CdooGemOodm?@00_oemOD3
ooCdm004ooGemOodm?ComOGeooCdm0;omOGe00Gom?CdooGemOodm?ComOGe
ooCdm002ooGem@?om?Cd00ComOGeooCdm?oemOGom?Cd0_oemOD01Oodm?Co
mOGeooCdm?oemOGom?Cd00;omOGe0oodm?@01?oemOGom?CdooGemOodm?@2
ooGem@03ooCdm?oemOGomOGe00;om_Kf1?ogmoL00oofm_KomoOgooKfmP03
ooOgm`0>oj6QXOnZZZ[o];Bdokbl_?o4a<Cob/[:om7AdOoHf=Sog=cLon7Q
hOoTi>Coj>SXon[Zj_o]kNd3onk^kP03ong]kOo^k^kok^k^0?ook^k^1_o^
k^h00003okJf]_n/[:cooooo00?ooooo00Soc<c<obd];OmCDe?o^k^kob`/
;?mFEUKom?CdooknoP;ooOgm00?oo?cloogmoOolo?`00_olo?`04Onb/[;o
8B4QonOWioolo?coTi>CocLg=ombLW;oW9bLob4Q8Onf][KooOgmooclo?nR
XZ;o<c<cooWinOm`L73oMGEe00;oo?cl00[oU9BDocLg=ombLW;oW9bLob4Q
8Onf][Koo?cloogmoOolo?cooOgm3Oolo?`00oomoOgoo?cloogmo@0=oocl
o003oogmoOolo?cooOgm00goo?cl00?ooOgmooclo?omoOd01_olo?`3oogm
o@03ookno_oooooooooo00Wooooo00ko[:b/okNg]oo1`L7ob/[:om7AdOoI
fMWoh>3PonOWioo/k>colO7aooGemOohn?Sono_koogmoOoooooo3?ooool0
0003ojZZZ_nQXJ7om_Kf00;omoOg00WoaLG5ob/[:om?CdoojNWYooOgmoo3
`l?o:RXZoe=CDoo[jn/00_oemOD3ooCdm0;omOGe00?o[Jf]ob0P8?oQhN40
0_odm?@03OoVi^Ko^[Zjoj>SXolO7aoo[jn_ooGemOodm?CoBd];ogalO?oe
mOGo`L71obPX:?oZj^X00_odm?@01ooVi^Ko^k^koj>SXolO7aoo[jn_ooCd
m?oemOD00oodm?@2ooGem@03ooCdm?oemOGom?Cd00;om?Cd00?omOGeooCd
m?oemOD00_odm?@01?oemOGom?CdooCdm?odm?@2ooGem@03ooCdm?oemOGo
m?Cd00;om?Cd00?omOGeooCdm?oemOD00_odm?@01?oemOGom?CdooCdm?od
m?@2ooGem@03ooCdm?oemOGom?Cd00;om?Cd00?omOGeooCdm?oemOD00_od
m?@01?oemOGom?CdooCdm?odm?@2ooGem@04ooCdm?oemOGom?CdooCdm0;o
mOGe00?om_KfooOgmoofm_H00_ogmoL3ooKfmPComoOg00koXJ6QojZZZ_nd
];Co_;blolC4a?o;bl_odM7AomSHf?oMgMgohN7QonCTi?oWinOojn_[ong]
k@?ok^k^00?okNg]onk^k_o^k^h0ooo^k^h6onk^kP0000SoYJFUoi^KVooX
j>SoinOWonSXj?n@T93oBd];omcLg0;oj>SX00GoinOWokJf]_lX:2SoCTi>
omgMg@04onKViP0FonGUiOoVi^KoXZ:RoahN7_oCdm?oi^KVonCTi?oUiNGo
i^KVolo?colN7Qko][JfonGUiOo5aLGo7QhNol30`?oUiNGoi^KVoc/k>onE
UIGoi^KVonCTi0;oiNGU00?od=3@oahN7_ng]kL00_oUiND3onKViP04onGU
iOoVi^KoiNGUonGUi@;oi^KV0_oUiND00ooVi^KoiNGUonKViP02onGUi@?o
i^KV00CoiNGUonKVi_oUiNGoiNGU0_oVi^H2onGUi@03onKVi_oUiNGoi^KV
00;oiNGU0ooVi^H01?oUiNGoi^KVonGUiOoUiND2onKViP;oiNGU00?oi^KV
onGUiOoVi^H00_oUiND3onKViP04onGUiOoVi^KoiNGUonGUi@Coi^KV0_oW
inL00ooXj>SoinOWonSXj003onSXj00ConOWiooXj>SoinOWonSXj?nKVi_o
YJFUojj^[_ne]KGo_[jnol?3`oo:b/[od=3@omGEeOoIfMWogMgMon3Ph?oR
h^;oi>CTonGUi@3oonKViP_oi^KV00001?n[Zj_oX:2PooOgmoofm_H2ooOg
m`04oo;bl_ofm_KomoOgooKfmP;omoOg02;o`/;2obTY:OmADE7oj^[ZooGe
mOodm?ComOGeooCdm?oemOGo[Jf]oalO7ooPh>3omOGeofa/K?mCDe?oR8R8
oe9BD_ld=3Col_;booCdm?n3Ph?oATI6ooGemOodm?ComOGeoi>CTom:BT[o
m?Cdofe]KOmCDe?oR8R8oe=CDold=3Colo?c0_odm?@01?oemOGom?CdooGe
mOodm?@2ooGem@;om?Cd00ComOGeooCdm?odm?ComOGe1?odm?@01?oemOGo
m?CdooGemOodm?@2ooGem@;om?Cd00ComOGeooCdm?odm?ComOGe1?odm?@0
1?oemOGom?CdooGemOodm?@2ooGem@;om?Cd00ComOGeooCdm?odm?ComOGe
1?odm?@01?oemOGom?CdooGemOodm?@2ooGem@;om?Cd00?omOGeooCdm?oe
mOD00_ofm_H01oogmoOom_KfooKfm_ogmoOom_KfooOgmoofm_H00oogmoL0
3_nPX:3oZj^[okBd]?nl_;coa<C4ol[:b_oAdM7oemOGomcLg?oQhN7oi>CT
onSXj?oZj^[okNg]0_o^k^h00oo]kNgok^k^onk^kP3oonk^kPOok^k^0000
0onf][Ko[:b/ooooo`0:ooooo`04olO7aol/;2coE5ADoo;blPCoo?cl00go
/[:bob4Q8OoWinOoo?clonk^k_nn_[koShn?ojBTY?oUiNGooOgmooclo?nb
/[;ob/[:00?oo?cl00[ok>c/oj2PX?oemOGok^k^okno_on?ShooY:BTonKV
i_olo?cooOgm3oolo?`00oomoOgoo?clooclo00=ooclo003oogmoOolo?co
o?cl00goo?cl00?ooOgmooclo?olo?`02?olo?`2oogmo@03ookno_oooooo
oooo00Wooooo00ko[:b/okNg]oo1`L7obLW9om;Bd_oIfMWogmoOonOWioo/
k>colO7aooGemOohn?Soo?cloogmoOoooooo3?ooool00003ojZZZ_nQXJ7o
moOg00;om_Kf00ComoOgooKfm_ogmoOom_Kf0_ogmoL01_ofm_KomoOgooKf
m_o1`L7o:BTYogUiN@;omOGe0_odm?@01?n][Jgo7alOon7QhOodm?@2ooGe
m@06ooCdm?oemOGom?CdooCdm?oemOGom?Cd0_oemOD2ooCdm004ooGemOod
m?ComOGeooCdm0;omOGe00Kom?CdooGemOodm?Com?CdooGemOodm?@2ooGe
m@;om?Cd00ComOGeooCdm?oemOGom?Cd0_oemOD01_odm?ComOGeooCdm?od
m?ComOGeooCdm0;omOGe0_odm?@01?oemOGom?CdooGemOodm?@2ooGem@06
ooCdm?oemOGom?CdooCdm?oemOGom?Cd0_oemOD2ooCdm004ooGemOodm?Co
mOGeooCdm0;omOGe00Kom?CdooGemOodm?Com?CdooGemOodm?@2ooGem@;o
m?Cd00ComOGeooCdm?oemOGom?Cd0ooemOD2ooOgm`03ooKfm_ogmoOom_Kf
00;omoOg0_ofm_H04?ogmoOom_Kfoj6QXOnZZZ[o];Bdokbl_?o4a<Cobl_;
om7AdOoGemOogMgMon7QhOoTi>Coj>SXon[Zj_o/k>coonk^kPcok^k^0000
0onTY:CoVi^KonSXj003onSXj004onOWiooXj>Soj>SXonOWi`;oj>SX0_oW
inL00ooVi^Ko_;blom[JfP02onGUi@;oi^KV00GoXZ:RoahN7_oCdm?oi^KV
onGUi@02onKViP04onGUiOoVi^KoiNGUonKViP?oiNGU0_oVi^H2onGUi@;o
i^KV00OoiNGUonKVi_oVi^KoiNGUonKVi_oUiNGoi^KV00?oiNGU0_oVi^H2
onGUi@;oi^KV00OoiNGUonKVi_oVi^KoiNGUonKVi_oUiNGoi^KV00?oiNGU
0_oVi^H2onGUi@;oi^KV00OoiNGUonKVi_oVi^KoiNGUonKVi_oUiNGoi^KV
00?oiNGU0_oVi^H2onGUi@;oi^KV00OoiNGUonKVi_oVi^KoiNGUonKVi_oU
iNGoi^KV00?oiNGU0_oVi^H2onGUi@;oi^KV00KoiNGUonKVi_oWinOoinOW
onSXj?oWinL2onSXj003onOWiooXj>Soj>SX00;oj>SX017oinOWoibLW?nU
YJGo[Jf]okJf]_nm_Kgo`l?3ol[:b_o@d=3oeMGEomWIfOoLg=cogmoOon?S
hooUiNGoi^KVonGUi@3oonKViP[oi^KV00002on[Zj_oXJ6QooOgmoogmoOo
m_KfooOgmoofm_KomoOgooKfm_ogmoOom_Kf00;omoOg0ooemOD2ooCdm00:
ooGemOodm?Com?Cdonc/k?oKfm_olo?cooCdm?oemOGom?CdooGem@?om?Cd
00ComOGeooCdm?odm?ComOGe0_odm?@01ooemOGom?CdooCdm?odm?ComOGe
ooCdm?oemOD00oodm?@01?oemOGom?CdooCdm?oemOD2ooCdm007ooGemOod
m?Com?CdooCdm?oemOGom?CdooGem@03ooCdm004ooGemOodm?Com?CdooGe
m@;om?Cd00OomOGeooCdm?odm?Com?CdooGemOodm?ComOGe00?om?Cd00Co
mOGeooCdm?odm?ComOGe0_odm?@01ooemOGom?CdooCdm?odm?ComOGeooCd
m?oemOD00oodm?@01?oemOGom?CdooCdm?oemOD2ooCdm004ooGemOodm?Co
m?CdooCdm0;omOGe00?om_KfooOgmoofm_H01_ogmoL04Oofm_KomoOgooKf
m_nQXJ7oZZZZokBd]?nl_;coa<C4ol_;boo@d=3oemOGomgMgOoQhN7oi>CT
onSXj?o[jn_ok>c/00?ok^k^00?okNg]onk^k_o^k^h0ooo^k^h6onk^kP00
00?o][Jfojb/[?ooool02_ooool2ooknoP?oo?cl00?ooOgmooclo?olo?`0
0_olo?`00oomoOgoo?clooclo004ooclo005oogmoOolo?coo?clooclo?om
oOd01?olo?`00oomoOgoo?clooclo004ooclo005oogmoOolo?coo?cloocl
o?omoOd01?olo?`00oomoOgoo?clooclo004ooclo005oogmoOolo?coo?cl
ooclo?omoOd01?olo?`00oomoOgoo?clooclo004ooclo005oogmoOolo?co
o?clooclo?omoOd01?olo?`00oomoOgoo?clooclo004ooclo005oogmoOol
o?coo?clooclo?omoOd01?olo?`01OomoOgoo?clooclo?omoOgoo_kn00_o
oooo00ko[:b/okJf]_o0`<3ob/[:om7AdOoIfMWoh>3PonOWioo/k>colO7a
ooCdm?ohn?Soo?cloogmoOoooooo3?ooool00008ojZZZ_nQXJ7om_KfooKf
m_ogmoOom_KfooOgmoofm_H3ooOgm`03ooKfm_ogmoOomOGe00;omOGe00Oo
m?CdooGemOodm?Com?CdooGemOodm?ComOGe00;om?Cd0_oemOD01oodm?Co
mOGeooCdm?odm?ComOGeooCdm?oemOD00_odm?@00ooemOGom?CdooGem@02
ooCdm0;omOGe00Oom?CdooGemOodm?Com?CdooGemOodm?ComOGe00;om?Cd
00?omOGeooCdm?oemOD00_odm?@2ooGem@07ooCdm?oemOGom?CdooCdm?oe
mOGom?CdooGem@02ooCdm003ooGemOodm?ComOGe00;om?Cd0_oemOD01ood
m?ComOGeooCdm?odm?ComOGeooCdm?oemOD00_odm?@00ooemOGom?CdooGe
m@02ooCdm0;omOGe00Oom?CdooGemOodm?Com?CdooGemOodm?ComOGe00;o
m?Cd00?omOGeooCdm?oemOD00_odm?@2ooGem@07ooKfm_ogmoOom_KfooKf
m_ogmoOom_KfooOgm`02ooKfmP0@ooOgmoofm_KomoOgoj2PX?nZZZ[o];Bd
okbl_?o4a<Cobl_;om7AdOoGemOog=cLon7QhOoTi>CoinOWon[ZjP;okNg]
00?ok^k^ong]kOo^k^h0ooo^k^h8onk^kP0000?oYJFUoi^KVooXj>P00_oX
j>P01OoWinOoj>SXonSXj?oXj>SoinOW00?oj>SX00?oinOWonKVi_oVi^H0
0_oVi^H01?oUiNGoi^KVonKVi_oUiND2onKViP;oiNGU00?oi^KVonGUiOoV
i^H01OoVi^H01?oUiNGoi^KVonKVi_oUiND2onKViP;oiNGU00?oi^KVonGU
iOoVi^H01OoVi^H01?oUiNGoi^KVonKVi_oUiND2onKViP;oiNGU00?oi^KV
onGUiOoVi^H01OoVi^H01?oUiNGoi^KVonKVi_oUiND2onKViP;oiNGU00?o
i^KVonGUiOoVi^H01OoVi^H01?oUiNGoi^KVonKVi_oUiND2onKViP;oiNGU
00?oi^KVonGUiOoVi^H01OoVi^H01?oUiNGoi^KVonKVi_oUiND2onKViP;o
iNGU00?oi^KVonOWiooXj>P02?oXj>P04OoWinOoj>SXoi^KVonTY:Co[Jf]
okJf]_nm_Kgoa<C4ol[:b_o@d=3oeMGEom[Jf_oMgMgogmoOon?ShooTi>Co
iNGU0?ooi^KV2ooVi^H00004ojZZZ_nPX:3omoOgooKfmP;omoOg00?om_Kf
ooOgmoofm_H00_ogmoL00oofm_KomoOgooKfmP02ooGem@Gom?Cd00?omOGe
ooCdm?oemOD00_odm?@00ooemOGom?CdooGem@08ooCdm003ooGemOodm?Co
mOGe00;om?Cd00?omOGeooCdm?oemOD02?odm?@00ooemOGom?CdooGem@02
ooCdm003ooGemOodm?ComOGe00Som?Cd00?omOGeooCdm?oemOD00_odm?@0
0ooemOGom?CdooGem@08ooCdm003ooGemOodm?ComOGe00;om?Cd00?omOGe
ooCdm?oemOD02?odm?@01?oemOGom?CdooGemOodm?@2ooGem@05ooKfm_og
moOom_KfooKfm_ogmoL00_ofm_H04oogmoOom_KfooOgmoogmoOom_Kfoj6Q
XOnZZZ[o];Bdokbl_?o4a<Cobl_;om7AdOoGemOog=cLon7QhOoTi>CoinOW
on[Zj_o]kNd0ooo^k^h<onk^kP0000Ko]kNgojf][Ookno_ono_koo[jn_ok
no/2oo[jnP04oo_knoojn_[on_[joo_kn`?on_[j00?onOWiooShn?ohn?P0
0_oinOT4ooShn003ooWinOohn?Son?Sh00?on?Sh0_oinOT2ooShn0;onOWi
1?ohn?P00ooinOWon?ShooShn003ooShn0;onOWi0_ohn?P2ooWin@Con?Sh
00?onOWiooShn?ohn?P00oohn?P2ooWin@;on?Sh0_oinOT4ooShn003ooWi
nOohn?Son?Sh00?on?Sh0_oinOT2ooShn0;onOWi1?ohn?P00ooinOWon?Sh
ooShn003ooShn0;onOWi0_ohn?P2ooWin@Con?Sh00?onOWiooShn?oinOT0
0oojn_X2oo_kn`0Eoo[jn_okno_ono_koo_knoojn_[ono_koo[jn_n][Jgo
^;Rhol71`Oo9bLWod];BomSHf?oPh>3oinOWonc/k?oalO7omOGeooShn?ol
o?cooOgm0?oooooo3?ooool00004ojb/[?nRXZ;ojNWYonWYj@Goj^[Z00?o
jNWYon[Zj_oZj^X00ooYjNT3onSXj0;oinOW0_lP82000olO7aoo820PoalO
7`02oalO7`05ob0P8?lO7aoo7alOob0P8?lO7al00_oXj>P2onOWi`Goj>SX
00CoinOWonSXj?oXj>SoinOW0_oXj>P00ooWinOoj>SXonSXj002onOWi`Go
j>SX00CoinOWonSXj?oXj>SoinOW0_oXj>P00ooWinOoj>SXonSXj002onOW
i`Goj>SX00CoinOWonSXj?oXj>SoinOW0_oXj>P00ooWinOoj>SXonSXj002
onOWi`Goj>SX00CoinOWonSXj?oXj>SoinOW0_oXj>P00ooWinOoj>SXonSX
j002onOWi`Koj>SX0ooYjNT2on[ZjP03onWYjOoZj^[oj^[Z00;ojNWY0ooZ
j^X03_nSXj?o[:b/ok>c/onm_Kgoa<C4ol_;booBd];of=SHomcLg?oQhN7o
i>CTonOWiooZj^[okNg]ooo^k^h<onk^kP0000?oYZJVoijNW_oemOD00ooe
mOD00oodm?ComOGeooGem@02ooGem@04ooCdm?oemOGomOGeooCdm0;olo?c
00?om?Cdoo?clooclo<01Ooclo<01?odm?Colo?coo?cloodm?@4oo?cl`03
ooCdm?oclo?olo?c00Golo?c00Com?Cdoo?clooclo?om?Cd1?oclo<00ood
m?Colo?coo?cl`05oo?cl`04ooCdm?oclo?olo?cooCdm0Colo?c00?om?Cd
oo?clooclo<01Ooclo<01?odm?Colo?coo?cloodm?@4oo?cl`03ooCdm?oc
lo?olo?c00Golo?c00Com?Cdoo?clooclo?om?Cd1?oclo<00oodm?Colo?c
oo?cl`05oo?cl`?om?Cd0_oemOD2ooCdm0KomOGe017om?CdoijNW_nVYZKo
[jn_okNg]onn_[koa/K6ol_;boo@d=3oe=CDomWIfOoMgMgoh>3Pon?ShooT
i>Coi^KVonGUi@3oonKViP[oi^KV00000on^[ZkoY:BToo_kn`0<oo_kna?o
n_[j00GokNg]oo;bl_ojn_[on_[jonCTi004oo[jnP03onGUiOoclo?on_[j
00_on_[j00?omoOgomoOgoogmoL04Oojn_X01Oo]kNgolo?coo[jn_ojn_[o
hn?S00Con_[j00?oiNGUoo?cloojn_X01_ojn_X00oobl_;ohN7QooWin@03
oo[jnP05ong]kOoclo?on_[joo[jn_oUiND03Ookno/03_nTY:Co[Jf]okJf
]_nm_Kgoa/K6olc<c?oCdm?ofMWIomgMgOoQhN7oiNGUonSXj?oZj^[okNg]
0oo^k^h00oo]kNgok^k^onk^kP3oonk^kPKok^k^00001Onk^k_o/[:boo_k
noojn_[ono_k00?on_[j00Gono_koo[jn_okno_on_[joo_kn`02oo[jnP0C
oo_knoojn_[ono_koo_knoojn_[ono_kofATI?n6QXKon_[joo_knoo1`L7o
b/[:oo[jn_okno_oOGemoeMGEookno_on_[joh20P002obTY:@0=ohR8R?mh
N7So;2`/ol71`Ookno_ok>c/oe=CDolX:2SoOGemoo[jn_m]KFgoIFEUoo[j
nP02oo_kn`0:oc4a<OnQXJ7on_[joo[jn_odm?CoPH61obPX:?l`<33o;2`/
ofe]K@;on_[j00OoKFe]ofATI?okno_ono_konGUiOlS8b?oa<C400;on_[j
01goQ8B4oda<C?okno_on_[joh20P?lY:BWo:RXZohR8R?mhN7So;Bd]ol;2
`_ojn_[ok>c/oe=CDolX:2SoOGemoo_knom]KFgoI6AToo[jn_okno_olo?c
ogIfM_lV9RKo9bLWobh^;_nSXj?on_[joh20P002obTY:@06ohR8R?mhN7So
;2`/ol;2`_ojn_[ono_k0_ojn_X01_okno_on_[joo_knookno_on_[joo_k
n`;on_[j00ko/K6aokbl_?o4a<CocLg=omCDe?oLg=cohN7QonSXj?o]kNgo
lO7aooKfm_oinOWono_koogmoOoooooo3?ooool00003ok6a/OnWYjOojNWY
00Goj^[Z00KojNWYon[Zj_oZj^[ojNWYon[Zj_oYjNT2on[ZjP03onWYjOoZ
j^[ojNWY00;oj^[Z023oGUiNogemOOoZj^[of][Job@T9?lb<S;oi^KVon[Z
j_mdM7CoDE5Aon[Zj_o=cLgo8B4Qoj2PX?oJf][oRHV9ob4Q8OnGUiOoj^[Z
onWYjOnHV9So:RXZomcLg?oZj^[ojNWYofIVI_mOGeoojNWYon[Zj_oYjNWo
;bl_oiJFUP;oj^[Z00ooNGUioc4a<On/[:coi^KVon7QhOo8b<SojNWYon[Z
j_mVIVKoGUiNon[Zj_oYjNWoe]KFob4Q8Ong]kL00_oZj^X09_mkNg_oAdM7
on[Zj_o=cLgo8R8Roj2PX?oJf][oRHV9ob0P8?nGUiOojNWYon[Zj_nIVIWo
:RXZomcLg?oZj^[ojNWYofIVI_mOGeoojNWYon[Zj_mdM7Co:BTYoiJFU_oQ
hN7oc/k>olW9bOo>c/ko8R8Roj2PX?oJf][oRHV9ob0P8?nGUiOoj^[ZonWY
jOoZj^[ojNWY0_oZj^X00ooYjNWoj^[ZonWYj@04on[ZjP0>ojNWYon`/;3o
^KViol30`?o7alOoc/k>om?CdooIfMWog]kNon;Rh_oUiNGoj>SXon_[joo]
kNd3onk^kP03ong]kOo^k^kok^k^0?ook^k^1_o^k^h00006ojb/[?nTY:Co
mOGeooCdm?oemOGom?Cd1?oemOD01Oodm?ComOGeooGemOoemOGom?Cd00Co
mOGe01Com?CdooGemOmPH63oPH61ooGemOnNWYko9BDUoclo?ond];ComOGe
ogUiNOmBDU;omOGeomOGeolP823o/k>cooCdm?o`l?3o7alOojn_[`;omOGe
00?oMGEeoe9BD_oemOD00_oemOD00omXJ6SoH61PooGem@02ooGem@08obd]
;OnLW9com?Cdonc/k?lR8R;oPh>3ooGemOodm?@3ooGem@03ooCdm?mYJFWo
H61P00;omOGe00?oh>3PoalO7ono_kl00_oemOD03_n0P83oB4Q8ooCdm?oG
emOo7alOok>c/oodm?Col?3`oalO7on`/;3omOGeooCdm?meMGGoDU9B0ooe
mOD01_mYJFWoH61PooGemOo[jn_o8R8RofMWI`ComOGe00Soe]KFoalO7onc
/k?omOGeoo7alOlP823o[jn_ooCdm0?omOGe00?om?CdooGemOoemOD00_oe
mOD04oodm?ComOGeooCdm?oemOGoY:BTojf][Ond];Co^k^kol71`Oo7alOo
cLg=om;Bd_oFe]Kof][JomkNg_oPh>3oh^;RonCTi?oUiND0oooVi^H;onKV
iP0000?o];Bdoj^[Zookno/01Ookno/00oolo?cono_koo_kn`0:oo_kn`0:
ofATI?n6QXKono_koeADE?mZJV[oV9RHofQXJ?okno_oO7aloeEEE@;ono_k
00[oTY:BocHf=_maLG7oVi^Kob4Q8One]KGono_kooclo?mhN7SoF5QH0ook
no/00om/K6coHf=Soo_kn`02oo_kn`06oc0`<?nQXJ7ono_kom;Bd_lP823o
MGEe0_n=SHd01_n>SXkoXZ:Roo_knookno_oK6a/ofATI0;ono_k00?oiNGU
ob4Q8Oo4a<@00_okno/02_n3Ph?oBTY:oo_knookno_oTY:BocHf=_maLG7o
Vi^Kob4Q8Ond];@2oo_kn`0;ogQhN?mHF5Sono_koo_knoolo?coK6a/of=S
Hookno_od];Bob4Q8OnZZZX01Ookno/01_nCTi?o=SHfog5aLOnJVY[o8B4Q
okFe]@gono_k00koZj^[okBd]?nl_;co`l?3ol[:b_o?clooe]KFom_KfooN
g]kohn?SonGUiOoYjNWoj^[Zong]k@;ok^k^00?okNg]onk^k_o^k^h0ooo^
k^h7onk^kP0000?o`l?3okbl_?ojn_X00_okno/01Oojn_[ono_koo[jn_oj
n_[ono_k00;on_[j00Oono_koo[jn_okno_ono_koo[jn_okno_on_[j00;o
no_k01;oI6ATohJ6Q_oPh>3o8b<SokVi^OoUiNGo:RXZong]kOmmOGgoEeMG
oo_knoojn_[ono_konc/k?o0`<3oZJVYob<S8one]KD2oo[jnP0@ogUiNOmI
FEWon_[joo_knoojn_[oKVi^of9RH_ojn_[ono_koo[jn_la<C7oXJ6Qoo[j
n_oOgmoo8b<Sofm_K`;oRh^;00ooCDe=oeQHF?ojn_[ono_kofe]KOmTI6Co
no_koo[jn_oVi^Ko8b<SolC4a?okno_on_[johB4Q?m<C4`00_ojn_X02ook
no_ojn_[ol30`?nYZJWo8R8RokFe]Oojn_[ono_kogUiNOmIFEWono_k00;o
n_[j00[oKFe]ofATI?ojn_[oh>3Pob8R8_n<S8cono_koo[jn_okno_on_[j
0_okno/01Oo[jn_o`<30ojRXZ?lS8b?o]KFe00;on_[j00Oono_koo[jn_ok
no_ono_koo[jn_okno_on_[j00;ono_k013on_[joo_knonk^k_o`l?3ol_;
booBd];of][Jon3Ph?oUiNGojn_[ono_koobl_;om_Kfoo[jn_olo?cooOgm
ooooool<ooooo`0000?o^KViok:b/_oZj^X00_oYjNT01?oZj^[ojNWYon[Z
j_oYjNT2on[ZjP04onWYjOoZj^[oj^[ZonWYj@Coj^[Z0_oYjNT02_mNGUko
OGemohV9ROl`<33oi^KVon[Zj_mHF5SoUiNGogAdM?m@D502on[ZjP0;onSX
j?oZj^[ojNWYom?CdolQ8B7o^[Zjon[Zj_oYjNWoLG5aoe=CDooYjNT00_oZ
j^X02omVIVKo8R8RojBTY?oZj^[og]kNob4Q8OnVYZKoj^[ZonSXj?lk>c_o
P82000;oj^[Z02GoCTi>ogAdM?oZj^[ojNWYofIVI_lY:BWo][Jfon[Zj_o4
a<Co820PoeEEEOoQhN7oj^[ZofYZJ_mDE5Coj^[ZonWYjOoXj>Soj^[ZonWY
jOoDe=Co8B4Qok^k^ooZj^[ojNWYog5aLOmCDe?ojNWYon[Zj_oYjNWoIVIV
oemOGooYjNWoj>SXocTi>Om2@T;oi>CT00?oj^[Z00WojNWYonSXj?oZj^[o
jNWYomCDe?lP823o^k^kon[Zj_oYjNT00_oZj^X00ooYjNWoj^[Zon[ZjP02
on[ZjP;ojNWY013oj^[ZonWYjOnb/[;o^KViol30`?o8b<SocLg=om?CdooG
emOog=cLon7QhOoShn?oinOWonWYjOoZj^[ok>c/ooo^k^h<onk^kP0000?o
]KFeojj^[_oemOD00ooemOD01?odm?ComOGeooGemOodm?@4ooGem@04ooCd
m?oemOGomOGeooCdm0?omOGe00[oH61Poh61POm1@D7oMgMgooCdm?oemOGo
Zj^[odi>C_miNGWoDU9B0_oemOD0:Om]KFgoDe=CohV9ROmCDe?o=3@doo?c
looemOGo/k>cod92@_le=CGoMgMgoijNW_oemOGoJ6QXoeEEEOmADE7oDe=C
oda<C?lX:2Sojn_[ooGemOodm?Co^KViobh^;_mdM7CoIFEUob`/;?oDe=Co
mOGeooCdm?mYJFWoDe=Coe5ADOmVIVKoAdM7ocPh>?nUYJGo?Cdmofi^K_lX
:2SoUiNG00;omOGe00ooKFe]oeADE?n8R8SoDe=Coc@d=?oclo?omOGeok>c
/om3@d?o=CDeogMgMonOWioomOGeofQXJ?mPH6000_oemOD03Onk^k_o:BTY
oc<c<on3Ph?oLG5aok>c/ooemOGoKFe]oe=CDon8R8SoDe=Coc@d=?oclo<0
1?oemOD01?odm?ComOGeooGemOodm?@4ooGem@0AooCdm?n_[joo][Jfok^k
^oo2`/;oalO7olg=cOoBd];oeMGEom[Jf_oLg=cog]kNon7QhOoTi>CoiNGU
onKVi_oUiND0oooVi^H:onKViP0000?o_knookVi^Oolo?`03ookno/01ool
o?cono_koo_knomTI6CoFe]Kob4Q8Oo8b<P00_okno/01?odm?Co;2`/oe]K
FomEEED2oo_kn`05onc/k?nn_[koSXj>oj:RX_oUiND00_okno/03?o:b/[o
De=Cod10@?nOWioo_;bloo_knom/K6coI6AToo;bl_nZZZ[oTi>Con3Ph0Co
no_k00Coe]KFoi2@T?n?Shoof][J0ookno/02ono_koo^k^konk^k_nWYjOo
TI6AomcLg?okno_ocLg=ohf=SOnh^;Son?Sh00;ono_k00ookNg]okfm_On>
SXkoXj>SonGUiOokno_oo?clol[:b_mCDe?o@410oijNW_nl_;cono_kokno
_onk^k/00ookno/02ooRh^;oWYjNoh:2P_nFUYKofMWIoo_knoo/k>co_Kfm
ohj>S_nSXj?oi>CT00Wono_k00?oo?cloo_knookno/00_okno/03?ni^KWo
_knoolK6a_o;bl_odM7AomKFe_oIfMWog]kNon;Rh_oTi>CoinOWon[ZjP;o
k>c/0oo^k^h00oo]kNgok^k^onk^kP3oonk^kPKok^k^00002?o@d=3ob/[:
oo_knookno_on_[joo_knoojn_[ono_k0_ojn_X01Ookno_on_[joo_knooj
n_[ono_k00?on_[j0_okno/01?ojn_[oI6ATobDU9Olo?cl2oo[jnP05oo_k
noojn_[oMWIfob@T9?mGEeL00oojn_X2oo_kn`0<oo[jn_okno_on_[joo_k
noojn_[oTi>Cofm_Koojn_[ono_koo[jn_m]KFgoI6AT0_ojn_X2oo_kn`04
oo[jn_okno_on_[joo_kn`;on_[j00Gono_koo[jn_okno_on_[joo_kn`03
oo[jnP;ono_k00Con_[joo_knoojn_[ono_k0_ojn_X01Ookno_on_[joo_k
noojn_[ono_k00?on_[j0_okno/02onCTi?oKfm_oo[jn_okno_on_[jom[J
f_oIfMWon_[joo_knoojn_[ono_k00?on_[j0_okno/01?ojn_[ono_koo[j
n_okno/2oo[jnP05oo_knoojn_[ono_koo[jn_okno/00oojn_X2oo_kn`0A
oo[jn_okno_on_[jol_;boo@d=3oemOGomgMgOoQhN7oinOWon_[joo`l?3o
lo?cooKfm_ohn?Sono_kooclo?ono_h0ooooool<ooooo`0000Soa/K6ol71
`OoYjNWojNWYon[Zj_oYjNWoj^[ZonWYj@?oj^[Z00OojNWYon[Zj_oYjNWo
jNWYon[Zj_oYjNWoj^[Z00;ojNWY00Coj^[ZoeiNG_lQ8B7oPH610ooZj^X0
1ooYjNWo^KViob0P8?m@D53oj^[ZonWYjOoZj^X00_oYjNT01?oZj^[ojNWY
on[Zj_oYjNT3on[ZjP07onWYjOoZj^[ojNWYofIVI_mNGUkojNWYon[ZjP02
onWYj@04on[Zj_oYjNWoj^[ZonWYj@?oj^[Z00OojNWYon[Zj_oYjNWojNWY
on[Zj_oYjNWoj^[Z00;ojNWY00Coj^[ZonWYjOoZj^[ojNWY0ooZj^X01ooY
jNWoj^[ZonWYjOoYjNWoj^[ZonWYjOoZj^X00_oYjNT02OoZj^[ojNWYon[Z
j_oYjNWoj^[ZofIVI_mNGUkojNWYon[ZjP02onWYj@03on[Zj_oYjNWoj^[Z
00;ojNWY00Coj^[ZonWYjOoZj^[ojNWY0ooZj^X01ooYjNWoj^[ZonWYjOoY
jNWoj^[ZonWYjOoZj^X00_oYjNT04?oZj^[ojNWYon[Zj_o0`<3oalO7olg=
cOoAdM7oeMGEomWIfOoMgMgoh>3PonCTi?oUiNGojNWYon[Zj_o[jn/2ong]
k@03onk^k_o]kNgok^k^0?ook^k^2?o^k^h00003olC4a?no_koomOGe00;o
mOGe00Oom?CdooGemOoemOGomOGeooCdm?oemOGom?Cd00WomOGe00Kohn?S
om_Kfoo^k^komOGeooCdm?oemOD2ooCdm003omcLg?oRh^;omOGe00GomOGe
00Oom?CdooGemOoemOGomOGeooCdm?oemOGom?Cd00;omOGe00?oQhN7oh20
P?oemOD01?oemOD01oodm?ComOGeooGemOoemOGom?CdooGemOodm?@02Ooe
mOD01oodm?ComOGeooGemOoemOGom?CdooGemOodm?@02OoemOD01?odm?Co
mOGeooGemOoemOD2onCTi003ooCdm?oemOGomOGe00OomOGe00Oom?CdooGe
mOoemOGomOGeooCdm?oemOGom?Cd00WomOGe00kom?CdooGemOno_kooa<C4
olS8b?o<c<cod=3@omCDe?oHf=Sof][JomgMgOoOgmoohN7Qon?Sh`?oiNGU
oooVi^H;onKViP0000?oc/k>olW9bOokno/0M?okno/03_o:b/[oc/k>om?C
dooGemOof][JomkNg_oPh>3ohn?SonKVi_oWinOojNWYon_[joo/k>cokNg]
ooo^k^h<onk^kP0000KohN7QomgMgOokno_ono_koo[jn_okno/2oo[jnP04
oo_knoojn_[on_[joo_kn`;on_[j0_okno/01_ojn_[ono_koo_knookno_o
n_[joo_kn`;on_[j00Cono_koo[jn_ojn_[ono_k0_ojn_X2oo_kn`06oo[j
n_okno_ono_koo_knoojn_[ono_k0_ojn_X01?okno_on_[joo[jn_okno/2
oo[jnP;ono_k00Kon_[joo_knookno_ono_koo[jn_okno/2oo[jnP04oo_k
noojn_[on_[joo_kn`;on_[j0_okno/01_ojn_[ono_koo_knookno_on_[j
oo_kn`;on_[j00Cono_koo[jn_ojn_[ono_k0_ojn_X2oo_kn`06oo[jn_ok
no_ono_koo_knoojn_[ono_k0_ojn_X01?okno_on_[joo[jn_okno/2oo[j
nP;ono_k00Kon_[joo_knookno_ono_koo[jn_okno/2oo[jnP04oo_knooj
n_[on_[joo_kn`;on_[j0_okno/04oojn_[ono_koo_knookno_on_[joo_k
noojn_[ogMgMon;Rh_oUiNGojNWYonc/k?o_knoolo?cooGemOogmoOon?Sh
oo_knoomoOd00_ono_koooooo`cooooo00001?oFe]Kod];BonWYjOoYjNT5
on[ZjP04onWYjOoZj^[oj^[ZonWYj@;oj^[Z00?ojNWYon[Zj_oZj^X00_oY
jNT5on[ZjP04onWYjOoZj^[oj^[ZonWYj@;oj^[Z00?ojNWYon[Zj_oZj^X0
0_oYjNT5on[ZjP04onWYjOoZj^[oj^[ZonWYj@;oj^[Z00?ojNWYon[Zj_oZ
j^X00_oYjNT5on[ZjP04onWYjOoZj^[oj^[ZonWYj@;oj^[Z00?ojNWYon[Z
j_oZj^X00_oYjNT5on[ZjP04onWYjOoZj^[oj^[ZonWYj@;oj^[Z00?ojNWY
on[Zj_oZj^X00_oYjNT5on[ZjP04onWYjOoZj^[oj^[ZonWYj@;oj^[Z00?o
jNWYon[Zj_oZj^X00_oYjNT5on[ZjP04onWYjOoZj^[oj^[ZonWYj@;oj^[Z
00?ojNWYon[Zj_oZj^X00_oYjNT3on[ZjP0:om?CdooFe]Kof=SHomcLg?oP
h>3ohN7QonCTi?oVi^KoinOWonWYj@;ojn_[00?ok>c/ong]kOo^k^h0ooo^
k^h;onk^kP0000?od];Bom3@d?oemOD00ooemOD00oodm?ComOGeooGem@02
ooGem@03ooCdm?oemOGomOGe00;om?Cd1_oemOD00oodm?ComOGeooGem@02
ooGem@03ooCdm?oemOGomOGe00;om?Cd1_oemOD00oodm?ComOGeooGem@02
ooGem@03ooCdm?oemOGomOGe00;om?Cd1_oemOD00oodm?ComOGeooGem@02
ooGem@03ooCdm?oemOGomOGe00;om?Cd1_oemOD00oodm?ComOGeooGem@02
ooGem@03ooCdm?oemOGomOGe00;om?Cd1_oemOD00oodm?ComOGeooGem@02
ooGem@03ooCdm?oemOGomOGe00;om?Cd1_oemOD00oodm?ComOGeooGem@02
ooGem@03ooCdm?oemOGomOGe00;om?Cd1_oemOD03_odm?Coclo?om;Bd_oE
eMGoemOGomWIfOoLg=cogMgMomoOgooPh>3oh^;Ron?ShooTi>CoiNGU0_oV
i^H00ooUiNGoi^KVonKViP3oonKViPSoi^KV00001_oLg=cof][JooWinOoh
n?SonOWiooShn0;onOWi00Con?ShooWinOohn?SonOWi0_ohn?P02?oinOWo
n?ShooShn?ohn?SonOWiooShn?oinOWon?Sh0_oinOT01?ohn?SonOWiooSh
n?oinOT2ooShn008ooWinOohn?Son?ShooShn?oinOWon?ShooWinOohn?P2
ooWin@04ooShn?oinOWon?ShooWin@;on?Sh00SonOWiooShn?ohn?Son?Sh
ooWinOohn?SonOWiooShn0;onOWi00Con?ShooWinOohn?SonOWi0_ohn?P0
2?oinOWon?ShooShn?ohn?SonOWiooShn?oinOWon?Sh0_oinOT01?ohn?So
nOWiooShn?oinOT2ooShn008ooWinOohn?Son?ShooShn?oinOWon?ShooWi
nOohn?P2ooWin@04ooShn?oinOWon?ShooWin@;on?Sh00SonOWiooShn?oh
n?Son?ShooWinOohn?SonOWiooShn0;onOWi00Con?ShooWinOohn?SonOWi
0_ohn?P04?oinOWon?ShooShn?ohn?SonOWiooShn?oinOWon?ShooWinOoK
fm_og=cLon3Ph?oQhN7ohn?SonGUiOoWinL2onWYj@;ojn_[0_o]kNd4onk^
kP03ong]kOo^k^kok^k^0?ook^k^1_o^k^h00003ono_koo^k^kooooo07Co
oooo00SokNg]ono_kooalO7om?CdooGemOogmoOon?Shoo[jnP;ono_k00?o
o_knoogmoOono_h0ooooool=ooooo`0000Oolo?cof][JooWinOoinOWonSX
j?oWinOoj>SX00SoinOW00?oj>SXonOWiooWinL00_oWinL00ooXj>SoinOW
onSXj008onOWi`03onSXj?oWinOoinOW00;oinOW00?oj>SXonOWiooXj>P0
2?oWinL00ooXj>SoinOWonOWi`02onOWi`03onSXj?oWinOoj>SX00SoinOW
00?oj>SXonOWiooWinL00_oWinL00ooXj>SoinOWonSXj008onOWi`03onSX
j?oWinOoinOW00;oinOW00?oj>SXonOWiooXj>P02?oWinL00ooXj>SoinOW
onOWi`02onOWi`03onSXj?oWinOoj>SX00SoinOW00?oj>SXonOWiooWinL0
0_oWinL01_oXj>SoinOWonSXj?m[Jf_oK6a/ofe]K@;oKVi^0_m_Kfl00om`
L73oLG5aog5aL@02og5aL@GoLW9b00?oLG5aog9bL_mbLW80oombLW86og9b
LP0000KomOGeooCdm?oQhN7oh>3Pon7QhOoPh>04on7Qh@05on3Ph?oQhN7o
hN7Qon7QhOoPh>001?oQhN400ooPh>3ohN7Qon3Ph004on7Qh@05on3Ph?oQ
hN7ohN7Qon7QhOoPh>001?oQhN400ooPh>3ohN7Qon3Ph004on7Qh@05on3P
h?oQhN7ohN7Qon7QhOoPh>001?oQhN400ooPh>3ohN7Qon3Ph004on7Qh@05
on3Ph?oQhN7ohN7Qon7QhOoPh>001?oQhN400ooPh>3ohN7Qon3Ph004on7Q
h@05on3Ph?oQhN7ohN7Qon7QhOoPh>001?oQhN400ooPh>3ohN7Qon3Ph004
on7Qh@05on3Ph?oQhN7ohN7Qon7QhOoPh>001?oQhN400ooPh>3ohN7Qon3P
h004on7Qh@05on3Ph?oQhN7ohN7Qon7QhOoPh>001?oQhN401?oPh>3ohN7Q
on3Ph?oQhN42oibLW004oifMWOnNWYkoWinOoinOW`;oX:2P00CoXJ6Qoj:R
X_nRXZ;oXZ:R1?nSXj<00onRXZ;oXj>Soj>SX`3ooj>SX`KoXj>S0OmbLW80
0003ooOgmoofm_Ko5D2T00;o5CnS00Oo5CnRoaDnX_lD?Z7o5CjQoa@mX?lE
?Yoo5CjP00;o53fO1?lD?Ih00olE?Ioo53fNoaDmW`03oa@mWP04oaDnWolD
?Iko53fNoaDmW`Ko53fN00?o5CfOoa@mW_lE?Il00olD?Ih01?lE?Yoo53fN
oa@mW_lE?Il6oa@mWP03oaDmWolD?Iko5CfO00?o53fN00Co5CjOoa@mW_lD
?Iko5CfO1OlD?Ih00oo[jn_ok>c/onc/k003onc/k003on_[joo/k>cok>c/
00Ook>c/00?ojn_[onc/k?o/k>`00oo/k>`00oo[jn_ok>c/onc/k007onc/
k003on_[joo/k>cok>c/00?ok>c/00Cojn_[onc/k?o/k>cok>c/0_o]kNd0
0oo^k^kokNg]onk^kP02oo3`l0;ol_;b00Colo?cooCdm?oemOGom_Kf0_oh
n?P00ooinOWon_[joo[jnP02ooclo004oogmoOono_koo_knookno_oooooo
3?ooool1oj>SX`7oLW9b0002ooShn0;o95B^00Co95B]ob=C[?lSE:go8e>/
0_lSDj/02OlSDZ[o8e:[ob=BZ_lRDZ[o8e>[ob=BZ_lRDZ[o8e:Zob=BZ@02
ob=BZP03ob=BZOlSDZ[o8e:Y00;o8e:Z00Co8U6Yob=BZOlSDZ[o8U:Y0_lS
DZX00olRDJWo8e:Zob=BZ@02ob=BZP03ob=BZOlSDZ[o8e:Y00;o8e:Z00Co
8U6Yob=BZOlSDZ[o8U:Y0_lSDZX00olRDJWo8e:Zob=BZ@02ob=BZP03ob=B
ZOlSDZ[o8e:Y00;o8e:Z00Co8U6Yob=BZOlSDZ[o8U:Y0_lSDZX01?lRDJWo
fm_Kom_KfooLg=`2om_Kf`04omcLg?oKfm_ofm_KomcLg0;ofm_K00Cog=cL
om_KfooLg=cog=cL0ooKfm/01?oLg=cofm_Kom_KfooLg=`2om_Kf`05omcL
g?oKfm_ofm_KomcLg?oKfm/00_oLg=`3om_Kf`07omcLg?oKfm_ofm_KomcL
g?oKfm_og=cLomgMg@02omcLg0;ogMgM0_oNg]h00ooMgMgogmoOomoOg`02
on3Ph004on7QhOoRh^;oh^;Ron?Sh`;oi>CT00GoiNGUonKVi_oVi^Koj>SX
onOWi`02onSXj?oojNWY3OoYjNT1oj>SX`7oLW9b0002oooooa7o<fZm00?o
=VbnocA[_OlcJ[d05olcJ[d8ooooo`_o<fZm00?o<VVmogEeMOmeMGD0oome
MGE<ogEeM@7oXj>S0OmbLW8000;ooooo2_liLl401OmVT/oon?[looCgnoo0
dn_oCH7700;o>G?100?oXKcQoj>nh_liLl40:oliLl7oomCDe4koe=CD0OnS
Xj<1og9bLP000_ooool:oc=Z_@05odIh`omVSlgoJ97>om_Tloo3dn/00_lc
J[d00omPRl_og^Odoc=Z_@0Xoc=Z_@03oc=Z__lcJ[go<VVm0?oon_[jC_oj
n_X1oj>SX`7oLW9b0002ooooo`go:5bg00OoSj[Ioo[koOlYGKOo:5bgobUM
]oo]lOWoA77000Co:5bg00?o_LgXooooooooool00oooool00omWRlco]<KV
okg=j002obQL]`03okC6i_nmcNSo:5bg00;o:5bg00Koko?ioh6Oe?lXG;Oo
:5bgokC6i_nmcNP2obQL]`03ofJ;booko?goR:GG00co:5bgoooooom>oooo
o`7oXj>S0OmbLW8000;ooooo3OlcJ[d00omiWM?oooooodEg`P02oc=Z_@03
ok;6i_n;Z]Wo<fZm00?o<fZm00?o`=7ZolkKkom1M<400om1M<400olgK;ko
^<_Xol3AjP02oc=Z_@03okS;j?o0dN[o<fZm00;o<fZm00[ol?CjohNWf?lc
J[go<fZmokS;j?o0dN[o<fZmof6;c?ognOcoX;[P2olcJ[d00olbJKgo<fZm
oo[jnP16oo[jnP03ooWinOojn_[on_[j0?oon_[j1?ojn_X1oj>SX`7oLW9b
0002ooooo`go>G?100?oNj;Eoooooom;P<H00_liLl400omhX=Cob][^ocUc
`@03ocUc`@03ol;Dk?o;f^ko>G?100Co>G?100Ko^/kYol;Dk?liLl7o>G?1
ok[>jOo2e>`3ocUc`@09oo7en_n;[M[o>G?1ocUc`Onjc^Wo`]C/oe^;booa
mO[o/lWW00ko>G?1oooYjNU>onWYj@7oXj>S0OmbLW8000;ooooo3OlcJ[d0
0omgW=?oooooodIh``02oc=Z_@03ocaa`?ofn?co?W;000?o<fZm00?o`=7Z
ol[HkOlcJ[d01?lcJ[d01_nhbnSo`=7Zoc=Z_OlcJ[go^<_Xol3AjP?o<fZm
00Wol?CjohNWf?lcJ[go<fZmokS;j?oCgo7oj^ohol3Aj_leJkd03_lcJ[go
oo[jnTkon_[j0OnSXj<1og9bLP000_ooool=obQL]`03og2Bcooooooo?6^m
00?o:5bg00?o`m;[og2BcolXG;L00_lXG;L00onmcNSoamC/obQL]`04obQL
]`06okC6i_nmcNSo:5bgobQL]onda^Ko`<oZ0olXG;L02Oo`m?[oPIoDobQL
]olXG;Oo]<KVoko?jOnnc^Woa]C/obaO^00>obQL]oooooooC_ooool1oj>S
X`7oLW9b0002ooooo`go<fZm00?oMicCoooooom6N<<00olcJ[d00on9ZMSo
]<SVoc=Z_@02oc=Z_@03ol3Aj_o:f>go<fZm00Co<fZm00_o^<_Xol3Aj_lc
J[go<fZmokS;j?omoOkoNIgCoc=Z_OloL/3oo_knogNLd`02oc=Z_@05okS;
j?o0dN[o>g2oomKQlOnaa^D03_lcJ[gooo[jnTkon_[j0OnSXj<1og9bLP00
0_ooool=ocUc`@03og^ReOooooooBh3600?o>G?100?oDHC8oo3dn_ljM<40
0_liLl400oo2e>cobm[^ocUc`@04ocUc`@0;ok[>jOo2e>co>G?1ocUc`Onj
c^WocM__om3Nl?o>g>ooeN7aooOio?m2NL<00_liLl401_njc^Wo`]C/ocUc
`Om;P<Koi^ggoiVgg`go>G?1oooYjNU>onWYj@7oXj>S0OmbLW8000;ooooo
3OlcJ[d00omgW=?oooooodIh``04oc=Z_@06om_TlomSSLco<fZmoc=Z_Oo0
dN[ob]S]1OlcJ[d02_m[T/ooKiG@oc=Z_OlcJ[goJi;?ofnEd?lkL;ooOZ3E
oiBag?m;O<D3oc=Z_@07okS;j?o0dN[o<fZmoc=Z_Om@OlKoR:SHoc]`_`0<
oc=Z_Ooon_[jC_ojn_X1oj>SX`7oLW9b0002ooooo`go:5bg00?oL9;?oooo
oollJkd01?lXG;L01_nH/McoVk?MobQL]olXG;Oo_LgXolODk0Go:5bg00?o
B7C1odUe`_lXG;L02_lXG;L00onda^Ko_LgXobQL]`0@obQL]oooooooC_oo
ool1oj>SX`7oLW9b0002ooooo`go<fZm00?oMicCoooooom6N<<01?lcJ[d0
1_mPRl_og^Odoc=Z_OlcJ[go`=7Zol[Hk@Go<fZm00?o^<_Xol3Aj_lcJ[d0
2_lcJ[d00onhbnSo`=7Zoc=Z_@0@oc=Z_Ooon_[jC_ojn_X1oj>SX`7oLW9b
0002ooooo`go>77000?o?gK2odn1aoliL/001OlhLL001Om>PLOo>770ocQa
`?m7O<CoBGg500Go>77000?oAW_4odMla?lhLL002_lhLL000onO^^3oYKkR
ocQa`00@ocQa`?oojNWYC_oYjNT1oj>SX`7oLW9b0002ooooocoo<fZmoooj
n_Y>oo[jnP7oXj>S0OmbLW8000;ooooo?olXG;Ooooooodkooooo0OnSXj<1
og9bLP000_oooolooc=Z_Ooon_[jC_ojn_X1oj>SX`7oLW9b0002ooooocoo
>G?1oooYjNU>onWYj@7oXj>S0OmbLW8000;ooooo?oldK;kooo[jnTkon_[j
0OnSXj<1og9bLP000_ooooloobQL]oooooooC_ooool1oj>SX`7oLW9b003o
oooooi3ooooo0OmbLW800?ooooooTOooool00<?oOgmo1omnOWk6ogmoO`00
00Cojn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP04omgMgOoNg]kogMgMomkN
gP?ogMgM0:oog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN00;ogMgM0<7ofm_L
om[Jf_oGemOof=SHomOGeooJf][ofm_KomcLg?oKfmcogMgMomcLg?oNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgN00?og]kN00?ogMgMomkNg_oNg]h00ooMgMd1on7Qh@7oinOW0OoZj^X0
0003onc/k?oVi^Koh>3P00OofMWI00Cof=SHomKFe_oCdm?od=3@0oo=cLd0
1_o@d=3odm?ComOGeooHf=SofMWIomSHf0WofMWI00Cof=SHomOGeooCdm?o
d=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@;oemOG00?odm?Com3@
d?o=cLd00_o=cLd01?o@d=3odm?ComOGeooHf=QVomWIf@Cof=SH5ooIfMT0
1?oHf=SoeMGEom;Bd_o>c/h2olg=c@07olo?cooBd];odm?Com?CdooDe=Co
emOGomSHf02eomWIf@03omSHf?oIfMWofMWI00KofMWI0OoNg]h1onKViP7o
k>c/00001oo^k^kojNWYonCTi?oPh>3ohN7Qon3Ph?oRh^800_oQhN403OoN
g]kog=cLom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_K
fooOgml02OoQhN403OoOgmoofm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:b
ok^k^oo7alOodm?Com_KfooOgml02OoQhN403OoOgmoofm_Kom?Cdoo7alOo
^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml0HooQhN400ooP
h>3ogmoOomoOg`02omkNgP03omoOgooPh>3oh>3P00;oh>3P00CogmoOon3P
h?oPh>3oh>3P0_oOgml7on3Ph003omoOgooPh>3oh>3P00?oh>3P00kogmoO
omgMgOoIfMWoeMGEom?CdooBd];odM7Aom;Bd_oCdm?oe=CDomKFe_oJf][o
gmoOon3Ph0;ogmoO0_oNg]h4omoOg`?oh>3P00?ogmoOon3Ph?oPh>001OoP
h>001?oOgmooh>3Pon3Ph?oPh>02omoOg`;oh>3PVooQhN400ooRh^;ohN7Q
on;RhP04on7Qh@7oi>CT0OoYjNT1ong]k@0000?ol?3`ono_kooalO400oo`
l?00Xoo_knool?3`onk^k_oYjNWofm_Kol71`OnTY:CoS8b<og]kNomgMgOo
NWYjohb<S?nTY:Co`/;1om[Jf_oZj^[okNg]oo3`l?o_knoolO7aono_kooa
lNookno_oo7alOo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<RomkNg_oMgMgog]k
Non<S8coY:BTol;2`_oJf][oj^[Xonc/k?oalO7okno_oo7alOo_knoolO7a
ono_kooalNookNg]on[Zj_oJf][o`/;2ojBTY?n<S8coNg]kogMgM_mjNW[o
S8b<ojBTY?o2`/;of][Jon[Zj_o]kNgolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_onk^k_o_knooj^[ZonWYjOoUiND00_oWinL03_o/k>[okNg]ono_
koo[jn_oj^[ZonWYjOo^k^kok>c/on_[jOoXj>Sok^k^ong]kOo^k^koj^[Z
0_o/k>`01_o]kN_ojNWYonc/k?o]kNgok^k^on[ZjP;ok>c/01;okNg[oj2P
X?mcLg?oF5QHog=cLoo2`/;ogmoOon3Ph?oQhN3ogmoOonGUiOoZj^[okNg]
onSXj?oWinOoiNGUonOWiOoVi^H2on[ZjP07on_[jooZj^[ok^k^on_[joo[
jnWojn_[ono_k`02onc/k006on[Zj_o^k^kojn_[on_[jOoZj^[ok^k^0_o[
jn/0Y?oZj^[okno_onk^k_oalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo`
l?3okno_oo3`l?o_knool?3`ono_koo`l?3okno_1?o`l?000003oo;bl_o^
k^koinOW00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mVIVKoDE5AodE5
AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@00ooUiNGo
i>CTonGUi002onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2
@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT07[oiNGUonCT
i?oUiNGoi>CTonCThooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92
odE5AOmADE7oIVIVohZ:R_na/K7odM7AomkNg_oTi>?oi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCohn?Son;Rh_oLg=cof=SHomGEe@;oe]KF01?of][IomkN
g_oPh>3ofm_KomKFe_oGemOog]kNomcLg?oGemKoeMGEomgMgOoQhN7ogmoO
omWIfOoKfm_og]kNomgMg?oHf=Sog=cL00;ogmoO0_oJf]X03ooMgMgogmoN
of5QHOm^KVkoRh^;odY:B_l92@Wo/[:bobHV9_m8B4SoTi>ComCDe?oLg=co
gMgMomKFeP02om?Cd`0<omKFeOoGemOofm_Kom_KfooIfMWofm_KomoOgooK
fm_ofMWHom_KfooQhN7og]kN0_oJf]X0Y?oNg]kog=cLomWIf?oJf][ogMgM
om[Jf_oHf=Sofm_Kon7QhOoShn?oiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CT1?oUiND01_oTi>CoiNGUonGUiOoUiNGoj>SXong]k@7ol_;b0000
0oodm?CokNg]onOWi`02on3Ph00Con7QhOoOgmoog]kNom;Bd_nd];CoQhN7
oeaLG?m]>cGoWTi2ole_GooYPfoocFmOoii>@om]>cKoG5aLohN7Qond];Co
d];BomkNgP05on3Ph00AomkNg_oBd];o];BdohN7QomLG5coKF0/oijF;_o=
cCoojNU=olg=?onNVRooKF<]oeaLG?n7QhOo];Bdom;Bd_oNg]h01OoPh>00
4OoNg]kod];BokBd]?n7QhOoG5aLodMW;_mXWS?oTLe7oj[YEOn@c4KoJYhd
odUZ;omLG5coQhN7okBd]?oBd];og]kN063oh>3P02[ogmoOomgMgOoJf][o
eMGEokZj^_o1`L7odM7Aom3@d?oFe]Kof=SHom;Bd_o<c<coclo?omGEeOoD
e=CocLg=olc<c?oDe=Cof][JomSHf?oAdM7od];BomSHf?oFe]KodM7AomCD
e?oJf][of=SHom;Bd_oAdM7of=SHomOGeooAdM7od=3@om7AdOo@d=3o:RXZ
oeiNG_nGUiOoSXj>oa@D5?nFUYH2omOGe`04om3@d?o>c/kodm?ComOGe`;o
f=SH00Woe]KFom7AdOoCdm?of=SHomGEeOoAdM7oeMGEom_KfooHf=P00_oB
d]802_oHf=Soe]KFom3@d?oAdM7od];Bom7AdOoBd];of=SHomgMgOoOgmnI
on3Ph003omoOgooPh>3ogmoO00;ogmoO0ooPh>000ooQhN7oinOWonc/k001
ooCdm00000?om_Kfoo;bl_o[jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWioo
JemOohlf;_o]LF7onIf@oofaYOom_:oooKBWooVOToo]M6?oTSL_of]OGonO
WioocLg=on7QhOoWinL00ooXj>P04ooWinOoh^;Rolg=cOnOWiooKVIOoi=b
8_o]dDConO=doogmSOomoIGooOf>ooWhM_o]edOoTg<RofiWGonOWioocLg=
on;Rh_oVi^H00ooXj>P04ooWinOoh^;Rolg=cOnOWiooH6QOod]l8onBhD_o
_OUkom3mT_oHoI_oe?fEol3iO_nHj4goCH0Tof1YGonOWioocLg=on;Rh_oW
inL0GooXj>P2onOWi`0XoijNW_l92@Wo2`/;ob0P8?l`<33oT92@om_KfooM
gMgoa<C4o`000?meMGGof][JomWIfOm0@43o8R8Rom[Jf_oPh>3ogmoOoc`l
??m/K6cogmoOomgMgOl51@GoXJ6Qon;Rh_oPh>3oG5aLoda<C?oMgMgofm_K
okFe]Om7AdOo=SHfogmoOomYJFWo?ShnomkNg_oOgmooDU9BoeQHF0;ogMgM
00?o;Rh^o`000?l000000_l000005_lf=SKog]kNobLW9on0P83ogmoOolk>
c_l0003o]KFeon;Rh_oOgmooB4Q8of5QHOoOgmoogMgMo`000?nQXJ7oe=CD
olC4a?lN7QkoE5ADonKVi_oWinLgonSXj003onOWiooXj>Soj>SX06Soj>SX
0Oo/k>`1oo;blP7om_Kf00000oogmoOon?ShooShn003ooShn00CooOgmoo^
k^koc/k>oi2@T?n5;b_ojFAFoo^BQoonYY_oo[6UoonhZoon/jKooZRLoo^D
ROo^J5WoRC4[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>
oi2@T?nIJB_ol;dmoo_PK_onm8;oo_j:ooooT_onoXcoo_R3oo_UL?o``Sko
VFX[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?m2
Lb_oQ<i3ojg_Loo2oXSoc_j@omGoU_o@oi;oa_j9ok;eM?n8dd?oA7D[oi2@
T?o>c/kok^k^ooOgm`1PooShn00AooOgmoo?cloo^;Rhong]kOo[jn_oTI6A
o`<30oo>c/kojn_[oi>CTol=3@go=CDeonGUiOoOgmoo2@T9o`h>3_o3`l<0
0_o^k^h05_m0@43oLg=cono_koo]kNgo1@D5oj^[ZooalO7okno_of=SHomA
DE7ok>c/onWYjOlS8b?o?clooj2PX?mSHf?o9RHVocTi>Oo^k^kokno_ogEe
MOl/;2`2ong]k@0Joc4a<Om_KfoolO7aooKfm_ohn?Som_Kfono_kolZ:R[o
RHV9ono_kooMgMgo0000ol71`OoalO7okno_oda<C?mWIfOokno_onc/k?l0
003oZj^[om?Cdol/;2coB4Q8oo;bl_ogmoLiooShn003ooOgmoohn?Son?Sh
063on?Sh00?omoOgooShn?ohn?P00_ohn?P01?ogmoOonOWiooOgmoogmoL1
ooShn00000?on_[jooGemOo^k^h00_o/k>`0/Oo[jn_ojNWYomoOgonj^[[o
NE9Boklb9?oWM6WooHUnoonHS?onXYKoojRLoojTV?ooVHgooXYoonifJ_o3
<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/on[Zj_oOgmoo^[ZjohQU
D_oRTAconL=@oogJHooojW;oo_=nooojP_onmWooonacookNI?ojae7ohY8L
ohUVDonj^[[og]kNon[Zj_o[jn_ok>c/on_[jooZj^[ogmoOokZj^_mBKE;o
DJ<Loi7BEOnVif[o^?Ujol3nP_o7ohWo`oj4okWmNonWk6coU=IGoe:V7?mB
KE;o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>coj^[ZonWY
jOoShn?ogmoOomWIfOo3`l?o0000oj>SXooNg]koC4a<ofIVI_lI6AWoa<C4
oj>SXolN7QkoHf=Sog5aL@02omoOg`0Uocdm?Om]KFgohn?SomoOh?l51@Go
XJ6Qon7QhOoOgmooGUiNode=COoPh>3o_;bmo`000?o4a<Coi>CTon7QhOmR
HV;o<c<con;Rh_oRh^?oL71`obPX:?oQhN7oh>3Pobl_;omYJFWoiNGUonWY
j_o/k>cojNWYon?SholX:2SoPX:2on;Rh_oAdM7o0000okJf]P02on3Ph02U
odQ8B?mRHV;oh^;Ron3Ph?l0003oWIfMocHf=_le=CGof][JonWYjOoZj^[o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>coj^[Zonc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/00Kojn_[00Gok>c/on_[
joo[jn_ok^k^ooKfmP01ooWin@0000?ono_koo?cloo]kNd00_oUiND0oooV
i^Koi>CTomWIfOnb/[;oNBh^olQ2=?oSJUcom7Y]oof8O?onUh[ooY^>oojH
RoonRWkom7]]onM[GOo:@SCoNbh^ok:b/_oHf=Sohn?SonGUiOoVi^KoiNGV
onCTi?oHf=So/[:boiIE;_oZW2_onka4ook<Doomf6;oo^=bookYMOoniW?o
o]]Uoog<Dook`DGokYh[oiUF;_nb/[;of=SHonCTi?oUiNGoi^KVonGUiOoT
i>Cof=SIok:b/_l^HRkoHjd[ohO:B?nGg5WoYNEYok;cMonhmW_o]?EiojOZ
JonHg5WoRLm;of>^:ol^Hbko/[:bomSHfOoTi>CoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^Kohn?SomoOgooGemOoe=CDolW9bOm6ATKo1`L7om?CdooFe]Ko
3@d=oj:RX_mKFe_oPh>3ofIVI_mHF5WoZ:RXobLW9ooJf][ofMWIoc`l??m[
Jf_og]kNom_Kg?l51@GoVi^KomOGeooFe]KoFe]Kod];BooNg]koQXJ7o``<
3?oEeMGofMWIomOGeomaLG7o<S8bomgMgOoMgMkoKFe]obHV9_oLg=cofm_K
obh^;_mVIVKogmoOon?Si?oVi^Kohn?SomgMgOlV9RKoOgmoomgMgOo=cLgo
0000ojn_[ooFe]KoemOGodI6A_mPH63og]kNomcLg?l0003o<C4aoa4A4Oo:
b/[of][Jon7QhOoShn?oiNGUonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUiP00P?oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGV0_oVi^H00ooUiNGoi^KVonKViP03onKViP03onGUiOo]kNgom?Cd007o
no_k00000oolo?con?Shoo7al@03onk^kP0Con_[jooQhN7o_;blogXG5oo3
?c;odeI9onAXF_o_Mfcom8=iooR7O?oeQ7[olgU]onEYFooIF4[oa3lbog`G
5onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;blojE75ooVUc;omJ``
oofl@OombE?ooM1Poo_CIOomdV3oo/eDoofm@_oj[c;ojI/bojE65onl_;co
hN7Qon_[j`03onk^kP0Conc/k?oQhN7o_;bloaMI5omOZ3;oM[dgohK=AonF
eU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg_cOoGj/boaMI5onl_;cohN7Qonc/
k01Oonk^kP0Jong]kOo[jn_oi>CTomcLg?nPX:3o6ATIoaDE5On_[jooj>SX
ojn_[ol:2P[oh^;RojFUYOm4A4Co;Bd]oiZJV_oVi^Ko51@Dol;2`_oTi>Co
?Shnog1`L?oXj>Soi^KVo`D51On6QXH2omoOg`06oeYJF_m?Cdooj^[Zoj>S
Xol0003o`l?30_oOgml01_mfMWKo=3@donOWiooVi^KoLG5aobPX:0;ohn?S
00go;bl_ofYZJ_oWinOok>c/onk^k_o/k>coinOWobPX:?n5QHGoj>SXomKF
e_l0003oVYZJ00;ogmoO00coADE5ofATI?oYjNWohn?So`000?nJVY[o92@T
oh61POoShn?oj>SXonc/k?o]kNdgonk^kP03ong]kOo^k^kok^k^06Ook^k^
00?okNg]oo;bl_ohn?P00Oolo?`000?ooOgm01Koo?cloogmoOomoOgoo?cl
oo?clooAdM7oJ0L7okPd=?o7?c?odU13omYREOoSKV;oi79TonA_H_oKHeKo
de53ola1=?ni=3CoJ`L7om;Bd_oclo?oo?cl0oomoOd04oolo?colo?com;B
d_nN:`OofXXdon^K6OoeZ2Won;@oooVmB_oh_dgon[m:ooVh?oofZR[okihI
om^;=?nR;@Ood];Boo;bl_olo?`00oomoOd04oolo?colo?com;Bd_l7@0Oo
CIXdoen[8?m`^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^BooHZhPodjK=?l7
@POod];Boo?cloolo?`0GoomoOd05_olo?con_[joo?clomkNg_o0000oe=C
DooMgMgomoOgooShn?mgMgOoBd];oo[jn_oclo?o4A4Ao`820_oXj>Sono_k
ofEUIOn3Ph?om_Kfod92@_mhN7P2ooWin@0Bo`D51OlJ6Q[oUiNGomGEeOlZ
:R[oQ8B4oo_knoobl_;o6a/Kof1PH?oTi>Cofm_KocTi>Olh>3SonOWiooKf
m_miNGWo:b/[0_oclo<06Olb<S;oLG5aooKfm_okno_ooOgmooclo?ohn?So
:b/[ohj>S_oinOWoj>SXo`000?lQ8B7oY:BTom;Bd_lI6AWoW9bLoo[jn_oc
lo?o0000okJf]_oFe]Ko5aLGojVYZOojn_X00_olo?bOoogmo@03ooclo?om
oOgoo?cl00?ooOgm0000>_omoOgon_[joo?cloo^k^kol?3`ono_koo^k^ko
jNWYom?CdomK7AgoXS@dok@X7Oo1>RgoadTlolmFB_o@Ed_od5M:olY:?_o3
>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>ook^k^on[Z
j_oCdm?oS2DMolQa=?oIQ1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/X2GoiiLE
omb87Oo8LCCoS2DMom?CdooZj^[ok^k^oo3`l?o_knool?3`onk^k_oZj^Wo
dm?Coadh7OldPSCoAiDMoeZU6omY[BX2ogBh>01XogFi>?m[/B_oFjLLodRJ
7OldPSCo7CPMom?CdooZj^Wok^k^oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>l2onk^
kP0^om7AdOl10@7oQ8B4on7QhOoRh^;oi^KUon[Zj_m5ADGoTY:Bono_koo^
k^koFUYJod10@?o_knkok^k^ok6a/Om6ATKojn_[oe5ADOmnOWkojn_[onk^
kOlN7QkoZ:RXodm?Col:2P[o@410omKFe_o^k^kokno^ol;2`_l_;boo2`/;
oc8b<_mRHV;oBDU9ong]kOoZj^WoLW9bobPX:?oVi^KoinOWoc0`<?m/K6co
jNWYono_kP;okno_01?oj^[Zochn?_n@T93okNg]on3Ph?lI6AWo/k>codA4
A?l92@WoBTY:on3Ph?o]kNgoiNGUo`000?n[Zj_ojn_[ok^k^olV9RKobLW9
00;okno_09[ol?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_0_o`l?06
ono_k`7olo?c0OoinOT1ooknoP0000?oo_knooOgmoo`l?001?oYjNT04OoW
inOofm_Kof=;Bon1<S;oYSDeokHd;Oo2CD7o`eA9olAEB_o3E4Wo`Te1okHd
;OnU=CGoPC8bof=;BooKfm_oi^KV00GojNWY017oinOWom_Kfon9Bd_o[d/b
oleg=OoFRbgoh9`^on2P<_oQX3Coh:0bomnJ;_oFRbgobWDeojm;<_n9Bd_o
fm_KonKViP05onWYj@0AonOWiooKfm_oBd];oc9P<_ljRCGoDi/]of^[;om`
[CSoKZdiog2]>?mZZRooDi/]ocV8=OlbH3;oBd];om_KfooWinL0HOoYjNT0
2OoXj>So`/;2o`410Oo:b/[ogMgMomkNg_oQhN7oiNGUonSXj008onWYj@06
onSXj?oVi^Kohn?Son?ShooVi^Koj>SX0ooYjNT00ooXj>SojNWYonWYj@04
onWYj@08onOWiooYjNWojNWYonWYjOoXj>Soi^KVog5aLOlW9bL2onCTi00;
obl_;omYJFWoiNGUonSXj?oYjNWoj>SXonGUiOoRh^;ohn?SonKVi_oXj>P0
0ooYjNT02OoXj>SojNWYonWYjOoWinOoh^;Ro`000?nYZJWoiNGUonSXj00f
onWYj@03onSXj?oYjNWojNWY06KojNWY00?oj>SXonWYjOoYjNT01?oYjNT1
oo3`l07omoOg0Oono_h00005ookno_ojn_[om?Cdono_kooalO400_o`l?00
4Oo_knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZNW?oIW9coe9FE
ok]cLonEE5CoCb<SoiFDU?oZj^[okno_00Gol?3`017okno_on[Zj_nYU9Co
PB<SokYZE?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S8onZ
U9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCoLjEcoik6
UOn/cYco[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Zj_o_knl0HOo`
l?02ono_k`07odE5AOlf=SKoPh>3oe]KFomBDU;ok^k^ono_k`08oo3`l004
ono_koo^k^koFEUIohB4Q0;okno_3_o`l?001?o_knook^k^ogEeMOlY:BT2
onk^kP09oc0`<?m^KVkok^k^ono_koo`l?3okno_onk^k_m6ATKoUiNG00;o
kno_1_o`l?001_o_knookNg]o`000?na/K7ok^k^ono_kjCol?3`00ColO7a
oo3`l?odm?Con_[j0Oono_h00004onk`l_ooooooooooooknoP;ooooo0_on
o_h0[_omoOgon?Shofi^K_mJ?coo/I2@omk9bOo`i>ColnKVoo3Ti?oNbLWo
/I2@oeXo?om]KFgon?Shooclo?ooooooo_knooooooono_koooonookno_oo
ooooo?clooShn?n=KFgoRSloolVAT?oYd<Wom>WTooK[i_odjNCojM39olVA
T?n9?cooSFe]ooShmoolo?coooooookno_ooooooo_knooooooono_koooon
ooclo?ohn?SoKFe]oclo?on@WI3obMG9onC/i?oVk^Koi>cTolWEbOn@WI3o
?cloofe]KOohn?Soo?clooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ojn_[o];Bdofe]KOn6QXKo_[jmoogmoOooooooo_knoooo
ooono_koooooookno_ooookoo_knooooo`;oo_kn027o];Bdol[:b_omoOgo
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooknoOo:b/[oZj^[oogmoOono_ko[Jf]olS8
b?omoOgoooonookno_oooooooOgmoj^[ZooBd]800_ono_h01Oooookoo_kn
ooooooono_kooooo00;oo_kn00?ooOgmo`000?nm_Kd00_ono_h0X?oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_h2ooooo`03ookno_oooooooooo00?ooooo0OomoOd00004olO>eOon
o_kon_[jooCdm0GolO7a00gokno_omKFe_m[Jf_o@cdmoi^<S?o6^[[oe/c<
olJi^OnKS8co@cdmof][JooFe]Kokno_00WolO7a00kokno_omOFe_n3Jf_o
M3dmokF<S?oE^[[ohLc<omJj^_nfS8coLSdmoh5[JooGe]Kokno_oo3`l0So
lO7a00gokno_omKFe_m[Jf_o?Cdmohb<S?nj^[[oc<g<okZj^_n<S8co?Cdm
of][JooFe]Kokno_0:7olO7a00?ok>c/oo3`l?oalO40W_oalO401?o`l?3o
lO7aoo7alOo`l?04oo7al@03ooCdm?ojn_[oo_kn007om_Kf00001On?W:Wo
oOgmooOgmoo_knoojn_[00?oj^[Z00kojNWYon[Zj_oYjNWoj>SXoi^KVomI
FEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWYon[ZjP;ojNWY2?oZj^X0
2ooYjNWoj>SXoj2KVomZFEWo@bHVobd92Om29RKoJEUIoj2KVooXj>SojNWY
00_oj^[Z0_oXj>P02OnKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SX
onWYj@3oon[ZjT_oj^[Z00Cojn_[oo3`l?ohn?SooOgm0OoZj^X00004od=E
I_o0b=3on_[jooCdm0KolO7a00Col?3`oo7alOo`l?3ol?3`0oo_knl2oo3`
l0oolO7a0_o`l?03ono_k`;ol?3`1OoalO400oo`l?3olO7aoo7al@07oo7a
l@;ol?3`0oo_knl2oo3`l>?olO7a0_o`l?1Soo7al@03oo3`l?oalO7olO7a
00;olO7a00?omOGeoo[jn_ohnOT00Onl_Kh00003obi5FOmFJ7Oo_lS@0?oo
ooooRoooool1ooKgm`7o_[jo0Onm_[l00006ocMAHol_AUSo?E=RohRHYOo3
c=?okNoaoooooon5ooooo`05oo_lo?oemOKohnCTok2a/_nh^KX00OoAdm@0
0001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{400, 300},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleJMenu",
        ButtonData:>{"SimpleJMenu.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SimpleJMenu[]\)], "Input"],

Cell[BoxData[
    \("Mathematica"\)], "Print"],

Cell[BoxData[
    \("Menu Action Performed. Mathematica"\)], "Print"],

Cell[BoxData[
    \("MacOS X"\)], "Print"],

Cell[BoxData[
    \("Menu Action Performed. MacOS X"\)], "Print"],

Cell[BoxData[
    \("Windows"\)], "Print"],

Cell[BoxData[
    \("Menu Action Performed. Windows"\)], "Print"],

Cell[BoxData[
    \("Linux"\)], "Print"],

Cell[BoxData[
    \("Menu Action Performed. Linux"\)], "Print"],

Cell[BoxData[
    \("Mathematica"\)], "Print"],

Cell[BoxData[
    \("Menu Action Performed. Mathematica"\)], "Print"],

Cell[BoxData[
    \("Windows"\)], "Print"],

Cell[BoxData[
    \("Menu Action Performed. Windows"\)], "Print"],

Cell[BoxData[
    \("Windows"\)], "Print"],

Cell[BoxData[
    \("Menu Action Performed. Windows"\)], "Print"],

Cell[BoxData[
    \("Linux"\)], "Print"],

Cell[BoxData[
    \("Menu Action Performed. Linux"\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JPopupMenu <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004D00015QP00`40o`00
0?l0003oo`0001D000000003R<2hB928B9280?m8T8PAB9280@00000000>8
`;S8h=R8`;P0ohS0^128`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^128
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<3Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<3Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;QXc<c<=fIVVFg<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2hJ<c<c003IVJIooooc<c<03?<c<`00fIVVLc<c<c<c01[
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^6S<c<`00fIVVOooolc<
c00cc<c<00=VIYW<c<c<c<`0Jlc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;QXc<c<00=VIYWoooo<c<`0<lc<c003IVJIc<c<c<c<06_<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hJ<c<c003IVJIooooc<c<03?<c<`0
0fIVVLc<c<c<c01[c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^6S<
c<`00fIVVOooolc<c00cc<c<00=VIYW<c<c<c<`0Jlc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;QXc<c<00=VIYWoooo<c<`0<lc<c003IVJIc<c<
c<c<06_<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hJ<c<c003IVJI
ooooc<c<03?<c<`00fIVVLc<c<c<c01[c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^6S<c<`00fIVVOooolc<c00:c<c<0P0000C<c<`300000/c<
c0800003c<c<100001G<c<`00fIVVLc<c<c<c01[c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^6S<c<`00fIVVOooolc<c00:c<c<0P0000C<c<`3
000000C<c<`0000000000002c<c<0P0000;<c<`200005<c<c003IVJIc<c<
c<c<06_<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hJ<c<c003IVJI
ooooc<c<00[<c<`200001<c<c0<000001<c<c0000000000000;<c<`20000
0/c<c080000Dc<c<00=VIYW<c<c<c<`0Jlc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;QXc<c<00=VIYWoooo<c<`02/c<c0800003c<c<0P000005
c<c<0000c<c<0000c<c<008000000lc<c00000000002c<c<0P0001C<c<`0
0fIVVLc<c<c<c01[c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^6S<
c<`00fIVVOooolc<c00:c<c<0P0000?<c<`2000000G<c<`000000000003<
c<`00P000003c<c<0000000000;<c<`200005<c<c003IVJIc<c<c<c<06_<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hJ<c<c003IVJIooooc<c<
00[<c<`200000lc<c08000001Lc<c000000000000<c<c00200000/c<c003
0000c<c<c<c<0080000Dc<c<00=VIYW<c<c<c<`0Jlc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;QXc<c<00=VIYWoooo<c<`02/c<c0800003c<c<
0P0000;<c<`00`000<c<c<c<c00200000/c<c0@0000Ec<c<00=VIYW<c<c<
c<`0Jlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QXc<c<00=VIYWo
ooo<c<`02/c<c080000Wc<c<00=VIYW<c<c<c<`0Jlc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;QXc<c<00=VIYWoooo<c<`02<c<c0H0000Uc<c<
00=VIYW<c<c<c<`0Jlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QX
c<c<00=VIYWoooo<c<`0<lc<c003IVJIc<c<c<c<06_<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hJ<c<c003IVJIooooc<c<03?<c<`00fIVVLc<
c<c<c01[c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^6S<c<`00fIV
VOooolc<c00cc<c<00=VIYW<c<c<c<`0Jlc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;QXc<c<00=VIYWoooo<c<`0<lc<c003IVJIc<c<c<c<06_<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hJ<c<c003IVJIooooc<c<
03?<c<`00fIVVLc<c<c<c01[c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^6S<c<`00fIVVOooolc<c00cc<c<00=VIYW<c<c<c<`0Jlc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;QXc<c<00=VIYWoooo<c<`0<lc<c003
IVJIc<c<c<c<06_<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hJ<c<
c003IVJIoooooooo03?oool00fIVVLc<c<c<c01[c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^6S<c<`gIVJIKLc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;QXc<c<00=VIYWoooo<c<`0<lc<c003IVJIc<c<c<c<06_<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hJ<c<c003IVJIoooooooo
03?oool00fIVVLc<c<c<c01[c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^6S<c<`00fIVVIVIc9VIc00cVIW<00=VIYW<c<c<c<`0Jlc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;QXc<c<00=VIYVIVLbIVL`0<iVIc003
IVJIc<c<c<c<06_<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hJ<c<
c003IVJIVIW<VIW<03>IVL`00fIVVLc<c<c<c01[c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^6S<c<`00fIVVIVIc9VIc00cVIW<00=VIYW<c<c<
c<`0Jlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QXc<c<00=VIYVI
VLbIVL`0<iVIc003IVJIc<c<c<c<06_<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hJ<c<c003IVJIVIW<VIW<00ZIVL`400000iVIc0800002VIW<
0P0000:IVL`400005YVIc003IVJIc<c<c<c<06_<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hJ<c<c003IVJIVIW<VIW<00VIVL`200000YVIc080
0002VIW<0P0000:IVL`2000000>IVL`0000000000YVIc080000EVIW<00=V
IYW<c<c<c<`0Jlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QXc<c<
00=VIYVIVLbIVL`029VIc0800004VIW<0P000003VIW<0000000000:IVL`2
000000>IVL`0000000006IVIc003IVJIc<c<c<c<06_<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hJ<c<c003IVJIVIW<VIW<00RIVL`2000019VI
c08000000iVIc00000000002VIW<0P000003VIW<0000000000@0000EVIW<
00=VIYW<c<c<c<`0Jlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QX
c<c<00=VIYVIVLbIVL`029VIc0800004VIW<0P000003VIW<0000000000:I
VL`2000000>IVL`0000000000YVIc080000EVIW<00=VIYW<c<c<c<`0Jlc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QXc<c<00=VIYVIVLbIVL`0
29VIc0800004VIW<0P000005VIW<000000000000VIW<008000000iVIc000
00000002VIW<0P0001FIVL`00fIVVLc<c<c<c01[c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^6S<c<`00fIVVIVIc9VIc008VIW<0P0000BIVL`2
000000BIVL`00000002IVL`200000iVIc0@0000FVIW<00=VIYW<c<c<c<`0
Jlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QXc<c<00=VIYVIVLbI
VL`02IVIc0800002VIW<0P0002BIVL`00fIVVLc<c<c<c01[c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^6S<c<`00fIVVIVIc9VIc00:VIW<1000
02FIVL`00fIVVLc<c<c<c01[c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^6S<c<`00fIVVIVIc9VIc00cVIW<00=VIYW<c<c<c<`0Jlc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;QXc<c<00=VIYVIVLbIVL`0<iVIc003
IVJIc<c<c<c<06_<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hJ<c<
c003IVJIVIW<VIW<03>IVL`00fIVVLc<c<c<c01[c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^6S<c<`00fIVVIVIc9VIc00cVIW<00=VIYW<c<c<
c<`0Jlc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QXc<c<00=VIYVI
VLbIVL`0<iVIc003IVJIc<c<c<c<06_<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hJ<c<c3MVIYU]c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^6S<c<`00fIVVOooolc<c00cc<c<00=VIYW<c<c<c<`0Jlc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;QXc<c<00=VIYWoooooool0<oooo`03
IVJIc<c<c<c<06_<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hJ<c<
c3MVIYU]c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`=c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`=c<c<0XS0^058T8P1000000000hS0^<SPf8S0^03o
R<2h48S0^058T8P10000000018S0^<SPf8S0^8S0^1@00800;P01P002P003
P@04P@05P@06PP07PP48PP49P`4:P`4;P`4;Q04<Q04=Q04>Q@8?Q@8@Q@8A
QP8BQP8CQP8DQ`8EQ`8FQ`<FR0<GR0<HR0<IR@<JR@<KR@<LRP<MRP@NRP@O
R`@PR`@QR`@QS0@RS0@SS0@TS@DUS@DVS@DWSPDXSPDYSPDZS`D[S`85;8l0
;`H]T0H^T0H_T0H`T@HaT@HbT@HcTPHdTPLeTPLfT`LgT`LhT`LhU0LiU0Lj
U0LkU@PlU@PmU@PnUPPoUPQ0UPQ1U`Q2U`Q3U`U3V0U4V0U5V0U6V@U7V@U8
V@U9VPU:VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW@]BW@]CW@]DWP]EWP]F
WP]GW`]HW`022eVO02l<FZ0<Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ8=Hj<=
I:<=IJ<=IJ@=IZ@=Ij@=J:D>JJD>JZD>JjH>K:H>KJH>KZL>KjL>L:L?L:P?
LJP?LZP?LjT?M:T?MJT?MZX?MjX@N:X@NJ/@NZ/@Nj/@Nj`@O:`@OJ`@OZdA
OjdAP:dAPJhAPZhAPjhAQ:lAQJl00Q66[`0`4XN`4XR`4XV`4XZa4X^a4Xba
4Xfb4Xjb4hnb4i2c4i6c4i:c4i:d4i>d4iBd4iFe59Je59Ne59Rf59Vf59Zf
59^g59bg59fg5Ifh5Ijh5Inh5J2i5J6i5J:i5J>j5JBj5ZFj5ZJk5ZNk5ZRk
5ZRl5ZVl5ZZl5Z^m5jbm5jfm5jjn5jnn5k2n5k6o5k:o5k>o=QRd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P4002000>KYo4c@jDc@jD02C=3Y@@0
0800;P01P002P003P@04P@05P@06PP07PP48PP49P`4:P`4;P`4;Q04<Q04=
Q04>Q@8?Q@8@Q@8AQP8BQP8CQP8DQ`8EQ`8FQ`<FR0<GR0<HR0<IR@<JR@<K
R@<LRP<MRP@NRP@OR`@PR`@QR`@QS0@RS0@SS0@TS@DUS@DVS@DWSPDXSPDY
SPDZS`D[S`85;8l0;`H]T0H^T0H_T0H`T@HaT@HbT@HcTPHdTPLeTPLfT`Lg
T`LhT`LhU0LiU0LjU0LkU@PlU@PmU@PnUPPoUPQ0UPQ1U`Q2U`Q3U`U3V0U4
V0U5V0U6V@U7V@U8V@U9VPU:VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW@]B
W@]CW@]DWP]EWP]FWP]GW`]HW`022eVO02l<FZ0<Fj0<G:0<GJ4<GZ4<Gj4<
H:8<HJ8=HZ8=Hj<=I:<=IJ<=IJ@=IZ@=Ij@=J:D>JJD>JZD>JjH>K:H>KJH>
KZL>KjL>L:L?L:P?LJP?LZP?LjT?M:T?MJT?MZX?MjX@N:X@NJ/@NZ/@Nj/@
Nj`@O:`@OJ`@OZdAOjdAP:dAPJhAPZhAPjhAQ:lAQJl00Q66[`0`4XN`4XR`
4XV`4XZa4X^a4Xba4Xfb4Xjb4hnb4i2c4i6c4i:c4i:d4i>d4iBd4iFe59Je
59Ne59Rf59Vf59Zf59^g59bg59fg5Ifh5Ijh5Inh5J2i5J6i5J:i5J>j5JBj
5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^m5jbm5jfm5jjn5jnn5k2n5k6o5k:o
5k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000NKYo7o
oon>N[JVVlBcZM:XWLRcZM800ZJKa005_;SMk^kdj^Waoooo<d>U00<00800
;P01P002P003P@04P@05P@06PP07PP48PP49P`4:P`4;P`4;Q04<Q04=Q04>
Q@8?Q@8@Q@8AQP8BQP8CQP8DQ`8EQ`8FQ`<FR0<GR0<HR0<IR@<JR@<KR@<L
RP<MRP@NRP@OR`@PR`@QR`@QS0@RS0@SS0@TS@DUS@DVS@DWSPDXSPDYSPDZ
S`D[S`85;8l0;`H]T0H^T0H_T0H`T@HaT@HbT@HcTPHdTPLeTPLfT`LgT`Lh
T`LhU0LiU0LjU0LkU@PlU@PmU@PnUPPoUPQ0UPQ1U`Q2U`Q3U`U3V0U4V0U5
V0U6V@U7V@U8V@U9VPU:VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW@]BW@]C
W@]DWP]EWP]FWP]GW`]HW`022eVO02l<FZ0<Fj0<G:0<GJ4<GZ4<Gj4<H:8<
HJ8=HZ8=Hj<=I:<=IJ<=IJ@=IZ@=Ij@=J:D>JJD>JZD>JjH>K:H>KJH>KZL>
KjL>L:L?L:P?LJP?LZP?LjT?M:T?MJT?MZX?MjX@N:X@NJ/@NZ/@Nj/@Nj`@
O:`@OJ`@OZdAOjdAP:dAPJhAPZhAPjhAQ:lAQJl00Q66[`0`4XN`4XR`4XV`
4XZa4X^a4Xba4Xfb4Xjb4hnb4i2c4i6c4i:c4i:d4i>d4iBd4iFe59Je59Ne
59Rf59Vf59Zf59^g59bg59fg5Ifh5Ijh5Inh5J2i5J6i5J:i5J>j5JBj5ZFj
5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^m5jbm5jfm5jjn5jnn5k2n5k6o5k:o5k>o
0QRd`20000026;C04000008H]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0P00P004VjOaooooK5ZU[jG:0[bhg@0:oogo/jWBoooooooo_;SMUhZl
Z9g8i^K/oooo<d>U0P00P00^006000:000>100B100F100J200N20@R20@V3
0@Z30@^30@^40@b40@f40@j50Pn50Q250Q660Q:60Q>60QB70QF70QJ70aJ8
0aN80aR80aV90aZ90a^90ab:0af:11j:11n;122;126;126<12:<12><12B=
1BF=1BJ=1BN>1BR>1BV>1BZ?1B^?0PD/S`0_1Rf@1Rj@1Rn@1S2A1S6A1S:A
1S>B1SBB1cFB1cJC1cNC1cRC1cRD1cVD1cZD1c^E23bE23fE23jF23nF242F
246G24:G24>G2D>H2DBH2DFH2DJI2DNI2DRI2DVJ2DZJ2T^J2TbK2TfK2TjK
2TjL2TnL2U2L2U6M2e:M2e>M2eBN2eFN2eJN2eNO2eRO008;FIl0;`aJX0aK
X0aLX0aMX@aNX@aOX@aPXPaQXPeRXPeSX`eTX`eUX`eUY0eVY0eWY0eXY@iY
Y@iZY@i[YPi/YPi]YPi^Y`i_Y`i`Y`m`Z0maZ0mbZ0mcZ@mdZ@meZ@mfZPmg
ZQ1hZQ1iZa1jZa1kZa1k[11l[11m[11n[A5o[A60[A61[Q62[Q63[Q64[a65
[`024HJ_030BQk0BR;0BRK0BR[4BRk4BS;4BSK8BS[8CSk8CT;<CTK<CT[<C
T[@CTk@CU;@CUKDDU[DDUkDDV;HDVKHDV[HDVkLDW;LDWKLEWKPEW[PEWkPE
X;TEXKTEX[TEXkXEY;XFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZkdG[;dG[KdG
[[hG[khG/;hG/KlG/[lG/kl26;C000?8h=Q8T8Q8T8P034R@R0030000b>3H
B92800e8T8P0100001Rd`1Rd`<SPf0i8T8P00`0001Rd`1Rd`002R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P00;VjOaooooZ9g8oooo/jWBH4bJ
SWZfN6F^Z9g8oooooogo00?oool0<S=3Y@00P000P000P001P002P003P@04
P@05P@06PP07PP48PP49P`4:P`4;P`4;Q04<Q04=Q04>Q@8?Q@8@Q@8AQP8B
QP8CQP8DQ`8EQ`8FQ`<FR0<GR0<HR0<IR@<JR@<KR@<LRP<MRP@NRP@OR`@P
R`@QR`@QS0@RS0@SS0@TS@DUS@DVS@DWSPDXSPDYSPDZS`D[S`85;8l0;`H]
T0H^T0H_T0H`T@HaT@HbT@HcTPHdTPLeTPLfT`LgT`LhT`LhU0LiU0LjU0Lk
U@PlU@PmU@PnUPPoUPQ0UPQ1U`Q2U`Q3U`U3V0U4V0U5V0U6V@U7V@U8V@U9
VPU:VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW@]BW@]CW@]DWP]EWP]FWP]G
W`]HW`022eVO02l<FZ0<Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ8=Hj<=I:<=
IJ<=IJ@=IZ@=Ij@=J:D>JJD>JZD>JjH>K:H>KJH>KZL>KjL>L:L?L:P?LJP?
LZP?LjT?M:T?MJT?MZX?MjX@N:X@NJ/@NZ/@Nj/@Nj`@O:`@OJ`@OZdAOjdA
P:dAPJhAPZhAPjhAQ:lAQJl00Q66[`0`4XN`4XR`4XV`4XZa4X^a4Xba4Xfb
4Xjb4hnb4i2c4i6c4i:c4i:d4i>d4iBd4iFe59Je59Ne59Rf59Vf59Zf59^g
59bg59fg5Ifh5Ijh5Inh5J2i5J6i5J:i5J>j5JBj5ZFj5ZJk5ZNk5ZRk5ZRl
5ZVl5ZZl5Z^m5jbm5jfm5jjn5jnn5k2n5k6o5k:o5k>o0QRd`003b>3HR<2h
R<2h00^8`;P00dR@R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P03HS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08003Y^WlOooooooom_Lk61<VY>5^[>Yd[bhgF1<VYV?_ZJKa<S3gooooc=3
Y@@008002P01P?ooo`03P@04P@05P@06PP07P_ooo`49P`4:P`Coool03@4>
Q@8?Q@8@QOooo`8BQ_ooo`8DQ`8EQ`8FQoooo`<GR0<HR0<IR@03oooo00h3
7HX47XX47h_oool48H/48H`48X`48h`498goool59Xd59hh5:8h5:Hh4oooo
00/6;I06;Y3oool6<946<I7oool6<i86=9;oool7=Y<7=i<00oooo`0Q1cZD
1c^E23bE23fE23jF23nF242F246G24:G24>G2D>H2DBH2DFH2DJI2DNI2DRI
2DVJ2DZJ2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6M2e:M2e>M2eBN2eFN2eJN
2eNO2eRO008;FIl0;`aJX0aKX0aLX0aMX@aNX@aOX@aPXPaQXPeRXPeSX`eT
X`eUX`eUY0eVY0eWY0eXY@iYY@iZY@i[YPi/YPi]YPi^Y`i_Y`i`Y`m`Z0ma
Z0mbZ0mcZ@mdZ@meZ@mfZPmgZQ1hZQ1iZa1jZa1kZa1k[11l[11m[11n[A5o
[A60[A61[Q62[Q63[Q64[a65[`024HJ_030BQk0BR;0BRK0BR[4BRk4BS;4B
SK8BS[8CSk8CT;<CTK<CT[<CT[@CTk@CU;@CUKDDU[DDUkDDV;HDVKHDV[HD
VkLDW;LDWKLEWKPEW[PEWkPEX;TEXKTEX[TEXkXEY;XFYKXFY[/FYk/FZ;/F
Z;`FZK`FZ[`FZkdG[;dG[KdG[[hG[khG/;hG/KlG/[lG/kl26;C000C8h=R8
`;R8`;R8`;P6000018S0^003B9280000b>3H00:8`;P900000XS0^005B928
00006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P3002000jKYo7ooonl^=fISkkooooFdMgKg>cco_nV
VlC^k_B5M[2CQK[ooolc@jD3002005l00H3oool00h40187oool01X801h;o
ool12H?oool12h<12h@138Coool13XD23hGoool24HH24XKoool258L25HL2
5XOoool35hP368Soool36XT36hT378[oool47XX47h_oool48H/48H`48X`4
8h`498goool59Xd59hh5:8koool5:Xl5:hl5;8ooool6;I06;Y3oool6<946
<I7oool6<i86=9;oool7=Y?oool7>9<7>9@7>ICoool7>iD8?9D8?ID8?YH8
?iH8@9H8@IL8@YL8@iL9@iP9A9P9AIP9AYT9AiT9B9T9BIX9BYX:BiX:C9/:
CI/:CY/:CY`:Ci`:D9`:DId;DYd;Did;E9h;EIh;EYh;Eil;F9l00P]IW`0_
35ZP35^P35bP35fQ35jQ35nQ362R366R3F:R3F>S3FBS3FFS3FFT3FJT3FNT
3FRU3VVU3VZU3V^V3VbV3VfV3VjW3VnW3W2W3g2X3g6X3g:X3g>Y3gBY3gFY
3gJZ3gNZ47RZ47V[47Z[47^[47^/47b/47f/47j]4Gn]4H2]4H6^4H:^4H>^
4HB_4HF_008AQZl0<1:7/1:8/1:9/1::/A:;/A:</A:=/Q:>/Q>?/Q>@/a>A
/a>B/a>B]1>C]1>D]1>E]ABF]ABG]ABH]QBI]QBJ]QBK]aBL]aBM]aFM^1FN
^1FO^1FP^AFQ^AFR^AFS^QFT^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_AN/
_AN]_AN^_QN__QN`_QNa_aNb_aNc_`8H]<001<SPf8S0^8S0^8S0^0H00004
R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0
^4R@R00000026;C000C8h=R8`;R8`;R8`;P2000018S0^0800002R<2h00A8
T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00?
VjOaooooVHnnUhZle=?XkjbcogIkkYn[FeRUYY_4UYoBH4bJ_;SMoooo<d>U
00800800G`01P?ooo`03P@04POooo`06PP07P_ooo`49Poooo`4;P`4;Q04<
Q?ooo`4>Q@8?QOooo`8AQP8BQ_ooo`8DQ`8EQ`8FQoooo`<GR0<HR?ooo`<J
R@<KR@<LR_ooo`@NRP@ORoooo`@QR`@QS0@RS0@SS0@TSOooo`DVS@DWSPDX
S_ooo`DZS`D[S`D/Soooo`H]T0H^T?ooo`H`T@HaTOooo`HcTPHdT_ooo`Lf
Toooo`LhT`LhU0LiU0LjU0LkU@PlU@PmU@PnUPPoUPQ0UPQ1U`Q2U`Q3U`U3
V0U4V0U5V0U6V@U7V@U8V@U9VPU:VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YA
W@]BW@]CW@]DWP]EWP]FWP]GW`]HW`022eVO02l<FZ0<Fj0<G:0<GJ4<GZ4<
Gj4<H:8<HJ8=HZ8=Hj<=I:<=IJ<=IJ@=IZ@=Ij@=J:D>JJD>JZD>JjH>K:H>
KJH>KZL>KjL>L:L?L:P?LJP?LZP?LjT?M:T?MJT?MZX?MjX@N:X@NJ/@NZ/@
Nj/@Nj`@O:`@OJ`@OZdAOjdAP:dAPJhAPZhAPjhAQ:lAQJl00Q66[`0`4XN`
4XR`4XV`4XZa4X^a4Xba4Xfb4Xjb4hnb4i2c4i6c4i:c4i:d4i>d4iBd4iFe
59Je59Ne59Rf59Vf59Zf59^g59bg59fg5Ifh5Ijh5Inh5J2i5J6i5J:i5J>j
5JBj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^m5jbm5jfm5jjn5jnn5k2n5k6o
5k:o5k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<0
0028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0
^002R<2h0P0000:8`;P200000hS0^004B92800006;C06;C00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^08008002Y^WlOoooiN:_7Y/Z[?7j:U^X<S3
gi>5^U]6TiV?_P9hIJh0148WQJnUb_oooc=3Y@8008002P01P?ooo`03POoo
o`05POooo`07P_ooo`49P`4:P`Coool07P4>Q@8?QOooo`8AQP8BQ_ooo`8D
Q`8EQ`8FQoooo`<GR0<HR0<IR@<JR@<KR@<LR_ooo`@NRP@ORoooo`@QR`@Q
S0@RS0@SS0@TSOooo`DVS@DWSPDXSPDYSPCoool02PH]T0H^T?ooo`H`T@Ha
TOooo`HcTPHdT_ooo`LfT`Goool080LkU@PlU@PmU@PnUPPoUPQ0UPQ1U`Q2
U`Q3U`U3V0U4V0U5V0U6V@U7V@U8V@U9VPU:VPY;VPY<V`Y=V`Y>V`Y>W0Y?
W0Y@W0YAW@]BW@]CW@]DWP]EWP]FWP]GW`]HW`8;FIl0;`aJX0aKX0aLX0aM
X@aNX@aOX@aPXPaQXPeRXPeSX`eTX`eUX`eUY0eVY0eWY0eXY@iYY@iZY@i[
YPi/YPi]YPi^Y`i_Y`i`Y`m`Z0maZ0mbZ0mcZ@mdZ@meZ@mfZPmgZQ1hZQ1i
Za1jZa1kZa1k[11l[11m[11n[A5o[A60[A61[Q62[Q63[Q64[a65[`024HJ_
030BQk0BR;0BRK0BR[4BRk4BS;4BSK8BS[8CSk8CT;<CTK<CT[<CT[@CTk@C
U;@CUKDDU[DDUkDDV;HDVKHDV[HDVkLDW;LDWKLEWKPEW[PEWkPEX;TEXKTE
X[TEXkXEY;XFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZkdG[;dG[KdG[[hG[khG
/;hG/KlG/[lG/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8
`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3H
R<2hR<2h00>8`;P4000018S0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^08008000i^WlOooooooo`02oooo00[o[K3oMW_i
cMCmkNkooonVVlB5M[2l^=gooolc@jD3002001<00H3oool00h7oool01H7o
ool01h;oool12H<12X<12h<12h@138Coool13XD23hGoool24HH24XH00_oo
o`0<0QF70QJ7oooo0aN80aR80aV90aZ90a^90ab:oooo11j:11n;1?ooo`0=
12><12B=oooooooo1BN>1BR>1BV>1BZ?1B^?1Bb?oooo1Rf@1Rj@00;oool0
:`HaTOooooooo`HdT_ooo`LfToooo`LhT`LhU0LiU?ooo`LkU@PlU@PmU@Pn
UPPoUPQ0UPQ1U`Q2U`Q3U`U3V0U4V0U5V0U6V@U7V@U8V@U9VPU:VPY;VPY<
V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW@]BW@]CW@]DWP]EWP]FWP]GW`]HW`022eVO
02l<FZ0<Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ8=Hj<=I:<=IJ<=IJ@=IZ@=
Ij@=J:D>JJD>JZD>JjH>K:H>KJH>KZL>KjL>L:L?L:P?LJP?LZP?LjT?M:T?
MJT?MZX?MjX@N:X@NJ/@NZ/@Nj/@Nj`@O:`@OJ`@OZdAOjdAP:dAPJhAPZhA
PjhAQ:lAQJl00Q66[`0`4XN`4XR`4XV`4XZa4X^a4Xba4Xfb4Xjb4hnb4i2c
4i6c4i:c4i:d4i>d4iBd4iFe59Je59Ne59Rf59Vf59Zf59^g59bg59fg5Ifh
5Ijh5Inh5J2i5J6i5J:i5J>j5JBj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^m
5jbm5jfm5jjn5jnn5k2n5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h00^8`;P0
0dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB928
0000008H]<000lSPf8S0^8S0^004R<2h0P0000F8`;P014R@R00001Rd`1Rd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000ZQ[?;icMCR9Scd
]KoR9ScdKGglhnWoooomkNko[K02oooo00<c@jD0080008000P00P00:0060
oooo00>1oooo00F1oooo00N2oooo0@V30@Z30oooo`030@f40@j5oooo00;o
ool00`8BQ_ooo`8DQ`02oooo01D35XP35hP368P36HT36XT36hT378[oool4
7XX47h_oool48H/48H`48X`48h`498goool59Xgoool5:8h5:Hh00oooo`05
1Bb?1Rf@1Rj@oooo1S2A00;oool01@HcT_ooo`LeTPLfT`LgT`03oooo0247
>Y@7>iD8?9D8?ID8?YH8?iH8@9H8@IL8@YL8@iL9@iP9A9P9AIP9AYT9AiT9
B9T9BIX9BYX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DId;DYd;Did;E9h;EIh;
EYh;Eil;F9l00P]IW`0_35ZP35^P35bP35fQ35jQ35nQ362R366R3F:R3F>S
3FBS3FFS3FFT3FJT3FNT3FRU3VVU3VZU3V^V3VbV3VfV3VjW3VnW3W2W3g2X
3g6X3g:X3g>Y3gBY3gFY3gJZ3gNZ47RZ47V[47Z[47^[47^/47b/47f/47j]
4Gn]4H2]4H6^4H:^4H>^4HB_4HF_008AQZl0<1:7/1:8/1:9/1::/A:;/A:<
/A:=/Q:>/Q>?/Q>@/a>A/a>B/a>B]1>C]1>D]1>E]ABF]ABG]ABH]QBI]QBJ
]QBK]aBL]aBM]aFM^1FN^1FO^1FP^AFQ^AFR^AFS^QFT^QJU^QJV^aJW^aJX
^aJX_1JY_1JZ_1J[_AN/_AN]_AN^_QN__QN`_QNa_aNb_aNc_`8H]<000lSP
f8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P0
1@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00hS0^0@00004R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00
P00=VjOaoNg^hRHlo_GhmhVGm69^lj2^m69^oogoojf`o>?Yoooo<d>U00D0
08001P01P?ooooooo`04P@05P@06PP;oool09P49P`4:P`4;P`4;Q04<Q04=
Q04>Q@8?QOooo`8AQP8BQ_ooo`8DQ`8EQ`8FQ`<FR0<GR0<HR0<IR@<JR@<K
R@<LR_ooo`@NRP@ORoooo`@QR`@QS0@RS0@SS0@TS@DUS@DVS@DWSPDXSPDY
SPDZS`D[S`85;8l0;`H]T0H^T0H_T0H`T@HaT@HbT@HcTPHdTPLeTPLfT`Lg
T`LhT`LhU0LiU0LjU0LkU@PlU@PmU@PnUPPoUPQ0UPQ1U`Q2U`Q3U`U3V0U4
V0U5V0U6V@U7V@U8V@U9VPU:VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW@]B
W@]CW@]DWP]EWP]FWP]GW`]HW`022eVO02l<FZ0<Fj0<G:0<GJ4<GZ4<Gj4<
H:8<HJ8=HZ8=Hj<=I:<=IJ<=IJ@=IZ@=Ij@=J:D>JJD>JZD>JjH>K:H>KJH>
KZL>KjL>L:L?L:P?LJP?LZP?LjT?M:T?MJT?MZX?MjX@N:X@NJ/@NZ/@Nj/@
Nj`@O:`@OJ`@OZdAOjdAP:dAPJhAPZhAPjhAQ:lAQJl00Q66[`0`4XN`4XR`
4XV`4XZa4X^a4Xba4Xfb4Xjb4hnb4i2c4i6c4i:c4i:d4i>d4iBd4iFe59Je
59Ne59Rf59Vf59Zf59^g59bg59fg5Ifh5Ijh5Inh5J2i5J6i5J:i5J>j5JBj
5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^m5jbm5jfm5jjn5jnn5k2n5k6o5k:o
5k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028
`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^002
R<2h0P0000:8`;P200000hS0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^08008000i^WlOK8c>8V?002ojf`00OO92koY9kf
_<Go[K3^Nhcooolc@jD01P00P0060060oooooooo00B100F100J20_ooo`0V
0@V30@Z30@^30@^40@b40@f40@j50Pn5oooo0Q660Q:6oooo0QB70QF70QJ7
0aJ80aN80aR80aV90aZ90a^90ab:oooo11j:11n;oooo126;126<12:<12><
12B=1BF=1BJ=1BN>1BR>1BV>1BZ?1B^?0PD/S`0_1Rf@1Rj@1Rn@1S2A1S6A
1S:A1S>B1SBB1cFB1cJC1cNC1cRC1cRD1cVD1cZD1c^E23bE23fE23jF23nF
242F246G24:G24>G2D>H2DBH2DFH2DJI2DNI2DRI2DVJ2DZJ2T^J2TbK2TfK
2TjK2TjL2TnL2U2L2U6M2e:M2e>M2eBN2eFN2eJN2eNO2eRO008;FIl0;`aJ
X0aKX0aLX0aMX@aNX@aOX@aPXPaQXPeRXPeSX`eTX`eUX`eUY0eVY0eWY0eX
Y@iYY@iZY@i[YPi/YPi]YPi^Y`i_Y`i`Y`m`Z0maZ0mbZ0mcZ@mdZ@meZ@mf
ZPmgZQ1hZQ1iZa1jZa1kZa1k[11l[11m[11n[A5o[A60[A61[Q62[Q63[Q64
[a65[`024HJ_030BQk0BR;0BRK0BR[4BRk4BS;4BSK8BS[8CSk8CT;<CTK<C
T[<CT[@CTk@CU;@CUKDDU[DDUkDDV;HDVKHDV[HDVkLDW;LDWKLEWKPEW[PE
WkPEX;TEXKTEX[TEXkXEY;XFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZkdG[;dG
[KdG[[hG[khG/;hG/KlG/[lG/kl26;C000?8h=R8`;R8`;P02hS0^003B928
0000b>3H00:8`;P900000XS0^005B92800006;C06;C0b>3H00>8`;P20000
18S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0P00P003VjOanLgDmhVG00;oool01on]/>4F=?mfNonTW^8V
??n9Oc=3Y@06002002400H3oool00h4018401H401X801h;oool12H<12X<1
2h<12h@138@13H@13XD23hD248D24HH24XKoool258L25HL25XL35XP35hP3
68P36HT36XT36hT378[oool47XX47h/01Oooo`0812B=1BF=1BJ=1BN>1BR>
1BV>1BZ?1B^?0PD/S`0_1Rf@1Rj@1Rn@1S2A1S6A1S:A1S>B1SBB1cFB1cJC
1cNC1cRC1cRD1cVD1cZD1c^E23bE23fE23jF23nF242F246G24:G24>G2D>H
2DBH2DFH2DJI2DNI2DRI2DVJ2DZJ2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6M
2e:M2e>M2eBN2eFN2eJN2eNO2eRO008;FIl0;`aJX0aKX0aLX0aMX@aNX@aO
X@aPXPaQXPeRXPeSX`eTX`eUX`eUY0eVY0eWY0eXY@iYY@iZY@i[YPi/YPi]
YPi^Y`i_Y`i`Y`m`Z0maZ0mbZ0mcZ@mdZ@meZ@mfZPmgZQ1hZQ1iZa1jZa1k
Za1k[11l[11m[11n[A5o[A60[A61[Q62[Q63[Q64[a65[`024HJ_030BQk0B
R;0BRK0BR[4BRk4BS;4BSK8BS[8CSk8CT;<CTK<CT[<CT[@CTk@CU;@CUKDD
U[DDUkDDV;HDVKHDV[HDVkLDW;LDWKLEWKPEW[PEWkPEX;TEXKTEX[TEXkXE
Y;XFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZkdG[;dG[KdG[[hG[khG/;hG/KlG
/[lG/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P90000
0XS0^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2002000NKYo7oooocX:kdHVkoooog
RIOicM@00_ooo`03lj2^oooo<d>U00H00800;P01P002P003P@04P@05P@06
PP07PP48PP49P`4:P`4;P`4;Q04<Q04=Q04>Q@8?Q@8@Q@8AQP8BQP8CQP8D
Q`8EQ`8FQ`<FR0<GR0<HR0<IR@<JR@<KR@<LRP<MRP@NRP@OR`@PR`@QR`@Q
S0@RS0@SS0@TS@DUS@DVS@DWSPDXSPDYSPDZS`D[S`85;8l0;`H]T0H^T0H_
T0H`T@HaT@HbT@HcTPHdTPLeTPLfT`LgT`LhT`LhU0LiU0LjU0LkU@PlU@Pm
U@PnUPPoUPQ0UPQ1U`Q2U`Q3U`U3V0U4V0U5V0U6V@U7V@U8V@U9VPU:VPY;
VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW@]BW@]CW@]DWP]EWP]FWP]GW`]HW`02
2eVO02l<FZ0<Fj0<G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ8=Hj<=I:<=IJ<=IJ@=
IZ@=Ij@=J:D>JJD>JZD>JjH>K:H>KJH>KZL>KjL>L:L?L:P?LJP?LZP?LjT?
M:T?MJT?MZX?MjX@N:X@NJ/@NZ/@Nj/@Nj`@O:`@OJ`@OZdAOjdAP:dAPJhA
PZhAPjhAQ:lAQJl00Q66[`0`4XN`4XR`4XV`4XZa4X^a4Xba4Xfb4Xjb4hnb
4i2c4i6c4i:c4i:d4i>d4iBd4iFe59Je59Ne59Rf59Vf59Zf59^g59bg59fg
5Ifh5Ijh5Inh5J2i5J6i5J:i5J>j5JBj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl
5Z^m5jbm5jfm5jjn5jnn5k2n5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h00^8
`;P00dR@R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008002i^W
lOoooon9Oooooo>P[_6CXOooooomoo>P[_oko3=3Y@06002002h00H000X00
0h4018401H401X801h8128812H<12X<12h<12h@138@13H@13XD23hD248D2
4HH24XH24hH258L25HL25XL35XP35hP368P36HT36XT36hT378X37HX47XX4
7h/488/48H/48H`48X`48h`498d59Hd59Xd59hh5:8h5:Hh5:Xl5:hl21Bb?
02l6;I06;Y06;i06<946<I46<Y46<i86=987=I87=Y<7=i<7>9<7>9@7>I@7
>Y@7>iD8?9D8?ID8?YH8?iH8@9H8@IL8@YL8@iL9@iP9A9P9AIP9AYT9AiT9
B9T9BIX9BYX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DId;DYd;Did;E9h;EIh;
EYh;Eil;F9l00P]IW`0_35ZP35^P35bP35fQ35jQ35nQ362R366R3F:R3F>S
3FBS3FFS3FFT3FJT3FNT3FRU3VVU3VZU3V^V3VbV3VfV3VjW3VnW3W2W3g2X
3g6X3g:X3g>Y3gBY3gFY3gJZ3gNZ47RZ47V[47Z[47^[47^/47b/47f/47j]
4Gn]4H2]4H6^4H:^4H>^4HB_4HF_008AQZl0<1:7/1:8/1:9/1::/A:;/A:<
/A:=/Q:>/Q>?/Q>@/a>A/a>B/a>B]1>C]1>D]1>E]ABF]ABG]ABH]QBI]QBJ
]QBK]aBL]aBM]aFM^1FN^1FO^1FP^AFQ^AFR^AFS^QFT^QJU^QJV^aJW^aJX
^aJX_1JY_1JZ_1J[_AN/_AN]_AN^_QN__QN`_QNa_aNb_aNc_`8H]<0?b>3H
00<00038h=S8h=P03LSPf00300006;C06;C000o8h=P00`0001Rd`1Rd`002
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1000P0>KYo401_oooo>P[_Be
_oJlaO_IfS=3Y@L00800;P01P002P003P@04P@05P@06PP07PP48PP49P`4:
P`4;P`4;Q04<Q04=Q04>Q@8?Q@8@Q@8AQP8BQP8CQP8DQ`8EQ`8FQ`<FR0<G
R0<HR0<IR@<JR@<KR@<LRP<MRP@NRP@OR`@PR`@QR`@QS0@RS0@SS0@TS@DU
S@DVS@DWSPDXSPDYSPDZS`D[S`85;8l0;`H]T0H^T0H_T0H`T@HaT@HbT@Hc
TPHdTPLeTPLfT`LgT`LhT`LhU0LiU0LjU0LkU@PlU@PmU@PnUPPoUPQ0UPQ1
U`Q2U`Q3U`U3V0U4V0U5V0U6V@U7V@U8V@U9VPU:VPY;VPY<V`Y=V`Y>V`Y>
W0Y?W0Y@W0YAW@]BW@]CW@]DWP]EWP]FWP]GW`]HW`022eVO02l<FZ0<Fj0<
G:0<GJ4<GZ4<Gj4<H:8<HJ8=HZ8=Hj<=I:<=IJ<=IJ@=IZ@=Ij@=J:D>JJD>
JZD>JjH>K:H>KJH>KZL>KjL>L:L?L:P?LJP?LZP?LjT?M:T?MJT?MZX?MjX@
N:X@NJ/@NZ/@Nj/@Nj`@O:`@OJ`@OZdAOjdAP:dAPJhAPZhAPjhAQ:lAQJl0
0Q66[`0`4XN`4XR`4XV`4XZa4X^a4Xba4Xfb4Xjb4hnb4i2c4i6c4i:c4i:d
4i>d4iBd4iFe59Je59Ne59Rf59Vf59Zf59^g59bg59fg5Ifh5Ijh5Inh5J2i
5J6i5J:i5J>j5JBj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^m5jbm5jfm5jjn
5jnn5k2n5k6o5k:o5k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PD002002h00H000X000h4018401H401X801h8128812H<12X<12h<12h@1
38@13H@13XD23hD248D24HH24XH24hH258L25HL25XL35XP35hP368P36HT3
6XT36hT378X37HX47XX47h/488/48H/48H`48X`48h`498d59Hd59Xd59hh5
:8h5:Hh5:Xl5:hl21Bb?02l6;I06;Y06;i06<946<I46<Y46<i86=987=I87
=Y<7=i<7>9<7>9@7>I@7>Y@7>iD8?9D8?ID8?YH8?iH8@9H8@IL8@YL8@iL9
@iP9A9P9AIP9AYT9AiT9B9T9BIX9BYX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:
DId;DYd;Did;E9h;EIh;EYh;Eil;F9l00P]IW`0_35ZP35^P35bP35fQ35jQ
35nQ362R366R3F:R3F>S3FBS3FFS3FFT3FJT3FNT3FRU3VVU3VZU3V^V3VbV
3VfV3VjW3VnW3W2W3g2X3g6X3g:X3g>Y3gBY3gFY3gJZ3gNZ47RZ47V[47Z[
47^[47^/47b/47f/47j]4Gn]4H2]4H6^4H:^4H>^4HB_4HF_008AQZl0<1:7
/1:8/1:9/1::/A:;/A:</A:=/Q:>/Q>?/Q>@/a>A/a>B/a>B]1>C]1>D]1>E
]ABF]ABG]ABH]QBI]QBJ]QBK]aBL]aBM]aFM^1FN^1FO^1FP^AFQ^AFR^AFS
^QFT^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_AN/_AN]_AN^_QN__QN`_QNa
_aNb_aNc_cHH]<02R<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;P@R<2h
0DR@R04000000003R<2hb>3HR<2h0?n8`;P@R<2h0DR@R04000000003R<2h
b>3Hb>3H0?o8h=P@b>3H0DR@R04000000?n8`;PDR<2h0@000000\
\>"], "Graphics",
  ImageSize->{276, 278},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004/0000b2000`400?l0
0000o`00003oooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000
ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`
l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]
oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`
l?0]oo3`l000ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00
ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKV
iP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]
onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00koo^k^h00oo]kNgok^k^
onk^kP0jonk^kP00oooVi^H]onKViP00/_o^k^h8ong]k@03onk^k_o]kNgo
kNg]00gokNg]00?ok^k^ong]kOo]kNd00_o]kNeMonk^kP00X?ooool6ookn
oPKooOgm00?oo_knoogmoOono_h03OomoOd00oono_kooOgmooknoP0=oogm
o@03ookno_omoOgoo_kn00cooOgm1_ono_i;ooooo`00W?o^k^h01?o]kNgo
k^k^ong]kOo]kNd3onc/k009ong]kOo[jn_ok>c/on_[joo/k>cojn_[on[Z
j_o[jn_oj^[Z00Gojn_[1OoZj^X00ooYjNWoj^[Zon[ZjP08on[ZjP03onWY
jOoZj^[oj^[Z00;oj^[Z00?ojNWYon[Zj_oZj^X01_oZj^X2on_[j`06on[Z
j_o[jn_ojn_[on[Zj_o[jn_oj^[Z0oo[jn/01oo/k>cojn_[onc/k?o]kNgo
k>c/ong]kOo/k>`01?o]kNd9onk^kP03ong]kOo^k^kok^k^03_ok^k^002J
onKViP?oiNGU1OoTi>@00ooShn?oh^;Ron?Sh`02on;RhPCohN7Q0ooPh>02
omoOg`;oh>3P0_oOgml00ooPh>3ogmoOon3Ph002omoOg`?oh>3P00CogmoO
on3Ph?oOgmoogmoO0_oPh>02omoOg`03on3Ph?oOgmooh>3P00;ogmoO0ooP
h>001?oOgmooh>3PomoOgooOgml2on3Ph004omoOgooPh>3ohN7Qon3Ph0Co
hN7Q0ooRh^801OoShn?oh^;Ron?ShooTi>CoiNGU00;oi>CT1?oUiNE4onKV
iP00VOo^k^h3ong]k@04onc/k?o]kNgok>c/on_[j`;oj^[Z0ooYjNT2onOW
i`?oi^KV00?oiNGUonKVi_oUiND00_oUiND2onCTi004onGUiOoTi>Coi>CT
onGUi@Koi>CT00?oiNGUonCTi?oTi>@00ooTi>@01?oUiNGoi>CTonCTi?oU
iND6onCTi003onGUiOoTi>Coi>CT00?oi>CT0ooUiND5onKViP;oinOW0_oX
j>P2onWYj@;oj^[Z0_o[jn/00oo/k>cokNg]onc/k002ong]k@Kok^k^00?o
kNg]onk^k_o^k^h0>oo^k^h009Sooooo0_ono_h2oogmo@03ooclo?okno_o
o?cl00;on_[j00ConOWiooShn?ogmoOom_Kf0_oemOD2ooCdm004oo?cloob
l_;ol_;boo;blPGolO7a00?ol?3`oo7alOo`l?003?o`l?000ooalO7ol?3`
oo7al@0;oo3`l0GolO7a0_obl_82oo?cl`03ooCdm?oemOGom?Cd00;om_Kf
00ComoOgooShn?ohn?Son_[j0_okno/2ooclo0;ooOgm0_ono_i3ooooo`00
Uoo^k^h2ong]k@05onc/k?o]kNgojn_[on_[jooZj^X00_oYjNT2onOWi`07
onKVi_oTi>Coi>CTon?ShooRh^;ohN7Qon3Ph002omoOg`;og]kN0ooMgMd4
omcLg003omgMgOoLg=cog=cL00Gog=cL00CogMgMomcLg?oLg=cogMgM1?oL
g=`00ooMgMgog=cLomcLg005omcLg004omgMgOoLg=cog=cLomgMg@;og=cL
0_oMgMd2omkNgP06omoOgooPh>3oh>3Pon7QhOoRh^;ohn?S0_oTi>@00ooV
i^KoinOWonOWi`02onWYj@03on[Zj_o[jn_ok>c/00CokNg]@_o^k^h009Ko
i^KV0_oUiND01_oTi>CoiNGUon?ShooRh^;ohn?Son7Qh@;oh>3P00Oog]kN
omcLg?oLg=cof][JomWIfOoHf=Soe]KF00;oeMGE00Goe=CDom?CdooAdM7o
d];Bom7Ad@04om3@d0Ooclo?00Cod=3@olo?coo?clood=3@3?o?cll01?o@
d=3oclo?olo?coo@d=02olo?c`Cod=3@00?odM7Aom;Bd_oAdM400_oCdm<0
2_oEeMGoe]KFomKFe_oGemOofMWIom[Jf_oKfm_ogMgMomkNg_oOgml2on7Q
h@03on;Rh_oShn?ohn?S00;oi>CT0_oVi^H01?oUiNGoi^KVonKVi_oUiNDm
onKViP00U_o^k^h00oo]kNgok^k^onc/k002on_[j`04on[Zj_oYjNWoinOW
onOWi`;oiNGU00Sohn?Son3Ph?oOgmoogMgMomcLg?oJf][ofMWIomOGe`;o
eMGE0_oDe=@01_oBd];odm?Com;Bd_oBd];odM7Aom3@d0oodM7A00?od=3@
om7AdOoAdM402ooAdM44om;BdP;oe=CD00[oeMGEomKFe_oGemOofMWIom[J
f_oKfm_ogMgMomkNg_oPh>3oh^;R0_oUiND01OoVi^KoinOWon[Zj_oZj^[o
jn_[00;ok>c/0_o]kNd2onk^kP03ong]kOo^k^kok^k^03cok^k^002Foooo
o`;oo_kn01?ooOgmoo_knookno_on_[jooShn?ogmoOomOGeooCdm?oalO7o
kno_ong]kOo[jn_oj>SXonOWiooUiNGoi>CTon;Rh_oPh>3og]kN00;ogMgM
00?og=cLom[Jf_oJf]X04?oIfMT00ooHf=SofMWIomWIf@0>omWIf@0Dom[J
f_oKfm_og=cLomcLg?oMgMgog]kNon3Ph?oRh^;ohn?SonGUiOoWinOojNWY
on_[joo]kNgokno_oo7alOodm?ComOGeooOgmoohn?P2oo[jnP04ooclo?om
oOgooOgmooknoT7ooooo002Eonk^kP;okNg]00?ok>c/on_[joo[jn/00_oY
jNT04OoVi^KoiNGUon?ShooQhN7ogmoOomgMgOoJf][oemOGomGEeOoBd];o
dM7Aolk>c_o=cLgoc<c<olW9bOo8b<SoalO700;oa/K600?oaLG5olC4a?o4
a<@01?o3`l<01_o4a<Co`l?3ol?3`oo4a<Co`l?3olC4a0;o`l?300Coa<C4
ol?3`oo3`l?oa<C41?o3`l<01_o4a<Co`l?3ol?3`oo4a<Co`l?3olC4a0;o
`l?30oo4a<@3olG5a@;oalO701?ob/[:ol_;boo=cLgoclo?om7AdOoCdm?o
eMGEomSHf?oKfm_og=cLomoOgooQhN7oh^;RonGUiOoWinOoj>SXonWYjOoZ
j^[ojn_[00;okNg]00?ok^k^ong]kOo^k^h0?_o^k^h009Koi^KV00CoiNGU
onCTi?oShn?oh^;R0_oPh>003_oNg]kog=cLomWIfOoGemOoe=CDom;Bd_o@
d=3oc<c<olW9bOo7alOoaLG5ol;2`_o0`<3o_[jn0_nk^k/01Onj^[[o^KVi
okNg]ong]kOo]KFe00?o][Jf00Go]KFeokJf]_nf][Ko]KFeokJf]P02okFe
]@;o][Jf0_ne]KD00onf][Ko]KFeokJf]P02okJf]P05okFe]Onf][Ko][Jf
okFe]Onf][H00_ne]KD2okJf]P;o]KFe00Co][JfokFe]Ong]kOo^;Rh0_ni
^KT04?nk^k_o_;blokjn__o0`<3o`/;2olC4a?o7alOobLW9olc<c?o?cloo
d];BomCDe?oGemOof][JomcLg?oMgMd2on3Ph004on;Rh_oShn?oi>CTonGU
i@?oi^KV00?oiNGUonKVi_oVi^H0>ooVi^H009Gok^k^01_okNg]onc/k?o/
k>coj^[ZonWYjOoXj>Soi^KVonCTi?oQhN7oh>3PomgMgOoIfMWoe]KFom;B
d_o?cloobl_;olS8b?o5aLGo`l?3ol30`?nn_[ko_;blokVi^Onh^;So]kNg
okJf]_ne]KD00_nd];@Mok>c/`;o];Bd0_ne]KD05ong]kOo^;RhokVi^Onl
_;co_[jnol30`?o3`l?oa/K6olS8b?o<c<coclo?om?CdooFe]KofMWIomcL
g?oOgmoohN7QonCTi?oVi^KoinOWonWYjOoZj^[ok>c/00;okNg]@?o^k^h0
09Gooooo01coo_knoogmoOomoOgono_kooWinOogmoOom?Cdoo;bl_o`l?3o
k>c/onWYjOoUiNGohN7QomgMgOoIfMWoeMGEom3@d?o=cLgob/[:olK6a_o3
`l?o`L71okjn__nl_;co^k^kokZj^_nh^;So]kNg0_nf][H2okNg]`06okJf
]_ng]kOo]kNgokNg]onf][Ko]kNg0_nf][H01?ng]kOo][JfokJf]_ng]kL2
okJf]P;o]kNg00Ko][JfokNg]ong]kOo]kNgokJf]_ng]kL2okJf]P0OokNg
]onf][Ko][JfokNg]onh^;So^[Zjok^k^onm_Kgo_[jnol71`Oo4a<Coa/K6
olW9bOo=cLgod=3@omCDe?oIfMWogMgMon7QhOoUiNGojNWYonc/k?o`l?3o
lo?cooCdm?ogmoOonOWioo_knoolo?cooOgmooknoP10ooooo`00UOo^k^h0
6_o]kNgok>c/on[Zj_oYjNWoj>SXonKVi_oShn?ohN7QomkNg_oJf][oe]KF
om?Cdoo>c/kob/[:olG5aOo1`L7o_;blokVi^Ond];Co/K6aojn_[on/[:co
ZJVYojRXZ?nUYJGoXj>S0_nRXZ801?nPX:3oXJ6Qoj6QXOnPX:02oj6QX@;o
X:2P1OnQXJ401?nPX:3oXJ6Qoj6QXOnPX:02oj6QX@03oj2PX?nQXJ7oXJ6Q
00;oX:2P1OnQXJ407?nPX:3oXJ6Qoj:RX_nRXZ;oY:BTojJVY_nWYjOoZZZZ
ojb/[?n^[Zko/K6aokFe]Oni^KWo_;blol71`Oo5aLGobLW9olo?cooCdm?o
e]KFom_KfooNg]koh>3PonCTi?oVi^KoinOWonWYjOo[jn/2ong]k@;ok^k^
00?okNg]onk^k_o^k^h0>oo^k^h009Goi^KV0_oUiND06OoShn?ohN7QomoO
gooMgMgof][JomOGeooDe=CodM7Aolc<c?o8b<Soa<C4okno_oni^KWo];Bd
ojn_[on/[:coZ:RXojFUYOnPX:3oWYjNoi^KVonIVIWoUYJFoiFEUOnDU9@0
0_nCTi<2oi:BTP03oi6ATOnBTY;oTY:B00CoTY:B00?oTI6Aoi:BT_nBTY80
1_nBTY800onATI7oTY:Boi:BTP04oi:BTP04oi6ATOnBTY;oTY:Boi:BTP;o
Ti>C0_nEUID06OnFUYKoV9RHoi^KVonNWYkoXJ6QojFUYOnWYjOoZj^[ojn_
[ond];Co^KViokno_oo4a<Cob<S8olg=cOo@d=3oe=CDomOGeooJf][ogMgM
omoOgooQhN7ohn?SonCTi?oUiND0@?oVi^H009Gok^k^01ookNg]on_[joo[
jn_oj>SXonKVi_oShn?oh>3PomgMgOoIfMWoeMGEom7AdOo<c<coa/K6ol71
`Onk^k_o][Jfok2`/?n[Zj_oYjNWoj:RX_nNWYkoVi^KoiRHV?nFUYKoTi>C
oi:BT_n@T93oShn?ohj>S_n=SHgoSXj>00?oSHf=00GoSXj>ohf=SOn>SXko
SHf=ohj>SP02ohf=S@03ohj>S_n=SHgoSHf=00;oSHf=00WoSXj>ohf=SOn=
SHgoSHf=ohj>S_n=SHgoSXj>ohf=SOn>SXh00_n=SHd2ohj>SP;oShn?01co
TY:Boi>CTonEUIGoV9RHoi^KVonNWYkoXZ:RojNWYon[Zj_o/;2`okJf]_nj
^[[o`L71olK6a_o<c<codM7AomGEeOoIfMWogMgMon3Ph?oShn?oi^KVonSX
j?o[jn_ok>c/ong]kOo^k^kokNg]?_o^k^h009Gooooo01goo_knoogmoOok
no_on?ShooKfm_oclo?okno_on_[jooWinOohN7QomgMgOoGemOod=3@ol[:
b_o2`/;o_KfmokJf]_na/K7o[:b/ojJVY_nRXZ;oWYjNoiZJV_nGUiOoUIFE
oi:BT_nATI7oSXj>ohn?S`0>ohj>SP03ohf=SOn>SXkoSXj>00coSXj>01go
Shn?ohj>S_n@T93oTY:BoiFEUOnHV9SoVIVIoinOWonRXZ;oYZJVoj^[Zon`
/;3o][Jfokbl_?o3`l?ob/[:om7AdOoGemOog=cLon7QhOoWinOojn_[ono_
kooclo?om_KfooShn?okno_oo?clooknoP10ooooo`00UOo^k^h2onc/k00I
on[Zj_oXj>SoiNGUon;Rh_oNg]kof][JomGEeOoAdM7oc<c<olK6a_o0`<3o
^;Rhok:b/_n/[:coY:BToinOWonIVIWoUIFEoi6ATOn<S8coRHV9ohF5QOn2
PX;oPH61ogmoO`02ogemO@03og]kNomlO7coO7al00?oNg]k1?mlO7`2og]k
N`;oO7al00?oNg]kogalO?mkNg/00_mlO7`3og]kN`CoO7al0_mkNg/08?ml
O7coOGemogemOOmoOgooP820oh>3Pon6QXKoR8R8ohb<S?n@T93oUIFEoiZJ
V_nOWiooYJFUoj^[Zona/K7o^KViol30`?o6a/Koc<c<om7AdOoFe]Kof][J
omkNg_oRh^;oi>CTonSXj?oZj^[ok>c/ong]kOo^k^kokNg]?_o^k^h009Go
i^KV0_oTi>@06?oQhN7og]kNomgMgOoIfMWoeMGEom;Bd_o=cLgoalO7ol;2
`_nl_;co]KFeojn_[onWYjOoX:2PoiZJV_nDU9CoShn?ohV9ROn5QHGoP820
ogemOOmkNg_oN7QhogEeM@;oLW9b0_maLG43og1`L003og5aLOm`L73oL71`
00?oL71`0_maLG42og1`L003og5aLOm`L73oLG5a00?oL71`00?oLG5aog1`
L?m`L7000om`L702og5aL@0Nog1`L?maLG7oLW9bog=cLomeMGGoMgMgogYj
N_mnOWkoPH61ohJ6Q_n9RHWoShn?oiBDU?nJVY[oXJ6QojRXZ?n^[Zko]KFe
okbl_?o2`/;ob<S8olc<c?oBd];oe]KFom[Jf_oMgMgog]kNon7QhOoShn?o
i>CT0ooVi^H00ooUiNGoi^KVonKViP0jonKViP00UOo^k^h07Oo]kNgoj^[Z
on[Zj_oVi^Koi>CTon3Ph?oLg=coemOGom?Cdoo=cLgoalO7ol30`?ni^KWo
/[:bojVYZOnRXZ;oVi^KoiBDU?n?ShooR8R8ohB4Q?n0P83oO7alogMgMomf
MWKoLW9bog1`L?m_KfooKVi^00GoKFe]00?oKVi^ofe]KOm]KFd00om]KFd0
1?m^KVkoKFe]ofe]KOm^KVh6ofe]K@03ofi^K_m]KFgoKFe]00?oKFe]023o
KVi^ofe]KOm^KVkoKfm_og1`L?mbLW;oMGEeogMgMomlO7coOgmoohB4Q?n8
R8SoShn?oiFEUOnKVi_oXZ:RojZZZ_na/K7o^KViol30`?o7alOocLg=om;B
d_oGemOog=cLon3Ph?oTi>Coi^KVonWYjOo[jn_ok>c/ong]kCook^k^002E
ooooo`0KoogmoOolo?con_[jooKfm_oclo?okno_on[Zj_oVi^Koh>3Pom[J
f_oBd];obl_;olC4a?nk^k_o/[:bojZZZ_nQXJ7oVYZJoiBDU?n=SHgoR8R8
oh:2P_mnOWkoNWYjogMgMomdM7CoLG5a00;oKfm_00?oKVi^ofm_Kom^KVh0
3_m^KVh00om_KfooKVi^ofi^KP0:ofi^KP0Lofm_KombLW;oM7AdogMgMomj
NW[oOGemoh>3Pon8R8SoSHf=oiBDU?nJVY[oXZ:RojVYZOnb/[;o_;blol?3
`oo;bl_odm?ComWIfOoPh>3oi^KVon[Zj_o_knoolo?cooKfm_ojn_[ono_k
oogmoD3ooooo002Eonk^kP0Konc/k?o[jn_ojNWYonKVi_oRh^;ogmoOom_K
fooFe]Koclo?ol[:b_o4a<Co_;blokBd]?n/[:coXj>Soi^KVonCTi?oS8b<
ohJ6Q_moOgooNWYjogEeMOm`L73oKFe]ofUYJOmWIfOoIFEU00;oHV9R1omQ
HF400omPH63oHF5Qof5QH@0=of5QH@03of1PH?mQHF7oHF5Q00?oHF5Q0_mR
HV806omTI6CoIfMWofUYJOm]KFgoL71`ogEeMOmjNW[oOgmoohF5QOn<S8co
Ti>Coi^KVonSXj?o[:b/okBd]?nl_;coa<C4ol[:b_o?clooe]KFom_KfooO
gmoohn?SonKVi_oXj>Sojn_[onc/k010onk^kP00UOoVi^H03ooTi>Coh^;R
on3Ph?oNg]kofm_KomKFe_oBd];ocLg=olO7aoo1`L7o^k^kokBd]?n/[:co
Y:BToo_kn`02ooclo0;ono_k0_olo?`01ookno_oo?cloo_knookno_oo?cl
oo_knoolo?`00ookno/2ooclo0;ono_k0_olo?`01ookno_oo?cloo_knook
no_oo?cloo_knoolo?`00ookno/2ooclo0;ono_k0_olo?`01ookno_oo?cl
oo_knookno_oo?cloo_knoolo?`00ookno/2ooclo0;ono_k0_olo?`04_ok
no_oo?cloo_knookno_oY:BTojb/[?nd];Co^k^kol71`Oo7alOocLg=om?C
dooFe]Kof][JomoOgooPh>3oh^;RonCTi0?oi^KV00?oiNGUonKVi_oVi^H0
>_oVi^H009Gok^k^00ookNg]on_[jooYjNWoiNGUon7QhOoNg]kofMWIomCD
e?o=cLgob<S8ol30`?ni^KWo/K6aojNWYooinOT00_ohn?P01ooinOWon?Sh
ooShn?ohn?SonOWiooShn?oinOT00oohn?P01?oinOWon?ShooShn?oinOT2
ooShn007ooWinOohn?Son?ShooShn?oinOWon?ShooWin@03ooShn004ooWi
nOohn?Son?ShooWin@;on?Sh00OonOWiooShn?ohn?Son?ShooWinOohn?So
nOWi00?on?Sh00ConOWiooShn?ohn?SonOWi0_ohn?P05_oinOWon?ShooSh
n?ohn?SonOWiooShn?oinOWon?ShojNWYona/K7o^KViol30`?o7alOoc/k>
om?CdooIfMWog]kNon;Rh_oUiNGoj>SXon_[joo/k>`2onk^kP03ong]kOo^
k^kok^k^03_ok^k^002Eooooo`0>oogmoOokno_onOWiooKfm_oalO7okNg]
onOWiooRh^;og=cLomCDe?o=cLgoa<C4okbl_?na/K42onk^kP04ong]kOo^
k^kokNg]onk^kP;okNg]00Gok^k^ong]kOo^k^kokNg]onk^kP03ong]k@;o
k^k^00CokNg]onk^k_o]kNgok^k^0_o]kNd01Oo^k^kokNg]onk^k_o]kNgo
k^k^00?okNg]0_o^k^h01?o]kNgok^k^ong]kOo^k^h2ong]k@05onk^k_o]
kNgok^k^ong]kOo^k^h00oo]kNd2onk^kP04ong]kOo^k^kokNg]onk^kP;o
kNg]017ok^k^ong]kOo^k^ko/K6aokbl_?o4a<CocLg=omCDe?oLg=coh^;R
onOWioo]kNgolO7aooKfm_oinOWono_koogmo@10ooooo`00UOo^k^h03_o/
k>cojn_[onOWiooUiNGohN7QomgMgOoIfMWod];Bolc<c?o6a/Ko_[jnokFe
]On^[ZkoXj>S0_ohn?P00ooinOWon?ShooWin@02ooShn0;onOWi00?on?Sh
ooWinOohn?P00_ohn?P02?ogmoOon?ShooShn?ogmoOon?ShooOgmoohn?So
moOg1Oohn?P01?ogmoOon?ShooShn?ogmoL2ooShn005ooOgmoohn?SomoOg
ooShn?ogmoL01Oohn?P01OogmoOon?ShooShn?ohn?SonOWi00;on?Sh00?o
nOWiooShn?oinOT00_ohn?P2ooWin@0@ooShn?oinOWoXj>Sojf][Onf][Ko
_KfmolK6a_o<c<cod];BomSHf?oMgMgoh^;RonGUiOoWinOojn_[ong]k@;o
k^k^00?okNg]onk^k_o^k^h0>oo^k^h009Goi^KV00koiNGUon?ShooOgmoo
gMgMomWIfOoDe=Cod=3@ol_;boo5aLGo_[jnokNg]on^[ZkoYZJVoijNWP?o
mOGe00Oom?CdooGemOoemOGomOGeooCdm?oemOGom?Cd00;omOGe0oodm?@2
oo?cl`03ooCdm?oclo?olo?c00Oolo?c00Com?Cdoo?clooclo?om?Cd0_oc
lo<00oodm?Colo?coo?cl`07oo?cl`?om?Cd1OoemOD05_odm?ComOGeooGe
mOoemOGom?CdooGemOodm?ComOGeoijNW_nVYZKo[jn_okRh^?nn_[koaLG5
ol_;boo@d=3oe=CDomWIfOoMgMgogmoOon;Rh_oTi>A0onKViP00UOo^k^h0
4?o/k>coj^[ZonOWiooTi>CohN7QomcLg?oGemOod];Bol_;boo4a<Co_Kfm
okBd]?n/[:coXZ:Ron[Zj_oYjNT2on[ZjP03onWYjOoZj^[ojNWY00;oj^[Z
00?ojNWYon[Zj_oYjNT00ooXj>P00ooWinOoj>SXonOWi`02onSXj003onOW
iooXj>SoinOW00;oj>SX00GoinOWonSXj?oXj>SoinOWonSXj002onOWi`07
onSXj?oWinOoj>SXonSXj?oWinOoj>SXonOWi`02onSXj004onOWiooXj>So
j>SXonOWi`;oj>SX00?ojNWYon[Zj_oYjNT00_oZj^X00ooYjNWoj^[ZonWY
j@02on[ZjP0@onWYjOoZj^[oXZ:Roj^[Zond];Co_KfmolC4a?o;bl_od];B
omSHf?oLg=cohN7QonCTi?oWinOojn_[ong]k@?ok^k^00?okNg]onk^k_o^
k^h0>_o^k^h009Gooooo00kooOgmooclo?ohn?SomOGeoo7alOo/k>coi^KV
on3Ph?oIfMWod];BolW9bOo1`L7o]kNgojf][@;ono_k00Gon_[joo_knooj
n_[on_[joo_kn`02oo[jnP05oo_knoojn_[on_[joo[jn_oinOT00_ohn?P2
ooWin@Con?Sh00?onOWiooShn?ohn?P00oohn?P2ooWin@;on?Sh0_oinOT4
ooShn003ooWinOohn?Son?Sh00?on?Sh0ooinOT01Oojn_[ono_koo_knooj
n_[ono_k00;on_[j01?ono_koo[jn_ojn_[ono_koo[jn_n][Jgo^;Rhol71
`Oo9bLWod];BomWIfOoPh>3oinOWonc/k?oalO7om?CdooShn?okno_ooOgm
043ooooo002Eonk^kP0>ong]kOo[jn_oinOWonCTi?oQhN7ogMgMomOGeooA
dM7obl_;olC4a?nl_;co];BdojZZZ_nQXJ45oo_kn`03ooclo?okno_ono_k
00?ono_k0_ojn_X3ooWin@;on?Sh0_oinOT01?ohn?SonOWiooWinOohn?P2
ooWin@04ooShn?oinOWonOWiooShn0;onOWi0_ohn?P2ooWin@08ooShn?oi
nOWonOWiooShn?oinOWol?3`on3Ph?ohn?P2ooWin@?on_[j1?okno/00ool
o?cono_koo_kn`03oo_kn`0>oj6QXOn[Zj_o];Bdokbl_?o4a<Cob/[:om7A
dOoHf=SogMgMon7QhOoUiNGoinOWon[Zj_o/k>a0onk^kP00UOoVi^H03_oT
i>Cohn?Son3Ph?oMgMgofMWIomGEeOo@d=3ob/[:olC4a?nn_[ko]KFeojj^
[_nUYJGoVi^K1?oemOD00oodm?ComOGeooGem@02ooGem@04ooCdm?oemOGo
m?Cdoo?cl`;ol_;b00?olo?coo;bl_oclo<00oobl_800one]KGo7QhNom?C
d`02oo;blP;olo?c01?ol?3`ob/[:omHF5Solo?coo;bl_o4a<Co7QhNoiJF
U_obl_;olo?coo;bl_oUiNGoIFEUoalO7olZ:R[o;2`/oj2PX?obl_;olo?c
00;om?Cd0ooemOD00oodm?ComOGeooGem@02ooGem@0@ooCdm?oemOGoVi^K
ojBTY?n][Jgo]KFeokjn__o4a<Cob/[:om3@d?oEeMGofMWIomgMgOoOgmoo
hn?SonCTi43oi^KV002Eonk^kP0@onc/k?oZj^[oj>SXonCTi?oQhN7og=cL
omSHf?oAdM7ob/[:olC4a?nl_;co];BdojZZZ_nQXJ7oj^[ZonWYj@Coj^[Z
00CojNWYon[Zj_oZj^[oj^[Z0ooYjNT05ooXj>SoinOWonOWiooXj>SoinOW
onSXj?oWinOoj>SXojj^[_lO7aoob/[:onOWiooXj>SoinOWonSXj?nk^k_o
820PobPX:?oLg=coj>SXohB4Q?lU9BGoCdm?00;oj>SX00coinOWofIVI_lk
>c_o^[Zjon7QhOnDU9Co820PokFe]OoXj>SojNWYon[Zj_oYjNT4on[ZjP0E
onWYjOoZj^[oj^[Zon[Zj_oYjNWoXJ6Qoj^[Zond];Co_;blolC4a?o;bl_o
dM7AomSHf?oLg=cohN7QonCTi?oWinOojn_[onc/k?o^k^kokNg]03kok^k^
002Eooooo`0AoogmoOolo?con?ShooCdm?oalO7ok>c/onKVi_oPh>3ofMWI
om;Bd_o:b/[o`<30okNg]on/[:cono_koo[jn_okno/00oojn_X01Ookno_o
n_[joo_knoojn_[ono_k00?onOWi1oohn?P00onj^[[o8R8RomSHf004ooSh
n00=ohZ:R_m=CDgoG5aLojn_[oohn?SoDe=CohN7QolU9BGoi>CTooShn?o[
jn_o8B4Qoh^;R`03ooShn007ocPh>?m[Jf_onOWioo[jn_okno_on_[joo_k
n`03oo[jnP0Coo_knoojn_[ono_koo[jn_okno_o[:b/okJf]_o1`L7obLW9
om;Bd_oIfMWoh>3PonOWioo/k>colO7aooCdm?ohn?Sono_koogmo@10oooo
o`00UOo^k^h03_o/k>cojn_[onOWiooTi>Coh^;RomcLg?oHf=SodM7Aol[:
b_o4a<Co_;blokBd]?n[Zj_oX:2P2ookno/2oo[jnP;onOWi0_ohn?P4ooWi
n@0JokZj^_lO7aoofMWIooWinOohn?SonOWiooShn?m<C4coRHV9oinOWom[
Jf_ok>c/ob<S8ooBd];oF5QHoinOWoohn?SocLg=oalO7onn_[kon?ShooWi
nOohn?SoJFUYoda<C?oinOT2oo[jnP[ono_k00koX:2PojZZZ_nd];Co_;bl
olC4a?o:b/[odM7AomSHf?oLg=coh^;RonCTi?oWinOojn_[ong]k@;ok^k^
00?okNg]onk^k_o^k^h0>oo^k^h009Goi^KV01;oi>CTon?ShooPh>3og=cL
omWIfOoDe=Cod=3@ol[:b_o4a<Co_KfmokFe]On^[ZkoY:BToi^KVooemOGo
m?CdooGemOodm?@4ooGem@04ooCdm?oemOGom?CdooCdm0Golo?c1?obl_80
7onf][Ko7QhNom?Cdoobl_;olo?coo;bl_oPh>3o7QhNol;2`_oKfm_o:b/[
ojb/[?la<C7ol_;boi^KVomEEEGolo?comWIfOlN7QkoX:2Poo?cloobl_;o
lo?coda<C?mHF5Solo?cooCdm?oemOGom?CdooGemOodm?@01?oemOD04Ood
m?ComOGeooGemOnKVi_oY:BTojj^[_nf][Ko_[jnolC4a?o9bLWod=3@omCD
e?oIfMWogMgMon3Ph?oShn?oi>CT00?oi^KV00?oiNGUonKVi_oVi^H0>_oV
i^H009Gok^k^013okNg]on[Zj_oXj>Soi>CTon7QhOoLg=coemOGom7AdOo;
bl_oa<C4okbl_?nd];CoZZZZoj6QXOoZj^[ojNWY0ooZj^X00ooYjNWoj^[Z
onWYj@03on[ZjP07onWYjOoXj>SoinOWonSXj?oWinOoj>SXonOWi`02onSX
j00JonOWion][Jgo820PolW9bOoWinOoj>SXonOWionNWYko;2`/onCTi?oX
j>SoATI6od10@?mVIVKoj>SXomGEeOlS8b?oemOGonKVi_li>CWoIFEUonSX
j?oWinOofm_Kob<S8on8R8P2onSXj003on[Zj_oYjNWoj^[Z00;oj^[Z00?o
jNWYon[Zj_oYjNT00ooZj^X03_nQXJ7oZZZZok>c/onl_;coa<C4ol_;booA
dM7of=SHomcLg?oQhN7oi>CTonSXj?oZj^[ok>c/@?o^k^h009Gooooo00oo
oOgmooclo?ohn?SomOGeoo7alOo[jn_oinOWon3Ph?oIfMWod];BolW9bOo1
`L7o]kNgojb/[?ojn_X00_okno/01Oojn_[ono_koo[jn_ojn_[ono_k00;o
n_[j00Cono_kooWinOoinOWonOWi1oohn?P00onj^[[o8B4QomSHf003ooSh
n007of][JomZJV[on?ShooShn?n=SHgo8B4QojNWY`02ooShn00;oeADE?nT
Y:Con?Shokjn__lZ:R[oCdm?oh:2P_la<C7oCdm?oo;bl_oinOT00_ojn_X2
oo_kn`05oo[jn_okno_on_[joo[jn_okno/00_ojn_X03ookno_o[:b/okNg
]oo1`L7obLW9om;Bd_oIfMWoh>3PonOWioo[jn_olO7aooCdm?ohn?Soo?cl
oogmo@10ooooo`00UOo^k^h03_o/k>cojn_[onSXj?oTi>CohN7QomcLg?oG
emOodM7Aol[:b_o4a<Co_;blok>c/on[Zj_oXJ6Q2ookno/00oojn_[onOWi
ooWin@03ooWin@;on?Sh01[onOWiooShn?nk^k_o7alOomWIfOoinOWon?Sh
ooWinOnZZZ[oc/k>ooWinOohn?SogmoOoifMWOoWinOon?ShooWinOo8b<So
`<30ooShn?oinOWog=cLoiNGUon4Q8CoZZZZooGem@;onOWi00?on_[joo_k
nookno/02Ookno/03_nQXJ7oZZZZokBd]?nl_;coa<C4ol_;booAdM7oemOG
omcLg?oQhN7oi>CTonOWioo[jn_okNg]@?o^k^h009Goi^KV00koi>CTon;R
h_oOgmoogMgMom[Jf_oEeMGod=3@ol[:b_o4a<Co_KfmokJf]_n^[ZkoY:BT
oi^KV`ComOGe00Com?CdooGemOoemOGom?Cd0_oemOD2ooCdm0;olo?c0oob
l_82oo?cl`;ol_;b00Co][JfoahN7_oCdm?olo?c0_obl_800ooclo?ol_;b
oo?cl`03oo;blP;olo?c0_obl_82oo?cl`06oo;bl_oclo?ol_;boo;bl_oc
lo?ol_;b0ooclo<01Oodm?ComOGeooGemOoemOGom?Cd00;omOGe01;om?Cd
ooGemOoemOGomOGeoi^KVonTY:Co[Zj^okFe]Onm_Kgo`l?3ol[:b_oAdM7o
eMGEomWIfOoMgMgoh>3Pon;Rh_oTi>@3onKViP03onGUiOoVi^Koi^KV03[o
i^KV002Eonk^kP0>ong]kOo[jn_oj>SXonCTi?oQhN7og=cLomOGeooAdM7o
b/[:olC4a?nl_;co];Bdoj^[ZonPX:02on[ZjP07onWYjOoZj^[oj^[Zon[Z
j_oYjNWoj^[ZonWYj@02on[ZjPCoj>SX00CoinOWonSXj?oWinOo?clo0_lX
:2P01_lU9BGo7alOobHV9_lW9bOo:2PXoeYJFP;oinOW0_oXj>P02_oWinOo
j>SXonOWiooWinOoj>SXonOWiooXj>SoinOWonSXj?oWinL2onSXj0;oinOW
0_oXj>P01?oYjNWoj^[Zon[Zj_oYjNT3on[ZjP03onWYjOoZj^[ojNWY00;o
j^[Z00koX:2PojZZZ_nd];Co_;blolC4a?o;bl_odM7AomOGeooLg=cohN7Q
onCTi?oWinOojn_[onc/k0;ok^k^00?okNg]onk^k_o^k^h0>oo^k^h009Go
oooo00kooOgmoo_knoohn?SomOGeoo7alOo/k>coinOWon3Ph?oIfMWod];B
ol[:b_o0`<3o]kNgojb/[0;ono_k00Con_[joo_knoojn_[ono_k0_ojn_X0
0ookno_on_[joo_kn`02ooWin@Gon?Sh00?oh^;RomkNg_oNg]h01OoNg]h0
0ooUiNGon?ShooShn00?ooShn004ooWinOohn?SonOWiooWin@;ono_k00Co
n_[joo_knoojn_[ono_k0_ojn_X04Ookno_on_[joo_knon/[:co]kNgol30
`?o9bLWod];BomWIfOoPh>3oinOWonc/k?oalO7omOGeooShn?okno_ooOgm
043ooooo002Eonk^kP0>onc/k?o[jn_oinOWonCTi?oQhN7og=cLomSHf?oA
dM7obl_;olC4a?nl_;co];Bdoj^[ZonPX:0;oo_kn`05oo[jn_oinOWonOWi
ooShn?oinOT00_ohn?P01?oinOWon?ShooWinOohn?P3ooWin@07ooShn?oi
nOWon?ShooShn?oinOWon?ShooWin@02ooShn004ooWinOohn?SonOWiooSh
n0?onOWi00?on?ShooWinOohn?P00ooinOT00oojn_[ono_koo_kn`09oo_k
n`0>oj2PX?nZZZ[o];Bdokbl_?o4a<Cob/[:om3@d?oHf=Sog=cLon;Rh_oT
i>CoinOWon_[joo]kNd2onk^kP03ong]kOo^k^kok^k^03_ok^k^002EonKV
iP0>onGUiOoShn?ogmoOomgMgOoIfMWoe=CDom3@d?o:b/[oa<C4okfm_Onf
][Ko[Jf]ojFUYOnLW9`3ooGem@09ooCdm?oemOGomOGeooGemOodm?ComOGe
ooCdm?oemOGom?Cd00Colo?c00Col_;boo?cloobl_;ol_;b0_oclo<2oo;b
lP03oo?cloobl_;olo?c00Golo?c00Col_;boo?cloobl_;ol_;b0_oclo<2
oo;blP03oo?cloobl_;olo?c00?olo?c0oodm?@2ooGem@0FooCdm?oemOGo
mOGeooGemOodm?ComOGeooCdm?oemOGoW9bLojFUYOn^[Zko][Jfokjn__o3
`l?ob/[:om3@d?oDe=CofMWIomgMgOoOgmooh^;RonCTi43oi^KV002Eonk^
kP0@onc/k?oZj^[oinOWonCTi?oQhN7og=cLomOGeooAdM7ob/[:olC4a?nl
_;co];Bdoj^[ZonQXJ7oj^[ZonWYj@;oj^[Z00?ojNWYon[Zj_oYjNT00_oZ
j^X00ooYjNWoj^[ZonWYj@02onSXj0CoinOW0_oXj>P00ooWinOoj>SXonOW
i`02onSXj003onOWiooXj>SoinOW00KoinOW0_oXj>P00ooWinOoj>SXonOW
i`02onSXj004onOWiooXj>SoinOWonOWi`?oj>SX00Ooj^[ZonWYjOoZj^[o
j^[ZonWYjOoZj^[ojNWY00;oj^[Z013ojNWYon[Zj_nQXJ7oZZZZokBd]?nl
_;coa<C4ol[:b_oAdM7of=SHomcLg?oQhN7oi>CTonOWioo[jn_okNg]0oo^
k^h00oo]kNgok^k^onk^kP0jonk^kP00UOooool03_omoOgoo?clooShn?oe
mOGolO7aonc/k?oVi^Koh>3PomWIfOoBd];obLW9ol71`Onf][Ko[:b/0_ok
no/01Oojn_[ono_koo[jn_ojn_[ono_k00;on_[j00?ono_koo[jn_oinOT0
0_oinOT3ooShn003ooWinOohn?Son?Sh00gon?Sh00?onOWiooShn?ohn?P0
2?ohn?P3ooWin@05oo[jn_okno_ono_koo[jn_okno/00_ojn_X04ookno_o
n_[joo[jn_okno_on_[jojb/[?ng]kOo`L71olW9bOoBd];ofMWIon3Ph?oW
inOok>c/oo7alOodm?Con?Shoo_knoomoOd0@?ooool009Gok^k^00kokNg]
on_[jooWinOoi>CTon7QhOoMgMgoemOGom7AdOo;bl_oa<C4okbl_?nd];Co
ZZZZoj6QX@?omoOg00?on?ShooOgmoohn?P00oogmoL01?ohn?SomoOgooOg
moogmoL8ooKfmP03ooOgmoofm_Kom_Kf00gom_Kf00?omoOgooKfm_ofm_H0
1_ofm_H5ooOgm`03ooShn?ogmoOon?Sh00?omoOg013on?ShooOgmonQXJ7o
Zj^[okBd]?nl_;coa<C4ol[:b_oAdM7of=SHomgMgOoQhN7oiNGUonOWiooZ
j^[ok>c/@?o^k^h009Goi^KV00koi>CTon?ShooPh>3ogMgMomWIfOoEeMGo
d=3@ol[:b_o4a<Co_[jnokFe]On^[ZkoYJFUoi^KV`;oj>SX0ooWinL00ooX
j>SoinOWonSXj002onOWi`03onSXj?oWinOoi^KV00;oi^KV00?oinOWonKV
i_oVi^H01OoVi^H01?oWinOoi^KVonKVi_oWinL4onKViP03onOWiooVi^Ko
i^KV00Goi^KV00CoinOWonKVi_oVi^KoinOW0ooVi^H01?oWinOoj>SXonSX
j?oXj>P3onOWi`03onSXj?oWinOoj>SX00;oinOW00ooj>SXoi^KVonTY:Co
[Jf]okFe]Onn_[koa<C4ol[:b_o@d=3oeMGEomWIfOoMgMgogmoOon?ShooT
i>@0@?oVi^H009Gok^k^01;ok>c/on[Zj_oXj>Soi>CTon7QhOoLg=cof=SH
om7AdOo:b/[oa<C4okbl_?nd];CoZZZZoj6QXOohn?SomoOgooShn?ogmoL2
ooShn004ooOgmoohn?SomoOgooShn0?omoOg8Oofm_H2ooOgm`04ooShn?og
moOon?ShooOgm`;on?Sh01GomoOgooShn?ogmoOon?ShooOgmonQXJ7oZj^[
okBd]?nl_;coa<C4ol_;booAdM7of=SHomcLg?oQhN7oi>CTonOWioo[jn_o
k>c/onk^k_o]kNd0?_o^k^h009Gooooo00kooOgmooclo?ohn?Som?Cdoo7a
lOo/k>coi^KVon3Ph?oIfMWod];Bol[:b_o0`<3o]kNgojb/[0_ooooo0oon
o_h00oomoOgoo_knoogmo@0<oogmo@03ookno_omoOgoo_kn00gooOgm0_on
o_h<ooooo`0>ojb/[?nf][Ko`L71olW9bOoBd];ofMWIon3Ph?oWinOok>c/
oo7alOodm?Con?Shoo_knoomoOe0ooooo`00UOo^k^h03oo/k>cojn_[onOW
iooTi>Coh^;RomcLg?oHf=SodM7Aol[:b_o4a<Co_;blokBd]?n[Zj_oX:2P
ooOgm`02ooShn003ooOgmoohn?SomoOg00;omoOg00Con?ShooOgmoohn?So
m_Kf0_ogmoL4ooKfmP03ooOgmoofm_Kom_Kf00Som_Kf00?omoOgooKfm_of
m_H00_ofm_H00oogmoOom_KfooKfmP08ooKfmP04ooOgmoofm_KomoOgooOg
m`;on?Sh00?omoOgooShn?ogmoL00_ogmoL04Oohn?SomoOgooShn?nPX:3o
ZZZZokBd]?nl_;coa<C4ol[:b_oAdM7of=SHomcLg?oRh^;oi>CTonOWioo[
jn_okNg]00;ok^k^00?okNg]onk^k_o^k^h0>oo^k^h009Goi^KV017oi>CT
on?ShooPh>3og=cLomWIfOoDe=Cod=3@ol[:b_o4a<Co_KfmokFe]On^[Zko
Y:BToi^KVooXj>SoinOWonSXj002onOWi`;oj>SX0_oWinL00ooXj>SoinOW
onOWi`03onKViP03onOWiooVi^Koi^KV00?oi^KV0_oWinL2onKViP03onOW
iooVi^KoinOW00?oi^KV00?oinOWonKVi_oVi^H00ooVi^H2onOWi`;oi^KV
00?oinOWonKVi_oWinL00_oVi^H2onOWi`03onSXj?oWinOoj>SX00;oinOW
0_oXj>P2onOWi`0@onSXj?oWinOoVi^KojBTY?n^[Zko][Jfokjn__o4a<Co
bLW9om3@d?oDe=CofMWIomgMgOoPh>3ohn?SonCTi0?oi^KV00?oiNGUonKV
i_oVi^H0>_oVi^H009Gok^k^017okNg]on[Zj_oXj>Soi>CTon7QhOoLg=co
emOGom7AdOo;bl_oa<C4okbl_?nd];CoZZZZoj6QXOohn?SomoOgooShn003
ooOgm`04ooShn?ogmoOomoOgooShn0;omoOg2_ofm_H00oogmoOom_KfooKf
mP0=ooKfmP03ooOgmoofm_Kom_Kf00Gom_Kf00GomoOgooKfm_ohn?SomoOg
ooShn003ooOgm`0CooShn?ogmoOomoOgooShn?ogmoOoXJ6QojZZZ_nc/k?o
_;blolC4a?o;bl_odM7AomSHf?oLg=cohN7QonCTi?oXj>Soj^[Zonc/k010
onk^kP00UOooool03_omoOgoo?clooShn?oemOGolO7aon_[jooWinOoh>3P
omWIfOoBd];obLW9ol71`Ong]kOo[:b/2oooool3ooknoPkooOgm00?oo_kn
oogmoOomoOd03OomoOd4ooknoP_ooooo00ko[:b/okNg]oo1`L7obLW9om;B
d_oIfMWoh>3PonOWioo[jn_olO7aooCdm?ohn?Soo?cloogmoD3ooooo002E
onk^kP0?onc/k?o[jn_oj>SXonCTi?oQhN7og=cLomOGeooAdM7ob/[:olC4
a?nl_;co/k>coj^[ZonQXJ7on?Sh00;omoOg00Con?ShooOgmoohn?SomoOg
0_ohn?P01OogmoOon?ShooOgmoofm_KomoOg01oom_Kf00ComoOgooKfm_og
moOon?Sh0_ogmoL01?ohn?SomoOgooShn?ogmoL2ooShn00@ooOgmoohn?So
XJ6QojZZZ_nd];Co_;blolC4a?o;bl_odM7AomOGeooLg=cohN7QonCTi?oW
inOojn_[ong]kD3ok^k^002EonKViP0?onCTi?oRh^;ogmoOomgMgOoJf][o
eMGEom3@d?o:b/[oa<C4okfm_Onf][Ko[Zj^ojBTY?nKVi_oinOW00;oj>SX
0_oWinL2onSXj003onOWiooXj>Soj>SX00;oinOW1_oVi^H01?oWinOoi^KV
onKVi_oWinL5onKViP03onOWiooVi^Koi^KV00Coi^KV00CoinOWonKVi_oV
i^KoinOW1OoVi^H00ooWinOoi^KVonKViP02onOWi`030>OWi`3Xj>P0j>SX
0080inOW01@0j>SX0?ooo`3oool0oooo0>SXj03WinL0Vi^K0:BTY02^[Zh0
]KFe0;fm_Oo3`l?ob/[:om7AdOoEeMGofMWIomgMgOoPh>3oh^;RonCTi0?o
i^KV00?oiNGUonKVi_oVi^H0>_oVi^H009Gok^k^00ookNg]on_[jooXj>So
i>CTon7QhOoLg=coemOGom7AdOo:b/[oa<C4okbl_?nd];CoZj^[oj2PX?oh
n?P00_ogmoL02Oohn?SomoOgooOgmoogmoOon?ShooOgmoohn?SomoOgooKf
mP02ooOgm`;om_Kf00?omoOgooKfm_ofm_H01_ofm_H00oogmoOom_KfooKf
mP04ooKfmP03ooOgmoofm_Kom_Kf00Kom_Kf00ComoOgooKfm_ofm_Kom_Kf
0oogmoL01P3hn?P0moOg0?Ogm`3hn?P0moOg0?ooo`8000000140oooo0?Sh
n03gmoL0X:2P0:ZZZP2d];@0_;bl0<C4a?o;bl_odM7AomOGeooLg=cohN7Q
onCTi?oWinOojn_[onc/k002onk^kP03ong]kOo^k^kok^k^03_ok^k^002E
ooooo`0>oogmoOokno_on?ShooGemOoalO7ok>c/onOWiooPh>3ofMWIom;B
d_o:b/[o`<30okNg]on/[:`;ooooo`;oo_kn0oomoOd00oono_kooOgmoogm
o@02oogmo@03ookno_omoOgooOgm00CooOgm00Goo_knoogmoOomoOgooOgm
ooknoP04oogmo@03ookno_omoOgooOgm00CooOgm00Coo_knoogmoOono_ko
o_kn1P3oool2000000<0oooo00h0[:b/0;Ng]`30`<00bLW90=;Bd_oIfMWo
h>3PonOWioo/k>colO7aooGemOohn?Sono_koogmoD3ooooo002Eonk^kP0D
onc/k?o[jn_oinOWonCTi?oQhN7og=cLomSHf?oAdM7obl_;olC4a?nl_;co
];Bdoj^[ZonQXJ7oCGk4odema?m>O/GoCGg4odinaOm=OL@3odina@03oden
a?m>O/GoCGg400;oC7g400goC7c3odema?m<O<?oC7c3odema?m<O<?oCGg4
odal`om<OL?oCGg4odam`om<O<?oCGg400;oC7c300?oC7g3odal`om=OL@0
0_m<O<<02Om=OLCoC7c3odema?m<O<?oC7g3odema?m<OL?oC7c3odema002
odal``03odama?m<OL?oCGk40080oooo00<0CWk504ema03oool00P000000
4P3oool0CWk504ena01>O/D0XJ6Q0:^[Z`2d];@0_;bl0<C4a?o:b/[od=3@
omSHf?oLg=coh^;RonCTi?oWinOojn_[ong]k@;ok^k^00?okNg]onk^k_o^
k^h0>oo^k^h009Goi^KV013oiNGUon?ShooOgmoogMgMomWIfOoDe=Cod=3@
ol_;boo4a<Co_KfmokNg]on][JgoYZJVoifMWOm<O<?oCGg40_m<O<<03_m<
OL?oC7g4odal`om<O<?oC7g3odal`om<OLCoC7g3odal`om;O<;oC7c3od]l
`_m;Nl;oC7c30_m;Nl82od]l`P;oBg_200[oBgc2od]k`_m;O<;oC7c3od]l
`_m;Nl;oC7c3od]l`_m;Nl;oC7c30_m;Nl82od]l`P;oBg_200CoBgc2od]k
`_m;O<;oC7c30_m;O<82odal``050?ooo`000000oooo04al``3oool00P00
00004P3oool0C7g304al``1<OL@0WIfM0:JVYP2^[Zh0]kNg0;jn__o4a<Co
bl_;om3@d?oDe=CofMWIomgMgOoOgmooh^;RonCTi43oi^KV002Eonk^kP0>
onc/k?oZj^[oinOWonCTi?oQhN7og=cLomOGeooBd];oc<c<olG5aOnn_[ko
]KFeojb/[?nSXj<2odId`00>odMd`?m7ML7oAWC0odMe`Om6M<3oAgG0odMe
`Om6M<3oAgG1odId`?m6LkooAWC0odIc_om5Lkl3odIc_`0:odId`?m6Lkoo
AWC0odEc_om6M;ooAWC0odIc_om6M<3oAW>oodEc_`;oAW>o00koAG>oodIc
_om6LkooAW>oodId`?m6LkooAWC0odEc_om6M;ooAWC0odIc_om6M<3oAW>o
odEc_`?oAWC000@0oooo000000000000oooo0P0000004`3oool0AgG004Me
`@16M<00AgG10:>SX`2[Zj/0]KFe0;fm_@34a<Coc<c<om;Bd_oHf=Sog=cL
on7QhOoTi>CoinOWon_[joo]kNd00oo^k^h00oo]kNgok^k^onk^kP0jonk^
kP00UOooool03_omoOgoo?clooShn?ofm_KolO7aong]kOoWinOohN7Qom_K
fooDe=Cobl_;ol?3`oni^KWo[jn_0_m@P<L01?m?P<KoD837odn0a_m?P<H2
oe20a`04odn0a_m@P<OoCh36odn0aP;oD83700KoCgo6odn0a_m?P<OoD837
odmoa_m?P<H2odmoaP04oef:bombV=7oF8G8odn0aP;oCgo60_m@P<L01_m?
OlKoCh36odn0aom@P<OoCgo6odn0aP;oCgo600KoCh37odmoa_m?OlKoDX77
ofB>cOmAPLL2oe20a`03odn0a_m@P<L0oooo00D000001@3oool03P2_[jl0
^[Zj0<?3``3;bl/0e=CDom_KfooRh^;oinOWong]kOoalO7omOGeooShn?ok
no_ooOgm@?ooool009Gok^k^013okNg]on_[jooXj>SoiNGUon7QhOoMgMgo
f=SHom?Cdoo=cLgoa/K6okno_ong]kOo[jn_ojFUYOmAPlKoDH?71OmBQ<L0
1?mAPlOoDXC7oe:4aomAQ<L5oe:4a`0;oe63a_mAPlOoDXC7oe:4aomcV]3o
h>SdooWjnooVk?Gon__lomCOl?mXTlh00omBQ<L01oo1d^[ob=O/oe63a_mA
PlOoDXC7oo7dn?nH]]d00_mBQ<L01_mFQlOo/LSUooSinoobmOWomOOjol7B
jP?oDXC700<0oooo0000000000001P000000403oool0DHC70:FUY@2_[jl0
]kNg0;no_`36a/Koc<c<om;Bd_oHf=SogMgMon7QhOoVi^Koj>SXon[Zj_o/
k>a0onk^kP00UOoVi^H04?oTi>Cohn?Son3Ph?oMgMgof][JomKFe_oAdM7o
c<c<olO7aoo1`L7o^KViok:b/_n[Zj_oXJ6Qodal`om<OL@3odal``03odam
a?m<O<?oCGg400;oC7c300?oCGg4odal`om<O<<00_m<O<<03Om=OLCoC7c3
odama?m<O<?oK9C=ooKgnOneb>CoDX75odema?mGQ<Ooa=?Yoo;dn?mNRLP0
0_m<O<<03onncnOoaMG[odal`om<OLCoC7c3onkbmonD/M[oC7g4odal`on_
aN?okO3foh6Rdom?OlGoDX75ofZBc@02odal``03odema03oool0000000H0
00000140oooo04al``1=OL@0XJ6Q0:ZZZP2b/[80^KVi0<71`Oo7alOoc<c<
om7AdOoFe]Kof][JomgMgOoPh>3ohn?SonCTi010onKViP00UOo^k^h0?oo/
k>coj^[ZonWYjOoUiNGoh^;RomkNg_oJf][oe=CDolk>c_o8b<So`L71ok^k
^onb/[;oZZZZodMe`Om6M<3oAgG1odMd`?m7ML7oAgG0odId`?m7ML7oAWC0
odMe`Om6M<3oAgG0odMe`Om6M<3oAgC0odId`?m7ML7oAWC0odMe`Oo=fNco
fnCbodMe`?m6M<3oAgG1odId`?m;N<7ojnofokW:i_m7ML7oAWC0okk=ioo4
d^WoAgG1odId`?m7ML7ol?;hoi:]f_m7ML3oCGW2oo[ko?nW_N3oAgG1odId
`?m7ML3oAgG1odId`?m7M<3oAWC00?ooo`060000000D0?ooo`16M<00AgG1
04Id`02ZZZX0/k>c0;Zj^P32`/80b<S8olo?cooDe=Cof][JomkNg_oRh^;o
i^KVonSXj?o[jn_ok>c/onk^k_o]kNdnonk^kP00UOooool03_omoOgoo?cl
ooWinOofm_Kolo?conk^k_oZj^[oiNGUomkNg_oHf=SodM7AolW9bOo1`L7o
^;Rh0om@P<L2odn0aP;oD83700?oCh36oe20aom?P<H01?m@P<L01om?P<Ko
D837oe20aom@P<OoFHO9oooooonL]ml00_m@P<L01Om?P<KoD837odn0a_n`
a^Gom?Ok00;oD83700?o`M?[olWIk_m@P<L00_m@P<L01oobmO[oV;CNoe20
aomaV=7ooooook_>jOnV_n800_nW_n801OnF/mgoD837odn0a_m@P<L0oooo
00D0000001<0oooo04n0aP1@P<L0Ch360520a`2h^;P0`L710<[:bP3AdM40
fMWIomkNg_oUiNGoj^[Zonk^k_obl_;om_KfooWinOokno_ooOgm043ooooo
002Eonk^kP0?onc/k?o[jn_ojNWYonKVi_oShn?ogmoOom_KfooFe]Kod=3@
ol_;boo5aLGo_KfmokNg]on_[jooDH?700GoDXC700?oDH?6oe:4aomBQ<L0
0_mBQ<L03?mAPlOoDXC7oe:4aomAPlOoDXC7oe63aomBQ<OoMIcBoogmoOn5
ZMOoDXC7oe63aP?oDXC700OoV[ONooclo?mQS/coDXC7ol7BjOo:fNgoDH?7
00;oDXC700KolOChoiVfgOmBQ<OoIi?=oogmoOo1d^X2ojW1hP06om_TlOoB
gnooDXC7oe63aomBQ<L0oooo100000000`3oool0DH?605:4a`0305:4a`0>
0:n_[`2f][H0_[jn0<C4a03;bl_odM7AomOGeooKfm_ogmoOon?ShooVi^Ko
jNWYon_[joo]kNd2onk^kP03ong]kOo^k^kok^k^03_ok^k^002EonKViP0?
onCTi?oShn?ohN7QomkNg_oLg=cof=SHomCDe?oAdM7oc<c<olK6a_o0`<3o
^[Zjok:b/_n/[:coC7g400CoC7c300OoCGg4odama?m<O<?oC7c3odama?m<
O<?oCGg400;oC7c30om<OL@01_m<O<?oLiS?oo_knomnXM?oCGg4odama0;o
C7c301GoC7g4oi:_f_olo?coGXW8odal`onnd>Son_[kohVXe_m<O<?oEX?6
oo[jn_n7YmGoCGg4odena?oSj_CoYkoPodama?m<O<?oe=o_ok?6i?m<O<<0
0_m<OL@01`3oool00000000000000000oooo04ema01<OL@00P1<O<<0401<
OL@0C7c30:b/[02b/[80^KVi0<71`@36a/Kobl_;om3@d?oEeMGof=SHomcL
g?oOgmoohN7Qon?ShooTi>@3onKViP03onGUiOoVi^Koi^KV03[oi^KV002E
onk^kP0Jong]kOo[jn_oj^[ZonKVi_oTi>CohN7QomgMgOoHf=SoeMGEolk>
c_o9bLWo`l?3okbl_?ne]KGoAgG1odId`?m7ML7oAgG0odMd`?m6M<3oAgG1
odId`?m7M<3oAgG1odId`?m7M<02odId`00>odMe`Om6M<3oAgG1odId`?mD
O/GooOgmoi6/f?m6M<3oAgG1odId`?m7M<3oAgG1ojFlgoodmoT2odId`00C
okk>ioo?f^god]c^oloJkOoFh?3omOOjodij`om6M<3oAgG1ogVJdOo`l_So
]<KUol7@jOoam?SoHXW9odId`?m7ML7oAWC00?ooo`020000000F0?ooo`17
M<00AWC004Me`@16M<00AgC004Me`@16M<00]KFe0;bl_032`/80bLW90<k>
c_oEeMGofMWIomgMgOoQhN7oi>CTonKVi_oZj^[ojn_[onc/k43ok^k^002E
ooooo`0>oogmoOolo?con_[jooShn?oemOGol_;bonk^k_oYjNWoiNGUon3P
h?oIfMWoe=CDolg=cOo6a/H3oe20a`03odn0a_m@P<OoCh3600;oD83700Co
Ch36oe20aom@P<OoCh360_m@P<L00om?P<KoD837oe20a`02oe20a`03omcV
looEh?7oCh3600;oD83700CoCh36oe61aooWkOOob=O/0_m@P<L02?moX]Go
PjGGoeN5b?n@[m_oXkgRofB>cOm@P<OoCh360_m@P<L01?m]U<ooYKkQojJn
homZTlh2oe20a`08odn0a_m@P<L0oooo0000003oool0Ch360520a`1?P<H2
0520a`0A04n0aP1@P<L0D8370<K6aP3=cLd0e=CD0=WIf@3Ph>3oiNGUon[Z
j_o^k^kol_;booGemOohn?Son_[jooclo?omoOd0@?ooool009Gok^k^017o
kNg]onc/k?oZj^[oinOWonGUiOoShn?ogmoOomcLg?oGemOodm?Colk>c_o8
b<So`l?3okfm_OmBQ<OoDH?7oe63aP03oe:4a`04oe64aomBQ<OoDXC7oe63
a`;oDXC700?oDHC7oe:4aomBQ<L00_mBQ<L03?mAPlOoDH?6ogbQe?olo?co
XkgPoe64aomBQ<OoEHK7okG9i_oinO_oJiG?oe64a`CoDXC700?oDH?7oe63
a_mBQ<L00_mBQ<L01?mAQ<OoDXC7oe:4aomAPlL2oe:4a`04oe64aomBQ<Oo
DXC7oe:4a`80oooo00D0DH?605:4a`1BQ<L0DXC70564a`0205:4a`0@0563
a`1BQ<L0_Kfm0<;2`P39bLT0c/k>0=?CdooHf=Sofm_KomoOgooShn?oi^KV
onSXj?oZj^[ok>c/ong]kD3ok^k^002EonKViP0AonGUiOoShn?ohn?Son3P
h?oOgmoog=cLomSHf?oFe]Kod];Bolg=cOo:b/[oaLG5okno_onk^k_oC7c3
odama?m=OL@00_m<O<<01?m=OLCoC7g4odal`om<OL@2odal``03odama?m<
O<?oC7g400?oC7c300goC7g4odema?m<O<?oOZ3BoncamooZkoGod=c]onka
m_oSj_CoLIO?odama?m<O<?oC7g400?oC7c300SoC7g4odema?m<O<?oC7c3
odema?m<OLCoC7c3odama0;oC7c300?oC7g4odal`om<OL@00om<O<<02?m<
OLCoCGg4odal`om<O<?oCGg4odama?m<O<?oC7g40_m<O<<02onk^k_o_kno
olG5aOo:b/[ocLg=om7AdOoFe]KofMWIomcLg?oNg]kohN7Q00;ohn?S00Go
iNGUonKVi_oVi^Koi^KVonGUi@0lonKViP00UOo^k^h03oo]kNgok>c/on_[
jooYjNWoi^KVonCTi?oRh^;ogmoOom_KfooHf=Sodm?Com3@d?o;bl_oaLG5
odMe`@02odId`008odMe`?m6M<3oAgC0odId`?m7ML7oAWC0odMe`Om7M<02
odId`004odMe`Om7M<3oAgC0odMe`@;oAWC000SoAgG0odId`?m:Ml7oJHk;
oh6PdomURl[oBWO1odMd`0;oAWC000CoAgG1odMd`?m7M<3oAgG10_m6M<00
2?m7ML3oAWC0odMd`?m6M<3oAgG1odId`?m7ML7oAgC00_m6M<001?m7ML7o
AgC0odMd`?m7ML42odId`00DodMe`?m6M<3oAgC0odId`?m7ML7oAWC0odMe
`Om7M<3oaLG5ol[:b_o@d=3oe=CDomOGeooLg=cogmoOon7QhOoTi>CoinOW
onWYjOoZj^X2ong]k@;ok^k^00?okNg]onk^k_o^k^h0>oo^k^h009Gooooo
00koo_knoogmoOolo?con_[jooShn?ofm_Kom?Cdoo7alOo]kNgoj^[ZonKV
i_oQhN7ogMgMomSHf0;oD83700?oCh37oe20aom?P<H00_m@P<L00om?P<Ko
D837odn0aP03oe20a`03odn0a_m@P<OoCh3600;oD83700?oCh37oe20aom?
P<H00_m@P<L00om?P<KoD837odn0aP03oe20a`03odn0a_m@P<OoCh3600;o
D83700?oCh37oe20aom?P<H00_m@P<L00om?P<KoD837odn0aP03oe20a`03
odn0a_m@P<OoCh3600;oD83700?oCh37oe20aom?P<H00_m@P<L04_m?P<Ko
D837odn0a_m@P<Oof=SHomgMgOoQhN7oi^KVon[Zj_o^k^kol?3`ooCdm?of
m_Kon?Shoo[jn_okno_ooOgmooknoT3ooooo002Eonk^kP;okNg]017ojn_[
onWYjOoYjNWoi^KVonGUiOoRh^;ogmoOomgMgOoJf][oeMGEom?Cdoo>c/ko
DH;6oe22a_mAP/OoDH;6oe62a`02oe62aP04oe62aomAP/KoDH;6oe62a`?o
DH;600OoD8;6oe62aomAP/KoD8;6oe62aomAP/KoDH;700;oDH;600CoDH;7
oe62a_mAP/KoDH;70omAP/H01om@P/KoDH;7oe62a_m@P/KoDH;7oe62a_mA
P/L00_mAP/H01?mAP/OoDH;6oe62a_mAP/L3oe62aP07oe22a_mAP/OoDH;6
oe22a_mAP/OoDH;6oe62a`02oe62aP0=oe62aomAP/KoDH;6oe62aoo>c/ko
d];BomKFe_oIfMWog=cLomoOgooRh^;oi>CTonKViP02onWYj@03onc/k?o]
kNgokNg]00;ok^k^00?okNg]onk^k_o^k^h0>oo^k^h009Koi^KV00ooi>CT
on?ShooShn?ohN7QomoOgooNg]kogMgMomWIfOoGemOoeMGEom7AdOo>c/ko
c<c<odal`om=OL@00_m<O<<03_m<OL?oC7g4odal`om<O<?oC7g3odal`om<
OLCoCGg4odama?m<O<?oCGg4odama?m<O<?oCGg40_m<O<<03_m<OL?oC7g4
odal`om<O<?oC7g3odal`om<OLCoCGg4odama?m<O<?oCGg4odama?m<O<?o
CGg40_m<O<<03_m<OL?oC7g4odal`om<O<?oC7g3odal`om<OLCoCGg4odam
a?m<O<?oCGg4odama?m<O<?oCGg40_m<O<<04Om<OL?oC7g4odal`om<O<?o
C7g3odal`om<OLCoc<c<olo?cooBd];oeMGEomSHf?oIfMWogMgMomkNg_oO
gmoohN7Q00;ohn?S00?oi>CTonGUiOoVi^H0?ooVi^H009Kok^k^00ookNg]
onc/k?oZj^[oj^[ZonWYjOoWinOoiNGUon?ShooQhN7ogmoOomcLg?oJf][o
e]KFodenaOm=O/@00_m>O/D00om=O/CoCWk5odena002odina@09odena?m>
O/GoCGk4odema?m=O/GoCGk4odema?m=O/GoCGk400;oCWk500?oCGk4odin
aOm=O/@00_m>O/D02Om=O/CoCWk5odena?m=OLCoCGk5odena?m=OLCoCGk5
odena002odina@03odena?m>O/GoCGk400;oCWk500WoCGk4odinaOm=O/Co
CGg4odenaOm=O/CoCGg4odenaOm=O/@00_m>O/D00om=O/CoCWk5odena002
odina@0?odena?m>O/Goe]KFomWIfOoLg=cog]kNon7QhOoShn?oiNGUonSX
j?oYjNWoj^[Zon_[joo/k>cokNg]00Cok^k^00?okNg]onk^k_o^k^h0>_o^
k^h009Kooooo0_ono_h02oomoOgono_koo[jn_ohn?SomoOgooKfm_oclo?o
lO7aono_koo[jn_oj^[Z00;ok^k^00CokNg]onk^k_o]kNgokNg]0_o^k^h0
1?o]kNgok^k^ong]kOo]kNd2onk^kP06ong]kOo^k^kok^k^onk^k_o]kNgo
k^k^0_o]kNd2onk^kP04ong]kOo^k^kokNg]ong]k@;ok^k^00KokNg]onk^
k_o^k^kok^k^ong]kOo^k^h2ong]k@;ok^k^00CokNg]onk^k_o]kNgokNg]
0_o^k^h01_o]kNgok^k^onk^k_o^k^kokNg]onk^kP;okNg]0_o^k^h03_o]
kNgok^k^ong]kOoZj^[ok>c/oo3`l?oalO7olo?cooKfm_ohn?SonOWioo[j
n_okno_oo?cl0_ono_i1ooooo`00U_o^k^h03Oo]kNgok>c/onc/k?o[jn_o
j^[ZonWYjOoXj>SoinOWonGUiOoShn?ohN7QomoOgooNg]h00oohn?P00ooi
nOWon?ShooWin@03ooShn003ooWinOohn?Son?Sh00;on?Sh00?onOWiooSh
n?ohn?P00_ohn?P00ooinOWon?ShooWin@03ooShn003ooWinOohn?Son?Sh
00;on?Sh00?onOWiooShn?ohn?P00_ohn?P00ooinOWon?ShooWin@03ooSh
n003ooWinOohn?Son?Sh00;on?Sh00?onOWiooShn?ohn?P00_ohn?P00ooi
nOWon?ShooWin@03ooShn00?ooWinOohn?Sog]kNon3Ph?oQhN7oi>CTonGU
iOoVi^KoinOWonWYjOoZj^[ojn_[ong]kOo/k>cokNg]047ok^k^002GonKV
iP06onGUiOoTi>Cohn?Son?ShooRh^;ohN7Q0_oOgml01_oMgMgog=cLom_K
fooIfMWono_kooclo0?ono_k00?oo?cloo_knoolo?`00_okno/00oolo?co
no_koo_kn`02oo_kn`03ooclo?okno_oo?cl00?ono_k00?oo?cloo_knool
o?`00_okno/00oolo?cono_koo_kn`02oo_kn`03ooclo?okno_oo?cl00?o
no_k00?oo?cloo_knoolo?`00_okno/00oolo?cono_koo_kn`02oo_kn`03
ooclo?okno_oo?cl00?ono_k00?oo?cloo_knoolo?`00_okno/02Oolo?co
fMWIom_KfooLg=cogMgMomoOgooPh>3ohN7Qon;RhP02on?Sh`03onCTi?oU
iNGoiNGU047oi^KV002Gonk^kP06ong]kOo/k>cokNg]onc/k?o[jn_oj^[Z
0_oYjNT02?oWinOoi^KVonCTi?oTi>ConOWiooShn?oinOWon?Sh0_oinOT0
1?ohn?SonOWiooShn?oinOT2ooShn008ooWinOohn?Son?ShooShn?oinOWo
n?ShooWinOohn?P2ooWin@04ooShn?oinOWon?ShooWin@;on?Sh00SonOWi
ooShn?ohn?Son?ShooWinOohn?SonOWiooShn0;onOWi00Con?ShooWinOoh
n?SonOWi0_ohn?P02?oinOWon?ShooShn?ohn?SonOWiooShn?oinOWon?Sh
0_oinOT02_ohn?SonOWiooShn?oinOWon?ShonCTi?oUiNGoi^KVonOWiooX
j>P2onWYj@03on_[joo/k>cokNg]00;okNg]@_o^k^h009Oooooo0_ono_h2
oogmo@08ooclo?okno_ono_koo[jn_oinOWon?ShooOgmoofm_H2ooCdm0;o
l_;b00ColO7aoo3`l?o_knook^k^1?o]kNd00oo/k>cojn_[onc/k003onc/
k003on_[joo/k>cok>c/00?ok>c/00?ojn_[onc/k?o/k>`00_o/k>`00oo[
jn_ok>c/onc/k002onc/k003on_[joo/k>cok>c/00?ok>c/00?ojn_[onc/
k?o/k>`00_o/k>`01_o[jn_ok>c/ong]kOo]kNgok^k^ong]k@;okno_00[o
l?3`oo7alOobl_;ol_;booCdm?oemOGom_KfooOgmoohn?SonOWi0_ojn_X2
ooclo004ookno_omoOgoo_knooknoT;ooooo002Honk^kP08ong]kOo^k^ko
k>c/ong]kOo/k>coj^[Zon_[jooZj^X2onWYj@;oinOW00?oi^KVonGUiOoT
i>@00_oTi>@2on?Sh`;oh^;R0_oQhN400ooRh^;ohN7Qon7Qh@02on3Ph003
on7QhOoPh>3oh>3P00;oh>3P00?ohN7Qon3Ph?oQhN400ooPh>000ooQhN7o
h>3Pon3Ph002on3Ph003on7QhOoPh>3oh>3P00;oh>3P00?ohN7Qon3Ph?oQ
hN400ooPh>000ooRh^;ohN7Qon7Qh@02on7Qh@;oh^;R00Gohn?Son;Rh_oT
i>CoiNGUonCTi003onKViP03onOWiooYjNWojNWY00;oj^[Z00Cojn_[onc/
k?o/k>cok>c/0_o]kNe3onk^kP00oooVi^H]onKViP00k_o^k^h00oo]kNgo
k^k^onk^kP0konk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00k_oVi^H0
0ooUiNGoi^KVonKViP0konKViP00ooo^k^h]onk^kP00ooooool]ooooo`00
kOo^k^h00oo]kNgok^k^onk^kP0lonk^kP00oooVi^H]onKViP00ooo^k^h]
onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^
k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00
ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKV
iP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]
onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooV
i^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00
oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^
kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]
onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^
k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00
ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]oooo
o`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]
ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00oooo
ool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00
ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00oomoOgl]ogmo
O`0000Cojn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP06omgMgOoNg]kogMgM
omkNg_oMgMgog]kN0_oMgMd0N_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkogMgM0_oLg=`0S_oKfm_ogMgMomcLg?oMgMgogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]h3omgMg@?og]kN00?ogMgMomkNg_oNg]h00ooMgMd1on7Qh@7oinOW0OoZ
j^X00003onc/k?oVi^Koh>3P00OofMWI00Cof=SHomKFe_oCdm?od=3@0oo=
cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?Com3@d0?o
cLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03
olg=c@04om3@d?oCdm?oemOGomSHf3cofMWI0_oHf=P00ooIfMWof=SHomSH
f003omWIf@;of=SH1OoIfMT00ooHf=Soe]KFom?Cd`02om?Cd`03omKFe_oH
f=Sof=SH00kofMWI00Cof=SHomWIfOoIfMWof=SH4?oIfMT2omSHf6SofMWI
00?of=SHomWIfOoIfMT01_oIfMT1omgMg@7oi^KV0Oo/k>`00007onk^k_oY
jNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=codm?ColO7
aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=
omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?o
fm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb
/[;o^k^kolO7aooCdm?ofm_KomoOg`0]on7Qh@[oh>3P00?ogmoOon3Ph?oP
h>001_oOgml2on3Ph0?ogmoO1OoPh>001ooOgmoofm_KomOGeooDe=CoeMGE
omWIfOoMgMd00_oPh>000ooOgmooh>3Pon3Ph002on7Qh@Ooh>3P1_oOgml0
0ooPh>3ogmoOon3Ph00;on3Ph004omoOgooNg]kog]kNomoOg`;oh>3PIooQ
hN400ooRh^;ohN7Qon;RhP04on7Qh@7oi>CT0OoYjNT1onc/k00000?ol?3`
ono_kooalO400oo`l?00J_o_knool?3`onk^k_oYjNWofm_Kol71`OnTY:Co
S8b<og]kNomgMgOoNg]kohb<S?nSXj?o`/;1om[Jf_oZj^[okNg]oo7alOo_
knoolO7aono_kooalNookno_oo7alOo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<
RomkNg_oMgMgog]kNon<S8coY:BTol;2`_oJf][oj^[Xong]kOoalO7okno_
oo7alOo_knoolO7aono_kooalNookNg]on[Zj_oJf][o`/;2ojBTY?n<S8co
Ng]kogMgM_mkNg_oS8b<ojBTY?o2`/;of][Jon[Zj_o]kNgolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_koo`l?02onc/k007on_[
joo^k^cok>c/ong]kOo/k>cok^k^on[ZjP02on_[j`0:onk^k?oYjNWoj>SX
onKVi_oYjNWoi^KVon[Zj_o[jn_okNg[onSXj0;ojNWY00OokNg]on[Zj_o/
k>cok>c/ono_kOoZj^[oj>SX00;ohn?S00gogmoOon?ShooXj>SokNg[on[Z
j_o[jn_ok>c/oo3`l?o_knool?3`ong]kOo/k>[oj^[Z00;ok^k^00Kokno_
on[Zj_oYjNWoi^KVonSXi_oWinL2onWYj@06onc/k?oYjNWok>c/ong]kOo^
k^coj^[Z0_o/k>`02?o^k^koj^[Zonc/k?o/k>cokno]on_[jooYjNWoi^KV
0_oXj>P2ong]k@1_oo3`k_o_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aonk^k_oalO7ol?3`ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l?3okno_00;ol?3`00000oobl_;ok^k^onOWi`04onGUi@0@onCTi?oOgmoo
dM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:ROna
/K7odM7AomkNgP;oi>CT00?oiNGUonCTi?oUiN@00_oTi>@03ooNg]kodM7A
ok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7o
dM7@omkNgP02onCTi012onGUiOoTi>CoiNGUonCTi?oTi>?og]kNom7AdOna
/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6aom7A
dOoNg]koi>CSonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oShn?og]kN0_oKfm/02_oNg]gog=cLom_KfooLg=cogmoOom_KfooIfMWo
g=cLomgMg?oGemL3omGEe@04omCDe?oIfMWogMgMomgMg0;oemOG01;ofm_K
omgMgOoJf][of][JomkNg_oQhN3ofm_KomSHf?m6ATKo<30`ogQhN?o2`/;o
f][JomkNgOoJf][ofMWIomgMgOoShn<2onCTi00FomoOgooLg=_ofMWIomoO
gooRh^;ohN7Qom_KfooFe]Koe=CDomKFeOoDe=Coe]KFom_KfooLg=cof=SH
omcLg?oOgmoogmoNomWIfOoKfm_og]kNomoOg`;of][J06oogMgMon3PgooK
fm_oemOGomGEeOoGemOofMWIomoOgooRh^;oi>CSonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>@01?oUiND01_oTi>CoiNGU
onGUiOoUiNGoj>SXong]k@7ol_;b00000oodm?CokNg]onOWi`02on3Ph00C
on7QhOoOgmoog]kNom;Bd_nd];CoQhN7oeaLG?m]>cGoWTi2ole_GooYPfoo
cFmOoii>@om/>SGoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomkNg_oB
d];o];BdohN7QomLG5coKF0/oijF;_o=cCoojNU=olg=?onNVRooKF<]oeaL
G?n7QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aL
odMW;_mXWS?oTLe7oj[YEOnAcDOoJYhdodUZ;omLG5coQhN7okBd]?oBd];o
g]kN02_oh>3P04?og]kNomSHf?oBd];oe=CDomKFe_oBd];oclo?om;Bd_oF
e]Kodm?Com7AdOoEeMGoe]KFom3@d?o4a<Cobl_;olo?coo9bLWoa<C4omSH
f?oEeMGod=3@olC4a?o@d=3of=SHom;Bd_oAdM7of=SHom_KfooFe]KodM7A
oiFEUOnPX:3o?Shnod];BooDe=Cof=SHom;Bd_oAdM7of=SHomkNg_oPh>3o
gmoOom[Jf_oCdm?odM7AomSHf?oMgMgof][Jom?Cdoo?cloo`<30om3@d?o=
cLgo_knoomCDe?oFe]KodM7AomCDe?oIfMWof=SHom7AdOoBd];of=SHomWI
fOoCdm?odM7A00;oemOG00SodM7Aolo?coo8b<Soa<C4omSHf?oKfm_og]kN
omoOgf;oh>3P00CogmoOon3Ph?oOgmooh>3P0ooOgml3on3Ph003on7QhOoW
inOok>c/007om?Cd00000oofm_Kol_;bon_[j`03onSXj00ConOWiooRh^;o
cLg=oinOWom[GeooScH^oneaHOoiWI3ooK6Uoofl[oom]:OonInConedHonB
=booJemOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinO
Wom^IUooTg8RongAA?oilgCooOf=oogmUOomoHkonOQfongGAonCLb;oKVMO
oinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWomPJ5oo
Bg`Soi;QBonmnG_od?fBomSmVooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=
cLgoh^;RonOWi`0ZonSXj00YonKVi_oOgmoo<30`ohn?SooKfm_oalO7ohR8
R?o5aLGofm_KojFUYOl10@7ogMgMomkNg_m]KFgo20P8oa4A4OmcLg?o<30`
ob@T9?oMgMgofm_Kod];Bol<30coHV9Ron7QhOm]KFgo>SXjomoOgooShn?o
`l?3o`000?o1`L7ohN7Qoj2PX?l=3@goemOGomkNg_mmOGgo5aLGomgMgOoT
i>@00_oVi^H05?oRh^;oOgmoobPX:?oOgmooiNGUon?Shonf][Ko7alOo`T9
2Olf=SKoM7Ado`P82?nFUYKogMgMo`l?3onGUiOohN7QomoOgom2@T;oI6AT
0_oPh>003?meMGGo<S8bomgMgOoKfm_o_[jnoc`l??l20P;o7alOoaDE5Ond
];Coi^KVonOWifgoj>SX0Oo/k>`1oo7al@7om_Kf00000oogmoOon?ShooSh
n003ooShn00CooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFoo^BQoonYY_oo[6U
oonhZoon/jKooZRLoo^DROo^J5WoRC4[oi2@T?o>c/kok^k^ooOgm`03ooSh
n00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_PK_onm8;oo_j:ooooT_on
oXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOg
moo^k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSoc_j@omKoUoo@oY;oa_j9
ok;eM?n8dd?oA7D[oi2@T?o>c/kok^k^ooOgm`0ZooShn00_ooKfm_o_knoo
<c<coiVIVOoWinOoPh>3o`000?mlO7coj>SXok2`/?l10@7okNg]on?Shol6
1PKoXZ:RomgMgOmgMgOo0000olk>c_o`l?3o`/;2o`000?oAdM7om?Cdoo7a
lOmeMGGo?Shnonk^k_obl_;od=3@o`000?o?cloolO7aolS8b?l0003o`l?3
onk^k_n6QXKo6ATIonWYjOo_knool_;booCdm?oalO7oR8R8ob/[:oo^k^h0
0_oemOD07?mTI6Co?cloonGUiOnc/k?o7alOofMWIoo_knookNg]oa0@4?nR
XZ;ol?3`ono_kom7AdOoJf][ono_koo`l?3oOWinocDe=Oo[jn_oj>SXocLg
=om4A4Coc/k>onOWiooMgMgoi>CTooGemOogmoMVooShn0;omoOg0oohn?P0
1?ogmoOonOWiooOgmoogmoL1ooShn00000?on_[jooGemOo^k^h00_o/k>`0
ZOo[jn_ojNWYomoOgonj^[[oNE9Boklb9?oWM6WooHUnoonHS?onXYKoojRL
oojTV?ooVHcooXYoonifJ_o3<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>co
jn_/on[Zj_oOgmoo^[ZjohQUD_oRTAconL=@oogJHooojW;oo_=nooojP_on
mWooonacookNI?ojae7ohY8LohUVDonj^[[ogmoOon[Zj_o[jn_ok>c/on_[
jooZj^[ogmoOokZj^_mBKE;oDJ<Loi7BEOnVif[o^?Ujol3nP_o7ohWo`oj4
okWmNonWk6coU=IGoe:V7?mBKE;o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojNWYon?Shol`<33oT92@omSHfOl];Bgo
@410ob<S8ooJf][oYZJVo`410OoQhN7ohn?Toa0@4?mlO7cogmoOokBd]?l0
003odM7AonCTi?nHV9Wo3`l?on3Ph?oWinOohn?Sofm_Kolk>c_ogmoOon7Q
h_o3`l?o0000olG5aOoTi>Co_knoo`000?nh^;SohN7RogmoOolG5aOofMWI
omgMgOoQhN7oiNGUonCTi?n1PH7o:2PXomoOgooVi^Koj>SXogAdM?lO7aoo
fMWIomcLgOlk>c_oKfm_onCTi?oPh>3o3`l?oiRHV?oQhN7ogmoPod=3@omU
IFD00_oPh>00KomgMgOo<S8bon3Ph?nh^;Wo0000ojRXZ?oLg=cofMWIom_K
fooQhN7ojNWYon[Zjoo/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k007on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H00Oohn?P00003oo_k
nooclo?okNg]00;oiNGU0;3oi^KVonCTi?oIfMWo/[:bogT^;_o8@SCohfYL
ooAjKOomR7cooYN:oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;o
f=SHonCTi?oUiNGoi^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^lA?on
c5?ooMQRookSL_onjGGoo^IcookKIOomc5?onl55onjN:onIERko/[:bomSH
f?oTi>CoiNGUonKVi_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on6bDOoUmaI
ojGUJOnblgOo^?IkokCeNOnWjV_oV=aIohW?BomS[R_o;V<^ok:b/_oHf=Wo
i>CTonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVon?ShooMgMgo
;bl_oh^;Rona/K;o0000okNg]olU9BGoZ:RXoj2PX?l10@7og=cLon3PhOnb
/[;o>CTiobDU9Olk>c_o0000olg=cOoMgMgoTi>Doa0@4?oFe]Kog]kNomcL
g?m/K6co>CTiomCDe?oFe]Oo_;blo`000?o2`/;ogmoOok^k^ol0003o];Bd
omcLg?mlO7co5aLGomKFe_oJf][og]kNon3Ph?oOgmooOGenobLW9ooEeMGo
g=cLomkNg_oKfm_oI6ATob0P8?ll?3co4a<Cofe]KOoPh>3og=cLo`l?3onC
Ti?oemOGomGEe_m1@D7oHV9RomOGeooFe]KoLg=coc4a<OoMgMgoVYZKo`00
00Co=cLg06Oo/[:bonCTi?oTi>Goi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGU00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooU
iNGokNg]ooCdm001oo_kn`0000?oo?clooShn?oalO400oo^k^h04oo[jn_o
hN7Qokbl_?mj5aOo`clbom=FBOoSIeWokgM/ooB3NOohQgcomHAjoo=iKOoU
JE_ofEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl
_?nUAaOoiYLbooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlb
onVK<_nUAQOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOo
GjPbogFm=_n6cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lG
FAOo_;blon7QhOo/k>`0:_o^k^h09oo/k>coiNGUoc4a<On?ShooKVi^ob`/
;?oXj>SoOGemoeiNG_nTY:Co0@41on?ShooYjNWoi^KVon;Rh_oPh>3o[Jf]
o`000?oGemOoi>CToiRHV?l@413ogMgMon?ShooTi>CoL71`ob@T9?oFe]Ko
gmoOokno_ol0003obl_;onWYjOo1`L7o0000okZj^_oTi>CoPH61o`H61P03
ochn?P0Rol_;booYjNWoQ8B4oaXJ6_oJf][oh^;RonGUiOoWinOohn?Son3P
h?oHf=So=cLgog9bL_oZj^[oinOWo`l?3on:RX[ogmoOomkNg_m3@d?oEUIF
on3Ph?oOgmooMgMgoc<c<ooYjNWo_[jno`000?nPX:3o][JfojZZZ_l20P;o
fMWIong]kFSok^k^0_o]kNd3onk^kP03ong]kOobl_;on?Sh007oo?cl0003
oogmo@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@
@ooJHUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];olo?c
ooclo0?ooOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWomJPYooRd?ooi
_D[on;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?oo?cl00?o
oOgm01?oo?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:cE3oSLeB
oh[>D?n1adCoLKT_of:^8?m>VcCo1d87om;Bd_oclo?oo?cl02[ooOgm04co
no_kooCdm?ld=3CoUiNGoalO7on7QhOon_[jomgMgOlC4a?oZJVYo`410Oob
l_;onOWiol30`?o4a<Colo?cohb<S?lQ8B7on_[jooGemOnMWIgo410@onKV
i_o^k^kom?CdogQhN?lA4A7oC4a<ol[:b_n9RHWo51@DooKfm_oinOWoc/k>
o`000?o6a/Kolo?cohV9ROlC4a?o][JfokVi^Onj^[[okNg]ooWinOn?Shoo
30`<oeMGEooAdM7okNg]onc/k?nVYZKoi^KVonCTi?lB4Q;o[Jf]oo_knooj
n_[o410@oahN7_nUYJGog=cLoaXJ6_lP823oOGemomkNg_m7AdOoGemOoo_k
noojn_[o=3@dog5aLOo^k^koSXj>ocDe=Ookno_oo?clJoomoOd00oolo?co
oOgmooclo003oogmo@0003[ooOgmoo[jn_oclo?ok^k^oo3`l?o_knook^k^
onWYjOoCdm?oFadMoj8d=?nd:1go`CX]olM9??o?ET[od5M;om1GB_o:BSko
`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_onk^k_oZ
j^[odm?Coh`U7Oo8LCCofH@MonBD5OoWWBCokZPcoo2Z=?o_ZS?ok:0UonNG
5OoLR1gob74doh`U7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`l?o^k^koj^[Y
om?CdolM>1go=88dodNE7OmJYA_oJJdZ0_md^3P0OOme^CSoJk4[oe^W7?m8
VQgo=88doadh7OoCdm?oj^[Yonk^k_o`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo^k^koinOWoc4a<OmOGeoo0@41om;Bd_o^k^kok>c/od51
@OmQHF7o0@41onKVi_o^k^goX:2PocTi>OlA4A7o9RHVoiRHV?o_knooaLG5
oa0@4?l10@7o6ATIoe9BD_oYjNWoLG5aocdm?OnGUiOo7alOoaPH6?nATI7o
k^k^ong]kOo3`l?o0000okbl_?oXj>OoPX:2oaPH6?oOgmooh^;Ron?ShooW
inOojn_[oi>CT_lo?cooTY:BoaLG5onDU9Coh>3Podm?ColO7aoo4A4Aodm?
CooXj>Sok^k^ono_kolW9bOoX:2Podi>C_l92@Wo=SHfon3Ph?m^KVko3`l?
ob`/;?nn_[kok^k^ono_k_oBd];o?3`lo`/;2olM7Ago/[:b00;okno_06Ko
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knl2oo3`l0Kokno_0Ooclo<1ooWin@7oo_kn00000oono_komoOgoo3`l004
onWYj@0AonOWiooKfm_oHd];oh4b<_nV=CGo]S@]ol9=@Oo3E4Woa5E:ol=D
BOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooWinL01OoYjNT04OoWinOofm_K
ohU;Bon_Bc;ocGLeomJ;;OoPW2koh:0bon6P=?oPX3;ogiX^omJ;;Oo:MCGo
[d/bohU;BooKfm_oinOW00GojNWY017oinOWom_Kfom;Bd_o<V0bocZ9=OmC
VbgoJj/_og2]>?m_[S[oL:dhofVY;_mCVbgo>HPeoc9P<_m;Bd_ofm_KonOW
i`0[onWYj@0=onSXj?oTi>Co<30`oa8B4_ll?3coi^KVonSXj?oWinOoTi>C
oa4A4Ol10@7ohn?SonOWi`02onWYj@03onOWiooYjNWojNWY00;oj>SX01Co
WIfMoa0@4?oWinOoinOWonCTi?m_Kfoo>c/kon?ShooWinOoj>SXonWYjOoX
j>SoinOWol;2`_l0003o^[ZjonCTi?n0P83o5aLGomgMg@;og]kN00?ohN7Q
onKVi_oXj>P00_oYjNT00ooXj>SoinOWonWYj@02onWYj@03onOWiooYjNWo
jNWY00GojNWY00Goj>SXonWYjOoYjNWojNWYonOWi`06onWYj@03onKVi_oY
jNWojNWY06GojNWY00Goj>SXonWYjOoYjNWojNWYonSXj006onWYj@7ol?3`
0OogmoL1ooknoP0000Goo_knoo[jn_odm?Cokno_oo7al@02oo3`l00Aono_
koo[jn_oUIBDodlS8onEE5Co^g=com>EUOoJW9cofYjLomVLW?oDUIGo^g=c
oiEDE?m?8b?oUIBDon[Zj_o_knl01Oo`l?004Oo_knooj^[ZojVDU?n18b?o
^VYDomBJLooT_9Goj/NLonW7W?oZaicoiKbEomBJLonkJUCoPB<SojZDU?oZ
j^[okno_00Gol?3`017okno_on[Zj_nDU9Co8bXSoeAjE?mcYG?oW/JEojc>
W?n]cYco[<jLoik6UOmcYG?oE7YDob<Z8onDU9Coj^[Zono_k`0[oo3`l005
ono_koo^k^ko<S8bo`000?nCTi<00oo_knl01OoTi>Co2`/;o`410Oo^k^ko
kno_00Ool?3`00Wohn?Sokno_oo_knookno_onk^k_mdM7Co?Cdmong]kOo_
knl00oo`l?001oo_knoob/[:o`000?o3`l?ok^k^ohJ6Q_l92@T00omNGUh0
0omiNGWok^k^ono_k`27oo3`l008ono_koo`l?3ol?3`oo3`l?oalO7ol?3`
ooCdm?oinOT1ooknoP0000Cok>k`ooooooooooooo_kn0_ooool2ooknoP1^
oogmoOohn?SoKVi^oeXo?onaT93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93o
FSloofe]KOohn?Soo?clooooooono_koooooookno_ooookoo_knoooooool
o?con?Shohe]KOn:?coobI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo
?on=KFgon?Sgooclo?ooooooo_knooooooono_koooooookno_ooookoo?cl
ooShn?m]KFgo?clooi2MT?o9eLWoi>cTonK^i_oSjn?obMG9oi2MT?lo?coo
KFe]ooShn?olo?coooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_oooooooOgmojn_[onHV9SolO7`oogmoOooool2ooknoP0FokBd
]?nJVY[ooOgmooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_oooooooOgmookno_mlO7co@D51oogmoOono_goo_knooooo`;oo_kn
09?ok^k^oiVIVOo[jn_oo_kmom7AdOnIVIWoV9RHoiVIVOnHV9So[:b/oogm
oOooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_h00_ooool00oono_koooooooooo`03ooooo`7ooOgm00001?o1b<ko
o_knoo[jn_odm?@5oo7al@0=ono_kooFe]KoJf][od<m?OnKS8coa[ZjomK<
c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7al@0=ono_kooGe]KoPf][
og@m?OneS8coeKZjon7<c?oF^[[o]Xb<og8m?On1Jf_oemKFono_k`09oo7a
l@0=ono_kooFe]KoJf][ocdm?On<S8co^[Zjolc=c?nj^[[oS8b<ocdm?Om[
Jf_oe]KFono_k`16oo7al@03onk^k_o]kNgolO7a09?olO7a00?ol?3`oo7a
lOo`l?000_oalO400oo`l?3olO7aoo7al@02oo7al@03ooCdm?ojn_[oo_kn
007om_Kg00001On4SiWooOgmooShn?o`l?3ojn_[00?oj^[Z00gojNWYon[Z
j_oYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY
00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo@RHVofUIFOnPVi_o
j>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mI
FEWoVi^KonSXj?oYjNT0i_oZj^X01?o[jn_ol?3`ooOgmoomoOd1onOXj000
00Co=TIAokS0aOoinOWom?Cd2?oalO42oo3`l0?okno_0_o`l?0?oo7al@;o
l?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`i?oalO400oo_knoo
lO7aoo7al@02oo7al@03ooGemOojn_[on_[k007o_l3000000olM;cooC5US
okVoa@3oooooobOooooo0Oohn?T1olG6aP7ob/_<00001_lL;Sgo6RTeoc8l
A_mnR93o_L?8on_/k_oooooo8Oooool01Oo/kNko`lK8ohJ;Solj?dGo9R/c
007o;C4j0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{300, 200},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleJPopupMenu",
        ButtonData:>{"SimpleJPopupMenu.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell["\<\
Try right button click (Win) or ctrl+click (Mac) on the \
frame.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SimpleJPopupMenu[]\)], "Input"],

Cell[BoxData[
    \("One"\)], "Print"],

Cell[BoxData[
    \("Two"\)], "Print"],

Cell[BoxData[
    \("One"\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JToolBar <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h1P00`40o`00
0?l0003oo`000?l00022000000000hS0^4R@R4R@R03oB928odR@R7i8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^7f8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;QmR<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<coc<c<N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<olc<c7[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
N/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c7[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0lc<c005IVIVc<c<c<c<c<c<
IVIV00?<c<`00fIVI/c<c<c<c03oc<c<olc<c6c<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c005ooooc<c<c<c<c<c<oooo00?<c<`00ooo
olc<c<c<c03oc<c<olc<c6g<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1Lc<c005IVIVc<c<c<c<c<c<IVIV0?o<c<coc<c<L<c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P4c<c<00Goooo<c<c<c<c<c<coool0olc<
c?o<c<aac<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?<c<`01FIV
I/c<c<c<c<c<c6IVIP03c<c<00=VIVK<c<c<c<`0olc<c?o<c<a/c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`01Oooolc<c<c<c<c<c?oo
o`03c<c<00?oooo<c<c<c<`0olc<c?o<c<a]c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`01FIVI/c<c<c<c<c<c6IVIP3oc<c<olc<c73<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1<c<c005ooooc<c<c<c<
c<c<oooo0?o<c<coc<c<LLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c003IVIVc<c<c<c<0?o<c<co
c<c<K<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00Goooo<
c<c<c<c<c<coool00lc<c003ooooc<c<c<c<0?o<c<coc<c<KLc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00EVIVK<c<c<c<c<c<aVIVH0
olc<c?o<c<a`c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
1Oooolc<c<c<c<c<c?ooo`3oc<c<olc<c77<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`00fIVI/c<
c<c<c03oc<c<olc<c6c<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c005ooooc<c<c<c<c<c<oooo00?<c<`00oooolc<c<c<c03oc<c<olc<
c6g<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c005IVIVc<c<
c<c<c<c<IVIV0?o<c<coc<c<L<c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P4c<c<00Goooo<c<c<c<c<c<coool0olc<c?o<c<aac<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0?<c<`01FIVI/c<c<c<c<c<c6IVIP03
c<c<00=VIVK<c<c<c<`0olc<c?o<c<a/c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00?oooo<c<c<
c<`0olc<c?o<c<a]c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`01FIVI/c<c<c<c<c<c6IVIP3oc<c<olc<c73<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1<c<c005ooooc<c<c<c<c<c<oooo0?o<c<coc<c<
LLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3c<c<00EVIVK<c<c<
c<c<c<aVIVH00lc<c003IVIVc<c<c<c<0?o<c<coc<c<K<c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00Goooo<c<c<c<c<c<coool00lc<
c003ooooc<c<c<c<0?o<c<coc<c<KLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P5c<c<00EVIVK<c<c<c<c<c<aVIVH0olc<c?o<c<a`c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0C<c<`01Oooolc<c<c<c<c<c?oo
o`3oc<c<olc<c77<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0lc<
c005IVIVc<c<c<c<c<c<IVIV00?<c<`00fIVI/c<c<c<c03oc<c<olc<c6c<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c005ooooc<c<c<c<
c<c<oooo00?<c<`00oooolc<c<c<c03oc<c<olc<c6g<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h1Lc<c005IVIVc<c<c<c<c<c<IVIV0?o<c<co
c<c<L<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00Goooo<
c<c<c<c<c<coool0olc<c?o<c<aac<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00=VIVK<c<c<c<`0
olc<c?o<c<a/c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
1Oooolc<c<c<c<c<c?ooo`03c<c<00?oooo<c<c<c<`0olc<c?o<c<a]c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`01FIVI/c<c<c<c<c<
c6IVIP3oc<c<olc<c73<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1<c<c005ooooc<c<c<c<c<c<oooo0?o<c<coc<c<LLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P3c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c003
IVIVc<c<c<c<0?o<c<coc<c<K<c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00Goooo<c<c<c<c<c<coool00lc<c003ooooc<c<c<c<00C<
c<a@oooo2lc<c4?oooooc<c<b/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P5c<c<00EVIVK<c<c<c<c<c<aVIVH01/c<c003IVIVc<c<IVIV04eV
IVH00oooolc<c<c<c008c<c<00=VIVK<c<aVIVH0@6IVIP03ooooc<c<c<c<
0?o<c<c8c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0C<c<`01Ooo
olc<c<c<c<c<c?ooo`07c<c<00=VIVKoooo<c<`0C<c<c003IVIVooooc<c<
00W<c<`00fIVI_ooolc<c00oc<c<00=VIVKoooo<c<`0olc<c<W<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0lc<c005IVIVc<c<c<c<c<c<IVIV
00?<c<`00fIVI/c<c<c<c002c<c<00=VIVKoooo<c<`0C<c<c003IVIVoooo
c<c<00W<c<`00fIVI_ooolc<c00oc<c<00=VIVKoooo<c<`0olc<c<W<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c005ooooc<c<c<c<c<c<
oooo00?<c<`00oooolc<c<c<c003c<c<00=VIVKoooo<c<`0C<c<c003IVIV
ooooc<c<00W<c<`00fIVI_ooolc<c00oc<c<00=VIVKoooo<c<`0olc<c<W<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c005IVIVc<c<c<c<
c<c<IVIV00K<c<`00fIVI_ooolc<c002c<c<AiVIc0?<c<`00fIVI_ooolc<
c009c<c<00=VIVKoooo<c<`0?lc<c003IVIVooooc<c<0?o<c<c9c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0C<c<`01Oooolc<c<c<c<c<c?oo
o`07c<c<00=VIVKoooo<c<`00/c<c003VIW<oooooooo04?oool01YVIc<c<
c<c<c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<c003c<c<>?ooo`C<c<`00fIV
I_ooolc<c03oc<c<bLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3
c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c003IVIVc<c<c<c<00;<c<`00fIV
I_ooolc<c002c<c<00>IVLcoooooool0@oooo`06VIW<c<c<c<c<c<c<IVIV
oooo2/c<c003IVIVooooc<c<00?<c<`hoooo1<c<c003IVIVooooc<c<0?o<
c<c9c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`01Oooolc<
c<c<c<c<c?ooo`03c<c<00?oooo<c<c<c<`00lc<c003IVIVooooc<c<00;<
c<`00iVIc?ooooooo`13oooo00JIVLc<c<c<c<c<c<aVIVKoool:c<c<00=V
IVKoooo<c<`00lc<c0goool00nogmoooonogm`02oooo00?_moOoooooool0
0_ooo`03koOgooookoOg00;oool00nogmoooooooo`0Ioooo1<c<c003IVIV
ooooc<c<0?o<c<c9c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`01FIVI/c<c<c<c<c<c6IVIP06c<c<00=VIVKoooo<c<`00/c<c003VIW<
oooooooo04?oool01YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<
c003c<c<1oooo`03knOWmoO_knOW01__inL01=KFinoWinoWimKFi`K_inL0
0nogmoooooooo`06oooo1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0C<c<`01Oooolc<c<c<c<c<c?ooo`07
c<c<00=VIVKoooo<c<`00/c<c003VIW<oooooooo00Woool01No_koooono_
kno_koooo`03kno_00Coooo_kno_knooool3kno_00Coooo_kno_knooool2
kno_00?oooo_knooool00^o_k`05ooookno_kno_kno_oooo00?_knl01Ooo
ono_koooono_koooo`02kno_00?oooo_kno_knl00^o_k`03ooookno_oooo
00Woool01YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<c003c<c<
1_ooo`0>moO_g]kNc/kN_Kfm]Kg>c/Je]Kg>c/Je]Kg>c/Je_Kfm]Kg>c/Je
]Kg>0kfm_@07c/k>_Kfma[fm]Kg>c/Jea[fm]Kg>00:m_Kd01LJm_KFmc[fm
_LJm_KFmcP03_Kfm00W>c/jm_Kfm_Kg6_Kfe_Ljm_Kg>c/k>e]k_inL01ooo
o`C<c<`00fIVI_ooolc<c03oc<c<bLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c003IVIVc<c<c<c<
00;<c<`00fIVI_ooolc<c002c<c<00>IVLcoooooool01oooo`;_knl00mkN
g/k>c]kNgP02c/k>0]kNgP05c/k>c/kFg]kNc/k>c/kF00;Ng]h00lk>c/k>
e]kNgP02c/k>00KNg]k>c/k>c/kNg]k>c/kNg]h2c/k>00CNg]k>c/kNg]k>
c/h2g]kN0/k>cP05g]kNc/k>g]kNc/k>g]kN00;>c/h2g]kN0/k>cP;Ng]h0
0no_koooooooo`07oooo00JIVLc<c<c<c<c<c<aVIVKoool:c<c<00=VIVKo
ooo<c<`00lc<c0Koool01MkNg/k>cZf]YJf]YIbLY@0AW9bL00>LW:F]YIBL
W:D00YbLW007[JFDW9bUW9bLW9bL[JfUW9bLW9bU00:LW9`00jf]YIbLW9bL
W002[JfU00?>c/kNg]k_moL01_ooo`C<c<`00fIVI_ooolc<c03oc<c<bLc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00Goooo<c<c<c<c<
c<coool00lc<c003ooooc<c<c<c<00?<c<`00fIVI_ooolc<c002c<c<00>I
VLcoooooool01oooo`03kno_c/k>[Jf]00F][Jd019bLYJf][Jf][IbLY@>]
[Jd019bLYJf][Jf][IbLY@:][Jd01YbLYJf][Jf][IbLYJf][IbLW0B][Jd0
19bLYJf][Jf][IbLY@:][Jd01IbLYJf][IbLYJf][IbLY@03[Jf]00NLW:F]
[Jf][Jf][Jfm_Kg>c/k_knl02?ooo`06VIW<c<c<c<c<c<c<IVIVoooo2/c<
c003IVIVooooc<c<00?<c<`6oooo00?_inONg]koool09_ooo`;Ng]h00noW
ioooooooo`04oooo1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0G<c<`01FIVI/c<c<c<c<c<c6IVIP06c<c<
00=VIVKoooo<c<`00/c<c003VIW<oooooooo00Koool01^o_kmkNgZf][Hb<
S7]kNf][JaIkNg/00f][Ng]kNg]kN`0BNg]k00AkNhbLW9c>c/kNg]h8oooo
00JIVLc<c<c<c<c<c<aVIVKoool:c<c<00=VIVKoooo<c<`00lc<c0Koool0
0mkNg/kFc_ooo`0Coooo00?gmnooooooool00_ooo`05inogoooooooooooo
knOW00;oool00noWioooonO_m`02oooo00C_moOooooWimk>c/h7oooo1<c<
c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0C<c<`01Oooolc<c<c<c<c<c?ooo`07c<c<00=VIVKoooo<c<`00/c<
c003VIW<oooooooo00Koool00no_klk>cV][J`02BTYJ00eJFUY:BTY:BUXi
>D9:BUXi>D9:BTY:BUXi>D9:BTXi>D9:BTXi>D800TY:BP05BTYJ>CU2BTY:
BTY:BTYJ009:BTX00dY:FTY:BTY:BP02BTY:00I:BUY:BTY:BTY:BUY:BTY:
BUX3BTY:00A:BUY:BTY:BUY:BTX2BTYJ15YJFP03S8bDg]kNoooo00Ooool0
1YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<c003c<c<1Oooo`03
inoginONc]KN00;oool00nogmoooooooo`0;oooo00?_moOoooooool00ooo
o`03inogoooooooo00[oool01noWioooooooooooomkNg/kFg^oWi`06oooo
1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00=VIVK<c<c<c<`0
0/c<c003IVIVooooc<c<00;<c<`00iVIc?ooooooo`06oooo00S_knnm_Ke:
BTY[Jf][Jg]JFW=[Jg]:BTX3>CTi01LY:C4i>CTi>CTi>D9:BUYJFUYJFV]J
FUY[Jf]JFV][Jf]JFV]JFW<i>CUJFUXi>D9JFV/i>CU:BUXi>D9:BUXi>D9:
BTX00STi@P08BTYJ>CTiFUY[Jf][FUY[Jf][FUY[BTY:0UYJJ`07Jf][FUY[
Jf]kNg]kFUY[Jf][g]kN00Soool01YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`0
0fIVI_ooolc<c003c<c<1_ooo`03g]kNg/k6oooo017oool00nogmooooooo
o`02oooo00?gknOoooooool00_ooo`04inogooooooooinog1Oooo`05knOW
ooooknOWc/k>koOg00Koool4c<c<00=VIVKoooo<c<`0olc<c<W<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c005ooooc<c<c<c<c<c<oooo
00?<c<`00oooolc<c<c<c003c<c<00=VIVKoooo<c<`00/c<c003VIW<oooo
oooo00Ooool01jf][DY:FUYJJeYJJf][Jf][NdY:FP03:BTa00<i>CU:BTY:
BUX00UYJJ`03FUYJFUY[FUY[00=JFV/02V][Jf][NcTi>DY:FSTi@UYJFRTY
<EYJFRTY<DY:BP8i>D8034Y:FSTi>DY:FRTY:F][JeYJJf][NeYJLg]k4>O_
04YB<F][N`9JFV/2Jf]k00=JFV][Jf_Ng]h02?ooo`06VIW<c<c<c<c<c<c<
IVIVoooo2/c<c003IVIVooooc<c<00?<c<`5oooo00?gmnoWg]k>e]h03_oo
o`03koOgoooooooo00Coool00oOgkoooooooo`0:oooo00?_moOooooWkoL0
0_ooo`03g]kNc]K>knOW00Koool4c<c<00=VIVKoooo<c<`0olc<c<W<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c005IVIVc<c<c<c<c<c<
IVIV00K<c<`00fIVI_ooolc<c002c<c<00>IVLcoooooool01_ooo`03kno_
[Jf]>CU2009JFV/01F][Jf][NdY:BQPH63Ti@P02BTYJ0UYJFP0CBTYJFUYJ
FUY[FUYJFUY[Jf][FUY[Jf][FUY[Jf][>CU2BTYJ>CTiFUY[>CTiBTYJ>CTi
BTYJ>CU2009:BTX013Ti@TY:FRTY<EYJJ`9[Jf/00eYJLg=kFZf]<@03Jf][
00MJFV][Jf][Jg][Jf]JFV_Ng]k_knl01oooo`06VIW<c<c<c<c<c<c<IVIV
oooo2/c<c003IVIVooooc<c<00?<c<`6oooo00?Ng]k>c/koool00oooo`0:
knOWc/k>knOWkoOgooooinogooooknOWc/k>knOW0_ooo`03koOgoooog]kN
00GNg]h01]K>eXAkLia[HjekHljmYIB<S0:]Nf<02[fm_Lk6]MkNc/k6]Kfm
[NO_moooomkNg/k>c^ogm`Koool4c<c<00=VIVKoooo<c<`0olc<c<W<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1<c<c005ooooc<c<c<c<c<c<
oooo00O<c<`00fIVI_ooolc<c002c<c<00>IVLcoooooool01_ooo`05kno_
W9bLBTY:FUY[Jf][009[Jg/013Ti@RTY<DY:BTY:BP=:BUX00eYJFUYJJeYJ
FP03FUY[00][Jf]SFV][Jf][Jg/i>D9:BUXi>D9JFV/i>CU:BUXi>CT00TY:
BP08>CU2BTYJ>CTiFUYJ>CTiFUY[Jf][FUY[0V][N`0:FUYcJf]kJf]kFUY[
Jf][FUY[Ng]kFUYcFUYJc/k>2?ooo`06VIW<c<c<c<c<c<c<IVIVoooo2/c<
c003IVIVooooc<c<00?<c<`6oooo00CFe^ONg/koooo_inL2_Kfm00G>c/jL
W9b]]KG>c/k_moL00Zf]Y@:LW9`07Hb<S;fm_Jf]YNoWioooonOWg^oWioOg
knoWioO_inOWg]k>aU9:@W/@28@H4:ekHiA2<G<H49`a8LjUQ=kNc^oWc]kN
c/k6]NoWioooomkNg/kFg^oWi`06oooo1<c<c003IVIVooooc<c<0?o<c<c9
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0?<c<`01FIVI/c<c<c<
c<c<c6IVIP03c<c<00=VIVK<c<c<c<`00/c<c003IVIVooooc<c<00;<c<`0
0iVIc?ooooooo`06oooo00?_knmkNha:BTX00UYJJ`9[Jg/2>CTi00<i>D9:
BUY:BTX00dY:FP03FUYJFUY[FUYJ00EJFV/03f][JbTY<EYJFRTY<EYJJbTY
<DY:FRTY<DY:FSTi>CTi@TY:BRTY<DY:FRTY:@02FUY[00M[Jf]JFV][Jg][
Jf][Jg]JFV][Jg/00UYJJ`05Jf]kJf][BTYJ_Kg6kno_00Ooool01YVIc<c<
c<c<c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<c003c<c<1Oooo`03moO_inON
c]KN00;oool00mK>e]kNg^oWi`02g]kN00O_inOooooFe^O_inO>e/kNg]jm
_Kd00]kNgP;oool06<k>cXBDU9bLYIbLW7^4Q6]cLeY[JdXH67<H49`a8H@i
<F<H68@Q6:EcFZekHibLYIb4NiB<Hjfe]OOgkoooonoWilk>c^ogm`Koool4
c<c<00=VIVKoooo<c<`0olc<c<W<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c005ooooc<c<c<c<c<c<oooo00?<c<`00oooolc<c<c<c003
c<c<00=VIVKoooo<c<`00/c<c003VIW<oooooooo00Koool00mkNig]kNeYJ
FP03Jf]k00=kNg]:BUY:BTX00TY:FP0FFUYJFUY[FUY[Jf][FUY[Jf][Jf]k
FUYcNg]kJf]kNg^<Ng]kNg^<FUYJFUY[BTY:Jf]kBTY:Jf]kFUYJFUY[FUYJ
0UYJJ`04FUYJJf]kBTYJNg]k0g]kS007S8b<Ng^<Ng]kNg^<Ng]kJf]kNg]k
009kNh`00eYJFZf][No_k`07oooo00JIVLc<c<c<c<c<c<aVIVKoool:c<c<
00=VIVKoooo<c<`00lc<c0Koool00mKFimK>e_ooo`07oooo00?_moOooooo
ool00_ooo`03inogoooooooo00;oool03]k>aXb<S8b<S6][Jhb<S:fUU6][
Je8826/a:I`a8JekHh@H48@Q66/a:@9:DUX025YJFU9:@V]cLnoWioooomkN
g/kFg^oWi`Koool4c<c<00=VIVKoooo<c<`0olc<c<W<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h1Lc<c005IVIVc<c<c<c<c<c<IVIV00K<c<`0
0fIVI_ooolc<c002c<c<00>IVLcoooooool01_ooo`05g]kN_Kfmc/kFg]kN
c/kF00;Ng]h00lk>e]kNimkNgP04g]kN00O>c]KNg]k>c]K>c]KNg]k>c]KN
g]h01/k>eP06c/k>c/kFc/k>c/kFc/k>c/kF0lk>cP0<_Kg6c/k>c/k>c/k>
_Kg6c/k>_Kfmc/k>_Kg6c/k>_Kg6c/k>0[fm_@04c/k>S8b<[Jf]kno_1ooo
o`06VIW<c<c<c<c<c<c<IVIVoooo2/c<c003IVIVooooc<c<00?<c<`6oooo
00GNg]k>e/koooogknN]]KD00[fm_@07]Kg>_Kf]knOWc/k>[JfUknOW[KFe
00:m_Kd04mkNg[Fmc/k6]OooolkFg[fm_Jf]YIbDS:fUU<k6]G]cHaP@4588
2:ekHha[BX@Q67/a:E8i<BTY:@03>CTa00IJFT;_inOooooWimk>c/k_moL6
oooo1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0C<c<`01Oooolc<c<c<c<c<c?ooo`07c<c<00=VIVKoooo<
c<`00/c<c003VIW<oooooooo00Koool00lk>cZf]]Kfm_@02W9bU0Zf]]@03
[Jf]W9bU[Jf]00NLW:D01YbLW9bLYIbLW9bLYHb<U9bLW0><S9@018b<S8b<
U8b<S8b<S0:<S9@3S8b<00MkNhb<S8akNhb<S8akNhb<S8akNg/00W]kS00:
Ng]kNg^<Ng]kNg]kJf]kNg]kJf]kNg^<S8b<kno_1oooo`06VIW<c<c<c<c<
c<c<IVIVoooo2/c<c003IVIVooooc<c<00?<c<`5oooo02g_moOWimk>c/ko
ooo_moNm_Kf][JG>c]k>a[G>c/k_inO>c/jm_Kg_inN][JFm_Kg>c/kNg]k>
c/j]]KGooooNg/jm_Jf][JFLW9b]W8C>_JEcJf<Q611BBT9S@SU:<BUB>C5B
>BUkNg]kQ8AJFUY:DSU:BS5:DSW_inOooooFe^O>e/k_inL01_ooo`C<c<`0
0fIVI_ooolc<c03oc<c<bLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c003IVIVc<c<c<c<00;<c<`0
0fIVI_ooolc<c002c<c<00>IVLcoooooool01_ooo`08c/k>[Jf][Jfe>CTi
>CU2Ng]k[Jfe_Kfm0Zf]]@:][Jd01:f]]IbLYJf]]IbLY@:][Jd2W9bU00N<
S9BLW:FLW9bLW:F][Jf][KFm_Kd00Zf]]@07W9bUW9bLS8b<S8bDS8b<S8bD
W9bL00B<S9@01Hb<S8b<U8b<S8b<U7]kS002S8b<00MkNha:BTY:BUY:BTZ<
S8b<S9C_knl01oooo`06VIW<c<c<c<c<c<c<IVIVoooo2/c<c003IVIVoooo
c<c<00?<c<`6oooo00SNg]k>e]koooooooo_moOoooo_inOWkoL5oooo00?_
moOoooooool00_ooo`09knOWooooc/kN_Kf]_KfmU8b<Lg=J[Ib4Lf]S009B
>C403d8Y8E8i<EY2>E8i<Hb<Lhb<S7]kNf]SDV][BUYSF^oWioooonOWg/k>
g_Ogk`06oooo1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00?o
ooo<c<c<c<`00lc<c003IVIVooooc<c<00;<c<`00iVIc?ooooooo`06oooo
00ONg]jLW:Fm_Ke[Jg]:BTZLW:Fm_Kd01Zf]]@03[Jf][Jfe[Jf]00:LW:D0
1:f][Kfma]kNg^o_k`[oool00mkNikfmaYbLY@02S8bD00J<S8b<S9B<S9B<
S9B<S8b<S9@3S8b<0W]kS005FUYJ>CTiJf]kS8b<W9bL00Soool01YVIc<c<
c<c<c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<c003c<c<1Oooo`;_inL00mK>
e_ooonoWi`02c/k>00VLW:F]YIBe_Lk>a[GNg]k>e]k>c/kNg]k>e]h00/k>
cP0<a[fmc]KNooooc/JeS8b<S8acFUY2S8b<c/JeLf]SDTY2<AP@0U8i<@04
LeYBDSTaFUY2Ng=S0V][BP07FUY2Jf]:knOWkoOgknOWc]K>knOW00Koool4
c<c<00=VIVKoooo<c<`0olc<c<W<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h1Lc<c005IVIVc<c<c<c<c<c<IVIV00K<c<`00fIVI_ooolc<c002
c<c<00>IVLcoooooool01_ooo`09g]kN[Jf]_Kg6_Kfm_Kg6[Jfe_Kfm[Jfe
_Kfm00F][KD019bLYJf][Lk>c^o_k`;oool02No_mmkNg[fma[fm_Jf]]Jf]
[IbLYJf][IbLY@02[Jfe00S>c/kNg^O_knoNg]jm_LJ][KFLW:EkNh`2S8bD
00FLW9b<S9B<S9B<S8b<S9@00Xb<S005Ng^<S8b<S8b<Ng^<[Jf]00Soool0
1YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<c003c<c<1_ooo`06
g]kNc]K>oooooooo[JfU[KFe1;fm_@06g]kN_Kfmc/Jec]KNc/Je[KFe0[fm
_@0A[JfUoooo[KFeBTY:DTY2Jf=BS8acW8AkFUYJDSTY@RTQJdY2FUY2LeYB
HeY::BTH>CTH009JDRT01STi67]SB^oWioooomkNg/k>cPOoool4c<c<00=V
IVKoooo<c<`0olc<c<W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1<c<c005ooooc<c<c<c<c<c<oooo00O<c<`00fIVI_ooolc<c002c<c<00>I
VLcoooooool01_ooo`06kno_[Jfe_Kg6_Kg6[Jfe_Kfm1Zf]]@03W9bU[Jf]
g]kN00;_koL01=kNikfmaYbLYIbLW0>LW:D019bLW9bLYIbLYIbLY@>LW9`3
S8bD0YbLY@:m_LH00lk>cYbLYHb<U004S8bD00><S8b<S9AkNh`00Xb<S003
Ng^<Ng]k_Kfm00Soool01YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIVI_oo
olc<c003c<c<1Oooo`06koOginONc/k>ooookoOgknOW2Oooo`0NknOWinON
ooookoOgknOWoooo[JfU:C4Y:BTHBTXY[JFDa[fm>CTa@RTQDSTaDTY2NeY:
Jf=BFT8i:BTHBS4YBTXYLg=JBS4YDV=2e]KWooooinONc]KNknOW1_ooo`C<
c<`00fIVI_ooolc<c03oc<c<bLc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P3c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c003IVIVc<c<c<c<00;<
c<`00fIVI_ooolc<c002c<c<00>IVLcoooooool01_ooo`09knog[Jf]c/k>
[Jfe_Kfm[Jfe_Kg6[Jfe_Kfm00:][KD01Zf][Lk>c^o_mno_mlk>cZf][@:L
W:D00jf]]Jf][Jf][@02W9bU00>][JfLW:FLW:D00ibLY@0;W9bLW9bUW9bL
W9bUS8bDW9bLS8bDW9bL[Jfec/kFc/k>00F<S9@00hb<S8b<U7]kS002S8b<
00=kNhbm_Kgoool01oooo`06VIW<c<c<c<c<c<c<IVIVoooo2/c<c003IVIV
ooooc<c<00?<c<`6oooo00[Ng]k>e]koooo_inO>e]kNg]k>c/kNg]k>c/k_
inL2c]KN023_inONg]k>e]k>c/kFc]K_inO>e]k_moN]YI@0000Y:APi8ARL
U8c>aZekLf<Y:AQ2:B6]Nf>DJeY[<BTi>APY:APa>B5:BRU:BS4i>AQ:BS7_
inO_moO_inO>c/k_moL6oooo1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`01Oooolc<c<c<c<c<c?oo
o`03c<c<00?oooo<c<c<c<`00lc<c003IVIVooooc<c<00;<c<`00iVIc?oo
ooooo`07oooo00>m_Kfm_LJm_Kd00[fmaP03[Jfe_Kfm[Jfe00:][KD02no_
koooomkNgZf]]Jf][Jf]]Jf][Jf]]IbLYJf]]IbLY@02[Jf]00RLW:F][JfL
W:FLW:F][JfLW:FLW9bLW:D2W9bL00ZLW:F<S9BLW9bLW9b<S9BLW:Fm_LKN
g]jLW:F<S8`3S8bD00J<S8b<S9B<S8b<S9AkNg_>c/h8oooo00JIVLc<c<c<
c<c<c<aVIVKoool:c<c<00=VIVKoooo<c<`00lc<c0Goool0;NogmnoWilk>
c_ooomkNg[fm_Jf]YJfe]Jf]YIbLW;G6eZf]YKfm[LkFg/k>cYbLYJf]YKfm
_LkFc[fm_NoWijf]YA0002TY634i8Kfm[Mk>_Hb<LbTY67=JDZekHlJ]W8Ak
Lc4i8AP@43Ti64YB>DYJ@RTY:CU2<NoWioooomKFilkFc^oWi`06oooo1<c<
c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0G<c<`01FIVI/c<c<c<c<c<c6IVIP06c<c<00=VIVKoooo<c<`00/c<
c003VIW<oooooooo00Ooool01Kfm_Kfma[fm_Jf]]KfmaP02_Kfm00J][KFm
_Kg_koO_koNm_KfLW:D4[Jfe0Zf][@04W9bU[JfeW9bU[Jfe0YbLY@03[Jf]
W9bUW9bU00BLW:D01IbLW9bLYIbLW8b<U9bLY@03S8bD00>][KG>c/j][Jd0
0Xb<U007S8b<S8bDS8b<S8b<S8bDNg^<g]kN00Soool01YVIc<c<c<c<c<c<
c6IVI_ooo`[<c<`00fIVI_ooolc<c003c<c<1Oooo`;_inL00lkFc_oooooo
o`03koOg00Cgmno>e]kWimk_inL6koOg0oooo`0H[JfU:BTH:BTH:BTHS8ac
c[fUBUY2:BTH>B4HNf=:S6]:FUY2>D8a:C4Y:B48BU8iQ9BDNhB4FV=JknOW
koOginONc/kNmoO_1_ooo`C<c<`00fIVI_ooolc<c03oc<c<bLc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00Goooo<c<c<c<c<c<coool0
1lc<c003IVIVooooc<c<00;<c<`00iVIc?ooooooo`07oooo00>m_LJm_Kfm
_LH00[fm_@05_Kg6[Jfe[Jfeooookno_00:][KD00kfm_Jf]]Jf]]@02[Jfe
00J][Jf][KF][Jf][Jf][KFLW:D2[Jf]0YbLY@03[Jf]W9bUW9bU00:LW9`0
1ibLYIbLW9bLW9bLYHb<U9bLYIbLW002S8bD00FLW:Fm_LJLW:F<S9BLW9`0
0hb<U0:<S8`00mkNg_ooooooo`06oooo00JIVLc<c<c<c<c<c<aVIVKoool:
c<c<00=VIVKoooo<c<`00lc<c0Koool00mkNg/k>g_ooo`04knOW00CFe^O_
inOWimkFe^L6knOW00GFe^OgknOooon][JDa>B400TYJ@P09U8aS_Kf][KFe
Jg=c4108>B4H<AP@610@FV][009JHeX02F=cS:fe]IbegZFec^oWinogmmkN
g/kFc^oWi`06oooo1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<
00=VIVK<c<c<c<`00/c<c003IVIVooooc<c<00;<c<`00iVIc?ooooooo`07
oooo00c>c/jm_Kfm_LJm_Kfm_LJ][KFm_Kg_koONg^Nm_Kf][KFm_LH6[Jfe
00R][Jf][KF][KF][Jf][KFLW:F][KF][Jd4W9bU00B][JfLW:FLW:FLW:D2
W9bL00BLW:F<S9BLW9bLW:D2S8bD00>LW:F][KF<S9@018b<U003W9bLS8bD
kno_00Soool01YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<c003
c<c<1_ooo`06g]kNg]k>ooooc]KN_Kfm]Jf]0Zf]Y@0ES8b<]Kg>_Kf]W9bU
[JfU[KFe_Kfm[JfU[KFe[JfUinogooooc/k>Hg><NhB4Jf=BNg]k_Kf][JFD
S8b<:BTY008000003DYBFYbegZFecYbegZFmgYbeikG6eYbeg^oWioOgkmkN
g/k>c^ogm`06oooo1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<
00?oooo<c<c<c<`00lc<c003IVIVooooc<c<00;<c<`00iVIc?ooooooo`07
oooo00C>c]J][KG>c/jm_LH2_Kfm00W>c/k>c]Jm_LJ][KFm_Kf][KFm_Kf]
[KFm_Kd01Jf]]@09[Jf][JfeW9bU[Jfe[Jf]W9bU[Jf]W9bU[Jf]00BLW:D0
0ibLW9bLYIbLY@02W9bL00FLW:F<S9B<S9BLW9b<S9@00YbLW003S8bDW9bL
S8bD00><S9@9oooo00JIVLc<c<c<c<c<c<aVIVKoool:c<c<00=VIVKoooo<
c<`00lc<c0Koool01MkNg/kFg_ooonoWimkNgP02koOg00?_inO>c/k_moL0
0^oWi`03c/k>knOWc]KN00;_inL01>O_moO_ioOgkmKFi`:L[Kd01YbLYJf]
YKfm_KFmc[G6eZFecP9SLh`6W;GN00NL]NNU]Lk_inOooooNg]k>e]k_inL0
1_ooo`C<c<`00fIVI_ooolc<c03oc<c<bLc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P5c<c<00EVIVK<c<c<c<c<c<aVIVH01/c<c003IVIVoooo
c<c<00;<c<`00iVIc?ooooooo`07oooo00?Ng]j][KFm_LH00kfmaP08[Jfe
_Kfm_Kfm[Jfe_Kg6_Kfm[Jfe_Kg60jf]]@03_Kfm[Jfe[Jfe00:][KD02:f]
[IbLYIbLYIbLW9bLYIbLW9bLYJf][@FLW:D019bLW9bLYIbLW9bLY@:LW9`0
1Hb<U9bLYHb<U9bLW8b<S003S8bD0YbLW0Woool01YVIc<c<c<c<c<c<c6IV
I_ooo`[<c<`00fIVI_ooolc<c003c<c<1Oooo`;_inL01LkFc_ooonoWinoW
inogm`02knOW00>]]KG_inO_moL01NoWi`05inogmnoWinogooooc]KN00:]
_NL00jg6mib]_Lk6[@03W;GW00F]a^nL]NNL]MjL]MjL]NL01IbegP05c]KN
koOgg]kNc/k>koOg00Koool4c<c<00=VIVKoooo<c<`0olc<c<W<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1<c<c005ooooc<c<c<c<c<c<oooo
00O<c<`00fIVI_ooolc<c002c<c<00>IVLcoooooool01oooo`03kno__Kfm
c/k>00:m_LH00ibLYIbLW;fmaP02_Kfm00>m_LJ][KFm_LH00Zf]]@03_Kfm
[Jfe[Jfe00>][KD029bLYJf][Kfm_Lk>e]kNg/k>e/k>cZf][@>LW:D03Zf]
[IbLYIbLYIbLYIbLW9bLYIbLW9bLYHb<U9bLYHb<U9bLW8b<U6][N`:<S9@0
0ibLW8b<U:f][@09oooo00JIVLc<c<c<c<c<c<aVIVKoool:c<c<00=VIVKo
ooo<c<`00lc<c0Koool02>OWg/k>g_ooolkFgYbLW<k6]KFmcZfe]@:][JD0
0ibLYJf]YIbLW002c/k>012]]KF][JF<S8c>c/kooonea]JL[MjL]MjL[MjL
[Kf][JFL[MjL[LjL]MjL[MjL[Lh2W:gN00JL[LjL[MjL[MjL[LjL[MjL[Lh2
knOW00?Ng]k>e/k_inL01_ooo`C<c<`00fIVI_ooolc<c03oc<c<bLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P3c<c<00EVIVK<c<c<c<c<c<aV
IVH00lc<c003IVIVc<c<c<c<00;<c<`00fIVI_ooolc<c002c<c<00>IVLco
ooooool01oooo`07kno_[Jfec/k>_Kg6c/k>Ng]kW9bU00:m_LH01;fm_Jf]
]Kfm_Jf]]@:m_Kd2[Jfe00Fm_LJ][KF][KF][Jg>c]H00_ooo`03knogkno_
kno_00;_koL00mkNikfm_IbLW004W9bU00b][JfLW9bLW:FLW9bLW:FLW9bL
W:F<S9BLW:E[Jf]kNg^LW9`2S8bD00>m_Kgoooooool01oooo`06VIW<c<c<
c<c<c<c<IVIVoooo2/c<c003IVIVooooc<c<00?<c<`5oooo00S_moONg]kN
g/koooo_inO>e]k_inOgmnl3knOW00G>e]k_inOWimkFe^O_inL00mkNgP05
knOWkoOgknOWc]KNg]kN00;>e]h01=k>a]KFimkNg]KFi`;>e]h00mkNg/kF
g/kFgP04c]KN00Fea]K_inOgmno>e]k>c/h01oooo`C<c<`00fIVI_ooolc<
c03oc<c<bLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00Go
ooo<c<c<c<c<c<coool00lc<c003ooooc<c<c<c<00?<c<`00fIVI_ooolc<
c002c<c<00>IVLcoooooool01oooo`03knog_Kfmc/kF00:m_LH02EYJJkfm
_Kfma[fm_Kfma[fm_Kfma[fm_KfmaP02[Jfe00Vm_Kf][KF][KF][KG_knoo
ooo>c/j][KF][Jd00YbLY@:][KD2g]kW00Bm_KfLW:FLW:F][Jd3W9bU00FL
W9bLW:FLW9bLW:F<S9@00YbLW006Jf][FUY[W9bUS8bDS8b<_Kg62Oooo`06
VIW<c<c<c<c<c<c<IVIVoooo2/c<c003IVIVooooc<c<00?<c<`6oooo0]kN
gP0>ooooknOWooooooooe]KWc/k>knOWmoO_oooomoO_inogknOW_Kfmg]kN
0_ooo`0:inogknOWkoOgooooknOWoooomnoWooooinogkoOg0^oWi`04oooo
knOWinogmoO_0^oWi`03g]kNknOWkoOg00;_inL00mkNg/kFc^oWi`06oooo
1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0G<c<`01FIVI/c<c<c<c<c<c6IVIP06c<c<00=VIVKoooo<c<`0
0/c<c003VIW<oooooooo00Soool01Kfm_Lk>c[fma[fm_EYJFP03_Kg600Fm
_Kfm_LJm_Kf][KFm_LH00[fm_@:][KD01;fm_Lk>e_ooojf]]@:][Jd02Jf]
]Jf][Jf]]IbLYJf][IbLYKfmaZf]]Jf][@04W9bU00B][JfLW:FLW9bLW:D3
W9bL00NLW:E[Jg]JFUZLW9b<S9B<S8c>c/h02Oooo`06VIW<c<c<c<c<c<c<
IVIVoooo2/c<c003IVIVooooc<c<00?<c<`5oooo0^oWi`0@c]KNooookoOg
[JfU_Kfmc/k>S8b<[JfU]Kg>knOWW9bL[JfUS8b<Q9BDU8b<[KFe0Zf]Y@09
c/k>knOWinogg]kNW9bUc/k>[KFe[JfUW9bL00;>c/h029bLW=kNgZfUU<k>
gZf]YIbLYHBDU<kFcP;_inL01>ogmlk>g/k>c^ogm`Koool4c<c<00=VIVKo
ooo<c<`0olc<c<W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1<c<
c005ooooc<c<c<c<c<c<oooo00O<c<`00fIVI_ooolc<c002c<c<00>IVLco
ooooool02?ooo`05_Kg6c/kFc/k>_Kg6FUYJ00Bm_LH2_Kfm00Bm_LJm_Kfm
_LJ][KD2_Kfm00>][KFLW:F][KD00Zf]]@04_Kfm[Jfe[Jfe[Jf]0Zf]]@07
W9bU[Jf]S8bDNg]k[JfeW9bU[Jf]00FLW:D02YbLW9bLYIbLYIbLYG]kNdY:
FYbLYIbLW8b<U=kNgPWoool01YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIV
I_ooolc<c003c<c<1_ooo`05g]kNc]K>ooooknOWc/k>00?Ng]h02/kFg^oW
inoWimkNg/kFg/k>c]K>eZfe]MkNc/kFgP;>c/h01oooonoWijfe]Hb<S;fm
_Jf]YMkNgP02c/k>00WNg]k>c/kNg]k>c/kNg]kFc]K>e/k>c/kFe^L00noW
i`03g]k>c]KNknOW00Koool4c<c<00=VIVKoooo<c<`0olc<c<W<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0lc<c005IVIVc<c<c<c<c<c<IVIV
00?<c<`00fIVI/c<c<c<c002c<c<00=VIVKoooo<c<`00/c<c003VIW<oooo
oooo00Soool01[fma/k>c[fma/k>cUYJJkfm_@:m_LH03Kfm_Kfma[fm_Kfm
a[fm_Jf]]KfmaZf]]Kfma[fm_F][Njf][Kfm_@05[Jfe00Z][Jf][KF][Jf]
[KEJFUY[Jf^][KF][JfLW:F][Jd5W9bU0YbLW007W9bUFUY[Jf][W9bLW9bU
S8bDg]kN00Woool01YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<
c003c<c<1_ooo`04inONc]KNooookoOg0oooo`05knOWooooinogoooomnoW
00?oool02>oWinogmnoWioooonoWioooomkNg/k>cP;Ng]h02^oWioooonO_
moooonoWinO_moO_inO_mnoWinO_m`C_inL01MKFinoWilkFg]k>a^ogm`06
oooo1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00?oooo<c<c<
c<`00lc<c003IVIVooooc<c<00;<c<`00iVIc?ooooooo`08oooo0/k>cP07
_Kg6g]kNJf]k[Jf]c/k>_Kg6c/k>00:m_LH01kfm_Kfma[fm_Kfm_KfmaZf]
]KfmaP02W9bU1Zf]]@0=[Jf][Jfe[Jfe[Jf]Jf]kW9bU[JfeW9bU[Jf]W9bU
[Jf]W9bU[Jf]00:LW:D02IbLW9bLYIbLYEYJFXb<S9bLYIbLW8b<U>o_k`09
oooo00JIVLc<c<c<c<c<c<aVIVKoool:c<c<00=VIVKoooo<c<`00lc<c0Ko
ool01MKFilk>c_ooonoWijf]Y@02[KFe00Vm_Kf]]KGNg]jm_Kf]]KGWimj]
[JFe_Lj][JD00/k>cP07]Jf]_Kfm[KFeW9bLS8b<_Kf]c/kN00:]]KD2[JfU
00K>c]jm_Kf][JFm_Kg>c/j][JD2[KFe0Zf]Y@05c/k>knOWc]K>c/k>inog
00Koool4c<c<00=VIVKoooo<c<`0olc<c<W<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1Lc<c005IVIVc<c<c<c<c<c<IVIV00K<c<`00fIVI_oo
olc<c002c<c<00>IVLcoooooool02?ooo`07g]kN_Kg6c/k>_Kg6[JfeS8b<
c/kF00Fm_LH02Kfm_Kfma[fm_Kfm_KfmaZf]]Kfm_Kfma[fm_@06[Jfe00>]
[JfLW:G>c/h00Zf]]@03[Jf]W9bU[Jf]00NLW:D2W9bL00EJFV^LW:FLW9bL
W:FLW9`02_ooo`06VIW<c<c<c<c<c<c<IVIVoooo2/c<c003IVIVooooc<c<
00?<c<`5oooo00SgmnoWimkNg]koooo_inN]]KF][JG>c/h2_Kfm00CNg]k>
c/j][JGFe^L2[JfU00K>c/kNg]jm_KfLW9c>c/k6_Kd2_Kfm00[>c/kNg]j]
YIB]]KG>c/jm_Kg>c/j][JFe_Lk>c/h2_Kfm00J][JG>c/jm_Kf][JFm_Kg_
inL2c/k>00?gmnooooooool01?ooo`C<c<`00fIVI_ooolc<c03oc<c<bLc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00Goooo<c<c<c<c<
c<coool01lc<c003IVIVooooc<c<00;<c<`00iVIc?ooooooo`08oooo00?N
g]jm_LK>c/h00/k>cP04Ng^<_Kg6_Kg6c/k>1;fmaP07_Kfm_Kg6_Kg6[Jfe
_Kfm_Kg6[Jfe00;>c/h00jf]]Kfm_Jf]]@02[Jfe00Nm_Kg>c/j][KF][Jf]
[KFLW:F][KD00YbLY@04[Jf]W9bUW9bU[Jf]0YbLY@03[Jf]S8bDS8bD00:L
W9`2W9bU2_ooo`06VIW<c<c<c<c<c<c<IVIVoooo2/c<c003IVIVooooc<c<
00?<c<`6oooo00CFe^O>e/koooo_moL3knOW00KNg]koooooooo_inOoooo_
moL2knOW00KoooogmnogmnoFe^OgknOWkoL2moO_00?WkoO_moO_inL00^oW
i`06inogknOWg]kNinogknOWc]KN0noWi`07e]KWg]kNg]kNinONc/k>c]KN
knOW00Koool4c<c<00=VIVKoooo<c<`0olc<c<W<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`00fIV
I/c<c<c<c002c<c<00=VIVKoooo<c<`00/c<c003VIW<oooooooo00Soool0
2]kNg[fma/k>e/k>e]kNg[fm_Hb<U<k>e[fma/k>cPBm_LH01Kfm_Kfma[fm
_Jf]]KfmaP02[Jfe0kfmaP>m_Kd2[Jfe0Zf][@03W9bU[JfeW9bU00:][Jd0
0ibLYJf][IbLY@04W9bU00IJFUZLW:F][JfLW9bLW:F][Jd:oooo00JIVLc<
c<c<c<c<c<aVIVKoool:c<c<00=VIVKoooo<c<`00lc<c0Goool01oOgknOW
g]K>e_ooonoWilk>cZfe]@02W9bL00Z][JFm_KgNg]k>c/jm_KgNc/K>e]jm
_Kfe_Ljm_Kd2c/k>00nm_Kfe_Lk>c/k>a[G>e]jm_Kf]]KG>c]kNg/jm_Kf]
]KFm_Kf]]KFm_Kg>c/h00[fm_@04c/k>[JfU_Kfmc/kN0/k>cPOoool4c<c<
00=VIVKoooo<c<`0olc<c<W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c005ooooc<c<c<c<c<c<oooo00?<c<`00oooolc<c<c<c003c<c<
00=VIVKoooo<c<`00/c<c003VIW<oooooooo00Soool02No_kkfma/k>eXb<
S7]kS;fma[fm_Jf]]Lk>eP02_Kg600?>c/jm_LJm_Kd00[fmaPBm_Kd01Kfm
a[fm_Jf]]Jf]]Kfm_@06[Jfe0jf][@05[JfeW9bU[Jf]W9bU[Jf]00:LW:D0
2:f][Hb<U3Ti@Xb<S6][Ng]kS9bLYKfm_@[oool01YVIc<c<c<c<c<c<c6IV
I_ooo`[<c<`00fIVI_ooolc<c003c<c<1_ooo`07e]KWc]K>ooooknOWW9bL
_Kfm[JfU00:m_Kd01Jfe]Lk>c[fm_Kfm_LkFgP02[KFe00J][JF]]KF][JF]
]KFm_Kf][JD2_Kfm00SNg]jL[Kf][JG>a[G>e]j4U9B][JF]]KD2[JfU00[>
c/jm_KfLW9bm_Kf<S8bLW9cNg]k>c/kNc/KWkoL6oooo1<c<c003IVIVoooo
c<c<0?o<c<c9c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`0
1FIVI/c<c<c<c<c<c6IVIP06c<c<00=VIVKoooo<c<`00/c<c003VIW<oooo
oooo00Woool02Kfm_Lk>cTY:BRTY:Jf][Lk>e[fm_Kfma/k>cP03_Kg600[>
c/jm_LJm_Kfm_LJm_Kfm_LJm_Kf][KFm_Kfm_LH2[Jfe00>m_LJ][KF][KD0
1:f]]@03[Jf][JfeW9bU00:][Jd039bLYJf][IbLYJf][IbLYHb<S4Y:BV][
JbTY:F][JibLYKfmaP[oool01YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIV
I_ooolc<c003c<c<1Oooo`06moO_inONc/kNmoO_knOWg]kN0^O_m`06knOW
koOgknOWinogknOWkoOg0^oWi`04c/kNknOWmoO_c]KN0]kNgP__inL01]kN
g^oWimkNg]kNg/k>c]K>eP;>c/h01<kFg/k>c/k>c_O_i`Koool4c<c<00=V
IVKoooo<c<`0olc<c<W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1<c<c005ooooc<c<c<c<c<c<oooo00O<c<`00fIVI_ooolc<c002c<c<00>I
VLcoooooool02Oooo`07_Kg6c/kF_Kg6_Kg6c/kF_Kg6c/kF00:m_LH01Lk>
c[fma/k>c[fma[fm_@03_Kg600Vm_Kfm_LJm_Kfm_LJ][KFm_LJm_Kf][KFm
_Kd00Zf]]@04_Kfm[Jfe[Jfe[Jfe0Zf][@0>[JfeW9bU[JfeW9bU[Jf]W9bU
[Jf]Ng^<BTY:W9bUS8b<W9bUS8bDc/k>2_ooo`06VIW<c<c<c<c<c<c<IVIV
oooo2/c<c003IVIVooooc<c<00?<c<`6oooo00CFe^O>c/kooooFe^L5c/k>
00CNg]k>c/k>c/kWg]h4c/k>00c>c]k>c/k>c/j4U9Bm_Kg>c/k>e]k>c/jm
_Kg>c/jm_Kg>c]h2c/k>00Nm_Kg>c/jm_Kg>c/jm_Kfe[Jf]]KD00[fm_@04
g/k6_Kfmc/k>koOg1_ooo`C<c<`00fIVI_ooolc<c03oc<c<bLc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P3c<c<00EVIVK<c<c<c<c<c<aVIVH0
0lc<c003IVIVc<c<c<c<00;<c<`00fIVI_ooolc<c002c<c<00>IVLcooooo
ool02Oooo`03_Kg6g]kNc/k>00;>c/h01/k>e[fma/k>c/k>c[fma/k>cP:m
_LH00lk>c[fma[fm_@02_Kg600Jm_Kfm_LJm_Kfm_Kf][KFm_LH2[Jfe00>m
_Kf][KF][KD01:f]]@:][Jd02Jf]]IbLYJf]]Jf][IbLYJf][G]kNeYJFZf]
[@02W9bU00>LW9c>c]Koool02Oooo`06VIW<c<c<c<c<c<c<IVIVoooo2/c<
c003IVIVooooc<c<00?<c<`6oooo00CNg]k>c/koooo>e]h3[JfU00fLW:F<
S8c>c/jLW9b][JFea]Jm_Kf4U9B]YIB][JG>c/j]]KG>c/h00Zf]Y@04W9bL
_Kfmc/k>[JfU0Xb<S00@a[fmW9bLS8b<W9bLW9bUS8b<_KfmS8b<W9bLU8b<
W9bLS8b<]Kg>_Kfmg]k>knOW1_ooo`C<c<`00fIVI_ooolc<c03oc<c<bLc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00Goooo<c<c<c<c<
c<coool00lc<c003ooooc<c<c<c<00?<c<`00fIVI_ooolc<c002c<c<00>I
VLcoooooool02Oooo`0:c/k>g]kNc/kFc/k>c/kF_Kg6c/kFc/k>_Kg6c/k>
0/k>eP>m_LH02Lk>c[fma[fm_Kfma[fm_Kfma[fm_KfmaZf]]@02_Kfm00>]
[KFm_Kf][KD00jf]]@0<[Jf][Jfe[JfeW9bU[Jf][JfeW9bU[Jf][JfeJf][
FUY[[Jf]0YbLY@03W9bLg]kNoooo00Woool01YVIc<c<c<c<c<c<c6IVI_oo
o`[<c<`00fIVI_ooolc<c003c<c<1Oooo`04koOgknOWc/k>koOg0noWi`05
g]kNknOWc/k>c]K>g]kN00G_inL00nOWg^oWinoWi`02knOW00KFe^ONg]k>
e/k_inOWimkFe^L3c/k>00Rm_Jg>c]k>c/kNc/Je_Ljm_Kg>c/je_Lh3_Kfm
00>m_Jg>e]koool01_ooo`C<c<`00fIVI_ooolc<c03oc<c<bLc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00EVIVK<c<c<c<c<c<aVIVH0
1/c<c003IVIVooooc<c<00;<c<`00iVIc?ooooooo`09oooo1<k>eP0:c/k>
c/kF_Kg6c/kFc/k>_Kg6c/k>_Kg6c/kFc/k>1;fmaP0<_Kfm_Kg6_Kfm_Kg6
[Jfe_Kg6[Jfe_Kg6[Jfe_Kfm[Jfe_Kfm0jf]]@0:[Jf][Jfe[Jf][Jf]W9bU
[JfeW9bU[JfeFUY[Jf]k0Zf][@03W9bU[Jf]kno_00[oool01YVIc<c<c<c<
c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<c003c<c<1Oooo`04mnoWe]KWg]k>
oooo1=kNgP07c/k>g]kNc/kNg]kNg]k>g]kNc]KN00;Ng]h00lk>g]kNg]kN
gP02g]kN00[>c/k_inO>c]kNg/je_LkNc/J][JFLW:Fe_Lje[Jd2[JfU00>]
]KF][JF][JD00Zf]Y@06W9bU[JfU[KFe_KfmknOWkoOg1_ooo`C<c<`00fIV
I_ooolc<c03oc<c<bLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P4
c<c<00Goooo<c<c<c<c<c<coool01lc<c003IVIVooooc<c<00;<c<`00iVI
c?ooooooo`09oooo00GNg]k>c/k>c]K>c/k>c]H00/k>cP05c/kF_Kg6c/k>
c/kF_Kg600;>c/h00kfma/k>c/k>cP03_Kg61;fm_@09_Kg6[Jfe_Kfm[Jfe
_Kfm[Jfe_Kfm[Jfe_Kfm00B][KD2[Jf]0Zf]]@07FUYJNg]k[JfeW9bU[Jf]
W9bUkno_00[oool01YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<
c003c<c<1_ooo`04knOWc/k>koOgc/k>0Zf]Y@03W9bUW9bLS8b<00:][JD0
3HBDU9bLYJf]YJf]YIbLYJf]YIbLYLk6]IbLYHb<S9bLW<k>cXb<S003W9bL
00B][JF<S8akNg]kNg/2Jf][00ZLW9a[Jf][Jf]kNg^<S8aJFUZLW9b][JG>
c]k_inL7oooo1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00=V
IVK<c<c<c<`00/c<c003IVIVooooc<c<00;<c<`00iVIc?ooooooo`09oooo
00?Ng]k>c]K>c]H00lk>eP06c/k>c/kFc/kFc/k>_Kg6c/kF0[fmaP04c/kF
_Kg6_Kg6c/k>1KfmaP09_Kfm_Kg6_Kfm_Kg6_Kfm[Jfe_Kg6_KfmW9bU00>]
[KD03:f][Jf]]Jf]]Jf][IbLYKfm_DY:FXb<S:f][IbLYJf][IbLY@_oool0
1YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<c003c<c<1Oooo`06
inoginONc/k>ooooc/k>c]KN0mkNgP0:_Kfmg]kNg]kNg]kN_Kfmg]kNc/k>
c]K>g]kNinON0/k>cP03_Kfmc/k>g]kN00;Ng]h03<k>c/kFg/k>c[fm_Jf]
YIbLW8b<S7]kNhb<S7]kNg^4Q7]kN`:<S8`00ibLW;fm_NoWi`08oooo1<c<
c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00?oooo<c<c<c<`00lc<
c003IVIVooooc<c<00;<c<`00iVIc?ooooooo`09oooo00?Ng]k>c]K>c]H0
0/k>eP07c/k>c/kFc/kF_Kg6c/kFc/k>_Kg600;>c/h00kfma/k>c[fmaP02
_Kg600Zm_Kfm_LJm_LJm_Kfm_LJm_Kfm_LJ][KFm_Kfm_LH2[Jfe0jf][@04
_Kfm[Jfe[Jfe[Jf]0jf]]@06BTY:S8bD[Jf]W9bU[Jfe[Jf]2oooo`06VIW<
c<c<c<c<c<c<IVIVoooo2/c<c003IVIVooooc<c<00?<c<`6oooo00CWimk>
c/k_moO_inL4g]kN0[fm_@08inONg]kNg]kNg]kNinONe]KWg]kNe]KW1]kN
gP08c/kNg]kNg/k6c/k>_KfmW9bLS8b<Jg=c16][J`05Ng]kNhB4W9bL_Kfm
g]kN00Woool4c<c<00=VIVKoooo<c<`0olc<c<W<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1Lc<c005IVIVc<c<c<c<c<c<IVIV00K<c<`00fIV
I_ooolc<c002c<c<00>IVLcoooooool02Oooo`06kno__Kg6g]kNc/kFc/k>
c/kF0lk>cP05_Kg6c/kFc/k>_Kg6c/k>00:m_LH01/k>c[fma[fm_Kfma[fm
_KfmaP>m_Kd01Jf]]KfmaZf]]Jf]]Kfm_@02[Jfe00>LW:Fm_Kf][Jd00Zf]
]@>][Jd01jf]]CTi@YbLYJf]]IbLYJf][Kfm_@0;oooo00JIVLc<c<c<c<c<
c<aVIVKoool:c<c<00=VIVKoooo<c<`00lc<c0Goool02_OgkmKFilkFc^O_
mnoWihb<S:f]YLk>cXBDU;F][@FLW9`01Lk>cZfUU:f]YHb<S9bLY@02[JfU
00>LW9b][JF<S8`00YbLW003NhB4_KfmNg]k00=[Jf/00hb<S7]kNhb<S002
[JfU0/k>cP03g]kNoooooooo00Soool4c<c<00=VIVKoooo<c<`0olc<c<W<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1<c<c005ooooc<c<c<c<
c<c<oooo00O<c<`00fIVI_ooolc<c002c<c<00>IVLcoooooool02Oooo`03
kno_c/k>g]kN00?>c]H00lk>c/k>e/k>eP02c/k>00G>c]Jm_LK>c/jm_LK>
c/h00kfmaP03c/k>_Kg6_Kg600>m_LH4_Kfm00F][KFm_Kf][KF][JfLW:D0
1Jf]]@03[Jf][JfeBTY:00>LW:D00jf][Kfma_ooo`0:oooo00JIVLc<c<c<
c<c<c<aVIVKoool:c<c<00=VIVKoooo<c<`00lc<c0Koool01mkNg/k>c^og
mnoWilk>c/kFc^OWgP02g]kN00W>e]k>c/k>c/k>e]k>c/kNg]k>c/k>c]kN
g/h00lk>cP03[KFec/k>c/k>00;>c/h01LJm_KFmcZf]YHb<S;fm_@04oooo
00C_inONg]k>c/kNg]h;oooo1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0?<c<`01FIVI/c<c<c<c<c<c6IV
IP03c<c<00=VIVK<c<c<c<`00/c<c003IVIVooooc<c<00;<c<`00iVIc?oo
ooooo`0:oooo00>m_LKNg]k>c]H00/k>eP03kno_oooooooo00[oool00no_
moooooooo`0;oooo00?>c]J][KF][KD00jf]]@:][Jd01STi@Zf][Jf][IbL
YJf][KfmaP_oool01YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<
c003c<c<1_ooo`07g]kNc/k>knOWknOWg]kNe]KWknOW00;Ng]h02^ONg^oW
inoWinoWimkNg/k>g^OWg]kNg]KFinoWi`KNg]h3c/k>00>]]KFDS8c>c/h0
0oooo`;Ng]h00lk>c]kNg_ooo`0;oooo1<c<c003IVIVooooc<c<0?o<c<c9
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`01Oooolc<c<c<
c<c<c?ooo`03c<c<00?oooo<c<c<c<`00lc<c003IVIVooooc<c<00;<c<`0
0iVIc?ooooooo`0:oooo00S>c/kNg^O>c]KNg]j][KFm_Kg>c]KNg]h2g]kW
0]kNgP03g]kWg]kNg]kN00GNg]h02<k>e]kNg/k>e/k>c]kNg/k>e/k>c/k>
eP;>c/h2_Kg60Zf]]@03_Kfm[Jfe[Jf]00:][KD01ibLYCTi@[fm_IbLYJf]
[IbLYLk>cP0;oooo00JIVLc<c<c<c<c<c<aVIVKoool:c<c<00=VIVKoooo<
c<`00lc<c0Goool06>O_mnOWg/k>c^ogmlk6]Lj<Hmk>_NoWimjm[LIkB/k6
[LkFgZf]YHBDU:fe]IbLW<k>cZfe]JfUU8BDU:fe]IbDS<k>cYbLY@BLW9`0
2Zf]YG^4Q6][Jkfm_OooonogmnOWg]kNg/k>c]kNgPgoool4c<c<00=VIVKo
ooo<c<`0olc<c<W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<
c005IVIVc<c<c<c<c<c<IVIV00K<c<`00fIVI_ooolc<c002c<c<00>IVLco
ooooool02_ooo`08c/kFg]kNg]kNc/kF_KfmJf]kkno_W9bU0UYJFP08FUY[
Jf][FUYJFUYJJf][FUY[FUYJFUY[1EYJFP9JFV/3FUYJ00=JFV]JFUY[Jf/0
0[fm_@>][KD01Kfm_Jf]]Jf]]IbLYCTi@P02[Jfe00>][JfLW:GNg]h02ooo
o`06VIW<c<c<c<c<c<c<IVIVoooo2/c<c003IVIVooooc<c<00?<c<`6oooo
01S>e]k>c/k_moO_inO6[IcNg/k_inO6[Ic>S6?_inOFe^Nm_Jg>c/j]]KG>
c/kNg]k>a[Fe_Lk6_Kg>a[Fe_Lk>a[F][JF]]KD2_Kfm00ZLW9b][JF<S8ak
Q8C>c/koooo_inO>e]k>c/kNg]h>oooo1<c<c003IVIVooooc<c<0?o<c<c9
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0C<c<`01Oooolc<c<c<
c<c<c?ooo`07c<c<00=VIVKoooo<c<`00/c<c003VIW<oooooooo00[oool0
4Lk>c]kNilk>e]kNg[fmaW]kNmkNijf][@0003Ti>APH624Q600003Ti>@00
01PH62TY<@0261PH00@i>CTH61PY:BTY:BT3000000HY:BUJFUY:BTX0000i
>CVm_LH2[Jfe00Vm_Kf][KF][KF][KFm_Kf<S9A:BTZm_KfLW:D00Zf][@03
g]kWoooooooo00Woool01YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIVI_oo
olc<c003c<c<1Oooo`0=koOgknOWc/k>knOWinONc]K>cZF4c/JeaW]:c[fU
knOWinONc]KN00;_inL00nOWg]kNg]kNgP04g]kN00?>c]k>c/kNg]h00]kN
gP09a[fm]Kg>[JfUS8b<c/kNknOWg]kNc/k>g]kN00ooool4c<c<00=VIVKo
ooo<c<`0olc<c<W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0lc<
c005IVIVc<c<c<c<c<c<IVIV00?<c<`00fIVI/c<c<c<c002c<c<00=VIVKo
ooo<c<`00/c<c003VIW<oooooooo00[oool02MkNg/k>e/k>e]kNilk>eV][
NmkNgZf][APH6002BTY:010i>CU:BTY:BTXi>CU:BTY:DS4i>D9:BTXi>CU:
BTXi>CU:BTY:DS5JFUXH61QJFUX2Ng]k00LH61Pi>D;>c/j][KFm_LJ][KFm
_Kd00jf]]@03S8b<FUYJ[Jfe00:][KD00jf][No_koooo`0:oooo00JIVLc<
c<c<c<c<c<aVIVKoool:c<c<00=VIVKoooo<c<`00lc<c0Koool02MkNg/k>
c_OgkmKFinoWimJeW<k6]LIkB/kFgP02knOW00?WimkFe^OWimh01MkNgP04
c/kNg]kNg]k>g]kN1<k>cP:][JD01Hb<S=k>a]kNg/k>c]kNgP0@oooo1<c<
c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00?oooo<c<c<c<`00lc<
c003IVIVooooc<c<00;<c<`00iVIc?ooooooo`0:oooo00?Ng]k>c]KNg]h0
0/k>eP0>Jf][g]kN_Kg60000FUYJBTY:Ng]k>CTiFUYJJf][BTY:BTYJFUYJ
BTY:0UYJFP0>BTYJFUYJFUYJJf][0000>CTi[Jf]Ng]k61PH>CTic/k>_Kfm
[Jfe_Kg60jf]]@08_KfmNg]kFUY[_Kfm[Jf][Jfe[Jf]kno_2oooo`06VIW<
c<c<c<c<c<c<IVIVoooo2/c<c003IVIVooooc<c<00?<c<`5oooo00?WkoOW
imk>c/h00noWi`03c/JecXaScYak00;_inL00nOWg]kNg]kNgP03g]kN00S>
e]kNg]kNg]kNg]kNg/kFc]K>c/kNg]h2c/k>0[fm_@:LW9`00lkFg/k>c]kN
gP0Aoooo1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`01FIVI/c<c<c<c<c<c6IVIP06c<c<00=VIVKo
ooo<c<`00/c<c003VIW<oooooooo00[oool5g]kN00>LW:G>c]K>c/h00hb<
S003Ng^<S8b<Ng]k00=kNg/00g]kS8b<S7]kN`02Ng]k00YkNhakNg]kNg]k
NhakNg^<S8a[Jg]kNg^<S9Bm_LH2_Kfm00F][KFm_LJ][KF][KFm_Kd00YbL
Y@B][KD<oooo00JIVLc<c<c<c<c<c<aVIVKoool:c<c<00=VIVKoooo<c<`0
0lc<c0Koool03=kNg/k>c^oWinoWilkFg^OWg[EcF/k6[NoWinOWg]KFinOW
gPGNg]h01]kNc/k>g]kNc/k>g]kNc/k>gP?>c/h01[fm_Jfe]IbLW;fm_Lk>
c]kNgQ;oool4c<c<00=VIVKoooo<c<`0olc<c<W<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1<c<c005ooooc<c<c<c<c<c<oooo00O<c<`00fIV
I_ooolc<c002c<c<00>IVLcoooooool02_ooo`06kno_c/k>g]kWc/k>c/kF
g]kN0/k>eP03g]kWg]kNg]kW00?Ng^L2g]kN00KNg^O>c]K>c]KNg^O>c]KN
g]h5c/kF00Zm_LK>c/k>c/k>c/j][KFm_LJ][KFm_Kf][KFm_Kd2[Jfe00Jm
_Kf][KF][KF][Jf][KFm_Kd<oooo00JIVLc<c<c<c<c<c<aVIVKoool:c<c<
00=VIVKoooo<c<`00lc<c0Goool01NogmnoWilk>c_OgklkFgP02knOW00C>
a[GWimkWimkFe^L5g]kN00O>c]kNg]k>e]kNg/k>c]kNg/k>e]h00lk>cP06
_Kfm[KFe[JfU[KFec/Jeg]kN4oooo`C<c<`00fIVI_ooolc<c03oc<c<bLc<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3c<c<00EVIVK<c<c<c<c<
c<aVIVH00lc<c003IVIVc<c<c<c<00;<c<`00fIVI_ooolc<c002c<c<00>I
VLcoooooool02_ooo`06kno_c/kF_Kg6:BTaFUY[kno_0]kNgP03c/kFg]kN
c/kF00K>c]H2c/k>00>m_LK>c]Jm_LH00/k>cP04_Kg6c/k>_Kg6c/k>0kfm
aP03c/k>_Kfm_Kg600:m_Kd01jf]]KfmaZf]]Kfm_IbLW3Ti@UYJFP02_Kfm
3?ooo`06VIW<c<c<c<c<c<c<IVIVoooo2/c<c003IVIVooooc<c<00?<c<`6
oooo00__inO>e]k_inOWimk>e]k_inOWimkFe^OWimkNg]kWimh00mkNgP07
g]k>g]kNg]k>e/kFg]kNc/k>c]KN00;>c/h01lk6]KFmc[fm_Kfm[Jf]YJfe
]MKFi`0Doooo1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00?o
ooo<c<c<c<`00lc<c003IVIVooooc<c<00;<c<`00iVIc?ooooooo`0;oooo
00[_knoNg]jLW:Fm_Kg_knoNg^ONg]kNg^ONg]kNg^L<g]kN00_>c]KNg]k>
c/kNg]k>c]K>c/kNg]k>c/k>c]K>c/k>c]H01Lk>cP05_Kg6c/k>S8b<W9bU
c/k>00goool01YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<c003
c<c<1_ooo`0@koOgknOWmoO_e]KWknOWinONe]KWinONc]KNinONc]KNg]kN
c]KNg]kNc]KNg]kN0/kFgP03c]K>c]KNc/k>00?>c/h01Kfm_Jfe]Jfe]Lk>
c^oWi`0Eoooo1<c<c003IVIVooooc<c<0?o<c<c9c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0G<c<`01FIVI/c<c<c<c<c<c6IVIP06c<c<00=V
IVKoooo<c<`00/c<c003VIW<oooooooo04?oool01YVIc<c<c<c<c<c<c6IV
I_ooo`[<c<`00fIVI_ooolc<c003c<c<1oooo`k_inL02=kNg^oWinoWinoW
imkNg^oWimkNg^oWi`;Ng]h2knOW5oooo`C<c<`00fIVI_ooolc<c03oc<c<
bLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00Goooo<c<c<
c<c<c<coool01lc<c003IVIVooooc<c<00;<c<`00iVIc?ooooooo`13oooo
00JIVLc<c<c<c<c<c<aVIVKoool:c<c<00=VIVKoooo<c<`00lc<c3Soool4
c<c<00=VIVKoooo<c<`0olc<c<W<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`00fIVI/c<c<c<c002
c<c<00=VIVKoooo<c<`00/c<c003VIW<oooooooo04?oool01YVIc<c<c<c<
c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<c003c<c<>?ooo`C<c<`00fIVI_oo
olc<c03oc<c<bLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00Goooo<c<c<c<c<c<coool00lc<c003ooooc<c<c<c<00?<c<`00fIVI_oo
olc<c002c<c<00>IVLcoooooool0@oooo`06VIW<c<c<c<c<c<c<IVIVoooo
2/c<c003IVIVooooc<c<00?<c<`hoooo1<c<c003IVIVooooc<c<0?o<c<c9
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`01FIVI/c<c<c<
c<c<c6IVIP06c<c<00=VIVKoooo<c<`00/c<c003VIW<oooooooo04?oool0
1YVIc<c<c<c<c<c<c6IVI_ooo`[<c<`00fIVI_ooolc<c003c<c<>?ooo`C<
c<`00fIVI_ooolc<c03oc<c<bLc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P4c<c<00Goooo<c<c<c<c<c<coool01lc<c003IVIVooooc<c<00;<
c<a7VIW<0lc<c003IVIVooooc<c<00W<c<`00fIVI_ooolc<c00oc<c<00=V
IVKoooo<c<`0olc<c<W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`00fIVI/c<c<c<c002c<c<00=V
IVKoooo<c<`0C<c<c003IVIVooooc<c<00W<c<`00fIVI_ooolc<c00oc<c<
00=VIVKoooo<c<`0olc<c<W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c005ooooc<c<c<c<c<c<oooo00?<c<`00oooolc<c<c<c003c<c<
00=VIVKoooo<c<`0C<c<c003IVIVooooc<c<00W<c<`00fIVI_ooolc<c00o
c<c<00=VIVKoooo<c<`0olc<c<W<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h1Lc<c005IVIVc<c<c<c<c<c<IVIV00K<c<`00fIVI_ooolc<c01<
c<c<00=VIVKoooo<c<`02Lc<c003IVIVooooc<c<03o<c<`00fIVI_ooolc<
c03oc<c<bLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00Go
ooo<c<c<c<c<c<coool01lc<c003IVIVoooooooo04coool00lc<c?ooolc<
c009c<c<00=VIVKoooooool0?oooo`03c<c<ooooc<c<0?o<c<c9c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0?<c<`01FIVI/c<c<c<c<c<c6IV
IP03c<c<00=VIVK<c<c<c<`00/c<c51VIVH;c<c<@fIVI_o<c<c;c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`01Oooolc<c<c<c<c<c?oo
o`03c<c<00?oooo<c<c<c<`0olc<c?o<c<a]c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0G<c<`01FIVI/c<c<c<c<c<c6IVIP3oc<c<olc<c73<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1<c<c005ooooc<c<c<c<
c<c<oooo0?o<c<coc<c<LLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c003IVIVc<c<c<c<0?o<c<co
c<c<K<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00Goooo<
c<c<c<c<c<coool00lc<c003ooooc<c<c<c<0?o<c<coc<c<KLc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00EVIVK<c<c<c<c<c<aVIVH0
olc<c?o<c<a`c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0C<c<`0
1Oooolc<c<c<c<c<c?ooo`3oc<c<olc<c77<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0lc<c005IVIVc<c<c<c<c<c<IVIV00?<c<`00fIVI/c<
c<c<c03oc<c<olc<c6c<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c005ooooc<c<c<c<c<c<oooo00?<c<`00oooolc<c<c<c03oc<c<olc<
c6g<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1Lc<c005IVIVc<c<
c<c<c<c<IVIV0?o<c<coc<c<L<c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P4c<c<00Goooo<c<c<c<c<c<coool0olc<c?o<c<aac<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0?<c<`01FIVI/c<c<c<c<c<c6IVIP03
c<c<00=VIVK<c<c<c<`0olc<c?o<c<a/c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`01Oooolc<c<c<c<c<c?ooo`03c<c<00?oooo<c<c<
c<`0olc<c?o<c<a]c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<
c<`01FIVI/c<c<c<c<c<c6IVIP3oc<c<olc<c73<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1<c<c005ooooc<c<c<c<c<c<oooo0?o<c<coc<c<
LLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3c<c<00EVIVK<c<c<
c<c<c<aVIVH00lc<c003IVIVc<c<c<c<0?o<c<coc<c<K<c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00Goooo<c<c<c<c<c<coool00lc<
c003ooooc<c<c<c<0?o<c<coc<c<KLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P5c<c<00EVIVK<c<c<c<c<c<aVIVH0olc<c?o<c<a`c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0C<c<`01Oooolc<c<c<c<c<c?oo
o`3oc<c<olc<c77<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0lc<
c005IVIVc<c<c<c<c<c<IVIV00?<c<`00fIVI/c<c<c<c03oc<c<olc<c6c<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c005ooooc<c<c<c<
c<c<oooo00?<c<`00oooolc<c<c<c03oc<c<olc<c6g<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h1Lc<c005IVIVc<c<c<c<c<c<IVIV0?o<c<co
c<c<L<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P4c<c<00Goooo<
c<c<c<c<c<coool0olc<c?o<c<aac<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0?<c<`01FIVI/c<c<c<c<c<c6IVIP03c<c<00=VIVK<c<c<c<`0
olc<c?o<c<a/c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
1Oooolc<c<c<c<c<c?ooo`03c<c<00?oooo<c<c<c<`0olc<c?o<c<a]c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`01FIVI/c<c<c<c<c<
c6IVIP3oc<c<olc<c73<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
1<c<c005ooooc<c<c<c<c<c<oooo0?o<c<coc<c<LLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P3c<c<00EVIVK<c<c<c<c<c<aVIVH00lc<c003
IVIVc<c<c<c<0?o<c<coc<c<K<c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00Goooo<c<c<c<c<c<coool00lc<c003ooooc<c<c<c<0?o<
c<coc<c<KLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P5c<c<00EV
IVK<c<c<c<c<c<aVIVH0olc<c?o<c<a`c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0C<c<`01Oooolc<c<c<c<c<c?ooo`3oc<c<olc<c77<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0lc<c005IVIVc<c<c<c<c<c<
IVIV00?<c<`00fIVI/c<c<c<c03oc<c<olc<c6c<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c005ooooc<c<c<c<c<c<oooo00?<c<`00ooo
olc<c<c<c03oc<c<olc<c6g<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2holc<c?o<c<ajc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<
c<coc<c<N/c<c0:8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;Qm
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h5P00P0<00H0200:000@00X40
0h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2
008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD30Q25
108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN8
0aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<4
88/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh5
9hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T004
1RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLe
TPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE
0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4
V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:
C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM
2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<
G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=
HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU
0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?
L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@
N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d0
0a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<B
R;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>
/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd
0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM
]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<E
Y;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d3
5jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1000P003VjOa<d>U<d>U
00Tc@jD600200`01P0800X001002P@03P@03P@03P@<0184200F100@01H80
1X801X801X8200N200<11h81288128800P48P`<12H<30@Z300<12h<12h@1
2h@00`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8D
Q`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<J
R@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=
12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?
00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@04
1S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC
1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8
@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI
00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YA
W0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]G
W`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<
Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<0
0`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP04
3VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mc
Z@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/
00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<A
Q:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<B
Rk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<3
4i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8D
V[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<E
X;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl
11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`
_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3002000NKYo7ooon>N[JVVlBcZM:XWLRcZM800ZJKa005_;SM
k^kdj^Waoooo<d>U00D0080300600P02P00400:100>100>100>10`04P@80
1H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<12X<0
0`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP04
0Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<I
R@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><
00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5
:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6
<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<3
1cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88
@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9
AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL
10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]F
WP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<
GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<3
3F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>
K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mb
Z0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[
0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62
[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa
4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P02
4hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@D
V;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN
^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk
0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn
00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C08000008H]<0@0000
0QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000BKYo7ooom/
FZF_YLX2_;SM00[ooOncZM;ooooooonl^=fGR[bXWLSVi^cooolc@jD40020
0`01P0800X001002P@03P@03P@03P@<0184200F100@01H801X801X801X82
00N200<11h81288128800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<1
3H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL2
0QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:
0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDU
S@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?
0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B
1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7
>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL3
24:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI
0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YB
W@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO
10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaP
XPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eU
Y0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW
3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY
0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@
OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l0
0a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@B
S;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<C
T[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK
]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T0
11FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l
5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o
5k6o00<G/[l35k>o0QRd`003b>3HB928B92800a8T8P00`000<SPf4R@R00=
B92800@0000H]<0H]<38h=P>B92800<0000H]<0H]<000XS0^058T8P10000
000018S0^<SPf8S0^8S0^08008002i^WlOooojRMb?oook>YdV1<VXij]WQU
[ZRMb?ooooomo`03oooo00<c@jD0080008000`00P0<00H0200:000@00X40
0h400h400h4300B10P05P@0400F200J200J200J20P07PP030@N20@R20@R2
008128<30@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<23hD20Q25
0oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<4
7h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=
1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086
;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7
=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9
@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:
BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<
Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`
Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?
MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd3
4H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<B
Qk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d
0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL
]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d2
5jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G
/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00f8`;P01DR@R000
01Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0P00P00>VjOaoooooooofmc/H4bJThFj/jWB_;SMH4bJ
VHnnYY_4b<?Ooooo<d>U1P00P0?oool200:000<00X7oooooool00_ooo`80
18400`05POooo`05PP0300J21?ooo`030@R20@R3oooo00?oool30@Z300Ko
ool12h@12h@138Coool138@20@f400Coool13XGoool13XD20Pn500Coool2
48Goool248D20Q6600?oool24HH24XH00P8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<3
6hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=
12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5
:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9
AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YA
W@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]G
W`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW
3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mc
Z@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@
OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hA
Q:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H0
11BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ
_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P03
5k6n5k6o5k6o00<G/[l35k>o0QRd`004b>3HR<2hR<2hR<2h1P0000B8`;P0
0dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00
P00>VjOaoooo_;SMVHnnooooe]7Mfmc/lokoYY_4k^kdQGJ`ThFjoooo<d>U
1000P007oooo006000600060oooo00:0oooo00<00h401_ooo`04P@04P@05
POooo`05PP801X802?ooo`07PP07PP47P_ooo`48P_ooo`48P`<12H<01?oo
o`4:P`4:Poooo`812h@00`4<Q?ooo`4<Q0020@f400Coool13XGoool13XD2
0Pn500?oool248Goool00oooo`824HH30Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<K
R@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d4
9Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[
S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO
00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y
00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n
[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64
[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P04
59Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl
00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G
/KhG/KlG/Kl00aNb_`<G/kl26;C000C8h=R8`;R8`;R8`;P6000018S0^003
B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P0
00000QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0^004B9280000
6;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008003i^WlOoo
oiV?_YN:_=CCj>n//omfNnjOZe]HYJJKa9JOdV1<V[bhgOoooc=3Y@030020
00Ooool00H000H000H3oool00X3oool00`03P@06oooo00B100B1oooo00F1
oooo0P06PP08oooo00N200N20@N2oooo0@R2oooo0@R30`49P`09oooo0@Z3
oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?ooo`4>QOooo`4>Q@823hD0
1?ooo`8@QOooo`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`82
5XL010<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X3
0af:0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=
0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l3
1Rf@0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86
<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`Li
U0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8
@YL224>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T3
2DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M
0P]BW@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l4
2eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R
362R362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT
00<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>
KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T3
3gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n
[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`03
4HF_1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:<
/Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B
]1>B]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g
59^g59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@04
5J6i0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`F
ZkdFZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG
/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8
`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3H
R<2hR<2h00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOX
ZFjPb<?OThFjFdJCVHnn0WQU[P04@RN5[jG:oooo<d>U1000P0<00H000ooo
o`02P002P@04oooo0P04P@03oooo00F1oooo00<01X84oooo00<1288128<1
28<00`49P`09oooo0@Z3oooo0@^3oooo0@^4oooo0@b4oooo00813H@01?oo
o`4>QOooo`4>Q@823hD00oooo`8@QOooo`03oooo0P8AQP<24XH20Q>600@2
4hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR0030aV80aV9
0aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@RS0@48h`0
10@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZ
SPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A1S2A0`Ha
T@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7
=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0
UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9AIP00`U6
V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>V`<:Ci`4
2U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh32eJN
00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aM
X@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ800PeRX`<=
Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/
YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?LJP33g:X
00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/3
47b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^
0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@BRK4BR[4B
R[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008C
Sk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D359Ne11BH
]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh5Ijh5Ijh
0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`<FYk/3
5ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;
R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0
^4R@R00000026;C000?8h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H
]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOaoooo
oooo00;oool02_n]/?mfNoW=e?g]k_ooojJKa8Ef/;bhgOoooc=3Y@D00803
006000?oool00X000X400`03P@03oooo00B1oooo00801H401005P_ooo`06
PP06PP801h800`47P_ooo`48PP020@R30oooo`812X<01oooo`4;Poooo`4;
Q?ooo`4<Q?ooo`020@f400Coool13XGoooooool20Pn500Koool248Goool2
48D24HKoool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<4
7XX311n;0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd0
0`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6
;Y021Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHd
TP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD
0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3
U`042D>H2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9
BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd3
2e>M00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<
FZ0335^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaP
XP8<HJ800`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT
0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_
Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?
MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd2
4Gn]0a60[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@A
QZl34XN`0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8B
SK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@0
0a>C]0<CU;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK
]`<DW;L259fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<E
X[T35J>j0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m
5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<0
0028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0
^004R<2h0P0000F8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P3002000ZQ[?;icMCR9Scd]KoR9ScdKGglhnWoooomkNko
[K02oooo00<c@jD0080008001000P0<00H000oooo`02P002P@03oooo0P04
P@05oooo00F100F100F2oooo00801X83oooo0P48PP030@R3oooo0@V30081
2H<20@Z300Coool12h<12hCoool20@b400Ooool13H@13HCoool13XGoool1
3XD00_ooo`030Pn50Q250Q2500Coool0108AQP8BQP8BQP8BQP824hH0108C
Q`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP30aR800<36HP36HT3
6HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@PR`<48H/312:<10@SS004
12B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>
1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6;i46<946<946<9431S6A
0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`Lg
T`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F
00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH2DBH2DBH0`U5V0032DJH
2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`<:CI/32TjK0`Y?W0@:
D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP<;EYh0
0`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ
0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQXPeRXPeRXP023F:S0`eS
X`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`Z0maZ0maZ0maZ0<?LZP0
0`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`<@
O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh3
4H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8/08BRK0011:9/A::/A::
/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?
/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@34iFe0aBF]@<DUkD459Rf
0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg00@EWKPEW[PEW[PEW[P3
5Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk0aJW^`<F
Z;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G[Kd00aN^_AN^_QN^_P03
5jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8
`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2h
B9280000008H]<000lSPf8S0^8S0^003R<2h100000B8`;P014R@R00001Rd
`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000fKYo7mkNkR
9ScnmOSgRIOdHVkcX:kdHVkooOoo[K3lhnWooolc@jD01`00P0<00H000ooo
o`02P002P@0300>10`04P@801H401005PP06PP06PP06PP801h801@47PP48
PP48P_ooo`48P`030@V30`4:P`030@^30@^40@^400<138@30@f40`4>Q@<2
3hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ8
0aN80aN80aN80`<HR0030aV80aV90aV900@36XT30a^90`<LRP<37HX311j:
0`@OR`<488/3126;0`@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<5
9hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@
0PH_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=980
0`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7
>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL0
10U3V0U4V0U4V0U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ
0`Y;VP<:C9/32TfK0`Y>V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]C
W@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP
0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82
366R00<=HJ8=HZ8=HZ800PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=
Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL2
3W2W00@?L:P?LJP?LJP?LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ
0`mgZP<@N:X347V[0a1jZ`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o
[@<AP:d00a61[A61[Q61[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_
0a:7/0<BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb
4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<C
Tk@34iBd0a>E]@<DU[D359Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL3
59bg0QBM]`045Ifh5Ijh5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i
0aFS^P<EY;X35ZFj0aJV^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/
_@8G[;d35jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o
0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000
R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P0
0XS0^0800002R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000>KYo7fb<cR9S`00_n]/007gb@^ojBN
m[c5ojf`kW^<oooo<d>U00P00803006000?oool00X000X400`03P@<01842
00F100@01H801X801X801X8200N200D11h81288128;oool128<00`49P`04
oooo0@Z30@Z30@^30P4;Q0<138@30@f40`4>Q@<23hD30Q25108AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN80`<HR003
0aV80aV90aV900@36XT30a^90`<LRP<37HX311j:0`@OR`<488/3126;0`@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`031B^?10D/S`<6;I031Rj@0PH_T0041RnA1S2A1S2A
1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC
0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0<7>iD323bE0`PmU@@8?YH3
23nF0PQ0UP04242G246G246G246G0`Q2U`88@iL010U3V0U4V0U4V0U4V0<9
AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/32TfK0`Y>
V`<:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aM
X@aMX@aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00<=HJ8=HZ8=HZ80
0PeRX`<=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU0`iYY@<>JZD4
3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00@?L:P?LJP?LJP?
LJP33g:X00<?LjP?LjT?LjT010mdZ@<?MJT33gJZ0`mgZP<@N:X347V[0a1j
Z`<@Nj/347b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61
[P034H:^0a63[P034HB^4HB_4HB_00<AQJl44HJ_0a:7/0<BR;024XV`00@B
RK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb
4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd0a>E]@<DU[D3
59Ne11BH]P<DVKH259Zf00@DV[LDVkLDVkLDVkL359bg0QBM]`045Ifh5Ijh
5Ijh5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`<FYk/35ZRk0aJY_0@FZ[`011J[_1J[_AJ[_AJ/_@8G[;d35jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0
^8S0^00;R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H
]<38h=P00hS0^0800004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7icMCgRIL00_ooo`07
ojf`hAHdogIkojBNhRHlohUo<d>U00P00803006000?oool00X000X400`03
P@<0184200F100@01H801X801X801X8200N200@11h812881288128<4oooo
0`4:P`030@^30@^40@^400<138@20@f400Coool13XD13XD13XD30Pn50`8@
Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<G
R0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3
122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>
1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i00
10H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987
=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`Pl
U@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9
A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX3
2TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]D
W@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj02
35bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP03
3F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eX
Y@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`04
3g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX3
47RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]
00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk03
4XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8B
S[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D
]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8D
WKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX3
5JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm
0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl2
6;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P900000XS0^005
B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000NKYo7oooocX:kdHVkoooogRIOicM@0
0_ooo`03lj2^oooo<d>U00P0080300600P02P00400:100>100>100>10`04
P@801H401005PP06PP06PP06PP801h800`47PP48PP48PP020@R30`49P`<1
2X<00`4;P`4;Q04;Q0030@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8C
QP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0<368P00`<I
R0<IR@<IR@040aZ90`<KR@<378X30af:0`@NRP<47h/3122;0`@QR`<48X`4
12><00@498`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@0`H^T086;i0010H_T@H`T@H`T@H`
T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7
=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00@9@iP9A9P9A9P9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK0`Y=V`<:CY/3
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<
GJ4<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP033F6R3F:R3F:R008=
HZ<33F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@<>JJD33VZU10i[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`043g2X3g6X3g6X3g6X
0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/3
47^[0a1l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh0
0a62[P<APjh00a64[Q64[a64[`034HF_1166[`<BQk034XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?
/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0<CUKD359Je0aBG
]@@DV;H359Vf0QBJ]P0459Zg59^g59^g59^g0aBL]`8DWKL011FM^1FN^1FN
^1FN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/3
5ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdFZkdF[;d25jbm0aN]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00
P00;VjOaooooohUooooolj2^lI>Qoooooogolj2^oo_l<d>U00P008030060
0P02P00400:100>100>100>10`04P@801H401005PP06PP06PP06PP801h80
0`47PP48PP48PP020@R30`49P`<12X<00`4;P`4;Q04;Q0030@b40`4=Q0<1
3XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0<368P00`<IR0<IR@<IR@040aZ90`<KR@<378X30af:
0`@NRP<47h/3122;0`@QR`<48X`412><00@498`498d498d49Hd21BF=0`DV
S@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl00`D[S`@5;8l31Rf@
0`H^T086;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i82
1SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7
>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL2
24>G00@9@iP9A9P9A9P9A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ
0`U:VP<:BiX32TbK0`Y=V`<:CY/32TnL10Y@W0042U6L2U6M2U6M2U:M0P]B
W@<;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO
0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@0435nR362R362R
362R0PaQXP033F6R3F:R3F:R008=HZ<33F>S0`eTX`033FFS3FFT3FFT00<=
IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL3
3VnW0Pi`Y`043g2X3g6X3g6X3g6X0`mbZ0033g>X3g>Y3g>Y00@?M:T33gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[0a1l[0@@OJ`0111n[11n[A1n[A1o
[@8AOjd34H2]00<APJdAPJhAPJh00a62[P<APjh00a64[Q64[a64[`034HF_
1166[`<BQk034XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=
/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B
]0034i>d0a>D]0<CUKD359Je0aBG]@@DV;H359Vf0QBJ]P0459Zg59^g59^g
59^g0aBL]`8DWKL011FM^1FN^1FN^1FN^0<EWkP00aFP^1FP^AFP^@045J6i
0aFR^@<EXkX35JBj0aJU^P<FY[/35ZNk0aJX^`<FZK`45ZZl00@FZk`FZkdF
ZkdF[;d25jbm0aN]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl0
0aNb_`<G/kl26;C03lSPf0030000b>3Hb>3H00g8h=P00`0001Rd`1Rd`00?
b>3H00<0000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0^8S0^0@0
0803VjOa00KoooocX:kd]Kof_<GkfMXc@jD900200`01P0800X001002P@03
P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h8128812880
0P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<248D4
0Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP3
5hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;0`@P
R`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDW
SP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@00@6
;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB
1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8?9D3
23fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H2DBH
2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<
V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;
E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaL
X00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ800`eQ
XPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D3
3VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L010m`
Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ0a1h
ZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@03
4H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`0a:8
/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb
00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@3
4iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L259fg
00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT
^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/_@<G
[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PF00200`01P0800X001002
P@03P@03P@03P@<0184200F100@01H801X801X801X8200N200<11h812881
28800P48P`<12H<30@Z300<12h<12h@12h@00`4<Q0<13H@30@j50`8?Q@<2
48D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP3
5hP35hP30aR800<36HP36HT36HT010<JR@<36hT30ab:0`<MRP<47XX311n;
0`@PR`<48H/312:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DW
SPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00<5:hl41Bb?0`H]T0<6;Y021Rn@
00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB
1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD0`LkU@<8
?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`042D>H
2DBH2DBH2DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J
0`Y<V`<:CI/32TjK0`Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;
E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P
0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ80
0`eQXPeRXPeRXP023F:S0`eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=
J:D33VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L0
10m`Z0maZ0maZ0maZ0<?LZP00`mcZ0mcZ@mcZ@043gBY0`meZ@<?MZX33gNZ
0a1hZP<@NJ/347Z[0a1kZ`<@O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60
[@034H6]4H6^4H6^00<APZh34H>^00<AQ:hAQ:lAQ:l00a65[`@AQZl34XN`
0a:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK82
4Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<C
U;@34iFe0aBF]@<DUkD459Rf0aBI]P8DV[H011BJ]aBK]aBK]aBK]`<DW;L2
59fg00@EWKPEW[PEW[PEW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j
0aFT^P<FYKX35ZJk0aJW^`<FZ;/35ZVl11JZ_0045Z^l5Z^m5Z^m5Zbm0QN/
_@<G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o
=QRd`0:8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;QmR<2h0DR@
R04000000003R<2hb>3HR<2h0?n8`;SoR<2hOHS0^058T8P1000000000hS0
^<SPf<SPf03ob>3HolSPf7g8h=P1B9280@000000ohS0^?n8`;R1R<2h0@00
0000\
\>"], "Graphics",
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:00001h2000`400?l0
0000o`00003oooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`l?000?oo
l?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?ool?3`P_o`
l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003ooo3`l?oo
l?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;ol?3`003o
oo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000ooo`l?3ooo3`l8;o
l?3`003ooo3`l?ool?3`P_o`l?000?ool?3`ooo`l?22oo3`l000oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool0
0?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_oo
ool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_oo
k^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003o
onKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;o
oooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^ko
onk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00
oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2
ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^
ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h0
0?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooooooo
P_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^
k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^
003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooo
oh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^
k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^
kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooo
oon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?oo
k^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^
k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooooooo
ooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003o
onk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;o
k^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooo
oooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00
ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2
onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooo
oooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H0
0?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^
P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003ooooo
ooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV
003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^
kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooo
oooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKV
iP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^
k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oo
oooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oV
i^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^k_oo
k^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003o
ooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;o
i^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^k^ko
onk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00
oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2
onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?ook^k^
ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h0
0?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KV
P_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003oonk^
k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;ok^k^
003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^KoonKV
iX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00ooo^
k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^
kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KVoooV
i^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool00?oo
k^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^P_o^
k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKVi_oo
i^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo003o
onk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^kX;o
k^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooVi^Ko
onKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2ooooo`00
ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^k^j2
onk^kP00oooooooooooooh;ooooo003oonk^k_ook^k^P_o^k^h00?ooi^KV
oooVi^J2onKViP00ooo^k^koonk^kX;ok^k^003oooooooooooooP_ooool0
0?ook^k^ooo^k^j2onk^kP00oooVi^KoonKViX;oi^KV003oonk^k_ook^k^
P_o^k^h00?oooooooooooon2ooooo`00ooo^k^koonk^kX;ok^k^003oonKV
i_ooi^KVP_oVi^H00?ook^k^ooo^k^j2onk^kP00oooooooooooooh;ooooo
003oonk^k_ook^k^P_o^k^h00?ooi^KVoooVi^J2onKViP00ooo^k^koonk^
kX;ok^k^003oooooooooooooP_ooool00?ook^k^ooo^k^j2onk^kP00oooV
i^KoonKViX;oi^KV003oonk^k_ook^k^P_o^k^h00?oooooooooooon2oooo
o`00ooo^k^koonk^kX;ok^k^003oonKVi_ooi^KVP_oVi^H00?ook^k^ooo^
k^j2onk^kP00oooooooooooooh;ooooo0002onk^kP06ohZ:R_oLg=cooooo
oooooon:RX[og=cL0_ooooooonk^k_ook^k^N?o^k^h000;oi^KV00?ooooo
ohZ:R_oLg=`00_ooool00on:RX[og=cLooooo`3oonKVi_ooi^KVN?oVi^H0
00;ok^k^0_ooool01_n:RX[og=cLooooooooooooRXZ:omcLg?ook^k^ooo^
k^ihonk^kP001Oooool01On:RX[og=cLooooooooooooRXZ:0?oooooooooo
oomhooooo`000_o^k^h01_n:RX[og=cLooooooooooooRXZ:omcLg0;ooooo
ooo^k^koonk^kWSok^k^0002onKViP03oooooon:RX[og=cL00;ooooo00?o
RXZ:omcLg?ooool0oooVi^KoonKViWSoi^KV0002onk^kP;ooooo00KoRXZ:
omcLg?ooooooooooohZ:R_oLg=coonk^k_ook^k^N?o^k^h000Gooooo00Go
RXZ:omcLg?ooooooooooohZ:RP3oooooooooooooN?ooool000;ok^k^00Ko
RXZ:omcLg?ooooooooooohZ:R_oLg=`2ooooooook^k^ooo^k^ihonk^kP00
0_oVi^H00oooooooRXZ:omcLg002ooooo`03ohZ:R_oLg=cooooo0?ooi^KV
oooVi^IhonKViP000_o^k^h2ooooo`06ohZ:R_oLg=cooooooooooon:RX[o
g=cLooo^k^koonk^kWSok^k^0005ooooo`05ohZ:R_oLg=cooooooooooon:
RXX0ooooooooooooogSooooo0002onk^kP06ohZ:R_oLg=cooooooooooon:
RX[og=cL0_ooooooonk^k_ook^k^N?o^k^h000;oi^KV00?oooooohZ:R_oL
g=`00_ooool00on:RX[og=cLooooo`3oonKVi_ooi^KVN?oVi^H000;ok^k^
0_ooool01_n:RX[og=cLooooooooooooRXZ:omcLg?ook^k^ooo^k^ihonk^
kP001Oooool01On:RX[og=cLooooooooooooRXZ:0?oooooooooooomhoooo
o`000_o^k^h01_n:RX[og=cLooooooooooooRXZ:omcLg0;oooooooo^k^ko
onk^kWSok^k^0002onKViP03oooooon:RX[og=cL00;ooooo00?oRXZ:omcL
g?ooool0oooVi^KoonKViWSoi^KV0002onk^kP;ooooo00KoRXZ:omcLg?oo
ooooooooohZ:R_oLg=coonk^k_ook^k^N?o^k^h000Gooooo00GoRXZ:omcL
g?ooooooooooohZ:RP3oooooooooooooN?ooool000;ok^k^00KoRXZ:omcL
g?ooooooooooohZ:R_oLg=`2ooooooook^k^ooo^k^ihonk^kP000_oVi^H0
0oooooooRXZ:omcLg002ooooo`03ohZ:R_oLg=cooooo0?ooi^KVoooVi^Ih
onKViP000_o^k^h2ooooo`06ohZ:R_oLg=cooooooooooon:RX[og=cLooo^
k^koonk^kWSok^k^0005ooooo`05ohZ:R_oLg=cooooooooooon:RXX0oooo
ooooooooogSooooo0002onk^kP06ohZ:R_oLg=cooooooooooon:RX[og=cL
0_ooooooonk^k_ook^k^N?o^k^h000;oi^KV00?oooooohZ:R_oLg=`00_oo
ool00on:RX[og=cLooooo`3oonKVi_ooi^KVN?oVi^H000;ok^k^0_ooool0
1_n:RX[og=cLooooooooooooRXZ:omcLg?ook^k^ooo^k^ihonk^kP001Ooo
ool01On:RX[og=cLooooooooooooRXZ:0?oooooooooooomhooooo`000_o^
k^h01_n:RX[og=cLooooooooooooRXZ:omcLg0;oooooooo^k^koonk^kWSo
k^k^0002onKViP03oooooon:RX[og=cL00;ooooo00?oRXZ:omcLg?ooool0
oooVi^KoonKViWSoi^KV0002onk^kP;ooooo00KoRXZ:omcLg?oooooooooo
ohZ:R_oLg=coonk^k_ook^k^N?o^k^h000Gooooo00GoRXZ:omcLg?oooooo
ooooohZ:RP3oooooooooooooN?ooool000;ok^k^00KoRXZ:omcLg?oooooo
ooooohZ:R_oLg=`2ooooooook^k^ooo^k^ihonk^kP000_oVi^H00ooooooo
RXZ:omcLg002ooooo`03ohZ:R_oLg=cooooo0?ooi^KVoooVi^IhonKViP00
0_o^k^h2ooooo`06ohZ:R_oLg=cooooooooooon:RX[og=cLooo^k^koonk^
kWSok^k^0005ooooo`05ohZ:R_oLg=cooooooooooon:RXX00_ooool@oh:2
PP03oh>3Pon2PX;oPX:200;oPX:200?oPh>3oh:2P_n2PX803?n2PX800on3
Ph?oPX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2
P_n2PX800_n2PX800on3Ph?oPX:2oh:2PP0;oh:2PP[ooooo4?n2PX800on3
Ph?oPX:2oh:2PP02oh:2PP03oh>3Pon2PX;oPX:200coPX:200?oPh>3oh:2
P_n2PX800_n2PX800on3Ph?oPX:2oh:2PP0<oh:2PP03oh>3Pon2PX;oPX:2
00CoPX:2oooooooQooooo`000_o^k^h01_n:RX[og=cLooooooooooooRXZ:
omcLg0;ooooo0_o^k^h01?n3Ph?ogMgMonSXj?o_knl5oo7al@03oo3`l?oa
lO7olO7a00OolO7a00?ol?3`oo7alOoalO400_o_knl5oo7al@03oo3`l?oa
lO7olO7a00OolO7a00?ol?3`oo7alOoalO400_o_knl5oo7al@03oo3`l?oa
lO7olO7a00OolO7a00?ol?3`oo7alOoalO400_o_knl5oo7al@06oo3`l?oa
lO7olO7aon[Zj_oKfm_oPh>32_o^k^h01?n3Ph?ogMgMonSXj?o_knl5oo7a
l@03oo3`l?oalO7olO7a00OolO7a00?ol?3`oo7alOoalO400_o_knl5oo7a
l@03oo3`l?oalO7olO7a00OolO7a00?ol?3`oo7alOoalO400_o_knl5oo7a
l@03oo3`l?oalO7olO7a00OolO7a00Col?3`on[Zj_oKfm_oPh>3ooo^k^kQ
onk^kP000_oVi^H00oooooooRXZ:omcLg002ooooo`03ohZ:R_oLg=cooooo
00;oi^KV00CoQ8B4on3Ph?oclo?oo?cl1?ono_h00oomoOgoo_knoogmo@02
oogmo@;oo_kn0oomoOd4ooknoP;oo?cl1?ono_h00oomoOgoo_knoogmo@02
oogmo@;oo_kn0oomoOd4ooknoP;oo?cl1?ono_h00oomoOgoo_knoogmo@02
oogmo@;oo_kn0oomoOd4ooknoP;oo?cl1?ono_h01oomoOgoo_knoogmoOom
oOgomOGeon7QhOn3Ph<02_oVi^H01?n4Q8Coh>3Poo?cloolo?`4ooknoP03
oogmoOono_kooOgm00;ooOgm0_ono_h3oogmo@Coo_kn0_olo?`4ooknoP03
oogmoOono_kooOgm00;ooOgm0_ono_h3oogmo@Coo_kn0_olo?`4ooknoP03
oogmoOono_kooOgm00;ooOgm0_ono_h3oogmo@;oo_kn00?omOGeon7QhOn3
Ph<0oooVi^KQonKViP000_o^k^h2ooooo`06ohZ:R_oLg=cooooooooooon:
RX[og=cL0_o^k^h01?n4Q8Coh>3PooGemOono_hBooooo`;oo_kn4_ooool2
ooknoQ;ooooo0_ono_h8ooooo`03ooKfm_oTi>CoPh>300[ok^k^00CoQ8B4
on3Ph?oemOGoo_kn4_ooool2ooknoQ;ooooo0_ono_h@ooooo`03ooKfm_oT
i>CoPh>30?ook^k^hOo^k^h000Gooooo00GoRXZ:omcLg?ooooooooooohZ:
RP02ooooo`03oh>3PooOgmoolO7a04Gooooo00?ol_;bon3Ph?n3Ph<02_oo
ool00on3Ph?ogmoOoo7al@0hooooo`04oo_knoobl_;oh>3Poh>3Pooooooo
hOooool000;ok^k^00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2ooooo`;o
k^k^00?oPh>3omoOgooalO40AOooool00oobl_;oh>3Poh>3P`0:onk^kP03
oh>3PooOgmoolO7a03Sooooo00Cono_koo;bl_oPh>3oPh>3ooo^k^kQonk^
kP000_oVi^H00oooooooRXZ:omcLg002ooooo`03ohZ:R_oLg=cooooo00;o
i^KV00?oPh>3omoOgooalO40AOooool00oobl_;oh>3Poh>3P`0:onKViP03
oh>3PooOgmoolO7a00gooooo00?okoOgooooooo_moL00_ooool00oo_moOo
ooooooooo`02ooooo`03onogmoooooookoOg00;ooooo00?okoOgoooooooo
ool06Oooool01?okno_ol_;bon3Ph?n3Ph?oonKVi^7oi^KV0002onk^kP;o
oooo00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2onk^kP03oh>3PooOgmoo
l?3`04Gooooo00?ol_;bomoOgon3Ph<02_o^k^h00on3Ph?ogmoOoo3`l007
ooooo`03onoWioogmnooknOW01_oknOW00Coe]KWonoWioo_inOoe]KW1_o_
inL00oo_moOoooooooooo`06ooooo`04oo[jn_obl_;ogmoOoh>3Poook^k^
hOo^k^h000Gooooo00GoRXZ:omcLg?ooooooooooohZ:RP02ooooo`03oh>3
PooOgmool?3`00_ooooo00Gokno_ooooooo_knookno_ooooo`03ono_k`04
ooooooo_knookno_ooooo`?okno_00Coooooono_koo_knoooooo0_o_knl0
0oooooookno_ooooo`02ono_k`05ooooooo_knookno_ono_koooool00oo_
knl01Oooooookno_ooooooo_knoooooo00;okno_00?oooooono_koo_knl0
0_o_knl00oooooookno_ooooo`09ooooo`03oo;bl_oOgmooPh>300[ooooo
00?oPh>3omoOgoo`l?001_ooool03_ogmnoog]kNolk>g_nm_Kgo]Kg>olk6
]One_Lkoc/JeokFmc_o>a[Go_KfmokFmc_o>a[Go]Kg>0onm_Kd01oo>c/ko
_KfmolJm_One_Lkoc/JeolJm_One_Lh00_nm_Kd01Oo6_Kgo]Kg>okfm_Oo6
_Kgo]Kg>00?o_Kfm00Woc/k>okfm_Onm_Kgoa[fmokFmc_nm_Kgoc/k>olkF
g_o_inL01oooool01?ojn_[ol_;bomoOgon3Ph?oooooon7ooooo0002onk^
kP06ohZ:R_oLg=cooooooooooon:RX[og=cL0_ooool2onk^kP03oh>3PooM
gMgokno_00Wooooo0_o_knl00ooNg]koc/k>omkNgP02olk>cP;og]kN00Go
c/k>olk>e_oNg]koc/k>olk>eP02omkNgP03olk>c_o>c]Kog]kN00;oc/k>
00Kog]kNolk>c_o>c/kog]kNolk>c_oNg]h2olk>cP04omkNg_o>c/kog]kN
olk>cP;og]kN0_o>c/h01OoNg]koc/k>omkNg_o>c/kog]kN00;oc/k>0_oN
g]h2olk>cP;og]kN00?okno_ooooooooool01oooool00ooalO7oh>3Poh>3
P`0:onk^kP03oh>3PooMgMgokno_00Kooooo00Gog]kNolk>c_n][JGo[JfU
oibLY@0AoibLW003oibLYOn]YICoW9bU00;oW9bL00Oo[JFDoibLYOnLW9co
W9bLojf]YOnLW9coW9bU00;oW9bL00?o[JfUoibLW?nLW9`00_n][JD00oo>
c/kog]kNonogm`06ooooo`04ooKfm_oalO7oh>3Poh>3Poook^k^hOo^k^h0
00;oi^KV00?oooooohZ:R_oLg=`00_ooool00on:RX[og=cLooooo`02onKV
iP03oh>3PooMgMgokno_00Wooooo00?okno_olk>c_n][Jd01On][Jd01?nL
W:Go[Jf]ojf][OnLW:D3ojf][@04oibLYOn][Jgo[Jf]oibLY@;o[Jf]00Ko
W9bUojf][On][JgoW9bUojf][OnLW9`4ojf][@04oibLYOn][Jgo[Jf]oibL
Y@;o[Jf]00GoW9bUojf][OnLW:Go[Jf]oibLY@03ojf][@07oibLYOn][Jgo
[Jf]ojf][Onm_Kgoc/k>ono_k`08ooooo`03oo7alOoPh>3oPh>300[oi^KV
00?oPh>3omgMgOo_knl01_ooool00oo_inOog]kNooooo`0Vooooo`;og]kN
00?oknOWooooooooool01?ooool01?ofm_KolO7aon3Ph?n3Ph?oonKVi^7o
i^KV0002onk^kP;ooooo00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2onk^
kP03oh>3PooMgMgok^k^00Sooooo00Kokno_omkNg_n][JgoS8b<og]kNom[
Jf/Fog]kN`03of][NomkNg_oNg]k01;oNg]k00CoNg^<oibLW?o>c/kog]kN
2?ooool00ooalO7ogmoOoh>3P`0:onk^kP03oh>3PooMgMgok^k^00Kooooo
00?og]kNolkFc_ooool04oooool00oogmnooooooooooo`02ooooo`05onO_
moooooooooooooooooo_inL00_ooool00oo_inOoooooonO_m`02ooooo`04
onogmoooooooinONolk>cPOooooo00ComOGeoo7alOoOgmooPh>3ooo^k^kQ
onk^kP001Oooool01On:RX[og=cLooooooooooooRXZ:00;ooooo00?oPh>3
omgMgOo^k^h02?ooool00oo_knooc/k>of][J`02odY:FP0=oeYJF_m:BT[o
BTYJocTi@_m:BU[o>CU2odY:B_m:BU[o>CU2odY:B_li>D;oBTY:ocTi@P02
odY:BP05odY:F_li>D;oBTY:odY:B_m:BUX00_m:BTX00om:BU[oBTY:odY:
BP02odY:BP06odY:F_m:BT[oBTY:odY:F_m:BT[oBTYJ0om:BTX01?m:BU[o
BTY:odY:F_m:BTX2odY:FPCoFUYJ00?oS8bDomkNg_ooool01oooool00ooa
lO7ogmoOoh>3P`0:ooooo`03oh>3PooMgMgok^k^00Gooooo00?oinogonOW
g_o>e]h00_ooool00oo_moOoooooooooo`0;ooooo`03onogmooooooooooo
00?ooooo00?oinogooooooooool02_ooool01oo_inOooooooooooooooooo
g]kNolkFg_o_inL01_ooool01?oemOGolO7aomoOgon3Ph?oooooon7ooooo
0002onk^kP06ohZ:R_oLg=cooooooooooon:RX[og=cL0_ooool2onk^kP03
oh>3PooMgMgok^k^00Sooooo00Sokno_okfm_Om:BT[oJf][of][NomJFW?o
Jf]kodY:BP?o>CTi01Oo:BTaocTi>Oli>CWo>CU2odY:F_mJFU[oFUY[oeYJ
F_m[Jf_oFUY[of][JomJFV_oFUYcocTi>OmJFU[o>CU2oeYJJoli>CWoBTYJ
ocTi@_m:BU[o>CU2odY:BP02ocTi@P08odY:F_li>CWoFUY[of][JomJFV_o
Jf][oeYJJom:BTX2oeYJJ`07of][JomJFV_oJf]kog]kNomJFV_oJf][omkN
gP08ooooo`03oo3`l?oPh>3oPh>300[ok^k^00?oPh>3omgMgOo^k^h01_oo
ool00ooNg]kog/k6ooooo`0Aooooo`03onogmooooooooooo00;ooooo00?o
mnoWooooooooool00_ooool01?oWkoOooooooooooooWkoL5ooooo`05onoW
ioooooooknOWolk>c_o_moL01_ooool01?oemOGol?3`on3Ph?n3Ph?oonk^
k^7ok^k^0002onKViP03oooooon:RX[og=cL00;ooooo00?oRXZ:omcLg?oo
ool00_oVi^H00on3Ph?ogMgMonc/k009ooooo`07ojf][Om:BU[oFUY[oeYJ
Jom[Jf_oJf]kodY:FP03obTY<@03ocTi>Om:BT[oBTYJ00;oFUY[00?oFUYJ
oeYJJomJFV/00omJFV/02_m[Jf_oJf]kocTi>Om:BU[o>CU2oeYJF_lY:C7o
FUYJobTY<Om:BTX2ocTi@P0<odY:F_li>CWoBTYJobTY:Om[Jf_oFUY[of][
NomJFW?oNg/@onO_0?m:DS7oJf]k0_mJFV/2of][N`03oeYJJom[Jf_og]kN
00Sooooo00?okno_omoOgon3Ph<02_oVi^H00on3Ph?ogMgMonc/k005oooo
o`03ooOgkooWg]koc]KN00kooooo00?okoOgooooooooool01?ooool00oog
mnooooooooooo`0:ooooo`03onogmoooooooinog00;ooooo00?og]kNolkF
c_o_inL01_ooool01?ofm_Kokno_omoOgon3Ph?oonKVi^7oi^KV0002onk^
kP;ooooo00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2onk^kP03oh>3PooM
gMgok>c/00Sooooo00?okno_ojf][Oli>D800_mJFV/01Om[Jf_oJf]kodY:
B_lH61So>CU200;oBTYJ0_mJFUX04om:BU[oFUYJoeYJJomJFU[oFUY[of][
JomJFV_oJf][oeYJJom[Jf_o>CU2odY:F_li>CWoFUY[ocTi>Om:BU[o>CTi
odY:F_li>D800_m:BTX01?li>D;oBTYJobTY<OmJFV/2of][J`03oeYJLomc
Ne[o[Jda00?oJf][00OoFUY[of][Jom[Jg_oJf][oeYJJooNg]kokno_00Oo
oooo00?okno_omoOgon3Ph<02_o^k^h00on3Ph?ogMgMonc/k006ooooo`03
omkNg_o>c/kooooo00?ooooo00[oknOWolk>c_o_inOokoOgoooooooWkoOo
ooooonoWioo>c/koknOW0_ooool00oo_moOoooooomkNgP05omkNgP06omK>
e_n4Ng?oW6]SojekHoo>_JGoU8b<0_n]Nf<02_nm_Kgoc/JeomkNc_o>a[Go
_Kf]onO_mooooooog]kNolk>c_o_moL6ooooo`04ooKfm_o_knoogmoOoh>3
Poook^k^hOo^k^h000Gooooo00GoRXZ:omcLg?ooooooooooohZ:RP02oooo
o`03oh>3PooMgMgok>c/00Sooooo00Gokno_oibLW?m:BT[oFUY[of][J`02
of][N`04ocTi@_lY:C7oBTY:odY:BP?oBTYJ00?oFUYJoeYJJomJFUX00omJ
FV/02om[Jf_oHeY[of][Jom[Jg_o>CU2odY:F_li>D;oFUY[ocTi>Om:BU[o
>CTi00;oBTY:00So>CU2odY:F_li>CWoFUYJocTi>OmJFV_oJf][oeYJJ`;o
Jf]k00[oFUYcof][Nom[Jg_oFUY[of][JomJFV_oNg]koeYJLomJFU[oc/k>
2?ooool00oo^k^koh>3Poh>3P`0:ooooo`03oh>3PooMgMgok>c/00Kooooo
00Coe]KWomkNc_ooooooknOW0_nm_Kd01Oo>c/koW9bLojfe]Oo>c/kokoOg
00;o[JfU0_nLW9`07On<S8co_Kfmojf]YOo_inOoooooonOWg_o_inOomoO_
onoWioogknOoinONomk>a_mBBT;oNa08oh@H4?n]Nf?oU48aog<H4?nL<B7o
cZF4omkNc_o_ilkog]k>olk6]Oo_inOoooooomkNg_o>e]koknOW00Kooooo
00Com_Kfonk^k_oPh>3oPh>3oooooooQooooo`000_o^k^h01_n:RX[og=cL
ooooooooooooRXZ:omcLg0;ooooo0_o^k^h00on3Ph?ogMgMonc/k008oooo
o`03ono_komkNhcoBTY:00;oFUY[0_m[Jg/2ocTi>@03ocTi@_m:BU[oBTY:
00?oBTYJ00?oFUYJoeYJJomJFUX01OmJFV/03om[Jf_o:BTaoeYJF_lY:C7o
FUY[obTY<Om:BU[o:BTaodY:F_li>CWo>CU2odY:B_lY:C7oBTYJobTY:@02
oeYJJ`07of][JomJFV_oJf]kof][Jom[Jg_oFUY[of][N`02oeYJJ`05of][
Nom[Jf_oBTYJokfma_o_knl01oooool00oo^k^koh>3Poh>3P`0:onk^kP03
oh>3PooMgMgok>c/00Gooooo00?omoO_onOWg_o>e]h00_ooool00ooFc]Ko
g]kNonoWi`02omkNgP07onoWioooooooe]KWonoWioo>e/kog]kNokfm_@02
omkNgP;ooooo01Soc/k>ohBDU?nLW:GoW9bLog^4Q?m[Lg?oFV][odXH6?mc
613oW34Qoh@i<OmS61SoQ24HojEcF_n]Nf?oW9bUoib4NonDS6?o[KFeooOg
koooooooknOWolk>c_o_moL6ooooo`04ooKfm_o^k^koh>3Poh>3Poook^k^
hOo^k^h000;oi^KV00?oooooohZ:R_oLg=`00_ooool00on:RX[og=cLoooo
o`02onKViP03oh>3PooMgMgok>c/00Sooooo00?og]kWog]kNomJFUX00om[
Jg/00omkNg_oBTYJodY:BP02odY:FP0FoeYJF_mJFV_oFUY[of][JomJFV_o
Jf][of][NomJFW?oNg]kof][NomkNhcoNg]kog]kS?mJFU[oFUY[odY:B_m[
Jg_oBTY:of][NomJFU[oFUY[oeYJFP;oFUY[00CoFUYJof][Nom:BU[oNg]k
0omkNh`01on<S8coNg^<og]kNomkNhcoNg]kof][NomkNg/00_mkNh`00omJ
FU[o[Jf]ono_k`07ooooo`03ong]kOoOgmooPh>300[oi^KV00?oPh>3omgM
gOo/k>`01_ooool00ooFe^Ooe/kFooooo`07ooooo`03onogmooooooooooo
00;ooooo00?oinogooooooooool00_ooool03_oNc/KoS8b<ohb<S?m[Jf_o
S8b<ojfUU?m[Jf_oDPP8of/a:OnL<B7o[G]Soh@H4?n48ASoJc4Y0_m:DUX0
2?mJFU[oDTY2of]cLoo_inOoooooomkNg_o>e]koknOW1_ooool01?ofm_Ko
kNg]omoOgon3Ph?oonKVi^7oi^KV0002onk^kP;ooooo00KoRXZ:omcLg?oo
ooooooooohZ:R_oLg=`2onk^kP03oh>3PooMgMgokNg]00Sooooo00Gog]kN
okfm_Oo>c]Kog]kNolk>eP02omkNgP03olk>e_oNg^Oog]kN00Cog]kN00Oo
c/kFomkNg_o>c]Koc/kFomkNg_o>c]Kog]kN00Koc/kF00Koc/k>olk>e_o>
c/koc/kFolk>c_o>c]H3olk>cP0<okfma_o>c/koc/k>olk>c_nm_LKoc/k>
okfm_Oo>c/ko_Kg6olk>c_nm_LKoc/k>0_nm_Kd01?o>c/koS8b<ojf][Oo_
knl7ooooo`03ong]kOoOgmooPh>300[ok^k^00?oPh>3omgMgOo]kNd01_oo
ool01OoNg]koc]K>ooooooogknOo[KFe00;o_Kfm00Oo]Kg>okfm[Oo_inOo
c/k>ojf]YOo_inOo[KFe00;o_Kfm01?og]kNokFmc_o>a[GoooooolkFg_nm
_Kgo[JfUoibDS?n]YICoc/Jeog]cHolH413oDPP8ojekHon<Jd[oQ24Hog/a
:OmB>C7o:BTY00?o>CTa00KoFUY2onoWioooooooinONolk>c_o_moL6oooo
o`04ooKfm_o]kNgogmoOoh>3Poook^k^hOo^k^h000Gooooo00GoRXZ:omcL
g?ooooooooooohZ:RP02ooooo`03oh>3PooNg]kok^k^00Sooooo00?oc/k>
ojf]]Onm_Kd00_nLW:D2ojf]]@03ojf][OnLW:Go[Jf]00OoW9bU00KoW9bL
oibLYOnLW9coW9bUohb<U?nLW9`3ohb<U004ohb<S?n<S9CoS8b<ohb<S0;o
S8bD0on<S8`01omkNhcoS8b<og]kS?n<S8coNg^<ohb<S?mkNg/00_mkNh`0
2_mkNg_oNg^<og]kNomkNg_oJf]kog]kNom[Jg_oNg^<ohb<S?o_knl7oooo
o`03on_[jooNg]koPh>300[ooooo00?oPh>3omkNg_o^k^h01Oooool0;Oo_
moOoinONolk>c_ooooookoOgokfm_On][JGoc/kNolk6]Oo>c/koknOWolk>
c_nm_KgoknOWojf]YOnm_Kgoc/k>omkNg_o>c/ko[KFeoooooooNg/ko_Kf]
ojf]YOnLW9co[Ib4oljmYOmcJf?o8AP@oe9:@_mS@SWoBS4Yoe8i<OmB>BWo
Ng]kog^4Q?mJFU[oBU8iodY:<Om:DSWoknOWoooooooFe^Ooc]K>onoWi`06
ooooo`04ooGemOo[jn_og]kNoh>3PooooooohOooool000;ok^k^00KoRXZ:
omcLg?ooooooooooohZ:R_oLg=`2ooooo`;ok^k^00?oPh>3omkNg_o^k^h0
2?ooool02?o>c/ko[Jf]ojf]]Oli>CWo>CU2og]kNon][KGo_Kfm0_n][KD2
ojf][@04ojf]]OnLW:Go[JfeoibLY@;o[Jf]0_nLW:D01on<S9CoW9bUoibL
W?nLW:Go[Jf]ojf]]Onm_Kd00_n][KD01onLW:GoW9bLohb<S?n<S9CoS8b<
ohb<U?nLW9`01?n<S9@01On<S8coS8bDohb<S?n<S9CoNg^<00;oS8b<00Oo
Ng^<odY:B_m:BU[oBTY:ohb<S?n<S9Cokno_00Oooooo00?ojn_[omgMgOn3
Ph<02_o^k^h00on3Ph?og]kNonk^kP06ooooo`08omkNg_o>e]kooooooooo
ooo_moOoooooonoWiooWkoL5ooooo`03onogmooooooooooo00;ooooo00Wo
knOWooooooo>c]ko_Kf]okfm_OnDS8coLg=JojfLQ?mcJf<00_mB>C403om2
:B7oDSTaoeY2>OmB>C7oS8acohb<S?mkNg_oJf=Bof][B_mJHe[oknOWoooo
oooWimkoc/kNooOgk`06ooooo`04ooGemOo[jn_ogMgMoh>3Poook^k^hOo^
k^h000;oi^KV00?oooooohZ:R_oLg=`00_ooool00on:RX[og=cLooooo`02
onKViP03oh>3PooNg]kok^k^00Sooooo00Oog]kNoibLYOnm_KgoJf]kodY:
B_nLW:Go_Kfm00Ko[Jfe00?o[Jf]ojf]]On][Jd00_nLW:D01?n][Jgo_Kg6
omkNg_o_knl:ooooo`03omkNionm_LKoW9bU00;oS8bD00KoS8b<ohb<U?n<
S9CoS8bDohb<S?n<S9@3ohb<S0;oNg^<00GoFUYJocTi>Om[Jg_oS8b<oibL
W008ooooo`03on_[jooMgMgoPh>300[oi^KV00?oPh>3omkNg_o^k^h01Ooo
ool2onoWi`03omK>e_ooooooknOW00;oc/k>00WoW9bUojfUU?ne_Lkoc/Je
omkNg_o>e]koc/k>omkNg_o>e]h00_o>c/h03?o6_Kgoc]KNooooooo>a[Go
S8b<ohb<LomJFT;oS8b<olk6]OmcJf?oDTY2oc4H40;oDSTa00CoLeYBoe8i
<OmJFT;oNg=S0_m[JdX01omJFT;oJf]:onoWioo_moOoknOWolkFc_o_inL0
1_ooool01?oemOGojn_[omgMgOn3Ph?oonKVi^7oi^KV0002onk^kP;ooooo
00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2onk^kP03oh>3PooNg]kokNg]
00Sooooo00Wog]kNojf][Onm_LKo_Kfmokfma_n][KGo_Kfmojf]]Onm_Kd0
1On][KD01?nLW:Go[Jf]olk>c_o_knl2ooooo`09ono_mooNg]ko_Kg6okfm
_On][KGo[Jf]oibLYOn][JgoW9bU00;o[Jfe00Soc/k>omkNioo_knoog]kN
okfma_n][KGoW9bUog]kS0;oS8bD00GoW9bLohb<U?n<S9CoS8b<ohb<U002
ohb<S005og]kS?n<S8coS8b<og]kS?n][Jd02?ooool00oo/k>cog]kNoh>3
P`0:onk^kP03oh>3PooNg]kokNg]00Kooooo00Kog]kNolkFc_oooooooooo
ojf]YOn]]KD4okfm_@06omkNg_nm_Kgoc/JeolkFg_o>a[Go[KFe0_nm_Kd0
4On][JGoooooojfe]Om:BT[oDTY2of]SD_n<S7?oW8AkoeYJF_mB>BWo@RTQ
of]:@_mJFT;oLeYBof=JB_lY:ASo>CTH00;oFU8Y00Ko>CTHog]SB_o_inOo
ooooomkNg_o>c/h7ooooo`04ooCdm?o/k>cog]kNoh>3Poook^k^hOo^k^h0
00Gooooo00GoRXZ:omcLg?ooooooooooohZ:RP02ooooo`03oh>3PooNg]ko
kNg]00Sooooo00Kokno_ojf]]Onm_LKo_Kg6ojf]]Onm_Kd6ojf]]@03oibL
YOn][Jgog]kN00;oknog00Cog]kWokfma_nLW:GoW9bL0onLW:D01?nLW9co
W9bUoibLYOnLW:D3oibLW0?oS8bD0_nLW:D2okfmaP03olk>c_nLW:GoS8bD
00CoS8bD00?oS8b<ohb<U?mkNh`00_n<S8`00omkNhcoNg]kokfm_@08oooo
o`03on_[jooOgmooPh>300[ooooo00?oPh>3omkNg_o]kNd01Oooool01_o_
moOoinONolk>c_ooooookoOgonoWi`Wooooo01koknOWonOWg_ooooookoOg
onoWiooooooo[JfUobTa:OlY:ASoBTXYojfUU?o6_Kgo>CTaod8Y8OmB>C7o
DTY2og]JB_m[He;oFT8iobTY6?m:<BWoBTXYog=cF_m:<BWoDV=2omKFiooo
ooooinONolkFg_o_inL6ooooo`04oo?cloo[jn_ogmoOoh>3PooooooohOoo
ool000;ok^k^00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2ooooo`;ok^k^
00?oPh>3omkNg_o[jn/02?ooool02Oo_koOo[Jf]olk>c_n][KGo_Kfmojf]
]Onm_LKo[Jfeokfm_@02ojf]]@06ojf][Oo>c/koknogono_moo>c/ko[Jf]
0_nLW:D00on][KGo[Jf]ojf][@02oibLY@03ojf][OnLW:GoW9bU00?oW9bU
00_oW9bLoibLYOnLW9coW9bUohb<U?nLW9coS8bDoibLW?n][KGoc/kFolk>
cP05ohb<U003ohb<S?n<S9CoNg^<00;oS8b<00?oNg^<okfm_Oooool01ooo
ool00oo/k>coh>3Poh>3P`0:onk^kP03oh>3PooNg]kojn_[00Kooooo00[o
g]kNolkFg_ooooooknOWolkFg_oNg]koc/k>omkNg_o>c/koknOW0_o>e]h0
8?o_inOog]kNolkFg_o>c/koe/kFonoWioo>e]kokoOgojfUU?l0003o:BTH
ocTQ6?nLU8coc/J]og]cHolY:ASo@RTQojekHonDJe[oJc4YocTi6?lY:ASo
<CTQodY::Om:BS7o>CTHodY:<Oo_inOokoOgonoWioo>c/kokoOg1_ooool0
1?obl_;ok>c/on3Ph?n3Ph?oonk^k^7ok^k^0002onKViP03oooooon:RX[o
g=cL00;ooooo00?oRXZ:omcLg?ooool00_oVi^H00on3Ph?og]kNon_[j`09
ooooo`03okfm_Onm_LKo_Kfm00;o_Kg600?o[Jfeokfm_On][KD00_n][KD0
2oo_knooooooomkNg_n][KGo[Jf]ojf]]On][Jgo[JfeoibLYOn][KGoW9bU
00;o[Jf]00SoW9bUojf][OnLW:GoW9bUojf][OnLW:GoW9bLoibLY@;oW9bL
00[oW9bUohb<U?nLW9coW9bLohb<U?nLW:Go_Kg6omkNg_nLW:GoS8b<0on<
S9@01_n<S8coS8bDohb<S?n<S9CoNg]kolk>cPSooooo00?ok>c/on7QhOn3
Ph<02_oVi^H00on3Ph?og]kNon_[j`05ooooo`0]onogmoo_inOoc/k>oooo
oooNg]ko_Kfmojf]YOn]]KGo[JfUoibLW?nea]Ko[JfUokfm[Oo>e]koc/k>
oibLYOn][JGo_KfmolkFc_nm_KgoknOWojf]YOl@003o:BTHoc4i8Onm_Jgo
g/jmohb<LolY:ASoLeYBojekHoo6[IcoQ7]coc4i8OlH413o>CTHodYB>Om:
FT;o:BTYocU2<Oo_inOoooooomKFioo>e/koknOW00Kooooo00Col_;bonc/
k?oQhN7oPh>3oooVi^KQonKViP000_o^k^h2ooooo`06ohZ:R_oLg=cooooo
oooooon:RX[og=cL0_o^k^h00on3Ph?og]kNon_[j`09ooooo`05okfm_Onm
_LKo_Kfmojf]]Onm_LH00_nm_Kd01_n][KGo_Kfmono_moo_koOo_KfmoibL
Y@Co[Jfe0_n][Jd01?nLW:Go[JfeoibLYOn][KD2oibLY@03ojf][OnLW:Go
W9bU00CoW9bU00GoW9bLoibLYOnLW9coS8bDoibLY@03ohb<U003ojf]]Oo>
c/ko[Jf]00;oS8bD00OoS8b<ohb<U?n<S8coS8b<ohb<U?mkNhcog]kN00So
oooo00?ok>c/on7QhOn3Ph<02_o^k^h00on3Ph?og]kNon_[j`05ooooo`;o
knOW00?oc]K>ooooooooool00oo_moL01?ogmnooc]KNonOWg_o_inL6onog
m`?ooooo01So[JfUobTY6?lY:ASo:BTHohb<Loo>_JGoBUY2obTY6?li8ASo
Nf=:oha[B_mJFT;o>D8aobTa:OlY8@SoBU8iohBDU?mkQ8CoFV=JonoWioo_
moOoinONolk>g_ogmnl6ooooo`04oo;bl_o/k>cohN7Qoh>3Poook^k^hOo^
k^h000Gooooo00GoRXZ:omcLg?ooooooooooohZ:RP02ooooo`03oh>3PooN
g]kojn_[00Wooooo00?o_Kg6okfm_Onm_LH00_nm_Kd01Onm_LKo[Jfeojf]
]Oooooookno_00;o[Jfe00?o_Kfmojf]]On][KD00_n][KD01_n][Jgo[Jfe
ojf][On][Jgo[JfeoibLY@;o[Jf]0_nLW:D00on][JgoW9bUoibLY@02oibL
W007oibLYOnLW9coW9bLoibLYOn<S9CoW9bUoibLW002ohb<U005oibLYOnm
_LKoW9bUohb<U?nLW9`00on<S9@2ohb<S003omkNg_oooooooooo00Kooooo
00?ojn_[on3Ph?n3Ph<02_ooool00on3Ph?og]kNon_[j`06ooooo`03omkN
g_o>c]kooooo00CoknOW00Coe]KWonoWiooWimkoe]KW1_o_inL01OoFe^Oo
mnoWoooooon][JGo<CTQ00;oBUY200WoU8aSokfm[On]]KGoJg=coa0@2?li
8ASo<AP@oaP@4?mJJf/00_mJHeX02OmSLhco[KFeoibeg_nU]LkoknOWonog
mooNg]koc]K>onoWi`06ooooo`04oo;bl_o[jn_oh>3Poh>3PooooooohOoo
ool000;ok^k^00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2ooooo`;ok^k^
00?oPh>3omkNg_oZj^X02Oooool03?o>c/ko_Kfmokfma_nm_Kgo_Kg6ojf]
]Onm_KgoknogomkNionm_Kgo[JfeokfmaPKo[Jfe00So[Jf]ojf]]On][KGo
[Jf]ojf]]OnLW:Go[Jfeojf][@CoW9bU00Co[Jf]oibLYOnLW:GoW9bU0_nL
W9`01?nLW:GoS8bDoibLW?nLW:D2ohb<U003oibLYOn][KGoS8bD00CoS8bD
00?oW9bLohb<U?o_knl02?ooool00oo[jn_og]kNoh>3P`0:onk^kP03oh>3
PooNg]koj^[Z00Kooooo00Kog]kNomkNc_ooooooc]KNokfm_One[Jd2ojf]
Y@0Eohb<S?ne_Lko_Kf]oibLYOn][JGo[KFeokfm_On][JGo[KFeojf]YOoW
koOoooooolk>c_mSLhcoNhB4of]SD_mkNg_o_Kf]ojfUU?n<S8co:BTY00;o
000000goBU9Joibeg_nU]LkoW;GNojFmg_nL]NOo]LKFoibeg_o_inOomoO_
omkNg_o>c/kokoOg00Kooooo00Col_;bon_[jooNg]koPh>3ooo^k^kQonk^
kP000_oVi^H00oooooooRXZ:omcLg002ooooo`03ohZ:R_oLg=cooooo00;o
i^KV00?oPh>3omgMgOoZj^X02Oooool01?o>c]Ko[Jfeolk>c_nm_LH2okfm
_@09olk>c_o>c]Ko_Kg6ojf]]Onm_Kgo[Jfeokfm_On][KGo_Kfm00Go[Jfe
00Wo[Jf]ojf]]OnLW:Go[Jfeojf][OnLW:Go[Jf]oibLYOn][Jd01?nLW:D0
0onLW9coW9bUoibLY@02oibLW005oibLYOn<S9CoS8bDoibLW?n<S9@00_nL
W9`00on<S9CoW9bLohb<U003ohb<U0Wooooo00?oj^[ZomgMgOn3Ph<02_oV
i^H00on3Ph?ogMgMon[ZjP06ooooo`05omkNg_o>e]koooooonoWiooNg]h0
0_o_moL00oo_inOoc/k>onogm`02onoWi`03olk>c_o_inOoc]KN00;oknOW
00CoinogooO_ioogmnooe]KW0_nL[Kd01_nLW:Go[JfUokfm_One_Lko]LKF
ojFecP;oHg><1_nL]Mh01onL]NOoYKG>onoWiooooooog]kNolkFg_o_inL0
1_ooool01?obl_;oj^[ZomgMgOn3Ph?oonKVi^7oi^KV0002onk^kP;ooooo
00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2onk^kP03oh>3PooMgMgoj^[Z
00Wooooo00?og]kNojf]]Onm_LH00onm_LH02?n][KGo_Kfmokfm_On][KGo
_Kg6okfm_On][KGo_Kg60on][KD00onm_Kgo[Jfeojf]]@02ojf]]@08ojf]
[OnLW:GoW9bUoibLW?nLW:GoW9bLoibLYOn][Jd5oibLY@04oibLW?nLW:Go
W9bLoibLY@;oW9bL00GoS8bDoibLYOn<S9CoW9bLohb<S003ohb<U0;oW9bL
2Oooool00ooZj^[og=cLoh>3P`0:onk^kP03oh>3PooMgMgoj^[Z00Gooooo
0_o_inL01Oo>e/koooooonoWioo_inOokoOg00;oknOW00?o[KFeonoWioo_
moL01Oo_inL01OoWkoOomnoWonO_moooooooc]KN00;o[KgW00?o[LKgoib]
_Oo>aZd00onL]NL01On]a^ooW;GWoibeg_nL]MkoW;GW00GoW;GN00Goc]KN
onogmooNg]koc/k>onogm`06ooooo`04oo;bl_oZj^[og=cLoh>3Poook^k^
hOo^k^h000Gooooo00GoRXZ:omcLg?ooooooooooohZ:RP02ooooo`03oh>3
PooMgMgoj^[Z00Wooooo00?okno_okfm_Oo>c/h00_nm_LH00onLW:GoW9bL
okfmaP02okfm_@03okfma_n][KGo_Kg600;o[Jfe00?o_Kfmojf]]On][KD0
0on][KD02?nLW:Go[Jf]okfm_Oo>c]Kog]kNolk>e_o>c/ko[Jf]0onLW:D0
3_n][JgoW9bUoibLYOnLW:GoW9bLoibLYOnLW9coW9bUohb<U?nLW:GoS8bD
oibLW?n<S9CoJf]k0_n<S9@00onLW9coS8bDojf][@09ooooo`03on[Zj_oL
g=coPh>300[ooooo00?oPh>3omgMgOoZj^X01_ooool02?oWimkoc/kNoooo
ooo>e]koW9bLolk6]One_Lko[KFe0_n][JD00onLW:Go[JfUoibLW002olk>
cP0@ojfe]On][JGoS8b<olk>c_oooooo]LKFoib]g_nL]MkoW:gNoib]_On]
[JGoW:gNoib]c_nL]MkoW:gNoib]cP;oW:gN00KoW:g>oib]g_nL[MkoW:g>
oib]g_nL[Lh2onoWi`03omkNg_o>e/koknOW00Kooooo00Col_;bon[Zj_oL
g=coPh>3oooooooQooooo`000_o^k^h01_n:RX[og=cLooooooooooooRXZ:
omcLg0;ooooo0_o^k^h00on3Ph?ogMgMon[ZjP09ooooo`07ono_kon][KGo
c/k>okfma_o>c/koNg]koibLY@02okfmaP04okfm_On][KGo_Kfmojf]]@;o
_Kfm0_n][KD01Onm_LKo[Jfeojf]]On][Jgoc/kF00;ooooo00?oknogono_
koo_knl00_o_koL00ooNg^Oo_KfmoibLW004oibLY@0<ojf][OnLW9coW9bU
oibLW?nLW:GoW9bLoibLYOn<S9CoW9bUof][JomkNg_oW9bL0_n<S9@00onm
_Kgoooooooooo`07ooooo`03on[Zj_oLg=coPh>300[ok^k^00?oPh>3omgM
gOoZj^X01Oooool02?o_moOog]kNomkNc_ooooooknOWolkFg_o_inOomoO_
0oo_inL01Oo>e]koknOWonOWg_oFe^OoknOW00?og]kN00GoknOWonogmoo_
inOoc]KNomkNgP02olkFgP04omk>a_oFe^Oog]kNomKFi`;oc]KN00?og]kN
olkFg_o>e]h01?o>e]h01Onea]KoknOWooOgkoo>e]koc/k>00Oooooo00Co
lO7aon[Zj_oLg=coPh>3ooo^k^kQonk^kP000_oVi^H00oooooooRXZ:omcL
g002ooooo`03ohZ:R_oLg=cooooo00;oi^KV00?oPh>3omcLg?oZj^X02Ooo
ool00oo_koOo_Kfmolk>eP02okfmaP09oeYJJonm_Kgo_Kg6okfm_Onm_LKo
_Kfmokfma_nm_Kgo_Kg600;o[Jfe00Wo_Kfmojf]]On][KGo[Jfeono_kooo
ooooc/k>ojf]]On][Jd00_nLW:D2ojf]]@;og]kW00Co_KfmoibLYOnLW:Go
[Jf]0onLW:D01OnLW9coW9bUoibLW?nLW:GoS8bD00;oW9bL00KoJf][oeYJ
JonLW:GoS8bDohb<S?nm_LH9ooooo`03on_[jooLg=coPh>300[oi^KV00?o
Ph>3omcLg?oZj^X01_ooool2omkNgP0>ooooooo_inOooooooooooooFe^Oo
c/k>onoWioogmnooooooooOgkooWkoOoknOWokfm_OoNg]h2ooooo`0:onO_
moo_inOokoOgooooooo_inOoooooooO_ioooooooinogonogm`;oknOW00Co
ooooonoWiooWkoOomoO_0_o_inL00ooNg]koknOWonogm`02onoWi`03omkN
g_o>e/koknOW00Kooooo00Col?3aon_[jooLg=coPh>3oooVi^KQonKViP00
0_o^k^h2ooooo`06ohZ:R_oLg=cooooooooooon:RX[og=cL0_o^k^h00on3
Ph?og=cLon[ZjP0:ooooo`05okfm_Oo>c/ko_Kg6okfm_OmJFUX00onm_LH0
1Onm_Kgo_Kg6okfm_On][KGo_Kg600;o_Kfm0_n][KD01?nm_Kgoc/kFoooo
oon][KD2ojf][@09ojf]]On][Jgo[JfeoibLYOn][JgoW9bUokfma_n][KGo
[Jf]00CoW9bU00Co[Jf]oibLYOnLW9coW9bU0onLW9`01onLW:GoJf]koeYJ
F_nLW9coS8bDohb<S?o>c/h02Oooool00oo[jn_og=cLoh>3P`0:onk^kP03
oh>3PooLg=coj^[Z00Gooooo0_o_inL04?o>e]koooooonogmon][JGo_Kfm
olk>c_n<S8co[JfUokFmc_o_inOoW9bLojf]YOn<S8coQ9BDoiB<S?n]]KD2
ojf]Y@09olk>c_o_inOoinogomkNg_nLW:Goc/k>ojfe]On][JGoW9bL00;o
c/k>00SoW9bLomkNg_n]YICoc/kNojf]YOnLW:GoQ9BDolkFcP;oknOW00Co
koOgolk>g_o>c/kokoOg1_ooool01?o_ko3ojn_[omcLg?n3Ph?oonk^k^7o
k^k^0005ooooo`05ohZ:R_oLg=cooooooooooon:RXX00_ooool00on3Ph?o
g=cLon[ZjP0:ooooo`05okfma_o>c]Koc/k>okfma_mJFUX01?nm_LH2okfm
_@04okfma_nm_Kgo_Kg6ojf]]@;o_Kfm00?o[JfeoibLYOn][KD00_n][KD0
1?nm_Kgo[Jfeojf]]On][Jd2ojf]]@07oibLYOn][JgoS8bDog]kNon][KGo
W9bUojf][@05oibLY@0:oibLW?nLW:GoW9bUoibLYOmkNg_oBTYJoibLYOnL
W9coS8bDomkNgPWooooo00?ojn_[omcLg?n3Ph<02_ooool00on3Ph?og=cL
on[ZjP06ooooo`05omkNg_o>e/koooooonoWioo>c/h00ooNg]h02_o>e]ko
knOWonoWiooNg]koc]KNolk>c_oFc]Ko[KFeomkNc_o>e]h2olk>cP07oooo
ooo_inOo[KFeohb<S?nm_Kgo[JfUomkNgP02olk>cP09omkNg_o>c/kog]kN
olk>c_oNg]koe/kFolkFc_o>c/koe]KW00?oknOW00?og]k>olkFg_o_inL0
1_ooool01?o^k^oojn_[omcLg?n3Ph?oooooon7ooooo0002onk^kP06ohZ:
R_oLg=cooooooooooon:RX[og=cL0_ooool2onk^kP03oh>3PooLg=coj^[Z
00[ooooo00Ko_Kg6olk>c_nm_LKoc/k>oeYJJonm_Kd2okfmaP0=okfm_Onm
_LKo_Kfmokfma_nm_Kgo[Jfeokfma_n][KGo_Kg6okfm_Om[Jg_o[Jf]okfm
_@05ojf]]@0:ojf][On][KGo[Jf]ojf]]OmJFU[oJf][ojf]]On][JgoW9bU
ojf][@GoW9bU0_nLW9`01onLW:GoFUY[of][JonLW9coW9bUohb<U?oNg]h0
2Oooool00oo[jn_og=cLoh>3P`0:onk^kP03oh>3PooLg=coj^[Z00Kooooo
00CoinONolkFg_ooooookoOg0oooool01Oo_inOoooooonO_mooooooomnoW
00?ooooo00SoknOWonogmoo_inOoooooonoWiooooooog]kNolk>cP;og]kN
00[oknOWoooooooWkoOoooooonoWiooWkoOomnoWonO_moo_inOoinog1?o_
inL01OoFe^OoknOWolkFg_oNc/KokoOg00Kooooo00Cok^k_on_[jooLg=co
Ph>3ooo^k^kQonk^kP000_oVi^H00oooooooRXZ:omcLg002ooooo`03ohZ:
R_oLg=cooooo00;oi^KV00?oPh>3omcLg?oZj^X02_ooool2olk>cP07okfm
a_oNg]koJf]kojf][Oo>c/ko_Kg6olk>cP02okfmaP07okfm_Onm_LKo_Kfm
okfm_Onm_LKo[JfeokfmaP02oibLY@Ko[Jfe00go[Jf]ojf]]On][KGo[Jf]
of][NonLW:Go[JfeoibLYOn][JgoW9bUojf][OnLW:Go[Jf]00;oW9bU00Wo
W9bLoibLYOnLW:GoFUYJohb<S?nLW:GoW9bLohb<U?o_knl02Oooool00oo[
jn_og=cLoh>3P`0:onKViP03oh>3PooLg=coj^[Z00Kooooo00Goe]KWolk>
c_ooooooknOWojf]Y@02ojfe]@09okfm_On]]KGog]kNokfm_On]]KGoinON
ojf]YOne_Lko[JfU00;oc/k>00Oo]Jf]okfm_On]]KGoW9bLohb<S?nm_Jgo
c/kN00;o[KFe0_n][JD01_o>c]ko_Kfmojf]YOnm_Kgoc/k>ojf]Y@;o[KFe
0_n][JD01Oo>c/koknOWolkFc_o>c/koinog00Kooooo00Cokno`on_[jooL
g=coPh>3oooVi^KQonKViP000_o^k^h2ooooo`06ohZ:R_oLg=cooooooooo
oon:RX[og=cL0_o^k^h00on3Ph?ofm_Kon[ZjP0:ooooo`07omkNg_nm_LKo
c/k>okfma_n][KGoS8b<olk>eP05okfmaP09okfm_Onm_LKo_Kfmokfm_Onm
_LKo[Jfeokfm_Onm_LKo_Kfm00Ko[Jfe00?o[Jf]oibLYOo>c/h00_n][KD0
0on][JgoW9bUojf][@07oibLY@;oW9bL00GoFUY[oibLYOnLW9coW9bUoibL
W00:ooooo`03on_[jooLg=coPh>300[ok^k^00?oPh>3om_KfooZj^X01Ooo
ool02?ogmnooinONomkNg_ooooooknOWojfe]On][JGoc/k>0_nm_Kd01?oN
g]koc/k>ojf]YOoFe^L2ojf]Y@06olk>c_oNg]ko_KfmoibLW?o>c/koa[fm
0_nm_Kd02_o>c/kog]kNojfUU?n]]KGoc/k>okfm_Oo>c/ko[JfUokFmc_o>
c/h2okfm_@06ojf]YOo>c/ko_Kfmojf]YOnm_KgoknOW0_o>c/h00oogmnoo
ooooooooo`04ooooo`04ono_l?o[jn_og=cLoh>3Poook^k^hOo^k^h000Go
oooo00GoRXZ:omcLg?ooooooooooohZ:RP02ooooo`03oh>3PooKfm_oj^[Z
00[ooooo00?og]kNokfma_o>c/h00_o>c/h01?mkNhco_Kg6okfma_o>c/h4
okfmaP07okfm_Onm_LKo_Kg6ojf]]Onm_Kgo_Kg6ojf]]@02olk>cP03ojf]
]Onm_Kgo[Jfe00;o[Jfe00Oo_Kfmolk>c_n][KGo[Jf]ojf]]OnLW:Go[Jfe
00;oW9bU00Co[Jf]oibLYOnLW:Go[Jf]0_nLW:D00on][JgoS8bDohb<U002
oibLW0;oW9bU2_ooool00ooZj^[ogMgMoh>3P`0:ooooo`03oh>3PooKfm_o
j^[Z00Kooooo00Coe]KWolkFc_ooooookoOg0oo_inL01_oNg]kooooooooo
ooo_inOoooooonogm`;oknOW00KoooooooOgkoogmnooe]KWooO_iooWkoL2
ooOgk`03onO_moo_moOoknOW00;oknOW00KoinogonoWiooNg]koinogonoW
ioo>e]h3onoWi`07omKFiooNg]kog]kNonOWg_o>c/koc]KNonoWi`06oooo
o`04ono_kooZj^[ogMgMoh>3PooooooohOooool000;ok^k^00KoRXZ:omcL
g?ooooooooooohZ:R_oLg=`2ooooo`;ok^k^00?oPh>3om[Jf_oZj^X02_oo
ool02_oNg]ko_Kg6olk>e_o>c]Kog]kNokfm_On<S9Coc/kFokfma_o>c/h4
okfmaP05okfm_Onm_LKo_Kfmojf]]Onm_LH00_n][KD3okfmaP?o_Kfm0_n]
[KD2ojf][@03oibLYOn][KGoW9bU00;o[Jf]00?oW9bUojf][OnLW:D01?nL
W:D01_mJFU[oW9bUojf][OnLW9coW9bUojf][@[ooooo00?oj^[ZomgMgOn3
Ph<02_o^k^h00on3Ph?of][Jon[ZjP05ooooo`07ooOgkooWimkoe/kFoooo
ooo_inOoc/k>ojfe]@02oibLW00:ojf]YOnm_Kgog]kNolk>c_nm_Kgog/k6
olkFg_nm_Kgo]Kg>okfm_@;oc/k>00oo_KfmokFmc_o>c/koc/JeolkFg_nm
_Kgo[KFeolk>g_oNg/ko_Kfmojfe]Onm_Kgo[KFeokfm_Oo>c/h00_nm_Kd0
1?o>c/ko[JfUokfm_Oo>c]h2olk>cPOooooo00Col?3`on[Zj_oMgMgoPh>3
ooo^k^kQonk^kP000_oVi^H00oooooooRXZ:omcLg002ooooo`03ohZ:R_oL
g=cooooo00;oi^KV00?oPh>3om[Jf_oZj^X02_ooool02Oo_knoo_Kg6olk>
e_n<S8coNg^<okfma_nm_Kgo[Jfeolk>eP02okfmaP03olk>c_nm_LKo_Kfm
00;o_Kg61?nm_Kd01Onm_LKo_Kfmojf]]On][KGo_Kfm00Ko[Jfe0on][Jd0
1On][KGoW9bUojf][OnLW:Go[Jf]00;oW9bU00So[Jf]ohb<U?li>D;oS8b<
of][NomkNhcoW9bUokfm_@[ooooo00?oj^[ZomgMgOn3Ph<02_oVi^H00on3
Ph?of][Jon[ZjP06ooooo`07omKFioo>e/koooooonoWionLW9co_Kfmojf]
Y@02okfm_@05ojfe]Oo>c/ko_Kfmokfm_Oo>e]h00_n]]KD01_n][JGo[KFe
ojf]YOn]]KGo_Kfmojf]Y@;o_Kfm00Sog]kNoib]_On][JGoc/JeolkFg_n4
U9Co[JfUojfe]@;o[JfU00[oc/k>okfm_OnLW9co_Kfmohb<S?nLW9cog]kN
olk>c_oNc/Koinog1_ooool01?o`l?3oj^[ZomgMgOn3Ph?oonKVi^7oi^KV
0002onk^kP;ooooo00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2onk^kP03
oh>3PooJf][ojNWY00_ooooo00Wo_Kfmolk>c_m:BT[o:BTYojf][Oo>c]Ko
_Kfmokfma_o>c/h00onm_LH02_o>c/ko_Kg6okfm_Onm_LKo_Kfmokfma_nm
_Kgo[Jfeokfm_Onm_LH2ojf]]@03okfma_n][KGo[Jfe00Co[Jfe00?o[Jf]
ojf]]OnLW:D00_n][Jd03?nLW:Go[Jf]oibLYOn][JgoW9bUohb<S?m:BT[o
Jf][obTY:Om[Jf_oW9bUokfmaP[ooooo00?oj^[ZomgMgOn3Ph<02_o^k^h0
0on3Ph?of][JonWYj@05ooooo`06ooOgkooWimkoc/kNooOgkoo_inOog]kN
0_oWkoL01_o_inOokoOgonoWiooWkoOoknOWonogm`;oknOW00Coc/kNonoW
ioogmnooc]KN0_oNg]h;onoWi`06omkNg_o_inOog]kNomkNg_o>c/koe/kF
0_o>c/h01?o>e]koc/k>olk>c_ogknL6ooooo`04ono_kooZj^[ogMgMoh>3
Poook^k^hOo^k^h000Gooooo00GoRXZ:omcLg?ooooooooooohZ:RP02oooo
o`03oh>3PooIfMWoj>SX00_ooooo00Oo_Kg6olk>e_nm_LKo_Kg6olk>e_nm
_LKoc/kF00;o_Kg600Goc/k>okfma_o>c/ko_Kg6okfm_@03okfmaP09okfm
_Onm_LKo_Kfmokfma_n][KGo_Kg6okfm_On][KGo_Kfm00;o[Jfe00Co_Kfm
ojf]]On][KGo[Jfe0_n][Jd03_n][KGoW9bUojf]]OnLW:Go[Jf]oibLYOn]
[JgoNg^<odY:B_nLW:GoS8b<oibLYOn<S9Coc/k>2_ooool00ooYjNWofm_K
oh>3P`0:ooooo`03oh>3PooIfMWoj>SX00Kooooo00Coe]KWolk>c_oooooo
e]KW1Oo>c/h01?oNg]koc/k>olk>c_oWg]h4olk>cP0<olk>g_o>c/koc/k>
ohBDU?nm_Kgoc/k>olkFg_o>c/ko_Kfmolk>c_nm_Kgoc/kN0_o>c/h01onm
_Kgoc/k>okfm_Oo>c/ko_KfmokF][On]]KD00_nm_Kd01?oNc/Ko_Kfmolk>
c_o_moL6ooooo`04onk^k_oYjNWofm_Koh>3PooooooohOooool000;ok^k^
00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2ooooo`;ok^k^00?oPh>3omWI
fOoWinL02oooool00onm_LKog]kNolk>cP02olk>cP06olk>e_nm_LKoc/k>
olk>c_nm_LKoc/k>0_nm_LH00oo>c/ko_Kg6okfm_@02okfmaP06okfm_Onm
_LKo_Kfmokfm_On][KGo_Kg60_n][KD00onm_Kgo[Jfeojf]]@04ojf]]@;o
[Jf]00Wo[JfeoibLYOn][KGo[Jf]oibLYOn][JgoNg]koeYJF_n][Jd00_nL
W:D00onLW9coc/kFooooo`09ooooo`03onSXj?oIfMWoPh>300[ok^k^00?o
Ph>3omWIfOoWinL01_ooool01?oNg]koc/k>ooooooo>e]h3ojf]Y@0=oibL
YOn<S8coc/k>oibLW?n][JGo]LKFokfm_On4U9Co[JFDojf]YOo>c/ko[KFe
olk>cP02ojf]Y@04oibLW?nm_Kgoc/k>ojf]Y@;oS8b<013oa[fmoibLW?n<
S8coW9bLoibLYOn<S8co_Kfmohb<S?nLW9coU8b<oibLW?n<S8co]Kg>okfm
_OoNg/koknOW1_ooool01?o^k^koj>SXomWIfOn3Ph?oonk^k^7ok^k^0002
onKViP03oooooon:RX[og=cL00;ooooo00?oRXZ:omcLg?ooool00_oVi^H0
0on3Ph?ofMWIonKViP0;ooooo`0:olk>c_oNg]koc/kFolk>c_o>c]Ko_Kg6
olk>e_o>c/ko_Kg6olk>cP;oc/kF0onm_LH02Oo>c/ko_Kg6okfm_Onm_LKo
_Kfmokfma_nm_Kgo_Kg6ojf]]@02okfm_@03ojf]]Onm_Kgo[Jfe00?o[Jfe
00co[Jf]ojf]]On][KGoW9bUojf][On][KGoW9bUojf][On][KGoJf][oeYJ
Jon][Jd2oibLY@03oibLW?oNg]kooooo00Wooooo00?oj>SXomSHf?n3Ph<0
2_oVi^H00on3Ph?ofMWIonKViP05ooooo`04onogmoo_inOoc/k>onogm`?o
knOW00Gog]kNonoWioo>c/koc]K>omkNgP05onoWi`03onOWg_o_inOoknOW
00;oknOW00Koe]KWomkNg_o>e/koknOWonOWg_oFe^L3olk>cP08okfm[Oo>
c]koc/k>omk>a_ne_Lko_Kfmolk>c_ne_Lh3okfm_@03okfm[Oo>e]kooooo
00Kooooo00CokNg]onSXj?oHf=SoPh>3oooVi^KQonKViP000_o^k^h2oooo
o`06ohZ:R_oLg=cooooooooooon:RX[og=cL0_o^k^h00on3Ph?ofMWIonKV
iP0;ooooo`Coc/kF00[oc/k>olk>e_nm_LKoc/kFolk>c_nm_LKoc/k>okfm
a_o>c]Koc/k>1?nm_LH03?nm_Kgo_Kg6okfm_Onm_LKo[Jfeokfma_n][KGo
_Kg6ojf]]Onm_Kgo[Jfeokfm_@?o[Jfe00[o[Jf]ojf]]On][Jgo[Jf]oibL
YOn][KGoW9bUojf]]OmJFV_oJf]k0_n][Jd00onLW:Go[Jf]ono_k`0:oooo
o`03onSXj?oHf=SoPh>300[ok^k^00?oPh>3omWIfOoVi^H01Oooool01?og
knOoe]KWomkNc_ooool4omkNgP07olk>c_oNg]koc/kNomkNg_oNg/kog]kN
olkFgP02omkNgP03olk>g_oNg]kog]kN00;og]kN00[oc/k>onoWioo>c]ko
g]k>okFmc_oNc/Ko[JfUoibLYOne_Lko]Jf]0_n][JD00on]]KGo[JfUojf]
Y@02ojf]Y@06oibLYOn][JGo[KFeokfm_Oo_inOokoOg1_ooool01?o]kNgo
j>SXomSHf?n3Ph?oonk^k^7ok^k^0005ooooo`05ohZ:R_oLg=cooooooooo
oon:RXX00_ooool00on3Ph?ofMWIonKViP0;ooooo`05omkNg_o>c/koc/kF
olk>c_o>c]H00_o>c/h01Oo>c]Ko_Kg6olk>c_o>c]Ko_Kg600;oc/k>00?o
_Kg6olk>c_o>c/h00onm_LH4okfm_@09okfma_n][KGo_Kfmojf]]Onm_Kgo
[Jfeokfm_On][KGo_Kfm00Co[Jfe0_n][Jd2ojf]]@07oeYJF_mkNg_o[Jfe
oibLYOn][JgoW9bUono_k`0:ooooo`03onOWiooGemOoPh>300[ooooo00?o
Ph>3omWIfOoVi^H01_ooool01?o_inOoc/k>onogmoo>c/h2ojf]Y@03oibL
YOnLW9coS8b<00;o[JfU00goQ9BDoibLYOn][JGo[JfUoibLYOn][JGoW9bU
olk6]OnLW:GoS8b<oibLW?o>c/koS8b<00?oW9bL00Co[JfUohb<S?mkNg_o
Ng]k0_m[Jf/02_nLW9coJf][of][JomkNg_oS8b<oeYJF_nLW9co[JfUolk>
g_o_inL7ooooo`04ong]kOoWinOoemOGoh>3PooooooohOooool000;ok^k^
00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2ooooo`;ok^k^00?oPh>3om[J
f_oUiND02oooool00ooNg]koc/kFolk>eP03olk>eP06olk>c_o>c]Koc/kF
olk>c_nm_LKoc/kF0_nm_LH01?o>c]Ko_Kg6okfma_o>c/h5okfmaP09okfm
_Onm_LKo_Kfmokfma_nm_Kgo[Jfeokfma_nm_KgoW9bU00?o[Jfe00co[Jf]
ojf]]On][KGo[Jf]oibLYOnm_KgoBTYJohb<S?n][JgoW9bUojf][OnLW:D;
ooooo`03onOWiooGemOoPh>300[ok^k^00?oPh>3om[Jf_oUiND01Oooool0
1_oWkoOoinONolk>c_ooooooc/k>olkFgP?og]kN00[o_KfmomkNg_oNg]ko
g]kNokfm_OoNg]koc/k>olkFc_oNg]koinON0_o>c/h00onm_Kgoc/k>omkN
gP02omkNgP0<olk>c_o>e]koc/k>okfm_On][JGoW9bLohb<S?mkNg_oS8b<
og]kNomkQ8CoNg]k0_n<S8`00onLW9co_KfmonoWi`08ooooo`04onc/k?oW
inOoemOGoh>3Poook^k^hOo^k^h000;oi^KV00?oooooohZ:R_oLg=`00_oo
ool00on:RX[og=cLooooo`02onKViP03oh:2P_oJf][oiNGU00_ooooo00?o
g]kNolk>e_o>c]H00_o>c]H01oo>c/koc/kFolk>e_nm_LKoc/kFolk>c_nm
_LH00_o>c/h00onm_LKoc/k>okfmaP02okfmaP0:okfm_Onm_LKo_Kg6okfm
_Onm_LKo_Kfmokfma_n][KGo_KfmokfmaP;o[Jfe0on][Jd01?nm_Kgo[Jfe
ojf]]On][Jd3ojf]]@06odY:B_n<S9Co[Jf]oibLYOn][KGo[Jf]2oooool0
0ooXj>Sof=SHoh:2PP0:onKViP03oh:2P_oJf][oiNGU00Kooooo00CoinON
olk>c_o_moOoknOW1?oNg]h2okfm_@08onOWg_oNg]kog]kNomkNg_oWimko
e]KWomkNg_oFe^L6omkNgP08olk>g_oNg]kog/k6olk>c_nm_KgoW9bLohb<
S?m[Lg<4of][J`05og]kNomkQ8CoW9bLokfm_OoNg]h02Oooool01?o/k>co
j>SXomSHf?n2PX;oonKVi^7oi^KV0002onk^kP;ooooo00KoRXZ:omcLg?oo
ooooooooohZ:R_oLg=`2onk^kP03oh:2P_oJf][oiNGU00_ooooo00Kokno_
okfma_oNg]koc/kFolk>c_o>c]H3olk>cP05okfma_o>c]Koc/k>okfma_o>
c/h00_nm_LH01_o>c/ko_Kg6okfm_Onm_LKo_KfmokfmaP?o_Kfm00Go[Jfe
okfma_n][KGo[Jfeokfm_@02ojf]]@03oibLYOnm_Kgo[Jf]00;o[Jfe0on]
[Jd01on][KGo>CU2oibLYOn][KGoW9bUojf][Onm_Kd02oooool00ooWinOo
emOGoh:2PP0:onk^kP03oh:2P_oJf][oiNGU00Gooooo00[omoO_omKFioo>
e/koinogonoWion<S8co[JfUolk>c_n4U9Co]Jf]1OnLW9`01Oo>c/ko[JFD
ojf]YOn<S8coW9bU00;o[JfU00?oW9bLojf]YOn<S8`00_nLW9`00omkQ8Co
_Kfmog]kN`03of][J`03ohb<S?mkNg_oS8b<00;o[JfU0_o>c/h00ooNg]ko
ooooooooo`08ooooo`04on_[jooWinOoemOGoh:2P_ook^k^hOo^k^h000Go
oooo00GoRXZ:omcLg?ooooooooooohZ:RP02ooooo`03oh:2P_oJf][oiNGU
00_ooooo00?okno_olk>c_oNg]h00oo>c]H00oo>c/koc/kFolk>eP02olk>
cP05olk>e_nm_LKoc/k>okfma_o>c/h00onm_LH00oo>c/ko_Kg6okfmaP03
okfmaPCo_Kfm00Go[Jfeokfm_On][KGo[Jf]oibLY@05ojf]]@03ojf][On]
[KGoBTY:00?oW9bU00?o[Jf]okfma_ooool02_ooool00ooWinOoemOGoh:2
PP0:ooooo`03oh:2P_oJf][oiNGU00Kooooo00Oog]kNolk>c_o_moOoknOW
olk>c_o>e/koinON00;og]kN00Woc]KNolk>c_o>c/koc]KNolk>c_oNg]ko
c/k>olk>g_oNg/h00oo>c/h00on]]KGoc/k>olk>cP02olk>cP05olJm_One
_Lko[JfUohb<S?nm_Kd01?ooool01?o_inOog]kNolk>c_oNg]h;ooooo`04
on_[jooWinOoemOGoh:2P_oooooohOooool000;ok^k^00KoRXZ:omcLg?oo
ooooooooohZ:R_oLg=`2ooooo`;ok^k^00?oPX:2omWIfOoUiND03?ooool0
0onm_LKog]kNolk>eP02olk>eP03ono_kooooooooooo00[ooooo00?oknog
ooooooooool02oooool00oo>c]Ko[Jfeojf]]@03ojf]]@;o[Jf]00Ko>CU2
ojf][On][JgoW9bUojf][Onm_LH;ooooo`03onOWiooHf=SoPX:200[ok^k^
00?oPX:2omWIfOoUiND01_ooool01ooNg]koc/k>onoWioo_inOog]kNomKF
ioo_inL00_oNg]h02_oWg]koknOWonoWioo_inOog]kNolk>g_oWimkog]kN
omKFioo_inL6omkNgP?oc/k>00?o[KFeoiB<S?o>c/h00oooool2omkNgP03
olk>c_oNg]kooooo00_ooooo00Cojn_[onOWiooHf=SoPX:2ooo^k^kQonk^
kP000_oVi^H00oooooooRXZ:omcLg002ooooo`03ohZ:R_oLg=cooooo00;o
i^KV00?oPX:2omWIfOoTi>@03?ooool02?o>c/kog]kWolk>e_oNg]ko[Jfe
okfm_Oo>c]Kog]kN0_oNg^L2omkNgP03omkNiooNg]kog]kN00Gog]kN00So
c/kFomkNg_o>c]Koc/k>omkNg_o>c]Koc/k>olk>eP;oc/k>0_nm_LH2ojf]
]@03okfm_On][KGo[Jf]00;o[Jfe00OoW9bUocTi@_nm_KgoW9bUojf][OnL
W:Goc/k>00_ooooo00?oinOWomSHf?n2PX802_oVi^H00on2PX;ofMWIonCT
i005ooooo`0HonO_mooWimkoc/k>onogmoo>a[GocXaSomk>_Oo_inOog[f]
olIkB_o>aZgoc]KNojf]YOn4U9Co[KFeoibLW?o>c/ko[KFeojfUU?n4U9Co
[KFeoibDS?o>c/koW9bU1?nLW9`02_n][JGoNhB4of][Jonm_Kgoooooonog
mooWimkog]kNolk>c_oNg]h=ooooo`04on_[jooWinOof=SHoh:2P_ooi^KV
hOoVi^H000;ok^k^0_ooool01_n:RX[og=cLooooooooooooRXZ:omcLg0;o
k^k^00?oPh>3omSHf?oTi>@03?ooool02?o>c]Kog]kNomkNg_o>c]Ko_Kfm
of][Noo_knooW9bU0_mJFUX02?mJFV_oJf][oeYJF_mJFU[oJf][oeYJJomJ
FU[oFUY[1OmJFUX2oeYJJ`?oFUYJ00?oFUY[oeYJF_m[Jf/00_nm_Kd3ojf]
]@05okfm_On][KGo[JfeoibLYOli>D800_n][KD00on][JgoW9bUomkNgP0;
ooooo`03onGUiOoIfMWoPh>300[ok^k^00?oPh>3omSHf?oTi>@01_ooool0
6?o>e]koc/k>onogmoo_inOoaZfLomkNc_o_inOoaZfLolj<Hoo_inOoe]KW
okfm[Oo>c/ko[KFeolk>c_oNg]koc/JeokFmc_o6_Kgoc/JeokFmc_o>a[Go
[JfUojfe]@;o_Kfm00[oW9bLojf]YOn<S8coNhB4olk>c_ooooooknOWolkF
g_o>c/kog]kN3_ooool01?oYjNWoiNGUomWIfOn3Ph?oonk^k^7ok^k^0005
ooooo`05ohZ:R_oLg=cooooooooooon:RXX00_ooool00on3Ph?oemOGon?S
h`0<ooooo`0Aolk>c_oNg^Ooc/kFomkNg_nm_LKoNg]komkNion][Jgo0000
ocTi>OlH61So8B4Ho`000?li>CWo0000oaPH6?lY:C400_lH61P01?li>CWo
61PHobTY:OlY:BT3o`000006obTY:OmJFU[oBTY:o`000?li>CWo_Kg60_n]
[KD02Onm_Kgo[Jfeojf]]On][KGo_Kfmohb<U?m:BT[o_KfmoibLY@02ojf]
[@03omkNiooooooooooo00Wooooo00?oiNGUom[Jf_n3Ph<02_ooool00on3
Ph?oemOGon?Sh`05ooooo`0=onogmoo_inOoc/k>onoWiooWimkoc]K>oljU
Q?o>a[GoaW]:oljmYOo_inOoinONolkFgP02onoWi`03onOWg_oNg]kog]kN
00Cog]kN00?oc/kNolk>c_oNg]h00_oNg]h02Oo6_Kgo]Kg>ojf]YOn<S8co
c/kNonoWiooNg]koc/k>omkNgP0?ooooo`04onWYjOoUiNGof][Joh>3Pooo
oooohOooool000;ok^k^00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2oooo
o`;ok^k^00?oPh>3omOGeooShn<03?ooool02OoNg]koc/kFolk>e_oNg^Oo
c/kFof][NooNg]ko[Jf]oaPH6002odY:BP0@ocTi>Om:BT[oBTY:ocTi>Om:
BT[oBU8aocTi@_m:BT[o>CTiodY:B_li>CWoBTY:odYB<OmJFU[o61PHoeYJ
FP;oNg]k00Oo61PHocTi@_o>c/ko[Jfeokfma_n][KGo_Kfm00?o[Jfe00?o
S8b<oeYJF_n][KD00_n][KD00on][Jgokno_ooooo`0:ooooo`03onGUiOoJ
f][oPh>300[ok^k^00?oPh>3omOGeooShn<01_ooool02OoNg]koc/k>ooOg
kooFe^OoknOWomJeW?o>a[GoaW]:olkFgP02onoWi`03onOWg_oFe^OoinON
00Gog]kN00Coc/kNomkNg_oNg/kog]kN1?o>c/h2ojf]Y@05ohb<S?oNc/Ko
g]kNolk>c_oNg]h04?ooool01?oYjNWoiNGUom[Jf_n3Ph?oonk^k^7ok^k^
0002onKViP03oooooon:RX[og=cL00;ooooo00?oRXZ:omcLg?ooool00_oV
i^H00on3Ph?oemOGon?Sh`0<ooooo`03omkNg_o>c]Kog]kN00;oc/kF00ko
Jf][omkNg_nm_LKo0000oeYJF_m:BT[oNg]kocTi>OmJFU[oJf][odY:B_m:
BU[oFUYJodY:BP;oFUYJ00koBTYJoeYJF_mJFU[oJf][o`000?li>CWo[Jf]
og]kNolH61So>CTiolk>c_nm_Kgo[JfeokfmaP?o[Jfe00So_Kfmog]kNomJ
FV_o_Kfmojf][On][KGo[Jf]ono_k`_ooooo00?oiNGUomWIfOn3Ph<02_oV
i^H00on3Ph?oemOGon?Sh`05ooooo`03onO_mooWimkoc/k>00?oknOW00?o
c/Jeolj<Hoo>W7/00_o_inL00ooWimkog]kNomkNgP03omkNgP08olkFg_oN
g]kog]kNomkNg_oNg/koe/kFolk>c_oNg]h2olk>cP;o_Kfm0_nLW9`00oo>
e]koc/k>omkNgP0Aooooo`04onSXj?oUiNGofMWIoh>3Poooi^KVhOoVi^H0
00;ok^k^0_ooool01_n:RX[og=cLooooooooooooRXZ:omcLg0;ok^k^00?o
Ph>3omOGeooShn<03?ooool5omkNgP03oibLYOo>c]Koc/k>00?oS8b<00?o
Ng^<ohb<S?mkNg/00omkNg/00omkNhcoS8b<og]kN`02og]kN`0:og]kS?mk
Ng_oNg]kog]kS?mkNg_oS8b<of][NomkNg_oS8bDokfmaP;o_Kfm00Go[Jfe
okfma_n][KGo[Jfeokfm_@02oibLY@Co[Jfe3?ooool00ooUiNGofMWIoh>3
P`0:onk^kP03oh>3PooGemOohn?S00Kooooo00cog]kNolk>c_o_inOoknOW
olkFg_oWimko]G=Jolk6[Oo_inOoinONomKFiooWimh5omkNgP06omkNc_o>
c]kog]k>olk>g_oNg/koc/kN0oo>c/h01_nm_Kgo[KFeoibLW?nm_Kgoc/k>
omkNgQ;ooooo00Coj>SXonGUiOoIfMWoPh>3ooo^k^kQonk^kP001Oooool0
1On:RX[og=cLooooooooooooRXZ:00;ooooo00?oPX:2omCDe?oRh^803?oo
ool01_o_knooc/k>omkNioo>c/koc/kFomkNgP;oc/kF00?og]kWomkNg_oN
g^L00ooNg^L2omkNgP06omkNioo>c]Koc/kFomkNioo>c]Kog]kN1Oo>c]H0
2_nm_LKoc/k>olk>c_o>c/ko[Jfeokfma_n][KGo_Kfmojf]]Onm_Kd2ojf]
]@06okfm_On][KGo[Jfeojf][On][KGo_Kfm3?ooool00ooTi>Cof=SHoh:2
PP0:ooooo`03oh:2P_oDe=Coh^;R00Gooooo00GokoOgonoWioo>c/komoO_
olkFgP02onoWi`04olk6]OoWimkoinONomKFi`Gog]kN00Ooc/kNomkNg_o>
e]kog]k>olk>g_oNg/koc]KN00?oc/k>00Ko_Kfmojfe]On][JGo[KFeolk6
]OoNg]hCooooo`04onKVi_oTi>Cof=SHoh:2P_oooooohOooool000;ok^k^
00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2ooooo`;ok^k^00?oPX:2omCD
e?oRh^803?ooool01_o_knooc/kFokfma_lY:C7oFUY[ono_k`;og]kN00?o
c/kFomkNg_o>c]H01_o>c]H2olk>cP03okfma_o>c]Ko_Kg600;oc/k>00Co
_Kg6olk>c_nm_LKoc/k>0onm_LH00oo>c/ko_KfmokfmaP02okfm_@07ojf]
]Onm_LKo[Jfeokfm_OnLW9co>CU2oeYJFP02okfm_@cooooo00?oi>CTomSH
f?n2PX802_o^k^h00on2PX;oe=CDon;RhP06ooooo`0;onoWioo>e]koknOW
onOWg_o>e]koknOWonOWg_oFe^OoinONomkNg_oWimh00ooNg]h01ooNg/ko
g]kNomkNc_oFc]Kog]kNolk>c_o>e]h00_o>c/h01oo>a[Go]Kg>okfm_Onm
_Jgo[JfUojfe]OoFe^L05?ooool01?oVi^Koi>CTomSHf?n2PX;oonk^k^7o
k^k^0002onKViP03oooooon:RX[og=cL00;ooooo00?oRXZ:omcLg?ooool0
0_oVi^H00on2PX;oe=CDon;RhP0=ooooo`0:ono_kooNg]koW9bUokfm_Oo_
knoog]kWomkNg_oNg^Oog]kNomkNi`cog]kN00_oc/kFomkNg_o>c/kog]kN
olk>e_o>c/kog]kNolk>c_o>c]Koc/k>olk>eP05olk>cP05okfma_o>c/ko
S8b<oibLYOo>c/h03Oooool00ooTi>CoemOGoh:2PP0:onKViP03oh:2P_oD
e=Coh^;R00Kooooo013okoOgonoWioogmnooe]KWonoWiooWimkoe]KWonOW
g_o>e]koinONolkFg_oNg]koc]KNomkNg_o>e]kog]kN0_o>e]h00oo>e/ko
c]KNolk>cP03olk>cP05okfm_On]]KGo[KFeolk>c_o_inL05Oooool01?oU
iNGoi>CTomOGeon2PX;oonKVi^7oi^KV0002onk^kP;ooooo00KoRXZ:omcL
g?ooooooooooohZ:R_oLg=`2onk^kP03oh:2P_oDe=Coh^;R04Gooooo00?o
i>CTomOGeon2PX802_o^k^h00on2PX;oe=CDon;RhP07ooooo`koknOW00So
g]kNonoWioo_inOoknOWomkNg_o_inOog]kNonoWi`;og]kN0_o_inLGoooo
o`04onGUiOoTi>CoemOGoh:2P_ook^k^hOo^k^h000Gooooo00GoRXZ:omcL
g?ooooooooooohZ:RP02ooooo`03oh:2P_oDe=Coh^;R04Gooooo00?oi>CT
omOGeon2PX802_ooool00on2PX;oe=CDon;RhP0hooooo`04onGUiOoTi>Co
emOGoh:2P_oooooohOooool000;ok^k^00KoRXZ:omcLg?ooooooooooohZ:
R_oLg=`2ooooo`;ok^k^00?oPX:2omCDe?oLg=`0AOooool00ooNg]kod];B
oh:2PP0:onk^kP03oh:2P_oDe=Cog=cL03Sooooo00CoiNGUomkNg_oBd];o
PX:2ooo^k^kQonk^kP000_oVi^H00oooooooRXZ:omcLg002ooooo`03ohZ:
R_oLg=cooooo00;oi^KV00?oPX:2om3@d?oKfm/0AOooool00ooLg=coc/k>
oh:2PP0:onKViP03oh:2P_o@d=3ofm_K03Sooooo00Coh^;RomcLg?o>c/ko
PX:2oooVi^KQonKViP000_o^k^h2ooooo`06ohZ:R_oLg=cooooooooooon:
RX[og=cL0_o^k^h00on2PX;obl_;omOGe`15ooooo`03omKFe_o>c/koPX:2
00[ok^k^00?oPX:2ol_;booGemL0>?ooool01?oLg=coe]KFolk>c_n2PX;o
onk^k^7ok^k^0005ooooo`05ohZ:R_oLg=cooooooooooon:RXX00_ooool0
0on2PX;og]kNong]k@02onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_
0_o`l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP06ono_
koo`l?3okno_ono_koo`l?3okno_0_o`l?000oo_knool?3`oo3`l002ono_
k`?ol?3`0_o_knl2onk^kP06ono_koo`l?3okno_ono_koo`l?3okno_0_o`
l?000oo_knool?3`oo3`l002ono_k`?ol?3`0_o_knl2onk^kP0:ono_koo`
l?3okno_ono_koo`l?3okno_oo3`l?o/k>cohN7Qoh:2PP[ooooo00?oPX:2
omkNg_o]kNd00_o^k^h01_o_knool?3`ono_koo_knool?3`ono_k`;ol?3`
00?okno_oo3`l?o`l?000_o_knl3oo3`l0;okno_0_o^k^h01_o_knool?3`
ono_koo_knool?3`ono_k`;ol?3`00?okno_oo3`l?o`l?000_o_knl3oo3`
l0;okno_0_o^k^h01_o_knool?3`ono_koo_knool?3`ono_k`;ol?3`00?o
kno_oo3`l?o`l?000_o_knl2oo3`l003onc/k?oQhN7oPX:20?oooooohOoo
ool000;ok^k^00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2ooooo`;ok^k^
00?oPX:2on_[joolo?`00_omoOd01Oolo?cooOgmooclo?omoOgoo?cl00;o
oOgm00Coo?cloogmoOolo?cooOgm0oolo?`6oogmo@05ooclo?omoOgoo?cl
oogmoOolo?`00_omoOd01?olo?cooOgmooclo?omoOd3ooclo0KooOgm00Go
o?cloogmoOolo?cooOgmooclo002oogmo@04ooclo?omoOgoo?cloogmo@?o
o?cl1_omoOd01Oolo?cooOgmooclo?omoOgoo?cl00;ooOgm00?oo?cloo3`
l?n2PX802_o^k^h00on2PX;ojn_[ooclo002oogmo@05ooclo?omoOgoo?cl
oogmoOolo?`00_omoOd01?olo?cooOgmooclo?omoOd3ooclo0KooOgm00Go
o?cloogmoOolo?cooOgmooclo002oogmo@04ooclo?omoOgoo?cloogmo@?o
o?cl1_omoOd01Oolo?cooOgmooclo?omoOgoo?cl00;ooOgm00Coo?cloogm
oOolo?cooOgm0oolo?`01?omoOgoo?cloo3`l?n2PX;oonk^k^7ok^k^0002
onKViP03oooooon:RX[og=cL00;ooooo00?oRXZ:omcLg?ooool00_oVi^H9
oh:2PP;oPh>31?n2PX801?n3Ph?oPX:2oh>3Pon3Ph<3oh:2PP03oh>3Pon2
PX;oPX:200CoPX:20_n3Ph<4oh:2PP04oh>3Pon2PX;oPh>3oh>3P`?oPX:2
00?oPh>3oh:2P_n2PX801?n2PX82oh>3P`CoPX:200CoPh>3oh:2P_n3Ph?o
Ph>30on2PX800on3Ph?oPX:2oh:2PP04oh:2PP;oPh>31?n2PX8:onKViPWo
PX:20_n3Ph<4oh:2PP04oh>3Pon2PX;oPh>3oh>3P`?oPX:200?oPh>3oh:2
P_n2PX801?n2PX82oh>3P`CoPX:200CoPh>3oh:2P_n3Ph?oPh>30on2PX80
0on3Ph?oPX:2oh:2PP04oh:2PP;oPh>31?n2PX801?n3Ph?oPX:2oh>3Pon3
Ph<4oh:2P_ooi^KVhOoVi^H000;ok^k^0_ooool01_n:RX[og=cLoooooooo
ooooRXZ:omcLg?ook^k^ooo^k^ihonk^kP001Oooool01On:RX[og=cLoooo
ooooooooRXZ:0?oooooooooooomhooooo`000_o^k^h01_n:RX[og=cLoooo
ooooooooRXZ:omcLg0;oooooooo^k^koonk^kWSok^k^0002onKViP03oooo
oon:RX[og=cL00;ooooo00?oRXZ:omcLg?ooool0oooVi^KoonKViWSoi^KV
0002onk^kP;ooooo00KoRXZ:omcLg?ooooooooooohZ:R_oLg=coonk^k_oo
k^k^N?o^k^h000Gooooo00GoRXZ:omcLg?ooooooooooohZ:RP3ooooooooo
ooooN?ooool000;ok^k^00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2oooo
ooook^k^ooo^k^ihonk^kP000_oVi^H00oooooooRXZ:omcLg002ooooo`03
ohZ:R_oLg=cooooo0?ooi^KVoooVi^IhonKViP000_o^k^h2ooooo`06ohZ:
R_oLg=cooooooooooon:RX[og=cLooo^k^koonk^kWSok^k^0005ooooo`05
ohZ:R_oLg=cooooooooooon:RXX0ooooooooooooogSooooo0002onk^kP06
ohZ:R_oLg=cooooooooooon:RX[og=cL0_ooooooonk^k_ook^k^N?o^k^h0
00;oi^KV00?oooooohZ:R_oLg=`00_ooool00on:RX[og=cLooooo`3oonKV
i_ooi^KVN?oVi^H000;ok^k^0_ooool01_n:RX[og=cLooooooooooooRXZ:
omcLg?ook^k^ooo^k^ihonk^kP001Oooool01On:RX[og=cLoooooooooooo
RXZ:0?oooooooooooomhooooo`000_o^k^h01_n:RX[og=cLoooooooooooo
RXZ:omcLg0;oooooooo^k^koonk^kWSok^k^0002onKViP03oooooon:RX[o
g=cL00;ooooo00?oRXZ:omcLg?ooool0oooVi^KoonKViWSoi^KV0002onk^
kP;ooooo00KoRXZ:omcLg?ooooooooooohZ:R_oLg=coonk^k_ook^k^N?o^
k^h000Gooooo00GoRXZ:omcLg?ooooooooooohZ:RP3oooooooooooooN?oo
ool000;ok^k^00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2ooooooook^k^
ooo^k^ihonk^kP000_oVi^H00oooooooRXZ:omcLg002ooooo`03ohZ:R_oL
g=cooooo0?ooi^KVoooVi^IhonKViP000_o^k^h2ooooo`06ohZ:R_oLg=co
oooooooooon:RX[og=cLooo^k^koonk^kWSok^k^0005ooooo`05ohZ:R_oL
g=cooooooooooon:RXX0ooooooooooooogSooooo0002onk^kP06ohZ:R_oL
g=cooooooooooon:RX[og=cL0_ooooooonk^k_ook^k^N?o^k^h000;oi^KV
00?oooooohZ:R_oLg=`00_ooool00on:RX[og=cLooooo`3oonKVi_ooi^KV
N?oVi^H000;ok^k^0_ooool01_n:RX[og=cLooooooooooooRXZ:omcLg?oo
k^k^ooo^k^ihonk^kP001Oooool01On:RX[og=cLooooooooooooRXZ:0?oo
oooooooooomhooooo`000_o^k^h01_n:RX[og=cLooooooooooooRXZ:omcL
g0;oooooooo^k^koonk^kWSok^k^0002onKViP03oooooon:RX[og=cL00;o
oooo00?oRXZ:omcLg?ooool0oooVi^KoonKViWSoi^KV0002onk^kP;ooooo
00KoRXZ:omcLg?ooooooooooohZ:R_oLg=coonk^k_ook^k^N?o^k^h000Go
oooo00GoRXZ:omcLg?ooooooooooohZ:RP3oooooooooooooN?ooool000;o
k^k^00KoRXZ:omcLg?ooooooooooohZ:R_oLg=`2ooooooook^k^ooo^k^ih
onk^kP000_oVi^H00oooooooRXZ:omcLg002ooooo`03ohZ:R_oLg=cooooo
0?ooi^KVoooVi^IhonKViP000_o^k^h2ooooo`06ohZ:R_oLg=cooooooooo
oon:RX[og=cLooo^k^koonk^kWSok^k^0005ooooo`05ohZ:R_oLg=cooooo
oooooon:RXX0ooooooooooooogSooooo003oonk^k_ook^k^P_o^k^h00?oo
i^KVoooVi^J2onKViP00oomoOgmGogmoO`OoOWinoomoOglTogmoO`0000Co
jn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP3oomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgM000FomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oLg=cogMgMom_Kf`;og=cL03?ogMgMomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]h0
0_oLg=`01OoIfMWof=SHomOGeooHf=SofMWJ00;og=cL0?oog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]h001OogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMgP03omkNgP03omgMgOoNg]kog]kN
00?ogMgM0OoQhN41onOWi`7oj^[Z00000oo/k>coi^KVon3Ph007omWIf@04
omSHf?oFe]Kodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT0
1?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI
00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=SKomWI
f@;of=SH00Koe]KFom?CdooCdm?oe=CDomOGeooHf=P2omWIf@03omSHf?oI
fMWofMWI00;of=SH2OoIfMT00ooHf=SofMWIomWIf@02omSHf003omWIfOoH
f=Sof=SH00;of=SH5ooIfMT01?oHf=Soe]KFom;Bd_o?cll2olg=c@04olo?
cooCdm?oemOGomSHf?oofMWI5_oIfMT00ooHf=SofMWIomWIf@06omWIf@7o
g]kN0OoVi^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoPh>3oh^;R
00;ohN7Q00gog]kNomcLg?oCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_o
alO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?oalO7ok^k^onb
/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_K
fooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO
0=[ohN7Q00Woh>3PomoOgooKfm_oe]KFomCDe?oFe]Kof][JomkNg_oPh>00
1_oOgml3on3Ph003omoOgooPh>3oh>3P00;oh>3P2?oOgml2omkNgP;ogmoO
0ooPh>02omoOg`;oh>3P0_oOgml=on3Ph005omoOgooMgMgofMWIomGEeOoC
dm<00_oBd]800ooFe]Kog=cLon3Ph00Son7Qh@03on3Ph?oQhN7ohN7Q0?7o
hN7Q00?oh^;Ron7QhOoRh^801?oQhN41onCTi07ojNWY0Oo]kNd00003oo3`
l?o_knoolO7a00?ol?3`0?ookno_oo3`l?o^k^kojNWYom_Kfoo1`L7oY:BT
ohb<S?mkNg_oMgMgog]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBTY?n<
S8_oNg]kogMgMomkNg_oS8b<ojBTY?o2`/;of][Jon[Zj?o]kNgolO7aono_
kooalO7okno_oo7alOo_knoolO7_ong]kOoZj^[of][Jol;2`_nTY:CoS8b<
og]kNomgMgKoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knl001_olO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo^k^kokno_on[Zj_oWinL00_oPh>001ooShn?ojn_Yon_[jooZ
j^[oi^KVonSXj?oWinL00_oYjNT04_o^k^cok>c/onc/k?oXj>Sok>c/ong]
kOo`l?3ok>c/on[Zj?oVi^Koj>SXonOWiooYjNWoj>SXon_[jooWinOoinOU
onGUi@;ojNWY00ook^k^ong]kOo]kNgoj>SXon_[jOo/k>cok^k^onWYjOoZ
j^[ojn_[ono_koo/k>cok>cZon[Zj_o^k^h00_o/k>`0oooZj^[okno_onc/
k?o/k>[oj^[Zonk^k_o/k>co[jn_ogIfM_mIFEWoKVi^okNg]_oPh>3ojNWY
ong]kOoalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_k`00;OoalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNool?3`ono_koo`
l?3okno_oo3`l?o_knool?3`ono_k`04oo3`l00000?ol_;bonk^k_oWinL0
1?oUiND04?oTi>CogmoOom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5
ADGoDE5AofIVI_n:RXWo/K6aom7AdOoNg]h2onCTi003onGUiOoTi>CoiNGT
00;oi>CT00oog]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGo
DE5AofIVI_n:RX[o/K6aom7Ad?oNg]h00_oTi>@0kOoUiNGoi>CTonGUiOoT
i>Coi>CSomkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5A
DOmVIVKoRXZ:ok6a/OoAdM7og]kNonCThooTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi002onCTi03oolG5
aOlX:2SoA4A4oi2@T?oAdM7og=cKom_KfooGemOoe=CDomKFe_oDe=CoeMGE
omWIfOoPh=oog]kNom[Jf_oDe=CofMWIomgMgOoRh^;og=cLomOGe_oDe=Co
e]KFomCDe?oEeMGof=SHom_KfooGemOoe]KEomGEeOoGemOof=SHomkNg_oO
gmoog=cLomGEeOoGemKog=cLomgMgOoGemOoe]KFom_KfooQhN7og]kNom_K
f_oJf][og]kNomcLg?oJf][ofm_Kon3Ph?oOgmoog=cKomWIfOoNg]kogmoO
ogAdM?mWIfOoSHf=oeADE?l820SoXZ:RomcLg?oRh^;oiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT001HonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi0CoiNGU00Koi>CTonGUiOoUiNGoiNGU
onSXj?o]kNd1oo;blP0000?om?Cdong]kOoWinL00_oPh>004ooQhN7ogmoO
omkNg_oBd];o];BdohN7QomLG5coKC/eoii>@_o=KeoojH=_ole_GonNCT?o
KC/foeaLG?n7QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7
QhOoG5aLofeP;?nNURkocLdoonWYCOo=cCooWYX_ofeS;OmLG5coQhN7okBd
]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m7IbkoJ9hc
oi7=AonZjEGoTLe7ofZN=?m9JRooG5aLohN7Qond];Cod];BomkNgP3Ion3P
h006omoOgoo?clooVIVIoi:BT_lI6AWoS8b<0_oEeMD07oo?cloo`/;2olk>
c_o>c/koaLG5ol[:b_oJf][of=SHom3@d?o;bl_oclo?omSHf?oJf][oeMGE
olo?coo1`L7od=3@olk>c_o4a<Cobl_;omSHf?oGemOo_[jnok^k^ooAdM7o
d=3@omGEeOoHf=Sodm?Colc<c?o>c/h00_oEeMD01Oo>c/koc<c<om?CdooJ
f][of=SH00;od];B00Cof=SHomOGeooAdM7odm?C0_oIfMT01_oCdm?odM7A
omOGeooHf=SodM7Aom3@d0;odM7A00CoATI6od51@OoGemOog]kN:OoPh>00
0ooOgmooh>3Pon3Ph03Yon3Ph003omoOgooPh>3ogmoO00;ogmoO0ooPh>00
0ooQhN7oinOWonc/k001ooCdm00000?om_Kfoo;bl_o[jn/00ooXj>P04ooW
inOoh^;Rolg=cOnOWiooJemOohlf;_o]LF7onIf@oofaYOom_:oooKBWooVO
Too]M6?oTSL_of]OGonOWioocLg=on;Rh_oWinL00ooXj>P04ooWinOoh^;R
olg=cOnOWiooKVIOoi=b8_o]dDConO=doogmSOomoIGooOf>ooWhM_o]edOo
Tg<RofiWGonOWioocLg=on;Rh_oWinL00ooXj>P04ooWinOoh^;Rolg=cOnO
WiooH6QOod]l8onBhD_o_OUkom3mT_oHoI_oe?fEol3iO_nHj4goCH0Tof1Y
GonOWioocLg=on;Rh_oWinL0f_oXj>P01?oVi^KohN7QoeeMGOm=CDd2omgM
g@0Ooe1@D?l71`Oo5ADEohB4Q?lF5QKo@d=3on;Rh_oMgMgoW9bLo`000?n?
ShoogMgMon7QhOoKfm_o@410o`P82?lI6AWoR8R8o`/;2omHF5So]kNgo``<
3?l71`Oo8b<SobLW9ommOGgof][JomgMgOoDe=Co2`/;oeUIF@02omWIf@03
oeeMGOl;2`_odm?C00;ogmoO00KoFUYJodi>C_oNg]kog]kNob<S8on4Q8@2
on7Qh@0<ogYjN_l^;RkogMgMomgMgOo2`/;oD51@oc<c<om^KVkoPh>3ob4Q
8OoNg]koi^KVoooXj>POonSXj07ok>c/0Oobl_81ooKfmP0000?omoOgooSh
n?ohn?P00oohn?P04oogmoOok^k^olk>c_n@T93oQBl[onUTE_okTXOooZJK
oojaYOoo^:_oo[>VoojXW?okU8WokVQIohTa:on@T93oc/k>onk^k_ogmoL0
0oohn?P04oogmoOok^k^olk>c_n@T93oVFT[oo2m?Ookh6koo_B2ooknR_oo
oi;oo_j<ookhPookiG3ol<8noiUZ:on@T93oc/k>onk^k_ogmoL00oohn?P0
4oogmoOok^k^olk>c_n@T93o@W<[ohC>@on]kg?o`_j8olknT?oFoiOod?jB
olKnROnbmGCoR==3odAe:on@T93oc/k>onk^k_ogmoL0f_ohn?P09Oofm_Ko
lO7aoh61POlO7aookNg]olK6a_l0003o`l?3om?CdomLG5co20P8on[Zj_o`
l?3oj^[Zoe9BD_lD51Co?CdmonWYjOo`l?3o[jn_o`L71ooBd];ocLg=odi>
C_lK6a_ok^k^om_Kfon^[Zkoj>SXonc/k?n^[Zko0000okBd]?o/k>co/;2`
o`/;2olJ6QX00_oTi>@02olS8b?o3Ph>ojBTY?o]kNgok^k^of1PH?mDE5Co
k^k^ong]kOlV9RKoSHf=00;ol?3`00coPX:2oc4a<Oo/k>coj^[Zod=3@ol_
;booW9bLog=cLolZ:R[o6QXJonk^k_ofm_HSooShn003ooOgmoohn?Son?Sh
0?7on?Sh00?omoOgooShn?ohn?P00_ohn?P01?ogmoOonOWiooOgmoogmoL1
ooShn00000?on_[jooGemOo^k^h00_o/k>`0ooo[jn_ojNWYomoOgonj^[[o
NE9Boklb9?oWM6WooHUnoonHS?onXYKoojRLoojTV?ooVXgooXYoonifJ_o3
<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/on[Zj_oOgmoo^[ZjohQU
D_oRTAconL=@oogJHooojW;oo_=nooojP_onmWooonacookNI?ojae7ohY8L
ohUVDonj^[[ogmoOon[Zj_o[jn_ok>c/on_[jooZj^[ogmoOokZj^_mBKE;o
DJ<Loi7BEOnVif[o^?Ujol3nP_o7ohWo`oj4okWmNonWk6coU=IGoe:V7?mB
KE;o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k000BOo/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?oYjNWoiNGUogYj
N_lL71cohN7Rolc<c?l30`?oX:2PomkNg_nDU9Co4a<Con7QhOoPh>7od=3@
o`H61_nQXJ7o2@T9okno_ooPh>3o^[Zjo`820_nb/[;ogMgMoh20P?lX:2So
hn?SonOWiooUiNGogmoOom_KfooCdm?o20P8ohF5QOoOgmooJFUYodY:B_le
=CGo[Jf]okfm_Ol71`OoN7QhoeEEEOoOgmooh>3Poe]KFom@D5000_oQhN40
2_lT92CoQHF5omoOgooQhN7oNg]kobl_;ooPh>3oe=CDo`D51OnXZ:P2on?S
h`3ooginOolF5QKohN7Qon[Zj_o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[000Jonc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jn`6on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H00Oohn?P00003oo_k
nooclo?okNg]00;oiNGU0?ooi^KVonCTi?oIfMWo/[:bogT^;_o8@SCohfYL
ooAjKOomR7cooYN:oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;o
f=SHonCTi?oUiNGoi^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^lA?on
c5?ooMQRookSL_onjGGoo^IcookKIOomc5?onl55onjN:onIERko/[:bomSH
f?oTi>CoiNGUonKVi_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on7bTSoUmaI
ojGUJOnblgOo^?IkokCeNOnWjV_oV=aIohW?BomS[R_o;V<^ok:b/_oHf=Wo
i>CTonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNH003Coi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^Kohn?SomoOgomgMgOo6a/KomcLg?oQ
hN7oWYjNobl_;ol[:b_o<S8boa8B4_oLg=cof][KohB4Q?lP823oh>3Poe9B
D_mXJ6Sof][JomkNg_n@T93o:RXZobh^;_l/;2co9bLW0_oNg]h04ooIfMWo
dm?Dom3@d?mKFe_o0000okfm_OoJf][o:2PXohN7QomgMgSoJ6QXoh:2P_ll
?3co`/;2o`l?3ooDe=Cof][JoeUIFOm>CTh00_oLg=`0>OlS8b?oPH61omGE
eOoGemOoMgMgobh^;_oLg=coXj>So`000?o7alOof=SHomWIfOn=SHko5ADE
omcLg?oTi>CoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonCTi002onGUi@3Z
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV0_oVi^H00ooU
iNGoi^KVonKViP03onKViP03onGUiOo]kNgolo?c007ono_k00000oolo?co
n?Shoo7al@03onk^kP0Con_[jooQhN7o_;blogXG5oo3?c;odeI9onAXF_o_
Mfcom8=iooR7O?oeQ7[olgU]onEYFooIF4[oa3lbog`G5onl_;cohN7Qonc/
k003onk^kP0Conc/k?oQhN7o_;blojE75ooVUc;omJ``oofl@OombE?ooM1P
oo_CIOomdV3oo/eDoofm@_oj[c;ojI/bojE65onl_;cohN7Qonc/k003onk^
kP0Conc/k?oQhN7o_;bloaMI5omOZ3;oM[dgohK=AonFeU[oX^1Uoj?PJOnS
hFOoUmYLohK>Aomg_cOoGj/boaMI5onl_;cohN7Qonc/k03Jonk^kP0^onc/
k?oWinOoNg]koa`L7?oTi>CojNWYonKVi_oQhN7og]kNohf=SOlD51Coi^KV
onCTi?le=CGoNGUion_[jonb/[;o5ADEomoOgooVi^Koi>CTon7QhOoMgMgo
NWYjobTY:OoXj>SoiNGUomgMgOna/K7o9RHVo`/;2onKVi_ojNWYolc<c?l0
003oc/k>ol?3`olU9BGoBd];ogalO?oXj>So<C4aojFUYOoTi>CoGEeMoe5A
D@;oinOW00[o9BDUofUYJOoOgmoogmoOogMgMola<C7ojNWYol71`Ol0003o
YjNW0_oOgml01?nCTi?o5QHFonOWioo/k>coonk^kQkok^k^00?okNg]oo;b
l_ohn?P00Oolo?`000?ooOgm01Koo?cloogmoOomoOgoo?cloo?clooAdM7o
J0L7okPd=?o7?c?odU13omYREOoSKV;oi79TonA_H_oLI5Oode53ola1=?ni
=3CoJ`L7om;Bd_oclo?oo?cl0oomoOd04oolo?colo?com;Bd_nN:`OofXXd
on^K6OoeZ2Won;@oooVmB_oh_dgon[m:ooVh?oofZR[okihIom^;=?nR;@Oo
d];Boo?cloolo?`00oomoOd04oolo?colo?com;Bd_l7@0OoCIXdoen[8?m`
^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^BooHZhPodjK=?l7@POod];Boo?c
loolo?`0f_omoOd08ookno_omoOgohB4Q?lN7Qkolo?cooWinOnc/k?od=3@
oo?clomXJ6SoAdM7oo[jn_oDe=Co0000omgMgOolo?cono_kobLW9onWYjOo
nOWioj^[ZooEeMGolO7aoeADE?mNGUkonOWiooCdm?nDU9Co1@D5od10@?oA
dM7omoOgooShn?nGUiOo:b/[00;on_[j01_o92@To`L71oo8b<Sono_kohF5
QOmSHf?omoOgof=SHomGEeOon?ShooWinOlW9bOo5ADEoh>3PooGemOo@T92
of=SHookno_on_[joc@d=?m9BDWofm_KonGUiOm?Cdoo5aLGoo[jn_olo?`0
ooomoOdLoogmo@03ooclo?omoOgoo?cl00?ooOgm0000>_omoOgon_[joo?c
loo^k^kol?3`ono_koo^k^kojNWYom?CdomK7AgoXS@dok@X7Oo1>RgoadTl
olmFB_o@Ed_od5M:olY:?_o3>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^ko
l?3`ono_koo`l>ook^k^on[Zj_oCdm?oS2DMolQa=?oIQ1goi9@EonNM9?o^
Z3?ol:XdonnZ<oo/X2GoiiLEomb87Oo8LCCoS2DMom?CdooZj^[ok^k^oo3`
l?o_knool?3`onk^k_oZj^Wodm?Coadh7OldPSCoAiDMoeZU6omY[BX2ogBh
>03RogFi>?m[/B_oFjLLodRJ7OldPSCo7CPMom?CdooZj^Wok^k^oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l0;okno_0?ooj^[ZoginO_lL71coj>SWong]kOn8R8So<30`o`l?
3ola<C7o/K6aonk^k_n5QHCoCDe=ono_koo^k^kokno_ohZ:R_mIFEWok^k^
ogQhN?l[:b_o3`l?ocPh>?no_kookNg]onCTi?l>3PkoJFUYomoOgooShn?o
iNGUon_[jomQHF7oMgMgonk^k_o_knkoMWIfobHV9_o]kNgokno_olc<c?l/
;2coj^[Zofe]K?mRHV;ok>c/ong]kOlk>c_oTi>Cof9RH_l>3Pko=3@dolC4
a?o_knook^k^om7AdOll?3co2PX:obLW9om/K6co;2`/ono_koo^k^kol?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knl0
05Kol?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_k`;ol?3`1_o_knl1oo?c
l`7onOWi0Oono_h00003ookno_ogmoOol?3`00CojNWY017oinOWom_KfomS
Bd_oPC8bojHe=Onf=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b
<_mSBd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oRD];ojm;<_o=McGoeX/]
on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;oRD];om_KfooWinL0
1OoYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[ZbooL:dhofn^>_m`
[CSoJZX_oe>K;OliR3Go<V0bod];BooKfm_oinOW0=_ojNWY00Koj>SXonKV
i_mkNg_o71`LonCTi?oXj>P2onWYj@03onOWiooYjNWojNWY00_ojNWY00co
inOWonWYjOoYjNWoj>SXomSHf?l:2P[o[Zj^omgMgOoNg]koh>3PonGUiOoX
j>P8onWYj@06onSXj?oVi^Kohn?Son?ShooVi^Koj>SX0ooYjNT00ooXj>So
jNWYonWYj@04onWYj@03onOWiooYjNWojNWY0?oojNWY6ooYjNT00ooXj>So
jNWYonWYj@04onWYj@7okno_0OogmoL1ooknoP0000Goo_knoo[jn_odm?Co
kno_oo7al@02oo3`l00Aono_koo[jn_oUIBDodlS8onEE5Co^g=com>EUOoJ
W9cofYjLomVLW?oDUIGo^g=coiEDE?m?8b?oUIBDon[Zj_o_knl01Oo`l?00
4Oo_knooj^[ZojVDU?n18b?o^VYDomBJLooT_9Goj/NLonW7W?oZaicoiKbE
omBJLonkJUCoPB<SojZDU?oZj^[okno_00Gol?3`017okno_on[Zj_nDU9Co
8bXSoeAjE?mcYG?oW/JEojc>W?n]cYco[<jLoik6UOmcYG?oE7YDob<Z8onD
U9Coj^[Zono_k`3Koo3`l0;okno_00CoP820oadM7Oo^k^kokno_4oo`l?02
ono_k`07ofATI?lY:BWoPH61of=SHolk>c_ok^k^ono_k`08oo3`l006ono_
koo^k^koLg=cofUYJOo^k^kokno_>Oo`l?000oo_knool?3`oo3`l03`oo3`
l004oo7alOo`l?3om?CdooWin@7oo_kn00001?olo?coooooooooooono_h2
ooooo`;oo_kn0?oooOgmooShn?m^KVkoFSlook6@T?oNbLWol>CToo?Vi_o`
i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?coooooookno_ooooooo_knoooo
o_ono_koooooooclo?ohn?SoSFe]ohXo?oo9TI3ojM39ooCYi?ofjnKom>WT
onW@bOo9TI3oRCloohe]KOohn?Ooo?clooooooono_koooooookno_oooooo
o_knooooo_olo?con?Shofe]KOlo?cooT9f@olWEbOoTk>Coi^kVonC/i?o9
eLWoT9f@oclo?om]KFgon?Shooclo?ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_h003So
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_kooooooogmoOo@d=3oYJFUooknoOono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_oooooooOgmol71`?maLG7oPH61ojn_[`;o
o_kn00coooooookno_ooookoo_knooooooono_koooooookno_oooooooOgm
ol;2`Onl_;`2ooknoP3oooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
000Yookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_h00_ooool00oono_ko
ooooooooo`03ooooo`7ok>k_00001?oem_Koo_knoo[jn_odm?@5oo7al@0=
ono_kooFe]KoJf][od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_o
e]KFono_k`09oo7al@0=ono_kooGe]KoPf][og@m?OneS8coeKZjon7<c?oF
^[[o]Xb<og8m?On1Jf_oemKFono_k`09oo7al@0=ono_kooFe]KoJf][ocdm
?On<S8co^[Zjolc=c?nj^[[oS8b<ocdm?Om[Jf_oe]KFono_k`3ooo7alOoo
lO7a=?oalO401?o`l?3olO7aoo7alOo`l?04oo7al@03ooCdm?ojn_[oo_kn
007o_lG:00001OoVinSooOgmooShn?o`l?3ojn_[00?oj^[Z00gojNWYon[Z
j_oYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY
00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo@RHVofUIFOnPVi_o
j>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mI
FEWoVi^KonSXj?oYjNT0oooZj^[oon[ZjScoj^[Z00Cojn_[oo3`l?ohn?So
oOgm0On0S9H00004okjn_ooin_[onOWiooCdm0SolO7a0_o`l?03ono_k`;o
l?3`3ooalO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l?oo
lO7aA?oalO400oo`l?3olO7aoo7al@3boo7al@03oo3`l?oalO7olO7a00;o
lO7a00?omOGeoo[jn_ng_L800Old@4`00003olW:boo5a/Oon__k0?oooooo
oooooomlooooo`7o^Kk30Om<EUl1oad[>00000Ko41`Vo`lI8OlX;cOoMgf3
okZm`?oYj^_oooooooooooooM_ooool01Oo[k>go_L;7ogj7S_lb?DKo6RPd
007o7Rhj0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{640, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[BoxData[{
    \(\(savedLayout = pane@getLayout[];\)\), "\[IndentingNewLine]", 
    \(JavaBlock[\[IndentingNewLine]\(pane@
          setLayout[\[IndentingNewLine]JavaNew["\<java.awt.GridLayout\>", 3, 
              3, 5, 5]\[IndentingNewLine]];\)\[IndentingNewLine]]\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(toolbar = NewJToolBar[pane]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JToolBar"] \[RightGuillemet]\),
      JLink`Objects`JavaObject77246496768001]], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(icon = 
      JavaNew["\<javax.swing.ImageIcon\>", 
        StringJoin[$JavaSwingMaterial, "\<hdd.gif\>"]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject40394888839169]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(button = NewJButton[Null, "\<J/Link\>", icon]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject75057422401537]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(toolbar@add[button]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject75057422401537]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(button@setLabel["\<\>"]\)], "Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[BoxData[
    \(toolbar@addSeparator[]\)], "Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(icon2 = 
      JavaNew["\<javax.swing.ImageIcon\>", 
        StringJoin[$JavaSwingMaterial, "\<file.gif\>"]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject111778084159489]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(button2 = NewJButton[Null, "\<\>", icon2]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject55928074272769]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(toolbar@add[button2]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JButton"] \[RightGuillemet]\),
      JLink`Objects`JavaObject55928074272769]], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(ReleaseObject[icon]\), "\n", 
    \(ReleaseObject[button]\), "\n", 
    \(ReleaseObject[icon2]\), "\[IndentingNewLine]", 
    \(ReleaseObject[button2]\)}], "Input"],

Cell[BoxData[
    \(DeleteJObject[pane, toolbar]\)], "Input"],

Cell[BoxData[{
    \(JavaBlock[pane@setLayout[savedLayout]]\), "\[IndentingNewLine]", 
    \(ReleaseObject[savedLayout]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JOptionPane <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell["Message", "Text"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004<0000LaP00`40o`00
0?l0003oo`0000d000000003R<2hB928B9280?m8T8P9B9280@00000000>8
`;S8h=R8`;P0ohS0^0R8`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<
c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1
000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8
h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7
c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B928
0@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2h
b>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<
1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0
^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<
c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h067<c<a5ooooH<c<c068
`;P1B9280@00000000>8`;S8h=R8`;P0H<c<c003IVIVc<c<IVIV049VIVH0
0oooolc<c<c<c01Nc<c<0HS0^058T8P1000000000hS0^<SPf8S0^01Pc<c<
00=VIVKoooo<c<`0@Lc<c003IVIVooooc<c<05o<c<`1R<2h0DR@R0400000
0003R<2hb>3HR<2h063<c<`00fIVI_ooolc<c011c<c<00=VIVKoooo<c<`0
Glc<c068`;P1B9280@00000000>8`;S8h=R8`;P0H<c<c003IVIVooooc<c<
00O<c<`bVIW<2<c<c003IVIVooooc<c<05o<c<`1R<2h0DR@R04000000003
R<2hb>3HR<2h063<c<`00fIVI_ooolc<c007c<c<00>IVLc<c<c<c<`0;/c<
c003VIW<c<c<c<c<00K<c<`00fIVI_ooolc<c01Oc<c<0HS0^058T8P10000
00000hS0^<SPf8S0^01Pc<c<00=VIVKoooo<c<`01lc<c003VIW<c<c<c<c<
02[<c<`01@000<c<c<c<c<c<c9VIc008c<c<00=VIVKoooo<c<`0Glc<c068
`;P1B9280@00000000>8`;S8h=R8`;P0H<c<c003IVIVooooc<c<00O<c<`0
0iVIc<c<c<c<c00Zc<c<0P0000;<c<`00iVIc<c<c<c<c006c<c<00=VIVKo
ooo<c<`0Glc<c068`;P1B9280@00000000>8`;S8h=R8`;P0H<c<c003IVIV
ooooc<c<00O<c<`00iVIc00000000004c<c<0P0000;<c<`2000000?<c<`0
000000000/c<c0800002c<c<100000?<c<`300000/c<c0800002c<c<0P00
00K<c<`010000<c<c<c<c9VIc0S<c<`00fIVI_ooolc<c01Oc<c<0HS0^058
T8P1000000000hS0^<SPf8S0^01Pc<c<00=VIVKoooo<c<`01lc<c003VIW<
0000000000C<c<`200000/c<c08000000lc<c00000000002c<c<0P000003
c<c<0000000000;<c<`200000/c<c0<000001<c<c0000000000000;<c<`2
00001/c<c08000000lc<c9VIc<c<c007c<c<00=VIVKoooo<c<`0Glc<c068
`;P1B9280@00000000>8`;S8h=R8`;P0H<c<c003IVIVooooc<c<00O<c<`0
0iVIc00000000004c<c<0P000003c<c<0000000000;<c<`200000/c<c080
00000lc<c00000000002c<c<0P0000;<c<`3000000C<c<`0000000000005
c<c<0`0000;<c<`2000000?<c<bIVLc<c<`01lc<c003IVIVooooc<c<05o<
c<`1R<2h0DR@R04000000003R<2hb>3HR<2h063<c<`00fIVI_ooolc<c007
c<c<00>IVL`0000000001<c<c0D00002c<c<0P0000;<c<`2000000?<c<`0
000000000/c<c08000002<c<c00000000<c<c0000<c<c0000<c<c0800009
c<c<0P000003c<c<VIW<c<c<00O<c<`00fIVI_ooolc<c01Oc<c<0HS0^058
T8P1000000000hS0^<SPf8S0^01Pc<c<00=VIVKoooo<c<`01lc<c003VIW<
0000000000C<c<`400000lc<c0800002c<c<0P000003c<c<0000000000;<
c<`2000000C<c<`00000003<c<`3000000?<c<`0000000002Lc<c0800000
0lc<c9VIc<c<c007c<c<00=VIVKoooo<c<`0Glc<c068`;P1B9280@000000
00>8`;S8h=R8`;P0H<c<c003IVIVooooc<c<00O<c<`00iVIc00000000004
c<c<0P000003c<c<0000000000;<c<`3000000?<c<`0000000000/c<c003
0000c<c<c<c<008000001<c<c00000000<c<c0<000001<c<c00000000<c<
c0800006c<c<0P000003c<c<VIW<c<c<00O<c<`00fIVI_ooolc<c01Oc<c<
0HS0^058T8P1000000000hS0^<SPf8S0^01Pc<c<00=VIVKoooo<c<`01lc<
c003VIW<0000000000C<c<`200000/c<c08000001<c<c00000000<c<c080
0003c<c<100000;<c<`200000/c<c0030000c<c<c<c<008000000lc<c000
00000006c<c<00@0003<c<c<c<bIVL`8c<c<00=VIVKoooo<c<`0Glc<c068
`;P1B9280@00000000>8`;S8h=R8`;P0H<c<c003IVIVooooc<c<00O<c<`0
0iVIc00000000004c<c<0P0002C<c<`200000/c<c003VIW<c<c<c<c<00K<
c<`00fIVI_ooolc<c01Oc<c<0HS0^058T8P1000000000hS0^<SPf8S0^01P
c<c<00=VIVKoooo<c<`01lc<c003VIW<0000000000C<c<`200009<c<c005
0000c<c<c<c<c<c<VIW<00S<c<`00fIVI_ooolc<c01Oc<c<0HS0^058T8P1
000000000hS0^<SPf8S0^01Pc<c<00=VIVKoooo<c<`01lc<c003VIW<c<c<
c<c<02k<c<`00iVIc<c<c<c<c006c<c<00=VIVKoooo<c<`0Glc<c068`;P1
B9280@00000000>8`;S8h=R8`;P0H<c<c003IVIVooooc<c<00O<c<`00iVI
c<c<c<c<c00^c<c<00>IVLc<c<c<c<`01/c<c003IVIVooooc<c<05o<c<`1
R<2h0DR@R04000000003R<2hb>3HR<2h063<c<`00fIVI_ooolc<c007c<c<
00>IVLc<c<c<c<`0;/c<c003VIW<c<c<c<c<00K<c<`00fIVI_ooolc<c01O
c<c<0HS0^058T8P1000000000hS0^<SPf8S0^01Pc<c<00=VIVKoooo<c<`0
1lc<c003VIW<c<c<c<c<02k<c<`00iVIc<c<c<c<c006c<c<00=VIVKoooo<
c<`0Glc<c068`;P1B9280@00000000>8`;S8h=R8`;P0H<c<c003IVIVoooo
c<c<00O<c<`bVIW<2<c<c003IVIVooooc<c<05o<c<`1R<2h0DR@R0400000
0003R<2hb>3HR<2h063<c<`00fIVI_ooolc<c011c<c<00=VIVKoooo<c<`0
Glc<c068`;P1B9280@00000000>8`;S8h=R8`;P0H<c<c003IVIVooooc<c<
047<c<`00fIVI_ooolc<c01Oc<c<0HS0^058T8P1000000000hS0^<SPf8S0
^01Pc<c<00=VIVKoooooool0@Oooo`03c<c<ooooc<c<05o<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h063<c<a5IVIVHLc<c068`;P1B9280@000000
00>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h
0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<1lc<c068
`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R0400000
0003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0
^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1
R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P10000
00000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8h=R8
`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h01K<c<`01jfT
bY:8[:NN`X^2Y:6I^hImWIfE]@3Yc<c<0HS0^058T8P1000000000hS0^<SP
f8S0^00Cc<c<00fi[mRMTk^dZ]6GS[B]Y<ZBR:bWW/:;PZBQVK^6OIfMUKF6
OIfMUKD0i/c<c068`;P1B9280@00000000>8`;S8h=R8`;P04Lc<c00AYik2
_K?MYik2^JoHWI>k]:[AUhjd[JC:TXR/Yik2Rh:TXIVkQWfMWIFeQWfMWIFe
QWfM0>C<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h013<c<`04j:G`Kfc
gJ:G`KfcgJ:G`KV_f9fC^kBZdIN>]:fTbY:7[:NN`X^2Y:6I^hImWIfE]HIm
WIfE]HImW@3Sc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00?c<c<01FR
Ul6m/mfRUl6m/mfRUl6i[mRWW/:i[mRMTk^dZ]6GS[B]Y<ZBR:bWW/:;PZBQ
VK^6OIfMUKF6OIfMUKF6OId0h/c<c068`;P1B9280@00000000>8`;S8h=R8
`;P03/c<c007Yik2_K?MXYO1^JoHYik2_K?MYik200_Hb_l01HImWIfE]HIm
WIfE]HImW@3Qc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00=c<c<00VW
W/:m/mfRUl6m/mfWW/:i[mRRUl51<FRUUlh02D4aJ007f<[oXIVkQWfMWIFe
QWfMWIFeQWfM0>3<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`0
2J:G`KfcgJ:G`KfcgJ:G`KV_f:NN`[V_f44aJ003f<[o00nRUl6i[mRMTk^d
Z]6GS[CHb_nUUlkHb_n;PZBQVK^6OIfMUKF6OIfMUKF6OId0glc<c068`;P1
B9280@00000000>8`;S8h=R8`;P03<c<c008^JoGXYO1_K?MYik2_K?MXYO1
^JoHYik20d4aJ00@f<[o_K?MYik2^JoHWI>k@C5XYIO>@C5XTXR/Yik2Rh:T
XIVkQWfMWIFeQWfMWIFeglc<c068`;P1B9280@00000000>8`;S8h=R8`;P0
2lc<c00M]:[AWI>k^JoGXYO1_K?MXYO1_K?MYik2^JoHXYO1^JoH@C5Xf<[o
XYO1_K?MXYO1^JoH@C5Xf<[oUhjd[JC:TXR/Yik2Rh:TXIVkQWfMWIFeQWfM
WIFe0=k<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00_<c<`07IN>];BZ
dIfC^kV_ej:G`KfcgJ:G`KfcgJ:G`KfcgJNN`T4aJ=S:okfcgJNN`[V_f::G
`D4aJ=S:okBZdIN>]:fTbY:7[:NN`X^2Y:6I^hImWIfE]HImW@0Bc<c<1000
00;<c<`00`000<c<c<c<c006000000C<c<`00000003<c<`200000/c<c080
00000lc<c00000000002c<c<0P0000C<c<`200000/c<c0@00006c<c<1000
00?<c<`400000lc<c0@00002c<c<0P000003c<c<00000000087<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h00_<c<`07JfTbYN>];BZdIfC^kV_ej:G
`KfcgJ:G`KfcgJ:G`KV_f44aJ=S:oj:G`KfcgJNN`[fcgD4aJ=S:oifC^kBZ
dIN>]:fTbY:7[:NN`X^2Y:6I^hImWIfE]@0Ac<c<0P0000;<c<`2000000C<
c<`0003<c<c<c<`200001Lc<c08000000lc<c00000000002c<c<0P000003
c<c<0000000000;<c<`200001<c<c08000000lc<c00000000002c<c<0P00
00C<c<`200000/c<c08000000lc<c00000000002c<c<0P000003c<c<0000
000000;<c<`2000000C<c<`00000003<c<`20000PLc<c068`;P1B9280@00
000000>8`;S8h=R8`;P02/c<c00OYik2TXN/[JC:Uhjd]:[AWI>k^JoGXYO1
_K?MYik2_K?MYik2@C5Xf<[o_K?MXYO1^JoHYik2@C5Xf<[o^JoHWI>k]:[A
Uhjd[JC:TXR/Yik2Rh:TXIVkQWfMWIFe013<c<`200000/c<c0800002c<c<
00@0003<c<`000000005c<c<0P000003c<c<0000000000;<c<`2000000C<
c<`00000003<c<`200001Lc<c0800004c<c<0`0000C<c<`200001Lc<c080
0002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`000000000Q<c<
c068`;P1B9280@00000000>8`;S8h=R8`;P02/c<c00ORh:TYik2TXR/[JC:
Uhjd[JC:WI>k^JoGXYO1_K?MXYO1_K?M@C5Xf<[oXYO1_K?MYik2_K?M@C5X
f<[oXYO1^JoHWI>k]:[AUhjd[JC:TXR/Yik2Rh:TXIVkQWfM01C<c<`20000
0/c<c0040000c<c<000000001Lc<c08000000lc<c00000000002c<c<0P00
0003c<c<0000000000<00005c<c<0P0000;<c<`400001Lc<c0800005c<c<
0P0000;<c<`2000000?<c<`0000000000/c<c08000001<c<c00000000<c<
c0800021c<c<0HS0^058T8P1000000000hS0^<SPf8S0^00:c<c<01nQVK^;
PZBWW/:BR:b]Y<ZGS[BdZ]6MTk^i[mNRUl6m/mfRUl51<FSHb_nm/mfRUl6m
/mfRUl51<FSHb_nm/mfRUl6i[mRMTk^dZ]6GS[B]Y<ZBR:bWW/:;PZBQVK/0
5<c<c0800002c<c<00@0003<c<`000000005c<c<0P000003c<c<00000000
00;<c<`2000000?<c<`0000000000P0000K<c<`2000000C<c<`000000000
0007c<c<0P0000G<c<`200000/c<c08000000lc<c00000000002c<c<0P00
0004c<c<00000000c<c<0P00087<c<`1R<2h0DR@R04000000003R<2hb>3H
R<2h00[<c<`07hImWJ6I^h^2Y:NN`Y:7[:fTbYN>];BZdIfC^kV_ej:G`Kfc
gD4aJ=S:ojNN`[V_f::G`KV_f44aJ=S:ojNN`[fcgJ:G`KV_f9fC^kBZdIN>
]:fTbY:8[:NN`X^2Y00Dc<c<0P0000;<c<`010000<c<c000000000G<c<`2
000000G<c<`000000000003<c<`00P000004c<c<00000000c<c<0P0000G<
c<`2000000?<c<`0000000000/c<c0800004c<c<0P0000;<c<`200000/c<
c0030000c<c<c<c<00800002c<c<00<0003<c<c<c<`00P000004c<c<0000
0000c<c<0P00087<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00[<c<`0
7ifE]HImWJ6I^h^2Y:NN`Y:7[:fTbYN>]:fTbYfC^kV_ej:G`D4aJ=S:okfc
gJNN`[fcgJNN`T4aJ=S:okfcgJ:G`KV_f:NN`[V_f9fC^kBZdIN>]:fTbY:8
[:NN`P0Dc<c<0P0000;<c<`010000<c<c000000000G<c<`2000000C<c<`0
0000003<c<`200000/c<c0800002c<c<0P0000C<c<`200000/c<c0@00006
c<c<100000?<c<`400000lc<c0@00002c<c<0P000003c<c<00000000087<
c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00[<c<`03HImWIfE]HImWIfC
^h^2Y:NN`Y:8[:fTbYN>];BZdIfC^kV_ed4aJ005f<[o00fUUlkHb_nRUl6m
/mfWW/:i[mRRUl6i[mRMTk^dZ]6GS[B]Y<ZBR:`05<c<c0800003c<c<0`00
00o<c<`20000:/c<c08000000lc<c00000000021c<c<0HS0^058T8P10000
00000hS0^<SPf8S0^00:c<c<00bMUKF6OIfMUKF6OIfMTk^;PZBWW/:BQjb]
Y<ZGS[BdZ]6MTk/7@C5X00bRUl6m/mfRUl6m/mfWW/:m/mfRUl6i[mRMTk^d
Z]6GS[B]Y<XDc<c<0P0000?<c<`300001Lc<c0800008c<c<0P0000S<c<`2
00008<c<c08000000lc<c00000000021c<c<0HS0^058T8P1000000000hS0
^<SPf8S0^00;c<c<00fMUKF6OIfMUKF6OIfQVK^;PZBWW/:BQjb]Y<ZGS[Bd
Z]6MTk^i[mL00mS:o`0=_K?MYik2^JoHXYO1_K?MXYO1_K?MXYO1_K?MXYO1
^JoHWI>k]:[A0=k<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00_<c<`0
3HImWIfE]HImWIfE]HImWJ6I^h^2Y:NN`Y:8[:fTbYN>];BZdMS:o`03@C5X
00gHb_nm/mfWW/:i[mRWW/:i[mRWW/:m/mfRUl6m/mfRUl6i[mRMTk/0g/c<
c068`;P1B9280@00000000>8`;S8h=R8`;P02lc<c00MWIFeQWfMWIFeQWfM
WIFeQWfMWI>kRh:TYik2TXR/[JC:Uhjd@C5XWI>k^JoGXYO1@C5Xf<[o_K?M
XYO1_K?MXYO1_K?MXYO1_K?MYik2^JoHYik2^JoH0=k<c<`1R<2h0DR@R040
00000003R<2hb>3HR<2h00c<c<`06ifE]HImWIfE]HImWIfE]HImWIfC^h^2
Y:NN`Y:7[44aJ=S:okBZdIfC^kV_ej:G`D4aJ=S:okfcgJ:G`KV_f::G`KV_
f::G`KfcgJNN`[fcg@3Oc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<
c<c<01^6OIfMUKF6OIfMUKF6OIfMUKF6OIfQVK^;PZBWW/91<FSHb_nGS[Bd
Z]6MTk^i[mM1<FSHb_nWW/:m/mfWW/:m/mfWW/:m/mfRUl6m/mfRUl40glc<
c068`;P1B9280@00000000>8`;S8h=R8`;P03Lc<c00IQWfMWIFeQWfMWIFe
QWfMWIFeQWfMXIVkRh:T@C5Xf<[o[JC:Uhjd]:[AWI>k@C5Xf<[o_K?MXYO1
_K?MXYO1^JoHXYO1^JoHYik20>3<c<`1R<2h0DR@R04000000003R<2hb>3H
R<2h00k<c<`02XImWIfE]HImWIfE]HImWIfE]HImWIfC^h^2Y44aJ0?Hb_l0
2T4aJ=S:okV_ej:G`KfcgJ:G`KfcgJNN`[fcgJNN`^7<c<`1R<2h0DR@R040
00000003R<2hb>3HR<2h00o<c<`02HImWIfE]HImWIfE]HImWIfE]HImWJ6I
^h^2Y003@C5X00VGS[BdZ]6MTk^i[mNRUl6m/mfWW/:i[mRRUl40h/c<c068
`;P1B9280@00000000>8`;S8h=R8`;P04<c<c00CQWfMWIFeQWfMWIFeQWfM
WIFeQWfMXIVkRh:TYik2TXN/[JC:Uhjd]:[AWI>k^JoGXYO1^JoHYik20>?<
c<`1R<2h0DR@R04000000003R<2hb>3HR<2h017<c<`04HImWIfE]HImWIfE
]HImWIfE]HImWJ6I^h^2Y:NN`Y:7[:fTbYN>];BZdIfC^kV_ej:G`@3Tc<c<
0HS0^058T8P1000000000hS0^<SPf8S0^00Cc<c<00fMUKF6OIfMUKF6OIfM
UKF6OIfQVK^;PZBWW/:BQjb]Y<ZGS[BdZ]40i/c<c068`;P1B9280@000000
00>8`;S8h=R8`;P05/c<c007WIFeQWfMWIFeQWfMXIVkRh:TYik20>W<c<`1
R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P10000
00000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8h=R8
`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<
0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00
000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3H
R<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<1lc<
c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R040
00000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SP
f8S0^03oR<2h28S0^058T8P1000000000hS0^<SPf8S0^002002001400H00
0X000X400h4018401H401H801X801h81288128<12H<12X<12h<12h@138@1
3H@00P4>Q@060Pn50Q250Q660Q660Q:60Q>60P8DQ`060QF70QJ70aN80aN8
0aR80aV80P<JR@050a^90ab:0af:0af:11j:00847h/02P@PR`@QR`@RS0@R
S0@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086
;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0Li
U0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9
A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:
Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0B
35ZP35^P35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS3FFS
3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W
3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1k
Za1l[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66
[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<0
1A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg
00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/F
Z;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG
/klD6;C00HS0^058T8P1000000000hS0^<SPf8S0^002002001400H000X00
0X400h4018401H401H801X801h81288128<12H<12X<12h<12h@138@13H@0
0P4>Q@060Pn50Q250Q660Q660Q:60Q>60P8DQ`060QF70QJ70aN80aN80aR8
0aV80P<JR@050a^90ab:0af:0af:11j:00847h/02P@PR`@QR`@RS0@RS0@S
S0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y00
2PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0Lj
U0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9
AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:
D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0B35ZP
35^P35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS3FFS3FFT
3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X
3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l
[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7
/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B
]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HE
WKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/F
Z;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/klD
6;C00HS0^058T8P1000000000hS0^<SPf8S0^002002001400H000X000X40
0h4018401H401H801X801h81288128<12H<12X<12h<12h@138@13H@00P4>
Q@060Pn50Q250Q660Q660Q:60Q>60P8DQ`060QF70QJ70aN80aN80aR80aV8
0P<JR@050a^90ab:0af:0af:11j:00847h/02P@PR`@QR`@RS0@RS0@SS0@T
S0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_
T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0Lj
U0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9
AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:
DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0B35ZP35^P
35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS3FFS3FFT3FJT
3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X
3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l
[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7/08B
R;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C
]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPE
W[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`F
ZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/kl26;C0
4000008H]<01R<2h0DR@R04000000003R<2hb>3HR<2h008008004@01P002
P002P@03P@04P@05P@05PP06PP07PP48PP48P`49P`4:P`4;P`4;Q04<Q04=
Q0020@j500H23hD248D24HH24HH24XH24hH20QB700H25HL25XL35hP35hP3
68P36HP20aZ900D36hT378X37HX37HX47XX00P@OR`0:122;126;12:<12:<
12><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^
T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD
1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4
V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?
W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO018<
FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=
IJ@=IZ@=Ij@23FRU00H>JJD>JZD>JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?
LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[
47b/47b/47f/47j/47n]4Gn]4H2]4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_
4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`05
4i:d4i>d4iBd4iBd4iFe008DU[D01QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L0
1QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX
^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc
_`8H]<000lSPf4R@R4R@R00<B92800D0000H]<0H]<28`;Q8T8P00@000000
00>8`;S8h=R8`;P00P00P00A006000:000:100>100B100F100F200J200N2
0@R20@R30@V30@Z30@^30@^40@b40@f400813XD01P8?Q@8@Q@8AQP8AQP8B
QP8CQP8258L01`8EQ`8FQ`<GR0<GR0<HR0<IR0<JR@03oooo0P<MRP0511j:
11n;11n;122;126;00848X`01P@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDY
SPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLd
TPLeT`LfT`87=i<01@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8
?iH8@9L8@IL224:G00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:
BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;
EYh;Eih;Eil;F9l00P]IW`0B35ZP35^P35bP35bQ35fQ35jQ35nQ35nR362R
366R3F:R3F:S3F>S3FBS3FFS3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V
3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ
3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8A
PZh01Q63[Q64[a65[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=
/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDD
V;HDVKHDVKHDV[LDVkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HE
XkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG
[[hG[khG/;hG/KhG/KlG/[lG/kl26;C000?8h=R8`;R8`;P02hS0^006B928
00006;C06;C0R<2hB9280@00000000>8`;S8h=R8`;P00P00P00:0060oooo
00:100>100B100F100F2oooo00N20@R20oooo`030@^30@^40@b400?oool0
0`8?Q@8@Q@8AQP03oooo0P8DQ`030QF7oooooooo00;oool020<IR?ooo`<J
R@<KR@<LR_ooo`<MRP@NRP?oool02@@QR`@RS0@RS0@SS0@TS0@US@DUS@DV
S@DWSP021BR>00H5:Hh5:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46
<I46<Y46<i86=987=987=I<7=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPl
U@0623fE23jF23nF23nF242G246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI
0PU8V@0E2DVJ2DZJ2T^J2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M
2e>M2eBM2eBN2eFN2eJN2eNN2eNO2eRO008;FIl04PaJX0aKX0aLX0aLX@aM
X@aNX@aOX@aOXPaPXPaQXPeRXPeRX`eSX`eTX`eUX`eUY0eVY0eWY08=J:D0
1PiYY@iZY@i[YPi[YPi/YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?
M:T01@meZ@mfZPmgZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@
OjdAOjdAP:dAPJh24H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0B
R[4BRk4BRk4BS;4BSK8BS[8CS[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@C
UKD00QBF]@0659Ne59Rf59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh
5J2i5J6i0QFR^@0F5J>j5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l
5Z^m5jbm5jfm5jjm5jjn5jnn5k2n5k6n5k6o5k:o5k>o0QRd`003b>3HR<2h
R<2h00^8`;P01TR@R00001Rd`1Rd`8S0^4R@R04000000003R<2hb>3HR<2h
008008004@01P?ooo`02P@03POooo`05P@05P_ooo`07P_ooo`48P`49P`4:
Poooo`4;Q?ooo`4=Q0020@j500[oool248Goool24HH24XH24hKoool258Oo
ool25XL20aN800?oool36HSoool00oooo`837HX01Oooo`@OR`@OR`@PRooo
o`0212:<00H48h`498`49Hd59Hd59Xd59hh21BR>00H5:Hh5:Xl5:hl5:hl5
;8l6;I021Rj@00X6;i06<946<I46<I46<Y46<i86=987=987=I<7=Y<21cNC
00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE23jF23nF23nF242G246G0PQ2
U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E2DVJ2DZJ2T^J2T^J2TbK2TfK
2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM2eBN2eFN2eJN2eNN2eNO2eRO
008;FIl04PaJX0aKX0aLX0aLX@aMX@aNX@aOX@aOXPaPXPaQXPeRXPeRX`eS
X`eTX`eUX`eUY0eVY0eWY08=J:D01PiYY@iZY@i[YPi[YPi/YPi]YP8>KZL0
1Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmgZPmgZQ1hZP0247V[
00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh24H:^00HAPjhAQ:lA
QJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4BSK8BS[8CS[8CSk<C
T;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne59Rf59Vf59Vf59Zg
59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F5J>j5JBj5ZFj5ZFj
5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm5jjn5jnn5k2n5k6n
5k6o5k:o5k>o0QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0^006
B92800006;C06;C0R<2hB9280@00000000>8`;S8h=R8`;P00P00P00A0060
oooo00:100>1oooo00F100F2oooo00N2oooo0@R30@V30@Z30@^30@^40@b4
0@f400;oool0108?Q@8@Q@8AQP8AQP;oool20QB700[oool25XL35hP35hSo
ool36HSoool36XT36hT378X20af:00Goool47h/47h/488/48H/00P@RS006
12><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^
T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD
1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4
V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?
W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO018<
FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=
IJ@=IZ@=Ij@23FRU00H>JJD>JZD>JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?
LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[
47b/47b/47f/47j/47n]4Gn]4H2]4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_
4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`05
4i:d4i>d4iBd4iBd4iFe008DU[D01QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L0
1QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX
^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc
_`8H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0^006B9280000
6;C06;C0R<2hB9280@00000000>8`;S8h=R8`;P00P00P0090060oooo00:1
oooo00B1oooo00F2oooo00N200Goool00`4;Q04<Q?ooo`020@j500H23hD2
48D24HKoool24XH24hH20QB700<25HOoooooool00_ooo`030aV8oooooooo
00;oool20af:1Oooo`848X`01P@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDY
SPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLd
TPLeT`LfT`87=i<01@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8
?iH8@9L8@IL224:G00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:
BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;
EYh;Eih;Eil;F9l00P]IW`0B35ZP35^P35bP35bQ35fQ35jQ35nQ35nR362R
366R3F:R3F:S3F>S3FBS3FFS3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V
3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ
3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8A
PZh01Q63[Q64[a65[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=
/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDD
V;HDVKHDVKHDV[LDVkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HE
XkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG
[[hG[khG/;hG/KhG/KlG/[lG/kl26;C000?8h=R8`;R8`;P00hS0^0@00004
R<2h00I8T8P0000H]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^0020020
01400H3oool00X7oool0187oool01H;oool01h;oool128<12H<12X?oool1
2hCoool13H@00P4>Q@0:oooo0Q25oooo0Q660Q:60Q>6oooo0QB70QF70QJ7
0P<GR006oooo0aV8oooo0aZ90a^9oooo0P<MRP05oooo11n;11n;122;oooo
00848X`01P@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/
S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<0
1@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G
00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:
CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l0
0P]IW`0B35ZP35^P35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S
3FBS3FFS3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`06
3VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/0
2Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65
[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@
/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LD
VkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXF
Y[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG
/KlG/[lG/kl26;C000?8h=R8`;R8`;P018S0^0800005R<2h00I8T8P0000H
]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^002002000X00H3oool00X7o
ool0187oool01H;oool01h812883oooo00<12h<12h@138@00oooo`030Pn5
0Q250Q6600?oool20QB700L25HOoooooooooool368P36HP36XT01?ooo`03
0af:11j:oooo00;oool02@@QR`@RS0@RS0@SS0@TS0@US@DUS@DVS@DWSP02
1BR>00H5:Hh5:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46<I46<Y46
<i86=987=987=I<7=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE
23jF23nF23nF242G246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E
2DVJ2DZJ2T^J2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM
2eBN2eFN2eJN2eNN2eNO2eRO008;FIl04PaJX0aKX0aLX0aLX@aMX@aNX@aO
X@aOXPaPXPaQXPeRXPeRX`eSX`eTX`eUX`eUY0eVY0eWY08=J:D01PiYY@iZ
Y@i[YPi[YPi/YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@me
Z@mfZPmgZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdA
P:dAPJh24H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4B
Rk4BS;4BSK8BS[8CS[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF
]@0659Ne59Rf59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i
0QFR^@0F5J>j5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm
5jfm5jjm5jjn5jnn5k2n5k6n5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h00>8
`;P4000018S0^006B92800006;C06;C0R<2hB9280@00000000>8`;S8h=R8
`;P00P00P0060060oooooooo00>100B100F10_ooo`0900N20@R20@R30@V3
0@Z30@^30@^40@b40@f400813XD01P8?Q@8@Q@8AQP8AQP8BQP8CQP8258L0
1P8EQ`8FQ`<GR0<GR0<HR0<IR0836XT01@<KR@<LRP<MRP<MRP@NRP0211n;
00X488/48H/48X`48X`48h`498`49Hd59Hd59Xd59hh21BR>00H5:Hh5:Xl5
:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46<I46<Y46<i86=987=987=I<7
=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE23jF23nF23nF242G
246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E2DVJ2DZJ2T^J2T^J
2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM2eBN2eFN2eJN2eNN
2eNO2eRO008;FIl04PaJX0aKX0aLX0aLX@aMX@aNX@aOX@aOXPaPXPaQXPeR
XPeRX`eSX`eTX`eUX`eUY0eVY0eWY08=J:D01PiYY@iZY@i[YPi[YPi/YPi]
YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmgZPmgZQ1h
ZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh24H:^00HA
PjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4BSK8BS[8C
S[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne59Rf59Vf
59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F5J>j5JBj
5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm5jjn5jnn
5k2n5k6n5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h00:8`;P200000XS0^080
0003R<2h00I8T8P0000H]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^002
002000H00H3oooooool00h4018401H42oooo00T01h81288128<12H<12X<1
2h<12h@138@13H@00P4>Q@060Pn50Q250Q660Q660Q:60Q>60P8DQ`060QF7
0QJ70aN80aN80aR80aV80P<JR@050a^90ab:0af:0af:11j:00847h/02P@P
R`@QR`@RS0@RS0@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[
S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87
=i<01@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL2
24:G00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:
CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;
F9l00P]IW`0B35ZP35^P35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S
3F>S3FBS3FFS3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^
Y`063VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@
NJ/02Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64
[a65[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?
/a>@/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHD
V[LDVkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXF
YKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG
/KhG/KlG/[lG/kl26;C000C8h=R8`;R8`;R8`;P2000018S0^0800002R<2h
00I8T8P0000H]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^00200200140
0H3oool00X400h4018401H401H;oool01h81288128<12H<12X<12h<12h@1
38@13H@00P4>Q@060Pn50Q250Q660Q660Q:60Q>60P8DQ`060QF70QJ70aN8
0aN80aR80aV80P<JR@050a^90ab:0af:0af:11j:00847h/02P@PR`@QR`@R
S0@RS0@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]
T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@Lh
U0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9
@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:
CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]I
W`0B35ZP35^P35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS
3FFS3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW
3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1j
Za1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65
[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8C
TK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL2
59bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/F
Yk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG
/[lG/kl26;C000?8h=R8`;R8`;P02hS0^006B92800006;C06;C0R<2hB928
0@00000000>8`;S8h=R8`;P00P00P00A006000:000:100>100B100F100F2
00J200N20@R20@R30@V30@Z30@^30@^40@b40@f400813XD01P8?Q@8@Q@8A
QP8AQP8BQP8CQP8258L01P8EQ`8FQ`<GR0<GR0<HR0<IR0836XT01@<KR@<L
RP<MRP<MRP@NRP0211n;00X488/48H/48X`48X`48h`498`49Hd59Hd59Xd5
9hh21BR>00H5:Hh5:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46<I46
<Y46<i86=987=987=I<7=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@06
23fE23jF23nF23nF242G246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8
V@0E2DVJ2DZJ2T^J2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M
2eBM2eBN2eFN2eJN2eNN2eNO2eRO008;FIl04PaJX0aKX0aLX0aLX@aMX@aN
X@aOX@aOXPaPXPaQXPeRXPeRX`eSX`eTX`eUX`eUY0eVY0eWY08=J:D01PiY
Y@iZY@i[YPi[YPi/YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T0
1@meZ@mfZPmgZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdA
OjdAP:dAPJh24H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4B
Rk4BRk4BS;4BSK8BS[8CS[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD0
0QBF]@0659Ne59Rf59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i
5J6i0QFR^@0F5J>j5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m
5jbm5jfm5jjm5jjn5jnn5k2n5k6n5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h
00^8`;P01TR@R00001Rd`1Rd`8S0^4R@R04000000003R<2hb>3HR<2h0080
08004@01P002P002P@03P@04P@05P@05PP06PP07PP48PP48P`49P`4:P`4;
P`4;Q04<Q04=Q0020@j500H23hD248D24HH24HH24XH24hH20QB700H25HL2
5XL35hP35hP368P36HP20aZ900D36hT378X37HX37HX47XX00P@OR`0:122;
126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?
1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLg
T`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88
@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=
V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]H
W`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HZ8=HZ<=
Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>JZD>JjH>JjH>K:H>KJH23VjW
00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?MjX?MjX@N:X00Q1i
Z`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6^0Q62[P064H>^4HB_
4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba4Xfb4Xjb4hjb4hnc
4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D01QBG]ABH]QBI]QBI]QBJ
]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T05QFS^QFT^QJU^QJU
^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^_AN^_QN__QN`_QNa
_QNa_aNb_aNc_`8H]<0?b>3H00D0000H]<0H]<28`;Q8T8P00@00000000>8
`;S8h=R8`;P00P00P00A006000:000:100>100B100F100F200J200N20@R2
0@R30@V30@Z30@^30@^40@b40@f400813XD01P8?Q@8@Q@8AQP8AQP8BQP8C
QP8258L01P8EQ`8FQ`<GR0<GR0<HR0<IR0836XT01@<KR@<LRP<MRP<MRP@N
RP0211n;00X488/48H/48X`48X`48h`498`49Hd59Hd59Xd59hh21BR>00H5
:Hh5:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46<I46<Y46<i86=987
=987=I<7=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE23jF23nF
23nF242G246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E2DVJ2DZJ
2T^J2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM2eBN2eFN
2eJN2eNN2eNO2eRO008;FIl04PaJX0aKX0aLX0aLX@aMX@aNX@aOX@aOXPaP
XPaQXPeRXPeRX`eSX`eTX`eUX`eUY0eVY0eWY08=J:D01PiYY@iZY@i[YPi[
YPi/YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmg
ZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh2
4H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4B
SK8BS[8CS[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne
59Rf59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F
5J>j5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm
5jjn5jnn5k2n5k6n5k6o5k:o5k>o51Rd`068`;P1B9280@00000000>8`;S8
h=R8`;P00P00P00A006000:000:100>100B100F100F200J200N20@R20@R3
0@V30@Z30@^30@^40@b40@f400813XD01P8?Q@8@Q@8AQP8AQP8BQP8CQP82
58L01P8EQ`8FQ`<GR0<GR0<HR0<IR0836XT01@<KR@<LRP<MRP<MRP@NRP02
11n;00X488/48H/48X`48X`48h`498`49Hd59Hd59Xd59hh21BR>00H5:Hh5
:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46<I46<Y46<i86=987=987
=I<7=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE23jF23nF23nF
242G246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E2DVJ2DZJ2T^J
2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM2eBN2eFN2eJN
2eNN2eNO2eRO008;FIl04PaJX0aKX0aLX0aLX@aMX@aNX@aOX@aOXPaPXPaQ
XPeRXPeRX`eSX`eTX`eUX`eUY0eVY0eWY08=J:D01PiYY@iZY@i[YPi[YPi/
YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmgZPmg
ZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh24H:^
00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4BSK8B
S[8CS[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne59Rf
59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F5J>j
5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm5jjn
5jnn5k2n5k6n5k6o5k:o5k>o51Rd`068`;P1B9280@00000000>8`;S8h=R8
`;P0ohS0^0R8`;P1B9280@00000000>8`;S8h=S8h=P0olSPf0S8h=P1B928
0@000000ohS0^0b8`;P100000000\
\>"], "Graphics",
  ImageSize->{268, 115},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000460000S2000`400?l0
0000o`00003oooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000
ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`
l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07
oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`
l?07oo3`l000ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00
ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKV
iP00ooo^k^h7onk^kP00ooooool7ooooo`00W_o^k^h2ong]k@0:on_[jooX
j>SoiNGUon;Rh_oMgMgof=SHomCDe?oAdM7oc/k>olc<c0;obl_;@Oo:b/X2
ol_;b`0:olc<c?o>c/kodM7AomCDe?oHf=SogMgMon;Rh_oUiNGoj>SXon_[
j`;okNg]2oo^k^h009goi^KV0_oUiND02_oRh^;oh>3Pom_KfooFe]Koc/k>
olO7aono_koo^;RhokBd]?n`/;02ojj^[P;o[Jf]?on/[:`2ojf][@;o[Zj^
00[o/;2`okBd]?nh^;So_knoolO7aoo>c/koe]KFom_KfooPh>3oh^;R0_oU
iND:onKViP00WOo^k^h03_o]kNgoj^[ZonOWiooRh^;ofMWIolk>c_o3`l?o
^;Rhojj^[_nVYZKoX:2PoibLW?nIVIWoV9RH@onGUiL03OnHV9SoVIVIoibL
W?nPX:3oYZJVojj^[_nh^;So`l?3olk>c_oIfMWoh^;RonOWiooZj^X00_o]
kNd9onk^kP00WOooool03_olo?conOWioo;bl_oXj>Sof][Jol_;bonj^[[o
[:b/oinOWonEUIGoSXj>ohZ:R_n7QhOoQXJ6@on5QHD03on6QXKoQhN7ohZ:
R_n>SXkoUIFEoinOWon/[:co^[Zjol_;booJf][oj>SXoo;bl_oinOWoo?cl
ooknoP09ooooo`00WOo^k^h05?oXj>Soh^;RomWIfOo:b/[o^[ZjojRXZ?nH
V9SoTY:BojFUYOo0`<3oemOGon_[joofm_KomoOgooWinOohn?SonOWioo[j
n_oinOWomoOg0oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWo
moOg00Con?Sh013onOWiooShn?ogmoOokNg]omSHf?o1`L7oYJFUoi:BT_nH
V9SoZ:RXokZj^_o:b/[ofMWIon;Rh_oXj>Sok>c/2Oo^k^h009goi^KV00co
gMgMomKFe_o7alOo]kNgoj>SXonATI7oXZ:Rol_;boo^k^kom_Kfooclo?on
o_i7ooooo`0=ookno_olo?comoOgono_koo<c<coXj>Soi6ATOnSXj?o]kNg
olO7aooFe]KogMgMon;RhP09onKViP00WOo^k^h02_oRh^;oe]KFol?3`on^
[ZkoVYZJojf][OoNg]kojn_[ooCdm?okno];ooooo`0;oo_knooclo?ok>c/
on7QhOn`/;3oVYZJojj^[_o3`l?oe]KFon;Rh_oXj>P02Oo^k^h009gooooo
00[okNg]omcLg?o5aLGo[:b/ojf][OoDe=Coh>3Ponc/k?oemOGooOgm?_oo
ool00onb/[;on?Shooooo`0:ooooo`0;ookno_ofm_Kok>c/on;Rh_oIfMWo
/K6aojb/[?o5aLGog=cLong]kOofm_H02Oooool009gok^k^00_of=SHolK6
a_n^[ZkoXj>SolK6a_oDe=Coh>3Ponc/k?obl_;oo?clooknoP0Sooooo`03
onc/k?o_knoooooo01Oooooo00?oa/K6oe]KFoooool02_ooool02oojn_[o
m?Cdon[Zj_oShn?oemOGolg=cOnVYZKo[Zj^olK6a_oHf=Soh^;R00Wok^k^
002MonKViP0?olg=cOni^KWoXJ6Qoj^[Zoo6a/Kod];BomcLg?oVi^Kok>c/
ooGemOohn?Son_[joogmoOooooooo?cl00Gooooo00Co=3@dogIfM_oooooo
oOgm1?ooool03_m0@43oOgmooooooooinOWoCDe=obd];Oo_knoooooood10
@?moOgoooooooogmoOnSXj?o71`L0_ooool01_oKfm_o=CDeo`h>3_l;2`_o
>CTiomcLg0;ooooo00Ooi^KVo`000?n8R8SooOgmoooooom9BDWo:2PX00?o
oooo00?oKFe]oe5ADOooool01_ooool01?omoOgoooooof=SHon5QHD5oooo
o`0@oogmoOoooooooOgmoo_knoohn?Som?Cdong]kOoVi^KogmoOomKFe_o<
c<co/K6aoj:RX_ni^KWocLg=om_Kf`Woi^KV002Monk^kP0Gom7AdOnk^k_o
XJ6QokJf]_o3`l?oclo?omKFe_oOgmooi^KVon[Zj_o_knoolo?cooCdm?oe
mOGomoOgooKfm_ogmoOom_KfooShn?ogmoOo<S8bog5aLOofm_H00_ogmoL0
6Oofm_Kon?ShooOgmolm?CgoNWYjooGemOmLG5co7alOomgMgOohn?SomoOg
ocdm?OmjNW[om_KfooOgmonMWIgo6a/KooShn?ofm_Ko<S8bodm?CooUiNGo
i^KVoe9BD_lc<c<00_ogmoL03onIVIWo3Ph>ocHf=_ogmoOol?3`o`T92Ol>
3PkocLg=ooOgmoofm_Kodm?Colg=cOogmoOom_KfooShn002ooOgm`;om_Kf
0_ogmoL01?o=cLgo4A4Aoo7alOogmoL3ooKfmP0@ooOgmoofm_Kom?Cdoo;b
l_o`l?3ojn_[onKVi_oQhN7of][Jom?Cdoo9bLWo_knoojJVY_nk^k_odM7A
on7Qh@Wok^k^002Mooooo`0;omoOgoo5aLGoY:BTok>c/oo0`<3obLW9om?C
dooIfMWogMgMon;Rh_oUiND00_oZj^X00oo/k>cokNg]ong]k@04onk^kP04
oc0`<?m^KVkok^k^oo3`l0Cok^k^00Go>c/kogIfM_m[Jf_o51@Dolc<c003
onk^kP0Hoc/k>omfMWKok^k^oo3`l?nHV9So6QXJonk^k_o9bLWo0000ojZZ
Z_o^k^kol?3`ojZZZ_l0003ocLg=onk^k_m?CdooJf][oaXJ6_oJf][o/;2`
oahN7_mVIVKoN7Qh0oo^k^h00oo`l?3ok^k^onk^kP05onk^kP05oo3`l?o^
k^koinOWo`000?na/K400oo^k^h2ong]k@;ok>c/00gojNWYonKVi_oShn?o
h>3Pom_KfooEeMGocLg=olG5aOnk^k_oZj^[olG5aOoOgmool?3`00Wooooo
002Monk^kP0=om3@d?nh^;SoW9bLojb/[?nk^k_oa/K6olg=cOoCdm?oemOG
om_KfooOgmoohN7Qon;RhP02on?Sh`GoiNGU00Co;Rh^ofUYJOoVi^Koi^KV
1?oUiND01?li>CWo<S8bo`000?n_[jl4onGUi@0:ocTi>OmbLW;oi^KVonKV
i_nBTY;o6ATIonGUiOnZZZ[o0000olk>cP;oi^KV00coc<c<o`000?n][Jgo
hN7Qo`d=3OnYZJWoGEeMohZ:R_mZJV[oFe]Kojb/[?lX:2P2onGUi@;oi^KV
00?oiNGUom_Kfom1@D401?m1@D401OoDe=CoiNGUonGUiOlI6AWoSHf=00;o
iNGU00?oi^KVonCTi?oTi>@00_oShn<03OoRh^;oh>3PomcLg?oIfMWoe]KF
om3@d?o9bLWo`L71okFe]OnUYJGo^;Rhom3@d?oPh>002Oo^k^h009goi^KV
00gob/[:okFe]OnDU9CoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOG
eooJf][ofm_K00?og=cL0_oNg]h2omgMg@04obd];OmVIVKogMgMomgMg@;o
g]kN0_oMgMd01_lg=cOoKFe]odY:B_m5ADGog=cLomkNgP;ogMgM00[o=cLg
oe1@D?oMgMgogMgMohR8R?lI6AWogMgMokjn__l0003oW9bL0_oMgMd03_nJ
VY[o0000ol;2`_nYZJWo2PX:omSHf?nMWIgo@D51obXZ:_nDU9Cofm_Koa<C
4onl_;cog]kN0_oMgMd00ooNg]kofm_KojZZZP02ojZZZP03oj^[ZonZZZ[o
emOG00;og]kN00Co71`LohF5QOoMgMgog]kN0_oMgMd2omcLg00>om_KfooJ
f][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
b_oIfMT9onKViP00WOo^k^h03OoDe=Co_knoohb<S?nNWYko[Jf]okVi^Oo2
`/;oalO7olc<c?o@d=3od];BomGEeOoFe]H00_oGemL00ooHf=SofMWIomWI
f@02omWIf@03ob`/;?mTI6CofMWI00GofMWI00Go=SHfofa/K?oCdm?o<c<c
oemOG`03omWIf@06ocHf=_lA4A7oI6ATokbl_?m:BT[o@D510_oIfMT05?lg
=cOo?Cdmokbl_?nl_;co?3`locTi>OoIfMWoIVIVod51@OoIfMWodm?Co`l?
3ol20P;obLW9omWIfOmFEUKoLW9bomWIfOn[Zj_oXj>S2OoIfMT00ooEeMGo
0P82oibLW003omWIf@;of=SH0_oGemL03OoEeMGodm?Com3@d?o>c/kob/[:
olG5aOno_koo]KFeojVYZOnHV9So_knoomCDe?oRh^802Oo^k^h009gooooo
00goj>SXomCDe?n<S8coTi>Coj:RX_n_[joo^[Zjol71`Oo7alOobl_;olk>
c_o@d=3odM7A00;odm?C0ooDe=@2omGEe@04ob/[:omRHV;oe]KFomGEe0;o
e=CD0_oEeMD01_le=CGoJVYZomKFe_o5aLGo;2`/ohb<S0;oeMGE00KoATI6
ogAdM?mUIFGo410@obHV9_nRXZ82omGEe@0Dol;2`_m4A4Co30`<o``<3?m5
ADGo`L71omGEeOlm?CgoQ8B4omGEeOoFe]KoDE5@ocTi>OoDe=CoeMGEoifM
WOm0@43oeMGEofQXJ?mCDe<2omCDe0;oeMGE00goe]KFomGEeOoFe]KoeMGD
omCDe?nf][Ko2@T9ol[:b_oFe]KoeMGEomKFe_oEeMGoe=CD00;odm?C00go
dM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jfoj^[ZonMWIgoUIFEomCDe?oX
j>Solo?c00Wooooo002Monk^kP0BomgMgOo=cLgoT92@ohV9ROnGUiOoYJFU
ok:b/_no_koobl_;om7AdOoEeMGoemOGomWIfOoJf][ofm_Kom[Jf_oKfm_o
g=cL0_oKfm/00ol/;2coIFEUom_Kf`02om_Kf`05omcLg?oKfm_ofm_KocHf
=_m]KFd00ooKfm/00ooLg=cofm_Kom_Kf`03om_Kf`03om[Jf_oKfm_og=cL
00Cofm_K0_oJf]X00ooKfm_og=cLom_Kf`06om_Kf`03omcLg?oKfm_ofm_K
00Gofm_K00?og=cLom_KfooKfm/01OoKfm/00omYJFWoGEeMom_Kf`05om_K
f`0?om[Jf_oIfMWof=SHomKFe_oCdm?ocLg=ol;2`_nf][Ko[:b/oinOWon@
T93oUYJFolg=cOoMgMgoiNGU00Wok^k^002MonKViP0;om[Jf_o>c/koW9bL
ogYjN_n8R8SoUYJFojZZZ_o4a<CoeMGEom_KfooNg]h00_oPh>03on;RhP06
onCTi?oShn?ohn?Son?Shol^;RkoJFUY0_oShn<01_oTi>Cohn?Son?ShooS
hn?o>3Phog5aL@;ohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<0
1OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03ol71`Oln?SkogMgM00Gohn?S
0_oRh^803_oQhN7oh>3PomoOgooLg=coemOGolG5aOn/[:coWYjNoi2@T?n2
PX;oX:2Polk>c_oJf][oh>3P2OoVi^H009gok^k^00koiNGUomgMgOo2`/;o
Ng]kogQhN?n6QXKoWinOolG5aOoHf=SogMgMomoOgooQhN7oh^;Ron?Sh`?o
i>CT0ooUiND01OnMWIgo/k>conCTi?oUiNGoi>CT00?oiNGU00Go>CTiog5a
LOoTi>CoiNGUonCTi004onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2
onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03
onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOn?Shoo
eMGE00?oiNGU1OoTi>@03_oShn?ohN7Qon3Ph?oOgmoof][JolK6a_nQXJ7o
SHf=oh20P?n4Q8Co`l?3omgMgOoUiNGoj^[Z2Oo^k^h009gooooo00_onOWi
oo?clooYjNWoZ:RXofEUIOmcLg?oSHf=ok^k^ooDe=Cof][JomgMg@02omoO
g`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401?oQhN400ooM
gMgoh>3Pon7Qh@06on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@02on7Q
h@0>on3Ph?oOgmoogMgMomcLg?oEeMGo^KViohj>S_mkNg_oKVi^oj^[ZooY
jNWolo?cooWinOomoOd9ooooo`00WOo^k^h03?o[jn_oj>SXon;Rh_oGemOo
SHf=of9RH_mfMWKoY:BTolO7aooBd];oeMGEomSHf0;of][J0ooKfm/7omcL
g003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL
00Cog=cL017ofm_KomcLg?oKfm_of][JomWIfOoHf=Sodm?ColG5aOnLW9co
MGEeofMWIon@T93oemOGon;Rh_oXj>Sojn_[ong]k@09onk^kP00WOoVi^H0
3_oUiNGoh^;RomoOgooJf][obLW9ohN7QomJFU[oNg]koj>SXonl_;coa/K6
ol_;boo=cLgoclo?0_oAdM45om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoB
d];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7A
d@05om;BdP03om7AdOoBd];odM7A00God];B017odM7Aom;Bd_oAdM7odM7A
om3@d?o?clooc<c<olS8b?nk^k_oW9bLog9bL_mKFe_oRXZ:olW9bOoJf][o
gmoOon;RhP02onGUi@Woi^KV002Monk^kP;okNg]00koj^[ZonSXj?oRh^;o
g=cLoibLW?m]KFgoJ6QXoh>3PonGUiOoXj>Sojb/[?n_[joo/K6aok:b/P;o
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf
][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][Jd
okBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@03one]KGo/k>cok:b/_nc
/k?o[jn_ojZZZ_nLW9coPX:2of9RH_m^KVkoWinOomcLg?oRh^;oj>SXon[Z
jP02ong]k@[ok^k^002Nooooo`;oo_kn00ooo?clooWinOofm_Kol_;bomWI
fOnXZ:SoPh>3ofi^K_mUIFGoJFUYog9bL_mdM7CoNGUiogalO?mkNg/00_mm
OGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNoml
O7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]k
NomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7co
Ng]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00?oO7al
og]kNomlO7`00_mjNWX02omgMgOoM7Adofm_KomdM7CoQHF5ojRXZ?oJf][o
l_;booKfm_oinOWoo?cl00;oo_kn2oooool009ook^k^0_o]kNd01?o/k>co
j^[ZonSXj?oUiND2on;RhP03on3Ph?oOgmoog]kN04GogMgM00?og]kNomoO
gooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/k>`2ong]k@cok^k^002QonKV
iP;oiNGU00?oi>CTon;Rh_oRh^800_oPh>02omoOgdGog]kN0_oOgml2on3P
h0;oh^;R00?oi>CTonGUiOoUiND03_oVi^H00?ook^k^1oo^k^h00?oooooo
1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H00?ook^k^1oo^k^h00?oo
oooo1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H00?ook^k^1oo^k^h0
0?oooooo1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H00?ook^k^1oo^
k^h00?oooooo1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H00?ook^k^
1oo^k^h00?oooooo1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H002Go
k^k^00?ok>c/onSXj?oZj^X0g_o^k^h002Cooooo00Gono_kon_[joo;bl_o
inOWooknoP3Mooooo`008?o^k^h3ong]k@06onKVi_o>c/koUiNGohn?Sonf
][KokNg]gOo^k^h001_oi^KV00koiNGUon?ShooPh>3ogMgMom[Jf_oGemOo
e]KFom?Cdond];CoQ8B4okno_oo7alOoZJVYonGUiMgoi^KV000Ionk^kP0A
ong]kOoYjNWoh>3Pom;Bd_o0`<3o[Jf]oinOWonHV9SoUIFEoi2@T?n<S8co
hn?Soo3`l?o:b/[oZZZZonSXj?o]kNd0g?o^k^h001Sooooo00cono_konk^
k_oAdM7oZZZZohn?SonEUIGo[Jf]olK6a_o@d=3od];BomOGeooemOD2ong]
k@05omcLg?nBTY;odm?Conc/k?okno/0foooool001Kok^k^00kokNg]onGU
iOo:b/[oVYZJohZ:R_o2`/;okNg]ooWinOofm_Kol_;bono_koo`l?3ok^k^
onc/k0;ol?3`00OolO7aolS8b?n;Rh_oVYZJol[:b_oUiNGokNg]0=Wok^k^
000EonKViP09onGUiOoJf][o/[:bohF5QOo4a<ComoOgoo?cloo]kNgok^k^
00;ol?3`00ComoOgoo7alOogmoOol_;b0ooalO401ooclo?omoOgolC4a?n5
QHGo/[:bom[Jf_oUiND0f?oVi^H001Cok^k^00SokNg]on;Rh_nb/[;oShn?
onc/k?oclo?ok^k^oo7al@;ol_;b00Kol?3`ooShn?nh^;SoJVYZoifMWOod
m?@3oo;blP08oo7alOo^k^kolo?conc/k?n?Shoo/[:bon;Rh_o]kNgGonk^
kP005?ooool01_oinOWob/[:oiNGUoohn?Sokno_oo;blP?olo?c00Wol_;b
ooGemOoYjNWoI6AToeUIFOmDE5CocLg=oo_knooalO400ooclo<01_obl_;o
kno_ooShn?nGUiOob/[:ooWinAoooooo00?oCTi>ojRXZ?ojn_X00_ooool0
0om_Kfoo/k>cooooo`2`ooooo`004oo^k^h01Oo]kNgod];Bohf=SOo`l?3o
kno_00Gom?Cd00Wolo?cooGemOo`l?3oLG5aodi>C_mKFe_of=SHoo[jn_oc
lo<01Oodm?@01Oo_knool?3`ohf=SOoBd];okNg]01kok^k^00?oWinOoa/K
6onLW9`00_o^k^h00onHV9SoFEUIonk^kP0Xonk^kP;ohN7Q2_o^k^h00ooM
gMgogmoOonk^kP04onk^kP03omcLg?oOgmook^k^00Gok^k^00?og=cLomoO
goo^k^h0J_o^k^h001?oi^KV00GogmoOoijNW_o<c<comOGeooCdm006ooGe
m@07ooCdm?okno_oe]KFoiNGUoo2`/;on_[jooCdm006ooGem@05ooCdm?oe
mOGoc<c<oijNW_oOgml07ooVi^H01omOGeooCTi>onKVi_oVi^Koe=CDoaDE
5OoUiND01?oVi^H00ol`<33o0000o`000002o`000004oc@d=?oVi^Ko>CTi
og9bLP;oi^KV00Ko>CTiog9bL_oVi^Koi^KVoi>CTolI6AT2onKViP07ocTi
>OmbLW;oi^KVon;Rh_m5ADGo:2PXomOGe`05onKViP09ocTi>OmbLW;oi^KV
onKVi_lQ8B7o3Ph>oa`L7?m5ADGogMgM00Koi^KV00goc/k>ocTi>Ol0003o
410@oaXJ6_oOgmooi^KVolG5aOl_;boo30`<o`X:2_lc<c?oa/K600;oi^KV
00KoaLG5obl_;ol<30co2PX:oc<c<oo6a/H2onKViP06ocTi>OmbLW;oi^KV
onKVi_mRHV;oBDU9HOoVi^H001?ok^k^00Coe]KFoi6ATOoinOWol_;b2?of
m_H01OoemOGoo?clom;Bd_oclo?on?Sh00Som_Kf00Col_;booWinOnATI7o
e]KF7oo^k^h00on0P83o7QhNonk^kP02onk^kP03ocPh>?nh^;Sok^k^00?o
k^k^00?o<S8bofa/K?o^k^h01?o^k^h01_lk>c_oMWIfonk^k_o^k^ko>c/k
ogIfMP;ok^k^00[oV9RHoaXJ6_o^k^kok^k^oc/k>omfMWKokNg]oeQHF?lN
7Qkoe]KF1_o^k^h02Olk>c_oMWIfonk^k_o^k^ko/k>con[Zj_o]kNgo<S8b
ohR8R006onk^kP09ocdm?OlY:BWo_Kfmonk^k_o9bLWok>c/ong]kOl`<33o
C4a<00;og]kN00KoCdm?oc4a<Oo]kNgokNg]oc0`<?m<C4`2omkNgP06odm?
Cola<C7okNg]onk^k_lk>c_oMWIf0_o^k^h00oo<c<coaLG5onk^kP1Ponk^
kP004_ooool01Oono_kob<S8okbl_?ojn_[om_Kf00OomoOg00Oom_KfooWi
nOobl_;oHV9Rolk>c_oooooomOGe00OomoOg00Gom_Kfoo[jn_nl_;cob<S8
ooknoP0Nooooo`03ohZ:R_lO7aoooooo00;ooooo00?oRXZ:ogYjN_ooool0
0oooool00olf=SKoM7Adooooo`04ooooo`06od10@?moOgoooooooooooom0
@43oOgmo0_ooool02OnSXj?o71`Loooooooooooo@410ogmoOomcLg?o5QHF
om_Kf`07ooooo`03od10@?moOgoooooo00?ooooo00?oaLG5oaHF5_nCTi<0
1Oooool00ooLg=co0000oiFEU@04ooooo`03omSHf?l0003o]kNg00;ooooo
00Ko]kNgo`000?oLg=cof=SHo`000?ng]kL2ooooo`06okNg]ol0003og=cL
oooooom0@43oOgmo0_ooool00oo:b/[o_;blooooo`1Pooooo`004_o^k^h0
1?o[jn_oXj>Son3Ph?ofm_H8ooShn007ooOgmoomoOgoi^KVoeYJF_o0`<3o
ooooooKfmP08ooShn004ooKfm_oPh>3oXj>Son_[jakok^k^00?oP820oa`L
7?o^k^h00_o^k^h00oo7alOo:RXZonk^kP03onk^kP03oc8b<_m/K6cok^k^
00Cok^k^00Ko>c/kogIfM_o^k^kok^k^oc/k>omfMWH2onk^kP08oiRHV?lJ
6Q[ok^k^onk^k_lk>c_o=3@do`000?nf][H8onk^kP09oc/k>omfMWKok^k^
onk^k_oDe=CoADE5o`820_mYJFWoiNGU00Gok^k^00?o/K6ao`000?o0`<00
1?o^k^h00ona/K7o0000omKFeP02onk^kP06omCDe?l0003o];Bdok6a/Ol0
003oe]KF0_o^k^h01_oDe=Co0000okBd]?o^k^ko>c/kogIfMP;ok^k^00?o
Q8B4ofUYJOo^k^h0H?o^k^h001;oi^KV00Coh^;RoiFEUOo^k^kom_Kf2?oj
n_X01oohn?SoooooomKFe_m@D53o[:b/ooooooogmoL02?ojn_X01?ofm_Ko
k^k^oiFEUOoRh^8NonKViP03ogalO?lK6a_oi^KV00?oi^KV00?o7alOol[:
b_oVi^H00_oVi^H00ol`<33oJ6QXonKViP04onKViP06ocTi>OmbLW;oi^KV
onKVi_li>CWoDe=C0_oVi^H02On=SHgo6QXJonKVi_oVi^Ko>CTiog5aLOm=
CDgoB4Q8onCTi007onKViP07ocTi>OmbLW;oi^KVonKVi_lj>S[o>c/kolG5
a@07onKViP03olG5aOl0003oPX:200Coi^KV00?oa/K6o`000?nRXZ800_oV
i^H01_nPX:3o0000ol[:b_o6a/Ko0000oj:RXP;oi^KV00KoX:2Po`000?o:
b/[oi^KVocTi>OmbLW82onKViP03ogQhN?mNGUkoi^KV063oi^KV000Bonk^
kP04on[Zj_nHV9Sokno_ooOgm`Sono_k00OonOWiooooooo1`L7oC4a<oiRH
V?oooooonOWi00Sono_k00ComoOgono_konHV9Soj^[Z7_o^k^h00on0P83o
71`Lonk^kP03onk^kP03ofQXJ?n9RHWok^k^00;ok^k^00?o<S8bofa/K?o^
k^h01?o^k^h02_lk>c_oMWIfonk^k_o^k^ko>c/koa8B4_m^KVkoclo?oe5A
DOm7AdL2onk^kP05oc/k>omfMWKoinOWocPh>?mXJ6P01oo^k^h02Olk>c_o
MWIfonk^k_o^k^ko<c<cohb<S?o^k^kof=SHonWYj@06onk^kP05ocXj>_lT
92Co/K6aong]kOo?cll00_o^k^h01_ll?3co@d=3olo?coo>c/ko@T92oclo
?`;ok^k^00Ko?3`lod=3@oo?clooc/k>od92@_lo?cl2onk^kP06oc/k>omf
MWKok^k^onk^k_mdM7CoFUYJHOo^k^h001;ooooo00Coo?cloj^[Zoo[jn_o
nOWi2?olo?`01ooinOWooooooj^[Zom@D53oPh>3oooooookno/02?olo?`0
1?oinOWojn_[oj^[Zoolo?`Nooooo`03ohZ:R_lO7aoooooo00?ooooo00?o
_KfmodI6A_ooool00_ooool00olf=SKoM7Adooooo`04ooooo`0:oeADE?n=
SHgooooooooooomDE5CoS8b<ogUiNOlD51Co;Rh^olC4a0;ooooo00Ko@410
ogmoOoooooookNg]ocDe=OnYZJT6ooooo`09oeADE?n=SHgooooooooooono
_koo>SXjoa0@4?lC4a?oj>SX00Kooooo00Goj>SXoeMGEol?3`oo2`/;obHV
9P02ooooo`06onSXj?mBDU;o3`l?o`l?3omDE5CojNWY0_ooool01_oXj>So
DU9Bo`l?3ol?3`ooE5ADonWYj@;ooooo00Ko@410ogmoOoooooooooooogEe
MOmJFUYQooooo`004_o^k^h01?o]kNgo];Bdom?Cdoolo?`8oogmo@08oo_k
noooooooU9BDoeEEEOmcLg?om_Kfooooooolo?`7oogmo@04ooclo?oCdm?o
];Bdong]kAkok^k^00?oP820oa`L7?o^k^h00oo^k^h00ooYjNWo4a<Con;R
hP02onk^kP03oc8b<_m/K6cok^k^00_ok^k^00?okNg]onk^k_o^k^h00_o^
k^h00olk>c_oMWIfonk^kP0?onk^kP03on_[joo^k^kok^k^00Wok^k^00?o
jn_[onk^k_o^k^h00oo^k^h2ong]k@Kok^k^0_o]kNd4onk^kP06oc/k>omf
MWKok^k^onk^k_mVIVKoCDe=HOo^k^h001?oi^KV00Cob/[:oj:RX_oooooo
o?cl2?ono_h01oooooooP820oeaLG?mUIFGoj>SXooooooomoOd01_ono_h0
1?olo?cooooooj:RX_o:b/XOonKViP03ogalO?lK6a_oi^KV00Coi^KV00Ko
CDe=oibLW?oVi^Koi^KVoc0`<?mXJ6P5onKViP03oe9BD_n3Ph?oi^KV00Wo
i^KV00?o>CTiog9bL_oVi^H02OoVi^H00omBDU;oPh>3onKViP0SonKViP06
ocTi>OmbLW;oi^KVonKVi_mRHV;oBDU9HOoVi^H001?ok^k^00CoinOWoi^K
Voo^k^kon_[j1_ono_h02OomoOgoooooooCdm?m_KfooHV9RoeeMGOoEeMGo
ooooooclo006ooknoP04oo[jn_o^k^koVi^KonOWiaook^k^00?o`l?3oi^K
Voo^k^h01?o^k^h01_o4a<Co_;blonk^k_o^k^koY:BTokZj^PGok^k^00?o
Z:RXokno_oo^k^h02Oo^k^h00olk>c_oMWIfonk^kP09onk^kP03ojRXZ?no
_kook^k^02?ok^k^00Ko>c/kogIfM_o^k^kok^k^okRh^?n^[ZiQonk^kP00
5?ooool01?oJf][oZJVYoogmoOolo?`5ooooo`09ookno_ooooooiNGUof=S
HomVIVKoFEUIol30`?ooooooo?cl00Gooooo00Coo?cloogmoOnYZJWof][J
?_ooool00ookno_ooOgmooooo`0_ooooo`03oo_knoomoOgooooo06Cooooo
000Donk^kP05on[Zj_n_[jooa/K6ookno_olo?`01?ooool02OomoOgooooo
omkNg_mKFe_oJFUYoeEEEOne]KGoooooooclo004ooooo`05ooclo?ono_ko
a/K6ojn_[ooZj^X0eoo^k^h001Goi^KV00Kog=cLoinOWoo:b/[ooooooo_k
noono_h2ooooo`09ookno_oooooono_koh:2P_mFEUKoJ6QXon?Shooooooo
o_kn00;ooooo00Koo_knoo_knooooooob/[:oinOWooLg=cHonKViP005_o^
k^h01ooShn?oZZZZojj^[_ogmoOooOgmoo_knoomoOd00oooool00ooemOGo
dM7Aon[ZjP03ooooo`07oogmoOokno_ooOgmooOgmon^[ZkoZZZZon?Sh`3I
onk^kP005oooool05OoinOWoclo?oinOWoo=cLgonOWiooooooomoOgono_k
oo[jn_olo?cooooooogmoOojn_[ono_koogmoOoooooonOWiolg=cOnOWioo
clo?ooWin@3Jooooo`006?o^k^h02?o]kNgogmoOokFe]OnGUiOo[Zj^om[J
f_oalO7on_[j0oolo?`02?ojn_[olO7aom[Jf_n^[ZkoUiNGokFe]OoOgmoo
kNg]foo^k^h001[oi^KV00KoiNGUomcLg?o6a/KoZZZZoiRHV?nCTi<3oi6A
T@06oi>CTonHV9SoZZZZolK6a_oLg=coiNGUgOoVi^H001gok^k^00WokNg]
on[Zj_oVi^Kohn?Son;Rh_oShn?oi^KVon[Zj_o]kNd0h?o^k^h00?oooooo
1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H00?ook^k^1oo^k^h00?oo
oooo1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H00?ook^k^1oo^k^h0
0?oooooo1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H00?ook^k^1oo^
k^h00?oooooo1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H00?ook^k^
1oo^k^h00?oooooo1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H008ko
Ogmo1omnOWiaogmoO`0000Cojn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP0K
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oMgMgog=cL00;ogMgM017og]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNgP02omgMg@1BomcLgOoMgMgogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNgP;og=cL00GofMWIomSHf?oGemOo
f=SHomWIfP02omcLg01TomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMg@?og]kN00?ogMgMomkNg_oNg]h00ooMgMd1on7Qh@7oinOW
0OoZj^X00003onc/k?oVi^Koh>3P00OofMWI00Cof=SHomKFe_oCdm?od=3@
0oo=cLd01?o@d=3odm?ComOGeooHf=P<omWIf@09omSHf?oGemOoeMGEomCD
e?oCdm?oe=CDomGEeOoGemOof=SH00gofMWI00Wof=SHomOGeooEeMGoe=CD
om?CdooDe=CoeMGEomOGeooHf=P0=OoIfMT3omSHf0?ofMWI0_oHf=P5omWI
f@;of=SH1OoIfMT00ooHf=SofMWIomSHf002omSHf003omGEeOoBd];oc/k>
00;ocLg=00Cod=3@omCDe?oGemOof=SH0_oIfMT2omSHf5oofMWI00?of=SH
omWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWoi>CT
on3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=codm?ColO7aonk^k_o
/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=on3Ph?oO
gmoofm_KomKFe_oBd];oc/k>olc<c?o>c/kod];BomKFe_oKfm_ogmoOon3P
h009on7Qh@0=on3Ph?oOgmoofm_KomKFe_oBd];oc/k>olc<c?o>c/kod];B
omKFe_oKfm_ogmoOon3Ph00Ton7Qh@[oh>3P00GogmoOon3Ph?oPh>3oh>3P
omoOg`02omkNgP;ogmoO00Goh>3PomoOgooOgmoog]kNomoOg`03on3Ph004
omoOgooNg]kog]kNomoOg`?oh>3P00?ogmoOomkNg_oOgml00ooOgml01?oM
gMgofMWIomGEeOoCdm<2om;BdP05omOGeooMgMgoh>3Pon3Ph?oOgml00_oN
g]h00ooOgmooh>3Pon3Ph01Non7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoT
i>@1onWYj@7okNg]00000oo`l?3okno_oo7al@03oo3`l00Hono_koo`l?3o
k^k^onWYjOoKfm_o`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2
`/7of][Jon[Zj_o]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7a0_o^
k^h05?oVi^Kog]kNom7AdOo9bLOo`L71okno_oo1`L7obLW9om7AdOoNg]ko
i^KVonk^k?o^k^kolO7aono_kooalO7okno_oo7alOo_knoolO7_0_o^k^h0
2ooVi^Kog]kNom7AdOo9bLWo`L71okno__o1`L7obLW9om7AdOoNg]koi^KV
00;ok^k^02?olO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7al@02onk^kP06on[Zj_o]kNgok>c/onk^k?o[jn_ok^k^
0_o/k>`01?oYjNWok^k^ong]kOo^k^`2onSXj00?onGUiOoYjNWoj^[Zong]
kOoZj^[ojNWWonKVi_oYjNWoj^[Zonk^k_o/k>cojn_[onKVi_oXj>Koj>SX
00?okNg]07[oinOWonSXj?oVi^KojNWWonOWioo[jn_oj^[ZojBTY?mcLg?o
FEUIog1`L?o1`L3oh>3Pon[Zj_o/k>cokNg]onSXj?oWinOoi^KVon[Zj?o[
jn_okno_onk^k_oalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7ol?3`ono_koo`l?3okno_oo3`l?o_knool?3`ono_
k`Col?3`00000oobl_;ok^k^onOWi`04onGUi@0@onCTi?oOgmoodM7Aok6a
/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:ROna/K7odM7A
omkNgP;oi>CT00_oiNGUonCTi?oUiNCoi>CTonGUiOoRh^;og=cLolo?coo1
`L7o/K6aojVYZ003ojBTY01=ojVYZOna/K7o`L71olo?cooLg=_oh^;RonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oRh^;og=cLolo?coo1`L7o/K6a
ojVYZOnTY:CoY:BSojBTY?nYZJWo/K6aol71`Oo?cloog=cLon;Rh_oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
on;Rh_oOgmoof][JomcLg?oMgMgogMgLom[Jf_oMgMgog]kNomcLg?oHf=So
gMgMomoOgooLg=/00ooFe]H04OoJf][og=cLomoOgooKfm_ofMWHomGEeOoG
emOof][JomoOgooNg]kofm_KomKFe_oFe]GoemOGomcLg?oNg]kog=cL00?o
eMGE00goeMGDomGEeOoLg=cog=cLofIVI_m/K6coRh^;od];Bol820So];Bd
omcLg?oNg]kog=cL00?oe]KF063of][IomkNg_oShn?ohn?SonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>@4
onGUi@06onCTi?oUiNGoiNGUonGUiOoXj>SokNg]0Oobl_800003ooCdm?o]
kNgoinOW00;oh>3P01?ohN7QomoOgooNg]kod];BokBd]?n7QhOoG5aLofdk
=OnNCT;ocFmOonV3Koo=KeooWTi3ofdk=_mLG5coQhN7okBd]?oBd];og]kN
00Goh>3P017ogmoOom[Jf_o>c/ko_;bloj^[Zon`/;3oalO7omWIfOoTi>Co
fMWIolO7aona/K7oZj^[okbl_?o>c/kof][JomoOg`05on3Ph00AomoOgooJ
f][oc/k>okbl_?n[Zj_o/;2`olO7aooIfMWoi>CTomWIfOo7alOo/K6aoj^[
Zonl_;coc/k>om[Jf_oOgml08_oPh>00>OoNg]kof=SHom;Bd_oDe=Coe]KF
om;Bd_o?clood];BomKFe_oCdm?odM7AomKFe_oHf=Sod];Bolo?coo<c<co
_[jnomOGeooJf][ofm_KomWIfOoEeMGo`<30om3@d?oAdM7of=SHom_KfooH
f=Soc<c<olG5aOo@d=3odm?ComOGeooCdm?oclo?okno_ooAdM7ocLg=ol30
`?oCdm?oe]KFom7AdOo@d=3odM7Aom3@d?la<C7oEeMGomKFe_oGemOodM7A
olo?coo8b<So`/;2omSHf?oKfm_og]kNomoOg`1Kon3Ph003omoOgooPh>3o
gmoO00;ogmoO0ooPh>000ooQhN7oinOWonc/k001ooCdm00000?om_Kfoo;b
l_o[jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWiooJemOohlf;_o]LF7onIf@
oofaYOom_:oooKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;Rh_oWinL0
1?oXj>P01ooVi^KogMgMol[:b_ne]KGo_knoonOWioo_knl00oo`l?001oo_
knoojNWYol71`One]KGob/[:omgMgOoVi^H01OoXj>P01ooVi^KogMgMol[:
b_ne]KGo_knoonOWioo_knl00oo`l?001oo_knoojNWYol71`One]KGob/[:
omgMgOoVi^H08_oXj>P02ooVi^KogmoOoc0`<?n?Shoofm_KolO7aon8R8So
aLG5om_KfonUYJGo0@4100;ogMgM02coclo?oeaLG?l410Co71`Loa8B4_n6
QXKoi>CTog]kNol;2`_o820Pob@T9?nJVY[oh>3PonCTi?l^;Rko30`<oadM
7Olm?CgocLg=omkNg_no_koo8b<So`T92Ol_;booNWYjo`H61_n<S8cog=cL
okRh^?m8B4So=CDeogYjN_m`L73o>3PhomgMgOoKfm_o`<30ochn?_l20P;o
7alOoaDE5On`/;3oi^KVonOWifCoj>SX0Oo/k>`1oo;blP7om_Kf00000oog
moOon?ShooShn003ooShn00CooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFoo^B
QoonYY_oo[6UoonhZoon/jKooZRLoo^DROo^J5WoRC4[oi2@T?o>c/kok^k^
ooOgm`04ooShn006ooCdm?oWinOoclo?olK6a_oZj^[om?Cd0_oinOT02Ooj
n_[onOWiooWinOofm_Kojn_[olO7aoo?clooinOWooCdm005ooShn006ooCd
m?oWinOoclo?olK6a_oZj^[om?Cd0_oinOT02Oojn_[onOWiooWinOofm_Ko
jn_[olO7aoo?clooinOWooCdm00RooShn00iooKfm_o_knoo<c<coiVIVOoW
inOoPh>3o`000?mlO7coj>SXok2`/?l10@7ok>c/on_[jom^KVko7AdMokbl
_?oWinOohn?SomcLg?obl_;ob<S8omGEeOoVi^KoVIVIob8R8_oalO7olo?c
okJf]_oShn?oi^KVod=3@omjNW[ol_;bog5aLOlc<c?ohn?SokRh^?lW9bOo
FEUIonc/k?oYjNWo:b/[oc/k>onOWiooIfMWobHV9_la<C7ojn_[onWYjOlk
>c_o@410olc<c?oWinOog]kNon?ShooemOGomoOg05gon?Sh00?omoOgooSh
n?ohn?P00_ohn?P01?ogmoOonOWiooOgmoogmoL1ooShn00000?on_[jooGe
mOo^k^h00_o/k>`08Oo[jn_ojNWYomoOgonj^[[oNE9Boklb9?oWM6WooHUn
oonHS?onXYKoojRLoojTV?ooVXgooXYoonifJ_o3<bCoNE9BokZj^_oOgmoo
j^[Zon_[joo/k>cojn_/on_[jooVi^Kof=SHok^k^ooDe=Coi>CTon_[jooa
lO7ol_;boo?cl`02oo;blP06ong]kOoUiNGoeMGEok^k^ooHf=Soi^KV0_o[
jn/03?o/k>cojn_[on_[jooVi^Oof=SHok^k^ooDe=Coi>CTon_[jooalO7o
l_;boo?cl`;ol_;b00KokNg]onGUiOoEeMGo^k^komSHf?oVi^L2on_[j`1;
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_oj^[Zon;R
h_la<C7oT92@omWIfOl];Bgo@410ob<S8ooKfm_oYJFUo`410OoOgmooh>3P
o`h>3_mdM7Cof][Jom_KfooIfMWoh>3Pon?ShooPh>3of][Kom3@d?mBDU;o
820PonSXj?oUiNGogMgMom[Jf_nd];Co71`LogIfM_oYjNWoPH61oaPH6?oC
dm?ogMgModM7AomSHf?oh>3Pol?3`ol0003o_[jn00;ohn?S00_oJFUYobd]
;OoOgmoo_Kfmo`000?nTY:Cofm_Kom[Jf_oJf]_oh^;RonSXj002on_[j`1I
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>`01oo[
jn/01Oo/k>cojn_[on_[joo^k^kom_Kf007onOWi00000ookno_olo?cong]
k@02onGUi@0OonKVi_oTi>CofMWIok:b/_mi;Rkob48don=ZG?odNVgooHQl
oojGR_onVhkooYR;ooj:O_odNfgoif]MolY2=?mk;Rko/[:bomSHf?oTi>Co
iNGUonKVi_oUiNKoiNGUomoOgooAdM7o][JfomCDe?oMgMgoi>CTonKVi`03
onc/k007onSXj?oTi>CogmoOomGEeOnf][OodM7AomoOg`02onGUi@0DonKV
i_oUiNGoiNGUomoOh?oAdM7o][JfomCDe?oMgMgoi>CTonKVi_o/k>cok>c]
onc/k?oXj>Soi>CTomoOgooEeMGo][Jfom7AdOoOgn02onGUi@0_onKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi>CTomcLg?l_;boo
Rh^;ok:b/_l0003o^;RhobDU9OnYZJWoWinOo`410OoJf][od=3@o`000?l[
:b/00olg=cL06On:RX[og]kNom[Jf_mnOWko30`<obPX:?nc/k?ohN7QomoO
goo7alOoBTY:o`410OmJFU[oe=CDonCTi?oNg]koJf][ob0P8?lj>S[o61PH
of5QHOoNg]koSXj>o`L71ooFe]H00_oHf=P01_mhN7So;2`/omcLg?nPX:3o
0000ocHf=P?o=cLg05ko[jn_on?ShooUiNGoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU0_oVi^H00ooUiNGoi^KV
onKViP03onKViP03onGUiOo]kNgom?Cd007ono_k00000oolo?con?Shoo7a
l@03onk^kP0Con_[jooQhN7o_;blogXG5oo3?c;odeI9onAXF_o_Mfcom8=i
ooR7O?oeQ7[olgU]onEYFooIF4[oa3lbog`G5onl_;cohN7Qonc/k003onk^
kP08ong]kOoYjNWof][JokVi^OoGemOog]kNon?ShooVi^H3on[ZjP08onSX
j?oTi>Cog]kNomSHf?ni^KWof][JonWYjOo]kNd3onk^kP08ong]kOoYjNWo
f][JokVi^OoGemOog]kNon?ShooVi^H3on[ZjP08onSXj?oTi>Cog]kNomSH
f?ni^KWof][JonWYjOo]kNdQonk^kP0?onc/k?oUiNGo<C4aohn?Som^KVko
;2`/onSXj?mmOGgoGUiNojBTY?l10@7ohn?SonWYjOl=3@goMGEe00;o][Jf
01[o8B4Qoj>SXooZj^[oXJ6Qo`/;2onCTi?og]kNonKVi_oZj^[ojNWYod];
Bolc<c?o^k^kon;Rh_oXj>Sojn_[onWYjOoTi>Coh>3PomWIfOm3@d?oIFEU
on[Zj_nYZJWo0000okbl_0;ogmoO00_oOGemobh^;_oWinOoa<C4o`000?nL
W9co][Jfojf][Ol10@7oe]KFong]k@1Tonk^kP03ong]kOobl_;on?Sh007o
o?cl0003oogmo@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Co
aclcom9@@ooJHUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooB
d];olo?cooclo0CooOgm00OonOWionc/k?nh^;Sofm_Kon7QhOoUiNGojNWY
00;ok>c/00SokNg]on[Zj_oUiNGoh^;Rom_Kfoni^KWok>c/ooWin@GooOgm
00OonOWionc/k?nh^;Sofm_Kon7QhOoUiNGojNWY00;ok>c/00SokNg]on[Z
j_oUiNGoh^;Rom_Kfoni^KWok>c/ooWinB;ooOgm01Wono_kooCdm?ld=3Co
UiNGoalO7on7QhOon_[jomgMgOlC4a?oZJVYo`410Oobl_;on_[jofm_Kom1
@D7ohn?SolG5aOl71`Ookno_oo_knonTY:Co:b/[ono_koo^k^kohn?S00;o
no_k01goATI6oh61POoemOGohn?Soo7alOokno_olo?coj>SXooShn?oinOW
oadM7OnOWioono_kooGemOlP823oFe]Kon;Rh_oMgMgo?Shnoc0`<?ojn_[o
no_kocTi>Om/K6cok^k^oiBDU?l_;boono_kooclo01Roogmo@03ooclo?om
oOgoo?cl00?ooOgm0000K?omoOgon_[joo?cloo^k^kol?3`ono_koo^k^ko
jNWYom?CdomK7AgoXS@dok@X7Oo1>RgoadTlolmFB_o@Ed_od5M:olY:?_o3
>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>ookno_onk^
k_oShn?o[:b/ol[:b_oBd];oemOGom[JfOoMgMgog]kNomgMgOoLg=coemOG
omCDe?o:b/[o[:b[on?Shoo^k^kokno_oo3`l?o_knool?3`ono_koo^k^go
hn?Sojb/[?o:b/[od];BomOGeooJf][ogMgMomkNgOoMgMgog=cLomOGeooD
e=Cob/[:ojb/[?oShn?ok^k]ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o]kNgoj>SXoc4a<OmPH63o0@41om?CdP;o
kNg]08go@410of5QHOl10@7oinOWong]kOoVi^GoG5aLoa0@4?l?3`ooQXJ6
onk^k_o_knooj^[ZoeQHEolI6AWo2`/;ogYjN_o_knook^k^okfm_Olj>S[o
410@o`l?3oo;bl_ok^k^onSXj?mCDe?o8B4Qoa0@4?m;Bd_oh>3Pono_koo^
k^koa/K6oc8b<_l;2`_o;bl_ofATHom2@T;okno_onk^k_oEeMGo?cloo`/;
2olL71co[jn^onk^k_o`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knl00_o`l?06ono_k`7olo?c
0OoinOT1ooknoP0000?oo_knooOgmoo`l?001?oYjNT04OoWinOofm_Kof=;
Bon1<S;oYSDeokHd;Oo2CD7o`eA9olAEB_o3E4Wo`Te1okHd;OnU=CGoPC8b
of=;BooKfm_oinOW00GojNWY00Koj>SXon?Shon[Zj_o^KViolW9bOo?cll2
omGEe@09omKFe_oEeMGoe=CDolo?coo8b<So^KVioj^[ZooShn?oj>SX00Go
jNWY00Koj>SXon?Shon[Zj_o^KViolW9bOo?cll2omGEe@09omKFe_oEeMGo
e=CDolo?coo8b<So^KVioj^[ZooShn?oj>SX02;ojNWY00goj>SXonCTi?l`
<33o4Q8Boc`l??oVi^Koj>SXonOWionCTi?o4A4Ao`410OoShn?oinOW00;o
jNWY00?oinOWonWYjOoYjNT01?oYjNT00ooWinOoj>SXonWYj@04onWYj@03
onKVi_oYjNWojNWY00CojNWY00?oinOWonWYjOoYjNT01?oYjNT00ooWinOo
jNWYonWYj@05onWYj@03onKVi_oYjNWojNWY063ojNWY00?oj>SXonWYjOoY
jNT01?oYjNT1oo3`l07omoOg0Oono_h00005ookno_ojn_[om?Cdono_kooa
lO400_o`l?004Oo_knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZN
W?oIW9coe9FEok]cLonEE5CoCb<SoiFDU?oZj^[okno_00Kol?3`00Kok^k^
ol_;bonWYjOob<S8omSHf?oShn<3onKViP06on?ShooHf=Sob<S8ojNWYoo;
bl_ok^k^1oo`l?001_o^k^kobl_;ojNWYoo8b<Sof=SHon?Sh`?oi^KV00Ko
hn?SomSHf?o8b<SoYjNWol_;boo^k^hSoo3`l005ono_koo^k^ko<S8bo`00
0?nCTi<00oo_knl01OoTi>Co2`/;o`410Oo^k^kokno_08kol?3`00ColO7a
oo3`l?odm?Con_[j0Oono_h00004ookno_ooooooooooooknoP;ooooo0_on
o_h0G_omoOgon?Shofi^K_mJ?coo/I2@omk9bOo`i>ColnKVoo3Ti?oNbLWo
/I2@oeXo?om]KFgon?Shooclo?ooooooo_knooooooono_koooonookno_oo
oooooOgmooclo?o5aLGo^[ZjomgMgOoalO3on?ShooWinOohn?SolO7aomgM
gOnj^[[oaLG5ooclnoomoOgoooooookno_ooooooo_knooooooono_koooon
oogmoOolo?coaLG5okZj^_oMgMgolO7aooShn?oinOSon?Shoo7alOoMgMgo
^[ZjolG5aOolo?cooOgmooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooool2ooknoP09ojj^[_nIVIWol?3`ooknoOon
o_kooooooogmoOne]KGoVIVI00;oo_kn08[oooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooooono_h2ooooo`03
ookno_oooooooooo00?ooooo0Oono_h00004ooOgmoono_kon_[jooCdm0Go
lO7a00gokno_omKFe_m[Jf_o@cdmoi^<S?o6^[[oe/c<olNj^_nKS8co@cdm
of][JooFe]Kokno_00WolO7a00gol?3`onKVi_nm_Kgo/;2`olo?cooOgmoo
iNGUomoOgoo?cloo/;2`okfm_OoVi^Kol?3`00WolO7a00gol?3`onKVi_nm
_Kgo/;2`olo?cooOgmooiNGUomoOgoo?cloo/;2`okfm_OoVi^Kol?3`0;So
lO7a00Col?3`oo7alOoalO7ol?3`1?oalO400oodm?Con_[jooknoP01ooOg
m`0000Gok>c/oogmoOohn?Sol?3`on_[j`03on[ZjP0=onWYjOoZj^[ojNWY
onSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0<on[Z
jP09onWYjOo:b/[o/K6aoifMWOnBTY;oWIfMok6a/Oo:b/[ojNWY00goj^[Z
00WojNWYol[:b_na/K7oWIfMoi:BT_nMWIgo/K6aol[:b_oYjNT0`OoZj^X0
1?o[jn_ol?3`ooShn?omoOd1on_[j`0000Coa/K6oogmoOojn_[om?Cd2?oa
lO42oo3`l0?okno_0_o`l?0Aoo7al@?ol?3`4ooalO43oo3`l<3olO7a00?o
l?3`oo7alOoalO400_oalO400ooemOGon_[joogmo@01olK6aP0000?oa/K6
ol?3`ooinOT0ooooool1ooooo`7onOWi0Oo4a<@1olK6aP0000Kofm_Kokno
_one]KGoinOWooOgmoomoOgjooooo`05oogmoOogmoOoinOWokFe]Ono_kl0
0OoKfm/00001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{262, 140},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    \( (*\ Message\ *) \)], "Input"],

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]ShowMessageDialog[
        frame, \[IndentingNewLine]JavaNew["\<java.lang.String\>", "\<J/Link \
is cool!\>"], \[IndentingNewLine]{JavaNew["\<java.lang.String\>", "\<I \
know:-)\>"]}]\[IndentingNewLine]]\)], "Input"],

Cell["Yes No", "Text"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004<0000LaP00`40o`00
0?l0003oo`0000d000000003R<2hB928B9280?m8T8P9B9280@00000000>8
`;S8h=R8`;P0ohS0^0R8`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<
c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1
000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8
h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7
c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B928
0@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2h
b>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<
1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0
^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<
c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04K<c<`joooo1lc<c3_o
oom4c<c<0HS0^058T8P1000000000hS0^<SPf8S0^014c<c<0VIVIP03c<c<
IVIVIVIV03IVIVH00oooolc<c<c<c004c<c<00=VIVK<c<aVIVH0>6IVIP03
ooooc<c<c<c<04;<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04C<c<`k
IVIV00?oooo<c<c<c<`01<c<c003IVIVooooc<c<03O<c<`00fIVI_ooolc<
c013c<c<0HS0^058T8P1000000000hS0^<SPf8S0^014c<c<0VIVIP03oooo
c<c<c<c<03C<c<`2IVIV00?oooo<c<c<c<`01<c<c003IVIVooooc<c<03O<
c<`00fIVI_ooolc<c013c<c<0HS0^058T8P1000000000hS0^<SPf8S0^014
c<c<0VIVIP03ooooc<c<c<c<00c<c<`KVIW<3Lc<c09VIVH00oooolc<c<c<
c004c<c<00=VIVKoooo<c<`0=lc<c003IVIVooooc<c<04?<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h04C<c<`2IVIV00?oooo<c<c<c<`03<c<c003
VIW<c<c<c<c<01O<c<`00iVIc<c<c<c<c00;c<c<0VIVIP03ooooc<c<c<c<
00C<c<`00fIVI_ooolc<c00gc<c<00=VIVKoooo<c<`0@lc<c068`;P1B928
0@00000000>8`;S8h=R8`;P0A<c<c09VIVH00oooolc<c<c<c00<c<c<00>I
VLc<c<c<c<`05lc<c003VIW<c<c<c<c<00_<c<`2IVIV00?oooo<c<c<c<`0
1<c<c003IVIVooooc<c<03O<c<`00fIVI_ooolc<c013c<c<0HS0^058T8P1
000000000hS0^<SPf8S0^014c<c<0VIVIP03ooooc<c<c<c<00c<c<`00iVI
c<c<c<c<c004c<c<00<0003<c<c<c<`04<c<c003VIW<c<c<c<c<00_<c<`2
IVIV00?oooo<c<c<c<`01<c<c003IVIVooooc<c<02;<c<`200004lc<c003
IVIVooooc<c<04?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04C<c<`2
IVIV00?oooo<c<c<c<`03<c<c003VIW<c<c<0000008000000lc<c0000000
0002000000?<c<`0000000000lc<c0@00006c<c<00>IVLc<c<c<c<`02lc<
c09VIVH00oooolc<c<c<c004c<c<00=VIVKoooo<c<`02/c<c0@00009c<c<
100000S<c<`200000lc<c0D0000:c<c<00=VIVKoooo<c<`0@lc<c068`;P1
B9280@00000000>8`;S8h=R8`;P0A<c<c09VIVH00oooolc<c<c<c00<c<c<
00FIVLc<c<`00000003<c<`00P0000;<c<`400000lc<c0D00005c<c<00>I
VLc<c<c<c<`02lc<c09VIVH00oooolc<c<c<c004c<c<00=VIVKoooo<c<`0
2/c<c0D00008c<c<1@0000S<c<`2000000?<c<`0000000003/c<c003IVIV
ooooc<c<04?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04C<c<`2IVIV
00?oooo<c<c<c<`03<c<c004VIW<c<c<000000000/c<c0D00005c<c<0P00
0003c<c<0000000000?<c<`2000000>IVLc<c<c<c<`02lc<c09VIVH00ooo
olc<c<c<c004c<c<00=VIVKoooo<c<`02/c<c08000000lc<c00000000003
c<c<0P0000?<c<`2000000?<c<`0000000000lc<c0800004c<c<100000k<
c<`00fIVI_ooolc<c013c<c<0HS0^058T8P1000000000hS0^<SPf8S0^014
c<c<0VIVIP03ooooc<c<c<c<00c<c<`019VIc<c<c000000000G<c<`20000
1Lc<c0<00005c<c<0P000003VIW<c<c<c<c<00_<c<`2IVIV00?oooo<c<c<
c<`01<c<c003IVIVooooc<c<00[<c<`300001Lc<c0800003c<c<0`0000G<
c<`200001Lc<c0<0000>c<c<00=VIVKoooo<c<`0@lc<c068`;P1B9280@00
000000>8`;S8h=R8`;P0A<c<c09VIVH00oooolc<c<c<c00<c<c<00BIVLc<
c<`000000005c<c<0P0000G<c<`200001Lc<c0<000000iVIc<c<c<c<c00;
c<c<0VIVIP03ooooc<c<c<c<00C<c<`00fIVI_ooolc<c00:c<c<0P0000G<
c<`300000lc<c0800005c<c<0`0000K<c<`200003/c<c003IVIVooooc<c<
04?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04C<c<`2IVIV00?oooo<
c<c<c<`03<c<c004VIW<c<c<000000001Lc<c0800005c<c<0P0000G<c<`2
000000?<c<bIVLc<c<`03<c<c09VIVH00oooolc<c<c<c004c<c<00=VIVKo
ooo<c<`02/c<c0800005c<c<0P0000C<c<`200001Lc<c0800003c<c<2000
00c<c<`00fIVI_ooolc<c013c<c<0HS0^058T8P1000000000hS0^<SPf8S0
^014c<c<0VIVIP03ooooc<c<c<c<00c<c<`00iVIc<c<c<c<c00:00000lc<
c0800004c<c<0`000003c<c<VIW<c<c<00c<c<`2IVIV00?oooo<c<c<c<`0
1<c<c003IVIVooooc<c<00[<c<`200001<c<c0<00004c<c<0P0000C<c<`3
00002<c<c080000=c<c<00=VIVKoooo<c<`0@lc<c068`;P1B9280@000000
00>8`;S8h=R8`;P0A<c<c09VIVH00oooolc<c<c<c00<c<c<00>IVLc<c<c<
c<`00P0000C<c<`00`000<c<c<c<c004c<c<0P0000C<c<`200000/c<c003
VIW<c<c<c<c<00_<c<`2IVIV00?oooo<c<c<c<`01<c<c003IVIVooooc<c<
00[<c<`200001<c<c0800005c<c<0P0000C<c<`200001Lc<c0030000c<c<
c<c<013<c<`00fIVI_ooolc<c013c<c<0HS0^058T8P1000000000hS0^<SP
f8S0^014c<c<0VIVIP03ooooc<c<c<c<00c<c<`00iVIc<c<c<c<c0020000
0lc<c0<00005c<c<00<0003<c<c<c<`01lc<c003VIW<c<c<c<c<00_<c<`2
IVIV00?oooo<c<c<c<`01<c<c003IVIVooooc<c<00[<c<`00`000<c<c<c<
c00:c<c<00<0003<c<c<c<`02lc<c0D0000=c<c<00=VIVKoooo<c<`0@lc<
c068`;P1B9280@00000000>8`;S8h=R8`;P0A<c<c09VIVH00oooolc<c<c<
c00<c<c<00>IVLc<c<c<c<`05lc<c003VIW<c<c<c<c<00_<c<`2IVIV00?o
ooo<c<c<c<`01<c<c003IVIVooooc<c<03O<c<`00fIVI_ooolc<c013c<c<
0HS0^058T8P1000000000hS0^<SPf8S0^014c<c<0VIVIP03ooooc<c<c<c<
00c<c<`00iVIc<c<c<c<c00Gc<c<00>IVLc<c<c<c<`02lc<c09VIVH00ooo
olc<c<c<c004c<c<00=VIVKoooo<c<`0=lc<c003IVIVooooc<c<04?<c<`1
R<2h0DR@R04000000003R<2hb>3HR<2h04C<c<`2IVIV00?oooo<c<c<c<`0
3<c<c003VIW<c<c<c<c<01O<c<`00iVIc<c<c<c<c00;c<c<0VIVIP03oooo
c<c<c<c<00C<c<`00fIVI_ooolc<c00gc<c<00=VIVKoooo<c<`0@lc<c068
`;P1B9280@00000000>8`;S8h=R8`;P0A<c<c09VIVH00oooolc<c<c<c00<
c<c<00>IVLc<c<c<c<`05lc<c003VIW<c<c<c<c<00_<c<`2IVIV00?oooo<
c<c<c<`01<c<c003IVIVooooc<c<03O<c<`00fIVI_ooolc<c013c<c<0HS0
^058T8P1000000000hS0^<SPf8S0^014c<c<0VIVIP03ooooc<c<c<c<00c<
c<`KVIW<3Lc<c09VIVH00oooolc<c<c<c004c<c<00=VIVKoooo<c<`0=lc<
c003IVIVooooc<c<04?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04C<
c<`2IVIV00?oooo<c<c<c<`0=<c<c09VIVH00oooolc<c<c<c004c<c<00=V
IVKoooo<c<`0=lc<c003IVIVooooc<c<04?<c<`1R<2h0DR@R04000000003
R<2hb>3HR<2h04C<c<`2IVIV=oooo`03IVIVc<c<oooo00K<c<`00fIVI_oo
olc<c00gc<c<00=VIVKoooo<c<`0@lc<c068`;P1B9280@00000000>8`;S8
h=R8`;P0A<c<c3]VIVH7c<c<00=VIVKoooooool0=oooo`03c<c<ooooc<c<
04?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04C<c<`kIVIV1lc<c3]V
IVI5c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1
B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003
R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03o
c<c<1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P100000000
0hS0^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0
olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0
^058T8P1000000000hS0^<SPf8S0^00=c<c<01Z7ZhNG`YN7ZhNKb9]oZgnG
`YMmYgfE_iEgWgN?]hmbUg6;[hY_U6n5YhE]Sff5YhEWQfMmYgeWQfN5YhEW
QfMmYgeWQfMmYgeWQfMmYggOc<c<0HS0^058T8P1000000000hS0^<SPf8S0
^00<c<c<01aoZh2Kb9^7ZhNKb9]oZgnKb9]oZgnG`YMmYgfE_iEgWgN?]hmb
Ug6?]hm_UG25YhE]Sff5YhEWQfMmYgeWQfMmYgeWQfN5YhEWQfN5YhEWQfMm
YggNc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<01bKai]oZgnK
b9]oZgnKb9^7ZhNKb9]oZgnG`YMmYgfE_iEgWgN?]hmbUg6;[hY_UG27ZhM]
SfemYgeWQfN5YhEWQfMmYgeWQfMmYgeWQfMmYge]SfgNc<c<0HS0^058T8P1
000000000hS0^<SPf8S0^00<c<c<00f7ZhNG`YN7ZhNKb9^7ZhNG`YMoZgnK
b9]oZgnG`YMmYgfE_iEgWgL00lc<c00<KiA_Qj^7KHm]QJN5IhMWOJMmIhMW
OJMmIhMWQJN5IhMWOJMmg/c<c068`;P1B9280@00000000>8`;S8h=R8`;P0
3<c<c00<VlRKOj]oVlRKOj]oVlRKQj^7VlRKOj]oVlRKOj]oVlNKOJMm100c
000<c<c<KiA_Qj^7KHm]QJN5IhMWQJN5IhMWOj^0IhMWOJMmIhMWg/c<c068
`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00LQj^7VlRKOj]oVlRKOj^0
Ul:GQj^7VlRKQj^7VlRKP:]o03<0c<c<UKnEOJMmSkN?03<0c<c<KiA_Qj^7
KHm]Oj^0IhMWOj^0IhMWQJN5IhMWQJN5g/c<c068`;P1B9280@00000000>8
`;S8h=R8`;P03<c<c00LVlRKOj]oVlRKQj^7Ul:GQj^7VlRKOj]oVlRKOj]o
VlRK03<0c<c<OJMmUKnEN:1g03<0c<c<Rjn:KiE`Qj^7KHm]QJN5IhMWOJMm
IhMWOJMmIhMWg/c<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00<
Qj^7VlRKOj]oVlRKP:]oVlRKOj^0VlRKQj^7VlRKQj^703<01<c<c00<03<0
SkN?MimgRjn:KiE`QJN5KHm]QJN5IhMWOJMmIhMWQJN5g/c<c068`;P1B928
0@00000000>8`;S8h=R8`;P03<c<c00<Ul:GQj^7VlRKOj]oVlRKOj]oVlRK
Oj]oVlRKP:]oVlRKQj^7100c000<UKnEMimgSkN?LYMaSkN?KiA_Qj^7KHm]
QJN5IhMWOJMmIhMWg/c<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<
c00LQj^7VlRKOj]oVlRKQj^7Ul:GQj^7Ul:GQj^7VlRKOj]oVlRKQj^7VlRK
Qj^7Ul:GOJMmUKnEMimgSkN?LYMaSkN?KiA_QJN5KHm]QJN5IhMWQJN59lc<
c0<0002dc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<00fKai]o
ZgnKb9^7ZhNKb9]oZh2Kb9]oZgnKb9^0ZgnKb9^7ZhNKb9/00lc<c00<VlNK
OJMmUKnEMimgSkN?MimgRjn:LYMaQj^7KHm]QJN5IhMW:Lc<c080002cc<c<
0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<00aoZgnKai^7ZhNG`YQo
ZgnKb9]oZgnKb9]oZgnKb9]oZgnKb9/403<000c<c<bKai]mYgfE_iEmYgf?
]hmbUg6;[hYbUg67ZhM]Sff5YhDAc<c<0P0000?<c<`2000000?<c<`00000
00001<c<c0@00006c<c<0`0000?<c<`400000lc<c08000000lc<c0000000
0005c<c<100000?<c<`500000/c<c08000000lc<c00000000002c<c<1000
00;<c<`200000/c<c0800002c<c<100000?<c<`2000000?<c<`000000000
0lc<c080001Zc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<01bE
_iEoZgnG`YN7ZhNKb9^7ZhNG`YN7ZhNG`YN7ZhNG`YL0<`3<c<b7ZhNG`YN7
ZhL0<`3<c<bKai]mYgfE_iEgWgN?]hmgWgN;[hY_UG27ZhM]SfdAc<c<0P00
00?<c<`2000000?<c<`0000000000lc<c0800002c<c<0P0000G<c<`30000
0/c<c0800002c<c<0P000004c<c<00000000c<c<0`0000C<c<`200000/c<
c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`20000
00?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P000003c<c<
0000000000;<c<`2000000C<c<`00000003<c<`300000lc<c080001Zc<c<
0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<01amYgfE_iEmYgfKai]o
ZgnKb9^7ZhNKb9]oZh2G`YN7ZhL0<`3<c<bG`YR7ZhNG`YR7ZhL0<`3<c<bG
`YMmYgfE_iEmYgf?]hmgWgN;[hYbUg67ZhLAc<c<1`000003c<c<00000000
00?<c<`200002<c<c08000001<c<c00000000<c<c0800002c<c<0P000003
c<c<0000000000;<c<`200001lc<c0<000000lc<c00000000002c<c<0P00
0003c<c<0000000000;<c<`200001<c<c0<000000lc<c00000000002c<c<
0P000003c<c<0000000000G<c<`200000/c<c080001_c<c<0HS0^058T8P1
000000000hS0^<SPf8S0^00<c<c<01bE_iEmYgfE_iEoZgnKai]oZgnKb9^7
ZhNG`YR7ZhNKb9^0Zgl0<`3<c<bKb9^7ZhNG`YN7ZhL0<`3<c<bKai]mYgfE
_iEhX7N?]hmgWgN;[hY_UG0Bc<c<0P000003c<c<0000000000;<c<`20000
0lc<c0H00004c<c<0P000004c<c<00000000c<c<0P0000;<c<`2000000?<
c<`0000000000/c<c0800005c<c<100000?<c<`2000000C<c<`00000003<
c<`200000/c<c0800002c<c<100000;<c<`200000/c<c08000000lc<c000
00000004000000?<c<`0000000000/c<c0800003c<c<0P0006[<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h00c<c<`077NOMi2gT7fWOIFoUGfWOI_7
Vgn[Oi_7VhN[QiO2Ugn[Oi_8Vgn[O`0c0<c<c9_8VhN[Qi_8Vgn[P00c0<c<
c9_7VgfWOIFoUGfWOHngSgNOMh^_RQ;<c<`2000000?<c<`0000000000/c<
c0800003c<c<0P0000;<c<`200001<c<c08000001<c<c00000000<c<c080
0002c<c<0P000003c<c<0000000000;<c<`200001<c<c0<00006c<c<1000
0003c<c<0000000000;<c<`2000000C<c<`0000000000004c<c<0P0000;<
c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P00
00?<c<`20000J/c<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00L
SkN?MimgSkN@OJMmUKnEOJMmVlNKOj]oVlNKQj^7VlRKOj]oVlRKQj^703<0
c<c<VlRKQj^7VlRKQj^703<0c<c<VlNKOJMmUKnEMimgSkN?Mimg4/c<c080
00000lc<c00000000002c<c<0P0000?<c<`200000/c<c0800003c<c<0P00
00?<c<`2000000C<c<`0003<c<c<c<`2000000?<c<`0000000000/c<c080
0004c<c<0P0000;<c<`2000000?<c<`0003<c<`00/c<c08000000lc<c000
00000002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`000000000
0/c<c08000000lc<c00000000002c<c<0P000004c<c<00000000c<c<0`00
00C<c<`20000JLc<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00L
KiE`SkN?MimgSkN@OJMmUKnEOj]oVlNKOj^0VlRKQj^7VlRKOj^0Ul:GOj^0
03<0c<c<VlRKOj]oVlRK03<0c<c<P:]oVlNKOj]oUKnEOJMmSkN?4/c<c080
00000lc<c00000000002c<c<100000;<c<`400001<c<c0800003c<c<0P00
0003c<c<0000000000800002c<c<0P0000;<c<`200001Lc<c0@00003c<c<
10000003c<c<00000000008000000lc<c00000000002c<c<10000003c<c<
00000000008000000lc<c00000000002c<c<100000?<c<`2000000?<c<`0
000000001Lc<c080001Xc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<
c<c<00V;[hYbUg6?]hmgWgN?]i1mYgfE_iEmYgfKai/00/c<c00AQj^7Ul:G
Qj^7VlRKOj]o03<0c<c<VlRKQj^7VlRK03<0c<c<Oj]oUl:GOJMmUKnEOJMm
01?<c<`30000=lc<c080000<c<c<0P00013<c<`2000000?<c<`000000000
0/c<c080001Xc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<00Q_
U6n;[hY_UG2?]hmgWgN?]hmmYgfE_iD303<0017<c<b7ZhNKb9]oZgnKb9^7
ZhL0<`3<c<bKb9^0Zgl0<`3<c<bKb9]oZgnKai]oZgnE_iD04lc<c0<0000h
c<c<00<0003<c<c<c<`00P0000W<c<`500003<c<c0800002c<c<100006W<
c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`078FWQFnDKh^_RW:G
LHngSgNOMi2gT00c0<c<c7fWOI_7V`0c0<c<c8N[Qi_8Vgn[Oi_8V`0c0<c<
c7n[Oi_8V`0c0<c<c8N[Qi_8Vgn[P9O2Ugn[Omk<c<`1R<2h0DR@R0400000
0003R<2hb>3HR<2h00c<c<`076N9IhFWQFf?KH^_RVnEL8ngSgNOM`0c0<c<
c9FoUGfWO@0c0<c<c9_8VhN[Qi_8VhN[Q`0c0<c<c9O2UhN[Q`0c0<c<c9_8
Vgn[Oi_8Vgn[Oi_7Vmk<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<
c<`03HFWQFN7IhFWQFf?KH^_RW:GLHngS`0c0<c<c7fWOIFoUGfWO@0c0003
c<c<00`0<`3<c<bKb9^7ZhNKb9/0<`3<c<b7ZhNKb9^7ZhNKb9]oZgoNc<c<
0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<00eWQfN5YhEWQfN5YhE]
Sff;[hY_UG2?]hl0<`3<c<amYgfE_iEmYgd00`0c000<P:]oVlRKOj]oVlRK
03<0c<c<Qj^7Ul:HP:]oVlRKP:]oVlRKg/c<c068`;P1B9280@00000000>8
`;S8h=R8`;P03<c<c00LOJMmIhMWQJN5IhQXQJN5KHm]Rjn:LYMa03<0c<c<
UKnEOJMmUKnEOj]oUl:GQj^7Ul:GQj^7VlRKQj^703<0c<c<VlRKOj]oVlRK
Oj]oVlRKQj^7g/c<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00:
IhMWQJN5IhMWOJMmKHm]QJN5KHm]Rjn:LYMa03<00/c<c005OJMmUKnEOJMm
Ul:GQj^700;<c<`02@0c0<c<c9_8Vh2[Oi_8VhN[Qi_8VhN[Qi_8V`3Nc<c<
0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<00YmYgeWQfMmYgeWQfMo
Zh1WQfN5YhE]Sff;[hY_UG0203<01Lc<c080<`002Gn[Oi_8Vgn[Oi_8Vgn[
P9_8Vgn[Oi_7Vh2[O`3Nc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<
c<c<00aWQfN5YhEWQfN5YhEWQfN5YhEWQfN5YhE]Sff;[hY_U6n?]hl503<0
00^G`YN7ZhNKb9^7ZhNKb9^7ZhNG`YMoZgnKb9^7ZhNKb9/0g/c<c068`;P1
B9280@00000000>8`;S8h=R8`;P03<c<c00LOJMmIhMWOJMmIhMWOJMmIhMW
OJMmIhMWQJN5KHm]Rjn:KiA_SkN?MimgSkN?MimgUKnEOJMmUl:GOj]oUl:H
Oj^0VlRKQj^7VlRKP:]oVlRKOj]og/c<c068`;P1B9280@00000000>8`;S8
h=R8`;P03<c<c00LIhMWQJN5IhMWOJMmIhMWQJN5IhMWOJMmKHm]QJN5KHm]
Rjn:LYMaSkN?MimgSkN?OJMmUKnEOJMmUl:GQj^7VlRKOj]oVlRKQj^7VlRK
Oj]oVlNKg/c<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00LOJMm
IhMWOJMmIhMWOJMmIhMWOJMmIhMWOJMmIhMWQJN5KHm]Rjn:KiE`Rjn:Mimg
SkN?OJMmUKnEOJMmUl:GOj]oVlNKOj]oVlRKOj]oVlRKQj^7g/c<c068`;P1
B9280@00000000>8`;S8h=R8`;P03Lc<c00JQJN5IhMWQJN5IhMWQJN5IhMW
QJN5IhMWQJN5IhUWQJN5KHm]Rjn:LYMaSkN?MimgT;N@OJMmUKnEOJMmVlNK
Qj^7VlNKQj^7VlRKQj^7glc<c068`;P1B9280@00000000>8`;S8h=R8`;P0
olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0
^058T8P1000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B9280@000000
00>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h
0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<1lc<c068
`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R0400000
0003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0
^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1
R<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;P8R<2h0DR@R04000000003
R<2hb>3HR<2h008008004@01P002P002P@03P@04P@05P@05PP06PP07PP48
PP48P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD248D24HH24HH24XH2
4hH20QB700H25HL25XL35hP35hP368P36HP20aZ900D36hT378X37HX37HX4
7XX00P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDXSP06
1BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB
1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPo
UPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:
VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]E
WP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj8<
H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>JZD>JjH>
JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?
MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6^
0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba
4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D01QBG
]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T0
5QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^
_AN^_QN__QN`_QNa_QNa_aNb_aNc_a@H]<01R<2h0DR@R04000000003R<2h
b>3HR<2h008008004@01P002P002P@03P@04P@05P@05PP06PP07PP48PP48
P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD248D24HH24HH24XH24hH2
0QB700H25HL25XL35hP35hP368P36HP20aZ900D36hT378X37HX37HX47XX0
0P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>
1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB
1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPo
UPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;
VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]F
WP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj8<H:8<
HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>JZD>JjH>JjH>
K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?MjX?
MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6^0Q62
[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba4Xfb
4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D01QBG]ABH
]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T05QFS
^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^_AN^
_QN__QN`_QNa_QNa_aNb_aNc_a@H]<01R<2h0DR@R04000000003R<2hb>3H
R<2h008008004@01P002P002P@03P@04P@05P@05PP06PP07PP48PP48P`49
P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD248D24HH24HH24XH24hH20QB7
00H25HL25XL35hP35hP368P36HP20aZ900D36hT378X37HX37HX47XX00P@O
R`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>1BZ?
1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB1cFC
1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPoUPQ0
U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;VPY;
VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]FWP]G
WP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj8<H:8<HJ8=
HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>JZD>JjH>JjH>K:H>
KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?MjX?MjX@
N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6^0Q62[P06
4H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba4Xfb4Xjb
4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D01QBG]ABH]QBI
]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T05QFS^QFT
^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^_AN^_QN_
_QN`_QNa_QNa_aNb_aNc_`8H]<0@00000QRd`068`;P1B9280@00000000>8
`;S8h=R8`;P00P00P00A006000:000:100>100B100F100F200J200N20@R2
0@R30@V30@Z30@^30@^40@b40@f400813XD01P8?Q@8@Q@8AQP8AQP8BQP8C
QP8258L01P8EQ`8FQ`<GR0<GR0<HR0<IR0836XT01@<KR@<LRP<MRP<MRP@N
RP0211n;00X488/48H/48X`48X`48h`498`49Hd59Hd59Xd59hh21BR>00H5
:Hh5:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46<I46<Y46<i86=987
=987=I<7=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE23jF23nF
23nF242G246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E2DVJ2DZJ
2T^J2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM2eBN2eFN
2eJN2eNN2eNO2eRO008;FIl04PaJX0aKX0aLX0aLX@aMX@aNX@aOX@aOXPaP
XPaQXPeRXPeRX`eSX`eTX`eUX`eUY0eVY0eWY08=J:D01PiYY@iZY@i[YPi[
YPi/YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmg
ZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh2
4H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4B
SK8BS[8CS[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne
59Rf59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F
5J>j5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm
5jjn5jnn5k2n5k6n5k6o5k:o5k>o0QRd`003b>3HB928B92800a8T8P01@00
01Rd`1Rd`8S0^4R@R001000000000hS0^<SPf8S0^002002001400H000X00
0X400h4018401H401H801X801h81288128<12H<12X<12h<12h@138@13H@0
0P4>Q@060Pn50Q250Q660Q660Q:60Q>60P8DQ`060QF70QJ70aN80aN80aR8
0aV80P<JR@050a^90ab:0af:0af:11j:00847h/02P@PR`@QR`@RS0@RS0@S
S0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y00
2PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0Lj
U0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9
AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:
D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0B35ZP
35^P35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS3FFS3FFT
3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X
3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l
[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7
/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B
]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HE
WKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/F
Z;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/kl2
6;C000?8h=R8`;R8`;P02hS0^006B92800006;C06;C0R<2hB9280@000000
00>8`;S8h=R8`;P00P00P003006000:0oooo00;oool01005POooo`06PP07
PP;oool01049Poooo`4;P`4;Q0?oool00`4>Q@8?Q@8@Q@03oooo00D24hH2
58L258L25HOoool00P<GR003oooo0aV80aZ900?oool20af:00Goool47h/4
7h/488_oool00P@RS00612><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>1BZ?
1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB1cFC
1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPoUPQ0
U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;VPY;
VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]FWP]G
WP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj8<H:8<HJ8=
HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>JZD>JjH>JjH>K:H>
KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?MjX?MjX@
N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6^0Q62[P06
4H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba4Xfb4Xjb
4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D01QBG]ABH]QBI
]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T05QFS^QFT
^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^_AN^_QN_
_QN`_QNa_QNa_aNb_aNc_`8H]<000lSPf8S0^8S0^00;R<2h00I8T8P0000H
]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^002002000@00H3oool00X40
0h42oooo00D01H801X;oool1288128<00_ooo`080@^3oooo0@b40@f40@j5
oooo0Pn5oooo0P8AQP060Q:6oooo0QB70QB7oooo0QJ70P<GR009oooo0aV8
oooo0aZ90a^90ab:oooo0af:oooo00847h/02P@PRoooo`@RS0@RS0@SS0@T
S0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_
T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0Lj
U0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9
AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:
DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0B35ZP35^P
35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS3FFS3FFT3FJT
3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X
3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l
[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7/08B
R;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C
]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPE
W[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`F
ZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/kl26;C0
00C8h=R8`;R8`;R8`;P2000018S0^0800002R<2h00I8T8P0000H]<0H]<28
`;Q8T8P1000000000hS0^<SPf8S0^0020020017oool00X000X7oool01840
1H7oool01X;oool1288128<12H?oool12h?oool138@13H@00P4>Q@030Pn5
0Q250Q6600;oool01@8CQP8DQ`8DQoooo`8FQ`020aN800Woool36HSoool3
6XT36hT378[oool37H[oool00P@OR`0:122;oooo12:<12:<12><12B<12F=
1BF=1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A
1S6A1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E
0088?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6
V@U7V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YA
W@]BW@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<
G:4<GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@2
3FRU00H>JJD>JZD>JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?
LjP23gBY00D?MJT?MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/
47j/47n]4Gn]4H2]4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:
4XV`4XZa4X^a4X^a4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd
4iBd4iFe008DU[D01QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO
^1FO^1FP^AFQ^@8EX[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ
_1J[_1J[_AN/_AN]_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc_`8H]<000lSP
f8S0^8S0^002R<2h0P0000:8`;P200000hS0^006B92800006;C06;C0R<2h
B9280@00000000>8`;S8h=R8`;P00P00P00>oooo00:000:100>100B100F1
oooo00J2oooo0@R20@R30@V3oooo0@^31Oooo`060Pn50Q25oooo0Q660Q:6
0Q>60P8DQ`0=oooo0QJ70aN80aN8oooo0aV8oooo0aZ90a^90ab:oooo0af:
oooo00847h/02P@PRoooo`@RS0@RS0@SS0@TS0@US@DUS@DVS@DWSP85:8h0
1PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHd
TPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8
?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9
BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;
EIh;EYh;Eih;Eil;F9l00P]IW`0B35ZP35^P35bP35bQ35fQ35jQ35nQ35nR
362R366R3F:R3F:S3F>S3FBS3FFS3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V
3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ
3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61
[P8APZh01Q63[Q64[a65[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:<
/A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HD
UkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i
01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG
[[dG[[hG[khG/;hG/KhG/KlG/[lG/kl26;C000?8h=R8`;R8`;P00hS0^0@0
0004R<2h00I8T8P0000H]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^002
002001Goool00X000X400h4018401H7oool01X;oool1288128<12H?oool1
2h?oool138@13H@13XGoool23hGoool00P8AQP060Q:6oooo0QB70QB7oooo
0QJ70P<GR008oooo0aV8oooo0aZ90a^90ab:oooo0af:0_ooo`0311n;122;
oooo00848X`01P@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[
S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87
=i<01@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL2
24:G00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:
CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;
F9l00P]IW`0B35ZP35^P35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S
3F>S3FBS3FFS3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^
Y`063VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@
NJ/02Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64
[a65[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?
/a>@/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHD
V[LDVkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXF
YKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG
/KhG/KlG/[lG/kl26;C000?8h=R8`;R8`;P018S0^0800005R<2h00I8T8P0
000H]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^002002000ooool00X00
0X400h4018401H7oool01X;oool1288128<12H?oool12h<12h@00oooo`03
0@j50Pn50Q2500?oool00`8CQP8DQoooo`02oooo0P<GR003oooo0aV80aZ9
00?oool20af:00Goool47h_oooooool48H/00P@RS00612><12B<12F=1BF=
1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A
1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088
?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7
V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]B
W@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<
GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU
00H>JJD>JZD>JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP2
3gBY00D?MJT?MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/
47n]4Gn]4H2]4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`
4XZa4X^a4X^a4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd
4iFe008DU[D01QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO
^1FP^AFQ^@8EX[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[
_1J[_AN/_AN]_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc_`8H]<000lSPf8S0
^8S0^003R<2h100000B8`;P01TR@R00001Rd`1Rd`8S0^4R@R04000000003
R<2hb>3HR<2h008008004Oooo`02P002P@03P@04P@05POooo`06PP07PP48
PP48P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD248D24HH24HH24XH2
4hH20QB700Koool25XL35hP35hP368P36HP20aZ900D36hT378X37HX37HX4
7XX00P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDXSP06
1BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB
1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPo
UPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:
VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]E
WP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj8<
H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>JZD>JjH>
JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?
MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6^
0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba
4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D01QBG
]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T0
5QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^
_AN^_QN__QN`_QNa_QNa_aNb_aNc_`8H]<000lSPf8S0^8S0^002R<2h0P00
00:8`;P200000hS0^006B92800006;C06;C0R<2hB9280@00000000>8`;S8
h=R8`;P00P00P00A0060oooo00:100>100B1oooo00F200J200N20@R20@R3
0@V30@Z30@^30@^40@b40@f400813XD01P8?Q@8@Q@8AQP8AQP8BQP8CQP82
58L01_ooo`8FQ`<GR0<GR0<HR0<IR0836XT01@<KR@<LRP<MRP<MRP@NRP02
11n;00X488/48H/48X`48X`48h`498`49Hd59Hd59Xd59hh21BR>00H5:Hh5
:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46<I46<Y46<i86=987=987
=I<7=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE23jF23nF23nF
242G246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E2DVJ2DZJ2T^J
2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM2eBN2eFN2eJN
2eNN2eNO2eRO008;FIl04PaJX0aKX0aLX0aLX@aMX@aNX@aOX@aOXPaPXPaQ
XPeRXPeRX`eSX`eTX`eUX`eUY0eVY0eWY08=J:D01PiYY@iZY@i[YPi[YPi/
YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmgZPmg
ZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh24H:^
00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4BSK8B
S[8CS[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne59Rf
59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F5J>j
5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm5jjn
5jnn5k2n5k6n5k6o5k:o5k>o0QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P2
00000XS0^006B92800006;C06;C0R<2hB9280@00000000>8`;S8h=R8`;P0
0P00P003006000:0oooo00;oool03005P@05PP06PP07PP48PP48P`49P`4:
P`4;P`4;Q04<Q04=Q0813XD01P8?Q@8@Q@8AQP8AQP8BQP8CQP8258L01P8E
Q`8FQ`<GR0<GR?ooo`<IR0836XT01@<KR@<LRP<MRP<MRP@NRP0211n;00X4
88/48H/48X`48X`48h`498`49Hd59Hd59Xd59hh21BR>00H5:Hh5:Xl5:hl5
:hl5;8l6;I021Rj@00X6;i06<946<I46<I46<Y46<i86=987=987=I<7=Y<2
1cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE23jF23nF23nF242G246G
0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E2DVJ2DZJ2T^J2T^J2TbK
2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM2eBN2eFN2eJN2eNN2eNO
2eRO008;FIl04PaJX0aKX0aLX0aLX@aMX@aNX@aOX@aOXPaPXPaQXPeRXPeR
X`eSX`eTX`eUX`eUY0eVY0eWY08=J:D01PiYY@iZY@i[YPi[YPi/YPi]YP8>
KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmgZPmgZQ1hZP02
47V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh24H:^00HAPjhA
Q:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4BSK8BS[8CS[8C
Sk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne59Rf59Vf59Vf
59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F5J>j5JBj5ZFj
5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm5jjn5jnn5k2n
5k6n5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h00^8`;P01TR@R00001Rd`1Rd
`8S0^4R@R04000000003R<2hb>3HR<2h008008004@01P002P002P@03P@04
P@05P@05PP06PP07PP48PP48P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H2
3hD248D24HH24HH24XH24hH20QB700H25HL25XL35hP35hP368P36HP20aZ9
00D36hT378X37HX37HX47XX00P@OR`0:122;126;12:<12:<12><12B<12F=
1BF=1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A
1S6A1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E
0088?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6
V@U7V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YA
W@]BW@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<
G:4<GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@2
3FRU00H>JJD>JZD>JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?
LjP23gBY00D?MJT?MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/
47j/47n]4Gn]4H2]4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:
4XV`4XZa4X^a4X^a4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd
4iBd4iFe008DU[D01QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO
^1FO^1FP^AFQ^@8EX[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ
_1J[_1J[_AN/_AN]_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc_`8H]<000lSP
f8S0^8S0^00;R<2h00I8T8P0000H]<0H]<28`;Q8T8P1000000000hS0^<SP
f8S0^002002001400H000X000X400h4018401H401H801X801h81288128<1
2H<12X<12h<12h@138@13H@00P4>Q@060Pn50Q250Q660Q660Q:60Q>60P8D
Q`060QF70QJ70aN80aN80aR80aV80P<JR@050a^90ab:0af:0af:11j:0084
7h/02P@PR`@QR`@RS0@RS0@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZ
S`D[S`D[S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLe
T`LfT`87=i<01@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8
@9L8@IL224:G00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:
BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;
Eih;Eil;F9l00P]IW`0B35ZP35^P35bP35bQ35fQ35jQ35nQ35nR362R366R
3F:R3F:S3F>S3FBS3FFS3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV
3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ
47RZ008@NJ/02Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8APZh0
1Q63[Q64[a65[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>
/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HD
VKHDVKHDV[LDVkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXE
Y;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG
[khG/;hG/KhG/KlG/[lG/kl26;C03lSPf00500006;C06;C0R<2hB9280040
00000003R<2hb>3HR<2h008008004@01P002P002P@03P@04P@05P@05PP06
PP07PP48PP48P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD248D24HH2
4HH24XH24hH20QB700H25HL25XL35hP35hP368P36HP20aZ900D36hT378X3
7HX37HX47XX00P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>
0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A
1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPm
U@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T0
5@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]D
W@]DWP]EWP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<
Gj4<Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>
JZD>JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?
MJT?MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]
4H2]4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a
4X^a4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008D
U[D01QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ
^@8EX[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/
_AN]_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc_a@H]<01R<2h0DR@R0400000
0003R<2hb>3HR<2h008008004@01P002P002P@03P@04P@05P@05PP06PP07
PP48PP48P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD248D24HH24HH2
4XH24hH20QB700H25HL25XL35hP35hP368P36HP20aZ900D36hT378X37HX3
7HX47XX00P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDX
SP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B
1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@Pn
UPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9
VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]D
WP]EWP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<
Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>JZD>
JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?
MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]
4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a
4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D0
1QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8E
X[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]
_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc_a@H]<01R<2h0DR@R04000000003
R<2hb>3HR<2h0?n8`;P8R<2h0DR@R04000000003R<2hb>3Hb>3H0?o8h=P8
b>3H0DR@R04000000?n8`;P<R<2h0@000000\
\>"], "Graphics",
  ImageSize->{268, 115},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000460000S2000`400?l00000o`00003omoo`l?00
0ooIfMWoooooooooo`0<ooooo`00moo`l?001?oIfMWooooooooooooUiND3ooooo`05onGUiOoooooo
oooooooooooUiND00oooool00?Ool?3`00gofMWIoooooooJf][oSHf=onGUiOoooooof][Johf=SOoU
iNGoooooom[Jf_n=SHgoiNGU00;ooooo003goo3`l00>omWIfOooooooooooom[Jf_n=SHgoiNGUoooo
oooJf][oSHf=onGUiOoooooof][Johf=SOoUiND1ooooo`00moo`l?003OoIfMWooooooooooooooooo
f][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGUoooooooJf]X00_ooool00?Ool?3`00?ofMWIoooooooo
ool00_ooool01ooJf][oSHf=onGUiOoooooof][Johf=SOoUiND00oooool00?Ool?3`00?ofMWIoooo
ooooool00oooool01ooJf][oSHf=onGUiOoooooof][Johf=SOoUiND00_ooool00?Ool?3`00?ofMWI
ooooooooool01?ooool01ooJf][oSHf=onGUiOoooooog=cLohf=SOoUiND00Oooool00?Ool?3`00?o
fMWIooooooooool01Oooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo003goo3`l003omWIfOoo
oooooooo00Kooooo00?og=cLohf=SOoUiND00oooool00?Ool?3`00?ofMWIooooooooool01oooool0
0ooLg=coSHf=onGUi@02ooooo`00moo`l?000ooIfMWoooooooooo`08ooooo`03omcLg?n=SHgoiNGU
007ooooo003goo3`l003omWIfOoooooooooo00Wooooo0OoLg=`1ooooo`7ooooo003goo3`l003omWI
fOoooooooooo00cooooo003goo3`l0oofMWI003oooooo`Oooooo003oonk^kPOok^k^003oonKViPOo
i^KV003oonk^kPOok^k^003oooooo`Oooooo003oonk^kPOok^k^003oonKViPOoi^KV003oonk^kPOo
k^k^003oooooo`Oooooo0019onk^kP;okNg]00[ojn_[onSXj?oUiNGoh^;RomgMgOoHf=Soe=CDom7A
dOo>c/koc<c<0_o;bl/eol[:bP;obl_;00[oc<c<olk>c_oAdM7oe=CDomSHf?oMgMgoh^;RonGUiOoX
j>Sojn_[0_o]kNd@onk^kP;okNg]00[ojn_[onOWiooRh^;ogMgMomKFe_o8bLWo^;VlojBYZonHWZ;o
TYVN0_nBV9d00onAV9goWJ6UoiNJXP04oi6HW@04oiNJX_nMXJGoWJ6UoiNJXPCoTIRM00CoUiZRoifQ
YOnMXJGoUiZR1?nAV9d01?nGVZ;oWJ6UoifQYOnGVZ84oi6HW@04oiNJX_nMXJGoWJ6UoiNJXPCoTIRM
00CoUiZRoifQYOnMXJGoUiZR1?nAV9d01?nGVZ;oWJ6UoifQYOnGVZ82oi6HW@;oTYRM00[oTYVNoiRN
X_nTZJ_o^;VlolS9bOoFe]KogMgMon;Rh_oWinOojn_[0_o]kNd;onk^kP00B?oVi^H2onGUi@0:on;R
h_oPh>3ofm_KomKFe_o>c/koalO7okno_onh^;So];Bdok2`/0;o[Zj^0_n][Jdcojb/[0;o[Jf]0_n^
[Zh02_n`/;3o];BdokRh^?no_kooalO7olk>c_oFe]Kofm_Kon3Ph?oRh^82onGUi@koi^KV0_oUiND0
3?oRh^;og]kNomSHf?o8b<So/kBeoi^OX_n9T9OoNHF>og1nRomYNh[oIg^;ofIiR`;oIWV:00?oKGZ8
ofMhR?mUN8X00omUN8X01?mWN8SoKGZ8ofejR?mWN8P4ofEhRP04ofMhR?m]NXSoKGZ8ofMhR0CoIGR:
00CoIgR8ofejR?m]NXSoIgR81?mUN8X01?mWN8SoKGZ8ofejR?mWN8P4ofEhRP04ofMhR?m]NXSoKGZ8
ofMhR0CoIGR:00GoIgR8ofejR?m]NXSoIgR8ofEhRP02ofIiRP0<ofIiRomWNh_oJG^:og1nRomiQHko
RI2Goi^OX_nc];Gob<S8omSHf?oNg]koh^;R0_oUiND:onKViP00B?o^k^h03_o]kNgoj^[ZonOWiooR
h^;ofMWIolk>c_o3`l?o^;Rhojj^[_nVYZKoX:2PoibLW?nIVIWoV9RH=onGUiL03OnHV9SoVIVIoibL
W?nPX:3oYZJVojj^[_nh^;So`l?3olk>c_oIfMWoh^;RonOWiooZj^X00_o]kNd=onk^kP0>ong]kOoZ
j^[oiNGUomgMgOo;c<coZZf_oh^CVOmeP8koIWR:oeecR_mHLhcoE7:<oeAaS?mCLH`2oe5_RP03oe=_
Q_mAKh[oDFn:00CoDFn:0_mCKhH6oe5_RP;oDfn61_mAKhX2oe=_QPKoDFn:0_mCKhH6oe5_RP;oDfn6
1_mAKhX2oe=_QPCoDFn:00goDg6<oeAaS?mDLXcoF7><oeecR_mVN8[oMH2>oh^CVOnZ[Jooblc<omgM
gOoUiNGoj^[Z00;okNg]2Oo^k^h004Sooooo00koo?clooWinOobl_;oj>SXom[Jf_o;bl_o^[Zjojb/
[?nOWiooUIFEohj>S_n:RX[oQhN7ohJ6QSOoQHF500ooQXJ6ohN7Qon:RX[oSXj>oiFEUOnOWioo[:b/
okZj^_o;bl_of][JonSXj?obl_;onOWiooclo?ono_h03Oooool02oolo?comoOgong]kOoFemOo/kNi
oh^DWOm/OXooG7J<oeE_ROm@Jh?oCfMn00;oCfEi00GoCf=hodiSN?m>HgSoB69lodYSNP04odiSN004
odYSN_m8HWcoB69lodYSNPCoCV=h00CoBV=jodQRO?m8HWcoBV=j1?m>HgP01?m:Hg[oB69lodQRO?m:
HgX4odiSN004odYSN_m8HWcoB69lodYSNPCoCV=h00CoBV=jodQRO?m8HWcoBV=j1?m>HgP01?m:Hg[o
B69lodQRO?m:HgX3odiSN00?odmSN?m?IGWoCfEiodmWO_m@Jh?oEFn9oeafS?m/OXooRiBMok>g^OoF
emOokNg]ooOgmoolo?coo_kn00Wooooo0018onk^kP0DonSXj?oRh^;ofMWIol[:b_nj^[[oZ:RXoiRH
V?nBTY;oYJFUol30`?oGemOojn_[ooKfm_ogmoOonOWiooShn?oinOWon_[jooWinOogmoL3ooShn0;o
nOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[o
nOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?o
n?Sh0_oinOT04oojn_[onOWiooShn?oinOWon?ShooOgmoo]kNgof=SHol71`OnUYJGoTY:BoiRHV?nX
Z:So^[Zjol[:b_oIfMWoh^;RonSXj?o/k>`03Oo^k^h04?oWinOogmoOol_<c?nVZZcoPHZBofEgQ_mG
KH7oDV^3oeekW?m`UK_oQ:kHoiC2l?nRdO[oXm;jojKFnonWe?/coj[Gn`0AojSDnonXeO_oY]Ckoj?C
nonGa?3oQJoHog:E^omNOIkoDf^4oeM]POmUMhKoPHZBojJZ[?o;c<cogmoOonOWioo/k>`02Oo^k^h0
04Soi^KV00cogMgMomKFe_o7alOo]kNgoj>SXonATI7oXZ:Rol_;boo^k^kom_Kfooclo?ono_hkoooo
o`0=ookno_olo?comoOgono_koo<c<coXj>Soi6ATOnSXj?o]kNgolO7aooFe]KogMgMon;RhP0=onKV
iP0@om[Jf_o8b<SoYJRYogj7SomSM8?oE6]ooeQgUombVl[oT<Ghoic>n_nVe_goZ][mojoNo_nah?oo
]N;ookGToc?o]nGo017o]NCookKUoonch_oo/N3ooj_KoOnXfOgoX=3koiG7n?mfWlgoG7^IoeA[OomS
M8?oOXN?ojFXZOo8b<Sof][Jon;RhP09onKViP00B?o^k^h02_oRh^;oe]KFol?3`on^[ZkoVYZJojf]
[OoNg]kojn_[ooCdm?okno/oooooo`0;oo_knooclo?ok>c/on7QhOn`/;3oVYZJojj^[_o3`l?oe]KF
on;Rh_oXj>P03Oo^k^h03_oEeMGo/KBfohR@V?mXNHSoF6n5oeUnXOmj[nOoRl7goiW;nonTe_co[mon
ok?Toonfiooo^NSo0_nkj_ldokgZo`;o^n[o00ko^^Wook?Toon_g_koY]Oloic<nonB`_SoP[CZoej1
YOmHL8KoJ7V8ohR@V?na];KoeMGEonKViPWok^k^0018ooooo`0:ong]kOoLg=coaLG5ojb/[?n][Jgo
e=CDon3Ph?o/k>comOGeoogmoCoooooo00_oo_knooKfm_o/k>coh^;RomWIfOna/K7o[:b/olG5aOoL
g=cokNg]ooKfmP0=ooooo`0=om3Ad_nLXj[oLXBCof1fROmENZ7oKZ3JogjbjOn>`_OoW<kkojWJoOn_
goko]^Gook_Zo`03okk/oc?o`^go017o_ncookk/oonnk?oo^n[ookKUoonah?ooZ][moj7?nonB`oSo
Q;KZogNZh?mKOZ?oH7J9og:4TonLXj[od=7Boo?cl`09ooooo`00B?o^k^h02ooHf=Soa/K6ojj^[_nS
Xj?oa/K6omCDe?oPh>3ok>c/oo;bl_olo?coo_kn02;ooooo00?ok>c/ono_koooool06Oooool02ooj
n_[om?Cdon[Zj_oShn?oemOGolg=cOnVYZKo[Zj^olK6a_oHf=Soh^;R00gok^k^013oYJV/ogZ7U?mQ
NHooCg2Boe^Ac?m_YMgoP;?Zoi32n?nKc?[oZ=WmojcMoOnch?ko^NOook[YoonljOoo^nSo6Onoj_l0
0onfgoCo[MCXokoZo`03okoZo`;o]Mkb4_noj_l04Onnj_oo_>Wook_YooniiOoo]NCook3No_nYeoco
W/okoi;2m?n7]ncoMjSNofJKd_mCM9CoHGV?ogZ7U?nUZJcoemOG00Wok^k^0018onKViP0?olg=cOni
^KWoXJ6Qoj^[Zoo6a/Kod];BomcLg?oVi^Kok>c/ooGemOohn?Son_[joogmoOooooooo?cl00Sooooo
00?ooOgmooooooooool01Oooool01?omoOgoooooocHf=_nUYJD3ooooo`03ol71`Ol0003oVi^K00;o
oooo00Kofm_KocDe=Ol>3Pko30`<ocPh>?oLg=`6ooooo`03oogmoOoooooooooo00Gooooo00?ooOgm
ooooooooool00_ooool04?omoOgooooooogmoOokno_on?ShooCdm?o]kNgoi^KVomoOgooFe]Koc<c<
ok6a/OnRXZ;o^KViolg=cOoKfm/=onKViP0@ohfDW?mYOi7oEG:<odQdYomKTLcoKZ;Jogf_iOn=_>oo
ULChoj;@nonXe_co[=[mok7MoOndh?ko/mcmokGQoQ7o^>7n00?o;3HmodeOJonhhOh00onhhOh03?nV
bnKo=D59o`820_lI7R;o41@Foh^Z`?nhhOko6R0To`/>3olG71oo=d=<ok7ImA3o^>7n017o]^7nokCO
oOndh?ko/]cmojoJoOnZe_coXm3koi[8n?n?_nooQ;CWogJWgOmUV];oDgb]oeMcS_mYOi7oSIBLol;3
``09onKViP00B?o^k^h04ooAdM7o^k^koj6QXOnf][Ko`l?3olo?cooFe]KogmoOonKVi_oZj^[okno_
oo?cloodm?ComOGeooOgmoofm_KomoOgooKfm_ohn?P00_ogmoL2ooKfmP;omoOg00Com_KfooShn?og
moOomoOg0_ofm_H2ooOgm`0<oc@d=?nPX:3omoOgooOgmoo]kNgo8b<So`000?nFUYKom_KfooOgmolb
<S;oCdm?0_oUiND01?mBDU;o<c<cooGemOohn?P2ooOgm`;om_Kf0_ogmoL01?ofm_Kon?ShooOgmoog
moL2ooKfmP;omoOg01?om_KfooShn?ofm_KomoOgooKfm_odm?Col_;boo3`l?o[jn_oi^KVon7QhOoJ
f][odm?ColW9bOno_kooYZJVok^k^ooAdM7ohN7Q00gok^k^00koPHjHofAoV?m:JhooAGfkoeR>b?m[
WmGoMjSNohBej?n?_nooUlCdoik;nOnTd?[oZ=;koj_Dn`;o[=Gl4On^eo`00olZ=3goBE]ZojkGo003
ojkGo00<obhi@ol[=CooV;cLojkGo?nUc?3oYLc_ojkGo?n3XKgoZm?hojgFnolT;CGoHg^@4?n^eo`0
4On]e_co[=Kloj_DnonXd__oY]3joj;=n_nKaoCoTl3^ohVgjOmo[n3oLJCIof:FcomAR<CoCW2DofAo
V?n1SYSo/kFg00Wok^k^0018ooooo`0;omoOgoo5aLGoY:BTok>c/oo0`<3obLW9om?CdooIfMWogMgM
on;Rh_oUiND00_oZj^X00oo/k>cokNg]ong]k@07onk^kP03oo3`l?o^k^kok^k^00Gok^k^00Col?3`
onk^k_lb<S;oVYZJ0_o^k^h02?m]KFgo4A4AobPX:?n@T93ok^k^olW9bOl0003oZZZZ0_o^k^h00on/
[:co0000olg=c@05onk^kP03oo3`l?o^k^kok^k^00Gok^k^00Col?3`onk^k_o^k^kok^k^0_o]kNd2
onc/k00=onWYjOoVi^Kohn?Son3Ph?oKfm_oeMGEolg=cOo5aLGo^k^koj^[Zoo5aLGogmoOoo3`l00=
ooooo`0@oh6BWomUPigo@6REocmg]omBR<GoHYOAog2TfOmm[=koQKCUohjjjOnE`>goV/Cboik8lonP
bOGoX/Weoj?:mA7oY<ce00?o9c4kodEFIonTc?D00_nTc?D00on>/=Co0000ogJC/007ojC<m@03ogjM
_Ol>4AGoGWF=013oY<ce017oXl[eoj?9mOnPbOGoWlWeoic5l_nG`^goT[g[oh^hi_n2/>3oN:SKof^M
e?mLTLcoC8:oodM_W?mUPigoPI:Ook>g^P09ooooo`00B?o^k^h03Oo@d=3o^;RhoibLW?n/[:co^k^k
olK6a_o=cLgodm?ComOGeooKfm_ogmoOon7QhOoRh^800_oShn<7onGUi@;oi^KV1_oUiND2onKViP0B
onGUiOl`<33oU9BDonGUiOne]KGo0P82oi>CTolh>3SoRh^;onGUiOnZZZ[o0000olk>c_oUiNGoi^KV
olg=cOl0003o[Jf]1?oUiND2onKViPKoiNGU0_oVi^H3onGUi@;oi>CT0_oShn<03OoRh^;oh>3PomcL
g?oIfMWoe]KFom3@d?o9bLWo`L71okFe]OnUYJGo^;Rhom3@d?oPh>003Oo^k^h04?mhRIWoHH2Koc9M
UoliKk;oBh?0oe^AbomYVm?oMJKIogb/gOn5/>3oRkOUohnki_nD_>SoUKkYoiJojOnI`>/Aoi_2j`03
obD^>?m1DV?oVl;[00;oVl;[00?oLi2_o`000?lU;SP00olV;cX01omgUKCoVl;[ohZ]d_l/>4Co0@82
odAEJ?nE^n804?nK`^/04OnG`>[oUkoZoiJojOnE_NWoTkcVohnhi_n7]>7oPZoOog^Zfom`XMOoI9S>
oeN;aom3Nk[o>VRPof60VomhRIWoXZN/00Wok^k^0018onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko
`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0;og]kN0ooMgMd00ooNg]kogMgMomgM
g@02omkNgP?ogMgM01Gog]kNomgMgOoMgMgog]kNobl_;on?Shoof=SHobHV9_m0@43ogMgMocHf=_n6
QXKog]kNokjn__l0003oW9bLomkNg_oMgMgoVYZJo`000?o3`l<00ooMgMd00ooNg]kogMgMomgMg@02
omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h2omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;B
d_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWIf@goi^KV00goMhRGof61WOlRD9Co<VR[
od9k^omBRLGoH9C<of^LdomcXmOoNjWJoh6]gOn6/^3oRKCP00;oS;KQ00?oSKKQoi2ii?n@^N@03_n@
^N@01?mnX/So10D7oa4F6on:/M/2oi2ii00;og^N`ol0003oH7bHogBF^Om`T;7o0@82oh6Vc?n@^NCo
92ljobD_>omkW/<04_n@^N@04On>]n7oSKKQohbfhOn:]^7oQk;PohF`g_n0[=_oNJOHog6Qe_mWVLoo
G97;odf5`ollLkCo;5jOof61WOmgR9OoWJ>W00Woi^KV0018onk^kP0=omCDe?no_kooS8b<oijNW_n]
[Jgo^KViol;2`_o7alOoc<c<om3@d?oBd];oeMGEomKFeP02omOGe`03omSHf?oIfMWofMWI00oofMWI
00So;Bd]ohb<S?m/K6co2`/;ol71`OoIfMWo=CDeoh>3P`;ofMWI00Ko=cLgocdm?Onl_;co_;bloc`l
??li>CTBomWIf@;of=SH0_oGemL03OoEeMGodm?Com3@d?o>c/kob/[:olG5aOno_koo]KFeojVYZOnH
V9So_knoomCDe?oRh^803Oo^k^h04?mkS9_oIHBPoaY8SOlYG:?o>6jbodIn__mFRlOoH9C<of^Ld_ma
XMGoMZGGog^Zf_n1Zm_oPZgKohB^fon5[m`@ohRagP04obdkB_lD6R7o9C0locmBI`?oR;7N00Go8B/f
ocU:GOn3ZmOoE6f9oaHM9@02ohRagP05oadV;om@J8;oR;7Nog^QbOn5[MT04?n8/Mh2ohF_g00?oh>^
fon1[M_oOZ_IogZXf?mfXmGoKj3CofNIcomLTLcoD8O5od1i^_ldJZko9EJIofF4X?mkS9_oY:R]00Wo
k^k^0018ooooo`0=onSXj?oDe=CoS8b<oi>CTonRXZ;o[jn_okZj^_o1`L7oalO7ol_;boo>c/kod=3@
om7Ad@02om?Cd`?oe=CD0_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE017oe]KFomGEeOoF
e]KoeMGDomCDe?l/;2coI6ATo`@41?mnOWkoeMGEomKFe_ld=3CoP820omCDe?oEeMGo`L71odA4A002
o``<3003odI6AOo1`L7oe=CD00;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oE
eMGoe]KFomGEe0;oe=CD0_oEeMD04?oDe=Codm?Com?CdooAdM7od=3@olg=cOo:b/[o`l?3okjn__nf
][KoZj^[oifMWOnEUIGoe=CDonSXj?oclo<=ooooo`0@oh>DXomYR:Go7TR5oaiAUol]HJKo>G6dodMn
_omDRLKoH9C<ofVJdOm_X=?oMZ?EogVWe_mlZ=OoO:SHogfYf0ooPJ_I00KoHX:Uo`000?mKN9WoKiBl
o`L92om[S[@2oh6[f@05ogBJ`olS;cco1PP;o`hB5omLNY/00_n1ZmT01OmPP:;o7BHao`P:3Ol9313o
MI_5013oPJ_I017oOZ[IogfZfOmlZ=OoNjOGogJVe_mcX]GoKYkCofBGcomJSlSoCXK4od=k^oleK[7o
9e^RobIBS_mYR:GoPiBSok2e^@09ooooo`00B?o^k^h04_oMgMgocLg=oi2@T?n9RHWoUiNGojFUYOnb
/[;o_knool_;booAdM7oeMGEomOGeooIfMWof][Jom_KfooJf][ofm_KomcLg0Oofm_K00?og=cLom_K
fooKfm/01OoKfm/00ol^;Rko10@4ocHf=P03om_Kf`03ocHf=_n5QHGog=cL00?ofm_K0_oJf]X2om_K
f`03omcLg?oKfm_ofm_K00Gofm_K00?og=cLom_KfooKfm/01OoKfm/04ooLg=cofm_Kom_KfooKfm_o
f][JomWIfOoHf=Soe]KFom?Cdoo=cLgo`/;2okJf]_n/[:coWinOoi2@T?nFUYKocLg=omgMgOoUiND0
3Oo^k^h04?n1T9koK8ZTobe?POlEA8go8E>MobeSZ_llLkSoE8W3offKc_mlZ=GoQ:gIohRafon>/mco
SkGMoi6gg_nA]md>oiJjg`03oiFig_lN9Bco:C<n00;oU[[O00?oCV5dob</=OnF^]l00onF^]l00onD
]mcoU[[OoiJjg`04oiJjg`03oiBgg?nF^]ooU[[O013oU[[O017oTKOMoi6gg_nA]mgoSkGMoh^bg?n7
/=[oOj[Eog6Od?mISLOo@WZkocE//OlXG:Co6TbEoc1DQ_m/RZCoPI2Nojfa]009onk^kP00B?oVi^H0
2ooJf][oc/k>oibLW?mjNW[oR8R8oiJFU_nZZZ[oa<C4omGEeOoKfm_og]kN00;oh>3P0ooRh^800ooT
i>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00Coi>CToc0`<?l820So`l?30ooShn<0
0olh>3SoRXZ:on?Sh`06on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<0
1?oTi>Cohn?Son?ShooShn<2on;RhP0>on7QhOoPh>3ogmoOomcLg?oGemOoaLG5ojb/[?nNWYkoT92@
oh:2P_nPX:3oc/k>om[Jf_oPh>0=onKViP0>ohZDWom_R9koAV25o`LdOolC@Xco7e6KocM/[omWU<So
SK;GoiRjg_nP`>7oY<7RojK3h_nWaN<2ojW7h`ko[LOU00?oJg^=o`830onAYl000_n]anD00onY`n3o
720Uof]kS@0Mojg7i@0Aoj[7iOn[an?oZLOSojS5honVa>;oX/3Qoi^mgon>/]SoIYK8ocQ^/_lVFZ?o
6DZEo`hlQom7HhSoKhRNohZDWond]kP02OoVi^H004Sok^k^00koiNGUomgMgOo2`/;oNg]kogQhN?n6
QXKoWinOolG5aOoHf=SogMgMomoOgooQhN7oh^;Ron?Sh`?oi>CT1?oUiND2onCTi003onGUiOoTi>Co
iNGU00?oiNGU0_oTi>@01?oUiNGoi>CToijNW_nZZZX2onGUi@;oi>CT00?oXJ6Qol71`OoUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00Co
iNGUonCTi?oUiNGoiNGU0ooTi>@03_oShn?ohN7Qon3Ph?oOgmoof][JolK6a_nQXJ7oSHf=oh20P?n4
Q8Co`l?3omgMgOoUiNGoj^[Z3Oo^k^h03_nUZZkoOi2NofMnU?lK>gKo1C9loa0oS?l`GjCoLiS7oibh
fOnU`=ooYl;Poj_7hon]an?o[lWS4?nbbnD00omkS9koOHnQok;;i@03ok;;i@03oi>X__mhRI_o//_U
01ko//_U00oo/L_Uojo9hon[an?oZ<CQojW3h?nM^mcoLiW8obiPYOlFAY;o2SV4oae0NomWOiGoOi2N
ojFZ[_oAd]802Oo^k^h004Sooooo00_onOWioo?clooYjNWoZ:RXofEUIOmcLg?oSHf=ok^k^ooDe=Co
f][JomgMg@02omoOg`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;o
hN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;o
hN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00KohN7Q00koh>3PomoOgooMgMgog=cLomGEeOni^KWo
SXj>og]kNom^KVkoZj^[onWYjOoclo?onOWioogmo@gooooo00ooeMKFoj2X/?n2U:?oBV:8o`0RJol1
;7So74RAofR:^onI/mCoY;cIojS1gOn[aMoo[<GPojk6h?n^an40=?n_b>804On_an;o[/KQojo8h_n]
a^3o[<GPoj[2g_nW_mcoVK?Eof26^_lJBI;o1cB0o`0YLom:I8[oPYBSoj2X/?oEe]KomOGe00Wooooo
0018onk^kP0<on_[jooXj>Soh^;RomOGeon=SHgoHV9RogIfM_nTY:CoalO7om;Bd_oEeMGof=SH0_oJ
f]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooL
g=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg00Dom_KfooL
g=cog=cLom_KfooLg=cofm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGoW9bLogEeMOmWIfOoT92@omOGeooR
h^;oj>SXon_[joo]kNd=onk^kP0<on;Rh_nd]kWoS9NQogB<X?liCW[o01iWo`XcN_m5K:KoQ9o7oiZa
dOnO]MGoY;_H0_nX_]X00onX_m_oZ<3KojS0f`0cojS0f`0@ojW0fonX_][oYKgIojJlf?nS^MOoV[;D
ogjLaOlfGYko0Rijo`0SK_liD7goM8bPohbGXOnd]kWoh^;Rong]k@Wok^k^0018onKViP0>onGUiOoR
h^;ogmoOom[Jf_o9bLWoQhN7oeYJF_mkNg_oXj>Sokbl_?o6a/Kobl_;olg=cOo?cll2om7Ad@God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00?od];B
0_oAdM403Oo@d=3oclo?olc<c?o8b<So^k^koibLW?mbLW;oFe]KohZ:R_o9bLWof][JomoOgooRh^80
0_oUiND=onKViP0@onGUiOo:bl_oXJJ[oh2?W?m]PYSo>4Ygo`8IHolK>WooCVjTogBB_?n6XLGoSZK:
oi>Zc_nE[LooVK3?oiVacc?oV[7@00ooVK7?oiR`conI[looUZk?oi6Ybon9XlSoLHnkoceSWOl;;gOo
01USocQ=N?m]PYSoP8nLoj6VZoo:bl/00_oUiND9onKViP00B?o^k^h2ong]k@0>on[Zj_oXj>Soh^;R
omcLg?nLW9coKFe]ofQXJ?n3Ph?oUiNGoj>SXon/[:co[jn_ok6a/Onb/[82okBd]0;o][Jf0_nd];@0
1?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf
]?nd];Co];Bd0_nf][H2okBd]00CokFe]Onf][Co];BdokBd]?nf][Ko/k>cok:b/_nc/k?o[jn_ojZZ
Z_nLW9coPX:2of9RH_m^KVkoWinOomcLg?oRh^;oj>SXon[ZjP02ong]k@kok^k^013okNg]onGUiOo9
bL[oY:V^ohFCX?mfSZ;oBEb4ob0_JOlC:6ko;DJ5odEQV?mBL:CoH7b/of9o[omUPk3oHh:a<omXQk@0
4?mVQK;oIXBaofR4/OmSP:ooG7VZodQVW?lWA8Co221Yoa`_JOm9GHGoMXjRohFCX?nTZJkobLW:onGU
iOo]kNd:onk^kP00BOooool2ooknoP0?ooclo?oinOWom_Kfoo;bl_oIfMWoZ:RXoh>3Pom^KVkoIFEU
ofUYJOmbLW;oM7AdogUiNOmlO7coNg]k00;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01omlO7coNg]kogalO?mmOGcoO7alog]kNommOGd00_mjNWX02omgMgOoM7Adofm_KomdM7Co
QHF5ojRXZ?oJf][ol_;booKfm_oinOWoo?cl00;oo_kn4?ooool03oono_kom_KfomSHfOne^KgoU:2Z
oh:FZ?m]QJ3oC5n7oc=2LolP;V[o52IXoaH[KolM=7Go7cIgob<lO@0cobE0O`0?ob@lOOlU?7go93]i
oalfMolK;Voo8CA]oc=3M?m<GhKoKHJPoh:FZ?nDX:[o]KVmomSHfOofm_Koo_kn00_ooooo001:onk^
kP;okNg]00Cok>c/on[Zj_oXj>SoiNGU0_oRh^800ooPh>3ogmoOomkNgP0iomgMg@03omkNg_oOgmoo
h>3P00;oh^;R00CoiNGUonSXj?oZj^[ok>c/0_o]kNdBonk^kP0;ong]kOoUiNGoe=GEokJh^_nNY:_o
R9FPogn@XOmeTJOoM9B]og6C[_maTZh00omaTJd00omdSZKoLI6]og6A[@04og6A[@;oM8jV1_maTJd2
ogB>YPKoLI6]0_mdSZH6og6A[@;oM8jV1_maTJd2ogB>YPKoLI6]0_mdSZH5og6A[@0;og6B[_maTjko
M9B]ogFAYomoT:7oR9FPoijTZonf^;[oe=GEonGUiOo]kNd03?o^k^h004coi^KV0_oUiND00ooTi>Co
h^;Ron;RhP02on3Ph0;ogmoO>OoNg]h2omoOg`;oh>3P0_oRh^800ooTi>CoiNGUonGUi@0FonKViP07
onGUiOoMgMgocLk>ok6b]?nLXZOoRiNOohBCW`02oh6AX0?oP92O00?oS9JNohBBW_n0T9l00on0T9l0
1?n4TYkoS9JNohbFW_n4TYh4oh2@W`04ohBBW_n<UYkoS9JNohBBWPCoP92O00CoQ9:NohbFW_n<UYko
Q9:N1?n0T9l01?n4TYkoS9JNohbFW_n4TYh4oh2@W`04ohBBW_n<UYkoS9JNohBBWPCoP92O00CoQ9:N
ohbFW_n<UYkoQ9:N1?n0T9l2oh6AX007ohBCWon;UiooW::Wok6b]?o=c/kogMgMonGUi@0>onKViP00
ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00
ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00
ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00
oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00
9Oo^k^h00oo/k>coj>SXon[ZjP3Nonk^kP009?ooool01Ookno_ojn_[ol_;booWinOoo_kn0=gooooo
000Ponk^kP?okNg]00Koi^KVolk>c_nGUiOoShn?okJf]_o]kNgMonk^kP006ooVi^H03_oUiNGohn?S
on3Ph?oMgMgof][JomOGeooFe]Kodm?CokBd]?n4Q8Co_knoolO7aonYZJWoiNGUgOoVi^H001Wok^k^
017okNg]onWYjOoPh>3od];Bol30`?n][JgoWinOoiRHV?nEUIGoT92@ohb<S?oShn?ol?3`ol[:b_nZ
ZZ[oj>SXong]k@3Lonk^kP006?ooool03?okno_ok^k^om7AdOnZZZ[oShn?oiFEUOn][Jgoa/K6om3@
d?oBd];oemOGooGem@;okNg]00Gog=cLoi:BT_oCdm?ok>c/oo_kn`3Kooooo`005_o^k^h03_o]kNgo
iNGUol[:b_nJVY[oRXZ:ol;2`_o]kNgonOWiooKfm_obl_;okno_oo3`l?o^k^kok>c/0_o`l?001ooa
lO7ob<S8oh^;RonJVY[ob/[:onGUiOo]kNd0fOo^k^h001Goi^KV00WoiNGUom[Jf_nb/[;oQHF5olC4
a?ogmoOolo?cong]kOo^k^h00_o`l?001?ogmoOolO7aooOgmoobl_83oo7al@07oo?cloogmoOoa<C4
ohF5QOnb/[;of][JonGUi@3HonKViP005?o^k^h02?o]kNgoh^;Rok:b/_n?Shook>c/oo?cloo^k^ko
lO7a0_obl_801_o`l?3on?ShokRh^?mZJV[oWIfMooCdm0?ol_;b00SolO7aonk^k_oclo?ok>c/ohn?
Sonb/[;oh^;Rong]kCWok^k^00?od];BogEeMOoWinL0Voo^k^h001Cooooo00KonOWiol[:b_nGUiOo
n?Shono_koobl_83oo?cl`09oo;bl_oemOGojNWYofATI?mIFEWoE5ADolg=cOokno_olO7a00?olo?c
00Kol_;bono_koohn?SoUiNGol[:b_oinOTiooooo`03oo_knolM7AgoYJFU09_ooooo000Conk^kP05
ong]kOoBd];oSHf=oo3`l?o_knl01Oodm?@02Ooclo?omOGeoo3`l?maLG7oCTi>oe]KFooHf=Son_[j
oo?cl`05ooCdm005ono_koo`l?3oSHf=om;Bd_o]kNd0;oo^k^h00ooShn?of=SHonk^kP07onk^kP03
oh61POli>CWok^k^00Gok^k^00?og=cLomoOgoo^k^h01?o^k^h00oo[jn_ogmoOonk^kP09onk^kP;o
hN7Q1Oo^k^h00ooLg=cok>c/onk^kP02on?Sh`?ok^k^00?oeMGEonc/k?o^k^h01Oo^k^h2on7Qh@oo
k^k^00?ohn?SomSHf?o^k^h00oo^k^h00ooZj^[of=SHonk^kP1Aonk^kP004ooVi^H01OoOgmooWYjN
olc<c?oemOGom?Cd00KomOGe00Oom?Cdoo_knooFe]KoUiNGol;2`_ojn_[om?Cd00KomOGe00Gom?Cd
ooGemOo<c<coWYjNomoOg`0NonKViP03odI6A_mXJ6Soi^KV00Coi^KV00Go:RXZoeEEEOoVi^Ko>CTi
og9bLP03onKViP06om3@d?m2@T;o0P82oalO7olD51Co[Zj^1_oVi^H00on3Ph?o0000ol71`@03onKV
iP06olG5aOl_;boo30`<o`X:2_lc<c?oa/K60_oVi^H01_n/[:co61PHo`H61_m9BDWoN7Qhob/[:`Ko
i^KV00Go8B4Qo`h>3_lL71coADE5omgMg@02onKViP0>odU9BOl71`Oo5aLGohb<S?lA4A7oCTi>onKV
i_nn_[ko8B4Qoa/K6onWYjOoi^KVocTi>OmbLW82onKViP05ob4Q8Ol>3Pko71`LodE5AOoMgMd00_oV
i^H00om_Kfoo>c/konKViP02onKViP0AocTi>OmbLW;oi^KVonKVi_o@d=3o@T92o`820_lO7aoo51@D
ojj^[_oVi^KoXj>So``<3?l10@7o:2PXohB4Q?l?3`l00_oVi^H00on7QhOo92@TonKViP1:onKViP00
4oo^k^h01?oFe]KoTI6AooWinOobl_88ooKfmP05ooGemOolo?cod];Boo?cloohn?P02?ofm_H01?ob
l_;onOWioi6ATOoFe]HNonk^kP03ojRXZ?lC4a?oj>SX00?ok^k^00Ko_Kfmo`000?nf][Kok^k^oc/k
>omfMWH3onk^kP06oclo?olk>c_od=3@onk^k_oRh^;ohN7Q1_o^k^h00ol[:b_o20P8ofUYJ@02onk^
kP03ong]kOl`<33oC4a<00;og]kN00[oCdm?oc4a<Oo]kNgok^k^odi>C_mCDe?oi^KVoi>CTol>3Pko
;2`/1_o^k^h03?nc/k?oj^[Zong]kOlb<S;oR8R8onk^k_nh^;So0`<3olk>c_oFe]KoE5ADo`l?3`;o
k^k^00?oJFUYoc`l??o]kNd00_o^k^h02Olk>c_oMWIfonk^k_o^k^ko/k>con[Zj_o]kNgo<S8bohR8
R002onk^kP03og=cLolm?Cgok^k^00;ok^k^017o>c/kogIfM_o^k^kok^k^oclo?olk>c_od=3@onk^
k_oRh^;ohN7Qonk^k_l_;booE5ADomgMgOnl_;co:RXZo`l?3`02onk^kP03omGEeOnl_;cok^k^04[o
k^k^000Booooo`05ookno_o8b<So_;bloo[jn_ofm_H01oogmoL01oofm_KonOWioo;bl_mRHV;oc/k>
oooooooemOD01oogmoL01Oofm_Kon_[jokbl_?o8b<Soo_kn01gooooo00?oo?cloa`L7?mbLW800onJ
VYX01_m9BDWo:2PXoooooooooooo@410ogmoO`;ooooo00?ogMgMo`000?nh^;P02Oooool02Oo<c<co
0@41oinOWolC4a?on?ShoooooooHf=So0000okNg]`02ooooo`06okNg]ol0003og=cLooooool/;2co
T92@0_ooool00omjNW[o<30`ooooo`07ooooo`0:olG5aOlF5QKoTi>CoooooooIfMWo0`<3okfm_Ooo
ooooWinOob0P80;ooooo00?oCDe=og9bL_ooool00_ooool00om0@43oOgmoooooo`03ooooo`03olG5
aOlF5QKoTi>C00;ooooo00?oO7alod92@_ooool00_ooool01_m0@43oOgmooooooooMgMgo0000okRh
^0Cooooo00?oj>SXo`410Oo5aLD00_ooool01_n[Zj_o4A4Aooooooooooooc<c<oiJFUT_ooooo000B
onk^kP04on_[jonSXj?oh>3PooKfmPSon?Sh00OomoOgoogmoOoVi^KoFUYJol30`?oooooom_Kf00So
n?Sh00Com_Kfon3Ph?nSXj?ojn_[7_o^k^h01omfMWKo3Ph>of5QHOmQHF7oEUIFo`000?n1PH400_o^
k^h01olk>c_oMWIfonk^k_o^k^ko/K6ao`000?lh>3P00olj>SX00onf][Kok^k^onk^kP03onk^kP09
of9RH_ll?3cok^k^obDU9OnIVIWok^k^ok6a/Ol0003oe]KF00;ok^k^00Koe=CDo`000?nd];Cok^k^
obTY:On9RHT2onk^kP03ohF5QOl/;2cok^k^00Gok^k^00Goe=CDodE5AOl20P;oJFUYonGUi@02onk^
kP05oj6QXOl^;Rko;bl_oc8b<_lM7Ad00_o^k^h00om7AdOoJVYZonk^kP02onk^kP09oc/k>omfMWKo
k^k^onk^k_oDe=CoADE5o`820_mYJFWoiNGU00;ok^k^00?oLg=cocdm?Oo^k^h00_o^k^h01_lk>c_o
MWIfonk^k_na/K7o0000ocPh>0?o>SXj00Co][Jfok>c/ol0003oe]KF0_o^k^h01_nPX:3o3`l?onk^
k_o^k^koYJFUoaTI6D_ok^k^000BonKViP04on;Rh_nEUIGok^k^ooKfmPSon_[j00Oon?ShoooooooF
e]KoD51@ojb/[?oooooomoOg00Son_[j00Com_Kfonk^k_nEUIGoh^;R7_oVi^H01oo:b/[o0P82olO7
aooVi^KoSHf=o`@41?oCdm<00_oVi^H02oli>CWoGUiNonKVi_oVi^KoaLG5o`000?nJVY[o^[Zjok>c
/ol20P;oc/k>00Coi^KV00[ogMgMo`d=3OnBTY;oi^KVoh61POlg=cOoi^KVolK6a_l0003oXZ:R0_oV
i^H01_nPX:3o0000ol[:b_oVi^Ko9bLWohB4Q0;oi^KV00?oP820ob/[:ooVi^H01OoVi^H00olj>S[o
>c/kolG5a@06onKViP03onCTi?n5QHGo7AdM00;oi^KV00?oADE5ofIVI_oVi^H00_oVi^H01oli>CWo
LW9bonKVi_oVi^Ko>SXjoc/k>oo5aLD01?oVi^H00om_Kfoo>c/konKViP02onKViP0=ocTi>OmbLW;o
i^KVolG5aOl0003oVYZJokZj^_nc/k?o0P82olk>c_o:b/[o0000oj2PX002onKViP07oi^KVol?3`oo
i^KVonKVi_oLg=co820PojVYZ@1:onKViP004_o^k^h01?oZj^[oV9RHono_koogmoL8oo_kn`07ooWi
nOoooooo`L71oda<C?nHV9SoooooooWin@08oo_kn`04ooOgmoo_knooV9RHon[ZjQook^k^00GoADE5
og1`L?o^k^ko=3@dode=C@03onk^kP0:oc/k>olA4A7oQhN7omCDe?o/k>co>SXjof=SHooVi^KoTi>C
obPX:0Gok^k^00koV9RHo`d=3OoTi>Cok^k^omkNg_l820Sob<S8onk^k_ll?3co@d=3olo?coo>c/ko
@T92oclo?`;ok^k^00Ko:BTYohV9ROo^k^kok^k^ohF5QOl/;2`6onk^kP05oc<c<on<S8cok^k^omSH
f?oYjNT00_o^k^h03_nXZ:Sobl_;on_[jomJFU[oCTi>onk^k_oXj>SoA4A4ofEUIOoShn?oj^[Zonk^
k_lk>c_oMWIf0_o^k^h03_lc<c?oS8b<onk^k_oHf=SojNWYonk^k_oYjNWoKVi^ocXj>_oShn?ojNWY
onk^k_lk>c_oMWIf0_o^k^h01Olj>S[oHf=SonKVi_nCTi?o:2PX00;ok^k^00Ko?Shnod51@OoCdm?o
fm_Koda<C?l?3`l3onk^kP03okjn__lF5QKo_[jn04Wok^k^000Booooo`04ooclo?n[Zj_ojn_[ooWi
n@Soo?cl00OonOWioooooon[Zj_oD51@oh>3Pooooooono_k00Soo?cl00ConOWion_[jon[Zj_oo?cl
7oooool01On_[joo61PHolk>c_l0003o]kNg00?ooooo00[oE5ADohV9ROmMGEgo2@T9oo3`l?oVi^Ko
AdM7o`d=3OlL71co]kNg1Oooool00omJFU[oLG5aooooo`02ooooo`05ofa/K?n5QHGoooooonSXj?mB
DU800_l?3`l01_mDE5CojNWYoooooooooooo@d=3oijNWP;ooooo00?oVi^KodI6A_ooool01Oooool0
1Ono_koo>SXjoa0@4?lC4a?oj>SX00;ooooo00koRXZ:oc8b<_l@413o>CTiolC4a?ooooooOgmoo`P8
2?l<30co6a/Kojj^[_ooooooE5ADohf=S@;ooooo00ko_knoocXj>_l@413o4a<ConSXj?ooooooShn?
o`d=3Ol71`Oo6a/KoiJFU_ooooooE5ADohf=S@;ooooo00Goi^KVodM7Aol=3@go71`LokNg]`02oooo
o`06onKVi_m4A4Co30`<obPX:?m]KFgo4A4A1?ooool00on;Rh_o6ATIooGem@18ooooo`004_o^k^h0
1?o]kNgo];Bdom?Cdoolo?`8oogmo@08oo_knoooooooU9BDoeEEEOmcLg?om_Kfooooooolo?`7oogm
o@04ooclo?oCdm?o];Bdong]kAook^k^00Goj^[ZoaHF5_lV9RKo6a/Kong]k@06onk^kP05on_[joo^
k^kok^k^onk^k_o[jn/04Oo^k^h2ong]kA;ok^k^00?ojn_[onk^k_o^k^h01?o^k^h00oo/k>cok^k^
onk^kP02onk^kP03odM7AomZJV[ok^k^00Sok^k^00?ojn_[onk^k_o^k^h00_o^k^h00omfMWKo?3`l
onk^kP08onk^kP03on_[joo^k^kok^k^00Cok^k^00Cok>c/onk^k_nPX:3o3`l?1?o^k^h00oo2`/;o
0000olS8b018onk^kP004ooVi^H01?o:b/[oXZ:Rooooooolo?`8ooknoP07oooooon0P83oG5aLofEU
IOoXj>Sooooooogmo@06ooknoP04ooclo?ooooooXZ:Rol[:bR7oi^KV00?oKVi^o`000?maLG40?OoV
i^H00oo:b/[ob<S8onKViP02onKViP03oe9BD_n3Ph?oi^KV00Soi^KV00?oYZJVoa/K6ooVi^H00_oV
i^H00omBDU;oPh>3onKViP0<onKViP08oi^KVol?3`ooi^KVofa/K?meMGGoS8b<ocHf=_lg=cM9onKV
iP004oo^k^h01?oWinOoVi^Konk^k_ojn_X6ooknoP09oogmoOoooooom?Cdofm_KomRHV;oGEeMomGE
eOooooooo?cl00Koo_kn00Con_[jonk^k_nKVi_oinOW8Oo^k^h00ooGemOoShn?omSHf012onk^kP03
ojRXZ?no_kook^k^00Sok^k^00Ooj>SXod10@?lP823o6QXJolS8b?nXZ:So_kno00gok^k^00SoX:2P
o`l?3oo^k^ko/;2`ogYjN_mTI6CoWYjNon3Ph4Wok^k^000Dooooo`04om[Jf_nYZJWooOgmooclo0Go
oooo00Woo_knoooooooUiNGoHf=SofIVI_mIFEWo`<30ooooooolo?`01Oooool01?olo?cooOgmojVY
ZOoJf]Ydooooo`03onWYjOo^k^kooooo00oooooo00?oo_knoo[jn_ooool0C_ooool001Cok^k^00Go
j^[Zojn_[oo6a/Koo_knooclo004ooooo`09oogmoOoooooog]kNoe]KFomYJFWoEEEEokFe]Ooooooo
o?cl00Cooooo00Goo?clookno_o6a/Ko[jn_on[ZjP3Gonk^kP005OoVi^H01_oLg=coWinOol[:b_oo
oooono_kooknoP;ooooo00Woo_knoooooookno_oPX:2oeIFE_mXJ6Sohn?Sooooooono_h00_ooool0
1_ono_kono_kooooooo:b/[oWinOomcLg=Soi^KV000Fonk^kP07on?ShonZZZ[o[Zj^ooOgmoomoOgo
no_koogmo@03ooooo`03ooGemOoAdM7oj^[Z00?ooooo00OooOgmoo_knoomoOgomoOgojj^[_nZZZ[o
hn?S0=Wok^k^000Gooooo`0EooWinOo?clooWinOolg=cOoinOWooooooogmoOokno_on_[jooclo?oo
oooooOgmoo[jn_okno_ooOgmoooooooinOWocLg=oinOWoo?cloonOWi0=[ooooo000Honk^kP08ong]
kOoOgmoo]KFeoiNGUon^[Zkof][Joo7alOojn_X3ooclo008oo[jn_oalO7of][Jojj^[_nGUiOo]KFe
omoOgoo]kNgKonk^kP006_oVi^H01_oUiNGog=cLolK6a_nZZZ[oV9RHoi>CT`?oTI6A00KoTi>CoiRH
V?nZZZ[oa/K6omcLg?oUiNGMonKViP007Oo^k^h02Oo]kNgoj^[ZonKVi_oShn?oh^;Ron?ShooVi^Ko
j^[Zong]k@3Ponk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^
kP00ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7oooo
o`00ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^
kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKV
iP00oomoOgl7ogmoO`0000Cojn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP0KomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oMgMgog=cL00;ogMgM017og]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNgP02omgMg@2oomcL
gOoMgMgogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oMgMgog=cLomgMgOoLg=cogMgMomcLg?oNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMd00ooNg]h00ooMgMgog]kNomkN
gP03omgMg@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>001ooIfMT01?oHf=Soe]KFom?Cdoo@
d=03olg=c@04om3@d?oCdm?oemOGomSHf0cofMWI00Wof=SHomOGeooEeMGoe=CDom?CdooDe=CoeMGE
omOGeooHf=P03OoIfMT02OoHf=SoemOGomGEeOoDe=Codm?ComCDe?oEeMGoemOGomSHf00YomWIf@?o
f=SH00GoemOGomKFe_oDe=Coe=CDomKFeP03omSHf0OofMWI0ooHf=P3omWIf@;of=SH1_oIfMT2omSH
f0KofMWI0ooHf=QVomWIf@03omSHf?oIfMWofMWI00KofMWI0OoNg]h1onKViP7ok>c/00001oo^k^ko
jNWYonCTi?oPh>3ohN7Qon3Ph?oRh^800_oQhN403OoNg]kog=cLom?Cdoo7alOo^k^kok:b/_n^[Zko
/[:bok^k^oo7alOodm?Com_KfooOgml02OoQhN403OoPh>3ogmoOom_KfooFe]Kod];Bolk>c_o<c<co
c/k>om;Bd_oFe]Kofm_KomoOgooPh>002OoQhN403OoPh>3ogmoOom_KfooFe]Kod];Bolk>c_o<c<co
c/k>om;Bd_oFe]Kofm_KomoOgooPh>009OoQhN42on3Ph008omoOgooMgMgog=cLom[Jf_oHf=Soe]KF
omSHf?oKfm/6omoOg`?oh>3P00?ogmoOomkNg_oNg]h00_oOgml01OoPh>3ogmoOomoOgooNg]kogmoO
00Coh>3P0ooOgml00ooPh>3ogmoOon3Ph003on3Ph004omoOgooNg]kog]kNomoOg`?oh>3P00?ogmoO
on3Ph?oPh>001OoPh>1Lon7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoTi>@1onWYj@7okNg]00000oo`
l?3okno_oo7al@03oo3`l00Hono_koo`l?3ok^k^onWYjOoKfm_o`L71ojBTY?n<S8coNg]kogMgMomk
Ng_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7a0_o^k^h0
5?oVi^Kog]kNom7AdOo9bLOo`L71okno_oo1`L7obLW9om7AdOoNg]koi^KVonk^k?o^k^kolO7aono_
kooalO7okno_oo7alOo_knoolO7_0_o^k^h02ooVi^Kog]kNom7AdOo9bLWo`L71okno__o1`L7obLW9
om7AdOoNg]koi^KV00;ok^k^02?olO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7al@02onk^kP0=onWYjOoXj>Soi>CT
onCTh_oPh>3ogmoOon3Ph?oVi^KojNWYon_[jooWinOoj>SVonKViP02onWYj@0?onk^k_o]kNgok^k^
onSXj?oXj>KoiNGUonWYjOoZj^[okNg]on[Zj_oYjNWoi^KVonWYiooZj^[okno_00;okNg]00GoinOW
onWYjOoZj^[okNg[onWYj@02onc/k007onk^k_oYjNWoj>SXonGUiOoXj>Koj>SXonk^kP02ong]k@1Z
onWYjOo]kNgokNg]onk^k?oZj^[ok>c/ong]kOo`l?3okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7ol?3`ono_koo`l?3okno_oo3`l?o_knool?3`
ono_k`Col?3`00000oobl_;ok^k^onOWi`04onGUi@0@onCTi?oOgmoodM7Aok6a/On:RX[oIVIVoe5A
DOm5ADGo@T92odE5AOmADE7oIVIVohZ:ROna/K7odM7AomkNgP;oi>CT00_oiNGUonCTi?oUiNCoi>CT
onGUiOoRh^;og=cLolo?coo1`L7o/K6aojVYZ003ojBTY00mojVYZOna/K7o`L71olo?cooLg=_oh^;R
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oRh^;og=cLolo?coo1`L7o/K6aojVYZOnTY:CoY:BS
ojBTY?nYZJWo/K6aol71`Oo?cloog=cLon;Rh_oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi002onCTi00>on7QhOoNg]kof=SH
omKFe_oEeMGoe=CCom;Bd_o=cLgoQHF5odM7AooEeMGofm_KomGEeOoEeM@2omGEe@0HomKFe_oMgMgo
gmoOomcLg?oFe]KoeMGDomKFe_oJf][og=cLomoOgooKfm_ofMWIomGEeOoGemKof][Jon3Ph?oOgmoo
g=cLomKFe_oIfMWog=cLomcLfooHf=Sog=cL0_oNg]h03ooHf=Soe]KFomCDe?oEeMCoemOGomcLg?oO
gmoog=cLomSHf?oLg=coh>3PomoOg_oIfMWofm_KomoOg`02onCTi01JonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT1?oUiND01_oTi>CoiNGUonGU
iOoUiNGoj>SXong]k@7ol_;b00000oodm?CokNg]onOWi`02on3Ph00Con7QhOoOgmoog]kNom;Bd_nd
];CoQhN7oeaLG?m]>cGoWTi2ole_GooYPfoocFmOoii>@om]>cKoG5aLohN7Qond];Cod];BomkNgP05
on3Ph00AomoOgooJf][oc/k>okbl_?n[Zj_o/;2`olO7aooIfMWoi>CTomWIfOo7alOo/K6aoj^[Zonl
_;coc/k>om[Jf_oOgml01OoPh>004OoOgmoof][Jolk>c_nl_;coZj^[ok2`/?o7alOofMWIonCTi?oI
fMWoalO7ok6a/On[Zj_o_;blolk>c_oJf][ogmoO027oh>3P02Gog]kNom[Jf_oCdm?od=3@om7AdOnf
][Ko[:b/og5aLOlH61So=CDeogQhN?o7alOod];Bolo?coo3`l?odM7Aolg=cOo>c/koe]KFomSHf?oB
d];oclo?ol_;bono_kooemOGom[Jf_oKfm_ofMWIomGEeOo0`<3od=3@om7AdOoHf=SofMWIom?CdooA
dM7o`<3000;oemOG00CodM7Aom?CdooHf=SoeMGE0_o@d=003_nm_KgocLg=om3@d?oCdm?of=SHomGE
eOoAdM7oeMGEom_KfooHf=SodM7Aom;Bd_oIfMWog]kNF_oPh>000ooOgmooh>3PomoOg`02omoOg`?o
h>3P00?ohN7QonOWioo/k>`00Oodm?@00003ooKfm_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgo
WinOof]OGon?=RkokG5QooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=cOoRh^;o
inOW00Coj>SX00Ooi^KVomgMgOo:b/[o]KFeokno_ooWinOokno_00?ol?3`00Ookno_onWYjOo1`L7o
]KFeol[:b_oMgMgoi^KV00Goj>SX00Ooi^KVomgMgOo:b/[o]KFeokno_ooWinOokno_00?ol?3`00Oo
kno_onWYjOo1`L7o]KFeol[:b_oMgMgoi^KV023oj>SX01?oinOWonGUiOoNg]koe]KFohf=SOl?3`oo
71`LoalO7ol0003oOGemomSHf?oMgMgog]kNokBd]?lO7aoo10@4oc/k>on3Ph?o51@D00;ogMgM00co
cLg=oeQHF?l30`?o71`Loa8B4_n<S8coi>CTogIfM_l:2P[o820PobHV9_nNWYh2omoOg`0Iok^k^olS
8b?o6ATIoinOWooNg]ko8R8RohF5QOoMgMgofMWIoi2@T?l@413o5QHFo`@41?mPH63odm?ComgMgOo5
aLGo0000okjn__oRh^;ogmoOoclo?omYJFWohN7QonKViP1SonSXj07ok>c/0Oobl_81ooKfmP0000?o
moOgooShn?ohn?P00oohn?P04oogmoOok^k^olk>c_n@T93oQBl[onUTE_okTXOooZJKoojaYOoo^:_o
o[>VoojXW?okU8WokVQIohTa:on@T93oc/k>onk^k_ogmoL01?ohn?P01_odm?CoinOWolo?coo6a/Ko
j^[ZooCdm0;onOWi00Won_[jooWinOoinOWom_Kfon_[joo7alOoclo?onOWioodm?@01Oohn?P01_od
m?CoinOWolo?coo6a/Koj^[ZooCdm0;onOWi00Won_[jooWinOoinOWom_Kfon_[joo7alOoclo?onOW
ioodm?@08?ohn?P0??ogmoOom?Cdonc/k?nHV9So2@T9ojj^[_ofm_KomoOgokjn__lF5QKoSXj>on[Z
j_o/k>coIVIVoclo?ooXj>SoYZJVoa@D5?lF5QKok>c/on_[jomVIVKo8B4Qokjn__oWinOoh^;RomgM
gOobl_;oa/K6omOGeooVi^KoTY:BobPX:?obl_;okno_og=cLole=CGol?3`ooCdm?o_knoo92@Tohn?
Soo/k>co`l?3o`<30onBTY;ol_;bolK6a_lI6AWoPX:2onc/k?oCdm?o0000ol[:b_obl_;okno_od=3
@om`L73olO7aooKfmUcon?Sh00?omoOgooShn?ohn?P00_ohn?P01?ogmoOonOWiooOgmoogmoL1ooSh
n00000?on_[jooGemOo^k^h00_o/k>`08Oo[jn_ojNWYomoOgonj^[[oNE9Boklb9?oWM6WooHUnoonH
S?onXYKoojRLoojTV?ooVXgooXYoonifJ_o3<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/on_[
jooVi^Kof=SHok^k^ooDe=Coi>CTon_[jooalO7ol_;boo?cl`02oo;blP06ong]kOoUiNGoeMGEok^k
^ooHf=Soi^KV0_o[jn/03?o/k>cojn_[on_[jooVi^Oof=SHok^k^ooDe=Coi>CTon_[jooalO7ol_;b
oo?cl`;ol_;b00KokNg]onGUiOoEeMGo^k^komSHf?oVi^L2on_[j`0aonc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/on_[jooVi^Kof][JoaTI6Om<
C4coi^KVon_[jooZj^_oj>SXoh>3Pol:2P[ofMWIomoOgolo?cooJFUYon?Si?oUiNGoPX:2oaDE5@02
omoOg`20o`T92OmkNg_of][Kom_KfooIfMWoh>3Pon?ShooPh>3of][Jolo?com=CDgo9RHVonOWiooS
hn?oCDe=oeeMGOoRh^;oj>SXon7Qh_lR8R;oQhN7on3Ph?maLG7o3`l?omgMgOoUiNGoh>3QoeEEEOl_
;boohN7QolO7aol0003o_Kfmon;Rh_oOgn3o@410of][JooVi^KojNWYonc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>`7on_[j`05onc/k?o[jn_ojn_[onk^
k_ofm_H00OoinOT00003oo_knooclo?okNg]00;oiNGU01ooi^KVonCTi?oIfMWo/[:bogT^;_o8@SCo
hfYLooAjKOomR7cooYN:oojKS_onV8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;of=SHonCTi?oUiNGo
i^KVonGUi_oUiNGogmoOom7AdOnf][Koe=CDomgMgOoTi>Coi^KW00?ok>c/00Ooj>SXonCTi?oOgmoo
eMGEokJf]ooAdM7ogmoO00;oiNGU01Coi^KVonGUiOoUiNGogmoPom7AdOnf][Koe=CDomgMgOoTi>Co
i^KVonc/k?o/k>gok>c/onSXj?oTi>CogmoOomGEeOnf][KodM7AomoOh0;oiNGU03Goi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoiNGUon7QhOnh
^;So0000ohB4Q?oPh>3oiNGUonCTiOoQhN7o`L71o`000?na/K7ofm_Kocdm?OmYJFWog]kOon3Ph?n@
T93o51@DomcLg?o:b/[o0000obd];@03ocLg=`1lohn?SooNg]kofMWIogUiNOl:2P[o;2`/okJf]_oP
h>3og=cLodY:B_mKFe_ofMWIomoOgooLg=co8B4QohB4Q?oMgMgoFEUIocHf=_oEeMGofMWIomKFeomh
N7So5QHFomkNg_o3`l?o0000okJf]_oGemOoeMGFochn?_mXJ6SohN7QonCTi?oVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUi@;oi^KV00?oiNGUonKV
i_oVi^H00ooVi^H00ooUiNGokNg]ooCdm001oo_kn`0000?oo?clooShn?oalO400oo^k^h04oo[jn_o
hN7Qokbl_?mj5aOo`clbom=FBOoTJ5[okgM/ooB3NOohQgcomHAjoo=iKOoUJE_ofEQ:ol@o<_ml5aOo
_;blon7QhOo/k>`00oo^k^h02?o]kNgojNWYom[Jf_ni^KWoemOGomkNg_oShn?oi^KV0ooZj^X02?oX
j>Soi>CTomkNg_oHf=So^KViom[Jf_oYjNWokNg]0oo^k^h02?o]kNgojNWYom[Jf_ni^KWoemOGomkN
g_oShn?oi^KV0ooZj^X02?oXj>Soi>CTomkNg_oHf=So^KViom[Jf_oYjNWokNg]7oo^k^h01_o]kNgo
jn_[oj:RX_l0003o_[jnonKViP;ojn_[00Ooi^KVom_Kfol0003oS8b<onGUiOm0@43oKVi^00;ojNWY
00KoV9RHoaDE5OoWinOoinOWo`L71omjNWX2okJf]P0=oaXJ6_nZZZ[oj^[Zoi^KVol=3@goUiNGomoO
gooVi^KoinOWon;Rh_m=CDgoGEeMomoOg`02onGUi@06ob<S8on;Rh_oj>SXogUiNOl=3@gogMgM0_oO
gml01_mBDU;o<c<conWYjOo=cLgo0000oj>SX`;ogmoO00Co?3`lofi^K_o[jn_okNg]H_o^k^h00oo]
kNgol_;booShn001ooclo0000oomoOd05_olo?cooOgmoogmoOolo?colo?com7AdOmX1`Oo^3@dolLo
<ooBD4?ofV9Eon=^H_oTLVCoi6mRomaTEooCDD?oc44dokTd=?m[1`Ood];Boo?cloolo?`4oogmo@07
ooWinOo/k>co^;Rhom_KfooQhN7oiNGUonWYj@02onc/k008ong]kOoZj^[oiNGUon;Rh_oKfm_o^KVi
onc/k?oinOT5oogmo@07ooWinOo/k>co^;Rhom_KfooQhN7oiNGUonWYj@02onc/k008ong]kOoZj^[o
iNGUon;Rh_oKfm_o^KVionc/k?oinOTPoogmo@06ooclo?okno_o`<30o`000?o5aLGol?3`0_oemOD0
1oo`l?3o`l?3o`000?nVYZKon?ShodA4A?mgMgL00_okno/0:OnTY:Co5QHFoo[jn_okno_oIfMWodI6
A_oUiNGo`<30o`P82?oclo?ono_koibLW?lb<S;ol?3`onk^k_oTi>ConOWionk^k_m?CdooH61PonSX
j?oclo?omoOgobDU9OnDU9ConOWiomcLg?l71`OoQHF5on[Zj_nc/k?o4a<CoiVIVOokno_ogmoOo`00
0?lU9BGoZJVYom3@d?lB4Q;oYZJV00;oo?clH?omoOd00oolo?cooOgmooclo003oogmo@0006CooOgm
oo[jn_oclo?ok^k^oo3`l?o_knook^k^onWYjOoCdm?oFadMoj8d=?nd:1go`CX]olM9??o?ET[od5M;
om1GB_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_ono_koo^k^kohn?S
ojb/[?o:b/[od];BomOGeooJf]WogMgMomkNg_oMgMgog=cLomOGeooDe=Cob/[:ojb/ZooShn?ok^k^
ono_koo`l?3okno_oo3`l?o_knook^k]on?Shon/[:cob/[:om;Bd_oGemOof][JomgMgOoNg]gogMgM
omcLg?oGemOoe=CDol[:b_n/[:cohn?Sonk^kOo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_0_o_knl05OoLg=co0P82oi6ATOoPh>3o
hN7Qon;RhOoPh>3oOGemo`000?o6a/KokNg]oe=CDomnOWkokno^onk^k_nVYZKo:b/[ono_koo^k^ko
i>CToeMGE`02oa0@400Hohf=SOo^k^kokno_onSXj?mDE5Co61PHo`/;2on0P83ok^k^ogemOOl820So
2PX:oaTI6OnJVY[ojn_ZocPh>?nGUiOok>c/ono_kona/K7o:b/[o`T92OlI6AWoOgmo0_o^k^h0I?oH
f=So6ATIokRh^?lo?coo2@T9ode=COoVi^Kok^k^oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knl2oo3`l0Kokno_0Ooclo<1ooWin@7o
o_kn00000oono_komoOgoo3`l004onWYj@0AonOWiooKfm_oHd];oh4b<_nV=CGo]S@]ol9=@Oo3E4Wo
a5E:ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooWinL01OoYjNT01_oXj>Sohn?Soj^[Zoni^KWo
bLW9olo?c`;oeMGE00Woe]KFomGEeOoDe=Coclo?olS8b?ni^KWoZj^[on?ShooXj>P01OoYjNT01_oX
j>Sohn?Soj^[Zoni^KWobLW9olo?c`;oeMGE00Woe]KFomGEeOoDe=Coclo?olS8b?ni^KWoZj^[on?S
hooXj>P08OoYjNT2onSXj003oeiNG_lW9bOod];B00;ogMgM00Gof=SHoc4a<Om5ADGoinOWonSXj00:
onWYj@03onOWiooYjNWojNWY00CojNWY00?oinOWonWYjOoYjNT00_oXj>P02Om>CTkoGemOonSXj?oX
j>SoiNGUon;Rh_oShn?oi^KVonSXj002onWYj@03onKVi_oYjNWojNWY00KojNWY00?oj>SXonWYjOoY
jNT0G_oYjNT00ooXj>SojNWYonWYj@04onWYj@7ol?3`0OogmoL1ooknoP0000Goo_knoo[jn_odm?Co
kno_oo7al@02oo3`l00Aono_koo[jn_oUIBDodlS8onEE5Co^g=com>EUOoJW9cofYjLomVLW?oDUIGo
^g=coiEDE?m?8b?oUIBDon[Zj_o_knl01_o`l?001_o^k^kobl_;ojNWYoo8b<Sof=SHon?Sh`?oi^KV
00Kohn?SomSHf?o8b<SoYjNWol_;boo^k^h7oo3`l006onk^k_o;bl_oYjNWolS8b?oHf=Sohn?S0ooV
i^H01_oShn?of=SHolS8b?nWYjOobl_;onk^kR?ol?3`00[okno_omkNg_lm?Cgo9RHVogYjN_n0P83o
<30`obh^;_oBd];okno_5_o`l?000oo_knooe=CDolo?c`02ono_k`03onk^k_m0@43oW9bL00;okno_
LOo`l?001?oalO7ol?3`ooCdm?ojn_X1ooknoP0000Coo_knooooooooooooo_kn0_ooool2ooknoP3e
oogmoOohn?SoKVi^oeXo?onaT93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSloofe]KOohn?Soo?cl
ooooooono_koooooookno_ooookoo_knooooooomoOgoo?clolG5aOnj^[[ogMgMoo7al?ohn?SonOWi
ooShn?oalO7ogMgMokZj^_o5aLGoo?ckoogmoOooooooo_knooooooono_koooooookno_ooookooOgm
ooclo?o5aLGo^[ZjomgMgOoalO7on?ShooWin?ohn?SolO7aomgMgOnj^[[oaLG5ooclo?omoOgoooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_kooooooo_knon/[:coN7Qhog=cLonSXj?on?ShoogmoOooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koo_kmojRXZ?oFe]KooOgm
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooooono_h00_ooool00oono_koooooooooo`03ooooo`7ooOgm00001?ohn?So
o_knoo[jn_odm?@5oo7al@0=ono_kooFe]KoJf][od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<od<m?Om[
Jf_oe]KFono_k`09oo7al@0=oo3`l?oVi^Ko_Kfmok2`/?o?cloogmoOonGUiOoOgmooclo?ok2`/?nm
_Kgoi^KVoo3`l009oo7al@0=oo3`l?oVi^Ko_Kfmok2`/?o?cloogmoOonGUiOoOgmooclo?ok2`/?nm
_Kgoi^KVoo3`l02hoo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_ono_h00Oohn?P0
0005on_[joomoOgon?Shoo3`l?o[jn/00ooZj^X03OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUIFOlV9RKo
2@T9obHV9_mIFEWoVi^KonSXj?oYjNT03?oZj^X02OoYjNWob/[:ok6a/OnMWIgoTY:BoifMWOna/K7o
b/[:onWYj@0=on[ZjP09onWYjOo:b/[o/K6aoifMWOnBTY;oWIfMok6a/Oo:b/[ojNWY0<7oj^[Z00Co
jn_[oo3`l?ohn?SooOgm0Oo[jn/00004olO7aoomoOgon_[jooCdm0SolO7a0_o`l?03ono_k`;ol?3`
4OoalO43oo3`l1?olO7a0oo`l?30oo7al@03oo3`l?oalO7olO7a00;olO7a00?omOGeoo[jn_ono_h0
0Oo6a/H00003olK6a_o3`l?on_[j0?oooooo0Oooool1ooWin@7o`l?30Oo6a/H00006om_Kfono_koo
]KFeonOWioogmoOooOgmn_ooool01OomoOgomoOgonOWionf][Ko_kno007ofm_K0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{262, 140},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    \( (*\ Yes\ No\ *) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]ShowConfirmDialog[
        frame, \[IndentingNewLine]JavaNew["\<java.lang.String\>", "\<Are you \
satisfied?\>"]]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(1\)], "Output"]
}, Open  ]],

Cell["Yes No Cancel", "Text"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004<0000LaP00`40o`00
0?l0003oo`0000d000000003R<2hB928B9280?m8T8P9B9280@00000000>8
`;S8h=R8`;P0ohS0^0R8`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<
c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1
000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8
h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7
c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B928
0@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2h
b>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<
1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0
^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<
c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h037<c<`boooo1lc<c3?o
ool7c<c<<oooobo<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h02o<c<`2
IVIV00?<c<aVIVIVIVH0;VIVIP03ooooc<c<c<c<00C<c<`00fIVI/c<c6IV
IP0`IVIV00?oooo<c<c<c<`01<c<c003IVIVc<c<IVIV031VIVH00oooolc<
c<c<c00]c<c<0HS0^058T8P1000000000hS0^<SPf8S0^00_c<c<<fIVIP03
ooooc<c<c<c<00C<c<`00fIVI_ooolc<c00_c<c<00=VIVKoooo<c<`01Lc<
c003IVIVooooc<c<02o<c<`00fIVI_ooolc<c00^c<c<0HS0^058T8P10000
00000hS0^<SPf8S0^00_c<c<0VIVIP03ooooc<c<c<c<02c<c<`2IVIV00?o
ooo<c<c<c<`01<c<c003IVIVooooc<c<02o<c<`00fIVI_ooolc<c005c<c<
00=VIVKoooo<c<`0;lc<c003IVIVooooc<c<02k<c<`1R<2h0DR@R0400000
0003R<2hb>3HR<2h02o<c<`2IVIV00?oooo<c<c<c<`02<c<c1^IVL`9c<c<
0VIVIP03ooooc<c<c<c<00C<c<`00fIVI_ooolc<c00_c<c<00=VIVKoooo<
c<`01Lc<c003IVIVooooc<c<02o<c<`00fIVI_ooolc<c00^c<c<0HS0^058
T8P1000000000hS0^<SPf8S0^00_c<c<0VIVIP03ooooc<c<c<c<00S<c<`0
0iVIc<c<c<c<c00Gc<c<00>IVLc<c<c<c<`01lc<c09VIVH00oooolc<c<c<
c004c<c<00=VIVKoooo<c<`0;lc<c003IVIVooooc<c<00G<c<`00fIVI_oo
olc<c00_c<c<00=VIVKoooo<c<`0;/c<c068`;P1B9280@00000000>8`;S8
h=R8`;P0;lc<c09VIVH00oooolc<c<c<c008c<c<00>IVLc<c<c<c<`05lc<
c003VIW<c<c<c<c<00O<c<`2IVIV00?oooo<c<c<c<`01<c<c003IVIVoooo
c<c<02o<c<`00fIVI_ooolc<c005c<c<00=VIVKoooo<c<`0;lc<c003IVIV
ooooc<c<02k<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h02o<c<`2IVIV
00?oooo<c<c<c<`02<c<c003VIW<c<c<c<c<00C<c<`00`000<c<c<c<c00@
c<c<00>IVLc<c<c<c<`01lc<c09VIVH00oooolc<c<c<c004c<c<00=VIVKo
ooo<c<`07/c<c080000?c<c<00=VIVKoooo<c<`01Lc<c003IVIVooooc<c<
00W<c<`300000lc<c0050000c<c<c<c<c<c<000000;<c<`200000/c<c080
0006c<c<00<0003<c<c<c<`02/c<c003IVIVooooc<c<02k<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h02o<c<`2IVIV00?oooo<c<c<c<`02<c<c003
VIW<c<c<0000008000000lc<c00000000002000000?<c<`0000000000lc<
c0@00006c<c<00>IVLc<c<c<c<`01lc<c09VIVH00oooolc<c<c<c004c<c<
00=VIVKoooo<c<`01/c<c0@00009c<c<100000S<c<`200000lc<c0D00006
c<c<00=VIVKoooo<c<`01Lc<c003IVIVooooc<c<00G<c<`010000<c<c<c<
c<c<c0L00002c<c<0P0000;<c<`200000lc<c0800004c<c<1P0000S<c<`0
0fIVI_ooolc<c00^c<c<0HS0^058T8P1000000000hS0^<SPf8S0^00_c<c<
0VIVIP03ooooc<c<c<c<00S<c<`01IVIc<c<c00000000<c<c00200000/c<
c0@00003c<c<1@0000G<c<`00iVIc<c<c<c<c007c<c<0VIVIP03ooooc<c<
c<c<00C<c<`00fIVI_ooolc<c006c<c<1@0000S<c<`500002<c<c0800000
0lc<c0000000000:c<c<00=VIVKoooo<c<`01Lc<c003IVIVooooc<c<00G<
c<`6000000C<c<`0000000000004c<c<0P000003c<c<0000000000?<c<`2
00000lc<c0800004c<c<0`0000K<c<`00fIVI_ooolc<c00^c<c<0HS0^058
T8P1000000000hS0^<SPf8S0^00_c<c<0VIVIP03ooooc<c<c<c<00S<c<`0
19VIc<c<c000000000;<c<`500001Lc<c08000000lc<c00000000003c<c<
0P000003VIW<c<c<c<c<00O<c<`2IVIV00?oooo<c<c<c<`01<c<c003IVIV
ooooc<c<00K<c<`2000000?<c<`0000000000lc<c0800003c<c<0P000003
c<c<0000000000?<c<`200001<c<c0@0000:c<c<00=VIVKoooo<c<`01Lc<
c003IVIVooooc<c<00K<c<`2000000C<c<`00000003<c<`300001<c<c0X0
0003c<c<0P0000G<c<`00`000<c<c<c<c005c<c<00=VIVKoooo<c<`0;/c<
c068`;P1B9280@00000000>8`;S8h=R8`;P0;lc<c09VIVH00oooolc<c<c<
c008c<c<00BIVLc<c<`000000005c<c<0P0000G<c<`300001Lc<c0800000
0iVIc<c<c<c<c007c<c<0VIVIP03ooooc<c<c<c<00C<c<`00fIVI_ooolc<
c006c<c<0`0000G<c<`200000lc<c0<00005c<c<0P0000G<c<`300002/c<
c003IVIVooooc<c<00G<c<`00fIVI_ooolc<c006c<c<2@0000G<c<`01000
0<c<c000000000?<c<`200000lc<c080000=c<c<00=VIVKoooo<c<`0;/c<
c068`;P1B9280@00000000>8`;S8h=R8`;P0;lc<c09VIVH00oooolc<c<c<
c008c<c<00BIVLc<c<`000000005c<c<0P0000G<c<`200001Lc<c0<00000
0iVIc<c<c<c<c007c<c<0VIVIP03ooooc<c<c<c<00C<c<`00fIVI_ooolc<
c006c<c<0P0000G<c<`300000lc<c0800005c<c<0`0000K<c<`200002/c<
c003IVIVooooc<c<00G<c<`00fIVI_ooolc<c006c<c<0P000003c<c<0000
000000@00004c<c<00<0003<c<c<c<`01`0000?<c<`200003Lc<c003IVIV
ooooc<c<02k<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h02o<c<`2IVIV
00?oooo<c<c<c<`02<c<c004VIW<c<c<000000001Lc<c0800005c<c<0P00
00G<c<`2000000?<c<bIVLc<c<`02<c<c09VIVH00oooolc<c<c<c004c<c<
00=VIVKoooo<c<`01/c<c0800005c<c<0P0000C<c<`200001Lc<c0800003
c<c<200000S<c<`00fIVI_ooolc<c005c<c<00=VIVKoooo<c<`01/c<c080
00000lc<c00000000002000000?<c<`0000000000/c<c0<000000lc<c000
00000003c<c<0P0000?<c<`200003Lc<c003IVIVooooc<c<02k<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h02o<c<`2IVIV00?oooo<c<c<c<`02<c<
c003VIW<c<c<c<c<00X00003c<c<0P0000C<c<`3000000?<c<bIVLc<c<`0
2<c<c09VIVH00oooolc<c<c<c004c<c<00=VIVKoooo<c<`01/c<c0800004
c<c<0`0000C<c<`200001<c<c0<00008c<c<0P0000W<c<`00fIVI_ooolc<
c005c<c<00=VIVKoooo<c<`01/c<c0L000000lc<c00000000003c<c<00<0
003<c<c<c<`01`0000?<c<`200003Lc<c003IVIVooooc<c<02k<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h02o<c<`2IVIV00?oooo<c<c<c<`02<c<
c003VIW<c<c<c<c<00800004c<c<00<0003<c<c<c<`01<c<c0800004c<c<
0P0000;<c<`00iVIc<c<c<c<c007c<c<0VIVIP03ooooc<c<c<c<00C<c<`0
0fIVI_ooolc<c006c<c<0P0000C<c<`200001Lc<c0800004c<c<0P0000G<
c<`00`000<c<c<c<c00<c<c<00=VIVKoooo<c<`01Lc<c003IVIVooooc<c<
00K<c<`2000000?<c<`0000000001@0000C<c<`800001<c<c080000=c<c<
00=VIVKoooo<c<`0;/c<c068`;P1B9280@00000000>8`;S8h=R8`;P0;lc<
c09VIVH00oooolc<c<c<c008c<c<00>IVLc<c<c<c<`00P0000?<c<`30000
1Lc<c0030000c<c<c<c<00O<c<`00iVIc<c<c<c<c007c<c<0VIVIP03oooo
c<c<c<c<00C<c<`00fIVI_ooolc<c006c<c<00<0003<c<c<c<`02/c<c003
0000c<c<c<c<00_<c<`500002Lc<c003IVIVooooc<c<00G<c<`00fIVI_oo
olc<c005c<c<1`0000O<c<`2000000?<c<`0000000001@0000?<c<`20000
3Lc<c003IVIVooooc<c<02k<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h
02o<c<`2IVIV00?oooo<c<c<c<`02<c<c003VIW<c<c<c<c<01O<c<`00iVI
c<c<c<c<c007c<c<0VIVIP03ooooc<c<c<c<00C<c<`00fIVI_ooolc<c00_
c<c<00=VIVKoooo<c<`01Lc<c003IVIVooooc<c<01;<c<`01P000<c<c<c<
c<c<c0000<c<c0<0000Dc<c<00=VIVKoooo<c<`0;/c<c068`;P1B9280@00
000000>8`;S8h=R8`;P0;lc<c09VIVH00oooolc<c<c<c008c<c<00>IVLc<
c<c<c<`05lc<c003VIW<c<c<c<c<00O<c<`2IVIV00?oooo<c<c<c<`01<c<
c003IVIVooooc<c<02o<c<`00fIVI_ooolc<c005c<c<00=VIVKoooo<c<`0
;lc<c003IVIVooooc<c<02k<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h
02o<c<`2IVIV00?oooo<c<c<c<`02<c<c003VIW<c<c<c<c<01O<c<`00iVI
c<c<c<c<c007c<c<0VIVIP03ooooc<c<c<c<00C<c<`00fIVI_ooolc<c00_
c<c<00=VIVKoooo<c<`01Lc<c003IVIVooooc<c<02o<c<`00fIVI_ooolc<
c00^c<c<0HS0^058T8P1000000000hS0^<SPf8S0^00_c<c<0VIVIP03oooo
c<c<c<c<00S<c<`00iVIc<c<c<c<c00Gc<c<00>IVLc<c<c<c<`01lc<c09V
IVH00oooolc<c<c<c004c<c<00=VIVKoooo<c<`0;lc<c003IVIVooooc<c<
00G<c<`00fIVI_ooolc<c00_c<c<00=VIVKoooo<c<`0;/c<c068`;P1B928
0@00000000>8`;S8h=R8`;P0;lc<c09VIVH00oooolc<c<c<c008c<c<6iVI
c0W<c<`2IVIV00?oooo<c<c<c<`01<c<c003IVIVooooc<c<02o<c<`00fIV
I_ooolc<c005c<c<00=VIVKoooo<c<`0;lc<c003IVIVooooc<c<02k<c<`1
R<2h0DR@R04000000003R<2hb>3HR<2h02o<c<`2IVIV00?oooo<c<c<c<`0
;<c<c09VIVH00oooolc<c<c<c004c<c<00=VIVKoooo<c<`0;lc<c003IVIV
ooooc<c<00G<c<`00fIVI_ooolc<c00_c<c<00=VIVKoooo<c<`0;/c<c068
`;P1B9280@00000000>8`;S8h=R8`;P0;lc<c09VIVH_oooo00=VIVK<c<co
ool01/c<c003IVIVooooc<c<02o<c<`00fIVI_ooolc<c005c<c<00=VIVKo
ooo<c<`0;lc<c003IVIVooooc<c<02k<c<`1R<2h0DR@R04000000003R<2h
b>3HR<2h02o<c<`cIVIV1lc<c003IVIVoooooooo02ooool00lc<c?ooolc<
c005c<c<00=VIVKoooooool0;oooo`03c<c<ooooc<c<02k<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h02o<c<`cIVIV1lc<c3=VIVH7c<c<<fIVIS3<
c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1
000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8
h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7
c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B928
0@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2h
b>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<
1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h00g<c<`06XN[QiO2UhN[Qi_8Vgn[OiO2UgfW
OIFoUGNOMhngSg:GLH^_RVnDKhFWQFf?KHFWQFN7IgfWOFN7IhFWQFN7IgfW
OFN7IgfWOFN7IgfWOMo<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<
c<`077n[P9_8VhN[Qi_8Vgn[Oi_8Vgn[OiO2UgfWOIFoUGNOMhngSg:GLHng
SfnEL8FWQFf?KHFWQFN7IgfWOFN7IgfWOFN7IhFWQFN7IhFWQFN7IgfWOMk<
c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`079_7Vgn[Oi_8Vgn[
Oi_8VhN[Qi_8Vgn[OiO2UgfWOIFoUGNOMhngSg:GLH^_RVnEL8N[Qff?KGfW
OFN7IhFWQFN7IgfWOFN7IgfWOFN7IgfWOFf?KMk<c<`1R<2h0DR@R0400000
0003R<2hb>3HR<2h00c<c<`03HN[QiO2UhN[Qi_8VhN[QiO2Ugn[Oi_8Vgn[
OiO2UgfWOIFoUGNOM`03c<c<00a_U6n7ZhM]Sff5YhEWQfMmYgeWQfMmYgeW
QfN5YhEWQfMmYggNc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<
00bKb9]oZgnKb9]oZgnKb9^7ZhNKb9]oZgnKb9]oZgnKai]mYgd403<000c<
c<a_U6n7ZhM]Sff5YhEWQfN5YhEWQfMoZh1WQfMmYgeWQfONc<c<0HS0^058
T8P1000000000hS0^<SPf8S0^00<c<c<01b7ZhNKb9]oZgnKb9]oZh2G`YN7
ZhNKb9^7ZhNKb9^0Zgl0<`3<c<bE_iEmYgf?]hl0<`3<c<a_U6n7ZhM]Sfeo
Zh1WQfMoZh1WQfN5YhEWQfN5YhGNc<c<0HS0^058T8P1000000000hS0^<SP
f8S0^00<c<c<01bKb9]oZgnKb9^7ZhNG`YN7ZhNKb9]oZgnKb9]oZgnKb9/0
<`3<c<amYgfE_iEhX7L0<`3<c<b;[hY_UG27ZhM]Sff5YhEWQfMmYgeWQfMm
YgeWQfONc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<00b7ZhNK
b9]oZgnKb9^0ZgnKb9]oZh2Kb9^7ZhNKb9^7ZhL0<`04c<c<00`0<`2?]hmg
WgN;[hY_UG25YhE]Sff5YhEWQfMmYgeWQfN5YhGNc<c<0HS0^058T8P10000
00000hS0^<SPf8S0^00<c<c<00bG`YN7ZhNKb9]oZgnKb9]oZgnKb9]oZgnK
b9^0ZgnKb9^7ZhL403<000bE_iEgWgN?]hmbUg6?]hm_U6n7ZhM]Sff5YhEW
QfMmYgeWQfONc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<01b7
ZhNKb9]oZgnKb9^7ZhNG`YN7ZhNG`YN7ZhNKb9]oZgnKb9^7ZhNKb9^7ZhNG
`YMmYgfE_iEgWgN?]hmbUg6?]hm_U6n5YhE]Sff5YhEWQfN5YhE[c<c<1000
06o<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`03I_7Vgn[Oi_8
VhN[Qi_8Vgn[P9_8Vgn[Oi_8Vh2[Oi_8VhN[Qi_8V`03c<c<00bKai]mYgfE
_iEgWgN?]hmgWgN;[hYbUg67ZhM]Sff5YhEWQfMZc<c<00@0003<c<c<c<c<
c<`20000K/c<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00<Oj]o
VlNKQj^7Ul:HOj]oVlRKOj]oVlRKOj]oVlRKOj]oVlRK100c000<c<c<VlNK
OJMmUKnEOJMmSkN?LYMaRjn:LYMaQj^7KHm]QJN54Lc<c0800005c<c<1000
00;<c<`200001<c<c0<00002c<c<0P0000?<c<`5000000?<c<`000000000
1<c<c08000000lc<c00000000004c<c<0P0000;<c<`200000/c<c0800002
c<c<100000?<c<`400000lc<c0@00003c<c<1@0000;<c<`2000000?<c<`0
000000000/c<c0@00003c<c<100000G<c<`200000/c<c0800002c<c<1000
00?<c<`300000/c<c0800004c<c<0P00043<c<`1R<2h0DR@R04000000003
R<2hb>3HR<2h00c<c<`079FoUGn[OiO2UhN[Qi_8VhN[QiO2UhN[QiO2UhN[
QiO2U`0c0<c<c8N[QiO2UhN[Q`0c0<c<c9_7VgfWOIFoUGNOMhngSgNOMh^_
RVnEL8N[Qff?KA7<c<`200001<c<c0800002c<c<0P000003c<c<00000000
00C<c<`3000000C<c<`0000000000002c<c<0P0000;<c<`2000000?<c<`0
000000000lc<c08000001<c<c0000000000000C<c<`200000/c<c0800002
c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c080
00000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`2000000C<
c<`00000003<c<`3000000?<c<`0000000000/c<c08000000lc<c0000000
0002c<c<0P0000C<c<`200000/c<c08000000lc<c00000000002c<c<0P00
00;<c<`3000000C<c<`0000000000004c<c<0P00043<c<`1R<2h0DR@R040
00000003R<2hb>3HR<2h00c<c<`077fWOIFoUGfWOI_7Vgn[Oi_8VhN[Qi_8
Vgn[P9O2UhN[Q`0c0<c<c9O2V8N[QiO2V8N[Q`0c0<c<c9O2UgfWOIFoUGfW
OHngSgNOMh^_RW:GLHN[Qa7<c<`200001<c<c0800002c<c<0P000003c<c<
0000000000C<c<`3000000C<c<`0000000000002c<c<0P0000;<c<`20000
00?<c<`0000000000lc<c0800002c<c<0P0000C<c<`200000/c<c0800002
c<c<0P000003c<c<0000000000S<c<`300001<c<c0<000000lc<c0000000
0002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000002<c<
c0<00004c<c<0P0000;<c<`2000000?<c<`0000000000/c<c0800002c<c<
0`000004c<c<000000000000A/c<c068`;P1B9280@00000000>8`;S8h=R8
`;P03<c<c00LUKnEOJMmUKnEOj]oVlNKOj]oVlRKQj^7Ul:HQj^7VlRKP:]o
03<0c<c<VlRKQj^7Ul:GQj^703<0c<c<VlNKOJMmUKnEN:1gSkN?MimgRjn:
KiE`4Lc<c0800004c<c<0P0000;<c<`2000000?<c<`0000000000lc<c080
00001Lc<c0000<c<c0000<c<c00200000/c<c08000001<c<c00000000<c<
c0800003c<c<0P0000;<c<`200001<c<c0800002c<c<0P0000;<c<`20000
00?<c<`000000000100000;<c<`400000lc<c0@00003c<c<0P000004c<c<
00000000c<c<0P0000;<c<`2000000?<c<`000000000100000;<c<`40000
1Lc<c0800002c<c<0P000003c<c<0000000000;<c<`2000000S<c<`00000
003<c<`0003<c<`0003<c<`200000lc<c0800010c<c<0HS0^058T8P10000
00000hS0^<SPf8S0^00<c<c<01agWgN@]i1mYgfE_iEmYgfKai]oZgnKai^7
ZhNG`YMoZgnKb9]oZgl0<`3<c<bKb9^7ZhNKb9]oZh00<`3<c<bKai]mYgfE
_iEmYgf?]hmgWgN;[hXAc<c<1@000003c<c<0000000000;<c<`2000000?<
c<`0000000000lc<c08000001Lc<c000000000000<c<c00200000lc<c0@0
00000lc<c00000000003c<c<0P0000;<c<`200001<c<c0800002c<c<0P00
00;<c<`2000000?<c<`0000000000/c<c08000001<c<c0000000000000C<
c<`300001/c<c0@000000lc<c00000000002c<c<0P000003c<c<00000000
00;<c<`2000000C<c<`0000000000007c<c<0P0000;<c<`2000000?<c<`0
000000000/c<c08000001<c<c00000000<c<c0<000000lc<c00000000003
c<c<0P00043<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`078ng
SgNOMhngT7fWOIFoUGfWOI_7Vgn[Oi_7VhN[Qi_8Vgn[Oi_8VhN[Q`0c0<c<
c9_8VhN[Qi_8VhN[Q`0c0<c<c9_7VgfWOIFoUGNOMhngSgNOMa7<c<`20000
1Lc<c0030000c<c<c<c<008000000lc<c00000000003c<c<0P000005c<c<
000000000000c<c<008000000lc<c0000<c<c002c<c<0P000003c<c<0000
000000?<c<`2000000C<c<`0000000000004c<c<0`000005c<c<00000000
0000c<c<008000000lc<c00000000002c<c<0P000003c<c<0000000000;<
c<`2000000?<c<`0000000000/c<c08000000lc<c0000<c<c002c<c<0P00
0004c<c<00000000c<c<0`000003c<c<0000000000;<c<`2000000?<c<`0
000000000/c<c0800004c<c<0`000003c<c<0000000000;<c<`00`000<c<
c<c<c002000000C<c<`00000003<c<`3000000?<c<`0000000001<c<c080
000oc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<01a_UG2?]hmg
WgN?]i1mYgfE_iEoZgnKai]oZh2Kb9^7ZhNKb9]oZh2G`YMoZh00<`3<c<bK
b9]oZgnKb9/0<`3<c<b0ZgnKai]oZgnE_iEmYgf?]hlAc<c<0P0000G<c<`4
00000/c<c0@000000lc<c00000000002c<c<00<0003<c<c<c<`00P0000;<
c<`400000/c<c0@00002c<c<0P000003c<c<0000000000C<c<`2000000?<
c<`0000000000/c<c0800003c<c<100000?<c<`400000lc<c0@00003c<c<
100000?<c<`2000000?<c<`0000000000/c<c0@00003c<c<100000G<c<`2
000000?<c<`0000000000lc<c0@00002c<c<0P0000;<c<`00`000<c<c<c<
c00200001Lc<c080000nc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<
c<c<00V;[hYbUg6?]hmgWgN?]i1mYgfE_iEmYgfKai/00/c<c00AQj^7Ul:G
Qj^7VlRKOj]o03<0c<c<VlRKQj^7VlRK03<0c<c<Oj]oUl:GOJMmUKnEOJMm
017<c<`20000:/c<c080001Kc<c<0P0000;<c<`20000?/c<c068`;P1B928
0@00000000>8`;S8h=R8`;P03<c<c008KiA_Rjn:KiE`SkN?MimgSkN?OJMm
UKnE0`0c000Ac<c<Qj^7VlRKOj]oVlRKQj^703<0c<c<VlRKP:]o03<0c<c<
VlRKOj]oVlNKOj]oUKnE017<c<`500009lc<c080001Lc<c<100003o<c<`1
R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`078FWQFnDKh^_RW:GLHng
SgNOMi2gT00c0<c<c7fWOI_7V`0c0<c<c8N[Qi_8Vgn[Oi_8V`0c0<c<c7n[
Oi_8V`0c0<c<c8N[Qi_8Vgn[P9O2Ugn[Omk<c<`1R<2h0DR@R04000000003
R<2hb>3HR<2h00c<c<`076N9IhFWQFf?KH^_RVnEL8ngSgNOM`0c0<c<c9Fo
UGfWO@0c0<c<c9_8VhN[Qi_8VhN[Q`0c0<c<c9O2UhN[Q`0c0<c<c9_8Vgn[
Oi_8Vgn[Oi_7Vmk<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`0
3HFWQFN7IhFWQFf?KH^_RW:GLHngS`0c0<c<c7fWOIFoUGfWO@0c0003c<c<
00`0<`3<c<bKb9^7ZhNKb9/0<`3<c<b7ZhNKb9^7ZhNKb9]oZgoNc<c<0HS0
^058T8P1000000000hS0^<SPf8S0^00<c<c<00eWQfN5YhEWQfN5YhE]Sff;
[hY_UG2?]hl0<`3<c<amYgfE_iEmYgd00`0c000<P:]oVlRKOj]oVlRK03<0
c<c<Qj^7Ul:HP:]oVlRKP:]oVlRKg/c<c068`;P1B9280@00000000>8`;S8
h=R8`;P03<c<c00LOJMmIhMWQJN5IhQXQJN5KHm]Rjn:LYMa03<0c<c<UKnE
OJMmUKnEOj]oUl:GQj^7Ul:GQj^7VlRKQj^703<0c<c<VlRKOj]oVlRKOj]o
VlRKQj^7g/c<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00:IhMW
QJN5IhMWOJMmKHm]QJN5KHm]Rjn:LYMa03<00/c<c005OJMmUKnEOJMmUl:G
Qj^700;<c<`02@0c0<c<c9_8Vh2[Oi_8VhN[Qi_8VhN[Qi_8V`3Nc<c<0HS0
^058T8P1000000000hS0^<SPf8S0^00<c<c<00YmYgeWQfMmYgeWQfMoZh1W
QfN5YhE]Sff;[hY_UG0203<01Lc<c080<`002Gn[Oi_8Vgn[Oi_8Vgn[P9_8
Vgn[Oi_7Vh2[O`3Nc<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<
00aWQfN5YhEWQfN5YhEWQfN5YhEWQfN5YhE]Sff;[hY_U6n?]hl503<000^G
`YN7ZhNKb9^7ZhNKb9^7ZhNG`YMoZgnKb9^7ZhNKb9/0g/c<c068`;P1B928
0@00000000>8`;S8h=R8`;P03<c<c00LOJMmIhMWOJMmIhMWOJMmIhMWOJMm
IhMWQJN5KHm]Rjn:KiA_SkN?MimgSkN?MimgUKnEOJMmUl:GOj]oUl:HOj^0
VlRKQj^7VlRKP:]oVlRKOj]og/c<c068`;P1B9280@00000000>8`;S8h=R8
`;P03<c<c00LIhMWQJN5IhMWOJMmIhMWQJN5IhMWOJMmKHm]QJN5KHm]Rjn:
LYMaSkN?MimgSkN?OJMmUKnEOJMmUl:GQj^7VlRKOj]oVlRKQj^7VlRKOj]o
VlNKg/c<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00LOJMmIhMW
OJMmIhMWOJMmIhMWOJMmIhMWOJMmIhMWQJN5KHm]Rjn:KiE`Rjn:MimgSkN?
OJMmUKnEOJMmUl:GOj]oVlNKOj]oVlRKOj]oVlRKQj^7g/c<c068`;P1B928
0@00000000>8`;S8h=R8`;P03Lc<c00JQJN5IhMWQJN5IhMWQJN5IhMWQJN5
IhMWQJN5IhUWQJN5KHm]Rjn:LYMaSkN?MimgT;N@OJMmUKnEOJMmVlNKQj^7
VlNKQj^7VlRKQj^7glc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<
c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058
T8P1000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8
`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<
c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1
B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003
R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03o
c<c<1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h0?n8`;P8R<2h0DR@R04000000003R<2h
b>3HR<2h008008004@01P002P002P@03P@04P@05P@05PP06PP07PP48PP48
P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD248D24HH24HH24XH24hH2
0QB700H25HL25XL35hP35hP368P36HP20aZ900D36hT378X37HX37HX47XX0
0P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>
1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB
1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPo
UPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;
VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]F
WP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj8<H:8<
HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>JZD>JjH>JjH>
K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?MjX?
MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6^0Q62
[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba4Xfb
4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D01QBG]ABH
]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T05QFS
^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^_AN^
_QN__QN`_QNa_QNa_aNb_aNc_a@H]<01R<2h0DR@R04000000003R<2hb>3H
R<2h008008004@01P002P002P@03P@04P@05P@05PP06PP07PP48PP48P`49
P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD248D24HH24HH24XH24hH20QB7
00H25HL25XL35hP35hP368P36HP20aZ900D36hT378X37HX37HX47XX00P@O
R`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>1BZ?
1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB1cFC
1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPoUPQ0
U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;VPY;
VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]FWP]G
WP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj8<H:8<HJ8=
HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>JZD>JjH>JjH>K:H>
KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?MjX?MjX@
N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6^0Q62[P06
4H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba4Xfb4Xjb
4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D01QBG]ABH]QBI
]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T05QFS^QFT
^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^_AN^_QN_
_QN`_QNa_QNa_aNb_aNc_a@H]<01R<2h0DR@R04000000003R<2hb>3HR<2h
008008004@01P002P002P@03P@04P@05P@05PP06PP07PP48PP48P`49P`4:
P`4;P`4;Q04<Q04=Q0020@j500H23hD248D24HH24HH24XH24hH20QB700H2
5HL25XL35hP35hP368P36HP20aZ900D36hT378X37HX37HX47XX00P@OR`0:
122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>1BZ?1B^?
1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB1cFC1cJC
0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPoUPQ0U`Q1
U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;VPY;VPY<
V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]FWP]GWP]G
W`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HZ8=
HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>JZD>JjH>JjH>K:H>KJH2
3VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?MjX?MjX@N:X0
0Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6^0Q62[P064H>^
4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba4Xfb4Xjb4hjb
4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D01QBG]ABH]QBI]QBI
]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T05QFS^QFT^QJU
^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^_AN^_QN__QN`
_QNa_QNa_aNb_aNc_`8H]<0@00000QRd`068`;P1B9280@00000000>8`;S8
h=R8`;P00P00P00A006000:000:100>100B100F100F200J200N20@R20@R3
0@V30@Z30@^30@^40@b40@f400813XD01P8?Q@8@Q@8AQP8AQP8BQP8CQP82
58L01P8EQ`8FQ`<GR0<GR0<HR0<IR0836XT01@<KR@<LRP<MRP<MRP@NRP02
11n;00X488/48H/48X`48X`48h`498`49Hd59Hd59Xd59hh21BR>00H5:Hh5
:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46<I46<Y46<i86=987=987
=I<7=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE23jF23nF23nF
242G246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E2DVJ2DZJ2T^J
2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM2eBN2eFN2eJN
2eNN2eNO2eRO008;FIl04PaJX0aKX0aLX0aLX@aMX@aNX@aOX@aOXPaPXPaQ
XPeRXPeRX`eSX`eTX`eUX`eUY0eVY0eWY08=J:D01PiYY@iZY@i[YPi[YPi/
YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmgZPmg
ZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh24H:^
00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4BSK8B
S[8CS[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne59Rf
59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F5J>j
5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm5jjn
5jnn5k2n5k6n5k6o5k:o5k>o0QRd`003b>3HB928B92800a8T8P01@0001Rd
`1Rd`8S0^4R@R001000000000hS0^<SPf8S0^002002001400H000X000X40
0h4018401H401H801X801h81288128<12H<12X<12h<12h@138@13H@00P4>
Q@060Pn50Q250Q660Q660Q:60Q>60P8DQ`060QF70QJ70aN80aN80aR80aV8
0P<JR@050a^90ab:0af:0af:11j:00847h/02P@PR`@QR`@RS0@RS0@SS0@T
S0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_
T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0Lj
U0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9
AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:
DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0B35ZP35^P
35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS3FFS3FFT3FJT
3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X
3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l
[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7/08B
R;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C
]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPE
W[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`F
ZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/kl26;C0
00?8h=R8`;R8`;P02hS0^006B92800006;C06;C0R<2hB9280@00000000>8
`;S8h=R8`;P00P00P003006000:0oooo00;oool01005POooo`06PP07PP;o
ool01049Poooo`4;P`4;Q0?oool00`4>Q@8?Q@8@Q@03oooo00D24hH258L2
58L25HOoool00P<GR003oooo0aV80aZ900?oool20af:00Goool47h/47h/4
88_oool00P@RS00612><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>1BZ?1B^?
1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB1cFC1cJC
0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPoUPQ0U`Q1
U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;VPY;VPY<
V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]FWP]GWP]G
W`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HZ8=
HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>JZD>JjH>JjH>K:H>KJH2
3VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?MjX?MjX@N:X0
0Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6^0Q62[P064H>^
4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba4Xfb4Xjb4hjb
4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D01QBG]ABH]QBI]QBI
]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T05QFS^QFT^QJU
^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^_AN^_QN__QN`
_QNa_QNa_aNb_aNc_`8H]<000lSPf8S0^8S0^00;R<2h00I8T8P0000H]<0H
]<28`;Q8T8P1000000000hS0^<SPf8S0^002002000@00H3oool00X400h42
oooo00D01H801X;oool1288128<00_ooo`080@^3oooo0@b40@f40@j5oooo
0Pn5oooo0P8AQP060Q:6oooo0QB70QB7oooo0QJ70P<GR009oooo0aV8oooo
0aZ90a^90ab:oooo0af:oooo00847h/02P@PRoooo`@RS0@RS0@SS0@TS0@U
S@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`
T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0LjU0Lk
U@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9AIP9
AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DI`:
DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0B35ZP35^P35bP
35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS3FFS3FFT3FJT3FNT
0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X
3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m
[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7/08BR;00
2Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D
]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPEW[PE
WkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`F
Z[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/kl26;C000C8
h=R8`;R8`;R8`;P2000018S0^0800002R<2h00I8T8P0000H]<0H]<28`;Q8
T8P1000000000hS0^<SPf8S0^0020020017oool00X000X7oool018401H7o
ool01X;oool1288128<12H?oool12h?oool138@13H@00P4>Q@030Pn50Q25
0Q6600;oool01@8CQP8DQ`8DQoooo`8FQ`020aN800Woool36HSoool36XT3
6hT378[oool37H[oool00P@OR`0:122;oooo12:<12:<12><12B<12F=1BF=
1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A
1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088
?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7
V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]B
W@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<
GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU
00H>JJD>JZD>JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP2
3gBY00D?MJT?MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/
47n]4Gn]4H2]4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`
4XZa4X^a4X^a4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd
4iFe008DU[D01QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO
^1FP^AFQ^@8EX[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[
_1J[_AN/_AN]_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc_`8H]<000lSPf8S0
^8S0^002R<2h0P0000:8`;P200000hS0^006B92800006;C06;C0R<2hB928
0@00000000>8`;S8h=R8`;P00P00P00>oooo00:000:100>100B100F1oooo
00J2oooo0@R20@R30@V3oooo0@^31Oooo`060Pn50Q25oooo0Q660Q:60Q>6
0P8DQ`0=oooo0QJ70aN80aN8oooo0aV8oooo0aZ90a^90ab:oooo0af:oooo
00847h/02P@PRoooo`@RS0@RS0@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDY
SPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLd
TPLeT`LfT`87=i<01@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8
?iH8@9L8@IL224:G00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:
BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;
EYh;Eih;Eil;F9l00P]IW`0B35ZP35^P35bP35bQ35fQ35jQ35nQ35nR362R
366R3F:R3F:S3F>S3FBS3FFS3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V
3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ
3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8A
PZh01Q63[Q64[a65[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=
/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDD
V;HDVKHDVKHDV[LDVkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HE
XkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG
[[hG[khG/;hG/KhG/KlG/[lG/kl26;C000?8h=R8`;R8`;P00hS0^0@00004
R<2h00I8T8P0000H]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^0020020
01Goool00X000X400h4018401H7oool01X;oool1288128<12H?oool12h?o
ool138@13H@13XGoool23hGoool00P8AQP060Q:6oooo0QB70QB7oooo0QJ7
0P<GR008oooo0aV8oooo0aZ90a^90ab:oooo0af:0_ooo`0311n;122;oooo
00848X`01P@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/
S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<0
1@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G
00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:
CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l0
0P]IW`0B35ZP35^P35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S
3FBS3FFS3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`06
3VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/0
2Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65
[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@
/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LD
VkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXF
Y[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG
/KlG/[lG/kl26;C000?8h=R8`;R8`;P018S0^0800005R<2h00I8T8P0000H
]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^002002000ooool00X000X40
0h4018401H7oool01X;oool1288128<12H?oool12h<12h@00oooo`030@j5
0Pn50Q2500?oool00`8CQP8DQoooo`02oooo0P<GR003oooo0aV80aZ900?o
ool20af:00Goool47h_oooooool48H/00P@RS00612><12B<12F=1BF=1BJ=
1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A
1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D0
1PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89
B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]C
W@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<
GZ4<Gj4<Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>
JJD>JZD>JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY
00D?MJT?MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]
4Gn]4H2]4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa
4X^a4X^a4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe
008DU[D01QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP
^AFQ^@8EX[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[
_AN/_AN]_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc_`8H]<000lSPf8S0^8S0
^003R<2h100000B8`;P01TR@R00001Rd`1Rd`8S0^4R@R04000000003R<2h
b>3HR<2h008008004Oooo`02P002P@03P@04P@05POooo`06PP07PP48PP48
P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD248D24HH24HH24XH24hH2
0QB700Koool25XL35hP35hP368P36HP20aZ900D36hT378X37HX37HX47XX0
0P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>
1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB
1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPo
UPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;
VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]F
WP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj8<H:8<
HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>JZD>JjH>JjH>
K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?MjX?
MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6^0Q62
[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba4Xfb
4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D01QBG]ABH
]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T05QFS
^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^_AN^
_QN__QN`_QNa_QNa_aNb_aNc_`8H]<000lSPf8S0^8S0^002R<2h0P0000:8
`;P200000hS0^006B92800006;C06;C0R<2hB9280@00000000>8`;S8h=R8
`;P00P00P00A0060oooo00:100>100B1oooo00F200J200N20@R20@R30@V3
0@Z30@^30@^40@b40@f400813XD01P8?Q@8@Q@8AQP8AQP8BQP8CQP8258L0
1_ooo`8FQ`<GR0<GR0<HR0<IR0836XT01@<KR@<LRP<MRP<MRP@NRP0211n;
00X488/48H/48X`48X`48h`498`49Hd59Hd59Xd59hh21BR>00H5:Hh5:Xl5
:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46<I46<Y46<i86=987=987=I<7
=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE23jF23nF23nF242G
246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E2DVJ2DZJ2T^J2T^J
2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM2eBN2eFN2eJN2eNN
2eNO2eRO008;FIl04PaJX0aKX0aLX0aLX@aMX@aNX@aOX@aOXPaPXPaQXPeR
XPeRX`eSX`eTX`eUX`eUY0eVY0eWY08=J:D01PiYY@iZY@i[YPi[YPi/YPi]
YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmgZPmgZQ1h
ZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh24H:^00HA
PjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4BSK8BS[8C
S[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne59Rf59Vf
59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F5J>j5JBj
5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm5jjn5jnn
5k2n5k6n5k6o5k:o5k>o0QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P20000
0XS0^006B92800006;C06;C0R<2hB9280@00000000>8`;S8h=R8`;P00P00
P003006000:0oooo00;oool03005P@05PP06PP07PP48PP48P`49P`4:P`4;
P`4;Q04<Q04=Q0813XD01P8?Q@8@Q@8AQP8AQP8BQP8CQP8258L01P8EQ`8F
Q`<GR0<GR?ooo`<IR0836XT01@<KR@<LRP<MRP<MRP@NRP0211n;00X488/4
8H/48X`48X`48h`498`49Hd59Hd59Xd59hh21BR>00H5:Hh5:Xl5:hl5:hl5
;8l6;I021Rj@00X6;i06<946<I46<I46<Y46<i86=987=987=I<7=Y<21cNC
00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE23jF23nF23nF242G246G0PQ2
U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E2DVJ2DZJ2T^J2T^J2TbK2TfK
2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM2eBN2eFN2eJN2eNN2eNO2eRO
008;FIl04PaJX0aKX0aLX0aLX@aMX@aNX@aOX@aOXPaPXPaQXPeRXPeRX`eS
X`eTX`eUX`eUY0eVY0eWY08=J:D01PiYY@iZY@i[YPi[YPi/YPi]YP8>KZL0
1Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmgZPmgZQ1hZP0247V[
00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh24H:^00HAPjhAQ:lA
QJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4BSK8BS[8CS[8CSk<C
T;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne59Rf59Vf59Vf59Zg
59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F5J>j5JBj5ZFj5ZFj
5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm5jjn5jnn5k2n5k6n
5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h00^8`;P01TR@R00001Rd`1Rd`8S0
^4R@R04000000003R<2hb>3HR<2h008008004@01P002P002P@03P@04P@05
P@05PP06PP07PP48PP48P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD2
48D24HH24HH24XH24hH20QB700H25HL25XL35hP35hP368P36HP20aZ900D3
6hT378X37HX37HX47XX00P@OR`0:122;126;12:<12:<12><12B<12F=1BF=
1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A
1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088
?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7
V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]B
W@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<
GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU
00H>JJD>JZD>JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP2
3gBY00D?MJT?MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/
47n]4Gn]4H2]4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`
4XZa4X^a4X^a4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd
4iFe008DU[D01QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO
^1FP^AFQ^@8EX[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[
_1J[_AN/_AN]_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc_`8H]<000lSPf8S0
^8S0^00;R<2h00I8T8P0000H]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0
^002002001400H000X000X400h4018401H401H801X801h81288128<12H<1
2X<12h<12h@138@13H@00P4>Q@060Pn50Q250Q660Q660Q:60Q>60P8DQ`06
0QF70QJ70aN80aN80aR80aV80P<JR@050a^90ab:0af:0af:11j:00847h/0
2P@PR`@QR`@RS0@RS0@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[
S`D[S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`Lf
T`87=i<01@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8
@IL224:G00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:
C9/:CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;
Eil;F9l00P]IW`0B35ZP35^P35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R
3F:S3F>S3FBS3FFS3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV
0Pi^Y`063VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ
008@NJ/02Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63
[Q64[a65[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>
/Q>?/a>@/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHD
VKHDV[LDVkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XF
YKXFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG
/;hG/KhG/KlG/[lG/kl26;C03lSPf00500006;C06;C0R<2hB92800400000
0003R<2hb>3HR<2h008008004@01P002P002P@03P@04P@05P@05PP06PP07
PP48PP48P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD248D24HH24HH2
4XH24hH20QB700H25HL25XL35hP35hP368P36HP20aZ900D36hT378X37HX3
7HX47XX00P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDX
SP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B
1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@Pn
UPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9
VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]D
WP]EWP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<
Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>JZD>
JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?
MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]
4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a
4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D0
1QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8E
X[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]
_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc_a@H]<01R<2h0DR@R04000000003
R<2hb>3HR<2h008008004@01P002P002P@03P@04P@05P@05PP06PP07PP48
PP48P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD248D24HH24HH24XH2
4hH20QB700H25HL25XL35hP35hP368P36HP20aZ900D36hT378X37HX37HX4
7XX00P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDXSP06
1BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB
1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPo
UPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:
VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]E
WP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj8<
H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>JZD>JjH>
JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?
MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6^
0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba
4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D01QBG
]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T0
5QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^
_AN^_QN__QN`_QNa_QNa_aNb_aNc_a@H]<01R<2h0DR@R04000000003R<2h
b>3HR<2h0?n8`;P8R<2h0DR@R04000000003R<2hb>3Hb>3H0?o8h=P8b>3H
0DR@R04000000?n8`;P<R<2h0@000000\
\>"], "Graphics",
  ImageSize->{268, 115},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004/0000S2000`400?l00000o`00003oooo`l?0]
oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]
oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]
oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooo`l?0]oo3`l000ooooool]
ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]
onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`003_o^k^h2ong]k@0:on_[jooX
j>SoiNGUon;Rh_oMgMgof=SHomCDe?oAdM7oc/k>olc<c0;obl_;=Oo:b/X2ol_;b`0:olc<c?o>c/ko
dM7AomCDe?oHf=SogMgMon;Rh_oUiNGoj>SXon_[j`;okNg]4?o^k^h2ong]k@0:on_[jooXj>SoiNGU
on;Rh_oMgMgof=SHomCDe?oAdM7oc/k>olc<c0;obl_;=Oo:b/X2ol_;b`0:olc<c?o>c/kodM7AomCD
e?oHf=SogMgMon;Rh_oUiNGoj>SXon_[j`;okNg]4?o^k^h2ong]k@0:on[Zj_oUiNGogmoOomSHf?o?
cloo_[nooj^/[_nCV9_oQhjCoh28S`;oOhJ=00?oOhN>ohf@U_n4RY801?moQhh01?n4RY;oSI2Fohf@
U_n4RY84ogn7SP04ohB:T_n=T9KoSI2FohB:TPCoOhN>00CoQ8ZBohf@U_n=T9KoQ8ZB1?moQhh01?n4
RY;oSI2Fohf@U_n4RY84ogn7SP04ohB:T_n=T9KoSI2FohB:TPCoOhN>00CoQ8ZBohf@U_n=T9KoQ8ZB
0_moQhh2ogn6S@0:oh28Son7SY?oTiRKoj^/[_nn_kooclo?omSHf?oOgmooiNGUon[ZjP;okNg]2oo^
k^h000goi^KV0_oUiND02_oRh^;oh>3Pom_KfooFe]Koc/k>olO7aono_koo^;RhokBd]?n`/;02ojj^
[P;o[Jf]<on/[:`2ojf][@;o[Zj^00[o/;2`okBd]?nh^;So_knoolO7aoo>c/koe]KFom_KfooPh>3o
h^;R0_oUiND>onKViP;oiNGU00[oh^;Ron3Ph?oKfm_oe]KFolk>c_o7alOo_knookRh^?nd];Co/;2`
0_n^[Zh2ojf][C?o[:b/0_n][Jd2ojj^[P0:ok2`/?nd];Co^;Rhokno_oo7alOoc/k>omKFe_oKfm_o
h>3Pon;RhP;oiNGU3_oVi^H2onGUi@0<on3Ph?oKfm_oe=CDokno`?nWZ:[oRhnCogMoQomWM83oGg1o
oe]^OomHKh3oF6b10_mHK7l00omLJg_oF6]noeM[P003oeM[P004oeQ[O_mLJg_oG6]koeQ[OPCoEf^0
00CoF6]noea[NomLJg_oF6]n1?mGJh001?mHJgkoG6]koea[NomHJgh4oeM[P004oeQ[O_mLJg_oG6]k
oeQ[OPCoEf^000CoF6]noea[NomLJg_oF6]n1?mGJh001OmHJgkoG6]koea[NomHJgkoEf^000;oF6ao
00coF6b1oeQ_P?mKKWooGg1oofMdP?mgOhOoRhnCojNXZ_no_l3oe=CDom_KfooPh>02onGUi@[oi^KV
000=onk^kP0>ong]kOoZj^[oinOWon;Rh_oIfMWoc/k>ol?3`onh^;So[Zj^ojJVY_nPX:3oW9bLoiVI
VOnHV9PgoiNGU`0=oiRHV?nIVIWoW9bLoj2PX?nVYZKo[Zj^okRh^?o3`l?oc/k>omWIfOoRh^;oinOW
on[ZjP02ong]k@gok^k^00kokNg]on[Zj_oWinOoh^;RomWIfOo>c/ko`l?3okRh^?n^[ZkoYZJVoj2P
X?nLW9coVIVIoiRHV3OoUiNG00goV9RHoiVIVOnLW9coX:2PojJVY_n^[Zko^;Rhol?3`oo>c/kofMWI
on;Rh_oWinOoj^[Z00;okNg]3Oo^k^h03_o]kNgoj>SXon;Rh_oHf=So`L;2oi^MX?mhPXWoHg60oeM[
P?mAJX;oCfb6oda/Qom=JXSoC6Z80_m:JXL00om;Ih3oBVZ7odYZQ`04odYZQ`;oBfN01_m:JXL2od]W
P0KoBVZ70_m;Ih06odYZQ`;oBfN01_m:JXL2od]WP0KoBVZ70_m;Ih04odYZQ`0=odaZR?m=JXSoC6b7
odm/Q_mAJX;oEf^0of=aP?mhPXWoVifPol72`_oHf=Soh^;RonSXj002ong]k@Wok^k^000=ooooo`0>
ooclo?oinOWol_;bonSXj?oJf][obl_;okZj^_n/[:coWinOoiFEUOn>SXkoRXZ:ohN7Qon6QXHgohF5
Q@0?ohJ6Q_n7QhOoRXZ:ohj>S_nEUIGoWinOojb/[?nj^[[obl_;om[Jf_oXj>Sol_;booWinOolo?co
o_kn00gooooo00koo?clooWinOobl_;oj>SXom[Jf_o;bl_o^[Zjojb/[?nOWiooUIFEohj>S_n:RX[o
QhN7ohJ6QSOoQHF500ooQXJ6ohN7Qon:RX[oSXj>oiFEUOnOWioo[:b/okZj^_o;bl_of][JonSXj?ob
l_;onOWiooclo?ono_h03Oooool03_okno_om?CdonSXj?o<cLgoXZNZogJ1RomLKh;oD6b4od]WPom7
HgcoA5efod=JL?m2FFoo@UM^0_m1F6h00om0FgKo@E]bod5HKP03od5HKP04od5KL_m0FgKo@5]fod5K
LPCo@EQ^00Co@E]bod1KM_m0FgKo@E]b1?m1F6h01?m1Fg;o@5]fod1KM_m1Fg84od5HKP04od5KL_m0
FgKo@5]fod5KLPCo@EQ^00Co@E]bod1KM_m0FgKo@E]b1?m1F6h01?m1Fg;o@5]fod1KM_m1Fg83od5H
KP0?od9GK_m2FFoo@eY`odAMM_m7HgcoBfN3oe1/Q?mLKh;oMX6;oj:WZ_o<cLgoj>SXooCdm?okno_o
o_kn00Wooooo000=onk^kP0DonSXj?oRh^;ofMWIol[:b_nj^[[oZ:RXoiRHV?nBTY;oYJFUol30`?oG
emOojn_[ooKfm_ogmoOonOWiooShn?oinOWon_[jooWinOogmoL3ooShn0;onOWi00?on_[jooWinOog
moL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;o
nOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT04oojn_[o
nOWiooShn?oinOWon?ShooOgmoo]kNgof=SHol71`OnUYJGoTY:BoiRHV?nXZ:So^[Zjol[:b_oIfMWo
h^;RonSXj?o/k>`03Oo^k^h05?oXj>Soh^;RomWIfOo:b/[o^[ZjojRXZ?nHV9SoTY:BojFUYOo0`<3o
emOGon_[joofm_KomoOgooWinOohn?SonOWioo[jn_oinOWomoOg0oohn?P2ooWin@03oo[jn_oinOWo
moOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi01?on_[j
ooWinOohn?SonOWiooShn?ogmoOokNg]omSHf?o1`L7oYJFUoi:BT_nHV9SoZ:RXokZj^_o:b/[ofMWI
on;Rh_oXj>Sok>c/00gok^k^013oiNGUom[Jf_o1`/;oUYZMofihPomEJW[oBV=iodERO?m=KiKoFhJc
of^MdOmi[n[oQKkdohRnmOn;`oSoS<7e<on>a?L04On=`OGoS<7goh[0mOn8_oGoO;;ZoffNdOmMQ[Co
CW6GodMROOm:HgWoEFYjofihPonFVYgo`L;2om[Jf_oUiNGojn_[00Wok^k^000=onKViP0<omgMgOoF
e]KoalO7okNg]onSXj?oTI6Aoj:RX_o;bl_ok^k^ooKfm_olo?coo_kn>oooool03Oono_koo?clooOg
moo_knooc<c<oj>SXonATI7oXj>SokNg]oo7alOoe]KFomgMgOoRh^803OoVi^H03?oMgMgoe]KFolO7
aong]kOoXj>Soi6ATOnRXZ;obl_;onk^k_ofm_Koo?clooknoS_ooooo00goo_knooclo?ogmoOokno_
olc<c?nSXj?oTI6Aoj>SXong]kOoalO7omKFe_oMgMgoh^;R00goi^KV013oemOGokno`?nFV9_oK7Io
oe=XNOm8H7KoAf^?oeV:`?mb[^koO[WdohW2nOn>aocoT/_moiK=o_nIcoooVM3o<onLd_l04OnId?oo
Vm;ooiO?o_nEcOkoSlSloh_4n_n2^oKoMk?`oef?a?m:KI7oB61foe=XNOm/MWooUYRKokno`?oGemOo
h>3P00Woi^KV000=onk^kP0:on;Rh_oFe]Ko`l?3ojj^[_nJVY[o[Jf]omkNg_o[jn_om?Cdoo_kncoo
oooo00_ono_koo?cloo/k>cohN7Qok2`/?nJVY[o[Zj^ol?3`ooFe]Koh^;RonSXj00=onk^kP0:on;R
h_oFe]Ko`l?3ojj^[_nJVY[o[Jf]omkNg_o[jn_om?Cdoo_kncoooooo00_ono_koo?cloo/k>cohN7Q
ok2`/?nJVY[o[Zj^ol?3`ooFe]Koh^;RonSXj00=onk^kP0@olk>c_nRYJWoMGj7oeQ/O?m:I7_oAFnI
oe^Jfom]Z^coN[KdohK2nOnAb_koUm3ooi_BoonMe?ooX=Kooj3Goc?oX]Wo017oXMOooj3GoonPe_oo
WMGooiOAoonBbogoRL;iogjhm?md[NkoI9oPodYbW_m;I7coF6alogEnQonRYJWoc/k>on?Sh`09onk^
kP003Oooool02_o]kNgog=cLolG5aOn/[:co[Jf]omCDe?oPh>3ok>c/ooGemOomoOdoooooo`0;ookn
o_ofm_Kok>c/on;Rh_oIfMWo/K6aojb/[?o5aLGog=cLong]kOofm_H03Oooool02_o]kNgog=cLolG5
aOn/[:co[Jf]omCDe?oPh>3ok>c/ooGemOomoOdoooooo`0;ookno_ofm_Kok>c/on;Rh_oIfMWo/K6a
ojb/[?o5aLGog=cLong]kOofm_H03Oooool04?o3aLKoR96Hof5eQOmBJWoo?fVFodn:comOW=koLJg]
ogjimOn;aO_oTl_noi[AoonOe_ooX][ooj;IoonTf_lcojKJo`0AojGJoonTf_ooX]Wooj3FoonKd_oo
U/gnohk7o?n4_?GoMZo^ofRQhOmIUMGoAVjIoe9ZOomQMHGoR96Hol?5a_o`l?002Oooool000gok^k^
00_of=SHolK6a_n^[ZkoXj>SolK6a_oDe=Coh>3Ponc/k?obl_;oo?clooknoP0=ooooo`03on?ShooF
e]Koo_kn00Cooooo00?ok>c/oogmoOooool00_odm?@;ooooo`03ong]kOo_knoooooo00Cooooo00?o
m?CdonSXj?ooool04?ooool02oojn_[om?Cdon[Zj_oShn?oemOGolg=cOnVYZKo[Zj^olK6a_oHf=So
h^;R00gok^k^00_of=SHolK6a_n^[ZkoXj>SolK6a_oDe=Coh>3Ponc/k?obl_;oo?clooknoP0Roooo
o`03onc/k?o_knoooooo01Wooooo00_on_[jooCdm?oZj^[ohn?SomOGeoo=cLgoYZJVojj^[_o6a/Ko
f=SHon;RhP0=onk^kP0@oiJIW_mYMhKoEG27oceRROlmNL3oDHkCof:Mgomb[NkoOKOcoh_4n_nAbOco
V<knoikDoonOe_ooXMKooj3EoaWoYMOo00?oWLgdoiK3j?nUeol00onUeol2oic<lQ;oYMOo017oY=Oo
oj7GoonPe_ooWmCooi[AoonEbocoSLCioh>km?mf[^coJJ?QoeZCe?m8QLOo@VJ=oeE`QomYMhKoUYVN
om7Ad@09onk^kP003OoVi^H03oo=cLgo^KVioj6QXOn[Zj_oa/K6om;Bd_oLg=coi^KVonc/k?oemOGo
n?Shoo[jn_omoOgoooooooclo007ooooo`0EoijNW_lB4Q;o2@T9obLW9olK6a_oC4a<omWIfOoooooo
DE5Ao`L71olJ6Q[oW9bLoa<C4omGEeOooooood10@?moOgoooOgmoooooonSXj?o71`L00;ooooo013o
iNGUod10@?l0003o4Q8BoadM7Oohn?SoooooonOWiom:BT[o0`<3ob8R8_lG5aOo`L71oooooom0@43o
Ogmo0_ooool00oomoOgoooooooooo`02ooooo`0@oogmoOoooooooOgmoo_knoohn?Som?Cdong]kOoV
i^KogmoOomKFe_o<c<co/K6aoj:RX_ni^KWocLg=om_Kf`goi^KV00oocLg=okVi^OnQXJ7oZj^[olK6
a_oBd];og=cLonKVi_o/k>comOGeooShn?ojn_[ooOgmooooooolo?`02?ooool00oomoOgooooooooo
o`05ooooo`04oogmoOoooooo=SHfojFUY@?ooooo00?o`L71o`000?nKVi/00_ooool01_oKfm_o=CDe
o`h>3_l<30co>3PhomcLg0Kooooo00?ooOgmooooooooool01Oooool00oomoOgoooooooooo`02oooo
o`0@oogmoOoooooooOgmoo_knoohn?Som?Cdong]kOoVi^KogmoOomKFe_o<c<co/K6aoj:RX_ni^KWo
cLg=om_Kf`goi^KV013oO8F=oeacR?m:JHGo;f6Nocei`?m@SLooH9[JofnXiOmj/NkoQKgdohg3m_nB
aoWoV<_loi[=o?nJbo_oW<ol4OnOcod00olV<Sgo@eM[oio?o@03oio?o@0<oi2kiOl^?4Wo0@82oaDL
8_l>4QKoN9booio?oOlG7RCo2@`?oa<I7ol`?TcoVLOd4?nOcod04OnMcocoV/kloi[>o?nIbo_oU<Sj
oho3m_n8_OCoOkG^og>[i_mWX=goFI?CodN3aoliJJ?oBfZ8oeacR?mlQHgo^K^k00Woi^KV000=onk^
kP0Com7AdOnk^k_oXJ6QokJf]_o3`l?oclo?omKFe_oOgmooi^KVon[Zj_o_knoolo?cooCdm?oemOGo
moOgooKfm_ogmoOom_KfooShn002ooOgm`04oi:BT_l20P;oQXJ6ooCdm0;om_Kf00So[:b/om7AdOno
_koo0`<3omKFe_oNg]koEeMGoa0@40;omoOg00Ko?CdmogYjN_ogmoOomoOgoifMWOlK6a/2ooOgm`0@
oclo?olZ:R[oa<C4ooOgmoo@d=3om_KfooOgmom1@D7o?CdmomOGeoogmoOojn_[onWYjOohn?So?Cdm
og]kN`;om_Kf0_ogmoL04oofm_Kon?ShooKfm_ogmoOom_KfooCdm?obl_;ol?3`on_[jooVi^KohN7Q
om[Jf_oCdm?obLW9okno_onVYZKo^k^kom7AdOoQhN403Oo^k^h04ooAdM7o^k^koj6QXOnf][Ko`l?3
olo?cooFe]KogmoOonKVi_oZj^[okno_oo?cloodm?ComOGeooOgmoofm_KomoOgooKfm_ohn?P00_og
moL2ooKfmP;omoOg00Com_KfooShn?ogmoOomoOg0_ofm_H2ooOgm`0<oc@d=?nPX:3omoOgooOgmoo]
kNgo8b<So`000?nFUYKom_KfooOgmolb<S;oCdm?0_oUiND01?mBDU;o<c<cooGemOohn?P2ooOgm`;o
m_Kf0_ogmoL01?ofm_Kon?ShooOgmoogmoL2ooKfmP;omoOg01?om_KfooShn?ofm_KomoOgooKfm_od
m?Col_;boo3`l?o[jn_oi^KVon7QhOoJf][odm?ColW9bOno_kooYZJVok^k^ooAdM7ohN7Q00gok^k^
013oL7j;oeYfT_liG8Ko9VB_ocUg_Om<R<[oFY?CofRQg_mcZnGoO;?ZohFhlOn;_O?oS/7doi72mOnC
a?KoTl?f4OnFaoH00olT<3_o?eAXoiK7mP03oiK7mP0<obPe@OlU<CgoPjkGoiK7m_n>_N[oS[cYoiK7
m_m`UKWoTl?boiG6mOlO:SCoEG6<4?nFaoH04OnEaOKoTlGgoi73mOn?`OCoS;kcohNklOn1]>coNJgU
ofjTh?mRV]OoEHk?od>1a?lbLKSo?6::oeYfT_m`OX_oY:NZ00Wok^k^000=ooooo`0;omoOgoo5aLGo
Y:BTok>c/oo0`<3obLW9om?CdooIfMWogMgMon;Rh_oUiND00_oZj^X00oo/k>cokNg]ong]k@04onk^
kP04onOWiolB4Q;oG5aLoo3`l0Gok^k^00Kob/[:o`820_na/K7ok^k^oiBDU?lM7Ad2onk^kP0;oc/k
>omfMWKol?3`onk^k_nHV9So6QXJonk^k_o=cLgo0000oh^;Roo`l?000oo^k^h01Oo>c/ko0000oj^[
Zoo^k^kol?3`00?ok^k^00Go>c/kogIfM_o^k^kok^k^oo3`l003onk^kP;okNg]0_o/k>`03OoYjNWo
i^KVon?ShooPh>3ofm_KomGEeOo=cLgoaLG5ok^k^on[Zj_oaLG5omoOgoo`l?003Oooool02ooOgmoo
aLG5ojBTY?nc/k?o`<30olW9bOoCdm?ofMWIomgMgOoRh^;oiNGU00;oj^[Z00?ok>c/ong]kOo]kNd0
1oo^k^h00oo`l?3ok^k^onk^kP05onk^kP04oo3`l?o^k^ko<S8boiZJVP;ok^k^00SoKFe]oa4A4OlX
:2SoT92@onk^k_o9bLWo0000ojZZZP;ok^k^00?o[:b/o`000?o=cLd01Oo^k^h00oo`l?3ok^k^onk^
kP05onk^kP04oo3`l?o^k^kok^k^onk^kP;okNg]0_o/k>`03OoYjNWoi^KVon?ShooPh>3ofm_KomGE
eOo=cLgoaLG5ok^k^on[Zj_oaLG5omoOgoo`l?003Oooool04?m`PY7oG7^GobeDR_lQGZ[o<g6iodF1
aOmES/koHYSDofZPfomcZ>3oNjkToh6cj_n5]^_oR;W/ohVik?n:^^dAohblk@03ob8]>OlkCfCoS;c]
00;oS;c]00?oNJ;=o`000?mUQj/01on<_>d00om/TKOo310Doe1/R00@ohblk@0AohZjkOn:^NcoRKW/
ohNhk?n4]>[oO[3TogRZh_maYMgoIYgGoebDd_m>R<Wo?g[0obe[]?laG9;oG7^Gog22TOnRYj/02Ooo
ool000gok^k^00god=3@okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoOgooQhN7o
h^;R00;ohn?S1OoUiND01?nn_[ko0000ojj^[_oVi^H6onGUi@05oibLW?l];Bgo;Bd]oc0`<?lL71`0
0_oUiND02oli>CWoLW9bonKVi_oUiNGoTY:BoaTI6OoUiNGoZZZZo`000?ni^KWoi^KV00?oiNGU00?o
ZZZZo`000?lf=SH00olh>3P01On`/;3oiNGUocTi>OmbLW;oiNGU00;oi^KV0ooUiND2onCTi0;ohn?S
00goh^;Ron3Ph?oLg=cofMWIomKFe_o@d=3obLW9ol71`One]KGoYJFUokRh^?o@d=3oh>3P00gok^k^
00god=3@okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoOgooQhN7oh^;R00;ohn?S
1ooUiND2onKViPKoiNGU0_oVi^H04_oUiNGo<30`oiBDU?oUiNGo]KFeo`820_nCTi?o>3Phoh^;RooU
iNGoZZZZo`000?o>c/koiNGUonKVi_o=cLgo0000ojf][@CoiNGU0_oVi^H6onGUi@;oi^KV0ooUiND2
onCTi0;ohn?S00goh^;Ron3Ph?oLg=cofMWIomKFe_o@d=3obLW9ol71`One]KGoYJFUokRh^?o@d=3o
h>3P00gok^k^013oJ7f>oeYkV?lOAh[o7UNTobe[]?lmN/3oC8K8oeVAcomQV=CoJYkHog6UgOmgZMko
Nj_Oogf]hOmn[^7oP:oS4On4/^<00olO:SKo=d]PohBbh`02ohBbh`03of:4ZOl0003o7bXf00?o82/h
00OoIHR^ohBbhomfWl[o9S=1o`420_ljCVCoOj_J013oQ;;S0_mo[n803omm[^7oO:_QogVZg_mdYmgo
KJ7HofNLe_mPU];oE8c=odJ2a?lhMK_o9V>^obACU?mJNiSoJ7f>oi6IWP09onk^kP003OoVi^H03Oo:
b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`2omkN
gP;ogMgM00CoVi^Ko`000?o3`l?ogMgM0_oNg]h3omgMg@06omkNg_oMgMgogMgMomcLg?n0P83o71`L
0_oMgMd02olg=cOoD51@omgMgOoNg]koR8R8oaTI6OoMgMgo_Kfmo`000?mmOGgogMgM00;og]kN00co
gMgMokfm_Ol0003oU9BDok>c/on/[:co0P82olO7aooMgMgo=cLgofi^K_oNg]h2omgMg@;og]kN0_oM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:
b_oIfMT=onKViP0=ol[:b_ne]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][J
om_Kf`03omcLg0;og]kN0ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM01Gog]kNomgMgOoMgMgo
g]kNobl_;on?Shoof=SHobHV9_m0@43ogMgMocHf=_n6QXKog]kNokjn__l0003oW9bLomkNg_oMgMgo
VYZJo`000?o3`l<00ooMgMd00ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oN
g]h2omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne
]KGob/[:omWIf@goi^KV013oIgb=oeYkVOlB=hOo6djNobAQ[_lcLKWo@Wg1odj7b?mGT<goH9K@ofNK
e?m/X=OoL:;Hog>Tf?mcYMSoMZKI4?mhZ=`01?mYTl7o0`D6o`hD6_mcXM<2ogRXg00;ofN@_?l0003o
D72Cof68/_mMPj_o0@42of^FaOmhZ=co7RXhoal[>?mWT;`04_mhZ=`04OmfYmWoMZKIog>Uf?mbY=So
KJ7GofZNe?mTV=;oGY?>oeF=c?m:Q<Go?WZoobi]]olPFjSo64JBoeYkVOmWO8goSYFI00Woi^KV000=
onk^kP0=omCDe?no_kooS8b<oijNW_n][Jgo^KViol;2`_o7alOoc<c<om3@d?oBd];oeMGEomKFeP02
omOGe`03omSHf?oIfMWofMWI00;ofMWI00?oZJVYo`000?nb/[801ooIfMT01OnIVIWo^KViomKFe_mB
DU;oAdM700;ofMWI00Ko=SHfoa4A4OmTI6Co_;blodY:B_m1@D42omWIf@05ocDe=OlQ8B7oXJ6QomSH
f?nl_;`00_oIfMT01Ole=CGoFe]Kom;Bd_n6QXKo92@T00;ofMWI00?o=SHfofa/K?oIfMT01OoIfMT2
omSHf0;oemOG00goeMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo_knookFe]OnYZJWoV9RHokno_ooDe=Co
h^;R00gok^k^00goe=CDokno_on<S8coWYjNojf][Oni^KWo`/;2olO7aoo<c<cod=3@om;Bd_oEeMGo
e]KF00;oemOG00?of=SHomWIfOoIfMT03ooIfMT02?l];BgoS8b<ofa/K?l;2`_o`L71omWIfOle=CGo
Ph>30_oIfMT01_lg=cOo?Cdmokbl_?nl_;co?3`locTi>A;ofMWI0_oHf=P2omOGe`0=omGEeOoCdm?o
d=3@olk>c_o:b/[oaLG5okno_one]KGoZJVYoiRHV?no_kooe=CDon;RhP0=onk^kP0@of^0SomMOY_o
3Rn0oaI2U?lNEJCo:6FaocQe_?m3OL7oCHO7oeJ=bomLTLkoHIO@ofFId_mWVm;oJYgCof^Me13oKj3F
00Co9CE8oa0G7olN:c[o<dYS0om_X=H01OlK9cCo;T=Iof^Jcom4HhCo4QXT00;oKj3F00Go5b8^od5N
OOm_X=KoI972ofbLd@0@ofnPeP;oJigD00ooJIcBofNKd_mUV=7oH9G?oeV@bomCRl[oBXC5ocmk`?la
KkSo8V2^oa]AX?lD?8coGGjKof^0SonDVIh02Oo^k^h000gooooo00goj>SXomCDe?n<S8coTi>Coj:R
X_n_[joo^[Zjol71`Oo7alOobl_;olk>c_o@d=3odM7A00;odm?C0ooDe=@2omGEe@04olK6a_l10@7o
Ph>3omGEe0;oe=CD0_oEeMD05_oFe]KoeMGEog=cLolY:BWo3@d=obl_;onSXj?oeMGEomKFe_m6ATKo
MGEeofEUI?l@413o9RHVoj>SXooEeMGoe]KFol71`Om9BDWo30`<o`T92OlO7al2omGEe@0<ol71`Olk
>c_o2PX:oaLG5onHV9Soe=CDomGEeOle=CGoJVYZomGEeOoFe]KoeMGD0_oDe=@2omGEe@0@omCDe?oC
dm?odm?Com7AdOo@d=3ocLg=ol[:b_o3`l?o_[jnokJf]_n[Zj_oWIfMoiFEUOoDe=Coj>SXoo?cl`go
oooo00goj>SXomCDe?n<S8coTi>Coj:RX_n_[joo^[Zjol71`Oo7alOobl_;olk>c_o@d=3odM7A00;o
dm?C0ooDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;oe=CD0_oEeMD04OoFe]KoeMGEomKFe_oEeMCo
e=CDob`/;?mTI6Co10@4oginO_oEeMGoe]KFoc@d=?n0P83oe=CDomGEeOo1`L7oA4A400;o30`<00?o
ATI5ol71`OoDe=@00_oEeMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE00Coe]KFomGEeOoFe]Ko
eMGD0_oDe=@2omGEe@0@omCDe?oCdm?odm?Com7AdOo@d=3ocLg=ol[:b_o3`l?o_[jnokJf]_n[Zj_o
WIfMoiFEUOoDe=Coj>SXoo?cl`gooooo013oLXJFof61XOlD<7Ko43J9oaQ7VOlNF:Oo:6JcocEb^_m2
OL7oC8G6oe:;bOmIT<_oGi?=of:FcomRU]3oHYO?3omVV]401_m>MIoo0000odQ/TomHQKGo1@P;oeB0
[@;oIY[A00GoG8Zloa`Z>_l51`[o2a0FodU^U@02ofJJd@05odacW?lG8boo1PT=o`L;3omLS;h04?mV
V]404OmUV=3oHiO@of:FcomPULooG9;=oeN?bomAR/[oAX;4ocah__laK[So9F:^oaaCXolE@I?o6C^1
of61XOmbQYKoWjFZ00Wooooo000=onk^kP0BomgMgOo=cLgoT92@ohV9ROnGUiOoYJFUok:b/_no_koo
bl_;om7AdOoEeMGoemOGomWIfOoJf][ofm_Kom[Jf_oKfm_og=cL0ooKfm/01OmEEEGo7alOol_;booK
fm_og=cL00Kofm_K00?ofMWIomcLg?oKfm/01OoKfm/00ooJf][og=cLom_Kf`05om_Kf`03omSHf?oL
g=cofm_K00?ofm_K00Oof=SHom_KfooKfm_og=cLom_Kfolf=SKoKFe]00Cofm_K01?og=cLom_KfooK
fm_ofm_Kom[Jf_oIfMWof=SHomKFe_oCdm?ocLg=ol;2`_nf][Ko[:b/oinOWon@T93oUYJFolg=cOoM
gMgoiNGU00gok^k^01;ogMgMolg=cOn@T93oRHV9oiNGUonUYJGo/[:bokno_oo;bl_odM7AomGEeOoG
emOofMWIom[Jf_oKfm_of][Jom_KfooLg=`7om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?o;Rh^o`@4
1?lf=SH00ooKfm/00olf=SKoQHF5omcLg003om_Kf`;of][J0_oKfm/00ooLg=cofm_Kom_Kf`05om_K
f`03omcLg?oKfm_ofm_K00Gofm_K01?og=cLom_KfooKfm_ofm_Kom[Jf_oIfMWof=SHomKFe_oCdm?o
cLg=ol;2`_nf][Ko[:b/oinOWon@T93oUYJFolg=cOoMgMgoiNGU00gok^k^013oL8:Aof>3WolS>g?o
32]noa4iS_lHB9_o8EbZocEa^?mAQlGoI9K<of^LdOm`X=;oMjGEogRUe_mkYmOoNZOG3_n0ZmL00omo
Z]Ko6B8[ob<_>`02oh2[e`03od9IL?lN:3?oP:_G00?oP:_G00?oOZSDoh2[eon0ZmL01?n0ZmL00omn
Z=CoP:_Goh2[e`0@oh2[e`0Aog^WeomlYmOoNZOGogRUe_meX]GoKikBofJHcOmERlKo>gJkobAQ[_lL
DZ?o5D:Fo`hbQOlU?gWoHh>Oog22TOnNXZH02Oo^k^h000goi^KV00_of][Jolk>c_nLW9coNWYjohR8
R?nFUYKoZZZZolC4a?oEeMGofm_KomkNgP02on3Ph0?oh^;R00?oi>CTon?ShooShn<00_oShn<02?oA
dM7o>CTioaXJ6_m]KFgoQXJ6ofMWIolZ:R[oZJVY0ooShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<01OoTi>Cohn?Son?Sholh>3SoLG5a00?o
hn?S00Coi>CTon?ShooShn?ohn?S0_oRh^803_oQhN7oh>3PomoOgooLg=coemOGolG5aOn/[:coWYjN
oi2@T?n2PX;oX:2Polk>c_oJf][oh>3P3OoVi^H02ooJf][oc/k>oibLW?mjNW[oR8R8oiJFU_nZZZ[o
a<C4omGEeOoKfm_og]kN00;oh>3P0ooRh^800ooTi>Cohn?Son?Sh`05on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00Coi>CToc0`<?l820So`l?30ooShn<00olh>3SoRXZ:on?Sh`06on?Sh`03onCTi?oShn?o
hn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<01?oTi>Cohn?Son?ShooShn<2on;RhP0>on7QhOoP
h>3ogmoOomcLg?oGemOoaLG5ojb/[?nNWYkoT92@oh:2P_nPX:3oc/k>om[Jf_oPh>0=onKViP0@ogZ5
TOmSOiOo>U5io`DLKol::7go43R<ob=CX_mAP;koN:;AohB/eon</][oT[GLoi>gg?nE^MkoUk_NoiRk
gPkoVkgP00?oH7F:o`820on2W[/00_nK_N000onG^M_o6AlTof1eRP0Moi^mh00AoiVkgonJ^mkoV;_N
oiJig_nC^=coSk?JohN_f?mhY=;oCH6oob1DY?lD@9?o3C26o`LRN?ljDgcoHgnGogZ5TOnXZjd02OoV
i^H000gok^k^00koiNGUomgMgOo2`/;oNg]kogQhN?n6QXKoWinOolG5aOoHf=SogMgMomoOgooQhN7o
h^;Ron?Sh`?oi>CT1?oUiND02?oTi>Cohn?SoinOWombLW;oGUiNog]kNonKVi_oemOG0_oTi>@00ooU
iNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU
00?oiNGU0_oTi>@01_oUiNGoi>CTonGUiOoUiNGo>CTiog9bLP;oi>CT00CoiNGUonCTi?oUiNGoiNGU
0ooTi>@03_oShn?ohN7Qon3Ph?oOgmoof][JolK6a_nQXJ7oSHf=oh20P?n4Q8Co`l?3omgMgOoUiNGo
j^[Z3Oo^k^h03_oUiNGogMgMol;2`_mkNg_oN7QhohJ6Q_nOWiooaLG5omSHf?oMgMgogmoOon7QhOoR
h^;ohn?S0ooTi>@4onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi004onGUiOoTi>CoWYjN
ojZZZP;oiNGU0_oTi>@00onQXJ7o`L71onGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2
onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@01?oUiNGoi>CTonGUiOoUiND3onCTi00>on?ShooQ
hN7oh>3PomoOgooJf][oa/K6oj6QXOn=SHgoP820ohB4Q?o3`l?ogMgMonGUiOoZj^X=onk^kP0>oiFL
X?m_PY?oFW:<oaDYI_l26fgo22Ilob=7U_mUQ[goSj_DoiNdf_nG]m[oV[_Noibmg_nP_ml2oj;0h0ko
Xl7P00?oLHFKog>8W_nS`N000onS`N000on7X;[oKX:Goj?1h00Loj?1h00Aoj?0h?nR`>3oXL3Poino
gonJ_=koV;WKoiZgf_n?[]GoHHNooae7Uol;;8?o1AmeoaH]K?mJLXcoKh:CoiFLX?o:bl/02Oo^k^h0
00gooooo00_onOWioo?clooYjNWoZ:RXofEUIOmcLg?oSHf=ok^k^ooDe=Cof][JomgMg@02omoOg`03
on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03
on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@03on7Qh@03
omgMgOoOgmooh^;R00SohN7Q00koh>3PomoOgooMgMgog=cLomGEeOni^KWoSXj>og]kNom^KVkoZj^[
onWYjOoclo?onOWioogmo@gooooo00_onOWioo?clooYjNWoZ:RXofEUIOmcLg?oSHf=ok^k^ooDe=Co
f][JomgMg@02omoOg`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;o
hN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;o
hN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00KohN7Q00koh>3PomoOgooMgMgog=cLomGEeOni^KWo
SXj>og]kNom^KVkoZj^[onWYjOoclo?onOWioogmo@gooooo013ob/_;ohfGX?maQYOo?UAko`0BF_l0
5fSo5bn2of1g/_nBY/koVk3Eoinef?nP^][oX;[Koj6kfonQ_M_oXKkM<onP_]d04OnP_MgoX;cKoj:n
gOnP^m_oXK[KoifgfOnM]=KoT:K?oeIb/?lB;h?o0a]`o`0FHolnEWgoLHJGohfGX?o:bl_olO7a00Wo
oooo000=onk^kP0<on_[jooXj>Soh^;RomOGeon=SHgoHV9RogIfM_nTY:CoalO7om;Bd_oEeMGof=SH
0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_K
fooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg00Dom_K
fooLg=cog=cLom_KfooLg=cofm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGoW9bLogEeMOmWIfOoT92@omOG
eooRh^;oj>SXon_[joo]kNd=onk^kP0<on_[jooXj>Soh^;RomOGeon=SHgoHV9RogIfM_nTY:CoalO7
om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcL
g005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcL
g005omcLg00Dom_KfooLg=cog=cLom_KfooLg=cofm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGoW9bLogEe
MOmWIfOoT92@omOGeooRh^;oj>SXon_[joo]kNd=onk^kP0@omoOgonUZZgoNXRCofR1V?l^@6co011F
o`XPJOm4FI[oPHnooiFTbonIZ/ooWK3Coj2ceOnO/mGoWkCFoineeS?oWkKG017oWkGFoj2fe_nO/mGo
WK7Eoij`e?nL[M;oTjC=ogZ<_OlbAi7o0QUYo`0CGOl^@VooJ86HogZ8TonUZZgogmoOong]k@09onk^
kP003OoVi^H03_oUiNGoh^;RomoOgooJf][obLW9ohN7QomJFU[oNg]koj>SXonl_;coa/K6ol_;boo=
cLgoclo?0_oAdM45om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooA
dM7od];Bom7Ad@03om;BdP;odM7A00god=3@olo?coo<c<cob<S8ok^k^onLW9coLW9boe]KFon:RX[o
bLW9om[Jf_oOgmooh^;R00;oiNGU3OoVi^H03_oUiNGoh^;RomoOgooJf][obLW9ohN7QomJFU[oNg]k
oj>SXonl_;coa/K6ol_;boo=cLgoclo?0_oAdM45om;BdP03om7AdOoBd];odM7A00God];B00?odM7A
om;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7A
om;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@03om;BdP;odM7A00god=3@olo?coo<c<cob<S8ok^k
^onLW9coLW9boe]KFon:RX[obLW9om[Jf_oOgmooh^;R00;oiNGU3OoVi^H04?oUiNGo`lC4oi>HWOma
PY3oH7R?obhnJ?l23U3o6ba`odiOVOmdQ;CoQIBnohbI`on@W<OoTIo8oiFSbOnDY<Tcoi>TbP0?oiBT
bOnDXlWoUJ;9oi>Qb?n>V/GoQiC1og20/_lmDI3o2aiWo`0=D_l^@6_oH7R?og62T?nCV9go`lC400;o
iNGU2OoVi^H000gok^k^0_o]kNd03_oZj^[oj>SXon;Rh_oLg=coW9bLofe]KOmXJ6SoPh>3oiNGUonS
Xj?o[:b/ojn_[ona/K7o/[:b0_nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@04one]KGo
][JdokBd]?nd];Co][Jfok>c/onb/[;o/k>cojn_[onZZZ[oW9bLoh:2P_mRHV;oKVi^oinOWooLg=co
h^;RonSXj?oZj^X00_o]kNd>onk^kP;okNg]00koj^[ZonSXj?oRh^;og=cLoibLW?m]KFgoJ6QXoh>3
PonGUiOoXj>Sojb/[?n_[joo/K6aok:b/P;o];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2
okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
01?o]KFeokJf]?nd];Co];BdokJf]_nc/k?o/[:bok>c/on_[jooZZZZoibLW?n2PX;oHV9Rofi^K_nO
Wioog=cLon;Rh_oXj>Soj^[Z00;okNg]3_o^k^h04?o]kNgoh^;Rokno`?nCVZ3oMHJDofZ3VOloDgSo
6BAIoa<NG_l]>gSoAEB<oe=SVOmOKZ7oHW:UofAdYomSM:LcofQi[00@ofIgZOmVMZSoJ7NXof=cYOmL
K9ooB5V@obLgMOl85EOo5b=HocmCNOmZPiWoMHJDoi>JX?no_l3oh^;Rong]k@[ok^k^000>ooooo`;o
o_kn00ooo?clooWinOofm_Kol_;bomWIfOnXZ:SoPh>3ofi^K_mUIFGoJFUYog9bL_mdM7CoNGUiogal
O?mkNg/00_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@07ogalO?mkNg_oO7al
ogemO?mlO7coNg]kogemO@02ogYjNP0;ogMgMomdM7CoKfm_ogAdM?n5QHGoZ:RXom[Jf_obl_;om_Kf
ooWinOolo?`00_ono_h@ooooo`;oo_kn00ooo?clooWinOofm_Kol_;bomWIfOnXZ:SoPh>3ofi^K_mU
IFGoJFUYog9bL_mdM7CoNGUiogalO?mkNg/00_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k
0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@07ogalO?mkNg_oO7alogemO?mlO7coNg]kogemO@02ogYjNP0;ogMgMomdM7CoKfm_ogAd
M?n5QHGoZ:RXom[Jf_obl_;om_KfooWinOolo?`00_ono_h@ooooo`0?ookno_oclo?oclo@ojJY[_n1
Si_oLXRKof1kU_m1EGWo:SQRoaTTF?lB75Ko5R9OoadYIOlO:fOo8c1]03?o9CAa00oo935_obDaKOlT
<6_o7b]WoaTSG_lK:5go:SMTod5EN?mPNiOoLXRKoh6?VonVZJkoclo@oo?cloono_h02oooool000oo
k^k^0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;RhP03on3Ph?oOgmoog]kN03WogMgM00?og]kNomoO
gooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/k>`2ong]kA;ok^k^0_o]kNd01?o/k>coj^[ZonSXj?oU
iND2on;RhP03on3Ph?oOgmoog]kN03WogMgM00?og]kNomoOgooPh>000_oRh^801?oUiNGoj>SXon[Z
j_o/k>`2ong]kA;ok^k^00WokNg]on;Rh_o<cLgoZ:^^ohjEW?mgQi?oL8FGof^8X_m[SJP00_mZSJX3
ofV;Z@03ofV6XOmYRjWoJH^Y00CoJH^Y0_mYQZ46ofV;Z@;oJHJQ1_mYRjT2ofV6X@KoJH^Y0_mYQZ46
ofV;Z@;oJHJQ1_mYRjT2ofV6X@GoJH^Y0_mZSJX02Om[SJSoJhRRog25UomgQi?oSYFLojR[[_o<cLgo
h^;Rong]k@0<onk^kP004OoVi^H2onGUi@03onCTi?oRh^;oh^;R00;oh>3P0_oOgmliomkNgP;ogmoO
0_oPh>02on;RhP03onCTi?oUiNGoiNGU01Koi^KV0_oUiND00ooTi>Coh^;Ron;RhP02on3Ph0;ogmoO
>OoNg]h2omoOg`;oh>3P0_oRh^800ooTi>CoiNGUonGUi@0FonKViP07onGUiOoJf][oa/O7oj:VZOn<
U9[oNXRCogF6U002og:4U@?oLH>D00?oO8RBogB5TomaPi@00omaPi@01?mdQI?oO8RBogb8T_mdQI<4
og63U004ogB5TomlR9;oO8RBogB5T`CoLH>D00CoM8FCogb8T_mlR9;oM8FC1?maPi@01?mdQI?oO8RB
ogb8T_mdQI<4og63U004ogB5TomlR9;oO8RBogB5T`CoLH>D00CoM8FCogb8T_mlR9;oM8FC1?maPi@2
og:4U@07ogF6U?mjR9?oS9BJoj:VZOo6alOof][JonGUi@0>onKViP00ooo^k^h]onk^kP00ooooool]
ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]
onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]
onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]
onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP009Oo^k^h00oo/k>coj>SXon[Z
jP3oonk^kPGok^k^000Tooooo`05oo_knoo[jn_obl_;onOWioono_h0ooooool4ooooo`008?o^k^h3
ong]k@06onKVi_o>c/koUiNGohn?Sonf][KokNg]ooo^k^h4onk^kP006ooVi^H03_oUiNGohn?Son3P
h?oMgMgof][JomOGeooFe]Kodm?CokBd]?n4Q8Co_knoolO7aonYZJWoiNGUoooVi^H4onKViP006Oo^
k^h04Oo]kNgojNWYon3Ph?oBd];o`<30ojf][OnOWiooV9RHoiFEUOn@T93oS8b<on?Shoo`l?3ob/[:
ojZZZ_oXj>SokNg]0?ook^k^0oo^k^h001Sooooo00cono_konk^k_oAdM7oZZZZohn?SonEUIGo[Jf]
olK6a_o@d=3od];BomOGeooemOD2ong]k@05omcLg?nBTY;odm?Conc/k?okno/0ooooool2ooooo`00
5_o^k^h03_o]kNgoiNGUol[:b_nJVY[oRXZ:ol;2`_o]kNgonOWiooKfm_obl_;okno_oo3`l?o^k^ko
k>c/0_o`l?001ooalO7ob<S8oh^;RonJVY[ob/[:onGUiOo]kNd0ooo^k^h001Goi^KV00WoiNGUom[J
f_nb/[;oQHF5olC4a?ogmoOolo?cong]kOo^k^h00_o`l?001?ogmoOolO7aooOgmoobl_83oo7al@07
oo?cloogmoOoa<C4ohF5QOnb/[;of][JonGUi@3nonKViP005?o^k^h02?o]kNgoh^;Rok:b/_n?Shoo
k>c/oo?cloo^k^kolO7a0_obl_801_o`l?3on?ShokRh^?mZJV[oWIfMooCdm0?ol_;b00SolO7aonk^
k_oclo?ok>c/ohn?Sonb/[;oh^;Rong]kGkok^k^00Go/k>cogYjN_mJFU[oL71`ol30`01jonk^kP00
5?ooool01_oinOWob/[:oiNGUoohn?Sokno_oo;blP?olo?c00Wol_;booGemOoYjNWoI6AToeUIFOmD
E5CocLg=oo_knooalO400ooclo<01_obl_;okno_ooShn?nGUiOob/[:ooWinGkooooo00KoRHV9ogIf
M_nUYJGoHf=So`/;2onl_;aiooooo`004oo^k^h01Oo]kNgod];Bohf=SOo`l?3okno_00Gom?Cd00Wo
lo?cooGemOo`l?3oLG5aodi>C_mKFe_of=SHoo[jn_oclo<01Oodm?@01Oo_knool?3`ohf=SOoBd];o
kNg]02Sok^k^00?og=cLomoOgoo^k^h04oo^k^h00ooLg=cok>c/onk^kP02on?Sh`Ook^k^00?oj^[Z
omSHf?o^k^h05_o^k^h00ooShn?of=SHonk^kP03onk^kP;ohN7Q1Oo^k^h2on7Qh@Gok^k^00?og=cL
onc/k?o^k^h00_oShn<5onk^kP03oeADE?m2@T;ok^k^00?ok^k^00?ohn?SomSHf?o^k^h00oo^k^h2
on7QhA;ok^k^00?og=cLomoOgoo^k^h0F?o^k^h001?oi^KV00GogmoOoijNW_o<c<comOGeooCdm006
ooGem@07ooCdm?okno_oe]KFoiNGUoo2`/;on_[jooCdm006ooGem@05ooCdm?oemOGoc<c<oijNW_oO
gml07ooVi^H00ol`<33oJ6QXonKViP04onKViP06olG5aOl_;boo30`<o`X:2_lc<c?oa/K60_oVi^H0
0oli>CWoLW9bonKViP02onKViP03olo?col0003oNWYj00;oi^KV00?o@D51ob@T9?oVi^H00_oVi^H0
2Om9BDWo1`L7oaLG5on<S8co4A4Aodi>C_oVi^Ko>CTiog9bLP03onKViP06oj>SXol<30co0@41obPX
:?n4Q8Co3`l?1_oVi^H01_li>CWoLW9bonKVi_oVi^KoKVi^oc`l?0;oi^KV013oXZ:Ro`P82?oVi^Ko
i^KVom3@d?m2@T;o0P82oalO7olD51Co[Zj^onKVi_lQ8B7o3Ph>oa`L7?m5ADGogMgM0_oVi^H01OlQ
8B7o3Ph>oa`L7?m5ADGogMgM00;oi^KV00goBDU9o`L71olG5aOoS8b<oa4A4Om>CTkoi^KVom3@d?mC
De?o<c<cofi^K_n=SHgo6a/K00;oi^KV00cod=3@od92@_l20P;o7alOoa@D5?n^[Zkoi^KVob4Q8Ol>
3Pko71`LodE5AOoMgMd6onKViP06ocTi>OmbLW;oi^KVonKVi_nCTi?o6ATI0_oVi^H01_o5aLGo;bl_
o``<3?l:2P[o<c<colK6aP;oi^KV00?oclo?o`000?mjNWX00_oVi^H00om1@D7o92@TonKViP02onKV
iP03ohN7QolT92Coi^KV04Soi^KV000Conk^kP04omKFe_nATI7onOWioo;blPSom_Kf00GomOGeoocl
o?oBd];olo?cooShn008ooKfmP04oo;bl_oinOWoTI6AomKFeQook^k^00?o<S8bofa/K?o^k^h00oo^
k^h00oo]kNgo<30`oda<C002omkNgP06odm?Cola<C7okNg]onk^k_lk>c_oMWIf0oo^k^h03onCTi?o
3Ph>ocDe=Oo^k^koinOWo`T92Ol>3PkoaLG5onk^k_nh^;So0`<3olk>c_oFe]KoE5ADo`l?3`02onk^
kP03oc/k>omfMWKok^k^00;ok^k^00Ko;bl_oeADE?oMgMgo_;blobXZ:_l?3`l6onk^kP06oc/k>omf
MWKok^k^onk^k_maLG7o?Shn0_o^k^h04?nXZ:So20P8onk^k_o^k^ko?clooc/k>oo@d=3ok^k^on;R
h_oQhN7ok^k^ok>c/ooZj^[okNg]oc8b<_n8R8P2onk^kP0<ok>c/ooZj^[okNg]oc8b<_n8R8Sok^k^
okRh^?l30`?oc/k>omKFe_mDE5Co3`l?0_o^k^h01_m7AdOo:RXZoiNGUomcLg?o:RXZoa8B4P;ok^k^
00co?clooc/k>oo@d=3ok^k^on;Rh_oQhN7ok^k^ok>c/ooZj^[okNg]oc8b<_n8R8P6onk^kP0:oc/k
>omfMWKok^k^onk^k_nHV9So6QXJonk^k_o]kNgo<30`oda<C0;og]kN00coCdm?oc4a<Oo]kNgok^k^
oi>CTol>3Pko=CDeonk^k_oWinOo2@T9o`h>3_o5aLD2onk^kP03omGEeOnl_;cok^k^04Sok^k^000B
ooooo`05ookno_o8b<So_;bloo[jn_ofm_H01oogmoL01oofm_KonOWioo;bl_mRHV;oc/k>oooooooe
mOD01oogmoL01Oofm_Kon_[jokbl_?o8b<Soo_kn01kooooo00?o=SHfogAdM?ooool00oooool00ooH
f=So0000okNg]`02ooooo`06okNg]ol0003og=cLoooooom0@43oOgmo0oooool03omEEEGoLg=coa`L
7?oXj>So_Kfmob4Q8Om^KVkoPH61oooooooIfMWo0`<3okfm_OooooooWinOob0P8002ooooo`07od10
@?moOgoooooooooooooXj>So0@41olG5a@02ooooo`03oj^[ZolA4A7ooooo00Gooooo00Ko@410ogmo
OoooooooooooogYjN_m3@d<2ooooo`06okBd]?l92@WoooooomgMgOl0003o^;Rh1oooool00oo5aLGo
5QHFoi>CT`04ooooo`0>olG5aOlF5QKoTi>CoooooooIfMWo0`<3okfm_OooooooWinOob0P8?oooooo
m_Kfo`T92Oni^KT2ooooo`06oiJFU_lA4A7oooooomgMgOl0003o^;Rh1oooool00oo5aLGo5QHFoi>C
T`06ooooo`0:od10@?moOgoooooooooooonSXj?o71`LoooooooHf=So0000okNg]`;ooooo00co]kNg
o`000?oLg=cooooooeEEEOmcLg?o71`LonSXj?nm_Kgo8B4Qofi^K_n1PH42ooooo`03olc<c?nFUYKo
oooo04Sooooo000Bonk^kP04on_[jonSXj?oh>3PooKfmPSon?Sh00OomoOgoogmoOoVi^KoFUYJol30
`?oooooom_Kf00Son?Sh00Com_Kfon3Ph?nSXj?ojn_[7_o^k^h00olb<S;oK6a/onk^kP03onk^kP03
ok6a/Ol0003oe]KF00;ok^k^00Koe=CDo`000?nd];Cok^k^oc/k>omfMWH2onk^kP09on[Zj_l>3Pko
/;2`of5QHOn?ShooKfm_oemOGonc/k?o:RXZ00;ok^k^00GoXJ6Qobh^;_l_;boo<S8boadM7@02onk^
kP07oc/k>omfMWKok^k^onk^k_nc/k?o0000omKFeP02onk^kP03oj2PX?l?3`ook^k^00Gok^k^00Ko
>c/kogIfM_o^k^kok^k^og5aLOln?Sh2onk^kP06ojRXZ?l820Sok^k^ok6a/Ol0003o>3Ph0olj>SX0
1onf][Kok^k^omCDe?m5ADGo0P82ofUYJOoUiND00_o^k^h01OoDe=CoADE5o`820_mYJFWoiNGU00;o
k^k^00WoXJ6Qobh^;_l_;boo<S8boadM7Oo^k^ko]KFeo`000?oFe]H00_o^k^h01_nPX:3o3`l?onk^
k_na/K7o0000ocPh>0?o>SXj00Oo][Jfonk^k_oDe=CoADE5o`820_mYJFWoiNGU00Kok^k^00[o>c/k
ogIfM_o^k^kok^k^oiRHV?lJ6Q[ok^k^ok6a/Ol0003oe]KF0_o^k^h03?oDe=Co0000okBd]?oZj^[o
3Ph>ok2`/?mQHF7oShn?ofm_KomOGeoo/k>cobXZ:P;ok^k^00?oYJFUoaTI6Oo^k^h0B?o^k^h001;o
i^KV00Coh^;RoiFEUOo^k^kom_Kf2?ojn_X01oohn?SoooooomKFe_m@D53o[:b/ooooooogmoL02?oj
n_X01?ofm_Kok^k^oiFEUOoRh^8NonKViP09oc0`<?lK6a_o?Cdmocdm?OmIFEWoi^KVolK6a_l0003o
XZ:R00;oi^KV00KoX:2Po`000?o:b/[oi^KVocTi>OmNGUh2onKViP0:ojn_[ol:2P[oh>3PojBTY?m3
@d?o;2`/oiVIVOoTi>Co4a<ColC4a0?oi^KV00?oi>CTohF5QOlM7Ad00_oVi^H01oli>CWoGUiNonKV
i_oVi^Kob/[:o`000?nPX:000_oVi^H00onKVi_o3`l?onKViP05onKViP0FocTi>OmRHV;oi^KVonKV
i_m]KFgo;Rh^onGUiOoVi^KoXJ6Qo`P82?oVi^KoaLG5o`000?nJVY[o^[Zjok>c/ol20P;oc/k>onKV
i_lj>S[o>c/kolG5a@Coi^KV00?o>SXjoc/k>oo5aLD01_oVi^H01ooTi>CoQHF5oadM7OoVi^Koa<C4
o`000?nSXj<00_oVi^H03_nKVi_o3`l?onKVi_o5aLGo0000oiZJV_nj^[[o/k>co`820_o>c/koi^KV
ocXj>_lk>c_oaLG52?oVi^H02_li>CWoDe=ConKVi_oVi^KoSHf=oaXJ6_oVi^Koa/K6o`000?nRXZ82
onKViP0Aoj2PX?l0003ob/[:ojn_[ol:2P[oh>3PojBTY?m3@d?o;2`/oiVIVOoTi>Co4a<ColC4a?oV
i^Kog=cLob0P8?nYZJT0B?oVi^H001;ok^k^00Coj^[ZoiRHV?o_knoomoOg2?okno/01ooinOWooooo
ol71`Om<C4coV9RHoooooooinOT02?okno/01?ogmoOokno_oiRHV?oZj^XNonk^kP05oc8b<_mADE7o
/k>cok>c/onl_;`00_o^k^h01_ll?3co@d=3olo?coo>c/ko@T92oclo?`;ok^k^01Co>c/koa4A4On7
QhOoe=CDofm_Kom7AdOok^k^onOWiol@413o0P82omgMgOo^k^koGemOogemOOo^k^koZ:RXol_;boo[
jn_oFUYJodi>CP;ok^k^00_o>c/koa4A4On7QhOoe=CDonc/k?ln?Sko@D51om?CdooKfm_oC4a<o`l?
3`06onk^kP0:oc/k>olC4a?oPX:2omSHf?lj>S[o71`LoeUIFOoBd];oJFUYobl_;`;ok^k^00Go>SXj
of=SHooVi^KoTi>CobPX:002onk^kP05oc<c<on<S8cok^k^omSHf?oYjNT00_o^k^h01Olc<c?oS8b<
onk^k_oHf=SojNWY00;ok^k^00GoZ:RXol_;boo[jn_oFUYJodi>CP02onk^kP06ocLg=om1@D7od];B
on3Ph?m@D53o3`l?0_o^k^h01Olj>S[oHf=SonKVi_nCTi?o:2PX00;ok^k^00Go<c<cohb<S?o^k^ko
f=SHonWYj@06onk^kP06oc/k>olB4Q;oKVi^olo?comADE7oAdM70_o^k^h04Oll?3co@d=3olo?coo>
c/ko@T92oclo?oo^k^koL71`odM7Aoo^k^koinOWoa0@4?l20P;ogMgMonk^k_mOGeooOGem00;ok^k^
00?o_[jnoaHF5_nn_[h0Aoo^k^h001;ooooo00Coo?cloj^[Zoo[jn_onOWi2?olo?`01ooinOWooooo
oj^[Zom@D53oPh>3oooooookno/02?olo?`01?oinOWojn_[oj^[Zoolo?`Nooooo`03ocHf=_mdM7Co
oooo00Cooooo00Koj>SXoe9BD_l?3`oo3`l?oeADE?oYjNT2ooooo`06oeADE?n9RHWoGEeMo`T92Om5
ADGoWYjN0_ooool03?mQHF7oADE5oooooooooooo_Kfmode=COooooooRXZ:oc8b<_l@413o>CTiolC4
a0;ooooo00_oE5ADohV9ROmMGEgo2@T9oo3`l?oVi^KoA4A4o``<3?lX:2SoKFe]oa4A4@06ooooo`0:
oeADE?n;Rh_oLG5aoa0@4?lX:2SoeMGEoiZJV_lJ6Q[o820Pojf][@;ooooo00Goi^KVodM7Aol=3@go
71`LokNg]`02ooooo`05okno_olj>S[o410@oa<C4ooXj>P00_ooool01Ono_koo>SXjoa0@4?lC4a?o
j>SX00;ooooo00GoRXZ:oc8b<_l@413o>CTiolC4a002ooooo`06on?Shom4A4Co2`/;obTY:OmfMWKo
:RXZ0_ooool01OoVi^KoAdM7o`d=3OlL71co]kNg00;ooooo00Go_knoocXj>_l@413o4a<ConSXj006
ooooo`06oeADE?n<S8coNGUioa@D5?l^;Rkoa<C40_ooool02OoXj>SoDU9Bo`l?3ol?3`ooE5ADonWY
jOooooooBTY:oijNWP02ooooo`06of5QHOm5ADGooooooooooonm_KgoCDe=0oooool00on;Rh_o6ATI
ooGem@16ooooo`004_o^k^h01?o]kNgo];Bdom?Cdoolo?`8oogmo@08oo_knoooooooU9BDoeEEEOmc
Lg?om_Kfooooooolo?`7oogmo@04ooclo?oCdm?o];Bdong]kAkok^k^00?o<S8bofa/K?o^k^h01_o^
k^h2ong]k@Ook^k^00?ojn_[onk^k_o^k^h02oo^k^h00oo/k>cok^k^onk^kP05onk^kP08on_[joo^
k^kok^k^onk^k_o/k>cok^k^oj2PX?l?3`l9onk^kP03ong]kOo^k^kok^k^00;ok^k^00?okNg]onk^
k_o^k^h00oo^k^h00oo[jn_ok^k^onk^kP04onk^kP03on_[joo^k^kok^k^00Cok^k^00?ojn_[onk^
k_o^k^h01?o^k^h00oo/k>cok^k^onk^kP04onk^kP03onc/k?o^k^kok^k^00Gok^k^00?ojn_[onk^
k_o^k^h01?o^k^h00oo[jn_ok^k^onk^kP09onk^kP03ong]kOo^k^kok^k^00Cok^k^0_o]kNd@onk^
kP03ol;2`_l0003ob<S804Kok^k^000ConKViP04ol[:b_nRXZ;oooooooclo0Soo_kn00Oooooooh20
P?mLG5coIFEUonSXj?oooooooOgm00Koo_kn00Coo?cloooooonRXZ;ob/[:7ooVi^H00ol`<33o:BTY
oe]KF`02oe]KF`03ojFUYOoVi^Koi^KV02Koi^KV00?oVi^Ko`l?3ooVi^H0H?oVi^H01Om/K6coMGEe
ohb<S?lf=SKo=cLg04Ooi^KV000Conk^kP04onOWionKVi_ok^k^oo[jnPKoo_kn00WooOgmoooooood
m?CoKfm_of9RH_mMGEgoeMGEooooooolo?`01_ono_h01?ojn_[ok^k^oi^KVooWinLOonk^kP03ojBT
Y?n?ShooShn?00;oShn?00?o`l?3onk^k_o^k^h09_o^k^h00onPX:3o3`l?onk^kP1Ponk^kP05ok2`
/?mjNW[oI6AToijNW_oPh>00Aoo^k^h001Cooooo00Cof][JojVYZOomoOgoo?cl1Oooool02Oono_ko
ooooonGUiOmSHf?oIVIVoeUIFOo0`<3oooooooclo005ooooo`04ooclo?omoOgoZJVYom[JfTkooooo
00?oo_knoo[jn_ooool0[?ooool001Cok^k^00Goj^[Zojn_[oo6a/Koo_knooclo004ooooo`09oogm
oOoooooog]kNoe]KFomYJFWoEEEEokFe]Oooooooo?cl00Cooooo00Goo?clookno_o6a/Ko[jn_on[Z
jP3monk^kP005OoVi^H01_oLg=coWinOol[:b_oooooono_kooknoP;ooooo00Woo_knoooooookno_o
PX:2oeIFE_mXJ6Sohn?Sooooooono_h00_ooool01_ono_kono_kooooooo:b/[oWinOomcLg?koi^KV
000Fonk^kP07on?ShonZZZ[o[Zj^ooOgmoomoOgono_koogmo@03ooooo`03ooGemOoAdM7oj^[Z00?o
oooo00OooOgmoo_knoomoOgomoOgojj^[_nZZZ[ohn?S0?ook^k^000Gooooo`0EooWinOo?clooWinO
olg=cOoinOWooooooogmoOokno_on_[jooclo?oooooooOgmoo[jn_okno_ooOgmoooooooinOWocLg=
oinOWoo?cloonOWi0?oooooo0Oooool001Sok^k^00SokNg]omoOgone]KGoUiNGojj^[_oJf][olO7a
oo[jnP?oo?cl00Son_[joo7alOoJf][o[Zj^oiNGUone]KGogmoOong]kOook^k^0_o^k^h001[oi^KV
00KoiNGUomcLg?o6a/KoZZZZoiRHV?nCTi<3oi6AT@06oi>CTonHV9SoZZZZolK6a_oLg=coiNGUoooV
i^H4onKViP007Oo^k^h02Oo]kNgoj^[ZonKVi_oShn?oh^;Ron?ShooVi^Koj^[Zong]k@3oonk^kPOo
k^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgo
oooo003oonk^kRgok^k^003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgooooo003oonk^kRgo
k^k^003oonKViRgoi^KV003oonk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgo
i^KV003oonk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV003oogmoObgo
Ogmo00001?o[jn_oi^KVon;Rh_oNg]h4omgMg@?og]kN01_ogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomgMgOoLg=`00_oMgMd04OoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN00;ogMgM04Wog=cMomgMgOoMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oLg=cogMgMomcLg?oMgMgog=cM00;ogMgM09[og]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgM0ooNg]h00ooMgMgog]kNomkNgP03omgMg@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>00
1ooIfMT01?oHf=Soe]KFom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0cofMWI00Wof=SHomOG
eooEeMGoe=CDom?CdooDe=CoeMGEomOGeooHf=P03OoIfMT02OoHf=SoemOGomGEeOoDe=Codm?ComCD
e?oEeMGoemOGomSHf00lomWIf@?of=SH00GoemOGomKFe_oDe=Coe=CDomKFeP03omSHf0OofMWI0ooH
f=P3omWIf@;of=SH1_oIfMT2omSHf0KofMWI0ooHf=QiomWIf@03omSHf?oIfMWofMWI00KofMWI0OoN
g]h1onKViP7ok>c/00001oo^k^kojNWYonCTi?oPh>3ohN7Qon3Ph?oRh^800_oQhN403OoNg]kog=cL
om?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml02OoQhN403OoPh>3ogmoO
om_KfooFe]Kod];Bolk>c_o<c<coc/k>om;Bd_oFe]Kofm_KomoOgooPh>002OoQhN403OoPh>3ogmoO
om_KfooFe]Kod];Bolk>c_o<c<coc/k>om;Bd_oFe]Kofm_KomoOgooPh>00>?oQhN42on3Ph008omoO
gooMgMgog=cLom[Jf_oHf=Soe]KFomSHf?oKfm/6omoOg`?oh>3P00?ogmoOomkNg_oNg]h00_oOgml0
1OoPh>3ogmoOomoOgooNg]kogmoO00Coh>3P0ooOgml00ooPh>3ogmoOon3Ph003on3Ph004omoOgooN
g]kog]kNomoOg`?oh>3P00?ogmoOon3Ph?oPh>001OoPh>1_on7Qh@03on;Rh_oQhN7oh^;R00CohN7Q
0OoTi>@1onWYj@7okNg]00000oo`l?3okno_oo7al@03oo3`l00Hono_koo`l?3ok^k^onWYjOoKfm_o
`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7aono_kooalO7o
kno_oo7akoo_knoolO7a0_o^k^h05?oVi^Kog]kNom7AdOo9bLOo`L71okno_oo1`L7obLW9om7AdOoN
g]koi^KVonk^k?o^k^kolO7aono_kooalO7okno_oo7alOo_knoolO7_0_o^k^h02ooVi^Kog]kNom7A
dOo9bLWo`L71okno__o1`L7obLW9om7AdOoNg]koi^KV00;ok^k^03WolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knool?3`onc/k?o[jnT00_oVi^H01_oRh^;ohN7QomkNg_oQhN7oi>CTon_[
j@;ojNWY00Woi^KVonSXj?oWinOojn_[onc/k?o_kngok>c/on[Zj_oVi^H00_oWinL03Oo/k>cojn_[
onc/j_oWinOoj>SXonOWioo/k>cokNg]ono_koo[jn_ojNWWonOWioo/k>`00_o[jn/03_oZj^[ok^k^
onc/k?o[jnWoi^KVonOWiooVi^Koj^[Zonc/k?o_knoojn_[on_[jOo[jn_okno_0_o/k>`0N?oZj^[o
kno_onk^k_oalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7ol?3`ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`Col?3`
00000oobl_;ok^k^onOWi`04onGUi@0@onCTi?oOgmoodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92
odE5AOmADE7oIVIVohZ:ROna/K7odM7AomkNgP;oi>CT00_oiNGUonCTi?oUiNCoi>CTonGUiOoRh^;o
g=cLolo?coo1`L7o/K6aojVYZ003ojBTY01GojVYZOna/K7o`L71olo?cooLg=_oh^;RonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oRh^;og=cLolo?coo1`L7o/K6aojVYZOnTY:CoY:BSojBTY?nYZJWo
/K6aol71`Oo?cloog=cLon;Rh_oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUon?ShooRh^;o
gMgMomWIf?oEeMGoe]KF00;odm?C01GocLg=ohF5QOm7AdOoe]KEom[Jf_oFe]Koe=CDomKFe_oDe=Co
emOGomcLg?oPh=oofm_KomOGeooDe=CoemOGomWIfOoMgMgog]kNomcLfooHf=P00_oFe]H03OoKfm_o
gmoOon3Ph?oKfm_oemOFomSHf?oMgMgofm_KomWIfOoKfm_ogmoOomgMgOoIfMP00_oEeMD02OoDe=Co
f=SHom_KfooPh>3ofm_KomWIf?oKfm_ohN7QomkNgP02om[JfP1`on3Ph?oShn?oiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi0CoiNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o]kNd1oo;blP0000?om?Cdong]kOoWinL0
0_oPh>004ooQhN7ogmoOomkNg_oBd];o];BdohN7QomLG5coKC/eoii>@_o=KeoojH=_ole_GonNCT?o
KC/foeaLG?n7QhOo];Bdom;Bd_oNg]h01OoPh>004OoOgmoof][Jolk>c_nl_;coZj^[ok2`/?o7alOo
fMWIonCTi?oIfMWoalO7ok6a/On[Zj_o_;blolk>c_oJf][ogmoO00Goh>3P017ogmoOom[Jf_o>c/ko
_;bloj^[Zon`/;3oalO7omWIfOoTi>CofMWIolO7aona/K7oZj^[okbl_?o>c/kof][JomoOg`0don3P
h00UomkNg_oJf][odm?Com3@d?oAdM7o][Jfojb/[?maLG7o61PHocDe=OmhN7SoalO7om;Bd_o?cloo
`l?3om7AdOo=cLgoc/k>omKFe_oHf=Sod];Bolo?coo;bl_o_knoomOGeooJf][ofm_KomWIfOoEeMGo
`<30om3@d?oAdM7of=SHomWIfOoCdm?odM7Aol30`002omOGe`04om7AdOoCdm?of=SHomGEe@;od=3@
00ko_Kfmolg=cOo@d=3odm?ComSHf?oEeMGodM7AomGEeOoKfm_of=SHom7AdOoBd];ofMWIomkNgVgo
h>3P00?ogmoOon3Ph?oOgml00_oOgml3on3Ph003on7QhOoWinOok>c/007om?Cd00000oofm_Kol_;b
on_[j`03onSXj00ConOWiooRh^;ocLg=oinOWom[GeooScH^oneaHOoiWI3ooK6Uoofl[oom]:OonInC
onedHonB=booJemOoinOWoo=cLgoh^;RonOWi`04onSXj007onKVi_oMgMgob/[:okFe]Ono_kooinOW
ono_k`03oo3`l007ono_kooYjNWo`L71okFe]Oo:b/[ogMgMonKViP05onSXj007onKVi_oMgMgob/[:
okFe]Ono_kooinOWono_k`03oo3`l007ono_kooYjNWo`L71okFe]Oo:b/[ogMgMonKViP0conSXj00C
onOWiooUiNGog]kNomKFe_n=SHgo3`l?oa`L7?lO7aoo0000ogemOOoHf=SogMgMomkNg_nd];Co7alO
o`@41?lk>c_oPh>3oa@D5002omgMg@0<olg=cOmHF5So0`<3oa`L7?lB4Q;oS8b<onCTi?mfMWKo2PX:
ob0P8?lV9RKoWYjN0_oOgml06Onk^k_o8b<SoaTI6OnOWioog]kNob8R8_n5QHGogMgMomWIfOn@T93o
410@oaHF5_l410CoH61Pom?CdooMgMgoaLG5o`000?nn_[koh^;RomoOgolo?cooJFUYon7QhOoVi^H0
M_oXj>P1onc/k07ol_;b0Oofm_H00003ooOgmoohn?Son?Sh00?on?Sh01?omoOgonk^k_o>c/koT92@
ohD_:ooYI5Koni:7oojVVoon/JGookR[oojcY_onZ9coniB9oniXFOn9<B_oT92@olk>c_o^k^komoOg
00Con?Sh00Kom?CdonOWioo?clooa/K6on[Zj_odm?@2ooWin@09oo[jn_oinOWonOWiooKfm_o[jn_o
alO7olo?cooWinOom?Cd00Gon?Sh00Kom?CdonOWioo?clooa/K6on[Zj_odm?@2ooWin@09oo[jn_oi
nOWonOWiooKfm_o[jn_oalO7olo?cooWinOom?Cd03?on?Sh03comoOgooCdm?o/k>coV9RHo`T92On^
[Zkom_KfooOgmonn_[ko5QHFohj>S_oZj^[ok>c/ofIVI_lo?cooj>SXojJVY_lD51Co5QHFonc/k?o[
jn_oIVIVob4Q8Onn_[koinOWon;Rh_oMgMgol_;bolK6a_oGemOoi^KVoi:BT_lX:2Sol_;bono_komc
Lg?o=CDeoo3`l?odm?Cokno_ob@T9?n?Shook>c/ol?3`ol30`?oTY:Boo;bl_o6a/Ko6ATIoh:2P_o/
k>codm?Co`000?o:b/[ol_;bono_kom3@d?oL71`oo7alOofm_I_ooShn003ooOgmoohn?Son?Sh00;o
n?Sh00ComoOgooWinOogmoOomoOg0Oohn?P00003oo[jn_oemOGok^k^00;ok>c/027ojn_[onWYjOoO
gmoo^[ZjogUBD_no<RCoigAYoof9O_ooV8cooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<TogUBD_nj
^[[ogmoOon[Zj_o[jn_ok>c/on_[k?o[jn_oi^KVomSHf?nk^k_oe=CDonCTi?o[jn_olO7aoo;bl_oc
lo<00_obl_801_o]kNgoiNGUomGEeOnk^k_of=SHonKViP;ojn_[00cok>c/on_[joo[jn_oi^KWomSH
f?nk^k_oe=CDonCTi?o[jn_olO7aoo;bl_oclo<2oo;blP06ong]kOoUiNGoeMGEok^k^ooHf=Soi^KW
0_o[jn/0@?o/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jncok>c/on_[joo/k>coj^[ZonOWiooJf][o6ATIod];C?oWinOoj^[Zon_[jooWinOo
Q8B4o`X:2_oJf][ogmoOoclo?omYJFT2onCTi007oh>3PolE5AGoh>3PomkNgol92@WoNg]kom_Kf`02
om[JfP2>omoOgooTi>CogmoPom_Kfoo>c/koCDe=obHV9_oXj>Soh^;Rode=COmLG5gohn?SonOWiooR
h^;o8R8RohR8R?oOgmooLW9bo`l?3ooNg]koi>CTon7QhOmDE5Co;bl_on3Ph?o8b<So0000okjn__oQ
hN7oh>3Pod10@?m[Jf_oiNGUon[Zj_o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k0Oojn_[00Gok>c/on_[joo[jn_ok^k^ooKf
mP01ooWin@0000?ono_koo?cloo]kNd00_oUiND07ooVi^Koi>CTomWIfOnb/[;oNBh^olQ2=?oSJUco
m7Y]oof8O?onUh[ooY^>oojHRoonRWkom7]]onM[GOo:@SCoNbh^ok:b/_oHf=Soi>CTonGUiOoVi^Ko
iNGVonGUiOoOgmoodM7AokJf]_oDe=CogMgMonCTi?oVi^L00oo/k>`01ooXj>Soi>CTomoOgooEeMGo
][Jgom7AdOoOgml00_oUiND05?oVi^KoiNGUonGUiOoOgn3odM7AokJf]_oDe=CogMgMonCTi?oVi^Ko
k>c/onc/kOo/k>coj>SXonCTi?oOgmooeMGEokJf]_oAdM7ogmoP0_oUiND0@?oVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^Koi>CTon;Rh_ng]kOo0000ohB4Q?oQhN7oi>CTonGUiOoPh>3o`/;2o`000?na/K7of][Kocdm?OmY
JFT2omoOg`06oi6ATOlD51Cog=cLolW9b_l0003o;Bd]0olg=cL07?n>SXkogmoOomSHfOmiNGWo2PX:
ob`/;?ne]KGohN7Qom_Kfom;Bd_oFUYKom[Jf_oNg]kog=cLob4Q8On5QHGog=cLoeYJF_lf=SKoe]KF
omSHf?oGemOoN7QhoaHF5_oMgMgoa<C4o`000?ng]kL2omKFeP1aochn?_mYJFWoh>3PonGUiOoUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiND00_oVi^H00ooUiNGoi^KVonKViP03onKViP03onGUiOo]kNgom?Cd007ono_k0000
0oolo?con?Shoo7al@03onk^kP0Con_[jooQhN7o_;blogXG5oo3?c;odeI9onAXF_o_Mfcom8=iooR7
O?oeQ7[olgU]onEYFooIF4[oa3lbog`G5onl_;cohN7Qonc/k003onk^kP08ong]kOoYjNWof][JokVi
^OoGemOog]kNon?ShooVi^H3on[ZjP08onSXj?oTi>Cog]kNomSHf?ni^KWof][JonWYjOo]kNd3onk^
kP08ong]kOoYjNWof][JokVi^OoGemOog]kNon?ShooVi^H3on[ZjP08onSXj?oTi>Cog]kNomSHf?ni
^KWof][JonWYjOo]kNdbonk^kP06ong]kOo[jn_oXZ:Ro`000?nn_[koi^KV0_o[jn/01ooVi^Kofm_K
o`000?n<S8coiNGUod10@?m^KVh00_oYjNT01_nHV9So5ADEonOWiooWinOo1`L7ogYjNP;o][Jf00go
6QXJojZZZ_oZj^[oVi^Ko`d=3OnGUiOogmoOonKVi_oWinOoh^;Rode=COmMGEgogmoO00;oiNGU00Ko
8b<Soh^;RooXj>SoNGUio`d=3OoMgMd2omoOg`06oe9BD_lc<c?ojNWYolg=cOl0003oXj>S0_oOgml0
1?ll?3coKVi^on_[joo]kNeeonk^kP03ong]kOobl_;on?Sh007oo?cl0003oogmo@0Fooclo?omoOgo
oOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@@ooJHUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo
^C@dof/71ooBd];olo?cooclo0CooOgm00OonOWionc/k?nh^;Sofm_Kon7QhOoUiNGojNWY00;ok>c/
00SokNg]on[Zj_oUiNGoh^;Rom_Kfoni^KWok>c/ooWin@GooOgm00OonOWionc/k?nh^;Sofm_Kon7Q
hOoUiNGojNWY00;ok>c/00SokNg]on[Zj_oUiNGoh^;Rom_Kfoni^KWok>c/ooWinC?ooOgm00Koo?cl
oo_knoo0`<3o0000olG5aOo`l?02ooGem@07oo3`l?o3`l?o0000ojJVY_ohn?SoA4A4ogMgM`02oo_k
n`0YojBTY?lF5QKon_[joo_knomWIfOoATI6onGUiOo0`<3o20P8oo?clookno_oW9bLoc8b<_o`l?3o
k^k^onCTi?oinOWok^k^odm?ComPH63oj>SXoo?cloogmoOo9BDUoiBDU?oinOWog=cLo`L71on5QHGo
j^[Zok>c/olC4a?oVIVIoo_knooOgmoo0000obDU9OnYZJWod=3@oa8B4_nVYZH00_olo?acoogmo@03
ooclo?omoOgoo?cl00?ooOgm0000S_omoOgon_[joo?cloo^k^kol?3`ono_koo^k^kojNWYom?CdomK
7AgoXS@dok@X7Oo1>RgoadTlolmFB_o@Ed_od5M:olY:?_o3>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^
k^kol?3`ono_koo`l>ookno_onk^k_oShn?o[:b/ol[:b_oBd];oemOGom[JfOoMgMgog]kNomgMgOoL
g=coemOGomCDe?o:b/[o[:b[on?Shoo^k^kokno_oo3`l?o_knool?3`ono_koo^k^gohn?Sojb/[?o:
b/[od];BomOGeooJf][ogMgMomkNgOoMgMgog=cLomOGeooDe=Cob/[:ojb/[?oShn?ok^k]ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o^k^kogMgMo`820_nBTY7oh>3Pon;Rh_oQhN7oh>3PogalO?l0
003oa/K6onk^kOmCDe?oOgmoonk^k_o_knooYZJVob`/;?o^k^kokno^on?ShomHF5P2oa0@400Qohb<
S?o_knook^k^onWYj?mDE5Co61PHo`/;2on1PH7okNg]oginO_l820So2PX:oaTI6OnJVY[oj^[ZocPh
>?nFUYKokNg]onk^k_nb/[7o:RXZo`T92OlI6AWoP820ong]kOo_knooemOGoaTI6Ong]kOo?cloo`T9
2Om=CDgoiNGU00;okno_06kol?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_k`;ol?3`1_o_knl1oo?cl`7onOWi0Oon
o_h00003ookno_ogmoOol?3`00CojNWY017oinOWom_KfomSBd_oPC8bojHe=Onf=2go`Te1ol=DBOo4
ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mSBd_ofm_KonOWi`05onWYj@06onSXj?oShn?oZj^[okVi^Oo9
bLWoclo?0_oEeMD02OoFe]KoeMGEomCDe?o?cloob<S8okVi^On[Zj_ohn?SonSXj005onWYj@06onSX
j?oShn?oZj^[okVi^Oo9bLWoclo?0_oEeMD02OoFe]KoeMGEomCDe?o?cloob<S8okVi^On[Zj_ohn?S
onSXj00donWYj@;oj>SX00?oGUiNobLW9ooBd]800_oMgMd01OoHf=So<C4aodE5AOoWinOoj>SX00[o
jNWY00?oinOWonWYjOoYjNT01?oYjNT00ooWinOojNWYonWYj@02onSXj009odi>C_mOGeooj>SXonSX
j?oUiNGoh^;Ron?ShooVi^Koj>SX00;ojNWY00?oi^KVonWYjOoYjNT01_oYjNT00ooXj>SojNWYonWY
j@1aonWYj@03onSXj?oYjNWojNWY00CojNWY0Oo`l?01ooOgm`7oo_kn00001Oono_kon_[jooCdm?o_
knoolO7a00;ol?3`017okno_on_[jonEU9CoCb<SoiEDE?nkLg?odiFEomZLW?oJWYcofIbLomBEUOnk
Lg?oUEADodlS8onEU9Coj^[Zono_k`06oo3`l006onk^k_o;bl_oYjNWolS8b?oHf=Sohn?S0ooVi^H0
1_oShn?of=SHolS8b?nWYjOobl_;onk^kPOol?3`00Kok^k^ol_;bonWYjOob<S8omSHf?oShn<3onKV
iP06on?ShooHf=Sob<S8ojNWYoo;bl_ok^k^=_o`l?002_o_knoog]kNocdm?OlV9RKoNWYjoh20P?l`
<33o;Rh^om;Bd_o_knlFoo3`l003ono_kooDe=Coclo?00;okno_00?ok^k^od10@?nLW9`00_o_knn4
oo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn00001?omoOgoooooooooooono_h2ooooo`;oo_kn07Wo
oOgmooShn?m^KVkoFSlook6@T?oNbLWol>CToo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?co
ooooookno_ooooooo_knooooo_ono_kooooooogmoOolo?coaLG5okZj^_oMgMgolO7`ooShn?oinOWo
n?Shoo7alOoMgMgo^[ZjolG5aOolo?_ooOgmooooooono_koooooookno_ooooooo_knooooo_omoOgo
o?clolG5aOnj^[[ogMgMoo7alOohn?SonOWhooShn?oalO7ogMgMokZj^_o5aLGoo?cloogmoOooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooclnon[Zj_oN7Qhog=cLonTY:Co
moOg00;oo_kn01koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
oOgmojVYZOoEeMD2ooknoP20ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_h2ooooo`03ookn
o_oooooooooo00?ooooo0Oono_h00004ooOgmoono_kon_[jooCdm0GolO7a00gokno_omKFe_m[Jf_o
@cdmoi^<S?o6^[[oe/c<olNj^_nKS8co@cdmof][JooFe]Kokno_00WolO7a00gol?3`onKVi_nm_Kgo
/;2`olo?cooOgmooiNGUomoOgoo?cloo/;2`okfm_OoVi^Kol?3`00WolO7a00gol?3`onKVi_nm_Kgo
/;2`olo?cooOgmooiNGUomoOgoo?cloo/;2`okfm_OoVi^Kol?3`0=kolO7a00Col?3`oo7alOoalO7o
l?3`1?oalO400oodm?Con_[jooknoP01ooOgm`0000Gojn_[oogmoOohn?Sol?3`on_[j`03on[ZjP0=
onWYjOoZj^[ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0<on[ZjP09
onWYjOo:b/[o/K6aoifMWOnBTY;oWIfMok6a/Oo:b/[ojNWY00goj^[Z00WojNWYol[:b_na/K7oWIfM
oi:BT_nMWIgo/K6aol[:b_oYjNT0iooZj^X01?o[jn_ol?3`ooShn?omoOd1on_[j`0000CoalO7ookn
o_ojn_[om?Cd2?oalO42oo3`l0?okno_0_o`l?0Aoo7al@?ol?3`4ooalO43oo3`l>KolO7a00?ol?3`
oo7alOoalO400_oalO400ooemOGon_[jooknoP01olK6aP0000?oa/K6ol?3`ooinOT0oooooolWoooo
o`7onOWi0Oo3`l<1olK6aP0000Kof][Jol30`?ne]KGoinOWooShn?olo?coooooob7ooooo00GooOgm
ooOgmooWinOo][Jfokno_`01om_Kf`00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{300, 140},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    \( (*\ Yes\ No\ Cancel\ *) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]ShowConfirmDialog[
        frame, \[IndentingNewLine]JavaNew["\<java.lang.String\>", "\<Forward \
messages now?\>"], \
\[IndentingNewLine]javax`swing`JOptionPane`YESUNOUCANCELUOPTION]\
\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(1\)], "Output"]
}, Open  ]],

Cell["Selections", "Text"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004<0000OQP00`40o`00
0?l0003oo`0000d000000003R<2hB928B9280?m8T8P9B9280@00000000>8
`;S8h=R8`;P0ohS0^0R8`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<
c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1
000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8
h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7
c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B928
0@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2h
b>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<
1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0
^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0A/c<
c3[oool7c<c<>oooodC<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04C<
c<`2IVIV00?<c<aVIVIVIVH0=VIVIP03ooooc<c<c<c<00C<c<`00fIVI/c<
c6IVIP0hIVIV00?oooo<c<c<c<`0@/c<c068`;P1B9280@00000000>8`;S8
h=R8`;P0A<c<c3]VIVH00oooolc<c<c<c004c<c<00=VIVKoooo<c<`0=lc<
c003IVIVooooc<c<04?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04C<
c<`2IVIV00?oooo<c<c<c<`0=<c<c09VIVH00oooolc<c<c<c004c<c<00=V
IVKoooo<c<`0=lc<c003IVIVooooc<c<04?<c<`1R<2h0DR@R04000000003
R<2hb>3HR<2h04C<c<`2IVIV00?oooo<c<c<c<`0=<c<c09VIVH00oooolc<
c<c<c004c<c<00=VIVKoooo<c<`0=lc<c003IVIVooooc<c<04?<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h04C<c<`2IVIV00?oooo<c<c<c<`0=<c<
c09VIVH00oooolc<c<c<c004c<c<00=VIVKoooo<c<`0=lc<c003IVIVoooo
c<c<04?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04C<c<`2IVIV00?o
ooo<c<c<c<`0=<c<c09VIVH00oooolc<c<c<c004c<c<00=VIVKoooo<c<`0
=lc<c003IVIVooooc<c<04?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h
04C<c<`2IVIV00?oooo<c<c<c<`04Lc<c0<00007c<c<0P000005c<c<0000
00000000c<c<0080000@c<c<0VIVIP03ooooc<c<c<c<00C<c<`00fIVI_oo
olc<c00=c<c<0`0000?<c<`01@000<c<c<c<c<c<c0000002c<c<0P0000;<
c<`200001/c<c0030000c<c<c<c<00k<c<`00fIVI_ooolc<c013c<c<0HS0
^058T8P1000000000hS0^<SPf8S0^014c<c<0VIVIP03ooooc<c<c<c<01?<
c<`200001/c<c0800002c<c<0P000003c<c<00000000013<c<`2IVIV00?o
ooo<c<c<c<`01<c<c003IVIVooooc<c<00W<c<`010000<c<c<c<c<c<c0L0
0002c<c<0P0000;<c<`200000lc<c0800004c<c<1P0000c<c<`00fIVI_oo
olc<c013c<c<0HS0^058T8P1000000000hS0^<SPf8S0^014c<c<0VIVIP03
ooooc<c<c<c<01?<c<`200001/c<c0800002c<c<1`0000k<c<`2IVIV00?o
ooo<c<c<c<`01<c<c003IVIVooooc<c<00W<c<`6000000C<c<`000000000
0004c<c<0P000003c<c<0000000000?<c<`200000lc<c0800004c<c<0`00
00[<c<`00fIVI_ooolc<c013c<c<0HS0^058T8P1000000000hS0^<SPf8S0
^014c<c<0VIVIP03ooooc<c<c<c<01?<c<`200001/c<c0T0000@c<c<0VIV
IP03ooooc<c<c<c<00C<c<`00fIVI_ooolc<c00:c<c<0P000004c<c<0000
0000c<c<0`0000C<c<`:00000lc<c0800005c<c<00<0003<c<c<c<`02Lc<
c003IVIVooooc<c<04?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04C<
c<`2IVIV00?oooo<c<c<c<`04lc<c0800006c<c<2`0000k<c<`2IVIV00?o
ooo<c<c<c<`01<c<c003IVIVooooc<c<00[<c<`900001Lc<c0040000c<c<
000000000lc<c0800003c<c<0P00017<c<`00fIVI_ooolc<c013c<c<0HS0
^058T8P1000000000hS0^<SPf8S0^014c<c<0VIVIP03ooooc<c<c<c<01?<
c<`200001/c<c0T0000@c<c<0VIVIP03ooooc<c<c<c<00C<c<`00fIVI_oo
olc<c00:c<c<0P000003c<c<0000000000@00004c<c<00<0003<c<c<c<`0
1`0000?<c<`200004Lc<c003IVIVooooc<c<04?<c<`1R<2h0DR@R0400000
0003R<2hb>3HR<2h04C<c<`2IVIV00?oooo<c<c<c<`04lc<c0800005c<c<
200001;<c<`2IVIV00?oooo<c<c<c<`01<c<c003IVIVooooc<c<00[<c<`2
000000?<c<`0000000000P000003c<c<0000000000;<c<`3000000?<c<`0
000000000lc<c0800003c<c<0P00017<c<`00fIVI_ooolc<c013c<c<0HS0
^058T8P1000000000hS0^<SPf8S0^014c<c<0VIVIP03ooooc<c<c<c<01;<
c<`00`000<c<c000000200001<c<c0/0000>c<c<0VIVIP03ooooc<c<c<c<
00C<c<`00fIVI_ooolc<c00:c<c<1`000003c<c<0000000000?<c<`00`00
0<c<c<c<c00700000lc<c080000Ac<c<00=VIVKoooo<c<`0@lc<c068`;P1
B9280@00000000>8`;S8h=R8`;P0A<c<c09VIVH00oooolc<c<c<c00Ec<c<
0`0000C<c<`400000/c<c0040000c<c<000000003/c<c09VIVH00oooolc<
c<c<c004c<c<00=VIVKoooo<c<`02/c<c08000000lc<c000000000050000
1<c<c0P00004c<c<0P00017<c<`00fIVI_ooolc<c013c<c<0HS0^058T8P1
000000000hS0^<SPf8S0^014c<c<0VIVIP03ooooc<c<c<c<00o<c<`90000
1<c<c0X0000>c<c<0VIVIP03ooooc<c<c<c<00C<c<`00fIVI_ooolc<c009
c<c<1`0000O<c<`2000000?<c<`0000000001@0000?<c<`200004Lc<c003
IVIVooooc<c<04?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04C<c<`2
IVIV00?oooo<c<c<c<`07Lc<c080000Ec<c<0VIVIP03ooooc<c<c<c<00C<
c<`00fIVI_ooolc<c00Fc<c<00H0003<c<c<c<c<c<`0003<c<`300006<c<
c003IVIVooooc<c<04?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04C<
c<`2IVIV00?oooo<c<c<c<`0=<c<c09VIVH00oooolc<c<c<c004c<c<00=V
IVKoooo<c<`0=lc<c003IVIVooooc<c<04?<c<`1R<2h0DR@R04000000003
R<2hb>3HR<2h04C<c<`2IVIV00?oooo<c<c<c<`0=<c<c09VIVH00oooolc<
c<c<c004c<c<00=VIVKoooo<c<`0=lc<c003IVIVooooc<c<04?<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h04C<c<`2IVIV00?oooo<c<c<c<`0=<c<
c09VIVH00oooolc<c<c<c004c<c<00=VIVKoooo<c<`0=lc<c003IVIVoooo
c<c<04?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04C<c<`2IVIV00?o
ooo<c<c<c<`0=<c<c09VIVH00oooolc<c<c<c004c<c<00=VIVKoooo<c<`0
=lc<c003IVIVooooc<c<04?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h
04C<c<`2IVIV00?oooo<c<c<c<`0=<c<c09VIVH00oooolc<c<c<c004c<c<
00=VIVKoooo<c<`0=lc<c003IVIVooooc<c<04?<c<`1R<2h0DR@R0400000
0003R<2hb>3HR<2h04C<c<`2IVIV=oooo`03IVIVc<c<oooo00K<c<`00fIV
I_ooolc<c00gc<c<00=VIVKoooo<c<`0@lc<c068`;P1B9280@00000000>8
`;S8h=R8`;P0A<c<c3]VIVH7c<c<00=VIVKoooooool0=oooo`03c<c<oooo
c<c<04?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h04C<c<`kIVIV1lc<
c3]VIVI5c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<1lc<c068
`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R0400000
0003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0
^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<c<`1
R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P10000
00000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8h=R8
`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<
0HS0^058T8P1000000000hS0^<SPf8S0^00jc<c<`_ooo`[<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h03W<c<`00fIVI/c<c6IVIP2oIVIV00?oooo<
c<c<c<`02<c<c068`;P1B9280@00000000>8`;S8h=R8`;P0>Lc<c003IVIV
ooooc<c<0;k<c<`00fIVI_ooolc<c009c<c<0HS0^058T8P1000000000hS0
^<SPf8S0^00ic<c<00=VIVKoooo<c<`0_IVIc003c<c<IVIVoooo00[<c<`1
R<2h0DR@R04000000003R<2hb>3HR<2h03W<c<`016IVI_ooolc<c9VIc;_<
c<`019VIc<c<c6IVI_ooo`[<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h
03W<c<`016IVI_ooolc<c9VIc;_<c<`019VIc<c<c6IVI_ooo`[<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h03W<c<`016IVI_ooolc<c9VIc2S<c<`3
0000T<c<c004VIW<c<c<IVIVoooo2/c<c068`;P1B9280@00000000>8`;S8
h=R8`;P0>Lc<c004IVIVooooc<c<VIW<:/c<c080002?c<c<00BIVLc<c<aV
IVKoool:c<c<0HS0^058T8P1000000000hS0^<SPf8S0^00ic<c<00AVIVKo
ooo<c<bIVL`2c<c<100000?<c<`5000000?<c<`0000000000/c<c0800002
c<c<0P000003c<c<0000000000;<c<`5000000?<c<`0000000001<c<c0<0
002>c<c<00BIVLc<c<aVIVKoool:c<c<0HS0^058T8P1000000000hS0^<SP
f8S0^00ic<c<00EVIVKoooo<c<bIVLc<c<`00P0000;<c<`2000000?<c<`0
000000000/c<c08000000lc<c00000000002c<c<0P000004c<c<00000000
c<c<0`000003c<c<0000000000;<c<`2000000?<c<`0000000001<c<c0<0
002>c<c<00BIVLc<c<aVIVKoool:c<c<0HS0^058T8P1000000000hS0^<SP
f8S0^00ic<c<00EVIVKoooo<c<bIVLc<c<`00P0000;<c<`2000000?<c<`0
000000000/c<c08000000lc<c00000000002c<c<0P000003c<c<00000000
00;<c<`2000000?<c<`0000000000/c<c08000000lc<c00000000003c<c<
0P000003c<c<0000000008g<c<`019VIc<c<c6IVI_ooo`[<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h03W<c<`016IVI_ooolc<c9VIc0G<c<`20000
0/c<c08000001<c<c00000000<c<c0800002c<c<0P000003c<c<00000000
00;<c<`200000/c<c08000001<c<c00000000<c<c0800003c<c<0P000003
c<c<0000000008C<c<`200001lc<c004VIW<c<c<IVIVoooo2/c<c068`;P1
B9280@00000000>8`;S8h=R8`;P03Lc<c00JQj^7Ul:GQj^7VlRKOj]oUl:G
OJMmUKnEMimgSkN?LYMaRjn:KiA_QJN5KHm]QJN5IhMWOJMmIhMWQJN5IhMW
OJMmIhMWOJMmIhMWOJMm4/c<c004IVIVooooc<c<VIW<1Lc<c0800003c<c<
10000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c0800003
c<c<10000003c<c<0000000000?<c<`2000000?<c<`000000000Plc<c0@0
0006c<c<00BIVLc<c<aVIVKoool:c<c<0HS0^058T8P1000000000hS0^<SP
f8S0^00<c<c<01aoZh2Kb9^7ZhNKb9]oZgnKb9]oZgnG`YMmYgfE_iEgWgN?
]hmbUg6?]hm_UG25YhE]Sff5YhEWQfMmYgeWQfMmYgeWQfN5YhEWQfN5YhEW
QfMmYgdAc<c<00AVIVKoooo<c<bIVL`5c<c<0P000003c<c<0000c<c<00;<
c<`2000000G<c<`000000000003<c<`00P000003c<c<0000000000;<c<`2
000000?<c<`0003<c<`00/c<c08000000lc<c00000000002c<c<0P0000?<
c<`20000PLc<c0H00005c<c<00BIVLc<c<aVIVKoool:c<c<0HS0^058T8P1
000000000hS0^<SPf8S0^00<c<c<01bKai]oZgnKb9]oZgnKb9^7ZhNKb9]o
ZgnG`YMmYgfE_iEgWgN?]hmbUg6;[hY_UG27ZhM]SfemYgeWQfN5YhEWQfMm
YgeWQfMmYgeWQfMmYge]SfdAc<c<00AVIVKoooo<c<bIVL`5c<c<0P0000;<
c<`400000/c<c08000000lc<c00000000002c<c<0P0000;<c<`200000/c<
c0@00002c<c<1P0000?<c<`20000P<c<c0P00004c<c<00BIVLc<c<aVIVKo
ool:c<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<00f7ZhNG`YN7
ZhNKb9^7ZhNG`YMoZgnKb9]oZgnG`YMmYgfE_iEgWgL00lc<c00<KiA_Qj^7
KHm]QJN5IhMWOJMmIhMWOJMmIhMWQJN5IhMWOJMm4Lc<c004IVIVooooc<c<
VIW<1Lc<c080002Wc<c<2P0000?<c<`019VIc<c<c6IVI_ooo`[<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h00c<c<`039_8Vgn[Oi_8Vgn[Oi_8VhN[
Qi_8Vgn[Oi_8Vgn[Oi_7VgfWO@@0<`003<c<c6nDKhN[Qff?KHFWQFN7IhFW
QFN7Ign[P6N7IgfWOFN7Ia7<c<`016IVI_ooolc<c9VIc0G<c<`20000]<c<
c004VIW<c<c<IVIVoooo2/c<c068`;P1B9280@00000000>8`;S8h=R8`;P0
3<c<c00LQj^7VlRKOj]oVlRKOj^0Ul:GQj^7VlRKQj^7VlRKP:]o03<0c<c<
UKnEOJMmSkN?03<0c<c<KiA_Qj^7KHm]Oj^0IhMWOj^0IhMWQJN5IhMWQJN5
4Lc<c004IVIVooooc<c<VIW<^lc<c004VIW<c<c<IVIVoooo2/c<c068`;P1
B9280@00000000>8`;S8h=R8`;P03<c<c00LVlRKOj]oVlRKQj^7Ul:GQj^7
VlRKOj]oVlRKOj]oVlRK03<0c<c<OJMmUKnEN:1g03<0c<c<Rjn:KiE`Qj^7
KHm]QJN5IhMWOJMmIhMWOJMmIhMW4Lc<c004IVIVooooc<c<VIW<^lc<c004
VIW<c<c<IVIVoooo2/c<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<
c00<Qj^7VlRKOj]oVlRKP:]oVlRKOj^0VlRKQj^7VlRKQj^703<01<c<c00<
03<0SkN?MimgRjn:KiE`QJN5KHm]QJN5IhMWOJMmIhMWQJN54Lc<c004IVIV
ooooc<c<VIW<^lc<c004VIW<c<c<IVIVoooo2/c<c068`;P1B9280@000000
00>8`;S8h=R8`;P03<c<c00<Ul:GQj^7VlRKOj]oVlRKOj]oVlRKOj]oVlRK
P:]oVlRKQj^7100c000<UKnEMimgSkN?LYMaSkN?KiA_Qj^7KHm]QJN5IhMW
OJMmIhMW4Lc<c004IVIVooooc<c<VIW<^lc<c004VIW<c<c<IVIVoooo2/c<
c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00LQj^7VlRKOj]oVlRK
Qj^7Ul:GQj^7Ul:GQj^7VlRKOj]oVlRKQj^7VlRKQj^7Ul:GOJMmUKnEMimg
SkN?LYMaSkN?KiA_QJN5KHm]QJN5IhMWQJN54Lc<c004IVIVooooc<c<VIW<
^lc<c004VIW<c<c<IVIVoooo2/c<c068`;P1B9280@00000000>8`;S8h=R8
`;P03<c<c00=VlNKOj]oVlRKQj^7VlRKOj^0VlRKOj]oVlRKP:]oVlRKQj^7
VlRK00?<c<`039_7VgfWOIFoUGNOMhngSgNOMh^_RW:GLHN[Qff?KHFWQFN7
Ia7<c<`00fIVI_ooolc<c02mVIW<00?<c<aVIVKoool02/c<c068`;P1B928
0@00000000>8`;S8h=R8`;P03<c<c00<Oj]oVlNKQj^7Ul:HOj]oVlRKOj]o
VlRKOj]oVlRKOj]oVlRK100c000<c<c<VlNKOJMmUKnEOJMmSkN?LYMaRjn:
LYMaQj^7KHm]QJN54Lc<c003IVIVoooooooo0;koool00lc<c?ooolc<c009
c<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<01bE_iEoZgnG`YN7
ZhNKb9^7ZhNG`YN7ZhNG`YN7ZhNG`YL0<`3<c<b7ZhNG`YN7ZhL0<`3<c<bK
ai]mYgfE_iEgWgN?]hmgWgN;[hY_UG27ZhM]SfdAc<c<`VIVIP_<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h00c<c<`077fWOIFoUGfWOI_7Vgn[Oi_8
VhN[Qi_8Vgn[P9O2UhN[Q`0c0<c<c9O2V8N[QiO2V8N[Q`0c0<c<c9O2UgfW
OIFoUGfWOHngSgNOMh^_RW:GLHN[Qmk<c<`1R<2h0DR@R04000000003R<2h
b>3HR<2h00c<c<`079FoUGfWOIFoUGn[Oi_7Vgn[Oi_8VhN[QiO2V8N[Qi_8
Vh2[O`0c0<c<c9_8VhN[QiO2UhN[Q`0c0<c<c9_7VgfWOIFoUGRPMhngSgNO
Mh^_RVnEL=k<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`077NO
Mi2gT7fWOIFoUGfWOI_7Vgn[Oi_7VhN[QiO2Ugn[Oi_8Vgn[O`0c0<c<c9_8
VhN[Qi_8Vgn[P00c0<c<c9_7VgfWOIFoUGfWOHngSgNOMh^_R]k<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h00c<c<`078ngSgNOMhngT7fWOIFoUGfW
OI_7Vgn[Oi_7VhN[Qi_8Vgn[Oi_8VhN[Q`0c0<c<c9_8VhN[Qi_8VhN[Q`0c
0<c<c9_7VgfWOIFoUGNOMhngSgNOMmk<c<`1R<2h0DR@R04000000003R<2h
b>3HR<2h00c<c<`076nEL8ngSgNOMhngT7fWOIFoUGn[Oi_7Vgn[P9_8VhN[
Qi_8Vgn[P9O2Ugn[P00c0<c<c9_8Vgn[Oi_8V`0c0<c<c82[Oi_7Vgn[OiFo
UGfWOHngScO<c<`30000Y<c<c068`;P1B9280@00000000>8`;S8h=R8`;P0
3<c<c009Rjn:LYMaSkN?MimgSkN@OJMmUKnEOJMmVlNK00;<c<`04HN[QiO2
UhN[Qi_8Vgn[O`0c0<c<c9_8VhN[Qi_8V`0c0<c<c7n[OiO2UgfWOIFoUGfW
O@0ic<c<0P000:?<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`0
26nDKh^_RVnEL8ngSgNOMhngSgfWOIFoU@<0<`004Lc<c8N[Qi_8Vgn[Oi_8
VhN[Q`0c0<c<c9_8Vh2[O`0c0<c<c9_8Vgn[Oi_7Vgn[OiFoU@0Bc<c<1@00
00?<c<`400000/c<c0800002c<c<100000?<c<`400000lc<c0800005c<c<
0`0000?<c<`400000lc<c08000001<c<c00000000<c<c0800006c<c<0P00
0003c<c<0000000000;<c<`2000000?<c<`0000000001<c<c08000000lc<
c00000000002c<c<0P0000C<c<`200000/c<c0800002c<c<0P0000;<c<`4
00000/c<c0800002c<c<0P0000;<c<`2000000?<c<`0000000000/c<c080
00000lc<c00000000017c<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<
c<c<01b5YhE_U6n;[hYbUg6?]hmgWgN@]i00<`3<c<amYgfKai/0<`3<c<b7
ZhNKb9]oZgnKb9/0<`3<c<aoZgnKb9/0<`3<c<b7ZhNKb9]oZh2G`YMoZglA
c<c<0P0000?<c<`2000000?<c<`0000000000/c<c08000001<c<c0000000
0<c<c0800002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`00000
00001/c<c0<00002c<c<0P0000;<c<`2000000C<c<`00000003<c<`30000
00?<c<`0000000001/c<c0<000001<c<c00000000<c<c08000000lc<c000
00000003c<c<0P0000;<c<`200000/c<c0800004c<c<0P0000;<c<`20000
0/c<c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`2
000000?<c<`0000000000/c<c0800002c<c<0P000003c<c<0000000004O<
c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`076N9IhFWQFf?KH^_
RVnEL8ngSgNOM`0c0<c<c9FoUGfWO@0c0<c<c9_8VhN[Qi_8VhN[Q`0c0<c<
c9O2UhN[Q`0c0<c<c9_8Vgn[Oi_8Vgn[Oi_7VaK<c<`2000000?<c<`00000
00001Lc<c08000000lc<c00000000005c<c<0P0000G<c<`200001Lc<c080
00001<c<c00000000<c<c0800002c<c<0P000003c<c<0000000000;<c<`2
000000?<c<`0000000001/c<c0800002c<c<0P000004c<c<00000000c<c<
0P0000?<c<`200000/c<c0800002c<c<0P0000C<c<`200000/c<c0800002
c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c080
00000lc<c00000000002c<c<0P0000;<c<`20000B/c<c068`;P1B9280@00
000000>8`;S8h=R8`;P03<c<c00=QJN5IhMWQJN5KHm]Rjn:LYMaSkN?03<0
c<c<OJMmUKnEOJMm03<000?<c<`0300c0<c<c9_8VhN[Qi_8V`0c0<c<c8N[
Qi_8VhN[Qi_8Vgn[OaC<c<`4000000?<c<`00000000010000004c<c<0000
0000c<c<1P000003c<c<0000000000G<c<`200001Lc<c08000001<c<c000
00000<c<c0800002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0
000000001/c<c0800002c<c<0P000004c<c<00000000c<c<0P0000?<c<`2
00000/c<c0800002c<c<0P0000C<c<`200000/c<c0800002c<c<0P000003
c<c<0000000000;<c<`2000000?<c<`0000000000/c<c08000000lc<c000
00000002c<c<0P0000;<c<`20000B/c<c068`;P1B9280@00000000>8`;S8
h=R8`;P03<c<c00=IhMWQJN5IhMWQJN5KHm]Rjn:KiE`SkN?03<0c<c<OJMm
UKnEOJMm00<0<`00382[Oi_8Vgn[Oi_8V`0c0<c<c8N[QiO2V82[Oi_8Vh2[
Oi_8Va;<c<`500000/c<c0800002c<c<0P000004c<c<00000000c<c<0P00
00;<c<`2000000?<c<`0000000001Lc<c0800005c<c<0P000004c<c<0000
0000c<c<0P0000;<c<`2000000?<c<`0000000000/c<c08000000lc<c000
00000006c<c<0P0000;<c<`2000000C<c<`00000003<c<`200000lc<c080
0002c<c<0P0000;<c<`200001<c<c0800002c<c<0P0000;<c<`2000000?<
c<`0000000000/c<c08000000lc<c00000000002c<c<0P000003c<c<0000
000000;<c<`200000/c<c080001:c<c<0HS0^058T8P1000000000hS0^<SP
f8S0^00<c<c<01amYgeWQfN5YhEWR6R5YhE]Sff;[hYbUg40<`3<c<bE_iEm
YgfE_iEoZgnG`YN7ZhNG`YN7ZhNKb9^7ZhL0<`3<c<bKb9]oZgnKb9]oZgnK
b9^7ZhLAc<c<100000C<c<`200000/c<c08000001<c<c00000000<c<c080
0002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000001<c<
c0800003c<c<0P000004c<c<0000c<c<c<c<0P000003c<c<0000000000;<
c<`2000000?<c<`0000000001/c<c0<000001<c<c00000000<c<c0800000
0lc<c00000000003c<c<0P0000;<c<`3000000?<c<`0000000001<c<c0<0
00001Lc<c000000000000<c<c00200000/c<c0030000c<c<c<c<00800000
1Lc<c000000000000<c<c002000000?<c<`0000000000/c<c0<000000lc<
c0000000001:c<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<00YW
QfN5YhEWQfMmYge]Sff5YhE]Sff;[hYbUg40<`02c<c<00EmYgfE_iEmYgfG
`YN7ZhL00/c<c00903<0c<c<VlRKP:]oVlRKQj^7VlRKQj^7VlRK017<c<`2
00001lc<c0@00002c<c<0P0000;<c<`400000lc<c0@000000lc<c0000000
000200000lc<c0800003c<c<0P000003c<c<0000000000800002c<c<0P00
00;<c<`2000000?<c<`0000000000P0000C<c<`2000000?<c<`000000000
0/c<c08000000lc<c00000000006000000C<c<`00000003<c<`200001Lc<
c08000000lc<c00000000002c<c<0P0000?<c<`400000/c<c08000001<c<
c00000000<c<c0@000001<c<c00000000<c<c080001;c<c<0HS0^058T8P1
000000000hS0^<SPf8S0^00<c<c<00YmYgeWQfMmYgeWQfMoZh1WQfN5YhE]
Sff;[hY_UG0203<01Lc<c080<`002Gn[Oi_8Vgn[Oi_8Vgn[P9_8Vgn[Oi_7
Vh2[O`0Ac<c<0P0000?<c<`200002<c<c080000?c<c<0P00027<c<`20000
3Lc<c0800002c<c<0P00027<c<`200000/c<c080001>c<c<0HS0^058T8P1
000000000hS0^<SPf8S0^00<c<c<00aWQfN5YhEWQfN5YhEWQfN5YhEWQfN5
YhE]Sff;[hY_U6n?]hl503<000^G`YN7ZhNKb9^7ZhNKb9^7ZhNG`YMoZgnK
b9^7ZhNKb9/04/c<c0D00009c<c<0P00013<c<`00`000<c<c<c<c00Oc<c<
0P0000G<c<`200001lc<c0030000c<c<c<c<0080000Rc<c<00<0003<c<c<
c<`00P0004k<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`077fW
OFN7IgfWOFN7IgfWOFN7IgfWOFN7IhFWQFf?KH^_RVnDKhngSgNOMhngSgNO
MiFoUGfWOIO2Ugn[OiO2V7n[P9_8VhN[Qi_8Vh2[Oi_8Vgn[Omk<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h00c<c<`076N7IhFWQFN7IgfWOFN7IhFW
QFN7IgfWOFf?KHFWQFf?KH^_RW:GLHngSgNOMhngSgfWOIFoUGfWOIO2UhN[
Qi_8Vgn[Oi_8VhN[Qi_8Vgn[Oi_7Vmk<c<`1R<2h0DR@R04000000003R<2h
b>3HR<2h00c<c<`077fWOFN7IgfWOFN7IgfWOFN7IgfWOFN7IgfWOFN7IhFW
QFf?KH^_RVnEL8^_RWNOMhngSgfWOIFoUGfWOIO2Ugn[Oi_7Vgn[Oi_8Vgn[
Oi_8VhN[Qmk<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00g<c<`06XFW
QFN7IhFWQFN7IhFWQFN7IhFWQFN7IhFWQFN9IhFWQFf?KH^_RW:GLHngSgNO
Mi2gT7fWOIFoUGfWOI_7VhN[Qi_7VhN[Qi_8VhN[Qmo<c<`1R<2h0DR@R040
00000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SP
f8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c0O<
c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7c<c<0HS0^058T8P1
000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B9280@00000000>8`;S8
h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`7
c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<1lc<c068`;P1B928
0@00000000>8`;S8h=R8`;P0olc<c0O<c<`1R<2h0DR@R04000000003R<2h
b>3HR<2h0?o<c<`7c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oR<2h
28S0^058T8P1000000000hS0^<SPf8S0^002002001400H000X000X400h40
18401H401H801X801h81288128<12H<12X<12h<12h@138@13H@00P4>Q@06
0Pn50Q250Q660Q660Q:60Q>60P8DQ`060QF70QJ70aN80aN80aR80aV80P<J
R@050a^90ab:0af:0af:11j:00847h/02P@PR`@QR`@RS0@RS0@SS0@TS0@U
S@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`
T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0LjU0Lk
U@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9AIP9
AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DI`:
DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0B35ZP35^P35bP
35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS3FFS3FFT3FJT3FNT
0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X
3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m
[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7/08BR;00
2Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D
]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPEW[PE
WkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`F
Z[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/klD6;C00HS0
^058T8P1000000000hS0^<SPf8S0^002002001400H000X000X400h401840
1H401H801X801h81288128<12H<12X<12h<12h@138@13H@00P4>Q@060Pn5
0Q250Q660Q660Q:60Q>60P8DQ`060QF70QJ70aN80aN80aR80aV80P<JR@05
0a^90ab:0af:0af:11j:00847h/02P@PR`@QR`@RS0@RS0@SS0@TS0@US@DU
S@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`T@Ha
T@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0LjU0LkU@02
23bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9AIP9AYT9
AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DI`:DId;
DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0B35ZP35^P35bP35bQ
35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS3FFS3FFT3FJT3FNT0PeX
Y@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X3g>X
0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m[11n
[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7/08BR;002Q:9
/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D]1>D
]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPEW[PEWkPE
WkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`F
Zk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/klD6;C00HS0^058
T8P1000000000hS0^<SPf8S0^002002001400H000X000X400h4018401H40
1H801X801h81288128<12H<12X<12h<12h@138@13H@00P4>Q@060Pn50Q25
0Q660Q660Q:60Q>60P8DQ`060QF70QJ70aN80aN80aR80aV80P<JR@050a^9
0ab:0af:0af:11j:00847h/02P@PR`@QR`@RS0@RS0@SS0@TS0@US@DUS@DV
S@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`T@HaT@Ha
T@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0LjU0LkU@0223bE
00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9AIP9AYT9AiT2
2DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;
Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0B35ZP35^P35bP35bQ35fQ
35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS3FFS3FFT3FJT3FNT0PeXY@06
3VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X3g>X0Pmd
Z@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m[11n[11o
[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7/08BR;002Q:9/1::
/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D]1>D]1>E
]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPEW[PEWkPEWkPE
X;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZk`F
ZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/kl26;C04000008H]<01
R<2h0DR@R04000000003R<2hb>3HR<2h008008004@01P002P002P@03P@04
P@05P@05PP06PP07PP48PP48P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H2
3hD248D24HH24HH24XH24hH20QB700H25HL25XL35hP35hP368P36HP20aZ9
00D36hT378X37HX37HX47XX00P@OR`0:122;126;12:<12:<12><12B<12F=
1BF=1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A
1S6A1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E
0088?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6
V@U7V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YA
W@]BW@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<
G:4<GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@2
3FRU00H>JJD>JZD>JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?
LjP23gBY00D?MJT?MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/
47j/47n]4Gn]4H2]4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:
4XV`4XZa4X^a4X^a4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd
4iBd4iFe008DU[D01QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO
^1FO^1FP^AFQ^@8EX[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ
_1J[_1J[_AN/_AN]_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc_`8H]<000lSP
f4R@R4R@R00<B92800D0000H]<0H]<28`;Q8T8P00@00000000>8`;S8h=R8
`;P00P00P00A006000:000:100>100B100F100F200J200N20@R20@R30@V3
0@Z30@^30@^40@b40@f400813XD01P8?Q@8@Q@8AQP8AQP8BQP8CQP8258L0
1P8EQ`8FQ`<GR0<GR0<HR0<IR0836XT01@<KR@<LRP<MRP<MRP@NRP0211n;
00X488/48H/48X`48X`48h`498`49Hd59Hd59Xd59hh21BR>00H5:Hh5:Xl5
:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46<I46<Y46<i86=987=987=I<7
=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE23jF23nF23nF242G
246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E2DVJ2DZJ2T^J2T^J
2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM2eBN2eFN2eJN2eNN
2eNO2eRO008;FIl04PaJX0aKX0aLX0aLX@aMX@aNX@aOX@aOXPaPXPaQXPeR
XPeRX`eSX`eTX`eUX`eUY0eVY0eWY08=J:D01PiYY@iZY@i[YPi[YPi/YPi]
YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmgZPmgZQ1h
ZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh24H:^00HA
PjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4BSK8BS[8C
S[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne59Rf59Vf
59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F5J>j5JBj
5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm5jjn5jnn
5k2n5k6n5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h00^8`;P01TR@R00001Rd
`1Rd`8S0^4R@R04000000003R<2hb>3HR<2h008008000`01P002P?ooo`02
oooo00@01H7oool01X801h82oooo00@12H?oool12h<12h@3oooo00<13XD2
3hD248D00oooo`050Q>60QB70QB70QF7oooo00835hP00oooo`<IR0<JR@03
oooo0P<MRP05oooo11n;11n;122;oooo00848X`01P@SS0@TS0@US@DUS@DV
S@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`T@HaT@Ha
T@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0LjU0LkU@0223bE
00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9AIP9AYT9AiT2
2DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;
Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0B35ZP35^P35bP35bQ35fQ
35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS3FFS3FFT3FJT3FNT0PeXY@06
3VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X3g>X0Pmd
Z@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m[11n[11o
[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7/08BR;002Q:9/1::
/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D]1>D]1>E
]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPEW[PEWkPEWkPE
X;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZk`F
ZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/kl26;C000?8h=R8`;R8
`;P02hS0^006B92800006;C06;C0R<2hB9280@00000000>8`;S8h=R8`;P0
0P00P0040060oooo00:100>10_ooo`0500F200J2oooo0@R20@R300;oool0
204;Poooo`4<Q04=Q04>QOooo`8?QOooo`824HH01P8BQ_ooo`8DQ`8DQooo
o`8FQ`835hP02Oooo`<IR?ooo`<JR@<KR@<LR_ooo`<MR_ooo`0211n;00X4
88_oool48X`48X`48h`498`49Hd59Hd59Xd59hh21BR>00H5:Hh5:Xl5:hl5
:hl5;8l6;I021Rj@00X6;i06<946<I46<I46<Y46<i86=987=987=I<7=Y<2
1cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE23jF23nF23nF242G246G
0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E2DVJ2DZJ2T^J2T^J2TbK
2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM2eBN2eFN2eJN2eNN2eNO
2eRO008;FIl04PaJX0aKX0aLX0aLX@aMX@aNX@aOX@aOXPaPXPaQXPeRXPeR
X`eSX`eTX`eUX`eUY0eVY0eWY08=J:D01PiYY@iZY@i[YPi[YPi/YPi]YP8>
KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmgZPmgZQ1hZP02
47V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh24H:^00HAPjhA
Q:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4BSK8BS[8CS[8C
Sk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne59Rf59Vf59Vf
59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F5J>j5JBj5ZFj
5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm5jjn5jnn5k2n
5k6n5k6o5k:o5k>o0QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0
^006B92800006;C06;C0R<2hB9280@00000000>8`;S8h=R8`;P00P00P00A
oooo00:000:1oooo00B100F1oooo00J2oooo0@R20@R30@V3oooo0@^3oooo
0@b40@f400813XD00`8?Q@8@Q@8AQP02oooo00D24hH258L258Ooool25XL0
0P<GR009oooo0aV8oooo0aZ90a^90ab:oooo0af:oooo00847h/02P@PRooo
o`@RS0@RS0@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/
S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<0
1@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G
00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:
CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l0
0P]IW`0B35ZP35^P35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S
3FBS3FFS3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`06
3VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/0
2Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65
[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@
/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LD
VkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXF
Y[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG
/KlG/[lG/kl26;C000?8h=R8`;R8`;P00XS0^0800002R<2h0P0000>8`;P0
1TR@R00001Rd`1Rd`8S0^4R@R04000000003R<2hb>3HR<2h008008003_oo
o`02P002P@03P@04P@05POooo`06P_ooo`48PP48P`49Poooo`4;P`Goool0
1P8?Q@8@QOooo`8AQP8BQP8CQP8258L03Oooo`8FQ`<GR0<GR?ooo`<IR?oo
o`<JR@<KR@<LR_ooo`<MR_ooo`0211n;00X488_oool48X`48X`48h`498`4
9Hd59Hd59Xd59hh21BR>00H5:Hh5:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06
<946<I46<I46<Y46<i86=987=987=I<7=Y<21cNC00D7>9@7>I@7>Y@7>Y@7
>iD00PPlU@0623fE23jF23nF23nF242G246G0PQ2U`062D>H2DBH2DFH2DFH
2DJI2DNI0PU8V@0E2DVJ2DZJ2T^J2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6L
2U6M2e:M2e>M2eBM2eBN2eFN2eJN2eNN2eNO2eRO008;FIl04PaJX0aKX0aL
X0aLX@aMX@aNX@aOX@aOXPaPXPaQXPeRXPeRX`eSX`eTX`eUX`eUY0eVY0eW
Y08=J:D01PiYY@iZY@i[YPi[YPi/YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mb
Z0mcZ08?M:T01@meZ@mfZPmgZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@
OJ`@OZ`@OjdAOjdAP:dAPJh24H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`
00XBRK0BR[4BRk4BRk4BS;4BSK8BS[8CS[8CSk<CT;<24i6c00DCT[@CTk@C
U;@CU;@CUKD00QBF]@0659Ne59Rf59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh
5Inh5Inh5J2i5J6i0QFR^@0F5J>j5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl
5ZZl5Z^l5Z^m5jbm5jfm5jjm5jjn5jnn5k2n5k6n5k6o5k:o5k>o0QRd`003
b>3HR<2hR<2h00>8`;P4000018S0^006B92800006;C06;C0R<2hB9280@00
000000>8`;S8h=R8`;P00P00P00Eoooo00:000:100>100B100F1oooo00J2
oooo0@R20@R30@V3oooo0@^3oooo0@b40@f40@j5oooo0Pn5oooo00824HH0
1P8BQ_ooo`8DQ`8DQoooo`8FQ`835hP02?ooo`<IR?ooo`<JR@<KR@<LR_oo
o`<MRP;oool00`@OR`@PRoooo`0212:<00H48h`498`49Hd59Hd59Xd59hh2
1BR>00H5:Hh5:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46<I46<Y46
<i86=987=987=I<7=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE
23jF23nF23nF242G246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E
2DVJ2DZJ2T^J2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM
2eBN2eFN2eJN2eNN2eNO2eRO008;FIl04PaJX0aKX0aLX0aLX@aMX@aNX@aO
X@aOXPaPXPaQXPeRXPeRX`eSX`eTX`eUX`eUY0eVY0eWY08=J:D01PiYY@iZ
Y@i[YPi[YPi/YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@me
Z@mfZPmgZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdA
P:dAPJh24H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4B
Rk4BS;4BSK8BS[8CS[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF
]@0659Ne59Rf59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i
0QFR^@0F5J>j5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm
5jfm5jjm5jjn5jnn5k2n5k6n5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h00B8
`;P200001HS0^006B92800006;C06;C0R<2hB9280@00000000>8`;S8h=R8
`;P00P00P00?oooo00:000:100>100B100F1oooo00J2oooo0@R20@R30@V3
oooo0@^30@^400?oool00`4>Q@8?Q@8@Q@03oooo00<24hH258Ooool00_oo
o`835hP00oooo`<IR0<JR@03oooo0P<MRP05oooo11n;oooooooo126;0084
8X`01P@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]
T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@Lh
U0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9
@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:
CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]I
W`0B35ZP35^P35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS
3FFS3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW
3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1j
Za1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65
[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8C
TK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL2
59bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/F
Yk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG
/[lG/kl26;C000?8h=R8`;R8`;P00hS0^0@00004R<2h00I8T8P0000H]<0H
]<28`;Q8T8P1000000000hS0^<SPf8S0^0020020017oool00X000X400h40
18401H7oool01X801h81288128<12H<12X<12h<12h@138@13H@00P4>Q@06
0Pn50Q250Q660Q660Q:60Q>60P8DQ`06oooo0QJ70aN80aN80aR80aV80P<J
R@050a^90ab:0af:0af:11j:00847h/02P@PR`@QR`@RS0@RS0@SS0@TS0@U
S@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`
T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0LjU0Lk
U@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9AIP9
AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DI`:
DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0B35ZP35^P35bP
35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS3FFS3FFT3FJT3FNT
0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X
3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m
[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7/08BR;00
2Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D
]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPEW[PE
WkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`F
Z[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/kl26;C000?8
h=R8`;R8`;P00XS0^0800002R<2h0P0000>8`;P01TR@R00001Rd`1Rd`8S0
^4R@R04000000003R<2hb>3HR<2h008008004@01P?ooo`02P@03P@04POoo
o`05PP06PP07PP48PP48P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD2
48D24HH24HH24XH24hH20QB700Koool25XL35hP35hP368P36HP20aZ900D3
6hT378X37HX37HX47XX00P@OR`0:122;126;12:<12:<12><12B<12F=1BF=
1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A
1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088
?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7
V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]B
W@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<
GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU
00H>JJD>JZD>JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP2
3gBY00D?MJT?MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/
47n]4Gn]4H2]4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`
4XZa4X^a4X^a4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd
4iFe008DU[D01QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO
^1FP^AFQ^@8EX[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[
_1J[_AN/_AN]_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc_`8H]<001<SPf8S0
^8S0^8S0^0800004R<2h0P0000:8`;P01TR@R00001Rd`1Rd`8S0^4R@R040
00000003R<2hb>3HR<2h008008000`01P002P?ooo`02oooo00`01H401H80
1X801h81288128<12H<12X<12h<12h@138@13H@20@j500H23hD248D24HH2
4HH24XH24hH20QB700H25HL25XL35hP35hSoool36HP20aZ900D36hT378X3
7HX37HX47XX00P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>
0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A
1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPm
U@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T0
5@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]D
W@]DWP]EWP]FWP]GWP]GW`]HW`022eVO018<FZ0<Fj0<G:0<G:4<GJ4<GZ4<
Gj4<Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@23FRU00H>JJD>
JZD>JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?
MJT?MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]
4H2]4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a
4X^a4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008D
U[D01QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ
^@8EX[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/
_AN]_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc_`8H]<000lSPf8S0^8S0^00;
R<2h00I8T8P0000H]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^0020020
01400H000X000X400h4018401H401H801X801h81288128<12H<12X<12h<1
2h@138@13H@00P4>Q@060Pn50Q250Q660Q660Q:60Q>60P8DQ`060QF70QJ7
0aN80aN80aR80aV80P<JR@050a^90ab:0af:0af:11j:00847h/02P@PR`@Q
R`@RS0@RS0@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/
S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<0
1@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G
00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:
CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l0
0P]IW`0B35ZP35^P35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S
3FBS3FFS3FFT3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`06
3VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/0
2Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65
[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@
/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LD
VkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXF
Y[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG
/KlG/[lG/kl26;C000?8h=R8`;R8`;P02hS0^006B92800006;C06;C0R<2h
B9280@00000000>8`;S8h=R8`;P00P00P00A006000:000:100>100B100F1
00F200J200N20@R20@R30@V30@Z30@^30@^40@b40@f400813XD01P8?Q@8@
Q@8AQP8AQP8BQP8CQP8258L01P8EQ`8FQ`<GR0<GR0<HR0<IR0836XT01@<K
R@<LRP<MRP<MRP@NRP0211n;00X488/48H/48X`48X`48h`498`49Hd59Hd5
9Xd59hh21BR>00H5:Hh5:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46
<I46<Y46<i86=987=987=I<7=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPl
U@0623fE23jF23nF23nF242G246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI
0PU8V@0E2DVJ2DZJ2T^J2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M
2e>M2eBM2eBN2eFN2eJN2eNN2eNO2eRO008;FIl04PaJX0aKX0aLX0aLX@aM
X@aNX@aOX@aOXPaPXPaQXPeRXPeRX`eSX`eTX`eUX`eUY0eVY0eWY08=J:D0
1PiYY@iZY@i[YPi[YPi/YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?
M:T01@meZ@mfZPmgZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@
OjdAOjdAP:dAPJh24H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0B
R[4BRk4BRk4BS;4BSK8BS[8CS[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@C
UKD00QBF]@0659Ne59Rf59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh
5J2i5J6i0QFR^@0F5J>j5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l
5Z^m5jbm5jfm5jjm5jjn5jnn5k2n5k6n5k6o5k:o5k>o0QRd`0o8h=P01@00
01Rd`1Rd`8S0^4R@R001000000000hS0^<SPf8S0^002002001400H000X00
0X400h4018401H401H801X801h81288128<12H<12X<12h<12h@138@13H@0
0P4>Q@060Pn50Q250Q660Q660Q:60Q>60P8DQ`060QF70QJ70aN80aN80aR8
0aV80P<JR@050a^90ab:0af:0af:11j:00847h/02P@PR`@QR`@RS0@RS0@S
S0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y00
2PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0Lj
U0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9
AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:
D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0B35ZP
35^P35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS3FFS3FFT
3FJT3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X
3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l
[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7
/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B
]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HE
WKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/F
Z;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/klD
6;C00HS0^058T8P1000000000hS0^<SPf8S0^002002001400H000X000X40
0h4018401H401H801X801h81288128<12H<12X<12h<12h@138@13H@00P4>
Q@060Pn50Q250Q660Q660Q:60Q>60P8DQ`060QF70QJ70aN80aN80aR80aV8
0P<JR@050a^90ab:0af:0af:11j:00847h/02P@PR`@QR`@RS0@RS0@SS0@T
S0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_
T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0Lj
U0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9
AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:
DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0B35ZP35^P
35bP35bQ35fQ35jQ35nQ35nR362R366R3F:R3F:S3F>S3FBS3FFS3FFT3FJT
3FNT0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X
3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l
[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7/08B
R;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C
]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPE
W[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`F
ZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/klD6;C0
0HS0^058T8P1000000000hS0^<SPf8S0^03oR<2h28S0^058T8P100000000
0hS0^<SPf<SPf03ob>3H2<SPf058T8P10000003oR<2h38S0^04000000001
\
\>"], "Graphics",
  ImageSize->{268, 126},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004<0000g1P00`40o`00
0?l0003o?<c<c<80000>c<c<000lc<c<00<0003<c<c<c<`0[/c<c13oool0
0`000<c<c<c<c00<c<c<000lc<c<00<0003<c<c<c<`0[Lc<c003IVIVc<c<
IVIV00eVIVH00oooo`000<c<c00=c<c<000lc<c<00<0003<c<c<c<`0[Lc<
c003IVIVooooc<c<00c<c<`00fIVI_ooo`00000>c<c<000lc<c<00<0003<
c<c<c<`0[Lc<c003IVIVooooc<c<00c<c<`00fIVI_ooo`00000>c<c<000l
c<c<00<0003<c<`00000100000C<c<`400000lc<c0@00003c<c<100000;<
c<`200000/c<c0800002c<c<0P000004c<c<00000000c<c<0P0000?<c<`4
00000/c<c080001fc<c<00=VIVKoooo<c<`03<c<c003IVIVoooo000000k<
c<`003c<c<`010000<c<c000000000;<c<`200000/c<c0800002c<c<0P00
0003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c08000000lc<
c00000000002c<c<0P0000;<c<`2000000G<c<`000000000003<c<`00P00
0003c<c<0000000000;<c<`2000000?<c<`000000000M/c<c003IVIVoooo
c<c<00c<c<`00fIVI_ooo`00000>c<c<000lc<c<00@0003<c<`000000003
c<c<0P000003c<c<0000000000G<c<`200001Lc<c0800005c<c<0P0000;<
c<`200000/c<c08000000lc<c00000000002c<c<0P000003c<c<00000000
00G<c<`20000M/c<c003IVIVooooc<c<00G<c<`200001Lc<c003IVIVoooo
000000k<c<`003c<c<`010000<c<c000000000?<c<`2000000?<c<`00000
000010000003c<c<0000000000G<c<`6000000?<c<`0000000000/c<c080
0002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000001000
0003c<c<0000000007K<c<`00fIVI_ooolc<c004c<c<100000C<c<`00fIV
I_ooo`00000>c<c<000lc<c<00@0003<c<`000000003c<c<0P000003c<c<
0000000000;<c<`2000000?<c<`0000000001Lc<c0800002c<c<0P000003
c<c<0000000000;<c<`200000/c<c08000000lc<c00000000002c<c<0P00
0003c<c<0000000000;<c<`2000000?<c<`000000000M/c<c003IVIVoooo
c<c<00?<c<`600000lc<c003IVIVoooo000000k<c<`003c<c<`010000<c<
c000000000?<c<`2000000?<c<`0000000000/c<c08000000lc<c0000000
0002c<c<0P000003c<c<0000000000;<c<`2000000G<c<`000000000003<
c<`00`000004c<c<00000000c<c<0`000004c<c<00000000c<c<0P0000;<
c<`2000000?<c<`000000000M/c<c003IVIVooooc<c<00;<c<`800000/c<
c003IVIVoooo000000k<c<`003c<c<`010000<c<c000000000?<c<`20000
0/c<c0@00003c<c<100000?<c<`400000/c<c08000000lc<c00000000002
c<c<0P0000;<c<`2000000?<c<`0000000000lc<c0@00002c<c<100007C<
c<`00fIVI_ooolc<c00<c<c<00=VIVKoool000003/c<c000?<c<c0040000
c<c<000000000/c<c080000Rc<c<0P0008C<c<`00fIVI_ooolc<c00<c<c<
00=VIVKoool000003/c<c000?<c<c0030000c<c<000000@0000Sc<c<0P00
08C<c<`00fIVI_ooolc<c00<c<c<00=VIVKoool000003/c<c000?<c<c003
0000c<c<c<c<0:g<c<`00fIVI_ooolc<c00<c<c<00=VIVKoool000003/c<
c000?<c<c0030000c<c<c<c<0:g<c<`00fIVI_ooolc<c00<c<c<00=VIVKo
ool000003/c<c000?<c<c0030000c<c<c<c<0:g<c<`00fIVI_ooooooo`0<
oooo00=VIVKoool000003/c<c000?<c<c0030000c<c<c<c<0:g<c<`@IVJI
00?oool0003<c<`03Lc<c000?<c<c0030000c<c<c<c<0:g<c<`00fIVVLc<
oiVIc00<VIW<00=VIYWoool000003/c<c000?<c<c0030000c<c<c<c<0:g<
c<`00fIVVLc<oiVIc00<VIW<00=VIYWoool000003/c<c000?<c<c0030000
c<c<c<c<0:g<c<`00fIVVLc<oiVIc003VIW<00EVIYVIVLbIVLbIVLaVIYT0
19VIc003IVJIoooo000000k<c<`003c<c<`00`000<c<c<c<c02]c<c<00=V
IYW<c?nIVL`00YVIc005c<coVIW<VIW<VIW<c<co00FIVL`00fIVVOooo`00
000>c<c<000lc<c<00<0003<c<c<c<`0[Lc<c005IVJIc<coVIW<VIW<IVJI
00>IVL`01FIVVIVIc9VIc9VIc6IVV@02VIW<00=VIYWoool000003/c<c000
?<c<c0040000c<c<000000000lc<c0800002c<c<100000?<c<`300000lc<
c0@00002c<c<0P0000;<c<`200000/c<c08000001<c<c00000000<c<c080
0003c<c<100000;<c<`20000Mlc<c004IVJIc<coVIW<c<co0iVIc005c<co
VIW<VIW<VIW<c<co00>IVL`00fIVVOooo`00000>c<c<000lc<c<00@0003<
c<`000000002c<c<0`000003c<c<0000000000;<c<`200000/c<c0<00002
c<c<0P0000;<c<`2000000?<c<`0000000000/c<c0800002c<c<0P000005
c<c<000000000000c<c<008000000lc<c00000000002c<c<0P000003c<c<
0000000007O<c<`00fIVVLc<oiVIc003VIW<00EVIYVIVLbIVLbIVLaVIYT0
19VIc003IVJIoooo000000k<c<`003c<c<`010000<c<c000000000;<c<`3
000000?<c<`0000000000/c<c08000001<c<c00000000<c<c08000000lc<
c00000000005c<c<0P0000;<c<`200000/c<c08000000lc<c00000000002
c<c<0P000003c<c<0000000000G<c<`20000Mlc<c003IVJIc<coVIW<00:I
VL`01Lc<oiVIc9VIc9VIc<c<o`05VIW<00=VIYWoool000003/c<c000?<c<
c0050000c<c<00000000c<c<00@000000lc<c00000000002c<c<0P000004
c<c<00000000c<c<0P000003c<c<0000000000@000000lc<c00000000002
c<c<0P0000;<c<`2000000?<c<`0000000000/c<c08000000lc<c0000000
0004000000?<c<`000000000Mlc<c005IVJIc<coVIW<VIW<IVJI00>IVL`0
1FIVVIVIc9VIc9VIc6IVV@02VIW<00=VIYWoool000003/c<c000?<c<c007
0000c<c<00000000c<c<0000c<c<008000000lc<c00000000002c<c<0P00
0004c<c<00000000c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0
000000000/c<c0800002c<c<0P000003c<c<0000000000;<c<`2000000?<
c<`0000000000/c<c08000000lc<c0000000001gc<c<00AVIYW<c?nIVLc<
c?l3VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc003IVJIoooo000000k<c<`0
03c<c<`00`000<c<c0000003000000?<c<`0000000000/c<c0030000c<c<
c<c<00@00003c<c<100000;<c<`2000000G<c<`000000000003<c<`00`00
0004c<c<00000000c<c<0`000004c<c<00000000c<c<0P0000;<c<`20000
00?<c<`000000000Mlc<c003IVJIc<coVIW<00>IVL`01FIVVIVIc9VIc9VI
c6IVV@04VIW<00=VIYWoool000003/c<c000?<c<c0030000c<c<00000080
0002c<c<0P0000;<c<`4000000?<c<`0000000000lc<c08000000lc<c000
0000000200000/c<c08000000lc<c00000000002c<c<0P0000;<c<`20000
00?<c<`0000000000lc<c0@00002c<c<100007G<c<`00fIVVLc<oiVIc002
VIW<00G<c?nIVLbIVLbIVLc<c?l01IVIc003IVJIoooo000000k<c<`003c<
c<`00`000<c<c000000200000/c<c080000Pc<c<0P0008G<c<`01FIVVLc<
oiVIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00YVIc003IVJIoooo
000000k<c<`003c<c<`010000<c<c000000000?<c<`200008<c<c0800025
c<c<00AVIYW<c?nIVLc<c?l3VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc003
IVJIoooo000000k<c<`003c<c<`00`000<c<c<c<c02]c<c<00=VIYW<c?nI
VL`00iVIc005IVJIVIW<VIW<VIW<IVJI00BIVL`00fIVVOooo`00000>c<c<
000lc<c<00<0003<c<c<c<`0[Lc<c003IVJIc<coVIW<00:IVL`01Lc<oiVI
c9VIc9VIc<c<o`05VIW<00=VIYWoool000003/c<c000?<c<c0030000c<c<
c<c<0:g<c<`01FIVVLc<oiVIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaV
IYT00YVIc003IVJIoooo000000k<c<`003c<c<`00`000<c<c<c<c02]c<c<
00AVIYW<c?nIVLc<c?l3VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc003IVJI
oooo000000k<c<`003c<c<`00`000<c<c<c<c02]c<c<00=VIYW<c?nIVL`0
0iVIc005IVJIVIW<VIW<VIW<IVJI00BIVL`00fIVVOooo`00000>c<c<000l
c<c<00<0002IVLbIVL`0[IVIc003IVJIc<coVIW<00:IVL`01Lc<oiVIc9VI
c9VIc<c<o`05VIW<00=VIYWoool000003/c<c000?<c<c0030000VIW<VIW<
0:fIVL`01FIVVLc<oiVIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT0
0YVIc003IVJIoooo000000k<c<`003c<c<`00`0009VIc9VIc02]VIW<00AV
IYW<c?nIVLc<c?l3VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc003IVJIoooo
000000k<c<`003c<c<`00`0009VIc9VIc02]VIW<00=VIYW<c?nIVL`00iVI
c005IVJIVIW<VIW<VIW<IVJI00BIVL`00fIVVOooo`00000>c<c<000lc<c<
00@0002IVLbIVLbIVL`4000019VIc0@00003VIW<0P0000:IVL`400000YVI
c08000000iVIc00000000003VIW<100000:IVL`20000PiVIc003IVJIc<co
VIW<00:IVL`01Lc<oiVIc9VIc9VIc<c<o`05VIW<00=VIYWoool000003/c<
c000?<c<c0030000VIW<VIW<00800002VIW<0P0000:IVL`200000YVIc080
00000iVIc00000000002VIW<0P0000:IVL`2000000FIVL`000000000002I
VL`00P000003VIW<0000000000:IVL`2000000>IVL`000000000PiVIc005
IVJIc<coVIW<VIW<IVJI00>IVL`01FIVVIVIc9VIc9VIc6IVV@02VIW<00=V
IYWoool000003/c<c000?<c<c0040000VIW<0000000019VIc08000000iVI
c00000000005VIW<0P0000:IVL`200000YVIc08000000iVIc00000000002
VIW<0P000003VIW<0000000000FIVL`20000PiVIc004IVJIc<coVIW<c<co
0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`00fIVVOooo`00000>c<c<000l
c<c<00@0002IVL`000000004VIW<0P000003VIW<0000000000FIVL`20000
0YVIc0800002VIW<0P000003VIW<0000000000:IVL`2000000>IVL`00000
000010000003VIW<0000000008>IVL`00fIVVLc<oiVIc003VIW<00EVIYVI
VLbIVLbIVLaVIYT019VIc003IVJIoooo000000k<c<`003c<c<`0100009VI
c000000000BIVL`2000000>IVL`0000000001IVIc0800002VIW<0P0000:I
VL`2000000>IVL`0000000000YVIc08000000iVIc00000000002VIW<0P00
0003VIW<0000000008>IVL`00fIVVLc<oiVIc002VIW<00G<c?nIVLbIVLbI
VLc<c?l01IVIc003IVJIoooo000000k<c<`003c<c<`0100009VIc0000000
00BIVL`2000000>IVL`0000000000YVIc08000000iVIc00000000003VIW<
00<0002IVLbIVL`00P000005VIW<000000000000VIW<008000000iVIc000
00000002VIW<0P000003VIW<0000000008>IVL`01FIVVLc<oiVIc9VIc6IV
V@03VIW<00EVIYVIVLbIVLbIVLaVIYT00YVIc003IVJIoooo000000k<c<`0
03c<c<`0100009VIc000000000BIVL`200000YVIc0@000000iVIc0000000
000200000YVIc0@00002VIW<0P000003VIW<0000000000>IVL`400000YVI
c0@00021VIW<00AVIYW<c?nIVLc<c?l3VIW<00G<c?nIVLbIVLbIVLc<c?l0
0iVIc003IVJIoooo000000k<c<`003c<c<`00`0009VIc9VIc00200000YVI
c0800009VIW<0P0000VIVL`20000TIVIc003IVJIc<coVIW<00>IVL`01FIV
VIVIc9VIc9VIc6IVV@04VIW<00=VIYWoool000003/c<c000?<c<c0040000
VIW<VIW<VIW<100000^IVL`00`0009VIc9VIc007VIW<0P00096IVL`00fIV
VLc<oiVIc002VIW<00G<c?nIVLbIVLbIVLc<c?l01IVIc003IVJIoooo0000
00k<c<`003c<c<`00`0009VIc9VIc02]VIW<00EVIYW<c?nIVLbIVLaVIYT0
0iVIc005IVJIVIW<VIW<VIW<IVJI00:IVL`00fIVVOooo`00000>c<c<000l
c<c<00<0002IVLbIVL`0[IVIc004IVJIc<coVIW<c<co0iVIc005c<coVIW<
VIW<VIW<c<co00>IVL`00fIVVOooo`00000>c<c<000lc<c<00<0002IVLbI
VL`0[IVIc003IVJIc<coVIW<00>IVL`01FIVVIVIc9VIc9VIc6IVV@04VIW<
00=VIYWoool000003/c<c000?<c<c0030000VIW<VIW<0:fIVL`00fIVVLc<
oiVIc002VIW<00G<c?nIVLbIVLbIVLc<c?l01IVIc003IVJIoooo000000k<
c<`003c<c<`00`0008R8c8R8c02]R8S<00EVIYW<c?nIVLb8R<`008P00YVI
c006R8S<0028VIW<VIW<R8S<00280YVIc003IVJIoooo000000k<c<`003c<
c<`00`000<c<c<c<c02]c<c<00=VIYW<c?nIVL`00iVIc005IVJIVIW<VIW<
VIW<IVJI00BIVL`00fIVVOooo`00000>c<c<000lc<c<00<0003<c<c<c<`0
3/c<c080002Mc<c<00=VIYW<c?nIVL`00YVIc005c<coVIW<VIW<VIW<c<co
00FIVL`00fIVVOooo`00000>c<c<000lc<c<00<0003<c<c<c<`03/c<c080
002Mc<c<00EVIYW<c?nIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI
00:IVL`00fIVVOooo`00000>c<c<000lc<c<00<0003<c<c<c<`01@0000?<
c<`400000/c<c08000000lc<c00000000003c<c<0P0000;<c<`400000/c<
c0800002c<c<0P0000;<c<`2000000C<c<`00000003<c<`200000lc<c0@0
0002c<c<0P0007;<c<`016IVVLc<oiVIc<c<o`>IVL`01Lc<oiVIc9VIc9VI
c<c<o`03VIW<00=VIYWoool000003/c<c000?<c<c0040000c<c<00000000
0lc<c08000000lc<c00000000002c<c<0P000005c<c<000000000000c<c<
008000000lc<c00000000002c<c<0P0000;<c<`2000000?<c<`000000000
0/c<c0800002c<c<0P000005c<c<000000000000c<c<008000000lc<c000
00000002c<c<0P000003c<c<0000000007;<c<`00fIVVLc<oiVIc003VIW<
00EVIYVIVLbIVLbIVLaVIYT019VIc003IVJIoooo000000k<c<`003c<c<`0
0`000<c<c<c<c004c<c<0P000003c<c<0000000000G<c<`200000/c<c080
00000lc<c00000000002c<c<0P0000G<c<`200000/c<c0800002c<c<0P00
0003c<c<0000000000;<c<`2000000?<c<`0000000001Lc<c080001bc<c<
00=VIYW<c?nIVL`00YVIc005c<coVIW<VIW<VIW<c<co00FIVL`00fIVVOoo
o`00000>c<c<000lc<c<00<0003<c<c<c<`00/c<c0@000000lc<c0000000
0004000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<1P00
0003c<c<0000000000;<c<`200000/c<c08000000lc<c00000000002c<c<
0P000003c<c<0000000000@000000lc<c0000000001bc<c<00EVIYW<c?nI
VLbIVLaVIYT00iVIc005IVJIVIW<VIW<VIW<IVJI00:IVL`00fIVVOooo`00
000>c<c<000lc<c<00<0003<c<c<c<`01@0000;<c<`200000/c<c0800000
0lc<c00000000002c<c<0P000003c<c<0000000000;<c<`200000/c<c080
00000lc<c00000000002c<c<0P0000;<c<`2000000?<c<`0000000000/c<
c08000000lc<c00000000002c<c<0P000003c<c<0000000007;<c<`016IV
VLc<oiVIc<c<o`>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00=VIYWoool0
00003/c<c000?<c<c0030000c<c<000000<00004c<c<0P0000;<c<`20000
00G<c<`000000000003<c<`00P000003c<c<0000000000;<c<`200000/c<
c08000001Lc<c000000000000<c<c003000000C<c<`00000003<c<`30000
00C<c<`00000003<c<`200000/c<c08000000lc<c0000000001bc<c<00=V
IYW<c?nIVL`00iVIc005IVJIVIW<VIW<VIW<IVJI00BIVL`00fIVVOooo`00
000>c<c<000lc<c<00@0003<c<`000000007c<c<100000;<c<`2000000C<
c<`00000003<c<`400000/c<c0@00002c<c<0P000003c<c<0000000000;<
c<`200000/c<c08000000lc<c00000000003c<c<100000;<c<`40000L<c<
c003IVJIc<coVIW<00:IVL`01Lc<oiVIc9VIc9VIc<c<o`05VIW<00=VIYWo
ool000003/c<c000?<c<c0040000c<c<000000000lc<c080000?c<c<0P00
01C<c<`20000P<c<c005IVJIc<coVIW<VIW<IVJI00>IVL`01FIVVIVIc9VI
c9VIc6IVV@02VIW<00=VIYWoool000003/c<c000?<c<c0030000c<c<c<c<
00D0000Ac<c<00<0003<c<c<c<`04/c<c0800020c<c<00AVIYW<c?nIVLc<
c?l3VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc003IVJIoooo000000k<c<`0
03c<c<`00`000<c<c<c<c02]c<c<00=VIYW<c?nIVL`00iVIc005IVJIVIW<
VIW<VIW<IVJI00BIVL`00fIVVOooo`00000>c<c<000lc<c<00<0003<c<c<
c<`0[Lc<c003IVJIc<coVIW<00:IVL`01Lc<oiVIc9VIc9VIc<c<o`05VIW<
00=VIYWoool000003/c<c000?<c<c0030000c<c<c<c<0:g<c<`01FIVVLc<
oiVIc9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00YVIc003IVJIoooo
000000k<c<`003c<c<`00`000<c<c<c<c02]c<c<00AVIYW<c?nIVLc<c?l3
VIW<00G<c?nIVLbIVLbIVLc<c?l00iVIc003IVJIoooo000000k<c<`003c<
c<`00`000<c<c<c<c02]c<c<00=VIYW<c?nIVL`00iVIc005IVJIVIW<VIW<
VIW<IVJI00BIVL`00fIVVOooo`00000>c<c<000lc<c<00<0003<c<c<c<`0
[Lc<c003IVJIc<coVIW<00:IVL`01Lc<oiVIc9VIc9VIc<c<o`05VIW<00=V
IYWoool000003/c<c000?<c<c0030000c<c<c<c<0:g<c<`01FIVVLc<oiVI
c9VIc6IVV@03VIW<00EVIYVIVLbIVLbIVLaVIYT00YVIc003IVJIoooo0000
00k<c<`003c<c<`00`000<c<c<c<c00?c<c<100009[<c<`016IVVLc<oiVI
c<c<o`>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<00=VIYWoool000003/c<
c000?<c<c0030000c<c<c<c<00k<c<`010000<c<c<c<c<c<c080002Ic<c<
00=VIYW<c?nIVL`00iVIc005IVJIVIW<VIW<VIW<IVJI00BIVL`00fIVVOoo
o`00000>c<c<000lc<c<00@0003<c<`000000003c<c<0P0000;<c<`20000
00?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P000003c<c<
0000000000;<c<`400000lc<c0800027c<c<00=VIYW<c?nIVL`00YVIc005
c<coVIW<VIW<VIW<c<co00FIVL`00fIVVOooo`00000>c<c<000lc<c<00@0
003<c<`000000003c<c<0P000004c<c<00000000c<c<0`000004c<c<0000
0000c<c<0`000004c<c<00000000c<c<0`000003c<c<0000000000;<c<`2
000000?<c<`000000000R<c<c005IVJIc<coVIW<VIW<IVJI00>IVL`01FIV
VIVIc9VIc9VIc6IVV@02VIW<00=VIYWoool000003/c<c000?<c<c0030000
c<c<000000H000000lc<c00000000002c<c<0P000003c<c<0000000000;<
c<`2000000?<c<`0000000000/c<c0800004c<c<0`000003c<c<00000000
08S<c<`016IVVLc<oiVIc<c<o`>IVL`01Lc<oiVIc9VIc9VIc<c<o`03VIW<
00=VIYWoool000003/c<c000?<c<c0030000c<c<c<c<008000000lc<c000
00000002c<c<0P0000;<c<`2000000?<c<`0000000000/c<c08000000lc<
c00000000002c<c<0P0000;<c<`400000/c<c0800028c<c<00=VIYW<c?nI
VL`00iVIc005IVJIVIW<VIW<VIW<IVJI00BIVL`00fIVVOooo`00000>c<c<
000lc<c<00<0003<c<c<c<`00P000003c<c<0000000000;<c<`200000/c<
c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`20000
00C<c<`0000000000004c<c<0P0008S<c<`00fIVVLc<oiVIc002VIW<00G<
c?nIVLbIVLbIVLc<c?l01IVIc003IVJIoooo000000k<c<`003c<c<`00`00
0<c<c<c<c002000000?<c<`0000000000/c<c0800002c<c<0P000004c<c<
00000000c<c<0`000003c<c<0000000000;<c<`2000000?<c<`000000000
0/c<c08000000lc<c00000000028c<c<00EVIYW<c?nIVLbIVLaVIYT00iVI
c005IVJIVIW<VIW<VIW<IVJI00:IVL`00fIVVOooo`00000>c<c<000lc<c<
00<0003<c<c<c<`00P000003c<c<0000000000;<c<`200000/c<c0800002
c<c<0P000004c<c<00000000c<c<0P0000;<c<`200000/c<c0@000000lc<
c000000000020000Qlc<c004IVJIc<coVIW<c<co0iVIc005c<coVIW<VIW<
VIW<c<co00>IVL`00fIVVOooo`00000>c<c<000lc<c<00@0003<c<c<c<c<
c<`300007lc<c0800028c<c<00=VIYW<c?nIVL`00iVIc005IVJIVIW<VIW<
VIW<IVJI00BIVL`00fIVVOooo`00000>c<c<000lc<c<00@0003<c<c<c<c<
c<`300008<c<c0030000c<c<c<c<08K<c<`00fIVVLc<oiVIc002VIW<00G<
c?nIVLbIVLbIVLc<c?l01IVIc003IVJIoooo000000k<c<`003c<c<`00`00
0<c<c<c<c02]c<c<00EVIYW<c?nIVLbIVLaVIYT00iVIc005IVJIVIW<VIW<
VIW<IVJI00:IVL`00fIVVOooo`00000>c<c<000lc<c<00<0003<c<c<c<`0
[Lc<c004IVJIc<coVIW<c<co0iVIc005c<coVIW<VIW<VIW<c<co00>IVL`0
0fIVVOooo`00000>c<c<000lc<c<00<0003<c<c<c<`0[Lc<c003IVJIc<co
VIW<00bIVL`00fIVVOooo`00000>c<c<000lc<c<00<0003<c<c<c<`0[Lc<
c003IVJIc<coVIW<00bIVL`00fIVVOooo`00000>c<c<000lc<c<00<0003<
c<c<c<`0[Lc<c003IVJIc<coc<co00c<c?l00fIVVOooo`00000>c<c<000l
c<c<00<0003<c<c<c<`0[Lc<c11VIYT00oooo`000<c<c00=c<c<000lc<c<
00<0003<c<c<c<`0[Lc<c003IVIVVIVIc<c<00c<c<`00fIVI_ooo`00000>
c<c<000lc<c<00<0003<c<c<c<`03lc<c0<0002Kc<c<00=VIVJIVIW<c<`0
3<c<c003IVIVoooo000000k<c<`003c<c<`00`000<c<c<c<c00Ac<c<0P00
09[<c<`00fIVIYVIVLc<c00<c<c<00=VIVKoool000003/c<c000?<c<c003
0000c<c<c<c<00@00003c<c<0P000004c<c<00000000c<c<0P0000;<c<`3
0000VLc<c003IVIVVIVIc<c<00c<c<`00fIVI_ooo`00000>c<c<000m0000
00?<c<`0000000000/c<c08000001<c<c00000000<c<c0<000000lc<c000
00000002c<c<0`0009W<c<`00fIVIYVIVLc<c00<c<c<00=VIVKoool00000
3@00007<c<`00003R<2hB928B92803U8T8P010000<c<c000000000;<c<`2
000000?<c<`0000000000/c<c08000001<c<c00000000<c<c08000000lc<
c0000000002Hc<c<00=VIVJIVIW<c<`03<c<c003IVIVoooo000000a8T8P1
00000Lc<c00000>8`;S8h=R8`;P0>HS0^0030000c<c<c<c<00?<c<`20000
00?<c<`0000000000/c<c08000001<c<c00000000<c<c08000000lc<c000
0000002Hc<c<00=VIVJIVIW<c<`03<c<c003IVIVoooo000000^8`;P1B928
0@00007<c<`00003R<2hb>3HR<2h03W<c<`00`000<c<c<c<c003c<c<0P00
0003c<c<0000000000;<c<`2000000C<c<`00000003<c<`2000000?<c<`0
00000000V<c<c003IVIVVIVIc<c<00c<c<`00fIVI_ooo`00000:c<c<00>8
`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0>Lc<c0030000c<c<c<c<00?<
c<`2000000?<c<`0000000000/c<c08000000lc<c0000000000200000lc<
c080002Gc<c<00=VIVJIVIW<c<`03<c<c003IVIVoooo000000[<c<`00hS0
^4R@R0000001c<c<00000hS0^<SPf8S0^00ic<c<00<0003<c<c<c<`00lc<
c08000000lc<c00000000002c<c<0P000003c<c<0000000000800003c<c<
0P0009O<c<`00fIVIYVIVLc<c00<c<c<00=VIVKoool000002/c<c003R<2h
B9280000007<c<`00003R<2hb>3HR<2h03W<c<`00`000<c<c<c<c003c<c<
0P0000S<c<`20000W/c<c003IVIVVIVIc<c<00c<c<`00fIVI_ooo`00000:
c<c<00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0>Lc<c0030000c<c<
c<c<00?<c<`200002<c<c080002Nc<c<00=VIVJIVIW<c<`03<c<c003IVIV
oooo000000[<c<`00hS0^4R@R0000001c<c<00000hS0^<SPf8S0^00ic<c<
00<0003<c<c<c<`0[Lc<c003IVIVVIVIc<c<00c<c<`00fIVI_ooo`00000:
c<c<00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0>Lc<c0030000c<c<
c<c<0:g<c<`00fIVIYVIVLc<c00<c<c<00=VIVKoool000002/c<c003R<2h
B9280000007<c<`00003R<2hb>3HR<2h03W<c<`00`000<c<c<c<c02]c<c<
00=VIVJIVIW<c<`03<c<c003IVIVoooo000000[<c<`00hS0^4R@R0000001
c<c<00000hS0^<SPf8S0^00ic<c<00<0003<c<c<c<`0[Lc<c003IVIVVIVI
c<c<00c<c<`00fIVI_ooo`00000:c<c<00>8`;Q8T8P000000Lc<c00000>8
`;S8h=R8`;P0>Lc<c0030000c<c<c<c<0:g<c<`00fIVIYVIVLc<c00<c<c<
00=VIVKoool000002/c<c003R<2hB9280000007<c<`00003R<2hb>3HR<2h
03W<c<`00`000<c<c<c<c02]c<c<00=VIVJIVIW<c<`03<c<c003IVIVoooo
000000[<c<`00hS0^4R@R0000001c<c<00000hS0^<SPf8S0^00ic<c<00<0
003<c<c<c<`0[Lc<c003IVIVVIVIc<c<00c<c<`00fIVI_ooo`00000:c<c<
00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0>Lc<c0030000c<c<c<c<
0:g<c<`00fIVIYVIVLc<c00<c<c<00=VIVKoool000002/c<c003R<2hB928
0000007<c<`00003R<2hb>3HR<2h03W<c<`00`000<c<c<c<c02]c<c<00=V
IVJIVIW<c<`03<c<c003IVIVoooo000000[<c<`00hS0^4R@R0000001c<c<
00000hS0^<SPf8S0^00ic<c<00<0003<c<c<c<`0100000?<c<`2000000C<
c<`00000003<c<`200000/c<c0800002c<c<100009C<c<`00fIVIYVIVLc<
c00<c<c<00=VIVKoool000002/c<c003R<2hB9280000007<c<`00003R<2h
b>3HR<2h03W<c<`010000<c<c000000000;<c<`2000000C<c<`00000003<
c<`3000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P00
09?<c<`00fIVIYVIVLc<c00<c<c<00=VIVKoool000002/c<c003R<2hB928
0000007<c<`00003R<2hb>3HR<2h03W<c<`010000<c<c000000000;<c<`2
000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P000003
c<c<0000000009O<c<`00fIVIYVIVLc<c00<c<c<00=VIVKoool000002/c<
c003R<2hB9280000007<c<`00003R<2hb>3HR<2h03W<c<`00`000<c<c<c<
c003c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<
c08000000lc<c000000000040000Tlc<c003IVIVVIVIc<c<00c<c<`00fIV
I_ooo`00000:c<c<00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0>Lc<
c0030000c<c<c<c<00?<c<`2000000?<c<`0000000000/c<c08000000lc<
c00000000002c<c<0P000003c<c<0000000000;<c<`20000Tlc<c003IVIV
VIVIc<c<00c<c<`00fIVI_ooo`00000:c<c<00>8`;Q8T8P000000Lc<c000
00>8`;S8h=R8`;P0>Lc<c0030000c<c<c<c<00?<c<`2000000?<c<`00000
00000/c<c08000001Lc<c000000000000<c<c002000000?<c<`000000000
0/c<c080002Cc<c<00=VIVJIVIW<c<`03<c<c003IVIVoooo000000[<c<`0
0hS0^4R@R0000001c<c<00000hS0^<SPf8S0^00ic<c<00<0003<c<c<c<`0
0lc<c08000000lc<c00000000002c<c<0P000004c<c<00000000c<c<0P00
00?<c<`40000U<c<c003IVIVVIVIc<c<00c<c<`00fIVI_ooo`00000:c<c<
00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0>Lc<c0030000c<c<c<c<
00?<c<`20000Z<c<c003IVIVVIVIc<c<00c<c<`00fIVI_ooo`00000:c<c<
00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0>Lc<c0030000c<c<c<c<
00?<c<`20000Z<c<c003IVIVVIVIc<c<00c<c<`00fIVI_ooo`00000:c<c<
00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0>Lc<c0030000c<c<c<c<
0:g<c<`00fIVIYVIVLc<c00<c<c<00=VIVKoool000002/c<c003R<2hB928
0000007<c<`00003R<2hb>3HR<2h03W<c<`00`000<c<c<c<c02]c<c<00=V
IVJIVIW<c<`03<c<c003IVIVoooo000000[<c<`00hS0^4R@R0000001c<c<
00000hS0^<SPf8S0^00ic<c<00<0003<c<c<c<`0[Lc<c003IVIVVIVIc<c<
00c<c<`00fIVI_ooo`00000:c<c<00>8`;Q8T8P000000Lc<c00000>8`;S8
h=R8`;P0>Lc<c0030000c<c<c<c<0:g<c<`00fIVIYVIVLc<c00<c<c<00=V
IVKoool000002/c<c003R<2hB9280000007<c<`00003R<2hb>3HR<2h03W<
c<`00`000<c<c<c<c02]c<c<00=VIVJIVIW<c<`03<c<c003IVIVoooo0000
00[<c<`00hS0^4R@R0000001c<c<00000hS0^<SPf8S0^00ic<c<00<0003<
c<c<c<`0[Lc<c003IVIVVIVIc<c<00c<c<`00fIVI_ooo`00000:c<c<00>8
`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0>Lc<c0030000c<c<c<c<0:g<
c<`00fIVIYVIVIVIV@0<VIVI00=VIVKoool000002/c<c003R<2hB9280000
007<c<`00003R<2hb>3HR<2h03W<c<`00`000<c<c<c<c00?c<c<0`0009_<
c<`00fIVI/c<c6IVIP0=IVIV00?oool0003<c<`02Lc<c003R<2hB9280000
007<c<`00003R<2hb>3HR<2h03W<c<`00`000<c<c<c<c00Ac<c<0P0009[<
c<`00fIVI_ooolc<c00<c<c<00=VIVKoool000002/c<c003R<2hB9280000
007<c<`00003R<2hb>3HR<2h03W<c<`010000<c<c000000000;<c<`00`00
0<c<c<c<c00200000/c<c0D00002c<c<0`0009W<c<`00fIVI_ooolc<c00<
c<c<00=VIVKoool000002/c<c003R<2hB9280000007<c<`00003R<2hb>3H
R<2h03W<c<`01@000<c<c00000000<c<c003000000C<c<`00000003<c<`2
00000/c<c0800002c<c<0`0009W<c<`00fIVI_ooolc<c00<c<c<00=VIVKo
ool000002/c<c003R<2hB9280000007<c<`00003R<2hb>3HR<2h03W<c<`0
1@000<c<c00000000<c<c003000000C<c<`00000003<c<`200000/c<c080
00001<c<c00000000<c<c080002Hc<c<00=VIVKoooo<c<`03<c<c003IVIV
oooo000000[<c<`00hS0^4R@R0000001c<c<00000hS0^<SPf8S0^00ic<c<
00T0003<c<`00000003<c<`0003<c<`0003<c<`00P0000;<c<`2000000C<
c<`00000003<c<`2000000?<c<`000000000V<c<c003IVIVooooc<c<00c<
c<`00fIVI_ooo`00000:c<c<00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8
`;P0>Lc<c0090000c<c<00000000c<c<0000c<c<0000c<c<00800003c<c<
10000004c<c<00000000c<c<0P0009S<c<`00fIVI_ooolc<c002c<c<2000
00;<c<`00fIVI_ooo`00000:c<c<00>8`;Q8T8P000000Lc<c00000>8`;S8
h=R8`;P0>Lc<c0030000c<c<000000<000000lc<c00000000002000000?<
c<`0003<c<`00/c<c0@00003c<c<0P0009O<c<`00fIVI_ooolc<c003c<c<
1P0000?<c<`00fIVI_ooo`00000:c<c<00>8`;Q8T8P000000Lc<c00000>8
`;S8h=R8`;P0>Lc<c0030000c<c<000000<000000lc<c000000000020000
0/c<c0@000000lc<c00000000003c<c<0P0009O<c<`00fIVI_ooolc<c004
c<c<100000C<c<`00fIVI_ooo`00000:c<c<00>8`;Q8T8P000000Lc<c000
00>8`;S8h=R8`;P0>Lc<c0030000c<c<000000800003c<c<0`000:G<c<`0
0fIVI_ooolc<c005c<c<0P0000G<c<`00fIVI_ooo`00000:c<c<00>8`;Q8
T8P000000Lc<c00000>8`;S8h=R8`;P0>Lc<c0030000c<c<000000800003
c<c<0`000:G<c<`00fIVI_ooolc<c00<c<c<00=VIVKoool000002/c<c003
R<2hB9280000007<c<`00003R<2hb>3HR<2h03W<c<`00`000<c<c<c<c02]
c<c<00=VIVKoooo<c<`03<c<c003IVIVoooo000000[<c<`00hS0^4R@R000
0001c<c<00000hS0^<SPf8S0^00ic<c<00<0003<c<c<c<`0[Lc<c003IVIV
ooooc<c<00c<c<`00fIVI_ooo`00000:c<c<00>8`;Q8T8P000000Lc<c000
00>8`;S8h=R8`;P0>Lc<c0030000c<c<c<c<0:g<c<`00fIVI_ooolc<c00<
c<c<00=VIVKoool000002/c<c003R<2hB9280000007<c<`00003R<2hb>3H
R<2h03W<c<`00`000<c<c<c<c02]c<c<00=VIVKoooooool03?ooo`03c<c<
oooo000000[<c<`00hS0^4R@R0000001c<c<00000hS0^<SPf8S0^00ic<c<
00<0003<c<c<c<`0[Lc<c11VIVH00lc<c0000<c<c009c<c<00>8`;Q8T8P0
00000Lc<c00000>8`;S8h=R8`;P0>Lc<c<80000:c<c<00>8`;Q8T8P00000
0Lc<c00000>8`;S8h=R8`;P0>/c<c<7oool:c<c<00>8`;Q8T8P000000Lc<
c00000>8`;S8h=R8`;P0>Lc<c003IVIVc<c<IVIV0;iVIVH00oooolc<c<c<
c008c<c<00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0>Lc<c003IVIV
ooooc<c<0;g<c<`00fIVI_ooolc<c009c<c<00>8`;Q8T8P000000Lc<c000
00>8`;S8h=R8`;P0>Lc<c003IVIVooooc<c<0;bIVL`00lc<c6IVI_ooo`0:
c<c<00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0>Lc<c004IVIVoooo
c<c<VIW<^/c<c004VIW<c<c<IVIVoooo2/c<c003R<2hB9280000007<c<`0
0003R<2hb>3HR<2h03W<c<`016IVI_ooolc<c9VIc;[<c<`019VIc<c<c6IV
I_ooo`[<c<`00hS0^4R@R0000001c<c<00000hS0^<SPf8S0^00ic<c<00AV
IVKoooo<c<bIVL`Xc<c<0`0008o<c<`019VIc<c<c6IVI_ooo`[<c<`00hS0
^4R@R0000001c<c<00000hS0^<SPf8S0^00ic<c<00AVIVKoooo<c<bIVL`Z
c<c<0P0008k<c<`019VIc<c<c6IVI_ooo`[<c<`00hS0^4R@R0000001c<c<
00000hS0^<SPf8S0^00ic<c<00AVIVKoooo<c<bIVL`2c<c<100000?<c<`5
000000?<c<`0000000000/c<c0800002c<c<0P000003c<c<0000000000;<
c<`5000000?<c<`0000000001<c<c0<0002=c<c<00BIVLc<c<aVIVKoool:
c<c<00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0>Lc<c005IVIVoooo
c<c<VIW<c<c<00800002c<c<0P000003c<c<0000000000;<c<`2000000?<
c<`0000000000/c<c08000001<c<c00000000<c<c0<000000lc<c0000000
0002c<c<0P000003c<c<0000000000C<c<`30000SLc<c004VIW<c<c<IVIV
oooo2/c<c003R<2hB9280000007<c<`00003R<2hb>3HR<2h03W<c<`01FIV
I_ooolc<c9VIc<c<c00200000/c<c08000000lc<c00000000002c<c<0P00
0003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c08000000lc<
c00000000002c<c<0P000003c<c<0000000000?<c<`2000000?<c<`00000
0000S<c<c004VIW<c<c<IVIVoooo2/c<c003R<2hB9280000007<c<`00003
R<2hb>3HR<2h03W<c<`016IVI_ooolc<c9VIc0G<c<`200000/c<c0800000
1<c<c00000000<c<c0800002c<c<0P000003c<c<0000000000;<c<`20000
0/c<c08000001<c<c00000000<c<c0800003c<c<0P000003c<c<00000000
08?<c<`200001lc<c004VIW<c<c<IVIVoooo2/c<c003R<2hB9280000007<
c<`00003R<2hb>3HR<2h00g<c<`06XN[QiO2UhN[Qi_8Vgn[OiO2UgfWOIFo
UGNOMhngSg:GLH^_RVnDKhFWQFf?KHFWQFN7IgfWOFN7IhFWQFN7IgfWOFN7
IgfWOFN7IgfWOA;<c<`016IVI_ooolc<c9VIc0G<c<`200000lc<c0@00000
0lc<c00000000002c<c<0P000003c<c<0000000000;<c<`200000lc<c0@0
00000lc<c00000000003c<c<0P000003c<c<0000000008;<c<`400001/c<
c004VIW<c<c<IVIVoooo2/c<c003R<2hB9280000007<c<`00003R<2hb>3H
R<2h00c<c<`077n[P9_8VhN[Qi_8Vgn[Oi_8Vgn[OiO2UgfWOIFoUGNOMhng
Sg:GLHngSfnEL8FWQFf?KHFWQFN7IgfWOFN7IgfWOFN7IhFWQFN7IhFWQFN7
IgfWOA7<c<`016IVI_ooolc<c9VIc0G<c<`2000000?<c<`0003<c<`00/c<
c08000001Lc<c000000000000<c<c002000000?<c<`0000000000/c<c080
00000lc<c0000<c<c002c<c<0P000003c<c<0000000000;<c<`200000lc<
c0800020c<c<1P0000G<c<`019VIc<c<c6IVI_ooo`[<c<`00hS0^4R@R000
0001c<c<00000hS0^<SPf8S0^00<c<c<01bKai]oZgnKb9]oZgnKb9^7ZhNK
b9]oZgnG`YMmYgfE_iEgWgN?]hmbUg6;[hY_UG27ZhM]SfemYgeWQfN5YhEW
QfMmYgeWQfMmYgeWQfMmYge]SfdAc<c<00AVIVKoooo<c<bIVL`5c<c<0P00
00;<c<`400000/c<c08000000lc<c00000000002c<c<0P0000;<c<`20000
0/c<c0@00002c<c<1P0000?<c<`20000Olc<c0P00004c<c<00BIVLc<c<aV
IVKoool:c<c<00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P03<c<c00=
Qj^7Ul:GQj^7VlRKQj^7Ul:GOj]oVlRKOj]oUl:GOJMmUKnEMimg00?<c<`0
36nDKhN[Qff?KHFWQFN7IgfWOFN7IgfWOFN7IhFWQFN7IgfWOA7<c<`016IV
I_ooolc<c9VIc0G<c<`20000Y/c<c0X00003c<c<00BIVLc<c<aVIVKoool:
c<c<00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P03<c<c00<VlRKOj]o
VlRKOj]oVlRKQj^7VlRKOj]oVlRKOj]oVlNKOJMm100c000<c<c<KiA_Qj^7
KHm]QJN5IhMWQJN5IhMWOj^0IhMWOJMmIhMW4Lc<c004IVIVooooc<c<VIW<
1Lc<c080002cc<c<00BIVLc<c<aVIVKoool:c<c<00>8`;Q8T8P000000Lc<
c00000>8`;S8h=R8`;P03<c<c00LQj^7VlRKOj]oVlRKOj^0Ul:GQj^7VlRK
Qj^7VlRKP:]o03<0c<c<UKnEOJMmSkN?03<0c<c<KiA_Qj^7KHm]Oj^0IhMW
Oj^0IhMWQJN5IhMWQJN54Lc<c004IVIVooooc<c<VIW<^/c<c004VIW<c<c<
IVIVoooo2/c<c003R<2hB9280000007<c<`00003R<2hb>3HR<2h00c<c<`0
79_8Vgn[Oi_8VhN[QiO2UhN[Qi_8Vgn[Oi_8Vgn[Oi_8V`0c0<c<c7fWOIFo
UGRPM`0c0<c<c8^_RVnEL8N[Qff?KHFWQFN7IgfWOFN7IgfWOFN7Ia7<c<`0
16IVI_ooolc<c9VIc;[<c<`019VIc<c<c6IVI_ooo`[<c<`00hS0^4R@R000
0001c<c<00000hS0^<SPf8S0^00<c<c<00b7PXN3R8<KR1/KR1^0R1/KR1/K
R80KR1^3R8>0R1^3R8<08`04000000L0<`07U`L7U`L2Q`0?U@05Q0D5R`D0
0PF71@9UQfD00`F71Lc<c<c<c00?c<c<00AVIVKoooo<c<bIVLbjc<c<00BI
VLc<c<aVIVKoool:c<c<00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0
3<c<c00LQj^7VlRKOj]oVlRKQj^7Ul:GQj^7Ul:GQj^7VlRKOj]oVlRKQj^7
VlRKQj^7Ul:GOJMmUKnEMimgSkN?LYMaSkN?KiA_QJN5KHm]QJN5IhMWQJN5
4Lc<c004IVIVooooc<c<VIW<^/c<c004VIW<c<c<IVIVoooo2/c<c003R<2h
B9280000007<c<`00003R<2hb>3HR<2h00c<c<`03I_7Vgn[Oi_8VhN[Qi_8
Vgn[P9_8Vgn[Oi_8Vh2[Oi_8VhN[Qi_8V`03c<c<00bKai]mYgfE_iEgWgN?
]hmgWgN;[hYbUg67ZhM]Sff5YhEWQfLAc<c<00=VIVKoooo<c<`0_9VIc003
c<c<IVIVoooo00[<c<`00hS0^4R@R0000001c<c<00000hS0^<SPf8S0^00<
c<c<00aoZgnKai^7ZhNG`YQoZgnKb9]oZgnKb9]oZgnKb9]oZgnKb9/403<0
00c<c<bKai]mYgfE_iEmYgf?]hmbUg6;[hYbUg67ZhM]Sff5YhDAc<c<00=V
IVKoooooool0_Oooo`03c<c<ooooc<c<00W<c<`00hS0^4R@R0000001c<c<
00000hS0^<SPf8S0^00<c<c<01bE_iEoZgnG`YN7ZhNKb9^7ZhNG`YN7ZhNG
`YN7ZhNG`YL0<`3<c<b7ZhNG`YN7ZhL0<`3<c<bKai]mYgfE_iEgWgN?]hmg
WgN;[hY_UG27ZhM]SfdAc<c<`FIVIP_<c<`00hS0^4R@R0000001c<c<0000
0hS0^<SPf8S0^00<c<c<01amYgfE_iEmYgfKai]oZgnKb9^7ZhNKb9]oZh2G
`YN7ZhL0<`3<c<bG`YR7ZhNG`YR7ZhL0<`3<c<bG`YMmYgfE_iEmYgf?]hmg
WgN;[hYbUg67ZhOMc<c<00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0
3<c<c00LUKnEOJMmUKnEOj]oVlNKOj]oVlRKQj^7Ul:HQj^7VlRKP:]o03<0
c<c<VlRKQj^7Ul:GQj^703<0c<c<VlNKOJMmUKnEN:1gSkN?MimgRjn:KiE`
gLc<c003R<2hB9280000007<c<`00003R<2hb>3HR<2h00c<c<`077NOMi2g
T7fWOIFoUGfWOI_7Vgn[Oi_7VhN[QiO2Ugn[Oi_8Vgn[O`0c0<c<c9_8VhN[
Qi_8Vgn[P00c0<c<c9_7VgfWOIFoUGfWOHngSgNOMh^_R]g<c<`00hS0^4R@
R0000001c<c<00000hS0^<SPf8S0^00<c<c<01b?]hmgWgN?]i1mYgfE_iEm
YgfKai]oZgnKai^7ZhNKb9]oZgnKb9^7ZhL0<`3<c<bKb9^7ZhNKb9^7ZhL0
<`3<c<bKai]mYgfE_iEgWgN?]hmgWgOMc<c<00>8`;Q8T8P000000Lc<c000
00>8`;S8h=R8`;P03<c<c00LKiE`SkN?MimgSkN@OJMmUKnEOj]oVlNKOj^0
VlRKQj^7VlRKOj^0Ul:GOj^003<0c<c<VlRKOj]oVlRK03<0c<c<P:]oVlNK
Oj]oUKnEOJMmSkN?=lc<c0<0002Sc<c<00>8`;Q8T8P000000Lc<c00000>8
`;S8h=R8`;P03<c<c009Rjn:LYMaSkN?MimgSkN@OJMmUKnEOJMmVlNK00;<
c<`04HN[QiO2UhN[Qi_8Vgn[O`0c0<c<c9_8VhN[Qi_8V`0c0<c<c7n[OiO2
UgfWOIFoUGfWO@0ic<c<0P000:;<c<`00hS0^4R@R0000001c<c<00000hS0
^<SPf8S0^00<c<c<00Q_U6n;[hY_UG2?]hmgWgN?]hmmYgfE_iD303<0017<
c<b7ZhNKb9]oZgnKb9^7ZhL0<`3<c<bKb9^0Zgl0<`3<c<bKb9]oZgnKai]o
ZgnE_iD04/c<c0D00003c<c<100000;<c<`200000/c<c0@00003c<c<1000
00?<c<`200001Lc<c0<00003c<c<100000?<c<`2000000C<c<`00000003<
c<`200001/c<c08000000lc<c00000000002c<c<00@0003<c<`000000004
c<c<0P000003c<c<0000000000;<c<`200001<c<c0800002c<c<0P0000;<
c<`200000/c<c0@00002c<c<0P0000;<c<`200000/c<c08000000lc<c000
00000002c<c<0P000003c<c<0000000004O<c<`00hS0^4R@R0000001c<c<
00000hS0^<SPf8S0^00<c<c<01b5YhE_U6n;[hYbUg6?]hmgWgN@]i00<`3<
c<amYgfKai/0<`3<c<b7ZhNKb9]oZgnKb9/0<`3<c<aoZgnKb9/0<`3<c<b7
ZhNKb9]oZh2G`YMoZglAc<c<0P0000?<c<`2000000?<c<`0000000000/c<
c08000001<c<c00000000<c<c0800002c<c<0P000003c<c<0000000000;<
c<`2000000?<c<`0000000001/c<c0<00002c<c<0P0000;<c<`2000000C<
c<`00000003<c<`3000000?<c<`0000000001/c<c0<000001/c<c0000000
0<c<c0000<c<c0800003c<c<0P0000;<c<`200000/c<c0800004c<c<0P00
00;<c<`200000/c<c08000000lc<c00000000002c<c<0P000003c<c<0000
000000;<c<`2000000?<c<`0000000000/c<c0800002c<c<0P000003c<c<
0000000004O<c<`00hS0^4R@R0000001c<c<00000hS0^<SPf8S0^00<c<c<
01aWRFN5YhE]Sff;[hY_UG2?]hmgWgL0<`3<c<bE_iEmYgd0<`3<c<bKb9^7
ZhNKb9^7ZhL0<`3<c<bG`YN7ZhL0<`3<c<bKb9]oZgnKb9]oZgnKai/Fc<c<
0P000003c<c<0000000000G<c<`2000000?<c<`0000000001Lc<c0800005
c<c<0P0000G<c<`2000000C<c<`00000003<c<`200000/c<c08000000lc<
c00000000002c<c<0P000003c<c<0000000000K<c<`200000/c<c0800000
0lc<c0000<c<c00200000lc<c0800002c<c<0P0000;<c<`200001<c<c080
0002c<c<0P0000;<c<`2000000?<c<`0000000000/c<c08000000lc<c000
00000002c<c<0P000003c<c<0000000000;<c<`200000/c<c080001:c<c<
00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P03<c<c00=QJN5IhMWQJN5
KHm]Rjn:LYMaSkN?03<0c<c<OJMmUKnEOJMm03<000?<c<`0300c0<c<c9_8
VhN[Qi_8V`0c0<c<c8N[Qi_8VhN[Qi_8Vgn[OaC<c<`4000000?<c<`00000
000010000004c<c<00000000c<c<1P000003c<c<0000000000G<c<`20000
1Lc<c08000001<c<c00000000<c<c0800002c<c<0P000003c<c<00000000
00;<c<`2000000?<c<`0000000001/c<c0800002c<c<0P000003c<c<0000
c<c<00800003c<c<0P0000;<c<`200000/c<c0800004c<c<0P0000;<c<`2
00000/c<c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<
c<`2000000?<c<`0000000000/c<c0800002c<c<0P0004[<c<`00hS0^4R@
R0000001c<c<00000hS0^<SPf8S0^00<c<c<00eWQfN5YhEWQfN5YhE]Sff;
[hY_UG2?]hl0<`3<c<amYgfE_iEmYgd00`0c000<P:]oVlRKOj]oVlRK03<0
c<c<Qj^7Ul:HP:]oVlRKP:]oVlRK4/c<c0D00002c<c<0P0000;<c<`20000
00C<c<`00000003<c<`200000/c<c08000000lc<c00000000005c<c<0P00
00G<c<`2000000C<c<`00000003<c<`200000/c<c08000000lc<c0000000
0002c<c<0P000003c<c<0000000000K<c<`200000/c<c08000000lc<c000
0<c<c00200000lc<c0800002c<c<0P0000;<c<`200001<c<c0800002c<c<
0P0000;<c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002
c<c<0P000003c<c<0000000000;<c<`200000/c<c080001:c<c<00>8`;Q8
T8P000000Lc<c00000>8`;S8h=R8`;P03<c<c00LOJMmIhMWQJN5IhQXQJN5
KHm]Rjn:LYMa03<0c<c<UKnEOJMmUKnEOj]oUl:GQj^7Ul:GQj^7VlRKQj^7
03<0c<c<VlRKOj]oVlRKOj]oVlRKQj^74Lc<c0@00004c<c<0P0000;<c<`2
000000C<c<`00000003<c<`200000/c<c08000000lc<c00000000002c<c<
0P000003c<c<0000000000C<c<`200000lc<c08000001<c<c0000<c<c<c<
c08000000lc<c00000000002c<c<0P000003c<c<0000000000K<c<`30000
00K<c<`00000003<c<`0003<c<`200000lc<c0800002c<c<0`000003c<c<
0000000000C<c<`3000000G<c<`000000000003<c<`00P0000;<c<`00`00
0<c<c<c<c002000000G<c<`000000000003<c<`00P000003c<c<00000000
00;<c<`3000000?<c<`000000000B/c<c003R<2hB9280000007<c<`00003
R<2hb>3HR<2h00c<c<`02VN7IhFWQFN7IgfWOFf?KHFWQFf?KH^_RW:GL@0c
00;<c<`01GfWOIFoUGfWOIO2UhN[Q`02c<c<00T0<`3<c<bKb9^0ZgnKb9^7
ZhNKb9^7ZhNKb9/04Lc<c0800007c<c<100000;<c<`200000/c<c0@00003
c<c<10000003c<c<0000000000800003c<c<0P0000?<c<`2000000?<c<`0
000000000P0000;<c<`200000/c<c08000000lc<c0000000000200001<c<
c08000000lc<c00000000002c<c<00<0003<c<`000001`000004c<c<0000
0000c<c<0P0000G<c<`2000000?<c<`0000000000/c<c0800003c<c<1000
00;<c<`2000000C<c<`00000003<c<`4000000C<c<`00000003<c<`20000
Blc<c003R<2hB9280000007<c<`00003R<2hb>3HR<2h00c<c<`02WfWOFN7
IgfWOFN7Ign[P6N7IhFWQFf?KH^_RVnEL080<`05c<c<0P0c0009Oj]oVlRK
Oj]oVlRKOj^0VlRKOj]oVlNKP:]o017<c<`200000lc<c0800008c<c<0P00
00o<c<`200008Lc<c080000<c<c<0P0000;<c<`200008Lc<c0800002c<c<
0P0004k<c<`00hS0^4R@R0000001c<c<00000hS0^<SPf8S0^00<c<c<00aW
QfN5YhEWQfN5YhEWQfN5YhEWQfN5YhE]Sff;[hY_U6n?]hl503<000^G`YN7
ZhNKb9^7ZhNKb9^7ZhNG`YMoZgnKb9^7ZhNKb9/04/c<c0D00009c<c<0P00
013<c<`00`000<c<c<c<c00Oc<c<0P0000G<c<`00`000<c<c<c<c005c<c<
00<0003<c<c<c<`00P0002;<c<`00`000<c<c<c<c0020000C/c<c003R<2h
B9280000007<c<`00003R<2hb>3HR<2h00c<c<`077fWOFN7IgfWOFN7IgfW
OFN7IgfWOFN7IhFWQFf?KH^_RVnDKhngSgNOMhngSgNOMiFoUGfWOIO2Ugn[
OiO2V7n[P9_8VhN[Qi_8Vh2[Oi_8Vgn[Omg<c<`00hS0^4R@R0000001c<c<
00000hS0^<SPf8S0^00<c<c<01aWQfN5YhEWQfMmYgeWQfN5YhEWQfMmYge]
Sff5YhE]Sff;[hYbUg6?]hmgWgN?]hmmYgfE_iEmYgfG`YN7ZhNKb9]oZgnK
b9^7ZhNKb9]oZgnKai_Mc<c<00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8
`;P03<c<c00LOJMmIhMWOJMmIhMWOJMmIhMWOJMmIhMWOJMmIhMWQJN5KHm]
Rjn:KiE`Rjn:MimgSkN?OJMmUKnEOJMmUl:GOj]oVlNKOj]oVlRKOj]oVlRK
Qj^7gLc<c003R<2hB9280000007<c<`00003R<2hb>3HR<2h00g<c<`06XFW
QFN7IhFWQFN7IhFWQFN7IhFWQFN7IhFWQFN9IhFWQFf?KH^_RW:GLHngSgNO
Mi2gT7fWOIFoUGfWOI_7VhN[Qi_7VhN[Qi_8VhN[Qmk<c<`00hS0^4R@R000
0001c<c<00000hS0^<SPf8S0^03oc<c<1/c<c003R<2hB9280000007<c<`0
0003R<2hb>3HR<2h0?o<c<`6c<c<00>8`;Q8T8P000000Lc<c00000>8`;S8
h=R8`;P0olc<c0K<c<`00hS0^4R@R0000001c<c<00000hS0^<SPf8S0^03o
c<c<1/c<c003R<2hB9280000007<c<`00003R<2hb>3HR<2h0?o<c<`6c<c<
00>8`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P0olc<c0K<c<`00hS0^4R@
R0000001c<c<00000hS0^<SPf8S0^03oc<c<1/c<c003R<2hB9280000007<
c<`00003R<2hb>3HR<2h0?o<c<`6c<c<00>8`;Q8T8P000000Lc<c00000>8
`;S8h=R8`;P0olc<c0K<c<`00hS0^4R@R0000001c<c<00000hS0^<SPf8S0
^03oc<c<1/c<c003R<2hB9280000007<c<`00003R<2hb>3HR<2h0?n8`;P7
R<2h0DR@R0400001c<c<00000hS0^<SPf8S0^002002001400H000X000X40
0h4018401H401H801X801h81288128<12H<12X<12h<12h@138@13H@00P4>
Q@060Pn50Q250Q660Q660Q:60Q>60P8DQ`060QF70QJ70aN80aN80aR80aV8
0P<JR@050a^90ab:0af:0af:11j:00847h/02P@PR`@QR`@RS0@RS0@SS0@T
S0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_
T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0Lj
U0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9
AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:
DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0835ZP35^P
35bP35bQ35fQ35jQ35nQ35nR0PaPXP073F:S3F>S3FBS3FFS3FFT3FJT3FNT
008=J:D01PiYY@iZY@i[YPi[YPi/YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mb
Z0mcZ08?M:T01@meZ@mfZPmgZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@
OJ`@OZ`@OjdAOjdAP:dAPJh24H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`
00XBRK0BR[4BRk4BRk4BS;4BSK8BS[8CS[8CSk<CT;<24i6c00DCT[@CTk@C
U;@CU;@CUKD00QBF]@0659Ne59Rf59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh
5Inh5Inh5J2i5J6i0QFR^@0F5J>j5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl
5ZZl5Z^l5Z^m5jbm5jfm5jjm5jjn5jnn5k2n5k6n5k6o5k:o5k>o51Rd`003
R<2hB9280000007<c<`00003R<2hb>3HR<2h008008004@01P002P002P@03
P@04P@05P@05PP06PP07PP48PP48P`49P`4:P`4;P`4;Q04<Q04=Q0020@j5
00H23hD248D24HH24HH24XH24hH20QB700H25HL25XL35hP35hP368P36HP2
0aZ900D36hT378X37HX37HX47XX00P@OR`0:122;126;12:<12:<12><12B<
12F=1BF=1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@
1S2A1S6A1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD
1c^E0088?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5
V0U6V@U7V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YA
W0YAW@]BW@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO00P<FZ0<Fj0<
G:0<G:4<GJ4<GZ4<Gj4<Gj82362R00L=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@0
0PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X
3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m
[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7/08BR;00
2Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D
]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPEW[PE
WkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`F
Z[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/klD6;C000>8
`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P00P00P00A006000:000:100>1
00B100F100F200J200N20@R20@R30@V30@Z30@^30@^40@b40@f400813XD0
1P8?Q@8@Q@8AQP8AQP8BQP8CQP8258L01P8EQ`8FQ`<GR0<GR0<HR0<IR083
6XT01@<KR@<LRP<MRP<MRP@NRP0211n;00X488/48H/48X`48X`48h`498`4
9Hd59Hd59Xd59hh21BR>00H5:Hh5:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06
<946<I46<I46<Y46<i86=987=987=I<7=Y<21cNC00D7>9@7>I@7>Y@7>Y@7
>iD00PPlU@0623fE23jF23nF23nF242G246G0PQ2U`062D>H2DBH2DFH2DFH
2DJI2DNI0PU8V@0E2DVJ2DZJ2T^J2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6L
2U6M2e:M2e>M2eBM2eBN2eFN2eJN2eNN2eNO2eRO008;FIl020aJX0aKX0aL
X0aLX@aMX@aNX@aOX@aOXP8<H:801`eRX`eSX`eTX`eUX`eUY0eVY0eWY002
3FRU00H>JJD>JZD>JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?
LjP23gBY00D?MJT?MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/
47j/47n]4Gn]4H2]4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:
4XV`4XZa4X^a4X^a4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd
4iBd4iFe008DU[D01QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO
^1FO^1FP^AFQ^@8EX[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ
_1J[_1J[_AN/_AN]_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc_`8H]<0@0000
0QRd`003R<2hB9280000007<c<`00003R<2hb>3HR<2h008008004@01P002
P002P@03P@04P@05P@05PP06PP07PP48PP48P`49P`4:P`4;P`4;Q04<Q04=
Q0020@j500H23hD248D24HH24HH24XH24hH20QB700H25HL25XL35hP35hP3
68P36HP20aZ900D36hT378X37HX37HX47XX00P@OR`0:122;126;12:<12:<
12><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^
T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD
1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4
V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?
W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO00P<
FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj82362R00L=HZ<=Hj<=I:<=IJ<=IJ@=
IZ@=Ij@00PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X
3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l
[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7
/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B
]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HE
WKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/F
Z;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/kl2
6;C000?8h=Q8T8Q8T8P034R@R00600006;C06;C0R<2hB92800000Lc<c000
00>8`;S8h=R8`;P00P00P00A006000:000:100>100B100F100F200J200N2
0@R20@R30@V30@Z30@^30@^40@b40@f400813XD01P8?Q@8@Q@8AQP8AQP8B
QP8CQP8258L01P8EQ`8FQ`<GR0<GR0<HR0<IR0836XT01@<KR@<LRP<MRP<M
RP@NRP0211n;00X488/48H/48X`48X`48h`498`49Hd59Hd59Xd59hh21BR>
00H5:Hh5:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46<I46<Y46<i86
=987=987=I<7=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@0623fE23jF
23nF23nF242G246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8V@0E2DVJ
2DZJ2T^J2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M2eBM2eBN
2eFN2eJN2eNN2eNO2eRO008;FIl020aJX0aKX0aLX0aLX@aMX@aNX@aOX@aO
XP8<H:801`eRX`eSX`eTX`eUX`eUY0eVY0eWY0023FRU00H>JJD>JZD>JjH>
JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?MJT?MZX?
MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]4H2]4H6^
0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a4X^a4Xba
4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008DU[D01QBG
]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ^@8EX[T0
5QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/_AN]_AN^
_AN^_QN__QN`_QNa_QNa_aNb_aNc_`8H]<000lSPf8S0^8S0^00;R<2h00M8
T8P0000H]<0H]<28`;Q8T8P000000Lc<c00000>8`;S8h=R8`;P00P00P003
006000:0oooo00;oool01005POooo`06PP07PP;oool01049Poooo`4;P`4;
Q0?oool00`4>Q@8?Q@8@Q@03oooo00D24hH258L258L25HOoool00P<GR003
oooo0aV80aZ900?oool20af:00Goool47h/47h/488_oool00P@RS00612><
12B<12F=1BF=1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:
1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD
1cZD1c^E0088?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5
V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@
W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO00P<FZ0<
Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj82362R00L=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=
Ij@00PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X
3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l
[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7/08B
R;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C
]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPE
W[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`F
ZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/kl26;C0
00?8h=R8`;R8`;P02hS0^007B92800006;C06;C0R<2hB9280000007<c<`0
0003R<2hb>3HR<2h008008001001P?ooo`02P@03P@;oool01@05PP06P_oo
o`48PP48P`02oooo00P12h?oool138@13H@13XGoool23hGoool20Q6600H2
4XKoool258L258Ooool25XL20aN800Woool36HSoool36XT36hT378[oool3
7H[oool00P@OR`0:122;oooo12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDX
SP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B
1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@Pn
UPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9
VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]D
WP]EWP]FWP]GWP]GW`]HW`022eVO00P<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<
Gj82362R00L=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@00PeXY@063VVU3VZU3V^V
3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ
3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61
[P8APZh01Q63[Q64[a65[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:<
/A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HD
UkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i
01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG
[[dG[[hG[khG/;hG/KhG/KlG/[lG/kl26;C000C8h=R8`;R8`;R8`;P20000
18S0^0800002R<2h00M8T8P0000H]<0H]<28`;Q8T8P000000Lc<c00000>8
`;S8h=R8`;P00P00P00Aoooo00:000:1oooo00B100F1oooo00J2oooo0@R2
0@R30@V3oooo0@^3oooo0@b40@f400813XD00`8?Q@8@Q@8AQP02oooo00D2
4hH258L258Ooool25XL00P<GR009oooo0aV8oooo0aZ90a^90ab:oooo0af:
oooo00847h/02P@PRoooo`@RS0@RS0@SS0@TS0@US@DUS@DVS@DWSP85:8h0
1PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHd
TPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8
?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9
BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;
EIh;EYh;Eih;Eil;F9l00P]IW`0835ZP35^P35bP35bQ35fQ35jQ35nQ35nR
0PaPXP073F:S3F>S3FBS3FFS3FFT3FJT3FNT008=J:D01PiYY@iZY@i[YPi[
YPi/YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmg
ZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh2
4H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4B
SK8BS[8CS[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne
59Rf59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F
5J>j5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm
5jjn5jnn5k2n5k6n5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h00:8`;P20000
0XS0^0800003R<2h00M8T8P0000H]<0H]<28`;Q8T8P000000Lc<c00000>8
`;S8h=R8`;P00P00P00>oooo00:000:100>100B100F1oooo00J2oooo0@R2
0@R30@V3oooo0@^31Oooo`060Pn50Q25oooo0Q660Q:60Q>60P8DQ`0=oooo
0QJ70aN80aN8oooo0aV8oooo0aZ90a^90ab:oooo0af:oooo00847h/02P@P
Roooo`@RS0@RS0@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[S`D[
S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`LfT`87
=i<01@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8@IL2
24:G00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:C9/:
CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;Eil;
F9l00P]IW`0835ZP35^P35bP35bQ35fQ35jQ35nQ35nR0PaPXP073F:S3F>S
3FBS3FFS3FFT3FJT3FNT008=J:D01PiYY@iZY@i[YPi[YPi/YPi]YP8>KZL0
1Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmgZPmgZQ1hZP0247V[
00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh24H:^00HAPjhAQ:lA
QJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4BSK8BS[8CS[8CSk<C
T;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne59Rf59Vf59Vf59Zg
59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F5J>j5JBj5ZFj5ZFj
5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm5jjn5jnn5k2n5k6n
5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h00>8`;P4000018S0^007B9280000
6;C06;C0R<2hB9280000007<c<`00003R<2hb>3HR<2h008008005Oooo`02
P002P@03P@04P@05POooo`06P_ooo`48PP48P`49Poooo`4;Poooo`4<Q04=
Q04>QOooo`8?QOooo`020Q6600H24XKoool258L258Ooool25XL20aN800So
ool36HSoool36XT36hT378[oool37HX2oooo00<47h/488_oool00P@RS006
12><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^
T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD
1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4
V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?
W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO00P<
FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj82362R00L=HZ<=Hj<=I:<=IJ<=IJ@=
IZ@=Ij@00PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X
3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l
[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7
/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B
]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HE
WKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/F
Z;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/kl2
6;C000?8h=R8`;R8`;P018S0^0800005R<2h00M8T8P0000H]<0H]<28`;Q8
T8P000000Lc<c00000>8`;S8h=R8`;P00P00P00?oooo00:000:100>100B1
00F1oooo00J2oooo0@R20@R30@V3oooo0@^30@^400?oool00`4>Q@8?Q@8@
Q@03oooo00<24hH258Ooool00_ooo`835hP00oooo`<IR0<JR@03oooo0P<M
RP05oooo11n;oooooooo126;00848X`01P@SS0@TS0@US@DUS@DVS@DWSP85
:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@Hc
TPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8
?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9
BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;
E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0835ZP35^P35bP35bQ35fQ35jQ35nQ
35nR0PaPXP073F:S3F>S3FBS3FFS3FFT3FJT3FNT008=J:D01PiYY@iZY@i[
YPi[YPi/YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mf
ZPmgZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dA
PJh24H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4B
S;4BSK8BS[8CS[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@06
59Ne59Rf59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR
^@0F5J>j5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm
5jjm5jjn5jnn5k2n5k6n5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h00>8`;P4
000018S0^007B92800006;C06;C0R<2hB9280000007<c<`00003R<2hb>3H
R<2h008008004Oooo`02P002P@03P@04P@05POooo`06PP07PP48PP48P`49
P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD248D24HH24HH24XH24hH20QB7
00Koool25XL35hP35hP368P36HP20aZ900D36hT378X37HX37HX47XX00P@O
R`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>1BZ?
1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB1cFC
1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPoUPQ0
U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;VPY;
VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]FWP]G
WP]GW`]HW`022eVO00P<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj82362R00L=
HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@00PeXY@063VVU3VZU3V^V3V^V3VbV3VfV
0Pi^Y`063VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ
008@NJ/02Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63
[Q64[a65[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>
/Q>?/a>@/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHD
VKHDV[LDVkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XF
YKXFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG
/;hG/KhG/KlG/[lG/kl26;C000?8h=R8`;R8`;P00XS0^0800002R<2h0P00
00>8`;P01dR@R00001Rd`1Rd`8S0^4R@R0000001c<c<00000hS0^<SPf8S0
^002002001400H3oool00X400h40187oool01H801X801h81288128<12H<1
2X<12h<12h@138@13H@00P4>Q@060Pn50Q250Q660Q660Q:60Q>60P8DQ`06
oooo0QJ70aN80aN80aR80aV80P<JR@050a^90ab:0af:0af:11j:00847h/0
2P@PR`@QR`@RS0@RS0@SS0@TS0@US@DUS@DVS@DWSP85:8h01PDYSPDZS`D[
S`D[S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@HbT@HcTPHdTPLdTPLeT`Lf
T`87=i<01@LhU0LiU0LjU0LjU0LkU@0223bE00H8?ID8?YH8?iH8?iH8@9L8
@IL224:G00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI01D9BIX9BYX:BiX:BiX:
C9/:CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;E9d;E9h;EIh;EYh;Eih;
Eil;F9l00P]IW`0835ZP35^P35bP35bQ35fQ35jQ35nQ35nR0PaPXP073F:S
3F>S3FBS3FFS3FFT3FJT3FNT008=J:D01PiYY@iZY@i[YPi[YPi/YPi]YP8>
KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@meZ@mfZPmgZPmgZQ1hZP02
47V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdAP:dAPJh24H:^00HAPjhA
Q:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4BRk4BS;4BSK8BS[8CS[8C
Sk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF]@0659Ne59Rf59Vf59Vf
59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i0QFR^@0F5J>j5JBj5ZFj
5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm5jjn5jnn5k2n
5k6n5k6o5k:o5k>o0QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0
^007B92800006;C06;C0R<2hB9280000007<c<`00003R<2hb>3HR<2h0080
08000`01P002P?ooo`02oooo00`01H401H801X801h81288128<12H<12X<1
2h<12h@138@13H@20@j500H23hD248D24HH24HH24XH24hH20QB700H25HL2
5XL35hP35hSoool36HP20aZ900D36hT378X37HX37HX47XX00P@OR`0:122;
126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?
1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLg
T`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88
@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=
V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]H
W`022eVO00P<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj82362R00L=HZ<=Hj<=
I:<=IJ<=IJ@=IZ@=Ij@00PeXY@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`06
3VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/0
2Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65
[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@
/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LD
VkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXF
Y[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG
/KlG/[lG/kl26;C000?8h=R8`;R8`;P02hS0^007B92800006;C06;C0R<2h
B9280000007<c<`00003R<2hb>3HR<2h008008004@01P002P002P@03P@04
P@05P@05PP06PP07PP48PP48P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H2
3hD248D24HH24HH24XH24hH20QB700H25HL25XL35hP35hP368P36HP20aZ9
00D36hT378X37HX37HX47XX00P@OR`0:122;126;12:<12:<12><12B<12F=
1BF=1BJ=1BN>0PDXSP061BV>1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A
1S6A1S6A1S:A1S>B1SBB1cBB1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E
0088?9D01PPmU@PnUPPoUPPoUPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6
V@U7V@89B9T05@U9VPU:VPY;VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YA
W@]BW@]CW@]DW@]DWP]EWP]FWP]GWP]GW`]HW`022eVO00P<FZ0<Fj0<G:0<
G:4<GJ4<GZ4<Gj4<Gj82362R00L=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@00PeX
Y@063VVU3VZU3V^V3V^V3VbV3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X3g>X
0PmdZ@053gFY3gJZ3gNZ3gNZ47RZ008@NJ/02Q1jZa1kZa1l[11l[11m[11n
[11o[A5o[A60[A61[P8APZh01Q63[Q64[a65[a65[a66[a:7/08BR;002Q:9
/1::/A:;/A:;/A:</A:=/Q:>/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D]1>D
]1>E]@0259Je00HDUkDDV;HDVKHDVKHDV[LDVkL259bg00HEWKPEW[PEWkPE
WkPEX;TEXKT25J:i01HEXkXEY;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`F
Zk`FZkdG[;dG[KdG[[dG[[hG[khG/;hG/KhG/KlG/[lG/kl26;C000?8h=R8
`;R8`;P02hS0^007B92800006;C06;C0R<2hB9280000007<c<`00003R<2h
b>3HR<2h008008004@01P002P002P@03P@04P@05P@05PP06PP07PP48PP48
P`49P`4:P`4;P`4;Q04<Q04=Q0020@j500H23hD248D24HH24HH24XH24hH2
0QB700H25HL25XL35hP35hP368P36HP20aZ900D36hT378X37HX37HX47XX0
0P@OR`0:122;126;12:<12:<12><12B<12F=1BF=1BJ=1BN>0PDXSP061BV>
1BZ?1B^?1B^?1Bb?1Rf@0PH^T00:1Rn@1S2A1S6A1S6A1S:A1S>B1SBB1cBB
1cFC1cJC0PLgT`051cRD1cVD1cZD1cZD1c^E0088?9D01PPmU@PnUPPoUPPo
UPQ0U`Q1U`88@YL01PU3V0U4V0U5V0U5V0U6V@U7V@89B9T05@U9VPU:VPY;
VPY;VPY<V`Y=V`Y>V`Y>W0Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@]DWP]EWP]F
WP]GWP]GW`]HW`022eVO00P<FZ0<Fj0<G:0<G:4<GJ4<GZ4<Gj4<Gj82362R
00L=HZ<=Hj<=I:<=IJ<=IJ@=IZ@=Ij@00PeXY@063VVU3VZU3V^V3V^V3VbV
3VfV0Pi^Y`063VnW3W2W3g6X3g6X3g:X3g>X0PmdZ@053gFY3gJZ3gNZ3gNZ
47RZ008@NJ/02Q1jZa1kZa1l[11l[11m[11n[11o[A5o[A60[A61[P8APZh0
1Q63[Q64[a65[a65[a66[a:7/08BR;002Q:9/1::/A:;/A:;/A:</A:=/Q:>
/Q>>/Q>?/a>@/`8CTK<01A>B]1>C]1>D]1>D]1>E]@0259Je00HDUkDDV;HD
VKHDVKHDV[LDVkL259bg00HEWKPEW[PEWkPEWkPEX;TEXKT25J:i01HEXkXE
Y;XFYKXFYKXFY[/FYk/FZ;/FZ;`FZK`FZ[`FZk`FZkdG[;dG[KdG[[dG[[hG
[khG/;hG/KhG/KlG/[lG/kl26;C03lSPf00600006;C06;C0R<2hB9280000
0Lc<c00000>8`;S8h=R8`;P00P00P00A006000:000:100>100B100F100F2
00J200N20@R20@R30@V30@Z30@^30@^40@b40@f400813XD01P8?Q@8@Q@8A
QP8AQP8BQP8CQP8258L01P8EQ`8FQ`<GR0<GR0<HR0<IR0836XT01@<KR@<L
RP<MRP<MRP@NRP0211n;00X488/48H/48X`48X`48h`498`49Hd59Hd59Xd5
9hh21BR>00H5:Hh5:Xl5:hl5:hl5;8l6;I021Rj@00X6;i06<946<I46<I46
<Y46<i86=987=987=I<7=Y<21cNC00D7>9@7>I@7>Y@7>Y@7>iD00PPlU@06
23fE23jF23nF23nF242G246G0PQ2U`062D>H2DBH2DFH2DFH2DJI2DNI0PU8
V@0E2DVJ2DZJ2T^J2T^J2TbK2TfK2TjK2TjL2TnL2U2L2U6L2U6M2e:M2e>M
2eBM2eBN2eFN2eJN2eNN2eNO2eRO008;FIl020aJX0aKX0aLX0aLX@aMX@aN
X@aOX@aOXP8<H:801`eRX`eSX`eTX`eUX`eUY0eVY0eWY0023FRU00H>JJD>
JZD>JjH>JjH>K:H>KJH23VjW00H>KjL>L:L?LJP?LJP?LZP?LjP23gBY00D?
MJT?MZX?MjX?MjX@N:X00Q1iZ`0:47Z[47^[47b/47b/47f/47j/47n]4Gn]
4H2]4H6^0Q62[P064H>^4HB_4HF_4HF_4HJ_4XN`0Q:8/00:4XV`4XZa4X^a
4X^a4Xba4Xfb4Xjb4hjb4hnc4i2c0Q>A/`054i:d4i>d4iBd4iBd4iFe008D
U[D01QBG]ABH]QBI]QBI]QBJ]aBK]`8DW;L01QFM^1FN^1FO^1FO^1FP^AFQ
^@8EX[T05QFS^QFT^QJU^QJU^QJV^aJW^aJX^aJX_1JY_1JZ_1J[_1J[_AN/
_AN]_AN^_AN^_QN__QN`_QNa_QNa_aNb_aNc_a@H]<000hS0^4R@R0000001
c<c<00000hS0^<SPf8S0^002002001400H000X000X400h4018401H401H80
1X801h81288128<12H<12X<12h<12h@138@13H@00P4>Q@060Pn50Q250Q66
0Q660Q:60Q>60P8DQ`060QF70QJ70aN80aN80aR80aV80P<JR@050a^90ab:
0af:0af:11j:00847h/02P@PR`@QR`@RS0@RS0@SS0@TS0@US@DUS@DVS@DW
SP85:8h01PDYSPDZS`D[S`D[S`D/S`H]T086;Y002PH_T0H`T@HaT@HaT@Hb
T@HcTPHdTPLdTPLeT`LfT`87=i<01@LhU0LiU0LjU0LjU0LkU@0223bE00H8
?ID8?YH8?iH8?iH8@9L8@IL224:G00H9@iP9A9P9AIP9AIP9AYT9AiT22DRI
01D9BIX9BYX:BiX:BiX:C9/:CI/:CY/:CY`:Ci`:D9`:DI`:DId;DYd;Did;
E9d;E9h;EIh;EYh;Eih;Eil;F9l00P]IW`0835ZP35^P35bP35bQ35fQ35jQ
35nQ35nR0PaPXP073F:S3F>S3FBS3FFS3FFT3FJT3FNT008=J:D01PiYY@iZ
Y@i[YPi[YPi/YPi]YP8>KZL01Pi_Y`i`Y`maZ0maZ0mbZ0mcZ08?M:T01@me
Z@mfZPmgZPmgZQ1hZP0247V[00X@NZ/@Nj/@O:`@O:`@OJ`@OZ`@OjdAOjdA
P:dAPJh24H:^00HAPjhAQ:lAQJlAQJlAQZlBQk024XR`00XBRK0BR[4BRk4B
Rk4BS;4BSK8BS[8CS[8CSk<CT;<24i6c00DCT[@CTk@CU;@CU;@CUKD00QBF
]@0659Ne59Rf59Vf59Vf59Zg59^g0QBL]`065Ifh5Ijh5Inh5Inh5J2i5J6i
0QFR^@0F5J>j5JBj5ZFj5ZFj5ZJk5ZNk5ZRk5ZRl5ZVl5ZZl5Z^l5Z^m5jbm
5jfm5jjm5jjn5jnn5k2n5k6n5k6o5k:o5k>o51Rd`003R<2hB9280000007<
c<`00003R<2hb>3HR<2h0?n8`;P7R<2h0DR@R0400001c<c<00000hS0^<SP
f<SPf03ob>3H1lSPf058T8P100000Lc<c000ohS0^0^8`;P100000Lc<c000
\
\>"], "Graphics",
  ImageSize->{268, 220},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000460000Sb000`400?l00000o`00003oooo`l?07
oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07
oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07
oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooooool7
ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7
onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00BOo^k^h2ong]k@0:on_[jooX
j>SoiNGUon;Rh_oMgMgof=SHomCDe?oAdM7oc/k>olc<c0;obl_;=Oo:b/X2ol_;b`0:olc<c?o>c/ko
dM7AomCDe?oHf=SogMgMon;Rh_oUiNGoj>SXon_[j`;okNg]4?o^k^h2ong]k@0:onWYjOoTiNGogMkP
omOIgOo@dmKoa/[@ol75b_nk`LKo][g3okBj`@;o/[Vo=Ona]kh2ok:i_`0:okBj`Onf_L?o^l76ol75
b_o6b]3od=?FomOIgOoMg^3oi>GUonWYj@;okNg]2oo^k^h004Soi^KV0_oUiND02_oRh^;oh>3Pom_K
fooFe]Koc/k>olO7aono_koo^;RhokBd]?n`/;02ojj^[P;o[Jf]<on/[:`2ojf][@;o[Zj^00[o/;2`
okBd]?nh^;So_knoolO7aoo>c/koe]KFom_KfooPh>3oh^;R0_oUiND>onKViP;oiNGU00cogmoPom[K
gOoCeMOobLg@ok_0aOn`][goXjZcoiRRZonBW:OoS9JRoh^EX?n9U:02ohRCWc?oQi6N0_n8Til03?n9
U:3oRiFPohbFX_nBW:OoV::[oj>Z/on`][go^l35olW=d?oCeMOof]_MomoOh0;oiNGU2_oVi^H004So
k^k^00kokNg]on[Zj_oWinOoh^;RomWIfOo>c/ko`l?3okRh^?n^[ZkoYZJVoj2PX?nLW9coVIVIoiRH
V3OoUiNG00goV9RHoiVIVOnLW9coX:2PojJVY_n^[Zko^;Rhol?3`oo>c/kofMWIon;Rh_oWinOoj^[Z
00;okNg]3Oo^k^h03_o]kNgoinOXon3QhooGfMgobLgBokJm`onU[KKoU9jZohNCWomkR9OoM8>Bofmn
S?m[NX[oJWV9=omXN8P03OmZNHWoJgZ:ofmnS?mdPi;oNhRGohNCWonDWZ[oYJffokJm`oo9cM;oemWM
on3QhooWinP00_o]kNd9onk^kP00B?ooool03_olo?conOWioo;bl_oXj>Sof][Jol_;bonj^[[o[:b/
oinOWonEUIGoSXj>ohZ:R_n7QhOoQXJ6=on5QHD03on6QXKoQhN7ohZ:R_n>SXkoUIFEoinOWon/[:co
^[Zjol_;booJf][oj>SXoo;bl_oinOWoo?clooknoP0=ooooo`0>oo[jn_ocm?Koi^S/omCIgonoa/co
Y[2johjJZ?mmS9WoKGb>of=cQ?mKJgooEVQkoe=VN_mBIGPgoe9UM`0?oe9UN?mCIW[oEVQkoe][OomS
LhCoKGb>ogf<VOn>VZSoY[2joko6c?oDfMooi^S/oo?dm_ojn_[oo_kn00Wooooo0018onk^kP0DonSX
j?oRh^;ofMWIol[:b_nj^[[oZ:RXoiRHV?nBTY;oYJFUol30`?oGemOojn_[ooKfm_ogmoOonOWiooSh
n?oinOWon_[jooWinOogmoL3ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT04oojn_[onOWiooShn?oinOWon?ShooOgmoo]
kNgof=SHol71`OnUYJGoTY:BoiRHV?nXZ:So^[Zjol[:b_oIfMWoh^;RonSXj?o/k>`03Oo^k^h04?oT
iNGof]_MolW=d_na]kkoUj6/ogn<V?mZNHWoF6n8oeAjY?mMS/7oIYoJofnZj?mg/o7oN[Cbogjim_mn
^?<coh6jm@0Aogjhlomn]oGoOKOcogZelombZnWoJZ3Joen?`omFO:GoF729ofYiROmoS9SoUj6/ok6g
__o9cM;of]_MonCUiOo[jn/02Oo^k^h004Soi^KV00cogMgMomKFe_o7alOo]kNgoj>SXonATI7oXZ:R
ol_;boo^k^kom_Kfooclo?ono_hkooooo`0=ookno_olo?comoOgono_koo<c<coXj>Soi6ATOnSXj?o
]kNgolO7aooFe]KogMgMon;RhP0=onKViP0@omGFf?o9cM3o/;NmoiJPZOmkR9CoI7B5odeeX?mES<Wo
HjCZog2`lOmk^?SoP;kkohC0o?n8a?koRlKoohc7oc?oS/Wo017oS<Ooohg8oon9aOkoQlCnoh:onoml
^_SoMK7cofVYjomITLkoDWVSofAdQOmkR9CoUZ2Yok2g_Oo9cM3oeMKHomoOh009onKViP00B?o^k^h0
2_oRh^;oe]KFol?3`on^[ZkoVYZJojf][OoNg]kojn_[ooCdm?okno/oooooo`0;oo_knooclo?ok>c/
on7QhOn`/;3oVYZJojj^[_o3`l?oe]KFon;Rh_oXj>P03Oo^k^h04?oGfMgo`/O=ojF]]_n5TIooI7N=
odMfZ?m=SmKoGZ3Wof^/lOmg^?OoPl7nohS7oon=bOooSl[ooi;=oonCc_lcoiG?o`;oTlko00ooT/go
oho<oon9aoooQ<3log^hmom`[o3oIJ?YoeFEfom>NZkoIGV=ohFAWonU[KKo`/O=omOIgOoRhnD02Oo^
k^h004Sooooo00[okNg]omcLg?o5aLGo[:b/ojf][OoDe=Coh>3Ponc/k?oemOGooOgm?oooool02oon
o_kom_Kfonc/k?oRh^;ofMWIok6a/On/[:coaLG5omcLg?o]kNgom_Kf00gooooo00gogn?Uol;9conN
ZKCoNhZJod5_Y?m0P<[oD9;Iof:Siom`/?;oOK[johG2o_n<b?ooTLco00;oUM3o00?oUm3ooiW@oonI
d?l0<OnId?l04OnHd?ooUm3ooiG@oonBcOooS/SoohS4o_n0___oM[?bofNUjOmIUm_oBX[AodQeZ?mk
RY[oWZVdol;9cooOhnGok^oa00Wooooo0018onk^kP0;omSHf?o6a/Ko[Zj^oj>SXoo6a/Koe=CDon3P
h?o/k>col_;booclo?ono_h03Oooool00ooShn?oe]KFooknoP04ooooo`03onc/k?omoOgooooo00;o
m?Cd2oooool00oo]kNgokno_ooooo`04ooooo`03ooCdm?oXj>Sooooo013ooooo00_on_[jooCdm?oZ
j^[ohn?SomOGeoo=cLgoYZJVojj^[_o6a/Kof=SHon;RhP0=onk^kP0@olK:d?nY/;WoQi>OodAZUol]
K[_o@X?>oe>Bf_mTXnWoKZg_ogbjn?n3`?_oR/Gnoi3<oonCc?ooTlgooiC=oa?oVLoo00CoV<knohBb
g?n3/M_oV<kn7?nIcol04OnGc_ooU<kooi?=oonAboooS/SoohO1non0^_OoMK;`ofRUiomJVMgoBh[?
ocUj`_m;L9goQi>OojV`^Oo6b]3of]_M00Wok^k^0018onKViP0?olg=cOni^KWoXJ6Qoj^[Zoo6a/Ko
d];BomcLg?oVi^Kok>c/ooGemOohn?Son_[joogmoOooooooo?cl00Oooooo01GoWYjNoa8B4_l92@Wo
9bLWoa/K6om<C4cofMWIoooooomADE7o1`L7oaXJ6_nLW9co4a<CoeMGEooooooo@410ogmoOoomoOgo
oooooj>SXolL71`00_ooool04?oUiNGo@410o`000?lB4Q;o7AdMooShn?ooooooinOWodY:B_l30`?o
8R8RoaLG5oo1`L7ooooood10@?moOgl2ooooo`03oogmoOoooooooooo00;ooooo013ooOgmooooooom
oOgono_kooShn?odm?CokNg]onKVi_oOgmooe]KFolc<c?na/K7oXZ:RokVi^Oo=cLgofm_K3OoVi^H0
4?nj_lCoVJ>/ofUkT_lUGJ;o;Fjkod62b_mASmKoHIkQofbWjOmg/o7oP;WdohFnn?n;`__oSLCkohg3
n_n?ao/Boi?7o007oeioX_l:3Q7o4QPOoa@K8_l82PgoE76@oi;6n`02oi?7o008oalZ=Om>JXOoTlOl
oi?7o?n<_O3o6b@^ob0[=on=_o<@oi?7o00Aoi77non>aO_oS/Kkohg3n_n8_oSoP[[dog^dl?ma[>[o
IJ;RoeVFf?m;R<ko>7W2oc9XZOmZOIGoVJ>/okZoa?oAdmL02OoVi^H004Sok^k^01?odM7Aok^k^onQ
XJ7o][Jfol?3`oo?clooe]KFomoOgooVi^Koj^[Zono_kooclo?om?CdooGemOogmoOom_KfooOgmoof
m_Kon?Sh00;omoOg00CoTY:Bo`820_n6QXKom?Cd0_ofm_H02?n/[:codM7Aokno_ol30`?oe]KFomkN
g_mGEeOo410@0_ogmoL01_lm?CgoNWYjooOgmoogmoOoWIfMoa/K6`;omoOg013o?cloobXZ:_o4a<Co
moOgom3@d?ofm_KomoOgod51@Olm?CgoemOGooOgmoo[jn_ojNWYooShn?lm?CgoNg]k0_ofm_H2ooOg
m`0CooKfm_ohn?Som_KfooOgmoofm_Kom?Cdoo;bl_o`l?3ojn_[onKVi_oQhN7of][Jom?Cdoo9bLWo
_knoojJVY_nk^k_odM7Aon7Qh@0=onk^kP0@ok_1a_nIXjgoA6BBoaMHZ_l[JkKo?Wg4odb:c_mIUmWo
IJ;QofnZi_mi[ncoOKC_oh6glOn5^_;oQkcdohJjm17oRKkd00?oF7ZLo`D72OmRR:l00_n9__@00omZ
U;ko2`lDodQTP@02ohVnm007oadX<om9IX?oRKkdohNklOlW=dKo4a/Sogj_h00AohVnm00AohRnm?n7
_?GoQK[boh>ilOn1]^ooNk;]ogB[iom[Y>7oHI[KoeF@dom6Q<[o=7JoobAV/_m7K9SoVJ>]ok_1a_oE
fM/02Oo^k^h004Sooooo00_ogmoOolG5aOnTY:Co/k>col30`?o9bLWodm?ComWIfOoMgMgoh^;RonGU
i@02on[ZjP03onc/k?o]kNgokNg]00Cok^k^00CoinOWoa8B4_mLG5col?3`1Oo^k^h01_o:b/[o0P82
ok6a/Oo^k^koU9BDoadM7@;ok^k^00_o>c/kogIfM_o`l?3ok^k^oiRHV?lJ6Q[ok^k^olg=cOl0003o
Rh^;oo3`l003onk^kP05olk>c_l0003oZj^[onk^k_o`l?000oo^k^h01Olk>c_oMWIfonk^k_o^k^ko
l?3`00?ok^k^0_o]kNd2onc/k00=onWYjOoVi^Kohn?Son3Ph?oKfm_oeMGEolg=cOo5aLGo^k^koj^[
Zoo5aLGogmoOoo3`l00=ooooo`0@olK=donOZ[Co:e:Aoa=BY?lTI[?o=WNoodJ4bOmDS/ooGIKGofNO
g?m_Y^7oM:_UogV_i_ml/NSoO[7XognbjQ3oPKGZ00?oO[7Uo`dC6?lZ>dd01?n1]NX02_m9IhGo1PP;
ogNXfOn1]N[o6bHaodEQOOn1]N[o=DYPo`/?5?m_W<TBoh6ejP0Aognbj_mo/NWoO;7Xogb`j?mhZnKo
LJOQofbQg_mTWMWoFICCodj9cOm0O/Co;fnkoamO[_l_Fi[oWjZdolK=dooSinX02Oooool004Sok^k^
00god=3@okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoOgooQhN7oh^;R00;ohn?S
1OoUiND01?nn_[ko0000ojj^[_oVi^H6onGUi@05oibLW?l];Bgo;Bd]oc0`<?lL71`00_oUiND02oli
>CWoLW9bonKVi_oUiNGoTY:BoaTI6OoUiNGoZZZZo`000?ni^KWoi^KV00?oiNGU00?oZZZZo`000?lf
=SH00olh>3P01On`/;3oiNGUocTi>OmbLW;oiNGU00;oi^KV0ooUiND2onCTi0;ohn?S00goh^;Ron3P
h?oLg=cofMWIomKFe_o@d=3obLW9ol71`One]KGoYJFUokRh^?o@d=3oh>3P00gok^k^013o^Ko6oiFP
ZOlG?h_o4DZNoaiO[_l^Kk_o?G_3odZ7b_mDS/ooGIGCofBLf?mZXM[oKZ;Kog2UgOmcYMgoM:SO4?mh
ZN000omTSK_o0000odQUQP04ogRYh009ofZEa_l0003oF7^TogRYh?lI8boo@5Yhod5LN_l41PSoGXF`
01?oN:WP017oLjONog>Vg_mbYMgoKj?MofbQfomXW][oHIWEoe^Cd_mCS<goAX;7ocQh__lYJ[Ko5eNW
oa]<U_nEX:Wo^Ko6omCHf`09onk^kP00B?oVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Ko
c<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`2omkNgP;ogMgM00CoVi^Ko`000?o3`l?ogMgM0_oN
g]h3omgMg@06omkNg_oMgMgogMgMomcLg?n0P83o71`L0_oMgMd02olg=cOoD51@omgMgOoNg]koR8R8
oaTI6OoMgMgo_Kfmo`000?mmOGgogMgM00;og]kN00cogMgMokfm_Ol0003oU9BDok>c/on/[:co0P82
olO7aooMgMgo=cLgofi^K_oNg]h2omgMg@;og]kN0_oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oB
d];od=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT=onKViP0=okBk`?nDWZWo32f2o`m1
U_lEEJSo96Jcoc=b^om0OL?oBXK7oe>=c?mJTLooH9KBof>Id`02ofNLe@03ofVMe_m/X=OoK:3G00ko
K:3G00?oC72Go`000?mKR;H01?m/X=L02?mZWM?o0000od1PPOm/X=Oo5R4]oa`Z>?l10@;oBg2F5?m/
X=L04Om[WmKoJIgFofNLeOmVVmGoHISBoefEd?mHSlgoD8[:odN4a_llN/3o;fjkob1Q/_lBCZ;o3cb?
oiBNZOnd^l3ocM7C00Woi^KV0018onk^kP0=omCDe?no_kooS8b<oijNW_n][Jgo^KViol;2`_o7alOo
c<c<om3@d?oBd];oeMGEomKFeP02omOGe`03omSHf?oIfMWofMWI00;ofMWI00?oZJVYo`000?nb/[80
1ooIfMT01OnIVIWo^KViomKFe_mBDU;oAdM700;ofMWI00Ko=SHfoa4A4OmTI6Co_;blodY:B_m1@D42
omWIf@05ocDe=OlQ8B7oXJ6QomSHf?nl_;`00_oIfMT01Ole=CGoFe]Kom;Bd_n6QXKo92@T00;ofMWI
00?o=SHfofa/K?oIfMT01OoIfMT2omSHf0;oemOG00goeMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo_kno
okFe]OnYZJWoV9RHokno_ooDe=Coh^;R00gok^k^013o`LG:oijX/Ol997_o33J=oa59W_lIFZco:6Vf
ocAb_?loOL;oB8?7odn9bOmDS/coFI3=oe^BcOmMU<koGiG?4?mSUm800om=MJ?o0000oe9m[P04of>G
dP08oe5k[?l0003o@VF<of>Gd_lD7bco;DEQo`dD7?lkFWdDof>GdP;oGiG?00ooG9?=oe^BcOmGSlgo
Dh_:odb6aom5PLKo?7[0obm_^olRHk;o4eFWoa14V_l=<XOoWZRaol75b_oHf]h02Oo^k^h004Sooooo
00goj>SXomCDe?n<S8coTi>Coj:RX_n_[joo^[Zjol71`Oo7alOobl_;olk>c_o@d=3odM7A00;odm?C
0ooDe=@2omGEe@04olK6a_l10@7oPh>3omGEe0;oe=CD0_oEeMD05_oFe]KoeMGEog=cLolY:BWo3@d=
obl_;onSXj?oeMGEomKFe_m6ATKoMGEeofEUI?l@413o9RHVoj>SXooEeMGoe]KFol71`Om9BDWo30`<
o`T92OlO7al2omGEe@0<ol71`Olk>c_o2PX:oaLG5onHV9Soe=CDomGEeOle=CGoJVYZomGEeOoFe]Ko
eMGD0_oDe=@2omGEe@0@omCDe?oCdm?odm?Com7AdOo@d=3ocLg=ol[:b_o3`l?o_[jnokJf]_n[Zj_o
WIfMoiFEUOoDe=Coj>SXoo?cl`gooooo013oe=WOokFlaOl@9GCo2BV1o`djT_lABj3o6E^]obIW]?lc
L[_o?W_1odB1a?m<Q/OoDH[9oeF=bOmESL_oEXk:4?mKTLd00omDQkoo0@42ocULPP04oe^Ac@09oc5>
K_l0003oC7V/oe^AcOlC7R_o<4e^od]hZ_l62PkoA6fJ01?oFi7=017oEi3<oeN?c?mESLWoDhc9odj9
b?m:QLKo@h36ocQg_ol]K[So8F:boaEFZ?l@Aigo33F<oa@`Oone_<Goe=WOon[/kP09ooooo`00B?o^
k^h04_oMgMgocLg=oi2@T?n9RHWoUiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooIfMWof][J
om_KfooJf][ofm_KomcLg0?ofm_K00GoEEEEoalO7oo;bl_ofm_KomcLg006om_Kf`03omWIfOoLg=co
fm_K00Gofm_K00?of][JomcLg?oKfm/01OoKfm/00ooHf=Sog=cLom_Kf`03om_Kf`07omSHf?oKfm_o
fm_KomcLg?oKfm_o=SHfofe]K@04om_Kf`0ComcLg?oKfm_ofm_Kom_KfooJf][ofMWIomSHf?oFe]Ko
dm?Colg=cOo2`/;o][Jfojb/[?nOWiooT92@oiJFU_o=cLgogMgMonGUi@0=onk^kP0>om3Ce_ne^l;o
8SEfo`LNMol:;HKo3C^DoaA?XolWI[?o@gg0oeN=bOmOU<goIIS?of^LdOm^W]82og2Oda7oMJCD00?o
;d9Eoa@L9?m_VlT00_meY=@00ombX<oo6B<]ob8`?`02ogFTe006oaPR;?lnF77oMJCDoe5bTol:3Q;o
IXni4_meY=@04Om`Wm?oLIoDofnOdom^W];oJI_Aof>Fc_mJT<WoB872oba[]_lEEJSo44FMo``fSol8
9Gko93YmokFk`_o@dmKogMkP00Wok^k^0018onKViP0;om[Jf_o>c/koW9bLogYjN_n8R8SoUYJFojZZ
Z_o4a<CoeMGEom_KfooNg]h00_oPh>03on;RhP03onCTi?oShn?ohn?S00;ohn?S00SodM7AocTi>OlJ
6Q[oKFe]ohJ6Q_mWIfOo:RXZojVYZ@?ohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?S
h`05on?Sh`03onCTi?oShn?ohn?S00Gohn?S00Goi>CTon?ShooShn?o>3Phog5aL@03on?Sh`04onCT
i?oShn?ohn?Son?Sh`;oh^;R00kohN7Qon3Ph?oOgmoog=cLomOGeoo5aLGo[:b/oijNW_n@T93oPX:2
oj2PX?o>c/kof][Jon3Ph0goi^KV013ocm7Eok_0aOm8Eh?o0a5Wo`DKM_l9:XKo6DJKodMg^Om]Vlgo
NZGDoh>/eon8[]SoRk;Iohfcg?n>]McoSkGL4OnC^=d02?n8Zlgo9RlioaLM8om<Gg;oCf=goadU;OlL
92_oPZ?30_nC^=d01olO9RkoCV9foi>hgOnC^=goCF5eoaTP9on<[m804OnC^=d04OnA]]coT[KLohnf
g?n=/mcoRk;IohF]f?mmZ=GoKIc=od5h^_lEB9ko2c><o`LRO_l45W7oBEZ8ok_0aOo?dMGof]_M00Wo
i^KV0018onk^kP0>onGUiOoMgMgo`/;2og]kNomhN7SoQXJ6oinOWoo5aLGof=SHomgMgOoOgmoohN7Q
on;Rh_oShn<3onCTi0CoiNGU00Soi>CTon?ShonOWiooLW9boeiNG_mkNg_oVi^KomOGe`;oi>CT00?o
iNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00KoiNGUonCTi?oUiNGoiNGUocTi>OmbLW82onCTi004onGUiOoTi>CoiNGUonGU
i@?oi>CT00kohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4ol?3`ooMgMgoiNGU
on[ZjPgok^k^013ogMkPom3Ce_nGWZoo4B1Ro`4?IOl56GGo73V?oeil^On9Y=3oT:kGoi2af?nC]]_o
U;SLoiNjgOnK_=goV[_M4_nK_Mh01_nI^mcoJH2FodUIJOm6EFCoI7Z?oiNhf0?oVkgN00?oJX:IognJ
]OnK_Mh00_nK_Mh00omTNXooP9bgoi^mgP0@oi^mgP0Aoi^lg_nK_=goV[_MoiNjgOnC]]_oT;?Hoi>b
f?n8Ym?oFWnkoaHjTOl67g_o0a9]oa4SJOnGWk3od=?FomgNh?oWinP02Oo^k^h004Sooooo00_onOWi
oo?clooYjNWoZ:RXofEUIOmcLg?oSHf=ok^k^ooDe=Cof][JomgMg@02omoOg`03on3Ph?oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@03on7Qh@03omgMgOoOgmooh^;R
00SohN7Q00koh>3PomoOgooMgMgog=cLomGEeOni^KWoSXj>og]kNom^KVkoZj^[onWYjOoclo?onOWi
oogmo@gooooo013omOKfon[/k_oHg>7oE5n7o`0:DOl03Eoo529koea][On>Wl_oUj[AoiV_eOnK]=So
VKCHoiZefOnJ^=WoV[WK<onJ^]/04OnJ^=_oV[OIoi^ifonJ]MSoV[CHoiVae_nH[]CoRj3<oe5XZol=
8W_o0Q1Xo`0<F_mDHH_of=cQon[/k_oem_Koo?cl00Wooooo0018onk^kP0<on_[jooXj>Soh^;RomOG
eon=SHgoHV9RogIfM_nTY:CoalO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oL
g=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oL
g=`01OoLg=`00ooKfm_og=cLomcLg005omcLg00Dom_KfooLg=cog=cLom_KfooLg=cofm_Kom[Jf_oI
fMWof=SHom?Cdoo5aLGoW9bLogEeMOmWIfOoT92@omOGeooRh^;oj>SXon_[joo]kNd=onk^kP0@onWY
jOoRhnGoemWMolC9c_lc?Vco00U=o`XGH_m3CiGoOhNkoi>Mb?nEXlcoVJ[@oib^d_nK[];oVjkDoiZ_
e3?oV[7E017oVZoDoi^ae?nK[];oVJ_AoiZ[dOnIYm3oTIk:ogN4^Ol_?8_o0@mRo`0:EOlc?g7oa<W>
omOIgOoRhnGojNWYong]k@09onk^kP00B?oVi^H03_oUiNGoh^;RomoOgooJf][obLW9ohN7QomJFU[o
Ng]koj>SXonl_;coa/K6ol_;boo=cLgoclo?0_oAdM45om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@03om;BdP;odM7A00god=3@olo?coo<c<cob<S8
ok^k^onLW9coLW9boe]KFon:RX[obLW9om[Jf_oOgmooh^;R00;oiNGU3OoVi^H03ooUiNGogmoPomSI
foo?dMGo[;2joc8kJ?l22DOo6bEXodmHTomdOK3oQHfkoh^B`?n>U/CoSi[5oi:Ma`0eoi6Ma`0>oi2M
a_nBW<OoT9[5ohbD`On6SKgoKgR]oci9Rol;5eoo00M8oc8mJon//;[ocm7EomSIfooOgn02onGUi@Wo
i^KV0018onk^kP;okNg]00koj^[ZonSXj?oRh^;og=cLoibLW?m]KFgoJ6QXoh>3PonGUiOoXj>Sojb/
[?n_[joo/K6aok:b/P;o];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne
]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf
][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd01?o]KFeokJf]?nd
];Co];BdokJf]_nc/k?o/[:bok>c/on_[jooZZZZoibLW?n2PX;oHV9Rofi^K_nOWioog=cLon;Rh_oX
j>Soj^[Z00;okNg]3_o^k^h2ong]k@0>onOWj?oRhnGof]_MolkBeOmFFggo5aa@oa<JEOl]=77oATj6
oe=LTomOJ9coHfbQofA]XomSKJ<cofQbY`;oIg2T00coJ76Tof=/XOmLII_oB56:obL`K_l83dko4QY@
oeAKOoo>d]Gof]_Mon;SiOoWinP2ong]k@[ok^k^0019ooooo`;oo_kn00ooo?clooWinOofm_Kol_;b
omWIfOnXZ:SoPh>3ofi^K_mUIFGoJFUYog9bL_mdM7CoNGUiogalO?mkNg/00_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@07ogalO?mkNg_oO7alogemO?mlO7coNg]kogemO@02ogYj
NP0;ogMgMomdM7CoKfm_ogAdM?n5QHGoZ:RXom[Jf_obl_;om_KfooWinOolo?`00_ono_h@ooooo`;o
o_kn00gon_[jooGfm_o^ko7oi^S/okJiaomOI8Go;S9OoaPMDOlA5dko5QeGoadTGOlO9V3o8b]V03?o
9BiZ00go92aWobD/I_lT;6?o7bIPoaPNEolJ85Ko;S9PoemTQ?nf^/Ooi^S/onk_lOoem_Kon_[j00;o
o_kn2oooool004[ok^k^0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;RhP03on3Ph?oOgmoog]kN03Wo
gMgM00?og]kNomoOgooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/k>`2ong]kA;ok^k^0_o]kNd02_o[
jn_oinOXon;SiOoMg^3of]_MomOIgOoDf=_od]KIom3Deoo?d]Dgom3CeP0:oloBeOo@e=Ood]KIomCH
fooGfMgof]_MomgNh?oRhnGoinOXon_[j`;okNg]3?o^k^h004coi^KV0_oUiND00ooTi>Coh^;Ron;R
hP02on3Ph0;ogmoO>OoNg]h2omoOg`;oh>3P0_oRh^800ooTi>CoiNGUonGUi@0FonKViP;oiNGU00Go
hn?SomoOh?oOgn3og=gMom[Kg@02omSIfcWoemSJ0_oHfM/01OoJfmgog=gMomoOh?oOgn3ohn?S00;o
iNGU3_oVi^H00?ook^k^1oo^k^h00?oooooo1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H00?oo
k^k^1oo^k^h00?oooooo1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H00?ook^k^1oo^k^h00?oo
oooo1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H00?ook^k^1oo^k^h00?oooooo1oooool00?oo
k^k^1oo^k^h00?ooi^KV1ooVi^H004kok^k^00SokNg]on_[jooShn?oe]KFolO7aonm_Kgo][JfokFe
]Iko];Bd00So]KFeokJf]_nm_KgoalO7omKFe_oShn?ojn_[ong]k@[ok^k^001>ooooo`08oogmoOod
m?Cog]kNokbl_?nLW9coQXJ6og]kNomgMgNNogIfMP08ogMgMomkNg_oQXJ6oibLW?nl_;cog]kNooCd
m?omoOd:ooooo`00C_o^k^h01_oXj>Soe]KFojn_[onIVIWo^;RhonKViY7ooooo00?oU]COokceoonl
mOl00_nlmOl00onkm?oo_?Gookceo`06okceo`09ok_doonhlOoo[n[ooi[@iomjX;koNh^Lojn_[ooF
e]Koj>SX00[ok^k^001>onKViP05omcLg?o1`L7oWYjNolo?coomoOd0T_ooool01_nKf]oo^oCook[a
oonlmOoo_oWookceo`Oo_OKo0_nonOl02?nkm?oo]?3ooj[WoonEf?ooKjCLogZ;Woo1`L7og=cL2_oV
i^H004kok^k^00GohN7Qokfm_Onc/k?olo?cooknoP0^ooooo`03on7QhOmnOWkon?Sh067ooooo00?o
T/kOokW`oonjlOl00_njlOl01_nhkooo^_7ookW`oonjlOoo^O3ookS_o`;o]^ko0_nhkol02?ndk?oo
[^WoojSVoonEe_ooNKgooef7]_nm_KgohN7Q2_o^k^h004kooooo00GolO7aolC4a?o>c/kolo?coogm
o@06ooooo`03odi>C_nXZ:Son_[j02Gooooo00?ono_koadM7OnUYJD0HOooool00onAc=oo]>[ookCZ
o`0:okG[o`0:ok?Yoonejooo/NWooj_UoonSh?ooT=3oogNjoom?SmCoa<C4oo7al@[ooooo001>onk^
kP06on3Ph?ne]KGof][Joo7alOoinOWooOgm0_ono_h3ooooo`03oj^[ZolL71coYjNW00;oo_kn00Co
ooooonc/k?omoOgooooo0_oclo<2ooknoPCooooo1?ono_h01?olo?cokno_ooooooooool4ooknoP05
onc/k?omoOgoooooooCdm?oclo<00oono_h4ooooo`04ohZ:R_lm?Cgoo_knooknoPCooooo1?ono_h4
ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4
ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool3ooknoP08oh[3gonaiOoo
/NGook7Uoon_i?oo/NGoojoToonaiOl4ojoTo`0;ok7Uoon^hooo[^GoojkSoonWhOooW=Soohg=oomd
^?ooA8gLokFe]OoPh>002_o^k^h002Goi^KV00?oi>CTon3Ph?oRh^809_oVi^H01OoHf=So[Zj^omWI
fOo^k^komOGe00;ono_k00?ooOgmoo_knookno/00_okno/03OmYJFWoEUIFooknnoono__oCdm?o`L7
1olI6AWoVIVIoa8B4_mFEUKoo_kkoclo?_mmOGd00_okno/05OnPX:3o6a/KoogmoOono__o_[jloaXJ
6_l61PKoD51@oh>3Pol_;boooOgmooknnom@D4oo1`L7oaTI6OnIVIWo4Q8BoeIFE_omoOgo?clnogin
O@04oo_kn`04oi2@T?l0003oe]KCooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k
0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k
0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k
0_omoOd2ooknn`Cono_k0_omoOd00oono__oPK[Ooj_Po`02oj[Oo`04ojcQoonZgooo[>7ooj[Oo`Co
[>7o00_oZ]ooojSOoonXg_ooY]_ooikEoonHe?ooR<Oooff_n?m2R]_o[Zj^omSHf00:onKViP009?o^
k^h01OoZj^[ofm_Kokfm_OoGemOokNg]02Gok^k^00Ooh>3PokBd]?oHf=Sojn_[ooGemOofm_Kon?Sh
00?onOWi0_ohn?P08?n6QXKo820PooShnOo0`<7o0`<3omOGeooOgmooF5QHoa0@4?oinOWon?Siochn
?_mlO7conOWiooShn?nNWYko6a/KooWinOohn?WoDE5BoeIFE_oalO7oVIVIo`h>3_l^;RkonOWiol30
`Ol30`?oemOGon3Ph?mHF5So410@0_oinOT01?ln?SkoNg]looWinOoinOT2ooShn004obd];Ol820So
KFe^ooShn@;onOWi0_ohn?P2ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oi
nOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oi
nOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oi
nOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oi
nOT01_ohn?WoO[GOojOKoonTf?ooY][oojGJo`?oY=Wo00?oT/;Toa`V;OnB`^@01?nTfOl02?nPe_oo
Vm?ooi39oon3`OooJJ[aocj6e_nd];Coh>3P2_o^k^h0023ooooo0oono_h01_ogmoOogMgMoj:RX_nD
U9Co`l?3ooknoRGooooo00Sol?3`ol71`OoEeMGojNWYoo?cloodm?Com_KfooGem@Com_Kf00WoQ8B4
oadM7OoemOGod=3@o`820_nf][Kom_KfoiVIVOlN7Qh00_oemOD01_lm?CgoNWYjooKfm_ofm_KoWIfM
oaXJ6P;omOGe00go:RXZohZ:R_ofm_Kom_KfogEeMOl^;RkomOGeom3@d?l20P;o][JfooKfm_nIVIWo
7QhN00;omOGe00?o?CdmogYjN_ofm_H00_ofm_H01Oo4a<Co0000oiRHV?lB4Q;ok^k^00Com_Kf1?oe
mOD4ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD4ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oe
mOD4ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD4ooKfmPComOGe1?ofm_H3ooGem@03ogjegonP
e_ooX=Ko00GoX=Ko00?o@EQYo`000?m1F6T01OnPe_l01onKdoooT<Wooh?1oomYZ_7o?XKFol71`Oo`
l?002_ooool001_ok^k^00kokNg]on_[jooXj>SoiNGUon7QhOoOgmoog]kNom[Jf_nj^[[oR8R8ol30
`?o8b<So[jn_ong]kBGok^k^00Ooh>3PokBd]?oDe=Coi^KVoo3`l?oclo?olO7a00Gom?Cd00goQ8B4
oadM7Ooclo?olo?cojFUYOl_;boo<30`oc<c<olN7Qkom?Cdoo?cloll?3coNGUi00;om?Cd00KoVi^K
oaXJ6_odm?Colo?cobTY:On<S8`2ooCdm009ohR8R?l];Bgom?Cdoo?clonTY:Co;bl_oc0`<?lc<c?o
7QhN00;om?Cd00?o?3`logUiNOodm?@00_odm?@01OmTI6Co?ShnooCdm?lV9RKoW9bL00Kom?Cd0_oc
lo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oc
lo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@01?oclo?oMjoOoikC
oonMd_l4oikCo`05ognZc_lK9Bgo0000oa/U;OmoZ/h00onNdol02?nJcoooTlcoohS0oOmk^?WoHZG^
ocMocond];Coh>3P2_o^k^h001Woi^KV017oiNGUon7QhOoHf=Sob/[:okVi^OnWYjOoVYZJoi>CTonA
TI7oS8b<ohV9ROoShn?ol?3`ol[:b_nTY:Coh>3PonGUi@0TonKViP07omSHf?n^[Zkoe=CDonKVi_o`
l?3olo?coo7al@05ooCdm004ohB4Q?lM7Agolo?coo?cl`;om?Cd00Ool_;bohf=SOlO7aoom?Cdoo?c
loll?3coF5QH00;om?Cd00KoUYJFoa/K6oodm?Colo?cobTY:On<S8`2ooCdm003ohR8R?l];Bgom?Cd
00;olo?c00Com?Cdoo;bl_n=SHgo7alO0_odm?@02_ll?3coI6ATooCdm?odm?Cojn_[o`h>3_nKVi_o
m?CdohV9ROlk>c/6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?c
l`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?c
l`Kom?Cd00?olo?coffUgonGc?l00_nFb_l3oiG9o`0@ob@a?ol0003o0000o`000?lT<CooULWooiK:
oonBaokoS/?johc3o_n2^oWoL[7doeRKi?l`NLWo[Zj^omSHf0[oi^KV000Honk^kP0<on[Zj_oNg]ko
`l?3oinOWon7QhOoT92@ojZZZ_o4a<Coclo?om7AdOoFe]Kom?Cd0_o]kNd01OoKfm_oRHV9olC4a?oL
g=coj^[Z02?ok^k^00Ooh>3PokBd]?oCdm?oi>CTonk^k_o_knool?3`00GolO7a00WoPX:2oadM7Ooa
lO7olO7aojZZZ_o>c/kok^k^oe]KFom?Cdl00_oalO401_ll?3co4Q8Bofm_KooAdM7oDU9BodQ8B0;o
lO7a00Ko:BTYohZ:R_oalO7olO7aohN7Qol];Bd2oo7al@05ojZZZ_o>c/kok^k^oe]KFom?Cdl00_oa
lO402oll?3co4A4AohV9ROoGemOoVYZJo`d=3OoWinOolO7aon3Ph?l820Sobl_;05kolO7a00OoI9cF
ohk2nOn>`o[oSL7hohk2nOn>`o[oH8BY00Go000000_oH8FZohk3n_n;_oKoR;geoh6im?mi/NkoJZOZ
oe2CfolYKl?o];Bdon3Ph00:onk^kP005_ooool03_ono_kom_KfomWIfOnUYJGoT92@olC4a?o^k^ko
nOWiooKfm_obl_;okno_oo3`l?o^k^kok>c/0_o`l?001ooalO7ob/[:oi6ATOnUYJGofMWIooKfm_on
o_h08Oooool01_o`l?3o`L71om3@d?oQhN7ojNWYonc/k0;ok^k^0_o`l?02ono_k`09oh61POlM7Ago
kno_ono_kon1PH7o;bl_o`h>3_le=CGo]kNg00;okno_00KoCTi>oh>3PomaLG7o4Q8Bob/[:ong]kL2
ono_k`06ochn?_nDU9Col?3`ono_konATI7o@D510_o_knl01On1PH7o;bl_o`l?3ole=CGo]kNg00;o
kno_00KoCTi>oh20P?mGEeOo20P8oeADE?mYJFT3ono_k`03ofEUIOmmOGgol?3`00Kokno_0_o`l?06
ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`l?06
ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`l?06ono_k`;ol?3`1Oo_knl01omKT/ooQ;WaohNkm?n7
^oCoQ;Waognbj?lD7BD01Ol000002olD7BGoPK?Xoh>ilOmo]NkoNK7[og2ZjOmPWn?oAX[Eob1X_Oo1
`L7ol?3`00[ooooo000Eonk^kP09ong]kOoQhN7o^;RhohV9ROo5aLGomoOgoo?cloo]kNgok^k^00;o
l?3`00ComoOgoo7alOogmoOol_;b0ooalO401ooclo?omoOgolG5aOn9RHWo^;Rhon7QhOo]kNd08?o^
k^h01ooPh>3o];Bdolg=cOoLg=coiNGUonOWiooYjNT00oo/k>`2on[ZjP04ogmoOolL71cojn_/on_[
k0;ok>c/00Coj>SXon[Zj_o/k>cok>c/0_o[jn`2onc/k004onWYjOoZj^[ok>c/onc/k0;ojn_/0_o/
k>`2on[ZjP;ok>c/0_o[jn`01?o/k>coj^[Zon[Zj_oZj^X2onc/k0;ojn_/00Cok>c/onWYjOoZj^[o
j^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;o
j^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;o
j^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;o
j^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;o
j^[Z0_o/k>`01?o[jncoDh[6ogbajOmk[nL2ogbaj@03od1LNOl0003o000000Go000000[o@5]iogN_
jOmcZnKoKJGSof:Ng_mETmSo>gk<oaIO]?nd];Coh>3P2_o^k^h001Coi^KV00SoiNGUom_Kfon/[:co
S8b<onc/k?oclo?ok^k^oo7al@;ol_;b00Kol?3`ooShn?nh^;SoJVYZoifMWOodm?@3oo;blP08oo7a
lOo^k^kolo?conc/k?n<S8co[:b/om_KfooUiNDOonKViP06omWIfOn`/;3o_;blom3@d?oOgmooi>CT
0_oUiND4onKViP03ogalO?lK6a_oi^KV08Soi^KV00CoGi73oh:_h?n1[]ooPk7P2On2[ml02_n0[moo
OjgNogf/g_mdYM[oKZ;Joe^Dd?lVK;go0DNUok2`/?oIfMT:onKViP005?o^k^h01_oXj>So_;bloi:B
T_ogmoOokno_oo;blP?olo?c00Wol_;booGemOoYjNWoI6AToeUIFOmDE5CocLg=oo_knooalO400ooc
lo<01_obl_;okno_ooOgmonBTY;o_;blonSXj1ook^k^00KohN7Qokfm_Onc/k?oa/K6on3Ph?oWinL2
onWYj@Coj^[Z00?o_knooiVIVOoZj^X0R?oZj^X01On9[MCoX/;Uoj;3i_nR`^GoX/?U00?oX/?V00oo
X/?Uoj32iOnP`^GoX<;Uoj;2i_nS`nKoWl;Voic0i?nH_>?oT[SOogNUf?lPIkWo03bLokfm_OoQhN40
2_o^k^h001?ooooo00Goo_knon;Rh_nEUIGolO7aono_k`05ooCdm009oo?clooemOGol?3`og5aLOm>
CTkoFe]KomSHf?ojn_[olo?c00Gom?Cd00Gokno_oo7alOnEUIGoh^;RooknoP0Nooooo`07ooGemOoF
e]KoYJFUokZj^_oLg=coinOWonWYj@2@on[ZjP09oijlf_nccNWo//gYok?>jOnbcNWo/lkYokC?j_nc
c^Wo/lgY00?o//gY00_o/lkZok?=jOnbcNOo[l[Wojc8i_nUa>CoNjKHo`mDZolE>Y;oe]KFooGem@0:
ooooo`004oo^k^h01OoWinOoXj>Solg=cOoemOGom?Cd00KomOGe00Oom?Cdoo_knooFe]KoUiNGol;2
`_ojn_[om?Cd00KomOGe00Gom?CdooGemOo=cLgoXj>SonOWi`0Nonk^kP08onSXj?oFe]KoXJ6Qojb/
[?o>c/kohn?SonKVi_oWinN?onWYj@0GojK1g?nid>[o^M3ZokW@j_nhd>[o^M3Zok[Bj_njd>Wo^];Z
okS@j_nhcnWo^M3Zok[Bj_nid>[o^<oYokC>ion_b^KoW;gPoeR>aol6@YooAeBComKFe_oXj>P02_o^
k^h001?oi^KV00Coclo?ohj>S_oinOWol_;b2?ofm_H01OoemOGoo?clom;Bd_oclo?on?Sh00Som_Kf
00Col_;booWinOn>SXkoclo?7_oVi^H02?oTi>Cog=cLokZj^_nOWioo/[:bolS8b?oFe]Kofm_KSooN
g]h01On;Zm3oWl3Poio0h?nO`>3oW[oP00?oWl3P00?oW/3Poio0h?nN_n000_nN_n002_nN_N3oW;gP
oiJig?n0Z]KoDh[6ob1HZolU?XooV9VcomcLg?oTi>@:onKViP004_o^k^h01Oo]kNgo^[ZjokVi^Ooj
n_[om_Kf00OomoOg00Oom_KfooWinOobl_;oHV9Rolk>c_oooooomOGe00OomoOg00Gom_Kfoo[jn_ni
^KWo^[Zjong]k@0Monk^kP08ong]kOo[jn_ohn?SolC4a?nYZJWoWinOoj2PX?nTY:B?oj>SX`So4UJX
00oo4UJWoa9FZ?lBEZSo4UJZoa9FZ?l@EJOo3U6Vo`e>Xol;AIko7TFHoe=TXOnRY;kohn?Son_[joo]
kNd02_o^k^h001;ooooo00Coo?clojn_[ooQhN7om_Kf2?ohn?P01oogmoOooOgmonKVi_mJFU[o`<30
ooooooofm_H02?ohn?P01?ofm_KohN7Qojn_[oolo?`Nooooo`06ookno_omoOgonOWiooGemOobl_;o
lO7aX?o`l?001_oalO7ol_;booGemOoinOWooOgmooknoP_ooooo000Bonk^kP04on[Zj_nJVY[ok^k^
ooKfmPSon_[j00Oon?ShoooooooFe]KoD51@ojb/[?oooooomoOg00Son_[j00Com_Kfonk^k_nJVY[o
j^[Z8?o^k^h2ong]kJCok>c/0_o]kNd=onk^kP004_oVi^H01?oRh^;oTi>Cono_koogmoL8oo_kn`07
ooWinOoooooo`L71oda<C?nHV9SoooooooWin@08oo_kn`04ooOgmoo_knooTi>Con;Rh]Goi^KV000B
onk^kP04on_[jonPX:3oj^[ZooWin@Soo?cl00OonOWioooooon[Zj_oD51@oh>3Pooooooono_k00So
o?cl00ConOWion[Zj_nPX:3ojn_[eOo^k^h001;ooooo00Coo_knol71`OoEeMGoo?cl2?omoOd02?ok
no_ooooooiBDU?mEEEGoLg=cooKfm_ooooooo?cl1oomoOd01?olo?coeMGEol71`Oono_kEooooo`00
4oo^k^h01?oBd];oY:BTooooooolo?`8ooknoP07oooooon0P83oG5aLofEUIOoXj>Sooooooogmo@06
ooknoP04ooclo?ooooooY:BTom;BdTSok^k^00?od];BogEeMOoWinL0Roo^k^h001?oi^KV00CogmoO
oiJFU_o^k^kon_[j1_ono_h02OomoOgoooooooCdm?m_KfooHV9RoeeMGOoEeMGoooooooclo006ookn
oP04oo[jn_o^k^koUYJFomoOgdSoi^KV00?oh^;RoaXJ6_nDU9@0RooVi^H001Cok^k^00Cobl_;ojBT
Y?olo?coo?cl1Oooool02Oono_koooooonGUiOmSHf?oIVIVoeUIFOo0`<3oooooooclo005ooooo`;o
o?cl00?oY:BTol_;boo^k^h07oo^k^h00oo/k>cocLg=omKFeP06onk^kP03on?ShooHf=Sok^k^00So
k^k^00?ohn?SomSHf?o^k^h01?o^k^h00ooMgMgogmoOonk^kP04onk^kP03omGEeOo/k>cok^k^00Go
k^k^00?oPH61ocTi>Oo^k^h01Oo^k^h00ooLg=cogmoOonk^kP04onk^kP03on_[jooOgmook^k^00go
k^k^00Goh>3PonSXj?o]kNgoeMGEong]k@0>onk^kP03omGEeOo/k>cok^k^01[ok^k^00?og=cLomoO
goo^k^h03Oo^k^h00ooEeMGok>c/onk^kP0[onk^kP005?ooool01Ookno_o^k^kolW9bOono_koo?cl
00Cooooo00WooOgmoooooooNg]koFe]KofUYJOmEEEGo]KFeooooooolo?`01?ooool01Oolo?coo_kn
olW9bOnk^k_ono_k01oooooo00Ko/;2`o`X:2_l=3@go92@TocHf=_nWYjL2ooooo`09onOWiom:BT[o
0`<3ob<S8olG5aOo`L71oooooom0@43oOgmo00;ooooo01;oinOWodY:B_l30`?o8b<SoaLG5oo1`L7o
ooooonGUiOm0@43o0000oa8B4_lM7Agon?ShoooooooCdm?o9BDUoahN7_nj^[X6ooooo`03oi:BT_l0
003oemOG00?ooooo00Kofm_KocDe=Ol>3Pko30`<ocTi>OoLg=`2ooooo`06okno_olK6a_o1`L7oe9B
D_n6QXKo<30`0_ooool00om0@43oOgmoooooo`06ooooo`06od10@?mIFEWo9RHVoa/K6olE5AGo_;bl
0_ooool01_m0@43oOgmooooooooooooo@410ogmoO`?ooooo00Oodm?CobDU9OlN7Qko^[Zjoooooom0
@43oOgmo00;ooooo00?oXj>Soa`L7?ooool01Oooool01_m0@43oOgmoooooooooooooNWYjod=3@`;o
oooo00[o];Bdo`T92Oooooooooooom_Kfole=CGo3Ph>o``<3?li>CWog=cL0_ooool01_m0@43oOgmo
ooooooooooooXj>Soa`L70;ooooo00Oodm?CobDU9OlN7Qko^[Zjoooooom0@43oOgmo00;ooooo00Ko
Xj>Soa`L7?ooooooooooodE5AOlY:BTQooooo`005Oo^k^h01_oTi>CoY:BTol_;booooooono_kookn
oP;ooooo00Woo_knoooooookno_oPX:2oeIFE_mXJ6Sohn?Sooooooono_h00_ooool01_ono_kono_k
ooooooo;bl_oY:BTonCTi23ok^k^017oalO7ok:b/_oYjNWok^k^oi:BT_l30`?oclo?onk^k_lo?coo
>c/kom3@d?o^k^koh^;Ron7QhOo^k^ko>c/kogIfMP02onk^kP0Aoclo?olk>c_od=3@onk^k_oRh^;o
hN7Qonk^k_lm?Cgo:BTYokfm_Oo^k^kobLW9onc/k?o^k^koJFUYoc`l??o]kNd01oo^k^h00ol[:b_o
20P8ofUYJ@02onk^kP03ong]kOl`<33oC4a<00;og]kN00[oCdm?oc4a<Oo]kNgok^k^odi>C_mCDe?o
i^KVoi>CTol>3Pko;2`/0_o^k^h00olk>c_oMWIfonk^kP06onk^kP0:oc/k>oln?SkogmoOon[Zj_md
M7Co4A4Aon;Rh_o^k^ko>c/kogIfMP;ok^k^00?o>c/kogIfM_o^k^h00_o^k^h00omYJFWo?3`long]
k@02onk^kP06oc/k>omfMWKok^k^onk^k_nHV9So6QXJ1_o^k^h01_lk>c_oMWIfonk^k_o^k^koLG5a
ochn?P;ok^k^00KoZ:RXo`P82?o^k^kokNg]oc0`<?m<C4`2omkNgP06odm?Cola<C7okNg]onk^k_lk
>c_oMWIf0_o^k^h01onHV9So6QXJonk^k_o^k^koJFUYoc`l??o]kNd00_o^k^h01_lk>c_oMWIfonk^
k_o^k^koV9RHoaXJ6P;ok^k^00?oRh^;ogemOOo^k^h08?o^k^h001Koi^KV00Oog=cLojFUYOn/[:co
moOgoogmoOokno_ooOgm00?ooooo00?omOGeom7AdOoZj^X00oooool01oomoOgono_koogmoOogmoOo
[:b/ojFUYOoLg=`09OoVi^H01_o:b/[o0000ojBTY?o7alOo0000ojFUY@Goi^KV00Ko>CTiog9bL_oV
i^KoalO7o`000?nUYJD4onKViP03olK6a_l0003oQXJ600Goi^KV00?oADE5ofIVI_oVi^H01_oVi^H0
2Onh^;So0000ohn?SolA4A7ogmoOonKVi_o2`/;o0000ojFUY@02onKViP06ojFUYOl0003oa/K6onKV
i_lW9bOoPH610_oVi^H01_m^KVko:b/[onKVi_oVi^Ko>CTiog9bLPOoi^KV00[o>CTiog9bL_oVi^Ko
i^KVom3@d?l0003oW9bLonKVi_li>CWoLW9b0_oVi^H00oli>CWoLW9bonKViP02onKViP03odE5AOmV
IVKoi^KV00;oi^KV00Ko>CTiog9bL_oVi^Koi^KVoi>CTolI6AT6onKViP06ocTi>OmbLW;oi^KVonKV
i_m^KVko?3`l0_oVi^H01_nRXZ;o20P8onKVi_o2`/;o0000ojFUY@;oi^KV00KoYJFUo`000?o6a/Ko
i^KVocTi>OmbLW82onKViP06oi>CTolI6AWoi^KVonKVi_m5ADGoIVIV0ooVi^H01_li>CWoLW9bonKV
i_oVi^KoTi>CoaTI6BGoi^KV000Gonk^kP0EonSXj?o1`L7oUiNGol[:b_ohn?SooooooogmoOokno_o
n_[jooclo?oooooooOgmoo[jn_okno_ooOgmooooooohn?Sob/[:oiNGUoo1`L7oj>SX02Gok^k^00Oo
h>3PodU9BOl71`OohN7Qok6a/Ol0003o>3Ph00?o>SXj00So][Jfonk^k_lk>c_oMWIfonk^k_na/K7o
0000ocPh>0?o>SXj00Co][Jfok6a/Ol0003o`<301Oo^k^h00om7AdOoJVYZonk^kP06onk^kP09of9R
H_ll?3cok^k^obDU9OnIVIWok^k^ok6a/Ol0003oe]KF00;ok^k^00Koe=CDo`000?nd];Cok^k^obTY
:On9RHT2onk^kP06ohF5QOl/;2cok^k^onk^k_lk>c_oMWIf1oo^k^h00olk>c_oMWIfonk^kP02onk^
kP05oa@D5?n7QhOok^k^oc/k>omfMWH00_o^k^h00olk>c_oMWIfonk^kP02onk^kP03odM7AomZJV[o
k^k^00;ok^k^00Ko>c/kogIfM_o^k^kok^k^oiRHV?lJ6QX6onk^kP06oc/k>omfMWKok^k^onk^k_ma
LG7o?Shn0_o^k^h01_nXZ:So20P8onk^k_na/K7o0000omKFeP;ok^k^00Koe=CDo`000?nd];Cok^k^
oc/k>omfMWH2onk^kP06oiRHV?lJ6Q[ok^k^onk^k_m7AdOoJVYZ0oo^k^h01_lk>c_oMWIfonk^k_o^
k^koV9RHoaXJ6RGok^k^000Hooooo`08ookno_o_knoo`/;2oinOWonb/[;og=cLoo;bl_okno/3oogm
o@08oo_knoobl_;og=cLok:b/_nOWioo`/;2ono_koono_hUooooo`0JokJf]_lL71co5aLGokjn__oo
oooofm_Ko`000?n[Zj_oclo?olO7aol30`?oiNGUoooooom0@43oOgmooooooooKfm_o0000oj^[Zoo?
clooalO7o`<30ooUiNGofm_Ko`000?nATI45ooooo`03ode=COmbLW;ooooo00Gooooo00[om_Kfo`l?
3onRXZ;ooooooi2@T?ln?SkoooooomcLg?l0003o];Bd0_ooool01_nb/[;o0000on3Ph?oooooo;2`/
oi>CT`;ooooo00KoShn?oc0`<?oooooooooood10@?mYJFT7ooooo`0:od10@?mjNW[oooooooooooo]
kNgo0000ol?3`ooooooo@410ogmoO`;ooooo00?o@410ofUYJOooool00_ooool00om=CDgoLW9boooo
o`02ooooo`06od10@?mMGEgooooooooooonMWIgo7AdM1_ooool03_m0@43oKFe]ooooooooooooNGUi
oc<c<oono_kooooook>c/ol92@WoooooomcLg?l0003o];Bd0_ooool01_nb/[;o0000on3Ph?oooooo
@410oeeMG@;ooooo00KoWIfMoadM7Oooooooooooode=COmbLW83ooooo`06od10@?mMGEgooooooooo
oonMWIgo7AdM9Oooool001[ok^k^00ookNg]on?Shoo=cLgo/;2`oifMWOnGUiOoUIFEoiBDU?nEUIGo
UiNGoifMWOn`/;3ocLg=on?Shoo]kNd09_o^k^h01?mhN7So0000oe1@D?oFe]H3onk^kP05ocXj>_mS
Hf?oi^KVoi>CTolX:2P00_o^k^h02Olk>c_oMWIfonk^k_o^k^ko>SXjof=SHooVi^KoTi>CobPX:002
onk^kP0;ocXj>_lT92Co/K6aong]kOo?clook^k^onSXj?m4A4CoIFEUon?ShooZj^X01?o^k^h03_nH
V9So3@d=onCTi?o^k^kog]kNo`P82?o8b<Sok^k^oc`l??m3@d?oclo?olk>c_m2@T;o?clo0_o^k^h0
1_lY:BWoRHV9onk^k_o^k^koQHF5ob`/;0;ok^k^00Go>c/koa4A4On7QhOoe=CDonc/k004onk^kP0:
oc/k>olI6AWoS8b<olg=cOmRHV;o3`l?on_[joo^k^ko>c/kogIfMP;ok^k^013o>c/koa4A4On7QhOo
e=CDonKVi_m4A4CoIFEUon?ShooZj^[ok^k^oc/k>olB4Q;oKVi^olo?comADE7oAdM71_o^k^h02_lk
>c_o4a<Coh:2P_oHf=So>SXjoa`L7?mIFEWod];BofUYJOl_;bl2onk^kP06oc`l??m3@d?oclo?olk>
c_m2@T;o?clo0_o^k^h04olk>c_o4Q8Bofi^K_o?clooDE5AodM7Aoo^k^koj>SXodA4A?mUIFGohn?S
on[Zj_o^k^ko>c/koa8B4_m^KVkoclo?oe5ADOm7AdL09Oo^k^h001goi^KV00WoiNGUon;Rh_oNg]ko
g=cLom_KfooLg=cog]kNon;Rh_oUiND0:?oVi^H00oo?cloo0@41ohB4Q005onKViP05olo?com0@43o
2`/;oaTI6OnUYJD00_oVi^H02Oli>CWoLW9bonKVi_oVi^Koclo?od10@?l;2`_o6ATIojFUY@02onKV
iP0;om7AdOm>CTko3@d=o`T92OlR8R;oi^KVog9bL_l71`Oo2PX:oaPH6?nLW9`01?oVi^H00omADE7o
IFEUonKViP02onKViP05of5QHOmgMgOoi^KVom7AdOm9BDT00_l=3@d01_m;Bd_od];BonKVi_oVi^Ko
?3`lohj>SP;oi^KV00WoRh^;oclo?ooVi^Koi^KVod];BomkNg_oDe=Co`P82?oHf=P01?oVi^H01_li
>CWoKfm_oe]KFol;2`_o5QHFoiNGU`;oi^KV01CoBd];ogmoOooVi^Koi^KVod];BomkNg_oDe=Co`P8
2?m[Jf_o1`L7o`X:2_lH61SoW9bLonKVi_li>CWoLG5aofe]KOlB4Q;o:BTYok2`/0Koi^KV00[oBd];
ogemOOmUIFGo3Ph>ob@T9?o0`<3oRXZ:oaLG5olL71coW9bL0_oVi^H01_oAdM7oBDU9o`d=3Ol=3@go
Bd];om;BdP;oi^KV01?oBd];oginO_m]KFgo4Q8BobTY:On`/;3oi^KVog9bL_l71`Oo2PX:oaPH6?nL
W9coi^KVocTi>OmaLG7oKFe]oa8B4_lY:BWo/;2`02Goi^KV001>onk^kP03olW9bOl10@7oemOG00Oo
k^k^00?ojn_[onk^k_o^k^h00_o^k^h00olk>c_oMWIfonk^kP03onk^kP03on_[joo^k^kok^k^00Go
k^k^00Kojn_[onk^k_o^k^kok^k^odM7AomZJVX@onk^kP;okNg]3oo^k^h00oo[jn_ok^k^onk^kP03
onk^kP04oc/k>omfMWKok^k^onc/k0_ok^k^00Cojn_[onk^k_m7AdOoJVYZ0oo^k^h01?lk>c_oMWIf
onk^k_o]kNd;onk^kP03ong]kOo^k^kok^k^00;ok^k^00?okNg]onk^k_o^k^h00oo^k^h2ong]k@Oo
k^k^00?okNg]onk^k_o^k^h00_o^k^h00om7AdOoJVYZonk^kP02onk^kP04oc/k>omfMWKok^k^ong]
kBOok^k^001?ooooo`05odY:B_lj>S[oSXj>of9RH_mHF5P02Oooool00om0@43oOgmoooooo`0?oooo
o`03on3Ph?oNg]kooooo02Kooooo00?o@410ogmoOoooool01Oooool00omKFe_oTY:Booooo`06oooo
o`03on3Ph?oNg]kooooo00;ooooo00?o@410ogmoOoooool09Oooool00ooPh>3og]kNooooo`02oooo
o`03od10@?moOgoooooo02Sooooo001?onk^kP05on[Zj_nYZJWoIVIVoginO_nb/[802Oo^k^h00olk
>c_oMWIfonk^kP0honk^kP03oc/k>omfMWKok^k^00Gok^k^00?oZ:RXokno_oo^k^h02oo^k^h00olk
>c_oMWIfonk^kP0Zonk^kP03oc/k>omfMWKok^k^02Sok^k^001MonKViP03on;Rh_oTi>Coi^KV03So
i^KV00?oh^;RonCTi?oVi^H04ooVi^H00ooRh^;oi>CTonKViP0ZonKViP03on;Rh_oTi>Coi^KV02So
i^KV003oonk^kPOok^k^003oooooo`Oooooo003oonk^kPOok^k^003oonKViPOoi^KV003oonk^kPOo
k^k^003oooooo`Oooooo003oonk^kPOok^k^003oonKViPOoi^KV003oonk^kPOok^k^003oooooo`Oo
oooo003oonk^kPOok^k^003oonKViPOoi^KV003oonk^kPOok^k^003oooooo`Oooooo003oonk^kPOo
k^k^003oogmoO`OoOgmo00001?o[jn_oi^KVon;Rh_oNg]h4omgMg@?og]kN01_ogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomgMgOoLg=`00_oMgMd04OoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN00;ogMgM0;oo
g=cMomgMgOoMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomgMgOoLg=cogMgMomcLg?oMgMgog=cLomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMg@03omkNgP03omgMgOoNg]ko
g]kN00?ogMgM0OoQhN41onOWi`7oj^[Z00000oo/k>coi^KVon3Ph007omWIf@04omSHf?oFe]Kodm?C
om3@d0?ocLg=00Cod=3@om?CdooGemOof=SH3?oIfMT02OoHf=SoemOGomGEeOoDe=Codm?ComCDe?oE
eMGoemOGomSHf00=omWIf@09omSHf?oGemOoeMGEomCDe?oCdm?oe=CDomGEeOoGemOof=SH02WofMWI
0ooHf=P01OoGemOoe]KFomCDe?oDe=Coe]KF00?of=SH1ooIfMT3omSHf0?ofMWI0_oHf=P6omWIf@;o
f=SH1_oIfMT3omSHf6KofMWI00?of=SHomWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^
k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=codm?ColO7aonk^k_o/[:bojj^
[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=on3Ph?oOgmoofm_KomKFe_oBd];oc/k>olc<
c?o>c/kod];BomKFe_oKfm_ogmoOon3Ph009on7Qh@0=on3Ph?oOgmoofm_KomKFe_oBd];oc/k>olc<
c?o>c/kod];BomKFe_oKfm_ogmoOon3Ph00Uon7Qh@;oh>3P00SogmoOomgMgOoLg=cof][JomSHf?oF
e]Kof=SHom_Kf`KogmoO0ooPh>000ooOgmoog]kNomkNgP02omoOg`05on3Ph?oOgmoogmoOomkNg_oO
gml01?oPh>03omoOg`03on3Ph?oOgmooh>3P00?oh>3P00CogmoOomkNg_oNg]kogmoO0ooPh>000ooO
gmooh>3Pon3Ph005on3Ph5cohN7Q00?oh^;Ron7QhOoRh^801?oQhN41onCTi07ojNWY0Oo]kNd00003
oo3`l?o_knoolO7a00?ol?3`01Sokno_oo3`l?o^k^kojNWYom_Kfoo1`L7oY:BTohb<S?mkNg_oMgMg
og]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7alOo_knoolO7_ono_kooalO42onk^
kP0DonKVi_oNg]kodM7AolW9aoo1`L7o_knool71`Oo9bLWodM7AomkNg_oVi^Kok^k/onk^k_oalO7o
kno_oo7alOo_knoolO7aono_kooalNl2onk^kP0;onKVi_oNg]kodM7AolW9bOo1`L7o_knnol71`Oo9
bLWodM7AomkNg_oVi^H00_o^k^h08ooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a00;ok^k^00gojNWYonSXj?oT
i>Coi>CRon3Ph?oOgmooh>3PonKVi_oYjNWojn_[onOWiooXj>Koi^KV00;ojNWY00ook^k^ong]kOo^
k^koj>SXonSXi_oUiNGojNWYon[Zj_o]kNgoj^[ZonWYjOoVi^KojNWWon[Zj_o_knl00_o]kNd01OoW
inOojNWYon[Zj_o]kN_ojNWY00;ok>c/00Ook^k^onWYjOoXj>SoiNGUonSXi_oXj>Sok^k^00;okNg]
06[ojNWYong]kOo]kNgok^k/on[Zj_o/k>cokNg]oo3`l?o_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo`l?3okno_oo3`l?o_knool?3`ono_koo`
l?3okno_1?o`l?000003oo;bl_o^k^koinOW00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mVIVKo
DE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@02ooUiNGoi>CTonGUi?oT
i>CoiNGUon;Rh_oLg=coclo?ol71`Ona/K7oZJVX00?oY:BT03goZJVYok6a/Oo1`L7oclo?omcLfooR
h^;oiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTon;Rh_oLg=coclo?ol71`Ona/K7oZJVYojBTY?nT
Y:?oY:BTojVYZOna/K7o`L71olo?cooLg=coh^;RonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT00;oi>CT00kohN7QomkNg_oH
f=Soe]KFomGEeOoDe=?od];Bolg=cOn5QHGoAdM7omGEeOoKfm_oeMGEomGEe0;oeMGE01Soe]KFomgM
gOoOgmoog=cLomKFe_oEeMCoe]KFom[Jf_oLg=cogmoOom_KfooIfMWoeMGEomOGe_oJf][oh>3PomoO
gooLg=coe]KFomWIfOoLg=cog=cKomSHf?oLg=`2omkNgP0?omSHf?oFe]Koe=CDomGEe?oGemOog=cL
omoOgooLg=cof=SHomcLg?oPh>3ogmoNomWIfOoKfm_ogmoO00;oi>CT05[oiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>@4onGUi@06onCTi?oUiNGo
iNGUonGUiOoXj>SokNg]0Oobl_800003ooCdm?o]kNgoinOW00;oh>3P01?ohN7QomoOgooNg]kod];B
okBd]?n7QhOoG5aLofdk=OnNCT;ocFmOonV3Koo=KeooWTi3ofdk=_mLG5coQhN7okBd]?oBd];og]kN
00Goh>3P017ogmoOom[Jf_o>c/ko_;bloj^[Zon`/;3oalO7omWIfOoTi>CofMWIolO7aona/K7oZj^[
okbl_?o>c/kof][JomoOg`05on3Ph00AomoOgooJf][oc/k>okbl_?n[Zj_o/;2`olO7aooIfMWoi>CT
omWIfOo7alOo/K6aoj^[Zonl_;coc/k>om[Jf_oOgml08OoPh>009OoNg]kof][Jom?Cdoo@d=3odM7A
okJf]_n/[:coLG5aoaPH6?le=CGoN7QholO7aooBd];oclo?ol?3`ooAdM7ocLg=olk>c_oFe]Kof=SH
om;Bd_o?cloobl_;okno_ooGemOof][Jom_KfooIfMWoeMGEol30`?o@d=3odM7AomSHf?oIfMWodm?C
om7AdOo0`<000_oGemL01?oAdM7odm?ComSHf?oEeMD2om3@d00>okfm_Oo=cLgod=3@om?CdooHf=So
eMGEom7AdOoEeMGofm_KomSHf?oAdM7od];BomWIfOoNg]iJon3Ph003omoOgooPh>3ogmoO00;ogmoO
0ooPh>000ooQhN7oinOWonc/k001ooCdm00000?om_Kfoo;bl_o[jn/00ooXj>P04ooWinOoh^;Rolg=
cOnOWiooJemOohlf;_o]LF7onIf@oofaYOom_:oooKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;R
h_oWinL01?oXj>P01ooVi^KogMgMol[:b_ne]KGo_knoonOWioo_knl00oo`l?001oo_knoojNWYol71
`One]KGob/[:omgMgOoVi^H01OoXj>P01ooVi^KogMgMol[:b_ne]KGo_knoonOWioo_knl00oo`l?00
1oo_knoojNWYol71`One]KGob/[:omgMgOoVi^H08?oXj>P04ooWinOoiNGUomkNg_oFe]KoSHf=o`l?
3olL71co7alOo`000?mmOGgof=SHomgMgOoNg]ko];BdoalO7ol410Co>c/koh>3PolD51@00_oMgMd0
3?o=cLgoF5QHo`<30olL71co4Q8Bohb<S?oTi>CoMWIfo`X:2_lP823o9RHVoijNWP;ogmoO01Wo^k^k
ob<S8olI6AWoWinOomkNg_lR8R;oQHF5omgMgOoIfMWoT92@oa0@4?lF5QKo10@4of1PH?oCdm?ogMgM
olG5aOl0003o_[jnon;Rh_oOgmoo?cloofUYJOoQhN7oi^KV06?oj>SX0Oo/k>`1oo;blP7om_Kf0000
0oogmoOon?ShooShn003ooShn00CooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFoo^BQoonYY_oo[6Uoonh
Zoon/jKooZRLoo^DROo^J5WoRC4[oi2@T?o>c/kok^k^ooOgm`04ooShn006ooCdm?oWinOoclo?olK6
a_oZj^[om?Cd0_oinOT02Oojn_[onOWiooWinOofm_Kojn_[olO7aoo?clooinOWooCdm005ooShn006
ooCdm?oWinOoclo?olK6a_oZj^[om?Cd0_oinOT02Oojn_[onOWiooWinOofm_Kojn_[olO7aoo?cloo
inOWooCdm00PooShn00looOgmoodm?Cok>c/oiRHV?l92@Wo[Zj^ooKfm_ogmoOo_[jnoaHF5_n>SXko
j^[Zonc/k?mVIVKo?cloonSXj?nVYZKo51@DoaHF5_o/k>cojn_[ofIVI_lQ8B7o_[jnonOWiooRh^;o
gMgMoo;bl_o6a/KoemOGonKVi_nBTY;o:2PXoo;bl_o_knooLg=cocDe=Oo`l?3om?Cdono_kolT92Co
Shn?onc/k?o3`l?o0`<3oi:BT_obl_;oa/K6oaTI6On2PX;ok>c/om?Cdol0003ob/[:oo;bl_o_knoo
@d=3og1`L?oalO7om_KfG?ohn?P00oogmoOon?ShooShn002ooShn004ooOgmooinOWomoOgooOgm`7o
n?Sh00000oojn_[omOGeonk^kP02onc/k00Qon_[jooYjNWogmoOokZj^_miDU;o_c8TonMdJOomRGko
oiR<oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c9?miDU;o^[ZjomoOgooZj^[ojn_[onc/k?o[jnco
jn_[onKVi_oHf=So^k^komCDe?oTi>Cojn_[oo7alOobl_;olo?c00;ol_;b00KokNg]onGUiOoEeMGo
^k^komSHf?oVi^H2on_[j`0<onc/k?o[jn_ojn_[onKViooHf=So^k^komCDe?oTi>Cojn_[oo7alOob
l_;olo?c0_obl_801_o]kNgoiNGUomGEeOnk^k_of=SHonKVi`;ojn_[037ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncojn_[onKVi_oJf][o6ATI
oda<C?oVi^Kojn_[on[ZjooXj>SoPh>3o`X:2_oIfMWogmoOoclo?omYJFWohn?TonGUiOn2PX;o5ADE
00;ogmoO083o2@T9og]kNooJf]_ofm_KomWIfOoPh>3ohn?Son3Ph?oJf][oclo?ode=COlV9RKoinOW
on?Shom=CDgoGEeMon;Rh_oXj>SohN7Rob8R8_n7QhOoh>3Pog5aLOl?3`oogMgMonGUiOoPh>7oEEEE
obl_;ooQhN7oalO7o`000?nm_Kgoh^;RomoOh?m0@43oJf][onKVi_oYjNWok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k0Oojn_[00Gok>c/on_[joo[jn_o
k^k^ooKfmP01ooWin@0000?ono_koo?cloo]kNd00_oUiND07ooVi^Koi>CTomWIfOnb/[;oNBh^olQ2
=?oSJUcom7Y]oof8O?onUh[ooY^>oojHRoonRWkom7]]onM[GOo:@SCoNbh^ok:b/_oHf=Soi>CTonGU
iOoVi^KoiNGVonGUiOoOgmoodM7AokJf]_oDe=CogMgMonCTi?oVi^L00oo/k>`01ooXj>Soi>CTomoO
gooEeMGo][Jgom7AdOoOgml00_oUiND05?oVi^KoiNGUonGUiOoOgn3odM7AokJf]_oDe=CogMgMonCT
i?oVi^Kok>c/onc/kOo/k>coj>SXonCTi?oOgmooeMGEokJf]_oAdM7ogmoP0_oUiND0=OoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oUiNGohN7Q
okRh^?l0003oQ8B4on3Ph?oUiNGoi>CUon7QhOo1`L7o0000ok6a/OoKfm_o?CdmofUYJOoNg]ooh>3P
oi2@T?lD51Cog=cLol[:b_l0003o;Bd]00?o=cLg07coShn?omkNg_oIfMWoNGUio`X:2_l/;2co][Jf
on3Ph?oLg=coBTY:oe]KFooIfMWogmoOomcLg?lQ8B7oQ8B4omgMgOmIFEWo=SHfomGEeOoIfMWoe]KG
ogQhN?lF5QKog]kNol?3`ol0003o][JfomOGeooEeMKo?ShnofQXJ?oQhN7oi>CTonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU0_oVi^H00ooUiNGo
i^KVonKViP03onKViP03onGUiOo]kNgom?Cd007ono_k00000oolo?con?Shoo7al@03onk^kP0Con_[
jooQhN7o_;blogXG5oo3?c;odeI9onAXF_o_Mfcom8=iooR7O?oeQ7[olgU]onEYFooIF4[oa3lbog`G
5onl_;cohN7Qonc/k003onk^kP08ong]kOoYjNWof][JokVi^OoGemOog]kNon?ShooVi^H3on[ZjP08
onSXj?oTi>Cog]kNomSHf?ni^KWof][JonWYjOo]kNd3onk^kP08ong]kOoYjNWof][JokVi^OoGemOo
g]kNon?ShooVi^H3on[ZjP08onSXj?oTi>Cog]kNomSHf?ni^KWof][JonWYjOo]kNdOonk^kP06ong]
kOo[jn_oXZ:Ro`000?nn_[koi^KV0_o[jn/01ooVi^Kofm_Ko`000?n<S8coiNGUod10@?m^KVh00_oY
jNT01_nHV9So5ADEonOWiooWinOo1`L7ogYjNP;o][Jf00go6QXJojZZZ_oZj^[oVi^Ko`d=3OnGUiOo
gmoOonKVi_oWinOoh^;Rode=COmMGEgogmoO00;oiNGU00Ko8b<Soh^;RooXj>SoNGUio`d=3OoMgMd2
omoOg`06oe9BD_lc<c?ojNWYolg=cOl0003oXj>S0_oOgml01?ll?3coKVi^on_[joo]kNeRonk^kP03
ong]kOobl_;on?Sh007oo?cl0003oogmo@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Co
aclcom9@@ooJHUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];olo?cooclo0CooOgm
00OonOWionc/k?nh^;Sofm_Kon7QhOoUiNGojNWY00;ok>c/00SokNg]on[Zj_oUiNGoh^;Rom_Kfoni
^KWok>c/ooWin@GooOgm00OonOWionc/k?nh^;Sofm_Kon7QhOoUiNGojNWY00;ok>c/00SokNg]on[Z
j_oUiNGoh^;Rom_Kfoni^KWok>c/ooWinB3ooOgm00Koo?cloo_knoo0`<3o0000olG5aOo`l?02ooGe
m@07oo3`l?o3`l?o0000ojJVY_ohn?SoA4A4ogMgM`02oo_kn`0YojBTY?lF5QKon_[joo_knomWIfOo
ATI6onGUiOo0`<3o20P8oo?clookno_oW9bLoc8b<_o`l?3ok^k^onCTi?oinOWok^k^odm?ComPH63o
j>SXoo?cloogmoOo9BDUoiBDU?oinOWog=cLo`L71on5QHGoj^[Zok>c/olC4a?oVIVIoo_knooOgmoo
0000obDU9OnYZJWod=3@oa8B4_nVYZH00_olo?aPoogmo@03ooclo?omoOgoo?cl00?ooOgm0000I?om
oOgon_[joo?cloo^k^kol?3`ono_koo^k^kojNWYom?CdomK7AgoXS@dok@X7Oo1>RgoadTlolmFB_o@
Ed_od5M:olY:?_o3>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>ookno_onk^k_oS
hn?o[:b/ol[:b_oBd];oemOGom[JfOoMgMgog]kNomgMgOoLg=coemOGomCDe?o:b/[o[:b[on?Shoo^
k^kokno_oo3`l?o_knool?3`ono_koo^k^gohn?Sojb/[?o:b/[od];BomOGeooJf][ogMgMomkNgOoM
gMgog=cLomOGeooDe=Cob/[:ojb/[?oShn?ok^k]ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>l2ono_k`0EomcLg?l20P;oTI6Aon3P
h?oQhN7oh^;Qon3Ph?mmOGgo0000olK6a_o]kNgoDe=CoginO_o_knkok^k^ojJVY_l[:b_okno_onk^
k_oTi>CoEeMG00;o410@01SoSHf=onk^k_o_knooj>SXoeADE?lH61So2`/;oh20P?o^k^koOGemo`P8
2?l:2P[o6ATIoiZJV_o[jn[o>3PhoiNGUoo/k>cokno_ok6a/Ol[:b_o2@T9oaTI6OmoOgl2onk^kP1T
omSHf?lI6AWo^;Rhoclo?ol92@WoCDe=onKVi_o^k^kol?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`;ol?3`1_o_knl1oo?cl`7onOWi
0Oono_h00003ookno_ogmoOol?3`00CojNWY017oinOWom_KfomSBd_oPC8bojHe=Onf=2go`Te1ol=D
BOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mSBd_ofm_KonOWi`05onWYj@06onSXj?oShn?oZj^[okVi
^Oo9bLWoclo?0_oEeMD02OoFe]KoeMGEomCDe?o?cloob<S8okVi^On[Zj_ohn?SonSXj005onWYj@06
onSXj?oShn?oZj^[okVi^Oo9bLWoclo?0_oEeMD02OoFe]KoeMGEomCDe?o?cloob<S8okVi^On[Zj_o
hn?SonSXj00QonWYj@;oj>SX00?oGUiNobLW9ooBd]800_oMgMd01OoHf=So<C4aodE5AOoWinOoj>SX
00[ojNWY00?oinOWonWYjOoYjNT01?oYjNT00ooWinOojNWYonWYj@02onSXj009odi>C_mOGeooj>SX
onSXj?oUiNGoh^;Ron?ShooVi^Koj>SX00;ojNWY00?oi^KVonWYjOoYjNT01_oYjNT00ooXj>SojNWY
onWYj@1NonWYj@03onSXj?oYjNWojNWY00CojNWY0Oo`l?01ooOgm`7oo_kn00001Oono_kon_[jooCd
m?o_knoolO7a00;ol?3`017okno_on_[jonEU9CoCb<SoiEDE?nkLg?odiFEomZLW?oJWYcofIbLomBE
UOnkLg?oUEADodlS8onEU9Coj^[Zono_k`06oo3`l006onk^k_o;bl_oYjNWolS8b?oHf=Sohn?S0ooV
i^H01_oShn?of=SHolS8b?nWYjOobl_;onk^kPOol?3`00Kok^k^ol_;bonWYjOob<S8omSHf?oShn<3
onKViP06on?ShooHf=Sob<S8ojNWYoo;bl_ok^k^8oo`l?002_o_knoog]kNocdm?OlV9RKoNWYjoh20
P?l`<33o;Rh^om;Bd_o_knlFoo3`l003ono_kooDe=Coclo?00;okno_00?ok^k^od10@?nLW9`00_o_
knmaoo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn00001?omoOgoooooooooooono_h2ooooo`;oo_kn
0?GooOgmooShn?m^KVkoFSlook6@T?oNbLWol>CToo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?ol
o?coooooookno_ooooooo_knooooo_ono_kooooooogmoOolo?coaLG5okZj^_oMgMgolO7`ooShn?oi
nOWon?Shoo7alOoMgMgo^[ZjolG5aOolo?_ooOgmooooooono_koooooookno_ooooooo_knooooo_om
oOgoo?clolG5aOnj^[[ogMgMoo7alOohn?SonOWhooShn?oalO7ogMgMokZj^_o5aLGoo?cloogmoOoo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_oooooono_kojb/[?mhN7SoLg=coj>SXoohn?SooOgmooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ono_goZ:RXomKFe_om
oOgoooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooooooknoP02ooooo`03ookno_oooooooooo00?ooooo0OomoOd00004oooo
ooono_kon_[jooCdm0GolO7a00gokno_omKFe_m[Jf_o@cdmoi^<S?o6^[[oe/c<olNj^_nKS8co@cdm
of][JooFe]Kokno_00WolO7a00gol?3`onKVi_nm_Kgo/;2`olo?cooOgmooiNGUomoOgoo?cloo/;2`
okfm_OoVi^Kol?3`00WolO7a00gol?3`onKVi_nm_Kgo/;2`olo?cooOgmooiNGUomoOgoo?cloo/;2`
okfm_OoVi^Kol?3`0;SolO7a00Col?3`oo7alOoalO7ol?3`1?oalO400oodm?Con_[jooknoP01oooo
o`0000Gok>c/oogmoOohn?Sol?3`on_[j`03on[ZjP0=onWYjOoZj^[ojNWYonSXj?nKVi_oFEUIobHV
9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0<on[ZjP09onWYjOo:b/[o/K6aoifMWOnBTY;oWIfMok6a
/Oo:b/[ojNWY00goj^[Z00WojNWYol[:b_na/K7oWIfMoi:BT_nMWIgo/K6aol[:b_oYjNT0`OoZj^X0
1?o[jn_ol?3`ooShn?omoOd1onc/k00000Co]KFeooKfm_ojn_[om?Cd2?oalO42oo3`l0?okno_0_o`
l?0Aoo7al@?ol?3`4ooalO43oo3`l<3olO7a00?ol?3`oo7alOoalO400_oalO400ooemOGon_[jooKf
mP01okFe]@0000?oa/K6ol?3`oojn_X0ooooool1ooooo`7onOWi0Oo3`l<1olK6aP0000Col_;bomCD
e?o6a/Kom?Cdo?ooool01Oono_koooooooCdm?o6a/Koe=CD007ol_;b0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{262, 143},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000460000nB000`400?l00000o`00003o@On2PX82
oh61P@0<oh20P?moOgooOWinogalO?mkNg_oNGUiogMgMomeMGGoLW9bog1`L?m]KFgoJVYZU_ooool0
3?mZJV[oKFe]og1`L?mbLW;oM7AdogMgMomiNGWoNg]kogalO?mnOWkoOgmooh20P0;oPH614on2PX80
047oOGem0_mlO7`03?mkNg_oNWYjogUiNOmgMgOoMWIfogAdM?mbLW;oL71`ofe]KOm[Jf_oJFUYofIV
IYKonOWi00_oIVIVofUYJOm[Jf_oKVi^og1`L?mbLW;oM7AdogIfM_mgMgOoNGUiogYjNP02og]kN`03
ogalO?mmOGgoOGem017oOGem0012ogYjNP0?ogUiNOmhN7SoMgMgogIfM_meMGGoLg=cog9bL_m`L73o
KVi^ofa/K?mYJFWoIVIVof=SHoo[jn_oj^[Z00Cojn_[0_oZj^X01?o[jn_oj^[Zon_[jooZj^X2on_[
j`04on[Zj_o[jn_ojn_[on[ZjPCojn_[0_oZj^X01oo[jn_oj^[Zon_[jooZj^[ojn_[on7QhOoFe]H0
0_o[jn/01OoZj^[ojn_[on_[jooKfm_ogMgM00;oj^[Z00Oojn_[on[Zj_o[jn_oh>3PomKFe_o[jn_o
j^[Z00;ojn_[00?oj^[Zon_[joo[jn/00_o[jn/2on[ZjP08on_[jooZj^[ojn_[on[Zj_oOgmooiNGU
onWYjOoDe=@2on[ZjPCojn_[00Koh>3PomGEeOo[jn_oj^[Zon_[jooZj^X2on_[j`04on[Zj_o[jn_o
jn_[on[ZjPCojn_[0_oZj^X01?o[jn_oj^[Zon_[jooZj^X2on_[j`04on[Zj_o[jn_ojn_[on[ZjPCo
jn_[0_oZj^X01?o[jn_oj^[Zon_[jooZj^X2on_[j`04on[Zj_o[jn_ojn_[on[ZjPCojn_[0_oZj^X0
1?o[jn_oj^[Zon_[jooZj^X2on_[j`04on[Zj_o[jn_ojn_[on[ZjPCojn_[0_oZj^X01?o[jn_oj^[Z
on_[jooZj^X2on_[j`04on[Zj_o[jn_ojn_[on[ZjPCojn_[00[oHf=SofIVI_mYJFWoJf][ofi^K_m`
L73oLW9bog=cLomeMGGoMWIf0_mhN7P00omiNGWoNWYjogYjNP0BogYjNP00@OmmOGd03_mlO7coNg]k
og]kNomjNW[oN7QhogMgMomeMGGoM7Adog9bL_m_KfooKFe]ofYZJ_mXJ6SoI6AT4OoinOT01oln?Sko
3Ph>o`h>3_lD51Co>CTiogMgMoo^k^h00ooinOT05ooRh^;oDE5Ao`l?3ol^;Rko8R8Rol30`?oinOWo
h>3PodQ8B?l=3@go7AdMobPX:?oclo?onOWion;Rh_mBDU;o3`l?obd];OlR8R;o_knoooWinOm8B4So
PX:200;onOWi00KoOGemodY:B_oinOWonOWiok>c/olE5AD2ooWin@06odQ8B?mPH63o<30`obHV9_lQ
8B7o^[Zj0_oinOT02OoRh^;oDE5Aoa0@4?l^;Rko8R8Rokno_ooinOWoB4Q8oh:2PP19ooWin@0:ofAT
I?mXJ6SoJVYZofe]KOm_KfooLW9bogAdM?meMGGoMgMgogQhN0;oNWYj00?oNg]kogalO?mlO7`04_mm
OGd0047oPX:20_n1PH403?moOgooOWinogemOOmkNg_oNWYjogQhN?mfMWKoLg=cog5aLOm^KVkoJf][
ofMWI`gooooo023oo_knooooooooooooo_knod51@OmlO7coooooooGemOo?clooCdm?obd];OoalO7o
o_knoooooom>CTkoBd];on3Ph?oooooolo?coo;bl_ono_koCDe=ocPh>?o=cLgoooooom[Jf_olo?co
ooooodi>C_m;Bd_oh>3Pooooo`;olo?c00?oooooodY:B_n6QXH00_ooool06_n1PH7oCTi>ookno_on
o_ko^;RhoaLG5oooooooo_knod];Bom=CDgol?3`oo_knon3Ph?o820Poo?cloooooooCTi>od];BooP
h>3oo_knoo?cloobl_;oooooodY:B_n6QXKoo_kn0_ooool2ooknoPCooooo0_ono_h01_ooooooo_kn
ooooooono_koooooooknoP;ooooo0_ono_h4ooooo`;oo_kn00Koooooookno_ooooooo_knooooooon
o_h2ooooo`;oo_kn1?ooool2ooknoP06ooooooono_koooooookno_ooooooo_kn0_ooool2ooknoPCo
oooo0_ono_h>ooooo`0<ofMWIomZJV[oKVi^og5aLOmcLg?oMWIfogQhN?mjNW[oO7alogemOOmnOWko
Ogmo0_n1PH4Coh:2PP00@OmmOGd03_mlO7coNg]kog]kNomjNW[oN7QhogMgMomeMGGoLg=cog5aLOm_
KfooK6a/ofUYJOmWIfOoI6AT3?oinOT01oohn?SonOWiooShn?oinOWon?Shoclo?omgMgL00_ohn?P0
4?oinOWom?CdobTY:OmeMGGon?ShomWIfOl=3@go]kNgooWinOohn?SonOWiooShn?oHf=So3@d=oiNG
Uoohn?P2ooWin@04ooShn?oIfMWo3@d=okNg]`;on?Sh00GonOWiooShn?oinOWoB4Q8oh:2PP02ooSh
n00NogemOOm;Bd_onOWiooShn?nc/k?o5ADEooWinOohn?SoAdM7oh:2P_ohn?SonOWion;Rh_l>3Pko
[:b/omWIfOl=3@go]kNgooWinOohn?SonOWiooShn?oinOWoB4Q8oh:2P_oinOWon?ShooWinOohn?So
nOWi0oohn?P2ooWin@04ooShn?oinOWon?ShooWin@;on?Sh00GonOWiooShn?oinOWon?ShooWin@03
ooShn0;onOWi00Con?ShooWinOohn?SonOWi0_ohn?P01OoinOWon?ShooWinOohn?SonOWi00?on?Sh
0_oinOT01?ohn?SonOWiooShn?oinOT2ooShn005ooWinOohn?SonOWiooShn?oinOT00oohn?PAooWi
n@0;ofATI?mWIfOoJVYZofa/K?m_KfooLG5aog=cLomeMGGoMgMgogQhN?miNGT00_mkNg/2ogalO1;o
OGem0012ogYjNP0=ogUiNOmhN7SoMgMgogIfM_meMGGoLg=cog5aLOm_KfooKFe]ofYZJ_mXJ6SoIFEU
of9RHP02on[ZjP03on_[jooZj^[ojn_[00;oj^[Z00?ojn_[on[Zj_o[jn/00_oZj^X02?o[jn_oj^[Z
on[Zj_oZj^[ojNWYoc/k>omaLG7ojNWY0_oZj^X03_oYjNWoN7QhobXZ:_oZj^[o/K6ao`d=3Om2@T;o
A4A4od=3@om4A4Co][Jfok6a/Ol=3@go_[jn0_oZj^X01OoYjNWoj^[Zok6a/Ol=3@go@D5100?oA4A4
013o][Jfon[Zj_m3@d?oNg]kon[Zj_oYjNWoMgMgodI6A_oYjNWoj^[ZojRXZ?lE5AGojNWYon[Zj_m4
A4CoNg]k0_oZj^X03OoYjNWo7alOohZ:R_na/K7o3@d=od51@Om3@d?oA4A4od=3@ong]kOojNWYodA4
A?mkNg/00ooZj^X01?oYjNWoj^[Zon[Zj_oYjNT2on[ZjP05onWYjOoZj^[oj^[Zon[Zj_oYjNT01OoZ
j^X01?oYjNWoj^[Zon[Zj_oYjNT2on[ZjP05onWYjOoZj^[oj^[Zon[Zj_oYjNT01OoZj^X01?oYjNWo
j^[Zon[Zj_oYjNT2on[ZjP05onWYjOoZj^[oj^[Zon[Zj_oYjNT01OoZj^X01?oYjNWoj^[Zon[Zj_oY
jNT2on[ZjP05onWYjOoZj^[oj^[Zon_[jooZj^X00oo[jn/05OoZj^[ojn_[on[Zj_oZj^[ojn_[on[Z
j_o[jn_oj^[Zof9RH_mUIFGoJ6QXof][Jom]KFgoKfm_og5aLOmcLg?oMGEeogIfM_mgMgOoN7QhogUi
N@0DogYjNP00@OmmOGd03_mlO7coNg]kog]kNomjNW[oN7QhogMgMomeMGGoLg=cog5aLOm_KfooK6a/
ofYZJ_mVIVKoHf=S3?oinOT00oohn?SonOWiooShn002ooWin@0Uochn?_mgMgOonOWiooWinOohn?So
nOWioijNW_l?3`oolo?comOGeol=3@goZZZZol_;boo4a<Co3`l?on7QhOoGemOo3@d=oi>CTooinOWo
n?ShooWinOohn?Soe]KFo`d=3OnZZZ[obl_;olC4a?l?3`ooh>3PooWinOm8B4SoLG5aooShn?oinOWo
O7aloc`l?002ooShn00Gok6a/OlE5AGonOWiooShn?m7AdOoOGemooShn?oinOWoj>SXo`d=3Oo1`L7o
emOGo`d=3OnZZZ[oc<c<olG5aOl?3`ooh>3PooWinOm7AdOoKFe]ooWinOohn?P00ooinOT01Oohn?So
nOWiooWinOohn?SonOWi00;on?Sh0_oinOT2ooShn003ooWinOohn?SonOWi00;onOWi00Gon?ShooWi
nOoinOWon?ShooWin@02ooShn0;onOWi0_ohn?P00ooinOWon?ShooWin@02ooWin@05ooShn?oinOWo
nOWiooShn?oinOT00_ohn?P2ooWin@;on?Sh00?onOWiooShn?oinOT00_oinOT01Oohn?SonOWiooWi
nOohn?SonOWi00;on?Sh3OoinOT02omSHf?oIVIVofUYJOm/K6coKfm_og5aLOmcLg?oMGEeogMgMomh
N7SoNWYj00;oNg]k00?oO7alogemOOmmOGd04OmmOGd0047oPX:20_n1PH403?moOgooOWinogemOOmk
Ng_oNWYjogQhN?meMGGoLg=cog1`L?m]KFgoJVYZofIVIPkooooo00Goo_knooooooono_ko@D51og]k
N`04ooknoP09oiJFU_lC4a?on_[joooooom9BDWoLg=cooOgmonSXj?o=cLg00;oo_kn02koBTY:oc<c
<oo1`L7ooOgmomoOgoono_koooooodU9BOmcLg?om_Kfoj>SXolg=cOoo_knoooooom:BT[o8B4Qoi:B
T_oXj>SoBDU9ob/[:omXJ6Sohn?SogUiNOln?Skoooooookno_m;Bd_o:2PXoibLW?oMgMgoLG5aoahN
7_okno_oo_knodU9BOmcLg?om_Kfoj>SXolg=cOoo_knoooooom:BT[o820PoiNGUooUiNGooOgm2?on
o_h00oooooooo_knooooo`02ooknoP03ooooooono_kooooo00Soo_kn00?oooooookno_ooool00_on
o_h00oooooooo_knooooo`08ooknoP03ooooooono_kooooo00;oo_kn00?oooooookno_ooool02?on
o_h00oooooooo_knooooo`0;ooooo`0<ofIVI_mZJV[oKVi^og1`L?mcLg?oMGEeogQhN?mjNW[oNg]k
ogemOOmnOWkoOgmo0_n1PH4Coh:2PP00@OmmOGd03_mlO7coNg]kog]kNomjNW[oN7QhogMgMomeMGGo
Lg=cog5aLOm_KfooK6a/ofUYJOmVIVKoHf=S1_oinOT00oojn_[onOWiooWin@04ooWin@07ooShn?oi
nOWon?ShooShn?lo?cooN7QhooShn003ooWin@0boeQHF?lf=SKon?ShooShn?oQhN7oCTi>oaPH6?lW
9bOo]KFeooShn?oinOWohn?SoeeMGOlK6a_o5aLGoc4a<Oohn?SonOWion3Ph?m>CTko6ATIobLW9one
]KGonOWiooShn?mJFU[oSXj>ogEeMOlK6a_o<S8bom7AdOnKVi_o92@TobXZ:_n/[:con?ShooWinOm7
AdOoOgmoof][JolH61So92@TojRXZ?oinOWon?Shon7QhOm>CTko6ATIobHV9_nf][H2ooShn006oe]K
Fon;Rh_oHV9RoaDE5OoZj^[on?Sh0_oinOT01_ohn?SonOWiooWinOoinOWon?ShooWin@;on?Sh00Co
nOWiooShn?ohn?SonOWi0_ohn?P2ooWin@06ooShn?oinOWonOWiooWinOohn?SonOWi0_ohn?P01?oi
nOWon?ShooShn?oinOT2ooShn0;onOWi00Kon?ShooWinOoinOWonOWiooShn?oinOT2ooShn004ooWi
nOohn?Son?ShooWin@;on?Sh0_oinOT01oohn?SonOWiooWinOoinOWon?ShooWinOohn?P03?oinOT0
3?mSHf?oIVIVofYZJ_m/K6coKfm_og5aLOmcLg?oMGEeogMgMomhN7SoNGUiog]kN`;oO7al4ommOGd0
04;oNWYj00goNGUiogQhN?mgMgOoMWIfogEeMOmcLg?oLG5aofm_Kom]KFgoJf][ofQXJ?mUIFGoHV9R
00;ojn_[00?oj^[Zon_[joo[jn/00_oZj^X4on_[j`Koj^[Z00So>c/kog1`L?oZj^[oj^[ZonWYjOnF
UYKo3@d=oiVIV@?oj^[Z00?ojNWYonOWiooZj^X01_oZj^X00ooWinOojNWYon[ZjP03on[ZjP03onOW
iooYjNWoj^[Z00Goj^[Z00KojNWYon[Zj_oYjNWojNWYon[Zj_oYjNT3on[ZjP04od=3@omkNg_oj^[Z
onSXj0Goj^[Z00?ojNWYonOWiooZj^X01?oZj^X00ooYjNWoj^[ZonOWi`06on[ZjP;ojNWY1OoZj^X0
0ooYjNWoj^[Zon[ZjP06on[ZjP;ojNWY1OoZj^X00ooYjNWoj^[Zon[ZjP06on[ZjP;ojNWY1OoZj^X0
0ooYjNWoj^[Zon[ZjP06on[ZjP;ojNWY0ooZj^X2on_[j`04on[Zj_o[jn_ojn_[on[ZjP;ojn_[017o
j^[Zon_[joo[jn_oj^[Zof9RH_mUIFGoJ6QXofYZJ_m]KFgoKfm_og5aLOmcLg?oMGEeogIfM_mgMgOo
N7QhogUiN@0DogYjNP00@OmmOGd2ogalO00<og]kNomiNGWoN7QhogMgMomeMGGoLg=cog5aLOm_Kfoo
K6a/ofUYJOmVIVKoHf=S3OoinOT2ooShn00>ooWinOohn?So?ShnocLg=omYJFWoEUIFocHf=_lC4a?o
TI6AooOgmoohn?SonOWiooShn?oinOT2ooShn003ooWinOohn?Son?Sh00;on?Sh00?onOWiooShn?oi
nOT00oohn?P00ooinOWon?ShooWin@02ooShn003ooWinOohn?Son?Sh00;on?Sh00?onOWiooShn?oi
nOT00oohn?P01_oinOWon?ShodQ8B?n2PX;on?ShooWin@Con?Sh00?onOWiooShn?oinOT00oohn?P0
0ooinOWon?ShooWin@02ooShn003ooWinOohn?Son?Sh00;on?Sh00?onOWiooShn?oinOT00oohn?P0
0ooinOWon?ShooWin@02ooShn003ooWinOohn?Son?Sh00;on?Sh00?onOWiooShn?oinOT00oohn?P0
0ooinOWon?ShooWin@02ooShn003ooWinOohn?Son?Sh00;on?Sh00?onOWiooShn?oinOT00oohn?P0
0ooinOWon?ShooWin@02ooShn003ooWinOohn?Son?Sh00;on?Sh00?onOWiooShn?oinOT00oohn?P<
ooWin@0>of=SHomVIVKoJFUYofa/K?m_KfooLG5aog=cLomeMGGoMgMgogQhN?miNGWoNWYjog]kNoml
O7`CogemO@00@On2PX82oh61P@0<oh20P?mnOWkoOGemog]kNomjNW[oN7QhogEeMOmcLg?oL71`ofi^
K_mZJV[oIVIV2oooool01?ono_koooooookno_ooool2ooknoP09okBd]?nOWiooWinOojJVY_o7alOo
jn_[ooooooono_kooooo00;oo_kn00?oooooookno_ooool00_ono_h02Oooooooo_knookno_ono_ko
ooooookno_ooooooo_knooooo`02ooknoP03ooooooono_kooooo00;oo_kn00Woooooookno_ono_ko
o_knooooooono_koooooookno_ooool00_ono_h00om;Bd_oQXJ6ooooo`02ooknoP09ooooooono_ko
o_knookno_ooooooo_knooooooono_kooooo00;oo_kn00?oooooookno_ooool00_ono_h02Ooooooo
o_knookno_ono_koooooookno_ooooooo_knooooo`02ooknoP03ooooooono_kooooo00;oo_kn00Wo
ooooookno_ono_koo_knooooooono_koooooookno_ooool00_ono_h00oooooooo_knooooo`02ookn
oP09ooooooono_koo_knookno_ooooooo_knooooooono_kooooo00;oo_kn00?oooooookno_ooool0
0_ono_h02?ooooooo_knookno_ono_koooooookno_ooooooo_kn0_ooool00oono_koooooooooo`08
ooooo`0<ofIVI_mZJV[oKFe]og1`L?mcLg?oMGEeogQhN?mjNW[oNg]kogemOOmnOWkoP8200_n1PH4C
oh:2PP00@OmmOGd03_mlO7coNg]kog]kNomiNGWoN7QhogMgMomeMGGoLg=cog5aLOm_KfooK6a/ofUY
JOmVIVKoHf=S3_oinOT01_ohn?SonOWiooShn?ohn?SonOWiooShn0;onOWi00?on?ShooWinOohn?P0
0_ohn?P01OoinOWon?ShooWinOohn?SonOWi00;on?Sh00KonOWiooShn?oinOWonOWiooShn?oinOT3
ooShn005ooWinOohn?SonOWiooShn?oinOT00_ohn?P01_oinOWon?ShooWinOoinOWon?ShooWin@?o
n?Sh00GonOWiooGemOogmoOon?ShooWin@02ooShn006ooWinOohn?SonOWiooWinOohn?SonOWi0ooh
n?P01OoinOWon?ShooWinOohn?SonOWi00;on?Sh00KonOWiooShn?oinOWonOWiooShn?oinOT3ooSh
n005ooWinOohn?SonOWiooShn?oinOT00_ohn?P01_oinOWon?ShooWinOoinOWon?ShooWin@?on?Sh
00GonOWiooShn?oinOWon?ShooWin@02ooShn006ooWinOohn?SonOWiooWinOohn?SonOWi0oohn?P0
1OoinOWon?ShooWinOohn?SonOWi00;on?Sh00KonOWiooShn?oinOWonOWiooShn?oinOT2ooShn0co
nOWi00coHf=SofIVI_mYJFWoK6a/ofm_KomaLG7oLg=cogEeMOmgMgOoN7QhogUiNOmkNg/2ogalO1?o
OGem0012ogYjNP0>ogUiNOmhN7SoMgMgogIfM_meMGGoLg=cog5aLOm_KfooKFe]ofYZJ_mXJ6SoIFEU
of9RH_oZj^X2on_[j`03on[Zj_o[jn_oj^[Z00Gojn_[1OoZj^X00ooYjNWoj^[Zon[ZjP08on[ZjP03
onWYjOoZj^[oj^[Z00;oj^[Z00?ojNWYon[Zj_oZj^X02?oZj^X00ooYjNWoj^[Zon[ZjP02on[ZjP03
onWYjOoZj^[oj^[Z00Soj^[Z00?ojNWYon[Zj_oZj^X00_oZj^X00ooYjNWoj^[Zon[ZjP08on[ZjP03
onWYjOoZj^[oj^[Z00;oj^[Z00?ojNWYon[Zj_oZj^X02?oZj^X00ooYjNWoj^[Zon[ZjP02on[ZjP03
onWYjOoZj^[oj^[Z00Soj^[Z00?ojNWYon[Zj_oZj^X00_oZj^X00ooYjNWoj^[Zon[ZjP08on[ZjP03
onWYjOoZj^[oj^[Z00;oj^[Z00?ojNWYon[Zj_oZj^X01_oZj^X00oo[jn_oj^[Zon[ZjP02on_[j`03
on[Zj_o[jn_oj^[Z00;ojn_[013oj^[Zon_[jooZj^[oHV9RofEUIOmXJ6SoJf][ofe]KOm_KfooLG5a
og=cLomeMGGoMWIfogMgMomhN7SoNGUi5?mjNWX0047oOGem00koO7alog]kNomkNg_oNGUiogQhN?mg
MgOoMGEeog=cLomaLG7oKfm_ofa/K?mYJFWoIVIVof=SH`conOWi0_ohn?P00ooinOWon?ShooWin@02
ooShn0?onOWi1?ohn?P2ooWin@;on?Sh00?onOWiooShn?oinOT00_ohn?P3ooWin@Con?Sh0_oinOT2
ooShn003ooWinOohn?SonOWi00;on?Sh0ooinOT4ooShn0;onOWi0_ohn?P00ooinOWon?ShooWin@02
ooShn0?onOWi1?ohn?P2ooWin@;on?Sh00?onOWiooShn?oinOT00_ohn?P3ooWin@Con?Sh0_oinOT2
ooShn003ooWinOohn?SonOWi00;on?Sh0ooinOT4ooShn0;onOWi0_ohn?P00ooinOWon?ShooWin@02
ooShn0?onOWi1?ohn?P2ooWin@;on?Sh00?onOWiooShn?oinOT00_ohn?P3ooWin@?on?Sh3OoinOT0
2_mSHf?oIVIVofUYJOm/K6coKfm_og5aLOmcLg?oMGEeogMgMomhN7P2ogYjNP05og]kNomlO7coOGem
ogemOOmlO7`04?mmOGd0047oPX:20_n1PH403?moOgooOWinogemOOmkNg_oNWYjogQhN?meMGGoLg=c
og1`L?m]KFgoJVYZofMWI`[ooooo00Goo_knooooooono_koo_knooooo`04ooknoP05ooooooono_ko
ooooookno_ooool00oono_h01?ooooooo_knookno_ooool4ooknoP05ooooooono_koooooookno_oo
ool00oono_h01?ooooooo_knookno_ooool4ooknoP05ooooooono_koooooookno_ooool00oono_h0
1?ooooooo_knookno_ooool4ooknoP05ooooooono_koooooookno_ooool00oono_h01?ooooooo_kn
ookno_ooool4ooknoP05ooooooono_koooooookno_ooool00oono_h01?ooooooo_knookno_ooool4
ooknoP05ooooooono_koooooookno_ooool00oono_h01?ooooooo_knookno_ooool4ooknoP05oooo
ooono_koooooookno_ooool00oono_h01?ooooooo_knookno_ooool4ooknoP08ooooooono_kooooo
ookno_ooooooo_knooooooono_h;ooooo`0<ofIVI_mZJV[oKFe]og1`L?mcLg?oMGEeogQhN?mjNW[o
O7alogemOOmnOWkoOgmo0_n1PH4Coh:2PP00@OmmOGd2ogalO0;oNWYj00[oN7QhogMgMomeMGGoLg=c
og5aLOm_KfooK6a/ofYZJ_mVIVKoHf=S3OoinOT2ooShn007ooWinOohn?SonOWiooWinOohn?SonOWi
ooShn002ooWin@03ooShn?oinOWon?Sh00;onOWi0_ohn?P01ooinOWon?ShooWinOoinOWon?ShooWi
nOohn?P00_oinOT00oohn?SonOWiooShn002ooWin@;on?Sh00OonOWiooShn?oinOWonOWiooShn?oi
nOWon?Sh00;onOWi00?on?ShooWinOohn?P00_oinOT2ooShn007ooWinOohn?SonOWiooWinOohn?So
nOWiooShn002ooWin@03ooShn?oinOWon?Sh00;onOWi0_ohn?P01ooinOWon?ShooWinOoinOWon?Sh
ooWinOohn?P00_oinOT00oohn?SonOWiooShn002ooWin@;on?Sh00OonOWiooShn?oinOWonOWiooSh
n?oinOWon?Sh00;onOWi00?on?ShooWinOohn?P00_oinOT2ooShn007ooWinOohn?SonOWiooWinOoh
n?SonOWiooShn002ooWin@03ooShn?oinOWon?Sh00;onOWi0_ohn?P01ooinOWon?ShooWinOoinOWo
n?ShooWinOohn?P00_oinOT00oohn?SonOWiooWin@0;ooWin@0;of=SHomVIVKoJFUYofa/K?m_Kfoo
LG5aog=cLomeMGGoMgMgogQhN?miNGT00_mkNg/00omlO7coOGemogemO@0AogemO@00@_mjNWX03omi
NGWoN7QhogMgMomfMWKoMGEeog=cLomaLG7oKfm_ofe]KOm[Jf_oJ6QXofEUIOmRHV;ojn_[on[ZjP04
on_[j`;oj^[Z00?ojn_[on[Zj_o[jn/03?oZj^X00ooYjNWoj^[Zon[ZjP03on[ZjP03omWIfOoLg=co
j^[Z00Ooj^[Z00?ojNWYon[Zj_oZj^X00_oZj^X00ooPh>3oe]KFon[ZjP08on[ZjP03onWYjOoZj^[o
j^[Z00?oj^[Z00Gog]kNonCTi?oYjNWodm?ConWYj@05on[ZjP03omoOgooEeMGoj^[Z00goj^[Z00?o
jNWYon[Zj_oZj^X03OoZj^X00ooYjNWoj^[Zon[ZjP0=on[ZjP03onWYjOoZj^[oj^[Z00goj^[Z00Go
jNWYon[Zj_oZj^[ojn_[on[ZjP02on_[j`04on[Zj_o[jn_ojn_[on[ZjPCojn_[00goHV9RofEUIOmX
J6SoJVYZofe]KOm_KfooLG5aog=cLomeMGGoMWIfogMgMomhN7SoNGUi01CoNWYj0011ogemO@0>ogal
O?mkNg_oNg]kogUiNOmhN7SoMgMgogEeMOmcLg?oLG5aofm_Kom/K6coJFUYofMWIomSHf<<ooWin@07
ooShn?oinOWon?ShooShn?oinOWo?ShnojFUY@03ooShn00Bokno_ol>3PkoVi^KooShn?oinOWoemOG
ocdm?OlI6AWo61PHod51@OoHf=Son?ShooWinOohn?SoP820o`d=3OoHf=SonOWi0_ohn?P02OoRh^;o
DE5Ao`l?3ol];Bgo8R8Rokno_ooinOWoAdM7oh:2PP02ooShn00>ogemOOm;Bd_onOWiooShn?nb/[;o
5ADEooWinOohn?SoB4Q8oemOGol`<33o9RHVob0P8?nj^[X2ooShn009on;Rh_mADE7o410@obd];OlQ
8B7o_knoooWinOm7AdOoPX:200;on?Sh00?onOWiooShn?oinOT00oohn?P2ooWin@;on?Sh0_oinOT0
1oohn?SonOWiooShn?ohn?SonOWiooShn?oinOT00oohn?P2ooWin@;on?Sh0_oinOT01oohn?SonOWi
ooShn?ohn?SonOWiooShn?oinOT00oohn?P2ooWin@;on?Sh0_oinOT01oohn?SonOWiooShn?ohn?So
nOWiooShn?oinOT00oohn?P2ooWin@;on?Sh3?oinOT02_mSHf?oIfMWofUYJOm/K6coKfm_og5aLOmc
Lg?oMGEeogMgMomhN7P2ogYjNP03og]kNomlO7coO7al01;oOGem0011oh:2PP;oPH6100coOgmoogin
O_mmOGgoNg]kogYjN_mhN7SoMGEeog=cLom`L73oKFe]ofYZJ_mVIVH;ooooo`04ookno_ooooooo_kn
ooooo`;oo_kn01Ko@D51ojZZZ_ono_koo_knooKfm_la<C7o3Ph>oj2PX?ono_kooOgmoclo?omLG5co
k^k^ono_komNGUko@410oogmoOoooooooOgmob/[:olR8R;oPH610oono_h02Om>CTkoBTY:on3Ph?on
o_kolo?coo;bl_ono_koBTY:ohJ6QP02ooknoP0Joh61POm=CDgoo_knookno_ng]kOo5aLGookno_oo
ooooBTY:odi>C_o_knoon_[johB4Q?lQ8B7olo?cookno_m?CdooBTY:on3Ph?ono_kolo?coo;bl_on
o_koBd];ohJ6Q_ooool3ooknoP04ooooooono_koo_knooooo`Koo_kn00?oooooookno_ooool00oon
o_h01?ooooooo_knookno_ooool6ooknoP03ooooooono_kooooo00?oo_kn00Coooooookno_ono_ko
oooo1_ono_h00oooooooo_knooooo`03ooknoP04ooooooono_koo_knooooo`Coo_kn00?oooooookn
o_ooool02Oooool03?mWIfOoJVYZofi^K_m`L73oLg=cogEeMOmhN7SoNWYjogalO?mmOGgoOWinogmo
O`;oPH614on2PX80047oOGem00koO7alog]kNomkNg_oNWYjogQhN?mgMgOoMGEeog=cLomaLG7oKfm_
ofa/K?mYJFWoIVIVof=SH`conOWi00Oon?ShooWinOohn?SonOWiooShn?lo?cooY:BT00;on?Sh01ko
NGUioahN7_le=CGoVi^KooShn?oDe=Co3@d=okFe]OoinOWon?ShokJf]_l=3@gof=SHooShn?nm_Kgo
5QHFok>c/olT92ComOGeooWinOoHf=So3Ph>okJf]_ohn?SonOWiooShn?oinOWon?ShodQ8B?n2PX82
ooShn006oginO_m;Bd_on?ShooWinOnc/k?o5ADE0_ohn?P05Om8B4SoPX:2ooWinOohn?Soh^;Ro`d=
3On/[:cof=SHo`d=3Ong]kOon?ShooWinOohn?SonOWiooShn?m7AdOoPX:2ooShn?oinOWon?ShooWi
n@03ooShn0;onOWi00Con?ShooWinOohn?SonOWi0_ohn?P01OoinOWon?ShooWinOohn?SonOWi00?o
n?Sh0_oinOT01?ohn?SonOWiooShn?oinOT2ooShn005ooWinOohn?SonOWiooShn?oinOT00oohn?P2
ooWin@04ooShn?oinOWon?ShooWin@;on?Sh00GonOWiooShn?oinOWon?ShooWin@03ooShn0;onOWi
00?on?ShooWinOoinOT03?oinOT02omSHf?oIVIVofYZJ_m/K6coKfm_og5aLOmcLg?oMGEeogMgMomh
N7SoNGUi00;oNg]k0_mlO7`BogemO@00@_mjNWX03OmiNGWoN7QhogMgMomfMWKoMGEeog=cLomaLG7o
Kfm_ofe]KOmZJV[oJ6QXofEUIOmRHV800_omoOd00oono_kooOgmooknoP02oogmo@03ookno_omoOgo
o_kn00KooOgm00goo?cloclo?onXZ:Soo?clol_;bol@413oYZJVodQ8B?nNWYkooOgmokno_ol=3@go
i^KV00;ooOgm00goi>CTo``<3?o2`/;ooOgmofMWIomUIFGooOgmoc0`<?nc/k?oo?clol30`?l<30co
ATI600?oB4Q800coa/K6ooclo?m9BDWoQ8B4ooclo?omoOgoOgmood];BoomoOgoo?clokNg]olE5AD2
oogmo@0:odU9BOn4Q8CooOgmooclo?omoOgo8R8RoiFEUOo0`<3o3@d=odI6AP?oB4Q800CoaLG5oogm
oOm9BDWoQ8B40_omoOd01?olo?cooOgmoogmoOolo?`2oogmo@05ooclo?omoOgoo?cloogmoOolo?`0
1OomoOd01?olo?cooOgmoogmoOolo?`2oogmo@05ooclo?omoOgoo?cloogmoOolo?`01OomoOd01?ol
o?cooOgmoogmoOolo?`2oogmo@05ooclo?omoOgoo?cloogmoOolo?`01OomoOd01?olo?cooOgmoogm
oOolo?`2oogmo@03ooclo?omoOgoo?cl00?ooOgm0_ono_h05OomoOgoo_knoogmoOomoOgoo_knoogm
oOono_kooOgmof9RH_mUIFGoJ6QXof][Jom]KFgoKfm_og5aLOmcLg?oMGEeogIfM_mgMgOoN7QhogUi
N@0DogYjNP00@OmmOGd03_mlO7coNg]kog]kNomjNW[oN7QhogMgMomeMGGoLg=cog5aLOm_KfooK6a/
ofYZJ_mVIVKoHf=S3?oinOT00oohn?SonOWiooShn002ooWin@0Rochn?_nUYJGom?CdocHf=_mADE7o
nOWiodM7AonKVi_onOWiomSHf?l=3@go/[:booWinOohn?So/K6ao`h>3_oLg=cok^k^oaLG5onk^k_o
n?Shohf=SOmBDU;on?ShomOGeol=3@goZZZZol_;boo5aLGo3`l?on3Ph?oinOWoB4Q8og5aL@;onOWi
00KoO7alocdm?OogmoOon?Shok:b/_lE5AD2ooShn00BodM7AommOGgonOWiooWinOoXj>So3@d=ol71
`OoGemOo3@d=oj^[Zoo;bl_oa<C4o`l?3ooPh>3on?ShodM7Aom]KFgon?Sh0ooinOT01Oohn?SonOWi
ooWinOohn?SonOWi00;on?Sh0_oinOT2ooShn003ooWinOohn?SonOWi00;onOWi00Gon?ShooWinOoi
nOWon?ShooWin@02ooShn0;onOWi0_ohn?P00ooinOWon?ShooWin@02ooWin@05ooShn?oinOWonOWi
ooShn?oinOT00_ohn?P2ooWin@;on?Sh00?onOWiooShn?oinOT00_oinOT01Oohn?SonOWiooWinOoh
n?SonOWi00;on?Sh3OoinOT02omSHf?oIVIVofUYJOm/K6coKfm_og5aLOmcLg?oMGEeogMgMomhN7So
NWYj00;oNg]k00?oO7alogemOOmmOGd04OmmOGd0047oPX:20_n1PH403?moOgooOWinogemOOmkNg_o
NWYjogQhN?meMGGoLg=cog1`L?m]KFgoJVYZofIVIPkok>c/04?ojn_[onc/k?o[jn_o?3`loifMWOml
O7co6ATIom?Cdoo[jn_oADE5oiBDU?o[jn_ok>c/odE5AOm<C4coclo?olg=cOm<C4coB4Q8on_[jonJ
VY[o:2PXon[Zj_o[jn_of=SHoaDE5OoBd];ojn_[odE5AOmZJV[oi>CToiNGUolc<c?ok>c/on_[jom4
A4Co820PohN7QooFe]KoADE5obPX:?mQHF7od];Bog1`L?lk>c_ojn_[onc/k?m5ADGo9BDUoi6ATOo<
c<coJ6QXoa`L7?oXj>Sojn_[odE5AOmZJV[oi>CToiNGUolc<c?ok>c/on_[jom5ADGo7alOoh^;RooD
e=CojNWY00Kojn_[0_o/k>`00oo[jn_ok>c/on_[j`02onc/k003on_[joo/k>cojn_[00Kojn_[0_o/
k>`00oo[jn_ok>c/on_[j`02onc/k003on_[joo/k>cojn_[00Kojn_[0_o/k>`00oo[jn_ok>c/on_[
j`02onc/k003on_[joo/k>cojn_[00Kojn_[0_o/k>`00oo[jn_ok>c/onc/k00:onc/k00<ofIVI_mZ
JV[oKVi^og1`L?mcLg?oMGEeogQhN?mjNW[oNg]kogemOOmnOWkoOgmo0_n1PH4Coh:2PP00@OmmOGd0
3_mlO7coNg]kog]kNomjNW[oN7QhogMgMomeMGGoLg=cog5aLOm_KfooK6a/ofUYJOmVIVKoHf=S1_oi
nOT00oojn_[onOWiooWin@04ooWin@08ooShn?oinOWon?ShooShn?lo?cooO7aloa4A4OnIVIT2ooWi
n@0=odM7AonKVi_on?ShooShn?oShn?oF5QHoaXJ6_lK6a_oFUYJonCTi?oinOWoHF5QohR8R003ooWi
n@08ofIVI_nEUIGon?Shon7QhOm>CTko61PHobHV9_nf][H2ooShn00Poe]KFon>SXkoM7Adoa`L7?lb
<S;odM7AoiZJV_lU9BGo:RXZojb/[?oinOWon?ShodM7AomoOgooJVYZoaPH6?lT92CoZ:RXooShn?oi
nOWohN7Qodm?ColH61So9bLWokFe]Oohn?SonOWioeYJF_n;Rh_oHf=Soa@D5?oZj^X2ooWin@06ooSh
n?oinOWonOWiooWinOohn?SonOWi0_ohn?P01?oinOWon?ShooShn?oinOT2ooShn0;onOWi00Kon?Sh
ooWinOoinOWonOWiooShn?oinOT2ooShn004ooWinOohn?Son?ShooWin@;on?Sh0_oinOT01_ohn?So
nOWiooWinOoinOWon?Sh0?Win@80n?Sh00<0nOWi0?Shn03hn?P00`3oool20?Win@070?Shn03inOT0
nOWi0?Win@3hn?SonOWiooShn00<ooWin@0<of=SHomVIVKoJVYZofa/K?m_KfooLG5aog=cLomeMGGo
MgMgogQhN?miNGWoNg]k0_mlO7`CogemO@00@_mjNWX03OmiNGWoN7QhogMgMomfMWKoMGEeog=cLoma
LG7oKfm_ofe]KOm[Jf_oJ6QXofEUIOmRHV800_ono_h00oomoOgoo_knoogmo@02oogmo@;oo_kn00?o
oOgmookno_omoOd01OomoOd01?m0@43o4A4AodU9BOomoOd2ooclo003odQ8B?nOWioooOgm00;ooOgm
0oolo?`6oogmo@;oo?cl1OomoOd00oojn_[ooOgmoogmo@05oogmo@?oo?cl0_omoOd02?olo?cooOgm
oogmoOolo?coBDU9ohF5QOomoOgono_k1?omoOd2ooclo003oo[jn_omoOgooOgm00;ooOgm00Coo?cl
oogmoOomoOgon_[j1OomoOd2ooclo0GooOgm00?oo?cloogmoOomoOd01_omoOd2ooclo0GooOgm00?o
o?cloogmoOomoOd01_omoOd2ooclo003oogmo@3moOd0oOgm0080oOgm00D0o?cl0?ooo`0000000000
0?ooo`040?gmo@80o?cl00@0oOgmoogmoOomoOgoo_kn0_omoOd2ooknoP05oogmoOono_koo_knoogm
oOono_h00_omoOd03OmRHV;oIFEUofQXJ?mZJV[oKFe]ofm_KomaLG7oLg=cogEeMOmfMWKoMgMgogQh
N?miNGT05?mjNWX0047oOGem0_mlO7`03?mkNg_oNGUiogQhN?mgMgOoMGEeog=cLomaLG7oKfm_ofa/
K?mYJFWoIVIVof=SH`gonOWi0_ohn?P03_oinOWon?Shochn?_lD51CoemOGooWinOohn?SonOWiodI6
A_nKVi_on?ShooWinOohn?SonOWi0_ohn?P00ooinOWon?ShooShn002ooShn003ooWinOohn?SonOWi
00?on?Sh00?onOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn003ooWinOohn?SonOWi
00?on?Sh00KonOWiooShn?oinOWoAdM7oh:2P_oinOT4ooShn003ooWinOohn?SonOWi00?on?Sh00?o
nOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn003ooWinOohn?SonOWi00?on?Sh00?o
nOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn003ooWinOohn?SonOWi00?on?Sh00?o
nOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn00:ooWinOohn?SonOWiooShn03oool0
n?Sh0?Win@3hn?P0nOWi0?ooo`80000000P0oooo0?Shn03hn?P0n?Sh0?Win@3hn?P0nOWi0?Shn0;o
n?Sh3?oinOT03_mSHf?oIVIVofUYJOm/K6coKfm_og5aLOmcLg?oMGEeogMgMomhN7SoNGUiogYjN_mk
Ng_oO7al4ommOGd0047oPX:20_n1PH403?n0P83oOWinogemOOmkNg_oNWYjogQhN?meMGGoLg=cog1`
L?m^KVkoJVYZofIVIP_ok>c/00Sojn_[onc/k?o[jn_ok>c/on_[joo/k>coYjNWok>c/`;ojn_[00Co
k>c/on_[jonZZZ[ob/[:0_o/k>`01Oo[jn_ok>c/on_[joo/k>cojn_[00;ok>c/0oo[jn/01?o/k>co
jn_[onc/k?o[jn/2onc/k005on_[joo/k>cojn_[onc/k?o[jn/00_o/k>`3on_[j`04onc/k?o[jn_o
k>c/on_[j`;ok>c/00Gojn_[onc/k?m5ADGoOGemon_[j`02onc/k0?ojn_[00Cok>c/on_[joo/k>co
jn_[0_o/k>`01Oo[jn_ok>c/on_[joo/k>cojn_[00;ok>c/0oo[jn/01?o/k>cojn_[onc/k?o[jn/2
onc/k005on_[joo/k>cojn_[onc/k?o[jn/00_o/k>`3on_[j`04onc/k?o[jn_ok>c/on_[j`;ok>c/
00Gojn_[onc/k?o[jn_ok>c/on_[j`02onc/k0?ojn_[00?ok>c/on_[joo/k>`00P3oool00`3/k>`0
jn_[0?ooo`02000000030?ooo`3/k>`0k>c/00<0jn_[00@0k>c/0>_[j`3/k>cojn_[0oo/k>`00oo]
kNgok>c/onc/k007onc/k00<ofIVI_mZJV[oKFe]og1`L?mcLg?oMGEeogQhN?mjNW[oNg]kogemOOmn
OWkoP8200_n1PH4Coh:2PP00@OmmOGd03_mlO7coNg]kog]kNomiNGWoN7QhogMgMomeMGGoLg=cog5a
LOm_KfooK6a/ofUYJOmVIVKoHf=S3_oinOT01_ohn?SonOWiooShn?ohn?SonOWiooShn0;onOWi00?o
n?ShooWinOohn?P00_ohn?P01OoinOWon?ShooWinOohn?SonOWi00;on?Sh00KonOWiooShn?oinOWo
nOWiooShn?oinOT3ooShn005ooWinOohn?SonOWiooShn?oinOT00_ohn?P01_oinOWon?ShooWinOoi
nOWon?ShooWin@?on?Sh00GonOWiooShn?oemOGom_KfooWin@02ooShn006ooWinOohn?SonOWiooWi
nOohn?SonOWi0oohn?P01OoinOWon?ShooWinOohn?SonOWi00;on?Sh00KonOWiooShn?oinOWonOWi
ooShn?oinOT3ooShn005ooWinOohn?SonOWiooShn?oinOT00_ohn?P01_oinOWon?ShooWinOoinOWo
n?ShooWin@?on?Sh00GonOWiooShn?oinOWon?ShooWin@02ooShn00;ooWinOohn?SonOWiooWinOoh
n?SonOWi0?ooo`000000oooo0?Win@3oool00P0000001@3oool0n?Sh0?Shn03inOT0n?Sh0080nOWi
00@0n?Sh0?WinOohn?Son?Sh3?oinOT03?mSHf?oIVIVofUYJOm/K6coKfm_og5aLOmcLg?oMGEeogMg
MomhN7SoNGUiog]kN`;oO7al4ommOGd004;oNWYj00koNGUiogQhN?mgMgOoMWIfogEeMOmcLg?oLG5a
ofm_Kom]KFgoJVYZofQXJ?mUIFGoHV9Roogmo@;oo_kn0oomoOd4ooknoPKooOgm00Koo?cloogmoOom
oOgoo?cloogmoOolo?`5oogmo@03ooclo?omoOgooOgm00;ooOgm00Koo?cloogmoOomoOgoo?cloogm
oOolo?`5oogmo@03ooclo?omoOgooOgm00;ooOgm00Koo?cloogmoOomoOgoo?cloogmoOolo?`5oogm
o@03ooclo?omoOgooOgm00;ooOgm00Koo?cloogmoOomoOgoo?cloogmoOolo?`5oogmo@03ooclo?om
oOgooOgm00;ooOgm00Koo?cloogmoOomoOgoo?cloogmoOolo?`5oogmo@03ooclo?omoOgooOgm00;o
oOgm00Koo?cloogmoOomoOgoo?cloogmoOolo?`5oogmo@03ooclo?omoOgooOgm00;ooOgm00Koo?cl
oogmoOomoOgoo?cloogmoOolo?`2oogmo@040?ooo`00000000000?ooo`80000000<0oooo0?gmo@3l
o?`00P3moOd00`3lo?`0oOgm0?clo0020?gmo@CooOgm0_ono_h00oomoOgoo_knoogmo@02ooknoP?o
oOgm00goHV9RofEUIOmXJ6SoJf][ofe]KOm_KfooLG5aog=cLomeMGGoMWIfogMgMomhN7SoNGUi01Co
NWYj0011ogemO@0>ogalO?mkNg_oNg]kogUiNOmhN7SoMgMgogEeMOmcLg?oLG5aofm_Kom/K6coJFUY
ofIVI_mSHf<<ooWin@;on?Sh00?onOWiooShn?oinOT00_ohn?P3ooWin@Con?Sh0_oinOT2ooShn003
ooWinOohn?SonOWi00;on?Sh0ooinOT4ooShn0;onOWi0_ohn?P00ooinOWon?ShooWin@02ooShn0?o
nOWi1?ohn?P2ooWin@;on?Sh00?onOWiooShn?oinOT00_ohn?P3ooWin@Con?Sh0_oinOT2ooShn003
ooWinOohn?SonOWi00;on?Sh0ooinOT4ooShn0;onOWi0_ohn?P00ooinOWon?ShooWin@02ooShn0?o
nOWi1?ohn?P2ooWin@;on?Sh00?onOWiooShn?oinOT00_ohn?P3ooWin@;on?Sh00<0oooo00000000
00000`0000050?ooo`<0nOWi0P3hn?P00oohn?SonOWiooWin@0;ooWin@0:of=SHomVIVKoJFUYofa/
K?m_KfooLG5aog=cLomeMGGoMgMgogQhN0;oNWYj00GoNg]kogalO?mmOGgoOGemogalO00@ogemO@00
@On2PX82oh61P@0CogmoOomnOWkoOGemog]kNomjNW[oN7QhogEeMOmcLg?oL71`ofe]KOmZJV[oIfMW
od1e`_m0M<;o?gC1od1e`_loM<7o@7G2od1d`P03od1e`P05ocmd`Om0ML;o?gC1ocmd`Om0M<400olo
M<400oloLl7o?gC1ocmc`@05ocmd`@03ocmc`OloM<7o?gC100Go?gC100?o?g?1ocmd`OloLl401Olo
M<400oloLl7o?gC1ocmd`@05ocmd`@03ocmc`OloM<7o?g?100Go?gC100?o?g?1ocmd`OloM<401Olo
M<400oloLl7o?gC1ocmc`@05ocmd`@03ocmc`OloM<7o?gC100Go?gC100?o?g?1ocmd`OloLl401Olo
M<400oloLl7o?gC1ocmd`@05ocmd`@03ocmc`OloM<7o?g?100Go?gC100?o?g?1ocmd`OloM<401Olo
M<400oloLl7o?gC1ocmc`@03ocmd`@030?ooo`000000000000H0000000@0oooo03mc`@0oM<40?g?1
0P0oM<401P10M<7o?gC1od1d`OloM<7o@7G2od1d`PCo@7G2017o@7C2ocmd`Om0ML;o?gC1od1e`_mV
IVKoJVYZofe]KOm`L73oLg=cogEeMOmhN7SoNWYjogalO?mmOGgoOWinogmoO`02oh61PA?oPX:20011
ogemO@;oO7al0_mjNWX02omhN7SoMgMgogEeMOmcLg?oLG5aofm_Kom/K6coJVYZofIVI_mSHf?o@g[3
00;oA7[400Co@g[3odAja?m3N/?oA7[40_m3N/<01?m4N/Co@g[3od=j`om3N/<2od=i``07od=j`om2
NL;o@g[3od=j`om2NL;o@g[3od=i``02od=j``03od9i`_m3N/?o@WW200;o@g[300Co@WW2od=i`om3
N/?o@WW20_m3N/<00om2NL;o@g[3od=i``02od=j``03od9i`_m3N/?o@WW200;o@g[300Co@WW2od=i
`om3N/?o@WW20_m3N/<00om2NL;o@g[3od=i``02od=j``03od9i`_m3N/?o@WW200;o@g[300Co@WW2
od=i`om3N/?o@WW20_m3N/<00om2NL;o@g[3od=i``02od=j``03od9i`_m3N/?o@WW200;o@g[300Co
@WW2od=i`om3N/?o@WW20_m3N/<00om2NL;o@g[3od=i``02od=j``03od9i`_m3N/?o@WW200;o@g[3
00Co@WW2od=i`om3N/?o@WW20_m3N/<00om2NL;o@g[3od=i``02od=j``03od9i`_m3N/?o@WW200;o
@g[300Co@WW2od=i`om3N/?o@WW20_m3N/<00om2NL;o@g[3od=i``02od=j``030?ooo`0000000000
00D0000000H0oooo04=j``13N/<0@WW204=j``13NL<204=j``05od=i`om3N/?o@g[3od=j`om4N/@0
0_m3N/<04_m4N/Co@g[3odAja?m4N/Co@g[3odAja?m3N/?oHf=SofIVI_mYJFWoK6a/ofm_KomaLG7o
Lg=cogEeMOmgMgOoN7QhogUiN@;oNg]k00?oO7alogemOOmmOGd04OmmOGd004;oNWYj00goNGUiogQh
N?mgMgOoMWIfogEeMOmcLg?oLG5aofm_Kom]KFgoJf][ofQXJ?mUIFGoHV9R00;o?W?000Co?g?1ocic
`?loLl7o?g?10_lnLl000oloLl7o?W?0ocmc`@03ocic`008oceb_olnLl3o?W;0ocib_olnLl3o?W:o
oeN5aomIQ/P2oceb_`0>ocic`?lnL[oo?W?0ocib_olnLl3oBgc4odUj`olnLl3o?W;0ocib_olnLl3o
?W:ooe60aOloM<02oceb_`04ocic`?m<O<?oBG_4ocib_`;o?W?000Ko?G:oodQj`om1ML3o?W:ooe60
a_lnL[l2ocic`0;o?G:o00Co?W?0odEh`Om?OlGo?W:o0_lnLl001_lmL[oo?W?0ocib`?lnL[oo?W?0
ocib_`;o?W?00_lmL[l01?lnLl3o?W:oocic`?lnL[l2ocic`006oceb_olnLl3o?W;0ocib_olnLl3o
?W:o0_lnLl02oceb_`04ocic`?lnL[oo?W?0ocib_`;o?W?000Ko?G:oocic`?lnL/3o?W:oocic`?ln
L[l2ocic`0;o?G:o00Co?W?0ocib_olnLl3o?W:o0_lnLl001_lmL[oo?W?0ocib`?lnL[oo?W?0ocib
_`;o?W?00_lmL[l00`3oool0000000000004000000050?ooo`0nL/00?W:o03ic`00nL[l00P0nLl02
03eb_`04ocic`?lnL/3o?W?0ocic`0;o?g?100Ko?W?0ocmc`OlnLl3o?W?0ocmc`OlnLl02ocmc`@0=
of9RH_mUIFGoJ6QXofYZJ_m]KFgoKfm_og5aLOmcLg?oMGEeogIfM_mgMgOoN7QhogUiN@0DogYjNP00
@OmmOGd03omlO7coNg]kog]kNomiNGWoN7QhogMgMomeMGGoLg=cog5aLOm_KfooK6a/ofUYJOmWIfOo
Hf=SocQY_006ocMY_00AocQY_?lgJKco=fVlocQZ_?lgJKco=VRkocMY_?lgJK_o=VRkocMY_?lfJ;_o
OIgBonobn?oSj_Coh^Sdoo;en_n<Z=L00_lfJ;/0:OlgJKcoBWS2ol_Gk?omoOgoko;honK/m_llKKgo
=VRkoeV2aooPio?oiN_dofb@c?lgJK_oDWk4omCNkooam?Wom?Kjom3Kk_mAO<?o=fVkocIY^oo;enco
^<WVomoVl_oXkOKok?3gofZ?c?lfJ;_o=fVkodUf`Oo3d^Won__lon;Ym?oZkoOoIXc;ocMY^oo;f>co
VK?LocMY_?lfJ;_o=fVk00?o=VRk00go=fVkocMY_?lfJ;_o=VRkocMY_?lgJK_o=VRkocMY^olfJK_o
=VRkocMY_?lfJ;_o=fVk00?o=VRk00go=fVkocMY_?lfJ;_o=VRkocMY_?lgJK_o=VRkocMY^olfJK_o
=VRkocMY_?lfJ;_o=fVk00?o=VRk00go=fVkocMY_?lfJ;_o=VRkocMY_?lgJK_o=VRkocMY^olfJK_o
=VRkocMY_?lfJ;_o=fVk00?o=VRk00?o=fVkocMY_03oool01@0000001@3oool0=VRk03MY_00fJ;/0
=fVk00<0=VRk00@0=fVk03MY_?lgJ;_o=VRk1_lgJK`00olhJKco=fVlocMY_003ocMY_00:of=SHomW
IfOoJFUYofa/K?m_KfooLG5aog=cLomeMGGoMgMgogQhN0;oNWYj00?oNg]kogalO?mlO7`04_mmOGd0
047oPX:20_n1PH403OmoOgooOWinogemOOmkNg_oNWYjogQhN?meMGGoLg=cog1`L?m]KFgoJVYZofIV
I_loM<401_m0ML803OloM<7o@7G2od1e`_m0ML;o?gC1od1d`_loM<7o@7C1ocmd`OloLl7oPjGGooOi
o?meVm800_loM<400omYT/kok_7hoiVeg@02ocmd`@09olcIk_oMi_?oIHo=ocmd`OmMRL[o@7C1ocmd
`OnZ`>?ocM_^00?o?gC100Koe^7aol3Ajom;O<GoC7c5okk@jOoFhO42ocmd`@0BolkLk_o;fNgoBWc5
od9f`_nP^^3okoCjodQja?loM<7ob]S]olkLk_mGQLSo?gC1odMi`om9NlCo?gC1oloLkonN^Moo?g?1
1_loM<401OloLl7o?gC1ocmd`OloM<7o?g?100Co?gC100?o?g?1ocmd`OloM<401?loM<401OloLl7o
?gC1ocmd`OloM<7o?g?100Co?gC100?o?g?1ocmd`OloM<401?loM<401OloLl7o?gC1ocmd`OloM<7o
?g?100Co?gC100?o?g?1ocmd`OloM<401?loM<400oloLl40oooo00000003000000040?ooo`0oM<40
?gC103mc`@H0?gC100L0?g?1ocmd`OloM<7o@7C2ocmd`Om0ML;o@7C200;o@7G200?o?gC1od1e`_m0
ML800om0ML803?mWIfOoJVYZofi^K_m`L73oLg=cogEeMOmhN7SoNWYjogalO?mmOGgoOWinogmoO`;o
PH614on2PX80047oOGem013oO7alog]kNomkNg_oNWYjogQhN?mgMgOoMGEeog=cLomaLG7oKfm_ofa/
K?mYJFWoIVIVof=SHom3N/?oA7[40om3N/<2odAja00>od=j`om4N/Co@g[3odAja?m3N/?o@gW3od=j
`om3NL?o@g[3odIka?oZkoOo_m7Yod=i`om2NL82od=j``0^oi:afoodmo[oCh;6oef<boomoOgoT;3J
od=j`om2NL;o@g[3od=i`om3N/?oa=C[ojW2hom2NL;o@g[3oen=boomoOgoMikCod=i`om3N/?oMYkC
oogmoOmMRl_o@WW2olkKk_nP^n3o@g[3od9i`_mDQ/OooOgmognTeOmLRl_ooOgmogNMdom3NL?o@g[3
od=i`om2NL;o@g[3olkKk_nP^n3o@gW3od=j`om2NL;o@gW3od9i`P;o@g[300ko@gW3od=j`om3NL?o
@g[3od=i`om2NL;o@g[3od9i`_m3N/?o@gW3od=j`om2NL;o@gW3od9i`P;o@g[300ko@gW3od=j`om3
NL?o@g[3od=i`om2NL;o@g[3od9i`_m3N/?o@gW3od=j`om2NL;o@gW3od9i`P;o@g[300ko@gW3od=j
`om3NL?o@g[3od=i`om2NL;o@g[3od9i`_m3N/?o@gW3od=j`om2NL;o@gW3od9i`P;o@g[300?o@gW3
0?ooo`0000000P0000002@3oool0@g[3049i`P13N/<0@gW304=j``12NL80@gW3049i`P0204=j``04
04=i`om3N/?o@g[3odAja0;o@g[300GoA7[4od=j`om4N/Co@g[3odAja003od=j``0<odAja?mSHf?o
IVIVofYZJ_m/K6coKfm_og5aLOmcLg?oMGEeogMgMomhN7SoNGUi0_mkNg/2ogalO1;oOGem0012ogYj
NP0=ogUiNOmhN7SoMgMgogIfM_meMGGoLg=cog5aLOm_KfooKFe]ofYZJ_mXJ6SoIFEUof9RHP04ocic
`006ocmc`OlnLl3o?W?0ocmc`OlnLl3o?gC11?lnLl00?_lnL[oo?W?0oeb8bOomoOgoRZWHoceb_oln
Ll3o?W:ooceb_omDP/Ooo?clog6Hd?m]ULkooOgmof>=bolnLl3o?W:oocic`?lmL[oo?W:ool?Cj_nW
_^3o?W?0ocib_om]ULkooOgmodmoaOlnLl3o?G:ooe:1aOomoOgoK9C>ocib_oo=f^goW;OMocib_oln
Ll3o?G:ooncamon@[M[oKIG>oogmoOo>fngocM[]olcIk?o=f^goJY?>ocic`?o=f^goWKONoceb_oln
L[oo?W?0oceb_olnLl3o?W:ooceb_olnLl3o?G:oocic`?lmL[oo?W;00_lnLl003_lnL[oo?W?0oceb
_olnL[oo?W?0oceb_olnLl3o?W:ooceb_olnLl3o?G:oocic`?lmL[oo?W;00_lnLl003_lnL[oo?W?0
oceb_olnL[oo?W?0oceb_olnLl3o?W:ooceb_olnLl3o?G:oocic`?lmL[oo?W;00_lnLl002olnL[oo
?W?0oceb_olnL[oo?W?0oceb_olnLl3o?W:ooceb_olnLl00oooo008000000180oooo03ic`00nLl00
?W:o03ic`00mL[l0?W:o03ic`00mL[l0?W?003ib_`0mL[l0?W?0oceb_olnLl3o?W;0ocic`?loLl42
ocic`003ocmc`OlnLl3o?W?000;o?W?000oo?g?1ocic`?mRHV;oIFEUofQXJ?m[Jf_oKFe]ofm_Koma
LG7oLg=cogEeMOmfMWKoMgMgogQhN?miNGT05?mjNWX0047oOGem00ooO7alog]kNomkNg_oNWYjogQh
N?mgMgOoMGEeog=cLomaLG7oKfm_ofa/K?mZJV[oIVIVof=SHolhJ[`00_lgJK`01?lhJ[co=fVlocMY
_?lhJ[`5ocMY_00MocIX^olgJKco=VRkocMY^ombU<oooOgmoeAnaOlgJKco=fVkocIX^olgJKco>FZl
oogmoOn6Y=KoDWg4oogmoOn<Z=Oo=fVkocIX^olgJK_o=fVlocMY^oo1d>WoY;_PocMY^olfJ;_oDGg4
oogmoOmaTlh00_lgJK/07_mbULoooOgmodij`olfJ;_obmS/oinfg_lgJK_o=VVkodAc_oomoOgoIH_:
oe9na?omoOgoMiW@oe^4aomRRL[on__lodYg`_lgJK_obmO/oj^oh_lgJKco=fVkocIY^olgJKco=fVk
ocIX^olgJKco=VVkocIX^`;o=fVk0_lfJ;/03?lgJK_o=VRkocMY^olgJKco=fVkocIY^olgJKco=fVk
ocIX^olgJKco=VVkocIX^`;o=fVk0_lfJ;/03?lgJK_o=VRkocMY^olgJKco=fVkocIY^olgJKco=fVk
ocIX^olgJKco=VVkocIX^`;o=fVk0_lfJ;/03_lgJK_o=VRkocMY^olgJKco=fVkocIY^olgJKco=fVk
ocIX^olgJKco=VVk0?ooo`000000oooo0P0fJ;/0300gJK/0=VRk03MY^`0gJK`0=fVk03IY^`0gJK`0
=fVk03IX^`0gJK`0=fVkocIX^`Oo=fVl00Co>6ZlocMY_?lgJKco>6Zl0_lgJK`02omSHf?oIVIVofUY
JOm/K6coKfm_og5aLOmcLg?oMGEeogMgMomhN7SoNWYj00;oNg]k00?oO7alogemOOmmOGd04OmmOGd0
047oPX:20_n1PH404omoOgooOWinogemOOmkNg_oNWYjogQhN?meMGGoLg=cog1`L?m]KFgoJVYZofIV
I_m0M<;o?gC1od1e`_m0M<;o?gC1od1e`_m0M<800_m0ML800om0M<;o@7G2ocmd`@02od1d`@;o?gC1
00GoJI;>ookno_mORl_o?gC1ocmc`@02ocmd`@0Fof6<c?ooooooOJ7Docmd`Oo>fnkoh>WeofnGd?lo
M<7oF8K9ocmd`Om3M/;oamK/ojc3i?m6NL?o@WK2ocmd`Oo=fnkob=O]oeN6b?mIQ/Wob=O/ol_IkP;o
?gC100goc]c^onW_mon<ZmWoF8O9ojo5iOoam?Wo@GG1ocmd`Oo>g>ko[/CTodEg`on8Z=SogNKd00;o
?gC100Ooc]_^onodn_nA[m_oDh;6od1e`OloM<7o?g?100co?gC100Co?g?1ocmd`OloM<7o?g?13?lo
M<401?loLl7o?gC1ocmd`OloLl4<ocmd`@04ocmc`OloM<7o?gC1ocmc`@?o?gC10P3oool703md`@04
03mc`@0oM<40?gC103mc`@<0?gC100Co@7C1ocmd`Om0ML;o@7C10_m0ML805?m0M<;o@7G2od1d`_lo
M<7o@7G2od1d`_loM<7o@7G2ofIVI_mZJV[oKVi^og1`L?mcLg?oMGEeogQhN?mjNW[oNg]kogemOOmn
OWkoOgmo0_n1PH4Coh:2PP00@OmmOGd03omlO7coNg]kog]kNomjNW[oN7QhogMgMomeMGGoLg=cog5a
LOm_KfooK6a/ofUYJOmVIVKoHf=Sod9h`P02od=i``06od9h`_m3N<?o@gW3od=i`om2N<;o@gS30_m2
N<802Om3N<?o@WS2od9g`_m2N<;o@GO1odj0aOoko?goQZSGod9g`P03od9h`P0BoiNeg?omoOgoGhc;
od9g`_mBPlOo_LoYoo7dnOoemo[oh>Scod9g`_nP^n3omoWloo?fn_oYk_OoOZ;Eod9h`_mBPlKo`M;Y
0_oam?T02_nodN[oDX?7od9g`_m2N<;oc]_^oj:kh?ncb>KoloKjon[`m_n1YMH2od9h`P05oe>4aoo9
f>col_GionS^m_mgWM800_m2Ml801_nodN[oV;CMokS<ioofn?_oCGo5od9g`P?o@WS200Go@WO2od9h
`_m2Ml;o@WO2od9h`P02od9g`P03od9h`_m1Ml7o@WO200;o@WS200Ko@WO2od9h`_m2N<;o@WS2od9g
`_m2N<82od9g`P06od9h`_m2Ml;o@WO2od9h`_m1Ml7o@WO20_m2N<801_m2Ml;o@WS2od9h`_m2N<;o
@WO2od9h`P;o@WO200Ko@WS2od9g`_m2Ml;o@WS2od5g`Om2Ml82od9h`P06od9g`_m2N<;o@WS2od9h
`_m2Ml;o@WS20_m2Ml801_m2N<;o@WO2od9g`_m2N<;o@GO1od9g`P;o@WS200Wo@WO2od9h`_m2N<;o
@WS2od9g`_m2N<;o@WO2od9h`_m3NL<00_m2N<800om3N<?o@WS2od9h`P02od=i``0?od9h`_m3N<?o
@gW3of=SHomVIVKoJVYZofa/K?m_KfooLG5aog=cLomeMGGoMgMgogQhN?miNGWoNg]k00;oO7al4omm
OGd004;oNWYj00goNGUiogQhN?mgMgOoMWIfogEeMOmcLg?oLG5aofm_Kom]KFgoJf][ofQXJ?mUIFGo
HV9R00?o?W?000?o?g?0ocic`?lnLl000_lnLl001OloLl7o?W?0ocmd`OlnLl3o?W:o00;o?W?0017o
?W:oocib`?n`a>CofnCaodMi`olnL[oo?G:ood5e`?oDgnooa=CZocib_olnLl3o?W;0oceb_olnL/3o
@7C0ocib_`02ocib`003ol;Bj_nW_n7o?W:o00;o?G:o0_lnLl003?lnL[oo?W?0ocib`?lmL[oo?W;0
ocic`?o<f^goWKONocib`?loLkoo?W?0ocib_`;o?G:o0_lnLl003?loLkoo?W?0ocib`?lmL[oo?W;0
ocic`?lnL[oo?W;0od1c`?lnL[oo?W?0ocib_`;o?G:o0_lnLl001olnL[oo?W?0ocib`?lmL[oo?W;0
ocic`?lnL[l00_lnL/000olnL[oo?W?0ocib_`02oceb_`;o?W?000Oo?W:oocic`?lnL/3o?G:oocib
`?lnLl3o?W:o00;o?W;000?o?W:oocic`?lnL[l00_lmL[l2ocic`007ocib_olnLl3o?W;0oceb_oln
L/3o?W?0ocib_`02ocib`003ocib_olnLl3o?W:o00;o?G:o0_lnLl001olnL[oo?W?0ocib`?lmL[oo
?W;0ocic`?lnL[l00_lnL/000olnL[oo?W?0ocib_`02oceb_`Oo?W?000?o?g?1ocic`?lnLl000_ln
Ll004?loLl3o?W?0ocic`?mRHV;oIFEUofQXJ?mZJV[oKFe]ofm_KomaLG7oLg=cogEeMOmfMWKoMgMg
ogQhN?miNGTDogYjNP00@OmmOGd2ogalO00=og]kNomiNGWoN7QhogMgMomeMGGoLg=cog5aLOm_Kfoo
K6a/ofUYJOmVIVKoHf=Socmd`@02ocic`00:ocmc`OloM<7o?g?1ocmd`OlnLl3o?g?1ocic`?loM<7o
?W?0ocmc`@;o?W?000_o?g?0ocic`?m;O<?obmS]omkVlonJ]MkoU[;KomKQl?oGh_7oE8;7ocib`002
ocic`009ocmc`?lnLl3o?W?0ocmc`?lnLl3o?W;0oeB2a_mFQ<Oo?g?000Co?W?000Co?W;0ocic`?ln
Ll3o?g?00_lnLl001_o>fnkoWKONocib`?lnL/3o?W?0ocmc`0Co?W?000Co?W;0ocic`?lnLl3o?g?0
0_lnLl001_loLl3o?W?0ocib`?lnL/3o?W?0ocmc`0Co?W?000Co?W;0ocic`?lnLl3o?g?00_lnLl00
1_loLl3o?W?0ocib`?lnL/3o?W?0ocmc`0Co?W?000Co?W;0ocic`?lnLl3o?g?00_lnLl001_loLl3o
?W?0ocib`?lnL/3o?W?0ocmc`0Co?W?000Co?W;0ocic`?lnLl3o?g?00_lnLl001_loLl3o?W?0ocib
`?lnL/3o?W?0ocmc`0Co?W?000Co?W;0ocic`?lnLl3o?g?00_lnLl001_loLl3o?W?0ocib`?lnL/3o
?W?0ocmc`0Go?W?00_loLl400oloM<7o?g?1ocic`002ocmd`@;o?W?0017o?g?1ocmd`OloLl7oHf=S
ofIVI_mYJFWoK6a/ofm_KomaLG7oLg=cogEeMOmgMgOoN7QhogUiNOmjNW[oNg]kogalO00CogemO@00
@On2PX82oh61P@0<oh20P?mnOWkoOGemog]kNomjNW[oN7QhogEeMOmcLg?oL71`ofi^K_mZJV[oIVIV
1?m0ML800om0M<;o@7G2ocmd`@04od1e`P05ocmd`Om0M<;o?gC1od1d`OloLl400_loM<401_m0ML7o
O:3Doj>lhOnW_n;oPZ?Eod=g`P?o?gC100Go?g?1ocmd`OloM<7o?gC1ocmc`@06ocmd`@03ocmc`Olo
M<7o?gC100;o?gC100Ko?g?1ocmd`OloM<7o?gC1olkKk_nN^Ml5ocmd`@03ocmc`OloM<7o?gC100;o
?gC100Go?g?1ocmd`OloM<7o?gC1ocmc`@06ocmd`@03ocmc`OloM<7o?gC100;o?gC100Go?g?1ocmd
`OloM<7o?gC1ocmc`@06ocmd`@03ocmc`OloM<7o?gC100;o?gC100Go?g?1ocmd`OloM<7o?gC1ocmc
`@06ocmd`@03ocmc`OloM<7o?gC100;o?gC100Go?g?1ocmd`OloM<7o?gC1ocmc`@06ocmd`@03ocmc
`OloM<7o?gC100;o?gC100Go?g?1ocmd`OloM<7o?gC1ocmc`@06ocmd`@06ocmc`Om0M<7o?gC1od1d
`_m0ML;o?gC10om0ML800oloM<7o@7G2od1e`P02od1e`P0>od1d`_m0ML;oIVIVofYZJ_m]KFgoL71`
og=cLomeMGGoN7QhogYjN_mkNg_oOGemoginO_n0P802oh61PA?oPX:20011ogemO@0>ogalO?mkNg_o
Ng]kogUiNOmhN7SoMgMgogEeMOmcLg?oLG5aofm_Kom/K6coJFUYofIVI_mSHf<2od9h`P04od=i`om2
N<;o@gW3od=h``So@WS200Ko@WO2od9h`_m2Ml;o@WO2od9h`_m2Ml82od9h`P03od9g`_m2N<;o@WO2
00;o@WO200Go@WS2od9g`_m2N<;o@WO2od9h`P02od9g`P06od9h`_m2Ml;o@WS2od9h`_m2Ml;o@WS2
0om2Ml802Om2N<;o@WO2od9h`_m2Ml;oAG[2od=h`_m2Ml;o@WS2od9g`P02od9h`P03od9g`_m2N<;o
@WO200;o@WO200Go@WS2od9g`_m2N<;o@WO2od9h`P02od9g`P06od9h`_m2Ml;o@WS2od9h`_m2Ml;o
@WS20om2Ml801Om2N<;o@WO2od9h`_m2Ml;o@WS200;o@WO200Ko@WS2od9g`_m2N<;o@WS2od9g`_m2
N<83od9g`P05od9h`_m2Ml;o@WS2od9g`_m2N<800_m2Ml801_m2N<;o@WO2od9h`_m2N<;o@WO2od9h
`P?o@WO200Go@WS2od9g`_m2N<;o@WO2od9h`P02od9g`P06od9h`_m2Ml;o@WS2od9h`_m2Ml;o@WS2
0om2Ml801Om2N<;o@WO2od9h`_m2Ml;o@WS200;o@WO200Go@WS2od9g`_m2N<;o@WS2od9g`P02od9h
`P07od9g`_m2N<;o@gS3od9h`_m3N<?o@WS2od=h``02od9h`P0@od=i`om2N<;o@gW3od=h`omSHf?o
IVIVofUYJOm/K6coKfm_og5aLOmcLg?oMGEeogMgMomhN7SoNGUiog]kN`;oO7al4ommOGd004;oNWYj
00goNGUiogQhN?mgMgOoMWIfogEeMOmcLg?oLG5aofm_Kom]KFgoJVYZofQXJ?mUIFGoHV9R00;o?W?0
00[o?gC1ocic`?lnLl3o?W?0ocmc`OloM<7o?W?0ocmc`OlnLl3o?W;00_lnLl002?lnL[oo?W?0oceb
_olnL/3o?W?0oceb_olnL[oo?G:o0_lnLl003_lnL/3o?W?0ocib_olmL[oo?W;0ocic`?lnL[oo?W?0
oceb_olnL/3o?W?0oceb_olnL[oo?G:o0_lnLl003_lnL/3o?W?0ocib_olmL[oo?W;0ocic`?lnL[oo
?W?0oceb_olnL/3o?W?0oceb_olnL[oo?G:o0_lnLl003_lnL/3o?W?0ocib_olmL[oo?W;0ocic`?ln
L[oo?W?0oceb_olnL/3o?W?0oceb_olnL[oo?G:o0_lnLl003_lnL/3o?W?0ocib_olmL[oo?W;0ocic
`?lnL[oo?W?0oceb_olnL/3o?W?0oceb_olnL[oo?G:o0_lnLl003_lnL/3o?W?0ocib_olmL[oo?W;0
ocic`?lnL[oo?W?0oceb_olnL/3o?W?0oceb_olnL[oo?G:o0_lnLl003_lnL/3o?W?0ocib_olmL[oo
?W;0ocic`?lnL[oo?W?0oceb_olnL/3o?W?0oceb_olnL[oo?G:o0_lnLl003_lnL/3o?W?0ocib_olm
L[oo?W;0ocic`?lnL[oo?W?0oceb_olnL/3o?W?0oceb_olnL[oo?G:o1olnLl000oloLl7o?W?0ocmc
`@02ocic`00Aocmd`OlnLl3o?W?0ocic`?mRHV;oIFEUofQXJ?m[Jf_oKFe]ofm_KomaLG7oLg=cogEe
MOmfMWKoMgMgogQhN?miNGT05?mjNWX0047oOGem017oO7alog]kNomkNg_oNGUiogQhN?mgMgOoMGEe
og=cLomaLG7oKfm_ofa/K?mYJFWoIVIVof=SHoloM<7o?W?0ocmc`@03ocmd`@04ocic`?loLl7o?W?0
ocmc`@;o?gC11?lnLl000oloLl3o?W;0ocic`003ocic`004ocib`?lnLl3o?W;0ocic`0;o?g?000Ko
?W?0ocib`?lnLl3o?W?0ocmc`?lnL/04ocic`004ocib`?lnLl3o?W;0ocic`0;o?g?000Ko?W?0ocib
`?lnLl3o?W?0ocmc`?lnL/04ocic`004ocib`?lnLl3o?W;0ocic`0;o?g?000Ko?W?0ocib`?lnLl3o
?W?0ocmc`?lnL/04ocic`004ocib`?lnLl3o?W;0ocic`0;o?g?000Ko?W?0ocib`?lnLl3o?W?0ocmc
`?lnL/04ocic`004ocib`?lnLl3o?W;0ocic`0;o?g?000Ko?W?0ocib`?lnLl3o?W?0ocmc`?lnL/04
ocic`004ocib`?lnLl3o?W;0ocic`0;o?g?000Ko?W?0ocib`?lnLl3o?W?0ocmc`?lnL/04ocic`004
ocib`?lnLl3o?W;0ocic`0;o?g?000Ko?W?0ocib`?lnLl3o?W?0ocmc`?lnL/04ocic`004ocib`?ln
Ll3o?W?0ocic`0;o?gC10_lnLl001OloM<7o?g?0ocmd`OlnLl3o?g?100?o?gC100[oHf=SofIVI_mY
JFWoK6a/ofm_KomaLG7oLg=cogEeMOmgMgOoN7Qh0_mjNWX01OmkNg_oO7alogemOOmmOGgoO7al013o
OGem0011oh:2PP;oPH6100coOgmooginO_mmOGgoNg]kogYjN_mhN7SoMGEeog=cLom`L73oKFe]ofYZ
J_mWIfL:ooooo`05ookno_ooooooo_knookno_ooool01?ono_h01Oooooooo_knooooooono_kooooo
00?oo_kn00Koooooookno_ono_kooooooj>SXoo1`L42ooknoP05ooooooono_koooooookno_ooool0
0oono_h01?ooooooo_knookno_ooool4ooknoP05ooooooono_koooooookno_ooool00oono_h01?oo
ooooo_knookno_ooool4ooknoP05ooooooono_koooooookno_ooool00oono_h01?ooooooo_knookn
o_ooool4ooknoP05ooooooono_koooooookno_ooool00oono_h01?ooooooo_knookno_ooool4ookn
oP05ooooooono_koooooookno_ooool00oono_h01?ooooooo_knookno_ooool4ooknoP05ooooooon
o_koooooookno_ooool00oono_h01?ooooooo_knookno_ooool4ooknoP08ooooooono_koooooookn
o_ooooooo_knooooooono_h;ooooo`0<ofIVI_mZJV[oKFe]og1`L?mcLg?oMGEeogQhN?mjNW[oO7al
ogemOOmnOWkoOgmo0_n1PH4Coh:2PP00@OmmOGd2ogalO0;oNWYj00[oN7QhogMgMomeMGGoLg=cog5a
LOm_KfooK6a/ofYZJ_mVIVKoHf=S3OoinOT2ooShn007ooWinOohn?SonOWiooWinOohn?SonOWiooSh
n002ooWin@03ooShn?oinOWon?Sh00;onOWi0_ohn?P01om8B4SoPX:2ooWinOoinOWon?ShooWinOoh
n?P00_oinOT00oohn?SonOWiooShn002ooWin@;on?Sh00OonOWiooShn?oinOWonOWiooShn?oinOWo
n?Sh00;onOWi00?on?ShooWinOohn?P00_oinOT2ooShn007ooWinOohn?SonOWiooWinOohn?SonOWi
ooShn002ooWin@03ooShn?oinOWon?Sh00;onOWi0_ohn?P01ooinOWon?ShooWinOoinOWon?ShooWi
nOohn?P00_oinOT00oohn?SonOWiooShn002ooWin@;on?Sh00OonOWiooShn?oinOWonOWiooShn?oi
nOWon?Sh00;onOWi00?on?ShooWinOohn?P00_oinOT2ooShn007ooWinOohn?SonOWiooWinOohn?So
nOWiooShn002ooWin@03ooShn?oinOWon?Sh00;onOWi0_ohn?P01ooinOWon?ShooWinOoinOWon?Sh
ooWinOohn?P00_oinOT00oohn?SonOWiooWin@0;ooWin@0;of=SHomVIVKoJFUYofa/K?m_KfooLG5a
og=cLomeMGGoMgMgogQhN?miNGT00_mkNg/00omlO7coOGemogemO@0AogemO@00@_mjNWX03omiNGWo
N7QhogMgMomfMWKoMGEeog=cLomaLG7oKfm_ofe]KOm[Jf_oJ6QXofEUIOmRHV;ojn_[on[ZjP04on_[
j`;oj^[Z00?ojn_[on[Zj_o[jn/01_oZj^X00ooXj>Sobl_;om?Cd`03on[ZjP05onWYjOoZj^[oj^[Z
on3Ph?oEeMD00ooZj^X01Om4A4CoNg]konWYjOoDe=CojNWY00?oj^[Z00CojNWYon[Zj_oCdm?oj>SX
0ooZj^X00ooOgmooe]KFon[ZjP06on[ZjP03onWYjOoZj^[oj^[Z00Goj^[Z00Gog]kNonCTi?oYjNWo
e=CDonWYj@03on[ZjP04onWYjOoZj^[oh>3PomKFePcoj^[Z00?ojNWYon[Zj_oZj^X03OoZj^X00ooY
jNWoj^[Zon[ZjP0=on[ZjP03onWYjOoZj^[oj^[Z00goj^[Z00GojNWYon[Zj_oZj^[ojn_[on[ZjP02
on_[j`04on[Zj_o[jn_ojn_[on[ZjPCojn_[00goHV9RofEUIOmXJ6SoJVYZofe]KOm_KfooLG5aog=c
LomeMGGoMWIfogMgMomhN7SoNGUi01CoNWYj0011ogemO@0>ogalO?mkNg_oNg]kogUiNOmhN7SoMgMg
ogEeMOmcLg?oLG5aofm_Kom/K6coJFUYofMWIomSHf<<ooWin@0:ooShn?oinOWon?ShooShn?n_[joo
5ADEoaTI6Ol^;Rko?ShnojJVYP;onOWi03_oh^;Roe1@D?l@413o;Bd]ob4Q8Ono_koon?ShodM7AomB
DU;o<30`obHV9_lP823o^[ZjooShn?oinOWod=3@obl_;olX:2So^KViooWinOoQhN7oDE5Ao`l?3ol]
;Bgo8R8Rokno_ooinOWoAdM7oh:2P_ohn?SonOWioginO_m:BT[on?ShooWinOnc/k?o51@DooWinOoh
n?SoAdM7oemOGol`<33o9RHVob0P8?nj^[[on?ShooWinOoRh^;oDE5Ao`l?3ol^;Rko8R8Rokno_ooi
nOWoAdM7oh:2P_oinOWon?ShooWin@03ooShn0;onOWi0_ohn?P2ooWin@07ooShn?oinOWon?ShooSh
n?oinOWon?ShooWin@03ooShn0;onOWi0_ohn?P2ooWin@07ooShn?oinOWon?ShooShn?oinOWon?Sh
ooWin@03ooShn0;onOWi0_ohn?P2ooWin@07ooShn?oinOWon?ShooShn?oinOWon?ShooWin@03ooSh
n0;onOWi0_ohn?P<ooWin@0:of=SHomWIfOoJFUYofa/K?m_KfooLG5aog=cLomeMGGoMgMgogQhN0;o
NWYj00?oNg]kogalO?mlO7`04_mmOGd0047oPX:20_n1PH403?moOgooOWinogemOOmkNg_oNWYjogQh
N?meMGGoLg=cog1`L?m]KFgoJVYZofIVIP_ooooo01ooo_knooooooono_koooooookno_oGemOo`/;2
oo[jn_ono_koXZ:Roa8B4_oOgmooo_knodi>C_m:BT[oh>3Pookno_oclo?ol_;boooooom;Bd_oCDe=
ono_kookno_oQ8B4ob0P8?oclo?oo_knogQhN?m<C4cooOgm00;oo_kn00CoCTi>odY:B_oQhN7oo_kn
0_obl_801oooooooBd];ohJ6Q_ooooooo_knoh61POm=CDd00_ono_h04?ng]kOo5aLGookno_oooooo
Bd];ode=COo_knoono_kohB4Q?lP823olo?cookno_m>CTkoBd];on3Ph?ono_h2oo;blP03ookno_m;
Bd_oQXJ600;oo_kn00Coooooookno_ono_kooooo1_ono_h00oooooooo_knooooo`03ooknoP04oooo
ooono_koo_knooooo`Koo_kn00?oooooookno_ooool00oono_h01?ooooooo_knookno_ooool6ookn
oP03ooooooono_kooooo00?oo_kn00Coooooookno_ono_kooooo1?ono_h00oooooooo_knooooo`09
ooooo`0<ofMWIomZJV[oKVi^og1`L?mcLg?oMGEeogQhN?mjNW[oO7alogemOOmnOWkoOgmo0_n1PH4C
oh:2PP00@OmmOGd03_mlO7coNg]kog]kNomjNW[oN7QhogMgMomeMGGoLg=cog5aLOm_KfooK6a/ofUY
JOmVIVKoHf=S3?oinOT01_ohn?SonOWiooShn?oinOWon?ShooWin@;on?Sh00Oog=cLo`d=3One]KGo
f=SHo`d=3Onf][KonOWi00;on?Sh01SonOWiooShn?m8B4SoPX:2ooWinOohn?Soh^;Ro`d=3On][Jgo
nOWioe=CDomfMWKon?ShooWinOoHf=So3@d=okNg]oohn?SonOWiooShn?oinOWon?ShodM7Aon2PX82
ooWin@0DogemOOm;Bd_on?ShooWinOnc/k?o51@DooWinOohn?SoB4Q8oh:2P_oinOWon?Shon;Rh_l=
3@go[Jf]omWIfOl=3@go]kNgooShn?oinOT2ooShn005ooWinOm7AdOoPX:2ooShn?oinOT00oohn?P2
ooWin@04ooShn?oinOWon?ShooWin@;on?Sh00GonOWiooShn?oinOWon?ShooWin@03ooShn0;onOWi
00Con?ShooWinOohn?SonOWi0_ohn?P01OoinOWon?ShooWinOohn?SonOWi00?on?Sh0_oinOT01?oh
n?SonOWiooShn?oinOT2ooShn005ooWinOohn?SonOWiooShn?oinOT00oohn?P2ooWin@03ooShn?oi
nOWonOWi00conOWi00_oHf=SofIVI_mZJV[oK6a/ofm_KomaLG7oLg=cogEeMOmgMgOoN7QhogUiN@02
og]kN`;oO7al4_mmOGd004;oNWYj00goNGUiogQhN?mgMgOoMWIfogEeMOmcLg?oLG5aofm_Kom]KFgo
JVYZofQXJ?mUIFGoHV9R00;oj^[Z00?ojn_[on[Zj_o[jn/00_oZj^X00oo[jn_oj^[Zon_[j`02on[Z
jP05on_[jooZj^[oj^[Zon[Zj_oYjNT00_oZj^X01ooLg=coDE5Aoa<C4ooNg]ko/[:bo``<3?m2@T80
0_m3@d<01Om4A4Co]kNgon[Zj_m4A4CoNWYj00;oj^[Z01[ojNWYob0P8?n:RX[ojNWYodm?Com_Kfoo
j^[ZonWYjOnb/[;o3@d=od92@_m3@d?oA4A4od=3@onf][Koj^[Zod=3@omkNg_oj^[ZonWYjOmgMgOo
ATI6on[Zj_oYjNWoZ:RXoaDE5@;oj^[Z00_oA4A4ogYjN_oZj^[oj^[ZonWYjOlP823oRXZ:ok6a/Ol=
3@go@D51odA4A002od=3@`05okNg]ooZj^[o@d=3og]kNooYjNT00_oZj^X01?oYjNWoj^[Zon[Zj_oY
jNT3on[ZjP03onWYjOoZj^[oj^[Z00?oj^[Z00CojNWYon[Zj_oZj^[ojNWY0_oZj^X01OoYjNWoj^[Z
on[Zj_oZj^[ojNWY00Goj^[Z00CojNWYon[Zj_oZj^[ojNWY0_oZj^X01OoYjNWoj^[Zon[Zj_oZj^[o
jNWY00Goj^[Z00CojNWYon[Zj_oZj^[ojNWY0_oZj^X01OoYjNWoj^[Zon[Zj_o[jn_oj^[Z00?ojn_[
01Goj^[Zon_[jooZj^[oj^[Zon_[jooZj^[ojn_[on[Zj_mRHV;oIFEUofQXJ?m[Jf_oKFe]ofm_Koma
LG7oLg=cogEeMOmfMWKoMgMgogQhN?miNGT05?mjNWX0047oOGem00koO7alog]kNomkNg_oNWYjogQh
N?mgMgOoMGEeog=cLomaLG7oKfm_ofa/K?mZJV[oIVIVof=SH`conOWi00?on?ShooWinOohn?P00ooi
nOT05one]KGo9bLWob8R8_nl_;conOWiomOGeol=3@goZZZZol_;boo5aLGo3`l?on3Ph?ohn?SoAdM7
oginO_oinOWon?ShonSXj?l=3@go`L71ooWinOmDE5CoMGEe00;onOWi02GoemOGo`d=3OnZZZ[obl_;
olG5aOl@413oh>3PooShn?m8B4SoLG5aooShn?oinOWoO7aloc`l??ohn?SonOWiok:b/_lD51ConOWi
ooShn?m7AdOoOWinooWinOohn?Soj>SXo`d=3Oo1`L7oemOGo`d=3OnZZZ[obl_;olG5aOl?3`ooh>3P
ooWinOm7AdOoKFe]00;onOWi00Gon?ShooWinOoinOWon?ShooWin@02ooShn0;onOWi0_ohn?P00ooi
nOWon?ShooWin@02ooWin@05ooShn?oinOWonOWiooShn?oinOT00_ohn?P2ooWin@;on?Sh00?onOWi
ooShn?oinOT00_oinOT01Oohn?SonOWiooWinOohn?SonOWi00;on?Sh0_oinOT2ooShn003ooWinOoh
n?SonOWi00;onOWi00Gon?ShooWinOoinOWon?ShooWin@02ooShn0gonOWi00_oHf=SofIVI_mYJFWo
K6a/ofm_KomaLG7oLg=cogEeMOmgMgOoN7QhogYjNP02og]kN`03ogalO?mmOGgoOGem017oOGem0011
oh:2PP;oPH6100coOgmooginO_mmOGgoNg]kogYjN_mhN7SoMGEeog=cLom`L73oKFe]ofYZJ_mVIVH>
ooooo`07ookno_ooooooo_knohN7Qol?3`ooGemOonKViP03ooknoP0IodY:B_mcLg?omoOgoj>SXolg
=cOoooooookno_m;Bd_o:2PXoibLW?oMgMgoLG5aoahN7_okno_on?Shoe=CDomeMGGom?Cdoo_knoon
o_koBTY:og=cLoofm_KoXj>SocHf=P02ooknoP0PodY:B_lQ8B7oTY:BonSXj?m:BT[o;2`/ofQXJ?oS
hn?oN7Qhochn?_ooooooo_knod];BolX:2SoW9bLomgMgOmaLG7o7QhNoo_knoono_koBTY:og=cLoof
m_KoXj>SocHf=_ono_koooooodY:B_lP823oUiNGonCTi?olo?`5ooknoP03ooooooono_kooooo00;o
o_kn00?oooooookno_ooool02?ono_h00oooooooo_knooooo`02ooknoP03ooooooono_kooooo00So
o_kn00?oooooookno_ooool00_ono_h00oooooooo_knooooo`08ooknoP03ooooooono_kooooo00_o
oooo00coIVIVofYZJ_m^KVkoL71`og=cLomeMGGoN7QhogYjN_mkNg_oOGemoginO_moOgl2oh61PA?o
PX:20011ogemO@0>ogalO?mkNg_oNg]kogYjN_mhN7SoMgMgogEeMOmcLg?oLG5aofm_Kom/K6coJFUY
ofIVI_mSHf<6ooWin@03oo[jn_oinOWonOWi00ConOWi00Oon?ShooWinOohn?SohN7Qo`l?3onEUIGo
n?Sh00?onOWi01[on?Shon7QhOm>CTko61PHobLW9one]KGon?ShooWinOmJFU[oS8b<of][JolI6AWo
92@TojRXZ?oinOWoPX:2oa<C4olH61So9BDUojf][OoinOWohN7Qodi>C_lI6AWo9RHVokFe]@;onOWi
01;oFUYJohf=SOmeMGGo71`Loc8b<_oAdM7oVYZJob@T9?l[:b_o[:b/ooShn?oinOWoAdM7ogmoOom[
Jf_o6ATIob@T9?nXZ:P2ooWin@05on7QhOm>CTko61PHobHV9_nf][H00_ohn?P01_mKFe_oRh^;of=S
HolE5AGojn_[ooShn0?onOWi00Gon?ShooWinOohn?Son?ShooWin@02ooShn003ooWinOohn?Son?Sh
00;onOWi00Kon?ShooWinOoinOWonOWiooShn?oinOT2ooShn004ooWinOohn?Son?ShooWin@;on?Sh
0_oinOT01_ohn?SonOWiooWinOoinOWon?ShooWin@;on?Sh00ConOWiooShn?ohn?SonOWi0_ohn?P2
ooWin@07ooShn?oinOWonOWiooWinOohn?SonOWiooShn00<ooWin@0<of=SHomVIVKoJVYZofa/K?m_
KfooLG5aog=cLomeMGGoMgMgogQhN?miNGWoNg]k0_mlO7`CogemO@00@_mjNWX03OmiNGWoN7QhogMg
MomfMWKoMGEeog=cLomaLG7oKfm_ofe]KOm[Jf_oJ6QXofEUIOmRHV800_o[jn/00ooZj^[ojn_[on_[
j`02on[ZjPCojn_[1OoZj^X00oo8b<So3Ph>omCDe002on[ZjP;ojNWY0ooZj^X00ooXj>Soj^[ZonWY
j@05on[ZjP03onSXj?oZj^[oj^[Z00;ojNWY00?oCdm?og1`L?oZj^X00_oZj^X00ooYjNWoj^[ZonOW
i`06on[ZjP;ojNWY1?oZj^X2onWYj@;oj^[Z00Co@d=3og]kNooZj^[oj>SX0_oZj^X2onWYj@;oj^[Z
00CoinOWon[Zj_oZj^[ojNWY1?oZj^X01?oWinOoj^[Zon[Zj_oZj^X2onWYj@Goj^[Z00?ojNWYon[Z
j_oZj^X01_oZj^X2onWYj@Goj^[Z00?ojNWYon[Zj_oZj^X01_oZj^X2onWYj@Goj^[Z00?ojNWYon[Z
j_oZj^X01_oZj^X2onWYj@?oj^[Z0_o[jn/01?oZj^[ojn_[on_[jooZj^X2on_[j`0Aon[Zj_o[jn_o
jn_[on[Zj_mRHV;oIFEUofQXJ?mZJV[oKFe]ofm_KomaLG7oLg=cogEeMOmfMWKoMgMgogQhN?miNGT0
5?mjNWX0047oOGem0_mlO7`03?mkNg_oNGUiogQhN?mgMgOoMGEeog=cLomaLG7oKfm_ofa/K?mYJFWo
IVIVof=SH`gonOWi0_ohn?P02?oinOWon?Shoe5ADOm2@T;oT92@ofQXJ?mNGUkonOWi0oohn?P00ooi
nOWon?ShooWin@02ooShn003ooWinOohn?Son?Sh00;on?Sh00WonOWiooShn?oinOWofm_KomWIfOoh
n?SonOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn003ooWinOohn?SonOWi00?on?Sh
00?onOWiooShn?oinOT00_ohn?P00om8B4SoPX:2ooShn002ooShn003ooWinOohn?SonOWi00?on?Sh
00?onOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn003ooWinOohn?SonOWi00?on?Sh
00?onOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn003ooWinOohn?SonOWi00?on?Sh
00?onOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn003ooWinOohn?SonOWi00?on?Sh
00?onOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn003ooWinOohn?SonOWi00?on?Sh
3?oinOT03_mSHf?oIVIVofUYJOm/K6coKfm_og5aLOmcLg?oMGEeogMgMomhN7SoNGUiogYjN_mkNg_o
O7al4ommOGd0047oPX:20_n1PH403?n0P83oOWinogemOOmkNg_oNWYjogQhN?meMGGoLg=cog1`L?m^
KVkoJVYZofIVIP_ooooo00Coo_knooooooono_kooooo0_ono_h02Ookno_o^[ZjogIfM_n>SXko`/;2
ookno_ooooooo_knooooo`02ooknoP03ooooooono_kooooo00;oo_kn00Woooooookno_ono_koo_kn
ooooooono_koooooookno_ooool00_ono_h00oooooooo_knooooo`02ooknoP09ooooooono_koo_kn
ookno_ooooooo_knooooooono_kooooo00;oo_kn00Koooooookno_ooooooBTY:ohJ6Q_ooool3ookn
oP05ooooooono_koooooookno_ooool00_ono_h00oooooooo_knooooo`02ooknoP09ooooooono_ko
o_knookno_ooooooo_knooooooono_kooooo00;oo_kn00?oooooookno_ooool00_ono_h02Ooooooo
o_knookno_ono_koooooookno_ooooooo_knooooo`02ooknoP03ooooooono_kooooo00;oo_kn00Wo
ooooookno_ono_koo_knooooooono_koooooookno_ooool00_ono_h00oooooooo_knooooo`02ookn
oP08ooooooono_koo_knookno_ooooooo_knooooooono_h2ooooo`03ookno_oooooooooo00Sooooo
00coIVIVofYZJ_m]KFgoL71`og=cLomeMGGoN7QhogYjN_mkNg_oOGemoginO_n0P802oh61PA?oPX:2
0011ogemO@0>ogalO?mkNg_oNg]kogUiNOmhN7SoMgMgogEeMOmcLg?oLG5aofm_Kom/K6coJFUYofIV
I_mSHf<>ooWin@06ooShn?oinOWon?ShooShn?oinOWon?Sh0_oinOT00oohn?SonOWiooShn002ooSh
n005ooWinOohn?SonOWiooShn?oinOT00_ohn?P01_oinOWon?ShooWinOoinOWon?ShooWin@?on?Sh
00GonOWiooShn?oinOWon?ShooWin@02ooShn006ooWinOohn?SonOWiooWinOohn?SonOWi0oohn?P0
2OoinOWon?ShooWinOohn?SomOGeooKfm_ohn?SonOWiooShn002ooWin@03ooShn?oinOWon?Sh00;o
n?Sh00GonOWiooShn?oinOWon?ShooWin@02ooShn006ooWinOohn?SonOWiooWinOohn?SonOWi0ooh
n?P01OoinOWon?ShooWinOohn?SonOWi00;on?Sh00KonOWiooShn?oinOWonOWiooShn?oinOT3ooSh
n005ooWinOohn?SonOWiooShn?oinOT00_ohn?P01_oinOWon?ShooWinOoinOWon?ShooWin@?on?Sh
00GonOWiooShn?oinOWon?ShooWin@02ooShn006ooWinOohn?SonOWiooWinOohn?SonOWi0_ohn?P<
ooWin@0<of=SHomVIVKoJFUYofa/K?m_KfooLG5aog=cLomeMGGoMgMgogQhN?miNGWoNg]k0_mlO7`C
ogemO@00@_mjNWX03_miNGWoN7QhogMgMomfMWKoMGEeog=cLomaLG7oKfm_ofe]KOmZJV[oJ6QXofEU
IOmRHV;oj^[Z0_o[jn/00ooZj^[ojn_[on[ZjP05on_[j`Goj^[Z00?ojNWYon[Zj_oZj^X02?oZj^X0
0ooYjNWoj^[Zon[ZjP02on[ZjP03onWYjOoZj^[oj^[Z00Soj^[Z00?ojNWYon[Zj_oZj^X00_oZj^X0
0ooYjNWoj^[Zon[ZjP08on[ZjP03onWYjOoZj^[oj^[Z00;oj^[Z00?ojNWYon[Zj_oZj^X02?oZj^X0
0ooYjNWoj^[Zon[ZjP02on[ZjP03onWYjOoZj^[oj^[Z00Soj^[Z00?ojNWYon[Zj_oZj^X00_oZj^X0
0ooYjNWoj^[Zon[ZjP08on[ZjP03onWYjOoZj^[oj^[Z00;oj^[Z00?ojNWYon[Zj_oZj^X02?oZj^X0
0ooYjNWoj^[Zon[ZjP02on[ZjP03onWYjOoZj^[oj^[Z00Koj^[Z00?ojn_[on[Zj_oZj^X00_o[jn/0
0ooZj^[ojn_[on[ZjP02on_[j`0@on[Zj_o[jn_oj^[Zof9RH_mUIFGoJ6QXof][Jom]KFgoKfm_og5a
LOmcLg?oMGEeogIfM_mgMgOoN7QhogUiNACoNWYj0011ogemO@0>ogalO?mkNg_oNg]kogUiNOmhN7So
MgMgogEeMOmcLg?oLG5aofm_Kom/K6coJFUYofIVI_mSHf<<ooWin@;on?Sh00?onOWiooShn?oinOT0
0_ohn?P3ooWin@Con?Sh0_oinOT2ooShn003ooWinOohn?SonOWi00;on?Sh0ooinOT4ooShn0;onOWi
0_ohn?P00ooinOWon?ShooWin@02ooShn0?onOWi1?ohn?P2ooWin@;on?Sh00?onOWiooShn?oinOT0
0_ohn?P3ooWin@Con?Sh0_oinOT2ooShn003ooWinOohn?SonOWi00;on?Sh0ooinOT4ooShn0;onOWi
0_ohn?P00ooinOWon?ShooWin@02ooShn0?onOWi1?ohn?P2ooWin@;on?Sh00?onOWiooShn?oinOT0
0_ohn?P3ooWin@Con?Sh0_oinOT2ooShn003ooWinOohn?SonOWi00;on?Sh0ooinOT3ooShn0gonOWi
00[oHf=SofIVI_mYJFWoK6a/ofm_KomaLG7oLg=cogEeMOmgMgOoN7Qh0_mjNWX01OmkNg_oO7alogem
OOmmOGgoO7al013oOGem0011oh:2PP;oPH6100coOgmooginO_mmOGgoNg]kogYjN_mhN7SoMGEeog=c
Lom`L73oKFe]ofYZJ_mWIfL:ooooo`05ookno_ooooooo_knookno_ooool01?ono_h01Oooooooo_kn
ooooooono_kooooo00?oo_kn00Coooooookno_ono_kooooo0oono_h01_o3`l?oRXZ:ofUYJOn0P83o
d=3@ooooo`?oo_kn00Coooooookno_ono_kooooo1?ono_h01Oooooooo_knooooooono_kooooo00?o
o_kn00Coooooookno_ono_kooooo1?ono_h01Oooooooo_knooooooono_kooooo00?oo_kn00Cooooo
ookno_ono_kooooo1?ono_h01Oooooooo_knooooooono_kooooo00?oo_kn00Coooooookno_ono_ko
oooo1?ono_h01Oooooooo_knooooooono_kooooo00?oo_kn00Coooooookno_ono_kooooo1?ono_h0
1Oooooooo_knooooooono_kooooo00?oo_kn00Coooooookno_ono_kooooo1?ono_h02?ooooooo_kn
ooooooono_koooooookno_ooooooo_kn2oooool03?mVIVKoJVYZofe]KOm`L73oLg=cogEeMOmhN7So
NWYjogalO?mmOGgoOWinogmoO`;oPH614on2PX80047oOGem0_mlO7`2ogYjNP0:ogQhN?mgMgOoMGEe
og=cLomaLG7oKfm_ofa/K?mZJV[oIVIVof=SH`gonOWi0_ohn?P01ooinOWon?ShooWinOoinOWon?Sh
ooWinOohn?P00_oinOT00oohn?SonOWiooShn002ooWin@;on?Sh00conOWiooShn?oinOWoRh^;ogUi
NOnUYJGoJ6QXoaLG5onj^[[on?ShooWinOohn?P2ooWin@;on?Sh00OonOWiooShn?oinOWonOWiooSh
n?oinOWon?Sh00;onOWi00?on?ShooWinOohn?P00_oinOT2ooShn007ooWinOohn?SonOWiooWinOoh
n?SonOWiooShn002ooWin@03ooShn?oinOWon?Sh00;onOWi0_ohn?P01ooinOWon?ShooWinOoinOWo
n?ShooWinOohn?P00_oinOT00oohn?SonOWiooShn002ooWin@;on?Sh00OonOWiooShn?oinOWonOWi
ooShn?oinOWon?Sh00;onOWi00?on?ShooWinOohn?P00_oinOT2ooShn007ooWinOohn?SonOWiooWi
nOohn?SonOWiooShn002ooWin@03ooShn?oinOWon?Sh00;onOWi0_ohn?P01ooinOWon?ShooWinOoi
nOWon?ShooWinOohn?P00_oinOT00oohn?SonOWiooWin@0;ooWin@0;of=SHomVIVKoJFUYofa/K?m_
KfooLG5aog=cLomeMGGoMgMgogQhN?miNGT00_mkNg/00omlO7coOGemogemO@0AogemO@00@_mjNWX0
4OmiNGWoN7QhogMgMomfMWKoMGEeog=cLomaLG7oKfm_ofe]KOm[Jf_oJ6QXofEUIOmRHV;oo_knoogm
oOono_kooOgm00;oo_kn0_omoOd00oono_kooOgmooknoP03oogmo@03ooclo?omoOgooOgm00GooOgm
0_olo?`3oogmo@04oo[jn_o^k^kooOgmooclo0OooOgm00?oHF5Qodm?CoomoOd00_omoOd01?ojn_[o
k^k^oogmoOolo?`4oogmo@03oo3`l?oalO7ooOgm00;oo?cl0oomoOd01?oTi>Cono_koogmoOolo?`7
oogmo@;oo?cl1_omoOd00oolo?cooOgmoogmo@05oogmo@;oo?cl1_omoOd00oolo?cooOgmoogmo@05
oogmo@;oo?cl1_omoOd00oolo?cooOgmoogmo@05oogmo@;oo?cl1_omoOd00oolo?cooOgmoogmo@05
oogmo@;oo?cl0_omoOd01Oono_kooOgmookno_ono_kooOgm00;oo_kn00?ooOgmookno_omoOd00_on
o_h03OmRHV;oIFEUofQXJ?mZJV[oKFe]ofm_KomaLG7oLg=cogEeMOmfMWKoMgMgogQhN?miNGT05?mj
NWX0047oOGem00koO7alog]kNomkNg_oNGUiogQhN?mgMgOoMGEeog=cLomaLG7oKfm_ofa/K?mYJFWo
IfMWof=SH`conOWi00Oon?ShooWinOohn?Son?ShoeEEEOmgMgOonOWi00?on?Sh01;onOWiocTi>OmU
IFGon?Shokjn__lV9RKo4a<CoeQHF?n8R8So>CTiooWinOohn?Soh^;Rof=SHom1@D7oOGemoifMWOlY
:BT2ooShn00Dokjn__lV9RKo4a<CoeQHF?n8R8So>CTiooWinOohn?So;bl_oa/K6olZ:R[oDe=Coo3`
l?oinOWon?Sholo?col`<33o:BTYokRh^?oinOT2ooShn003ooWinOohn?SonOWi00?on?Sh0_oinOT2
ooShn0;onOWi00Oon?ShooWinOohn?Son?ShooWinOohn?SonOWi00?on?Sh0_oinOT2ooShn0;onOWi
00Oon?ShooWinOohn?Son?ShooWinOohn?SonOWi00?on?Sh0_oinOT2ooShn0;onOWi00Oon?ShooWi
nOohn?Son?ShooWinOohn?SonOWi00?on?Sh0_oinOT2ooShn0;onOWi00Oon?ShooWinOohn?Son?Sh
ooWinOohn?SonOWi00?on?Sh0_oinOT2ooShn0conOWi00[oHf=SofMWIomYJFWoK6a/ofm_KomaLG7o
Lg=cogEeMOmgMgOoN7Qh0_mjNWX00omkNg_oO7alogalO00BogemO@00@On2PX82oh61P@0<ogmoOomn
OWkoOGemog]kNomjNW[oN7QhogEeMOmcLg?oL71`ofe]KOmZJV[oIVIV1Oo/k>`00oo]kNgok>c/onc/
k003onc/k003on_[joo/k>cojn_[00;ok>c/013oZJVYob0P8?oVi^Kok>c/on_[joo/k>co_[jno`h>
3_ng]kOojn_[oeMGEomKFe_oi>CToiNGUolK6a_o>3Ph0_o[jn/03_m@D53o=SHfoiZJV_mjNW[o=CDe
oalO7oo/k>cojn_[oeMGEomKFe_oi>CToiNGUolK6a_o>3Ph0_o[jn/03?nd];Coj>SXon[Zj_lm?Cgo
S8b<on_[joo/k>coL71`odI6A_oZj^[ok>c/on_[j`;ok>c/0_o[jn/2onc/k00:on_[joo/k>cojn_[
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[j`;ok>c/0_o[jn/2onc/k00:on_[joo/k>cojn_[on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[j`;ok>c/0_o[jn/2onc/k00:on_[joo/k>cojn_[on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[j`;ok>c/0_o[jn/2onc/k00:on_[joo/k>cojn_[on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[j`;ok>c/0_o[jn/2onc/k004on_[joo/k>cojn_[on_[j`Kok>c/00?o
kNg]onc/k?o/k>`01?o/k>`03Oo]kNgoIfMWofYZJ_m^KVkoL71`og=cLomeMGGoN7QhogYjN_mlO7co
OGemoginO_moOgl00_n1PH4Coh:2PP00@OmmOGd03_mlO7coNg]kog]kNomjNW[oN7QhogMgMomeMGGo
Lg=cog5aLOm_KfooK6a/ofUYJOmVIVKoHf=S3?oinOT01oohn?SonOWiooShn?oinOWom_KfobLW9ome
MGD00_nJVYX07OnKVi_oD51@oc8b<_oinOWon?ShocHf=_nBTY;on?ShooWinOmmOGgo>SXjooShn?o`
l?3o51@DokNg]oohn?SonOWioiRHV?lL71conOWiooShn?lf=SKoTY:BooShn?oinOWoOGemocXj>_oh
n?SonOWi00;on?Sh00Oo`/;2ob4Q8OnEUIGon?ShooWinOmCDe?oMWIf00;on?Sh00GonOWiooShn?oi
nOWon?ShooWin@03ooShn0;onOWi00Con?ShooWinOohn?SonOWi0_ohn?P01OoinOWon?ShooWinOoh
n?SonOWi00?on?Sh0_oinOT01?ohn?SonOWiooShn?oinOT2ooShn005ooWinOohn?SonOWiooShn?oi
nOT00oohn?P2ooWin@04ooShn?oinOWon?ShooWin@;on?Sh00GonOWiooShn?oinOWon?ShooWin@03
ooShn0;onOWi00Con?ShooWinOohn?SonOWi0_ohn?P01OoinOWon?ShooWinOohn?SonOWi00?on?Sh
0_oinOT00oohn?SonOWiooWin@0<ooWin@0;of=SHomVIVKoJVYZofa/K?m_KfooLG5aog=cLomeMGGo
MgMgogQhN?miNGT00_mkNg/2ogalO1;oOGem0012ogYjNP0=ogUiNOmhN7SoMgMgogIfM_meMGGoLg=c
og5aLOm_KfooKFe]ofYZJ_mXJ6SoIFEUof9RHP02oogmo@03ookno_omoOgoo_kn00;ooOgm00?oo_kn
oogmoOono_h01_omoOd03?olo?coQ8B4oa/K6om^KVkoKfm_ofATI?l<30coT92@ooclo?omoOgo=SHf
oiNGU`;ooOgm00KoTi>CocXj>_olo?co`l?3o`d=3OoUiND2oogmo@06ojj^[_lM7Agoo?cloogmoOlf
=SKoUiNG0_omoOd03OnCTi?o>SXjooclo?omoOgoi>CToe9BD_l@413oMgMgooCdm?omoOgoo?cloeIF
E_mhN7P01OomoOd01?olo?cooOgmoogmoOolo?`2oogmo@05ooclo?omoOgoo?cloogmoOolo?`01Oom
oOd01?olo?cooOgmoogmoOolo?`2oogmo@05ooclo?omoOgoo?cloogmoOolo?`01OomoOd01?olo?co
oOgmoogmoOolo?`2oogmo@05ooclo?omoOgoo?cloogmoOolo?`01OomoOd01?olo?cooOgmoogmoOol
o?`2oogmo@05ooclo?omoOgoo?cloogmoOolo?`01OomoOd01?olo?cooOgmoogmoOolo?`2oogmo@03
ooclo?omoOgoo?cl00?ooOgm0_ono_h05OomoOgoo_knoogmoOomoOgoo_knoogmoOono_kooOgmof9R
H_mUIFGoJ6QXof][Jom]KFgoKfm_og5aLOmcLg?oMGEeogIfM_mgMgOoN7QhogUiN@0DogYjNP00@Omm
OGd03_mlO7coNg]kog]kNomjNW[oN7QhogMgMomeMGGoLg=cog5aLOm_KfooK6a/ofYZJ_mVIVKoHf=S
3?oinOT00oohn?SonOWiooShn002ooWin@0OomgMgOl?3`oofMWIooWinOnMWIgo4A4AonGUiOohn?So
nOWiocHf=_nEUIGon?ShooWinOnATI7o>SXjooWinOoFe]Ko3@d=okBd]?oinOWon?Shojb/[?lL71co
n?ShooWinOlf=SKoUIFEooShn?oinOWoTI6AocXj>P02ooWin@05odQ8B?m:BT[oemOGooShn?oinOT0
0_ohn?P01_mDE5CoMWIfooShn?ohn?SonOWiooShn0?onOWi00Gon?ShooWinOoinOWon?ShooWin@02
ooShn0;onOWi0_ohn?P00ooinOWon?ShooWin@02ooWin@05ooShn?oinOWonOWiooShn?oinOT00_oh
n?P2ooWin@;on?Sh00?onOWiooShn?oinOT00_oinOT01Oohn?SonOWiooWinOohn?SonOWi00;on?Sh
0_oinOT2ooShn003ooWinOohn?SonOWi00;onOWi00Gon?ShooWinOoinOWon?ShooWin@02ooShn0;o
nOWi0_ohn?P00ooinOWon?ShooWin@02ooWin@05ooShn?oinOWonOWiooShn?oinOT00_ohn?P=ooWi
n@0;of=SHomVIVKoJFUYofa/K?m_KfooLG5aog=cLomeMGGoMgMgogQhN?mjNWX00_mkNg/00omlO7co
OGemogemO@0AogemO@00@On2PX82oh61P@0<ogmoOomnOWkoOGemog]kNomjNW[oN7QhogEeMOmcLg?o
L71`ofe]KOmZJV[oIVIV3_o/k>`02Oo[jn_ok>c/on_[joo[jn_oCTi>ogIfM_o[jn_o?ShnoeIFEP02
onc/k003on_[jold=3CoSHf=00;ok>c/00koRHV9ocPh>?o[jn_ojn_[od51@Om:BT[od];BomoOgomH
F5So7AdMonc/k?o[jn_o=3@dohf=S@;ok>c/01;oRHV9ocPh>?o[jn_ojn_[ocdm?On@T93ojn_[omOG
eooVi^Kok>c/onKVi_m=CDgoKFe]on7QhOoXj>Sok>c/on_[joo/k>`7on_[j`;ok>c/00?ojn_[onc/
k?o[jn/00_o/k>`00oo[jn_ok>c/on_[j`06on_[j`;ok>c/00?ojn_[onc/k?o[jn/00_o/k>`00oo[
jn_ok>c/on_[j`06on_[j`;ok>c/00?ojn_[onc/k?o[jn/00_o/k>`00oo[jn_ok>c/on_[j`06on_[
j`;ok>c/00?ojn_[onc/k?o[jn/00_o/k>`00oo[jn_ok>c/on_[j`06on_[j`;ok>c/00?ojn_[onc/
k?o/k>`02_o/k>`03?mVIVKoJVYZofi^K_m`L73oLg=cogEeMOmhN7SoNWYjog]kNommOGgoOWinogmo
O`;oPH614on2PX80047oOGem00koO7alog]kNomkNg_oNWYjogQhN?mgMgOoMGEeog=cLomaLG7oKfm_
ofa/K?mYJFWoIVIVof=SH`KonOWi00?on_[jooWinOoinOT01?oinOT03oohn?SonOWiooShn?ohn?So
nOWiojj^[_lS8b?obl_;o`d=3Onf][Kon?ShooWinOohn?SoBTY:oijNWP02ooShn00>oibLW?m=CDgo
n?ShooWinOoNg]koBd];oaLG5olc<c?oNWYjoc@d=?oinOWon?ShodY:B_nNWYh2ooShn00AoibLW?m=
CDgon?ShooWinOnn_[ko@T92oa`L7?lN7Qkohn?SooShn?n2PX;o4a<CoaLG5olV9RKo[Jf]ooShn?oi
nOT00_ohn?P2ooWin@06ooShn?oinOWonOWiooWinOohn?SonOWi0_ohn?P01?oinOWon?ShooShn?oi
nOT2ooShn0;onOWi00Kon?ShooWinOoinOWonOWiooShn?oinOT2ooShn004ooWinOohn?Son?ShooWi
n@;on?Sh0_oinOT01_ohn?SonOWiooWinOoinOWon?ShooWin@;on?Sh00ConOWiooShn?ohn?SonOWi
0_ohn?P2ooWin@06ooShn?oinOWonOWiooWinOohn?SonOWi0_ohn?P01?oinOWon?ShooShn?oinOT2
ooShn0;onOWi00Oon?ShooWinOoinOWonOWiooShn?oinOWon?Sh00conOWi00coHf=SofIVI_mZJV[o
K6a/ofm_KomaLG7oLg=cogEeMOmgMgOoN7QhogUiNOmkNg/2ogalO1?oOGem0012ogYjNP0=ogUiNOmh
N7SoMgMgogIfM_meMGGoLg=cog5aLOm_KfooKFe]of][JomXJ6SoIFEUof9RHP02ooknoP03oogmoOon
o_kooOgm00;ooOgm0_ono_h00oomoOgoo_knoogmo@06oogmo@05ooWinOlT92Co<c<cobPX:?okno/0
1OomoOd00oolo?cooOgmoogmo@05oogmo@03oo_knoolo?coo?cl00GooOgm00?oo?cloogmoOomoOd0
1OomoOd00oojn_[oo?clooclo002oogmo@04oeEEEOmiNGWooOgmooclo0SooOgm0_olo?`5oogmo@03
ooclo?omoOgooOgm00KooOgm0_olo?`5oogmo@03ooclo?omoOgooOgm00KooOgm0_olo?`5oogmo@03
ooclo?omoOgooOgm00KooOgm0_olo?`5oogmo@03ooclo?omoOgooOgm00KooOgm0_olo?`3oogmo@03
ookno_omoOgooOgm00;oo_kn00GooOgmookno_ono_kooOgmooknoP02oogmo@0=of9RH_mUIFGoJ6QX
ofYZJ_m]KFgoKfm_og5aLOmcLg?oMGEeogIfM_mgMgOoN7QhogUiN@0DogYjNP00@OmmOGd2ogalO00<
og]kNomiNGWoN7QhogMgMomeMGGoLg=cog5aLOm_KfooK6a/ofUYJOmVIVKoHf=S3OoinOT2ooShn008
ooWinOohn?Son?ShooShn?mmOGgo3Ph>oh61POoinOT3ooShn003ooWinOohn?SonOWi00;on?Sh00?o
nOWiooShn?ohn?P00_ohn?P00ooinOWon?ShooWin@03ooShn003ooWinOohn?SonOWi00;on?Sh00?o
nOWiooShn?ohn?P00_ohn?P00ooinOWon?ShooWin@02ooShn004om_KfooIfMWon?ShooWin@;on?Sh
00?onOWiooShn?ohn?P00_ohn?P00ooinOWon?ShooWin@03ooShn003ooWinOohn?SonOWi00;on?Sh
00?onOWiooShn?ohn?P00_ohn?P00ooinOWon?ShooWin@03ooShn003ooWinOohn?SonOWi00;on?Sh
00?onOWiooShn?ohn?P00_ohn?P00ooinOWon?ShooWin@03ooShn003ooWinOohn?SonOWi00;on?Sh
00?onOWiooShn?ohn?P00_ohn?P00ooinOWon?ShooWin@03ooShn003ooWinOohn?SonOWi00;on?Sh
00?onOWiooShn?ohn?P00_ohn?P00ooinOWon?ShooWin@03ooShn0conOWi00koHf=SofIVI_mYJFWo
K6a/ofm_KomaLG7oLg=cogEeMOmgMgOoN7QhogUiNOmjNW[oNg]kogalO1?oOGem0011oh:2PP;oPH61
00coP820oginO_mmOGgoNg]kogYjN_mhN7SoMGEeog=cLom`L73oKVi^ofYZJ_mVIVH;onc/k005on_[
joo/k>cojn_[onc/k?o[jn/00_o/k>`01oo[jn_oe]KFoi>CTooGemOojn_[onc/k?o[jn/00_o/k>`0
1Oo[jn_ok>c/on_[joo/k>cojn_[00;ok>c/0oo[jn/01?o/k>cojn_[onc/k?o[jn/2onc/k005on_[
joo/k>cojn_[onc/k?o[jn/00_o/k>`3on_[j`04onc/k?o[jn_ok>c/on_[j`;ok>c/00Gojn_[onc/
k?o[jn_ok>c/on_[j`02onc/k0?ojn_[00Cok>c/on_[joo/k>cojn_[0_o/k>`01Oo[jn_ok>c/on_[
joo/k>cojn_[00;ok>c/0oo[jn/01?o/k>cojn_[onc/k?o[jn/2onc/k005on_[joo/k>cojn_[onc/
k?o[jn/00_o/k>`3on_[j`04onc/k?o[jn_ok>c/on_[j`;ok>c/00Gojn_[onc/k?o[jn_ok>c/on_[
j`02onc/k0?ojn_[00Cok>c/on_[joo/k>cojn_[0_o/k>`01Oo[jn_ok>c/on_[joo/k>cojn_[00;o
k>c/0oo[jn/01?o/k>cojn_[onc/k?o[jn/3onc/k003ong]kOo/k>cok>c/00Ook>c/00coIVIVofYZ
J_m]KFgoL71`og=cLomeMGGoN7QhogYjN_mkNg_oOGemoginO_n0P802oh61PA?oPX:20011ogemO@0>
ogalO?mkNg_oNg]kogUiNOmhN7SoMgMgogEeMOmcLg?oLG5aofm_Kom/K6coJFUYofIVI_mSHf<>ooWi
n@06ooShn?oinOWon?ShooShn?oinOWon?Sh0_oinOT00oohn?SonOWiooShn002ooShn005ooWinOoh
n?SonOWiooShn?oinOT00_ohn?P01_oinOWon?ShooWinOoinOWon?ShooWin@?on?Sh00GonOWiooSh
n?oinOWon?ShooWin@02ooShn006ooWinOohn?SonOWiooWinOohn?SonOWi0oohn?P01OoinOWon?Sh
ooWinOohn?SonOWi00;on?Sh00KonOWiooShn?oinOWonOWiooShn?oinOT3ooShn005ooWinOohn?So
nOWiooShn?oinOT00_ohn?P01_oinOWon?ShooWinOoinOWon?ShooWin@?on?Sh00GonOWiooShn?oi
nOWon?ShooWin@02ooShn006ooWinOohn?SonOWiooWinOohn?SonOWi0oohn?P01OoinOWon?ShooWi
nOohn?SonOWi00;on?Sh00KonOWiooShn?oinOWonOWiooShn?oinOT3ooShn005ooWinOohn?SonOWi
ooShn?oinOT00_ohn?P01_oinOWon?ShooWinOoinOWon?ShooWin@;on?Sh3?oinOT03?mSHf?oIVIV
ofUYJOm/K6coKfm_og5aLOmcLg?oMGEeogMgMomhN7SoNGUiog]kN`;oO7al4ommOGd004;oNWYj00ko
NGUiogQhN?mgMgOoMWIfogEeMOmcLg?oLG5aofm_Kom]KFgoJVYZofQXJ?mUIFGoHV9Roogmo@;oo_kn
0oomoOd4ooknoPKooOgm00Koo?cloogmoOomoOgoo?cloogmoOolo?`5oogmo@03ooclo?omoOgooOgm
00;ooOgm00Koo?cloogmoOomoOgoo?cloogmoOolo?`5oogmo@03ooclo?omoOgooOgm00;ooOgm00Ko
o?cloogmoOomoOgoo?cloogmoOolo?`5oogmo@03ooclo?omoOgooOgm00;ooOgm00Koo?cloogmoOom
oOgoo?cloogmoOolo?`5oogmo@03ooclo?omoOgooOgm00;ooOgm00Koo?cloogmoOomoOgoo?cloogm
oOolo?`5oogmo@03ooclo?omoOgooOgm00;ooOgm00Koo?cloogmoOomoOgoo?cloogmoOolo?`5oogm
o@03ooclo?omoOgooOgm00;ooOgm00Koo?cloogmoOomoOgoo?cloogmoOolo?`5oogmo@03ooclo?om
oOgooOgm00;ooOgm00Koo?cloogmoOomoOgoo?cloogmoOolo?`6oogmo@;oo_kn00?ooOgmookno_om
oOd00_ono_h3oogmo@0=of9RH_mUIFGoJ6QXof][Jom]KFgoKfm_og5aLOmcLg?oMGEeogIfM_mgMgOo
N7QhogUiN@0DogYjNP00@OmmOGd03_mlO7coNg]kog]kNomiNGWoN7QhogMgMomeMGGoLg=cog5aLOm_
KfooK6a/ofUYJOmVIVKoHf=S3?oinOT2ooShn003ooWinOohn?SonOWi00;on?Sh0ooinOT4ooShn0;o
nOWi0_ohn?P00ooinOWon?ShooWin@02ooShn0?onOWi1?ohn?P2ooWin@;on?Sh00?onOWiooShn?oi
nOT00_ohn?P3ooWin@Con?Sh0_oinOT2ooShn003ooWinOohn?SonOWi00;on?Sh0ooinOT4ooShn0;o
nOWi0_ohn?P00ooinOWon?ShooWin@02ooShn0?onOWi1?ohn?P2ooWin@;on?Sh00?onOWiooShn?oi
nOT00_ohn?P3ooWin@Con?Sh0_oinOT2ooShn003ooWinOohn?SonOWi00;on?Sh0ooinOT4ooShn0;o
nOWi0_ohn?P00ooinOWon?ShooWin@02ooShn0?onOWi0oohn?P=ooWin@0:of=SHomVIVKoJFUYofa/
K?m_KfooLG5aog=cLomeMGGoMgMgogQhN0;oNWYj00GoNg]kogalO?mmOGgoOGemogalO00@ogemO@00
@On2PX82oh61P@0<ogmoOomnOWkoOGemog]kNomjNW[oN7QhogEeMOmcLg?oL71`ofe]KOmZJV[oIfMW
1Oo/k>`00oo]kNgok>c/onc/k004onc/k0;ojn_[00?ok>c/on_[joo[jn/00_o[jn/01?o/k>cojn_[
onc/k?o[jn/2onc/k0;ojn_[00Cok>c/on_[joo[jn_ok>c/0_o[jn/01_oAdM7oNg]konGUiOo[jn_o
k>c/on_[j`;ok>c/0_o[jn/01?o/k>cojn_[on_[joo/k>`4on_[j`04onc/k?o[jn_ok>c/on_[j`;o
k>c/0_o[jn/01?o/k>cojn_[on_[joo/k>`4on_[j`04onc/k?o[jn_ok>c/on_[j`;ok>c/0_o[jn/0
1?o/k>cojn_[on_[joo/k>`4on_[j`04onc/k?o[jn_ok>c/on_[j`;ok>c/0_o[jn/01?o/k>cojn_[
on_[joo/k>`4on_[j`04onc/k?o[jn_ok>c/on_[j`;ok>c/0_o[jn/01?o/k>cojn_[on_[joo/k>`4
on_[j`04onc/k?o[jn_ok>c/on_[j`;ok>c/0_o[jn/01?o/k>cojn_[on_[joo/k>`4on_[j`04onc/
k?o[jn_ok>c/on_[j`?ok>c/00Gojn_[ong]kOo/k>cok>c/ong]k@06onc/k00=ong]kOmVIVKoJVYZ
ofe]KOm`L73oLg=cogEeMOmhN7SoNWYjogalO?mmOGgoOWinogmoO`02oh61PA?oPX:20011ogemO@;o
O7al0_mjNWX02_mhN7SoMgMgogEeMOmcLg?oLG5aofm_Kom/K6coJVYZofIVI_mSHf<=ooWin@09ooSh
n?oJf][o=cLgoeADE?nXZ:Som?CdooShn?oinOWon?Sh00;onOWi00?on?ShooWinOohn?P00_oinOT2
ooShn007ooWinOohn?SomOGeobPX:?nTY:ConOWiooShn002ooWin@03ooShn?oinOWon?Sh00;onOWi
0_ohn?P01ooinOWon?ShooWinOoinOWon?ShooWinOohn?P00_oinOT00oohn?SonOWiooShn002ooWi
n@;on?Sh00OonOWiooShn?oinOWonOWiooShn?oinOWon?Sh00;onOWi00?on?ShooWinOohn?P00_oi
nOT2ooShn007ooWinOohn?SonOWiooWinOohn?SonOWiooShn002ooWin@03ooShn?oinOWon?Sh00;o
nOWi0_ohn?P01ooinOWon?ShooWinOoinOWon?ShooWinOohn?P00_oinOT00oohn?SonOWiooShn002
ooWin@;on?Sh00OonOWiooShn?oinOWonOWiooShn?oinOWon?Sh00;onOWi00?on?ShooWinOohn?P0
0_oinOT2ooShn007ooWinOohn?SonOWiooWinOohn?SonOWiooShn002ooWin@03ooShn?oinOWonOWi
00_onOWi00_oHf=SofIVI_mYJFWoK6a/ofm_KomaLG7oLg=cogEeMOmgMgOoN7QhogUiN@02og]kN`03
ogalO?mmOGgoOGem017oOGem0012ogYjNP0AogUiNOmhN7SoMgMgogIfM_meMGGoLg=cog5aLOm_Kfoo
KFe]of][JomXJ6SoIFEUof9RH_ono_kooOgmookno_omoOd00_ono_h2oogmo@03ookno_omoOgoo_kn
00?ooOgm00Gok>c/ok>c/on^[Zko:2PXoj^[Z`03oogmo@03oo[jn_o]kNgooOgm00GooOgm00Koo?cl
oogmoOomoOgooOgmoi2@T?m7AdL2oogmo@;oo?cl1_omoOd00oolo?cooOgmoogmo@05oogmo@;oo?cl
1_omoOd00oolo?cooOgmoogmo@05oogmo@;oo?cl1_omoOd00oolo?cooOgmoogmo@05oogmo@;oo?cl
1_omoOd00oolo?cooOgmoogmo@05oogmo@;oo?cl1_omoOd00oolo?cooOgmoogmo@05oogmo@;oo?cl
1_omoOd00oolo?cooOgmoogmo@05oogmo@;oo?cl0_omoOd01Oono_kooOgmookno_ono_kooOgm00;o
o_kn00?ooOgmookno_omoOd00_ono_h03OmRHV;oIFEUofQXJ?mZJV[oKFe]ofm_KomaLG7oLg=cogEe
MOmfMWKoMgMgogQhN?miNGT05?mjNWX000ooOGem1?mlO7`00ommOGgoO7alogalO008ogalO003ogem
OOmlO7coO7al00;oO7al00?oOGemogalO?mlO7`02?mlO7`00ommOGgoO7alogalO002ogalO003ogem
OOmlO7coO7al00coO7al00goNg]kogYjN_miNGWoN7QhogMgMomeMGGoLg=cog5aLOm_KfooK6a/ofUY
JOmVIVKoHf=S00conOWi00Oon?ShooWinOohn?Son?ShooWinOm^KVkoGEeM00;on?Sh017o_KfmobHV
9_lC4a?oF5QHohR8R?lj>S[onOWiooShn?m8B4SoPX:2ooShn?oinOWon?ShoiBDU?l=3@godm?CooSh
n002ooWin@;on?Sh0_oinOT01oohn?SonOWiooShn?ohn?SonOWiooShn?oinOT00oohn?P2ooWin@;o
n?Sh0_oinOT01oohn?SonOWiooShn?ohn?SonOWiooShn?oinOT00oohn?P2ooWin@;on?Sh0_oinOT0
1oohn?SonOWiooShn?ohn?SonOWiooShn?oinOT00oohn?P2ooWin@;on?Sh0_oinOT01oohn?SonOWi
ooShn?ohn?SonOWiooShn?oinOT00oohn?P2ooWin@;on?Sh0_oinOT01oohn?SonOWiooShn?ohn?So
nOWiooShn?oinOT00oohn?P2ooWin@;on?Sh0_oinOT01oohn?SonOWiooShn?ohn?SonOWiooShn?oi
nOT00oohn?P2ooWin@;on?Sh3?oinOT03OmSHf?oIVIVofUYJOm/K6coKfm_og5aLOmcLg?oMGEeogMg
MomhN7SoNGUiogYjN_mkNg/01OmlO7`?ogemO@00@_n1PH403_n0P83oOgmooginO_mmOGgoNg]kogUi
NOmgMgOoMGEeog9bL_m`L73oKFe]ofYZJ_mVIVKojn_[1_o/k>`01oo[jn_ok>c/onc/k?o/k>cojn_[
onc/k?o[jn/00_o/k>`04?o[jn_oQXJ6ob/[:oo/k>cojn_[oeMGEomKFe_ohn?SoiNGUolJ6Q[o>3Ph
on_[joo/k>coADE5ogemOOo/k>`2on_[j`04ocLg=olF5QKoL71`onc/k0;ojn_[00Kok>c/on_[joo/
k>cojn_[onc/k?o[jn/2onc/k0;ojn_[0_o/k>`02_o[jn_ok>c/on_[joo[jn_ok>c/on_[joo/k>co
jn_[onc/k?o[jn/2onc/k0;ojn_[0_o/k>`02_o[jn_ok>c/on_[joo[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jn/2onc/k0;ojn_[0_o/k>`02_o[jn_ok>c/on_[joo[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jn/2onc/k0;ojn_[0_o/k>`02_o[jn_ok>c/on_[joo[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jn/2onc/k0;ojn_[0_o/k>`02_o[jn_ok>c/on_[joo[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jn/2
onc/k0;ojn_[0_o/k>`01?o[jn_ok>c/on_[joo[jn/3onc/k003on_[joo/k>cok>c/00;ok>c/00?o
jn_[onc/k?o/k>`00oo/k>`03OmVIVKoJFUYofe]KOm`L73oLg=cogEeMOmgMgOoNGUiog]kNommOGgo
OWinogmoOon0P8005?n1PH4000GoO7al1_mkNg/01?mlO7coNg]kog]kNomlO7`cog]kN`0=ogYjN_mi
NGWoN7QhogMgMomeMGGoM7Adog9bL_m`L73oKVi^of][JomYJFWoIFEUof=SH`02ooWin@03ooShn?oi
nOWon?Sh00OonOWi1Oohn?P01_n<S8co:BTYooShn?ohn?So=SHfoi:BTP;on?Sh00KoOGemocXj>_oh
n?Son?ShodM7Aon1PH42ooShn005ol[:b_l=3@goWinOoahN7_obl_801?ohn?P00ooinOWon?ShooSh
n004ooShn005ooWinOohn?Son?ShooShn?oinOT01?ohn?P00ooinOWon?ShooShn004ooShn005ooWi
nOohn?Son?ShooShn?oinOT01?ohn?P00ooinOWon?ShooShn004ooShn005ooWinOohn?Son?ShooSh
n?oinOT01?ohn?P00ooinOWon?ShooShn004ooShn005ooWinOohn?Son?ShooShn?oinOT01?ohn?P0
0ooinOWon?ShooShn004ooShn005ooWinOohn?Son?ShooShn?oinOT01?ohn?P00ooinOWon?ShooSh
n004ooShn005ooWinOohn?Son?ShooShn?oinOT01?ohn?P2ooWin@03ooShn?oinOWon?Sh00?onOWi
017on?ShooWinOohn?SonOWiof=SHomVIVKoJFUYof][Jom^KVkoL71`og9bL_mdM7CoMGEeogMgMomh
N7SoNGUiogYjNP09og]kN`04ogalO?mkNg_oNg]kogalO0;oNg]k1OmlO7`000KoNGUi??mhN7P03Omg
MgOoMWIfogEeMOmdM7CoLg=cog5aLOm_KfooKFe]of][JomYJFWoIVIVof=SHomPH6003_omoOd07?ol
o?cooOgmooclo?n>SXko:RXZooclo?omoOgo=SHfoiJFU_omoOgoo?cloi>CToli>CWoo?cloogmoOm9
BDWoQ8B4oogmoOolo?coKfm_odY:B_olo?co<S8bojNWYoolo?cooOgmooclo?omoOd2ooclo0;ooOgm
00?oo?cloogmoOolo?`00oolo?`01_omoOgoo?clooclo?omoOgoo?cloogmo@;oo?cl0_omoOd00ool
o?cooOgmooclo003ooclo006oogmoOolo?coo?cloogmoOolo?cooOgm0_olo?`2oogmo@03ooclo?om
oOgoo?cl00?oo?cl00KooOgmooclo?olo?cooOgmooclo?omoOd2ooclo0;ooOgm00?oo?cloogmoOol
o?`00oolo?`01_omoOgoo?clooclo?omoOgoo?cloogmo@;oo?cl0_omoOd00oolo?cooOgmooclo003
ooclo006oogmoOolo?coo?cloogmoOolo?cooOgm0_olo?`2oogmo@03ooclo?omoOgoo?cl00?oo?cl
00OooOgmooclo?olo?cooOgmooclo?omoOgoo?cl00_ooOgm00goH61Pof=SHomVIVKoJFUYof][Jom]
KFgoKfm_og5aLOmcLg?oM7AdogEeMOmfMWKoMgMg00goN7Qh00?oNGUiogQhN?mhN7P01?miNGT000;o
Ng]k00?oNWYjog]kNomjNWX01omjNWXfogUiN@0=ogQhN?mgMgOoMWIfogEeMOmdM7CoLW9bog1`L?m^
KVkoK6a/ofUYJOmWIfOoI6ATof5QH@02ooWin@05ooShn?oinOWonOWiooShn?oinOT00_ohn?P2ooWi
n@Kon?Sh01GoS8b<obTY:Oohn?Son?ShocDe=OnEUIGon?ShooOgmon@T93o>CTiooShn?ogmoOoAdM7
oh61POohn?Sol?3`oaXJ6_nQXJ7on?Shoi6ATOm5ADD00_ohn?P01oogmoOon?ShooShn?ohn?SomoOg
ooShn?ogmoL02Oohn?P01oogmoOon?ShooShn?ohn?SomoOgooShn?ogmoL02Oohn?P01oogmoOon?Sh
ooShn?ohn?SomoOgooShn?ogmoL02Oohn?P01oogmoOon?ShooShn?ohn?SomoOgooShn?ogmoL02Ooh
n?P01oogmoOon?ShooShn?ohn?SomoOgooShn?ogmoL02Oohn?P01oogmoOon?ShooShn?ohn?SomoOg
ooShn?ogmoL03_ohn?P00ooinOWon?ShooWin@02ooWin@0AooShn?oinOWonOWiooShn?mQHF7oI6AT
ofMWIomZJV[oK6a/ofi^K_m`L73oLW9bogAdM?meMGGoMWIfogMgMomhN7P02?miNGT9ogYjNP?oNg]k
0002ogmoO`KoOWin>?mmOGd2ogalO00=og]kNomjNW[oNGUiogQhN?mgMgOoMGEeog=cLomaLG7oKfm_
ofa/K?mZJV[oIVIVof=SH`0>ooknoP05oogmoOono_kooOgmohn?SolZ:RX00_omoOd01_lg=cOoV9RH
oogmoOono_koU9BDoc/k>`;ooOgm00koBTY:ohF5QOono_koYjNWoaXJ6_odm?CooOgmong]kOlF5QKo
f=SHoogmoOono_kooOgmooknoP;ooOgm00?oo_knoogmoOono_h02?omoOd00oono_kooOgmooknoP02
oogmo@03ookno_omoOgoo_kn00SooOgm00?oo_knoogmoOono_h00_omoOd00oono_kooOgmooknoP08
oogmo@03ookno_omoOgoo_kn00;ooOgm00?oo_knoogmoOono_h02?omoOd00oono_kooOgmooknoP02
oogmo@03ookno_omoOgoo_kn00SooOgm00?oo_knoogmoOono_h00_omoOd00oono_kooOgmooknoP08
oogmo@03ookno_omoOgoo_kn00_oo_kn00goHf=SofIVI_mZJV[oK6a/ofm_KomaLG7oLg=cogEeMOmg
MgOoN7QhogUiNOmjNW[oNg]k00;oO7al2_mmOGd6oginOP;oOgmo0003ogUiN@CoN7Qh1OmgMgL2ogIf
MP;oMgMg0omfMWH00omgMgOoMWIfogMgM`03ogIfMP03ogMgMomfMWKoMgMg00;oMWIf0_mgMgL3ogIf
MP03ogMgMomfMWKoMgMg00?oMWIf00?oMgMgogIfM_mgMgL00_mfMWH2ogMgM`?oMWIf00?oMgMgogIf
M_mgMgL00omfMWH01OmgMgOoMWIfogMgMomfMWKoMgMg00;oMWIf00ooMgMgogIfM_meMGGoMGEeogAd
M?mcLg?oLG5aog1`L?m^KVkoK6a/ofYZJ_mXJ6SoIFEUof9RH_mOGel01_ohn?P00ooinOWon?ShooSh
n003ooShn0GomoOg00KoS8b<obTY:OogmoOomoOgodY:B_nNWYh2ooOgm`0:oiZJV_m<C4con?ShooOg
mom6ATKoPH61ooOgmomOGeooM7AdooShn0;omoOg00?oKfm_ohN7QoogmoL00oogmoL00oohn?SomoOg
ooOgm`03ooOgm`;on?Sh0_ogmoL2ooShn0ComoOg00?on?ShooOgmoogmoL00oogmoL2ooShn0;omoOg
0_ohn?P4ooOgm`03ooShn?ogmoOomoOg00?omoOg0_ohn?P2ooOgm`;on?Sh1?ogmoL00oohn?SomoOg
ooOgm`03ooOgm`;on?Sh0_ogmoL2ooShn0ComoOg00?on?ShooOgmoogmoL00oogmoL2ooShn0;omoOg
0_ohn?P4ooOgm`03ooShn?ogmoOomoOg00?omoOg0_ohn?P2ooOgm`;on?Sh00ComoOgooShn?ogmoOo
moOg2oohn?P02omPH63oHV9RofEUIOmWIfOoJVYZofa/K?m^KVkoL71`og5aLOmbLW;oLg=c00;oMGEe
00CoMWIfogMgMomgMgOoMgMg0omfMWH5ogMgM`GoN7Qh0omiNGT00003ogIfM_meMGGoMGEe00;oMGEe
0omdM7@7og=cLcCoLW9b00coLG5aofm_Kom_KfooKFe]ofa/K?mZJV[oJFUYofMWIomTI6CoHV9Rof1P
H?mMGEd:onWYj@03on[Zj_oYjNWoj>SX00;ojNWY0_oXj>P00on3Ph?o9BDUonWYj@03onSXj0;ojNWY
00Koj>SXonWYjOoXj>Soj>SXod92@_mjNWX2onSXj003onWYjOoXj>SojNWY00?oj>SX0_oYjNT00ooX
j>SojNWYonSXj002onSXj006onWYjOoXj>Soj>SXonWYjOoXj>SojNWY0ooXj>P2onWYj@03onSXj?oY
jNWoj>SX00;oj>SX00KojNWYonSXj?oXj>SojNWYonSXj?oYjNT3onSXj0;ojNWY00?oj>SXonWYjOoX
j>P00_oXj>P01_oYjNWoj>SXonSXj?oYjNWoj>SXonWYj@?oj>SX0_oYjNT00ooXj>SojNWYonSXj002
onSXj006onWYjOoXj>Soj>SXonWYjOoXj>SojNWY0ooXj>P2onWYj@03onSXj?oYjNWoj>SX00;oj>SX
00KojNWYonSXj?oXj>SojNWYonSXj?oYjNT3onSXj0;ojNWY00?oj>SXonWYjOoXj>P00_oXj>P01_oY
jNWoj>SXonSXj?oYjNWoj>SXonWYj@?oj>SX3ooYjNT03?mMGEgoH61Pof9RH_mTI6CoIfMWofUYJOmZ
JV[oK6a/ofi^K_m_KfooL71`og5aL@KoLW9b00?oLg=cog9bL_mcLg<01?mcLg<3ogAdM0?oMGEe0_mf
MWH000;oMgMg0_mfMWH2ogEeM@?oM7Ad1_mcLg<4og9bLP03og=cLombLW;oLg=c00?oLW9b00?oLg=c
og9bL_mcLg<00_mbLW800omcLg?oLW9bog9bLP02og9bLP03og=cLombLW;oLg=c00?oLW9b00?oLg=c
og9bL_mcLg<00_mbLW800omcLg?oLW9bog9bLP02og9bLP03og=cLombLW;oLg=c00?oLW9b00?oLg=c
og9bL_mcLg<00_mbLW800omcLg?oLW9bog9bLP02og9bLP0<og5aLOm`L73oKfm_ofe]KOm/K6coJVYZ
ofUYJOmWIfOoIFEUof9RH_mPH63oGEeM1?ogmoL00oohn?SomoOgooOgm`07ooOgm`09ooKfm_ogmoOo
m_KfohZ:R_lW9bOom_KfooOgmoofm_KomoOg00?om_Kf00KomoOgooKfm_ogmoOoATI6oh20P?ogmoL4
ooKfmP03ooOgmoofm_KomoOg00?om_Kf00?omoOgooKfm_ogmoL00_ofm_H00oogmoOom_KfooKfmP02
ooKfmP03ooOgmoofm_KomoOg00?om_Kf00?omoOgooKfm_ogmoL00_ofm_H00oogmoOom_KfooKfmP02
ooKfmP03ooOgmoofm_KomoOg00?om_Kf00?omoOgooKfm_ogmoL00_ofm_H00oogmoOom_KfooKfmP02
ooKfmP03ooOgmoofm_KomoOg00?om_Kf00?omoOgooKfm_ogmoL00_ofm_H00oogmoOom_KfooKfmP02
ooKfmP03ooOgmoofm_KomoOg00?om_Kf00?omoOgooKfm_ogmoL00_ofm_H00oogmoOom_KfooKfmP02
ooKfmP03ooOgmoofm_KomoOg00?om_Kf00?omoOgooKfm_ogmoL00_ofm_H00oogmoOom_KfooKfmP02
ooKfmP06ooOgmoofm_KomoOgooKfm_ogmoOom_Kf0_ogmoL01?ohn?SomoOgooOgmoohn?P4ooOgm`0>
ooShn?ogmoOoGEeMof1PH?mRHV;oI6ATofMWIomYJFWoJVYZofa/K?m]KFgoKfm_og1`L?maLG42og9b
LP03og=cLombLW;oLW9b00;oLW9b1OmcLg<3ogAdM0;oMGEe0_mfMWH2ogMgM`0000CoNg]kogYjN_mi
NGWoNGUi0_mhN7P01?mgMgOoMWIfogIfM_mfMWHgogEeM@;oM7Ad0_mbLW803?maLG7oKfm_ofi^K_m/
K6coJVYZofQXJ?mVIVKoI6ATof5QHOmNGUkoo?cloogmo@?oo?cl00GooOgmooclo?omoOgoo?cloogm
o@05ooclo004oo_knoolo?codM7AojVYZ@?oo?cl00?ono_kooclo?olo?`00_olo?`01Ookno_oo?cl
odQ8B?n4Q8Cono_k00Koo?cl00?ono_kooclo?olo?`00_olo?`01Ookno_oo?clooclo?olo?cono_k
00Koo?cl00?ono_kooclo?olo?`00_olo?`01Ookno_oo?clooclo?olo?cono_k00Koo?cl00?ono_k
ooclo?olo?`00_olo?`01Ookno_oo?clooclo?olo?cono_k00Koo?cl00?ono_kooclo?olo?`00_ol
o?`01Ookno_oo?clooclo?olo?cono_k00Koo?cl00?ono_kooclo?olo?`00_olo?`01Ookno_oo?cl
ooclo?olo?cono_k00Koo?cl00?ono_kooclo?olo?`00_olo?`01Ookno_oo?clooclo?olo?cono_k
00Koo?cl00?ono_kooclo?olo?`00oolo?`00oomoOgoo?cloogmo@02ooclo00AoogmoOolo?coo?cl
ooclo?omoOgoGUiNof5QHOmTI6CoIVIVofUYJOmZJV[oK6a/ofi^K_m_KfooLG5aog9bL_mcLg<00_md
M7@2ogEeM@03ogAdM?meMGGoMGEe00CoMGEe0_mfMWH2ogMgM`;oN7Qh00?oNGUiogYjN_mjNWX00Omk
Ng/00005ogEeMOmdM7CoLg=cog=cLombLW800_maLG400om`L73oKfm_ofm_K`02ofm_KcGoKVi^0_m]
KFd03?m/K6coJf][ofYZJ_mYJFWoJ6QXofIVI_mUIFGoHf=Sof5QHOmOGeooG5aLoeYJFP;om_Kf00?o
moOgooKfm_ogmoL02Oofm_H00ooemOGom_KfooKfmP02ooKfmP03ooGemOofm_Kom_Kf00?om_Kf00Ko
mOGeooKfm_ofm_Kom_Kfoo;bl_oclo<4ooKfmP03ooGemOofm_Kom_Kf00?om_Kf00?omOGeooKfm_of
m_H00_ofm_H00ooemOGom_KfooKfmP02ooKfmP03ooGemOofm_Kom_Kf00?om_Kf00?omOGeooKfm_of
m_H00_ofm_H00ooemOGom_KfooKfmP02ooKfmP03ooGemOofm_Kom_Kf00?om_Kf00?omOGeooKfm_of
m_H00_ofm_H00ooemOGom_KfooKfmP02ooKfmP03ooGemOofm_Kom_Kf00?om_Kf00?omOGeooKfm_of
m_H00_ofm_H00ooemOGom_KfooKfmP02ooKfmP03ooGemOofm_Kom_Kf00?om_Kf00?omOGeooKfm_of
m_H00_ofm_H00ooemOGom_KfooKfmP02ooKfmP03ooGemOofm_Kom_Kf00?om_Kf00?omOGeooKfm_of
m_H00_ofm_H00ooemOGom_KfooKfmP02ooKfmP03ooGemOofm_Kom_Kf00com_Kf013omoOgooKfm_og
moOom_KfoeYJF_mLG5coGemOof5QHOmSHf?oIFEUofIVI_mXJ6SoJFUYofYZJ_m[Jf_oK6a/0_m]KFd6
ofi^KPGoKfm_00?oL71`og5aLOmaLG400_mbLW81og=cL`7oM7Ad0OmeMGD00006og5aLOm`L73oKfm_
ofm_Kom^KVkoKFe]0_m/K6`3of][J`;oJVYZ00?oJFUYofYZJ_mYJFT00omYJFT00omZJV[oJFUYofUY
J@05ofUYJ@04ofYZJ_mYJFWoJFUYofYZJPCoJFUY00?oJVYZofUYJOmYJFT01OmYJFT01?mZJV[oJFUY
ofUYJOmZJVX4ofUYJ@03ofYZJ_mYJFWoJFUY00GoJFUY00?oJVYZofUYJOmYJFT01OmYJFT03OmXJ6So
IfMWofIVI_mUIFGoI6ATof=SHomQHF7oGemOoeeMGOmLG5coFEUIoeMGEooWinL00_oXj>P3onOWi`;o
j>SX00?oinOWonSXj?oWinL04?oWinL00ooVi^KoinOWonOWi`0=onOWi`03onKVi_oWinOoinOW00go
inOW00?oi^KVonOWiooWinL03OoWinL00ooVi^KoinOWonOWi`0=onOWi`03onKVi_oWinOoinOW00go
inOW00?oi^KVonOWiooWinL03OoWinL00ooVi^KoinOWonOWi`0;onOWi`08onSXj?oWinOoinOWonOW
iooXj>SoinOWonSXj?oWinL2onSXj0?oinOW00coEeMGoeYJF_mLG5coGUiNoemOGomQHF7oHf=SofAT
I?mUIFGoIVIVofMWIomXJ6P5ofUYJ@03ofYZJ_mYJFWoJFUY00;oJVYZ0om[Jf/2ofa/K005ofe]KOm^
KVkoKfm_ofm_Kom`L7000OmaLG400008og9bL_maLG7oKfm_ofm_Kom^KVkoKFe]ofa/K?m[Jf/3ofYZ
JPCoJFUY1?mXJ6P00omYJFWoJ6QXofQXJ008ofQXJ003ofUYJOmXJ6SoJ6QX00;oJ6QX00?oJFUYofQX
J?mXJ6P02?mXJ6P00omYJFWoJ6QXofQXJ002ofQXJ003ofUYJOmXJ6SoJ6QX00coJ6QX0_mWIfL03?mV
IVKoIFEUofATI?mSHf?oHF5Qof1PH?mNGUkoGEeMoeYJF_mHF5SoEUIFooKfmP?omOGe00?om_KfooGe
mOoemOD01_oemOD01Oodm?ComOGeooGemOoemOGom?Cd00ComOGe00?om?CdooGemOodm?@01?oemOD0
1Oodm?ComOGeooGemOoemOGom?Cd00ComOGe00?om?CdooGemOodm?@01?oemOD01Oodm?ComOGeooGe
mOoemOGom?Cd00ComOGe00?om?CdooGemOodm?@01?oemOD01Oodm?ComOGeooGemOoemOGom?Cd00Co
mOGe00?om?CdooGemOodm?@01?oemOD01Oodm?ComOGeooGemOoemOGom?Cd00ComOGe00?om?CdooGe
mOodm?@01?oemOD01Oodm?ComOGeooGemOoemOGom?Cd00ComOGe00?om?CdooGemOodm?@01?oemOD0
1Oodm?ComOGeooGemOoemOGom?Cd00ComOGe00?om?CdooGemOodm?@01?oemOD01Oodm?ComOGeooGe
mOoemOGom?Cd00ComOGe00?om?CdooGemOodm?@01ooemOD04?ofm_KomOGeooGemOoemOGom_KfooGe
mOmFEUKoF5QHoeYJF_mMGEgoGemOof1PH?mQHF7oHf=SofATI?mUIFD2ofIVIP03ofMWIomXJ6SoJ6QX
00?oJ6QX1?mYJFT3ofYZJP;oK6a/0_m]KFd00om_KfooL71`og5aL@01og9bLP0000SoMGEeog=cLomb
LW;oLG5aofm_Kom^KVkoKFe]ofa/K0;oJf][0_mZJVXeofUYJ@;oJ6QX00coIfMWofIVI_mVIVKoIFEU
of=SHomRHV;oH61PoemOGomMGEgoFe]KoeUIFOmFEUH?oo[jnP08ooWinOojn_[onOWiooWinOojn_[o
nOWioo[jn_oinOT3oo[jnP03ooWinOojn_[onOWi00;on_[j00SonOWioo[jn_oinOWonOWioo[jn_oi
nOWon_[jooWin@?on_[j00?onOWioo[jn_oinOT00_ojn_X02?oinOWon_[jooWinOoinOWon_[jooWi
nOojn_[onOWi0oojn_X00ooinOWon_[jooWin@02oo[jnP08ooWinOojn_[onOWiooWinOojn_[onOWi
oo[jn_oinOT3oo[jnP03ooWinOojn_[onOWi00;on_[j00SonOWioo[jn_oinOWonOWioo[jn_oinOWo
n_[jooWin@?on_[j00?onOWioo[jn_oinOT00_ojn_X02?oinOWon_[jooWinOoinOWon_[jooWinOoj
n_[onOWi0oojn_X00ooinOWon_[jooWin@02oo[jnP08ooWinOojn_[onOWiooWinOojn_[onOWioo[j
n_oinOT3oo[jnP03ooWinOojn_[onOWi00;on_[j00SonOWioo[jn_oinOWonOWioo[jn_oinOWon_[j
ooWin@?on_[j00?onOWioo_knoojn_X02Oojn_X02OmFEUKoFEUIoe]KFomMGEgoGemOof1PH?mRHV;o
Hf=SofEUI@02ofIVIP04ofMWIomXJ6SoJ6QXofQXJ0KoJFUY0_mZJVX2of][J`07ofa/K?m]KFgoKVi^
ofm_Kom`L73oLW9bog=cL`01ogEeM@0000KoKVi^ofe]KOm[Jf_oJVYZofUYJOmXJ6P2ofIVIP03ofEU
IOmTI6CoHf=S00;oHf=S=?mRHV82of5QH@;oH61P00_oGemOoeiNG_mMGEgoG5aLoeYJF_mIFEWoEeMG
oeIFE_mDE5CoDU9Boo?cl`02ooCdm003oo?cloodm?Com?Cd00;om?Cd00?olo?cooCdm?odm?@00_od
m?@02Ooclo?oeMGEoc8b<_m?CdooXj>Sono_kooclo?om?Cdoo?cl`02ooCdm003oo?cloodm?Colo?c
00;om?Cd0_oclo<01oodm?Colo?cooCdm?odm?Colo?cooCdm?oclo<00_odm?@00ooclo?om?Cdoo?c
l`02ooCdm0;olo?c00Oom?Cdoo?cloodm?Com?Cdoo?cloodm?Colo?c00;om?Cd00?olo?cooCdm?oc
lo<00_odm?@2oo?cl`07ooCdm?oclo?om?CdooCdm?oclo?om?Cdoo?cl`02ooCdm003oo?cloodm?Co
lo?c00;om?Cd0_oclo<01oodm?Colo?cooCdm?odm?Colo?cooCdm?oclo<00_odm?@00ooclo?om?Cd
oo?cl`02ooCdm0;olo?c00Oom?Cdoo?cloodm?Com?Cdoo?cloodm?Colo?c00;om?Cd00?olo?cooCd
m?oclo<00_odm?@2oo?cl`07ooCdm?oclo?om?CdooCdm?oclo?om?Cdoo?cl`02ooCdm003oo?clood
m?Colo?c00;om?Cd0_oclo<01oodm?Colo?cooCdm?odm?Colo?cooCdm?oclo<00_odm?@00ooclo?o
m?CdooCdm002ooCdm004oo?cloodm?Com?Cdoo?cl`;om?Cd00golo?cooCdm?odm?CoDU9BoeADE?mF
EUKoEeMGoeUIFOmJFU[oG5aLoeeMGOmNGUkoGemO00;oH61P0_mQHF46of9RHP;oHf=S0_mTI6@02?mU
IFGoIVIVofMWIomXJ6SoJFUYofYZJ_m/K6coKFe]0Om_Kfl00008of][JomYJFWoIfMWofIVI_mUIFGo
I6ATof9RH_mQHF42of1PH003oemOGomNGUkoGUiN03GoGEeM0_mLG5`02omKFe_oFUYJoeYJF_mIFEWo
F5QHoeMGEomEEEGoE5ADoe=CDomADE7oCdm?00OoiNGU00Goi>CTonGUiOoUiNGoiNGUonCTi002onGU
i@06omCDe?nPX:3oVi^Kob0P8?nIVIWoi>CT0_oUiND01_oQhN7oe]KFonGUiOoTi>CoiNGUonCTi0;o
iNGU00Koi>CTonGUiOoTi>Coi>CTonGUiOoTi>@2onGUi@06onCTi?oJf][od=3@onCTi?oUiNGoi>CT
0_oUiND01_oTi>CoiNGUonCTi?oTi>CoiNGUonCTi0;oiNGU0_oTi>@01?oUiNGoi>CTonGUiOoTi>@2
onGUi@06onCTi?oUiNGoi>CTonCTi?oUiNGoi>CT0_oUiND2onCTi004onGUiOoTi>CoiNGUonCTi0;o
iNGU00Koi>CTonGUiOoTi>Coi>CTonGUiOoTi>@2onGUi@;oi>CT00CoiNGUonCTi?oUiNGoi>CT0_oU
iND01_oTi>CoiNGUonCTi?oTi>CoiNGUonCTi0;oiNGU0_oTi>@01?oUiNGoi>CTonGUiOoTi>@2onGU
i@06onCTi?oUiNGoi>CTonCTi?oUiNGoi>CT0_oUiND2onCTi004onGUiOoTi>CoiNGUonCTi0;oiNGU
00Koi>CTonGUiOoTi>Coi>CTonGUiOoTi>@2onGUi@;oi>CT3_oUiND02Om?CdooDE5Aoe=CDomDE5Co
EEEEoeMGEomHF5SoFEUIoeYJFP02oe]KF`03oeaLG?mMGEgoGEeM00KoGEeM0_mNGUh02_mOGeooH61P
of1PH?mQHF7oHV9Rof=SHomUIFGoIVIVofQXJ?mYJFT1of][J`0000[oJf][ofUYJOmWIfOoIVIVofAT
I?mSHf?oHF5Qof1PH?mOGeooGUiN0_mMGEd3oeaLG3?oFe]K0_mJFUX2oeUIF@0<oeQHF?mGEeOoEUIF
oeEEEOmDE5CoDU9Boe5ADOm?CdooCTi>oo?cloobl_;olo?c0oobl_82oo?cl`;ol_;b0_oclo<4oo;b
lP03oo?clomWIfOoEeMG00;ol_;b00Ko]kNgoalO7ol=3@goDU9Boh:2P_ld=3@2oo;blP06od51@Oml
O7col_;boo?clonLW9co820P0_obl_801_oKfm_oBd];o`T92OlW9bOo6a/KokVi^@Gol_;b00?olo?c
oo;bl_obl_801?obl_801?oclo?ol_;boo;bl_oclo<5oo;blP03oo?cloobl_;ol_;b00Col_;b00Co
lo?coo;bl_obl_;olo?c1Oobl_800ooclo?ol_;boo;blP04oo;blP04oo?cloobl_;ol_;boo?cl`Go
l_;b00?olo?coo;bl_obl_801?obl_801?oclo?ol_;boo;bl_oclo<5oo;blP03oo?cloobl_;ol_;b
00Col_;b00Colo?coo;bl_obl_;olo?c1Oobl_800ooclo?ol_;boo;blP04oo;blP03oo?cloobl_;o
l_;b00;olo?c00Ool_;boo?cloobl_;ol_;boo?cloobl_;olo?c00?ol_;b00[oCTi>odm?ComADE7o
DU9BoeADE?mEEEGoEUIFoeMGEomHF5SoFEUI0omJFUX6oe]KF`;oG5aL0_mMGEd02OmNGUkoGemOof1P
H?mQHF7oHV9RofATI?mVIVKoIfMWofUYJ@01of][J`0000coKFe]of][JomYJFWoIfMWofEUIOmSHf?o
HF5Qof1PH?mOGeooGUiNoeeMGOmLG5`3oe]KF`CoFUYJ00?oFe]KoeYJF_mKFe/00omJFUX00omKFe_o
FUYJoe]KF`02oeYJFP03oe]KFomJFU[oFUYJ00;oFUYJ00?oFe]KoeYJF_mKFe/00omJFUX00omKFe_o
FUYJoe]KF`02oeYJFP03oe]KFomJFU[oFUYJ00;oFUYJ00?oFe]KoeYJF_mKFe/00omJFUX00omKFe_o
FUYJoe]KF`07oeYJFP;oFEUI00[oF5QHoeMGEomGEeOoEEEEoeADE?mCDe?oDU9Boe5ADOm?CdooCDe=
0_ogmoL01?ohn?SomoOgooOgmoohn?P2ooOgm`03ooShn?ogmoOomoOg00GomoOg00?om_KfohV9ROlV
9RH00_ogmoL03_mFEUKoFe]Kono_konLW9co5ADEoc@d=?ofm_KomoOgod=3@omoOgoomoOgooKfm_nP
X:3o8R8R0_ogmoL01om7AdOo@d=3omSHf?ogmoOok>c/on_[joofm_H01?ogmoL00oofm_KomoOgooOg
m`04ooOgm`05ooKfm_ogmoOomoOgooOgmoofm_H01?ogmoL00oofm_KomoOgooOgm`04ooOgm`05ooKf
m_ogmoOomoOgooOgmoofm_H01?ogmoL00oofm_KomoOgooOgm`04ooOgm`05ooKfm_ogmoOomoOgooOg
moofm_H01?ogmoL00oofm_KomoOgooOgm`04ooOgm`05ooKfm_ogmoOomoOgooOgmoofm_H01?ogmoL0
0oofm_KomoOgooOgm`04ooOgm`05ooKfm_ogmoOomoOgooOgmoofm_H01?ogmoL00oofm_KomoOgooOg
m`04ooOgm`03ooKfm_ogmoOomoOg00;omoOg00?on?ShooOgmoohn?P00oogmoL02oohn?SomoOgooOg
moohn?SoCDe=odm?ComADE7oDU9Boe=CDomDE5CoEUIF00;oEeMG00?oF5QHoeUIFOmIFET00omJFUX0
0omKFe_oFUYJoeYJFP02oe]KF`;oG5aL00[oGEeMoeiNG_mOGeooH61Pof5QHOmSHf?oIFEUofIVI_mY
JFWoJf][0Om]KFd0000:ofQXJ?mUIFGoHf=Sof5QHOmOGeooGUiNoeaLG?mJFU[oFEUIoeQHF0;oEeMG
0_mFEUHcoeEEE@CoE5AD00coDe=Coe9BD_mADE7oDE5Aoe1@D?m?CdooCTi>ode=COm;Bd_oBTY:oo7a
lOobl_83oo7al@03oo;bl_oalO7olO7a00;olO7a00?ol_;boo7alOoalO401?oalO401_n5QHGo8R8R
oo7alOoalO7o;bl_oh^;R`;olO7a00KoMWIfoc8b<_oalO7olO7aod10@?mjNWX2oo7al@06oibLW?lO
7aoolO7aom7AdOl61PKo[jn_HooalO400oobl_;olO7aoo7al@04oo7al@0<oo;bl_oalO7olO7aoo7a
lOobl_;oBTY:od];Bom=CDgoCTi>odm?Com@D53oDE5A0_mBDU82oe=CD`?oE5AD1_mEEED03?mFEUKo
EeMGoeQHF?mHF5SoFUYJoe]KFomLG5coGEeMoemOGomQHF7oHf=SofIVIP7oJ6QX00003?mUIFGoHV9R
of1PH?mNGUkoG5aLoeYJF_mIFEWoEeMGoeIFE_mEEEGoE5ADoe=CD`?oDU9B1?mADE400omBDU;oDE5A
oe5AD@05oe5AD@04oe9BD_mADE7oDE5Aoe9BDPCoDE5A00?oDU9Boe5ADOmADE401OmADE401?mBDU;o
DE5Aoe5ADOmBDU84oe5AD@03oe9BD_mADE7oDE5A00GoDE5A00?oDU9Boe5ADOmADE401_mADE42oe1@
D009odm?Com>CTkoCTi>ode=COm<C4coBd];odY:B_m8B4SoAdM700;oh^;R00Sohn?Son;Rh_oShn?o
hn?Son;Rh_oShn?oh^;Ron?Sh`;oh^;R0_oShn<07_oRh^;ohn?Son;Rh_mmOGgo820Pon;Rh_oShn?o
:b/[ohB4Q?oShn?oh^;Roh61POl^;Rkoh^;Ron?Sholl?3coLg=con?ShooRh^;oTY:BoadM7OoRh^;o
ZZZZo`D51Oli>CWo?3`loc/k>oll?3co[Zj^on;RhP;ohn?S00Ooh^;Ron?ShooRh^;oh^;Ron?ShooR
h^;ohn?S00;oh^;R00?ohn?Son;Rh_oShn<00_oRh^82on?Sh`07on;Rh_oShn?oh^;Ron;Rh_oShn?o
h^;Ron?Sh`02on;RhP03on?ShooRh^;ohn?S00;oh^;R0_oShn<01ooRh^;ohn?Son;Rh_oRh^;ohn?S
on;Rh_oShn<00_oRh^800ooShn?oh^;Ron?Sh`02on;RhP;ohn?S00Ooh^;Ron?ShooRh^;oh^;Ron?S
hooRh^;ohn?S00;oh^;R00?ohn?Son;Rh_oShn<00_oRh^82on?Sh`07on;Rh_oShn?oh^;Ron;Rh_oS
hn?oh^;Ron?Sh`02on;RhP03on?ShooRh^;ohn?S00;oh^;R0_oShn<01ooRh^;ohn?Son;Rh_oRh^;o
hn?Son;Rh_oShn<00_oRh^801?oShn?oh^;Ron?ShooRh^83on?Sh`06on;Rh_oShn?oh^;Ron;Rh_oS
hn?oh^;R0_oShn<01_m7AdOoBDU9odY:B_m;Bd_oC4a<ode=C@;oCTi>00?oCdm?oe1@D?m@D5001omA
DE43oe9BDP0;oe=CDomDE5CoEEEEoeIFE_mGEeOoFEUIoeYJF_mLG5coGUiNof1PH?mRHV800OmUIFD0
000<ofEUIOmRHV;oH61PoeiNG_mLG5coFUYJoeQHF?mGEeOoEEEEoeADE?mCDe?oDU9B0omADE4doe1@
D007odm?Com>CTkoCTi>odi>C_m=CDgoC4a<od];B`02odY:BP04odU9BOm7AdOoATI6oo7al@;ol?3`
00ColO7aoo3`l?o`l?3olO7a2Oo`l?001ooalO7oQ8B4ob4Q8OoalO7ol?3`obd];On=SHd00_o`l?00
4_n9RHWo<C4aoo3`l?o`l?3o?clooeYJF_o`l?3olO7aoiFEUOlO7aoolO7aolk>c_l51@GoXj>Sol?3
`onl_;co1`L7omSHf0Gol?3`00ColO7aoo3`l?o`l?3olO7a3?o`l?001?oalO7ol?3`oo3`l?oalO4<
oo3`l004oo7alOo`l?3ol?3`oo7al@col?3`00ColO7aoo3`l?o`l?3olO7a3?o`l?001?oalO7ol?3`
oo3`l?oalO4<oo3`l004oo7alOo`l?3ol?3`oo7al@col?3`00ColO7aoo3`l?o`l?3olO7a0_o`l?00
1?m6ATKoAdM7odU9BOm:BTX2od];B`04oda<C?m=CDgoCTi>odi>CP?oCdm?1_m@D502oe5AD@0;oe9B
D_mCDe?oE5ADoeEEEOmGEeOoF5QHoeYJF_mLG5coGUiNof1PH?mSHf<00OmUIFD0000:ofMWIomTI6Co
HF5QoemOGomMGEgoFUYJoeQHF?mGEeOoEEEEoeADE0;oDU9B00CoDE5Aoe1@D?m@D53oD51@0om?Cdl3
oe1@D005odm?Com@D53oCdm?oe1@D?m?Cdl00_m@D5000om?CdooD51@oe1@D003odm?C`?oD51@00Go
Cdm?oe1@D?m?CdooD51@odm?C`02oe1@D003odm?Com@D53oD51@00?oCdm?0om@D5001Om?CdooD51@
odm?Com@D53oCdm?00;oD51@1_m?Cdl3odi>CP;oCDe=00OoC4a<od];Bom:BT[oBDU9odQ8B?m7AdOo
ATI6017omOGe00KoQXJ6ob8R8_oemOGom?Cdobh^;_n?Shl2ooGem@0Aoh^;Rolb<S;omOGeooGemOm1
@D7o5aLGogAdM?oFe]KoEUIFode=COoemOGom?Cdod10@?mYJFWok^k^oiZJV_l];Bd01ooemOD01?od
m?ComOGeooGemOodm?@<ooGem@04ooCdm?oemOGomOGeooCdm0comOGe00Com?CdooGemOoemOGom?Cd
3?oemOD01?odm?ComOGeooGemOodm?@<ooGem@04ooCdm?oemOGomOGeooCdm0comOGe00Com?CdooGe
mOoemOGom?Cd4OoemOD01om6ATKoAdM7odQ8B?m9BDWoBTY:od];Bom<C4`00_m=CDd3odi>CPKoCdm?
0_m@D502oe5AD@0:oe=CDomDE5CoEEEEoeMGEomIFEWoFUYJoeeMGOmOGeooHV9RofATI07oIfMW0000
2_mSHf?oH61PoeeMGOmKFe_oF5QHoeMGEomDE5CoDe=Coe5ADOm@D502odi>CP03ode=COm<C4coC4a<
02ooC4a<0_m;Bd/00om<C4coBd];od];B`02od];B`;oBTY:00KoBDU9odQ8B?m8B4SoAdM7odI6A_m5
ADD2odA4A004ono_koo`l?3ol?3`ono_k`?ol?3`00Gokno_oo3`l?o_knookno_oo3`l005ono_k`06
oh>3PolQ8B7okno_ono_kom2@T;oUIFE0_o_knl02_nBTY;oA4A4oo3`l?o_knooDE5AohF5QOmcLg?o
5QHFobl_;oni^KT2ono_k`07omSHf?m5ADGo3`l?oadM7On/[:cokno_oo3`l005ono_k`;ol?3`0_o_
knl2oo3`l0Cokno_00?ol?3`ono_koo_knl00oo_knl2oo3`l0;okno_0_o`l?04ono_k`03oo3`l?o_
knookno_00?okno_0_o`l?02ono_k`;ol?3`1?o_knl00oo`l?3okno_ono_k`03ono_k`;ol?3`0_o_
knl2oo3`l0Cokno_00?ol?3`ono_koo_knl00oo_knl2oo3`l0;okno_0_o`l?04ono_k`03oo3`l?o_
knookno_00?okno_0_o`l?02ono_k`;ol?3`1?o_knl01?o`l?3okno_ono_koo`l?02ono_k`;ol?3`
00?okno_oo3`l?o`l?000_m4A4@2odI6AP04odM7Aom8B4SoBDU9odU9B@?oBTY:0om;Bd/3oda<C00?
od];Bom<C4coC4a<ode=COm>CTkoCdm?oe1@D?mADE7oDe=CoeADE?mFEUKoF5QHoeYJF_mMGEgoH61P
007oHf=S0011oo3`l00>onk^k_o/k>cojNWYonKVi_oQhN7ogMgMomOGeoo?cloobLW9ol;2`_ni^KWo
/;2`ojJVY_nKVi/:on_[j`03onc/k?o[jn_oj^[Z00;ojn_[0_oZj^X00on5QHGo9bLWon_[j`03on[Z
jP;ojn_[00?oj^[Zon_[jooZj^X00_oZj^X01_o[jn_oj^[Zon[Zj_o[jn_oj^[Zon_[j`?oj^[Z00Co
j>SXon_[jooZj^[ojn_[0ooZj^X01_o[jn_oj^[Zon[Zj_o[jn_oj^[Zon_[j`?oj^[Z0_o[jn/00ooZ
j^[ojn_[on[ZjP02on[ZjP06on_[jooZj^[oj^[Zon_[jooZj^[ojn_[0ooZj^X2on_[j`03on[Zj_o[
jn_oj^[Z00;oj^[Z00Kojn_[on[Zj_oZj^[ojn_[on[Zj_o[jn/3on[ZjP;ojn_[00?oj^[Zon_[jooZ
j^X00_oZj^X01_o[jn_oj^[Zon[Zj_o[jn_oj^[Zon_[j`?oj^[Z0_o[jn/00ooZj^[ojn_[on[ZjP02
on[ZjP06on_[jooZj^[oj^[Zon_[jooZj^[ojn_[0ooZj^X2on_[j`03on[Zj_o[jn_oj^[Z00;oj^[Z
00Kojn_[on[Zj_oZj^[ojn_[on[Zj_o[jn/3on[ZjPoojn_[00ooVi^KojJVY_n`/;3o^KViol;2`_o9
bLWod=3@omOGeooMgMgohN7QonGUiOoYjNWok>c/onk^k_o`l?000_o_knl00oo`l?3ofMWIooooo`0=
ooooo`00@Oo`l?003_o^k^kokNg]onWYjOoUiNGohN7QomcLg?oHf=Sod=3@olW9bOo1`L7o^KViok2`
/?nUYJGoVi^K1?oinOT00oojn_[onOWiooWin@07ooWin@09ooShn?oinOWon?Shohb<S?lY:BWon?Sh
ooWinOohn?SonOWi00?on?Sh00?onOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn003
ooWinOohn?SonOWi00?on?Sh00?onOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn003
ooWinOohn?SonOWi00?on?Sh00?onOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn003
ooWinOohn?SonOWi00?on?Sh00?onOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn003
ooWinOohn?SonOWi00?on?Sh00?onOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn003
ooWinOohn?SonOWi00?on?Sh00?onOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn003
ooWinOohn?SonOWi00?on?Sh00?onOWiooShn?oinOT00_ohn?P00ooinOWon?ShooShn002ooShn006
ooWinOohn?SonOWiooShn?oinOWon?Sh0_oinOT01?ojn_[onOWiooWinOojn_X4ooWin@0@oo[jn_oi
nOWoVi^KojFUYOn`/;3o^KViol;2`_o9bLWod=3@omOGeooLg=coh^;RonGUiOoXj>Sok>c/onk^kPCo
l?3`00CofMWIooooooooooooiNGU0oooool01OoUiNGoooooooooooooooooiNGU00?ooooo0011oo3`
l00>onk^k_o/k>cojNWYonKVi_oRh^;ogMgMomOGeoo@d=3obLW9ol;2`_ni^KWo/;2`ojJVY_nKVi/;
ooknoP04oogmoOono_kooOgmooknoP;ooOgm00Wod];Boj^[ZoomoOgooOgmookno_omoOgoo_knoogm
oOono_h00_omoOd00oono_kooOgmooknoP02oogmo@09ookno_omoOgooOgmoogmoOono_kooOgmookn
o_omoOgoo_kn00;ooOgm00?oo_knoogmoOono_h00_omoOd02Oono_kooOgmoogmoOomoOgoo_knoogm
oOono_kooOgmooknoP02oogmo@03ookno_omoOgoo_kn00;ooOgm00Woo_knoogmoOomoOgooOgmookn
o_omoOgoo_knoogmoOono_h00_omoOd00oono_kooOgmooknoP02oogmo@09ookno_omoOgooOgmoogm
oOono_kooOgmookno_omoOgoo_kn00;ooOgm00?oo_knoogmoOono_h00_omoOd02Oono_kooOgmoogm
oOomoOgoo_knoogmoOono_kooOgmooknoP02oogmo@03ookno_omoOgoo_kn00;ooOgm00Woo_knoogm
oOomoOgooOgmookno_omoOgoo_knoogmoOono_h00_omoOd00oono_kooOgmooknoP02oogmo@06ookn
o_omoOgooOgmoogmoOono_kooOgm3oono_h03_nJVY[oYZJVok2`/?ni^KWo`/;2olW9bOo@d=3oemOG
omgMgOoQhN7oi^KVonWYjOo/k>cok^k^0_o`l?003oo_knool?3`omWIfOoooooof][Johf=SOoUiNGo
ooooom[Jf_n=SHgoiNGUoooooooJf][oSHf=onGUi@02ooooo`00@Oo`l?003_o^k^kok>c/onWYjOoU
iNGoh^;RomcLg?oHf=Sod=3@olW9bOo2`/;o^KViok2`/?nUYJGoVi^K0_oinOT00oojn_[onOWioo[j
nP09ooWin@06ooShn?oinOWon?ShooShn?oinOWon?Sh0_oinOT00oohn?SonOWiooShn002ooShn005
ooWinOohn?SonOWiooShn?oinOT00_ohn?P01_oinOWon?ShooWinOoinOWon?ShooWin@?on?Sh00Go
nOWiooShn?oinOWon?ShooWin@02ooShn006ooWinOohn?SonOWiooWinOohn?SonOWi0oohn?P01Ooi
nOWon?ShooWinOohn?SonOWi00;on?Sh00KonOWiooShn?oinOWonOWiooShn?oinOT3ooShn005ooWi
nOohn?SonOWiooShn?oinOT00_ohn?P01_oinOWon?ShooWinOoinOWon?ShooWin@?on?Sh00GonOWi
ooShn?oinOWon?ShooWin@02ooShn006ooWinOohn?SonOWiooWinOohn?SonOWi0oohn?P01OoinOWo
n?ShooWinOohn?SonOWi00;on?Sh00KonOWiooShn?oinOWonOWiooShn?oinOT3ooShn005ooWinOoh
n?SonOWiooShn?oinOT00_ohn?P01OoinOWon?ShooWinOoinOWon?Sh00;onOWi00?on?ShooWinOoi
nOT01_oinOT04_ojn_[onOWioo[jn_oinOWoVi^KojFUYOn`/;3o^KViol;2`_o9bLWod=3@omOGeooL
g=coh^;RonGUiOoYjNWokNg]onk^kPCol?3`00kofMWIoooooooooooof][Johf=SOoUiNGoooooom[J
f_n=SHgoiNGUoooooooJf][oSHf=onGUi@7ooooo0011oo3`l00>onk^k_o]kNgoj>SXonKVi_oRh^;o
g=cLomOGeoo@d=3obLW9ol;2`_ni^KWo/;2`ojFUYOnJVYX;ooknoP05oogmoOono_koo_knoogmoOon
o_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP03oogmoOono_kooOgm00;ooOgm00?oo_knoogm
oOono_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP03oogmoOono_kooOgm00;ooOgm00?oo_kn
oogmoOono_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP03oogmoOono_kooOgm00;ooOgm00?o
o_knoogmoOono_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP03oogmoOono_kooOgm00;ooOgm
00?oo_knoogmoOono_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP03oogmoOono_kooOgm00;o
oOgm00?oo_knoogmoOono_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP03oogmoOono_kooOgm
00;ooOgm00?oo_knoogmoOono_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP03oogmoOono_ko
oOgm00;ooOgm00?oo_knoogmoOono_h00_omoOd01?ono_kooOgmoogmoOomoOd@ooknoP0@oi^KVonV
YZKo/;2`okVi^Oo2`/;ob<S8om3@d?oHf=Sog=cLon;Rh_oUiNGojNWYong]kOo^k^kol?3`ono_k`;o
l?3`00gofMWIooooooooooooooooom[Jf_n=SHgoiNGUoooooooJf][oSHf=onGUiOoooooof][J00;o
oooo0011oo3`l00?onk^k_o/k>cojNWYonGUiOoQhN7og=cLomOGeoo@d=3ob<S8ol;2`_ni^KWo/;2`
ojJVY_nKVi_on_[j00?onOWi00?on_[jooWinOoinOT00ooinOT01oojn_[onOWiooShn?ohn?SonOWi
ooShn?oinOT00_ohn?P3ooWin@Con?Sh0_oinOT2ooShn003ooWinOohn?SonOWi00;on?Sh0ooinOT4
ooShn0;onOWi0_ohn?P00ooinOWon?ShooWin@02ooShn0?onOWi1?ohn?P2ooWin@;on?Sh00?onOWi
ooShn?oinOT00_ohn?P3ooWin@Con?Sh0_oinOT2ooShn003ooWinOohn?SonOWi00;on?Sh0ooinOT4
ooShn0;onOWi0_ohn?P00ooinOWon?ShooWin@02ooShn0?onOWi1?ohn?P2ooWin@;on?Sh00?onOWi
ooShn?oinOT00_ohn?P3ooWin@Con?Sh0_oinOT2ooShn003ooWinOohn?SonOWi00;on?Sh0ooinOT3
ooShn0;onOWi00?on_[jooWinOoinOT00_oinOT05?ojn_[onOWiooWinOoinOWon_[jooWinOnJVY[o
YJFUok2`/?ni^KWo`/;2olW9bOo@d=3oemOGomgMgOoQhN7oi^KVonSXj?o/k>cok^k^0_o`l?000oo_
knool?3`omWIf@04ooooo`07om[Jf_n=SHgoiNGUoooooooJf][oSHf=onGUi@03ooooo`00@Oo`l?00
3_o_knook>c/onWYjOoUiNGohN7QomgMgOoGemOod=3@olW9bOo2`/;o^KViok2`/?nUYJGoVi^K1Oo[
jn/00oo/k>cojn_[on_[j`07on_[j`Coj^[Z00Cojn_[on[Zj_o[jn_oj^[Z0_o[jn/2on[ZjP04on_[
jooZj^[oj^[Zon_[j`Coj^[Z00CodM7AogYjN_oTi>Coj^[Z0_o[jn/2on[ZjP04on_[jooZj^[oj^[Z
on_[j`Coj^[Z00Cojn_[on[Zj_o[jn_oj^[Z0_o[jn/2on[ZjP04on_[jooZj^[oj^[Zon_[j`Coj^[Z
00Cojn_[on[Zj_o[jn_oj^[Z0_o[jn/2on[ZjP04on_[jooZj^[oj^[Zon_[j`Coj^[Z00Cojn_[on[Z
j_o[jn_oj^[Z0_o[jn/2on[ZjP04on_[jooZj^[oj^[Zon_[j`Coj^[Z00Cojn_[on[Zj_o[jn_oj^[Z
0_o[jn/2on[ZjP04on_[jooZj^[oj^[Zon_[j`Coj^[Z00Cojn_[on[Zj_o[jn_oj^[Z0_o[jn/2on[Z
jP04on_[jooZj^[oj^[Zon_[j`Coj^[Z00Cojn_[on[Zj_o[jn_oj^[Z0oo[jn/01OoZj^[ok>c/on_[
joo[jn_ok>c/00Kojn_[013ok>c/oi^KVonVYZKo/;2`okVi^Oo1`L7obLW9om3@d?oGemOogMgMon;R
h_oUiNGojNWYonc/k?o^k^kokno_0oo`l?000ooIfMWoooooooooo`03ooooo`07om[Jf_n=SHgoiNGU
oooooooJf][oSHf=onGUi@02ooooo`00@Oo`l?004?o^k^kokNg]onSXj?oVi^Koh^;RomcLg?oGemOo
d=3@olW9bOo2`/;o^KViok2`/?nUYJGoVi^KooWinOojn_X;ooWin@;on?Sh00OonOWiooShn?oinOWo
nOWiooShn?oinOWon?Sh00;onOWi00?on?ShooWinOohn?P00_oinOT2ooShn007ooWinOohn?SonOWi
ooWinOodm?Co:2PXojFUY@02ooWin@03ooShn?oinOWon?Sh00;onOWi0_ohn?P01ooinOWon?ShooWi
nOoinOWon?ShooWinOohn?P00_oinOT00oohn?SonOWiooShn002ooWin@;on?Sh00OonOWiooShn?oi
nOWonOWiooShn?oinOWon?Sh00;onOWi00?on?ShooWinOohn?P00_oinOT2ooShn007ooWinOohn?So
nOWiooWinOohn?SonOWiooShn002ooWin@03ooShn?oinOWon?Sh00;onOWi0_ohn?P01ooinOWon?Sh
ooWinOoinOWon?ShooWinOohn?P00_oinOT00oohn?SonOWiooShn002ooWin@;on?Sh00OonOWiooSh
n?oinOWonOWiooShn?oinOWon?Sh00;onOWi00?on?ShooWinOohn?P00_oinOT2ooShn007ooWinOoh
n?SonOWiooWinOohn?SonOWiooShn002ooWin@03ooShn?oinOWonOWi00KonOWi00?on_[jooWinOoi
nOT00_oinOT03_nKVi_oYJFUok2`/?ni^KWo`L71olW9bOo@d=3oemOGomcLg?oRh^;oiNGUonWYjOo/
k>cok^k^1?o`l?000ooIfMWoooooooooo`04ooooo`07om[Jf_n=SHgoiNGUoooooooLg=coSHf=onGU
i@01ooooo`00@Oo`l?003_o^k^kokNg]onWYjOoUiNGoh^;RomcLg?oGemOod=3@olW9bOo1`L7o^KVi
ok2`/?nVYZKoVi^K3_ono_h01_omoOgoo_knoogmoOomoOgoo_knoogmo@;oo_kn0_omoOd02?ono_ko
oOgmookno_omoOgoo_knonc/k?okno_oo_kn0_oclo<01?ono_kooOgmoi2@T?m8B4P2oogmo@04ookn
o_omoOgoo_knoogmo@;oo_kn00KooOgmookno_omoOgooOgmookno_omoOd2ooknoP;ooOgm00Coo_kn
oogmoOono_kooOgm0_ono_h01_omoOgoo_knoogmoOomoOgoo_knoogmo@;oo_kn0_omoOd01?ono_ko
oOgmookno_omoOd2ooknoP06oogmoOono_kooOgmoogmoOono_kooOgm0_ono_h2oogmo@04ookno_om
oOgoo_knoogmo@;oo_kn00KooOgmookno_omoOgooOgmookno_omoOd2ooknoP;ooOgm00Coo_knoogm
oOono_kooOgm0_ono_h01_omoOgoo_knoogmoOomoOgoo_knoogmo@;oo_kn0_omoOd01?ono_kooOgm
ookno_omoOd2ooknoP06oogmoOono_kooOgmoogmoOono_kooOgm0_ono_h2oogmo@03ookno_omoOgo
o_kn00_oo_kn00koVi^KojFUYOn`/;3o^KViol;2`_o9bLWod=3@omSHf?oLg=coh^;RonGUiOoYjNWo
kNg]onk^kP?ol?3`00?okno_omWIfOooool01_ooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo
0011oo3`l00?onk^k_o/k>cojNWYonGUiOoRh^;og=cLomOGeoo@d=3obLW9ol;2`_ni^KWo/;2`ojJV
Y_nKVi_on_[j00KonOWi00Oon_[jooWinOoinOWon_[jooWinOohn?SonOWi00;on?Sh00[onOWiochn
?_nUYJGon?ShonOWionPX:3oiNGUooWinOnm_Kgo3Ph>0_oinOT03?mGEeOo51@DobDU9OnLW9co7QhN
oeeMGOoinOWon?Shoi>CTol=3@godm?CooWin@;on?Sh0_oinOT01oohn?SonOWiooShn?ohn?SonOWi
ooShn?oinOT00oohn?P2ooWin@;on?Sh0_oinOT01oohn?SonOWiooShn?ohn?SonOWiooShn?oinOT0
0oohn?P2ooWin@;on?Sh0_oinOT01oohn?SonOWiooShn?ohn?SonOWiooShn?oinOT00oohn?P2ooWi
n@;on?Sh0_oinOT01oohn?SonOWiooShn?ohn?SonOWiooShn?oinOT00oohn?P2ooWin@;on?Sh0_oi
nOT01oohn?SonOWiooShn?ohn?SonOWiooShn?oinOT00oohn?P2ooWin@;on?Sh0_oinOT01oohn?So
nOWiooShn?ohn?SonOWiooShn?oinOT00oohn?P3ooWin@03ooShn?oinOWonOWi00ConOWi00?on_[j
ooWinOoinOT00ooinOT03onKVi_oYZJVok2`/?ni^KWo`/;2olW9bOo@d=3oemOGomcLg?oQhN7oi^KV
onSXj?o/k>cok^k^ono_k`03oo3`l003omWIfOoooooooooo00Kooooo00?og=cLohf=SOoUiND00ooo
ool0047ol?3`00kokno_ong]kOoXj>SoiNGUon;Rh_oMgMgoemOGom3@d?o9bLWo`L71okVi^On`/;3o
YZJVoi^KV`;ojn_[00Cok>c/on_[joo[jn_ok>c/1Oo[jn/00ooZj^[ojn_[on[ZjP02on_[j`0Bon[Z
j_ll?3coWIfMon_[jon8R8So3Ph>oh20P?oZj^[o/k>co`h>3_o[jn_o^;Rhoa0@4?o<c<coe=CDoeaL
G?lK6a_oj^[Z0_o[jn/02_lf=SKo5ADEofm_KooZj^[ojn_[on[Zj_o[jn_oj^[Zon_[jooZj^X2on_[
j`;oj^[Z0_o[jn/02_oZj^[ojn_[on[Zj_oZj^[ojn_[on[Zj_o[jn_oj^[Zon_[jooZj^X2on_[j`;o
j^[Z0_o[jn/02_oZj^[ojn_[on[Zj_oZj^[ojn_[on[Zj_o[jn_oj^[Zon_[jooZj^X2on_[j`;oj^[Z
0_o[jn/02_oZj^[ojn_[on[Zj_oZj^[ojn_[on[Zj_o[jn_oj^[Zon_[jooZj^X2on_[j`;oj^[Z0_o[
jn/02_oZj^[ojn_[on[Zj_oZj^[ojn_[on[Zj_o[jn_oj^[Zon_[jooZj^X2on_[j`;oj^[Z0_o[jn/0
2_oZj^[ojn_[on[Zj_oZj^[ojn_[on[Zj_o[jn_oj^[Zon_[jooZj^X2on_[j`;oj^[Z0_o[jn/01?oZ
j^[ojn_[on[Zj_oZj^X6on_[j`05onc/k?o[jn_ojn_[on_[joo/k>`00_o[jn/03oo/k>coVi^KojFU
YOn`/;3o^KViol;2`_o9bLWod=3@omOGeooMgMgoh^;RonGUiOoYjNWokNg]onk^kP03oo3`l003ono_
kooIfMWooooo00Sooooo00?og=cLohf=SOoUiND00_ooool0047ol?3`013ok^k^onc/k?oYjNWoi^KV
on7QhOoLg=coemOGom3@d?o9bLWo`/;2okVi^On`/;3oYZJVoi^KVooinOWon_[j0ooinOT00oojn_[o
nOWiooWin@02ooWin@0Qoo[jn_oinOWon?ShooWinOohn?SonOWiooShn?lo?cooYJFUooShn?lk>c_o
CTi>oc4a<Oohn?So_Kfmo`h>3_oinOWoeMGEo`l?3onl_;con?ShoinOWolZ:R[onOWiooShn?o9bLWo
3@d=oinOWolN7Qkol_;booWinOohn?SonOWi00;on?Sh00GonOWiooShn?oinOWon?ShooWin@03ooSh
n0;onOWi00Con?ShooWinOohn?SonOWi0_ohn?P01OoinOWon?ShooWinOohn?SonOWi00?on?Sh0_oi
nOT01?ohn?SonOWiooShn?oinOT2ooShn005ooWinOohn?SonOWiooShn?oinOT00oohn?P2ooWin@04
ooShn?oinOWon?ShooWin@;on?Sh00GonOWiooShn?oinOWon?ShooWin@03ooShn0;onOWi00Con?Sh
ooWinOohn?SonOWi0_ohn?P01OoinOWon?ShooWinOohn?SonOWi00?on?Sh0_oinOT01?ohn?SonOWi
ooShn?oinOT2ooShn005ooWinOohn?SonOWiooShn?oinOT00oohn?P2ooWin@03ooShn?oinOWonOWi
00OonOWi01Con_[jooWinOoinOWonOWioo[jn_nKVi_oYJFUok2`/?ni^KWo`/;2olW9bOo@d=3oemOG
omcLg?oRh^;oiNGUonWYjOo/k>cok^k^ono_k`?ol?3`00?ofMWIooooooooool02?ooool00ooLg=co
SHf=onGUi@01ooooo`00@Oo`l?003_o^k^kokNg]onSXj?oUiNGoh^;RomcLg?oHf=Sod=3@olW9bOo2
`/;o^KViok6a/OnUYJGoVi^K3_ono_h03?omoOgoo_knoogmoOm0@43oZJVYomOGeol>3PkoeMGEoc@d
=?o:b/[o`L71oa0@40;ooOgm00Go/;2`ocdm?Olm?Cgo@410ob/[:`02oogmo@07og1`L?m;Bd_ooOgm
oc<c<onXZ:SooOgmooknoP02oogmo@04ookno_omoOgooOgmooknoPCooOgm00Koo_knoogmoOomoOgo
o_knoogmoOono_h2oogmo@04ookno_omoOgooOgmooknoPCooOgm00Koo_knoogmoOomoOgoo_knoogm
oOono_h2oogmo@04ookno_omoOgooOgmooknoPCooOgm00Koo_knoogmoOomoOgoo_knoogmoOono_h2
oogmo@04ookno_omoOgooOgmooknoPCooOgm00Koo_knoogmoOomoOgoo_knoogmoOono_h2oogmo@04
ookno_omoOgooOgmooknoPCooOgm00Koo_knoogmoOomoOgoo_knoogmoOono_h2oogmo@04ookno_om
oOgooOgmooknoPCooOgm00Ooo_knoogmoOomoOgoo_knoogmoOono_kooOgm00_oo_kn00koVYZJojJV
Y_n`/;3o^KViol71`Oo9bLWod=3@omOGeooLg=coh^;RonGUiOoYjNWokNg]onk^kP;ol?3`00?okno_
oo3`l?oIfMT02oooool1omcLg07ooooo0Oooool0047ol?3`00ook^k^onc/k?oYjNWoiNGUon;Rh_oM
gMgoemOGom3@d?o9bLWo`/;2okVi^On`/;3oYZJVoi^KVoojn_X00_oinOT01?ojn_[onOWiooWinOoj
n_X5ooWin@03ooShn?oinOWon?Sh00;onOWi00[o?ShnojFUYOn0P83o>SXjooShn?n<S8coKFe]okfm
_Ol>3PkonOWi0_ohn?P03?oinOWom_KfoiJFU_l/;2conOWioo3`l?lK6a_oXZ:RooShn?nBTY;oATI6
ooShn0;onOWi0_ohn?P00ooinOWon?ShooWin@02ooWin@05ooShn?oinOWonOWiooShn?oinOT00_oh
n?P2ooWin@;on?Sh00?onOWiooShn?oinOT00_oinOT01Oohn?SonOWiooWinOohn?SonOWi00;on?Sh
0_oinOT2ooShn003ooWinOohn?SonOWi00;onOWi00Gon?ShooWinOoinOWon?ShooWin@02ooShn0;o
nOWi0_ohn?P00ooinOWon?ShooWin@02ooWin@05ooShn?oinOWonOWiooShn?oinOT00_ohn?P2ooWi
n@;on?Sh00?onOWiooShn?oinOT00_oinOT01Oohn?SonOWiooWinOohn?SonOWi00;on?Sh0_oinOT2
ooShn003ooWinOohn?SonOWi00;onOWi00Gon?ShooWinOoinOWon?ShooWin@02ooShn0OonOWi00Co
n_[jooWinOoinOWon_[j0_oinOT03_nKVi_oYJFUok2`/?ni^KWo`/;2olW9bOo?clooemOGomcLg?oR
h^;oi^KVonWYjOo/k>cokno_1?o`l?000ooIfMWoooooooooo`0<ooooo`00@Oo`l?003_o^k^kokNg]
onWYjOoUiNGoh^;RomcLg?oGemOod=3@olW9bOo2`/;o^KViok2`/?nVYZKoVi^K3_o[jn/07_oZj^[o
jn_[on[Zj_lk>c_oVi^KobPX:?n5QHGoj^[Zom?CdolN7Qko[Jf]o`h>3_o[jn_oj^[ZojVYZOo:b/[o
inOWof5QHOmFEUKoj^[ZoiZJV_lH61SohN7Qon[Zj_oKfm_o5ADEolS8b?oZj^[ojn_[on[ZjP;ojn_[
00?oj^[Zon_[jooZj^X01_oZj^X2on_[j`03on[Zj_o[jn_oj^[Z00;ojn_[00?oj^[Zon_[jooZj^X0
1_oZj^X2on_[j`03on[Zj_o[jn_oj^[Z00;ojn_[00?oj^[Zon_[jooZj^X01_oZj^X2on_[j`03on[Z
j_o[jn_oj^[Z00;ojn_[00?oj^[Zon_[jooZj^X01_oZj^X2on_[j`03on[Zj_o[jn_oj^[Z00;ojn_[
00?oj^[Zon_[jooZj^X01_oZj^X2on_[j`03on[Zj_o[jn_oj^[Z00;ojn_[00?oj^[Zon_[jooZj^X0
1_oZj^X?on_[j`0?oi^KVonVYZKo/;2`okVi^Oo2`/;obLW9om3@d?oHf=Sog=cLon;Rh_oUiNGoj>SX
onc/k?o^k^kokno_00?ol?3`3ooIfMT0047ooooo00oooOgmoo_knoogmoOom?Cdoo3`l?oZj^[oiNGU
omgMgOoFe]Koc/k>olG5aOnk^k_o/;2`ojFUYOojn_X00_okno/2oo[jnP;ono_k1_ojn_X02?oinOWo
n_[jooWinOoinOWo?cloofm_Kol?3`oohN7Q0_ojn_X03Om>CTkoLG5ao`l?3ooinOWon_[johf=SOll
?3co7AdMod51@Oo3`l?on_[jof5QHOmeMGD00oojn_X01OmaLG7oRHV9ooWinOoinOWon_[j00;onOWi
00?on_[jooWinOoinOT00_ojn_X01_oinOWon_[joo[jn_ojn_[onOWioo[jnP;onOWi00Con_[jooWi
nOoinOWon_[j0_oinOT2oo[jnP06ooWinOojn_[on_[joo[jn_oinOWon_[j0_oinOT01?ojn_[onOWi
ooWinOojn_X2ooWin@;on_[j00KonOWioo[jn_ojn_[on_[jooWinOojn_X2ooWin@04oo[jn_oinOWo
nOWioo[jnP;onOWi0_ojn_X01_oinOWon_[joo[jn_ojn_[onOWioo[jnP;onOWi00Con_[jooWinOoi
nOWon_[j0_oinOT2oo[jnP06ooWinOojn_[on_[joo[jn_oinOWon_[j0_oinOT01?ojn_[onOWiooWi
nOojn_X2ooWin@;on_[j00OonOWioo[jn_ojn_[on_[jooWinOojn_[onOWi00Oon_[j0_okno/2oo[j
nP0?oo_knonUYJGo/;2`ok^k^oo4a<Coc/k>omKFe_oMgMgoi>CTon[Zj_o_knoolo?cooShn?okno_o
oOgm01?ooooo0011onk^kP0>onc/k?oZj^[oinOWonCTi?oPh>3ofm_KomGEeOo>c/koalO7ol30`?nh
^;So[jn_ojFUYOnJVYX5ooknoP;ooOgm1Oono_h2oogmo@06ookno_omoOgooOgmod10@?lP823oC4a<
0oomoOd01?nXZ:So820Po`l?3oono_h3oogmo@03ooclo?omoOgooOgm00;ooOgm00?oo_knoogmoOom
oOd00_omoOd00oono_kooOgmooknoP03oogmo@03ookno_omoOgooOgm00;ooOgm00?oo_knoogmoOom
oOd00_omoOd00oono_kooOgmooknoP03oogmo@03ookno_omoOgooOgm00;ooOgm00?oo_knoogmoOom
oOd00_omoOd00oono_kooOgmooknoP03oogmo@03ookno_omoOgooOgm00;ooOgm00?oo_knoogmoOom
oOd00_omoOd00oono_kooOgmooknoP03oogmo@03ookno_omoOgooOgm00;ooOgm00?oo_knoogmoOom
oOd00_omoOd00oono_kooOgmooknoP03oogmo@03ookno_omoOgooOgm00;ooOgm00?oo_knoogmoOom
oOd00_omoOd00oono_kooOgmooknoP03oogmo@03ookno_omoOgooOgm00;ooOgm00?oo_knoogmoOom
oOd00_omoOd01Oono_kooOgmookno_ono_kooOgm00Soo_kn013ooOgmoiVIVOnTY:Co[jn_okNg]oo1
`L7oalO7olk>c_oEeMGofm_Kon3Ph?oShn?oinOWon[Zj_o/k>cok^k^0_o]kNd@onk^kP00@OoVi^H0
3ooTi>Cohn?SomoOgooKfm_of=SHom?Cdoo?clooalO7ol71`Oni^KWo/K6aojRXZ?nOWiooU9BDooWi
n@02ooShn0ConOWi00Kon?ShooWinOohn?SonOWiooShn?oinOT4ooShn003ocdm?Ol<30coWIfM00?o
n?Sh00?ok^k^oaLG5ol=3@d0L?ohn?P01OoinOWon?ShooWinOoinOWon?Sh00;onOWi0_ohn?P3ooWi
n@0>oiBDU?nNWYkoZJVYok6a/Onj^[[o`<30olS8b?o>c/kodm?ComWIfOoLg=cogmoOon;Rh_oTi>@C
onKViP00@Oo^k^h03_o/k>coj^[ZonOWiooTi>Coh>3Pom_KfooEeMGoclo?olO7aoo1`L7o^;Rhojn_
[onTY:CoVIVI2oo[jn/05OoZj^[ojn_[on_[joo[jn_oj^[Zon_[jonVYZKoTY:BomoOgooZj^[ojn_[
on[Zj_o[jn_oZZZZoi>CToo[jn_oj^[Zon_[jooZj^[ojn_[on[ZjP02on_[j`?oj^[Z00Cojn_[on[Z
j_o[jn_oj^[Z0_o[jn/01OoZj^[ojn_[on[Zj_o[jn_oj^[Z00;ojn_[0ooZj^X01?o[jn_oj^[Zon_[
jooZj^X2on_[j`05on[Zj_o[jn_oj^[Zon_[jooZj^X00_o[jn/3on[ZjP04on_[jooZj^[ojn_[on[Z
jP;ojn_[00Goj^[Zon_[jooZj^[ojn_[on[ZjP02on_[j`?oj^[Z00Cojn_[on[Zj_o[jn_oj^[Z0_o[
jn/01OoZj^[ojn_[on[Zj_o[jn_oj^[Z00;ojn_[0ooZj^X01?o[jn_oj^[Zon_[jooZj^X2on_[j`05
on[Zj_o[jn_oj^[Zon_[jooZj^X00_o[jn/3on[ZjP04on_[jooZj^[ojn_[on[ZjP;ojn_[00Goj^[Z
on_[jooZj^[ojn_[on[ZjP02on_[j`?oj^[Z00?ojn_[on[Zj_o[jn/01?o[jn/00oo/k>cojn_[on_[
j`07on_[j`0>oiVIVOnTY:Co[jn_okRh^?o0`<3oalO7olo?cooEeMGofm_KomoOgooTi>CoinOWon[Z
j_o/k>`2onk^kP03ong]kOo^k^kok^k^00kok^k^0011ooooo`0>oogmoOokno_omoOgoo?cloo`l?3o
j^[ZonGUiOoMgMgoeMGEolk>c_o4a<Co^k^kok2`/?nUYJD2oo[jnP03oo_knoojn_[ono_k00Won_[j
00KonOWioo[jn_oinOWonOWioo[jn_oinOT2oo[jnP03ooWinOojn_[onOWi00;onOWi00Gon_[jooWi
nOojn_[onOWioo[jnP02ooWin@06oo[jn_oinOWon_[joo[jn_oinOWon_[j0ooinOT01Oojn_[onOWi
oo[jn_oinOWon_[j00;onOWi00Kon_[jooWinOojn_[on_[jooWinOojn_X3ooWin@05oo[jn_oinOWo
n_[jooWinOojn_X00_oinOT01_ojn_[onOWioo[jn_ojn_[onOWioo[jnP?onOWi00Gon_[jooWinOoj
n_[onOWioo[jnP02ooWin@06oo[jn_oinOWon_[joo[jn_oinOWon_[j0ooinOT01Oojn_[onOWioo[j
n_oinOWon_[j00;onOWi00Kon_[jooWinOojn_[on_[jooWinOojn_X3ooWin@05oo[jn_oinOWon_[j
ooWinOojn_X00_oinOT01_ojn_[onOWioo[jn_ojn_[onOWioo[jnP?onOWi00Gon_[jooWinOojn_[o
nOWioo[jnP02ooWin@06oo[jn_oinOWon_[joo[jn_oinOWon_[j0_oinOT8oo[jnP0Boo_knoojn_[o
no_koo[jn_nTY:Co/;2`ok^k^oo4a<Coc/k>omKFe_oMgMgoiNGUon[Zj_o`l?3olo?cooOgmookno_o
oOgm4oooool0047ok^k^00ook>c/on_[jooWinOoi>CTon3Ph?oJf][oeMGEolk>c_o7alOo`L71okRh
^?n_[jooY:BToiVIVOomoOd00_ono_h00oomoOgoo_knoogmo@05ooknoP05oogmoOono_koo_knoogm
oOono_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP03oogmoOono_kooOgm00;ooOgm00?oo_kn
oogmoOono_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP03oogmoOono_kooOgm00;ooOgm00?o
o_knoogmoOono_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP03oogmoOono_kooOgm00;ooOgm
00?oo_knoogmoOono_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP03oogmoOono_kooOgm00;o
oOgm00?oo_knoogmoOono_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP03oogmoOono_kooOgm
00;ooOgm00?oo_knoogmoOono_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP03oogmoOono_ko
oOgm00;ooOgm00?oo_knoogmoOono_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP03oogmoOon
o_kooOgm00;ooOgm00?oo_knoogmoOono_h00_omoOd01?ono_kooOgmoogmoOomoOd2ooknoP04oogm
oOono_koo_knoogmo@Coo_kn01CooOgmookno_ono_kooOgmookno_omoOgoVYZJojFUYOn_[joo^;Rh
ol30`?o7alOoc/k>omKFe_oKfm_oh>3Pon?ShooWinOojn_[onc/k1?ok^k^0011onKViP0@onCTi?oR
h^;ogmoOom_KfooHf=Sodm?Colk>c_o7alOo`<30okZj^_na/K7oZJVYoinOWonEUIGonOWiooShn0Co
nOWi00?on?ShooWinOohn?P00ooinOUnooShn0;onOWi0_ohn?P3ooWin@03ooShn?oinOWonOWi00;o
nOWi00koU9BDoinOWonXZ:So/K6aokZj^_o1`L7oalO7olk>c_oCdm?of=SHomcLg?oOgmooh^;RonCT
i0;oi^KV00?oiNGUonKVi_oVi^H03_oVi^H0047ok^k^00kokNg]on[Zj_oWinOohn?Son3Ph?oKfm_o
eMGEolo?coo7alOo`L71okRh^?n_[jooY:BToiZJVPGojn_[00?ok>c/on_[joo[jn/01?o[jn/00ooZ
j^[ojn_[on_[j`04on[ZjP04on_[jooZj^[ojn_[on[ZjP;ojn_[00?oj^[ZoiFEUOnb/[800_oZj^X0
0oo[jn_oj^[Zon[ZjP02on[ZjP04on_[jooZj^[ojn_[on[ZjP;ojn_[0_oZj^X01?o[jn_oj^[Zon[Z
j_o[jn/4on[ZjP04on_[jooZj^[ojn_[on[ZjP;ojn_[0_oZj^X01?o[jn_oj^[Zon[Zj_o[jn/4on[Z
jP04on_[jooZj^[ojn_[on[ZjP;ojn_[0_oZj^X01?o[jn_oj^[Zon[Zj_o[jn/4on[ZjP04on_[jooZ
j^[ojn_[on[ZjP;ojn_[0_oZj^X01?o[jn_oj^[Zon[Zj_o[jn/4on[ZjP04on_[jooZj^[ojn_[on[Z
jP;ojn_[0_oZj^X01?o[jn_oj^[Zon[Zj_o[jn/4on[ZjP04on_[jooZj^[ojn_[on[ZjP;ojn_[0_oZ
j^X01?o[jn_oj^[Zon[Zj_o[jn/4on[ZjP04on_[jooZj^[ojn_[on[ZjP?ojn_[00Goj^[Zonc/k?o[
jn_ojn_[onc/k006on_[j`0@onc/k?nIVIWoY:BTojn_[onh^;So`<30olS8b?o>c/koeMGEom_KfooP
h>3ohn?SonOWiooZj^[ok>c/ong]kA;ok^k^0011ooooo`0@oogmoOokno_omoOgooCdm?o`l?3oj^[Z
onGUiOoMgMgoe]KFolk>c_o4a<Co^k^kok2`/?nUYJGon_[joo_kn`_on_[j0_oinOT01oojn_[onOWi
oo[jn_ojn_[onOWioo[jn_oinOT00_ojn_X01OoinOWon_[jodQ8B?n3Ph?on_[j00;onOWi00Oon_[j
ooWinOojn_[on_[jooWinOojn_[onOWi00;on_[j00GonOWioo[jn_oinOWonOWioo[jnP02ooWin@07
oo[jn_oinOWon_[joo[jn_oinOWon_[jooWin@02oo[jnP05ooWinOojn_[onOWiooWinOojn_X00_oi
nOT01oojn_[onOWioo[jn_ojn_[onOWioo[jn_oinOT00_ojn_X01OoinOWon_[jooWinOoinOWon_[j
00;onOWi00Oon_[jooWinOojn_[on_[jooWinOojn_[onOWi00;on_[j00GonOWioo[jn_oinOWonOWi
oo[jnP02ooWin@07oo[jn_oinOWon_[joo[jn_oinOWon_[jooWin@02oo[jnP05ooWinOojn_[onOWi
ooWinOojn_X00_oinOT01oojn_[onOWioo[jn_ojn_[onOWioo[jn_oinOT00_ojn_X01OoinOWon_[j
ooWinOoinOWon_[j00;onOWi00Oon_[jooWinOojn_[on_[jooWinOojn_[onOWi00;on_[j00?onOWi
oo[jn_ojn_X01_ojn_X00ookno_on_[joo[jnP02oo[jnP0>ojFUYOn`/;3o^k^kolG5aOo>c/koeMGE
omgMgOoTi>Coj^[Zoo3`l?oclo?on?Shoo_knoomoOdCooooo`00@Oo^k^h04Oo/k>cojn_[onOWiooS
hn?oh>3Pom_KfooEeMGoclo?olK6a_no_koo]KFeojZZZ_nNWYkoTY:BoogmoOolo?cooOgm00?oo?cl
0_okno/3ooclo005oo_knoolo?coo?cloo_knoolo?`00_okno/01?olo?cono_kooclo?olo?`2oo_k
n`08ooclo?okno_oB4Q8oh>3Pookno_ohn?Soo[jn_olo?`2oo_kn`04ooclo?okno_oo?clooclo0;o
no_k00Coo?cloo_knoolo?cono_k0_olo?`01_okno_oo?cloo_knookno_oo?cloo_kn`;oo?cl0_ok
no/01?olo?cono_kooclo?okno/2ooclo004oo_knoolo?coo?cloo_kn`;oo?cl0_omoOd2ooclo0;o
oOgm00Koo_knoogmoOono_koo_knoogmoOono_h2oogmo@04ookno_omoOgoo_knooknoP;ooOgm00So
o_knoogmoOono_kooOgmookno_omoOgoo?cloogmo@?oo?cl00?ono_koo_ko?okno/00_ojn_/01?ok
no_on_[koo_knoojn_/2oo_kn`06oo[jnookno_on__koo[jnookno_on_[k0_okno/2oo[jn`04oo_k
noojn__ono_koo[jn`;ono_k00Kon_[koo_knoojno_on_[koo_knoojn_/2oo_kn`;on_[k00Cono_k
oo[knooknocono_k0_okno`01_ojno_ono_loo_ko?okno_ono_loo_kn`;ono_l01CoN7]ooh23R?n9
S97oSi>IoiNKX?nKX:KoXJJ/ojN[/_n[/;Go/;Fkok>h__ni_l?o`<G9olK:coo;d=Coe=OJom_LgooO
h>7oi^OWon[ZjP;okNg]2oo^k^h0047oi^KV00ooi>CTon;Rh_oOgmoofm_KomWIfOoCdm?oc/k>olK6
a_o0`<3o]kNgojb/[?nPX:3oU9BDohF5QOogmoL00oofm_H3ooGem@04ooKfm_oemOGomOGeooKfmPGo
mOGe00GoDE5Aog=cLooemOGomOGeooCdm002ooGem@0>ocDe=OmQHF7om?CdodA4A?m>CTko;2`/ob8R
8_lL71co]kNgooGemOodm?CoA4A4oginO_odm?@2ooGem@06odA4A?mnOWkom?CdooGemOm4A4CoOWin
1?oemOD01?odm?ComOGeooGemOodm?@4ooGem@04ooCdm?oemOGomOGeooCdm0GomOGe0oofm_H2ooOg
m`;on?Sh00?omoOgooShn?ohn?P04?ohn?P00oogmoOon?ShooOgm`02ooKgm`;omOGf00?om?GeooCd
mOodm?D00_odm?D2oo?dm0;om?Ce00OoloCdooCdmOocm?ColoCdooCdmOocm?Com?Ce00?oloCd0_od
m?D2oo?dm0;om?Ce00OoloCdooCdmOocm?ColoCdooCdmOocm?Com?Ce00?oloCd0_odm?D2oo?dm003
ooCemOodm?GoloCe00?om?Ce01_om?Geoo?dmOodm?Gom?Ceoo?dmOodm?GoGfE/ofI]Lom/Lg[oLWV0
ogQoQomlQ8coP8R@ohN>Uon:TY_oSYJPoi2IXonDWJKoW:B]oj:Y/_n[/kWo^;g3ol76b_o=d=?oe]OI
omcMg_oQhN800_oUiND:onKViP00@Oo^k^h03_o]kNgojn_[onKVi_oShn?oh>3Pom_KfooEeMGoc/k>
olC4a?nj^[[o[Zj^oinOWon>SXkoOGem0oojn_X4ooWin@0<ooShn?oinOWonOWiooWinOohn?SonOWi
ooShn?oinOWon?Shok6a/OlL71colo?c0_ohn?P05?oinOWoalO7o`P82?o0`<3on?ShodE5AOm7AdOo
j^[ZooCdm?mnOWko6QXJong]kOohn?SoADE5oh20P?ohn?SonOWiooShn?m4A4CoP8200_ohn?P01?m4
A4CoP820ooShn?oinOT3ooShn004ooWinOohn?Son?ShooWin@;on?Sh00KonOWiooShn?ohn?Son?Sh
ooWinOohn?P2ooWin@03ooShn?oinOWon_[j00;on_[j0_okno/00oolo?cooOgmoogmo@02oogmo@03
ookno_omoOgoo_kn00?ooOgm00Coo_knoogmoOomoOgoo_kn1oomoOd2ooclo00Doo_knooin_[onOWj
ooWin_ohn?WomoSiooShnOogn?Som_OhooOhnOofmoSomoShooKgn?ogn?Wom_OhooOhnOogn?Som_Oh
ooOhn?ogn?T2ooOhn00>ooOhnOogn?Som_OhooOhnOofmoSomoShooKgn?ogn?Wom_OhooOhnOogn?So
m_OhooOhn?ogn?T2ooOhn00<ooOhnOogn?Som_OhooOhnOogmoSomoSiooOgn?ogn?WomoShooShnOog
n?WomoOh1?ogn?T05oohn?WoCUMOoe=MI_mIHfgoGFQbof9]N?mULG_oJGF1ofaiQ?m`O8SoLWn<ogJ2
T?mkR9CoPXjKohVDX_nEWZWoX:Zdok6h__noaLWoc]7Fom_LgooSi>GojNWZ00;okNg]2Oo^k^h0047o
oooo00kooOgmoo_knoogmoOom?Cdoo3`l?oZj^[oi>CTom_KfooAdM7o`l?3ok>c/onPX:3oS8b<ogQh
N0;omOGe00?om?Cdoo?clooclo<02Ooclo<01Oobl_;olo?coo3`l?lQ8B7oL71`00;oU9BD013oUIFE
odY:B_l/;2colo?coo;bl_m2@T;oO7aloo;bl_oclo?ofm_Ko`L71onVYZKolo?cod51@OmlO7col_;b
0_oclo<02om2@T;oO7aloo;bl_oclo?o@T92ogalO?oclo?ol_;boo?cloobl_;olo?c00?ol_;b0_oc
lo<01?obl_;olo?coo;bl_oclo<2oo;blP03oo?cloobl_;olo?c00?olo?c0_odm?@01?ofm_KomoOg
ooOgmoohn?P4ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT2oo[jnP05ooWinOojn_[onOWi
oo[jn_oinOT00_ohn?P01Oofm_OomOKfooCdmOocm?Gol_?d00ColO;c00ColO7coo7blooalO;olO;c
0_oalO801Ooal_?ol?7boo7blooalO;olO;c00;olO7b00Ool?7boo7blooal_?olO7boo7blooalO;o
lO;c00;olO7b00GolO;coo3al_oal_?olO7boo7bl`02oo7alP04oo3al_oal_?olO;coo7al`kolO;c
01So@D]GodE@G?m9EF;oCEUWoe5NK?mDHG3oEVAdoeYXN?mKJW_oGFeoof1`POmUM8GoJWZ:og>1TOmo
S9_oSY^VoijX]?nc^lGob<kDom_Phoo[k>oomOKgoo_knoono_h9ooooo`00@Oo^k^h04?o/k>cojn_[
onKVi_oShn?oh>3Pom[Jf_oFe]KobLW9okfm_On`/;3oVi^KohV9ROmcLg?oHV9RonGUiOoVi^H2onWY
j@?ojn_[00?ok>c/on_[joo/k>`00_o[jn/00oo/k>cojn_[on_[j`02on_[j`0;ogalO?lJ6Q[oIfMW
ofMWIomNGUko3@d=ohN7Qoo[jn_ok>c/odA4A?mlO7`00oo[jn/01OlQ8B7oRh^;on_[jom5ADGoO7al
00;ojn_[00Ooj^[ZodE5AOmlO7cok>c/on_[jom5ADGoO7al00Wojn_[00Coj^[Zon_[joo[jn_ok>c/
1_o[jn/01OoZj^[ojNWYonSXj?oVi^KoiNGU00;oi^KV0_oXj>P00ooZj^[ojNWYon[ZjP02on_[j`07
on[Zj_o[jn_oj^[Zon[Zj_o[jn_oj^[Zon_[j`02on[ZjP04on_[jooZj^[ojn_[onWYj@;ojNWZ00?o
j>SXonKViooUi^H00_oSi>D01OoSiNOohnGXonCWj_oTin[oi>SZ00;oiNS[00Ooi^W[onGXjooVj>_o
i^W/onKYjooUj>_oi^W[00;oiNS[00koi^W[onGXjooVjN_oi^S[onGXjooVjN_oiNS[onKYk?oUj>_o
i^S[onKYk?oVjN_oiNS[onKYj`;oiNS[00Woi^W[onGXjooVjN_oi^S[onGXjooVjN_oiNS[onKYk?oU
j>/00ooVjN`08?oVjN_oi^W/onGXjooVjN_oi^W/onGXjooVjNcoi^W[of:2X?mYS:coKiBfogJL`?mj
XlWoOjWAohB_f?n7/mkoRKOToh^kjOn:_N_oQ;GXogf]g?mbVlOoJHZ^ofYoUOmhQiCoSIVTojB/]Onj
_lKoc]7FomgNh?oVinOok>c/2Oo^k^h0047oi^KV00ooi>CTon;Rh_oPh>3og=cLomSHf?oDe=Coc/k>
okno_onc/k?oXJ6Qohb<S?mhN7SoI6ATofQXJ?ogmoL00_oinOT3oo[jnP03oo_knoojn_[on_[j00?o
n_[j00?onOWioo[jn_oinOT00_ojn_X06?oMgMgo410@om[Jf_ojn_[oWYjNoa8B4_oVi^KonOWioo[j
n_m9BDWoOWinooWinOojn_[oj>SXo`h>3_o2`/;on_[jodQ8B?m_Kfoon_[jooWinOojn_[oB4Q8oh:2
PP;on_[j00CoB4Q8oh>3Poojn_[onOWi0oojn_X01OoinOWon_[joo[jn_oinOWon_[j00;onOWi0_oj
n_X2ooWin@04oo[jn_oinOWon_[joo[jnP?onOWi00KomoOgooCdm?odm?Com?CdooGemOofm_H3ooOg
m`gon?Sh00gomoOgooKgmooemOKom?Geoo;cm?obl_?olO?eoo7dmoobmOWoloKiooCfnOocmoWom?Oj
00;om?Oi0_odmoX2ooCgn@0:ooCgn_odmoWom?OjooGhn_odmo[om?OiooGhn_odmo[om?OiooGhnP;o
m?Oi0_odmoX2ooCgn@0:ooCgn_odmoWom?OjooGhn_odmo[om?OiooGhn_odmo[om?OiooGhnP;om?Oi
0ooen?X01Oodmo[omOSjooCgn_oen?[omOSk00;omOSj01_omOSkooGhn_oen?[oJhbUog:E/?miW[_o
OjK4ohF^c_n:]MGoS[_Moi;1iOnFa^[oU/S`oiO;m?nEb?GoT/Sgohc1m_n1^_?oKioDofJ6ZomcPI3o
RIFPoj:Z/_nh_/?ocM3ComSIf_oQhN802OoVi^H0047ok^k^00kok>c/on_[jooWinOohn?Son3Ph?oJ
f][oeMGEolC4a?nc/k?oWYjNohJ6Q_maLG7oN7Qhohn?S`;oo_kn3?ooool08_ono_koooooookno_on
o_koE5ADoh20P?ono_ko@d=3oeaLG?ono_koooooookno_m;Bd_o9bLWoifMWOoNg]koLG5aoahN7_ok
no_oo_knod];BolP823oUYJFonGUiOolo?coBd];ohJ6Q_ono_koooooodY:B_n6QXKoooooookno_oo
ool8ooknoP03ooooooono_kooooo00;oo_kn00?oooooookno_ooool00oono_h3oogmo@04oo[jn_oi
nOWon_[joo_kn`;oo?cl00CooOgmookno_omoOgoo_kn2?omoOd02oono_kooOgmoogmoOokno_on_[k
ooWin_ofmoSomOSjooGio?ofnOgomo_n00;on?_n0ooio?h02?ojoOoonOcnoo[moooio?kon_cnoo[m
oooio?kon_go0_oio?h03_ojo?konOcnooWlo_ojo?konOcnoo[lo_ojoOoonOcnoo[moooio?kon_cn
oo[moooio?kon_go0_oio?h02?ojo?konOcnooWlo_ojo?konOcnoo[mo_ojoOoonOcn3?ojoOl06?m^
T:CoMYZ`ogjT_?n4[<CoR[C>ohnkeOnD`MgoVLKUoic;j_nOd?3oWm;coi_AmonJc_WoTlShohW0mOmn
]?7oKZKSof69]OmfR9[oU9jYok6h__o9c]7ofmcOonCUiPWok^k^0011ooooo`0?oogmoOokno_omoOg
ooCdm?o`l?3oj^[ZonGUiOo>c/ko^KVioinOWon5QHGoOgmooi:BT_nATI7onOWi00Con_[j0_okno/6
oo[jnP0LooWinOojn_[onOWiooWinOojn_[o[jn_ob@T9?o<c<co3Ph>okNg]ooinOWon_[jooWinOmK
Fe_oSHf=of][JolI6AWo9BDUojRXZ?oinOWon_[joeaLG?n<S8coI6AToaHF5_o/k>coFe]Koi2@T0;o
nOWi00CoBDU9oh>3PooinOWon_[j0_oinOT2oo[jnP06ooWinOojn_[on_[joo[jn_oinOWon_[j0_oi
nOT01?ojn_[onOWiooWinOojn_X2ooWin@;on_[j00ConOWiooShn?ohn?Son?Sh0_oemOD00oofm_Ko
moOgooWin@02ooWin@03oo[jn_oinOWonOWi00;on_[j00oonOWioo[jn_ojn_[on_[jooWinOojn_[o
nOWiooOhn?ogmoSomOGfoo?cm?o`l_Gol??goo7dn?obm_T00_ocm_T03OodmoWomOSjooGhn_oen?Wo
mOSjooCgnOoemoWomOSjooGhnOoemoWomOSjooGgnOoen?T00_oen?X01_oemoWomOSjooGhn_ofn?[o
mOSiooGhnP;omOOi00KomOSjooGhnOoemoWomOSjooGgnOoen?T2ooGhnP09ooGgnOoen?[omOSjooKh
n_oen?WomOSjooGhnOoen?[om_Wj00;omOSj00?om_SjooGhn_oen?X00_ofnO/06ooen?[om_SjooKi
nombTJGoNIZ`oh6T^on7[<CoS[C>oiBle_nH`]goW<SToio>j_nQd^ooXM?coj7Bn?nMdO_oU/cjohg3
mon0]_7oLZWTof>KfOmOQk?oSIVVojbe_oo;dMOohnKYoo7bl`09ooooo`00@Oo^k^h03oo/k>coj^[Z
onOWiooTi>Coh>3Pom_KfooEeMGo^k^kojFUYOn=SHgoOWinoi6ATOnCTi?oTI6Aon_[j`09onc/k005
ong]kOo/k>cojn_[on_[joo/k>`00_o[jn/01ooZj^[oiNGUob<S8ola<C7o9RHVon[Zj_o/k>`00_o[
jn/01Oo/k>cojn_[on[Zj_oYjNWok>c/00;ojn_[00kok>c/on_[joo/k>cojn_[onSXj?o[jn_ok>c/
on_[jooZj^[ok>c/odE5AOmlO7cojn_[onc/k0;oj^[Z00?ok>c/on_[joo/k>`00oo[jn/2onc/k003
on_[joo/k>cojn_[00;ojn_[00Cok>c/on_[joo[jn_ok>c/0_o[jn/01?oZj^[ojNWYonWYjOoYjNT2
onOWi`?ojNWY00Ooj^[Zon_[jooZj^[oj^[Zon_[jooZj^[ojn_[00?oj^[Z0_o[jn/02?oZj^[ojNWY
onOWj?oUiNKoh^CVon7Uj?oRiNWohnKZ0_oTin/2onKYj`0:onKXjooVjN_oin[/onOZk?oWjN_oin[/
onOYjooVjN_oinW[onOZk0;oinW[00Coin[/onOYjooWj^coinW[0_oVjN/2onOZk00<onOYjooWj^co
inW[onKYjooWjN_oi^SZonGWjOoWjN_oin[/onOYjooWj^coinW[0_oVjN/3onOZk005onSZk?oWj^co
in[/onOZk?oXj^`00_oWj^`00ooXj^coin[/onSZk002onOZk00Hog2?Y?mhVK3oP:>lohJ[a?n=]<ko
T[[FoiK0gOnKa^GoWL[Zoik?l?nOd?CoWm7goic>nOnFbOSoS<;foh2dkOmbZNGoI9_Hoe><bomOPJKo
UIjYok>j`Oo;d=CogMkP2Oo^k^h0047oi^KV00_oi>CTon?ShooOgmoofm_KomSHf?oCdm?oclo?ok6a
/OnKVi_oPX:2ohB4Q002oi6AT@04ohj>S_oinOWonOWiooWin@[on_[j0_oinOT04OoemOGok>c/on_[
joo]kNgoLG5ao`D51On0P83on_[jono_koo[jn_ok>c/ooCdm?o/k>col?3`ooWinOo_knoolo?c00;o
nOWi01Gom?Cdong]kOojn_[onOWiooShn?mGEeOoQXJ6onc/k?o]kNgoB4Q8oh>3Poohn?Sokno_onc/
k?o]kNgok>c/ooKfm_oinOWokno_oo;bl_ojn_X00ooinOT00oojn_[onOWioo[jnP02ooWin@03oo[j
n_oinOWonOWi00?on?Sh0_ogmoL00oofm_KomOGeooCdm002ooKfmPkon?Sh00com_KgooCemOobloCo
k_7eonobm_oam?SolOCgoo7en?obmOSoloKiooCgnOodm_T4ooCgn@03ooGgnOodmoWomOOj00;om?Oi
00?omOSjooGgnOodmoT00_odmoT00ooemo[om?OiooGgn@03ooCgn@08ooGgnOodmoWol_?eonc/k?o/
k>gokNg^onc/k?o`l_<2ooCgn@03ooGgn_o]kNkol?;c00;om?Oi00?om?Kiong]k_o]k^h00_oen?X0
0ooemo[om_SjooGhnP02ooGgnP?omOSj01SoK8ZSogBC[_mkWK[oPJC3ohR]c?n=/mCoT[[LoiBohonF
`^OoVlW_oi_8lOnHao?oU/Kdoho2m?n8_?;oOK7Yog2WhOmSVMOoDH_:odUj/_mkRj3oYJbeol75b_oD
eMP9onKViP00@Oo^k^h03oo/k>coj^[ZonOWiooTi>Coh>3Pom_KfooEeMGo]KFeoibLW?n2PX;oS8b<
oi2@T?n?ShooRXZ:oogmo@04ooknoP05ooooooono_koooooookno_ooool01?ono_h00oohn?Sol?3`
ooShn002ooknoP09onOWionJVY[oi^KVoo[jn_o`l?3oo?cloogmoOoemOGol?3`00;oo_kn00Kom?Cd
ooKfm_ono_koo_knooWinOoalO42ooknoP07oo?clon/[:coc<c<ookno_olo?coBTY:ohJ6QP02ooCd
m008ooclo?ono_kooOgmoogmoOono_kolo?cooOgmoomoOd4ooknoP05oogmoOono_koo_knookno_om
oOd00_ono_h2oogmo@;oo?cl0ookno/00oojn_[ono_koo_kn`02oogmo@04ookno_omoOgooOgmookn
oP?ooOgm00coo_knoogmoOono_kooOgmookno_oknoconOWjooGgnOocm_[om?OkooChnoofnO`3ooOj
o@03ooSjoOohnokon?_m00?onO_n00SonOcnooSkoOoio?konO_nooWlo_ohnogonO_nooWloP?onO_n
00ConOcnooSkoOoio?konO_n0_oio?h02?oemoSolO7aooKhn_oio?kon?_mooOinooalO7omOKg0_oi
noh03Ooblo?om?KgooWlo_oinokoloCdoo7bl_ohnogon_coooWlo_ojo?oonO_nooWlooojo?l00_oi
o?l06_oio?kon_coofF3X?m]SJ_oM9JfogZM`?n0YLSoQ:[?ohVaeon<]]koSk_Uoi2mj?nB_N_oTKo^
ohjnl?n8^NcoP[CXogN[hom/X=WoGYKBodj9b?lmNKgoG7fRojF^]oo3b<cofMcM2Oo^k^h0047ooooo
00kooOgmoo_knoogmoOolo?coo3`l?oZj^[oiNGUol71`OnUYJGoQ8B4ohZ:R_n=SHgoRXZ:ohR8R0;o
n?Sh00?onOWiooShn?oinOT02?oinOT00oohn?Sok>c/oo3`l002ooShn00>ooWinOohn?SonOWiooWi
nOofm_Kojn_[ooGemOohn?Solo?cong]kOohn?SonOWionk^k_obl_82ooShn006ooCdm?o/k>conOWi
ooOgmoo[jn_olo?c0oohn?P2ooGem@03on_[joodm?ConOWi00;on?Sh00KonOWiooShn?o_knool_;b
ooShn?oinOT3ooShn003ooWinOohn?SonOWi00Gon?Sh00?omoOgooShn?ogmoL00_ofm_H00ooemOGo
m?CdooKfmP02ooShn003oo[jn_oinOWon_[j00;onOWi00Kon_[jooWinOojn_[on_[jooWinOojn_X2
ooWin@03ooOgmooemOKoko7d00;ok_7e00Gol??foo3cmooam?Ool_Ghoo;dm`03oo?fn009oo?fnOoc
m_SoloGhoo?fn?odm_WoloKhooCfnOocm_Som?Ki00;oloKh00Kom?Kioo?fn?odm_Wom?Kioo?fn?od
m_T3oo?fn00Eonc]kOo^k^oom?Kioo?fn?odm_WoloKhoo3aloo/k>col_GgooCfnOo]kNkoko7booCf
nOo^ko3ojnc/oo;emoodmoWom?KiooCgnOocm_Wom?Oi00;om?Ki01com?Ojoo?fnOodmo[om?Oioeml
VomVQJGoK8f`og:D^OmgW<;oO:;9oh2Wd?n4[=OoQjoLohRdhOn8]>CoR;CVohBdiOn0[^;oNZcPog2T
f_mVV]GoF8o=odR1aOlhLkSoAg6Wojff__o@eM[oj>_^2Oooool0047ok^k^00ook>c/on_[jooWinOo
i>CTon3Ph?oJf][oeMGEokBd]?nJVY[oOWinohF5QOn:RX[oR8R8ohB4Q?oYjNT01OoZj^X4on_[j`?o
j^[Z00Coj>SXomgMgOoWinOojNWY1_oZj^X01OoVi^Koh>3Pon3Ph?oPh>3og]kN00;oj^[Z00[oh>3P
onCTi?oYjNWoj^[ZonKVi_oNg]koj^[ZonKVi_oMgMgoj>SX0ooZj^X00ooYjNWoinOWomkNgP04on3P
h004onOWiooZj^[oh>3Pon?Sh`Goj^[Z00?ojNWYon[Zj_oZj^X00_oZj^X00ooYjNWoj^[Zon[ZjP02
onWYj@03onSXj?oYjNWoj>SX00?oinOW00Goj>SXon[Zj_o[jn_oj^[Zon_[j`02on[ZjP04on_[jooZ
j^[oj^[Zon[ZjP;ojn_[00Goj^[Zon_[jooXj>Soi^KWomoRi@02on3Si`0Bon7Uj?oRiNSohnKYon?V
j_oSi^Woi>OZonCWjOoUin[oiNSZonGWj_oUj>[oiNOZonCWjOoUin[oiNSZonGWj_oUj>[oiNOY0_oU
j>X3onGWjP;oiNSZ01WoiNOZonGXj_oTi^SogMgMon;SiOoUj>[oiNOZonGXj_oUinWoi>KXomkNg_oR
i>KoiNOZomkOgooQhnCoh^?UomgMg_oTi^SoiNSZonGWj_oUj>_oi^S[onGXj_oVj>_oiNSZ00;oi^S[
01_oiNSZonGXjooUj>[oFgJEof5oWomWQZWoK8fbog6D^_meVL3oNIo7ogZRc_mmYM;oOZ[FognYfOmm
Zm[oO:_MogFUfOmaXmWoJIcEoefCd?m@RLOo@Wfoobm[/OlaH:7oXJZcol;7c?oHfmh02Oo^k^h0047o
i^KV00_oi>CTon;Rh_oOgmoofm_KomSHf?oCdm?oc/k>ojn_[onGUiOoMgMgoh20P002ohF5Q@04oh20
P?ogmoOomoOgooOgm`Oon?Sh00OonOWiooShn?ogmoOolo?con_[joofm_Kon?Sh00;omoOg0oohn?P4
ooOgm`04oo?cloo]kNgomoOgooOgm`;okno_00Son?ShooOgmooclo?okNg]ooShn?ofm_Kojn_[oo;b
lP;omoOg0_ohn?P00oofm_Kojn_[ooCdm002ooGem@05on_[joofm_Kon?Shono_kooalO401?ogmoL2
ooShn0;omoOg00?on?ShooOgmoohn?P01OogmoL2ooKfmP03ooGemOodm?Com_Kf00;omoOg3Oohn?P0
1_ofm_Oom?Geonc_loo]l?Cok_7eonkbmP;ol??f00Gol??goo7dmoobm?Sol_Cgoo7dm`02oo;dm`0L
oo;emoocmOSoloGhoo;emoobm?Ool_Ghoo;emoocmOSol_Cgoo;emoobmOSoloGhoo;en?obm?Ool_Gg
oo;dmoobmOOolO;don_[jooaloKol_Cgoo;en?obmOOoloGhoo;dmoo[jn_ol?7coo?en0;okNg^00Oo
jn_[oo3bm?obmOSoloKhoo?fnOocmOSol_Gh00;oloGh01koloKioo;en?ocmOSoloGhoo?fnOocmOSo
Dg2?oeUhV_mNOj?oHhJ/ofR=]?m/T[_oL9K1og6KaOmcWL[oM:7>ogFSdOmbXM?oLJ7EoffOe?mWV];o
GYC>oe>:b?m8P/Co>GFjobUS[?lQDI_oX:Rbokc2a_oBeMD9onKViP00@Oo^k^h02oo]kNgoj^[ZonOW
iooShn?oh>3Pom_KfooEeMGo^;Rhoj2PX?maLG7oNWYj00;oOgmo00SoOWinooclo?olo?coo?cloogm
oOolo?cooOgmooclo0?ooOgm00Koo?cloogmoOolo?con_[joo3`l?ojn_X7ooclo003ooWinOojn_[o
o?cl00;om?Cd0_olo?`01?oclo?olO7aooKfm_ojn_X2ooCdm0;oo?cl00colo?coo;bl_oinOWoo?cl
oo[jn_omoOgoo?cloo?cloofm_Kono_kooOgmoobl_82ooclo003oo;bl_ofm_Koo?cl00Coo?cl00?o
oOgmooclo?olo?`01?olo?`01?okno_oo?cloo_knookno/2oo[jnP03ooWinOohn?Son_[j00;oo?cl
00?ooOgmookno_omoOd00oomoOd01Oono_kooOgmookno_omoOgoo_kn00;ooOgm00Cono_koo[jnooa
loOol_Ci0_ocm_X3ooCgn`05ooKho?oen?_om_WlooKio?ognO`00oofnO`01_ogn_gom_WlooOio?og
n_com_WlooOio0;om_Wl00Gomo[looKio?ogn_com_WlooOjo002ooOio00CooGgnOo`l?3omOOjooOi
o?ogn_com_WlooOio?oemo[ol?3`ooGfn?ofnOcol_;coo?dmOoalO;om?GgooOio?ofnOcomo[mooOi
o@02ooOjo@0OooOioOogn_gomoWmooKio?ogn_gom_WlooOjoOm<JhcoDW>FoeMjWomLP:OoH8J_ofB;
]_mWT;coJ9?1of^Ga_m[V<SoJi_<ofVIc_mVV<koHYK>oefBcOmDRlSoB8;4oc]g_Ol]JK7o95VToaa7
TonZ/[[ob<cAom_Lg`09onk^kP00@Oooool02OomoOgono_kooOgmoodm?Col?3`on[Zj_oUiNGobLW9
ok:b/P02og5aL@04ogMgMomhN7SoN7QhooKfmPGomoOg0_ohn?P02?ogmoOon?ShooOgmoohn?SomoOg
ooKfm_o[jn_olo?c1oogmoL01Oobl_;okNg]onc/k?o^k^kom?Cd00;omoOg00?okno_oo;bl_o`l?00
0_o]kNd02?odm?ComoOgooOgmoofm_Kokno_on_[joo/k>cokNg]0_ogmoL01Oofm_Kok^k^onc/k?o/
k>com?Cd00;omoOg00?ok^k^oo7alOogmoL02OogmoL00oofm_KomoOgooOgm`03ooKfmP;omOGe0_od
m?@00oogmoOon?ShooWin@02ooWin@07oo[jn_oinOWon_[joo[jn_oinOWon_[jooWin@02oo[jnP0:
ooWinOojn_[omoShooKfmoo]ko?ok>kcong_m?o^lOGokO7eonobmP;oko?f00Gol??goo7cmooam?Oo
lOCgoo7cmP06oo7dm`03oo;dmooam?Ool_Cg00SolOCg00?olO?fon_[joo_lO<00_oam?L03?obm?Oo
lOCgono`l_o[jn_ol?;eoo7dmoo/kNgoko3boo3cmOo[jn_ol?;doo7dm`;ol_Gh00ColOCgoo;dmoob
mOSolOCg0_obmOP06ooam?Ool_Ghoo;dmom8IhWoCFjBoe9dVomFNj?oFX2[oej5/_mQR[SoHHfmof>A
`_mTTlGoI9C7of:EbOmPTl_oFXo;oe69b?m6PL;o>gJlobiZ/olUG:Wo6dZHob=8S_noalkofn3Sonk_
l@09ooooo`00@Oo^k^h04?o/k>cojn_[onOWiooShn?oh>3Pom_KfooEeMGo`<30oj^[ZomdM7CoJVYZ
ofm_KombLW;oLg=conSXj?oYjNT5on[ZjP05onWYjOoZj^[oj^[Zon[Zj_oYjNT00_oZj^X01_oRh^;o
gmoOonSXj?oYjNWoj^[ZonWYj@;oj^[Z0_oYjNT02?oZj^[ojNWYon[Zj_oYjNWoj^[ZomWIfOoWinOo
j^[Z0_oOgml01?oZj^[ojNWYon[Zj_oZj^X2onWYj@04on[Zj_oYjNWof][Jom_Kf`;oj^[Z1?oYjNT0
1?oZj^[ojNWYon3Ph?oShn<2onWYj@04on[Zj_oYjNWoj^[ZonWYj@;oj^[Z1_oYjNT00ooXj>SoinOW
onKViP03onGUi@;ojNWY00Coj^[Zon_[jooZj^[ojn_[0_oZj^X01?o[jn_oj^[Zon_[joo[jn/2on[Z
jP05on_[jooZj^[ojNWZonOXj?oPh^D00_oNh>D01ooOh^Kogn?Won3TiooRiNSohnKYonCVjOoTinT0
0_oTi^T01?oUin[oi>KYonGWj_oTinT2onGWjP06onCWjOoUin[oiNOYonCWjOoUin[oiNOY0_oUinX0
5_oTinWoi>KYonGWj_oUinWoiNOZon3Qh_oOgmooiNOYonCWjOoUin[oi>OYomkOgooPh>7oiNOYonGW
j_oOgn3ohN;SonCVjOoSi>Kog]kNonCVj?oUinX2onGXjP06onGWj_oUj>[oiNOZonGWj_oUj>[oiNOZ
0_oUj>X06?mGLHcoGGVFof>2X?mXR:SoKHn`og6C]_meVKgoMY_3ogRNaomjX/coNj?>ogRSd?mdX];o
KIg>oejAb_m5Okoo;VZcob=JZ?lLBi[o4S^:ocEBS?nm`lWoe=OJon3QhPWok^k^0011onKViP0>onCT
i?oRh^;ogmoOom_KfooIfMWodm?Colk>c_nm_Kgo[:b/oginO_mNGUkoHf=SofQXJ?m^KVh2ooOgm`Co
n?Sh0_oinOT2ooShn00@ooWinOohn?Son?ShooShn?ogmoOok^k^ong]kOlg=cOoWinOoo7alOoLg=co
W9bLonCTi?ohn?So_;blo`d=3@;on?Sh00WoEeMGoa<C4olT92CoVi^KoahN7_mLG5con?ShodM7Aon1
PH400oohn?P02OoOgmooAdM7o`d=3OlM7Ago9RHVoo7alOohn?SoAdM7oh:2PP02ooShn003oj:RX_lL
71colO7a00Kon?Sh00?omoOgooShn?ohn?P00_ohn?P01OogmoOon?ShooOgmoofm_KomOGe00;om?Cd
00?ol_;booCdm?ogmoL00_ogmoL=ooShn009ooOgn?ofm_Ool?7con_]l_o/k_;ok>oconkamOo`l_Ko
l_Gg00?oloGg0_odm_P01Oodm_Oom?GgooGfn?odm_Som?Kg00?om?Kh00GomOKhooCfmoodm_Som?Kh
ooCfm`02ooCfn00DooGfn?odm_Som?KgooGfn?odmOOokNg^ong]kOo`lO7ol?7bong^k_o/kNgoloGf
ooCfn?odm_OokNg^oo3al_oem_Som?Khoo3al_o]k^h2ooCfn00QooGgn?oem_SomOKhooGgnOodm_So
mOOhooGfn?odm_SomOKhofUmTOm`QIcoMhjUogbD[On3W;KoR::lohbW`on>Zl[oTjo>oi>cd_nD]MGo
UKKGoi:dfOn=/MWoP:SCoeJ8`_lXGJWo6TRIoa4iRol9:ggoFVjGol76b_oCe=Oog=gN00Woi^KV0011
onk^kP0@ong]kOo[jn_oi^KVon?ShooPh>3ofm_KomGEeOo7alOo^KVioibLW?mOGeooF5QHoeeMGOmV
IVKono_kooclo0?ooOgm00?oo_knoogmoOomoOd02?omoOd04Oohn?So>CTioj6QXOogmoOoSXj>o``<
3?n:RX[oo?clol71`Ol>3PkooOgmolO7aolA4A7og=cLonKVi_mSHf?o71`L00;ooOgm00koBDU9ohB4
Q?omoOgooOgmooclo?m;Bd_o=SHfolc<c?olo?cof=SHoo_knoomoOgoBDU9ohB4Q0;ooOgm00GoYZJV
oadM7OogmoOooOgmooclo003oogmo@03ooclo?omoOgooOgm00;ooOgm0_olo?`02?omoOgoo?cloo_k
nooinOWon?ShooOgmoohn?Sono_k0_olo?`2oogmo@05ookno_omoOgooOgmoogmoOono_h00_omoOd0
0oono_kooOgmoogmo@03oogmo@08oo_lo?oin__olO?foo7bmooaloOol_ChooKhnoohn_`2ooWjo00;
ooWkoOoinoconO[loo[koOoinoconO_mooWko?ojnogonO_loo[koOoinod00_oino`01?ojnogonO_m
ooWkoOojo?d2ooWko00;oo[koOoinoconO_mooWko?ojnogom_OhooGfm_odmOKom_OhooWko?ojnod0
0_oinod03_ogn?Won?WjooWko?ojnogonO_mooKgn?ohnO[on_cnoo[koOojo?kon_cmooWkoOojnogo
n_cn0_ojo?d06Oojo?koKGnBogB7W?mlTJKoPYR^ohVO]on=YKgoTj_4oiN_b_nJ]LooWKSDoibjeOnK
^]SoW;[JoijjfonD/]OoIhk2ob=@W?l?=8So1bMioadhN?nS[;[oe=OJon3Qh_oYjNX02Oo^k^h0047o
oooo00oooOgmoo_knoogmoOom?Cdoo3`l?oZj^[oi>CTomSHf?o<c<co_;bloh:2P_m:BT[oD51@oe]K
Foofm_H01?ohn?P00ooinOWon?ShooShn002ooShn005ooWinOohn?Son?ShooShn?ogmoL00_ohn?P0
5?ln?SkoY:BTooShn?lj>S[oCTi>oc0`<?ohn?So_Kfmo`d=3Oohn?Soe=CDo`h>3_nk^k_omoOgoijN
W_lY:BWon?ShooOgmom7AdOoPH610_ohn?P00ooGemOo3@d=oiJFUP04ooShn007ooOgmom7AdOoPH61
ooShn?ogmoOoXZ:RobDU9@09ooShn004ooOgmoohn?SomoOgooShn0;omoOg00KomOGeoo?cloobl_;o
lO7aooGemOohn?P3ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT2oo[jnP0<ooWinOojn_[o
nOWiooWinOohn?SomoShoo7bm?o[k?3ojngaonc^looal_KoloCf0_odmOL01_oem_Som?KhooCfmood
m_Som?KgooGfn0;om?Kg00GomOKhooCfmooem_Som?KgooGfn003ooCfm`;omOKh00Com?KgooGfn?od
m_OomOKh0_odm_L01Ooem_Som?KgooGfn?odm_OomOKh00?om?Kg0_oem_P01?odm_OomOKhooCfn?oe
moP2ooGfn005ooGgn?odm_SomOOhooGfn?oemoT00_oem_P06_odm_SomOOiof]mSombQYWoNXnSoh2E
Zon6WKCoRj:joi2X`?nE[LOoU[3;oiffdOnN]]?oWkWGoinge_nO]]KoTj[AoeUi/olE>8So12Aeo`0L
JOmWMi_ogN3Uonk_lOogn?SooOgm2Oooool0047ok^k^01;ok>c/on_[jooVi^Kohn?Son3Ph?oJf][o
e]KFolc<c?o2`/;o]kNgojFUYOmXJ6So@d=3oda<C?oVi^KojNWYon[Zj_oYjNT2on[ZjP05onWYjOoZ
j^[oj^[Zon[Zj_oYjNT00ooZj^X03?oYjNWoj^[ZonWYjOlj>S[oVi^KolK6a_l=3@goa<C4oc0`<?nj
^[[o/K6ao`h>3P;ojNWY00WoXZ:RocPh>?lh>3So>c/kobLW9ooYjNWoj^[Zod92@_mkNg/00_oYjNT0
0ona/K7o30`<okjn_P02onWYj@;oj^[Z00OojNWYod=3@omjNW[ojNWYon[Zj_nIVIWo92@T00;ojNWY
00?oj^[ZonWYjOoZj^X00_oYjNT2on[ZjP03onWYjOoZj^[ojNWY00;ojNWY00Koj>SXonKVi_oTi>Co
h^;RonGUiOoYjNT3on[ZjP;ojn_[00Ooj^[Zon_[jooZj^[oj^[Zon_[jooZj^[ojn_[00;oj^[Z00?o
jn_[on[Zj_o[jn/00ooZj^X01OoYjNWohN7TomkNh_oMgn?ohN;V00;oiNKX0ooVinT00ooVj>Woi^OY
onOXjP02onKWj@04onOXj_oVj>Woi^OYonKXj@;oi^OY00?oi^SYonKWjOoVj>T00_oVinT00ooVj>Wo
i^OYonOXjP02onKWj@04onOXj_oVj>Woi^OYonKXj@;oi^OY00?oi^SYonKWjOoVj>T00_oVinT01?oV
j>[oi^OYonOXj_oVinT3onOXjP06onKXj_oWj>[oi^OYonKXj_oWj>[oi^OY0_oWj>X06?mYMhcoLH2F
ogN7WomnSjSoPiF_ohVK]_n>XKcoTZK2oiFZa_nH[<[oVJc<oi^_c_nL[m7oTjO=og^B_olcCiKo0Am^
o`0HHom5E8Cob/oCom_LgooTiNKoj^[Zong]k@Wok^k^0011onKViP0AonCTi?oRh^;oh>3PomcLg?oH
f=Soe=CDolk>c_o6a/Ko_[jnokBd]?nXZ:SoTi>CoeeMGOlj>S[olo?cooGemOofm_H00oogmoL00ooh
n?SomoOgooOgm`02ooShn0?omoOg00com_KfooOgmoogmoOo?Cdmoj>SXomnOWko>3PhooOgmon:RX[o
K6a/ok^k^ol<30`2ooOgm`05ooKfm_ogmoOomOGeoiBDU?lZ:RX00_ogmoL01om6ATKoK6a/ooOgmoog
moOoeMGEo`/;2onATI400_ogmoL01Oofm_KomoOgooKfm_m6ATKoHV9R00;omoOg00?oW9bLobHV9_og
moL00_ogmoL01oofm_KomoOgooOgmoogmoOom_KfooOgmoofm_H00_ogmoL02?ofm_KomOGeooCdm?ob
l_;ol?3`oo?cloofm_KomoOg4oohn?P2ooOgm`06ooGem_o_l?;ok>gaong^l_o`lOCol_?f0_ocm?H0
0oodm?OoloCfoo?dmP02ooCem`;oloCf00?om?Ggoo?dm_odmOL00_odmOL01Oocm?Kom?GgooCemooc
m?Kom?Gg00;oloCf0_odmOL2oo?dmP03ooCemoocm?Kom?Gg00;om?Gg00GoloCfooCemoodmOOoloCf
ooCem`02oo?dmP?om?Gg00?oloGgooCemoocmOL01oodmOL05_mQKHCoIgB=ofekUOmcPYgoN8RUogf=
Zon1TK3oQYJgohRJ^_n=W/3oSYk1ohZJ`On5Ul3oL8BdociHUOl;96co015God=@OOne^L?odmCGom_L
gOoQhN82onGUi@Woi^KV0011onk^kP0>onc/k?o[jn_oinOWon?ShooPh>3of][JomGEeOo=cLgoa/K6
okfm_Onc/k?oYZJVoiRHV?mTI6@2ooKfmP03ooShn?oinOWonOWi00?on_[j00?ono_koo[jn_okno/0
1_ojn_X02Oll?3coY:BTobPX:?n=SHgon_[jon3Ph?lM7Ago^;Rgo``<3002oo[jnP05okBd]?oHf=So
moOgofIVI_mIFET00_ojn_X02_m6ATKo71`Loi:BT_oPh>3on?ShodE5AOl^;Rko_KfmooWinOoKfm/2
oo[jnP06odI6A_lM7AgoNGUiom_KfomLG5coDU9B2oojn_X01ooinOWon?ShooOgmooemOGom_KfooWi
nOolo?`00oomoOd01_ono_kooOgmoogmoOono_kooOgmooknoPSooOgm00?oo_knoogmoOono_h00oom
oOd2ooclo005ooGfn?oal_GolO;foo;cmoocm?P00_oem_T01OoemoWom_OjooGfnOofmo[om_Oi00;o
m_Oj00Wom_OiooKgn_ofmoWomOOiooKgn_ofmoWomOOiooKgn_ofmoT00_ofmoX00oofmoWom_OjooKg
n@02ooKgnP09ooKgnOofmo[om_OiooGgnOofmo[om_OiooGgnOofmo[om_Oi00?om_Oj00Kom_SjooKg
n_ofmo[om_SjooKgn_ofn?X6ooKgnP0EodAAL?m8EgSoCEf0oe5QQ_mEIXgoF6VAoe]]UomLKY_oGG6N
of9eX_mNLZ7oFVfOodQKTolV>WWo21ULoahYHomVKY3odmKIomgNh?oTiNKojNWZ00;okNg]2_o^k^h0
047ooooo017ooOgmoo_knoogmoOom?Cdoo3`l?oZj^[oiNGUomgMgOoEeMGocLg=ol;2`_nf][KoZJVY
oibLW?ohn?SomOGeoo?cl`02oo7al@Kol_;b00?olo?coo;bl_obl_800oobl_802Olh>3SoJ6QXo`L7
1ooJf][ol_;boo?clom7AdOoJVYZo`L71`02oo;blP05ohJ6Q_le=CGo5ADEocXj>_nk^k/00_obl_80
2_mDE5CoQHF5oeeMGOl?3`ooi>CTomgMg?mGEeOo51@Doa0@4?lZ:RX2oo;blP08od51@OmjNW[oMWIf
oaTI6Ola<C7o_;bloo;bl_oclo<8oo;blP;olO7a00Kol_;boo?cloodm?ComoOgooWinOojn_X4ooWi
n@04oo[jn_oinOWonOWioo[jnP;onOWi0_ojn_X01_oinOWon_[joo[jn_ojn_[onOWioo[jnP;onOWi
00Con_[jooWinOoinOWonOWi0_ohn?P01oofm_Ool_;donk_lOo]k_7okNgaong^lOo]kO400oo]k_40
1_o^ko;okNkbong^lOo]k_;okNkaong^lP;ok^ob00CokNkaong^l_o^ko;ok^ob0_o]k_82ong^l@06
onk_l_o]k_;okNkaong^l_o]k_7okNkb0_o^ko801?o]k_7okNkbonk_l_o^ko82ong^lP;okNka00?o
k^obong^l_o]k_800oo]k_82onk_lP;okNkb01Gok^oboaPTC?lI9U3o6bQFoa`ZF_lN;5ko7biRob0_
IOlP;fOo8S9Zob4`J?lM;FOo6bMTob@^J?lnA7CoLWJGol75dOo[k>oolO;cooOhn?okno/00_ono_h;
ooooo`00@Oo^k^h03_o/k>coj^[ZonOWiooTi>Coh>3Pom_KfooEeMGoc/k>olO7aoo0`<3o]kNgojf]
[OnRXZ;oUYJF1_omoOd00oolo?cooOgmoogmo@03oogmo@;oo?cl00KooOgmooclo?olo?co?clooalO
7om;Bd/3ooclo004ojNWYolO7aoo3Ph>oogmo@?oo?cl00?ono_kooclo?olo?`00_olo?`02OomoOgo
o?clooclo?oinOWoo?cloogmoOolo?cooOgmoo[jnP02ooclo006oogmoOm8B4SoQ8B4ooclo?okno_o
oOgm1?olo?`00oomoOgoo?cloogmo@03ooclo005oogmoOolo?coo?cloogmoOolo?`00_omoOd01_ol
o?cooOgmoogmoOono_kooOgmooknoP?ooOgm00?oo_knoogmoOomoOd00_omoOd00oono_kooOgmoogm
o@02oogmo@03ookno_omoOgoo_kn00OooOgm00Goo?cloogmoOolo?coo?cloo_lo005ooclo003oo_l
o?olo?coo?cl00Koo?cl0_oko?`5ooclo003oo_lo?olo?coo?cl00Koo?cl0_oko?`02Oolo?coo?cm
ooclo?omoOgoo?gmooclo?oloOgooOgmooclo@02oocmo@0GoocloOomoOgoo?cmooclo?n8RXcoTYBF
oibNX?nSYZSo[:jaok:d]ong^[go_/73ol?6bOo7b/gocLoAom7Ce_oEf=_ofM_MomgNh?oOh>7oi>GU
onWYj_o/k>`00_o]kNd<onk^kP00@OoVi^H03_oTi>Cohn?SomoOgooKfm_of=SHom?Cdoo?clooalO7
ol71`Oni^KWo/K6aojRXZ?nNWYkoTi>C1?ohn?P00ooinOWon?ShooShn007ooShn00?ooOgmoohn?So
moOgocdm?Ol<30coWIfMooShn?ogmoOon?Shonk^k_lG5aOo3@d=ooShn?ogmoOon?Sh00;omoOg00?o
n?ShooOgmoogmoL00_ogmoL00oohn?SomoOgooShn003ooOgm`03ooShn?ogmoOon?Sh00;omoOg00?o
AdM7oh61POogmoL00_ogmoL00oohn?SomoOgooShn003ooOgm`03ooShn?ogmoOon?Sh00;omoOg00Co
n?ShooOgmoogmoOomoOg7_ohn?P3ooOgm`03ooShn?ogmoOon?Sh00?omoOg00?omoOhooOgmoohn?P0
0_ogmoL00oohn?SomoOgooOgm`02ooOgm`03ooShn?ogmoOomoOh00?omoOg00?omoOhooOgmoohn?P0
0_ogmoL00oohn?SomoOgooOgm`02ooOgm`03ooShn?ogmoOomoOh00?omoOg3?ohn?P03_n<SHgoUIJG
oinPXOnWZ:So[k2aokFf]onl_Kko`/?4olO8bOo<cLkodM;ComCEe_oHfM[og=gM0_oQhN800ooTi>Co
iNGUonGUi@0>onKViP00@Oo^k^h03_o/k>coj^[ZonOWiooTi>Coh>3Pom_KfooEeMGoclo?olO7aoo1
`L7o^;Rhojn_[onTY:CoVIVI2oo[jn/05OoZj^[ojn_[on_[joo[jn_oj^[Zon_[jonVYZKoTY:BomoO
gooZj^[ojn_[on[Zj_o[jn_oZZZZoi>CToo[jn_oj^[Zon_[jooZj^[ojn_[on[ZjP02on_[j`?oj^[Z
00Cojn_[on[Zj_o[jn_oj^[Z0_o[jn/01ooZj^[ojn_[on[Zj_o[jn_o@d=3og]kNoo[jn/00ooZj^X0
1?o[jn_oj^[Zon_[jooZj^X2on_[j`05on[Zj_o[jn_oj^[Zon_[jooZj^X00_o[jn/3on[ZjP04on_[
jooZj^[ojn_[on[ZjP;ojn_[00Goj^[Zon_[jooZj^[ojn_[on[ZjP02on_[j`?oj^[Z00Cojn_[on[Z
j_o[jn_oj^[Z0_o[jn/01OoZj^[ojn_[on[Zj_o[jn_oj^[Z00;ojn_[0ooZj^X01?o[jn_oj^[Zon_[
jooZj^X2on_[j`05on[Zj_o[jn_oj^[Zon_[jooZj^X00_o[jn/3on[ZjP04on_[jooZj^[ojn_[on[Z
jP;ojn_[00Goj^[Zon_[jooZj^[ojn_[on[ZjP02on_[j`?oj^[Z00?ojn_[on[Zj_o[jn/01?o[jn/0
0oo/k>cojn_[on_[j`07on_[j`0>oiVIVOnTY:Co[jn_okRh^?o0`<3oalO7olo?cooEeMGofm_KomoO
gooTi>CoinOWon[Zj_o/k>`2onk^kP03ong]kOo^k^kok^k^00kok^k^0011ooooo`0>oogmoOokno_o
moOgoo?cloo`l?3oj^[ZonGUiOoMgMgoeMGEolk>c_o4a<Co^k^kok2`/?nUYJD2oo[jnP03oo_knooj
n_[ono_k00Won_[j00KonOWioo[jn_oinOWonOWioo[jn_oinOT2oo[jnP03ooWinOojn_[onOWi00;o
nOWi00Gon_[jooWinOojn_[onOWioo[jnP02ooWin@06oo[jn_oinOWon_[joo[jn_oinOWon_[j0ooi
nOT02Oojn_[onOWioo[jn_oinOWom_KfooOgmooinOWon_[jooWin@02oo[jnP03ooWinOojn_[onOWi
00;onOWi00Gon_[jooWinOojn_[onOWioo[jnP02ooWin@06oo[jn_oinOWon_[joo[jn_oinOWon_[j
0ooinOT01Oojn_[onOWioo[jn_oinOWon_[j00;onOWi00Kon_[jooWinOojn_[on_[jooWinOojn_X3
ooWin@05oo[jn_oinOWon_[jooWinOojn_X00_oinOT01_ojn_[onOWioo[jn_ojn_[onOWioo[jnP?o
nOWi00Gon_[jooWinOojn_[onOWioo[jnP02ooWin@06oo[jn_oinOWon_[joo[jn_oinOWon_[j0ooi
nOT01Oojn_[onOWioo[jn_oinOWon_[j00;onOWi00Kon_[jooWinOojn_[on_[jooWinOojn_X2ooWi
n@Son_[j01;ono_koo[jn_okno_on_[jojBTY?n`/;3o^k^kolC4a?o>c/koe]KFomgMgOoUiNGoj^[Z
oo3`l?oclo?omoOgoo_knoomoOdCooooo`00@Oo^k^h03oo/k>cojn_[onOWiooTi>Coh>3Pom[Jf_oE
eMGoc/k>olO7aoo1`L7o^;Rhojn_[onTY:CoVIVIoogmo@02ooknoP03oogmoOono_kooOgm00Goo_kn
00GooOgmookno_ono_kooOgmooknoP02oogmo@04ookno_omoOgooOgmoogmo@;oo_kn00?ooOgmookn
o_omoOd00_omoOd00oono_kooOgmooknoP02oogmo@04ookno_omoOgooOgmoogmo@;oo_kn00?ooOgm
ookno_omoOd00_omoOd00oono_kooOgmooknoP02oogmo@04ookno_omoOgooOgmoogmo@;oo_kn00?o
oOgmookno_omoOd00_omoOd00oono_kooOgmooknoP02oogmo@04ookno_omoOgooOgmoogmo@;oo_kn
00?ooOgmookno_omoOd00_omoOd00oono_kooOgmooknoP02oogmo@04ookno_omoOgooOgmoogmo@;o
o_kn00?ooOgmookno_omoOd00_omoOd00oono_kooOgmooknoP02oogmo@04ookno_omoOgooOgmoogm
o@;oo_kn00?ooOgmookno_omoOd00_omoOd00oono_kooOgmooknoP02oogmo@04ookno_omoOgooOgm
oogmo@;oo_kn00?ooOgmookno_omoOd00_omoOd00oono_kooOgmooknoP02oogmo@04ookno_omoOgo
oOgmoogmo@;oo_kn00CooOgmookno_ono_kooOgm1?ono_h05?omoOgoo_knookno_omoOgoo_knoogm
oOnJVY[oYJFUojn_[onh^;So`<30olO7aoo>c/koe]KFom_KfooPh>3ohn?SonOWioo[jn_ok>c/4oo^
k^h0047oi^KV013oi>CTon;Rh_oOgmoofm_KomSHf?oCdm?oc/k>olO7aoo0`<3o^[Zjok6a/OnYZJWo
WinOoiFEUOoinOWon?Sh1?oinOT00oohn?SonOWiooShn003ooWinGkon?Sh0_oinOT2ooShn0?onOWi
00?on?ShooWinOoinOT00_oinOT03_nDU9CoWinOojRXZ?na/K7o^[Zjol71`Oo7alOoc/k>om?CdooH
f=Sog=cLomoOgooRh^;oi>CT0_oVi^H00ooUiNGoi^KVonKViP0>onKViP00@Oo^k^h03_o]kNgoj^[Z
onOWiooShn?oh>3Pom_KfooEeMGoclo?olO7aoo1`L7o^;Rhojn_[onTY:CoVYZJ1Oo[jn/00oo/k>co
jn_[on_[j`04on_[j`03on[Zj_o[jn_ojn_[00Coj^[Z00Cojn_[on[Zj_o[jn_oj^[Z0_o[jn/2on[Z
jP04on_[jooZj^[oj^[Zon_[j`Coj^[Z00Cojn_[on[Zj_o[jn_oj^[Z0_o[jn/2on[ZjP04on_[jooZ
j^[oj^[Zon_[j`Coj^[Z00Cojn_[on[Zj_o[jn_oj^[Z0_o[jn/2on[ZjP0<on_[jooZj^[oj^[Zon_[
jooZj^[od=3@ogYjN_oTi>Cojn_[on[Zj_o[jn_oj^[Z0_o[jn/2on[ZjP04on_[jooZj^[oj^[Zon_[
j`Coj^[Z00Cojn_[on[Zj_o[jn_oj^[Z0_o[jn/2on[ZjP04on_[jooZj^[oj^[Zon_[j`Coj^[Z00Co
jn_[on[Zj_o[jn_oj^[Z0_o[jn/2on[ZjP04on_[jooZj^[oj^[Zon_[j`Coj^[Z00Cojn_[on[Zj_o[
jn_oj^[Z0_o[jn/2on[ZjP04on_[jooZj^[oj^[Zon_[j`Coj^[Z00Cojn_[on[Zj_o[jn_oj^[Z0oo[
jn/01OoZj^[ok>c/on_[joo[jn_ok>c/00Kojn_[013ok>c/oiVIVOnTY:Co[jn_okRh^?o0`<3ob<S8
olk>c_oEeMGofm_Kon3Ph?oShn?oinOWon[Zj_o/k>cokNg]4_o^k^h0047ooooo013ooOgmoo_knoog
moOom?Cdoo3`l?oZj^[oiNGUomgMgOoFe]Koc/k>olC4a?nk^k_o/;2`ojFUYOojn_[ono_k2oojn_X2
ooWin@07oo[jn_oinOWon_[joo[jn_oinOWon_[jooWin@02oo[jnP05ooWinOojn_[onOWiooWinOoj
n_X00_oinOT01oojn_[onOWioo[jn_ojn_[onOWioo[jn_oinOT00_ojn_X01OoinOWon_[jooWinOoi
nOWon_[j00;onOWi00Oon_[jooWinOojn_[on_[jooWinOojn_[onOWi00;on_[j00GonOWioo[jn_oi
nOWonOWioo[jnP02ooWin@07oo[jn_oemOGo:BTYojJVY_oinOWon_[jooWin@02oo[jnP05ooWinOoj
n_[onOWiooWinOojn_X00_oinOT01oojn_[onOWioo[jn_ojn_[onOWioo[jn_oinOT00_ojn_X01Ooi
nOWon_[jooWinOoinOWon_[j00;onOWi00Oon_[jooWinOojn_[on_[jooWinOojn_[onOWi00;on_[j
00GonOWioo[jn_oinOWonOWioo[jnP02ooWin@07oo[jn_oinOWon_[joo[jn_oinOWon_[jooWin@02
oo[jnP05ooWinOojn_[onOWiooWinOojn_X00_oinOT01oojn_[onOWioo[jn_ojn_[onOWioo[jn_oi
nOT00_ojn_X00ooinOWon_[joo[jnP06oo[jnP03oo_knoojn_[on_[j00;on_[j00koYJFUok2`/?nk
^k_oaLG5olk>c_oEeMGogMgMonCTi?oZj^[ol?3`oo?cloohn?Sono_koogmoA?ooooo0011onk^kP0>
onc/k?o[jn_oinOWon?ShooPh>3ofm_KomGEeOo?clooalO7ol30`?nh^;So[Zj^ojBTY?nIVIT6ookn
oP;ooOgm1_ono_h01_omoOgoo_knoogmoOomoOgoo_knoogmo@;oo_kn0_omoOd01?ono_kooOgmoo?c
looWinL2ooknoP06oogmoOo`l?3on?Shooclo?oUiNGoo?cl0_ono_h2oogmo@08ookno_omoOgoo_kn
oogmoOono_kono_konk^k_ono_h2oogmo@06ookno_omoOgoo_knonc/k?okno_ooOgm0_oclo<02_on
o_kooOgmookno_ono_kooOgmookno_omoOgoT92@odQ8B?omoOd2ooknoP;ooOgm00Coo_knoogmoOon
o_kooOgm0_ono_h01_omoOgoo_knoogmoOomoOgoo_knoogmo@;oo_kn0_omoOd01?ono_kooOgmookn
o_omoOd2ooknoP06oogmoOono_kooOgmoogmoOono_kooOgm0_ono_h2oogmo@04ookno_omoOgoo_kn
oogmo@;oo_kn00KooOgmookno_omoOgooOgmookno_omoOd2ooknoP;ooOgm00Coo_knoogmoOono_ko
oOgm0_ono_h01_omoOgoo_knoogmoOomoOgoo_knoogmo@;oo_kn0_omoOd00oono_kooOgmooknoP03
ooknoP03oogmoOono_koo_kn00Goo_kn00koVIVIojBTY?n_[joo]kNgol71`Oo7alOoc/k>omKFe_oJ
f][oh>3Pon?ShooWinOojn_[onc/k0?ok^k^00?okNg]onk^k_o^k^h03Oo^k^h0047oi^KV013oi>CT
on;Rh_oOgmoofm_KomWIfOoCdm?oc/k>olO7aoo1`L7o^[Zjok6a/OnXZ:SoWinOoiBDU?oinOWon?Sh
0_oinOT00oohn?SonOWiooWin@02ooWin@03ooShn?oinOWonOWi00Gon?Sh00?o?CdmogMgMoohn?P0
1?ohn?P03OoQhN7oD51@o`l?3ol];Bgo8B4Qokno_oohn?SoAdM7oemOGol_;boo9BDUoalO7onj^[X0
0_ohn?P00om8B4SoPH61ooShn002ooShn006okbl_?lU9BGo4Q8BoeQHF?n8R8So>CTi0_ohn?P02OmG
EeOo4a<Cob@T9?nLW9co7AdMoeaLG?ohn?SoAdM7oh61P@04ooShn003oi>CTol=3@god];B04Kon?Sh
0_oinOT00oohn?SonOWiooWin@02ooWin@0DooShn?oinOWonOWiooShn?oinOWoUIFEoinOWonYZJWo
/K6aokZj^_o1`L7oalO7olk>c_oCdm?of=SHomcLg?oOgmooh^;RonCTi?oUiNDBonKViP00@Oo^k^h0
3_o]kNgojn_[onKVi_oShn?oh>3Pom_KfooEeMGoclo?olO7aoo0`<3o^;Rhojn_[onTY:CoVIVI0_o[
jn/01?o/k>cojn_[on_[joo/k>`5on_[j`03on[Zj_o[jn_oj^[Z00;ojn_[00Koj^[Zoc/k>omaLG7o
jn_[on[Zj_o[jn/2on[ZjP04odQ8B?m4A4Coc/k>on[ZjP;ogmoO023ojn_[odA4A?m6ATKog=cLonOW
iomjNW[o7AdMon3Ph?oZj^[o@d=3ogalO?oZj^[ojn_[on[Zj_mFEUKoFUYJon?ShonFUYKo6ATIocLg
=oo[jn_o^KVioa0@4?o=cLgoe=CDoe]KFolL71coj^[Zon_[jom3@d?oO7alon[ZjP;ojn_[00Koj^[Z
ocHf=_lE5AGoKfm_on[Zj_o[jn/2on[ZjP06on_[jooZj^[ojn_[on[Zj_o[jn_oj^[Z0_o[jn/2on[Z
jP;ojn_[00[oj^[Zon_[jooZj^[oj^[Zon_[jooZj^[ojn_[on[Zj_o[jn_oj^[Z0_o[jn/2on[ZjP;o
jn_[00[oj^[Zon_[jooZj^[oj^[Zon_[jooZj^[ojn_[on[Zj_o[jn_oj^[Z0_o[jn/2on[ZjP;ojn_[
00[oj^[Zon_[jooZj^[oj^[Zon_[jooZj^[ojn_[on[Zj_o[jn_oj^[Z0_o[jn/2on[ZjP;ojn_[00Co
j^[Zon_[jooZj^[oj^[Z1_o[jn/01Oo/k>cojn_[on_[joo[jn_ok>c/00;ojn_[00ook>c/oiZJV_nT
Y:Co[jn_okNg]oo0`<3oalO7olk>c_oEeMGofm_Kon3Ph?oShn?oinOWon_[joo/k>`00oo^k^h00oo]
kNgok^k^onk^kP0=onk^kP00@Oooool04?omoOgono_kooOgmoodm?Col?3`on[Zj_oTi>CogMgMomKF
e_o>c/koaLG5ok^k^on`/;3oYJFUoo[jn_okno/3oo[jnP03oo_knoojn_[on_[j00Con_[j00OonOWi
oo[jn_oinOWon_[jooWinOlo?cooN7Qh00;onOWi0_ojn_X01?oIfMWo3Ph>okNg]oojn_X2ooWin@0X
oo[jn_oinOWoBDU9oh>3Poojn_[onOWion?Shol>3Pko[Zj^oo[jn_m8B4SoPh>3ooWinOojn_[onOWi
ocHf=_nCTi?onOWioo[jn_mnOWko>c/kooWinOoFe]Ko410@okfm_Oojn_[oX:2Pob/[:ooinOWon_[j
odQ8B?n3Ph?on_[jooWinOojn_[ob/[:o`l?3onPX:3o7alOoo;blP;on_[j00ConOWioo[jn_oinOWo
n_[j0_oinOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi0_ojn_X01?oinOWon_[jooWinOojn_X2
ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT2oo[jnP04ooWinOojn_[onOWioo[jnP;onOWi
00Gon_[jooWinOojn_[onOWioo[jnP03ooWin@;on_[j00ConOWioo[jn_oinOWon_[j0_oinOT01Ooj
n_[onOWioo[jn_oinOWon_[j00?onOWi0_ojn_X00ooinOWon_[joo[jnP07oo[jnP0Coo_knoojn_[o
n_[joo[jn_okno_oYJFUok2`/?nk^k_oa<C4olk>c_oEeMGogMgMonGUiOoZj^[ol?3`oo?cloohn?So
no_koogmo@0Cooooo`00@Oo^k^h03oo/k>cojn_[onKVi_oShn?oh>3Pom[Jf_oFe]Koc/k>olO7aoo1
`L7o]kNgojn_[onTY:CoVYZJoogmo@02ooknoP08oogmoOono_koo_knoogmoOono_kooOgmookno_om
oOd2ooknoP;ooOgm00Koo_knoogmoOm0@43oNWYjoogmoOono_h2oogmo@04ol30`?l=3@goAdM7odQ8
B0;oBDU900Coa/K6oogmoOm:BT[oQ8B40oomoOd01_lR8R;oUYJFoogmoOm:BT[oQ8B4ooknoP;ooOgm
00Ko=cLgoiRHV?omoOgoo_knoi>CTolj>SX2oogmo@09ok2`/?ll?3co?Cdmod10@?l[:b_oo_knoogm
oOm:BT[oQHF500;ooOgm00Koo_knog1`L?m:BT[ooOgmoc8b<_nXZ:P2oogmo@03ookno_omoOgoo_kn
00;ooOgm00Coo_knoogmoOomoOgoo_kn1?omoOd01_ono_kooOgmoogmoOono_kooOgmooknoP;ooOgm
00Coo_knoogmoOomoOgoo_kn1?omoOd01_ono_kooOgmoogmoOono_kooOgmooknoP;ooOgm00Coo_kn
oogmoOomoOgoo_kn1?omoOd01_ono_kooOgmoogmoOono_kooOgmooknoP;ooOgm00Coo_knoogmoOom
oOgoo_kn1?omoOd01oono_kooOgmoogmoOono_kooOgmookno_omoOd01Oono_h01?omoOgoo_knookn
o_omoOd2ooknoP0>oiVIVOnTY:Co[Zj^okRh^?o0`<3oalO7olo?cooEeMGof][Jon3Ph?oShn?oinOW
on_[joo/k>`2onk^kP03ong]kOo^k^kok^k^00kok^k^0011onKViP0>onCTi?oRh^;oh>3PomcLg?oH
f=Soe=CDolk>c_o7alOo`L71okZj^_na/K7oZJVYoinOWonDU9@8ooWin@03ooShn?oinOWonOWi00Ko
n?Sh013o?ShnobPX:?m;Bd_oBd];ofQXJ?ohn?Soe]KFo``<3?nZZZ[obl_;olC4a?l>3Pkoh>3PooSh
n?m7AdOoOGem0_ohn?P01_oXj>So3@d=ol30`?ohn?SoAdM7ofa/K0?on?Sh00Ko=CDeoiBDU?ohn?So
n?Shoi6ATOli>CT4ooShn003ooOgmonEUIGo:RXZ00;on?Sh00[oAdM7ofa/K?ohn?Son?Shoo3`l?lJ
6Q[oXZ:RooShn?nBTY;oADE5AOohn?P01OoinOWon?ShooShn?oinOWon?Sh00OonOWi00koUIFEoinO
WonXZ:So/K6aokZj^_o0`<3oalO7olk>c_oCdm?of=SHomcLg?oOgmooh^;RonGUiA?oi^KV0011onk^
kP0>onc/k?o[jn_oinOWon?ShooPh>3of][JomGEeOo>c/koalO7ol30`?nh^;So[Zj^ojBTY?nIVIT>
on_[j`0Ton[Zj_o[jn_oj^[Zoc/k>omHF5So/k>cok:b/_nl_;coj^[Zon_[jom4A4CoJFUYon?ShonE
UIGo<S8bon_[jooZj^[oA4A4ob@T9?n@T93obl_;ofMWIolK6a_oj>SXon[Zj_m4A4Co7AdMohZ:R_oC
dm?oj>SXoc<c<on=SHgoj^[Zon_[jon8R8So=SHf0_oZj^X04onXZ:SobLW9onOWiomQHF7oEUIFon[Z
j_o[jn_o@d=3oadM7On;Rh_odm?CoiVIVOlH61Soh>3Pon[Zj_oKfm_o51@DolO7aooZj^X00_o[jn/0
0ooZj^[ojn_[on[ZjP02on_[j`03on[Zj_o[jn_oj^[Z00Koj^[Z0_o[jn/00ooZj^[ojn_[on[ZjP02
on_[j`03on[Zj_o[jn_oj^[Z00Koj^[Z0_o[jn/00ooZj^[ojn_[on[ZjP02on_[j`03on[Zj_o[jn_o
j^[Z00Koj^[Z0_o[jn/00ooZj^[ojn_[on[ZjP02on_[j`03on[Zj_o[jn_oj^[Z00Koj^[Z0_o[jn/0
0ooZj^[ojn_[on_[j`0:on_[j`0?oiZJV_nTY:Co[jn_okNg]oo1`L7oalO7olk>c_oFe]Kof][Jon3P
h?oShn?oi^KVon[Zj_o/k>cokNg]01;ok^k^0011ooooo`0?oogmoOokno_omoOgooCdm?o`l?3oj^[Z
onGUiOoMgMgoe]KFolk>c_o5aLGo^k^kok6a/OnVYZKon_[j00;ono_k0_ojn_X2oo_kn`Kon_[j00Oo
nOWioo[jn_oinOWonOWiod10@?miNGWonOWi00?on_[j00konOWion;Rh_m?Cdoo6ATIobPX:?ng]kOo
nOWioo[jn_m8B4SoP820ofa/K?lJ6Q[o9BDUojVYZ@;on_[j01;oFe]Kohf=SOmSHf?o5ADEonc/k?m;
Bd_oWinOoo[jn_oinOWoW9bLodm?Coojn_[onOWiohf=SOlm?Cgo7AdMod92@_o3`l<2ooWin@06oeaL
G?n<S8coHf=SoaHF5_mKFe_oMWIf0_ojn_X01_oinOWoLG5aohV9ROojn_[onOWioo[jnP;onOWi00Co
n_[jooWinOoinOWon_[j0_oinOT2oo[jnP06ooWinOojn_[on_[joo[jn_oinOWon_[j0_oinOT01?oj
n_[onOWiooWinOojn_X2ooWin@;on_[j00KonOWioo[jn_ojn_[on_[jooWinOojn_X2ooWin@04oo[j
n_oinOWonOWioo[jnP;onOWi0_ojn_X01_oinOWon_[joo[jn_ojn_[onOWioo[jnP;onOWi00Con_[j
ooWinOoinOWon_[j0_oinOT2oo[jnP09ooWinOojn_[on_[joo[jn_oinOWon_[jooWinOojn_[ono_k
00Gon_[j0_okno/2oo[jnP0?oo_knonVYZKo/K6aok^k^oo4a<Coc/k>omKFe_oMgMgoi>CTon[Zj_o_
knoolo?cooShn?okno_ooOgm01?ooooo0011onk^kP0>onc/k?oZj^[oinOWonCTi?oPh>3ofm_KomGE
eOo?cloob<S8ol30`?ni^KWo[jn_ojJVY_nLW9`5ooknoP;ooOgm1Oono_h00oomoOgoo_knooknoP02
oogmo@03od10@?mjNW[oo_kn00CooOgm00?oo_knoogmoOokno/00oomoOd01_ono_koBDU9ohF5QOom
oOgono_kooknoPCooOgm00?oo_knoogmoOokno/00oomoOd00oono_kooOgmoogmo@02oogmo@08ookn
o_omoOgooOgmoo_knoomoOgoo_knoogmoOono_h3oogmo@03oo_knoomoOgooOgm00;ooOgm00?oo_kn
oogmoOomoOd00_omoOd00oono_kooOgmooknoP03oogmo@03ookno_omoOgooOgm00;ooOgm00?oo_kn
oogmoOomoOd00_omoOd00oono_kooOgmooknoP03oogmo@03ookno_omoOgooOgm00;ooOgm00?oo_kn
oogmoOomoOd00_omoOd00oono_kooOgmooknoP03oogmo@03ookno_omoOgooOgm00;ooOgm00?oo_kn
oogmoOomoOd00_omoOd00oono_kooOgmooknoP03oogmo@03ookno_omoOgooOgm00;ooOgm00Coo_kn
oogmoOomoOgooOgm0_ono_h01?omoOgoo_knookno_omoOd8ooknoP0@oogmoOnKVi_oYZJVojn_[onh
^;So`L71olS8b?o?clooeMGEom_KfooPh>3ohn?SonOWiooZj^[ok>c/onk^kP;okNg]4?o^k^h0047o
i^KV00ooi>CTon?ShooOgmoofm_KomSHf?oCdm?oclo?olS8b?o2`/;o^[Zjok>c/onYZJWoX:2PoiNG
UooinOT00_ohn?P4ooWin@03ooShn?oinOWon?Sh00?onOWi0_ohn?P02?oinOWon?Shochn?_lg=cOo
JVYZof][JomZJV[o]kNg1Oohn?P01OoinOWon?ShooShn?m8B4SoPX:200?on?Sh00?onOWiooShn?oh
n?P01Oohn?P01?oinOWon?ShooShn?oinOT4ooShn003ooWinOohn?Son?Sh00Gon?Sh00ConOWiooSh
n?ohn?SonOWi1?ohn?P00ooinOWon?ShooShn005ooShn004ooWinOohn?Son?ShooWin@Con?Sh00?o
nOWiooShn?ohn?P01Oohn?P01?oinOWon?ShooShn?oinOT4ooShn003ooWinOohn?Son?Sh00Gon?Sh
00ConOWiooShn?ohn?SonOWi1?ohn?P00ooinOWon?ShooShn005ooShn004ooWinOohn?Son?ShooWi
n@Con?Sh00?onOWiooShn?ohn?P00oohn?P4ooWin@03ooShn?oinOWonOWi00;on?Sh0ooinOT03_nG
UiOoX:2PojVYZOnc/k?o^k^kol;2`_o9bLWoc/k>om?CdooIfMWog=cLomoOgooRh^;oi>CT4ooVi^H0
047ok^k^01Ook>c/on[Zj_oWinOoiNGUon3Ph?oLg=coe]KFom3@d?o9bLWo`/;2okVi^Ona/K7oZ:RX
oiNGUooZj^[oj>SXonKViooUiNKohnCUon?Ui_oSi>GohnGVon?TiP02on?UiP07on?TiOoSiNKohnCV
on?Ti_oSi>GohnCVoinPX@03ohZ<S@04oh^<SOnj^kcohnCUon?Ti@;ohnCV00Ooh^CUon?Ui_oSi>Go
hnCUoc`m?_mdMGOohnGV00;ohnCU00?oh^CUon?Ti_oSi>D00_oSi>D2on?TiP03on;TiOoSiNKohnCU
00;ohnCU00KohnCVon?Ui_oSi>GohnCUon;TiOoSi>H3on?Ti@;ohnCV00?oh^CUon?Ui_oSi>D00_oS
i>D01_oSi>KohnGVon?TiOoSi>Goh^CUon?TiP?ohnCU0_oSi>H00ooRi>GohnGVon?Ti@02on?Ti@06
on?Ti_oSiNKohnCUon?TiOoRi>GohnCV0ooSi>D2on?TiP03on;TiOoSiNKohnCU00;ohnCU00KohnCV
on?Ui_oSi>GohnCUon;TiOoSi>H3on?Ti@;ohnCV00?oh^CUon?Ui_oSi>D00_oSi>D01_oSi>KohnGV
on?TiOoSi>Goh^CUon?TiP?ohnCU0_oSi>H00ooRi>GohnGVon?Ti@02on?Ti@07on?Ti_oSiNKohnCU
on?TiOoRi>GohnCVon?Ti@02on?TiP;ohnGV00GohnCUon?Ui_oSi>KohnGVon?Ti@02on?UiP;ohnCV
01WohnCUon?Ui_m1DF3oAUQWodULK?m=HG;oDFEgoe=XNomGKH3oFG23oe]cQomMM8WoGgN<of1iS_mQ
NY3oHW^Aof=lT_mVOY;oJ7j@og63T_moS9SoTibTok2d]oo@d=7oi^KV00[ok^k^0011ooooo`0Aoogm
oOokno_on?ShooCdm?o`l?3ojn_[onKVi_oOgmoof=SHom7AdOo8b<So_knookFe]OnEUYKom_Kfoo?d
mOoblo@00_o`lO82oo3`l@;oko3a00Koko3`oo3`lOo`l?7ol?3aono`lOo_l?02ono`l@04oo3`lOo`
lO7oko3`oo3al@Coko3a00coko3`oo3`lOo`l?7ol?3aono`lOo_l?3ok>c]ong^koo`l?7ol?7aono`
l?o`lO44ono`l@06ono`l?o`l?7ol?3aoo3`lOo_l?7oko3`0_o_l?401?o`l?7ol?7aono`l?o`lO44
ono`l@06ono`l?o`l?7ol?3aoo3`lOo_l?7oko3`0_o_l?401?o`l?7ol?7aono`l?o`lO44ono`l@06
ono`l?o`l?7ol?3aoo3`lOo_l?7oko3`0_o_l?401?o`l?7ol?7aono`l?o`lO44ono`l@06ono`l?o`
l?7ol?3aoo3`lOo_l?7oko3`0_o_l?401?o`l?7ol?7aono`l?o`lO44ono`l@06ono`l?o`l?7ol?3a
oo3`lOo_l?7oko3`0_o_l?401?o`l?7ol?7aono`l?o`lO44ono`l@06ono`l?o`l?7ol?3aoo3`lOo_
l?7oko3`0_o_l?401?o`l?7ol?7aono`l?o`lO44ono`l@06ono`l?o`l?7ol?3aoo3`lOo_l?7oko3`
0_o_l?404Oo`l?7ol?7aono`l?o`lO7oko3aoc@k@Olh?dGo>d58oci5C?m0B4oo@d]BodE=E?m7CeOo
B51IodYCFom<E5goCEIN00;oCUMP00WoCeQQodiHHOm=FFCoCEeZoeMZN_m/OXooS9VSokJk_ooOh>40
2_ooool0047ok^k^01?ok>c/on_[jooXj>SoiNGUon7QhOoLg=coemOGom7AdOo;bl_oa<C4okbl_?nd
];CoZj^[ogMjO?ogn?Wom_OhooOhn?oinO[ooOgm097ooooo01OoIHnGohRa^?n>^L7oUL;:oi_9d_nO
cmWoYMOPoj[Nion^hnco/^SaokC[m?ngkoSo^_;lok[coOnkm?oo]o3oojoZoonCbN3oJ8n^oeE]QOm[
Nh[oR9FPok6e^00:onk^kP00@OoVi^H04OoTi>Coh^;Ron3Ph?oMgMgofMWIomGEeOoAdM7obl_;olC4
a?nn_[ko]kNgojn_[onWYjOoIfeboo;cm?oal_?om_Kg00Oon_[j0_okno/4oo[jnP03oo_knoojn_[o
n_[j00Oon_[j0_okno/4oo[jnP03oo_knoojn_[on_[j00Oon_[j0_okno/4oo[jnP03oo_knoojn_[o
n_[j00Oon_[j0_okno/4oo[jnP03oo_knoojn_[on_[j00Oon_[j0_okno/4oo[jnP03oo_knoojn_[o
n_[j00Oon_[j0_okno/4oo[jnP03oo_knoojn_[on_[j00Oon_[j0_okno/4oo[jnP03oo_knoojn_[o
n_[j00Oon_[j0_okno/4oo[jnP03oo_knoojn_[on_[j00Oon_[j0_okno/4oo[jnP03oo_knoojn_[o
n_[j00?on_[j01OoJYFHohRa^On>^<;oUL?;oik>donQd][oY]WQoj_Oion_i>co/^SaokK]m_nhkoSo
^_;kokkgoOnonOoo^oCook?_oonZioooUMSoofJJdOmBJhKoLHFHoiJOYP0:onKViP00@Oo^k^h04Oo]
kNgoj^[ZonSXj?oUiNGohN7QomgMgOoIfMWoe=CDolc<c?o7alOo_knookRh^?n^[ZkoI6edooKhnOoi
nOWoo_kn02oooooo00?ooOgmooShn?ono_h00oooool00ooShn?oQXJ6ooShn01Kooooo`0GofF?Von8
/;coT;[5oiG2cOnJbMCoWlkLojGFh_nYfnSo[N3^ojoSl_nai_Ko/NShok?ZnongkOgo]nkookC/oon^
jOooZ>KooiGFoomi_OooBGFTofV2U_n?VjH02_o^k^h0047ooooo013ooOgmoo_knooinOWom_Kfoo;b
l_o^k^koj>SXon?ShooMgMgoe]KFolo?coo7alOo_[jnofUcNooal_ComoOg2?ojn_X02Oo`l?3omOGe
oo[jn_ojn_[og=cLocPh>?mFEUKoZZZZooKfmP0>oo[jnP03oo_knoojn_[on_[j00gon_[j00Cono_k
oo[jn_o/k>comOGe0oojn_X00oofm_Ko:BTYojJVYP06oo[jnP03oo_knoojn_[on_[j00gon_[j00?o
no_koo[jn_ojn_X03Oojn_X00ookno_on_[joo[jnP0=oo[jnP03oo_knoojn_[on_[j00gon_[j00?o
no_koo[jn_ojn_X03Oojn_X00ookno_on_[joo[jnP02oo[jnP0GofNAWon6[[koS;K6oi>oconHaMKo
WLcMoj;Bi?nTe^SoZM_^ojcOl_n^h_Go/NKjok;Wnonaiogo]N_ook7Yoon[iOooXn3ooi3@oomg^_oo
AhO;ofR1UonCXJd02_ooool0047ok^k^017ok>c/on_[jooYjNWoi^KVon?ShooOgmoofm_KomKFe_o@
d=3obLW9olC4a?nl_;co];BdofA^MooSi>Koj^[Zon_[j`07onc/k00:onOWiooNg]koinOWonc/k?oL
g=coZ:RXoj:RX_lW9bOoX:2Pon_[j`;ok>c/00?ofm_Kon[Zj_o/k>`00_oRh^85onc/k003on_[joo/
k>cok>c/00;ok>c/00?ojNWYomkNg_oZj^X00oo/k>`02_o[jn_ok>c/omcLg?oZj^[ok>c/on;Rh_oQ
hN7ok>c/onGUiOoQhN44onc/k003ohN7Qom5ADGok>c/05[ok>c/01OoHhfQohF]`?n<]L[oTKcBoiG2
fOnJb=ooWLcUoj?Cj_nTeNooYmWcojWLmon[goWo[n;kojgQoOn^iOoo[^?oojOQoonKeoooSLgoogBh
oom4SMcoI7bBoh^IY@0:onk^kP009OoVi^H00ooTi>Coh>3Pon;RhP0IonKViP0@onCTi?oShn?ohN7Q
omkNg_oLg=cof=SHomCDe?o@d=3obl_;olG5aOno_koo^;Rhok:b/_mTKgSolO?dooShn0;onOWi0_oj
n_X00oo3`l?oDU9Bonk^kP02oo[jnP0[oo7alOo`l?3on_[joo[jn_o`l?3ok>c/of9RH_mIFEWok>c/
oo3`l?mIFEWo2PX:oalO7onMWIgo7alOoeYJF_o]kNgoBDU9ohB4Poofm_Kok>c/oiJFU_lN7Qkolo?c
onk^k_nn_[ko9bLWo`X:2_m<C4coO7alocDe=Oo]kNgol?3`oeUIFOl:2P[o7alOoifMWOlP823oGUiN
oo[jn_m3@d?oM7AdooShm`03oo[jnP03oiFEUOl?3`ooe=CD05[on_[j01OoGhVTohB]aOn8//coSKWC
oiC1fonFaN7oVl_Voig>jonRe?3oY=OcojKJmonXg?WoZ=glojKMoOnWgOooY]_ooikEoonHe?ooR<Oo
off_n?m2R]_oHW^AohRFXP0:onKViP009?o^k^h01OoZj^[ofm_Kokfm_OoGemOokNg]01Sok^k^013o
kNg]onc/k?oYjNWoinOWonCTi?oQhN7og=cLomSHf?oCdm?oc/k>olS8b?o2`/;o^k^kofUcO?oemoSo
o?cl0oono_h06Oo6a/Ko6QXJo`h>3_m7AdOolo?cooooooogmoOol_;bookno_olo?col?3`ooclo?n?
Shoo9BDUoo7alOo9bLWo4a<Com?CdooOgmooI6AToahN7_oinOWolO7aod];Bon6QXH00_oemOD05_nW
YjOo8b<Soo7alOoclo?oGUiNoemOGooYjNWoXJ6Qoa/K6olb<S;olO7aolW9bOlB4Q;odm?Con3Ph?mT
I6Co7QhNookno_oooooo?cloogQhN?ogmoL2ooknoP06oooooolk>c_o5aLGogQhN?ooooooo_kn0_oo
ool2ooknoPCooooo0_ono_h01_ooooooo_knooooooono_koooooooknoP;ooooo0_ono_h4ooooo`;o
o_kn00Koooooookno_ooooooo_knooooooono_h2ooooo`;oo_kn1?ooool2ooknoP06ooooooono_ko
ooooookno_ooooooo_kn0_ooool2ooknoPCooooo0_ono_h01_ooooooo_knooooooono_koooooookn
oP;ooooo0_ono_h4ooooo`;oo_kn00Koooooookno_ooooooo_knooooooono_h2ooooo`;oo_kn1?oo
ool05omORJWoPjc8ohJ`d?n;]mKoSkgMoi70h_nEaNSoV<W/ohZhf?lK92_oSKcMoj7En_nSeocoXmOm
ojCIoonPe_ooVm?ooi39oon3`OooJJ[aocj6e_mSO9;oRiVU00[ok^k^000Pooooo`?oo_kn00KomoOg
omgMgOnRXZ;oU9BDol?3`oono_hHooooo`0?ookno_olo?con_[jooShn?oemOGol_;bonk^k_oZj^[o
iNGUomoOgooIfMWodm?Colg=cOmbO8KolO;d00;on?Sh03?onOWiol?3`olI6AWo@410ok6a/OlH61So
ADE5ono_kooclo?okNg]oo[jn_ogmoOojn_[ooKfm_n>SXko9BDUong]kOoFe]Ko410@ok:b/_obl_;o
X:2Pob/[:ooemOGok>c/odQ8B?n3Ph?okNg]oo?clonTY:Co:2PXoo;bl_o^k^ko=SHfoi6ATOo[jn_o
m_KfoginO_le=CGokNg]omKFe_l@413o/[:boo;bl_nPX:3o:b/[oo[jn_ofm_Ko>SXjogemOOo]kNd0
0_oinOT02_o;bl_o3Ph>oj2PX?lO7aoolo?coo[jn_oinOWon_[jooWinOojn_X3ooWin@;on_[j00Co
nOWioo[jn_oinOWon_[j0_oinOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi0_ojn_X01?oinOWo
n_[jooWinOojn_X2ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT2oo[jnP04ooWinOojn_[o
nOWioo[jnP;onOWi00Gon_[jooWinOojn_[onOWioo[jnP03ooWin@;on_[j00ConOWioo[jn_oinOWo
n_[j0_oinOT01Oojn_[onOWioo[jn_oinOWon_[j00?onOWi0_ojn_X01?oinOWon_[jooWinOojn_X2
ooWin@05oo[jn_oinOWon_[jooWinOojn_X00ooinOT03oojn_[oHXb]oh2[c?n5/]CoR;KIohbkgon?
`>GoT/?YoiG8k_lmDf?o0000ocmEI_nMd__oW]?loioEoP02oj3Fo`07oi_Coon@bOooPl7oofVZlOln
Q]KoIWnEoi>Q[@0:ooooo`006oo^k^h03_o]kNgojn_[onSXj?oUiNGohN7QomoOgooNg]kof][JokZj
^_n8R8So`<30olS8b?n_[jookNg]6?o^k^h0C_o]kNgok>c/on[Zj_oXj>SoiNGUon;Rh_oOgmoofm_K
omOGeooCdm?oc/k>olW9bOo2`/;oKWV3on;TiOoYjNWojn_[okNg]olI6AWo?CdmomkNg_o/k>co/k>c
oaPH6?m2@T;ofMWIomoOgoo/k>cojn_[onOWiooOgmooNWYjoadM7OoNg]kok>c/ojBTY?l^;Rko=3@d
oc`l??lZ:R[oi^KVomoOgom5ADGoOGemomoOgooVi^KoVi^KobHV9_oUiNGogmoOoc@d=?n=SHgoi^KV
on3Ph?mnOWko;Bd]omkNg_o[jn_oY:BTobl_;olc<c?o?CdmobTY:Oo[jn_ohn?SocXj>_mmOGgogmoO
onKVi_o/k>coJ6QXodI6A_o[jn_o<30`oifMWOo/k>cojn_[onc/k0;ojn_[00?ok>c/on_[joo/k>`0
0_o[jn/00oo/k>cojn_[onc/k002on_[j`;ok>c/00Oojn_[onc/k?o[jn_ojn_[onc/k?o[jn_ok>c/
00;ojn_[00?ok>c/on_[joo/k>`00_o[jn/2onc/k007on_[joo/k>cojn_[on_[joo/k>cojn_[onc/
k002on_[j`03onc/k?o[jn_ok>c/00;ojn_[0_o/k>`01oo[jn_ok>c/on_[joo[jn_ok>c/on_[joo/
k>`00_o[jn/00oo/k>cojn_[onc/k002on_[j`;ok>c/00Oojn_[onc/k?o[jn_ojn_[onc/k?o[jn_o
k>c/00;ojn_[00?ok>c/on_[joo/k>`00_o[jn/2onc/k00Oon_[joo/k>cojn_[on_[joo/k>cojn_[
onc/k?o[jn_oGXZ`oh:]dOn4/MOoRKONoh^jhOn?_nKoT/?/ogNO`OlI8b_o0000oaXS:ommYl_oW=7l
oigBo_nNdoooV/oooi;<oon8`?goNkSiof:Uk_lgOlooHgbBoh^IY@0:onk^kP006OoVi^H04OoUiNGo
hN7QomSHf?o:b/[o^KViojNWYonJVY[oTi>Coi6ATOn<S8coRHV9on?Shoo`l?3ob/[:ojBTY?oPh>3o
iNGU01Ooi^KV01GoiNGUonCTi?oShn?ohN7QomkNg_oLg=cofMWIomGEeOoCdm?oc/k>olW9bOo6a/Ko
`L71ofmjQ?oaloCon?ShooWinOnCTi?o@410on_[joojn_X00_oinOT01_no_koo61PHochn?_oQhN7o
n_[jooWin@;on_[j00GoSHf=ob@T9?o^k^kon_[jooWin@02ono_k`0CoiJFU_l/;2com?Cdong]kOm8
B4SoI6ATong]kOoclo?oWinOobTY:Ooclo?ok^k^ocLg=onEUIGon_[jooWinOnATI7o=3@dong]k@02
ooWin@;okno_013oUiNGobd];OoinOWok>c/odA4A?m^KVkolo?cono_kooalO7o6a/Koj>SXoojn_[o
Ti>CodI6A_ojn_[onOWi0oojn_X01OoinOWon_[joo[jn_oinOWon_[j00;onOWi0_ojn_X2ooWin@03
oo[jn_oinOWon_[j00;on_[j00GonOWioo[jn_ojn_[onOWioo[jnP02ooWin@;on_[j0_oinOT00ooj
n_[onOWioo[jnP02oo[jnP05ooWinOojn_[on_[jooWinOojn_X00_oinOT2oo[jnP;onOWi00?on_[j
ooWinOojn_X00_ojn_X01OoinOWon_[joo[jn_oinOWon_[j00;onOWi0_ojn_X2ooWin@03oo[jn_oi
nOWon_[j00;on_[j00GonOWioo[jn_ojn_[onOWioo[jnP02ooWin@;on_[j0_oinOT00oojn_[onOWi
oo[jnP02oo[jnP0<ooWinOojn_[on_[jooWinOmIQkKoOZ_Eoh2]fon4/N3oQ[CUohRhjOn:^^go8Rhl
0ol000003?lT<3koU<OmoiK:o_nBaokoS/?iohc3o_n2^oWoL[7doeRKi?l`NLWoHW^AohRFXP[oi^KV
000Honk^kP0<on[Zj_oNg]ko`l?3oinOWon7QhOoT92@ojZZZ_o4a<Coclo?om7AdOoFe]Kom?Cd0_o]
kNd01OoKfm_oRHV9olC4a?oLg=coj^[Z01Kok^k^01?okNg]onc/k?oZj^[oj>SXonOWiooUiNGoh^;R
omoOgooLg=cofMWIomGEeOo@d=3oc<c<ogAoROofmoSoo?cloogmoOono_konOWi00Goo_kn03Co`l?3
oa8B4_li>CWolo?cookno_ojn_[oo?clohn?SolR8R;om?Cdookno_nh^;SodM7Aonk^k_mRHV;oFe]K
ooGemOodm?CoBTY:ob4Q8OmaLG7ofMWIof1PH?mFEUKon?Shoo;bl_lg=cOoV9RHoo[jn_olo?coUIFE
oc8b<_oemOGoo_knokRh^?oAdM7ok^k^of=SHomLG5conOWioo7alOm:BT[o7alOoiFEUOoGemOoY:BT
oa/K6oodm?Coo_knonk^k_lG5aOofMWIF?ono_h01omCP[;oNZKEogb[fomn[=goP[7Soh>diomJO9l0
1Ol000002omOQ:WoSL;ioh^omOn8_OGoPKWdogVak_mZYn[oD9?KobU_`omSO9;oRiVU00[ok^k^000F
ooooo`0>ookno_ofm_KofMWIojFUYOn@T93oa<C4onk^k_oinOWom_Kfoo;bl_o_knool?3`onk^k_o/
k>`2oo3`l007oo7alOo:b/[oTI6AojFUYOoIfMWom_KfooknoP0Dooooo`0Bookno_omoOgoo?cloo_k
nooinOWom_KfooCdm?obl_;okno_on[Zj_oWinOoh^;RomoOgon1RiColO;dooShn?oinOWon?Sh0_oi
nOT00oojn_[onOWiooWin@02ooWin@0^okVi^Ol;2`_o@d=3onk^k_obl_;ok^k^oh20P?lO7aoomOGe
ooWinOn=SHgo<c<coaDE5Olj>S[o]KFeong]kOofm_KoFe]Kohn?SomcLg?o6QXJocPh>?o3`l?om?Cd
ono_kom;Bd_oWinOoo?cloo^k^koShn?od=3@ooemOGon_[johf=SOlb<S;o5QHFocPh>?ne]KGol?3`
oo;bl_mKFe_oS8b<ofATI?l>3PkoE5ADogIfMP;onOWi00?on_[jog5aLOn8R8P00ooinOT2oo[jnP;o
nOWi0_ojn_X4ooWin@03oo[jn_oinOWonOWi00?onOWi0_ojn_X2ooWin@;on_[j1?oinOT00oojn_[o
nOWiooWin@03ooWin@;on_[j0_oinOT2oo[jnPConOWi00?on_[jooWinOoinOT00ooinOT2oo[jnP;o
nOWi0_ojn_X4ooWin@03oo[jn_oinOWonOWi00?onOWi0_ojn_X2ooWin@;on_[j1?oinOT00oojn_[o
nOWiooWin@03ooWin@;on_[j0_oinOT02?ojn_[oCWfbog>Qd_mhY]WoNZWMogVZgOmgY]Wo4a/S1Ol0
00002olD7BGoP;;Woh>ilOmo]NkoNK7[og2ZjOmPWn?oAX[Eob1X_OmVOiGoUZ:]00[ooooo000Eonk^
kP09ong]kOoQhN7o^;RhohV9ROo5aLGomoOgoo?cloo]kNgok^k^00;ol?3`00ComoOgoo7alOogmoOo
l_;b0ooalO401ooclo?omoOgolG5aOn9RHWo^;Rhon7QhOo]kNd04oo^k^h04Oo]kNgok>c/on_[joo[
jn_oj>SXonOWiooUiNGohn?Son3Ph?oNg]kofm_KomOGeooDe=CoQHbCon?TiOoYjNWoj^[Z00;ojn_[
0_oZj^X4on_[j`04onGUiOnWYjOo5aLGofa/K0;ojn_[00CoQHF5obPX:?o[jn_ojn_[0_oZj^X00ooY
jNWojn_[on_[j`02on_[j`04on[Zj_o[jn_ojn_[on[ZjPGojn_[0_oZj^X5on_[j`03on[Zj_o[jn_o
jNWY00Kojn_[00?oj^[ZonSXj?o[jn/01?o[jn/00ooZj^[ojn_[on_[j`06on_[j`;oj^[Z1Oo[jn/0
0ooZj^[ojn_[on_[j`06on_[j`;oj^[Z1Oo[jn/00ooZj^[ojn_[on_[j`06on_[j`;oj^[Z1Oo[jn/0
0ooZj^[ojn_[on_[j`06on_[j`;oj^[Z1Oo[jn/00ooZj^[ojn_[on_[j`06on_[j`;oj^[Z1Oo[jn/0
0ooZj^[ojn_[on_[j`06on_[j`07on[Zj_m8N:goKYk?ofnOdOmbXmKoM:KJocaGLP07o`00000:od1K
NOmg[nWoLZ[UofbUhomRW]koEI?Hoc]nc?lFGkCoJ7b>oiRPZ0[ok^k^000DonKViP08onGUiOoKfm_o
[:b/ohb<S?o/k>colo?conk^k_oalO42oo;blP06oo3`l?ohn?So^;RhofYZJ_nMWIgom?Cd0oobl_80
2?oalO7ok^k^oo?cloo/k>coS8b<ojb/[?oKfm_oiNGU5?oVi^H00ooTi>Coh^;Ron7Qh@02on3Ph00F
omgMgOoKfm_of=SHomKFe_oCdm?odM7AohB<TooaloCom_KfooOgmoohn?SonOWiooShn?oinOWon?Sh
ooWinOohn?SonOWioo;bl_o]kNgoalO7on_[j`;onOWi00?oS8b<obTY:OoinOT00ooinOT00oohn?So
nOWiooShn004ooWin@03ooShn?oinOWonOWi00;on?Sh1?oinOT00oohn?SonOWiooShn004ooWin@03
ooShn?oinOWonOWi00;on?Sh1?oinOT00oohn?SonOWiooShn004ooWin@03ooShn?oinOWonOWi00;o
n?Sh1?oinOT00oohn?SonOWiooShn004ooWin@03ooShn?oinOWonOWi00;on?Sh1?oinOT00oohn?So
nOWiooShn004ooWin@03ooShn?oinOWonOWi00;on?Sh1?oinOT00oohn?SonOWiooShn004ooWin@03
ooShn?oinOWonOWi00;on?Sh1?oinOT00oohn?SonOWiooShn004ooWin@03ooShn?oinOWonOWi00;o
n?Sh1?oinOT00oohn?SonOWiooShn004ooWin@03ooShn?oinOWonOWi00;on?Sh0ooinOT05omEPJko
MYk;ogJPcOmiY=3oNZGBog^Ve?mmZ=KoOZ[HogjZfOn0[=_oP:cLoh6]gOn1[]koP:oOogn]g_mm[=ko
M:GJofjRf_mKU=3o9Vbmo`57YOmWO8koU9fU00[oi^KV000Donk^kP06onSXj?nl_;coTY:BooOgmoo_
knool_;b0ooclo<02Oobl_;omOGeonWYjOmTI6CoFEUIoeADE?o=cLgono_koo7al@03oo?cl`06oo;b
l_o_knoomoOgoi:BT_nl_;coj>SX4oo^k^h04?o]kNgok>c/onc/k?oZj^[ojNWYonSXj?oVi^Koi>CT
on;Rh_oPh>3og]kNom_Kfon2SIOom_Sioo_knoolo?`2oogmo@03ookno_omoOgoo_kn00?oo_kn00So
no_kooWinOono_koo_knoogmoOono_kodm?Coj^[Z`?oo_kn00?ooOgmookno_ono_h00_ono_h01Oom
oOgoo_knookno_ono_kooOgm00Koo_kn00?ooOgmookno_ono_h00_ono_h01OomoOgoo_knookno_on
o_kooOgm00Koo_kn00?ooOgmookno_ono_h00_ono_h01OomoOgoo_knookno_ono_kooOgm00Koo_kn
00?ooOgmookno_ono_h00_ono_h01OomoOgoo_knookno_ono_kooOgm00Koo_kn00?ooOgmookno_on
o_h00_ono_h01OomoOgoo_knookno_ono_kooOgm00Koo_kn00?ooOgmookno_ono_h00_ono_h01Oom
oOgoo_knookno_ono_kooOgm00Koo_kn00?ooOgmookno_ono_h00_ono_h01OomoOgoo_knookno_on
o_kooOgm00Koo_kn00?ooOgmookno_ono_h00_ono_h01OomoOgoo_knookno_ono_kooOgm00Koo_kn
01OoO9g1oiFbd_nG]]OoVKOHoiZifOnK^mcoWKgOoijnh?nO_n3oWKoQoik0honO`NCoXL7Uoj?3i_nO
`^KoW<3ToiNlh_nB^=ooMjGHob1W^Ol0?9coJ8:HohnKYP0:onk^kP004oooool01Oono_koh^;RoiFE
UOoalO7okno_00Gom?Cd00Wolo?cooGemOo`l?3oLG5aodi>C_mKFe_of=SHoo[jn_oclo<01Oodm?@0
1Oo_knoolO7aoiFEUOoRh^;oo_kn01;ooooo00Coo_knoogmoOomoOgono_k0_ojn_X02oogmoOom_Kf
ooGemOobl_;okno_onk^k_n>VJ?ol_?eooCdm?ofm_Kon?Sh09;onOWi00OoTZk:ojNofOnW`=_oZ/CM
oj[4gon]an7o[/SS00;o[lWT00ko[l[Uok3;ion`bnOo/lgYok;=j?nbcNOo[l[Wojc8i_nUa>CoNjKH
o`mDZol>=H_oLXbRoiVU/0[ooooo000Conk^kP05onOWionSXj?ocLg=ooGemOodm?@01_oemOD01ood
m?Cono_komKFe_nGUiOo`/;2oo[jn_odm?@01_oemOD01Oodm?ComOGeolg=cOnSXj?oinOW01;ok^k^
0_o]kNd2onc/k0;oj^[Z00?oj>SXonOWiooWinL00_oTi>@01_oRh^;oTiZRonCUi_oUiNKoj>SXonWY
j@;oj^[Z1Oo[jn/00ooZj^[ojn_[on_[j`02on_[j`03on[Zj_o[jn_ojn_[00Sojn_[00?oj^[Zon_[
joo[jn/00_o[jn/00ooZj^[ojn_[on_[j`08on_[j`03on[Zj_o[jn_ojn_[00;ojn_[00?oj^[Zon_[
joo[jn/02?o[jn/00ooZj^[ojn_[on_[j`02on_[j`03on[Zj_o[jn_ojn_[00Sojn_[00?oj^[Zon_[
joo[jn/00_o[jn/00ooZj^[ojn_[on_[j`08on_[j`03on[Zj_o[jn_ojn_[00;ojn_[00?oj^[Zon_[
joo[jn/02?o[jn/00ooZj^[ojn_[on_[j`02on_[j`03on[Zj_o[jn_ojn_[00Sojn_[00?oj^[Zon_[
joo[jn/00_o[jn/00ooZj^[ojn_[on_[j`08on_[j`03on[Zj_o[jn_ojn_[00;ojn_[00?oj^[Zon_[
joo[jn/00oo[jn/05onL]Lko/<KNok77gonbb>7o//WRok?9h_nfcNGo]lcUokO?i_nfc^So]/gWokS?
jOnjd^[o^M3ZokS?jOncc^Oo[l[Voibmh?mHS/Oo1T:Ooc13P?mjT:?oWJF]00[ok^k^000ConKViP04
olo?con>SXkonOWioo;blPSom_Kf00GomOGeooclo?oBd];olo?cooShn008ooKfmP04oo;bl_oinOWo
SXj>olo?ca?oi^KV00?oiNGUonCTi?oTi>@00_oShn<03?oRh^;oh>3Pon3Ph?oOgmoogMgMomcLg?nV
ZZgom?Ceoo;cloocloCom_KfooOgm`Gon?Sh0_oinOT4ooShn005ooWinOohn?Son?ShooShn?oinOT0
1Oohn?P2ooWin@Con?Sh00GonOWiooShn?ohn?Son?ShooWin@05ooShn0;onOWi1?ohn?P01OoinOWo
n?ShooShn?ohn?SonOWi00Gon?Sh0_oinOT4ooShn005ooWinOohn?Son?ShooShn?oinOT01Oohn?P2
ooWin@Con?Sh00GonOWiooShn?ohn?Son?ShooWin@05ooShn0;onOWi1?ohn?P01OoinOWon?ShooSh
n?ohn?SonOWi00Gon?Sh0_oinOT4ooShn005ooWinOohn?Son?ShooShn?oinOT01Oohn?P2ooWin@Co
n?Sh00GonOWiooShn?ohn?Son?ShooWin@05ooShn0;onOWi1?ohn?P02ooinOWon?ShooShn?ohn?So
nOWiooShn?n4X/KoV;OFoiVheonJ^]WoV[[J00;oW;cK013oW;gLoibng_nM_]koWKkNoifngonN_n3o
W[gPoibmh?nF^McoP:[Foe>:a_lPF:_o6cJ4of5`Son<VJ?o[[:e2_oVi^H001;ok^k^00GokNg]okZj
^_ni^KWon_[jooKfmP07ooOgm`07ooKfm_oinOWol_;bof9RH_o>c/koooooooGem@07ooOgm`05ooKf
m_ojn_[o^KViokZj^_o]kNd04_o^k^h2ong]k@;ok>c/0_o[jn/2onWYj@0<onSXj?oWinOoi^KVol[;
c?nW[;3oRiNOogV6T_mjPHWoRHb>oiJFU_nIVIWoV9RH0_nGUiL01OnFUYKoUiNGoiJFU_nFUYKoUIFE
00OoUYJF00GoUIFEoiJFU_nEUIGoUYJFoiFEU@03oiJFUP03oiFEUOnFUYKoUYJF00GoUYJF00GoUIFE
oiJFU_nEUIGoUYJFoiFEU@03oiJFUP03oiFEUOnFUYKoUYJF00GoUYJF00GoUIFEoiJFU_nEUIGoUYJF
oiFEU@03oiJFUP03oiFEUOnFUYKoUYJF00GoUYJF00GoUIFEoiJFU_nEUIGoUYJFoiFEU@03oiJFUP03
oiFEUOnFUYKoUYJF00GoUYJF00GoUIFEoiJFU_nEUIGoUYJFoiFEU@03oiJFUP03oiFEUOnFUYKoUYJF
00GoUYJF00GoUIFEoiJFU_nEUIGoUYJFoiFEU@03oiJFUP03oiFEUOnFUYKoUYJF00GoUYJF00GoUIFE
oiJFU_nEUIGoUYJFoiFEU@03oiJFUP03oiFEUOnFUYKoUYJF00GoUYJF00?oUIFEoiJFU_nEUID00_nF
UYH4oiNGU`?oVIVI0_nJVYX02?nKVi_oW9bLoa5BXOlBDj?o4E>Roa9DY?lAE:Co4UFU0_lBEJH03olA
EJGo4UJWoa9FYolBEZWo4UJXoa1EYol>DJKo3DjSo`]5W_lG?i3o=dj:ofIeUOnBWZOo[kBhom7Bd`0:
onk^kP004_ooool01?olo?co[jn_on7QhOofm_H8ooShn007ooOgmoomoOgoi^KVoeYJF_o0`<3ooooo
ooKfmP08ooShn004ooKfm_oQhN7o[jn_ooclo1?ooooo0_ono_h2oogmo@0?ooclo?okno_ono_koo[j
n_oinOWon?Shoo3`l?oIf]_o]KRloiBPZ_n0UJSoNIBZogJC[?mfTJ[oNY2T00?oMI2Y00KoMI2XogB@
Z?meT:SoNI2SogV?XomdSjP2ogB?Y`07ogB?Z?mdSjOoM92XogV?XomhSj;oM8nXogB?Y`02ogB?Z005
ogB?YomdSjSoNHnSogV?XomdSjP00_mdSjL01omdSjSoM8nWogB@Z?miSj?oN8nRogB?Z?mdSjL00_md
SjP01OmdSjOoM8nXogV?XomiSj?oM8nX00;oM8nW00OoM8nXogB?YomdT:SoNHnSogR?X_mdSjSoM8nW
00;oM8nX00GoM8nWogB?Z?miSj?oNHnSogB?Z002ogB?Y`07ogB?Z?mdSjOoM92XogV?XomhSj;oM8nX
ogB?Y`02ogB?Z005ogB?YomdSjSoNHnSogV?XomdSjP00_mdSjL01omdSjSoM8nWogB@Z?miSj?oN8nR
ogB?Z?mdSjL00_mdSjP01OmdSjOoM8nXogV?XomiSj?oM8nX00;oM8nW00OoM8nXogB?YomdT:SoNHnS
ogR?X_mdSjSoM8nW00;oM8nX00GoM8nWogB?Z?miSj?oNHnSogB?Z002ogB?Y`07ogB?Z?mdSjOoM92X
ogV?XomhSj;oM8nXogB?Y`02ogB?Z005ogB?YomdSjSoNHnSogV?XomdSjP00_mdSjL00omdSjSoM8nW
ogB@Z002ogV?X`06ogF@Z?mdT:SoMI2YogF@Z?meT:WoMI6Y0_mjTJD2ogJBZP08ogJBZomgTjcoMi>/
ogRD[OmhUJkoN9B^ogVE[omiUZl3ogZG/005og^H/_mkUk7oNiRbogbI/_mlV;801?mlVK<01omlV[Co
Oi^cohJL/?nKYk;o_<34on3Qh_ogmoL02_ooool001;ok^k^00Coj^[ZoiZJV_o^k^kom_Kf2?ojn_X0
1oohn?SoooooomKFe_m@D53o[:b/ooooooogmoL02?ojn_X01?ofm_Kok^k^oiZJV_oZj^XNonk^kP05
onKVi_oBd]?o][Zloj2X[onDX:/00_nAWj`00onOYjooU:2[oi6O[003oi6O[004oiBPZonOYjooWjN_
oiBPZ`CoTIn/00CoU:2[oinW[onOYjooU:2[1?nAWj`01?nDX:_oWjN_oinW[onDX:/4oi6O[004oiBP
ZonOYjooWjN_oiBPZ`CoTIn/00CoU:2[oinW[onOYjooU:2[1?nAWj`01?nDX:_oWjN_oinW[onDX:/4
oi6O[004oiBPZonOYjooWjN_oiBPZ`CoTIn/00CoU:2[oinW[onOYjooU:2[1?nAWj`01?nDX:_oWjN_
oinW[onDX:/4oi6O[004oiBPZonOYjooWjN_oiBPZ`CoTIn/00CoU:2[oinW[onOYjooU:2[1?nAWj`0
1?nDX:_oWjN_oinW[onDX:/4oi6O[004oiBPZonOYjooWjN_oiBPZ`CoTIn/00CoU:2[oinW[onOYjoo
U:2[1?nAWj`01?nDX:_oWjN_oinW[onDX:/4oi6O[004oiBPZonOYjooWjN_oiBPZ`CoTIn/00CoU:2[
oinW[onOYjooU:2[1?nAWj`00onDX:_oTIn/oi6O[00?oi6O[005oiBPZonPZ:oo][Zlom;BdooVi^H0
2oo^k^h001;oi^KV00Coh^;Roi>CToo_knoomoOg2?okno/01ooinOWooooool71`Om<C4coV9RHoooo
oooinOT02?okno/01?ogmoOokno_oi>CTooRh^;EonKViP004_o^k^h01?o[jn_oX:2Pon[Zj_oinOT8
ooclo007ooWinOooooooZj^[oe1@D?n3Ph?ooooooo_kn`08ooclo004ooWinOoZj^[oX:2Pon_[jmGo
k^k^000Booooo`04ookno_o1`L7oeMGEooclo0SooOgm00Sono_koooooonDU9CoEEEEog=cLoofm_Ko
ooooooclo0OooOgm00Coo?clomGEeOo1`L7oo_kneOooool001?ok^k^00Cod];BojBTY?ooooooo?cl
2?ono_h01oooooooP820oeaLG?mUIFGoj>SXooooooomoOd01_ono_h01?olo?coooooojBTY?oBd]98
onk^kP03om;Bd_meMGGoinOW08_ok^k^000ConKViP04omoOgonFUYKok^k^oo[jnPKoo_kn00WooOgm
ooooooodm?CoKfm_of9RH_mMGEgoeMGEooooooolo?`01_ono_h01?ojn_[ok^k^oiJFU_oOgmm8onKV
iP03on;Rh_lJ6Q[oU9BD08_oi^KV000Donk^kP04ol_;bonTY:Coo?clooclo0Gooooo00Woo_knoooo
oooUiNGoHf=SofIVI_mIFEWo`<30ooooooolo?`01Oooool2ooclo003ojBTY?o;bl_ok^k^01ook^k^
00?ok>c/olg=cOoFe]H01_o^k^h00ooShn?of=SHonk^kP08onk^kP03on?ShooHf=Sok^k^00Cok^k^
00?ogMgMomoOgoo^k^h01?o^k^h00ooEeMGok>c/onk^kP05onk^kP03oh61POli>CWok^k^00Gok^k^
00?og=cLomoOgoo^k^h01?o^k^h00oo[jn_ogmoOonk^kP0=onk^kP05on3Ph?oXj>SokNg]omGEeOo]
kNd03_o^k^h00ooEeMGok>c/onk^kP0Jonk^kP03omcLg?oOgmook^k^00gok^k^00?oeMGEonc/k?o^
k^h0:oo^k^h001Cooooo00Gono_kok^k^oo9bLWoo_knooclo004ooooo`09oogmoOoooooog]kNoe]K
FomYJFWoEEEEokFe]Oooooooo?cl00Cooooo00Goo?clookno_o9bLWo^k^koo_kn`0Oooooo`06ok2`
/?l:2P[o3@d=ob@T9?lf=SKoYjNW0_ooool02OoWinOoBTY:o`<30olS8b?o5aLGol71`Ooooooo@410
ogmoO`02ooooo`0BonOWiom:BT[o0`<3ob<S8olG5aOo`L71oooooooUiNGo@410o`000?lB4Q;o7AdM
ooShn?oooooodm?CobDU9OlN7Qko^[Zj1_ooool00onBTY;o0000omOGe`03ooooo`06om_Kfole=CGo
3Ph>o``<3?li>CWog=cL0_ooool01_no_koo6a/Ko`L71omBDU;oQXJ6oc0`<0;ooooo00?o@410ogmo
Ooooool01_ooool01_m0@43oFEUIobHV9_lK6a_o5ADEokbl_0;ooooo00Ko@410ogmoOooooooooooo
od10@?moOgl3ooooo`07om?CdolU9BGo7QhNokZj^_oooooo@410ogmoO`02ooooo`03oj>SXolL71co
oooo00Gooooo00Ko@410ogmoOoooooooooooogYjN_m3@d<2ooooo`0:okBd]?l92@WooooooooooooK
fm_o=CDeo`h>3_l<30co>CTiomcLg0;ooooo00Ko@410ogmoOooooooooooooj>SXolL71`2ooooo`07
om?CdolU9BGo7QhNokZj^_oooooo@410ogmoO`02ooooo`06oj>SXolL71cooooooooooom5ADGo:BTY
8Oooool001Gok^k^00Koi>CTojBTY?o;bl_ooooooo_knoono_h2ooooo`09ookno_oooooono_koh:2
P_mFEUKoJ6QXon?Shoooooooo_kn00;ooooo00Koo_knoo_knooooooobl_;ojBTY?oTi>@Ponk^kP0A
olO7aonb/[;ojNWYonk^k_nBTY;o0`<3olo?coo^k^ko?clooc/k>oo@d=3ok^k^on;Rh_oQhN7ok^k^
oc/k>omfMWH00_o^k^h04Olo?coo>c/kom3@d?o^k^koh^;Ron7QhOo^k^ko?CdmobTY:Onm_Kgok^k^
olW9bOo/k>cok^k^ofUYJOll?3cokNg]00Ook^k^00?o:b/[o`P82?mYJFT00_o^k^h00oo]kNgo<30`
oda<C002omkNgP0:odm?Cola<C7okNg]onk^k_m>CTkoDe=ConKVi_nCTi?o3Ph>ob`/;0;ok^k^00?o
>c/kogIfM_o^k^h01_o^k^h02_lk>c_o?ShnomoOgooZj^[oM7Adoa4A4OoRh^;ok^k^oc/k>omfMWH2
onk^kP03oc/k>omfMWKok^k^00;ok^k^00?oJFUYoc`l??o]kNd00_o^k^h01_lk>c_oMWIfonk^k_o^
k^koV9RHoaXJ6PKok^k^00Ko>c/kogIfM_o^k^kok^k^og5aLOln?Sh2onk^kP06ojRXZ?l820Sok^k^
ong]kOl`<33oC4a<0_oNg]h01_m?Cdoo<C4aong]kOo^k^ko>c/kogIfMP;ok^k^00OoV9RHoaXJ6_o^
k^kok^k^ofUYJOll?3cokNg]00;ok^k^00Ko>c/kogIfM_o^k^kok^k^oiRHV?lJ6QX2onk^kP03oh^;
RommOGgok^k^023ok^k^000FonKViP07omcLg?nUYJGo[:b/ooOgmoomoOgono_koogmo@03ooooo`03
ooGemOoAdM7oj^[Z00?ooooo00OooOgmoo_knoomoOgomoOgojb/[?nUYJGog=cL02Goi^KV00Kob/[:
o`000?nTY:CoalO7o`000?nUYJD5onKViP06ocTi>OmbLW;oi^KVolO7aol0003oYJFU1?oVi^H00oo6
a/Ko0000ohJ6QP05onKViP03odE5AOmVIVKoi^KV00Koi^KV00Wo^;Rho`000?n?Shoo4A4AomoOgooV
i^Ko`/;2o`000?nUYJD00_oVi^H01_nUYJGo0000olK6a_oVi^Ko9bLWoh61P@;oi^KV00KoKVi^ob/[
:ooVi^Koi^KVocTi>OmbLW87onKViP0:ocTi>OmbLW;oi^KVonKVi_o@d=3o0000oibLW?oVi^Ko>CTi
og9bLP;oi^KV00?o>CTiog9bL_oVi^H00_oVi^H00om5ADGoIVIVonKViP02onKViP06ocTi>OmbLW;o
i^KVonKVi_nCTi?o6ATI1_oVi^H01_li>CWoLW9bonKVi_oVi^KoKVi^oc`l?0;oi^KV00KoXZ:Ro`P8
2?oVi^Ko`/;2o`000?nUYJD2onKViP06ojFUYOl0003oa/K6onKVi_li>CWoLW9b0_oVi^H01_nCTi?o
6ATIonKVi_oVi^KoADE5ofIVIP?oi^KV00Ko>CTiog9bL_oVi^Koi^KVoi>CTolI6ATUonKViP005oo^
k^h05OoXj>So`L71oiNGUoo:b/[on?ShooooooomoOgono_koo[jn_olo?cooooooogmoOojn_[ono_k
oogmoOoooooon?Shol[:b_nGUiOo`L71onSXj00Uonk^kP07on3Ph?m9BDWo1`L7on7QhOna/K7o0000
ocPh>003ocXj>P08okJf]_o^k^ko>c/kogIfM_o^k^ko/K6ao`000?lh>3P3ocXj>P04okJf]_na/K7o
0000ol30`0Gok^k^00?oAdM7ofYZJ_o^k^h01_o^k^h02OmRHV;o?3`lonk^k_lU9BGoVIVIonk^k_na
/K7o0000omKFeP02onk^kP06omCDe?l0003o];Bdonk^k_lY:BWoRHV90_o^k^h01_n5QHGo;2`/onk^
k_o^k^ko>c/kogIfMPOok^k^00?o>c/kogIfM_o^k^h00_o^k^h01OlD51CoQhN7onk^k_lk>c_oMWIf
00;ok^k^00?o>c/kogIfM_o^k^h00_o^k^h00om7AdOoJVYZonk^kP02onk^kP06oc/k>omfMWKok^k^
onk^k_nHV9So6QXJ1_o^k^h01_lk>c_oMWIfonk^k_o^k^koLG5aochn?P;ok^k^00KoZ:RXo`P82?o^
k^ko/K6ao`000?oFe]H2onk^kP06omCDe?l0003o];Bdonk^k_lk>c_oMWIf0_o^k^h01_nHV9So6QXJ
onk^k_o^k^koAdM7ofYZJP?ok^k^00Ko>c/kogIfM_o^k^kok^k^oiRHV?lJ6QXUonk^kP006?ooool0
2?ono_kokno_ol;2`_nOWioo/[:bomcLg?obl_;ono_k0oomoOd02?okno_ol_;bomcLg?nb/[;oWinO
ol;2`_o_knooo_kn9Oooool06_nf][Ko71`LoaLG5onn_[koooooom_Kfol0003oZj^[olo?coo7alOo
0`<3onGUiOoooooo@410ogmoOooooooofm_Ko`000?n[Zj_oclo?olO7aol30`?oiNGUom_Kfol0003o
TI6A1Oooool00om=CDgoLW9booooo`05ooooo`0:ooKfm_l?3`ooXZ:Roooooon@T93o?ShnoooooooL
g=co0000okBd]0;ooooo00Ko/[:bo`000?oPh>3oooooob`/;?nCTi<2ooooo`06ohn?Sol`<33ooooo
oooooom0@43oJFUY1oooool02_m0@43oNWYjooooooooooookNg]o`000?o3`l?ooooood10@?moOgl2
ooooo`03od10@?mYJFWooooo00;ooooo00?oCDe=og9bL_ooool00_ooool01_m0@43oGEeMoooooooo
ooooWIfMoadM7@Kooooo00ko@410ofe]KOooooooooooogUiNOlc<c?oo_knoooooonc/k?o2@T9oooo
oooLg=co0000okBd]0;ooooo00Ko/[:bo`000?oPh>3ooooood10@?mMGEd2ooooo`06oifMWOlM7Ago
oooooooooom=CDgoLW9b0oooool01_m0@43oGEeMooooooooooooWIfMoadM7BGooooo000Jonk^kP0?
ong]kOoShn?ocLg=ok2`/?nMWIgoUiNGoiFEUOnDU9CoUIFEoiNGUonMWIgo/;2`olg=cOoShn?okNg]
02Kok^k^00CoN7Qho`000?m@D53oe]KF0oo^k^h01Olj>S[oHf=SonKVi_nCTi?o:2PX00;ok^k^00Wo
>c/kogIfM_o^k^kok^k^ocXj>_mSHf?oi^KVoi>CTolX:2P00_o^k^h02olj>S[o92@Tok6a/Oo]kNgo
clo?onk^k_oXj>SoA4A4ofEUIOoShn?oj^[Z00Cok^k^00koV9RHo`d=3OoTi>Cok^k^omkNg_l820So
b<S8onk^k_ll?3co@d=3olo?coo>c/ko@T92oclo?`;ok^k^00Ko:BTYohV9ROo^k^kok^k^ohF5QOl/
;2`2onk^kP05oc/k>olA4A7oQhN7omCDe?o/k>`01?o^k^h02_lk>c_o6ATIohb<S?o=cLgoHV9Ro`l?
3oo[jn_ok^k^oc/k>omfMWH2onk^kP0@oc/k>olA4A7oQhN7omCDe?oVi^KoA4A4ofEUIOoShn?oj^[Z
onk^k_lk>c_o4Q8Bofi^K_o?clooDE5AodM7A`Kok^k^00[o>c/koa<C4on2PX;of=SHocXj>_lL71co
FEUIom;Bd_mYJFWo;bl_0_o^k^h01_ll?3co@d=3olo?coo>c/ko@T92oclo?`;ok^k^01?o>c/koa8B
4_m^KVkoclo?oe5ADOm7AdOok^k^onSXj?m4A4CoIFEUon?ShooZj^[ok^k^oc/k>olB4Q;oKVi^olo?
comADE7oAdM702Gok^k^000MonKViP09onGUiOoRh^;og]kNomcLg?oKfm_og=cLomkNg_oRh^;oiNGU
02Soi^KV00?oclo?o`410On4Q8@01OoVi^H01Oo?cloo@410o`/;2olI6AWoYJFU00;oi^KV00Wo>CTi
og9bL_oVi^Koi^KVolo?com0@43o2`/;oaTI6OnUYJD00_oVi^H02ooAdM7oCTi>o`d=3Ol92@Wo8R8R
onKVi_mbLW;o1`L7o`X:2_lH61SoW9bL00Coi^KV00?oDE5AofEUIOoVi^H00_oVi^H01OmQHF7oMgMg
onKVi_oAdM7oBDU900;o3@d=00KoBd];om;Bd_oVi^Koi^KVoc`l??n>SXh2onKViP09oh^;Rolo?coo
i^KVonKVi_m;Bd_oNg]koe=CDol820Sof=SH00Coi^KV00Ko>CTiofm_KomKFe_o2`/;oaHF5_nGUiL2
onKViP0Dod];BomoOgooi^KVonKVi_m;Bd_oNg]koe=CDol820SoJf][o`L71ol:2P[o61PHoibLW?oV
i^Ko>CTiog5aLOm]KFgo4Q8BobTY:On`/;06onKViP0:od];BommOGgoIFEUo`h>3_lT92Co`<30ohZ:
R_lG5aOo71`LoibLW0;oi^KV00KodM7AodU9BOl=3@go3@d=od];BooBd]82onKViP0Cod];BomnOWko
KFe]oa8B4_lY:BWo/;2`onKVi_mbLW;o1`L7o`X:2_lH61SoW9bLonKVi_li>CWoLG5aofe]KOlB4Q;o
:BTYok2`/00UonKViP00C_o^k^h00oo9bLWo0@41omOGe`07onk^kP03on_[joo^k^kok^k^00;ok^k^
00?o>c/kogIfM_o^k^h00oo^k^h00oo[jn_ok^k^onk^kP05onk^kP06on_[joo^k^kok^k^onk^k_m7
AdOoJVYZ4?o^k^h2ong]k@ook^k^00?ojn_[onk^k_o^k^h00oo^k^h01?lk>c_oMWIfonk^k_o/k>`;
onk^kP04on_[joo^k^koAdM7ofYZJP?ok^k^00Co>c/kogIfM_o^k^kokNg]2oo^k^h00oo]kNgok^k^
onk^kP02onk^kP03ong]kOo^k^kok^k^00?ok^k^0_o]kNd7onk^kP03ong]kOo^k^kok^k^00;ok^k^
00?oAdM7ofYZJ_o^k^h00_o^k^h01?lk>c_oMWIfonk^k_o]kNdWonk^kP00Coooool01Om:BT[o>SXj
ohj>S_mRHV;oF5QH00Wooooo00?o@410ogmoOoooool03oooool00ooPh>3og]kNooooo`0Vooooo`03
od10@?moOgoooooo00Gooooo00?oFe]Koi:BT_ooool01_ooool00ooPh>3og]kNooooo`02ooooo`03
od10@?moOgoooooo02Gooooo00?oh>3PomkNg_ooool00_ooool00om0@43oOgmoooooo`0Xooooo`00
Coo^k^h01OoZj^[oZJVYofIVI_mnOWko/[:b00Wok^k^00?o>c/kogIfM_o^k^h0>?o^k^h00olk>c_o
MWIfonk^kP05onk^kP03ojRXZ?no_kook^k^00_ok^k^00?o>c/kogIfM_o^k^h0:_o^k^h00olk>c_o
MWIfonk^kP0Xonk^kP00GOoVi^H00ooRh^;oi>CTonKViP0honKViP03on;Rh_oTi>Coi^KV01?oi^KV
00?oh^;RonCTi?oVi^H0:_oVi^H00ooRh^;oi>CTonKViP0XonKViP00ooo^k^h7onk^kP00ooooool7
ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7
onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7
onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00oomoOgl7ogmoO`0000Cojn_[
onKVi_oRh^;og]kN1?oMgMd3omkNgP0KomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oMgMgog=cL00;ogMgM017og]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNgP02omgMg@2oomcLgOoMgMgogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oMgMgog=cL
omgMgOoLg=cogMgMomcLg?oNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMd00ooNg]h00ooMgMgog]kNomkNgP03omgMg@7ohN7Q0OoWinL1on[Z
jP0000?ok>c/onKVi_oPh>001ooIfMT01?oHf=Soe]KFom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOG
omSHf0cofMWI00Wof=SHomOGeooEeMGoe=CDom?CdooDe=CoeMGEomOGeooHf=P03OoIfMT02OoHf=So
emOGomGEeOoDe=Codm?ComCDe?oEeMGoemOGomSHf00YomWIf@?of=SH00GoemOGomKFe_oDe=Coe=CD
omKFeP03omSHf0OofMWI0ooHf=P3omWIf@;of=SH1_oIfMT2omSHf0KofMWI0ooHf=QVomWIf@03omSH
f?oIfMWofMWI00KofMWI0OoNg]h1onKViP7ok>c/00001oo^k^kojNWYonCTi?oPh>3ohN7Qon3Ph?oR
h^800_oQhN403OoNg]kog=cLom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooO
gml02OoQhN403OoPh>3ogmoOom_KfooFe]Kod];Bolk>c_o<c<coc/k>om;Bd_oFe]Kofm_KomoOgooP
h>002OoQhN403OoPh>3ogmoOom_KfooFe]Kod];Bolk>c_o<c<coc/k>om;Bd_oFe]Kofm_KomoOgooP
h>009OoQhN42on3Ph008omoOgooMgMgog=cLom[Jf_oHf=Soe]KFomSHf?oKfm/6omoOg`?oh>3P00?o
gmoOomkNg_oNg]h00_oOgml01OoPh>3ogmoOomoOgooNg]kogmoO00Coh>3P0ooOgml00ooPh>3ogmoO
on3Ph003on3Ph004omoOgooNg]kog]kNomoOg`?oh>3P00?ogmoOon3Ph?oPh>001OoPh>1Lon7Qh@03
on;Rh_oQhN7oh^;R00CohN7Q0OoTi>@1onWYj@7okNg]00000oo`l?3okno_oo7al@03oo3`l00Hono_
koo`l?3ok^k^onWYjOoKfm_o`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Z
j_o]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7a0_o^k^h05?oVi^Kog]kNom7AdOo9bLOo`L71
okno_oo1`L7obLW9om7AdOoNg]koi^KVonk^k?o^k^kolO7aono_kooalO7okno_oo7alOo_knoolO7_
0_o^k^h02ooVi^Kog]kNom7AdOo9bLWo`L71okno__o1`L7obLW9om7AdOoNg]koi^KV00;ok^k^02?o
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7al@02onk^kP0=onWYjOoXj>Soi>CTonCTh_oPh>3ogmoOon3Ph?oVi^Ko
jNWYon_[jooWinOoj>SVonKViP02onWYj@0?onk^k_o]kNgok^k^onSXj?oXj>KoiNGUonWYjOoZj^[o
kNg]on[Zj_oYjNWoi^KVonWYiooZj^[okno_00;okNg]00GoinOWonWYjOoZj^[okNg[onWYj@02onc/
k007onk^k_oYjNWoj>SXonGUiOoXj>Koj>SXonk^kP02ong]k@1ZonWYjOo]kNgokNg]onk^k?oZj^[o
k>c/ong]kOo`l?3okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7ol?3`ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`Col?3`00000oobl_;ok^k^
onOWi`04onGUi@0@onCTi?oOgmoodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIV
ohZ:ROna/K7odM7AomkNgP;oi>CT00_oiNGUonCTi?oUiNCoi>CTonGUiOoRh^;og=cLolo?coo1`L7o
/K6aojVYZ003ojBTY00mojVYZOna/K7o`L71olo?cooLg=_oh^;RonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oRh^;og=cLolo?coo1`L7o/K6aojVYZOnTY:CoY:BSojBTY?nYZJWo/K6aol71`Oo?cloo
g=cLon;Rh_oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi002onCTi00>on7QhOoNg]kof=SHomKFe_oEeMGoe=CCom;Bd_o=cLgo
QHF5odM7AooEeMGofm_KomGEeOoEeM@2omGEe@0HomKFe_oMgMgogmoOomcLg?oFe]KoeMGDomKFe_oJ
f][og=cLomoOgooKfm_ofMWIomGEeOoGemKof][Jon3Ph?oOgmoog=cLomKFe_oIfMWog=cLomcLfooH
f=Sog=cL0_oNg]h03ooHf=Soe]KFomCDe?oEeMCoemOGomcLg?oOgmoog=cLomSHf?oLg=coh>3PomoO
g_oIfMWofm_KomoOg`02onCTi01JonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CT1?oUiND01_oTi>CoiNGUonGUiOoUiNGoj>SXong]k@7ol_;b0000
0oodm?CokNg]onOWi`02on3Ph00Con7QhOoOgmoog]kNom;Bd_nd];CoQhN7oeaLG?m]>cGoWTi2ole_
GooYPfoocFmOoii>@om]>cKoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomoOgooJf][oc/k>okbl
_?n[Zj_o/;2`olO7aooIfMWoi>CTomWIfOo7alOo/K6aoj^[Zonl_;coc/k>om[Jf_oOgml01OoPh>00
4OoOgmoof][Jolk>c_nl_;coZj^[ok2`/?o7alOofMWIonCTi?oIfMWoalO7ok6a/On[Zj_o_;blolk>
c_oJf][ogmoO027oh>3P02Gog]kNom[Jf_oCdm?od=3@om7AdOnf][Ko[:b/og5aLOlH61So=CDeogQh
N?o7alOod];Bolo?coo3`l?odM7Aolg=cOo>c/koe]KFomSHf?oBd];oclo?ol_;bono_kooemOGom[J
f_oKfm_ofMWIomGEeOo0`<3od=3@om7AdOoHf=SofMWIom?CdooAdM7o`<3000;oemOG00CodM7Aom?C
dooHf=SoeMGE0_o@d=003_nm_KgocLg=om3@d?oCdm?of=SHomGEeOoAdM7oeMGEom_KfooHf=SodM7A
om;Bd_oIfMWog]kNF_oPh>000ooOgmooh>3PomoOg`02omoOg`?oh>3P00?ohN7QonOWioo/k>`00Ood
m?@00003ooKfm_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgoWinOof]OGon?=RkokG5QooVMT?om
/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=cOoRh^;oinOW00Coj>SX00Ooi^KVomgMgOo:
b/[o]KFeokno_ooWinOokno_00?ol?3`00Ookno_onWYjOo1`L7o]KFeol[:b_oMgMgoi^KV00Goj>SX
00Ooi^KVomgMgOo:b/[o]KFeokno_ooWinOokno_00?ol?3`00Ookno_onWYjOo1`L7o]KFeol[:b_oM
gMgoi^KV023oj>SX01?oinOWonGUiOoNg]koe]KFohf=SOl?3`oo71`LoalO7ol0003oOGemomSHf?oM
gMgog]kNokBd]?lO7aoo10@4oc/k>on3Ph?o51@D00;ogMgM00cocLg=oeQHF?l30`?o71`Loa8B4_n<
S8coi>CTogIfM_l:2P[o820PobHV9_nNWYh2omoOg`0Iok^k^olS8b?o6ATIoinOWooNg]ko8R8RohF5
QOoMgMgofMWIoi2@T?l@413o5QHFo`@41?mPH63odm?ComgMgOo5aLGo0000okjn__oRh^;ogmoOoclo
?omYJFWohN7QonKViP1SonSXj07ok>c/0Oobl_81ooKfmP0000?omoOgooShn?ohn?P00oohn?P04oog
moOok^k^olk>c_n@T93oQBl[onUTE_okTXOooZJKoojaYOoo^:_oo[>VoojXW?okU8WokVQIohTa:on@
T93oc/k>onk^k_ogmoL01?ohn?P01_odm?CoinOWolo?coo6a/Koj^[ZooCdm0;onOWi00Won_[jooWi
nOoinOWom_Kfon_[joo7alOoclo?onOWioodm?@01Oohn?P01_odm?CoinOWolo?coo6a/Koj^[ZooCd
m0;onOWi00Won_[jooWinOoinOWom_Kfon_[joo7alOoclo?onOWioodm?@08?ohn?P0??ogmoOom?Cd
onc/k?nHV9So2@T9ojj^[_ofm_KomoOgokjn__lF5QKoSXj>on[Zj_o/k>coIVIVoclo?ooXj>SoYZJV
oa@D5?lF5QKok>c/on_[jomVIVKo8B4Qokjn__oWinOoh^;RomgMgOobl_;oa/K6omOGeooVi^KoTY:B
obPX:?obl_;okno_og=cLole=CGol?3`ooCdm?o_knoo92@Tohn?Soo/k>co`l?3o`<30onBTY;ol_;b
olK6a_lI6AWoPX:2onc/k?oCdm?o0000ol[:b_obl_;okno_od=3@om`L73olO7aooKfmUcon?Sh00?o
moOgooShn?ohn?P00_ohn?P01?ogmoOonOWiooOgmoogmoL1ooShn00000?on_[jooGemOo^k^h00_o/
k>`08Oo[jn_ojNWYomoOgonj^[[oNE9Boklb9?oWM6WooHUnoonHS?onXYKoojRLoojTV?ooVXgooXYo
onifJ_o3<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/on_[jooVi^Kof=SHok^k^ooDe=Coi>CT
on_[jooalO7ol_;boo?cl`02oo;blP06ong]kOoUiNGoeMGEok^k^ooHf=Soi^KV0_o[jn/03?o/k>co
jn_[on_[jooVi^Oof=SHok^k^ooDe=Coi>CTon_[jooalO7ol_;boo?cl`;ol_;b00KokNg]onGUiOoE
eMGo^k^komSHf?oVi^L2on_[j`0aonc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/on_[jooVi^Kof][JoaTI6Om<C4coi^KVon_[jooZj^_oj>SXoh>3
Pol:2P[ofMWIomoOgolo?cooJFUYon?Si?oUiNGoPX:2oaDE5@02omoOg`20o`T92OmkNg_of][Kom_K
fooIfMWoh>3Pon?ShooPh>3of][Jolo?com=CDgo9RHVonOWiooShn?oCDe=oeeMGOoRh^;oj>SXon7Q
h_lR8R;oQhN7on3Ph?maLG7o3`l?omgMgOoUiNGoh>3QoeEEEOl_;boohN7QolO7aol0003o_Kfmon;R
h_oOgn3o@410of][JooVi^KojNWYonc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>`7on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT00003oo_knooc
lo?okNg]00;oiNGU01ooi^KVonCTi?oIfMWo/[:bogT^;_o8@SCohfYLooAjKOomR7cooYN:oojKS_on
V8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;of=SHonCTi?oUiNGoi^KVonGUi_oUiNGogmoOom7AdOnf
][Koe=CDomgMgOoTi>Coi^KW00?ok>c/00Ooj>SXonCTi?oOgmooeMGEokJf]ooAdM7ogmoO00;oiNGU
01Coi^KVonGUiOoUiNGogmoPom7AdOnf][Koe=CDomgMgOoTi>Coi^KVonc/k?o/k>gok>c/onSXj?oT
i>CogmoOomGEeOnf][KodM7AomoOh0;oiNGU03Goi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoiNGUon7QhOnh^;So0000ohB4Q?oPh>3oiNGUonCT
iOoQhN7o`L71o`000?na/K7ofm_Kocdm?OmYJFWog]kOon3Ph?n@T93o51@DomcLg?o:b/[o0000obd]
;@03ocLg=`1lohn?SooNg]kofMWIogUiNOl:2P[o;2`/okJf]_oPh>3og=cLodY:B_mKFe_ofMWIomoO
gooLg=co8B4QohB4Q?oMgMgoFEUIocHf=_oEeMGofMWIomKFeomhN7So5QHFomkNg_o3`l?o0000okJf
]_oGemOoeMGFochn?_mXJ6SohN7QonCTi?oVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUi@;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGokNg]
ooCdm001oo_kn`0000?oo?clooShn?oalO400oo^k^h04oo[jn_ohN7Qokbl_?mj5aOo`clbom=FBOoT
J5[okgM/ooB3NOohQgcomHAjoo=iKOoUJE_ofEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h02?o]
kNgojNWYom[Jf_ni^KWoemOGomkNg_oShn?oi^KV0ooZj^X02?oXj>Soi>CTomkNg_oHf=So^KViom[J
f_oYjNWokNg]0oo^k^h02?o]kNgojNWYom[Jf_ni^KWoemOGomkNg_oShn?oi^KV0ooZj^X02?oXj>So
i>CTomkNg_oHf=So^KViom[Jf_oYjNWokNg]7oo^k^h01_o]kNgojn_[oj:RX_l0003o_[jnonKViP;o
jn_[00Ooi^KVom_Kfol0003oS8b<onGUiOm0@43oKVi^00;ojNWY00KoV9RHoaDE5OoWinOoinOWo`L7
1omjNWX2okJf]P0=oaXJ6_nZZZ[oj^[Zoi^KVol=3@goUiNGomoOgooVi^KoinOWon;Rh_m=CDgoGEeM
omoOg`02onGUi@06ob<S8on;Rh_oj>SXogUiNOl=3@gogMgM0_oOgml01_mBDU;o<c<conWYjOo=cLgo
0000oj>SX`;ogmoO00Co?3`lofi^K_o[jn_okNg]H_o^k^h00oo]kNgol_;booShn001ooclo0000oom
oOd05_olo?cooOgmoogmoOolo?colo?com7AdOmX1`Oo^3@dolLo<ooBD4?ofV9Eon=^H_oTLVCoi6mR
omaTEooCDD?oc44dokTd=?m[1`Ood];Boo?cloolo?`4oogmo@07ooWinOo/k>co^;Rhom_KfooQhN7o
iNGUonWYj@02onc/k008ong]kOoZj^[oiNGUon;Rh_oKfm_o^KVionc/k?oinOT5oogmo@07ooWinOo/
k>co^;Rhom_KfooQhN7oiNGUonWYj@02onc/k008ong]kOoZj^[oiNGUon;Rh_oKfm_o^KVionc/k?oi
nOTPoogmo@06ooclo?okno_o`<30o`000?o5aLGol?3`0_oemOD01oo`l?3o`l?3o`000?nVYZKon?Sh
odA4A?mgMgL00_okno/0:OnTY:Co5QHFoo[jn_okno_oIfMWodI6A_oUiNGo`<30o`P82?oclo?ono_k
oibLW?lb<S;ol?3`onk^k_oTi>ConOWionk^k_m?CdooH61PonSXj?oclo?omoOgobDU9OnDU9ConOWi
omcLg?l71`OoQHF5on[Zj_nc/k?o4a<CoiVIVOokno_ogmoOo`000?lU9BGoZJVYom3@d?lB4Q;oYZJV
00;oo?clH?omoOd00oolo?cooOgmooclo003oogmo@0006CooOgmoo[jn_oclo?ok^k^oo3`l?o_knoo
k^k^onWYjOoCdm?oFadMoj8d=?nd:1go`CX]olM9??o?ET[od5M;om1GB_o:BSko`c/^okHX7OnR=3Co
G1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_ono_koo^k^kohn?Sojb/[?o:b/[od];BomOGeooJf]Wo
gMgMomkNg_oMgMgog=cLomOGeooDe=Cob/[:ojb/ZooShn?ok^k^ono_koo`l?3okno_oo3`l?o_knoo
k^k]on?Shon/[:cob/[:om;Bd_oGemOof][JomgMgOoNg]gogMgMomcLg?oGemOoe=CDol[:b_n/[:co
hn?Sonk^kOo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_0_o_knl05OoLg=co0P82oi6ATOoPh>3ohN7Qon;RhOoPh>3oOGemo`000?o6
a/KokNg]oe=CDomnOWkokno^onk^k_nVYZKo:b/[ono_koo^k^koi>CToeMGE`02oa0@400Hohf=SOo^
k^kokno_onSXj?mDE5Co61PHo`/;2on0P83ok^k^ogemOOl820So2PX:oaTI6OnJVY[ojn_ZocPh>?nG
UiOok>c/ono_kona/K7o:b/[o`T92OlI6AWoOgmo0_o^k^h0I?oHf=So6ATIokRh^?lo?coo2@T9ode=
COoVi^Kok^k^oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knl2oo3`l0Kokno_0Ooclo<1ooWin@7oo_kn00000oono_komoOgoo3`l004
onWYj@0AonOWiooKfm_oHd];oh4b<_nV=CGo]S@]ol9=@Oo3E4Woa5E:ol=DBOo2CD7o]S@]ojDe=On1
<S;oHd];om_KfooWinL01OoYjNT01_oXj>Sohn?Soj^[Zoni^KWobLW9olo?c`;oeMGE00Woe]KFomGE
eOoDe=Coclo?olS8b?ni^KWoZj^[on?ShooXj>P01OoYjNT01_oXj>Sohn?Soj^[Zoni^KWobLW9olo?
c`;oeMGE00Woe]KFomGEeOoDe=Coclo?olS8b?ni^KWoZj^[on?ShooXj>P08OoYjNT2onSXj003oeiN
G_lW9bOod];B00;ogMgM00Gof=SHoc4a<Om5ADGoinOWonSXj00:onWYj@03onOWiooYjNWojNWY00Co
jNWY00?oinOWonWYjOoYjNT00_oXj>P02Om>CTkoGemOonSXj?oXj>SoiNGUon;Rh_oShn?oi^KVonSX
j002onWYj@03onKVi_oYjNWojNWY00KojNWY00?oj>SXonWYjOoYjNT0G_oYjNT00ooXj>SojNWYonWY
j@04onWYj@7ol?3`0OogmoL1ooknoP0000Goo_knoo[jn_odm?Cokno_oo7al@02oo3`l00Aono_koo[
jn_oUIBDodlS8onEE5Co^g=com>EUOoJW9cofYjLomVLW?oDUIGo^g=coiEDE?m?8b?oUIBDon[Zj_o_
knl01_o`l?001_o^k^kobl_;ojNWYoo8b<Sof=SHon?Sh`?oi^KV00Kohn?SomSHf?o8b<SoYjNWol_;
boo^k^h7oo3`l006onk^k_o;bl_oYjNWolS8b?oHf=Sohn?S0ooVi^H01_oShn?of=SHolS8b?nWYjOo
bl_;onk^kR?ol?3`00[okno_omkNg_lm?Cgo9RHVogYjN_n0P83o<30`obh^;_oBd];okno_5_o`l?00
0oo_knooe=CDolo?c`02ono_k`03onk^k_m0@43oW9bL00;okno_LOo`l?001?oalO7ol?3`ooCdm?oj
n_X1ooknoP0000CooOgmooooooooooooo_kn0_ooool2ooknoP3eoogmoOohn?SoKVi^oeXo?onaT93o
g/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSloofe]KOohn?Soo?clooooooono_koooooookno_ooooko
o_knooooooomoOgoo?clolG5aOnj^[[ogMgMoo7al?ohn?SonOWiooShn?oalO7ogMgMokZj^_o5aLGo
o?ckoogmoOooooooo_knooooooono_koooooookno_ooookooOgmooclo?o5aLGo^[ZjomgMgOoalO7o
n?ShooWin?ohn?SolO7aomgMgOnj^[[oaLG5ooclo?omoOgoooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
oooooo_knon/[:coN7Qhog=cLonSXj?on?ShoogmoOooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koo_kmojRXZ?oFe]KooOgmooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooooono_h0
0_ooool00oono_koooooooooo`03ooooo`7ooOgm00001?ooooooo_knoo[jn_odm?@5oo7al@0=ono_
kooFe]KoJf][od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7al@0=oo3`
l?oVi^Ko_Kfmok2`/?o?cloogmoOonGUiOoOgmooclo?ok2`/?nm_Kgoi^KVoo3`l009oo7al@0=oo3`
l?oVi^Ko_Kfmok2`/?o?cloogmoOonGUiOoOgmooclo?ok2`/?nm_Kgoi^KVoo3`l02hoo7al@04oo3`
l?oalO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_ono_h00Oooool00005onc/k?omoOgon?Shoo3`l?o[
jn/00ooZj^X03OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oY
jNT03?oZj^X02OoYjNWob/[:ok6a/OnMWIgoTY:BoifMWOna/K7ob/[:onWYj@0=on[ZjP09onWYjOo:
b/[o/K6aoifMWOnBTY;oWIfMok6a/Oo:b/[ojNWY0<7oj^[Z00Cojn_[oo3`l?ohn?SooOgm0Oo/k>`0
0004okFe]Oofm_Kon_[jooCdm0SolO7a0_o`l?03ono_k`;ol?3`4OoalO43oo3`l1?olO7a0oo`l?30
oo7al@03oo3`l?oalO7olO7a00;olO7a00?omOGeoo[jn_ofm_H00One]KD00003olK6a_o3`l?on_[j
0?oooooo0Oooool1ooWin@7o`l?30Oo6a/H00004oo;bl_oDe=Coa/K6ooCdm?cooooo00Goo_knoooo
ooodm?Coa/K6omCDe001oo;blP00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{262, 249},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    \( (*\ Selections\ *) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]ShowInputDialog[
        frame, \[IndentingNewLine]JavaNew["\<java.lang.String\>", "\<Select \
your birth month.\>"], \[IndentingNewLine]{JavaNew["\<java.lang.String\>", \
"\<January\>"], \[IndentingNewLine]JavaNew["\<java.lang.String\>", \
"\<February\>"], \[IndentingNewLine]JavaNew["\<java.lang.String\>", \
"\<March\>"], \[IndentingNewLine]JavaNew["\<java.lang.String\>", \
"\<April\>"], \[IndentingNewLine]JavaNew["\<java.lang.String\>", "\<May\>"], \
\[IndentingNewLine]JavaNew["\<java.lang.String\>", "\<June\>"], \
\[IndentingNewLine]JavaNew["\<java.lang.String\>", "\<July\>"], \
\[IndentingNewLine]JavaNew["\<java.lang.String\>", "\<August\>"], \
\[IndentingNewLine]JavaNew["\<java.lang.String\>", "\<September\>"], \
\[IndentingNewLine]JavaNew["\<java.lang.String\>", "\<October\>"], \
\[IndentingNewLine]JavaNew["\<java.lang.String\>", "\<November\>"], \
\[IndentingNewLine]JavaNew["\<java.lang.String\>", "\<December\>"]\
\[IndentingNewLine]}, \[IndentingNewLine]1 (*Defalut\ \
\(\(selection\)\(.\)\)*) ]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \("October"\)], "Output"]
}, Open  ]],

Cell["Text Input", "Text"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004U0000LaP00`40o`00
0?l0003oo`0002H000000003R<2hB928B9280?m8T8PRB9280@00000000>8
`;S8h=R8`;P0ohS0^268`;P1B9280@00000000>8`;S8h=R8`;P0olc<c23<
c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`Pc<c<0HS0^058T8P1
000000000hS0^<SPf8S0^03oc<c<8<c<c068`;P1B9280@00000000>8`;S8
h=R8`;P0olc<c23<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`P
c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<8<c<c068`;P1B928
0@00000000>8`;S8h=R8`;P0olc<c23<c<`1R<2h0DR@R04000000003R<2h
b>3HR<2h0?o<c<`Pc<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<
8<c<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c23<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h0?o<c<`Pc<c<0HS0^058T8P1000000000hS0
^<SPf8S0^03oc<c<8<c<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<
c23<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h05;<c<`joooo1lc<c3_o
oomAc<c<0HS0^058T8P1000000000hS0^<SPf8S0^01@c<c<0VIVIP03c<c<
IVIVIVIV03IVIVH00oooolc<c<c<c004c<c<00=VIVK<c<aVIVH0>6IVIP03
ooooc<c<c<c<04o<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h053<c<`k
IVIV00?oooo<c<c<c<`01<c<c003IVIVooooc<c<03O<c<`00fIVI_ooolc<
c01@c<c<0HS0^058T8P1000000000hS0^<SPf8S0^01@c<c<0VIVIP03oooo
c<c<c<c<03C<c<`2IVIV00?oooo<c<c<c<`01<c<c003IVIVooooc<c<03O<
c<`00fIVI_ooolc<c01@c<c<0HS0^058T8P1000000000hS0^<SPf8S0^01@
c<c<0VIVIP03ooooc<c<c<c<03C<c<`2IVIV00?oooo<c<c<c<`01<c<c003
IVIVooooc<c<03O<c<`00fIVI_ooolc<c01@c<c<0HS0^058T8P100000000
0hS0^<SPf8S0^01@c<c<0VIVIP03ooooc<c<c<c<03C<c<`2IVIV00?oooo<
c<c<c<`01<c<c003IVIVooooc<c<03O<c<`00fIVI_ooolc<c01@c<c<0HS0
^058T8P1000000000hS0^<SPf8S0^01@c<c<0VIVIP03ooooc<c<c<c<03C<
c<`2IVIV00?oooo<c<c<c<`01<c<c003IVIVooooc<c<03O<c<`00fIVI_oo
olc<c01@c<c<0HS0^058T8P1000000000hS0^<SPf8S0^01@c<c<0VIVIP03
ooooc<c<c<c<017<c<`300001lc<c08000001Lc<c000000000000<c<c002
00004<c<c09VIVH00oooolc<c<c<c004c<c<00=VIVKoooo<c<`03Lc<c0<0
0003c<c<00D0003<c<c<c<c<c<`000000/c<c0800002c<c<0P0000K<c<`0
0`000<c<c<c<c00>c<c<00=VIVKoooo<c<`0D<c<c068`;P1B9280@000000
00>8`;S8h=R8`;P0D<c<c09VIVH00oooolc<c<c<c00Cc<c<0P0000K<c<`2
00000/c<c08000000lc<c0000000000@c<c<0VIVIP03ooooc<c<c<c<00C<
c<`00fIVI_ooolc<c009c<c<00@0003<c<c<c<c<c<`700000/c<c0800002
c<c<0P0000?<c<`200001<c<c0H0000<c<c<00=VIVKoooo<c<`0D<c<c068
`;P1B9280@00000000>8`;S8h=R8`;P0D<c<c09VIVH00oooolc<c<c<c00C
c<c<0P0000K<c<`200000/c<c0L0000>c<c<0VIVIP03ooooc<c<c<c<00C<
c<`00fIVI_ooolc<c009c<c<1P000004c<c<0000000000001<c<c0800000
0lc<c00000000003c<c<0P0000?<c<`200001<c<c0<0000:c<c<00=VIVKo
ooo<c<`0D<c<c068`;P1B9280@00000000>8`;S8h=R8`;P0D<c<c09VIVH0
0oooolc<c<c<c00Cc<c<0P0000K<c<`900004<c<c09VIVH00oooolc<c<c<
c004c<c<00=VIVKoooo<c<`02/c<c08000001<c<c00000000<c<c0<00004
c<c<2P0000?<c<`200001Lc<c0030000c<c<c<c<00W<c<`00fIVI_ooolc<
c01@c<c<0HS0^058T8P1000000000hS0^<SPf8S0^01@c<c<0VIVIP03oooo
c<c<c<c<01?<c<`200001/c<c0/0000>c<c<0VIVIP03ooooc<c<c<c<00C<
c<`00fIVI_ooolc<c00:c<c<2@0000G<c<`010000<c<c000000000?<c<`2
00000lc<c080000Ac<c<00=VIVKoooo<c<`0D<c<c068`;P1B9280@000000
00>8`;S8h=R8`;P0D<c<c09VIVH00oooolc<c<c<c00Cc<c<0P0000K<c<`9
00004<c<c09VIVH00oooolc<c<c<c004c<c<00=VIVKoooo<c<`02/c<c080
00000lc<c0000000000400001<c<c0030000c<c<c<c<00L00003c<c<0P00
017<c<`00fIVI_ooolc<c01@c<c<0HS0^058T8P1000000000hS0^<SPf8S0
^01@c<c<0VIVIP03ooooc<c<c<c<01?<c<`200001Lc<c0P0000Bc<c<0VIV
IP03ooooc<c<c<c<00C<c<`00fIVI_ooolc<c00:c<c<0P000003c<c<0000
0000008000000lc<c00000000002c<c<0`000003c<c<0000000000?<c<`2
00000lc<c080000Ac<c<00=VIVKoooo<c<`0D<c<c068`;P1B9280@000000
00>8`;S8h=R8`;P0D<c<c09VIVH00oooolc<c<c<c00Bc<c<00<0003<c<`0
00000P0000C<c<`;00003/c<c09VIVH00oooolc<c<c<c004c<c<00=VIVKo
ooo<c<`02/c<c0L000000lc<c00000000003c<c<00<0003<c<c<c<`01`00
00?<c<`200004Lc<c003IVIVooooc<c<053<c<`1R<2h0DR@R04000000003
R<2hb>3HR<2h053<c<`2IVIV00?oooo<c<c<c<`05Lc<c0<00004c<c<1000
00;<c<`010000<c<c000000000k<c<`2IVIV00?oooo<c<c<c<`01<c<c003
IVIVooooc<c<00[<c<`2000000?<c<`0000000001@0000C<c<`800001<c<
c080000Ac<c<00=VIVKoooo<c<`0D<c<c068`;P1B9280@00000000>8`;S8
h=R8`;P0D<c<c09VIVH00oooolc<c<c<c00?c<c<2@0000C<c<`:00003/c<
c09VIVH00oooolc<c<c<c004c<c<00=VIVKoooo<c<`02Lc<c0L00007c<c<
0P000003c<c<0000000000D00003c<c<0P00017<c<`00fIVI_ooolc<c01@
c<c<0HS0^058T8P1000000000hS0^<SPf8S0^01@c<c<0VIVIP03ooooc<c<
c<c<01g<c<`200005Lc<c09VIVH00oooolc<c<c<c004c<c<00=VIVKoooo<
c<`05/c<c0060000c<c<c<c<c<c<0000c<c<0`0001S<c<`00fIVI_ooolc<
c01@c<c<0HS0^058T8P1000000000hS0^<SPf8S0^01@c<c<0VIVIP03oooo
c<c<c<c<03C<c<`2IVIV00?oooo<c<c<c<`01<c<c003IVIVooooc<c<03O<
c<`00fIVI_ooolc<c01@c<c<0HS0^058T8P1000000000hS0^<SPf8S0^01@
c<c<0VIVIP03ooooc<c<c<c<03C<c<`2IVIV00?oooo<c<c<c<`01<c<c003
IVIVooooc<c<03O<c<`00fIVI_ooolc<c01@c<c<0HS0^058T8P100000000
0hS0^<SPf8S0^01@c<c<0VIVIP03ooooc<c<c<c<03C<c<`2IVIV00?oooo<
c<c<c<`01<c<c003IVIVooooc<c<03O<c<`00fIVI_ooolc<c01@c<c<0HS0
^058T8P1000000000hS0^<SPf8S0^01@c<c<0VIVIP03ooooc<c<c<c<03C<
c<`2IVIV00?oooo<c<c<c<`01<c<c003IVIVooooc<c<03O<c<`00fIVI_oo
olc<c01@c<c<0HS0^058T8P1000000000hS0^<SPf8S0^01@c<c<0VIVIP03
ooooc<c<c<c<03C<c<`2IVIV00?oooo<c<c<c<`01<c<c003IVIVooooc<c<
03O<c<`00fIVI_ooolc<c01@c<c<0HS0^058T8P1000000000hS0^<SPf8S0
^01@c<c<0VIVISOoool00fIVI/c<c?ooo`06c<c<00=VIVKoooo<c<`0=lc<
c003IVIVooooc<c<053<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h053<
c<`kIVIV1lc<c003IVIVoooooooo03Ooool00lc<c?ooolc<c01@c<c<0HS0
^058T8P1000000000hS0^<SPf8S0^01@c<c<>fIVIPO<c<`kIVIVD/c<c068
`;P1B9280@00000000>8`;S8h=R8`;P0olc<c23<c<`1R<2h0DR@R0400000
0003R<2hb>3HR<2h0?o<c<`Pc<c<0HS0^058T8P1000000000hS0^<SPf8S0
^03oc<c<8<c<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c23<c<`1
R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`Pc<c<0HS0^058T8P10000
00000hS0^<SPf8S0^03oc<c<8<c<c068`;P1B9280@00000000>8`;S8h=R8
`;P0olc<c23<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`Pc<c<
0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<8<c<c068`;P1B9280@00
000000>8`;S8h=R8`;P03Lc<c00JQj^7Ul:GQj^7VlRKOj]oUl:GOJMmUKnE
MimgSkN?LYMaRjn:KiA_QJN5KHm]QJN5IhMWOJMmIhMWQJN5IhMWOJMmIhMW
OJMmIhMWOJMm4lc<c=_oool:c<c<0HS0^058T8P1000000000hS0^<SPf8S0
^00<c<c<01aoZh2Kb9^7ZhNKb9]oZgnKb9]oZgnG`YMmYgfE_iEgWgN?]hmb
Ug6?]hm_UG25YhE]Sff5YhEWQfMmYgeWQfMmYgeWQfN5YhEWQfN5YhEWQfMm
YgdAc<c<00=VIVK<c<aVIVH0f6IVIP03ooooc<c<c<c<00S<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h00c<c<`079_7Vgn[Oi_8Vgn[Oi_8VhN[Qi_8
Vgn[OiO2UgfWOIFoUGNOMhngSg:GLH^_RVnEL8N[Qff?KGfWOFN7IhFWQFN7
IgfWOFN7IgfWOFN7IgfWOFf?KA7<c<`00fIVI_ooooooo`3Goooo00=VIVKo
ooo<c<`02Lc<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00=Qj^7
Ul:GQj^7VlRKQj^7Ul:GOj]oVlRKOj]oUl:GOJMmUKnEMimg00?<c<`036nD
KhN[Qff?KHFWQFN7IgfWOFN7IgfWOFN7IhFWQFN7IgfWOA7<c<`00fIVI_oo
ooooo`0Poooo10000;?oool00fIVI_ooolc<c009c<c<0HS0^058T8P10000
00000hS0^<SPf8S0^00<c<c<00bKb9]oZgnKb9]oZgnKb9^7ZhNKb9]oZgnK
b9]oZgnKai]mYgd403<000c<c<a_U6n7ZhM]Sff5YhEWQfN5YhEWQfMoZh1W
QfMmYgeWQfLAc<c<00=VIVKoooooool09?ooo`030000oooooooo0;3oool0
0fIVI_ooolc<c009c<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<
01b7ZhNKb9]oZgnKb9]oZh2G`YN7ZhNKb9^7ZhNKb9^0Zgl0<`3<c<bE_iEm
Ygf?]hl0<`3<c<a_U6n7ZhM]SfeoZh1WQfMoZh1WQfN5YhEWQfN5YhDAc<c<
00=VIVKoooooool00_ooo`<00005oooo0P000005oooo0000oooooooo0000
00;oool010000?ooooooo`0000;oool01@000?ooooooooooo`000003oooo
0P000003oooo0000oooo00Coool300001?ooo`8000000oooo`000?ooo`02
oooo00<0003oooooool00_ooo`8000000oooo`000?ooo`04oooo00@0003o
ooooool00004oooo0`0000?oool01@000?ooooooooooo`000003oooo00<0
003oooooool00oooo`040000oooooooo00000_ooo`040000oooooooooooo
0P000004oooo0000oooooooo0P000003oooo0000oooo00;oool010000?oo
ooooooooo`<00003oooo00D0003oooooooooool000000oooo`040000oooo
oooooooo0P000004oooo0000oooooooo0P000003oooo0000oooo00;oool2
00001?ooo`8000000oooo`000?ooo`0`oooo00=VIVKoooo<c<`02Lc<c068
`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00LVlRKOj]oVlRKQj^7Ul:G
Qj^7VlRKOj]oVlRKOj]oVlRK03<0c<c<OJMmUKnEN:1g03<0c<c<Rjn:KiE`
Qj^7KHm]QJN5IhMWOJMmIhMWOJMmIhMW4Lc<c005IVIVoooooooooooo0000
00?oool01@000?ooooooooooo`000002oooo0P0000;oool010000?oooooo
o`0000;oool010000?ooooooo`0000?oool010000?ooooooo`0000;oool2
00001?ooo`050000oooooooooooo000000;oool00`000?ooooooo`020000
0oooo`050000oooooooooooo000000;oool200001Oooo`040000oooooooo
00000oooo`050000oooooooooooo000000;oool01@000?ooooooooooo`00
0003oooo00<0003oooooool00oooo`040000oooooooo00000_ooo`040000
oooooooo00000_ooo`800002oooo00@0003oooooool00003oooo00@0003o
ooooool00003oooo00@0003oooooool00003oooo00D0003oooooooooool0
00000_ooo`030000oooooooo00800002oooo00@0003oooooool00002oooo
00@0003oooooool00002oooo00<0003oooooool00P00037oool00fIVI_oo
olc<c009c<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<00b7ZhNK
b9]oZgnKb9^0ZgnKb9]oZh2Kb9^7ZhNKb9^7ZhL0<`04c<c<00`0<`2?]hmg
WgN;[hY_UG25YhE]Sff5YhEWQfMmYgeWQfN5YhDAc<c<00AVIVKoooooool0
0005oooo00@0003oooooool00003oooo00@0003oooooool00002oooo00@0
003oooooool00002oooo00D0003oooooooooool000000_ooo`050000oooo
oooooooo000000Coool01@000?ooooooooooo`000002oooo00D0003ooooo
ooooool000000_ooo`030000oooo000000;oool01@000?ooooooooooo`00
0005oooo00@0003oooooool00003oooo00D0003oooooooooool000000_oo
o`050000oooooooooooo000000?oool00`000?ooooooo`03oooo00L0003o
ool0003oool0003oool000000_ooo`050000oooooooooooo000000;oool0
10000?ooooooo`0000?oool010000?ooooooo`0000Koool01@000?oooooo
ooooo`000003oooo00@0003oooooool00003oooo00@0003oooooool00002
oooo00@0003oooooool00005oooo00D0003oooooooooool00000<Oooo`03
IVIVooooc<c<00W<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`0
39O2UhN[Qi_8Vgn[Oi_8Vgn[Oi_8Vgn[Oi_8Vh2[Oi_8VhN[Q`@0<`0039Fo
UGNOMhngSg:GLHngSfnDKhN[Qff?KHFWQFN7IgfWOFN7Ia7<c<`016IVI_oo
ooooo`0000Woool400000_ooo`040000oooooooo00000_ooo`040000oooo
oooo00000oooo`040000oooooooo00000oooo`030000oooooooo00Koool0
10000?ooooooooooo`@00002oooo00<0003oool000000oooo`@00005oooo
00@0003oooooool00003oooo00D0003oooooooooool000000_ooo`050000
oooooooooooo000000?oool00`000?ooooooo`03oooo00L0003oool0003o
ool0003oool000000oooo`@00002oooo00@0003oooooool00003oooo00<0
003oooooool01@0000;oool01@000?ooooooooooo`000003oooo00@0003o
ooooooooool400000_ooo`040000oooooooo00000_ooo`030000oooooooo
00Coool40000<Oooo`03IVIVooooc<c<00W<c<`1R<2h0DR@R04000000003
R<2hb>3HR<2h00c<c<`078N[Qi_8Vgn[Oi_8VhN[QiO2UhN[QiO2UhN[Qi_8
Vgn[Oi_8VhN[Qi_8VhN[QiO2UgfWOIFoUGNOMhngSg:GLHngSfnDKhFWQFf?
KHFWQFN7IhFWQA7<c<`016IVI_ooooooo`0000coool010000?ooooooo`00
00;oool010000?ooooooo`0000;oool01@000?ooooooooooo`000002oooo
00D0003oooooooooool000002?ooo`030000oooooooo00Coool01P000?oo
ooooo`000?ooo`0000Koool00`000?ooooooo`03oooo00@0003oooooool0
0003oooo00D0003oooooooooool000000_ooo`050000oooooooooooo0000
00?oool00`000?ooooooo`03oooo00L0003oool0003oool0003oool00000
1_ooo`040000oooooooo00000_ooo`050000oooooooooooo000000;oool0
1@000?ooooooooooo`000002oooo00D0003oooooooooool000000oooo`03
0000oooooooo00Coool010000?ooooooo`0000;oool010000?ooooooo`00
00Woool00`000?ooooooo`0_oooo00=VIVKoooo<c<`02Lc<c068`;P1B928
0@00000000>8`;S8h=R8`;P03<c<c00=VlNKOj]oVlRKQj^7VlRKOj^0VlRK
Oj]oVlRKP:]oVlRKQj^7VlRK00?<c<`039_7VgfWOIFoUGNOMhngSgNOMh^_
RW:GLHN[Qff?KHFWQFN7Ia7<c<`016IVI_ooooooo`0000Soool01@000?oo
ooooooooo`000002oooo00@0003oooooool00002oooo00<0003oooooool0
0P0000;oool010000?ooooooo`0000;oool200002?ooo`040000oooooooo
00000oooo`030000oooo000000?oool00`000?ooo`000003oooo00<0003o
ooooool00oooo`030000oooooooo00800002oooo00D0003oooooooooool0
00000_ooo`800002oooo0P0000;oool00`000?ooooooo`03oooo00L0003o
ool0003oool0003oool000000_ooo`050000oooooooooooo000000;oool0
0`000?ooooooo`0200000_ooo`040000oooooooo00000oooo`030000oooo
oooo00800002oooo0P0000;oool010000?ooooooo`0000?oool010000?oo
ooooo`0000;oool010000?ooooooo`0000;oool010000?ooooooo`0000?o
ool00`000?ooooooo`0_oooo00=VIVKoooo<c<`02Lc<c068`;P1B9280@00
000000>8`;S8h=R8`;P03<c<c00<Oj]oVlNKQj^7Ul:HOj]oVlRKOj]oVlRK
Oj]oVlRKOj]oVlRK100c000<c<c<VlNKOJMmUKnEOJMmSkN?LYMaRjn:LYMa
Qj^7KHm]QJN54Lc<c004IVIVoooooooo00001Oooo`040000oooooooooooo
0`0000?oool010000?ooooooo`0000;oool01@000?ooooooo`000?ooo`02
00001?ooo`8000000oooo`000?ooo`07oooo00@0003oooooooooool30000
0_ooo`050000oooooooooooo000000;oool300001Oooo`<000001?ooo`00
0?ooo`0000;oool300000oooo`040000oooo000000000_ooo`800006oooo
0P0000?oool200000oooo`<00002oooo0`000003oooo0000oooo00800004
oooo0`0000?oool010000?ooo`00000000;oool200001?ooo`<00002oooo
0`000003oooo0000oooo00;oool200001?ooo`<0000boooo00=VIVKoooo<
c<`02Lc<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00LUKnEOj]o
Ul:GQj^7VlRKQj^7Ul:GQj^7Ul:GQj^7Ul:G03<0c<c<Qj^7Ul:GQj^703<0
c<c<VlNKOJMmUKnEMimgSkN?MimgRjn:KiE`Qj^7KHm]4Lc<c005IVIVoooo
oooooooo000000?oool00`000?ooooooo`08oooo00@0003oooooool0000I
oooo00<0003oooooool05_ooo`030000oooooooo01Woool200000oooo`80
0009oooo00@0003oooooool0000Ooooo00<0003oooooool0?oooo`03IVIV
ooooc<c<00W<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`077fW
OIFoUGfWOI_7Vgn[Oi_8VhN[Qi_8Vgn[P9O2UhN[Q`0c0<c<c9O2V8N[QiO2
V8N[Q`0c0<c<c9O2UgfWOIFoUGfWOHngSgNOMh^_RW:GLHN[Qa7<c<`00fIV
I_ooooooo`02oooo0`0000_oool010000?ooooooo`0000;oool00`000?oo
ooooo`0Doooo00<0003oooooool05oooo`80000Ioooo00<0003oooooool0
0oooo`030000oooooooo00Ooool010000?ooooooo`0001ooool010000?oo
ooooo`0003koool00fIVI_ooolc<c009c<c<0HS0^058T8P1000000000hS0
^<SPf8S0^00<c<c<01bE_iEmYgfE_iEoZgnKai]oZgnKb9^7ZhNG`YR7ZhNK
b9^0Zgl0<`3<c<bKb9^7ZhNG`YN7ZhL0<`3<c<bKai]mYgfE_iEhX7N?]hmg
WgN;[hY_UG0Ac<c<00=VIVKoooooool0eoooo`03IVIVooooc<c<00W<c<`1
R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`077NOMi2gT7fWOIFoUGfW
OI_7Vgn[Oi_7VhN[QiO2Ugn[Oi_8Vgn[O`0c0<c<c9_8VhN[Qi_8Vgn[P00c
0<c<c9_7VgfWOIFoUGfWOHngSgNOMh^_RQ7<c<`00fIVI_ooooooo`3Goooo
00=VIVKoooo<c<`02Lc<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<
c00LSkN?MimgSkN@OJMmUKnEOJMmVlNKOj]oVlNKQj^7VlRKOj]oVlRKQj^7
03<0c<c<VlRKQj^7VlRKQj^703<0c<c<VlNKOJMmUKnEMimgSkN?Mimg4Lc<
c003IVIVoooooooo0=Ooool00fIVI_ooolc<c009c<c<0HS0^058T8P10000
00000hS0^<SPf8S0^00<c<c<01a_UG2?]hmgWgN?]i1mYgfE_iEoZgnKai]o
Zh2Kb9^7ZhNKb9]oZh2G`YMoZh00<`3<c<bKb9]oZgnKb9/0<`3<c<b0ZgnK
ai]oZgnE_iEmYgf?]hlAc<c<00=VIVKoooooool0eoooo`03IVIVooooc<c<
00W<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`02H^_RW:GLHng
SgNOMhngT7fWOIFoUGfWOI_7V`02c<c<0167ZhNG`YN7ZhNKb9]oZgl0<`3<
c<bKb9^7ZhNKb9/0<`3<c<aoZgnG`YMmYgfE_iEmYgd04Lc<c003IVIVoooo
oooo0=Ooool00lc<c?ooolc<c009c<c<0HS0^058T8P1000000000hS0^<SP
f8S0^00<c<c<00Q_U6n;[hY_UG2?]hmgWgN?]hmmYgfE_iD303<0017<c<b7
ZhNKb9]oZgnKb9^7ZhL0<`3<c<bKb9^0Zgl0<`3<c<bKb9]oZgnKai]oZgnE
_iD04Lc<c=]VIVH;c<c<0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<
01b5YhE_U6n;[hYbUg6?]hmgWgN@]i00<`3<c<amYgfKai/0<`3<c<b7ZhNK
b9]oZgnKb9/0<`3<c<aoZgnKb9/0<`3<c<b7ZhNKb9]oZh2G`YMoZgogc<c<
0HS0^058T8P1000000000hS0^<SPf8S0^00<c<c<01aWRFN5YhE]Sff;[hY_
UG2?]hmgWgL0<`3<c<bE_iEmYgd0<`3<c<bKb9^7ZhNKb9^7ZhL0<`3<c<bG
`YN7ZhL0<`3<c<bKb9]oZgnKb9]oZgnKai_gc<c<0HS0^058T8P100000000
0hS0^<SPf8S0^00<c<c<00f5YhEWQfN5YhE]Sff;[hYbUg6?]hl0<`3<c<am
YgfE_iEmYgd0<`000lc<c00<03<0c<c<VlRKQj^7VlRK03<0c<c<Qj^7VlRK
Qj^7VlRKOj]omlc<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00=
IhMWQJN5IhMWQJN5KHm]Rjn:KiE`SkN?03<0c<c<OJMmUKnEOJMm00<0<`00
382[Oi_8Vgn[Oi_8V`0c0<c<c8N[QiO2V82[Oi_8Vh2[Oi_8VoO<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h00c<c<`077fWOFN7IhFWQFN8J8FWQFf?
KH^_RW:GL@0c0<c<c9FoUGfWOIFoUGn[OiO2UhN[QiO2UhN[Qi_8VhN[Q`0c
0<c<c9_8Vgn[Oi_8Vgn[Oi_8VhN[QoO<c<`1R<2h0DR@R04000000003R<2h
b>3HR<2h00c<c<`02VN7IhFWQFN7IgfWOFf?KHFWQFf?KH^_RW:GL@0c00;<
c<`01GfWOIFoUGfWOIO2UhN[Q`02c<c<00T0<`3<c<bKb9^0ZgnKb9^7ZhNK
b9^7ZhNKb9/0mlc<c068`;P1B9280@00000000>8`;S8h=R8`;P03<c<c00:
OJMmIhMWOJMmIhMWOj^0IhMWQJN5KHm]Rjn:KiE`0P0c00G<c<`203<000Uo
ZgnKb9]oZgnKb9]oZh2Kb9]oZgnKai^0Zgl0mlc<c068`;P1B9280@000000
00>8`;S8h=R8`;P03<c<c00<IhMWQJN5IhMWQJN5IhMWQJN5IhMWQJN5KHm]
Rjn:KiA_SkN?1@0c000;Ul:GQj^7VlRKQj^7VlRKQj^7Ul:GOj]oVlRKQj^7
VlRK0?O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00c<c<`077fWOFN7
IgfWOFN7IgfWOFN7IgfWOFN7IhFWQFf?KH^_RVnDKhngSgNOMhngSgNOMiFo
UGfWOIO2Ugn[OiO2V7n[P9_8VhN[Qi_8Vh2[Oi_8Vgn[OoO<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h00c<c<`076N7IhFWQFN7IgfWOFN7IhFWQFN7
IgfWOFf?KHFWQFf?KH^_RW:GLHngSgNOMhngSgfWOIFoUGfWOIO2UhN[Qi_8
Vgn[Oi_8VhN[Qi_8Vgn[Oi_7VoO<c<`1R<2h0DR@R04000000003R<2hb>3H
R<2h00c<c<`077fWOFN7IgfWOFN7IgfWOFN7IgfWOFN7IgfWOFN7IhFWQFf?
KH^_RVnEL8^_RWNOMhngSgfWOIFoUGfWOIO2Ugn[Oi_7Vgn[Oi_8Vgn[Oi_8
VhN[QoO<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h00g<c<`06XFWQFN7
IhFWQFN7IhFWQFN7IhFWQFN7IhFWQFN9IhFWQFf?KH^_RW:GLHngSgNOMi2g
T7fWOIFoUGfWOI_7VhN[Qi_7VhN[Qi_8VhN[QoS<c<`1R<2h0DR@R0400000
0003R<2hb>3HR<2h0?o<c<`Pc<c<0HS0^058T8P1000000000hS0^<SPf8S0
^03oc<c<8<c<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c23<c<`1
R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`Pc<c<0HS0^058T8P10000
00000hS0^<SPf8S0^03oc<c<8<c<c068`;P1B9280@00000000>8`;S8h=R8
`;P0olc<c23<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`Pc<c<
0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<8<c<c068`;P1B9280@00
000000>8`;S8h=R8`;P0olc<c23<c<`1R<2h0DR@R04000000003R<2hb>3H
R<2h0?o<c<`Pc<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oR<2h8HS0
^058T8P1000000000hS0^<SPf8S0^002002000@00H000X000X000h4200B1
00L01H401X801X801h81288128<12H<00P4:P`040@^40@b40@b40@f40P4>
Q@040Pn50Q250Q250Q660P8BQP070Q>60QB70QB70QF70QJ70aJ80aN80083
68P010<IR@<JR@<JR@<KR@8378X01@<MRP@NRP@OR`@OR`@PR`02126;00X4
8X`48h`48h`498`49Hd59Hd59Xd59hd59hh5:8h21BV>00@5:Xl5:hl5:hl5
;8l21Rf@00@6;Y06;i06;i46<9421S6A00L6<Y46<i86<i87=987=I87=I<7
=Y<00PLgT`041cRD1cVD1cVD1cZD0PLkU@0823bE23fE23jF23jF23nF242F
242G246G0PQ2U`0724>G2DBH2DBH2DFH2DJH2DJI2DNI0089B9T010U9VPU:
VPU:VPY;VP8:C9/010Y=V`Y>V`Y>W0Y?W08:D9`01`YAW@YBW@]BW@]CW@]D
W@]DWP]EWP022eJN00D;Eil;F9l;F9l;FIl<FZ000PaKX00:35bP35fQ35fQ
35jQ35nQ35nR362R366R3F6R3F:R0PeSX`043FBS3FFS3FFT3FJT0PeWY004
3FRU3VVU3VVU3VZU0Pi[YP043VbV3VfV3VfW3VjW0Pi_Y`073g2X3g6X3g6X
3g:X3g>X3g>Y3gBY008?MJT01@mfZPmgZPmgZQ1hZQ1iZ`0247Z[00L@Nj/@
O:`@O:`@OJ`@OZ`@OZd@Ojd00Q60[@074H6^4H:^4H:^4H>^4HB^4HB_4HF_
008AQZl011:7/1:8/1:8/1:9/08BR[401a:;/A:</A:</Q:=/Q:>/Q>>/Q>?
/`024i2c00@CTK<CT[@CT[@CTk@24iBd00DCUKDDU[DDUkDDUkDDV;H00QBI
]P0759Zf59^g59^g59bg59fg5Ifh5Ijh008EWkP011FP^AFQ^AFQ^AFR^@8E
XkX011FT^QJU^QJU^QJV^`8FYk/01aJX^aJY_1JY_1JZ_1J[_1J[_AN/_@02
5jfm00@G[[hG[khG[khG/;h25k6o00<G/[lG/klH]<004aRd`068`;P1B928
0@00000000>8`;S8h=R8`;P00P00P004006000:000:000>10P04P@0700F1
00J200J200N20@R20@R30@V300812X<0104;Q04<Q04<Q04=Q0813XD0108?
Q@8@Q@8@Q@8AQP824XH01`8CQP8DQ`8DQ`8EQ`8FQ`<FR0<GR0020aR800@3
6HT36XT36XT36hT20ab:00D37HX47XX47h/47h/488/00P@QR`0:12:<12><
12><12B<12F=1BF=1BJ=1BN=1BN>1BR>0PDYSP041BZ?1B^?1B^?1Bb?0PH]
T0041Rj@1Rn@1RnA1S2A0PHaT@071S:A1S>B1S>B1cBB1cFB1cFC1cJC0087
=i<010LhU0LiU0LiU0LjU087>iD020PlU@PmU@PnUPPnUPPoUPQ0UPQ0U`Q1
U`88@YL01`Q3U`U4V0U4V0U5V0U6V0U6V@U7V@022DRI00@9BIX9BYX9BYX:
BiX22TbK00@:CI/:CY/:CY`:Ci`22U2L00L:DId:DYd;DYd;Did;E9d;E9h;
EIh00P]FWP052eNO2eRO2eRO2eVO35ZP008<Fj002PaLX0aMX@aMX@aNX@aO
X@aOXPaPXPaQXPeQXPeRXP8=Hj<010eTX`eUX`eUY0eVY08=Ij@010eXY@iY
Y@iYY@iZY@8>JjH010i/YPi]YPi]Y`i^Y`8>KjL01`m`Z0maZ0maZ0mbZ0mc
Z0mcZ@mdZ@023gFY00D?MZX?MjX?MjX@N:X@NJ/00Q1jZ`0747^[47b/47b/
47f/47j/47j]47n]008AP:d01a61[Q62[Q62[Q63[Q64[Q64[a65[`024HJ_
00@BQk0BR;0BR;0BRK024XZa00LBRk4BS;4BS;8BSK8BS[8CS[8CSk<00Q>@
/`044i6c4i:d4i:d4i>d0Q>D]0054iFe59Je59Ne59Ne59Rf008DVKH01aBJ
]QBK]aBK]aBL]aBM]aFM^1FN^0025Inh00@EX;TEXKTEXKTEX[T25J>j00@E
Y;XFYKXFYKXFY[/25ZNk00LFZ;/FZK`FZK`FZ[`FZk`FZkdG[;d00QN]_@04
5jjn5jnn5jnn5k2n0QNa_`035k:o5k>o6;C001<H]<01R<2h0DR@R0400000
0003R<2hb>3HR<2h008008001001P002P002P003P@8018401`05P@06PP06
PP07PP48PP48P`49P`020@Z300@12h@138@138@13H@20@j500@23hD248D2
48D24HH20Q:600L24hH258L258L25HL25XL35XP35hP00P<HR0040aV90aZ9
0aZ90a^90P<LRP050af:11j:11n;11n;122;00848H/02P@RS0@SS0@SS0@T
S0@US@DUS@DVS@DWS@DWSPDXSP85:Hh010DZS`D[S`D[S`D/S`86;I0010H^
T0H_T0H_T@H`T@86<I401`HbT@HcTPHcTPLdTPLeTPLeT`LfT`021cNC00@7
>9@7>I@7>I@7>Y@21c^E00P8?9D8?ID8?YH8?YH8?iH8@9H8@9L8@IL224:G
00L8@iL9A9P9A9P9AIP9AYP9AYT9AiT00PU8V@042DVJ2DZJ2DZJ2T^J0PY<
V`042TfK2TjK2TjL2TnL0PY@W0072U6M2U:M2e:M2e>M2eBM2eBN2eFN008;
EYh01@]GW`]HW`]HW`]IW`aJX00235^P00X<G:0<GJ4<GJ4<GZ4<Gj4<Gj8<
H:8<HJ8=HJ8=HZ823F>S00@=I:<=IJ<=IJ@=IZ@23FNT00@=J:D>JJD>JJD>
JZD23V^V00@>K:H>KJH>KJL>KZL23VnW00L?L:P?LJP?LJP?LZP?LjP?LjT?
M:T00PmeZ@053gJZ3gNZ3gNZ47RZ47V[008@NZ/01a1kZa1l[11l[11m[11n
[11n[A1o[@024H2]00LAPJhAPZhAPZhAPjhAQ:hAQ:lAQJl00Q66[`044XN`
4XR`4XR`4XV`0Q::/@074X^a4Xba4Xbb4Xfb4Xjb4hjb4hnc008CT;<011>A
/a>B]1>B]1>C]08CU;@01A>E]ABF]ABG]ABG]ABH]P0259Vf00LDV[HDVkLD
VkLDW;LDWKLEWKPEW[P00QFO^0045J2i5J6i5J6i5J:i0QFS^P045JBj5ZFj
5ZFj5ZJk0QJW^`075ZRk5ZVl5ZVl5ZZl5Z^l5Z^m5jbm008G[Kd011N^_QN_
_QN__QN`_P8G/Kl011Nb_aNc_aRd`1Rd`10000026;C00HS0^058T8P10000
00000hS0^<SPf8S0^002002000@00H000X000X000h4200B100L01H401X80
1X801h81288128<12H<00P4:P`040@^40@b40@b40@f40P4>Q@040Pn50Q25
0Q250Q660P8BQP070Q>60QB70QB70QF70QJ70aJ80aN8008368P010<IR@<J
R@<JR@<KR@8378X01@<MRP@NRP@OR`@OR`@PR`02126;00X48X`48h`48h`4
98`49Hd59Hd59Xd59hd59hh5:8h21BV>00@5:Xl5:hl5:hl5;8l21Rf@00@6
;Y06;i06;i46<9421S6A00L6<Y46<i86<i87=987=I87=I<7=Y<00PLgT`04
1cRD1cVD1cVD1cZD0PLkU@0823bE23fE23jF23jF23nF242F242G246G0PQ2
U`0724>G2DBH2DBH2DFH2DJH2DJI2DNI0089B9T010U9VPU:VPU:VPY;VP8:
C9/010Y=V`Y>V`Y>W0Y?W08:D9`01`YAW@YBW@]BW@]CW@]DW@]DWP]EWP02
2eJN00D;Eil;F9l;F9l;FIl<FZ000PaKX00:35bP35fQ35fQ35jQ35nQ35nR
362R366R3F6R3F:R0PeSX`043FBS3FFS3FFT3FJT0PeWY0043FRU3VVU3VVU
3VZU0Pi[YP043VbV3VfV3VfW3VjW0Pi_Y`073g2X3g6X3g6X3g:X3g>X3g>Y
3gBY008?MJT01@mfZPmgZPmgZQ1hZQ1iZ`0247Z[00L@Nj/@O:`@O:`@OJ`@
OZ`@OZd@Ojd00Q60[@074H6^4H:^4H:^4H>^4HB^4HB_4HF_008AQZl011:7
/1:8/1:8/1:9/08BR[401a:;/A:</A:</Q:=/Q:>/Q>>/Q>?/`024i2c00@C
TK<CT[@CT[@CTk@24iBd00DCUKDDU[DDUkDDUkDDV;H00QBI]P0759Zf59^g
59^g59bg59fg5Ifh5Ijh008EWkP011FP^AFQ^AFQ^AFR^@8EXkX011FT^QJU
^QJU^QJV^`8FYk/01aJX^aJY_1JY_1JZ_1J[_1J[_AN/_@025jfm00@G[[hG
[khG[khG/;h25k6o00DG/[lG/klH]<0H]<38h=P03TR@R00500006;C06;C0
R<2hB928004000000003R<2hb>3HR<2h008008001?ooo`02P002P003P@80
18401`05P@06PP06PP07P_ooo`48Poooo`020@Z300@12h@138@138@13H@2
oooo00@23hD248D248D24HH20Q:600L24hH258L258L25HL25XL35XP35hP0
0P<HR0040aV90aZ90aZ90a^90P<LRP050af:11j:11n;11n;122;00848H/0
2P@RS0@SS0@SS0@TS0@US@DUS@DVS@DWS@DWSPDXSP85:Hh010DZS`D[S`D[
S`D/S`86;I0010H^T0H_T0H_T@H`T@86<I401`HbT@HcTPHcTPLdTPLeTPLe
T`LfT`021cNC00@7>9@7>I@7>I@7>Y@21c^E00P8?9D8?ID8?YH8?YH8?iH8
@9H8@9L8@IL224:G00L8@iL9A9P9A9P9AIP9AYP9AYT9AiT00PU8V@042DVJ
2DZJ2DZJ2T^J0PY<V`042TfK2TjK2TjL2TnL0PY@W0072U6M2U:M2e:M2e>M
2eBM2eBN2eFN008;EYh01@]GW`]HW`]HW`]IW`aJX00235^P00X<G:0<GJ4<
GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HJ8=HZ823F>S00@=I:<=IJ<=IJ@=IZ@23FNT
00@=J:D>JJD>JJD>JZD23V^V00@>K:H>KJH>KJL>KZL23VnW00L?L:P?LJP?
LJP?LZP?LjP?LjT?M:T00PmeZ@053gJZ3gNZ3gNZ47RZ47V[008@NZ/01a1k
Za1l[11l[11m[11n[11n[A1o[@024H2]00LAPJhAPZhAPZhAPjhAQ:hAQ:lA
QJl00Q66[`044XN`4XR`4XR`4XV`0Q::/@074X^a4Xba4Xbb4Xfb4Xjb4hjb
4hnc008CT;<011>A/a>B]1>B]1>C]08CU;@01A>E]ABF]ABG]ABG]ABH]P02
59Vf00LDV[HDVkLDVkLDW;LDWKLEWKPEW[P00QFO^0045J2i5J6i5J6i5J:i
0QFS^P045JBj5ZFj5ZFj5ZJk0QJW^`075ZRk5ZVl5ZVl5ZZl5Z^l5Z^m5jbm
008G[Kd011N^_QN__QN__QN`_P8G/Kl01ANb_aNc_aRd`1Rd`<SPf00=R<2h
00I8T8P0000H]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^002002000@0
0H3oool00X000h4200B100X01H401X801X;oool1288128<12H?oool12X<1
2h@20@b400@13H@13XD13XGoool20Q2500@24HH24XH24XH24hH20QB700@2
5HL25XL35XP35hP20aR800@36HT36XT36XT36hT20ab:00D37HX47XX47h/4
7h/488/00P@QR`0:12:<12><12><12B<12F=1BF=1BJ=1BN=1BN>1BR>0PDY
SP041BZ?1B^?1B^?1Bb?0PH]T0041Rj@1Rn@1RnA1S2A0PHaT@071S:A1S>B
1S>B1cBB1cFB1cFC1cJC0087=i<010LhU0LiU0LiU0LjU087>iD020PlU@Pm
U@PnUPPnUPPoUPQ0UPQ0U`Q1U`88@YL01`Q3U`U4V0U4V0U5V0U6V0U6V@U7
V@022DRI00@9BIX9BYX9BYX:BiX22TbK00@:CI/:CY/:CY`:Ci`22U2L00L:
DId:DYd;DYd;Did;E9d;E9h;EIh00P]FWP052eNO2eRO2eRO2eVO35ZP008<
Fj002PaLX0aMX@aMX@aNX@aOX@aOXPaPXPaQXPeQXPeRXP8=Hj<010eTX`eU
X`eUY0eVY08=Ij@010eXY@iYY@iYY@iZY@8>JjH010i/YPi]YPi]Y`i^Y`8>
KjL01`m`Z0maZ0maZ0mbZ0mcZ0mcZ@mdZ@023gFY00D?MZX?MjX?MjX@N:X@
NJ/00Q1jZ`0747^[47b/47b/47f/47j/47j]47n]008AP:d01a61[Q62[Q62
[Q63[Q64[Q64[a65[`024HJ_00@BQk0BR;0BR;0BRK024XZa00LBRk4BS;4B
S;8BSK8BS[8CS[8CSk<00Q>@/`044i6c4i:d4i:d4i>d0Q>D]0054iFe59Je
59Ne59Ne59Rf008DVKH01aBJ]QBK]aBK]aBL]aBM]aFM^1FN^0025Inh00@E
X;TEXKTEXKTEX[T25J>j00@EY;XFYKXFYKXFY[/25ZNk00LFZ;/FZK`FZK`F
Z[`FZk`FZkdG[;d00QN]_@045jjn5jnn5jnn5k2n0QNa_`055k:o5k>o6;C0
6;C0b>3H00f8`;P01TR@R00001Rd`1Rd`8S0^4R@R04000000003R<2hb>3H
R<2h008008001001P002P?ooo`03P@8018402P05P@06P_ooo`07PP48PP48
P`49P`4:Poooo`4;Q08138@0104=Q04>Q@4>QOooo`8248D0108AQP8BQP8B
QP8CQP8258L0108EQ`8FQ`<FR0<GR08368P010<IR@<JR@<JR@<KR@8378X0
1@<MRP@NRP@OR`@OR`@PR`02126;00X48X`48h`48h`498`49Hd59Hd59Xd5
9hd59hh5:8h21BV>00@5:Xl5:hl5:hl5;8l21Rf@00@6;Y06;i06;i46<942
1S6A00L6<Y46<i86<i87=987=I87=I<7=Y<00PLgT`041cRD1cVD1cVD1cZD
0PLkU@0823bE23fE23jF23jF23nF242F242G246G0PQ2U`0724>G2DBH2DBH
2DFH2DJH2DJI2DNI0089B9T010U9VPU:VPU:VPY;VP8:C9/010Y=V`Y>V`Y>
W0Y?W08:D9`01`YAW@YBW@]BW@]CW@]DW@]DWP]EWP022eJN00D;Eil;F9l;
F9l;FIl<FZ000PaKX00:35bP35fQ35fQ35jQ35nQ35nR362R366R3F6R3F:R
0PeSX`043FBS3FFS3FFT3FJT0PeWY0043FRU3VVU3VVU3VZU0Pi[YP043VbV
3VfV3VfW3VjW0Pi_Y`073g2X3g6X3g6X3g:X3g>X3g>Y3gBY008?MJT01@mf
ZPmgZPmgZQ1hZQ1iZ`0247Z[00L@Nj/@O:`@O:`@OJ`@OZ`@OZd@Ojd00Q60
[@074H6^4H:^4H:^4H>^4HB^4HB_4HF_008AQZl011:7/1:8/1:8/1:9/08B
R[401a:;/A:</A:</Q:=/Q:>/Q>>/Q>?/`024i2c00@CTK<CT[@CT[@CTk@2
4iBd00DCUKDDU[DDUkDDUkDDV;H00QBI]P0759Zf59^g59^g59bg59fg5Ifh
5Ijh008EWkP011FP^AFQ^AFQ^AFR^@8EXkX011FT^QJU^QJU^QJV^`8FYk/0
1aJX^aJY_1JY_1JZ_1J[_1J[_AN/_@025jfm00@G[[hG[khG[khG/;h25k6o
00DG/[lG/klH]<0H]<38h=P00hS0^0800004R<2h0P0000:8`;P01TR@R000
01Rd`1Rd`8S0^4R@R04000000003R<2hb>3HR<2h008008001001P002P002
P?ooo`8018401`05POooo`06PP07PP48PP48P`49P`020@Z300Coool138@1
38@13H@20@j500Coool248D248D24HH20Q:600L24hH258L258L25HL25XL3
5XP35hP00P<HR0040aV90aZ90aZ90a^90P<LRP050af:11j:11n;11n;122;
00848H/02P@RS0@SS0@SS0@TS0@US@DUS@DVS@DWS@DWSPDXSP85:Hh010DZ
S`D[S`D[S`D/S`86;I0010H^T0H_T0H_T@H`T@86<I401`HbT@HcTPHcTPLd
TPLeTPLeT`LfT`021cNC00@7>9@7>I@7>I@7>Y@21c^E00P8?9D8?ID8?YH8
?YH8?iH8@9H8@9L8@IL224:G00L8@iL9A9P9A9P9AIP9AYP9AYT9AiT00PU8
V@042DVJ2DZJ2DZJ2T^J0PY<V`042TfK2TjK2TjL2TnL0PY@W0072U6M2U:M
2e:M2e>M2eBM2eBN2eFN008;EYh01@]GW`]HW`]HW`]IW`aJX00235^P00X<
G:0<GJ4<GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HJ8=HZ823F>S00@=I:<=IJ<=IJ@=
IZ@23FNT00@=J:D>JJD>JJD>JZD23V^V00@>K:H>KJH>KJL>KZL23VnW00L?
L:P?LJP?LJP?LZP?LjP?LjT?M:T00PmeZ@053gJZ3gNZ3gNZ47RZ47V[008@
NZ/01a1kZa1l[11l[11m[11n[11n[A1o[@024H2]00LAPJhAPZhAPZhAPjhA
Q:hAQ:lAQJl00Q66[`044XN`4XR`4XR`4XV`0Q::/@074X^a4Xba4Xbb4Xfb
4Xjb4hjb4hnc008CT;<011>A/a>B]1>B]1>C]08CU;@01A>E]ABF]ABG]ABG
]ABH]P0259Vf00LDV[HDVkLDVkLDW;LDWKLEWKPEW[P00QFO^0045J2i5J6i
5J6i5J:i0QFS^P045JBj5ZFj5ZFj5ZJk0QJW^`075ZRk5ZVl5ZVl5ZZl5Z^l
5Z^m5jbm008G[Kd011N^_QN__QN__QN`_P8G/Kl01ANb_aNc_aRd`1Rd`<SP
f004R<2h0P0000:8`;P200000hS0^006B92800006;C06;C0R<2hB9280@00
000000>8`;S8h=R8`;P00P00P004006000:000:0oooo0P04P@0700F1oooo
00J200N20@R20@R30@V300812X<01?ooo`4<Q04<Q04=Q0813XD01?ooo`8@
Q@8@Q@8AQP824XH01`8CQP8DQ`8DQ`8EQ`8FQ`<FR0<GR0020aR800@36HT3
6XT36XT36hT20ab:00D37HX47XX47h/47h/488/00P@QR`0:12:<12><12><
12B<12F=1BF=1BJ=1BN=1BN>1BR>0PDYSP041BZ?1B^?1B^?1Bb?0PH]T004
1Rj@1Rn@1RnA1S2A0PHaT@071S:A1S>B1S>B1cBB1cFB1cFC1cJC0087=i<0
10LhU0LiU0LiU0LjU087>iD020PlU@PmU@PnUPPnUPPoUPQ0UPQ0U`Q1U`88
@YL01`Q3U`U4V0U4V0U5V0U6V0U6V@U7V@022DRI00@9BIX9BYX9BYX:BiX2
2TbK00@:CI/:CY/:CY`:Ci`22U2L00L:DId:DYd;DYd;Did;E9d;E9h;EIh0
0P]FWP052eNO2eRO2eRO2eVO35ZP008<Fj002PaLX0aMX@aMX@aNX@aOX@aO
XPaPXPaQXPeQXPeRXP8=Hj<010eTX`eUX`eUY0eVY08=Ij@010eXY@iYY@iY
Y@iZY@8>JjH010i/YPi]YPi]Y`i^Y`8>KjL01`m`Z0maZ0maZ0mbZ0mcZ0mc
Z@mdZ@023gFY00D?MZX?MjX?MjX@N:X@NJ/00Q1jZ`0747^[47b/47b/47f/
47j/47j]47n]008AP:d01a61[Q62[Q62[Q63[Q64[Q64[a65[`024HJ_00@B
Qk0BR;0BR;0BRK024XZa00LBRk4BS;4BS;8BSK8BS[8CS[8CSk<00Q>@/`04
4i6c4i:d4i:d4i>d0Q>D]0054iFe59Je59Ne59Ne59Rf008DVKH01aBJ]QBK
]aBK]aBL]aBM]aFM^1FN^0025Inh00@EX;TEXKTEXKTEX[T25J>j00@EY;XF
YKXFYKXFY[/25ZNk00LFZ;/FZK`FZK`FZ[`FZk`FZkdG[;d00QN]_@045jjn
5jnn5jnn5k2n0QNa_`055k:o5k>o6;C06;C0b>3H00F8`;P4000018S0^006
B92800006;C06;C0R<2hB9280@00000000>8`;S8h=R8`;P00P00P0070060
00:000:000>1oooo00B1oooo00801X801007PP48PP48P`49P`812X<0104;
Q?ooo`4<Q04=Q0813XD01?ooo`8@Q@8@Q@8AQP824XH01`8CQP8DQ`8DQ`8E
Q`8FQ`<FR0<GR0020aR800@36HT36XT36XT36hT20ab:00D37HX47XX47h/4
7h/488/00P@QR`0:12:<12><12><12B<12F=1BF=1BJ=1BN=1BN>1BR>0PDY
SP041BZ?1B^?1B^?1Bb?0PH]T0041Rj@1Rn@1RnA1S2A0PHaT@071S:A1S>B
1S>B1cBB1cFB1cFC1cJC0087=i<010LhU0LiU0LiU0LjU087>iD020PlU@Pm
U@PnUPPnUPPoUPQ0UPQ0U`Q1U`88@YL01`Q3U`U4V0U4V0U5V0U6V0U6V@U7
V@022DRI00@9BIX9BYX9BYX:BiX22TbK00@:CI/:CY/:CY`:Ci`22U2L00L:
DId:DYd;DYd;Did;E9d;E9h;EIh00P]FWP052eNO2eRO2eRO2eVO35ZP008<
Fj002PaLX0aMX@aMX@aNX@aOX@aOXPaPXPaQXPeQXPeRXP8=Hj<010eTX`eU
X`eUY0eVY08=Ij@010eXY@iYY@iYY@iZY@8>JjH010i/YPi]YPi]Y`i^Y`8>
KjL01`m`Z0maZ0maZ0mbZ0mcZ0mcZ@mdZ@023gFY00D?MZX?MjX?MjX@N:X@
NJ/00Q1jZ`0747^[47b/47b/47f/47j/47j]47n]008AP:d01a61[Q62[Q62
[Q63[Q64[Q64[a65[`024HJ_00@BQk0BR;0BR;0BRK024XZa00LBRk4BS;4B
S;8BSK8BS[8CS[8CSk<00Q>@/`044i6c4i:d4i:d4i>d0Q>D]0054iFe59Je
59Ne59Ne59Rf008DVKH01aBJ]QBK]aBK]aBL]aBM]aFM^1FN^0025Inh00@E
X;TEXKTEXKTEX[T25J>j00@EY;XFYKXFYKXFY[/25ZNk00LFZ;/FZK`FZK`F
Z[`FZk`FZkdG[;d00QN]_@045jjn5jnn5jnn5k2n0QNa_`055k:o5k>o6;C0
6;C0b>3H00J8`;P200001HS0^006B92800006;C06;C0R<2hB9280@000000
00>8`;S8h=R8`;P00P00P007006000:000:000>1oooo00B1oooo00801X80
1007PP48PP48P`49P`812X<0104;Q?ooo`4<Q04=Q0813XD01?ooo`8@Q@8@
Q@8AQP824XH01`8CQP8DQ`8DQ`8EQ`8FQ`<FR0<GR0020aR800@36HT36XT3
6XT36hT20ab:00D37HX47XX47h/47h/488/00P@QR`0:12:<12><12><12B<
12F=1BF=1BJ=1BN=1BN>1BR>0PDYSP041BZ?1B^?1B^?1Bb?0PH]T0041Rj@
1Rn@1RnA1S2A0PHaT@071S:A1S>B1S>B1cBB1cFB1cFC1cJC0087=i<010Lh
U0LiU0LiU0LjU087>iD020PlU@PmU@PnUPPnUPPoUPQ0UPQ0U`Q1U`88@YL0
1`Q3U`U4V0U4V0U5V0U6V0U6V@U7V@022DRI00@9BIX9BYX9BYX:BiX22TbK
00@:CI/:CY/:CY`:Ci`22U2L00L:DId:DYd;DYd;Did;E9d;E9h;EIh00P]F
WP052eNO2eRO2eRO2eVO35ZP008<Fj002PaLX0aMX@aMX@aNX@aOX@aOXPaP
XPaQXPeQXPeRXP8=Hj<010eTX`eUX`eUY0eVY08=Ij@010eXY@iYY@iYY@iZ
Y@8>JjH010i/YPi]YPi]Y`i^Y`8>KjL01`m`Z0maZ0maZ0mbZ0mcZ0mcZ@md
Z@023gFY00D?MZX?MjX?MjX@N:X@NJ/00Q1jZ`0747^[47b/47b/47f/47j/
47j]47n]008AP:d01a61[Q62[Q62[Q63[Q64[Q64[a65[`024HJ_00@BQk0B
R;0BR;0BRK024XZa00LBRk4BS;4BS;8BSK8BS[8CS[8CSk<00Q>@/`044i6c
4i:d4i:d4i>d0Q>D]0054iFe59Je59Ne59Ne59Rf008DVKH01aBJ]QBK]aBK
]aBL]aBM]aFM^1FN^0025Inh00@EX;TEXKTEXKTEX[T25J>j00@EY;XFYKXF
YKXFY[/25ZNk00LFZ;/FZK`FZK`FZ[`FZk`FZkdG[;d00QN]_@045jjn5jnn
5jnn5k2n0QNa_`055k:o5k>o6;C06;C0b>3H00F8`;P4000018S0^006B928
00006;C06;C0R<2hB9280@00000000>8`;S8h=R8`;P00P00P007006000:0
00:000>100B1oooo00F100801X801007PP48PP48P`49P`812X<0104;Q?oo
o`4<Q04=Q0813XD01?ooo`8@Q@8@Q@8AQP824XH01`8CQP8DQ`8DQ`8EQ`8F
Q`<FR0<GR0020aR800@36HT36XT36XT36hT20ab:00D37HX47XX47h/47h/4
88/00P@QR`0:12:<12><12><12B<12F=1BF=1BJ=1BN=1BN>1BR>0PDYSP04
1BZ?1B^?1B^?1Bb?0PH]T0041Rj@1Rn@1RnA1S2A0PHaT@071S:A1S>B1S>B
1cBB1cFB1cFC1cJC0087=i<010LhU0LiU0LiU0LjU087>iD020PlU@PmU@Pn
UPPnUPPoUPQ0UPQ0U`Q1U`88@YL01`Q3U`U4V0U4V0U5V0U6V0U6V@U7V@02
2DRI00@9BIX9BYX9BYX:BiX22TbK00@:CI/:CY/:CY`:Ci`22U2L00L:DId:
DYd;DYd;Did;E9d;E9h;EIh00P]FWP052eNO2eRO2eRO2eVO35ZP008<Fj00
2PaLX0aMX@aMX@aNX@aOX@aOXPaPXPaQXPeQXPeRXP8=Hj<010eTX`eUX`eU
Y0eVY08=Ij@010eXY@iYY@iYY@iZY@8>JjH010i/YPi]YPi]Y`i^Y`8>KjL0
1`m`Z0maZ0maZ0mbZ0mcZ0mcZ@mdZ@023gFY00D?MZX?MjX?MjX@N:X@NJ/0
0Q1jZ`0747^[47b/47b/47f/47j/47j]47n]008AP:d01a61[Q62[Q62[Q63
[Q64[Q64[a65[`024HJ_00@BQk0BR;0BR;0BRK024XZa00LBRk4BS;4BS;8B
SK8BS[8CS[8CSk<00Q>@/`044i6c4i:d4i:d4i>d0Q>D]0054iFe59Je59Ne
59Ne59Rf008DVKH01aBJ]QBK]aBK]aBL]aBM]aFM^1FN^0025Inh00@EX;TE
XKTEXKTEX[T25J>j00@EY;XFYKXFYKXFY[/25ZNk00LFZ;/FZK`FZK`FZ[`F
Zk`FZkdG[;d00QN]_@045jjn5jnn5jnn5k2n0QNa_`055k:o5k>o6;C06;C0
b>3H00B8`;P200000XS0^0800003R<2h00I8T8P0000H]<0H]<28`;Q8T8P1
000000000hS0^<SPf8S0^002002000L00H000X000X000h40187oool01H40
0P06PP0300N20@R20@R300[oool20Q2500@24HH24XH24XH24hH20QB700@2
5HL25XL35XP35hP20aR800@36HT36XT36XT36hT20ab:00D37HX47XX47h/4
7h/488/00P@QR`0:12:<12><12><12B<12F=1BF=1BJ=1BN=1BN>1BR>0PDY
SP041BZ?1B^?1B^?1Bb?0PH]T0041Rj@1Rn@1RnA1S2A0PHaT@071S:A1S>B
1S>B1cBB1cFB1cFC1cJC0087=i<010LhU0LiU0LiU0LjU087>iD020PlU@Pm
U@PnUPPnUPPoUPQ0UPQ0U`Q1U`88@YL01`Q3U`U4V0U4V0U5V0U6V0U6V@U7
V@022DRI00@9BIX9BYX9BYX:BiX22TbK00@:CI/:CY/:CY`:Ci`22U2L00L:
DId:DYd;DYd;Did;E9d;E9h;EIh00P]FWP052eNO2eRO2eRO2eVO35ZP008<
Fj002PaLX0aMX@aMX@aNX@aOX@aOXPaPXPaQXPeQXPeRXP8=Hj<010eTX`eU
X`eUY0eVY08=Ij@010eXY@iYY@iYY@iZY@8>JjH010i/YPi]YPi]Y`i^Y`8>
KjL01`m`Z0maZ0maZ0mbZ0mcZ0mcZ@mdZ@023gFY00D?MZX?MjX?MjX@N:X@
NJ/00Q1jZ`0747^[47b/47b/47f/47j/47j]47n]008AP:d01a61[Q62[Q62
[Q63[Q64[Q64[a65[`024HJ_00@BQk0BR;0BR;0BRK024XZa00LBRk4BS;4B
S;8BSK8BS[8CS[8CSk<00Q>@/`044i6c4i:d4i:d4i>d0Q>D]0054iFe59Je
59Ne59Ne59Rf008DVKH01aBJ]QBK]aBK]aBL]aBM]aFM^1FN^0025Inh00@E
X;TEXKTEXKTEX[T25J>j00@EY;XFYKXFYKXFY[/25ZNk00LFZ;/FZK`FZK`F
Z[`FZk`FZkdG[;d00QN]_@045jjn5jnn5jnn5k2n0QNa_`055k:o5k>o6;C0
6;C0b>3H00>8`;P2000018S0^0800002R<2h00I8T8P0000H]<0H]<28`;Q8
T8P1000000000hS0^<SPf8S0^002002000L00H000X000X000h40187oool0
1H400P06PP0400N20@R20@R30@V30P4:P`040@^4oooo0@b40@f40P4>Q@04
0Pn50Q250Q250Q660P8BQP070Q>60QB70QB70QF70QJ70aJ80aN8008368P0
10<IR@<JR@<JR@<KR@8378X01@<MRP@NRP@OR`@OR`@PR`02126;00X48X`4
8h`48h`498`49Hd59Hd59Xd59hd59hh5:8h21BV>00@5:Xl5:hl5:hl5;8l2
1Rf@00@6;Y06;i06;i46<9421S6A00L6<Y46<i86<i87=987=I87=I<7=Y<0
0PLgT`041cRD1cVD1cVD1cZD0PLkU@0823bE23fE23jF23jF23nF242F242G
246G0PQ2U`0724>G2DBH2DBH2DFH2DJH2DJI2DNI0089B9T010U9VPU:VPU:
VPY;VP8:C9/010Y=V`Y>V`Y>W0Y?W08:D9`01`YAW@YBW@]BW@]CW@]DW@]D
WP]EWP022eJN00D;Eil;F9l;F9l;FIl<FZ000PaKX00:35bP35fQ35fQ35jQ
35nQ35nR362R366R3F6R3F:R0PeSX`043FBS3FFS3FFT3FJT0PeWY0043FRU
3VVU3VVU3VZU0Pi[YP043VbV3VfV3VfW3VjW0Pi_Y`073g2X3g6X3g6X3g:X
3g>X3g>Y3gBY008?MJT01@mfZPmgZPmgZQ1hZQ1iZ`0247Z[00L@Nj/@O:`@
O:`@OJ`@OZ`@OZd@Ojd00Q60[@074H6^4H:^4H:^4H>^4HB^4HB_4HF_008A
QZl011:7/1:8/1:8/1:9/08BR[401a:;/A:</A:</Q:=/Q:>/Q>>/Q>?/`02
4i2c00@CTK<CT[@CT[@CTk@24iBd00DCUKDDU[DDUkDDUkDDV;H00QBI]P07
59Zf59^g59^g59bg59fg5Ifh5Ijh008EWkP011FP^AFQ^AFQ^AFR^@8EXkX0
11FT^QJU^QJU^QJV^`8FYk/01aJX^aJY_1JY_1JZ_1J[_1J[_AN/_@025jfm
00@G[[hG[khG[khG/;h25k6o00DG/[lG/klH]<0H]<38h=P03HS0^006B928
00006;C06;C0R<2hB9280@00000000>8`;S8h=R8`;P00P00P003006000:0
oooo00?oool01`05P@06PP06PP07PP48PP48P`49P`020@Z300@12hCoool1
38@13H@20@j500@23hD248D248D24HH20Q:600L24hH258L258L25HL25XL3
5XP35hP00P<HR0040aV90aZ90aZ90a^90P<LRP050af:11j:11n;11n;122;
00848H/02P@RS0@SS0@SS0@TS0@US@DUS@DVS@DWS@DWSPDXSP85:Hh010DZ
S`D[S`D[S`D/S`86;I0010H^T0H_T0H_T@H`T@86<I401`HbT@HcTPHcTPLd
TPLeTPLeT`LfT`021cNC00@7>9@7>I@7>I@7>Y@21c^E00P8?9D8?ID8?YH8
?YH8?iH8@9H8@9L8@IL224:G00L8@iL9A9P9A9P9AIP9AYP9AYT9AiT00PU8
V@042DVJ2DZJ2DZJ2T^J0PY<V`042TfK2TjK2TjL2TnL0PY@W0072U6M2U:M
2e:M2e>M2eBM2eBN2eFN008;EYh01@]GW`]HW`]HW`]IW`aJX00235^P00X<
G:0<GJ4<GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HJ8=HZ823F>S00@=I:<=IJ<=IJ@=
IZ@23FNT00@=J:D>JJD>JJD>JZD23V^V00@>K:H>KJH>KJL>KZL23VnW00L?
L:P?LJP?LJP?LZP?LjP?LjT?M:T00PmeZ@053gJZ3gNZ3gNZ47RZ47V[008@
NZ/01a1kZa1l[11l[11m[11n[11n[A1o[@024H2]00LAPJhAPZhAPZhAPjhA
Q:hAQ:lAQJl00Q66[`044XN`4XR`4XR`4XV`0Q::/@074X^a4Xba4Xbb4Xfb
4Xjb4hjb4hnc008CT;<011>A/a>B]1>B]1>C]08CU;@01A>E]ABF]ABG]ABG
]ABH]P0259Vf00LDV[HDVkLDVkLDW;LDWKLEWKPEW[P00QFO^0045J2i5J6i
5J6i5J:i0QFS^P045JBj5ZFj5ZFj5ZJk0QJW^`075ZRk5ZVl5ZVl5ZZl5Z^l
5Z^m5jbm008G[Kd011N^_QN__QN__QN`_P8G/Kl01ANb_aNc_aRd`1Rd`<SP
f00=R<2h00I8T8P0000H]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^002
002000@00H000X000X000h4200B100L01H401X801X801h81288128<12H<0
0P4:P`040@^40@b40@b40@f40P4>Q@040Pn50Q250Q250Q660P8BQP070Q>6
0QB70QB70QF70QJ70aJ80aN8008368P010<IR@<JR@<JR@<KR@8378X01@<M
RP@NRP@OR`@OR`@PR`02126;00X48X`48h`48h`498`49Hd59Hd59Xd59hd5
9hh5:8h21BV>00@5:Xl5:hl5:hl5;8l21Rf@00@6;Y06;i06;i46<9421S6A
00L6<Y46<i86<i87=987=I87=I<7=Y<00PLgT`041cRD1cVD1cVD1cZD0PLk
U@0823bE23fE23jF23jF23nF242F242G246G0PQ2U`0724>G2DBH2DBH2DFH
2DJH2DJI2DNI0089B9T010U9VPU:VPU:VPY;VP8:C9/010Y=V`Y>V`Y>W0Y?
W08:D9`01`YAW@YBW@]BW@]CW@]DW@]DWP]EWP022eJN00D;Eil;F9l;F9l;
FIl<FZ000PaKX00:35bP35fQ35fQ35jQ35nQ35nR362R366R3F6R3F:R0PeS
X`043FBS3FFS3FFT3FJT0PeWY0043FRU3VVU3VVU3VZU0Pi[YP043VbV3VfV
3VfW3VjW0Pi_Y`073g2X3g6X3g6X3g:X3g>X3g>Y3gBY008?MJT01@mfZPmg
ZPmgZQ1hZQ1iZ`0247Z[00L@Nj/@O:`@O:`@OJ`@OZ`@OZd@Ojd00Q60[@07
4H6^4H:^4H:^4H>^4HB^4HB_4HF_008AQZl011:7/1:8/1:8/1:9/08BR[40
1a:;/A:</A:</Q:=/Q:>/Q>>/Q>?/`024i2c00@CTK<CT[@CT[@CTk@24iBd
00DCUKDDU[DDUkDDUkDDV;H00QBI]P0759Zf59^g59^g59bg59fg5Ifh5Ijh
008EWkP011FP^AFQ^AFQ^AFR^@8EXkX011FT^QJU^QJU^QJV^`8FYk/01aJX
^aJY_1JY_1JZ_1J[_1J[_AN/_@025jfm00@G[[hG[khG[khG/;h25k6o00@G
/[lG/klH]<0H]<0?b>3H00D0000H]<0H]<28`;Q8T8P00@00000000>8`;S8
h=R8`;P00P00P004006000:000:000>10P04P@0700F100J200J200N20@R2
0@R30@V300812X<0104;Q04<Q04<Q04=Q0813XD0108?Q@8@Q@8@Q@8AQP82
4XH01`8CQP8DQ`8DQ`8EQ`8FQ`<FR0<GR0020aR800@36HT36XT36XT36hT2
0ab:00D37HX47XX47h/47h/488/00P@QR`0:12:<12><12><12B<12F=1BF=
1BJ=1BN=1BN>1BR>0PDYSP041BZ?1B^?1B^?1Bb?0PH]T0041Rj@1Rn@1RnA
1S2A0PHaT@071S:A1S>B1S>B1cBB1cFB1cFC1cJC0087=i<010LhU0LiU0Li
U0LjU087>iD020PlU@PmU@PnUPPnUPPoUPQ0UPQ0U`Q1U`88@YL01`Q3U`U4
V0U4V0U5V0U6V0U6V@U7V@022DRI00@9BIX9BYX9BYX:BiX22TbK00@:CI/:
CY/:CY`:Ci`22U2L00L:DId:DYd;DYd;Did;E9d;E9h;EIh00P]FWP052eNO
2eRO2eRO2eVO35ZP008<Fj002PaLX0aMX@aMX@aNX@aOX@aOXPaPXPaQXPeQ
XPeRXP8=Hj<010eTX`eUX`eUY0eVY08=Ij@010eXY@iYY@iYY@iZY@8>JjH0
10i/YPi]YPi]Y`i^Y`8>KjL01`m`Z0maZ0maZ0mbZ0mcZ0mcZ@mdZ@023gFY
00D?MZX?MjX?MjX@N:X@NJ/00Q1jZ`0747^[47b/47b/47f/47j/47j]47n]
008AP:d01a61[Q62[Q62[Q63[Q64[Q64[a65[`024HJ_00@BQk0BR;0BR;0B
RK024XZa00LBRk4BS;4BS;8BSK8BS[8CS[8CSk<00Q>@/`044i6c4i:d4i:d
4i>d0Q>D]0054iFe59Je59Ne59Ne59Rf008DVKH01aBJ]QBK]aBK]aBL]aBM
]aFM^1FN^0025Inh00@EX;TEXKTEXKTEX[T25J>j00@EY;XFYKXFYKXFY[/2
5ZNk00LFZ;/FZK`FZK`FZ[`FZk`FZkdG[;d00QN]_@045jjn5jnn5jnn5k2n
0QNa_`035k:o5k>o6;C001<H]<01R<2h0DR@R04000000003R<2hb>3HR<2h
008008001001P002P002P003P@8018401`05P@06PP06PP07PP48PP48P`49
P`020@Z300@12h@138@138@13H@20@j500@23hD248D248D24HH20Q:600L2
4hH258L258L25HL25XL35XP35hP00P<HR0040aV90aZ90aZ90a^90P<LRP05
0af:11j:11n;11n;122;00848H/02P@RS0@SS0@SS0@TS0@US@DUS@DVS@DW
S@DWSPDXSP85:Hh010DZS`D[S`D[S`D/S`86;I0010H^T0H_T0H_T@H`T@86
<I401`HbT@HcTPHcTPLdTPLeTPLeT`LfT`021cNC00@7>9@7>I@7>I@7>Y@2
1c^E00P8?9D8?ID8?YH8?YH8?iH8@9H8@9L8@IL224:G00L8@iL9A9P9A9P9
AIP9AYP9AYT9AiT00PU8V@042DVJ2DZJ2DZJ2T^J0PY<V`042TfK2TjK2TjL
2TnL0PY@W0072U6M2U:M2e:M2e>M2eBM2eBN2eFN008;EYh01@]GW`]HW`]H
W`]IW`aJX00235^P00X<G:0<GJ4<GJ4<GZ4<Gj4<Gj8<H:8<HJ8=HJ8=HZ82
3F>S00@=I:<=IJ<=IJ@=IZ@23FNT00@=J:D>JJD>JJD>JZD23V^V00@>K:H>
KJH>KJL>KZL23VnW00L?L:P?LJP?LJP?LZP?LjP?LjT?M:T00PmeZ@053gJZ
3gNZ3gNZ47RZ47V[008@NZ/01a1kZa1l[11l[11m[11n[11n[A1o[@024H2]
00LAPJhAPZhAPZhAPjhAQ:hAQ:lAQJl00Q66[`044XN`4XR`4XR`4XV`0Q::
/@074X^a4Xba4Xbb4Xfb4Xjb4hjb4hnc008CT;<011>A/a>B]1>B]1>C]08C
U;@01A>E]ABF]ABG]ABG]ABH]P0259Vf00LDV[HDVkLDVkLDW;LDWKLEWKPE
W[P00QFO^0045J2i5J6i5J6i5J:i0QFS^P045JBj5ZFj5ZFj5ZJk0QJW^`07
5ZRk5ZVl5ZVl5ZZl5Z^l5Z^m5jbm008G[Kd011N^_QN__QN__QN`_P8G/Kl0
0aNb_aNc_aRd`00C6;C00HS0^058T8P1000000000hS0^<SPf8S0^03oR<2h
8HS0^058T8P1000000000hS0^<SPf<SPf03ob>3H8LSPf058T8P10000003o
R<2h9HS0^04000000001\
\>"], "Graphics",
  ImageSize->{293, 115},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004c0000S2000`400?l00000o`00003oooo`l?0d
oo3`l000ooo`l?0doo3`l000ooo`l?0doo3`l000ooo`l?0doo3`l000ooo`l?0doo3`l000ooo`l?0d
oo3`l000ooo`l?0doo3`l000ooo`l?0doo3`l000ooo`l?0doo3`l000ooo`l?0doo3`l000ooo`l?0d
oo3`l000ooo`l?0doo3`l000ooo`l?0doo3`l000ooo`l?0doo3`l000ooo`l?0doo3`l000oooooold
ooooo`00ooo^k^hdonk^kP00oooVi^HdonKViP00ooo^k^hdonk^kP00ooooooldooooo`00ooo^k^hd
onk^kP00oooVi^HdonKViP00ooo^k^hdonk^kP00ooooooldooooo`00M_o^k^h2ong]k@0:on_[jooX
j>SoiNGUon;Rh_oMgMgof=SHomCDe?oAdM7oc/k>olc<c0;obl_;=Oo:b/X2ol_;b`0:olc<c?o>c/ko
dM7AomCDe?oHf=SogMgMon;Rh_oUiNGoj>SXon_[j`;okNg]4?o^k^h2ong]k@0:on[Zj_oUi^Kogn3R
om[LgooDem[obloColK;coo1al_o_L;8ok_1aP;o^Ko4=Onh_/@2okVoa00:ok_1a_nm`/So`LO;olK;
coo;cm?oe=OJom[LgooOh>;oiNKVon[ZjP;okNg]2oo^k^h007Goi^KV0_oUiND02_oRh^;oh>3Pom_K
fooFe]Koc/k>olO7aono_koo^;RhokBd]?n`/;02ojj^[P;o[Jf]<on/[:`2ojf][@;o[Zj^00[o/;2`
okBd]?nh^;So_knoolO7aoo>c/koe]KFom_KfooPh>3oh^;R0_oUiND>onKViP;oiNGU00coh>3QomcM
gooEemSocM3Col74bOnf_<;oZk:ioj6Z/_nMYJkoUYnYoiFOZ?nCWJP2oi:LYc?oTI^V0_nBW:L03?nC
WJSoUInXoiJOZOnMYJkoXJZboj^b^Onf_<;o`LC9olg@dooEemSog=gOon3Ph@;oiNGU2_oVi^H007Go
k^k^00kokNg]on[Zj_oWinOoh^;RomWIfOo>c/ko`l?3okRh^?n^[ZkoYZJVoj2PX?nLW9coVIVIoiRH
V3OoUiNG00goV9RHoiVIVOnLW9coX:2PojJVY_n^[Zko^;Rhol?3`oo>c/kofMWIon;Rh_oWinOoj^[Z
00;okNg]3Oo^k^h03_o]kNgoj>SYon;SiOoJg=ooc]7Eokg2b?n^][coWZNaoi6LYon7TZ3oP8fKogb9
U_miQICoMXBC=omePi403OmfQ9?oNHFDogb9U_n0SI_oQi:Poi6LYonNYk7o[[Jlokg2b?o>dMGof]cO
on;SiOoXj>T00_o]kNd9onk^kP00MOooool03_olo?conOWioo;bl_oXj>Sof][Jol_;bonj^[[o[:b/
oinOWonEUIGoSXj>ohZ:R_n7QhOoQXJ6=on5QHD03on6QXKoQhN7ohZ:R_n>SXkoUIFEoinOWon/[:co
^[Zjol_;booJf][oj>SXoo;bl_oinOWoo?clooknoP0=ooooo`0>oo_knooem_Soj^c_om[Nhoo7cM;o
/;W3oiZT/On:Uj?oNhRHog60SomYN8[oI7B6of5cQ?mOLH<gof1aPP0?oemaPomQLhCoI7B6ofUhR_ma
P8ooNhRHohZGXonJY;7o/;W3olO=d_oJg^?oj^c_ooGfn?okno_oo_kn00Wooooo001eonk^kP0DonSX
j?oRh^;ofMWIol[:b_nj^[[oZ:RXoiRHV?nBTY;oYJFUol30`?oGemOojn_[ooKfm_ogmoOonOWiooSh
n?oinOWon_[jooWinOogmoL3ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oi
nOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT04oojn_[onOWiooShn?oinOWon?ShooOgmoo]
kNgof=SHol71`OnUYJGoTY:BoiRHV?nXZ:So^[Zjol[:b_oIfMWoh^;RonSXj?o/k>`03Oo^k^h04?oU
i^Kog=kOolkAeOnh_/CoXZZcoh^FXOmfQ9?oIG^Aof:4Z_m/V<KoMj[Noh2fkOn9`OGoS<7foho6n?n@
aOHcoi;6n00Aoi75m_nAa?SoS/Cfohc2m_n2^>koNZcNofjIaomTQZ_oIW^BogJ4Ton;UZ7oXZZcokRn
a?o>dMGog=kOonGVi_o[jn/02Oo^k^h007Goi^KV00cogMgMomKFe_o7alOo]kNgoj>SXonATI7oXZ:R
ol_;boo^k^kom_Kfooclo?ono_hkooooo`0=ookno_olo?comoOgono_koo<c<coXj>Soi6ATOnSXj?o
]kNgolO7aooFe]KogMgMon;RhP0=onKViP0@omOHf_o=d=?o][c1oj2X/?n6TYcoL7j>oeaoY_mVUloo
Mk;`oh>mmOn>aO[oTl[loiO=oOnJd?koWM;ooikCoc?oWmGo017oW]?ooikEoonKd_koVM3noiC;o?n@
ao[oQkogogbglOmZWM?oHH>Xog1nS_n6TYcoX:R`okJl`Oo=d=?oemSJon3Ph@09onKViP00MOo^k^h0
2_oRh^;oe]KFol?3`on^[ZkoVYZJojf][OoNg]kojn_[ooCdm?okno/oooooo`0;oo_knooclo?ok>c/
on7QhOn`/;3oVYZJojj^[_o3`l?oe]KFon;Rh_oXj>P03Oo^k^h04?oJg=oob<cAojjf_?n@VZOoLH>F
oeV2[_mQW]goLJk^ognjmOn:aOWoU/knoi_CoonNe_ooXMOoojCJoonUf_lcojKKo`;oYM[o00ooY=[o
oj7IoonKe?ooUlgmohk5nOn3_?GoN;3_ofVSh_mNQ[?oLXFGoi2JYon^][cob<cAom[LgooTiNL02Oo^
k^h007Gooooo00[okNg]omcLg?o5aLGo[:b/ojf][OoDe=Coh>3Ponc/k?oemOGooOgm?oooool02oon
o_kom_Kfonc/k?oRh^;ofMWIok6a/On/[:coaLG5omcLg?o]kNgom_Kf00gooooo00gohnKYol[?eOnY
/[coRIJToe=m[?mCS]7oI:3PogJ`k_n3_OKoT<OkoiS?o_nNe?ooY=Wo00;oYmco00?oZ=cooj_Moon[
gOl0<On[gOl04OnYg?ooZ=coojOLoonTf_ooWmGooi[@o_nCb_coR;ofog^bkom/YN;oGYOGoeZ3/?n9
UZCoZK:lol[?eOoSi^Wol?7c00Wooooo001eonk^kP0;omSHf?o6a/Ko[Zj^oj>SXoo6a/Koe=CDon3P
h?o/k>col_;booclo?ono_h03Oooool00ooShn?oe]KFooknoP04ooooo`03onc/k?omoOgooooo00;o
m?Cd2oooool00oo]kNgokno_ooooo`04ooooo`03ooCdm?oXj>Sooooo013ooooo00_on_[jooCdm?oZ
j^[ohn?SomOGeoo=cLgoYZJVojj^[_o6a/Kof=SHon;RhP0=onk^kP0>ol_?dona^;ooTIbWoeEgWom1
OL;oEY7DofNPh?mh/>ooPK_doi37n_nFcOcoW=7noj;HoonTf?l2ojGIoa?oZM_o00CoZ=[noi6lg?nA
_=_oZ=[n7?nYfol04OnXf_ooY]WoojCIoonReoooWmCooi[>o?nBa_WoQkkeog^akOm^Y^CoGiOFodf9
bOmKOZCoTIbWok6h_oo;cm?og=kO00Wok^k^001eonKViP0?olg=cOni^KWoXJ6Qoj^[Zoo6a/Kod];B
omcLg?oVi^Kok>c/ooGemOohn?Son_[joogmoOooooooo?cl00Oooooo01GoWYjNoa8B4_l92@Wo9bLW
oa/K6om<C4cofMWIoooooomADE7o1`L7oaXJ6_nLW9co4a<CoeMGEooooooo@410ogmoOoomoOgooooo
oj>SXolL71`00_ooool04?oUiNGo@410o`000?lB4Q;o7AdMooShn?ooooooinOWodY:B_l30`?o8R8R
oaLG5oo1`L7ooooood10@?moOgl2ooooo`03oogmoOoooooooooo00;ooooo013ooOgmooooooomoOgo
no_kooShn?odm?CokNg]onKVi_oOgmooe]KFolc<c?na/K7oXZ:RokVi^Oo=cLgofm_K3OoVi^H04?o0
aLSoXZZcogF6V_lhK:Wo@Gg2oeB@dOmTWMcoM:_Wogjdkon9`?GoTLGgoiK:n_nLc_coW]3loig>nonP
d_`Boj?Bo@07ofR7X_l;3Q7o51XOoaHL8_l82`goGGR@oj;Ao002oj?Bo@08ob8/=OmGL8OoXm;moj?B
oOnKb?7o7RH^ob<^=onMb_@@oj?Bo@0Aoj7Bo?nOd?coWm7loig>nonIbo[oTlKgohg0mOn3^O3oN:kX
of^SgomNUMCoC8O9od=e/?mgR9goXZZcol35b?oDeMP02OoVi^H007Gok^k^01?odM7Aok^k^onQXJ7o
][Jfol?3`oo?clooe]KFomoOgooVi^Koj^[Zono_kooclo?om?CdooGemOogmoOom_KfooOgmoofm_Ko
n?Sh00;omoOg00CoTY:Bo`820_n6QXKom?Cd0_ofm_H02?n/[:codM7Aokno_ol30`?oe]KFomkNg_mG
EeOo410@0_ogmoL01_lm?CgoNWYjooOgmoogmoOoWIfMoa/K6`;omoOg013o?cloobXZ:_o4a<ComoOg
om3@d?ofm_KomoOgod51@Olm?CgoemOGooOgmoo[jn_ojNWYooShn?lm?CgoNg]k0_ofm_H2ooOgm`0C
ooKfm_ohn?Som_KfooOgmoofm_Kom?Cdoo;bl_o`l?3ojn_[onKVi_oQhN7of][Jom?Cdoo9bLWo_kno
ojJVY_nk^k_odM7Aon7Qh@0=onk^kP0@ol77bonSZkCoE7>Kob]X/_loNkkoDX_<oenGeOm[YMooN:kW
oh2fk?n9^o;oS/3doi;4mOnEaOKoUlOgoiO6ma7oV/Wg00?oHh6No`H72Om^T;400_nJbOL00omhW<3o
310Doe5ZPP02oi[9m`07ob0Z=?mBJhCoV/WgoiS6m?l/>TOo5QdSohfih`0Aoi[9m`0AoiS9monGaoSo
ULGfoi?4mOnA`OCoS;kcohFgkOmm/>KoLjOQofNNfOmJT]7oB8G6ocMe^_mHNJ3oXj^dol77booHfmd0
2Oo^k^h007Gooooo00_ogmoOolG5aOnTY:Co/k>col30`?o9bLWodm?ComWIfOoMgMgoh^;RonGUi@02
on[ZjP03onc/k?o]kNgokNg]00Cok^k^00CoinOWoa8B4_mLG5col?3`1Oo^k^h01_o:b/[o0P82ok6a
/Oo^k^koU9BDoadM7@;ok^k^00_o>c/kogIfM_o`l?3ok^k^oiRHV?lJ6Q[ok^k^olg=cOl0003oRh^;
oo3`l003onk^kP05olk>c_l0003oZj^[onk^k_o`l?000oo^k^h01Olk>c_oMWIfonk^k_o^k^kol?3`
00?ok^k^0_o]kNd2onc/k00=onWYjOoVi^Kohn?Son3Ph?oKfm_oeMGEolg=cOo5aLGo^k^koj^[Zoo5
aLGogmoOoo3`l00=ooooo`0@olgCf?n[];co?6>JobIR[OlhMK_oBHG7oeVBd?mVW=KoKj?MogR[h_mo
/NKoQKKZohVjk?n<^ngoS[c]ohjmka3oT;o_00?oSK_Zo`lD6Ol_?Th01?n@_nl02_mBKHSo1PP;ohFa
g_n@_noo7RPbodeVP?n@_noo>diRo``@5?mlY<hBoi2ok`0Aohjmkon>_>koS;c]oh^jkOn8]n_oP[?V
ogf]homeZMkoJj3Iof6FdomBS<_o@gk3oc=^]Om2JjCoZkBlolgCf?oWj^d02Oooool007Gok^k^00go
d=3@okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoOgooQhN7oh^;R00;ohn?S1OoU
iND01?nn_[ko0000ojj^[_oVi^H6onGUi@05oibLW?l];Bgo;Bd]oc0`<?lL71`00_oUiND02oli>CWo
LW9bonKVi_oUiNGoTY:BoaTI6OoUiNGoZZZZo`000?ni^KWoi^KV00?oiNGU00?oZZZZo`000?lf=SH0
0olh>3P01On`/;3oiNGUocTi>OmbLW;oiNGU00;oi^KV0ooUiND2onCTi0;ohn?S00goh^;Ron3Ph?oL
g=cofMWIomKFe_o@d=3obLW9ol71`One]KGoYJFUokRh^?o@d=3oh>3P00gok^k^013o_lG;oinX/OlV
Ci?o8eZVoc5_]_m2O/;oDH[:oejEdOmVVmGoKZ7IogFWgOmj[=ooOZgQoh6`h_n2/>;oQ;;T4?n8]>@0
0ombUkoo0000oe5/R004ohRdi009ogROb_l0003oHhBWohRdi?lL9S3oBF1jodYROOl51`SoJhfc01?o
R;CT017oPk;Soh>ahon1/>;oP:kRogf/h?miZ]ooLZGJofbOf?mTVM?oFHo?od^6aOlmNKgo:fN_obaL
WonOZ;7o_lG;omSJg@09onk^kP00MOoVi^H03Oo:b/[o]KFeoiBDU?nWYjOo][Jfol30`?o6a/Koc<c<
om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`2omkNgP;ogMgM00CoVi^Ko`000?o3`l?ogMgM0_oNg]h3
omgMg@06omkNg_oMgMgogMgMomcLg?n0P83o71`L0_oMgMd02olg=cOoD51@omgMgOoNg]koR8R8oaTI
6OoMgMgo_Kfmo`000?mmOGgogMgM00;og]kN00cogMgMokfm_Ol0003oU9BDok>c/on/[:co0P82olO7
aooMgMgo=cLgofi^K_oNg]h2omgMg@;og]kN0_oMgMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];o
d=3@ol[:b_o5aLGo_Kfmok2`/?nPX:3o]KFeol[:b_oIfMT=onKViP0@ok[0aOnMYZoo5Sj;oaiBWolY
IK7o>7FkodJ1`_mBRl[oG9??ofFId_mZW]GoLJ?HogBUfOmgYm[oMjSJogVYfa3oO:_M00?oEgRLo`00
0?mYTK`01?mlZmd02?mjZ=Wo0000odYVQ?mlZmgo6R@^ob0/>_l10P;oEgRK5?mlZmd04OmjZM_oNJWK
ogNXf_mfY][oLZCHofnQeOmYW=?oHYK@oeV@cOm?R<Oo@gg2oc=`^OlTGZ[o7DbHoifV[onj`<GodMCF
00Woi^KV001eonk^kP0=omCDe?no_kooS8b<oijNW_n][Jgo^KViol;2`_o7alOoc<c<om3@d?oBd];o
eMGEomKFeP02omOGe`03omSHf?oIfMWofMWI00;ofMWI00?oZJVYo`000?nb/[801ooIfMT01OnIVIWo
^KViomKFe_mBDU;oAdM700;ofMWI00Ko=SHfoa4A4OmTI6Co_;blodY:B_m1@D42omWIf@05ocDe=OlQ
8B7oXJ6QomSHf?nl_;`00_oIfMT01Ole=CGoFe]Kom;Bd_n6QXKo92@T00;ofMWI00?o=SHfofa/K?oI
fMT01OoIfMT2omSHf0;oemOG00goeMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo_knookFe]OnYZJWoV9RH
okno_ooDe=Coh^;R00gok^k^013oa/_?ojN`^?lB=HCo6DNFob9IY_l]J[Co?7RmodN1a?mARlWoFY3=
of6Ed?mUV];oJY_CofbNdom^X=CoL:3E4?mcX]L00omIOZOo0000oen6/P04og>Re`08oej4/?l0003o
CFb@og>ReolH8Rgo=DYSo`lE7?m4H80Dog>Re`;oL:3E00ooKIoCof^NdomXVm;oI9S@oejCcOmGS/co
ChS7od=n`_lfL[[o9fB_oamEX_lI@i7oYk2holK;cooJg=l02Oo^k^h007Gooooo00goj>SXomCDe?n<
S8coTi>Coj:RX_n_[joo^[Zjol71`Oo7alOobl_;olk>c_o@d=3odM7A00;odm?C0ooDe=@2omGEe@04
olK6a_l10@7oPh>3omGEe0;oe=CD0_oEeMD05_oFe]KoeMGEog=cLolY:BWo3@d=obl_;onSXj?oeMGE
omKFe_m6ATKoMGEeofEUI?l@413o9RHVoj>SXooEeMGoe]KFol71`Om9BDWo30`<o`T92OlO7al2omGE
e@0<ol71`Olk>c_o2PX:oaLG5onHV9Soe=CDomGEeOle=CGoJVYZomGEeOoFe]KoeMGD0_oDe=@2omGE
e@0@omCDe?oCdm?odm?Com7AdOo@d=3ocLg=ol[:b_o3`l?o_[jnokJf]_n[Zj_oWIfMoiFEUOoDe=Co
j>SXoo?cl`gooooo013of]kSokk5c?lJ=h3o4SZ;oa];VolSFjWo;F^docYf^om6PL?oD8W8oeJ>bomN
TlgoHiK?ofJId?mVVM7oIi[@4?m[W=800omSTLCo0@42od=SQ@04of^LdP09ocUDLOl0003oFH:`of^L
d_lF8Bco>E=`oeR1[_l72`koD7FN01?oJicB0_mXVm403omVVM3oIIS@of2Ec_mLTLcoEXg<od^6a_m1
O;oo=G:jobYV/OlPF:Go64FFob12R_nnaLcof]kSong_l009ooooo`00MOo^k^h04_oMgMgocLg=oi2@
T?n9RHWoUiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooIfMWof][Jom_KfooJf][ofm_KomcL
g0?ofm_K00GoEEEEoalO7oo;bl_ofm_KomcLg006om_Kf`03omWIfOoLg=cofm_K00Gofm_K00?of][J
omcLg?oKfm/01OoKfm/00ooHf=Sog=cLom_Kf`03om_Kf`07omSHf?oKfm_ofm_KomcLg?oKfm_o=SHf
ofe]K@04om_Kf`0ComcLg?oKfm_ofm_Kom_KfooJf][ofMWIomSHf?oFe]Kodm?Colg=cOo2`/;o][Jf
ojb/[?nOWiooT92@oiJFU_o=cLgogMgMonGUi@0=onk^kP0@omCGf_nl`LOo;dR2o`h_POlD?I3o6dfN
obIO[?ljMK[oEH[6ofNIc_m_Wm;oM:?Dog^We_mlZ=OoOZWHogjZf17oPjkH00?o=4IGoaHN9OmlYL`0
0_n3[]P00omoZM;o72D^obLc@002oh>^f006oa/T;Om6GGCoPjkHoe]iU_l;3a;oLYRl4_n3[]P04Omn
ZMSoOj[HogjYf?mlZ=OoN:GFog:Qe?mZVlkoFXk8ocmj_OlYIK7o85JUoaQ7V?l@=XSo<Tb9okc1aooD
em[ogn3R00Wok^k^001eonKViP0;om[Jf_o>c/koW9bLogYjN_n8R8SoUYJFojZZZ_o4a<CoeMGEom_K
fooNg]h00_oPh>03on;RhP03onCTi?oShn?ohn?S00;ohn?S00SodM7AocTi>OlJ6Q[oKFe]ohJ6Q_mW
IfOo:RXZojVYZ@?ohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00Goi>CTon?ShooShn?o>3Phog5aL@03on?Sh`04onCTi?oShn?ohn?Son?S
h`;oh^;R00kohN7Qon3Ph?oOgmoog=cLomOGeoo5aLGo[:b/oijNW_n@T93oPX:2oj2PX?o>c/kof][J
on3Ph0goi^KV00kodmGGol74bOmEIhko1B1bo`//P?lC>hoo9UNToeF4_omkYM;oQjoHohnefonD]]co
UkWMoiRkg`;oV[cO4OnN_^402?nB/=7o:34joaTN9?mAHWCoEFIiob0V;OlN9BcoS:S70_nN_^401olQ
:2ooE6IhoijnhOnN_^7oDfAgoa/Q9onF]MH04OnN_^404OnL_N3oWKgOoiZmgonH^mooUk[Moi6eg?n:
/MWoO:KCoe65`?lTFJKo5dBFo`ldR?l89g[oEVZCol74bOoCeMOog=gO00Woi^KV001eonk^kP0>onGU
iOoMgMgo`/;2og]kNomhN7SoQXJ6oinOWoo5aLGof=SHomgMgOoOgmoohN7Qon;Rh_oShn<3onCTi0Co
iNGU00Soi>CTon?ShonOWiooLW9boeiNG_mkNg_oVi^KomOGe`;oi>CT00?oiNGUonCTi?oUiND00ooU
iND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00Ko
iNGUonCTi?oUiNGoiNGUocTi>OmbLW82onCTi004onGUiOoTi>CoiNGUonGUi@?oi>CT00kohn?Son7Q
hOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4ol?3`ooMgMgoiNGUon[ZjPgok^k^013ogn3R
omCGf_nQZKOo6Rm_o`<NL?l::Wko9DZHofN8_onA[]GoVKKJoiZhfonM_MkoWkkOoj;1h?nU`n7oY<;Q
4_nU`n401_nS`MooKhBHodiLJ_m;F6KoJWjAoj6nf`?oYL?Q00?oLHJKohNO^?nU`n400_nU`n400omZ
OY7oR:6jojG3h@0BojG3h@0?oj?2hOnR`N3oWKgNoi^kg?nL^M_oT[3GofF:`OlQBiWo3C26o`HSMolJ
<gKoXJZhomCGf_oOh>;oj>SY00Wok^k^001eooooo`0;ooWinOoclo?ojNWYojRXZ?mUIFGoLg=cohf=
SOnk^k_oe=CDom[Jf_oMgMd00_oOgml00ooPh>3ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00Go
hN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00Go
hN7Q00?oh^;Ron7QhOoQhN400ooQhN400ooMgMgogmoOon;RhP08on7Qh@0>on3Ph?oOgmoogMgMomcL
g?oEeMGo^KViohj>S_mkNg_oKVi^oj^[ZooYjNWolo?cooWinOomoOd=ooooo`0@ooKgmoo]ko3og^3T
of=`UOl055co01][oaPcQOmQN[?oTjS?oifbe_nP]mWoX[_Koj6kfonR_=coX[kMoj>ogS?oXl3N017o
XkkNoj:mgOnT_mkoX[cKoj:kfonP^=WoW[GHoi:Xd?mGMK;o4c>6o`@OL_l06FGoHg:HomkPi?o]ko3o
m_Ogooclo009ooooo`00MOo^k^h03?o[jn_oj>SXon;Rh_oGemOoSHf=of9RH_mfMWKoY:BTolO7aooB
d];oeMGEomSHf0;of][J0ooKfm/7omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`05?oKfm_og=cLomcLg?oKfm_og=cLom_KfooJf][ofMWIomSHf?oCdm?oaLG5oibLW?meMGGo
IfMWoi2@T?oGemOoh^;RonSXj?o[jn_okNg]3Oo^k^h04?oZj^[oi>GWom[Lgoo:c];o@Dejo`0BF?l:
8VcoA5bLoh:B`?nEY/coVJc@oijae?nQ]MKoX;GFoj2eeonP]]Lcoj2gf00Aoj2feonQ]mOoX;GFoijc
e_nO/mGoWK3CoiFVc_mjSkko<T^Do`8MK?l05F3o@Dmool[>d_oJg=ooi>GWon[Zj_o]kNd02Oo^k^h0
07Goi^KV00koiNGUon;Rh_oOgmoof][JolW9bOn7QhOoFUYJog]kNonSXj?o_;blolK6a_o;bl_ocLg=
olo?c`;odM7A1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7A
om;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7A
om;Bd_oAdM400ooBd]82om7Ad@0=om3@d?o?clooc<c<olS8b?nk^k_oW9bLog9bL_mKFe_oRXZ:olW9
bOoJf][ogmoOon;RhP02onGUi@goi^KV013oiNGUon3PhOoJfmgodmGGok>g`Om0BGKo0Q1Doa/^L_m?
HY[oM8JeohFF_on<VlCoSio8oi:RbOnEYL_oU:K;<onEY//03onDY/_oU:G:oiFTbonCX/WoSYg6ohNF
`_m_P[?o?EFCo`/QJ_l03eCo@4aiok>g`OoCeMOof]_Mon3Ph@02onGUi@Woi^KV001eonk^kP;okNg]
00koj^[ZonSXj?oRh^;og=cLoibLW?m]KFgoJ6QXoh>3PonGUiOoXj>Sojb/[?n_[joo/K6aok:b/P;o
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf
0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd01?o]KFeokJf]?nd];Co];BdokJf]_nc/k?o
/[:bok>c/on_[jooZZZZoibLW?n2PX;oHV9Rofi^K_nOWioog=cLon;Rh_oXj>Soj^[Z00;okNg]3_o^
k^h2ong]k@0>onSXjOoTiNOog=kOom;Ef?mTJH[o7bMOoa<PH?l]?7[oAEN?oe=UV_mOL:?oHWBWofAg
Z?mSMZTcofUk[@0>ofIiZomVNJ[oJ7ZZof=eYomLKZ7oB5ZCobLhN?l85e[o72IOof9YSOoBeMSog=kO
onCUiooXj>T2ong]k@[ok^k^001fooooo`;oo_kn00ooo?clooWinOofm_Kol_;bomWIfOnXZ:SoPh>3
ofi^K_mUIFGoJFUYog9bL_mdM7CoNGUiogalO?mkNg/00_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@07ogalO?mkNg_oO7alogemO?mlO7coNg]kogemO@02ogYjNP0;ogMgMomdM7Co
Kfm_ogAdM?n5QHGoZ:RXom[Jf_obl_;om_KfooWinOolo?`00_ono_h@ooooo`;oo_kn00gono_kooKg
moo`lO?oj^c_oko1c_m^LYCo>d5_ob0WGolD7U[o5R=Road[J?lO;F[o8c9`03?o9CIc00go93=aobDc
L?lT<Vgo7beZoaXVHolR;6Go>d5aofibTono`/koj^c_oo3aloofmoOono_k00;oo_kn2oooool007Oo
k^k^0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;RhP03on3Ph?oOgmoog]kN03WogMgM00?og]kNomoO
gooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/k>`2ong]kA;ok^k^0_o]kNd02_o[jn_oj>SYonCUiooO
h>;og=kOom[LgooHf]goe]WLomGHfooCe]TgomCGfP0:om?FfOoEf=_oe]WLomSJgOoJg=oog=kOomoP
h_oTiNOoj>SYon_[j`;okNg]3?o^k^h007Woi^KV0_oUiND00ooTi>Coh^;Ron;RhP02on3Ph0;ogmoO
>OoNg]h2omoOg`;oh>3P0_oRh^800ooTi>CoiNGUonGUi@0FonKViP;oiNGU00Gohn?Son3PhOoPh>7o
gMkNomcMg`02om[KgCWofM[L0_oJfmd01OoLgMoogMkNon3PhOoPh>7ohn?S00;oiNGU3_oVi^H00?oo
k^k^=?o^k^h00?oooooo=?ooool00?ook^k^=?o^k^h00?ooi^KV=?oVi^H00?ook^k^=?o^k^h00?oo
oooo=?ooool00?ook^k^=?o^k^h00?ooi^KV=?oVi^H00?ook^k^=?o^k^h00?oooooo=?ooool00?oo
k^k^=?o^k^h00?ooi^KV=?oVi^H00?ook^k^=?o^k^h00?oooooo=?ooool00?ook^k^=?o^k^h00?oo
i^KV=?oVi^H00?ook^k^=?o^k^h004kooooo00?oY[6logj]fOmn[MT0fOmn[MT9ooooo`00C_o^k^h0
0onZ]L3oOZgIogj/f@3GohJafP03ogj/fOmn[MWok^k^00Sok^k^001>onKViP03ojZe`?mn[MWoQk;K
00ComoOg7_ojn_X01?oEeMGoZ:RXoi>CToni^KV:oo[jnP03o`000?ojn_[on_[j01oon_[j1OogmoL0
0on5/=WoOZgIonKViP08onKViP009Oo^k^h00oo/k>coj>SXon[ZjP0Vonk^kP03ojZe`?mn[MWoQk;K
02;ooooo00GoI6ATofEUIOmlO7co9bLWoeADE003ooooo`04oo?clomBDU;oLg=colg=cH;ooooo00?o
0000ooooooooool08oooool00oogmoOoQK3Iogj]f@09onk^kP009?ooool01Ookno_ojn_[ol_;booW
inOoo_kn02Gooooo00?oZ[G0ogj]fOn7/]/01Oooool00ookno_of=SHonk^kP04ooooo`04ong]kOoo
ooooooooonc/k1Gooooo00?oj^[Zo`<30ooAdM400_ooool01Oofm_KoX:2PoiZJV_lA4A7ofMWI00?o
oooo00CokNg]ooooooooooook>c/2Oooool01?o]kNgoooooooooooo/k>`Aooooo`03onOWioojn_[o
oooo01cooooo00CokNg]ooooooooooook>c/0oooool00oojn_[ok>c/ooooo`09ooooo`03on_[joof
m_Kooooo00kooooo00CokNg]ooooooooooook>c/0oooool00oojn_[ok>c/ooooo`05ooooo`03onSX
j?ojn_[ooooo00;ooooo00KokNg]ooooooooooook>c/ooooool0000Uooooo`03ooOgmon5/=WoOZgI
00Wooooo000Ponk^kP?okNg]00Koi^KVolk>c_nGUiOoShn?okJf]_o]kNdUonk^kP03ojZe`?mn[MWo
Qk;K00?ooooo01[om_Kfog5aLOl92@Wo:BTYoalO7ol];BgoVIVIooWinOlh>3So5QHFoc@d=?mfMWKo
5aLGolk>c_oooooo9bLWok6a/Ooooooo9bLWok6a/Ooooooo9bLWok6a/Ooooooo9bLWok6a/@;ooooo
00Wo=3@dojBTY?ooooooc/k>odM7Aolo?cooZJVYoc<c<on`/;001Oooool02_m@D53oR8R8oooooooi
nOWo>3PhoaHF5_ld=3CoMWIfoaLG5oo>c/h2ooooo`0;odU9BOl];BgooooooooooooinOWo>3PhoaHF
5_ld=3CoMWIfoaLG5oo>c/h01Oooool01_mOGeooN7Qhoooooooooooo9bLWok6a/@?ooooo00Go`<30
oa`L7?lU9BGo2PX:ogUiN@02ooooo`0:obLW9ona/K7oooooooooool>3Pkob<S8oooooooemOGo0000
on7Qh@Gooooo00Go7QhNom?Cdooooooo`L71ojj^[P02ooooo`0@oa<C4oo7alOonOWiocPh>?lF5QKo
=3@dogIfM_lG5aOoc/k>oooooonf][Ko6ATIocXj>_oooooo9bLWok6a/@;ooooo00So=3@dojBTY?oo
ooood=3@ob`/;?lE5AGo;Bd]oda<C0;ooooo02Ko9bLWok6a/Oooooooooooo`h>3_o8b<SoooooooGe
mOl0003ohN7QooWinOlh>3So5QHFoc@d=?mfMWKo5aLGolk>c_oooooo][JfoaTI6Olj>S[oooooobLW
9ona/K7oooooolc<c?lT92Co3`l?oa/K6on2PX;onOWiocPh>?lF5QKo=3@dogIfM_lG5aOoc/k>o`00
02Gooooo00?omoOgohF`fOmn[MT02Oo^k^h001_oi^KV00koiNGUon?ShooPh>3ogMgMom[Jf_oGemOo
e]KFom?Cdond];CoQ8B4okno_oo7alOoZJVYonGUiBGoi^KV00?oZ[G0ogj]fOn7/]/00oooool00omW
IfOo820Pom;BdP02ooooo`08om?Cdonm_Kgo/[:boa/K6ookno_oh>3PobXZ:_n9RHT2ooooo`0;obLW
9ona/K7oooooobLW9ona/K7oooooobLW9ona/K7oooooobLW9ona/K400_ooool02Old=3CoY:BToooo
oolZ:R[oHf=Sol;2`_m[Jf_o51@DoijNWP05ooooo`09ofa/K?mHF5Sooooook:b/_lK6a_ono_kon3P
h?lZ:R[oRHV900;ooooo00_oi^KVo`H61_lN7QkoalO7oooooonb/[;o6a/Koo_knooPh>3o:RXZohV9
R@06ooooo`06oemOGomhN7SooooooooooolW9bOo/K6a0_ooool02_oclo?o5aLGoi6ATOooooooh^;R
oa@D5?n[Zj_oooooobLW9ona/K42ooooo`06o`h>3_o8b<SoooooooGemOl0003ohN7Q1Oooool03olN
7Qkodm?CoooooolY:BWo2@T9oo7alOoooooo4a<ColO7aonb/[;o6a/Koo_knooPh>3o:RXZohV9R@02
ooooo`06ode=COn2PX;ooooooooooolW9bOo/K6a0_ooool02?ld=3CoY:BTooOgmolR8R;oO7aloo_k
nooooooomoOg0_ooool04?lW9bOo/K6aoooooooooooo3Ph>olS8b?oooooomOGeo`000?oQhN7o/[:b
oa/K6ookno_oh>3PobXZ:_n9RHT2ooooo`0Dode=COn2PX;ooooooooooolW9bOo/K6aooOgmolP823o
HF5Qoo;bl_ono_kok^k^ok:b/_lK6a_ono_kon3Ph?lZ:R[oRHV9ooooool0000Uooooo`03ooOgmon5
/=WoOZgI00Woi^KV000Ionk^kP0Aong]kOoYjNWoh>3Pom;Bd_o0`<3o[Jf]oinOWonHV9SoUIFEoi2@
T?n<S8cohn?Soo3`l?o:b/[oZZZZonSXj?o]kNd09?o^k^h00onZ]L3oOZgIohNbf`02ooooo`03onCT
i?l20P;o/;2`00Gooooo00Kofm_Ko`d=3On`/;3onOWiodA4A?nDU9@2ooooo`0;obLW9ona/K7ooooo
obLW9ona/K7oooooobLW9ona/K7oooooobLW9ona/K400_ooool01Old=3CoY:BTomgMgOl20P;okno_
00;ooooo00?o=SHfoiZJV_ooool01?ooool02Om/K6coF5QHoooooooKfm_o3@d=ok2`/?oinOWoA4A4
oiBDU002ooooo`0;ohZ:R_m;Bd_oRXZ:of9RH_oooooofm_Ko`d=3On`/;3onOWiodA4A?nDU9@01_oo
ool01_mOGeooN7Qhoooooooooooo9bLWok6a/@;ooooo00?o`<30o`820_o^k^h00_ooool01OmCDe?o
HF5QoooooolW9bOo/K6a00;ooooo00Ko3Ph>olS8b?oooooomOGeo`000?oQhN45ooooo`0?oahN7_oC
dm?oc/k>o`L71omMGEgoVi^KoooooolC4a?oalO7om_Kfol=3@go/;2`ooWinOm4A4CoU9BD00;ooooo
00Ko<c<cojFUYOooooooooooobLW9ona/K42ooooo`05oc@d=?nTY:Coa<C4o`T92Oo_knl01Oooool0
4?lW9bOo/K6aoooooooooooo3Ph>olS8b?oooooomOGeo`000?oQhN7ofm_Ko`d=3On`/;3onOWiodA4
A?nDU9@2ooooo`09oc<c<onUYJGooooooooooolW9bOo/K6aol?3`ol0003oeMGE00?ooooo00Sofm_K
o`d=3On`/;3onOWiodA4A?nDU9Coooooo`0002Gooooo00?on_[johF`fOmn[MT02Oo^k^h001Sooooo
00cono_konk^k_oAdM7oZZZZohn?SonEUIGo[Jf]olK6a_o@d=3od];BomOGeooemOD2ong]k@05omcL
g?nBTY;odm?Conc/k?okno/08oooool00onZ]L3oOZgIohNbf`02ooooo`03okZj^_l10@7omoOg00Ko
oooo00Gof=SHoi:BT_mQHF7o5QHFoiBDU002ooooo`0;obLW9ona/K7oooooobLW9ona/K7oooooobLW
9ona/K7oooooobLW9ona/K400_ooool01Old=3CoY:BTol71`Ol<30cooOgm00;ooooo00?o?CdmoiZJ
V_ooool01?ooool02Om/K6coF5QHoooooooooooof=SHoi:BT_mQHF7o5QHFoiBDU002ooooo`0;ob/[
:on[Zj_ojNWYoa0@4?obl_;oooooomSHf?nBTY;oHF5QoaHF5_nDU9@01_ooool01_mOGeooN7Qhoooo
oooooooo9bLWok6a/@;ooooo00?o/k>co`/;2oolo?`00_ooool01OmYJFWoE5ADoooooolW9bOo/K6a
00;ooooo00Ko3Ph>olS8b?oooooomOGeo`000?oQhN45ooooo`0?oahN7_oCdm?oLg=coe=CDoo;bl_o
?CdmoooooolC4a?oalO7oooooooHf=SoTY:Bof5QHOlF5QKoU9BD00;ooooo00Ko<c<cojFUYOoooooo
ooooobLW9ona/K42ooooo`04oc@d=?nTY:Co`L71o`<30`;o8B4Q00Ko5QHFocDe=OooooooooooobLW
9ona/K42ooooo`0<o`h>3_o8b<SoooooooGemOl0003ohN7QoooooooHf=SoTY:Bof5QHOlF5QKoU9BD
0_ooool02Olc<c?oYJFUoooooooooooo9bLWok6a/Onc/k?o0P82ono_k`04ooooo`07omSHf?nBTY;o
HF5QoaHF5_nDU9Coooooo`00000Uooooo`03oo[jn_n5/=WoOZgI00Wooooo000Fonk^kP0>ong]kOoU
iNGob/[:oiZJV_n:RX[o`/;2ong]kOoinOWom_Kfoo;bl_o_knool?3`onk^k_o/k>`2oo3`l007oo7a
lOo8b<SoRh^;oiZJV_o:b/[oiNGUong]k@0Qonk^kP03ojZe`?mn[MWoQk;K00;ooooo00?oYZJVo`P8
2?ojn_X02Oooool05_lj>S[oWYjNoooooooooooo9bLWok6a/Ooooooo9bLWok6a/Ooooooo9bLWok6a
/Ooooooo9bLWoeMGEoomoOgoooooob<S8on/[:coo?cloa@D5?o;bl/2ooooo`03ocLg=onIVIWooooo
00Cooooo00?oK6a/oeQHF?ooool01?ooool02Olj>S[oWYjNooooooo<c<co4Q8BooWinOooooooDe=C
oiRHV004ooooo`03ocXj>_nNWYkooooo00Gooooo00KoGemOogQhN?ooooooooooobLW9omZJVX2oooo
o`03on3Ph?l20P;obl_;00;ooooo00go;2`/ohB4Q?oooooo9bLWof][Joooooooo?clo`L71on2PX;o
ooooon_[jol0003oinOW00Gooooo00Wo7QhNom3@d?lI6AWo[Zj^oooooolZ:R[ogMgMoa<C4oo7alL0
1?ooool01_lj>S[oWYjNoooooooooooo<c<cojFUY@;ooooo00co9bLWoeMGEoomoOgoooooob<S8on/
[:coo?cloaPH6?oUiNGoooooohN7QomfMWH2ooooo`0:obLW9om[Jf_oooooooclo?l71`OoPX:2oooo
ooo[jn_o0000onOWi`Cooooo00Ko>SXjoijNW_oooooooooooc<c<onUYJD2ooooo`05obLW9ona/K7o
gmoOo`820_nUYJD01oooool01?lj>S[oWYjNooooool0000Uooooo`03oo[jn_n5/=WoOZgI00Wok^k^
000EonKViP09onGUiOoJf][o/[:bohF5QOo4a<ComoOgoo?cloo]kNgok^k^00;ol?3`00ComoOgoo7a
lOogmoOol_;b0ooalO401ooclo?omoOgolC4a?n5QHGo/[:bom[Jf_oUiND08?oVi^H00onZ]L3oOZgI
ohNbf`02ooooo`03olO7aol0003o_[jn00Kooooo00GoDE5AogEeMOn2PX;o1PH6onKViP02ooooo`0F
obLW9ona/K7oooooobLW9ona/K7oooooobLW9ona/K7oooooobLW9omGEeOo>SXjof9RH_l820Sol?3`
oooooomhN7So71`Loh:2P_lh>3So410@oiZJVPGooooo00coK6a/oeQHF?oooooooooooe5ADOmeMGGo
PX:2o`H61_oVi^Koooooofe]KOmZJVX2ooooo`08okRh^?lc<c?ooooooe5ADOmeMGGoPX:2o`H61_oV
i^H5ooooo`0Gok^k^ol_;boo>c/kogmoOoo`l?3o9bLWodY:B_m7AdOoXJ6QoooooomgMgOo7QhNoh:2
P_m5ADGo:2PXoo7alOoooooo9bLWoe=CDom9BDWoGUiNoaDE5OmhN7P00_mADE400ol[:b_ooooooooo
o`04ooooo`0QoahN7_n?Shoo4A4AooWinOooooooQhN7oh20P?lC4a?oalO7oooooomADE7oMGEeoh:2
P_l61PKoi^KVoooooonc/k?o6ATIoe5ADOmoOgoooOgmobLW9omGEeOo>SXjof9RH_l820Sol?3`oooo
oomlO7co?3`lohJ6Q_lM7Agoa<C400;ooooo00Ko9bLWoe=CDom9BDWoGUiNoaDE5OmhN7P2oe5AD@0N
ob/[:ooooooooooooe5ADOmeMGGoPX:2o`H61_oVi^Kooooook>c/olI6AWoDE5AogmoOoomoOgo9bLW
ok6a/OooooooN7Qho`X:2_m/K6coPh>3ok2`/?ooooooDE5AogEeMOn2PX;o1PH6onKVi_oooooo0000
9Oooool00oojn_[oQK3Iogj]f@09onKViP005?o^k^h02?o]kNgoh^;Rok:b/_n?Shook>c/oo?cloo^
k^kolO7a0_obl_801_o`l?3on?ShokRh^?mZJV[oWIfMooCdm0?ol_;b00SolO7aonk^k_oclo?ok>c/
ohn?Sonb/[;oh^;Rong]kAook^k^00?oZ[G0ogj]fOn7/]/00_ooool00oodm?Co5aLGogEeM@06oooo
o`04onGUiOn][JgoTi>ComWIf@?ooooo00ko9bLWok6a/Ooooooo9bLWok6a/Ooooooo/K6aon?Shooo
oooo/K6aon?Shoo?clooTi>ComkNgP?ooooo00Go]KFeohf=SOo@d=3o^KViom[JfP05ooooo`08ofa/
K?mHF5SooooooooooooUiNGo[Jf]oi>CTooIfMT2ooooo`0;ok>c/ooQhN7oooooooooooomoOgoY:BT
ooWinOoUiNGo[Jf]oi>CTooIfMT01_ooool02Oo>c/ko?3`loda<C?nRXZ;om?Cdok6a/OoShn?o_Kfm
ojj^[P02ooooo`04ol71`On<S8coY:BTooGem@;ooooo00Wo/K6aon?Shoo:b/[oTI6AomWIfOoooooo
_KfmoiJFU_oXj>P01_ooool00olN7Qko=3@dofEUI@02ooooo`09on?SholT92Co4Q8BolO7aooooooo
iNGUojf][OnCTi?ofMWI00;ooooo00[ob<S8ob0P8?mYJFWoXZ:Rookno_lW9bOo/K6aolo?conCTi?o
g]kN0oooool00onf][KoRXZ:olS8b003ooooo`09ok6a/OoShn?ob/[:oi6ATOoIfMWooooookfm_OnF
UYKoj>SX00;ooooo00CoiNGUojf][OnCTi?ofMWI0_ooool01oo8b<So820PofUYJOnRXZ;oo_knok6a
/OoShn<00_ooool02Oo5aLGoSHf=oi>CTooEeMGoooooonGUiOn][JgoTi>ComWIf@02ooooo`03o`00
0?oooooooooo02?ooooo00?on_[johF`fOmn[MT02Oo^k^h001Cooooo00KonOWiol[:b_nGUiOon?Sh
ono_koobl_83oo?cl`09oo;bl_oemOGojNWYofATI?mIFEWoE5ADolg=cOokno_olO7a00?olo?c00Ko
l_;bono_koohn?SoUiNGol[:b_oinOTOooooo`03ojZe`?mn[MWoQk;K00?ooooo00OoYZJVo`d=3OnH
V9Soi>CTon;Rh_n^[ZkoYjNW00Sooooo00So9bLWok6a/Ooooooo9bLWok6a/OooooooUiNGomWIfA?o
oooo00?oK6a/oeQHF?ooool06Oooool00omlO7coJFUYooooo`0Looooo`03oahN7_l0003o`L7100?o
oooo00?oA4A4o`000?o7alL02?ooool01_n>SXkob<S8oooooooooooo9bLWok6a/Akooooo00KoSXj>
olS8b?oooooooooooiNGUooIfMT=ooooo`03o`000?oooooooooo02?ooooo00?omoOgohF`fOmn[MT0
2Oooool001?ok^k^00GokNg]om;Bd_n=SHgol?3`ono_k`05ooCdm009oo?clooemOGol?3`og5aLOm>
CTkoFe]KomSHf?ojn_[olo?c00Gom?Cd00Gokno_oo3`l?n=SHgod];Bong]k@0Nonk^kP03ojZe`?mn
[MWoQk;K00Cooooo00Kob<S8oeMGEol];Bgo<S8boeEEEOnXZ:P8ooooo`08obLW9ona/K7oooooobLW
9ona/K7oooooofi^K_o:b/XCooooo`03oibLW?n?Shoooooo01Wooooo00CocLg=oa/K6omfMWKoPh>3
6oooool00omXJ6SoGemOooooo`03ooooo`03okJf]_mCDe?ofMWI00cooooo00?o9bLWok6a/Oooool0
8Oooool00om^KVkob/[:ooooo`0<ooooo`03o`000?oooooooooo02?ooooo00?omoOgohF`fOmn[MT0
2Oo^k^h001?oi^KV00GogmoOoijNW_o<c<comOGeooCdm006ooGem@07ooCdm?okno_oe]KFoiNGUoo2
`/;on_[jooCdm006ooGem@05ooCdm?oemOGoc<c<oijNW_oOgml07_oVi^H00onZ]L3oOZgIohNbf`0B
ooooo`05olW9bOo/k>coooooolW9bOo/k>`0<oooool00oo/k>coZJVYolc<c00`ooooo`03olW9bOo/
k>cooooo033ooooo00?o0000ooooooooool08oooool00oogmoOoQK3Iogj]f@09onKViP004oo^k^h0
1?oFe]KoTI6AooWinOobl_88ooKfmP05ooGemOolo?cod];Boo?cloohn?P02?ofm_H01?obl_;onOWi
oi6ATOoFe]HNonk^kP03ojZe`?mn[MWoQk;K00Cooooo[?ojn_X00ol0003on_[joo[jnP0Ooo[jnPCo
oooo00?omoOgohF`fOmn[MT02Oo^k^h001;ooooo00Goo_knolS8b?nl_;con_[jooKfmP07ooOgm`07
ooKfm_oinOWol_;bof9RH_o>c/koooooooGem@07ooOgm`05ooKfm_ojn_[o_;blolS8b?ono_h07Ooo
ool00onZ]L3oOZgIogj/f@2`ohJafP03ogBOb?n6/M[oQ[7J02CoQ[7J00?oOZcIogj]fOooool02?oo
ool001;ok^k^00Cojn_[oj>SXooPh>3om_Kf2?ohn?P01oogmoOooOgmonKVi_mJFU[o`<30ooooooof
m_H02?ohn?P01?ofm_Koh>3Poj>SXoo[jn/Monk^kP03oi>NZOmn[MWoOZgI0=WoOZgI2Oo^k^h001;o
i^KV00Coh^;RoiFEUOo^k^kom_Kf2?ojn_X01oohn?SoooooomKFe_m@D53o[:b/ooooooogmoL02?oj
n_X01?ofm_Kok^k^oiFEUOoRh^8MonKViP03og:5V?miQ8ooO8NB0=OoO8NB00?oNHB?ofiiQ?oVi^H0
2?oVi^H001;ok^k^00Coj^[ZoiRHV?o_knoomoOg2?okno/01ooinOWooooool71`Om<C4coV9RHoooo
oooinOT02?okno/01?ogmoOokno_oiRHV?oZj^[oonk^kP?ok^k^000Booooo`04ooclo?n[Zj_ojn_[
ooWin@Soo?cl00OonOWioooooon[Zj_oD51@oh>3Pooooooono_k00Soo?cl00ConOWion_[jon[Zj_o
o?clooooool3ooooo`004_o^k^h01?o]kNgo];Bdom?Cdoolo?`8oogmo@08oo_knoooooooU9BDoeEE
EOmcLg?om_Kfooooooolo?`7oogmo@04ooclo?oCdm?o];Bdong]kOook^k^0oo^k^h001?oi^KV00Co
b/[:oj:RX_ooooooo?cl2?ono_h01oooooooP820oeaLG?mUIFGoj>SXooooooomoOd01_ono_h01?ol
o?cooooooj:RX_o:b/X[onKViP03ohj>S_n[Zj_oi^KV03?oi^KV00Go[Jf]ogIfM_mGEeOoKFe]okVi
^@2MonKViP004oo^k^h01?oWinOoVi^Konk^k_ojn_X6ooknoP09oogmoOoooooom?Cdofm_KomRHV;o
GEeMomGEeOooooooo?cl00Koo_kn00Con_[jonk^k_nKVi_oinOW:oo^k^h00olk>c_oMWIfonk^kP0c
onk^kP06ogmoOom^KVkoVYZJoeaLG?l:2P[o[jn_W?o^k^h001Cooooo00Cof][JojVYZOomoOgoo?cl
1Oooool02Oono_koooooonGUiOmSHf?oIVIVoeUIFOo0`<3oooooooclo005ooooo`04ooclo?omoOgo
ZJVYom[JfRcooooo00Go@410ogmoOoono_koiNGUooknoP04ooooo`03ooclo?o_knoooooo00Kooooo
00?oiNGUoogmoOooool01?ooool00oomoOgog=cLonKViP06ooooo`03onGUiOomoOgooooo01Gooooo
00?oFUYJodM7Aoooool0Voooool001Cok^k^00Goj^[Zojn_[oo6a/Koo_knooclo004ooooo`09oogm
oOoooooog]kNoe]KFomYJFWoEEEEokFe]Oooooooo?cl00Cooooo00Goo?clookno_o6a/Ko[jn_on[Z
jP0Ponk^kP06oc0`<?m^KVkok^k^onk^k_lk>c_oMWIf0_o^k^h02_nHV9So6QXJonk^k_o^k^ko>c/k
odI6A_lS8b?o6ATIoa<C4on_[jl2onk^kP06ok:b/_lI6AWo1PH6oda<C?mmOGgo;2`/0_o^k^h01?o4
a<Co8R8Roa`L7?n][Jd4onk^kP06ojBTY?l92@Wo30`<ob4Q8Olb<S;oVi^K0_o^k^h01oo4a<Co8R8R
oa`L7?n][Jgok^k^oc/k>omfMWH00oo^k^h01_lk>c_oMWIfonk^k_o^k^ko>c/kogIfMP;ok^k^00[o
V9RHoaXJ6_o^k^kok^k^omOGeomFEUKo=CDeog5aLOnBTY;o71`LW?o^k^h001Goi^KV00Kog=cLoinO
Woo:b/[ooooooo_knoono_h2ooooo`09ookno_oooooono_koh:2P_mFEUKoJ6QXon?Shoooooooo_kn
00;ooooo00Koo_knoo_knooooooob/[:oinOWooLg=`QonKViP06obh^;_mZJV[oi^KVonKVi_li>CWo
LW9b0_oVi^H04_nCTi?o6ATIonKVi_oVi^Ko>CTioc`l??oGemOoh^;Rog1`L?lA4A7ofm_KonKVi_m;
Bd_oD51@omkNg_n>SXko3@d=ob/[:`;oi^KV00?oIFEUocXj>_oUiND01OoVi^H02oo1`L7o[:b/on7Q
hOoVi^KoSHf=o`<30oo8b<Soi^KVofEUIOlj>S[oiNGU00;oi^KV00?o>CTiog9bL_oVi^H00_oVi^H0
1_li>CWoLW9bonKVi_oVi^Ko>CTiog9bLP;oi^KV00[oTi>CoaTI6OoVi^Koi^KVodE5AOlY:BWoTY:B
ofm_KolX:2So4Q8BW?oVi^H001Kok^k^00Oohn?SojZZZ_n^[ZkomoOgoogmoOokno_ooOgm00?ooooo
00?omOGeom7AdOoZj^X00oooool01oomoOgono_koogmoOogmoOo[Zj^ojZZZ_oShn<08_o^k^h01_l`
<33oKVi^onk^k_o^k^ko>c/kogIfMP;ok^k^00KoV9RHoaXJ6_o^k^kok^k^oc/k>omfMWH2onk^kP06
omOGeol0003oXJ6Qonk^k_lY:BWoQXJ60_o^k^h01_maLG7o;2`/onk^k_o^k^koAdM7ofYZJP[ok^k^
00Kod];Bo`000?nYZJWok^k^odM7AomZJVX3onk^kP03oc/k>omfMWKok^k^00;ok^k^00Ko>c/kogIf
M_o^k^kok^k^oc/k>omfMWH2onk^kP06oiRHV?lJ6Q[ok^k^onGUiOl820So[:b/0_o^k^h00on<S8co
3`l?onk^kP2Konk^kP005oooool05OoinOWoclo?oinOWoo=cLgonOWiooooooomoOgono_koo[jn_ol
o?cooooooogmoOojn_[ono_koogmoOoooooonOWiolg=cOnOWiooclo?ooWin@0Sooooo`06oc@d=?mf
MWKooooooooooom0@43oOgmo0_ooool01_nSXj?o71`Loooooooooooo@410ogmoO`?ooooo00Go5QHF
oi6ATOoooooo;2`/oi>CT`02ooooo`06ohn?Sol`<33ooooooooooom=CDgoLW9b2Oooool01oo`l?3o
Cdm?o`P82?obl_;oooooode=COmbLW800oooool00om0@43oOgmoooooo`02ooooo`06od10@?moOgoo
oooooooooom0@43oOgmo0_ooool01_nSXj?o71`Looooooo2`/;o0000onKViP;ooooo00?o[:b/oa4A
4Oooool0Voooool001Sok^k^00SokNg]omoOgone]KGoUiNGojj^[_oJf][olO7aoo[jnP?oo?cl00So
n_[joo7alOoJf][o[Zj^oiNGUone]KGogmoOong]kBCok^k^00Ko<30`ofi^K_o^k^kok^k^oc/k>omF
EUH2onk^kP06oi:BT_lK6a_ok^k^onk^k_lk>c_oLG5a0_o^k^h01_oMgMgo0000okJf]_o^k^ko:BTY
ohV9R@;ok^k^00KoQHF5ob`/;?o^k^kok^k^odM7AomZJVX8onk^kP04ojVYZOlJ6Q[o5ADEok6a/@;o
k^k^00?oAdM7ofYZJ_o^k^h00_o^k^h00olk>c_oHV9Ronk^kP02onk^kP06oc/k>omfMWKok^k^onk^
k_lk>c_oEUIF0_o^k^h01_nBTY;o6a/Konk^k_o;bl_o0000ojRXZ0;ok^k^00?oX:2Po`l?3oo^k^h0
Voo^k^h001[oi^KV00KoiNGUomcLg?o6a/KoZZZZoiRHV?nCTi<3oi6AT@06oi>CTonHV9SoZZZZolK6
a_oLg=coiNGU9_oVi^H02_l^;RkoJVYZonKVi_oVi^Ko>CTioa8B4_mZJV[ob<S8odi>C_m5ADD2onKV
iP0:ocTi>OlH61SoR8R8olK6a_mNGUko3`l?on?ShooVi^Ko9bLWohB4Q0;oi^KV00SoP820ob/[:ooV
i^Koh>3Pod51@OmRHV;og=cLon;RhPGoi^KV00CoM7Ado`000?m=CDgoclo?0_oVi^H03OoPh>3o@D51
of9RH_oLg=coh^;RonKVi_li>CWo4A4Aoh:2P_o=cLgoi>CTocTi>OmbLW800_oVi^H01_li>CWo4Q8B
ofYZJ_o8b<SoCTi>odE5A@;oi^KV00Ko=CDeoclo?oo;bl_ofMWIode=COl?3`nLonKViP007Oo^k^h0
2Oo]kNgoj^[ZonKVi_oShn?oh^;Ron?ShooVi^Koj^[Zong]k@0Yonk^kP0:oc0`<?m^KVkok^k^onk^
k_m>CTkoPX:2og1`L?lB4Q;o:RXZokJf]P;ok^k^00KoCTi>oh20P?mNGUko30`<oaLG5onLW9`2onk^
kP0<ochn?_nCTi?ok^k^onk^k_n@T93o@D51onk^k_mfMWKo1`L7o`/;2olI6AWoXZ:R1?o^k^h00ooF
e]Ko0@41ohV9R@04onk^kP0=ogIfM_l71`Oo2`/;oaTI6OnRXZ;ok^k^odi>C_moOgooEUIFo`P82?oP
h>3oCTi>oh>3P`02onk^kP06odi>C_n2PX;oL71`oa8B4_lZ:R[o][Jf0_o^k^h01_oCdm?o?cloo`X:
2_lV9RKoKVi^obLW9icok^k^001?ooooo`03oc@d=?mfMWKooooo00Cooooo00?oo_knooooooooool0
1Oooool00oomoOgoooooooooo`0:ooooo`03ode=COmbLW;ooooo00Gooooo00?of=SHo`820_oWinL0
1Oooool00om=CDgoLW9booooo`05ooooo`03ooclo?oooooooooo00Kooooo00?oo_knooooooooool0
1?ooool00oomoOgoooooooooo`2Mooooo`00Coo^k^h00ol`<33oKVi^onk^kP0Ionk^kP03om7AdOo?
clook^k^00Kok^k^00GoADE5ocHf=_n4Q8CoFe]Koe9BDP02onk^kP03om7AdOo?clook^k^00Ook^k^
00?oE5ADohR8R?o^k^h0Zoo^k^h004ooi^KV00?oWIfMokFe]OoVi^H08_oVi^H01OoRh^;oY:BTof=S
HomjNW[o[:b/00coi^KV00?oXZ:RokRh^?oVi^H0ZooVi^H00?ook^k^=?o^k^h00?oooooo=?ooool0
0?ook^k^=?o^k^h00?ooi^KV=?oVi^H00?ook^k^=?o^k^h00?oooooo=?ooool00?ook^k^=?o^k^h0
0?ooi^KV=?oVi^H00?ook^k^=?o^k^h00?oooooo=?ooool00?ook^k^=?o^k^h00?ooi^KV=?oVi^H0
0?ook^k^=?o^k^h00?oooooo=?ooool00?ook^k^=?o^k^h00?ooi^KV=?oVi^H009?oOgmo1OmnOWjK
ogmoO`0000Cojn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP0KomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oMgMgog=cL00;ogMgM017og]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNgP02omgMg@1MomcLgOoMgMgogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oLg=gog=cLomWIfOoKfm_og=cL
00;ogMgM08cog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMg@Cog]kN00?ogMgMomkNg_oNg]h00ooMgMd1on7Qh@7o
inOW0OoZj^X00003onc/k?oVi^Koh>3P00OofMWI00Cof=SHomKFe_oCdm?od=3@0oo=cLd01?o@d=3o
dm?ComOGeooHf=P<omWIf@09omSHf?oGemOoeMGEomCDe?oCdm?oe=CDomGEeOoGemOof=SH00gofMWI
00Wof=SHomOGeooEeMGoe=CDom?CdooDe=CoeMGEomOGeooHf=P0DooIfMT01_oGemOoe=CDom7AdOoC
dm?oe]KFomSHf0KofMWI00?of=SHomWIfOoIfMT01OoIfMT2omSHf7kofMWI00?of=SHomWIfOoIfMT0
1_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=
omkNg_oLg=codm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=
on3Ph?oOgmoofm_KomKFe_oBd];oc/k>olc<c?o>c/kod];BomKFe_oKfm_ogmoOon3Ph009on7Qh@0=
on3Ph?oOgmoofm_KomKFe_oBd];oc/k>olc<c?o>c/kod];BomKFe_oKfm_ogmoOon3Ph015on7Qh@Ko
h>3P00?ogmoOon3Ph?oPh>000ooPh>001ooOgmoofMWIom?CdooEeMGofm_KomkNg_oOgml01?oPh>05
omoOg`?oh>3P0ooOgml00ooPh>3ohN7Qon7Qh@1mon7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoTi>@1
onWYj@7okNg]00000oo`l?3okno_oo7al@03oo3`l00Hono_koo`l?3ok^k^onWYjOoKfm_o`L71ojBT
Y?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7aono_kooalO7okno_oo7a
koo_knoolO7a0_o^k^h05?oVi^Kog]kNom7AdOo9bLOo`L71okno_oo1`L7obLW9om7AdOoNg]koi^KV
onk^k?o^k^kolO7aono_kooalO7okno_oo7alOo_knoolO7_0_o^k^h02ooVi^Kog]kNom7AdOo9bLWo
`L71okno__o1`L7obLW9om7AdOoNg]koi^KV00;ok^k^04WolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_koo`l?3ok>c/on_[jooZj^[ok^k/00?ojn_[00Sokno_onc/k?o/k>coj^[Zonc/j_oUiNGo
NGUiokbl_0;oiNGU00SojNWYon[Zj_o_kngokNg]onc/k?oWinOoj>SXonOWi`;ojNWY08cok^k/ong]
kOo]kNgoj>SXonWYjOoZj^[okno_onk^k_oalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3`ono_k`Col?3`00000oobl_;ok^k^onOWi`04onGUi@0@onCTi?oOgmoodM7Aok6a/On:
RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:ROna/K7odM7AomkNgP;oi>CT00_oiNGUonCT
i?oUiNCoi>CTonGUiOoRh^;og=cLolo?coo1`L7o/K6aojVYZ003ojBTY01RojVYZOna/K7o`L71olo?
cooLg=_oh^;RonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oRh^;og=cLolo?coo1`L7o/K6aojVY
ZOnTY:CoY:BSojBTY?nYZJWo/K6aol71`Oo?cloog=cLon;Rh_oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTon?ShooNg]h2omWIf@0<omkNgOoLg=cofMWIom_KfooPh>3og]kNom_KfooJf][ogMgL
om[Jf_l>3PkoTY:B0_oDe=@01OoFe]Kof][Jon3PgooOgmoofm_K00CoeMGE08CoemOGomkNgOoOgmoo
g=cLomKFe_oIfMWogMgMon;Rh_oShn?oiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiND2onCTi0CoiNGU00Koi>CTonGUiOoUiNGo
iNGUonSXj?o]kNd1oo;blP0000?om?Cdong]kOoWinL00_oPh>004ooQhN7ogmoOomkNg_oBd];o];Bd
ohN7QomLG5coKC/eoii>@_o=KeoojH=_ole_GonNCT?oKC/foeaLG?n7QhOo];Bdom;Bd_oNg]h01OoP
h>004OoOgmoof][Jolk>c_nl_;coZj^[ok2`/?o7alOofMWIonCTi?oIfMWoalO7ok6a/On[Zj_o_;bl
olk>c_oJf][ogmoO00Goh>3P017ogmoOom[Jf_o>c/ko_;bloj^[Zon`/;3oalO7omWIfOoTi>CofMWI
olO7aona/K7oZj^[okbl_?o>c/kof][JomoOg`13on3Ph00:omkNg_oHf=SodM7Aom;Bd_oHf=Soe]KF
om7AdOoDe=Cof][JomSHf0;od];B01Sof=SHomKFe_l=3@goTI6Aolo?cono_kood=3@om7AdOoGemOo
f=SHom7AdOo=cLgoa<C4om7AdOo=cLgoclo?omOGeooHf=Sodm?Com3@d?o1`L7of=SHomkNg_oOgmml
on3Ph003omoOgooPh>3ogmoO00;ogmoO0ooPh>000ooQhN7oinOWonc/k001ooCdm00000?om_Kfoo;b
l_o[jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWiooJemOohlf;_o]LF7onIf@oofaYOom_:oooKBWooVO
Too]M6?oTSL_of]OGonOWioocLg=on;Rh_oWinL01?oXj>P01ooVi^KogMgMol[:b_ne]KGo_knoonOW
ioo_knl00oo`l?001oo_knoojNWYol71`One]KGob/[:omgMgOoVi^H01OoXj>P01ooVi^KogMgMol[:
b_ne]KGo_knoonOWioo_knl00oo`l?001oo_knoojNWYol71`One]KGob/[:omgMgOoVi^H0@ooXj>P0
8ooVi^KogmoOobh^;_mWIfOogmoOomcLg?l0003oZ:RXon;Rh_oPh>3oEEEEoe=CDooNg]kogMgMo`h>
3_m?Cdoo71`Loa4A4OlS8b?o^;RhomcLg?oMgMgoY:BToaPH6?l61PKoBDU9og=cLol[:b_og]kNomoO
gono_koo9BDUoaPH6?nLW9coinOW08Koj>SX0Oo/k>`1oo;blP7om_Kf00000oogmoOon?ShooShn003
ooShn00CooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFoo^BQoonYY_oo[6UoonhZoon/jKooZRLoo^DROo^
J5WoRC4[oi2@T?o>c/kok^k^ooOgm`04ooShn006ooCdm?oWinOoclo?olK6a_oZj^[om?Cd0_oinOT0
2Oojn_[onOWiooWinOofm_Kojn_[olO7aoo?clooinOWooCdm005ooShn006ooCdm?oWinOoclo?olK6
a_oZj^[om?Cd0_oinOT02Oojn_[onOWiooWinOofm_Kojn_[olO7aoo?clooinOWooCdm013ooShn00R
ooKfm_o_knoo<C4aofm_Koo_knoojn_[o`000?nc/k?olO7aono_komLG5coFEUIonk^k_o]kNgo3`l?
of5QHOo]kNgoiNGUoe5ADOld=3Coj^[Zonc/k?m=CDgoEEEEonWYjOnFUYKo3Ph>obh^;_o^k^kokno_
ogYjN_l`<33ok^k^ooKfmX3on?Sh00?omoOgooShn?ohn?P00_ohn?P01?ogmoOonOWiooOgmoogmoL1
ooShn00000?on_[jooGemOo^k^h00_o/k>`08Oo[jn_ojNWYomoOgonj^[[oNE9Boklb9?oWM6WooHUn
oonHS?onXYKoojRLoojTV?ooVXgooXYoonifJ_o3<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/
on_[jooVi^Kof=SHok^k^ooDe=Coi>CTon_[jooalO7ol_;boo?cl`02oo;blP06ong]kOoUiNGoeMGE
ok^k^ooHf=Soi^KV0_o[jn/03?o/k>cojn_[on_[jooVi^Oof=SHok^k^ooDe=Coi>CTon_[jooalO7o
l_;boo?cl`;ol_;b00KokNg]onGUiOoEeMGo^k^komSHf?oVi^L2on_[j`19onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojNWYon?Shol_;booJFUYon;RhooOgmoo0000ojRXZ002on3Ph02FoeIFE_mDE5Coh^;Son7Q
hOl>3PkoVIVIon7QhOoShn?oXJ6Qo`000?o1`L;oh>3PobLW9on1PH7oi>CTonGUiOm[Jf_o;2`/on7Q
h_oRh^;oDe=CoeQHF?oRh^;ojNWYon[Zj_o/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/1_o[jn/01Oo/k>cojn_[
on_[joo^k^kom_Kf007onOWi00000ookno_olo?cong]k@02onGUi@0OonKVi_oTi>CofMWIok:b/_mi
;Rkob48don=ZG?odNVgooHQloojGR_onVhkooYR;ooj:O_odNfgoif]MolY2=?mk;Rko/[:bomSHf?oT
i>CoiNGUonKVi_oUiNKoiNGUomoOgooAdM7o][JfomCDe?oMgMgoi>CTonKVi`03onc/k007onSXj?oT
i>CogmoOomGEeOnf][OodM7AomoOg`02onGUi@0DonKVi_oUiNGoiNGUomoOh?oAdM7o][JfomCDe?oM
gMgoi>CTonKVi_o/k>cok>c]onc/k?oXj>Soi>CTomoOgooEeMGo][Jfom7AdOoOgn02onGUi@1IonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^Kohn?SomgMgOl];BgoIVIVomcLgOoKfm_o0000oj:RX_oFe]KoemOGoeAD
E?mBDU;og]kOomcLg?l>3PkoU9BDomKFe_oGemOo`<30o`000?nXZ:Sog=cLobHV9_n0P8000_oOgml0
QOmkNg_o:b/[om_Kg?oKfm_oD51@oeEEEOoIfMWoh>3Pon?ShooUiNGoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiND00ooVi^H0
0ooUiNGoi^KVonKViP03onKViP03onGUiOo]kNgom?Cd007ono_k00000oolo?con?Shoo7al@03onk^
kP0Con_[jooQhN7o_;blogXG5oo3?c;odeI9onAXF_o_Mfcom8=iooR7O?oeQ7[olgU]onEYFooIF4[o
a3lbog`G5onl_;cohN7Qonc/k003onk^kP08ong]kOoYjNWof][JokVi^OoGemOog]kNon?ShooVi^H3
on[ZjP08onSXj?oTi>Cog]kNomSHf?ni^KWof][JonWYjOo]kNd3onk^kP08ong]kOoYjNWof][JokVi
^OoGemOog]kNon?ShooVi^H3on[ZjP08onSXj?oTi>Cog]kNomSHf?ni^KWof][JonWYjOo]kNe2onk^
kP08onc/k?oUiNGo;bl_ofYZJ_oUiNGoi>CTo`000?n=SHd2omoOg`0>oe=CDomFEUKojNWYonOWiol>
3PkoUiNGomoOgooNg]koZ:RXo`<30ooKfm_oinOWobLW9on6QXH2onWYj@0:oh61POl];BgoiNGUon7Q
hOmCDe?oF5QHomoOgooVi^Kojn_[ong]kHCok^k^00?okNg]oo;bl_ohn?P00Oolo?`000?ooOgm01Ko
o?cloogmoOomoOgoo?cloo?clooAdM7oJ0L7okPd=?o7?c?odU13omYREOoSKV;oi79TonA_H_oLI5Oo
de53ola1=?ni=3CoJ`L7om;Bd_oclo?oo?cl1?omoOd01ooinOWok>c/okRh^?oKfm_ohN7QonGUiOoY
jNT00_o/k>`02?o]kNgoj^[ZonGUiOoRh^;ofm_KokVi^Oo/k>conOWi1OomoOd01ooinOWok>c/okRh
^?oKfm_ohN7QonGUiOoYjNT00_o/k>`02?o]kNgoj^[ZonGUiOoRh^;ofm_KokVi^Oo/k>conOWi@oom
oOd06?okno_om?Cdoc8b<_maLG7omOGeooShn?l0003o71`Loi^KVooDe=Co92@Tohb<S?okno_on_[j
o`l?3olY:BWoZZZZolg=cOm7AdOo?3`loo_knoojn_[o:RXZoi6AT@;ono_k00[oRh^;oc0`<?ohn?So
kno_oeIFE_mKFe_oj>SXooCdm?okno_oo?clP_omoOd00oolo?cooOgmooclo003oogmo@000:WooOgm
oo[jn_oclo?ok^k^oo3`l?o_knook^k^onWYjOoCdm?oFadMoj8d=?nd:1go`CX]olM9??o?ET[od5M;
om1GB_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_ono_koo^k^kohn?S
ojb/[?o:b/[od];BomOGeooJf]WogMgMomkNg_oMgMgog=cLomOGeooDe=Cob/[:ojb/ZooShn?ok^k^
ono_koo`l?3okno_oo3`l?o_knook^k]on?Shon/[:cob/[:om;Bd_oGemOof][JomgMgOoNg]gogMgM
omcLg?oGemOoe=CDol[:b_n/[:cohn?Sonk^kOo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knook^k^
onSXj?l`<33oJf][on[ZjOo/k>co6ATIoj^[Zom;Bd_o2PX:od=3@ooIfMWokno^onk^k_lV9RKoW9bL
odA4A?l61PKo92@TokZj^_o_knkok^k^ocdm?OnDU9Cokno_onk^k_n@T93o@T92onk^kOn3Ph?o20P8
o`T92OlI6AWoUIFE00;okno_07_ol?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?000_o_knl2oo3`l0Kokno_0Ooclo<1ooWin@7o
o_kn00000oono_komoOgoo3`l004onWYj@0AonOWiooKfm_oHd];oh4b<_nV=CGo]S@]ol9=@Oo3E4Wo
a5E:ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooWinL01OoYjNT01_oXj>Sohn?Soj^[Zoni^KWo
bLW9olo?c`;oeMGE00Woe]KFomGEeOoDe=Coclo?olS8b?ni^KWoZj^[on?ShooXj>P01OoYjNT01_oX
j>Sohn?Soj^[Zoni^KWobLW9olo?c`;oeMGE00Woe]KFomGEeOoDe=Coclo?olS8b?ni^KWoZj^[on?S
hooXj>P0@ooYjNT01_oXj>Soi>CTobl_;omYJFWoiNGUonSXj0?ojNWY00?oj>SXonWYjOoYjNT01OoY
jNT00ooWinOojNWYonWYj@08onWYj@;oj>SX00CoE5ADoeUIFOoXj>Soj>SXP?oYjNT00ooXj>SojNWY
onWYj@04onWYj@7ol?3`0OogmoL1ooknoP0000Goo_knoo[jn_odm?Cokno_oo7al@02oo3`l00Aono_
koo[jn_oUIBDodlS8onEE5Co^g=com>EUOoJW9cofYjLomVLW?oDUIGo^g=coiEDE?m?8b?oUIBDon[Z
j_o_knl01_o`l?001_o^k^kobl_;ojNWYoo8b<Sof=SHon?Sh`?oi^KV00Kohn?SomSHf?o8b<SoYjNW
ol_;boo^k^h7oo3`l006onk^k_o;bl_oYjNWolS8b?oHf=Sohn?S0ooVi^H01_oShn?of=SHolS8b?nW
YjOobl_;onk^kTCol?3`00Kokno_onk^k_l`<33oKVi^onk^k_o_knlGoo3`l004ono_kooEeMGoc/k>
ono_khKol?3`00ColO7aoo3`l?odm?Con_[j0Oono_h00004oogmoOooooooooooooknoP;ooooo0_on
o_h0ooomoOgon?Shofi^K_mJ?coo/I2@omk9bOo`i>ColnKVoo3Ti?oNbLWo/I2@oeXo?om]KFgon?Sh
ooclo?ooooooo_knooooooono_koooonookno_oooooooOgmooclo?o5aLGo^[ZjomgMgOoalO3on?Sh
ooWinOohn?SolO7aomgMgOnj^[[oaLG5ooclnoomoOgoooooookno_ooooooo_knooooooono_koooon
oogmoOolo?coaLG5okZj^_oMgMgolO7aooShn?oinOSon?Shoo7alOoMgMgo^[ZjolG5aOolo?cooOgm
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_kooooooogmoOn^[ZkoalO7ooknoOono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ooknoP007oooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooool00_ono_h01Oooooooo_knooooooooooooo_kn00Gooooo0OomoOd00004oo[jn_on
o_kon_[jooCdm0GolO7a00gokno_omKFe_m[Jf_o@cdmoi^<S?o6^[[oe/c<olNj^_nKS8co@cdmof][
JooFe]Kokno_00WolO7a00gol?3`onKVi_nm_Kgo/;2`olo?cooOgmooiNGUomoOgoo?cloo/;2`okfm
_OoVi^Kol?3`00WolO7a00gol?3`onKVi_nm_Kgo/;2`olo?cooOgmooiNGUomoOgoo?cloo/;2`okfm
_OoVi^Kol?3`0>GolO7a00Col?3`oo7alOoalO7ol?3`1?oalO400oodm?Con_[jooknoP01ooWin@00
00Gom?CdoogmoOohn?Sol?3`on_[j`03on[ZjP0=onWYjOoZj^[ojNWYonSXj?nKVi_oFEUIobHV9_l9
2@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0<on[ZjP09onWYjOo:b/[o/K6aoifMWOnBTY;oWIfMok6a/Oo:
b/[ojNWY00goj^[Z00WojNWYol[:b_na/K7oWIfMoi:BT_nMWIgo/K6aol[:b_oYjNT0k_oZj^X01?o[
jn_ol?3`ooShn?omoOd1ooCdm00000Co^k^kooShn?ojn_[om?Cd2?oalO42oo3`l0?okno_0_o`l?0A
oo7al@?ol?3`4ooalO43oo3`l>golO7a00?ol?3`oo7alOoalO400_oalO400ooemOGon_[jooShn001
ok^k^`0000?o`<30okjn__ogmoL0ooooool^ooooo`7omoOg0Onn_[h1ol30`00000Koh^;RolK6a_nk
^k_ojn_[oo[jn_omoOgoooooobSooooo00Goo_knoo[jn_o[jn_o^k^kolK6aP01on;RhP00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{307, 140},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    \( (*\ Text\ Input\ *) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(JavaBlock[\[IndentingNewLine]JavaShow[
        frame]; \[IndentingNewLine]ShowInputDialog[pane, 
        MakeJavaObject["\<Input String\>"]]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \("Calling Java from Mathematica"\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JFileChooser <<< from J/Link Examples \
Part1",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[BoxData[
    RowBox[{
      StyleBox[\(FileChooserDialog[]\),
        FontWeight->"Bold"], " ", "is", " ", "originally", " ", "provided", 
      " ", "in", "  ", \(FileChooserDialog . nb\), " ", "in", 
      " ", \(\(JLink/Examples\)/\(\(Part1\)\(.\)\)\)}]], "Text",
  CellFrame->True,
  Background->GrayLevel[0.849989]],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007l0001HAP00`40o`00
0?l0003oo`000?d000000003R<2hB928B9280?m8T8SiB9280@00000000>8
`;S8h=R8`;P0ohS0^?R8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?R8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<E/c<c4Ooool6c<c<Aoooo`_<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c5G<c<`00fIVI/c<c6IVIP14
IVIV00?oooo<c<c<c<`00lc<c003IVIVc<c<IVIV04AVIVH00oooolc<c<c<
c009c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<aEc<c<00=V
IVKoooo<c<`0@lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c013c<c<
00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<ELc<c003IVIVooooc<c<04?<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`0@lc<c003IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c5G<c<`00fIVI_ooolc<c013c<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<04?<c<`00fIVI_ooolc<c00:c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<aEc<c<00=VIVKoooo<c<`0@lc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c013c<c<00=VIVKoooo<c<`02/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<ELc<c003IVIVoooo
c<c<01_<c<`200009/c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c013
c<c<00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Soc<c<ELc<c003IVIVooooc<c<01_<c<`200009/c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c00Cc<c<0`0000?<c<`01@000<c<c<c<c<c<c000
0002c<c<0P0000;<c<`200001/c<c0030000c<c<c<c<01C<c<`00fIVI_oo
olc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<aEc<c<
00=VIVKoooo<c<`05<c<c0@00003c<c<0P000003c<c<0000000000?<c<`4
00000/c<c0800002c<c<0P0001C<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`03lc<c0040000c<c<c<c<c<c<1`0000;<c<`200000/c<c0800003
c<c<0P0000C<c<`600004/c<c003IVIVooooc<c<00[<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2holc<c5G<c<`00fIVI_ooolc<c00Cc<c<0P00
00;<c<`200000/c<c0<000001<c<c00000000<c<c0800002c<c<0P000003
c<c<0000000000;<c<`200005<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c00?c<c<1P000004c<c<0000000000001<c<c08000000lc<c0000000
0003c<c<0P0000?<c<`200001<c<c0<0000@c<c<00=VIVKoooo<c<`02/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<ELc<c003IVIVoooo
c<c<01;<c<`200001<c<c08000000lc<c00000000002c<c<0P000003c<c<
0000000000G<c<`200000/c<c080000Dc<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<013<c<`2000000C<c<`00000003<c<`300001<c<c0X00003
c<c<0P0000G<c<`00`000<c<c<c<c00?c<c<00=VIVKoooo<c<`02/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<ELc<c003IVIVooooc<c<
01;<c<`200001<c<c08000000lc<c00000000002c<c<0P000003c<c<0000
000000@000000lc<c00000000002c<c<0P0001C<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`04<c<c0T00005c<c<00@0003<c<`000000003c<c<
0P0000?<c<`200005lc<c003IVIVooooc<c<00[<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2holc<c5G<c<`00fIVI_ooolc<c00Bc<c<0P0000C<
c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P00
0003c<c<0000000000;<c<`200005<c<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c00@c<c<0P000003c<c<0000000000@00004c<c<00<0003<c<c<
c<`01`0000?<c<`200005lc<c003IVIVooooc<c<00[<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2holc<c5G<c<`00fIVI_ooolc<c00Bc<c<0P00
00C<c<`2000000G<c<`000000000003<c<`00P000003c<c<0000000000;<
c<`2000000G<c<`000000000003<c<`00P0001C<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`04<c<c08000000lc<c00000000002000000?<c<`0
000000000/c<c0<000000lc<c00000000003c<c<0P0000?<c<`200005lc<
c003IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
olc<c5G<c<`00fIVI_ooolc<c00Bc<c<0P0000C<c<`2000000C<c<`00000
003<c<`200000lc<c0@00002c<c<0P000003c<c<0000000001G<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`04<c<c0L000000lc<c00000000003
c<c<00<0003<c<c<c<`01`0000?<c<`200005lc<c003IVIVooooc<c<00[<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c5G<c<`00fIVI_oo
olc<c00Cc<c<0P0000;<c<`20000:/c<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c00@c<c<0P000003c<c<0000000000D00004c<c<200000C<c<`2
00005lc<c003IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2holc<c5G<c<`00fIVI_ooolc<c00Dc<c<100002_<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`03lc<c0L00007c<c<0P000003c<c<0000
000000D00003c<c<0P0001O<c<`00fIVI_ooolc<c00:c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<aEc<c<00=VIVKoooo<c<`0@lc<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c00Lc<c<00H0003<c<c<c<c<c<`0
003<c<`300007/c<c003IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c5G<c<`00fIVI_ooolc<c013c<c<00=VIVKoooo<
c<`01<c<c003IVIVooooc<c<04?<c<`00fIVI_ooolc<c00:c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<aEc<c<00=VIVKoooo<c<`0@lc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c013c<c<00=VIVKoooo<c<`0
2/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<ELc<c003IVIV
ooooc<c<04?<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0@lc<c003
IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c5G<c<`00fIVI_ooolc<c013c<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<04?<c<`00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^?o<c<aEc<c<00=VIVKoooo<c<`0@lc<c003IVIVooooc<c<00C<
c<`00fIVI_ooolc<c013c<c<00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<ELc<c003IVIVooooc<c<04?<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0@lc<c003IVIVooooc<c<00[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c5G<c<`00fIVI_oooooo
o`13oooo00?<c<coooo<c<`01<c<c003IVIVoooooooo04?oool00lc<c?oo
olc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<aEc<c<
AfIVIPK<c<a7IVIV3<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Qdc<c<ooooogKoool;c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^7?<c<`00fIVI/c<c6IVIP3oIVIV
LfIVIP03ooooc<c<c<c<00W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hLlc<c003IVIVooooc<c<0?o<c<abc<c<00=VIVKoooo<c<`02/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Qcc<c<00=VIVKoooo<c<`0olc<
c7;<c<`00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^7?<c<`00fIVI_ooolc<c03oc<c<L/c<c003IVIVooooc<c<00[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2hLlc<c003IVIVooooc<c<0?o<
c<abc<c<00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Qcc<c<00=VIVKoooo<c<`0olc<c7;<c<`00fIVI_ooolc<c00:c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0o<c<`00`000<c<c<c<c00:
c<c<0P0000g<c<`200001lc<c0030000c<c<c<c<00[<c<`300003Lc<c080
0008c<c<00<0003<c<c<c<`05Lc<c003IVIVooooc<c<00K<c<`200009lc<
c0030000c<c<c<c<00K<c<`00`000<c<c<c<c009c<c<0P0000k<c<`20000
1lc<c0030000c<c<c<c<0?o<c<`Bc<c<00=VIVKoooo<c<`02/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P?c<c<100000[<c<`200003<c<c080
0006c<c<0`0000;<c<`300002<c<c0<0000;c<c<0P0000S<c<`400001/c<
c080000<c<c<00=VIVKoooo<c<`01lc<c080000Hc<c<1@0000C<c<`30000
00?<c<`0000000000P0000K<c<`400002Lc<c080000=c<c<0P0000K<c<`3
00000/c<c0<0003oc<c<3/c<c003IVIVooooc<c<00[<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h4Lc<c0<0000:c<c<0P0000_<c<`200001lc<
c0800002c<c<100000S<c<`400002Lc<c080000:c<c<0`0000G<c<`20000
3<c<c003IVIVooooc<c<00S<c<`200003lc<c0030000c<c<c<c<00C<c<`2
00001lc<c0D00002c<c<0`0000O<c<`300002Lc<c080000<c<c<0P0000O<
c<`200000/c<c0@0003oc<c<3Lc<c003IVIVooooc<c<00[<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h4lc<c0800009c<c<0P0000O<c<`01000
0<c<c<c<c<c<c0800008c<c<0P000004c<c<00000000c<c<0`0000O<c<`4
00001<c<c0040000c<c<c<c<c<c<0P0000c<c<`200004/c<c003IVIVoooo
c<c<00K<c<`400001/c<c0030000c<c<c<c<00G<c<`300001<c<c0800008
c<c<0P000003c<c<0000000000?<c<`300002<c<c0800008c<c<0P0000S<
c<`010000<c<c<c<c<c<c0800008c<c<0P000004c<c<00000000c<c<0`00
0?o<c<`;c<c<00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;PDc<c<0P0000S<c<`400001<c<c0@000000lc<c00000000008
c<c<0P000003c<c<0000000000;<c<`200000/c<c0800003c<c<0`0000C<
c<`4000000?<c<`0000000003Lc<c080000Ac<c<00=VIVKoooo<c<`01Lc<
c08000000lc<c00000000006c<c<0P0000G<c<`300001Lc<c0800008c<c<
0P0000;<c<`200000lc<c0800009c<c<0P0000O<c<`400001Lc<c0@00000
0lc<c00000000008c<c<0P000003c<c<0000000000;<c<`20000olc<c080
0009c<c<00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;PDc<c<0`0000O<c<`500001Lc<c0D00008c<c<0P000003c<c<0000
000000?<c<`010000<c<c<c<c<c<c0L00006c<c<1@0000g<c<`300004<c<
c003IVIVooooc<c<00G<c<`2000000?<c<`0000000001lc<c0800002c<c<
0`0000O<c<`200002<c<c0800002c<c<0P0000?<c<`200002Lc<c0<00006
c<c<1@0000K<c<`500002<c<c08000000lc<c00000000003c<c<00<0003<
c<c<c<`0o<c<c0@00008c<c<00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;PEc<c<0P0000C<c<`900001/c<c0<00008c<c<
0P000003c<c<0000000000O<c<`300000lc<c0800007c<c<0`0000k<c<`2
00000/c<c080000<c<c<00=VIVKoooo<c<`01/c<c0@00008c<c<1@0000W<
c<`200001lc<c0<000000lc<c00000000002c<c<0`0000[<c<`200000lc<
c0T00007c<c<0`0000S<c<`2000000?<c<`000000000olc<c0;<c<`60000
1lc<c003IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h5Lc<c080000;c<c<00<0003<c<c<c<`01/c<c0<00007c<c<0P000003
c<c<0000000000S<c<`200000lc<c0800008c<c<0`0000g<c<`200000/c<
c080000<c<c<00=VIVKoooo<c<`00lc<c0L00009c<c<0`0000;<c<`01000
0<c<c<c<c<c<c0<000001<c<c0000000000000O<c<`2000000?<c<`00000
00000/c<c080000;c<c<0P0000[<c<`00`000<c<c<c<c007c<c<0`0000O<
c<`2000000?<c<`000000000olc<c07<c<`800001/c<c003IVIVooooc<c<
00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3/c<c0T0000Ec<c<
100000G<c<`2000000?<c<`0000000002Lc<c0H00009c<c<100000C<c<`9
00004<c<c003IVIVooooc<c<00S<c<`600002<c<c0@00004c<c<2@0000C<
c<`700001Lc<c0T0000Ec<c<100000G<c<`2000000?<c<`000000000olc<
c0X00005c<c<00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P]c<c<0P0001C<c<`300003Lc<c080000<c<c<100000k<c<`0
0fIVI_ooolc<c008c<c<0P0000g<c<`300002lc<c0030000c<c<c<c<00K<
c<`00`000<c<c<c<c00Uc<c<0P000?o<c<`Jc<c<00=VIVKoooo<c<`02/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P]c<c<00<0003<c<c<c<`0
5<c<c0030000c<c<c<c<00c<c<`00`000<c<c<c<c00;c<c<100000k<c<`0
0fIVI_ooolc<c008c<c<0P0000g<c<`00`000<c<c<c<c00lc<c<00<0003<
c<c<c<`0olc<c1W<c<`00fIVI_ooolc<c00:c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^7?<c<`00fIVI_ooolc<c03oc<c<L/c<c003IVIVoooo
c<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hLlc<c003IVIV
ooooc<c<0?o<c<abc<c<00=VIVKoooo<c<`02/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Qcc<c<00=VIVKoooo<c<`0olc<c7;<c<`00fIVI_oo
olc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^7?<c<`00fIV
I_ooolc<c03oc<c<L/c<c003IVIVooooc<c<00[<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hLlc<c003IVIVooooc<c<0?o<c<abc<c<00=VIVKo
ooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qcc<c<00=V
IVKoooooool0ooooog;oool00lc<c?ooolc<c00:c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^7?<c<coIVIVMVIVIPc<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2holc<c?G<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2holc<c?G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?G<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c?G<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hM<c<c?oooomfoooo2lc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Qcc<c<00=VIVK<c<aVIVH0ofIVIW=VIVH00oooolc<
c<c<c009c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^7?<c<`00fIV
I_ooooooo`3oooooL_ooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hLlc<c003IVIVoooooooo0?oooomboooo00=VIVKo
ooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P?c<c<00<0
003<c<c<c<`02/c<c080000=c<c<0P0000O<c<`00`000<c<c<c<c00<c<c<
0P0000?<c<`20000:Lc<c003IVIVoooooooo0?oooomboooo00=VIVKoooo<
c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P?c<c<100000[<
c<`200003<c<c0800006c<c<0`0000;<c<`300002<c<c0L000000lc<c000
0000000Vc<c<00AVIVKoooooool00002oooo00@0003oooooool00003oooo
0P000004oooo0000oooooooo0P000003oooo0000oooo00;oool010000?oo
ooooo`0000Goool00`000?ooooooo`0300000oooo`050000oooooooooooo
000000?oool010000?ooooooooooo`<00003oooo00@0003oooooool00003
oooo0`0000;oool01@000?ooooooooooo`000002oooo0`000?oooolQoooo
00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PA
c<c<0`0000[<c<`200002lc<c0800007c<c<0P0000;<c<`400001<c<c003
0000c<c<c<c<00800003c<c<0P000003c<c<0000000002K<c<`016IVI_oo
ooooo`0000;oool010000?ooooooo`0000;oool00`000?ooooooo`020000
0_ooo`040000oooooooo00000oooo`040000oooooooo00001?ooo`040000
oooooooo00000oooo`040000oooooooo00000oooo`050000oooooooooooo
000000;oool01@000?ooooooooooo`000002oooo00<0003oooooool00ooo
o`050000oooooooooooo000000;oool00`000?ooo`000002oooo00D0003o
ooooooooool00000ooooob3oool00fIVI_ooolc<c00:c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^1?<c<`200002Lc<c0800007c<c<00@0003<
c<c<c<c<c<`200002<c<c08000001<c<c00000000<c<c0<00002c<c<1@00
00?<c<`20000:Lc<c00:IVIVoooooooo0000oooo0000oooo0000oooo0000
0_ooo`050000oooooooooooo000000;oool010000?ooooooo`0000?oool0
10000?ooooooo`0000?oool01@000?ooooooooooo`000006oooo00D0003o
ooooooooool000000oooo`040000oooooooo00001_ooo`030000oooooooo
00?oool00`000?ooooooo`04oooo0P0000?oool00`000?ooooooo`3ooooo
8_ooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h5<c<c0800008c<c<100000C<c<`4000000?<c<`0000000002<c<c080
00000lc<c00000000002c<c<0P0000C<c<`80000:Lc<c00:IVIVoooooooo
0000oooo0000oooo0000oooo00000oooo`@00002oooo00@0003oooooool0
0003oooo00<0003oooooool00P000003oooo0000oooo00?oool500000_oo
o`050000oooooooooooo000000?oool00`000?ooooooo`0500000_ooo`03
0000oooooooo00?oool500000oooo`040000oooooooooooo1@000?oooolP
oooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;PDc<c<0`0000O<c<`500001Lc<c0D00008c<c<0P000003c<c<00000000
00?<c<`010000<c<c<c<c00000?<c<`20000;Lc<c00:IVIVoooooooo0000
oooo0000oooo0000oooo00001_ooo`040000oooooooo00000_ooo`050000
oooooooooooo000000;oool00`000?ooo`000005oooo00D0003ooooooooo
ool000000_ooo`050000oooooooooooo000000?oool010000?ooooooo`00
00?oool010000?ooooooo`0000Goool01@000?ooooooooooo`000002oooo
00<0003oool000000_ooo`050000oooooooooooo00000?oooolPoooo00=V
IVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PEc<c<
0P0000C<c<`900001/c<c0<00008c<c<0P000003c<c<0000000000K<c<`3
000000C<c<`0000000000004c<c<0P0002K<c<`02VIVI_ooooooo`000?oo
o`000?ooo`000?ooo`0000;oool01@000?ooooooooooo`000002oooo00<0
003oooooool00P0000;oool010000?ooooooo`0000;oool00`000?oooooo
o`02oooo00D0003oooooooooool000000_ooo`800002oooo0P0000;oool0
10000?ooooooo`0000?oool010000?ooooooo`0000Goool01@000?oooooo
ooooo`000002oooo00<0003oool000000_ooo`050000oooooooooooo0000
0?oooolPoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;PEc<c<0P0000_<c<`00`000<c<c<c<c006c<c<0`0000O<c<`2
000000?<c<`0000000001lc<c0@000000lc<c00000000003c<c<0P0002K<
c<`00fIVI_ooooooo`0200000oooo`800003oooo0`0000;oool3000000?o
ool0003oool00P0000?oool01@000?ooooooooooo`000004oooo0`0000?o
ool01P000?ooo`000?ooo`000?ooo`800004oooo0`0000?oool00`000?oo
ooooo`04oooo0`0000;oool01@000?ooooooooooo`000002oooo0`000?oo
oolQoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P>c<c<2@0001G<c<`400001Lc<c08000000lc<c00000000008c<c<
0`0000;<c<`30000:Lc<c003IVIVoooooooo00800003oooo0P0000Woool0
10000?ooooooo`0000Koool00`000?ooooooo`02oooo00<0003oooooool0
6Oooo`030000oooooooo0?ooooldoooo00=VIVKoooo<c<`02/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P]c<c<0P0001C<c<`60000:/c<c004
IVIVoooooooo00001Oooo`030000oooooooo00Ooool010000?ooooooo`00
00Koool00`000?ooooooo`03oooo00<0003oooooool06?ooo`030000oooo
oooo0?ooooldoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P]c<c<00<0003<c<c<c<`04lc<c080000^c<c<00=VIVKo
ooooool0ooooog;oool00fIVI_ooolc<c00:c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^7?<c<`00fIVI_ooooooo`3oooooL_ooo`03IVIVoooo
c<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hLlc<c003IVIV
oooooooo0?oooomboooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Qcc<c<00=VIVKoooooool0ooooog;oool00fIVI_oo
olc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^7?<c<`00fIV
I_ooooooo`3oooooL_ooo`03c<c<ooooc<c<00[<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hLlc<c?mVIVIfIVIV3<c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<
mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<
mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P=c<c<ooooomgoool;c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0c<c<`00fIVI/c<c6IVIP3oIVIVfVIVIP03ooooc<c<c<c<00W<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooooooo0?oo
oooIoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P<c<c<00=VIVKoooooool0ooooomWoool00fIVI_ooolc<c00:c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`00fIVI_ooooooo`3o
oooofOooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h3<c<c003IVIVoooooooo0?oooooIoooo00=VIVKoooo<c<`02/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00=VIVKoooooool0
ooooomWoool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0c<c<`00fIVI_ooooooo`3ooooofOooo`03IVIVooooc<c<00[<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooooooo
0?oooooIoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P<c<c<00AVIVKoooooooooool=0000oooool_oool00fIVI_oo
olc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`01FIV
I_ooooooooooo`00000;c<co00<0003oooooool0ooooolWoool00fIVI_oo
olc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`01VIV
I_ooooooooooo`000<c<o`Woool00lc<o`000?ooo`3ooooob_ooo`03IVIV
ooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c006
IVIVoooooooooooo0000c<co2Oooo`03c<co0000oooo00Coool200000_oo
o`030000oooooooo00800002oooo1@0000;oool2000000?oool000000000
0_ooo`800002oooo100000;oool200000_ooo`800002oooo0P0000;oool5
00000_ooo`8000000oooo`0000000002oooo100000?oool5000000?oool0
000000000_ooo`@00002oooo0P0000;oool200000_ooo`@0003oooooI_oo
o`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
3<c<c006IVIVoooooooooooo0000c<co2Oooo`03c<co0000oooo00Coool2
000000Goool000000000003oool00P000003oooo0000000000;oool20000
00?oool0000000000_ooo`800002oooo0P000003oooo0000000000;oool2
000000?oool0000000000_ooo`800002oooo0P000003oooo0000000000;o
ool2000000?oool0000000000_ooo`8000000oooo`0000000002oooo0P00
0003oooo0000000000;oool2000000Coool00000003oool200000_ooo`80
00000oooo`0000000002oooo0P000003oooo0000000000;oool20000oooo
ofGoool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0c<c<`01VIVI_ooooooooooo`000<c<o`Woool00lc<o`000?ooo`04
oooo0P000005oooo000000000000oooo008000000oooo`0000000002oooo
0P000003oooo0000000000;oool200000_ooo`8000000oooo`0000000005
oooo0P0000;oool200000_ooo`8000000oooo`0000000002oooo0P000003
oooo0000000000;oool2000000?oool0000000001Oooo`800002oooo0P00
00Coool200001_ooo`@00002oooo0P000?oooomYoooo00=VIVKoooo<c<`0
2/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00IVIVKooooo
ooooool0003<c?l9oooo00?<c?l0003oool01?ooo`8000001Oooo`000?oo
o`000?ooo`0200000_ooo`8000001?ooo`0000000?ooo`800002oooo0P00
00;oool2000000?oool00000000010000003oooo0000000000;oool20000
0_ooo`800002oooo0P000004oooo00000000oooo0P0000;oool2000000?o
ool0000000001_ooo`8000000oooo`0000000004oooo1P0000?oool20000
0oooo`H0003oooooIOooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h3<c<c006IVIVoooooooooooo0000c<co2Oooo`03
c<co0000oooo00Coool2000000Goool0003oool0003oool00P0000?oool4
000000?oool0000000000_ooo`800002oooo0P000003oooo0000000000;o
ool2000000?oool0000000000_ooo`800002oooo0P0000?oool4000000?o
ool0000000000_ooo`8000000oooo`0000000007oooo100000Coool20000
0_ooo`800002oooo100000;oool200000_ooo`80003oooooIOooo`03IVIV
ooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c006
IVIVoooooooooooo0000c<co2Oooo`03c<co0000oooo00Coool4000000?o
ool0000000000P000003oooo0000oooo00;oool2000000?oool000000000
0_ooo`<000001?ooo`0000000?ooo`800002oooo0P000005oooo00000000
0000oooo00<000001Oooo`0000000?ooo`000003oooo0P000003oooo0000
000000;oool2000000?oool0000000000_ooo`8000000oooo`000?ooo`02
oooo0P0000Coool200000_ooo`8000000oooo`0000000002oooo0P000003
oooo0000000000;oool20000ooooofGoool00fIVI_ooolc<c00:c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`01VIVI_ooooooooooo`00
0<c<o`Woool200001Oooo`@000000oooo`000000000200000_ooo`@00000
0oooo`0000000002000000Coool00000003oool200000oooo`@00002oooo
0P000003oooo0000000000;oool200000oooo`@000000oooo`0000000002
000000?oool0000000000_ooo`@00003oooo100000Koool400000_ooo`80
0002oooo0P0000;oool40000ooooofKoool00fIVI_ooolc<c00:c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`01VIVI_ooooooooooo`00
0<c<o`Soool200001_ooo`<00003oooo0`0000Soool200000_ooo`80000N
oooo0P000?oooon?oooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P<c<c<00IVIVKoooooooooool0003<c?l7oooo00<0
003<c?l000001_ooo`<00003oooo0`0000Woool00`000?ooooooo`020000
7oooo`030000oooooooo0080003oooooRoooo`03IVIVooooc<c<00[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c006IVIVoooooooooooo
0000c<co1_ooo`030000c<co00000?ooooo=oooo00=VIVKoooo<c<`02/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00IVIVKooooooooo
ool0003<c?l5oooo00@0003<c?ooool0003ooooocOooo`03IVIVooooc<c<
00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c005IVIVoooo
oooooooo000000O<c?l20000ooooolkoool00fIVI_ooolc<c00:c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`016IVI_ooooooooooo`X0
003oooooc_ooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h3<c<c003IVIVoooooooo0?oooooIoooo00=VIVKoooo<c<`0
2/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00=VIVKooooo
ool0ooooomWoool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0c<c<`00fIVI_ooooooo`3ooooofOooo`03IVIVooooc<c<
00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooo
oooo0?oooooIoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P<c<c<00=VIVKoooooool0ooooomWoool00fIVI_ooolc<
c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`00fIVI_oo
ooooo`3ooooofOooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h3<c<c004IVIVoooooooooooo3@000?ooooo;oooo00=V
IVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<
00EVIVKoooooooooool000002lc<o`030000oooooooo0?ooooo9oooo00=V
IVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<
00IVIVKoooooooooool0003<c?l9oooo00?<c?l0003oool0oooool[oool0
0fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<
c<`01VIVI_ooooooooooo`000<c<o`Woool00lc<o`000?ooo`04oooo0P00
00;oool200000_ooo`800002oooo1@0000;oool2000000?oool000000000
0_ooo`8000000oooo`0000000002oooo100000;oool200000_ooo`800002
oooo10000?oooonCoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P<c<c<00IVIVKoooooooooool0003<c?l9oooo00?<
c?l0003oool01?ooo`800002oooo0P0000;oool2000000?oool000000000
0_ooo`8000000oooo`0000000002oooo0P0000;oool2000000Coool00000
003oool200000_ooo`8000000oooo`0000000002oooo0P000003oooo0000
000000;oool20000oooooi;oool00fIVI_ooolc<c00:c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0c<c<`01VIVI_ooooooooooo`000<c<o`Wo
ool00lc<o`000?ooo`04oooo0P0000;oool200000_ooo`8000000oooo`00
00000002oooo0P000003oooo0000000000;oool200000_ooo`800004oooo
0P0000Koool400000_ooo`80003oooooU_ooo`03IVIVooooc<c<00[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c006IVIVoooooooooooo
0000c<co2Oooo`03c<co0000oooo00Coool200000_ooo`800002oooo0P00
00;oool2000000Coool00000003oool200000_ooo`800002oooo0P0000Co
ool600000oooo`800003oooo1P000?oooonBoooo00=VIVKoooo<c<`02/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00IVIVKooooooooo
ool0003<c?l9oooo00?<c?l0003oool01?ooo`800002oooo0P0000;oool2
00000oooo`@000000oooo`0000000002oooo0P0000;oool200001?ooo`80
0002oooo0P0000;oool400000_ooo`800002oooo0P000?oooonBoooo00=V
IVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<
00IVIVKoooooooooool0003<c?l9oooo00?<c?l0003oool01?ooo`<00000
1Oooo`00000000000?ooo`02000000?oool0003oool00_ooo`8000000ooo
o`0000000002oooo0`000003oooo0000000000Coool200000_ooo`800000
0oooo`0000000002oooo0P000003oooo0000000000;oool20000oooooi;o
ool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0c<c<`01VIVI_ooooooooooo`000<c<o`Woool200001Oooo`8000000ooo
o`0000000002oooo0P0000?oool4000000?oool0000000000P000004oooo
00000000oooo0P0000Koool400000_ooo`800002oooo0P0000;oool40000
oooooi?oool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0c<c<`01VIVI_ooooooooooo`000<c<o`Soool200006?ooo`80
0002oooo0P000?oooon^oooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P<c<c<00IVIVKoooooooooool0003<c?l7oooo
00<0003<c?l000006Oooo`030000oooooooo0080003ooooo[_ooo`03IVIV
ooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c006
IVIVoooooooooooo0000c<co1_ooo`030000c<co00000?ooooo=oooo00=V
IVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<
00IVIVKoooooooooool0003<c?l5oooo00@0003<c?ooool0003ooooocOoo
o`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
3<c<c005IVIVoooooooooooo000000O<c?l20000ooooolkoool00fIVI_oo
olc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`016IV
I_ooooooooooo`X0003oooooc_ooo`03IVIVooooc<c<00[<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooooooo0?oooooIoooo
00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<
c<c<00=VIVKoooooool0ooooomWoool00fIVI_ooolc<c00:c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0c<c<`00fIVI_ooooooo`3ooooofOoo
o`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
3<c<c003IVIVoooooooo0?oooooIoooo00=VIVKoooo<c<`02/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00=VIVKoooooool0ooooomWo
ool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0c<c<`00fIVI_ooooooo`3ooooofOooo`03IVIVooooc<c<00[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooooooo0?oooooI
oooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P<c<c<00=VIVKoooooool06_ooo`<0003ooooo_?ooo`03IVIVooooc<c<
00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooo
000000l0000=oooo0P000?oooonkoooo00=VIVKoooo<c<`02/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00AVIVKoool0003oool=c<co
00<0003oooooool00oooo`D00003oooo0`0000?oool400000oooo`800002
oooo100000;oool200000_ooo`800002oooo0P000003oooo0000000000Co
ool2000000?oool0000000000_ooo`@00003oooo10000?oooon3oooo00=V
IVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<
00AVIVKoool0003oool=c<co00<0003oooooool00_ooo`800003oooo0P00
00;oool300000_ooo`800002oooo0P000003oooo0000000000;oool20000
0_ooo`8000000oooo`0000000002oooo0P0000;oool2000000?oool00000
00001?ooo`8000001?ooo`0000000?ooo`800002oooo0P000003oooo0000
000000;oool20000oooooh;oool00fIVI_ooolc<c00:c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0c<c<`016IVI_ooo`000?ooo`g<c?l00`00
0?ooooooo`07oooo0P000004oooo00000000oooo0P0000Coool3000000?o
ool0000000000_ooo`800005oooo0P0000;oool200000_ooo`8000000ooo
o`0000000004oooo0P000004oooo00000000oooo0P0000Soool30000oooo
oh;oool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0c<c<`016IVI_ooo`000?ooo`g<c?l00`000?ooooooo`05oooo1000
0004oooo00000000oooo0P0000;oool400000_ooo`800002oooo1P000003
oooo0000000000;oool200000_ooo`8000000oooo`0000000004oooo0P00
0004oooo00000000oooo1P0000;oool40000oooooh?oool00fIVI_ooolc<
c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`016IVI_oo
o`000?ooo`g<c?l00`000?ooooooo`03oooo1@0000;oool2000000Coool0
0000003oool300001?ooo`800002oooo0P0000;oool2000000?oool00000
00000_ooo`800002oooo0P000003oooo0000000000<000001?ooo`000000
0?ooo`8000000oooo`0000000002oooo0P000004oooo000000000000oooo
ohGoool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0c<c<`016IVI_ooo`000?ooo`g<c?l00`000?ooooooo`02oooo1000
00?oool200000oooo`@00002oooo0P000003oooo0000000000;oool20000
0_ooo`8000001Oooo`00000000000?ooo`03000000Coool00000003oool2
00001?ooo`8000001?ooo`0000000?ooo`800002oooo0P000003oooo0000
000000;oool20000oooooh;oool00fIVI_ooolc<c00:c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0c<c<`016IVI_ooo`000?ooo`g<c?l00`00
0?ooooooo`02oooo0P0000Goool200000oooo`8000000oooo`0000000002
000000?oool0000000000P0000;oool400000_ooo`8000000oooo`000000
0002oooo0P0000;oool200001?ooo`8000000oooo`0000000002oooo1000
00?oool40000oooooh?oool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0c<c<`016IVI_ooo`000?ooo`O<c?l6oooo00<0
003oooooool00_ooo`800003oooo0P0000koool200005?ooo`800007oooo
0P000?oooon@oooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P<c<c<00=VIVKoool000002?ooo`L00005oooo1@00013o
ool00`000?ooooooo`0Boooo1@000004oooo00000000oooo0P000?oooon@
oooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P<c<c<00=VIVKoooooool0200000JIVL`00`000?ooooooo`3ooooob?oo
o`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
3<c<c003IVIVoooooooo00Soool7IVJIoooool[oool00fIVI_ooolc<c00:
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`00fIVI_oooooo
o`09oooo1VIVVOooooo:oooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P<c<c<00=VIVKoooooool0ooooomWoool00fIV
I_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`0
0fIVI_ooooooo`3ooooofOooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooooooo0?oooooIoooo00=V
IVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<
00=VIVKoooooool0ooooomWoool00fIVI_ooolc<c00:c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0c<c<`00fIVI_ooooooo`3ooooofOooo`03
IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<
c003IVIVoooooooo0?oooooIoooo00=VIVKoooo<c<`02/c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P<c<c<00=VIVKoooooool0ooooomWoool0
0fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<
c<`00fIVI_ooooooo`3ooooofOooo`03IVIVooooc<c<00[<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooooooo02?oool40000
oooook;oool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0c<c<`00fIVI_ooo`00000?00004oooo`040000oooooooooooo
0P000?oooonaoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P<c<c<00AVIVKoool0003oool=c<co00<0003oooooool0
0_ooo`800004oooo0P000003oooo0000000000800003oooo0P000004oooo
00000000oooo0P0000;oool400000oooo`8000000oooo`0000000004oooo
1@0000;oool2000000?oool0000000000_ooo`@00002oooo0P0000;oool2
0000oooooh;oool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0c<c<`016IVI_ooo`000?ooo`g<c?l00`000?ooooooo`02
oooo0P0000?oool2000000?oool0000000000_ooo`8000001?ooo`000000
0?ooo`<000001?ooo`0000000?ooo`800002oooo0P000003oooo00000000
00;oool200000oooo`800002oooo0P000003oooo0000000000;oool20000
00?oool0000000000_ooo`8000000oooo`0000000002oooo0P000?oooon2
oooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P<c<c<00AVIVKoool0003oool=c<co00<0003oooooool00_ooo`800003
oooo0P000003oooo0000000000Goool200000_ooo`8000000oooo`000000
0004oooo0`000003oooo0000000000;oool200000oooo`800002oooo0P00
0003oooo0000000000;oool2000000?oool0000000000_ooo`8000000ooo
o`0000000002oooo0P000?oooon2oooo00=VIVKoooo<c<`02/c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00AVIVKoool0003oool=c<co
00<0003oooooool00_ooo`800002oooo0P0000;oool6000000?oool00000
00000_ooo`8000000oooo`0000000002oooo100000;oool200000_ooo`80
0004oooo0P000004oooo00000000oooo0P0000;oool2000000?oool00000
00000_ooo`8000000oooo`0000000002oooo0P000?oooon2oooo00=VIVKo
ooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00AV
IVKoool0003oool=c<co00<0003oooooool00_ooo`H00002oooo0P0000;o
ool2000000?oool0000000000_ooo`8000001?ooo`0000000?ooo`<00004
oooo0P0000;oool200001Oooo`@000000oooo`0000000002oooo0P000003
oooo0000000000;oool2000000?oool0000000000_ooo`80003oooooP_oo
o`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
3<c<c004IVIVoooo0000oooo3Lc<o`030000oooooooo00;oool200000ooo
o`8000000oooo`0000000002oooo0P000004oooo00000000oooo0`000004
oooo00000000oooo0P0000;oool2000000?oool0000000000_ooo`800003
oooo00@0003oooooooooool2000000?oool0000000000_ooo`800002oooo
00<0003oooooool00P000005oooo000000000000oooo0080003oooooP_oo
o`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
3<c<c004IVIVoooo0000oooo3Lc<o`030000oooooooo00;oool200000ooo
o`800002oooo100000?oool2000000Coool00000003oool200000_ooo`@0
00000oooo`0000000002000000?oool0000000000P0000;oool4000000?o
ool0000000000P000003oooo0000000000;oool400000_ooo`8000000ooo
o`000000003oooooPoooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h3<c<c004IVIVoooo0000oooo1lc<o`Koool00`00
0?ooooooo`02oooo0P0000?oool200006Oooo`80000>oooo0P000?oooonD
oooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P<c<c<00=VIVKoool000002?ooo`L00004oooo1P00013oool200002Ooo
o`030000oooooooo00goool00`000?ooooooo`020000oooooi3oool00fIV
I_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`0
0fIVI_ooooooo`0800001YVIc0030000oooooooo0?ooooo8oooo00=VIVKo
ooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00=V
IVKoooooool02?ooo`MVIYWooooob_ooo`03IVIVooooc<c<00[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooooooo00Woool6
IVJIoooool[oool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0c<c<`00fIVI_ooooooo`3ooooofOooo`03IVIVooooc<c<
00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooo
oooo0?oooooIoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P<c<c<00=VIVKoooooool0ooooomWoool00fIVI_ooolc<
c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`00fIVI_oo
ooooo`3ooooofOooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h3<c<c003IVIVoooooooo0?oooooIoooo00=VIVKoooo<
c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00=VIVKo
ooooool0ooooomWoool00fIVI_ooolc<c00:c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0c<c<`00fIVI_ooooooo`3ooooofOooo`03IVIVoooo
c<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIV
oooooooo0?oooooIoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P<c<c<00=VIVKoooooool0ooooomWoool00fIVI_oo
olc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`00fIV
I_ooo`00000?0000oooool[oool00fIVI_ooolc<c00:c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0c<c<`016IVI_ooo`000?ooo`g<c?l00`00
0?ooooooo`02oooo1@0000Coool400000oooo`@00003oooo0P000004oooo
00000000oooo0P0000;oool200000_ooo`800002oooo100000;oool20000
0_ooo`800002oooo0P0000;oool500000_ooo`8000000oooo`0000000002
oooo100000;oool200000_ooo`80003oooooLOooo`03IVIVooooc<c<00[<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c004IVIVoooo0000
oooo3Lc<o`030000oooooooo00;oool200000_ooo`800002oooo0P0000;o
ool2000000?oool0000000000_ooo`8000001?ooo`0000000?ooo`<00000
0oooo`0000000002oooo0P0000;oool2000000?oool0000000000_ooo`80
00000oooo`0000000002oooo0P000003oooo0000000000;oool200000_oo
o`8000000oooo`0000000002oooo0P000003oooo0000000000;oool20000
00?oool0000000000_ooo`80003oooooLOooo`03IVIVooooc<c<00[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c004IVIVoooo0000oooo
3Lc<o`030000oooooooo00;oool200000oooo`8000000oooo`0000000002
oooo0P000003oooo0000000000Goool200000_ooo`8000000oooo`000000
0002oooo0P0000;oool2000000?oool0000000001Oooo`800002oooo0P00
0003oooo0000000000;oool200000_ooo`8000000oooo`0000000002oooo
0P000003oooo0000000000;oool2000000?oool0000000000_ooo`80003o
ooooLOooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h3<c<c004IVIVoooo0000oooo3Lc<o`030000oooooooo00;oool2
00000oooo`8000000oooo`0000000002oooo0P000003oooo0000000000Go
ool200000_ooo`8000000oooo`0000000002oooo0P0000;oool2000000?o
ool00000000010000003oooo0000000000;oool2000000?oool000000000
0oooo`8000001?ooo`0000000?ooo`800002oooo0P000003oooo00000000
00;oool2000000?oool0000000000_ooo`80003oooooLOooo`03IVIVoooo
c<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c004IVIV
oooo0000oooo3Lc<o`030000oooooooo00;oool200000oooo`8000000ooo
o`0000000002oooo0P000003oooo0000000000Goool200000_ooo`800000
0oooo`0000000002oooo0P0000;oool2000000?oool0000000000_ooo`80
00000oooo`0000000002oooo0P000003oooo0000000000Coool4000000?o
ool0000000000_ooo`8000000oooo`0000000002oooo0P000003oooo0000
000000;oool20000ooooog7oool00fIVI_ooolc<c00:c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0c<c<`016IVI_ooo`000?ooo`g<c?l00`00
0?ooooooo`02oooo0P0000?oool200000_ooo`030000oooooooo00800000
0oooo`0000000002oooo0P000003oooo0000000000;oool2000000Goool0
00000000003oool00`000004oooo00000000oooo0P0000;oool2000000Go
ool000000000003oool00P000003oooo0000000000;oool010000?oooooo
ooooo`8000000oooo`0000000002oooo0P0000;oool00`000?ooooooo`02
000000Goool000000000003oool00P000?oooomaoooo00=VIVKoooo<c<`0
2/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00AVIVKoool0
003oool=c<co00<0003oooooool00_ooo`800003oooo0P0000;oool40000
0oooo`@00002oooo0P0000;oool2000000Coool00000003oool200000_oo
o`800003oooo100000;oool2000000Coool00000003oool400000_ooo`@0
00000oooo`0000000002000000?oool0000000000_ooo`@00002oooo0P00
0003oooo000000000?oooomboooo00=VIVKoooo<c<`02/c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P<c<c<00AVIVKoool0003oool7c<co1_oo
o`030000oooooooo00;oool200000_ooo`80000`oooo0P0000Woool20000
oooooh?oool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0c<c<`00fIVI_ooo`000008oooo1`0000Coool50000<_ooo`03
0000oooooooo00Soool00`000?ooooooo`020000ooooogooool00fIVI_oo
olc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`00fIV
I_ooooooo`0800001YVIc0030000oooooooo0?ooooo8oooo00=VIVKoooo<
c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00=VIVKo
ooooool02?ooo`MVIYWooooob_ooo`03IVIVooooc<c<00[<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooooooo00Woool6IVJI
oooool[oool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0c<c<`00fIVI_ooooooo`3ooooofOooo`03IVIVooooc<c<00[<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooooooo
0?oooooIoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P<c<c<00=VIVKoooooool0ooooomWoool00fIVI_ooolc<c00:
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`00fIVI_oooooo
o`3ooooofOooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h3<c<c003IVIVoooooooo0?oooooIoooo00=VIVKoooo<c<`0
2/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00=VIVKooooo
ool0ooooomWoool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0c<c<`00fIVI_ooooooo`3ooooofOooo`03IVIVooooc<c<
00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooo
oooo0?oooooIoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P<c<c<00=VIVKoooooool0<Oooo`@0003oooooY?ooo`03
IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<
c003IVIVoooo000000l0000Qoooo00@0003oooooooooool20000oooooj?o
ool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0c<c<`016IVI_ooo`000?ooo`g<c?l00`000?ooooooo`04oooo100000?o
ool400000_ooo`800002oooo0P000003oooo0000000000;oool200000_oo
o`8000000oooo`0000000002oooo0P000004oooo00000000oooo0P0000Co
ool500000_ooo`8000000oooo`0000000002oooo100000;oool200000_oo
o`80003oooooNoooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h3<c<c004IVIVoooo0000oooo3Lc<o`030000oooooooo
00?oool200000_ooo`8000000oooo`0000000002oooo0P000003oooo0000
000000;oool2000000?oool0000000000_ooo`8000001?ooo`0000000?oo
o`<000001?ooo`0000000?ooo`<000000oooo`0000000003oooo0P0000;o
ool2000000?oool0000000000_ooo`8000000oooo`0000000002oooo0P00
0003oooo0000000000;oool20000ooooog_oool00fIVI_ooolc<c00:c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`016IVI_ooo`000?oo
o`g<c?l00`000?ooooooo`02oooo0P0000Koool200000_ooo`8000000ooo
o`0000000002oooo0P000003oooo0000000000;oool2000000?oool00000
00000_ooo`8000000oooo`0000000002oooo0P000003oooo0000000000?o
ool200000_ooo`8000000oooo`0000000002oooo0P000003oooo00000000
00;oool2000000?oool0000000000_ooo`80003oooooNoooo`03IVIVoooo
c<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c004IVIV
oooo0000oooo3Lc<o`030000oooooooo00;oool200001_ooo`800002oooo
0P000003oooo0000000000;oool2000000?oool0000000000_ooo`800000
0oooo`0000000002oooo0P000003oooo0000000000;oool2000000?oool0
000000001?ooo`8000001?ooo`0000000?ooo`800002oooo0P000003oooo
0000000000;oool2000000?oool0000000000_ooo`80003oooooNoooo`03
IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<
c004IVIVoooo0000oooo3Lc<o`030000oooooooo00;oool200001_ooo`80
0002oooo0P000003oooo0000000000;oool2000000?oool0000000000_oo
o`8000000oooo`0000000002oooo0P000003oooo0000000000;oool20000
00?oool0000000001Oooo`@000000oooo`0000000002oooo0P000003oooo
0000000000;oool2000000?oool0000000000_ooo`80003oooooNoooo`03
IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<
c004IVIVoooo0000oooo3Lc<o`030000oooooooo00;oool200001oooo`03
0000oooooooo008000001Oooo`00000000000?ooo`02000000?oool00000
00000_ooo`8000001?ooo`0000000?ooo`<000000oooo`0000000002oooo
0P000003oooo0000000000?oool010000?ooooooooooo`8000000oooo`00
00000002oooo0P0000;oool00`000?ooooooo`02000000Goool000000000
003oool00P000?oooomkoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P<c<c<00AVIVKoool0003oool=c<co00<0003o
ooooool00_ooo`800007oooo100000;oool2000000Coool00000003oool4
000000?oool0000000000_ooo`8000001?ooo`0000000?ooo`800002oooo
0P000003oooo0000000000800002oooo10000003oooo0000000000800000
0oooo`0000000002oooo100000;oool2000000?oool000000000ooooogco
ool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0c<c<`016IVI_ooo`000?ooo`O<c?l6oooo00<0003oooooool00oooo`80
0002oooo0P0000ooool200007oooo`80003oooooSOooo`03IVIVooooc<c<
00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooo
000000Soool700001_ooo`@0000Aoooo1@0001coool00`000?ooooooo`02
0000ooooohWoool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0c<c<`00fIVI_ooooooo`0800001YVIc0030000oooooooo
0?ooooo8oooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P<c<c<00=VIVKoooooool02?ooo`MVIYWooooob_ooo`03IVIV
ooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c003
IVIVoooooooo00Woool6IVJIoooool[oool00fIVI_ooolc<c00:c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`00fIVI_ooooooo`3ooooo
fOooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h3<c<c003IVIVoooooooo0?oooooIoooo00=VIVKoooo<c<`02/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00=VIVKoooooool0oooo
omWoool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0c<c<`00fIVI_ooooooo`3ooooofOooo`03IVIVooooc<c<00[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooooooo07Ko
oomhVIW<j_ooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h3<c<c003IVIVoooooooo07Koool00iVIc<c<olc<o`1dc<co
00>IVLcoooooool0j?ooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h3<c<c003IVIVoooooooo07Koool00iVIc<c<olc<
o`1dc<co00>IVLcoooooool0j?ooo`03IVIVooooc<c<00[<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooooooo07Koool00iVI
c<c<olc<o`0=0000Ilc<o`03VIW<oooooooo0>Soool00fIVI_ooolc<c00:
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`00fIVI_oooooo
o`1foooo00BIVLc<c?o<c?l0000;c<co00<0003<c?o<c?l0ILc<o`03VIW<
oooooooo0>Soool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0c<c<`00fIVI_ooo`00000?0000Ioooo`05VIW<c<coc<co
0000c<co00Woool00lc<o`000<c<o`1Vc<co00>IVLcoooooool0j?ooo`03
IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<
c004IVIVoooo0000oooo3Lc<o`030000oooooooo00;oool200000oooo`80
0002oooo0P000003oooo0000000000;oool2000000?oool0000000000ooo
o`@00003oooo0P0000;oool200000_ooo`@0000hoooo00FIVLc<c?o<c?l0
003<c?l02Oooo`03c<co0000c<co00C<c?l200000/c<o`030000c<coc<co
00800002c<co1@0000;<c?l2000000?<c?l0000000000/c<o`8000000lc<
o`0000000003c<co0P0000;<c?l400000/c<o`800003c<co0P0000;<c?l2
00000/c<o`@00002c<co0P000003c<co0000000000;<c?l400000/c<o`80
0002c<co0P0000;<c?l400002lc<o`03VIW<oooooooo0>Soool00fIVI_oo
olc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`016IV
I_ooo`000?ooo`g<c?l00`000?ooooooo`02oooo0P0000?oool2000000Co
ool00000003oool3000000Coool00000003oool300000_ooo`800002oooo
0P0000;oool200000_ooo`8000000oooo`0000000002oooo0P0003Ooool0
1IVIc<c<olc<o`000<c<o`09oooo00?<c?l0003<c?l01<c<o`8000001Lc<
o`00000000000<c<o`02000000?<c?l0000000000/c<o`8000000lc<o`00
00000002c<co0P0000;<c?l2000000?<c?l0000000000lc<o`8000000lc<
o`0000000002c<co0P000003c<co0000000000?<c?l200000/c<o`800000
0lc<o`0000000002c<co0P000004c<co00000000c<co0P000003c<co0000
000000;<c?l2000000?<c?l0000000000/c<o`8000000lc<o`0000000002
c<co0P0000[<c?l00iVIc?ooooooo`3Xoooo00=VIVKoooo<c<`02/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00AVIVKoool0003oool=
c<co00<0003oooooool00_ooo`L000000oooo`0000000002oooo0P000003
oooo0000000000;oool2000000?oool0000000001?ooo`8000000oooo`00
00000002oooo0P0000Coool30000=oooo`05VIW<c<coc<co0000c<co00Wo
ool00lc<o`000<c<o`04c<co0P000005c<co000000000000c<co00800000
0lc<o`0000000002c<co0P000003c<co0000000000;<c?l200000/c<o`80
00000lc<o`0000000002c<co0P0000;<c?l200001Lc<o`800003c<co0P00
00;<c?l2000000?<c?l0000000001Lc<o`800004c<co0P0000K<c?l40000
0/c<o`80000>c<co00>IVLcoooooool0j?ooo`03IVIVooooc<c<00[<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c004IVIVoooo0000oooo
3Lc<o`030000oooooooo00?oool2000000?oool0000000000_ooo`800002
oooo0P000003oooo0000000000;oool2000000?oool0000000001?ooo`80
00000oooo`0000000002oooo0P0000;oool40000>?ooo`05VIW<c<coc<co
0000c<co00Woool00lc<o`000<c<o`04c<co0P000005c<co0000c<co0000
c<co00800002c<co0P000004c<co00000000c<co0P0000;<c?l200000/c<
o`8000000lc<o`0000000002c<co0P0000;<c?l6000000?<c?l000000000
0lc<o`800002c<co0P000003c<co0000000000@000000lc<o`0000000004
c<co1P0000?<c?l200000lc<o`H0000:c<co00>IVLcoooooool0j?ooo`03
IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<
c004IVIVoooo0000oooo3Lc<o`030000oooooooo00?oool2000000?oool0
000000000_ooo`800002oooo0P000003oooo0000000000;oool2000000?o
ool0000000001?ooo`8000000oooo`0000000002oooo0P000004oooo0000
00000000>_ooo`05VIW<c<coc<co0000c<co00Woool00lc<o`000<c<o`04
c<co0P000005c<co0000c<co0000c<co00800003c<co10000003c<co0000
000000;<c?l200000/c<o`8000000lc<o`000000000400000/c<o`800002
c<co0P000003c<co0000000000?<c?l200000/c<o`8000000lc<o`000000
0002c<co0P000003c<co0000000000C<c?l200000/c<o`800002c<co1000
00;<c?l200000/c<o`80000:c<co00>IVLcoooooool0j?ooo`03IVIVoooo
c<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c004IVIV
oooo0000oooo3Lc<o`030000oooooooo00?oool2000000?oool000000000
0_ooo`8000001Oooo`00000000000?ooo`02000000Goool000000000003o
ool00P0000Coool2000000Goool000000000003oool00P000003oooo0000
000000;oool20000=oooo`05VIW<c<coc<co0000c<co00Woool00lc<o`00
0<c<o`04c<co10000003c<co00000000008000000lc<o`000<c<o`02c<co
0P000003c<co0000000000;<c?l3000000C<c?l00000003<c?l500000lc<
o`800002c<co0P000003c<co0000000000?<c?l3000000C<c?l00000003<
c?l200000/c<o`8000000lc<o`0000000004c<co0P0000;<c?l2000000?<
c?l0000000000/c<o`8000000lc<o`0000000002c<co0P0000[<c?l00iVI
c?ooooooo`3Xoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P<c<c<00AVIVKoool0003oool=c<co00<0003oooooool0
0oooo`8000000oooo`0000000003oooo0P000003oooo0000000000;oool2
000000Coool00000003oool200001?ooo`8000001?ooo`0000000?ooo`80
0003oooo100003Soool01IVIc<c<olc<o`000<c<o`09oooo0P0000G<c?l4
000000?<c?l0000000000P0000;<c?l4000000?<c?l0000000000P000004
c<co00000000c<co0P0000;<c?l2000000?<c?l0000000001<c<o`@00002
c<co10000004c<co00000000c<co0P0000?<c?l400000/c<o`800005c<co
100000;<c?l200000/c<o`800002c<co100000_<c?l00iVIc?ooooooo`3X
oooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P<c<c<00AVIVKoool0003oool7c<co1_ooo`030000oooooooo00Coool3
00001oooo`800005oooo0P0000;oool200000_ooo`800016oooo00FIVLc<
c?o<c?l0003<c?l02?ooo`800006c<co0`0000?<c?l300002<c<o`800002
c<co0P0000G<c?l200000/c<o`80000Lc<co0P0002;<c?l00iVIc?oooooo
o`3Xoooo00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P<c<c<00=VIVKoool000002?ooo`L00006oooo0`0000Ooool20000
1Oooo`800003oooo100004Ooool01IVIc<c<olc<o`000<c<o`07oooo00<0
003<c?l000001/c<o`<00003c<co0`0000W<c?l00`000<c<olc<o`020000
1Lc<o`800003c<co0P0001_<c?l200008/c<o`03VIW<oooooooo0>Soool0
0fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<
c<`00fIVI_ooooooo`0800001YVIc0030000oooooooo06Goool01IVIc<c<
olc<o`000<c<o`06oooo00<0003<c?l00000JLc<o`03VIW<oooooooo0>So
ool00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^0c<c<`00fIVI_ooooooo`08oooo1fIVVFOoool01IVIc<c<olc<o`000<c<
o`05oooo00@0003<c?ooool0001Yc<co00>IVLcoooooool0j?ooo`03IVIV
ooooc<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h3<c<c003
IVIVoooooooo00Woool6IVJIIoooo`04VIW<c<coc<co00001lc<o`80001Z
c<co00>IVLcoooooool0j?ooo`03IVIVooooc<c<00[<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h3<c<c003IVIVoooooooo07Koool00iVIc<c<
olc<o`0:0000J/c<o`03VIW<oooooooo0>Soool00fIVI_ooolc<c00:c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`00fIVI_ooooooo`1f
oooo00>IVLc<c?o<c?l0M<c<o`03VIW<oooooooo0>Soool00fIVI_ooolc<
c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`00fIVI_oo
ooooo`1foooo00>IVLc<c?o<c?l0M<c<o`03VIW<oooooooo0>Soool00lc<
c?ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`0
0fIVI_ooooooo`1fooooN9VIc>[oool00fIVI_ooolc<c00:c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0c<c<coIVIVgFIVIPc<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2holc<c?G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2holc<c?G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?G<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?G<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2holc<c?G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2holc<c?G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2holc<c?G<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?G<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?G<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2holc<c?G<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h=<c<c?oooolTooooWLc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;Pcc<c<00=VIVK<c<aVIVH0ofIVIR5VIVH00oooolc<c<c<
c02Kc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`00fIVI_oo
olc<c03oc<c<8<c<c003IVIVooooc<c<00_<c<`Goooo1/c<c1Ooool6c<c<
5oooo`K<c<`Goooo00?<c<coooooool05Oooo`_<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h<lc<c003IVIVooooc<c<0?o<c<`Pc<c<00=VIVKo
ooo<c<`02/c<c003IVIVc<c<IVIV01AVIVH00oooolc<c<c<c003c<c<00=V
IVK<c<aVIVH056IVIP03ooooc<c<c<c<00?<c<`00fIVI/c<c6IVIP0DIVIV
00?oooo<c<c<c<`00lc<c003IVIVVIVIIVIV01AVIVH00oooofIVI/c<c00E
IVIV00?oooo<c<c<c<`02Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Pcc<c<00=VIVKoooo<c<`0olc<c23<c<`00fIVI_ooolc<c00:c<c<00=V
IVKoooo<c<`04lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00Cc<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<01?<c<`00fIVI_ooolc<c004
c<c<00=VIVK<c<bIVIT04iVIV@04IVIVooooIVIVoooo5<c<c003IVIVoooo
c<c<00[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c003IVIV
ooooc<c<0?o<c<`Pc<c<00=VIVKoooo<c<`02/c<c003IVIVooooc<c<01?<
c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`04lc<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c00Cc<c<00=VIVKoooo<c<`01<c<c003IVIVc<c<
VIVI01>IVIT016IVI_ooofIVI_oooaC<c<`00fIVI_ooolc<c00:c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`00fIVI_ooolc<c03oc<c<
8<c<c003IVIVooooc<c<00[<c<`00fIVI_ooolc<c008c<c<00<0003<c<c<
c<`02<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00Cc<c<00=VIVKo
ooo<c<`01<c<c003IVIVooooc<c<01?<c<`00fIVI_ooolc<c004c<c<00=V
IVK<c<bIVIT04iVIV@04IVIVooooIVIVoooo5<c<c003IVIVooooc<c<00[<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c003IVIVooooc<c<
0?o<c<`Pc<c<00=VIVKoooo<c<`02/c<c003IVIVooooc<c<00S<c<`00`00
0<c<c<c<c008c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00?<c<`;
00001Lc<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00Cc<c<00=VIVKo
ooo<c<`01<c<c003IVIVc<c<VIVI00:IVIT500000iVIV@D00004VIVI00AV
IVKooomVIVKoool3c<c<1@0000c<c<`00fIVI_ooolc<c00:c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0k<c<`400002<c<c08000001<c<c000
00000<c<c08000000lc<c0000000000>c<c<00=VIVKoooo<c<`00/c<c100
003oc<c<3/c<c003IVIVooooc<c<00[<c<`016IVI_ooolc<c<c<c0l00003
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00?<c<`010000<c<olc<
o`0000?<c<`010000<c<olc<o`0000G<c<`00fIVI_ooolc<c004c<c<00AV
IVKoooo<c<c<c<`?00000lc<c003IVIVooooc<c<00C<c<`00fIVI/c<c9VI
V@02VIVI00D0003<c?o<c?o<c?l000000iVIV@050000c<coc<coc<co0000
00BIVIT016IVI_ooofIVI_ooo`?<c<`01@000<c<olc<olc<o`00000<c<c<
00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P?
c<c<00<0003<c<c<c<`00`0000G<c<`=00003<c<c003IVIVooooc<c<00;<
c<`00`000?ooolc<o`0<c<co00<0003<c<c<c<`01Lc<c0800002c<c<0P00
00C<c<`20000n/c<c003IVIVooooc<c<00[<c<`01VIVI_ooolc<c<c<c000
0?ooo`G<c?l00`000<c<olc<o`04c<co00H0003<c<c<c<c<c<aVIVKoool5
c<c<00=VIVKoooo<c<`00lc<c0040000c<coc<co00000lc<c0040000c<co
c<co00001Lc<c003IVIVooooc<c<00C<c<`01VIVI_ooolc<c<c<c0000?oo
o`c<c?l01P000<c<c<c<c<c<c6IVI_ooo`G<c<`00fIVI/c<c9VIV@02VIVI
00l0003<c?ooooo<c?l0002IVIT0002IVIT0003<c?ooooo<c?l0002IVIT0
00000YVIV@04IVIVooooIVIVoooo0lc<c0060000c<coooooc<co0000c<c<
200000?<c<`00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^13<c<`3000000C<c<`0000000000004c<c<00L0003<c<`00000
003<c<`0003<c<`00P000003c<c<0000000000c<c<`00fIVI_ooolc<c002
c<c<00<0003oooo<c?l03<c<o`030000c<c<c<c<00G<c<`200000/c<c080
0004c<c<0P000?[<c<`00fIVI_ooolc<c00:c<c<00IVIVKoooo<c<c<c<`0
003oool2c<co1`0000?<c?l01P000<c<c<c<c<c<c6IVI_ooo`G<c<`00fIV
I_ooolc<c003c<c<00@0003<c?o<c?l00002c<c<00EVIVH0003<c?o<c?l0
00001Lc<c003IVIVooooc<c<00C<c<`01VIVI_ooolc<c<c<c0000?ooo`c<
c?l01P000<c<c<c<c<c<c6IVI_ooo`G<c<`00fIVI/c<c9VIV@02VIVI00D0
003<c?ooooo<c?l000000iVIV@050000c<coooooc<co000000BIVIT016IV
I_ooofIVI_ooo`?<c<`01@000<c<ooooolc<o`00000<c<c<00=VIVKoooo<
c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<00<0003<
c<`000000P000003c<c<0000000000800004c<c<2`0000k<c<`00fIVI_oo
olc<c002c<c<00<0003oooo<c?l03<c<o`030000c<c<c<c<00;<c<`60000
1lc<c080003jc<c<00=VIVKoooo<c<`02/c<c006IVIVooooc<c<c<c<0000
oooo0lc<o`D00004c<co00H0003<c<c<c<c<c<aVIVKoool5c<c<00=VIVKo
ooo<c<`00lc<c0040000c<coc<co00000lc<c0040000c<coc<co00001Lc<
c003IVIVooooc<c<00C<c<`01VIVI_ooolc<c<c<c0000?ooo`c<c?l01P00
0<c<c<c<c<c<c6IVI_ooo`G<c<`00fIVI/c<c9VIV@02VIVI00D0003<c?o<
c?o<c?l000000iVIV@050000c<coc<coc<co000000BIVIT016IVI_ooofIV
I_ooo`?<c<`01@000<c<olc<olc<o`00000<c<c<00=VIVKoooo<c<`02/c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<20000004c<c<0000
000000000/c<c08000000lc<c0000000000200000/c<c080000>c<c<00=V
IVKoooo<c<`00/c<c0030000ooooc<co00c<c?l00`000<c<c<c<c002c<c<
00<0003<c<c<c<`00P0000S<c<`20000klc<c0800009c<c<00=VIVKoooo<
c<`02/c<c006IVIVooooc<c<c<c<0000oooo1<c<o`<00005c<co00H0003<
c<c<c<c<c<aVIVKoool5c<c<00=VIVKoooo<c<`00lc<c0040000c<coc<co
00000lc<c0040000c<coc<co00001Lc<c003IVIVooooc<c<00C<c<`01VIV
I_ooolc<c<c<c0000?ooo`c<c?l01P000<c<c<c<c<c<c6IVI_ooo`G<c<`0
0fIVI/c<c9VIV@02VIVI100000BIVIT400001IVIV@04IVIVooooIVIVoooo
0lc<c0@0000=c<c<00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P?c<c<1`0000C<c<`2000000?<c<`0000000001P0000k<
c<`00fIVI_ooolc<c002c<c<00<0003oooo<c?l03<c<o`030000c<c<c<c<
00?<c<`010000<c<c000000000S<c<`20000k/c<c0@00008c<c<00=VIVKo
ooo<c<`02/c<c006IVIVooooc<c<c<c<0000oooo1Lc<o`030000c<coc<co
00C<c?l01P000<c<c<c<c<c<c6IVI_ooo`G<c<`00fIVI_ooolc<c003c<c<
00<0003<c?o<c?l01@0000;<c?l00`000<c<c<c<c003c<c<00=VIVKoooo<
c<`01<c<c006IVIVooooc<c<c<c<0000oooo3<c<o`060000c<c<c<c<c<c<
IVIVoooo1Lc<c003IVIVc<c<VIVI01>IVIT016IVI_ooofIVI_oooaC<c<`0
0fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0g<
c<`;00000/c<c0H00005c<c<0P0000c<c<`00fIVI_ooolc<c002c<c<00<0
003oooo<c?l03<c<o`030000c<c<c<c<00?<c<`010000<c<c000000000K<
c<`010000<c<c00000000>g<c<`600001lc<c003IVIVooooc<c<00[<c<`0
1VIVI_ooolc<c<c<c0000?ooo`c<c?l01P000<c<c<c<c<c<c6IVI_ooo`G<
c<`01fIVI_ooolc<c<c<c0000<c<c0000009c<co00<0003<c<`000000lc<
c003IVIVooooc<c<00C<c<`01VIVI_ooolc<c<c<c0000?ooo`c<c?l01P00
0<c<c<c<c<c<c6IVI_ooo`G<c<`00fIVI/c<c9VIV@0CVIVI00AVIVKooomV
IVKooolDc<c<00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P>c<c<00<0003<c<c<c<`00P0000;<c<`00`000<c<c<c<c002
c<c<0P000003c<c<0000000000P0000<c<c<00=VIVKoooo<c<`00/c<c003
0000ooooc<co00c<c?l00`000<c<c<c<c004c<c<0`0000K<c<`40000k<c<
c0P00006c<c<00=VIVKoooo<c<`02/c<c006IVIVooooc<c<c<c<0000oooo
1lc<o`Goool01P000<c<c<c<c<c<c6IVI_ooo`G<c<`00fIVI_ooolc<c002
c<c<0P0000UVIVH200001<c<c003IVIVooooc<c<00C<c<`01VIVI_ooolc<
c<c<c0000?ooo`O<c?l5oooo00H0003<c<c<c<c<c<aVIVKoool5c<c<00=V
IVK<c<bIVIT00YVIV@D00003VIVI1@0000BIVIT016IVI_ooofIVI_ooo`?<
c<`500003<c<c003IVIVooooc<c<00[<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h3/c<c0T00003c<c<0P000004c<c<00000000c<c<0P000003
c<c<0000000000k<c<`00fIVI_ooolc<c002c<c<00<0003oooo<c?l01/c<
o`Koool00`000<c<c<c<c004c<c<0`0000O<c<`30000jlc<c0X00005c<c<
00=VIVKoooo<c<`02/c<c005IVIVooooc<c<c<c<000000Soool600000lc<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c003c<c<00<0001VIVIVIVH0
1fIVIP030000c<c<c<c<00?<c<`00fIVI_ooolc<c004c<c<00EVIVKoooo<
c<c<c<`000002?ooo`H00003c<c<00=VIVKoooo<c<`01<c<c003IVIVc<c<
VIVI00:IVIT01@000<c<olc<olc<o`000003VIVI00D0003<c?o<c?o<c?l0
000019VIV@04IVIVooooIVIVoooo0lc<c0050000c<coc<coc<co000000c<
c<`00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^13<c<`2000000?<c<`0000000001Lc<c0/0000>c<c<00=VIVKoooo<c<`0
0/c<c0030000oooooooo00Koool700001lc<c0800008c<c<0P000?[<c<`0
0fIVI_ooolc<c00:c<c<00=VIVKoooo<c<`00/c<c0P00005c<co00H0003<
c<c<c<c<c<aVIVKoool5c<c<00=VIVKoooo<c<`01<c<c0030000IVIVIVIV
00EVIVH00`000<c<c<c<c004c<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<00;<c<`800001Lc<o`060000c<c<c<c<c<c<IVIVoooo1Lc<c003IVIV
c<c<VIVI00:IVIT03`000<c<ooooolc<o`0009VIV@0009VIV@000<c<oooo
olc<o`0009VIV@000002VIVI00AVIVKooomVIVKoool3c<c<00H0003<c?oo
ooo<c?l0003<c<`800000lc<c003IVIVooooc<c<00[<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h4Lc<c0<0000Oc<c<00=VIVKoooo<c<`00lc<
c0P00006VIW<00<0003<c<c<c<`0olc<c0c<c<`00fIVI_ooolc<c00:c<c<
00=VIVKoooo<c<`02/c<c0IVIYT3c<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<00G<c<`00`0006IVIVIVIP03IVIV0P0000K<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`02/c<c0IVIYT3c<c<00=VIVKoooo<c<`01<c<
c003IVIVc<c<VIVI00:IVIT01@000<c<ooooolc<o`000003VIVI00D0003<
c?ooooo<c?l0000019VIV@04IVIVooooIVIVoooo0lc<c0050000c<cooooo
c<co000000c<c<`00fIVI_ooolc<c00:c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^3?<c<`00fIVI_ooolc<c00;c<c<1fIVVOo<c<`>c<c<00=V
IVKoooo<c<`02/c<c003IVIVooooc<c<00_<c<`5IVJI0lc<c003IVIVoooo
c<c<00C<c<`00fIVI_ooolc<c006c<c<00@0001VIVIVIVIVIVH300001/c<
c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00;c<c<1FIVV@?<c<`00fIV
I_ooolc<c004c<c<00=VIVK<c<bIVIT00YVIV@050000c<coc<coc<co0000
00>IVIT01@000<c<olc<olc<o`000004VIVI00AVIVKooomVIVKoool3c<c<
00D0003<c?o<c?o<c?l000003<c<c003IVIVooooc<c<00[<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h<lc<c003IVIVooooc<c<00c<c<`6IVJI
olc<c0k<c<`00fIVI_ooolc<c00:c<c<00=VIVKoooo<c<`04lc<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c007c<c<00@0001VIVH0003<c<`20000
1/c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00Cc<c<00=VIVKoooo<
c<`01<c<c003IVIVc<c<VIVI00:IVIT4000019VIV@@00005VIVI00AVIVKo
oomVIVKoool3c<c<100000g<c<`00fIVI_ooolc<c00:c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^3?<c<`00fIVI_ooolc<c03oc<c<8<c<c003
IVIVooooc<c<00[<c<`00fIVI_ooolc<c00Cc<c<00=VIVKoooo<c<`01<c<
c003IVIVooooc<c<00S<c<`00`000<c<c<c<c008c<c<00=VIVKoooo<c<`0
1<c<c003IVIVooooc<c<01?<c<`00fIVI_ooolc<c004c<c<00=VIVK<c<bI
VIT04iVIV@04IVIVooooIVIVoooo5<c<c003IVIVooooc<c<00[<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h<lc<c003IVIVooooc<c<0?o<c<`P
c<c<00=VIVKoooo<c<`02/c<c003IVIVooooc<c<01?<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`04lc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c00Cc<c<00=VIVKoooo<c<`01<c<c003IVIVc<c<VIVI01>IVIT016IV
I_ooofIVI_oooaC<c<`00fIVI_ooolc<c00:c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^3?<c<`00fIVI_ooolc<c03oc<c<8<c<c003IVIVoooo
c<c<00[<c<`00fIVI_ooolc<c00Cc<c<00=VIVKoooo<c<`01<c<c003IVIV
ooooc<c<01?<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`04lc<c003
IVIVooooc<c<00C<c<`00fIVI/c<c9VIV@0CVIVI00AVIVKooomVIVKooolD
c<c<00=VIVKoooo<c<`02/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Pcc<c<00=VIVKoooo<c<`0olc<c23<c<`00fIVI_ooolc<c00:c<c<00=V
IVKoooooool04oooo`03c<c<ooooc<c<00C<c<`00fIVI_ooooooo`0Coooo
00?<c<coooo<c<`01<c<c003IVIVoooooooo01?oool00lc<c?ooolc<c004
c<c<00=VIVK<c<c<c<`04lc<c003VIVIooooIVIV01Goool00lc<c?ooolc<
c00:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^3?<c<`00fIVI_oo
ooooo`3ooooo8?ooo`03c<c<ooooc<c<00[<c<`GIVIV1/c<c1MVIVH6c<c<
5fIVIPK<c<`GIVIV00?<c<aVIVIVIVH05FIVIPc<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h<lc<c?mVIVHTIVIVW/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<
mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<
mLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Soc<c<mLc<c0:8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?R8
`;P1B9280@00000000B8`;S8h=R8`;R8`;PE00200`01P0800X0300>10P04
P@801H400`05PP06PP06PP0200N200@11h81288128<128<20@V30`4:P`81
2h@30@b40P4=Q0030@j40@j50@j500<23hD20Q250`8AQP824XH20Q>600<2
4hL258L258L00`8EQ`030QJ70aJ80aJ800835hP30aR80P<IR@<36XT20a^9
00<378T378X378X00`<MRP847XX311n;0P@PR`848H/00`@QS0@RS0@RS003
12><00D498`498d49Hd49Hd59Hd00`DVS@031BN=1BN>1BR>0085:8h21BV>
00<5:Xh5:Xl5:Xl00PD[S`<5;8l31Rf@0PH^T086;i000`H_T@H`T@H`T@03
1S6A00<6<Y46<Y86<i800PHcTP051SBB1cBB1cBB1cFB1cFC00<7=Y<21cNC
00<7>9<7>9@7>9@00PLiU0<7>Y@31c^E0PPlU@88?ID00`PmUPPnUPPnUP03
23nF0PQ0UP<8@IL224:G0PQ3U`042D>H2DBH2DBH2DBH0PU5V0032DJH2DJI
2DJI0089AiT32DRI0PU9VP<9BYX22T^J00<:Bi/:C9/:C9/00`Y=V`8:CY/3
2TnL0PY@W08:DI`010YAW@YBW@]BW@]BW@8;Did00`]DW@]DWP]DWP022eFN
0`]FWP8;Eil32eRO0`]IW`8<FZ0335^P0PaLX0<<GJ4235jQ0PaOX@0335nR
362R362R008<HJ8010eQXPeRXPeRX`eRX`8=Hj<33FBS0PeUY0<=IZ@23FNT
00<=J:@=J:D=J:D00`iYY@8>JZD33V^V0Pi/YP8>KJH00`i]Y`i^Y`i^Y`03
3VnW00<>L:L?L:P?L:P00PmaZ0<?LZP23g>Y0`mdZ@8?MJT00`mfZ@mfZPmf
ZP033gNZ0Q1hZP<@NJ/247Z[0Q1kZ`0347^/47b/47b/00<@OJ`01A1n[11n
[A1o[A1o[A5o[@034H2]00<APJdAPJhAPZh00Q62[P8APjh00a64[Q64[a64
[`024HF_0a66[`<BQk024XR`0Q:9/0034XVa4XZa4XZa00<BRk400a:</A:<
/Q:=/P024Xfb00DBS[8CS[8CS[8CSk8CSk<00a>@/`8CTK<00a>B/a>B]1>B
]0024i>d0a>D]0<CUKD259Je0QBG]@0359Nf59Rf59Rf00<DVKH259Zf0aBK
]`8DW;L259fg00@EWKPEW[PEW[PEW[P25Inh00<EX;PEX;TEX;T00QFQ^@<E
X[T25J>j0aFT^P8FYKX00aJU^aJV^aJV^`035ZNk0QJX^`<FZK`25ZZl0QJ[
_0045Z^m5Zbm5jbm5jbm0QN]_@035jjm5jjn5jjn008G[kh35k2n0QNa_`<G
/[l25k>o51Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P4002000>K
Yo4c@jDc@jD02C=3Y@D0080300600P02P0<00h4200B10P05P@0300F200J2
00J200801h801047PP48PP48P`48P`812H<30@Z30P4;Q0<138@20@f400<1
3X@13XD13XD00`8?Q@8248D30Q660P8BQP824hH00`8CQ`8DQ`8DQ`030QF7
00<25XL35XP35XP00P<GR0<368P20aV90`<JR@836hT00`<LR@<LRP<LRP03
0af:0P@NRP<47h/2122;0P@QR`03126<12:<12:<00<48h`01@@TS0@TS@@U
S@@US@DUS@031BJ=00<59hd59hh5:8h00PDXSP85:Hh00`DZSPDZS`DZS`02
1B^?0`D/S`<6;I021Rj@0PH_T0031RnA1S2A1S2A00<6<I400`HbT@HbTPHc
TP021S>B00D6=987=987=987=I87=I<00`LfT`87=i<00`LhT`LhU0LhU002
1cVD0`LjU0<7>iD223bE0PPmU@0323fF23jF23jF00<8?iH2242F0`Q1U`88
@YL224>G00@9@iP9A9P9A9P9A9P22DFH00<9AYP9AYT9AYT00PU7V@<9B9T2
2DVJ0`U:VP8:BiX00`Y;V`Y<V`Y<V`032TfK0PY>V`<:Ci`22U2L0PYAW004
2U6M2U:M2e:M2e:M0P]CW@032eBM2eBN2eBN008;EIh32eJN0P]GW`<;F9l3
2eVO0PaJX0<<Fj0235bP0`aMX@8<GZ4235nQ00<<Gj8<H:8<H:800PaQXP04
3F6R3F:R3F:S3F:S0PeSX`<=I:<23FFT0`eVY08=Ij@00`eXY0eXY@eXY@03
3VVU0PiZY@<>JjH23VbV0Pi]YP033VfW3VjW3VjW00<>KjL00`i`Y`m`Z0m`
Z0023g6X0`mbZ08?LjT33gBY0PmeZ@033gJY3gJZ3gJZ00<?MjX247RZ0a1i
Z`8@NZ/247^[00<@Nj`@O:`@O:`00a1m[00547j/47j]47n]47n]4Gn]00<A
P:d00a61[A61[Q62[P024H:^0Q63[P034HB^4HB_4HB_008AQJl34HJ_0a:7
/08BR;024XV`00<BRK4BR[4BR[400a:;/@034Xba4Xbb4Xfb008BSK801A:>
/Q>>/Q>>/Q>?/Q>?/`034i2c0Q>A/`034i:c4i:d4i:d008CTk@34iBd0a>E
]@8DU[D259Ne00<DUkHDV;HDV;H00aBI]P8DV[H359^g0QBL]`8DWKL011FM
^1FN^1FN^1FN^08EWkP00aFP^1FP^AFP^@025J6i0aFR^@8EXkX35JBj0QJU
^P035ZFk5ZJk5ZJk00<FYk/25ZRk0aJY_08FZ[`25Z^l00@FZkdF[;dG[;dG
[;d25jfm00<G[[dG[[hG[[h00QN__P<G/;h25k6o0aNb_`8G/klD6;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0<008001i^WlOooohij]ZJKa;>Y
dZRMb;>YdP02YY_400Fl^=g^k_CZjO7ooolc@jD01000P0<00H0200:00`03
P@80184200F100<01H801X801X800P07PP040@N20@R20@R30@R30P49P`<1
2X<20@^40`4<Q0813H@00`4>Q04>Q@4>Q@030Pn50P8@Q@<24HH20Q:60P8C
QP030Q>70QB70QB700<25HL00`8FQ`<FR0<FR0020aN80`<HR0836HT30aZ9
0P<KR@030ab90ab:0ab:00<37HX211j:0`@OR`8488/2126;00<48H`48X`4
8X`00`@SS00512B<12B=12F=12F=1BF=00<59Xd00`DWS@DWSPDXSP021BR>
0PDYSP031BZ>1BZ?1BZ?0085:hl31Bb?0`H]T086;Y021Rn@00<6;i46<946
<9400`HaT@031S:A1S:B1S>B0086<i801@HdTPLdTPLdTPLeTPLeT`031cJC
0PLgT`031cRC1cRD1cRD0087>I@31cZD0`LkU@88?9D223fE00<8?IH8?YH8
?YH00`PoUP88@9H3246G0PQ2U`88@iL010U3V0U4V0U4V0U4V089AIP00`U6
V0U6V@U6V@022DNI0`U8V@89BIX32DZJ0PY;VP032T^K2TbK2TbK00<:CI/2
2TjK0`Y?W08:D9`22U6L00@:DId:DYd;DYd;DYd22e>M00<;E9d;E9h;E9h0
0P]EWP<;EYh22eNO0`]HW`<;FIl235ZP0`aKX08<G:0335fQ0PaNX@8<Gj40
0`aOXPaPXPaPXP02366R00@=HJ8=HZ8=HZ<=HZ<23F>S0`eTX`8=IJ@33FJT
0PeWY0033FRT3FRU3FRU00<>JJD23VZU0`i[YP8>K:H23VfV00<>KJL>KZL>
KZL00`i_Y`033W2W3g2X3g2X008?LJP33g:X0PmcZ@<?M:T23gFY00<?MZT?
MZX?MZX00`mgZP8@N:X347V[0Q1jZ`8@Nj/00a1k[11l[11l[00347f/00D@
OZ`@OZd@Ojd@OjdAOjd00a60[@034H6]4H6^4H:^008APZh24H>^00<AQ:hA
Q:lAQ:l00Q65[`<AQZl34XN`0Q:8/08BRK000a:9/A::/A::/@034X^a00<B
S;4BS;8BSK800Q:=/P054Xjb4hjb4hjb4hnb4hnc00<CT;<24i6c00<CT[<C
T[@CT[@00Q>C]0<CU;@34iFe0QBF]@8DUkD00aBG]QBH]QBH]P0359Vf0QBJ
]P<DVkL259bg0QBM]`045Ifh5Ijh5Ijh5Ijh0QFO^0035J2h5J2i5J2i008E
XKT35J:i0QFS^P<EY;X25ZFj00<FYK/FY[/FY[/00aJW^`8FZ;/35ZVl0QJZ
_08FZk`011J[_AJ/_AN/_AN/_@8G[Kd00aN^_AN^_QN^_P025jnn0aN`_P8G
/Kl35k:o0QNc_`8H]<0@00000QRd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000BKYo7ooom/FZF_YLX2_;SM00[ooOncZM;ooooooonl^=fG
R[bXWLSVi^cooolc@jD300200`01P0800X0300>10P04P@801H400`05PP06
PP06PP0200N200@11h81288128<128<20@V30`4:P`812h@30@b40P4=Q003
0@j40@j50@j500<23hD20Q250`8AQP824XH20Q>600<24hL258L258L00`8E
Q`030QJ70aJ80aJ800835hP30aR80P<IR@<36XT20a^900<378T378X378X0
0`<MRP847XX311n;0P@PR`848H/00`@QS0@RS0@RS00312><00D498`498d4
9Hd49Hd59Hd00`DVS@031BN=1BN>1BR>0085:8h21BV>00<5:Xh5:Xl5:Xl0
0PD[S`<5;8l31Rf@0PH^T086;i000`H_T@H`T@H`T@031S6A00<6<Y46<Y86
<i800PHcTP051SBB1cBB1cBB1cFB1cFC00<7=Y<21cNC00<7>9<7>9@7>9@0
0PLiU0<7>Y@31c^E0PPlU@88?ID00`PmUPPnUPPnUP0323nF0PQ0UP<8@IL2
24:G0PQ3U`042D>H2DBH2DBH2DBH0PU5V0032DJH2DJI2DJI0089AiT32DRI
0PU9VP<9BYX22T^J00<:Bi/:C9/:C9/00`Y=V`8:CY/32TnL0PY@W08:DI`0
10YAW@YBW@]BW@]BW@8;Did00`]DW@]DWP]DWP022eFN0`]FWP8;Eil32eRO
0`]IW`8<FZ0335^P0PaLX0<<GJ4235jQ0PaOX@0335nR362R362R008<HJ80
10eQXPeRXPeRX`eRX`8=Hj<33FBS0PeUY0<=IZ@23FNT00<=J:@=J:D=J:D0
0`iYY@8>JZD33V^V0Pi/YP8>KJH00`i]Y`i^Y`i^Y`033VnW00<>L:L?L:P?
L:P00PmaZ0<?LZP23g>Y0`mdZ@8?MJT00`mfZ@mfZPmfZP033gNZ0Q1hZP<@
NJ/247Z[0Q1kZ`0347^/47b/47b/00<@OJ`01A1n[11n[A1o[A1o[A5o[@03
4H2]00<APJdAPJhAPZh00Q62[P8APjh00a64[Q64[a64[`024HF_0a66[`<B
Qk024XR`0Q:9/0034XVa4XZa4XZa00<BRk400a:</A:</Q:=/P024Xfb00DB
S[8CS[8CS[8CSk8CSk<00a>@/`8CTK<00a>B/a>B]1>B]0024i>d0a>D]0<C
UKD259Je0QBG]@0359Nf59Rf59Rf00<DVKH259Zf0aBK]`8DW;L259fg00@E
WKPEW[PEW[PEW[P25Inh00<EX;PEX;TEX;T00QFQ^@<EX[T25J>j0aFT^P8F
YKX00aJU^aJV^aJV^`035ZNk0QJX^`<FZK`25ZZl0QJ[_0045Z^m5Zbm5jbm
5jbm0QN]_@035jjm5jjn5jjn008G[kh35k2n0QNa_`<G/[l25k>o0QRd`003
b>3HB928B92800a8T8P00`0001Rd`1Rd`002R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0P00P00;VjOaooooZ9g8oooo/jWBH4bJSWZfN6F^Z9g8oooo
oogo00?oool00c=3Y@00P000P00200200`01P0800X0300>10P04P@801H40
0`05PP06PP06PP0200N200@11h81288128<128<20@V30`4:P`812h@30@b4
0P4=Q0030@j40@j50@j500<23hD20Q250`8AQP824XH20Q>600<24hL258L2
58L00`8EQ`030QJ70aJ80aJ800835hP30aR80P<IR@<36XT20a^900<378T3
78X378X00`<MRP847XX311n;0P@PR`848H/00`@QS0@RS0@RS00312><00D4
98`498d49Hd49Hd59Hd00`DVS@031BN=1BN>1BR>0085:8h21BV>00<5:Xh5
:Xl5:Xl00PD[S`<5;8l31Rf@0PH^T086;i000`H_T@H`T@H`T@031S6A00<6
<Y46<Y86<i800PHcTP051SBB1cBB1cBB1cFB1cFC00<7=Y<21cNC00<7>9<7
>9@7>9@00PLiU0<7>Y@31c^E0PPlU@88?ID00`PmUPPnUPPnUP0323nF0PQ0
UP<8@IL224:G0PQ3U`042D>H2DBH2DBH2DBH0PU5V0032DJH2DJI2DJI0089
AiT32DRI0PU9VP<9BYX22T^J00<:Bi/:C9/:C9/00`Y=V`8:CY/32TnL0PY@
W08:DI`010YAW@YBW@]BW@]BW@8;Did00`]DW@]DWP]DWP022eFN0`]FWP8;
Eil32eRO0`]IW`8<FZ0335^P0PaLX0<<GJ4235jQ0PaOX@0335nR362R362R
008<HJ8010eQXPeRXPeRX`eRX`8=Hj<33FBS0PeUY0<=IZ@23FNT00<=J:@=
J:D=J:D00`iYY@8>JZD33V^V0Pi/YP8>KJH00`i]Y`i^Y`i^Y`033VnW00<>
L:L?L:P?L:P00PmaZ0<?LZP23g>Y0`mdZ@8?MJT00`mfZ@mfZPmfZP033gNZ
0Q1hZP<@NJ/247Z[0Q1kZ`0347^/47b/47b/00<@OJ`01A1n[11n[A1o[A1o
[A5o[@034H2]00<APJdAPJhAPZh00Q62[P8APjh00a64[Q64[a64[`024HF_
0a66[`<BQk024XR`0Q:9/0034XVa4XZa4XZa00<BRk400a:</A:</Q:=/P02
4Xfb00DBS[8CS[8CS[8CSk8CSk<00a>@/`8CTK<00a>B/a>B]1>B]0024i>d
0a>D]0<CUKD259Je0QBG]@0359Nf59Rf59Rf00<DVKH259Zf0aBK]`8DW;L2
59fg00@EWKPEW[PEW[PEW[P25Inh00<EX;PEX;TEX;T00QFQ^@<EX[T25J>j
0aFT^P8FYKX00aJU^aJV^aJV^`035ZNk0QJX^`<FZK`25ZZl0QJ[_0045Z^m
5Zbm5jbm5jbm0QN]_@035jjm5jjn5jjn008G[kh35k2n0QNa_`<G/[l25k>o
0QRd`003b>3HR<2hR<2h00^8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000jKYo7ooooooooKg>aPC9ZCQKZcZM:l
^=ePC9ZISkjVVlC8`moooolc@jD500201?ooo`0300:000>100>100?oool2
00F100@01H;oool01X801h83oooo0P48P`050@V3oooooooooooo0@Z30081
2h@00`4<Q?ooo`4<Q0020@f400<13X@13XD13XD01?ooo`040Q250Q660Q66
0Q660P8BQP05oooo0Q>60Q>70QB7oooo00825HL00oooo`8FQ`<FR003oooo
0`<HR0836HT30aZ90P<KR@030ab90ab:0ab:00<37HX211j:0`@OR`8488/2
126;00<48H`48X`48X`00`@SS00512B<12B=12F=12F=1BF=00<59Xd00`DW
S@DWSPDXSP021BR>0PDYSP031BZ>1BZ?1BZ?0085:hl31Bb?0`H]T086;Y02
1Rn@00<6;i46<946<9400`HaT@031S:A1S:B1S>B0086<i801@HdTPLdTPLd
TPLeTPLeT`031cJC0PLgT`031cRC1cRD1cRD0087>I@31cZD0`LkU@88?9D2
23fE00<8?IH8?YH8?YH00`PoUP88@9H3246G0PQ2U`88@iL010U3V0U4V0U4
V0U4V089AIP00`U6V0U6V@U6V@022DNI0`U8V@89BIX32DZJ0PY;VP032T^K
2TbK2TbK00<:CI/22TjK0`Y?W08:D9`22U6L00@:DId:DYd;DYd;DYd22e>M
00<;E9d;E9h;E9h00P]EWP<;EYh22eNO0`]HW`<;FIl235ZP0`aKX08<G:03
35fQ0PaNX@8<Gj400`aOXPaPXPaPXP02366R00@=HJ8=HZ8=HZ<=HZ<23F>S
0`eTX`8=IJ@33FJT0PeWY0033FRT3FRU3FRU00<>JJD23VZU0`i[YP8>K:H2
3VfV00<>KJL>KZL>KZL00`i_Y`033W2W3g2X3g2X008?LJP33g:X0PmcZ@<?
M:T23gFY00<?MZT?MZX?MZX00`mgZP8@N:X347V[0Q1jZ`8@Nj/00a1k[11l
[11l[00347f/00D@OZ`@OZd@Ojd@OjdAOjd00a60[@034H6]4H6^4H:^008A
PZh24H>^00<AQ:hAQ:lAQ:l00Q65[`<AQZl34XN`0Q:8/08BRK000a:9/A::
/A::/@034X^a00<BS;4BS;8BSK800Q:=/P054Xjb4hjb4hjb4hnb4hnc00<C
T;<24i6c00<CT[<CT[@CT[@00Q>C]0<CU;@34iFe0QBF]@8DUkD00aBG]QBH
]QBH]P0359Vf0QBJ]P<DVkL259bg0QBM]`045Ifh5Ijh5Ijh5Ijh0QFO^003
5J2h5J2i5J2i008EXKT35J:i0QFS^P<EY;X25ZFj00<FYK/FY[/FY[/00aJW
^`8FZ;/35ZVl0QJZ_08FZk`011J[_AJ/_AN/_AN/_@8G[Kd00aN^_AN^_QN^
_P025jnn0aN`_P8G/Kl35k:o0QNc_`8H]<000lSPf8S0^8S0^00;R<2h00A8
T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00>
VjOaoooo_;SMVHnnooooe]7Mfmc/lokoYY_4k^kdQGJ`ThFjoooo<d>U0`00
P009oooo00600060006000:0oooo00>1oooo00>1008018403Oooo`05P@05
P_ooo`06P_ooo`07PP47PP48P_ooo`48Poooo`49P`020@Z300Coool12h@1
2hCoool20@b40P4=Q0030@j40@j5oooo00<23hD00oooo`8@Q@8AQP020Q66
0P8BQP05oooo0Q>60Q>70QB7oooo00825HL01?ooo`8FQoooo`<FR0835hP0
0oooo`<HR?ooo`020aV90`<JR@836hT00`<LR@<LRP<LRP030af:0P@NRP<4
7h/2122;0P@QR`03126<12:<12:<00<48h`01@@TS0@TS@@US@@US@DUS@03
1BJ=00<59hd59hh5:8h00PDXSP85:Hh00`DZSPDZS`DZS`021B^?0`D/S`<6
;I021Rj@0PH_T0031RnA1S2A1S2A00<6<I400`HbT@HbTPHcTP021S>B00D6
=987=987=987=I87=I<00`LfT`87=i<00`LhT`LhU0LhU0021cVD0`LjU0<7
>iD223bE0PPmU@0323fF23jF23jF00<8?iH2242F0`Q1U`88@YL224>G00@9
@iP9A9P9A9P9A9P22DFH00<9AYP9AYT9AYT00PU7V@<9B9T22DVJ0`U:VP8:
BiX00`Y;V`Y<V`Y<V`032TfK0PY>V`<:Ci`22U2L0PYAW0042U6M2U:M2e:M
2e:M0P]CW@032eBM2eBN2eBN008;EIh32eJN0P]GW`<;F9l32eVO0PaJX0<<
Fj0235bP0`aMX@8<GZ4235nQ00<<Gj8<H:8<H:800PaQXP043F6R3F:R3F:S
3F:S0PeSX`<=I:<23FFT0`eVY08=Ij@00`eXY0eXY@eXY@033VVU0PiZY@<>
JjH23VbV0Pi]YP033VfW3VjW3VjW00<>KjL00`i`Y`m`Z0m`Z0023g6X0`mb
Z08?LjT33gBY0PmeZ@033gJY3gJZ3gJZ00<?MjX247RZ0a1iZ`8@NZ/247^[
00<@Nj`@O:`@O:`00a1m[00547j/47j]47n]47n]4Gn]00<AP:d00a61[A61
[Q62[P024H:^0Q63[P034HB^4HB_4HB_008AQJl34HJ_0a:7/08BR;024XV`
00<BRK4BR[4BR[400a:;/@034Xba4Xbb4Xfb008BSK801A:>/Q>>/Q>>/Q>?
/Q>?/`034i2c0Q>A/`034i:c4i:d4i:d008CTk@34iBd0a>E]@8DU[D259Ne
00<DUkHDV;HDV;H00aBI]P8DV[H359^g0QBL]`8DWKL011FM^1FN^1FN^1FN
^08EWkP00aFP^1FP^AFP^@025J6i0aFR^@8EXkX35JBj0QJU^P035ZFk5ZJk
5ZJk00<FYk/25ZRk0aJY_08FZ[`25Z^l00@FZkdF[;dG[;dG[;d25jfm00<G
[[dG[[hG[[h00QN__P<G/;h25k6o0aNb_`8G/kl26;C000C8h=R8`;R8`;R8
`;P2000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0`00P00?VjOaooooVHnnUhZle=?XkjbcogIkkYn[
FeRUYY_4UYoBH4bJ_;SMoooo<d>U008008002Oooo`01P001P001P002P?oo
o`03POooo`03P@0200B10P05P@0700F2oooo00J2oooo00N20@N20@R20081
28<00oooo`49P`4:P`020@Z30P4;Q003oooo0@b40@b400813H@00`4>Q04>
QOooo`030Pn500?oool248D24HH00P8AQP824XH01Oooo`8CQP8CQ`8DQooo
o`020QF700Coool25XOoool35XP20aN80`<HR0836HT30aZ90P<KR@030ab9
0ab:0ab:00<37HX211j:0`@OR`8488/2126;00<48H`48X`48X`00`@SS005
12B<12B=12F=12F=1BF=00<59Xd00`DWS@DWSPDXSP021BR>0PDYSP031BZ>
1BZ?1BZ?0085:hl31Bb?0`H]T086;Y021Rn@00<6;i46<946<9400`HaT@03
1S:A1S:B1S>B0086<i801@HdTPLdTPLdTPLeTPLeT`031cJC0PLgT`031cRC
1cRD1cRD0087>I@31cZD0`LkU@88?9D223fE00<8?IH8?YH8?YH00`PoUP88
@9H3246G0PQ2U`88@iL010U3V0U4V0U4V0U4V089AIP00`U6V0U6V@U6V@02
2DNI0`U8V@89BIX32DZJ0PY;VP032T^K2TbK2TbK00<:CI/22TjK0`Y?W08:
D9`22U6L00@:DId:DYd;DYd;DYd22e>M00<;E9d;E9h;E9h00P]EWP<;EYh2
2eNO0`]HW`<;FIl235ZP0`aKX08<G:0335fQ0PaNX@8<Gj400`aOXPaPXPaP
XP02366R00@=HJ8=HZ8=HZ<=HZ<23F>S0`eTX`8=IJ@33FJT0PeWY0033FRT
3FRU3FRU00<>JJD23VZU0`i[YP8>K:H23VfV00<>KJL>KZL>KZL00`i_Y`03
3W2W3g2X3g2X008?LJP33g:X0PmcZ@<?M:T23gFY00<?MZT?MZX?MZX00`mg
ZP8@N:X347V[0Q1jZ`8@Nj/00a1k[11l[11l[00347f/00D@OZ`@OZd@Ojd@
OjdAOjd00a60[@034H6]4H6^4H:^008APZh24H>^00<AQ:hAQ:lAQ:l00Q65
[`<AQZl34XN`0Q:8/08BRK000a:9/A::/A::/@034X^a00<BS;4BS;8BSK80
0Q:=/P054Xjb4hjb4hjb4hnb4hnc00<CT;<24i6c00<CT[<CT[@CT[@00Q>C
]0<CU;@34iFe0QBF]@8DUkD00aBG]QBH]QBH]P0359Vf0QBJ]P<DVkL259bg
0QBM]`045Ifh5Ijh5Ijh5Ijh0QFO^0035J2h5J2i5J2i008EXKT35J:i0QFS
^P<EY;X25ZFj00<FYK/FY[/FY[/00aJW^`8FZ;/35ZVl0QJZ_08FZk`011J[
_AJ/_AN/_AN/_@8G[Kd00aN^_AN^_QN^_P025jnn0aN`_P8G/Kl35k:o0QNc
_`8H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0^004B9280000
6;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008002Y^WlOoo
oiN:_7Y/Z[?7j:U^X<S3gi>5^U]6TiV?_P9hIJh0148WQJnUb_oooc=3Y@<0
0803006000<00X3oool00h401Oooo`0400F100F2oooo00J21Oooo`030@R3
oooo0@V300<12X<20@^400?oool138@138@00P4=Q0030@j40@j50@j500Co
ool0108@Q@8AQP8AQP8AQP824XH01Oooo`8CQP8CQ`8DQoooo`020QF700?o
ool25XOoool01?ooo`8368P20aV90`<JR@836hT00`<LR@<LRP<LRP030af:
0P@NRP<47h/2122;0P@QR`03126<12:<12:<00<48h`01@@TS0@TS@@US@@U
S@DUS@031BJ=00<59hd59hh5:8h00PDXSP85:Hh00`DZSPDZS`DZS`021B^?
0`D/S`<6;I021Rj@0PH_T0031RnA1S2A1S2A00<6<I400`HbT@HbTPHcTP02
1S>B00D6=987=987=987=I87=I<00`LfT`87=i<00`LhT`LhU0LhU0021cVD
0`LjU0<7>iD223bE0PPmU@0323fF23jF23jF00<8?iH2242F0`Q1U`88@YL2
24>G00@9@iP9A9P9A9P9A9P22DFH00<9AYP9AYT9AYT00PU7V@<9B9T22DVJ
0`U:VP8:BiX00`Y;V`Y<V`Y<V`032TfK0PY>V`<:Ci`22U2L0PYAW0042U6M
2U:M2e:M2e:M0P]CW@032eBM2eBN2eBN008;EIh32eJN0P]GW`<;F9l32eVO
0PaJX0<<Fj0235bP0`aMX@8<GZ4235nQ00<<Gj8<H:8<H:800PaQXP043F6R
3F:R3F:S3F:S0PeSX`<=I:<23FFT0`eVY08=Ij@00`eXY0eXY@eXY@033VVU
0PiZY@<>JjH23VbV0Pi]YP033VfW3VjW3VjW00<>KjL00`i`Y`m`Z0m`Z002
3g6X0`mbZ08?LjT33gBY0PmeZ@033gJY3gJZ3gJZ00<?MjX247RZ0a1iZ`8@
NZ/247^[00<@Nj`@O:`@O:`00a1m[00547j/47j]47n]47n]4Gn]00<AP:d0
0a61[A61[Q62[P024H:^0Q63[P034HB^4HB_4HB_008AQJl34HJ_0a:7/08B
R;024XV`00<BRK4BR[4BR[400a:;/@034Xba4Xbb4Xfb008BSK801A:>/Q>>
/Q>>/Q>?/Q>?/`034i2c0Q>A/`034i:c4i:d4i:d008CTk@34iBd0a>E]@8D
U[D259Ne00<DUkHDV;HDV;H00aBI]P8DV[H359^g0QBL]`8DWKL011FM^1FN
^1FN^1FN^08EWkP00aFP^1FP^AFP^@025J6i0aFR^@8EXkX35JBj0QJU^P03
5ZFk5ZJk5ZJk00<FYk/25ZRk0aJY_08FZ[`25Z^l00@FZkdF[;dG[;dG[;d2
5jfm00<G[[dG[[hG[[h00QN__P<G/;h25k6o0aNb_`8G/kl26;C000?8h=R8
`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0P00P003VjOaoooooooo00;oool02_n]/?mfNoW=
e?g]k_ooojJKa8Ef/;bhgOoooc=3Y@@008002001P?ooooooooooo`02P003
POooo`03P@8018403Oooo`05P@05P_ooo`06P_ooo`07PP47PP48P_ooo`48
Poooo`49P`020@Z300Coool12h@12hCoool20@b40P4=Q0030@j40@j50@j5
00<23hD00oooo`8@Q@8AQP020Q660P8BQP05oooo0Q>60Q>70QB7oooo0082
5HL01?ooo`8FQoooo`<FR0835hP00oooo`<HR0<HR0020aV90`<JR@836hT0
0`<LR@<LRP<LRP030af:0P@NRP<47h/2122;0P@QR`03126<12:<12:<00<4
8h`01@@TS0@TS@@US@@US@DUS@031BJ=00<59hd59hh5:8h00PDXSP85:Hh0
0`DZSPDZS`DZS`021B^?0`D/S`<6;I021Rj@0PH_T0031RnA1S2A1S2A00<6
<I400`HbT@HbTPHcTP021S>B00D6=987=987=987=I87=I<00`LfT`87=i<0
0`LhT`LhU0LhU0021cVD0`LjU0<7>iD223bE0PPmU@0323fF23jF23jF00<8
?iH2242F0`Q1U`88@YL224>G00@9@iP9A9P9A9P9A9P22DFH00<9AYP9AYT9
AYT00PU7V@<9B9T22DVJ0`U:VP8:BiX00`Y;V`Y<V`Y<V`032TfK0PY>V`<:
Ci`22U2L0PYAW0042U6M2U:M2e:M2e:M0P]CW@032eBM2eBN2eBN008;EIh3
2eJN0P]GW`<;F9l32eVO0PaJX0<<Fj0235bP0`aMX@8<GZ4235nQ00<<Gj8<
H:8<H:800PaQXP043F6R3F:R3F:S3F:S0PeSX`<=I:<23FFT0`eVY08=Ij@0
0`eXY0eXY@eXY@033VVU0PiZY@<>JjH23VbV0Pi]YP033VfW3VjW3VjW00<>
KjL00`i`Y`m`Z0m`Z0023g6X0`mbZ08?LjT33gBY0PmeZ@033gJY3gJZ3gJZ
00<?MjX247RZ0a1iZ`8@NZ/247^[00<@Nj`@O:`@O:`00a1m[00547j/47j]
47n]47n]4Gn]00<AP:d00a61[A61[Q62[P024H:^0Q63[P034HB^4HB_4HB_
008AQJl34HJ_0a:7/08BR;024XV`00<BRK4BR[4BR[400a:;/@034Xba4Xbb
4Xfb008BSK801A:>/Q>>/Q>>/Q>?/Q>?/`034i2c0Q>A/`034i:c4i:d4i:d
008CTk@34iBd0a>E]@8DU[D259Ne00<DUkHDV;HDV;H00aBI]P8DV[H359^g
0QBL]`8DWKL011FM^1FN^1FN^1FN^08EWkP00aFP^1FP^AFP^@025J6i0aFR
^@8EXkX35JBj0QJU^P035ZFk5ZJk5ZJk00<FYk/25ZRk0aJY_08FZ[`25Z^l
00@FZkdF[;dG[;dG[;d25jfm00<G[[dG[[hG[[h00QN__P<G/;h25k6o0aNb
_`8G/kl26;C000?8h=R8`;R8`;P018S0^0800005R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00:XJcbnLgDhRHl
m;FohRHlm6emo>?YoooooNg^ojf`0_ooo`03<d>U0020002000<008000ooo
o`01P001P00200:00P03P@?oool200F100@01H;oool01X801h83oooo0P48
P`060@V3oooooooooooo0@Z30@^40oooo`040@b40@f40@f40@j40P4>Q@?o
ool20Q250`8AQP070Q:6oooooooooooo0Q>70QB7oooo00825HL00oooo`8F
Q`<FR003oooo0P<HR003oooo0aV90aV900<36XT20a^900<378T378X378X0
0`<MRP847XX311n;0P@PR`848H/00`@QS0@RS0@RS00312><00D498`498d4
9Hd49Hd59Hd00`DVS@031BN=1BN>1BR>0085:8h21BV>00<5:Xh5:Xl5:Xl0
0PD[S`<5;8l31Rf@0PH^T086;i000`H_T@H`T@H`T@031S6A00<6<Y46<Y86
<i800PHcTP051SBB1cBB1cBB1cFB1cFC00<7=Y<21cNC00<7>9<7>9@7>9@0
0PLiU0<7>Y@31c^E0PPlU@88?ID00`PmUPPnUPPnUP0323nF0PQ0UP<8@IL2
24:G0PQ3U`042D>H2DBH2DBH2DBH0PU5V0032DJH2DJI2DJI0089AiT32DRI
0PU9VP<9BYX22T^J00<:Bi/:C9/:C9/00`Y=V`8:CY/32TnL0PY@W08:DI`0
10YAW@YBW@]BW@]BW@8;Did00`]DW@]DWP]DWP022eFN0`]FWP8;Eil32eRO
0`]IW`8<FZ0335^P0PaLX0<<GJ4235jQ0PaOX@0335nR362R362R008<HJ80
10eQXPeRXPeRX`eRX`8=Hj<33FBS0PeUY0<=IZ@23FNT00<=J:@=J:D=J:D0
0`iYY@8>JZD33V^V0Pi/YP8>KJH00`i]Y`i^Y`i^Y`033VnW00<>L:L?L:P?
L:P00PmaZ0<?LZP23g>Y0`mdZ@8?MJT00`mfZ@mfZPmfZP033gNZ0Q1hZP<@
NJ/247Z[0Q1kZ`0347^/47b/47b/00<@OJ`01A1n[11n[A1o[A1o[A5o[@03
4H2]00<APJdAPJhAPZh00Q62[P8APjh00a64[Q64[a64[`024HF_0a66[`<B
Qk024XR`0Q:9/0034XVa4XZa4XZa00<BRk400a:</A:</Q:=/P024Xfb00DB
S[8CS[8CS[8CSk8CSk<00a>@/`8CTK<00a>B/a>B]1>B]0024i>d0a>D]0<C
UKD259Je0QBG]@0359Nf59Rf59Rf00<DVKH259Zf0aBK]`8DW;L259fg00@E
WKPEW[PEW[PEW[P25Inh00<EX;PEX;TEX;T00QFQ^@<EX[T25J>j0aFT^P8F
YKX00aJU^aJV^aJV^`035ZNk0QJX^`<FZK`25ZZl0QJ[_0045Z^m5Zbm5jbm
5jbm0QN]_@035jjm5jjn5jjn008G[kh35k2n0QNa_`<G/[l25k>o0QRd`003
b>3HR<2hR<2h00>8`;P4000018S0^004B92800006;C06;C00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P
[_ARK_omoon]/?cSjOoooc=3Y@05002000Coool00H000H000H0200:00`03
P@80184200F100<01H;oool01X800P07PP040@N20@R20@R30@R30P49P`<1
2X<20@^400?oool138@138@00P4=Q0030@j40@j50@j500<23hD20Q250`8A
QP824XH00oooo`8CQP8CQ`020QB70P8EQ`04oooo0QJ70aJ80aJ80P<GR0<3
68P20aV90`<JR@836hT00`<LR@<LRP<LRP030af:0P@NRP<47h/2122;0P@Q
R`03126<12:<12:<00<48h`01@@TS0@TS@@US@@US@DUS@031BJ=00<59hd5
9hh5:8h00PDXSP85:Hh00`DZSPDZS`DZS`021B^?0`D/S`<6;I021Rj@0PH_
T0031RnA1S2A1S2A00<6<I400`HbT@HbTPHcTP021S>B00D6=987=987=987
=I87=I<00`LfT`87=i<00`LhT`LhU0LhU0021cVD0`LjU0<7>iD223bE0PPm
U@0323fF23jF23jF00<8?iH2242F0`Q1U`88@YL224>G00@9@iP9A9P9A9P9
A9P22DFH00<9AYP9AYT9AYT00PU7V@<9B9T22DVJ0`U:VP8:BiX00`Y;V`Y<
V`Y<V`032TfK0PY>V`<:Ci`22U2L0PYAW0042U6M2U:M2e:M2e:M0P]CW@03
2eBM2eBN2eBN008;EIh32eJN0P]GW`<;F9l32eVO0PaJX0<<Fj0235bP0`aM
X@8<GZ4235nQ00<<Gj8<H:8<H:800PaQXP043F6R3F:R3F:S3F:S0PeSX`<=
I:<23FFT0`eVY08=Ij@00`eXY0eXY@eXY@033VVU0PiZY@<>JjH23VbV0Pi]
YP033VfW3VjW3VjW00<>KjL00`i`Y`m`Z0m`Z0023g6X0`mbZ08?LjT33gBY
0PmeZ@033gJY3gJZ3gJZ00<?MjX247RZ0a1iZ`8@NZ/247^[00<@Nj`@O:`@
O:`00a1m[00547j/47j]47n]47n]4Gn]00<AP:d00a61[A61[Q62[P024H:^
0Q63[P034HB^4HB_4HB_008AQJl34HJ_0a:7/08BR;024XV`00<BRK4BR[4B
R[400a:;/@034Xba4Xbb4Xfb008BSK801A:>/Q>>/Q>>/Q>?/Q>?/`034i2c
0Q>A/`034i:c4i:d4i:d008CTk@34iBd0a>E]@8DU[D259Ne00<DUkHDV;HD
V;H00aBI]P8DV[H359^g0QBL]`8DWKL011FM^1FN^1FN^1FN^08EWkP00aFP
^1FP^AFP^@025J6i0aFR^@8EXkX35JBj0QJU^P035ZFk5ZJk5ZJk00<FYk/2
5ZRk0aJY_08FZ[`25Z^l00@FZkdF[;dG[;dG[;d25jfm00<G[[dG[[hG[[h0
0QN__P<G/;h25k6o0aNb_`8G/kl26;C000?8h=R8`;R8`;P00XS0^0800002
R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2002000>KYo7fb<cR9S`00_n]/007gb@^ojBNm[c5ojf`kW^<
oooo<d>U00H008001_ooo`01P001P001P002P?ooo`<00h4200B10P05P@03
00F2oooo00J200801h801047PP48PP48P`48P`812H<30@Z30P4;Q003oooo
0@b40@b400813H@00`4>Q04>Q@4>Q@030Pn50P8@Q@<24HH20Q:600?oool2
4hH24hL00P8DQ`825HL01?ooo`8FQ`<FR0<FR0835hP30aR80P<IR@<36XT2
0a^900<378T378X378X00`<MRP847XX311n;0P@PR`848H/00`@QS0@RS0@R
S00312><00D498`498d49Hd49Hd59Hd00`DVS@031BN=1BN>1BR>0085:8h2
1BV>00<5:Xh5:Xl5:Xl00PD[S`<5;8l31Rf@0PH^T086;i000`H_T@H`T@H`
T@031S6A00<6<Y46<Y86<i800PHcTP051SBB1cBB1cBB1cFB1cFC00<7=Y<2
1cNC00<7>9<7>9@7>9@00PLiU0<7>Y@31c^E0PPlU@88?ID00`PmUPPnUPPn
UP0323nF0PQ0UP<8@IL224:G0PQ3U`042D>H2DBH2DBH2DBH0PU5V0032DJH
2DJI2DJI0089AiT32DRI0PU9VP<9BYX22T^J00<:Bi/:C9/:C9/00`Y=V`8:
CY/32TnL0PY@W08:DI`010YAW@YBW@]BW@]BW@8;Did00`]DW@]DWP]DWP02
2eFN0`]FWP8;Eil32eRO0`]IW`8<FZ0335^P0PaLX0<<GJ4235jQ0PaOX@03
35nR362R362R008<HJ8010eQXPeRXPeRX`eRX`8=Hj<33FBS0PeUY0<=IZ@2
3FNT00<=J:@=J:D=J:D00`iYY@8>JZD33V^V0Pi/YP8>KJH00`i]Y`i^Y`i^
Y`033VnW00<>L:L?L:P?L:P00PmaZ0<?LZP23g>Y0`mdZ@8?MJT00`mfZ@mf
ZPmfZP033gNZ0Q1hZP<@NJ/247Z[0Q1kZ`0347^/47b/47b/00<@OJ`01A1n
[11n[A1o[A1o[A5o[@034H2]00<APJdAPJhAPZh00Q62[P8APjh00a64[Q64
[a64[`024HF_0a66[`<BQk024XR`0Q:9/0034XVa4XZa4XZa00<BRk400a:<
/A:</Q:=/P024Xfb00DBS[8CS[8CS[8CSk8CSk<00a>@/`8CTK<00a>B/a>B
]1>B]0024i>d0a>D]0<CUKD259Je0QBG]@0359Nf59Rf59Rf00<DVKH259Zf
0aBK]`8DW;L259fg00@EWKPEW[PEW[PEW[P25Inh00<EX;PEX;TEX;T00QFQ
^@<EX[T25J>j0aFT^P8FYKX00aJU^aJV^aJV^`035ZNk0QJX^`<FZK`25ZZl
0QJ[_0045Z^m5Zbm5jbm5jbm0QN]_@035jjm5jjn5jjn008G[kh35k2n0QNa
_`<G/[l25k>o0QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0^004
B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0800800
0i^WlOW=e?N9U`02oooo00Oo[K3Q5SCoMW_oY9kR9ScoRGlc@jD01`00P0Co
ool01002P003P@03P@03P@80184200F100<01H;oool01X800P07PP040@N2
0@R20@R30@R30P49P`<12X<20@^40`4<Q0813H@00`4>Q04>Q@4>Q@030Pn5
0P8@Q@<24HH20Q:600D24hKoool24hL258Ooool00P8EQ`04oooo0QJ70aJ8
0aJ80P<GR0<368P20aV90`<JR@836hT00`<LR@<LRP<LRP030af:0P@NRP<4
7h/2122;0P@QR`03126<12:<12:<00<48h`01@@TS0@TS@@US@@US@DUS@03
1BJ=00<59hd59hh5:8h00PDXSP85:Hh00`DZSPDZS`DZS`021B^?0`D/S`<6
;I021Rj@0PH_T0031RnA1S2A1S2A00<6<I400`HbT@HbTPHcTP021S>B00D6
=987=987=987=I87=I<00`LfT`87=i<00`LhT`LhU0LhU0021cVD0`LjU0<7
>iD223bE0PPmU@0323fF23jF23jF00<8?iH2242F0`Q1U`88@YL224>G00@9
@iP9A9P9A9P9A9P22DFH00<9AYP9AYT9AYT00PU7V@<9B9T22DVJ0`U:VP8:
BiX00`Y;V`Y<V`Y<V`032TfK0PY>V`<:Ci`22U2L0PYAW0042U6M2U:M2e:M
2e:M0P]CW@032eBM2eBN2eBN008;EIh32eJN0P]GW`<;F9l32eVO0PaJX0<<
Fj0235bP0`aMX@8<GZ4235nQ00<<Gj8<H:8<H:800PaQXP043F6R3F:R3F:S
3F:S0PeSX`<=I:<23FFT0`eVY08=Ij@00`eXY0eXY@eXY@033VVU0PiZY@<>
JjH23VbV0Pi]YP033VfW3VjW3VjW00<>KjL00`i`Y`m`Z0m`Z0023g6X0`mb
Z08?LjT33gBY0PmeZ@033gJY3gJZ3gJZ00<?MjX247RZ0a1iZ`8@NZ/247^[
00<@Nj`@O:`@O:`00a1m[00547j/47j]47n]47n]4Gn]00<AP:d00a61[A61
[Q62[P024H:^0Q63[P034HB^4HB_4HB_008AQJl34HJ_0a:7/08BR;024XV`
00<BRK4BR[4BR[400a:;/@034Xba4Xbb4Xfb008BSK801A:>/Q>>/Q>>/Q>?
/Q>?/`034i2c0Q>A/`034i:c4i:d4i:d008CTk@34iBd0a>E]@8DU[D259Ne
00<DUkHDV;HDV;H00aBI]P8DV[H359^g0QBL]`8DWKL011FM^1FN^1FN^1FN
^08EWkP00aFP^1FP^AFP^@025J6i0aFR^@8EXkX35JBj0QJU^P035ZFk5ZJk
5ZJk00<FYk/25ZRk0aJY_08FZ[`25Z^l00@FZkdF[;dG[;dG[;d25jfm00<G
[[dG[[hG[[h00QN__P<G/;h25k6o0aNb_`8G/kl26;C000?8h=R8`;R8`;P0
2hS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^08008001i^WlOoooo>P[_ARK_ooooN9UoW=e002oooo00?cX:kooolc@jD0
1`00P0<00H0200:00`03P@80184200F100<01H801X801X800P07PP040@N2
0@R20@R30@R30P49P`<12X<20@^40`4<Q0813H@00`4>Q04>Q@4>Q@030Pn5
0P8@Q@<24HH20Q:60P8CQP030Q>70QB70QB700<25HL00`8FQ`<FR0<FR002
0aN80`<HR0836HT30aZ90P<KR@030ab90ab:0ab:00<37HX211j:0`@OR`84
88/2126;00<48H`48X`48X`00`@SS00512B<12B=12F=12F=1BF=00<59Xd0
0`DWS@DWSPDXSP021BR>0PDYSP031BZ>1BZ?1BZ?0085:hl31Bb?0`H]T086
;Y021Rn@00<6;i46<946<9400`HaT@031S:A1S:B1S>B0086<i801@HdTPLd
TPLdTPLeTPLeT`031cJC0PLgT`031cRC1cRD1cRD0087>I@31cZD0`LkU@88
?9D223fE00<8?IH8?YH8?YH00`PoUP88@9H3246G0PQ2U`88@iL010U3V0U4
V0U4V0U4V089AIP00`U6V0U6V@U6V@022DNI0`U8V@89BIX32DZJ0PY;VP03
2T^K2TbK2TbK00<:CI/22TjK0`Y?W08:D9`22U6L00@:DId:DYd;DYd;DYd2
2e>M00<;E9d;E9h;E9h00P]EWP<;EYh22eNO0`]HW`<;FIl235ZP0`aKX08<
G:0335fQ0PaNX@8<Gj400`aOXPaPXPaPXP02366R00@=HJ8=HZ8=HZ<=HZ<2
3F>S0`eTX`8=IJ@33FJT0PeWY0033FRT3FRU3FRU00<>JJD23VZU0`i[YP8>
K:H23VfV00<>KJL>KZL>KZL00`i_Y`033W2W3g2X3g2X008?LJP33g:X0Pmc
Z@<?M:T23gFY00<?MZT?MZX?MZX00`mgZP8@N:X347V[0Q1jZ`8@Nj/00a1k
[11l[11l[00347f/00D@OZ`@OZd@Ojd@OjdAOjd00a60[@034H6]4H6^4H:^
008APZh24H>^00<AQ:hAQ:lAQ:l00Q65[`<AQZl34XN`0Q:8/08BRK000a:9
/A::/A::/@034X^a00<BS;4BS;8BSK800Q:=/P054Xjb4hjb4hjb4hnb4hnc
00<CT;<24i6c00<CT[<CT[@CT[@00Q>C]0<CU;@34iFe0QBF]@8DUkD00aBG
]QBH]QBH]P0359Vf0QBJ]P<DVkL259bg0QBM]`045Ifh5Ijh5Ijh5Ijh0QFO
^0035J2h5J2i5J2i008EXKT35J:i0QFS^P<EY;X25ZFj00<FYK/FY[/FY[/0
0aJW^`8FZ;/35ZVl0QJZ_08FZk`011J[_AJ/_AN/_AN/_@8G[Kd00aN^_AN^
_QN^_P025jnn0aN`_P8G/Kl35k:o0QNc_`8H]<000lSPf8S0^8S0^00;R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00
P00;VjOaooooohUooooolj2^lI>Qoooooogolj2^oo_l<d>U00L008030060
0P02P0<00h4200B10P05P@0300F200J200J200801h801047PP48PP48P`48
P`812H<30@Z30P4;Q0<138@20@f400<13X@13XD13XD00`8?Q@8248D30Q66
0P8BQP824hH00`8CQ`8DQ`8DQ`030QF700<25XL35XP35XP00P<GR0<368P2
0aV90`<JR@836hT00`<LR@<LRP<LRP030af:0P@NRP<47h/2122;0P@QR`03
126<12:<12:<00<48h`01@@TS0@TS@@US@@US@DUS@031BJ=00<59hd59hh5
:8h00PDXSP85:Hh00`DZSPDZS`DZS`021B^?0`D/S`<6;I021Rj@0PH_T003
1RnA1S2A1S2A00<6<I400`HbT@HbTPHcTP021S>B00D6=987=987=987=I87
=I<00`LfT`87=i<00`LhT`LhU0LhU0021cVD0`LjU0<7>iD223bE0PPmU@03
23fF23jF23jF00<8?iH2242F0`Q1U`88@YL224>G00@9@iP9A9P9A9P9A9P2
2DFH00<9AYP9AYT9AYT00PU7V@<9B9T22DVJ0`U:VP8:BiX00`Y;V`Y<V`Y<
V`032TfK0PY>V`<:Ci`22U2L0PYAW0042U6M2U:M2e:M2e:M0P]CW@032eBM
2eBN2eBN008;EIh32eJN0P]GW`<;F9l32eVO0PaJX0<<Fj0235bP0`aMX@8<
GZ4235nQ00<<Gj8<H:8<H:800PaQXP043F6R3F:R3F:S3F:S0PeSX`<=I:<2
3FFT0`eVY08=Ij@00`eXY0eXY@eXY@033VVU0PiZY@<>JjH23VbV0Pi]YP03
3VfW3VjW3VjW00<>KjL00`i`Y`m`Z0m`Z0023g6X0`mbZ08?LjT33gBY0Pme
Z@033gJY3gJZ3gJZ00<?MjX247RZ0a1iZ`8@NZ/247^[00<@Nj`@O:`@O:`0
0a1m[00547j/47j]47n]47n]4Gn]00<AP:d00a61[A61[Q62[P024H:^0Q63
[P034HB^4HB_4HB_008AQJl34HJ_0a:7/08BR;024XV`00<BRK4BR[4BR[40
0a:;/@034Xba4Xbb4Xfb008BSK801A:>/Q>>/Q>>/Q>?/Q>?/`034i2c0Q>A
/`034i:c4i:d4i:d008CTk@34iBd0a>E]@8DU[D259Ne00<DUkHDV;HDV;H0
0aBI]P8DV[H359^g0QBL]`8DWKL011FM^1FN^1FN^1FN^08EWkP00aFP^1FP
^AFP^@025J6i0aFR^@8EXkX35JBj0QJU^P035ZFk5ZJk5ZJk00<FYk/25ZRk
0aJY_08FZ[`25Z^l00@FZkdF[;dG[;dG[;d25jfm00<G[[dG[[hG[[h00QN_
_P<G/;h25k6o0aNb_`8G/kl26;C03lSPf00300006;C06;C000:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P400200i^Wl@06oooolj2^m;Fom[c5nmWJ
<d>U2000P0<00H0200:00`03P@80184200F100<01H801X801X800P07PP04
0@N20@R20@R30@R30P49P`<12X<20@^40`4<Q0813H@00`4>Q04>Q@4>Q@03
0Pn50P8@Q@<24HH20Q:60P8CQP030Q>70QB70QB700<25HL00`8FQ`<FR0<F
R0020aN80`<HR0836HT30aZ90P<KR@030ab90ab:0ab:00<37HX211j:0`@O
R`8488/2126;00<48H`48X`48X`00`@SS00512B<12B=12F=12F=1BF=00<5
9Xd00`DWS@DWSPDXSP021BR>0PDYSP031BZ>1BZ?1BZ?0085:hl31Bb?0`H]
T086;Y021Rn@00<6;i46<946<9400`HaT@031S:A1S:B1S>B0086<i801@Hd
TPLdTPLdTPLeTPLeT`031cJC0PLgT`031cRC1cRD1cRD0087>I@31cZD0`Lk
U@88?9D223fE00<8?IH8?YH8?YH00`PoUP88@9H3246G0PQ2U`88@iL010U3
V0U4V0U4V0U4V089AIP00`U6V0U6V@U6V@022DNI0`U8V@89BIX32DZJ0PY;
VP032T^K2TbK2TbK00<:CI/22TjK0`Y?W08:D9`22U6L00@:DId:DYd;DYd;
DYd22e>M00<;E9d;E9h;E9h00P]EWP<;EYh22eNO0`]HW`<;FIl235ZP0`aK
X08<G:0335fQ0PaNX@8<Gj400`aOXPaPXPaPXP02366R00@=HJ8=HZ8=HZ<=
HZ<23F>S0`eTX`8=IJ@33FJT0PeWY0033FRT3FRU3FRU00<>JJD23VZU0`i[
YP8>K:H23VfV00<>KJL>KZL>KZL00`i_Y`033W2W3g2X3g2X008?LJP33g:X
0PmcZ@<?M:T23gFY00<?MZT?MZX?MZX00`mgZP8@N:X347V[0Q1jZ`8@Nj/0
0a1k[11l[11l[00347f/00D@OZ`@OZd@Ojd@OjdAOjd00a60[@034H6]4H6^
4H:^008APZh24H>^00<AQ:hAQ:lAQ:l00Q65[`<AQZl34XN`0Q:8/08BRK00
0a:9/A::/A::/@034X^a00<BS;4BS;8BSK800Q:=/P054Xjb4hjb4hjb4hnb
4hnc00<CT;<24i6c00<CT[<CT[@CT[@00Q>C]0<CU;@34iFe0QBF]@8DUkD0
0aBG]QBH]QBH]P0359Vf0QBJ]P<DVkL259bg0QBM]`045Ifh5Ijh5Ijh5Ijh
0QFO^0035J2h5J2i5J2i008EXKT35J:i0QFS^P<EY;X25ZFj00<FYK/FY[/F
Y[/00aJW^`8FZ;/35ZVl0QJZ_08FZk`011J[_AJ/_AN/_AN/_@8G[Kd00aN^
_AN^_QN^_P025jnn0aN`_P8G/Kl35k:o0QNc_a@H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h5@00P0<00H0200:00`03P@80184200F100<01H80
1X801X800P07PP040@N20@R20@R30@R30P49P`<12X<20@^40`4<Q0813H@0
0`4>Q04>Q@4>Q@030Pn50P8@Q@<24HH20Q:60P8CQP030Q>70QB70QB700<2
5HL00`8FQ`<FR0<FR0020aN80`<HR0836HT30aZ90P<KR@030ab90ab:0ab:
00<37HX211j:0`@OR`8488/2126;00<48H`48X`48X`00`@SS00512B<12B=
12F=12F=1BF=00<59Xd00`DWS@DWSPDXSP021BR>0PDYSP031BZ>1BZ?1BZ?
0085:hl31Bb?0`H]T086;Y021Rn@00<6;i46<946<9400`HaT@031S:A1S:B
1S>B0086<i801@HdTPLdTPLdTPLeTPLeT`031cJC0PLgT`031cRC1cRD1cRD
0087>I@31cZD0`LkU@88?9D223fE00<8?IH8?YH8?YH00`PoUP88@9H3246G
0PQ2U`88@iL010U3V0U4V0U4V0U4V089AIP00`U6V0U6V@U6V@022DNI0`U8
V@89BIX32DZJ0PY;VP032T^K2TbK2TbK00<:CI/22TjK0`Y?W08:D9`22U6L
00@:DId:DYd;DYd;DYd22e>M00<;E9d;E9h;E9h00P]EWP<;EYh22eNO0`]H
W`<;FIl235ZP0`aKX08<G:0335fQ0PaNX@8<Gj400`aOXPaPXPaPXP02366R
00@=HJ8=HZ8=HZ<=HZ<23F>S0`eTX`8=IJ@33FJT0PeWY0033FRT3FRU3FRU
00<>JJD23VZU0`i[YP8>K:H23VfV00<>KJL>KZL>KZL00`i_Y`033W2W3g2X
3g2X008?LJP33g:X0PmcZ@<?M:T23gFY00<?MZT?MZX?MZX00`mgZP8@N:X3
47V[0Q1jZ`8@Nj/00a1k[11l[11l[00347f/00D@OZ`@OZd@Ojd@OjdAOjd0
0a60[@034H6]4H6^4H:^008APZh24H>^00<AQ:hAQ:lAQ:l00Q65[`<AQZl3
4XN`0Q:8/08BRK000a:9/A::/A::/@034X^a00<BS;4BS;8BSK800Q:=/P05
4Xjb4hjb4hjb4hnb4hnc00<CT;<24i6c00<CT[<CT[@CT[@00Q>C]0<CU;@3
4iFe0QBF]@8DUkD00aBG]QBH]QBH]P0359Vf0QBJ]P<DVkL259bg0QBM]`04
5Ifh5Ijh5Ijh5Ijh0QFO^0035J2h5J2i5J2i008EXKT35J:i0QFS^P<EY;X2
5ZFj00<FYK/FY[/FY[/00aJW^`8FZ;/35ZVl0QJZ_08FZk`011J[_AJ/_AN/
_AN/_@8G[Kd00aN^_AN^_QN^_P025jnn0aN`_P8G/Kl35k:o0QNc_a@H]<02
R<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;ShR<2h0DR@R04000000003
R<2hb>3HR<2h0?n8`;ShR<2h0DR@R04000000003R<2hb>3Hb>3H0?o8h=Sh
b>3H0DR@R04000000?n8`;SlR<2h0@000000\
\>"], "Graphics",
  ImageSize->{508, 353},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001DB000`400?l00000o`00003ooooooooe
ooooo`00oooooooeooooo`00oooooooeooooo`00oooooooeooooo`00oooooooeooooo`00oooooooe
ooooo`00oooooooeooooo`00oooooooeooooo`00oooooooeooooo`00oooooooeooooo`00oooooooe
ooooo`00oooooooeooooo`00oooooooeooooo`00oooooooeooooo`00oooooooeooooo`00oooooooe
ooooo`00ooo^k^keonk^kP00oooVi^KeonKViP00ooo^k^hXonk^kP;okNg]00[ojn_[onSXj?oUiNGo
h^;RomgMgOoHf=Soe=CDom7AdOo>c/koc<c<0_o;bl/eol[:bP;obl_;00[oc<c<olk>c_oAdM7oe=CD
omSHf?oMgMgoh^;RonGUiOoXj>Sojn_[0_o]kNdGonk^kP;okNg]00[oj^[ZonKWiooQh^?og=gPomGH
foo=dMGob/kBolG:c_o1a/co_l?90_nm`/Lcokc1a`;o_L;700[o_l?9ol76c?o5b/kob/kBolgAeOoE
f=_og=gPon7RhooVinOoj^[Z0_o]kNdFonk^kP00oooooolWooooo`;oo_kn00[ono_kooWinOoclo?o
kNg]onGUiOoLg=coe=CDolc<c?o7alOo`l?30_o0`<02okno_c?o_[jn0_no_kl2ol30`00:ol?3`oo7
alOoc<c<omCDe?oLg=coiNGUong]kOoclo?onOWioo_kn`;oo_kn5Oooool2ooknoP0<oo[jnoofmoSo
ko3bonGXjooIgN3oc];Hol?9d?nh`LSo/k[4ojfe_onZ];coZ[>m0_nX/K/aojN`^P;oZ;6k00coZ[>m
ojZd_?n]]Koo/k[4okS1b?o3bM3oc];HomWMh?oUj>_oko3booKgn?ojn_/2ooknoQGooooo003oonk^
kROok^k^00kokNg]on[Zj_oWinOoh^;RomWIfOo>c/ko`l?3okRh^?n^[ZkoYZJVoj2PX?nLW9coVIVI
oiRHV3OoUiNG00goV9RHoiVIVOnLW9coX:2PojJVY_n^[Zko^;Rhol?3`oo>c/kofMWIon;Rh_oWinOo
j^[Z00;okNg]5?o^k^h03_o]kNgojNWZonCUi_oLgN3od=?Gol76c?nc^/3oY:beoiRR[?n=VJKoR9BP
oh>@W?moS9WoOX^H=OmlRIL03OmnRiSoOhbIoh>@W?n8U:3oSIVVoiRR[?nT[;Go/k[0ol76c?o@dmOo
g=gPonCUi_oYjNX00_o]kNdDonk^kP00oooVi^HWonKViP0=on?ShooPh>3of][Jom7AdOo5aLGo]kNg
ojRXZ?nLW9coT92@ohR8R?n1PH7oOWinog]kN`0iogYjNP0>og]kNomnOWkoPH61ohR8R?n@T93oW9bL
ojRXZ?ng]kOoaLG5om7AdOoJf][oh>3Pon?ShooUiNDDonKViP0>on;Rh_oMg]ooe=GHolK:c_ng_<;o
Y:feoi6KY_n4TIcoMXBCofilRomVMXKoHg:2of1aPOmNKh0eof1`P00?oei_P?mPLH7oHg:2ofIfQ_m^
O8_oMXBCohBAW?nAVjKoY:feokNl`_o6b/koe=GHomgNgooRh^;oiNGU01Coi^KV003oonk^kROok^k^
01Coj>SXon;Rh_oIfMWob/[:okZj^_nXZ:SoV9RHoi:BT_nUYJGo`<30omOGeoo[jn_om_KfooOgmooi
nOWon?ShooWinOojn_[onOWiooOgm`?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?o
n_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@0Coo[jn_oinOWon?ShooWinOohn?So
moOgong]kOoHf=So`L71ojFUYOnBTY;oV9RHojRXZ?nj^[[ob/[:omWIfOoRh^;oj>SXonc/k00Donk^
kP0@onKWiooNgn7od=?Gokc1aonW[kSoTIfWogj;V?m]PYOoJh^^ogJObOn1/>7oS;k`oiC9n?nFbOSo
V/kjoi_<n37oWLki017oW<choic<nOnJboSoU/Whohk0l?n4/^7oN9o:ofj=[om_PYOoOX^Hoi6MYonW
[kSo_<77om3CeooNgn7oi^OWonc/k00Donk^kP00oooooolWooooo`0<ooKfm_o]kNgogMgMol[:b_nd
];CoWinOojZZZ_o>c/kok^k^ooKfm_olo?coo_kn>oooool03Oono_koo?clooOgmoo_knooclo?oj^[
ZonOWioo];Bdol[:b_oMgMgokNg]ooKfm_okno/05?ooool04?obloCoiNS[oloDf_ng_/GoVjNaoh>@
Wom[S;3oLZ3Doh:km?n>aOSoVLgkoikBoOnReOgoYMSoojWJoonYfolaoj[Lo`0AojWKoonZg?ooY][o
ojCHoonNd_goVloloi?7nOn8_oGoMZGHog2@/_n3T9ooVjNaokNnaOo?e=[oiNS[oo;cm?ojn_/05?oo
ool00?ook^k^9oo^k^h02_oRh^;oe]KFol?3`on^[ZkoVYZJojf][OoNg]kojn_[ooCdm?okno/ooooo
o`0;oo_knooclo?ok>c/on7QhOn`/;3oVYZJojj^[_o3`l?oe]KFon;Rh_oXj>P05?o^k^h04?oLgN3o
b/kBok>j`?nGXJcoNXZKof>:/_m]Y^;oO[Oboh_3n?nGcO_oXMGnojKKoonZg_oo[MooojoQoon`hOlC
ok7So`03off<W_n3ZKko/N?o01_o/N?o0_n`hOl03on_hOoo[>3oojKLoonReOgoVLkkoho4mon4^O?o
M:_VofR=]omjRicoUj6/ok>j`?o:c];og=gPonGVi`0Donk^kP00oooVi^HWonKViP0:omKFe_o7alOo
/[:boibLW?nWYjOoe=CDon3Ph?o/k>comOGeoogmoCoooooo00_oo_knooKfm_o/k>coh^;RomWIfOn[
Zj_oW9bLok:b/_o7alOoe]KFomgMg@0DonKViP0@oloBeOnj_lCoWZN`oh>@W?mIP:goH9OEog2Xi?n1
^??oSlGioi_@o?nTe_koZM_oojoPoonai?oo/N?ook?Toa?o]NGo00?o;CU0oeYbOoneiOl06oneiOl2
ok?To`0?ok7Soon_hOooZ]coojGHoonNd_goU<OiohFjlomh[NKoJJ3Kof67/On3T9coWZN`okZoa?o?
d]GofM[K01Coi^KV003oonk^kROok^k^00_of=SHolK6a_n^[ZkoXj>SolK6a_oDe=Coh>3Ponc/k?ob
l_;oo?clooknoP0=ooooo`03on?ShooFe]Koo_kn00Cooooo00?ok>c/oogmoOooool00_odm?@;oooo
o`03ong]kOo_knoooooo00Cooooo00?om?CdonSXj?ooool04?ooool02oojn_[om?Cdon[Zj_oShn?o
emOGolg=cOnVYZKo[Zj^olK6a_oHf=Soh^;R01Cok^k^013ocM7EokJl`onHXZcoH7nSodf6a_mQV]Wo
LZWToh>hlon=`_OoVloloj3DoOnWfOko[MooojkPoon`hOoo[^3o2onchOl01?nbh?koV/;LoiW1fonb
h?h4ok?Qo`05ob`h@?mIL7oo/^3noj3:iOnbh?h01OnchOl00on[eoCoX/cXok?Qo`0Bok?Qo`0@ok3Q
oon^hOoo[Mkooj[JoonUeOgoWLkkoi;6mon6^O7oNJkXofVOf_mITLgoIHFXoiRR[?nf_<?ocM7EomkO
hACok^k^003oooooobOooooo00oohn?Solg=cOn`/;3o[jn_olK6a_oBd];og=cLonKVi_o/k>comOGe
ooShn?ojn_[ooOgmooooooolo?`01oooool05OnNWYko4Q8Bo`T92OlW9bOo6a/Koda<C?oIfMWooooo
oe5ADOl71`Oo6QXJoibLW?lC4a?oEeMGoooooom0@43oOgmooogmoOooooooXj>Soa`L7002ooooo`0@
onGUiOm0@43o0000oa8B4_lM7Agon?ShoooooooWinOoBTY:o`<30olR8R;o5aLGol71`Ooooooo@410
ogmoO`;ooooo00?ooOgmooooooooool00_ooool04?omoOgooooooogmoOokno_on?ShooCdm?o]kNgo
i^KVomoOgooFe]Koc<c<okFe]Ona/K7ocLg=on?Shooclo<Dooooo`0@omWMh?nj`/[oRIZ]odIh/?m=
Q/KoHISEog2Uh?n0/n[oRK_coiC8n?nLcOWoX=7kojOFoOnXeogoYmClojWHo@[o[=[m00OoKXbRo``?
4OlE6aoo5adRo`T;3OmRO93oZmWl00;o[=[m00Ko:cHooc90B_lI82Go4QLJo`hA5?mnX;X2ojcJo@09
oi_5iOla?dWo0P82oaLM8_l?4aKoPZBoojcJoOl[=SooEFan00;o[=[m00?oKH^Qoa8G6on/f_d02?n/
f_d04On[fOgoZMOmojWHoOnWe?coXm;loik>nOnGaoOoSL3doh>ejomgZn?oJIkIoeN@c?mBPKOoRib_
ok[2b_oIgN3okNka01Cooooo003oonk^kROok^k^01?odM7Aok^k^onQXJ7o][Jfol?3`oo?clooe]KF
omoOgooVi^Koj^[Zono_kooclo?om?CdooGemOogmoOom_KfooOgmoofm_Kon?Sh00;omoOg00CoTY:B
o`820_n6QXKom?Cd0_ofm_H02?n/[:codM7Aokno_ol30`?oe]KFomkNg_mGEeOo410@0_ogmoL01_lm
?CgoNWYjooOgmoogmoOoWIfMoa/K6`;omoOg013o?cloobXZ:_o4a<ComoOgom3@d?ofm_KomoOgod51
@Olm?CgoemOGooOgmoo[jn_ojNWYooShn?lm?CgoNg]k0_ofm_H2ooOgm`0CooKfm_ohn?Som_KfooOg
moofm_Kom?Cdoo;bl_o`l?3ojn_[onKVi_oQhN7of][Jom?Cdoo9bLWo_knoojJVY_nk^k_odM7Aon7Q
h@0Donk^kP0@olG:c_nY/;[oGWbQocIb]_m:Pl?oGYC@ofZOfOmg[>?oPkGZoh^mkonC`_KoV<Ogoig;
n?nOc?WoXLkioj7=n@WoXm3i00?oJ8FPo`H82OmdUK800_nSd?T00omoX/;o3A4DoeI^P`02oj?@n@0A
obPd?_lZ=T7oV<;Yoj3<mOm?IG[o30lBoi_6kOnSd?Wo:cM2obPd?_n>]MWoXm3ioi_6kOnJaNcoXm3i
obPd?_mAIg`00_nSd?T00omXQ9oo4AHKoj?@n@08oj?@n@0Aoj;>nOnQco[oWlcioik;n?nJb?OoU/Gf
oi2nlOn7^>[oOJoTog>Ug?mUVmGoE8c:odAn_omSPZOoZK2jolG:c_oKg]l05?o^k^h00?ooi^KV9ooV
i^H02oo9bLWo/[:boijNW_nc/k?o`<30olW9bOoCdm?ofMWIomgMgOoRh^;oiNGU00;oj^[Z00?ok>c/
ong]kOo]kNd01?o^k^h01?oWinOo4Q8BoeaLG?o`l?05onk^kP06ol[:b_l20P;o/K6aonk^k_nDU9Co
7AdM0_o^k^h02olk>c_oMWIfoo3`l?o^k^koV9RHoaXJ6_o^k^kocLg=o`000?n;Rh_ol?3`00?ok^k^
00Goc/k>o`000?n[Zj_ok^k^oo3`l003onk^kP05oc/k>omfMWKok^k^onk^k_o`l?000oo^k^h2ong]
k@;ok>c/00gojNWYonKVi_oShn?oh>3Pom_KfooEeMGocLg=olG5aOnk^k_oYJFUok:b/_o9bLWof=SH
01Coi^KV013o_L;8oinX/?m3JYgo<VfaodAn`?mESL_oI9_Dog6Tf_mjZn3oPk;UohZgjOn?_>koT/3`
oiG2l?nH`o3oV<?b2?nIaO800onF`Ngo41@Ioc90C`04oiW5lP06oeM`R_l72@_oS[OPoiW5l_lV<Cco
C69h0_nIaO801_n:/]_o0000ofN5Y?n4Z]7o0000ofj>[PGoVLGb00Ko9S4lodaRN?nIaO;oVLGbof5m
V_l@5AX9oiW5lP0AoiS3l_nH`o7oUL?`oiG1l?nA_NkoS;[YohNei_n0/>;oMJOLof^NeomMTlooChO7
ocig^_m:LZKoWjR`okg2b?oAe=H05?oVi^H00?ook^k^9oo^k^h03Oo@d=3o^;RhoibLW?n/[:co^k^k
olK6a_o=cLgodm?ComOGeooKfm_ogmoOon7QhOoRh^800_oShn<5onGUi@04okjn__l0003o[Zj^onKV
iPKoiNGU00GoW9bLobd];Ol];Bgo<30`oa`L7002onGUi@0;ocTi>OmbLW;oi^KVonGUiOnBTY;o6ATI
onGUiOnZZZ[o0000okVi^OoVi^H00ooUiND00onZZZ[o0000ocHf=P03ocPh>005ok2`/?oUiNGo>CTi
og9bL_oUiND00_oVi^H3onGUi@;oi>CT0_oShn<03OoRh^;oh>3PomcLg?oIfMWoe]KFom3@d?o9bLWo
`L71okFe]OnUYJGo^;Rhom3@d?oPh>005?o^k^h04?o4bLooYJfeobmIVOl]IJ_o?WRkodj7a_mMT/ko
J9gEog2Sf_miZ=goP:kPohBchon9]>GoR[KUohbgi_n=^>L8oi2ki`03ogRL`Ol0003oEW2:00CoT;_W
00KoOjG<o`000?mYRJWoT;_Wob@^>Om7GG<3oi2ki`05o``@4omAJX?oJh^/o`000?lR;3L00olS;ST0
1?m^Sk7oT;_Wob@^>Om7GG<2oi2ki`03oeagTol?51WoT;_W00SoT;_W0_n=^>H03on;]nGoRKGUohNd
i?n3/>;oO:_MogJVfom_XMOoHiSCoeN>bOm9P/;o=VndocIVY?nU[KGoa<W?omWLgP0Donk^kP00oooo
oolWooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_K
f`03omcLg0;og]kN0_oMgMd01?nKVi_o0000ol?3`ooMgMd2omkNgP?ogMgM00Kog]kNomgMgOoMgMgo
g=cLoh20P?lL71`2omgMg@0;ocLg=om@D53ogMgMomkNg_n8R8So6ATIomgMgOnm_Kgo0000ogemOOoM
gMd00_oNg]h03?oMgMgo_Kfmo`000?nDU9Co/k>cojb/[?l20P;oalO7omgMgOlg=cOoKVi^omkNgP;o
gMgM0_oNg]h2omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`
oj6QXOo8b<Soh>3Poo7alACooooo013odmSLokFla_lNB97o:5bUocA_]Om4O/3oDX[7oefBc_mVV]?o
Kj3FogFVf_mkZMcoOZcMoh6^gOn1[mgoPZoM2?n5/N000omMO9ko0000og6F_P04ohFah006oh:^g?l0
003oCfZ6ohFah?lQ;3So?eA[0_n5/N003OmkY=3o0000ofF7ZombV<3o0000oeUfU_m[SkGoIhZ^o`42
0_mgW/WoQK7Pob4/>?l`@5400_n5/N000omAK8Wo3a@IohFah008ohFah00AohB`gOn2[mgoPJoMoh2]
gOmlZ]coN:SJogBSeom/W]?oI9WAoeZ@bom?Q/Go?gZmobmX[_lVEYko]Kc6om?Hg?o[k^l05?ooool0
0?ook^k^9oo^k^h03OoDe=Co_knoohb<S?nNWYko[Jf]okVi^Oo2`/;oalO7olc<c?o@d=3od];BomGE
eOoFe]H00_oGemL00ooHf=SofMWIomWIf@02omWIf@03ojVYZOl0003o/[:b00OofMWI00GoVIVIokVi
^OoFe]KoDU9BodM7A`02omWIf@06ocHf=_lA4A7oI6ATokbl_?m:BT[o@D510_oIfMT01Ole=CGo8B4Q
oj6QXOoHf=So_;bl00;ofMWI00Go=CDeoe]KFooBd];oQXJ6ob@T9002omWIf@03ocHf=_m/K6cofMWI
00GofMWI0_oHf=P2omOGe`0=omGEeOoCdm?od=3@olk>c_o:b/[oaLG5okno_one]KGoZJVYoiRHV?no
_kooe=CDon;RhP0Donk^kP0@ol[>d_n]][go5cn9ob1@W?l/I:_o>G>iodR1`_mCR/SoGI;>ofFHdOm[
WM?oL:7FogBSeomfYMOoN:OHogVWf@SoOJWK00?oHH>Zo`000?mWS;H01?mmZM/04OmVR[?o0000oe=a
T_mmZM_o7bXfo`dA5om:I87oJi6loc=5F_l82`koNjOHogfYfolN:CKo=4IKogVSe?m=J8Oo5A`T00;o
OJWK00Ko7bXfo`T=4OliCVGoK9>nobXiB_lU<d89ogfYf`;oNJOI00ooN:KGogFUeomcX]GoKYoDofVJ
dOmSU/ooFY3;odn7a_m2O;oo<fjdobUOZ?lOC9Ko[KJmol[>d_oLgN005?o^k^h00?ooi^KV9ooVi^H0
3OoAdM7o_knoohR8R?nCTi?oXZ:Rojn_[onj^[[o`L71olO7aoo;bl_oc/k>om3@d?oAdM400_oCdm<3
omCDe0;oeMGE00Coa/K6o`410On3Ph?oeMGD0_oDe=@2omGEe@0FomKFe_oEeMGoLg=cobTY:Ol=3@go
;bl_oj>SXooEeMGoe]KFodI6A_meMGGoIFEToa0@4?lV9RKoXj>SomGEeOoFe]Ko`L71odU9BOl<30co
2@T9oalO7`;oeMGE00co`L71oc/k>ol:2P[o5aLGoiRHV?oDe=CoeMGEocDe=OmZJV[oeMGEomKFe_oE
eM@2omCDe0;oeMGE013oe=CDom?CdooCdm?odM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jfoj^[ZonM
WIgoTI6Aokno_ooAdM7ofm_K5?oVi^H04?o6b/ko[kJmoae0PolHAI7o8eFPobeV[_liM;WoAWo0oe::
b?mLTLcoHYK>ofVJdOm/W];oL:3Dog2PeOmaX=@8ogFTe@03offIa_l10@;oBVR700CoMJCE00[o?eQc
o`000?mRRK;oMJCEobHfA_loF7?o;T1Do`D82_l;41CoCFb<0_meY=D01OmYTl3o82dko`D82_l<4QOo
DgFH00;oMJCE00Ko9SI6od1JM?lgCFGo2@`@oaDM9_mIOZ<9ogFTe@0Aog>ReOmbXMGoL:3DofnOe?mZ
WM;oIY[@of6FcomHSL[oC8G4od5k_oleL;Go:V:[oam@VolUBXko[kJmolK:c_oGf=X05?oVi^H00?oo
k^k^9oo^k^h04_oMgMgocLg=oi2@T?n9RHWoUiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooI
fMWof][Jom_KfooJf][ofm_KomcLg0?ofm_K00GoEEEEoalO7oo;bl_ofm_KomcLg006om_Kf`03omWI
fOoLg=cofm_K00Gofm_K00?of][JomcLg?oKfm/01OoKfm/00ooHf=Sog=cLom_Kf`03om_Kf`07omSH
f?oKfm_ofm_KomcLg?oKfm_o=SHfofe]K@04om_Kf`0ComcLg?oKfm_ofm_Kom_KfooJf][ofMWIomSH
f?oFe]Kodm?Colg=cOo2`/;o][Jfojb/[?nOWiooT92@oiJFU_o=cLgogMgMonGUi@0Donk^kP0@omGH
foo0a<[o=U>:oa0iQolJB9Ko8eRSoc5X/Om6O[koHI;:og6PdOmiY]GoOZWGoh>/fOn5[][oQk3LohNa
f`WoS;?L00?o>4QHoaPN9On4ZM000_n</m`00on8[]Ko7RH_obTe@@05ohbcg003ohZaf_n</mcoS;?L
00CoS;?L00?oR[3Iohbcg?n</m`01On</m`00on;/]_oS;?Lohbcg009ohbcg00AohN`fon8/M_oQjoK
ohF^f_n1ZmWoO:OGogBRd_mTU/coC8?2ocA^]OlZH:_o852NoaE0S_liEi3o`<C:omGHfooQh^<05?o^
k^h00?oooooo9oooool02oobl_;oiNGUojVYZOmjNW[oR8R8oiJFU_nZZZ[oa<C4omGEeOoKfm_og]kN
00;oh>3P0ooRh^800ooTi>Cohn?Son?Sh`02on?Sh`08om7AdOli>CWo6QXJofe]KOn6QXKoIfMWobXZ
:_nYZJT3on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`05on?Sh`05onCTi?oShn?ohn?SocPh>?maLG400ooShn<01?oTi>Cohn?Son?ShooShn<2on;R
hP0>on7QhOoPh>3ogmoOomcLg?oGemOoaLG5ojb/[?nNWYkoT92@oh:2P_n][JgoiNGUoo;bl_oinOTD
ooooo`0@onc]l?oIgN3oJ7ZPo`HYMol?=XKo6DFEobiQZOmNS<?oPj_EohndfonG^]goVkcOoijmh?nO
`>3oX<7Poj71h0WoYL?S00SoVKGBobXb>_lJ7bCoEFAeoeUYN_lQ9bko82H/oi:/bB3oYL?S017oXl;S
oj?2hOnQ`^7oWl3Poijoh?nI^]koT[OLohB[e_mKSLCo;F:[oai?VolD?Xko2c60ofUnY?oIgN3ok>g`
ooKgn00Dooooo`00ooo^k^hWonk^kP0>onGUiOoMgMgo`/;2og]kNomhN7SoQXJ6oinOWoo5aLGof=SH
omgMgOoOgmoohN7Qon;Rh_oShn<3onCTi0CoiNGU00Soi>CTon?ShonOWiooLW9boeiNG_mkNg_oVi^K
omOGe`;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@0
0ooUiNGoi>CTonGUi@03onGUi@;oi>CT00KoiNGUonCTi?oUiNGoiNGUocTi>OmbLW82onCTi004onGU
iOoTi>CoiNGUonGUi@?oi>CT00kohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4
ol?3`ooMgMgoiNGUon[ZjQCok^k^013ohN;SomGHfonW[[_o7SQfo`@XM_l==8Go:UBMofb@`_nF/mOo
W[_Loj6mg_nS`^3oY/?QojW4hOn[a^?oZ/KS2_n[an<01_nYaN7oM8NJoe5NJom=FVOoKX2BojK2gB7o
ZlOS0_n[a^<03onYa^?oZ<CQoj?2h?nR`=koX[gNoiNefOm[T/Co9eFOoa4kRol8;Gko7cilojN__OoE
f=_ohN;SonWYjP0Donk^kP00oooVi^HWonKViP0;on3Ph?oKfm_od];Boi^KVomUIFGoLg=cohf=SOnk
^k_oe=CDom[Jf_oMgMd00_oOgml00ooPh>3ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q
00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q
00?oh^;Ron7QhOoQhN400ooQhN400ooMgMgogmoOon;RhP08on7Qh@0>on3Ph?oOgmoogMgMomcLg?oE
eMGo^KViohj>S_mkNg_oKVi^oijNW_oBd];ofm_Kon3Ph?oTi>@DonKViP0?omkOgooGf=[obLc@of5^
Tol06VCo0B=aoaXmRomTP[OoUZgBoj2ff?nS^m_oYl3MojK0g_nX`MooZ<?O03?oZL?O013oZ<;OojW3
gonW`MkoY/3NojFmfonS^]WoUZgBoean]_lG?H_o1BUio`0PK?mQLIGobLc@omOHf_oNgmooi>CT5?oV
i^H00?ook^k^9oo^k^h03?o[jn_oj>SXon;Rh_oGemOoSHf=of9RH_mfMWKoY:BTolO7aooBd];oeMGE
omSHf0;of][J0ooKfm/7omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
0ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`0
5?oKfm_og=cLomcLg?oKfm_og=cLom_KfooJf][ofMWIomSHf?oCdm?oaLG5oibLW?meMGGoIfMWoi2@
T?oGemOoh^;RonSXj?o[jn_okNg]5?o^k^h03_oZj^[oiNKWomcMh?o<d=CoBEN3o`0HH?l::W;oA6>P
oh>Ha?nGZlooW;3Boj2ee_nT^]SoXk[H0_nT^]PaojBkf@0AojBjf?nU^mSoXk[Hoj:gf?nR]mOoWkCE
oiN/dOmlUL7o<e>Ho`4UL_l076KoBEV8olc@e?oLgN3oiNKWon[Zj_o]kNd05?o^k^h00?oooooo9ooo
ool03_ono_kono_kooShn?obl_;og]kNoi6ATOmJFU[oNg]koj>SXonl_;coa/K6ol_;boo=cLgoclo?
0_oAdM45om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];B
om7Ad@03om;BdP;odM7A00god=3@olo?coo<c<cob<S8ok^k^onLW9coLW9boe]KFonDU9Cog]kNoo;b
l_ohn?Sono_k00;oo_kn5?ooool04?ono_kon_[kooGfmoo/kO3obloHodmJQ_l25E_o6cAhodiWWomd
S;SoQY_2ohfPaonAY<[oTjO<oiJZcOnGZldboiN/c@;oUZ[=00coUJS<ohnRb?n8W<GoL8RfoceLUol;
:6oo01AKodmMROo;cmSok>g`ooGfmoojn_/2ooknoQCooooo003oonk^kROok^k^0_o]kNd03_oZj^[o
j>SXon;Rh_oLg=coW9bLofe]KOmXJ6SoPh>3oiNGUonSXj?o[:b/ojn_[ona/K7o/[:b0_nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd
];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@04one]KGo][JdokBd]?nd];Co][Jfok>c/onb/[;o/k>c
ojn_[onZZZ[oW9bLoh:2P_mRHV;oKVi^oinOWooLg=coh^;RonSXj?oZj^X00_o]kNdEonk^kP;okNg]
00kojNWZonGViooNgn7oe=OJofaaT_lT;VSo4b=Wobe1Oom5G9?oDfZOoemeZ?mSNZ[oI7b/of=l[C7o
JH6`00koIWn_ofIn[_mXOjkoHgZZoeacY_m8H9Ko9cemo`PLHOlQ;FSoJg:EomCGf_oNgn7oiNKWonWY
jP;okNg]5Oo^k^h00?ooi^KV:?oVi^H2onGUi@0?on?ShooPh>3ogMgMom[Jf_o4a<CoVYZJogYjN_mY
JFWoHf=SofUYJOmbLW;oM7AdogUiNOmlO7coNg]k00;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7al
og]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?ml
O7coNg]k0_mmOGd01omlO7coNg]kogalO?mmOGcoO7alog]kNommOGd00_mjNWX02omgMgOoM7Adofe]
KOm_KfooO7aloiZJV_o5aLGof][JomgMgOoPh>3ohn?S00;oiNGU5ooVi^H2onGUi@0=on;Rh_oNgmoo
fM[KomCEf?n`/kkoJg2@oce2LOlQ:VCo529QoaHWIolM<6ko7c5`ob<gMP0aobDjN@0=ob@gMolU>7Ko
93IcoalaL?lK:FWo8bmZoce4Lom[L93o/;BoomCEf?oIf]_og]oOon;RhP02onGUiAKoi^KV003oonk^
kRWok^k^0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;RhP03on3Ph?oOgmoog]kN03WogMgM00?og]kN
omoOgooPh>000_oRh^801?oUiNGoj>SXon[Zj_o/k>`2ong]kAWok^k^0_o]kNd02_o/k>cojNWZonGV
iooQh^?og]oQomcMh?oIg=kof=_MomKIfooEf=XeomGHf`0:omGHf_oFfM_of=_MomWLg_oLgN3og]oQ
on7RhooUi^OojNWZonc/k0;okNg]5oo^k^h00?oooooo:oooool2ooknoP03oogmoOokno_ono_k00;o
nOWi0_ohn?PiooOgm`;on?Sh0_oinOT2oo_kn`03oogmoOono_koo_kn01gooooo0_ono_h01OomoOgo
n_[koo[jnoogn?Som_Oh00;omOKg=oocm?D2ooGfm`05ooKgn?ogn?Son_[koo[jnoomoOd00_ono_hI
ooooo`00ooo^k^keonk^kP00oooVi^KeonKViP00ooo^k^keonk^kP00oooooooeooooo`00ooo^k^ke
onk^kP00oooVi^KeonKViP00ooo^k^keonk^kP00oooooooeooooo`00ooo^k^keonk^kP00oooVi^Ke
onKViP00ooo^k^keonk^kP00oooooooeooooo`00ooo^k^keonk^kP00oooVi^KeonKViP00>_o^k^h0
2?o]kNgojn_[on?ShooFe]KoalO7okfm_Onf][Ko]KFec?nd];@02?ne]KGo][Jfokfm_Oo7alOoe]KF
on?Shoo[jn_okNg]g_o^k^h003[ooooo00SooOgmooCdm?oNg]ko_;bloibLW?n6QXKoNg]kogMgMlco
MWIf00SoMgMgog]kNon6QXKoW9bLokbl_?oNg]kom?CdoogmoMkooooo000jonk^kP06onSXj?oFe]Ko
[jn_oiVIVOnh^;Soi^KV_oooool00onFe=oo_?Gookceo`02okceo`03ok_doonlmOoo_?Go00Ko_?Go
00Wo^oCookSaoon_j_ooV]3WogZP__mkRico[jn_omKFe_oXj>P0g_o^k^h003[oi^KV00Gog=cLol71
`OnNWYkoclo?oogmo@30ooooo`06oi_Jgonkm?oo^_7ookceoononOoo_?Go1onmm_l2okoio`08ok_d
oondl?ooZ^OooiGHoom_Y=coNX^Ool71`OoLg=cNonKViP00>_o^k^h01OoQhN7o_Kfmok>c/ooclo?o
o_kn0<3ooooo00?oT/kOokW`oonjlOl00_njlOl01_nhkooo^_7ookW`oonjlOoo^O3ookS_o`;o]^ko
0_nhkol02?ndk?oo[^WoojSVoonEe_ooNKgooef7]_nm_KgohN7Qg_o^k^h003[ooooo00GolO7aolC4
a?o>c/kolo?coogmo@30ooooo`03oi7<gondj_oo]>[o00[o]N_o00[o/nWookG[oonajOooZnGooj?P
oon@d?ooMk[oodn?e?o4a<ColO7ag_ooool003[ok^k^00Koh>3PokFe]OoJf][olO7aooWinOomoOd2
ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4
ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4
ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4
ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool0
0oono_koR/?Ook7Uo`02ok7Uo`04ojoToonaiOoo[nCook7Uo`Co[nCo00_o/NGoojkSoon^iOoo[^?o
ojOQoonLf?ooSLgoogBhoom4SMco]KFeon3Ph03Nonk^kP003ooVi^H00ooDe=CoemOGonKViP0EonKV
iP03omCDe?oTi>Coi^KV00;og=cL0ooVi^H00oo>c/koi>CTonKViP08onKViP05omSHf?n^[ZkofMWI
onk^k_oemOD00_okno/00oomoOgono_koo_kn`02oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4
oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4
oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4
oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4
oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4
oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4
oo_kn`;ooOgm0_ono_/4oo_kn`03oogmoOn1^]ooZn3o00;oZ]oo00Co[>7ooj[Ooon/hOooZ]oo1?n/
hOl02onZgoooZ=ooojSNoonVfoooW]GooiSDoon8aoooKJohod::fon^[Zkof=SH0=koi^KV0006onk^
kP03oc8b<_m/K6cok^k^00Cok^k^00Koc<c<oc4a<Ol=3@go2`/;ocDe=Oo=cLd2onk^kP03oc/k>omf
MWKok^k^00;ok^k^00Ko>c/kogIfM_o^k^kok^k^og5aLOln?Sh2onk^kP0BojRXZ?l820Sok^k^onk^
k_m;Bd_o1`L7oaPH6?nATI7o4A4Aoe5ADOo^k^koa<C4ob8R8_lL71co[Jf]onk^k_mUIFGoC4a<1_o^
k^h01ooPh>3o];BdomSHf?o[jn_omOGeooKfm_ohn?P00ooinOT2ooShn0;onOWi0_ohn?T2ooWin@;o
n?Sh0_oinOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;o
n?Sh0_oinOT2ooShn@;onOWi00Con?Shong]kOoRh^;onOWi0_ohn?T01?oinOWok>c/on_[joohn?P2
ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2
ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2
ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2
ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2
ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2
ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh00KonOWiogjegonWfoooY=SoojKJ
oonUf_l:ojCIo`08oj3FoonKdoooT<Wooh?1oomYZ_7o?XKFokBd]?oPh>3Nonk^kP001_ooool00olf
=SKoM7Adooooo`03ooooo`03ookno_ld=3CoDU9B00;ok^k^00KoEEEEocDe=Oono_kooooood10@?mo
Ogl3ooooo`06od10@?moOgoooooooooooomjNW[o@d=30_ooool02Ond];Co2@T9ooooooo6a/Ko10@4
omgMgOoVi^KoFe]Koa4A4@02ooooo`03og5aLOm1@D7oo_kn00;ooooo00?ofm_KomCDe?ooool01Ooo
ool02?o`l?3o`L71omGEeOoYjNWolo?cooCdm?ofm_KomOGe1?ofm_H01?m:BT[oKfm_ooGemOoemOD3
ooKfmP05obd];OmKFe_omOGeocdm?OmjNWX00_ofm_H00olm?CgoNWYjooGem@03ooGem@;om_Kf00?o
=3@dofm_KooemOD00ooemOD05Oofm_Ko?CdmogYjN_ofm_KomOGeocdm?OmjNW[omOGeooKfm_oNg]ko
AdM7o`820_lQ8B7o5QHFokVi^OoemOGo8b<So`l?3olN7QkoBTY:onc/k003ooGem@Com_Kf1?oemOD4
ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD4ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD4
ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD4ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD4
ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD4ooKfmP03ooGemOmn]MooX=Ko00KoX=Ko00?oSkoT
oa`U;On?_n@01OnPe_l01onKdoooT<Wooh?1oomYZ_7o?XKFol71`Oo`l?00g_ooool000Kok^k^00?o
<S8bofa/K?o^k^h00oo^k^h00oo9bLWo0000ojZZZP02onk^kP06ojZZZ_l0003ocLg=onk^k_lk>c_o
MWIf0oo^k^h01_lk>c_oMWIfonk^k_o^k^koLG5aochn?P;ok^k^00WoZ:RXo`P82?o^k^kob/[:o`82
0_n`/;3ok^k^oiBDU?lM7Ad00_o^k^h00om7AdOoJVYZonk^kP0:onk^kP07on3Ph?nd];Coe=CDonKV
i_o`l?3olo?coo7al@05ooCdm004ojb/[?lD51CokNg]oo?cl`;om?Cd00Ko`/;2o`000?nj^[[om?Cd
oc`l??miNGT2ooCdm004ocdm?OmiNGWom?CdooCdm0;olo?c0_odm?@01?lc<c?oKVi^ooCdm?odm?@2
oo?cl`03ooCdm?lm?CgoNGUi00;om?Cd017o?CdmogUiNOoclo?om?Cdod51@Olm?CgoeMGEooCdm?oX
j>Soi^KVoo?clong]kOol?3`oo?clolc<c?oRh^;ooCdm002oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c
1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c
1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c
1_odm?@2oo?cl`Kom?Cd0_oclo<5ooCdm003ogN_gonNdoooWM;o00GoW]?o00?o@EIYo`000?m1EVT0
1?nNdol02?nJcoooTlcoohS0oOmk^?WoHZG^ocMocond];Coh>3Pg_o^k^h000Koi^KV00?o<30`ofQX
J?oVi^H00ooVi^H00on[Zj_o0000olo?c`02onKViP06olg=cOl0003o[Zj^onKVi_li>CWoLW9b0ooV
i^H01_li>CWoLW9bonKVi_oVi^KoKVi^oc`l?0;oi^KV00WoXZ:Ro`P82?oVi^Koi^KVoibLW?l];Bgo
;Rh^oc0`<?lL71`00_oVi^H00om5ADGoIVIVonKViP0:onKViP07omSHf?n^[Zkoe=CDonKVi_o`l?3o
lo?coo7al@05ooCdm004oo7alOlJ6Q[oK6a/oi:BTP;oTi>C00KoADE5obHV9_odm?Com?Cdoc`l??mi
NGT2ooCdm004ocdm?OmiNGWom?CdooCdm0;olo?c0_odm?@01?lc<c?oKVi^ooCdm?odm?@2oo?cl`03
ooCdm?lm?CgoNGUi00;om?Cd00Ko?CdmogUiNOoclo?odm?Co`000?n`/;03ooCdm0;olo?c0_odm?@0
1?nl_;co5ADEohb<S?odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oc
lo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oc
lo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oc
lo<5ooCdm004offUgonGc?ooU/[ooiK:o`?oULWo013oN:;>oaXS;Ol0003o6R<]ogRRc_nEbOooU/[o
oi;7o_n>`o[oS<?noh:knOmb/OCoF9_Toc1ibOn^[Zkof=SHg_oVi^H000Kok^k^00Wo<S8boa`L7?lo
?coo?clooeaLG?o^k^kocLg=o`000?nXZ:P00_o^k^h01_nVYZKo0000om7AdOo^k^ko>c/kof9RHP?o
k^k^00[o>c/kofEUIOo^k^kok^k^og1`L?l_;bookNg]onk^k_nWYjOo20P81?o^k^h00oo/k>coRXZ:
oahN7P02onk^kP03odM7AomZJV[ok^k^00[ok^k^00Ooh>3PokBd]?oCdm?oi>CTonk^k_o_knool?3`
00KolO7a00OoN7Qho`h>3_mRHV;oHV9RoeMGEol0003oPh>300;olO7a00Ko?3`logQhN?oalO7olO7a
oc`l??mhN7P6oo7al@03oc<c<om]KFgolO7a00ColO7a00[o?3`logQhN?oalO7olO7aoc`l??mhN7So
lO7aok>c/ol0003o>CTi0olk>c/01oni^KWolO7aomOGeom5ADGo0P82ofYZJ_oXj>P0R?oalO402?mT
W=KoS/;iohk3n_n=`OSoS/;iohk3n_n>`_Wo8c0m0ol000003?lS;cgoS/?johk3n_n;_oKoR;geoh6i
m?mi/NkoJZOZoe2CfolYKl?o];Bdon3Ph=kok^k^0006ooooo`05ocHf=_mGEeOo`<30ol30`?o:b/X0
0_ooool01_m1@D7oB4Q8omkNg_oMgMgoAdM7odA4A0;ooooo00oo@410oa<C4onATI7oi>CToogmoOm0
@43o5ADEohb<S?oXj>So?clooalO7omPH63oh^;Rog5aLOlc<c<00_ooool03_nd];Cof][Jooclo?mQ
HF7oE5ADoooooooinOWoBDU9ofe]KOodm?Cono_kooooooo:b/[o`<301_ooool01_o`l?3o`L71om3@
d?oQhN7ojNWYonc/k0;ok^k^0_o`l?03ono_k`07om;Bd_l20P;oclo?oo3`l?nCTi?o10@4om_Kf`02
ono_k`06oc/k>omgMgOol?3`oo3`l?lk>c_oMgMg1?o_knl2oo3`l009oc8b<_lL71co?clooclo?omL
G5cokno_oo3`l?ll?3coMgMg00;okno_00ko>c/kogMgMoo_knooc/k>o`000?nPX:3o`/;2okZj^_l2
0P;oe]KFono_kolm?Cgo?Shnolg=c@Gokno_0_o`l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`
l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`
l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`
l?06ono_k`;ol?3`0oo_knl01?mKT/ooQ;WaohNkm?n7^o@2ohBil@03oeYnY?l0003o000000?o0000
00_oFWjTohJjlOn3^O7oOkG^ogVajom`Z^WoH9oSodJ:eOlPJ;go`L71oo3`l03Nooooo`001_o^k^h0
0olb<S;oK6a/onk^kP04onk^kP06omSHf?m<C4co3Ph>o`h>3_m>CTkofMWI0_o^k^h03om>CTkoOgmo
oeIFE_l820Soh>3Podi>C_n1PH7oJFUYo`h>3_lU9BGoa/K6ohn?SolH61So7AdMoj6QX@02onk^kP0>
oh20P?l^;Rko3Ph>ocDe=Onf][Kok^k^ogIfM_l71`Oo2`/;oaTI6OnRXZ;ok^k^ogAdM?mMGEd6onk^
kP07on3Ph?nd];CocLg=omcLg?oUiNGoinOWonWYj@03onc/k0;oj^[Z0_o/k>`01_m4A4CoKfm_onc/
k?lc<c?oC4a<on[ZjP;ok>c/00Ko>SXkogEeMOo/k>cok>c/ocXj>_mdM7@2onc/k0;ojn_/0_o/k>`0
5?la<C7oCdm?ok6a/Ona/K7o^[Zjon_[k?o/k>co>c/kogAdM?oZj^[ok>c/oc/k>omeMGGojn_/onc/
k?lj>S[oHV9Ron;Rh_nBTY;o9bLW0_o[jn`01_lb<S;oRXZ:on[Zj_oDe=CoinOWonc/k0;ojn_/0_o/
k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/
k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/
k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/
k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/
k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/
k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z00Cok>c/oe>:a_ml/NWoNjoW0_ml/NT00omgZ^3o4a/T
o`000004o`00000;oa<K9?mfZ>3oMjoYog>[i_m]YN?oHYkNoeFCf?lkO/co5UndokBd]?oPh>00g_o^
k^h000Koi^KV00?o<30`ofQXJ?oVi^H01_oVi^H2onGUi@Ooi^KV00?ohn?SonKVi_oVi^H00_oVi^H0
0ooUiNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV00?oi^KV00?oi>CTonKVi_oVi^H00_oVi^H0
0om5ADGoIVIVonKViP0:onKViP08omSHf?n^[Zkoa<C4omKFe_oPh>3oiNGUonKVi_oUiND6onOWi`05
oijNW_lE5AGo^[Zjo`000?nUYJD00ooWinL01_li>CWoLg=conOWiooWinOo>CTiog=cL`KoinOW00?o
<30`ofUYJOoWinL01?oWinL01_m<C4coOgmoonOWiooWinOo>CTiog=cL`;oinOW00cod=3@od10@?l;
2`_o6ATIojFUYOoWinOoi^KVojb/[?ld=3Co3Ph>oa4A4OoAdM5IonKViRooinOW00KoCX?0ogN/i?mg
Zn?oMj_SogFZh?lmF7D7o`00000:oceIM_mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko[Zj^omSH
f=koi^KV0006onk^kP03oc8b<_lZ:R[oGUiN00;oGUiN00?oZj^[onk^k_o^k^h07oo^k^h00ooAdM7o
clo?onk^kP0:onk^kP08on3Ph?ne]KGoa<C4omKFe_oPh>3oiNGUonKVi_oUiND6onOWi`05on?SholE
5AGo9BDUoaXJ6_oVi^H00ooWinL01_li>CWoLg=conOWiooWinOo>CTiog=cL`KoinOW00?o<30`ofUY
JOoWinL02?oWinL00oli>CWoLg=conOWi`03onOWi`04onCTi?oWinOoinOWonOWi`?oi^KV00?ohn?S
onKVi_oVi^H0FOoVi^H_onOWi`08odj3`?mg[>CoMj_SogN[homeZ^3oMZ[QogFZh?mfZ^44ogFZh00;
ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^okFe]OoPh>00g_o^k^h000Kooooo00?o
/;2`oiZJV_nJVYX00_nJVYX00ooAdM7oooooooooo`0/ooooo`08oo3`l?o2`/;oa<C4omKFe_oPh>3o
iNGUonKVi_oUiND7onOWi`03ofi^K_l0003oLW9b00CoinOW00Ko>CTiog=cLooWinOoinOWocTi>Omc
Lg<6onOWi`03oc0`<?lY:BWoFe]K00;oFe]K00CoYZJVonOWiomBDU;oQ8B40_oWinL00oli>CWoLg=c
onOWi`07onOWieooi^KV;ooWinL02?m>Pl3oMjcTogN[homgZn?oMJ[PogJZhOmeZ^3oMZ[Q1?meZ^00
2omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_o2`/;ol?3`0=kooooo000jonk^kP06
on3Ph?nf][Ko_;blom3@d?oOgmooi>CT0_oUiND7onKViP03om3@d?n:RX[odM7A00Coi^KV00Ko>CTi
og9bL_oVi^Koi^KVocTi>OmbLW86onKViP03oijNW_n:RX[oRXZ:00;oRXZ:00Co_;blonKVi_nRXZ;o
^;Rh0_oVi^H00oli>CWoLW9bonKViP2EonKViP04oenA`on2[n3oPJkOoh>ah0WoPZoO00[oP:oOogn]
g_mm[=koM:GJofjRf_mKU=3o9Vbmo`57YOnf][Koh>3Pg_o^k^h003[oi^KV00Kof][JokNg]onc/k?o
a/K6on3Ph?oWinL2onWYj@koj^[Z00Koi^KVonSXj?oZj^[oj^[ZonKVi_oXj>PAon[ZjP03onKVi_oX
j>Soj^[Z09Goj^[Z00GoRJgDoj;2iOnR`nKoX/;Uoj;3i@03oj;3iP0?oj;3iOnP`^GoX<;Uoj32iOnR
`^KoXl?Voio2i_nL`>CoV;cSoi:hgomgYMSo86Nio`0lW?ng]kOof][J0=koi^KV000jonk^kP07onCT
i?o7alOoXj>SokZj^_oLg=coinOWonWYj@2non[ZjP09oijlf_nccNWo//gYok?>jOnbcNWo/lkYokC?
j_ncc^Wo/lgY00?o//gY00_o/lkZok?=jOnbcNOo[l[Wojc8i_nUa>CoNjKHo`mDZolC>93oalO7onCT
i03Nonk^kP00>_ooool02?oinOWoi^KVojNWYon/[:coc/k>on?ShooVi^KoinOW_OoYjNT05onV`Mco
^M3ZokW@j_nid>[o^=3ZokW@j_njd^[o^]3Yok[Bj_nhd>[o^<oYokW@j_njd^[o^M3ZokS?jOndc^Oo
[l[Voibmh?mHS/Oo1T:OodeJVOoVi^KonOWi0=kooooo000jonk^kP08onc/k?oShn?o_knooj2PX?nb
/[;ob<S8omKFe_oKfm^momkNgP05oh^[d?nO`>3oWl3Poio0h?nN_n000onO`>000onN`>3oWl3Poijo
h002oijoh00:oijmh?nL_N3oU[WLoh2Ze_mCR/Ko85R[obHoT?nMW[Sohn?Sonc/k=kok^k^000jonKV
iP08onGUiOoShn?og=cLokjn__nVYZKoWYjNoj2PX?nTY:Bmoj>SX`So4UJX00oo4UJWoa9FZ?lBEZSo
4UJZoa9FZ?l@EJOo3U6Vo`e>Xol;AIko7DBGoe1QW_nLW[Sog=cLon?ShooUiND0g_oVi^H003_ok^k^
00GokNg]onc/k?oXj>Soi>CTon7Qh@3@on3Ph005on7QhOoTi>Coj>SXonc/k?o]kNd0goo^k^h003go
oooo0_ono_kBoogmo@;oo_knhOooool00?ook^k^mOo^k^h00?ooi^KVmOoVi^H00?ook^k^mOo^k^h0
0?oooooomOooool00?ook^k^mOo^k^h00?ooi^KVmOoVi^H00?ook^k^mOo^k^h00?oooooomOooool0
0?ook^k^mOo^k^h00?ooi^KVmOoVi^H003[ok^k^00?o];Bdolo?coo?cll0eoo?cll00oo5aLGo];Bd
onk^kP1nonk^kP;okNg]00[ojn_[onSXj?oUiNGoh^;RomgMgOoHf=Soe=CDom7AdOo>c/koc<c<0_o;
bl/kol[:bP;obl_;00[oc<c<olk>c_oAdM7oe=CDomSHf?oMgMgoh^;RonGUiOoXj>Sojn_[0_o]kNd8
onk^kP00>_ooool00oni^KWogMgMonc/k004onc/k<kok^k^1Oo/k>`00ooMgMgo^KViooooo`1moooo
o`;oo_kn00[ono_kooWinOoclo?okNg]onGUiOoLg=coe=CDolc<c?o7alOo`l?30_o0`<02okno_cWo
_[jn0_no_kl2ol30`00:ol?3`oo7alOoc<c<omCDe?oLg=coiNGUong]kOoclo?onOWioo_kn`;oo_kn
1oooool003[ok^k^00?o^KVion?ShooemOD01?ogmoO>oo[jnPGomoOg00?ohn?SokVi^Oo^k^h0OOo^
k^h03_o]kNgoj^[ZonOWiooRh^;ofMWIolk>c_o3`l?o^;Rhojj^[_nVYZKoX:2PoibLW?nIVIWoV9RH
?OnGUiL03OnHV9SoVIVIoibLW?nPX:3oYZJVojj^[_nh^;So`l?3olk>c_oIfMWoh^;RonOWiooZj^X0
0_o]kNd6onk^kP00>_oVi^H00oni^KWohn?SooGem@3Fooooo`03ooOgmooShn?o^KVi07koi^KV00go
hn?Son3Ph?oJf][odM7AolG5aOng]kOoZ:RXoibLW?n@T93oR8R8oh61POmnOWkoNg]k03ooNWYj00ko
Ng]koginO_n1PH7oR8R8oi2@T?nLW9coZ:RXokNg]oo5aLGodM7Aom[Jf_oPh>3ohn?SonGUi@Koi^KV
000jonk^kP03okVi^OoShn?omOGe0=Kooooo00?omoOgon?Shoni^KT0O_o^k^h05?oXj>Soh^;RomWI
fOo:b/[o^[ZjojRXZ?nHV9SoTY:BojFUYOo0`<3oemOGon_[joofm_KomoOgooWinOohn?SonOWioo[j
n_oinOWomoOg0oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@0AooShn?oinOWo
n?ShooOgmoo]kNgof=SHol71`OnUYJGoTY:BoiRHV?nXZ:So^[Zjol[:b_oIfMWoh^;RonSXj?o/k>`0
1_o^k^h003[ooooo00?o^KVion?ShooemOD0e_ooool00oogmoOohn?SokVi^@1nooooo`0<ooKfm_o]
kNgogMgMol[:b_nd];CoWinOojZZZ_o>c/kok^k^ooKfm_olo?coo_kn@Oooool03Oono_koo?clooOg
moo_knooclo?oj^[ZonOWioo];Bdol[:b_oMgMgokNg]ooKfm_okno/01_ooool003[ok^k^00?o^KVi
on?ShooemOD0e_ooool00oogmoOohn?SokVi^@1nonk^kP0:on;Rh_oFe]Ko`l?3ojj^[_nJVY[o[Jf]
omkNg_o[jn_om?Cdoo_knbcooooo00GoVYZJoe5BD_n3PhOodM7AooGem@0Dooooo`0;oo_knooclo?o
k>c/on7QhOn`/;3oVYZJojj^[_o3`l?oe]KFon;Rh_oXj>P01_o^k^h0017oi^KV00?oe=CDonCTi?oV
i^H00_oLg=`?onKViP03omcLg?oAdM7oi^KV01;oi^KV00?o^KVion?Shoojn_X0e_ooool00oojn_[o
hn?SokVi^@1nonKViP0:omKFe_o7alOo/[:boibLW?nWYjOoe=CDon3Ph?o/k>comOGeoogmoBcooooo
00WoLFm_okNb/?nDfOCoRKcUof5jVomRIg7oWj2QonKVi_olo?`04?ooool02oono_kom_Kfonc/k?oR
h^;ofMWIoj^[ZonLW9co/[:bolO7aooFe]KogMgM00Koi^KV0006onk^kP03oc8b<_nJVY[ok^k^00;o
k^k^00?o];Bdo`000?n@T9000_o^k^h02Om;Bd_o1`L7oaPH6?nATI7o4A4Aoe5ADOo^k^ko>c/kogIf
MP02onk^kP06og5aLOln?Skok^k^onk^k_nXZ:So20P80_o^k^h02OoGemOoADE5o`820_lP823o5ADE
okBd]?o^k^koIFEUoda<C00>onk^kP03okVi^OoShn?on_[j0=Kooooo00?on_[jon?Shoni^KT0O_o^
k^h02ooHf=Soa/K6ojj^[_nSXj?oa/K6omCDe?oPh>3ok>c/oo;bl_olo?coo_kn01Gooooo00?om?Cd
onSXj?ooool04oooool03?mlNggoW9ZHogNlmOnHfOoo[>koojWZoonLf?KoMJ77oeY/QomlOH;o^KVi
ooCdm0gooooo00_on_[jooCdm?oZj^[ohn?SomOGeoo=cLgoYZJVojj^[_o6a/Kof=SHon;RhP06onk^
kP001_ooool03olf=SKoYJFUoooooooooooom_KfobDU9Ol0003oVi^Kooooooo6a/Ko10@4omgMgOoV
i^KoFe]Koa4A4@02ooooo`06od10@?moOgoooooooooooomjNW[o@d=30_ooool03Ond];Co2@T9oooo
ooooooooA4A4od10@?oOgmoooooooo?cloobl_;oooooom_KfooDe=@03_ooool00oni^KWohn?Soo[j
nP3Fooooo`03oo[jn_oShn?o^KVi07kooooo00oohn?Solg=cOn`/;3o[jn_olK6a_oBd];og=cLonKV
i_o/k>comOGeooShn?ojn_[ooOgmooooooolo?`01Oooool02?lf=SKoYJFUooooooomoOgooooool71
`Ol10@7oVi^K0_ooool02_oWinOoBDU9o`<30olS8b?o5aLGol71`Oooooooi^KVo`000?n6QXH2oooo
o`03odU9BOlX:2Sooooo00;ooooo00?ooOgmooooooooool01?ooool03omoOh3oW9bIohW8l?nKdOoo
Vm?ooi?=oonHeOooW=oooiSLoonHfOkoPkGWof=mV_m]LGOoY:FVooOgm`02ooooo`0CoogmoOoooooo
oooooogmoOoooooooOgmoo_knoohn?Som?Cdong]kOoVi^KogmoOomKFe_o<c<co]KFeok6a/Oo=cLgo
hn?Soo?cl`06ooooo`001_o^k^h03olb<S;oVYZJonk^k_o^k^koKFe]oa4A4OlX:2SoT92@onk^k_o:
b/[o0P82ok2`/?o^k^koU9BDoadM7@02onk^kP06oc/k>omfMWKok^k^onk^k_maLG7o?Shn0_o^k^h0
1_nXZ:So20P8onk^k_o>c/ko0000oj^[ZaGok^k^00?o^KVion?Shoojn_X0e_ooool00oojn_[ohn?S
okVi^@1nonk^kP0]om7AdOnk^k_oXJ6QokJf]_o3`l?oclo?omKFe_oOgmooi^KVon[Zj_o_knoolo?c
ooCdm?oemOGomoOgooKfm_ogmoOom_KfooShn?ogmoOo=3@doinOWoofm_KomoOgonk^k_lS8b?o0000
oiJFU_ogmoOom_Kfod51@Olm?Cgof=SHooKfm_o/k>coj^[ZooOgmonHV9So3Ph>ocLg=oogmoOokno_
o`T92Ol>3PkocLg=00;om_Kf0_ogmoL05?ofm_Kon?ShooOgmoogmoOom_KfoginOonTXjGoV=3Vok?U
oongj_oo^>_oojSLoonEcOgoP[giogFam?mf^?coP/SooiCGo_n2^^koQYJU0_ofm_H2ooOgm`0AooKf
m_ogmoOom_KfooCdm?obl_;ol?3`on_[jooVi^KohN7Qom[Jf_oCdm?obLW9okno_onVYZKo^k^kom7A
dOoQhN401_o^k^h000Koi^KV00So<30`oiBDU?oVi^Ko][Jfo`820_nCTi?o>3Phoh^;R`;oi^KV00Go
W9bLobd];Ol^;Rko<30`oa`L7002onKViP06ocTi>OmbLW;oi^KVonKVi_m^KVko?3`l0_oVi^H01_nR
XZ;o20P8onKVi_n[Zj_o0000ocLg=`?o>3Ph00?o/;2`onKVi_oVi^H03ooVi^H00oni^KWohn?Soo[j
nP3Fooooo`03oo[jn_oShn?o^KVi07koi^KV00_obLW9ok:b/_nNWYko/k>col30`?o9bLWodm?ComWI
fOoMgMgoh^;RonGUi@02on[ZjP03onc/k?o]kNgokNg]00Cok^k^00co<S8boiZJV_o^k^kol?3`ofe]
KOlA4A7o:2PXoi2@T?o^k^koc/k>o`000?n][Jd5onk^kP08odm?Com[Jf_o6QXJomSHf?n`/;3o7QhN
ofIVI_mhN7P2onk^kP03oo3`l?o^k^kok^k^00Cok^k^00ooOGenojj//?nMb]Koao?ool?_ooo5l_oo
^N[oojoPoonLcokoR;ggogF[kOmZXNWoHIWVofj/m?m`XL800_o^k^h01?o`l?3ok^k^ong]kOo]kNd2
onc/k00=onWYjOoVi^Kohn?Son3Ph?oKfm_oeMGEolg=cOo5aLGo^k^kojFUYOnb/[;obLW9omSHf006
onKViP001_o^k^h02?lb<S;oVYZJonWYjOlY:BWoADE5onk^k_lj>S[oT92@1?o^k^h00oo/k>coRXZ:
oahN7P02onk^kP0Boc/k>omUIFGok^k^onk^k_m`L73o;bl_ong]kOo^k^koYjNWo`P82?o^k^koc<c<
o`000?nOWioo`L71okVi^Ol20P;oeMGE4Oo^k^h00oni^KWohn?Soo[jnP3Fooooo`03oo[jn_oShn?o
^KVi07kok^k^00god=3@okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoOgooQhN7o
h^;R00;ohn?S1OoUiND03?l`<33oU9BDonKVi_nf][Ko0P82oi:BT_lh>3SoRh^;onGUiOnZZZ[o0000
ocLg=`?o>3Ph00_o/;2`on7QhOl=3@goZZZZoeeMGOn:RX[oJVYZoe]KFon/[:co:2PXonGUi@02onKV
iPKoiNGU013oO7amokZh^?nV`lWodO[oomGhoooDoOooa_?ookORoonWeogoULGjoh6ckomk[NgoN:WZ
ofnUj_meX<7oiNGU0_oVi^H00ooUiNGoi>CTonCTi002on?Sh`0=on;Rh_oPh>3og=cLomWIfOoFe]Ko
d=3@olW9bOo1`L7o]KFeojFUYOnh^;Sod=3@on3Ph006onk^kP001_ooool02?lf=SKoYJFUoh20P?l>
3Pkohn?Soooooolo?cooVi^K0_ooool01Ond];Cof][Jooclo?mQHF7oE5AD00;ooooo00[o@410oaDE
5On<S8coj>SXoclo?olO7aooH61Pon;Rh_maLG7o<c<c0_ooool01Olo?cooJf][ooOgmonNWYko:b/[
00;ooooo00?ob/[:ol30`?ooool03Oooool00oni^KWohn?Soo[jnP3Fooooo`03oo[jn_oShn?o^KVi
07kooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K
00?og=cL0_oNg]h2omgMg@0Jobh^;_n?Shoof=SHobHV9_m0@43og]kNocHf=_n6QXKogMgMokjn__l0
003oU9BDokBd]?n][Jgo0P82olK6a_nYZJWo2PX:omOGeonMWIgo@D51obXZ:_nCTi?ofm_Koa<C4onm
_Kd2omgMg@;og]kN0ooMgMd04OoNg]koNW]lolk:aonV_<;oh?koomSkoooKo?ood_WoolC_oon`f_ko
W/Whohnll_n4/^goOZ[Xogj^jom^WLOog]kN00;ogMgM01;og]kNomgMgOoLg=cog=cLom_KfooJf][o
f=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oalO46ooooo`001_o^k^h0
1?lb<S;oL71`o`@41?n<S8`2onk^kP09ocXj>_n@T93ok^k^onk^k_n0P83o;Rh^o`h>3_le=CGo][Jf
00;ok^k^00[oCTi>oh61POmYJFWo3Ph>obDU9Oo6a/KoShn?oaPH6?lM7AgoXJ6Q0_o^k^h01OoFe]Ko
@T92o``<3?lJ6Q[oZZZZ00;ok^k^00?oM7AdoeeMGOo^k^h03Oo^k^h00oni^KWohn?Soo[jnP3Foooo
o`03oo[jn_oShn?o^KVi07kok^k^00goe=CDokno_on<S8coWYjNojf][Oni^KWo`/;2olO7aoo<c<co
d=3@om;Bd_oEeMGoe]KF00;oemOG00?of=SHomWIfOoIfMT00_oIfMT02?l];BgoS8b<ofa/K?l;2`_o
`L71omWIfOle=CGoPh>30_oIfMT04?le=CGoFe]Kom;Bd_n6QXKo92@TomWIfOmVIVKo@D51omWIfOoC
dm?o3`l?o`820_o9bLWofMWIoeIFE_mbLW88omWIf@0@ogYjO?oKem[oW[>gon_ooooToOoohogoom[k
ooo:lOoo^^7oojO>nonE__;oRkK]ohJ`j_n6[nWoKJ3@omOGe`?ofMWI0_oHf=P2omOGe`0=omGEeOoC
dm?od=3@olk>c_o:b/[oaLG5okno_one]KGoZJVYoiRHV?no_kooe=CDon;RhP06onk^kP001_oVi^H0
0ol`<33o10@4ocTi>@03onKViP03ocPh>?n;Rh_oi^KV00?oi^KV00?oi>CTonKVi_oVi^H01OoVi^H0
0ooUiNGoi^KVonKViP02onKViP03onGUiOoVi^Koi^KV00?oi^KV00?ohn?SonKVi_oVi^H04_oVi^H0
0oni^KWohn?Soo[jnP3Fooooo`03oo[jn_oShn?o^KVi07koi^KV00godM7Aokno_on8R8SoTi>Coj:R
X_n_[joo^[Zjol71`Oo7alOobl_;olk>c_o@d=3odM7A00;odm?C0ooDe=@2omGEe@04obd];OmTI6Co
10@4oginO@;oe=CD013o=3@doh61POoFe]KoeMGEol71`Olk>c_o2PX:oaLG5onHV9SoeMGEochn?_n3
Ph?oe]KFomGEe?m@D53o>CTi0_oEeMD01?nNWYko@410omKFe_oEeM@2omCDe0;oeMGE01Ooe]KFomGE
eOmiNG_oi^?RojJ`]Ooeooooh_koonWooooSo_ood?CookgOoOn/dOWoW/Cboi6fjon8[NKoSKGZofjS
eOoAdM7oe]KFomGEe?oDe=CoeMGEomCDe002om?Cd`0=om7AdOo@d=3ocLg=ol[:b_o3`l?o_[jnokJf
]_n[Zj_oWIfMoi6ATOno_koodM7Aom_Kf`06onKViP001_o^k^h00olb<S;o20P8olg=c@03onk^kP03
ocXj>_n@T93ok^k^02_ok^k^00?o^KVion?Shoojn_X0e_ooool00oojn_[ohn?SokVi^@1nonk^kP0B
omgMgOo=cLgoT92@ohV9ROnGUiOoYJFUok:b/_no_koobl_;om7AdOoEeMGoemOGomWIfOoJf][ofm_K
om[Jf_oKfm_og=cL0_oKfm/00ol^;Rko10@4ocHf=P02om_Kf`03omcLg?lf=SKoQHF500Cofm_K00?o
f=SHomcLg?oKfm/01_oKfm/00ooLg=cofm_Kom_Kf`05om_Kf`03omcLg?oKfm_ofm_K00;ofm_K013o
NWYkoo;blOnHW:;olo[koo[oooo_ooooh_koom;dooo0h_ko[m7ioj?6l_nG^ncoT;CXohndjOmfZM_o
d];B1OoKfm/03ooJf][ofMWIomSHf?oFe]Kodm?Colg=cOo2`/;o][Jfojb/[?nOWiooT92@oiJFU_o=
cLgogMgMonGUi@06onk^kP001_ooool00on`/;3o_[jnooooo`03ooooo`03okBd]?oHf=Sooooo02_o
oooo00?o^KVion?Shoojn_X0e_ooool00oojn_[ohn?SokVi^@1nooooo`0;oo;bl_oUiNGoZJVYogYj
N_n8R8SoUYJFojZZZ_o4a<CoeMGEom_KfooNg]h00_oPh>03on;RhP0<onCTi?oShn?ohn?Son?Shol`
<33o20P8ol?3`ooShn?oi>CTon?Sholh>3SoRHV91?oShn<00ooTi>Cohn?Son?Sh`05on?Sh`03onCT
i?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<00ooShn<04?mmOGkooOgmolG5a?nEVIko_/C9onO_
lOo/n?[ojOgoomOeoonheogoY/KboiZij?nC/nKoT[CVogZ/goo<cLh2on?Sh`0BonCTi?oShn?oh^;R
on;Rh_oQhN7oh>3PomoOgooLg=coemOGolG5aOn/[:coWYjNoi2@T?n2PX;o[Jf]onGUiOobl_;onOWi
1_ooool003[ok^k^00?o^KVion?Shoojn_X0e_ooool00oojn_[ohn?SokVi^@1nonk^kP0>onGUiOoM
gMgo`/;2og]kNomhN7SoQXJ6oinOWoo5aLGof=SHomgMgOoOgmoohN7Qon;Rh_oShn<3onCTi0?oiNGU
00WoWYjNojVYZOoTi>CoiNGUonCTi?oUiNGoXJ6Qol71`OoUiND00_oTi>@00ooUiNGoi>CTonGUi@03
onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU01?oi>CT
oh^;SOobl_;okno_omgKfOnk^[coYJNWoj:RYonT/;?oZKW2ok?KmOn`e_SoZm3koj?2lonG]NGoPJcQ
ok:g^ooTi>CoiNGU00Coi>CT00kohn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oQ8B4
ol?3`ooMgMgoiNGUon[ZjPKok^k^000jonKViP03okVi^OoShn?omOGe0=Kooooo00?omoOgon?Shoni
^KT0O_oVi^H02ooPh>3ofm_Kom;Bd_nKVi_oIFEUog=cLon=SHgo^k^komCDe?oJf][ogMgM00;ogmoO
00?oh>3Pon7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q
00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_nSXj?om_Kf00;om_Kf
00?okNg]ooKfm_ofm_H00_ofm_H2olC4a005ohJL]on3X<CoRJgPoiKCmOnMZ;001_oQhN403_oPh>3o
gmoOomgMgOoLg=coeMGEokVi^On>SXkoNg]kofi^K_nNWYkod];Bom_KfooPh>3oi>CT1_oVi^H003[o
k^k^00?o^KVion?ShooemOD0e_ooool00oogmoOohn?SokVi^@1nonk^kP0<on_[jooXj>Soh^;RomOG
eon=SHgoHV9RogIfM_nTY:CoalO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oL
g=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oL
g=`00ooLg=`02_mjNW[oXj>Sol_;c?ofm_Kojn_[ooShn?nDU9CoN7QhoiNGUooXi^03ooKfmP03ok^j
_?mKHfWo/K>f00;og=cL0_oKfm/04?oLg=cofm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGoW9bLogEeMOmW
IfOoT92@omOGeooRh^;oj>SXon_[joo]kNd6onk^kP00>_ooool00oni^KWohn?SooGem@3Fooooo`03
ooOgmooShn?o^KVi07kooooo00koo_knoo_knoohn?Sol_;bomkNg_nATI7oFUYJog]kNonSXj?o_;bl
olK6a_o;bl_ocLg=olo?c`;odM7A1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A
00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP04om7AdOoBd];oYZJV
ojNWY`;oU9BD00GoRXZ:okjn__oAdM7oclo?oi2@T002oi6AT@07of9SHooBd];od];Bom7AdOoBd];o
dM7Aom;BdP02om7Ad@0=om3@d?o?clooc<c<olS8b?nk^k_oW9bLog9bL_mKFe_oU9BDomkNg_obl_;o
n?Shoo_kn`02ooknoPKooooo000jonk^kP03okVi^OoShn?omOGe00Coooooc_ojn_X4ooooo`03ooOg
mooShn?o^KVi07kok^k^0_o]kNd03_oZj^[oj>SXon;Rh_oLg=coW9bLofe]KOmXJ6SoPh>3oiNGUonS
Xj?o[:b/ojn_[ona/K7o/[:b0_nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd
]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd017o]KFeokJf]?nd];Co/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9co
PX:2of9RH_m^KVkoWinOomcLg?oRh^;oj>SXon[ZjP02ong]k@Ook^k^000jonKViP03okVi^OoMgMgo
j^[Z00Coj^[Zc_o`l?05on[ZjP03omgMgOni^KWoi^KV07koi^KV0_oUiND03ooShn?oh>3PomgMgOoJ
f][oa<C4oiZJV_mjNW[oJFUYof=SHomYJFWoLW9bogAdM?miNGWoO7alog]kN`02ogemO@06ogalO?mk
Ng_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7al
og]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@05
ogalO?mkNg_oO7alogemO?mlO7`00_mjNWX02omgMgOoM7Adofe]KOm_KfooO7aloiZJV_o5aLGof][J
omgMgOoPh>3ohn?S00;oiNGU2?oVi^H003[ok^k^00?oVYZJokVi^Oo2`/801?o2`/;>ol?3``Go`/;2
00?o^KVioiZJV_o^k^h0Ooo^k^h2ong]k@04onc/k?oZj^[oj>SXonGUi@;oh^;R00?oh>3PomoOgooN
g]h0?ooMgMd00ooNg]kogmoOon3Ph002on;RhP04onGUiOoXj>Soj^[Zonc/k0;okNg]2Oo^k^h003[o
oooo00?oJFUYogMgMomkNg/01?mkNg_>ogalO0GoNg]k00?oMgMgofUYJOooool0POooool2ooknoP03
oogmoOokno_ono_k00;onOWi0_ohn?PoooOgm`;on?Sh0_oinOT2oo_kn`03oogmoOono_koo_kn00_o
oooo003oonk^k_Gok^k^003oonKVi_Goi^KV003oonk^k_Gok^k^003oooooooGooooo003oonk^k_Go
k^k^003oonKVi_Goi^KV003oonk^k_Gok^k^0003ooooooooOZgIl?mn[MT2ooooo`000oo^k^h00omn
[MWok^k^onk^kP3oonk^k^cok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Koi^KV0?oo
i^KVk?oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool0oooooooJooooo`0?ojn_
[onZZZ[o_;blok>c/on^[Zko[jn_okNg]onm_Kgo`/;2olS8b?o>c/kodm?ComKFe_oCdm?ob/[:00?o
k^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo013ooooo00?o`/;2od10@?lN7Qh0
2?lU9BD00olN7Qko@410okbl_03oooooof_ooooo00?oLG5aon?Shoooool04oooool00omaLG7ohn?S
ooooo`0hooooo`0?ok>c/oo>c/kokno_oo7alOo[jn_ogmoOomGEeOoGemOogMgMonCTi?oZj^[ol?3`
oo?cloo`l?3oiNGU00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo013ooooo
00?oa<C4oginO_mmOGd01OmmOGd3ogalO0;oNg]k00?o[jn_ooooooooool00oooool4o`000003oaPH
6?l51@Go000000;o000000Co3`l?o`<30ol61PKo4Q8B1?l000000onn_[koFUYJo`000006o`000003
oa<C4ol30`?o000000Co000000?o51@Do`T92Ol000001ol0003oooooocGooooo00?og]kNonSXj?oo
ool00oooool00on0P83oUiNGooooo`0;ooooo`03ookno_oQhN7ogMgM00Gooooo00?oP820oiNGUooo
ool01Oooool00ooMgMgolo?cooooo`0`ooooo`0?okJf]_o@d=3olO7aooOgmoohn?SomoOgonSXj?oL
g=coh^;RonKVi_o^k^kom?CdooOgmoodm?Coj>SX00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03
ogj]fOoVi^Kooooo013ooooo00?oa/K6ogemOOmnOWh00_mnOWh3ogemO@?oO7al00?oNg]kogYiNOna
/K401Oooool2o`000005oclo?ooShn?of][JooGemOn6QXH00_l000001_oHf=SoXj>Son?Shoo/k>co
/k>co`X:2P;o000000coZJVYoginO_l0003o0000om?CdonNWYko0000oa0@4?oShn?oeMGEomCDe?me
MGD2o`000005obl_;ooCdm?oj^[Zom;Bd_nc/k<00_l000000ooHf=SoCTi>o`000002o`000?oooooo
<oooool01_oXj>So<c<cob@T9?lM7AgoGEeMooclo0;ooooo00?ocLg=odY:B_ooool00oooool5o`00
0008omOGeoooooooooooofEUIOlc<c?oATI6obPX:?o;bl/3ooooo`03olg=cOm:BT[ooooo00?ooooo
00Gokno_ocXj>_m0@43o8b<Sohf=S@03ooooo`Go000000?oemOGooooooooool09Oooool03ong]kOo
d=3@oo7alOogmoOonOWioo[jn_oemOGogMgMonCTi?oZj^[olO7aooShn?ojn_[om_Kfon_[j`03onKV
iP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`0@ooooo`04olK6a_mlO7coOGemogem
O@?oO7al0omkNg/2ogYjNP03ogQhN?na/K7ooooo00Cooooo00oo0000o``<3?oXj>SoKVi^o`000?lM
7Agojn_[oeADE?l0003of=SHohf=SOl:2P[o3`l?ol_;bomJFUX00_l000004onYZJWoOWino`000?l0
003oGUiNodI6A_l0003o1@D5oahN7_l0003o5aLGooOgmolC4a?o20P8omgMgOn3Ph?o10@4o`000?l8
20P00_l000000ooHf=SoCTi>o`000002o`000?oooooo<oooool01_mMGEgoH61Pooclo?okno_o=3@d
oiRHV0;ooooo00?oo_knob8R8_oemOD00oooool00om<C4coH61Pooclo002ooclo0Kooooo00?oa/K6
o`l?3oo_knl00_ooool00oono_ko8R8RooGem@03ooooo`06ofEUIOmdM7Coooooono_kolJ6Q[oc<c<
0_ooool00om<C4coH61Pooclo002ooclo2Sooooo00Go^[Zjom7AdOobl_;on?ShooWin@02oo[jnP08
omoOgooVi^Kojn_[oo;bl_oinOWoo?clooShn?o]kNd3onk^kP7oOZgI0Oo^k^h1onk^kP000oooool0
0omn[MWoooooooooo`0@ooooo`04olK6a_mkNg_oNg]kog]lO0?oNg]k0_mjNWX2ogUiN@03ogQhN?mg
MgOo/K6a00Gooooo00Co0000oclo?oomoOgo4A4A0_l000001On/[:coWYjNo`000?oHf=SoCTi>00;o
000000KoP820ojFUYOl0003o0000ojVYZOmnOWh7o`000007oa/K6onMWIgoj>SXo`@41?lk>c_om_Kf
oa0@4005o`000003omSHf?m>CTko000000;o0000oooooolbooooo`03oo[jn_l51@Go^k^k00;ooooo
00?oO7aloeMGEoooool00_ooool00omVIVKo/;2`ooooo`02ooooo`03onCTi?lS8b?o]KFe00Wooooo
00?o9BDUohR8R?ooool00_ooool01omVIVKo/;2`oooooooooooon?Sho`X:2_oBd]800_ooool2ofUY
J@;ooooo00?oi>CTob<S8one]KD0:_ooool03onj^[[odM7Aoo;bl_ogmoOonOWioo[jn_okno_o[:b/
onOWioo]kNgom?Cdoo[jn_omoOgonOWiono_k`03ooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn
[MWok^k^ooooo`0@ooooo`05olK6a_mgMgOoNWYjog]kNomkNgX00_mjNWX2ogUiN@;oN7Qh00?oMgMg
ogEeMOna/K401Oooool01?l0003oC4a<ooCdm?l30`<2o`000005oiJFU_n[Zj_o0000omSHf?m>CTh0
0_l000001_mUIFGodm?Co`000?l0003oZJVYoginOPKo000000OoHF5Qoo?clon/[:co7AdMo`000?ln
?Skoo?cl00;og]kN00KojNWYol[:b_l0003o0000omSHf?m>CTh3o`000?oooooo<_ooool00ooOgmoo
0000ok6a/@02ooooo`03oe1@D?n1PH7ooooo00;ooooo00?o/k>cof=SHoooool00oooool00ooKfm_o
9BDUok>c/`04ooooo`06onOWiom?Cdoo8B4QoeEEEOmADE7oEEEE0oooool01onc/k?oHf=Soooooooo
oooofm_Ko`000?oclo<00_ooool00on;Rh_o@d=3ooooo`02ooooo`03om_KfolU9BGo/k>c02Wooooo
00oo^[Zjom7AdOobl_;on?ShooWinOojn_[oeMGEod=3@oo1`L7ok>c/ooKfm_okno_oo_knoo[jn_o_
knl00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool04?ooool00oo6a/KoMgMg
ogUiN@03ogUiN@;oN7Qh0_mgMgL01?mfMWKoMGEeog5aLOna/K45ooooo`04o`000?lO7aoooOgmoc@d
=0;o000000Godm?Cog]kNol0003of=SHogemO@02o`000006oiZJV_nDU9Co0000o`000?nYZJWoOWin
1Ol000000ol10@7okNg]od];B`03o`000006o`<30ooWinOo6QXJo`000?mhN7SoRHV90_l000000ooH
f=SoUIFEo`000002o`000?oooooo<_ooool01ooHf=So0000od=3@onCTi?oMGEeoa8B4_oOgml00ooo
ool00oofm_Ko8B4QooknoP04ooooo`03on3Ph?lM7Ago^KVi00?ooooo00KoJf][oeeMGOobl_;oe=CD
oaLG5oli>CT3ooooo`07ooKfm_lQ8B7oo_knooooooo:b/[o0000ooclo002ooooo`03oiJFU_lb<S;o
oooo00?ooooo00?oh>3PoadM7Oni^KT0:?ooool03onj^[[od=3@oo;bl_ohn?SonOWioo[jn_maLG7o
@d=3ofEUIOoYjNWomOGeoo_knoomoOgon_[jono_k`03onKViP7oOZgI0OoVi^H1onKViP000oo^k^h0
0omn[MWok^k^ooooo`0@ooooo`03olK6a_mhN7SoN7Qh00;oN7Qh0_mgMgL2ogIfMP05ogEeMOmdM7Co
L71`ofQXJ?na/K401Oooool2o`00000=ohR8R?oQhN7oOGemokZj^_oGemOo3Ph>o`000?oHf=So/K6a
okFe]On/[:con_[joclo?`02o`000003ojVYZOmnOWko000000Go000000Co/K6aoijNW_m^KVkoJf][
0_l000001On3Ph?o`l?3ogUiNOoRh^;o>c/k00;o000000Gof=SHokFe]Onh^;SoGUiNo`00003ooooo
oc;ooooo00?omOGeo`000?o;bl/00_nEUID00oo`l?3oooooooooo`03ooooo`03ode=COo:b/[ooooo
00Cooooo00Oo[Jf]oa@D5?omoOgooooooo[jn_l@413oalO700;ooooo00?oJf][odY:B_ooool00ooo
ool01_m=CDgob/[:oooooooTi>Co0000ong]k@;ooooo00?oQhN7oda<C?ooool01?ooool00on][Jgo
51@Doogmo@0Wooooo`0?okbl_?oBd];ol_;booShn?oinOWo]kNgod];Bom3@d?oADE5oj^[Zoodm?Co
no_kookno_ojn_[okno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo013o
oooo00?oa/K6ogMgMomgMgL00_mgMgL2ogIfMP;oMGEe00GoM7Adog5aLOmZJV[oHV9RokJf]P05oooo
o`?o000000Co?Shnog=cLomKFe_o2PX:0_l000001OoHf=SoCTi>oc`l??mbLW;o=SHf00?o000000?o
?Cdmobh^;_l000001Ol000001?l:2P[oCdm?ogEeMOm3@d<3o`000003odU9BOmeMGGo=cLg00?o0000
00GoCTi>oa`L7?m2@T;oDE5Ao`00003ooooooc?ooooo00?o<c<coj2PX?ooool01oooool00onJVY[o
OGemooooo`04ooooo`07on?Shol0003ohn?SooooooomoOgo2@T9ol[:bP02ooooo`03od10@?mfMWKo
oooo00?ooooo00KoVYZJogemOOoooooooOgmoahN7_nk^k/2ooooo`03oeIFE_n3Ph?ooooo00Cooooo
00?ohn?So`000?oShn<09oooool03onk^k_odM7Aoo;bl_ohn?Sokno_oeiNG_m:BT[o@d=3odE5AOmC
De?oj>SXooclo?ono_kon_[jono_k`03ooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^
ooooo`0@ooooo`03olK6a_meMGGoMWIf00;oMGEe0_mdM7@01omcLg?oLW9bofm_KomYJFWoHf=SoeMG
Eonk^k/01Oooool9o`000003omSHf?m>CTko000000Go000000?oDE5Aocdm?Ol000005ol0003ooooo
oc?ooooo00Ko/k>cob<S8oo@d=3om?Cdokfm_OoRh^84ooooo`09onGUiOla<C7ooooooooooonATI7o
_knoonc/k?mbLW;o>SXj00?ooooo00KoJFUYoeEEEOoTi>CoWIfMo`h>3_oOgml4ooooo`0:onGUiOla
<C7ooooooooooonCTi?o?cloon_[jonm_Kgo6ATIonWYj@;ooooo00GoTI6Aokno_oo/k>coLW9bocXj
>P0Xooooo`0?ok^k^ooBd];ol_;booShn?nPX:3oBd];odY:B_m3@d?oADE5odM7AonATI7ono_kookn
o_ojn_[okno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo013ooooo00?o
a/K6og=cLomcLg<00_mcLg<2og9bLP07og5aLOm]KFgoHf=SoeQHF?mGEeOoBTY:ol71`@05ooooo`Wo
000000?of=SHodi>C_l000001Ol000000ombLW;oEEEEo`00000Go`000?oooooo=?ooool01One]KGo
B4Q8obPX:?m=CDgoeMGE00Gooooo00SoKfm_ooGemOooooooYjNWoeUIFOl_;booLW9bomSHf0?ooooo
00Gon?ShogMgMol];BgoATI6olK6aP06ooooo`08ofm_KooemOGooooooooooon=SHgo<S8bodY:B_o?
cll3ooooo`05ojNWYomIFEWo;bl_og9bL_oHf=P0:?ooool03onk^k_od];Boo?cloohn?SonOWioo[j
n_ofm_KohN7QonSXj?o]kNgom?Cdooclo?ono_kon_[jono_k`03onKViP7oOZgI0OoVi^H1onKViP00
0oo^k^h00omn[MWok^k^ooooo`0@ooooo`03olK6a_maLG7oLG5a00;oLG5a0_m`L7001om[Jf_oD51@
odA4A?ln?SkoBTY:oe5ADOoHf=P01Oooool9o`000003ocHf=_lC4a?o000001oo0000oooooon<oooo
o`0?ok^k^ooBd];olo?cooShn?oinOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?clookno_ojn_[o
kno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo013ooooo00?oa/K6ofm_
Kom`L7000om_Kfl00om/K6coIVIVodA4A002ogemO@03ofm_Kom`L73ojn_[00Gooooo:ol0003ooooo
ohcooooo00oo^k^kom;Bd_oclo?on?ShooWinOojn_[om_Kfon7QhOoXj>SokNg]ooCdm?olo?coo_kn
oo[jn_o_knl00oooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_ooool04?ooool00oo6
a/KoKFe]ofi^KP02ofi^KP08ofa/K?mWIfOoGemOoe9BD_mmOGgoKfm_ofMWIooPh>06ooooob_o0000
oooooon<ooooo`0?ok^k^ooBd];olo?cooShn?oinOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?cl
ookno_ojn_[okno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo013ooooo
00co`l?3ofa/K?m]KFgoKFe]of][JomVIVKoH61Poe=CDomPH63oKfm_ofMWIooQhN47ooooob_o0000
oooooon<ooooo`0?ok^k^ooBd];olo?cooShn?oinOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?cl
ookno_ojn_[okno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo013ooooo
00_of][JofIVI_mSHf?oHV9Rof1PH?mHF5SoDU9BoeQHF?mKFe_oHf=SonOWi`3ooooookoooooo00go
YJFUok2`/?no_koo]kNgok:b/_n_[joo[Jf]oijNW_nTY:CoZZZZokFe]Oo4a<Coclo?00;ofm_K0oo^
k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool0oooooooJooooo`0?ok^k^ooBd];o
lo?cooShn?oinOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?clookno_ojn_[okno_00?ooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooof_ooool03onk^k_od];Boo?clooh
n?SonOWioo[jn_ofm_KohN7QonSXj?o]kNgom?Cdooclo?ono_kon_[jono_k`03onk^kP7oOZgI0Oo^
k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`0@ooooo`05oj:RX_mbMgooYjR[omcLg?omoOd00ooo
ool01?omoOgono_kooclo?ono_koooooofgooooo00?oLG5aon?Shoooool04oooool00omaLG7ohn?S
ooooo`0hooooo`0?ok^k^ooBd];olo?cooShn?oinOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?cl
ookno_ojn_[okno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo013ooooo
00SoPWmmoj[;i?n2_oSoN:7?off0VOn3R93o][Nhon[ZjPCooooo00?oo?cloo_knoono_h04Oooool0
0ooemOGonOWiooooo`04ooooo`03onc/k?olo?cooooo00Oooooo00?oj>SXoo[jn_ooool0oooooolm
ooooo`03ookno_oQhN7ogMgM00Gooooo00?oP820oiNGUoooool03Oooool00ooMgMgolo?cooooo`03
ooooo`03oh20P?nGUiOooooo00Gooooo00?ogMgMoo?cloooool0<?ooool03onk^k_od];Boo?clooh
n?SonOWioo[jn_ofm_KohN7QonSXj?o]kNgom?Cdooclo?ono_kon_[jono_k`03onk^kP7oOZgI0Oo^
k^h1onk^kP000oooool00omn[MWoooooooooo`0@ooooo`0<ohV7Q_nQ`]SoP;kfoi??o_nMfoooV]Ko
ohZom?mcV<CoLX6FohnBV?o4aLGolo?c2Oooool01OlN7Qkodm?Cooooooo1`L7o[Zj^00;ooooo00ko
4a<ColO7aoooooooXZ:Roa0@4?lH61SoTY:Bob8R8_nf][Kokno_oa`L7?lZ:R[o:b/[ohZ:RP;ooooo
00So9bLWok6a/Oooooooc<c<ob@T9?l?3`oo6a/Koh:2P_oooooo?Oooool01OmUIFGo<c<codI6A_lX
:2Sobl_;00?ooooo00?ocLg=odY:B_ooool00oooool01_oDe=Co8B4Qoa8B4_l:2P[o8B4QoinOW`;o
oooo00Gokno_ocXj>_m0@43o8b<Sohf=S@03ooooo`03olg=cOm:BT[ooooo00?ooooo00Gokno_ocXj
>_m0@43o8b<Sohf=S@03ooooo`Go000000?oemOGooooooooool09Oooool03onk^k_od];Boo?clooh
n?SonOWioo[jn_ofm_KohN7QonSXj?o]kNgom?Cdooclo?ono_kon_[jono_k`03ooooo`7oOZgI0Ooo
ool1ooooo`000oo^k^h00omn[MWok^k^ooooo`0@ooooo`0?ohV8Qon_b]WoTlcjoic@nonNdoWoV]3g
oiKBoOn;aOCoNjoQohW5oomm[ncoKH^bogAoS_nMWj;olO7a00Kooooo01oo7QhNom?Cdooooooo:BTY
o`T92OoalO7ooooooa<C4oo7alOooooooc4a<OnIVIWon?Shog1`L?l410Co][Jfoo[jn_oQhN7ooooo
onSXj?l820Sok>c/oooooolW9bOo/K6aooOgmolP823oHF5Qoo;bl_ono_kok^k^0?oooooo@?ooool0
0oo6a/Ko3`l?ono_k`02ooooo`03ookno_lR8R;omOGe00Gooooo00?oRXZ:ode=COooool00oooool0
1_mUIFGoM7Adooooooo_knoo6QXJolc<c0;ooooo00?oo_knob8R8_oemOD00oooool01_mUIFGoM7Ad
ooooooo_knoo6QXJolc<c0;ooooo00?oC4a<of1PH?olo?`00_olo?`Xooooo`0?ok^k^ooBd];ol_;b
ooShn?nPX:3oBd];odY:B_m3@d?oADE5odM7AonATI7ono_kookno_ojn_[okno_00?ok^k^0Omn[MT1
onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo013ooooo00ooRXV7okO>f_nVfO[o/n;nokOYoond
iOgo/NSoog^Q__lg?DGoKj3FogBam_mf]?[oOKSlogfnoonTZ[001_ooool04?lN7Qkodm?Colk>c_l7
1`OoGEeMoi^KVooooooo4a<ColO7aooooooo5ADEol;2`_ooooooo_knoa`L7?nf][H2ooooo`0:onCT
i?mRHV;o5aLGoo_knooooooo9bLWok6a/Oo3`l?o0000omGEeOooooooA?ooool00olU9BGoR8R8oooo
o`02ooooo`03ofIVI_n`/;3ooooo00Cooooo00?oRXZ:ode=COooool00_ooool00oohn?So2PX:om;B
dP02ooooo`;oJFUY0oooool01omVIVKo/;2`oooooooooooon?Sho`X:2_oBd]800_ooool2ofUYJ@;o
oooo00?oi>CTob<S8one]KD0:_ooool03onk^k_odM7Aoo;bl_ohn?Sokno_oeiNG_m:BT[o@d=3odE5
AOmCDe?oj>SXooclo?ono_kon_[jono_k`03onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWo
k^k^ooooo`0@ooooo`0?ohZ:ROnod=So]>;hol;/ooo4l?gob?Oooj?;gOm5CE;oD5eWofZ=/omo]o[o
K:;SofJJgOm^[?3oVjJ`00Kooooo00co7QhNom?CdomcLg?oDe=Col_;bolm?Cgooooooa<C4oo7alOo
oooooaDE5Oo3`l<2ooooo`07ob8R8_nf][KooooooijNW_l<30coDe=Con;RhP02ooooo`05obLW9ona
/K7o/k>co`820_o_knl0oooooom0ooooo`06onOWiom?Cdoo8B4QoeEEEOmADE7oEEEE0oooool00onc
/k?oHf=Sooooo`04ooooo`03ohZ:R_m=CDgooooo00;ooooo00?ofm_Ko`000?oclo<00_ooool00on;
Rh_o@d=3ooooo`02ooooo`07ok>c/omSHf?ooooooooooooKfm_o0000oo?cl`02ooooo`03oh^;Rom3
@d?ooooo00;ooooo00?ofm_KobDU9Onc/k<0:Oooool03onl_;cod];Boo;bl_ohn?SonOWiokNg]om;
Bd_o@d=3odE5AOn[Zj_om?Cdoo_knoono_kon_[jono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000ooo
ool00omn[MWoooooooooo`0@ooooo`0?ohb:R_o5d]Ko_^WeolofoooAmocog_ooohVPYOm3BDooNiRa
oe9RMOn3/^[oOJo]ogJUiOmh/O?oVJB^00Kooooo00co7QhNom3@d?lI6AWo[Zj^oooooolZ:R[ogMgM
oa<C4oo7alOooooooaDE5Oo3`l<2ooooo`05ob8R8_nf][Koo_knoa8B4_nd];@01?ooool01OlW9bOo
/K6aomoOgol20P;oYJFU0?oooooo@?ooool01_m[Jf_oGEeMoo;bl_oDe=Co5aLGocTi>@?ooooo00?o
m_Kfob4Q8Oono_h01?ooool00on:RX[oCDe=ooooo`02ooooo`03ol[:b_l0003oo?cl00;ooooo00?o
UYJFoc8b<_ooool00_ooool01oofm_Ko8B4Qookno_oooooob/[:o`000?olo?`00_ooool00onFUYKo
<S8booooo`03ooooo`03on3Ph?lM7Ago^KVi02Sooooo00oo^[Zjom3@d?obl_;on?ShooWinOojn_[o
LG5aod=3@omUIFGojNWYooGemOokno_ooOgmoo[jn_o_knl00oooool1ogj]f@7ooooo0Oooool000?o
k^k^00?oOZgIonk^k_ooool04?ooool03on<S8cob];EolG[lOoJo?oofo[mon7ooonee=_o@4A8ocXm
?olc=3CoPZOEohRgl_mnZNGoOk?^oiFS[`06ooooo`0<oahN7_n?Shoo4A4AooWinOooooooQhN7oh20
P?lC4a?oalO7oooooolE5AGo`l?30_ooool01olR8R;o][Jfoooooom>CTkoHF5Qoi6ATOnDU9@00_oo
ool02?lW9bOo/K6aoooooomhN7So2PX:ofa/K?n3Ph?o/;2`oooooollooooo`03oo[jn_l@413oalO7
00;ooooo00?oJf][odY:B_ooool00oooool00om=CDgob/[:ooooo`03ooooo`03ohZ:R_m=CDgooooo
00;ooooo00?oi>CTo`000?o]kNd00_ooool00on7QhOoC4a<ooooo`03ooooo`06ode=COo:b/[ooooo
onCTi?l0003okNg]0_ooool00on7QhOoC4a<ooooo`04ooooo`03ojf][OlD51CooOgm02Oooooo00oo
^[Zjom7AdOobl_;on?ShooWinOojn_[oeMGEod=3@oo1`L7ok>c/ooKfm_okno_oo_knoo[jn_o_knl0
0oo^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool04?ooool03on>SHgocm?EolWV
jOoSooooi?goon7koOoSooooO8fAodU?Eom_PYOoUKg^ohbek?n5[NKoQ[;Zoi:Q/006ooooo`03oahN
7_ld=3CoIFEU00;ooooo00Oohn?Sob@T9?lB4Q;oalO7oooooonZZZ[ojNWY00;ooooo00Oo[jn_onGU
iOoooooomOGeok2`/?n:RX[o_;bl00;ooooo00So/K6aon?ShoooooooooooolG5aOn=SHgoTi>ComGE
eOoooooo??ooool00oomoOgo2@T9ol[:bP02ooooo`03od10@?mfMWKooooo00?ooooo00?oVYZJogem
OOooool00oooool00on:RX[oCDe=ooooo`02ooooo`03oogmoOlN7Qko^k^k00;ooooo00?oEUIFoh>3
Poooool00oooool01_nJVY[oOGemooooooomoOgo7QhNok^k^`;ooooo00?oEUIFoh>3Poooool01?oo
ool00ooShn?o0000on?Sh`0Wooooo`0?okZj^_oAdM7ol_;booOgmooinOWon_[joo_knon/[:coinOW
ong]kOodm?Con_[joogmoOoinOWokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^
k^kooooo013ooooo00ooSXj>omKGfOoAhN?ok_ooonSmo_oTn_coh_oook3;d_mRKg[o[M7foj36m?nA
]n[oS;7VohVbi?n@XK801_ooool00olN7Qko0000ol71`@03ooooo`03odA4A?l0003oalO700kooooo
00?oUiNGomWIfOooool0oooooom2ooooo`06ofUYJOmEEEGoi>CToifMWOl>3PkogmoO1?ooool02?oU
iNGo<C4aoooooooooooogMgMog=cLomHF5SoCDe=1?ooool01_nCTi?o?cloon_[jonm_Kgo6ATIonWY
j@Cooooo00[oiNGUoc4a<Ooooooooooooi>CTolo?coojn_[okfm_OlI6AWojNWY0_ooool01OnATI7o
_knoonc/k?mbLW;o>SXj02Sooooo00oo^k^komCDe?oclo?on?ShooWinOojn_[om?Cdon7QhOoWinOo
kNg]ooGemOokno_oo_knoo[jn_o_knl00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIoooo
ooooool04?ooool03on>SXkohn?Tok[1aOo]n_coloknoo?noOo]oooo`MgVodM<DOnH/]3oZ<[goiJh
j?nB]>KoS;3PohnR]P06ooooo`03ofQXJ?mOGeoooooo00?ooooo00?o][Jfoe=CDooIfMT03_ooool0
0om^KVkob/[:ooooo`3ooooood;ooooo00Gon?ShogMgMol];BgoATI6olK6aP06ooooo`07ofm_Kooe
mOGoooooooKfm_nXZ:SoJFUYog1`L005ooooo`04ohf=SOlb<S;oBTY:olo?c`Kooooo00SoKfm_ooGe
mOooooooooooohf=SOlb<S;oBTY:olo?c`?ooooo00GoYjNWoeUIFOl_;booLW9bomSHf00Xooooo`0?
ok^k^ooCdm?ol_;booShn?oinOWon?Shon_[jooQhN7oj>SXono_koofm_Kono_koogmoOojn_[okno_
00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo013ooooo00ooSXj>ooclo?nk
_;co^kk1oko5b?o8d=CobmcPolWVk?nYa=Co^=Skojg>n?nO_ngoV;OWohn^fOn@XkP0oooooonkoooo
o`0?ok^k^ooBd];ol_;booOgmoofm_Koj^[ZomcLg?oQhN7oj>SXonk^k_oemOGono_kookno_ojn_[o
kno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo013ooooo00ooc/k>omgM
gOo`l>ooe]KEolg=cOo2`/?obL[;ol_?d_nnbm?oY[S:oiVddOnD]=_oUkOWoi>cgonCZL40oooooonk
ooooo`0?okZj^_oAdM7ol_;boo;bl_oNg]kodm?ComWIfOoQhN7oinOWong]kOoemOGono_kookno_oj
n_[okno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo00oooooo013oo_kn
oooooon=SHgok>c/oo7alOofm_Kono_koj:RX_nIV9SocL_9omoMfooIf=So`/O;ojfga?n;WK3oSIZY
oooooonkooooo`0?okbl_?oCdm?ok^k^om;Bd_nYZJWoVi^Koi:BT_n9RHWoTi>CojFUYOo4a<Colo?c
ookno_ojn_[okno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo013ooooo
00ooo_knoo_knooHf=SoZj^[oi2@T?nQXJ7oeMGEoooooooPh>3o];Bdoi>CTonEU9Co^kZhoinNW?ok
no/0oooooonkooooo`06okZj^_oAdM7oaLG5oiZJV_nFUYKoXJ6Q0onXZ:P01_nQXJ7oUiNGojf][OoR
h^;on_[jono_k`?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo013ooooo00?o
o_knoogmoOooool00oooool02?ojn_[oo?clooooooooooooo_knoooooooEeMGob<S9oooooonloooo
o`0?ok^k^ono_kooX:2PojFUYOn_[joo^[Zjokjn__o3`l?o`/;2okbl_?nf][Ko[Zj^ok6a/OoTi>Co
kno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooof_ooool03onm
_KgoYZJVoj^[Zong]kOo`L71olG5aOo:b/[oc/k>om7AdOo@d=3oclo?olS8b?nl_;coa<C4ong]k@03
onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`3oooooom[ooooo00oo^KViojn_
[onf][Ko_[jnolO7aoo<c<codM7AomKFe_oHf=Sofm_KomWIfOoHf=Sod];Bol?3`ooNg]h00oo^k^h1
ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool04?ooool01OnRXZ;oLWMoojNXZooLg=co
oOgm00?ooooo00CooOgmoo_knoolo?coo_knoooooom]ooooo`03og5aLOoShn?ooooo01?ooooo00?o
LG5aon?Shoooool0>?ooool03One]KGo][Jfokfm_Oo2`/;obLW9om3@d?oFe]Kof][JomoOgooShn?o
h^;Ron?ShooNg]h00_oHf=P3ooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^ooooo`0@
ooooo`08oh9oOOnZbnCoP[ohogNPc_m]PI_oQHZDokNg^?oZj^X4ooooo`03ooclo?okno_oo_kn01;o
oooo00?oinOWoo[jn_ooool03Oooool00oo[jn_om_Kfooooo`03ooooo`03onc/k?olo?cooooo0?oo
oooo=oooool00oono_kohN7QomgMg@05ooooo`03oh20P?nGUiOooooo00gooooo00?ogMgMoo?clooo
ool00oooool00on0P83oUiNGooooo`05ooooo`03omgMgOoclo?ooooo033ooooo00[o];BdokNg]oo1
`L7oalO7olo?cooEeMGofm_Kon3Ph?oUiNGojNWY0_oZj^X00ooWinOoh^;RomgMg@03onk^kP7oOZgI
0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`0@ooooo`0<ohV7Q_nQ`]SoP;kfoiCAoonDcoCo
N:c2ogf^fOmeV<OoLh:Koi2DV_o4aLGolo?c2Oooool01OlN7Qkodm?Cooooooo1`L7o[Zj^00;ooooo
00So4a<ColO7aooooooo`<30oa`L7?lU9BGo2PX:ogUiN@?ooooo00?oBDU9obd];Oooool00_ooool0
3_lW9bOo/K6aooooooo@d=3o;2`/oaDE5Ol];BgoC4a<ooooooo_knoo71`LobXZ:_l[:b_oRXZ:oooo
oolgooooo`05ofEUIOlc<c?oATI6obPX:?o;bl/00oooool00oo=cLgoBTY:ooooo`03ooooo`06omCD
e?lQ8B7o4Q8Bo`X:2_lQ8B7oWinO0_ooool01Oo_knoo>SXjod10@?lS8b?oSHf=00?ooooo00?ocLg=
odY:B_ooool00oooool01Oo_knoo>SXjod10@?lS8b?oSHf=00?ooooo1Ol000000ooGemOooooooooo
o`0Uooooo`0?okFe]Onk^k_o`l?3ol[:b_oAdM7of=SHomoOgooTi>Coj^[Zonk^k_o`l?3olO7aong]
kOoXj>Sohn?S00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo013ooooo00oo
RHR7ojo:fOnBb_SoX]Onoh2`a_lQ@Poo;ULVoci_DomHSY3oMJW;ogJWg_m_SKKoM7n>oifOX_oalO40
1_ooool05OlN7Qkodm?CoooooolY:BWo2@T9oo7alOoooooo4a<ColO7aooclo?o5aLGoi6ATOoooooo
h^;Roa@D5?n[Zj_oooooonKVi_l61PKo7QhNolO7a`02ooooo`0?obLW9ona/K7omoOgob8R8_mlO7co
no_kooooooogmoOooooooo[jn_oQhN7oooooonSXj?l820Sok>c/0?oooooo>Oooool00oo6a/Ko3`l?
ono_k`02ooooo`03ookno_lR8R;omOGe00Gooooo00?oRXZ:ode=COooool00oooool01_mUIFGoM7Ad
ooooooo_knoo6QXJolc<c0;ooooo00?oo_knob8R8_oemOD00oooool01_mUIFGoM7Adooooooo_knoo
6QXJolc<c0;ooooo00?oC4a<of1PH?olo?`00_olo?`Xooooo`0:okRh^?nl_;coaLG5olc<c?oDe=Co
g=cLon;Rh_oYjNWok^k^oo;blP;om?Cd00?olO7aonk^k_oXj>P00oo^k^h1ogj]f@7ok^k^0Oo^k^h0
00?ooooo00?oOZgIooooooooool04?ooool03on:RHOo]lkJojGGn?nij?ooVl_FodMP?OlgCBco3S85
o`H_0olXC1So=5h/oebAZOmo^okoO;goojBZ/006ooooo`0<oahN7_oCdm?oc/k>o`L71omMGEgoVi^K
oooooolC4a?oalO7ol30`?l20P;ok^k^0_ooool01omCDe?oHF5Qoooooon:RX[oBd];ohZ:R_mRHV80
0_ooool01OlW9bOo/K6aolC4a?l92@Wokno_00Kooooo00Coi>CTof9RH_lG5aOono_kooooooljoooo
o`03obDU9On8R8Sooooo00;ooooo00?oIVIVok2`/?ooool01?ooool00on:RX[oCDe=ooooo`02oooo
o`03ooShn?l:2P[od];B00;ooooo0_mYJFT3ooooo`07ofIVI_n`/;3oooooooooooohn?So2PX:om;B
dP02ooooo`;oJFUY0_ooool00ooTi>Co8b<SokFe]@0Zooooo`0:okRh^?nn_[koa/K6olo?cooFe]Ko
gmoOonGUiOo/k>colO7aooGem@;omoOg00?omOGeoo3`l?oZj^X00oooool1ogj]f@7ooooo0Oooool0
00?ok^k^00?oOZgIonk^k_ooool04?ooool03on:RXWo_m3Hok?Qm_o7l_oo[=OLodMX??m;H47oB5/m
ociG=_lnFcGo;4XDocMQFom[X>_oK:_]oi^V/006ooooo`0<oahN7_oCdm?oLg=coe=CDoo;bl_o?Cdm
oooooolC4a?oalO7ok>c/ol;2`_oo?cl0_ooool03OmYJFWoE5ADooooool[:b_oZj^[onWYjOl@413o
l_;boooooolW9bOo/K6aol71`Ol30`<00_lQ8B402?lF5QKo=CDeooooooooooooWYjNo``<3?mCDe?o
h^;Roooooolgooooo`06onOWiom?Cdoo8B4QoeEEEOmADE7oEEEE0oooool00onc/k?oHf=Sooooo`04
ooooo`03ohZ:R_m=CDgooooo00;ooooo00?ofm_Ko`000?oclo<00_ooool00on;Rh_o@d=3ooooo`02
ooooo`07ok>c/omSHf?ooooooooooooKfm_o0000oo?cl`02ooooo`03oh^;Rom3@d?ooooo00;ooooo
00?ofm_KobDU9Onc/k<0:Oooool03onh^;So_knoolK6a_o@d=3of=SHon7QhOoXj>Sok^k^oo?cloog
moOon_[jooShn?ogmoOolo?conc/k003onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KV
ooooo`0@ooooo`0?ohb:R_o5d]Ko_NSdomCkoonkh]koAF/goc]J=OldAC3o?4hdodMJ?_laBAko>F1N
og^/l_mg/?3oVJB^00Kooooo00co7QhNom3@d?lI6AWo[Zj^oooooolZ:R[ogMgMoa<C4oo7alOoh>3P
o`820_o;bl/2ooooo`0Eob`/;?n4Q8Coc<c<oa8B4_oinOWooooooe=CDonHV9SoooooobLW9ona/K7o
o?cloaPH6?oUiNGoooooohN7QomfMWKoooooookno_lB4Q;o];Bd0?oooooo>Oooool01_m[Jf_oGEeM
oo;bl_oDe=Co5aLGocTi>@?ooooo00?om_Kfob4Q8Oono_h01?ooool00on:RX[oCDe=ooooo`02oooo
o`03ol[:b_l0003oo?cl00;ooooo00?oUYJFoc8b<_ooool00_ooool01oofm_Ko8B4Qookno_oooooo
b/[:o`000?olo?`00_ooool00onFUYKo<S8booooo`03ooooo`03on3Ph?lM7Ago^KVi02Sooooo00[o
^;Rhokno_oo7alOodM7AomWIfOoRh^;ojNWYono_kooemOGonOWi0_ojn_X00oohn?Solo?cong]k@03
onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`0@ooooo`0?ohb<S?o:d]Goa>W_
omkoooo6i>?o@ehjocUJ;olVAAko7B`HobHe8olP=aKo;55?ohNcm?mo/N_oUJ>_00Kooooo01;o7QhN
ohn?SolA4A7onOWioooooon7QhOoP820oa<C4oo7alOoooooogMgMolN7QkoPX:2odE5AOlX:2SolO7a
ofe]KOmZJVX2ooooo`0;okRh^?lc<c?oooooobLW9ona/K7oooooogalO?ll?3coQXJ6oadM7Oo4a<@0
0_ooool01?m>CTkoHF5Qoi6ATOnDU9CoooooocKooooo00?on_[joa0@4?o7alL00_ooool00om[Jf_o
BTY:ooooo`03ooooo`03ode=COo:b/[ooooo00?ooooo00?oRXZ:ode=COooool00_ooool00ooTi>Co
0000ong]k@02ooooo`03ohN7Qom<C4cooooo00?ooooo00KoCDe=ol[:b_ooooooi>CTo`000?o]kNd2
ooooo`03ohN7Qom<C4cooooo00Cooooo00?o[Jf]oa@D5?omoOd09oooool03onh^;So`<30olS8b?oC
dm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^
k^h1onk^kP000oooool00omn[MWoooooooooo`0@ooooo`0?ohj=SOo?dmGob>GXonKooooHk_3oGUiP
ofIYIonKYJ7oJ7=YodiFA?lP;a3o:DE6ohbelOn4/NOoTZ6`00Kooooo00?o7QhNoc@d=?mUIFD00_oo
ool01?oShn?o92@Toa8B4_o7alL2ooooo`07ol71`On<S8coY:BTooGemOoooooo/k>con7Qh@02oooo
o`05oogmoOnTY:ConOWiok6a/OoShn<00_ooool00onf][KoRXZ:olS8b003ooooo`04ooGemOn`/;3o
RXZ:okbl_?oooooo=_ooool00oomoOgo2@T9ol[:bP02ooooo`03od10@?mfMWKooooo00?ooooo00?o
VYZJogemOOooool00oooool00on:RX[oCDe=ooooo`02ooooo`03oogmoOlN7Qko^k^k00;ooooo00?o
EUIFoh>3Poooool00oooool01_nJVY[oOGemooooooomoOgo7QhNok^k^`;ooooo00?oEUIFoh>3Pooo
ool01?ooool00ooShn?o0000on?Sh`0Wooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooa
lO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03
ogj]fOo^k^kooooo013ooooo00ooSXj>omKGfOoAhN;okOooon_oooo8g]ko/[k2okg5c?nda=Go[L;L
oibW]_mhQYKoQjgSoh^ci?n@XK801_ooool00olN7Qko0000ol71`@03ooooo`03odA4A?l0003oalO7
00kooooo00?oUiNGomWIfOooool0oooooom2ooooo`06ofUYJOmEEEGoi>CToifMWOl>3PkogmoO1?oo
ool02?oUiNGo<C4aoooooooooooogMgMog=cLomHF5SoCDe=1?ooool01_nCTi?o?cloon_[jonm_Kgo
6ATIonWYj@Cooooo00[oiNGUoc4a<Ooooooooooooi>CTolo?coojn_[okfm_OlI6AWojNWY0_ooool0
1OnATI7o_knoonc/k?mbLW;o>SXj02Sooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?o
OZgIonKVi_ooool04?ooool03on>SXkohn?Tok[1aOo]n_coloknoo[oooo_ooooeNkeokg8dOnV/l7o
Uk?HoiJijonC]>KoS;3PohnR]P06ooooo`03ofQXJ?mOGeoooooo00?ooooo00?o][Jfoe=CDooIfMT0
3_ooool00om^KVkob/[:ooooo`3ooooood;ooooo00Gon?ShogMgMol];BgoATI6olK6aP06ooooo`07
ofm_KooemOGoooooooKfm_nXZ:SoJFUYog1`L005ooooo`04ohf=SOlb<S;oBTY:olo?c`Kooooo00So
Kfm_ooGemOooooooooooohf=SOlb<S;oBTY:olo?c`?ooooo00GoYjNWoeUIFOl_;booLW9bomSHf00X
ooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOod
m?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo013ooooo00ooSXj>
ooclo?nk_;co^kk1ol35b?o7cm?ob]_NolWXkoo5j?ko_=G`ok:lb?nIZL7oUKGVohn^fOn@XkP0oooo
oonkooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo013ooooo00oo
c/k>omgMgOo`l>ooe]KEolg=cOo2`/?obL[;ol_?dOnha<[oY;S<oibge?n=YlGoU;GToiBcgonCZL40
oooooonkooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?cl
ooWinOodm?Cokno_00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo00oooooo
013oo_knoooooon=SHgok>c/oo7alOofm_Kono_koj:RX_nIV9Soc/c;omoMf_oHf=Oo`lW?ojfga?n;
WK3oSIZYoooooonkooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_ok
no_oo?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo
013ooooo00ooo_knoo_knooHf=SoZj^[oi2@T?nQXJ7oeMGEoooooooPh>3o];Bdoi>CTonDU9?o^kZh
oinNW?okno/0oooooonkooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[j
n_okno_oo?clooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo013ooooo00?oo_knoogmoOooool00oooool02?ojn_[oo?clooooooooooooo_knoooooooEeMGo
b<S9oooooonlooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_o
o?clooWinOodm?Cokno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oo
oooof_ooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oi
nOWom?Cdono_k`03ooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^ooooo`17ooooo`03
omoOgoo0`<3ooooo0?ooooooT?ooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKf
m_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWo
i^KVooooo`0@ooooo`05oj:RX_mbMgooYjR[omcLg?omoOd00oooool01?omoOgono_kooclo?ono_h[
ooooo`03omoOgol:2P[ojn_[0?oooooo?oooool00omaLG7ohn?Sooooo`0Cooooo`03og5aLOoShn?o
oooo03Sooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?co
nOWiooCdm?o_knl00ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool04?ooool0
2?n2OggoZ/_Toh:on?mhXLooKH2IohF;U?ng]kSoj^[Z1?ooool00oolo?cono_kooknoP0?ooooo`04
oo3`l?olo?conOWiong]k@[ooooo00CokNg]ooooooooooook>c/2?ooool00omDE5CoS8b<ooooo`3o
ooooocSooooo00?oinOWoo;bl_ooool00oooool00on0P83oUiNGooooo`0=ooooo`03omgMgOoclo?o
oooo00?ooooo00?oP820oiNGUoooool01Oooool00ooMgMgolo?cooooo`0`ooooo`0?okRh^?o0`<3o
b<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00?ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo013ooooo00coRHN6oj72f?n0__KoTlonoi_H
o_mgY<GoN:KCofnHa?m`PiSoT9BJolC5aOoclo<9ooooo`03oahN7_l=3@go51@D00;o51@D00[oa<C4
obLW9ona/K7oooooobLW9omLG5co71`Loa<C4om<C4comOGe0_ooool03_lW9bOo/K6aoooooooooooo
nOWiocPh>?lF5QKo=3@dogIfM_lG5aOoc/k>oooooolW9bOo/K6a1?ooool00omLG5co9RHVooooo`3o
ooooocKooooo00Kod];BocPh>?lb<S;o<c<code=COoQhN42ooooo`03olg=cOm:BT[ooooo00?ooooo
00Koe=CDob4Q8OlB4Q;o2PX:ob4Q8OnOWil2ooooo`05ono_kolj>S[o@410ob<S8on=SHd00oooool0
0oo=cLgoBTY:ooooo`03ooooo`05ono_kolj>S[o@410ob<S8on=SHd00oooool5o`000003omOGeooo
oooooooo02Gooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knool
o?conOWiooCdm?o_knl00oooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_ooool04?oo
ool03on9R8Oo[l[Ioi?;nOnNdogoU/K^odMQ@_lhCS7oKD5?og9dUOm`WmWoM:7Hoff;/OmdOhkoWInR
oo7al@06ooooo`03oahN7_nVYZKooooo00?ooooo00Wo9bLWok6a/Ooooooo9bLWog9bL_oemOGol?3`
oc@d=?nUYJD00_ooool02_lW9bOo/K6aoooooooooooo/[:boa/K6ookno_oh>3PobXZ:_n9RHT2oooo
o`03obLW9ona/K7ooooo00;ooooo00Col?3`o`T92OlB4Q;o_knooooooolfooooo`06oeADE?mhN7So
oooooooooomQHF7oEUIF0_ooool00oono_ko8R8RooGem@05ooooo`03ohZ:R_m=CDgooooo00?ooooo
00KoIFEUogAdM?ooooookno_oaXJ6_o<c<`2ooooo`03ookno_lR8R;omOGe00?ooooo00KoIFEUogAd
M?ooooookno_oaXJ6_o<c<`2ooooo`03oda<C?mPH63oo?cl00;oo?cl:?ooool03onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`03onk^kP7oOZgI
0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`0@ooooo`0?ohZ9Qongc][oY]SjokGToon^gO[o
L8AAoeMN7On731OoHa8KocA=P?ljB7?oJYcLognlo_ml_OooY:Z`00Kooooo00?o7QhNojJVY_ooool0
0oooool01OlW9bOo/K6aoooooolW9bOo/K6a00;ooooo00KoOgmooeYJF_ooooooooooobLW9ona/K42
ooooo`06om_Kfol=3@go/;2`ooWinOm4A4CoU9BD0_ooool00olW9bOo/K6aooooo`02ooooo`04oiJF
U_l`<33oRXZ:oeUIFOoooooo=_ooool01_lW9bOo^[ZjooooooooooooOGemodE5A@?ooooo00?oIVIV
ok2`/?ooool01?ooool00on:RX[oCDe=ooooo`02ooooo`03ooShn?l:2P[od];B00;ooooo0_mYJFT3
ooooo`07ofIVI_n`/;3oooooooooooohn?So2PX:om;BdP02ooooo`;oJFUY0_ooool00ooTi>Co8b<S
okFe]@0Zooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_ohn?Son[Zj_o_knoom?CdooWinOojn_[oo?cl
ooWinOodm?Cokno_00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo013ooooo
00ooRXZ9oko@f?ndhOSo`nkool7Zo?mQOeko@5PVojh[=on@;d7oDVjModQANomNQ;goJ9kSoff[konK
Y[001_ooool00olN7QkoYZJVooooo`03ooooo`05obLW9ona/K7oooooobLW9ona/K400_ooool01_nJ
VY[o;2`/oooooooooooo9bLWok6a/@?ooooo00Gof=SHoi:BT_mQHF7o5QHFoiBDU002ooooo`03obLW
9ona/K7ooooo00;ooooo00Go<c<coi6ATOo[jn_o3@d=on_[j`3oooooocGooooo00KoQhN7oeMGEook
no_oRh^;o`L71on[Zj/3ooooo`03ok>c/omSHf?ooooo00Cooooo00?oRXZ:ode=COooool00_ooool0
0ooKfm_o0000oo?cl`02ooooo`03oh^;Rom3@d?ooooo00;ooooo00Oo/k>cof=SHoooooooooooom_K
fol0003olo?c00;ooooo00?oRh^;od=3@oooool00_ooool00ooKfm_o9BDUok>c/`0Yooooo`0;okRh
^?o0`<3ob<S8om7AdOoFe]Kog=cLomoOgooShn?oj>SXong]kOoclo<00_ogmoL00oodm?Cokno_onk^
kP02onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`0@ooooo`0?ohb:R_o5d]Ko
_^WeolofoooBm_koKI1`ociW=onQ5BooT1Xiod5VXOmAH9;oJXk5ogRYj_mg/?7oVJB^00Kooooo00?o
7QhNojJVY_ooool00oooool01OlW9bOo/K6aoooooolW9bOoPX:200;ooooo00KoIFEUof][Jooooooo
ooooobLW9omZJVX6ooooo`06ocXj>_nNWYkooooooooooolW9bOoJVYZ0_ooool01_o@d=3o1PH6onc/
k?ooooooFUYJohb<S?oooooo=_ooool01?m]KFgo5QHFo`<30onh^;P4ooooo`03ooKfm_lQ8B7oo_kn
00Cooooo00?oRXZ:ode=COooool00_ooool00oo:b/[o0000ooclo002ooooo`03oiJFU_lb<S;ooooo
00;ooooo00Oom_Kfob4Q8Oono_kooooool[:b_l0003oo?cl00;ooooo00?oUYJFoc8b<_ooool00ooo
ool00ooPh>3o7AdMokVi^@0Xooooo`0?okRh^?no_kooaLG5ol[:b_o7alOo`L71okZj^_nf][Ko^[Zj
olK6a_oDe=CoiNGUono_kooalO7ok^k^00?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^
k^kooooo013ooooo00ooS8b<ol[BeOo5jo3of_coomSgoon:Y7GoIhPkojDJ>?nM6D3o=f>ZocMAVOmU
R<;oPk3[ognakOnEXjl01_ooool00olN7QkoYZJVooooo`03ooooo`09obLW9ona/K7oooooobLW9om>
CTkoBTY:oe=CDol51@Go`<3000;ooooo00[o9bLWodY:B_m7AdOoXJ6QoooooomADE7oMGEeoh:2P_l6
1PKoi^KV0_ooool01_lW9bOoBTY:odM7AonQXJ7oKFe]oeADE0;ooooo00?o`/;2obHV9_ooool0oooo
ooldooooo`06on3Ph?lI6AWoIVIVoinOWomBDU;onOWi1?ooool00om=CDgob/[:ooooo`03ooooo`03
ohZ:R_m=CDgooooo00;ooooo00?oi>CTo`000?o]kNd00_ooool00on7QhOoC4a<ooooo`03ooooo`06
ode=COo:b/[oooooonCTi?l0003okNg]0_ooool00on7QhOoC4a<ooooo`04ooooo`03ojf][OlD51Co
oOgm02Oooooo00oo^;Rhokfm_Onm_KgoXZFdoeY_Y_lVDZKo2Tneo`iH]ol[HjWoDW>LohRAVoni^KWo
emOGonOWioo/k>`00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool04?ooool0
3on>SHgocm?EolWVjOoSooooh_[ooiVcROmeU4SoZC=1ojh^B_mNQ;ooCW:foff?aOn9/^WoQK7Yoi:Q
/006ooooo`03oahN7_nVYZKooooo00?ooooo00So/K6aon?Shooooooo9bLWok6a/Oo3`l?oSHf=olW9
b@?ooooo00Wo/K6aon?Shonm_Kgo[Zj^oooooooUiNGo[Jf]oi>CTooIfMT00oooool01_na/K7ohn?S
okfm_On^[Zko/[:bomWIf@?ooooo00?oYZJVooCdm?ooool0oooooolcooooo`06oi:BT_m;Bd_ooooo
oooooomADE7o[Zj^1?ooool00onJVY[oOGemooooo`03ooooo`03ohZ:R_m=CDgooooo00;ooooo00?o
oOgmoahN7_nk^k/00_ooool00omFEUKoPh>3ooooo`03ooooo`06oiZJV_mmOGgooooooogmoOlN7Qko
^k^k0_ooool00omFEUKoPh>3ooooo`04ooooo`03on?Shol0003ohn?S02Oooooo00oo][JfokRh^?n6
S:_o;DfUo`0m^?l0CKgo35[3oa]Xb?lVLLco<7W?oci_ZOm]OHoo[:b/om?CdooUiND00ooVi^H1ogj]
f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool04?ooool03on>SXkoe]OIom7Ph_o^oooojOgo
oi6ZSOmLQdooY2`hokPZCOmfWm;oJi?>og^KcOn=/^SoRK7Soi2Q/P06ooooo`03oahN7_nVYZKooooo
00?ooooo00GoUiNGomWIfOoooooo9bLWok6a/@3ooooooe7ooooo00KofMWIobd];OoPh>3ogMgMobDU
9Onn_[h4ooooo`08onGUiOla<C7ooooooooooooMgMgoLg=coeQHF?m=CDd4ooooo`06oi>CTolo?coo
jn_[okfm_OlI6AWojNWY1?ooool02_oUiNGo<C4aooooooooooooTi>Coclo?oo[jn_o_KfmoaTI6OoY
jNT2ooooo`05oi6ATOno_kook>c/og9bL_lj>SX0:?ooool03ond];CoVif]obe:Xol0>KCo04bmo`aK
`olMJLWo;7G>ocQodom2Q]GoB8[Fod]gZ_mfOHGo/k>comWIf@03onk^kP7oOZgI0Oo^k^h1onk^kP00
0oooool00omn[MWoooooooooo`0@ooooo`0?ohj>S_oShnCo^/75ongjo?obooooeM_AokRaUOnaLg;o
_5a^oh:<[om]R;_oNYK7oiBfjOn</=ooSj:f00Kooooo00?oJ6QXol?3`oooool00oooool01Om^KVko
b/[:oooooolW9bOo/K6a0?ooooooD_ooool01?nXZ:SoC4a<oc/k>on=SHd6ooooo`07ofm_KooemOGo
ooooooKfm_nXZ:SoJFUYog1`L005ooooo`04ohf=SOlb<S;oBTY:olo?c`Kooooo00SoKfm_ooGemOoo
ooooooooohf=SOlb<S;oBTY:olo?c`?ooooo00GoYjNWoeUIFOl_;booLW9bomSHf00Xooooo`0?ok:b
/_mKJjKo03Bbo`=;_Ol=G/Ko76[:ob]fcolmPmGoBXgKoe>FhOmLW^KoGioVoeIaSonCTi?ob/[:00?o
oooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo013ooooo00ooSXj>ooclo?nk_;co
^kk1ol35b?o;e=WobMSMolCRi?nle^3o^Kg<ojNY]onGY/CoUkS[ohn^f?n@XkP03oooool00oo9bLWo
k>c/ooooo`3oooooojWooooo00oo[Zj^obY9Y_l;B[_oCXkFof6Lfom?T=[o>H3EodZ=f_mHVnGoIJK^
ofn_m_md]O_oH8flogUiNOnl_;`00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_oo
ool04?ooool03oo>c/kogMgMoo3`kooFe]GocLg=ol;1`Oo:blcoc=3DokW6d?nS^]3oV;CBoi>cfOnG
]nOoTk?Noi>Y`@3ooooook_ooooo00oo[Jf]o``e[?m4OLooRkKVohJciOmm[^Go?hOKoe6FiOmPXnoo
K[7kogbooon4bOooMJo]ofUYJOnc/k<00ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^
k_ooool03oooool04?ono_koooooohf=SOo/k>colO7aooKfm_okno_oXZ:RoiVHUoo>bl[oh=cJomWH
f?o2alco[KO4oh^M/?n=VZWooooook_ooooo00ooZj^[o`0/[Om/V=[oS[WVoh^fiOn1/NGo@HOJoeJK
j_mWYo?oM[[ooh?7oon=d_ooQlSoof1PH?n^[Zh00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?o
OZgIooooooooool04?ooool03oono_kono_komSHf?n[Zj_oT92@oj6QXOoEeMGoooooon3Ph?nd];Co
Ti>CoiFDU?nk^[SoWijLoo_kn`3ooooook_ooooo00ooZj^[o`0/[_mdWmcoTK[Woh^fion1/^OoA8cP
oeRMk?mZ[O[oN[coohS=oonCfOooRloooeaLG?n/[:`00oooool1ogj]f@7ooooo0Oooool000?ok^k^
00?oOZgIonk^k_ooool04?ooool00oono_kooOgmooooo`03ooooo`08oo[jn_olo?coooooooooooon
o_koooooomGEeOo8b<Wooooookcooooo00ooZj^[o`0[ZomeWmcoT;[Voh^fi_n2/^KoAXgPoeZOkom[
[o_oO<3ooh[@oonFg_ooS=3ooeaLG?n[Zj/00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgI
onKVi_ooool0oooooooJooooo`0?oj^[Zol0:ZcoNJ;Loi2jion:]^OoP[?YodB>i?mFW^coK;7oogc0
oon9d?ooU=koohkDoomLG5coZj^[00?oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo0?oooooof_ooool03on[Zj_o03VcogJMg?n<^>KoRKKVognaiom0R^3oDY[/ofF/nomf_?ooPlgo
oi3Koon7d?ooG5aLoj^[Z`03onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`0@
ooooo`05oj:RX_mbMgooYjR[omcLg?omoOd00oooool01?omoOgono_kooclo?ono_koooooofgooooo
00?oLG5aon?Shoooool04oooool00omaLG7ohn?Sooooo`0hooooo`0?oj^[Zol0>K?oMi_JohbfiOn3
/nGoNjgUoc^7h?m>Un_oH:Siog6koomob?ooRMGooh38oomLG5coZj^[00?ooooo0Omn[MT1ooooo`7o
oooo0003onk^kP03ogj]fOo^k^kooooo013ooooo00SoPWmmoj[;i?n2_oSoN:7?off0VOn3R97o][Nh
on[ZjPCooooo00?oo?cloo_knoono_h04Oooool00ooWinOon_[jooooo`04ooooo`03onSXj?ojn_[o
oooo00;ooooo00?omOGeooWinOooool04?ooool00oo[jn_om_Kfooooo`0:ooooo`06oo[jn_o/k>co
ooooooooooo/k>coo?cloooooolOooooo`03ookno_oQhN7ogMgM00Gooooo00?oP820oiNGUoooool0
4oooool00on0P83oUiNGooooo`05ooooo`03omgMgOoclo?ooooo033ooooo00ooZj^[o`0i/omiW]co
R[KUohRei_ml[^Ko?h[Poe>Kk_mT[?goM;cooh;8oon=f?ooQ/cooeaLG?n[Zj/00oo^k^h1ogj]f@7o
k^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool04?ooool03?n9QhKoXL;Hoh2nm_nCc_goW=cooi72
iOnK/LkoLhVYofUeQon<T9Goa<C5oo?cl`Wooooo00Ko7QhNo`d=3OlD51Co5aLGochn?_ne]KD3oooo
o`05ol30`?lL71co9BDUo`X:2_miNGT00_ooool03oo<c<co92@To`l?3olK6a_oPX:2oooooonRXZ;o
410@oaPH6?nBTY;o8R8RokJf]_oooooo9bLWok6a/@02ooooo`0<o`h>3_o8b<SoooooooGemOl0003o
hN7Qooooooo@d=3o;2`/oaDE5Ol];BgoC4a<0_ooool03olW9bOo/K6aoooooooooooo=3@dojBTY?oo
oooo][JfoaTI6Olj>S[okno_oa`L7?lZ:R[o:b/[ohZ:RP3ooooooakooooo00GoIFEUoc<c<om6ATKo
:2PXol_;b`03ooooo`03olg=cOm:BT[ooooo00?ooooo00Koe=CDob4Q8OlB4Q;o2PX:ob4Q8OnOWil2
ooooo`Go000000GoemOGoooooooooooocLg=odY:BP04ooooo`05ono_kolj>S[o@410ob<S8on=SHd0
0oooool5o`000003omOGeooooooooooo02Gooooo00ooZj^[o`0i/omfW]coT;WVohRdi_n0/NKo@X[O
oeFKjomY[O_oN[ooohO<oonCf_ooRLgooeaLG?n[Zj/00ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^
00?oOZgIonk^k_ooool04?ooool03on9R8Oo[l[Ioi?<n_nMd?WoW=?loi>i]oofm^Soo?koon;[mOo0
d>KoRjS?of^8/?meOhkoWInRoo7al@06ooooo`0OoahN7_nVYZKoooooooWinOnh^;So61PHoiRHV?oo
oooolo?coaLG5onATI7oooooon;Rh_lD51CoZj^[ooOgmolP823oHF5Qoo;bl_ono_kok^k^oooooola
<C7oVIVIooShn?m`L73o10@4okJf]_oooooo9bLWok6a/@02ooooo`0<o`h>3_o8b<SoooooooGemOl0
003ohN7QooOgmolR8R;oO7aloo_knooooooomoOg0_ooool04?lW9bOo/K6aoooooooooooo=3@dojBT
Y?ooooooCDe=oh:2P_oooooon_[jon7QhOooooooj>SXo`P82?o/k>coooooob3ooooo00?oa/K6o`l?
3oo_knl00_ooool00oono_ko8R8RooGem@05ooooo`03ohZ:R_m=CDgooooo00?ooooo00?oC4a<of1P
H?olo?`00_olo?`3ooooo`03ookno_lR8R;omOGe00?ooooo00KoIFEUogAdM?ooooookno_oaXJ6_o<
c<`2ooooo`03oda<C?mPH63oo?cl00;oo?cl:?ooool03on[Zj_o03VcogJPg?nA^nOoSKWWoh:cjOm7
S^7oFj3^offcoomm`?ooRm3ooiOOoon@doooG5aLoj^[Z`03onk^kP7oOZgI0Oo^k^h1onk^kP000ooo
ool00omn[MWoooooooooo`0@ooooo`0?ohZ9Qongc][oY]Wjok?RoOngjoooXLO0onW[hOojnOcon?Oe
oo_knooKh]SoL:[Pogjjo_mm__ooY:Z`00Kooooo00?o7QhNojJVY_ooool00_ooool01_n3Ph?o410@
oo;bl_o0`<3o0P82onk^kP;ooooo00GoDe=Cof5QHOo3`l?o0000omGEe@04ooooo`09oaDE5Oo2`/;o
ooooookno_lL71co][JfoooooolW9bOo/K6a00;ooooo00Wo3Ph>olS8b?oooooomOGeo`000?oQhN7o
a<C4o`T92Oo_knl01Oooool02OlW9bOo/K6aoooooooooooo=3@dojBTY?oooooo<c<cojFUY@03oooo
o`04onCTi?mRHV;o5aLGoo_knooooooo8Oooool00olU9BGoR8R8ooooo`02ooooo`03ofIVI_n`/;3o
oooo00Cooooo00?oRXZ:ode=COooool00oooool00ooTi>Co8b<SokFe]@06ooooo`07ofIVI_n`/;3o
ooooooooooohn?So2PX:om;BdP02ooooo`;oJFUY0_ooool00ooTi>Co8b<SokFe]@0Zooooo`0?oj^[
Zol0>K?oMJ;LoiBlion>^^KoRKKWodZ@hOmNX^koLKCooh32oon>doooV=oooi?FoomLG5coZj^[00?o
oooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo013ooooo00ooRXZ9oko@f?ndh_So
`^cmolOeoonVb/3ohnGJooKfn?o`lO3omoKiom[Odom[WLOoIY_Sofj/konKY[001_ooool00olN7Qko
YZJVooooo`02ooooo`06olg=cOl0003oa/K6ok>c/ol;2`_oo?cl0_ooool01OmYJFWoE5ADok>c/ol2
0P;okno_00Cooooo00Wo5ADEol?3`oooooooooooob8R8_nf][KoooooobLW9ona/K400_ooool02?l>
3Pkob<S8oooooooemOGo0000on7QhOo1`L7o0`<30_lQ8B401_lF5QKo=CDeoooooooooooo9bLWok6a
/@;ooooo00Go=3@dojBTY?oooooo<c<cojFUY@02ooooo`04oijNW_l<30coDe=Con;Rh_oooooo7_oo
ool01_oWinOoCdm?ob4Q8OmEEEGoDE5AoeEEE@?ooooo00?o/k>cof=SHoooool01?ooool00on:RX[o
CDe=ooooo`04ooooo`03om_KfolU9BGo/k>c00Gooooo00Oo/k>cof=SHoooooooooooom_Kfol0003o
lo?c00;ooooo00?oRh^;od=3@oooool00_ooool00ooKfm_o9BDUok>c/`0Yooooo`0?oj^[Zol0>K?o
MZ?OoiJmjOnA^nWoRKSZodjDiOmPY>ooL[CoohC7oonCe_ooWN7ooi?EoomLG5coZj^[00?ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo013ooooo00ooS8Z:olGBe_nnjOGoc_GnomSo
oon`dL;ofmkCoo;bm?o]kNgolo;eomOLd?mfY<_oMjO/ogRalOnIY:h01_ooool00olN7QkoYZJVoooo
o`02ooooo`06oo[jn_l30`?oZ:RXon3Ph?l20P;obl_;0_ooool01Ol/;2coQ8B4omoOgol20P;oYJFU
00Cooooo01Oo5ADEol?3`oooooooooooob8R8_nf][KoooooobLW9om[Jf_oooooooclo?l71`OoPX:2
ooooooo[jn_o0000onOWioolo?co61PHonGUiOooooooQhN7ogIfMP02ooooo`0=obLW9omGEeOooOgm
oooooolS8b?o[:b/oooooolc<c?oYJFUooooooono_ko4Q8BokBd]03oooooob3ooooo00KoJf][oeeM
GOobl_;oe=CDoaLG5oli>CT3ooooo`03ooKfm_lQ8B7oo_kn00Cooooo00?oRXZ:ode=COooool01Ooo
ool00ooPh>3o7AdMokVi^@04ooooo`07ooKfm_lQ8B7oo_knooooooo:b/[o0000ooclo002ooooo`03
oiJFU_lb<S;ooooo00?ooooo00?oh>3PoadM7Oni^KT0:?ooool03on[Zj_o03VcogZWgonF_NOoTK[W
ohZhj_m@Tn?oI:K`ogJfoon7aoooU=Kooj;VoonJfOooG5aLoj^[Z`03onKViP7oOZgI0OoVi^H1onKV
iP000oo^k^h00omn[MWok^k^ooooo`0@ooooo`0?ohb<S?o:d]GoaN_aomWkoooQoooo]=74oloCaoo[
j^goiNKUonk]l?oCf<coO:G7oh2]kOmo/^goUJ>_00Kooooo00?o7QhNojJVY_ooool00_ooool04onm
_Kgo0000ol;2`_ooooooMgMgoahN7_n2PX;oADE5obPX:?oalO7oooooogQhN?l:2P[oK6a/oh>3Pon`
/;3ooooooaDE5Oo3`l<00_ooool02OlR8R;o][JfoooooolW9bOoDe=CodU9BOmNGUko5ADEogQhN002
oe5AD@08ob/[:oooooooooooogalO?ll?3coQXJ6oadM7Oo4a<@2ooooo`0?obLW9omGEeOo>SXjof9R
H_l820Sol?3`ok>c/olI6AWoDE5AogmoOoomoOgoCTi>of5QHOnATI7oU9BD0?oooooo7Oooool00ooj
n_[o410@olO7a`02ooooo`03of][Jom:BT[ooooo00?ooooo00?oCDe=ol[:b_ooool00oooool00on:
RX[oCDe=ooooo`06ooooo`03ojf][OlD51CooOgm00Cooooo00KoCDe=ol[:b_ooooooi>CTo`000?o]
kNd2ooooo`03ohN7Qom<C4cooooo00Cooooo00?o[Jf]oa@D5?omoOd09oooool03on[Zj_o03VcogZZ
h?nE_NWoU;gZoh^ij_mCUnGoJ:[cogZjoon;c?ooV][ooj?WoonJf_ooG5aLoj^[Z`03onk^kP7oOZgI
0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`0@ooooo`0?ohj=SOo?dmGobNKYon;noooZoooo
^mG8olO:`_oTh^Oog]oNolk<d?nd^:coPjW6ohN_kOn5/^SoTZ6`00Kooooo00?o7QhNojJVY_ooool0
0_ooool00omYJFWo5aLGooCdm002ooooo`04ol71`On<S8coY:BTooGem@?ooooo00OoaLG5ohf=SOnC
Ti?oeMGEoooooonZZZ[ojNWY00;ooooo00co[jn_onGUiOoooooo/K6aon?Shoo:b/[oTI6AomWIfOoo
oooo_KfmoiJFU_oXj>P3ooooo`03okJf]_n:RX[ob<S800?ooooo00oo/K6aon?Shoo?clooTi>ComkN
g_oooooob<S8ob0P8?mYJFWoXZ:Rookno_oemOGo/;2`ohZ:R_nl_;`0oooooolMooooo`03oogmoOl9
2@Wob/[:00;ooooo00?o@410ogIfM_ooool00oooool00onJVY[oOGemooooo`03ooooo`03ohZ:R_m=
CDgooooo00Kooooo00?ohn?So`000?oShn<01?ooool01_nJVY[oOGemooooooomoOgo7QhNok^k^`;o
oooo00?oEUIFoh>3Poooool01?ooool00ooShn?o0000on?Sh`0Wooooo`0?oj^[Zol0>K?oMJOPoiJo
jOnE_NWoS[_[oeNKiom/Zo?oO;_oohg<oonKf_ooYn_ooioPoomLG5coZj^[00?ooooo0Omn[MT1oooo
o`7ooooo0003onk^kP03ogj]fOo^k^kooooo013ooooo00ooSXj>omKGfOoAhN?okOooonkooonoe/[o
[;bLoloCcOoFeMOoZ:VYogZ=Hon7ZlCoS[?^ohVah_n@XK801_ooool01olN7QkoOGemok^k^onRXZ;o
GUiNo`d=3On`/;00;oooool00on>SXkob<S8ooooo`3oooooob?ooooo00KoJFUYoeEEEOoTi>CoWIfM
o`h>3_oOgml4ooooo`08onGUiOla<C7ooooooooooooMgMgoLg=coeQHF?m=CDd4ooooo`05oi6ATOno
_kook>c/og9bL_lj>SX01Oooool02_oUiNGo<C4aooooooooooooTi>Coclo?oo[jn_o_KfmoaTI6OoY
jNT2ooooo`05oi6ATOno_kook>c/og9bL_lj>SX0:?ooool03on[Zj_o03VcogJWh?nH`>WoU[oZohfj
jomDUnKoIjS`ogVioon;cOooV=Wooj?WoonKfoooG5aLoj^[Z`03onk^kP7oOZgI0Oo^k^h1onk^kP00
0ooVi^H00omn[MWoi^KVooooo`0@ooooo`0?ohj>S_oShnCo^/75oncinoohoooofNWQoiJiNOnC]G?o
TZefohnNN_nQ/;SoTKCRoi>ej?n</=ooSj:f00Kooooo00KoJ6QXoe=CDomCDe?oIFEUohR8R?oLg=co
oooooeKooooo00Gon?ShogMgMol];BgoATI6olK6aP06ooooo`07ofm_KooemOGoooooooKfm_nXZ:So
JFUYog1`L004ooooo`05ojNWYomIFEWo;bl_og9bL_oHf=P01_ooool02?m_KfoomOGeoooooooooooo
SHf=oc8b<_m:BT[oclo?0oooool01OnWYjOoFEUIobl_;ombLW;of=SH02Sooooo00ooZj^[o`0i/omf
YMkoUkoYoi>lj_n;^>[oD9?Sof>Ukome]OkoR<SooiKIoonRi?ooV][ooeaLG?n[Zj/00ooVi^H1ogj]
f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool04?ooool03on>SXkoo?clok^l_?nk_/7o`<G8
olO?donmc/ko[LW0oiVlY?nN^[Wo/]7ooio0konH]nKoSjkIoi2S^03ooooook_ooooo00ooZj^[o`0i
/omgY=ooUKcWoi6kj_n8]^[oCI;Sof6Ul?mc]?ooQ<Oooi7DoonNhoooUMSooeaLG?n[Zj/00oo^k^h1
ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool04?ooool03oo>c/kogMgMoo3`kooFe]Go
cLg=ol?3`oo=cLood=CJok_7e?nW^LooVKC@oiBdfonG]nOoTk?Noi>Y`@3ooooook_ooooo00ooZj^[
o`0i/omgXmkoT[_Vohjjion4]>WoBY7SoejRk_m_/_goPLCooi3DoonJh?ooTmGooeaLG?n[Zj/00ooo
ool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_ooool03oooool04?ono_koooooohf=SOo/
k>colO7aooKfm_okno_oXZ:RoiRGU_o>blWogmcJomSHf?o2al_o[KO4oh^M/?n=VZWooooook_ooooo
00ooZj^[o`0i/omgX]koTK_Wohbiion2/nOoAi7Toe^Rkom]/_koOL7ooh[?oonGgoooT=CooeaLG?n[
Zj/00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool04?ooool03oono_kono_k
omSHf?n[Zj_oT92@oj6QXOoEeMGoooooon3Ph?nd];CoTi>CoiFDU?nk^[SoWijLoo_kn`3ooooook_o
oooo00ooZj^[o`0SZ?meW=_oS;KUohNei_mn/NOo?HSPodnJk?mSZo_oM;_ooh79oon:e?ooPl[ooeaL
G?nZZZX00ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool04?ooool00oono_ko
oOgmooooo`03ooooo`08oo[jn_olo?coooooooooooono_koooooomGEeOo8b<Wooooookcooooo00oo
Zj^[o`0SZ?meW=_oSKSVohJciOmo/NKo?hSNoe>Jk?mTZ_SoMK[ooh;:oon<e_ooQ<[ooeaLG?nYZJT0
0oo^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool0oooooooJooooo`0?oj^[Zol0
9Z_oMIgLohfii_n7]NKoO[7Wocn:hOmBV^_oIJckog>joon3c?ooR]?ooh74oomKFe_oZ:RX00?ooooo
0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo04gooooo00?o_;blonOWioooool0oooo
oon:ooooo`0?oj^[Zol09Z[oJ9?HohZeiOn6]>GoNjgUocb7gom@V>[oHZ[hog6hoomoa_ooQ<[oogg0
oomNGUkoZJVY00?ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo00oooooo00?o
n_[joo?cloo_knl03?o_knl00oodm?Coooooooooo`0/ooooo`03obLW9ona/K7ooooo0?oooooo>Ooo
ool00omaLG7ohn?Sooooo`0Cooooo`03og5aLOoShn?ooooo03Sooooo00ooZZZZo`//Z?loL/goPJkS
oh:biOmaYnCo>HCOodbDiomNY?GoKKCoogVooomm`_ooKZW]ofATI?nZZZX00ooVi^H1ogj]f@7oi^KV
0OoVi^H000?ok^k^00?oOZgIonk^k_ooool03oooool04?o3`l?oR8Z@og5fPOmaMh7oLGN2og9gP_mb
N8;oLgV2og=iPomdNX?oMGZ3ogIkQ?mhOXGoNGn6ogZ0Q_nCUYTAooooo`03on_[joofm_Kooooo00?o
oooo00?ok>c/ooclo?ooool02_ooool00oojn_[ok>c/ooooo`02ooooo`03onOWioojn_[ooooo00;o
oooo00Co9bLWok6a/OoinOWokNg]ooooool`ooooo`03ookno_oQhN7ogMgM00Gooooo00?oP820oiNG
Uoooool04oooool00on0P83oUiNGooooo`05ooooo`03omgMgOoclo?ooooo033ooooo00ooZZZZobQ1
X?l7?kKo@X7Boe:Af?lnQ=Ko=7kHodJ=homEVncoHZKdoffaoom`/okoFhJiog1`L?n^[Zh00oo^k^h1
ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool03oooool04?n7RXoo>Dn1oai5U?lWD9[o
8dbHobMAVolcFj;o=UnTocYRY_lmIZSo@6RXodee[omKPkGoHXVgof><_OmIL8h6ooooo`06oahN7_l=
3@go51@DoaLG5oln?Sko]KFe0oooool02oo@d=3o;2`/oaDE5Ol];BgoC4a<ooooooo_knoo71`LobXZ
:_l[:b_oRXZ:00;ooooo013o9bLWok6a/Ooooooobl_;o`l?3on[Zj_ooooookJf]_lI6AWo>SXjoooo
ooo0`<3o71`LobDU9Ol:2P[oNGUi0_ooool01_lW9bOoD51@oa`L7?lC4a?oC4a<ooGemOoooooo;_oo
ool01OmUIFGo<c<codI6A_lX:2Sobl_;00?ooooo00?ocLg=odY:B_ooool00oooool01_oDe=Co8B4Q
oa8B4_l:2P[o8B4QoinOW`;ooooo1Ol000001OoGemOoooooooooooo=cLgoBTY:00Cooooo00Gokno_
ocXj>_m0@43o8b<Sohf=S@03ooooo`Go000000?oemOGooooooooool09Oooool03on_[jooEVJQo`0e
/_l1BKco2eg6oa]Zc?l/NM?o?XOKodbBhomFVn[oGZ;[oenOi_mAK8[oPX:2okJf]P03ooooo`7oOZgI
0Oooool1ooooo`000oo^k^h00omn[MWok^k^ooooo`0?ooooo`0@oh:4R_mIJhkoXJg1oc]MV_n5UkOo
Oi:dob]DWOleGJ?o=EfRocMNXom2JjSoDW^`oeR1/_mOQ[?oEh:goe1YR`Kooooo01_o7QhNojJVY_oo
oooonOWiokRh^?lH61SoV9RHooooooogmoOo8R8RogalO?okno_oooooooOgmooooooon_[jon7QhOoo
ooooj>SXo`P82?o/k>coooooobLW9ona/K7of=SHoaDE5OnGUiL00_ooool04Om=CDgoPX:2oooooooc
lo?o5aLGoi6ATOooooooh^;Roa@D5?n[Zj_oooooobLW9ombLW;omOGeoo3`l?ld=3CoYJFU0?oooooo
<Oooool00oo6a/Ko3`l?ono_k`02ooooo`03ookno_lR8R;omOGe00Gooooo00?oRXZ:ode=COooool0
0oooool00om<C4coH61Pooclo002ooclo0?ooooo00?oo_knob8R8_oemOD00oooool01_mUIFGoM7Ad
ooooooo_knoo6QXJolc<c0;ooooo00?oC4a<of1PH?olo?`00_olo?`Xooooo`0?okFe]On=T:3o:D^Q
o`11^?l3Dl3o4V?7obAacOlbO=;o@8OHodZ=f_m?TM[oC7NYofI]MOn?ShoobLW900?ok^k^0Omn[MT1
onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo00oooooo013oPhB:ogB2WOohm>coAFBOom?Hh?n_
^LSo9U>Moc5LX_l`Fj;o@FbZoeAn/_mGP[CoGHJfofF;^?mDOkOoE6b?1_ooool00olN7QkoYZJVoooo
o`02ooooo`06oh>3Pol@413ol_;bolC4a?l92@Wokno_1_ooool02OoTi>CoHV9RoaLG5ookno_ooooo
obLW9onDU9Co7QhNoh:2PP03ooooo`06oc<c<onUYJGooooool30`?l20P;ok^k^0_ooool01OmCDe?o
HF5QoooooolW9bOo/K6a00;ooooo00?oOgmooeYJF_ooool0oooooolaooooo`03obDU9On8R8Sooooo
00;ooooo00?oIVIVok2`/?ooool01?ooool00on:RX[oCDe=ooooo`03ooooo`03onCTi?lS8b?o]KFe
00Kooooo00OoIVIVok2`/?ooooooooooooShn?l:2P[od];B00;ooooo0_mYJFT2ooooo`03onCTi?lS
8b?o]KFe02[ooooo00oo^k^koinOWomcNiWo9d^Ro`14^_l4E<7o4V;7ob5^c?l/Mloo=Wk@oci^Y_mK
JWcoPX:2ojVYZOoShn<00ooVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool03ooo
ool04?n4Qh_oH7:Dog:6Z_m5JZOoKXN[oeMgYOl_GZCo>6:UodI`[?mGP;CoFXBeoeZ4]_mOQkOoFH6a
odQc[_mCK8l6ooooo`03oahN7_nVYZKooooo00;ooooo00GocLg=o`000?o6a/Ko`L71o`<30`02ob4Q
8@08oaHF5_le=CGooooooooooonNWYko30`<oe=CDooRh^82ooooo`04obLW9om2@T;o7QhNooWin@?o
oooo00Ko<c<cojFUYOoooooo/k>co`/;2oolo?`2ooooo`05ofUYJOmDE5CoooooobLW9ona/K400_oo
ool00onJVY[o;2`/ooooo`3oooooobgooooo00KoinOWodm?ColQ8B7oEEEEoe5ADOmEEED3ooooo`03
ok>c/omSHf?ooooo00Cooooo00?oRXZ:ode=COooool01?ooool00ooKfm_o9BDUok>c/`05ooooo`07
ok>c/omSHf?ooooooooooooKfm_o0000oo?cl`02ooooo`03oh^;Rom3@d?ooooo00;ooooo00?ofm_K
obDU9Onc/k<0:Oooool03onk^k_o_;bloiNGUomnPY7oB5jFoam?Xol:D[So4EVhobYPYOm4I8coIFeg
oh20P?nIVIWof=SHonc/k003onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`0?
ooooo`0@ohB6RomjQj3om?3/of1o[?oDg>;o[[G9oaM4U_m9LZgoEX2coeV3]OmJQ;KoFhJgoe=l/?n=
[LGoR;WWod]US@Kooooo00?o7QhNojJVY_ooool00_ooool03Oojn_[o0`<3ojRXZ?olo?co61PHonGU
iOooooooQhN7ogIfM_ooooooo_knoa8B4_nd];@01?ooool01?lW9bOo/;2`of5QHOmNGUh3ooooo`06
oc<c<onUYJGoooooon3Ph?l20P;obl_;0_ooool01Ol/;2coQ8B4oooooolW9bOoPX:200;ooooo00?o
IFEUof][Joooool0ooooool]ooooo`06of][JomMGEgol_;bomCDe?lG5aOo>CTi0oooool00oofm_Ko
8B4QooknoP04ooooo`03ohZ:R_m=CDgooooo00Gooooo00?oh>3PoadM7Oni^KT01?ooool01oofm_Ko
8B4Qookno_oooooob/[:o`000?olo?`00_ooool00onFUYKo<S8booooo`03ooooo`03on3Ph?lM7Ago
^KVi02Sooooo00Co^[Zjom3@d?o2`/;oTi>C0_n8R8P00on5QHGoOgmoogmoO`02ogmoO`04oifMWOoI
fMWomoOgonk^kP?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo00oooooo00Wo
QHN<ogF5WOn^^<Oo<5JJoh^G]omLKj;o:eRRoeb4]OmIP[D00_mJQ;H01OmMQ[OoCGR`oh^O^onT_n3o
CfVA00Kooooo00?o7QhNojJVY_ooool00_ooool02Onm_Kgo0000ol;2`_ooooooO7aloc`l??n6QXKo
7AdMolC4a002ooooo`04odi>C_mQHF7oTI6AoiBDU0;ooooo01So9bLWok6a/Oojn_[oADE5oh20P?oo
oooo/k>coaTI6OmADE7oOgmooogmoOmgMgOo7QhNoh:2P_m5ADGo:2PXoo7alOoooooo9bLWodi>C_m:
BT[oDe=Co`D51Oo0`<3oooooobgooooo00?on_[joa0@4?o7alL00_ooool00om[Jf_oBTY:ooooo`03
ooooo`03ode=COo:b/[ooooo00?ooooo00?oRXZ:ode=COooool01_ooool00on][Jgo51@Doogmo@04
ooooo`06ode=COo:b/[oooooonCTi?l0003okNg]0_ooool00on7QhOoC4a<ooooo`04ooooo`03ojf]
[OlD51CooOgm02Oooooo00oo_;blom?Cdoo^k^kod=3@ojFUYOnFUYKoRXZ:oh61POn:RX[oW9bLokfm
_Oo^k^koo?cloo[jn_o_knl00oo^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool0
3oooool04?n6R8coLH2Loi>T`?lYAI7oMX:^ofn6/_lWEYooDgbaoe^4]_mJQ;GoFH>eoe^4]_m6Kj_o
AfnWodEd/om7GXL6ooooo`03oahN7_nVYZKooooo00;ooooo00?oJFUYoaLG5oodm?@00_ooool00onf
][KoRXZ:olS8b003ooooo`04ooGemOn`/;3oRXZ:okbl_0;ooooo013o9bLWok6a/OoooooolO7aoj>S
XoogmoOob<S8ob0P8?mYJFWoXZ:Rookno_oooooo`L71ohb<S?nTY:ComOGe0_ooool01Ona/K7ohn?S
ol?3`on=SHgobLW90?oooooo;_ooool00oomoOgo2@T9ol[:bP02ooooo`03od10@?mfMWKooooo00?o
oooo00?oVYZJogemOOooool00oooool00on:RX[oCDe=ooooo`06ooooo`03on?Shol0003ohn?S00Co
oooo00KoVYZJogemOOoooooooOgmoahN7_nk^k/2ooooo`03oeIFE_n3Ph?ooooo00Cooooo00?ohn?S
o`000?oShn<09oooool03onj^[[odM7Aoo;bl_obl_;og]kNom;Bd_oHf=SogmoOonGUiOo/k>com?Cd
oo_knoono_kon_[jono_k`03onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`0?
ooooo`0:ohJ8S?n7U:Goo?__oc9<T?oAe]go^L7:oc9NX_m5Kj_oCgR_oeN0/`;oFH6d00Co;EROoinc
a_njhO_oCFNA1_ooool01olN7QkoOGemok^k^onRXZ;oGUiNo`d=3On`/;003oooool00olW9bOo/K6a
ooooo`04ooooo`03ohj>S_o8b<Sooooo0?oooooo??ooool01_mYJFWoEEEEonCTi?nMWIgo3Ph>omoO
g`Cooooo00SoiNGUoc4a<OooooooooooomgMgOmcLg?oF5QHode=C@Cooooo00GoTI6Aokno_oo/k>co
LW9bocXj>P05ooooo`0:onGUiOla<C7ooooooooooonCTi?o?cloon_[jonm_Kgo6ATIonWYj@;ooooo
00GoTI6Aokno_oo/k>coLW9bocXj>P0Xooooo`0?ok^k^ooBd];ol_;booOgmoofm_Koj^[ZomcLg?oQ
hN7oj>SXonk^k_oemOGono_kookno_ojn_[okno_00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03
ogj]fOoooooooooo00oooooo00SoQhV<og>3WOmaR[Go74NEodIYYOm0IZGo@6^]odag/@;oBGB`00Ko
CGNbod=^[OlYEj?oDg>Zof:3]om9Hh`6ooooo`06ofQXJ?mCDe?oDe=CofEUIOn8R8Sog=cL4?ooool0
0olW9bOo/K6aooooo`3ooooood?ooooo00Gon?ShogMgMol];BgoATI6olK6aP06ooooo`07ofm_Kooe
mOGoooooooKfm_nXZ:SoJFUYog1`L004ooooo`05ojNWYomIFEWo;bl_og9bL_oHf=P01_ooool02?m_
KfoomOGeooooooooooooSHf=oc8b<_m:BT[oclo?0oooool01OnWYjOoFEUIobl_;ombLW;of=SH02So
oooo00oo^k^kom?Cdoobl_;on?ShooWinOohn?Sojn_[on7QhOoXj>Sokno_ooKfm_okno_ooOgmoo[j
n_o_knl00oooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_ooool03oooool04?n8RHco
IWJ@od=SUol`DH[o:Df:oc1CSOlnGY;oB6RFode]VOm<K9WoB6RFocAGS_l`DXco;e><oc=FTom:G7hL
ooooo`03olW9bOo/k>cooooo0?ooooooW?ooool03onf][Kod=3@oo7alOogmoOon?ShooOgmooXj>So
g=cLon;Rh_oVi^Kok^k^ooCdm?ogmoOom?CdonSXj003onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H0
0omn[MWoi^KVooooo`0?ooooo`0@oiJFU_nHX;GoN9KPonCVj?oVj>_oi^SZonKWj_oVj>[oinS[onOY
jooWj>[oi^SZonGWj_oTi^Woj^_^ojRYZooooooo^oooool03onc/k?oc/k>ono_kooalO7ojn_[omoO
gooEeMGoemOGomgMgOoTi>Coj^[Zoo3`l?oclo?ol?3`onGUi@03onKViP7oOZgI0OoVi^H1onKViP00
0oo^k^h00omn[MWok^k^ooooo`0?ooooo`04olW9bOnJVigoRhjEoiFEUP_oUYJF00?oXJ6Qoooooooo
ool0ooooooniooooo`0?ojn_[onZZZ[o_;blok>c/on^[Zko[jn_okNg]onm_Kgo`/;2olS8b?o>c/ko
dm?ComKFe_oCdm?ob/[:00?ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOooooooPX:20?oo
VIVILonIVIT00oo`l?3oPX:2oiVIV@1RoiVIV@03oo3`l?n2PX;ooooo017ooooo0Omn[MT1ooooo`7o
oooo0003onk^kP03ogj]fOo^k^kofMWI0?ooooooLoooool00oo`l?3ofMWIooooo`1Rooooo`03oo3`
l?oIfMWok^k^017ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^KofMWI0?ooooooLooo
ool00oo`l?3ofMWIooooo`1Rooooo`03oo3`l?oIfMWoi^KV017oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kofMWI0?ooooooLoooool00oo`l?3ofMWIooooo`1Rooooo`03oo3`l?oIfMWo
k^k^017ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooof=SH0;?oo_kn00Cok>c/ookn
o_ono_kojn_[3oono_h00ooZj^[omOGeooknoP2YooknoP03oo3`l?oHf=Soo_kn01Coo_kn00Cok>c/
ookno_ono_kojn_[0oono_h00ooinOWojn_[ooknoP02ooknoP03on[Zj_oemOGoo_kn01;oo_kn00?o
i^KVooWinOono_h00oono_h00ooemOGol?3`ooknoP0@ooknoP03on[Zj_oemOGoo_kn00?oo_kn00?o
mOGeoo3`l?ono_h02oono_h00oo`l?3of=SHooooo`0Aooooo`7oOZgI0Oooool1ooooo`000oo^k^h0
0omn[MWok^k^omKFeP2Yoogmo@0BoadM7OoAdM7ooOgmoogmoOokno_o>3Phoclo?oomoOgomoOgocLg
=olE5AGo<c<cogEeMOlF5QKoc<c<oogmoOlV9RKo[jn_0_omoOd03?l=3@goa/K6oogmoOoclo?o0000
omoOgoomoOgoc/k>ob/[:olD51Co;2`/od];BjWooOgm00?ol?3`omKFe_omoOd02_omoOd01_lM7Ago
30`<oa<C4olF5QKo?Cdmok>c/`;ooOgm017omoOgocLg=olE5AGo<c<cogEeMOlF5QKoc<c<oogmoOnd
];Co61PHocTi>OomoOgoc/k>ob/[:olD51Co;2`/od];B`06oogmo@05oadM7OoAdM7ooOgmokno_on/
[:`00_omoOd02?lB4Q;oaLG5oogmoOnn_[ko6a/Kob@T9?l92@WoN7Qh0_omoOd01_nBTY;o0`<3o`l?
3omWIfOo>c/koiRHV0;ooOgm00Go9RHVojn_[oomoOgoGUiNogMgM`02oogmo@08obHV9_n_[joooOgm
olk>c_l[:b_o51@Dob`/;?m;Bd/2oogmo@06oi:BT_l30`?o3`l?ofMWIolk>c_oV9RH2OomoOd00oo`
l?3oe]KFonk^kP0Aonk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVom3@d02YooOgm`0>
oadM7Oo<c<comoOgooOgmon;Rh_o0000ochn?_ogmoOo[:b/oaXJ6_oclo?of=SHobPX:?n4Q8@2ooOg
m`0@obDU9On[Zj_omoOgooOgmol=3@go`L71ooOgmoo]kNgo0000omWIfOo_knoo820PogQhN?oclo?o
moOgono_kjWomoOg00?ol?3`om3@d?ogmoL02_ogmoL03_lM7AgoX:2PooOgmooalO7o/[:boaLG5onC
Ti?omoOgojb/[?lJ6Q[olo?comSHf?lX:2SoQ8B40_ogmoL02Om:BT[oOGemooOgmoo_knoo820PogQh
N?oclo?omoOgono_k`06ooOgm`0GoadM7Oo<c<comoOgobLW9ol820SojNWYooOgmolB4Q;o`<30on_[
jolF5QKoS8b<ooOgmooJf][o4a<CojFUYOoemOGo51@DoiJFU_ofm_KoZ:RXo`h>3_nEUID00_ogmoL0
1OlU9BGoZj^[ooOgmomLG5coM7Ad00;omoOg013o9BDUoj^[Zoo_knoo820PogQhN?oclo?omoOgono_
koogmoOomOGeoa@D5?nFUYKom_KfojRXZ?l>3PkoUIFE2OogmoL00oo`l?3od=3@onKViP03onKViPSo
00001_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_o:b/X0ZOobl_803_lL71cob<S8
oo;bl_oBd];o2PX:oe9BD_lm?Cgol_;bolo?col<30coYjNWonc/k?m0@43oS8b<0_obl_803OlU9BGo
YjNWoo;bl_obl_;o3@d=okfm_Oobl_;oj>SXo`000?oEeMGo^[Zjo`P82?oRh^80[?obl_800oo`l?3o
b/[:oo;blP0:oo;blP03oa`L7?nMWIgol_;b00;ol_;b00WoO7alo`l?3ooUiNGoclo?o``<3?nWYjOo
k>c/od10@?n<S8`00_obl_801_l`<33oW9bLoo;bl_nj^[[o20P8on;RhPWol_;b00co71`LolS8b?o3
`l?o1PH6oeQHF?nCTi?ol_;boa8B4_nl_;co][Jfo`410OoQhN42oo;blP05odi>C_mLG5co_knoo`@4
1?oZj^X00_obl_802Oli>CWoTY:Boo;bl_obl_;o9BDUojNWYoobl_;oFUYJog5aL@02oo;blP05obDU
9OnWYjOo^[Zjo`P82?oRh^801?obl_800ono_koo10@4on[ZjP02oo;blP03ocTi>OnBTY;ol_;b00So
l_;b00?ol?3`ol[:b_o^k^h04Oo^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooo3`l<0
ZOoYjNT01olK6a_o`<30onWYjOlm?CgoATI6oj6QXOlk>c/00_oYjNT01Oo5aLGoQHF5oeQHF?lD51Co
QhN700;ojNWY00co8b<Soj6QXOoYjNWojNWYo``<3?nf][KojNWYomoOgol0003ocLg=ok2`/?l20P82
oahN7P03oa@D5?l`<33ojNWY0:SojNWY00?ol?3`ol?3`ooYjNT02_oYjNT00olK6a_oUiNGonWYj@02
onWYj@09ok^k^ol0003o];BdonWYjOo5aLGoQHF5oeQHF?lD51CoQhN700;ojNWY00Go;Rh^oiJFU_oY
jNWo/;2`o`820P02oahN7P03oa@D5?l`<33ojNWY00GojNWY00co6a/Kol30`?mYJFWoBd];okVi^Olg
=cOojNWYoa4A4One]KGoXj>So`X:2_oVi^H2onWYj@05oemOGom<C4co^k^ko`T92OoUiND00_oYjNT0
2Olg=cOoS8b<onWYjOoYjNWo8b<Soj6QXOoYjNWoEUIFofe]K@02onWYj@04ob<S8onQXJ7o/;2`o`82
0P;o7QhN00Ko51@Doc0`<?oYjNWo^k^ko`T92OoUiND2onWYj@03ocLg=on<S8cojNWY00SojNWY00?o
l?3`ol?3`oooool01?ooool6o`0000Oooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
_Kfm0:Woh>3P00Oo6QXJokVi^On8R8So3@d=olW9bOnKVi_o>CTi00Goh>3P01Co<S8bohZ:R_oPh>3o
h>3Pob8R8_mMGEgoh>3PomgMgOl61PKoLW9bon3Ph?o>c/ko0000ol[:b_oMgMgo5ADEolW9bOoPh>3o
MWIfofMWIjWoh>3P00?ol?3`okfm_OoPh>002_oPh>000olJ6Q[oTI6Aon3Ph002on3Ph003om_Kfol2
0P;oTi>C00Coh>3P00go<S8bohZ:R_oPh>3oh>3Pob`/;?n@T93oh>3PomgMgOlE5AGobLW9on3Ph?mf
MWKoIfMW00Koh>3P00co6QXJokJf]_lE5AGoV9RHon3Ph?lT92Co`/;2oa0@4?n^[Zkoa<C4o`410Onb
/[82on3Ph005obHV9_mcLg?ogmoOoaDE5Onb/[800_oPh>002Ol_;booQXJ6on3Ph?oPh>3o8R8Roi^K
VooPh>3oDe=CofUYJ@02on3Ph00<ob8R8_nKVi_ogMgMoaDE5Oo9bLWoh>3PogIfM_mWIfOoh>3PomoO
golE5AGo/[:b0_oPh>000ol_;booQXJ6on3Ph008on3Ph003oo3`l?nm_Kgok^k^017ok^k^0Omn[MT1
onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko[jn_0:WofMWI00Oo6ATIoibLW?l<30coPh>3omWIfOnF
UYKo=cLg00;ofMWI00GoA4A4of=SHom^KVko1@D5ol?3``02omWIf@06ob4Q8Om6ATKo?Shnodm?ColA
4A7oIVIV0_m4A4@02?lT92CofMWIomWIfOmYJFWo<c<cog9bL_lH61SoYZJVZOoIfMT00oo`l?3o[jn_
omWIf@0:omWIf@03oaTI6On=SHgofMWI00;ofMWI01CoX:2Po`000?nUYJGofMWIodA4A?mSHf?oKVi^
o`D51Oo3`l?ofMWIoiRHV?lE5AGoA4A4ofa/K?oGemOoJFUYoc<c<ombLW;o61PHojJVYPKofMWI01Oo
6ATIogUiNOl>3Pkodm?ComWIfOmbLW;oK6a/oa0@4?nYZJWofMWIofEUIOlI6AWoKVi^ocXj>_lR8R;o
cLg=omWIfOmXJ6So5aLGofi^K_l];Bgo3@d=oh>3P`02omWIf@0?ob4Q8OnFUYKoWinOobLW9olb<S;o
K6a/olc<c?lQ8B7oUYJFomWIfOmYJFWo<c<cog9bL_lH61SoYZJV00;ofMWI00KoJ6QXoaLG5om^KVko
;Bd]o`d=3On3Ph<9omWIf@03oo3`l?n_[jooi^KV00Goi^KV1?l00008onKViP7oOZgI0OoVi^H1onKV
iP000oo^k^h00omn[MWok^k^ojZZZP2YomCDe003oaPH6?lQ8B7o=cLg00;oe=CD00SoTi>CocHf=_oD
e=Coe=CDokjn__n?ShooNWYjokBd]0?oe=CD00WoTi>Cokbl_?nWYjOoN7QhokBd]?oDe=CoWIfMogal
O?o0`<000ooDe=@00onGUiOoLW9bojJVYP2ZomCDe003oo3`l?nZZZ[oe=CD00[oe=CD00?o61PHohZ:
R_oDe=@00_oDe=@02?mGEeOo4a<Col[:b_oDe=Co_[jnohn?SomjNW[o];Bd0_oDe=@02OnVYZKo6QXJ
oeMGEon6QXKodm?ComCDe?nGUiOoLW9bojJVYP07omCDe003oaPH6?l[:b_oDe=C00;oe=CD00Co_;bl
oadM7Ol>3PkoYJFU0_oDe=@01?nPX:3oM7AdohR8R?o;bl/3omCDe005oiFEUOmeMGGo[:b/oc8b<_n0
P8000_oDe=@02OnCTi?o_;bloj^[Zola<C7o?cloohJ6Q_o:b/[oTi>Cokbl_002omCDe003oiNGUomb
LW;oYZJV00Coe=CD00GoUIFEogEeMOn/[:co<S8boh20P009omCDe003oo3`l?nZZZ[ok^k^017ok^k^
0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo/;2`0:Wof=SH00?o6ATIo`T92Onl_;`00_oH
f=P00onEUIGo=cLgomSHf031omSHf003oo3`l?n`/;3of=SH00[of=SH00Oo6ATIofUYJOnNWYkoRHV9
odm?Col;2`_oUIFE00Wof=SH00?oN7QhojVYZOoHf=P03?oHf=P00olI6AWo0000oj>SX`03omSHf003
ocTi>Ol0003oZ:RX00cof=SH00Wo<c<coh:2P_oHf=Sof=SHogmoOong]kOof=SHofUYJOmHF5P00_oH
f=P00omoOgoo]kNgomSHf00;omSHf003oc<c<on2PX;of=SH00Sof=SH00?ol?3`ok2`/?ooool01_oo
ool2o`0000Wooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko/k>c0:Wog=cL00?oFEUI
oh^;RooLg=`00_oLg=`00on^[ZkoKFe]omcLg031omcLg003oo3`l?nc/k?og=cL00[og=cL00KoFEUI
odM7Aom7AdOoEeMGogEeMOnm_KdIomcLg003oeUIFOmADE7og=cL00?og=cL00?oWIfModM7Aonk^k/0
3?oLg=`03Old=3CoQ8B4omcLg?oLg=coGUiNojj^[_oLg=co/;2`oaLG5omUIFGoLG5aoeiNG_n^[Zh0
3?oLg=`00old=3CoQ8B4omcLg008omcLg003oo3`l?nc/k?ok^k^017ok^k^0Omn[MT1onk^kP7ok^k^
0003onKViP03ogj]fOoVi^Ko];Bd0?oog=cLLooLg=`00oo`l?3o];BdomcLg00nomcLg003ok6a/Oo6
a/Kog=cL00Gog=cL00?obl_;oi6ATOn`/;003_oLg=`00ona/K7oa/K6omcLg008omcLg003oo3`l?nd
];Coi^KV017oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko/K6a0?oofMWILooIfMT0
0oo`l?3o/K6aomWIf@1RomWIf@03oo3`l?na/K7ok^k^017ok^k^0Omn[MT1onk^kP7ok^k^0003oooo
o`03ogj]fOooooooYjNW0?ood=3@Loo@d=000oo`l?3oYjNWom3@d01Rom3@d003oo3`l?nWYjOooooo
017ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^koUiNG0?oo_[jnLonn_[h00oo`l?3o
UiNGokjn_P1Rokjn_P03oo3`l?nGUiOok^k^017ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]
fOoVi^KoUIFE0?ooUIFELonEUID00oo`l?3oUIFEoiFEU@1RoiFEU@03oo3`l?nEUIGoi^KV017oi^KV
0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kok^k^0?ook^k^k?o^k^h1ogj]f@7ok^k^0Oo^
k^h000?ooooooomn[MW`ogj]f@;ooooo003oonk^k_Gok^k^003oonKVi_Goi^KV003oonk^k_Gok^k^
003oooooooGooooo003oonk^k_Gok^k^003oonKVi_Goi^KV003oonk^k_Gok^k^003oooooooGooooo
003oonk^k_Gok^k^003oonKVi_Goi^KV003oonk^k_Gok^k^003oooooooGooooo003oonk^k_Gok^k^
003oonKVi_Goi^KV003oonk^k_Gok^k^003oooooooGooooo003oonk^k_Gok^k^003oonKVi_Goi^KV
0005onk^kP08ong]kOo[jn_ohn?SomKFe_o7alOo_KfmokJf]_ne]KFhokBd]008okFe]Onf][Ko_Kfm
olO7aooFe]Kohn?Son_[joo]kNgoonk^kRSok^k^0005ooooo`08oogmoOodm?Cog]kNokbl_?nLW9co
QXJ6og]kNomgMgNhogIfMP08ogMgMomkNg_oQXJ6oibLW?nl_;cog]kNooCdm?omoOgoooooobSooooo
0005onk^kP06onSXj?oFe]Ko[jn_oiVIVOnh^;Soi^KVZoooool00onFe=oo_?Gookceo`02okceo`03
ok_doonlmOoo_?Go00Ko_?Go00Wo^oCookSaoon_j_ooV]3WogZP__mkRico[jn_omKFe_oXj>P0ooo^
k^hXonk^kP001OoVi^H01OoLg=co`L71oijNW_o?cloooOgm0:cooooo00KoVm[Ook_doonjlOoo_?Go
okoioonlmOl7okgfo`;o_oWo00So^oCookC`oonZioooUMSoofnTg?mjRioo`L71omcLg?ooi^KV:?oV
i^H000Gok^k^00GohN7Qokfm_Onc/k?olo?cooknoP2/ooooo`03oi;>gonil?oo^_7o00;o^_7o00Ko
^>oook[aoonil?oo^_7ookW`oonhkol2okK^o`;o^>oo00So]>coojkYoonXi_ooUMKoogVmoomMQkKo
_Kfmon7QhOook^k^:?o^k^h000Gooooo00GolO7aolC4a?o>c/kolo?coogmo@2/ooooo`03oi7<gond
j_oo]>[o00[o]N_o00[o/nWookG[oonajOooZnGooj?Poon@d?ooMk[oodn?e?o4a<ColO7aoooooolX
ooooo`001Oo^k^h01_oPh>3o]KFeom[Jf_oalO7onOWioogmo@;oo_kn1?ooool2ooknoP0>oogmoOok
no_oo?clooShn?oXj>Sofm_KomSHf?oIfMWohN7Qoo?clookno_oo?cloogmoOooool3ooknoP03ohj>
S_m/K6co`<3000;ooooo1?ono_h4ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn
1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn
1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn
1?ooool4ooknoP03oooooon:`moo/NGo00;o/NGo00Co[nCook7Uoon_i?oo/NGo1?n_i?l02onaiOoo
[^?oojkUoon^hoooYn7ooicHoon=cOooM;SoodB=g?ne]KGoh>3P0?ook^k^:?o^k^h000Goi^KV00Go
f=SHojj^[_oIfMWok^k^ooGem@02oo_kn`03oogmoOokno_ono_k00;ono_k013ooOgmooclo?oinOKo
g=cIojj^[_nYZJWoWYjNohR7Qon5Q8CoQXF4oiVIUonZZZSoZZZZokjn__o^k^kon?Sh0_omoOd01_on
o__oOWimoibLW?lJ6Q[o];Bdoo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_on
o_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_on
o_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_on
o_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_on
o_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/4oo_kn`;ooOgm0_ono_/00ookno_oPK[Ooj_P
o`02oj[Oo`04ojcQoonZgooo[>7ooj[Oo`Co[>7o00_oZ]ooojSOoonXg_ooY]_ooikEoonHe?ooR<Oo
off_n?m2R]_o[Zj^omSHf03oonKViRSoi^KV0005onk^kP07on3Ph?nd];Cof=SHon_[jooemOGom_Kf
ooShn003ooWin@?on?Sh00oom_Kfong]k_nVYZOoYjBPojj]Zon/ZJSoWH=_ojYgC_nIKdcoWYF>ojj/
Zond/[3oQXF2om[Jf_obl_800_oinOT2ooShn@04ooWinOmKFe_oJf][ooShn0;onOWi0_o[jn`2ooWi
n@;on?Sh00ConOWionKVi_ofm_Oon?Si0_o^k^h2ooShn004ooWinOoOgmoom_KgooShn@;onOWi00Co
iNGUonSXj?oinOWonOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si
0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si
0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si
0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si
0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si
00KonOWiogjegonWfoooY=SoojKJoonUf_l:ojCIo`08oj3FoonKdoooT<Wooh?1oomYZ_7o?XKFokBd
]?oPh>3oonk^kRSok^k^0005ooooo`08oo3`l?o1`L7oeMGEonWYjOoclo?om?CdooKfm_oemOD4ooKf
mP0@ooGemOodm?Cokno_ojNWY_o>bL?oo?SfoocknonhT73o_60Nok=W;_oRelkoo_ckoo_inOn?S8Wo
g]kNoo?cl`ComOGe00[om_Kfofe]KOm8B4Som_KfooGemOlS8b?o3`l?oahN7_m:BT[okNg]0_ofm_H0
4_m=CDgo1`L7oaPH6?nEUIGo4Q8Boe=CDoofm_Kobl_;ob<S8olL71co/[:booGemOoCdm?o<c<co`d=
3Ol;2`_o=SHfom?Cd`;omOGe1?ofm_H4ooGem@Com_Kf1?oemOD4ooKfmPComOGe1?ofm_H4ooGem@Co
m_Kf1?oemOD4ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD4ooKfmPComOGe1?ofm_H4ooGem@Co
m_Kf1?oemOD4ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD00oofm_KoO[GOoj3Fo`06oj3Fo`03
ohnoi?lL9BgoSkoT00GoX=Ko00OoVm?ooi39oon3`OooJJ[aocj6e_o1`L7ol?3`0?oooooo:?ooool0
00Gok^k^00Ooh>3PokBd]?oDe=Coi^KVoo3`l?oclo?olO7a00Oom?Cd00gol_;bojZZZ_o9a;ookNOW
oncZjon]RVko_W<jojaZ=ooEb/?ok^[YooG`kOn=RhSohn?S00?om?Cd0_oclo<00oodm?CoKFe]odM7
A`02ooCdm00<okNg]oo_knool_;boc<c<on;Rh_om?Cdokfm_Ol30`?odm?Com_KfomFEUKo410@0_od
m?@01om/K6co?Shnoo?clooclo?ol_;boc4a<Om>CTh00_oShn<01?mADE7o<S8boo;bl_oclo<6ooCd
m0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCd
m0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCd
m0;olo?c1_odm?@2oo?cl`04ooCdm?mg[mooW]?ooigBo`GoW]?o00?o@EIYo`000?m1EVT01?nNdol0
2?nJcoooTlcoohS0oOmk^?WoHZG^ocMocond];Coh>3Pooo^k^hXonk^kP001OoVi^H01ooHf=So[Zj^
omCDe?oVi^Kol?3`oo?clooalO401oodm?@03Ooclo?oZjZZolBn]oo_j>SokN_/oj5mI?nRBQSoV50U
omK>b?o^jnWom>k/ohV7Q?oTi>@00oodm?@2oo?cl`03ooCdm?m]KFgoAdM700?om?Cd00_olo?cok^k
^olE5AGoS8b<ooCdm?o?cloo0P82okBd]?oclo?oUiNGoahN7P02ooCdm007odU9BOm]KFgom?Cdoo?c
loo=cLgo0000ojn_[`02ooCdm004ojn_[ol0003odM7Aoo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_od
m?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_od
m?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c00?o
m?CdoffUgonGc?l00_nFb_l3oiG9o`0@ogRRc_lJ8bgo0000oaXS;OmhX/koULWooiK:oonBaokoS/?j
ohc3o_n2^oWoL[7doeRKi?l`NLWo[Zj^omSHf?ooi^KV:?oVi^H000Gok^k^00Ooh>3PokBd]?oCdm?o
i>CTonk^k_o_knool?3`00SolO7a00coZJVXokbe[_o[inOok>[XofeEA?mX:P_oGC0Dolo7`?oZi^Go
l>_YohB1OOoQhN46oo7al@09of][Jom6ATKolO7aoo7alOoGemOoADE5o`820_mZJV[oj>SX00;olO7a
00GoXj>Sobl_;ol`<33o<c<coahN7P02oo7al@07odQ8B?m[Jf_olO7aoo7alOnc/k?o0000omWIf@02
oo7al@03omOGeol0003o][Jf07;olO7a00SoI9cFohk2nOn>`o[oSL7hohk2nOn>`o[oS/;iob<`?@?o
000000co8blmohk3n_n>`o[oRkofohRmmOn1^OCoNK7^ofZWj_m@Tm_o:Fo3okBd]?oPh>3oonk^kRSo
k^k^0005ooooo`06oo3`l?o1`L7od=3@on7QhOoYjNWok>c/0_o^k^h2oo3`l0?okno_00ook^k^om[J
f_n=S8_o]:fUon3Kf?oUhMoo`KbfoijFRon]YI_oi>;OomWCc_oQfmCoOg]golK6a_o/k>`01?o_knl0
0oo`l?3oJf][odI6AP02ono_k`03oc`l??lm?CgocLg=00;ol?3`1?o_knl01oo]kNgoRXZ:oalO7oo`
l?3okno_odQ8B?mZJVX00_o_knl00oo>c/ko0000ojVYZ@02ono_k`04ojJVY_l0003odM7Aono_k`;o
l?3`1_o_knl2oo3`l0Kokno_0_o`l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`l?06ono_k`;o
l?3`1_o_knl2oo3`l0Kokno_0_o`l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`l?06ono_k`;o
l?3`1_o_knl2oo3`l0Kokno_00?ol?3`oe^Bcon4^O400_n7^o@2ohBil@03oeYnY?l0003o000000?o
000000_oFWjTohJjlOn3^O7oOkG^ogVajom`Z^WoH9oSodJ:eOlPJ;go`L71oo3`l03oooooobSooooo
0005onk^kP07on3Ph?nd];CocLg=omcLg?oUiNGoinOWonWYj@03onc/k0;oj^[Z013ok>c/onOWionO
Wj7oIF9PokBXV?o=a[ood<Fnoj5nJ_nCN6GoUWEOokNOT_o:aKkoa[VYog9^Ion7QhSog]kN0_o/k>`2
on_[k00:onc/k?mYJFWoA4A4on[Zj_o/k>co<S8bohZ:R_o[jncoe]KFonOWi`;oj^[Z01;oYZJVolW9
bOoXj>WoFEUIode=COo/k>coi>CTod92@_mTI6CohN7QonOWj?o[jnco?3`lod92@_o;bl_ob/[:od51
@Oln?Sh2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z
0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z
0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z
0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z
0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/k>`2on[ZjP;ok>c/0_o[jn`01?o/k>coDh[6
ogbajOmk[nL2ogbaj@03ogNZh?lC6bCo000000Co000000_o4a/TogJXh?mg[nWoLj_VoffUhomRW]ko
EI?Hoc]nc?lFGkCo];Bdon3Ph03oonk^kRSok^k^0005onKViP08omSHf?n^[Zkoa<C4omKFe_oPh>3o
iNGUonKVi_oUiND5onOWi`0?onKVi_o9bLWoLg=cofYUG_o5`;Co/i:4ogX`7_oJi>OoWWmeoh0g8oo@
bkooLFQMoe9@Cond];Cohn?S00GoinOW00WoM7AdoeEEEOoWinOoinOWojf][Old=3Co3Ph>oa4A4OoB
d]800_oWinL03_mmOGgo;Bd]o`h>3_lc<c?o/K6aonOWiombLW;o1`L7o`X:2_lH61SoW9bLonKVi_oA
dM7oBDU90_l=3@d00om;Bd_od];BonKViP18onKViR[oinOW00KoCX?0ogN/i?mgZn?oMj_SogFZh?lm
F7D7o`00000:oceIM_mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko[Zj^omSHf?ooi^KV:?oVi^H0
00Gok^k^00Soh>3PokFe]Oo4a<Coe]KFon3Ph?oUiNGoi^KVonGUi@KoinOW00goiNGUol[:b_m^KVoo
KF]Tojn>NOmd<A_ogMG>oiehJOn6@bOoPgiboeQEDomeLVkoemOG00coinOW00?oi>CTonOWiooWinL0
1?oWinL01ooUiNGoinOWonOWiooWinOoi^KVodE5AOmVIVH01OoVi^H2onGUiD_oi^KV:_oWinL02?m>
Pl3oMjcTogN[homgZn?oMJ[PogJZhOmeZ^3oMZ[Q1?meZ^002omfZ^7oMJ_Tog>XhOm_Y]ooJJ;KoenJ
f_m?SM?o<7G4o`eE[_ne]KGoh>3P0?ook^k^:?o^k^h000Gooooo00Sol?3`ol;2`_o4a<Coe]KFon3P
h?oUiNGoi^KVonGUi@OoinOW00coiNGUolO7aom^KVooGeI=oiZ2Jon[TWKoYXaaof=CA_m>BTGo^K>[
ogmlMooIfMT6onOWi`03ogUiNOmKFe_oinOW00koinOW00?oi^KVol[:b_o8b<P0D_oVi^HZonOWi`08
odj3`?mg[>CoMj_SogN[homeZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_o
Gi[Jodn=dol`MLCo3EF^ol;2`_o`l?00oooooolXooooo`001Oo^k^h01_oPh>3o][Jfokbl_?o@d=3o
gmoOonCTi0;oiNGU2?oVi^H02ooTi>Cob/[:og=cM?mLEdkoWi9hofUSEOmJFU[oQXF3oj^SVOmmNGGo
f=SH00Koi^KV00?o];BdojFUYOoVi^H0SOoVi^H01?mOTL?oPZoPoh6^gon3/N09oh:_g`0:oh2_gomo
[MkoOJcNogBUf_m^X][oFiC@obI/_Ol1AjGo][Jfon3Ph?ook^k^:?o^k^h000Goi^KV00Kof][JokNg
]onc/k?oa/K6on3Ph?oWinL2onWYj@Woj^[Z00[ojNWYom7AdOmhN7SoCTY6oeeMGOnl_;co^;RhohJ3
Oon;RXSoh>3PU_oZj^X01On9[MCoX/;Uoj;3i_nR`^GoX/?U00?oX/?V00ooX/?Uoj32iOnP`^GoX<;U
oj;2i_nS`nKoWl;Voic0i?nH_>?oT[SOogNUf?lPIkWo03bLokNg]ooJf]X0oooVi^HXonKViP001Oo^
k^h01ooTi>CoalO7oj>SXonj^[[og=cLonOWiooYjNT02ooZj^X02OoXj>SodM7AoiJFUonn_[koi^KV
on?Shoo9bLWof=SHonWYj@2Fon[ZjP09oijlf_nccNWo//gYok?>jOnbcNWo/lkYokC?j_ncc^Wo/lgY
00?o//gY00_o/lkZok?=jOnbcNOo[l[Wojc8i_nUa>CoNjKHo`mDZolC>93oalO7onCTi03oonk^kRSo
k^k^0005ooooo`08ooWinOoVi^KoYjNWojb/[?o>c/kohn?SonKVi_oWinL;onWYj@03onOWiooOgmoo
iNGU09_ojNWY01OoY/7LokW@j_nid>[o^M3ZokS@j_nid>[o^];Zok[@jOnjd^[o^=3ZokS?jOnid>[o
^];ZokW@j_nhcnWo]<kWojo:i_nL_N3oF8k7o`I2Wom=FYWoi^KVooWin@3oooooobSooooo0005onk^
kP08onc/k?oShn?o_knooj2PX?nb/[;ob<S8omKFe_oKfm^YomkNgP05oh^[d?nO`>3oWl3Poio0h?nN
_n000onO`>000onN`>3oWl3Poijoh002oijoh00:oijmh?nL_N3oU[WLoh2Ze_mCR/Ko85R[obHoT?nM
W[Sohn?Sonc/k?ook^k^:?o^k^h000Goi^KV00SoiNGUon?ShooLg=co_[jnojJVY_nNWYkoX:2PojBT
Y:WoXj>S2?lBEZP03olBEZOo4UJXoa9FZ?lBEZ[o4UJXoa1EYol>DJKo3DjSo`]5W_lMA9OoD66NoibN
^?oLg=cohn?SonGUi@3oonKViRSoi^KV0006onk^kP05ong]kOo/k>coj>SXonCTi?oQhN40_?oPh>00
1OoQhN7oi>CTonSXj?o/k>cokNg]0?ook^k^:Oo^k^h000Sooooo0_ono_jnoogmo@;oo_knooooool[
ooooo`00ooo^k^keonk^kP00oooVi^KeonKViP00ooo^k^keonk^kP00oooooooeooooo`00ooo^k^ke
onk^kP00oooVi^KeonKViP00ooo^k^keonk^kP00oooooooeooooo`00ooo^k^keonk^kP00oooVi^Ke
onKViP00ooo^k^keonk^kP00oooooooeooooo`00ooo^k^keonk^kP00oooVi^KeonKViP00ooo^k^ke
onk^kP00oomoOgoeogmoO`0000Cojn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP0KomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oMgMgog=cL00;ogMgM017og]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNgP02omgMg@2^
omcLgOoMgMgogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN0_oMgMd0oOoMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMd00ooNg]h00ooMgMgog]kNomkNgP03omgM
g@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>001ooIfMT01?oHf=Soe]KFom?Cdoo@d=03olg=
c@04om3@d?oCdm?oemOGomSHf0cofMWI00Wof=SHomOGeooEeMGoe=CDom?CdooDe=CoeMGEomOGeooH
f=P03OoIfMT02OoHf=SoemOGomGEeOoDe=Codm?ComCDe?oEeMGoemOGomSHf02EomWIf@Cof=SH1OoI
fMT2omSHf0WofMWI0_oHf=P5omWIf@;of=SH1?oIfMT3omSHf0KofMWI00?of=SHomWIfOoIfMT00_oH
f=PComWIf@?of=SHc_oIfMT00ooHf=SofMWIomWIf@06omWIf@7og]kN0OoVi^H1onc/k00000Ook^k^
onWYjOoTi>Coh>3Pon7QhOoPh>3oh^;R00;ohN7Q00gog]kNomcLg?oCdm?oalO7ok^k^onb/[;o[Zj^
ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00goh>3PomoOgooKfm_oe]KFom;Bd_o>c/koc<c<
olk>c_oBd];oe]KFom_KfooOgmooh>3P00WohN7Q00goh>3PomoOgooKfm_oe]KFom;Bd_o>c/koc<c<
olk>c_oBd];oe]KFom_KfooOgmooh>3P097ohN7Q00?oh>3PomoOgooOgml00_oNg]h00ooOgmooh>3P
on3Ph002on3Ph004omoOgooNg]kog]kNomoOg`Ooh>3P00CogmoOomkNg_oNg]kogmoO0ooPh>001?oO
gmoog]kNomkNg_oOgml3on3Ph0?ogmoO00?oh>3Pon7QhOoQhN400_oPh>06omoOg`;oh>3P0_oQhN4:
on3Ph004omoOgooPh>3oh>3Pon3Ph0;ogmoO00?og]kNomoOgooOgml00_oPh>000ooOgmooh>3Pon3P
h03:on7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoTi>@1onWYj@7okNg]00000oo`l?3okno_oo7al@03
oo3`l00Hono_koo`l?3ok^k^onWYjOoKfm_o`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2
`/7of][Jon[Zj_o]kNgolO7aono_kooalO7okno_oo7akoo_knoolO7a0_o^k^h05?oVi^Kog]kNom7A
dOo9bLOo`L71okno_oo1`L7obLW9om7AdOoNg]koi^KVonk^k?o^k^kolO7aono_kooalO7okno_oo7a
lOo_knoolO7_0_o^k^h02ooVi^Kog]kNom7AdOo9bLWo`L71okno__o1`L7obLW9om7AdOoNg]koi^KV
00;ok^k^09ColO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo^k^kokno]on[Zj_oYjNWoiNGU
0_oWinL01_o/k>cokNg]ono_kOo[jn_oj^[ZonKViP;oj>SX00GokNg]onc/k?o/k>[oj^[Zonk^kP02
ong]k@;oj>SX00Ooi^KVon[Zj?o[jn_okno_on_[jooZj^[oi^KV00;oinOW00_okNg[onc/k?o/k>co
inOWon[Zj_o[jn_okno_onk^k_o`l>kok^k^ong]k@02onSXj00?onKVi_oYjNWoinOWon_[jOo]kNgo
l?3`ono_koo`l?3okNg]onc/k?oYjNWok^k/ong]kOo^k^kojNWY00;ok>c/00_okNg]onWYjOo]kN_o
kNg]onk^k_oYjNWoj>SXonGUiOoYjNWoj^[Zonk^k002onc/k03Bon_[joo_knook^k^oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo`l?3okno_oo3`l?o_knool?3`ono_koo`l?3okno_1?o`l?000003oo;bl_o^k^koinOW
00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9
ok6a/OoAdM7og]kN0_oTi>@02ooUiNGoi>CTonGUi?oTi>CoiNGUon;Rh_oLg=coclo?ol71`Ona/K7o
ZJVX00?oY:BT0;3oZJVYok6a/Oo1`L7oclo?omcLfooRh^;oiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTon;Rh_oLg=coclo?ol71`Ona/K7oZJVYojBTY?nTY:?oY:BTojVYZOna/K7o`L71olo?cooLg=co
h^;RonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGohn?Son;RhOoLg=cof=SHomGEe@;oe]KF
023of][JomgMgOoPh=oofm_KomOGeooDe=CoemOGomWIfOoNg]kogMgMom_Kf_oIfMWog]kNomoOgooL
g=coe]KFomGEeOoFe]KofMWHomgMgOoPh>3ofm_KomOGeooDe=Coe]KFomWIfOoNg]gog]kNom_KfooF
e]KofMWIomkNgP;ohn?S00Coi>CSon7QhOoLg=coe]KF0ooEeMD00ooDe=Cofm_Jon3Ph003onCTi00G
on3Ph?oLg=cof=SHomkNgOoQhN7og]kNomSHf?oLg=cogMgMomcLg?oHf=SogMgLomoOgooMgMgoemOG
omKFe_oEeMGofMWIomcLg?oQhN3og]kNomcLg?oNg]h00_oShn<0b?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
1?oUiND01_oTi>CoiNGUonGUiOoUiNGoj>SXong]k@7ol_;b00000oodm?CokNg]onOWi`02on3Ph00C
on7QhOoOgmoog]kNom;Bd_nd];CoQhN7oeaLG?m]>cGoWTi2ole_GooYPfoocFmOoii>@om]>cKoG5aL
ohN7Qond];Cod];BomkNgP05on3Ph00AomoOgooJf][oc/k>okbl_?n[Zj_o/;2`olO7aooIfMWoi>CT
omWIfOo7alOo/K6aoj^[Zonl_;coc/k>om[Jf_oOgml01OoPh>004OoOgmoof][Jolk>c_nl_;coZj^[
ok2`/?o7alOofMWIonCTi?oIfMWoalO7ok6a/On[Zj_o_;blolk>c_oJf][ogmoO08koh>3P01?ogmoO
omgMgOoJf][oeMGEokZj^_o1`L7odM7Aom3@d?oEeMGoe]KFom7AdOo?cloob<S8ol;2`_oHf=Sof][J
omSHf?oBd];odM7A00;oemOG01;odM7Aolo?coo8b<So`/;2omSHf?oJf][of=SHom;Bd_o>c/kobLW9
ol;2`_oHf=Sof][JomSHf?oBd];oclo?ol71`OoKfm/3omoOg`0OomcLg?oEeMGoclo?ol30`?oAdM7o
c/k>ol;2`_o@d=3ogMgMomoOgooPh>3ogmoOom_KfooDe=CodM7AomSHf?oLg=coemOGom7AdOoDe=Co
f=SHomCDe?oAdM7oe]KFomSHf?oCdm?oclo?olk>c_nn_[koe]KFom[JfP02omcLg004omWIfOoKfm_o
g]kNomoOglOoh>3P00?ogmoOon3Ph?oOgml00_oOgml3on3Ph003on7QhOoWinOok>c/007om?Cd0000
0oofm_Kol_;bon_[j`03onSXj00ConOWiooRh^;ocLg=oinOWom[GeooScH^oneaHOoiWI3ooK6Uoofl
[oom]:OonInConedHonB=booJemOoinOWoo=cLgoh^;RonOWi`04onSXj007onKVi_oMgMgob/[:okFe
]Ono_kooinOWono_k`03oo3`l007ono_kooYjNWo`L71okFe]Oo:b/[ogMgMonKViP05onSXj007onKV
i_oMgMgob/[:okFe]Ono_kooinOWono_k`03oo3`l007ono_kooYjNWo`L71okFe]Oo:b/[ogMgMonKV
iP2>onSXj0;oinOW00KoWYjNo`T92Ol;2`_o820Poc0`<?n@T902om[JfP13ol;2`_m2@T;o0P82oalO
7olD51CoZj^[on3Ph?m^KVko>CTiomgMgOoLg=co`/;2od92@_l20P;o7alOoa@D5?n[Zj_ogMgMom3@
d?mKFe_o0`<3o`l?3olA4A7o/K6aomoOgonWYjOo6QXJoahN7_ni^KWoinOWonSXj?oWinOoi>CTomKF
e_le=CGo2@T9oadM7On7QhOo1`L7ofQXJ?oVi^KoinOWonSXj?oWinOoh^;Roi:BT_lC4a?og]kNonCT
i?oNg]ko2@T9oibLW?oOgmoo/K6ao`000?oAdM7ogMgMomCDe?m/K6co1`L7oaTI6OlB4Q;oL71`onGU
iOoQhN7o0000ok6a/@02onOWim3oj>SX0Oo/k>`1oo;blP7om_Kf00000oogmoOon?ShooShn003ooSh
n00CooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFoo^BQoonYY_oo[6UoonhZoon/jKooZRLoo^DROo^J5Wo
RC4[oi2@T?o>c/kok^k^ooOgm`04ooShn006ooCdm?oWinOoclo?olK6a_oZj^[om?Cd0_oinOT02Ooj
n_[onOWiooWinOofm_Kojn_[olO7aoo?clooinOWooCdm005ooShn006ooCdm?oWinOoclo?olK6a_oZ
j^[om?Cd0_oinOT02Oojn_[onOWiooWinOofm_Kojn_[olO7aoo?clooinOWooCdm02?ooShn00VooOg
moo?cloo^;Rhong]kOo[jn_oTI6Ao`<30oo=cLgoj>SXod10@?ll?3cob/[:onSXj?oNg]koh^;Rono_
komfMWKo?Cdmonc/k?oYjNWo@410oc`l??o:b/[oj>SXomgMgOoQhN7ok>c/ogMgMol;2`_oYJFUooCd
m?oOgmooi>CTono_komDE5CoDe=Coo;bl_ofm_H2ooShn00:ooOgmoofm_KoWinOoa0@4?oJf][obLW9
od92@_l/;2cokno_ooKfmP;on?Sh01WomoOgoo;bl_nMWIgo5ADEonk^k_oclo?ok^k^o`X:2_nXZ:So
kno_okjn__l0003ogmoOonc/k?n7QhOo3@d=ok>c/ooWinOoi^KVomWIfOodm?Com_KfokVi^OoYjNWo
moOg0<[on?Sh00?omoOgooShn?ohn?P00_ohn?P01?ogmoOonOWiooOgmoogmoL1ooShn00000?on_[j
ooGemOo^k^h00_o/k>`08Oo[jn_ojNWYomoOgonj^[[oNE9Boklb9?oWM6WooHUnoonHS?onXYKoojRL
oojTV?ooVXgooXYoonifJ_o3<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>cojn_/on_[jooVi^Kof=SH
ok^k^ooDe=Coi>CTon_[jooalO7ol_;boo?cl`02oo;blP06ong]kOoUiNGoeMGEok^k^ooHf=Soi^KV
0_o[jn/03?o/k>cojn_[on_[jooVi^Oof=SHok^k^ooDe=Coi>CTon_[jooalO7ol_;boo?cl`;ol_;b
00KokNg]onGUiOoEeMGo^k^komSHf?oVi^L2on_[j`2bonc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on[Z
jooYjNWohn?SomoOgooIfMWo`l?3o`000?nTY:Co`/;3o`000?nNWYkofm_KomWIfOoKfm_oh>3Pon?S
hom`L73o>SXjomoOgoo3`l?o0000oinOWooJf][ofMWIom[JfooPh>3ogmoOoaPH6?m=CDgohN7QonKV
i_oYjNWoinOXon;Rh_l_;booNWYjon?Sh`;oj^[Z02Cok>c/on_[k?o[jn_oZj^[o`D51Onm_Kgog]kN
og1`L?li>CWohn?Ton[Zj_o[jn_ok>c/onWYjOoVi^KoU9BDoa@D5?oOgn3oi^KVomoOgol:2P[oWYjN
on?Shond];Co0000om?Ce?oQhN7o9bLWoeeMGOoJf][ofm_KomWIfOoOgmooi^KWonWYjOoXj>P2on[Z
jP;ojn_[0<Gok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k007on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT00003oo_knooc
lo?okNg]00;oiNGU01ooi^KVonCTi?oIfMWo/[:bogT^;_o8@SCohfYLooAjKOomR7cooYN:oojKS_on
V8_ooXYnooAkKOoWJegobT8dog/^;_nb/[;of=SHonCTi?oUiNGoi^KVonGUi_oUiNGogmoOom7AdOnf
][Koe=CDomgMgOoTi>Coi^KW00?ok>c/00Ooj>SXonCTi?oOgmooeMGEokJf]ooAdM7ogmoO00;oiNGU
01Coi^KVonGUiOoUiNGogmoPom7AdOnf][Koe=CDomgMgOoTi>Coi^KVonc/k?o/k>gok>c/onSXj?oT
i>CogmoOomGEeOnf][KodM7AomoOh0;oiNGU09Soi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Kohn?TomoO
gooGemOoe=CDolW9bOm6ATKo1`L7omKFe_nVYZKo0000ocDe=@?o=cLg00SoZZZZomgMgOm]KFgo>CTi
omcLg?nVYZKo0000ocDe=@?o=cLg01WoZj^[omWIfOl0003oNg]komOGeooJf][og]kNomgMg_oJf][o
;Bd]ogMgMooJf][ohN7Qon?ShooUiNGoiNGVonGUiOoQhN7oQhN7obHV9_lb<S;o9RHVocLg=ooOgn3o
i>CT00;oiNGU013ohn?SomkNg_n?Shoo4a<ComGEe_oKfm_oe]KFo`T92OnKVi_ogMgMok2`/?l0003o
clo@omkNg_l;2`_o9BDU0olg=cL01_mhN7Soh>3Qon7QhOoNg]kohN7Qon?Sh`;oiNGU0<Koi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiND2onKViP03onGUiOoVi^Koi^KV00?oi^KV00?oiNGUong]kOodm?@00Ookno/00003ooclo?oh
n?SolO7a00?ok^k^01?ojn_[on7QhOnl_;coNQLGol<o<_oCETWoi6QJonmgK?odPgWon8MlooF4N_oc
NFgoiFUKomUHB_o4?c;oO1LGokbl_?oQhN7ok>c/00?ok^k^00SokNg]onWYjOoJf][o^KViomOGeooN
g]kohn?SonKViP?oj^[Z00Soj>SXonCTi?oNg]kof=SHokVi^OoJf][ojNWYong]k@?ok^k^00SokNg]
onWYjOoJf][o^KViomOGeooNg]kohn?SonKViP?oj^[Z00Soj>SXonCTi?oNg]kof=SHokVi^OoJf][o
jNWYong]kHgok^k^03[okNg]on_[jooTi>Cog=cLoj2PX?lI6AWo5ADEojn_[oo/k>cobLW9o`000?nH
V9So][Jfok2`/?l20P;od=3@onKVi_maLG7o>c/konGUiOo9bLWo0000oiRHV?nf][Ko/;2`o`820_oA
dM7oj^[ZoaPH6?m:BT[og]kNomoOgooRh^;oi>CTon3Ph?l_;booNg]kon3Ph?oWinOok>c/ong]kOo^
k^kokNg]on[Zj_oUiNGohN7QomcLg?mZJV[o>SXjon[Zj_o]kNgok^k^ong]kOo[jn_oiNGUoiBDU?lD
51Cofm_K0_oNg]h02Ol:2P[oXZ:RonKVi_nf][Ko0000omOGeooXj>So9RHVof5QH@02okJf]P08ocHf
=_n:RX[ojn_[onWYjOoVi^Koj>SXonc/k?o]kNg?onk^kP03ong]kOobl_;on?Sh007oo?cl0003oogm
o@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@@ooJHUGohfiRonAbI?oTKf;o
g6AGom=A@oo<@CCo^C@dof/71ooBd];olo?cooclo0CooOgm00OonOWionc/k?nh^;Sofm_Kon7QhOoU
iNGojNWY00;ok>c/00SokNg]on[Zj_oUiNGoh^;Rom_Kfoni^KWok>c/ooWin@GooOgm00OonOWionc/
k?nh^;Sofm_Kon7QhOoUiNGojNWY00;ok>c/00SokNg]on[Zj_oUiNGoh^;Rom_Kfoni^KWok>c/ooWi
nHkooOgm03[oo?cloo[jn_oclo?oNg]ko`000?mCDe?ogMgMooShn?ojn_[ono_kochn?_mWIfOokNg]
oiZJV_lY:BWon_[jooKfm_miNGWo?cloooCdm?ojn_[o?ShnofMWIoo]kNgoVYZJobTY:Ookno_oo?cl
og]kNol:2P[oVi^Kono_kooNg]kokNg]onc/k?l`<33oOgmoonSXj?ofm_Kono_kooclo?omoOgoo?cl
oo_knonVYZKof][Jono_kom3@d?oLG5aoo_knoolo?cooOgmooclo?okno_olo?coiNGUolD51CohN7Q
0_oVi^H04ol92@Wo[Zj^ooKfm_o2`/;o0000onKVi_oinOWoRh^;obd];OoLg=codm?Coa0@4?oHf=So
no_kooWinOnOWiooiNGUoo_knoolo?`0cOomoOd00oolo?cooOgmooclo003oogmo@000?WooOgmoo[j
n_oclo?ok^k^oo3`l?o_knook^k^onWYjOoCdm?oFadMoj8d=?nd:1go`CX]olM9??o?ET[od5M;om1G
B_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_ono_koo^k^kohn?Sojb/
[?o:b/[od];BomOGeooJf]WogMgMomkNg_oMgMgog=cLomOGeooDe=Cob/[:ojb/ZooShn?ok^k^ono_
koo`l?3okno_oo3`l?o_knook^k]on?Shon/[:cob/[:om;Bd_oGemOof][JomgMgOoNg]gogMgMomcL
g?oGemOoe=CDol[:b_n/[:cohn?Sonk^kOo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3ok^k^onk^
kOoAdM7o0@41ohB4Q?oQhN7oh^;RonKVi_o[jn_okno^omKFe_m2@T;o30`<oaXJ6_nZZZ[ok^k^onWY
jOmcLg;o>c/konSXj?o]kNgoemOGod92@_l<30co6QXJoj^[Z_o^k^kokno_onSXj?mcLg?o5aLGo`L7
1olD51CoaLG5of5QHOl410Co3@d=oaTI6Ong]kL00_o_knl02oo`l>ook^k^ono_kom/K6co:BTYo`h>
3_lm?Cgob<S8ono_k_o_knool?3`00;okno_00?oZ:RXo`l?3ol10@401?lI6AT01On/[:cojNWYokRh
^?l0003of][I00;ok>c/00WoKVi^oa<C4ol>3PkoL71`onk^k_o_knkoj^[ZoaTI6Onm_Kd00_o_knl0
b?o`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_0_o`l?06ono_k`7olo?c0OoinOT1ooknoP0000?oo_knooOgmoo`
l?001?oYjNT04OoWinOofm_Kof=;Bon1<S;oYSDeokHd;Oo2CD7o`eA9olAEB_o3E4Wo`Te1okHd;OnU
=CGoPC8bof=;BooKfm_oinOW00GojNWY00Koj>SXon?Shon[Zj_o^KViolW9bOo?cll2omGEe@09omKF
e_oEeMGoe=CDolo?coo8b<So^KVioj^[ZooShn?oj>SX00GojNWY00Koj>SXon?Shon[Zj_o^KViolW9
bOo?cll2omGEe@09omKFe_oEeMGoe=CDolo?coo8b<So^KVioj^[ZooShn?oj>SX08oojNWY00Woj>SX
ol;2`_l10@7ob/[:omgMgOoNg]kohN7QonGUiOoXj>P00_oYjNT02OoVi^KojNWYonWYjOoXj>Soi>CT
og1`L?lj>S[ohn?SonOWi`02onWYj@03onKVi_oYjNWojNWY00GojNWY00Koi^KVonWYjOoXj>Soj>SX
obl_;omnOWh2onSXj0OojNWY00?oinOWonWYjOoYjNT01?oYjNT04_oXj>SoinOWoiRHV?lC4a?ofm_K
omgMgOoOgmooh>3Pon?ShooTi>Co];Bdo`000?oFe]KoinOWonSXj?oYjNWoj>SXonOWim7ojNWY00?o
j>SXonWYjOoYjNT01?oYjNT1oo3`l07omoOg0Oono_h00005ookno_ojn_[om?Cdono_kooalO400_o`
l?004Oo_knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZNW?oIW9coe9FEok]cLonEE5CoCb<S
oiFDU?oZj^[okno_00Kol?3`00Kok^k^ol_;bonWYjOob<S8omSHf?oShn<3onKViP06on?ShooHf=So
b<S8ojNWYoo;bl_ok^k^1oo`l?001_o^k^kobl_;ojNWYoo8b<Sof=SHon?Sh`?oi^KV00Kohn?SomSH
f?o8b<SoYjNWol_;boo^k^j@oo3`l0;okno_00OoADE5ocHf=_n3Ph?oFe]Koe9BD_o^k^kokno_00Go
l?3`00Kokno_onk^k_meMGGo?3`long]kOo_knl=oo3`l004ono_koo=cLgoeMGEono_ka3ol?3`00go
kno_om?Cdol10@7ofm_KonSXj?oZj^[o:b/[ok:b/_o^k^ko_Kfmo`000?oPh>3okno_0=[ol?3`00Co
lO7aoo3`l?odm?Con_[j0Oono_h00004oo_knoooooooooooooknoP;ooooo0_ono_h0f?omoOgon?Sh
ofi^K_mJ?coo/I2@omk9bOo`i>ColnKVoo3Ti?oNbLWo/I2@oeXo?om]KFgon?Shooclo?ooooooo_kn
ooooooono_koooonookno_oooooooOgmooclo?o5aLGo^[ZjomgMgOoalO3on?ShooWinOohn?SolO7a
omgMgOnj^[[oaLG5ooclnoomoOgoooooookno_ooooooo_knooooooono_koooonoogmoOolo?coaLG5
okZj^_oMgMgolO7aooShn?oinOSon?Shoo7alOoMgMgo^[ZjolG5aOolo?cooOgmooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_kon_[jokBd]?m]KFgoQXJ6okjn__omoOgoooon
ookno_ooooooo_knooooo`;oo_kn0?oooOgmogemOOm0@43oo_knoogmoOooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooomoOgo
o_knofATI?lM7Ago8b<Sojb/[?nMWIgohN7QoogmoOo<c<co0000oo7al?omoOgoooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_h000[oooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_kn0_ooool00oono_koooooooooo`04ooooo`0000Col?3`ookno_ojn_[om?Cd1OoalO403Oo_
knooe]KFof][Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?CgoJf][omKFe_o_knl02OoalO403Oo`
l?3oi^KVokfm_On`/;3oclo?omoOgooUiNGogmoOolo?con`/;3o_KfmonKVi_o`l?002OoalO403Oo`
l?3oi^KVokfm_On`/;3oclo?omoOgooUiNGogmoOolo?con`/;3o_KfmonKVi_o`l?00XOoalO400oo_
knookNg]oo7al@04oo7al@03oo3`l?oalO7olO7a01kolO7a00?oh^;Rom[Jf_o`l?000ooalO400oo`
l?3ok>c/oo7al@3Doo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_ono_h00Oojn_X0
0005omWIfOomoOgon?Shoo3`l?o[jn/00ooZj^X03OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUIFOlV9RKo
2@T9obHV9_mIFEWoVi^KonSXj?oYjNT03?oZj^X02OoYjNWob/[:ok6a/OnMWIgoTY:BoifMWOna/K7o
b/[:onWYj@0=on[ZjP09onWYjOo:b/[o/K6aoifMWOnBTY;oWIfMok6a/Oo:b/[ojNWY0?ooj^[Z/?oZ
j^X01?o[jn_ol?3`ooShn?omoOd1onOWi`0000CoY:BTong]kOojn_[om?Cd2?oalO42oo3`l0?okno_
0_o`l?0Aoo7al@?ol?3`4ooalO43oo3`l:golO7a00?ol?3`oo7alOoalO40o_oalO400oo`l?3olO7a
oo7al@02oo7al@03ooGemOojn_[on?Sh007o^k^k00000onZZZ[o[jn_ono_k`3ooooooo3ooooo0Oo>
c/h1omCDe00000Ko`/;2ojVYZOnTY:Cof][Joo3`l?ojn_[oooooonWooooo00Goo_knoo[jn_o[jn_o
^k^kolK6aP01on;RhP00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{500, 337},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(JavaShow[frame]\), "\[IndentingNewLine]", 
    \(JavaBlock[ShowFileChooser[]]\)}], "Input"],

Cell[BoxData[
    \("/Users/jsato/obj.ser"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[""], "Input"],

Cell[BoxData[
    \("/Users/jsato/obj.ser"\)], "Output"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007l0001HB000`400?l00000o`00003oo`00003m
0000000000<0R<2h04R@R018T8P0o`18T8Si04R@R040000000000`28`;P0b>3H08S0^03o08S0^?P0
R<2h0@18T8P10000000000<0R<2h0<SPf028`;P0o`28`;Sh08S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<
m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<
m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<
m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^?l0c<c<EP3<c<a70?ooo`H0c<c<A`3oool;0<c<c080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<aE0<c<c00306IVIP3<c<`0IVIV04@0IVIV
00<0oooo0<c<c03<c<`00`3<c<`00`1VIVH0c<c<06IVIP1406IVIP030?ooo`3<c<`0c<c<00T0c<c<
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c5D0c<c<00<0IVIV0?ooo`3<c<`0
@`3<c<`00`1VIVH0oooo0<c<c0040<c<c00306IVIP3oool0c<c<04<0c<c<00<0IVIV0?ooo`3<c<`0
2P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<E@3<c<`00`1VIVH0oooo
0<c<c0130<c<c00306IVIP3oool0c<c<00@0c<c<00<0IVIV0?ooo`3<c<`0@`3<c<`00`1VIVH0oooo
0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<aE0<c<c00306IV
IP3oool0c<c<04<0c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo0<c<c0130<c<c00306IV
IP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c5D0c<c<
00<0IVIV0?ooo`3<c<`0@`3<c<`00`1VIVH0oooo0<c<c0040<c<c00306IVIP3oool0c<c<04<0c<c<
00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<
E@3<c<`00`1VIVH0oooo0<c<c0130<c<c00306IVIP3oool0c<c<00@0c<c<00<0IVIV0?ooo`3<c<`0
@`3<c<`00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
o`3<c<aE0<c<c00306IVIP3oool0c<c<04<0c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo
0<c<c00C0<c<c0<000000`3<c<`01@000000c<c<0<c<c03<c<`000000080c<c<0P0000020<c<c080
00001P3<c<`00`000000c<c<0<c<c00D0<c<c00306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;So0<c<c5D0c<c<00<0IVIV0?ooo`3<c<`0503<c<`5000000<0
c<c<1@0000020<c<c0<000000`3<c<`4000001H0c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0
oooo0<c<c00?0<c<c0040000003<c<`0c<c<0<c<c0L000000P3<c<`200000080c<c<0P0000030<c<
c0800000103<c<`600000180c<c<00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^?l0c<c<E@3<c<`00`1VIVH0oooo0<c<c00C0<c<c08000000`3<c<`20000
00030<c<c000000000000080c<c<0P0000020<c<c0<000000P3<c<`200000080c<c<0P00000E0<c<
c00306IVIP3oool0c<c<00@0c<c<00<0IVIV0?ooo`3<c<`03`3<c<`6000000040<c<c00000000000
000000@0c<c<0P0000000`3<c<`00000000000030<c<c08000000`3<c<`2000000@0c<c<0`00000@
0<c<c00306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So
0<c<c5D0c<c<00<0IVIV0?ooo`3<c<`0603<c<`2000000030<c<c000000000000080c<c<0P000000
103<c<`000000000003<c<`2000000030<c<c0000000000001T0c<c<00<0IVIV0?ooo`3<c<`0103<
c<`00`1VIVH0oooo0<c<c00@0<c<c080000000@0c<c<000000000000c<c<0`0000040<c<c0X00000
0`3<c<`2000000D0c<c<00<000000<c<c03<c<`03`3<c<`00`1VIVH0oooo0<c<c00:0<c<c080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<aE0<c<c00306IVIP3oool0c<c<01H0c<c<
100000020<c<c080000000@0c<c<000000000000c<c<0P000000103<c<`000000000003<c<`60000
01D0c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo0<c<c00@0<c<c0T000001@3<c<`01000
0000c<c<0000000000030<c<c08000000`3<c<`2000001L0c<c<00<0IVIV0?ooo`3<c<`02P3<c<`2
08S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<E@3<c<`00`1VIVH0oooo0<c<c00D
0<c<c0D00000103<c<`4000000040<c<c000000000000<c<c080000000<0c<c<0000000000000P3<
c<`2000001D0c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo0<c<c00@0<c<c080000000<0
c<c<000000000000100000040<c<c0030000003<c<`0c<c<00L000000`3<c<`2000001L0c<c<00<0
IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<E@3<
c<`00`1VIVH0oooo0<c<c00C0<c<c0@00000103<c<`010000000c<c<0<c<c03<c<`4000000<0c<c<
100000020<c<c08000005@3<c<`00`1VIVH0oooo0<c<c0040<c<c00306IVIP3oool0c<c<0100c<c<
0P0000000`3<c<`0000000000002000000030<c<c000000000000080c<c<0`0000000`3<c<`00000
000000030<c<c08000000`3<c<`2000001L0c<c<00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^?l0c<c<E@3<c<`00`1VIVH0oooo0<c<c00C0<c<c0800000
1`3<c<`4000000030<c<c0000000000000<0c<c<0P0000000`3<c<`0000000000002000001H0c<c<
00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo0<c<c00@0<c<c0L0000000<0c<c<000000000000
0`3<c<`00`000000c<c<0<c<c007000000<0c<c<0P00000G0<c<c00306IVIP3oool0c<c<00X0c<c<
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c5D0c<c<00<0IVIV0?ooo`3<c<`0
4`3<c<`2000000<0c<c<0P00000Y0<c<c00306IVIP3oool0c<c<00@0c<c<00<0IVIV0?ooo`3<c<`0
403<c<`2000000030<c<c0000000000000D00000103<c<`8000000@0c<c<0P00000G0<c<c00306IV
IP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c5D0c<c<
00<0IVIV0?ooo`3<c<`0503<c<`5000002X0c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo
0<c<c00?0<c<c0L000001`3<c<`2000000030<c<c0000000000000D000000`3<c<`2000001L0c<c<
00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<
E@3<c<`00`1VIVH0oooo0<c<c0130<c<c00306IVIP3oool0c<c<00@0c<c<00<0IVIV0?ooo`3<c<`0
703<c<`01P000000c<c<0<c<c03<c<`000000<c<c0<000007P3<c<`00`1VIVH0oooo0<c<c00:0<c<
c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<aE0<c<c00306IVIP3oool0c<c<
04<0c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo0<c<c0130<c<c00306IVIP3oool0c<c<
00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<c5D0c<c<00<0IVIV0?oo
o`3<c<`0@`3<c<`00`1VIVH0oooo0<c<c0040<c<c00306IVIP3oool0c<c<04<0c<c<00<0IVIV0?oo
o`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<E@3<c<`00`1V
IVH0oooo0<c<c0130<c<c00306IVIP3oool0c<c<00@0c<c<00<0IVIV0?ooo`3<c<`0@`3<c<`00`1V
IVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<aE0<c<
c00306IVIP3oool0c<c<04<0c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo0<c<c0130<c<
c00306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So0<c<
c5D0c<c<00<0IVIV0?ooo`3<c<`0@`3<c<`00`1VIVH0oooo0<c<c0040<c<c00306IVIP3oool0c<c<
04<0c<c<00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^?l0c<c<E@3<c<`00`1VIVH0oooo0<c<c0130<c<c00306IVIP3oool0c<c<00@0c<c<00<0IVIV0?oo
o`3<c<`0@`3<c<`00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028
`;P0R<2ho`3<c<aE0<c<c00306IVIP3oool0oooo04<0oooo00<0c<c<0?ooo`3<c<`0103<c<`00`1V
IVH0oooo0?ooo`130?ooo`030<c<c03oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;So0<c<c5D0c<c<A`1VIVH60<c<c4L0IVIV303<c<`208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^7@0c<c<o`3ooomf0?ooo`/0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;Qc0<c<
c00306IVIP3<c<`0IVIV0?l0IVIVL`1VIVH00`3oool0c<c<0<c<c0090<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2hL`3<c<`00`1VIVH0oooo0<c<c03o0<c<c780c<c<00<0IVIV0?oo
o`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^7<0c<c<00<0IVIV0?oo
o`3<c<`0o`3<c<ab0<c<c00306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;Qc0<c<c00306IVIP3oool0c<c<0?l0c<c<LP3<c<`00`1VIVH0oooo0<c<c00:0<c<
c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2hL`3<c<`00`1VIVH0oooo0<c<c03o0<c<
c780c<c<00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^7<0c<c<00<0IVIV0?ooo`3<c<`0o`3<c<ab0<c<c00306IVIP3oool0c<c<00X0c<c<0P28`;P104R@
R040000000001028`;P0b>3H08S0^028`;P?0<c<c0030000003<c<`0c<c<00X0c<c<0P00000=0<c<
c08000001`3<c<`00`000000c<c<0<c<c00:0<c<c0<000003@3<c<`2000000P0c<c<00<000000<c<
c03<c<`05@3<c<`00`1VIVH0oooo0<c<c0060<c<c08000009`3<c<`00`000000c<c<0<c<c0060<c<
c0030000003<c<`0c<c<00T0c<c<0P00000>0<c<c08000001`3<c<`00`000000c<c<0<c<c03o0<c<
c180c<c<00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^0l0c<c<1000000:0<c<c0800000303<c<`2000000H0c<c<0`0000020<c<c0<00000203<c<`30000
00/0c<c<0P0000080<c<c0@000001P3<c<`2000000`0c<c<00<0IVIV0?ooo`3<c<`01`3<c<`20000
01P0c<c<1@0000040<c<c0<0000000<0c<c<0000000000000P0000060<c<c0@000002@3<c<`20000
00d0c<c<0P0000060<c<c0<000000P3<c<`300000?l0c<c<3P3<c<`00`1VIVH0oooo0<c<c00:0<c<
c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h4@3<c<`3000000X0c<c<0P00000;0<c<
c08000001`3<c<`200000080c<c<100000080<c<c0@000002@3<c<`2000000X0c<c<0`0000050<c<
c0800000303<c<`00`1VIVH0oooo0<c<c0080<c<c08000003`3<c<`00`000000c<c<0<c<c0040<c<
c08000001`3<c<`500000080c<c<0`0000070<c<c0<000002@3<c<`2000000`0c<c<0P0000070<c<
c08000000P3<c<`400000?l0c<c<3@3<c<`00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2h4`3<c<`2000000T0c<c<0P0000070<c<c0040000003<c<`0c<c<
0<c<c0800000203<c<`2000000040<c<c000000000000<c<c0<000001`3<c<`4000000@0c<c<00@0
00000<c<c03<c<`0c<c<0P00000<0<c<c08000004P3<c<`00`1VIVH0oooo0<c<c0060<c<c0@00000
1P3<c<`00`000000c<c<0<c<c0050<c<c0<00000103<c<`2000000P0c<c<0P0000000`3<c<`00000
000000030<c<c0<00000203<c<`2000000P0c<c<0P0000080<c<c0040000003<c<`0c<c<0<c<c080
0000203<c<`2000000040<c<c000000000000<c<c0<00000o`3<c<`;0<c<c00306IVIP3oool0c<c<
00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;PD0<c<c0800000203<c<`40000
00@0c<c<100000000`3<c<`00000000000080<c<c080000000<0c<c<0000000000000P3<c<`20000
0080c<c<0P0000030<c<c0<00000103<c<`4000000030<c<c0000000000000d0c<c<0P00000A0<c<
c00306IVIP3oool0c<c<00D0c<c<0P0000000`3<c<`00000000000060<c<c08000001@3<c<`30000
00D0c<c<0P0000080<c<c08000000P3<c<`2000000<0c<c<0P0000090<c<c08000001`3<c<`40000
00D0c<c<100000000`3<c<`00000000000080<c<c080000000<0c<c<0000000000000P3<c<`20000
0?l0c<c<0P0000090<c<c00306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;PD0<c<c0<000001`3<c<`5000000D0c<c<1@0000080<c<c080000000<0c<c<0000
000000000`3<c<`010000000c<c<0<c<c03<c<`7000000H0c<c<1@00000=0<c<c0<00000403<c<`0
0`1VIVH0oooo0<c<c0050<c<c080000000<0c<c<0000000000001`3<c<`200000080c<c<0`000007
0<c<c0800000203<c<`200000080c<c<0P0000030<c<c08000002@3<c<`3000000H0c<c<1@000006
0<c<c0D00000203<c<`2000000030<c<c0000000000000<0c<c<00<000000<c<c03<c<`0o03<c<`4
000000P0c<c<00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^1D0c<c<0P0000040<c<c0T000001P3<c<`3000000P0c<c<0P0000000`3<c<`0000000000007
0<c<c0<000000`3<c<`2000000L0c<c<0`00000>0<c<c08000000P3<c<`2000000`0c<c<00<0IVIV
0?ooo`3<c<`01P3<c<`4000000P0c<c<1@0000090<c<c08000001`3<c<`3000000030<c<c0000000
00000080c<c<0`00000:0<c<c08000000`3<c<`9000000L0c<c<0`0000080<c<c080000000<0c<c<
000000000000o`3<c<`20<c<c0H000001`3<c<`00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P1
0000000000@0R<2h0<SPf028`;P0R<2h5@3<c<`2000000/0c<c<00<000000<c<c03<c<`01P3<c<`3
000000L0c<c<0P0000000`3<c<`00000000000080<c<c08000000`3<c<`2000000P0c<c<0`00000=
0<c<c08000000P3<c<`2000000`0c<c<00<0IVIV0?ooo`3<c<`00`3<c<`7000000T0c<c<0`000002
0<c<c0040000003<c<`0c<c<0<c<c0<0000000@0c<c<00000000000000001`3<c<`2000000030<c<
c000000000000080c<c<0P00000;0<c<c08000002P3<c<`00`000000c<c<0<c<c0070<c<c0<00000
1`3<c<`2000000030<c<c000000000000?l0c<c<0@3<c<`8000000H0c<c<00<0IVIV0?ooo`3<c<`0
2P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0h0c<c<2@00000E0<c<c0@00000
1@3<c<`2000000030<c<c0000000000000T0c<c<1P0000090<c<c0@00000103<c<`900000100c<c<
00<0IVIV0?ooo`3<c<`0203<c<`6000000P0c<c<100000040<c<c0T00000103<c<`7000000D0c<c<
2@00000E0<c<c0@000001@3<c<`2000000030<c<c000000000000?l0c<c<2P0000050<c<c00306IV
IP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P]0<c<c0800000
503<c<`3000000d0c<c<0P00000<0<c<c0@000003P3<c<`00`1VIVH0oooo0<c<c0080<c<c0800000
3@3<c<`3000000/0c<c<00<000000<c<c03<c<`01P3<c<`00`000000c<c<0<c<c00U0<c<c0800000
o`3<c<`J0<c<c00306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P]0<c<c0030000003<c<`0c<c<01@0c<c<00<000000<c<c03<c<`0303<c<`00`000000c<c<
0<c<c00;0<c<c0@000003P3<c<`00`1VIVH0oooo0<c<c0080<c<c08000003@3<c<`00`000000c<c<
0<c<c00l0<c<c0030000003<c<`0c<c<0?l0c<c<6@3<c<`00`1VIVH0oooo0<c<c00:0<c<c080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2hL`3<c<`00`1VIVH0oooo0<c<c03o0<c<c780c<c<
00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^7<0c<c<
00<0IVIV0?ooo`3<c<`0o`3<c<ab0<c<c00306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;Qc0<c<c00306IVIP3oool0c<c<0?l0c<c<LP3<c<`00`1VIVH0oooo
0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2hL`3<c<`00`1VIVH0oooo
0<c<c03o0<c<c780c<c<00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^7<0c<c<00<0IVIV0?ooo`3<c<`0o`3<c<ab0<c<c00306IVIP3oool0c<c<00X0c<c<
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;Qc0<c<c00306IVIP3oool0oooo0?l0oooo
LP3oool00`3<c<`0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
L`3<c<co06IVIWH0IVIV303<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<
m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<
m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^7@0c<c<o`3ooomf0?ooo`/0c<c<
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;Qc0<c<c00306IVIP3<c<`0IVIV0?l0IVIV
L`1VIVH00`3oool0c<c<0<c<c0090<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
L`3<c<`00`1VIVH0oooo0?ooo`3o0?ooog80oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^7<0c<c<00<0IVIV0?ooo`3oool02@3oool00`000000oooo
0?ooo`3o0?ooofH0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^0l0c<c<00<000000<c<c03<c<`02P3<c<`2000000d0c<c<0P0000070<c<c0030000
003<c<`0c<c<00`0c<c<0P0000030<c<c0800000:@3<c<`00`1VIVH0oooo0?ooo`0:0?ooo`030000
003oool0oooo0?l0ooooI@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0
R<2h0<SPf028`;P0R<2h3`3<c<`4000000X0c<c<0P00000<0<c<c08000001P3<c<`300000080c<c<
0`0000080<c<c0L0000000<0c<c<0000000000009P3<c<`0101VIVH0oooo0?ooo`0000020?ooo`04
0000003oool0oooo000000<0oooo00@000000?ooo`3oool0oooo1@0000050?ooo`80000000@0oooo
0000003oool0oooo0P0000020?ooo`80000000D0oooo0000003oool0oooo000000060?ooo`040000
003oool0oooo000000<0oooo0`0000030?ooo`040000003oool0oooo0?ooo`80000000<0oooo0000
003oool00P3oool2000000040?ooo`000000oooo0?ooo`800000o`3ooolS0?ooo`0306IVIP3oool0
c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;PA0<c<c0<000002P3<c<`2
000000/0c<c<0P0000070<c<c08000000P3<c<`4000000@0c<c<00<000000<c<c03<c<`00P000003
0<c<c080000000<0c<c<0000000000009P3<c<`0101VIVH0oooo0?ooo`0000020?ooo`040000003o
ool0oooo000000<0oooo00D000000?ooo`3oool0oooo000000040?ooo`050000003oool0oooo0?oo
o`0000000P3oool200000080oooo00@000000?ooo`3oool000000P3oool200000080oooo00<00000
0?ooo`3oool0103oool010000000oooo0?ooo`0000020?ooo`050000003oool0oooo0?ooo`000000
1@3oool00`000000oooo0?ooo`0200000080oooo00<000000?ooo`3oool00P0000020?ooo`030000
003oool0oooo0?l0oooo8P3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0
R<2h0<SPf028`;P0R<2h4`3<c<`2000000T0c<c<0P0000070<c<c0040000003<c<`0c<c<0<c<c080
0000203<c<`2000000040<c<c000000000000<c<c0<000000P3<c<`5000000<0c<c<0P00000Y0<c<
c00:06IVIP3oool0oooo0000003oool000000?ooo`000000oooo00000080oooo00<000000?ooo`00
00000P3oool00`000000oooo0?ooo`030?ooo`040000003oool0oooo000000<0oooo00@000000?oo
o`3oool000000P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0103o
ool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo00L0oooo00D000000?ooo`3oool0
oooo000000020?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`3o0?oo
ob80oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^1@0c<c<0P0000080<c<c0@00000103<c<`4000000030<c<c0000000000000P0c<c<0P0000000`3<
c<`00000000000020<c<c0800000103<c<`8000002T0c<c<00X0IVIV0?ooo`3oool000000?ooo`00
0000oooo0000003oool000000P3oool00`000000oooo000000020?ooo`030000003oool0oooo00<0
oooo00@000000?ooo`3oool0oooo100000020?ooo`040000003oool0oooo0?ooo`@000000P3oool0
0`000000oooo0?ooo`040?ooo`040000003oool0oooo00000080oooo1@0000050?ooo`050000003o
ool0oooo0?ooo`0000000`3oool400000080oooo00<000000?ooo`3oool0o`3ooolR0?ooo`0306IV
IP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;PD0<c<c0<00000
1`3<c<`5000000D0c<c<1@0000080<c<c080000000<0c<c<0000000000000`3<c<`010000000c<c<
0<c<c00000030<c<c0800000;@3<c<`02P1VIVH0oooo0?ooo`000000oooo0000003oool000000?oo
o`0000020?ooo`030000003oool000000080oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`040?ooo`040000003oool0oooo000000H0oooo00<000000?ooo`3oool0100000030?ooo`04
0000003oool0oooo00000080oooo00D000000?ooo`3oool0oooo000000050?ooo`050000003oool0
oooo0?ooo`0000001P3oool010000000oooo0?ooo`00003o0?ooob@0oooo00<0IVIV0?ooo`3<c<`0
2P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^1D0c<c<0P0000040<c<c0T00000
1P3<c<`3000000P0c<c<0P0000000`3<c<`00000000000060<c<c0<0000000@0c<c<000000000000
0000103<c<`2000002H0c<c<00`0IVIV0?ooo`3oool000000?ooo`000000oooo0000003oool00000
0?ooo`0000030?ooo`030000003oool0000000D0oooo00@000000?ooo`3oool000000`3oool01000
0000oooo0?ooo`0000020?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?oo
o`040?ooo`040000003oool0oooo00000080oooo00D000000?ooo`3oool0oooo000000050?ooo`03
0000003oool0oooo008000000P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?oo
o`3oool0o`3ooolR0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;PE0<c<c08000002`3<c<`00`000000c<c<0<c<c0060<c<c0<000001`3<c<`20000
00030<c<c0000000000000L0c<c<100000000`3<c<`00000000000030<c<c08000009P3<c<`00`1V
IVH0oooo0?ooo`02000000<0oooo0P0000000`3oool000000?ooo`020?ooo`030000003oool00000
00D0oooo00@000000?ooo`3oool0oooo0`0000020?ooo`<000000P3oool3000000<0oooo00<00000
0?ooo`3oool0103oool010000000oooo0?ooo`0000030?ooo`<000001`3oool2000000030?ooo`00
0000oooo0080oooo0`0000020?ooo`<00000o`3ooolS0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28
`;P104R@R040000000001028`;P0b>3H08S0^028`;P>0<c<c0T000005@3<c<`4000000D0c<c<0P00
00000`3<c<`00000000000080<c<c0<000000P3<c<`3000002T0c<c<00<0IVIV0?ooo`3oool00P00
00030?ooo`8000001`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00h0oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`3o0?ooob80oooo00<0IVIV0?ooo`3<c<`02P3<
c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^2d0c<c<0P00000D0<c<c0H00000:P3<
c<`0101VIVH0oooo0?ooo`0000050?ooo`030000003oool0oooo00D0oooo1@00000;0?ooo`030000
003oool0oooo00L0oooo1@0000020?ooo`040000003oool0oooo00000100oooo00<000000?ooo`3o
ool01`3oool00`000000oooo0?ooo`3o0?ooob80oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^2d0c<c<00<000000<c<c03<c<`04`3<c<`2000002h0
c<c<00<0IVIV0?ooo`3oool0o`3ooomb0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;Qc0<c<c00306IVIP3oool0oooo0?l0ooooLP3oool00`1VIVH0
oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2hL`3<c<`00`1VIVH0
oooo0?ooo`3o0?ooog80oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0
^038h=P0R<2h08S0^7<0c<c<00<0IVIV0?ooo`3oool0o`3ooomb0?ooo`0306IVIP3oool0c<c<00X0
c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;Qc0<c<c00306IVIP3oool0oooo0?l0
ooooLP3oool00`3<c<`0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0
R<2hL`3<c<co06IVIWH0IVIV303<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0
c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0
^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0
c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0
^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0
c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0
^038h=P0R<2h08S0^0d0c<c<o`3ooooM0?ooo`/0c<c<0P28`;P104R@R040000000001028`;P0b>3H
08S0^028`;P<0<c<c00306IVIP3<c<`0IVIV0?l0IVIVfP1VIVH00`3oool0c<c<0<c<c0090<c<c080
R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo0?ooo`3o0?ooomT0
oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0
c<c<00<0IVIV0?ooo`3oool0o`3ooooI0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0oooo0?l0oooof@3oool00`1VIVH0
oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0
oooo0?ooo`3o0?ooomT0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0
^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool0o`3ooooI0?ooo`0306IVIP3oool0c<c<00X0
c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0oooo0?l0
oooof@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0
R<2h303<c<`00`1VIVH0oooo0?ooo`3o0?ooomT0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00@0IVIV0?ooo`3oool0oooo3@00003o0?oo
ol/0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^0`0c<c<00D0IVIV0?ooo`3oool0oooo0000000;0<c<o`030000003oool0oooo0?l0oooob@3oool0
0`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`0
1P1VIVH0oooo0?ooo`3oool000000<c<o`T0oooo00<0c<co0000003oool0o`3oooo:0?ooo`0306IV
IP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00606IV
IP3oool0oooo0?ooo`000000c<co2@3oool00`3<c?l000000?ooo`040?ooo`8000000P3oool00`00
0000oooo0?ooo`0200000080oooo1@0000020?ooo`80000000<0oooo0000000000000P3oool20000
0080oooo100000020?ooo`8000000P3oool200000080oooo0P0000020?ooo`D000000P3oool20000
00030?ooo`00000000000080oooo100000030?ooo`D0000000<0oooo0000000000000P3oool40000
0080oooo0P0000020?ooo`8000000P3oool400000?l0ooooIP3oool00`1VIVH0oooo0<c<c00:0<c<
c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`01P1VIVH0oooo0?ooo`3oool0
00000<c<o`T0oooo00<0c<co0000003oool0103oool2000000050?ooo`00000000000000003oool0
0P0000000`3oool00000000000020?ooo`80000000<0oooo0000000000000P3oool200000080oooo
0P0000000`3oool00000000000020?ooo`80000000<0oooo0000000000000P3oool200000080oooo
0P0000000`3oool00000000000020?ooo`80000000<0oooo0000000000000P3oool2000000030?oo
o`00000000000080oooo0P0000000`3oool00000000000020?ooo`80000000@0oooo000000000000
oooo0P0000020?ooo`80000000<0oooo0000000000000P3oool2000000030?ooo`00000000000080
oooo0P00003o0?ooofD0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0
^038h=P0R<2h08S0^0`0c<c<00H0IVIV0?ooo`3oool0oooo0000003<c?l90?ooo`030<c<o`000000
oooo00@0oooo0P0000001@3oool00000000000000000oooo0080000000<0oooo0000000000000P3o
ool2000000030?ooo`00000000000080oooo0P0000020?ooo`80000000<0oooo0000000000001@3o
ool200000080oooo0P0000020?ooo`80000000<0oooo0000000000000P3oool2000000030?ooo`00
000000000080oooo0P0000000`3oool00000000000050?ooo`8000000P3oool2000000@0oooo0P00
00060?ooo`@000000P3oool200000?l0ooooJ@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18
T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`01P1VIVH0oooo0?ooo`3oool000000<c<o`T0
oooo00<0c<co0000003oool0103oool2000000050?ooo`000000oooo0000003oool00P0000020?oo
o`80000000@0oooo000000000000oooo0P0000020?ooo`8000000P3oool2000000030?ooo`000000
000000@0000000<0oooo0000000000000P3oool200000080oooo0P0000020?ooo`80000000@0oooo
000000000000oooo0P0000020?ooo`80000000<0oooo0000000000001P3oool2000000030?ooo`00
0000000000@0oooo1P0000030?ooo`8000000`3oool600000?l0ooooI@3oool00`1VIVH0oooo0<c<
c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`01P1VIVH0oooo0?oo
o`3oool000000<c<o`T0oooo00<0c<co0000003oool0103oool2000000050?ooo`000000oooo0000
003oool00P0000030?ooo`@0000000<0oooo0000000000000P3oool200000080oooo0P0000000`3o
ool00000000000020?ooo`80000000<0oooo0000000000000P3oool200000080oooo0P0000030?oo
o`@0000000<0oooo0000000000000P3oool2000000030?ooo`000000000000L0oooo100000040?oo
o`8000000P3oool200000080oooo100000020?ooo`8000000P3oool200000?l0ooooI@3oool00`1V
IVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`01P1V
IVH0oooo0?ooo`3oool000000<c<o`T0oooo00<0c<co0000003oool0103oool4000000030?ooo`00
000000000080000000<0oooo0000003oool00P3oool2000000030?ooo`00000000000080oooo0`00
0000103oool000000000003oool200000080oooo0P0000001@3oool00000000000000000oooo00<0
000000D0oooo000000000000oooo000000030?ooo`80000000<0oooo0000000000000P3oool20000
00030?ooo`00000000000080oooo0P0000000`3oool000000?ooo`020?ooo`800000103oool20000
0080oooo0P0000000`3oool00000000000020?ooo`80000000<0oooo0000000000000P3oool20000
0?l0ooooI@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028
`;P0R<2h303<c<`01P1VIVH0oooo0?ooo`3oool000000<c<o`T0oooo0P0000050?ooo`@0000000<0
oooo0000000000000P0000020?ooo`@0000000<0oooo0000000000000P000000103oool000000000
003oool2000000<0oooo100000020?ooo`80000000<0oooo0000000000000P3oool2000000<0oooo
100000000`3oool0000000000002000000030?ooo`00000000000080oooo100000030?ooo`@00000
1P3oool400000080oooo0P0000020?ooo`8000000P3oool400000?l0ooooIP3oool00`1VIVH0oooo
0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`01P1VIVH0oooo
0?ooo`3oool000000<c<o`P0oooo0P0000060?ooo`<000000`3oool3000000P0oooo0P0000020?oo
o`8000007P3oool200000?l0ooooS`3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2h303<c<`01P1VIVH0oooo0?ooo`3oool000000<c<o`L0oooo00<0
00000<c<o`0000001P3oool3000000<0oooo0`0000090?ooo`030000003oool0oooo008000007`3o
ool00`000000oooo0?ooo`0200000?l0ooooR`3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18
T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`01P1VIVH0oooo0?ooo`3oool000000<c<o`H0
oooo00<000000<c<o`000000o`3oooo=0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;P<0<c<c00606IVIP3oool0oooo0?ooo`000000c<co1@3oool0
10000000c<co0?ooo`00003o0?ooold0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@00
0000000408S0^038h=P0R<2h08S0^0`0c<c<00D0IVIV0?ooo`3oool0oooo000000070<c<o`800000
o`3oooo>0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P<0<c<c00406IVIP3oool0oooo0?ooo`X00000o`3oooo>0?ooo`0306IVIP3oool0c<c<00X0
c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0oooo0?l0
oooof@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0
R<2h303<c<`00`1VIVH0oooo0?ooo`3o0?ooomT0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool0o`3ooooI0?ooo`03
06IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c003
06IVIP3oool0oooo0?l0oooof@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P100000000
00@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo0?ooo`3o0?ooomT0oooo00<0IVIV0?ooo`3<
c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3o
ool0o`3ooooI0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H
08S0^028`;P<0<c<c00406IVIP3oool0oooo0?ooo`d00000o`3oooo;0?ooo`0306IVIP3oool0c<c<
00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00506IVIP3oool0oooo
0?ooo`0000002`3<c?l00`000000oooo0?ooo`3o0?ooolT0oooo00<0IVIV0?ooo`3<c<`02P3<c<`2
08S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00H0IVIV0?ooo`3oool0oooo0000
003<c?l90?ooo`030<c<o`000000oooo0?l0oooobP3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`01P1VIVH0oooo0?ooo`3oool000000<c<
o`T0oooo00<0c<co0000003oool0103oool200000080oooo0P0000020?ooo`8000000P3oool50000
0080oooo0P0000000`3oool00000000000020?ooo`80000000<0oooo0000000000000P3oool40000
0080oooo0P0000020?ooo`8000000P3oool400000?l0ooooT`3oool00`1VIVH0oooo0<c<c00:0<c<
c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`01P1VIVH0oooo0?ooo`3oool0
00000<c<o`T0oooo00<0c<co0000003oool0103oool200000080oooo0P0000020?ooo`80000000<0
oooo0000000000000P3oool2000000030?ooo`00000000000080oooo0P0000020?ooo`80000000@0
oooo000000000000oooo0P0000020?ooo`80000000<0oooo0000000000000P3oool2000000030?oo
o`00000000000080oooo0P00003o0?oooi80oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^0`0c<c<00H0IVIV0?ooo`3oool0oooo0000003<c?l90?oo
o`030<c<o`000000oooo00@0oooo0P0000020?ooo`8000000P3oool2000000030?ooo`0000000000
0080oooo0P0000000`3oool00000000000020?ooo`8000000P3oool2000000@0oooo0P0000060?oo
o`@000000P3oool200000?l0ooooUP3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2h303<c<`01P1VIVH0oooo0?ooo`3oool000000<c<o`T0oooo00<0
c<co0000003oool0103oool200000080oooo0P0000020?ooo`8000000P3oool2000000040?ooo`00
000000000?ooo`8000000P3oool200000080oooo0P0000040?ooo`H000000`3oool2000000<0oooo
1P00003o0?oooi80oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^0`0c<c<00H0IVIV0?ooo`3oool0oooo0000003<c?l90?ooo`030<c<o`000000oooo
00@0oooo0P0000020?ooo`8000000P3oool2000000<0oooo100000000`3oool00000000000020?oo
o`8000000P3oool2000000@0oooo0P0000020?ooo`8000000P3oool400000080oooo0P0000020?oo
o`800000o`3ooonB0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;P<0<c<c00606IVIP3oool0oooo0?ooo`000000c<co2@3oool00`3<c?l000000?oo
o`040?ooo`<0000000D0oooo00000000000000000?ooo`02000000030?ooo`000000oooo0080oooo
0P0000000`3oool00000000000020?ooo`<0000000<0oooo000000000000103oool200000080oooo
0P0000000`3oool00000000000020?ooo`80000000<0oooo0000000000000P3oool200000?l0oooo
TP3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
303<c<`01P1VIVH0oooo0?ooo`3oool000000<c<o`T0oooo0P0000050?ooo`80000000<0oooo0000
000000000P3oool2000000<0oooo100000000`3oool0000000000002000000040?ooo`0000000000
0?ooo`8000001P3oool400000080oooo0P0000020?ooo`8000000P3oool400000?l0ooooT`3oool0
0`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`0
1P1VIVH0oooo0?ooo`3oool000000<c<o`P0oooo0P00000H0?ooo`8000000P3oool200000?l0oooo
[P3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
303<c<`01P1VIVH0oooo0?ooo`3oool000000<c<o`L0oooo00<000000<c<o`0000006@3oool00`00
0000oooo0?ooo`0200000?l0oooo[P3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2h303<c<`01P1VIVH0oooo0?ooo`3oool000000<c<o`H0oooo00<0
00000<c<o`000000o`3oooo=0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R04000000000
1028`;P0b>3H08S0^028`;P<0<c<c00606IVIP3oool0oooo0?ooo`000000c<co1@3oool010000000
c<co0?ooo`00003o0?ooold0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^0`0c<c<00D0IVIV0?ooo`3oool0oooo000000070<c<o`800000o`3oooo>
0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<
0<c<c00406IVIP3oool0oooo0?ooo`X00000o`3oooo>0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28
`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0oooo0?l0oooof@3o
ool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<
c<`00`1VIVH0oooo0?ooo`3o0?ooomT0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@00
0000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool0o`3ooooI0?ooo`0306IVIP3o
ool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3o
ool0oooo0?l0oooof@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h
0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo0?ooo`3o0?ooomT0oooo00<0IVIV0?ooo`3<c<`02P3<
c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool0o`3o
oooI0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028
`;P<0<c<c00306IVIP3oool0oooo0?l0oooof@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18
T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo0?ooo`0J0?ooo`<00000o`3o
oonl0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028
`;P<0<c<c00306IVIP3oool0000000l000003@3oool200000?l0oooo^`3oool00`1VIVH0oooo0<c<
c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`0101VIVH0oooo0000
003oool=0<c<o`030000003oool0oooo00<0oooo1@0000030?ooo`<000000`3oool4000000<0oooo
0P0000020?ooo`@000000P3oool200000080oooo0P0000020?ooo`80000000<0oooo000000000000
103oool2000000030?ooo`00000000000080oooo100000030?ooo`@00000o`3ooon30?ooo`0306IV
IP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00406IV
IP3oool000000?ooo`d0c<co00<000000?ooo`3oool00P3oool2000000<0oooo0P0000020?ooo`<0
00000P3oool200000080oooo0P0000000`3oool00000000000020?ooo`8000000P3oool200000003
0?ooo`00000000000080oooo0P0000020?ooo`80000000<0oooo000000000000103oool200000004
0?ooo`00000000000?ooo`8000000P3oool2000000030?ooo`00000000000080oooo0P00003o0?oo
oh80oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^0`0c<c<00@0IVIV0?ooo`000000oooo3@3<c?l00`000000oooo0?ooo`070?ooo`80000000@0oooo
000000000000oooo0P0000040?ooo`<0000000<0oooo0000000000000P3oool2000000D0oooo0P00
00020?ooo`8000000P3oool2000000030?ooo`000000000000@0oooo0P000000103oool000000000
003oool2000000P0oooo0`00003o0?oooh80oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^0`0c<c<00@0IVIV0?ooo`000000oooo3@3<c?l00`000000
oooo0?ooo`050?ooo`@0000000@0oooo000000000000oooo0P0000020?ooo`@000000P3oool20000
0080oooo1P0000000`3oool00000000000020?ooo`8000000P3oool2000000030?ooo`0000000000
00@0oooo0P000000103oool000000000003oool600000080oooo1000003o0?oooh<0oooo00<0IVIV
0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00@0IVIV
0?ooo`000000oooo3@3<c?l00`000000oooo0?ooo`030?ooo`D000000P3oool2000000040?ooo`00
000000000?ooo`<00000103oool200000080oooo0P0000020?ooo`80000000<0oooo000000000000
0P3oool200000080oooo0P0000000`3oool0000000000003000000040?ooo`00000000000?ooo`80
000000<0oooo0000000000000P3oool2000000040?ooo`000000000000000?l0ooooQ@3oool00`1V
IVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`0101V
IVH0oooo0000003oool=0<c<o`030000003oool0oooo0080oooo100000030?ooo`8000000`3oool4
00000080oooo0P0000000`3oool00000000000020?ooo`8000000P3oool2000000050?ooo`000000
00000000003oool00`000000103oool000000000003oool2000000@0oooo0P000000103oool00000
0000003oool200000080oooo0P0000000`3oool00000000000020?ooo`800000o`3ooon20?ooo`03
06IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c004
06IVIP3oool000000?ooo`d0c<co00<000000?ooo`3oool00P3oool2000000D0oooo0P0000030?oo
o`80000000<0oooo0000000000000P0000000`3oool000000000000200000080oooo100000020?oo
o`80000000<0oooo0000000000000P3oool200000080oooo0P0000040?ooo`80000000<0oooo0000
000000000P3oool4000000<0oooo1000003o0?oooh<0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00@0IVIV0?ooo`000000oooo1`3<c?l6
0?ooo`030000003oool0oooo0080oooo0P0000030?ooo`8000003P3oool2000001@0oooo0P000007
0?ooo`800000o`3ooon@0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0000000P0oooo1`0000050?ooo`D00000403oool0
0`000000oooo0?ooo`0B0?ooo`D0000000@0oooo000000000000oooo0P00003o0?oooi00oooo00<0
IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0
IVIV0?ooo`3oool02000000609VIc0030000003oool0oooo0?l0oooob03oool00`1VIVH0oooo0<c<
c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo0?oo
o`080?ooo`L0IVJIo`3oooo:0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R04000000000
1028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0oooo00T0oooo1P1VIYWo0?ooolX0oooo00<0
IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0
IVIV0?ooo`3oool0o`3ooooI0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R04000000000
1028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0oooo0?l0oooof@3oool00`1VIVH0oooo0<c<
c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo0?oo
o`3o0?ooomT0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0
R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool0o`3ooooI0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28
`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0oooo0?l0oooof@3o
ool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<
c<`00`1VIVH0oooo0?ooo`3o0?ooomT0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@00
0000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool0o`3ooooI0?ooo`0306IVIP3o
ool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3o
ool0oooo0?l0oooof@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h
0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo0?ooo`0S0?ooo`@00000o`3ooonb0?ooo`0306IVIP3o
ool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3o
ool0000000l000004`3oool010000000oooo0?ooo`3oool200000?l0oooo/@3oool00`1VIVH0oooo
0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`0101VIVH0oooo
0000003oool=0<c<o`030000003oool0oooo0080oooo0P0000040?ooo`80000000<0oooo00000000
00000P0000030?ooo`80000000@0oooo000000000000oooo0P0000020?ooo`@000000`3oool20000
00030?ooo`000000000000@0oooo1@0000020?ooo`80000000<0oooo0000000000000P3oool40000
0080oooo0P0000020?ooo`800000o`3ooon20?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@
R040000000001028`;P0b>3H08S0^028`;P<0<c<c00406IVIP3oool000000?ooo`d0c<co00<00000
0?ooo`3oool00P3oool2000000<0oooo0P0000000`3oool00000000000020?ooo`80000000@0oooo
000000000000oooo0`000000103oool000000000003oool200000080oooo0P0000000`3oool00000
000000020?ooo`8000000`3oool200000080oooo0P0000000`3oool00000000000020?ooo`800000
00<0oooo0000000000000P3oool2000000030?ooo`00000000000080oooo0P00003o0?oooh80oooo
00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<
00@0IVIV0?ooo`000000oooo3@3<c?l00`000000oooo0?ooo`020?ooo`8000000`3oool200000003
0?ooo`000000000000D0oooo0P0000020?ooo`80000000<0oooo000000000000103oool300000003
0?ooo`00000000000080oooo0P0000030?ooo`8000000P3oool2000000030?ooo`00000000000080
oooo0P0000000`3oool00000000000020?ooo`80000000<0oooo0000000000000P3oool200000?l0
ooooPP3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0
R<2h303<c<`0101VIVH0oooo0000003oool=0<c<o`030000003oool0oooo0080oooo0P0000020?oo
o`8000000P3oool6000000030?ooo`00000000000080oooo0P0000000`3oool00000000000020?oo
o`@000000P3oool200000080oooo0P0000040?ooo`80000000@0oooo000000000000oooo0P000002
0?ooo`80000000<0oooo0000000000000P3oool2000000030?ooo`00000000000080oooo0P00003o
0?oooh80oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^0`0c<c<00@0IVIV0?ooo`000000oooo3@3<c?l00`000000oooo0?ooo`020?ooo`H000000P3o
ool200000080oooo0P0000000`3oool00000000000020?ooo`80000000@0oooo000000000000oooo
0`0000040?ooo`8000000P3oool2000000D0oooo100000000`3oool00000000000020?ooo`800000
00<0oooo0000000000000P3oool2000000030?ooo`00000000000080oooo0P00003o0?oooh80oooo
00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<
00@0IVIV0?ooo`000000oooo3@3<c?l00`000000oooo0?ooo`020?ooo`8000000`3oool200000003
0?ooo`00000000000080oooo0P000000103oool000000000003oool3000000040?ooo`0000000000
0?ooo`8000000P3oool2000000030?ooo`00000000000080oooo0P0000030?ooo`040000003oool0
oooo0?ooo`80000000<0oooo0000000000000P3oool200000080oooo00<000000?ooo`3oool00P00
00001@3oool00000000000000000oooo00800000o`3ooon20?ooo`0306IVIP3oool0c<c<00X0c<c<
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00406IVIP3oool000000?ooo`d0
c<co00<000000?ooo`3oool00P3oool2000000<0oooo0P0000020?ooo`@000000`3oool200000004
0?ooo`00000000000?ooo`8000000P3oool4000000030?ooo`00000000000080000000<0oooo0000
000000000P0000020?ooo`@0000000<0oooo0000000000000P0000000`3oool00000000000020?oo
o`@000000P3oool2000000030?ooo`00000000000?l0ooooP`3oool00`1VIVH0oooo0<c<c00:0<c<
c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`0101VIVH0oooo0000003oool7
0<c<o`H0oooo00<000000?ooo`3oool00P3oool2000000<0oooo0P00000I0?ooo`8000003P3oool2
00000?l0ooooU03oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SP
f028`;P0R<2h303<c<`00`1VIVH0oooo000000080?ooo`L00000103oool600000100oooo0P000009
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool00P00003o0?oooi00oooo00<0IVIV
0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV
0?ooo`3oool02000000609VIc0030000003oool0oooo0?l0oooob03oool00`1VIVH0oooo0<c<c00:
0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo0?ooo`08
0?ooo`L0IVJIo`3oooo:0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0oooo00T0oooo1P1VIYWo0?ooolX0oooo00<0IVIV
0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV
0?ooo`3oool0o`3ooooI0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0oooo0?l0oooof@3oool00`1VIVH0oooo0<c<c00:
0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo0?ooo`3o
0?ooomT0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^0`0c<c<00<0IVIV0?ooo`3oool0o`3ooooI0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P1
04R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0oooo0?l0oooof@3oool0
0`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`0
0`1VIVH0oooo0?ooo`3o0?ooomT0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000
000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool0o`3ooooI0?ooo`0306IVIP3oool0
c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0
oooo0?l0oooof@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SP
f028`;P0R<2h303<c<`00`1VIVH0oooo0?ooo`3o0?ooomT0oooo00<0IVIV0?ooo`3<c<`02P3<c<`2
08S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`0000003`00003o
0?ooolX0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^0`0c<c<00@0IVIV0?ooo`000000oooo3@3<c?l00`000000oooo0?ooo`020?ooo`D00000103o
ool4000000<0oooo100000030?ooo`80000000@0oooo000000000000oooo0P0000020?ooo`800000
0P3oool200000080oooo100000020?ooo`8000000P3oool200000080oooo0P0000020?ooo`D00000
0P3oool2000000030?ooo`00000000000080oooo100000020?ooo`8000000P3oool200000?l0oooo
L@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
303<c<`0101VIVH0oooo0000003oool=0<c<o`030000003oool0oooo0080oooo0P0000020?ooo`80
00000P3oool200000080oooo0P0000000`3oool00000000000020?ooo`80000000@0oooo00000000
0000oooo0`0000000`3oool00000000000020?ooo`8000000P3oool2000000030?ooo`0000000000
0080oooo0P0000000`3oool00000000000020?ooo`80000000<0oooo0000000000000P3oool20000
0080oooo0P0000000`3oool00000000000020?ooo`80000000<0oooo0000000000000P3oool20000
00030?ooo`00000000000080oooo0P00003o0?ooog40oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00@0IVIV0?ooo`000000oooo3@3<c?l0
0`000000oooo0?ooo`020?ooo`8000000`3oool2000000030?ooo`00000000000080oooo0P000000
0`3oool00000000000050?ooo`8000000P3oool2000000030?ooo`00000000000080oooo0P000002
0?ooo`80000000<0oooo0000000000001@3oool200000080oooo0P0000000`3oool0000000000002
0?ooo`8000000P3oool2000000030?ooo`00000000000080oooo0P0000000`3oool0000000000002
0?ooo`80000000<0oooo0000000000000P3oool200000?l0ooooL@3oool00`1VIVH0oooo0<c<c00:
0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`0101VIVH0oooo0000003o
ool=0<c<o`030000003oool0oooo0080oooo0P0000030?ooo`80000000<0oooo0000000000000P3o
ool2000000030?ooo`000000000000D0oooo0P0000020?ooo`80000000<0oooo0000000000000P3o
ool200000080oooo0P0000000`3oool0000000000004000000030?ooo`00000000000080oooo0P00
00000`3oool00000000000030?ooo`80000000@0oooo000000000000oooo0P0000020?ooo`800000
00<0oooo0000000000000P3oool2000000030?ooo`00000000000080oooo0P00003o0?ooog40oooo
00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<
00@0IVIV0?ooo`000000oooo3@3<c?l00`000000oooo0?ooo`020?ooo`8000000`3oool200000003
0?ooo`00000000000080oooo0P0000000`3oool00000000000050?ooo`8000000P3oool200000003
0?ooo`00000000000080oooo0P0000020?ooo`80000000<0oooo0000000000000P3oool200000003
0?ooo`00000000000080oooo0P0000000`3oool00000000000040?ooo`@0000000<0oooo00000000
00000P3oool2000000030?ooo`00000000000080oooo0P0000000`3oool00000000000020?ooo`80
0000o`3oooma0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H
08S0^028`;P<0<c<c00406IVIP3oool000000?ooo`d0c<co00<000000?ooo`3oool00P3oool20000
00<0oooo0P0000020?ooo`030000003oool0oooo0080000000<0oooo0000000000000P3oool20000
00030?ooo`00000000000080oooo0P0000001@3oool00000000000000000oooo00<0000000@0oooo
000000000000oooo0P0000020?ooo`80000000D0oooo00000000000000000?ooo`02000000030?oo
o`00000000000080oooo00@000000?ooo`3oool0oooo0P0000000`3oool00000000000020?ooo`80
00000P3oool00`000000oooo0?ooo`02000000050?ooo`00000000000000003oool00P00003o0?oo
og40oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^0`0c<c<00@0IVIV0?ooo`000000oooo3@3<c?l00`000000oooo0?ooo`020?ooo`8000000`3oool2
00000080oooo100000030?ooo`@000000P3oool200000080oooo0P000000103oool000000000003o
ool200000080oooo0P0000030?ooo`@000000P3oool2000000040?ooo`00000000000?ooo`@00000
0P3oool4000000030?ooo`00000000000080000000<0oooo0000000000000P3oool400000080oooo
0P0000000`3oool000000000003o0?ooog80oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^0`0c<c<00@0IVIV0?ooo`000000oooo1`3<c?l60?ooo`03
0000003oool0oooo0080oooo0P0000020?ooo`800000<03oool2000000T0oooo0P00003o0?oooh<0
oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0
c<c<00<0IVIV0?ooo`000000203oool7000000@0oooo1@00000b0?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool00P00003o0?ooogl0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool02000000609VIc003
0000003oool0oooo0?l0oooob03oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P100000000
00@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo0?ooo`080?ooo`L0IVJIo`3oooo:0?ooo`03
06IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c003
06IVIP3oool0oooo00T0oooo1P1VIYWo0?ooolX0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool0o`3ooooI0?ooo`03
06IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c003
06IVIP3oool0oooo0?l0oooof@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P100000000
00@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo0?ooo`3o0?ooomT0oooo00<0IVIV0?ooo`3<
c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3o
ool0o`3ooooI0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H
08S0^028`;P<0<c<c00306IVIP3oool0oooo0?l0oooof@3oool00`1VIVH0oooo0<c<c00:0<c<c080
R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo0?ooo`3o0?ooomT0
oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0
c<c<00<0IVIV0?ooo`3oool0o`3ooooI0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0oooo0?l0oooof@3oool00`1VIVH0
oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0
oooo0?ooo`0a0?ooo`@00000o`3ooonT0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0000000l000008@3oool010000000
oooo0?ooo`3oool200000?l0ooooX`3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2h303<c<`0101VIVH0oooo0000003oool=0<c<o`030000003oool0
oooo00@0oooo100000030?ooo`@000000P3oool200000080oooo0P0000000`3oool0000000000002
0?ooo`8000000P3oool2000000030?ooo`00000000000080oooo0P000000103oool000000000003o
ool2000000@0oooo1@0000020?ooo`80000000<0oooo0000000000000P3oool400000080oooo0P00
00020?ooo`800000o`3ooomk0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R04000000000
1028`;P0b>3H08S0^028`;P<0<c<c00406IVIP3oool000000?ooo`d0c<co00<000000?ooo`3oool0
0`3oool200000080oooo0P0000000`3oool00000000000020?ooo`80000000<0oooo000000000000
0P3oool2000000030?ooo`00000000000080oooo0P000000103oool000000000003oool300000004
0?ooo`00000000000?ooo`<0000000<0oooo0000000000000`3oool200000080oooo0P0000000`3o
ool00000000000020?ooo`80000000<0oooo0000000000000P3oool2000000030?ooo`0000000000
0080oooo0P00003o0?ooog/0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^0`0c<c<00@0IVIV0?ooo`000000oooo3@3<c?l00`000000oooo0?ooo`02
0?ooo`8000001P3oool200000080oooo0P0000000`3oool00000000000020?ooo`80000000<0oooo
0000000000000P3oool2000000030?ooo`00000000000080oooo0P0000000`3oool0000000000002
0?ooo`80000000<0oooo0000000000000`3oool200000080oooo0P0000000`3oool0000000000002
0?ooo`80000000<0oooo0000000000000P3oool2000000030?ooo`00000000000080oooo0P00003o
0?ooog/0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^0`0c<c<00@0IVIV0?ooo`000000oooo3@3<c?l00`000000oooo0?ooo`020?ooo`8000001P3o
ool200000080oooo0P0000000`3oool00000000000020?ooo`80000000<0oooo0000000000000P3o
ool2000000030?ooo`00000000000080oooo0P0000000`3oool00000000000020?ooo`80000000<0
oooo000000000000103oool2000000040?ooo`00000000000?ooo`8000000P3oool2000000030?oo
o`00000000000080oooo0P0000000`3oool00000000000020?ooo`800000o`3ooomk0?ooo`0306IV
IP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00406IV
IP3oool000000?ooo`d0c<co00<000000?ooo`3oool00P3oool2000000H0oooo0P0000020?ooo`80
000000<0oooo0000000000000P3oool2000000030?ooo`00000000000080oooo0P0000000`3oool0
0000000000020?ooo`80000000<0oooo0000000000000P3oool2000000030?ooo`000000000000D0
oooo100000000`3oool00000000000020?ooo`80000000<0oooo0000000000000P3oool200000003
0?ooo`00000000000080oooo0P00003o0?ooog/0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00@0IVIV0?ooo`000000oooo3@3<c?l00`00
0000oooo0?ooo`020?ooo`8000001`3oool00`000000oooo0?ooo`02000000050?ooo`0000000000
0000003oool00P0000000`3oool00000000000020?ooo`80000000@0oooo000000000000oooo0`00
00000`3oool00000000000020?ooo`80000000<0oooo0000000000000`3oool010000000oooo0?oo
o`3oool2000000030?ooo`00000000000080oooo0P0000020?ooo`030000003oool0oooo00800000
00D0oooo00000000000000000?ooo`0200000?l0ooooN`3oool00`1VIVH0oooo0<c<c00:0<c<c080
R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`0101VIVH0oooo0000003oool=0<c<
o`030000003oool0oooo0080oooo0P0000070?ooo`@000000P3oool2000000040?ooo`0000000000
0?ooo`@0000000<0oooo0000000000000P3oool2000000040?ooo`00000000000?ooo`8000000P3o
ool2000000030?ooo`0000000000008000000P3oool4000000030?ooo`00000000000080000000<0
oooo0000000000000P3oool400000080oooo0P0000000`3oool000000000003o0?ooog`0oooo00<0
IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00@0
IVIV0?ooo`000000oooo1`3<c?l60?ooo`030000003oool0oooo00<0oooo0P0000020?ooo`800000
3`3oool2000001l0oooo0P00003o0?ooohd0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`000000203oool7000000H0oooo
1000000A0?ooo`D00000703oool00`000000oooo0?ooo`0200000?l0ooooR@3oool00`1VIVH0oooo
0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo
0?ooo`08000000H0VIW<00<000000?ooo`3oool0o`3oooo80?ooo`0306IVIP3oool0c<c<00X0c<c<
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0oooo00P0oooo
1`1VIYWo0?ooolX0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool02@3oool606IVVOl0oooobP3oool00`1VIVH0oooo
0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo
0?ooo`3o0?ooomT0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool0o`3ooooI0?ooo`0306IVIP3oool0c<c<00X0c<c<
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0oooo0?l0oooo
f@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
303<c<`00`1VIVH0oooo0?ooo`3o0?ooomT0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool0o`3ooooI0?ooo`0306IV
IP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00306IV
IP3oool0oooo0?l0oooof@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0
R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo0?ooo`3o0?ooomT0oooo00<0IVIV0?ooo`3<c<`0
2P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool0
N@3oool=00000?l0ooooD`3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0
R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0oooo0?ooo`1i0?ooo`030000003<c?l0c<co00T0c<co
00<000000?ooo`3oool0o`3ooomA0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0000000l00000JP3oool00`000000c<co
0?ooo`080?ooo`030<c<o`000000oooo0?l0ooooDP3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`0101VIVH0oooo0000003oool=0<c<o`03
0000003oool0oooo0080oooo0P0000030?ooo`8000000P3oool2000000030?ooo`00000000000080
oooo0P0000000`3oool00000000000030?ooo`@000000`3oool200000080oooo0P0000020?ooo`@0
0000>`3oool00`000000c<co0?ooo`080?ooo`030<c<o`000000oooo00@0oooo0P0000020?ooo`03
0000003oool0oooo008000000P3oool500000080oooo0P0000000`3oool00000000000020?ooo`80
000000<0oooo0000000000000`3oool200000080oooo100000020?ooo`8000000`3oool200000080
oooo0P0000020?ooo`@000000P3oool2000000030?ooo`00000000000080oooo100000020?ooo`80
00000P3oool200000080oooo1000003f0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;P<0<c<c00406IVIP3oool000000?ooo`d0c<co00<000000?oo
o`3oool00P3oool2000000<0oooo0P000000103oool000000000003oool3000000040?ooo`000000
00000?ooo`<000000P3oool200000080oooo0P0000020?ooo`8000000P3oool2000000030?ooo`00
000000000080oooo0P00000j0?ooo`030000003<c?l0oooo00P0oooo00<0c<co0000003oool0103o
ool2000000050?ooo`00000000000000003oool00P0000000`3oool00000000000020?ooo`800000
00<0oooo0000000000000P3oool200000080oooo0P0000000`3oool00000000000030?ooo`800000
00<0oooo0000000000000P3oool2000000030?ooo`000000000000<0oooo0P0000020?ooo`800000
00<0oooo0000000000000P3oool2000000040?ooo`00000000000?ooo`80000000<0oooo00000000
00000P3oool2000000030?ooo`00000000000080oooo0P0000000`3oool00000000000020?ooo`80
0000m@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0
R<2h303<c<`0101VIVH0oooo0000003oool=0<c<o`030000003oool0oooo0080oooo1`0000000`3o
ool00000000000020?ooo`80000000<0oooo0000000000000P3oool2000000030?ooo`0000000000
00@0oooo0P0000000`3oool00000000000020?ooo`800000103oool3000003X0oooo00<000000<c<
o`3oool0203oool00`3<c?l000000?ooo`040?ooo`80000000D0oooo00000000000000000?ooo`02
000000030?ooo`00000000000080oooo0P0000000`3oool00000000000020?ooo`8000000P3oool2
000000030?ooo`00000000000080oooo0P0000020?ooo`8000001@3oool2000000<0oooo0P000002
0?ooo`80000000<0oooo0000000000001@3oool2000000@0oooo0P0000060?ooo`@000000P3oool2
00000?T0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^0`0c<c<00@0IVIV0?ooo`000000oooo3@3<c?l00`000000oooo0?ooo`030?ooo`80000000<0
oooo0000000000000P3oool200000080oooo0P0000000`3oool00000000000020?ooo`80000000<0
oooo000000000000103oool2000000030?ooo`00000000000080oooo0P0000020?ooo`@00000>`3o
ool00`000000c<co0?ooo`080?ooo`030<c<o`000000oooo00@0oooo0P0000001@3oool000000?oo
o`000000oooo008000000P3oool2000000040?ooo`00000000000?ooo`8000000P3oool200000080
oooo0P0000000`3oool00000000000020?ooo`8000000P3oool6000000030?ooo`000000000000<0
oooo0P0000020?ooo`80000000<0oooo000000000000100000000`3oool00000000000040?ooo`H0
00000`3oool2000000<0oooo1P00003e0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;P<0<c<c00406IVIP3oool000000?ooo`d0c<co00<000000?oo
o`3oool00`3oool2000000030?ooo`00000000000080oooo0P0000020?ooo`80000000<0oooo0000
000000000P3oool2000000030?ooo`000000000000@0oooo0P0000000`3oool00000000000020?oo
o`80000000@0oooo0000000000000000?@3oool00`000000c<co0?ooo`080?ooo`030<c<o`000000
oooo00@0oooo0P0000001@3oool000000?ooo`000000oooo008000000`3oool4000000030?ooo`00
000000000080oooo0P0000020?ooo`80000000<0oooo000000000000100000020?ooo`8000000P3o
ool2000000030?ooo`000000000000<0oooo0P0000020?ooo`80000000<0oooo0000000000000P3o
ool2000000030?ooo`000000000000@0oooo0P0000020?ooo`8000000P3oool400000080oooo0P00
00020?ooo`800000m@3oool00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h
0<SPf028`;P0R<2h303<c<`0101VIVH0oooo0000003oool=0<c<o`030000003oool0oooo00<0oooo
0P0000000`3oool00000000000020?ooo`80000000D0oooo00000000000000000?ooo`0200000005
0?ooo`00000000000000003oool00P0000040?ooo`80000000D0oooo00000000000000000?ooo`02
000000030?ooo`00000000000080oooo0P00000j0?ooo`030000003<c?l0oooo00P0oooo00<0c<co
0000003oool0103oool4000000030?ooo`00000000000080000000<0oooo0000003oool00P3oool2
000000030?ooo`00000000000080oooo0`000000103oool000000000003oool5000000<0oooo0P00
00020?ooo`80000000<0oooo0000000000000`3oool3000000040?ooo`00000000000?ooo`800000
0P3oool2000000030?ooo`000000000000@0oooo0P0000020?ooo`80000000<0oooo000000000000
0P3oool2000000030?ooo`00000000000080oooo0P00003e0?ooo`0306IVIP3oool0c<c<00X0c<c<
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c00406IVIP3oool000000?ooo`d0
c<co00<000000?ooo`3oool00`3oool2000000030?ooo`000000000000<0oooo0P0000000`3oool0
0000000000020?ooo`80000000@0oooo000000000000oooo0P0000040?ooo`80000000@0oooo0000
00000000oooo0P0000030?ooo`@00000>`3oool00`000000c<co0?ooo`080?ooo`8000001@3oool4
000000030?ooo`0000000000008000000P3oool4000000030?ooo`00000000000080000000@0oooo
000000000000oooo0P0000020?ooo`80000000<0oooo000000000000103oool400000080oooo1000
0000103oool000000000003oool2000000<0oooo100000020?ooo`8000001@3oool400000080oooo
0P0000020?ooo`8000000P3oool400000?H0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^0`0c<c<00@0IVIV0?ooo`000000oooo1`3<c?l60?ooo`03
0000003oool0oooo00@0oooo0`0000070?ooo`8000001@3oool200000080oooo0P0000020?ooo`80
0000B@3oool00`000000c<co0?ooo`070?ooo`8000001P3oool3000000<0oooo0`0000080?ooo`80
00000P3oool2000000D0oooo0P0000020?ooo`800000703oool200000?l0oooo3P3oool00`1VIVH0
oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`00`1VIVH0
oooo000000080?ooo`L000001P3oool3000000L0oooo0P0000050?ooo`8000000`3oool4000004X0
oooo00<000000<c<o`3oool01P3oool00`000000c<co000000060?ooo`<000000`3oool3000000T0
oooo00<000000?ooo`3oool00P0000050?ooo`8000000`3oool2000001/0oooo0P00003o0?ooo`h0
oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0
c<c<00<0IVIV0?ooo`3oool02000000609VIc0030000003oool0oooo06P0oooo00<000000<c<o`3o
ool01@3oool00`000000c<co0000003o0?oooeD0oooo00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool0203oool706IVVFX0
oooo00<000000<c<o`3oool0103oool010000000c<co0?ooo`00003o0?oooeD0oooo00<0IVIV0?oo
o`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?oo
o`3oool02@3oool606IVVFX0oooo00<000000<c<o`3<c?l01@3<c?l200000?l0ooooEP3oool00`1V
IVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`00`1V
IVH0oooo0?ooo`1i0?ooo`X00000o`3ooomF0?ooo`0306IVIP3oool0c<c<00X0c<c<0P28`;P104R@
R040000000001028`;P0b>3H08S0^028`;P<0<c<c00306IVIP3oool0oooo0?l0oooof@3oool00`1V
IVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h303<c<`00`1V
IVH0oooo0?ooo`3o0?ooomT0oooo00<0c<c<0?ooo`3<c<`02P3<c<`208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^0`0c<c<00<0IVIV0?ooo`3oool0o`3ooooI0?ooo`0306IVIP3oool0c<c<
00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P<0<c<c?l0IVIVg@1VIVH<0<c<
c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<ce0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2ho`3<c<ce0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028
`;P0R<2ho`3<c<ce0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<ce0<c<
c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<ce0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2ho`3<c<ce0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028
`;P0R<2ho`3<c<ce0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<ce0<c<
c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<ce0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2ho`3<c<ce0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028
`;P0R<2ho`3<c<ce0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h=03<c<co0?oo
ob@0ooooW@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^3<0c<c<00<0IVIV0<c<
c01VIVH0o`1VIVHQ06IVIP030?ooo`3<c<`0c<c<09/0c<c<0P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;Pc0<c<c00306IVIP3oool0c<c<0?l0c<c<803<c<`00`1VIVH0oooo0<c<c00;0<c<
c1L0oooo1P3<c<`G0?ooo`H0c<c<5`3oool60<c<c1L0oooo00<0c<c<0?ooo`3oool05@3oool;0<c<
c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h<`3<c<`00`1VIVH0oooo0<c<c03o0<c<
c200c<c<00<0IVIV0?ooo`3<c<`02P3<c<`00`1VIVH0c<c<06IVIP0D06IVIP030?ooo`3<c<`0c<c<
00<0c<c<00<0IVIV0<c<c01VIVH0501VIVH00`3oool0c<c<0<c<c0030<c<c00306IVIP3<c<`0IVIV
01@0IVIV00<0oooo0<c<c03<c<`00`3<c<`00`1VIVH0VIVI06IVIP0D06IVIP030?ooo`1VIVH0c<c<
01D0IVIV00<0oooo0<c<c03<c<`02@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^3<0c<c<00<0IVIV0?ooo`3<c<`0o`3<c<`P0<c<c00306IVIP3oool0c<c<00X0c<c<00<0IVIV0?oo
o`3<c<`04`3<c<`00`1VIVH0oooo0<c<c0040<c<c00306IVIP3oool0c<c<01<0c<c<00<0IVIV0?oo
o`3<c<`0103<c<`00`1VIVH0oooo0<c<c00C0<c<c00306IVIP3oool0c<c<00@0c<c<00<0IVIV0<c<
c02IVIT04`2IVIT0101VIVH0oooo06IVIP3ooolD0<c<c00306IVIP3oool0c<c<00X0c<c<0P28`;P1
04R@R040000000001028`;P0b>3H08S0^028`;Pc0<c<c00306IVIP3oool0c<c<0?l0c<c<803<c<`0
0`1VIVH0oooo0<c<c00:0<c<c00306IVIP3oool0c<c<01<0c<c<00<0IVIV0?ooo`3<c<`0103<c<`0
0`1VIVH0oooo0<c<c00C0<c<c00306IVIP3oool0c<c<00@0c<c<00<0IVIV0?ooo`3<c<`04`3<c<`0
0`1VIVH0oooo0<c<c0040<c<c00306IVIP3<c<`0VIVI01<0VIVI00@0IVIV0?ooo`1VIVH0oooo503<
c<`00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h<`3<
c<`00`1VIVH0oooo0<c<c03o0<c<c200c<c<00<0IVIV0?ooo`3<c<`02P3<c<`00`1VIVH0oooo0<c<
c0080<c<c0030000003<c<`0c<c<00P0c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo0<c<
c00C0<c<c00306IVIP3oool0c<c<00@0c<c<00<0IVIV0?ooo`3<c<`04`3<c<`00`1VIVH0oooo0<c<
c0040<c<c00306IVIP3<c<`0VIVI01<0VIVI00@0IVIV0?ooo`1VIVH0oooo503<c<`00`1VIVH0oooo
0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h<`3<c<`00`1VIVH0oooo
0<c<c03o0<c<c200c<c<00<0IVIV0?ooo`3<c<`02P3<c<`00`1VIVH0oooo0<c<c0080<c<c0030000
003<c<`0c<c<00P0c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo0<c<c0030<c<c0/00000
1@3<c<`00`1VIVH0oooo0<c<c0040<c<c00306IVIP3oool0c<c<01<0c<c<00<0IVIV0?ooo`3<c<`0
103<c<`00`1VIVH0c<c<09VIV@0209VIV@D000000`2IVIT5000000@0VIVI00@0IVIV0?ooo`1VIVH0
oooo0`3<c<`5000000`0c<c<00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0
^038h=P0R<2h08S0^0h0c<c<100000080<c<c080000000@0c<c<000000000000c<c<0P0000000`3<
c<`000000000000>0<c<c00306IVIP3oool0c<c<0080c<c<4000003o0<c<c0h0c<c<00<0IVIV0?oo
o`3<c<`02P3<c<`0101VIVH0oooo0<c<c03<c<`?000000<0c<c<00<0IVIV0?ooo`3<c<`0103<c<`0
0`1VIVH0oooo0<c<c0030<c<c0040000003<c?l0c<co000000<0c<c<00@000000<c<o`3<c?l00000
1@3<c<`00`1VIVH0oooo0<c<c0040<c<c00406IVIP3oool0c<c<0<c<c0l000000`3<c<`00`1VIVH0
oooo0<c<c0040<c<c00306IVIP3<c<`0VIVI0080VIVI00D000000<c<o`3<c?l0c<co0000000309VI
V@050000003<c?l0c<co0<c<o`000000102IVIT0101VIVH0oooo06IVIP3oool30<c<c0050000003<
c?l0c<co0<c<o`000000303<c<`00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0
R<2h0<SPf028`;P0R<2h3`3<c<`00`000000c<c<0<c<c003000000D0c<c<3@00000<0<c<c00306IV
IP3oool0c<c<0080c<c<00<000000?ooo`3<c?l0303<c?l00`000000c<c<0<c<c0050<c<c0800000
0P3<c<`2000000@0c<c<0P00003j0<c<c00306IVIP3oool0c<c<00X0c<c<00H0IVIV0?ooo`3<c<`0
c<c<0000003oool50<c<o`030000003<c?l0c<co00@0c<co00H000000<c<c03<c<`0c<c<06IVIP3o
ool50<c<c00306IVIP3oool0c<c<00<0c<c<00@000000<c<o`3<c?l000000`3<c<`010000000c<co
0<c<o`0000050<c<c00306IVIP3oool0c<c<00@0c<c<00H0IVIV0?ooo`3<c<`0c<c<0000003oool<
0<c<o`060000003<c<`0c<c<0<c<c01VIVH0oooo1@3<c<`00`1VIVH0c<c<09VIV@0209VIV@0?0000
003<c?l0oooo0<c<o`000000VIVI0000002IVIT000000<c<o`3oool0c<co0000002IVIT000000080
VIVI00@0IVIV0?ooo`1VIVH0oooo0`3<c<`01P000000c<co0?ooo`3<c?l000000<c<c0P000000`3<
c<`00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h403<
c<`3000000040<c<c00000000000000000@0c<c<00L000000<c<c000000000000<c<c0000000c<c<
0080000000<0c<c<000000000000303<c<`00`1VIVH0oooo0<c<c0020<c<c0030000003oool0c<co
00`0c<co00<000000<c<c03<c<`01@3<c<`200000080c<c<0P0000040<c<c0800000nP3<c<`00`1V
IVH0oooo0<c<c00:0<c<c00606IVIP3oool0c<c<0<c<c0000000oooo0P3<c?l7000000<0c<co00H0
00000<c<c03<c<`0c<c<06IVIP3oool50<c<c00306IVIP3oool0c<c<00<0c<c<00@000000<c<o`3<
c?l000000P3<c<`01@1VIVH000000<c<o`3<c?l0000000D0c<c<00<0IVIV0?ooo`3<c<`0103<c<`0
1P1VIVH0oooo0<c<c03<c<`000000?ooo``0c<co00H000000<c<c03<c<`0c<c<06IVIP3oool50<c<
c00306IVIP3<c<`0VIVI0080VIVI00D000000<c<o`3oool0c<co0000000309VIV@050000003<c?l0
oooo0<c<o`000000102IVIT0101VIVH0oooo06IVIP3oool30<c<c0050000003<c?l0oooo0<c<o`00
0000303<c<`00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0
R<2h303<c<`00`000000c<c<00000002000000030<c<c0000000000000800000103<c<`;000000h0
c<c<00<0IVIV0?ooo`3<c<`00P3<c<`00`000000oooo0<c<o`0<0<c<o`030000003<c<`0c<c<0080
c<c<1P0000070<c<c0800000nP3<c<`00`1VIVH0oooo0<c<c00:0<c<c00606IVIP3oool0c<c<0<c<
c0000000oooo0`3<c?l5000000@0c<co00H000000<c<c03<c<`0c<c<06IVIP3oool50<c<c00306IV
IP3oool0c<c<00<0c<c<00@000000<c<o`3<c?l000000`3<c<`010000000c<co0<c<o`0000050<c<
c00306IVIP3oool0c<c<00@0c<c<00H0IVIV0?ooo`3<c<`0c<c<0000003oool<0<c<o`060000003<
c<`0c<c<0<c<c01VIVH0oooo1@3<c<`00`1VIVH0c<c<09VIV@0209VIV@050000003<c?l0c<co0<c<
o`0000000`2IVIT01@000000c<co0<c<o`3<c?l0000000@0VIVI00@0IVIV0?ooo`1VIVH0oooo0`3<
c<`01@000000c<co0<c<o`3<c?l0000000`0c<c<00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^0`0c<c<20000000103<c<`000000000000000020<c<c080
000000<0c<c<0000000000000P0000020<c<c08000003P3<c<`00`1VIVH0oooo0<c<c0020<c<c003
0000003oool0c<co00`0c<co00<000000<c<c03<c<`00P3<c<`00`000000c<c<0<c<c002000000P0
c<c<0P00003_0<c<c08000002@3<c<`00`1VIVH0oooo0<c<c00:0<c<c00606IVIP3oool0c<c<0<c<
c0000000oooo103<c?l3000000D0c<co00H000000<c<c03<c<`0c<c<06IVIP3oool50<c<c00306IV
IP3oool0c<c<00<0c<c<00@000000<c<o`3<c?l000000`3<c<`010000000c<co0<c<o`0000050<c<
c00306IVIP3oool0c<c<00@0c<c<00H0IVIV0?ooo`3<c<`0c<c<0000003oool<0<c<o`060000003<
c<`0c<c<0<c<c01VIVH0oooo1@3<c<`00`1VIVH0c<c<09VIV@0209VIV@@00000102IVIT4000000D0
VIVI00@0IVIV0?ooo`1VIVH0oooo0`3<c<`4000000d0c<c<00<0IVIV0?ooo`3<c<`02P3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^0l0c<c<1`0000040<c<c080000000<0c<c<0000
000000001P00000>0<c<c00306IVIP3oool0c<c<0080c<c<00<000000?ooo`3<c?l0303<c?l00`00
0000c<c<0<c<c0030<c<c0040000003<c<`00000000000P0c<c<0P00003^0<c<c0@00000203<c<`0
0`1VIVH0oooo0<c<c00:0<c<c00606IVIP3oool0c<c<0<c<c0000000oooo1@3<c?l00`000000c<co
0<c<o`040<c<o`060000003<c<`0c<c<0<c<c01VIVH0oooo1@3<c<`00`1VIVH0oooo0<c<c0030<c<
c0030000003<c?l0c<co00D000000P3<c?l00`000000c<c<0<c<c0030<c<c00306IVIP3oool0c<c<
00@0c<c<00H0IVIV0?ooo`3<c<`0c<c<0000003oool<0<c<o`060000003<c<`0c<c<0<c<c01VIVH0
oooo1@3<c<`00`1VIVH0c<c<09VIV@0C09VIV@0406IVIP3oool0IVIV0?oooa@0c<c<00<0IVIV0?oo
o`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0d0c<c<2`0000020<c<
c0H000001@3<c<`2000000`0c<c<00<0IVIV0?ooo`3<c<`00P3<c<`00`000000oooo0<c<o`0<0<c<
o`030000003<c<`0c<c<00<0c<c<00@000000<c<c000000000001P3<c<`010000000c<c<00000000
003]0<c<c0H000001`3<c<`00`1VIVH0oooo0<c<c00:0<c<c00606IVIP3oool0c<c<0<c<c0000000
oooo303<c?l01P000000c<c<0<c<c03<c<`0IVIV0?ooo`D0c<c<00L0IVIV0?ooo`3<c<`0c<c<0000
003<c<`0000000T0c<co00<000000<c<c00000000`3<c<`00`1VIVH0oooo0<c<c0040<c<c00606IV
IP3oool0c<c<0<c<c0000000oooo303<c?l01P000000c<c<0<c<c03<c<`0IVIV0?ooo`D0c<c<00<0
IVIV0<c<c02IVIT04`2IVIT0101VIVH0oooo06IVIP3ooolD0<c<c00306IVIP3oool0c<c<00X0c<c<
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P>0<c<c0030000003<c<`0c<c<00800000
0P3<c<`00`000000c<c<0<c<c0020<c<c080000000<0c<c<0000000000002000000<0<c<c00306IV
IP3oool0c<c<0080c<c<00<000000?ooo`3<c?l0303<c?l00`000000c<c<0<c<c0040<c<c0<00000
1P3<c<`400000>`0c<c<200000060<c<c00306IVIP3oool0c<c<00X0c<c<00H0IVIV0?ooo`3<c<`0
c<c<0000003oool70<c<o`D0oooo00H000000<c<c03<c<`0c<c<06IVIP3oool50<c<c00306IVIP3o
ool0c<c<0080c<c<0P00000906IVIP800000103<c<`00`1VIVH0oooo0<c<c0040<c<c00606IVIP3o
ool0c<c<0<c<c0000000oooo1`3<c?l50?ooo`060000003<c<`0c<c<0<c<c01VIVH0oooo1@3<c<`0
0`1VIVH0c<c<09VIV@0209VIV@D000000`2IVIT5000000@0VIVI00@0IVIV0?ooo`1VIVH0oooo0`3<
c<`5000000`0c<c<00<0IVIV0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0
R<2h08S0^0h0c<c<2@0000030<c<c080000000@0c<c<000000000000c<c<0P0000000`3<c<`00000
0000000>0<c<c00306IVIP3oool0c<c<0080c<c<00<000000?ooo`3<c?l01P3<c?l60?ooo`030000
003<c<`0c<c<00@0c<c<0`0000070<c<c0<00000j`3<c<`:000000D0c<c<00<0IVIV0?ooo`3<c<`0
2P3<c<`01@1VIVH0oooo0<c<c03<c<`0000000P0oooo1P0000030<c<c00306IVIP3oool0c<c<00@0
c<c<00<0IVIV0?ooo`3<c<`00`3<c<`00`000000IVIV06IVIP0706IVIP030000003<c<`0c<c<00<0
c<c<00<0IVIV0?ooo`3<c<`0103<c<`01@1VIVH0oooo0<c<c03<c<`0000000P0oooo1P0000030<c<
c00306IVIP3oool0c<c<00@0c<c<00<0IVIV0<c<c02IVIT00P2IVIT01@000000c<co0<c<o`3<c?l0
000000<0VIVI00D000000<c<o`3<c?l0c<co0000000409VIV@0406IVIP3oool0IVIV0?ooo`<0c<c<
00D000000<c<o`3<c?l0c<co0000000<0<c<c00306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;P@0<c<c080000000<0c<c<0000000000001@3<c<`;000000h0
c<c<00<0IVIV0?ooo`3<c<`00P3<c<`00`000000oooo0?ooo`060?ooo`L000001`3<c<`2000000P0
c<c<0P00003j0<c<c00306IVIP3oool0c<c<00X0c<c<00<0IVIV0?ooo`3<c<`00P3<c<`8000000D0
c<co00H000000<c<c03<c<`0c<c<06IVIP3oool50<c<c00306IVIP3oool0c<c<00@0c<c<00<00000
06IVIP1VIVH01@1VIVH00`000000c<c<0<c<c0040<c<c00306IVIP3oool0c<c<00@0c<c<00<0IVIV
0?ooo`3<c<`00P3<c<`8000000D0c<co00H000000<c<c03<c<`0c<c<06IVIP3oool50<c<c00306IV
IP3<c<`0VIVI0080VIVI00l000000<c<o`3oool0c<co0000002IVIT0000009VIV@000000c<co0?oo
o`3<c?l0000009VIV@0000000P2IVIT0101VIVH0oooo06IVIP3oool30<c<c0060000003<c?l0oooo
0<c<o`000000c<c<200000030<c<c00306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R04000000000
1028`;P0b>3H08S0^028`;PA0<c<c0<000007`3<c<`00`1VIVH0oooo0<c<c0030<c<c0P000001P2I
VL`00`000000c<c<0<c<c03o0<c<c0`0c<c<00<0IVIV0?ooo`3<c<`02P3<c<`00`1VIVH0oooo0<c<
c00:0<c<c0H0IVJI0`3<c<`00`1VIVH0oooo0<c<c0040<c<c00306IVIP3oool0c<c<00D0c<c<00<0
000006IVIP1VIVH00`1VIVH2000000H0c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo0<c<
c00:0<c<c0H0IVJI0`3<c<`00`1VIVH0oooo0<c<c0040<c<c00306IVIP3<c<`0VIVI0080VIVI00D0
00000<c<o`3oool0c<co0000000309VIV@050000003<c?l0oooo0<c<o`000000102IVIT0101VIVH0
oooo06IVIP3oool30<c<c0050000003<c?l0oooo0<c<o`000000303<c<`00`1VIVH0oooo0<c<c00:
0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h<`3<c<`00`1VIVH0oooo0<c<c00;
0<c<c0L0IVJIo`3<c<`>0<c<c00306IVIP3oool0c<c<00X0c<c<00<0IVIV0?ooo`3<c<`02`3<c<`5
06IVV@<0c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo0<c<c0060<c<c0040000001VIVH0
IVIV06IVIP<000001P3<c<`00`1VIVH0oooo0<c<c0040<c<c00306IVIP3oool0c<c<00/0c<c<1@1V
IYT30<c<c00306IVIP3oool0c<c<00@0c<c<00<0IVIV0<c<c02IVIT00P2IVIT01@000000c<co0<c<
o`3<c?l0000000<0VIVI00D000000<c<o`3<c?l0c<co0000000409VIV@0406IVIP3oool0IVIV0?oo
o`<0c<c<00D000000<c<o`3<c?l0c<co0000000<0<c<c00306IVIP3oool0c<c<00X0c<c<0P28`;P1
04R@R040000000001028`;P0b>3H08S0^028`;Pc0<c<c00306IVIP3oool0c<c<00`0c<c<1P1VIYWo
0<c<c0h0c<c<00<0IVIV0?ooo`3<c<`02P3<c<`00`1VIVH0oooo0<c<c00C0<c<c00306IVIP3oool0
c<c<00@0c<c<00<0IVIV0?ooo`3<c<`01`3<c<`010000000IVIV0000003<c<`2000000H0c<c<00<0
IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo0<c<c00C0<c<c00306IVIP3oool0c<c<00@0c<c<00<0
IVIV0<c<c02IVIT00P2IVIT4000000@0VIVI1000000509VIV@0406IVIP3oool0IVIV0?ooo`<0c<c<
1000000=0<c<c00306IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;Pc0<c<c00306IVIP3oool0c<c<0?l0c<c<803<c<`00`1VIVH0oooo0<c<c00:0<c<c00306IV
IP3oool0c<c<01<0c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo0<c<c0080<c<c0030000
003<c<`0c<c<00P0c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo0<c<c00C0<c<c00306IV
IP3oool0c<c<00@0c<c<00<0IVIV0<c<c02IVIT04`2IVIT0101VIVH0oooo06IVIP3ooolD0<c<c003
06IVIP3oool0c<c<00X0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;Pc0<c<c003
06IVIP3oool0c<c<0?l0c<c<803<c<`00`1VIVH0oooo0<c<c00:0<c<c00306IVIP3oool0c<c<01<0
c<c<00<0IVIV0?ooo`3<c<`0103<c<`00`1VIVH0oooo0<c<c00C0<c<c00306IVIP3oool0c<c<00@0
c<c<00<0IVIV0?ooo`3<c<`04`3<c<`00`1VIVH0oooo0<c<c0040<c<c00306IVIP3<c<`0VIVI01<0
VIVI00@0IVIV0?ooo`1VIVH0oooo503<c<`00`1VIVH0oooo0<c<c00:0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2h<`3<c<`00`1VIVH0oooo0<c<c03o0<c<c200c<c<00<0IVIV0?oo
o`3<c<`02P3<c<`00`1VIVH0oooo0<c<c00C0<c<c00306IVIP3oool0c<c<00@0c<c<00<0IVIV0?oo
o`3<c<`04`3<c<`00`1VIVH0oooo0<c<c0040<c<c00306IVIP3oool0c<c<01<0c<c<00<0IVIV0?oo
o`3<c<`0103<c<`00`1VIVH0c<c<09VIV@0C09VIV@0406IVIP3oool0IVIV0?oooa@0c<c<00<0IVIV
0?ooo`3<c<`02P3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^3<0c<c<00<0IVIV
0?ooo`3<c<`0o`3<c<`P0<c<c00306IVIP3oool0c<c<00X0c<c<00<0IVIV0?ooo`3oool04`3oool0
0`3<c<`0oooo0<c<c0040<c<c00306IVIP3oool0oooo01<0oooo00<0c<c<0?ooo`3<c<`0103<c<`0
0`1VIVH0oooo0?ooo`0C0?ooo`030<c<c03oool0c<c<00@0c<c<00<0IVIV0<c<c03<c<`04`3<c<`0
0`2IVIT0oooo06IVIP0E0?ooo`030<c<c03oool0c<c<00X0c<c<0P28`;P104R@R040000000001028
`;P0b>3H08S0^028`;Pc0<c<c00306IVIP3oool0oooo0?l0oooo803oool00`3<c<`0oooo0<c<c00:
0<c<c1L0IVIV1P3<c<`G06IVIPH0c<c<5`1VIVH60<c<c1L0IVIV00<0c<c<06IVIP1VIVH05@1VIVH<
0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h<`3<c<co06IVIR@0IVIVWP3<c<`2
08S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000
000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`2
08S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000
000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`2
08S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000
000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^?l0c<c<m@3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0c<c<m@3<c<`2
08S0^040B9280@000000000308S0^038h=P0R<2h0?l0R<2hn028`;P104R@R040000000001028`;P0
b>3H08S0^028`;PE0000P0<000600P000X030003P@8000B10P001H400`001H8000J20006PP020007
PP040047PP0128800@R30048P`800@V30`012X<2004;Q0<00@b40P013H@00`013X@00@j5004>Q@03
008?Q@800Q250`024HH2008BQP800Q>600<00Q>7008DQ`0258L00`025HL00`025XL00aJ800<FR002
00<GR0<00aR80P036HT300<JR@800a^900<00ab900<LRP0378X00`037HX200@NRP<011n;0P0488/2
00@QR`0300@QS0048X`012:<00<012><00D012B<00@TS@049Hd012F=00DUS@0300DVS@0300DWS@05
9hh01BR>00801BR>0P05:Hh00`05:Xh01BZ?00DZS`0200D[S`<01Bb?0`06;I0200H^T0801Rn@00<0
1RnA00H`T@06<9400`06<I400`06<Y401S:B00HcTP0200HcTP0500HdTP07=9801cBB00LeTP07=I<0
0`07=Y<200LgT`0300LhT`07>9@01cRD00801cVD0`07>Y@300LkU@8023bE0P08?ID00`08?IH023jF
00PnUP0300PoUP80242F0`08@IL200Q2U`8024>G00@02D>H00U4V009A9P02DBH0P09AIP00`09AYP0
2DJI00U6V@0200U7V@<02DRI0P09BIX300U:VP802T^J00<02T^K00Y<V`0:C9/00`0:CI/200Y>V`<0
2TnL0P0:D9`200YAW00400YAW@0:DYd02e:M00]BW@802e>M00<02eBM00]DWP0;E9h00P0;EIh300]F
WP802eNO0`0;F9l300]IW`8035ZP0`0<Fj0200aLX0<035fQ0P0<GZ4200aOX@0300aOXP0<H:80362R
0080366R00@03F6R00eRXP0=HZ<03F:S0P0=Hj<300eTX`803FFT0`0=IZ@200eWY00300eXY00=J:D0
3FRU00<03VVU0P0>JZD300i[YP803VbV0P0>KJH00`0>KJL03VjW00i^Y`0300i_Y`0300i`Y`0?L:P0
3g2X00803g6X0`0?LZP200mcZ@<03gBY0P0?MJT00`0?MZT03gJZ00mfZP0300mgZP8047RZ0`0@NJ/2
011jZ`8047^[00<047^/011l[00@O:`00`0@OJ`01@0@OZ`047j]011o[@0@Ojd04Gn]00<04H2]00<0
4H6]0161[P0APZh00P0APZh20163[P030164[P0AQ:l04HB_00804HF_0`0AQZl301:7/0804XR`0P0B
RK000`0BRK404XZa01::/@0301:;/@0301:</@0BS;804Xfb00804Xfb00D04Xjb01>>/P0CS[804hnb
01>?/`0301>@/`804i6c00<04i:c01>B]00CT[@00P0CTk@301>D]0<04iFe0P0DU[D201BG]@0301BG
]P0DV;H059Rf00<059Vf0P0DV[H301BK]`8059bg0P0DWKL0100EWKP05Ijh01FN^00EW[P201FO^003
01FP^00EX;T05J2i00805J6i0`0EX[T201FS^P<05JBj0P0FYKX00`0FYK/05ZJk01JV^`0301JW^`80
5ZRk0`0FZK`201JZ_0805Z^l00@05Z^m01J/_@0G[;d05jbm0P0G[Kd00`0G[[d05jjn01N^_P0201N_
_P<05k2n0P0G/Kl301Nb_`805k>o500H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^0@0002000<0VjOa03=3Y@0c@jD02@0c@jD50000P0<000600P000X030003P@8000B10P001H400`00
1H8000J20006PP020007PP040047PP0128800@R30048P`800@V30`012X<2004;Q0<00@b40P013H@0
0`013X@00@j5004>Q@03008?Q@800Q250`024HH2008BQP800Q>600<00Q>7008DQ`0258L00`025HL0
0`025XL00aJ800<FR00200<GR0<00aR80P036HT300<JR@800a^900<00ab900<LRP0378X00`037HX2
00@NRP<011n;0P0488/200@QR`0300@QS0048X`012:<00<012><00D012B<00@TS@049Hd012F=00DU
S@0300DVS@0300DWS@059hh01BR>00801BR>0P05:Hh00`05:Xh01BZ?00DZS`0200D[S`<01Bb?0`06
;I0200H^T0801Rn@00<01RnA00H`T@06<9400`06<I400`06<Y401S:B00HcTP0200HcTP0500HdTP07
=9801cBB00LeTP07=I<00`07=Y<200LgT`0300LhT`07>9@01cRD00801cVD0`07>Y@300LkU@8023bE
0P08?ID00`08?IH023jF00PnUP0300PoUP80242F0`08@IL200Q2U`8024>G00@02D>H00U4V009A9P0
2DBH0P09AIP00`09AYP02DJI00U6V@0200U7V@<02DRI0P09BIX300U:VP802T^J00<02T^K00Y<V`0:
C9/00`0:CI/200Y>V`<02TnL0P0:D9`200YAW00400YAW@0:DYd02e:M00]BW@802e>M00<02eBM00]D
WP0;E9h00P0;EIh300]FWP802eNO0`0;F9l300]IW`8035ZP0`0<Fj0200aLX0<035fQ0P0<GZ4200aO
X@0300aOXP0<H:80362R0080366R00@03F6R00eRXP0=HZ<03F:S0P0=Hj<300eTX`803FFT0`0=IZ@2
00eWY00300eXY00=J:D03FRU00<03VVU0P0>JZD300i[YP803VbV0P0>KJH00`0>KJL03VjW00i^Y`03
00i_Y`0300i`Y`0?L:P03g2X00803g6X0`0?LZP200mcZ@<03gBY0P0?MJT00`0?MZT03gJZ00mfZP03
00mgZP8047RZ0`0@NJ/2011jZ`8047^[00<047^/011l[00@O:`00`0@OJ`01@0@OZ`047j]011o[@0@
Ojd04Gn]00<04H2]00<04H6]0161[P0APZh00P0APZh20163[P030164[P0AQ:l04HB_00804HF_0`0A
QZl301:7/0804XR`0P0BRK000`0BRK404XZa01::/@0301:;/@0301:</@0BS;804Xfb00804Xfb00D0
4Xjb01>>/P0CS[804hnb01>?/`0301>@/`804i6c00<04i:c01>B]00CT[@00P0CTk@301>D]0<04iFe
0P0DU[D201BG]@0301BG]P0DV;H059Rf00<059Vf0P0DV[H301BK]`8059bg0P0DWKL0100EWKP05Ijh
01FN^00EW[P201FO^00301FP^00EX;T05J2i00805J6i0`0EX[T201FS^P<05JBj0P0FYKX00`0FYK/0
5ZJk01JV^`0301JW^`805ZRk0`0FZK`201JZ_0805Z^l00@05Z^m01J/_@0G[;d05jbm0P0G[Kd00`0G
[[d05jjn01N^_P0201N__P<05k2n0P0G/Kl301Nb_`805k>o500H]<0208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^0<0002000L0VjOa0?ooo`2>N[H0YY_40;>YdP2XWLP0/jWB0080YY_400D0
_;SM0>k^m03ZjO40oooo03=3Y@040000P0<000600P000X030003P@8000B10P001H400`001H8000J2
0006PP020007PP040047PP0128800@R30048P`800@V30`012X<2004;Q0<00@b40P013H@00`013X@0
0@j5004>Q@03008?Q@800Q250`024HH2008BQP800Q>600<00Q>7008DQ`0258L00`025HL00`025XL0
0aJ800<FR00200<GR0<00aR80P036HT300<JR@800a^900<00ab900<LRP0378X00`037HX200@NRP<0
11n;0P0488/200@QR`0300@QS0048X`012:<00<012><00D012B<00@TS@049Hd012F=00DUS@0300DV
S@0300DWS@059hh01BR>00801BR>0P05:Hh00`05:Xh01BZ?00DZS`0200D[S`<01Bb?0`06;I0200H^
T0801Rn@00<01RnA00H`T@06<9400`06<I400`06<Y401S:B00HcTP0200HcTP0500HdTP07=9801cBB
00LeTP07=I<00`07=Y<200LgT`0300LhT`07>9@01cRD00801cVD0`07>Y@300LkU@8023bE0P08?ID0
0`08?IH023jF00PnUP0300PoUP80242F0`08@IL200Q2U`8024>G00@02D>H00U4V009A9P02DBH0P09
AIP00`09AYP02DJI00U6V@0200U7V@<02DRI0P09BIX300U:VP802T^J00<02T^K00Y<V`0:C9/00`0:
CI/200Y>V`<02TnL0P0:D9`200YAW00400YAW@0:DYd02e:M00]BW@802e>M00<02eBM00]DWP0;E9h0
0P0;EIh300]FWP802eNO0`0;F9l300]IW`8035ZP0`0<Fj0200aLX0<035fQ0P0<GZ4200aOX@0300aO
XP0<H:80362R0080366R00@03F6R00eRXP0=HZ<03F:S0P0=Hj<300eTX`803FFT0`0=IZ@200eWY003
00eXY00=J:D03FRU00<03VVU0P0>JZD300i[YP803VbV0P0>KJH00`0>KJL03VjW00i^Y`0300i_Y`03
00i`Y`0?L:P03g2X00803g6X0`0?LZP200mcZ@<03gBY0P0?MJT00`0?MZT03gJZ00mfZP0300mgZP80
47RZ0`0@NJ/2011jZ`8047^[00<047^/011l[00@O:`00`0@OJ`01@0@OZ`047j]011o[@0@Ojd04Gn]
00<04H2]00<04H6]0161[P0APZh00P0APZh20163[P030164[P0AQ:l04HB_00804HF_0`0AQZl301:7
/0804XR`0P0BRK000`0BRK404XZa01::/@0301:;/@0301:</@0BS;804Xfb00804Xfb00D04Xjb01>>
/P0CS[804hnb01>?/`0301>@/`804i6c00<04i:c01>B]00CT[@00P0CTk@301>D]0<04iFe0P0DU[D2
01BG]@0301BG]P0DV;H059Rf00<059Vf0P0DV[H301BK]`8059bg0P0DWKL0100EWKP05Ijh01FN^00E
W[P201FO^00301FP^00EX;T05J2i00805J6i0`0EX[T201FS^P<05JBj0P0FYKX00`0FYK/05ZJk01JV
^`0301JW^`805ZRk0`0FZK`201JZ_0805Z^l00@05Z^m01J/_@0G[;d05jbm0P0G[Kd00`0G[[d05jjn
01N^_P0201N__P<05k2n0P0G/Kl301Nb_`805k>o0P0H]<0@000000806;C00P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;P20000P00409^Wl@3oool0K5ZU0:nUbP80_;SM00X0oogo0;>YdP3o
ool0oooo0;bhg@2GR[`0Z9g80>KVk03oool0<d>U0`0008030001P08000:00`000h420004P@8000F1
00<000F20006PP001X800P001h8010011h800@R20048P`0128<20049P`<00@Z30P012h@3004<Q080
0@f400<00@j4004>Q@013XD00`023hD2008@Q@<00Q660P024XH2008CQP03008CQ`0258L00QB700<0
0QF700<00QJ700<FR0035XP00P035hP300<HR0800aV90`036XT200<KR@0300<LR@0378X00ab:00<0
0af:0P047XX300@OR`80122;0P048H/00`048H`012:<00@RS00300@SS00500@TS00498d012F=00@U
S@059Hd00`059Xd00`059hd01BN>00DXSP0200DXSP801BV>00<01BZ>00DZS`05:Xl00P05:hl300D/
S`<01Rf@0P06;Y0200H_T00300H_T@06<9401S2A00<01S6A00<01S:A00HbTP06<i800P06<i801@06
=9801cBB00LdTP07=I801cFC00<01cJC0P07=i<00`07>9<01cRD00LhU00200LiU0<01cZD0`07>iD2
00PlU@8023fE00<023fF00PnUP08?YH00`08?iH200Q0UP<0246G0P08@YL200Q3U`0400U3V009A9P0
2DBH00U4V0802DFH00<02DJH00U6V@09AYT00P09AiT300U8V@802DVJ0`09BYX200Y;VP0300Y;V`0:
C9/02TbK00<02TfK0P0:CY/300Y?W0802U2L0P0:DI`0100:DId02U:M00]BW@0;DYd200]CW@0300]D
W@0;E9h02eBN00802eFN0`0;EYh200]GW`<02eRO0`0;FIl200aJX0<035^P0P0<G:0300aMX@8035jQ
0P0<Gj400`0<Gj80362R00aPXP0200aQXP0400eQXP0=HZ803F:S00eRX`803F>S0`0=I:<200eUY0<0
3FJT0P0=Ij@00`0=J:@03FRU00eXY@0300iYY@803VZU0`0>JjH200i/YP803VfV00<03VfW00i^Y`0>
KZL00`0>KjL00`0>L:L03g2X00m`Z00200maZ0<03g:X0P0?LjT300mdZ@803gFY00<03gJY00mfZP0?
MZX00`0?MjX2011hZP<047V[0P0@NZ/2011kZ`03011k[00@O:`047b/00<047f/00D047j/011n[@0@
Ojd047n]015o[@030160[@030161[@0APJh04H:^00804H:^0P0APjh00`0AQ:h04HB_0164[`020165
[`<04HJ_0`0BQk0201:8/0804XV`00<04XVa01::/@0BR[400`0BRk400`0BS;404Xbb01:=/P0201:=
/P0501:>/P0CS[804hjb01>?/P0CSk<00`0CT;<201>A/`0301>B/`0CT[@04i:d00804i>d0`0CU;@3
01>E]@8059Je0P0DUkD00`0DUkH059Rf01BH]P0301BI]P8059Zf0`0DVkL201BL]`8059fg00@05Ifh
01FN^00EW[P05Ijh0P0EWkP00`0EX;P05J2i01FP^@0201FQ^@<05J:i0P0EXkX301FT^P805ZFj00<0
5ZFk01JV^`0FY[/00`0FYk/201JX^`<05ZVl0P0FZ[`201J[_00401J[_@0F[;d05jbm01N/_@805jfm
00<05jjm01N^_P0G[[h00P0G[kh301N`_P805k6o0`0G/[l201Nc_`806;C000<0b>3H04R@R018T8P0
3018T8P00`0000006;C001Rd`00208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0800020
00/0VjOa0?ooo`2XWLP0oooo0;>YdP1PC9X0SWZf07QU[P2XWLP0oooo0?omo`030?ooo`0303=3Y@00
08000020008000200`000H020002P0<000>10P0018420005P@030005PP001X8000J2008000N200@0
0@N20048PP0128<00@R30P012H<3004:P`800@^40`0138@2004=Q003004>Q0013XD00@j500<00Pn5
0P0248D3008AQP800Q:60P024hH00`024hL00QB7008DQ`03008EQ`03008FQ`035XP00aJ800800aN8
0`0368P200<IR@<00aZ90P036hT00`0378T00ab:00<LRP0300<MRP8011j:0`047h/200@PR`80126;
00<0126<00@RS0048X`00`048h`01@0498`012B=00@US@049Hd01BF=00<01BJ=00<01BN=00DWSP05
:8h00P05:8h200DYSP0300DZSP05:Xl01BZ?00801B^?0`05;8l300H]T0801Rj@0P06;i000`06;i40
1S2A00H`T@0300HaT@0300HbT@06<Y801S>B00801S>B00D01SBB00LdTP07=9801cFB00LeT`0300Lf
T`801cNC00<01cRC00LhU007>9@00P07>I@300LjU0<01c^E0P08?9D200PmU@0300PmUP08?YH023jF
00<023nF0P08@9H300Q1U`8024:G0P08@iL01009@iP02DBH00U4V009A9P200U5V00300U6V009AYT0
2DJI00802DNI0`09B9T200U9VP<02DZJ0P0:BiX00`0:Bi/02TbK00Y<V`0300Y=V`802TjK0`0:Ci`2
00Y@W0802U6L00@02U6M00YBW@0;DYd02e:M0P0;Did00`0;E9d02eBN00]DWP0200]EWP<02eJN0P0;
Eil300]HW`<02eVO0P0<FZ0300aKX08035bP0`0<GJ4200aNX@8035nQ00<035nR00aPXP0<H:800P0<
HJ80100=HJ803F:R00eRX`0=HZ<200eSX`<03FBS0P0=IJ@300eVY0803FNT00<03FRT00eXY@0=J:D0
0`0>JJD200iZY@<03V^V0P0>K:H200i]YP0300i]Y`0>KZL03VjW00<03VnW00<03W2W00m`Z00?L:P0
0P0?LJP300mbZ0803g>Y0`0?M:T200meZ@0300mfZ@0?MZX03gJZ00<03gNZ0P0@N:X3011iZ`8047Z[
0P0@Nj/00`0@Nj`047b/011l[003011m[005011n[00@OZd047n]011o[@0AOjd00`0AP:d00`0APJd0
4H6^0162[P020162[P804H>^00<04HB^0164[`0AQ:l00P0AQJl30166[`<04XN`0P0BR;0201:9/003
01:9/@0BR[404XZa00<04X^a00<04Xba01:</P0BSK800P0BSK801@0BS[804hjb01>>/P0CSk804hnc
00<04i2c0P0CTK<00`0CT[<04i:d01>B]00201>C]0<04iBd0`0CUKD201BF]@8059Ne00<059Nf01BH
]P0DV;H00`0DVKH201BJ]P<059^g0P0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0805Inh00<05J2h
01FP^@0EX;T00P0EXKT301FR^@805J>j0`0EY;X201JU^P0301JU^`0FY[/05ZJk00<05ZNk0P0FZ;/3
01JY_0805ZZl0P0FZk`0100FZkd05Zbm01N/_@0G[;d201N]_@0301N^_@0G[[h05jjn00805jnn0`0G
/;h201Na_`<05k:o0P0G/kl201Rd`0030<SPf028`;P0R<2h00/0R<2h00@0B9280000000H]<006;C0
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20000P00>09^Wl@3oool0oooo0=_Lk01P
C9X0ThFj0;>YdP2l^=d0H4bJ09V?_P2VVl@0b<?O0?ooo`0c@jD50000P0@0oooo00<000:00003P@00
0h40103oool010001H4000F20006PP3oool20007PP030047PP012880oooo0080oooo00@00@V3004:
P`012X<00@Z30P012h@00`0138@0oooo0?ooo`020?ooo`03004>Q0013XD0oooo00<0oooo0P0248D0
10024HH0oooo008AQP024XH40?ooo`800QB70`025HL00`025XL0oooo0?ooo`020?ooo`800aR80`3o
ool300<JR@800a^900<00ab900<LRP0378X00`037HX200@NRP<011n;0P0488/200@QR`0300@QS004
8X`012:<00<012><00D012B<00@TS@049Hd012F=00DUS@0300DVS@0300DWS@059hh01BR>00801BR>
0P05:Hh00`05:Xh01BZ?00DZS`0200D[S`<01Bb?0`06;I0200H^T0801Rn@00<01RnA00H`T@06<940
0`06<I400`06<Y401S:B00HcTP0200HcTP0500HdTP07=9801cBB00LeTP07=I<00`07=Y<200LgT`03
00LhT`07>9@01cRD00801cVD0`07>Y@300LkU@8023bE0P08?ID00`08?IH023jF00PnUP0300PoUP80
242F0`08@IL200Q2U`8024>G00@02D>H00U4V009A9P02DBH0P09AIP00`09AYP02DJI00U6V@0200U7
V@<02DRI0P09BIX300U:VP802T^J00<02T^K00Y<V`0:C9/00`0:CI/200Y>V`<02TnL0P0:D9`200YA
W00400YAW@0:DYd02e:M00]BW@802e>M00<02eBM00]DWP0;E9h00P0;EIh300]FWP802eNO0`0;F9l3
00]IW`8035ZP0`0<Fj0200aLX0<035fQ0P0<GZ4200aOX@0300aOXP0<H:80362R0080366R00@03F6R
00eRXP0=HZ<03F:S0P0=Hj<300eTX`803FFT0`0=IZ@200eWY00300eXY00=J:D03FRU00<03VVU0P0>
JZD300i[YP803VbV0P0>KJH00`0>KJL03VjW00i^Y`0300i_Y`0300i`Y`0?L:P03g2X00803g6X0`0?
LZP200mcZ@<03gBY0P0?MJT00`0?MZT03gJZ00mfZP0300mgZP8047RZ0`0@NJ/2011jZ`8047^[00<0
47^/011l[00@O:`00`0@OJ`01@0@OZ`047j]011o[@0@Ojd04Gn]00<04H2]00<04H6]0161[P0APZh0
0P0APZh20163[P030164[P0AQ:l04HB_00804HF_0`0AQZl301:7/0804XR`0P0BRK000`0BRK404XZa
01::/@0301:;/@0301:</@0BS;804Xfb00804Xfb00D04Xjb01>>/P0CS[804hnb01>?/`0301>@/`80
4i6c00<04i:c01>B]00CT[@00P0CTk@301>D]0<04iFe0P0DU[D201BG]@0301BG]P0DV;H059Rf00<0
59Vf0P0DV[H301BK]`8059bg0P0DWKL0100EWKP05Ijh01FN^00EW[P201FO^00301FP^00EX;T05J2i
00805J6i0`0EX[T201FS^P<05JBj0P0FYKX00`0FYK/05ZJk01JV^`0301JW^`805ZRk0`0FZK`201JZ
_0805Z^l00@05Z^m01J/_@0G[;d05jbm0P0G[Kd00`0G[[d05jjn01N^_P0201N__P<05k2n0P0G/Kl3
01Nb_`805k>o0P0H]<000`38h=P0R<2h08S0^00;08S0^00404R@R00000006;C001Rd`080R<2h0@18
T8P10000000000@0R<2h0<SPf028`;P0R<2h0`0008003P2KYo40oooo0;bhg@2ISkh0oooo0=KAg@3K
g>`0loko0:JKa03^k_@0QGJ`09>5^P3oool0<d>U0`0008002@3oool000600001P0000H0000:00?oo
o`000h40oooo0003P@020004P@050?ooo`001H4000F20006PP3oool00P001h801P011h80oooo0048
P`0128<00@V30?ooo`<00@Z30P012h@0203oool00@b4004<Q0013H@0oooo004>Q03oool00@j50P02
3hD0103oool00Q25008@Q@3oool2008AQP050?ooo`024XH00Q>6008CQP3oool00P0258L3008EQ`08
0?ooo`035XP00aJ800<GR03oool00aR80?ooo`0368P200<IR@030?ooo`036XT0oooo00800a^900<0
0ab900<LRP0378X00`037HX200@NRP<011n;0P0488/200@QR`0300@QS0048X`012:<00<012><00D0
12B<00@TS@049Hd012F=00DUS@0300DVS@0300DWS@059hh01BR>00801BR>0P05:Hh00`05:Xh01BZ?
00DZS`0200D[S`<01Bb?0`06;I0200H^T0801Rn@00<01RnA00H`T@06<9400`06<I400`06<Y401S:B
00HcTP0200HcTP0500HdTP07=9801cBB00LeTP07=I<00`07=Y<200LgT`0300LhT`07>9@01cRD0080
1cVD0`07>Y@300LkU@8023bE0P08?ID00`08?IH023jF00PnUP0300PoUP80242F0`08@IL200Q2U`80
24>G00@02D>H00U4V009A9P02DBH0P09AIP00`09AYP02DJI00U6V@0200U7V@<02DRI0P09BIX300U:
VP802T^J00<02T^K00Y<V`0:C9/00`0:CI/200Y>V`<02TnL0P0:D9`200YAW00400YAW@0:DYd02e:M
00]BW@802e>M00<02eBM00]DWP0;E9h00P0;EIh300]FWP802eNO0`0;F9l300]IW`8035ZP0`0<Fj02
00aLX0<035fQ0P0<GZ4200aOX@0300aOXP0<H:80362R0080366R00@03F6R00eRXP0=HZ<03F:S0P0=
Hj<300eTX`803FFT0`0=IZ@200eWY00300eXY00=J:D03FRU00<03VVU0P0>JZD300i[YP803VbV0P0>
KJH00`0>KJL03VjW00i^Y`0300i_Y`0300i`Y`0?L:P03g2X00803g6X0`0?LZP200mcZ@<03gBY0P0?
MJT00`0?MZT03gJZ00mfZP0300mgZP8047RZ0`0@NJ/2011jZ`8047^[00<047^/011l[00@O:`00`0@
OJ`01@0@OZ`047j]011o[@0@Ojd04Gn]00<04H2]00<04H6]0161[P0APZh00P0APZh20163[P030164
[P0AQ:l04HB_00804HF_0`0AQZl301:7/0804XR`0P0BRK000`0BRK404XZa01::/@0301:;/@0301:<
/@0BS;804Xfb00804Xfb00D04Xjb01>>/P0CS[804hnb01>?/`0301>@/`804i6c00<04i:c01>B]00C
T[@00P0CTk@301>D]0<04iFe0P0DU[D201BG]@0301BG]P0DV;H059Rf00<059Vf0P0DV[H301BK]`80
59bg0P0DWKL0100EWKP05Ijh01FN^00EW[P201FO^00301FP^00EX;T05J2i00805J6i0`0EX[T201FS
^P<05JBj0P0FYKX00`0FYK/05ZJk01JV^`0301JW^`805ZRk0`0FZK`201JZ_0805Z^l00@05Z^m01J/
_@0G[;d05jbm0P0G[Kd00`0G[[d05jjn01N^_P0201N__P<05k2n0P0G/Kl301Nb_`805k>o0P0H]<00
1038h=P0R<2h08S0^028`;P2000000@0R<2h0P00000208S0^00404R@R00000006;C001Rd`080R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0`0008003`2KYo40oooo09V?_P2GR[`0e=?X0>n/
/`3oMW/0kYn[05]HY@2VVl@0UYoB061<VP2l^=d0oooo03=3Y@020000P0090?ooo`000H0000600001
P0000X00oooo0003P@3oool000>1008000B100T0oooo0005P@001H80oooo0006PP3oool000N20047
PP3oool00P0128<20049P`<00@Z30P012h@0203oool00@b4004<Q0013H@0oooo004>Q03oool00@j5
0P023hD0103oool00Q25008@Q@3oool2008AQP050?ooo`024XH00Q>6008CQP3oool00P0258L3008E
Q`050?ooo`035XP00aJ800<GR03oool00`0368P20?ooo`<00aZ90P036hT00`0378T00ab:00<LRP03
00<MRP8011j:0`047h/200@PR`80126;00<0126<00@RS0048X`00`048h`01@0498`012B=00@US@04
9Hd01BF=00<01BJ=00<01BN=00DWSP05:8h00P05:8h200DYSP0300DZSP05:Xl01BZ?00801B^?0`05
;8l300H]T0801Rj@0P06;i000`06;i401S2A00H`T@0300HaT@0300HbT@06<Y801S>B00801S>B00D0
1SBB00LdTP07=9801cFB00LeT`0300LfT`801cNC00<01cRC00LhU007>9@00P07>I@300LjU0<01c^E
0P08?9D200PmU@0300PmUP08?YH023jF00<023nF0P08@9H300Q1U`8024:G0P08@iL01009@iP02DBH
00U4V009A9P200U5V00300U6V009AYT02DJI00802DNI0`09B9T200U9VP<02DZJ0P0:BiX00`0:Bi/0
2TbK00Y<V`0300Y=V`802TjK0`0:Ci`200Y@W0802U6L00@02U6M00YBW@0;DYd02e:M0P0;Did00`0;
E9d02eBN00]DWP0200]EWP<02eJN0P0;Eil300]HW`<02eVO0P0<FZ0300aKX08035bP0`0<GJ4200aN
X@8035nQ00<035nR00aPXP0<H:800P0<HJ80100=HJ803F:R00eRX`0=HZ<200eSX`<03FBS0P0=IJ@3
00eVY0803FNT00<03FRT00eXY@0=J:D00`0>JJD200iZY@<03V^V0P0>K:H200i]YP0300i]Y`0>KZL0
3VjW00<03VnW00<03W2W00m`Z00?L:P00P0?LJP300mbZ0803g>Y0`0?M:T200meZ@0300mfZ@0?MZX0
3gJZ00<03gNZ0P0@N:X3011iZ`8047Z[0P0@Nj/00`0@Nj`047b/011l[003011m[005011n[00@OZd0
47n]011o[@0AOjd00`0AP:d00`0APJd04H6^0162[P020162[P804H>^00<04HB^0164[`0AQ:l00P0A
QJl30166[`<04XN`0P0BR;0201:9/00301:9/@0BR[404XZa00<04X^a00<04Xba01:</P0BSK800P0B
SK801@0BS[804hjb01>>/P0CSk804hnc00<04i2c0P0CTK<00`0CT[<04i:d01>B]00201>C]0<04iBd
0`0CUKD201BF]@8059Ne00<059Nf01BH]P0DV;H00`0DVKH201BJ]P<059^g0P0DW;L201BM]`0401FM
^00EW[P05Ijh01FN^0805Inh00<05J2h01FP^@0EX;T00P0EXKT301FR^@805J>j0`0EY;X201JU^P03
01JU^`0FY[/05ZJk00<05ZNk0P0FZ;/301JY_0805ZZl0P0FZk`0100FZkd05Zbm01N/_@0G[;d201N]
_@0301N^_@0G[[h05jjn00805jnn0`0G/;h201Na_`<05k:o0P0G/kl201Rd`0030<SPf028`;P0R<2h
0080R<2h0P00000208S0^08000000`28`;P01018T8P0000001Rd`00H]<0208S0^040B9280@000000
000408S0^038h=P0R<2h08S0^080002000X0VjOa0?ooo`2GR[`0NVbZ0;?7j02YKZ00b<?O09>5^P1K
AY<0VHnn0P1hIJh010129hD0[jG:0?ooo`0c@jD30000P0<0006000@000:00?ooo`000h4000>1103o
ool01`001H4000F20?ooo`001X80oooo0007PP011h801@3oool3004:P`800@^400L0oooo004<Q001
38@00@f40?ooo`013X@00@j500@0oooo0P0248D0103oool00Q66008AQP024XH40?ooo`800QB70`02
5HL00`025XL0oooo0?ooo`020?ooo`800aR800<0oooo00<IR@036HT00`036XT200<KR@0300<LR@03
78X00ab:00<00af:0P047XX300@OR`80122;0P048H/00`048H`012:<00@RS00300@SS00500@TS004
98d012F=00@US@059Hd00`059Xd00`059hd01BN>00DXSP0200DXSP801BV>00<01BZ>00DZS`05:Xl0
0P05:hl300D/S`<01Rf@0P06;Y0200H_T00300H_T@06<9401S2A00<01S6A00<01S:A00HbTP06<i80
0P06<i801@06=9801cBB00LdTP07=I801cFC00<01cJC0P07=i<00`07>9<01cRD00LhU00200LiU0<0
1cZD0`07>iD200PlU@8023fE00<023fF00PnUP08?YH00`08?iH200Q0UP<0246G0P08@YL200Q3U`04
00U3V009A9P02DBH00U4V0802DFH00<02DJH00U6V@09AYT00P09AiT300U8V@802DVJ0`09BYX200Y;
VP0300Y;V`0:C9/02TbK00<02TfK0P0:CY/300Y?W0802U2L0P0:DI`0100:DId02U:M00]BW@0;DYd2
00]CW@0300]DW@0;E9h02eBN00802eFN0`0;EYh200]GW`<02eRO0`0;FIl200aJX0<035^P0P0<G:03
00aMX@8035jQ0P0<Gj400`0<Gj80362R00aPXP0200aQXP0400eQXP0=HZ803F:S00eRX`803F>S0`0=
I:<200eUY0<03FJT0P0=Ij@00`0=J:@03FRU00eXY@0300iYY@803VZU0`0>JjH200i/YP803VfV00<0
3VfW00i^Y`0>KZL00`0>KjL00`0>L:L03g2X00m`Z00200maZ0<03g:X0P0?LjT300mdZ@803gFY00<0
3gJY00mfZP0?MZX00`0?MjX2011hZP<047V[0P0@NZ/2011kZ`03011k[00@O:`047b/00<047f/00D0
47j/011n[@0@Ojd047n]015o[@030160[@030161[@0APJh04H:^00804H:^0P0APjh00`0AQ:h04HB_
0164[`020165[`<04HJ_0`0BQk0201:8/0804XV`00<04XVa01::/@0BR[400`0BRk400`0BS;404Xbb
01:=/P0201:=/P0501:>/P0CS[804hjb01>?/P0CSk<00`0CT;<201>A/`0301>B/`0CT[@04i:d0080
4i>d0`0CU;@301>E]@8059Je0P0DUkD00`0DUkH059Rf01BH]P0301BI]P8059Zf0`0DVkL201BL]`80
59fg00@05Ifh01FN^00EW[P05Ijh0P0EWkP00`0EX;P05J2i01FP^@0201FQ^@<05J:i0P0EXkX301FT
^P805ZFj00<05ZFk01JV^`0FY[/00`0FYk/201JX^`<05ZVl0P0FZ[`201J[_00401J[_@0F[;d05jbm
01N/_@805jfm00<05jjm01N^_P0G[[h00P0G[kh301N`_P805k6o0`0G/[l201Nc_`806;C000<0b>3H
08S0^028`;P00`28`;P4000000@0R<2h00@0B9280000000H]<006;C00P28`;P104R@R04000000000
1028`;P0b>3H08S0^028`;P20000P00309^Wl@3oool0oooo0080oooo00X0ojf`0?mfN`3icM@0oNg^
0?ooo`2VVl@0QGJ`0;bhg@3oool0<d>U100008001@000H00oooo0?ooo`3oool000:000<000>10P00
18400`3oool000F10?ooo`020006PP040007PP3oool00@N20?ooo`800@R300<00@V30?ooo`012X<0
0P012X<2004;Q0060?ooo`0138@00@b4004=Q03oool00@j40P013XD2008?Q@040?ooo`0248D00Q25
0?ooo`800Q660P024XH2008CQP030?ooo`0258L00QB700<00QF700P00QJ700<FR0035XP00aN80?oo
o`0368P0oooo00<HR0800aV900<0oooo00<JR@036XT00P036hT00`0378T00ab:00<LRP0300<MRP80
11j:0`047h/200@PR`80126;00<0126<00@RS0048X`00`048h`01@0498`012B=00@US@049Hd01BF=
00<01BJ=00<01BN=00DWSP05:8h00P05:8h200DYSP0300DZSP05:Xl01BZ?00801B^?0`05;8l300H]
T0801Rj@0P06;i000`06;i401S2A00H`T@0300HaT@0300HbT@06<Y801S>B00801S>B00D01SBB00Ld
TP07=9801cFB00LeT`0300LfT`801cNC00<01cRC00LhU007>9@00P07>I@300LjU0<01c^E0P08?9D2
00PmU@0300PmUP08?YH023jF00<023nF0P08@9H300Q1U`8024:G0P08@iL01009@iP02DBH00U4V009
A9P200U5V00300U6V009AYT02DJI00802DNI0`09B9T200U9VP<02DZJ0P0:BiX00`0:Bi/02TbK00Y<
V`0300Y=V`802TjK0`0:Ci`200Y@W0802U6L00@02U6M00YBW@0;DYd02e:M0P0;Did00`0;E9d02eBN
00]DWP0200]EWP<02eJN0P0;Eil300]HW`<02eVO0P0<FZ0300aKX08035bP0`0<GJ4200aNX@8035nQ
00<035nR00aPXP0<H:800P0<HJ80100=HJ803F:R00eRX`0=HZ<200eSX`<03FBS0P0=IJ@300eVY080
3FNT00<03FRT00eXY@0=J:D00`0>JJD200iZY@<03V^V0P0>K:H200i]YP0300i]Y`0>KZL03VjW00<0
3VnW00<03W2W00m`Z00?L:P00P0?LJP300mbZ0803g>Y0`0?M:T200meZ@0300mfZ@0?MZX03gJZ00<0
3gNZ0P0@N:X3011iZ`8047Z[0P0@Nj/00`0@Nj`047b/011l[003011m[005011n[00@OZd047n]011o
[@0AOjd00`0AP:d00`0APJd04H6^0162[P020162[P804H>^00<04HB^0164[`0AQ:l00P0AQJl30166
[`<04XN`0P0BR;0201:9/00301:9/@0BR[404XZa00<04X^a00<04Xba01:</P0BSK800P0BSK801@0B
S[804hjb01>>/P0CSk804hnc00<04i2c0P0CTK<00`0CT[<04i:d01>B]00201>C]0<04iBd0`0CUKD2
01BF]@8059Ne00<059Nf01BH]P0DV;H00`0DVKH201BJ]P<059^g0P0DW;L201BM]`0401FM^00EW[P0
5Ijh01FN^0805Inh00<05J2h01FP^@0EX;T00P0EXKT301FR^@805J>j0`0EY;X201JU^P0301JU^`0F
Y[/05ZJk00<05ZNk0P0FZ;/301JY_0805ZZl0P0FZk`0100FZkd05Zbm01N/_@0G[;d201N]_@0301N^
_@0G[[h05jjn00805jnn0`0G/;h201Na_`<05k:o0P0G/kl201Rd`0030<SPf028`;P0R<2h00@0R<2h
0P00000508S0^00404R@R00000006;C001Rd`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0
R<2h0`0008002P2Q[?80nLgD0>8V?03d]Kl0hRHl0?A]O@3lhnT0oooo0?g]kP3o[K020?ooo`0303=3
Y@000800002000<0002000<0oooo0001P0000H000P000X020003P@<0oooo0P001H401`3oool000J2
0006PP001h80oooo0047PP0128800`3oool010012H<00@Z3004:P`012X<2004;Q003004<Q03oool0
oooo0080oooo00<00@j4004>Q@3oool00P3oool00`023hD00Q250?ooo`020?ooo`03008AQP024XH0
oooo0080oooo00<00Q>7008DQ`0258L00`025HL01@025XL0oooo0?ooo`3oool00aN800800aR80`3o
ool200<JR@040?ooo`036hT00a^900<LR@800ab:0`037HX200@NRP<011n;0P0488/200@QR`0300@Q
S0048X`012:<00<012><00D012B<00@TS@049Hd012F=00DUS@0300DVS@0300DWS@059hh01BR>0080
1BR>0P05:Hh00`05:Xh01BZ?00DZS`0200D[S`<01Bb?0`06;I0200H^T0801Rn@00<01RnA00H`T@06
<9400`06<I400`06<Y401S:B00HcTP0200HcTP0500HdTP07=9801cBB00LeTP07=I<00`07=Y<200Lg
T`0300LhT`07>9@01cRD00801cVD0`07>Y@300LkU@8023bE0P08?ID00`08?IH023jF00PnUP0300Po
UP80242F0`08@IL200Q2U`8024>G00@02D>H00U4V009A9P02DBH0P09AIP00`09AYP02DJI00U6V@02
00U7V@<02DRI0P09BIX300U:VP802T^J00<02T^K00Y<V`0:C9/00`0:CI/200Y>V`<02TnL0P0:D9`2
00YAW00400YAW@0:DYd02e:M00]BW@802e>M00<02eBM00]DWP0;E9h00P0;EIh300]FWP802eNO0`0;
F9l300]IW`8035ZP0`0<Fj0200aLX0<035fQ0P0<GZ4200aOX@0300aOXP0<H:80362R0080366R00@0
3F6R00eRXP0=HZ<03F:S0P0=Hj<300eTX`803FFT0`0=IZ@200eWY00300eXY00=J:D03FRU00<03VVU
0P0>JZD300i[YP803VbV0P0>KJH00`0>KJL03VjW00i^Y`0300i_Y`0300i`Y`0?L:P03g2X00803g6X
0`0?LZP200mcZ@<03gBY0P0?MJT00`0?MZT03gJZ00mfZP0300mgZP8047RZ0`0@NJ/2011jZ`8047^[
00<047^/011l[00@O:`00`0@OJ`01@0@OZ`047j]011o[@0@Ojd04Gn]00<04H2]00<04H6]0161[P0A
PZh00P0APZh20163[P030164[P0AQ:l04HB_00804HF_0`0AQZl301:7/0804XR`0P0BRK000`0BRK40
4XZa01::/@0301:;/@0301:</@0BS;804Xfb00804Xfb00D04Xjb01>>/P0CS[804hnb01>?/`0301>@
/`804i6c00<04i:c01>B]00CT[@00P0CTk@301>D]0<04iFe0P0DU[D201BG]@0301BG]P0DV;H059Rf
00<059Vf0P0DV[H301BK]`8059bg0P0DWKL0100EWKP05Ijh01FN^00EW[P201FO^00301FP^00EX;T0
5J2i00805J6i0`0EX[T201FS^P<05JBj0P0FYKX00`0FYK/05ZJk01JV^`0301JW^`805ZRk0`0FZK`2
01JZ_0805Z^l00@05Z^m01J/_@0G[;d05jbm0P0G[Kd00`0G[[d05jjn01N^_P0201N__P<05k2n0P0G
/Kl301Nb_`805k>o0P0H]<000`38h=P0R<2h08S0^00308S0^0@000001028`;P01018T8P0000001Rd
`00H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080002000d0VjOa0?g]kP3R9S`0
o_Gh0?N9U`3dHVh0lj2^0?ARKP3ooOl0ojf`0?cSj@3oool0<d>U00D0002000@0oooo0001P0000H00
00600P000X030003P@8000B10P001H400`001H8000J20006PP020007PP040047PP0128800@R30048
P`800@V30`012X<2004;Q0<00@b400<00@f40?ooo`013X@00P013XD3008?Q@800Q2500<0oooo008A
QP024HH00P024XH2008CQP03008CQ`0258L00QB700<00QF700<00QJ700<FR0035XP00P035hP300<H
R0800aV90`036XT200<KR@0300<LR@0378X00ab:00<00af:0P047XX300@OR`80122;0P048H/00`04
8H`012:<00@RS00300@SS00500@TS00498d012F=00@US@059Hd00`059Xd00`059hd01BN>00DXSP02
00DXSP801BV>00<01BZ>00DZS`05:Xl00P05:hl300D/S`<01Rf@0P06;Y0200H_T00300H_T@06<940
1S2A00<01S6A00<01S:A00HbTP06<i800P06<i801@06=9801cBB00LdTP07=I801cFC00<01cJC0P07
=i<00`07>9<01cRD00LhU00200LiU0<01cZD0`07>iD200PlU@8023fE00<023fF00PnUP08?YH00`08
?iH200Q0UP<0246G0P08@YL200Q3U`0400U3V009A9P02DBH00U4V0802DFH00<02DJH00U6V@09AYT0
0P09AiT300U8V@802DVJ0`09BYX200Y;VP0300Y;V`0:C9/02TbK00<02TfK0P0:CY/300Y?W0802U2L
0P0:DI`0100:DId02U:M00]BW@0;DYd200]CW@0300]DW@0;E9h02eBN00802eFN0`0;EYh200]GW`<0
2eRO0`0;FIl200aJX0<035^P0P0<G:0300aMX@8035jQ0P0<Gj400`0<Gj80362R00aPXP0200aQXP04
00eQXP0=HZ803F:S00eRX`803F>S0`0=I:<200eUY0<03FJT0P0=Ij@00`0=J:@03FRU00eXY@0300iY
Y@803VZU0`0>JjH200i/YP803VfV00<03VfW00i^Y`0>KZL00`0>KjL00`0>L:L03g2X00m`Z00200ma
Z0<03g:X0P0?LjT300mdZ@803gFY00<03gJY00mfZP0?MZX00`0?MjX2011hZP<047V[0P0@NZ/2011k
Z`03011k[00@O:`047b/00<047f/00D047j/011n[@0@Ojd047n]015o[@030160[@030161[@0APJh0
4H:^00804H:^0P0APjh00`0AQ:h04HB_0164[`020165[`<04HJ_0`0BQk0201:8/0804XV`00<04XVa
01::/@0BR[400`0BRk400`0BS;404Xbb01:=/P0201:=/P0501:>/P0CS[804hjb01>?/P0CSk<00`0C
T;<201>A/`0301>B/`0CT[@04i:d00804i>d0`0CU;@301>E]@8059Je0P0DUkD00`0DUkH059Rf01BH
]P0301BI]P8059Zf0`0DVkL201BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0P0EWkP00`0EX;P05J2i
01FP^@0201FQ^@<05J:i0P0EXkX301FT^P805ZFj00<05ZFk01JV^`0FY[/00`0FYk/201JX^`<05ZVl
0P0FZ[`201J[_00401J[_@0F[;d05jbm01N/_@805jfm00<05jjm01N^_P0G[[h00P0G[kh301N`_P80
5k6o0`0G/[l201Nc_`806;C000<0b>3H08S0^028`;P00P28`;P200000080R<2h0P00000308S0^004
04R@R00000006;C001Rd`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P0008000`2K
Yo40m/S<0>8V?0020?n]/0070=lT;P3oY9h0m[c50?n]/03^Nh`0oooo03=3Y@060000P0060?ooo`00
0H0000600001P0000X00oooo0`000h420004P@8000F100<000F20006PP001X800P001h8010011h80
0@R20048P`0128<20049P`<00@Z30P012h@3004<Q003004=Q03oool00@j400800@j50`023hD2008@
Q@030?ooo`024HH00Q6600800Q:60P024hH00`024hL00QB7008DQ`03008EQ`03008FQ`035XP00aJ8
00800aN80`0368P200<IR@<00aZ90P036hT00`0378T00ab:00<LRP0300<MRP8011j:0`047h/200@P
R`80126;00<0126<00@RS0048X`00`048h`01@0498`012B=00@US@049Hd01BF=00<01BJ=00<01BN=
00DWSP05:8h00P05:8h200DYSP0300DZSP05:Xl01BZ?00801B^?0`05;8l300H]T0801Rj@0P06;i00
0`06;i401S2A00H`T@0300HaT@0300HbT@06<Y801S>B00801S>B00D01SBB00LdTP07=9801cFB00Le
T`0300LfT`801cNC00<01cRC00LhU007>9@00P07>I@300LjU0<01c^E0P08?9D200PmU@0300PmUP08
?YH023jF00<023nF0P08@9H300Q1U`8024:G0P08@iL01009@iP02DBH00U4V009A9P200U5V00300U6
V009AYT02DJI00802DNI0`09B9T200U9VP<02DZJ0P0:BiX00`0:Bi/02TbK00Y<V`0300Y=V`802TjK
0`0:Ci`200Y@W0802U6L00@02U6M00YBW@0;DYd02e:M0P0;Did00`0;E9d02eBN00]DWP0200]EWP<0
2eJN0P0;Eil300]HW`<02eVO0P0<FZ0300aKX08035bP0`0<GJ4200aNX@8035nQ00<035nR00aPXP0<
H:800P0<HJ80100=HJ803F:R00eRX`0=HZ<200eSX`<03FBS0P0=IJ@300eVY0803FNT00<03FRT00eX
Y@0=J:D00`0>JJD200iZY@<03V^V0P0>K:H200i]YP0300i]Y`0>KZL03VjW00<03VnW00<03W2W00m`
Z00?L:P00P0?LJP300mbZ0803g>Y0`0?M:T200meZ@0300mfZ@0?MZX03gJZ00<03gNZ0P0@N:X3011i
Z`8047Z[0P0@Nj/00`0@Nj`047b/011l[003011m[005011n[00@OZd047n]011o[@0AOjd00`0AP:d0
0`0APJd04H6^0162[P020162[P804H>^00<04HB^0164[`0AQ:l00P0AQJl30166[`<04XN`0P0BR;02
01:9/00301:9/@0BR[404XZa00<04X^a00<04Xba01:</P0BSK800P0BSK801@0BS[804hjb01>>/P0C
Sk804hnc00<04i2c0P0CTK<00`0CT[<04i:d01>B]00201>C]0<04iBd0`0CUKD201BF]@8059Ne00<0
59Nf01BH]P0DV;H00`0DVKH201BJ]P<059^g0P0DW;L201BM]`0401FM^00EW[P05Ijh01FN^0805Inh
00<05J2h01FP^@0EX;T00P0EXKT301FR^@805J>j0`0EY;X201JU^P0301JU^`0FY[/05ZJk00<05ZNk
0P0FZ;/301JY_0805ZZl0P0FZk`0100FZkd05Zbm01N/_@0G[;d201N]_@0301N^_@0G[[h05jjn0080
5jnn0`0G/;h201Na_`<05k:o0P0G/kl201Rd`0040<SPf028`;P0R<2h08S0^08000001028`;P20000
0080R<2h00@0B9280000000H]<006;C00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P2
0000P00309^Wl@3icM@0mhVG0080oooo00L0ojf`0>4F=03oMW/0ojBN0>8V?03oRGl0<d>U00L00020
103oool010000X0000>10003P@000h420004P@8000F100<000F20006PP001X800P001h8010011h80
0@R20048P`0128<20049P`<00@Z30P012h@3004<Q003004=Q03oool00@j400800@j50`023hD2008@
Q@<00Q660P024XH2008CQP03008CQ`0258L00QB700<00QF700<00QJ700<FR0035XP00P035hP300<H
R0800aV90`036XT200<KR@0300<LR@0378X00ab:00<00af:0P047XX300@OR`80122;0P048H/00`04
8H`012:<00@RS00300@SS00500@TS00498d012F=00@US@059Hd00`059Xd00`059hd01BN>00DXSP02
00DXSP801BV>00<01BZ>00DZS`05:Xl00P05:hl300D/S`<01Rf@0P06;Y0200H_T00300H_T@06<940
1S2A00<01S6A00<01S:A00HbTP06<i800P06<i801@06=9801cBB00LdTP07=I801cFC00<01cJC0P07
=i<00`07>9<01cRD00LhU00200LiU0<01cZD0`07>iD200PlU@8023fE00<023fF00PnUP08?YH00`08
?iH200Q0UP<0246G0P08@YL200Q3U`0400U3V009A9P02DBH00U4V0802DFH00<02DJH00U6V@09AYT0
0P09AiT300U8V@802DVJ0`09BYX200Y;VP0300Y;V`0:C9/02TbK00<02TfK0P0:CY/300Y?W0802U2L
0P0:DI`0100:DId02U:M00]BW@0;DYd200]CW@0300]DW@0;E9h02eBN00802eFN0`0;EYh200]GW`<0
2eRO0`0;FIl200aJX0<035^P0P0<G:0300aMX@8035jQ0P0<Gj400`0<Gj80362R00aPXP0200aQXP04
00eQXP0=HZ803F:S00eRX`803F>S0`0=I:<200eUY0<03FJT0P0=Ij@00`0=J:@03FRU00eXY@0300iY
Y@803VZU0`0>JjH200i/YP803VfV00<03VfW00i^Y`0>KZL00`0>KjL00`0>L:L03g2X00m`Z00200ma
Z0<03g:X0P0?LjT300mdZ@803gFY00<03gJY00mfZP0?MZX00`0?MjX2011hZP<047V[0P0@NZ/2011k
Z`03011k[00@O:`047b/00<047f/00D047j/011n[@0@Ojd047n]015o[@030160[@030161[@0APJh0
4H:^00804H:^0P0APjh00`0AQ:h04HB_0164[`020165[`<04HJ_0`0BQk0201:8/0804XV`00<04XVa
01::/@0BR[400`0BRk400`0BS;404Xbb01:=/P0201:=/P0501:>/P0CS[804hjb01>?/P0CSk<00`0C
T;<201>A/`0301>B/`0CT[@04i:d00804i>d0`0CU;@301>E]@8059Je0P0DUkD00`0DUkH059Rf01BH
]P0301BI]P8059Zf0`0DVkL201BL]`8059fg00@05Ifh01FN^00EW[P05Ijh0P0EWkP00`0EX;P05J2i
01FP^@0201FQ^@<05J:i0P0EXkX301FT^P805ZFj00<05ZFk01JV^`0FY[/00`0FYk/201JX^`<05ZVl
0P0FZ[`201J[_00401J[_@0F[;d05jbm01N/_@805jfm00<05jjm01N^_P0G[[h00P0G[kh301N`_P80
5k6o0`0G/[l201Nc_`806;C000<0b>3H08S0^028`;P02`28`;P01018T8P0000001Rd`00H]<0208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^080002000L0VjOa0?ooo`3cX:h0m69^0?ooo`3g
RIL0nLgD0080oooo00<0lj2^0?ooo`0c@jD01`0008030001P08000:00`000h420004P@8000F100<0
00F20006PP001X800P001h8010011h800@R20048P`0128<20049P`<00@Z30P012h@3004<Q0800@f4
00<00@j4004>Q@013XD00`023hD2008@Q@<00Q660P024XH2008CQP03008CQ`0258L00QB700<00QF7
00<00QJ700<FR0035XP00P035hP300<HR0800aV90`036XT200<KR@0300<LR@0378X00ab:00<00af:
0P047XX300@OR`80122;0P048H/00`048H`012:<00@RS00300@SS00500@TS00498d012F=00@US@05
9Hd00`059Xd00`059hd01BN>00DXSP0200DXSP801BV>00<01BZ>00DZS`05:Xl00P05:hl300D/S`<0
1Rf@0P06;Y0200H_T00300H_T@06<9401S2A00<01S6A00<01S:A00HbTP06<i800P06<i801@06=980
1cBB00LdTP07=I801cFC00<01cJC0P07=i<00`07>9<01cRD00LhU00200LiU0<01cZD0`07>iD200Pl
U@8023fE00<023fF00PnUP08?YH00`08?iH200Q0UP<0246G0P08@YL200Q3U`0400U3V009A9P02DBH
00U4V0802DFH00<02DJH00U6V@09AYT00P09AiT300U8V@802DVJ0`09BYX200Y;VP0300Y;V`0:C9/0
2TbK00<02TfK0P0:CY/300Y?W0802U2L0P0:DI`0100:DId02U:M00]BW@0;DYd200]CW@0300]DW@0;
E9h02eBN00802eFN0`0;EYh200]GW`<02eRO0`0;FIl200aJX0<035^P0P0<G:0300aMX@8035jQ0P0<
Gj400`0<Gj80362R00aPXP0200aQXP0400eQXP0=HZ803F:S00eRX`803F>S0`0=I:<200eUY0<03FJT
0P0=Ij@00`0=J:@03FRU00eXY@0300iYY@803VZU0`0>JjH200i/YP803VfV00<03VfW00i^Y`0>KZL0
0`0>KjL00`0>L:L03g2X00m`Z00200maZ0<03g:X0P0?LjT300mdZ@803gFY00<03gJY00mfZP0?MZX0
0`0?MjX2011hZP<047V[0P0@NZ/2011kZ`03011k[00@O:`047b/00<047f/00D047j/011n[@0@Ojd0
47n]015o[@030160[@030161[@0APJh04H:^00804H:^0P0APjh00`0AQ:h04HB_0164[`020165[`<0
4HJ_0`0BQk0201:8/0804XV`00<04XVa01::/@0BR[400`0BRk400`0BS;404Xbb01:=/P0201:=/P05
01:>/P0CS[804hjb01>?/P0CSk<00`0CT;<201>A/`0301>B/`0CT[@04i:d00804i>d0`0CU;@301>E
]@8059Je0P0DUkD00`0DUkH059Rf01BH]P0301BI]P8059Zf0`0DVkL201BL]`8059fg00@05Ifh01FN
^00EW[P05Ijh0P0EWkP00`0EX;P05J2i01FP^@0201FQ^@<05J:i0P0EXkX301FT^P805ZFj00<05ZFk
01JV^`0FY[/00`0FYk/201JX^`<05ZVl0P0FZ[`201J[_00401J[_@0F[;d05jbm01N/_@805jfm00<0
5jjm01N^_P0G[[h00P0G[kh301N`_P805k6o0`0G/[l201Nc_`806;C000<0b>3H08S0^028`;P02`28
`;P01018T8P0000001Rd`00H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0<00020
00/0VjOa0?ooo`3oRGl0oooo0?>P[P3aTj40oooo0?omo`3cX:h0oo_l03=3Y@070000P0<000600P00
0X030003P@8000B10P001H400`001H8000J20006PP020007PP040047PP0128800@R30048P`800@V3
0`012X<2004;Q0<00@b40P013H@00`013X@00@j5004>Q@03008?Q@800Q250`024HH2008BQP800Q>6
00<00Q>7008DQ`0258L00`025HL00`025XL00aJ800<FR00200<GR0<00aR80P036HT300<JR@800a^9
00<00ab900<LRP0378X00`037HX200@NRP<011n;0P0488/200@QR`0300@QS0048X`012:<00<012><
00D012B<00@TS@049Hd012F=00DUS@0300DVS@0300DWS@059hh01BR>00801BR>0P05:Hh00`05:Xh0
1BZ?00DZS`0200D[S`<01Bb?0`06;I0200H^T0801Rn@00<01RnA00H`T@06<9400`06<I400`06<Y40
1S:B00HcTP0200HcTP0500HdTP07=9801cBB00LeTP07=I<00`07=Y<200LgT`0300LhT`07>9@01cRD
00801cVD0`07>Y@300LkU@8023bE0P08?ID00`08?IH023jF00PnUP0300PoUP80242F0`08@IL200Q2
U`8024>G00@02D>H00U4V009A9P02DBH0P09AIP00`09AYP02DJI00U6V@0200U7V@<02DRI0P09BIX3
00U:VP802T^J00<02T^K00Y<V`0:C9/00`0:CI/200Y>V`<02TnL0P0:D9`200YAW00400YAW@0:DYd0
2e:M00]BW@802e>M00<02eBM00]DWP0;E9h00P0;EIh300]FWP802eNO0`0;F9l300]IW`8035ZP0`0<
Fj0200aLX0<035fQ0P0<GZ4200aOX@0300aOXP0<H:80362R0080366R00@03F6R00eRXP0=HZ<03F:S
0P0=Hj<300eTX`803FFT0`0=IZ@200eWY00300eXY00=J:D03FRU00<03VVU0P0>JZD300i[YP803VbV
0P0>KJH00`0>KJL03VjW00i^Y`0300i_Y`0300i`Y`0?L:P03g2X00803g6X0`0?LZP200mcZ@<03gBY
0P0?MJT00`0?MZT03gJZ00mfZP0300mgZP8047RZ0`0@NJ/2011jZ`8047^[00<047^/011l[00@O:`0
0`0@OJ`01@0@OZ`047j]011o[@0@Ojd04Gn]00<04H2]00<04H6]0161[P0APZh00P0APZh20163[P03
0164[P0AQ:l04HB_00804HF_0`0AQZl301:7/0804XR`0P0BRK000`0BRK404XZa01::/@0301:;/@03
01:</@0BS;804Xfb00804Xfb00D04Xjb01>>/P0CS[804hnb01>?/`0301>@/`804i6c00<04i:c01>B
]00CT[@00P0CTk@301>D]0<04iFe0P0DU[D201BG]@0301BG]P0DV;H059Rf00<059Vf0P0DV[H301BK
]`8059bg0P0DWKL0100EWKP05Ijh01FN^00EW[P201FO^00301FP^00EX;T05J2i00805J6i0`0EX[T2
01FS^P<05JBj0P0FYKX00`0FYK/05ZJk01JV^`0301JW^`805ZRk0`0FZK`201JZ_0805Z^l00@05Z^m
01J/_@0G[;d05jbm0P0G[Kd00`0G[[d05jjn01N^_P0201N__P<05k2n0P0G/Kl301Nb_`805k>o0P0H
]<0?0<SPf0030000000H]<006;C00080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h1000
080309^Wl@060?ooo`3cX:h0m;Fo0?Jla@3kfMX0<d>U200008030001P08000:00`000h420004P@80
00F100<000F20006PP001X800P001h8010011h800@R20048P`0128<20049P`<00@Z30P012h@3004<
Q0800@f400<00@j4004>Q@013XD00`023hD2008@Q@<00Q660P024XH2008CQP03008CQ`0258L00QB7
00<00QF700<00QJ700<FR0035XP00P035hP300<HR0800aV90`036XT200<KR@0300<LR@0378X00ab:
00<00af:0P047XX300@OR`80122;0P048H/00`048H`012:<00@RS00300@SS00500@TS00498d012F=
00@US@059Hd00`059Xd00`059hd01BN>00DXSP0200DXSP801BV>00<01BZ>00DZS`05:Xl00P05:hl3
00D/S`<01Rf@0P06;Y0200H_T00300H_T@06<9401S2A00<01S6A00<01S:A00HbTP06<i800P06<i80
1@06=9801cBB00LdTP07=I801cFC00<01cJC0P07=i<00`07>9<01cRD00LhU00200LiU0<01cZD0`07
>iD200PlU@8023fE00<023fF00PnUP08?YH00`08?iH200Q0UP<0246G0P08@YL200Q3U`0400U3V009
A9P02DBH00U4V0802DFH00<02DJH00U6V@09AYT00P09AiT300U8V@802DVJ0`09BYX200Y;VP0300Y;
V`0:C9/02TbK00<02TfK0P0:CY/300Y?W0802U2L0P0:DI`0100:DId02U:M00]BW@0;DYd200]CW@03
00]DW@0;E9h02eBN00802eFN0`0;EYh200]GW`<02eRO0`0;FIl200aJX0<035^P0P0<G:0300aMX@80
35jQ0P0<Gj400`0<Gj80362R00aPXP0200aQXP0400eQXP0=HZ803F:S00eRX`803F>S0`0=I:<200eU
Y0<03FJT0P0=Ij@00`0=J:@03FRU00eXY@0300iYY@803VZU0`0>JjH200i/YP803VfV00<03VfW00i^
Y`0>KZL00`0>KjL00`0>L:L03g2X00m`Z00200maZ0<03g:X0P0?LjT300mdZ@803gFY00<03gJY00mf
ZP0?MZX00`0?MjX2011hZP<047V[0P0@NZ/2011kZ`03011k[00@O:`047b/00<047f/00D047j/011n
[@0@Ojd047n]015o[@030160[@030161[@0APJh04H:^00804H:^0P0APjh00`0AQ:h04HB_0164[`02
0165[`<04HJ_0`0BQk0201:8/0804XV`00<04XVa01::/@0BR[400`0BRk400`0BS;404Xbb01:=/P02
01:=/P0501:>/P0CS[804hjb01>?/P0CSk<00`0CT;<201>A/`0301>B/`0CT[@04i:d00804i>d0`0C
U;@301>E]@8059Je0P0DUkD00`0DUkH059Rf01BH]P0301BI]P8059Zf0`0DVkL201BL]`8059fg00@0
5Ifh01FN^00EW[P05Ijh0P0EWkP00`0EX;P05J2i01FP^@0201FQ^@<05J:i0P0EXkX301FT^P805ZFj
00<05ZFk01JV^`0FY[/00`0FYk/201JX^`<05ZVl0P0FZ[`201J[_00401J[_@0F[;d05jbm01N/_@80
5jfm00<05jjm01N^_P0G[[h00P0G[kh301N`_P805k6o0`0G/[l201Nc_a@06;C00P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;PE0000P0<000600P000X030003P@8000B10P001H400`001H80
00J20006PP020007PP040047PP0128800@R30048P`800@V30`012X<2004;Q0<00@b40P013H@00`01
3X@00@j5004>Q@03008?Q@800Q250`024HH2008BQP800Q>600<00Q>7008DQ`0258L00`025HL00`02
5XL00aJ800<FR00200<GR0<00aR80P036HT300<JR@800a^900<00ab900<LRP0378X00`037HX200@N
RP<011n;0P0488/200@QR`0300@QS0048X`012:<00<012><00D012B<00@TS@049Hd012F=00DUS@03
00DVS@0300DWS@059hh01BR>00801BR>0P05:Hh00`05:Xh01BZ?00DZS`0200D[S`<01Bb?0`06;I02
00H^T0801Rn@00<01RnA00H`T@06<9400`06<I400`06<Y401S:B00HcTP0200HcTP0500HdTP07=980
1cBB00LeTP07=I<00`07=Y<200LgT`0300LhT`07>9@01cRD00801cVD0`07>Y@300LkU@8023bE0P08
?ID00`08?IH023jF00PnUP0300PoUP80242F0`08@IL200Q2U`8024>G00@02D>H00U4V009A9P02DBH
0P09AIP00`09AYP02DJI00U6V@0200U7V@<02DRI0P09BIX300U:VP802T^J00<02T^K00Y<V`0:C9/0
0`0:CI/200Y>V`<02TnL0P0:D9`200YAW00400YAW@0:DYd02e:M00]BW@802e>M00<02eBM00]DWP0;
E9h00P0;EIh300]FWP802eNO0`0;F9l300]IW`8035ZP0`0<Fj0200aLX0<035fQ0P0<GZ4200aOX@03
00aOXP0<H:80362R0080366R00@03F6R00eRXP0=HZ<03F:S0P0=Hj<300eTX`803FFT0`0=IZ@200eW
Y00300eXY00=J:D03FRU00<03VVU0P0>JZD300i[YP803VbV0P0>KJH00`0>KJL03VjW00i^Y`0300i_
Y`0300i`Y`0?L:P03g2X00803g6X0`0?LZP200mcZ@<03gBY0P0?MJT00`0?MZT03gJZ00mfZP0300mg
ZP8047RZ0`0@NJ/2011jZ`8047^[00<047^/011l[00@O:`00`0@OJ`01@0@OZ`047j]011o[@0@Ojd0
4Gn]00<04H2]00<04H6]0161[P0APZh00P0APZh20163[P030164[P0AQ:l04HB_00804HF_0`0AQZl3
01:7/0804XR`0P0BRK000`0BRK404XZa01::/@0301:;/@0301:</@0BS;804Xfb00804Xfb00D04Xjb
01>>/P0CS[804hnb01>?/`0301>@/`804i6c00<04i:c01>B]00CT[@00P0CTk@301>D]0<04iFe0P0D
U[D201BG]@0301BG]P0DV;H059Rf00<059Vf0P0DV[H301BK]`8059bg0P0DWKL0100EWKP05Ijh01FN
^00EW[P201FO^00301FP^00EX;T05J2i00805J6i0`0EX[T201FS^P<05JBj0P0FYKX00`0FYK/05ZJk
01JV^`0301JW^`805ZRk0`0FZK`201JZ_0805Z^l00@05Z^m01J/_@0G[;d05jbm0P0G[Kd00`0G[[d0
5jjn01N^_P0201N__P<05k2n0P0G/Kl301Nb_`805k>o500H]<0208S0^040B9280@000000000308S0
^038h=P0R<2h0?l0R<2hn028`;P104R@R040000000000`28`;P0b>3H08S0^03o08S0^?P0R<2h0@18
T8P10000000000<0R<2h0<SPf038h=P0o`38h=Sh0<SPf040B9280@0000000?l0R<2ho028`;P10000
0000\
\>"], "Graphics",
  ImageSize->{508, 353},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001DB000`400?l00000o`00003ooooooooe
ooooo`00oooooooeooooo`00oooooooeooooo`00oooooooeooooo`00oooooooeooooo`00oooooooe
ooooo`00oooooooeooooo`00oooooooeooooo`00oooooooeooooo`00oooooooeooooo`00oooooooe
ooooo`00oooooooeooooo`00oooooooeooooo`00oooooooeooooo`00oooooooeooooo`00oooooooe
ooooo`00ooo^k^keonk^kP00oooVi^KeonKViP00ooo^k^hXonk^kP;okNg]00[ojn_[onSXj?oUiNGo
h^;RomgMgOoHf=Soe=CDom7AdOo>c/koc<c<0_o;bl/eol[:bP;obl_;00[oc<c<olk>c_oAdM7oe=CD
omSHf?oMgMgoh^;RonGUiOoXj>Sojn_[0_o]kNdGonk^kP;okNg]00[oj^[ZonGVi_oOh>;ofM_Nom?F
fOo;cm?oaL[>ol36bonl`LSo^Ko50_nh_/@cokNla0;o^;k400[o^Ko5okc1b?o0a/_oaL[>ol_?dooC
e]WofM_NomoPh_oUi^Koj^[Z0_o]kNdFonk^kP00oooooolWooooo`;oo_kn00[ono_kooWinOoclo?o
kNg]onGUiOoLg=coe=CDolc<c?o7alOo`l?30_o0`<02okno_c?o_[jn0_no_kl2ol30`00:ol?3`oo7
alOoc<c<omCDe?oLg=coiNGUong]kOoclo?onOWioo_kn`;oo_kn5Oooool2ooknoP0<ooWin_oem_So
k>k_on;Uj?oEfMkobLkDokc3b_na^l?oZk>mojF_^OnR[;KoX:Zf0_nOZKDaoijX/`;oWjVe00coX:Zf
oj:/]_nU[kWoZk>mok6k`onl`l[obLkDomGIg_oRiNSok>k_ooGfn?oinOX2ooknoQGooooo003oonk^
kROok^k^00kokNg]on[Zj_oWinOoh^;RomWIfOo>c/ko`l?3okRh^?n^[ZkoYZJVoj2PX?nLW9coVIVI
oiRHV3OoUiNG00goV9RHoiVIVOnLW9coX:2PojJVY_n^[Zko^;Rhol?3`oo>c/kofMWIon;Rh_oWinOo
j^[Z00;okNg]5?o^k^h03_o]kNgoj>SYon;SiOoIfmkocM3Dokc1b?n]];_oW:J`ohnKYOn5TIkoOXbI
ogZ8U?mfQ9;oM8>A=OmcPI003OmdPi7oMXBBogZ8U?mnS9WoQI6NohnKYOnLY[3o[KBkokc1b?o=d=Co
fM_Non;SiOoXj>T00_o]kNdDonk^kP00oooVi^HWonKViP0=on?ShooPh>3of][Jom7AdOo5aLGo]kNg
ojRXZ?nLW9coT92@ohR8R?n1PH7oOWinog]kN`0iogYjNP0>og]kNomnOWkoPH61ohR8R?n@T93oW9bL
ojRXZ?ng]kOoaLG5om7AdOoJf][oh>3Pon?ShooUiNDDonKViP0>on;Rh_oLgMood]CGolC8cOnc^Kko
WJN`ohVEXOmkRIGoKG^;ofEePomMKGooFVYloeMXN_mFIWXeoeIXN@0?oeIVN_mGJ7[oFVYloee]OomU
MH?oKG^;og^9UOn9UJ7oWJN`ok>i__o4b<god]CGomcMgooRh^;oiNGU01Coi^KV003oonk^kROok^k^
01Coj>SXon;Rh_oIfMWob/[:okZj^_nXZ:SoV9RHoi:BT_nUYJGo`<30omOGeoo[jn_om_KfooOgmooi
nOWon?ShooWinOojn_[onOWiooOgm`?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?o
n_[jooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@0Coo[jn_oinOWon?ShooWinOohn?So
moOgong]kOoHf=So`L71ojFUYOnBTY;oV9RHojRXZ?nj^[[ob/[:omWIfOoRh^;oj>SXonc/k00Donk^
kP0@onGVi_oKgMkocM3DokNla?nPZ;;oRIFOogB3TOmRNI3oH8BYofZHa_mdYmgoOKC/ohNomOn9_oGo
S<Chohk3mS7oT<Gg017oS/?fohg2mon<`_KoRL3foh2ekOmgZMgoK9S7of:5ZomTNI7oM8>AohVEWonP
Z;;o]kc4olg@e?oKgMkoiNKVon_[j`0Donk^kP00oooooolWooooo`0<ooKfm_o]kNgogMgMol[:b_nd
];CoWinOojZZZ_o>c/kok^k^ooKfm_olo?coo_kn>oooool03Oono_koo?clooOgmoo_knooclo?oj^[
ZonOWioo];Bdol[:b_oMgMgokNg]ooKfm_okno/05?ooool04?o`lO?oh^GXolW?e_n_]kooTYnYogV8
UomOPj[oI9O@ogB`kon0^_GoRl?joi79o?nDbogoUlonoi_AoonKd_laoigCo`0Aoi_BoonLd_ooVM3n
oiK?o_nBbOcoS<KjohFmm_mi]?3oJIcCofB7[?miR9OoTYnYojng_oo9cmKoh^GXoo3alooinOX05?oo
ool00?ook^k^9oo^k^h02_oRh^;oe]KFol?3`on^[ZkoVYZJojf][OoNg]kojn_[ooCdm?okno/ooooo
o`0;oo_knooclo?ok>c/on7QhOn`/;3oVYZJojj^[_o3`l?oe]KFon;Rh_oXj>P05?o^k^h03_oIfmko
al_@ojfd^on>VZKoKh6EoeEo[_mNVmcoKjc]ogbhmOn8`oWoTlcnoiSBoonLe?ooW]Go0_nRf?laojCI
o`0Aoj?HoonRf?ooX]SooioGoonId_ooU<_moh_3nOn0^_CoMJo_ofJQh?mKQK;oKh:EohjJY_n]];_o
al_@omWKg_oTiNL05?o^k^h00?ooi^KV9ooVi^H02_oFe]KoalO7ok:b/_nLW9coYjNWomCDe?oPh>3o
k>c/ooGemOomoOdoooooo`0;ookno_ofm_Kok>c/on;Rh_oIfMWoZj^[oibLW?nb/[;oalO7omKFe_oM
gMd05?oVi^H03Oo<cm;o][_1oiNQZomjR9KoC7NWoe6<d?mQW]ooLjk]oh2jm_n=a__oULgnoi_BoonQ
eol00_nTf_l00onVf_ooYm_oojOKo`0_ojOKo`;oY][o00ooY=[ooj;HoonLd_ooUlonoi79o?n5_OKo
N;3_ofZShOmJU]OoE7j[ogZ8U_nGXJ_o][_1olc?d_oGf=X05?oVi^H00?ook^k^9oo^k^h02ooHf=So
a/K6ojj^[_nSXj?oa/K6omCDe?oPh>3ok>c/oo;bl_olo?coo_kn00gooooo00?ohn?SomKFe_ono_h0
1?ooool00oo/k>cooOgmooooo`02ooCdm0_ooooo00?okNg]ono_koooool01?ooool00oodm?Coj>SX
ooooo`0@ooooo`0;oo[jn_odm?Coj^[Zon?ShooGemOocLg=ojJVY_n^[Zkoa/K6omSHf?oRh^805?o^
k^h04?o;cm?o/;JnohnKYOmBMYko?W_1oe>?domTW^3oM:k_ognhlon<a_[oTl_loi[?o_nOe_ooXMOo
oj?HoonReol;ojOIo`03ojGGoOn@^mcoU/?V00GoYmWo00?oV/S/ojGGoOnWfOl00_nOco@:ojOIo`03
oio?m?nGaNSoYmWo00coYmWo017oY]Sooj?HoonRf?ooX=GooicAoonGc?coT<GiohBlm?mh/>coJZCR
oebDeOm;Q/SoFGbSohnKYOn`][kobloCom_MgP0Donk^kP00oooooolWooooo`0?on?Shoo=cLgo/;2`
ojn_[oo6a/Kod];BomcLg?oVi^Kok>c/ooGemOohn?Son_[joogmoOooooooo?cl00Oooooo01GoWYjN
oa8B4_l92@Wo9bLWoa/K6om<C4cofMWIoooooomADE7o1`L7oaXJ6_nLW9co4a<CoeMGEooooooo@410
ogmoOoomoOgooooooj>SXolL71`00_ooool04?oUiNGo@410o`000?lB4Q;o7AdMooShn?ooooooinOW
odY:B_l30`?o8R8RoaLG5oo1`L7ooooood10@?moOgl2ooooo`03oogmoOoooooooooo00;ooooo013o
oOgmooooooomoOgono_kooShn?odm?CokNg]onKVi_oOgmooe]KFolc<c?ne]KGo/K6aolg=cOoShn?o
lo?c5?ooool04?oCf=co/[_4ognAY_lgJj[o?W_1oe:>d?mQW=_oLJ[Vog^bkon7__GoSlCgoiC8n_nJ
cOcoW<oloi_=nonMd?`:oj3Ao@06ofj@[_l620Wo20X<oaHM8olQ;3GoJ8RU0_nPdOd01_lb@U3o1@H7
oa0E6OmQOi[o2`lBocI7EP;oX=7m00?oCVIlo`000?n:]M/00onPdOd01_n@_NGo;Sa9o`420_lE72;o
3Q8FogVN_`_oX=7m017oWm3loic?o?nLd?coV/gkoiO9n_nAa?OoR[kdoh6fkome[>OoJ:7Noe^De?m9
QLOo@gJaoh6CZ?nb^lCodmSLon_]l00Dooooo`00ooo^k^hWonk^kP0Com7AdOnk^k_oXJ6QokJf]_o3
`l?oclo?omKFe_oOgmooi^KVon[Zj_o_knoolo?cooCdm?oemOGomoOgooKfm_ogmoOom_KfooShn002
ooOgm`04oi:BT_l20P;oQXJ6ooCdm0;om_Kf00So[:b/om7AdOno_koo0`<3omKFe_oNg]koEeMGoa0@
40;omoOg00Ko?CdmogYjN_ogmoOomoOgoifMWOlK6a/2ooOgm`0@oclo?olZ:R[oa<C4ooOgmoo@d=3o
m_KfooOgmom1@D7o?CdmomOGeoogmoOojn_[onWYjOohn?So?Cdmog]kN`;om_Kf0_ogmoL04oofm_Ko
n?ShooKfm_ogmoOom_KfooCdm?obl_;ol?3`on_[jooVi^KohN7Qom[Jf_oCdm?obLW9okno_onVYZKo
^k^kom7AdOoQhN405?o^k^h04?o0a/_oXJVcoe9`VOlXI[3o?7Rmodj9b_mLU=GoJJ?OogF/i_mn/n_o
Q[Waohbnlon@`_GoTl?foiK6monDaOL:oiO7m`0=ogjWcomaUKWoU<?boiO7momLNYSo0P<3oh>]eome
V[oo0P<3oh:/e_n8/mko=DMHo`X=4002oiO7m`04oiK6m_lB61ko310DodQOMP?oUlOg00Ko:3E1obDa
?On4[]SoUlOgohnmjon?_>X;oiO7m`0AoiK7monFa_OoTlCfoi72mOn>_o?oRKcboh:ek?mj[nKoKjGP
ofFKf?mFT=3oAH;5ocEc^OmFMiooXJVcol36booHfmd05?o^k^h00?ooi^KV9ooVi^H02oo9bLWo/[:b
oijNW_nc/k?o`<30olW9bOoCdm?ofMWIomgMgOoRh^;oiNGU00;oj^[Z00?ok>c/ong]kOo]kNd01?o^
k^h01?oWinOo4Q8BoeaLG?o`l?05onk^kP06ol[:b_l20P;o/K6aonk^k_nDU9Co7AdM0_o^k^h02olk
>c_oMWIfoo3`l?o^k^koV9RHoaXJ6_o^k^kocLg=o`000?n;Rh_ol?3`00?ok^k^00Goc/k>o`000?n[
Zj_ok^k^oo3`l003onk^kP05oc/k>omfMWKok^k^onk^k_o`l?000oo^k^h2ong]k@;ok>c/00gojNWY
onKVi_oShn?oh>3Pom_KfooEeMGocLg=olG5aOnk^k_oYJFUok:b/_o9bLWof=SH01Coi^KV013o^;k4
oiRRZ_lfGIKo8f2[ocEc^_m6P/KoEY3?of>IeOm]XMcoMJWPogf`iOn3]>WoQ[S[ohVjkOn<^^goS;_^
3_n>_Nh02OmmY];o0000ofF6ZOmhX<[o0@82ofV</?n>_NkoF7FDoa4G7@02ohjmkP09ofZ=/_l620[o
I8FXo`dB5on;^^[oS[g^og^Sc_l0003oIXR[00ooS[g^017oS;_^ohbjkOn:^^goR;W]ohFdj_mo/NGo
NZcRog>Wg_mXWmSoGYGBodn:bOm0Nl7o<6bdoc]VWonHXZ[o^;k4oloBe@0DonKViP00ooo^k^hWonk^
kP0=om3@d?nh^;SoW9bLojb/[?nk^k_oa/K6olg=cOoCdm?oemOGom_KfooOgmoohN7Qon;RhP02on?S
h`GoiNGU00Co_[jno`000?n^[Zkoi^KV1_oUiND01OnLW9co;Bd]obd];Ol`<33o71`L00;oiNGU00_o
>CTiog9bL_oVi^KoiNGUoi:BT_lI6AWoiNGUojZZZ_l0003o^KVionKViP03onGUi@03ojZZZ_l0003o
=SHf00?o>3Ph00Go/;2`onGUiOli>CWoLW9bonGUi@02onKViP?oiNGU0_oTi>@2on?Sh`0=on;Rh_oP
h>3og=cLomWIfOoFe]Kod=3@olW9bOo1`L7o]KFeojFUYOnh^;Sod=3@on3Ph00Donk^kP0@okk4bonM
Yjoo94fBob1HYOl_KKGo?W_0odf8bOmKTm3oHi[DofbPf?mcYMgoN:[Oogb[h?mn[^7oOjoRoh:ai0go
QK?T00[oOJSFobTgA_l41@OoOZWHohFci?mJNI[o6R</oaXS;OlL9C3o41HL0_n5/n@02Olb@eGo<45C
ohFci?lC6R7oFg^MohFci?mSQJWo0000oalZ=P03ob0/>003ofJ9[on5/nCoQK?T00WoQK?T017oPK3R
oh6_h_mo[n7oOZgQog^[gomfZ=koKj?IofZMeomRUm;oEHg>odR3aOljM[co:6B^obUJWOnMYjoo_/C;
omOJg00Donk^kP00oooooolWooooo`0=on3Ph?o8b<SoUIFEojNWYonf][Ko`<30olK6a_o<c<codM7A
omCDe?oGemOof][Jom_Kf`03omcLg0;og]kN0_oMgMd01?nKVi_o0000ol?3`ooMgMd2omkNgP?ogMgM
00Kog]kNomgMgOoMgMgog=cLoh20P?lL71`2omgMg@0;ocLg=om@D53ogMgMomkNg_n8R8So6ATIomgM
gOnm_Kgo0000ogemOOoMgMd00_oNg]h03?oMgMgo_Kfmo`000?nDU9Co/k>cojb/[?l20P;oalO7omgM
gOlg=cOoKVi^omkNgP;ogMgM0_oNg]h2omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3o
b/[:olG5aOnm_Kgo/;2`oj6QXOo8b<Soh>3Poo7alACooooo013oc]CHojbe_olE?8[o752NobIS[ole
Lk[o@gk1odn9bOmJTLkoHYOAofRLe?m^XMOoLJ?HogFUfOmeYmWoMZOJ3?mjZM`01?mGN9go3A8Ho`/?
4omJOJ<4ogZYg00BogVWf_m6HWoo3aDLogZYg?mdXM;o1@L9oeYmXomjZMco@U]gob<a@?mjZMcoJ96l
o`000?mALI?oHhVboen3Zol10@;oKIO52omjZM`04OmhZ=[oMZOJogFWfOmcY=WoKj;GofbOeOmVV];o
GiC?oeN?c?m<QLGo@7c0oc1^^?lQG:Wo6dZGojbe_oo>e=Soj>_]01Cooooo003oonk^kROok^k^00go
e=CDokno_on<S8coWYjNojf][Oni^KWo`/;2olO7aoo<c<cod=3@om;Bd_oEeMGoe]KF00;oemOG00?o
f=SHomWIfOoIfMT00_oIfMT00onYZJWo0000ok:b/P07omWIf@05oiVIVOni^KWoe]KFoe9BD_m7AdL0
0_oIfMT01_lf=SKo4A4AofATI?nl_;coBTY:od51@@;ofMWI00Go=CDeob4Q8OnQXJ7of=SHokbl_002
omWIf@05ocDe=OmKFe_od];BohJ6Q_lT92@00_oIfMT00olf=SKoK6a/omWIf@05omWIf@;of=SH0_oG
emL03OoEeMGodm?Com3@d?o>c/kob/[:olG5aOno_koo]KFeojVYZOnHV9So_knoomCDe?oRh^805?o^
k^h04?o5b/koYZngoa0cP_lGA9Go7eNUobYX/oliMKgoA7o2odn9bOmGS/coGY??of>HdOmWV];oJYcC
of^Ndom]Wm@;og6QeP04ocUAK?l0003o9SI8ofFA`@?oLJ7F01?oCg6Gof29]_m_Wm?o:SeAobDeA_ma
XMKoAfJ7o`dC6_m`X=GoLJ7FofNC`ol31@KoI8jmog6Qe_lK9cCo;d=IoffKcom6HhCo4a/T00coLJ7F
0_m]Wm@03om[WM?oJIcCofJIdOmQU/ooFi7<oeF<bom<QLGo@7c1oc=`^OlTHZko7E:QoaM0SonV[kOo
aL[>om[Lg`0Donk^kP00oooVi^HWonKViP0=om7AdOno_kooR8R8oi>CTonRXZ;o[jn_okZj^_o1`L7o
alO7ol_;boo>c/kod=3@om7Ad@02om?Cd`?oe=CD0_oEeMD01?o6a/Ko0@41oh>3PooEeM@2omCDe0;o
eMGE01Koe]KFomGEeOmcLg?o:BTYo`d=3Ol_;booXj>SomGEeOoFe]KoATI6ogEeMOmUIFCo410@obHV
9_nSXj?oeMGEomKFe_o1`L7oBDU9o``<3?l92@Wo7alO0_oEeMD03?o1`L7o>c/ko`X:2_lG5aOoV9RH
omCDe?oEeMGo=CDeofYZJ_oEeMGoe]KFomGEe0;oe=CD0_oEeMD04?oDe=Codm?Com?CdooAdM7od=3@
olg=cOo:b/[o`l?3okjn__nf][KoZj^[oifMWOnATI7o_knoom7AdOoKfm/DonKViP0@olC8cOnZ/;So
5S9loa4gR_lIBI[o85VXobYY/olgM;_o@go1odj7aomDS<WoFi7<of2Dc_mSUlooHiO@ofFHc`[oJI_A
00?oGX^lo`010OllFGP01OmYVm402?lhDg7o51hXo`H93OlG8RkoD7NPofVKdOlU=d[o=e5]0omYVm40
2?lW>Too?5UhofVKdOmNRkco7B/jo`D72_l;4AKoBfnE3?mYVm404OmVVM3oIIS@of>GcomRUlooGIC=
oeZ@bomCRl_oBH?5ocij__lbL;Wo9f>_oaiDYOlF@YCo73f7ojZ`^?o4b<goe=KG01Coi^KV003oonk^
kROok^k^01;ogMgMolg=cOn@T93oRHV9oiNGUonUYJGo/[:bokno_oo;bl_odM7AomGEeOoGemOofMWI
om[Jf_oKfm_of][Jom_KfooLg=`3om_Kf`05oeEEEOlO7aoobl_;om_KfooLg=`01_oKfm/00ooIfMWo
g=cLom_Kf`05om_Kf`03om[Jf_oLg=cofm_K00Gofm_K00?of=SHomcLg?oKfm/00ooKfm/01ooHf=So
fm_Kom_KfooLg=cofm_KocHf=_m]KFd01?oKfm/04ooLg=cofm_Kom_KfooKfm_of][JomWIfOoHf=So
e]KFom?Cdoo=cLgo`/;2okJf]_n/[:coWinOoi2@T?nFUYKocLg=omgMgOoUiND05?o^k^h04?oCe]Wo
^l76obe5P?l=;83o4S^?oaU:WOlSGJ_o>7>ioe>8a_mUV<goK9kBog:Qe?mhYMGoNZOFogfXeomlZML:
oh6/e`03offA]_l10@7oM9_200OoPJcG00?oOj[Eoh6/eon1[=L02on1[=L00omoZMCoPJcGoh6/e`0<
oh6/e`0AogfXeommZMOoNjOGogZWe_meY=GoL:3CofRIcOmFS<Oo?7RlobIS[olMDjGo5TBGo`ldQ_l`
BHOo^l76om?FfOoOh>805?o^k^h00?oooooo9oooool02oobl_;oiNGUojVYZOmjNW[oR8R8oiJFU_nZ
ZZ[oa<C4omGEeOoKfm_og]kN00;oh>3P0ooRh^800ooTi>Cohn?Son?Sh`02on?Sh`08om7AdOli>CWo
6QXJofe]KOn6QXKoIfMWobXZ:_nYZJT3on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooS
hn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`05onCTi?oShn?ohn?SocPh>?maLG400ooShn<01?oT
i>Cohn?Son?ShooShn<2on;RhP0>on7QhOoPh>3ogmoOomcLg?oGemOoaLG5ojb/[?nNWYkoT92@oh:2
P_n][JgoiNGUoo;bl_oinOTDooooo`0@onW[k_oEfMkoG6fFo`DNL?l::Wko4CV=obEDXomCP[koNJ?A
ohF]eon>]=_oTkGLoiFhg?nF^]koV;cNoiVlgP_oWKkQ00Go;CM1ob<[<omGJGgo?4UFocI1C@0Qoifn
h@0AoiZlh?nJ_=ooVKcOoiNjg_nE^McoT;CKohR`f?miYM;oCh>oob9FYOlE@ICo3S67o`PTNOmML9_o
eMWNonW[k_oem_P05?ooool00?ook^k^9oo^k^h03_oUiNGogMgMol;2`_mkNg_oN7QhohJ6Q_nOWioo
aLG5omSHf?oMgMgogmoOon7QhOoRh^;ohn?S0ooTi>@4onGUi@08onCTi?oShn?oWinOog9bL_mNGUko
Ng]koi^KVooGemL2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGU
i@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi006onGUiOoTi>CoiNGUonGUiOli>CWoLW9b0_oT
i>@01?oUiNGoi>CTonGUiOoUiND3onCTi00>on?ShooQhN7oh>3PomoOgooJf][oa/K6oj6QXOn=SHgo
P820ohB4Q?o3`l?ogMgMonGUiOoZj^XDonk^kP0@omoPh_oCe]WoWjNfoaP/K?l376ko2BMmobA8U_mV
Q[koT:cDoiNef_nI]m[oVkcMoijngonP_n3oXl7Qoj;0h@_oYL;Q00GoX[kMogF:X?m7Df7oF6Mhog^A
Z00QojG2h@0AojG1hOnS`N7oX/3Qoj2oh?nK_MgoV[[Loi^hf_n@[mKoHXS0oam9V?l<;HCo1B5eoaT`
LonOZ;SodmKIomoPh_oXj>T05?o^k^h00?ooi^KV9ooVi^H02ooPh>3ofm_Kom;Bd_nKVi_oIFEUog=c
Lon=SHgo^k^komCDe?oJf][ogMgM00;ogmoO00?oh>3Pon7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Q
h@05on7Qh@03on;Rh_oQhN7ohN7Q00?ohN7Q00?ogMgMomoOgooRh^802?oQhN403_oPh>3ogmoOomgM
gOoLg=coeMGEokVi^On>SXkoNg]kofi^K_nNWYkod];Bom_KfooPh>3oi>CT5?oVi^H04?oMg]koe=KG
olO:c_mGHhWo01=Ko`0IJOlG<8CoH7Rboi>Vd?nL/MGoWkKHoj:kf_nQ^m_oX[cKoj:ng?nS_]daoj:o
g@0Aoj:ngOnQ_McoXkkMoj6lfonQ^m_oWkOIoijdeonAZ=3oEg>aoa8`Q?l47G7o01MToeMUS?o7b/ko
e=KGomgNg_oShn<05?oVi^H00?ook^k^9oo^k^h03?o[jn_oj>SXon;Rh_oGemOoSHf=of9RH_mfMWKo
Y:BTolO7aooBd];oeMGEomSHf0;of][J0ooKfm/7omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_K
omcLg?oLg=`01OoLg=`05?oKfm_og=cLomcLg?oKfm_og=cLom_KfooJf][ofMWIomSHf?oCdm?oaLG5
oibLW?meMGGoIfMWoi2@T?oGemOoh^;RonSXj?o[jn_okNg]5?o^k^h04?oZj^[oi>GWomWKg_o9cM;o
?d]ho`0AEol:8F_o@eZKoh6@`?nEY<_oVJ[@oif`donP]=GoWkCEoinde_nP]MHaoj2fe`0Aoj2ee_nQ
]]KoWkCEoijbeOnN/]CoW:kBoiBVcOmjSKgo<DRBo`8KJol055oo?denolW=d_oIfmkoi>GWon[Zj_o]
kNd05?o^k^h00?oooooo9oooool03_ono_kono_kooShn?obl_;og]kNoi6ATOmJFU[oNg]koj>SXonl
_;coa/K6ol_;boo=cLgoclo?0_oAdM45om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@03om;BdP;odM7A00god=3@olo?coo<c<cob<S8ok^k^onLW9co
LW9boe]KFonDU9Cog]kNoo;bl_ohn?Sono_k00;oo_kn5?ooool03_ono_konOWjoo?dm_oYjnkoa/[C
odE>Nol23e;o6beaodiPVOmdQKCoQIFoohbJa?n?W/OoTJ390_nDY<XaoiBUb`0?oiBUb_nCY<WoU:C:
oi:RbOn>W<CoQiG1ofn0/_lmDi7o2amXo`0>D_m5D7koa/[ConW[k_ocm?KonOWj00;oo_kn5?ooool0
0?ook^k^9oo^k^h2ong]k@0>on[Zj_oXj>Soh^;RomcLg?nLW9coKFe]ofQXJ?n3Ph?oUiNGoj>SXon/
[:co[jn_ok6a/Onb/[82okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo
][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]00CokFe]Onf][Co
];BdokBd]?nf][Ko/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9RH_m^KVkoWinOomcLg?oRh^;o
j>SXon[ZjP02ong]kAGok^k^0_o]kNd03_oXj>Woi>GWom_Mg_oAe=OoHVN8oahVGOlC7eoo;C]hodEE
SOmCI9WoGg2Sof9bYOmUMZSoHgFY<OmYNZ`2ofMhZ@0<ofQiZOmSM:KoG6fQodQITOlW=gOo21EHoaXU
G?mPIh_odMCGom_Mg_oTiNOoj>SY0_o]kNdEonk^kP00oooVi^HXonKViP;oiNGU00oohn?Son3Ph?oM
gMgof][JolC4a?nJVY[oNWYjofUYJOmSHf?oJFUYog9bL_mdM7CoNGUiogalO?mkNg/00_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem
00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@07ogalO?mkNg_oO7alogemO?mlO7coNg]kogem
O@02ogYjNP0;ogMgMomdM7CoKFe]ofm_KomlO7coVYZJolG5aOoJf][ogMgMon3Ph?oShn<00_oUiNDG
onKViP;oiNGU00goh^;RomgNg_oGf=[od]CGojZ]^_mQIHKo<cUWoa`SF_lB75So5R9PoadZI_lO;6So
8c5^037o9CAa00go939`obDcK_lT<F_o7baXoaTTHOlN9f3o<cUYof5UQ_nZ[[[od]CGomOHf_oMg]ko
h^;R00;oiNGU5_oVi^H00?ook^k^:Oo^k^h2ong]k@04onc/k?oZj^[oj>SXonGUi@;oh^;R00?oh>3P
omoOgooNg]h0>OoMgMd00ooNg]kogmoOon3Ph002on;RhP04onGUiOoXj>Soj^[Zonc/k0;okNg]6Oo^
k^h2ong]k@0:on_[jooXj>Woi>GWomoPh_oKgMkofM_NomOJg?oFfMcoe=OJom;Ef3GodmKI00[od]GH
omCGf_oFfMcoem[LomWKg_oKgMkogn3RonCUiooXj>Wojn_[0_o]kNdGonk^kP00ooooool[ooooo`;o
o_kn00?ooOgmoo_knookno/00_oinOT2ooShn3WomoOg0_ohn?P2ooWin@;ono_k00?ooOgmookno_on
o_h07Oooool2ooknoP05ooclo?oinO[onOWjooKgmooem_P00_ocm?Hgoo;cm@;oloCf00GomOKhooKg
mooinO[onOWjooclo002ooknoQWooooo003oonk^k_Gok^k^003oonKVi_Goi^KV003oonk^k_Gok^k^
003oooooooGooooo003oonk^k_Gok^k^003oonKVi_Goi^KV003oonk^k_Gok^k^003oooooooGooooo
003oonk^k_Gok^k^003oonKVi_Goi^KV003oonk^k_Gok^k^003oooooooGooooo003oonk^k_Gok^k^
003oonKVi_Goi^KV000jonk^kP08ong]kOo[jn_ohn?SomKFe_o7alOo_KfmokJf]_ne]KG<okBd]008
okFe]Onf][Ko_KfmolO7aooFe]Kohn?Son_[joo]kNgNonk^kP00>_ooool02?omoOgom?CdomkNg_nl
_;coW9bLohJ6Q_mkNg_oMgMgc?mfMWH02?mgMgOoNg]kohJ6Q_nLW9co_;blomkNg_odm?CooOgmg_oo
ool003[ok^k^00Koj>SXomKFe_n_[jooVIVIokRh^?oVi^Joooooo`03oiKDgonlmOoo_?Go00;o_?Go
00?o^oCookceoonlmOl01_nlmOl02Onkm?oo^?7oojoZoonJd>OoNZ2nog^;W?n_[jooe]KFonSXj03N
onk^kP00>_oVi^H01OoLg=co`L71oijNW_o?cloooOgm0<3ooooo00KoVm[Ook_doonjlOoo_?Gookoi
oonlmOl7okgfo`;o_oWo00So^oCookC`oonZioooUMSoofnTg?mjRioo`L71omcLg=koi^KV000jonk^
kP05on7QhOnm_Kgo/k>coo?cloono_h0`?ooool00onBc]oo^O3ook[ao`02ok[ao`06okS_oonjlOoo
^O3ook[aoonil?oo^>oo0_nfk_l2okS_o`08okC/oon^jOooZ>KooiGFoomi_OooGHNfokfm_OoQhN7N
onk^kP00>_ooool01OoalO7oa<C4olk>c_oclo?ooOgm0<3ooooo00?oTLcOokCZoondj_l02_nejol0
2_ncjOoo]N_ook7Yoon[iOooXn3ooi3@oomg^_ooChoDolC4a?oalO7Nooooo`00>_o^k^h01_oPh>3o
]KFeom[Jf_oalO7onOWioogmo@;oo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4
ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4
ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4
ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4
ooknoPCooooo1?ono_h4ooooo`03ookno_n:`moo/NGo00;o/NGo00Co[nCook7Uoon_i?oo/NGo1?n_
i?l02onaiOoo[^?oojkUoon^hoooYn7ooicHoon=cOooM;SoodB=g?ne]KGoh>3P0=kok^k^000?onKV
iP03omCDe?oGemOoi^KV01Goi^KV00?oe=CDonCTi?oVi^H00_oLg=`3onKViP03olk>c_oTi>Coi^KV
00Soi^KV00Gof=SHojj^[_oIfMWok^k^ooGem@02oo_kn`03oogmoOokno_ono_k00;ono_k0_omoOd2
ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2
ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2
ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2
ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2
ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2
ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k00?ooOgmoh6jgon[h?l00_nZgol0
1?n/hOooZ]ooojcQoonZgol4ojcQo`0;oj[OoonXgoooZ=koojKKoonNeOooV=CoohS7oom][oSo@X[K
ojj^[_oHf=P0g_oVi^H000Kok^k^00?o<S8bofa/K?o^k^h01?o^k^h01_o<c<co<C4ao`d=3Ol;2`_o
=CDeolg=c@;ok^k^00?o>c/kogIfM_o^k^h00_o^k^h01_lk>c_oMWIfonk^k_o^k^koLG5aochn?P;o
k^k^01;oZ:RXo`P82?o^k^kok^k^od];Bol71`Oo61PHoi6ATOlA4A7oDE5Aonk^k_o4a<Co8R8Roa`L
7?n][Jgok^k^ofEUIOm<C4`6onk^kP07on3Ph?nd];Cof=SHon_[jooemOGom_KfooShn003ooWin@;o
n?Sh0_oinOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;o
n?Sh0_oinOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si0_oinOT01?ohn?SokNg]on;Rh_oinOT2ooSh
n@04ooWinOo/k>cojn_[ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2
ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2
ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2
ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2
ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P2
ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;on?Sh0_oinOT2ooShn@;onOWi0_ohn?P0
1_oinOWoO[GOojOKoonTf?ooY][oojGJo`[oY=Wo00SoX=Kooi_Coon@bOooPl7oofVZlOlnQ]Ko];Bd
on3Ph=kok^k^0006ooooo`03ocHf=_mdM7Cooooo00?ooooo00?oo_knoc@d=?mBDU800_o^k^h01_mE
EEGo=CDeookno_oooooo@410ogmoO`?ooooo00Ko@410ogmoOoooooooooooogYjN_m3@d<2ooooo`09
okBd]?l92@WoooooolK6a_l410CogMgMonKVi_mKFe_o4A4A00;ooooo00?oLG5aod51@Oono_h00_oo
ool00ooKfm_oe=CDooooo`05ooooo`08oo3`l?o1`L7oeMGEonWYjOoclo?om?CdooKfm_oemOD4ooKf
mP04odY:B_m_KfoomOGeooGem@?om_Kf00Go;Bd]oe]KFooemOGo?CdmogYjNP02ooKfmP03ocdm?Omj
NW[omOGe00?omOGe0_ofm_H00old=3CoKfm_ooGem@03ooGem@0EooKfm_lm?CgoNWYjooKfm_oemOGo
?CdmogYjN_oemOGom_KfomkNg_m7AdOo0P82ob4Q8OlF5QKo^KViooGemOlS8b?o3`l?oahN7_m:BT[o
k>c/00?omOGe1?ofm_H4ooGem@Com_Kf1?oemOD4ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD4
ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD4ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD4
ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD4ooKfmPComOGe1?ofm_H4ooGem@Com_Kf00?omOGe
ogjegonPe_l01_nPe_l00on?_nCo72D]ohnoi005oj3Fo`07oi_Coon@bOooPl7oofVZlOlnQ]Ko`L71
oo3`l03Nooooo`001_o^k^h00olb<S;oK6a/onk^kP03onk^kP03olW9bOl0003oZZZZ00;ok^k^00Ko
ZZZZo`000?o=cLgok^k^oc/k>omfMWH3onk^kP06oc/k>omfMWKok^k^onk^k_maLG7o?Shn0_o^k^h0
2OnXZ:So20P8onk^k_o:b/[o0P82ok2`/?o^k^koU9BDoadM7@02onk^kP03odM7AomZJV[ok^k^00[o
k^k^00Ooh>3PokBd]?oDe=Coi^KVoo3`l?oclo?olO7a00Gom?Cd00Co[:b/oa@D5?o]kNgolo?c0_od
m?@01_o2`/;o0000okZj^_odm?Co?3`logUiN@;om?Cd00Co?CdmogUiNOodm?Com?Cd0_oclo<2ooCd
m004oc<c<om^KVkom?CdooCdm0;olo?c00?om?Cdocdm?OmiNGT00_odm?@04Olm?CgoNGUioo?clood
m?Co@D51ocdm?OoEeMGom?CdonSXj?oVi^Kolo?cokNg]oo`l?3olo?coc<c<on;Rh_om?Cd00;olo?c
1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c
1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c
1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Gom?Cd00?oMjoOoikCoonMd_l0
1OnNdol00om1EVWo0000od5FJ@04oikCo`08oi[?oonCc?ooR<3mog^hnOmRYNko=go?okBd]?oPh>3N
onk^kP001_oVi^H00ol`<33oJ6QXonKViP03onKViP03oj^[Zol0003oclo?00;oi^KV00KocLg=o`00
0?n^[Zkoi^KVocTi>OmbLW83onKViP06ocTi>OmbLW;oi^KVonKVi_m^KVko?3`l0_oVi^H02OnRXZ;o
20P8onKVi_oVi^KoW9bLobd];Ol^;Rko<30`oa`L7002onKViP03odE5AOmVIVKoi^KV00[oi^KV00Oo
f=SHojj^[_oDe=Coi^KVoo3`l?oclo?olO7a00Gom?Cd00ColO7aoaXJ6_m/K6coTY:B0_nCTi<01_m5
ADGo9RHVooCdm?odm?Co?3`logUiN@;om?Cd00Co?CdmogUiNOodm?Com?Cd0_oclo<2ooCdm004oc<c
<om^KVkom?CdooCdm0;olo?c00?om?Cdocdm?OmiNGT00_odm?@01_lm?CgoNGUioo?clooCdm?o0000
ok2`/0?om?Cd0_oclo<2ooCdm004okbl_?lE5AGoS8b<ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oc
lo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oc
lo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oc
lo<6ooCdm0;olo?c1_odm?@2oo?cl`Gom?Cd00CoKJGOoiO<oonFb_ooU/[o0onEbOl04?mhX/ko6R<]
o`000?lJ8bgoN:;>oiG9oonFb_ooT/Onohk3n_n<`okoP[_iog:am?mHVnCo<7W9ojj^[_oHf=SNonKV
iP001_o^k^h02Olb<S;o71`Loclo?olo?cooG5aLonk^k_o=cLgo0000ojRXZ002onk^kP06ojJVY_l0
003odM7Aonk^k_lk>c_oHV9R0oo^k^h02_lk>c_oIFEUonk^k_o^k^koL71`obl_;oo]kNgok^k^ojNW
Yol820P4onk^kP03onc/k?n:RX[o7QhN00;ok^k^00?oAdM7ofYZJ_o^k^h02_o^k^h01ooPh>3o];Bd
om?CdooTi>Cok^k^ono_koo`l?001_oalO401omhN7So3Ph>of9RH_mRHV;oEeMGo`000?n3Ph<00_oa
lO401_ll?3coN7Qhoo7alOoalO7o?3`logQhN0KolO7a00?o<c<cofe]KOoalO401?oalO402_ll?3co
N7Qhoo7alOoalO7o?3`logQhN?oalO7o/k>co`000?li>CT3oc/k>`07okVi^OoalO7oemOGodE5AOl2
0P;oJVYZonSXj028oo7al@08ofBLe_n>`_WoS/?johg1n?n>`_WoS/?johk2nOlS<3d3o`00000<ob<_
?On>`o[oS/?joh^om_n8_OGoPKWdogVak_mZYn[oD9?KobU_`ond];Coh>3Pg_o^k^h000Kooooo00Go
=SHfoeMGEoo0`<3o`<30ol[:bP02ooooo`06od51@Om8B4Sog]kNomgMgOm7AdOoA4A40_ooool03om0
@43o4a<Coi6ATOoTi>CooOgmod10@?lE5AGoS8b<onSXj?lo?coo7alOof1PH?oRh^;oLG5aoc<c<`02
ooooo`0>okBd]?oJf][oo?clof5QHOmDE5CoooooooWinOm9BDWoKFe]ooCdm?okno_ooooool[:b_o0
`<06ooooo`06oo3`l?o1`L7od=3@on7QhOoYjNWok>c/0_o^k^h2oo3`l0?okno_00Ood];Bo`820_o?
clool?3`oi>CTol410Cofm_K00;okno_00Ko>c/kogMgMoo`l?3ol?3`oc/k>omgMgL4ono_k`;ol?3`
00Wo<S8boa`L7?lo?coo?clooeaLG?o_knool?3`oc`l??mgMgL00_o_knl03_lk>c_oMgMgono_koo>
c/ko0000oj2PX?o2`/;o^[Zjo`820_oFe]Kokno_ocdm?Oln?SkocLg=1Oo_knl2oo3`l0Kokno_0_o`
l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`
l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`
l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`l?03ono_k`04oe^Bcon4^O7oQk_dohNkm0;oQ;Wa
00?oFWjTo`000?l000000ol000002omJOZCoQ[[aoh>ilOmo]NkoNK7[og2ZjOmPWn?oAX[Eob1X_Oo1
`L7ol?3`0=kooooo0006onk^kP03oc8b<_m/K6cok^k^00Cok^k^00Kof=SHoda<C?l>3Pko3Ph>odi>
C_oIfMT2onk^kP0?odi>C_moOgooEUIFo`P82?oPh>3oCTi>oh61POmYJFWo3Ph>obDU9Oo6a/KoShn?
oaPH6?lM7AgoXJ6Q00;ok^k^00koP820obh^;_l>3Pko=CDeokJf]_o^k^koMWIfo`L71ol;2`_o6ATI
oj:RX_o^k^koM7AdoeeMG@Kok^k^00Ooh>3PokBd]?o=cLgog=cLonGUiOoWinOojNWY00?ok>c/0_oZ
j^X2onc/k006odA4A?m_Kfook>c/oc<c<om<C4coj^[Z0_o/k>`01_lj>S_oMGEeonc/k?o/k>co>SXj
ogAdM0;ok>c/0_o[jn`2onc/k00Doc4a<Om?Cdoo/K6aok6a/Onj^[[ojn_/onc/k?lk>c_oM7Adon[Z
j_o/k>co>c/kogEeMOo[jncok>c/ocXj>_mRHV;oh^;Roi:BT_lW9bL2on_[k006oc8b<_n:RX[oj^[Z
omCDe?oWinOok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/
k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/
k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/
k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/
k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;ojn_/0_o/
k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X01?o/k>coDh[6ogba
jOmk[nL2ogbaj@03ogNZh?lC6bCo000000Co000000_o4a/TogJXh?mg[nWoLj_VoffUhomRW]koEI?H
oc]nc?lFGkCo];Bdon3Ph03Nonk^kP001_oVi^H00ol`<33oJ6QXonKViP06onKViP;oiNGU1ooVi^H0
0ooShn?oi^KVonKViP02onKViP03onGUiOoVi^Koi^KV00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H0
0ooTi>Coi^KVonKViP02onKViP03odE5AOmVIVKoi^KV00[oi^KV00Sof=SHojj^[_o4a<Coe]KFon3P
h?oUiNGoi^KVonGUi@KoinOW00GoWYjNoaDE5Onj^[[o0000ojFUY@03onOWi`06ocTi>OmcLg?oinOW
onOWioli>CWoLg=c1_oWinL00ol`<33oJFUYonOWi`04onOWi`06oda<C?moOgooinOWonOWioli>CWo
Lg=c0_oWinL03?o@d=3o@410o`/;2olI6AWoYJFUonOWiooVi^Ko[:b/oc@d=?l>3Pko4A4Aom7AdEWo
i^KV;ooWinL01_m>Pl3oMjcTogN[homgZn?oMJ[PoceHM@Oo000000[o?EUfog>XhOm_Y]ooJJ;KoenJ
f_m?SM?o<7G4o`eE[_n^[Zkof=SHg_oVi^H000Kok^k^00?o<S8bobXZ:_mNGUh00_mNGUh00on[Zj_o
k^k^onk^kP0Oonk^kP03om7AdOo?clook^k^00[ok^k^00Soh>3PokFe]Oo4a<Coe]KFon3Ph?oUiNGo
i^KVonGUi@KoinOW00Gohn?SoaDE5OlU9BGo6QXJonKViP03onOWi`06ocTi>OmcLg?oinOWonOWioli
>CWoLg=c1_oWinL00ol`<33oJFUYonOWi`08onOWi`03ocTi>OmcLg?oinOW00?oinOW00Coi>CTonOW
iooWinOoinOW0ooVi^H00ooShn?oi^KVonKViP1IonKViRooinOW00SoCX?0ogN/i?mgZn?oMj_SogFZ
h?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgCoc1ea?l=EJko]KFe
on3Ph03Nonk^kP001_ooool00on`/;3oVYZJoiZJVP02oiZJVP03om7AdOoooooooooo02cooooo00So
l?3`ol;2`_o4a<Coe]KFon3Ph?oUiNGoi^KVonGUi@OoinOW00?oKVi^o`000?mbLW801?oWinL01_li
>CWoLg=conOWiooWinOo>CTiog=cL`KoinOW00?o<30`obTY:OmKFe/00_mKFe/01?nVYZKoinOWoe9B
D_n4Q8@2onOWi`03ocTi>OmcLg?oinOW00OoinOWGooVi^H_onOWi`08odj3`?mg[>CoMj_SogN[home
Z^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`MLCo3EF^ol;2
`_o`l?00g_ooool003[ok^k^00Koh>3PokJf]_nl_;cod=3@omoOgooTi>@2onGUi@Ooi^KV00?od=3@
ohZ:R_oAdM401?oVi^H01_li>CWoLW9bonKVi_oVi^Ko>CTiog9bLPKoi^KV00?oWYjNohZ:R_n:RXX0
0_n:RXX01?nl_;coi^KVoj:RX_nh^;P2onKViP03ocTi>OmbLW;oi^KV09Goi^KV00CoGi73oh:_h?n1
[]ooPk7P2On2[ml02_n0[mooOjgNogf/g_mdYM[oKZ;Joe^Dd?lVK;go0DNUokJf]_oPh>3Nonk^kP00
>_oVi^H01_oJf][o]kNgok>c/oo6a/Koh>3PonOWi`;ojNWY3_oZj^X01_oVi^Koj>SXon[Zj_oZj^[o
i^KVonSXj17oj^[Z00?oi^KVonSXj?oZj^X0UOoZj^X01On9[MCoX/;Uoj;3i_nR`^GoX/?U00?oX/?V
00ooX/?Uoj32iOnP`^GoX<;Uoj;2i_nS`nKoWl;Voic0i?nH_>?oT[SOogNUf?lPIkWo03bLokNg]ooJ
f]X0g_oVi^H003[ok^k^00Ooi>CTolO7aonSXj?o^[ZjomcLg?oWinOojNWY0;koj^[Z00WoW[cJok?=
jOnbcNWo/lkYok;=jOncc^Wo]<oZok?>jOnccNT00onbcNT02oncc^[o/lgYok;=ion_b^Oo[<SVojG4
i?mkY]So3eB[oa<hT?o7alOoi>CT0=kok^k^000jooooo`08ooWinOoVi^KoYjNWojb/[?o>c/kohn?S
onKVi_oWinNmonWYj@0GojK1g?nid>[o^M3ZokW@j_nhd>[o^M3Zok[Bj_njd>Wo^];ZokS@j_nhcnWo
^M3Zok[Bj_nid>[o^<oYokC>ion_b^KoW;gPoeR>aol6@YooCEZIonKVi_oinOT0g_ooool003[ok^k^
00Sok>c/on?Shono_kooX:2Pok:b/_o8b<Soe]KFom_Kfkgog]kN00GoRj_@oio0h?nO`>3oWl3Poijo
h003oio0h003oik0h?nO`>3oW[oP00;oW[oP00[oW[gPoibmh?nF^McoP:[Foe>:a_lPF:_o9Sn@oifN
^?oShn?ok>c/g_o^k^h003[oi^KV00SoiNGUon?ShooLg=co_[jnojJVY_nNWYkoX:2PojBTY;goXj>S
2?lBEZP03olBEZOo4UJXoa9FZ?lBEZ[o4UJXoa1EYol>DJKo3DjSo`]5W_lMA9OoD66NoibN^?oLg=co
hn?SonGUi@3NonKViP00>oo^k^h01Oo]kNgok>c/onSXj?oTi>CohN7Q0=3oh>3P00GohN7QonCTi?oX
j>Sok>c/ong]k@3Oonk^kP00?Oooool2ookno];ooOgm0_ono_kQooooo`00ooo^k^keonk^kP00oooV
i^KeonKViP00ooo^k^keonk^kP00oooooooeooooo`00ooo^k^keonk^kP00oooVi^KeonKViP00ooo^
k^keonk^kP00oooooooeooooo`00ooo^k^keonk^kP00oooVi^KeonKViP00>_o^k^h00onV/KcoOZgI
ogj]f@3Iogj]fGook^k^0_o]kNd02_o[jn_oj>SXonGUiOoRh^;ogMgMomSHf?oDe=CodM7Aolk>c_o<
c<`2ol_;bc_ob/[:0_o;bl/02_o<c<coc/k>om7AdOoDe=Cof=SHomgMgOoRh^;oiNGUonSXj?o[jn/2
ong]k@Sok^k^000jooooo`03ojZe`?mn[MWoOZcI0=OoQ[7J00?oOZcIogj]fOooool0OOooool2ookn
oP0:oo_knooinOWolo?cong]kOoUiNGog=cLomCDe?o<c<coalO7ol?3``;o`<300_no_kliokjn_P;o
_kno0_o0`<002_o3`l?oalO7olc<c?oDe=Cog=cLonGUiOo]kNgolo?cooWinOokno/2ooknoPOooooo
000jonk^kP03ojZe`?mn[MWoQk;K00ComoOgc_ojn_X5ooOgm`03ohF`fOmn[MWok^k^07gok^k^00ko
kNg]on[Zj_oWinOoh^;RomWIfOo>c/ko`l?3okRh^?n^[ZkoYZJVoj2PX?nLW9coVIVIoiRHV3goUiNG
00goV9RHoiVIVOnLW9coX:2PojJVY_n^[Zko^;Rhol?3`oo>c/kofMWIon;Rh_oWinOoj^[Z00;okNg]
1_o^k^h003[oi^KV00?oZ[G0ogj]fOn7/]/0e_ooool00oogmoOoQK3Iogj]f@1nonKViP0=on?ShooP
h>3of][Jom7AdOo5aLGo]kNgojRXZ?nLW9coT92@ohR8R?n1PH7oOWinog]kN`0oogYjNP0>og]kNomn
OWkoPH61ohR8R?n@T93oW9bLojRXZ?ng]kOoaLG5om7AdOoJf][oh>3Pon?ShooUiND6onKViP00>_o^
k^h00onZ]L3oOZgIohNbf`3Fooooo`03ooOgmon5/=WoOZgI07kok^k^01Coj>SXon;Rh_oIfMWob/[:
okZj^_nXZ:SoV9RHoi:BT_nUYJGo`<30omOGeoo[jn_om_KfooOgmooinOWon?ShooWinOojn_[onOWi
ooOgm`?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT04Oohn?SonOWiooShn?og
moOokNg]omSHf?o1`L7oYJFUoi:BT_nHV9SoZ:RXokZj^_o:b/[ofMWIon;Rh_oXj>Sok>c/00Kok^k^
000jooooo`03ojZe`?mn[MWoQk;K0=Kooooo00?omoOgohF`fOmn[MT0O_ooool03?ofm_KokNg]omgM
gOo:b/[o];BdoinOWonZZZ[oc/k>onk^k_ofm_Koo?clooknoT7ooooo00goo_knooclo?ogmoOokno_
olo?con[Zj_oWinOokBd]?o:b/[ogMgMong]kOofm_Kono_k00Kooooo000jonk^kP03ojZe`?mn[MWo
Qk;K00gooooo00?ogmoOol30`?ooool0Aoooool00ol0003oooooooooo`1looooo`03ooOgmon5/=Wo
OZgI07kok^k^00[oh^;RomKFe_o3`l?o[Zj^oiZJV_n][Jgog]kNon_[joodm?Cono_k;?ooool01OnJ
VY[oDE9Boh>3QooAdM7omOGe01Cooooo00_ono_koo?cloo/k>cohN7Qok2`/?nJVY[o[Zj^ol?3`ooF
e]Koh^;RonSXj006onk^kP004OoVi^H00ooDe=Coi>CTonKViP02omcLg0ooi^KV00?og=cLom7AdOoV
i^H04_oVi^H00onZ]L3oOZgIohNbf`0=ooooo`03omoOgol:2P[ojn_[04Oooooo00?o0000oooooooo
ool0O?ooool00oojn_[oQK3Iogj]f@1nonKViP0:omKFe_o7alOo/[:boibLW?nWYjOoe=CDon3Ph?o/
k>comOGeoogmoBcooooo00WoLFm_okNb/?nDfOCoRKcUof5jVomRIg7oWj2QonKVi_olo?`04?ooool0
2oono_kom_Kfonc/k?oRh^;ofMWIoj^[ZonLW9co/[:bolO7aooFe]KogMgM00Koi^KV0006onk^kP03
oc8b<_nJVY[ok^k^00;ok^k^00?o];Bdo`000?n@T9000_o^k^h02Om;Bd_o1`L7oaPH6?nATI7o4A4A
oe5ADOo^k^ko>c/kogIfMP02onk^kP06og5aLOln?Skok^k^onk^k_nXZ:So20P80_o^k^h02OoGemOo
ADE5o`820_lP823o5ADEokBd]?o^k^koIFEUoda<C00>onk^kP03ojZe`?mn[MWoQk;K00kooooo00?o
E5ADohb<S?ooool03?ooool01?o]kNgoooooooooooo/k>`3ooooo`05oo[jn_o/k>coooooooooooo]
kNd00_ooool00oo/k>coooooooooo`0>ooooo`03on_[joofm_Kooooo00Oooooo00?om_Kfoo7alOoo
ool01Oooool01?o]kNgoooooooooooo/k>`3ooooo`03oo[jn_o/k>co000007kooooo00?on_[johF`
fOmn[MT0O_o^k^h02ooHf=Soa/K6ojj^[_nSXj?oa/K6omCDe?oPh>3ok>c/oo;bl_olo?coo_kn01Go
oooo00?om?CdonSXj?ooool04oooool03?mlNggoW9ZHogNlmOnHfOoo[>koojWZoonLf?KoMJ77oeY/
QomlOH;o^KViooCdm0gooooo00_on_[jooCdm?oZj^[ohn?SomOGeoo=cLgoYZJVojj^[_o6a/Kof=SH
on;RhP06onk^kP001_ooool03olf=SKoYJFUoooooooooooom_KfobDU9Ol0003oVi^Kooooooo6a/Ko
10@4omgMgOoVi^KoFe]Koa4A4@02ooooo`06od10@?moOgoooooooooooomjNW[o@d=30_ooool03Ond
];Co2@T9ooooooooooooA4A4od10@?oOgmoooooooo?cloobl_;oooooom_KfooDe=@03_ooool00onZ
]L3oOZgIohNbf`03ooooo`05oahN7_oCdm?ooooool71`On^[Zh00_ooool01_lC4a?oalO7oooooooo
ooooG5aLobHV9P?ooooo00Ko7QhNo`d=3OlD51Co5aLGochn?_ne]KD2ooooo`0EooWinOlh>3So5QHF
oc@d=?mfMWKo5aLGolk>c_oooooo][JfoaTI6Olj>S[onOWiocPh>?lF5QKo=3@dogIfM_lG5aOoc/k>
oooooolN7QkoYZJV00Cooooo00_o9bLWok6a/Ooooooo9bLWok6a/Oooooood=3@ob`/;?lE5AGo;Bd]
oda<C002ooooo`0Gob`/;?mQHF7ooooooooooonDU9Co10@4oa0@4?mXJ6So?3`loiZJV_oooooonOWi
ocPh>?lF5QKo=3@dogIfM_lG5aOoc/k>oooooonf][Ko6ATIocXj>_l00000O_ooool00oojn_[oQK3I
ogj]f@1nooooo`0?on?Shoo=cLgo/;2`ojn_[oo6a/Kod];BomcLg?oVi^Kok>c/ooGemOohn?Son_[j
oogmoOooooooo?cl00Gooooo00So=SHfojFUYOoooooooOgmooooooo1`L7o0@41oi^KV`;ooooo00[o
inOWodU9BOl30`?o8b<SoaLG5oo1`L7oooooonKVi_l0003oQXJ60_ooool00om9BDWo:2PXooooo`02
ooooo`03oogmoOoooooooooo00Cooooo00ooOgn0oibLVOn9b?3oVm7ooi_CoonCcOooV=GooicOoonH
g?ooV=Wnoh>eiomSOI[oKG5gojBUY_ogmoL00_ooool04oomoOgoooooooooooomoOgooooooogmoOok
no_on?ShooCdm?o]kNgoi^KVomoOgooFe]Koc<c<okFe]Ona/K7ocLg=on?Shooclo<01_ooool000Ko
k^k^00oo<S8boiZJV_o^k^kok^k^ofe]KOlA4A7o:2PXoi2@T?o^k^kob/[:o`820_n`/;3ok^k^oiBD
U?lM7Ad00_o^k^h01_lk>c_oMWIfonk^k_o^k^koLG5aochn?P;ok^k^00KoZ:RXo`P82?o^k^koc/k>
o`000?n[Zj/Eonk^kP03ojZe`?mn[MWoQk;K00?ooooo00ko7QhNom?Cdooooooo:BTYo`T92OoalO7o
oooooa<C4oo7alOooooooo3`l?l92@Wo4Q8Bokno_`;ooooo00ko7QhNojJVY_oooooonOWiokRh^?lH
61SoV9RHoooooonb/[;o6a/Koo_knooPh>3o:RXZohV9R@;ooooo00WoCDe=oh:2P_oooooo/[:boa/K
6ookno_oh>3PobXZ:_n9RHT00_ooool00olN7QkoYZJVooooo`03ooooo`0;obLW9ona/K7oooooobLW
9ona/K7omoOgob8R8_mlO7cono_kooooooogmoL00_ooool04OnQXJ7o^KViooooooomoOgo5ADEoi^K
Voono_ko[Zj^o`l?3onJVY[ooooook:b/_lK6a_ono_kon3Ph?lZ:R[oRHV900;ooooo00CoCDe=oh:2
P_oooooo0000O_ooool00oojn_[oQK3Iogj]f@1nonk^kP0]om7AdOnk^k_oXJ6QokJf]_o3`l?oclo?
omKFe_oOgmooi^KVon[Zj_o_knoolo?cooCdm?oemOGomoOgooKfm_ogmoOom_KfooShn?ogmoOo=3@d
oinOWoofm_KomoOgonk^k_lS8b?o0000oiJFU_ogmoOom_Kfod51@Olm?Cgof=SHooKfm_o/k>coj^[Z
ooOgmonHV9So3Ph>ocLg=oogmoOokno_o`T92Ol>3PkocLg=00;om_Kf0_ogmoL05?ofm_Kon?ShooOg
moogmoOom_KfoginOonTXjGoV=3Vok?Uoongj_oo^>_oojSLoonEcOgoP[giogFam?mf^?coP/SooiCG
o_n2^^koQYJU0_ofm_H2ooOgm`0AooKfm_ogmoOom_KfooCdm?obl_;ol?3`on_[jooVi^KohN7Qom[J
f_oCdm?obLW9okno_onVYZKo^k^kom7AdOoQhN401_o^k^h000Koi^KV00So<30`oiBDU?oVi^Ko][Jf
o`820_nCTi?o>3Phoh^;R`;oi^KV00GoW9bLobd];Ol^;Rko<30`oa`L7002onKViP06ocTi>OmbLW;o
i^KVonKVi_m^KVko?3`l0_oVi^H01_nRXZ;o20P8onKVi_n[Zj_o0000ocLg=`?o>3Ph00?o/;2`onKV
i_oVi^H03ooVi^H00onZ]L3oOZgIohNbf`03ooooo`0>oahN7_oCdm?oc/k>o`L71omMGEgoVi^Koooo
oolC4a?oalO7oooooonFUYKo<30`ohZ:R_mIFET2ooooo`03oahN7_nVYZKooooo00;ooooo00WoPh>3
oa0@4?obl_;ofm_Ko`d=3On`/;3onOWiodA4A?nDU9@00_ooool02Olc<c?oYJFUoooooooKfm_o3@d=
ok2`/?oinOWoA4A4oiBDU002ooooo`03oahN7_nVYZKooooo00?ooooo00So9bLWok6a/Ooooooo9bLW
ok6a/Oo4a<Co2@T9ono_k`Sooooo00?ob/[:o`D51OogmoL00_ooool02Olm?CgoVYZJoooooooKfm_o
3@d=ok2`/?oinOWoA4A4oiBDU002ooooo`04oc<c<onUYJGoooooo`0007kooooo00?on_[johF`fOmn
[MT0O_oVi^H02oo9bLWo/[:boijNW_nc/k?o`<30olW9bOoCdm?ofMWIomgMgOoRh^;oiNGU00;oj^[Z
00?ok>c/ong]kOo]kNd01?o^k^h03?lb<S;oVYZJonk^k_o`l?3oKFe]oa4A4OlX:2SoT92@onk^k_o>
c/ko0000ojf][@Gok^k^00SoCdm?of][JolJ6Q[of=SHok2`/?lN7QkoIVIVogQhN0;ok^k^00?ol?3`
onk^k_o^k^h01?o^k^h03ommOGko[Zb`oig:e_o7looo`nooolGboonij_oo[n3ooic?o_n8_OOoMJ_]
ofZQjOmQVNKoKZcdog2Q`P02onk^kP04oo3`l?o^k^kokNg]ong]k@;ok>c/00gojNWYonKVi_oShn?o
h>3Pom_KfooEeMGocLg=olG5aOnk^k_oYJFUok:b/_o9bLWof=SH00Koi^KV0006onk^kP08oc8b<_nJ
VY[ojNWYobTY:Om5ADGok^k^ocXj>_n@T904onk^kP03onc/k?n:RX[o7QhN00;ok^k^01;o>c/kofEU
IOo^k^kok^k^og1`L?l_;bookNg]onk^k_nWYjOo20P8onk^k_o<c<co0000oinOWoo1`L7o^KVio`82
0_oEeMDAonk^kP03ojZe`?mn[MWoQk;K00?ooooo01;o7QhNom?CdomcLg?oDe=Col_;bolm?Cgooooo
oa<C4oo7alOooooooc<c<onATI7ojn_[o`d=3Oo[jn_ooooooahN7_nVYZH3ooooo`09olg=cOl0003o
a/K6oooooooHf=SoTY:Bof5QHOlF5QKoU9BD00;ooooo00Wo<c<cojFUYOooooooooooomSHf?nBTY;o
HF5QoaHF5_nDU9@00_ooool03OlN7QkoW9bLoo3`l?o`l?3onOWioooooolW9bOo/K6aoooooolW9bOo
/K6aol71`Ol30`<00_lQ8B400olF5QKo=CDeooooo`04ooooo`03olg=cOl:2P[ono_k00;ooooo00Wo
?CdmoiZJV_ooooooooooomSHf?nBTY;oHF5QoaHF5_nDU9@00_ooool01?lc<c?oYJFUooooool0001n
ooooo`03oo[jn_n5/=WoOZgI07kok^k^00god=3@okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooG
emOofm_KomoOgooQhN7oh^;R00;ohn?S1OoUiND03?l`<33oU9BDonKVi_nf][Ko0P82oi:BT_lh>3So
Rh^;onGUiOnZZZ[o0000ocLg=`?o>3Ph00_o/;2`on7QhOl=3@goZZZZoeeMGOn:RX[oJVYZoe]KFon/
[:co:2PXonGUi@02onKViPKoiNGU013oO7amokZh^?nV`lWodO[oomGhoooDoOooa_?ookORoonWeogo
ULGjoh6ckomk[NgoN:WZofnUj_meX<7oiNGU0_oVi^H00ooUiNGoi>CTonCTi002on?Sh`0=on;Rh_oP
h>3og=cLomWIfOoFe]Kod=3@olW9bOo1`L7o]KFeojFUYOnh^;Sod=3@on3Ph006onk^kP001_ooool0
2?lf=SKoYJFUoh20P?l>3Pkohn?Soooooolo?cooVi^K0_ooool01Ond];Cof][Jooclo?mQHF7oE5AD
00;ooooo00[o@410oaDE5On<S8coj>SXoclo?olO7aooH61Pon;Rh_maLG7o<c<c0_ooool01Olo?coo
Jf][ooOgmonNWYko:b/[00;ooooo00?ob/[:ol30`?ooool03Oooool00onZ]L3oOZgIohNbf`03oooo
o`0BoahN7_o@d=3o6ATIojj^[_oooooo:RXZomgMgOlC4a?oalO7om3@d?l61PKok>c/oooooomJFU[o
S8b<oooooolN7QkoYZJV0oooool00oojn_[o0`<3ojRXZ004ooooo`06ocXj>_nNWYkooooooooooolc
<c?oYJFU1Oooool01_lj>S[oWYjNoooooooooooo7QhNoaTI6@;o9bLW00go[:b/oooooolW9bOo/K6a
oooooolW9bOo/K6aooclo?lH61SoiNGUoooooon7QhOoMWIf00Gooooo00?oo_knoaTI6Oo;bl/00_oo
ool00olf=SKoVIVIooooo`04ooooo`08ocXj>_nNWYkooooooooooolc<c?oYJFUooooool0001noooo
o`03oo[jn_n5/=WoOZgI07kooooo00goh>3PolS8b?nEUIGoYjNWokJf]_o0`<3oa/K6olc<c?oAdM7o
e=CDomOGeooJf][ofm_K00?og=cL0_oNg]h2omgMg@0Jobh^;_n?Shoof=SHobHV9_m0@43og]kNocHf
=_n6QXKogMgMokjn__l0003oU9BDokBd]?n][Jgo0P82olK6a_nYZJWo2PX:omOGeonMWIgo@D51obXZ
:_nCTi?ofm_Koa<C4onm_Kd2omgMg@;og]kN0ooMgMd04OoNg]koNW]lolk:aonV_<;oh?koomSkoooK
o?ood_WoolC_oon`f_koW/Whohnll_n4/^goOZ[Xogj^jom^WLOog]kN00;ogMgM01;og]kNomgMgOoL
g=cog=cLom_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfmok2`/?nQXJ7ob<S8on3Ph?oa
lO46ooooo`001_o^k^h01?lb<S;oL71`o`@41?n<S8`2onk^kP09ocXj>_n@T93ok^k^onk^k_n0P83o
;Rh^o`h>3_le=CGo][Jf00;ok^k^00[oCTi>oh61POmYJFWo3Ph>obDU9Oo6a/KoShn?oaPH6?lM7Ago
XJ6Q0_o^k^h01OoFe]Ko@T92o``<3?lJ6Q[oZZZZ00;ok^k^00?oM7AdoeeMGOo^k^h03Oo^k^h00onZ
]L3oOZgIohNbf`03ooooo`0;oahN7_n?Shoo4A4AooWinOooooooQhN7oh20P?lC4a?oalO7ofe]KOmD
E5@00_ooool01Oo2`/;o9RHVoooooolN7QkoYZJV00?ooooo01Co_Kfmo`000?o2`/;ooooooe5ADOme
MGGoPX:2o`H61_oVi^Kooooook>c/olI6AWoDE5AogmoOoomoOgoDE5AogEeMOn2PX;o1PH6onKViP;o
oooo00?o7QhNojJVY_ooool00oooool02olW9bOo/K6aoooooolW9bOo/K6aoooooomlO7co?3`lohJ6
Q_lM7Agoa<C400Kooooo00KoNg]koa`L7?n2PX;o=SHfoa0@4?nJVYX2ooooo`0;oe5ADOmeMGGoPX:2
o`H61_oVi^Kooooook>c/olI6AWoDE5AogmoOol00000O_ooool00oojn_[oQK3Iogj]f@1nonk^kP0=
omCDe?no_kooS8b<oijNW_n][Jgo^KViol;2`_o7alOoc<c<om3@d?oBd];oeMGEomKFeP02omOGe`03
omSHf?oIfMWofMWI00;ofMWI00So;Bd]ohb<S?m/K6co2`/;ol71`OoIfMWo=CDeoh>3P`;ofMWI013o
=CDeoe]KFooBd];oQXJ6ob@T9?oIfMWoIVIVod51@OoIfMWodm?Co`l?3ol20P;obLW9omWIfOmFEUKo
LW9b2?oIfMT04?mjNWcofmOJoijc]oo[ooooi?goon?moooJnooob_7ook[QoonWc__oUKkboh^fkOn6
/>[oQZoYoffPd?oGemL3omWIf@;of=SH0_oGemL03OoEeMGodm?Com3@d?o>c/kob/[:olG5aOno_koo
]KFeojVYZOnHV9So_knoomCDe?oRh^801_o^k^h000Koi^KV00?o<30`o`@41?li>CT00ooVi^H00olh
>3SoRh^;onKViP03onKViP03onCTi?oVi^Koi^KV00Goi^KV00?oiNGUonKVi_oVi^H00_oVi^H00ooU
iNGoi^KVonKViP03onKViP03on?ShooVi^Koi^KV01;oi^KV00?oZ[G0ogj]fOn7/]/00oooool00olN
7Qko=3@dofEUI@02ooooo`06on?SholT92Co4Q8BolO7aonb/[;ofMWI0oooool01?nVYZKom?CdoahN
7_nVYZH3ooooo`08ofUYJOlG5aOom?CdoooooooUiNGo[Jf]oi>CTooIfMT2ooooo`09olS8b?lP823o
JFUYoj:RX_ono_koiNGUojf][OnCTi?ofMWI00?ooooo00?o7QhNojJVY_ooool00oooool01Ona/K7o
hn?SoooooolW9bOo/K6a00;ooooo00?o][JfohZ:R_o8b<P02?ooool01Ond];CoSHf=om3@d?lm?Cgo
VYZJ00;ooooo00CoiNGUojf][OnCTi?ofMWI0_ooool01Oo8b<So820PofUYJOnRXZ;o000007kooooo
00?on_[johF`fOmn[MT0O_oVi^H03OoAdM7o_knoohR8R?nCTi?oXZ:Rojn_[onj^[[o`L71olO7aoo;
bl_oc/k>om3@d?oAdM400_oCdm<3omCDe0;oeMGE00Co;Bd]ofATI?l410CoOWim0_oDe=@04?ld=3Co
PH61omKFe_oEeMGo`L71oc/k>ol:2P[o5aLGoiRHV?oEeMGo?Shnoh>3PooFe]KoeMGDoe1@D?li>CT2
omGEe@04oijNW_m0@43oe]KFomGEe0;oe=CD0_oEeMD05ooFe]KoeMGEogUiNooVhn;oY[2eooGooooR
o_oojOooon?nooo@m?oo_MomojcAnOnNa?;oTKK[ohR]i_n=]N[oKZ?Eom7AdOoFe]KoeMGDomCDe?oE
eMGoe=CD00;odm?C00godM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jfoj^[ZonMWIgoTI6Aokno_ooA
dM7ofm_K00Koi^KV0006onk^kP03oc8b<_l820SocLg=00?ok^k^00?o>SXjoi2@T?o^k^h0:oo^k^h0
0onZ]L3oOZgIohNbf`03ooooo`03oahN7_l0003o`L7100?ooooo00?oA4A4o`000?o7alL01oooool0
1olN7QkoOGemok^k^onRXZ;oGUiNo`d=3On`/;002Oooool00on>SXkob<S8ooooo`08ooooo`0;oahN
7_mmOGgo`<30ol30`?o2`/;ooooooiNGUooIfMWoooooobLW9ona/K404?ooool00olm?CgoVYZJoooo
o`08ooooo`04ohj>S_o8b<Soooooo`0007kooooo00?on_[johF`fOmn[MT0O_o^k^h04_oMgMgocLg=
oi2@T?n9RHWoUiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooIfMWof][Jom_KfooJf][ofm_K
omcLg0;ofm_K00?o;Rh^o`@41?lf=SH00_oKfm/00ooLg=co=SHfohF5Q@04om_Kf`03omSHf?oLg=co
fm_K00Kofm_K00?og=cLom_KfooKfm/01OoKfm/00ooLg=cofm_Kom_Kf`02om_Kf`0@ogYjNoobl_7o
V9bRoo?jnoojooookoooon;noooBm?oo`>;nojoAnOnSa_;oUk_/oi2dj?n?]>WoMZWKom;BdPGofm_K
00oof][JomWIfOoHf=Soe]KFom?Cdoo=cLgo`/;2okJf]_n/[:coWinOoi2@T?nFUYKocLg=omgMgOoU
iND01_o^k^h000Kooooo00?o/;2`okjn__ooool00oooool00ond];Cof=SHooooo`0[ooooo`03ojZe
`?mn[MWoQk;K00?ooooo00?oJ6QXoemOGoooool00oooool00onf][KoDe=ComWIf@07ooooo`06ofQX
J?mCDe?oDe=CofEUIOn8R8Sog=cL5Oooool02omXJ6SoDe=Coe=CDomCDe?oFUYJoooooom^KVkob/[:
oooooolW9bOo/K6a013ooooo00?o?CdmoiZJV_ooool02oooool00ol0003oooooooooo`1looooo`03
oo[jn_n5/=WoOZgI07kooooo00_ol_;bonGUiOnYZJWoNWYjohR8R?nFUYKoZZZZolC4a?oEeMGofm_K
omkNgP02on3Ph0?oh^;R00coi>CTon?ShooShn?ohn?Soc0`<?l820So`l?3on?ShooTi>Cohn?SocPh
>?n9RHT4on?Sh`03onCTi?oShn?ohn?S00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?S
on?Sh`03on?Sh`0@ogemO_omoOgoaLG4oiFIW_nna<Woinoaonchn_oYoOooeoGookSGoOnVa_;oV[WX
oi>ci_nB]>KoNZcOolc=cP;ohn?S01;oi>CTon?ShooRh^;oh^;Ron7QhOoPh>3ogmoOomcLg?oGemOo
aLG5ojb/[?nNWYkoT92@oh:2P_n][JgoiNGUoo;bl_oinOT6ooooo`00>_o^k^h00onZ]L3oOZgIohNb
f`0gooooo`03olW9bOo/k>cooooo00oooooo00?oc/k>onKVi_ooool02oooool00ol0003ooooooooo
o`1looooo`03oo[jn_n5/=WoOZgI07kok^k^00koiNGUomgMgOo2`/;oNg]kogQhN?n6QXKoWinOolG5
aOoHf=SogMgMomoOgooQhN7oh^;Ron?Sh`?oi>CT0ooUiND02OnNWYkoZJVYonCTi?oUiNGoi>CTonGU
iOnQXJ7o`L71onGUi@02onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03
onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND04ooTi>CoRh^=oo;bl_o_knoogM_Iok^j_?nUYjOo
XZ:WojB`/onY^L;o/m_eok3Fn?n[d?_oXl;coiNeiOn1[>7o/[NkonCTi?oUiND01?oTi>@03_oShn?o
hN7Qon3Ph?oOgmoof][JolK6a_nQXJ7oSHf=oh20P?n4Q8Co`l?3omgMgOoUiNGoj^[Z1_o^k^h003[o
i^KV00?oZ[G0ogj]fOn7/]/0Eoooool00ol0003oooooooooo`1looooo`03ooOgmon5/=WoOZgI07ko
i^KV00_oh>3Pom_KfooBd];oVi^KofEUIOmcLg?oSHf=ok^k^ooDe=Cof][JomgMg@02omoOg`03on3P
h?oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;R
h_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;oXj>SooKfmP02ooKfmP03ong]
kOofm_Kom_Kf00;om_Kf0_o4a<@01On6W;OoPj34ohV]h?nFdoGoWJR`00KohN7Q00koh>3PomoOgooM
gMgog=cLomGEeOni^KWoSXj>og]kNom^KVkoWYjNom;Bd_oKfm_oh>3PonCTi0Koi^KV000jonk^kP03
ojZe`?mn[MWoQk;K05Oooooo00?o0000ooooooooool0O?ooool00oogmoOoQK3Iogj]f@1nonk^kP0<
on_[jooXj>Soh^;RomOGeon=SHgoHV9RogIfM_nTY:CoalO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oo
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Go
g=cL00?ofm_KomcLg?oLg=`00ooLg=`02_mjNW[oXj>Sol_;c?ofm_Kojn_[ooShn?nDU9CoN7QhoiNG
UooXi^03ooKfmP03ok^j_?mKHfWo/K>f00;og=cL0_oKfm/04?oLg=cofm_Kom[Jf_oIfMWof=SHom?C
doo5aLGoW9bLogEeMOmWIfOoT92@omOGeooRh^;oj>SXon_[joo]kNd6onk^kP00>_ooool00onZ]L3o
OZgIohNbf`3Fooooo`03ooOgmon5/=WoOZgI07kooooo00koo_knoo_knoohn?Sol_;bomkNg_nATI7o
FUYJog]kNonSXj?o_;blolK6a_o;bl_ocLg=olo?c`;odM7A1OoBd]800ooAdM7od];Bom7Ad@05om;B
dP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;B
dP04om7AdOoBd];oYZJVojNWY`;oU9BD00GoRXZ:okjn__oAdM7oclo?oi2@T002oi6AT@07of9SHooB
d];od];Bom7AdOoBd];odM7Aom;BdP02om7Ad@0=om3@d?o?clooc<c<olS8b?nk^k_oW9bLog9bL_mK
Fe_oU9BDomkNg_obl_;on?Shoo_kn`02ooknoPKooooo000jonk^kP03ojZe`?mn[MWoQk;K00Cooooo
c_ojn_X4ooooo`03ooOgmon5/=WoOZgI07kok^k^0_o]kNd03_oZj^[oj>SXon;Rh_oLg=coW9bLofe]
KOmXJ6SoPh>3oiNGUonSXj?o[:b/ojn_[ona/K7o/[:b0_nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd
];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd
];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd017o]KFeokJf]?nd];Co/k>cok:b/_nc
/k?o[jn_ojZZZ_nLW9coPX:2of9RH_m^KVkoWinOomcLg?oRh^;oj>SXon[ZjP02ong]k@Ook^k^000j
onKViP03ojZe`?mn[MWoOZcI0=OoQ[7J00?oOZcIogj]fOoVi^H0O_oVi^H2onGUi@0?on?ShooPh>3o
gMgMom[Jf_o4a<CoVYZJogYjN_mYJFWoHf=SofUYJOmbLW;oM7AdogUiNOmlO7coNg]k00;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;o
OGem00GoO7alog]kNomlO7coOGelogalO002ogYjNP0;ogMgMomdM7CoKFe]ofm_KomlO7coVYZJolG5
aOoJf][ogMgMon3Ph?oShn<00_oUiND8onKViP00>_o^k^h00onCWZWoOZgIogj]f@3Iogj]fH3ok^k^
0_o]kNd01?o/k>coj^[ZonSXj?oUiND2on;RhP03on3Ph?oOgmoog]kN03oogMgM00?og]kNomoOgooP
h>000_oRh^801?oUiNGoj>SXon[Zj_o/k>`2ong]k@Wok^k^000jooooo`03og:5V?miQ8ooO8NB0=Oo
O8NB00?oNHB?ofiiQ?ooool0POooool2ooknoP03oogmoOokno_ono_k00;onOWi0_ohn?PoooOgm`;o
n?Sh0_oinOT2oo_kn`03oogmoOono_koo_kn00_ooooo003oonk^k_Gok^k^003oonKVi_Goi^KV003o
onk^k_Gok^k^003oooooooGooooo003oonk^k_Gok^k^003oonKVi_Goi^KV003oonk^k_Gok^k^0003
ooooooooclo?l?o?cll2ooooo`000oo^k^h00oni^KWok^k^onk^kP3oonk^k^cok^k^0Oni^KT1onk^
kP7ok^k^0003onKViP03okVi^OoShn?oi^KV0?ooi^KVjooVi^H00ooShn?o^KVionKViP01onKViP00
0oo^k^h00oni^KWohn?Sooooo`0@ooooo`03olC4a?olo?cono_k00?ono_k0_ojn_X2ooWin@04ooSh
n?ogmoOom_Kfojn_[`Wooooo00?oinOWoo[jn_ooool00_ooool01?o`l?3oo?clooWinOo]kNd4oooo
o`03od51@OnUYJGooooo00Kooooo00?ok>c/ooclo?ooool01?ooool00oo[jn_om_Kfooooo`3ooooo
occooooo00?og]kNonSXj?ooool00oooool00on0P83oUiNGooooo`0;ooooo`03ookno_oQhN7ogMgM
00Gooooo00?oP820oiNGUoooool01Oooool00ooMgMgolo?cooooo`0`ooooo`0?ojn_[onZZZ[o_;bl
ok>c/on^[Zko[jn_okNg]onm_Kgo`/;2olS8b?o>c/kodm?ComKFe_oCdm?ob/[:00;ok^k^00?ohn?S
okVi^Oo^k^h00Oo^k^h000?ooooo00?o^KVion?Shoooool04?ooool00oo6a/Kon_[jooclo002oocl
o0;ono_k00Oon_[jooWinOoinOWon?ShooOgmoodlo?o/K6a00Oooooo00Go`<30oa`L7?lU9BGo2PX:
ogUiN@02ooooo`06obLW9omLG5co71`Loa<C4om<C4comOGe0_ooool03?mFEUKoPH61oooooooooooo
;2`/of5QHOooooookno_oa`L7?lZ:R[o:b/[ohZ:RP;ooooo00God=3@ob`/;?lE5AGo;Bd]oda<C002
ooooo`03obLW9ona/K7ooooo0?oooooo=Oooool01_oXj>So<c<cob@T9?lM7AgoGEeMooclo0;ooooo
00?ocLg=odY:B_ooool00oooool5o`000008omOGeoooooooooooofEUIOlc<c?oATI6obPX:?o;bl/3
ooooo`03olg=cOm:BT[ooooo00?ooooo00Gokno_ocXj>_m0@43o8b<Sohf=S@03ooooo`Go000000?o
emOGooooooooool09Oooool03onc/k?oc/k>ono_kooalO7ojn_[omoOgooEeMGoemOGomgMgOoTi>Co
j^[Zoo3`l?oclo?ol?3`onGUi@02ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo013ooooo00Coa/K6ooShn?ojn_[on_[j0_oinOT02?ohn?SomoOgooOgmoofm_KomOGeooCd
m?oalO7o/K6a1_ooool03_oclo?o5aLGoi6ATOooooooh^;Roa@D5?n[Zj_oooooobLW9ombLW;omOGe
oo3`l?ld=3CoYJFU0_ooool04omFEUKoPH61ooooooooooooXJ6QokVi^Ooooooon_[jon7QhOoooooo
j>SXo`P82?o/k>comoOgob8R8_mlO7cono_kooooooogmoL00_ooool00olW9bOo/K6aooooo`3ooooo
ocGooooo00KoGEeMof1PH?olo?cono_koc@d=?nHV9P2ooooo`03ookno_lR8R;omOGe00?ooooo00?o
C4a<of1PH?olo?`00_olo?`6ooooo`03olK6a_l?3`ookno_00;ooooo00?oo_knob8R8_oemOD00ooo
ool01_mUIFGoM7Adooooooo_knoo6QXJolc<c0;ooooo00?oC4a<of1PH?olo?`00_olo?`Xooooo`0?
okJf]_o@d=3olO7aooOgmoohn?SomoOgonSXj?oLg=coh^;RonKVi_o^k^kom?CdooOgmoodm?Coj>SX
00;ok^k^00?ohn?SokVi^Oo^k^h00Oo^k^h000?oi^KV00?o^KVion?Shoooool04?ooool01Oo6a/Ko
moOgooKfm_ogn?SomoOg00;om_Kf00OomOGeooCdm?oclo?ol_;boo7alOo_knoo/K6a00Kooooo00?o
`<30o`820_o^k^h00_ooool01OmCDe?oHF5QoooooolW9bOo/K6a00;ooooo00KoOgmooeYJF_oooooo
oooooeIFE_n1PH47ooooo`07onCTi?mRHV;o5aLGoo_knoo4a<Co2@T9ono_k`05ooooo`03obLW9ona
/K7ooooo0?oooooo=?ooool00oojn_[o1@D5ok^k^`02ooooo`03ogalO?mGEeOooooo00;ooooo00?o
IVIVok2`/?ooool00_ooool00ooTi>Co8b<SokFe]@09ooooo`03obDU9On8R8Sooooo00;ooooo00Oo
IVIVok2`/?ooooooooooooShn?l:2P[od];B00;ooooo0_mYJFT2ooooo`03onCTi?lS8b?o]KFe02[o
oooo00oo]kNgom3@d?oalO7omoOgooWinOojn_[omOGeomgMgOoTi>Coj^[Zoo7alOohn?Son_[jooKf
m_o[jn/00_oVi^H00ooShn?o^KVionKViP01onKViP000oo^k^h00oni^KWohn?Sooooo`0@ooooo`0>
olK6a_o`l?3om?CdooKfm_ofm_GomOGeooCdm?oclo?ol_;boo7alOo`l?3okno_on_[jona/K46oooo
o`03ok>c/ol;2`_oo?cl00;ooooo00GoJFUYoeADE?oooooo9bLWok6a/@02ooooo`06oiZJV_l/;2co
oooooooooomFEUKoPH611_ooool01onNWYko30`<oe=CDooRh^;ooooool71`Ol30`<00_lQ8B401_lF
5QKo=CDeoooooooooooo9bLWok6a/Ooooooo=Oooool00ooOgmoo0000ok6a/@02ooooo`03oe1@D?n1
PH7ooooo00;ooooo00?o/k>cof=SHoooool00oooool00ooKfm_o9BDUok>c/`04ooooo`06onOWiom?
Cdoo8B4QoeEEEOmADE7oEEEE0oooool01onc/k?oHf=Soooooooooooofm_Ko`000?oclo<00_ooool0
0on;Rh_o@d=3ooooo`02ooooo`03om_KfolU9BGo/k>c02Wooooo00Go^[Zjom7AdOobl_;on?ShooWi
n@02oo[jnP08omoOgooVi^Kojn_[oo;bl_oinOWoo?clooShn?o]kNd2onk^kP03on?Shoni^KWok^k^
007ok^k^0003ooooo`03okVi^OoShn?ooooo013ooooo00?oa/K6ono_koobl_800_oclo<02Oobl_;o
lO7aoo3`l?o_knook^k^ong]kOo[jn_oh^;Rok6a/@06ooooo`03on3Ph?l20P;obl_;00;ooooo00Go
;2`/ohB4Q?oooooo9bLWoh:2PP02ooooo`06ofEUIOm[Jf_ooooooooooomFEUKoPH611Oooool00oon
o_ko4Q8BokBd]003ooooo`06ooclo?lH61SoiNGUoooooon7QhOoMWIf0_ooool00olW9bOoJVYZoooo
o`3oooooocCooooo00Oof=SHo`000?m3@d?oTi>CogEeMOlB4Q;ogmoO00?ooooo00?om_Kfob4Q8Oon
o_h01?ooool00ooPh>3o7AdMokVi^@03ooooo`06of][JomMGEgol_;bomCDe?lG5aOo>CTi0oooool0
1oofm_Ko8B4Qookno_oooooob/[:o`000?olo?`00_ooool00onFUYKo<S8booooo`03ooooo`03on3P
h?lM7Ago^KVi02Sooooo00oo^[Zjom7AdOobl_;omoOgooWinOojn_[ono_kojb/[?oWinOokNg]ooCd
m?ojn_[ooOgmooWinOo_knl00_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?S
ooooo`0@ooooo`0>olK6a_o`l?3ol?3`oo7alOo`l?3okno_onk^k_o]kNgok>c/on_[jooYjNWohN7Q
om;Bd_na/K47ooooo`0=ogMgMolN7QkoPX:2odE5AOlX:2SolO7aoooooolW9bOoCTi>odY:B_mCDe?o
1@D5ol30`002ooooo`03oeIFE_n1PH7ooooo00Gooooo00CoCTi>of5QHOnATI7oU9BD0_ooool01Oml
O7co?3`lohJ6Q_lM7Agoa<C400;ooooo00Co9bLWodY:B_m7AdOoXJ6Qoooooolcooooo`03ooGemOl0
003obl_;00;oUIFE00?ol?3`ooooooooool00oooool00om=CDgob/[:ooooo`04ooooo`07ojf][OlD
51CooOgmooooooojn_[o410@olO7a`02ooooo`03of][Jom:BT[ooooo00?ooooo00KoCDe=ol[:b_oo
ooooi>CTo`000?o]kNd2ooooo`03ohN7Qom<C4cooooo00Cooooo00?o[Jf]oa@D5?omoOd09oooool0
3onj^[[odM7Aoo;bl_ohn?SonOWioo[jn_oEeMGo@d=3ol71`Oo/k>com_Kfoo_knoono_kon_[jono_
k`02onk^kP03on?Shoni^KWok^k^007ok^k^0003onKViP03okVi^OoShn?ooooo013ooooo00koa/K6
onk^k_o_knook^o^onk^k_o]kNgok>c/on_[jooZj^[oj>SXon;Rh_oEeMGoaLG5okJf]PSooooo00Co
`L71ohb<S?nTY:ComOGe0_ooool01OlW9bOo/K6aol?3`on=SHgobLW900?ooooo00?o`/;2om7AdOoo
ool01Oooool01?oemOGo/;2`ohZ:R_nl_;`3ooooo`03okJf]_n:RX[ob<S800?ooooo00Co/K6aon?S
honm_Kgo[Zj^ooooooldooooo`03oc<c<onPX:3ooooo00Oooooo00?oVYZJogemOOooool01?ooool0
1ooShn?o0000on?ShooooooooOgmo`T92Oo:b/X00_ooool00om0@43oMWIfooooo`03ooooo`06oiZJ
V_mmOGgooooooogmoOlN7Qko^k^k0_ooool00omFEUKoPh>3ooooo`04ooooo`03on?Shol0003ohn?S
02Oooooo00oo^[Zjom3@d?obl_;on?ShooWinOojn_[oLG5aod=3@omUIFGojNWYooGemOokno_ooOgm
oo[jn_o_knl00_oVi^H00ooShn?o^KVionKViP01onKViP000oo^k^h00oni^KWohn?Sooooo`0@oooo
o`0>olK6a_o[jn_ok>c/on_[jooZj^[ojNWYonSXj?oWinOoiNGUomkNg_oCdm?oa/K6ojn_[onk^k/>
ooooo`03obLW9ona/K7ooooo00Gooooo00?o[Zj^ol;2`_ooool0oooooom:ooooo`06ok>c/olS8b?o
d=3@ooCdm?nm_Kgoh^;R1?ooool02OoUiNGo<C4aooooooooooooTI6Aokno_oo/k>coLW9bocXj>P03
ooooo`06ofUYJOmEEEGoi>CToifMWOl>3PkogmoO1?ooool02_oUiNGo<C4aooooooooooooTi>Coclo
?oo[jn_o_KfmoaTI6OoYjNT2ooooo`05oi6ATOno_kook>c/og9bL_lj>SX0:?ooool03onl_;cod];B
oo;bl_ohn?SonOWiokNg]om;Bd_o@d=3odE5AOn[Zj_om?Cdoo_knoono_kon_[jono_k`02onk^kP03
on?Shoni^KWok^k^007ok^k^0003ooooo`03okVi^OoShn?ooooo013ooooo00koa/K6onOWiooWinOo
inOWonKVi_oUiNGoi>CTon;Rh_oJf][oalO7ok2`/?n_[jooUIFEol71`@kooooo00?o9bLWok6a/Ooo
ool01Oooool00on=SHgoZZZZooooo`3ooooood_ooooo00Go]KFeodQ8B?lX:2SoCDe=omGEe@05oooo
o`08ofm_KooemOGoooooojNWYomIFEWo;bl_og9bL_oHf=P3ooooo`05ooShn?mgMgOo;Bd]odI6A_o6
a/H01_ooool02?m_KfoomOGeooooooooooooSHf=oc8b<_m:BT[oclo?0oooool01OnWYjOoFEUIobl_
;ombLW;of=SH02Sooooo00oo^k^kom7AdOobl_;on?Shono_komNGUkoBTY:od=3@om5ADGoDe=ConSX
j?olo?coo_knoo[jn_o_knl00_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?S
ooooo`0@ooooo`0>olK6a_oRh^;ohn?Son?ShooRh^;ohN7Qon3Ph?oGemOoX:2PohR8R?mmOGgoU9BD
oj:RX_oHf=P>ooooo`03olW9bOo/k>cooooo0?ooooooZoooool03onk^k_od];Boo;bl_ohn?SoX:2P
od];Bom:BT[o@d=3odE5AOm7AdOoTI6Aoo_knoono_kon_[jono_k`02onk^kP03on?Shoni^KWok^k^
007ok^k^0003onKViP03okVi^OoShn?ooooo013ooooo00?oa/K6omoOgooPh>000_oOgml01?oNg]ko
fMWIolc<c?n8R8P2oo_kn`03omoOgon@T93ojn_[0?oooooo_?ooool03onk^k_od];Boo?cloohn?So
nOWioo[jn_ofm_KohN7QonSXj?o]kNgom?Cdooclo?ono_kon_[jono_k`02onKViP03on?Shoni^KWo
i^KV007oi^KV0003onk^kP03okVi^OoShn?ooooo013ooooo00?oa/K6om_KfooMgMd00_oLg=`02?oH
f=Soc/k>okno_onUYJGono_komoOgon@T93oh>3Poooooonmooooo`0?ok^k^ooBd];olo?cooShn?oi
nOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?clookno_ojn_[okno_00;ok^k^00?ohn?SokVi^Oo^
k^h00Oo^k^h000?ooooo00?o^KVion?Shoooool04?ooool03?o3`l?ofMWIom_KfooKfm_oe]KFolc<
c?o1`L7oYZJVol30`?oOgmooTi>Con7QhOoooooo__ooool03onk^k_od];Boo?cloohn?SonOWioo[j
n_ofm_KohN7QonSXj?o]kNgom?Cdooclo?ono_kon_[jono_k`02ooooo`03on?Shoni^KWooooo007o
oooo0003onk^kP03okVi^OoShn?ooooo013ooooo00_of][JolW9bOo6a/KoaLG5ol71`Ona/K7oY:BT
ok2`/?nh^;So`<30onOWi`3ooooookoooooo00oo^k^kom;Bd_oclo?on?ShooWinOojn_[om_Kfon7Q
hOoXj>SokNg]ooCdm?olo?coo_knoo[jn_o_knl00_o^k^h00ooShn?o^KVionk^kP01onk^kP000ooV
i^H00oni^KWohn?Sooooo`3oooooom[ooooo00oo^k^kom;Bd_oclo?on?ShooWinOojn_[om_Kfon7Q
hOoXj>SokNg]ooCdm?olo?coo_knoo[jn_o_knl00_oVi^H00ooShn?o^KVionKViP01onKViP000oo^
k^h00oni^KWohn?Sooooo`3oooooom[ooooo00goYJFUok2`/?no_koo]kNgok:b/_n_[joo[Jf]oijN
W_nTY:CoZZZZokFe]Oo4a<Coclo?00;ofm_K0_o^k^h00ooShn?o^KVionk^kP01onk^kP000oooool0
0oni^KWohn?Sooooo`0@ooooo`05oj:RX_mbMgooYjR[omcLg?omoOd00oooool01?omoOgono_koocl
o?ono_koooooofgooooo00?oLG5aon?Shoooool04oooool00omaLG7ohn?Sooooo`0hooooo`0?ok^k
^ooBd];olo?cooShn?oinOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?clookno_ojn_[okno_00;o
oooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool04?ooool02?n2OggoZ/_T
oh:on?mhXLooKH2Ioh>8T?nf]kSoj^[Z1?ooool00oolo?cono_kooknoP0Aooooo`03ooGemOoinOWo
oooo00Cooooo00?ok>c/ooclo?ooool01oooool00ooXj>Son_[jooooo`3oooooocgooooo00?oo_kn
on7QhOoMgMd01Oooool00on0P83oUiNGooooo`0=ooooo`03omgMgOoclo?ooooo00?ooooo00?oP820
oiNGUoooool01Oooool00ooMgMgolo?cooooo`0`ooooo`0?ok^k^ooBd];olo?cooShn?oinOWon_[j
ooKfm_oQhN7oj>SXong]kOodm?Coo?clookno_ojn_[okno_00;ok^k^00?ohn?SokVi^Oo^k^h00Oo^
k^h000?oi^KV00?o^KVion?Shoooool04?ooool03?n9QhKoXL;Hoh2nm_nCcokoWM_ooi[Foon:_oCo
LiS4og:1U_n?TYSoa<G5oo?cl`Wooooo00Go7QhNom?Cdooooooo`L71ojj^[P02ooooo`0>oa<C4oo7
alOooooooj:RX_l@413o61PHoi:BT_lR8R;o][Jfono_kolL71co:RXZob/[:on:RXX2ooooo`08obLW
9ona/K7oooooolc<c?lT92Co3`l?oa/K6on2PX;oooooocgooooo00GoIFEUoc<c<om6ATKo:2PXol_;
b`03ooooo`03olg=cOm:BT[ooooo00?ooooo00Koe=CDob4Q8OlB4Q;o2PX:ob4Q8OnOWil2ooooo`05
ono_kolj>S[o@410ob<S8on=SHd00oooool00oo=cLgoBTY:ooooo`03ooooo`05ono_kolj>S[o@410
ob<S8on=SHd00oooool5o`000003omOGeooooooooooo02Gooooo00oo^k^kom;Bd_oclo?on?ShooWi
nOojn_[om_Kfon7QhOoXj>SokNg]ooCdm?olo?coo_knoo[jn_o_knl00_oVi^H00ooShn?o^KVionKV
iP01onKViP000oo^k^h00oni^KWohn?Sooooo`0@ooooo`0?ohV8Qon_b]WoTlcjoic@nonNdoWoV]3g
oiKBoOn;aOCoNjoQohW5oomm[ncoKH^bogAoS_nMWj;olO7a00Kooooo01oo7QhNom?Cdooooooo:BTY
o`T92OoalO7ooooooa<C4oo7alOooooooc4a<OnIVIWon?Shog1`L?l410Co][Jfoo[jn_oQhN7ooooo
onSXj?l820Sok>c/oooooolW9bOo/K6aooOgmolP823oHF5Qoo;bl_ono_kok^k^0?oooooo@?ooool0
0oo6a/Ko3`l?ono_k`02ooooo`03ookno_lR8R;omOGe00Gooooo00?oRXZ:ode=COooool00oooool0
1_mUIFGoM7Adooooooo_knoo6QXJolc<c0;ooooo00?oo_knob8R8_oemOD00oooool01_mUIFGoM7Ad
ooooooo_knoo6QXJolc<c0;ooooo00?oC4a<of1PH?olo?`00_olo?`Xooooo`0?ok^k^ooBd];olo?c
ooShn?oinOWon_[jooKfm_oQhN7oj>SXong]kOodm?Coo?clookno_ojn_[okno_00;ok^k^00?ohn?S
okVi^Oo^k^h00Oo^k^h000?ooooo00?o^KVion?Shoooool04?ooool03on:RHOo]lkJojKIn_nch_ko
]nWookCUoOnaj?ooNj6nocLmAOm_X=KoM;7fogJdn_mm^?coOKkoojBZ/006ooooo`0@oahN7_oCdm?o
c/k>o`L71omMGEgoVi^KoooooolC4a?oalO7oooooolE5AGo`/;2ooooooono_ko71`LokJf]P;ooooo
00[oi>CTof9RH_lG5aOono_koooooolW9bOo/K6aol?3`ol0003oeMGEoooooom4ooooo`03obDU9On8
R8Sooooo00;ooooo00?oIVIVok2`/?ooool01?ooool00on:RX[oCDe=ooooo`02ooooo`03ooShn?l:
2P[od];B00;ooooo0_mYJFT3ooooo`07ofIVI_n`/;3oooooooooooohn?So2PX:om;BdP02ooooo`;o
JFUY0_ooool00ooTi>Co8b<SokFe]@0Zooooo`0?ok^k^ooBd];olo?cooShn?oinOWon_[jooKfm_oQ
hN7oj>SXong]kOodm?Coo?clookno_ojn_[okno_00;ooooo00?ohn?SokVi^Oooool00Oooool000?o
k^k^00?o^KVion?Shoooool04?ooool03on:RXWo_m3HokCRn?o2k?ooa?3molSgoonSbmgoADeBoe1M
IomZSK?oOkOjofbRhomVV]goKZc`oi^V/006ooooo`0<oahN7_oCdm?oLg=coe=CDoo;bl_o?Cdmoooo
oolC4a?oalO7oooooolE5AGo`l?30_ooool01olR8R;o][JfoooooonNWYko30`<oe=CDooRh^800_oo
ool01OlW9bOo/K6aok>c/ol20P;okno_0?oooooo@?ooool01_oWinOoCdm?ob4Q8OmEEEGoDE5AoeEE
E@?ooooo00?o/k>cof=SHoooool01?ooool00on:RX[oCDe=ooooo`02ooooo`03om_Kfol0003olo?c
00;ooooo00?oRh^;od=3@oooool00_ooool01onc/k?oHf=Soooooooooooofm_Ko`000?oclo<00_oo
ool00on;Rh_o@d=3ooooo`02ooooo`03om_KfolU9BGo/k>c02Wooooo00oo^k^kom;Bd_obl_;on?Sh
oj2PX?m;Bd_oBTY:od=3@om5ADGoAdM7oi6ATOokno_oo_knoo[jn_o_knl00_o^k^h00ooShn?o^KVi
onk^kP01onk^kP000ooVi^H00oni^KWohn?Sooooo`0@ooooo`0?ohb:R_o5d]Ko_^WeolofoooAmoco
g_ooohVPYOm3BDooNiRaoe9RMOn3/^[oOJo]ogJUiOmh/O?oVJB^00Kooooo00co7QhNom3@d?lI6AWo
[Zj^oooooolZ:R[ogMgMoa<C4oo7alOooooooaDE5Oo3`l<2ooooo`05ob8R8_nf][Koo_knoa8B4_nd
];@01?ooool01OlW9bOo/K6aomoOgol20P;oYJFU0?oooooo@?ooool01_m[Jf_oGEeMoo;bl_oDe=Co
5aLGocTi>@?ooooo00?om_Kfob4Q8Oono_h01?ooool00on:RX[oCDe=ooooo`02ooooo`03ol[:b_l0
003oo?cl00;ooooo00?oUYJFoc8b<_ooool00_ooool01oofm_Ko8B4Qookno_oooooob/[:o`000?ol
o?`00_ooool00onFUYKo<S8booooo`03ooooo`03on3Ph?lM7Ago^KVi02Sooooo00oo^k^kom7AdOob
l_;on?Shono_komNGUkoBTY:od=3@om5ADGoDe=ConSXj?olo?coo_knoo[jn_o_knl00_oVi^H00ooS
hn?o^KVionKViP01onKViP000oo^k^h00oni^KWohn?Sooooo`0@ooooo`0?ohb<S?o:d]GoaN_aom[l
oooKn_gohOoookGDfom0A4So>Sdooc<d=?n2YmGoR;ObogjYiOmo/nkoUJ>_00Kooooo00co7QhNohn?
SolA4A7onOWioooooon7QhOoP820oa<C4oo7alOooooooaDE5Oo3`l<2ooooo`07ob8R8_nf][Kooooo
odi>C_mQHF7oTI6AoiBDU002ooooo`08obLW9ona/K7oooooogQhN?l:2P[oK6a/oh>3Pon`/;3ooooo
occooooo00?on_[joa0@4?o7alL00_ooool00om[Jf_oBTY:ooooo`03ooooo`03ode=COo:b/[ooooo
00?ooooo00?oRXZ:ode=COooool00_ooool00ooTi>Co0000ong]k@02ooooo`03ohN7Qom<C4cooooo
00?ooooo00KoCDe=ol[:b_ooooooi>CTo`000?o]kNd2ooooo`03ohN7Qom<C4cooooo00Cooooo00?o
[Jf]oa@D5?omoOd09oooool03onl_;cod];Boo;bl_ohn?SonOWiokNg]om;Bd_o@d=3odE5AOn[Zj_o
m?Cdoo_knoono_kon_[jono_k`02onk^kP03on?Shoni^KWok^k^007ok^k^0003ooooo`03okVi^OoS
hn?ooooo013ooooo00ooSXf=oloCeOo9i^WohoooonCmoooQnogohoooogb=TOm9CeOoKh:GoiFmk_n<
]NcoQJgVohJbj_nBXK001_ooool00olN7Qko=3@dofEUI@02ooooo`07on?SholT92Co4Q8BolO7aooo
ooooZZZZonWYj@02ooooo`07ojn_[ooUiNGoooooooGemOn`/;3oRXZ:okbl_002ooooo`08ok6a/OoS
hn?oooooooooooo5aLGoSHf=oi>CTooEeMGooooooccooooo00?ooOgmo`T92Oo:b/X00_ooool00om0
@43oMWIfooooo`03ooooo`03oiZJV_mmOGgooooo00?ooooo00?oRXZ:ode=COooool00_ooool00oom
oOgo7QhNok^k^`02ooooo`03oeIFE_n3Ph?ooooo00?ooooo00KoVYZJogemOOoooooooOgmoahN7_nk
^k/2ooooo`03oeIFE_n3Ph?ooooo00Cooooo00?ohn?So`000?oShn<09oooool03onj^[[od=3@oo;b
l_ohn?SonOWioo[jn_maLG7o@d=3ofEUIOoYjNWomOGeoo_knoomoOgon_[jono_k`02ooooo`03on?S
honi^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo013ooooo00ooSXj>omKGfOoAhN?ok_oo
onSmo_oTn_coh_oook3;d_mRKg[o[M7foj36m?nA]n[oS;7VohVbi?n@XK801_ooool00olN7Qko0000
ol71`@03ooooo`03odA4A?l0003oalO700kooooo00?oUiNGomWIfOooool0oooooom2ooooo`06ofUY
JOmEEEGoi>CToifMWOl>3PkogmoO1?ooool02?oUiNGo<C4aoooooooooooogMgMog=cLomHF5SoCDe=
1?ooool01_nCTi?o?cloon_[jonm_Kgo6ATIonWYj@Cooooo00[oiNGUoc4a<Ooooooooooooi>CTolo
?coojn_[okfm_OlI6AWojNWY0_ooool01OnATI7o_knoonc/k?mbLW;o>SXj02Sooooo00oo^[Zjom7A
dOobl_;on?ShooWinOojn_[oeMGEod=3@oo1`L7ok>c/ooKfm_okno_oo_knoo[jn_o_knl00_o^k^h0
0ooShn?o^KVionk^kP01onk^kP000ooVi^H00oni^KWohn?Sooooo`0@ooooo`0?ohj>S_oShnCo^/75
ongjo?oco_kolokmongoooo1gNKoAdaAoiRbd?nXb_OoU[SXoi:di_n</>3oSj:f00Kooooo00?oJ6QX
oemOGoooool00oooool00onf][KoDe=ComWIf@0>ooooo`03ofi^K_o:b/[ooooo0?oooooo@_ooool0
1Oohn?SoMgMgobd];Om6ATKoa/K600Kooooo00OoKfm_ooGemOoooooom_KfojRXZ?mYJFWoL71`00Go
oooo00CoSHf=oc8b<_m:BT[oclo?1_ooool02?m_KfoomOGeooooooooooooSHf=oc8b<_m:BT[oclo?
0oooool01OnWYjOoFEUIobl_;ombLW;of=SH02Sooooo00oo^[Zjom7AdOobl_;omoOgooWinOojn_[o
no_kojb/[?oWinOokNg]ooCdm?ojn_[ooOgmooWinOo_knl00_oVi^H00ooShn?o^KVionKViP01onKV
iP000oo^k^h00oni^KWohn?Sooooo`0@ooooo`0?ohj>S_olo?co^kblok^n`OnoaLSob=3Dol_Lh?o9
i^coZLCDokSHnon]c_SoWko]oiRgion?[]WoT:>h0?oooooo^oooool03onk^k_oe=CDoo?cloohn?So
nOWioo[jn_odm?CohN7QonOWioo]kNgomOGeoo_knoono_kon_[jono_k`02onk^kP03on?Shoni^KWo
k^k^007ok^k^0003ooooo`03okVi^OoShn?ooooo013ooooo00ooc/k>omgMgOo`l>ooe]KEolg=cOo2
`/?obL[;ol_?d_nnbm?oY[S:oiVddOnD]=_oUkOWoi>cgonCZL40oooooonkooooo`0?ok^k^ooCdm?o
l_;booShn?oinOWon?Shon_[jooQhN7oj>SXono_koofm_Kono_koogmoOojn_[okno_00;ooooo00?o
hn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool03oooool04?ono_koooooohf=SOo/
k>colO7aooKfm_okno_oXZ:RoiVHV?o=blWogmgKomWHf?o2al_o[KO4oh^M/?n=VZWooooook_ooooo
00oo^k^kom;Bd_obl_;omoOgooKfm_oZj^[og=cLon7QhOoXj>Sok^k^ooGemOokno_oo_knoo[jn_o_
knl00_o^k^h00ooShn?o^KVionk^kP01onk^kP000ooVi^H00oni^KWohn?Sooooo`0@ooooo`0?ookn
o_okno_of=SHoj^[Zon@T93oXJ6QomGEeOooooooh>3PokBd]?nCTi?oUIBDok^j^?nOWYcono_k0?oo
oooo^oooool03onj^[[odM7Aoo;bl_obl_;og]kNom?CdooIfMWohN7QonOWioo]kNgomOGeoo_knoon
o_kon_[jono_k`02onKViP03on?Shoni^KWoi^KV007oi^KV0003onk^kP03okVi^OoShn?ooooo013o
oooo00?oo_knoogmoOooool00oooool02?ojn_[oo?clooooooooooooo_knoooooooEeMGob<S9oooo
oonlooooo`0?okbl_?oCdm?ok^k^om;Bd_nYZJWoVi^Koi:BT_n9RHWoTi>CojFUYOo4a<Colo?cookn
o_ojn_[okno_00;ok^k^00?ohn?SokVi^Oo^k^h00Oo^k^h000?ooooo00?o^KVion?Shoooool0oooo
oooJooooo`06okZj^_oAdM7oaLG5oiZJV_nFUYKoXJ6Q0onXZ:P01_nQXJ7oUiNGojf][OoRh^;on_[j
ono_k`;ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0oooooooJoooo
o`0?ok^k^ono_kooX:2PojFUYOn_[joo^[Zjokjn__o3`l?o`/;2okbl_?nf][Ko[Zj^ok6a/OoTi>Co
kno_00;ok^k^00?ohn?SokVi^Oo^k^h00Oo^k^h000?oi^KV00?o^KVion?Shoooool04?ooool01OnR
XZ;oLWMoojNXZooLg=cooOgm00?ooooo00CooOgmoo_knoolo?coo_knoooooom]ooooo`03og5aLOoS
hn?ooooo01?ooooo00?oLG5aon?Shoooool0>?ooool03onm_KgoYZJVoj^[Zong]kOo`L71olG5aOo:
b/[oc/k>om7AdOo@d=3oclo?olS8b?nl_;coa<C4ong]k@02onKViP03on?Shoni^KWoi^KV007oi^KV
0003onk^kP03okVi^OoShn?ooooo013ooooo00SoPWmmoj[;i?n2_oSoMj3>off1Von5RYCo]kNhon[Z
jPCooooo00?oo?cloo_knoono_h04_ooool00ooWinOon_[jooooo`0=ooooo`03on_[joofm_Kooooo
00?ooooo00?ok>c/ooclo?ooool0oooooolgooooo`03ookno_oQhN7ogMgM00Gooooo00?oP820oiNG
Uoooool03Oooool00ooMgMgolo?cooooo`03ooooo`03oh20P?nGUiOooooo00Gooooo00?ogMgMoo?c
loooool0<?ooool03oni^KWo[jn_okJf]_nn_[koalO7olc<c?oAdM7oe]KFomSHf?oKfm_ofMWIomSH
f?oBd];o`l?3omkNgP02onk^kP03on?Shoni^KWok^k^007ok^k^0003ooooo`03okVi^OoShn?ooooo
013ooooo00coRHN6oj72f?n0__KoU=7ooiC?m?mh[<;oOJkIogFHaomcPY_oT9BJolC5aOoclo<9oooo
o`05oahN7_oCdm?ooooool71`On^[Zh00_ooool02?lC4a?oalO7ooooooo0`<3o71`LobDU9Ol:2P[o
NGUi0oooool00om9BDWo;Bd]ooooo`02ooooo`0>obLW9ona/K7oooooom3@d?l/;2co5ADEobd];Om<
C4coooooono_kolL71co:RXZob/[:on:RX[oooooocOooooo00GoIFEUoc<c<om6ATKo:2PXol_;b`03
ooooo`03olg=cOm:BT[ooooo00?ooooo00Koe=CDob4Q8OlB4Q;o2PX:ob4Q8OnOWil2ooooo`05ono_
kolj>S[o@410ob<S8on=SHd00oooool00oo=cLgoBTY:ooooo`03ooooo`05ono_kolj>S[o@410ob<S
8on=SHd00oooool5o`000003omOGeooooooooooo02Gooooo00go]KFeokJf]_nm_Kgo`/;2olW9bOo@
d=3oe]KFom[Jf_oOgmoohn?Son;Rh_oShn?og]kN00;of=SH0_ooool00ooShn?o^KViooooo`01oooo
o`000oo^k^h00oni^KWohn?Sooooo`0@ooooo`0?ohV8Qon_b]WoT/[hoj;Go_n0/<Ko8D8?obiG9_ln
Ke?oF8j@ogFYbomfYmkoKhffogAoS_nMWj;olO7a00Kooooo01Go7QhNom?Cdooooooo:BTYo`T92Ooa
lO7ooooooa<C4oo7alOolo?coaLG5onATI7oooooon;Rh_lD51CoZj^[oooooooVi^Ko1PH6oahN7_o7
alL00_ooool03olW9bOo/K6aooOgmolR8R;oO7aloo_knooooooomoOgooooooojn_[ohN7QoooooooX
j>So20P8onc/k03oooooocWooooo00?oa/K6o`l?3oo_knl00_ooool00oono_ko8R8RooGem@05oooo
o`03ohZ:R_m=CDgooooo00?ooooo00KoIFEUogAdM?ooooookno_oaXJ6_o<c<`2ooooo`03ookno_lR
8R;omOGe00?ooooo00KoIFEUogAdM?ooooookno_oaXJ6_o<c<`2ooooo`03oda<C?mPH63oo?cl00;o
o?cl:?ooool02_nd];Co]kNgol71`Oo7alOoclo?omGEeOoKfm_oh>3PonGUiOoYjNT2on[ZjP03onOW
iooRh^;ogMgM00;ok^k^00?ohn?SokVi^Oo^k^h00Oo^k^h000?oi^KV00?o^KVion?Shoooool04?oo
ool03on:RHOo]lkJojGGn?nij?ooVl_FodMP?OlgCBco3S85o`H_0olXC1So=5h/oebAZOmo^okoO;go
ojBZ/006ooooo`0<oahN7_oCdm?oc/k>o`L71omMGEgoVi^KoooooolC4a?oalO7ol30`?l20P;ok^k^
0_ooool01omCDe?oHF5Qoooooon:RX[oBd];ohZ:R_mRHV800_ooool01OlW9bOo/K6aolC4a?l92@Wo
kno_00Kooooo00Coi>CTof9RH_lG5aOono_kooooooljooooo`03obDU9On8R8Sooooo00;ooooo00?o
IVIVok2`/?ooool01?ooool00on:RX[oCDe=ooooo`02ooooo`03ooShn?l:2P[od];B00;ooooo0_mY
JFT3ooooo`07ofIVI_n`/;3oooooooooooohn?So2PX:om;BdP02ooooo`;oJFUY0_ooool00ooTi>Co
8b<SokFe]@0Zooooo`0?okFe]Onk^k_o`l?3ol[:b_oAdM7of=SHomoOgooTi>Coj^[Zonk^k_o`l?3o
lO7aong]kOoXj>Sohn?S00;oi^KV00?ohn?SokVi^OoVi^H00OoVi^H000?ok^k^00?o^KVion?Shooo
ool04?ooool03on:RXWo_m3Hok?Qm_o7l_oo[=OLodMX??m;H47oB5/mociG=_lnFcGo;4XDocMQFom[
X>_oK:_]oi^V/006ooooo`0<oahN7_oCdm?oLg=coe=CDoo;bl_o?CdmoooooolC4a?oalO7ok>c/ol;
2`_oo?cl0_ooool03OmYJFWoE5ADooooool[:b_oZj^[onWYjOl@413ol_;boooooolW9bOo/K6aol71
`Ol30`<00_lQ8B402?lF5QKo=CDeooooooooooooWYjNo``<3?mCDe?oh^;Roooooolgooooo`06onOW
iom?Cdoo8B4QoeEEEOmADE7oEEEE0oooool00onc/k?oHf=Sooooo`04ooooo`03ohZ:R_m=CDgooooo
00;ooooo00?ofm_Ko`000?oclo<00_ooool00on;Rh_o@d=3ooooo`02ooooo`07ok>c/omSHf?ooooo
oooooooKfm_o0000oo?cl`02ooooo`03oh^;Rom3@d?ooooo00;ooooo00?ofm_KobDU9Onc/k<0:Ooo
ool02_nh^;So_;blolG5aOo<c<coe=CDomcLg?oRh^;ojNWYonk^k_obl_82ooCdm003oo7alOo^k^ko
j>SX00;ok^k^00?ohn?SokVi^Oo^k^h00Oo^k^h000?ooooo00?o^KVion?Shoooool04?ooool03on<
RX[oaM;FokgXm?oDnooo^n;NodE[=olkFSGo=4D`oca>=?m7FSko<DTNocUPG_mk[?;oMk3`oiVT[P06
ooooo`0<oahN7_o@d=3o6ATIojj^[_oooooo:RXZomgMgOlC4a?oalO7on3Ph?l20P;obl_;0_ooool0
5Ol/;2coQ8B4olc<c?lB4Q;onOWioooooomCDe?oV9RHoooooolW9bOo/K6aooclo?lH61SoiNGUoooo
oon7QhOoMWIfooooooono_ko4Q8BokBd]03oooooocWooooo00KoJf][oeeMGOobl_;oe=CDoaLG5oli
>CT3ooooo`03ooKfm_lQ8B7oo_kn00Cooooo00?oRXZ:ode=COooool00_ooool00oo:b/[o0000oocl
o002ooooo`03oiJFU_lb<S;ooooo00;ooooo00Oom_Kfob4Q8Oono_kooooool[:b_l0003oo?cl00;o
oooo00?oUYJFoc8b<_ooool00oooool00ooPh>3o7AdMokVi^@0Xooooo`0:okRh^?nn_[koa/K6olo?
cooFe]KogmoOonGUiOo/k>colO7aooGem@;omoOg00?omOGeoo3`l?oZj^X00_ooool00ooShn?o^KVi
ooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0@ooooo`0?ohb<S?o:d]Goa>W_omkoooo6i>?o
@ehjocUJ;olVAAko7B`HobHe8olP=aKo;55?ohNcm?mo/N_oUJ>_00Kooooo01;o7QhNohn?SolA4A7o
nOWioooooon7QhOoP820oa<C4oo7alOoooooogMgMolN7QkoPX:2odE5AOlX:2SolO7aofe]KOmZJVX2
ooooo`0;okRh^?lc<c?oooooobLW9ona/K7oooooogalO?ll?3coQXJ6oadM7Oo4a<@00_ooool01?m>
CTkoHF5Qoi6ATOnDU9CoooooocKooooo00?on_[joa0@4?o7alL00_ooool00om[Jf_oBTY:ooooo`03
ooooo`03ode=COo:b/[ooooo00?ooooo00?oRXZ:ode=COooool00_ooool00ooTi>Co0000ong]k@02
ooooo`03ohN7Qom<C4cooooo00?ooooo00KoCDe=ol[:b_ooooooi>CTo`000?o]kNd2ooooo`03ohN7
Qom<C4cooooo00Cooooo00?o[Jf]oa@D5?omoOd09oooool03onh^;So_knoolK6a_o@d=3of=SHon7Q
hOoXj>Sok^k^oo?cloogmoOon_[jooShn?ogmoOolo?conc/k002onk^kP03on?Shoni^KWok^k^007o
k^k^0003onKViP03okVi^OoShn?ooooo013ooooo00ooSXf=oloCeOo8iNSoi_ooomS^l?mNGV3oIVUW
oi^UXOmXLfWoCUI4ob0_4?lYADKoS;GaohBaionBXK001_ooool00olN7Qko=3@dofEUI@02ooooo`04
on?SholT92Co4Q8BolO7a`;ooooo00Oo`L71ohb<S?nTY:ComOGeoooooonc/k?ohN7Q00;ooooo00Go
oOgmojBTY?oinOWo/K6aon?Sh`02ooooo`03okJf]_n:RX[ob<S800?ooooo00ComOGeok2`/?n:RX[o
_;bloooooolfooooo`03oogmoOl92@Wob/[:00;ooooo00?o@410ogIfM_ooool00oooool00onJVY[o
OGemooooo`03ooooo`03ohZ:R_m=CDgooooo00;ooooo00?ooOgmoahN7_nk^k/00_ooool00omFEUKo
Ph>3ooooo`03ooooo`06oiZJV_mmOGgooooooogmoOlN7Qko^k^k0_ooool00omFEUKoPh>3ooooo`04
ooooo`03on?Shol0003ohn?S02Oooooo00[o^;Rhokno_oo7alOodM7AomWIfOoRh^;ojNWYono_kooe
mOGonOWi0_ojn_X00oohn?Solo?cong]k@02onKViP03on?Shoni^KWoi^KV007oi^KV0003onk^kP03
okVi^OoShn?ooooo013ooooo00ooSXj>omKGfOoAhN;okOooon_oooo8g]ko/[k2okg5c?nda=Go[L;L
oibW]_mhQYKoQjgSoh^ci?n@XK801_ooool00olN7Qko0000ol71`@03ooooo`03odA4A?l0003oalO7
00kooooo00?oUiNGomWIfOooool0oooooom2ooooo`06ofUYJOmEEEGoi>CToifMWOl>3PkogmoO1?oo
ool02?oUiNGo<C4aoooooooooooogMgMog=cLomHF5SoCDe=1?ooool01_nCTi?o?cloon_[jonm_Kgo
6ATIonWYj@Cooooo00[oiNGUoc4a<Ooooooooooooi>CTolo?coojn_[okfm_OlI6AWojNWY0_ooool0
1OnATI7o_knoonc/k?mbLW;o>SXj02Sooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7a
lOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00_o^k^h00ooShn?o^KVionk^kP01onk^kP000ooo
ool00oni^KWohn?Sooooo`0@ooooo`0?ohj>S_oShnCo^/75ongjo?oco_kon_ooonoooooEk_Go_LSA
ojJc`OnG/mSoU[W[oi>di_n</>3oSj:f00Kooooo00?oJ6QXoemOGoooool00oooool00onf][KoDe=C
omWIf@0>ooooo`03ofi^K_o:b/[ooooo0?oooooo@_ooool01Oohn?SoMgMgobd];Om6ATKoa/K600Ko
oooo00OoKfm_ooGemOoooooom_KfojRXZ?mYJFWoL71`00Gooooo00CoSHf=oc8b<_m:BT[oclo?1_oo
ool02?m_KfoomOGeooooooooooooSHf=oc8b<_m:BT[oclo?0oooool01OnWYjOoFEUIobl_;ombLW;o
f=SH02Sooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?co
nOWiooCdm?o_knl00_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0@
ooooo`0?ohj>S_olo?co^kblok^n`Oo0aLSoaloCol[Kg_o9j>ooaNSnokcEl?nb_<SoVJW1oiFei_n?
[]WoT:>h0?oooooo^oooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[o
no_kooclo?oinOWom?Cdono_k`02onk^kP03on?Shoni^KWok^k^007ok^k^0003onKViP03okVi^OoS
hn?ooooo013ooooo00ooc/k>omgMgOo`l>ooe]KEolg=cOo2`/?obL[;ol_?dOnha<[oY;S<oibge?n=
YlGoU;GToiBcgonCZL40oooooonkooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7o
m_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00;oi^KV00?ohn?SokVi^OoVi^H00OoVi^H000?ok^k^
00?o^KVion?Shoooool03oooool04?ono_koooooohf=SOo/k>colO7aooKfm_okno_oXZ:RoiVHV?o>
c<_ogmgJomSHeoo3bLoo[KO4oh^M/?n=VZWooooook_ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooT
i>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00_o^k^h00ooShn?o^KVionk^kP01
onk^kP000oooool00oni^KWohn?Sooooo`0@ooooo`0?ookno_okno_of=SHoj^[Zon@T93oXJ6QomGE
eOooooooh>3PokBd]?nCTi?oU9BCok^j^?nOWYcono_k0?oooooo^oooool03onh^;So`<30olS8b?oC
dm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`02ooooo`03on?Shoni
^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo013ooooo00?oo_knoogmoOooool00oooool0
2?ojn_[oo?clooooooooooooo_knoooooooEeMGob<S9oooooonlooooo`0?okRh^?o0`<3ob<S8om?C
dooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00;ok^k^00?ohn?SokVi
^Oo^k^h00Oo^k^h000?oi^KV00?o^KVion?Shoooool0oooooooJooooo`0?okRh^?o0`<3ob<S8om?C
dooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWinOodm?Cokno_00;oi^KV00?ohn?SokVi
^OoVi^H00OoVi^H000?ok^k^00?o^KVion?Shoooool0Aoooool00ooOgmoo`<30ooooo`3ooooooi3o
oooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCd
m?o_knl00_o^k^h00ooShn?o^KVionk^kP01onk^kP000oooool00oni^KWohn?Sooooo`0@ooooo`05
oj:RX_mbMgooYjR[omcLg?omoOd00oooool01?omoOgono_kooclo?ono_h[ooooo`03omoOgol:2P[o
jn_[0?oooooo?oooool00omaLG7ohn?Sooooo`0Cooooo`03og5aLOoShn?ooooo03Sooooo00oo^;Rh
ol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00_oo
ool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0@ooooo`08oh9oOOnZbnCo
P[ohogRQcom]P9WoQH^DokNg^?oZj^X4ooooo`03ooclo?okno_oo_kn00oooooo00Col?3`ooclo?oi
nOWokNg]2_ooool01?o]kNgoooooooooooo/k>`8ooooo`03oeADE?n<S8cooooo0?oooooo>?ooool0
0ooWinOol_;booooo`03ooooo`03oh20P?nGUiOooooo00gooooo00?ogMgMoo?cloooool00oooool0
0on0P83oUiNGooooo`05ooooo`03omgMgOoclo?ooooo033ooooo00oo^;Rhol30`?o8b<Sodm?Com_K
fooTi>Cojn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00_o^k^h00ooShn?o^KVionk^
kP01onk^kP000ooVi^H00oni^KWohn?Sooooo`0@ooooo`0<ohV7Q_nQ`]SoP;kfoi??o_nKf?koMjC5
ogRVdom_V<CoL8>Hoi2DV_o4aLGolo?c2Oooool00olN7Qko3@d=oa@D5002oa@D500:olC4a?lW9bOo
/K6aoooooolW9bOoG5aLoa`L7?lC4a?oC4a<ooGem@;ooooo00ko9bLWok6a/OooooooooooooWinOlh
>3So5QHFoc@d=?mfMWKo5aLGolk>c_oooooo9bLWok6a/@Cooooo00?oG5aLobHV9_ooool0oooooolf
ooooo`06om;Bd_lh>3So<S8boc<c<om=CDgohN7Q0_ooool00oo=cLgoBTY:ooooo`03ooooo`06omCD
e?lQ8B7o4Q8Bo`X:2_lQ8B7oWinO0_ooool01Oo_knoo>SXjod10@?lS8b?oSHf=00?ooooo00?ocLg=
odY:B_ooool00oooool01Oo_knoo>SXjod10@?lS8b?oSHf=00?ooooo1Ol000000ooGemOooooooooo
o`0Uooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_oi>CTon_[jooalO7om_Kfoo[jn_okno_oo?clooWi
nOodm?Cokno_00;oi^KV00?ohn?SokVi^OoVi^H00OoVi^H000?ok^k^00?o^KVion?Shoooool04?oo
ool03on9R8Oo[l[Ioi?;nOnNdogoU/K^odMQ@_lhCS7oKD5?og9dUOm`WmWoM:7Hoff;/OmdOhkoWInR
oo7al@06ooooo`03oahN7_nVYZKooooo00?ooooo00Wo9bLWok6a/Ooooooo9bLWog9bL_oemOGol?3`
oc@d=?nUYJD00_ooool02_lW9bOo/K6aoooooooooooo/[:boa/K6ookno_oh>3PobXZ:_n9RHT2oooo
o`03obLW9ona/K7ooooo00;ooooo00Col?3`o`T92OlB4Q;o_knooooooolfooooo`06oeADE?mhN7So
oooooooooomQHF7oEUIF0_ooool00oono_ko8R8RooGem@05ooooo`03ohZ:R_m=CDgooooo00?ooooo
00KoIFEUogAdM?ooooookno_oaXJ6_o<c<`2ooooo`03ookno_lR8R;omOGe00?ooooo00KoIFEUogAd
M?ooooookno_oaXJ6_o<c<`2ooooo`03oda<C?mPH63oo?cl00;oo?cl:?ooool03onh^;So`<30olS8
b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWom?Cdono_k`02onk^kP03on?S
honi^KWok^k^007ok^k^0003ooooo`03okVi^OoShn?ooooo013ooooo00ooRXV7okO>f_nVf?[o]NCo
ojkMn_m`Q57oEehMohL<5omS4Q_o=4f0ocY8LomZW=coOkcnogbmoonTZ[001_ooool00olN7QkoYZJV
ooooo`03ooooo`05obLW9ona/K7oooooobLW9ona/K400_ooool01_moOgooFUYJoooooooooooo9bLW
ok6a/@;ooooo00Kofm_Ko`d=3On`/;3onOWiodA4A?nDU9@2ooooo`03obLW9ona/K7ooooo00;ooooo
00CoUYJFoc0`<?n:RX[oFEUIoooooolfooooo`06obLW9onj^[[ooooooooooommOGgoADE50oooool0
0omVIVKo/;2`ooooo`04ooooo`03ohZ:R_m=CDgooooo00;ooooo00?on?Sho`X:2_oBd]800_ooool2
ofUYJ@?ooooo00OoIVIVok2`/?ooooooooooooShn?l:2P[od];B00;ooooo0_mYJFT2ooooo`03onCT
i?lS8b?o]KFe02[ooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Cojn_[oo7alOofm_Kon_[joo_k
noolo?conOWiooCdm?o_knl00_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?S
ooooo`0@ooooo`0?ohZ:ROnod=So]>7hol?^ooo1j_coHGmNod1H9_n^:cOoT2m1oe9^WOm8DG_oGXBm
ofRNhom]ZnooVjJ`00Kooooo00?o7QhNojJVY_ooool00oooool01OlW9bOo/K6aoooooolW9bOo/K6a
00;ooooo00KoVYZJob`/;?ooooooooooobLW9ona/K43ooooo`05omSHf?nBTY;oHF5QoaHF5_nDU9@0
0_ooool00olW9bOo/K6aooooo`02ooooo`05oc<c<onATI7ojn_[o`d=3Oo[jn/0ooooooleooooo`06
ohN7QomGEeOono_koh^;Rol71`OoZj^[0oooool00onc/k?oHf=Sooooo`04ooooo`03ohZ:R_m=CDgo
oooo00;ooooo00?ofm_Ko`000?oclo<00_ooool00on;Rh_o@d=3ooooo`02ooooo`07ok>c/omSHf?o
oooooooooooKfm_o0000oo?cl`02ooooo`03oh^;Rom3@d?ooooo00;ooooo00?ofm_KobDU9Onc/k<0
:Oooool03onh^;So`<30olS8b?oCdm?ofm_KonCTi?o[jn_olO7aooKfm_ojn_[ono_kooclo?oinOWo
m?Cdono_k`02onk^kP03on?Shoni^KWok^k^007ok^k^0003onKViP03okVi^OoShn?ooooo013ooooo
00ooS8Z:olGBe_nnjOGocoKoom;fo_m]T73o?VLgoj4E;on@6SWo@FJQoe5PT_mZS/GoN:WZogN`lOnI
Y:h01_ooool00olN7QkoYZJVooooo`03ooooo`05obLW9ona/K7oooooobLW9on2PX800_ooool01_mU
IFGoJf][oooooooooooo9bLWofYZJPKooooo00Ko>SXjoijNW_ooooooooooobLW9omZJVX2ooooo`06
om3@d?l61PKok>c/oooooomJFU[oS8b<oooooolfooooo`04ofe]KOlF5QKo0`<3okRh^0Cooooo00?o
m_Kfob4Q8Oono_h01?ooool00on:RX[oCDe=ooooo`02ooooo`03ol[:b_l0003oo?cl00;ooooo00?o
UYJFoc8b<_ooool00_ooool01oofm_Ko8B4Qookno_oooooob/[:o`000?olo?`00_ooool00onFUYKo
<S8booooo`03ooooo`03on3Ph?lM7Ago^KVi02Sooooo00oo^;Rhol30`?o8b<Sodm?Com_KfooTi>Co
jn_[oo7alOofm_Kon_[joo_knoolo?conOWiooCdm?o_knl00_oVi^H00ooShn?o^KVionKViP01onKV
iP000oo^k^h00oni^KWohn?Sooooo`0@ooooo`0?ohb<S?o:d]GoaN_`om[loooHmoooRZAeofN8>onU
6SSoWAU0ocMSZ_lgDIWoIHS2oh>`jomo/NgoUJ>_00Kooooo00?o7QhNojJVY_ooool00oooool02OlW
9bOo/K6aoooooolW9bOoCTi>odY:B_mCDe?o1@D5ol30`002ooooo`0:obLW9om:BT[oAdM7oj6QXOoo
ooooDE5AogEeMOn2PX;o1PH6onKViP;ooooo00Ko9bLWodY:B_m7AdOoXJ6Qofe]KOmDE5@2ooooo`03
ol;2`_lV9RKooooo0?oooooo=?ooool01_oPh>3o6ATIofIVI_nOWiooDU9BooWin@Cooooo00?oCDe=
ol[:b_ooool00oooool00on:RX[oCDe=ooooo`02ooooo`03onCTi?l0003okNg]00;ooooo00?oQhN7
oda<C?ooool00oooool01_m=CDgob/[:oooooooTi>Co0000ong]k@;ooooo00?oQhN7oda<C?ooool0
1?ooool00on][Jgo51@Doogmo@0Wooooo`0?okRh^?o0`<3ob<S8om?CdooKfm_ohn?Son[Zj_o_knoo
m?CdooWinOojn_[oo?clooWinOodm?Cokno_00;ok^k^00?ohn?SokVi^Oo^k^h00Oo^k^h000?ooooo
00?o^KVion?Shoooool04?ooool03on>SHgocm?EolWVjOoSooooh_[ooiVcROmeU4SoZC=1ojh^B_mN
Q;ooCW:foff?aOn9/^WoQK7Yoi:Q/006ooooo`03oahN7_nVYZKooooo00?ooooo00So/K6aon?Shooo
oooo9bLWok6a/Oo3`l?oSHf=olW9b@?ooooo00Wo/K6aon?Shonm_Kgo[Zj^oooooooUiNGo[Jf]oi>C
TooIfMT00oooool01_na/K7ohn?Sokfm_On^[Zko/[:bomWIf@?ooooo00?oYZJVooCdm?ooool0oooo
oolcooooo`06oi:BT_m;Bd_ooooooooooomADE7o[Zj^1?ooool00onJVY[oOGemooooo`03ooooo`03
ohZ:R_m=CDgooooo00;ooooo00?ooOgmoahN7_nk^k/00_ooool00omFEUKoPh>3ooooo`03ooooo`06
oiZJV_mmOGgooooooogmoOlN7Qko^k^k0_ooool00omFEUKoPh>3ooooo`04ooooo`03on?Shol0003o
hn?S02Oooooo00_o^;Rhol30`?o8b<SodM7AomKFe_oLg=cogmoOon?ShooXj>SokNg]oo?cl`02ooOg
m`06ooCdm?o_knoooooooooooooShn?o^KVi0_ooool000?ok^k^00?o^KVion?Shoooool04?ooool0
3on>SXkoe]OIom7Ph_o^oooojOgooi6ZSOmLQdooY2`hokPZCOmfWm;oJi?>og^KcOn=/^SoRK7Soi2Q
/P06ooooo`03oahN7_nVYZKooooo00?ooooo00GoUiNGomWIfOoooooo9bLWok6a/@3ooooooe7ooooo
00KofMWIobd];OoPh>3ogMgMobDU9Onn_[h4ooooo`08onGUiOla<C7ooooooooooooMgMgoLg=coeQH
F?m=CDd4ooooo`06oi>CTolo?coojn_[okfm_OlI6AWojNWY1?ooool02_oUiNGo<C4aoooooooooooo
Ti>Coclo?oo[jn_o_KfmoaTI6OoYjNT2ooooo`05oi6ATOno_kook>c/og9bL_lj>SX0:?ooool03_nh
^;So_knoolG5aOo:b/[oalO7ol71`Onj^[[o][JfokZj^_o6a/Koe=CDonGUiOo_knoolO7a0oo^k^h0
0ooShn?o^KVionk^kP01onk^kP000ooVi^H00oni^KWohn?Sooooo`0@ooooo`0?ohj>S_oShnCo^/75
ongjo?obooooeM_AokRaUOnaLg;o_5a^oh:<[om]R;_oNYK7oiBfjOn</=ooSj:f00Kooooo00?oJ6QX
ol?3`oooool00oooool01Om^KVkob/[:oooooolW9bOo/K6a0?ooooooD_ooool01?nXZ:SoC4a<oc/k
>on=SHd6ooooo`07ofm_KooemOGoooooooKfm_nXZ:SoJFUYog1`L005ooooo`04ohf=SOlb<S;oBTY:
olo?c`Kooooo00SoKfm_ooGemOooooooooooohf=SOlb<S;oBTY:olo?c`?ooooo00GoYjNWoeUIFOl_
;booLW9bomSHf00Xooooo`0?okRh^?nm_Kgo_Kfmoj:V]OmJL:So9UBZo`YA^?lAF[Wo;VB[oe=dWOn9
TI_o^KViomOGeooWinOok>c/00;oi^KV00?ohn?SokVi^OoVi^H00OoVi^H000?ok^k^00?o^KVion?S
hoooool04?ooool03on>SXkoo?clok^l_?nk_/7o`<G8ol_DfOo9f=goa>;TokcFh?ni_LcoYjVgoiNV
a?nG^>_oSjkHoi2S^00?ooooo`03olW9bOo/k>cooooo0?ooooooZOooool03onf][Ko^;RhohJ=Zol]
CjGo042ho`9?_Ol?G<?o7V[8obYcc?lcNloo@72YofimSon/[:codm?ConGUi@02onk^kP03on?Shoni
^KWok^k^007ok^k^0003ooooo`03okVi^OoShn?ooooo013ooooo00ooc/k>omgMgOo`l>ooe]KEolg=
cOo2`L7ob/_<olc@e?nia]3oXk[@oiRdd_nC/mWoUkOWoi>cg_nCZL40oooooonkooooo`0?okBd]?nK
WZko;DfUo`0n^?l1DL3o3eo6ob1_cOl_N]3o?8;DodF9e_m<S][oCGR/ogInQ_nc/k?ofMWI00;ooooo
00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool03oooool04?ono_koooooohf=
SOo/k>colO7aooKfm_okno_oXZ:RoiVHUoo>bl[oh=cJomWHf?o2alco[KO4oh^M/?n=VZWooooook_o
oooo00oo/[:boe]/Y_l0=k;o0dfmoa1Oa_lOK<[o;WW?od26eOm=T=_oEYSQoenOi_mRX>KoEg:?oi>C
Too:b/X00_o^k^h00ooShn?o^KVionk^kP01onk^kP000ooVi^H00oni^KWohn?Sooooo`0@ooooo`0?
ookno_okno_of=SHoj^[Zon@T93oXJ6QomGEeOooooooh>3PokBd]?nCTi?oUIBDok^j^?nOWYcono_k
0?oooooo^oooool03on^[Zko:TVVo`]8^om=S=KoGi[Kodb>f_leOmGoAh_JoeBHiOmRYNkoK:kfog:c
nomORkcoNGUiokbl_002onKViP03on?Shoni^KWoi^KV007oi^KV0003onk^kP03okVi^OoShn?ooooo
013ooooo00?oo_knoogmoOooool00oooool02?ojn_[oo?clooooooooooooo_knoooooooEeMGob<S9
oooooonlooooo`0?ojf][Ol<>:coA7W>ohVeiOn3/^CoNjcToc^2fOm=Tn?oG9o/ofb]n?mg^oooPLCo
og2/kOmYJFWo/k>c00;ok^k^00?ohn?SokVi^Oo^k^h00Oo^k^h000?ooooo00?o^KVion?Shoooool0
oooooooJooooo`0?oj^[Zol0=;7oK9OJohfii_n9]NGoOjoUocj4f_mBV>[oHZKcogBfoon0a?ooRM3o
oh;7oomPH63o[Zj^00;ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0
oooooooJooooo`0?oj^[Zol0=K;oM9kLoi2ii_n9]NKoP;7Vod6:gomEVn[oIjchogNkoon4b_ooS]Ko
ohS>oomLG5co[:b/00;ok^k^00?ohn?SokVi^Oo^k^h00Oo^k^h000?oi^KV00?o^KVion?Shoooool0
4?ooool01OnRXZ;oLWMoojNXZooLg=cooOgm00?ooooo00CooOgmoo_knoolo?coo_knoooooom]oooo
o`03og5aLOoShn?ooooo01?ooooo00?oLG5aon?Shoooool0>?ooool03on[Zj_o03NbogFNg?n>^NKo
RKGVoh2ai_m2Rn3oEYk_ofV^nomj_oooR<oooi;Koon9coooG5aLoj^[Z`02onKViP03on?Shoni^KWo
i^KV007oi^KV0003onk^kP03okVi^OoShn?ooooo013ooooo00SoPWmmoj[;i?n2_oSoN:7?off0VOn3
R97o][Nhon[ZjPCooooo00?oo?cloo_knoono_h04Oooool00ooWinOon_[jooooo`04ooooo`03onSX
j?ojn_[ooooo00;ooooo00?omOGeooWinOooool04?ooool00oo[jn_om_Kfooooo`0:ooooo`06oo[j
n_o/k>coooooooooooo/k>coo?cloooooolOooooo`03ookno_oQhN7ogMgM00Gooooo00?oP820oiNG
Uoooool04oooool00on0P83oUiNGooooo`05ooooo`03omgMgOoclo?ooooo033ooooo00ooZj^[o`0i
/omiWmcoSKSVohRdi_mo[nOo@H_PoeBJjomX[_koMkcoohO=oonAfOooRM3ooeaLG?n[Zj/00_o^k^h0
0ooShn?o^KVionk^kP01onk^kP000oooool00oni^KWohn?Sooooo`0@ooooo`0<ohV7Q_nQ`]SoP;kf
oi?>oOnLg?ooTL;Uoi^ac_mcRJWoJGF7ohb@UOo4a<Golo?c2Oooool01_lN7Qko3@d=oa@D5?lG5aOo
?ShnokFe]@?ooooo00Go`<30oa`L7?lU9BGo2PX:ogUiN@02ooooo`0?olc<c?lT92Co3`l?oa/K6on2
PX;ooooooj:RX_l@413o61PHoi:BT_lR8R;o][JfoooooolW9bOo/K6a00;ooooo00co3Ph>olS8b?oo
oooomOGeo`000?oQhN7oooooom3@d?l/;2co5ADEobd];Om<C4`2ooooo`0?obLW9ona/K7ooooooooo
oold=3CoY:BToooooonf][Ko6ATIocXj>_o_knoo71`LobXZ:_l[:b_oRXZ:0?oooooo7_ooool01OmU
IFGo<c<codI6A_lX:2Sobl_;00?ooooo00?ocLg=odY:B_ooool00oooool01_oDe=Co8B4Qoa8B4_l:
2P[o8B4QoinOW`;ooooo1Ol000001OoGemOoooooooooooo=cLgoBTY:00Cooooo00Gokno_ocXj>_m0
@43o8b<Sohf=S@03ooooo`Go000000?oemOGooooooooool09Oooool03on[Zj_o03VcogNKf_n<]^Go
Pk?Uog^]iOlkQn3oCYO[of2XnOma^oooOlSoohWEoon0b?ooG5aLoj^[Z`02ooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo013ooooo00ooRHR7ojo:fOnCc?[oWM3ioicCo?nC
^KOom_KXoocnoooRjoGo`=3Voh^Xcom[R;3oMGn>oifOX_oalO401_ooool07olN7QkoYZJVoooooooi
nOWo^;RhoaPH6?nHV9Sooooooo?clolG5aOoTI6AoooooooRh^;o51@Doj^[ZoogmoOo820Pof5QHOob
l_;oo_knonk^k_oooooo<C4aoiVIVOohn?SoL71`o`@41?nf][KoooooobLW9ona/K400_ooool03?l>
3Pkob<S8oooooooemOGo0000on7QhOogmoOo8R8RogalO?okno_oooooooOgm`;ooooo013o9bLWok6a
/Ooooooooooooc@d=?nTY:Coooooode=COn2PX;ooooooo[jn_oQhN7oooooonSXj?l820Sok>c/oooo
oolPooooo`03olK6a_l?3`ookno_00;ooooo00?oo_knob8R8_oemOD01Oooool00on:RX[oCDe=oooo
o`03ooooo`03oda<C?mPH63oo?cl00;oo?cl0oooool00oono_ko8R8RooGem@03ooooo`06ofEUIOmd
M7Coooooono_kolJ6Q[oc<c<0_ooool00om<C4coH61Pooclo002ooclo2Sooooo00ooZj^[o`0i/omi
W]coR[KUohRei_ml[^Ko?h[Poe>Kk_mT[?goM;cooh;8oon=f?ooQ/cooeaLG?n[Zj/00_o^k^h00ooS
hn?o^KVionk^kP01onk^kP000ooVi^H00oni^KWohn?Sooooo`0@ooooo`0?ohZ9Qongc][oY]Wjok?R
oOngjoooXLO0onW[hOojnOcon?Oeoo_knooKh]SoL:[Pogjjo_mm__ooY:Z`00Kooooo00?o7QhNojJV
Y_ooool00_ooool01_n3Ph?o410@oo;bl_o0`<3o0P82onk^kP;ooooo00GoDe=Cof5QHOo3`l?o0000
omGEe@04ooooo`09oaDE5Oo2`/;oooooookno_lL71co][JfoooooolW9bOo/K6a00;ooooo00Wo3Ph>
olS8b?oooooomOGeo`000?oQhN7oa<C4o`T92Oo_knl01Oooool02OlW9bOo/K6aoooooooooooo=3@d
ojBTY?oooooo<c<cojFUY@03ooooo`04onCTi?mRHV;o5aLGoo_knooooooo8Oooool00olU9BGoR8R8
ooooo`02ooooo`03ofIVI_n`/;3ooooo00Cooooo00?oRXZ:ode=COooool00oooool00ooTi>Co8b<S
okFe]@06ooooo`07ofIVI_n`/;3oooooooooooohn?So2PX:om;BdP02ooooo`;oJFUY0_ooool00ooT
i>Co8b<SokFe]@0Zooooo`0?oj^[Zol0>K?oMYkLoi2ii_n8]>KoP;7Vod::gomEVn_oJJgkogZooon7
c?ooTm[oohW=oomLG5coZj^[00;oi^KV00?ohn?SokVi^OoVi^H00OoVi^H000?ok^k^00?o^KVion?S
hoooool04?ooool03on:RXWo_m3HokCRn?o2k?goaoGoojK:`?oSiM[om_Khoo3al?ogm_Wof]oCof^M
aomVVn?oKZc_oi^V/006ooooo`03oahN7_nVYZKooooo00;ooooo00KocLg=o`000?o6a/Ko/k>co`/;
2oolo?`2ooooo`05ofUYJOmDE5Co/k>co`820_o_knl01?ooool02OlE5AGo`l?3oooooooooooo8R8R
okJf]_oooooo9bLWok6a/@02ooooo`08o`h>3_o8b<SoooooooGemOl0003ohN7Qol71`Ol30`<2ob4Q
8@06oaHF5_le=CGooooooooooolW9bOo/K6a0_ooool01Old=3CoY:BToooooolc<c?oYJFU00;ooooo
00CoWYjNo``<3?mCDe?oh^;RoooooolNooooo`06onOWiom?Cdoo8B4QoeEEEOmADE7oEEEE0oooool0
0onc/k?oHf=Sooooo`04ooooo`03ohZ:R_m=CDgooooo00Cooooo00?ofm_KobDU9Onc/k<01Oooool0
1onc/k?oHf=Soooooooooooofm_Ko`000?oclo<00_ooool00on;Rh_o@d=3ooooo`02ooooo`03om_K
folU9BGo/k>c02Wooooo00ooZj^[o`0i/omfX=coTK_Wohfiion2/nWoAhkQoe^Pk_m]/oooOL3ooh_@
oonGgoooT=?ooeaLG?n[Zj/00_o^k^h00ooShn?o^KVionk^kP01onk^kP000oooool00oni^KWohn?S
ooooo`0@ooooo`0?ohb:R_o5d]Ko_^Weolkeo_oHoooo/=72om_Ndoobl_CokNg]oo?bmOoGg=3oMZC;
ogNWk?mh/O7oVJB^00Kooooo00?o7QhNojJVY_ooool00_ooool01_ojn_[o0`<3ojRXZ?oPh>3o0P82
ol_;b`;ooooo00Go;2`/ohB4Q?oOgmoo0P82ojFUY@04ooooo`0GoaDE5Oo3`l?ooooooooooolR8R;o
][JfoooooolW9bOoJf][ooooooolo?co1`L7oh:2P_oooooojn_[o`000?oWinOoo?cloaPH6?oUiNGo
ooooohN7QomfMWH00_ooool03OlW9bOoEeMGoogmoOoooooo8b<Sojb/[?oooooo<c<cojFUYOoooooo
o_knoa8B4_nd];@0oooooolPooooo`06of][JomMGEgol_;bomCDe?lG5aOo>CTi0oooool00oofm_Ko
8B4QooknoP04ooooo`03ohZ:R_m=CDgooooo00Gooooo00?oh>3PoadM7Oni^KT01?ooool01oofm_Ko
8B4Qookno_oooooob/[:o`000?olo?`00_ooool00onFUYKo<S8booooo`03ooooo`03on3Ph?lM7Ago
^KVi02Sooooo00ooZj^[o`0i/omeX]coU;cWohjji_n9]^OoBY3QoejRk_ma]?ooP<;oohkCoonHgooo
TmKooeaLG?n[Zj/00_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0@
ooooo`0?ohb<S?o:d]GoaN_aomWkoooQoooo]=74oloCaoo[j^goiNKUonk]l?oCf<coO:G7oh2]kOmo
/^goUJ>_00Kooooo00?o7QhNojJVY_ooool00_ooool04onm_Kgo0000ol;2`_ooooooMgMgoahN7_n2
PX;oADE5obPX:?oalO7oooooogQhN?l:2P[oK6a/oh>3Pon`/;3ooooooaDE5Oo3`l<00_ooool02OlR
8R;o][JfoooooolW9bOoDe=CodU9BOmNGUko5ADEogQhN002oe5AD@08ob/[:oooooooooooogalO?ll
?3coQXJ6oadM7Oo4a<@2ooooo`0?obLW9omGEeOo>SXjof9RH_l820Sol?3`ok>c/olI6AWoDE5Aogmo
OoomoOgoCTi>of5QHOnATI7oU9BD0?oooooo7Oooool00oojn_[o410@olO7a`02ooooo`03of][Jom:
BT[ooooo00?ooooo00?oCDe=ol[:b_ooool00oooool00on:RX[oCDe=ooooo`06ooooo`03ojf][OlD
51CooOgm00Cooooo00KoCDe=ol[:b_ooooooi>CTo`000?o]kNd2ooooo`03ohN7Qom<C4cooooo00Co
oooo00?o[Jf]oa@D5?omoOd09oooool03on[Zj_o03VcogJSgonF_NWoTK_YohVhj_m>U>GoH:C_og:d
oon4aoooTmKooigQoonCeOooG5aLoj^[Z`02onk^kP03on?Shoni^KWok^k^007ok^k^0003onKViP03
okVi^OoShn?ooooo013ooooo00ooSXf=oloCeOo9i^Woh_koon[ooonkeLSoal[2onCRiooNgmkoc/c@
okBh[?n3ZLKoQjo]ohFbj?nBXK001_ooool00olN7QkoYZJVooooo`02ooooo`03ofUYJOlG5aOom?Cd
00;ooooo00Co`L71ohb<S?nTY:ComOGe0oooool01oo5aLGoSHf=oi>CTooEeMGoooooojZZZ_oYjNT0
0_ooool03?n_[jooiNGUoooooona/K7ohn?Sol[:b_nATI7ofMWIoooooonm_KgoUYJFonSXj0?ooooo
00?o][JfohZ:R_o8b<P00oooool03ona/K7ohn?Solo?conCTi?og]kNooooooo8b<So820PofUYJOnR
XZ;oo_knooGemOn`/;3oRXZ:okbl_03ooooooagooooo00?ooOgmo`T92Oo:b/X00_ooool00om0@43o
MWIfooooo`03ooooo`03oiZJV_mmOGgooooo00?ooooo00?oRXZ:ode=COooool01_ooool00ooShn?o
0000on?Sh`04ooooo`06oiZJV_mmOGgooooooogmoOlN7Qko^k^k0_ooool00omFEUKoPh>3ooooo`04
ooooo`03on?Shol0003ohn?S02Oooooo00ooZj^[o`0i/omjYmooU[gWoi6jion:^>[oD9?SofBVl?mf
]_ooQlOooiCFoonRi_ooV]WooeaLG?n[Zj/00_oVi^H00ooShn?o^KVionKViP01onKViP000oo^k^h0
0oni^KWohn?Sooooo`0@ooooo`0?ohj>S_oFemWodN7Songoooo^oooo_mK:ojblW?o?dlgoe]GGojRY
ZOmjSF?oQj_4ohjck_n9/N;oT:6b00Kooooo00Oo7QhNogemOOnk^k_oXZ:RoeiNG_l=3@go/;2`02oo
oooo00?oSXj>olS8b?ooool0oooooolSooooo`06ofUYJOmEEEGoi>CToifMWOl>3PkogmoO1?ooool0
2?oUiNGo<C4aoooooooooooogMgMog=cLomHF5SoCDe=1?ooool01OnATI7o_knoonc/k?mbLW;o>SXj
00Gooooo00[oiNGUoc4a<Ooooooooooooi>CTolo?coojn_[okfm_OlI6AWojNWY0_ooool01OnATI7o
_knoonc/k?mbLW;o>SXj02Sooooo00ooZj^[o`0i/omjZ^3oUKgYoiBmj_n;^N[oDiOUofRZlomj^_oo
Rlcooi[JoonSioooV][ooeaLG?n[Zj/00_o^k^h00ooShn?o^KVionk^kP01onk^kP000oooool00oni
^KWohn?Sooooo`0@ooooo`0?ohj>S_oShnCo^/75oncinoohoooofNWQoiJiNOnC]G?oTZefohnNN_nQ
/;SoTKCRoi>ej?n</=ooSj:f00Kooooo00KoJ6QXoe=CDomCDe?oIFEUohR8R?oLg=cooooooeKooooo
00Gon?ShogMgMol];BgoATI6olK6aP06ooooo`07ofm_KooemOGoooooooKfm_nXZ:SoJFUYog1`L004
ooooo`05ojNWYomIFEWo;bl_og9bL_oHf=P01_ooool02?m_KfoomOGeooooooooooooSHf=oc8b<_m:
BT[oclo?0oooool01OnWYjOoFEUIobl_;ombLW;of=SH02Sooooo00ooZj^[o`0i/omeYn3oU[oYoiFm
jOn>^n_oEi_Wofb[loml^oooSLcooi_JoonWjoooWn3ooeaLG?n[Zj/00_ooool00ooShn?o^KVioooo
o`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0@ooooo`0?ohj>S_olo?co^kblok^n`Oo0aLSoaloC
okg>c_n]bL3oVKbToijj^OnbdOooWl3_oiRgi_n?[]WoT:>h0?oooooo^oooool03on[Zj_o03VcogJW
h?nH`>WoU[oZohfjjomDUnKoIjS`ogVioon;cOooV=Wooj?WoonKfoooG5aLoj^[Z`02onk^kP03on?S
honi^KWok^k^007ok^k^0003onKViP03okVi^OoShn?ooooo013ooooo00ooc/k>omgMgOo`l>ooe]KE
olg=cOo3`l?ocLg?om3Df_nkamCoYkW?oiVdd?nD]=_oUkOWoi>cg_nCZL40oooooonkooooo`0?oj^[
Zol0>K?oMZGNoiNojOnC_>[oRkSZoe2ChomSYNooMKGnohS8oonFfOooX^Cooi[JoomLG5coZj^[00;o
i^KV00?ohn?SokVi^OoVi^H00OoVi^H000?ok^k^00?o^KVion?Shoooool03oooool04?ono_kooooo
ohf=SOo/k>colO7aooKfm_okno_oXZ:RoiRGU_o>blWogmcJomSHf?o2al_o[KO4oh^M/?n=VZWooooo
ok_ooooo00ooZj^[o`0i/omgY=ooUKcWoi6kj_n8]^[oCI;Sof6Ul?mc]?ooQ<Oooi7DoonNhoooUMSo
oeaLG?n[Zj/00_o^k^h00ooShn?o^KVionk^kP01onk^kP000oooool00oni^KWohn?Sooooo`0@oooo
o`0?ookno_okno_of=SHoj^[Zon@T93oXJ6QomGEeOooooooh>3PokBd]?nCTi?oUIBDok^j^?nOWYco
no_k0?oooooo^oooool03on[Zj_o03VcogNSg_nB^nKoS[[WohBdjOm:TN?oGZ;^ofnboOn1a?ooT=Co
oi[PoonCeOooG5aLoj^[Z`02ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?o
oooo013ooooo00?oo_knoogmoOooool00oooool02?ojn_[oo?clooooooooooooo_knoooooooEeMGo
b<S9oooooonlooooo`0?oj^[Zol0>K?oMj;Noi6kion<^NOoP[?WodNAi?mKX^ooKK;nogg1oon:cooo
Umoooi3DoomLG5coZj^[00;ok^k^00?ohn?SokVi^Oo^k^h00Oo^k^h000?oi^KV00?o^KVion?Shooo
ool0oooooooJooooo`0?oj^[Zol0>K?oMYkLoi2ii_n:]NKoP[?Wod:;gomHWNcoJZkmog^moon8cOoo
Tm[oohgBoomLG5coZZZZ00;oi^KV00?ohn?SokVi^OoVi^H00OoVi^H000?ok^k^00?o^KVion?Shooo
ool0COooool00onl_;coinOWooooo`3ooooooh[ooooo00ooZj^[o`0UZ?meWM_oSKSUohVei_n1/NOo
@H[PoeFKk?mW[?_oMkcoohK<oon>e_ooQlgooeaLG?nYZJT00_o^k^h00ooShn?o^KVionk^kP01onk^
kP000oooool00oni^KWohn?Sooooo`0?ooooo`03oo[jn_oclo?okno_00cokno_00?om?Cdoooooooo
ool0;?ooool00olW9bOo/K6aooooo`3oooooocWooooo00?oLG5aon?Shoooool04oooool00omaLG7o
hn?Sooooo`0hooooo`0?oj^[Zol0::_oMIkLoi2jion8]NKoPK?Wod:;h?mFWNkoJJkkogVloon7c_oo
TM[oohO=oomKFe_oYjNW00;ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shooo
ool03oooool04?o3`l?oR8Z@og5fPOmaMh7oLGN2og9gP_mbN8;oLgV2og=iPomdNX?oMGZ3ogIkQ?mh
OXGoNGn6ogZ0Q_nCUYTAooooo`03on_[joofm_Kooooo00?ooooo00?ok>c/ooclo?ooool02_ooool0
0oojn_[ok>c/ooooo`02ooooo`03onOWioojn_[ooooo00;ooooo00Co9bLWok6a/OoinOWokNg]oooo
ool`ooooo`03ookno_oQhN7ogMgM00Gooooo00?oP820oiNGUoooool04oooool00on0P83oUiNGoooo
o`05ooooo`03omgMgOoclo?ooooo033ooooo00ooZj^[o`0YZomeW]coT;WVohVei_n0/nOo@X_QoeFK
jomX[O_oMk_oohS>oon<eOooPlOooeYJF_nWYjL00_o^k^h00ooShn?o^KVionk^kP01onk^kP000ooV
i^H00oni^KWohn?Sooooo`0?ooooo`0@ohN:SoliCh7o7TFDobM@V_lSC9So9e6Koc=KX_lfGjCo>V:V
oceVZ?m0J:SoCGF_oe^3]OmRRKOoHhbmoeU`SPKooooo00Ko7QhNo`d=3OlD51Co5aLGochn?_ne]KD3
ooooo`0;om3@d?l/;2co5ADEobd];Om<C4coooooono_kolL71co:RXZob/[:on:RXX00_ooool04?lW
9bOo/K6aooooooo;bl_o3`l?oj^[Zooooooo][JfoaTI6Olj>S[ooooool30`?lL71co9BDUo`X:2_mi
NGT2ooooo`06obLW9om@D53o71`Loa<C4om<C4comOGeooooool^ooooo`05ofEUIOlc<c?oATI6obPX
:?o;bl/00oooool00oo=cLgoBTY:ooooo`03ooooo`06omCDe?lQ8B7o4Q8Bo`X:2_lQ8B7oWinO0_oo
ool5o`000005omOGeoooooooooooolg=cOm:BTX01?ooool01Oo_knoo>SXjod10@?lS8b?oSHf=00?o
oooo1Ol000000ooGemOoooooooooo`0Uooooo`0?ojRXZ?l0:JgoJ9CIohbhi_n8]NKoOJoWod28h?mC
V^coIJ_kogFioon2b?ooR<kooh32oomKFe_oYJFU00;oi^KV00?ohn?SokVi^OoVi^H00OoVi^H000?o
k^k^00?o^KVion?Shoooool03oooool04?n2Q8[oFF^>oj6]`OlkGI[oQINgognB]?l[E9go=EfSocEM
X_lgGZ?o@V^Xoe9k/?mHPK;oGhJcoeN2]om@JH/6ooooo`0KoahN7_nVYZKoooooooWinOnh^;So61PH
oiRHV?oooooomoOgob8R8_mlO7cono_kooooooogmoOooooooo[jn_oQhN7oooooonSXj?l820Sok>c/
oooooolW9bOo/K6aomSHf?lE5AGoUiNG00;ooooo017oCDe=oh:2P_oooooolo?coaLG5onATI7ooooo
on;Rh_lD51CoZj^[oooooolW9bOoLW9booGemOo`l?3o=3@dojFUY@3ooooooc7ooooo00?oa/K6o`l?
3oo_knl00_ooool00oono_ko8R8RooGem@05ooooo`03ohZ:R_m=CDgooooo00?ooooo00?oC4a<of1P
H?olo?`00_olo?`3ooooo`03ookno_lR8R;omOGe00?ooooo00KoIFEUogAdM?ooooookno_oaXJ6_o<
c<`2ooooo`03oda<C?mPH63oo?cl00;oo?cl:?ooool03onYZJWo2bnXocmdcOn2/N?oQ;?Uog>Xi?ll
Q]ooCiKWof2UmOma]OooNl7ooh33oom`Z^goHF5QojFUY@02onk^kP03on?Shoni^KWok^k^007ok^k^
0003ooooo`03okVi^OoShn?ooooo00oooooo013oPhB:ogB2WOohm>coAFBOom?Hh?n_^LSo9U>Moc5L
X_l`Fj;o@FbZoeAn/_mGP[CoGHJfofF;^?mDOkOoE6b?1_ooool00olN7QkoYZJVooooo`02ooooo`06
oh>3Pol@413ol_;bolC4a?l92@Wokno_1_ooool02OoTi>CoHV9RoaLG5ookno_oooooobLW9onDU9Co
7QhNoh:2PP03ooooo`06oc<c<onUYJGooooool30`?l20P;ok^k^0_ooool01OmCDe?oHF5QoooooolW
9bOo/K6a00;ooooo00?oOgmooeYJF_ooool0oooooolaooooo`03obDU9On8R8Sooooo00;ooooo00?o
IVIVok2`/?ooool01?ooool00on:RX[oCDe=ooooo`03ooooo`03onCTi?lS8b?o]KFe00Kooooo00Oo
IVIVok2`/?ooooooooooooShn?l:2P[od];B00;ooooo0_mYJFT2ooooo`03onCTi?lS8b?o]KFe02[o
oooo00ooZj^[obQ5Y?l7@kWo@XCDoeJDfOm1R=Wo=X;JodZBi?mHW^ooIj[eog2eoomc]OooG8Rjof][
JonZZZX00_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0?ooooo`0@
ohB7RomPLYCoLXJZodEZYom^Qj_oEgNUobmNY?lhHZGoAW2/oeN0]?mJQ;GoFXBfoen7]omIPK7oB7>^
oe=/S`Kooooo00?o7QhNojJVY_ooool00_ooool01Oo=cLgo0000olK6a_o1`L7o0`<300;o8B4Q00So
5QHFocDe=OoooooooooooijNW_l<30coDe=Con;RhP;ooooo00Co9bLWod92@_lN7QkonOWi0oooool0
1_lc<c?oYJFUoooooonc/k?o2`/;ooclo0;ooooo00GoJFUYoeADE?oooooo9bLWok6a/@02ooooo`03
oiZJV_l/;2cooooo0?oooooo;Oooool01_oWinOoCdm?ob4Q8OmEEEGoDE5AoeEEE@?ooooo00?o/k>c
of=SHoooool01?ooool00on:RX[oCDe=ooooo`04ooooo`03om_KfolU9BGo/k>c00Gooooo00Oo/k>c
of=SHoooooooooooom_Kfol0003olo?c00;ooooo00?oRh^;od=3@oooool00_ooool00ooKfm_o9BDU
ok>c/`0Yooooo`0?ok>c/omCI9ko03Rbo`5<_?l?GlKo7Vc<obmkdom1RM_oCiCSoeVNj_mQXn_oHZ3V
oe1[R?meMGGo_;bl00;ok^k^00?ohn?SokVi^Oo^k^h00Oo^k^h000?oi^KV00?o^KVion?Shoooool0
3oooool04?n4QX_oNXNPooC`k?mPOjcoe=cRojjebOlGA9KoBG:]oeJ0/omIPkGoFXBfoe^6]omCO;3o
SJg5ohRiiom;IHd6ooooo`03oahN7_nVYZKooooo00;ooooo00gon_[jo`<30onXZ:Soo?cloaPH6?oU
iNGoooooohN7QomfMWKoooooookno_lB4Q;o];Bd00Cooooo00Co9bLWok2`/?mQHF7oGUiN0oooool0
1_lc<c?oYJFUoooooooPh>3o0P82ol_;b`;ooooo00Go;2`/ohB4Q?oooooo9bLWoh:2PP02ooooo`03
ofEUIOm[Jf_ooooo0?oooooo;Oooool01_m[Jf_oGEeMoo;bl_oDe=Co5aLGocTi>@?ooooo00?om_Kf
ob4Q8Oono_h01?ooool00on:RX[oCDe=ooooo`05ooooo`03on3Ph?lM7Ago^KVi00Cooooo00Oom_Kf
ob4Q8Oono_kooooool[:b_l0003oo?cl00;ooooo00?oUYJFoc8b<_ooool00oooool00ooPh>3o7AdM
okVi^@0Xooooo`0?okVi^On6RIWo9TJNo`0n^?l1DL3o3f37ob1_cOl_Nm;o?HCHodN;f_m<S][oB7>W
oe]SJon@T93oemOG00;oi^KV00?ohn?SokVi^OoVi^H00OoVi^H000?ok^k^00?o^KVion?Shoooool0
3oooool02On5QhcoMHFMojjhaol`EY[oRiNgoea_X_l[F:;oG8BeoeV2]@02oeZ4]P05oef6]om=N;3o
RinkojBoh?m?JI401_ooool00olN7QkoYZJVooooo`02ooooo`09okfm_Ol0003o`/;2oooooomlO7co
?3`lohJ6Q_lM7Agoa<C400;ooooo00CoCTi>of5QHOnATI7oU9BD0_ooool06?lW9bOo/K6aoo[jn_m5
ADGoP820oooooonc/k?o6ATIoe5ADOmoOgoooOgmogMgMolN7QkoPX:2odE5AOlX:2SolO7aoooooolW
9bOoCTi>odY:B_mCDe?o1@D5ol30`?oooooo;Oooool00oojn_[o410@olO7a`02ooooo`03of][Jom:
BT[ooooo00?ooooo00?oCDe=ol[:b_ooool00oooool00on:RX[oCDe=ooooo`06ooooo`03ojf][OlD
51CooOgm00Cooooo00KoCDe=ol[:b_ooooooi>CTo`000?o]kNd2ooooo`03ohN7Qom<C4cooooo00Co
oooo00?o[Jf]oa@D5?omoOd09oooool03oni^KWo]kNgof]bT?lSAI_o042ho`9?_Ol?GLCo7V_9obYc
cOlcNloo>FVRoe1OLOmjNW[oaLG5onGUi@02onk^kP03on?Shoni^KWok^k^007ok^k^0003ooooo`03
okVi^OoShn?ooooo00oooooo013oQXR<og60W?nCY<3o:DFAogJ2[_m_Q[;o9eJOoe=l/OmKQ;KoFXBe
oeV3]OmKQ;KoAVn[odM_Yom5M;?oAej71_ooool00olN7QkoYZJVooooo`02ooooo`03ofUYJOlG5aOo
m?Cd00;ooooo00?o][JfohZ:R_o8b<P00oooool01?oemOGo/;2`ohZ:R_nl_;`2ooooo`0@obLW9ona
/K7ooooooo7alOnSXj?omoOgolS8b?lP823oJFUYoj:RX_ono_kooooool71`On<S8coY:BTooGem@;o
oooo00Go/K6aon?Shoo3`l?oSHf=olW9b@3oooooobkooooo00?ooOgmo`T92Oo:b/X00_ooool00om0
@43oMWIfooooo`03ooooo`03oiZJV_mmOGgooooo00?ooooo00?oRXZ:ode=COooool01_ooool00ooS
hn?o0000on?Sh`04ooooo`06oiZJV_mmOGgooooooogmoOlN7Qko^k^k0_ooool00omFEUKoPh>3oooo
o`04ooooo`03on?Shol0003ohn?S02Oooooo00oo^[Zjolk>c_nj^[[oMWZ9oceCRolKBIoo1djgo`iG
]olUFj;o>U^4oeALI_moOgoo`l?3ong]kOo/k>`00_ooool00ooShn?o^KViooooo`01ooooo`000oo^
k^h00oni^KWohn?Sooooo`0?ooooo`0:ohJ8S?n7U:Goo?__oc9<T?oAe]go^L7:oc9NX_m5Kj_oCgR_
oeN0/`;oFH6d00Co;EROoinca_njhO_oCFNA1_ooool01olN7QkoOGemok^k^onRXZ;oGUiNo`d=3On`
/;003oooool00olW9bOo/K6aooooo`04ooooo`03ohj>S_o8b<Sooooo0?oooooo??ooool01_mYJFWo
EEEEonCTi?nMWIgo3Ph>omoOg`Cooooo00SoiNGUoc4a<OooooooooooomgMgOmcLg?oF5QHode=C@Co
oooo00GoTI6Aokno_oo/k>coLW9bocXj>P05ooooo`0:onGUiOla<C7ooooooooooonCTi?o?cloon_[
jonm_Kgo6ATIonWYj@;ooooo00GoTI6Aokno_oo/k>coLW9bocXj>P0Xooooo`0>okbl_?oBd];ojn_[
olW9bOnIVIWoPh>3og=cLomWIfOoKfm_oh:2P_nVYZKogMgMooCdm?ogmoL3onk^kP03on?Shoni^KWo
k^k^007ok^k^0003onKViP03okVi^OoShn?ooooo00oooooo00SoQhV<og>3WOmaR[Go74NEodIYYOm0
IZGo@6^]odag/@;oBGB`00KoCGNbod=^[OlYEj?oDg>Zof:3]om9Hh`6ooooo`06ofQXJ?mCDe?oDe=C
ofEUIOn8R8Sog=cL4?ooool00olW9bOo/K6aooooo`3ooooood?ooooo00Gon?ShogMgMol];BgoATI6
olK6aP06ooooo`07ofm_KooemOGoooooooKfm_nXZ:SoJFUYog1`L004ooooo`05ojNWYomIFEWo;bl_
og9bL_oHf=P01_ooool02?m_KfoomOGeooooooooooooSHf=oc8b<_m:BT[oclo?0oooool01OnWYjOo
FEUIobl_;ombLW;of=SH02Sooooo00oo^[Zjom7AdOobl_;ol?3`omWIfOo<c<cocLg=omCDe?oJf][o
h>3Pong]kOofm_Koo?cloo[jn_o_knl00_oVi^H00ooShn?o^KVionKViP01onKViP000oo^k^h00oni
^KWohn?Sooooo`0?ooooo`0@ohR9S?mVMY3o@f>Goc1AR_lYCH[o<5>=ociNT_m8J9KoCFfIoda/VOm8
J9Ko=5N>oc1BS?l_Dhco<eJCodYLOQcooooo00?obLW9onc/k?ooool0oooooonLooooo`0?ok^k^ooB
d];ol_;booOgmoofm_KojNWYom_KfooOgmooi^KVong]kOodm?Cono_kookno_ojn_[okno_00;ok^k^
00?ohn?SokVi^Oo^k^h00Oo^k^h000?ooooo00?o^KVion?Shoooool03oooool04?nFUYKoV:2eogRF
h?oTi^Soi^S[onKXj_oVin[oi^SZonOXjooWjN_oinSZonKXj_oUin[oi>KYon[[k_nXZJ_ooooook_o
oooo00oo^k^kom?Cdoobl_;on?ShooWinOohn?Sojn_[on7QhOoXj>Sokno_ooKfm_okno_ooOgmoo[j
n_o_knl00_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0?ooooo`04
olW9bOnJVigoRhjEoiFEUP_oUYJF00?oXJ6Qooooooooool0ooooooniooooo`0?okJf]_o@d=3olO7a
ooOgmoohn?SomoOgonSXj?oLg=coh^;RonKVi_o^k^kom?CdooOgmoodm?Coj>SX00;ok^k^00?ohn?S
okVi^Oo^k^h00Oo^k^h000?oi^KV00?o^KVion?Shoooool03oooool00oolo?con?ShooGem@0<ooGe
m@03ooShn?oooooooooo0?oooooo^Oooool03onc/k?oc/k>ono_kooalO7ojn_[omoOgooEeMGoemOG
omgMgOoTi>Coj^[Zoo3`l?oclo?ol?3`onGUi@02onKViP03on?Shoni^KWoi^KV007oi^KV0003onk^
kP03okVi^OoShn?ooooo0?oooooof_ooool03on_[jooZZZZokbl_?nc/k?o[Zj^ojn_[ong]kOo_Kfm
ol;2`_o8b<Soc/k>om?CdooFe]Kodm?Col[:bP02onk^kP03on?Shoni^KWok^k^007ok^k^0003oooo
o`03okVi^OoShn?oPX:20?ooVIVILonIVIT00oo`l?3oPX:2oiVIV@1RoiVIV@03oo3`l?n2PX;ooooo
013ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?ShooIfMT0oooooomcooooo`03
oo3`l?oIfMWooooo06;ooooo00?ol?3`omWIfOo^k^h04?o^k^h00ooShn?o^KVionk^kP01onk^kP00
0ooVi^H00oni^KWohn?SomWIf@3oooooog?ooooo00?ol?3`omWIfOooool0H_ooool00oo`l?3ofMWI
onKViP0@onKViP03on?Shoni^KWoi^KV007oi^KV0003onk^kP03okVi^OoShn?ofMWI0?ooooooLooo
ool00oo`l?3ofMWIooooo`1Rooooo`03oo3`l?oIfMWok^k^013ok^k^00?ohn?SokVi^Oo^k^h00Oo^
k^h000?ooooo00?o^KVion?ShooHf=P0/oono_h01?o/k>coo_knookno_o[jn/?ooknoP03on[Zj_oe
mOGoo_kn0:Woo_kn00?ol?3`omSHf?ono_h05?ono_h01?o/k>coo_knookno_o[jn/3ooknoP03ooWi
nOo[jn_oo_kn00;oo_kn00?oj^[ZooGemOono_h04_ono_h00ooVi^KonOWiooknoP03ooknoP03ooGe
mOo`l?3oo_kn013oo_kn00?oj^[ZooGemOono_h00oono_h00ooemOGol?3`ooknoP0;ooknoP03oo3`
l?oHf=Sooooo013ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?ShooFe]H0ZOom
oOd04_lM7AgodM7AoogmoOomoOgono_kocPh>?lo?coooOgmooOgmolg=cOo5ADEoc<c<omeMGGo5QHF
olc<c?omoOgo9RHVojn_[`;ooOgm00co3@d=olK6a_omoOgolo?co`000?oOgmoooOgmolk>c_l[:b_o
51@Dob`/;?m;Bd^Yoogmo@03oo3`l?oFe]KooOgm00[ooOgm00Ko7AdMo``<3?lC4a?o5QHFocdm?Onc
/k<2oogmo@0AooOgmolg=cOo5ADEoc<c<omeMGGo5QHFolc<c?omoOgo];BdoaPH6?li>CWooOgmolk>
c_l[:b_o51@Dob`/;?m;Bd/01_omoOd01OlM7AgodM7AoogmoOno_koo[:b/00;ooOgm00So4Q8BolG5
aOomoOgo_[jnoa/K6olT92Co2@T9ogQhN0;ooOgm00KoTY:Bo`<30ol?3`ooIfMWoc/k>onHV9P2oogm
o@05obHV9_n_[joooOgmoeiNG_mgMgL00_omoOd02?lV9RKo[jn_oogmoOo>c/ko:b/[oa@D5?l/;2co
Bd];0_omoOd01_nBTY;o0`<3o`l?3omWIfOo>c/koiRHV0WooOgm00?ol?3`omKFe_o^k^h04?o^k^h0
0ooShn?o^KVionk^kP01onk^kP000ooVi^H00oni^KWohn?Som3@d02YooOgm`0>oadM7Oo<c<comoOg
ooOgmon;Rh_o0000ochn?_ogmoOo[:b/oaXJ6_oclo?of=SHobPX:?n4Q8@2ooOgm`0@obDU9On[Zj_o
moOgooOgmol=3@go`L71ooOgmoo]kNgo0000omWIfOo_knoo820PogQhN?oclo?omoOgono_kjWomoOg
00?ol?3`om3@d?ogmoL02_ogmoL03_lM7AgoX:2PooOgmooalO7o/[:boaLG5onCTi?omoOgojb/[?lJ
6Q[olo?comSHf?lX:2SoQ8B40_ogmoL02Om:BT[oOGemooOgmoo_knoo820PogQhN?oclo?omoOgono_
k`06ooOgm`0GoadM7Oo<c<comoOgobLW9ol820SojNWYooOgmolB4Q;o`<30on_[jolF5QKoS8b<ooOg
mooJf][o4a<CojFUYOoemOGo51@DoiJFU_ofm_KoZ:RXo`h>3_nEUID00_ogmoL01OlU9BGoZj^[ooOg
momLG5coM7Ad00;omoOg013o9BDUoj^[Zoo_knoo820PogQhN?oclo?omoOgono_koogmoOomOGeoa@D
5?nFUYKom_KfojRXZ?l>3PkoUIFE2OogmoL00oo`l?3od=3@onKViP03onKViPSo00001OoVi^H00ooS
hn?o^KVionKViP01onKViP000oo^k^h00oni^KWohn?Sol[:bP2Yoo;blP0>oa`L7?o8b<Sol_;bom;B
d_l:2P[oDU9Bocdm?Oobl_;oclo?o``<3?nWYjOok>c/od10@?n<S8`2oo;blP0=obDU9OnWYjOol_;b
oo;bl_l=3@go_Kfmoo;bl_oXj>So0000omGEeOnj^[[o20P8on;RhP2/oo;blP03oo3`l?o:b/[ol_;b
00[ol_;b00?o71`LoifMWOobl_800_obl_802OmlO7co3`l?onGUiOo?cloo30`<ojNWYoo/k>co@410
ohb<S002oo;blP06oc0`<?nLW9col_;bokZj^_l820Soh^;R2Oobl_803?lL71cob<S8ol?3`ol61PKo
F5QHoi>CToobl_;o4Q8Bokbl_?nf][Ko0@41on7Qh@;ol_;b00GoCTi>oeaLG?no_koo10@4on[ZjP02
oo;blP09ocTi>OnBTY;ol_;boo;bl_lU9BGoYjNWoo;bl_mJFU[oLG5a00;ol_;b00Go9BDUojNWYonj
^[[o20P8on;RhP04oo;blP03okno_ol410Coj^[Z00;ol_;b00?o>CTioi:BT_obl_802?obl_800oo`
l?3ob/[:onk^kP0@onk^kP03on?Shoni^KWok^k^007ok^k^0003ooooo`03okVi^OoShn?o`l?30:Wo
jNWY00Oo6a/Kol30`?oYjNWo?CdmodI6A_nQXJ7o>c/k00;ojNWY00GoaLG5ohF5QOmHF5So51@DohN7
Q`02onWYj@0<ob<S8onQXJ7ojNWYonWYjOl<30co][JfonWYjOoOgmoo0000olg=cOn`/;3o0P820_lN
7Qh00olD51Co<30`onWYj@2XonWYj@03oo3`l?o3`l?ojNWY00[ojNWY00?o6a/KoiNGUooYjNT00_oY
jNT02Onk^k_o0000okBd]?oYjNWoaLG5ohF5QOmHF5So51@DohN7Q`02onWYj@05obh^;_nFUYKojNWY
ok2`/?l20P800_lN7Qh00olD51Co<30`onWYj@05onWYj@0<oa/K6oo0`<3oJFUYod];Boni^KWo=cLg
onWYjOlA4A7o]KFeoj>SXol:2P[oi^KV0_oYjNT01OmOGeooC4a<ok^k^ol92@WoiNGU00;ojNWY00Wo
=cLgohb<S?oYjNWojNWYob<S8onQXJ7ojNWYoeIFE_m]KFd00_oYjNT01?lS8b?oXJ6Qok2`/?l20P82
oahN7P06oa@D5?l`<33ojNWYok^k^ol92@WoiNGU0_oYjNT00olg=cOoS8b<onWYj@08onWYj@03oo3`
l?o3`l?ooooo00Cooooo1_l00006ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?o_Kfm0:Woh>3P00Oo6QXJokVi^On8R8So3@d=olW9bOnKVi_o>CTi00Goh>3P01Co<S8bohZ:R_oP
h>3oh>3Pob8R8_mMGEgoh>3PomgMgOl61PKoLW9bon3Ph?o>c/ko0000ol[:b_oMgMgo5ADEolW9bOoP
h>3oMWIfofMWIjWoh>3P00?ol?3`okfm_OoPh>002_oPh>000olJ6Q[oTI6Aon3Ph002on3Ph003om_K
fol20P;oTi>C00Coh>3P00go<S8bohZ:R_oPh>3oh>3Pob`/;?n@T93oh>3PomgMgOlE5AGobLW9on3P
h?mfMWKoIfMW00Koh>3P00co6QXJokJf]_lE5AGoV9RHon3Ph?lT92Co`/;2oa0@4?n^[Zkoa<C4o`41
0Onb/[82on3Ph005obHV9_mcLg?ogmoOoaDE5Onb/[800_oPh>002Ol_;booQXJ6on3Ph?oPh>3o8R8R
oi^KVooPh>3oDe=CofUYJ@02on3Ph00<ob8R8_nKVi_ogMgMoaDE5Oo9bLWoh>3PogIfM_mWIfOoh>3P
omoOgolE5AGo/[:b0_oPh>000ol_;booQXJ6on3Ph008on3Ph003oo3`l?nm_Kgok^k^013ok^k^00?o
hn?SokVi^Oo^k^h00Oo^k^h000?oi^KV00?o^KVion?Shon_[jl0ZOoIfMT01olI6AWoW9bLo``<3?n3
Ph?ofMWIoiJFU_lg=cL00_oIfMT01Om4A4CoHf=Sofi^K_l51@Go`l?300;ofMWI00Ko8B4QodI6A_ln
?SkoCdm?oa4A4OmVIVH2odA4A008ob@T9?oIfMWofMWIofUYJOlc<c?oLW9boaPH6?nVYZJYomWIf@03
oo3`l?n_[joofMWI00[ofMWI00?o6ATIohf=SOoIfMT00_oIfMT05?nPX:3o0000ojFUYOoIfMWoA4A4
of=SHom^KVko1@D5ol?3`ooIfMWoV9RHoaDE5Om4A4CoK6a/omOGeomYJFWo<c<cog9bL_lH61SoYZJV
1_oIfMT05olI6AWoNGUio`h>3_oCdm?ofMWIog9bL_m/K6co410@ojVYZOoIfMWoIFEUoaTI6Om^KVko
>SXjob8R8_o=cLgofMWIofQXJ?lG5aOoKVi^obd];Ol=3@goPh>300;ofMWI00oo8B4QoiJFU_nOWioo
9bLWoc8b<_m/K6coc<c<ob4Q8OnFUYKofMWIofUYJOlc<c?oLW9boaPH6?nVYZH00_oIfMT01_mXJ6So
5aLGofi^K_l];Bgo3@d=oh>3P`WofMWI00?ol?3`ojn_[ooVi^H01OoVi^H4o`0000Ooi^KV00?ohn?S
okVi^OoVi^H00OoVi^H000?ok^k^00?o^KVion?ShonZZZX0ZOoDe=@00olH61So8B4QocLg=`02omCD
e008oi>CTolf=SKoe=CDomCDe?nn_[koShn?ogYjN_nd];@3omCDe009oi>CTonl_;coYjNWogQhN?nd
];Coe=CDoifMWOmlO7co`<3000?oe=CD00?oUiNGog9bL_nVYZH0Z_oDe=@00oo`l?3oZZZZomCDe00:
omCDe003oaPH6?n:RX[oe=CD00;oe=CD00SoEeMGoa<C4oo:b/[oe=CDokjn__n?ShooNWYjokBd]0;o
e=CD00WoYZJVoaXJ6_mGEeOoQXJ6om?CdooDe=CoUiNGog9bL_nVYZH01ooDe=@00olH61So:b/[oe=C
D`02omCDe004okbl_?lM7Ago3Ph>ojFUY@;oe=CD00CoX:2PogAdM?n8R8Sobl_;0ooDe=@01OnEUIGo
MGEeojb/[?lb<S;oP82000;oe=CD00WoTi>Cokbl_?n[Zj_o<C4aoclo?on6QXKob/[:oi>CTonl_;`0
0_oDe=@00onGUiOoLW9bojJVYP04omCDe005oiFEUOmeMGGo[:b/oc8b<_n0P8002OoDe=@00oo`l?3o
ZZZZonk^kP0@onk^kP03on?Shoni^KWok^k^007ok^k^0003ooooo`03okVi^OoShn?o/;2`0:Wof=SH
00?o6ATIo`T92Onl_;`00_oHf=P00onEUIGo=cLgomSHf031omSHf003oo3`l?n`/;3of=SH00[of=SH
00Oo6ATIofUYJOnNWYkoRHV9odm?Col;2`_oUIFE00Wof=SH00?oN7QhojVYZOoHf=P03?oHf=P00olI
6AWo0000oj>SX`03omSHf003ocTi>Ol0003oZ:RX00cof=SH00Wo<c<coh:2P_oHf=Sof=SHogmoOong
]kOof=SHofUYJOmHF5P00_oHf=P00omoOgoo]kNgomSHf00;omSHf003oc<c<on2PX;of=SH00Sof=SH
00?ol?3`ok2`/?ooool01_ooool2o`0000Sooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o
^KVion?Shonc/k<0ZOoLg=`00omIFEWoRh^;omcLg002omcLg003ojj^[_m]KFgog=cL0<7og=cL00?o
l?3`ok>c/ooLg=`02_oLg=`01_mIFEWoAdM7odM7AomGEeOoMGEeokfm_AWog=cL00?oFEUIoe5ADOoL
g=`00ooLg=`00onMWIgoAdM7ok^k^`0<omcLg00=oc@d=?n4Q8Cog=cLomcLg?mNGUko[Zj^omcLg?n`
/;3o5aLGofEUIOmaLG7oGUiNojj^[P0<omcLg003oc@d=?n4Q8Cog=cL00Sog=cL00?ol?3`ok>c/oo^
k^h04?o^k^h00ooShn?o^KVionk^kP01onk^kP000ooVi^H00oni^KWohn?SokBd]03oomcLg7?og=cL
00?ol?3`okBd]?oLg=`0?_oLg=`00ona/K7oa/K6omcLg005omcLg003ol_;bonATI7o/;2`00kog=cL
00?o/K6aolK6a_oLg=`02?oLg=`00oo`l?3o];BdonKViP0@onKViP03on?Shoni^KWoi^KV007oi^KV
0003onk^kP03okVi^OoShn?o/K6a0?oofMWILooIfMT00oo`l?3o/K6aomWIf@1RomWIf@03oo3`l?na
/K7ok^k^013ok^k^00?ohn?SokVi^Oo^k^h00Oo^k^h000?ooooo00?o^KVion?ShonWYjL0ooo@d=1c
om3@d003oo3`l?nWYjOod=3@06;od=3@00?ol?3`ojNWYoooool04?ooool00ooShn?o^KViooooo`01
ooooo`000oo^k^h00oni^KWohn?SoiNGU`3ookjn_W?o_[jn00?ol?3`oiNGUonn_[h0H_nn_[h00oo`
l?3oUiNGonk^kP0@onk^kP03on?Shoni^KWok^k^007ok^k^0003onKViP03okVi^OoShn?oUIFE0?oo
UIFELonEUID00oo`l?3oUIFEoiFEU@1RoiFEU@03oo3`l?nEUIGoi^KV013oi^KV00?ohn?SokVi^OoV
i^H00OoVi^H000?ok^k^00?o^KViol?3`oo3`l<0ooo3`l?/ol?3``7o^KVi0Oo^k^h1onk^kP000ooo
ooooogalO?3oO7al0_ooool00?ook^k^mOo^k^h00?ooi^KVmOoVi^H00?ook^k^mOo^k^h00?oooooo
mOooool00?ook^k^mOo^k^h00?ooi^KVmOoVi^H00?ook^k^mOo^k^h00?oooooomOooool00?ook^k^
mOo^k^h00?ooi^KVmOoVi^H00?ook^k^mOo^k^h00?oooooomOooool00?ook^k^mOo^k^h00?ooi^KV
mOoVi^H00?ook^k^mOo^k^h00?oooooomOooool00?ook^k^mOo^k^h00?ooi^KVmOoVi^H000Gok^k^
00SokNg]on_[jooShn?oe]KFolO7aonm_Kgo][JfokFe]KSo];Bd00So]KFeokJf]_nm_KgoalO7omKF
e_oShn?ojn_[ong]kOook^k^:?o^k^h000Gooooo00SooOgmooCdm?oNg]ko_;bloibLW?n6QXKoNg]k
ogMgMkSoMWIf00SoMgMgog]kNon6QXKoW9bLokbl_?oNg]kom?CdoogmoOoooooo:?ooool000Gok^k^
00Koj>SXomKFe_n_[jooVIVIokRh^?oVi^J[ooooo`03oiKDgonlmOoo_?Go00;o_?Go00?o^oCookce
oonlmOl01_nlmOl02Onkm?oo^?7oojoZoonJd>OoNZ2nog^;W?n_[jooe]KFonSXj03oonk^kRSok^k^
0005onKViP05omcLg?o1`L7oWYjNolo?coomoOd0[?ooool01_nKf]oo^oCook[aoonlmOoo_oWookce
o`Oo_OKo0_nonOl02?nkm?oo]?3ooj[WoonEf?ooKjCLogZ;Woo1`L7og=cLoooVi^HXonKViP001Oo^
k^h01OoQhN7o_Kfmok>c/ooclo?oo_kn0:cooooo00?oT/kOokW`oonjlOl00_njlOl01_nhkooo^_7o
okW`oonjlOoo^O3ookS_o`;o]^ko0_nhkol02?ndk?oo[^WoojSVoonEe_ooNKgooef7]_nm_KgohN7Q
ooo^k^hXonk^kP001Oooool01OoalO7oa<C4olk>c_oclo?ooOgm0:cooooo00?oTLcOokCZoondj_l0
2_nejol02_ncjOoo]N_ook7Yoon[iOooXn3ooi3@oomg^_ooChoDolC4a?oalO7oooooobSooooo0005
onk^kP06on3Ph?ne]KGof][Joo7alOoinOWooOgm0_ono_h4ooooo`;oo_kn00kooOgmoo_knoolo?co
n?ShonSXj?oKfm_of=SHomWIfOoQhN7olo?coo_knoolo?cooOgmooooo`?oo_kn00?oSXj>ofa/K?o0
`<000_ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Co
o_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Co
o_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Coo_kn1?ooool4ooknoPCooooo1?ono_h4ooooo`Co
o_kn00?ooooooh[3gonaiOl00_naiOl01?n_i?oo/NGoojoToonaiOl4ojoTo`0;ok7Uoon^hooo[^Go
ojkSoonWhOooW=Soohg=oomd^?ooA8gLokFe]OoPh>00ooo^k^hXonk^kP001OoVi^H01OoHf=So[Zj^
omWIfOo^k^komOGe00;ono_k00?ooOgmoo_knookno/00_okno/04?omoOgoo?clooWim_oLg=Wo[Zj^
ojVYZOnNWYkoR8N7ohF4Q?n6QHCoVIVGojZZZ?nZZZ[o_[jnonk^k_ohn?P2oogmo@06ooknnomnOWgo
W9bLoaXJ6_nd];Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k
0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k
0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k
0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k
0_omoOd2ooknn`Cono_k0_omoOd2ooknn`Cono_k0_omoOd2ooknn`03oo_knon1^]ooZn3o00;oZ]oo
00Co[>7ooj[Ooon/hOooZ]oo1?n/hOl02onZgoooZ=ooojSNoonVfoooW]GooiSDoon8aoooKJohod::
fon^[Zkof=SH0?ooi^KV:?oVi^H000Gok^k^00Ooh>3PokBd]?oHf=Sojn_[ooGemOofm_Kon?Sh00?o
nOWi0oohn?P03oofm_KokNg^ojJVYonWY:3o[Zf[ojbYZ?nMPfooZWM>oiU_C?nNUHko[Zb[okBb/?n6
QH;of][Joo;blP02ooWin@;on?Si00ConOWioe]KFom[Jf_on?Sh0_oinOT2on_[k0;onOWi0_ohn?P0
1?oinOWoi^KVooKfmoohn?T2onk^kP;on?Sh00ConOWiomoOgoofm_Oon?Si0_oinOT01?oUiNGoj>SX
ooWinOoinOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;o
n?Sh0_oinOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;o
n?Sh0_oinOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;o
n?Sh0_oinOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T2ooWin@;o
n?Sh0_oinOT2ooShn@;onOWi0_ohn?P2ooWin@;on?Si0_oinOT2ooShn0;onOWi0_ohn?T01_oinOWo
O[GOojOKoonTf?ooY][oojGJo`[oY=Wo00SoX=Kooi_Coon@bOooPl7oofVZlOlnQ]Ko];Bdon3Ph?oo
k^k^:?o^k^h000Gooooo00Sol?3`ol71`OoEeMGojNWYoo?cloodm?Com_KfooGem@Com_Kf013omOGe
ooCdm?o_knooYjNVolk9`ooln?Koo?_kokR@L?nlH1ko/fL^on;Gc_ono?_onoWiohn<ROoNg]kolo?c
1?oemOD02_ofm_KoKFe]odQ8B?ofm_KomOGeob<S8ol?3`oo7QhNodY:B_o]kNd2ooKfmP0Bode=COl7
1`Oo61PHoiFEUOlB4Q;oDe=CooKfm_o;bl_o8b<Soa`L7?nb/[;omOGeom?Cdolc<c?o3@d=o`/;2olf
=SKodm?C0_oemOD4ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD4ooKfmPComOGe1?ofm_H4ooGe
m@Com_Kf1?oemOD4ooKfmPComOGe1?ofm_H4ooGem@Com_Kf1?oemOD4ooKfmPComOGe1?ofm_H4ooGe
m@Com_Kf1?oemOD4ooKfmPComOGe1?ofm_H4ooGem@03ooKfm_mn]MooX=Ko00KoX=Ko00?oSkoToa`U
;On?_n@01OnPe_l01onKdoooT<Wooh?1oomYZ_7o?XKFol71`Oo`l?00oooooolXooooo`001Oo^k^h0
1ooPh>3o];BdomCDe?oVi^Kol?3`oo?clooalO401oodm?@03Oobl_;oZZZZolW4_oo]inOok>[[ojf:
K_nnLc[o[6XgomG:`oo^j^WomO3]ohf;R?oShn<00oodm?@2oo?cl`03ooCdm?m]KFgoAdM700;om?Cd
00co]kNgono_koobl_;o<c<coh^;Roodm?Co_Kfmo`<30ooCdm?ofm_KoeIFE_l@4102ooCdm007ofa/
K?ln?Skolo?coo?cloobl_;o<C4aodi>CP02on?Sh`04oe5ADOlb<S;ol_;boo?cl`Kom?Cd0_oclo<6
ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6
ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6
ooCdm0;olo?c00Com?CdogN_gonNdoooWM;o1OnNdol00om1EVWo0000od5FJ@04oikCo`08oi[?oonC
c?ooR<3mog^hnOmRYNko=go?okBd]?oPh>3oonk^kRSok^k^0005onKViP07omSHf?n^[Zkoe=CDonKV
i_o`l?3olo?coo7al@07ooCdm00=oo?clon[ZZ[oa;jgonoXj?o]jncoXGeToj9:6?nHD2Goe/k8onk[
jOodk^coRHN4onCTi003ooCdm0;olo?c00?om?Cdofe]KOm7AdL00oodm?@02ooclo?o^k^koaDE5On<
S8com?Cdolo?col20P;o];Bdoo?clonGUiOo7QhN00;om?Cd00OoBDU9ofe]KOodm?Colo?colg=cOl0
003o[jn_00;om?Cd00Co[jn_o`000?oAdM7olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c
1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c
1_odm?@2oo?cl`Kom?Cd0_oclo<6ooCdm0;olo?c1_odm?@2oo?cl`Kom?Cd0_oclo<00oodm?CoKJGO
oiO<o`02oiK:o`?oULWo013oN:;>oaXS;Ol0003o6R<]ogRRc_nEbOooU/[ooi;7o_n>`o[oS<?noh:k
nOmb/OCoF9_Toc1ibOn^[Zkof=SHoooVi^HXonKViP001Oo^k^h01ooPh>3o];Bdom?CdooTi>Cok^k^
ono_koo`l?002?oalO403?nYZJSo_;F^on_Wioo/j^SoKEE4ofPZ2omM<1CoclO0on[ViOo`jnWoQ85m
on7Qh@KolO7a00WoJf][odI6A_oalO7olO7aomOGeom5ADGo0P82ofYZJ_oXj>P00_oalO401OnSXj?o
;bl_oc0`<?lc<c?o7QhN00;olO7a00OoB4Q8of][JooalO7olO7aok>c/ol0003ofMWI00;olO7a00?o
emOGo`000?nf][H0L_oalO402?mTW=KoS/;iohk3n_n=`OSoS/;iohk3n_n>`_Wo8c0m0ol000003?lS
;cgoS/?johk3n_n;_oKoR;geoh6im?mi/NkoJZOZoe2CfolYKl?o];Bdon3Ph?ook^k^:?o^k^h000Go
oooo00Kol?3`ol71`Oo@d=3ohN7QonWYjOo/k>`2onk^kP;ol?3`0oo_knl03oo^k^kof][Johf<Rond
[JGoh=_HonGQgoo1_;KoWYJ;ojfUVooTh]oofM?>on7Ke?moNgOoa/K6onc/k004ono_k`03oo3`l?m[
Jf_oATI600;okno_00?o?3`locdm?Oo=cLd00_o`l?04ono_k`07ong]kOn:RX[o7alOoo3`l?o_knoo
B4Q8ofYZJP02ono_k`03olk>c_l0003oZJVY00;okno_00CoYZJVo`000?oAdM7okno_0_o`l?06ono_
k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`l?06ono_
k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`l?06ono_k`;ol?3`1_o_knl2oo3`l0Kokno_0_o`l?06ono_
k`;ol?3`1_o_knl00oo`l?3oFi;?ohBil@02ohNkm0;oQ;Wa00?oFWjTo`000?l000000ol000002omJ
OZCoQ[[aoh>ilOmo]NkoNK7[og2ZjOmPWn?oAX[Eob1X_Oo1`L7ol?3`0?oooooo:?ooool000Gok^k^
00Ooh>3PokBd]?o=cLgog=cLonGUiOoWinOojNWY00?ok>c/0_oZj^X04?o/k>coinOWoinOXOmUHV3o
]:RHolg6_oo@aKkoXGiZoi=hIOnFMEoo]inBol[5__o6^JWoLViWohN7R?oNg]h2onc/k0;ojn_/00[o
k>c/ofUYJOm4A4Coj^[Zonc/k?lb<S;oRXZ:on_[k?oFe]KoinOW0_oZj^X04_nVYZKobLW9onSXjOmI
FEWoCDe=onc/k?oTi>Co@T92ofATI?oQhN7oinOXon_[k?ll?3co@T92ol_;boo:b/[o@D51ochn?P;o
jn_/0_o/k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;o
jn_/0_o/k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;o
jn_/0_o/k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;o
jn_/0_o/k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k0;ok>c/0_oZj^X2onc/k0;o
jn_/0_o/k>`2on[ZjP;ok>c/0_o[jn`2onc/k0;oj^[Z0_o/k>`2on_[k004onc/k?mCR/KoO;7Yog^_
i`;oO;7Y00?oMj[Poa<K9?l000001?l000002olC6bCoMZSPogN_jOmcZnKoKJGSof:Ng_mETmSo>gk<
oaIO]?nd];Coh>3P0?ook^k^:?o^k^h000Goi^KV00Sof=SHojj^[_o4a<Coe]KFon3Ph?oUiNGoi^KV
onGUi@GoinOW00ooi^KVolW9bOmcLg?oJVENolG0]?ncTXCoNS0Nom[TionNOgGoP3LSom3;_omaJ5go
DU1?okBd]?oShn<01OoWinL02OmdM7CoEEEEonOWiooWinOo[Jf]oc@d=?l>3Pko4A4Aom;BdP02onOW
i`0>ogemOOl];Bgo3Ph>oc<c<ona/K7oinOWog9bL_l71`Oo2PX:oaPH6?nLW9coi^KVom7AdOm9BDT2
o`d=3@03od];BooBd];oi^KV04Soi^KV:_oWinL01_m>Pl3oMjcTogN[homgZn?oMJ[PoceHM@Oo0000
00[o?EUfog>XhOm_Y]ooJJ;KoenJf_m?SM?o<7G4o`eE[_n^[Zkof=SHoooVi^HXonKViP001Oo^k^h0
2?oPh>3o]KFeolC4a?oFe]Koh>3PonGUiOoVi^KoiNGU1_oWinL03OoUiNGob/[:ofi^Kom]JfCo[hii
og@a6ooMeLkoWGQYohI39on3OW;oF5ECogEbK_oGemL03?oWinL00ooTi>CoinOWonOWi`04onOWi`07
onGUiOoWinOoinOWonOWiooVi^KoADE5ofIVIP05onKViP;oiNGUBooVi^HZonOWi`08odj3`?mg[>Co
Mj_SogN[homeZ^3oMZ[QogFZh?mfZ^44ogFZh00;ogJZhOmeZnCoLjSQofnVgomYX]_oGi[Jodn=dol`
MLCo3EF^okFe]OoPh>00ooo^k^hXonk^kP001Oooool02?o`l?3o`/;2olC4a?oFe]Koh>3PonGUiOoV
i^KoiNGU1ooWinL03?oUiNGoalO7ofi^KomOETgoVX9[oj^BM_nVS77oHe=6odi:AOni/j_oOgagomWI
f@KoinOW00?oNGUioe]KFooWinL03_oWinL00ooVi^Kob/[:olS8b01BonKViR[oinOW00SoCX?0ogN/
i?mgZn?oMj_SogFZh?mfZ^7oMJ[PogJZh@CoMJ[P00_oMZ[QogF[i?mcZ>7oKjKOofVRfomOV][oChgC
oc1ea?l=EJko`/;2oo3`l03oooooobSooooo0005onk^kP06on3Ph?nf][Ko_;blom3@d?oOgmooi>CT
0_oUiND8onKViP0;onCTi?o:b/[oLg=doeaGC_nOTWSoJF=EoeYJF_n6QH?oZj>IogeiMOoHf=P01_oV
i^H00ond];CoYJFUonKViP2=onKViP04oenA`on2[n3oPJkOoh>ah0WoPZoO00[oP:oOogn]g_mm[=ko
M:GJofjRf_mKU=3o9Vbmo`57YOnf][Koh>3Pooo^k^hXonk^kP001OoVi^H01_oJf][o]kNgok>c/oo6
a/Koh>3PonOWi`;ojNWY2OoZj^X02_oYjNWodM7AogQhN?m>BTKoGEeMokbl_?nh^;SoQX=ooh^:R?oP
h>2Fon[ZjP05ohV]e?nR`^GoX/?Voj;2iOnR`nD00onR`nH03onR`nGoX<;Uoj32iOnP`^GoX/;Voj?3
i_nO`^KoW<3ToiRlhonB^=ooMjGHob1W^Ol0?9co]kNgom[JfP3oonKViRSoi^KV0005onk^kP07onCT
i?o7alOoXj>SokZj^_oLg=coinOWonWYj@0;on[ZjP09onSXj?oAdM7oUYJGokjn__oVi^Kohn?SolW9
bOoHf=SojNWY09Koj^[Z00WoW[cJok?=jOnbcNWo/lkYok;=jOncc^Wo]<oZok?>jOnccNT00onbcNT0
2oncc^[o/lgYok;=ion_b^Oo[<SVojG4i?mkY]So3eB[oa<hT?o7alOoi>CT0?ook^k^:?o^k^h000Go
oooo00SonOWionKVi_nWYjOo[:b/olk>c_oShn?oi^KVonOWi`_ojNWY00?oinOWomoOgooUiND0VooY
jNT05onV`Mco^M3ZokW@j_nid>[o^=3ZokW@j_njd^[o^]3Yok[Bj_nhd>[o^<oYokW@j_njd^[o^M3Z
okS?jOndc^Oo[l[Voibmh?mHS/Oo1T:OodeJVOoVi^KonOWi0?oooooo:?ooool000Gok^k^00Sok>c/
on?Shono_kooX:2Pok:b/_o8b<Soe]KFom_KfjWog]kN00GoRj_@oio0h?nO`>3oWl3Poijoh003oio0
h003oik0h?nO`>3oW[oP00;oW[oP00[oW[gPoibmh?nF^McoP:[Foe>:a_lPF:_o9Sn@oifN^?oShn?o
k>c/ooo^k^hXonk^kP001OoVi^H02?oUiNGohn?SomcLg?nn_[koYZJVoijNW_nPX:3oY:BTZOnSXj<8
oa9FZ00?oa9FYolBEZSo4UJXoa9FZ_lBEZSo45FWo`iAY_l=CZ?o2dFNoae4Uom@HIkoW9jhomcLg?oS
hn?oiNGU0?ooi^KV:?oVi^H000Kok^k^00GokNg]onc/k?oXj>Soi>CTon7Qh@2lon3Ph005on7QhOoT
i>Coj>SXonc/k?o]kNd0ooo^k^hYonk^kP002?ooool2ookno[kooOgm0_ono_koooooob_ooooo003o
onk^k_Gok^k^003oonKVi_Goi^KV003oonk^k_Gok^k^003oooooooGooooo003oonk^k_Gok^k^003o
onKVi_Goi^KV003oonk^k_Gok^k^003oooooooGooooo003oonk^k_Gok^k^003oonKVi_Goi^KV003o
onk^k_Gok^k^003oooooooGooooo003oonk^k_Gok^k^003oonKVi_Goi^KV003oonk^k_Gok^k^003o
ogmoOoGoOgmo00001?o[jn_oi^KVon;Rh_oNg]h4omgMg@?og]kN01_ogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomgMgOoLg=`00_oMgMd04OoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN00;ogMgM0:kog=cMomgM
gOoMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]h2omgMg@3momgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMg@03omkNgP03omgMgOoNg]kog]kN00?ogMgM0OoQhN41
onOWi`7oj^[Z00000oo/k>coi^KVon3Ph007omWIf@04omSHf?oFe]Kodm?Com3@d0?ocLg=00Cod=3@
om?CdooGemOof=SH3?oIfMT02OoHf=SoemOGomGEeOoDe=Codm?ComCDe?oEeMGoemOGomSHf00=omWI
f@09omSHf?oGemOoeMGEomCDe?oCdm?oe=CDomGEeOoGemOof=SH09;ofMWI1?oHf=P4omWIf@03omSH
f?oIfMWofMWI00;of=SH2_oIfMT2omSHf0WofMWI0_oHf=P6omWIf@04omSHf?oIfMWofMWIomSHf0?o
fMWI0_oHf=P3omWIf@04omSHf?oIfMWof=SHomSHf0OofMWI00?of=SHomWIfOoIfMT00_oHf=P2omWI
f@;of=SHc?oIfMT00ooHf=SofMWIomWIf@06omWIf@7og]kN0OoVi^H1onc/k00000Ook^k^onWYjOoT
i>Coh>3Pon7QhOoPh>3oh^;R00;ohN7Q00gog]kNomcLg?oCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk
^k_oalO7om?CdooKfm_ogmoO00WohN7Q00goh>3PomoOgooKfm_oe]KFom;Bd_o>c/koc<c<olk>c_oB
d];oe]KFom_KfooOgmooh>3P00WohN7Q00goh>3PomoOgooKfm_oe]KFom;Bd_o>c/koc<c<olk>c_oB
d];oe]KFom_KfooOgmooh>3P08kohN7Q00?oh>3PomoOgooOgml00_oNg]h01?oOgmooh>3Pon3Ph?oP
h>06omoOg`?oh>3P00CogmoOon3Ph?oPh>3ohN7Q0_oPh>001?oOgmoog]kNomkNg_oOgml2on3Ph0?o
hN7Q0_oPh>000ooOgmoog]kNomoOg`02omoOg`?oh>3P1_oOgml01OoPh>3ogmoOomoOgooOgmooh>3P
00KogmoO0_oPh>02on7Qh@;oh>3P00?ogmoOomkNg_oOgml01OoOgml00ooNg]kogmoOomoOg`03on3P
h003omoOgooPh>3oh>3P0<OohN7Q00?oh^;Ron7QhOoRh^801?oQhN41onCTi07ojNWY0Oo]kNd00003
oo3`l?o_knoolO7a00?ol?3`01Sokno_oo3`l?o^k^kojNWYom_Kfoo1`L7oY:BTohb<S?mkNg_oMgMg
og]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7alOo_knoolO7_ono_kooalO42onk^
kP0DonKVi_oNg]kodM7AolW9aoo1`L7o_knool71`Oo9bLWodM7AomkNg_oVi^Kok^k/onk^k_oalO7o
kno_oo7alOo_knoolO7aono_kooalNl2onk^kP0;onKVi_oNg]kodM7AolW9bOo1`L7o_knnol71`Oo9
bLWodM7AomkNg_oVi^H00_o^k^h0V_oalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo3`l?o]kNgok>c/onOWiooW
inGoiNGUonWYjOoZj^[ok^k^on_[jooZj^[oi^KVonSXi_oWinL2onWYj@07onk^k_o/k>cok>c/onSX
j?o/k>[okNg]oo3`l002ong]k@;oinOW00goi^KVon[Zj?o[jn_ol?3`onk^k_oalO7ok^k^ono_koo[
jn_ojNWWonGUiOoXj>SoinOW00;oj^[Z00gok^k^on[Zj_oYjNOoi^KVonSXj?oWinOojNWYon[Zj_o]
kNgojNWYonWYiooXj>Sok>c/00;ojNWY013oi^KVonSXj?oWinOojNWWon_[joo_knook^k^oo3`l?o^
k^kokNg]onOWiooXj>Koi^KVonWYjOoWinOojn_[0_oZj^X01ooVi^Koj>SVonSXj?o^k^kokNg]onk^
k_oZj^X00_o]kNd0cOo`l>kokno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aoo3`l?o_knool?3`ono_koo`l?3okno_oo3`l?o_knl01?o`l?00
0003oo;bl_o^k^koinOW00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;o
ADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@02ooUiNGoi>CTonGUi?oTi>CoiNGUon;Rh_oL
g=coclo?ol71`Ona/K7oZJVX00?oY:BT0:OoZJVYok6a/Oo1`L7oclo?omcLfooRh^;oiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTon;Rh_oLg=coclo?ol71`Ona/K7oZJVYojBTY?nTY:?oY:BTojVYZOna
/K7o`L71olo?cooLg=coh^;RonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUi@02onCTi00Hon7QhOoMgMgoemOGomKFeOoE
eMGoemOGomWIfOoMgMgofm_KomOGeooDe=Coe]KEomCDe?oEeMGofMWIon3Ph?oNg]kofMWIomCDe?oI
fMSogmoOon?ShooOgmoofm_K0_oEeMD00ooFe]Kof][IomkNgP02on?Sh`0NonGUiOoShn?ohN7Qom_K
fooFe]Godm?ComKFe_oDe=Coe]KFom_KfooMgMgofMWIomGEe?oDe=Coe]KFomCDe?oGemOog=cLomgM
gOoHf=SoemOFomWIfOoLg=cofMWIomGEeOoDe=Coe]KFomCDe?oGemKog=cL0_oShn<01OoTi>CohN7Q
omcLg?oEeMGoeMGD00?oeMGE00Oofm_KomcLg?oJf][oe]KFomKFeOoGemOogMgM00;oh>3P0<Wofm_K
omkNg_oQhN7oi>CSonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>@01?oUiND01_oTi>CoiNGUonGUiOoUiNGoj>SXong]k@7ol_;b0000
0oodm?CokNg]onOWi`02on3Ph00Con7QhOoOgmoog]kNom;Bd_nd];CoQhN7oeaLG?m]>cGoWTi2ole_
GooYPfoocFmOoii>@om]>cKoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomoOgooJf][oc/k>okbl
_?n[Zj_o/;2`olO7aooIfMWoi>CTomWIfOo7alOo/K6aoj^[Zonl_;coc/k>om[Jf_oOgml01OoPh>00
4OoOgmoof][Jolk>c_nl_;coZj^[ok2`/?o7alOofMWIonCTi?oIfMWoalO7ok6a/On[Zj_o_;blolk>
c_oJf][ogmoO08_oh>3P01[ogmoOomgMgOoJf][oeMGEokZj^_o1`L7odM7Aom3@d?oDe=Codm?Colo?
coo1`L7oclo?olk>c_o5aLGobl_;om[Jf_oHf=Soclo?ol_;boo@d=3of=SHomcLg?oHf=SodM7Aolo?
c`;oa/K602?of=SHom_KfooNg]kogmoOon3Ph?oNg]kofMWIom;Bd_o?cloo_[jnom;Bd_o@d=3ocLg=
om?CdooFe]KodM7Aol[:b_o3`l?od=3@olg=cOno_koof=SHomOGeooAdM7ob<S8olO7aooGemOodM7A
ol_;boo3`l?od=3@olg=cOno_koof=SHomkNgP02omoOg`0Dom_KfooDe=Coclo?okno_ooAdM7oc/k>
ol71`OoAdM7ofMWIomSHf?o8b<SoalO7om3@d?oEeMGofm_KomcLg?oIfMWofm_KomkNg_oOgmo4on3P
h003omoOgooPh>3ogmoO00;ogmoO0ooPh>000ooQhN7oinOWonc/k001ooCdm00000?om_Kfoo;bl_o[
jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWiooJemOohlf;_o]LF7onIf@oofaYOom_:oooKBWooVOToo]
M6?oTSL_of]OGonOWioocLg=on;Rh_oWinL01?oXj>P01ooVi^KogMgMol[:b_ne]KGo_knoonOWioo_
knl00oo`l?001oo_knoojNWYol71`One]KGob/[:omgMgOoVi^H01OoXj>P01ooVi^KogMgMol[:b_ne
]KGo_knoonOWioo_knl00oo`l?001oo_knoojNWYol71`One]KGob/[:omgMgOoVi^H0RooXj>P2onOW
i`1AoijNW_l92@Wo2`/;ob0P8?l`<33oT92@om[Jf_oLg=coB4Q8o`L71olG5aOoQXJ6oa4A4Om<C4co
h^;RomgMgOnDU9Co0000oiRHV?oMgMgoh>3PomcLg?nj^[[o=cLgo`<30olN7Qko5aLGokfm_OoVi^Ko
inOWonSXj?oVi^KogmoOokjn__lT92Co0@41oa<C4onEUIGo0000ok6a/OoNg]koVIVIoa8B4_l;2`_o
Cdm?oeYJF_lB4Q;o][JfomgMgOmiNGWo30`<obl_;ooQhN7oX:2PoaDE5Ol;2`_oBDU9of5QHOl@413o
/K6aonKVi_oXj>SoinOWonCTi?o;bl_o:RXZo`T92OlV9RKoPX:2o`D51OmkNg_og=cLoalO7ol?3`oo
71`LodQ8B?oHf=Sohn?SonKVi_l30`?oZ:RX00;oinOWcOoXj>P1onc/k07ol_;b0Oofm_H00003ooOg
moohn?Son?Sh00?on?Sh01?omoOgonk^k_o>c/koT92@ohD_:ooYI5Koni:7oojVVoon/JGookR[oojc
Y_onZ9coniB9oniXFOn9<B_oT92@olk>c_o^k^komoOg00Con?Sh00Kom?CdonOWioo?clooa/K6on[Z
j_odm?@2ooWin@09oo[jn_oinOWonOWiooKfm_o[jn_oalO7olo?cooWinOom?Cd00Gon?Sh00Kom?Cd
onOWioo?clooa/K6on[Zj_odm?@2ooWin@09oo[jn_oinOWonOWiooKfm_o[jn_oalO7olo?cooWinOo
m?Cd08con?Sh05?omoOgolo?conh^;SokNg]on_[jonATI7o0`<3olo?conk^k_o0P82ol_;booAdM7o
EUIFoa0@4?o]kNgol?3`on[Zj_m9BDWo51@DodQ8B?oYjNWokNg]onKVi_l];BgoC4a<om7AdOoXj>So
f][JonKVi_ofm_KomoOgooShn?ofm_Kok^k^ofm_Kol/;2coc<c<omWIfOmDE5Co0000okjn__o`l?3o
=CDeofUYJOoVi^KoXJ6Qo`L71onDU9Col?3`onWYjOlD51CoUIFEoo?cloodm?Co@410oemOGooVi^Ko
YJFUo``<3?n9RHWol_;booOgmoohn?SomoOgooGemOn7QhOo8B4Qon3Ph?o0`<3o<c<codA4A?o_knoo
k^k^okNg]ooUiNGoi>CTob/[:onDU9ComOGeooOgmoni^KWoi^KVooOgm`37ooShn003ooOgmoohn?So
n?Sh00;on?Sh00ComoOgooWinOogmoOomoOg0Oohn?P00003oo[jn_oemOGok^k^00;ok>c/027ojn_[
onWYjOoOgmoo^[ZjogUBD_no<RCoigAYoof9O_ooV8cooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<T
ogUBD_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[k?o[jn_oi^KVomSHf?nk^k_oe=CDonCTi?o[jn_olO7a
oo;bl_oclo<00_obl_801_o]kNgoiNGUomGEeOnk^k_of=SHonKViP;ojn_[00cok>c/on_[joo[jn_o
i^KWomSHf?nk^k_oe=CDonCTi?o[jn_olO7aoo;bl_oclo<2oo;blP06ong]kOoUiNGoeMGEok^k^ooH
f=Soi^KW0_o[jn/0ROo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/00;ojn_[01goj>SXonCTi?oNg]oof][Jol;2`_l0003oY:BTolK6
a_l20P;oZ:RXomgMg_n;Rh_o7AdMon7QhOoPh>3ob/[:o`820_nUYJGo1`L7olK6a_oOgmoo[Jf]o`00
0?nc/k?ofm_KomWIfOoJf]_oh^;RonSXj002on_[j`0Oon[Zj_oRh^;o:RXZog=cLooRh^;oi>CTom7A
dOl0003o];BdonGUiOm8B4SoADE5on3Ph?oKfm_o3`l?oiVIVOoTi>Coclo?o`000?nf][Ooi^KVonSX
j?mADE7o?3`lomoOgooKfm_o6ATIoi2@TOoWinOoj^[Zonc/k002on_[j`0>oiFEUOl=3@gob/[;omgM
gOmKFe_oCdm?on;Rh_oTi>CogMgMom[Jf_nWYjSo3`l?ohj>S_oZj^X3onWYj@35on_[jooZj^_ok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>`01oo[
jn/01Oo/k>cojn_[on_[joo^k^kom_Kf007onOWi00000ookno_olo?cong]k@02onGUi@0OonKVi_oT
i>CofMWIok:b/_mi;Rkob48don=ZG?odNVgooHQloojGR_onVhkooYR;ooj:O_odNfgoif]MolY2=?mk
;Rko/[:bomSHf?oTi>CoiNGUonKVi_oUiNKoiNGUomoOgooAdM7o][JfomCDe?oMgMgoi>CTonKVi`03
onc/k007onSXj?oTi>CogmoOomGEeOnf][OodM7AomoOg`02onGUi@0DonKVi_oUiNGoiNGUomoOh?oA
dM7o][JfomCDe?oMgMgoi>CTonKVi_o/k>cok>c]onc/k?oXj>Soi>CTomoOgooEeMGo][Jfom7AdOoO
gn02onGUi@2RonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonCTi?oNg]kof=SHom?Ce?o:b/[oADE5o`L71ooFe]Koh^;RoiNG
Uol/;2co;Bd]obl_;olL71cog=cLom[Jf_mkNg_o:BTYon3Ph?m9BDWoL71`omWIfOn@T93o0P821?lg
=cL08onk^k_ohn?SonKVi_oUiNGoi>CTomkNg_l410CoRXZ;omSHf?oIfMWobLW9o`000?n`/;3ogmoO
olk>c_m?Cdoo7alOod92@_l410CoUYJFomkNg_o8b<So0000ok6a/OoLg=coh>3Pom;Bd_mCDe?o7alO
od51@Ol820SoSHf>on;Rh_oTi>Coi^KV00;oiNGU00KohN7QogQhN?lR8R;o=SHfoalO7om=CDd2omkN
gP3?okfm_Oll?3co0`<3ofUYJOoJf][oi>CTon7QhOoOgmooh>3PonCTi?oTi>Goi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU00;oi^KV00?o
iNGUonKVi_oVi^H00ooVi^H00ooUiNGokNg]ooCdm001oo_kn`0000?oo?clooShn?oalO400oo^k^h0
4oo[jn_ohN7Qokbl_?mj5aOo`clbom=FBOoTJ5[okgM/ooB3NOohQgcomHAjoo=iKOoUJE_ofEQ:ol@o
<_ml5aOo_;blon7QhOo/k>`00oo^k^h02?o]kNgojNWYom[Jf_ni^KWoemOGomkNg_oShn?oi^KV0ooZ
j^X02?oXj>Soi>CTomkNg_oHf=So^KViom[Jf_oYjNWokNg]0oo^k^h02?o]kNgojNWYom[Jf_ni^KWo
emOGomkNg_oShn?oi^KV0ooZj^X02?oXj>Soi>CTomkNg_oHf=So^KViom[Jf_oYjNWokNg]R_o^k^h0
7oo]kNgojn_[onCTi?oLg=coX:2PoaTI6OlE5AGo[jn_onc/k?oZj^[oiNGUon7QhOoNg]koQ8B4oadM
7OoVi^Koi>CTobXZ:_n3Ph?ojn_[ojRXZ?lL71coh^;Rok:b/_l0003oZ:RXokJf]_nRXZ;o1PH6on3P
h?o]kNd00_o^k^h01?o]kNgojn_[ob4Q8OmTI6@2omoOg`0Hom3@d?l0003o][JfonSXj?oWinOohn?S
on3Ph?oFe]Ko3@d=oijNW_oVi^Kod=3@o`000?nf][KohN7QonSXj?oWinOohn?Son3Ph?oFe]Ko5aLG
oiFEUOo/k>cokNg]0_o^k^h05?o]kNgoj^[ZonCTi?oPh>3ofm_KoeIFE_mBDU;oj^[ZonWYjOlb<S;o
@T92olC4a?oShn?ojNWYonc/k?oYjNWoi^KVonSXj?o[jn_okNg]c?o^k^h00oo]kNgol_;booShn001
ooclo0000oomoOd05_olo?cooOgmoogmoOolo?colo?com7AdOmX1`Oo^3@dolLo<ooBD4?ofV9Eon=^
H_oTLVCoi6mRomaTEooCDD?oc44dokTd=?m[1`Ood];Boo?cloolo?`4oogmo@07ooWinOo/k>co^;Rh
om_KfooQhN7oiNGUonWYj@02onc/k008ong]kOoZj^[oiNGUon;Rh_oKfm_o^KVionc/k?oinOT5oogm
o@07ooWinOo/k>co^;Rhom_KfooQhN7oiNGUonWYj@02onc/k008ong]kOoZj^[oiNGUon;Rh_oKfm_o
^KVionc/k?oinOV;oogmo@0Oooclo?ojn_[olo?cog]kNol0003oDe=ComgMgOohn?Son_[joo_knon`
/;3odm?Coo;bl_mOGeooDU9Boo[jn_o;bl_o0`<3onGUiOolo?conOWioahN7_nc/k?omoOgobXZ:_ml
O7cokno_ohF5QOm0@43ono_kooclo002oogmo@;oo?cl01_oQ8B4oadM7Ono_kookNg]oh:2P_l0003o
`/;2ooShn?oGemOo/k>conk^k_o8b<So0000om_Kfoohn?Sof=SHo`000?nm_Kgoj^[ZooWinOoKfm_o
/K6aonc/k?o@d=3o0@41om?Cdoolo?`00oomoOd01oolo?con_[joj6QXOoOgmoojn_[obl_;on9RHT0
0_okno/02ol[:b_oVi^KooGemOoNg]komoOgoo_knoojn_[oX:2Pon;Rh_okno_oo?cl0<[ooOgm00?o
o?cloogmoOolo?`00oomoOd0003>oogmoOojn_[olo?conk^k_o`l?3okno_onk^k_oYjNWodm?Coe/M
7OnR=3Co]2PMol4j;Oo7BCcoceI:om1GBoo@Ed[obTXnol<k;_nf:1goXS@doe`M7OoCdm?oj^[Zonk^
k_o`l?3okno_oo3`koo_knook^k^on?Shon/[:cob/[:om;Bd_oGemOof][IomgMgOoNg]kogMgMomcL
g?oGemOoe=CDol[:b_n/[:_ohn?Sonk^k_o_knool?3`ono_koo`l?3okno_onk^kOoShn?o[:b/ol[:
b_oBd];oemOGom[Jf_oMgMgog]kMomgMgOoLg=coemOGomCDe?o:b/[o[:b/on?Shoo^k^gokno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?02ono_k`0Pong]kOoBd];o0@41ohB4Q?oPh>3ohn?SonGUiOo/k>cokNg]oh61POl^;Rko3`l>
ocDe=Ong]kOok^k^og]kNomEEEGokno_onk^k_o_knkoPH61of9RH_o^k^koc/k>ocPh>?l:2P[o8B4Q
okVi^?o^k^kol?3`ono_koo`l?02ono_k`3gonWYjOmUIFCo3@d=oaXJ6_mdM7Co0000okRh^?o/k>co
aLG5odI6A_lJ6Q[o5aLGofe]KOo_knookNg]obDU9Ol0003o51@Doa`L7?o_knoobl_;odQ8B?lL71co
5ADEofEUIOo_knkok^k^oo3`l?o_knool?3`onk^k_o_knooFe]Kob@T9?l?3`ooADE5omGEeOo_knoo
k^k^ojf][Olc<c?o3`l>oa8B4_oPh>3ok^k^ono_kolL71co][Jfonk^k_o`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_k`02oo3`
l0Kokno_0Ooclo<1ooWin@7oo_kn00000oono_komoOgoo3`l004onWYj@0AonOWiooKfm_oHd];oh4b
<_nV=CGo]S@]ol9=@Oo3E4Woa5E:ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooWinL01OoYjNT0
1_oXj>Sohn?Soj^[Zoni^KWobLW9olo?c`;oeMGE00Woe]KFomGEeOoDe=Coclo?olS8b?ni^KWoZj^[
on?ShooXj>P01OoYjNT01_oXj>Sohn?Soj^[Zoni^KWobLW9olo?c`;oeMGE00Woe]KFomGEeOoDe=Co
clo?olS8b?ni^KWoZj^[on?ShooXj>P0S?oYjNT02OoXj>So`/;2o`410Oo:b/[ogMgMomkNg_oQhN7o
iNGUonSXj002onWYj@03onOWiooYjNWojNWY00_ojNWY00?oi^KVonWYjOoYjNT02?oYjNT2onOWi`05
om?Cdol0003o];BdonKVi_oXj>P00_oYjNT01ooXj>SojNWYonWYjOoXj>Soe]KFo`000?nn_[h00_oX
j>P3onWYj@03onSXj?oYjNWojNWY00SojNWY00?oinOWonWYjOoYjNT01?oYjNT00ooVi^KojNWYonWY
j@3<onWYj@03onSXj?oYjNWojNWY00CojNWY0Oo`l?01ooOgm`7oo_kn00001Oono_kon_[jooCdm?o_
knoolO7a00;ol?3`017okno_on_[jonEU9CoCb<SoiEDE?nkLg?odiFEomZLW?oJWYcofIbLomBEUOnk
Lg?oUEADodlS8onEU9Coj^[Zono_k`06oo3`l006onk^k_o;bl_oYjNWolS8b?oHf=Sohn?S0ooVi^H0
1_oShn?of=SHolS8b?nWYjOobl_;onk^kPOol?3`00Kok^k^ol_;bonWYjOob<S8omSHf?oShn<3onKV
iP06on?ShooHf=Sob<S8ojNWYoo;bl_ok^k^SOo`l?02ono_k`07odE5AOlf=SKoPh>3oe]KFomBDU;o
k^k^ono_k`0Loo3`l006ono_kooOgmoo0000okjn__o^k^kokno_1_o`l?000oo^k^ko`<30onGUi@3[
oo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn00001?ono_koooooooooooono_h2ooooo`;oo_kn0<oo
oOgmooShn?m^KVkoFSlook6@T?oNbLWol>CToo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?co
ooooookno_ooooooo_knooooo_ono_kooooooogmoOolo?coaLG5okZj^_oMgMgolO7`ooShn?oinOWo
n?Shoo7alOoMgMgo^[ZjolG5aOolo?_ooOgmooooooono_koooooookno_ooooooo_knooooo_omoOgo
o?clolG5aOnj^[[ogMgMoo7alOohn?SonOWhooShn?oalO7ogMgMokZj^_o5aLGoo?cloogmoOooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooooWinOne]KCoKFe]ohN7Qonm_Kd00_ono_h06ooooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooooP02ooknoP03onk^k_l0003o
bl_;00;oo_kn0?3oooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_h2ooooo`03ookno_oooooooooo00Cooooo00001?ogmoOoo_knoo[jn_odm?@5oo7a
l@0=ono_kooFe]KoJf][od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7a
l@0=oo3`l?oVi^Ko_Kfmok2`/?o?cloogmoOonGUiOoOgmooclo?ok2`/?nm_Kgoi^KVoo3`l009oo7a
l@0=oo3`l?oVi^Ko_Kfmok2`/?o?cloogmoOonGUiOoOgmooclo?ok2`/?nm_Kgoi^KVoo3`l02Xoo7a
l@03oo3`l?oalO7olO7a00[olO7a00?ok>c/oo3`l?oalO40k_oalO401?o`l?3olO7aoo7alOo`l?04
oo7al@03ooCdm?ojn_[oo_kn007on_[j00001Oo[jn_ooOgmooShn?o`l?3ojn_[00?oj^[Z00gojNWY
on[Zj_oYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY00coj^[Z00WojNWY
ol[:b_na/K7oWIfMoi:BT_nMWIgo/K6aol[:b_oYjNT03OoZj^X02OoYjNWob/[:ok6a/OnMWIgoTY:B
oifMWOna/K7ob/[:onWYj@3oon[Zj[3oj^[Z00Cojn_[oo3`l?ohn?SooOgm0OoWinL00004olK6a_on
o_kon_[jooCdm0SolO7a0_o`l?03ono_k`;ol?3`4OoalO43oo3`l1?olO7a0oo`l?2]oo7al@03oo3`
l?oalO7olO7a0?kolO7a00?ol?3`oo7alOoalO400_oalO400ooemOGon_[jooShn001ok^k^`0000?o
a/K6ol?3`oojn_X0ooooooo`ooooo`7oc/k>0OoDe=@00006om[Jf_no_koo]KFeonOWioogmoOoo?cl
oooooooYooooo`05ookno_ojn_[ojn_[ok^k^oo6a/H00OoRh^800001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{500, 337},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(JavaShow[frame]\), "\[IndentingNewLine]", 
    \(JavaBlock[
      ShowFileChooser["\<Save data as:\>", "\<Save\>", 
        Directory[]]]\)}], "Input"],

Cell[BoxData[
    \("/Users/jsato/MyDataFile.dat"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(JavaShow[frame]\), "\[IndentingNewLine]", 
    \(JavaBlock[
      GetFilePathAndName["\<Save data as:\>", "\<Save\>", 
        Directory[]]]\)}], "Input"],

Cell[BoxData[
    \({"/Users/jsato/MyDataFile.dat", "MyDataFile.dat"}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JColorChooser <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell["Color Chooser", "Text"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000::0001jaP00`40o`00
0?l0003oo`000?l0002<000000000hS0^4R@R4R@R03oB928odR@R8Q8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^8N8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;R7R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c?o<c<b4c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
Q<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<oiVIVOnIVIV0
VIVI0/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<
c<c<c<`0olc<c?o<c<alc<c<00>IVIW<c<c<c<`00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c7c<c<`00iVI
VLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<0?o<c<coc<c<O<c<c003VIVIc<c<c<c<00:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<alc<c<00>I
VIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c03oc<c<olc<c7c<c<`00iVIVLc<c<c<c002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0>[<c<c8oooob<c<c003
VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>I
VIW<c<c<c<`0j/c<c<Soooo8c<c<00>IVIW<c<c<c<`00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03Zc<c<1Oooo`<cc007
oooo0c?<00[oool3<l`01oooo`03<l`0oooooooo00;oool2<l`02?ooo`8c
c00=oooo00<cc03oooooool00oooo`8cc007oooo00<cc03oooooool01?oo
o`03<l`0oooooooo00_oool3<l`01oooo`<cc00:oooo0c?<00Ooool00c?<
0?ooooooo`02oooo0S?<00Soool2<l`03Oooo`03<l`0oooooooo00?oool2
<l`01oooo`03<l`0oooooooo00Coool00c?<0?ooooooo`08oooob<c<c003
VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>I
VIW<c<c<c<`0j/c<c0Soool00c?<0?ooooooo`07oooo0S?<00_oool2<l`0
1_ooo`07<l`0oooooooooooo<l`0oooo<l`000Woool00c?<0?ooooooo`0:
oooo00<cc03oooooool01Oooo`03<l`0oooooooo00?oool00c?<0?oooooo
o`05oooo00<cc03oooooool03_ooo`03<l`0oooooooo00Ooool2<l`02ooo
o`8cc006oooo00Lcc03ooooooooooolcc03ooolcc0002Oooo`03<l`0oooo
oooo00[oool00c?<0?ooooooo`05oooo00<cc03oooooool00oooo`03<l`0
oooooooo00Goool00c?<0?ooooooo`08oooob<c<c003VIVIc<c<c<c<00:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0j/c<
c0Woool00c?<0?ooooooo`08oooo00<cc03oooooool02_ooo`03<l`0oooo
oooo00?oool01C?<0?oooooooooooc?<0002oooo00<cc03oooooool01ooo
o`03<l`0oooooooo00Woool00c?<0?ooooooo`06oooo00Dcc03ooooooooo
oolcc0002?ooo`03<l`0oooooooo00ooool00c?<0?ooooooo`08oooo00<c
c03oooooool02_ooo`03<l`0oooooooo00?oool01C?<0?oooooooooooc?<
0002oooo00<cc03oooooool01oooo`03<l`0oooooooo00Woool00c?<0?oo
ooooo`06oooo00Dcc03ooooooooooolcc0002?ooo`03<l`0oooooooo00So
ooo8c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00iVIVLc<c<c<c02@c<c<6C?<00G<c<`Ioooo1Lc<c1T00005c<c<
2Oooo`03<l`0oooooooo00Woool00c?<0?ooooooo`0:oooo00<cc03ooooo
ool00oooo`04<l`0oooooooo<l`00oooo`03<l`0oooooooo00Koool00c?<
0?ooooooo`09oooo00<cc03oooooool01oooo`03<l`0oooo<l`000Woool0
0c?<0?ooooooo`0?oooo00<cc03oooooool02Oooo`03<l`0oooooooo00[o
ool00c?<0?ooooooo`03oooo00@cc03ooooooolcc003oooo00<cc03ooooo
ool01_ooo`03<l`0oooooooo00Woool00c?<0?ooooooo`07oooo00<cc03o
oolcc0002Oooo`03<l`0oooooooo00Soooo8c<c<00>IVIW<c<c<c<`00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02@c<c<
6C?<00G<c<`Ioooo1Lc<c1T00005c<c<1?ooo`03<l`0oooooooo00;oool0
0c?<0?ooooooo`0:oooo00<cc03oooooool02Oooo`03<l`0oooooooo00?o
ool013?<0?oooooooc?<00Coool00c?<0?ooooooo`05oooo00<cc03ooooo
ool00oooo`/cc006oooo00<cc03oooooool02?ooo`03<l`0oooooooo00[o
ool00c?<0?ooooooo`02oooo00<cc03oooooool02_ooo`03<l`0oooooooo
00Woool00c?<0?ooooooo`03oooo00@cc03ooooooolcc004oooo00<cc03o
ooooool01Oooo`03<l`0oooooooo00?oool;<l`01_ooo`03<l`0oooooooo
00Soool00c?<0?ooooooo`08oooo1Lc<c38cc02Ac<c<00>IVIW<c<c<c<`0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02@
c<c<6C?<00G<c<`Ioooo1Lc<c1T00005c<c<1?ooo`03<l`0oooooooo00;o
ool00c?<0?ooooooo`0;oooo00<cc03oooooool02Oooo`03<l`0oooooooo
00;oool013?<0?oooooooc?<00Coool00c?<0?ooooooo`05oooo00<cc03o
ooooool02?ooo`03<l`0oooooooo00[oool00c?<0?ooooooo`07oooo00<c
c03oooooool00S?<00Soool00c?<0?ooooooo`02oooo00<cc03oooooool0
2oooo`03<l`0oooooooo00Woool00c?<0?ooooooo`02oooo00@cc03ooooo
oolcc004oooo00<cc03oooooool01Oooo`03<l`0oooooooo00Soool00c?<
0?ooooooo`0:oooo00<cc03oooooool01oooo`03<l`0oooooooo008cc006
oooo1Lc<c38cc02Ac<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02@c<c<6C?<00G<c<`Ioooo1Lc<
c1T00005c<c<1?ooo`03<l`0oooooooo00;oool00c?<0?ooooooo`0;oooo
00<cc03oooooool02Oooo`03<l`0oooooooo00;oool013?<0?oooooooc?<
00Ooool:<l`01_ooo`03<l`0oooooooo00[oool00c?<0?ooooooo`07oooo
0c?<00[oool00c?<0?ooooooo`02oooo00<cc03oooooool02oooo`03<l`0
oooooooo00Woool00c?<0?ooooooo`02oooo00@cc03ooooooolcc007oooo
2S?<00Koool00c?<0?ooooooo`0:oooo00<cc03oooooool01oooo`<cc008
oooo1Lc<c38cc02Ac<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02@c<c<6C?<00G<c<`Ioooo1Lc<
c1T00005c<c<0_ooo`/cc00:oooo00@cc03oooooooooool9<l`01?ooo`04
<l`0oooooooo<l`04oooo`Tcc009oooo00<cc03oooooool01_ooo`03<l`0
oooooooo00Soool;<l`02_ooo`04<l`0oooooooooooo2C?<00Coool013?<
0?oooooooc?<01?oool9<l`02Oooo`03<l`0oooooooo00Koool00c?<0?oo
ooooo`08oooo1Lc<c38cc02Ac<c<00>IVIW<c<c<c<`00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02@c<c<6C?<00G<c<`5
oooo3c?<00Goool5c<c<1@0000lcc00500001Lc<c0Coool00c?<0?oooooo
o`02oooo00<cc03oooooool01Oooo`03<l`0oooooooo00ooool00c?<0?oo
ooooo`02oooo00@cc03ooooooolcc00Goooo00<cc03oooooool02oooo`03
<l`0oooooooo00Koool00c?<0?ooooooo`0:oooo00<cc03oooooool00_oo
o`03<l`0oooooooo00Goool00c?<0?ooooooo`0?oooo00<cc03oooooool0
0_ooo`04<l`0oooooooo<l`05oooo`03<l`0oooooooo00_oool00c?<0?oo
ooooo`06oooo00<cc03oooooool02?ooo`G<c<`b<l`0TLc<c003VIVIc<c<
c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<
c<`0T<c<c1Tcc005c<c<1Oooo`lcc005oooo1Lc<c0D0000?<l`01@0000G<
c<`4oooo00<cc03oooooool00_ooo`03<l`0oooooooo00?oool2<l`04Ooo
o`03<l`0oooo<l`000Koool00c?<0?ooooooo`06oooo23?<00Ooool00c?<
0?ooooooo`05oooo1c?<00Soool00c?<0?ooooooo`0:oooo00<cc03ooooo
ool00_ooo`03<l`0oooooooo00?oool2<l`04Oooo`03<l`0oooo<l`000Ko
ool00c?<0?ooooooo`06oooo23?<00Ooool00c?<0?ooooooo`05oooo1c?<
00Soool00c?<0?ooooooo`08oooo1Lc<c38cc02Ac<c<00>IVIW<c<c<c<`0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02@
c<c<6C?<00G<c<`5oooo3c?<00Goool5c<c<1@0000lcc00500001Lc<c2?o
ool00c?<0?ooooooo`0Moooo00<cc03oooooool05?ooo`03<l`0oooooooo
02Woool00c?<0?ooooooo`0Moooo00<cc03oooooool05?ooo`03<l`0oooo
oooo00Soool5c<c<<S?<097<c<`00iVIVLc<c<c<c002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<093<c<`I<l`01Lc<c0Go
ool?<l`01Oooo`G<c<`500003c?<00D00005c<c<b?ooo`G<c<`b<l`0TLc<
c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00>IVIW<c<c<c<`0T<c<c1Tcc005c<c<1Oooo`lcc005oooo1Lc<c0D0000?
<l`01@0000G<c<c8oooo1Lc<c38cc02Ac<c<00>IVIW<c<c<c<`00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02@c<c<6C?<
00G<c<`5oooo3c?<00Goool5c<c<1@0000lcc00500001Lc<c<Soool5c<c<
<S?<097<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<093<c<`I<l`01Lc<c0Goool?<l`01Oooo`G<
c<`500003c?<00D00005c<c<b?ooo`G<c<`b<l`0TLc<c003VIVIc<c<c<c<
00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0
T<c<c1Tcc005c<c<1Oooo`lcc005oooo1Lc<c0D0000?<l`01@0000G<c<c8
oooo1Lc<c38cc02Ac<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02@c<c<6C?<00G<c<`5oooo3c?<
00Goool5c<c<1@0000lcc0050000d/c<c38cc02Ac<c<00>IVIW<c<c<c<`0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02@
c<c<6C?<00G<c<`5oooo3c?<00Goool5c<c<1@0000lcc0050000d/c<c38c
c02Ac<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00iVIVLc<c<c<c02@c<c<6C?<00G<c<`5oooo3c?<00Goool5c<c<
1@0000lcc0050000d/c<c38cc02Ac<c<00>IVIW<c<c<c<`00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02@c<c<6C?<00G<
c<`5oooo3c?<00Goool5c<c<1@0000lcc00500001Lc<c<Pcc005c<c<<S?<
097<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<093<c<`I<l`01Lc<c0Goool?<l`01Oooo`G<c<`5
00003c?<00D00005c<c<b3?<00G<c<`b<l`0TLc<c003VIVIc<c<c<c<00:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0T<c<
c1Tcc005c<c<1Oooo`lcc005oooo1Lc<c0D0000?<l`01@0000G<c<`5<l`0
0`0000Lcc00300002S?<00<00007<l`000<0000cc00cc0000S?<00800008
<l`00P0000dcc0000`0003?<03?<0003<l`00P0000Lcc0000`0003?<03?<
0004<l`000<0000cc00cc0002c?<00<00007<l`00`0000Xcc00300001c?<
00030000<l`0<l`0008cc002000023?<0080000=<l`000<0000cc00cc000
0c?<00800007<l`000<0000cc00cc00013?<00030000<l`0<l`000Pcc005
c<c<<S?<097<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c003VIVIc<c<c<c<093<c<`I<l`01Lc<c0Goool?<l`01Ooo
o`G<c<`500003c?<00D00005c<c<23?<00030000<l`0<l`000Lcc0020000
2c?<00800006<l`000L0000cc00cc00cc000000cc00000002C?<00030000
<l`0<l`000Xcc0000`0003?<03?<0005<l`000<0000cc00cc0000c?<0003
0000<l`0<l`000Dcc0000`0003?<03?<000><l`000<0000cc00cc0001c?<
0080000;<l`00P0000Hcc0001`0003?<03?<03?<000003?<00000009<l`0
00<0000cc00cc0002S?<00030000<l`0<l`000Dcc0000`0003?<03?<0003
<l`000<0000cc00cc0001C?<00030000<l`0<l`000Pcc005c<c<<S?<097<
c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<093<c<`I<l`01Lc<c1Woool5c<c<6@0000G<c<`9<l`0
00<0000cc00cc00023?<00030000<l`0<l`000Xcc0000`0003?<03?<0003
<l`000D0000cc00cc00cc00000000S?<00030000<l`0<l`000Lcc0000`00
03?<03?<0009<l`000<0000cc00cc0001S?<00050000<l`0<l`0<l`00000
00Pcc0000`0003?<03?<000?<l`000<0000cc00cc00023?<00030000<l`0
<l`000Xcc0000`0003?<03?<0003<l`000D0000cc00cc00cc00000000S?<
00030000<l`0<l`000Lcc0000`0003?<03?<0009<l`000<0000cc00cc000
1S?<00050000<l`0<l`0<l`0000000Pcc0000`0003?<03?<0008<l`01Lc<
c38cc02Ac<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00iVIVLc<c<c<c02@c<c<6C?<00G<c<`Ioooo1Lc<c1T00005
c<c<2C?<00030000<l`0<l`000Tcc0000`0003?<03?<000:<l`000<0000c
c00cc0000c?<00040000<l`0<l`000000c?<00030000<l`0<l`000Hcc000
0`0003?<03?<0009<l`000<0000cc00cc0001c?<00030000<l`0000000Tc
c0000`0003?<03?<000?<l`000<0000cc00cc0002C?<00030000<l`0<l`0
00Xcc0000`0003?<03?<0003<l`000@0000cc00cc0000003<l`000<0000c
c00cc0001S?<00030000<l`0<l`000Tcc0000`0003?<03?<0007<l`000<0
000cc00000002C?<00030000<l`0<l`000Pcc005c<c<<S?<097<c<`00iVI
VLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<093<c<`I<l`01Lc<c1Woool5c<c<6@0000G<c<`4<l`000<0000c
c00cc0000S?<00030000<l`0<l`000Xcc0000`0003?<03?<0009<l`000<0
000cc00cc0000c?<00040000<l`0<l`0000013?<00030000<l`0<l`000Dc
c0000`0003?<03?<0003<l`02`0000Hcc0000`0003?<03?<0008<l`000<0
000cc00cc0002S?<00030000<l`0<l`0008cc0000`0003?<03?<000:<l`0
00<0000cc00cc0002C?<00030000<l`0<l`000<cc000100003?<03?<0000
00@cc0000`0003?<03?<0005<l`000<0000cc00cc0000c?<00/00006<l`0
00<0000cc00cc00023?<00030000<l`0<l`000Pcc005c<c<<S?<097<c<`0
0iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
VIVIc<c<c<c<093<c<`I<l`01Lc<c1Woool5c<c<6@0000G<c<`4<l`000<0
000cc00cc0000S?<00030000<l`0<l`000/cc0000`0003?<03?<0009<l`0
00<0000cc00cc0000S?<00040000<l`0<l`0000013?<00030000<l`0<l`0
00Dcc0000`0003?<03?<0008<l`000<0000cc00cc0002S?<00030000<l`0
<l`000Lcc0000`0003?<03?<0002000023?<00030000<l`0<l`0008cc000
0`0003?<03?<000;<l`000<0000cc00cc0002C?<00030000<l`0<l`0008c
c000100003?<03?<000000@cc0000`0003?<03?<0005<l`000<0000cc00c
c00023?<00030000<l`0<l`000Xcc0000`0003?<03?<0007<l`000<0000c
c00cc0000P0000Hcc005c<c<<S?<097<c<`00iVIVLc<c<c<c002R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<093<c<`I<l`0
1Lc<c1Woool5c<c<6@0000G<c<`4<l`000<0000cc00cc0000S?<00030000
<l`0<l`000/cc0000`0003?<03?<0009<l`000<0000cc00cc0000S?<0004
0000<l`0<l`000001c?<00X00006<l`000<0000cc00cc0002S?<00030000
<l`0<l`000Lcc00300002S?<00030000<l`0<l`0008cc0000`0003?<03?<
000;<l`000<0000cc00cc0002C?<00030000<l`0<l`0008cc000100003?<
03?<000000Lcc00:00001S?<00030000<l`0<l`000Xcc0000`0003?<03?<
0007<l`00`0000Pcc005c<c<<S?<097<c<`00iVIVLc<c<c<c002R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0>[<c<`2<l`0
2`0000Xcc000100003?<03?<03?<00T00004<l`000@0000cc00cc000000C
<l`02@0000Tcc0000`0003?<03?<0006<l`000<0000cc00cc00023?<00/0
000:<l`000@0000cc00cc00cc009000013?<00040000<l`0<l`000004c?<
00T00009<l`000<0000cc00cc0001S?<00030000<l`0<l`000Pcc005c<c<
<S?<097<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<0>[<c<`4<l`000<0000cc00cc0000S?<0003
0000<l`0<l`000Dcc0000`0003?<03?<000?<l`000<0000cc00cc0000S?<
00040000<l`0<l`000005c?<00030000<l`0<l`000/cc0000`0003?<03?<
0006<l`000<0000cc00cc0002S?<00030000<l`0<l`0008cc0000`0003?<
03?<0005<l`000<0000cc00cc0003c?<00030000<l`0<l`0008cc0001000
03?<03?<000001Lcc0000`0003?<03?<000;<l`000<0000cc00cc0001S?<
00030000<l`0<l`000Pcc005c<c<<S?<097<c<`00iVIVLc<c<c<c002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0>[<c<`4
<l`000<0000cc00cc0000S?<00030000<l`0<l`000<cc00200004C?<0003
0000<l`0000000Hcc0000`0003?<03?<0006<l`0200000Lcc0000`0003?<
03?<0005<l`01`0000Pcc0000`0003?<03?<000:<l`000<0000cc00cc000
0S?<00030000<l`0<l`000<cc00200004C?<00030000<l`0000000Hcc000
0`0003?<03?<0006<l`0200000Lcc0000`0003?<03?<0005<l`01`0000Pc
c0000`0003?<03?<0008<l`01Lc<c38cc02Ac<c<00>IVIW<c<c<c<`00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03Zc<c<
8c?<00030000<l`0<l`001dcc0000`0003?<03?<000D<l`000<0000cc00c
c000:C?<00030000<l`0<l`001dcc0000`0003?<03?<000D<l`000<0000c
c00cc00023?<00G<c<`booooTLc<c003VIVIc<c<c<c<00:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0j/c<c<Pcc005c<c<
<_oooi7<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003VIVIc<c<c<c<093<c<`Ioooo1Lc<c1T00005c<c<6Oooo`G<
c<c8<l`01Lc<c3;ooonAc<c<00>IVIW<c<c<c<`00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02@c<c<6Oooo`G<c<`I0000
1Lc<c1Woool5c<c<b3?<00G<c<`booooTLc<c003VIVIc<c<c<c<00:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0T<c<c1Wo
ool5c<c<6@0000G<c<`Ioooo1Lc<c<Pcc005c<c<<_oooi7<c<`00iVIVLc<
c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<
c<c<093<c<`Ioooo1Lc<c1T00005c<c<6Oooo`G<c<c8<l`01Lc<c3;ooonA
c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c02@c<c<6Oooo`G<c<`I00001Lc<c1WooooBc<c<<_oo
oi7<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<093<c<`5oooo3c?<00Goool5c<c<1@0000lcc005
00001Lc<c0Goool?<l`01Oooom;<c<`booooTLc<c003VIVIc<c<c<c<00:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0T<c<
c0Goool?<l`01Oooo`G<c<`500003c?<00D00005c<c<1Oooo`lcc005oooo
d/c<c3;ooonAc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c02@c<c<1Oooo`lcc005oooo1Lc<c0D0
000?<l`01@0000G<c<`5oooo3c?<00GooooBc<c<<_oooi7<c<`00iVIVLc<
c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<
c<c<093<c<`5oooo3c?<00Goool5c<c<1@0000lcc00500001Lc<c0Goool?
<l`01Oooom;<c<`booooTLc<c003VIVIc<c<c<c<00:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0T<c<c0Goool?<l`01Ooo
o`G<c<`500003c?<00D00005c<c<1Oooo`lcc005oooo2/c<c0<cc007c<c<
0c?<00[<c<`3<l`01lc<c003<l`0c<c<c<c<00;<c<`2<l`02<c<c08cc00=
c<c<00<cc03<c<c<c<`00lc<c08cc007c<c<00<cc03<c<c<c<`01<c<c003
<l`0c<c<c<c<00_<c<`3<l`01lc<c0<cc00:c<c<0c?<00O<c<`00c?<0<c<
c<c<c002c<c<0S?<00S<c<`2<l`03Lc<c003<l`0c<c<c<c<00?<c<`2<l`0
1lc<c003<l`0c<c<c<c<00C<c<`00c?<0<c<c<c<c00=c<c<<_oooi7<c<`0
0iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
VIVIc<c<c<c<093<c<`5oooo1C?<00Goool5<l`01Oooo`G<c<`500001C?<
00Goool5<l`01@0000G<c<`5oooo1C?<00D00005<l`01Oooo`g<c<`00c?<
0<c<c<c<c007c<c<0S?<00_<c<`2<l`01/c<c007<l`0c<c<c<c<c<c<<l`0
c<c<<l`000W<c<`00c?<0<c<c<c<c00:c<c<00<cc03<c<c<c<`01Lc<c003
<l`0c<c<c<c<00?<c<`00c?<0<c<c<c<c005c<c<00<cc03<c<c<c<`03/c<
c003<l`0c<c<c<c<00O<c<`2<l`02lc<c08cc006c<c<00Lcc03<c<c<c<c<
c<`cc03<c<`cc0002Lc<c003<l`0c<c<c<c<00[<c<`00c?<0<c<c<c<c005
c<c<00<cc03<c<c<c<`00lc<c003<l`0c<c<c<c<00G<c<`00c?<0<c<c<c<
c00=c<c<<_oooi7<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003VIVIc<c<c<c<093<c<`5oooo1C?<00Goool5<l`0
1Oooo`G<c<`500001C?<00Goool5<l`01@0000G<c<`5oooo1C?<00D00005
<l`01Oooo`k<c<`00c?<0<c<c<c<c008c<c<00<cc03<c<c<c<`02/c<c003
<l`0c<c<c<c<00?<c<`01C?<0<c<c<c<c<c<c3?<0002c<c<00<cc03<c<c<
c<`01lc<c003<l`0c<c<c<c<00W<c<`00c?<0<c<c<c<c006c<c<00Dcc03<
c<c<c<c<c<`cc0002<c<c003<l`0c<c<c<c<00o<c<`00c?<0<c<c<c<c008
c<c<00<cc03<c<c<c<`02/c<c003<l`0c<c<c<c<00?<c<`01C?<0<c<c<c<
c<c<c3?<0002c<c<00<cc03<c<c<c<`01lc<c003<l`0c<c<c<c<00W<c<`0
0c?<0<c<c<c<c006c<c<00Dcc03<c<c<c<c<c<`cc0002<c<c003<l`0c<c<
c<c<00g<c<`booooTLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0T<c<c0Goool5<l`01Oooo`Dc
c005oooo1Lc<c0D00005<l`01Oooo`Dcc00500001Lc<c0Goool5<l`01@00
00Dcc005oooo3/c<c003<l`0c<c<c<c<00W<c<`00c?<0<c<c<c<c00:c<c<
00<cc03<c<c<c<`00lc<c004<l`0c<c<c<c<<l`00lc<c003<l`0c<c<c<c<
00K<c<`00c?<0<c<c<c<c009c<c<00<cc03<c<c<c<`01lc<c003<l`0c<c<
<l`000W<c<`00c?<0<c<c<c<c00?c<c<00<cc03<c<c<c<`02Lc<c003<l`0
c<c<c<c<00[<c<`00c?<0<c<c<c<c003c<c<00@cc03<c<c<c<`cc003c<c<
00<cc03<c<c<c<`01/c<c003<l`0c<c<c<c<00W<c<`00c?<0<c<c<c<c007
c<c<00<cc03<c<`cc0002Lc<c003<l`0c<c<c<c<00g<c<`booooTLc<c003
VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>I
VIW<c<c<c<`0T<c<c0Goool5<l`01Oooo`Dcc005oooo1Lc<c0D00005<l`0
1Oooo`Dcc00500001Lc<c0Goool5<l`01@0000Dcc005oooo2Lc<c003<l`0
c<c<c<c<00;<c<`00c?<0<c<c<c<c00:c<c<00<cc03<c<c<c<`02Lc<c003
<l`0c<c<c<c<00?<c<`013?<0<c<c<c<c3?<00C<c<`00c?<0<c<c<c<c005
c<c<00<cc03<c<c<c<`00lc<c0/cc006c<c<00<cc03<c<c<c<`02<c<c003
<l`0c<c<c<c<00[<c<`00c?<0<c<c<c<c002c<c<00<cc03<c<c<c<`02/c<
c003<l`0c<c<c<c<00W<c<`00c?<0<c<c<c<c003c<c<00@cc03<c<c<c<`c
c004c<c<00<cc03<c<c<c<`01Lc<c003<l`0c<c<c<c<00?<c<`;<l`01/c<
c003<l`0c<c<c<c<00S<c<`00c?<0<c<c<c<c00=c<c<<_oooi7<c<`00iVI
VLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<093<c<`5oooo1C?<00Goool5<l`01Oooo`G<c<`500001C?<00Go
ool5<l`01@0000G<c<`5oooo1C?<00D00005<l`01Oooo`W<c<`00c?<0<c<
c<c<c002c<c<00<cc03<c<c<c<`02lc<c003<l`0c<c<c<c<00W<c<`00c?<
0<c<c<c<c002c<c<00@cc03<c<c<c<`cc004c<c<00<cc03<c<c<c<`01Lc<
c003<l`0c<c<c<c<00S<c<`00c?<0<c<c<c<c00:c<c<00<cc03<c<c<c<`0
1lc<c003<l`0c<c<c<c<008cc008c<c<00<cc03<c<c<c<`00/c<c003<l`0
c<c<c<c<00_<c<`00c?<0<c<c<c<c009c<c<00<cc03<c<c<c<`00/c<c004
<l`0c<c<c<c<<l`01<c<c003<l`0c<c<c<c<00G<c<`00c?<0<c<c<c<c008
c<c<00<cc03<c<c<c<`02/c<c003<l`0c<c<c<c<00O<c<`00c?<0<c<c<c<
c002<l`02lc<c3;ooonAc<c<00>IVIW<c<c<c<`00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02@c<c<1Oooo`lcc005oooo
1Lc<c0D0000?<l`01@0000G<c<`5oooo3c?<00Goool9c<c<00<cc03<c<c<
c<`00/c<c003<l`0c<c<c<c<00_<c<`00c?<0<c<c<c<c009c<c<00<cc03<
c<c<c<`00/c<c004<l`0c<c<c<c<<l`01lc<c0Xcc006c<c<00<cc03<c<c<
c<`02/c<c003<l`0c<c<c<c<00O<c<`3<l`02/c<c003<l`0c<c<c<c<00;<
c<`00c?<0<c<c<c<c00;c<c<00<cc03<c<c<c<`02Lc<c003<l`0c<c<c<c<
00;<c<`013?<0<c<c<c<c3?<00O<c<`:<l`01/c<c003<l`0c<c<c<c<00[<
c<`00c?<0<c<c<c<c007c<c<0c?<00g<c<`booooTLc<c003VIVIc<c<c<c<
00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0
T<c<c0Goool?<l`01Oooo`G<c<`500003c?<00D00005c<c<1Oooo`lcc005
oooo1lc<c0/cc00:c<c<00@cc03<c<c<c<c<c<`9<l`01<c<c004<l`0c<c<
c<c<<l`04lc<c0Tcc009c<c<00<cc03<c<c<c<`01/c<c003<l`0c<c<c<c<
00S<c<`;<l`02/c<c004<l`0c<c<c<c<c<c<2C?<00C<c<`013?<0<c<c<c<
c3?<01?<c<`9<l`02Lc<c003<l`0c<c<c<c<00K<c<`00c?<0<c<c<c<c00=
c<c<<_oooi7<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c003VIVIc<c<c<c<093<c<`5oooo3c?<00Goool5c<c<1@00
00lcc00500001Lc<c0Goool?<l`01Oooo`W<c<`00c?<0<c<c<c<c002c<c<
00<cc03<c<c<c<`01Lc<c003<l`0c<c<c<c<00o<c<`00c?<0<c<c<c<c002
c<c<00@cc03<c<c<c<`cc00Gc<c<00<cc03<c<c<c<`02lc<c003<l`0c<c<
c<c<00K<c<`00c?<0<c<c<c<c00:c<c<00<cc03<c<c<c<`00/c<c003<l`0
c<c<c<c<00G<c<`00c?<0<c<c<c<c00?c<c<00<cc03<c<c<c<`00/c<c004
<l`0c<c<c<c<<l`05lc<c003<l`0c<c<c<c<00_<c<`00c?<0<c<c<c<c006
c<c<00<cc03<c<c<c<`03Lc<c3;ooonAc<c<00>IVIW<c<c<c<`00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02@c<c<1Ooo
o`lcc005oooo1Lc<c0D0000?<l`01@0000G<c<`5oooo3c?<00Goool9c<c<
00<cc03<c<c<c<`00/c<c003<l`0c<c<c<c<00?<c<`2<l`04Lc<c003<l`0
c<c<<l`000K<c<`00c?<0<c<c<c<c006c<c<23?<00O<c<`00c?<0<c<c<c<
c005c<c<1c?<00S<c<`00c?<0<c<c<c<c00:c<c<00<cc03<c<c<c<`00/c<
c003<l`0c<c<c<c<00?<c<`2<l`04Lc<c003<l`0c<c<<l`000K<c<`00c?<
0<c<c<c<c006c<c<23?<00O<c<`00c?<0<c<c<c<c005c<c<1c?<00S<c<`0
0c?<0<c<c<c<c00=c<c<<_oooi7<c<`00iVIVLc<c<c<c002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<093<c<`5oooo3c?<
00Goool5c<c<1@0000lcc00500001Lc<c0Goool?<l`01OooobS<c<`00c?<
0<c<c<c<c00Mc<c<00<cc03<c<c<c<`05<c<c003<l`0c<c<c<c<02W<c<`0
0c?<0<c<c<c<c00Mc<c<00<cc03<c<c<c<`05<c<c003<l`0c<c<c<c<00g<
c<`booooTLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00>IVIW<c<c<c<`0T<c<c1Woool5c<c<6@0000G<c<`Ioooo
d/c<c3;ooonAc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c02@c<c<6Oooo`G<c<`I00001Lc<c1Wo
oooBc<c<<_oooi7<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003VIVIc<c<c<c<093<c<`Ioooo1Lc<c1T00005c<c<
6Oooom;<c<`booooTLc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0T<c<c1Woool5c<c<6@0000G<
c<`Iooood/c<c3;ooonAc<c<00>IVIW<c<c<c<`00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c02@c<c<6Oooo`G<c<`I0000
1Lc<c1WooooBc<c<<_oooi7<c<`00iVIVLc<c<c<c002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<O<c<c003
VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>I
VIW<c<c<c<`0olc<c?o<c<alc<c<00>IVIW<c<c<c<`00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<olc<c7c<c<`0
0iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
VIVIc<c<c<c<0?o<c<coc<c<O<c<c003VIVIc<c<c<c<00:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c?o<c<alc<c<
00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0iVIVLc<c<c<c03oc<c<olc<c7c<c<`00iVIVLc<c<c<c002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<coc<c<O<c<
c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<
00>IVIW<c<c<c<`01/c<c0030000c<c<c<c<0?o<c<coc<c<Llc<c003VIVI
c<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<
c<c<c<`01/c<c0@00009c<c<100000S<c<`800001<c<c0T0003oc<c<olc<
c4S<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<00S<c<`300002<c<c08000001<c<c00000000000
00K<c<`200003lc<c080003oc<c<olc<c4[<c<`00iVIVLc<c<c<c002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<00[<c<`2
00001lc<c0800003c<c<0P0000G<c<`200003lc<c080003oc<c<olc<c4[<
c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<00_<c<`200001/c<c0800004c<c<0P0000C<c<`20000
3lc<c080003oc<c<olc<c4[<c<`00iVIVLc<c<c<c002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c0FIVIT9c<c<0`0000G<c<`200001Lc<c080
0003c<c<0P0000o<c<`200001Lc<c0/000000lc<c9VIVIVIV@3oVIVIoiVI
VCRIVIT2c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^17<c<`20000
1Lc<c0800005c<c<00<0003<c<c<c<`00/c<c0P00005c<c<1P000?o<c<co
c<c<CLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PAc<c<0P0000G<
c<`200002/c<c0800003c<c<0P000?o<c<coc<c<FLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P:c<c<2@0000G<c<`200002/c<c0800004c<c<
00<0003<c<c<c<`0olc<c?o<c<aGc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^17<c<`400005<c<c0@0003oc<c<olc<c5O<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h4Lc<c0@0000Dc<c<0`000?o<c<coc<c<F<c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PZc<c<00<0003<c<c<c<`0
olc<c?o<c<aGc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<co
c<c<Q<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c8C<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hofIVI_mVIVJ4IVIV0XS0
^058T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<
c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<
c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<
c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<
c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<
c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<
c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<
c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<
c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<
c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<
c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<
c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<
c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<
c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<
c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0L<c<c?l0001I0000^<c<c004IVIV
R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooo
oooo0?oooomEoooo00<0003<c<c<c<`0]/c<c004IVIVR<2hR<2hB9280@00
000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooo000000T000000ooo
o`0000000008000000?oool00000000020000003oooo0000000000P00000
0oooo`0000000008000000?oool00000000020000003oooo0000000000P0
00000oooo`0000000008000000?oool00000000020000003oooo00000000
00P000000oooo`0000000008000000?oool00000000020000003oooo0000
000000P000000oooo`0000000008000000?oool00000000020000003oooo
0000000000P000000oooo`0000000008000000?oool00000000020000003
oooo0000000000P000000oooo`0000000008000000?oool0000000002000
0003oooo0000000000P000000oooo`0000000008000000?oool000000000
20000003oooo0000000000P000000oooo`0000000008000000?oool00000
000020000003oooo0000000000P000000oooo`0000000008000000?oool0
0000000020000003oooo0000000000P000000oooo`000<c<c02gc<c<00AV
IVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0003o
ool000002@000003oooo03<c03<c00L0<c<00`000?ooo`0c<`0803<c00<0
003oool0<c<0200c<`030000oooo03<c00P0<c<00`000?ooo`0c<`0803<c
00<0003oool003<02000<`030000oooo<`0c00Pc03<00`000?oooc<0<`08
<`0c00<0003ooolc03<023<0<`030000oooo<`0c00Pc03<00`000?oooc<0
<`08<`0c00<0003ooolc03<023<0<`030000oooo<`0c00Pc03<00`000?oo
oc<0<`08<`0c00<0003ooolc03<023<0<`030000oooo<`0000Pc00000`00
0?oooc<c0008<c<000<0003ooolc<`0023<c00030000oooo<c<000Pc<`00
0`000?oooc<c0008<c<000<0003ooolc<`0023<c00030000oooo<c<000Pc
<`000`000?oooc<c0008<c<000<0003ooolc<`0023<c00030000oooo03<0
00P0<`000`000?ooo`0c<`0803<c00<0003oool0<c<0200c<`030000oooo
03<c00P0<c<00`000?ooo`0c<`0803<c00<0003ooolc<c<023<c<`030000
oooo000000[<c<`j0000M<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0L<c<c0030000oooo000000T000000oooo`0c<`0c<`07
03<c00<0003oool0<c<0200c<`030000oooo03<c00P0<c<00`000?ooo`0c
<`0803<c00<0003oool0<c<0200c<`030000oooo000c00P003<00`000?oo
oc<0<`08<`0c00<0003ooolc03<023<0<`030000oooo<`0c00Pc03<00`00
0?oooc<0<`08<`0c00<0003ooolc03<023<0<`030000oooo<`0c00Pc03<0
0`000?oooc<0<`08<`0c00<0003ooolc03<023<0<`030000oooo<`0c00Pc
03<00`000?oooc<00008<`0000<0003ooolc<`0023<c00030000oooo<c<0
00Pc<`000`000?oooc<c0008<c<000<0003ooolc<`0023<c00030000oooo
<c<000Pc<`000`000?oooc<c0008<c<000<0003ooolc<`0023<c00030000
oooo<c<000Pc<`000`000?ooo`0c000803<000<0003oool0<c<0200c<`03
0000oooo03<c00P0<c<00`000?ooo`0c<`0803<c00<0003oool0<c<0200c
<`030000oooo<c<c00Pc<c<00`000?ooo`00000:c<c<00<0003oooooool0
=_ooo`030000c<c<c<c<07;<c<`016IVIXS0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hoooo073<c<`00`000?ooo`000009000000?oool0<c<0<c<0
1`0c<`030000oooo03<c00P0<c<00`000?ooo`0c<`0803<c00<0003oool0
<c<0200c<`030000oooo03<c00P0<c<00`000?ooo`00<`08000c00<0003o
oolc03<023<0<`030000oooo<`0c00Pc03<00`000?oooc<0<`08<`0c00<0
003ooolc03<023<0<`030000oooo<`0c00Pc03<00`000?oooc<0<`08<`0c
00<0003ooolc03<023<0<`030000oooo<`0c00Pc03<00`000?oooc<0<`08
<`0c00<0003ooolc000023<000030000oooo<c<000Pc<`000`000?oooc<c
0008<c<000<0003ooolc<`0023<c00030000oooo<c<000Pc<`000`000?oo
oc<c0008<c<000<0003ooolc<`0023<c00030000oooo<c<000Pc<`000`00
0?oooc<c0008<c<000<0003oool0<`00200c00030000oooo03<c00P0<c<0
0`000?ooo`0c<`0803<c00<0003oool0<c<0200c<`030000oooo03<c00P0
<c<00`000?oooc<c<`08<c<c00<0003oool000002/c<c0030000oooo0000
00T000000oooo`0000000008000000?oool00000000020000003oooo0000
000000P000000oooo`0000000008000000?oool0003<c<`0Llc<c004IVIV
R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooo
000000T000000oooo`0c<`0c<`0703<c00<0003oool0<c<0200c<`030000
oooo03<c00P0<c<00`000?ooo`0c<`0803<c00<0003oool0<c<0200c<`03
0000oooo000c00P003<00`000?oooc<0<`08<`0c00<0003ooolc03<023<0
<`030000oooo<`0c00Pc03<00`000?oooc<0<`08<`0c00<0003ooolc03<0
23<0<`030000oooo<`0c00Pc03<00`000?oooc<0<`08<`0c00<0003ooolc
03<023<0<`030000oooo<`0c00Pc03<00`000?oooc<00008<`0000<0003o
oolc<`0023<c00030000oooo<c<000Pc<`000`000?oooc<c0008<c<000<0
003ooolc<`0023<c00030000oooo<c<000Pc<`000`000?oooc<c0008<c<0
00<0003ooolc<`0023<c00030000oooo<c<000Pc<`000`000?ooo`0c0008
03<000<0003oool0<c<0200c<`030000oooo03<c00P0<c<00`000?ooo`0c
<`0803<c00<0003oool0<c<0200c<`030000oooo<c<c00Pc<c<00`000?oo
o`00000:c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`00
0?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`0
0`000?ooo`00001dc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^?ooo`1`c<c<00<0003oool000002@000003oooo03<c03<c00L0<c<0
0`000?ooo`0c<`0803<c00<0003oool0<c<0200c<`030000oooo03<c00P0
<c<00`000?ooo`0c<`0803<c00<0003oool003<02000<`030000oooo<`0c
00Pc03<00`000?oooc<0<`08<`0c00<0003ooolc03<023<0<`030000oooo
<`0c00Pc03<00`000?oooc<0<`08<`0c00<0003ooolc03<023<0<`030000
oooo<`0c00Pc03<00`000?oooc<0<`08<`0c00<0003ooolc03<023<0<`03
0000oooo<`0000Pc00000`000?oooc<c0008<c<000<0003ooolc<`0023<c
00030000oooo<c<000Pc<`000`000?oooc<c0008<c<000<0003ooolc<`00
23<c00030000oooo<c<000Pc<`000`000?oooc<c0008<c<000<0003ooolc
<`0023<c00030000oooo03<000P0<`000`000?ooo`0c<`0803<c00<0003o
ool0<c<0200c<`030000oooo03<c00P0<c<00`000?ooo`0c<`0803<c00<0
003ooolc<c<023<c<`030000oooo000000[<c<`00`000?ooolc<c008c<c<
00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008
c<c<00<0003oooo<c<`02<c<c0030000oooo000007C<c<`016IVIXS0^8S0
^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<c<`00`000?ooo`000009
000000?oool0<c<0<c<01`0c<`030000oooo03<c00P0<c<00`000?ooo`0c
<`0803<c00<0003oool0<c<0200c<`030000oooo03<c00P0<c<00`000?oo
o`00<`08000c00<0003ooolc03<023<0<`030000oooo<`0c00Pc03<00`00
0?oooc<0<`08<`0c00<0003ooolc03<023<0<`030000oooo<`0c00Pc03<0
0`000?oooc<0<`08<`0c00<0003ooolc03<023<0<`030000oooo<`0c00Pc
03<00`000?oooc<0<`08<`0c00<0003ooolc000023<000030000oooo<c<0
00Pc<`000`000?oooc<c0008<c<000<0003ooolc<`0023<c00030000oooo
<c<000Pc<`000`000?oooc<c0008<c<000<0003ooolc<`0023<c00030000
oooo<c<000Pc<`000`000?oooc<c0008<c<000<0003oool0<`00200c0003
0000oooo03<c00P0<c<00`000?ooo`0c<`0803<c00<0003oool0<c<0200c
<`030000oooo03<c00P0<c<00`000?oooc<c<`08<c<c00<0003oool00000
2/c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<
c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003o
ool00000M<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;So
ool0L<c<c0030000oooo000000T000000oooo`0c<`0c<`0703<c00<0003o
ool0<c<0200c<`030000oooo03<c00P0<c<00`000?ooo`0c<`0803<c00<0
003oool0<c<0200c<`030000oooo000c00P003<00`000?oooc<0<`08<`0c
00<0003ooolc03<023<0<`030000oooo<`0c00Pc03<00`000?oooc<0<`08
<`0c00<0003ooolc03<023<0<`030000oooo<`0c00Pc03<00`000?oooc<0
<`08<`0c00<0003ooolc03<023<0<`030000oooo<`0c00Pc03<00`000?oo
oc<00008<`0000<0003ooolc<`0023<c00030000oooo<c<000Pc<`000`00
0?oooc<c0008<c<000<0003ooolc<`0023<c00030000oooo<c<000Pc<`00
0`000?oooc<c0008<c<000<0003ooolc<`0023<c00030000oooo<c<000Pc
<`000`000?ooo`0c000803<000<0003oool0<c<0200c<`030000oooo03<c
00P0<c<00`000?ooo`0c<`0803<c00<0003oool0<c<0200c<`030000oooo
<c<c00Pc<c<00`000?ooo`00000:c<c<00<0003oooo<c<`02<c<c0030000
ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c003
0000ooooc<c<00S<c<`00`000?ooo`00001dc<c<00AVIVJ8`;R8`;Q8T8P1
000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0003oool000002@000003
oooo03<c03<c00L0<c<00`000?ooo`0c<`0803<c00<0003oool0<c<0200c
<`030000oooo03<c00P0<c<00`000?ooo`0c<`0803<c00<0003oool003<0
2000<`030000oooo<`0c00Pc03<00`000?oooc<0<`08<`0c00<0003ooolc
03<023<0<`030000oooo<`0c00Pc03<00`000?oooc<0<`08<`0c00<0003o
oolc03<023<0<`030000oooo<`0c00Pc03<00`000?oooc<0<`08<`0c00<0
003ooolc03<023<0<`030000oooo<`0000Pc00000`000?oooc<c0008<c<0
00<0003ooolc<`0023<c00030000oooo<c<000Pc<`000`000?oooc<c0008
<c<000<0003ooolc<`0023<c00030000oooo<c<000Pc<`000`000?oooc<c
0008<c<000<0003ooolc<`0023<c00030000oooo03<000P0<`000`000?oo
o`0c<`0803<c00<0003oool0<c<0200c<`030000oooo03<c00P0<c<00`00
0?ooo`0c<`0803<c00<0003ooolc<c<023<c<`030000oooo000000[<c<`0
0`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<
c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000oooo0000
07C<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<
c<`00`000?ooo`000009000000?oool0<c<0<c<01`0c<`030000oooo03<c
00P0<c<00`000?ooo`0c<`0803<c00<0003oool0<c<0200c<`030000oooo
03<c00P0<c<00`000?ooo`00<`08000c00<0003ooolc03<023<0<`030000
oooo<`0c00Pc03<00`000?oooc<0<`08<`0c00<0003ooolc03<023<0<`03
0000oooo<`0c00Pc03<00`000?oooc<0<`08<`0c00<0003ooolc03<023<0
<`030000oooo<`0c00Pc03<00`000?oooc<0<`08<`0c00<0003ooolc0000
23<000030000oooo<c<000Pc<`000`000?oooc<c0008<c<000<0003ooolc
<`0023<c00030000oooo<c<000Pc<`000`000?oooc<c0008<c<000<0003o
oolc<`0023<c00030000oooo<c<000Pc<`000`000?oooc<c0008<c<000<0
003oool0<`00200c00030000oooo03<c00P0<c<00`000?ooo`0c<`0803<c
00<0003oool0<c<0200c<`030000oooo03<c00P0<c<00`000?oooc<c<`08
<c<c00<0003oool000002/c<c0030000ooooc<c<00S<c<`00`000?ooolc<
c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?oo
olc<c008c<c<00<0003oool00000M<c<c004IVIVR<2hR<2hB9280@000000
00F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooooooo0?oooomEoooo00<0
003<c<c<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<
00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008
c<c<00<0003oool00000M<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0L<c<c0030000oooo000000T000000oooo`0000000008
000000?oool00000000020000003oooo0000000000P000000oooo`000000
0008000000?oool00000000020000003oooo0000000000P000000oooo`00
00000008000000?oool00000000020000003oooo0000000000P000000ooo
o`0000000008000000?oool00000000020000003oooo0000000000P00000
0oooo`0000000008000000?oool00000000020000003oooo0000000000P0
00000oooo`0000000008000000?oool00000000020000003oooo00000000
00P000000oooo`0000000008000000?oool00000000020000003oooo0000
000000P000000oooo`0000000008000000?oool00000000020000003oooo
0000000000P000000oooo`0000000008000000?oool00000000020000003
oooo0000000000P000000oooo`0000000008000000?oool0000000002000
0003oooo0000000000P000000oooo`000<c<c009c<c<00<0003oooo<c<`0
2<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<
c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooo`00001dc<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0003ooolc
<c<023<c<`030000oooo06IV00P0IVH00`000?ooo`1VIP0806IV00<0003o
ool0IVH0201VIP030000oooo06IV00P0IVH00`000?ooo`0cIP0803=V00<0
003oool006H02000IP030000oooo<`1V00Pc06H00`000?ooofH0IP08IP1V
00<0003ooomV06H026H0IP030000ooooIP1V00QV06H00`000?ooofH0IP08
IP1V00<0003ooomV06H026H0IP030000ooooIP1V00QV06H00`000?ooofH0
IP08IP1V00<0003ooomV03<026H0<`030000ooooIP0000QV00000`000?oo
ofHc0008IS<000<0003ooomVIP0026IV00030000ooooIVH000QVIP000`00
0?ooofIV0008IVH000<0003ooomVIP0026IV00030000ooooIVH000QVIP00
0`000?ooofIV0008IVH000<0003ooomVIP0026IV00030000oooo<fH000Pc
IP000`000?ooo`1V000806H000<0003oool0IS<0201V<`030000oooo06IV
00P0IVH00`000?ooo`1VIP0806IV00<0003oool0IVH0201VIP030000oooo
000000[<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000
ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c003
0000oooo000007C<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo073<c<`00`000?oooc<c<`08<c<c00<0003oool0IVH0201VIP03
0000oooo06IV00P0IVH00`000?ooo`1VIP0806IV00<0003oool0IVH0201V
IP030000oooo03=V00P0<fH00`000?ooo`00IP08001V00<0003ooolc06H0
23<0IP030000ooooIP1V00QV06H00`000?ooofH0IP08IP1V00<0003ooomV
06H026H0IP030000ooooIP1V00QV06H00`000?ooofH0IP08IP1V00<0003o
oomV06H026H0IP030000ooooIP1V00QV06H00`000?ooofH0<`08IP0c00<0
003ooomV000026H000030000ooooIS<000QV<`000`000?ooofIV0008IVH0
00<0003ooomVIP0026IV00030000ooooIVH000QVIP000`000?ooofIV0008
IVH000<0003ooomVIP0026IV00030000ooooIVH000QVIP000`000?ooofIV
0008IVH000<0003ooolcIP0023=V00030000oooo06H000P0IP000`000?oo
o`1V<`0806Hc00<0003oool0IVH0201VIP030000oooo06IV00P0IVH00`00
0?ooo`1VIP0806IV00<0003oool000002/c<c0030000oooooooo03Koool0
0`000<c<c<c<c01bc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^?ooo`1`c<c<00<0003ooolc<c<023<c<`030000oooo06IV00P0IVH0
0`000?ooo`1VIP0806IV00<0003oool0IVH0201VIP030000oooo06IV00P0
IVH00`000?ooo`0cIP0803=V00<0003oool006H02000IP030000oooo<`1V
00Pc06H00`000?ooofH0IP08IP1V00<0003ooomV06H026H0IP030000oooo
IP1V00QV06H00`000?ooofH0IP08IP1V00<0003ooomV06H026H0IP030000
ooooIP1V00QV06H00`000?ooofH0IP08IP1V00<0003ooomV03<026H0<`03
0000ooooIP0000QV00000`000?ooofHc0008IS<000<0003ooomVIP0026IV
00030000ooooIVH000QVIP000`000?ooofIV0008IVH000<0003ooomVIP00
26IV00030000ooooIVH000QVIP000`000?ooofIV0008IVH000<0003ooomV
IP0026IV00030000oooo<fH000PcIP000`000?ooo`1V000806H000<0003o
ool0IS<0201V<`030000oooo06IV00P0IVH00`000?ooo`1VIP0806IV00<0
003oool0IVH0201VIP030000oooo000000[<c<`00`000?ooo`0000090000
00?oool00000000020000003oooo0000000000P000000oooo`0000000008
000000?oool00000000020000003oooo0000c<c<07?<c<`016IVIXS0^8S0
^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<c<`00`000?oooc<c<`08
<c<c00<0003oool0IVH0201VIP030000oooo06IV00P0IVH00`000?ooo`1V
IP0806IV00<0003oool0IVH0201VIP030000oooo03=V00P0<fH00`000?oo
o`00IP08001V00<0003ooolc06H023<0IP030000ooooIP1V00QV06H00`00
0?ooofH0IP08IP1V00<0003ooomV06H026H0IP030000ooooIP1V00QV06H0
0`000?ooofH0IP08IP1V00<0003ooomV06H026H0IP030000ooooIP1V00QV
06H00`000?ooofH0<`08IP0c00<0003ooomV000026H000030000ooooIS<0
00QV<`000`000?ooofIV0008IVH000<0003ooomVIP0026IV00030000oooo
IVH000QVIP000`000?ooofIV0008IVH000<0003ooomVIP0026IV00030000
ooooIVH000QVIP000`000?ooofIV0008IVH000<0003ooolcIP0023=V0003
0000oooo06H000P0IP000`000?ooo`1V<`0806Hc00<0003oool0IVH0201V
IP030000oooo06IV00P0IVH00`000?ooo`1VIP0806IV00<0003oool00000
2/c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<
c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003o
ool00000M<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;So
ool0L<c<c0030000oooo<c<c00Pc<c<00`000?ooo`1VIP0806IV00<0003o
ool0IVH0201VIP030000oooo06IV00P0IVH00`000?ooo`1VIP0806IV00<0
003oool0<fH0200cIP030000oooo001V00P006H00`000?oooc<0IP08<`1V
00<0003ooomV06H026H0IP030000ooooIP1V00QV06H00`000?ooofH0IP08
IP1V00<0003ooomV06H026H0IP030000ooooIP1V00QV06H00`000?ooofH0
IP08IP1V00<0003ooomV06H026H0IP030000ooooIP0c00QV03<00`000?oo
ofH00008IP0000<0003ooomV<`0026Hc00030000ooooIVH000QVIP000`00
0?ooofIV0008IVH000<0003ooomVIP0026IV00030000ooooIVH000QVIP00
0`000?ooofIV0008IVH000<0003ooomVIP0026IV00030000ooooIVH000QV
IP000`000?oooc=V0008<fH000<0003oool0IP00201V00030000oooo06Hc
00P0IS<00`000?ooo`1VIP0806IV00<0003oool0IVH0201VIP030000oooo
06IV00P0IVH00`000?ooo`00000:c<c<00<0003oooo<c<`02<c<c0030000
ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c003
0000ooooc<c<00S<c<`00`000?ooo`00001dc<c<00AVIVJ8`;R8`;Q8T8P1
000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0003ooolc<c<023<c<`03
0000oooo06IV00P0IVH00`000?ooo`1VIP0806IV00<0003oool0IVH0201V
IP030000oooo06IV00P0IVH00`000?ooo`0cIP0803=V00<0003oool006H0
2000IP030000oooo<`1V00Pc06H00`000?ooofH0IP08IP1V00<0003ooomV
06H026H0IP030000ooooIP1V00QV06H00`000?ooofH0IP08IP1V00<0003o
oomV06H026H0IP030000ooooIP1V00QV06H00`000?ooofH0IP08IP1V00<0
003ooomV03<026H0<`030000ooooIP0000QV00000`000?ooofHc0008IS<0
00<0003ooomVIP0026IV00030000ooooIVH000QVIP000`000?ooofIV0008
IVH000<0003ooomVIP0026IV00030000ooooIVH000QVIP000`000?ooofIV
0008IVH000<0003ooomVIP0026IV00030000oooo<fH000PcIP000`000?oo
o`1V000806H000<0003oool0IS<0201V<`030000oooo06IV00P0IVH00`00
0?ooo`1VIP0806IV00<0003oool0IVH0201VIP030000oooo000000[<c<`0
0`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<
c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000oooo0000
07C<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<
c<`00`000?oooc<c<`08<c<c00<0003oool0IVH0201VIP030000oooo06IV
00P0IVH00`000?ooo`1VIP0806IV00<0003oool0IVH0201VIP030000oooo
03=V00P0<fH00`000?ooo`00IP08001V00<0003ooolc06H023<0IP030000
ooooIP1V00QV06H00`000?ooofH0IP08IP1V00<0003ooomV06H026H0IP03
0000ooooIP1V00QV06H00`000?ooofH0IP08IP1V00<0003ooomV06H026H0
IP030000ooooIP1V00QV06H00`000?ooofH0<`08IP0c00<0003ooomV0000
26H000030000ooooIS<000QV<`000`000?ooofIV0008IVH000<0003ooomV
IP0026IV00030000ooooIVH000QVIP000`000?ooofIV0008IVH000<0003o
oomVIP0026IV00030000ooooIVH000QVIP000`000?ooofIV0008IVH000<0
003ooolcIP0023=V00030000oooo06H000P0IP000`000?ooo`1V<`0806Hc
00<0003oool0IVH0201VIP030000oooo06IV00P0IVH00`000?ooo`1VIP08
06IV00<0003oool000002/c<c0030000ooooc<c<00S<c<`00`000?ooolc<
c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?oo
olc<c008c<c<00<0003oool00000M<c<c004IVIVR<2hR<2hB9280@000000
00F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooo<c<c00Pc<c<00`000?oo
o`1VIP0806IV00<0003oool0IVH0201VIP030000oooo06IV00P0IVH00`00
0?ooo`1VIP0806IV00<0003oool0<fH0200cIP030000oooo001V00P006H0
0`000?oooc<0IP08<`1V00<0003ooomV06H026H0IP030000ooooIP1V00QV
06H00`000?ooofH0IP08IP1V00<0003ooomV06H026H0IP030000ooooIP1V
00QV06H00`000?ooofH0IP08IP1V00<0003ooomV06H026H0IP030000oooo
IP0c00QV03<00`000?ooofH00008IP0000<0003ooomV<`0026Hc00030000
ooooIVH000QVIP000`000?ooofIV0008IVH000<0003ooomVIP0026IV0003
0000ooooIVH000QVIP000`000?ooofIV0008IVH000<0003ooomVIP0026IV
00030000ooooIVH000QVIP000`000?oooc=V0008<fH000<0003oool0IP00
201V00030000oooo06Hc00P0IS<00`000?ooo`1VIP0806IV00<0003oool0
IVH0201VIP030000oooo06IV00P0IVH00`000?ooo`00000:c<c<00<0003o
ooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0
003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooo`00001dc<c<
00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0
003ooolc<c<023<c<`030000oooo06IV00P0IVH00`000?ooo`1VIP0806IV
00<0003oool0IVH0201VIP030000oooo06IV00P0IVH00`000?ooo`0cIP08
03=V00<0003oool006H02000IP030000oooo<`1V00Pc06H00`000?ooofH0
IP08IP1V00<0003ooomV06H026H0IP030000ooooIP1V00QV06H00`000?oo
ofH0IP08IP1V00<0003ooomV06H026H0IP030000ooooIP1V00QV06H00`00
0?ooofH0IP08IP1V00<0003ooomV03<026H0<`030000ooooIP0000QV0000
0`000?ooofHc0008IS<000<0003ooomVIP0026IV00030000ooooIVH000QV
IP000`000?ooofIV0008IVH000<0003ooomVIP0026IV00030000ooooIVH0
00QVIP000`000?ooofIV0008IVH000<0003ooomVIP0026IV00030000oooo
<fH000PcIP000`000?ooo`1V000806H000<0003oool0IS<0201V<`030000
oooo06IV00P0IVH00`000?ooo`1VIP0806IV00<0003oool0IVH0201VIP03
0000oooo000000[<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<
c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`0
2<c<c0030000oooo000007C<c<`016IVIXS0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hoooo073<c<`00`000?ooooooo`3oooooEOooo`030000c<c<
c<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000
ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c003
0000oooo000007C<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo073<c<`00`000?ooo`000009000000?oool00000000020000003
oooo0000000000P000000oooo`0000000008000000?oool0000000002000
0003oooo0000000000P000000oooo`0000000008000000?oool000000000
20000003oooo0000000000P000000oooo`0000000008000000?oool00000
000020000003oooo0000000000P000000oooo`0000000008000000?oool0
0000000020000003oooo0000000000P000000oooo`0000000008000000?o
ool00000000020000003oooo0000000000P000000oooo`00000000080000
00?oool00000000020000003oooo0000000000P000000oooo`0000000008
000000?oool00000000020000003oooo0000000000P000000oooo`000000
0008000000?oool00000000020000003oooo0000000000P000000oooo`00
00000008000000?oool00000000020000003oooo0000000000P000000ooo
o`0000000008000000?oool0003<c<`02Lc<c0030000ooooc<c<00S<c<`0
0`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<
c<`00`000?ooolc<c008c<c<00<0003oool00000M<c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000ooooIVIV00QV
IVH00`000?ooo`2IV@0809VI00<0003oool0VIT0202IV@030000oooo09VI
00P0VIT00`000?ooo`1VV@0806JI00<0003oool0<iT0200cV@030000oooo
002I00P009T00`000?oooc<0V@08<`2I00<0003ooomV09T026H0V@030000
ooooV@2I00RI09T00`000?oooiT0V@08V@2I00<0003ooonI09T029T0V@03
0000ooooV@2I00RI09T00`000?oooiT0V@08V@2I00<0003ooonI06H029T0
IP030000ooooV@0c00RI03<00`000?oooiT00008V@0000<0003ooonI<`00
29Tc00030000ooooVFH000RIIP000`000?oooiVI0008VIT000<0003ooonI
V@0029VI00030000ooooVIT000RIV@000`000?oooiVI0008VIT000<0003o
oonIV@0029VI00030000ooooIYT000QVV@000`000?oooc>I0008<iT000<0
003oool0V@00202I00030000oooo09Tc00P0VC<00`000?ooo`2IIP0809UV
00<0003oool0VIT0202IV@030000oooo09VI00P0VIT00`000?ooo`00000:
c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<
c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?oo
o`00001dc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`1`c<c<00<0003ooomVIVH026IVIP030000oooo09VI00P0VIT00`000?oo
o`2IV@0809VI00<0003oool0VIT0202IV@030000oooo06JI00P0IYT00`00
0?ooo`0cV@0803>I00<0003oool009T02000V@030000oooo<`2I00Pc09T0
0`000?ooofH0V@08IP2I00<0003ooonI09T029T0V@030000ooooV@2I00RI
09T00`000?oooiT0V@08V@2I00<0003ooonI09T029T0V@030000ooooV@2I
00RI09T00`000?oooiT0IP08V@1V00<0003ooonI03<029T0<`030000oooo
V@0000RI00000`000?oooiTc0008VC<000<0003ooonIIP0029UV00030000
ooooVIT000RIV@000`000?oooiVI0008VIT000<0003ooonIV@0029VI0003
0000ooooVIT000RIV@000`000?oooiVI0008VIT000<0003ooomVV@0026JI
00030000oooo<iT000PcV@000`000?ooo`2I000809T000<0003oool0VC<0
202I<`030000oooo09UV00P0VFH00`000?ooo`2IV@0809VI00<0003oool0
VIT0202IV@030000oooo000000[<c<`00`000?ooooooo`0foooo00<0003<
c<c<c<`0L/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;So
ool0L<c<c0030000ooooIVIV00QVIVH00`000?ooo`2IV@0809VI00<0003o
ool0VIT0202IV@030000oooo09VI00P0VIT00`000?ooo`1VV@0806JI00<0
003oool0<iT0200cV@030000oooo002I00P009T00`000?oooc<0V@08<`2I
00<0003ooomV09T026H0V@030000ooooV@2I00RI09T00`000?oooiT0V@08
V@2I00<0003ooonI09T029T0V@030000ooooV@2I00RI09T00`000?oooiT0
V@08V@2I00<0003ooonI06H029T0IP030000ooooV@0c00RI03<00`000?oo
oiT00008V@0000<0003ooonI<`0029Tc00030000ooooVFH000RIIP000`00
0?oooiVI0008VIT000<0003ooonIV@0029VI00030000ooooVIT000RIV@00
0`000?oooiVI0008VIT000<0003ooonIV@0029VI00030000ooooIYT000QV
V@000`000?oooc>I0008<iT000<0003oool0V@00202I00030000oooo09Tc
00P0VC<00`000?ooo`2IIP0809UV00<0003oool0VIT0202IV@030000oooo
09VI00P0VIT00`000?ooo`00000:c<c<00<0003oool000002@000003oooo
0000000000P000000oooo`0000000008000000?oool00000000020000003
oooo0000000000P000000oooo`000<c<c01cc<c<00AVIVJ8`;R8`;Q8T8P1
000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0003ooomVIVH026IVIP03
0000oooo09VI00P0VIT00`000?ooo`2IV@0809VI00<0003oool0VIT0202I
V@030000oooo06JI00P0IYT00`000?ooo`0cV@0803>I00<0003oool009T0
2000V@030000oooo<`2I00Pc09T00`000?ooofH0V@08IP2I00<0003ooonI
09T029T0V@030000ooooV@2I00RI09T00`000?oooiT0V@08V@2I00<0003o
oonI09T029T0V@030000ooooV@2I00RI09T00`000?oooiT0IP08V@1V00<0
003ooonI03<029T0<`030000ooooV@0000RI00000`000?oooiTc0008VC<0
00<0003ooonIIP0029UV00030000ooooVIT000RIV@000`000?oooiVI0008
VIT000<0003ooonIV@0029VI00030000ooooVIT000RIV@000`000?oooiVI
0008VIT000<0003ooomVV@0026JI00030000oooo<iT000PcV@000`000?oo
o`2I000809T000<0003oool0VC<0202I<`030000oooo09UV00P0VFH00`00
0?ooo`2IV@0809VI00<0003oool0VIT0202IV@030000oooo000000[<c<`0
0`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<
c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000oooo0000
07C<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<
c<`00`000?ooofIVIP08IVIV00<0003oool0VIT0202IV@030000oooo09VI
00P0VIT00`000?ooo`2IV@0809VI00<0003oool0IYT0201VV@030000oooo
03>I00P0<iT00`000?ooo`00V@08002I00<0003ooolc09T023<0V@030000
ooooIP2I00QV09T00`000?oooiT0V@08V@2I00<0003ooonI09T029T0V@03
0000ooooV@2I00RI09T00`000?oooiT0V@08V@2I00<0003ooonI09T029T0
V@030000ooooV@1V00RI06H00`000?oooiT0<`08V@0c00<0003ooonI0000
29T000030000ooooVC<000RI<`000`000?oooiUV0008VFH000<0003ooonI
V@0029VI00030000ooooVIT000RIV@000`000?oooiVI0008VIT000<0003o
oonIV@0029VI00030000ooooVIT000RIV@000`000?ooofJI0008IYT000<0
003ooolcV@0023>I00030000oooo09T000P0V@000`000?ooo`2I<`0809Tc
00<0003oool0VFH0202IIP030000oooo09VI00P0VIT00`000?ooo`2IV@08
09VI00<0003oool000002/c<c0030000ooooc<c<00S<c<`00`000?ooolc<
c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?oo
olc<c008c<c<00<0003oool00000M<c<c004IVIVR<2hR<2hB9280@000000
00F8`;S8h=R8`;R8`;Soool0L<c<c0030000ooooIVIV00QVIVH00`000?oo
o`2IV@0809VI00<0003oool0VIT0202IV@030000oooo09VI00P0VIT00`00
0?ooo`1VV@0806JI00<0003oool0<iT0200cV@030000oooo002I00P009T0
0`000?oooc<0V@08<`2I00<0003ooomV09T026H0V@030000ooooV@2I00RI
09T00`000?oooiT0V@08V@2I00<0003ooonI09T029T0V@030000ooooV@2I
00RI09T00`000?oooiT0V@08V@2I00<0003ooonI06H029T0IP030000oooo
V@0c00RI03<00`000?oooiT00008V@0000<0003ooonI<`0029Tc00030000
ooooVFH000RIIP000`000?oooiVI0008VIT000<0003ooonIV@0029VI0003
0000ooooVIT000RIV@000`000?oooiVI0008VIT000<0003ooonIV@0029VI
00030000ooooIYT000QVV@000`000?oooc>I0008<iT000<0003oool0V@00
202I00030000oooo09Tc00P0VC<00`000?ooo`2IIP0809UV00<0003oool0
VIT0202IV@030000oooo09VI00P0VIT00`000?ooo`00000:c<c<00<0003o
ooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0
003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooo`00001dc<c<
00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0
003ooomVIVH026IVIP030000oooo09VI00P0VIT00`000?ooo`2IV@0809VI
00<0003oool0VIT0202IV@030000oooo06JI00P0IYT00`000?ooo`0cV@08
03>I00<0003oool009T02000V@030000oooo<`2I00Pc09T00`000?ooofH0
V@08IP2I00<0003ooonI09T029T0V@030000ooooV@2I00RI09T00`000?oo
oiT0V@08V@2I00<0003ooonI09T029T0V@030000ooooV@2I00RI09T00`00
0?oooiT0IP08V@1V00<0003ooonI03<029T0<`030000ooooV@0000RI0000
0`000?oooiTc0008VC<000<0003ooonIIP0029UV00030000ooooVIT000RI
V@000`000?oooiVI0008VIT000<0003ooonIV@0029VI00030000ooooVIT0
00RIV@000`000?oooiVI0008VIT000<0003ooomVV@0026JI00030000oooo
<iT000PcV@000`000?ooo`2I000809T000<0003oool0VC<0202I<`030000
oooo09UV00P0VFH00`000?ooo`2IV@0809VI00<0003oool0VIT0202IV@03
0000oooo000000[<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<
c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`0
2<c<c0030000oooo000007C<c<`016IVIXS0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hoooo073<c<`00`000?ooofIVIP08IVIV00<0003oool0VIT0
202IV@030000oooo09VI00P0VIT00`000?ooo`2IV@0809VI00<0003oool0
IYT0201VV@030000oooo03>I00P0<iT00`000?ooo`00V@08002I00<0003o
oolc09T023<0V@030000ooooIP2I00QV09T00`000?oooiT0V@08V@2I00<0
003ooonI09T029T0V@030000ooooV@2I00RI09T00`000?oooiT0V@08V@2I
00<0003ooonI09T029T0V@030000ooooV@1V00RI06H00`000?oooiT0<`08
V@0c00<0003ooonI000029T000030000ooooVC<000RI<`000`000?oooiUV
0008VFH000<0003ooonIV@0029VI00030000ooooVIT000RIV@000`000?oo
oiVI0008VIT000<0003ooonIV@0029VI00030000ooooVIT000RIV@000`00
0?ooofJI0008IYT000<0003ooolcV@0023>I00030000oooo09T000P0V@00
0`000?ooo`2I<`0809Tc00<0003oool0VFH0202IIP030000oooo09VI00P0
VIT00`000?ooo`2IV@0809VI00<0003oool000002/c<c0030000ooooc<c<
00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000oooo
c<c<00S<c<`00`000?ooolc<c008c<c<00<0003oool00000M<c<c004IVIV
R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooo
IVIV00QVIVH00`000?ooo`2IV@0809VI00<0003oool0VIT0202IV@030000
oooo09VI00P0VIT00`000?ooo`1VV@0806JI00<0003oool0<iT0200cV@03
0000oooo002I00P009T00`000?oooc<0V@08<`2I00<0003ooomV09T026H0
V@030000ooooV@2I00RI09T00`000?oooiT0V@08V@2I00<0003ooonI09T0
29T0V@030000ooooV@2I00RI09T00`000?oooiT0V@08V@2I00<0003ooonI
06H029T0IP030000ooooV@0c00RI03<00`000?oooiT00008V@0000<0003o
oonI<`0029Tc00030000ooooVFH000RIIP000`000?oooiVI0008VIT000<0
003ooonIV@0029VI00030000ooooVIT000RIV@000`000?oooiVI0008VIT0
00<0003ooonIV@0029VI00030000ooooIYT000QVV@000`000?oooc>I0008
<iT000<0003oool0V@00202I00030000oooo09Tc00P0VC<00`000?ooo`2I
IP0809UV00<0003oool0VIT0202IV@030000oooo09VI00P0VIT00`000?oo
o`00000:c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`00
0?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`0
0`000?ooo`00001dc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^?ooo`1`c<c<00<0003oooooool0oooooeGoool00`000<c<c<c<c008
c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<
c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?oo
o`00001dc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`1`c<c<00<0003oool000002@000003oooo0000000000P000000oooo`00
00000008000000?oool00000000020000003oooo0000000000P000000ooo
o`0000000008000000?oool00000000020000003oooo0000000000P00000
0oooo`0000000008000000?oool00000000020000003oooo0000000000P0
00000oooo`0000000008000000?oool00000000020000003oooo00000000
00P000000oooo`0000000008000000?oool00000000020000003oooo0000
000000P000000oooo`0000000008000000?oool00000000020000003oooo
0000000000P000000oooo`0000000008000000?oool00000000020000003
oooo0000000000P000000oooo`0000000008000000?oool0000000002000
0003oooo0000000000P000000oooo`0000000008000000?oool000000000
20000003oooo0000000000P000000oooo`0000000008000000?oool00000
000020000003oooo0000c<c<00W<c<`00`000?ooolc<c008c<c<00<0003o
ooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0
003oooo<c<`02<c<c0030000oooo000007C<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo073<c<`00`000?ooofIVIP08IVIV00<0
003oool0c<`0203<c0030000oooo0<c<00P0c<`00`000?ooo`2Ic00809W<
00<0003oool0I/`0201Vc0030000oooo03?<00P0<l`00`000?ooo`00c008
003<00<0003ooolc0<`023<0c0030000ooooIP3<00QV0<`00`000?oooiT0
c008V@3<00<0003oooo<0<`02<`0c0030000ooooc03<00S<0<`00`000?oo
ol`0c008c03<00<0003oooo<09T02<`0V@030000ooooc01V00S<06H00`00
0?oool`0<`08c00c00<0003oooo<00002<`000030000ooooc3<000S<<`00
0`000?ooolaV0008c6H000<0003oooo<V@002<bI00030000ooooc<`000S<
c0000`000?ooolc<0008c<`000<0003oooo<c0002<c<00030000ooooVL`0
00RIc0000`000?ooofK<0008I/`000<0003ooolcc00023?<00030000oooo
0<`000P0c0000`000?ooo`3<<`080<`c00<0003oool0c6H0203<IP030000
oooo0<bI00P0c9T00`000?ooo`3<c0080<c<00<0003oool000002/c<c003
0000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<
c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oool00000
M<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<
c0030000ooooIVIV00QVIVH00`000?ooo`3<c0080<c<00<0003oool0c<`0
203<c0030000oooo09W<00P0VL`00`000?ooo`1Vc00806K<00<0003oool0
<l`0200cc0030000oooo003<00P00<`00`000?oooc<0c008<`3<00<0003o
oomV0<`026H0c0030000ooooV@3<00RI0<`00`000?oool`0c008c03<00<0
003oooo<0<`02<`0c0030000ooooc03<00S<0<`00`000?oool`0V@08c02I
00<0003oooo<06H02<`0IP030000ooooc00c00S<03<00`000?oool`00008
c00000<0003oooo<<`002<`c00030000ooooc6H000S<IP000`000?ooolbI
0008c9T000<0003oooo<c0002<c<00030000ooooc<`000S<c0000`000?oo
olc<0008c<`000<0003ooonIc00029W<00030000ooooI/`000QVc0000`00
0?oooc?<0008<l`000<0003oool0c000203<00030000oooo0<`c00P0c3<0
0`000?ooo`3<IP080<aV00<0003oool0c9T0203<V@030000oooo0<c<00P0
c<`00`000?ooo`00000:c<c<00<0003oooooool0=_ooo`030000c<c<c<c<
07;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<
c<`00`000?ooofIVIP08IVIV00<0003oool0c<`0203<c0030000oooo0<c<
00P0c<`00`000?ooo`2Ic00809W<00<0003oool0I/`0201Vc0030000oooo
03?<00P0<l`00`000?ooo`00c008003<00<0003ooolc0<`023<0c0030000
ooooIP3<00QV0<`00`000?oooiT0c008V@3<00<0003oooo<0<`02<`0c003
0000ooooc03<00S<0<`00`000?oool`0c008c03<00<0003oooo<09T02<`0
V@030000ooooc01V00S<06H00`000?oool`0<`08c00c00<0003oooo<0000
2<`000030000ooooc3<000S<<`000`000?ooolaV0008c6H000<0003oooo<
V@002<bI00030000ooooc<`000S<c0000`000?ooolc<0008c<`000<0003o
ooo<c0002<c<00030000ooooVL`000RIc0000`000?ooofK<0008I/`000<0
003ooolcc00023?<00030000oooo0<`000P0c0000`000?ooo`3<<`080<`c
00<0003oool0c6H0203<IP030000oooo0<bI00P0c9T00`000?ooo`3<c008
0<c<00<0003oool000002/c<c0030000oooo000000T000000oooo`000000
0008000000?oool00000000020000003oooo0000000000P000000oooo`00
00000008000000?oool0003<c<`0Llc<c004IVIVR<2hR<2hB9280@000000
00F8`;S8h=R8`;R8`;Soool0L<c<c0030000ooooIVIV00QVIVH00`000?oo
o`3<c0080<c<00<0003oool0c<`0203<c0030000oooo09W<00P0VL`00`00
0?ooo`1Vc00806K<00<0003oool0<l`0200cc0030000oooo003<00P00<`0
0`000?oooc<0c008<`3<00<0003ooomV0<`026H0c0030000ooooV@3<00RI
0<`00`000?oool`0c008c03<00<0003oooo<0<`02<`0c0030000ooooc03<
00S<0<`00`000?oool`0V@08c02I00<0003oooo<06H02<`0IP030000oooo
c00c00S<03<00`000?oool`00008c00000<0003oooo<<`002<`c00030000
ooooc6H000S<IP000`000?ooolbI0008c9T000<0003oooo<c0002<c<0003
0000ooooc<`000S<c0000`000?ooolc<0008c<`000<0003ooonIc00029W<
00030000ooooI/`000QVc0000`000?oooc?<0008<l`000<0003oool0c000
203<00030000oooo0<`c00P0c3<00`000?ooo`3<IP080<aV00<0003oool0
c9T0203<V@030000oooo0<c<00P0c<`00`000?ooo`00000:c<c<00<0003o
ooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0
003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooo`00001dc<c<
00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0
003ooomVIVH026IVIP030000oooo0<c<00P0c<`00`000?ooo`3<c0080<c<
00<0003oool0VL`0202Ic0030000oooo06K<00P0I/`00`000?ooo`0cc008
03?<00<0003oool00<`02000c0030000oooo<`3<00Pc0<`00`000?ooofH0
c008IP3<00<0003ooonI0<`029T0c0030000ooooc03<00S<0<`00`000?oo
ol`0c008c03<00<0003oooo<0<`02<`0c0030000ooooc02I00S<09T00`00
0?oool`0IP08c01V00<0003oooo<03<02<`0<`030000ooooc00000S<0000
0`000?oool`c0008c3<000<0003oooo<IP002<aV00030000ooooc9T000S<
V@000`000?ooolc<0008c<`000<0003oooo<c0002<c<00030000ooooc<`0
00S<c0000`000?oooiW<0008VL`000<0003ooomVc00026K<00030000oooo
<l`000Pcc0000`000?ooo`3<00080<`000<0003oool0c3<0203<<`030000
oooo0<aV00P0c6H00`000?ooo`3<V@080<bI00<0003oool0c<`0203<c003
0000oooo000000[<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<
c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`0
2<c<c0030000oooo000007C<c<`016IVIXS0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hoooo073<c<`00`000?ooofIVIP08IVIV00<0003oool0c<`0
203<c0030000oooo0<c<00P0c<`00`000?ooo`2Ic00809W<00<0003oool0
I/`0201Vc0030000oooo03?<00P0<l`00`000?ooo`00c008003<00<0003o
oolc0<`023<0c0030000ooooIP3<00QV0<`00`000?oooiT0c008V@3<00<0
003oooo<0<`02<`0c0030000ooooc03<00S<0<`00`000?oool`0c008c03<
00<0003oooo<09T02<`0V@030000ooooc01V00S<06H00`000?oool`0<`08
c00c00<0003oooo<00002<`000030000ooooc3<000S<<`000`000?ooolaV
0008c6H000<0003oooo<V@002<bI00030000ooooc<`000S<c0000`000?oo
olc<0008c<`000<0003oooo<c0002<c<00030000ooooVL`000RIc0000`00
0?ooofK<0008I/`000<0003ooolcc00023?<00030000oooo0<`000P0c000
0`000?ooo`3<<`080<`c00<0003oool0c6H0203<IP030000oooo0<bI00P0
c9T00`000?ooo`3<c0080<c<00<0003oool000002/c<c0030000ooooc<c<
00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000oooo
c<c<00S<c<`00`000?ooolc<c008c<c<00<0003oool00000M<c<c004IVIV
R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooo
IVIV00QVIVH00`000?ooo`3<c0080<c<00<0003oool0c<`0203<c0030000
oooo09W<00P0VL`00`000?ooo`1Vc00806K<00<0003oool0<l`0200cc003
0000oooo003<00P00<`00`000?oooc<0c008<`3<00<0003ooomV0<`026H0
c0030000ooooV@3<00RI0<`00`000?oool`0c008c03<00<0003oooo<0<`0
2<`0c0030000ooooc03<00S<0<`00`000?oool`0V@08c02I00<0003oooo<
06H02<`0IP030000ooooc00c00S<03<00`000?oool`00008c00000<0003o
ooo<<`002<`c00030000ooooc6H000S<IP000`000?ooolbI0008c9T000<0
003oooo<c0002<c<00030000ooooc<`000S<c0000`000?ooolc<0008c<`0
00<0003ooonIc00029W<00030000ooooI/`000QVc0000`000?oooc?<0008
<l`000<0003oool0c000203<00030000oooo0<`c00P0c3<00`000?ooo`3<
IP080<aV00<0003oool0c9T0203<V@030000oooo0<c<00P0c<`00`000?oo
o`00000:c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`00
0?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`0
0`000?ooo`00001dc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^?ooo`1`c<c<00<0003ooomVIVH026IVIP030000oooo0<c<00P0c<`0
0`000?ooo`3<c0080<c<00<0003oool0VL`0202Ic0030000oooo06K<00P0
I/`00`000?ooo`0cc00803?<00<0003oool00<`02000c0030000oooo<`3<
00Pc0<`00`000?ooofH0c008IP3<00<0003ooonI0<`029T0c0030000oooo
c03<00S<0<`00`000?oool`0c008c03<00<0003oooo<0<`02<`0c0030000
ooooc02I00S<09T00`000?oool`0IP08c01V00<0003oooo<03<02<`0<`03
0000ooooc00000S<00000`000?oool`c0008c3<000<0003oooo<IP002<aV
00030000ooooc9T000S<V@000`000?ooolc<0008c<`000<0003oooo<c000
2<c<00030000ooooc<`000S<c0000`000?oooiW<0008VL`000<0003ooomV
c00026K<00030000oooo<l`000Pcc0000`000?ooo`3<00080<`000<0003o
ool0c3<0203<<`030000oooo0<aV00P0c6H00`000?ooo`3<V@080<bI00<0
003oool0c<`0203<c0030000oooo000000[<c<`00`000?ooolc<c008c<c<
00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008
c<c<00<0003oooo<c<`02<c<c0030000oooo000007C<c<`016IVIXS0^8S0
^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<c<`00`000?ooofIVIP08
IVIV00<0003oool0c<`0203<c0030000oooo0<c<00P0c<`00`000?ooo`2I
c00809W<00<0003oool0I/`0201Vc0030000oooo03?<00P0<l`00`000?oo
o`00c008003<00<0003ooolc0<`023<0c0030000ooooIP3<00QV0<`00`00
0?oooiT0c008V@3<00<0003oooo<0<`02<`0c0030000ooooc03<00S<0<`0
0`000?oool`0c008c03<00<0003oooo<09T02<`0V@030000ooooc01V00S<
06H00`000?oool`0<`08c00c00<0003oooo<00002<`000030000ooooc3<0
00S<<`000`000?ooolaV0008c6H000<0003oooo<V@002<bI00030000oooo
c<`000S<c0000`000?ooolc<0008c<`000<0003oooo<c0002<c<00030000
ooooVL`000RIc0000`000?ooofK<0008I/`000<0003ooolcc00023?<0003
0000oooo0<`000P0c0000`000?ooo`3<<`080<`c00<0003oool0c6H0203<
IP030000oooo0<bI00P0c9T00`000?ooo`3<c0080<c<00<0003oool00000
2/c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<
c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003o
ool00000M<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;So
ool0L<c<c0030000oooooooo0?oooomEoooo00<0003<c<c<c<`02<c<c003
0000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<
c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oool00000
M<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<
c0030000oooo000000T000000oooo`0000000008000000?oool000000000
20000003oooo0000000000P000000oooo`0000000008000000?oool00000
000020000003oooo0000000000P000000oooo`0000000008000000?oool0
0000000020000003oooo0000000000P000000oooo`0000000008000000?o
ool00000000020000003oooo0000000000P000000oooo`00000000080000
00?oool00000000020000003oooo0000000000P000000oooo`0000000008
000000?oool00000000020000003oooo0000000000P000000oooo`000000
0008000000?oool00000000020000003oooo0000000000P000000oooo`00
00000008000000?oool00000000020000003oooo0000000000P000000ooo
o`0000000008000000?oool00000000020000003oooo0000000000P00000
0oooo`0000000008000000?oool00000000020000003oooo0000000000P0
00000oooo`000<c<c009c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<
00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000oooo
c<c<00S<c<`00`000?ooo`00001dc<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0003ooonIVIT029VIV@030000oooo
0?oo00P0ool00`000?ooo`3<o`080<co00<0003oool0VOl0202Io`030000
oooo06Ko00P0I_l00`000?ooo`0co`0803?o00<0003oool00?l02000o`03
0000oooo<`3o00Pc0?l00`000?ooofH0o`08IP3o00<0003ooonI0?l029T0
o`030000ooooc03o00S<0?l00`000?ooool0o`08o`3o00<0003ooooo0<`0
2?l0c0030000ooooo`2I00So09T00`000?ooool0IP08o`1V00<0003ooooo
03<02?l0<`030000ooooo`0000So00000`000?oooolc0008oc<000<0003o
ooooIP002?mV00030000oooooiT000SoV@000`000?ooooo<0008ol`000<0
003oooooo`002?oo00030000ooooc?l000S<o`000`000?oooiWo0008VOl0
00<0003ooomVo`0026Ko00030000oooo<ol000Pco`000`000?ooo`3o0008
0?l000<0003oool0oc<0203o<`030000oooo0?mV00P0ofH00`000?ooo`3o
V@080?nI00<0003oool0ol`0203oc0030000oooo000000[<c<`00`000?oo
olc<c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`00
0?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000oooo000007C<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<c<`00`00
0?oooiVIV@08VIVI00<0003oool0ool0203oo`030000oooo0<co00P0c?l0
0`000?ooo`2Io`0809Wo00<0003oool0I_l0201Vo`030000oooo03?o00P0
<ol00`000?ooo`00o`08003o00<0003ooolc0?l023<0o`030000ooooIP3o
00QV0?l00`000?oooiT0o`08V@3o00<0003oooo<0?l02<`0o`030000oooo
o`3o00So0?l00`000?ooool0c008o`3<00<0003ooooo09T02?l0V@030000
ooooo`1V00So06H00`000?ooool0<`08o`0c00<0003ooooo00002?l00003
0000oooooc<000So<`000`000?oooomV0008ofH000<0003oooooV@002?nI
00030000oooool`000Soc0000`000?oooooo0008ool000<0003oooo<o`00
2<co00030000ooooVOl000RIo`000`000?ooofKo0008I_l000<0003ooolc
o`0023?o00030000oooo0?l000P0o`000`000?ooo`3o<`080?lc00<0003o
ool0ofH0203oIP030000oooo0?nI00P0oiT00`000?ooo`3oc0080?o<00<0
003oool000002/c<c0030000oooooooo03Koool00`000<c<c<c<c01bc<c<
00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0
003ooonIVIT029VIV@030000oooo0?oo00P0ool00`000?ooo`3<o`080<co
00<0003oool0VOl0202Io`030000oooo06Ko00P0I_l00`000?ooo`0co`08
03?o00<0003oool00?l02000o`030000oooo<`3o00Pc0?l00`000?ooofH0
o`08IP3o00<0003ooonI0?l029T0o`030000ooooc03o00S<0?l00`000?oo
ool0o`08o`3o00<0003ooooo0<`02?l0c0030000ooooo`2I00So09T00`00
0?ooool0IP08o`1V00<0003ooooo03<02?l0<`030000ooooo`0000So0000
0`000?oooolc0008oc<000<0003oooooIP002?mV00030000oooooiT000So
V@000`000?ooooo<0008ol`000<0003oooooo`002?oo00030000ooooc?l0
00S<o`000`000?oooiWo0008VOl000<0003ooomVo`0026Ko00030000oooo
<ol000Pco`000`000?ooo`3o00080?l000<0003oool0oc<0203o<`030000
oooo0?mV00P0ofH00`000?ooo`3oV@080?nI00<0003oool0ol`0203oc003
0000oooo000000[<c<`00`000?ooo`000009000000?oool0000000002000
0003oooo0000000000P000000oooo`0000000008000000?oool000000000
20000003oooo0000c<c<07?<c<`016IVIXS0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hoooo073<c<`00`000?oooiVIV@08VIVI00<0003oool0ool0
203oo`030000oooo0<co00P0c?l00`000?ooo`2Io`0809Wo00<0003oool0
I_l0201Vo`030000oooo03?o00P0<ol00`000?ooo`00o`08003o00<0003o
oolc0?l023<0o`030000ooooIP3o00QV0?l00`000?oooiT0o`08V@3o00<0
003oooo<0?l02<`0o`030000ooooo`3o00So0?l00`000?ooool0c008o`3<
00<0003ooooo09T02?l0V@030000ooooo`1V00So06H00`000?ooool0<`08
o`0c00<0003ooooo00002?l000030000oooooc<000So<`000`000?oooomV
0008ofH000<0003oooooV@002?nI00030000oooool`000Soc0000`000?oo
oooo0008ool000<0003oooo<o`002<co00030000ooooVOl000RIo`000`00
0?ooofKo0008I_l000<0003ooolco`0023?o00030000oooo0?l000P0o`00
0`000?ooo`3o<`080?lc00<0003oool0ofH0203oIP030000oooo0?nI00P0
oiT00`000?ooo`3oc0080?o<00<0003oool000002/c<c0030000ooooc<c<
00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000oooo
c<c<00S<c<`00`000?ooolc<c008c<c<00<0003oool00000M<c<c004IVIV
R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooo
VIVI00RIVIT00`000?ooo`3oo`080?oo00<0003oool0c?l0203<o`030000
oooo09Wo00P0VOl00`000?ooo`1Vo`0806Ko00<0003oool0<ol0200co`03
0000oooo003o00P00?l00`000?oooc<0o`08<`3o00<0003ooomV0?l026H0
o`030000ooooV@3o00RI0?l00`000?oool`0o`08c03o00<0003ooooo0?l0
2?l0o`030000ooooo`3<00So0<`00`000?ooool0V@08o`2I00<0003ooooo
06H02?l0IP030000ooooo`0c00So03<00`000?ooool00008o`0000<0003o
oooo<`002?lc00030000ooooofH000SoIP000`000?oooonI0008oiT000<0
003oooooc0002?o<00030000ooooool000Soo`000`000?ooolco0008c?l0
00<0003ooonIo`0029Wo00030000ooooI_l000QVo`000`000?oooc?o0008
<ol000<0003oool0o`00203o00030000oooo0?lc00P0oc<00`000?ooo`3o
IP080?mV00<0003oool0oiT0203oV@030000oooo0?o<00P0ol`00`000?oo
o`00000:c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`00
0?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`0
0`000?ooo`00001dc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^?ooo`1`c<c<00<0003ooonIVIT029VIV@030000oooo0?oo00P0ool0
0`000?ooo`3<o`080<co00<0003oool0VOl0202Io`030000oooo06Ko00P0
I_l00`000?ooo`0co`0803?o00<0003oool00?l02000o`030000oooo<`3o
00Pc0?l00`000?ooofH0o`08IP3o00<0003ooonI0?l029T0o`030000oooo
c03o00S<0?l00`000?ooool0o`08o`3o00<0003ooooo0<`02?l0c0030000
ooooo`2I00So09T00`000?ooool0IP08o`1V00<0003ooooo03<02?l0<`03
0000ooooo`0000So00000`000?oooolc0008oc<000<0003oooooIP002?mV
00030000oooooiT000SoV@000`000?ooooo<0008ol`000<0003oooooo`00
2?oo00030000ooooc?l000S<o`000`000?oooiWo0008VOl000<0003ooomV
o`0026Ko00030000oooo<ol000Pco`000`000?ooo`3o00080?l000<0003o
ool0oc<0203o<`030000oooo0?mV00P0ofH00`000?ooo`3oV@080?nI00<0
003oool0ol`0203oc0030000oooo000000[<c<`00`000?ooolc<c008c<c<
00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008
c<c<00<0003oooo<c<`02<c<c0030000oooo000007C<c<`016IVIXS0^8S0
^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<c<`00`000?oooiVIV@08
VIVI00<0003oool0ool0203oo`030000oooo0<co00P0c?l00`000?ooo`2I
o`0809Wo00<0003oool0I_l0201Vo`030000oooo03?o00P0<ol00`000?oo
o`00o`08003o00<0003ooolc0?l023<0o`030000ooooIP3o00QV0?l00`00
0?oooiT0o`08V@3o00<0003oooo<0?l02<`0o`030000ooooo`3o00So0?l0
0`000?ooool0c008o`3<00<0003ooooo09T02?l0V@030000ooooo`1V00So
06H00`000?ooool0<`08o`0c00<0003ooooo00002?l000030000oooooc<0
00So<`000`000?oooomV0008ofH000<0003oooooV@002?nI00030000oooo
ol`000Soc0000`000?oooooo0008ool000<0003oooo<o`002<co00030000
ooooVOl000RIo`000`000?ooofKo0008I_l000<0003ooolco`0023?o0003
0000oooo0?l000P0o`000`000?ooo`3o<`080?lc00<0003oool0ofH0203o
IP030000oooo0?nI00P0oiT00`000?ooo`3oc0080?o<00<0003oool00000
2/c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<
c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003o
ool00000M<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;So
ool0L<c<c0030000ooooVIVI00RIVIT00`000?ooo`3oo`080?oo00<0003o
ool0c?l0203<o`030000oooo09Wo00P0VOl00`000?ooo`1Vo`0806Ko00<0
003oool0<ol0200co`030000oooo003o00P00?l00`000?oooc<0o`08<`3o
00<0003ooomV0?l026H0o`030000ooooV@3o00RI0?l00`000?oool`0o`08
c03o00<0003ooooo0?l02?l0o`030000ooooo`3<00So0<`00`000?ooool0
V@08o`2I00<0003ooooo06H02?l0IP030000ooooo`0c00So03<00`000?oo
ool00008o`0000<0003ooooo<`002?lc00030000ooooofH000SoIP000`00
0?oooonI0008oiT000<0003oooooc0002?o<00030000ooooool000Soo`00
0`000?ooolco0008c?l000<0003ooonIo`0029Wo00030000ooooI_l000QV
o`000`000?oooc?o0008<ol000<0003oool0o`00203o00030000oooo0?lc
00P0oc<00`000?ooo`3oIP080?mV00<0003oool0oiT0203oV@030000oooo
0?o<00P0ol`00`000?ooo`00000:c<c<00<0003oooo<c<`02<c<c0030000
ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c003
0000ooooc<c<00S<c<`00`000?ooo`00001dc<c<00AVIVJ8`;R8`;Q8T8P1
000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0003ooonIVIT029VIV@03
0000oooo0?oo00P0ool00`000?ooo`3<o`080<co00<0003oool0VOl0202I
o`030000oooo06Ko00P0I_l00`000?ooo`0co`0803?o00<0003oool00?l0
2000o`030000oooo<`3o00Pc0?l00`000?ooofH0o`08IP3o00<0003ooonI
0?l029T0o`030000ooooc03o00S<0?l00`000?ooool0o`08o`3o00<0003o
oooo0<`02?l0c0030000ooooo`2I00So09T00`000?ooool0IP08o`1V00<0
003ooooo03<02?l0<`030000ooooo`0000So00000`000?oooolc0008oc<0
00<0003oooooIP002?mV00030000oooooiT000SoV@000`000?ooooo<0008
ol`000<0003oooooo`002?oo00030000ooooc?l000S<o`000`000?oooiWo
0008VOl000<0003ooomVo`0026Ko00030000oooo<ol000Pco`000`000?oo
o`3o00080?l000<0003oool0oc<0203o<`030000oooo0?mV00P0ofH00`00
0?ooo`3oV@080?nI00<0003oool0ol`0203oc0030000oooo000000[<c<`0
0`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<
c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000oooo0000
07C<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<
c<`00`000?ooooooo`3oooooEOooo`030000c<c<c<c<00S<c<`00`000?oo
olc<c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`00
0?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000oooo000007C<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<c<`00`00
0?ooo`000009000000?oool00000000020000003oooo0000000000P00000
0oooo`0000000008000000?oool00000000020000003oooo0000000000P0
00000oooo`0000000008000000?oool00000000020000003oooo00000000
00P000000oooo`0000000008000000?oool00000000020000003oooo0000
000000P000000oooo`0000000008000000?oool00000000020000003oooo
0000000000P000000oooo`0000000008000000?oool00000000020000003
oooo0000000000P000000oooo`0000000008000000?oool0000000002000
0003oooo0000000000P000000oooo`0000000008000000?oool000000000
20000003oooo0000000000P000000oooo`0000000008000000?oool00000
000020000003oooo0000000000P000000oooo`0000000008000000?oool0
0000000020000003oooo0000000000P000000oooo`0000000008000000?o
ool0003<c<`02Lc<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<
00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008
c<c<00<0003oool00000M<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0L<c<c0030000ooooVIVI00RIVIT00`000?oooc?oo`08
<ooo00<0003ooolcc?l023?<o`030000oooo<iWo00PcVOl00`000?oooc=V
o`08<fKo00<0003ooolc<ol023<co`030000oooo<c?o00Pc<ol00`000?oo
oc<co`08<c?o00<0003ooomV<ol026Hco`030000ooooVC?o00RI<ol00`00
0?oool`co`08c3?o00<0003ooooo<ol02?lco`030000oooooc?<00So<l`0
0`000?oooolcV@08oc>I00<0003ooooo<fH02?lcIP030000oooooc<c00So
<c<00`000?oooolc<`08oc<c00<0003ooooo<c<02?lc<`030000ooooofHc
00SoIS<00`000?oooonI<`08oiTc00<0003oooooc3<02?o<<`030000oooo
oolc00Sooc<00`000?ooolco<`08c?lc00<0003ooonIm3<029Wd<`030000
ooooI_lc00QVoc<00`000?oooc?o<`08<olc00<0003ooolcoc<023?o<`03
0000oooo<olc00Pcoc<00`000?oooc?oIP08<omV00<0003ooolcoiT023?o
V@030000oooo<oo<00Pcol`00`000?ooo`00000:c<c<00<0003oooo<c<`0
2<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<
c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooo`00001dc<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0003ooonI
VIT029VIV@030000oooo<ooo00Pcool00`000?oooc?<o`08<lco00<0003o
oolcVOl023>Io`030000oooo<fKo00PcI_l00`000?oooc<co`08<c?o00<0
003ooolc<ol023<co`030000oooo<c?o00Pc<ol00`000?ooofHco`08IS?o
00<0003ooonI<ol029Tco`030000ooooc3?o00S<<ol00`000?oooolco`08
oc?o00<0003ooooo<l`02?lcc0030000oooooc>I00So<iT00`000?oooolc
IP08oc=V00<0003ooooo<c<02?lc<`030000oooooc<c00So<c<00`000?oo
oolc<`08oc<c00<0003oooooIS<02?mV<`030000oooooiTc00SoVC<00`00
0?ooooo<<`08ol`c00<0003ooooooc<02?oo<`030000ooooc?lc00S<oc<0
0`000?oooiWd<`08VO@c00<0003ooomVoc<026Ko<`030000oooo<olc00Pc
oc<00`000?oooc?o<`08<olc00<0003ooolcoc<023?o<`030000oooo<omV
00PcofH00`000?oooc?oV@08<onI00<0003ooolcol`023?oc0030000oooo
000000[<c<`00`000?ooooooo`0foooo00<0003<c<c<c<`0L/c<c004IVIV
R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooo
VIVI00RIVIT00`000?oooc?oo`08<ooo00<0003ooolcc?l023?<o`030000
oooo<iWo00PcVOl00`000?oooc=Vo`08<fKo00<0003ooolc<ol023<co`03
0000oooo<c?o00Pc<ol00`000?oooc<co`08<c?o00<0003ooomV<ol026Hc
o`030000ooooVC?o00RI<ol00`000?oool`co`08c3?o00<0003ooooo<ol0
2?lco`030000oooooc?<00So<l`00`000?oooolcV@08oc>I00<0003ooooo
<fH02?lcIP030000oooooc<c00So<c<00`000?oooolc<`08oc<c00<0003o
oooo<c<02?lc<`030000ooooofHc00SoIS<00`000?oooonI<`08oiTc00<0
003oooooc3<02?o<<`030000oooooolc00Sooc<00`000?ooolco<`08c?lc
00<0003ooonIm3<029Wd<`030000ooooI_lc00QVoc<00`000?oooc?o<`08
<olc00<0003ooolcoc<023?o<`030000oooo<olc00Pcoc<00`000?oooc?o
IP08<omV00<0003ooolcoiT023?oV@030000oooo<oo<00Pcol`00`000?oo
o`00000:c<c<00<0003oool000002@000003oooo0000000000P000000ooo
o`0000000008000000?oool00000000020000003oooo0000000000P00000
0oooo`000<c<c01cc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^?ooo`1`c<c<00<0003ooonIVIT029VIV@030000oooo<ooo00Pcool0
0`000?oooc?<o`08<lco00<0003ooolcVOl023>Io`030000oooo<fKo00Pc
I_l00`000?oooc<co`08<c?o00<0003ooolc<ol023<co`030000oooo<c?o
00Pc<ol00`000?ooofHco`08IS?o00<0003ooonI<ol029Tco`030000oooo
c3?o00S<<ol00`000?oooolco`08oc?o00<0003ooooo<l`02?lcc0030000
oooooc>I00So<iT00`000?oooolcIP08oc=V00<0003ooooo<c<02?lc<`03
0000oooooc<c00So<c<00`000?oooolc<`08oc<c00<0003oooooIS<02?mV
<`030000oooooiTc00SoVC<00`000?ooooo<<`08ol`c00<0003ooooooc<0
2?oo<`030000ooooc?lc00S<oc<00`000?oooiWd<`08VO@c00<0003ooomV
oc<026Ko<`030000oooo<olc00Pcoc<00`000?oooc?o<`08<olc00<0003o
oolcoc<023?o<`030000oooo<omV00PcofH00`000?oooc?oV@08<onI00<0
003ooolcol`023?oc0030000oooo000000[<c<`00`000?ooolc<c008c<c<
00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008
c<c<00<0003oooo<c<`02<c<c0030000oooo000007C<c<`016IVIXS0^8S0
^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<c<`00`000?oooiVIV@08
VIVI00<0003ooolcool023?oo`030000oooo<lco00Pcc?l00`000?oooc>I
o`08<iWo00<0003ooolcI_l023=Vo`030000oooo<c?o00Pc<ol00`000?oo
oc<co`08<c?o00<0003ooolc<ol023<co`030000ooooIS?o00QV<ol00`00
0?oooiTco`08VC?o00<0003oooo<<ol02<`co`030000oooooc?o00So<ol0
0`000?oooolcc008oc?<00<0003ooooo<iT02?lcV@030000oooooc=V00So
<fH00`000?oooolc<`08oc<c00<0003ooooo<c<02?lc<`030000oooooc<c
00So<c<00`000?oooomV<`08ofHc00<0003oooooVC<02?nI<`030000oooo
ol`c00Soc3<00`000?oooooo<`08oolc00<0003oooo<oc<02<co<`030000
ooooVO@c00RIm3<00`000?ooofKo<`08I_lc00<0003ooolcoc<023?o<`03
0000oooo<olc00Pcoc<00`000?oooc?o<`08<olc00<0003ooolcofH023?o
IP030000oooo<onI00PcoiT00`000?oooc?oc008<oo<00<0003oool00000
2/c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<
c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003o
ool00000M<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;So
ool0L<c<c0030000ooooVIVI00RIVIT00`000?oooc?oo`08<ooo00<0003o
oolcc?l023?<o`030000oooo<iWo00PcVOl00`000?oooc=Vo`08<fKo00<0
003ooolc<ol023<co`030000oooo<c?o00Pc<ol00`000?oooc<co`08<c?o
00<0003ooomV<ol026Hco`030000ooooVC?o00RI<ol00`000?oool`co`08
c3?o00<0003ooooo<ol02?lco`030000oooooc?<00So<l`00`000?oooolc
V@08oc>I00<0003ooooo<fH02?lcIP030000oooooc<c00So<c<00`000?oo
oolc<`08oc<c00<0003ooooo<c<02?lc<`030000ooooofHc00SoIS<00`00
0?oooonI<`08oiTc00<0003oooooc3<02?o<<`030000oooooolc00Sooc<0
0`000?ooolco<`08c?lc00<0003ooonIm3<029Wd<`030000ooooI_lc00QV
oc<00`000?oooc?o<`08<olc00<0003ooolcoc<023?o<`030000oooo<olc
00Pcoc<00`000?oooc?oIP08<omV00<0003ooolcoiT023?oV@030000oooo
<oo<00Pcol`00`000?ooo`00000:c<c<00<0003oooo<c<`02<c<c0030000
ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c003
0000ooooc<c<00S<c<`00`000?ooo`00001dc<c<00AVIVJ8`;R8`;Q8T8P1
000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0003ooonIVIT029VIV@03
0000oooo<ooo00Pcool00`000?oooc?<o`08<lco00<0003ooolcVOl023>I
o`030000oooo<fKo00PcI_l00`000?oooc<co`08<c?o00<0003ooolc<ol0
23<co`030000oooo<c?o00Pc<ol00`000?ooofHco`08IS?o00<0003ooonI
<ol029Tco`030000ooooc3?o00S<<ol00`000?oooolco`08oc?o00<0003o
oooo<l`02?lcc0030000oooooc>I00So<iT00`000?oooolcIP08oc=V00<0
003ooooo<c<02?lc<`030000oooooc<c00So<c<00`000?oooolc<`08oc<c
00<0003oooooIS<02?mV<`030000oooooiTc00SoVC<00`000?ooooo<<`08
ol`c00<0003ooooooc<02?oo<`030000ooooc?lc00S<oc<00`000?oooiWd
<`08VO@c00<0003ooomVoc<026Ko<`030000oooo<olc00Pcoc<00`000?oo
oc?o<`08<olc00<0003ooolcoc<023?o<`030000oooo<omV00PcofH00`00
0?oooc?oV@08<onI00<0003ooolcol`023?oc0030000oooo000000[<c<`0
0`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<
c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000oooo0000
07C<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<
c<`00`000?oooiVIV@08VIVI00<0003ooolcool023?oo`030000oooo<lco
00Pcc?l00`000?oooc>Io`08<iWo00<0003ooolcI_l023=Vo`030000oooo
<c?o00Pc<ol00`000?oooc<co`08<c?o00<0003ooolc<ol023<co`030000
ooooIS?o00QV<ol00`000?oooiTco`08VC?o00<0003oooo<<ol02<`co`03
0000oooooc?o00So<ol00`000?oooolcc008oc?<00<0003ooooo<iT02?lc
V@030000oooooc=V00So<fH00`000?oooolc<`08oc<c00<0003ooooo<c<0
2?lc<`030000oooooc<c00So<c<00`000?oooomV<`08ofHc00<0003ooooo
VC<02?nI<`030000oooool`c00Soc3<00`000?oooooo<`08oolc00<0003o
ooo<oc<02<co<`030000ooooVO@c00RIm3<00`000?ooofKo<`08I_lc00<0
003ooolcoc<023?o<`030000oooo<olc00Pcoc<00`000?oooc?o<`08<olc
00<0003ooolcofH023?oIP030000oooo<onI00PcoiT00`000?oooc?oc008
<oo<00<0003oool000002/c<c0030000ooooc<c<00S<c<`00`000?ooolc<
c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?oo
olc<c008c<c<00<0003oool00000M<c<c004IVIVR<2hR<2hB9280@000000
00F8`;S8h=R8`;R8`;Soool0L<c<c0030000ooooVIVI00RIVIT00`000?oo
oc?oo`08<ooo00<0003ooolcc?l023?<o`030000oooo<iWo00PcVOl00`00
0?oooc=Vo`08<fKo00<0003ooolc<ol023<co`030000oooo<c?o00Pc<ol0
0`000?oooc<co`08<c?o00<0003ooomV<ol026Hco`030000ooooVC?o00RI
<ol00`000?oool`co`08c3?o00<0003ooooo<ol02?lco`030000oooooc?<
00So<l`00`000?oooolcV@08oc>I00<0003ooooo<fH02?lcIP030000oooo
oc<c00So<c<00`000?oooolc<`08oc<c00<0003ooooo<c<02?lc<`030000
ooooofHc00SoIS<00`000?oooonI<`08oiTc00<0003oooooc3<02?o<<`03
0000oooooolc00Sooc<00`000?ooolco<`08c?lc00<0003ooonIm3<029Wd
<`030000ooooI_lc00QVoc<00`000?oooc?o<`08<olc00<0003ooolcoc<0
23?o<`030000oooo<olc00Pcoc<00`000?oooc?oIP08<omV00<0003ooolc
oiT023?oV@030000oooo<oo<00Pcol`00`000?ooo`00000:c<c<00<0003o
ooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0
003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooo`00001dc<c<
00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0
003oooooool0oooooeGoool00`000<c<c<c<c008c<c<00<0003oooo<c<`0
2<c<c0030000ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<
c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooo`00001dc<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0003oool0
00002@000003oooo0000000000P000000oooo`0000000008000000?oool0
0000000020000003oooo0000000000P000000oooo`0000000008000000?o
ool00000000020000003oooo0000000000P000000oooo`00000000080000
00?oool00000000020000003oooo0000000000P000000oooo`0000000008
000000?oool00000000020000003oooo0000000000P000000oooo`000000
0008000000?oool00000000020000003oooo0000000000P000000oooo`00
00000008000000?oool00000000020000003oooo0000000000P000000ooo
o`0000000008000000?oool00000000020000003oooo0000000000P00000
0oooo`0000000008000000?oool00000000020000003oooo0000000000P0
00000oooo`0000000008000000?oool00000000020000003oooo00000000
00P000000oooo`0000000008000000?oool00000000020000003oooo0000
c<c<00W<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000
ooooc<c<00S<c<`00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c003
0000oooo000007C<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo073<c<`00`000?ooolc<c008c<c<00<0003ooomVool026Koo`03
0000ooooI/co00QVc?l00`000?ooofJIo`08IYWo00<0003ooomVI_l026IV
o`030000ooooIVKo00QVI_l00`000?ooofIVo`08IVKo00<0003ooomVI_l0
26IVo`030000ooooIVKo00QVI_l00`000?oooiUVo`08VFKo00<0003oooo<
I_l02<aVo`030000ooooofKo00SoI_l00`000?oooomVc008ofK<00<0003o
ooooIYT02?mVV@030000ooooofIV00SoIVH00`000?oooomVIP08ofIV00<0
003oooooIVH02?mVIP030000ooooofIV00SoIVH00`000?oooomVIP08ofIV
00<0003oooooVFH02?nIIP030000ooooolaV00Soc6H00`000?ooooooIP08
oomV00<0003oooo<ofH02<coIP030000ooooVOmV00RIofH00`000?ooofKo
IP08I_mV00<0003ooomVofH026KoIP030000ooooI_mV00QVofH00`000?oo
ofKoIP08I_mV00<0003ooomVofH026KoIP030000ooooI_nI00QVoiT00`00
0?ooofKoc008I_o<00<0003oool000002/c<c0030000ooooc<c<00S<c<`0
0`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000ooooc<c<00S<
c<`00`000?ooolc<c008c<c<00<0003oool00000M<c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000ooooc<c<00S<
c<`00`000?ooofKoo`08I_oo00<0003ooomVc?l026K<o`030000ooooIYWo
00QVVOl00`000?ooofIVo`08IVKo00<0003ooomVI_l026IVo`030000oooo
IVKo00QVI_l00`000?ooofIVo`08IVKo00<0003ooomVI_l026IVo`030000
ooooVFKo00RII_l00`000?ooolaVo`08c6Ko00<0003oooooI_l02?mVo`03
0000ooooofK<00SoI/`00`000?oooomVV@08ofJI00<0003oooooIVH02?mV
IP030000ooooofIV00SoIVH00`000?oooomVIP08ofIV00<0003oooooIVH0
2?mVIP030000ooooofIV00SoIVH00`000?oooonIIP08oiUV00<0003ooooo
c6H02?o<IP030000oooooomV00SoofH00`000?ooolcoIP08c?mV00<0003o
oonIofH029WoIP030000ooooI_mV00QVofH00`000?ooofKoIP08I_mV00<0
003ooomVofH026KoIP030000ooooI_mV00QVofH00`000?ooofKoIP08I_mV
00<0003ooomVoiT026KoV@030000ooooI_o<00QVol`00`000?ooo`00000:
c<c<00<0003oooooool0=_ooo`030000c<c<c<c<07;<c<`016IVIXS0^8S0
^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<c<`00`000?ooolc<c008
c<c<00<0003ooomVool026Koo`030000ooooI/co00QVc?l00`000?ooofJI
o`08IYWo00<0003ooomVI_l026IVo`030000ooooIVKo00QVI_l00`000?oo
ofIVo`08IVKo00<0003ooomVI_l026IVo`030000ooooIVKo00QVI_l00`00
0?oooiUVo`08VFKo00<0003oooo<I_l02<aVo`030000ooooofKo00SoI_l0
0`000?oooomVc008ofK<00<0003oooooIYT02?mVV@030000ooooofIV00So
IVH00`000?oooomVIP08ofIV00<0003oooooIVH02?mVIP030000ooooofIV
00SoIVH00`000?oooomVIP08ofIV00<0003oooooVFH02?nIIP030000oooo
olaV00Soc6H00`000?ooooooIP08oomV00<0003oooo<ofH02<coIP030000
ooooVOmV00RIofH00`000?ooofKoIP08I_mV00<0003ooomVofH026KoIP03
0000ooooI_mV00QVofH00`000?ooofKoIP08I_mV00<0003ooomVofH026Ko
IP030000ooooI_nI00QVoiT00`000?ooofKoc008I_o<00<0003oool00000
2/c<c0030000oooo000000T000000oooo`0000000008000000?oool00000
000020000003oooo0000000000P000000oooo`0000000008000000?oool0
003<c<`0Llc<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;So
ool0L<c<c0030000ooooc<c<00S<c<`00`000?ooofKoo`08I_oo00<0003o
oomVc?l026K<o`030000ooooIYWo00QVVOl00`000?ooofIVo`08IVKo00<0
003ooomVI_l026IVo`030000ooooIVKo00QVI_l00`000?ooofIVo`08IVKo
00<0003ooomVI_l026IVo`030000ooooVFKo00RII_l00`000?ooolaVo`08
c6Ko00<0003oooooI_l02?mVo`030000ooooofK<00SoI/`00`000?oooomV
V@08ofJI00<0003oooooIVH02?mVIP030000ooooofIV00SoIVH00`000?oo
oomVIP08ofIV00<0003oooooIVH02?mVIP030000ooooofIV00SoIVH00`00
0?oooonIIP08oiUV00<0003oooooc6H02?o<IP030000oooooomV00SoofH0
0`000?ooolcoIP08c?mV00<0003ooonIofH029WoIP030000ooooI_mV00QV
ofH00`000?ooofKoIP08I_mV00<0003ooomVofH026KoIP030000ooooI_mV
00QVofH00`000?ooofKoIP08I_mV00<0003ooomVoiT026KoV@030000oooo
I_o<00QVol`00`000?ooo`00000:c<c<00<0003ooolcc00023?<00030000
oooooomV00SoofH00`000?ooofIVo`08IVKo00<0003oooo<c<`02<c<c003
0000ooooc<c<00S<c<`00`000?ooo`00001dc<c<00AVIVJ8`;R8`;Q8T8P1
000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0003oooo<c<`02<c<c003
0000ooooI_oo00QVool00`000?ooofK<o`08I/co00<0003ooomVVOl026JI
o`030000ooooIVKo00QVI_l00`000?ooofIVo`08IVKo00<0003ooomVI_l0
26IVo`030000ooooIVKo00QVI_l00`000?ooofIVo`08IVKo00<0003ooonI
I_l029UVo`030000ooooc6Ko00S<I_l00`000?oooomVo`08ofKo00<0003o
ooooI/`02?mVc0030000ooooofJI00SoIYT00`000?oooomVIP08ofIV00<0
003oooooIVH02?mVIP030000ooooofIV00SoIVH00`000?oooomVIP08ofIV
00<0003oooooIVH02?mVIP030000oooooiUV00SoVFH00`000?ooooo<IP08
olaV00<0003oooooofH02?ooIP030000ooooc?mV00S<ofH00`000?oooiWo
IP08VOmV00<0003ooomVofH026KoIP030000ooooI_mV00QVofH00`000?oo
ofKoIP08I_mV00<0003ooomVofH026KoIP030000ooooI_mV00QVofH00`00
0?ooofKoV@08I_nI00<0003ooomVol`026Koc0030000oooo000000[<c<`0
0`000?oooc?<0008<l`000<0003oooooofH02?ooIP030000ooooIVKo00QV
I_l00`000?ooolc<c008c<c<00<0003oooo<c<`02<c<c0030000oooo0000
07C<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<
c<`00`000?ooolc<c008c<c<00<0003ooomVool026Koo`030000ooooI/co
00QVc?l00`000?ooofJIo`08IYWo00<0003ooomVI_l026IVo`030000oooo
IVKo00QVI_l00`000?ooofIVo`08IVKo00<0003ooomVI_l026IVo`030000
ooooIVKo00QVI_l00`000?oooiUVo`08VFKo00<0003oooo<I_l02<aVo`03
0000ooooofKo00SoI_l00`000?oooomVc008ofK<00<0003oooooIYT02?mV
V@030000ooooofIV00SoIVH00`000?oooomVIP08ofIV00<0003oooooIVH0
2?mVIP030000ooooofIV00SoIVH00`000?oooomVIP08ofIV00<0003ooooo
VFH02?nIIP030000ooooolaV00Soc6H00`000?ooooooIP08oomV00<0003o
ooo<ofH02<coIP030000ooooVOmV00RIofH00`000?ooofKoIP08I_mV00<0
003ooomVofH026KoIP030000ooooI_mV00QVofH00`000?ooofKoIP08I_mV
00<0003ooomVofH026KoIP030000ooooI_nI00QVoiT00`000?ooofKoc008
I_o<00<0003oool000002/c<c0030000oooo<l`000Pcc0000`000?oooooo
IP08oomV00<0003ooomVI_l026IVo`030000ooooc<c<00S<c<`00`000?oo
olc<c008c<c<00<0003oool00000M<c<c004IVIVR<2hR<2hB9280@000000
00F8`;S8h=R8`;R8`;Soool0L<c<c0030000ooooc<c<00S<c<`00`000?oo
ofKoo`08I_oo00<0003ooomVc?l026K<o`030000ooooIYWo00QVVOl00`00
0?ooofIVo`08IVKo00<0003ooomVI_l026IVo`030000ooooIVKo00QVI_l0
0`000?ooofIVo`08IVKo00<0003ooomVI_l026IVo`030000ooooVFKo00RI
I_l00`000?ooolaVo`08c6Ko00<0003oooooI_l02?mVo`030000ooooofK<
00SoI/`00`000?oooomVV@08ofJI00<0003oooooIVH02?mVIP030000oooo
ofIV00SoIVH00`000?oooomVIP08ofIV00<0003oooooIVH02?mVIP030000
ooooofIV00SoIVH00`000?oooonIIP08oiUV00<0003oooooc6H02?o<IP03
0000oooooomV00SoofH00`000?ooolcoIP08c?mV00<0003ooonIofH029Wo
IP030000ooooI_mV00QVofH00`000?ooofKoIP08I_mV00<0003ooomVofH0
26KoIP030000ooooI_mV00QVofH00`000?ooofKoIP08I_mV00<0003ooomV
oiT026KoV@030000ooooI_o<00QVol`00`000?ooo`00000:c<c<00<0003o
oolcc00023?<00030000oooooomV00SoofH00`000?ooofIVo`08IVKo00<0
003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?ooo`00001dc<c<
00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0
003oooo<c<`02<c<c0030000ooooI_oo00QVool00`000?ooofK<o`08I/co
00<0003ooomVVOl026JIo`030000ooooIVKo00QVI_l00`000?ooofIVo`08
IVKo00<0003ooomVI_l026IVo`030000ooooIVKo00QVI_l00`000?ooofIV
o`08IVKo00<0003ooonII_l029UVo`030000ooooc6Ko00S<I_l00`000?oo
oomVo`08ofKo00<0003oooooI/`02?mVc0030000ooooofJI00SoIYT00`00
0?oooomVIP08ofIV00<0003oooooIVH02?mVIP030000ooooofIV00SoIVH0
0`000?oooomVIP08ofIV00<0003oooooIVH02?mVIP030000oooooiUV00So
VFH00`000?ooooo<IP08olaV00<0003oooooofH02?ooIP030000ooooc?mV
00S<ofH00`000?oooiWoIP08VOmV00<0003ooomVofH026KoIP030000oooo
I_mV00QVofH00`000?ooofKoIP08I_mV00<0003ooomVofH026KoIP030000
ooooI_mV00QVofH00`000?ooofKoV@08I_nI00<0003ooomVol`026Koc003
0000oooo000000[<c<`00`000?oooc?<0008<l`000<0003oooooofH02?oo
IP030000ooooIVKo00QVI_l00`000?ooolc<c008c<c<00<0003oooo<c<`0
2<c<c0030000oooo000007C<c<`016IVIXS0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hoooo073<c<`00`000?ooolc<c008c<c<00<0003ooomVool0
26Koo`030000ooooI/co00QVc?l00`000?ooofJIo`08IYWo00<0003ooomV
I_l026IVo`030000ooooIVKo00QVI_l00`000?ooofIVo`08IVKo00<0003o
oomVI_l026IVo`030000ooooIVKo00QVI_l00`000?oooiUVo`08VFKo00<0
003oooo<I_l02<aVo`030000ooooofKo00SoI_l00`000?oooomVc008ofK<
00<0003oooooIYT02?mVV@030000ooooofIV00SoIVH00`000?oooomVIP08
ofIV00<0003oooooIVH02?mVIP030000ooooofIV00SoIVH00`000?oooomV
IP08ofIV00<0003oooooVFH02?nIIP030000ooooolaV00Soc6H00`000?oo
ooooIP08oomV00<0003oooo<ofH02<coIP030000ooooVOmV00RIofH00`00
0?ooofKoIP08I_mV00<0003ooomVofH026KoIP030000ooooI_mV00QVofH0
0`000?ooofKoIP08I_mV00<0003ooomVofH026KoIP030000ooooI_nI00QV
oiT00`000?ooofKoc008I_o<00<0003oool000002/c<c0030000oooo<l`0
00Pcc0000`000?ooooooIP08oomV00<0003ooomVI_l026IVo`030000oooo
c<c<00S<c<`00`000?ooolc<c008c<c<00<0003oool00000M<c<c004IVIV
R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooo
oooo0?oooomEoooo00<0003<c<c<c<`02<c<c0030000oooo<l`000Pcc000
0`000?ooooooIP08oomV00<0003ooomVI_l026IVo`030000ooooc<c<00S<
c<`00`000?ooolc<c008c<c<00<0003oool00000M<c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooo000000T0
00000oooo`0000000008000000?oool00000000020000003oooo00000000
00P000000oooo`0000000008000000?oool00000000020000003oooo0000
000000P000000oooo`0000000008000000?oool00000000020000003oooo
0000000000P000000oooo`0000000008000000?oool00000000020000003
oooo0000000000P000000oooo`0000000008000000?oool0000000002000
0003oooo0000000000P000000oooo`0000000008000000?oool000000000
20000003oooo0000000000P000000oooo`0000000008000000?oool00000
000020000003oooo0000000000P000000oooo`0000000008000000?oool0
0000000020000003oooo0000000000P000000oooo`0000000008000000?o
ool00000000020000003oooo0000000000P000000oooo`00000000080000
00?oool00000000020000003oooo0000000000P000000oooo`000<c<c009
c<c<00<0003ooolcc00023?<00030000oooooomV00SoofH00`000?ooofIV
o`08IVKo00<0003oooo<c<`02<c<c0030000ooooc<c<00S<c<`00`000?oo
o`00001dc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`1`c<c<00<0003oooo<c<`02<c<c0030000ooooVOoo00RIool00`000?oo
oiW<o`08VLco00<0003ooonIVOl029VIo`030000ooooVIWo00RIVOl00`00
0?oooiVIo`08VIWo00<0003ooonIVOl029VIo`030000ooooVIWo00RIVOl0
0`000?oooiVIo`08VIWo00<0003ooonIVOl029VIo`030000ooooc9Wo00S<
VOl00`000?oooonIo`08oiWo00<0003oooooVL`02?nIc0030000oooooiVI
00SoVIT00`000?oooonIV@08oiVI00<0003oooooVIT02?nIV@030000oooo
oiVI00SoVIT00`000?oooonIV@08oiVI00<0003oooooVIT02?nIV@030000
oooooiVI00SoVIT00`000?ooooo<V@08olbI00<0003ooooooiT02?ooV@03
0000ooooc?nI00S<oiT00`000?oooiWoV@08VOnI00<0003ooonIoiT029Wo
V@030000ooooVOnI00RIoiT00`000?oooiWoV@08VOnI00<0003ooonIoiT0
29WoV@030000ooooVOnI00RIoiT00`000?oooiWoV@08VOnI00<0003ooonI
ol`029Woc0030000oooo000000[<c<`00`000?oooc?<0008<l`000<0003o
ooooofH02?ooIP030000ooooIVKo00QVI_l00`000?ooolc<c008c<c<00<0
003oooo<c<`02<c<c0030000oooo000007C<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo073<c<`00`000?ooolc<c008c<c<00<0
003ooonIool029Woo`030000ooooVLco00RIc?l00`000?oooiVIo`08VIWo
00<0003ooonIVOl029VIo`030000ooooVIWo00RIVOl00`000?oooiVIo`08
VIWo00<0003ooonIVOl029VIo`030000ooooVIWo00RIVOl00`000?oooiVI
o`08VIWo00<0003oooo<VOl02<bIo`030000oooooiWo00SoVOl00`000?oo
oonIc008oiW<00<0003oooooVIT02?nIV@030000oooooiVI00SoVIT00`00
0?oooonIV@08oiVI00<0003oooooVIT02?nIV@030000oooooiVI00SoVIT0
0`000?oooonIV@08oiVI00<0003oooooVIT02?nIV@030000ooooolbI00So
c9T00`000?ooooooV@08oonI00<0003oooo<oiT02<coV@030000ooooVOnI
00RIoiT00`000?oooiWoV@08VOnI00<0003ooonIoiT029WoV@030000oooo
VOnI00RIoiT00`000?oooiWoV@08VOnI00<0003ooonIoiT029WoV@030000
ooooVOnI00RIoiT00`000?oooiWoc008VOo<00<0003oool000002/c<c003
0000oooooooo03Koool00`000<c<c<c<c01bc<c<00AVIVJ8`;R8`;Q8T8P1
000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0003oooo<c<`02<c<c003
0000ooooVOoo00RIool00`000?oooiW<o`08VLco00<0003ooonIVOl029VI
o`030000ooooVIWo00RIVOl00`000?oooiVIo`08VIWo00<0003ooonIVOl0
29VIo`030000ooooVIWo00RIVOl00`000?oooiVIo`08VIWo00<0003ooonI
VOl029VIo`030000ooooc9Wo00S<VOl00`000?oooonIo`08oiWo00<0003o
ooooVL`02?nIc0030000oooooiVI00SoVIT00`000?oooonIV@08oiVI00<0
003oooooVIT02?nIV@030000oooooiVI00SoVIT00`000?oooonIV@08oiVI
00<0003oooooVIT02?nIV@030000oooooiVI00SoVIT00`000?ooooo<V@08
olbI00<0003ooooooiT02?ooV@030000ooooc?nI00S<oiT00`000?oooiWo
V@08VOnI00<0003ooonIoiT029WoV@030000ooooVOnI00RIoiT00`000?oo
oiWoV@08VOnI00<0003ooonIoiT029WoV@030000ooooVOnI00RIoiT00`00
0?oooiWoV@08VOnI00<0003ooonIol`029Woc0030000oooo000000[<c<`j
0000M<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0
L<c<c0030000ooooc<c<00S<c<`00`000?oooiWoo`08VOoo00<0003ooonI
c?l029W<o`030000ooooVIWo00RIVOl00`000?oooiVIo`08VIWo00<0003o
oonIVOl029VIo`030000ooooVIWo00RIVOl00`000?oooiVIo`08VIWo00<0
003ooonIVOl029VIo`030000ooooVIWo00RIVOl00`000?ooolbIo`08c9Wo
00<0003oooooVOl02?nIo`030000oooooiW<00SoVL`00`000?oooonIV@08
oiVI00<0003oooooVIT02?nIV@030000oooooiVI00SoVIT00`000?oooonI
V@08oiVI00<0003oooooVIT02?nIV@030000oooooiVI00SoVIT00`000?oo
oonIV@08oiVI00<0003oooooc9T02?o<V@030000oooooonI00SooiT00`00
0?ooolcoV@08c?nI00<0003ooonIoiT029WoV@030000ooooVOnI00RIoiT0
0`000?oooiWoV@08VOnI00<0003ooonIoiT029WoV@030000ooooVOnI00RI
oiT00`000?oooiWoV@08VOnI00<0003ooonIoiT029WoV@030000ooooVOo<
00RIol`00`000?ooo`00002hc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`1`c<c<00<0003oooo<c<`02<c<c0030000ooooVOoo
00RIool00`000?oooiW<o`08VLco00<0003ooonIVOl029VIo`030000oooo
VIWo00RIVOl00`000?oooiVIo`08VIWo00<0003ooonIVOl029VIo`030000
ooooVIWo00RIVOl00`000?oooiVIo`08VIWo00<0003ooonIVOl029VIo`03
0000ooooc9Wo00S<VOl00`000?oooonIo`08oiWo00<0003oooooVL`02?nI
c0030000oooooiVI00SoVIT00`000?oooonIV@08oiVI00<0003oooooVIT0
2?nIV@030000oooooiVI00SoVIT00`000?oooonIV@08oiVI00<0003ooooo
VIT02?nIV@030000oooooiVI00SoVIT00`000?ooooo<V@08olbI00<0003o
oooooiT02?ooV@030000ooooc?nI00S<oiT00`000?oooiWoV@08VOnI00<0
003ooonIoiT029WoV@030000ooooVOnI00RIoiT00`000?oooiWoV@08VOnI
00<0003ooonIoiT029WoV@030000ooooVOnI00RIoiT00`000?oooiWoV@08
VOnI00<0003ooonIol`029Woc0030000oooo000001c<c<`00`000<c<c<c<
c02Ic<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`1`
c<c<00<0003oooo<c<`02<c<c0030000ooooVOoo00RIool00`000?oooiW<
o`08VLco00<0003ooonIVOl029VIo`030000ooooVIWo00RIVOl00`000?oo
oiVIo`08VIWo00<0003ooonIVOl029VIo`030000ooooVIWo00RIVOl00`00
0?oooiVIo`08VIWo00<0003ooonIVOl029VIo`030000ooooc9Wo00S<VOl0
0`000?oooonIo`08oiWo00<0003oooooVL`02?nIc0030000oooooiVI00So
VIT00`000?oooonIV@08oiVI00<0003oooooVIT02?nIV@030000oooooiVI
00SoVIT00`000?oooonIV@08oiVI00<0003oooooVIT02?nIV@030000oooo
oiVI00SoVIT00`000?ooooo<V@08olbI00<0003ooooooiT02?ooV@030000
ooooc?nI00S<oiT00`000?oooiWoV@08VOnI00<0003ooonIoiT029WoV@03
0000ooooVOnI00RIoiT00`000?oooiWoV@08VOnI00<0003ooonIoiT029Wo
V@030000ooooVOnI00RIoiT00`000?oooiWoV@08VOnI00<0003ooonIol`0
29Woc0030000oooo000000_<c<`00`000<c<c<c<c00400000/c<c0800002
c<c<00<0003<c<`000000`0000;<c<`20000U/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000ooooc<c<00S<c<`0
0`000?oooiWoo`08VOoo00<0003ooonIc?l029W<o`030000ooooVIWo00RI
VOl00`000?oooiVIo`08VIWo00<0003ooonIVOl029VIo`030000ooooVIWo
00RIVOl00`000?oooiVIo`08VIWo00<0003ooonIVOl029VIo`030000oooo
VIWo00RIVOl00`000?ooolbIo`08c9Wo00<0003oooooVOl02?nIo`030000
oooooiW<00SoVL`00`000?oooonIV@08oiVI00<0003oooooVIT02?nIV@03
0000oooooiVI00SoVIT00`000?oooonIV@08oiVI00<0003oooooVIT02?nI
V@030000oooooiVI00SoVIT00`000?oooonIV@08oiVI00<0003oooooc9T0
2?o<V@030000oooooonI00SooiT00`000?ooolcoV@08c?nI00<0003ooonI
oiT029WoV@030000ooooVOnI00RIoiT00`000?oooiWoV@08VOnI00<0003o
oonIoiT029WoV@030000ooooVOnI00RIoiT00`000?oooiWoV@08VOnI00<0
003ooonIoiT029WoV@030000ooooVOo<00RIol`00`000?ooo`00000;c<c<
1@000003c<c<0000000000800003c<c<1`000004c<c<00000000c<c<0P00
09?<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<
c<`00`000?ooolc<c008c<c<00<0003ooonIool029Woo`030000ooooVLco
00RIc?l00`000?oooiVIo`08VIWo00<0003ooonIVOl029VIo`030000oooo
VIWo00RIVOl00`000?oooiVIo`08VIWo00<0003ooonIVOl029VIo`030000
ooooVIWo00RIVOl00`000?oooiVIo`08VIWo00<0003oooo<VOl02<bIo`03
0000oooooiWo00SoVOl00`000?oooonIc008oiW<00<0003oooooVIT02?nI
V@030000oooooiVI00SoVIT00`000?oooonIV@08oiVI00<0003oooooVIT0
2?nIV@030000oooooiVI00SoVIT00`000?oooonIV@08oiVI00<0003ooooo
VIT02?nIV@030000ooooolbI00Soc9T00`000?ooooooV@08oonI00<0003o
ooo<oiT02<coV@030000ooooVOnI00RIoiT00`000?oooiWoV@08VOnI00<0
003ooonIoiT029WoV@030000ooooVOnI00RIoiT00`000?oooiWoV@08VOnI
00<0003ooonIoiT029WoV@030000ooooVOnI00RIoiT00`000?oooiWoc008
VOo<00<0003oool000003<c<c0@000001<c<c0000000000000G<c<`60000
00C<c<`00000003<c<`20000Tlc<c004IVIVR<2hR<2hB9280@00000000F8
`;S8h=R8`;R8`;Soool0L<c<c0030000ooooc<c<00S<c<`00`000?oooiWo
o`08VOoo00<0003ooonIc?l029W<o`030000ooooVIWo00RIVOl00`000?oo
oiVIo`08VIWo00<0003ooonIVOl029VIo`030000ooooVIWo00RIVOl00`00
0?oooiVIo`08VIWo00<0003ooonIVOl029VIo`030000ooooVIWo00RIVOl0
0`000?ooolbIo`08c9Wo00<0003oooooVOl02?nIo`030000oooooiW<00So
VL`00`000?oooonIV@08oiVI00<0003oooooVIT02?nIV@030000oooooiVI
00SoVIT00`000?oooonIV@08oiVI00<0003oooooVIT02?nIV@030000oooo
oiVI00SoVIT00`000?oooonIV@08oiVI00<0003oooooc9T02?o<V@030000
oooooonI00SooiT00`000?ooolcoV@08c?nI00<0003ooonIoiT029WoV@03
0000ooooVOnI00RIoiT00`000?oooiWoV@08VOnI00<0003ooonIoiT029Wo
V@030000ooooVOnI00RIoiT00`000?oooiWoV@08VOnI00<0003ooonIoiT0
29WoV@030000ooooVOo<00RIol`00`000?ooo`00000<c<c<10000003c<c<
0000000000800005c<c<0P0000;<c<`40000U/c<c004IVIVR<2hR<2hB928
0@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooooooo0?oooomE
oooo00<0003<c<c<c<`02/c<c0X00002c<c<2P0009K<c<`016IVIXS0^8S0
^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<c<`00`000?ooo`000009
000000?oool00000000020000003oooo0000000000P000000oooo`000000
0008000000?oool00000000020000003oooo0000000000P000000oooo`00
00000008000000?oool00000000020000003oooo0000000000P000000ooo
o`0000000008000000?oool00000000020000003oooo0000000000P00000
0oooo`0000000008000000?oool00000000020000003oooo0000000000P0
00000oooo`0000000008000000?oool00000000020000003oooo00000000
00P000000oooo`0000000008000000?oool00000000020000003oooo0000
000000P000000oooo`0000000008000000?oool00000000020000003oooo
0000000000P000000oooo`0000000008000000?oool00000000020000003
oooo0000000000P000000oooo`0000000008000000?oool0000000002000
0003oooo0000000000P000000oooo`0000000008000000?oool0003<c<`0
2/c<c0/00004c<c<0P0000;<c<`40000U/c<c004IVIVR<2hR<2hB9280@00
000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooooooo00Soool00`00
0?ooolcoo`08c?oo00<0003oooo<c?l02<c<o`030000ooooc<co00S<c?l0
0`000?ooolc<o`08c<co00<0003oooo<c?l02<c<o`030000ooooc<co00S<
c?l00`000?ooolc<o`08c<co00<0003oooo<c?l02<c<o`030000ooooc<co
00S<c?l00`000?ooolc<o`08c<co00<0003oooooc?l02?o<o`030000oooo
olc<00Soc<`00`000?ooooo<c008olc<00<0003oooooc<`02?o<c0030000
ooooolc<00Soc<`00`000?ooooo<c008olc<00<0003oooooc<`02?o<c003
0000ooooolc<00Soc<`00`000?ooooo<c008olc<00<0003oooooc<`02?o<
c0030000ooooooo<00Sool`00`000?ooolcoc008c?o<00<0003oooo<ol`0
2<coc0030000ooooc?o<00S<ol`00`000?ooolcoc008c?o<00<0003oooo<
ol`02<coc0030000ooooc?o<00S<ol`00`000?ooolcoc008c?o<00<0003o
ooo<ol`02<coc0030000ooooc?o<00S<ol`00`000?ooo`00000Hc<c<3@00
09?<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo073<
c<`00`000?ooooooo`08oooo00<0003oooo<ool02<coo`030000ooooc<co
00S<c?l00`000?ooolc<o`08c<co00<0003oooo<c?l02<c<o`030000oooo
c<co00S<c?l00`000?ooolc<o`08c<co00<0003oooo<c?l02<c<o`030000
ooooc<co00S<c?l00`000?ooolc<o`08c<co00<0003oooo<c?l02<c<o`03
0000ooooolco00Soc?l00`000?ooooo<c008olc<00<0003oooooc<`02?o<
c0030000ooooolc<00Soc<`00`000?ooooo<c008olc<00<0003oooooc<`0
2?o<c0030000ooooolc<00Soc<`00`000?ooooo<c008olc<00<0003ooooo
c<`02?o<c0030000ooooolc<00Soc<`00`000?ooooooc008ooo<00<0003o
ooo<ol`02<coc0030000ooooc?o<00S<ol`00`000?ooolcoc008c?o<00<0
003oooo<ol`02<coc0030000ooooc?o<00S<ol`00`000?ooolcoc008c?o<
00<0003oooo<ol`02<coc0030000ooooc?o<00S<ol`00`000?ooolcoc008
c?o<00<0003oool000003<c<c0T00004c<c<10000003c<c<0000000000?<
c<`20000Tlc<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;So
ool0L<c<c0030000oooooooo00Soool00`000?ooolcoo`08c?oo00<0003o
ooo<c?l02<c<o`030000ooooc<co00S<c?l00`000?ooolc<o`08c<co00<0
003oooo<c?l02<c<o`030000ooooc<co00S<c?l00`000?ooolc<o`08c<co
00<0003oooo<c?l02<c<o`030000ooooc<co00S<c?l00`000?ooolc<o`08
c<co00<0003oooooc?l02?o<o`030000ooooolc<00Soc<`00`000?ooooo<
c008olc<00<0003oooooc<`02?o<c0030000ooooolc<00Soc<`00`000?oo
ooo<c008olc<00<0003oooooc<`02?o<c0030000ooooolc<00Soc<`00`00
0?ooooo<c008olc<00<0003oooooc<`02?o<c0030000ooooooo<00Sool`0
0`000?ooolcoc008c?o<00<0003oooo<ol`02<coc0030000ooooc?o<00S<
ol`00`000?ooolcoc008c?o<00<0003oooo<ol`02<coc0030000ooooc?o<
00S<ol`00`000?ooolcoc008c?o<00<0003oooo<ol`02<coc0030000oooo
c?o<00S<ol`00`000?ooo`00000<c<c<2@0000?<c<`80000V<c<c004IVIV
R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooo
oooo00Soool00`000?ooolcoo`08c?oo00<0003oooo<c?l02<c<o`030000
ooooc<co00S<c?l00`000?ooolc<o`08c<co00<0003oooo<c?l02<c<o`03
0000ooooc<co00S<c?l00`000?ooolc<o`08c<co00<0003oooo<c?l02<c<
o`030000ooooc<co00S<c?l00`000?ooolc<o`08c<co00<0003oooooc?l0
2?o<o`030000ooooolc<00Soc<`00`000?ooooo<c008olc<00<0003ooooo
c<`02?o<c0030000ooooolc<00Soc<`00`000?ooooo<c008olc<00<0003o
ooooc<`02?o<c0030000ooooolc<00Soc<`00`000?ooooo<c008olc<00<0
003oooooc<`02?o<c0030000ooooooo<00Sool`00`000?ooolcoc008c?o<
00<0003oooo<ol`02<coc0030000ooooc?o<00S<ol`00`000?ooolcoc008
c?o<00<0003oooo<ol`02<coc0030000ooooc?o<00S<ol`00`000?ooolco
c008c?o<00<0003oooo<ol`02<coc0030000ooooc?o<00S<ol`00`000?oo
o`00000<c<c<2@0000G<c<`200000/c<c0D0002Ec<c<00AVIVJ8`;R8`;Q8
T8P1000000001HS0^<SPf8S0^8S0^?ooo`1`c<c<00<0003oooooool02?oo
o`030000ooooc?oo00S<ool00`000?ooolc<o`08c<co00<0003oooo<c?l0
2<c<o`030000ooooc<co00S<c?l00`000?ooolc<o`08c<co00<0003oooo<
c?l02<c<o`030000ooooc<co00S<c?l00`000?ooolc<o`08c<co00<0003o
ooo<c?l02<c<o`030000ooooc<co00S<c?l00`000?ooooo<o`08olco00<0
003oooooc<`02?o<c0030000ooooolc<00Soc<`00`000?ooooo<c008olc<
00<0003oooooc<`02?o<c0030000ooooolc<00Soc<`00`000?ooooo<c008
olc<00<0003oooooc<`02?o<c0030000ooooolc<00Soc<`00`000?ooooo<
c008olc<00<0003ooooool`02?ooc0030000ooooc?o<00S<ol`00`000?oo
olcoc008c?o<00<0003oooo<ol`02<coc0030000ooooc?o<00S<ol`00`00
0?ooolcoc008c?o<00<0003oooo<ol`02<coc0030000ooooc?o<00S<ol`0
0`000?ooolcoc008c?o<00<0003oooo<ol`02<coc0030000oooo000001[<
c<`200001Lc<c0030000c<c<c<c<09C<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo073<c<`00`000?ooooooo`08oooo00<0003o
ooo<ool02<coo`030000ooooc<co00S<c?l00`000?ooolc<o`08c<co00<0
003oooo<c?l02<c<o`030000ooooc<co00S<c?l00`000?ooolc<o`08c<co
00<0003oooo<c?l02<c<o`030000ooooc<co00S<c?l00`000?ooolc<o`08
c<co00<0003oooo<c?l02<c<o`030000ooooolco00Soc?l00`000?ooooo<
c008olc<00<0003oooooc<`02?o<c0030000ooooolc<00Soc<`00`000?oo
ooo<c008olc<00<0003oooooc<`02?o<c0030000ooooolc<00Soc<`00`00
0?ooooo<c008olc<00<0003oooooc<`02?o<c0030000ooooolc<00Soc<`0
0`000?ooooooc008ooo<00<0003oooo<ol`02<coc0030000ooooc?o<00S<
ol`00`000?ooolcoc008c?o<00<0003oooo<ol`02<coc0030000ooooc?o<
00S<ol`00`000?ooolcoc008c?o<00<0003oooo<ol`02<coc0030000oooo
c?o<00S<ol`00`000?ooolcoc008c?o<00<0003oool00000^<c<c004IVIV
R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooo
oooo00Soool00`000?ooolcoo`08c?oo00<0003oooo<c?l02<c<o`030000
ooooc<co00S<c?l00`000?ooolc<o`08c<co00<0003oooo<c?l02<c<o`03
0000ooooc<co00S<c?l00`000?ooolc<o`08c<co00<0003oooo<c?l02<c<
o`030000ooooc<co00S<c?l00`000?ooolc<o`08c<co00<0003oooooc?l0
2?o<o`030000ooooolc<00Soc<`00`000?ooooo<c008olc<00<0003ooooo
c<`02?o<c0030000ooooolc<00Soc<`00`000?ooooo<c008olc<00<0003o
ooooc<`02?o<c0030000ooooolc<00Soc<`00`000?ooooo<c008olc<00<0
003oooooc<`02?o<c0030000ooooooo<00Sool`00`000?ooolcoc008c?o<
00<0003oooo<ol`02<coc0030000ooooc?o<00S<ol`00`000?ooolcoc008
c?o<00<0003oooo<ol`02<coc0030000ooooc?o<00S<ol`00`000?ooolco
c008c?o<00<0003oooo<ol`02<coc0030000ooooc?o<00S<ol`00`000?oo
o`00002hc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`1`c<c<00<0003oooooool02?ooo`030000ooooc?oo00S<ool00`000?oo
olc<o`08c<co00<0003oooo<c?l02<c<o`030000ooooc<co00S<c?l00`00
0?ooolc<o`08c<co00<0003oooo<c?l02<c<o`030000ooooc<co00S<c?l0
0`000?ooolc<o`08c<co00<0003oooo<c?l02<c<o`030000ooooc<co00S<
c?l00`000?ooooo<o`08olco00<0003oooooc<`02?o<c0030000ooooolc<
00Soc<`00`000?ooooo<c008olc<00<0003oooooc<`02?o<c0030000oooo
olc<00Soc<`00`000?ooooo<c008olc<00<0003oooooc<`02?o<c0030000
ooooolc<00Soc<`00`000?ooooo<c008olc<00<0003ooooool`02?ooc003
0000ooooc?o<00S<ol`00`000?ooolcoc008c?o<00<0003oooo<ol`02<co
c0030000ooooc?o<00S<ol`00`000?ooolcoc008c?o<00<0003oooo<ol`0
2<coc0030000ooooc?o<00S<ol`00`000?ooolcoc008c?o<00<0003oooo<
ol`02<coc0030000oooo00000;S<c<`016IVIXS0^8S0^4R@R04000000005
R<2hb>3HR<2hR<2hoooo073<c<`00`000?ooooooo`08oooo00<0003oooo<
ool02<coo`030000ooooc<co00S<c?l00`000?ooolc<o`08c<co00<0003o
ooo<c?l02<c<o`030000ooooc<co00S<c?l00`000?ooolc<o`08c<co00<0
003oooo<c?l02<c<o`030000ooooc<co00S<c?l00`000?ooolc<o`08c<co
00<0003oooo<c?l02<c<o`030000ooooolco00Soc?l00`000?ooooo<c008
olc<00<0003oooooc<`02?o<c0030000ooooolc<00Soc<`00`000?ooooo<
c008olc<00<0003oooooc<`02?o<c0030000ooooolc<00Soc<`00`000?oo
ooo<c008olc<00<0003oooooc<`02?o<c0030000ooooolc<00Soc<`00`00
0?ooooooc008ooo<00<0003oooo<ol`02<coc0030000ooooc?o<00S<ol`0
0`000?ooolcoc008c?o<00<0003oooo<ol`02<coc0030000ooooc?o<00S<
ol`00`000?ooolcoc008c?o<00<0003oooo<ol`02<coc0030000ooooc?o<
00S<ol`00`000?ooolcoc008c?o<00<0003oool00000^<c<c004IVIVR<2h
R<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0L<c<c0030000oooooooo
0?oooomEoooo00<0003<c<c<c<`0]/c<c004IVIVR<2hR<2hB9280@000000
00F8`;S8h=R8`;R8`;Soool0L<c<c?l0001I0000^<c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<
P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<
P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<
P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<
P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<
P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<
P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<
P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<
P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<
P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<
P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<
P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<
P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<
P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c?o<c<b2c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<olc<c8;<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<coc<c<
P/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c?o<c<b2c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<olc<c8;<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<coc<c<P/c<c004IVIVR<2hR<2hB9280@00000000B8`;S8
h=R8`;R8`;P4ooooA/c<c?oooooooooo>Oooo`04IVIVR<2hR<2hB9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00=VIVKoooo<c<`0ALc<c003IVIVc<c<
VIVI02ZIVIT00fIVI/c<c9VIV@0YVIVI00=VIVK<c<c<c<`0olc<c=g<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVIVooooc<c<04G<
c<`00fIVI/c<c9VIV@0ZVIVI00=VIVK<c<bIVIT0:IVIV@03IVIVc<c<c<c<
0?o<c<cMc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIV
I_ooolc<c008c<c<3@00033<c<`00fIVI/c<c9VIV@07VIVI200001^IVIT0
0fIVI/c<c9VIV@0?VIVI200001:IVIT00fIVI/c<c<c<c03oc<c<gLc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIVKoooo<c<`0ALc<
c003IVIVc<c<VIVI02ZIVIT00fIVI/c<c9VIV@0YVIVI00=VIVK<c<c<c<`0
olc<c=g<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVIV
ooooc<c<00c<c<`200002Lc<c0030000c<c<c<c<00[<c<`00`000<c<c<c<
c009c<c<00<0003<c<c<c<`04/c<c003IVIVc<c<VIVI02ZIVIT00fIVI/c<
c9VIV@0YVIVI00=VIVK<c<c<c<`0olc<c=g<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003IVIVooooc<c<00g<c<`300001lc<c0D00008
c<c<100000O<c<`300000/c<c0<0000>c<c<00=VIVK<c<bIVIT01iVIV@80
0003VIVI0P0000:IVIT500000YVIV@H0000=VIVI00=VIVK<c<bIVIT01iVI
V@800004VIVI0P0000:IVIT400000YVIV@H0000<VIVI00=VIVK<c<c<c<`0
olc<c=g<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVIV
ooooc<c<00k<c<`300002Lc<c0@00008c<c<0`0000O<c<`200000/c<c0@0
000=c<c<00=VIVK<c<bIVIT01iVIV@800003VIVI0P000003VIVI00000000
00>IVIT2000000>IVIT0000000000iVIV@80000<VIVI00=VIVK<c<bIVIT0
1iVIV@800003VIVI0P0000:IVIT200000YVIV@8000000iVIV@0000000003
VIVI0P0000^IVIT00fIVI/c<c<c<c03oc<c<gLc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00=VIVKoooo<c<`03lc<c080000;c<c<0`00
00W<c<`200001lc<c08000001<c<c00000000<c<c0<0000;c<c<00=VIVK<
c<bIVIT01iVIV@800003VIVI0P0000JIVIT2000000>IVIT0000000000iVI
V@80000<VIVI00=VIVK<c<bIVIT01iVIV@800003VIVI0P000003VIVI0000
000000>IVIT2000000>IVIT0000000000iVIV@80000;VIVI00=VIVK<c<c<
c<`0olc<c=g<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003
IVIVooooc<c<00_<c<`200000/c<c080000<c<c<0`0000W<c<`200001/c<
c08000000lc<c00000000002c<c<0P0000_<c<`00fIVI/c<c9VIV@07VIVI
0P0000>IVIT2000019VIV@@000000iVIV@0000000003VIVI0P0000bIVIT0
0fIVI/c<c9VIV@07VIVI0P0000:IVIT200000YVIV@800003VIVI0P000003
VIVI0000000000>IVIT200002iVIV@03IVIVc<c<c<c<0?o<c<cMc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVI_ooolc<c00;c<c<
0P0000?<c<`200003<c<c0<00008c<c<0`0000G<c<`2000000?<c<`00000
00000lc<c0030000c<c<c<c<00W<c<`00fIVI/c<c9VIV@07VIVI1`0000:I
VIT500000YVIV@H0000=VIVI00=VIVK<c<bIVIT01iVIV@H00002VIVI0P00
00:IVIT3000000>IVIT000000000100000bIVIT00fIVI/c<c<c<c03oc<c<
gLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIVKoooo<
c<`02Lc<c0/00005c<c<0P0000C<c<`200002Lc<c0800005c<c<0P000003
c<c<0000000000o<c<`00fIVI/c<c9VIV@07VIVI0P0000>IVIT2000000>I
VIT0000000000P0000BIVIT200000iVIV@80000<VIVI00=VIVK<c<bIVIT0
1iVIV@800003VIVI0P000003VIVI0000000000JIVIT200000iVIV@80000;
VIVI00=VIVK<c<c<c<`0olc<c=g<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0/c<c003IVIVooooc<c<00_<c<`200000/c<c0800007c<c<0`00
00C<c<`00`000<c<c<c<c008c<c<0P0000G<c<`2000000?<c<`000000000
3lc<c003IVIVc<c<VIVI00NIVIT200000iVIV@8000000iVIV@0000000006
VIVI0P0000>IVIT2000039VIV@03IVIVc<c<VIVI00NIVIT200000iVIV@80
00000iVIV@0000000006VIVI0P0000>IVIT200002iVIV@03IVIVc<c<c<c<
0?o<c<cMc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIV
I_ooolc<c00;c<c<0P0000;<c<`200001/c<c0<00009c<c<2@0000G<c<`2
000000?<c<`0000000003lc<c003IVIVc<c<VIVI00NIVIT200000iVIV@80
00000iVIV@0000000003VIVI0P000003VIVI0000000000>IVIT2000039VI
V@03IVIVc<c<VIVI00NIVIT200000iVIV@800002VIVI0P0000:IVIT20000
00>IVIT0000000000iVIV@80000;VIVI00=VIVK<c<c<c<`0olc<c=g<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0lc<c003IVIVooooc<c<00[<
c<`3000000C<c<`0000000000006c<c<00<0003<c<c<c<`03lc<c0@0000G
c<c<0VIVIP03c<c<VIVIVIVI00FIVIT200000iVIV@800002VIVI1@0000:I
VIT600003IVIV@9VIVH00lc<c9VIVIVIV@05VIVI1P0000BIVIT400000YVI
V@H0000<VIVI00=VIVK<c<c<c<`0olc<c=g<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h1<c<c003IVIVooooc<c<02S<c<`400005lc<c004IVIV
c<c<IVIVc<c<:IVIV@04IVIVc<c<IVIVc<c<:9VIV@03IVIVc<c<c<c<0?o<
c<cMc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIVI_oo
olc<c012c<c<00EVIVK<c<c<c<aVIVK<c<`0:9VIV@05IVIVc<c<c<c<IVIV
c<c<02NIVIT00fIVI/c<c<c<c03oc<c<gLc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P6c<c<00=VIVKoooo<c<`0@Lc<c006IVIVc<c<c<c<c<c<
IVIVc<c<9iVIV@06IVIVc<c<c<c<c<c<IVIVc<c<9YVIV@03IVIVc<c<c<c<
0?o<c<cMc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0O<c<`00fIV
I_ooooooo`10oooo00=VIVK<c<c<c<`00/c<c003IVIVc<c<c<c<02G<c<`0
0fIVI/c<c<c<c002c<c<00=VIVK<c<c<c<`0olc<c?o<c<`5c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0S<c<a3IVIV1Lc<c2QVIVH5c<c<9fIV
I_o<c<cOc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<
Q<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<olc<c8C<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c?o<c<b4c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<coc<c<Q<c<c0:8`;P1B9280@00
000000>8`;S8h=R8`;P0ohS0^?n8`;R7R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h5P00P0<00H0200:000@00X400h400h400h4300B10P05P@801H83
00J200@01h811h811h8128820@R30`49P`<12X<0104;P`4;Q04;Q04;Q0<1
38@30@f40`4>Q@<23hD30Q25108AQP<24XH20Q>600@24hL258L258L258L3
0QF70P8FQ`030aJ80aN80aN800835hP30aR800<36HP36HT36HT00`<JR@<3
6hT00`<LR@<LRP<LRP040af:0P@NRP0411j;11n;11n;11n;0`@PR`848H/0
10@QS0@RS0@RS0@RS0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd5
9hh59hh00`DXSP@5:Hh31BZ?0`D[S`<5;8l31Rf@0`H^T0<6;i0010H_T@H`
T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I80
0PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`LiU0<7>Y@010LkU0LkU@LkU@Lk
U@<8?9D223fE00@8?IH8?YH8?YH8?YH323nF0PQ0UP03242G246G246G0088
@IL324:G00<8@iL9@iP9@iP00`U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8
V@<9BIX32DZJ0`Y;VP<:C9/42TfK0PY>V`042TjL2TnL2TnL2TnL0`Y@W08:
DI`010YAW@YBW@YBW@]BW@@;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN
2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ
0PaOX@8<Gj83362R00@<HJ8=HJ8=HJ8=HZ823F:S0`eSX`<=I:<010eUX`eU
Y0eUY0eUY0<=IZ@33FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>
KZL>KZL>KZL33VnW0Pi`Y`033g2X3g6X3g6X008?LJP33g:X00<?LjP?LjT?
LjT00`mdZ@<?MJT00`mfZ@mfZPmfZP043gNZ0Q1hZP0447R[47V[47V[47V[
0a1jZ`8@Nj/0111k[11l[11l[11l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd3
4H2]00<APJdAPJhAPJh00a62[P@APjh34HB_0a65[`<AQZl34XN`0a:8/0<B
RK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<C
S[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@011>E
]1>E]A>E]A>E]@<DU[D259Ne00@DUkHDV;HDV;HDV;H359Vf0QBJ]P0359Zg
59^g59^g008DVkL359bg00<DWKLEWKPEWKP00aFN^0<EWkP00aFP^1FP^AFP
^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl5ZVl
5ZVl0aJZ_08FZk`011J[_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P035jnn
0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P4002000>KYo4c@jDc@jD02C=3Y@H0080300600P02P004
00:100>100>100>10`04P@801H4200F20`06PP0400N20@N20@N20@R20P48
P`<12H<30@Z300@12h<12h@12h@12h@30@b40`4=Q0<13XD30Pn50`8@Q@@2
4HH30Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL00`<FR0<GR0<GR002
0aN80`<HR0030aV80aV90aV900<36XT30a^900<378T378X378X010<MRP84
7XX010@NR`@OR`@OR`@OR`<488/2126;00@48H`48X`48X`48X`412><00@4
98`498d498d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h41BV>0`DZS`<5
:hl31Bb?0`H]T0<6;Y031Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B
1S>B1S>B1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD
1cRD00<7>I@31cZD00@7>i@7>iD7>iD7>iD323bE0PPmU@0423fF23jF23jF
23jF0`PoUP88@9H00`Q0U`Q1U`Q1U`02246G0`Q2U`0324>G2D>H2D>H00<9
A9P32DFH00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK10Y=
V`8:CY/010Y>W0Y?W0Y?W0Y?W0<:D9`22U6L00@:DId:DYd:DYd;DYd42e>M
00<;E9d;E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ03
35^P0PaLX00435bQ35fQ35fQ35fQ0`aNX@8<Gj4235nR0`aPXP04366R3F6R
3F6R3F:R0PeRX`<=Hj<33FBS00@=IJ<=IJ@=IJ@=IJ@33FJT0`eWY0<=J:D3
3VVU0`iZY@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L00`m`
Z0maZ0maZ0023g6X0`mbZ0033g>X3g>Y3g>Y00<?M:T33gFY00<?MZT?MZX?
MZX010mgZP8@N:X0111hZa1iZa1iZa1iZ`<@NZ/247^[00@@Nj`@O:`@O:`@
O:`447f/00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh4
4H>^0a64[`<AQJl34HJ_0a:7/0<BR;034XV`00@BRK4BR[4BR[4BR[434X^a
0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A
/`034i:c4i:d4i:d00<CTk@34iBd00@CUK@CUKDCUKDCUKD359Je0QBG]@04
59Nf59Rf59Rf59Rf0aBI]P8DV[H00aBJ]aBK]aBK]`0259^g0aBL]`0359fg
5Ifh5Ifh00<EW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<F
YKX35ZJk11JW^`8FZ;/011JX_1JY_1JY_1JY_0<FZ[`25Z^l00@FZkdF[;dF
[;dG[;d45jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o
0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P007VjOa
ooooSWZfYY_4/jWBZ9g8/jWB00:VVl@01KbhgNk^m>[YlOoooc=3Y@050020
0`01P0800X001002P@03P@03P@03P@<0184200F10P05PP<01X801007PP47
PP47PP48PP8128<30@V30`4:P`040@^30@^40@^40@^40`4<Q0<13H@30@j5
0`8?Q@<248D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700<3
5XP35hP35hP00P<GR0<368P00`<IR0<IR@<IR@030aZ90`<KR@030ab90ab:
0ab:00@37HX211j:00@47X/47h/47h/47h/3122;0P@QR`04126<12:<12:<
12:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>
10DYSP<5:Xl31B^?0`D/S`<6;I031Rj@0`H_T0041RnA1S2A1S2A1S2A0`Ha
T@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7
=i<00`LhT`LhU0LhU0031cVD0`LjU0041c^D1c^E1c^E1c^E0`PlU@88?ID0
10PmUPPnUPPnUPPnUP<8?iH2242F00<8@9L8@IL8@IL00PQ1U`<8@YL00`Q3
U`U3V0U3V0032DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX3
2T^J0`Y<V`@:CI/22TjK00@:CY`:Ci`:Ci`:Ci`32U2L0PYAW0042U6M2U:M
2U:M2e:M10]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]H
W`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ0PaOXP<<
H:8010aQXPeQXPeQXPeRXP8=HZ<33F>S0`eTX`043FFS3FFT3FFT3FFT0`eV
Y0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>
KjL23W2W00<?L:P?LJP?LJP00PmaZ0<?LZP00`mcZ0mcZ@mcZ@033gBY0`me
Z@033gJY3gJZ3gJZ00@?MjX247RZ00@@N:/@NJ/@NJ/@NJ/347Z[0Q1kZ`04
47^/47b/47b/47b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61
[Q61[P034H:^1163[P<AQ:l34HF_0a66[`<BQk034XR`0a:9/0044XVa4XZa
4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P02
4hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0044iFd4iFe4iFe4iFe
0aBF]@8DUkD011BG]QBH]QBH]QBH]P<DVKH259Zf00<DV[LDVkLDVkL00QBK
]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i
0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`FZK`FZK`35ZZl0QJ[
_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG
/KlG/Kl00aNb_`<G/kl26;C08000008H]<0@00000QRd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000BKYo7ooom/FZF_YLX2_;SM00[ooOnc
ZM;ooooooonl^=fGR[bXWLSVi^cooolc@jD400200`01P0800X001002P@03
P@03P@03P@<0184200F10P05PP<01X801007PP47PP47PP48PP8128<30@V3
0`4:P`040@^30@^40@^40@^40`4<Q0<13H@30@j50`8?Q@<248D40Q660`8B
QP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700<35XP35hP35hP00P<GR0<3
68P00`<IR0<IR@<IR@030aZ90`<KR@030ab90ab:0ab:00@37HX211j:00@4
7X/47h/47h/47h/3122;0P@QR`04126<12:<12:<12:<10@SS00412B<12B=
12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>10DYSP<5:Xl31B^?0`D/
S`<6;I031Rj@0`H_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHc
TPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU003
1cVD0`LjU0041c^D1c^E1c^E1c^E0`PlU@88?ID010PmUPPnUPPnUPPnUP<8
?iH2242F00<8@9L8@IL8@IL00PQ1U`<8@YL00`Q3U`U3V0U3V0032DBH0`U5
V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`@:CI/22TjK
00@:CY`:Ci`:Ci`:Ci`32U2L0PYAW0042U6M2U:M2U:M2e:M10]CW@032eBM
2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<
G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ0PaOXP<<H:8010aQXPeQXPeQXPeR
XP8=HZ<33F>S0`eTX`043FFS3FFT3FFT3FFT0`eVY0<=Ij@33FRU0`iYY@<>
JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00<?L:P?LJP?
LJP00PmaZ0<?LZP00`mcZ0mcZ@mcZ@033gBY0`meZ@033gJY3gJZ3gJZ00@?
MjX247RZ00@@N:/@NJ/@NJ/@NJ/347Z[0Q1kZ`0447^/47b/47b/47b/111m
[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^1163[P<A
Q:l34HF_0a66[`<BQk034XR`0a:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;40
11:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B
/a>B]1>B]0034i>d0a>D]0044iFd4iFe4iFe4iFe0aBF]@8DUkD011BG]QBH
]QBH]QBH]P<DVKH259Zf00<DV[LDVkLDVkL00QBK]`<DW;L00aBM]aFM^1FM
^0035Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`@FYk/25ZRk00@FZ;`FZK`FZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm
11N]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl2
6;C000?8h=Q8T8Q8T8P034R@R0030000b>3HB92800e8T8P0100001Rd`1Rd
`<SPf0i8T8P00`0001Rd`1Rd`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0P00P00;VjOaooooZ9g8oooo/jWBH4bJSWZfN6F^Z9g8oooooogo00?o
ool00c=3Y@00P000P00300200`01P0800X001002P@03P@03P@03P@<01842
00F10P05PP<01X801007PP47PP47PP48PP8128<30@V30`4:P`040@^30@^4
0@^40@^40`4<Q0<13H@30@j50`8?Q@040Q25oooooooooooo0`8AQP<24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`030aJ80aN80aN800835hP30aR8
00<36HP36HT36HT00`<JR@<36hT00`<LR@<LRP<LRP040af:0P@NRP0411j;
11n;11n;11n;0`@PR`848H/010@QS0@RS0@RS0@RS0@48h`010@TS0@TS@@T
S@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP@5:Hh31BZ?0`D[S`<5;8l3
1Rf@0`H^T0<6;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86<i86<i86
<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7>9@00`Li
U0<7>Y@010LkU0LkU@LkU@LkU@<8?9D223fE00@8?IH8?YH8?YH8?YH323nF
0PQ0UP03242G246G246G0088@IL324:G00<8@iL9@iP9@iP00`U4V0<9AIP0
0`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/42TfK0PY>V`04
2TjL2TnL2TnL2TnL0`Y@W08:DI`010YAW@YBW@YBW@]BW@@;Did00`]DW@]D
WP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<Fj0235bP
00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@8<Gj83362R00@<HJ8=HJ8=HJ8=HZ82
3F:S0`eSX`<=I:<010eUX`eUY0eUY0eUY0<=IZ@33FNT0`eXY@<>JJD33VZU
10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`033g2X3g6X3g6X
008?LJP33g:X00<?LjP?LjT?LjT00`mdZ@<?MJT00`mfZ@mfZPmfZP043gNZ
0Q1hZP0447R[47V[47V[47V[0a1jZ`8@Nj/0111k[11l[11l[11l[0@@OJ`0
111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P@APjh34HB_
0a65[`<AQZl34XN`0a:8/0<BRK0011:9/A::/A::/A::/@<BRk424Xba00@B
S;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c00<CT[<C
T[@CT[@00a>C]0<CU;@011>E]1>E]A>E]A>E]@<DU[D259Ne00@DUkHDV;HD
V;HDV;H359Vf0QBJ]P0359Zg59^g59^g008DVkL359bg00<DWKLEWKPEWKP0
0aFN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/4
5ZNk0QJX^`045ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`011J[_AJ/_AJ/_AN/_@@G
[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd
`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf00=R<2h00E8T8P0000H]<0H
]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^08008003Y^WlOooooooom_Lk61<VY>5^[>Yd[bhgF1<VYV?_ZJK
a<S3gooooc=3Y@H00803oooo0P02P00300:1oooooooo00;oool200B100@0
1H7oool01H801H8200J21?ooo`030@R20@R3oooo00?oool30@Z300Goool1
2h@12h@12hCoool00P4<Q0040@f4oooo0@f4oooo0P4>Q@040Pn5oooo0Pn5
oooo0P8@Q@040Q66oooo0Q660Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<2
5HL20QJ700<35XP35hP35hP00P<GR0<368P00`<IR0<IR@<IR@030aZ90`<K
R@030ab90ab:0ab:00@37HX211j:00@47X/47h/47h/47h/3122;0P@QR`04
126<12:<12:<12:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DW
SPDWSP031BR>10DYSP<5:Xl31B^?0`D/S`<6;I031Rj@0`H_T0041RnA1S2A
1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP02
1cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0041c^D1c^E1c^E1c^E
0`PlU@88?ID010PmUPPnUPPnUPPnUP<8?iH2242F00<8@9L8@IL8@IL00PQ1
U`<8@YL00`Q3U`U3V0U3V0032DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI
0`U9VP<9BYX32T^J0`Y<V`@:CI/22TjK00@:CY`:Ci`:Ci`:Ci`32U2L0PYA
W0042U6M2U:M2U:M2e:M10]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;
Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ42
35nQ0PaOXP<<H:8010aQXPeQXPeQXPeRXP8=HZ<33F>S0`eTX`043FFS3FFT
3FFT3FFT0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^
Y`i^Y`i^Y`<>KjL23W2W00<?L:P?LJP?LJP00PmaZ0<?LZP00`mcZ0mcZ@mc
Z@033gBY0`meZ@033gJY3gJZ3gJZ00@?MjX247RZ00@@N:/@NJ/@NJ/@NJ/3
47Z[0Q1kZ`0447^/47b/47b/47b/111m[00447j/47j]47j]47n]0Q5o[@<A
P:d00a61[A61[Q61[P034H:^1163[P<AQ:l34HF_0a66[`<BQk034XR`0a:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0044iFd
4iFe4iFe4iFe0aBF]@8DUkD011BG]QBH]QBH]QBH]P<DVKH259Zf00<DV[LD
VkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO^0035J2h5J2i5J2i
00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`FZK`F
ZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000C8h=R8`;R8`;R8`;P60000
18S0^003B9280000b>3H00:8`;P900000XS0^005B92800006;C06;C0b>3H
00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P3002000jKYo7ooonl^=fISkkooooFdMgKg>cco_nVVlC^k_B5M[2CQK[o
oolc@jD4002000Ooool00H000H000H3oool00X3oool00`03P@05oooo00B1
00B100F1oooo00801H802@06P_ooo`06PP07PP47P_ooo`48P_ooo`48P`03
0@V300Coool12X<12X?oool30@^400Ooool138@138@13HCoool13HCoool0
0P4>Q@030Pn5oooo0Pn500Coool30Q660`8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700<35XP35hP35hP00P<GR0<368P00`<IR0<IR@<IR@030aZ9
0`<KR@030ab90ab:0ab:00@37HX211j:00@47X/47h/47h/47h/3122;0P@Q
R`04126<12:<12:<12:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DW
S@DWSPDWSP031BR>10DYSP<5:Xl31B^?0`D/S`<6;I031Rj@0`H_T0041RnA
1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLe
TP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0041c^D1c^E1c^E
1c^E0`PlU@88?ID010PmUPPnUPPnUPPnUP<8?iH2242F00<8@9L8@IL8@IL0
0PQ1U`<8@YL00`Q3U`U3V0U3V0032DBH0`U5V0032DJH2DJI2DJI00@9AiT3
2DRI0`U9VP<9BYX32T^J0`Y<V`@:CI/22TjK00@:CY`:Ci`:Ci`:Ci`32U2L
0PYAW0042U6M2U:M2U:M2e:M10]CW@032eBM2eBN2eBN00<;EIh32eJN00<;
Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<
GZ4235nQ0PaOXP<<H:8010aQXPeQXPeQXPeRXP8=HZ<33F>S0`eTX`043FFS
3FFT3FFT3FFT0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]
Y`i^Y`i^Y`i^Y`<>KjL23W2W00<?L:P?LJP?LJP00PmaZ0<?LZP00`mcZ0mc
Z@mcZ@033gBY0`meZ@033gJY3gJZ3gJZ00@?MjX247RZ00@@N:/@NJ/@NJ/@
NJ/347Z[0Q1kZ`0447^/47b/47b/47b/111m[00447j/47j]47j]47n]0Q5o
[@<AP:d00a61[A61[Q61[P034H:^1163[P<AQ:l34HF_0a66[`<BQk034XR`
0a:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[80
0a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]004
4iFd4iFe4iFe4iFe0aBF]@8DUkD011BG]QBH]QBH]QBH]P<DVKH259Zf00<D
V[LDVkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO^0035J2h5J2i
5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`F
ZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn00<G
[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000C8h=R8`;R8`;R8`;P6
000018S0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028
`;R8`;Q8T8P000000QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<0
08003i^WlOoooiV?_YN:_=CCj>n//omfNnjOZe]HYJJKa9JOdV1<V[bhgOoo
oc=3Y@03002000Ooool00H000H000H3oool00X3oool00`03P@0@oooo00B1
00B1oooo00F1oooo00F200J2oooo00J200N20@N2oooo0@R2oooo0@R30`49
P`0>oooo0@Z3oooo0@^3oooo0@^4oooo0@b4oooo0@b40@f4oooo0@f4oooo
0P4>Q@040Pn5oooo0Pn5oooo0P8@Q@@24HH30Q:60P8CQP040Q>70QB70QB7
0QB70`8EQ`825XL00`<FR0<GR0<GR0020aN80`<HR0030aV80aV90aV900<3
6XT30a^900<378T378X378X010<MRP847XX010@NR`@OR`@OR`@OR`<488/2
126;00@48H`48X`48X`48X`412><00@498`498d498d49Hd21BF=0`DVS@03
1BN=1BN>1BN>00<5:8h41BV>0`DZS`<5:hl31Bb?0`H]T0<6;Y031Rn@00@6
;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP031cBB1cFB
1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD00@7>i@7>iD7
>iD7>iD323bE0PPmU@0423fF23jF23jF23jF0`PoUP88@9H00`Q0U`Q1U`Q1
U`02246G0`Q2U`0324>G2D>H2D>H00<9A9P32DFH00<9AYP9AYT9AYT010U7
V@<9B9T32DVJ0`U:VP<:BiX32TbK10Y=V`8:CY/010Y>W0Y?W0Y?W0Y?W0<:
D9`22U6L00@:DId:DYd:DYd;DYd42e>M00<;E9d;E9h;E9h00`]EWP<;EYh0
0`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ35fQ35fQ
0`aNX@8<Gj4235nR0`aPXP04366R3F6R3F6R3F:R0PeRX`<=Hj<33FBS00@=
IJ<=IJ@=IJ@=IJ@33FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV0Pi]YP04
3VfW3VjW3VjW3VjW0`i_Y`8>L:L00`m`Z0maZ0maZ0023g6X0`mbZ0033g>X
3g>Y3g>Y00<?M:T33gFY00<?MZT?MZX?MZX010mgZP8@N:X0111hZa1iZa1i
Za1iZ`<@NZ/247^[00@@Nj`@O:`@O:`@O:`447f/00@@OZ`@OZd@OZd@Ojd2
4Gn]0a60[@034H6]4H6^4H6^00<APZh44H>^0a64[`<AQJl34HJ_0a:7/0<B
R;034XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>
/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<CTk@34iBd
00@CUK@CUKDCUKDCUKD359Je0QBG]@0459Nf59Rf59Rf59Rf0aBI]P8DV[H0
0aBJ]aBK]aBK]`0259^g0aBL]`0359fg5Ifh5Ifh00<EW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk11JW^`8FZ;/011JX_1JY
_1JY_1JY_0<FZ[`25Z^l00@FZkdF[;dF[;dG[;d45jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;
R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0
^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h0P0000>8`;P0
14R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P20020
00ZKYo7ooonGR[ajK:ZcanRYKZ38`mnCQKYKAY>ISkh2N6F^00A29hF_YL[o
oolc@jD400200`01P003oooo00:000:100Coool200B100Coool01H7oool0
1H8200J21?ooo`030@R20@R30@R300<12H<03_ooo`4:Poooo`4;Poooo`4;
Q?ooo`4<Q?ooo`4<Q04=Q?ooo`4=Q?ooo`813XD00`8?QOooo`8?Q@04oooo
0`8AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`030aJ80aN80aN8
00835hP30aR800<36HP36HT36HT00`<JR@<36hT00`<LR@<LRP<LRP040af:
0P@NRP0411j;11n;11n;11n;0`@PR`848H/010@QS0@RS0@RS0@RS0@48h`0
10@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP@5:Hh31BZ?
0`D[S`<5;8l31Rf@0`H^T0<6;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6
<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7
>9@7>9@00`LiU0<7>Y@010LkU0LkU@LkU@LkU@<8?9D223fE00@8?IH8?YH8
?YH8?YH323nF0PQ0UP03242G246G246G0088@IL324:G00<8@iL9@iP9@iP0
0`U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/4
2TfK0PY>V`042TjL2TnL2TnL2TnL0`Y@W08:DI`010YAW@YBW@YBW@]BW@@;
Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJ
X0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@8<Gj83362R00@<HJ8=
HJ8=HJ8=HZ823F:S0`eSX`<=I:<010eUX`eUY0eUY0eUY0<=IZ@33FNT0`eX
Y@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`03
3g2X3g6X3g6X008?LJP33g:X00<?LjP?LjT?LjT00`mdZ@<?MJT00`mfZ@mf
ZPmfZP043gNZ0Q1hZP0447R[47V[47V[47V[0a1jZ`8@Nj/0111k[11l[11l
[11l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62
[P@APjh34HB_0a65[`<AQZl34XN`0a:8/0<BRK0011:9/A::/A::/A::/@<B
Rk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<3
4i6c00<CT[<CT[@CT[@00a>C]0<CU;@011>E]1>E]A>E]A>E]@<DU[D259Ne
00@DUkHDV;HDV;HDV;H359Vf0QBJ]P0359Zg59^g59^g008DVkL359bg00<D
WKLEWKPEWKP00aFN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj
0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`011J[_AJ/
_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<0
0028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0
^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2002000>KYo7oooooool00_ooo`0:ojf`ogIknLgDoNg^
ooooYY_4QGJ`_;SMoooo<d>U1@00P0<00H000oooo`02P002P@0300>100?o
ool0187oool00P05P@0300F2oooo00J200801X801007PP47P_ooo`48PP81
28<3oooo0P4:P`0;oooo0@^3oooo0@^4oooo0@b4oooo0@b40@f4oooo0@f4
00;oool01@4>Q@8?QOooo`8?QOooo`020Q2500Coool24HH24HH24HH30Q:6
0P8CQP040Q>70QB70QB70QB70`8EQ`825XL00`<FR0<GR0<GR0020aN80`<H
R0030aV80aV90aV900<36XT30a^900<378T378X378X010<MRP847XX010@N
R`@OR`@OR`@OR`<488/2126;00@48H`48X`48X`48X`412><00@498`498d4
98d49Hd21BF=0`DVS@031BN=1BN>1BN>00<5:8h41BV>0`DZS`<5:hl31Bb?
0`H]T0<6;Y031Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B
1S>B0PHdTP031cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7
>I@31cZD00@7>i@7>iD7>iD7>iD323bE0PPmU@0423fF23jF23jF23jF0`Po
UP88@9H00`Q0U`Q1U`Q1U`02246G0`Q2U`0324>G2D>H2D>H00<9A9P32DFH
00<9AYP9AYT9AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK10Y=V`8:CY/0
10Y>W0Y?W0Y?W0Y?W0<:D9`22U6L00@:DId:DYd:DYd;DYd42e>M00<;E9d;
E9h;E9h00`]EWP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaL
X00435bQ35fQ35fQ35fQ0`aNX@8<Gj4235nR0`aPXP04366R3F6R3F6R3F:R
0PeRX`<=Hj<33FBS00@=IJ<=IJ@=IJ@=IJ@33FJT0`eWY0<=J:D33VVU0`iZ
Y@@>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L00`m`Z0maZ0ma
Z0023g6X0`mbZ0033g>X3g>Y3g>Y00<?M:T33gFY00<?MZT?MZX?MZX010mg
ZP8@N:X0111hZa1iZa1iZa1iZ`<@NZ/247^[00@@Nj`@O:`@O:`@O:`447f/
00@@OZ`@OZd@OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh44H>^0a64
[`<AQJl34HJ_0a:7/0<BR;034XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@04
4Xbb4Xfb4Xfb4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c
4i:d4i:d00<CTk@34iBd00@CUK@CUKDCUKDCUKD359Je0QBG]@0459Nf59Rf
59Rf59Rf0aBI]P8DV[H00aBJ]aBK]aBK]`0259^g0aBL]`0359fg5Ifh5Ifh
00<EW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk
11JW^`8FZ;/011JX_1JY_1JY_1JY_0<FZ[`25Z^l00@FZkdF[;dF[;dG[;d4
5jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H
]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h
00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P018S0^080
0005R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0`00P00:XJcbnLgDhRHlm;FohRHlm6emo>?YoooooNg^ojf`0_ooo`03
<d>U0020002000@00803006000?oool00X000X400oooo`8018401Oooo`05
P@05P@05P_ooo`0200J20oooo`040@N20@R20@R3oooo0`49P`812X<03Ooo
o`4;P`4;Q?ooo`4;Q04<Q?ooo`4<Q04=Q?ooo`4=Q?ooo`4>Q@02oooo0P8?
Q@030Q25oooooooo00;oool20Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<2
5HL20QJ700<35XP35hP35hP00P<GR0<368P00`<IR0<IR@<IR@030aZ90`<K
R@030ab90ab:0ab:00@37HX211j:00@47X/47h/47h/47h/3122;0P@QR`04
126<12:<12:<12:<10@SS00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DW
SPDWSP031BR>10DYSP<5:Xl31B^?0`D/S`<6;I031Rj@0`H_T0041RnA1S2A
1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP02
1cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0041c^D1c^E1c^E1c^E
0`PlU@88?ID010PmUPPnUPPnUPPnUP<8?iH2242F00<8@9L8@IL8@IL00PQ1
U`<8@YL00`Q3U`U3V0U3V0032DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI
0`U9VP<9BYX32T^J0`Y<V`@:CI/22TjK00@:CY`:Ci`:Ci`:Ci`32U2L0PYA
W0042U6M2U:M2U:M2e:M10]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;
Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ42
35nQ0PaOXP<<H:8010aQXPeQXPeQXPeRXP8=HZ<33F>S0`eTX`043FFS3FFT
3FFT3FFT0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^
Y`i^Y`i^Y`<>KjL23W2W00<?L:P?LJP?LJP00PmaZ0<?LZP00`mcZ0mcZ@mc
Z@033gBY0`meZ@033gJY3gJZ3gJZ00@?MjX247RZ00@@N:/@NJ/@NJ/@NJ/3
47Z[0Q1kZ`0447^/47b/47b/47b/111m[00447j/47j]47j]47n]0Q5o[@<A
P:d00a61[A61[Q61[P034H:^1163[P<AQ:l34HF_0a66[`<BQk034XR`0a:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>
/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0044iFd
4iFe4iFe4iFe0aBF]@8DUkD011BG]QBH]QBH]QBH]P<DVKH259Zf00<DV[LD
VkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO^0035J2h5J2i5J2i
00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`FZK`F
ZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003
B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P0
00000QRd`003b>3HR<2hR<2h00>8`;P4000018S0^004B92800006;C06;C0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^08008003I^WlOg]k^8V??ke
n?N9UoARK_>P[_ARK_omoon]/?cSjOoooc=3Y@0700200`01P003oooo00:0
00:100<00h4300B10P05P@801H8300J200H01h811h811h8128;oool128<3
0@V30`4:P`040@^30@^40@^40@^40`4<Q0<13H@30@j50`8?Q@<248D40Q66
0`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700<35XP35hP35hP00P<G
R0<368P00`<IR0<IR@<IR@030aZ90`<KR@030ab90ab:0ab:00@37HX211j:
00@47X/47h/47h/47h/3122;0P@QR`04126<12:<12:<12:<10@SS00412B<
12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>10DYSP<5:Xl31B^?
0`D/S`<6;I031Rj@0`H_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHc
TPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0Lh
U0031cVD0`LjU0041c^D1c^E1c^E1c^E0`PlU@88?ID010PmUPPnUPPnUPPn
UP<8?iH2242F00<8@9L8@IL8@IL00PQ1U`<8@YL00`Q3U`U3V0U3V0032DBH
0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`@:CI/2
2TjK00@:CY`:Ci`:Ci`:Ci`32U2L0PYAW0042U6M2U:M2U:M2e:M10]CW@03
2eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aK
X08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ0PaOXP<<H:8010aQXPeQXPeQ
XPeRXP8=HZ<33F>S0`eTX`043FFS3FFT3FFT3FFT0`eVY0<=Ij@33FRU0`iY
Y@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00<?L:P?
LJP?LJP00PmaZ0<?LZP00`mcZ0mcZ@mcZ@033gBY0`meZ@033gJY3gJZ3gJZ
00@?MjX247RZ00@@N:/@NJ/@NJ/@NJ/347Z[0Q1kZ`0447^/47b/47b/47b/
111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^1163
[P<AQ:l34HF_0a66[`<BQk034XR`0a:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d0a>D]0044iFd4iFe4iFe4iFe0aBF]@8DUkD011BG
]QBH]QBH]QBH]P<DVKH259Zf00<DV[LDVkLDVkL00QBK]`<DW;L00aBM]aFM
^1FM^0035Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj
0aJV^`@FYk/25ZRk00@FZ;`FZK`FZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm
5jbm11N]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G
/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0
^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8
`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0P00P003VjOam/S<hRHl00;o[K001mlT;_nTW_Jl
aOn]/>ikS?oooc=3Y@0800200`01P003oooo00:000:100<00h4300B10P05
P@801H8300J200H01h811h811h8128;oool128<30@V300Coool12X<12X<1
2h<30@^40`4<Q0<13H@30@j50`8?Q@<248D40Q660`8BQP824hH0108CQ`8D
Q`8DQ`8DQ`<25HL20QJ700<35XP35hP35hP00P<GR0<368P00`<IR0<IR@<I
R@030aZ90`<KR@030ab90ab:0ab:00@37HX211j:00@47X/47h/47h/47h/3
122;0P@QR`04126<12:<12:<12:<10@SS00412B<12B=12B=12F=0PDUS@<5
9Xd00`DWS@DWSPDWSP031BR>10DYSP<5:Xl31B^?0`D/S`<6;I031Rj@0`H_
T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHcTPHcTP86=9800`Ld
TPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU0031cVD0`LjU0041c^D
1c^E1c^E1c^E0`PlU@88?ID010PmUPPnUPPnUPPnUP<8?iH2242F00<8@9L8
@IL8@IL00PQ1U`<8@YL00`Q3U`U3V0U3V0032DBH0`U5V0032DJH2DJI2DJI
00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`@:CI/22TjK00@:CY`:Ci`:Ci`:
Ci`32U2L0PYAW0042U6M2U:M2U:M2e:M10]CW@032eBM2eBN2eBN00<;EIh3
2eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<G:0010aLX@aMX@aM
X@aMX@<<GZ4235nQ0PaOXP<<H:8010aQXPeQXPeQXPeRXP8=HZ<33F>S0`eT
X`043FFS3FFT3FFT3FFT0`eVY0<=Ij@33FRU0`iYY@<>JZD43V^V0`i/YP8>
KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00<?L:P?LJP?LJP00PmaZ0<?LZP0
0`mcZ0mcZ@mcZ@033gBY0`meZ@033gJY3gJZ3gJZ00@?MjX247RZ00@@N:/@
NJ/@NJ/@NJ/347Z[0Q1kZ`0447^/47b/47b/47b/111m[00447j/47j]47j]
47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^1163[P<AQ:l34HF_0a66[`<B
Qk034XR`0a:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B/a>B]1>B]0034i>d
0a>D]0044iFd4iFe4iFe4iFe0aBF]@8DUkD011BG]QBH]QBH]QBH]P<DVKH2
59Zf00<DV[LDVkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO^003
5J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@F
Z;`FZK`FZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00:8`;P900000XS0^005B92800006;C06;C0
b>3H00>8`;P2000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P003VjOanLgDmhVG00;oool01on]
/>4F=?mfNonTW^8V??n9Oc=3Y@0800200`01P003oooo00:000:100<00h43
00B10P05P@801H8300J200D01h811h811h81288128<01?ooo`<12X<0104;
P`4;Q04;Q04;Q0<138@00`4=Q?ooo`4=Q0030@j50`8?Q@<248D40Q660`8B
QP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700<35XP35hP35hP00P<GR0<3
68P00`<IR0<IR@<IR@030aZ90`<KR@030ab90ab:0ab:00@37HX211j:00@4
7X/47h/47h/47h/3122;0P@QR`04126<12:<12:<12:<10@SS00412B<12B=
12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>10DYSP<5:Xl31B^?0`D/
S`<6;I031Rj@0`H_T0041RnA1S2A1S2A1S2A0`HaT@86<Y4010HbTPHcTPHc
TPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`LhT`LhU0LhU003
1cVD0`LjU0041c^D1c^E1c^E1c^E0`PlU@88?ID010PmUPPnUPPnUPPnUP<8
?iH2242F00<8@9L8@IL8@IL00PQ1U`<8@YL00`Q3U`U3V0U3V0032DBH0`U5
V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<V`@:CI/22TjK
00@:CY`:Ci`:Ci`:Ci`32U2L0PYAW0042U6M2U:M2U:M2e:M10]CW@032eBM
2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl335ZP0`aKX08<
G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ0PaOXP<<H:8010aQXPeQXPeQXPeR
XP8=HZ<33F>S0`eTX`043FFS3FFT3FFT3FFT0`eVY0<=Ij@33FRU0`iYY@<>
JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W00<?L:P?LJP?
LJP00PmaZ0<?LZP00`mcZ0mcZ@mcZ@033gBY0`meZ@033gJY3gJZ3gJZ00@?
MjX247RZ00@@N:/@NJ/@NJ/@NJ/347Z[0Q1kZ`0447^/47b/47b/47b/111m
[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P034H:^1163[P<A
Q:l34HF_0a66[`<BQk034XR`0a:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;40
11:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@/`<CTK<00a>B
/a>B]1>B]0034i>d0a>D]0044iFd4iFe4iFe4iFe0aBF]@8DUkD011BG]QBH
]QBH]QBH]P<DVKH259Zf00<DV[LDVkLDVkL00QBK]`<DW;L00aBM]aFM^1FM
^0035Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV
^`@FYk/25ZRk00@FZ;`FZK`FZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm
11N]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl2
6;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P900000XS0^005
B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000NKYo7oooocX:kdHVkoooogRIOicM@0
0_ooo`03lj2^oooo<d>U00P0080300600P02P00400:100>100>100>10`04
P@801H4200F20`06PP0400N20@N20@N20@R20P48P`<12H<30@Z300@12h<1
2h@12h@12h@30@b40`4=Q0<13XD30Pn50`8@Q@@24HH30Q:60P8CQP040Q>7
0QB70QB70QB70`8EQ`825XL00`<FR0<GR0<GR0020aN80`<HR0030aV80aV9
0aV900<36XT30a^900<378T378X378X010<MRP847XX010@NR`@OR`@OR`@O
R`<488/2126;00@48H`48X`48X`48X`412><00@498`498d498d49Hd21BF=
0`DVS@031BN=1BN>1BN>00<5:8h41BV>0`DZS`<5:hl31Bb?0`H]T0<6;Y03
1Rn@00@6;i46<946<946<9431S6A0PHbT@041S:B1S>B1S>B1S>B0PHdTP03
1cBB1cFB1cFB0087=I<31cJC0`LgT`031cRC1cRD1cRD00<7>I@31cZD00@7
>i@7>iD7>iD7>iD323bE0PPmU@0423fF23jF23jF23jF0`PoUP88@9H00`Q0
U`Q1U`Q1U`02246G0`Q2U`0324>G2D>H2D>H00<9A9P32DFH00<9AYP9AYT9
AYT010U7V@<9B9T32DVJ0`U:VP<:BiX32TbK10Y=V`8:CY/010Y>W0Y?W0Y?
W0Y?W0<:D9`22U6L00@:DId:DYd:DYd;DYd42e>M00<;E9d;E9h;E9h00`]E
WP<;EYh00`]GWP]GW`]GW`032eRO10]IW`<<FZ0335^P0PaLX00435bQ35fQ
35fQ35fQ0`aNX@8<Gj4235nR0`aPXP04366R3F6R3F6R3F:R0PeRX`<=Hj<3
3FBS00@=IJ<=IJ@=IJ@=IJ@33FJT0`eWY0<=J:D33VVU0`iZY@@>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW0`i_Y`8>L:L00`m`Z0maZ0maZ0023g6X0`mb
Z0033g>X3g>Y3g>Y00<?M:T33gFY00<?MZT?MZX?MZX010mgZP8@N:X0111h
Za1iZa1iZa1iZ`<@NZ/247^[00@@Nj`@O:`@O:`@O:`447f/00@@OZ`@OZd@
OZd@Ojd24Gn]0a60[@034H6]4H6^4H6^00<APZh44H>^0a64[`<AQJl34HJ_
0a:7/0<BR;034XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb
4Xfb0Q:>/P034hjb4hnb4hnb008CSk<34i2c0a>A/`034i:c4i:d4i:d00<C
Tk@34iBd00@CUK@CUKDCUKDCUKD359Je0QBG]@0459Nf59Rf59Rf59Rf0aBI
]P8DV[H00aBJ]aBK]aBK]`0259^g0aBL]`0359fg5Ifh5Ifh00<EW[P35Inh
00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk11JW^`8FZ;/0
11JX_1JY_1JY_1JY_0<FZ[`25Z^l00@FZkdF[;dF[;dG[;d45jfm00<G[[dG
[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0
^8S0^00;R<2h00=8T8P00038h=P03HS0^005B92800006;C06;C0b>3H00f8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3
002000^KYo7oooooRGooooocX:kaTj7ooooooOocX:kono`c@jD02000P0<0
0H0200:000@00X400h400h400h4300B10P05P@801H8300J200@01h811h81
1h8128820@R30`49P`<12X<0104;P`4;Q04;Q04;Q0<138@30@f40`4>Q@<2
3hD30Q25108AQP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`030aJ8
0aN80aN800835hP30aR800<36HP36HT36HT00`<JR@<36hT00`<LR@<LRP<L
RP040af:0P@NRP0411j;11n;11n;11n;0`@PR`848H/010@QS0@RS0@RS0@R
S0@48h`010@TS0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP@5
:Hh31BZ?0`D[S`<5;8l31Rf@0`H^T0<6;i0010H_T@H`T@H`T@H`T@<6<I42
1S:A00@6<Y86<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC
00<7>9<7>9@7>9@00`LiU0<7>Y@010LkU0LkU@LkU@LkU@<8?9D223fE00@8
?IH8?YH8?YH8?YH323nF0PQ0UP03242G246G246G0088@IL324:G00<8@iL9
@iP9@iP00`U4V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;
VP<:C9/42TfK0PY>V`042TjL2TnL2TnL2TnL0`Y@W08:DI`010YAW@YBW@YB
W@]BW@@;Did00`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l4
2eVO0`aJX0<<Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@8<Gj83362R
00@<HJ8=HJ8=HJ8=HZ823F:S0`eSX`<=I:<010eUX`eUY0eUY0eUY0<=IZ@3
3FNT0`eXY@<>JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW
0Pi`Y`033g2X3g6X3g6X008?LJP33g:X00<?LjP?LjT?LjT00`mdZ@<?MJT0
0`mfZ@mfZPmfZP043gNZ0Q1hZP0447R[47V[47V[47V[0a1jZ`8@Nj/0111k
[11l[11l[11l[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhA
PJh00a62[P@APjh34HB_0a65[`<AQZl34XN`0a:8/0<BRK0011:9/A::/A::
/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?
/`<CT;<34i6c00<CT[<CT[@CT[@00a>C]0<CU;@011>E]1>E]A>E]A>E]@<D
U[D259Ne00@DUkHDV;HDV;HDV;H359Vf0QBJ]P0359Zg59^g59^g008DVkL3
59bg00<DWKLEWKPEWKP00aFN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`0
11J[_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o
5k6o00<G/[l35k>o0QRd`0o8h=P00`000<SPf<SPf00=b>3H00<0000H]<0H
]<003lSPf00300006;C06;C000:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P400200i^Wl@06oooolj2^m;Fom[c5nmWJ<d>U2@00P0<00H0200:000@0
0X400h400h400h4300B10P05P@801H8300J200@01h811h811h8128820@R3
0`49P`<12X<0104;P`4;Q04;Q04;Q0<138@30@f40`4>Q@<23hD30Q25108A
QP<24XH20Q>600@24hL258L258L258L30QF70P8FQ`030aJ80aN80aN80083
5hP30aR800<36HP36HT36HT00`<JR@<36hT00`<LR@<LRP<LRP040af:0P@N
RP0411j;11n;11n;11n;0`@PR`848H/010@QS0@RS0@RS0@RS0@48h`010@T
S0@TS@@TS@@US@859Hd31BJ=00<59hd59hh59hh00`DXSP@5:Hh31BZ?0`D[
S`<5;8l31Rf@0`H^T0<6;i0010H_T@H`T@H`T@H`T@<6<I421S:A00@6<Y86
<i86<i86<i821SBB00<7=987=I87=I800PLeT`<7=Y<31cNC00<7>9<7>9@7
>9@00`LiU0<7>Y@010LkU0LkU@LkU@LkU@<8?9D223fE00@8?IH8?YH8?YH8
?YH323nF0PQ0UP03242G246G246G0088@IL324:G00<8@iL9@iP9@iP00`U4
V0<9AIP00`U6V0U6V@U6V@042DNI0`U8V@<9BIX32DZJ0`Y;VP<:C9/42TfK
0PY>V`042TjL2TnL2TnL2TnL0`Y@W08:DI`010YAW@YBW@YBW@]BW@@;Did0
0`]DW@]DWP]DWP032eFN0`]FWP032eNN2eNO2eNO00<;F9l42eVO0`aJX0<<
Fj0235bP00@<G:4<GJ4<GJ4<GJ4335jQ0PaOX@8<Gj83362R00@<HJ8=HJ8=
HJ8=HZ823F:S0`eSX`<=I:<010eUX`eUY0eUY0eUY0<=IZ@33FNT0`eXY@<>
JJD33VZU10i[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL33VnW0Pi`Y`033g2X
3g6X3g6X008?LJP33g:X00<?LjP?LjT?LjT00`mdZ@<?MJT00`mfZ@mfZPmf
ZP043gNZ0Q1hZP0447R[47V[47V[47V[0a1jZ`8@Nj/0111k[11l[11l[11l
[0@@OJ`0111n[11n[A1n[A1o[@8AOjd34H2]00<APJdAPJhAPJh00a62[P@A
Pjh34HB_0a65[`<AQZl34XN`0a:8/0<BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb00<CS[8CSk8CSk800Q>?/`<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0<CU;@011>E]1>E]A>E]A>E]@<DU[D259Ne00@D
UkHDV;HDV;HDV;H359Vf0QBJ]P0359Zg59^g59^g008DVkL359bg00<DWKLE
WKPEWKP00aFN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/45ZNk0QJX^`045ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`011J[_AJ/_AJ/
_AN/_@@G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l3
5k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PF00200`01P080
0X001002P@03P@03P@03P@<0184200F10P05PP<01X801007PP47PP47PP48
PP8128<30@V30`4:P`040@^30@^40@^40@^40`4<Q0<13H@30@j50`8?Q@<2
48D40Q660`8BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700<35XP35hP3
5hP00P<GR0<368P00`<IR0<IR@<IR@030aZ90`<KR@030ab90ab:0ab:00@3
7HX211j:00@47X/47h/47h/47h/3122;0P@QR`04126<12:<12:<12:<10@S
S00412B<12B=12B=12F=0PDUS@<59Xd00`DWS@DWSPDWSP031BR>10DYSP<5
:Xl31B^?0`D/S`<6;I031Rj@0`H_T0041RnA1S2A1S2A1S2A0`HaT@86<Y40
10HbTPHcTPHcTPHcTP86=9800`LdTPLeTPLeTP021cFC0`LfT`<7=i<00`Lh
T`LhU0LhU0031cVD0`LjU0041c^D1c^E1c^E1c^E0`PlU@88?ID010PmUPPn
UPPnUPPnUP<8?iH2242F00<8@9L8@IL8@IL00PQ1U`<8@YL00`Q3U`U3V0U3
V0032DBH0`U5V0032DJH2DJI2DJI00@9AiT32DRI0`U9VP<9BYX32T^J0`Y<
V`@:CI/22TjK00@:CY`:Ci`:Ci`:Ci`32U2L0PYAW0042U6M2U:M2U:M2e:M
10]CW@032eBM2eBN2eBN00<;EIh32eJN00<;Eih;Eil;Eil00`]HW`@;FIl3
35ZP0`aKX08<G:0010aLX@aMX@aMX@aMX@<<GZ4235nQ0PaOXP<<H:8010aQ
XPeQXPeQXPeRXP8=HZ<33F>S0`eTX`043FFS3FFT3FFT3FFT0`eVY0<=Ij@3
3FRU0`iYY@<>JZD43V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`<>KjL23W2W
00<?L:P?LJP?LJP00PmaZ0<?LZP00`mcZ0mcZ@mcZ@033gBY0`meZ@033gJY
3gJZ3gJZ00@?MjX247RZ00@@N:/@NJ/@NJ/@NJ/347Z[0Q1kZ`0447^/47b/
47b/47b/111m[00447j/47j]47j]47n]0Q5o[@<AP:d00a61[A61[Q61[P03
4H:^1163[P<AQ:l34HF_0a66[`<BQk034XR`0a:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[800a>>/Q>?/Q>?/P024hnc0a>@
/`<CTK<00a>B/a>B]1>B]0034i>d0a>D]0044iFd4iFe4iFe4iFe0aBF]@8D
UkD011BG]QBH]QBH]QBH]P<DVKH259Zf00<DV[LDVkLDVkL00QBK]`<DW;L0
0aBM]aFM^1FM^0035Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<E
Y;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`FZK`FZK`35ZZl0QJ[_0045Z^m
5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl0
0aNb_`<G/klf6;C00XS0^058T8P1000000000hS0^<SPf8S0^03oR<2hohS0
^8N8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^?n8`;R7R<2h0DR@R040
00000003R<2hb>3Hb>3H0?o8h=Sob>3HQlSPf058T8P10000003oR<2hohS0
^8^8`;P100000000\
\>"], "Graphics",
  ImageSize->{650, 491},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:20001h2000`400?l00000o`00003oooo`l?3o
oo3`l8Col?3`003ooo3`l?ool?3`Q?o`l?000?ool?3`ooo`l?24oo3`l000ooo`l?3ooo3`l8Col?3`
003ooo3`l?ool?3`Q?o`l?000?ool?3`ooo`l?24oo3`l000ooo`l?3ooo3`l8Col?3`003ooo3`l?oo
l?3`Q?o`l?000?ool?3`ooo`l?24oo3`l000ooo`l?3ooo3`l8Col?3`003ooo3`l?ool?3`Q?o`l?00
0?ool?3`ooo`l?24oo3`l000ooo`l?3ooo3`l8Col?3`003ooo3`l?ool?3`Q?o`l?000?ool?3`ooo`
l?24oo3`l000ooooooooooooohCooooo0002onk^k_ooU9BDoonDU9B1oiBDU07ok^k^0002onKViP03
oiBDU?oVi^Koi^KV0?ooi^KVoooVi^ImonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0
ooo^k^koonk^kWgok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3oooooooooooooOOoo
ool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^imonk^kP7oU9BD0Oo^k^h0
00;oi^KV00?oU9BDonKVi_oVi^H0oooVi^KoonKViWgoi^KV0OnDU9@1onKViP000_o^k^h00onDU9Co
k^k^onk^kP3oonk^k_ook^k^OOo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oooooo
oooooommooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^h3onk^kQgooooo00?o
f=SoonGUooooool0D_ooool00ooHf?ooiNGoooooo`0booooom;ok^k^0OnDU9@1onk^kP000_oVi^H0
0onDU9Coi^KVonKViP3oonKViP?oi^KV7Oooool00onb/_oobl_oooooo`1Booooo`03ok:booo;booo
oooo03;oooood_oVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^0oo^k^h3oooo
o`03ooknoooalOoomOGo00Gooooo00?omoOoooknooooool00_ojn_l=ooooo`05ok:booo;boooo_ko
ooCdooono_l02Oooool00oojn_oomOGoooooo`0@ooooo`03oo[joooemOoooooo00cooooo00?om?Co
ooknooooool02?ooool00oono_oolO7oooGeo`05ooooo`03ooOgooono_oooooo00;on_[o3Oooool0
1Onb/_oobl_oooknooodm?ooo_ko00Wooooo00?on_[oooGeooooool04?ooool00oojn_oomOGooooo
o`0<ooooo`03ooCdooono_oooooo00;oooood_o^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooo
oooo0?oooooo1Oooool01_oOgoooWIgooijNoonWYooo[Zkoom_Ko`;ooooo00Wo^KWooibLoonSXooo
emOooj2Poonk^ooooooook:booo;bol00_ooool01_o9bOoo/k?ooooooooooooohN7ooibLo`;ooooo
00Ko/[;ookNgoonXZ?ooXj?ooj6QoooTi?l2ooooo`0:ok:booo;booooooooooooooemOoo][KooiZJ
oonWYoooXZ;oonKVo`Oooooo00?oa/Koojn_ooooool00oooool02OoemOoo][KooiZJoonWYoooXZ;o
onKVoooalOooXJ7oon[Zo`02ooooo`08olg=oonRX_oomOGoooooooo]kOooYjOoojFUoooShol8oooo
o`06omoOoonMWOooWYkoojNWoon^[_oofm_o0_ooool02Oni^OooW9cooj>SoooGeoooX:3ook^koooo
oooo/[;ool_;o`02ooooo`06olW9oonc/ooooooooooooooQhOooW9co0_ooool01_nb/_oo]kOoojRX
oonSXoooXJ7oonCTo`;ooooo00[o/[;ool_;ooooooooooooooGeoonf]_ooVY[oojNWoonRX_ooi^Ko
1oooool00oo6a_oo[jooooooo`03ooooo`09ooGeoonf]_ooVY[oojNWoonRX_ooi^Kooo7aoonQXOoo
j^[o00;ooooo00SocLgooj:RoooemOooooooong]oonWYoooYJGoon?SomGooooo0OnDU9@1ooooo`00
0_o^k^h00onDU9Cok^k^onk^kP3oonk^kP?ok^k^0_ooool03Oo^k_ooiNGooogmooooooooemOooiZJ
oooalOooj>SooiZJoooalOoomOGookfmoonOWol00_ooool01_nb/_oobl_ooooooooooooobLWook>c
o`;ooooo00kohN7ooibLoooooooooooook:boonc/ooon?Sooogmooo;boooX:3ooo[joooooooo/[;o
ol_;o`;ooooo00Ko];Cook:booobl_oooooooo[joooinOl7ooooo`03olK6oon_[ooooooo00?ooooo
00go];Cook:booobl_oooooooo[joooinOooooooomcLoonWYooonOWoonGUoonKVoooiNGo00;ooooo
00?oa/Kook>cooono_l02Oooool03Oo^k_ooiNGooogmooooooooemOooiZJoooalOooj>SooiZJoooa
lOoomOGookfmoonOWol00_ooool01_nb/_oobl_ooooooooooooobLWook>co`;ooooo00kohN7ooibL
oooooooooooook:boonc/ooon?Sooogmooo;boooX:3ooo[joooooooo/[;ool_;o`;ooooo00Ko];Co
ok:booobl_oooooooo[joooinOl7ooooo`03olK6oon_[ooooooo00?ooooo00go];Cook:booobl_oo
oooooo[joooinOooooooomcLoonWYooonOWoonGUoonKVoooiNGo00;ooooo00?oa/Kook>cooono_l0
1?oooooBonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0XooVi^HIoiVIo`Goi^KV6Ooo
ool5onKViQWo00002_oVi^H6ooooo`09oo?coonIVOoohN7oono_oonJV_ooi>CooooooooHf?ooYJGo
00;ooooo00Ko/[;ool_;ooooooooooooolW9oonc/ol2ooooo`06on7QoonLW?oooooooooooonb/_oo
bl_o0_ooool02_oemOooVIWoomkNoooooooo/[;ool_;oooooooolO7ooiVIoooRh_l;ooooo`03olK6
oon_[ooooooo00;ooooo00?olO7ooiVIoooRh_l01_ooool01?o1`Ooo^;Sooj:Rooo?col3ooooo`03
okNgooo6a_oooooo00gooooo00Wolo?ooiVIoooQhOooknoooiZJoooTi?ooooooomSHoonUYOl00_oo
ool01_nb/_oobl_ooooooooooooobLWook>co`;ooooo00KohN7ooibLoooooooooooook:booo;bol2
ooooo`0:ooGeoonIVOoog]kooooooonb/_oobl_ooooooooalOooVIWoon;Ro`_ooooo00?oa/Koojn_
ooooool00_ooool00ooalOooVIWoon;Ro`06ooooo`04ol71oonh^?ooXZ;oolo?o`?ooooo00?o]kOo
olK6ooooool01?oooooBonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0Xoo^k^hIoiVI
o`Gok^k^6Oooool5onk^kQWo00002_o^k^h5ooooo`06ooWioonh^?ooW9coooWioooooooog]ko0_n]
[Ol01_n^[_ooYJGooooooooooooo/[;ool_;o`;ooooo00KobLWook>cooooooooooooon7QoonLW?l2
ooooo`03ok:booo;booooooo00;ooooo00WoXJ7oom?Coooooooo/[;ool_;ooooooooiNGooiVIoona
/Ol00onb/_l00ooWioooooooooooo`05ooooo`03olK6oon_[ooooooo00;ooooo00?oiNGooiVIoona
/Ol00onb/_l01ooWiooooooooooooooinOooWIgooinOoooknol00oooool00ong]oooa/Koooooo`0<
ooooo`06ooWioonh^?ooW9coooWioooooooog]ko0_n][Ol01_n^[_ooYJGooooooooooooo/[;ool_;
o`;ooooo00KobLWook>cooooooooooooon7QoonLW?l2ooooo`03ok:booo;booooooo00;ooooo00Wo
XJ7oom?Coooooooo/[;ool_;ooooooooiNGooiVIoona/Ol00onb/_l00ooWioooooooooooo`05oooo
o`03olK6oon_[ooooooo00;ooooo00?oiNGooiVIoona/Ol00onb/_l01ooWiooooooooooooooinOoo
WIgooinOoooknol00oooool00ong]oooa/Koooooo`04ooooo`Cok^k^:OnIVOnUonk^kP7oU9BD0Oo^
k^h000;ooooo00?oU9BDooooooooool0XooooolIoiVIob?ooooo6Ol0000>ooooo`04on7QoonTY?oo
XZ;oonGUo`Cooooo00?oo_koomCDoonVY_l00_ooool02_nb/_ooa<CooooooooooooobLWoojf]ooon
o_ooooooon3PoonLW?l2ooooo`0Bok:booo9bOooooooooooooogmoooVIWoonOWoooooooo/[;ool_;
ooooooool?3ooiVIoooMgOoojn_oonSXoonJV_oom?Co1oooool00oo6a_oo[jooooooo`02ooooo`07
oo3`oonIVOoogMgoon_[oooXj?ooVY[oooCdo`02ooooo`04olS8oonVY_oo][KoolO7o`?ooooo00?o
]kOoolK6ooooool02oooool01?oQhOooY:Cooj:RoooUiOl4ooooo`03ooknoooDe?ooYZKo00;ooooo
00[o/[;oolC4ooooooooooooolW9oon][Oooo_kooooooooPh?ooW9co0_ooool04_nb/_oobLWooooo
oooooooomoOooiVIoooWiooooooook:booo;booooooooo3`oonIVOoogMgoon_[oooXj?ooVY[oooCd
o`Oooooo00?oa/Koojn_ooooool00_ooool01oo`l?ooVIWoomgMooo[joooj>SooiZJooodm?l00_oo
ool01?o8b?ooYZKookJfooo7aol3ooooo`03okNgooo6a_oooooo00Sooooo:OnIVOnUooooo`7oU9BD
0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0Xoo^k^hIoiVIo`Gok^k^6Oooool5onk^kQWo00002_o^
k^h3ooooo`04olc<oonIVOoo^k_oooGeo`?ooooo00GohN7ooo3`ooomoOoo_koookZjo`02ooooo`0:
ok:boonQXOoodM7oooGeoonb/_ooYJGooknoooocloooa/Koojf]o`;ooooo00[o/[;ooj>SoooEeOoo
lO7ool?3oonOWooooOgooooooonb/_oobl_o0_ooool01Onb/_oo`l?ooo_koooHf?ooZZ[o00Sooooo
00?oa/Koojn_ooooool00oooool01Onb/_oo`l?ooo_koooHf?ooZZ[o00;ooooo00cogmoooi^KoooZ
j_oom_Kooj:RoooWiooooooooocloonf]_ooa<Cooo[jooomoOl9ooooo`04olc<oonIVOoo^k_oooGe
o`?ooooo00GohN7ooo3`ooomoOoo_koookZjo`02ooooo`0:ok:boonQXOoodM7oooGeoonb/_ooYJGo
oknoooocloooa/Koojf]o`;ooooo00[o/[;ooj>SoooEeOoolO7ool?3oonOWooooOgooooooonb/_oo
bl_o0_ooool01Onb/_oo`l?ooo_koooHf?ooZZ[o00Sooooo00?oa/Koojn_ooooool00oooool01Onb
/_oo`l?ooo_koooHf?ooZZ[o00;ooooo00cogmoooi^KoooZj_oom_Kooj:RoooWiooooooooocloonf
]_ooa<Cooo[jooomoOl3ooooo`Cok^k^:OnIVOnUonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKV
i_oVi^H0XooVi^HIoiVIo`Goi^KV6Oooool5onKViQWo00002_oVi^H2ooooo`03ooGeoonIVOoodm?o
00Gooooo00God=3oojf]oonOWooo[jooonOWo`02ooooo`0:okZjooo@d?ooa/KooinOoonYZOook^ko
omKFoonSXoooYJGoomkNo`;ooooo00Ko^[[oom3@ooo1`OooWYkooj>SoooLg?l2ooooo`09ok:booo;
booooooooooooooemOoo]KGooijNoonTY?ooh^;o00Sooooo00?oa/Koojn_ooooool00oooool02Ooe
mOoo]KGooijNoonTY?ooh^;oooooooofm_ooZZ[oomGEo`02ooooo`08omoOoonb/_oooOgool_;oonL
W?ooWIgooj>SoooNg_l8ooooo`03ooGeoonIVOoodm?o00Gooooo00God=3oojf]oonOWooo[jooonOW
o`02ooooo`0:okZjooo@d?ooa/KooinOoonYZOook^koomKFoonSXoooYJGoomkNo`;ooooo00Ko^[[o
om3@ooo1`OooWYkooj>SoooLg?l2ooooo`09ok:booo;booooooooooooooemOoo]KGooijNoonTY?oo
h^;o00Sooooo00?oa/Koojn_ooooool00oooool02OoemOoo]KGooijNoonTY?ooh^;oooooooofm_oo
ZZ[oomGEo`02ooooo`08omoOoonb/_oooOgool_;oonLW?ooWIgooj>SoooNg_l3ooooo`Coi^KV:OnI
VOnUonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0Xoo^k^hIoiVIo`Gok^k^1Oooool?
oiVIo`Gooooo1Oo^k^h5o`0000ooVIWo1Ol0000:onk^kP;ooooo00?oknoooiVIoooemOl01oooool0
0oono_ooooooooooo`05ooooo`03ooknoooooooooooo00;ooooo00?oo_koooooooooool01?ooool0
0oono_ooooooooooo`02ooooo`03ok:booo;booooooo00?ooooo00?ooOgoooooooooool02?ooool0
0oo6a_oo[jooooooo`05ooooo`03oogmoooooooooooo00[ooooo00?o]kOoolK6ooooool02Oooool0
0oo_koooVIWoooGeo`07ooooo`03ooknoooooooooooo00Gooooo00?oo_koooooooooool00_ooool0
0oono_ooooooooooo`04ooooo`03ooknoooooooooooo00;ooooo00?o/[;ool_;ooooool00oooool0
0oomoOooooooooooo`08ooooo`03olK6oon_[ooooooo00Gooooo00?ooOgoooooooooool02_ooool0
0ong]oooa/Koooooo`04ooooo`Cok^k^:OnIVOnUonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDoooo
ooooool0XooooolIoiVIo`[ooooo3onIVOl:ooooo`Go00003onIVOl5o`0000gooooo00Go][Kook2`
oooAdOoo`<3ookblo`0Mooooo`03ok:booo;booooooo00_ooooo00Gob<Sool71ooo1`OooZj_ooj6Q
o`03ol71o`03ooShoooooooooooo00gooooo00?ol_;ooo7aooooool02_ooool01Onf]_oo/;3oom7A
ooo0`?oo_;co01gooooo00?o/[;ool_;ooooool02oooool01Oo8b?oo`L7ool71oon[ZoooXJ7o00?o
`L7o00?on?Soooooooooool03Oooool00oobl_oolO7oooooo`08ooooobWoVIWoYOooool1oiBDU07o
oooo0002onk^kP03oiBDU?o^k^kok^k^0:?ok^k^6OnIVOl5onk^kPGooooo3onIVOl5ooooo`Gok^k^
1Ol0000?oiVIo`Go00002_o^k^h3ooooo`05oogmoooQhOooaLGoolo?oooUiOl07Oooool00onb/_oo
bl_oooooo`0;ooooo`03om_KoooFe_ooe]Ko00Goe]Ko00?on_[oooooooooool06_ooool01OomoOoo
hN7oolG5ooo?coooiNGo01gooooo00?o/[;ool_;ooooool02oooool00ooKfoooe]KoomKFo`05omKF
o`03oo[joooooooooooo01Cooooo1?o^k^hYoiVIojGok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Co
i^KVonKViP2SonKViQWoVIWo1OoVi^H5ooooo`ooVIWo1Oooool5onKViPGo00003onIVOl5o`0000[o
i^KV9Oooool00oomoOooo_koooooo`1Booooo`03oogmooono_oooooo02[ooooo1?oVi^HYoiVIojGo
i^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP2Sonk^kQWoVIWo1Oo^k^h5ooooo`ooVIWo
1Oooool5onk^kPGo00003onIVOl5o`0000[ok^k^Yoooool4onk^kRWoVIWoYOo^k^h1oiBDU07ok^k^
0002ooooo`03oiBDU?oooooooooo0:?ooooo6OnIVOl:ooooo`ooVIWo2_ooool5o`0000ooVIWo1Ol0
002eooooobWoVIWoYOooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0:?ok^k^6OnIVOl5
onk^kPGooooo3onIVOl5ooooo`Gok^k^1Ol0000?oiVIo`Go00002_o^k^jWooooo`Cok^k^:OnIVOnU
onk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0XooVi^HIoiVIo`Goi^KV1Oooool?oiVI
o`Gooooo1OoVi^H5o`0000ooVIWo1Ol0000:onKViZOooooo1?oVi^HYoiVIojGoi^KV0OnDU9@1onKV
iP000_o^k^h00onDU9Cok^k^onk^kP2Sonk^kQWoVIWo1Oo^k^h5ooooo`ooVIWo1Oooool5onk^kPGo
00003onIVOl5o`000;Gok^k^:OnIVOnUonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0
XooooolIoiVIo`[ooooo3onIVOl:ooooo`Go00003onIVOl5o`000;Gooooo:OnIVOnUooooo`7oU9BD
0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0Xoo^k^hIoiVIo`Gok^k^1Oooool?oiVIo`Gooooo1Oo^
k^h5o`0000ooVIWo1Ol0002eonk^kRWoVIWoYOo^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Ko
i^KV0:?oi^KV6OnIVOl5onKViPGooooo3onIVOl5ooooo`Goi^KV1Ol0000?oiVIo`Go00002_oVi^HM
oiVIo`03oeiNW_mbL[koVIWo05;oVIWo00?oGUjNog9b__nIVOl0<_nIVOl4onKViRWoVIWoYOoVi^H1
oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^0:?ok^k^6OnIVOl5onk^kPGooooo3onIVOl5oooo
o`Gok^k^1Ol0000?oiVIo`Go00002_o^k^hMoiVIo`03obHV@?m<C7ooVIWo05;oVIWo00?o9RI0oda<
OonIVOl0<_nIVOl4onk^kRWoVIWoYOo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0:?o
oooo6OnIVOl:ooooo`ooVIWo2_ooool5o`0000ooVIWo1Ol0000:ooooo`?oVIWo00?oUiOmohB4g?n:
R^H01OnIVOl00on=SNcoUiOmoiVIo`02oi:Bm0goVIWo00Go9RI0oda<OonHV?koRHWUoiRHoP09oiVI
o`03oi:Bm?n;RnSoVIWo013oVIWo00?oTY;doh^;j?nIVOl03?nIVOl00on9RNGoUiOmoiVIo`08oiVI
o`03oiNGoOn4Q=coRX[V00GoVIWo00?oSHg/oiNGoOnIVOl00_nBT_@=oiVIo`05obHV@?m<C7ooV9Sn
ohV9iOnHV?h02OnIVOl00onBT_CoRh_XoiVIo`0@oiVIo`03oi:Bm?n;RnSoVIWo00coVIWo00?oRHWU
oiNGoOnIVOl00_nIVOl4ooooobWoVIWoYOooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^
0:?ok^k^6OnIVOl5onk^kPGooooo3onIVOl5ooooo`Gok^k^1Ol0000?oiVIo`Go00002_o^k^h2oiVI
o`06ofUY/?l61P[o1`L=oaDE9?lP83KoI6BW0_nIVOl02Ol`<57o10@8o`l?6_mMGIco2`/Coc@dEonI
VOoo9RI0oda<O`02oiVIo`06odU9N_lX:4?oVIWooiVIoom/K;Co1@D90_nIVOl01_lV9T3o;Be;oaHF
9_l@41_o30`Eog1`_0;oVIWo00[o9RI0oda<OonIVOooVIWoohZ:iol/;4[o0@43oaDE8ol=3AOoLg?1
1onIVOl00om4A7;o8B4hoiVIo`03oiVIo`09ohZ:iol/;4[o0@43oaDE8ol=3AOoLg?1ohF5g_l<31Go
NGW;00;oVIWo00SoCdn4o`h>6?n:R^OoVIWoogindolF5RGo4Q8Nofm_^PSoVIWo00KoJFV`o`H62_l7
1`go5ADTob0P=_mTI:L2oiVIo`09oc0`DOl410So3`lJoeeMW?l;2a?o=3AGoiVIoolV9T3oC4ao00;o
VIWo00KoBDUjobPX@onIVOooVIWoofa/]?l51@T2oiVIo`06obHV@?l];D_o5QHVoa0@6ol<31GoL72l
0_nIVOl02_lV9T3oC4aooiVIoonIVOooRX[Wob`/B_l10@?o5ADSo`d=5omcLl47oiVIo`03odA4L_lQ
8CSoVIWo00?oVIWo00WoRX[Wob`/B_l10@?o5ADSo`d=5omcLl7oQHGNo``<5OmiNL/00_nIVOl02?m?
ChCo3PhHohZ:ionIVOooOWkCoaHF9OlB4QkoKfnj0onIVOl4onk^kRWoVIWoYOo^k^h1oiBDU07ok^k^
0002onKViP03oiBDU?oVi^Koi^KV0:?oi^KV6OnIVOl5onKViQWooooo1OoVi^HIo`0000[oi^KV0_nI
VOl03On0P=KoLW:ooiJFn_nIVOooGUjMo`821?n5QMkoMWK6o`821?n4Q=goRX[VocHfFol:2Q400_nI
VOl01_lV9T3oC4aooiVIoonIVOooBDUjobPX@`;oVIWo00koK6bdo`D52OnIVOooVIWoobHV@?lX:4?o
Sho_oiJFnom;Bggo2`/Coi6AlonIVOoo9RI0oda<O`;oVIWo00Ko:2Q4obHV@?n5QMooVIWooi6AlonA
TO87oiVIo`03odA4L_lQ8CSoVIWo00?oVIWo00go:2Q4obHV@?n5QMooVIWooi6AlonATO;oVIWoofEU
ZOlE5B?oT93aog9b__l30`KoLg?000;oVIWo00?o@d=aobLW@OnHV?h02OnIVOl03On0P=KoLW:ooiJF
n_nIVOooGUjMo`821?n5QMkoMWK6o`821?n4Q=goRX[VocHfFol:2Q400_nIVOl01_lV9T3oC4aooiVI
oonIVOooBDUjobPX@`;oVIWo00koK6bdo`D52OnIVOooVIWoobHV@?lX:4?oSho_oiJFnom;Bggo2`/C
oi6AlonIVOoo9RI0oda<O`;oVIWo00Ko:2Q4obHV@?n5QMooVIWooi6AlonATO87oiVIo`03odA4L_lQ
8CSoVIWo00?oVIWo00go:2Q4obHV@?n5QMooVIWooi6AlonATO;oVIWoofEUZOlE5B?oT93aog9b__l3
0`KoLg?000;oVIWo00?o@d=aobLW@OnHV?h01?nIVOl4onKViRWoVIWoYOoVi^H1oiBDU07oi^KV0002
onk^kP03oiBDU?o^k^kok^k^0:?ok^k^6OnIVOl5onk^kQWooooo1Oo^k^hIo`0000[ok^k^1_nIVOl0
2On7Qn7o0000ofe]]_n2P]Wo0@43og5a_OnIVOooGenOoa<C8002oiVIo`06obHV@?m<C7ooVIWooiVI
oom9BG[o:2Q30_nIVOl01_m/K;Co1@D9oiVIoonIVOoo9RI0oda<O`;oVIWo00[oRX[Wo`000?mWIjgo
VIWoobHV@?m<C7ooVIWoohB4gOl0003oKVjh2onIVOl00om4A7;o8B4hoiVIo`02oiVIo`03ohB4gOl0
003oKVjh00KoVIWo00Co?CeVobh^C_l=3AOoDE670onIVOl00ol^;TgoA4AboiVIo`0=oiVIo`09ohN7
hOl0003oKFffoh:2fOl10@?oLG6moiVIoomOGioo4a<P00;oVIWo00Ko9RI0oda<OonIVOooVIWoodU9
N_lX:4<2oiVIo`06ofa/]?l51@WoVIWooiVIoolV9T3oC4ao0_nIVOl02_n:R^Oo0000ofMW[OnIVOoo
9RI0oda<OonIVOooQ8CMo`000?m^K[P;oiVIo`03odA4L_lQ8CSoVIWo00;oVIWo00?oQ8CMo`000?m^
K[P01_nIVOl01?lm?FKo;Ri>o`d=5omADHL3oiVIo`03obh^COm4A7;oVIWo00CoVIWo1?o^k^hYoiVI
ojGok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`2SoooooaWoVIWo8ooooolIo`0000[o
oooo1OnIVOl02_n@T?3o;bm?o`@42?nATO;oVIWoofMW[OlN7S;o7Qhcob0P=_lC4b02oiVIo`06obHV
@?m<C7ooVIWooiVIoom9BG[o:2Q30_nIVOl01_m/K;Co1@D9oiVIoonIVOoo9RI0oda<O`?oVIWo00Wo
3@dFoeMGTOnIVOoo9RI0oda<OonIVOooLW:no`000?lT93d00olU9Cl00omeMLCoVIWooiVIo`05oiVI
o`03odA4L_lQ8CSoVIWo00;oVIWo00?oLW:no`000?lT93d00olU9Cl01omeMLCoVIWooiVIoonATO;o
1PH:o`T94?nDU?L00onIVOl00ol^;TgoA4AboiVIo`0<oiVIo`0:oi2@l?l_;doo10@8oi6Al_nIVOoo
IfN]oahN<_lN7S?o820foa<C80;oVIWo00Ko9RI0oda<OonIVOooVIWoodU9N_lX:4<2oiVIo`06ofa/
]?l51@WoVIWooiVIoolV9T3oC4ao0onIVOl02Ol=3AKoEeNAoiVIoolV9T3oC4aooiVIoombL[ko0000
ob@T?@03obDU?`03ogEea?nIVOooVIWo00GoVIWo00?oA4Abob4Q>?nIVOl00_nIVOl00ombL[ko0000
ob@T?@03obDU?`07ogEea?nIVOooVIWooi6Al_l61P[o2@T@oiBDm`03oiVIo`03obh^COm4A7;oVIWo
00CoVIWo1?oooolYoiVIojGooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP2Sonk^kQWo
VIWo1Oo^k^hIooooo`Gok^k^6Ol0000:onk^kPCoVIWo00CoKFffoa0@7?l=3AOoLW:n1?nIVOl00onG
UogoF5RDoa<C8@02oiVIo`0:obHV@?m1@FgoVIWooiVIoom8B7Wo7QhcoiRHo_nIVOooJf^co`D52@;o
VIWo01;o9RI0odU9N_nIVOooVIWoohj>kOl0003oMGG3oiVIoolV9T3oC4aooiVIoon3Pm_o0000ofIV
ZomlO<ooMgO7o`410on9RND7oiVIo`03odA4L_lQ8CSoVIWo00;oVIWo00OoPh?Ko`000?mVIZ_oO7c?
ogMgaol10@?oRHWU00;oVIWo00CoATIfoa<C8Ol[:dWoATIe0onIVOl00ol^;TgoA4AboiVIo`0;oiVI
o`04ofe]]_l@41co3@dGog9b_PCoVIWo00?oUiOmoeQHU?lC4b400_nIVOl02_lV9T3o@D5]oiVIoonI
VOooB4QioahN<onHV?koVIWoof][/ol51@T2oiVIo`0BobHV@?m9BG[oVIWooiVIoon>S^go0000ogEe
`onIVOoo9RI0oda<OonIVOooPh?Ko`000?mVIZ_oO7c?ogMgaol10@?oRHWU1onIVOl00om4A7;o8B4h
oiVIo`02oiVIo`07oh>3fol0003oIVJ[ogalcomgMlOo0@43ohV9i@02oiVIo`04odI6M_lC4b7o:b]9
odI6M@?oVIWo00?o;Ri=odA4L_nIVOl01?nIVOl4onk^kRWoVIWoYOo^k^h1oiBDU07ok^k^0002onKV
iP03oiBDU?oVi^Koi^KV0:?oi^KV6OnIVOl5onKViQWooooo1OoVi^HIo`0000[oi^KV0onIVOl01?m=
CH7o0001oc<cE_n:R^H3oiVIo`05ofa/]?n2P][oUiOlocXjHOlb<U@00_nIVOl02_lV9T3o30`EoeAD
S?n;RnSo9BDooa8B7oli>F3oQhORod=3LOlN7S<2oiVIo`0:obHV@?l@41_oFUZGohB4g?lo?fWo2PXA
oiNGo?nIVOoo9RI0oda<O`;oVIWo00Go9BDood10JonDU?OoGUjNoaTI:`08oiVIo`03odA4L_lQ8CSo
VIWo00?oVIWo00Go9BDood10JonDU?OoGUjNoaTI:`02oiVIo`0<ofYZ/Ol410OoNGW;oh^;jOl>3QSo
MGG4oiVIoonEUOWo:b]9od51KOnBT_CoUYKk2OnIVOl01?m=CH7o0001oc<cE_n:R^H3oiVIo`05ofa/
]?n2P][oUiOlocXjHOlb<U@00_nIVOl02_lV9T3o30`EoeADS?n;RnSo9BDooa8B7oli>F3oQhORod=3
LOlN7S<2oiVIo`0:obHV@?l@41_oFUZGohB4g?lo?fWo2PXAoiNGo?nIVOoo9RI0oda<O`;oVIWo00Go
9BDood10JonDU?OoGUjNoaTI:`08oiVIo`03odA4L_lQ8CSoVIWo00?oVIWo00Go9BDood10JonDU?Oo
GUjNoaTI:`02oiVIo`0<ofYZ/Ol410OoNGW;oh^;jOl>3QSoMGG4oiVIoonEUOWo:b]9od51KOnBT_Co
UYKk0onIVOl4onKViRWoVIWoYOoVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^
0oo^k^h2oiVIo`03ohZ:i_l10@;oF5RC00GoVIWo00GoDU::oahN<_l92A3o8R8iogEea002oiVIo`0:
oc8bE?mCDh_o@d=ao`T94?lH62SoOgoEoeaLV_l?3a[o4a<PofMW[@;oVIWo00Ko<S9Doe9BR_ll?6Go
1`L=o`l?6OmTI:P2oiVIo`09obHV@?m<C7ooVIWooiVIoon:R^Ko:RY7o`L73Ol@41coKFfg00SoVIWo
00?oA4Abob4Q>?nIVOl00onIVOl02On:R^Ko:RY7o`L73Ol@41coKFfgoiVIoon;RnWo6QX/oeYJU`02
oiVIo`08ofUY[olU9CooUYKjoda<Ool410So1`L<oa0@6omXJ:h8oiVIo`03ohZ:i_l10@;oF5RC00Go
VIWo00GoDU::oahN<_l92A3o8R8iogEea002oiVIo`0:oc8bE?mCDh_o@d=ao`T94?lH62SoOgoEoeaL
V_l?3a[o4a<PofMW[@;oVIWo00Ko<S9Doe9BR_ll?6Go1`L=o`l?6OmTI:P2oiVIo`09obHV@?m<C7oo
VIWooiVIoon:R^Ko:RY7o`L73Ol@41coKFfg00SoVIWo00?oA4Abob4Q>?nIVOl00onIVOl02On:R^Ko
:RY7o`L73Ol@41coKFfgoiVIoon;RnWo6QX/oeYJU`02oiVIo`08ofUY[olU9CooUYKjoda<Ool410So
1`L<oa0@6omXJ:h3oiVIo`Cok^k^:OnIVOnUonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDoooooooo
ool0ooooool3ooooo`;oVIWo00?oPH7Ho`410_n:R^L01onIVOl00onGUogoVIWooiVIo`05oiVIo`03
oiRHo_nIVOooVIWo00;oVIWo00?oV9SnoiVIoonIVOl01?nIVOl00onGUogoVIWooiVIo`02oiVIo`03
obHV@?m<C7ooVIWo00?oVIWo00?oUiOloiVIoonIVOl02?nIVOl00om4A7;o8B4hoiVIo`05oiVIo`03
oiNGo?nIVOooVIWo00[oVIWo00?o;Ri=odA4L_nIVOl02OnIVOl00on1PMSo0@42ohZ:i`07oiVIo`03
oiNGoOnIVOooVIWo00GoVIWo00?oV9SnoiVIoonIVOl00_nIVOl00onHV?koVIWooiVIo`04oiVIo`03
oiNGoOnIVOooVIWo00;oVIWo00?o9RI0oda<OonIVOl00onIVOl00onGUocoVIWooiVIo`08oiVIo`03
odA4L_lQ8CSoVIWo00GoVIWo00?oUiOloiVIoonIVOl02_nIVOl00ol^;TgoA4AboiVIo`04oiVIo`Co
oooo:OnIVOnUooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^h3onk^kP?oVIWo
00Go;2a:ob8R>_mEEHko>SYRoc@dF00MoiVIo`03obHV@?m<C7ooVIWo00_oVIWo00GoAdMgoc`lIOll
?6Go6a/]o`d=5P03oc`lI@03ohj>k_nIVOooVIWo00goVIWo00?oQXKPohF5g_nIVOl02_nIVOl01Ol/
;4[o8R8joeEES_lj>V;o=3AH01goVIWo00?o9RI0oda<OonIVOl02onIVOl01Om7AgOo?3aUoc`lIOlK
6bgo3@dF00?o?3aU00?oSXk^oiVIoonIVOl03OnIVOl00on6Q^3oQHGNoiVIo`04oiVIo`Cok^k^:OnI
VOnUonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^H3onKViP?oVIWo00GoUYKk
ofe]]_m2@VkoDE68og9b_`0MoiVIo`03obHV@?m<C7ooVIWo00_oVIWo00?oHf>VoeaLV_mLG9X01OmL
G9X00onBT_CoVIWooiVIo`0JoiVIo`05oiJFnom]KKKo@T9^oe5AR?mbL[l07OnIVOl00olV9T3oC4ao
oiVIo`0;oiVIo`03of=SY_mLG9[oG5bJ00GoG5bJ00?oTY;doiVIoonIVOl05?nIVOl4onKViRWooooo
YOoVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^0oo^k^hUoiVIo`03oiJFnonG
UogoVIWo05;oVIWo00?oUYKkoiNGoOnIVOl0:_nIVOl4onk^kRWoooooYOo^k^h1oiBDU07ok^k^0002
ooooo`03oiBDU?oooooooooo0<7ooooo6Ol0000XooooojOoVIWod_ooool1oiBDU07ooooo0002onk^
kP03oiBDU?o^k^kok^k^0:?ok^k^6Oooool5onk^kQWo00001Oo^k^hIooooo`[ok^k^YonIVOl4onk^
kRWoooooYOo^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV0:?oi^KV6Oooool5onKViQWo
00001OoVi^HIooooo`[oi^KVYonIVOl4onKViRWoooooYOoVi^H1oiBDU07oi^KV0002onk^kP03oiBD
U?o^k^kok^k^0:?ok^k^6Oooool5onk^kQWo00001Oo^k^hIooooo`[ok^k^YonIVOl4onk^kRWooooo
YOo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0<7ooooo6Ol0003ooooooj;ooooo0OnD
U9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP2Sonk^kPGooooo3onIVOl5ooooo`Gok^k^1Ol0000?
oiVIo`Go00001Oo^k^h5ooooo`ooVIWo1Oooooneonk^kRWoooooYOo^k^h1oiBDU07ok^k^0002onKV
iP03oiBDU?oVi^Koi^KV0:?oi^KV1Oooool?oiVIo`Gooooo1OoVi^H5o`0000ooVIWo1Ol00005onKV
iPGooooo3onIVOl5oooookGoi^KV:OoooonUonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^
k^h0Xoo^k^h5ooooo`ooVIWo1Oooool5onk^kPGo00003onIVOl5o`0000Gok^k^1Oooool?oiVIo`Go
oooo9Oo^k^h00oo=cOCof=Sbonk^kP1Bonk^kP03olg=m?oHf?;ok^k^03Sok^k^:OoooonUonk^kP7o
U9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0Z?ooool?oiVIo`[ooooo1Ol0000?oiVIo`Go0000
2_ooool?oiVIob[ooooo00?o/[;ool_;ooooool0D_ooool00onb/_oobl_oooooo`3oooooo`Oooooo
0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP2Sonk^kPGooooo3onIVOl5ooooo`Gok^k^1Ol0
000?oiVIo`Go00001Oo^k^h5ooooo`ooVIWo1Oooool;onk^kP03ong]k_oRh_3oiNG_00Gok^k^00?o
inO_ong]k_o^k^h00_oZj^h=onk^kP05ojj^n_o3`oKokNg^onGUkoo]kNh02Oo^k^h00ooZj^koi^K_
onk^kP0@onk^kP03on[Zk_oVi^ook^k^00cok^k^00?oiNG_ong]k_o^k^h02?o^k^h00oo]kNkoh^;`
onGUk`05onk^kP03onOWkoo]kNkok^k^00;oj^[^3Oo^k^h01On^[_[o`l?fong]k_oUiNookNg^00Wo
k^k^00?oj^[^onKVkoo^k^h04?o^k^h00ooZj^koi^K_onk^kP0<onk^kP03onGUkoo]kNkok^k^00So
k^k^:OoooonUonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0XooVi^H5ooooo`GoVIWo
1Oooool5oiVIo`Gooooo1OoVi^H5o`0000GoVIWo1Oooool5oiVIo`Go00001OoVi^H5ooooo`GoVIWo
1Ol00005oiVIo`Gooooo2_oVi^H01_o>c^goW9cnoibLoOnSXo_oZJWiol_;kP;oi^KV00Wo/K7goi^K
o_nPX?cob<S_oijNoOnc/oKoi^KVojb/n?no_o800_oVi^H01_nm_O?o[JghonKVi_oVi^Koclo]oi^K
oP;oi^KV00Ko[:chojn_monTY?_oXJ7loinOo?oAdN`2onKViP0:ojb/n?no_o;oi^KVonKVi_oNg^So
[jogoiVIo_nSXo_oWiolom?Ck0Ooi^KV00?o^k_cojVYnOoVi^H00ooVi^H02OoNg^So[jogoiVIo_nS
Xo_oWiolom?Ck?oLg>WoWiolomKFj`02onKViP08ol30l_nPX?cog]kXonKVi_oHf>[oY:Ckoj:Ro?oA
dN`8onKViP06olk>kOnLW?koW9cmoj>SnonYZOWobl_^0_oVi^H02Ona/OOoVi_noj2Po?o8b>ooWYkm
ok>cm_oVi^Ko[:choknolP02onKViP06okfmlon][OSoi^KVonKVi_o?cngoVi_n0_oVi^H01_n/[?So
[jogojBTnonQXOcoWiolom7Ak0;oi^KV00[o[:choknol_oVi^Koi^KVomkNj?n_[oOoVIWnoj>SnonO
Wocodm?/1ooVi^H00onk^o?oZJWionKViP03onKViP09omkNj?n_[oOoVIWnoj>SnonOWocodm?/omcL
jOnOWocoe]K[00;oi^KV00So`<3boj2Po?oNg^Soi^KVomSHj_nTY?_oXZ;lom7Ak0Woi^KV:OoooonU
onKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0Xoo^k^h5ooooo`GoVIWo1Oooool5oiVI
o`Gooooo1Oo^k^h5o`0000GoVIWo1Oooool5oiVIo`Go00001Oo^k^h5ooooo`GoVIWo1Ol00005oiVI
o`Gooooo2_o^k^h03OoPh?3of=Sbonc/k_o^k^kocLgdoiZJo_oSho3ofm_aoiZJo_oRh_3oiNG_okNg
n?nNW_d00_o^k^h01_n^[_[o`l?fonk^k_o^k^ko`L7fojn_nP;ok^k^00koeMGcoibLo_o^k^kok^k^
ojj^n_n_[o[oj>S_onc/k_o2`_KoWiomon[Zk_o^k^ko[Zkjol?3mP;ok^k^00Ko[jojojj^n_oSho3o
k^k^on[Zk_oYjNh7onk^kP03oknomon[Zo_ok^k^00?ok^k^00go[jojojj^n_oSho3ok^k^on[Zk_oY
jNkok^k^om7AlonTY?cojNW^omSHl_nKVokofMWb00;ok^k^00?o_[kgojj^n_o]kNh02Oo^k^h03OoP
h?3of=Sbonc/k_o^k^kocLgdoiZJo_oSho3ofm_aoiZJo_oRh_3oiNG_okNgn?nNW_d00_o^k^h01_n^
[_[o`l?fonk^k_o^k^ko`L7fojn_nP;ok^k^00koeMGcoibLo_o^k^kok^k^ojj^n_n_[o[oj>S_onc/
k_o2`_KoWiomon[Zk_o^k^ko[Zkjol?3mP;ok^k^00Ko[jojojj^n_oSho3ok^k^on[Zk_oYjNh7onk^
kP03oknomon[Zo_ok^k^00?ok^k^00go[jojojj^n_oSho3ok^k^on[Zk_oYjNkok^k^om7AlonTY?co
jNW^omSHl_nKVokofMWb00;ok^k^00?o_[kgojj^n_o]kNh02_o^k^hYooooojGok^k^0OnDU9@1onk^
kP000_ooool00onDU9Coooooooooo`2Xooooo`GoVIWo1Oooool5oiVIo`[ooooo1Ol00005oiVIo`Go
oooo1OnIVOl5o`0000[ooooo1OnIVOl5o`0000GoVIWo4oooool02OocloooVIWoon7Qooo_koooVY[o
onCToooooooof=SoojFUo`02ooooo`06ok:booo;boooooooooooooo9bOoo/k?o0_ooool01_oQhOoo
W9cooooooooooooo/[;ool_;o`;ooooo00[omOGooiVIoooNg_oooooook:booo;booooooooo7aoonI
VOooh^;o2oooool00oo6a_oo[jooooooo`02ooooo`03oo7aoonIVOooh^;o00Kooooo00Co`L7ookRh
oonRX_oocloo0oooool00ong]oooa/Koooooo`0=ooooo`09oo?coonIVOoohN7oono_oonJV_ooi>Co
oooooooHf?ooYJGo00;ooooo00Ko/[;ool_;ooooooooooooolW9oonc/ol2ooooo`06on7QoonLW?oo
oooooooooonb/_oobl_o0_ooool02_oemOooVIWoomkNoooooooo/[;ool_;oooooooolO7ooiVIoooR
h_l;ooooo`03olK6oon_[ooooooo00;ooooo00?olO7ooiVIoooRh_l01_ooool01?o1`Ooo^;Sooj:R
ooo?col3ooooo`03okNgooo6a_oooooo0=Sooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^
kP2Sonk^kPGooooo1OnIVOl5ooooo`GoVIWo1Oooool5onk^kPGo00001OnIVOl5ooooo`GoVIWo1Ol0
0005onk^kPGooooo1OnIVOl5o`0000GoVIWo1Oooool=onk^kP0:onWYkonc/oWoVi_nonWYk_o^k^ko
d];cojVYnonZZ__oZj_koj>So0;ok^k^00Ko[Zkjol?3m_o^k^kok^k^ol71m_n_[oX2onk^kP06omGE
lonLW?kok^k^onk^k_n^[_[o`l?f0oo^k^h02OnPX?gobLWeonk^k_n^[_[o`l?fonk^k_oHf?;oVIWo
ojf]nP03ojj^nP03om[JlOo^k^kok^k^00Gok^k^00?o_kogoj^[noo^k^h00_o^k^h00ooHf?;oVIWo
ojf]nP03ojj^nP07om[JlOo^k^kok^k^onWYk_nLW?koWYkmon_[kP03onk^kP03ok:bnOno_oOok^k^
00cok^k^00[ojNW_ok>cnOnKVokojNW^onk^k_oBd_?oZJWkojZZnon[Zo_oXj?l0_o^k^h01_n^[_[o
`l?fonk^k_o^k^ko`L7fojn_nP;ok^k^00KoeMGcoibLo_o^k^kok^k^ojj^n_o3`oH3onk^kP09oj2P
oOo9bOGok^k^ojj^n_o3`oKok^k^omSHl_nIVOoo[Jgj00?o[Zkj00?of][aonk^k_o^k^h01Oo^k^h0
0ono_oOoZj_konk^kP02onk^kP03omSHl_nIVOoo[Jgj00?o[Zkj00Oof][aonk^k_o^k^kojNW^oibL
o_nNW_gojn_^00?ok^k^00?o/[;ioknomoo^k^h02_o^k^hYooooojGok^k^0OnDU9@1onk^kP000_oV
i^H00onDU9Coi^KVonKViP2SonKViPGooooo1OnIVOl5ooooo`GoVIWo1Oooool5onKViPGo00001OnI
VOl5ooooo`GoVIWo1Ol00005onKViPGooooo1OnIVOl5o`0000GoVIWo1Oooool<onKViP04olo?kOnQ
XOcoWiolom;Bk0Coi^KV00?oiNGVolG5l?nRX_/00_oVi^H02_n/[?So^KWdonKVi_oVi^Ko_KgcojRX
n_oUiNKoi^KVolo?kOnKVoh2onKViP0Bojb/n?nm_O?oi^KVonKVi_oPh>OoVIWoom?CjooVi^Ko[:ch
oknol_oVi^Kofm_YoiVIooo<c>koemOZomGEjonIVOkog]kX1ooVi^H00onk^o?oZJWionKViP02onKV
iP07om_KjOnIVOooc<c^omOGj_oEeN_oVIWnomkNj002onKViP04okbllonRX__o[jogokbll`?oi^KV
00?o/;3gok^klooVi^H02ooVi^H01?o?cngoXJ7loinOo?oBd^`4onKViP03onGUi_o5aO3oXZ;k00;o
i^KV00[o[:chokVim?oVi^Koi^KVokfmlonXZ?[oiNGVonKVi_o?cngoVi_n0_oVi^H04_n/[?So_Kgc
onKVi_oVi^Koh>3WoiVIoooCdn_oi^KVojb/n?no_o;oi^KVom_KjOnIVOooc<c^omOGj_oEeN_oVIWn
omkNj0Ooi^KV00?o^k_cojVYnOoVi^H00_oVi^H01ooKfnWoVIWoolc<k_oGen[oeMG[oiVIo_oNg^P0
0_oVi^H01?nl_??oXZ;kojn_monl_?<3onKViP03ok2`monk^o?oi^KV00[oi^KV:OoooonUonKViP7o
U9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0Xoo^k^h5ooooo`ooVIWo1Oooool5onk^kPGo0000
3onIVOl5o`0000Gok^k^1Oooool?oiVIo`Gooooo2oo^k^h01?o4a?KoVIWnokFenOoUiNl3onk^kP05
omGElooQhO3okNg^okVin?ne]OT00_o^k^h02_n^[_[oX:3molO7mOoVi^oo[Zkjoj>So?ni^OSoi>C_
okjnmonZZ_/2onk^kP0:ojj^n_nRX_gobl_don;Rl?nl_?SoWYkmong]k_o^k^ko[Zkjol?3mP;ok^k^
00Go[Zkjokblmoo[jnkocLgdojNWo008onk^kP03oknomon[Zo_ok^k^00?ok^k^00Go[Zkjokblmoo[
jnkocLgdojNWo002onk^kP0<omCDlonKVokog=caonKVkonQXOgof][aonk^k_o/k>ko/K7jokfmmooZ
j^kok>c^2Oo^k^h01?o4a?KoVIWnokFenOoUiNl3onk^kP05omGElooQhO3okNg^okVin?ne]OT00_o^
k^h02_n^[_[oX:3molO7mOoVi^oo[Zkjoj>So?ni^OSoi>C_okjnmonZZ_/2onk^kP0:ojj^n_nRX_go
bl_don;Rl?nl_?SoWYkmong]k_o^k^ko[Zkjol?3mP;ok^k^00Go[Zkjokblmoo[jnkocLgdojNWo008
onk^kP03oknomon[Zo_ok^k^00?ok^k^00Go[Zkjokblmoo[jnkocLgdojNWo002onk^kP0<omCDlonK
Vokog=caonKVkonQXOgof][aonk^k_o/k>ko/K7jokfmmooZj^kok>c^2Oo^k^hYooooojGok^k^0OnD
U9@1onk^kP000_ooool00onDU9Coooooooooo`2Xooooo`ooVIWo2_ooool5o`0000ooVIWo1Ol0000:
ooooo`ooVIWo3oooool00ooemOooVIWoom?Co`05ooooo`05om3@oon][OooWiooojn_oooWiol00_oo
ool02_nj^_ood=3oolK6oonOWoooZJWoonk^oooFe_ooXj?oojFUoooNg_l2ooooo`06okZjooo@d?oo
`L7ooijNoonSXooog=co0_ooool02Onb/_oobl_ooooooooooooomOGookFeoonNW_ooY:Coon;Ro`08
ooooo`03olK6oon_[ooooooo00?ooooo00WomOGookFeoonNW_ooY:Coon;Roooooooom_KoojZZoooE
eOl00_ooool02?oOgooo/[;ooogmooo;boooW9cooifMoonSXooog]ko2?ooool00ooemOooVIWoom?C
o`05ooooo`05om3@oon][OooWiooojn_oooWiol00_ooool02_nj^_ood=3oolK6oonOWoooZJWoonk^
oooFe_ooXj?oojFUoooNg_l2ooooo`06okZjooo@d?oo`L7ooijNoonSXooog=co0_ooool02Onb/_oo
bl_ooooooooooooomOGookFeoonNW_ooY:Coon;Ro`08ooooo`03olK6oon_[ooooooo00?ooooo00Wo
mOGookFeoonNW_ooY:Coon;Roooooooom_KoojZZoooEeOl00_ooool02?oOgooo/[;ooogmooo;booo
W9cooifMoonSXooog]koeoooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0:?ok^k^1Ooo
ool?oiVIo`Gooooo1Oo^k^h5o`0000ooVIWo1Ol00005onk^kPGooooo3onIVOl5ooooo`[ok^k^00?o
hN7`oiVIo_oVi^l01oo^k^h00oo]kNkok^k^onk^kP05onk^kP03ong]k_o^k^kok^k^00;ok^k^00?o
kNg^onk^k_o^k^h01?o^k^h00oo]kNkok^k^onk^kP02onk^kP03ojj^n_o3`oKok^k^00?ok^k^00?o
kNg^onk^k_o^k^h02?o^k^h00ono_oOoZj_konk^kP05onk^kP03ong]k_o^k^kok^k^00[ok^k^00?o
/[;ioknomoo^k^h02Oo^k^h00ooQhO3oVIWnonKVk`07onk^kP03ong]k_o^k^kok^k^00Gok^k^00?o
kNg^onk^k_o^k^h00_o^k^h00oo]kNkok^k^onk^kP04onk^kP03ong]k_o^k^kok^k^00;ok^k^00?o
[Zkjol?3m_o^k^h00oo^k^h00oo]kNkok^k^onk^kP08onk^kP03oknomon[Zo_ok^k^00Gok^k^00?o
kNg^onk^k_o^k^h02_o^k^h00onb/_Wo_kogonk^kP0:onk^kRWoooooYOo^k^h1oiBDU07ok^k^0002
onKViP03oiBDU?oVi^Koi^KV0:?oi^KV1Oooool?oiVIo`Gooooo1OoVi^H5o`0000ooVIWo1Ol00005
onKViPGooooo3onIVOl5ooooo`_oi^KV00Go[jogojZZnOo3`o7o][Keok>cmP0MonKViP03ojb/n?no
_o;oi^KV00_oi^KV00Go_;ccokNgmOng]oGoYZKjoinOo003okNgm@03on3PiooVi^Koi^KV00goi^KV
0_oLg>T;onKViP05ojn_monZZ_Wo`l?aokJfmOnc/oH07OoVi^H00on/[?So_kobonKViP0;onKViP05
okbllong]oGo]kOeojJVn_nOWo`00ong]oD00ooPh>Ooi^KVonKViP0=onKViP;og=cY2ooVi^HYoooo
ojGoi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP2Sonk^kPGooooo3onIVOl5ooooo`Go
k^k^1Ol0000?oiVIo`Go00001Oo^k^h5ooooo`ooVIWo1Oooool;onk^kP05onc/k_oEeO;o_KggolK6
mOoHf?807Oo^k^h00on^[_[o`l?fonk^kP0;onk^kP03om3@loo<c?Coc<cd00Goc<cd00?oj^[^onk^
k_o^k^h06_o^k^h01Oo/k>koeMGbokfmmoo6a_Gof=Sb01gok^k^00?o[Zkjol?3m_o^k^h02oo^k^h0
0oo@d??oc<cdolc<m005olc<m003on[Zk_o^k^kok^k^01[ok^k^:OoooonUonk^kP7oU9BD0Oo^k^h0
00;ooooo00?oU9BDooooooooool0`OoooolIo`0004_ooooo00?ooOgoooknooooool0D_ooool00oom
oOooo_koooooo`3nooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0Xoo^k^hIooooo`Go
k^k^6Ol00005onk^kQWooooo]Oo^k^hYooooojGok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KV
onKViP2SonKViQWooooo1OoVi^HIo`0000Goi^KV6OooooneonKViRWoooooYOoVi^H1oiBDU07oi^KV
0002onk^kP03oiBDU?o^k^kok^k^0:?ok^k^6Oooool5onk^kQWo00001Oo^k^hIoooookGok^k^:Ooo
oonUonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0`OoooolIo`000?ooooooX_ooool1
oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^imonk^kP7oU9BD0Oo^k^h000;o
i^KV00?oU9BDonKVi_oVi^H0oooVi^KoonKViWgoi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^
onk^kP3oonk^k_ook^k^OOo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oooooooooo
oommooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^koonk^kWgok^k^0OnDU9@1
onk^kP000_oVi^H00onDU9Coi^KVonKViP3oonKVi_ooi^KVOOoVi^H1oiBDU07oi^KV0002onk^kP03
oiBDU?o^k^kok^k^0?ook^k^ooo^k^imonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0
4oooool00oodm?Coj>SXooooo`0?ooooo`03ooCdm?oXj>Sooooo0?oooooooooooomEooooo`7oU9BD
0Oooool000;ok^k^00?oU9BDonk^k_o^k^h01Oo^k^h00olb<S;oKfm_onk^kP04onk^kP03oc/k>omf
MWKok^k^00;ok^k^00KoemOGodE5AOl20P;o820PoaDE5Ond];@2onk^kP03ogAdM?l0003oc/k>00?o
k^k^00ko>c/kogIfM_o^k^kok^k^omOGeom5ADGo0P82ob0P8?lE5AGo];Bdonk^k_oFe]Ko0000ogin
OP;ok^k^00?oA4A4obDU9Oo^k^h0ooo^k^koonk^kT_ok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Co
i^KVonKViP05onKViP03oc0`<?m[Jf_oi^KV00Coi^KV00?o>CTiog9bL_oVi^H00_oVi^H02olm?Cgo
>CTiolW9bOoVi^Kofm_Kom[Jf_oVi^KoiNGUoa/K6olB4Q;oKVi^00?oi^KV01?o>CTiog9bL_oVi^Ko
i^KVocdm?Oli>CWobLW9onKVi_oKfm_of][JonKVi_n>SXko3@d=oc<c<ooVi^KogmoOo`T92Ol=3@go
_kno0?ooi^KVoooVi^I;onKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h01Oo^k^h00olb
<S;oKfm_onk^kP04onk^kP07oc/k>omfMWKok^k^onk^k_o>c/ko0000oj^[Z`05onk^kP05ok:b/_l:
2P[oZ:RXoaLG5ooZj^X00_o^k^h01_lk>c_oMWIfonk^k_o>c/ko0000oj^[Z`Gok^k^00SoCdm?of][
JolJ6Q[of=SHok2`/?lN7QkoIVIVogQhN?ook^k^ooo^k^i;onk^kP7oU9BD0Oo^k^h000;ooooo00?o
U9BDooooooooool01Oooool01?lf=SKoEeMGolS8b?o/k>`3ooooo`07od10@?moOgoooooooooooonn
_[ko0000ocdm?@03oclo?`07olC4a?ooooooH61PoeeMGOoooooo9RHVok2`/002ooooo`06od10@?mo
Ogoooooookjn__l0003o?Cdm0olo?cl02_o4a<Cono_ko`l?3onm_KgoJ6QXoiZJV_mgMgOoIVIVol30
`?l];BgoooooooooooooBoooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^00Gok^k^00Wo
<S8boa`L7?lN7Qko0000oeADE?oShn?ok^k^oc/k>omRHV800_o^k^h03Oo<c<co0000oinOWoo1`L7o
^KVio`820_oEeMGohn?So`X:2_n`/;3ok^k^oh20P?m6ATH00_o^k^h05?lk>c_oMWIfonk^k_o<c<co
0000oinOWoo1`L7o^KVio`820_oEeMGo][Jfo`/;2ooXj>SoZJVYodI6A_l];BgoWYjNonc/k?lD51Co
bl_;ooo^k^koonk^kT[ok^k^0OnDU9@1onk^kP000_oVi^H7oiBDU00MonKVi_l`<33oJf][onKVi_nn
_[ko2PX:oemOGooVi^Ko>CTioa4A4On2PX;ocLg=onCTi?lh>3SoH61PomkNg_n>SXko9RHVonKVi_nB
TY;o6a/KonGUiOoVi^Kod];Bo`L71oo;bl_oi^KVocTi>OmbLW800_oVi^H04?lh>3SoH61PomkNg_n>
SXko9RHVonKVi_m]KFgoADE5onKVi_oOgmoo410@o`820_oEeMGoi^KVoeaLG?mhN7SooiBDU?ooU9BD
BonDU9@1onKViP002_o^k^h05?lb<S;oKfm_onk^k_o^k^koH61PoadM7Oo^k^koCTi>ogmoOomFEUKo
20P8on3Ph?oFe]Ko@T92o``<3?lJ6Q[oZZZZonk^k_mDE5CoOGem0oo^k^h01OmJFU[oRHV9onk^k_m>
CTkoPh>300;ok^k^00Soe]KFod92@_l<30co6QXJojZZZ_o^k^koADE5oi>CT`;ok^k^00KoFUYJod10
@?o^k^kok^k^ok2`/?m7AdOoonk^k_ook^k^C?o^k^h000[ooooo00Ko=SHfogMgMoooooooooooodE5
AOm4A4@4ooooo`05ooclo?ooooooooooooooooolo?`04Oooool00oolo?coooooooooo`3ooooooooo
ooooEoooool000[ok^k^00Ko<S8bob/[:omDE5Co92@To`410OnRXZ8Donk^kP03oeADE?n8R8Sok^k^
0?ook^k^ooo^k^iMonk^kP002_oVi^H01OnNWYkoRXZ:oh^;RonLW9cob<S801Goi^KV00?oXZ:RokRh
^?oVi^H0oooVi^KoonKViUgoi^KV003oonk^k_ook^k^Q?o^k^h00?oooooooooooon4ooooo`00ooo^
k^koonk^kXCok^k^003oonKVi_ooi^KVQ?oVi^H000CohN7QoooKfm_oom_Kfg_ofm_K1?oQhN41onk^
kP0000Col_;bon[Zj_oZj^[oj^[ZoooNg]koomkNgW_og]kN0ooZj^X1ooooo`7ol_;b00001?oQhN7o
f][Jolo?coo?cloookfm_Ooo_KfmNonm_Kd2olo?c`7ok^k^0OoJf]X1on7Qh@0000Cof][Jom?Cdoo8
b<So]kNgoonKVi_ooi^KVg_oVi^K00Co]kNgonKVi_o8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?
okfm_Olg=cL0oomfMWKoogIfMW[oMWIf00CoKfm_okfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[o
g]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJ
f][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[J
f_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005
on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
0005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oob
l_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;
booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00Co
WIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[o
oooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^
kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^Ko
onKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^
k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0
ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnS
Xj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg
]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?
okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[o
g]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJ
f][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[J
f_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005
on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
0005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oob
l_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;
booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00Co
WIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[o
oooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^
kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^Ko
onKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^
k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0
ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnS
Xj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg
]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?
okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[o
g]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJ
f][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[J
f_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005
on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
0005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oob
l_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;
booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00Co
WIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[o
oooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^
kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^Ko
onKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^
k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0
ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnS
Xj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg
]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?
okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[o
g]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJ
f][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[J
f_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005
on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
0005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oob
l_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;
booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00Co
WIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[o
oooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^
kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^Ko
onKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^
k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0
ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnS
Xj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg
]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?
okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[o
g]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJ
f][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[J
f_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005
on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
0005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oob
l_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;
booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00Co
WIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[o
oooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^
kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^Ko
onKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^
k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0
ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnS
Xj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg
]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?
okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[o
g]kNol_;bon_[jl0KOooooooo`0005Wo0000/oooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000Go
hN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooooooo0?ooooooEOooool00ol0003ok^k^
onk^kP2aonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM06go
i^KV00?o0000ooooool000002Ol000000ooooooo0000o`000008o`000003ooooool0003o000000So
000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So
000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So
000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So
000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So
000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So
000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So
000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So
000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So
000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So
000000?oooooo`000?l000002?l000000ooooooo0000onKViP2bonKViP04oifMWOng]kOob<S8om?C
d`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S06gok^k^00?o0000ooooool0<c<02?l0<c<00ol0
003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0
003oooooo`0c<`08o`0c<`03o`000?oooooo000c00So000c00?o0000oooooolc03<02?lc03<00ol0
003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0
003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0
003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc00002?lc00000ol0
003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0
003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0
003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0
003oooooo`0c0008o`0c0003o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0
003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0
003oooooo`00002conk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o
[jn_06gooooo00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo
03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo
000c00So000c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo
<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo
<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo
<`0c00So<`0c00?o0000oooooolc00002?lc00000ol0003ooooooc<c0008oc<c0003o`000?oooooo
<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo
<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo
<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003oooooo`0c0008o`0c0003o`000?oooooo
03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo
03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`00002cooooo`04ojn_[oo;bl_o
g]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S06gok^k^00?o0000ooooool0<c<02?l0
<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0
<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo000c00So000c00?o0000oooooolc03<02?lc
03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc
03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc
03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc00002?lc
00000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc
<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc
<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc
<`000ol0003oooooo`0c0008o`0c0003o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0
<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0
<c<00ol0003oooooo`00002conk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8
b?ng]kOoWIfM06goi^KV00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`00
0?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`00
0?oooooo000c00So000c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`00
0?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`00
0?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`00
0?oooooo<`0c00So<`0c00?o0000oooooolc00002?lc00000ol0003ooooooc<c0008oc<c0003o`00
0?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`00
0?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`00
0?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003oooooo`0c0008o`0c0003o`00
0?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`00
0?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`00002conKViP04oifM
WOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S06gok^k^00?o0000ooooool0
<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0
<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo000c00So000c00?o0000oooooolc
03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc
03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc
03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc
00002?lc00000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc
<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc
<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc
<`002?lc<`000ol0003oooooo`0c0008o`0c0003o`000?oooooo03<c00So03<c00?o0000ooooool0
<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0
<c<02?l0<c<00ol0003oooooo`00002conk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;o
j^[ZomkNg_o;bl_o[jn_06gooooo00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c
<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c
<`03o`000?oooooo000c00So000c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0
<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0
<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0
<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc00002?lc00000ol0003ooooooc<c0008oc<c
0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c
0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c
0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003oooooo`0c0008o`0c
0003o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c
<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`00002coooo
o`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S06gok^k^00?o0000
ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000
ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo000c00So000c00?o0000
oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000
oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000
oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000
oooooolc00002?lc00000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000
oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000
oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000
oooooolc<`002?lc<`000ol0003oooooo`0c0008o`0c0003o`000?oooooo03<c00So03<c00?o0000
ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000
ooooool0<c<02?l0<c<00ol0003oooooo`00000:onk^kS[o0000Koo^k^h01?nSXj?o_Kfmolo?cooJ
f]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@1]onKViP03o`000?oooooo03<c00So03<c00?o
0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o
0000ooooool0<c<02?l0<c<00ol0003oooooo`00<`08o`00<`03o`000?oooooo<`0c00So<`0c00?o
0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o
0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o
0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0000So<`0000?o
0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o
0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o
0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o
0000ooooool0<`002?l0<`000ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o
0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o
0000ooooool000002_oVi^H00ol0003oooooooooo`0fooooo`03o`000?oVi^Koi^KV06goi^KV00Co
WIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0KOo^k^h00ol0003ooooo
o`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003ooooo
o`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool003<02?l003<00ol0003ooooo
oc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooo
oc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooo
oc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooo
oc<00008oc<00003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooo
oc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooo
oc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooo
oc<c0008oc<c0003o`000?oooooo03<000So03<000?o0000ooooool0<c<02?l0<c<00ol0003ooooo
o`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003ooooo
o`0c<`08o`0c<`03o`000?oooooo000000[ok^k^00?o0000ooooool000002Ol000000ooooooo0000
o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000
o`000008o`000003ooooool0003ok^k^06kok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;b
l_oZj^[og]kNol_;bon_[jl0KOooool00ol0003oooooooooo`3ooooooeGooooo00?o0000oooooooo
ool02?ooool00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`
l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool0
0000Koooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^
kP03o`000?oooooo000000Wo000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?o^k^h02Oo^k^h00ol0003ooooooo3`l008oo3`
l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`
l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@1]onKViP03o`000?oooooo06IV00So06IV00?o0000
ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000
ooooool0<fH02?l0<fH00ol0003oooooo`00IP08o`00IP03o`000?oooooo<`1V00So<`1V00?o0000
oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000
oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000
oooooomV06H02?mV06H00ol0003oooooofH0<`08ofH0<`03o`000?ooooooIP0000SoIP0000?o0000
oooooomV<`002?mV<`000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000
oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000
oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?oooooo<fH000So<fH000?o0000
ooooool0IP002?l0IP000ol0003oooooo`1V<`08o`1V<`03o`000?oooooo06IV00So06IV00?o0000
ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000
ooooool000002_oVi^H00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000
ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000
ooooool00000KooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>S
X`1]onk^kP03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1V
IP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool0<fH02?l0<fH00ol0003oooooo`00
IP08o`00IP03o`000?oooooo<`1V00So<`1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0
IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0
IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0
<`08ofH0<`03o`000?ooooooIP0000SoIP0000?o0000oooooomV<`002?mV<`000ol0003oooooofIV
0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003oooooofIV
0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003oooooofIV
0008ofIV0003o`000?oooooo<fH000So<fH000?o0000ooooool0IP002?l0IP000ol0003oooooo`1V
<`08o`1V<`03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1V
IP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool000002_o^k^h00ol0003ooooooo3`
l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`
l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?
cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`1]ooooo`03o`000?oooooo06IV00So06IV
00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV
00?o0000ooooool0<fH02?l0<fH00ol0003oooooo`00IP08o`00IP03o`000?oooooo<`1V00So<`1V
00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V
00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V
00?o0000oooooomV06H02?mV06H00ol0003oooooofH0<`08ofH0<`03o`000?ooooooIP0000SoIP00
00?o0000oooooomV<`002?mV<`000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH0
00?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH0
00?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?oooooo<fH000So<fH0
00?o0000ooooool0IP002?l0IP000ol0003oooooo`1V<`08o`1V<`03o`000?oooooo06IV00So06IV
00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV
00?o0000ooooool000002_ooool00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`
00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`
00?o0000ooooool00000Koooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo
_Kfmoj>SX`1]onk^kP03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003o
ooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool0<fH02?l0<fH00ol0003o
ooooo`00IP08o`00IP03o`000?oooooo<`1V00So<`1V00?o0000oooooomV06H02?mV06H00ol0003o
ooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003o
ooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003o
ooooofH0<`08ofH0<`03o`000?ooooooIP0000SoIP0000?o0000oooooomV<`002?mV<`000ol0003o
ooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003o
ooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003o
ooooofIV0008ofIV0003o`000?oooooo<fH000So<fH000?o0000ooooool0IP002?l0IP000ol0003o
ooooo`1V<`08o`1V<`03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003o
ooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool000002_o^k^h00ol0003o
oooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003o
oooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koo^k^h01?nSXj?o
_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@1]onKViP03o`000?oooooo06IV
00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV
00So06IV00?o0000ooooool0<fH02?l0<fH00ol0003oooooo`00IP08o`00IP03o`000?oooooo<`1V
00So<`1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V
00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V
00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0<`08ofH0<`03o`000?ooooooIP00
00SoIP0000?o0000oooooomV<`002?mV<`000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH0
00SoIVH000?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH0
00SoIVH000?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?oooooo<fH0
00So<fH000?o0000ooooool0IP002?l0IP000ol0003oooooo`1V<`08o`1V<`03o`000?oooooo06IV
00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV
00So06IV00?o0000ooooool000002_oVi^H00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`
00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`
00Sol?3`00?o0000ooooool00000KooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[J
f_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH0
0ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool0<fH02?l0<fH0
0ol0003oooooo`00IP08o`00IP03o`000?oooooo<`1V00So<`1V00?o0000oooooomV06H02?mV06H0
0ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H0
0ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H0
0ol0003oooooofH0<`08ofH0<`03o`000?ooooooIP0000SoIP0000?o0000oooooomV<`002?mV<`00
0ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP00
0ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP00
0ol0003oooooofIV0008ofIV0003o`000?oooooo<fH000So<fH000?o0000ooooool0IP002?l0IP00
0ol0003oooooo`1V<`08o`1V<`03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH0
0ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool000002_o^k^h0
0ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?00
0ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`1]ooooo`03o`000?oo
oooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oo
oooo06IV00So06IV00?o0000ooooool0<fH02?l0<fH00ol0003oooooo`00IP08o`00IP03o`000?oo
oooo<`1V00So<`1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?oo
ooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?oo
ooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0<`08ofH0<`03o`000?oo
ooooIP0000SoIP0000?o0000oooooomV<`002?mV<`000ol0003oooooofIV0008ofIV0003o`000?oo
ooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?oo
ooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?oo
oooo<fH000So<fH000?o0000ooooool0IP002?l0IP000ol0003oooooo`1V<`08o`1V<`03o`000?oo
oooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oo
oooo06IV00So06IV00?o0000ooooool000002_ooool00ol0003ooooooo3`l008oo3`l003o`000?oo
ooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oo
ooool?3`00Sol?3`00?o0000ooooool00000Koooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000Go
hN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH0
2?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool0<fH0
2?l0<fH00ol0003oooooo`00IP08o`00IP03o`000?oooooo<`1V00So<`1V00?o0000oooooomV06H0
2?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H0
2?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H0
2?mV06H00ol0003oooooofH0<`08ofH0<`03o`000?ooooooIP0000SoIP0000?o0000oooooomV<`00
2?mV<`000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP00
2?mVIP000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP00
2?mVIP000ol0003oooooofIV0008ofIV0003o`000?oooooo<fH000So<fH000?o0000ooooool0IP00
2?l0IP000ol0003oooooo`1V<`08o`1V<`03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH0
2?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool00000
2_o^k^h00ol0003oooooooooo`0fooooo`03o`000?o^k^kok^k^06gok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0KOoVi^H00ol0003oooooo`1VIP08o`1VIP03
o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03
o`000?oooooo03=V00So03=V00?o0000ooooool006H02?l006H00ol0003ooooooc<0IP08oc<0IP03
o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03
o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03
o`000?ooooooIP1V00SoIP1V00?o0000oooooomV03<02?mV03<00ol0003oooooofH00008ofH00003
o`000?ooooooIS<000SoIS<000?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003
o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003
o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003ooooooc=V0008oc=V0003
o`000?oooooo06H000So06H000?o0000ooooool0IS<02?l0IS<00ol0003oooooo`1VIP08o`1VIP03
o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03
o`000?oooooo000000[oi^KV00?o0000ooooool000002Ol000000ooooooo0000o`000008o`000003
ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003
ooooool0003oi^KV06koi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm
_OnSXj<0KOo^k^h00ol0003oooooooooo`3ooooooeGooooo00?o0000onk^k_o^k^h02?o^k^h00ol0
003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0
003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koo^k^h01?nS
Xj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`1]ooooo`03o`000?oooooo
000000Wo000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?ooool02Oooool00ol0003ooooooo3`l008oo3`l003o`000?oooooo
l?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo
l?3`00Sol?3`00?o0000ooooool00000Koooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Q
om[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo09VI00So09VI00?o0000ooooool0VIT02?l0
VIT00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo06JI00So06JI00?o0000ooooool0<iT02?l0
<iT00ol0003oooooo`00V@08o`00V@03o`000?oooooo<`2I00So<`2I00?o0000oooooomV09T02?mV
09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI09T02?nI
09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI06H02?nI
06H00ol0003ooooooiT0<`08oiT0<`03o`000?ooooooV@0000SoV@0000?o0000oooooonI<`002?nI
<`000ol0003ooooooiUV0008oiUV0003o`000?ooooooVIT000SoVIT000?o0000oooooonIV@002?nI
V@000ol0003ooooooiVI0008oiVI0003o`000?ooooooVIT000SoVIT000?o0000oooooonIV@002?nI
V@000ol0003oooooofJI0008ofJI0003o`000?oooooo<iT000So<iT000?o0000ooooool0V@002?l0
V@000ol0003oooooo`2I<`08o`2I<`03o`000?oooooo09UV00So09UV00?o0000ooooool0VIT02?l0
VIT00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo09VI00So09VI00?o0000ooooool000002_o^
k^h00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`
l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koo^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@1]onKViP03o`00
0?oooooo09VI00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`2IV@08o`2IV@03o`00
0?oooooo06JI00So06JI00?o0000ooooool0<iT02?l0<iT00ol0003oooooo`00V@08o`00V@03o`00
0?oooooo<`2I00So<`2I00?o0000oooooomV09T02?mV09T00ol0003ooooooiT0V@08oiT0V@03o`00
0?ooooooV@2I00SoV@2I00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`00
0?ooooooV@2I00SoV@2I00?o0000oooooonI06H02?nI06H00ol0003ooooooiT0<`08oiT0<`03o`00
0?ooooooV@0000SoV@0000?o0000oooooonI<`002?nI<`000ol0003ooooooiUV0008oiUV0003o`00
0?ooooooVIT000SoVIT000?o0000oooooonIV@002?nIV@000ol0003ooooooiVI0008oiVI0003o`00
0?ooooooVIT000SoVIT000?o0000oooooonIV@002?nIV@000ol0003oooooofJI0008ofJI0003o`00
0?oooooo<iT000So<iT000?o0000ooooool0V@002?l0V@000ol0003oooooo`2I<`08o`2I<`03o`00
0?oooooo09UV00So09UV00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`2IV@08o`2IV@03o`00
0?oooooo09VI00So09VI00?o0000ooooool000002_oVi^H00ol0003ooooooo3`l008oo3`l003o`00
0?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`00
0?ooooool?3`00Sol?3`00?o0000ooooool00000KooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00
00GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo09VI00So09VI00?o0000ooooool0
VIT02?l0VIT00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo06JI00So06JI00?o0000ooooool0
<iT02?l0<iT00ol0003oooooo`00V@08o`00V@03o`000?oooooo<`2I00So<`2I00?o0000oooooomV
09T02?mV09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI
09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI
06H02?nI06H00ol0003ooooooiT0<`08oiT0<`03o`000?ooooooV@0000SoV@0000?o0000oooooonI
<`002?nI<`000ol0003ooooooiUV0008oiUV0003o`000?ooooooVIT000SoVIT000?o0000oooooonI
V@002?nIV@000ol0003ooooooiVI0008oiVI0003o`000?ooooooVIT000SoVIT000?o0000oooooonI
V@002?nIV@000ol0003oooooofJI0008ofJI0003o`000?oooooo<iT000So<iT000?o0000ooooool0
V@002?l0V@000ol0003oooooo`2I<`08o`2I<`03o`000?oooooo09UV00So09UV00?o0000ooooool0
VIT02?l0VIT00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo09VI00So09VI00?o0000ooooool0
00002_o^k^h00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`
l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool0
0000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`1]oooo
o`03o`000?oooooo09VI00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`2IV@08o`2I
V@03o`000?oooooo06JI00So06JI00?o0000ooooool0<iT02?l0<iT00ol0003oooooo`00V@08o`00
V@03o`000?oooooo<`2I00So<`2I00?o0000oooooomV09T02?mV09T00ol0003ooooooiT0V@08oiT0
V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0
V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI06H02?nI06H00ol0003ooooooiT0<`08oiT0
<`03o`000?ooooooV@0000SoV@0000?o0000oooooonI<`002?nI<`000ol0003ooooooiUV0008oiUV
0003o`000?ooooooVIT000SoVIT000?o0000oooooonIV@002?nIV@000ol0003ooooooiVI0008oiVI
0003o`000?ooooooVIT000SoVIT000?o0000oooooonIV@002?nIV@000ol0003oooooofJI0008ofJI
0003o`000?oooooo<iT000So<iT000?o0000ooooool0V@002?l0V@000ol0003oooooo`2I<`08o`2I
<`03o`000?oooooo09UV00So09UV00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`2IV@08o`2I
V@03o`000?oooooo09VI00So09VI00?o0000ooooool000002_ooool00ol0003ooooooo3`l008oo3`
l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`
l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koooool01?n_[joobl_;omkNg_oZj^X1
oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo09VI00So09VI00?o0000
ooooool0VIT02?l0VIT00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo06JI00So06JI00?o0000
ooooool0<iT02?l0<iT00ol0003oooooo`00V@08o`00V@03o`000?oooooo<`2I00So<`2I00?o0000
oooooomV09T02?mV09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000
oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000
oooooonI06H02?nI06H00ol0003ooooooiT0<`08oiT0<`03o`000?ooooooV@0000SoV@0000?o0000
oooooonI<`002?nI<`000ol0003ooooooiUV0008oiUV0003o`000?ooooooVIT000SoVIT000?o0000
oooooonIV@002?nIV@000ol0003ooooooiVI0008oiVI0003o`000?ooooooVIT000SoVIT000?o0000
oooooonIV@002?nIV@000ol0003oooooofJI0008ofJI0003o`000?oooooo<iT000So<iT000?o0000
ooooool0V@002?l0V@000ol0003oooooo`2I<`08o`2I<`03o`000?oooooo09UV00So09UV00?o0000
ooooool0VIT02?l0VIT00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo09VI00So09VI00?o0000
ooooool000002_o^k^h00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000
ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000
ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifM
W@1]onKViP03o`000?oooooo09VI00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`2I
V@08o`2IV@03o`000?oooooo06JI00So06JI00?o0000ooooool0<iT02?l0<iT00ol0003oooooo`00
V@08o`00V@03o`000?oooooo<`2I00So<`2I00?o0000oooooomV09T02?mV09T00ol0003ooooooiT0
V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0
V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI06H02?nI06H00ol0003ooooooiT0
<`08oiT0<`03o`000?ooooooV@0000SoV@0000?o0000oooooonI<`002?nI<`000ol0003ooooooiUV
0008oiUV0003o`000?ooooooVIT000SoVIT000?o0000oooooonIV@002?nIV@000ol0003ooooooiVI
0008oiVI0003o`000?ooooooVIT000SoVIT000?o0000oooooonIV@002?nIV@000ol0003oooooofJI
0008ofJI0003o`000?oooooo<iT000So<iT000?o0000ooooool0V@002?l0V@000ol0003oooooo`2I
<`08o`2I<`03o`000?oooooo09UV00So09UV00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`2I
V@08o`2IV@03o`000?oooooo09VI00So09VI00?o0000ooooool000002_oVi^H00ol0003ooooooo3`
l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`
l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000KooVi^H01?nMWIgo]kNgolS8
b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo09VI00So09VI
00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo06JI00So06JI
00?o0000ooooool0<iT02?l0<iT00ol0003oooooo`00V@08o`00V@03o`000?oooooo<`2I00So<`2I
00?o0000oooooomV09T02?mV09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I
00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I
00?o0000oooooonI06H02?nI06H00ol0003ooooooiT0<`08oiT0<`03o`000?ooooooV@0000SoV@00
00?o0000oooooonI<`002?nI<`000ol0003ooooooiUV0008oiUV0003o`000?ooooooVIT000SoVIT0
00?o0000oooooonIV@002?nIV@000ol0003ooooooiVI0008oiVI0003o`000?ooooooVIT000SoVIT0
00?o0000oooooonIV@002?nIV@000ol0003oooooofJI0008ofJI0003o`000?oooooo<iT000So<iT0
00?o0000ooooool0V@002?l0V@000ol0003oooooo`2I<`08o`2I<`03o`000?oooooo09UV00So09UV
00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo09VI00So09VI
00?o0000ooooool000002_o^k^h00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`
00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`
00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]ko
bl_;ojn_[`1]ooooo`03o`000?oooooo09VI00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003o
ooooo`2IV@08o`2IV@03o`000?oooooo06JI00So06JI00?o0000ooooool0<iT02?l0<iT00ol0003o
ooooo`00V@08o`00V@03o`000?oooooo<`2I00So<`2I00?o0000oooooomV09T02?mV09T00ol0003o
oooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI09T02?nI09T00ol0003o
oooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI06H02?nI06H00ol0003o
oooooiT0<`08oiT0<`03o`000?ooooooV@0000SoV@0000?o0000oooooonI<`002?nI<`000ol0003o
oooooiUV0008oiUV0003o`000?ooooooVIT000SoVIT000?o0000oooooonIV@002?nIV@000ol0003o
oooooiVI0008oiVI0003o`000?ooooooVIT000SoVIT000?o0000oooooonIV@002?nIV@000ol0003o
ooooofJI0008ofJI0003o`000?oooooo<iT000So<iT000?o0000ooooool0V@002?l0V@000ol0003o
ooooo`2I<`08o`2I<`03o`000?oooooo09UV00So09UV00?o0000ooooool0VIT02?l0VIT00ol0003o
ooooo`2IV@08o`2IV@03o`000?oooooo09VI00So09VI00?o0000ooooool000002_ooool00ol0003o
ooooooooo`0fooooo`03o`000?oooooooooo06gooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005
on7QhOoJf][oclo?okfm_OnSXj<0KOo^k^h00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo09VI
00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`1VV@08o`1VV@03o`000?oooooo03>I
00So03>I00?o0000ooooool009T02?l009T00ol0003ooooooc<0V@08oc<0V@03o`000?ooooooIP2I
00SoIP2I00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@2I
00SoV@2I00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@1V
00SoV@1V00?o0000oooooonI03<02?nI03<00ol0003ooooooiT00008oiT00003o`000?ooooooVC<0
00SoVC<000?o0000oooooonIIP002?nIIP000ol0003ooooooiVI0008oiVI0003o`000?ooooooVIT0
00SoVIT000?o0000oooooonIV@002?nIV@000ol0003ooooooiVI0008oiVI0003o`000?ooooooVIT0
00SoVIT000?o0000oooooomVV@002?mVV@000ol0003ooooooc>I0008oc>I0003o`000?oooooo09T0
00So09T000?o0000ooooool0VC<02?l0VC<00ol0003oooooo`2IIP08o`2IIP03o`000?oooooo09VI
00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo0000
00[ok^k^00?o0000ooooool000002Ol000000ooooooo0000o`000008o`000003ooooool0003o0000
00So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003ok^k^
06kok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0KOoVi^H0
0ol0003oooooooooo`3ooooooeGooooo00?o0000onKVi_oVi^H02?oVi^H00ol0003ooooooo3`l008
oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008
oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000KooVi^H01?nMWIgo]kNgolS8b?oC
dm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo000000Wo000000?o
ooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?o
ooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?o
ooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?o
ooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?o
ooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?o
ooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?o
ooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?o
ooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?o
ooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?o
ooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?o
ooooo`000?o^k^h02Oo^k^h00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o
0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o
0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;
ojn_[`1]ooooo`03o`000?oooooo0<c<00So0<c<00?o0000ooooool0c<`02?l0c<`00ol0003ooooo
o`2Ic008o`2Ic003o`000?oooooo06K<00So06K<00?o0000ooooool0<l`02?l0<l`00ol0003ooooo
o`00c008o`00c003o`000?oooooo<`3<00So<`3<00?o0000oooooomV0<`02?mV0<`00ol0003ooooo
oiT0c008oiT0c003o`000?ooooooc03<00Soc03<00?o0000ooooooo<0<`02?o<0<`00ol0003ooooo
ol`0c008ol`0c003o`000?ooooooc02I00Soc02I00?o0000ooooooo<06H02?o<06H00ol0003ooooo
ol`0<`08ol`0<`03o`000?ooooooc00000Soc00000?o0000ooooooo<<`002?o<<`000ol0003ooooo
olaV0008olaV0003o`000?ooooooc9T000Soc9T000?o0000ooooooo<c0002?o<c0000ol0003ooooo
olc<0008olc<0003o`000?ooooooc<`000Soc<`000?o0000oooooonIc0002?nIc0000ol0003ooooo
ofK<0008ofK<0003o`000?oooooo<l`000So<l`000?o0000ooooool0c0002?l0c0000ol0003ooooo
o`3<<`08o`3<<`03o`000?oooooo0<aV00So0<aV00?o0000ooooool0c9T02?l0c9T00ol0003ooooo
o`3<c008o`3<c003o`000?oooooo0<c<00So0<c<00?o0000ooooool000002_ooool00ol0003ooooo
oo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooo
oo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koooool01?n_[joobl_;
omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo0<c<00So
0<c<00?o0000ooooool0c<`02?l0c<`00ol0003oooooo`2Ic008o`2Ic003o`000?oooooo06K<00So
06K<00?o0000ooooool0<l`02?l0<l`00ol0003oooooo`00c008o`00c003o`000?oooooo<`3<00So
<`3<00?o0000oooooomV0<`02?mV0<`00ol0003ooooooiT0c008oiT0c003o`000?ooooooc03<00So
c03<00?o0000ooooooo<0<`02?o<0<`00ol0003ooooool`0c008ol`0c003o`000?ooooooc02I00So
c02I00?o0000ooooooo<06H02?o<06H00ol0003ooooool`0<`08ol`0<`03o`000?ooooooc00000So
c00000?o0000ooooooo<<`002?o<<`000ol0003oooooolaV0008olaV0003o`000?ooooooc9T000So
c9T000?o0000ooooooo<c0002?o<c0000ol0003oooooolc<0008olc<0003o`000?ooooooc<`000So
c<`000?o0000oooooonIc0002?nIc0000ol0003oooooofK<0008ofK<0003o`000?oooooo<l`000So
<l`000?o0000ooooool0c0002?l0c0000ol0003oooooo`3<<`08o`3<<`03o`000?oooooo0<aV00So
0<aV00?o0000ooooool0c9T02?l0c9T00ol0003oooooo`3<c008o`3<c003o`000?oooooo0<c<00So
0<c<00?o0000ooooool000002_o^k^h00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00So
l?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00So
l?3`00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8
b<So]kNgoifMW@1]onKViP03o`000?oooooo0<c<00So0<c<00?o0000ooooool0c<`02?l0c<`00ol0
003oooooo`2Ic008o`2Ic003o`000?oooooo06K<00So06K<00?o0000ooooool0<l`02?l0<l`00ol0
003oooooo`00c008o`00c003o`000?oooooo<`3<00So<`3<00?o0000oooooomV0<`02?mV0<`00ol0
003ooooooiT0c008oiT0c003o`000?ooooooc03<00Soc03<00?o0000ooooooo<0<`02?o<0<`00ol0
003ooooool`0c008ol`0c003o`000?ooooooc02I00Soc02I00?o0000ooooooo<06H02?o<06H00ol0
003ooooool`0<`08ol`0<`03o`000?ooooooc00000Soc00000?o0000ooooooo<<`002?o<<`000ol0
003oooooolaV0008olaV0003o`000?ooooooc9T000Soc9T000?o0000ooooooo<c0002?o<c0000ol0
003oooooolc<0008olc<0003o`000?ooooooc<`000Soc<`000?o0000oooooonIc0002?nIc0000ol0
003oooooofK<0008ofK<0003o`000?oooooo<l`000So<l`000?o0000ooooool0c0002?l0c0000ol0
003oooooo`3<<`08o`3<<`03o`000?oooooo0<aV00So0<aV00?o0000ooooool0c9T02?l0c9T00ol0
003oooooo`3<c008o`3<c003o`000?oooooo0<c<00So0<c<00?o0000ooooool000002_oVi^H00ol0
003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0
003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000KooVi^H01?nM
WIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo
0<c<00So0<c<00?o0000ooooool0c<`02?l0c<`00ol0003oooooo`2Ic008o`2Ic003o`000?oooooo
06K<00So06K<00?o0000ooooool0<l`02?l0<l`00ol0003oooooo`00c008o`00c003o`000?oooooo
<`3<00So<`3<00?o0000oooooomV0<`02?mV0<`00ol0003ooooooiT0c008oiT0c003o`000?oooooo
c03<00Soc03<00?o0000ooooooo<0<`02?o<0<`00ol0003ooooool`0c008ol`0c003o`000?oooooo
c02I00Soc02I00?o0000ooooooo<06H02?o<06H00ol0003ooooool`0<`08ol`0<`03o`000?oooooo
c00000Soc00000?o0000ooooooo<<`002?o<<`000ol0003oooooolaV0008olaV0003o`000?oooooo
c9T000Soc9T000?o0000ooooooo<c0002?o<c0000ol0003oooooolc<0008olc<0003o`000?oooooo
c<`000Soc<`000?o0000oooooonIc0002?nIc0000ol0003oooooofK<0008ofK<0003o`000?oooooo
<l`000So<l`000?o0000ooooool0c0002?l0c0000ol0003oooooo`3<<`08o`3<<`03o`000?oooooo
0<aV00So0<aV00?o0000ooooool0c9T02?l0c9T00ol0003oooooo`3<c008o`3<c003o`000?oooooo
0<c<00So0<c<00?o0000ooooool000002_o^k^h00ol0003ooooooo3`l008oo3`l003o`000?oooooo
l?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo
l?3`00Sol?3`00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;b
on[Zj_oNg]kobl_;ojn_[`1]ooooo`03o`000?oooooo0<c<00So0<c<00?o0000ooooool0c<`02?l0
c<`00ol0003oooooo`2Ic008o`2Ic003o`000?oooooo06K<00So06K<00?o0000ooooool0<l`02?l0
<l`00ol0003oooooo`00c008o`00c003o`000?oooooo<`3<00So<`3<00?o0000oooooomV0<`02?mV
0<`00ol0003ooooooiT0c008oiT0c003o`000?ooooooc03<00Soc03<00?o0000ooooooo<0<`02?o<
0<`00ol0003ooooool`0c008ol`0c003o`000?ooooooc02I00Soc02I00?o0000ooooooo<06H02?o<
06H00ol0003ooooool`0<`08ol`0<`03o`000?ooooooc00000Soc00000?o0000ooooooo<<`002?o<
<`000ol0003oooooolaV0008olaV0003o`000?ooooooc9T000Soc9T000?o0000ooooooo<c0002?o<
c0000ol0003oooooolc<0008olc<0003o`000?ooooooc<`000Soc<`000?o0000oooooonIc0002?nI
c0000ol0003oooooofK<0008ofK<0003o`000?oooooo<l`000So<l`000?o0000ooooool0c0002?l0
c0000ol0003oooooo`3<<`08o`3<<`03o`000?oooooo0<aV00So0<aV00?o0000ooooool0c9T02?l0
c9T00ol0003oooooo`3<c008o`3<c003o`000?oooooo0<c<00So0<c<00?o0000ooooool000002_oo
ool00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`
l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Kooo
ool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`00
0?oooooo0<c<00So0<c<00?o0000ooooool0c<`02?l0c<`00ol0003oooooo`2Ic008o`2Ic003o`00
0?oooooo06K<00So06K<00?o0000ooooool0<l`02?l0<l`00ol0003oooooo`00c008o`00c003o`00
0?oooooo<`3<00So<`3<00?o0000oooooomV0<`02?mV0<`00ol0003ooooooiT0c008oiT0c003o`00
0?ooooooc03<00Soc03<00?o0000ooooooo<0<`02?o<0<`00ol0003ooooool`0c008ol`0c003o`00
0?ooooooc02I00Soc02I00?o0000ooooooo<06H02?o<06H00ol0003ooooool`0<`08ol`0<`03o`00
0?ooooooc00000Soc00000?o0000ooooooo<<`002?o<<`000ol0003oooooolaV0008olaV0003o`00
0?ooooooc9T000Soc9T000?o0000ooooooo<c0002?o<c0000ol0003oooooolc<0008olc<0003o`00
0?ooooooc<`000Soc<`000?o0000oooooonIc0002?nIc0000ol0003oooooofK<0008ofK<0003o`00
0?oooooo<l`000So<l`000?o0000ooooool0c0002?l0c0000ol0003oooooo`3<<`08o`3<<`03o`00
0?oooooo0<aV00So0<aV00?o0000ooooool0c9T02?l0c9T00ol0003oooooo`3<c008o`3<c003o`00
0?oooooo0<c<00So0<c<00?o0000ooooool000002_o^k^h00ol0003ooooooo3`l008oo3`l003o`00
0?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`00
0?ooooool?3`00Sol?3`00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00
00Gof][Jom?Cdoo8b<So]kNgoifMW@1]onKViP03o`000?oooooo0<c<00So0<c<00?o0000ooooool0
c<`02?l0c<`00ol0003oooooo`2Ic008o`2Ic003o`000?oooooo06K<00So06K<00?o0000ooooool0
<l`02?l0<l`00ol0003oooooo`00c008o`00c003o`000?oooooo<`3<00So<`3<00?o0000oooooomV
0<`02?mV0<`00ol0003ooooooiT0c008oiT0c003o`000?ooooooc03<00Soc03<00?o0000ooooooo<
0<`02?o<0<`00ol0003ooooool`0c008ol`0c003o`000?ooooooc02I00Soc02I00?o0000ooooooo<
06H02?o<06H00ol0003ooooool`0<`08ol`0<`03o`000?ooooooc00000Soc00000?o0000ooooooo<
<`002?o<<`000ol0003oooooolaV0008olaV0003o`000?ooooooc9T000Soc9T000?o0000ooooooo<
c0002?o<c0000ol0003oooooolc<0008olc<0003o`000?ooooooc<`000Soc<`000?o0000oooooonI
c0002?nIc0000ol0003oooooofK<0008ofK<0003o`000?oooooo<l`000So<l`000?o0000ooooool0
c0002?l0c0000ol0003oooooo`3<<`08o`3<<`03o`000?oooooo0<aV00So0<aV00?o0000ooooool0
c9T02?l0c9T00ol0003oooooo`3<c008o`3<c003o`000?oooooo0<c<00So0<c<00?o0000ooooool0
00002_oVi^H00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`
l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool0
0000KooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^
kP03o`000?oooooo0<c<00So0<c<00?o0000ooooool0c<`02?l0c<`00ol0003oooooo`2Ic008o`2I
c003o`000?oooooo06K<00So06K<00?o0000ooooool0<l`02?l0<l`00ol0003oooooo`00c008o`00
c003o`000?oooooo<`3<00So<`3<00?o0000oooooomV0<`02?mV0<`00ol0003ooooooiT0c008oiT0
c003o`000?ooooooc03<00Soc03<00?o0000ooooooo<0<`02?o<0<`00ol0003ooooool`0c008ol`0
c003o`000?ooooooc02I00Soc02I00?o0000ooooooo<06H02?o<06H00ol0003ooooool`0<`08ol`0
<`03o`000?ooooooc00000Soc00000?o0000ooooooo<<`002?o<<`000ol0003oooooolaV0008olaV
0003o`000?ooooooc9T000Soc9T000?o0000ooooooo<c0002?o<c0000ol0003oooooolc<0008olc<
0003o`000?ooooooc<`000Soc<`000?o0000oooooonIc0002?nIc0000ol0003oooooofK<0008ofK<
0003o`000?oooooo<l`000So<l`000?o0000ooooool0c0002?l0c0000ol0003oooooo`3<<`08o`3<
<`03o`000?oooooo0<aV00So0<aV00?o0000ooooool0c9T02?l0c9T00ol0003oooooo`3<c008o`3<
c003o`000?oooooo0<c<00So0<c<00?o0000ooooool000002_o^k^h00ol0003oooooooooo`0foooo
o`03o`000?o^k^kok^k^06gok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kN
ol_;bon_[jl0KOooool00ol0003oooooo`3<c008o`3<c003o`000?oooooo0<c<00So0<c<00?o0000
ooooool0VL`02?l0VL`00ol0003oooooo`1Vc008o`1Vc003o`000?oooooo03?<00So03?<00?o0000
ooooool00<`02?l00<`00ol0003ooooooc<0c008oc<0c003o`000?ooooooIP3<00SoIP3<00?o0000
oooooonI0<`02?nI0<`00ol0003ooooool`0c008ol`0c003o`000?ooooooc03<00Soc03<00?o0000
ooooooo<0<`02?o<0<`00ol0003ooooool`0V@08ol`0V@03o`000?ooooooc01V00Soc01V00?o0000
ooooooo<03<02?o<03<00ol0003ooooool`00008ol`00003o`000?ooooooc3<000Soc3<000?o0000
ooooooo<IP002?o<IP000ol0003oooooolbI0008olbI0003o`000?ooooooc<`000Soc<`000?o0000
ooooooo<c0002?o<c0000ol0003oooooolc<0008olc<0003o`000?ooooooVL`000SoVL`000?o0000
oooooomVc0002?mVc0000ol0003ooooooc?<0008oc?<0003o`000?oooooo0<`000So0<`000?o0000
ooooool0c3<02?l0c3<00ol0003oooooo`3<IP08o`3<IP03o`000?oooooo0<bI00So0<bI00?o0000
ooooool0c<`02?l0c<`00ol0003oooooo`3<c008o`3<c003o`000?oooooo000000[ooooo00?o0000
ooooool000002Ol000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?ooooo
o`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003ooooo06kooooo00Co[jn_
ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0KOo^k^h00ol0003ooooooooo
o`3ooooooeGooooo00?o0000onk^k_o^k^h02?o^k^h00ol0003ooooooo3`l008oo3`l003o`000?oo
ooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oo
ooool?3`00Sol?3`00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Go
f][Jom?Cdoo8b<So]kNgoifMW@1]onKViP03o`000?oooooo000000Wo000000?oooooo`000?l00000
2?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l00000
2?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l00000
2?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l00000
2?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l00000
2?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l00000
2?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l00000
2?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l00000
2?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l00000
2?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l00000
2?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?oVi^H0
2OoVi^H00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?00
2?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000
KooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03
o`000?oooooo0?oo00So0?oo00?o0000ooooool0c?l02?l0c?l00ol0003oooooo`2Io`08o`2Io`03
o`000?oooooo06Ko00So06Ko00?o0000ooooool0<ol02?l0<ol00ol0003oooooo`00o`08o`00o`03
o`000?oooooo<`3o00So<`3o00?o0000oooooomV0?l02?mV0?l00ol0003ooooooiT0o`08oiT0o`03
o`000?ooooooc03o00Soc03o00?o0000oooooooo0?l02?oo0?l00ol0003oooooool0c008ool0c003
o`000?ooooooo`2I00Soo`2I00?o0000oooooooo06H02?oo06H00ol0003oooooool0<`08ool0<`03
o`000?ooooooo`0000Soo`0000?o0000oooooooo<`002?oo<`000ol0003ooooooomV0008oomV0003
o`000?oooooooiT000SooiT000?o0000ooooooooc0002?ooc0000ol0003ooooooooo0008oooo0003
o`000?ooooooc?l000Soc?l000?o0000oooooonIo`002?nIo`000ol0003oooooofKo0008ofKo0003
o`000?oooooo<ol000So<ol000?o0000ooooool0o`002?l0o`000ol0003oooooo`3o<`08o`3o<`03
o`000?oooooo0?mV00So0?mV00?o0000ooooool0oiT02?l0oiT00ol0003oooooo`3oc008o`3oc003
o`000?oooooo0?oo00So0?oo00?o0000ooooool000002_o^k^h00ol0003ooooooo3`l008oo3`l003
o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003
o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Q
h@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`1]ooooo`03o`000?oooooo0?oo00So0?oo00?o0000oooo
ool0c?l02?l0c?l00ol0003oooooo`2Io`08o`2Io`03o`000?oooooo06Ko00So06Ko00?o0000oooo
ool0<ol02?l0<ol00ol0003oooooo`00o`08o`00o`03o`000?oooooo<`3o00So<`3o00?o0000oooo
oomV0?l02?mV0?l00ol0003ooooooiT0o`08oiT0o`03o`000?ooooooc03o00Soc03o00?o0000oooo
oooo0?l02?oo0?l00ol0003oooooool0c008ool0c003o`000?ooooooo`2I00Soo`2I00?o0000oooo
oooo06H02?oo06H00ol0003oooooool0<`08ool0<`03o`000?ooooooo`0000Soo`0000?o0000oooo
oooo<`002?oo<`000ol0003ooooooomV0008oomV0003o`000?oooooooiT000SooiT000?o0000oooo
ooooc0002?ooc0000ol0003ooooooooo0008oooo0003o`000?ooooooc?l000Soc?l000?o0000oooo
oonIo`002?nIo`000ol0003oooooofKo0008ofKo0003o`000?oooooo<ol000So<ol000?o0000oooo
ool0o`002?l0o`000ol0003oooooo`3o<`08o`3o<`03o`000?oooooo0?mV00So0?mV00?o0000oooo
ool0oiT02?l0oiT00ol0003oooooo`3oc008o`3oc003o`000?oooooo0?oo00So0?oo00?o0000oooo
ool000002_ooool00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000oooo
ooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000oooo
ool00000Koooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]
onk^kP03o`000?oooooo0?oo00So0?oo00?o0000ooooool0c?l02?l0c?l00ol0003oooooo`2Io`08
o`2Io`03o`000?oooooo06Ko00So06Ko00?o0000ooooool0<ol02?l0<ol00ol0003oooooo`00o`08
o`00o`03o`000?oooooo<`3o00So<`3o00?o0000oooooomV0?l02?mV0?l00ol0003ooooooiT0o`08
oiT0o`03o`000?ooooooc03o00Soc03o00?o0000oooooooo0?l02?oo0?l00ol0003oooooool0c008
ool0c003o`000?ooooooo`2I00Soo`2I00?o0000oooooooo06H02?oo06H00ol0003oooooool0<`08
ool0<`03o`000?ooooooo`0000Soo`0000?o0000oooooooo<`002?oo<`000ol0003ooooooomV0008
oomV0003o`000?oooooooiT000SooiT000?o0000ooooooooc0002?ooc0000ol0003ooooooooo0008
oooo0003o`000?ooooooc?l000Soc?l000?o0000oooooonIo`002?nIo`000ol0003oooooofKo0008
ofKo0003o`000?oooooo<ol000So<ol000?o0000ooooool0o`002?l0o`000ol0003oooooo`3o<`08
o`3o<`03o`000?oooooo0?mV00So0?mV00?o0000ooooool0oiT02?l0oiT00ol0003oooooo`3oc008
o`3oc003o`000?oooooo0?oo00So0?oo00?o0000ooooool000002_o^k^h00ol0003ooooooo3`l008
oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008
oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJ
f]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@1]onKViP03o`000?oooooo0?oo00So0?oo00?o
0000ooooool0c?l02?l0c?l00ol0003oooooo`2Io`08o`2Io`03o`000?oooooo06Ko00So06Ko00?o
0000ooooool0<ol02?l0<ol00ol0003oooooo`00o`08o`00o`03o`000?oooooo<`3o00So<`3o00?o
0000oooooomV0?l02?mV0?l00ol0003ooooooiT0o`08oiT0o`03o`000?ooooooc03o00Soc03o00?o
0000oooooooo0?l02?oo0?l00ol0003oooooool0c008ool0c003o`000?ooooooo`2I00Soo`2I00?o
0000oooooooo06H02?oo06H00ol0003oooooool0<`08ool0<`03o`000?ooooooo`0000Soo`0000?o
0000oooooooo<`002?oo<`000ol0003ooooooomV0008oomV0003o`000?oooooooiT000SooiT000?o
0000ooooooooc0002?ooc0000ol0003ooooooooo0008oooo0003o`000?ooooooc?l000Soc?l000?o
0000oooooonIo`002?nIo`000ol0003oooooofKo0008ofKo0003o`000?oooooo<ol000So<ol000?o
0000ooooool0o`002?l0o`000ol0003oooooo`3o<`08o`3o<`03o`000?oooooo0?mV00So0?mV00?o
0000ooooool0oiT02?l0oiT00ol0003oooooo`3oc008o`3oc003o`000?oooooo0?oo00So0?oo00?o
0000ooooool000002_oVi^H00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o
0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o
0000ooooool00000KooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfm
oj>SX`1]onk^kP03o`000?oooooo0?oo00So0?oo00?o0000ooooool0c?l02?l0c?l00ol0003ooooo
o`2Io`08o`2Io`03o`000?oooooo06Ko00So06Ko00?o0000ooooool0<ol02?l0<ol00ol0003ooooo
o`00o`08o`00o`03o`000?oooooo<`3o00So<`3o00?o0000oooooomV0?l02?mV0?l00ol0003ooooo
oiT0o`08oiT0o`03o`000?ooooooc03o00Soc03o00?o0000oooooooo0?l02?oo0?l00ol0003ooooo
ool0c008ool0c003o`000?ooooooo`2I00Soo`2I00?o0000oooooooo06H02?oo06H00ol0003ooooo
ool0<`08ool0<`03o`000?ooooooo`0000Soo`0000?o0000oooooooo<`002?oo<`000ol0003ooooo
oomV0008oomV0003o`000?oooooooiT000SooiT000?o0000ooooooooc0002?ooc0000ol0003ooooo
oooo0008oooo0003o`000?ooooooc?l000Soc?l000?o0000oooooonIo`002?nIo`000ol0003ooooo
ofKo0008ofKo0003o`000?oooooo<ol000So<ol000?o0000ooooool0o`002?l0o`000ol0003ooooo
o`3o<`08o`3o<`03o`000?oooooo0?mV00So0?mV00?o0000ooooool0oiT02?l0oiT00ol0003ooooo
o`3oc008o`3oc003o`000?oooooo0?oo00So0?oo00?o0000ooooool000002_o^k^h00ol0003ooooo
oo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooo
oo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`1]ooooo`03o`000?oooooo0?oo00So
0?oo00?o0000ooooool0c?l02?l0c?l00ol0003oooooo`2Io`08o`2Io`03o`000?oooooo06Ko00So
06Ko00?o0000ooooool0<ol02?l0<ol00ol0003oooooo`00o`08o`00o`03o`000?oooooo<`3o00So
<`3o00?o0000oooooomV0?l02?mV0?l00ol0003ooooooiT0o`08oiT0o`03o`000?ooooooc03o00So
c03o00?o0000oooooooo0?l02?oo0?l00ol0003oooooool0c008ool0c003o`000?ooooooo`2I00So
o`2I00?o0000oooooooo06H02?oo06H00ol0003oooooool0<`08ool0<`03o`000?ooooooo`0000So
o`0000?o0000oooooooo<`002?oo<`000ol0003ooooooomV0008oomV0003o`000?oooooooiT000So
oiT000?o0000ooooooooc0002?ooc0000ol0003ooooooooo0008oooo0003o`000?ooooooc?l000So
c?l000?o0000oooooonIo`002?nIo`000ol0003oooooofKo0008ofKo0003o`000?oooooo<ol000So
<ol000?o0000ooooool0o`002?l0o`000ol0003oooooo`3o<`08o`3o<`03o`000?oooooo0?mV00So
0?mV00?o0000ooooool0oiT02?l0oiT00ol0003oooooo`3oc008o`3oc003o`000?oooooo0?oo00So
0?oo00?o0000ooooool000002_ooool00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00So
l?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00So
l?3`00?o0000ooooool00000Koooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?
cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo0?oo00So0?oo00?o0000ooooool0c?l02?l0c?l00ol0
003oooooo`2Io`08o`2Io`03o`000?oooooo06Ko00So06Ko00?o0000ooooool0<ol02?l0<ol00ol0
003oooooo`00o`08o`00o`03o`000?oooooo<`3o00So<`3o00?o0000oooooomV0?l02?mV0?l00ol0
003ooooooiT0o`08oiT0o`03o`000?ooooooc03o00Soc03o00?o0000oooooooo0?l02?oo0?l00ol0
003oooooool0c008ool0c003o`000?ooooooo`2I00Soo`2I00?o0000oooooooo06H02?oo06H00ol0
003oooooool0<`08ool0<`03o`000?ooooooo`0000Soo`0000?o0000oooooooo<`002?oo<`000ol0
003ooooooomV0008oomV0003o`000?oooooooiT000SooiT000?o0000ooooooooc0002?ooc0000ol0
003ooooooooo0008oooo0003o`000?ooooooc?l000Soc?l000?o0000oooooonIo`002?nIo`000ol0
003oooooofKo0008ofKo0003o`000?oooooo<ol000So<ol000?o0000ooooool0o`002?l0o`000ol0
003oooooo`3o<`08o`3o<`03o`000?oooooo0?mV00So0?mV00?o0000ooooool0oiT02?l0oiT00ol0
003oooooo`3oc008o`3oc003o`000?oooooo0?oo00So0?oo00?o0000ooooool000002_o^k^h00ol0
003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0
003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koo^k^h01?nS
Xj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@1]onKViP03o`000?oooooo
0?oo00So0?oo00?o0000ooooool0c?l02?l0c?l00ol0003oooooo`2Io`08o`2Io`03o`000?oooooo
06Ko00So06Ko00?o0000ooooool0<ol02?l0<ol00ol0003oooooo`00o`08o`00o`03o`000?oooooo
<`3o00So<`3o00?o0000oooooomV0?l02?mV0?l00ol0003ooooooiT0o`08oiT0o`03o`000?oooooo
c03o00Soc03o00?o0000oooooooo0?l02?oo0?l00ol0003oooooool0c008ool0c003o`000?oooooo
o`2I00Soo`2I00?o0000oooooooo06H02?oo06H00ol0003oooooool0<`08ool0<`03o`000?oooooo
o`0000Soo`0000?o0000oooooooo<`002?oo<`000ol0003ooooooomV0008oomV0003o`000?oooooo
oiT000SooiT000?o0000ooooooooc0002?ooc0000ol0003ooooooooo0008oooo0003o`000?oooooo
c?l000Soc?l000?o0000oooooonIo`002?nIo`000ol0003oooooofKo0008ofKo0003o`000?oooooo
<ol000So<ol000?o0000ooooool0o`002?l0o`000ol0003oooooo`3o<`08o`3o<`03o`000?oooooo
0?mV00So0?mV00?o0000ooooool0oiT02?l0oiT00ol0003oooooo`3oc008o`3oc003o`000?oooooo
0?oo00So0?oo00?o0000ooooool000002_oVi^H00ol0003oooooooooo`0fooooo`03o`000?oVi^Ko
i^KV06goi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0KOo^
k^h00ol0003oooooo`3oo`08o`3oo`03o`000?oooooo0<co00So0<co00?o0000ooooool0VOl02?l0
VOl00ol0003oooooo`1Vo`08o`1Vo`03o`000?oooooo03?o00So03?o00?o0000ooooool00?l02?l0
0?l00ol0003ooooooc<0o`08oc<0o`03o`000?ooooooIP3o00SoIP3o00?o0000oooooonI0?l02?nI
0?l00ol0003ooooool`0o`08ol`0o`03o`000?ooooooo`3o00Soo`3o00?o0000oooooooo0<`02?oo
0<`00ol0003oooooool0V@08ool0V@03o`000?ooooooo`1V00Soo`1V00?o0000oooooooo03<02?oo
03<00ol0003oooooool00008ool00003o`000?oooooooc<000Sooc<000?o0000ooooooooIP002?oo
IP000ol0003ooooooonI0008oonI0003o`000?oooooool`000Sool`000?o0000ooooooooo`002?oo
o`000ol0003oooooolco0008olco0003o`000?ooooooVOl000SoVOl000?o0000oooooomVo`002?mV
o`000ol0003ooooooc?o0008oc?o0003o`000?oooooo0?l000So0?l000?o0000ooooool0oc<02?l0
oc<00ol0003oooooo`3oIP08o`3oIP03o`000?oooooo0?nI00So0?nI00?o0000ooooool0ol`02?l0
ol`00ol0003oooooo`3oo`08o`3oo`03o`000?oooooo000000[ok^k^00?o0000ooooool000002Ol0
00000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l0
00000ooooooo0000o`000008o`000003ooooool0003ok^k^06kok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0KOooool00ol0003oooooooooo`3ooooooeGooooo
00?o0000ooooooooool02?ooool00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`
00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`
00?o0000ooooool00000Koooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo
_Kfmoj>SX`1]onk^kP03o`000?oooooo000000Wo000000?oooooo`000?l000002?l000000ooooooo
0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo
0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo
0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo
0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo
0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo
0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo
0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo
0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo
0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo
0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?o^k^h02Oo^k^h00ol0003o
oooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003o
oooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koo^k^h01?nSXj?o
_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@1]onKViP03o`000?oooooo<ooo
00So<ooo00?o0000oooooolcc?l02?lcc?l00ol0003ooooooc>Io`08oc>Io`03o`000?oooooo<fKo
00So<fKo00?o0000oooooolc<ol02?lc<ol00ol0003ooooooc<co`08oc<co`03o`000?oooooo<c?o
00So<c?o00?o0000oooooomV<ol02?mV<ol00ol0003ooooooiTco`08oiTco`03o`000?ooooooc3?o
00Soc3?o00?o0000oooooooo<ol02?oo<ol00ol0003ooooooolcc008oolcc003o`000?oooooooc>I
00Sooc>I00?o0000oooooooo<fH02?oo<fH00ol0003ooooooolc<`08oolc<`03o`000?oooooooc<c
00Sooc<c00?o0000oooooooo<c<02?oo<c<00ol0003ooooooomV<`08oomV<`03o`000?oooooooiTc
00SooiTc00?o0000ooooooooc3<02?ooc3<00ol0003ooooooooo<`08oooo<`03o`000?ooooooc?lc
00Soc?lc00?o0000oooooonIm3<02?nIm3<00ol0003oooooofKo<`08ofKo<`03o`000?oooooo<olc
00So<olc00?o0000oooooolcoc<02?lcoc<00ol0003ooooooc?o<`08oc?o<`03o`000?oooooo<omV
00So<omV00?o0000oooooolcoiT02?lcoiT00ol0003ooooooc?oc008oc?oc003o`000?oooooo<ooo
00So<ooo00?o0000ooooool000002_oVi^H00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`
00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`
00Sol?3`00?o0000ooooool00000KooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[J
f_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo<ooo00So<ooo00?o0000oooooolcc?l02?lcc?l0
0ol0003ooooooc>Io`08oc>Io`03o`000?oooooo<fKo00So<fKo00?o0000oooooolc<ol02?lc<ol0
0ol0003ooooooc<co`08oc<co`03o`000?oooooo<c?o00So<c?o00?o0000oooooomV<ol02?mV<ol0
0ol0003ooooooiTco`08oiTco`03o`000?ooooooc3?o00Soc3?o00?o0000oooooooo<ol02?oo<ol0
0ol0003ooooooolcc008oolcc003o`000?oooooooc>I00Sooc>I00?o0000oooooooo<fH02?oo<fH0
0ol0003ooooooolc<`08oolc<`03o`000?oooooooc<c00Sooc<c00?o0000oooooooo<c<02?oo<c<0
0ol0003ooooooomV<`08oomV<`03o`000?oooooooiTc00SooiTc00?o0000ooooooooc3<02?ooc3<0
0ol0003ooooooooo<`08oooo<`03o`000?ooooooc?lc00Soc?lc00?o0000oooooonIm3<02?nIm3<0
0ol0003oooooofKo<`08ofKo<`03o`000?oooooo<olc00So<olc00?o0000oooooolcoc<02?lcoc<0
0ol0003ooooooc?o<`08oc?o<`03o`000?oooooo<omV00So<omV00?o0000oooooolcoiT02?lcoiT0
0ol0003ooooooc?oc008oc?oc003o`000?oooooo<ooo00So<ooo00?o0000ooooool000002_o^k^h0
0ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?00
0ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`1]ooooo`03o`000?oo
oooo<ooo00So<ooo00?o0000oooooolcc?l02?lcc?l00ol0003ooooooc>Io`08oc>Io`03o`000?oo
oooo<fKo00So<fKo00?o0000oooooolc<ol02?lc<ol00ol0003ooooooc<co`08oc<co`03o`000?oo
oooo<c?o00So<c?o00?o0000oooooomV<ol02?mV<ol00ol0003ooooooiTco`08oiTco`03o`000?oo
ooooc3?o00Soc3?o00?o0000oooooooo<ol02?oo<ol00ol0003ooooooolcc008oolcc003o`000?oo
oooooc>I00Sooc>I00?o0000oooooooo<fH02?oo<fH00ol0003ooooooolc<`08oolc<`03o`000?oo
oooooc<c00Sooc<c00?o0000oooooooo<c<02?oo<c<00ol0003ooooooomV<`08oomV<`03o`000?oo
oooooiTc00SooiTc00?o0000ooooooooc3<02?ooc3<00ol0003ooooooooo<`08oooo<`03o`000?oo
ooooc?lc00Soc?lc00?o0000oooooonIm3<02?nIm3<00ol0003oooooofKo<`08ofKo<`03o`000?oo
oooo<olc00So<olc00?o0000oooooolcoc<02?lcoc<00ol0003ooooooc?o<`08oc?o<`03o`000?oo
oooo<omV00So<omV00?o0000oooooolcoiT02?lcoiT00ol0003ooooooc?oc008oc?oc003o`000?oo
oooo<ooo00So<ooo00?o0000ooooool000002_ooool00ol0003ooooooo3`l008oo3`l003o`000?oo
ooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oo
ooool?3`00Sol?3`00?o0000ooooool00000Koooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000Go
hN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo<ooo00So<ooo00?o0000oooooolcc?l0
2?lcc?l00ol0003ooooooc>Io`08oc>Io`03o`000?oooooo<fKo00So<fKo00?o0000oooooolc<ol0
2?lc<ol00ol0003ooooooc<co`08oc<co`03o`000?oooooo<c?o00So<c?o00?o0000oooooomV<ol0
2?mV<ol00ol0003ooooooiTco`08oiTco`03o`000?ooooooc3?o00Soc3?o00?o0000oooooooo<ol0
2?oo<ol00ol0003ooooooolcc008oolcc003o`000?oooooooc>I00Sooc>I00?o0000oooooooo<fH0
2?oo<fH00ol0003ooooooolc<`08oolc<`03o`000?oooooooc<c00Sooc<c00?o0000oooooooo<c<0
2?oo<c<00ol0003ooooooomV<`08oomV<`03o`000?oooooooiTc00SooiTc00?o0000ooooooooc3<0
2?ooc3<00ol0003ooooooooo<`08oooo<`03o`000?ooooooc?lc00Soc?lc00?o0000oooooonIm3<0
2?nIm3<00ol0003oooooofKo<`08ofKo<`03o`000?oooooo<olc00So<olc00?o0000oooooolcoc<0
2?lcoc<00ol0003ooooooc?o<`08oc?o<`03o`000?oooooo<omV00So<omV00?o0000oooooolcoiT0
2?lcoiT00ol0003ooooooc?oc008oc?oc003o`000?oooooo<ooo00So<ooo00?o0000ooooool00000
2_o^k^h00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?00
2?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000
Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@1]onKViP03
o`000?oooooo<ooo00So<ooo00?o0000oooooolcc?l02?lcc?l00ol0003ooooooc>Io`08oc>Io`03
o`000?oooooo<fKo00So<fKo00?o0000oooooolc<ol02?lc<ol00ol0003ooooooc<co`08oc<co`03
o`000?oooooo<c?o00So<c?o00?o0000oooooomV<ol02?mV<ol00ol0003ooooooiTco`08oiTco`03
o`000?ooooooc3?o00Soc3?o00?o0000oooooooo<ol02?oo<ol00ol0003ooooooolcc008oolcc003
o`000?oooooooc>I00Sooc>I00?o0000oooooooo<fH02?oo<fH00ol0003ooooooolc<`08oolc<`03
o`000?oooooooc<c00Sooc<c00?o0000oooooooo<c<02?oo<c<00ol0003ooooooomV<`08oomV<`03
o`000?oooooooiTc00SooiTc00?o0000ooooooooc3<02?ooc3<00ol0003ooooooooo<`08oooo<`03
o`000?ooooooc?lc00Soc?lc00?o0000oooooonIm3<02?nIm3<00ol0003oooooofKo<`08ofKo<`03
o`000?oooooo<olc00So<olc00?o0000oooooolcoc<02?lcoc<00ol0003ooooooc?o<`08oc?o<`03
o`000?oooooo<omV00So<omV00?o0000oooooolcoiT02?lcoiT00ol0003ooooooc?oc008oc?oc003
o`000?oooooo<ooo00So<ooo00?o0000ooooool000002_oVi^H00ol0003ooooooo3`l008oo3`l003
o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003
o`000?ooooool?3`00Sol?3`00?o0000ooooool00000KooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[J
fP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo<ooo00So<ooo00?o0000oooo
oolcc?l02?lcc?l00ol0003ooooooc>Io`08oc>Io`03o`000?oooooo<fKo00So<fKo00?o0000oooo
oolc<ol02?lc<ol00ol0003ooooooc<co`08oc<co`03o`000?oooooo<c?o00So<c?o00?o0000oooo
oomV<ol02?mV<ol00ol0003ooooooiTco`08oiTco`03o`000?ooooooc3?o00Soc3?o00?o0000oooo
oooo<ol02?oo<ol00ol0003ooooooolcc008oolcc003o`000?oooooooc>I00Sooc>I00?o0000oooo
oooo<fH02?oo<fH00ol0003ooooooolc<`08oolc<`03o`000?oooooooc<c00Sooc<c00?o0000oooo
oooo<c<02?oo<c<00ol0003ooooooomV<`08oomV<`03o`000?oooooooiTc00SooiTc00?o0000oooo
ooooc3<02?ooc3<00ol0003ooooooooo<`08oooo<`03o`000?ooooooc?lc00Soc?lc00?o0000oooo
oonIm3<02?nIm3<00ol0003oooooofKo<`08ofKo<`03o`000?oooooo<olc00So<olc00?o0000oooo
oolcoc<02?lcoc<00ol0003ooooooc?o<`08oc?o<`03o`000?oooooo<omV00So<omV00?o0000oooo
oolcoiT02?lcoiT00ol0003ooooooc?oc008oc?oc003o`000?oooooo<ooo00So<ooo00?o0000oooo
ool000002_o^k^h00ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000oooo
ooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000oooo
ool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`1]
ooooo`03o`000?oooooo<ooo00So<ooo00?o0000oooooolcc?l02?lcc?l00ol0003ooooooc>Io`08
oc>Io`03o`000?oooooo<fKo00So<fKo00?o0000oooooolc<ol02?lc<ol00ol0003ooooooc<co`08
oc<co`03o`000?oooooo<c?o00So<c?o00?o0000oooooomV<ol02?mV<ol00ol0003ooooooiTco`08
oiTco`03o`000?ooooooc3?o00Soc3?o00?o0000oooooooo<ol02?oo<ol00ol0003ooooooolcc008
oolcc003o`000?oooooooc>I00Sooc>I00?o0000oooooooo<fH02?oo<fH00ol0003ooooooolc<`08
oolc<`03o`000?oooooooc<c00Sooc<c00?o0000oooooooo<c<02?oo<c<00ol0003ooooooomV<`08
oomV<`03o`000?oooooooiTc00SooiTc00?o0000ooooooooc3<02?ooc3<00ol0003ooooooooo<`08
oooo<`03o`000?ooooooc?lc00Soc?lc00?o0000oooooonIm3<02?nIm3<00ol0003oooooofKo<`08
ofKo<`03o`000?oooooo<olc00So<olc00?o0000oooooolcoc<02?lcoc<00ol0003ooooooc?o<`08
oc?o<`03o`000?oooooo<omV00So<omV00?o0000oooooolcoiT02?lcoiT00ol0003ooooooc?oc008
oc?oc003o`000?oooooo<ooo00So<ooo00?o0000ooooool000002_ooool00ol0003ooooooo3`l008
oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008
oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koooool01?n_[joobl_;omkNg_oZ
j^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo<ooo00So<ooo00?o
0000oooooolcc?l02?lcc?l00ol0003ooooooc>Io`08oc>Io`03o`000?oooooo<fKo00So<fKo00?o
0000oooooolc<ol02?lc<ol00ol0003ooooooc<co`08oc<co`03o`000?oooooo<c?o00So<c?o00?o
0000oooooomV<ol02?mV<ol00ol0003ooooooiTco`08oiTco`03o`000?ooooooc3?o00Soc3?o00?o
0000oooooooo<ol02?oo<ol00ol0003ooooooolcc008oolcc003o`000?oooooooc>I00Sooc>I00?o
0000oooooooo<fH02?oo<fH00ol0003ooooooolc<`08oolc<`03o`000?oooooooc<c00Sooc<c00?o
0000oooooooo<c<02?oo<c<00ol0003ooooooomV<`08oomV<`03o`000?oooooooiTc00SooiTc00?o
0000ooooooooc3<02?ooc3<00ol0003ooooooooo<`08oooo<`03o`000?ooooooc?lc00Soc?lc00?o
0000oooooonIm3<02?nIm3<00ol0003oooooofKo<`08ofKo<`03o`000?oooooo<olc00So<olc00?o
0000oooooolcoc<02?lcoc<00ol0003ooooooc?o<`08oc?o<`03o`000?oooooo<omV00So<omV00?o
0000oooooolcoiT02?lcoiT00ol0003ooooooc?oc008oc?oc003o`000?oooooo<ooo00So<ooo00?o
0000ooooool000002_o^k^h00ol0003oooooooooo`0fooooo`03o`000?o^k^kok^k^06gok^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0KOoVi^H00ol0003ooooo
oc?oo`08oc?oo`03o`000?oooooo<lco00So<lco00?o0000oooooolcVOl02?lcVOl00ol0003ooooo
oc=Vo`08oc=Vo`03o`000?oooooo<c?o00So<c?o00?o0000oooooolc<ol02?lc<ol00ol0003ooooo
oc<co`08oc<co`03o`000?ooooooIS?o00SoIS?o00?o0000oooooonI<ol02?nI<ol00ol0003ooooo
ol`co`08ol`co`03o`000?oooooooc?o00Sooc?o00?o0000oooooooo<l`02?oo<l`00ol0003ooooo
oolcV@08oolcV@03o`000?oooooooc=V00Sooc=V00?o0000oooooooo<c<02?oo<c<00ol0003ooooo
oolc<`08oolc<`03o`000?oooooooc<c00Sooc<c00?o0000ooooooooIS<02?ooIS<00ol0003ooooo
oonI<`08oonI<`03o`000?oooooool`c00Sool`c00?o0000oooooooooc<02?oooc<00ol0003ooooo
olco<`08olco<`03o`000?ooooooVO@c00SoVO@c00?o0000oooooomVoc<02?mVoc<00ol0003ooooo
oc?o<`08oc?o<`03o`000?oooooo<olc00So<olc00?o0000oooooolcoc<02?lcoc<00ol0003ooooo
oc?oIP08oc?oIP03o`000?oooooo<onI00So<onI00?o0000oooooolcol`02?lcol`00ol0003ooooo
oc?oo`08oc?oo`03o`000?oooooo000000[oi^KV00?o0000ooooool000002Ol000000ooooooo0000
o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000
o`000008o`000003ooooool0003oi^KV06koi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7Q
hOoJf][oclo?okfm_OnSXj<0KOo^k^h00ol0003oooooooooo`3ooooooeGooooo00?o0000onk^k_o^
k^h02?o^k^h00ol0003ooooool`0c008ol`0c003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`
l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool0
0000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`1]oooo
o`03o`000?oooooo000000Wo000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?ooool02Oooool00ol0003ooooool`0c008ol`0
c003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`
l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koooool01?n_[joobl_;omkNg_oZj^X1
oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?ooooooI_oo00SoI_oo00?o0000
oooooomVc?l02?mVc?l00ol0003oooooofJIo`08ofJIo`03o`000?ooooooIVKo00SoIVKo00?o0000
oooooomVI_l02?mVI_l00ol0003oooooofIVo`08ofIVo`03o`000?ooooooIVKo00SoIVKo00?o0000
oooooomVI_l02?mVI_l00ol0003ooooooiUVo`08oiUVo`03o`000?ooooooc6Ko00Soc6Ko00?o0000
ooooooooI_l02?ooI_l00ol0003ooooooomVc008oomVc003o`000?ooooooofJI00SoofJI00?o0000
ooooooooIVH02?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?ooooooofIV00SoofIV00?o0000
ooooooooIVH02?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?oooooooiUV00SooiUV00?o0000
ooooooooc6H02?ooc6H00ol0003oooooooooIP08ooooIP03o`000?ooooooc?mV00Soc?mV00?o0000
oooooonIofH02?nIofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000
oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000
oooooomVoiT02?mVoiT00ol0003oooooofKoc008ofKoc003o`000?ooooooI_oo00SoI_oo00?o0000
ooooool000002_o^k^h00ol0003ooooool`0c008ol`0c003o`000?ooooool?3`00Sol?3`00?o0000
ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000
ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifM
W@1]onKViP03o`000?ooooooI_oo00SoI_oo00?o0000oooooomVc?l02?mVc?l00ol0003oooooofJI
o`08ofJIo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooomVI_l02?mVI_l00ol0003oooooofIV
o`08ofIVo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooomVI_l02?mVI_l00ol0003ooooooiUV
o`08oiUVo`03o`000?ooooooc6Ko00Soc6Ko00?o0000ooooooooI_l02?ooI_l00ol0003ooooooomV
c008oomVc003o`000?ooooooofJI00SoofJI00?o0000ooooooooIVH02?ooIVH00ol0003ooooooomV
IP08oomVIP03o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003ooooooomV
IP08oomVIP03o`000?oooooooiUV00SooiUV00?o0000ooooooooc6H02?ooc6H00ol0003ooooooooo
IP08ooooIP03o`000?ooooooc?mV00Soc?mV00?o0000oooooonIofH02?nIofH00ol0003oooooofKo
IP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000oooooomVofH02?mVofH00ol0003oooooofKo
IP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000oooooomVoiT02?mVoiT00ol0003oooooofKo
c008ofKoc003o`000?ooooooI_oo00SoI_oo00?o0000ooooool000002_oVi^H00ol0003ooooool`0
c008ol`0c003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`
l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000KooVi^H01?nMWIgo]kNgolS8
b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?ooooooI_oo00SoI_oo
00?o0000oooooomVc?l02?mVc?l00ol0003oooooofJIo`08ofJIo`03o`000?ooooooIVKo00SoIVKo
00?o0000oooooomVI_l02?mVI_l00ol0003oooooofIVo`08ofIVo`03o`000?ooooooIVKo00SoIVKo
00?o0000oooooomVI_l02?mVI_l00ol0003ooooooiUVo`08oiUVo`03o`000?ooooooc6Ko00Soc6Ko
00?o0000ooooooooI_l02?ooI_l00ol0003ooooooomVc008oomVc003o`000?ooooooofJI00SoofJI
00?o0000ooooooooIVH02?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?ooooooofIV00SoofIV
00?o0000ooooooooIVH02?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?oooooooiUV00SooiUV
00?o0000ooooooooc6H02?ooc6H00ol0003oooooooooIP08ooooIP03o`000?ooooooc?mV00Soc?mV
00?o0000oooooonIofH02?nIofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV
00?o0000oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV
00?o0000oooooomVoiT02?mVoiT00ol0003oooooofKoc008ofKoc003o`000?ooooooI_oo00SoI_oo
00?o0000ooooool000002_o^k^h00ol0003ooooool`0c008ol`0c003o`000?ooooool?3`00Sol?3`
00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`
00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]ko
bl_;ojn_[`1]ooooo`03o`000?ooooooI_oo00SoI_oo00?o0000oooooomVc?l02?mVc?l00ol0003o
ooooofJIo`08ofJIo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooomVI_l02?mVI_l00ol0003o
ooooofIVo`08ofIVo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooomVI_l02?mVI_l00ol0003o
oooooiUVo`08oiUVo`03o`000?ooooooc6Ko00Soc6Ko00?o0000ooooooooI_l02?ooI_l00ol0003o
oooooomVc008oomVc003o`000?ooooooofJI00SoofJI00?o0000ooooooooIVH02?ooIVH00ol0003o
oooooomVIP08oomVIP03o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003o
oooooomVIP08oomVIP03o`000?oooooooiUV00SooiUV00?o0000ooooooooc6H02?ooc6H00ol0003o
ooooooooIP08ooooIP03o`000?ooooooc?mV00Soc?mV00?o0000oooooonIofH02?nIofH00ol0003o
ooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000oooooomVofH02?mVofH00ol0003o
ooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000oooooomVoiT02?mVoiT00ol0003o
ooooofKoc008ofKoc003o`000?ooooooI_oo00SoI_oo00?o0000ooooool000002_ooool00ol0003o
oooool`0c008ol`0c003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003o
oooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000Koooool01?n_[joo
bl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?ooooooI_oo
00SoI_oo00?o0000oooooomVc?l02?mVc?l00ol0003oooooofJIo`08ofJIo`03o`000?ooooooIVKo
00SoIVKo00?o0000oooooomVI_l02?mVI_l00ol0003oooooofIVo`08ofIVo`03o`000?ooooooIVKo
00SoIVKo00?o0000oooooomVI_l02?mVI_l00ol0003ooooooiUVo`08oiUVo`03o`000?ooooooc6Ko
00Soc6Ko00?o0000ooooooooI_l02?ooI_l00ol0003ooooooomVc008oomVc003o`000?ooooooofJI
00SoofJI00?o0000ooooooooIVH02?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?ooooooofIV
00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?oooooooiUV
00SooiUV00?o0000ooooooooc6H02?ooc6H00ol0003oooooooooIP08ooooIP03o`000?ooooooc?mV
00Soc?mV00?o0000oooooonIofH02?nIofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV
00SoI_mV00?o0000oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV
00SoI_mV00?o0000oooooomVoiT02?mVoiT00ol0003oooooofKoc008ofKoc003o`000?ooooooI_oo
00SoI_oo00?o0000ooooool000002_o^k^h00ol0003ooooool`0c008ol`0c003o`000?ooooool?3`
00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`
00Sol?3`00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?C
doo8b<So]kNgoifMW@1]onKViP03o`000?ooooooI_oo00SoI_oo00?o0000oooooomVc?l02?mVc?l0
0ol0003oooooofJIo`08ofJIo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooomVI_l02?mVI_l0
0ol0003oooooofIVo`08ofIVo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooomVI_l02?mVI_l0
0ol0003ooooooiUVo`08oiUVo`03o`000?ooooooc6Ko00Soc6Ko00?o0000ooooooooI_l02?ooI_l0
0ol0003ooooooomVc008oomVc003o`000?ooooooofJI00SoofJI00?o0000ooooooooIVH02?ooIVH0
0ol0003ooooooomVIP08oomVIP03o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH0
0ol0003ooooooomVIP08oomVIP03o`000?oooooooiUV00SooiUV00?o0000ooooooooc6H02?ooc6H0
0ol0003oooooooooIP08ooooIP03o`000?ooooooc?mV00Soc?mV00?o0000oooooonIofH02?nIofH0
0ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000oooooomVofH02?mVofH0
0ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000oooooomVoiT02?mVoiT0
0ol0003oooooofKoc008ofKoc003o`000?ooooooI_oo00SoI_oo00?o0000ooooool000002_oVi^H0
0ol0003ooooool`0c008ol`0c003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?00
0ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooool00000KooVi^H0
1?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oo
ooooI_oo00SoI_oo00?o0000oooooomVc?l02?mVc?l00ol0003oooooofJIo`08ofJIo`03o`000?oo
ooooIVKo00SoIVKo00?o0000oooooomVI_l02?mVI_l00ol0003oooooofIVo`08ofIVo`03o`000?oo
ooooIVKo00SoIVKo00?o0000oooooomVI_l02?mVI_l00ol0003ooooooiUVo`08oiUVo`03o`000?oo
ooooc6Ko00Soc6Ko00?o0000ooooooooI_l02?ooI_l00ol0003ooooooomVc008oomVc003o`000?oo
ooooofJI00SoofJI00?o0000ooooooooIVH02?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?oo
ooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?oo
oooooiUV00SooiUV00?o0000ooooooooc6H02?ooc6H00ol0003oooooooooIP08ooooIP03o`000?oo
ooooc?mV00Soc?mV00?o0000oooooonIofH02?nIofH00ol0003oooooofKoIP08ofKoIP03o`000?oo
ooooI_mV00SoI_mV00?o0000oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKoIP03o`000?oo
ooooI_mV00SoI_mV00?o0000oooooomVoiT02?mVoiT00ol0003oooooofKoc008ofKoc003o`000?oo
ooooI_oo00SoI_oo00?o0000ooooool000002_o^k^h00ol0003ooooool`0c008ol`0c003o`000?oo
ooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oo
ooool?3`00Sol?3`00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Go
l_;bon[Zj_oNg]kobl_;ojn_[`1]ooooo`03o`000?ooooooI_oo00SoI_oo00?o0000oooooomVc?l0
2?mVc?l00ol0003oooooofJIo`08ofJIo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooomVI_l0
2?mVI_l00ol0003oooooofIVo`08ofIVo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooomVI_l0
2?mVI_l00ol0003ooooooiUVo`08oiUVo`03o`000?ooooooc6Ko00Soc6Ko00?o0000ooooooooI_l0
2?ooI_l00ol0003ooooooomVc008oomVc003o`000?ooooooofJI00SoofJI00?o0000ooooooooIVH0
2?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH0
2?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?oooooooiUV00SooiUV00?o0000ooooooooc6H0
2?ooc6H00ol0003oooooooooIP08ooooIP03o`000?ooooooc?mV00Soc?mV00?o0000oooooonIofH0
2?nIofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000oooooomVofH0
2?mVofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000oooooomVoiT0
2?mVoiT00ol0003oooooofKoc008ofKoc003o`000?ooooooI_oo00SoI_oo00?o0000ooooool00000
2_ooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo06gooooo00Co[jn_ol_;booNg]ko
j^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0KOo^k^h00ol0003oooooofKoo`08ofKoo`03
o`000?ooooooI/co00SoI/co00?o0000oooooomVVOl02?mVVOl00ol0003oooooofIVo`08ofIVo`03
o`000?ooooooIVKo00SoIVKo00?o0000oooooomVI_l02?mVI_l00ol0003oooooofIVo`08ofIVo`03
o`000?ooooooIVKo00SoIVKo00?o0000oooooonII_l02?nII_l00ol0003oooooolaVo`08olaVo`03
o`000?ooooooofKo00SoofKo00?o0000ooooooooI/`02?ooI/`00ol0003ooooooomVV@08oomVV@03
o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003ooooooomVIP08oomVIP03
o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003ooooooonIIP08oonIIP03
o`000?ooooooolaV00SoolaV00?o0000ooooooooofH02?ooofH00ol0003oooooolcoIP08olcoIP03
o`000?ooooooVOmV00SoVOmV00?o0000oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKoIP03
o`000?ooooooI_mV00SoI_mV00?o0000oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKoIP03
o`000?ooooooI_nI00SoI_nI00?o0000oooooomVol`02?mVol`00ol0003oooooofKoo`08ofKoo`03
o`000?oooooo000000[ok^k^00?o0000ooooool000002Ol000000ooooooo0000o`000008o`000003
ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003
ooooool0003ok^k^06kok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg
]onMWId0KOoVi^H00ol0003oooooooooo`3ooooooeGooooo00?o0000onKVi_oVi^H02?oVi^H00ol0
003ooooooiVIo`08oiVIo`03o`000?ooooooc6Ko00Soc6Ko00?o0000ooooooooI_l02?ooI_l00ol0
003ooooooiUVo`08oiUVo`03o`000?ooooooV@3o00SoV@3o00?o0000ooooool00000KooVi^H01?nM
WIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo
000000Wo000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?o^k^h02Oo^k^h00ol0003ooooooiVIo`08oiVIo`03o`000?oooooo
c6Ko00Soc6Ko00?o0000ooooooooI_l02?ooI_l00ol0003ooooooiUVo`08oiUVo`03o`000?oooooo
V@3o00SoV@3o00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;b
on[Zj_oNg]kobl_;ojn_[`1]ooooo`03o`000?ooooooVOoo00SoVOoo00?o0000oooooonIc?l02?nI
c?l00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nI
VOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nI
VOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooc9Wo00Soc9Wo00?o0000ooooooooVOl02?oo
VOl00ol0003ooooooonIc008oonIc003o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?oo
VIT00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?oo
VIT00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000ooooooooc9T02?oo
c9T00ol0003oooooooooV@08ooooV@03o`000?ooooooc?nI00Soc?nI00?o0000oooooonIoiT02?nI
oiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nI
oiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nI
oiT00ol0003ooooooiWoc008oiWoc003o`000?ooooooVOoo00SoVOoo00?o0000ooooool000002_oo
ool00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooc6Ko00Soc6Ko00?o0000ooooooooI_l02?oo
I_l00ol0003ooooooiUVo`08oiUVo`03o`000?ooooooV@3o00SoV@3o00?o0000ooooool00000Kooo
ool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`00
0?ooooooVOoo00SoVOoo00?o0000oooooonIc?l02?nIc?l00ol0003ooooooiVIo`08oiVIo`03o`00
0?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`00
0?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`00
0?ooooooc9Wo00Soc9Wo00?o0000ooooooooVOl02?ooVOl00ol0003ooooooonIc008oonIc003o`00
0?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`00
0?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`00
0?oooooooiVI00SooiVI00?o0000ooooooooc9T02?ooc9T00ol0003oooooooooV@08ooooV@03o`00
0?ooooooc?nI00Soc?nI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`00
0?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`00
0?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoc008oiWoc003o`00
0?ooooooVOoo00SoVOoo00?o0000ooooool000002_o^k^h00ol0003ooooooiVIo`08oiVIo`03o`00
0?ooooooc6Ko00Soc6Ko00?o0000ooooooooI_l02?ooI_l00ol0003ooooooiUVo`08oiUVo`03o`00
0?ooooooV@3o00SoV@3o00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00
00Gof][Jom?Cdoo8b<So]kNgoifMW@1]onKViP03o`000?ooooooVOoo00SoVOoo00?o0000oooooonI
c?l02?nIc?l00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonI
VOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonI
VOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooc9Wo00Soc9Wo00?o0000oooooooo
VOl02?ooVOl00ol0003ooooooonIc008oonIc003o`000?oooooooiVI00SooiVI00?o0000oooooooo
VIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000oooooooo
VIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000oooooooo
c9T02?ooc9T00ol0003oooooooooV@08ooooV@03o`000?ooooooc?nI00Soc?nI00?o0000oooooonI
oiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonI
oiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonI
oiT02?nIoiT00ol0003ooooooiWoc008oiWoc003o`000?ooooooVOoo00SoVOoo00?o0000ooooool0
00002_oVi^H00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooc6Ko00Soc6Ko00?o0000oooooooo
I_l02?ooI_l00ol0003ooooooiUVo`08oiUVo`03o`000?ooooooV@3o00SoV@3o00?o0000ooooool0
0000KooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^
kP03o`000?ooooooVOoo00SoVOoo00?o0000oooooonIc?l02?nIc?l00ol0003ooooooiVIo`08oiVI
o`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVI
o`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVI
o`03o`000?ooooooc9Wo00Soc9Wo00?o0000ooooooooVOl02?ooVOl00ol0003ooooooonIc008oonI
c003o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonI
V@03o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonI
V@03o`000?oooooooiVI00SooiVI00?o0000ooooooooc9T02?ooc9T00ol0003oooooooooV@08oooo
V@03o`000?ooooooc?nI00Soc?nI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWo
V@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWo
V@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoc008oiWo
c003o`000?ooooooVOoo00SoVOoo00?o0000ooooool000002_o^k^h00ol0003ooooooiVIo`08oiVI
o`03o`000?ooooooc6Ko00Soc6Ko00?o0000ooooooooI_l02?ooI_l00ol0003ooooooiUVo`08oiUV
o`03o`000?ooooooV@3o00SoV@3o00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`1]ooooo`03o`000?ooooooVOoo00SoVOoo00?o0000
oooooonIc?l02?nIc?l00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000
oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000
oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooc9Wo00Soc9Wo00?o0000
ooooooooVOl02?ooVOl00ol0003ooooooonIc008oonIc003o`000?oooooooiVI00SooiVI00?o0000
ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000
ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000
ooooooooc9T02?ooc9T00ol0003oooooooooV@08ooooV@03o`000?ooooooc?nI00Soc?nI00?o0000
oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000
oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000
oooooonIoiT02?nIoiT00ol0003ooooooiWoc008oiWoc003o`000?ooooooVOoo00SoVOoo00?o0000
ooooool000002_ooool00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooc6Ko00Soc6Ko00?o0000
ooooooooI_l02?ooI_l00ol0003ooooooiUVo`08oiUVo`03o`000?ooooooV@3o00SoV@3o00?o0000
ooooool00000Koooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>S
X`1]onk^kP03o`000?ooooooVOoo00SoVOoo00?o0000oooooonIc?l02?nIc?l00ol0003ooooooiVI
o`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVI
o`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVI
o`08oiVIo`03o`000?ooooooc9Wo00Soc9Wo00?o0000ooooooooVOl02?ooVOl00ol0003ooooooonI
c008oonIc003o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonI
V@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonI
V@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000ooooooooc9T02?ooc9T00ol0003ooooooooo
V@08ooooV@03o`000?ooooooc?nI00Soc?nI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWo
V@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWo
V@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWo
c008oiWoc003o`000?ooooooVOoo00SoVOoo00?o0000ooooool000002_o^k^h00ol0003ooooooiVI
o`08oiVIo`03o`000?ooooooc6Ko00Soc6Ko00?o0000ooooooooI_l02?ooI_l00ol0003ooooooiUV
o`08oiUVo`03o`000?ooooooV@3o00SoV@3o00?o0000ooooool00000Koo^k^h01?nSXj?o_Kfmolo?
cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@1]onKViP03o`000?ooooooVOoo00SoVOoo
00?o0000oooooonIc?l02?nIc?l00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo
00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo
00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooc9Wo00Soc9Wo
00?o0000ooooooooVOl02?ooVOl00ol0003ooooooonIc008oonIc003o`000?oooooooiVI00SooiVI
00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI
00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI
00?o0000ooooooooc9T02?ooc9T00ol0003oooooooooV@08ooooV@03o`000?ooooooc?nI00Soc?nI
00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI
00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI
00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoc008oiWoc003o`000?ooooooVOoo00SoVOoo
00?o0000ooooool000002_oVi^H00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooc6Ko00Soc6Ko
00?o0000ooooooooI_l02?ooI_l00ol0003ooooooiUVo`08oiUVo`03o`000?ooooooV@3o00SoV@3o
00?o0000ooooool00000KooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo
_Kfmoj>SX`1]onk^kP03o`000?ooooooVOoo00SoVOoo00?o0000oooooonIc?l02?nIc?l00ol0003o
oooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003o
oooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003o
oooooiVIo`08oiVIo`03o`000?ooooooc9Wo00Soc9Wo00?o0000ooooooooVOl02?ooVOl00ol0003o
oooooonIc008oonIc003o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003o
oooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003o
oooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000ooooooooc9T02?ooc9T00ol0003o
ooooooooV@08ooooV@03o`000?ooooooc?nI00Soc?nI00?o0000oooooonIoiT02?nIoiT00ol0003o
oooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003o
oooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003o
oooooiWoc008oiWoc003o`000?ooooooVOoo00SoVOoo00?o0000ooooool000002_o^k^h00ol0003o
ooooooooo`0fooooo`03o`000?o^k^kok^k^06gok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005
oo;bl_oZj^[og]kNol_;bon_[jl0KOooool00ol0003ooooooiWoo`08oiWoo`03o`000?ooooooVLco
00SoVLco00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo
00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo
00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003oooooolbIo`08olbIo`03o`000?oooooooiWo
00SooiWo00?o0000ooooooooVL`02?ooVL`00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI
00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI
00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?ooooooolbI
00SoolbI00?o0000oooooooooiT02?oooiT00ol0003oooooolcoV@08olcoV@03o`000?ooooooVOnI
00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI
00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI
00SoVOnI00?o0000oooooonIol`02?nIol`00ol0003ooooooiWoo`08oiWoo`03o`000?oooooo0000
00[ooooo>_l0001_ooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_Kgo
Xj>S06gok^k^00?o0000ooooooooool0oooooomEooooo`03o`000?o^k^kok^k^0;7ok^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0KOoVi^H00ol0003oooooo`00
0009o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`00
0008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`00
0008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`00
0008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`00
0008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`00
0008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`00
0008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`00
0008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`00
0008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`00
0008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`00
0008o`000003ooooool0003oi^KV0;;oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJ
f][oclo?okfm_OnSXj<0KOo^k^h00ol0003oooooolcoo`08olcoo`03o`000?ooooooc<co00Soc<co
00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co
00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co
00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooolco00Soolco
00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<
00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<
00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<
00?o0000oooooooool`02?oool`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<
00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<
00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<
00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoo`08olcoo`03o`000?oooooo000001Gok^k^
00?ohn?SomSHf?o^k^h01?o^k^h00ooMgMgogmoOonk^kP04onk^kP03on?ShooHf=Sok^k^00cok^k^
00?oeMGEonc/k?o^k^h0O_o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]ko
bl_;ojn_[`1]ooooo`03o`000?ooooooc?oo00Soc?oo00?o0000ooooooo<c?l02?o<c?l00ol0003o
ooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003o
ooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003o
ooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooooc?l02?ooc?l00ol0003o
ooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003o
ooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003o
ooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003o
ooooooooc008ooooc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003o
ooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003o
ooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003o
ooooolcoc008olcoc003o`000?ooooooc?oo00Soc?oo00?o0000ooooool000002oooool07olf=SKo
MgMgoooooooooooom_KfobHV9_m6ATKoo_knonOWiom:BT[o0`<3ob<S8olG5aOo`L71oooooooUiNGo
@410o`000?lB4Q;o7AdMooShn?ooooooinOWodY:B_l30`?o8b<SoaLG5oo1`L7ooooood10@?moOgl0
0_ooool02onSXj?o71`Loooooooooooodm?CobDU9OlN7Qko^[Zjoooooom]KFgoDU9B07cooooo00Co
[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0KOo^k^h00ol0003ooooo
olcoo`08olcoo`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003ooooo
olc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003ooooo
olc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003ooooo
olc<o`08olc<o`03o`000?ooooooolco00Soolco00?o0000ooooooooc<`02?ooc<`00ol0003ooooo
ooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003ooooo
ooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003ooooo
ooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000oooooooool`02?oool`00ol0003ooooo
olcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003ooooo
olcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003ooooo
olcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003ooooo
olcoo`08olcoo`03o`000?oooooo000000_ok^k^01oo<S8bofm_Koo^k^kok^k^ofQXJ?lB4Q;oemOG
onk^k_lo?coo>c/kom3@d?o^k^koh^;Ron7QhOo^k^ko?CdmobTY:Onm_Kgok^k^olW9bOo/k>cok^k^
oclo?olk>c_od=3@onk^k_oRh^;ohN7Qonk^k_lk>c_oMWIf00;ok^k^00OoV9RHoaXJ6_o^k^kok^k^
ofUYJOll?3cokNg]00;ok^k^00?oc<c<olG5aOo^k^h0Noo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Q
h@0000Gof][Jom?Cdoo8b<So]kNgoifMW@1]onKViP03o`000?ooooooc?oo00Soc?oo00?o0000oooo
ooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000oooo
ooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000oooo
ooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000oooo
ooooc?l02?ooc?l00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000oooo
ooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000oooo
ooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000oooo
ooooc<`02?ooc<`00ol0003oooooooooc008ooooc003o`000?ooooooc?o<00Soc?o<00?o0000oooo
ooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000oooo
ooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000oooo
ooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?oo00Soc?oo00?o0000oooo
ool000002ooVi^H02_l`<33oJf][onKVi_n^[Zko0@41oinOWooVi^KoalO7o`000?nUYJD4onKViP03
olK6a_l0003oQXJ600Coi^KV00?oalO7o`000?nUYJD01OoVi^H01_li>CWoLW9bonKVi_oVi^KoTi>C
oaTI6@;oi^KV00?oADE5ofIVI_oVi^H0P?oVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Q
om[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?ooooooc?oo00Soc?oo00?o0000ooooooo<c?l02?o<
c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<
c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<
c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooooc?l02?oo
c?l00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?oo
c<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?oo
c<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?oo
c<`00ol0003oooooooooc008ooooc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<
ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<
ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<
ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?oo00Soc?oo00?o0000ooooool000002oo^
k^h01Olb<S;oK6a/omoOgolP823oHF5Q00;ok^k^00?o/K6ao`000?lh>3P00olj>SX01?nf][Ko/K6a
o`000?o0`<04onk^kP03ok6a/Ol0003o>3Ph00?o>SXj00Co][Jfonk^k_lk>c_oMWIf0_o^k^h01_nH
V9So6QXJonk^k_o^k^koAdM7ofYZJX7ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZ
j^[og]kNol_;bon_[jl0KOooool00ol0003oooooolcoo`08olcoo`03o`000?ooooooc<co00Soc<co
00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co
00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co
00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooolco00Soolco
00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<
00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<
00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<
00?o0000oooooooool`02?oool`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<
00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<
00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<
00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoo`08olcoo`03o`000?oooooo000000_ooooo
00Go=SHfo`<30ol0003o0000ol71`@02ooooo`0:om_Kfol0003oZj^[olo?coo7alOo0`<3onGUiOoK
fm_o0000oi6AT@Cooooo00[ofm_Ko`000?n[Zj_oclo?olO7aol30`?oiNGUoooooom0@43oGEeM0_oo
ool01_nMWIgo7AdMooooooooooooCDe=og9bLX7ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005
on7QhOoJf][oclo?okfm_OnSXj<0KOo^k^h00ol0003oooooolcoo`08olcoo`03o`000?ooooooc<co
00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co
00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co
00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooolco
00Soolco00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<
00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<
00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<
00Soolc<00?o0000oooooooool`02?oool`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<
00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<
00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<
00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoo`08olcoo`03o`000?oooooo0000
00_ok^k^00Ko<S8bofm_KooCdm?oShn?o`L71on/[:`2onk^kP05ocXj>_mSHf?oi^KVoi>CTolX:2P0
0_o^k^h01Olj>S[o92@Tok6a/Oo]kNgoclo?00;ok^k^00Go>SXjof=SHooVi^KoTi>CobPX:002onk^
kP0?oc/k>olB4Q;oKVi^olo?comADE7oAdM7onk^k_oXj>SoA4A4ofEUIOoShn?oj^[Zonk^k_nl_;co
/k>c07cok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0KOoV
i^H00ol0003oooooolcoo`08olcoo`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<
c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<
c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<
c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooolco00Soolco00?o0000ooooooooc<`02?oo
c<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?oo
c<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?oo
c<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000oooooooool`02?oo
ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<
ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<
ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<
ol`00ol0003oooooolcoo`08olcoo`03o`000?oooooo000000_oi^KV00Ko<30`of][JooVi^Koi^KV
od51@Om:BTX2onKViP05olo?com0@43o2`/;oaTI6OnUYJD00_oVi^H01OoAdM7oCTi>o`d=3Ol92@Wo
8R8R00;oi^KV00Goclo?od10@?l;2`_o6ATIojFUY@02onKViP0?od];BomnOWkoKFe]oa8B4_lY:BWo
/;2`onKVi_mbLW;o1`L7o`X:2_lH61SoW9bLonKVi_m`L73oFUYJ07coi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0KOo^k^h00ol0003oooooolcoo`08olcoo`03
o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03
o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03
o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03
o`000?ooooooolco00Soolco00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003
o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003
o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003
o`000?ooooooolc<00Soolc<00?o0000oooooooool`02?oool`00ol0003oooooolcoc008olcoc003
o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003
o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003
o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoo`08olcoo`03
o`000?oooooo000000_ok^k^00Ko<S8bofm_Koo^k^kok^k^oc4a<Om?Cdl4onk^kP03on_[joo^k^ko
k^k^00Gok^k^00?ojn_[onk^k_o^k^h00oo^k^h00oo[jn_ok^k^onk^kP05onk^kP03ong]kOo^k^ko
k^k^00;ok^k^00?oAdM7ofYZJ_o^k^h0P?o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;b
on[Zj_oNg]kobl_;ojn_[`1]ooooo`03o`000?oooooooooo0?ooooooEOooool00ol0003ooooooooo
o`09ooooo`06ocHf=_l_;booFUYJob<S8ol<30co`l?37oooool00ooPh>3og]kNooooo`20ooooo`04
ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S06gok^k^00?o0000oooo
ool000002Ol000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`00
0?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`00
0?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`00
0?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`00
0?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`00
0?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`00
0?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`00
0?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`00
0?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`00
0?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`00
0?l000002?l000000ooooooo0000onk^kP0:onk^kP05ojBTY?n?ShooShn?ojj^[_oXj>P0Xoo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@1]onKViP03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooool00000/ooVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000Go
hN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooool00000
/oo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`1]ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooool00000/oooool01?n_[joobl_;omkNg_oZj^X1oo;b
lP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ool00000/oo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@1]
onKViP03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooool00000/ooVi^H01?nMWIgo]kNgolS8b?oC
dm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooool00000/oo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;
ojn_[`1]ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooool00000/oooool01?n_[joobl_;
omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooool00000/oo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8
b<So]kNgoifMW@1]onKViP03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooool00000/ooVi^H01?nM
WIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1]onk^kP03o`000?oooooo
oooo0?ooooooEOooool00ol0003ok^k^onk^kP2aonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0000
1Oobl_;oj^[ZomkNg_o;bl_o[jn_06goooooool0001Io`000;?ooooo00Co[jn_ol_;booNg]koj^[Z
0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8
b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_
ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV
00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[o
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0oooooooooooo
og[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^ko
onk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooV
i^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0
ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_
[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm
_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8
okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][o
clo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZ
j^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7Q
hOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005
om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X0
0005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z
0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8
b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_
ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV
00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[o
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0oooooooooooo
og[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^ko
onk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooV
i^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0
ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_
[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm
_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8
okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][o
clo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZ
j^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7Q
hOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005
om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X0
0005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z
0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8
b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_
ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV
00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[o
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0oooooooooooo
og[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^ko
onk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooV
i^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0
ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_
[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm
_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8
okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][o
clo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZ
j^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7Q
hOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005
om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X0
0005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z
0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8
b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_
ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV
00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[o
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0oooooooooooo
og[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^ko
onk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooV
i^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0
ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_
[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm
_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8
okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][o
clo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZ
j^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7Q
hOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005
om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X0
0005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z
0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8
b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_
ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV
00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[o
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0oooooooooooo
og[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^ko
onk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooV
i^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0
ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_
[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm
_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8
okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][o
clo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZ
j^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7Q
hOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005
om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^KoonKViW[oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X0
0005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN400005oo;bl_oZj^[og]kNol_;bon_[jl0ooooooooooooog[ooooo00Co[jn_ol_;booNg]koj^[Z
0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^koonk^kW[ok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oomZJV[oofYZJW[oJVYZ00CoWIfMokNg]oo8
b<Sodm?C0OoJf]X0000:on7QhOoJf][oclo?okfm_OnSXj?o^>cook__oonllOoo^^kookW^o`?o^noo
00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01Onk
lOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonk
kooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonl
lOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonj
k_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^ooni
k_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03
ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo
00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01Onk
lOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonk
kooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonl
lOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonj
k_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^ooni
k_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03
ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo
00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01Onk
lOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonk
kooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonl
lOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonj
k_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^ooni
k_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03
ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo
00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01Onk
lOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonk
kooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonl
lOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonj
k_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^ooni
k_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03
ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo
00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01Onk
lOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonk
kooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonl
lOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonj
k_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^ooni
k_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03
ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo
00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01Onk
lOoo^noookcaoonjk_oo^Nko00;o^noo00Go^>cooj>SXonm_Kgoclo?om[JfP01on7Qh@0000Gol_;b
on[Zj_oNg]kobl_;ojn_[`02oi_>o`3ooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlco
oiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlko
oiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<ko
oi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oo
oiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/go
oic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oo
oi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgo
oic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[o
oiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlco
oiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlko
oiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<ko
oi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oo
oiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/go
oic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oo
oi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgo
oic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[o
oiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlco
oiO:oonIcOooW<oooi[=oonLcoooV<ko003ooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_oo
VlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcooo
V<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOoo
W<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcooo
V/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOoo
W<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_oo
VLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?oo
Ul[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_oo
UlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_oo
VlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcooo
V<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOoo
W<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcooo
V/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOoo
W<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_oo
VLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?oo
Ul[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_oo
UlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_oo
VlkooiO<oonGb_ooVLgooic?oonJcOooW<oo001loiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonL
coooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJ
cOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonL
coooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonI
cOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonG
b_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonG
c?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonK
c_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonH
c_ooVlkooiO<oonGb_ooVLgooic?oonJcOooVlkoojn_[oo;bl_og]kNon[ZjP7ol_;b00001ooQhN7o
f][Jolo?conm_KgoXj>Sog^ak?mi[^/00_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[
00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg
[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2
ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^
j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^Wo
NJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^
jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^co
NJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^
k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nko
NJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_
k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[o
NJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]
j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_o
MZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^
jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00Ko
N:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/0
1_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^
j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;o
Mjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[
0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi
[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkY
ogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi
[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/
ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi
[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^
ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi
[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZ
ogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf
[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[
ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh
[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06
ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[
00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg
[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2
ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^
j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^Wo
NJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^
jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^co
NJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^
k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nko
NJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/02?mh[^_oMZgZogV_
k_mk/NcoXj>Sokfm_Oo?cloof][J0OoQhN40003oom[Jf_oCdm?ob<S8okNg]onMWIgoEi;EokWCk_nh
dnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_ni
dnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonf
d^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nh
d^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nf
d>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonh
d^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkong
d^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkoni
dnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nh
dnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_ni
dnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonf
d^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nh
d^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nf
d>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonh
d^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkong
d^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkoni
dnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nh
dnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^003ookSCkonidnoo]m;_okSBk_nfd>ko^=;_okKB
k_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSB
konfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@
k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSB
k_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOB
konhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWC
kongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSC
konidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWC
k_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKB
k_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSB
konfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@
k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSB
k_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOB
konhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWC
kongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSC
konidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWC
k_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKB
k_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^0023okWCk_nhdnoo^M?_okOBkonhd^ko]]3^
okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^
okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_
okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_
okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_
okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^
okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^
okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_
okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^
oeNBeOnMWIgo]kNgolS8b?oCdm<00OoJf]X00008on7QhOoJf][oclo?okfm_OnSXj?o<7;0ojK6i_nS
`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KV
oj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nV
a^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCV
ojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnU
a>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?U
ojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT
`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KV
ojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nV
a^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CV
ojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nT
a>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06
ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV
00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nU
a>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2
ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H0AonQ`^GoW/?Zoj78k_nXc_3o[]G`ojkC
kon`do3o/=C`ojoCl?nae_3o[mC_ok3Dl?n`eO3o/=C_ok7El?n`e?3o[mC`ok7Fl?n_dnoo/=C`ok3E
l?n`e>oo/MG`ok3Dl?n_e?3o/MK`ojoCkon`e?3o/=G`ok3DkonaeO3o/=C`ojoDl?nae_3o[m?_ok3D
l?n`eO3o/=C_ok7El?n`e?3o[mC`ok7Fl?n_dnoo/=C`ok3El?n`e>oo/MG`ok3Dl?n_e?3o/MK`ojoC
kon`e?3o/=G`ok3DkonaeO3o/=C`ojoDl?nae_3o[m?_ok3Dl?n`eO3o/=C_ok7El?n`e?3o[mC`ok7F
l?n_dnoo/=C`ok3El?n`eNoo/=K`00;o/=G`00go/MO`ojoDl?n/d_3oZ<o`oj38kOnL`^[oX/;UojC4
i_nVa^KoY<?UojG4i_nVa^KoXl;T00;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06
ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV
00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nU
a>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2
ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2
i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^Ko
Xl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6
i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>Ko
Y/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4
i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGo
YLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3
iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^Ko
Y<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6
i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>Ko
Y/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4
i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00Ko
Y<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H0
1_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4
iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;o
YLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T
0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00OoY<CVojK6i_l`L/3oXj>Sokfm_Oo?
cloof][J007ohN7Q0000lOobl_;oj^[ZomkNg_o;bl_o[jn_o`mF/Ol;Djko3eJ_o`mE[ol;E;3o2eBa
o`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`
o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_
o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_
o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^
o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^
o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^
o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^
o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBa
o`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`
o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_
o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_
o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^
o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^
o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^
o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?mHYoooR/ko
oj_Tooo0lOoobO[oolknoooDool00_o?nol0ooo@o_ood_ooom3ooooBooood?ooom;oooo?oOood?oo
olokoooCooood?ooom;oooo@ooood_ooolomooo@ooooco_oom?oooo@ooood_ooom3ooooBoooocogo
om3oooo?nooodoooom3ooooBooood?ooom;oooo?oOood?ooolokoooCooood?ooom;oooo@ooood_oo
olomooo@ooooco_oom?oooo@ooood_ooom3ooooBoooocogoom3oooo?nooodoooom3ooooBooood?oo
om;oooo?oOood?ooolokoooCooood?ooom;ooooCoooocokoolkjooo?noood?ooolknooo8nOoo_o3o
ojgWoon;c_ooF:Ooo`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^
o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^
o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^
o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBa
o`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`
o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_
o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_
o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^
o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^
o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^
o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^
o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBa
o`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/000Sol;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo
2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo
3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko
3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko
2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko
3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko
2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o
3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o
2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo
2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l?E[7o[jn_ol_;booNg]ko
j^[Z007ol_;b00001OoQhN7of][Jolo?conm_KgoOWin0>;ob<S800coa/K6okVi^On:RX[oFJCnohc9
oonZg_oo^^_ool;aooo8loooc?Koolgfooo=n?l3oloio`05olgiooo>nOooc_Soolkhooo=m_l00_o?
n_l00oo?nOoocOWoolkio`02olkho`06olgfooo?n_ooco[ooloiooo=nOooc_Wo0_o>n?l01_o=m_oo
co[oolojooo?nOoocOWoolkio`;oc_So00KocOKoolojooo?n_oocoWoolgiooo>nOl2olkho`06olgf
ooo?n_ooco[ooloiooo=nOooc_Wo0_o>n?l01_o=m_ooco[oolojooo?nOoocOWoolkio`;oc_So01?o
cOKoolojooo?n_oocoWoolgiooo?n_ooc_Soolcfooo?nOooco[oolWeooo6m_oo^n_oojgQoon9b_go
DYO[oemOGooPh>3om?Cd02[ooooo00Gom_Kfolo?comOGeooh>3PooCdm00Zooooo`05ooShn?oPh>3o
RXZ:okVi^Oo6a/H0h_o8b<P01?nFUYKo_Kfmolo?cooJf]X1on7Qh@000ooVi^H00ooJf][oc/k>olk>
cP3Qolk>cP0=olc<c?nn_[koSXj>oeJPlOn7`oooY=KookGQoonoj_oo`n_oolK^ooo6koooa^koolK`
o`02ol?^o`18olO`ooo8lOooa_3ool?^ooo8lOooa^koolK`ooo3k_ooao3oolSaooo6l?oo`nkoolSa
ooo6k_ooa_3ool?^ooo7l?oob?7oolK`ooo3k_oob?7oolK^ooo6l?oo`nkoolO`ooo8lOooa_3ool?^
ooo8lOooa^koolK`ooo3k_ooao3oolSaooo6l?oo`nkoolSaooo6k_ooa_3ool?^ooo7l?oob?7oolK`
ooo3k_oob?7oolK^ooo6l?oo`nkoolO`ooo8lOooa_3ool?^ooo8lOooa^koolK`ooo3k_ooao3oolK`
ooo2j_oob?7oolO_ooo6kooo`^_ool3[oonhi?ooXmSoohO4oOm?U>3oHV9Rom[Jf_o_knoonOWi:?oo
ool01ooinOWok^k^ol[:b_mRHV;of][Jono_kooinOT0:?ooool01_oinOWol?3`om_Kfon>SXko_[jn
olc<c>;oc/k>00?of][JonKVi_oVi^H00_oVi^H000;ok^k^0_oVi^KSomoOg`0>omgMgOo>c/koVYZJ
oe6Kjon2_OgoW/oook7Loonhhooo_NGookgTooo0i_oo`^[ookgTooo1iol2ol3Vo`;o`NOo0_noiOl4
ol3Vo`;o`NOo0_noiOl4ol3Vo`;o`NOo0_noiOl4ol3Vo`;o`NOo0_noiOl4ol3Vo`;o`NOo0_noiOl4
ol3Vo`;o`NOo0_noiOl4ol3Vo`;o`NOo0_noiOl4ol3Vo`0Aol7Wooo0i_oo`>Kool7Yoonlhooo^nCo
okGPoon_foooWLkoogjimom:Sm[oJVYZomCDe?oYjNWolo?cooWinOomoOd00_ono_h9ooooo`03ookn
o_oooooooooo00Gooooo00?oo_knooooooooool01Oooool00oono_koooooooooo`04ooooo`0=ookn
o_omoOgon_[jooShn?obl_;oiNGUolC4a?mZJV[oe=CDonWYjOoclo?onOWioogmo@02ooknoPWooooo
00?oo_knooooooooool01Oooool00oono_koooooooooo`05ooooo`03ookno_oooooooooo00Cooooo
00[oo_knoogmoOojn_[on?Shoo;bl_oWinOoe=CDoiZJV_o>c/kogMgMh_oOgml2onKViP?ok^k^0000
1?oooooon_[joo[jn_ojn_[SooGem@0:oo?clooRh^;oZZZZoe:GiOmm]O?oV/[nojSDoondgooo^^7o
okSOo`;o_>?o00Oo^=oookWPoonkhOoo^^3ookWPoonmi?oo^N3o00;o^^3o00Ko]]cook_Qoonjh?oo
^N3ookgToonih?l2ok[Po`06okKLoonkhOoo^^3ookWPoonmi?oo^N3o0_njh?l01_nfg?oo^n7ook[P
oonih?oo_NCookWPo`;o^^3o00Ko]]cook_Qoonjh?oo^N3ookgToonih?l2ok[Po`06okKLoonkhOoo
^^3ookWPoonmi?oo^N3o0_njh?l01_nfg?oo^n7ook[Poonih?oo_NCookWPo`;o^^3o01Ko]]cook_Q
oonjh?oo_>?ook[Qoonhgooo^MoookSOoonfg_oo/M_ooj[EoonGbOgoOKCbodZ<eOmfMWKod=3@on3P
h?o_knoolO7aooWinOojn_[on?Sh0_olo?`00ooinOWon_[jooclo002ooWin@06oogmoOoinOWon_[j
ooWinOojn_[oo?cl0_oinOT01_omoOgonOWioo[jn_oinOWon_[jooclo0;onOWi00OooOgmooWinOoj
n_[onOWioo[jn_olo?conOWi00;on?Sh00oonOWiooOgmoohn?Som?Cdonk^k_oOgmoo`<30ogIfM_o@
d=3oh>3Pono_kooalO7onOWioo[jn_ohn?P00_olo?`00ooinOWon_[jooclo002ooWin@06oogmoOoi
nOWon_[jooWinOojn_[oo?cl0_oinOT01_omoOgonOWioo[jn_oinOWon_[jooclo0;onOWi00OooOgm
ooWinOojn_[onOWioo[jn_olo?conOWi00;on?Sh00[onOWiooOgmoohn?Som?Cdonk^k_oQhN7od=3@
ojZZZ_oRh^;olo?ch_oemOD3oo[jnP;ooooo0004on_[jn?oj>SX00Soi^KVomKFe_nQXJ7oC93NogVa
konCa?SoY<okojcEo`;o/][o03ko]=Wook?JoondfOoo/m[ookCKoonaf?goW;gLoj;3i_ndf_oo/m[o
okGLoonefooo]=_ook?Jooneg?oo]=WookCJooncf_oo]McookGKoondfooo/m[ookGLoonVb>co/]Sm
ok?Joon]d_Co[M7dokCKooncf_oo]Mcooj72iOnbf?go/m[ookGLoonefoooYl_]ojO<koneg?oo]=Wo
okCJooncf_oo]McookGKoondfooo/m[ookGLoondfOoo]=[ook?Jooneg?oo[M7doj?7j?ncf_oo]Mco
okCIoondf_ooZLkboj_@l_nefooo]=_ook?Jo`;o]M_o00oo/m[ookGKooncfooo[mSoojgHoonUd?go
U<ChogJ/jOm6QLgoKfm_olS8b?oMgMgoj^[Zonk^k_obl_800_oemOD00oodm?ComOGeooOgm`02ooKf
mP06ooGemOofm_Kom?CdooGemOodm?ComoOg0_ofm_H01_oemOGom_Kfoo;bl_oCdm?og=cLooOgm`;o
m_Kf00KomOGeooKfm_odm?ComOGeooCdm?ogmoL2ooKfmP;omOGe0_ofm_H03?oclo?om?Cdono_koo[
jn_ofMWIokVi^Om_Kfoob<S8omgMgOoZj^[ok^k^oo;blP;omOGe00?om?CdooGemOogmoL00_ofm_H0
1_oemOGom_KfooCdm?oemOGom?CdooOgm`;om_Kf00KomOGeooKfm_odm?Cofm_KolO7aoo/k>`2ooKf
mP06ooGemOofm_Kom?CdooGemOodm?ComoOg0_ofm_H2ooGem@;om_Kf00Wolo?cooCdm?o_knoojn_[
om_Kfoo8b<SoXJ6QomKFe_oVi^H0h_oXj>P4on_[j`7ok^k^003WonKViP0DonCTi?oDe=CoWinOodJ;
f?me[NWoS[oaoio9mOnUd?[o[=?jojkEoOn^e?_o/MKnojkDnonbf?ooNY>^o`H82Ol92`go61hSob@/
=OmdSJL2ojkDn`1Ioio0i?l0003oGW>8ok7Fo_n^e?_o<Se9oa/Q9on^e?_o/MGmojkDnolhA57o1@H7
oa4E6Om/Q9co30lBoc]8EOnaeOgoSjo?oaTO9OlD6AgoOYZgok;HoonL_^7o:cDno`000?l<3Q7o51PM
ojc@mon^e?_o;3I0oeIYOOn^e?_o/MGmofn7X?lC5aco/MKnojkDnonQ`nOo<Se8o`820_lH7B;o3a<F
ohJS`Onae_ko6AhTo`/=4?lE6Qoo=41;oj[=m?n^e?_o/]SoojoEoOn^e_ko[]CkojcCn_n[e?_oY]3j
oj3<n?n>_o7oLj[Uod>3b_m^KVkoaLG5omWIfOoVi^KojNWYong]kOo_knoolO7aono_koobl_;olO7a
ono_koo`l?3o<S8bofi^K_obl_;ol?3`oo;bl_oalO7o0P82oifMWOo`l?3oYjNWo`T92Ol<30co8R8R
oc<c<onLW9`00_o`l?001_lc<c?o0000o`000?l@413o@T92om;BdP;ol?3`02Sol_;boo3`l?o_knoo
l?3`ong]kOo[jn_oiNGUomOGeong]kOoKVi^olG5aOoIfMWoi^KVonWYjOo]kNgokno_oo7alOo_knoo
l_;boo7alOo_knool?3`oc8b<_m`L73ol_;boo3`l?oYjNWo8b<Sod51@Oo_knool?3`oiFEUOlB4Q;o
3Ph>obl_;olC4a?o7AdMokjn__o`l?3o<c<c0_l000000ol@413o@T92om;BdP02oo3`l00<oo;bl_o`
l?3okno_oo3`l?o]kNgojn_[onGUiOoIfMWoa/K6oinOWooDe=Coi>CTiooVi^H00>Ook^k^05Sok>c/
omcLg?nUYJGo@hWDog2Xhon;^ncoVlKaojC<mOnVc_GoZ<oeoj[?mOnZcoKoZ/oeoj_BnOn?[LgoOi^g
ojC:lOnZcoGoJH2Io`830onD]MKoYlgdofV0Uol:30ko9Bhfoj[?mOnVb_;o1PP9o`X<3_n:Z/[oZloe
ohBP__l20`?oTk?DoiZkh?lmBEOo2`d@ojO=m?n[coGoBe]/obXd?_nYc_CoZm3ioj_?m_l/=Coo72<Z
ohRT`onZcoGoSZo@ojS=lon[d?Wo:S<moeAWN_nWcOCoZloeofb4W?lB5Q_oZ/oeoj_@nOl]=d7o:S@m
oi:ceOn[coGoX/GYoio4jOnZcoGoP9bkojS;l_nYcoGo8b/cof5fS?nZcoGoZ/gdoj[@m_nZcoKoZ<gc
ojS>mOnUc??oX/ceoi_6lOn:^^_oKjGQocima?mbLW;o`/;2omGEeOoRh^;oi^KV0_oZj^X07Oo/k>co
jn_[on_[joo^k^kojn_[onc/k?la<C7oJVYZonc/k?o^k^kok>c/onk^k_l20P;oVYZJonc/k?o5aLGo
/;2`onWYjOo/k>coTY:Bo`<30oo=cLgok>c/oc4a<Om^KVkojNWYolG5aOlU9BGoDe=C00;ok>c/00ko
kNg]onWYjOo/k>coj>SXonWYjOoVi^KohN7Qom?Cdonb/[;oLW9bol;2`_oEeMGoh^;RonKViP;oj^[Z
01gok>c/on_[joo[jn_ok^k^on_[joo/k>co<C4aofe]KOo/k>cok^k^ofMWIolB4Q;oe=CDonc/k?n;
Rh_o0`<3ohR8R?o^k^kok>c/on3Ph?l0003o[:b/onc/k?la<C7oKVi^onWYjOo5aLGo9BDUoe=CD`02
onc/k00<ong]kOoYjNWok>c/onSXj?oYjNWoi^KVon7QhOoEeMGo`L71ojFUYOoLg=cok>c/ioo^k^h0
0>Oooooo00WooOgmonc/k?na/K7o?X;=ofVPf_n6]>KoUL7[oic4k_nRanh00_nSb>l07_nUb>ooYLW`
ojK:lOnWc??oYL[aojG9l?nTb>ooT;3Bo`000?meSZ[oYLW`ocM4DOm:Ffco4QHJoiFefOmiU;7o5ATN
odIFIomCIGWoYlccohb[cOl10P;oNIBaojC8komVO9Go51TMojG9l?nWc??o<Ca8odUIJ`;oY<S_00Ko
SJc>o`000?mPMHcoYlccojG:lOnUbO02ojC8k`0>obTb>omAHgOoYLW`ojO<lomYPI[o4QHJojC8kon>
[Loo0000ogJ@[?nUbO3oYlccojG:lOnUbO03ojC8k`07ogjJ^?l>4ACoH7F<ojG:lOnSb>ooYLccojG9
l002ojC9l00Eoj?8konMa^ooUL7[ohJeiomYXMco>WVoogYjN_nm_Kgoc/k>omcLg?oQhN7oi>CTonGU
iOoVi^KoiNGUonKVi_oXj>SoinOWonSXj?la<C7oJFUY00?oi^KV00Goj>SXo`820_nGUiOojNWYonOW
i`03onKViP06olc<c?l0003oYJFUonWYjOl`<33oJf][0_oVi^H01?mRHV;o9BDUonSXj?oYjNT3onOW
i`0MonKVi_oUiNGohN7QomgMgOo>c/ko[Zj^ogYjN_nm_Kgoc/k>omcLg?oQhN7oi>CTonGUiOoVi^Ko
iNGUonKVi_oXj>SoinOWonSXj?la<C7oJf][onKVi_n^[Zko0@41oj6QXOoWinOohN7Qoa8B4_mNGUh0
0ooVi^H01_oKfm_o0000ojVYZOoYjNWo<30`of][J`;oi^KV00CoHV9RobDU9OoXj>SojNWY0ooWinL0
2OoVi^KoiNGUon7QhOoMgMgod=3@okfm_Ona/K7ok>c/oogmo@3Wooooo`00ioo^k^h03?o/k>cog=cL
ojFUYOliOLWoI9gFogj_h?n@^^?oUl3Zoik3jonM`^_oX<K[oio4j`;oX<C[0_nRa>`03_nOa>_oUKSM
oc8mBOl41POoUk[Ooig0iol92`goN96^od1?GomPMXgoBea^ocm>G_mhTk7o728Y0_nRa>`03_m[Q9oo
7bH^ob0W;olQ:C7o51PMoj34jonRa>co<3]7odMGJOnOa>_oX/K/ogJA[ol0003oPIjm0_nRa>`2oio4
j`0<oj;6k?lW<3_oCf5eoj34jonRa>coIgfFoa4E6OnOa>_oN9>_o`000?lV;SSo9c0j0_lX<3X06_mj
U[CoWlC[oi2adol^>4Co0@82odIFJ?nL_N?oX/C/oj34jonOa>coX/C/oik3j_nPa^coWL;ZoiO0j_n>
^NCoPK7Tof>Je_lbL[[oLW9bokRh^?o;bl_oemOGom_KfooPh>3oh^;R1_oShn<00ol`<33oIfMWon?S
h`03on?Sh`03o`820_nDU9Cohn?S00?ohn?S00_oeMGEodI6A_l71`OoemOGon?Shol`<33oJFUYon?S
hoo;bl_o30`<og1`L003on?Sh`0?on;Rh_oShn?ohN7Qon3Ph?oKfm_ofMWIolW9bOnZZZ[oLW9bokRh
^?o;bl_oemOGom_KfooPh>3oh^;R00Kohn?S00Go<30`ofMWIooDe=Co7alOoeaLG002on?Sh`03okbl
_?l0003o[Jf]00?ohn?S00[oe]KFo`000?nUYJGohn?Soc0`<?mYJFWohn?Sol_;bol<30coL71`0ooS
hn<02ooRh^;ohn?Son7QhOoPh>3ofm_KomWIfOo;bl_o^;RhojFUYOoLg=cok>c/0>Ook^k^003WonKV
iP17onCTi?oDe=CoWinOoc=fa?mOU]?oNZSKohZeh?n@^^?oUkgUoiS0iOnK`NWoUkgToi[0ionK_nKo
V/3Voi_0iom/R:?o4ADIo`dA5?mbSj_oVl7WogJC[ol72@[oUk_Qofb8Xol]>4?o7B@/ofJ0VOnI_nGo
3A0Coh>Ta?nK`>OoV;oUoi_0i_nH_NCoFG25oa@H7OnK`NKoV/3VobhiAOm3EFKoVl3VoiZoi_n4YLGo
0000oeQ]P_nJ`>KoVl3WoiRoiOnK`>KoV[oVobH`>OlhAUCoVl7Voi[0i_mOMXko4ADJoi_0i_n4Y<Go
0000ofN1V_mmW;[oN9Fco`420_n8ZlgoVl3VobL`>_lW<C_oQJG6oi_1i_nJ`>H00_nK`>L04?nJ_NGo
Vl3Woi_1ionG_NGoV;gUoi>lion;^>?oO:cOoefCd?l`KkGoKVi^ok>c/oo8b<Sodm?ComWIfOoKfm/2
omkNgP07on7QhOoMgMgogmoOomkNg_oOgmoo;bl_ob/[:`04of5QH@0Bo`000?nBTY;oh>3PomkNg_oO
gmooWinOoaPH6?lD51CoYJFUomoOgooPh>3o;bl_ob/[:olg=cOo4a<CohF5QOoLg=cogmoO0ooPh>03
omkNgP0:om[Jf_oEeMGoa<C4ojNWYom^KVko/k>colS8b?oCdm?ofMWIom_Kf`;og]kN00OohN7QomgM
gOoOgmoog]kNomoOgol_;boo0P8200;o000000KoZ:RXomoOgooNg]koW9bLo`000?o4a<@4omoOg`0:
om7AdOoLg=coh>3Pobl_;ol[:b_o=cLgoa<C4on5QHGog=cLomoOg`?oh>3P0ooNg]h01ooJf][oeMGE
olK6a_ne]KGoWinOomCDe?oTi>@0iooVi^H00>Ook^k^05[ok>c/omcLg?nUYJGo;W;1oeVBd_meYMWo
QkCOohfhhOnC^n7oUKcToiJli?nE_>?oUK[QoiBkhOnF_>CoBemco`000?lb?dcoQZW<oiBih?nE^n?o
AeU/obdhA?nF_NCoSkGJo`X=4?l10P;oRJ_@oiFkhollBe_oCV9goiJmi?mXQ9koP:72oi>ih?lhAUGo
<Ce:oiJmi?nB]mko:SI1ocm?H?n?]=[oT[WOoiBih?lT;SSo5Q`Rofn<ZOnE_>?oP:;3oiJmi?nE_>?o
9Bhho`/>4Om5EfWoPZ?6oc=0COl/>4?oU[gToiFlholT;COo?TiOoi6gg?mLM8go6AlVoiBkhOnF_NCo
82P`oeM/PonE^n?oR:_?oi>hgonF_NCoU;_QoiBjhOnF_>CoU;_Qoi>khonC^^7oRkKOohJbg?mcYMSo
FI3=obUX/?mbLW;o/;2`olG5aOoAdM7oemOGom[Jf_oKfm/3omcLg0;ofm_K00?og=cLobh^;_lg=cL0
0_mlO7`2og]kN`0So`410On@T93ogMgMom_Kfom_Kfoo0000odU9BOo5aLGofm_KomcLg?oMgMgo;Rh^
od];BomoOgoo=SHfofMWIooGemOog=cLomgMgOoLg=cofm_KomcLg?oKfm_of=SHomKFe_o@d=3o`L71
oj6QXOmbLW;o/;2`olG5aOoAdM7oemOGom[Jf_oKfm/00ooLg=`2om_Kf`0>omcLg?l^;RkoIVIVolC4
a?n4Q8Co1PH6oijNW_oKfm_oZZZZo`000?nd];CogMgMomcLg?oJf]X2om_Kf`0FomcLg?oMgMgo;Rh^
od];BomoOgoo=SHfofMWIooGemOog=cLomgMgOoLg=cofm_KomcLg?oKfm_of=SHomKFe_o@d=3o`l?3
ojj^[_nUYJGog=cLonc/k>Ook^k^003Wooooo`09oogmoOo/k>co/K6aobE/_?mDSLcoL:;Eoh2/fOn8
/mkoSKKL00;oT;SP03coT;KOoi2hgon@^>3oPJG:o`410OmCJX3oTKSOoi6ihOnA^>3oTKSOobTd@?mI
LX[oT;KNoi2hgolgAECo9c8loi6hh?nA^=ooJXJTob/g@on@]]koCF=hoa`T:ol92`ko82Tbofn=Zon@
]]koAe]_o`@51_l620[o3a<Gof9nVOnA^>3oPjO:oc4nBol82Pgo1PL9oaDK8OnA^=ooTKWQob@^>?m7
FVkoA5IYo`/>4OlI82SoKXf[oi6hgonA^N7oPZG:obPc?_l72@_o3a@HofN2Won@^=ooTKSOofb:Z?lP
:C;o2@/=o`X=4?n3Yl/2oi2fgP?oT;SP00ooTK[Sohffg?n9]=ooOjcHofnPe?mBRlSo8VB^ogYjN_n[
Zj_o`<30olk>c_oBd];oe]KFomOGeooJf]X00_oIfMT2om[JfP0>omWIfOl];BgoHV9RomSHf?oJf][o
fMWIom[Jf_l20P;oSXj>omSHf?o2`/;o0@41ogemOOoIfMT2om[JfP0:omWIfOoHf=So;Bd]ofATI?oJ
f][ob<S8o`P82?nJVY[ofMWIomSHf0;ofMWI00oofm_KomOGeooGemOod];Bolk>c_nl_;coWYjNogYj
N_n[Zj_o`<30olk>c_oBd];oe]KFomOGeooJf]X00_oIfMT2om[JfP0>omWIfOl];BgoI6ATomSHf?oJ
f][o?ShnodI6A_oJf][obLW9o`000?n4Q8Cof=SHom[Jf_oIfMT2om[JfP0:omWIfOoHf=So;Bd]ofAT
I?oJf][ob<S8o`P82?nJVY[ofMWIomSHf0;ofMWI00[ofm_KomOGeooGemOod];Bolk>c_nn_[koZj^[
ok6a/Oo/k>cooOgmioooool00>Ook^k^00_ok>c/omcLg?nUYJGo7VFfodZ7b?m[W=;oOJOHohB]f_n9
/]WoRK7Kohfeg003ohbdg003ogJG^Ol10@7oOJ7600;oS;CK00CoS;CNohfeg?n;/m[oS;?K0_n;/]/2
ohbdf`04ohbdg_n=]McoRk?Johbcf`;oRk;K00SoS;CKohZbfOn<]=koSKGLoh^cf_n</m_o:CE2oci?
H@;oS;CK00KoS;CNohfeg?n;/m[oS;?KohV_f?n;/]/2ohbdf`04ob<]=om6FVgoRk?Joh^bfP;oRk;K
0_n<]=/01?n<]=koSKGLohV`eon</m/2oh^bf`;oS;CK01GoS;CNoh^bfOn;/m[oS;?Koh^bfon</m_o
Rk?Johbcfon<]=coRk?LohZcf_n3[MWoO:OFofVKd?m:QLCo7F2Zog9bL_nVYZKo^k^kolW9bOo@d=00
0ooDe=@01ooGemOoe]KFomCDe?oDe=CoeMGEob`/;?mPH6000_oFe]H02OoGemOoe=CDo`820_n;Rh_o
e=CDok>c/ol10@7o`L71omOGe`02omCDe00;omGEeOoDe=Co;2`/of=SHooFe]Ko`l?3o`P82?mgMgOo
eMGEomCDe?oEeMD00_oFe]H02ooEeMGodm?Com3@d?o8b<So^;RhoiZJV_mbLW;oYZJVok^k^oo9bLWo
d=3@00?oe=CD00OoemOGomKFe_oDe=Coe=CDomGEeOl/;2coHV9R00;oe]KF00Wo;2`/odI6A_oDe=Co
eMGEoe9BD_lM7Agoa/K6omKFe_oGemL00_oDe=@02ooEeMGoe=CDob`/;?mSHf?oe]KFol?3`ol820So
MgMgomGEeOoDe=CoeMGE00;oe]KF00WoeMGEom?Cdoo@d=3ob<S8okZj^_nWYjOoYJFUomcLg?o/k>`0
ioo^k^h00>Ooi^KV00[oi>CTomCDe?nOWioo6Ef^odF2`_mRV<koLj?BogbUeOn4[]WoQZkJ0_n8[mX0
2On7[MWoQjoJohR_f_lX<coo7RLaod]QNOlc@U?o;Sa;ohRafP02ohR_fP06ohZafon8[]WoR:oJohJ^
f_n8[m[oR;7J0_n8[mX01_n:/M_oR:kIohR_f_n6[][oR:oJohRafP;oR:oJ00KoNI_0ogJG_?n8[m[o
QZkJohR_f_n8/MX2ohR_fP06ohZafon8[]WoR:oJohJ^f_lR:cKo@eQ/0_n8[mX01_n:/M_oR:kIohR_
f_n6[][oR:oJohRafP;oR:oJ00KoR[7KohR^fOn8[m[oQZkJohR_f_n8/MX2ohR_fP0CohZafon8[m[o
QjgIohR_f_n7[m[oQ:cJohB^fOmmYmKoLj;Bof:Hcom4P<7o5EFSofi^K_nQXJ7o]kNgolC4a?o;bl_o
c/k>om;BdP06om?Cd`04obd];OmOGeoodm?Com;BdP;odm?C01Go0P82ohZ:R_oEeMGod];Bocdm?Ol_
;booMGEeoe5ADOm8B4Sodm?ComGEeOl/;2co9RHVoclo?olA4A7o5ADEolO7aooCdm?oeMGEom?CdooD
e=@00_oBd]803?o?cloob/[:olG5aOnf][KoUIFEofi^K_nQXJ7o]kNgolC4a?o;bl_oc/k>om;BdPKo
dm?C00Ko;Bd]obHV9_m:BT[o71`Lo`T92OnQXJ42om?Cd`0ColC4a?le=CGo61PHofEUIOmlO7coH61P
obPX:?nMWIgoeMGEob`/;?lV9RKo?clooa4A4OlE5AGoalO7om?CdooEeMGodm?ComCDe002om;BdP08
olo?coo:b/[oaLG5okRh^?nQXJ7oWinOomCDe?oTi>CWonKViP00ioo^k^h05?o/k>cog=cLojFUYOl?
E:[o?7Vmoe^Aaom^WLooNjSHognXe_n0Z=KoPj_Hoh>/f?n2Z]KoPZ_Foh:Ze_n0Z=CoG7VHocQ9GOm5
Fg;oHX2Q0_n3ZmP01On2Z]KoPj_Hoh:Ze_n2ZmSoPj_F00?oPj_H00GoPZ[Foh>[f?n2Z]KoPZ_Hoh>[
eP03oh>[f005oh:Ze_n3ZmSoPZ[Foh:[f?n3ZmH00on3ZmP03On2Z]KoPj_Hoh:Ze_n2ZmSoPj_Fob0Z
=_m1EF_oPj_Hoh:Ze_n3ZmSoPZ[Foh:[f?n3ZmH00on3ZmP01On2Z]KoPj_Hoh:Ze_n2ZmSoPj_F00?o
Pj_H00?oPZ[Foh>[f?n3ZmP00_n3[=P03on4[MWoP:SFogjWeOmiYMKoL9kBoeZ@a_lnNkoo3DfMog9b
L_nIVIWo/K6aokno_oo9bLWoc/k>olo?c`06om3@d003ohn?SonSXj?od=3@00?od=3@00WoOgmook>c
/oo@d=3od=3@olc<c?nDU9CoFEUIofi^K_nKVi/00_o@d=001On?ShooOGemoh20P?nYZJWoc/k>00Co
d=3@00ood];Bom3@d?o?clooc<c<olW9bOnn_[ko/[:bohf=SOmbLW;oVIVIok6a/Ono_koobLW9olk>
c_o?cll01_o@d=001On?ShooOGemogemOOnHV9Sobl_;00Cod=3@00goclo?oi2@T?mWIfOoEUIFog5a
LOn>SXkoa<C4om3@d?n?ShooOGemoh20P?nYZJWoc/k>00Cod=3@00_od];Bom3@d?o?clooc<c<olW9
bOnn_[ko];BdoiVIVOnUYJGog=cLonc/k03Wonk^kP00ioooool03?omoOgokNg]okBd]?l4BZCo<G:h
oeB9a_mWUlcoLYo@ogNTdommYMCoOZOEogjXe@?oOZSD00?oOj[Eoh2ZeOmnZ=@00omnZ=@01?moZ=Co
OZSDognZeOn0Z]D4ogjXe004ognXe?mnZ=CoOj[Eoh2Ze@CoOZSD00CoOjSDogjXe?moZ]GoP:[E1?mn
Z=@01?moZ=CoOZSDognZeOn0Z]D2ogjXe006ogbUd?mmY];oOjSDogjXe?moZ]GoP:[E1?mnZ=@01?mo
Z=CoOZSDognZeOn0Z]D4ogjXe00HognXe?mnZ=CoOj[EogjXdomoZ=CoOZSDognXe_mmYMCoNJCDog:O
d?mXV/goDhW4oc5`]ol3@YSoOgmooi:BT_n/[:co_;blolC4a?o:b/[obl_;olc<c?o>c/koclo?7_o>
c/h2olc<c00?ol[:b_o4a<Co_;blojZZZ_n7QhOoOgmooi:BT_n/[:co_;blolC4a?o:b/[obl_;olc<
c?o>c/koclo?01koc/k>0_o<c<`02?o:b/[oa<C4okbl_?n/[:coTY:BokBd]?o]kNgooOgmioooool0
0>Ook^k^00[ok>c/omoOgon][Jgo03nLobAU/om5P<3oG937ofbJc?mcWlooMj?@0omjY=80COmjYM?o
O:ODog^WdomjY];oMjC?ogVUd?mjY]?oO:SDog^We?mlYmCoNjOCogZVd_mgY<ooNJG@ogZVdomlZ=Co
NjODogbWe?mkYm?oNZKBogNTcomiYM3oNZKCogbXe?mkYmCoO:ODog^WdomjY];oMjC?ogVUd?mjY]?o
O:SDog^We?mlYmCoNjOCogZVd_mgY<ooNJG@ogZVdomlZ=CoNjODogbWe?mkYm?oNZKBogNTcomiYM3o
NZKCogbXe?mkYmCoO:ODog^WdomjY];oMjC?ogVUd?mjY]?oO:SDog^We?mlYmCoNjOCogZTd_mkYM;o
NZC@og^Ud_meWlgoLio@ofbJc?mLTLOoAH30ob=T/Ol0>Y?oOWinoh^;RonUYJGo][Jfol30`?o5aLGo
b<S800;ob/[:00?oc<c<ol[:b_o;bl/00oo<c<`01Oo:b/[obl_;olc<c?o:b/[obl_;00?oc<c<00Go
b/[:ol_;boo<c<cob/[:ol_;b`03olc<c005ol[:b_o;bl_oc<c<ol[:b_o;bl/00_o<c<`04?o;bl_o
b/[:olO7aoo9bLWoaLG5ol30`?ne]KGoXj>Soh:2P_mnOWkoRh^;ojFUYOnf][Ko`<30olG5aOo8b<P2
ol[:bP03olc<c?o:b/[obl_;00?oc<c<00Gob/[:ol_;boo<c<cob/[:ol_;b`03olc<c005ol[:b_o;
bl_oc<c<ol[:b_o;bl/00oo<c<`01Oo:b/[obl_;olc<c?o:b/[obl_;00;oc<c<00cobl_;ol[:b_o7
alOobLW9olG5aOo0`<3o]KFeojFUYOn;Rh_o[Jf]omoOgoo/k>cWonk^kP00iooVi^H0F_oUiNGofMWI
ok6a/Ol9;Xco4UNZocMc^Om>Q/7oHI?7ofRGb_m^VlkoLIk=og6McombWlooLYo>og6NcOmaWlkoLYo?
og>PcombX=3oLIk>og6NcombWlkoLIk=og6Oc_mbWlooLj3?og:Pd?maW/koLIk?og:Oc_maW/goLIo>
og:OcomcX<ooLZ3@og6Nc_maW/ooLYo>og6NcOmaWlkoLYo?og>PcombX=3oLIk>og6NcombWlkoLIk=
og6Oc_mbWlooLj3?og:Pd?maW/koLIk?og:Oc_maW/goLIo>og:OcomcX<ooLZ3@og6Nc_maW/ooLYo>
og6NcOmaWlkoLYo?og>PcombX=3oLIk>og6NcombWlkoLIk=og6Oc_m`WLgoLYo?og>Nc_m`WLcoK9S:
ofVGb_mPT/OoCXK3ocIc^?l?E:Wo22b5ohR8R?mhN7SoW9bLojj^[_nh^;So`L71olC4a0?oalO700Co
a/K6olS8b?o6a/KoalO70oo8b<P2olK6aP03olS8b?o6a/KoalO700?ob<S80_o6a/H00oo8b<Soa/K6
olO7a`03olS8b0;oa/K600?ob<S8olK6a_o7alL00_o7alL2olC4a00<ol30`?ni^KWo[Zj^oiZJV_mc
Lg?oR8R8ogQhN?nLW9co[Zj^okRh^?o1`L7oa<C40oo7alL01?o6a/Kob<S8olK6a_o7alL3olS8b0;o
a/K600?ob<S8olK6a_o7alL00oo8b<P2olK6aP03olS8b?o6a/KoalO700?ob<S80_o6a/H00oo8b<So
a/K6olO7a`02olO7a`;oa<C400So`<30okVi^On^[ZkoVi^KogYjN_na/K7ofMWIonGUiNOoi^KV003W
onk^kP0Eong]kOoUiNGoa/K6obPfQOl3AJ3o=g>iof:CbOmlYM?oQZkEoh^_eOn@]=SoTKGJoi2dfOnB
]M[oTKGJoi6df_nB]M[oT[GKoi6dfOn@]=WoT[GJ00;oTKGJ00KoTKCJoi:ef_nB]M_oTKCIoi2dfOnB
]MX2oi6efP06oi6df_nB]M[oT[GKoi6dfOn@]=WoT[GJ0_nA]MX01_nA]=[oT[GJoi:efonA]=WoT;CI
oi:efP;oTKGJ00KoTKCJoi:ef_nB]M_oTKCIoi2dfOnB]MX2oi6efP06oi6df_nB]M[oT[GKoi6dfOn@
]=WoT[GJ0_nA]MX01_nA]=[oT[GJoi:efonA]=WoT;CIoi:efP;oTKGJ01CoTKCJoi6dfonA]M[oT[KJ
oi6df?n=/MSoR:kEoh2ZeOmUULWo>gFio`51W_lV<WooYJFUog1`L?n?Shoo[Zj^ol;2`_o<c<codM7A
om;BdP;oe=CD0_oEeMD3omCDe003omGEeOoDe=Codm?C00;oeMGE0ooDe=@00ooEeMGoe=CDom?Cd`02
omGEe@?oe=CD00?oeMGEomCDe?oCdm<00_oEeMD5omCDe00>om3@d?o>c/ko`/;2ok2`/?n<S8coKFe]
ojFUYOm`L73oShn?ojj^[_o2`/;oc<c<om7AdOoBd]82omCDe0;oeMGE0ooDe=@00ooEeMGoe=CDom?C
d`02omGEe@?oe=CD00?oeMGEomCDe?oCdm<00_oEeMD3omCDe003omGEeOoDe=Codm?C00;oeMGE1OoD
e=@02Oo@d=3oc/k>ol;2`_n`/;3oSHf=og5aLOo6a/KoiNGUong]k@3Wonk^kP00j?ooool03_ojn_[o
inOWofUYV?l;<9GoEX[6ohjcfOnO_mooYL?Qojc6hon/an?o[/WSojo:iOn^b>Co//[T1On_bN@00onc
c>Go/L[Uok;:i005ojo9i003ok?<iOnab^Go//[T00Go[lWT00?o/lcUok7:iOnbb^@01On_bN@00onc
c>Go/L[Uok;:i005ojo9i003ok?<iOnab^Go//[T00Go[lWT00?o/lcUok7:iOnbb^@01On_bN@00onc
c>Go/L[Uok;:i002ojo9i00Cojo:iOn^bN?o[LSSoj_6honS`^7oWkoOoi:ef_mHS<Ko1bjCofIVUOoA
dM7oR8R8oh20P?nl_;coe=CDom[Jf_oMgMgoh>3PomoOg`05on7Qh@04on3Ph?oQhN7oh>3Pon3Ph0Co
hN7Q00Coh>3Pon7QhOoPh>3oh>3P1?oQhN401?oPh>3ohN7Qon3Ph?oPh>05on7Qh@0Aon3Ph?oOgmoo
g=cLom_KfooEeMGo_KfmoginO_n8R8SodM7AohR8R?n0P83o_;blomCDe?oJf][ogMgMon3Ph?oOgml0
1OoQhN401?oPh>3ohN7Qon3Ph?oPh>04on7Qh@04on3Ph?oQhN7oh>3Pon3Ph0CohN7Q00Coh>3Pon7Q
hOoPh>3oh>3P1OoQhN402_oPh>3ogmoOomcLg?oKfm_oeMGEokfm_OmnOWkoRh^;onOWioojn_[Xoooo
o`00j?o^k^h03_o/k>cohn?SokFe_olf>hWoCg:foh^af?nJ^]coYL;PojO3hOn[a>?o[<OSoj_7hon/
b>CoZlOS1?n/b>@01?n[anCo[<STojc7hon[an<4ojc8i004oj_7i?n/b>Co[<OSoj_7h`Co[<ST00Co
ZlOTojc8i?n/an?oZlOS1?n/b>@01?n[anCo[<STojc7hon[an<4ojc8i004oj_7i?n/b>Co[<OSoj_7
h`Co[<ST00CoZlOTojc8i?n/an?oZlOS1?n/b>@01?n[anCo[<STojc7hon[an<3ojc8i00@ojc8hon/
an?oY/?Qoj?2h?nH^McoNjGCocMN[?ld>HKo/k>momWIfOnh^;SoMGEeojb/[?oBd];of=SHomgMg@;o
gmoO00?oh>3PomoOgooPh>000_oOgml4on3Ph004omoOgooPh>3ogmoOomoOg`Coh>3P00CogmoOon3P
h?oOgmoogmoO1?oPh>001?oOgmooh>3PomoOgooOgml2on3Ph00>omkNg_oLg=cof=SHolc<c?nPX:3o
Lg=cokRh^?oIfMWo^;RhogEeMOn/[:cod];BomSHf?oMgMd2omoOg`03on3Ph?oOgmooh>3P00;ogmoO
1?oPh>001?oOgmooh>3PomoOgooOgml4on3Ph004omoOgooPh>3ogmoOomoOg`Coh>3P00CogmoOon3P
h?oOgmoogmoO0_oPh>002OoNg]kog=cLomSHf?o<c<coX:2Pog=cLonj^[[ohn?Sonc/k03Xonk^kP00
jOoVi^H0A_oShn?ofMWIoiZJ[_m4BI?oB6>bof^Ab?n4ZmGoU[SLoiZkg_nL_=koW[oNoijogonM_Mko
W;cNoijmg_nN_MooWKcNoinogonN_MkoW[gOoifmg_nL_=koW[gNoijmgonM_=koWkoOoijmg_nN_Moo
WKgNoiblg_nN_MkoW[gOoiflg_nO_mooW[gNoijmgonM_MkoW;cNoijmg_nN_MooWKcNoinogonN_Mko
W[gOoifmg_nL_=koW[gNoijmgonM_=koWkoOoijmg_nN_MooWKgNoiblg_nN_MkoW[gOoiflg_nO_moo
W[gNoijmgonM_MkoW;cNoijmg_nN_MooWKcNoinogonN_MkoW[gOoifmg_nL_=h2oifmgP0Boi^lg_nJ
^mkoU[SLohV]e_mTRlKo:DVRocPmRonJVZoofMWIon3Ph?oIfMWoYZJVoh61POnTY:Co_knoolo?cooG
emOofMWI0_oJf]X00ooIfMWof][JomWIf@05om[JfP03omWIfOoJf][ofMWI00Gof][J00?ofMWIom[J
f_oIfMT01OoJf]X05OoIfMWof][JomWIfOoJf][ofMWIomOGeooAdM7o_;bloi6ATOmgMgOoYZJVomWI
fOoPh>3ofMWIojJVY_n1PH7oY:BTokno_oo?clooemOGomWIf@02om[JfP03omWIfOoJf][ofMWI00Go
f][J00?ofMWIom[Jf_oIfMT01OoJf]X00ooIfMWof][JomWIf@05om[JfP0=omWIfOoJf][ofMWIom[J
f_oIfMWoemOGom7AdOnl_;coTI6AogMgMonVYZKofMWIon?Sh`3YonKViP00jOo^k^h04Oo]kNgojn_[
on?Shoo0`<WoLG6PocHmS_l?98Ko0228o`0URol0:8go02^@o`0/TOl0;I7o02b@o`0/TOl0;93o02bA
00;o02fA00Ko02fBo`0]TOl0;93o02bAo`0/T?l0;942o`0]T@06o`0]T_l0;I7o02b@o`0/TOl0;93o
02bA0_l0;I401_l0;I;o02fAo`0/T?l0;97o02b@o`0/T@;o02fA00Ko02fBo`0]TOl0;93o02bAo`0/
T?l0;942o`0]T@06o`0]T_l0;I7o02b@o`0/TOl0;93o02bA0_l0;I401_l0;I;o02fAo`0/T?l0;97o
02b@o`0/T@;o02fA01Wo02fBo`0]TOl0;93o02fAo`0[S_l09hgo02J;o`0PR?l?98Ko=Sf>og5aX?o0
`<Wohn?Son_[joo/k>cojn_[on?Shoo5aLGoTI6AogYjN_maLG7oLW9bogIfM_mgMgOoNg]k00;oO7al
00?oNg]kogalO?mkNg/00_mlO7`01_mkNg_oO7alogalO?mkNg_oO7alog]kN`;oO7al00KoNg]kogal
O?mlO7coNg]kogalO?mkNg/2ogalO006og]kNomlO7coO7alog]kNomfMWKoMgMg0_maLG404?mjNW[o
TI6AolG5aOoShn?ojn_[onc/k?o[jn_ohn?SolG5aOnATI7oNWYjog5aLOmbLW;oMWIfogMgMomkNg/2
ogalO003og]kNomlO7coNg]k00;oO7al00KoNg]kogalO?mlO7coNg]kogalO?mkNg/2ogalO006og]k
NomlO7coO7alog]kNomlO7coNg]k0_mlO7`01_mkNg_oO7alogalO?mkNg_oMWIfogMgM`;oLG5a00Ko
NWYjoi6ATOo5aLGohn?Son_[joo]kNgYonk^kP00joooool01_omoOgon_[jooKfm_oalO7okno_ong]
kD;ok>c/00KokNg]ono_kooalO7om_Kfoo[jn_omoOd3ooooo`06oogmoOojn_[om_Kfoo7alOo_knoo
kNg]8?o/k>`01_o]kNgokno_oo7alOofm_Kon_[joogmo@?ooooo00KooOgmoo[jn_ofm_KolO7aono_
koo]kNdPonc/k006ong]kOo_knoolO7aooKfm_ojn_[ooOgmjoooool00>gok^k^0_o]kNe6onc/k0;o
kNg]1oo^k^h2ong]kBCok>c/0_o]kNd7onk^kP;okNg]9?o/k>`2ong]kNgok^k^003oonKVi_ooi^KV
Q?oVi^H00?ooOgmoF?moOgl7oginO_ooOgmo9OmoOgl00004on_[jooVi^Koh^;RomkNgPCogMgM0ooN
g]h0oooMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMg@004ooNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]h00_oMgMd2omcLg00dom_KfooMgMgog=cMomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNgP;ogMgM00Oofm_Kom[Jf_oGemOof=SHomOGf?oJf][ofm_K00;ogMgM0?oog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]h001OogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMg@03omkNgP03omgMgOoNg]kog]kN00?ogMgM0OoQhN41onOWi`7o
j^[Z00000oo/k>coi^KVon3Ph007omWIf@04omSHf?oFe]Kodm?Com3@d0?ocLg=00Cod=3@om?CdooG
emOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Co
f=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=SLomWIf@;of=SH00Koe]KFom?CdooC
dm?oe=CDomOGeooHf=P2omWIf@03omSHf?oIfMWofMWI00;of=SH2OoIfMT00ooHf=SofMWIomWIf@02
omSHf003omWIfOoHf=Sof=SH00;of=SH5ooIfMT01?oHf=Soe]KFom;Bd_o?cll2olg=c@04olo?cooC
dm?oemOGomSHf0kofMWI00?of=SHomWIfOoIfMT0oooIfMT6omWIf@03omSHf?oIfMWofMWI00KofMWI
0OoNg]h1onKViP7ok>c/00001oo^k^kojNWYonCTi?oPh>3ohN7Qon3Ph?oRh^800_oQhN403OoNg]ko
g=cLom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml02OoQhN403OoOgmoo
fm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml02OoQhN403OoOgmoo
fm_Kom?Cdoo7alOo^k^kok:b/_n^[Zko/[:bok^k^oo7alOodm?Com_KfooOgml0fooQhN402OoPh>3o
gmoOom_KfooFe]Koe=CDomKFe_oJf][og]kNon3Ph006omoOg`?oh>3P00?ogmoOon3Ph?oPh>000_oP
h>08omoOg`;og]kN0_oOgml3on3Ph0;ogmoO0_oPh>02omoOg`goh>3P00GogmoOomgMgOoIfMWoeMGE
om?Cd`02om;BdP03omKFe_oLg=coh>3P0?oohN7Q6OoQhN400ooRh^;ohN7Qon;RhP04on7Qh@7oi>CT
0OoYjNT1ong]k@0000?ol?3`ono_kooalO400oo`l?00ooo_knool?3`onk^k_oYjNWofm_Kol71`OnT
Y:CoS8b<og]kNomgMgOoNg]kohb<S?nTY:Co`/;1om[Jf_oZj^[okNg]oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<RomkNg_oMgMgog]kNon<S8coY:BTol;2`_oJ
f][oj^[Xong]kOoalO7okno_oo7alOo_knoolO7aono_kooalNookNg]on[Zj_oJf][o`/;2ojBTY?n<
S8coNg]kogMgM_mkNg_oS8b<ojBTY?o2`/;of][Jon[Zj_o]kNgolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_k`008OoalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_koo`l?3okNg]onc/k?oUiNGoh^;RomoOgooUiN?ojNWYong]k@02onSXj006onKV
i_oYjNWoinOWon_[jOo/k>cok^k^0ooZj^X00oo_knook^k^onk^k002onSXj007onKVi_oYjNWoinOW
on[Zj_oYjNWojNWWonGUi@02onOWi`0:on_[joo/k>cokno_on_[jooZj^SojNWYonk^k_o/k>cojn_[
onSXj0;okNg]00[ok^k/on[Zj_o/k>cok>c/onk^k_oZj^[ok>c/ong]kOo^k^coj^[Z0_o/k>`02?o^
k^ko[Jf]ogMgMomIFEWoKfm^okJf]_oQhN7oinOW0_o_knl0oooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_koo`l?3okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7al@007_o_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7ol?3`ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`Col?3`00000ooalO7ok^k^onOW
i`04onGUi@0@onCTi?oOgmoodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:
ROna/K7odM7AomkNgP;oi>CT00?oiNGUonCTi?oUiN@00_oTi>@03ooNg]kodM7Aok6a/On:RX[oIVIV
oe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7@omkNgP02onCTi03honGUiOoTi>CoiNGU
onCTi?oTi>?og]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6a
om7AdOoNg]koi>CSonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGohn?SolK6a_lX:2SoADE5
ohn?SooBd]7ofm_KomcLg?oFe]H3omGEe@0;omCDe?oJf]WogmoOomoOgooIfMWoeMGEomSHf?oOgmoo
hN7QomgMg?oFe]H00ooEeMD01OoDe=CofMWIom[Jf_oHf=OoeMGE00;oe]KF00oofMWIomgMgOoPh>3o
fm_KomKFeOoFe]KogMgMomcLg?oHf=SoeMGEomcLg?oPh>3ogmoNom[Jf_oKfm/00_oMgMd0oooIfMWo
g=cLomoOgooPh=oofm_Kom[Jf_oMgMgoh>3Pog=cLomXJ6SoSHf=oeADE?l820SoXj>Som_KfooShn?o
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoShn?oiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi000:?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>@4onGUi@06onCTi?oUiNGoiNGUonGU
iOoXj>SokNg]0Oobl_800003ooCdm?o]kNgoinOW00;oh>3P01?ohN7QomoOgooNg]kod];BokBd]?n7
QhOoG5aLofdk=OnNCT;ocFmOonV3Koo=KeooWTi3ofdk=_mLG5coQhN7okBd]?oBd];og]kN00Goh>3P
017og]kNom;Bd_nd];CoQhN7oeaLG?m]H2coWYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aLohN7Qond
];Cod];BomkNgP05on3Ph00AomkNg_oBd];o];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=AomZ
WSCoBFX_oeaLG?n7QhOo];Bdom;Bd_oNg]h0f_oPh>001_oOgmooclo?oiVIVOnBTY;o6ATIohb<S0;o
eMGE01ooclo?ol;2`_o>c/koc/k>olG5aOo:b/[of][JomSHf?o@d=3obl_;olo?cooHf=Sof][JomGE
eOo?cloo`L71om3@d?o>c/koa<C4ol_;booHf=SoemOGokjn__nk^k_odM7Aom3@d?oEeMGof=SHom?C
doo<c<coc/k>00;oeMGE00Goc/k>olc<c?oCdm?of][JomSHf002om;BdP04omSHf?oGemOodM7Aom?C
d`;ofMWI00Kodm?Com7AdOoGemOof=SHom7AdOo@d=02om7Ad@04odI6A_m1@D7oemOGomkNgPgoh>3P
00?ogmoOon3Ph?oPh>00oooPh>07on3Ph003omoOgooPh>3ogmoO00;ogmoO0ooPh>000ooQhN7oinOW
onc/k001ooCdm00000?om_Kfoo;bl_o[jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWiooJemOohlf;_o]
LF7onIf@oofaYOom_:oooKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;Rh_oWinL00ooXj>P04ooW
inOoh^;Rolg=cOnOWiooKVIOoi=b8_o]dDConO=doogmSOomoIGooOf>ooWhM_o]edOoTg<RofiWGonO
WioocLg=on;Rh_oWinL00ooXj>P04ooWinOoh^;Rolg=cOnOWiooH6QOod]l8onBhD_o_OUkom3mT_oH
oI_oe?fEol3iO_nHj4goCH0Tof1YGonOWioocLg=on;Rh_oWinL0fooXj>P01?oVi^KohN7QoeeMGOm=
CDd2omgMg@0Ooe1@D?l71`Oo5ADEohB4Q?lF5QKo@d=3on;Rh_oMgMgoW9bLo`000?n?ShoogMgMon7Q
hOoKfm_o@410o`P82?lI6AWoR8R8o`/;2omHF5So]kNgo``<3?l71`Oo8b<SobLW9ommOGgof][JomgM
gOoDe=Co2`/;oeUIF@02omWIf@03oeeMGOl;2`_odm?C00;ogmoO00KoFUYJodi>C_oNg]kog]kNob<S
8on4Q8@2on7Qh@0<ogYjN_l^;RkogMgMomgMgOo2`/;oD51@oc<c<om^KVkoPh>3ob4Q8OoNg]koi^KV
oooXj>PPonSXj07ok>c/0Oobl_81ooKfmP0000?om_KfooShn?ohn?P00oohn?P04oogmoOok^k^olk>
c_n@T93oQBl[onUTE_okTXOooZJKoojaYOoo^:_oo[>VoojXW?okU8WokVQIohTa:on@T93oc/k>onk^
k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93oVFT[oo2m?Ookh6koo_B2ooknR_oooi;oo_j<ookh
PookiG3ol<8noiUZ:on@T93oc/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93o@W<[ohC>
@on]kg?o`_j8olknT?oFoiOod?jBolKnROnbmGCoR==3odAe:on@T93oc/k>onk^k_ogmoL0foohn?P0
9Oofm_KolO7aoh61POlO7aookNg]olK6a_l0003o`l?3om?CdomLG5co20P8on[Zj_o`l?3oj^[Zoe9B
D_lD51Co?CdmonWYjOo`l?3o[jn_o`L71ooBd];ocLg=odi>C_lK6a_ok^k^om_Kfon^[Zkoj>SXonc/
k?n^[Zko0000okBd]?o/k>co/;2`o`/;2olJ6QX00_oTi>@02olS8b?o3Ph>ojBTY?o]kNgok^k^of1P
H?mDE5Cok^k^ong]kOlV9RKoSHf=00;ol?3`00coPX:2oc4a<Oo/k>coj^[Zod=3@ol_;booW9bLog=c
LolZ:R[o6QXJonk^k_ofm_H8ooShn003ooOgmoohn?Son?Sh0?oon?Sh3_ohn?P00oogmoOon?ShooSh
n002ooShn004ooOgmooinOWomoOgooOgm`7on?Sh00000oojn_[omOGeonk^kP02onc/k03oon_[jooY
jNWogmoOokZj^_miDU;o_c8TonMdJOomRGkooiR<oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c9?mi
DU;o^[ZjomoOgooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3ooMYSoooZL_on
lgkoooZ2ookfOoook7?oo]iToo[7DOoRTQcoRFICokZj^_oOgmooj^[Zon_[joo/k>cojn_[on[Zj_oO
gmoo^[Zjoe9]D_mAXacoTM9EojKWJ_nhnG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]D_nj
^[[ogmoOon[Zj_o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/003oonc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[jooZj^[oi>CTogYj
N_lL71coh^;Rol_;bol30`?oWinOomoOgonDU9Co4a<Con3PhOoQhN7od=3@o`H61_nQXJ7o2@T9okjn
__oRh^;o^KVjo`820_na/K7og]kNoh20P?lY:BWoh^;RonSXj?oTi>GogmoOom[Jf_oDe=Co20P8ohJ6
Q_oOgmooJVYZodU9B_le=CGo[:b/okjn__l71`OoN7QhoeEEEOoOgmoogmoPoe]KFom?Cdooh^;Ron3P
h?lT92CoQ8B4on3Ph?oPh>7oNg]kobl_;ooQhN7oe=CDo`D51OnWYjOoi>CTon;RhomoOgoo5ADEon;R
h_oYjNWok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/001b
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/1oo[jn/01Oo/k>cojn_[on_[joo^k^ko
m_Kf007onOWi00000oojn_[olo?cong]k@02onGUi@3oonKVi_oTi>CofMWIok:b/_mi;Rkob48don=Z
G?odNVgooHQloojGR_onVhkooYR;ooj:O_odNfgoif]MolY2=?mk;Rko/[:bomSHf?oTi>CoiNGUonKV
i_oUiNKoi>CTomSHf?nb/[;oUUD^onZL:ook_4Coo/aCoogHH_onhg;oo^UeookVLoonffGooLaCoo_1
AOo^WR_oVEH^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGUonCTi?oHf=Wo/[:bobiR;_mS[B_oQlY8oiOL
FOnUiFWo/_=gokSfNondmGWoYnY[oiSLFOn9cd_oHjh[obiS;_nb/[;of=SIonCTi?oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV001YonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoTi>Cog]kNogMgMolK6a_og=cLon3Ph?nNWYko;Rh^
ob/[:olb<S;o4Q8Bom_Kg?oKfm_oQ8B4ob4Q8OoOgmooDe=CofMWIooKfm_ogMgNoi2@T?lY:BWo;bl_
ob`/;?lX:2SogMgMomoOgooHf=Woe=CDolo?comKFe_o0000okjn__oIfMWo:2PXohJ6QomhN7SoJ6QX
oh:2P_ll?3co`l?3o`l?3ooEeMGofMWJoeUIFOm>CTkogMgMomcLg?lS8b?oPH61omKFe_oFe]OoMgMg
obh^;_oMgMgoXZ:Ro`000?o6a/KofMWIomSHfOn>SXko5ADEomgMgOoShn?oi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV00?oiNGU0?ooi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^H000OoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGU00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGokNg]ooCdm001oo_k
n`0000?oo?clooShn?oalO400oo^k^h04oo[jn_ohN7Qokbl_?mj5aOo`clbom=FBOoTJ5[okgM/ooB3
NOohQgcomHAjoo=iKOoUJE_ofEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl
_?nUAaOoiYLbooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlbonVK<_nUAQOo_;blon7Q
hOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?lGFAOoGjPbogJm=on6cDOoU]IJoj;PIOnSh6WoXn5WoiOJ
G?n6cTOoMklgoen[<_lGFAOo_;blon7QhOo/k>`0foo^k^h0;_o/k>coinOWog]kNolL71coi>CTonWY
jOoVi^KohN7QomkNg_n=SHgo51@DonKVi_oTi>Co=CDeogUiNOo[jn_o/[:boaDE5OoOgmooi^KVonCT
i?oQhN7ogMgMogYjN_lY:BWoj>SXonGUiOoMgMgo/K6aobHV9_l;2`_oVi^KonWYjOo<c<co0000olk>
c_o3`l?o9BDUod];BomlO7coj>SXoc4a<OnUYJGoi>CToeeMGOmADE42onOWi`0:obDU9OmYJFWogmoO
omoOgomgMgOo<C4aonWYjOo1`L7o0000ojNWY`;ogmoO00CoTi>CoaHF5_oWinOok>c/ooo^k^hOonk^
kP03ong]kOobl_;on?Sh007oo?cl0003oogmo@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh
=3Coaclcom9@@ooJHUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];olo?cooclo0?o
oOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWomJPYooRd?ooi_D[on;m=ooZoB_oi^3oomZXZonnN
6OoKRcCoXRd7om;Bd_oclo?oo?cl00?ooOgm01?oo?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3
@on:cE3oSLeBoh[>D?n1adCoLKT_of:^8?m>VcCo1d87om;Bd_oclo?oo?cl0=_ooOgm02?ono_kooOg
mon4Q8Co7QhNoo?clooinOWo/k>com3@d?oclo?oJ6QXodM7Aoojn_[oe=CDo`000?oMgMgoo?cloo_k
nolW9bOoZ:RXooWinOn[Zj_oeMGEoo7alOmDE5CoGUiNooWinOodm?CoU9BDo`D51Om0@43odM7AooOg
moohn?SoUiNGob/[:`02oo[jnP0Kob@T9?l71`Oob<S8oo_knon5QHGoHf=SooOgmomSHf?oEeMGooSh
n?oinOWo9bLWoaDE5On3Ph?oemOGod92@_mSHf?ono_koo[jn_ld=3CoBDU9om_KfooUiNGoCdm?oaLG
5oojn_[oo?cl0?oooOgm7OomoOd00oolo?cooOgmooclo003oogmo@0003[ooOgmoo[jn_oclo?ok^k^
oo3`l?o_knook^k^onWYjOoCdm?oFadMoj8d=?nd:1go`CX]olM9??o?ET[od5M;om1GB_o:BSko`c/^
okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_onk^k_oZj^[odm?Coh`U7Oo8LCCofH@M
onBD5OoWWBCokZPcoo2Z=?o_ZS?ok:0UonNG5OoLR1gob74doh`U7OoCdm?oj^[Zonk^k_o`l?3okno_
oo3`l?o^k^koj^[Yom?CdolM>1go=88dodNE7OmJYA_oJJdZ0_md^3P0oome^CSoJk4[oe^W7?m8VQgo
=88doadh7OoCdm?oj^[Yonk^k_o`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o^k^ko
jn_[ogemOOlL71coinOWonk^k_n8R8So<30`o`h>3_la<C7o/;2`ono_k_n4Q8CoCDe=onk^k_o_knoo
k^k^ohZ:R_mIFEWokno^ogQhN?l/;2co3Ph>ocPh>?nn_[kok^k^on?Sh`003?l>3PkoJFUYon3Ph?oR
h^;oi^KVon[Zj_mQHF7oMWIfono_k_o^k^koMgMgobHV9P;ok^k^01KocLg=ob`/;?o[jn[oK6a/of=S
Hoo[jn_ok^k^ocXj>_nDU9CoHV9Ro`h>3_ld=3Coa<C4onk^k_o_knoodM7Aoc`l??l:2P[o9bLWofa/
K?l/;2cok^k^0_o_knl0ooo`l?3okno_oo3`koo_knool?3`ono_koo`l?3ok^k^oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l0005oo_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_00;ol?3`1_o_
knl1oo?cl`7on?Sh0Oono_h00003ookno_ogmoOol?3`00CojNWY017oinOWom_KfomSBd_oPC8bojHe
=Onf=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mSBd_ofm_KonOWi`05onWYj@0AonOW
iooKfm_oRD];ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;oRD];om_K
fooWinL01OoYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[ZbooL:dhofn^>_m`[CSoJZX_oe>K
;OliR3Go<V0bod];BooKfm_oinOW0=cojNWY00Koj>SXonKVi_mkNg_o71`LonCTi?oXj>P2onWYj@03
onOWiooYjNWojNWY00_ojNWY00coinOWonWYjOoYjNWoj>SXomSHf?l:2P[o[Zj^omgMgOoNg]koh>3P
onGUiOoXj>P8onWYj@06onSXj?oVi^Kohn?Son?ShooVi^Koj>SX0ooYjNT00ooXj>SojNWYonWYj@04
onWYj@03onOWiooYjNWojNWY013ojNWY00?oj>SXonWYjOoYjNT0oooYjNT9onWYj@03onSXj?oYjNWo
jNWY00CojNWY0Oo`l?01ooOgm`7oo_kn00001Oono_kon_[jooCdm?o_knoolO7a00;ol?3`017okno_
on_[jonEU9CoCb<SoiEDE?nkLg?odiFEomZLW?oJWYcofIbLomBEUOnkLg?oUEADodlS8onEU9Coj^[Z
ono_k`05oo3`l00Aono_kooZj^[oZIBDoh4S8onjJUCoe9YconBlUOoZaicojLNLon[7W?oU_9Goe9Yc
ok]ZE?n18b?oZYBDon[Zj_o_knl01Oo`l?004Oo_knooj^[ZoiBDU?lS:R?oE7YDog>ULonNaYGo[<jL
ojg>W?n/cYcoW/JEog>ULomDNUCo8bXSoiBDU?oZj^[okno_0=col?3`0_o_knl01?n0P83o7AdMonk^
k_o_knlCoo3`l0;okno_00OoI6ATobTY:On1PH7oHf=Soc/k>oo^k^kokno_00Sol?3`00Kokno_onk^
k_mcLg?oJFUYonk^k_o_knoooo3`l2kol?3`00ColO7aoo3`l?odm?Con_[j0Oono_h00004oo_knooo
ooooooooooknoP;ooooo0_ono_h0ooomoOgon?Shofi^K_mJ?coo/I2@omk9bOo`i>ColnKVoo3Ti?oN
bLWo/I2@oeXo?om]KFgon?Shooclo?ooooooo_knooooooono_koooonookno_ooooooo?clooShn?n=
KFgoRSloolVAT?oYd<Wom>WTooK[i_odjNCojM39olVAT?n9?cooSFe]ooShmoolo?coooooookno_oo
ooooo_knooooooono_koooonooclo?ohn?SoKFe]oclo?on@WI3obMG9onC/i?oVk^Koi>cTolWEbOn@
WI3o?cloofe]KOohn?Soo?clooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooooknoP006Oooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooool00_ono_h0ooo?clooYZJUoogmoOooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koo_kmol30
`?maLG7oP820ok2`/?omoOgoooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knookn
oOo1`L7o_KfmoogmoOooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooooknoP00F?ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_h2ooooo`03ookno_oooooooooo00?ooooo0Oo/k_000004oo7bloono_konOWiooCdm0Go
lO7a00gokno_omKFe_m[Jf_o@cdmoi^<S?o6^[[oe/c<olNj^_nKS8co@cdmof][JooFe]Kokno_00Wo
lO7a00gokno_omOFe_n3Jf_oM3dmokF<S?oE^[[ohLc<omJj^_nfS8coLSdmoh5[JooGe]Kokno_00Wo
lO7a00gokno_omKFe_m[Jf_o?Cdmohb<S?nj^[[oc<g<okZj^_n<S8co?Cdmof][JooFe]Kokno_0?oo
lO7aoooalO4foo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_ono_h00Oo2bM000005
on?UioomoOgon?Shoo3`l?o[jn/00ooZj^X03OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9
obHV9_mIFEWoVi^KonSXj?oYjNT02ooZj^X02ooYjNWoj>SXoj2KVomZFEWo@bHVobd92Om29RKoJEUI
oj2KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SX
onWYj@3oon[ZjRkoj^[Z00?ojNWYon[Zj_oZj^X0oooZj^X=on[ZjP04on_[joo`l?3omoOgoogmo@7o
QYBQ00001?nXZZgoko3aoo[jn_odm?@8oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;o
l?3`3ooalO42oo3`l0?okno_0_o`l?3ooo7alOoolO7a??oalO400oo`l?3olO7aoo7al@02oo7al@03
ooGemOojn_[o^/;:007o>d]I00000onY[:oo[k6conk_l03oooooooooooooO_ooool1ok_3b@7oD5m]
0OlT>DP00006ol?6b_n/[[7oYJRZom[Lg_o`l_?on__kooooooooooooogSooooo00Gok>k_ol78c_n5
T9_o>4QEob8gB@01obU0D000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{642, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell["Color Chooser With Default Color", "Text"],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell["\<\
JColorChooser is a handy tool to select a color. This component is \
easily added to the pane on the frame.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(JavaShow[frame]\), "\[IndentingNewLine]", 
    \(ch = NewJColorChooser[pane]\), "\[IndentingNewLine]", 
    \(pane@repaint[]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JColorChooser"] \[RightGuillemet]\),
      JLink`Objects`JavaObject100592026386433]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[
    \(DeleteJObject[pane, ch]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:90001jb000`400?l00000o`00003oo`00003o
000008/0000000000`28`;P0B92804R@R03o04R@R?l0B928Q`18T8P10000000000<0R<2h0<SPf028
`;P0o`28`;So08S0^8H0R<2h0@18T8P10000000000<0R<2h0<SPf028`;P0o`28`;So08S0^8H0R<2h
0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c8<0c<c<0P28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;So0<c<c?l0c<c<P`3<c<`208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^080c<c<o`2IVIWo09VIVGl0VIVI0P3<c<`208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0o`3<c<co0<c<c7/0c<c<00<0VIVI0<c<c03<c<`0
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20<c<c00309VIV@3<c<`0c<c<0?l0c<c<
o`3<c<ak0<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h
0P3<c<`00`2IVIT0c<c<0<c<c03o0<c<c?l0c<c<N`3<c<`00`2IVIT0c<c<0<c<c00208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0o`3<c<co0<c<c7/0c<c<
00<0VIVI0<c<c03<c<`00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20<c<c00309VI
V@3<c<`0c<c<0?l0c<c<o`3<c<ak0<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P10000000000@0
R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c03Y0<c<c<P0oooob03<c<`00`2IVIT0c<c<
0<c<c00208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0
j@3<c<c80?ooolP0c<c<00<0VIVI0<c<c03<c<`00P28`;P104R@R040000000001028`;P0b>3H08S0
^028`;P20<c<c00309VIV@3<c<`0c<c<0>T0c<c<1@3oool30?o800L0oooo0`3ob00:0?ooo`<0olP0
1`3oool00`3ob000oooo0?ooo`020?ooo`80olP0203oool20?o800d0oooo00<0olP00?ooo`3oool0
0`3oool20?o800L0oooo00<0olP00?ooo`3oool0103oool00`3ob000oooo0?ooo`0;0?ooo`<0olP0
1`3oool30?o800X0oooo0`3ob0070?ooo`030?o8003oool0oooo0080oooo0P3ob0080?ooo`80olP0
3@3oool00`3ob000oooo0?ooo`030?ooo`80olP01`3oool00`3ob000oooo0?ooo`040?ooo`030?o8
003oool0oooo00P0oooob03<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0j@3<c<`80?ooo`030?o8003oool0oooo00L0oooo
0P3ob00;0?ooo`80olP01P3oool01`3ob000oooo0?ooo`3oool0olP00?ooo`3ob0002@3oool00`3o
b000oooo0?ooo`0:0?ooo`030?o8003oool0oooo00D0oooo00<0olP00?ooo`3oool00`3oool00`3o
b000oooo0?ooo`050?ooo`030?o8003oool0oooo00h0oooo00<0olP00?ooo`3oool01`3oool20?o8
00/0oooo0P3ob0060?ooo`070?o8003oool0oooo0?ooo`3ob000oooo0?o800090?ooo`030?o8003o
ool0oooo00X0oooo00<0olP00?ooo`3oool01@3oool00`3ob000oooo0?ooo`030?ooo`030?o8003o
ool0oooo00D0oooo00<0olP00?ooo`3oool0203oooo80<c<c00309VIV@3<c<`0c<c<0080R<2h0@18
T8P10000000000@0R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c03Y0<c<c0T0oooo00<0
olP00?ooo`3oool0203oool00`3ob000oooo0?ooo`0:0?ooo`030?o8003oool0oooo00<0oooo00D0
olP00?ooo`3oool0oooo0?o800020?ooo`030?o8003oool0oooo00L0oooo00<0olP00?ooo`3oool0
2@3oool00`3ob000oooo0?ooo`060?ooo`050?o8003oool0oooo0?ooo`3ob000203oool00`3ob000
oooo0?ooo`0?0?ooo`030?o8003oool0oooo00P0oooo00<0olP00?ooo`3oool02P3oool00`3ob000
oooo0?ooo`030?ooo`050?o8003oool0oooo0?ooo`3ob0000P3oool00`3ob000oooo0?ooo`070?oo
o`030?o8003oool0oooo00T0oooo00<0olP00?ooo`3oool01P3oool01@3ob000oooo0?ooo`3oool0
olP000P0oooo00<0olP00?ooo`3oool0203oooo80<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P1
0000000000@0R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c02?0<c<c1T0olP01@3<c<`I
0?ooo`D0c<c<6@0000050<c<c0T0oooo00<0olP00?ooo`3oool02@3oool00`3ob000oooo0?ooo`0:
0?ooo`030?o8003oool0oooo00<0oooo00@0olP00?ooo`3oool0olP00`3oool00`3ob000oooo0?oo
o`060?ooo`030?o8003oool0oooo00T0oooo00<0olP00?ooo`3oool01`3oool00`3ob000oooo0?o8
00090?ooo`030?o8003oool0oooo00l0oooo00<0olP00?ooo`3oool02@3oool00`3ob000oooo0?oo
o`0:0?ooo`030?o8003oool0oooo00<0oooo00@0olP00?ooo`3oool0olP00`3oool00`3ob000oooo
0?ooo`060?ooo`030?o8003oool0oooo00T0oooo00<0olP00?ooo`3oool01`3oool00`3ob000oooo
0?o800090?ooo`030?o8003oool0oooo00P0oooob03<c<`00`2IVIT0c<c<0<c<c00208S0^040B928
0@000000000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0S`3<c<`I0?o800D0c<c<
6@3oool50<c<c1T000001@3<c<`40?ooo`030?o8003oool0oooo0080oooo00<0olP00?ooo`3oool0
2P3oool00`3ob000oooo0?ooo`090?ooo`030?o8003oool0oooo00<0oooo00@0olP00?ooo`3oool0
olP0103oool00`3ob000oooo0?ooo`050?ooo`030?o8003oool0oooo00<0oooo2`3ob0060?ooo`03
0?o8003oool0oooo00P0oooo00<0olP00?ooo`3oool02P3oool00`3ob000oooo0?ooo`020?ooo`03
0?o8003oool0oooo00X0oooo00<0olP00?ooo`3oool02@3oool00`3ob000oooo0?ooo`030?ooo`04
0?o8003oool0oooo0?o800@0oooo00<0olP00?ooo`3oool01@3oool00`3ob000oooo0?ooo`030?oo
o`/0olP01P3oool00`3ob000oooo0?ooo`080?ooo`030?o8003oool0oooo00P0oooo1@3<c<`b0?o8
0940c<c<00<0VIVI0<c<c03<c<`00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20<c<
c00309VIV@3<c<`0c<c<08l0c<c<6@3ob0050<c<c1T0oooo1@3<c<`I000000D0c<c<103oool00`3o
b000oooo0?ooo`020?ooo`030?o8003oool0oooo00/0oooo00<0olP00?ooo`3oool02@3oool00`3o
b000oooo0?ooo`020?ooo`040?o8003oool0oooo0?o800@0oooo00<0olP00?ooo`3oool01@3oool0
0`3ob000oooo0?ooo`080?ooo`030?o8003oool0oooo00X0oooo00<0olP00?ooo`3oool01`3oool0
0`3ob000oooo0?ooo`020?o800P0oooo00<0olP00?ooo`3oool00P3oool00`3ob000oooo0?ooo`0;
0?ooo`030?o8003oool0oooo00T0oooo00<0olP00?ooo`3oool00P3oool0103ob000oooo0?ooo`3o
b0040?ooo`030?o8003oool0oooo00D0oooo00<0olP00?ooo`3oool0203oool00`3ob000oooo0?oo
o`0:0?ooo`030?o8003oool0oooo00L0oooo00<0olP00?ooo`3oool00P3ob0060?ooo`D0c<c<<P3o
b02A0<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P3<
c<`00`2IVIT0c<c<0<c<c02?0<c<c1T0olP01@3<c<`I0?ooo`D0c<c<6@0000050<c<c0@0oooo00<0
olP00?ooo`3oool00P3oool00`3ob000oooo0?ooo`0;0?ooo`030?o8003oool0oooo00T0oooo00<0
olP00?ooo`3oool00P3oool0103ob000oooo0?ooo`3ob0070?ooo`X0olP01P3oool00`3ob000oooo
0?ooo`0:0?ooo`030?o8003oool0oooo00L0oooo0`3ob00:0?ooo`030?o8003oool0oooo0080oooo
00<0olP00?ooo`3oool02`3oool00`3ob000oooo0?ooo`090?ooo`030?o8003oool0oooo0080oooo
00@0olP00?ooo`3oool0olP01`3oool:0?o800H0oooo00<0olP00?ooo`3oool02P3oool00`3ob000
oooo0?ooo`070?ooo`<0olP0203oool50<c<c380olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0S`3<c<`I0?o800D0
c<c<6@3oool50<c<c1T000001@3<c<`20?ooo`/0olP02P3oool0103ob000oooo0?ooo`3oool90?o8
00@0oooo00@0olP00?ooo`3oool0olP04`3oool90?o800T0oooo00<0olP00?ooo`3oool01P3oool0
0`3ob000oooo0?ooo`080?ooo`/0olP02P3oool0103ob000oooo0?ooo`3oool90?o800@0oooo00@0
olP00?ooo`3oool0olP04`3oool90?o800T0oooo00<0olP00?ooo`3oool01P3oool00`3ob000oooo
0?ooo`080?ooo`D0c<c<<P3ob02A0<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P10000000000@0
R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c02?0<c<c1T0olP01@3<c<`50?ooo`l0olP0
1@3oool50<c<c0D000003`3ob005000000D0c<c<103oool00`3ob000oooo0?ooo`020?ooo`030?o8
003oool0oooo00D0oooo00<0olP00?ooo`3oool03`3oool00`3ob000oooo0?ooo`020?ooo`040?o8
003oool0oooo0?o801L0oooo00<0olP00?ooo`3oool02`3oool00`3ob000oooo0?ooo`060?ooo`03
0?o8003oool0oooo00X0oooo00<0olP00?ooo`3oool00P3oool00`3ob000oooo0?ooo`050?ooo`03
0?o8003oool0oooo00l0oooo00<0olP00?ooo`3oool00P3oool0103ob000oooo0?ooo`3ob00G0?oo
o`030?o8003oool0oooo00/0oooo00<0olP00?ooo`3oool01P3oool00`3ob000oooo0?ooo`080?oo
o`D0c<c<<P3ob02A0<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P10000000000@0R<2h0<SPf028
`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c02?0<c<c1T0olP01@3<c<`50?ooo`l0olP01@3oool50<c<
c0D000003`3ob005000000D0c<c<103oool00`3ob000oooo0?ooo`020?ooo`030?o8003oool0oooo
00<0oooo0P3ob00A0?ooo`030?o8003oool0olP000H0oooo00<0olP00?ooo`3oool01P3oool80?o8
00L0oooo00<0olP00?ooo`3oool01@3oool70?o800P0oooo00<0olP00?ooo`3oool02P3oool00`3o
b000oooo0?ooo`020?ooo`030?o8003oool0oooo00<0oooo0P3ob00A0?ooo`030?o8003oool0olP0
00H0oooo00<0olP00?ooo`3oool01P3oool80?o800L0oooo00<0olP00?ooo`3oool01@3oool70?o8
00P0oooo00<0olP00?ooo`3oool0203oool50<c<c380olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0S`3<c<`I0?o8
00D0c<c<1@3oool?0?o800D0oooo1@3<c<`5000000l0olP01@0000050<c<c2<0oooo00<0olP00?oo
o`3oool07@3oool00`3ob000oooo0?ooo`0D0?ooo`030?o8003oool0oooo02T0oooo00<0olP00?oo
o`3oool07@3oool00`3ob000oooo0?ooo`0D0?ooo`030?o8003oool0oooo00P0oooo1@3<c<`b0?o8
0940c<c<00<0VIVI0<c<c03<c<`00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20<c<
c00309VIV@3<c<`0c<c<08l0c<c<6@3ob0050<c<c0D0oooo3`3ob0050?ooo`D0c<c<1@00000?0?o8
00D000001@3<c<c80?ooo`D0c<c<<P3ob02A0<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c02?0<c<c1T0olP01@3<c<`50?oo
o`l0olP01@3oool50<c<c0D000003`3ob005000000D0c<c<b03oool50<c<c380olP0T@3<c<`00`2I
VIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<
c03<c<`0S`3<c<`I0?o800D0c<c<1@3oool?0?o800D0oooo1@3<c<`5000000l0olP01@0000050<c<
c<P0oooo1@3<c<`b0?o80940c<c<00<0VIVI0<c<c03<c<`00P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;P20<c<c00309VIV@3<c<`0c<c<08l0c<c<6@3ob0050<c<c0D0oooo3`3ob0050?oo
o`D0c<c<1@00000?0?o800D000001@3<c<c80?ooo`D0c<c<<P3ob02A0<c<c00309VIV@3<c<`0c<c<
0080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c02?0<c<
c1T0olP01@3<c<`50?ooo`l0olP01@3oool50<c<c0D000003`3ob005000000D0c<c<b03oool50<c<
c380olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^080c<c<00<0VIVI0<c<c03<c<`0S`3<c<`I0?o800D0c<c<1@3oool?0?o800D0oooo1@3<c<`50000
00l0olP01@00003B0<c<c380olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0S`3<c<`I0?o800D0c<c<1@3oool?0?o8
00D0oooo1@3<c<`5000000l0olP01@00003B0<c<c380olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0S`3<c<`I0?o8
00D0c<c<1@3oool?0?o800D0oooo1@3<c<`5000000l0olP01@00003B0<c<c380olP0T@3<c<`00`2I
VIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<
c03<c<`0S`3<c<`I0?o800D0c<c<1@3oool?0?o800D0oooo1@3<c<`5000000l0olP01@0000050<c<
c<P0olP01@3<c<`b0?o80940c<c<00<0VIVI0<c<c03<c<`00P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;P20<c<c00309VIV@3<c<`0c<c<08l0c<c<6@3ob0050<c<c0D0oooo3`3ob0050?oo
o`D0c<c<1@00000?0?o800D000001@3<c<c80?o800D0c<c<<P3ob02A0<c<c00309VIV@3<c<`0c<c<
0080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c02?0<c<
c1T0olP01@3<c<`50?ooo`l0olP01@3oool50<c<c0D000003`3ob005000000D0c<c<1@3ob0030000
00L0olP00`00000:0?o800<000001`3ob0000`000000olP00?o800020?o800800000203ob0020000
00d0olP000<000000?o8003ob0000`3ob002000000L0olP000<000000?o8003ob000103ob0000`00
0000olP00?o8000;0?o800<000001`3ob003000000X0olP00`0000070?o800030000003ob000olP0
0080olP00P0000080?o8008000003@3ob0000`000000olP00?o800030?o8008000001`3ob0000`00
0000olP00?o800040?o800030000003ob000olP000P0olP01@3<c<`b0?o80940c<c<00<0VIVI0<c<
c03<c<`00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20<c<c00309VIV@3<c<`0c<c<
08l0c<c<6@3ob0050<c<c0D0oooo3`3ob0050?ooo`D0c<c<1@00000?0?o800D000001@3<c<`80?o8
00030000003ob000olP000L0olP00P00000;0?o8008000001P3ob0001`000000olP00?o8003ob000
00000?o8000000002@3ob0000`000000olP00?o8000:0?o800030000003ob000olP000D0olP000<0
00000?o8003ob0000`3ob0000`000000olP00?o800050?o800030000003ob000olP000h0olP000<0
00000?o8003ob0001`3ob002000000/0olP00P0000060?o800070000003ob000olP00?o800000000
olP0000000090?o800030000003ob000olP000X0olP000<000000?o8003ob0001@3ob0000`000000
olP00?o800030?o800030000003ob000olP000D0olP000<000000?o8003ob000203ob0050<c<c380
olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080
c<c<00<0VIVI0<c<c03<c<`0S`3<c<`I0?o800D0c<c<6@3oool50<c<c1T000001@3<c<`90?o80003
0000003ob000olP000P0olP000<000000?o8003ob0002P3ob0000`000000olP00?o800030?o80005
0000003ob000olP00?o8000000000P3ob0000`000000olP00?o800070?o800030000003ob000olP0
00T0olP000<000000?o8003ob0001P3ob0001@000000olP00?o8003ob000000000P0olP000<00000
0?o8003ob0003`3ob0000`000000olP00?o800080?o800030000003ob000olP000X0olP000<00000
0?o8003ob0000`3ob0001@000000olP00?o8003ob00000000080olP000<000000?o8003ob0001`3o
b0000`000000olP00?o800090?o800030000003ob000olP000H0olP000D000000?o8003ob000olP0
000000080?o800030000003ob000olP000P0olP01@3<c<`b0?o80940c<c<00<0VIVI0<c<c03<c<`0
0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20<c<c00309VIV@3<c<`0c<c<08l0c<c<
6@3ob0050<c<c1T0oooo1@3<c<`I000000D0c<c<2@3ob0000`000000olP00?o800090?o800030000
003ob000olP000X0olP000<000000?o8003ob0000`3ob00010000000olP00?o8000000030?o80003
0000003ob000olP000H0olP000<000000?o8003ob0002@3ob0000`000000olP00?o800070?o80003
0000003ob000000000T0olP000<000000?o8003ob0003`3ob0000`000000olP00?o800090?o80003
0000003ob000olP000X0olP000<000000?o8003ob0000`3ob00010000000olP00?o8000000030?o8
00030000003ob000olP000H0olP000<000000?o8003ob0002@3ob0000`000000olP00?o800070?o8
00030000003ob000000000T0olP000<000000?o8003ob000203ob0050<c<c380olP0T@3<c<`00`2I
VIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<
c03<c<`0S`3<c<`I0?o800D0c<c<6@3oool50<c<c1T000001@3<c<`40?o800030000003ob000olP0
0080olP000<000000?o8003ob0002P3ob0000`000000olP00?o800090?o800030000003ob000olP0
00<0olP000@000000?o8003ob0000000103ob0000`000000olP00?o800050?o800030000003ob000
olP000<0olP02`0000060?o800030000003ob000olP000P0olP000<000000?o8003ob0002P3ob000
0`000000olP00?o800020?o800030000003ob000olP000X0olP000<000000?o8003ob0002@3ob000
0`000000olP00?o800030?o800040000003ob000olP0000000@0olP000<000000?o8003ob0001@3o
b0000`000000olP00?o800030?o800/000001P3ob0000`000000olP00?o800080?o800030000003o
b000olP000P0olP01@3<c<`b0?o80940c<c<00<0VIVI0<c<c03<c<`00P28`;P104R@R04000000000
1028`;P0b>3H08S0^028`;P20<c<c00309VIV@3<c<`0c<c<08l0c<c<6@3ob0050<c<c1T0oooo1@3<
c<`I000000D0c<c<103ob0000`000000olP00?o800020?o800030000003ob000olP000/0olP000<0
00000?o8003ob0002@3ob0000`000000olP00?o800020?o800040000003ob000olP0000000@0olP0
00<000000?o8003ob0001@3ob0000`000000olP00?o800080?o800030000003ob000olP000X0olP0
00<000000?o8003ob0001`3ob0000`000000olP00?o80002000000P0olP000<000000?o8003ob000
0P3ob0000`000000olP00?o8000;0?o800030000003ob000olP000T0olP000<000000?o8003ob000
0P3ob00010000000olP00?o8000000040?o800030000003ob000olP000D0olP000<000000?o8003o
b000203ob0000`000000olP00?o8000:0?o800030000003ob000olP000L0olP000<000000?o8003o
b0000P0000060?o800D0c<c<<P3ob02A0<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P100000000
00@0R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c02?0<c<c1T0olP01@3<c<`I0?ooo`D0
c<c<6@0000050<c<c0@0olP000<000000?o8003ob0000P3ob0000`000000olP00?o8000;0?o80003
0000003ob000olP000T0olP000<000000?o8003ob0000P3ob00010000000olP00?o8000000070?o8
00X000001P3ob0000`000000olP00?o8000:0?o800030000003ob000olP000L0olP00`00000:0?o8
00030000003ob000olP00080olP000<000000?o8003ob0002`3ob0000`000000olP00?o800090?o8
00030000003ob000olP00080olP000@000000?o8003ob00000001`3ob00:000000H0olP000<00000
0?o8003ob0002P3ob0000`000000olP00?o800070?o800<00000203ob0050<c<c380olP0T@3<c<`0
0`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI
0<c<c03<c<`0j@3<c<`20?o800/000002P3ob00010000000olP00?o8003ob009000000@0olP000@0
00000?o8003ob00000004`3ob009000000T0olP000<000000?o8003ob0001P3ob0000`000000olP0
0?o800080?o800/000002P3ob00010000000olP00?o8003ob009000000@0olP000@000000?o8003o
b00000004`3ob009000000T0olP000<000000?o8003ob0001P3ob0000`000000olP00?o800080?o8
00D0c<c<<P3ob02A0<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P10000000000@0R<2h0<SPf028
`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c03Y0<c<c0@0olP000<000000?o8003ob0000P3ob0000`00
0000olP00?o800050?o800030000003ob000olP000l0olP000<000000?o8003ob0000P3ob0001000
0000olP00?o80000000G0?o800030000003ob000olP000/0olP000<000000?o8003ob0001P3ob000
0`000000olP00?o8000:0?o800030000003ob000olP00080olP000<000000?o8003ob0001@3ob000
0`000000olP00?o8000?0?o800030000003ob000olP00080olP000@000000?o8003ob00000005`3o
b0000`000000olP00?o8000;0?o800030000003ob000olP000H0olP000<000000?o8003ob000203o
b0050<c<c380olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0
R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0j@3<c<`40?o800030000003ob000olP00080olP000<0
00000?o8003ob0000`3ob00200000140olP000<000000?o8000000001P3ob0000`000000olP00?o8
00060?o800P000001`3ob0000`000000olP00?o800050?o800L00000203ob0000`000000olP00?o8
000:0?o800030000003ob000olP00080olP000<000000?o8003ob0000`3ob00200000140olP000<0
00000?o8000000001P3ob0000`000000olP00?o800060?o800P000001`3ob0000`000000olP00?o8
00050?o800L00000203ob0000`000000olP00?o800080?o800D0c<c<<P3ob02A0<c<c00309VIV@3<
c<`0c<c<0080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<
c03Y0<c<c2<0olP000<000000?o8003ob0007@3ob0000`000000olP00?o8000D0?o800030000003o
b000olP002T0olP000<000000?o8003ob0007@3ob0000`000000olP00?o8000D0?o800030000003o
b000olP000P0olP01@3<c<`b0?o80940c<c<00<0VIVI0<c<c03<c<`00P28`;P104R@R04000000000
1028`;P0b>3H08S0^028`;P20<c<c00309VIV@3<c<`0c<c<0>T0c<c<b03ob0050<c<c380olP0T@3<
c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080c<c<00<0
VIVI0<c<c03<c<`0S`3<c<`I0?ooo`D0c<c<6@0000050<c<c1T0oooo1@3<c<c80?o800D0c<c<<P3o
b02A0<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P3<
c<`00`2IVIT0c<c<0<c<c02?0<c<c1T0oooo1@3<c<`I000000D0c<c<6@3oool50<c<c<P0olP01@3<
c<`b0?o80940c<c<00<0VIVI0<c<c03<c<`00P28`;P104R@R040000000001028`;P0b>3H08S0^028
`;P20<c<c00309VIV@3<c<`0c<c<08l0c<c<6@3oool50<c<c1T000001@3<c<`I0?ooo`D0c<c<b03o
b0050<c<c380olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0
R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0S`3<c<`I0?ooo`D0c<c<6@0000050<c<c1T0oooo1@3<
c<c80?o800D0c<c<<P3ob02A0<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P10000000000@0R<2h
0<SPf028`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c02?0<c<c1T0oooo1@3<c<`I000000D0c<c<6@3o
oooB0<c<c380olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0
R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0S`3<c<`50?ooo`l0olP01@3oool50<c<c0D000003`3o
b005000000D0c<c<1@3oool?0?o800D0oooodP3<c<`b0?o80940c<c<00<0VIVI0<c<c03<c<`00P28
`;P104R@R040000000001028`;P0b>3H08S0^028`;P20<c<c00309VIV@3<c<`0c<c<08l0c<c<1@3o
ool?0?o800D0oooo1@3<c<`5000000l0olP01@0000050<c<c0D0oooo3`3ob0050?ooom80c<c<<P3o
b02A0<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P3<
c<`00`2IVIT0c<c<0<c<c02?0<c<c0D0oooo3`3ob0050?ooo`D0c<c<1@00000?0?o800D000001@3<
c<`50?ooo`l0olP01@3ooooB0<c<c380olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@00
0000000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0S`3<c<`50?ooo`l0olP01@3o
ool50<c<c0D000003`3ob005000000D0c<c<1@3oool?0?o800D0oooodP3<c<`b0?o80940c<c<00<0
VIVI0<c<c03<c<`00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20<c<c00309VIV@3<
c<`0c<c<08l0c<c<1@3oool?0?o800D0oooo1@3<c<`5000000l0olP01@0000050<c<c0D0oooo3`3o
b0050?ooo`X0c<c<0`3ob0070<c<c0<0olP02P3<c<`30?o800L0c<c<00<0olP00<c<c03<c<`00P3<
c<`20?o800P0c<c<0P3ob00=0<c<c0030?o8003<c<`0c<c<00<0c<c<0P3ob0070<c<c0030?o8003<
c<`0c<c<00@0c<c<00<0olP00<c<c03<c<`02`3<c<`30?o800L0c<c<0`3ob00:0<c<c0<0olP01`3<
c<`00`3ob000c<c<0<c<c0020<c<c080olP0203<c<`20?o800d0c<c<00<0olP00<c<c03<c<`00`3<
c<`20?o800L0c<c<00<0olP00<c<c03<c<`0103<c<`00`3ob000c<c<0<c<c00=0<c<c380olP0T@3<
c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080c<c<00<0
VIVI0<c<c03<c<`0S`3<c<`50?ooo`D0olP01@3oool50?o800D0oooo1@3<c<`5000000D0olP01@3o
ool50?o800D000001@3<c<`50?ooo`D0olP01@0000050?o800D0oooo3@3<c<`00`3ob000c<c<0<c<
c0070<c<c080olP02`3<c<`20?o800H0c<c<00L0olP00<c<c03<c<`0c<c<0?o8003<c<`0olP000T0
c<c<00<0olP00<c<c03<c<`02P3<c<`00`3ob000c<c<0<c<c0050<c<c0030?o8003<c<`0c<c<00<0
c<c<00<0olP00<c<c03<c<`01@3<c<`00`3ob000c<c<0<c<c00>0<c<c0030?o8003<c<`0c<c<00L0
c<c<0P3ob00;0<c<c080olP01P3<c<`01`3ob000c<c<0<c<c03<c<`0olP00<c<c03ob0002@3<c<`0
0`3ob000c<c<0<c<c00:0<c<c0030?o8003<c<`0c<c<00D0c<c<00<0olP00<c<c03<c<`00`3<c<`0
0`3ob000c<c<0<c<c0050<c<c0030?o8003<c<`0c<c<00d0c<c<<P3ob02A0<c<c00309VIV@3<c<`0
c<c<0080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c02?
0<c<c0D0oooo1@3ob0050?ooo`D0olP01@3oool50<c<c0D000001@3ob0050?ooo`D0olP01@000005
0<c<c0D0oooo1@3ob005000000D0olP01@3oool>0<c<c0030?o8003<c<`0c<c<00P0c<c<00<0olP0
0<c<c03<c<`02P3<c<`00`3ob000c<c<0<c<c0030<c<c0050?o8003<c<`0c<c<0<c<c03ob0000P3<
c<`00`3ob000c<c<0<c<c0070<c<c0030?o8003<c<`0c<c<00T0c<c<00<0olP00<c<c03<c<`01P3<
c<`01@3ob000c<c<0<c<c03<c<`0olP000P0c<c<00<0olP00<c<c03<c<`03`3<c<`00`3ob000c<c<
0<c<c0080<c<c0030?o8003<c<`0c<c<00X0c<c<00<0olP00<c<c03<c<`00`3<c<`01@3ob000c<c<
0<c<c03<c<`0olP00080c<c<00<0olP00<c<c03<c<`01`3<c<`00`3ob000c<c<0<c<c0090<c<c003
0?o8003<c<`0c<c<00H0c<c<00D0olP00<c<c03<c<`0c<c<0?o800080<c<c0030?o8003<c<`0c<c<
00d0c<c<<P3ob02A0<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P10000000000@0R<2h0<SPf028
`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c02?0<c<c0D0oooo1@3ob0050?ooo`D0olP01@3oool50<c<
c0D000001@3ob0050?ooo`D0olP01@0000050<c<c0D0oooo1@3ob005000000D0olP01@3oool>0<c<
c0030?o8003<c<`0c<c<00T0c<c<00<0olP00<c<c03<c<`02P3<c<`00`3ob000c<c<0<c<c0030<c<
c0040?o8003<c<`0c<c<0?o800<0c<c<00<0olP00<c<c03<c<`01P3<c<`00`3ob000c<c<0<c<c009
0<c<c0030?o8003<c<`0c<c<00L0c<c<00<0olP00<c<c03ob0002@3<c<`00`3ob000c<c<0<c<c00?
0<c<c0030?o8003<c<`0c<c<00T0c<c<00<0olP00<c<c03<c<`02P3<c<`00`3ob000c<c<0<c<c003
0<c<c0040?o8003<c<`0c<c<0?o800<0c<c<00<0olP00<c<c03<c<`01P3<c<`00`3ob000c<c<0<c<
c0090<c<c0030?o8003<c<`0c<c<00L0c<c<00<0olP00<c<c03ob0002@3<c<`00`3ob000c<c<0<c<
c00=0<c<c380olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0
R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0S`3<c<`50?ooo`D0olP01@3oool50?o800D0oooo1@3<
c<`5000000D0olP01@3oool50?o800D000001@3<c<`50?ooo`D0olP01@0000050?o800D0oooo2@3<
c<`00`3ob000c<c<0<c<c0020<c<c0030?o8003<c<`0c<c<00X0c<c<00<0olP00<c<c03<c<`02@3<
c<`00`3ob000c<c<0<c<c0030<c<c0040?o8003<c<`0c<c<0?o800@0c<c<00<0olP00<c<c03<c<`0
1@3<c<`00`3ob000c<c<0<c<c0030<c<c0/0olP01P3<c<`00`3ob000c<c<0<c<c0080<c<c0030?o8
003<c<`0c<c<00X0c<c<00<0olP00<c<c03<c<`00P3<c<`00`3ob000c<c<0<c<c00:0<c<c0030?o8
003<c<`0c<c<00T0c<c<00<0olP00<c<c03<c<`00`3<c<`0103ob000c<c<0<c<c03ob0040<c<c003
0?o8003<c<`0c<c<00D0c<c<00<0olP00<c<c03<c<`00`3<c<`;0?o800H0c<c<00<0olP00<c<c03<
c<`0203<c<`00`3ob000c<c<0<c<c00=0<c<c380olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0S`3<c<`50?ooo`D0
olP01@3oool50?o800D0oooo1@3<c<`5000000D0olP01@3oool50?o800D000001@3<c<`50?ooo`D0
olP01@0000050?o800D0oooo2@3<c<`00`3ob000c<c<0<c<c0020<c<c0030?o8003<c<`0c<c<00/0
c<c<00<0olP00<c<c03<c<`02@3<c<`00`3ob000c<c<0<c<c0020<c<c0040?o8003<c<`0c<c<0?o8
00@0c<c<00<0olP00<c<c03<c<`01@3<c<`00`3ob000c<c<0<c<c0080<c<c0030?o8003<c<`0c<c<
00X0c<c<00<0olP00<c<c03<c<`01`3<c<`00`3ob000c<c<0<c<c0020?o800P0c<c<00<0olP00<c<
c03<c<`00P3<c<`00`3ob000c<c<0<c<c00;0<c<c0030?o8003<c<`0c<c<00T0c<c<00<0olP00<c<
c03<c<`00P3<c<`0103ob000c<c<0<c<c03ob0040<c<c0030?o8003<c<`0c<c<00D0c<c<00<0olP0
0<c<c03<c<`0203<c<`00`3ob000c<c<0<c<c00:0<c<c0030?o8003<c<`0c<c<00L0c<c<00<0olP0
0<c<c03<c<`00P3ob00;0<c<c380olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000
000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0S`3<c<`50?ooo`l0olP01@3oool5
0<c<c0D000003`3ob005000000D0c<c<1@3oool?0?o800D0oooo2@3<c<`00`3ob000c<c<0<c<c002
0<c<c0030?o8003<c<`0c<c<00/0c<c<00<0olP00<c<c03<c<`02@3<c<`00`3ob000c<c<0<c<c002
0<c<c0040?o8003<c<`0c<c<0?o800L0c<c<2P3ob0060<c<c0030?o8003<c<`0c<c<00X0c<c<00<0
olP00<c<c03<c<`01`3<c<`30?o800X0c<c<00<0olP00<c<c03<c<`00P3<c<`00`3ob000c<c<0<c<
c00;0<c<c0030?o8003<c<`0c<c<00T0c<c<00<0olP00<c<c03<c<`00P3<c<`0103ob000c<c<0<c<
c03ob0070<c<c0X0olP01P3<c<`00`3ob000c<c<0<c<c00:0<c<c0030?o8003<c<`0c<c<00L0c<c<
0`3ob00=0<c<c380olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038
h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0S`3<c<`50?ooo`l0olP01@3oool50<c<c0D00000
3`3ob005000000D0c<c<1@3oool?0?o800D0oooo1`3<c<`;0?o800X0c<c<00@0olP00<c<c03<c<`0
c<c<2@3ob0040<c<c0040?o8003<c<`0c<c<0?o801<0c<c<2@3ob0090<c<c0030?o8003<c<`0c<c<
00H0c<c<00<0olP00<c<c03<c<`0203<c<`;0?o800X0c<c<00@0olP00<c<c03<c<`0c<c<2@3ob004
0<c<c0040?o8003<c<`0c<c<0?o801<0c<c<2@3ob0090<c<c0030?o8003<c<`0c<c<00H0c<c<00<0
olP00<c<c03<c<`03@3<c<`b0?o80940c<c<00<0VIVI0<c<c03<c<`00P28`;P104R@R04000000000
1028`;P0b>3H08S0^028`;P20<c<c00309VIV@3<c<`0c<c<08l0c<c<1@3oool?0?o800D0oooo1@3<
c<`5000000l0olP01@0000050<c<c0D0oooo3`3ob0050?ooo`T0c<c<00<0olP00<c<c03<c<`00P3<
c<`00`3ob000c<c<0<c<c0050<c<c0030?o8003<c<`0c<c<00l0c<c<00<0olP00<c<c03<c<`00P3<
c<`0103ob000c<c<0<c<c03ob00G0<c<c0030?o8003<c<`0c<c<00/0c<c<00<0olP00<c<c03<c<`0
1P3<c<`00`3ob000c<c<0<c<c00:0<c<c0030?o8003<c<`0c<c<0080c<c<00<0olP00<c<c03<c<`0
1@3<c<`00`3ob000c<c<0<c<c00?0<c<c0030?o8003<c<`0c<c<0080c<c<00@0olP00<c<c03<c<`0
olP05`3<c<`00`3ob000c<c<0<c<c00;0<c<c0030?o8003<c<`0c<c<00H0c<c<00<0olP00<c<c03<
c<`03@3<c<`b0?o80940c<c<00<0VIVI0<c<c03<c<`00P28`;P104R@R040000000001028`;P0b>3H
08S0^028`;P20<c<c00309VIV@3<c<`0c<c<08l0c<c<1@3oool?0?o800D0oooo1@3<c<`5000000l0
olP01@0000050<c<c0D0oooo3`3ob0050?ooo`T0c<c<00<0olP00<c<c03<c<`00P3<c<`00`3ob000
c<c<0<c<c0030<c<c080olP04@3<c<`00`3ob000c<c<0?o800060<c<c0030?o8003<c<`0c<c<00H0
c<c<203ob0070<c<c0030?o8003<c<`0c<c<00D0c<c<1`3ob0080<c<c0030?o8003<c<`0c<c<00X0
c<c<00<0olP00<c<c03<c<`00P3<c<`00`3ob000c<c<0<c<c0030<c<c080olP04@3<c<`00`3ob000
c<c<0?o800060<c<c0030?o8003<c<`0c<c<00H0c<c<203ob0070<c<c0030?o8003<c<`0c<c<00D0
c<c<1`3ob0080<c<c0030?o8003<c<`0c<c<00d0c<c<<P3ob02A0<c<c00309VIV@3<c<`0c<c<0080
R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c02?0<c<c0D0
oooo3`3ob0050?ooo`D0c<c<1@00000?0?o800D000001@3<c<`50?ooo`l0olP01@3ooolX0<c<c003
0?o8003<c<`0c<c<01d0c<c<00<0olP00<c<c03<c<`0503<c<`00`3ob000c<c<0<c<c00Y0<c<c003
0?o8003<c<`0c<c<01d0c<c<00<0olP00<c<c03<c<`0503<c<`00`3ob000c<c<0<c<c00=0<c<c380
olP0T@3<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080
c<c<00<0VIVI0<c<c03<c<`0S`3<c<`I0?ooo`D0c<c<6@0000050<c<c1T0oooodP3<c<`b0?o80940
c<c<00<0VIVI0<c<c03<c<`00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20<c<c003
09VIV@3<c<`0c<c<08l0c<c<6@3oool50<c<c1T000001@3<c<`I0?ooom80c<c<<P3ob02A0<c<c003
09VIV@3<c<`0c<c<0080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0
c<c<0<c<c02?0<c<c1T0oooo1@3<c<`I000000D0c<c<6@3ooooB0<c<c380olP0T@3<c<`00`2IVIT0
c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<
c<`0S`3<c<`I0?ooo`D0c<c<6@0000050<c<c1T0oooodP3<c<`b0?o80940c<c<00<0VIVI0<c<c03<
c<`00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20<c<c00309VIV@3<c<`0c<c<08l0
c<c<6@3oool50<c<c1T000001@3<c<`I0?ooom80c<c<<P3ob02A0<c<c00309VIV@3<c<`0c<c<0080
R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c03o0<c<c?l0
c<c<N`3<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080
c<c<00<0VIVI0<c<c03<c<`0o`3<c<co0<c<c7/0c<c<00<0VIVI0<c<c03<c<`00P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;P20<c<c00309VIV@3<c<`0c<c<0?l0c<c<o`3<c<ak0<c<c003
09VIV@3<c<`0c<c<0080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0
c<c<0<c<c03o0<c<c?l0c<c<N`3<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0
^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`0o`3<c<co0<c<c7/0c<c<00<0VIVI0<c<c03<
c<`00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20<c<c00309VIV@3<c<`0c<c<0?l0
c<c<o`3<c<ak0<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0
R<2h0P3<c<`00`2IVIT0c<c<0<c<c03o0<c<c?l0c<c<N`3<c<`00`2IVIT0c<c<0<c<c00208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`01P3<c<`00`000000
c<c<0<c<c03o0<c<c?l0c<c<LP3<c<`00`2IVIT0c<c<0<c<c00208S0^040B9280@000000000408S0
^038h=P0R<2h08S0^080c<c<00<0VIVI0<c<c03<c<`01P3<c<`4000000T0c<c<100000080<c<c0P0
0000103<c<`900000?l0c<c<o`3<c<a70<c<c00309VIV@3<c<`0c<c<0080R<2h0@18T8P100000000
00@0R<2h0<SPf028`;P0R<2h0P3<c<`00`2IVIT0c<c<0<c<c0080<c<c0<00000203<c<`200000004
0<c<c00000000000000000H0c<c<0P00000?0<c<c0800000o`3<c<co0<c<c4T0c<c<00<0VIVI0<c<
c03<c<`00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20<c<c00309VIV@3<c<`0c<c<
00X0c<c<0P0000070<c<c08000000`3<c<`2000000D0c<c<0P00000?0<c<c0800000o`3<c<co0<c<
c4T0c<c<00<0VIVI0<c<c03<c<`00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20<c<
c00309VIV@3<c<`0c<c<00/0c<c<0P0000060<c<c0800000103<c<`2000000@0c<c<0P00000?0<c<
c0800000o`3<c<co0<c<c4T0c<c<00<0VIVI0<c<c03<c<`00P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;P20<c<c0D0VIVI2@3<c<`3000000D0c<c<0P0000050<c<c08000000`3<c<`20000
00l0c<c<0P0000050<c<c0/0000000<0c<c<09VIV@2IVIT0o`2IVIWo09VIVCL0VIVI0P3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^140c<c<0P0000050<c<c08000001@3<c<`00`00
0000c<c<0<c<c0020<c<c0P000001@3<c<`600000?l0c<c<o`3<c<a<0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2h4@3<c<`2000000D0c<c<0P00000:0<c<c08000000`3<c<`20000
0?l0c<c<o`3<c<aH0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h2P3<c<`90000
00D0c<c<0P00000:0<c<c0800000103<c<`00`000000c<c<0<c<c03o0<c<c?l0c<c<EP3<c<`208S0
^040B9280@000000000408S0^038h=P0R<2h08S0^140c<c<1000000D0<c<c0@00000o`3<c<co0<c<
c5H0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;PA0<c<c0@00000503<c<`30000
0?l0c<c<o`3<c<aG0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h:P3<c<`00`00
0000c<c<0<c<c03o0<c<c?l0c<c<EP3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^?l0c<c<o`3<c<b30<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<
c8<0c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;So06IVI_l0IVIVP`1VIVH208S0
^040B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<
c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co
0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<
c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03o
ool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038
h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@0000000005
08S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B928
0@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028
`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<
c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co
0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<
c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03o
ool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038
h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@0000000005
08S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B928
0@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028
`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<
c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co
0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<
c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03o
ool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038
h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@0000000005
08S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B928
0@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028
`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<
c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co
0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<
c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03o
ool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038
h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@0000000005
08S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B928
0@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028
`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<
c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co
0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<
c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03o
ool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038
h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@0000000005
08S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B928
0@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028
`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<
c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co
0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<
c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03o
ool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038
h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@0000000005
08S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B928
0@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028
`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<co0000
05T00000]`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`
0<c<c0030000003oool0oooo0?l0ooooE@3oool00`000000c<c<0<c<c02e0<c<c00406IVIP28`;P0
R<2h04R@R040000000001@28`;P0b>3H08S0^028`;P0oooo0700c<c<00<000000?ooo`0000002@00
00000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo0000000000002000
00000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo0000000000002000
00000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo0000000000002000
00000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo0000000000002000
00000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo0000000000002000
00000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo0000000000002000
00000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo0000000000002000
00000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo0000000000002000
00000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo0000000000002000
00000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo0000000000002000
00000`3oool000000<c<c02f0<c<c00406IVIP28`;P0R<2h04R@R040000000001@28`;P0b>3H08S0
^028`;P0oooo0700c<c<00<000000?ooo`0000002@0000000`3oool003<c000c<`07000c<`030000
003oool003<c00P003<c00<000000?ooo`00<c<02000<c<00`000000oooo000c<`08000c<`030000
003oool003<c00P003<c00<000000?ooo`0003<0200003<00`000000oooo03<0<`0803<0<`030000
003oool0<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`000000oooo03<0<`0803<0<`030000
003oool0<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`000000oooo03<0<`0803<0<`030000
003oool0<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`000000oooo03<0000803<000030000
003oool0<c<000P0<c<000<000000?ooo`0c<`00200c<`000`000000oooo03<c000803<c00030000
003oool0<c<000P0<c<000<000000?ooo`0c<`00200c<`000`000000oooo03<c000803<c00030000
003oool0<c<000P0<c<000<000000?ooo`0c<`00200c<`000`000000oooo000c0008000c00030000
003oool003<c00P003<c00<000000?ooo`00<c<02000<c<00`000000oooo000c<`08000c<`030000
003oool003<c00P003<c00<000000?ooo`0c<c<0200c<c<00`000000oooo0000000:0<c<c3X00000
L`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c003
0000003oool0000000T0000000<0oooo000c<`00<c<01`00<c<00`000000oooo000c<`08000c<`03
0000003oool003<c00P003<c00<000000?ooo`00<c<02000<c<00`000000oooo000c<`08000c<`03
0000003oool0000c00P0000c00<000000?ooo`0c03<0200c03<00`000000oooo03<0<`0803<0<`03
0000003oool0<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`000000oooo03<0<`0803<0<`03
0000003oool0<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`000000oooo03<0<`0803<0<`03
0000003oool0<`0c00P0<`0c00<000000?ooo`0c0000200c00000`000000oooo03<c000803<c0003
0000003oool0<c<000P0<c<000<000000?ooo`0c<`00200c<`000`000000oooo03<c000803<c0003
0000003oool0<c<000P0<c<000<000000?ooo`0c<`00200c<`000`000000oooo03<c000803<c0003
0000003oool0<c<000P0<c<000<000000?ooo`00<`002000<`000`000000oooo000c<`08000c<`03
0000003oool003<c00P003<c00<000000?ooo`00<c<02000<c<00`000000oooo000c<`08000c<`03
0000003oool0<c<c00P0<c<c00<000000?ooo`0000002P3<c<`00`000000oooo0?ooo`0f0?ooo`03
0000003<c<`0c<c<0740c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0L03<c<`00`000000oooo00000009000000030?ooo`00<c<003<c00L003<c00<000000?oo
o`00<c<02000<c<00`000000oooo000c<`08000c<`030000003oool003<c00P003<c00<000000?oo
o`00<c<02000<c<00`000000oooo0000<`080000<`030000003oool0<`0c00P0<`0c00<000000?oo
o`0c03<0200c03<00`000000oooo03<0<`0803<0<`030000003oool0<`0c00P0<`0c00<000000?oo
o`0c03<0200c03<00`000000oooo03<0<`0803<0<`030000003oool0<`0c00P0<`0c00<000000?oo
o`0c03<0200c03<00`000000oooo03<0<`0803<0<`030000003oool0<`0000P0<`0000<000000?oo
o`0c<`00200c<`000`000000oooo03<c000803<c00030000003oool0<c<000P0<c<000<000000?oo
o`0c<`00200c<`000`000000oooo03<c000803<c00030000003oool0<c<000P0<c<000<000000?oo
o`0c<`00200c<`000`000000oooo03<c000803<c00030000003oool003<000P003<000<000000?oo
o`00<c<02000<c<00`000000oooo000c<`08000c<`030000003oool003<c00P003<c00<000000?oo
o`00<c<02000<c<00`000000oooo03<c<`0803<c<`030000003oool0000000X0c<c<00<000000?oo
o`0000002@0000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo0000
00000000200000000`3oool0000000000008000000030?ooo`000000c<c<0780c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo00000009
000000030?ooo`00<c<003<c00L003<c00<000000?ooo`00<c<02000<c<00`000000oooo000c<`08
000c<`030000003oool003<c00P003<c00<000000?ooo`00<c<02000<c<00`000000oooo0000<`08
0000<`030000003oool0<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`000000oooo03<0<`08
03<0<`030000003oool0<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`000000oooo03<0<`08
03<0<`030000003oool0<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`000000oooo03<0<`08
03<0<`030000003oool0<`0000P0<`0000<000000?ooo`0c<`00200c<`000`000000oooo03<c0008
03<c00030000003oool0<c<000P0<c<000<000000?ooo`0c<`00200c<`000`000000oooo03<c0008
03<c00030000003oool0<c<000P0<c<000<000000?ooo`0c<`00200c<`000`000000oooo03<c0008
03<c00030000003oool003<000P003<000<000000?ooo`00<c<02000<c<00`000000oooo000c<`08
000c<`030000003oool003<c00P003<c00<000000?ooo`00<c<02000<c<00`000000oooo03<c<`08
03<c<`030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c008
0<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c008
0<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0L03<c<`00`000000oooo00000009000000030?ooo`00<c<003<c00L003<c00<0
00000?ooo`00<c<02000<c<00`000000oooo000c<`08000c<`030000003oool003<c00P003<c00<0
00000?ooo`00<c<02000<c<00`000000oooo0000<`080000<`030000003oool0<`0c00P0<`0c00<0
00000?ooo`0c03<0200c03<00`000000oooo03<0<`0803<0<`030000003oool0<`0c00P0<`0c00<0
00000?ooo`0c03<0200c03<00`000000oooo03<0<`0803<0<`030000003oool0<`0c00P0<`0c00<0
00000?ooo`0c03<0200c03<00`000000oooo03<0<`0803<0<`030000003oool0<`0000P0<`0000<0
00000?ooo`0c<`00200c<`000`000000oooo03<c000803<c00030000003oool0<c<000P0<c<000<0
00000?ooo`0c<`00200c<`000`000000oooo03<c000803<c00030000003oool0<c<000P0<c<000<0
00000?ooo`0c<`00200c<`000`000000oooo03<c000803<c00030000003oool003<000P003<000<0
00000?ooo`00<c<02000<c<00`000000oooo000c<`08000c<`030000003oool003<c00P003<c00<0
00000?ooo`00<c<02000<c<00`000000oooo03<c<`0803<c<`030000003oool0000000X0c<c<00<0
00000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<0
00000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo
00000009000000030?ooo`00<c<003<c00L003<c00<000000?ooo`00<c<02000<c<00`000000oooo
000c<`08000c<`030000003oool003<c00P003<c00<000000?ooo`00<c<02000<c<00`000000oooo
0000<`080000<`030000003oool0<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`000000oooo
03<0<`0803<0<`030000003oool0<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`000000oooo
03<0<`0803<0<`030000003oool0<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`000000oooo
03<0<`0803<0<`030000003oool0<`0000P0<`0000<000000?ooo`0c<`00200c<`000`000000oooo
03<c000803<c00030000003oool0<c<000P0<c<000<000000?ooo`0c<`00200c<`000`000000oooo
03<c000803<c00030000003oool0<c<000P0<c<000<000000?ooo`0c<`00200c<`000`000000oooo
03<c000803<c00030000003oool003<000P003<000<000000?ooo`00<c<02000<c<00`000000oooo
000c<`08000c<`030000003oool003<c00P003<c00<000000?ooo`00<c<02000<c<00`000000oooo
03<c<`0803<c<`030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo
0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo
0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo00000009000000030?ooo`00<c<003<c00L0
03<c00<000000?ooo`00<c<02000<c<00`000000oooo000c<`08000c<`030000003oool003<c00P0
03<c00<000000?ooo`00<c<02000<c<00`000000oooo0000<`080000<`030000003oool0<`0c00P0
<`0c00<000000?ooo`0c03<0200c03<00`000000oooo03<0<`0803<0<`030000003oool0<`0c00P0
<`0c00<000000?ooo`0c03<0200c03<00`000000oooo03<0<`0803<0<`030000003oool0<`0c00P0
<`0c00<000000?ooo`0c03<0200c03<00`000000oooo03<0<`0803<0<`030000003oool0<`0000P0
<`0000<000000?ooo`0c<`00200c<`000`000000oooo03<c000803<c00030000003oool0<c<000P0
<c<000<000000?ooo`0c<`00200c<`000`000000oooo03<c000803<c00030000003oool0<c<000P0
<c<000<000000?ooo`0c<`00200c<`000`000000oooo03<c000803<c00030000003oool003<000P0
03<000<000000?ooo`00<c<02000<c<00`000000oooo000c<`08000c<`030000003oool003<c00P0
03<c00<000000?ooo`00<c<02000<c<00`000000oooo03<c<`0803<c<`030000003oool0000000X0
c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0
c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`00
0000oooo00000009000000030?ooo`00<c<003<c00L003<c00<000000?ooo`00<c<02000<c<00`00
0000oooo000c<`08000c<`030000003oool003<c00P003<c00<000000?ooo`00<c<02000<c<00`00
0000oooo0000<`080000<`030000003oool0<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`00
0000oooo03<0<`0803<0<`030000003oool0<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`00
0000oooo03<0<`0803<0<`030000003oool0<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`00
0000oooo03<0<`0803<0<`030000003oool0<`0000P0<`0000<000000?ooo`0c<`00200c<`000`00
0000oooo03<c000803<c00030000003oool0<c<000P0<c<000<000000?ooo`0c<`00200c<`000`00
0000oooo03<c000803<c00030000003oool0<c<000P0<c<000<000000?ooo`0c<`00200c<`000`00
0000oooo03<c000803<c00030000003oool003<000P003<000<000000?ooo`00<c<02000<c<00`00
0000oooo000c<`08000c<`030000003oool003<c00P003<c00<000000?ooo`00<c<02000<c<00`00
0000oooo03<c<`0803<c<`030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`00
0000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`00
0000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo00000009000000030?ooo`00<c<0
03<c00L003<c00<000000?ooo`00<c<02000<c<00`000000oooo000c<`08000c<`030000003oool0
03<c00P003<c00<000000?ooo`00<c<02000<c<00`000000oooo0000<`080000<`030000003oool0
<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`000000oooo03<0<`0803<0<`030000003oool0
<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`000000oooo03<0<`0803<0<`030000003oool0
<`0c00P0<`0c00<000000?ooo`0c03<0200c03<00`000000oooo03<0<`0803<0<`030000003oool0
<`0000P0<`0000<000000?ooo`0c<`00200c<`000`000000oooo03<c000803<c00030000003oool0
<c<000P0<c<000<000000?ooo`0c<`00200c<`000`000000oooo03<c000803<c00030000003oool0
<c<000P0<c<000<000000?ooo`0c<`00200c<`000`000000oooo03<c000803<c00030000003oool0
03<000P003<000<000000?ooo`00<c<02000<c<00`000000oooo000c<`08000c<`030000003oool0
03<c00P003<c00<000000?ooo`00<c<02000<c<00`000000oooo03<c<`0803<c<`030000003oool0
000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0
c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0
000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<
c<`00`000000oooo0?ooo`3o0?oooeD0oooo00<000000<c<c03<c<`0203<c<`00`000000oooo0<c<
c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<
c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`000000L`3<c<`0101VIVH0R<2h08S0
^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0000000T00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo0000003<c<`02@3<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<
00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<
00<000000?ooo`000000L`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0
R<2h0?ooo`1`0<c<c0030000003oool0<c<c00P0<c<c00<000000?ooo`00IVH02000IVH00`000000
oooo001VIP08001VIP030000003oool006IV00P006IV00<000000?ooo`00IVH02000IVH00`000000
oooo000cIP08000cIP030000003oool0001V00P0001V00<000000?ooo`0c06H0200c06H00`000000
oooo06H0IP0806H0IP030000003oool0IP1V00P0IP1V00<000000?ooo`1V06H0201V06H00`000000
oooo06H0IP0806H0IP030000003oool0IP1V00P0IP1V00<000000?ooo`1V06H0201V06H00`000000
oooo06H0IP0806H0IP030000003oool0IP0c00P0IP0c00<000000?ooo`1V0000201V00000`000000
oooo06Hc000806Hc00030000003oool0IVH000P0IVH000<000000?ooo`1VIP00201VIP000`000000
oooo06IV000806IV00030000003oool0IVH000P0IVH000<000000?ooo`1VIP00201VIP000`000000
oooo06IV000806IV00030000003oool0IVH000P0IVH000<000000?ooo`0cIP00200cIP000`000000
oooo001V0008001V00030000003oool006Hc00P006Hc00<000000?ooo`00IVH02000IVH00`000000
oooo001VIP08001VIP030000003oool006IV00P006IV00<000000?ooo`0000002P3<c<`00`000000
oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000
oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`000000L`3<c<`0101VIVH0
R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0<c<c
00P0<c<c00<000000?ooo`00IVH02000IVH00`000000oooo001VIP08001VIP030000003oool006IV
00P006IV00<000000?ooo`00IVH02000IVH00`000000oooo000cIP08000cIP030000003oool0001V
00P0001V00<000000?ooo`0c06H0200c06H00`000000oooo06H0IP0806H0IP030000003oool0IP1V
00P0IP1V00<000000?ooo`1V06H0201V06H00`000000oooo06H0IP0806H0IP030000003oool0IP1V
00P0IP1V00<000000?ooo`1V06H0201V06H00`000000oooo06H0IP0806H0IP030000003oool0IP0c
00P0IP0c00<000000?ooo`1V0000201V00000`000000oooo06Hc000806Hc00030000003oool0IVH0
00P0IVH000<000000?ooo`1VIP00201VIP000`000000oooo06IV000806IV00030000003oool0IVH0
00P0IVH000<000000?ooo`1VIP00201VIP000`000000oooo06IV000806IV00030000003oool0IVH0
00P0IVH000<000000?ooo`0cIP00200cIP000`000000oooo001V0008001V00030000003oool006Hc
00P006Hc00<000000?ooo`00IVH02000IVH00`000000oooo001VIP08001VIP030000003oool006IV
00P006IV00<000000?ooo`0000002P3<c<`00`000000oooo0?ooo`0f0?ooo`030000003<c<`0c<c<
0740c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`0
0`000000oooo03<c<`0803<c<`030000003oool006IV00P006IV00<000000?ooo`00IVH02000IVH0
0`000000oooo001VIP08001VIP030000003oool006IV00P006IV00<000000?ooo`00<fH02000<fH0
0`000000oooo0000IP080000IP030000003oool0<`1V00P0<`1V00<000000?ooo`1V06H0201V06H0
0`000000oooo06H0IP0806H0IP030000003oool0IP1V00P0IP1V00<000000?ooo`1V06H0201V06H0
0`000000oooo06H0IP0806H0IP030000003oool0IP1V00P0IP1V00<000000?ooo`1V06H0201V06H0
0`000000oooo06H0<`0806H0<`030000003oool0IP0000P0IP0000<000000?ooo`1V<`00201V<`00
0`000000oooo06IV000806IV00030000003oool0IVH000P0IVH000<000000?ooo`1VIP00201VIP00
0`000000oooo06IV000806IV00030000003oool0IVH000P0IVH000<000000?ooo`1VIP00201VIP00
0`000000oooo06IV000806IV00030000003oool0<fH000P0<fH000<000000?ooo`00IP002000IP00
0`000000oooo001V<`08001V<`030000003oool006IV00P006IV00<000000?ooo`00IVH02000IVH0
0`000000oooo001VIP08001VIP030000003oool0000000X0c<c<00<000000?ooo`0000002@000000
0`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000000020000000
0`3oool0000000000008000000030?ooo`000000c<c<0780c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo03<c<`0803<c<`030000003o
ool006IV00P006IV00<000000?ooo`00IVH02000IVH00`000000oooo001VIP08001VIP030000003o
ool006IV00P006IV00<000000?ooo`00<fH02000<fH00`000000oooo0000IP080000IP030000003o
ool0<`1V00P0<`1V00<000000?ooo`1V06H0201V06H00`000000oooo06H0IP0806H0IP030000003o
ool0IP1V00P0IP1V00<000000?ooo`1V06H0201V06H00`000000oooo06H0IP0806H0IP030000003o
ool0IP1V00P0IP1V00<000000?ooo`1V06H0201V06H00`000000oooo06H0<`0806H0<`030000003o
ool0IP0000P0IP0000<000000?ooo`1V<`00201V<`000`000000oooo06IV000806IV00030000003o
ool0IVH000P0IVH000<000000?ooo`1VIP00201VIP000`000000oooo06IV000806IV00030000003o
ool0IVH000P0IVH000<000000?ooo`1VIP00201VIP000`000000oooo06IV000806IV00030000003o
ool0<fH000P0<fH000<000000?ooo`00IP002000IP000`000000oooo001V<`08001V<`030000003o
ool006IV00P006IV00<000000?ooo`00IVH02000IVH00`000000oooo001VIP08001VIP030000003o
ool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003o
ool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003o
ool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
L03<c<`00`000000oooo03<c<`0803<c<`030000003oool006IV00P006IV00<000000?ooo`00IVH0
2000IVH00`000000oooo001VIP08001VIP030000003oool006IV00P006IV00<000000?ooo`00<fH0
2000<fH00`000000oooo0000IP080000IP030000003oool0<`1V00P0<`1V00<000000?ooo`1V06H0
201V06H00`000000oooo06H0IP0806H0IP030000003oool0IP1V00P0IP1V00<000000?ooo`1V06H0
201V06H00`000000oooo06H0IP0806H0IP030000003oool0IP1V00P0IP1V00<000000?ooo`1V06H0
201V06H00`000000oooo06H0<`0806H0<`030000003oool0IP0000P0IP0000<000000?ooo`1V<`00
201V<`000`000000oooo06IV000806IV00030000003oool0IVH000P0IVH000<000000?ooo`1VIP00
201VIP000`000000oooo06IV000806IV00030000003oool0IVH000P0IVH000<000000?ooo`1VIP00
201VIP000`000000oooo06IV000806IV00030000003oool0<fH000P0<fH000<000000?ooo`00IP00
2000IP000`000000oooo001V<`08001V<`030000003oool006IV00P006IV00<000000?ooo`00IVH0
2000IVH00`000000oooo001VIP08001VIP030000003oool0000000X0c<c<00<000000?ooo`3<c<`0
203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0
203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo03<c<`0803<c<`03
0000003oool006IV00P006IV00<000000?ooo`00IVH02000IVH00`000000oooo001VIP08001VIP03
0000003oool006IV00P006IV00<000000?ooo`00<fH02000<fH00`000000oooo0000IP080000IP03
0000003oool0<`1V00P0<`1V00<000000?ooo`1V06H0201V06H00`000000oooo06H0IP0806H0IP03
0000003oool0IP1V00P0IP1V00<000000?ooo`1V06H0201V06H00`000000oooo06H0IP0806H0IP03
0000003oool0IP1V00P0IP1V00<000000?ooo`1V06H0201V06H00`000000oooo06H0<`0806H0<`03
0000003oool0IP0000P0IP0000<000000?ooo`1V<`00201V<`000`000000oooo06IV000806IV0003
0000003oool0IVH000P0IVH000<000000?ooo`1VIP00201VIP000`000000oooo06IV000806IV0003
0000003oool0IVH000P0IVH000<000000?ooo`1VIP00201VIP000`000000oooo06IV000806IV0003
0000003oool0<fH000P0<fH000<000000?ooo`00IP002000IP000`000000oooo001V<`08001V<`03
0000003oool006IV00P006IV00<000000?ooo`00IVH02000IVH00`000000oooo001VIP08001VIP03
0000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c003
0000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c003
0000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0L03<c<`00`000000oooo03<c<`0803<c<`030000003oool006IV00P006IV00<000000?oo
o`00IVH02000IVH00`000000oooo001VIP08001VIP030000003oool006IV00P006IV00<000000?oo
o`00<fH02000<fH00`000000oooo0000IP080000IP030000003oool0<`1V00P0<`1V00<000000?oo
o`1V06H0201V06H00`000000oooo06H0IP0806H0IP030000003oool0IP1V00P0IP1V00<000000?oo
o`1V06H0201V06H00`000000oooo06H0IP0806H0IP030000003oool0IP1V00P0IP1V00<000000?oo
o`1V06H0201V06H00`000000oooo06H0<`0806H0<`030000003oool0IP0000P0IP0000<000000?oo
o`1V<`00201V<`000`000000oooo06IV000806IV00030000003oool0IVH000P0IVH000<000000?oo
o`1VIP00201VIP000`000000oooo06IV000806IV00030000003oool0IVH000P0IVH000<000000?oo
o`1VIP00201VIP000`000000oooo06IV000806IV00030000003oool0<fH000P0<fH000<000000?oo
o`00IP002000IP000`000000oooo001V<`08001V<`030000003oool006IV00P006IV00<000000?oo
o`00IVH02000IVH00`000000oooo001VIP08001VIP030000003oool0000000X0c<c<00<000000?oo
o`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?oo
o`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo03<c<`08
03<c<`030000003oool006IV00P006IV00<000000?ooo`00IVH02000IVH00`000000oooo001VIP08
001VIP030000003oool006IV00P006IV00<000000?ooo`00<fH02000<fH00`000000oooo0000IP08
0000IP030000003oool0<`1V00P0<`1V00<000000?ooo`1V06H0201V06H00`000000oooo06H0IP08
06H0IP030000003oool0IP1V00P0IP1V00<000000?ooo`1V06H0201V06H00`000000oooo06H0IP08
06H0IP030000003oool0IP1V00P0IP1V00<000000?ooo`1V06H0201V06H00`000000oooo06H0<`08
06H0<`030000003oool0IP0000P0IP0000<000000?ooo`1V<`00201V<`000`000000oooo06IV0008
06IV00030000003oool0IVH000P0IVH000<000000?ooo`1VIP00201VIP000`000000oooo06IV0008
06IV00030000003oool0IVH000P0IVH000<000000?ooo`1VIP00201VIP000`000000oooo06IV0008
06IV00030000003oool0<fH000P0<fH000<000000?ooo`00IP002000IP000`000000oooo001V<`08
001V<`030000003oool006IV00P006IV00<000000?ooo`00IVH02000IVH00`000000oooo001VIP08
001VIP030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c008
0<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c008
0<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0L03<c<`00`000000oooo03<c<`0803<c<`030000003oool006IV00P006IV00<0
00000?ooo`00IVH02000IVH00`000000oooo001VIP08001VIP030000003oool006IV00P006IV00<0
00000?ooo`00<fH02000<fH00`000000oooo0000IP080000IP030000003oool0<`1V00P0<`1V00<0
00000?ooo`1V06H0201V06H00`000000oooo06H0IP0806H0IP030000003oool0IP1V00P0IP1V00<0
00000?ooo`1V06H0201V06H00`000000oooo06H0IP0806H0IP030000003oool0IP1V00P0IP1V00<0
00000?ooo`1V06H0201V06H00`000000oooo06H0<`0806H0<`030000003oool0IP0000P0IP0000<0
00000?ooo`1V<`00201V<`000`000000oooo06IV000806IV00030000003oool0IVH000P0IVH000<0
00000?ooo`1VIP00201VIP000`000000oooo06IV000806IV00030000003oool0IVH000P0IVH000<0
00000?ooo`1VIP00201VIP000`000000oooo06IV000806IV00030000003oool0<fH000P0<fH000<0
00000?ooo`00IP002000IP000`000000oooo001V<`08001V<`030000003oool006IV00P006IV00<0
00000?ooo`00IVH02000IVH00`000000oooo001VIP08001VIP030000003oool0000000X0c<c<00<0
00000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<0
00000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo
0?ooo`3o0?oooeD0oooo00<000000<c<c03<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000
003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000
003oool0c<c<00P0c<c<00<000000?ooo`000000L`3<c<`0101VIVH0R<2h08S0^018T8P100000000
00D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0000000T0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo0000003<
c<`02@3<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<
c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`00
0000L`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<
c0030000003oool0IVIV00P0IVIV00<000000?ooo`00VIT02000VIT00`000000oooo002IV@08002I
V@030000003oool009VI00P009VI00<000000?ooo`00IYT02000IYT00`000000oooo000cV@08000c
V@030000003oool0002I00P0002I00<000000?ooo`0c09T0200c09T00`000000oooo06H0V@0806H0
V@030000003oool0V@2I00P0V@2I00<000000?ooo`2I09T0202I09T00`000000oooo09T0V@0809T0
V@030000003oool0V@2I00P0V@2I00<000000?ooo`2I09T0202I09T00`000000oooo09T0IP0809T0
IP030000003oool0V@0c00P0V@0c00<000000?ooo`2I0000202I00000`000000oooo09Tc000809Tc
00030000003oool0VFH000P0VFH000<000000?ooo`2IV@00202IV@000`000000oooo09VI000809VI
00030000003oool0VIT000P0VIT000<000000?ooo`2IV@00202IV@000`000000oooo09VI000809VI
00030000003oool0IYT000P0IYT000<000000?ooo`0cV@00200cV@000`000000oooo002I0008002I
00030000003oool009Tc00P009Tc00<000000?ooo`00VFH02000VFH00`000000oooo002IV@08002I
V@030000003oool009VI00P009VI00<000000?ooo`0000002P3<c<`00`000000oooo0<c<c0080<c<
c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<
c0030000003oool0c<c<00P0c<c<00<000000?ooo`000000L`3<c<`0101VIVH0R<2h08S0^018T8P1
0000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0IVIV00P0IVIV00<00000
0?ooo`00VIT02000VIT00`000000oooo002IV@08002IV@030000003oool009VI00P009VI00<00000
0?ooo`00IYT02000IYT00`000000oooo000cV@08000cV@030000003oool0002I00P0002I00<00000
0?ooo`0c09T0200c09T00`000000oooo06H0V@0806H0V@030000003oool0V@2I00P0V@2I00<00000
0?ooo`2I09T0202I09T00`000000oooo09T0V@0809T0V@030000003oool0V@2I00P0V@2I00<00000
0?ooo`2I09T0202I09T00`000000oooo09T0IP0809T0IP030000003oool0V@0c00P0V@0c00<00000
0?ooo`2I0000202I00000`000000oooo09Tc000809Tc00030000003oool0VFH000P0VFH000<00000
0?ooo`2IV@00202IV@000`000000oooo09VI000809VI00030000003oool0VIT000P0VIT000<00000
0?ooo`2IV@00202IV@000`000000oooo09VI000809VI00030000003oool0IYT000P0IYT000<00000
0?ooo`0cV@00200cV@000`000000oooo002I0008002I00030000003oool009Tc00P009Tc00<00000
0?ooo`00VFH02000VFH00`000000oooo002IV@08002IV@030000003oool009VI00P009VI00<00000
0?ooo`0000002P3<c<`00`000000oooo0?ooo`0f0?ooo`030000003<c<`0c<c<0740c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo06IV
IP0806IVIP030000003oool009VI00P009VI00<000000?ooo`00VIT02000VIT00`000000oooo002I
V@08002IV@030000003oool006JI00P006JI00<000000?ooo`00<iT02000<iT00`000000oooo0000
V@080000V@030000003oool0<`2I00P0<`2I00<000000?ooo`1V09T0201V09T00`000000oooo09T0
V@0809T0V@030000003oool0V@2I00P0V@2I00<000000?ooo`2I09T0202I09T00`000000oooo09T0
V@0809T0V@030000003oool0V@2I00P0V@2I00<000000?ooo`2I06H0202I06H00`000000oooo09T0
<`0809T0<`030000003oool0V@0000P0V@0000<000000?ooo`2I<`00202I<`000`000000oooo09UV
000809UV00030000003oool0VIT000P0VIT000<000000?ooo`2IV@00202IV@000`000000oooo09VI
000809VI00030000003oool0VIT000P0VIT000<000000?ooo`2IV@00202IV@000`000000oooo06JI
000806JI00030000003oool0<iT000P0<iT000<000000?ooo`00V@002000V@000`000000oooo002I
<`08002I<`030000003oool009UV00P009UV00<000000?ooo`00VIT02000VIT00`000000oooo002I
V@08002IV@030000003oool0000000X0c<c<00<000000?ooo`0000002@0000000`3oool000000000
0008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool000000000
0008000000030?ooo`000000c<c<0780c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038
h=P0R<2h08S0^03oool0L03<c<`00`000000oooo06IVIP0806IVIP030000003oool009VI00P009VI
00<000000?ooo`00VIT02000VIT00`000000oooo002IV@08002IV@030000003oool006JI00P006JI
00<000000?ooo`00<iT02000<iT00`000000oooo0000V@080000V@030000003oool0<`2I00P0<`2I
00<000000?ooo`1V09T0201V09T00`000000oooo09T0V@0809T0V@030000003oool0V@2I00P0V@2I
00<000000?ooo`2I09T0202I09T00`000000oooo09T0V@0809T0V@030000003oool0V@2I00P0V@2I
00<000000?ooo`2I06H0202I06H00`000000oooo09T0<`0809T0<`030000003oool0V@0000P0V@00
00<000000?ooo`2I<`00202I<`000`000000oooo09UV000809UV00030000003oool0VIT000P0VIT0
00<000000?ooo`2IV@00202IV@000`000000oooo09VI000809VI00030000003oool0VIT000P0VIT0
00<000000?ooo`2IV@00202IV@000`000000oooo06JI000806JI00030000003oool0<iT000P0<iT0
00<000000?ooo`00V@002000V@000`000000oooo002I<`08002I<`030000003oool009UV00P009UV
00<000000?ooo`00VIT02000VIT00`000000oooo002IV@08002IV@030000003oool0000000X0c<c<
00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<
00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000
oooo06IVIP0806IVIP030000003oool009VI00P009VI00<000000?ooo`00VIT02000VIT00`000000
oooo002IV@08002IV@030000003oool006JI00P006JI00<000000?ooo`00<iT02000<iT00`000000
oooo0000V@080000V@030000003oool0<`2I00P0<`2I00<000000?ooo`1V09T0201V09T00`000000
oooo09T0V@0809T0V@030000003oool0V@2I00P0V@2I00<000000?ooo`2I09T0202I09T00`000000
oooo09T0V@0809T0V@030000003oool0V@2I00P0V@2I00<000000?ooo`2I06H0202I06H00`000000
oooo09T0<`0809T0<`030000003oool0V@0000P0V@0000<000000?ooo`2I<`00202I<`000`000000
oooo09UV000809UV00030000003oool0VIT000P0VIT000<000000?ooo`2IV@00202IV@000`000000
oooo09VI000809VI00030000003oool0VIT000P0VIT000<000000?ooo`2IV@00202IV@000`000000
oooo06JI000806JI00030000003oool0<iT000P0<iT000<000000?ooo`00V@002000V@000`000000
oooo002I<`08002I<`030000003oool009UV00P009UV00<000000?ooo`00VIT02000VIT00`000000
oooo002IV@08002IV@030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000
oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000
oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@0000000005
08S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo06IVIP0806IVIP030000003oool009VI
00P009VI00<000000?ooo`00VIT02000VIT00`000000oooo002IV@08002IV@030000003oool006JI
00P006JI00<000000?ooo`00<iT02000<iT00`000000oooo0000V@080000V@030000003oool0<`2I
00P0<`2I00<000000?ooo`1V09T0201V09T00`000000oooo09T0V@0809T0V@030000003oool0V@2I
00P0V@2I00<000000?ooo`2I09T0202I09T00`000000oooo09T0V@0809T0V@030000003oool0V@2I
00P0V@2I00<000000?ooo`2I06H0202I06H00`000000oooo09T0<`0809T0<`030000003oool0V@00
00P0V@0000<000000?ooo`2I<`00202I<`000`000000oooo09UV000809UV00030000003oool0VIT0
00P0VIT000<000000?ooo`2IV@00202IV@000`000000oooo09VI000809VI00030000003oool0VIT0
00P0VIT000<000000?ooo`2IV@00202IV@000`000000oooo06JI000806JI00030000003oool0<iT0
00P0<iT000<000000?ooo`00V@002000V@000`000000oooo002I<`08002I<`030000003oool009UV
00P009UV00<000000?ooo`00VIT02000VIT00`000000oooo002IV@08002IV@030000003oool00000
00X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<
00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool00000
07<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`0
0`000000oooo06IVIP0806IVIP030000003oool009VI00P009VI00<000000?ooo`00VIT02000VIT0
0`000000oooo002IV@08002IV@030000003oool006JI00P006JI00<000000?ooo`00<iT02000<iT0
0`000000oooo0000V@080000V@030000003oool0<`2I00P0<`2I00<000000?ooo`1V09T0201V09T0
0`000000oooo09T0V@0809T0V@030000003oool0V@2I00P0V@2I00<000000?ooo`2I09T0202I09T0
0`000000oooo09T0V@0809T0V@030000003oool0V@2I00P0V@2I00<000000?ooo`2I06H0202I06H0
0`000000oooo09T0<`0809T0<`030000003oool0V@0000P0V@0000<000000?ooo`2I<`00202I<`00
0`000000oooo09UV000809UV00030000003oool0VIT000P0VIT000<000000?ooo`2IV@00202IV@00
0`000000oooo09VI000809VI00030000003oool0VIT000P0VIT000<000000?ooo`2IV@00202IV@00
0`000000oooo06JI000806JI00030000003oool0<iT000P0<iT000<000000?ooo`00V@002000V@00
0`000000oooo002I<`08002I<`030000003oool009UV00P009UV00<000000?ooo`00VIT02000VIT0
0`000000oooo002IV@08002IV@030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`0
0`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`0
0`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo06IVIP0806IVIP030000003o
ool009VI00P009VI00<000000?ooo`00VIT02000VIT00`000000oooo002IV@08002IV@030000003o
ool006JI00P006JI00<000000?ooo`00<iT02000<iT00`000000oooo0000V@080000V@030000003o
ool0<`2I00P0<`2I00<000000?ooo`1V09T0201V09T00`000000oooo09T0V@0809T0V@030000003o
ool0V@2I00P0V@2I00<000000?ooo`2I09T0202I09T00`000000oooo09T0V@0809T0V@030000003o
ool0V@2I00P0V@2I00<000000?ooo`2I06H0202I06H00`000000oooo09T0<`0809T0<`030000003o
ool0V@0000P0V@0000<000000?ooo`2I<`00202I<`000`000000oooo09UV000809UV00030000003o
ool0VIT000P0VIT000<000000?ooo`2IV@00202IV@000`000000oooo09VI000809VI00030000003o
ool0VIT000P0VIT000<000000?ooo`2IV@00202IV@000`000000oooo06JI000806JI00030000003o
ool0<iT000P0<iT000<000000?ooo`00V@002000V@000`000000oooo002I<`08002I<`030000003o
ool009UV00P009UV00<000000?ooo`00VIT02000VIT00`000000oooo002IV@08002IV@030000003o
ool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003o
ool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003o
ool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
L03<c<`00`000000oooo06IVIP0806IVIP030000003oool009VI00P009VI00<000000?ooo`00VIT0
2000VIT00`000000oooo002IV@08002IV@030000003oool006JI00P006JI00<000000?ooo`00<iT0
2000<iT00`000000oooo0000V@080000V@030000003oool0<`2I00P0<`2I00<000000?ooo`1V09T0
201V09T00`000000oooo09T0V@0809T0V@030000003oool0V@2I00P0V@2I00<000000?ooo`2I09T0
202I09T00`000000oooo09T0V@0809T0V@030000003oool0V@2I00P0V@2I00<000000?ooo`2I06H0
202I06H00`000000oooo09T0<`0809T0<`030000003oool0V@0000P0V@0000<000000?ooo`2I<`00
202I<`000`000000oooo09UV000809UV00030000003oool0VIT000P0VIT000<000000?ooo`2IV@00
202IV@000`000000oooo09VI000809VI00030000003oool0VIT000P0VIT000<000000?ooo`2IV@00
202IV@000`000000oooo06JI000806JI00030000003oool0<iT000P0<iT000<000000?ooo`00V@00
2000V@000`000000oooo002I<`08002I<`030000003oool009UV00P009UV00<000000?ooo`00VIT0
2000VIT00`000000oooo002IV@08002IV@030000003oool0000000X0c<c<00<000000?ooo`3<c<`0
203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0
203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo0?ooo`3o0?oooeD0
oooo00<000000<c<c03<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0
c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0
c<c<00<000000?ooo`000000L`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028
`;P0R<2h0?ooo`1`0<c<c0030000003oool0000000T0000000<0oooo000000000000200000000`3o
ool0000000000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3o
ool0000000000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3o
ool0000000000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3o
ool0000000000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3o
ool0000000000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3o
ool0000000000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3o
ool0000000000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3o
ool0000000000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3o
ool0000000000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3o
ool0000000000008000000030?ooo`000000000000P0000000<0oooo0000003<c<`02@3<c<`00`00
0000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`00
0000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`000000L`3<c<`0101V
IVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0
IVIV00P0IVIV00<000000?ooo`00c<`02000c<`00`000000oooo003<c008003<c0030000003oool0
09W<00P009W<00<000000?ooo`00I/`02000I/`00`000000oooo000cc008000cc0030000003oool0
003<00P0003<00<000000?ooo`0c0<`0200c0<`00`000000oooo06H0c00806H0c0030000003oool0
V@3<00P0V@3<00<000000?ooo`3<0<`0203<0<`00`000000oooo0<`0c0080<`0c0030000003oool0
c03<00P0c03<00<000000?ooo`3<09T0203<09T00`000000oooo0<`0IP080<`0IP030000003oool0
c00c00P0c00c00<000000?ooo`3<0000203<00000`000000oooo0<`c00080<`c00030000003oool0
c6H000P0c6H000<000000?ooo`3<V@00203<V@000`000000oooo0<c<00080<c<00030000003oool0
c<`000P0c<`000<000000?ooo`3<c000203<c0000`000000oooo09W<000809W<00030000003oool0
I/`000P0I/`000<000000?ooo`0cc000200cc0000`000000oooo003<0008003<00030000003oool0
0<`c00P00<`c00<000000?ooo`00c6H02000c6H00`000000oooo003<V@08003<V@030000003oool0
0<c<00P00<c<00<000000?ooo`0000002P3<c<`00`000000oooo0<c<c0080<c<c0030000003oool0
c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0
c<c<00P0c<c<00<000000?ooo`000000L`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h
0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0IVIV00P0IVIV00<000000?ooo`00c<`02000
c<`00`000000oooo003<c008003<c0030000003oool009W<00P009W<00<000000?ooo`00I/`02000
I/`00`000000oooo000cc008000cc0030000003oool0003<00P0003<00<000000?ooo`0c0<`0200c
0<`00`000000oooo06H0c00806H0c0030000003oool0V@3<00P0V@3<00<000000?ooo`3<0<`0203<
0<`00`000000oooo0<`0c0080<`0c0030000003oool0c03<00P0c03<00<000000?ooo`3<09T0203<
09T00`000000oooo0<`0IP080<`0IP030000003oool0c00c00P0c00c00<000000?ooo`3<0000203<
00000`000000oooo0<`c00080<`c00030000003oool0c6H000P0c6H000<000000?ooo`3<V@00203<
V@000`000000oooo0<c<00080<c<00030000003oool0c<`000P0c<`000<000000?ooo`3<c000203<
c0000`000000oooo09W<000809W<00030000003oool0I/`000P0I/`000<000000?ooo`0cc000200c
c0000`000000oooo003<0008003<00030000003oool00<`c00P00<`c00<000000?ooo`00c6H02000
c6H00`000000oooo003<V@08003<V@030000003oool00<c<00P00<c<00<000000?ooo`0000002P3<
c<`00`000000oooo0?ooo`0f0?ooo`030000003<c<`0c<c<0740c<c<00@0IVIV08S0^028`;P0B928
0@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo06IVIP0806IVIP030000
003oool00<c<00P00<c<00<000000?ooo`00c<`02000c<`00`000000oooo002Ic008002Ic0030000
003oool006K<00P006K<00<000000?ooo`00<l`02000<l`00`000000oooo0000c0080000c0030000
003oool0<`3<00P0<`3<00<000000?ooo`1V0<`0201V0<`00`000000oooo09T0c00809T0c0030000
003oool0c03<00P0c03<00<000000?ooo`3<0<`0203<0<`00`000000oooo0<`0c0080<`0c0030000
003oool0c02I00P0c02I00<000000?ooo`3<06H0203<06H00`000000oooo0<`0<`080<`0<`030000
003oool0c00000P0c00000<000000?ooo`3<<`00203<<`000`000000oooo0<aV00080<aV00030000
003oool0c9T000P0c9T000<000000?ooo`3<c000203<c0000`000000oooo0<c<00080<c<00030000
003oool0c<`000P0c<`000<000000?ooo`2Ic000202Ic0000`000000oooo06K<000806K<00030000
003oool0<l`000P0<l`000<000000?ooo`00c0002000c0000`000000oooo003<<`08003<<`030000
003oool00<aV00P00<aV00<000000?ooo`00c9T02000c9T00`000000oooo003<c008003<c0030000
003oool0000000X0c<c<00<000000?ooo`0000002@0000000`3oool0000000000008000000030?oo
o`000000000000P0000000<0oooo000000000000200000000`3oool0000000000008000000030?oo
o`000000c<c<0780c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03o
ool0L03<c<`00`000000oooo06IVIP0806IVIP030000003oool00<c<00P00<c<00<000000?ooo`00
c<`02000c<`00`000000oooo002Ic008002Ic0030000003oool006K<00P006K<00<000000?ooo`00
<l`02000<l`00`000000oooo0000c0080000c0030000003oool0<`3<00P0<`3<00<000000?ooo`1V
0<`0201V0<`00`000000oooo09T0c00809T0c0030000003oool0c03<00P0c03<00<000000?ooo`3<
0<`0203<0<`00`000000oooo0<`0c0080<`0c0030000003oool0c02I00P0c02I00<000000?ooo`3<
06H0203<06H00`000000oooo0<`0<`080<`0<`030000003oool0c00000P0c00000<000000?ooo`3<
<`00203<<`000`000000oooo0<aV00080<aV00030000003oool0c9T000P0c9T000<000000?ooo`3<
c000203<c0000`000000oooo0<c<00080<c<00030000003oool0c<`000P0c<`000<000000?ooo`2I
c000202Ic0000`000000oooo06K<000806K<00030000003oool0<l`000P0<l`000<000000?ooo`00
c0002000c0000`000000oooo003<<`08003<<`030000003oool00<aV00P00<aV00<000000?ooo`00
c9T02000c9T00`000000oooo003<c008003<c0030000003oool0000000X0c<c<00<000000?ooo`3<
c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<
c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028
`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo06IVIP0806IV
IP030000003oool00<c<00P00<c<00<000000?ooo`00c<`02000c<`00`000000oooo002Ic008002I
c0030000003oool006K<00P006K<00<000000?ooo`00<l`02000<l`00`000000oooo0000c0080000
c0030000003oool0<`3<00P0<`3<00<000000?ooo`1V0<`0201V0<`00`000000oooo09T0c00809T0
c0030000003oool0c03<00P0c03<00<000000?ooo`3<0<`0203<0<`00`000000oooo0<`0c0080<`0
c0030000003oool0c02I00P0c02I00<000000?ooo`3<06H0203<06H00`000000oooo0<`0<`080<`0
<`030000003oool0c00000P0c00000<000000?ooo`3<<`00203<<`000`000000oooo0<aV00080<aV
00030000003oool0c9T000P0c9T000<000000?ooo`3<c000203<c0000`000000oooo0<c<00080<c<
00030000003oool0c<`000P0c<`000<000000?ooo`2Ic000202Ic0000`000000oooo06K<000806K<
00030000003oool0<l`000P0<l`000<000000?ooo`00c0002000c0000`000000oooo003<<`08003<
<`030000003oool00<aV00P00<aV00<000000?ooo`00c9T02000c9T00`000000oooo003<c008003<
c0030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<
c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<
c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0L03<c<`00`000000oooo06IVIP0806IVIP030000003oool00<c<00P00<c<00<00000
0?ooo`00c<`02000c<`00`000000oooo002Ic008002Ic0030000003oool006K<00P006K<00<00000
0?ooo`00<l`02000<l`00`000000oooo0000c0080000c0030000003oool0<`3<00P0<`3<00<00000
0?ooo`1V0<`0201V0<`00`000000oooo09T0c00809T0c0030000003oool0c03<00P0c03<00<00000
0?ooo`3<0<`0203<0<`00`000000oooo0<`0c0080<`0c0030000003oool0c02I00P0c02I00<00000
0?ooo`3<06H0203<06H00`000000oooo0<`0<`080<`0<`030000003oool0c00000P0c00000<00000
0?ooo`3<<`00203<<`000`000000oooo0<aV00080<aV00030000003oool0c9T000P0c9T000<00000
0?ooo`3<c000203<c0000`000000oooo0<c<00080<c<00030000003oool0c<`000P0c<`000<00000
0?ooo`2Ic000202Ic0000`000000oooo06K<000806K<00030000003oool0<l`000P0<l`000<00000
0?ooo`00c0002000c0000`000000oooo003<<`08003<<`030000003oool00<aV00P00<aV00<00000
0?ooo`00c9T02000c9T00`000000oooo003<c008003<c0030000003oool0000000X0c<c<00<00000
0?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<00000
0?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo06IV
IP0806IVIP030000003oool00<c<00P00<c<00<000000?ooo`00c<`02000c<`00`000000oooo002I
c008002Ic0030000003oool006K<00P006K<00<000000?ooo`00<l`02000<l`00`000000oooo0000
c0080000c0030000003oool0<`3<00P0<`3<00<000000?ooo`1V0<`0201V0<`00`000000oooo09T0
c00809T0c0030000003oool0c03<00P0c03<00<000000?ooo`3<0<`0203<0<`00`000000oooo0<`0
c0080<`0c0030000003oool0c02I00P0c02I00<000000?ooo`3<06H0203<06H00`000000oooo0<`0
<`080<`0<`030000003oool0c00000P0c00000<000000?ooo`3<<`00203<<`000`000000oooo0<aV
00080<aV00030000003oool0c9T000P0c9T000<000000?ooo`3<c000203<c0000`000000oooo0<c<
00080<c<00030000003oool0c<`000P0c<`000<000000?ooo`2Ic000202Ic0000`000000oooo06K<
000806K<00030000003oool0<l`000P0<l`000<000000?ooo`00c0002000c0000`000000oooo003<
<`08003<<`030000003oool00<aV00P00<aV00<000000?ooo`00c9T02000c9T00`000000oooo003<
c008003<c0030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<
c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<
c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038
h=P0R<2h08S0^03oool0L03<c<`00`000000oooo06IVIP0806IVIP030000003oool00<c<00P00<c<
00<000000?ooo`00c<`02000c<`00`000000oooo002Ic008002Ic0030000003oool006K<00P006K<
00<000000?ooo`00<l`02000<l`00`000000oooo0000c0080000c0030000003oool0<`3<00P0<`3<
00<000000?ooo`1V0<`0201V0<`00`000000oooo09T0c00809T0c0030000003oool0c03<00P0c03<
00<000000?ooo`3<0<`0203<0<`00`000000oooo0<`0c0080<`0c0030000003oool0c02I00P0c02I
00<000000?ooo`3<06H0203<06H00`000000oooo0<`0<`080<`0<`030000003oool0c00000P0c000
00<000000?ooo`3<<`00203<<`000`000000oooo0<aV00080<aV00030000003oool0c9T000P0c9T0
00<000000?ooo`3<c000203<c0000`000000oooo0<c<00080<c<00030000003oool0c<`000P0c<`0
00<000000?ooo`2Ic000202Ic0000`000000oooo06K<000806K<00030000003oool0<l`000P0<l`0
00<000000?ooo`00c0002000c0000`000000oooo003<<`08003<<`030000003oool00<aV00P00<aV
00<000000?ooo`00c9T02000c9T00`000000oooo003<c008003<c0030000003oool0000000X0c<c<
00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<
00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000
oooo06IVIP0806IVIP030000003oool00<c<00P00<c<00<000000?ooo`00c<`02000c<`00`000000
oooo002Ic008002Ic0030000003oool006K<00P006K<00<000000?ooo`00<l`02000<l`00`000000
oooo0000c0080000c0030000003oool0<`3<00P0<`3<00<000000?ooo`1V0<`0201V0<`00`000000
oooo09T0c00809T0c0030000003oool0c03<00P0c03<00<000000?ooo`3<0<`0203<0<`00`000000
oooo0<`0c0080<`0c0030000003oool0c02I00P0c02I00<000000?ooo`3<06H0203<06H00`000000
oooo0<`0<`080<`0<`030000003oool0c00000P0c00000<000000?ooo`3<<`00203<<`000`000000
oooo0<aV00080<aV00030000003oool0c9T000P0c9T000<000000?ooo`3<c000203<c0000`000000
oooo0<c<00080<c<00030000003oool0c<`000P0c<`000<000000?ooo`2Ic000202Ic0000`000000
oooo06K<000806K<00030000003oool0<l`000P0<l`000<000000?ooo`00c0002000c0000`000000
oooo003<<`08003<<`030000003oool00<aV00P00<aV00<000000?ooo`00c9T02000c9T00`000000
oooo003<c008003<c0030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000
oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000
oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@0000000005
08S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo0?ooo`3o0?oooeD0oooo00<000000<c<
c03<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?oo
o`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?oo
o`000000L`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`
0<c<c0030000003oool0000000T0000000<0oooo000000000000200000000`3oool0000000000008
000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool0000000000008
000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool0000000000008
000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool0000000000008
000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool0000000000008
000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool0000000000008
000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool0000000000008
000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool0000000000008
000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool0000000000008
000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool0000000000008
000000030?ooo`000000000000P0000000<0oooo0000003<c<`02@3<c<`00`000000oooo0<c<c008
0<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c008
0<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`000000L`3<c<`0101VIVH0R<2h08S0^018
T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0VIVI00P0VIVI00<0
00000?ooo`00ool02000ool00`000000oooo003<o`08003<o`030000003oool009Wo00P009Wo00<0
00000?ooo`00I_l02000I_l00`000000oooo000co`08000co`030000003oool0003o00P0003o00<0
00000?ooo`0c0?l0200c0?l00`000000oooo06H0o`0806H0o`030000003oool0V@3o00P0V@3o00<0
00000?ooo`3<0?l0203<0?l00`000000oooo0?l0o`080?l0o`030000003oool0o`3<00P0o`3<00<0
00000?ooo`3o09T0203o09T00`000000oooo0?l0IP080?l0IP030000003oool0o`0c00P0o`0c00<0
00000?ooo`3o0000203o00000`000000oooo0?lc00080?lc00030000003oool0ofH000P0ofH000<0
00000?ooo`3oV@00203oV@000`000000oooo0?o<00080?o<00030000003oool0ool000P0ool000<0
00000?ooo`3<o`00203<o`000`000000oooo09Wo000809Wo00030000003oool0I_l000P0I_l000<0
00000?ooo`0co`00200co`000`000000oooo003o0008003o00030000003oool00?lc00P00?lc00<0
00000?ooo`00ofH02000ofH00`000000oooo003oV@08003oV@030000003oool00?o<00P00?o<00<0
00000?ooo`0000002P3<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<0
00000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<0
00000?ooo`000000L`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h
0?ooo`1`0<c<c0030000003oool0VIVI00P0VIVI00<000000?ooo`00ool02000ool00`000000oooo
003<o`08003<o`030000003oool009Wo00P009Wo00<000000?ooo`00I_l02000I_l00`000000oooo
000co`08000co`030000003oool0003o00P0003o00<000000?ooo`0c0?l0200c0?l00`000000oooo
06H0o`0806H0o`030000003oool0V@3o00P0V@3o00<000000?ooo`3<0?l0203<0?l00`000000oooo
0?l0o`080?l0o`030000003oool0o`3<00P0o`3<00<000000?ooo`3o09T0203o09T00`000000oooo
0?l0IP080?l0IP030000003oool0o`0c00P0o`0c00<000000?ooo`3o0000203o00000`000000oooo
0?lc00080?lc00030000003oool0ofH000P0ofH000<000000?ooo`3oV@00203oV@000`000000oooo
0?o<00080?o<00030000003oool0ool000P0ool000<000000?ooo`3<o`00203<o`000`000000oooo
09Wo000809Wo00030000003oool0I_l000P0I_l000<000000?ooo`0co`00200co`000`000000oooo
003o0008003o00030000003oool00?lc00P00?lc00<000000?ooo`00ofH02000ofH00`000000oooo
003oV@08003oV@030000003oool00?o<00P00?o<00<000000?ooo`0000002P3<c<`00`000000oooo
0?ooo`0f0?ooo`030000003<c<`0c<c<0740c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo09VIV@0809VIV@030000003oool00?oo00P0
0?oo00<000000?ooo`00c?l02000c?l00`000000oooo002Io`08002Io`030000003oool006Ko00P0
06Ko00<000000?ooo`00<ol02000<ol00`000000oooo0000o`080000o`030000003oool0<`3o00P0
<`3o00<000000?ooo`1V0?l0201V0?l00`000000oooo09T0o`0809T0o`030000003oool0c03o00P0
c03o00<000000?ooo`3o0?l0203o0?l00`000000oooo0?l0c0080?l0c0030000003oool0o`2I00P0
o`2I00<000000?ooo`3o06H0203o06H00`000000oooo0?l0<`080?l0<`030000003oool0o`0000P0
o`0000<000000?ooo`3o<`00203o<`000`000000oooo0?mV00080?mV00030000003oool0oiT000P0
oiT000<000000?ooo`3oc000203oc0000`000000oooo0?oo00080?oo00030000003oool0c?l000P0
c?l000<000000?ooo`2Io`00202Io`000`000000oooo06Ko000806Ko00030000003oool0<ol000P0
<ol000<000000?ooo`00o`002000o`000`000000oooo003o<`08003o<`030000003oool00?mV00P0
0?mV00<000000?ooo`00oiT02000oiT00`000000oooo003oc008003oc0030000003oool0000000X0
c<c<00<000000?ooo`0000002@0000000`3oool0000000000008000000030?ooo`000000000000P0
000000<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000c<c<0780
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`00
0000oooo09VIV@0809VIV@030000003oool00?oo00P00?oo00<000000?ooo`00c?l02000c?l00`00
0000oooo002Io`08002Io`030000003oool006Ko00P006Ko00<000000?ooo`00<ol02000<ol00`00
0000oooo0000o`080000o`030000003oool0<`3o00P0<`3o00<000000?ooo`1V0?l0201V0?l00`00
0000oooo09T0o`0809T0o`030000003oool0c03o00P0c03o00<000000?ooo`3o0?l0203o0?l00`00
0000oooo0?l0c0080?l0c0030000003oool0o`2I00P0o`2I00<000000?ooo`3o06H0203o06H00`00
0000oooo0?l0<`080?l0<`030000003oool0o`0000P0o`0000<000000?ooo`3o<`00203o<`000`00
0000oooo0?mV00080?mV00030000003oool0oiT000P0oiT000<000000?ooo`3oc000203oc0000`00
0000oooo0?oo00080?oo00030000003oool0c?l000P0c?l000<000000?ooo`2Io`00202Io`000`00
0000oooo06Ko000806Ko00030000003oool0<ol000P0<ol000<000000?ooo`00o`002000o`000`00
0000oooo003o<`08003o<`030000003oool00?mV00P00?mV00<000000?ooo`00oiT02000oiT00`00
0000oooo003oc008003oc0030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`00
0000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`00
0000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo09VIV@0809VIV@030000003oool0
0?oo00P00?oo00<000000?ooo`00c?l02000c?l00`000000oooo002Io`08002Io`030000003oool0
06Ko00P006Ko00<000000?ooo`00<ol02000<ol00`000000oooo0000o`080000o`030000003oool0
<`3o00P0<`3o00<000000?ooo`1V0?l0201V0?l00`000000oooo09T0o`0809T0o`030000003oool0
c03o00P0c03o00<000000?ooo`3o0?l0203o0?l00`000000oooo0?l0c0080?l0c0030000003oool0
o`2I00P0o`2I00<000000?ooo`3o06H0203o06H00`000000oooo0?l0<`080?l0<`030000003oool0
o`0000P0o`0000<000000?ooo`3o<`00203o<`000`000000oooo0?mV00080?mV00030000003oool0
oiT000P0oiT000<000000?ooo`3oc000203oc0000`000000oooo0?oo00080?oo00030000003oool0
c?l000P0c?l000<000000?ooo`2Io`00202Io`000`000000oooo06Ko000806Ko00030000003oool0
<ol000P0<ol000<000000?ooo`00o`002000o`000`000000oooo003o<`08003o<`030000003oool0
0?mV00P00?mV00<000000?ooo`00oiT02000oiT00`000000oooo003oc008003oc0030000003oool0
000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0
c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0
000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<
c<`00`000000oooo09VIV@0809VIV@030000003oool00?oo00P00?oo00<000000?ooo`00c?l02000
c?l00`000000oooo002Io`08002Io`030000003oool006Ko00P006Ko00<000000?ooo`00<ol02000
<ol00`000000oooo0000o`080000o`030000003oool0<`3o00P0<`3o00<000000?ooo`1V0?l0201V
0?l00`000000oooo09T0o`0809T0o`030000003oool0c03o00P0c03o00<000000?ooo`3o0?l0203o
0?l00`000000oooo0?l0c0080?l0c0030000003oool0o`2I00P0o`2I00<000000?ooo`3o06H0203o
06H00`000000oooo0?l0<`080?l0<`030000003oool0o`0000P0o`0000<000000?ooo`3o<`00203o
<`000`000000oooo0?mV00080?mV00030000003oool0oiT000P0oiT000<000000?ooo`3oc000203o
c0000`000000oooo0?oo00080?oo00030000003oool0c?l000P0c?l000<000000?ooo`2Io`00202I
o`000`000000oooo06Ko000806Ko00030000003oool0<ol000P0<ol000<000000?ooo`00o`002000
o`000`000000oooo003o<`08003o<`030000003oool00?mV00P00?mV00<000000?ooo`00oiT02000
oiT00`000000oooo003oc008003oc0030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<
c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<
c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B928
0@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo09VIV@0809VIV@030000
003oool00?oo00P00?oo00<000000?ooo`00c?l02000c?l00`000000oooo002Io`08002Io`030000
003oool006Ko00P006Ko00<000000?ooo`00<ol02000<ol00`000000oooo0000o`080000o`030000
003oool0<`3o00P0<`3o00<000000?ooo`1V0?l0201V0?l00`000000oooo09T0o`0809T0o`030000
003oool0c03o00P0c03o00<000000?ooo`3o0?l0203o0?l00`000000oooo0?l0c0080?l0c0030000
003oool0o`2I00P0o`2I00<000000?ooo`3o06H0203o06H00`000000oooo0?l0<`080?l0<`030000
003oool0o`0000P0o`0000<000000?ooo`3o<`00203o<`000`000000oooo0?mV00080?mV00030000
003oool0oiT000P0oiT000<000000?ooo`3oc000203oc0000`000000oooo0?oo00080?oo00030000
003oool0c?l000P0c?l000<000000?ooo`2Io`00202Io`000`000000oooo06Ko000806Ko00030000
003oool0<ol000P0<ol000<000000?ooo`00o`002000o`000`000000oooo003o<`08003o<`030000
003oool00?mV00P00?mV00<000000?ooo`00oiT02000oiT00`000000oooo003oc008003oc0030000
003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000
003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000
003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03o
ool0L03<c<`00`000000oooo09VIV@0809VIV@030000003oool00?oo00P00?oo00<000000?ooo`00
c?l02000c?l00`000000oooo002Io`08002Io`030000003oool006Ko00P006Ko00<000000?ooo`00
<ol02000<ol00`000000oooo0000o`080000o`030000003oool0<`3o00P0<`3o00<000000?ooo`1V
0?l0201V0?l00`000000oooo09T0o`0809T0o`030000003oool0c03o00P0c03o00<000000?ooo`3o
0?l0203o0?l00`000000oooo0?l0c0080?l0c0030000003oool0o`2I00P0o`2I00<000000?ooo`3o
06H0203o06H00`000000oooo0?l0<`080?l0<`030000003oool0o`0000P0o`0000<000000?ooo`3o
<`00203o<`000`000000oooo0?mV00080?mV00030000003oool0oiT000P0oiT000<000000?ooo`3o
c000203oc0000`000000oooo0?oo00080?oo00030000003oool0c?l000P0c?l000<000000?ooo`2I
o`00202Io`000`000000oooo06Ko000806Ko00030000003oool0<ol000P0<ol000<000000?ooo`00
o`002000o`000`000000oooo003o<`08003o<`030000003oool00?mV00P00?mV00<000000?ooo`00
oiT02000oiT00`000000oooo003oc008003oc0030000003oool0000000X0c<c<00<000000?ooo`3<
c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<
c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028
`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo09VIV@0809VI
V@030000003oool00?oo00P00?oo00<000000?ooo`00c?l02000c?l00`000000oooo002Io`08002I
o`030000003oool006Ko00P006Ko00<000000?ooo`00<ol02000<ol00`000000oooo0000o`080000
o`030000003oool0<`3o00P0<`3o00<000000?ooo`1V0?l0201V0?l00`000000oooo09T0o`0809T0
o`030000003oool0c03o00P0c03o00<000000?ooo`3o0?l0203o0?l00`000000oooo0?l0c0080?l0
c0030000003oool0o`2I00P0o`2I00<000000?ooo`3o06H0203o06H00`000000oooo0?l0<`080?l0
<`030000003oool0o`0000P0o`0000<000000?ooo`3o<`00203o<`000`000000oooo0?mV00080?mV
00030000003oool0oiT000P0oiT000<000000?ooo`3oc000203oc0000`000000oooo0?oo00080?oo
00030000003oool0c?l000P0c?l000<000000?ooo`2Io`00202Io`000`000000oooo06Ko000806Ko
00030000003oool0<ol000P0<ol000<000000?ooo`00o`002000o`000`000000oooo003o<`08003o
<`030000003oool00?mV00P00?mV00<000000?ooo`00oiT02000oiT00`000000oooo003oc008003o
c0030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<
c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<
c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0L03<c<`00`000000oooo0?ooo`3o0?oooeD0oooo00<000000<c<c03<c<`0203<c<`0
0`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`0
0`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`000000L`3<c<`0
101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003o
ool0000000T0000000<0oooo000000000000200000000`3oool0000000000008000000030?ooo`00
0000000000P0000000<0oooo000000000000200000000`3oool0000000000008000000030?ooo`00
0000000000P0000000<0oooo000000000000200000000`3oool0000000000008000000030?ooo`00
0000000000P0000000<0oooo000000000000200000000`3oool0000000000008000000030?ooo`00
0000000000P0000000<0oooo000000000000200000000`3oool0000000000008000000030?ooo`00
0000000000P0000000<0oooo000000000000200000000`3oool0000000000008000000030?ooo`00
0000000000P0000000<0oooo000000000000200000000`3oool0000000000008000000030?ooo`00
0000000000P0000000<0oooo000000000000200000000`3oool0000000000008000000030?ooo`00
0000000000P0000000<0oooo000000000000200000000`3oool0000000000008000000030?ooo`00
0000000000P0000000<0oooo000000000000200000000`3oool0000000000008000000030?ooo`00
0000000000P0000000<0oooo0000003<c<`02@3<c<`00`000000oooo0<c<c0080<c<c0030000003o
ool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003o
ool0c<c<00P0c<c<00<000000?ooo`000000L`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0
R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0VIVI00P0VIVI00<000000?ooo`0cool0
200cool00`000000oooo03?<o`0803?<o`030000003oool0<iWo00P0<iWo00<000000?ooo`0cI_l0
200cI_l00`000000oooo03<co`0803<co`030000003oool0<c?o00P0<c?o00<000000?ooo`0c<ol0
200c<ol00`000000oooo06Hco`0806Hco`030000003oool0VC?o00P0VC?o00<000000?ooo`3<<ol0
203<<ol00`000000oooo0?lco`080?lco`030000003oool0oc?<00P0oc?<00<000000?ooo`3o<iT0
203o<iT00`000000oooo0?lcIP080?lcIP030000003oool0oc<c00P0oc<c00<000000?ooo`3o<c<0
203o<c<00`000000oooo0?lc<`080?lc<`030000003oool0ofHc00P0ofHc00<000000?ooo`3oVC<0
203oVC<00`000000oooo0?o<<`080?o<<`030000003oool0oolc00P0oolc00<000000?ooo`3<oc<0
203<oc<00`000000oooo09Wd<`0809Wd<`030000003oool0I_lc00P0I_lc00<000000?ooo`0coc<0
200coc<00`000000oooo03?o<`0803?o<`030000003oool0<olc00P0<olc00<000000?ooo`0cofH0
200cofH00`000000oooo03?oV@0803?oV@030000003oool0<oo<00P0<oo<00<000000?ooo`000000
2P3<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0
203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`000000
L`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c003
0000003oool0VIVI00P0VIVI00<000000?ooo`0cool0200cool00`000000oooo03?<o`0803?<o`03
0000003oool0<iWo00P0<iWo00<000000?ooo`0cI_l0200cI_l00`000000oooo03<co`0803<co`03
0000003oool0<c?o00P0<c?o00<000000?ooo`0c<ol0200c<ol00`000000oooo06Hco`0806Hco`03
0000003oool0VC?o00P0VC?o00<000000?ooo`3<<ol0203<<ol00`000000oooo0?lco`080?lco`03
0000003oool0oc?<00P0oc?<00<000000?ooo`3o<iT0203o<iT00`000000oooo0?lcIP080?lcIP03
0000003oool0oc<c00P0oc<c00<000000?ooo`3o<c<0203o<c<00`000000oooo0?lc<`080?lc<`03
0000003oool0ofHc00P0ofHc00<000000?ooo`3oVC<0203oVC<00`000000oooo0?o<<`080?o<<`03
0000003oool0oolc00P0oolc00<000000?ooo`3<oc<0203<oc<00`000000oooo09Wd<`0809Wd<`03
0000003oool0I_lc00P0I_lc00<000000?ooo`0coc<0200coc<00`000000oooo03?o<`0803?o<`03
0000003oool0<olc00P0<olc00<000000?ooo`0cofH0200cofH00`000000oooo03?oV@0803?oV@03
0000003oool0<oo<00P0<oo<00<000000?ooo`0000002P3<c<`00`000000oooo0?ooo`0f0?ooo`03
0000003<c<`0c<c<0740c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0L03<c<`00`000000oooo09VIV@0809VIV@030000003oool0<ooo00P0<ooo00<000000?oo
o`0cc?l0200cc?l00`000000oooo03>Io`0803>Io`030000003oool0<fKo00P0<fKo00<000000?oo
o`0c<ol0200c<ol00`000000oooo03<co`0803<co`030000003oool0<c?o00P0<c?o00<000000?oo
o`1V<ol0201V<ol00`000000oooo09Tco`0809Tco`030000003oool0c3?o00P0c3?o00<000000?oo
o`3o<ol0203o<ol00`000000oooo0?lcc0080?lcc0030000003oool0oc>I00P0oc>I00<000000?oo
o`3o<fH0203o<fH00`000000oooo0?lc<`080?lc<`030000003oool0oc<c00P0oc<c00<000000?oo
o`3o<c<0203o<c<00`000000oooo0?mV<`080?mV<`030000003oool0oiTc00P0oiTc00<000000?oo
o`3oc3<0203oc3<00`000000oooo0?oo<`080?oo<`030000003oool0c?lc00P0c?lc00<000000?oo
o`2Im3<0202Im3<00`000000oooo06Ko<`0806Ko<`030000003oool0<olc00P0<olc00<000000?oo
o`0coc<0200coc<00`000000oooo03?o<`0803?o<`030000003oool0<omV00P0<omV00<000000?oo
o`0coiT0200coiT00`000000oooo03?oc00803?oc0030000003oool0000000X0c<c<00<000000?oo
o`0000002@0000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo0000
00000000200000000`3oool0000000000008000000030?ooo`000000c<c<0780c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo09VIV@08
09VIV@030000003oool0<ooo00P0<ooo00<000000?ooo`0cc?l0200cc?l00`000000oooo03>Io`08
03>Io`030000003oool0<fKo00P0<fKo00<000000?ooo`0c<ol0200c<ol00`000000oooo03<co`08
03<co`030000003oool0<c?o00P0<c?o00<000000?ooo`1V<ol0201V<ol00`000000oooo09Tco`08
09Tco`030000003oool0c3?o00P0c3?o00<000000?ooo`3o<ol0203o<ol00`000000oooo0?lcc008
0?lcc0030000003oool0oc>I00P0oc>I00<000000?ooo`3o<fH0203o<fH00`000000oooo0?lc<`08
0?lc<`030000003oool0oc<c00P0oc<c00<000000?ooo`3o<c<0203o<c<00`000000oooo0?mV<`08
0?mV<`030000003oool0oiTc00P0oiTc00<000000?ooo`3oc3<0203oc3<00`000000oooo0?oo<`08
0?oo<`030000003oool0c?lc00P0c?lc00<000000?ooo`2Im3<0202Im3<00`000000oooo06Ko<`08
06Ko<`030000003oool0<olc00P0<olc00<000000?ooo`0coc<0200coc<00`000000oooo03?o<`08
03?o<`030000003oool0<omV00P0<omV00<000000?ooo`0coiT0200coiT00`000000oooo03?oc008
03?oc0030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c008
0<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c008
0<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0L03<c<`00`000000oooo09VIV@0809VIV@030000003oool0<ooo00P0<ooo00<0
00000?ooo`0cc?l0200cc?l00`000000oooo03>Io`0803>Io`030000003oool0<fKo00P0<fKo00<0
00000?ooo`0c<ol0200c<ol00`000000oooo03<co`0803<co`030000003oool0<c?o00P0<c?o00<0
00000?ooo`1V<ol0201V<ol00`000000oooo09Tco`0809Tco`030000003oool0c3?o00P0c3?o00<0
00000?ooo`3o<ol0203o<ol00`000000oooo0?lcc0080?lcc0030000003oool0oc>I00P0oc>I00<0
00000?ooo`3o<fH0203o<fH00`000000oooo0?lc<`080?lc<`030000003oool0oc<c00P0oc<c00<0
00000?ooo`3o<c<0203o<c<00`000000oooo0?mV<`080?mV<`030000003oool0oiTc00P0oiTc00<0
00000?ooo`3oc3<0203oc3<00`000000oooo0?oo<`080?oo<`030000003oool0c?lc00P0c?lc00<0
00000?ooo`2Im3<0202Im3<00`000000oooo06Ko<`0806Ko<`030000003oool0<olc00P0<olc00<0
00000?ooo`0coc<0200coc<00`000000oooo03?o<`0803?o<`030000003oool0<omV00P0<omV00<0
00000?ooo`0coiT0200coiT00`000000oooo03?oc00803?oc0030000003oool0000000X0c<c<00<0
00000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<0
00000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo
09VIV@0809VIV@030000003oool0<ooo00P0<ooo00<000000?ooo`0cc?l0200cc?l00`000000oooo
03>Io`0803>Io`030000003oool0<fKo00P0<fKo00<000000?ooo`0c<ol0200c<ol00`000000oooo
03<co`0803<co`030000003oool0<c?o00P0<c?o00<000000?ooo`1V<ol0201V<ol00`000000oooo
09Tco`0809Tco`030000003oool0c3?o00P0c3?o00<000000?ooo`3o<ol0203o<ol00`000000oooo
0?lcc0080?lcc0030000003oool0oc>I00P0oc>I00<000000?ooo`3o<fH0203o<fH00`000000oooo
0?lc<`080?lc<`030000003oool0oc<c00P0oc<c00<000000?ooo`3o<c<0203o<c<00`000000oooo
0?mV<`080?mV<`030000003oool0oiTc00P0oiTc00<000000?ooo`3oc3<0203oc3<00`000000oooo
0?oo<`080?oo<`030000003oool0c?lc00P0c?lc00<000000?ooo`2Im3<0202Im3<00`000000oooo
06Ko<`0806Ko<`030000003oool0<olc00P0<olc00<000000?ooo`0coc<0200coc<00`000000oooo
03?o<`0803?o<`030000003oool0<omV00P0<omV00<000000?ooo`0coiT0200coiT00`000000oooo
03?oc00803?oc0030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo
0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo
0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo09VIV@0809VIV@030000003oool0<ooo00P0
<ooo00<000000?ooo`0cc?l0200cc?l00`000000oooo03>Io`0803>Io`030000003oool0<fKo00P0
<fKo00<000000?ooo`0c<ol0200c<ol00`000000oooo03<co`0803<co`030000003oool0<c?o00P0
<c?o00<000000?ooo`1V<ol0201V<ol00`000000oooo09Tco`0809Tco`030000003oool0c3?o00P0
c3?o00<000000?ooo`3o<ol0203o<ol00`000000oooo0?lcc0080?lcc0030000003oool0oc>I00P0
oc>I00<000000?ooo`3o<fH0203o<fH00`000000oooo0?lc<`080?lc<`030000003oool0oc<c00P0
oc<c00<000000?ooo`3o<c<0203o<c<00`000000oooo0?mV<`080?mV<`030000003oool0oiTc00P0
oiTc00<000000?ooo`3oc3<0203oc3<00`000000oooo0?oo<`080?oo<`030000003oool0c?lc00P0
c?lc00<000000?ooo`2Im3<0202Im3<00`000000oooo06Ko<`0806Ko<`030000003oool0<olc00P0
<olc00<000000?ooo`0coc<0200coc<00`000000oooo03?o<`0803?o<`030000003oool0<omV00P0
<omV00<000000?ooo`0coiT0200coiT00`000000oooo03?oc00803?oc0030000003oool0000000X0
c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0
c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`00
0000oooo09VIV@0809VIV@030000003oool0<ooo00P0<ooo00<000000?ooo`0cc?l0200cc?l00`00
0000oooo03>Io`0803>Io`030000003oool0<fKo00P0<fKo00<000000?ooo`0c<ol0200c<ol00`00
0000oooo03<co`0803<co`030000003oool0<c?o00P0<c?o00<000000?ooo`1V<ol0201V<ol00`00
0000oooo09Tco`0809Tco`030000003oool0c3?o00P0c3?o00<000000?ooo`3o<ol0203o<ol00`00
0000oooo0?lcc0080?lcc0030000003oool0oc>I00P0oc>I00<000000?ooo`3o<fH0203o<fH00`00
0000oooo0?lc<`080?lc<`030000003oool0oc<c00P0oc<c00<000000?ooo`3o<c<0203o<c<00`00
0000oooo0?mV<`080?mV<`030000003oool0oiTc00P0oiTc00<000000?ooo`3oc3<0203oc3<00`00
0000oooo0?oo<`080?oo<`030000003oool0c?lc00P0c?lc00<000000?ooo`2Im3<0202Im3<00`00
0000oooo06Ko<`0806Ko<`030000003oool0<olc00P0<olc00<000000?ooo`0coc<0200coc<00`00
0000oooo03?o<`0803?o<`030000003oool0<omV00P0<omV00<000000?ooo`0coiT0200coiT00`00
0000oooo03?oc00803?oc0030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`00
0000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`00
0000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo09VIV@0809VIV@030000003oool0
<ooo00P0<ooo00<000000?ooo`0cc?l0200cc?l00`000000oooo03>Io`0803>Io`030000003oool0
<fKo00P0<fKo00<000000?ooo`0c<ol0200c<ol00`000000oooo03<co`0803<co`030000003oool0
<c?o00P0<c?o00<000000?ooo`1V<ol0201V<ol00`000000oooo09Tco`0809Tco`030000003oool0
c3?o00P0c3?o00<000000?ooo`3o<ol0203o<ol00`000000oooo0?lcc0080?lcc0030000003oool0
oc>I00P0oc>I00<000000?ooo`3o<fH0203o<fH00`000000oooo0?lc<`080?lc<`030000003oool0
oc<c00P0oc<c00<000000?ooo`3o<c<0203o<c<00`000000oooo0?mV<`080?mV<`030000003oool0
oiTc00P0oiTc00<000000?ooo`3oc3<0203oc3<00`000000oooo0?oo<`080?oo<`030000003oool0
c?lc00P0c?lc00<000000?ooo`2Im3<0202Im3<00`000000oooo06Ko<`0806Ko<`030000003oool0
<olc00P0<olc00<000000?ooo`0coc<0200coc<00`000000oooo03?o<`0803?o<`030000003oool0
<omV00P0<omV00<000000?ooo`0coiT0200coiT00`000000oooo03?oc00803?oc0030000003oool0
000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0
c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0
000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<
c<`00`000000oooo0?ooo`3o0?oooeD0oooo00<000000<c<c03<c<`0203<c<`00`000000oooo0<c<
c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<
c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`000000L`3<c<`0101VIVH0R<2h08S0
^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0000000T00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo000000000000200000000`3oool0000000000008000000030?ooo`000000000000P00000
00<0oooo0000003<c<`02@3<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<
00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<
00<000000?ooo`000000L`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0
R<2h0?ooo`1`0<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`1Vool0201Vool00`000000
oooo06K<o`0806K<o`030000003oool0IYWo00P0IYWo00<000000?ooo`1VI_l0201VI_l00`000000
oooo06IVo`0806IVo`030000003oool0IVKo00P0IVKo00<000000?ooo`1VI_l0201VI_l00`000000
oooo06IVo`0806IVo`030000003oool0VFKo00P0VFKo00<000000?ooo`3<I_l0203<I_l00`000000
oooo0?mVo`080?mVo`030000003oool0ofK<00P0ofK<00<000000?ooo`3oIYT0203oIYT00`000000
oooo0?mVIP080?mVIP030000003oool0ofIV00P0ofIV00<000000?ooo`3oIVH0203oIVH00`000000
oooo0?mVIP080?mVIP030000003oool0ofIV00P0ofIV00<000000?ooo`3oVFH0203oVFH00`000000
oooo0?o<IP080?o<IP030000003oool0oomV00P0oomV00<000000?ooo`3<ofH0203<ofH00`000000
oooo09WoIP0809WoIP030000003oool0I_mV00P0I_mV00<000000?ooo`1VofH0201VofH00`000000
oooo06KoIP0806KoIP030000003oool0I_mV00P0I_mV00<000000?ooo`1VofH0201VofH00`000000
oooo06KoV@0806KoV@030000003oool0I_o<00P0I_o<00<000000?ooo`0000002P3<c<`00`000000
oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000
oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`000000L`3<c<`0101VIVH0
R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0c<c<
00P0c<c<00<000000?ooo`1Vool0201Vool00`000000oooo06K<o`0806K<o`030000003oool0IYWo
00P0IYWo00<000000?ooo`1VI_l0201VI_l00`000000oooo06IVo`0806IVo`030000003oool0IVKo
00P0IVKo00<000000?ooo`1VI_l0201VI_l00`000000oooo06IVo`0806IVo`030000003oool0VFKo
00P0VFKo00<000000?ooo`3<I_l0203<I_l00`000000oooo0?mVo`080?mVo`030000003oool0ofK<
00P0ofK<00<000000?ooo`3oIYT0203oIYT00`000000oooo0?mVIP080?mVIP030000003oool0ofIV
00P0ofIV00<000000?ooo`3oIVH0203oIVH00`000000oooo0?mVIP080?mVIP030000003oool0ofIV
00P0ofIV00<000000?ooo`3oVFH0203oVFH00`000000oooo0?o<IP080?o<IP030000003oool0oomV
00P0oomV00<000000?ooo`3<ofH0203<ofH00`000000oooo09WoIP0809WoIP030000003oool0I_mV
00P0I_mV00<000000?ooo`1VofH0201VofH00`000000oooo06KoIP0806KoIP030000003oool0I_mV
00P0I_mV00<000000?ooo`1VofH0201VofH00`000000oooo06KoV@0806KoV@030000003oool0I_o<
00P0I_o<00<000000?ooo`0000002P3<c<`00`000000oooo0?ooo`0f0?ooo`030000003<c<`0c<c<
0740c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`0
0`000000oooo0<c<c0080<c<c0030000003oool0I_oo00P0I_oo00<000000?ooo`1Vc?l0201Vc?l0
0`000000oooo06JIo`0806JIo`030000003oool0IVKo00P0IVKo00<000000?ooo`1VI_l0201VI_l0
0`000000oooo06IVo`0806IVo`030000003oool0IVKo00P0IVKo00<000000?ooo`1VI_l0201VI_l0
0`000000oooo09UVo`0809UVo`030000003oool0c6Ko00P0c6Ko00<000000?ooo`3oI_l0203oI_l0
0`000000oooo0?mVc0080?mVc0030000003oool0ofJI00P0ofJI00<000000?ooo`3oIVH0203oIVH0
0`000000oooo0?mVIP080?mVIP030000003oool0ofIV00P0ofIV00<000000?ooo`3oIVH0203oIVH0
0`000000oooo0?mVIP080?mVIP030000003oool0oiUV00P0oiUV00<000000?ooo`3oc6H0203oc6H0
0`000000oooo0?ooIP080?ooIP030000003oool0c?mV00P0c?mV00<000000?ooo`2IofH0202IofH0
0`000000oooo06KoIP0806KoIP030000003oool0I_mV00P0I_mV00<000000?ooo`1VofH0201VofH0
0`000000oooo06KoIP0806KoIP030000003oool0I_mV00P0I_mV00<000000?ooo`1VoiT0201VoiT0
0`000000oooo06Koc00806Koc0030000003oool0000000X0c<c<00<000000?ooo`0000002@000000
0`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000000020000000
0`3oool0000000000008000000030?ooo`000000c<c<0780c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo0<c<c0080<c<c0030000003o
ool0I_oo00P0I_oo00<000000?ooo`1Vc?l0201Vc?l00`000000oooo06JIo`0806JIo`030000003o
ool0IVKo00P0IVKo00<000000?ooo`1VI_l0201VI_l00`000000oooo06IVo`0806IVo`030000003o
ool0IVKo00P0IVKo00<000000?ooo`1VI_l0201VI_l00`000000oooo09UVo`0809UVo`030000003o
ool0c6Ko00P0c6Ko00<000000?ooo`3oI_l0203oI_l00`000000oooo0?mVc0080?mVc0030000003o
ool0ofJI00P0ofJI00<000000?ooo`3oIVH0203oIVH00`000000oooo0?mVIP080?mVIP030000003o
ool0ofIV00P0ofIV00<000000?ooo`3oIVH0203oIVH00`000000oooo0?mVIP080?mVIP030000003o
ool0oiUV00P0oiUV00<000000?ooo`3oc6H0203oc6H00`000000oooo0?ooIP080?ooIP030000003o
ool0c?mV00P0c?mV00<000000?ooo`2IofH0202IofH00`000000oooo06KoIP0806KoIP030000003o
ool0I_mV00P0I_mV00<000000?ooo`1VofH0201VofH00`000000oooo06KoIP0806KoIP030000003o
ool0I_mV00P0I_mV00<000000?ooo`1VoiT0201VoiT00`000000oooo06Koc00806Koc0030000003o
ool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003o
ool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003o
ool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
L03<c<`00`000000oooo0<c<c0080<c<c0030000003oool0I_oo00P0I_oo00<000000?ooo`1Vc?l0
201Vc?l00`000000oooo06JIo`0806JIo`030000003oool0IVKo00P0IVKo00<000000?ooo`1VI_l0
201VI_l00`000000oooo06IVo`0806IVo`030000003oool0IVKo00P0IVKo00<000000?ooo`1VI_l0
201VI_l00`000000oooo09UVo`0809UVo`030000003oool0c6Ko00P0c6Ko00<000000?ooo`3oI_l0
203oI_l00`000000oooo0?mVc0080?mVc0030000003oool0ofJI00P0ofJI00<000000?ooo`3oIVH0
203oIVH00`000000oooo0?mVIP080?mVIP030000003oool0ofIV00P0ofIV00<000000?ooo`3oIVH0
203oIVH00`000000oooo0?mVIP080?mVIP030000003oool0oiUV00P0oiUV00<000000?ooo`3oc6H0
203oc6H00`000000oooo0?ooIP080?ooIP030000003oool0c?mV00P0c?mV00<000000?ooo`2IofH0
202IofH00`000000oooo06KoIP0806KoIP030000003oool0I_mV00P0I_mV00<000000?ooo`1VofH0
201VofH00`000000oooo06KoIP0806KoIP030000003oool0I_mV00P0I_mV00<000000?ooo`1VoiT0
201VoiT00`000000oooo06Koc00806Koc0030000003oool0000000X0c<c<00<000000?ooo`3<c<`0
203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0
203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo0<c<c0080<c<c003
0000003oool0I_oo00P0I_oo00<000000?ooo`1Vc?l0201Vc?l00`000000oooo06JIo`0806JIo`03
0000003oool0IVKo00P0IVKo00<000000?ooo`1VI_l0201VI_l00`000000oooo06IVo`0806IVo`03
0000003oool0IVKo00P0IVKo00<000000?ooo`1VI_l0201VI_l00`000000oooo09UVo`0809UVo`03
0000003oool0c6Ko00P0c6Ko00<000000?ooo`3oI_l0203oI_l00`000000oooo0?mVc0080?mVc003
0000003oool0ofJI00P0ofJI00<000000?ooo`3oIVH0203oIVH00`000000oooo0?mVIP080?mVIP03
0000003oool0ofIV00P0ofIV00<000000?ooo`3oIVH0203oIVH00`000000oooo0?mVIP080?mVIP03
0000003oool0oiUV00P0oiUV00<000000?ooo`3oc6H0203oc6H00`000000oooo0?ooIP080?ooIP03
0000003oool0c?mV00P0c?mV00<000000?ooo`2IofH0202IofH00`000000oooo06KoIP0806KoIP03
0000003oool0I_mV00P0I_mV00<000000?ooo`1VofH0201VofH00`000000oooo06KoIP0806KoIP03
0000003oool0I_mV00P0I_mV00<000000?ooo`1VoiT0201VoiT00`000000oooo06Koc00806Koc003
0000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c003
0000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c003
0000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0L03<c<`00`000000oooo0<c<c0080<c<c0030000003oool0I_oo00P0I_oo00<000000?oo
o`1Vc?l0201Vc?l00`000000oooo06JIo`0806JIo`030000003oool0IVKo00P0IVKo00<000000?oo
o`1VI_l0201VI_l00`000000oooo06IVo`0806IVo`030000003oool0IVKo00P0IVKo00<000000?oo
o`1VI_l0201VI_l00`000000oooo09UVo`0809UVo`030000003oool0c6Ko00P0c6Ko00<000000?oo
o`3oI_l0203oI_l00`000000oooo0?mVc0080?mVc0030000003oool0ofJI00P0ofJI00<000000?oo
o`3oIVH0203oIVH00`000000oooo0?mVIP080?mVIP030000003oool0ofIV00P0ofIV00<000000?oo
o`3oIVH0203oIVH00`000000oooo0?mVIP080?mVIP030000003oool0oiUV00P0oiUV00<000000?oo
o`3oc6H0203oc6H00`000000oooo0?ooIP080?ooIP030000003oool0c?mV00P0c?mV00<000000?oo
o`2IofH0202IofH00`000000oooo06KoIP0806KoIP030000003oool0I_mV00P0I_mV00<000000?oo
o`1VofH0201VofH00`000000oooo06KoIP0806KoIP030000003oool0I_mV00P0I_mV00<000000?oo
o`1VoiT0201VoiT00`000000oooo06Koc00806Koc0030000003oool0000000X0c<c<00<000000?oo
o`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?oo
o`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo0<c<c008
0<c<c0030000003oool0I_oo00P0I_oo00<000000?ooo`1Vc?l0201Vc?l00`000000oooo06JIo`08
06JIo`030000003oool0IVKo00P0IVKo00<000000?ooo`1VI_l0201VI_l00`000000oooo06IVo`08
06IVo`030000003oool0IVKo00P0IVKo00<000000?ooo`1VI_l0201VI_l00`000000oooo09UVo`08
09UVo`030000003oool0c6Ko00P0c6Ko00<000000?ooo`3oI_l0203oI_l00`000000oooo0?mVc008
0?mVc0030000003oool0ofJI00P0ofJI00<000000?ooo`3oIVH0203oIVH00`000000oooo0?mVIP08
0?mVIP030000003oool0ofIV00P0ofIV00<000000?ooo`3oIVH0203oIVH00`000000oooo0?mVIP08
0?mVIP030000003oool0oiUV00P0oiUV00<000000?ooo`3oc6H0203oc6H00`000000oooo0?ooIP08
0?ooIP030000003oool0c?mV00P0c?mV00<000000?ooo`2IofH0202IofH00`000000oooo06KoIP08
06KoIP030000003oool0I_mV00P0I_mV00<000000?ooo`1VofH0201VofH00`000000oooo06KoIP08
06KoIP030000003oool0I_mV00P0I_mV00<000000?ooo`1VoiT0201VoiT00`000000oooo06Koc008
06Koc0030000003oool0000000X0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c008
0<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c008
0<c<c0030000003oool0000007<0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0L03<c<`00`000000oooo0<c<c0080<c<c0030000003oool0I_oo00P0I_oo00<0
00000?ooo`1Vc?l0201Vc?l00`000000oooo06JIo`0806JIo`030000003oool0IVKo00P0IVKo00<0
00000?ooo`1VI_l0201VI_l00`000000oooo06IVo`0806IVo`030000003oool0IVKo00P0IVKo00<0
00000?ooo`1VI_l0201VI_l00`000000oooo09UVo`0809UVo`030000003oool0c6Ko00P0c6Ko00<0
00000?ooo`3oI_l0203oI_l00`000000oooo0?mVc0080?mVc0030000003oool0ofJI00P0ofJI00<0
00000?ooo`3oIVH0203oIVH00`000000oooo0?mVIP080?mVIP030000003oool0ofIV00P0ofIV00<0
00000?ooo`3oIVH0203oIVH00`000000oooo0?mVIP080?mVIP030000003oool0oiUV00P0oiUV00<0
00000?ooo`3oc6H0203oc6H00`000000oooo0?ooIP080?ooIP030000003oool0c?mV00P0c?mV00<0
00000?ooo`2IofH0202IofH00`000000oooo06KoIP0806KoIP030000003oool0I_mV00P0I_mV00<0
00000?ooo`1VofH0201VofH00`000000oooo06KoIP0806KoIP030000003oool0I_mV00P0I_mV00<0
00000?ooo`1VoiT0201VoiT00`000000oooo06Koc00806Koc0030000003oool0000000X0c<c<00<0
00000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<0
00000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0000007<0c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo
0?ooo`3o0?oooeD0oooo00<000000<c<c03<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000
003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000
003oool0c<c<00P0c<c<00<000000?ooo`000000L`3<c<`0101VIVH0R<2h08S0^018T8P100000000
00D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0000000T0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo00000000
0000200000000`3oool0000000000008000000030?ooo`000000000000P0000000<0oooo0000003<
c<`02@3<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<
c<`0203<c<`00`000000oooo0<c<c0080<c<c0030000003oool0c<c<00P0c<c<00<000000?ooo`00
0000L`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<
c0030000003oool0c<c<00P0c<c<00<000000?ooo`2Iool0202Iool00`000000oooo09W<o`0809W<
o`030000003oool0VIWo00P0VIWo00<000000?ooo`2IVOl0202IVOl00`000000oooo09VIo`0809VI
o`030000003oool0VIWo00P0VIWo00<000000?ooo`2IVOl0202IVOl00`000000oooo09VIo`0809VI
o`030000003oool0VIWo00P0VIWo00<000000?ooo`3<VOl0203<VOl00`000000oooo0?nIo`080?nI
o`030000003oool0oiW<00P0oiW<00<000000?ooo`3oVIT0203oVIT00`000000oooo0?nIV@080?nI
V@030000003oool0oiVI00P0oiVI00<000000?ooo`3oVIT0203oVIT00`000000oooo0?nIV@080?nI
V@030000003oool0oiVI00P0oiVI00<000000?ooo`3oVIT0203oVIT00`000000oooo0?o<V@080?o<
V@030000003oool0oonI00P0oonI00<000000?ooo`3<oiT0203<oiT00`000000oooo09WoV@0809Wo
V@030000003oool0VOnI00P0VOnI00<000000?ooo`2IoiT0202IoiT00`000000oooo09WoV@0809Wo
V@030000003oool0VOnI00P0VOnI00<000000?ooo`2IoiT0202IoiT00`000000oooo09WoV@0809Wo
V@030000003oool0VOo<00P0VOo<00<000000?ooo`0000002P3<c<`00`000000oooo0<c<c0080<c<
c0030000003oool0c<c<00P0c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo0<c<c0080<c<
c0030000003oool0c<c<00P0c<c<00<000000?ooo`000000L`3<c<`0101VIVH0R<2h08S0^018T8P1
0000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0c<c<00P0c<c<00<00000
0?ooo`2Iool0202Iool00`000000oooo09W<o`0809W<o`030000003oool0VIWo00P0VIWo00<00000
0?ooo`2IVOl0202IVOl00`000000oooo09VIo`0809VIo`030000003oool0VIWo00P0VIWo00<00000
0?ooo`2IVOl0202IVOl00`000000oooo09VIo`0809VIo`030000003oool0VIWo00P0VIWo00<00000
0?ooo`3<VOl0203<VOl00`000000oooo0?nIo`080?nIo`030000003oool0oiW<00P0oiW<00<00000
0?ooo`3oVIT0203oVIT00`000000oooo0?nIV@080?nIV@030000003oool0oiVI00P0oiVI00<00000
0?ooo`3oVIT0203oVIT00`000000oooo0?nIV@080?nIV@030000003oool0oiVI00P0oiVI00<00000
0?ooo`3oVIT0203oVIT00`000000oooo0?o<V@080?o<V@030000003oool0oonI00P0oonI00<00000
0?ooo`3<oiT0203<oiT00`000000oooo09WoV@0809WoV@030000003oool0VOnI00P0VOnI00<00000
0?ooo`2IoiT0202IoiT00`000000oooo09WoV@0809WoV@030000003oool0VOnI00P0VOnI00<00000
0?ooo`2IoiT0202IoiT00`000000oooo09WoV@0809WoV@030000003oool0VOo<00P0VOo<00<00000
0?ooo`0000002P3<c<`00`000000oooo0?ooo`0f0?ooo`030000003<c<`0c<c<0740c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`000000oooo0<c<
c0080<c<c0030000003oool0VOoo00P0VOoo00<000000?ooo`2Ic?l0202Ic?l00`000000oooo09VI
o`0809VIo`030000003oool0VIWo00P0VIWo00<000000?ooo`2IVOl0202IVOl00`000000oooo09VI
o`0809VIo`030000003oool0VIWo00P0VIWo00<000000?ooo`2IVOl0202IVOl00`000000oooo09VI
o`0809VIo`030000003oool0c9Wo00P0c9Wo00<000000?ooo`3oVOl0203oVOl00`000000oooo0?nI
c0080?nIc0030000003oool0oiVI00P0oiVI00<000000?ooo`3oVIT0203oVIT00`000000oooo0?nI
V@080?nIV@030000003oool0oiVI00P0oiVI00<000000?ooo`3oVIT0203oVIT00`000000oooo0?nI
V@080?nIV@030000003oool0oiVI00P0oiVI00<000000?ooo`3oc9T0203oc9T00`000000oooo0?oo
V@080?ooV@030000003oool0c?nI00P0c?nI00<000000?ooo`2IoiT0202IoiT00`000000oooo09Wo
V@0809WoV@030000003oool0VOnI00P0VOnI00<000000?ooo`2IoiT0202IoiT00`000000oooo09Wo
V@0809WoV@030000003oool0VOnI00P0VOnI00<000000?ooo`2IoiT0202IoiT00`000000oooo09Wo
c00809Woc0030000003oool0000000X0c<c<>P00001c0<c<c00406IVIP28`;P0R<2h04R@R0400000
00001@28`;P0b>3H08S0^028`;P0oooo0700c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo
09Woo`0809Woo`030000003oool0VLco00P0VLco00<000000?ooo`2IVOl0202IVOl00`000000oooo
09VIo`0809VIo`030000003oool0VIWo00P0VIWo00<000000?ooo`2IVOl0202IVOl00`000000oooo
09VIo`0809VIo`030000003oool0VIWo00P0VIWo00<000000?ooo`2IVOl0202IVOl00`000000oooo
0<bIo`080<bIo`030000003oool0oiWo00P0oiWo00<000000?ooo`3oVL`0203oVL`00`000000oooo
0?nIV@080?nIV@030000003oool0oiVI00P0oiVI00<000000?ooo`3oVIT0203oVIT00`000000oooo
0?nIV@080?nIV@030000003oool0oiVI00P0oiVI00<000000?ooo`3oVIT0203oVIT00`000000oooo
0?nIV@080?nIV@030000003oool0olbI00P0olbI00<000000?ooo`3ooiT0203ooiT00`000000oooo
0<coV@080<coV@030000003oool0VOnI00P0VOnI00<000000?ooo`2IoiT0202IoiT00`000000oooo
09WoV@0809WoV@030000003oool0VOnI00P0VOnI00<000000?ooo`2IoiT0202IoiT00`000000oooo
09WoV@0809WoV@030000003oool0VOnI00P0VOnI00<000000?ooo`2Iol`0202Iol`00`000000oooo
0000002g0<c<c00406IVIP28`;P0R<2h04R@R040000000001@28`;P0b>3H08S0^028`;P0oooo0700
c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo09Woo`0809Woo`030000003oool0VLco00P0
VLco00<000000?ooo`2IVOl0202IVOl00`000000oooo09VIo`0809VIo`030000003oool0VIWo00P0
VIWo00<000000?ooo`2IVOl0202IVOl00`000000oooo09VIo`0809VIo`030000003oool0VIWo00P0
VIWo00<000000?ooo`2IVOl0202IVOl00`000000oooo0<bIo`080<bIo`030000003oool0oiWo00P0
oiWo00<000000?ooo`3oVL`0203oVL`00`000000oooo0?nIV@080?nIV@030000003oool0oiVI00P0
oiVI00<000000?ooo`3oVIT0203oVIT00`000000oooo0?nIV@080?nIV@030000003oool0oiVI00P0
oiVI00<000000?ooo`3oVIT0203oVIT00`000000oooo0?nIV@080?nIV@030000003oool0olbI00P0
olbI00<000000?ooo`3ooiT0203ooiT00`000000oooo0<coV@080<coV@030000003oool0VOnI00P0
VOnI00<000000?ooo`2IoiT0202IoiT00`000000oooo09WoV@0809WoV@030000003oool0VOnI00P0
VOnI00<000000?ooo`2IoiT0202IoiT00`000000oooo09WoV@0809WoV@030000003oool0VOnI00P0
VOnI00<000000?ooo`2Iol`0202Iol`00`000000oooo0000000L0<c<c0030000003<c<`0c<c<09P0
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`00
0000oooo0<c<c0080<c<c0030000003oool0VOoo00P0VOoo00<000000?ooo`2Ic?l0202Ic?l00`00
0000oooo09VIo`0809VIo`030000003oool0VIWo00P0VIWo00<000000?ooo`2IVOl0202IVOl00`00
0000oooo09VIo`0809VIo`030000003oool0VIWo00P0VIWo00<000000?ooo`2IVOl0202IVOl00`00
0000oooo09VIo`0809VIo`030000003oool0c9Wo00P0c9Wo00<000000?ooo`3oVOl0203oVOl00`00
0000oooo0?nIc0080?nIc0030000003oool0oiVI00P0oiVI00<000000?ooo`3oVIT0203oVIT00`00
0000oooo0?nIV@080?nIV@030000003oool0oiVI00P0oiVI00<000000?ooo`3oVIT0203oVIT00`00
0000oooo0?nIV@080?nIV@030000003oool0oiVI00P0oiVI00<000000?ooo`3oc9T0203oc9T00`00
0000oooo0?ooV@080?ooV@030000003oool0c?nI00P0c?nI00<000000?ooo`2IoiT0202IoiT00`00
0000oooo09WoV@0809WoV@030000003oool0VOnI00P0VOnI00<000000?ooo`2IoiT0202IoiT00`00
0000oooo09WoV@0809WoV@030000003oool0VOnI00P0VOnI00<000000?ooo`2IoiT0202IoiT00`00
0000oooo09Woc00809Woc0030000003oool0000000/0c<c<00<000000<c<c03<c<`0100000020<c<
c08000000P3<c<`00`000000c<c<0000000300000080c<c<0P00002E0<c<c00406IVIP28`;P0R<2h
04R@R040000000001@28`;P0b>3H08S0^028`;P0oooo0700c<c<00<000000?ooo`3<c<`0203<c<`0
0`000000oooo09Woo`0809Woo`030000003oool0VLco00P0VLco00<000000?ooo`2IVOl0202IVOl0
0`000000oooo09VIo`0809VIo`030000003oool0VIWo00P0VIWo00<000000?ooo`2IVOl0202IVOl0
0`000000oooo09VIo`0809VIo`030000003oool0VIWo00P0VIWo00<000000?ooo`2IVOl0202IVOl0
0`000000oooo0<bIo`080<bIo`030000003oool0oiWo00P0oiWo00<000000?ooo`3oVL`0203oVL`0
0`000000oooo0?nIV@080?nIV@030000003oool0oiVI00P0oiVI00<000000?ooo`3oVIT0203oVIT0
0`000000oooo0?nIV@080?nIV@030000003oool0oiVI00P0oiVI00<000000?ooo`3oVIT0203oVIT0
0`000000oooo0?nIV@080?nIV@030000003oool0olbI00P0olbI00<000000?ooo`3ooiT0203ooiT0
0`000000oooo0<coV@080<coV@030000003oool0VOnI00P0VOnI00<000000?ooo`2IoiT0202IoiT0
0`000000oooo09WoV@0809WoV@030000003oool0VOnI00P0VOnI00<000000?ooo`2IoiT0202IoiT0
0`000000oooo09WoV@0809WoV@030000003oool0VOnI00P0VOnI00<000000?ooo`2Iol`0202Iol`0
0`000000oooo0000000;0<c<c0D0000000<0c<c<0000000000000P0000030<c<c0L0000000@0c<c<
000000000000c<c<0P00002B0<c<c00406IVIP28`;P0R<2h04R@R040000000001@28`;P0b>3H08S0
^028`;P0oooo0700c<c<00<000000?ooo`3<c<`0203<c<`00`000000oooo09Woo`0809Woo`030000
003oool0VLco00P0VLco00<000000?ooo`2IVOl0202IVOl00`000000oooo09VIo`0809VIo`030000
003oool0VIWo00P0VIWo00<000000?ooo`2IVOl0202IVOl00`000000oooo09VIo`0809VIo`030000
003oool0VIWo00P0VIWo00<000000?ooo`2IVOl0202IVOl00`000000oooo0<bIo`080<bIo`030000
003oool0oiWo00P0oiWo00<000000?ooo`3oVL`0203oVL`00`000000oooo0?nIV@080?nIV@030000
003oool0oiVI00P0oiVI00<000000?ooo`3oVIT0203oVIT00`000000oooo0?nIV@080?nIV@030000
003oool0oiVI00P0oiVI00<000000?ooo`3oVIT0203oVIT00`000000oooo0?nIV@080?nIV@030000
003oool0olbI00P0olbI00<000000?ooo`3ooiT0203ooiT00`000000oooo0<coV@080<coV@030000
003oool0VOnI00P0VOnI00<000000?ooo`2IoiT0202IoiT00`000000oooo09WoV@0809WoV@030000
003oool0VOnI00P0VOnI00<000000?ooo`2IoiT0202IoiT00`000000oooo09WoV@0809WoV@030000
003oool0VOnI00P0VOnI00<000000?ooo`2Iol`0202Iol`00`000000oooo0000000<0<c<c0@00000
00@0c<c<00000000000000001@3<c<`6000000040<c<c000000000000<c<c0800000TP3<c<`0101V
IVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0
c<c<00P0c<c<00<000000?ooo`2Iool0202Iool00`000000oooo09W<o`0809W<o`030000003oool0
VIWo00P0VIWo00<000000?ooo`2IVOl0202IVOl00`000000oooo09VIo`0809VIo`030000003oool0
VIWo00P0VIWo00<000000?ooo`2IVOl0202IVOl00`000000oooo09VIo`0809VIo`030000003oool0
VIWo00P0VIWo00<000000?ooo`3<VOl0203<VOl00`000000oooo0?nIo`080?nIo`030000003oool0
oiW<00P0oiW<00<000000?ooo`3oVIT0203oVIT00`000000oooo0?nIV@080?nIV@030000003oool0
oiVI00P0oiVI00<000000?ooo`3oVIT0203oVIT00`000000oooo0?nIV@080?nIV@030000003oool0
oiVI00P0oiVI00<000000?ooo`3oVIT0203oVIT00`000000oooo0?o<V@080?o<V@030000003oool0
oonI00P0oonI00<000000?ooo`3<oiT0203<oiT00`000000oooo09WoV@0809WoV@030000003oool0
VOnI00P0VOnI00<000000?ooo`2IoiT0202IoiT00`000000oooo09WoV@0809WoV@030000003oool0
VOnI00P0VOnI00<000000?ooo`2IoiT0202IoiT00`000000oooo09WoV@0809WoV@030000003oool0
VOo<00P0VOo<00<000000?ooo`000000303<c<`4000000030<c<c00000000000008000001@3<c<`2
00000080c<c<1000002E0<c<c00406IVIP28`;P0R<2h04R@R040000000001@28`;P0b>3H08S0^028
`;P0oooo0700c<c<00<000000?ooo`3oool0o`3ooomE0?ooo`030000003<c<`0c<c<00X0c<c<2P00
00020<c<c0X00000U@3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h
0?ooo`1`0<c<c0030000003oool0000000T0000000<0oooo000000000000200000000`3oool00000
00000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool00000
00000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool00000
00000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool00000
00000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool00000
00000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool00000
00000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool00000
00000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool00000
00000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool00000
00000008000000030?ooo`000000000000P0000000<0oooo000000000000200000000`3oool00000
00000008000000030?ooo`000000000000P0000000<0oooo0000003<c<`02P3<c<`;000000@0c<c<
0P0000020<c<c0@00000U@3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0
R<2h0?ooo`1`0<c<c0030000003oool0oooo00P0oooo00<000000?ooo`3<ool0203<ool00`000000
oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000
oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000
oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000
oooo0?o<o`080?o<o`030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000
oooo0?o<c0080?o<c0030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000
oooo0?o<c0080?o<c0030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000
oooo0?o<c0080?o<c0030000003oool0ooo<00P0ooo<00<000000?ooo`3<ol`0203<ol`00`000000
oooo0<coc0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`00`000000
oooo0<coc0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`00`000000
oooo0<coc0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`000000603<c<`=00000980
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0L03<c<`00`00
0000oooo0?ooo`080?ooo`030000003oool0c?oo00P0c?oo00<000000?ooo`3<c?l0203<c?l00`00
0000oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`00
0000oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`00
0000oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3oc?l0203oc?l00`00
0000oooo0?o<c0080?o<c0030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`00
0000oooo0?o<c0080?o<c0030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`00
0000oooo0?o<c0080?o<c0030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`00
0000oooo0?ooc0080?ooc0030000003oool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`00`00
0000oooo0<coc0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`00`00
0000oooo0<coc0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`00`00
0000oooo0<coc0080<coc0030000003oool0000000`0c<c<2@0000040<c<c0@0000000<0c<c<0000
000000000`3<c<`200000980c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0L03<c<`00`000000oooo0?ooo`080?ooo`030000003oool0c?oo00P0c?oo00<00000
0?ooo`3<c?l0203<c?l00`000000oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<00000
0?ooo`3<c?l0203<c?l00`000000oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<00000
0?ooo`3<c?l0203<c?l00`000000oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<00000
0?ooo`3oc?l0203oc?l00`000000oooo0?o<c0080?o<c0030000003oool0olc<00P0olc<00<00000
0?ooo`3oc<`0203oc<`00`000000oooo0?o<c0080?o<c0030000003oool0olc<00P0olc<00<00000
0?ooo`3oc<`0203oc<`00`000000oooo0?o<c0080?o<c0030000003oool0olc<00P0olc<00<00000
0?ooo`3oc<`0203oc<`00`000000oooo0?ooc0080?ooc0030000003oool0c?o<00P0c?o<00<00000
0?ooo`3<ol`0203<ol`00`000000oooo0<coc0080<coc0030000003oool0c?o<00P0c?o<00<00000
0?ooo`3<ol`0203<ol`00`000000oooo0<coc0080<coc0030000003oool0c?o<00P0c?o<00<00000
0?ooo`3<ol`0203<ol`00`000000oooo0<coc0080<coc0030000003oool0000000`0c<c<2@000003
0<c<c0P00000U`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?oo
o`1`0<c<c0030000003oool0oooo00P0oooo00<000000?ooo`3<ool0203<ool00`000000oooo0<c<
o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000oooo0<c<
o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000oooo0<c<
o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000oooo0?o<
o`080?o<o`030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000oooo0?o<
c0080?o<c0030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000oooo0?o<
c0080?o<c0030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000oooo0?o<
c0080?o<c0030000003oool0ooo<00P0ooo<00<000000?ooo`3<ol`0203<ol`00`000000oooo0<co
c0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`00`000000oooo0<co
c0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`00`000000oooo0<co
c0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`000000303<c<`9000000D0c<c<0P00
00020<c<c0D00000U03<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h
0?ooo`1`0<c<c0030000003oool0oooo00P0oooo00<000000?ooo`3<ool0203<ool00`000000oooo
0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000oooo
0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000oooo
0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000oooo
0?o<o`080?o<o`030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000oooo
0?o<c0080?o<c0030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000oooo
0?o<c0080?o<c0030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000oooo
0?o<c0080?o<c0030000003oool0ooo<00P0ooo<00<000000?ooo`3<ol`0203<ol`00`000000oooo
0<coc0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`00`000000oooo
0<coc0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`00`000000oooo
0<coc0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`0000006P3<c<`2000000D0c<c<
00<000000<c<c03<c<`0T`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0
R<2h0?ooo`1`0<c<c0030000003oool0oooo00P0oooo00<000000?ooo`3<ool0203<ool00`000000
oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000
oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000
oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000
oooo0?o<o`080?o<o`030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000
oooo0?o<c0080?o<c0030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000
oooo0?o<c0080?o<c0030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000
oooo0?o<c0080?o<c0030000003oool0ooo<00P0ooo<00<000000?ooo`3<ol`0203<ol`00`000000
oooo0<coc0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`00`000000
oooo0<coc0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`00`000000
oooo0<coc0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`000000]`3<c<`0101VIVH0
R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0oooo
00P0oooo00<000000?ooo`3<ool0203<ool00`000000oooo0<c<o`080<c<o`030000003oool0c<co
00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000oooo0<c<o`080<c<o`030000003oool0c<co
00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000oooo0<c<o`080<c<o`030000003oool0c<co
00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000oooo0?o<o`080?o<o`030000003oool0olc<
00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000oooo0?o<c0080?o<c0030000003oool0olc<
00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000oooo0?o<c0080?o<c0030000003oool0olc<
00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000oooo0?o<c0080?o<c0030000003oool0ooo<
00P0ooo<00<000000?ooo`3<ol`0203<ol`00`000000oooo0<coc0080<coc0030000003oool0c?o<
00P0c?o<00<000000?ooo`3<ol`0203<ol`00`000000oooo0<coc0080<coc0030000003oool0c?o<
00P0c?o<00<000000?ooo`3<ol`0203<ol`00`000000oooo0<coc0080<coc0030000003oool0c?o<
00P0c?o<00<000000?ooo`000000]`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SP
f028`;P0R<2h0?ooo`1`0<c<c0030000003oool0oooo00P0oooo00<000000?ooo`3<ool0203<ool0
0`000000oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l0
0`000000oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l0
0`000000oooo0<c<o`080<c<o`030000003oool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l0
0`000000oooo0?o<o`080?o<o`030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`0
0`000000oooo0?o<c0080?o<c0030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`0
0`000000oooo0?o<c0080?o<c0030000003oool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`0
0`000000oooo0?o<c0080?o<c0030000003oool0ooo<00P0ooo<00<000000?ooo`3<ol`0203<ol`0
0`000000oooo0<coc0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`0
0`000000oooo0<coc0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`0
0`000000oooo0<coc0080<coc0030000003oool0c?o<00P0c?o<00<000000?ooo`000000]`3<c<`0
101VIVH0R<2h08S0^018T8P10000000000D0R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003o
ool0oooo00P0oooo00<000000?ooo`3<ool0203<ool00`000000oooo0<c<o`080<c<o`030000003o
ool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000oooo0<c<o`080<c<o`030000003o
ool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000oooo0<c<o`080<c<o`030000003o
ool0c<co00P0c<co00<000000?ooo`3<c?l0203<c?l00`000000oooo0?o<o`080?o<o`030000003o
ool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000oooo0?o<c0080?o<c0030000003o
ool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000oooo0?o<c0080?o<c0030000003o
ool0olc<00P0olc<00<000000?ooo`3oc<`0203oc<`00`000000oooo0?o<c0080?o<c0030000003o
ool0ooo<00P0ooo<00<000000?ooo`3<ol`0203<ol`00`000000oooo0<coc0080<coc0030000003o
ool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`00`000000oooo0<coc0080<coc0030000003o
ool0c?o<00P0c?o<00<000000?ooo`3<ol`0203<ol`00`000000oooo0<coc0080<coc0030000003o
ool0c?o<00P0c?o<00<000000?ooo`000000]`3<c<`0101VIVH0R<2h08S0^018T8P10000000000D0
R<2h0<SPf028`;P0R<2h0?ooo`1`0<c<c0030000003oool0oooo0?l0ooooE@3oool00`000000c<c<
0<c<c02e0<c<c00406IVIP28`;P0R<2h04R@R040000000001@28`;P0b>3H08S0^028`;P0oooo0700
c<c<o`00001I00000;L0c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038
h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@0000000005
08S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B928
0@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028
`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<
c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co
0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<
c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03o
ool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038
h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@0000000005
08S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B928
0@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028
`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<
c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co
0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<
c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03o
ool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038
h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@0000000005
08S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B928
0@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028
`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<
c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co
0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<
c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03o
ool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038
h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@0000000005
08S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B928
0@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028
`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<
c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co
0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<
c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03o
ool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038
h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@0000000005
08S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B928
0@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028
`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<
c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co
0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<
c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03o
ool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038
h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0
^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@0000000005
08S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000
000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@00
0000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B928
0@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0
B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028
`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0
^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV
08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0
IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840c<c<
00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<c840
c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co0<c<
c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<c<co
0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0o`3<
c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03oool0
o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0^03o
ool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h08S0
^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0R<2h
08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000508S0^038h=P0
R<2h08S0^03oool0o`3<c<co0<c<c840c<c<00@0IVIV08S0^028`;P0B9280@000000000408S0^038
h=P0R<2h08S0^0@0ooooAP3<c<co0?ooool0oooo>03oool0101VIVH0R<2h08S0^018T8P100000000
00@0R<2h0<SPf028`;P0R<2h0P3<c<`00`1VIVH0oooo0<c<c0150<c<c00306IVIP3<c<`0VIVI02X0
VIVI00<0IVIV0<c<c02IVIT0:@2IVIT00`1VIVH0c<c<0<c<c03o0<c<c=`0c<c<0P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;P20<c<c00306IVIP3oool0c<c<04D0c<c<00<0IVIV0<c<c02I
VIT0:P2IVIT00`1VIVH0c<c<09VIV@0Y09VIV@0306IVIP3<c<`0c<c<0?l0c<c<g03<c<`208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^080c<c<00<0IVIV0?ooo`3<c<`0203<c<`=00000300
c<c<00<0IVIV0<c<c02IVIT01`2IVIT8000001/0VIVI00<0IVIV0<c<c02IVIT03`2IVIT800000180
VIVI00<0IVIV0<c<c03<c<`0o`3<c<cL0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0
R<2h0P3<c<`00`1VIVH0oooo0<c<c0150<c<c00306IVIP3<c<`0VIVI02X0VIVI00<0IVIV0<c<c02I
VIT0:@2IVIT00`1VIVH0c<c<0<c<c03o0<c<c=`0c<c<0P28`;P104R@R040000000001028`;P0b>3H
08S0^028`;P20<c<c00306IVIP3oool0c<c<00`0c<c<0P0000090<c<c0030000003<c<`0c<c<00X0
c<c<00<000000<c<c03<c<`02@3<c<`00`000000c<c<0<c<c00B0<c<c00306IVIP3<c<`0VIVI02X0
VIVI00<0IVIV0<c<c02IVIT0:@2IVIT00`1VIVH0c<c<0<c<c03o0<c<c=`0c<c<0P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;P20<c<c00306IVIP3oool0c<c<00d0c<c<0`0000070<c<c0D0
0000203<c<`4000000L0c<c<0`0000020<c<c0<000003P3<c<`00`1VIVH0c<c<09VIV@0709VIV@80
00000`2IVIT200000080VIVI1@00000209VIV@H000003@2IVIT00`1VIVH0c<c<09VIV@0709VIV@80
0000102IVIT200000080VIVI1000000209VIV@H00000302IVIT00`1VIVH0c<c<0<c<c03o0<c<c=`0
c<c<0P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20<c<c00306IVIP3oool0c<c<00h0
c<c<0`0000090<c<c0@00000203<c<`3000000L0c<c<0P0000020<c<c0@000003@3<c<`00`1VIVH0
c<c<09VIV@0709VIV@8000000`2IVIT20000000309VIV@000000000000<0VIVI0P0000000`2IVIT0
00000000000309VIV@800000302IVIT00`1VIVH0c<c<09VIV@0709VIV@8000000`2IVIT200000080
VIVI0P00000209VIV@80000000<0VIVI0000000000000`2IVIT2000000/0VIVI00<0IVIV0<c<c03<
c<`0o`3<c<cL0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P3<c<`00`1VIVH0
oooo0<c<c00?0<c<c08000002`3<c<`3000000T0c<c<0P0000070<c<c080000000@0c<c<00000000
0000c<c<0`00000;0<c<c00306IVIP3<c<`0VIVI00L0VIVI0P00000309VIV@8000001P2IVIT20000
000309VIV@000000000000<0VIVI0P00000<09VIV@0306IVIP3<c<`0VIVI00L0VIVI0P00000309VI
V@80000000<0VIVI0000000000000`2IVIT20000000309VIV@000000000000<0VIVI0P00000;09VI
V@0306IVIP3<c<`0c<c<0?l0c<c<g03<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^080c<c<00<0IVIV0?ooo`3<c<`02`3<c<`200000080c<c<0P00000<0<c<c0<000002@3<c<`20000
00H0c<c<0P0000000`3<c<`00000000000020<c<c08000002`3<c<`00`1VIVH0c<c<09VIV@0709VI
V@8000000`2IVIT2000000@0VIVI100000000`2IVIT000000000000309VIV@800000302IVIT00`1V
IVH0c<c<09VIV@0709VIV@8000000P2IVIT200000080VIVI0P00000309VIV@80000000<0VIVI0000
000000000`2IVIT2000000/0VIVI00<0IVIV0<c<c03<c<`0o`3<c<cL0<c<c080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2h0P3<c<`00`1VIVH0oooo0<c<c00;0<c<c08000000`3<c<`20000
00`0c<c<0`0000080<c<c0<000001@3<c<`2000000030<c<c0000000000000<0c<c<00<000000<c<
c03<c<`02@3<c<`00`1VIVH0c<c<09VIV@0709VIV@L000000P2IVIT500000080VIVI1P00000=09VI
V@0306IVIP3<c<`0VIVI00L0VIVI1P00000209VIV@8000000P2IVIT30000000309VIV@0000000000
00@00000302IVIT00`1VIVH0c<c<0<c<c03o0<c<c=`0c<c<0P28`;P104R@R040000000001028`;P0
b>3H08S0^028`;P20<c<c00306IVIP3oool0c<c<00T0c<c<2`0000050<c<c0800000103<c<`20000
00T0c<c<0P0000050<c<c080000000<0c<c<0000000000003`3<c<`00`1VIVH0c<c<09VIV@0709VI
V@8000000`2IVIT20000000309VIV@000000000000800000102IVIT2000000<0VIVI0P00000<09VI
V@0306IVIP3<c<`0VIVI00L0VIVI0P00000309VIV@80000000<0VIVI0000000000001P2IVIT20000
00<0VIVI0P00000;09VIV@0306IVIP3<c<`0c<c<0?l0c<c<g03<c<`208S0^040B9280@0000000004
08S0^038h=P0R<2h08S0^080c<c<00<0IVIV0?ooo`3<c<`02`3<c<`200000080c<c<0P0000070<c<
c0<00000103<c<`00`000000c<c<0<c<c0080<c<c08000001@3<c<`2000000030<c<c00000000000
00l0c<c<00<0IVIV0<c<c02IVIT01`2IVIT2000000<0VIVI0P0000000`2IVIT000000000000609VI
V@8000000`2IVIT2000000`0VIVI00<0IVIV0<c<c02IVIT01`2IVIT2000000<0VIVI0P0000000`2I
VIT000000000000609VIV@8000000`2IVIT2000000/0VIVI00<0IVIV0<c<c03<c<`0o`3<c<cL0<c<
c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P3<c<`00`1VIVH0oooo0<c<c00;0<c<
c08000000P3<c<`2000000H0c<c<0`0000090<c<c0T000001@3<c<`2000000030<c<c00000000000
00l0c<c<00<0IVIV0<c<c02IVIT01`2IVIT2000000<0VIVI0P0000000`2IVIT000000000000309VI
V@80000000<0VIVI0000000000000`2IVIT2000000`0VIVI00<0IVIV0<c<c02IVIT01`2IVIT20000
00<0VIVI0P00000209VIV@8000000P2IVIT20000000309VIV@000000000000<0VIVI0P00000;09VI
V@0306IVIP3<c<`0c<c<0?l0c<c<g03<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0
^0<0c<c<00<0IVIV0?ooo`3<c<`02P3<c<`3000000040<c<c00000000000000000H0c<c<00<00000
0<c<c03<c<`03`3<c<`4000001L0c<c<0P1VIVH00`3<c<`0VIVI09VIV@0509VIV@8000000`2IVIT2
00000080VIVI1@00000209VIV@H000003@2IVIT206IVIP030<c<c02IVIT0VIVI00D0VIVI1P000004
09VIV@@000000P2IVIT6000000`0VIVI00<0IVIV0<c<c03<c<`0o`3<c<cL0<c<c080R<2h0@18T8P1
0000000000@0R<2h0<SPf028`;P0R<2h103<c<`00`1VIVH0oooo0<c<c00X0<c<c0@000005`3<c<`0
101VIVH0c<c<06IVIP3<c<`Y09VIV@0406IVIP3<c<`0IVIV0<c<c2P0VIVI00<0IVIV0<c<c03<c<`0
o`3<c<cL0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h1@3<c<`00`1VIVH0oooo
0<c<c0120<c<c00506IVIP3<c<`0c<c<06IVIP3<c<`0:02IVIT01@1VIVH0c<c<0<c<c01VIVH0c<c<
02L0VIVI00<0IVIV0<c<c03<c<`0o`3<c<cL0<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028
`;P0R<2h1P3<c<`00`1VIVH0oooo0<c<c0110<c<c00606IVIP3<c<`0c<c<0<c<c01VIVH0c<c<9`2I
VIT01P1VIVH0c<c<0<c<c03<c<`0IVIV0<c<c2H0VIVI00<0IVIV0<c<c03<c<`0o`3<c<cL0<c<c080
R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h1`3<c<`00`1VIVH0oooo0?ooo`100?ooo`03
06IVIP3<c<`0c<c<0080c<c<00<0IVIV0<c<c03<c<`09@3<c<`00`1VIVH0c<c<0<c<c0020<c<c003
06IVIP3<c<`0c<c<0?l0c<c<o`3<c<`40<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0
R<2h203<c<a306IVIPD0c<c<:01VIVH50<c<c2L0IVIVo`3<c<cN0<c<c080R<2h0@18T8P100000000
00@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c8<0c<c<0P28`;P104R@R040000000001028`;P0b>3H
08S0^028`;So0<c<c?l0c<c<P`3<c<`208S0^040B9280@000000000408S0^038h=P0R<2h08S0^?l0
c<c<o`3<c<b30<c<c080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2ho`3<c<co0<c<c8<0
c<c<0P28`;P104R@R040000000000`28`;P0b>3H08S0^03o08S0^?l0R<2hQP28`;P104R@R0400000
00001028`;P0b>3H08S0^028`;PF0000P0<000600P000X0010000X4000>10003P@000h430004P@80
00F100<000F20006PP001X800P001X8010001h800@N20047PP0128820048P`<00@V30`012X<00`01
2h<00@^4004;Q004004<Q0<00@f40`013XD3008?Q@<00Q250`024HH4008BQP800Q>600@00Q>7008D
Q`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0@00aR800<00aV800<IR@036HT00`03
6XT300<KR@<00ab:0`037HX300@NRP@011n;0`0488/200@QR`0400@QS0048X`012:<00@RS0<012><
0P0498`00`0498d012F=00@US@0200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZ
SP05:Xl01BZ?00@01B^?0`05;8l300H]T0<01Rj@0`06;i0300H`T@@01S6A0P06<Y401@06<Y801S>B
00HcTP06<i801SBB00801cBB00<01cFB00LeT`07=I<00`07=Y<400LgT`<01cRD0`07>I@300LjU0<0
1c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL00`09
@iP02DBH00U4V00200U4V0<02DFH00<02DJH00U6V@09AYT00`09AiT300U8V@0300U9V@09BIX02DVJ
00@02DZJ0`0:BiX300Y<V`<02TfK0P0:CY/0100:CY`02TnL00Y?W00:Ci`400Y@W00400YAW00:DId0
2U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP@02eJN0`0;Eil300]HW`<02eVO0`0<
FZ0300aKX0<035bP100<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ80100=HJ803F:R
00eRXP0=HZ<400eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU100>JJD200iZY@04
00iZYP0>JjH03V^V00i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL400i_Y`0300i`Y`0?L:P0
3g2X00<03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0300mdZ@@03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3
011jZ`<047^[100@O:`3011m[08047j/00@047j]011o[@0@Ojd04Gn]0`0AP:d00`0APJd04H6^0161
[P040162[P<04H>^0`0AQ:l30165[`<04HJ_0`0BQk0401:8/0804XV`00@04XVa01::/@0BR[404XZa
0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb0P0CS[800`0CSk804hnc01>?/`0301>@/`<0
4i6c00<04i:c01>B]00CT[@00`0CTk@401>D]0<04iFe0`0DU[D301BG]@<059Rf0`0DVKH201BJ]P03
01BJ]`0DVkL059^g008059^g0`0DW;L00`0DWKL05Ifh01FM^00301FN^0<05Inh00<05J2h01FP^@0E
X;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk100FYk/201JX^`0401JX_00FZK`05ZVl01JY
_0<05ZZl0P0FZk`0100FZkd05Zbm01J/_@0G[;d401N]_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h0
0`0G/Kh05k6o01Na_`0301Nb_`<05k>o=P0H]<0208S0^040B9280@000000000408S0^038h=P0R<2h
08S0^0@0002000<0VjOa03=3Y@0c@jD02@0c@jD60000P0<000600P000X0010000X4000>10003P@00
0h430004P@8000F100<000F20006PP001X800P001X8010001h800@N20047PP0128820048P`<00@V3
0`012X<00`012h<00@^4004;Q004004<Q0<00@f40`013XD3008?Q@<00Q250`024HH4008BQP800Q>6
00@00Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0@00aR800<00aV800<I
R@036HT00`036XT300<KR@<00ab:0`037HX300@NRP@011n;0`0488/200@QR`0400@QS0048X`012:<
00@RS0<012><0P0498`00`0498d012F=00@US@0200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h3
00DYSP0300DZSP05:Xl01BZ?00@01B^?0`05;8l300H]T0<01Rj@0`06;i0300H`T@@01S6A0P06<Y40
1@06<Y801S>B00HcTP06<i801SBB00801cBB00<01cFB00LeT`07=I<00`07=Y<400LgT`<01cRD0`07
>I@300LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G
0P08@iL00`09@iP02DBH00U4V00200U4V0<02DFH00<02DJH00U6V@09AYT00`09AiT300U8V@0300U9
V@09BIX02DVJ00@02DZJ0`0:BiX300Y<V`<02TfK0P0:CY/0100:CY`02TnL00Y?W00:Ci`400Y@W004
00YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP@02eJN0`0;Eil300]H
W`<02eVO0`0<FZ0300aKX0<035bP100<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ80
100=HJ803F:R00eRXP0=HZ<400eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU100>
JJD200iZY@0400iZYP0>JjH03V^V00i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL400i_Y`03
00i`Y`0?L:P03g2X00<03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0300mdZ@@03gFY0`0?MZX300mgZP<0
47RZ0`0@NJ/3011jZ`<047^[100@O:`3011m[08047j/00@047j]011o[@0@Ojd04Gn]0`0AP:d00`0A
PJd04H6^0161[P040162[P<04H>^0`0AQ:l30165[`<04HJ_0`0BQk0401:8/0804XV`00@04XVa01::
/@0BR[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb0P0CS[800`0CSk804hnc01>?
/`0301>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@401>D]0<04iFe0`0DU[D301BG]@<059Rf0`0D
VKH201BJ]P0301BJ]`0DVkL059^g008059^g0`0DW;L00`0DWKL05Ifh01FM^00301FN^0<05Inh00<0
5J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk100FYk/201JX^`0401JX_00F
ZK`05ZVl01JY_0<05ZZl0P0FZk`0100FZkd05Zbm01J/_@0G[;d401N]_@0301N^_@0G[[h05jjn00<0
5jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o=P0H]<0208S0^040B9280@000000000408S0
^038h=P0R<2h08S0^0<0002000L0VjOa0?ooo`2>N[H0YY_40;>YdP2XWLP0/jWB0080YY_400D0_;SM
0>k^m03ZjO40oooo03=3Y@050000P0<000600P000X0010000X4000>10003P@000h430004P@8000F1
00<000F20006PP001X800P001X8010001h800@N20047PP0128820048P`<00@V30`012X<00`012h<0
0@^4004;Q004004<Q0<00@f40`013XD3008?Q@<00Q250`024HH4008BQP800Q>600@00Q>7008DQ`02
58L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0@00aR800<00aV800<IR@036HT00`036XT3
00<KR@<00ab:0`037HX300@NRP@011n;0`0488/200@QR`0400@QS0048X`012:<00@RS0<012><0P04
98`00`0498d012F=00@US@0200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05
:Xl01BZ?00@01B^?0`05;8l300H]T0<01Rj@0`06;i0300H`T@@01S6A0P06<Y401@06<Y801S>B00Hc
TP06<i801SBB00801cBB00<01cFB00LeT`07=I<00`07=Y<400LgT`<01cRD0`07>I@300LjU0<01c^E
0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL00`09@iP0
2DBH00U4V00200U4V0<02DFH00<02DJH00U6V@09AYT00`09AiT300U8V@0300U9V@09BIX02DVJ00@0
2DZJ0`0:BiX300Y<V`<02TfK0P0:CY/0100:CY`02TnL00Y?W00:Ci`400Y@W00400YAW00:DId02U6M
00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP@02eJN0`0;Eil300]HW`<02eVO0`0<FZ03
00aKX0<035bP100<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ80100=HJ803F:R00eR
XP0=HZ<400eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU100>JJD200iZY@0400iZ
YP0>JjH03V^V00i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL400i_Y`0300i`Y`0?L:P03g2X
00<03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0300mdZ@@03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011j
Z`<047^[100@O:`3011m[08047j/00@047j]011o[@0@Ojd04Gn]0`0AP:d00`0APJd04H6^0161[P04
0162[P<04H>^0`0AQ:l30165[`<04HJ_0`0BQk0401:8/0804XV`00@04XVa01::/@0BR[404XZa0`0B
Rk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb0P0CS[800`0CSk804hnc01>?/`0301>@/`<04i6c
00<04i:c01>B]00CT[@00`0CTk@401>D]0<04iFe0`0DU[D301BG]@<059Rf0`0DVKH201BJ]P0301BJ
]`0DVkL059^g008059^g0`0DW;L00`0DWKL05Ifh01FM^00301FN^0<05Inh00<05J2h01FP^@0EX;T0
100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk100FYk/201JX^`0401JX_00FZK`05ZVl01JY_0<0
5ZZl0P0FZk`0100FZkd05Zbm01J/_@0G[;d401N]_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G
/Kh05k6o01Na_`0301Nb_`<05k>o0P0H]<0P000000806;C04000000201Rd`080R<2h0@18T8P10000
000000@0R<2h0<SPf028`;P0R<2h0P000800102KYo40oooo06aJY@2_YLX20;bhg@0:0?omo`2cZM80
oooo0?ooo`2l^=d0UhZl0:RMb03Vi^`0oooo03=3Y@@000200`000H020002P0040002P@000h4000>1
0003P@<000B10P001H400`001H8000J20006PP020006PP040007PP011h800@N20048PP800@R30`01
2H<3004:P`03004;P`012h@00@^400@00@b40`013H@3004>Q@<00Pn50`0248D3008AQP@00Q:60P02
4hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN8100368P00`036HP0
0aV900<IR@0300<JR@<00a^90`0378X300<MRP<011j:10047h/300@PR`80126;00@0126<00@RS004
8X`012:<0`048h`200@TS00300@TS@049Hd012F=00801BF=0`059Xd00`059hd01BN>00DWSP0300DX
SP<01BV>00<01BZ>00DZS`05:Xl01005:hl300D/S`<01Rf@0`06;Y0300H_T0<01S2A1006<I4200Hb
T@0500HbTP06<i801S>B00HcTP06=9800P07=9800`07=I801cFC00LeT`0300LfT`@01cNC0`07>9@3
00LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08
@YL200Q3U`0300U3V009A9P02DBH00802DBH0`09AIP00`09AYP02DJI00U6V@0300U7V@<02DRI00<0
2DVI00U9VP09BIX01009BYX300Y;VP<02TbK0`0:CI/200Y>V`0400Y>W00:Ci`02TnL00Y?W0@02U2L
00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN100;EYh300]GW`<0
2eRO0`0;FIl300aJX0<035^P0`0<G:0400aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQ
XP0400eQXP0=HZ803F:R00eRX`@03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D4
00iYY@803VZU00@03VZV00i[YP0>JjH03V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW00i^Y`@03VnW
00<03W2W00m`Z00?L:P00`0?LJP300mbZ00300mcZ00?LjT03g>Y00<03gBY100?MJT300mfZP<03gNZ
0`0@N:X3011iZ`<047Z[0`0@Nj/4011l[0<047f/0P0@OZ`0100@OZd047n]011o[@0AOjd30160[@03
0161[@0APJh04H6^00@04H:^0`0APjh30164[`<04HF_0`0AQZl301:7/0@04XR`0P0BRK00100BRK40
4XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[8201>>/P0301>?/P0CSk<0
4hnc00<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0@04iBd0`0CUKD301BF]@<059Ne0`0DV;H3
01BI]P8059Zf00<059Zg01BK]`0DVkL00P0DVkL301BL]`0301BM]`0EWKP05Ifh00<05Ijh0`0EWkP0
0`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/401JW^`805ZRk00@05ZRl
01JY_00FZK`05ZVl0`0FZ[`201J[_00401J[_@0F[;d05Zbm01N/_@@05jfm00<05jjm01N^_P0G[[h0
0`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0030<SPf018T8P0B92800`0B928
00<000000<SPf018T8P03@18T8P0100000006;C001Rd`038h=P>04R@R0030000000H]<006;C00080
R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0P0008002`2KYo40oooo0:RMb03oool0/jWB
061<VP2>N[H0N6F^0:RMb03oool0oogo00<0oooo00<0<d>U0000P00008000`0008030001P08000:0
00@000:10003P@000h4000>10`0018420005P@030005PP001X8000J2008000J200@000N20047PP01
1h800@R20P0128<30049P`<00@Z300<00@^3004;Q0012h@0100138@3004=Q0<00@j50`023hD01002
48D0oooo0?ooo`3oool2008AQP@00Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@0
0aJ800<GR0035hP00aN8100368P00`036HP00aV900<IR@0300<JR@<00a^90`0378X300<MRP<011j:
10047h/300@PR`80126;00@0126<00@RS0048X`012:<0`048h`200@TS00300@TS@049Hd012F=0080
1BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl01005:hl300D/S`<0
1Rf@0`06;Y0300H_T0<01S2A1006<I4200HbT@0500HbTP06<i801S>B00HcTP06=9800P07=9800`07
=I801cFC00LeT`0300LfT`@01cNC0`07>9@300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300Po
UP80242F00@0242G00Q1U`08@IL0246G0`08@YL200Q3U`0300U3V009A9P02DBH00802DBH0`09AIP0
0`09AYP02DJI00U6V@0300U7V@<02DRI00<02DVI00U9VP09BIX01009BYX300Y;VP<02TbK0`0:CI/2
00Y>V`0400Y>W00:Ci`02TnL00Y?W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]D
W@0;E9h02eBN00<02eFN100;EYh300]GW`<02eRO0`0;FIl300aJX0<035^P0`0<G:0400aMX@<035jQ
0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0400eQXP0=HZ803F:R00eRX`@03F>S0`0=I:<00`0=
IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D400iYY@803VZU00@03VZV00i[YP0>JjH03V^V0`0>K:H2
00i]YP0400i]Y`0>KZL03VjW00i^Y`@03VnW00<03W2W00m`Z00?L:P00`0?LJP300mbZ00300mcZ00?
LjT03g>Y00<03gBY100?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/4011l[0<047f/0P0@
OZ`0100@OZd047n]011o[@0AOjd30160[@030161[@0APJh04H6^00@04H:^0`0APjh30164[`<04HF_
0`0AQZl301:7/0@04XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0B
SK804Xfb0P0BS[8201>>/P0301>?/P0CSk<04hnc00<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C
]0@04iBd0`0CUKD301BF]@<059Ne0`0DV;H301BI]P8059Zf00<059Zg01BK]`0DVkL00P0DVkL301BL
]`0301BM]`0EWKP05Ifh00<05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT
^P<05ZFj0`0FY[/401JW^`805ZRk00@05ZRl01JY_00FZK`05ZVl0`0FZ[`201J[_00401J[_@0F[;d0
5Zbm01N/_@@05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G
/kl201Rd`0030<SPf028`;P0R<2h00/0R<2h00<0B92800000038h=P03@28`;P01@18T8P0000001Rd
`00H]<00b>3H00d0R<2h00@0B9280000000H]<006;C00P28`;P104R@R040000000001028`;P0b>3H
08S0^028`;P20000P00>09^Wl@3oool0oooo0=_Lk01PC9X0ThFj0;>YdP2l^=d0H4bJ09V?_P2VVl@0
b<?O0?ooo`0c@jD60000P0<0oooo0P000X000`000X40oooo0?ooo`020?ooo`8000B100<000F10?oo
o`001H800`001X840?ooo`030048PP0128<0oooo00<0oooo0`012X<01@3oool00@^4004;Q00138@0
oooo00800@b400@00@f40?ooo`013H@0oooo0P013XD010023hD0oooo008?Q@3oool2008@Q@03008A
QP3oool00Q6600@00Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR003
5hP00aN8100368P00`036HP00aV900<IR@0300<JR@<00a^90`0378X300<MRP<011j:10047h/300@P
R`80126;00@0126<00@RS0048X`012:<0`048h`200@TS00300@TS@049Hd012F=00801BF=0`059Xd0
0`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl01005:hl300D/S`<01Rf@0`06;Y03
00H_T0<01S2A1006<I4200HbT@0500HbTP06<i801S>B00HcTP06=9800P07=9800`07=I801cFC00Le
T`0300LfT`@01cNC0`07>9@300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0
242G00Q1U`08@IL0246G0`08@YL200Q3U`0300U3V009A9P02DBH00802DBH0`09AIP00`09AYP02DJI
00U6V@0300U7V@<02DRI00<02DVI00U9VP09BIX01009BYX300Y;VP<02TbK0`0:CI/200Y>V`0400Y>
W00:Ci`02TnL00Y?W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN
00<02eFN100;EYh300]GW`<02eRO0`0;FIl300aJX0<035^P0`0<G:0400aMX@<035jQ0P0<Gj40100<
Gj80362R00aPXP0<H:8200aQXP0400eQXP0=HZ803F:R00eRX`@03F>S0`0=I:<00`0=IJ<03FFT00eU
Y00300eVY0<03FNT0`0=J:D400iYY@803VZU00@03VZV00i[YP0>JjH03V^V0`0>K:H200i]YP0400i]
Y`0>KZL03VjW00i^Y`@03VnW00<03W2W00m`Z00?L:P00`0?LJP300mbZ00300mcZ00?LjT03g>Y00<0
3gBY100?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/4011l[0<047f/0P0@OZ`0100@OZd0
47n]011o[@0AOjd30160[@030161[@0APJh04H6^00@04H:^0`0APjh30164[`<04HF_0`0AQZl301:7
/0@04XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0B
S[8201>>/P0301>?/P0CSk<04hnc00<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0@04iBd0`0C
UKD301BF]@<059Ne0`0DV;H301BI]P8059Zf00<059Zg01BK]`0DVkL00P0DVkL301BL]`0301BM]`0E
WKP05Ifh00<05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0F
Y[/401JW^`805ZRk00@05ZRl01JY_00FZK`05ZVl0`0FZ[`201J[_00401J[_@0F[;d05Zbm01N/_@@0
5jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`004
0<SPf028`;P0R<2h08S0^0H000001028`;P00`18T8P000000<SPf00208S0^0T000000P28`;P01@18
T8P0000001Rd`00H]<00b>3H00d0R<2h00@0B9280000000H]<006;C00P28`;P104R@R04000000000
1028`;P0b>3H08S0^028`;P30000P00>09^Wl@3oool0_;SM09V?_P3oool0e]7M0=_Lk03co_l0YY_4
0>k^m025M[00ThFj0?ooo`0c@jD40000P0070?ooo`000H0000600001P03oool000:00?ooo`030003
P@060?ooo`00184000B10005P@3oool000F20P001X80203oool000J20007PP011h80oooo0048PP3o
ool00@R30`012H<0103oool00@Z3004:P`3oool2004;Q008004<Q03oool00@b4004<Q0013H@0oooo
004=Q03oool2004>Q@03008?Q@3oool00Pn500@0oooo0P024HH4008BQP800Q>600@00Q>7008DQ`02
58L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0@00aR800<00aV800<IR@036HT00`036XT3
00<KR@<00ab:0`037HX300@NRP@011n;0`0488/200@QR`0400@QS0048X`012:<00@RS0<012><0P04
98`00`0498d012F=00@US@0200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DYSP0300DZSP05
:Xl01BZ?00@01B^?0`05;8l300H]T0<01Rj@0`06;i0300H`T@@01S6A0P06<Y401@06<Y801S>B00Hc
TP06<i801SBB00801cBB00<01cFB00LeT`07=I<00`07=Y<400LgT`<01cRD0`07>I@300LjU0<01c^E
0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08@iL00`09@iP0
2DBH00U4V00200U4V0<02DFH00<02DJH00U6V@09AYT00`09AiT300U8V@0300U9V@09BIX02DVJ00@0
2DZJ0`0:BiX300Y<V`<02TfK0P0:CY/0100:CY`02TnL00Y?W00:Ci`400Y@W00400YAW00:DId02U6M
00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP@02eJN0`0;Eil300]HW`<02eVO0`0<FZ03
00aKX0<035bP100<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ80100=HJ803F:R00eR
XP0=HZ<400eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU100>JJD200iZY@0400iZ
YP0>JjH03V^V00i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL400i_Y`0300i`Y`0?L:P03g2X
00<03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0300mdZ@@03gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011j
Z`<047^[100@O:`3011m[08047j/00@047j]011o[@0@Ojd04Gn]0`0AP:d00`0APJd04H6^0161[P04
0162[P<04H>^0`0AQ:l30165[`<04HJ_0`0BQk0401:8/0804XV`00@04XVa01::/@0BR[404XZa0`0B
Rk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb0P0CS[800`0CSk804hnc01>?/`0301>@/`<04i6c
00<04i:c01>B]00CT[@00`0CTk@401>D]0<04iFe0`0DU[D301BG]@<059Rf0`0DVKH201BJ]P0301BJ
]`0DVkL059^g008059^g0`0DW;L00`0DWKL05Ifh01FM^00301FN^0<05Inh00<05J2h01FP^@0EX;T0
100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk100FYk/201JX^`0401JX_00FZK`05ZVl01JY_0<0
5ZZl0P0FZk`0100FZkd05Zbm01J/_@0G[;d401N]_@0301N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G
/Kh05k6o01Na_`0301Nb_`<05k>o0P0H]<001038h=P0R<2h08S0^028`;P6000000@0R<2h00<0B928
00000038h=P00P28`;P00`000000R<2h08S0^00508S0^00500000028`;P0R<2h04R@R00000000P0H
]<001038h=P0R<2h08S0^028`;P2000000@0R<2h0P00000208S0^00404R@R00000006;C001Rd`080
R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0`0008003`2KYo40oooo09V?_P2GR[`0e=?X
0>n//`3oMW/0kYn[05]HY@2VVl@0UYoB061<VP2l^=d0oooo03=3Y@030000P0070?ooo`000H000060
0001P03oool000:00?ooo`030003P@060?ooo`00184000B10?ooo`001H40oooo0P001X80203oool0
00J20007PP011h80oooo0048PP3oool00@R30`012H<03P3oool00@Z30?ooo`012h<0oooo004;Q03o
ool00@b40?ooo`0138@00@f40?ooo`013H@0oooo0P013XD010023hD0oooo008?Q@3oool2008@Q@<0
0Q6610024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN800<GR0035hP4
00<HR00300<IR0036HT00aV900<00aZ90`036hT300<LRP<00af:0`047XX400@OR`<0122;0P048H/0
10048H`012:<00@RS0048X`300@SS08012B<00<012B=00@US@049Hd00P059Hd300DVS@0300DWS@05
9hh01BN>00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0400D[S`<01Bb?0`06;I0300H^T0<01Rn@0`06
<94400HaT@801S:A00D01S:B00HcTP06<i801S>B00HdTP0200LdTP0300LeTP07=I<01cFC00<01cJC
1007=i<300LhU0<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G
00Q1U`08@IL300Q2U`8024>G00<02D>H00U4V009A9P00P09A9P300U5V00300U6V009AYT02DJI00<0
2DNI0`09B9T00`09BIT02DVJ00U9VP0400U:VP<02T^J0`0:C9/300Y=V`802TjK00@02TjL00Y?W00:
Ci`02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh4
00]FWP<02eNO0`0;F9l300]IW`<035ZP0`0<Fj0300aLX0@035fQ0`0<GZ4200aOX@0400aOXP0<H:80
362R00aPXP80366R00@03F6R00eRXP0=HZ803F:S100=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT
0`0=Ij@300eXY@@03VVU0P0>JZD0100>JZH03V^V00i[YP0>JjH300i/YP803VfV00@03VfW00i^Y`0>
KZL03VjW100>KjL00`0>L:L03g2X00m`Z00300maZ0<03g:X00<03g>X00mcZ@0?LjT00`0?M:T400me
Z@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`@047b/0`0@OJ`2011n[004011n[@0@Ojd047n]
015o[@<04H2]00<04H6]0161[P0APJh0100APZh30163[P<04HB_0`0AQJl30166[`<04XN`100BR;02
01:9/00401:9/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P804hjb
00<04hnb01>?/`0CSk<00`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d100CU;@301>E]@<059Je
0`0DUkD301BH]P<059Vf0P0DV[H00`0DV[L059^g01BK]`0201BK]`<059bg00<059fg01FM^00EWKP0
0`0EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0FYKX301JV^`@05ZNk
0P0FZ;/0100FZ;`05ZVl01JY_00FZK`301JZ_0805Z^l00@05Z^m01J/_@0F[;d05jbm100G[Kd00`0G
[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C000<0b>3H08S0
^028`;P02`28`;P00`18T8P000000<SPf00208S0^00300000028`;P0R<2h00D0R<2h00D0000008S0
^028`;P0B9280000000201Rd`0030<SPf028`;P0R<2h0080R<2h0P00000208S0^08000000`28`;P0
1018T8P0000001Rd`00H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080002000X0
VjOa0?ooo`2GR[`0NVbZ0;?7j02YKZ00b<?O09>5^P1KAY<0VHnn0P1hIJh010129hD0[jG:0?ooo`0c
@jD40000P0<0006000<0oooo0002P0000X40103oool20004P@030?ooo`001H40oooo00<000J2103o
ool00`0128800@R30048P`030049P`0>0?ooo`012X<0oooo004;P`3oool00@^40?ooo`0138@0oooo
004<Q0013H@0oooo004=Q03oool2004>Q@03008?Q@3oool00Pn500@0oooo0P024HH4008BQP800Q>6
00@00Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0@00aR800<00aV800<I
R@036HT00`036XT300<KR@<00ab:0`037HX300@NRP@011n;0`0488/200@QR`0400@QS0048X`012:<
00@RS0<012><0P0498`00`0498d012F=00@US@0200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h3
00DYSP0300DZSP05:Xl01BZ?00@01B^?0`05;8l300H]T0<01Rj@0`06;i0300H`T@@01S6A0P06<Y40
1@06<Y801S>B00HcTP06<i801SBB00801cBB00<01cFB00LeT`07=I<00`07=Y<400LgT`<01cRD0`07
>I@300LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G
0P08@iL00`09@iP02DBH00U4V00200U4V0<02DFH00<02DJH00U6V@09AYT00`09AiT300U8V@0300U9
V@09BIX02DVJ00@02DZJ0`0:BiX300Y<V`<02TfK0P0:CY/0100:CY`02TnL00Y?W00:Ci`400Y@W004
00YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP@02eJN0`0;Eil300]H
W`<02eVO0`0<FZ0300aKX0<035bP100<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ80
100=HJ803F:R00eRXP0=HZ<400eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU100>
JJD200iZY@0400iZYP0>JjH03V^V00i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL400i_Y`03
00i`Y`0?L:P03g2X00<03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0300mdZ@@03gFY0`0?MZX300mgZP<0
47RZ0`0@NJ/3011jZ`<047^[100@O:`3011m[08047j/00@047j]011o[@0@Ojd04Gn]0`0AP:d00`0A
PJd04H6^0161[P040162[P<04H>^0`0AQ:l30165[`<04HJ_0`0BQk0401:8/0804XV`00@04XVa01::
/@0BR[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb0P0CS[800`0CSk804hnc01>?
/`0301>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@401>D]0<04iFe0`0DU[D301BG]@<059Rf0`0D
VKH201BJ]P0301BJ]`0DVkL059^g008059^g0`0DW;L00`0DWKL05Ifh01FM^00301FN^0<05Inh00<0
5J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk100FYk/201JX^`0401JX_00F
ZK`05ZVl01JY_0<05ZZl0P0FZk`0100FZkd05Zbm01J/_@0G[;d401N]_@0301N^_@0G[[h05jjn00<0
5jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o0P0H]<000`38h=P0R<2h08S0^00;08S0^003
04R@R0000000b>3H0080R<2h00<0000008S0^028`;P01@28`;P01@000000R<2h08S0^018T8P00000
00806;C000<0b>3H08S0^028`;P00`28`;P4000000@0R<2h00@0B9280000000H]<006;C00P28`;P1
04R@R040000000001028`;P0b>3H08S0^028`;P20000P00309^Wl@3oool0oooo0080oooo00X0ojf`
0?mfN`3icM@0oNg^0?ooo`2VVl@0QGJ`0;bhg@3oool0<d>U1@0008030001P0030?ooo`000X0000:1
00<000>100<0oooo0004P@3oool00P001H400`001H80oooo0006PP020006PP040007PP011h80oooo
0048PP800@R30`3oool2004:P`0;0?ooo`012h<0oooo004;Q03oool00@b40?ooo`0138@00@f40?oo
o`013H@00P3oool01@013XD00Pn50?ooo`023hD0oooo00800Q2500<0oooo008AQP024HH010024XH2
008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN800<GR0035hP400<HR00300<I
R0036HT00aV900<00aZ90`036hT300<LRP<00af:0`047XX400@OR`<0122;0P048H/010048H`012:<
00@RS0048X`300@SS08012B<00<012B=00@US@049Hd00P059Hd300DVS@0300DWS@059hh01BN>00<0
1BR>0`05:Hh00`05:Xh01BZ?00DZS`0400D[S`<01Bb?0`06;I0300H^T0<01Rn@0`06<94400HaT@80
1S:A00D01S:B00HcTP06<i801S>B00HdTP0200LdTP0300LeTP07=I<01cFC00<01cJC1007=i<300Lh
U0<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G00Q1U`08@IL3
00Q2U`8024>G00<02D>H00U4V009A9P00P09A9P300U5V00300U6V009AYT02DJI00<02DNI0`09B9T0
0`09BIT02DVJ00U9VP0400U:VP<02T^J0`0:C9/300Y=V`802TjK00@02TjL00Y?W00:Ci`02TnL100:
D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh400]FWP<02eNO
0`0;F9l300]IW`<035ZP0`0<Fj0300aLX0@035fQ0`0<GZ4200aOX@0400aOXP0<H:80362R00aPXP80
366R00@03F6R00eRXP0=HZ803F:S100=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT0`0=Ij@300eX
Y@@03VVU0P0>JZD0100>JZH03V^V00i[YP0>JjH300i/YP803VfV00@03VfW00i^Y`0>KZL03VjW100>
KjL00`0>L:L03g2X00m`Z00300maZ0<03g:X00<03g>X00mcZ@0?LjT00`0?M:T400meZ@<03gJZ0`0?
MjX3011hZP<047V[0`0@NZ/3011kZ`@047b/0`0@OJ`2011n[004011n[@0@Ojd047n]015o[@<04H2]
00<04H6]0161[P0APJh0100APZh30163[P<04HB_0`0AQJl30166[`<04XN`100BR;0201:9/00401:9
/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P804hjb00<04hnb01>?
/`0CSk<00`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d100CU;@301>E]@<059Je0`0DUkD301BH
]P<059Vf0P0DV[H00`0DV[L059^g01BK]`0201BK]`<059bg00<059fg01FM^00EWKP00`0EW[P301FO
^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0FYKX301JV^`@05ZNk0P0FZ;/0100F
Z;`05ZVl01JY_00FZK`301JZ_0805Z^l00@05Z^m01J/_@0F[;d05jbm100G[Kd00`0G[[d05jjn01N^
_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C000<0b>3H08S0^028`;P02`28
`;P00`18T8P000000<SPf00208S0^00300000028`;P0R<2h00D0R<2h00D0000008S0^028`;P0B928
0000000201Rd`0030<SPf028`;P0R<2h00@0R<2h0P00000508S0^00404R@R00000006;C001Rd`080
R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h0`0008002P2Q[?80nLgD0>8V?03d]Kl0hRHl
0?A]O@3lhnT0oooo0?g]kP3o[K020?ooo`0303=3Y@000800002000@000200`000H000`3oool000:0
0002P@030?ooo`8000B100D0oooo0005P@001H4000F20?ooo`020006PP<0oooo00@00@N20048PP01
28<0oooo0`012H<2004:P`040?ooo`012h<00@^40?ooo`800@b400L0oooo004<Q0013H@0oooo004=
Q03oool00@j50080oooo0P023hD00`0248D0oooo0?ooo`020?ooo`03008AQP024XH00Q:600800Q:6
0P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN8100368P00`03
6HP00aV900<IR@0300<JR@<00a^90`0378X300<MRP<011j:10047h/300@PR`80126;00@0126<00@R
S0048X`012:<0`048h`200@TS00300@TS@049Hd012F=00801BF=0`059Xd00`059hd01BN>00DWSP03
00DXSP<01BV>00<01BZ>00DZS`05:Xl01005:hl300D/S`<01Rf@0`06;Y0300H_T0<01S2A1006<I42
00HbT@0500HbTP06<i801S>B00HcTP06=9800P07=9800`07=I801cFC00LeT`0300LfT`@01cNC0`07
>9@300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G
0`08@YL200Q3U`0300U3V009A9P02DBH00802DBH0`09AIP00`09AYP02DJI00U6V@0300U7V@<02DRI
00<02DVI00U9VP09BIX01009BYX300Y;VP<02TbK0`0:CI/200Y>V`0400Y>W00:Ci`02TnL00Y?W0@0
2U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN100;EYh300]G
W`<02eRO0`0;FIl300aJX0<035^P0`0<G:0400aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:82
00aQXP0400eQXP0=HZ803F:R00eRX`@03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=
J:D400iYY@803VZU00@03VZV00i[YP0>JjH03V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW00i^Y`@0
3VnW00<03W2W00m`Z00?L:P00`0?LJP300mbZ00300mcZ00?LjT03g>Y00<03gBY100?MJT300mfZP<0
3gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/4011l[0<047f/0P0@OZ`0100@OZd047n]011o[@0AOjd30160
[@030161[@0APJh04H6^00@04H:^0`0APjh30164[`<04HF_0`0AQZl301:7/0@04XR`0P0BRK00100B
RK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[8201>>/P0301>?/P0C
Sk<04hnc00<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0@04iBd0`0CUKD301BF]@<059Ne0`0D
V;H301BI]P8059Zf00<059Zg01BK]`0DVkL00P0DVkL301BL]`0301BM]`0EWKP05Ifh00<05Ijh0`0E
WkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/401JW^`805ZRk00@0
5ZRl01JY_00FZK`05ZVl0`0FZ[`201J[_00401J[_@0F[;d05Zbm01N/_@@05jfm00<05jjm01N^_P0G
[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0030<SPf028`;P0R<2h00/0
R<2h00<0B92800000038h=P00P28`;P00`000000R<2h08S0^00508S0^00500000028`;P0R<2h04R@
R00000000P0H]<000`38h=P0R<2h08S0^00308S0^0@000001028`;P01018T8P0000001Rd`00H]<02
08S0^040B9280@000000000408S0^038h=P0R<2h08S0^080002000d0VjOa0?g]kP3R9S`0o_Gh0?N9
U`3dHVh0lj2^0?ARKP3ooOl0ojf`0?cSj@3oool0<d>U00L000200`000H000`3oool000:00002P@03
0003P@<000B10P001H400`001H8000J20006PP020006PP060007PP011h800@N20048PP3oool00@R3
0`012H<3004:P`03004;P`012h@00@^400@00@b40`013H@3004>Q@<00Pn50`0248D3008AQP@00Q:6
0P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN8100368P00`03
6HP00aV900<IR@0300<JR@<00a^90`0378X300<MRP<011j:10047h/300@PR`80126;00@0126<00@R
S0048X`012:<0`048h`200@TS00300@TS@049Hd012F=00801BF=0`059Xd00`059hd01BN>00DWSP03
00DXSP<01BV>00<01BZ>00DZS`05:Xl01005:hl300D/S`<01Rf@0`06;Y0300H_T0<01S2A1006<I42
00HbT@0500HbTP06<i801S>B00HcTP06=9800P07=9800`07=I801cFC00LeT`0300LfT`@01cNC0`07
>9@300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1U`08@IL0246G
0`08@YL200Q3U`0300U3V009A9P02DBH00802DBH0`09AIP00`09AYP02DJI00U6V@0300U7V@<02DRI
00<02DVI00U9VP09BIX01009BYX300Y;VP<02TbK0`0:CI/200Y>V`0400Y>W00:Ci`02TnL00Y?W0@0
2U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN100;EYh300]G
W`<02eRO0`0;FIl300aJX0<035^P0`0<G:0400aMX@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:82
00aQXP0400eQXP0=HZ803F:R00eRX`@03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=
J:D400iYY@803VZU00@03VZV00i[YP0>JjH03V^V0`0>K:H200i]YP0400i]Y`0>KZL03VjW00i^Y`@0
3VnW00<03W2W00m`Z00?L:P00`0?LJP300mbZ00300mcZ00?LjT03g>Y00<03gBY100?MJT300mfZP<0
3gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/4011l[0<047f/0P0@OZ`0100@OZd047n]011o[@0AOjd30160
[@030161[@0APJh04H6^00@04H:^0`0APjh30164[`<04HF_0`0AQZl301:7/0@04XR`0P0BRK00100B
RK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[8201>>/P0301>?/P0C
Sk<04hnc00<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0@04iBd0`0CUKD301BF]@<059Ne0`0D
V;H301BI]P8059Zf00<059Zg01BK]`0DVkL00P0DVkL301BL]`0301BM]`0EWKP05Ifh00<05Ijh0`0E
WkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/401JW^`805ZRk00@0
5ZRl01JY_00FZK`05ZVl0`0FZ[`201J[_00401J[_@0F[;d05Zbm01N/_@@05jfm00<05jjm01N^_P0G
[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0030<SPf028`;P0R<2h00/0
R<2h00<0B92800000038h=P00P28`;P00`000000R<2h08S0^00508S0^00500000028`;P0R<2h04R@
R00000000P0H]<000`38h=P0R<2h08S0^00208S0^08000000P28`;P2000000<0R<2h00@0B9280000
000H]<006;C00P28`;P104R@R040000000001028`;P0b>3H08S0^028`;P20000P00309^Wl@3fb<`0
hRHl0080ojf`00L0gb@^0?nTWP3f_<D0ojf`0>ikS03oool0<d>U00P000200`000H000`3oool000:0
0002P@030003P@<000B10P001H400`001H8000J20006PP020006PP060007PP011h800@N20048PP3o
ool00@R30`012H<0103oool00@Z3004:P`012h<2004;Q0@00@b40`013H@3004>Q@<00Pn50`0248D3
008AQP@00Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`800QJ700@00aJ800<GR0035hP00aN8
100368P00`036HP00aV900<IR@0300<JR@<00a^90`0378X300<MRP<011j:10047h/300@PR`80126;
00@0126<00@RS0048X`012:<0`048h`200@TS00300@TS@049Hd012F=00801BF=0`059Xd00`059hd0
1BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl01005:hl300D/S`<01Rf@0`06;Y0300H_T0<0
1S2A1006<I4200HbT@0500HbTP06<i801S>B00HcTP06=9800P07=9800`07=I801cFC00LeT`0300Lf
T`@01cNC0`07>9@300LiU0<01cZD0`07>iD300PlU@<023fE1008?YH300PoUP80242F00@0242G00Q1
U`08@IL0246G0`08@YL200Q3U`0300U3V009A9P02DBH00802DBH0`09AIP00`09AYP02DJI00U6V@03
00U7V@<02DRI00<02DVI00U9VP09BIX01009BYX300Y;VP<02TbK0`0:CI/200Y>V`0400Y>W00:Ci`0
2TnL00Y?W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]CW@0300]DW@0;E9h02eBN00<02eFN
100;EYh300]GW`<02eRO0`0;FIl300aJX0<035^P0`0<G:0400aMX@<035jQ0P0<Gj40100<Gj80362R
00aPXP0<H:8200aQXP0400eQXP0=HZ803F:R00eRX`@03F>S0`0=I:<00`0=IJ<03FFT00eUY00300eV
Y0<03FNT0`0=J:D400iYY@803VZU00@03VZV00i[YP0>JjH03V^V0`0>K:H200i]YP0400i]Y`0>KZL0
3VjW00i^Y`@03VnW00<03W2W00m`Z00?L:P00`0?LJP300mbZ00300mcZ00?LjT03g>Y00<03gBY100?
MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/4011l[0<047f/0P0@OZ`0100@OZd047n]011o
[@0AOjd30160[@030161[@0APJh04H6^00@04H:^0`0APjh30164[`<04HF_0`0AQZl301:7/0@04XR`
0P0BRK00100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb01:=/P0BSK804Xfb0P0BS[8201>>
/P0301>?/P0CSk<04hnc00<04i2c0`0CTK<00`0CT[<04i:d01>B]00301>C]0@04iBd0`0CUKD301BF
]@<059Ne0`0DV;H301BI]P8059Zf00<059Zg01BK]`0DVkL00P0DVkL301BL]`0301BM]`0EWKP05Ifh
00<05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0EXkX301FT^P<05ZFj0`0FY[/401JW
^`805ZRk00@05ZRl01JY_00FZK`05ZVl0`0FZ[`201J[_00401J[_@0F[;d05Zbm01N/_@@05jfm00<0
5jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<05k:o0`0G/kl201Rd`0030<SPf028
`;P0R<2h00/0R<2h00<0B92800000038h=P00P28`;P900000080R<2h00D0B9280000000H]<006;C0
0<SPf00308S0^08000001028`;P200000080R<2h00@0B9280000000H]<006;C00P28`;P104R@R040
000000001028`;P0b>3H08S0^028`;P20000P00309^Wl@3icM@0mhVG0080oooo00L0ojf`0>4F=03o
MW/0ojBN0>8V?03oRGl0<d>U00P000200`000H000`3oool000:00002P@030003P@<000B10P001H40
0`001H8000J20006PP020006PP050007PP011h800@N20048PP0128<0103oool3004:P`03004;P`01
2h@00@^400@00@b400<00@f40?ooo`013H@00`013XD3008?Q@<00Q250`024HH4008BQP800Q>600@0
0Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<GR0@00aR800<00aV800<IR@03
6HT00`036XT300<KR@<00ab:0`037HX300@NRP@011n;0`0488/200@QR`0400@QS0048X`012:<00@R
S0<012><0P0498`00`0498d012F=00@US@0200DUS@<01BJ=00<01BN=00DWSP059hh00`05:8h300DY
SP0300DZSP05:Xl01BZ?00@01B^?0`05;8l300H]T0<01Rj@0`06;i0300H`T@@01S6A0P06<Y401@06
<Y801S>B00HcTP06<i801SBB00801cBB00<01cFB00LeT`07=I<00`07=Y<400LgT`<01cRD0`07>I@3
00LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08@IL0246G00Q1U`<024:G0P08
@iL00`09@iP02DBH00U4V00200U4V0<02DFH00<02DJH00U6V@09AYT00`09AiT300U8V@0300U9V@09
BIX02DVJ00@02DZJ0`0:BiX300Y<V`<02TfK0P0:CY/0100:CY`02TnL00Y?W00:Ci`400Y@W00400YA
W00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]EWP@02eJN0`0;Eil300]HW`<0
2eVO0`0<FZ0300aKX0<035bP100<GJ4300aNX@8035nQ00@035nR00aPXP0<H:80362R0P0<HJ80100=
HJ803F:R00eRXP0=HZ<400eSX`<03FBS00<03FFS00eUY00=IJ@00`0=IZ@300eWY0<03FRU100>JJD2
00iZY@0400iZYP0>JjH03V^V00i[YP<03VbV0P0>KJH0100>KJL03VjW00i^Y`0>KZL400i_Y`0300i`
Y`0?L:P03g2X00<03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0300mdZ@@03gFY0`0?MZX300mgZP<047RZ
0`0@NJ/3011jZ`<047^[100@O:`3011m[08047j/00@047j]011o[@0@Ojd04Gn]0`0AP:d00`0APJd0
4H6^0161[P040162[P<04H>^0`0AQ:l30165[`<04HJ_0`0BQk0401:8/0804XV`00@04XVa01::/@0B
R[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb0P0CS[800`0CSk804hnc01>?/`03
01>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@401>D]0<04iFe0`0DU[D301BG]@<059Rf0`0DVKH2
01BJ]P0301BJ]`0DVkL059^g008059^g0`0DW;L00`0DWKL05Ifh01FM^00301FN^0<05Inh00<05J2h
01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk100FYk/201JX^`0401JX_00FZK`0
5ZVl01JY_0<05ZZl0P0FZk`0100FZkd05Zbm01J/_@0G[;d401N]_@0301N^_@0G[[h05jjn00<05jnn
0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o0P0H]<000`38h=P0R<2h08S0^00;08S0^00304R@
R0000000b>3H0080R<2h2@00000208S0^00504R@R00000006;C001Rd`038h=P03@28`;P01018T8P0
000001Rd`00H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^080002000L0VjOa0?oo
o`3cX:h0m69^0?ooo`3gRIL0nLgD0080oooo00<0lj2^0?ooo`0c@jD0200008030001P08000:000@0
00:10003P@000h4000>10`0018420005P@030005PP001X8000J2008000J200@000N20047PP011h80
0@R20P0128<30049P`<00@Z300<00@^3004;Q0012h@0100138@3004=Q0<00@j50`023hD3008@Q@<0
0Q6610024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN800<GR0035hP4
00<HR00300<IR0036HT00aV900<00aZ90`036hT300<LRP<00af:0`047XX400@OR`<0122;0P048H/0
10048H`012:<00@RS0048X`300@SS08012B<00<012B=00@US@049Hd00P059Hd300DVS@0300DWS@05
9hh01BN>00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0400D[S`<01Bb?0`06;I0300H^T0<01Rn@0`06
<94400HaT@801S:A00D01S:B00HcTP06<i801S>B00HdTP0200LdTP0300LeTP07=I<01cFC00<01cJC
1007=i<300LhU0<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008@9L0246G
00Q1U`08@IL300Q2U`8024>G00<02D>H00U4V009A9P00P09A9P300U5V00300U6V009AYT02DJI00<0
2DNI0`09B9T00`09BIT02DVJ00U9VP0400U:VP<02T^J0`0:C9/300Y=V`802TjK00@02TjL00Y?W00:
Ci`02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h00`0;EIh4
00]FWP<02eNO0`0;F9l300]IW`<035ZP0`0<Fj0300aLX0@035fQ0`0<GZ4200aOX@0400aOXP0<H:80
362R00aPXP80366R00@03F6R00eRXP0=HZ803F:S100=Hj<300eTX`0300eUX`0=IJ@03FFT00<03FJT
0`0=Ij@300eXY@@03VVU0P0>JZD0100>JZH03V^V00i[YP0>JjH300i/YP803VfV00@03VfW00i^Y`0>
KZL03VjW100>KjL00`0>L:L03g2X00m`Z00300maZ0<03g:X00<03g>X00mcZ@0?LjT00`0?M:T400me
Z@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`@047b/0`0@OJ`2011n[004011n[@0@Ojd047n]
015o[@<04H2]00<04H6]0161[P0APJh0100APZh30163[P<04HB_0`0AQJl30166[`<04XN`100BR;02
01:9/00401:9/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>/P804hjb
00<04hnb01>?/`0CSk<00`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d100CU;@301>E]@<059Je
0`0DUkD301BH]P<059Vf0P0DV[H00`0DV[L059^g01BK]`0201BK]`<059bg00<059fg01FM^00EWKP0
0`0EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0FYKX301JV^`@05ZNk
0P0FZ;/0100FZ;`05ZVl01JY_00FZK`301JZ_0805Z^l00@05Z^m01J/_@0F[;d05jbm100G[Kd00`0G
[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_`806;C000<0b>3H08S0
^028`;P02`28`;P00`18T8P000000<SPf00=08S0^00504R@R00000006;C001Rd`038h=P03@28`;P0
1018T8P0000001Rd`00H]<0208S0^040B9280@000000000408S0^038h=P0R<2h08S0^0<0002000/0
VjOa0?ooo`3oRGl0oooo0?>P[P3aTj40oooo0?omo`3cX:h0oo_l03=3Y@080000P0<000600P000X00
10000X4000>10003P@000h430004P@8000F100<000F20006PP001X800P001X8010001h800@N20047
PP0128820048P`<00@V30`012X<00`012h<00@^4004;Q004004<Q0<00@f40`013XD3008?Q@<00Q25
0`024HH4008BQP800Q>600@00Q>7008DQ`0258L00QB70`025HL2008FQ`0400<FR0035hP00aN800<G
R0@00aR800<00aV800<IR@036HT00`036XT300<KR@<00ab:0`037HX300@NRP@011n;0`0488/200@Q
R`0400@QS0048X`012:<00@RS0<012><0P0498`00`0498d012F=00@US@0200DUS@<01BJ=00<01BN=
00DWSP059hh00`05:8h300DYSP0300DZSP05:Xl01BZ?00@01B^?0`05;8l300H]T0<01Rj@0`06;i03
00H`T@@01S6A0P06<Y401@06<Y801S>B00HcTP06<i801SBB00801cBB00<01cFB00LeT`07=I<00`07
=Y<400LgT`<01cRD0`07>I@300LjU0<01c^E0`08?9D300PmU@@023jF0`08?iH200Q0UP0400Q0U`08
@IL0246G00Q1U`<024:G0P08@iL00`09@iP02DBH00U4V00200U4V0<02DFH00<02DJH00U6V@09AYT0
0`09AiT300U8V@0300U9V@09BIX02DVJ00@02DZJ0`0:BiX300Y<V`<02TfK0P0:CY/0100:CY`02TnL
00Y?W00:Ci`400Y@W00400YAW00:DId02U6M00YBW@802e:M0`0;Did00`0;E9d02eBN00]DWP0300]E
WP@02eJN0`0;Eil300]HW`<02eVO0`0<FZ0300aKX0<035bP100<GJ4300aNX@8035nQ00@035nR00aP
XP0<H:80362R0P0<HJ80100=HJ803F:R00eRXP0=HZ<400eSX`<03FBS00<03FFS00eUY00=IJ@00`0=
IZ@300eWY0<03FRU100>JJD200iZY@0400iZYP0>JjH03V^V00i[YP<03VbV0P0>KJH0100>KJL03VjW
00i^Y`0>KZL400i_Y`0300i`Y`0?L:P03g2X00<03g6X0`0?LZP00`0?LjP03g>Y00mcZ@0300mdZ@@0
3gFY0`0?MZX300mgZP<047RZ0`0@NJ/3011jZ`<047^[100@O:`3011m[08047j/00@047j]011o[@0@
Ojd04Gn]0`0AP:d00`0APJd04H6^0161[P040162[P<04H>^0`0AQ:l30165[`<04HJ_0`0BQk0401:8
/0804XV`00@04XVa01::/@0BR[404XZa0`0BRk4201:</@0401:</P0BSK804Xfb01:=/P804Xjb0P0C
S[800`0CSk804hnc01>?/`0301>@/`<04i6c00<04i:c01>B]00CT[@00`0CTk@401>D]0<04iFe0`0D
U[D301BG]@<059Rf0`0DVKH201BJ]P0301BJ]`0DVkL059^g008059^g0`0DW;L00`0DWKL05Ifh01FM
^00301FN^0<05Inh00<05J2h01FP^@0EX;T0100EXKT301FR^@<05J>j0`0EY;X301JU^P<05ZJk100F
Yk/201JX^`0401JX_00FZK`05ZVl01JY_0<05ZZl0P0FZk`0100FZkd05Zbm01J/_@0G[;d401N]_@03
01N^_@0G[[h05jjn00<05jnn0`0G/;h00`0G/Kh05k6o01Na_`0301Nb_`<05k>o0P0H]<0?0<SPf003
00000038h=P0b>3H00d0b>3H00<0000001Rd`00H]<003`38h=P00`0000006;C001Rd`00208S0^040
B9280@000000000408S0^038h=P0R<2h08S0^0@000200`2KYo401P3oool0lj2^0?Be_`3f_<D0nmWJ
03=3Y@T000200`000H020002P0040002P@000h4000>10003P@<000B10P001H400`001H8000J20006
PP020006PP040007PP011h800@N20048PP800@R30`012H<3004:P`03004;P`012h@00@^400@00@b4
0`013H@3004>Q@<00Pn50`0248D3008AQP@00Q:60P024hH010024hL00QB7008DQ`0258L3008EQ`80
0QJ700@00aJ800<GR0035hP00aN8100368P00`036HP00aV900<IR@0300<JR@<00a^90`0378X300<M
RP<011j:10047h/300@PR`80126;00@0126<00@RS0048X`012:<0`048h`200@TS00300@TS@049Hd0
12F=00801BF=0`059Xd00`059hd01BN>00DWSP0300DXSP<01BV>00<01BZ>00DZS`05:Xl01005:hl3
00D/S`<01Rf@0`06;Y0300H_T0<01S2A1006<I4200HbT@0500HbTP06<i801S>B00HcTP06=9800P07
=9800`07=I801cFC00LeT`0300LfT`@01cNC0`07>9@300LiU0<01cZD0`07>iD300PlU@<023fE1008
?YH300PoUP80242F00@0242G00Q1U`08@IL0246G0`08@YL200Q3U`0300U3V009A9P02DBH00802DBH
0`09AIP00`09AYP02DJI00U6V@0300U7V@<02DRI00<02DVI00U9VP09BIX01009BYX300Y;VP<02TbK
0`0:CI/200Y>V`0400Y>W00:Ci`02TnL00Y?W0@02U2L00@02U6L00YAW@0:DId02U:M0P0;DYd300]C
W@0300]DW@0;E9h02eBN00<02eFN100;EYh300]GW`<02eRO0`0;FIl300aJX0<035^P0`0<G:0400aM
X@<035jQ0P0<Gj40100<Gj80362R00aPXP0<H:8200aQXP0400eQXP0=HZ803F:R00eRX`@03F>S0`0=
I:<00`0=IJ<03FFT00eUY00300eVY0<03FNT0`0=J:D400iYY@803VZU00@03VZV00i[YP0>JjH03V^V
0`0>K:H200i]YP0400i]Y`0>KZL03VjW00i^Y`@03VnW00<03W2W00m`Z00?L:P00`0?LJP300mbZ003
00mcZ00?LjT03g>Y00<03gBY100?MJT300mfZP<03gNZ0`0@N:X3011iZ`<047Z[0`0@Nj/4011l[0<0
47f/0P0@OZ`0100@OZd047n]011o[@0AOjd30160[@030161[@0APJh04H6^00@04H:^0`0APjh30164
[`<04HF_0`0AQZl301:7/0@04XR`0P0BRK00100BRK404XZa01::/@0BR[4301:;/@804Xba00@04Xbb
01:=/P0BSK804Xfb0P0BS[8201>>/P0301>?/P0CSk<04hnc00<04i2c0`0CTK<00`0CT[<04i:d01>B
]00301>C]0@04iBd0`0CUKD301BF]@<059Ne0`0DV;H301BI]P8059Zf00<059Zg01BK]`0DVkL00P0D
VkL301BL]`0301BM]`0EWKP05Ifh00<05Ijh0`0EWkP00`0EX;P05J2i01FP^@0401FQ^@<05J:i0`0E
XkX301FT^P<05ZFj0`0FY[/401JW^`805ZRk00@05ZRl01JY_00FZK`05ZVl0`0FZ[`201J[_00401J[
_@0F[;d05Zbm01N/_@@05jfm00<05jjm01N^_P0G[[h00`0G[kh301N`_P0301Na_P0G/Kl05k6o00<0
5k:o0`0G/klf01Rd`080R<2h0@18T8P10000000000@0R<2h0<SPf028`;P0R<2h5P0008030001P080
00:000@000:10003P@000h4000>10`0018420005P@030005PP001X8000J2008000J200@000N20047
PP011h800@R20P0128<30049P`<00@Z300<00@^3004;Q0012h@0100138@3004=Q0<00@j50`023hD3
008@Q@<00Q6610024XH2008CQP04008CQ`0258L00QB7008DQ`<00QF70P025XL010035XP00aN800<G
R0035hP400<HR00300<IR0036HT00aV900<00aZ90`036hT300<LRP<00af:0`047XX400@OR`<0122;
0P048H/010048H`012:<00@RS0048X`300@SS08012B<00<012B=00@US@049Hd00P059Hd300DVS@03
00DWS@059hh01BN>00<01BR>0`05:Hh00`05:Xh01BZ?00DZS`0400D[S`<01Bb?0`06;I0300H^T0<0
1Rn@0`06<94400HaT@801S:A00D01S:B00HcTP06<i801S>B00HdTP0200LdTP0300LeTP07=I<01cFC
00<01cJC1007=i<300LhU0<01cVD0`07>Y@300LkU@<023bE0`08?ID400PnUP<023nF0P08@9H01008
@9L0246G00Q1U`08@IL300Q2U`8024>G00<02D>H00U4V009A9P00P09A9P300U5V00300U6V009AYT0
2DJI00<02DNI0`09B9T00`09BIT02DVJ00U9VP0400U:VP<02T^J0`0:C9/300Y=V`802TjK00@02TjL
00Y?W00:Ci`02TnL100:D9`0100:DI`02U6M00YAW@0:DYd200]BW@<02e>M00<02eBM00]DWP0;E9h0
0`0;EIh400]FWP<02eNO0`0;F9l300]IW`<035ZP0`0<Fj0300aLX0@035fQ0`0<GZ4200aOX@0400aO
XP0<H:80362R00aPXP80366R00@03F6R00eRXP0=HZ803F:S100=Hj<300eTX`0300eUX`0=IJ@03FFT
00<03FJT0`0=Ij@300eXY@@03VVU0P0>JZD0100>JZH03V^V00i[YP0>JjH300i/YP803VfV00@03VfW
00i^Y`0>KZL03VjW100>KjL00`0>L:L03g2X00m`Z00300maZ0<03g:X00<03g>X00mcZ@0?LjT00`0?
M:T400meZ@<03gJZ0`0?MjX3011hZP<047V[0`0@NZ/3011kZ`@047b/0`0@OJ`2011n[004011n[@0@
Ojd047n]015o[@<04H2]00<04H6]0161[P0APJh0100APZh30163[P<04HB_0`0AQJl30166[`<04XN`
100BR;0201:9/00401:9/@0BR[404XZa01::/@<04X^a0P0BS;40100BS;804Xfb01:=/P0BSK8201:>
/P804hjb00<04hnb01>?/`0CSk<00`0CT;<301>A/`0301>B/`0CT[@04i:d00<04i>d100CU;@301>E
]@<059Je0`0DUkD301BH]P<059Vf0P0DV[H00`0DV[L059^g01BK]`0201BK]`<059bg00<059fg01FM
^00EWKP00`0EW[P301FO^00301FP^00EX;T05J2i00@05J6i0`0EX[T301FS^P<05JBj0`0FYKX301JV
^`@05ZNk0P0FZ;/0100FZ;`05ZVl01JY_00FZK`301JZ_0805Z^l00@05Z^m01J/_@0F[;d05jbm100G
[Kd00`0G[[d05jjn01N^_P0301N__P<05k2n00<05k6n01Na_`0G/Kl00`0G/[l301Nc_cH06;C00P28
`;P104R@R040000000000`28`;P0b>3H08S0^03o08S0^?l0R<2hQP28`;P104R@R040000000000`28
`;P0b>3H08S0^03o08S0^?l0R<2hQP28`;P104R@R040000000000`28`;P0b>3H0<SPf03o0<SPf?l0
b>3HQP38h=P104R@R0400000003o08S0^?l0R<2hRP28`;P100000000\
\>"], "Graphics",
  ImageSize->{649, 491},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:40001h2000`400?l00000o`00003oooo`l?3o
oo3`l8Kol?3`003ooo3`l?ool?3`Q_o`l?000?ool?3`ooo`l?26oo3`l000ooo`l?3ooo3`l8Kol?3`
003ooo3`l?ool?3`Q_o`l?000?ool?3`ooo`l?26oo3`l000ooo`l?3ooo3`l8Kol?3`003ooo3`l?oo
l?3`Q_o`l?000?ool?3`ooo`l?26oo3`l000ooo`l?3ooo3`l8Kol?3`003ooo3`l?ool?3`Q_o`l?00
0?ool?3`ooo`l?26oo3`l000ooo`l?3ooo3`l8Kol?3`003ooo3`l?ool?3`Q_o`l?000?ool?3`ooo`
l?26oo3`l000ooooooooooooohKooooo0002onk^k_ooU9BDoonDU9B3oiBDU07ok^k^0002onKViP03
oiBDU?oVi^Koi^KV0?ooi^KVoooVi^IoonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0
ooo^k^koonk^kWook^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3oooooooooooooOooo
ool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^ioonk^kP7oU9BD0Oo^k^h0
00;oi^KV00?oU9BDonKVi_oVi^H0oooVi^KoonKViWooi^KV0OnDU9@1onKViP000_o^k^h00onDU9Co
k^k^onk^kP3oonk^k_ook^k^Ooo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oooooo
oooooomoooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^h4onk^kQgooooo00?o
onZNooo`__ooool0D_ooool00ooojYkooo2nooooo`0booooom?ok^k^0OnDU9@1onk^kP000_oVi^H0
0onDU9Coi^KVonKViP3oonKViPCoi^KV7Oooool00oooeD3oon=oooooo`1Booooo`03oooE@?oohgoo
oooo03;ooooodooVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^1?o^k^h3oooo
o`03ooonoOoommcoooWV00Gooooo00?ooo[/ooonoOooool00_ooo?@=ooooo`05oooE@?oohgooookn
oooiiOooo_h02Oooool00oooo?Cooo[Xooooo`0@ooooo`03ooolm?oon^Sooooo00cooooo00?oooWU
ooonoOooool02?ooool00oooo_goooOLoooiiP05ooooo`03ooojk?ooo_gooooo00;ooocd3Oooool0
1OooeD3oon=oooono_oonNGoookn00Wooooo00?ooocdooojj?ooool04?ooool00oooo?Cooo[Xoooo
o`0<ooooo`03oooiiOooo_gooooo00;ooooodoo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooo
oooo0?oooooo1_ooool01_ookK3oolX:ooo:3OoocbCoom<fooo/Y`;ooooo00WoomUAooo92?oocA[o
onVLooo<4ooofUOooooooooE@?oohgl00_ooool01_oohW[oomI3ooooooooooooonjdooo92@;ooooo
00KoomE0oooHBoood2KooldKooo<5Oool;`2ooooo`0:oooE@?oohgoooooooooooooonNOoomM:ooo8
0ooocb?ool`Goooa`@Oooooo00?oon1boooD>?ooool00oooool02OoonNOoomM:ooo80ooocb?ool`G
oooa`Ooommkool`Eooocb`02ooooo`08oooTQ?oocASoooWWoooooooomM?oollUooo>7_ool;X8oooo
o`06ooo]/?oobP[oolX=ooo?9?oodcKoonbW0_ooool02OoofE7oolT8ooo=6_oojIcool`CoooJEooo
ooooomE0oooSO`02ooooo`06oooRN_ooeT?oooooooooooook[CoolT90_ooool01_ooeD3oomQ;ooo@
9_oocA_ool`Eooo`_0;ooooo00[oomE0oooSOooooooooooooooiioooed[oolP3ooo?8oooc1Oooo71
1oooool00oooh7;oom@hooooo`03ooooo`09oooiioooed[oolP3ooo?8oooc1Oooo71ooogg_ooc1Go
oo?;00;ooooo00SoonB4ooo=6?oonNOooooooooedooocbGoolhNooo`^]Kooooo0OnDU9@1ooooo`00
0_o^k^h00onDU9Cok^k^onk^kP3oonk^kPCok^k^0_ooool03Ooom]Kooo6oooomn_ooooooonVMooo8
1?oommkooo;6ooo81?oommgoooWVoooKFoooba400_ooool01_ooeD3oon=oooooooooooooon9joooF
@`;ooooo00koonjdooo92OoooooooooooooE@?ooeT?ooo__ooonnooohWgool`CooolloooooooomE0
oooSO`;ooooo00KoomI4oooE@?oon=ooooooooolloooo?87ooooo`03oooPL_ooe3Sooooo00?ooooo
00goomI4oooE@?oon=ooooooooolloooo?;oooooooo/ZOoocb?ooo_aooo`__oob@Kooo7000;ooooo
00?oon1aoooF@Oooo_h02Oooool03Ooom]Kooo6oooomn_ooooooonVMooo81?oommkooo;6ooo81?oo
mmgoooWVoooKFoooba400_ooool01_ooeD3oon=oooooooooooooon9joooF@`;ooooo00koonjdooo9
2OoooooooooooooE@?ooeT?ooo__ooonnooohWgool`CooolloooooooomE0oooSO`;ooooo00KoomI4
oooE@?oon=ooooooooolloooo?87ooooo`03oooPL_ooe3Sooooo00?ooooo00goomI4oooE@?oon=oo
ooooooolloooo?;oooooooo/ZOoocb?ooo_aooo`__oob@Kooo7000;ooooo00?oon1aoooF@Oooo_h0
1?oooooConk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0Y?oVi^HIooo800Goi^KV6Ooo
ool5onKViQWo00002_oVi^H6ooooo`09ooohhOoob03oonnfoooffOoob0?ooo2moooooooojYooolhP
00;ooooo00KoomE0oooSOooooooooooooooRN_ooeT<2ooooo`06ooo^]?oob@WoooooooooooooeD3o
on=o0_ooool02_oonNOoolP0ooo][OooooooomE0oooSOoooooooooOMooo80?ookkP;ooooo`03oooP
L_ooe3Sooooo00;ooooo00?oooOMooo80?ookkP01_ooool01?oogVKoomQ>ooo<5oooiHL3ooooo`03
oooHCOooh7;ooooo00gooooo00WoooSQooo80?ookkKoooKIooo80oool;gooooooooZWooocR000_oo
ool01_ooeD3oon=oooooooooooooon9joooF@`;ooooo00Koonjdooo92OoooooooooooooE@?oohgl2
ooooo`0:oooiiooob03oonf]ooooooooeD3oon=ooooooooommgoolP0ooo_^0_ooooo00?oon1boooD
>?ooool00_ooool00ooommgoolP0ooo_^006ooooo`04oooNI_oof4kool`GoooUQ`?ooooo00?oomQ=
oooPL_ooool01?oooooConKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0Y?o^k^hIooo8
00Gok^k^6Oooool5onk^kQWo00002_o^k^h5ooooo`0:oookl?oofDooolT8oooll_ooooooonf]oooB
<_oodc?oom<fooo>80;ooooo00KoomE0oooSOooooooooooooooRN_ooeT<2ooooo`06ooo^]?oob@Wo
ooooooooooooeD3oon=o0oooool02Oooc1KoonNAooooooooeD3oon=oooooooool;koolP0oooE?@03
oooE?`03oooba?oooooooooo00Gooooo00?oon1boooD>?ooool00_ooool00oool;koolP0oooE?@03
oooE?`07oooba?oooooooooooooll_oobP[ool/@ooomm`03ooooo`03oooHCOooh7;ooooo00cooooo
00[ooo_`oooICooob@SooocbooooooookJgoom8boooC<ooodcKoolhP0_ooool01_ooeD3oon=ooooo
ooooooooon9joooF@`;ooooo00Koonjdooo92OoooooooooooooE@?oohgl3ooooo`09ooo<5_ooii7o
oooooooE@?oohgooooooooo`__oob03oomDm00?oomDo00?ooo;4ooooooooool01Oooool00oooh7;o
om@hooooo`02ooooo`03ooo`__oob03oomDm00?oomDo00Oooo;4oooooooooooooocbooo:2_ooba3o
oogg00?ooooo00?oomQ=oooPL_ooool01?ooool4onk^kRWoolP0Y_o^k^h1oiBDU07ok^k^0002oooo
o`03oiBDU?oooooooooo0:Cooooo6Ooob00SoooooaWo00003_ooool01?ookkKoolhLooo<5oool;h4
ooooo`03ooonoOooiiCoollQ00;ooooo00[oomE0oooOKOoooooooooooooRNOoodc?oooknoooooooo
k[?oolT90_ooool04_ooeD3oon9joooooooooooooo_]ooo80?ool/?ooooooooE@?oohgooooooooog
fooob03oonb[ooodcoool/OoolP3oooii@Oooooo00?oon1boooD>?ooool00_ooool01ooomm_oolP0
ooo/Zooom<oooo;7ooo80ooonND00_ooool01?oohGKoollQoooGBOoohGD3ooooo`03oooHCOooh7;o
oooo00_ooooo00Coonnfooo>7?ooc1Oooo2n1?ooool00oooo_goonNDooo?8@02ooooo`0:oooE@?oo
gfgooooooooooooohWWoom<cooono_ooooooonjcooo92@;ooooo01;oomE0oooRN_oooooooooooook
kOoob03ooo;3ooooooooeD3oon=ooooooooomm_oolP0ooo/Zooom<oooo;7ooo80ooonND7ooooo`03
oooPL_ooe3Sooooo00;ooooo00OoooOKooo80?ook:_oooC?ooobaooob0?oooWU00;ooooo00Coon5f
ooo?8OooedWoon5e0oooool00ooof4goon1booooo`08ooooobWoolP0Y_ooool1oiBDU07ooooo0002
onk^kP03oiBDU?o^k^kok^k^0:Cok^k^6Ooob005onk^kQWooooo1Oo^k^hIo`0000[ok^k^0oooool0
1?oohh7oolP1oooJE_oonNH3ooooo`05ooo^]?oomm[oookloooLHOoofU@00_ooool02_ooeD3ool`E
oooVS?oon^SoomDoooo>7ooog63oooSRoooPLOoodc<2ooooo`0:oooE@?oocA_oonRGooogg?oogVWo
ol/Aooono?ooooooomE0oooSO`;ooooo00GoomDooooOJooooOOoonZNoooA:`08ooooo`03oooPL_oo
e3Sooooo00?ooooo00GoomDooooOJooooOOoonZNoooA:`02ooooo`0<ooo^/Ooob@Oooo?;ooojjOoo
cASooo;4oooooooooOWoomM9oooOKOooo?Coookk2Oooool01?oohh7oolP1oooJE_oonNH3ooooo`05
ooo^]?oomm[oookloooLHOoofU@00_ooool02_ooeD3ool`EoooVS?oon^SoomDoooo>7ooog63oooSR
oooPLOoodc<2ooooo`0:oooE@?oocA_oonRGooogg?oogVWool/Aooono?ooooooomE0oooSO`;ooooo
00GoomDooooOJooooOOoonZNoooA:`08ooooo`03oooPL_ooe3Sooooo00?ooooo00GoomDooooOJooo
oOOoonZNoooA:`02ooooo`0<ooo^/Ooob@Oooo?;ooojjOoocASooo;4oooooooooOWoomM9oooOKOoo
o?Coookk0oooool4onk^kRWoolP0Y_o^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV0:Co
i^KV6Ooob005onKViQWooooo1OoVi^HIo`0000[oi^KV0_ooool00ooonNKoolP2oooWT`05ooooo`05
oooUR_oodS;ool/@oooD>Oool/@00_ooool02_oofUCoonF;oooPLOooba3oom0XoooeeOoojI[ooldJ
ooo>8?ookJd2ooooo`06oooJE?ooiH[oomeUooo:3OoocAWoonbX0_ooool02OooeD3oon=ooooooooo
ooooooWVoooGAooobPgoolhLooo_]`08ooooo`03oooPL_ooe3Sooooo00?ooooo00WoooWVoooGAooo
bPgoolhLooo_]ooooooooo[YoooA;?ooj9L00_ooool02?ookJooomDoooomn_oohgooolT8ooo:3?oo
cA_oonf^2?ooool00ooonNKoolP2oooWT`05ooooo`05oooUR_oodS;ool/@oooD>Oool/@00_ooool0
2_oofUCoonF;oooPLOooba3oom0XoooeeOoojI[ooldJooo>8?ookJd2ooooo`06oooJE?ooiH[oomeU
ooo:3OoocAWoonbX0_ooool02OooeD3oon=oooooooooooooooWVoooGAooobPgoolhLooo_]`08oooo
o`03oooPL_ooe3Sooooo00?ooooo00WoooWVoooGAooobPgoolhLooo_]ooooooooo[YoooA;?ooj9L0
0_ooool02?ookJooomDoooomn_oohgooolT8ooo:3?oocA_oonf^0oooool4onKViRWoolP0Y_oVi^H1
oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^0:Cok^k^6Ooob005onk^kPGooooo3ooob005oooo
o`Gok^k^1Ol0000?ooo800Go00002_o^k^h2ooooo`03oooff?oob0;oooWW00Oooooo00?oookmoooo
ooooool01Oooool00oooo_koooooooooo`02ooooo`03ooono_oooooooooo00Cooooo00?oookmoooo
ooooool00_ooool00oooeD3oon=oooooo`03ooooo`03ooono?oooooooooo00Sooooo00?oon1boooD
>?ooool01Oooool00oooo_coooooooooo`0:ooooo`03oooHCOooh7;ooooo00Wooooo00?oooKHooo8
0_oonNL01oooool00oooo_goooooooooo`05ooooo`03ooono_oooooooooo00;ooooo00?oooknoooo
ooooool01?ooool00oooo_goooooooooo`02ooooo`03oooE@?oohgoooooo00?ooooo00?oookloooo
ooooool02?ooool00oooh7;oom@hooooo`05ooooo`03ooono?oooooooooo00[ooooo00?oomQ=oooP
L_ooool01?ooool4onk^kRWoolP0Y_o^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0:Co
oooo6Ooob00:ooooo`ooolP02_ooool5o`0000ooolP01Ol0000=ooooo`05oooGB_ooe3[oonJ>oooM
H_oofUP07Oooool00oooeD3oon=oooooo`0;ooooo`05oooQMooogFGoomeUoooA;Oooc1H00ooogFD0
0ooonnkoooooooooo`0=ooooo`03ooohh?oommkooooo00[ooooo00GoomM:oooD>_ooiXkoomeRoooJ
F00Mooooo`03oooE@?oohgoooooo00_ooooo00Goon5goooMIOoogFGoom4]ooo<5P03oooMI@03oook
k_oooooooooo00gooooo00?oooSPooogg_ooool02?oooolYooo80:Kooooo0OnDU9@1ooooo`000_o^
k^h00onDU9Cok^k^onk^kP2Tonk^kQWoolP01Oo^k^h5ooooo`ooolP01Oooool5onk^kPGo00003ooo
b005o`0000[ok^k^0oooool01Oooo__oonnfoooOK_ooiHSooo6o01gooooo00?oomE0oooSOoooool0
2oooool00ooojjKoonVJoooYVP05oooYVP03ooolm?oooooooooo01[ooooo00Goookkooo_]_oogfko
onF8oooa_`0Mooooo`03oooE@?oohgoooooo00_ooooo00?oon^VoooYV_oojIX01OoojIX00oooo?Co
ooooooooo`0Dooooo`Cok^k^:Ooob02Vonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0
Y?oVi^HIooo800Goi^KV1Oooool?ooo800Gooooo1OoVi^H5o`0000ooolP01Ol0000:onKViRGooooo
00?oookkooonoOooool0D_ooool00oooo__oookmooooo`0Zooooo`Coi^KV:Ooob02VonKViP7oU9BD
0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0Y?o^k^hIooo800Gok^k^1Oooool?ooo800Gooooo1Oo^
k^h5o`0000ooolP01Ol0000:onk^kZOooooo1?o^k^hYooo80:Kok^k^0OnDU9@1onk^kP000_ooool0
0onDU9Coooooooooo`2ToooooaWoolP02_ooool?ooo800[ooooo1Ol0000?ooo800Go0000]OoooolY
ooo80:Kooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP2Tonk^kQWoolP01Oo^k^h5oooo
o`ooolP01Oooool5onk^kPGo00003ooob005o`0000[ok^k^Yoooool4onk^kRWoolP0Y_o^k^h1oiBD
U07ok^k^0002onKViP03oiBDU?oVi^Koi^KV0:Coi^KV6Ooob005onKViPGooooo3ooob005ooooo`Go
i^KV1Ol0000?ooo800Go00002_oVi^JWooooo`Coi^KV:Ooob02VonKViP7oU9BD0OoVi^H000;ok^k^
00?oU9BDonk^k_o^k^h0Y?o^k^hIooo800Gok^k^1Oooool?ooo800Gooooo1Oo^k^h5o`0000ooolP0
1Ol0002eonk^kRWoolP0Y_o^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0:Cooooo6Ooo
b00:ooooo`ooolP02_ooool5o`0000ooolP01Ol0002eooooobWoolP0Y_ooool1oiBDU07ooooo0002
onk^kP03oiBDU?o^k^kok^k^0:Cok^k^6Ooob005onk^kPGooooo3ooob005ooooo`Gok^k^1Ol0000?
ooo800Go0000]Oo^k^hYooo80:Kok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP2TonKV
iQWoolP01OoVi^H5ooooo`ooolP01Oooool5onKViPGo00003ooob005o`0000[oi^KV7Ooob0000onN
N`3o_YD0ooo8001Booo80003oiik0?nnU@3oolP003;oolP01?oVi^HYooo80:Koi^KV0OnDU9@1onKV
iP000_o^k^h00onDU9Cok^k^onk^kP2Tonk^kQWoolP01Oo^k^h5ooooo`ooolP01Oooool5onk^kPGo
00003ooob005o`0000[ok^k^7Ooob0000om0<P3oOf<0ooo8001Booo80003od0b0?moH`3oolP003;o
olP01?o^k^hYooo80:Kok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`2ToooooaWoolP0
2_ooool?ooo800[ooooo1Ol0000?ooo800Go00002_ooool3ooo80003oog60?oL[03oi[@000GoolP0
00?ok;T0oog60?oob0000_od_`0=ooo80005od0b0?moH`3oo/L0onFc0?ona`002Ooob0000ood_`3o
j;D0ooo8000@ooo80003ooBo0?oX]@3oolP000coolP000?oiK<0oog60?oob0002?oob0000oomaP3o
g:`0onJd0005ooo80003onbi0?omaP3oolP000;om;l03Ooob0001Om0<P3oOf<0ook70?oU/`3oo/L0
00WoolP000?om;l0onRe0?oob0004?oob0000ood_`3oj;D0ooo8000<ooo80003onFc0?omaP3oolP0
00;oolP01?oooolYooo80:Kooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP2Tonk^kQWo
olP01Oo^k^h5ooooo`ooolP01Oooool5onk^kPGo00003ooob005o`0000[ok^k^0_oob0001_n`RP3o
2PL0o`d:0?lT703o=RX0ojN200;oolP000WoDCl0o`P60?lJ503oW7X0oa<>0?mGA03oolP0od0b0?mo
H`000_oob0001_mjG`3o@c@0ooo80?oob03o]8d0o`T700;oolP000Ko@380od/j0?lV7@3o6aD0oaD@
0?nlT`02ooo8000:od0b0?moH`3oolP0ooo80?oW]@3oBSX0o`<20?lS6`3o5a80ol6G00OoolP000?o
LUT0ocP[0?oob0000ooob0002OoW]@3oBSX0o`<20?lS6`3o5a80ol6G0?oN[P3o5A00ol^O0002ooo8
0008ohAW0?lH4P3oikD0ooo80?oCY@3o9Ad0oahG0?njT@08ooo80006ok2:0?l:1`3o3@X0ob@L0?lf
:P3oYh800_oob0002OmA?`3o20H0oaXD0?nLNP3o4`h0oeM40?oob03o@380ogmS0002ooo80006ogYO
0?m3=03oolP0ooo80?ndS@3o2@L00_oob0001_m0<P3oBcX0obHM0?lK5@3o5A00okbC00;oolP000[o
@380ogmS0?oob03oolP0onNe0?m:>P3o0`80ob<K0?lG4P3o`IL01ooob0000ombF@3o>2/0ooo80003
ooo80009onNe0?m:>P3o0`80ob<K0?lG4P3o`IL0omj^0?lE403obil000;oolP000SoQ6L0oaPB0?oW
]@3oolP0om>U0?lU7@3o7QL0okZA00?oolP01?o^k^hYooo80:Kok^k^0OnDU9@1onk^kP000_oVi^H0
0onDU9Coi^KVonKViP2TonKViQWoolP01OoVi^HIooooo`Goi^KV6Ol0000:onKViP;oolP000goeZL0
oknE0?oja03oolP0oiek0?l40`3ogZh0olJK0?l40`3ogJd0onJd0?mKA`3o4@d000;oolP000Ko@380
ogmS0?oob03oolP0ogYO0?m3=002ooo8000>okB=0?l91`3oolP0ooo80?m0<P3o@c@0onnk0?oka03o
OF80oa<>0?oc_P3oolP0od0b0?moH`02ooo80006od@e0?m0<P3ogjh0ooo80?oc_P3ol[d01ooob000
0ombF@3o>2/0ooo80003ooo8000=od@e0?m0<P3ogjh0ooo80?oc_P3ol[d0ooo80?nYQ03o8a/0oo6m
0?nnU@3o1P@0ol2F0002ooo80003og5H0?m1<P3oo/L000WoolP000goeZL0oknE0?oja03oolP0oiek
0?l40`3ogZh0olJK0?l40`3ogJd0onJd0?mKA`3o4@d000;oolP000Ko@380ogmS0?oob03oolP0ogYO
0?m3=002ooo8000>okB=0?l91`3oolP0ooo80?m0<P3o@c@0onnk0?oka03oOF80oa<>0?oc_P3oolP0
od0b0?moH`02ooo80006od@e0?m0<P3ogjh0ooo80?oc_P3ol[d01ooob0000ombF@3o>2/0ooo80003
ooo8000=od@e0?m0<P3ogjh0ooo80?oc_P3ol[d0ooo80?nYQ03o8a/0oo6m0?nnU@3o1P@0ol2F0002
ooo80003og5H0?m1<P3oo/L000CoolP01?oVi^HYooo80:Koi^KV0OnDU9@1onKViP000_o^k^h00onD
U9Cok^k^onk^kP2Tonk^kQWoolP01Oo^k^hIooooo`Gok^k^6Ol0000:onk^kPKoolP000WohK00o`00
0?nfSP3ofJX0o`<20?nmU03oolP0oiml0?lP6@000_oob0001_m0<P3oOf<0ooo80?oob03oNUl0od<d
00;oolP000Ko]8d0o`T70?oob03oolP0od0b0?moH`02ooo8000:onNe0?l0003o[HL0ooo80?m0<P3o
Of<0ooo80?oM[@3o0000okR@00_oolP000?oLUT0ocP[0?oob0000_oob0000ooM[@3o0000okR@0006
ooo80004ofI@0?m>?@3o5a80ohMY00?oolP000?oCC`0og9I0?oob0003Ooob0002OoQ/03o0000okJ>
0?oIZP3o0`80okfD0?oob03oWg`0ob0I0002ooo80006od0b0?moH`3oolP0ooo80?mjG`3o@c@00_oo
b0001_ndS@3o2@L0ooo80?oob03o@380ogmS00;oolP000[oikD0o`000?n]Q`3oolP0od0b0?moH`3o
olP0omf]0?l0003o^9002ooob0000ombF@3o>2/0ooo80002ooo80003omf]0?l0003o^90000KoolP0
00CoIU00odhm0?lG4P3oQfT00ooob0000om=?03oLUT0ooo80004ooo800Cok^k^:Ooob02Vonk^kP7o
U9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0Y?oooolIooo802?ooooo6Ol0000:ooooo`GoolP0
00[ol;`0odlm0?l81P3ol[d0ooo80?n]Q`3o<RL0oc<X0?lf:P3o81T00_oob0001_m0<P3oOf<0ooo8
0?oob03oNUl0od<d00;oolP000Ko]8d0o`T70?oob03oolP0od0b0?moH`03ooo80009oaHA0?nAL@3o
olP0od0b0?moH`3oolP0okjE0?l0003o?Bl000?o?c4000?oa9T0ooo80?oob0001Ooob0000ombF@3o
>2/0ooo80002ooo80003okjE0?l0003o?Bl000?o?c4000Ooa9T0ooo80?oob03ol[d0o`X70?l@303o
ml4000?oolP000?oCC`0og9I0?oob0003?oob0002_o`_03oCcd0o`P60?ob_@3oolP0ojf70?lb9`3o
<bP0ocHZ0?lP6@02ooo80006od0b0?moH`3oolP0ooo80?mjG`3o@c@00_oob0001_ndS@3o2@L0ooo8
0?oob03o@380ogmS00?oolP000Wo5Q40oi5a0?oob03o@380ogmS0?oob03o_YD0o`000?lm;`000olo
<@000oo4V@3oolP0ooo80005ooo80003og9I0?lh:`3oolP000;oolP000?o_YD0o`000?lm;`000olo
<@001oo4V@3oolP0ooo80?ob_@3o2PL0oa0<0?og`@000ooob0000om=?03oLUT0ooo80004ooo800Co
oooo:Ooob02Vooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0Y?o^k^hIooo800Gok^k^
6Oooool5onk^kQWo00002_o^k^h4ooo80004okJ>0?lL5@3o5a80okjE00CoolP000?ooLH0oiAd0?lQ
6@000_oob0002_m0<P3oKED0ooo80?oob03oNEh0oc<X0?ona`3oolP0ok><0?l91`02ooo8000Bod0b
0?mjG`3oolP0ooo80?o]^@3o0000ol>H0?oob03o@380ogmS0?oob03ofj/0o`000?n[QP3ocj80olNL
0?l30P3oiK<01ooob0000ombF@3o>2/0ooo80002ooo80007om^[0?l0003oZhH0olnR0?o7W03o0`80
onFc0002ooo80004ogIL0?lQ6@3oBCT0ogEK00?oolP000?oCC`0og9I0?oob0002ooob0001?nfSP3o
71D0oaLB0?nnU@04ooo80003oog60?nDM03o8AT000;oolP000[o@380ofeE0?oob03oolP0ogUN0?lc
:03oo/L0ooo80?ncS03o2@L00_oob0004_m0<P3oNUl0ooo80?oob03okKT0o`000?o3V03oolP0od0b
0?moH`3oolP0om^[0?l0003oZhH0olnR0?o7W03o0`80onFc00OoolP000?oLUT0ocP[0?oob0000_oo
b0001ooKZ`3o0000oj^60?o?XP3oai`0o`<20?oU/`000_oob0001?mfG03o8AT0odTi0?meF`03ooo8
0003oddl0?mbF@3oolP000CoolP01?o^k^hYooo80:Kok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Co
i^KVonKViP2TonKViQWoolP01OoVi^HIooooo`Goi^KV6Ol0000:onKViP?oolP000CoPFD0o`400?mF
@`3oi[@00ooob0001OndS@3ofZX0ooc50?mQC03oE44000;oolP000[o@380oaD@0?n<K@3oj;D0ocla
0?lO603oH4/0on:a0?maF03o<bP00_oob0002_m0<P3o6aD0oiMf0?oL[03oJE80oa4=0?ola@3oolP0
od0b0?moH`02ooo80005ocla0?m[D`3oml40oiik0?l[8@002?oob0000ombF@3o>2/0ooo80003ooo8
0005ocla0?m[D`3oml40oiik0?l[8@000_oob0003?naRP3o1`D0ol^O0?oY]P3o6180olBI0?oob03o
nL<0odTi0?m]E@3om;l0oo_400WoolP000CoPFD0o`400?mF@`3oi[@00ooob0001OndS@3ofZX0ooc5
0?mQC03oE44000;oolP000[o@380oaD@0?n<K@3oj;D0ocla0?lO603oH4/0on:a0?maF03o<bP00_oo
b0002_m0<P3o6aD0oiMf0?oL[03oJE80oa4=0?ola@3oolP0od0b0?moH`02ooo80005ocla0?m[D`3o
ml40oiik0?l[8@002?oob0000ombF@3o>2/0ooo80003ooo80005ocla0?m[D`3oml40oiik0?l[8@00
0_oob0003?naRP3o1`D0ol^O0?oY]P3o6180olBI0?oob03onL<0odTi0?m]E@3om;l0oo_400?oolP0
1?oVi^HYooo80:Koi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^kPCok^k^0_oo
b0000ooV]03o0P40oi=c0005ooo80005ohY/0?lb9`3o40`0ocT/0?o4V@000_oob0002_mD@@3oRfd0
og5H0?l@303o:1l0omFW0?nJN03o6Q@0ob0I0?n]Q`02ooo80006oeA10?n:K03oIDl0o`d:0?lI4`3o
Z8<00_oob0002Om0<P3oOf<0ooo80?oob03oi[@0odLg0?l=2P3o71D0okN?0008ooo80003og9I0?lh
:`3oolP000?oolP000Woi[@0odLg0?l=2P3o71D0okN?0?oob03ojKH0ob`R0?nGMP000_oob0002?n_
R@3o?c40oo[40?moH`3o20H0o``90?lK5@3o[XP02?oob0000ooV]03o0P40oi=c0005ooo80005ohY/
0?lb9`3o40`0ocT/0?o4V@000_oob0002_mD@@3oRfd0og5H0?l@303o:1l0omFW0?nJN03o6Q@0ob0I
0?n]Q`02ooo80006oeA10?n:K03oIDl0o`d:0?lI4`3oZ8<00_oob0002Om0<P3oOf<0ooo80?oob03o
i[@0odLg0?l=2P3o71D0okN?0008ooo80003og9I0?lh:`3oolP000?oolP000Woi[@0odLg0?l=2P3o
71D0okN?0?oob03ojKH0ob`R0?nGMP000_oob0002?n_R@3o?c40oo[40?moH`3o20H0o``90?lK5@3o
[XP00ooob004onk^kRWoolP0Y_o^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0?oooooo
1?ooool2ooo80003omRY0?l20@3oikD000OoolP000?ooLH0ooo80?oob0001Ooob0000oona`3oolP0
ooo80002ooo80003ook70?oob03oolP000CoolP000?ooLH0ooo80?oob0000_oob0000om0<P3oOf<0
ooo80003ooo80003ooc50?oob03oolP000SoolP000?oLUT0ocP[0?oob0001Ooob0000oola@3oolP0
ooo8000:ooo80003oddl0?mbF@3oolP000WoolP000?of:T0o`810?oW]@001ooob0000oomaP3oolP0
ooo80005ooo80003ook70?oob03oolP000;oolP000?oo/L0ooo80?oob0001?oob0000oomaP3oolP0
ooo80002ooo80003od0b0?moH`3oolP000?oolP000?oo<D0ooo80?oob0002?oob0000ombF@3o>2/0
ooo80005ooo80003ooc50?oob03oolP000[oolP000?oCC`0og9I0?oob0001?oob004ooooobWoolP0
Y_ooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^1?o^k^h3ooo80005odXj0?lj
;@3oSVl0of9<0?mHA@007Ooob0000om0<P3oOf<0ooo8000;ooo80005ogMM0?mUC`3oIDl0obdS0?lF
4@000omUC`000oo^^P3oolP0ooo8000=ooo80003on2_0?oN[P3oolP000[oolP000GoBSX0ocX]0?n>
K`3oHT`0oeQ5000Mooo80003od0b0?moH`3oolP000_oolP000GoMed0ofE?0?mUC`3o;B<0oaHA0003
ofE?0003onjj0?oob03oolP000goolP000?oh:l0omj^0?oob0001?oob004onk^kRWoolP0Y_o^k^h1
oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV0?ooi^KV1?oVi^H3ooo80005oo_40?nfSP3oKUH0
ohQZ0?noU@007Ooob0000om0<P3oOf<0ooo8000;ooo80003ojJ20?nJN03oVWP000GoVWP000?om;l0
ooo80?oob0006_oob0001Ooka03o]Xh0ofiF0?n8JP3o_iD001goolP000?o@380ogmS0?oob0002ooo
b0000onVPP3oVWP0oiYh0005oiYh0003ooBo0?oob03oolP001CoolP01?oVi^HYooo80:Koi^KV0OnD
U9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^kPCok^k^9Ooob0000ooka03ooLH0ooo8001B
ooo80003oo_40?omaP3oolP002[oolP01?o^k^hYooo80:Kok^k^0OnDU9@1onk^kP000_ooool00onD
U9Coooooooooo`32oooooaWo0000:?oooonWooo800Cooooo:Ooob02Vooooo`7oU9BD0Oooool000;o
k^k^00?oU9BDonk^k_o^k^h0Y?o^k^hIooooo`Gok^k^6Ol00005onk^kQWooooo2_o^k^jWooo800Co
k^k^:Ooob02Vonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0Y?oVi^HIooooo`Goi^KV
6Ol00005onKViQWooooo2_oVi^JWooo800Coi^KV:Ooob02VonKViP7oU9BD0OoVi^H000;ok^k^00?o
U9BDonk^k_o^k^h0Y?o^k^hIooooo`Gok^k^6Ol00005onk^kQWooooo2_o^k^jWooo800Cok^k^:Ooo
b02Vonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0`_oooolIo`000=?ooooo:Ooob02V
ooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0Y?o^k^h5ooooo`ooolP01Oooool5onk^
kPGo00003ooob005o`0000Gok^k^1Oooool?ooo800Gooooo]Oo^k^hYooo80:Kok^k^0OnDU9@1onk^
kP000_oVi^H00onDU9Coi^KVonKViP2TonKViPGooooo3ooob005ooooo`Goi^KV1Ol0000?ooo800Go
00001OoVi^H5ooooo`ooolP01OooooneonKViRWoolP0Y_oVi^H1oiBDU07oi^KV0002onk^kP03oiBD
U?o^k^kok^k^0:Cok^k^1Oooool?ooo800Gooooo1Oo^k^h5o`0000ooolP01Ol00005onk^kPGooooo
3ooob005ooooobGok^k^00?om=nCoo;T/Oo^k^h0D_o^k^h00oodgi?ol^Baonk^kP0honk^kRWoolP0
Y_o^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo0:Wooooo3ooob00:ooooo`Go00003ooo
b005o`0000[ooooo3ooob00Zooooo`03oooE@?oohgoooooo05;ooooo00?oomE0oooSOoooool0>?oo
oolYooo80:Kooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP2Tonk^kPGooooo3ooob005
ooooo`Gok^k^1Ol0000?ooo800Go00001Oo^k^h5ooooo`ooolP01Oooool;onk^kP03onk]k?o`j<go
kn[F00Gok^k^00?okn_Lonk]k?o^k^h00_o^k><=onk^kP05oo[A>ooffWKok^g]onoZeOo^kNd02Oo^
k^h00oo^k>?okn[Honk^kP0@onk^kP03onk/hoo_j]Sok^k^00cok^k^00?okn[Eonk]k?o^k^h02?o^
k^h00oo^kNcol>S=onoZeP05onk^kP03ono[g?o^kNcok^k^00;ok^cS3Oo^k^h01OojdC_om]Yfonk]
kOo_j]Gok^g]00Wok^k^00?ok^cSonoZf?o^k^h04?o^k^h00oo^k>?okn[Honk^kP0<onk^kP03onoZ
eOo^kNcok^k^00Sok^k^:Ooob02Vonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0Y?oV
i^H5ooooo`GoolP01Oooool5ooo800Gooooo1OoVi^H5o`0000GoolP01Oooool5ooo800Go00001OoV
i^H5ooooo`GoolP01Ol00005ooo800Gooooo2_oVi^H01_o]g9koo/T9oog92ookc23onLh`onkKUP;o
i^KV00Womm59ook81oolbaOokmZ<oog:4OofdTkoi^KVooS?>OobeW800_oVi^H01_oceVkon<llonKV
i_oVi^KokMfRook920;oi^KV00Kon<liooO@@ookc2;oo</Hooc:4_o/gZT2onKViP0:ooS?>OobeW;o
i^KVonKVi_oXhm3omm12ook80_okc1ooo<XDoncN[POoi^KV00?olmEVooW><_oVi^H00ooVi^H02OoX
hm3omm12ook80_okc1ooo<XDoncN[_oYh/Soo<XBon_O]`02onKViP08oo;GMoolbQGoj>?@onKVi_oZ
h;konl`Qooc;6oo/gJL8onKViP06ongLW_onb@WooLT;oo_<8?oicS3ok]^F0_oVi^H02OogdDWoo/P7
ooc;5oo_fXcooLXAooKBC_oVi^Kon<lioo;FLP02onKViP06oo?FK_ohcccoi^KVonKVi_o]gJ;oo/T8
0_oVi^H01_ohccWomm13oo_<8_olbaSoo<XBoncNZ@;oi^KV00[on<lioo;FL_oVi^Koi^KVonSSd?og
d4;oo/P2oo_<7oolbQCok=j^1ooVi^H00ooceFKonLhbonKViP03onKViP09onSSd?ogd4;oo/P2oo_<
7oolbQCok=j^onWRb?olbQ;ojmng00;oi^KV00Sol]Mgooc:5OoXhm3oi^KVon[P__okc27oo</KoncM
Y`Woi^KV:Ooob02VonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0Y?o^k^h5ooooo`Go
olP01Oooool5ooo800Gooooo1Oo^k^h5o`0000GoolP01Oooool5ooo800Go00001Oo^k^h5ooooo`Go
olP01Ol00005ooo800Gooooo2_o^k^h03Oo`ilOol^Bbonk]jOo^k^kom=nBook80oo`jLoolNFhook8
0oo`j<kokn[FooSEE?ombPl00_o^k^h01_ojdC_om]Yfonk^k_o^k^kom]Yaoo[A?P;ok^k^00koln:X
ook92?o^k^kok^k^oo[A>oojdCkokn_Oonk]j_offWCooLXAonk/h_o^k^kon]4kooKJMP;ok^k^00Ko
n]8ooo[A>oo`jM3ok^k^onk/h_o^k>47onk^kP03ooOHJ_okd3Cok^k^00?ok^k^00gon]8ooo[A>oo`
jM3ok^k^onk/h_o^k>7ok^k^oo?QWOolcB3ok^_Poo;T/Oonb0Gol^Bc00;ok^k^00?ommQYoo[A??o^
kNd02Oo^k^h03Oo`ilOol^Bbonk]jOo^k^kom=nBook80oo`jLoolNFhook80oo`j<kokn[FooSEE?om
bPl00_o^k^h01_ojdC_om]Yfonk^k_o^k^kom]Yaoo[A?P;ok^k^00koln:Xook92?o^k^kok^k^oo[A
>oojdCkokn_Oonk]j_offWCooLXAonk/h_o^k^kon]4kooKJMP;ok^k^00Kon]8ooo[A>oo`jM3ok^k^
onk/h_o^k>47onk^kP03ooOHJ_okd3Cok^k^00?ok^k^00gon]8ooo[A>oo`jM3ok^k^onk/h_o^k>7o
k^k^oo?QWOolcB3ok^_Poo;T/Oonb0Gol^Bc00;ok^k^00?ommQYoo[A??o^kNd02_o^k^hYooo80:Ko
k^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`2Yooooo`GoolP01Oooool5ooo800[ooooo
1Ol00005ooo800Gooooo1Ooob005o`0000[ooooo1Ooob005o`0000GoolP04oooool02Ooon>7oolP0
ooo_]_oom]WoolP3ooo`_OooooooonZOooo>8002ooooo`06oooE@?oohgoooooooooooooohW[oomI3
0_ooool01_ook[CoolT9ooooooooooooomE0oooSO`;ooooo00[oooWWooo80?ookJgooooooooE@?oo
hgoooooooooggOoob03oonnh2oooool00oooh7;oom@hooooo`02ooooo`03oooggOoob03oonnh00Ko
oooo00CoomiVoooHC_ooc1OoonF70oooool00ooof4goon1booooo`0=ooooo`09ooohhOoob03oonnf
oooffOoob0?ooo2moooooooojYooolhP00;ooooo00KoomE0oooSOooooooooooooooRN_ooeT<2oooo
o`06ooo^]?oob@WoooooooooooooeD3oon=o0_ooool02_oonNOoolP0ooo][OooooooomE0oooSOooo
ooooooOMooo80?ookkP;ooooo`03oooPL_ooe3Sooooo00;ooooo00?oooOMooo80?ookkP01_ooool0
1?oogVKoomQ>ooo<5oooiHL3ooooo`03oooHCOooh7;ooooo00[ooooo:Ooob02Vooooo`7oU9BD0Ooo
ool000;ok^k^00?oU9BDonk^k_o^k^h0Y?o^k^h5ooooo`GoolP01Oooool5ooo800Gooooo1Oo^k^h5
o`0000GoolP01Oooool5ooo800Go00001Oo^k^h5ooooo`GoolP01Ol00005ooo800Gooooo3Oo^k^h0
2_o_jn3onM=9ook91oo^k>7ok^k^oo?QXOokcbkonll_oo_@<_olc1d2onk^kP06oo[A>ooffWKok^k^
onk^k_offW7on]4n0_o^k^h01_ochZSoo/T8onk^k_o^k^kon]4kooKJMP?ok^k^00WooL/DooGMQoo^
k^kon]4kooKJM_o^k^kol^Baooo80?ojdCP00oojdCX00ooaiKKok^k^onk^kP05onk^kP03ooOHJ_ok
d3Cok^k^00;ok^k^00?ol^Baooo80?ojdCP00oojdCX01ooaiKKok^k^onk^k_o^k>7oo/T9oog:3_o^
k>H00oo^k^h00ooiddOommQZonk^kP0<onk^kP0:ono[h?oiddWoo/T7onk/hOo^k^koln6Qoo_?;_ok
cboonm0booc<7@;ok^k^00Kon]4kooKJM_o^k^kok^k^ooKJLOojdCh2onk^kP06oo?RZ?onb@Sok^k^
onk^k_ojdC_om]Yf0oo^k^h02OombaComMf7onk^k_ojdC_om]Yfonk^k_obi;7oolP0oo[A>003oo[A
>P03oo7U]_o^k^kok^k^00Gok^k^00?ommQZoo_@=?o^k^h00_o^k^h00oobi;7oolP0oo[A>003oo[A
>P07oo7U]_o^k^kok^k^onk/hOonb@WooLX>onk/iP03onk^kP03ooWCAoogf6[ok^k^00[ok^k^:Ooo
b02Vonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0Y?oVi^H5ooooo`GoolP01Oooool5
ooo800Gooooo1OoVi^H5o`0000GoolP01Oooool5ooo800Go00001OoVi^H5ooooo`GoolP01Ol00005
ooo800Gooooo3?oVi^H01?o]gJCoo</Iooc:5?o/gZ/4onKViP03onKUi?o`fHGonl/M00;oi^KV00[o
n<liooCDH_oVi^Koi^KVoo?FKOojcRkoi^GUonKVi_o]gJ7oo/T80_oVi^H04_ohccWolmI^onKVi_oV
i^Koin?Eooo80?o[gZooi^KVooS?>OobeW;oi^KVonWQaOoob03ok]bJon[P^_o[gk?oo/P2onSRcPOo
i^KV00?olmEVooW><_oVi^H00_oVi^H01ooYhLGoolP0onkLV_oZh;[ojmncook80_oXh/h00_oVi^H0
1?oceF[onl/MooO@@OoceFT3onKViP03ooOAAOoceFKoi^KV00_oi^KV00CokMfTooc;6OolbQCok=j[
1?oVi^H00ooViNCol=V5oo_;7@02onKViP0:ooS?>Oode6;oi^KVonKVi_oceVgon/h^onKUiOoVi^Ko
kMfQook920;oi^KV01;on<lioo?FK_oVi^Koi^KVonOSeOoob03ojmj_onKVi_ohccWol]IbonKVi_oY
hLGoolP0onkLV_oZh;[ojmncook80_oXh/h7onKViP03oo?EI_oicS;oi^KV00;oi^KV00OojN75ooo8
0?o^g9[oj^2jon_O/oonb0;oj>;>00;oi^KV00ColmEZoo_;7Oogd47olmEY0ooVi^H00oogdDGolmEV
onKViP0:onKViRWoolP0Y_oVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^0:Cok^k^1Ooo
ool?ooo800Gooooo1Oo^k^h5o`0000ooolP01Ol00005onk^kPGooooo3ooob005ooooo`_ok^k^00Co
m]]hook80?oie53okn[F0oo^k^h01OochZSol>S;onk]jooheU[onMA>00;ok^k^00[on]4koog;4ooe
g8;okn[Hoo[A>_olc1con=IIonoYd_ogf6Wonll_0_o^k^h02_ojdC_ooL`IooCNS?o`j<gon=MRoog:
3oo^kN_ok^k^oo[A>ooffWH2onk^kP05oo[A>_ogef?ok^cVooCOToolcRP02?o^k^h00oogf6[onm0d
onk^kP03onk^kP05oo[A>_ogef?ok^cVooCOToolcRP00_o^k^h03?ochZGoo/T6oo7V_Oo_j]WooL/F
oo7U]_o^k^kok^gXoo[BA?ogf6Gok^cSonk]jPWok^k^00Com]]hook80?oie53okn[F0oo^k^h01Ooc
hZSol>S;onk]jooheU[onMA>00;ok^k^00[on]4koog;4ooeg8;okn[Hoo[A>_olc1con=IIonoYd_og
f6Wonll_0_o^k^h02_ojdC_ooL`IooCNS?o`j<gon=MRoog:3oo^kN_ok^k^oo[A>ooffWH2onk^kP05
oo[A>_ogef?ok^cVooCOToolcRP02?o^k^h00oogf6[onm0donk^kP03onk^kP05oo[A>_ogef?ok^cV
ooCOToolcRP00_o^k^h03?ochZGoo/T6oo7V_Oo_j]WooL/Foo7U]_o^k^kok^gXoo[BA?ogf6Gok^cS
onk]jPWok^k^:Ooob02Vonk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0ZOooool?ooo8
00[ooooo1Ol0000?ooo800Go00002_ooool?ooo800oooooo00?oooWVooo80_ooii<01Oooool01Ooo
iH[oom8booo;4?ooe3Wooo;400;ooooo00[oomYDoooURoooh77ool/@ooo@:?oomMGoonVJooo=6_oo
cR3oonf]0_ooool01_oofUCoonF:oooMIOoobPgooldIooo/Z0;ooooo00WoomE0oooSOooooooooooo
oooii_ooedOoolX=ooo>7?ookkL02?ooool00oooh7;oom@hooooo`03ooooo`09oooii_ooedOoolX=
ooo>7?ookkOoooooooojjOoodBcoonRG00;ooooo00Soonf_oooE?ooooO[oon=oooo92?oobPcooldK
ooo][PSooooo00?oooWVooo80_ooii<01Oooool01OooiH[oom8booo;4?ooe3Wooo;400;ooooo00[o
omYDoooURoooh77ool/@ooo@:?oomMGoonVJooo=6_oocR3oonf]0_ooool01_oofUCoonF:oooMIOoo
bPgooldIooo/Z0;ooooo00WoomE0oooSOooooooooooooooii_ooedOoolX=ooo>7?ookkL02?ooool0
0oooh7;oom@hooooo`03ooooo`09oooii_ooedOoolX=ooo>7?ookkOoooooooojjOoodBcoonRG00;o
oooo00Soonf_oooE?ooooO[oon=oooo92?oobPcooldKooo][PWooooo:Ooob02Vooooo`7oU9BD0Ooo
ool000;ok^k^00?oU9BDonk^k_o^k^h0Y?o^k^h5ooooo`ooolP01Oooool5onk^kPGo00003ooob005
o`0000Gok^k^1Oooool?ooo800Gooooo2_o^k^h00oo`j<Woo/P1onoZe`07onk^kP03onk]k?o^k^ko
k^k^00Gok^k^00?ok^g]onk^k_o^k^h00_o^k^h00oo^kNgok^k^onk^kP04onk^kP03onk]k?o^k^ko
k^k^00;ok^k^00?on]4kooKJM_o^k^h00oo^k^h00oo^kN_ok^k^onk^kP08onk^kP03ooOHJ_okd3Co
k^k^00Gok^k^00?ok^g[onk^k_o^k^h02_o^k^h00ooiddOommQZonk^kP09onk^kP03oo3XbOonb07o
kn[G00Ook^k^00?ok^g/onk^k_o^k^h01Oo^k^h00oo^kNgok^k^onk^kP02onk^kP03onk]kOo^k^ko
k^k^00Cok^k^00?ok^g/onk^k_o^k^h00_o^k^h00oojdC_om]Yfonk^kP03onk^kP03onk]joo^k^ko
k^k^00Sok^k^00?ommQZoo_@=?o^k^h01Oo^k^h00oo^kN_ok^k^onk^kP0:onk^kP03ooWCAoogf6[o
k^k^00[ok^k^:Ooob02Vonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0Y?oVi^H5oooo
o`ooolP01Oooool5onKViPGo00003ooob005o`0000Goi^KV1Oooool?ooo800Gooooo2ooVi^H01Oog
d4;onLhdoo7HP?oedeSom]9?01goi^KV00?on<lioo;FL_oVi^H02ooVi^H01OoceV_omM=KooGCFooj
cBSoo<XC00?omM=K00?oinCFonKVi_oVi^H03OoVi^H00ooYh/[ojN;8onKViP0:onKViP05ooO@@_oi
cSColMR0ooGCF?ofdTl07OoVi^H00oohccWol]IbonKViP0;onKViP05oo?FJooede_omM=Koo[=:?ol
bQ<00ooede/00ooWi=Koi^KVonKViP0=onKViP03onWRb_oYh/Soi^KV00[oi^KV:Ooob02VonKViP7o
U9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0Y?o^k^h5ooooo`ooolP01Oooool5onk^kPGo0000
3ooob005o`0000Gok^k^1Oooool?ooo800Gooooo2oo^k^h01Oo^kN[ol^>YooOHI_oeg7kol^Bb01go
k^k^00?on]4kooKJM_o^k^h02oo^k^h00ooch9[om=j?ooCNS`05ooCNS`03onk/hoo^k^kok^k^01[o
k^k^00Gok^gZoo;SZOogf6KomManoo;T/P0Monk^kP03oo[A>ooffWKok^k^00_ok^k^00?oln2JooCN
SoodgXl01OodgXl00oo^k>?ok^k^onk^kP0Jonk^kRWoolP0Y_o^k^h1oiBDU07ok^k^0002ooooo`03
oiBDU?oooooooooo0<;ooooo6Ol0001;ooooo`03ooonnoooo_gooooo05;ooooo00?oookkooonoOoo
ool0<?oooolYooo80:Kooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP2Tonk^kQWooooo
1Oo^k^hIo`0000Gok^k^6Oooooneonk^kRWoolP0Y_o^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oV
i^Koi^KV0:Coi^KV6Oooool5onKViQWo00001OoVi^HIoooookGoi^KV:Ooob02VonKViP7oU9BD0OoV
i^H000;ok^k^00?oU9BDonk^k_o^k^h0Y?o^k^hIooooo`Gok^k^6Ol00005onk^kQWooooo]Oo^k^hY
ooo80:Kok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`32oooooaWo0000dooooolYooo8
0:Kooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^Ooo^k^h1oiBDU07o
k^k^0002onKViP03oiBDU?oVi^Koi^KV0?ooi^KVoooVi^IoonKViP7oU9BD0OoVi^H000;ok^k^00?o
U9BDonk^k_o^k^h0ooo^k^koonk^kWook^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3o
ooooooooooooOoooool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^0?ook^k^ooo^k^ioonk^
kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^KoonKViWooi^KV0OnDU9@1onKViP00
0_o^k^h00onDU9Cok^k^onk^kP3oonk^k_ook^k^Ooo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oo
oooooooo01?ooooo00?om?CdonSXj?ooool03oooool00oodm?Coj>SXooooo`3oooooooooooooEooo
ool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^00Gok^k^00?o<S8bofm_Koo^k^h01?o^k^h0
0olk>c_oMWIfonk^kP02onk^kP06omOGeom5ADGo0P82ob0P8?lE5AGo];Bd0_o^k^h00omdM7Co0000
olk>cP03onk^kP0>oc/k>omfMWKok^k^onk^k_oGemOoADE5o`820_lP823o5ADEokBd]?o^k^koe]KF
o`000?mnOWh2onk^kP03odA4A?lU9BGok^k^0?ook^k^ooo^k^i=onk^kP7oU9BD0Oo^k^h000;oi^KV
00?oU9BDonKVi_oVi^H01OoVi^H00ol`<33oJf][onKViP04onKViP03ocTi>OmbLW;oi^KV00;oi^KV
00_o?CdmocTi>Oo9bLWoi^KVom_KfooJf][oi^KVonGUiOlK6a_o4Q8Bofi^KP03onKViP0CocTi>Omb
LW;oi^KVonKVi_lm?Cgo>CTiolW9bOoVi^Kofm_Kom[Jf_oVi^KoSXj>o`d=3Olc<c?oi^KVomoOgol9
2@Wo3@d=okno_`3oonKVi_ooi^KVCOoVi^H1oiBDU07oi^KV0002onk^kP03oiBDU?o^k^kok^k^00Go
k^k^00?o<S8bofm_Koo^k^h01?o^k^h01olk>c_oMWIfonk^k_o^k^koc/k>o`000?n[Zj/01Oo^k^h0
1Onb/[;o2PX:ojRXZ?lG5aOoj^[Z00;ok^k^00Ko>c/kogIfM_o^k^koc/k>o`000?n[Zj/5onk^kP08
odm?Com[Jf_o6QXJomSHf?n`/;3o7QhNofIVI_mhN7Soonk^k_ook^k^COo^k^h1oiBDU07ok^k^0002
ooooo`03oiBDU?oooooooooo00Gooooo00Co=SHfoeMGEoo8b<Sok>c/0oooool01om0@43oOgmooooo
oooooooo_[jno`000?lm?Cd00olo?cl01oo4a<Coooooof1PH?mMGEgoooooobHV9_n`/;000_ooool0
1_m0@43oOgmooooooonn_[ko0000ocdm?@?o?clo00[oa<C4oo_knol?3`oo_KfmofQXJ?nJVY[oMgMg
ofIVI_o0`<3o;Bd]ooooooooooooodgooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP05
onk^kP09oc8b<_lL71co7QhNo`000?mDE5Cohn?Sonk^k_lk>c_oHV9R00;ok^k^00goc<c<o`000?nO
Wioo`L71okVi^Ol20P;oeMGEon?Shol:2P[o/;2`onk^k_n0P83oATI600;ok^k^01Co>c/kogIfM_o^
k^koc<c<o`000?nOWioo`L71okVi^Ol20P;oeMGEokJf]_l;2`_oj>SXojVYZOm6ATKo;Bd]oijNW_o/
k>co51@Dol_;boook^k^ooo^k^i<onk^kP7oU9BD0Oo^k^h000;oi^KV1onDU9@07OoVi^Ko<30`of][
JooVi^Ko_[jno`X:2_mOGeooi^KVocTi>OlA4A7oPX:2olg=cOoTi>Co>3Phof1PH?oNg]koSXj>obHV
9_oVi^KoTY:Boa/K6ooUiNGoi^KVom;Bd_l71`Oobl_;onKVi_li>CWoLW9b00;oi^KV013o>3Phof1P
H?oNg]koSXj>obHV9_oVi^KoKFe]odE5AOoVi^KogmoOoa0@4?l20P;oeMGEonKVi_mLG5coN7QhoonD
U9CooiBDU4goU9BD0OoVi^H000[ok^k^01Co<S8bofm_Koo^k^kok^k^of1PH?lM7Agok^k^odi>C_mo
OgooEUIFo`P82?oPh>3oe]KFod92@_l<30co6QXJojZZZ_o^k^koE5ADogemO@?ok^k^00GoFUYJohV9
ROo^k^koCTi>oh>3P`02onk^kP08omKFe_m2@T;o30`<oaXJ6_nZZZ[ok^k^odE5AOnCTi<2onk^kP06
oeYJF_m0@43ok^k^onk^k_n`/;3oAdM7ooo^k^koonk^kTkok^k^000:ooooo`06ocHf=_mgMgOooooo
oooooom5ADGoA4A41?ooool01Oolo?coooooooooooooooooo?cl017ooooo00?oo?clooooooooool0
oooooooooooooeWooooo000:onk^kP06oc8b<_l[:b_oE5ADob@T9?l10@7oXZ:R5?o^k^h00omDE5Co
R8R8onk^kP3oonk^k_ook^k^Goo^k^h000[oi^KV00GoWYjNohZ:R_n;Rh_oW9bLolS8b00EonKViP03
oj:RX_nh^;Soi^KV0?ooi^KVoooVi^IOonKViP00ooo^k^koonk^kXKok^k^003oooooooooooooQ_oo
ool00?ook^k^ooo^k^j6onk^kP00oooVi^KoonKViXKoi^KV0004on7QhOoofm_KoooKfm]mom_Kf`Co
hN7Q0Oo^k^h00004oo;bl_oZj^[oj^[Zon[Zj_oog]kNoooNg]imomkNgP?oj^[Z0Oooool1oo;blP00
00CohN7Qom[Jf_o?clooclo?oonm_Kgookfm_Ggo_Kfm0_o?cll1onk^kP7of][J0OoQhN400004om[J
f_oCdm?ob<S8okNg]oooVi^KoonKVi]moi^KV`04okNg]ooVi^Kob<S8om?Cd`7of][J00001OoQhN7o
f][Jolo?conm_Kgo=cLg0?ooMWIfoomfMWIlogIfMP04ofm_Konm_Kgoclo?om[JfP7ohN7Q00001Oob
l_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0000
1OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7o
f][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kN
on[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng
]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04
ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^Il
onKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^
k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooo
oooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?oo
k^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM
0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_Kgo
Xj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;
bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?
conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?C
olS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7o
f][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oob
l_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0000
1OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7o
f][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kN
on[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng
]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04
ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^Il
onKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^
k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooo
oooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?oo
k^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM
0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_Kgo
Xj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;
bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?
conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?C
olS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7o
f][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oob
l_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0000
1OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7o
f][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kN
on[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng
]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04
ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^Il
onKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^
k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooo
oooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?oo
k^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM
0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_Kgo
Xj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;
bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?
conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?C
olS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7o
f][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oob
l_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0000
1OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7o
f][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kN
on[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng
]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04
ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^Il
onKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^
k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooo
oooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?oo
k^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM
0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_Kgo
Xj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;
bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?
conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?C
olS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7o
f][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oob
l_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0000
1OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7o
f][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kN
on[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng
]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04
ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^Il
onKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^
k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooo
oooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?oo
k^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM
0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_Kgo
Xj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;
bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?
conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?C
olS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7o
f][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oob
l_;oj^[ZomkNg_o;bl_o[jn_06koooooool0001Io`000;Cooooo00Co[jn_ol_;booNg]koj^[Z0Oob
l_800005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooooooo`3ooooooeGooooo00?o
0000onk^k_o^k^h0/_o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNg
oifMW@1^onKViP03o`000?oooooo000000Wo000000?oooooo`000?l000002?l000000ooooooo0000
o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000
o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000
o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000
o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000
o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000
o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000
o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000
o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000
o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000
o`000008o`000003ooooool0003o000000So000000?oooooo`000?oVi^H0/ooVi^H01?nMWIgo]kNg
olS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1^onk^kP03o`000?oooooo03<c00So
03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So
03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`00<`08o`00<`03o`000?oooooo<`0c00So
<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So
<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So
<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0000So
<`0000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So
<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So
<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So
<c<000?o0000ooooool0<`002?l0<`000ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So
03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So
03<c00?o0000ooooool00000]?o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oN
g]kobl_;ojn_[`1^ooooo`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0
003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0
003oooooo`00<`08o`00<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0
003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0
003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0
003ooooooc<0<`08oc<0<`03o`000?oooooo<`0000So<`0000?o0000oooooolc<`002?lc<`000ol0
003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0
003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0
003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000ooooool0<`002?l0<`000ol0
003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0
003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool00000]?ooool01?n_
[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1^onk^kP03o`000?oooooo
03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo
03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`00<`08o`00<`03o`000?oooooo
<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo
<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo
<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo
<`0000So<`0000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo
<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo
<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo
<c<000So<c<000?o0000ooooool0<`002?l0<`000ol0003oooooo`0c<`08o`0c<`03o`000?oooooo
03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo
03<c00So03<c00?o0000ooooool00000]?o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][J
om?Cdoo8b<So]kNgoifMW@1^onKViP03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0
<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0
<c<00ol0003oooooo`00<`08o`00<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc
03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc
03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc
03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0000So<`0000?o0000oooooolc<`002?lc
<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc
<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc
<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000ooooool0<`002?l0
<`000ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0
<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool00000]?oV
i^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1^onk^kP03o`00
0?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`00
0?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`00<`08o`00<`03o`00
0?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`00
0?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`00
0?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`00
0?oooooo<`0000So<`0000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`00
0?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`00
0?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`00
0?oooooo<c<000So<c<000?o0000ooooool0<`002?l0<`000ol0003oooooo`0c<`08o`0c<`03o`00
0?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`00
0?oooooo03<c00So03<c00?o0000ooooool00000]?o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00
00Gol_;bon[Zj_oNg]kobl_;ojn_[`1^ooooo`03o`000?oooooo03<c00So03<c00?o0000ooooool0
<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0
<c<02?l0<c<00ol0003oooooo`00<`08o`00<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc
03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc
03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc
03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0000So<`0000?o0000oooooolc
<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc
<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc
<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o0000ooooool0
<`002?l0<`000ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0
<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0
0000]?ooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1^onk^
kP03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c
<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`00<`08o`00
<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0
<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0
<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0
<`03o`000?oooooo<`0000So<`0000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c
0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c
0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c
0003o`000?oooooo<c<000So<c<000?o0000ooooool0<`002?l0<`000ol0003oooooo`0c<`08o`0c
<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c
<`03o`000?oooooo03<c00So03<c00?o0000ooooool000002_o^k^hjo`00073ok^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0K_oVi^H00ol0003oooooo`0c<`08
o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08
o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool003<02?l003<00ol0003ooooooc<0<`08
oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08
oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08
oc<0<`03o`000?oooooo<`0c00So<`0c00?o0000oooooolc03<02?lc03<00ol0003ooooooc<00008
oc<00003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008
oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008
oc<c0003o`000?oooooo<c<000So<c<000?o0000oooooolc<`002?lc<`000ol0003ooooooc<c0008
oc<c0003o`000?oooooo03<000So03<000?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08
o`0c<`03o`000?oooooo03<c00So03<c00?o0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08
o`0c<`03o`000?oooooo000000[oi^KV00?o0000ooooooooool0=_ooool00ol0003oi^KVonKViP1^
onKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S06kok^k^00?o
0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o
0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo000c00So000c00?o
0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o
0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o
0000oooooolc03<02?lc03<00ol0003ooooooc<0<`08oc<0<`03o`000?oooooo<`0c00So<`0c00?o
0000oooooolc00002?lc00000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o
0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o
0000oooooolc<`002?lc<`000ol0003ooooooc<c0008oc<c0003o`000?oooooo<c<000So<c<000?o
0000oooooolc<`002?lc<`000ol0003oooooo`0c0008o`0c0003o`000?oooooo03<c00So03<c00?o
0000ooooool0<c<02?l0<c<00ol0003oooooo`0c<`08o`0c<`03o`000?oooooo03<c00So03<c00?o
0000ooooool0<c<02?l0<c<00ol0003oooooo`00000:onk^kP03o`000?oooooo000000Wo000000?o
ooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?o
ooooo`000?l000002?l000000ooooooo0000onk^kP1_onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
00001Oobl_;oj^[ZomkNg_o;bl_o[jn_06kooooo00?o0000ooooooooool0oooooomEooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`00
0?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`00
0?oooooo0000073ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnS
Xj<0K_o^k^h00ol0003oooooo`000009o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003ok^k^00Wok^k^00?o0000ooooooo`
l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`
l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0K_oVi^H00ol0003oooooo`1VIP08o`1V
IP03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1V
IP03o`000?oooooo03=V00So03=V00?o0000ooooool006H02?l006H00ol0003ooooooc<0IP08oc<0
IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0
IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0
IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV03<02?mV03<00ol0003oooooofH00008ofH0
0003o`000?ooooooIS<000SoIS<000?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV
0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV
0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003ooooooc=V0008oc=V
0003o`000?oooooo06H000So06H000?o0000ooooool0IS<02?l0IS<00ol0003oooooo`1VIP08o`1V
IP03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1V
IP03o`000?oooooo000000[oi^KV00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`
l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`
l003o`000?oooooo0000073oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?
okfm_OnSXj<0K_o^k^h00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000
ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo03=V00So03=V00?o0000
ooooool006H02?l006H00ol0003ooooooc<0IP08oc<0IP03o`000?ooooooIP1V00SoIP1V00?o0000
oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000
oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000
oooooomV03<02?mV03<00ol0003oooooofH00008ofH00003o`000?ooooooIS<000SoIS<000?o0000
oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000
oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000
oooooomVIP002?mVIP000ol0003ooooooc=V0008oc=V0003o`000?oooooo06H000So06H000?o0000
ooooool0IS<02?l0IS<00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000
ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo000000[ok^k^00?o0000
ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000
ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0K_ooool00ol0003oooooo`1V
IP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1V
IP08o`1VIP03o`000?oooooo03=V00So03=V00?o0000ooooool006H02?l006H00ol0003ooooooc<0
IP08oc<0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0
IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0
IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV03<02?mV03<00ol0003oooooofH0
0008ofH00003o`000?ooooooIS<000SoIS<000?o0000oooooomVIP002?mVIP000ol0003oooooofIV
0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003oooooofIV
0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003ooooooc=V
0008oc=V0003o`000?oooooo06H000So06H000?o0000ooooool0IS<02?l0IS<00ol0003oooooo`1V
IP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1V
IP08o`1VIP03o`000?oooooo000000[ooooo00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`
l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`
l008oo3`l003o`000?oooooo0000073ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJ
f][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV
00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo03=V00So03=V
00?o0000ooooool006H02?l006H00ol0003ooooooc<0IP08oc<0IP03o`000?ooooooIP1V00SoIP1V
00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V
00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V
00?o0000oooooomV03<02?mV03<00ol0003oooooofH00008ofH00003o`000?ooooooIS<000SoIS<0
00?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH0
00?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH0
00?o0000oooooomVIP002?mVIP000ol0003ooooooc=V0008oc=V0003o`000?oooooo06H000So06H0
00?o0000ooooool0IS<02?l0IS<00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV
00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo000000[ok^k^
00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`
00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0K_oVi^H00ol0003o
ooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003o
ooooo`1VIP08o`1VIP03o`000?oooooo03=V00So03=V00?o0000ooooool006H02?l006H00ol0003o
oooooc<0IP08oc<0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003o
ooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003o
ooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV03<02?mV03<00ol0003o
ooooofH00008ofH00003o`000?ooooooIS<000SoIS<000?o0000oooooomVIP002?mVIP000ol0003o
ooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003o
ooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003o
oooooc=V0008oc=V0003o`000?oooooo06H000So06H000?o0000ooooool0IS<02?l0IS<00ol0003o
ooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003o
ooooo`1VIP08o`1VIP03o`000?oooooo000000[oi^KV00?o0000ooooooo`l?002?o`l?000ol0003o
oooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003o
oooooo3`l008oo3`l003o`000?oooooo0000073oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005
on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV
00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo03=V
00So03=V00?o0000ooooool006H02?l006H00ol0003ooooooc<0IP08oc<0IP03o`000?ooooooIP1V
00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V
00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V
00SoIP1V00?o0000oooooomV03<02?mV03<00ol0003oooooofH00008ofH00003o`000?ooooooIS<0
00SoIS<000?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH0
00SoIVH000?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH0
00SoIVH000?o0000oooooomVIP002?mVIP000ol0003ooooooc=V0008oc=V0003o`000?oooooo06H0
00So06H000?o0000ooooool0IS<02?l0IS<00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV
00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo0000
00[ok^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`
00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000
073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0K_ooool0
0ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH0
0ol0003oooooo`1VIP08o`1VIP03o`000?oooooo03=V00So03=V00?o0000ooooool006H02?l006H0
0ol0003ooooooc<0IP08oc<0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H0
0ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H0
0ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV03<02?mV03<0
0ol0003oooooofH00008ofH00003o`000?ooooooIS<000SoIS<000?o0000oooooomVIP002?mVIP00
0ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP00
0ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP002?mVIP00
0ol0003ooooooc=V0008oc=V0003o`000?oooooo06H000So06H000?o0000ooooool0IS<02?l0IS<0
0ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH0
0ol0003oooooo`1VIP08o`1VIP03o`000?oooooo000000[ooooo00?o0000ooooooo`l?002?o`l?00
0ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?00
0ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ooooo00Co[jn_ol_;booNg]koj^[Z0Oob
l_800005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooo`1VIP08o`1VIP03o`000?oo
oooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oo
oooo03=V00So03=V00?o0000ooooool006H02?l006H00ol0003ooooooc<0IP08oc<0IP03o`000?oo
ooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?oo
ooooIP1V00SoIP1V00?o0000oooooomV06H02?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?oo
ooooIP1V00SoIP1V00?o0000oooooomV03<02?mV03<00ol0003oooooofH00008ofH00003o`000?oo
ooooIS<000SoIS<000?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?oo
ooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003oooooofIV0008ofIV0003o`000?oo
ooooIVH000SoIVH000?o0000oooooomVIP002?mVIP000ol0003ooooooc=V0008oc=V0003o`000?oo
oooo06H000So06H000?o0000ooooool0IS<02?l0IS<00ol0003oooooo`1VIP08o`1VIP03o`000?oo
oooo06IV00So06IV00?o0000ooooool0IVH02?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oo
oooo000000[ok^k^00?o0000ooooooooool0=_ooool00ol0003ok^k^onk^kP1^onk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM06koi^KV00?o0000ooooool0IVH0
2?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH0
2?l0IVH00ol0003oooooo`0cIP08o`0cIP03o`000?oooooo001V00So001V00?o0000oooooolc06H0
2?lc06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H0
2?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP1V00SoIP1V00?o0000oooooomV06H0
2?mV06H00ol0003oooooofH0IP08ofH0IP03o`000?ooooooIP0c00SoIP0c00?o0000oooooomV0000
2?mV00000ol0003oooooofHc0008ofHc0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP00
2?mVIP000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooomVIP00
2?mVIP000ol0003oooooofIV0008ofIV0003o`000?ooooooIVH000SoIVH000?o0000oooooolcIP00
2?lcIP000ol0003oooooo`1V0008o`1V0003o`000?oooooo06Hc00So06Hc00?o0000ooooool0IVH0
2?l0IVH00ol0003oooooo`1VIP08o`1VIP03o`000?oooooo06IV00So06IV00?o0000ooooool0IVH0
2?l0IVH00ol0003oooooo`00000:onKViP03o`000?oooooo000000Wo000000?oooooo`000?l00000
2?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l00000
2?l000000ooooooo0000onKViP1_onKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][J
olo?conm_KgoXj>S06kok^k^00?o0000ooooooooool0oooooomEooooo`03o`000?o^k^kok^k^00So
k^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00So
l?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073o
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0K_ooool00ol0
003oooooo`000009o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003ooooo00Wooooo00?o0000ooooooo`l?002?o`l?000ol0
003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0
003ooooooo3`l008oo3`l003o`000?oooooo0000073ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_80
0005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo
09VI00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`1VV@08o`1VV@03o`000?oooooo
03>I00So03>I00?o0000ooooool009T02?l009T00ol0003ooooooc<0V@08oc<0V@03o`000?oooooo
IP2I00SoIP2I00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`000?oooooo
V@2I00SoV@2I00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`000?oooooo
V@1V00SoV@1V00?o0000oooooonI03<02?nI03<00ol0003ooooooiT00008oiT00003o`000?oooooo
VC<000SoVC<000?o0000oooooonIIP002?nIIP000ol0003ooooooiVI0008oiVI0003o`000?oooooo
VIT000SoVIT000?o0000oooooonIV@002?nIV@000ol0003ooooooiVI0008oiVI0003o`000?oooooo
VIT000SoVIT000?o0000oooooomVV@002?mVV@000ol0003ooooooc>I0008oc>I0003o`000?oooooo
09T000So09T000?o0000ooooool0VC<02?l0VC<00ol0003oooooo`2IIP08o`2IIP03o`000?oooooo
09VI00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo
000000[ok^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo
l?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo
0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0K_oV
i^H00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo09VI00So09VI00?o0000ooooool0VIT02?l0
VIT00ol0003oooooo`1VV@08o`1VV@03o`000?oooooo03>I00So03>I00?o0000ooooool009T02?l0
09T00ol0003ooooooc<0V@08oc<0V@03o`000?ooooooIP2I00SoIP2I00?o0000oooooonI09T02?nI
09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI09T02?nI
09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@1V00SoV@1V00?o0000oooooonI03<02?nI
03<00ol0003ooooooiT00008oiT00003o`000?ooooooVC<000SoVC<000?o0000oooooonIIP002?nI
IP000ol0003ooooooiVI0008oiVI0003o`000?ooooooVIT000SoVIT000?o0000oooooonIV@002?nI
V@000ol0003ooooooiVI0008oiVI0003o`000?ooooooVIT000SoVIT000?o0000oooooomVV@002?mV
V@000ol0003ooooooc>I0008oc>I0003o`000?oooooo09T000So09T000?o0000ooooool0VC<02?l0
VC<00ol0003oooooo`2IIP08o`2IIP03o`000?oooooo09VI00So09VI00?o0000ooooool0VIT02?l0
VIT00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo000000[oi^KV00?o0000ooooooo`l?002?o`
l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`
l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073oi^KV00CoWIfMokNg]oo8b<Sodm?C
0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooo`2IV@08o`2IV@03o`00
0?oooooo09VI00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`1VV@08o`1VV@03o`00
0?oooooo03>I00So03>I00?o0000ooooool009T02?l009T00ol0003ooooooc<0V@08oc<0V@03o`00
0?ooooooIP2I00SoIP2I00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`00
0?ooooooV@2I00SoV@2I00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`00
0?ooooooV@1V00SoV@1V00?o0000oooooonI03<02?nI03<00ol0003ooooooiT00008oiT00003o`00
0?ooooooVC<000SoVC<000?o0000oooooonIIP002?nIIP000ol0003ooooooiVI0008oiVI0003o`00
0?ooooooVIT000SoVIT000?o0000oooooonIV@002?nIV@000ol0003ooooooiVI0008oiVI0003o`00
0?ooooooVIT000SoVIT000?o0000oooooomVV@002?mVV@000ol0003ooooooc>I0008oc>I0003o`00
0?oooooo09T000So09T000?o0000ooooool0VC<02?l0VC<00ol0003oooooo`2IIP08o`2IIP03o`00
0?oooooo09VI00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`2IV@08o`2IV@03o`00
0?oooooo000000[ok^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`00
0?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`00
0?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_
[jl0K_ooool00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo09VI00So09VI00?o0000ooooool0
VIT02?l0VIT00ol0003oooooo`1VV@08o`1VV@03o`000?oooooo03>I00So03>I00?o0000ooooool0
09T02?l009T00ol0003ooooooc<0V@08oc<0V@03o`000?ooooooIP2I00SoIP2I00?o0000oooooonI
09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI
09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@1V00SoV@1V00?o0000oooooonI
03<02?nI03<00ol0003ooooooiT00008oiT00003o`000?ooooooVC<000SoVC<000?o0000oooooonI
IP002?nIIP000ol0003ooooooiVI0008oiVI0003o`000?ooooooVIT000SoVIT000?o0000oooooonI
V@002?nIV@000ol0003ooooooiVI0008oiVI0003o`000?ooooooVIT000SoVIT000?o0000oooooomV
V@002?mVV@000ol0003ooooooc>I0008oc>I0003o`000?oooooo09T000So09T000?o0000ooooool0
VC<02?l0VC<00ol0003oooooo`2IIP08o`2IIP03o`000?oooooo09VI00So09VI00?o0000ooooool0
VIT02?l0VIT00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo000000[ooooo00?o0000ooooooo`
l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`
l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ooooo00Co[jn_ol_;booN
g]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooo`2IV@08o`2I
V@03o`000?oooooo09VI00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`1VV@08o`1V
V@03o`000?oooooo03>I00So03>I00?o0000ooooool009T02?l009T00ol0003ooooooc<0V@08oc<0
V@03o`000?ooooooIP2I00SoIP2I00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0
V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0
V@03o`000?ooooooV@1V00SoV@1V00?o0000oooooonI03<02?nI03<00ol0003ooooooiT00008oiT0
0003o`000?ooooooVC<000SoVC<000?o0000oooooonIIP002?nIIP000ol0003ooooooiVI0008oiVI
0003o`000?ooooooVIT000SoVIT000?o0000oooooonIV@002?nIV@000ol0003ooooooiVI0008oiVI
0003o`000?ooooooVIT000SoVIT000?o0000oooooomVV@002?mVV@000ol0003ooooooc>I0008oc>I
0003o`000?oooooo09T000So09T000?o0000ooooool0VC<02?l0VC<00ol0003oooooo`2IIP08o`2I
IP03o`000?oooooo09VI00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`2IV@08o`2I
V@03o`000?oooooo000000[ok^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`
l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`
l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8
okNg]onMWId0K_oVi^H00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo09VI00So09VI00?o0000
ooooool0VIT02?l0VIT00ol0003oooooo`1VV@08o`1VV@03o`000?oooooo03>I00So03>I00?o0000
ooooool009T02?l009T00ol0003ooooooc<0V@08oc<0V@03o`000?ooooooIP2I00SoIP2I00?o0000
oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000
oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@1V00SoV@1V00?o0000
oooooonI03<02?nI03<00ol0003ooooooiT00008oiT00003o`000?ooooooVC<000SoVC<000?o0000
oooooonIIP002?nIIP000ol0003ooooooiVI0008oiVI0003o`000?ooooooVIT000SoVIT000?o0000
oooooonIV@002?nIV@000ol0003ooooooiVI0008oiVI0003o`000?ooooooVIT000SoVIT000?o0000
oooooomVV@002?mVV@000ol0003ooooooc>I0008oc>I0003o`000?oooooo09T000So09T000?o0000
ooooool0VC<02?l0VC<00ol0003oooooo`2IIP08o`2IIP03o`000?oooooo09VI00So09VI00?o0000
ooooool0VIT02?l0VIT00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo000000[oi^KV00?o0000
ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000
ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073oi^KV00CoWIfM
okNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooo`2I
V@08o`2IV@03o`000?oooooo09VI00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`1V
V@08o`1VV@03o`000?oooooo03>I00So03>I00?o0000ooooool009T02?l009T00ol0003ooooooc<0
V@08oc<0V@03o`000?ooooooIP2I00SoIP2I00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0
V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0
V@08oiT0V@03o`000?ooooooV@1V00SoV@1V00?o0000oooooonI03<02?nI03<00ol0003ooooooiT0
0008oiT00003o`000?ooooooVC<000SoVC<000?o0000oooooonIIP002?nIIP000ol0003ooooooiVI
0008oiVI0003o`000?ooooooVIT000SoVIT000?o0000oooooonIV@002?nIV@000ol0003ooooooiVI
0008oiVI0003o`000?ooooooVIT000SoVIT000?o0000oooooomVV@002?mVV@000ol0003ooooooc>I
0008oc>I0003o`000?oooooo09T000So09T000?o0000ooooool0VC<02?l0VC<00ol0003oooooo`2I
IP08o`2IIP03o`000?oooooo09VI00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`2I
V@08o`2IV@03o`000?oooooo000000[ok^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`
l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`
l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZ
j^[og]kNol_;bon_[jl0K_ooool00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo09VI00So09VI
00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`1VV@08o`1VV@03o`000?oooooo03>I00So03>I
00?o0000ooooool009T02?l009T00ol0003ooooooc<0V@08oc<0V@03o`000?ooooooIP2I00SoIP2I
00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I
00?o0000oooooonI09T02?nI09T00ol0003ooooooiT0V@08oiT0V@03o`000?ooooooV@1V00SoV@1V
00?o0000oooooonI03<02?nI03<00ol0003ooooooiT00008oiT00003o`000?ooooooVC<000SoVC<0
00?o0000oooooonIIP002?nIIP000ol0003ooooooiVI0008oiVI0003o`000?ooooooVIT000SoVIT0
00?o0000oooooonIV@002?nIV@000ol0003ooooooiVI0008oiVI0003o`000?ooooooVIT000SoVIT0
00?o0000oooooomVV@002?mVV@000ol0003ooooooc>I0008oc>I0003o`000?oooooo09T000So09T0
00?o0000ooooool0VC<02?l0VC<00ol0003oooooo`2IIP08o`2IIP03o`000?oooooo09VI00So09VI
00?o0000ooooool0VIT02?l0VIT00ol0003oooooo`2IV@08o`2IV@03o`000?oooooo000000[ooooo
00?o0000ooooooooool0=_ooool00ol0003oooooooooo`1^ooooo`04ojn_[oo;bl_og]kNon[ZjP7o
l_;b00001OoQhN7of][Jolo?conm_KgoXj>S06kok^k^00?o0000ooooool0VIT02?l0VIT00ol0003o
ooooo`2IV@08o`2IV@03o`000?oooooo09VI00So09VI00?o0000ooooool0IYT02?l0IYT00ol0003o
ooooo`0cV@08o`0cV@03o`000?oooooo002I00So002I00?o0000oooooolc09T02?lc09T00ol0003o
ooooofH0V@08ofH0V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI09T02?nI09T00ol0003o
oooooiT0V@08oiT0V@03o`000?ooooooV@2I00SoV@2I00?o0000oooooonI09T02?nI09T00ol0003o
oooooiT0IP08oiT0IP03o`000?ooooooV@0c00SoV@0c00?o0000oooooonI00002?nI00000ol0003o
oooooiTc0008oiTc0003o`000?ooooooVFH000SoVFH000?o0000oooooonIV@002?nIV@000ol0003o
oooooiVI0008oiVI0003o`000?ooooooVIT000SoVIT000?o0000oooooonIV@002?nIV@000ol0003o
oooooiVI0008oiVI0003o`000?ooooooIYT000SoIYT000?o0000oooooolcV@002?lcV@000ol0003o
ooooo`2I0008o`2I0003o`000?oooooo09Tc00So09Tc00?o0000ooooool0VFH02?l0VFH00ol0003o
ooooo`2IV@08o`2IV@03o`000?oooooo09VI00So09VI00?o0000ooooool0VIT02?l0VIT00ol0003o
ooooo`00000:onk^kP03o`000?oooooo000000Wo000000?oooooo`000?l000002?l000000ooooooo
0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo
0000onk^kP1_onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM
06koi^KV00?o0000ooooooooool0oooooomEooooo`03o`000?oVi^Koi^KV00Soi^KV00?o0000oooo
ooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000oooo
ooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073oi^KV00CoWIfMokNg
]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooo`000009
o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008
o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008
o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008
o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008
o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008
o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008
o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008
o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008
o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008
o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008
o`000003ooooool0003ok^k^00Wok^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008
oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008
oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[o
g]kNol_;bon_[jl0K_ooool00ol0003oooooo`3<c008o`3<c003o`000?oooooo0<c<00So0<c<00?o
0000ooooool0VL`02?l0VL`00ol0003oooooo`1Vc008o`1Vc003o`000?oooooo03?<00So03?<00?o
0000ooooool00<`02?l00<`00ol0003ooooooc<0c008oc<0c003o`000?ooooooIP3<00SoIP3<00?o
0000oooooonI0<`02?nI0<`00ol0003ooooool`0c008ol`0c003o`000?ooooooc03<00Soc03<00?o
0000ooooooo<0<`02?o<0<`00ol0003ooooool`0V@08ol`0V@03o`000?ooooooc01V00Soc01V00?o
0000ooooooo<03<02?o<03<00ol0003ooooool`00008ol`00003o`000?ooooooc3<000Soc3<000?o
0000ooooooo<IP002?o<IP000ol0003oooooolbI0008olbI0003o`000?ooooooc<`000Soc<`000?o
0000ooooooo<c0002?o<c0000ol0003oooooolc<0008olc<0003o`000?ooooooVL`000SoVL`000?o
0000oooooomVc0002?mVc0000ol0003ooooooc?<0008oc?<0003o`000?oooooo0<`000So0<`000?o
0000ooooool0c3<02?l0c3<00ol0003oooooo`3<IP08o`3<IP03o`000?oooooo0<bI00So0<bI00?o
0000ooooool0c<`02?l0c<`00ol0003oooooo`3<c008o`3<c003o`000?oooooo000000[ooooo00?o
0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o
0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ooooo00Co
[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003ooooo
o`3<c008o`3<c003o`000?oooooo0<c<00So0<c<00?o0000ooooool0VL`02?l0VL`00ol0003ooooo
o`1Vc008o`1Vc003o`000?oooooo03?<00So03?<00?o0000ooooool00<`02?l00<`00ol0003ooooo
oc<0c008oc<0c003o`000?ooooooIP3<00SoIP3<00?o0000oooooonI0<`02?nI0<`00ol0003ooooo
ol`0c008ol`0c003o`000?ooooooc03<00Soc03<00?o0000ooooooo<0<`02?o<0<`00ol0003ooooo
ol`0V@08ol`0V@03o`000?ooooooc01V00Soc01V00?o0000ooooooo<03<02?o<03<00ol0003ooooo
ol`00008ol`00003o`000?ooooooc3<000Soc3<000?o0000ooooooo<IP002?o<IP000ol0003ooooo
olbI0008olbI0003o`000?ooooooc<`000Soc<`000?o0000ooooooo<c0002?o<c0000ol0003ooooo
olc<0008olc<0003o`000?ooooooVL`000SoVL`000?o0000oooooomVc0002?mVc0000ol0003ooooo
oc?<0008oc?<0003o`000?oooooo0<`000So0<`000?o0000ooooool0c3<02?l0c3<00ol0003ooooo
o`3<IP08o`3<IP03o`000?oooooo0<bI00So0<bI00?o0000ooooool0c<`02?l0c<`00ol0003ooooo
o`3<c008o`3<c003o`000?oooooo000000[ok^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooo
oo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooo
oo3`l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[J
f_oCdm?ob<S8okNg]onMWId0K_oVi^H00ol0003oooooo`3<c008o`3<c003o`000?oooooo0<c<00So
0<c<00?o0000ooooool0VL`02?l0VL`00ol0003oooooo`1Vc008o`1Vc003o`000?oooooo03?<00So
03?<00?o0000ooooool00<`02?l00<`00ol0003ooooooc<0c008oc<0c003o`000?ooooooIP3<00So
IP3<00?o0000oooooonI0<`02?nI0<`00ol0003ooooool`0c008ol`0c003o`000?ooooooc03<00So
c03<00?o0000ooooooo<0<`02?o<0<`00ol0003ooooool`0V@08ol`0V@03o`000?ooooooc01V00So
c01V00?o0000ooooooo<03<02?o<03<00ol0003ooooool`00008ol`00003o`000?ooooooc3<000So
c3<000?o0000ooooooo<IP002?o<IP000ol0003oooooolbI0008olbI0003o`000?ooooooc<`000So
c<`000?o0000ooooooo<c0002?o<c0000ol0003oooooolc<0008olc<0003o`000?ooooooVL`000So
VL`000?o0000oooooomVc0002?mVc0000ol0003ooooooc?<0008oc?<0003o`000?oooooo0<`000So
0<`000?o0000ooooool0c3<02?l0c3<00ol0003oooooo`3<IP08o`3<IP03o`000?oooooo0<bI00So
0<bI00?o0000ooooool0c<`02?l0c<`00ol0003oooooo`3<c008o`3<c003o`000?oooooo000000[o
i^KV00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00So
l?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073o
i^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0
003oooooo`3<c008o`3<c003o`000?oooooo0<c<00So0<c<00?o0000ooooool0VL`02?l0VL`00ol0
003oooooo`1Vc008o`1Vc003o`000?oooooo03?<00So03?<00?o0000ooooool00<`02?l00<`00ol0
003ooooooc<0c008oc<0c003o`000?ooooooIP3<00SoIP3<00?o0000oooooonI0<`02?nI0<`00ol0
003ooooool`0c008ol`0c003o`000?ooooooc03<00Soc03<00?o0000ooooooo<0<`02?o<0<`00ol0
003ooooool`0V@08ol`0V@03o`000?ooooooc01V00Soc01V00?o0000ooooooo<03<02?o<03<00ol0
003ooooool`00008ol`00003o`000?ooooooc3<000Soc3<000?o0000ooooooo<IP002?o<IP000ol0
003oooooolbI0008olbI0003o`000?ooooooc<`000Soc<`000?o0000ooooooo<c0002?o<c0000ol0
003oooooolc<0008olc<0003o`000?ooooooVL`000SoVL`000?o0000oooooomVc0002?mVc0000ol0
003ooooooc?<0008oc?<0003o`000?oooooo0<`000So0<`000?o0000ooooool0c3<02?l0c3<00ol0
003oooooo`3<IP08o`3<IP03o`000?oooooo0<bI00So0<bI00?o0000ooooool0c<`02?l0c<`00ol0
003oooooo`3<c008o`3<c003o`000?oooooo000000[ok^k^00?o0000ooooooo`l?002?o`l?000ol0
003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0
003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
0005oo;bl_oZj^[og]kNol_;bon_[jl0K_ooool00ol0003oooooo`3<c008o`3<c003o`000?oooooo
0<c<00So0<c<00?o0000ooooool0VL`02?l0VL`00ol0003oooooo`1Vc008o`1Vc003o`000?oooooo
03?<00So03?<00?o0000ooooool00<`02?l00<`00ol0003ooooooc<0c008oc<0c003o`000?oooooo
IP3<00SoIP3<00?o0000oooooonI0<`02?nI0<`00ol0003ooooool`0c008ol`0c003o`000?oooooo
c03<00Soc03<00?o0000ooooooo<0<`02?o<0<`00ol0003ooooool`0V@08ol`0V@03o`000?oooooo
c01V00Soc01V00?o0000ooooooo<03<02?o<03<00ol0003ooooool`00008ol`00003o`000?oooooo
c3<000Soc3<000?o0000ooooooo<IP002?o<IP000ol0003oooooolbI0008olbI0003o`000?oooooo
c<`000Soc<`000?o0000ooooooo<c0002?o<c0000ol0003oooooolc<0008olc<0003o`000?oooooo
VL`000SoVL`000?o0000oooooomVc0002?mVc0000ol0003ooooooc?<0008oc?<0003o`000?oooooo
0<`000So0<`000?o0000ooooool0c3<02?l0c3<00ol0003oooooo`3<IP08o`3<IP03o`000?oooooo
0<bI00So0<bI00?o0000ooooool0c<`02?l0c<`00ol0003oooooo`3<c008o`3<c003o`000?oooooo
000000[ooooo00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo
l?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo
0000073ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0K_o^
k^h00ol0003oooooo`3<c008o`3<c003o`000?oooooo0<c<00So0<c<00?o0000ooooool0VL`02?l0
VL`00ol0003oooooo`1Vc008o`1Vc003o`000?oooooo03?<00So03?<00?o0000ooooool00<`02?l0
0<`00ol0003ooooooc<0c008oc<0c003o`000?ooooooIP3<00SoIP3<00?o0000oooooonI0<`02?nI
0<`00ol0003ooooool`0c008ol`0c003o`000?ooooooc03<00Soc03<00?o0000ooooooo<0<`02?o<
0<`00ol0003ooooool`0V@08ol`0V@03o`000?ooooooc01V00Soc01V00?o0000ooooooo<03<02?o<
03<00ol0003ooooool`00008ol`00003o`000?ooooooc3<000Soc3<000?o0000ooooooo<IP002?o<
IP000ol0003oooooolbI0008olbI0003o`000?ooooooc<`000Soc<`000?o0000ooooooo<c0002?o<
c0000ol0003oooooolc<0008olc<0003o`000?ooooooVL`000SoVL`000?o0000oooooomVc0002?mV
c0000ol0003ooooooc?<0008oc?<0003o`000?oooooo0<`000So0<`000?o0000ooooool0c3<02?l0
c3<00ol0003oooooo`3<IP08o`3<IP03o`000?oooooo0<bI00So0<bI00?o0000ooooool0c<`02?l0
c<`00ol0003oooooo`3<c008o`3<c003o`000?oooooo000000[ok^k^00?o0000ooooooo`l?002?o`
l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`
l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0K_oVi^H00ol0003oooooo`3<c008o`3<c003o`00
0?oooooo0<c<00So0<c<00?o0000ooooool0VL`02?l0VL`00ol0003oooooo`1Vc008o`1Vc003o`00
0?oooooo03?<00So03?<00?o0000ooooool00<`02?l00<`00ol0003ooooooc<0c008oc<0c003o`00
0?ooooooIP3<00SoIP3<00?o0000oooooonI0<`02?nI0<`00ol0003ooooool`0c008ol`0c003o`00
0?ooooooc03<00Soc03<00?o0000ooooooo<0<`02?o<0<`00ol0003ooooool`0V@08ol`0V@03o`00
0?ooooooc01V00Soc01V00?o0000ooooooo<03<02?o<03<00ol0003ooooool`00008ol`00003o`00
0?ooooooc3<000Soc3<000?o0000ooooooo<IP002?o<IP000ol0003oooooolbI0008olbI0003o`00
0?ooooooc<`000Soc<`000?o0000ooooooo<c0002?o<c0000ol0003oooooolc<0008olc<0003o`00
0?ooooooVL`000SoVL`000?o0000oooooomVc0002?mVc0000ol0003ooooooc?<0008oc?<0003o`00
0?oooooo0<`000So0<`000?o0000ooooool0c3<02?l0c3<00ol0003oooooo`3<IP08o`3<IP03o`00
0?oooooo0<bI00So0<bI00?o0000ooooool0c<`02?l0c<`00ol0003oooooo`3<c008o`3<c003o`00
0?oooooo000000[oi^KV00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`00
0?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`00
0?oooooo0000073oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnS
Xj<0K_o^k^h00ol0003oooooo`3<c008o`3<c003o`000?oooooo0<c<00So0<c<00?o0000ooooool0
VL`02?l0VL`00ol0003oooooo`1Vc008o`1Vc003o`000?oooooo03?<00So03?<00?o0000ooooool0
0<`02?l00<`00ol0003ooooooc<0c008oc<0c003o`000?ooooooIP3<00SoIP3<00?o0000oooooonI
0<`02?nI0<`00ol0003ooooool`0c008ol`0c003o`000?ooooooc03<00Soc03<00?o0000ooooooo<
0<`02?o<0<`00ol0003ooooool`0V@08ol`0V@03o`000?ooooooc01V00Soc01V00?o0000ooooooo<
03<02?o<03<00ol0003ooooool`00008ol`00003o`000?ooooooc3<000Soc3<000?o0000ooooooo<
IP002?o<IP000ol0003oooooolbI0008olbI0003o`000?ooooooc<`000Soc<`000?o0000ooooooo<
c0002?o<c0000ol0003oooooolc<0008olc<0003o`000?ooooooVL`000SoVL`000?o0000oooooomV
c0002?mVc0000ol0003ooooooc?<0008oc?<0003o`000?oooooo0<`000So0<`000?o0000ooooool0
c3<02?l0c3<00ol0003oooooo`3<IP08o`3<IP03o`000?oooooo0<bI00So0<bI00?o0000ooooool0
c<`02?l0c<`00ol0003oooooo`3<c008o`3<c003o`000?oooooo000000[ok^k^00?o0000oooooooo
ool0=_ooool00ol0003ok^k^onk^kP1^onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;o
j^[ZomkNg_o;bl_o[jn_06kooooo00?o0000ooooool0c<`02?l0c<`00ol0003oooooo`3<c008o`3<
c003o`000?oooooo09W<00So09W<00?o0000ooooool0I/`02?l0I/`00ol0003oooooo`0cc008o`0c
c003o`000?oooooo003<00So003<00?o0000oooooolc0<`02?lc0<`00ol0003oooooofH0c008ofH0
c003o`000?ooooooV@3<00SoV@3<00?o0000ooooooo<0<`02?o<0<`00ol0003ooooool`0c008ol`0
c003o`000?ooooooc03<00Soc03<00?o0000ooooooo<09T02?o<09T00ol0003ooooool`0IP08ol`0
IP03o`000?ooooooc00c00Soc00c00?o0000ooooooo<00002?o<00000ol0003ooooool`c0008ol`c
0003o`000?ooooooc6H000Soc6H000?o0000ooooooo<V@002?o<V@000ol0003oooooolc<0008olc<
0003o`000?ooooooc<`000Soc<`000?o0000ooooooo<c0002?o<c0000ol0003ooooooiW<0008oiW<
0003o`000?ooooooI/`000SoI/`000?o0000oooooolcc0002?lcc0000ol0003oooooo`3<0008o`3<
0003o`000?oooooo0<`c00So0<`c00?o0000ooooool0c6H02?l0c6H00ol0003oooooo`3<V@08o`3<
V@03o`000?oooooo0<c<00So0<c<00?o0000ooooool0c<`02?l0c<`00ol0003oooooo`00000:oooo
o`03o`000?oooooo000000Wo000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`00
0003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000ooooo`1_oooo
o`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S06kok^k^00?o0000
ooooooooool0oooooomEooooo`03o`000?o^k^kok^k^00Sok^k^00?o0000ooooooo`l?002?o`l?00
0ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?00
0ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN400005om[Jf_oCdm?ob<S8okNg]onMWId0K_oVi^H00ol0003oooooo`000009o`000003ooooool0
003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0
003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0
003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0
003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0
003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0
003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0
003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0
003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0
003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0
003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0
003oi^KV00Woi^KV00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oo
ooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oo
oooo0000073oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0
K_o^k^h00ol0003oooooo`3oo`08o`3oo`03o`000?oooooo0<co00So0<co00?o0000ooooool0VOl0
2?l0VOl00ol0003oooooo`1Vo`08o`1Vo`03o`000?oooooo03?o00So03?o00?o0000ooooool00?l0
2?l00?l00ol0003ooooooc<0o`08oc<0o`03o`000?ooooooIP3o00SoIP3o00?o0000oooooonI0?l0
2?nI0?l00ol0003ooooool`0o`08ol`0o`03o`000?ooooooo`3o00Soo`3o00?o0000oooooooo0<`0
2?oo0<`00ol0003oooooool0V@08ool0V@03o`000?ooooooo`1V00Soo`1V00?o0000oooooooo03<0
2?oo03<00ol0003oooooool00008ool00003o`000?oooooooc<000Sooc<000?o0000ooooooooIP00
2?ooIP000ol0003ooooooonI0008oonI0003o`000?oooooool`000Sool`000?o0000ooooooooo`00
2?ooo`000ol0003oooooolco0008olco0003o`000?ooooooVOl000SoVOl000?o0000oooooomVo`00
2?mVo`000ol0003ooooooc?o0008oc?o0003o`000?oooooo0?l000So0?l000?o0000ooooool0oc<0
2?l0oc<00ol0003oooooo`3oIP08o`3oIP03o`000?oooooo0?nI00So0?nI00?o0000ooooool0ol`0
2?l0ol`00ol0003oooooo`3oo`08o`3oo`03o`000?oooooo000000[ok^k^00?o0000ooooooo`l?00
2?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?00
2?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0K_ooool00ol0003oooooo`3oo`08o`3oo`03
o`000?oooooo0<co00So0<co00?o0000ooooool0VOl02?l0VOl00ol0003oooooo`1Vo`08o`1Vo`03
o`000?oooooo03?o00So03?o00?o0000ooooool00?l02?l00?l00ol0003ooooooc<0o`08oc<0o`03
o`000?ooooooIP3o00SoIP3o00?o0000oooooonI0?l02?nI0?l00ol0003ooooool`0o`08ol`0o`03
o`000?ooooooo`3o00Soo`3o00?o0000oooooooo0<`02?oo0<`00ol0003oooooool0V@08ool0V@03
o`000?ooooooo`1V00Soo`1V00?o0000oooooooo03<02?oo03<00ol0003oooooool00008ool00003
o`000?oooooooc<000Sooc<000?o0000ooooooooIP002?ooIP000ol0003ooooooonI0008oonI0003
o`000?oooooool`000Sool`000?o0000ooooooooo`002?ooo`000ol0003oooooolco0008olco0003
o`000?ooooooVOl000SoVOl000?o0000oooooomVo`002?mVo`000ol0003ooooooc?o0008oc?o0003
o`000?oooooo0?l000So0?l000?o0000ooooool0oc<02?l0oc<00ol0003oooooo`3oIP08o`3oIP03
o`000?oooooo0?nI00So0?nI00?o0000ooooool0ol`02?l0ol`00ol0003oooooo`3oo`08o`3oo`03
o`000?oooooo000000[ooooo00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003
o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003
o`000?oooooo0000073ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm
_OnSXj<0K_o^k^h00ol0003oooooo`3oo`08o`3oo`03o`000?oooooo0<co00So0<co00?o0000oooo
ool0VOl02?l0VOl00ol0003oooooo`1Vo`08o`1Vo`03o`000?oooooo03?o00So03?o00?o0000oooo
ool00?l02?l00?l00ol0003ooooooc<0o`08oc<0o`03o`000?ooooooIP3o00SoIP3o00?o0000oooo
oonI0?l02?nI0?l00ol0003ooooool`0o`08ol`0o`03o`000?ooooooo`3o00Soo`3o00?o0000oooo
oooo0<`02?oo0<`00ol0003oooooool0V@08ool0V@03o`000?ooooooo`1V00Soo`1V00?o0000oooo
oooo03<02?oo03<00ol0003oooooool00008ool00003o`000?oooooooc<000Sooc<000?o0000oooo
ooooIP002?ooIP000ol0003ooooooonI0008oonI0003o`000?oooooool`000Sool`000?o0000oooo
ooooo`002?ooo`000ol0003oooooolco0008olco0003o`000?ooooooVOl000SoVOl000?o0000oooo
oomVo`002?mVo`000ol0003ooooooc?o0008oc?o0003o`000?oooooo0?l000So0?l000?o0000oooo
ool0oc<02?l0oc<00ol0003oooooo`3oIP08o`3oIP03o`000?oooooo0?nI00So0?nI00?o0000oooo
ool0ol`02?l0ol`00ol0003oooooo`3oo`08o`3oo`03o`000?oooooo000000[ok^k^00?o0000oooo
ooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000oooo
ooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0K_oVi^H00ol0003oooooo`3oo`08
o`3oo`03o`000?oooooo0<co00So0<co00?o0000ooooool0VOl02?l0VOl00ol0003oooooo`1Vo`08
o`1Vo`03o`000?oooooo03?o00So03?o00?o0000ooooool00?l02?l00?l00ol0003ooooooc<0o`08
oc<0o`03o`000?ooooooIP3o00SoIP3o00?o0000oooooonI0?l02?nI0?l00ol0003ooooool`0o`08
ol`0o`03o`000?ooooooo`3o00Soo`3o00?o0000oooooooo0<`02?oo0<`00ol0003oooooool0V@08
ool0V@03o`000?ooooooo`1V00Soo`1V00?o0000oooooooo03<02?oo03<00ol0003oooooool00008
ool00003o`000?oooooooc<000Sooc<000?o0000ooooooooIP002?ooIP000ol0003ooooooonI0008
oonI0003o`000?oooooool`000Sool`000?o0000ooooooooo`002?ooo`000ol0003oooooolco0008
olco0003o`000?ooooooVOl000SoVOl000?o0000oooooomVo`002?mVo`000ol0003ooooooc?o0008
oc?o0003o`000?oooooo0?l000So0?l000?o0000ooooool0oc<02?l0oc<00ol0003oooooo`3oIP08
o`3oIP03o`000?oooooo0?nI00So0?nI00?o0000ooooool0ol`02?l0ol`00ol0003oooooo`3oo`08
o`3oo`03o`000?oooooo000000[oi^KV00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008
oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008
oo3`l003o`000?oooooo0000073oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][o
clo?okfm_OnSXj<0K_o^k^h00ol0003oooooo`3oo`08o`3oo`03o`000?oooooo0<co00So0<co00?o
0000ooooool0VOl02?l0VOl00ol0003oooooo`1Vo`08o`1Vo`03o`000?oooooo03?o00So03?o00?o
0000ooooool00?l02?l00?l00ol0003ooooooc<0o`08oc<0o`03o`000?ooooooIP3o00SoIP3o00?o
0000oooooonI0?l02?nI0?l00ol0003ooooool`0o`08ol`0o`03o`000?ooooooo`3o00Soo`3o00?o
0000oooooooo0<`02?oo0<`00ol0003oooooool0V@08ool0V@03o`000?ooooooo`1V00Soo`1V00?o
0000oooooooo03<02?oo03<00ol0003oooooool00008ool00003o`000?oooooooc<000Sooc<000?o
0000ooooooooIP002?ooIP000ol0003ooooooonI0008oonI0003o`000?oooooool`000Sool`000?o
0000ooooooooo`002?ooo`000ol0003oooooolco0008olco0003o`000?ooooooVOl000SoVOl000?o
0000oooooomVo`002?mVo`000ol0003ooooooc?o0008oc?o0003o`000?oooooo0?l000So0?l000?o
0000ooooool0oc<02?l0oc<00ol0003oooooo`3oIP08o`3oIP03o`000?oooooo0?nI00So0?nI00?o
0000ooooool0ol`02?l0ol`00ol0003oooooo`3oo`08o`3oo`03o`000?oooooo000000[ok^k^00?o
0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o
0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0K_ooool00ol0003ooooo
o`3oo`08o`3oo`03o`000?oooooo0<co00So0<co00?o0000ooooool0VOl02?l0VOl00ol0003ooooo
o`1Vo`08o`1Vo`03o`000?oooooo03?o00So03?o00?o0000ooooool00?l02?l00?l00ol0003ooooo
oc<0o`08oc<0o`03o`000?ooooooIP3o00SoIP3o00?o0000oooooonI0?l02?nI0?l00ol0003ooooo
ol`0o`08ol`0o`03o`000?ooooooo`3o00Soo`3o00?o0000oooooooo0<`02?oo0<`00ol0003ooooo
ool0V@08ool0V@03o`000?ooooooo`1V00Soo`1V00?o0000oooooooo03<02?oo03<00ol0003ooooo
ool00008ool00003o`000?oooooooc<000Sooc<000?o0000ooooooooIP002?ooIP000ol0003ooooo
oonI0008oonI0003o`000?oooooool`000Sool`000?o0000ooooooooo`002?ooo`000ol0003ooooo
olco0008olco0003o`000?ooooooVOl000SoVOl000?o0000oooooomVo`002?mVo`000ol0003ooooo
oc?o0008oc?o0003o`000?oooooo0?l000So0?l000?o0000ooooool0oc<02?l0oc<00ol0003ooooo
o`3oIP08o`3oIP03o`000?oooooo0?nI00So0?nI00?o0000ooooool0ol`02?l0ol`00ol0003ooooo
o`3oo`08o`3oo`03o`000?oooooo000000[ooooo00?o0000ooooooo`l?002?o`l?000ol0003ooooo
oo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooo
oo3`l008oo3`l003o`000?oooooo0000073ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7Q
hOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooo`3oo`08o`3oo`03o`000?oooooo0<co00So
0<co00?o0000ooooool0VOl02?l0VOl00ol0003oooooo`1Vo`08o`1Vo`03o`000?oooooo03?o00So
03?o00?o0000ooooool00?l02?l00?l00ol0003ooooooc<0o`08oc<0o`03o`000?ooooooIP3o00So
IP3o00?o0000oooooonI0?l02?nI0?l00ol0003ooooool`0o`08ol`0o`03o`000?ooooooo`3o00So
o`3o00?o0000oooooooo0<`02?oo0<`00ol0003oooooool0V@08ool0V@03o`000?ooooooo`1V00So
o`1V00?o0000oooooooo03<02?oo03<00ol0003oooooool00008ool00003o`000?oooooooc<000So
oc<000?o0000ooooooooIP002?ooIP000ol0003ooooooonI0008oonI0003o`000?oooooool`000So
ol`000?o0000ooooooooo`002?ooo`000ol0003oooooolco0008olco0003o`000?ooooooVOl000So
VOl000?o0000oooooomVo`002?mVo`000ol0003ooooooc?o0008oc?o0003o`000?oooooo0?l000So
0?l000?o0000ooooool0oc<02?l0oc<00ol0003oooooo`3oIP08o`3oIP03o`000?oooooo0?nI00So
0?nI00?o0000ooooool0ol`02?l0ol`00ol0003oooooo`3oo`08o`3oo`03o`000?oooooo000000[o
k^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00So
l?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073o
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0K_oVi^H00ol0
003oooooo`3oo`08o`3oo`03o`000?oooooo0<co00So0<co00?o0000ooooool0VOl02?l0VOl00ol0
003oooooo`1Vo`08o`1Vo`03o`000?oooooo03?o00So03?o00?o0000ooooool00?l02?l00?l00ol0
003ooooooc<0o`08oc<0o`03o`000?ooooooIP3o00SoIP3o00?o0000oooooonI0?l02?nI0?l00ol0
003ooooool`0o`08ol`0o`03o`000?ooooooo`3o00Soo`3o00?o0000oooooooo0<`02?oo0<`00ol0
003oooooool0V@08ool0V@03o`000?ooooooo`1V00Soo`1V00?o0000oooooooo03<02?oo03<00ol0
003oooooool00008ool00003o`000?oooooooc<000Sooc<000?o0000ooooooooIP002?ooIP000ol0
003ooooooonI0008oonI0003o`000?oooooool`000Sool`000?o0000ooooooooo`002?ooo`000ol0
003oooooolco0008olco0003o`000?ooooooVOl000SoVOl000?o0000oooooomVo`002?mVo`000ol0
003ooooooc?o0008oc?o0003o`000?oooooo0?l000So0?l000?o0000ooooool0oc<02?l0oc<00ol0
003oooooo`3oIP08o`3oIP03o`000?oooooo0?nI00So0?nI00?o0000ooooool0ol`02?l0ol`00ol0
003oooooo`3oo`08o`3oo`03o`000?oooooo000000[oi^KV00?o0000ooooooooool0=_ooool00ol0
003oi^KVonKViP1^onKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_Kgo
Xj>S06kok^k^00?o0000ooooool0ool02?l0ool00ol0003oooooo`3<o`08o`3<o`03o`000?oooooo
09Wo00So09Wo00?o0000ooooool0I_l02?l0I_l00ol0003oooooo`0co`08o`0co`03o`000?oooooo
003o00So003o00?o0000oooooolc0?l02?lc0?l00ol0003oooooofH0o`08ofH0o`03o`000?oooooo
V@3o00SoV@3o00?o0000ooooooo<0?l02?o<0?l00ol0003oooooool0o`08ool0o`03o`000?oooooo
o`3<00Soo`3<00?o0000oooooooo09T02?oo09T00ol0003oooooool0IP08ool0IP03o`000?oooooo
o`0c00Soo`0c00?o0000oooooooo00002?oo00000ol0003ooooooolc0008oolc0003o`000?oooooo
ofH000SoofH000?o0000ooooooooV@002?ooV@000ol0003oooooooo<0008ooo<0003o`000?oooooo
ool000Soool000?o0000ooooooo<o`002?o<o`000ol0003ooooooiWo0008oiWo0003o`000?oooooo
I_l000SoI_l000?o0000oooooolco`002?lco`000ol0003oooooo`3o0008o`3o0003o`000?oooooo
0?lc00So0?lc00?o0000ooooool0ofH02?l0ofH00ol0003oooooo`3oV@08o`3oV@03o`000?oooooo
0?o<00So0?o<00?o0000ooooool0ool02?l0ool00ol0003oooooo`00000:onk^kP03o`000?oooooo
000000Wo000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o
000000So000000?oooooo`000?l000002?l000000ooooooo0000onk^kP1_onk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_06kooooo00?o0000ooooooooool0oooo
oomEooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`
l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`
l008oo3`l003o`000?oooooo0000073ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJ
f][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooo`000009o`000003ooooool0003o000000So0000
00?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So0000
00?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So0000
00?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So0000
00?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So0000
00?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So0000
00?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So0000
00?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So0000
00?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So0000
00?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So0000
00?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003ok^k^00Wok^k^
00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`
00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0K_oVi^H00ol0003o
oooooc?oo`08oc?oo`03o`000?oooooo<lco00So<lco00?o0000oooooolcVOl02?lcVOl00ol0003o
oooooc=Vo`08oc=Vo`03o`000?oooooo<c?o00So<c?o00?o0000oooooolc<ol02?lc<ol00ol0003o
oooooc<co`08oc<co`03o`000?ooooooIS?o00SoIS?o00?o0000oooooonI<ol02?nI<ol00ol0003o
oooool`co`08ol`co`03o`000?oooooooc?o00Sooc?o00?o0000oooooooo<l`02?oo<l`00ol0003o
oooooolcV@08oolcV@03o`000?oooooooc=V00Sooc=V00?o0000oooooooo<c<02?oo<c<00ol0003o
oooooolc<`08oolc<`03o`000?oooooooc<c00Sooc<c00?o0000ooooooooIS<02?ooIS<00ol0003o
oooooonI<`08oonI<`03o`000?oooooool`c00Sool`c00?o0000oooooooooc<02?oooc<00ol0003o
ooooolco<`08olco<`03o`000?ooooooVO@c00SoVO@c00?o0000oooooomVoc<02?mVoc<00ol0003o
oooooc?o<`08oc?o<`03o`000?oooooo<olc00So<olc00?o0000oooooolcoc<02?lcoc<00ol0003o
oooooc?oIP08oc?oIP03o`000?oooooo<onI00So<onI00?o0000oooooolcol`02?lcol`00ol0003o
oooooc?oo`08oc?oo`03o`000?oooooo000000[oi^KV00?o0000ooooooo`l?002?o`l?000ol0003o
oooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003o
oooooo3`l008oo3`l003o`000?oooooo0000073oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005
on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003ooooooc?oo`08oc?oo`03o`000?oooooo<lco
00So<lco00?o0000oooooolcVOl02?lcVOl00ol0003ooooooc=Vo`08oc=Vo`03o`000?oooooo<c?o
00So<c?o00?o0000oooooolc<ol02?lc<ol00ol0003ooooooc<co`08oc<co`03o`000?ooooooIS?o
00SoIS?o00?o0000oooooonI<ol02?nI<ol00ol0003ooooool`co`08ol`co`03o`000?oooooooc?o
00Sooc?o00?o0000oooooooo<l`02?oo<l`00ol0003ooooooolcV@08oolcV@03o`000?oooooooc=V
00Sooc=V00?o0000oooooooo<c<02?oo<c<00ol0003ooooooolc<`08oolc<`03o`000?oooooooc<c
00Sooc<c00?o0000ooooooooIS<02?ooIS<00ol0003ooooooonI<`08oonI<`03o`000?oooooool`c
00Sool`c00?o0000oooooooooc<02?oooc<00ol0003oooooolco<`08olco<`03o`000?ooooooVO@c
00SoVO@c00?o0000oooooomVoc<02?mVoc<00ol0003ooooooc?o<`08oc?o<`03o`000?oooooo<olc
00So<olc00?o0000oooooolcoc<02?lcoc<00ol0003ooooooc?oIP08oc?oIP03o`000?oooooo<onI
00So<onI00?o0000oooooolcol`02?lcol`00ol0003ooooooc?oo`08oc?oo`03o`000?oooooo0000
00[ok^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`
00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000
073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0K_ooool0
0ol0003ooooooc?oo`08oc?oo`03o`000?oooooo<lco00So<lco00?o0000oooooolcVOl02?lcVOl0
0ol0003ooooooc=Vo`08oc=Vo`03o`000?oooooo<c?o00So<c?o00?o0000oooooolc<ol02?lc<ol0
0ol0003ooooooc<co`08oc<co`03o`000?ooooooIS?o00SoIS?o00?o0000oooooonI<ol02?nI<ol0
0ol0003ooooool`co`08ol`co`03o`000?oooooooc?o00Sooc?o00?o0000oooooooo<l`02?oo<l`0
0ol0003ooooooolcV@08oolcV@03o`000?oooooooc=V00Sooc=V00?o0000oooooooo<c<02?oo<c<0
0ol0003ooooooolc<`08oolc<`03o`000?oooooooc<c00Sooc<c00?o0000ooooooooIS<02?ooIS<0
0ol0003ooooooonI<`08oonI<`03o`000?oooooool`c00Sool`c00?o0000oooooooooc<02?oooc<0
0ol0003oooooolco<`08olco<`03o`000?ooooooVO@c00SoVO@c00?o0000oooooomVoc<02?mVoc<0
0ol0003ooooooc?o<`08oc?o<`03o`000?oooooo<olc00So<olc00?o0000oooooolcoc<02?lcoc<0
0ol0003ooooooc?oIP08oc?oIP03o`000?oooooo<onI00So<onI00?o0000oooooolcol`02?lcol`0
0ol0003ooooooc?oo`08oc?oo`03o`000?oooooo000000[ooooo00?o0000ooooooo`l?002?o`l?00
0ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?00
0ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ooooo00Co[jn_ol_;booNg]koj^[Z0Oob
l_800005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003ooooooc?oo`08oc?oo`03o`000?oo
oooo<lco00So<lco00?o0000oooooolcVOl02?lcVOl00ol0003ooooooc=Vo`08oc=Vo`03o`000?oo
oooo<c?o00So<c?o00?o0000oooooolc<ol02?lc<ol00ol0003ooooooc<co`08oc<co`03o`000?oo
ooooIS?o00SoIS?o00?o0000oooooonI<ol02?nI<ol00ol0003ooooool`co`08ol`co`03o`000?oo
oooooc?o00Sooc?o00?o0000oooooooo<l`02?oo<l`00ol0003ooooooolcV@08oolcV@03o`000?oo
oooooc=V00Sooc=V00?o0000oooooooo<c<02?oo<c<00ol0003ooooooolc<`08oolc<`03o`000?oo
oooooc<c00Sooc<c00?o0000ooooooooIS<02?ooIS<00ol0003ooooooonI<`08oonI<`03o`000?oo
oooool`c00Sool`c00?o0000oooooooooc<02?oooc<00ol0003oooooolco<`08olco<`03o`000?oo
ooooVO@c00SoVO@c00?o0000oooooomVoc<02?mVoc<00ol0003ooooooc?o<`08oc?o<`03o`000?oo
oooo<olc00So<olc00?o0000oooooolcoc<02?lcoc<00ol0003ooooooc?oIP08oc?oIP03o`000?oo
oooo<onI00So<onI00?o0000oooooolcol`02?lcol`00ol0003ooooooc?oo`08oc?oo`03o`000?oo
oooo000000[ok^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oo
ooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oo
oooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0
K_oVi^H00ol0003ooooooc?oo`08oc?oo`03o`000?oooooo<lco00So<lco00?o0000oooooolcVOl0
2?lcVOl00ol0003ooooooc=Vo`08oc=Vo`03o`000?oooooo<c?o00So<c?o00?o0000oooooolc<ol0
2?lc<ol00ol0003ooooooc<co`08oc<co`03o`000?ooooooIS?o00SoIS?o00?o0000oooooonI<ol0
2?nI<ol00ol0003ooooool`co`08ol`co`03o`000?oooooooc?o00Sooc?o00?o0000oooooooo<l`0
2?oo<l`00ol0003ooooooolcV@08oolcV@03o`000?oooooooc=V00Sooc=V00?o0000oooooooo<c<0
2?oo<c<00ol0003ooooooolc<`08oolc<`03o`000?oooooooc<c00Sooc<c00?o0000ooooooooIS<0
2?ooIS<00ol0003ooooooonI<`08oonI<`03o`000?oooooool`c00Sool`c00?o0000oooooooooc<0
2?oooc<00ol0003oooooolco<`08olco<`03o`000?ooooooVO@c00SoVO@c00?o0000oooooomVoc<0
2?mVoc<00ol0003ooooooc?o<`08oc?o<`03o`000?oooooo<olc00So<olc00?o0000oooooolcoc<0
2?lcoc<00ol0003ooooooc?oIP08oc?oIP03o`000?oooooo<onI00So<onI00?o0000oooooolcol`0
2?lcol`00ol0003ooooooc?oo`08oc?oo`03o`000?oooooo000000[oi^KV00?o0000ooooooo`l?00
2?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?00
2?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073oi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003ooooooc?oo`08oc?oo`03
o`000?oooooo<lco00So<lco00?o0000oooooolcVOl02?lcVOl00ol0003ooooooc=Vo`08oc=Vo`03
o`000?oooooo<c?o00So<c?o00?o0000oooooolc<ol02?lc<ol00ol0003ooooooc<co`08oc<co`03
o`000?ooooooIS?o00SoIS?o00?o0000oooooonI<ol02?nI<ol00ol0003ooooool`co`08ol`co`03
o`000?oooooooc?o00Sooc?o00?o0000oooooooo<l`02?oo<l`00ol0003ooooooolcV@08oolcV@03
o`000?oooooooc=V00Sooc=V00?o0000oooooooo<c<02?oo<c<00ol0003ooooooolc<`08oolc<`03
o`000?oooooooc<c00Sooc<c00?o0000ooooooooIS<02?ooIS<00ol0003ooooooonI<`08oonI<`03
o`000?oooooool`c00Sool`c00?o0000oooooooooc<02?oooc<00ol0003oooooolco<`08olco<`03
o`000?ooooooVO@c00SoVO@c00?o0000oooooomVoc<02?mVoc<00ol0003ooooooc?o<`08oc?o<`03
o`000?oooooo<olc00So<olc00?o0000oooooolcoc<02?lcoc<00ol0003ooooooc?oIP08oc?oIP03
o`000?oooooo<onI00So<onI00?o0000oooooolcol`02?lcol`00ol0003ooooooc?oo`08oc?oo`03
o`000?oooooo000000[ok^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003
o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003
o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;
bon_[jl0K_ooool00ol0003ooooooc?oo`08oc?oo`03o`000?oooooo<lco00So<lco00?o0000oooo
oolcVOl02?lcVOl00ol0003ooooooc=Vo`08oc=Vo`03o`000?oooooo<c?o00So<c?o00?o0000oooo
oolc<ol02?lc<ol00ol0003ooooooc<co`08oc<co`03o`000?ooooooIS?o00SoIS?o00?o0000oooo
oonI<ol02?nI<ol00ol0003ooooool`co`08ol`co`03o`000?oooooooc?o00Sooc?o00?o0000oooo
oooo<l`02?oo<l`00ol0003ooooooolcV@08oolcV@03o`000?oooooooc=V00Sooc=V00?o0000oooo
oooo<c<02?oo<c<00ol0003ooooooolc<`08oolc<`03o`000?oooooooc<c00Sooc<c00?o0000oooo
ooooIS<02?ooIS<00ol0003ooooooonI<`08oonI<`03o`000?oooooool`c00Sool`c00?o0000oooo
oooooc<02?oooc<00ol0003oooooolco<`08olco<`03o`000?ooooooVO@c00SoVO@c00?o0000oooo
oomVoc<02?mVoc<00ol0003ooooooc?o<`08oc?o<`03o`000?oooooo<olc00So<olc00?o0000oooo
oolcoc<02?lcoc<00ol0003ooooooc?oIP08oc?oIP03o`000?oooooo<onI00So<onI00?o0000oooo
oolcol`02?lcol`00ol0003ooooooc?oo`08oc?oo`03o`000?oooooo000000[ooooo00?o0000oooo
ooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000oooo
ooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ooooo00Co[jn_ol_;
booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003ooooooc?oo`08
oc?oo`03o`000?oooooo<lco00So<lco00?o0000oooooolcVOl02?lcVOl00ol0003ooooooc=Vo`08
oc=Vo`03o`000?oooooo<c?o00So<c?o00?o0000oooooolc<ol02?lc<ol00ol0003ooooooc<co`08
oc<co`03o`000?ooooooIS?o00SoIS?o00?o0000oooooonI<ol02?nI<ol00ol0003ooooool`co`08
ol`co`03o`000?oooooooc?o00Sooc?o00?o0000oooooooo<l`02?oo<l`00ol0003ooooooolcV@08
oolcV@03o`000?oooooooc=V00Sooc=V00?o0000oooooooo<c<02?oo<c<00ol0003ooooooolc<`08
oolc<`03o`000?oooooooc<c00Sooc<c00?o0000ooooooooIS<02?ooIS<00ol0003ooooooonI<`08
oonI<`03o`000?oooooool`c00Sool`c00?o0000oooooooooc<02?oooc<00ol0003oooooolco<`08
olco<`03o`000?ooooooVO@c00SoVO@c00?o0000oooooomVoc<02?mVoc<00ol0003ooooooc?o<`08
oc?o<`03o`000?oooooo<olc00So<olc00?o0000oooooolcoc<02?lcoc<00ol0003ooooooc?oIP08
oc?oIP03o`000?oooooo<onI00So<onI00?o0000oooooolcol`02?lcol`00ol0003ooooooc?oo`08
oc?oo`03o`000?oooooo000000[ok^k^00?o0000ooooooooool0=_ooool00ol0003ok^k^onk^kP1^
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM06koi^KV00?o
0000oooooolcool02?lcool00ol0003ooooooc?<o`08oc?<o`03o`000?oooooo<iWo00So<iWo00?o
0000oooooolcI_l02?lcI_l00ol0003ooooooc<co`08oc<co`03o`000?oooooo<c?o00So<c?o00?o
0000oooooolc<ol02?lc<ol00ol0003oooooofHco`08ofHco`03o`000?ooooooVC?o00SoVC?o00?o
0000ooooooo<<ol02?o<<ol00ol0003ooooooolco`08oolco`03o`000?oooooooc?<00Sooc?<00?o
0000oooooooo<iT02?oo<iT00ol0003ooooooolcIP08oolcIP03o`000?oooooooc<c00Sooc<c00?o
0000oooooooo<c<02?oo<c<00ol0003ooooooolc<`08oolc<`03o`000?ooooooofHc00SoofHc00?o
0000ooooooooVC<02?ooVC<00ol0003oooooooo<<`08ooo<<`03o`000?oooooooolc00Sooolc00?o
0000ooooooo<oc<02?o<oc<00ol0003ooooooiWd<`08oiWd<`03o`000?ooooooI_lc00SoI_lc00?o
0000oooooolcoc<02?lcoc<00ol0003ooooooc?o<`08oc?o<`03o`000?oooooo<olc00So<olc00?o
0000oooooolcofH02?lcofH00ol0003ooooooc?oV@08oc?oV@03o`000?oooooo<oo<00So<oo<00?o
0000oooooolcool02?lcool00ol0003oooooo`00000:onKViP03o`000?oooooo000000Wo000000?o
ooooo`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?o
ooooo`000?l000002?l000000ooooooo0000onKViP1_onKViP04oifMWOng]kOob<S8om?Cd`7of][J
00001OoQhN7of][Jolo?conm_KgoXj>S06kok^k^00?o0000ooooooooool0oooooomEooooo`03o`00
0?o^k^kok^k^00Sok^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`00
0?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`00
0?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_
[jl0K_ooool00ol0003oooooo`000009o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l0
00002?l000000ooooooo0000o`000008o`000003ooooool0003ooooo00Wooooo00?o0000ooooooo`
l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`
l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ooooo00Co[jn_ol_;booN
g]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooofKoo`08ofKo
o`03o`000?ooooooI/co00SoI/co00?o0000oooooomVVOl02?mVVOl00ol0003oooooofIVo`08ofIV
o`03o`000?ooooooIVKo00SoIVKo00?o0000oooooomVI_l02?mVI_l00ol0003oooooofIVo`08ofIV
o`03o`000?ooooooIVKo00SoIVKo00?o0000oooooonII_l02?nII_l00ol0003oooooolaVo`08olaV
o`03o`000?ooooooofKo00SoofKo00?o0000ooooooooI/`02?ooI/`00ol0003ooooooomVV@08oomV
V@03o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003ooooooomVIP08oomV
IP03o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003ooooooonIIP08oonI
IP03o`000?ooooooolaV00SoolaV00?o0000ooooooooofH02?ooofH00ol0003oooooolcoIP08olco
IP03o`000?ooooooVOmV00SoVOmV00?o0000oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKo
IP03o`000?ooooooI_mV00SoI_mV00?o0000oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKo
IP03o`000?ooooooI_nI00SoI_nI00?o0000oooooomVol`02?mVol`00ol0003oooooofKoo`08ofKo
o`03o`000?oooooo000000[ok^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`
l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`
l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8
okNg]onMWId0K_oVi^H00ol0003oooooofKoo`08ofKoo`03o`000?ooooooI/co00SoI/co00?o0000
oooooomVVOl02?mVVOl00ol0003oooooofIVo`08ofIVo`03o`000?ooooooIVKo00SoIVKo00?o0000
oooooomVI_l02?mVI_l00ol0003oooooofIVo`08ofIVo`03o`000?ooooooIVKo00SoIVKo00?o0000
oooooonII_l02?nII_l00ol0003oooooolaVo`08olaVo`03o`000?ooooooofKo00SoofKo00?o0000
ooooooooI/`02?ooI/`00ol0003ooooooomVV@08oomVV@03o`000?ooooooofIV00SoofIV00?o0000
ooooooooIVH02?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?ooooooofIV00SoofIV00?o0000
ooooooooIVH02?ooIVH00ol0003ooooooonIIP08oonIIP03o`000?ooooooolaV00SoolaV00?o0000
ooooooooofH02?ooofH00ol0003oooooolcoIP08olcoIP03o`000?ooooooVOmV00SoVOmV00?o0000
oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000
oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_nI00SoI_nI00?o0000
oooooomVol`02?mVol`00ol0003oooooofKoo`08ofKoo`03o`000?oooooo000000[oi^KV00?o0000
ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000
ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073oi^KV00CoWIfM
okNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooofKo
o`08ofKoo`03o`000?ooooooI/co00SoI/co00?o0000oooooomVVOl02?mVVOl00ol0003oooooofIV
o`08ofIVo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooomVI_l02?mVI_l00ol0003oooooofIV
o`08ofIVo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooonII_l02?nII_l00ol0003oooooolaV
o`08olaVo`03o`000?ooooooofKo00SoofKo00?o0000ooooooooI/`02?ooI/`00ol0003ooooooomV
V@08oomVV@03o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003ooooooomV
IP08oomVIP03o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003ooooooonI
IP08oonIIP03o`000?ooooooolaV00SoolaV00?o0000ooooooooofH02?ooofH00ol0003oooooolco
IP08olcoIP03o`000?ooooooVOmV00SoVOmV00?o0000oooooomVofH02?mVofH00ol0003oooooofKo
IP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000oooooomVofH02?mVofH00ol0003oooooofKo
IP08ofKoIP03o`000?ooooooI_nI00SoI_nI00?o0000oooooomVol`02?mVol`00ol0003oooooofKo
o`08ofKoo`03o`000?oooooo000000[ok^k^00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`
l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`
l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZ
j^[og]kNol_;bon_[jl0K_ooool00ol0003oooooofKoo`08ofKoo`03o`000?ooooooI/co00SoI/co
00?o0000oooooomVVOl02?mVVOl00ol0003oooooofIVo`08ofIVo`03o`000?ooooooIVKo00SoIVKo
00?o0000oooooomVI_l02?mVI_l00ol0003oooooofIVo`08ofIVo`03o`000?ooooooIVKo00SoIVKo
00?o0000oooooonII_l02?nII_l00ol0003oooooolaVo`08olaVo`03o`000?ooooooofKo00SoofKo
00?o0000ooooooooI/`02?ooI/`00ol0003ooooooomVV@08oomVV@03o`000?ooooooofIV00SoofIV
00?o0000ooooooooIVH02?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?ooooooofIV00SoofIV
00?o0000ooooooooIVH02?ooIVH00ol0003ooooooonIIP08oonIIP03o`000?ooooooolaV00SoolaV
00?o0000ooooooooofH02?ooofH00ol0003oooooolcoIP08olcoIP03o`000?ooooooVOmV00SoVOmV
00?o0000oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV
00?o0000oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_nI00SoI_nI
00?o0000oooooomVol`02?mVol`00ol0003oooooofKoo`08ofKoo`03o`000?oooooo000000[ooooo
00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`
00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ooooo
00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003o
ooooofKoo`08ofKoo`03o`000?ooooooI/co00SoI/co00?o0000oooooomVVOl02?mVVOl00ol0003o
ooooofIVo`08ofIVo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooomVI_l02?mVI_l00ol0003o
ooooofIVo`08ofIVo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooonII_l02?nII_l00ol0003o
ooooolaVo`08olaVo`03o`000?ooooooofKo00SoofKo00?o0000ooooooooI/`02?ooI/`00ol0003o
oooooomVV@08oomVV@03o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003o
oooooomVIP08oomVIP03o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003o
oooooonIIP08oonIIP03o`000?ooooooolaV00SoolaV00?o0000ooooooooofH02?ooofH00ol0003o
ooooolcoIP08olcoIP03o`000?ooooooVOmV00SoVOmV00?o0000oooooomVofH02?mVofH00ol0003o
ooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000oooooomVofH02?mVofH00ol0003o
ooooofKoIP08ofKoIP03o`000?ooooooI_nI00SoI_nI00?o0000oooooomVol`02?mVol`00ol0003o
ooooofKoo`08ofKoo`03o`000?oooooo000000[ok^k^00?o0000ooooooo`l?002?o`l?000ol0003o
oooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003o
oooooo3`l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005
om[Jf_oCdm?ob<S8okNg]onMWId0K_oVi^H00ol0003oooooofKoo`08ofKoo`03o`000?ooooooI/co
00SoI/co00?o0000oooooomVVOl02?mVVOl00ol0003oooooofIVo`08ofIVo`03o`000?ooooooIVKo
00SoIVKo00?o0000oooooomVI_l02?mVI_l00ol0003oooooofIVo`08ofIVo`03o`000?ooooooIVKo
00SoIVKo00?o0000oooooonII_l02?nII_l00ol0003oooooolaVo`08olaVo`03o`000?ooooooofKo
00SoofKo00?o0000ooooooooI/`02?ooI/`00ol0003ooooooomVV@08oomVV@03o`000?ooooooofIV
00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?ooooooofIV
00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003ooooooonIIP08oonIIP03o`000?ooooooolaV
00SoolaV00?o0000ooooooooofH02?ooofH00ol0003oooooolcoIP08olcoIP03o`000?ooooooVOmV
00SoVOmV00?o0000oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV
00SoI_mV00?o0000oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_nI
00SoI_nI00?o0000oooooomVol`02?mVol`00ol0003oooooofKoo`08ofKoo`03o`000?oooooo0000
00[oi^KV00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`
00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000
073oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h0
0ol0003oooooofKoo`08ofKoo`03o`000?ooooooI/co00SoI/co00?o0000oooooomVVOl02?mVVOl0
0ol0003oooooofIVo`08ofIVo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooomVI_l02?mVI_l0
0ol0003oooooofIVo`08ofIVo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooonII_l02?nII_l0
0ol0003oooooolaVo`08olaVo`03o`000?ooooooofKo00SoofKo00?o0000ooooooooI/`02?ooI/`0
0ol0003ooooooomVV@08oomVV@03o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH0
0ol0003ooooooomVIP08oomVIP03o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH0
0ol0003ooooooonIIP08oonIIP03o`000?ooooooolaV00SoolaV00?o0000ooooooooofH02?ooofH0
0ol0003oooooolcoIP08olcoIP03o`000?ooooooVOmV00SoVOmV00?o0000oooooomVofH02?mVofH0
0ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000oooooomVofH02?mVofH0
0ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_nI00SoI_nI00?o0000oooooomVol`02?mVol`0
0ol0003oooooofKoo`08ofKoo`03o`000?oooooo000000[ok^k^00?o0000ooooooo`l?002?o`l?00
0ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?00
0ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN400005oo;bl_oZj^[og]kNol_;bon_[jl0K_ooool00ol0003oooooofKoo`08ofKoo`03o`000?oo
ooooI/co00SoI/co00?o0000oooooomVVOl02?mVVOl00ol0003oooooofIVo`08ofIVo`03o`000?oo
ooooIVKo00SoIVKo00?o0000oooooomVI_l02?mVI_l00ol0003oooooofIVo`08ofIVo`03o`000?oo
ooooIVKo00SoIVKo00?o0000oooooonII_l02?nII_l00ol0003oooooolaVo`08olaVo`03o`000?oo
ooooofKo00SoofKo00?o0000ooooooooI/`02?ooI/`00ol0003ooooooomVV@08oomVV@03o`000?oo
ooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?oo
ooooofIV00SoofIV00?o0000ooooooooIVH02?ooIVH00ol0003ooooooonIIP08oonIIP03o`000?oo
ooooolaV00SoolaV00?o0000ooooooooofH02?ooofH00ol0003oooooolcoIP08olcoIP03o`000?oo
ooooVOmV00SoVOmV00?o0000oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKoIP03o`000?oo
ooooI_mV00SoI_mV00?o0000oooooomVofH02?mVofH00ol0003oooooofKoIP08ofKoIP03o`000?oo
ooooI_nI00SoI_nI00?o0000oooooomVol`02?mVol`00ol0003oooooofKoo`08ofKoo`03o`000?oo
oooo000000[ooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`1^ooooo`04ojn_[oo;
bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S06kok^k^00?o0000oooooomVool0
2?mVool00ol0003oooooofK<o`08ofK<o`03o`000?ooooooIYWo00SoIYWo00?o0000oooooomVI_l0
2?mVI_l00ol0003oooooofIVo`08ofIVo`03o`000?ooooooIVKo00SoIVKo00?o0000oooooomVI_l0
2?mVI_l00ol0003oooooofIVo`08ofIVo`03o`000?ooooooVFKo00SoVFKo00?o0000ooooooo<I_l0
2?o<I_l00ol0003ooooooomVo`08oomVo`03o`000?ooooooofK<00SoofK<00?o0000ooooooooIYT0
2?ooIYT00ol0003ooooooomVIP08oomVIP03o`000?ooooooofIV00SoofIV00?o0000ooooooooIVH0
2?ooIVH00ol0003ooooooomVIP08oomVIP03o`000?ooooooofIV00SoofIV00?o0000ooooooooVFH0
2?ooVFH00ol0003oooooooo<IP08ooo<IP03o`000?oooooooomV00SooomV00?o0000ooooooo<ofH0
2?o<ofH00ol0003ooooooiWoIP08oiWoIP03o`000?ooooooI_mV00SoI_mV00?o0000oooooomVofH0
2?mVofH00ol0003oooooofKoIP08ofKoIP03o`000?ooooooI_mV00SoI_mV00?o0000oooooomVofH0
2?mVofH00ol0003oooooofKoV@08ofKoV@03o`000?ooooooI_o<00SoI_o<00?o0000oooooomVool0
2?mVool00ol0003oooooo`00000:onk^kP03o`000?oooooo000000Wo000000?oooooo`000?l00000
2?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l00000
2?l000000ooooooo0000onk^kP1_onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?C
olS8b?ng]kOoWIfM06koi^KV00?o0000ooooooooool0oooooomEooooo`03o`000?oVi^Koi^KV00So
i^KV00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00So
l?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073o
i^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0
003oooooo`000009o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003o000000So000000?oooooo`000?l000002?l000000ooo
oooo0000o`000008o`000003ooooool0003ok^k^00Wok^k^00?o0000ooooooo`l?002?o`l?000ol0
003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0
003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
0005oo;bl_oZj^[og]kNol_;bon_[jl0K_ooool00ol0003ooooooiWoo`08oiWoo`03o`000?oooooo
VLco00SoVLco00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?oooooo
VIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?oooooo
VIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003oooooolbIo`08olbIo`03o`000?oooooo
oiWo00SooiWo00?o0000ooooooooVL`02?ooVL`00ol0003ooooooonIV@08oonIV@03o`000?oooooo
oiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?oooooo
oiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?oooooo
olbI00SoolbI00?o0000oooooooooiT02?oooiT00ol0003oooooolcoV@08olcoV@03o`000?oooooo
VOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?oooooo
VOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?oooooo
VOnI00SoVOnI00?o0000oooooonIol`02?nIol`00ol0003ooooooiWoo`08oiWoo`03o`000?oooooo
000000[ooooo00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo
l?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo
0000073ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0K_o^
k^h00ol0003ooooooiWoo`08oiWoo`03o`000?ooooooVLco00SoVLco00?o0000oooooonIVOl02?nI
VOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nI
VOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nI
VOl00ol0003oooooolbIo`08olbIo`03o`000?oooooooiWo00SooiWo00?o0000ooooooooVL`02?oo
VL`00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?oo
VIT00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?oo
VIT00ol0003ooooooonIV@08oonIV@03o`000?ooooooolbI00SoolbI00?o0000oooooooooiT02?oo
oiT00ol0003oooooolcoV@08olcoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nI
oiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nI
oiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIol`02?nI
ol`00ol0003ooooooiWoo`08oiWoo`03o`000?oooooo000000[ok^k^00?o0000ooooooo`l?002?o`
l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`
l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0K_oVi^H00ol0003ooooooiWoo`08oiWoo`03o`00
0?ooooooVLco00SoVLco00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`00
0?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`00
0?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003oooooolbIo`08olbIo`03o`00
0?oooooooiWo00SooiWo00?o0000ooooooooVL`02?ooVL`00ol0003ooooooonIV@08oonIV@03o`00
0?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`00
0?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`00
0?ooooooolbI00SoolbI00?o0000oooooooooiT02?oooiT00ol0003oooooolcoV@08olcoV@03o`00
0?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`00
0?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`00
0?ooooooVOnI00SoVOnI00?o0000oooooonIol`02?nIol`00ol0003ooooooiWoo`08oiWoo`03o`00
0?oooooo000000[oi^KV00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`00
0?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`00
0?oooooo0000073oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnS
Xj<0K_o^k^h00ol0003ooooooiWoo`08oiWoo`03o`000?ooooooVLco00SoVLco00?o0000oooooonI
VOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonI
VOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonI
VOl02?nIVOl00ol0003oooooolbIo`08olbIo`03o`000?oooooooiWo00SooiWo00?o0000oooooooo
VL`02?ooVL`00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000oooooooo
VIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000oooooooo
VIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?ooooooolbI00SoolbI00?o0000oooooooo
oiT02?oooiT00ol0003oooooolcoV@08olcoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonI
oiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonI
oiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonI
ol`02?nIol`00ol0003ooooooiWoo`08oiWoo`03o`000?oooooo000000[ok^k^00?o0000ooooooo`
l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`
l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0K_ooool00ol0003ooooooiWoo`08oiWo
o`03o`000?ooooooVLco00SoVLco00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVI
o`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVI
o`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003oooooolbIo`08olbI
o`03o`000?oooooooiWo00SooiWo00?o0000ooooooooVL`02?ooVL`00ol0003ooooooonIV@08oonI
V@03o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonI
V@03o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonI
V@03o`000?ooooooolbI00SoolbI00?o0000oooooooooiT02?oooiT00ol0003oooooolcoV@08olco
V@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWo
V@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWo
V@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIol`02?nIol`00ol0003ooooooiWoo`08oiWo
o`03o`000?oooooo000000[ooooo00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`
l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`
l003o`000?oooooo0000073ooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?
okfm_OnSXj<0K_o^k^h00ol0003ooooooiWoo`08oiWoo`03o`000?ooooooVLco00SoVLco00?o0000
oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000
oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000
oooooonIVOl02?nIVOl00ol0003oooooolbIo`08olbIo`03o`000?oooooooiWo00SooiWo00?o0000
ooooooooVL`02?ooVL`00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000
ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000
ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?ooooooolbI00SoolbI00?o0000
oooooooooiT02?oooiT00ol0003oooooolcoV@08olcoV@03o`000?ooooooVOnI00SoVOnI00?o0000
oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000
oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000
oooooonIol`02?nIol`00ol0003ooooooiWoo`08oiWoo`03o`000?oooooo000000[ok^k^00?o0000
ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000
ooooooo`l?002?o`l?000ol0003ooooooo3`l008oo3`l003o`000?oooooo0000073ok^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0K_oVi^H00ol0003ooooooiWo
o`08oiWoo`03o`000?ooooooVLco00SoVLco00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVI
o`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVI
o`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003oooooolbI
o`08olbIo`03o`000?oooooooiWo00SooiWo00?o0000ooooooooVL`02?ooVL`00ol0003ooooooonI
V@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonI
V@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonI
V@08oonIV@03o`000?ooooooolbI00SoolbI00?o0000oooooooooiT02?oooiT00ol0003oooooolco
V@08olcoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWo
V@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWo
V@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIol`02?nIol`00ol0003ooooooiWo
o`08oiWoo`03o`000?oooooo000000[oi^KV00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`
l008oo3`l003o`000?ooooool?3`00Sol?3`00?o0000ooooooo`l?002?o`l?000ol0003ooooooo3`
l008oo3`l003o`000?oooooo0000073oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJ
f][oclo?okfm_OnSXj<0K_o^k^h00ol0003ooooooiWoo`08oiWoo`03o`000?ooooooVLco00SoVLco
00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo
00?o0000oooooonIVOl02?nIVOl00ol0003ooooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo
00?o0000oooooonIVOl02?nIVOl00ol0003oooooolbIo`08olbIo`03o`000?oooooooiWo00SooiWo
00?o0000ooooooooVL`02?ooVL`00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI
00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI
00?o0000ooooooooVIT02?ooVIT00ol0003ooooooonIV@08oonIV@03o`000?ooooooolbI00SoolbI
00?o0000oooooooooiT02?oooiT00ol0003oooooolcoV@08olcoV@03o`000?ooooooVOnI00SoVOnI
00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI
00?o0000oooooonIoiT02?nIoiT00ol0003ooooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI
00?o0000oooooonIol`02?nIol`00ol0003ooooooiWoo`08oiWoo`03o`000?oooooo000000[ok^k^
00?o0000ooooooooool0=_ooool00ol0003ok^k^onk^kP1^onk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_06kooooo00?o0000oooooonIool02?nIool00ol0003o
oooooiW<o`08oiW<o`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003o
oooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000oooooonIVOl02?nIVOl00ol0003o
oooooiVIo`08oiVIo`03o`000?ooooooVIWo00SoVIWo00?o0000ooooooo<VOl02?o<VOl00ol0003o
oooooonIo`08oonIo`03o`000?oooooooiW<00SooiW<00?o0000ooooooooVIT02?ooVIT00ol0003o
oooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003o
oooooonIV@08oonIV@03o`000?oooooooiVI00SooiVI00?o0000ooooooooVIT02?ooVIT00ol0003o
ooooooo<V@08ooo<V@03o`000?oooooooonI00SooonI00?o0000ooooooo<oiT02?o<oiT00ol0003o
oooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003o
oooooiWoV@08oiWoV@03o`000?ooooooVOnI00SoVOnI00?o0000oooooonIoiT02?nIoiT00ol0003o
oooooiWoV@08oiWoV@03o`000?ooooooVOo<00SoVOo<00?o0000oooooonIool02?nIool00ol0003o
ooooo`00000:oooooc[o0000L?ooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?
cloo_Kfmoj>SX`1^onk^kP03o`000?oooooooooo0?ooooooEOooool00ol0003ok^k^onk^kP2bonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM06koi^KV00?o0000
ooooool000002Ol000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?ooooo
o`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?ooooo
o`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?ooooo
o`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?ooooo
o`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?ooooo
o`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?ooooo
o`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?ooooo
o`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?ooooo
o`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?ooooo
o`000?l000002?l000000ooooooo0000o`000008o`000003ooooool0003o000000So000000?ooooo
o`000?l000002?l000000ooooooo0000onKViP2conKViP04oifMWOng]kOob<S8om?Cd`7of][J0000
1OoQhN7of][Jolo?conm_KgoXj>S06kok^k^00?o0000ooooooo<ool02?o<ool00ol0003oooooolc<
o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<
o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<
o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooooo<
o`08ooo<o`03o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<
c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<
c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<
c008ooo<c003o`000?ooooooooo<00Soooo<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolco
c008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolco
c008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolco
c008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ool02?o<ool00ol0003oooooo`00
000Eonk^kP03on?ShooHf=Sok^k^00Cok^k^00?ogMgMomoOgoo^k^h01?o^k^h00ooShn?of=SHonk^
kP0<onk^kP03omGEeOo/k>cok^k^07ook^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZ
j^[og]kNol_;bon_[jl0K_ooool00ol0003oooooolcoo`08olcoo`03o`000?ooooooc<co00Soc<co
00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co
00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co
00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooolco00Soolco
00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<
00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<
00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<
00?o0000oooooooool`02?oool`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<
00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<
00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<
00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoo`08olcoo`03o`000?oooooo000000_ooooo
01oo=SHfogMgMoooooooooooooKfm_lV9RKoATI6ookno_oWinOoBTY:o`<30olS8b?o5aLGol71`Ooo
ooooiNGUod10@?l0003o4Q8BoadM7Oohn?SoooooonOWiom:BT[o0`<3ob<S8olG5aOo`L71oooooom0
@43oOgmo00;ooooo00_oXj>Soa`L7?ooooooooooom?CdolU9BGo7QhNokZj^_ooooooKFe]oe9BDP1m
ooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S06kok^k^00?o
0000ooooooo<ool02?o<ool00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o
0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o
0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o
0000ooooooo<c?l02?o<c?l00ol0003oooooooo<o`08ooo<o`03o`000?ooooooolc<00Soolc<00?o
0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o
0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o
0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooooo<00Soooo<00?o
0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o
0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o
0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o
0000ooooooo<ool02?o<ool00ol0003oooooo`00000;onk^kP0Ooc8b<_m_Kfook^k^onk^k_mXJ6So
4Q8BomOGeoo^k^ko?clooc/k>oo@d=3ok^k^on;Rh_oQhN7ok^k^ocdm?OlY:BWo_Kfmonk^k_o9bLWo
k>c/onk^k_lo?coo>c/kom3@d?o^k^koh^;Ron7QhOo^k^ko>c/kogIfMP02onk^kP07oiRHV?lJ6Q[o
k^k^onk^k_mYJFWo?3`long]k@02onk^kP03olc<c?o5aLGok^k^07cok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0K_oVi^H00ol0003oooooolcoo`08olcoo`03
o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03
o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03
o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03
o`000?ooooooolco00Soolco00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003
o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003
o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003
o`000?ooooooolc<00Soolc<00?o0000oooooooool`02?oool`00ol0003oooooolcoc008olcoc003
o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003
o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003
o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoo`08olcoo`03
o`000?oooooo000000_oi^KV00[o<30`of][JooVi^Ko[Zj^o`410OnOWiooi^KVolO7aol0003oYJFU
1?oVi^H00oo6a/Ko0000ohJ6QP04onKViP03olO7aol0003oYJFU00Goi^KV00Ko>CTiog9bL_oVi^Ko
i^KVoi>CTolI6AT2onKViP03odE5AOmVIVKoi^KV087oi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X0
0005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooolcoo`08olcoo`03o`000?oooooo
c<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?oooooo
c<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?oooooo
c<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?oooooo
olco00Soolco00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?oooooo
olc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?oooooo
olc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?oooooo
olc<00Soolc<00?o0000oooooooool`02?oool`00ol0003oooooolcoc008olcoc003o`000?oooooo
c?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?oooooo
c?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?oooooo
c?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoo`08olcoo`03o`000?oooooo
000000_ok^k^00Go<S8bofa/K?oOgmoo820Pof5QH@02onk^kP03ok6a/Ol0003o>3Ph00?o>SXj00Co
][Jfok6a/Ol0003o`<301?o^k^h00ona/K7o0000ocPh>003ocXj>P04okJf]_o^k^ko>c/kogIfMP;o
k^k^00KoV9RHoaXJ6_o^k^kok^k^odM7AomZJVZ2onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0000
1Oobl_;oj^[ZomkNg_o;bl_o[jn_06kooooo00?o0000ooooooo<ool02?o<ool00ol0003oooooolc<
o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<
o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<
o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooooo<
o`08ooo<o`03o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<
c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<
c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<
c008ooo<c003o`000?ooooooooo<00Soooo<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolco
c008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolco
c008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolco
c008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ool02?o<ool00ol0003oooooo`00
000;ooooo`05ocHf=_l30`?o0000o`000?o1`L400_ooool02_oKfm_o0000oj^[Zoo?clooalO7o`<3
0ooUiNGofm_Ko`000?nATI44ooooo`0:om_Kfol0003oZj^[olo?coo7alOo0`<3onGUiOoooooo@410
oeeMG@;ooooo00KoWIfMoadM7Oooooooooooode=COmbLW:2ooooo`04ojn_[oo;bl_og]kNon[ZjP7o
l_;b00001OoQhN7of][Jolo?conm_KgoXj>S06kok^k^00?o0000ooooooo<ool02?o<ool00ol0003o
ooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003o
ooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003o
ooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003o
ooooooo<o`08ooo<o`03o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003o
ooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003o
ooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003o
ooooooo<c008ooo<c003o`000?ooooooooo<00Soooo<00?o0000ooooooo<ol`02?o<ol`00ol0003o
ooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003o
ooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003o
ooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ool02?o<ool00ol0003o
ooooo`00000;onk^kP06oc8b<_m_Kfoodm?Cohn?Sol71`Oo[:b/0_o^k^h01Olj>S[oHf=SonKVi_nC
Ti?o:2PX00;ok^k^00Go>SXjob@T9?na/K7okNg]olo?c`02onk^kP05ocXj>_mSHf?oi^KVoi>CTolX
:2P00_o^k^h03olk>c_o4Q8Bofi^K_o?clooDE5AodM7Aoo^k^koj>SXodA4A?mUIFGohn?Son[Zj_o^
k^ko_;blok>c/`1monk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOo
WIfM06koi^KV00?o0000ooooooo<ool02?o<ool00ol0003oooooolc<o`08olc<o`03o`000?oooooo
c<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?oooooo
c<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?oooooo
c<co00Soc<co00?o0000ooooooo<c?l02?o<c?l00ol0003oooooooo<o`08ooo<o`03o`000?oooooo
olc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?oooooo
olc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?oooooo
olc<00Soolc<00?o0000ooooooooc<`02?ooc<`00ol0003oooooooo<c008ooo<c003o`000?oooooo
ooo<00Soooo<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?oooooo
c?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?oooooo
c?o<00Soc?o<00?o0000ooooooo<ol`02?o<ol`00ol0003oooooolcoc008olcoc003o`000?oooooo
c?o<00Soc?o<00?o0000ooooooo<ool02?o<ool00ol0003oooooo`00000;onKViP06oc0`<?m[Jf_o
i^KVonKVi_m1@D7oBTY:0_oVi^H01Oo?cloo@410o`/;2olI6AWoYJFU00;oi^KV00GodM7Aodi>C_l=
3@go2@T9ob8R8P02onKViP05olo?com0@43o2`/;oaTI6OnUYJD00_oVi^H03om;Bd_oOWinofe]KOlB
4Q;o:BTYok2`/?oVi^KoLW9bo`L71ol:2P[o61PHoibLW?oVi^KoL71`oeYJFP1monKViP04oifMWOng
]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S06kok^k^00?o0000ooooooo<ool0
2?o<ool00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l0
2?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l0
2?o<c?l00ol0003oooooolc<o`08olc<o`03o`000?ooooooc<co00Soc<co00?o0000ooooooo<c?l0
2?o<c?l00ol0003oooooooo<o`08ooo<o`03o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`0
2?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`0
2?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooolc<00Soolc<00?o0000ooooooooc<`0
2?ooc<`00ol0003oooooooo<c008ooo<c003o`000?ooooooooo<00Soooo<00?o0000ooooooo<ol`0
2?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`0
2?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ol`0
2?o<ol`00ol0003oooooolcoc008olcoc003o`000?ooooooc?o<00Soc?o<00?o0000ooooooo<ool0
2?o<ool00ol0003oooooo`00000;onk^kP06oc8b<_m_Kfook^k^onk^k_la<C7oCdm?1?o^k^h00oo[
jn_ok^k^onk^kP05onk^kP03on_[joo^k^kok^k^00?ok^k^00?ojn_[onk^k_o^k^h01Oo^k^h00oo]
kNgok^k^onk^kP02onk^kP03odM7AomZJV[ok^k^087ok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
0005oo;bl_oZj^[og]kNol_;bon_[jl0K_ooool00ol0003oooooooooo`3ooooooeGooooo00?o0000
ooooooooool02Oooool01_lf=SKo;bl_oeYJF_lS8b?o30`<ol?3`aoooooo00?oh>3PomkNg_ooool0
POooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`1^onk^kP03
o`000?oooooo000000Wo000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003
ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003
ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003
ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003
ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003
ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003
ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003
ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003
ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003
ooooool0003o000000So000000?oooooo`000?l000002?l000000ooooooo0000o`000008o`000003
ooooool0003o000000So000000?oooooo`000?o^k^h02_o^k^h01OnTY:CoShn?ohn?Son^[Zkoj>SX
0:Cok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0K_oVi^H0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooo00000;Coi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJ
f]X00005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooo00000;Cok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0
K_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo00000;Cooooo00Co[jn_ol_;booNg]ko
j^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooo00000;Cok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg
]onMWId0K_oVi^H00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo00000;Coi^KV00CoWIfMokNg
]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooo00000;Cok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[o
g]kNol_;bon_[jl0K_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo00000;Cooooo00Co
[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooo00000;Cok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[J
f_oCdm?ob<S8okNg]onMWId0K_oVi^H00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo00000;Co
i^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0K_o^k^h00ol0
003oooooooooo`3ooooooeGooooo00?o0000onk^k_o^k^h0/_o^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`1^oooooooo0000FOl0002dooooo`04ojn_[oo;bl_o
g]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifM
WOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04
oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomloooo
o`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^il
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooV
i^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^
ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oo
oooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S
0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOo
WIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm
_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkN
g_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][J
olo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][o
dm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQ
hN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0000
1Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b
00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?C
d`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?
om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_o
g]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifM
WOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04
oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomloooo
o`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^il
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooV
i^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^
ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oo
oooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S
0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOo
WIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm
_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkN
g_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][J
olo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][o
dm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQ
hN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0000
1Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b
00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?C
d`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?
om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_o
g]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifM
WOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04
oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomloooo
o`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^il
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooV
i^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^
ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oo
oooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S
0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOo
WIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm
_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkN
g_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][J
olo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][o
dm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQ
hN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0000
1Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b
00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?C
d`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?
om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_o
g]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifM
WOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04
oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomloooo
o`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^il
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooV
i^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^
ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oo
oooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S
0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOo
WIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm
_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkN
g_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][J
olo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][o
dm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQ
hN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0000
1Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b
00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?C
d`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?
om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_o
g]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifM
WOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04
oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomloooo
o`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^il
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooV
i^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^
ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oo
oooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S
0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOo
WIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm
_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkN
g_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][J
olo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][o
dm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQ
hN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0000
1Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b
00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?om[JfP7o
hN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVoooVi^IlonKViP04oifMWOng]kOob<S8om?C
d`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm_Kgoclo?
om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_0?oooooooooooomlooooo`04ojn_[oo;bl_o
g]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ooo^k^ilonk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooJVYZoomZJVYlofYZJP04oifM
WOng]kOob<S8om?Cd`7of][J00002_oQhN7of][Jolo?conm_KgoXj>SokS/oonkkooo_?7ook[^ooni
k_l3ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o
^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol0
1OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_a
oonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__
oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookca
oonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^
oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^
o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o
^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol0
1OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_a
oonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__
oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookca
oonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^
oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^
o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o
^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol0
1OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_a
oonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__
oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookca
oonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^
oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^
o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o
^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol0
1OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_a
oonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__
oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookca
oonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^
oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^
o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o
^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol0
1OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_a
oonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__
oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookca
oonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^
oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^
o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o
^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`06ok_aoonhk?ooXj>Sokfm_Oo?cloof][J0OoQ
hN400005oo;bl_oZj^[og]kNol_;bon_[jl00_nKc_l0oonGc?ooUl[ooiW=oonLcoooV/gooic?oonH
c_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonL
coooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJ
cOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonL
coooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonI
cOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonG
b_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonG
c?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonK
c_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonH
c_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonL
coooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJ
cOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonL
coooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonI
cOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonG
b_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonG
c?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonK
c_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonH
c_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>o`00oonKc_ooUlcooiO:oonIcOooW<oooi[=
oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?
oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=
oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:
oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<
oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>
oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>
oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?
oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=
oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?
oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=
oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:
oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<
oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>
oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>
oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?
oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=
oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?o`00O_nHc_ooVlkooiO<oonGb_ooVLgo
oic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[o
oiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlco
oiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlko
oiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<ko
oi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oo
oiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/go
oic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oo
oi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkoojn_[oo;bl_og]kN
on[ZjP7ol_;b00001ooQhN7of][Jolo?conm_KgoXj>Sog^ak?mi[^/00_mg[^/01_mh[^_oMZgZogV_
k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[o
NJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]
j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_o
MZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^
jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00Ko
N:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/0
1_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^
j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;o
Mjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[
0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi
[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkY
ogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi
[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/
ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi
[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^
ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi
[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZ
ogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf
[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[
ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh
[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06
ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[
00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg
[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2
ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^
j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^Wo
NJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^
jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^co
NJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^
k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nko
NJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_
k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[o
NJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]
j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_o
MZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^
jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00Ko
N:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/0
1_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^
j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;o
Mjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[
0_mg[^/02_mh[^_oMZgZogV_k_mi[^coNJkYog^ak?nSXj?o_Kfmolo?cooJf]X1on7Qh@000?oof][J
om?Cdoo8b<So]kNgoifMWOmGT]Go^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_
okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^
okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^
okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_
okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^
okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^
okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_
okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_
okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_
okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^
okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^
okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_
okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^
okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^
okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_
okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_
okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnh00?oo
^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko
^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo
]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko
^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko
]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo
^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo
]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo
^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko
^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko
^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo
]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko
^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko
]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo
^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo
]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo
^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko
^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^h0
08Go^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nh
d^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nf
d>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonh
d^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkong
d^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkoni
dnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nh
dnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_ni
dnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonf
d^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_mGT]GoWIfMokNg]oo8b<Sodm?C007of][J
00002?oQhN7of][Jolo?conm_KgoXj>Soc1b`?nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>Ko
Y/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4
i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGo
YLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3
iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^Ko
Y<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6
i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>Ko
Y/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4
i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00Ko
Y<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H0
1_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4
iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;o
YLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T
0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS
`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KV
oj?2i0;oYLCV00_oY<CVoj?4iOnL`NWoXLS^ojW?l?n/d^oo[mC`ok3Cl?n_e?3o/=G`ok3Dk`02ok3E
l009ojoCkonaeO3o/MG`ojoDl?n`eO3o/=C_ok3Dl?n`eO3o[m?_00;o/MG`00Ko[mC`ok3El?n`e>oo
/=C`ok3El?n_dnl2ok7El006ojoDl?n`eO3o/=C_ok3Dl?n`eO3o[m?_0_naeO001_n_e?3o/=G`ok3D
kon`e?3o/=G`ojoCk`;o/MG`00Ko[mC`ok3El?n`e>oo/=C`ok3El?n_dnl2ok7El006ojoDl?n`eO3o
/=C_ok3Dl?n`eO3o[m?_0_naeO005_n_e?3o/=G`ok3Dkon`e?3o/=G`ojoCkonae_3o/=K`ojoEl?na
e_3o/=G`ok3Dl?n/do3oYlg_oj;9k_nL`^[oXL;UojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4
i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00Ko
Y<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H0
1_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4
iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;o
YLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T
0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS
`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KV
oj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nV
a^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCV
ojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnU
a>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?U
ojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT
`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KV
ojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nV
a^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CV
ojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nT
a>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06
ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV
00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nU
a>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2
ojG4iP09ojC4i_nVa^KoY<?UojG4i_l`L/3oXj>Sokfm_Oo?cloof][J007ohN7Q0000l_obl_;oj^[Z
omkNg_o;bl_o[jn_o`mF/Ol;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_
o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_
o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^
o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^
o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^
o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^
o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBa
o`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`
o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_
o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_
o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^
o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^
o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^
o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^
o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBa
o`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7oF:Oooh[>oon[i?oo`?7oolWjooo>o_ooe?oo
0_o?nol0ooo@o_ood_ooom3ooooBooood?ooom;oooo?oOood?ooolokoooCooood?ooom;oooo@oooo
d_ooolomooo@ooooco_oom?oooo@ooood_ooom3ooooBoooocogoom3oooo?nooodoooom3ooooBoooo
d?ooom;oooo?oOood?ooolokoooCooood?ooom;oooo@ooood_ooolomooo@ooooco_oom?oooo@oooo
d_ooom3ooooBoooocogoom3oooo?nooodoooom3ooooBooood?ooom;oooo?oOood?ooolokoooCoooo
d?ooom;ooooCoooocokoolkjooo?noood?ooolknooo8nOoo_o3oojgWoon;c_ooF:Ooo`eD[_l:DJko
3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko
2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o
3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o
2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo
2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo
3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko
3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko
2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko
3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko
2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o
3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o
2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo
2eB`o`]D/@00T?l=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?
EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;
Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=
E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:
DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=
E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;
E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;
E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?
EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?
EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko3eJaojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7o
f][Jolo?conm_KgoOWin0>?ob<S800coa/K6okVi^On:RX[oFJCnohc9oonZg_oo^^_ool;aooo8looo
c?Koolgfooo=n?l3oloio`05olgiooo>nOooc_Soolkhooo=m_l00_o?n_l00oo?nOoocOWoolkio`02
olkho`06olgfooo?n_ooco[ooloiooo=nOooc_Wo0_o>n?l01_o=m_ooco[oolojooo?nOoocOWoolki
o`;oc_So00KocOKoolojooo?n_oocoWoolgiooo>nOl2olkho`06olgfooo?n_ooco[ooloiooo=nOoo
c_Wo0_o>n?l01_o=m_ooco[oolojooo?nOoocOWoolkio`;oc_So01?ocOKoolojooo?n_oocoWoolgi
ooo?n_ooc_Soolcfooo?nOooco[oolWeooo6m_oo^n_oojgQoon9b_goDYO[oemOGooPh>3om?Cd02[o
oooo00Gom_Kfolo?comOGeooh>3PooCdm00Zooooo`05ooShn?oPh>3oRXZ:okVi^Oo6a/H0hoo8b<P0
1?nFUYKo_Kfmolo?cooJf]X1on7Qh@000ooVi^H00ooJf][oc/k>olk>cP3Rolk>cP0=olc<c?nn_[ko
SXj>oeJPlOn7`oooY=KookGQoonoj_oo`n_oolK^ooo6koooa^koolK`o`02ol?^o`18olO`ooo8lOoo
a_3ool?^ooo8lOooa^koolK`ooo3k_ooao3oolSaooo6l?oo`nkoolSaooo6k_ooa_3ool?^ooo7l?oo
b?7oolK`ooo3k_oob?7oolK^ooo6l?oo`nkoolO`ooo8lOooa_3ool?^ooo8lOooa^koolK`ooo3k_oo
ao3oolSaooo6l?oo`nkoolSaooo6k_ooa_3ool?^ooo7l?oob?7oolK`ooo3k_oob?7oolK^ooo6l?oo
`nkoolO`ooo8lOooa_3ool?^ooo8lOooa^koolK`ooo3k_ooao3oolK`ooo2j_oob?7oolO_ooo6kooo
`^_ool3[oonhi?ooXmSoohO4oOm?U>3oHV9Rom[Jf_o_knoonOWi:?ooool01ooinOWok^k^ol[:b_mR
HV;of][Jono_kooinOT0:?ooool01_oinOWol?3`om_Kfon>SXko_[jnolc<c>?oc/k>00?of][JonKV
i_oVi^H00_oVi^H000;ok^k^0_oVi^KTomoOg`0>omgMgOo>c/koVYZJoe6Kjon2_OgoW/oook7Loonh
hooo_NGookgTooo0i_oo`^[ookgTooo1iol2ol3Vo`;o`NOo0_noiOl4ol3Vo`;o`NOo0_noiOl4ol3V
o`;o`NOo0_noiOl4ol3Vo`;o`NOo0_noiOl4ol3Vo`;o`NOo0_noiOl4ol3Vo`;o`NOo0_noiOl4ol3V
o`;o`NOo0_noiOl4ol3Vo`0Aol7Wooo0i_oo`>Kool7Yoonlhooo^nCookGPoon_foooWLkoogjimom:
Sm[oJVYZomCDe?oYjNWolo?cooWinOomoOd00_ono_h9ooooo`03ookno_oooooooooo00Gooooo00?o
o_knooooooooool01Oooool00oono_koooooooooo`04ooooo`0=ookno_omoOgon_[jooShn?obl_;o
iNGUolC4a?mZJV[oe=CDonWYjOoclo?onOWioogmo@02ooknoPWooooo00?oo_knooooooooool01Ooo
ool00oono_koooooooooo`05ooooo`03ookno_oooooooooo00Cooooo00[oo_knoogmoOojn_[on?Sh
oo;bl_oWinOoe=CDoiZJV_o>c/kogMgMhooOgml2onKViP?ok^k^00001?oooooon_[joo[jn_ojn_[T
ooGem@0:oo?clooRh^;oZZZZoe:GiOmm]O?oV/[nojSDoondgooo^^7ookSOo`;o_>?o00Oo^=oookWP
oonkhOoo^^3ookWPoonmi?oo^N3o00;o^^3o00Ko]]cook_Qoonjh?oo^N3ookgToonih?l2ok[Po`06
okKLoonkhOoo^^3ookWPoonmi?oo^N3o0_njh?l01_nfg?oo^n7ook[Poonih?oo_NCookWPo`;o^^3o
00Ko]]cook_Qoonjh?oo^N3ookgToonih?l2ok[Po`06okKLoonkhOoo^^3ookWPoonmi?oo^N3o0_nj
h?l01_nfg?oo^n7ook[Poonih?oo_NCookWPo`;o^^3o01Ko]]cook_Qoonjh?oo_>?ook[Qoonhgooo
^MoookSOoonfg_oo/M_ooj[EoonGbOgoOKCbodZ<eOmfMWKod=3@on3Ph?o_knoolO7aooWinOojn_[o
n?Sh0_olo?`00ooinOWon_[jooclo002ooWin@06oogmoOoinOWon_[jooWinOojn_[oo?cl0_oinOT0
1_omoOgonOWioo[jn_oinOWon_[jooclo0;onOWi00OooOgmooWinOojn_[onOWioo[jn_olo?conOWi
00;on?Sh00oonOWiooOgmoohn?Som?Cdonk^k_oOgmoo`<30ogIfM_o@d=3oh>3Pono_kooalO7onOWi
oo[jn_ohn?P00_olo?`00ooinOWon_[jooclo002ooWin@06oogmoOoinOWon_[jooWinOojn_[oo?cl
0_oinOT01_omoOgonOWioo[jn_oinOWon_[jooclo0;onOWi00OooOgmooWinOojn_[onOWioo[jn_ol
o?conOWi00;on?Sh00[onOWiooOgmoohn?Som?Cdonk^k_oQhN7od=3@ojZZZ_oRh^;olo?chooemOD3
oo[jnP;ooooo0004on_[jnCoj>SX00Soi^KVomKFe_nQXJ7oC93NogVakonCa?SoY<okojcEo`;o/][o
03ko]=Wook?JoondfOoo/m[ookCKoonaf?goW;gLoj;3i_ndf_oo/m[ookGLoonefooo]=_ook?Joone
g?oo]=WookCJooncf_oo]McookGKoondfooo/m[ookGLoonVb>co/]Smok?Joon]d_Co[M7dokCKoonc
f_oo]Mcooj72iOnbf?go/m[ookGLoonefoooYl_]ojO<koneg?oo]=WookCJooncf_oo]McookGKoond
fooo/m[ookGLoondfOoo]=[ook?Jooneg?oo[M7doj?7j?ncf_oo]McookCIoondf_ooZLkboj_@l_ne
fooo]=_ook?Jo`;o]M_o00oo/m[ookGKooncfooo[mSoojgHoonUd?goU<ChogJ/jOm6QLgoKfm_olS8
b?oMgMgoj^[Zonk^k_obl_800_oemOD00oodm?ComOGeooOgm`02ooKfmP06ooGemOofm_Kom?CdooGe
mOodm?ComoOg0_ofm_H01_oemOGom_Kfoo;bl_oCdm?og=cLooOgm`;om_Kf00KomOGeooKfm_odm?Co
mOGeooCdm?ogmoL2ooKfmP;omOGe0_ofm_H03?oclo?om?Cdono_koo[jn_ofMWIokVi^Om_Kfoob<S8
omgMgOoZj^[ok^k^oo;blP;omOGe00?om?CdooGemOogmoL00_ofm_H01_oemOGom_KfooCdm?oemOGo
m?CdooOgm`;om_Kf00KomOGeooKfm_odm?Cofm_KolO7aoo/k>`2ooKfmP06ooGemOofm_Kom?CdooGe
mOodm?ComoOg0_ofm_H2ooGem@;om_Kf00Wolo?cooCdm?o_knoojn_[om_Kfoo8b<SoXJ6QomKFe_oV
i^H0hooXj>P4on_[j`7ok^k^003XonKViP0DonCTi?oDe=CoWinOodJ;f?me[NWoS[oaoio9mOnUd?[o
[=?jojkEoOn^e?_o/MKnojkDnonbf?ooNY>^o`H82Ol92`go61hSob@/=OmdSJL2ojkDn`1Ioio0i?l0
003oGW>8ok7Fo_n^e?_o<Se9oa/Q9on^e?_o/MGmojkDnolhA57o1@H7oa4E6Om/Q9co30lBoc]8EOna
eOgoSjo?oaTO9OlD6AgoOYZgok;HoonL_^7o:cDno`000?l<3Q7o51PMojc@mon^e?_o;3I0oeIYOOn^
e?_o/MGmofn7X?lC5aco/MKnojkDnonQ`nOo<Se8o`820_lH7B;o3a<FohJS`Onae_ko6AhTo`/=4?lE
6Qoo=41;oj[=m?n^e?_o/]SoojoEoOn^e_ko[]CkojcCn_n[e?_oY]3joj3<n?n>_o7oLj[Uod>3b_m^
KVkoaLG5omWIfOoVi^KojNWYong]kOo_knoolO7aono_koobl_;olO7aono_koo`l?3o<S8bofi^K_ob
l_;ol?3`oo;bl_oalO7o0P82oifMWOo`l?3oYjNWo`T92Ol<30co8R8Roc<c<onLW9`00_o`l?001_lc
<c?o0000o`000?l@413o@T92om;BdP;ol?3`02Sol_;boo3`l?o_knool?3`ong]kOo[jn_oiNGUomOG
eong]kOoKVi^olG5aOoIfMWoi^KVonWYjOo]kNgokno_oo7alOo_knool_;boo7alOo_knool?3`oc8b
<_m`L73ol_;boo3`l?oYjNWo8b<Sod51@Oo_knool?3`oiFEUOlB4Q;o3Ph>obl_;olC4a?o7AdMokjn
__o`l?3o<c<c0_l000000ol@413o@T92om;BdP02oo3`l00<oo;bl_o`l?3okno_oo3`l?o]kNgojn_[
onGUiOoIfMWoa/K6oinOWooDe=Coi>CTj?oVi^H00>Sok^k^05Sok>c/omcLg?nUYJGo@hWDog2Xhon;
^ncoVlKaojC<mOnVc_GoZ<oeoj[?mOnZcoKoZ/oeoj_BnOn?[LgoOi^gojC:lOnZcoGoJH2Io`830onD
]MKoYlgdofV0Uol:30ko9Bhfoj[?mOnVb_;o1PP9o`X<3_n:Z/[oZloeohBP__l20`?oTk?DoiZkh?lm
BEOo2`d@ojO=m?n[coGoBe]/obXd?_nYc_CoZm3ioj_?m_l/=Coo72<ZohRT`onZcoGoSZo@ojS=lon[
d?Wo:S<moeAWN_nWcOCoZloeofb4W?lB5Q_oZ/oeoj_@nOl]=d7o:S@moi:ceOn[coGoX/GYoio4jOnZ
coGoP9bkojS;l_nYcoGo8b/cof5fS?nZcoGoZ/gdoj[@m_nZcoKoZ<gcojS>mOnUc??oX/ceoi_6lOn:
^^_oKjGQocima?mbLW;o`/;2omGEeOoRh^;oi^KV0_oZj^X07Oo/k>cojn_[on_[joo^k^kojn_[onc/
k?la<C7oJVYZonc/k?o^k^kok>c/onk^k_l20P;oVYZJonc/k?o5aLGo/;2`onWYjOo/k>coTY:Bo`<3
0oo=cLgok>c/oc4a<Om^KVkojNWYolG5aOlU9BGoDe=C00;ok>c/00kokNg]onWYjOo/k>coj>SXonWY
jOoVi^KohN7Qom?Cdonb/[;oLW9bol;2`_oEeMGoh^;RonKViP;oj^[Z01gok>c/on_[joo[jn_ok^k^
on_[joo/k>co<C4aofe]KOo/k>cok^k^ofMWIolB4Q;oe=CDonc/k?n;Rh_o0`<3ohR8R?o^k^kok>c/
on3Ph?l0003o[:b/onc/k?la<C7oKVi^onWYjOo5aLGo9BDUoe=CD`02onc/k00<ong]kOoYjNWok>c/
onSXj?oYjNWoi^KVon7QhOoEeMGo`L71ojFUYOoLg=cok>c/j?o^k^h00>Sooooo00WooOgmonc/k?na
/K7o?X;=ofVPf_n6]>KoUL7[oic4k_nRanh00_nSb>l07_nUb>ooYLW`ojK:lOnWc??oYL[aojG9l?nT
b>ooT;3Bo`000?meSZ[oYLW`ocM4DOm:Ffco4QHJoiFefOmiU;7o5ATNodIFIomCIGWoYlccohb[cOl1
0P;oNIBaojC8komVO9Go51TMojG9l?nWc??o<Ca8odUIJ`;oY<S_00KoSJc>o`000?mPMHcoYlccojG:
lOnUbO02ojC8k`0>obTb>omAHgOoYLW`ojO<lomYPI[o4QHJojC8kon>[Loo0000ogJ@[?nUbO3oYlcc
ojG:lOnUbO03ojC8k`07ogjJ^?l>4ACoH7F<ojG:lOnSb>ooYLccojG9l002ojC9l00Eoj?8konMa^oo
UL7[ohJeiomYXMco>WVoogYjN_nm_Kgoc/k>omcLg?oQhN7oi>CTonGUiOoVi^KoiNGUonKVi_oXj>So
inOWonSXj?la<C7oJFUY00?oi^KV00Goj>SXo`820_nGUiOojNWYonOWi`03onKViP06olc<c?l0003o
YJFUonWYjOl`<33oJf][0_oVi^H01?mRHV;o9BDUonSXj?oYjNT3onOWi`0MonKVi_oUiNGohN7QomgM
gOo>c/ko[Zj^ogYjN_nm_Kgoc/k>omcLg?oQhN7oi>CTonGUiOoVi^KoiNGUonKVi_oXj>SoinOWonSX
j?la<C7oJf][onKVi_n^[Zko0@41oj6QXOoWinOohN7Qoa8B4_mNGUh00ooVi^H01_oKfm_o0000ojVY
ZOoYjNWo<30`of][J`;oi^KV00CoHV9RobDU9OoXj>SojNWY0ooWinL02OoVi^KoiNGUon7QhOoMgMgo
d=3@okfm_Ona/K7ok>c/oogmo@3Xooooo`00j?o^k^h03?o/k>cog=cLojFUYOliOLWoI9gFogj_h?n@
^^?oUl3Zoik3jonM`^_oX<K[oio4j`;oX<C[0_nRa>`03_nOa>_oUKSMoc8mBOl41POoUk[Ooig0iol9
2`goN96^od1?GomPMXgoBea^ocm>G_mhTk7o728Y0_nRa>`03_m[Q9oo7bH^ob0W;olQ:C7o51PMoj34
jonRa>co<3]7odMGJOnOa>_oX/K/ogJA[ol0003oPIjm0_nRa>`2oio4j`0<oj;6k?lW<3_oCf5eoj34
jonRa>coIgfFoa4E6OnOa>_oN9>_o`000?lV;SSo9c0j0_lX<3X06_mjU[CoWlC[oi2adol^>4Co0@82
odIFJ?nL_N?oX/C/oj34jonOa>coX/C/oik3j_nPa^coWL;ZoiO0j_n>^NCoPK7Tof>Je_lbL[[oLW9b
okRh^?o;bl_oemOGom_KfooPh>3oh^;R1_oShn<00ol`<33oIfMWon?Sh`03on?Sh`03o`820_nDU9Co
hn?S00?ohn?S00_oeMGEodI6A_l71`OoemOGon?Shol`<33oJFUYon?Shoo;bl_o30`<og1`L003on?S
h`0?on;Rh_oShn?ohN7Qon3Ph?oKfm_ofMWIolW9bOnZZZ[oLW9bokRh^?o;bl_oemOGom_KfooPh>3o
h^;R00Kohn?S00Go<30`ofMWIooDe=Co7alOoeaLG002on?Sh`03okbl_?l0003o[Jf]00?ohn?S00[o
e]KFo`000?nUYJGohn?Soc0`<?mYJFWohn?Sol_;bol<30coL71`0ooShn<02ooRh^;ohn?Son7QhOoP
h>3ofm_KomWIfOo;bl_o^;RhojFUYOoLg=cok>c/0>Sok^k^003XonKViP17onCTi?oDe=CoWinOoc=f
a?mOU]?oNZSKohZeh?n@^^?oUkgUoiS0iOnK`NWoUkgToi[0ionK_nKoV/3Voi_0iom/R:?o4ADIo`dA
5?mbSj_oVl7WogJC[ol72@[oUk_Qofb8Xol]>4?o7B@/ofJ0VOnI_nGo3A0Coh>Ta?nK`>OoV;oUoi_0
i_nH_NCoFG25oa@H7OnK`NKoV/3VobhiAOm3EFKoVl3VoiZoi_n4YLGo0000oeQ]P_nJ`>KoVl3WoiRo
iOnK`>KoV[oVobH`>OlhAUCoVl7Voi[0i_mOMXko4ADJoi_0i_n4Y<Go0000ofN1V_mmW;[oN9Fco`42
0_n8ZlgoVl3VobL`>_lW<C_oQJG6oi_1i_nJ`>H00_nK`>L04?nJ_NGoVl3Woi_1ionG_NGoV;gUoi>l
ion;^>?oO:cOoefCd?l`KkGoKVi^ok>c/oo8b<Sodm?ComWIfOoKfm/2omkNgP07on7QhOoMgMgogmoO
omkNg_oOgmoo;bl_ob/[:`04of5QH@0Bo`000?nBTY;oh>3PomkNg_oOgmooWinOoaPH6?lD51CoYJFU
omoOgooPh>3o;bl_ob/[:olg=cOo4a<CohF5QOoLg=cogmoO0ooPh>03omkNgP0:om[Jf_oEeMGoa<C4
ojNWYom^KVko/k>colS8b?oCdm?ofMWIom_Kf`;og]kN00OohN7QomgMgOoOgmoog]kNomoOgol_;boo
0P8200;o000000KoZ:RXomoOgooNg]koW9bLo`000?o4a<@4omoOg`0:om7AdOoLg=coh>3Pobl_;ol[
:b_o=cLgoa<C4on5QHGog=cLomoOg`?oh>3P0ooNg]h01ooJf][oeMGEolK6a_ne]KGoWinOomCDe?oT
i>@0j?oVi^H00>Sok^k^05[ok>c/omcLg?nUYJGo;W;1oeVBd_meYMWoQkCOohfhhOnC^n7oUKcToiJl
i?nE_>?oUK[QoiBkhOnF_>CoBemco`000?lb?dcoQZW<oiBih?nE^n?oAeU/obdhA?nF_NCoSkGJo`X=
4?l10P;oRJ_@oiFkhollBe_oCV9goiJmi?mXQ9koP:72oi>ih?lhAUGo<Ce:oiJmi?nB]mko:SI1ocm?
H?n?]=[oT[WOoiBih?lT;SSo5Q`Rofn<ZOnE_>?oP:;3oiJmi?nE_>?o9Bhho`/>4Om5EfWoPZ?6oc=0
COl/>4?oU[gToiFlholT;COo?TiOoi6gg?mLM8go6AlVoiBkhOnF_NCo82P`oeM/PonE^n?oR:_?oi>h
gonF_NCoU;_QoiBjhOnF_>CoU;_Qoi>khonC^^7oRkKOohJbg?mcYMSoFI3=obUX/?mbLW;o/;2`olG5
aOoAdM7oemOGom[Jf_oKfm/3omcLg0;ofm_K00?og=cLobh^;_lg=cL00_mlO7`2og]kN`0So`410On@
T93ogMgMom_Kfom_Kfoo0000odU9BOo5aLGofm_KomcLg?oMgMgo;Rh^od];BomoOgoo=SHfofMWIooG
emOog=cLomgMgOoLg=cofm_KomcLg?oKfm_of=SHomKFe_o@d=3o`L71oj6QXOmbLW;o/;2`olG5aOoA
dM7oemOGom[Jf_oKfm/00ooLg=`2om_Kf`0>omcLg?l^;RkoIVIVolC4a?n4Q8Co1PH6oijNW_oKfm_o
ZZZZo`000?nd];CogMgMomcLg?oJf]X2om_Kf`0FomcLg?oMgMgo;Rh^od];BomoOgoo=SHfofMWIooG
emOog=cLomgMgOoLg=cofm_KomcLg?oKfm_of=SHomKFe_o@d=3o`l?3ojj^[_nUYJGog=cLonc/k>So
k^k^003Xooooo`09oogmoOo/k>co/K6aobE/_?mDSLcoL:;Eoh2/fOn8/mkoSKKL00;oT;SP03coT;KO
oi2hgon@^>3oPJG:o`410OmCJX3oTKSOoi6ihOnA^>3oTKSOobTd@?mILX[oT;KNoi2hgolgAECo9c8l
oi6hh?nA^=ooJXJTob/g@on@]]koCF=hoa`T:ol92`ko82Tbofn=Zon@]]koAe]_o`@51_l620[o3a<G
of9nVOnA^>3oPjO:oc4nBol82Pgo1PL9oaDK8OnA^=ooTKWQob@^>?m7FVkoA5IYo`/>4OlI82SoKXf[
oi6hgonA^N7oPZG:obPc?_l72@_o3a@HofN2Won@^=ooTKSOofb:Z?lP:C;o2@/=o`X=4?n3Yl/2oi2f
gP?oT;SP00ooTK[Sohffg?n9]=ooOjcHofnPe?mBRlSo8VB^ogYjN_n[Zj_o`<30olk>c_oBd];oe]KF
omOGeooJf]X00_oIfMT2om[JfP0>omWIfOl];BgoHV9RomSHf?oJf][ofMWIom[Jf_l20P;oSXj>omSH
f?o2`/;o0@41ogemOOoIfMT2om[JfP0:omWIfOoHf=So;Bd]ofATI?oJf][ob<S8o`P82?nJVY[ofMWI
omSHf0;ofMWI00oofm_KomOGeooGemOod];Bolk>c_nl_;coWYjNogYjN_n[Zj_o`<30olk>c_oBd];o
e]KFomOGeooJf]X00_oIfMT2om[JfP0>omWIfOl];BgoI6ATomSHf?oJf][o?ShnodI6A_oJf][obLW9
o`000?n4Q8Cof=SHom[Jf_oIfMT2om[JfP0:omWIfOoHf=So;Bd]ofATI?oJf][ob<S8o`P82?nJVY[o
fMWIomSHf0;ofMWI00[ofm_KomOGeooGemOod];Bolk>c_nn_[koZj^[ok6a/Oo/k>cooOgmj?ooool0
0>Sok^k^00_ok>c/omcLg?nUYJGo7VFfodZ7b?m[W=;oOJOHohB]f_n9/]WoRK7Kohfeg003ohbdg003
ogJG^Ol10@7oOJ7600;oS;CK00CoS;CNohfeg?n;/m[oS;?K0_n;/]/2ohbdf`04ohbdg_n=]McoRk?J
ohbcf`;oRk;K00SoS;CKohZbfOn<]=koSKGLoh^cf_n</m_o:CE2oci?H@;oS;CK00KoS;CNohfeg?n;
/m[oS;?KohV_f?n;/]/2ohbdf`04ob<]=om6FVgoRk?Joh^bfP;oRk;K0_n<]=/01?n<]=koSKGLohV`
eon</m/2oh^bf`;oS;CK01GoS;CNoh^bfOn;/m[oS;?Koh^bfon</m_oRk?Johbcfon<]=coRk?LohZc
f_n3[MWoO:OFofVKd?m:QLCo7F2Zog9bL_nVYZKo^k^kolW9bOo@d=000ooDe=@01ooGemOoe]KFomCD
e?oDe=CoeMGEob`/;?mPH6000_oFe]H02OoGemOoe=CDo`820_n;Rh_oe=CDok>c/ol10@7o`L71omOG
e`02omCDe00;omGEeOoDe=Co;2`/of=SHooFe]Ko`l?3o`P82?mgMgOoeMGEomCDe?oEeMD00_oFe]H0
2ooEeMGodm?Com3@d?o8b<So^;RhoiZJV_mbLW;oYZJVok^k^oo9bLWod=3@00?oe=CD00OoemOGomKF
e_oDe=Coe=CDomGEeOl/;2coHV9R00;oe]KF00Wo;2`/odI6A_oDe=CoeMGEoe9BD_lM7Agoa/K6omKF
e_oGemL00_oDe=@02ooEeMGoe=CDob`/;?mSHf?oe]KFol?3`ol820SoMgMgomGEeOoDe=CoeMGE00;o
e]KF00WoeMGEom?Cdoo@d=3ob<S8okZj^_nWYjOoYJFUomcLg?o/k>`0j?o^k^h00>Soi^KV00[oi>CT
omCDe?nOWioo6Ef^odF2`_mRV<koLj?BogbUeOn4[]WoQZkJ0_n8[mX02On7[MWoQjoJohR_f_lX<coo
7RLaod]QNOlc@U?o;Sa;ohRafP02ohR_fP06ohZafon8[]WoR:oJohJ^f_n8[m[oR;7J0_n8[mX01_n:
/M_oR:kIohR_f_n6[][oR:oJohRafP;oR:oJ00KoNI_0ogJG_?n8[m[oQZkJohR_f_n8/MX2ohR_fP06
ohZafon8[]WoR:oJohJ^f_lR:cKo@eQ/0_n8[mX01_n:/M_oR:kIohR_f_n6[][oR:oJohRafP;oR:oJ
00KoR[7KohR^fOn8[m[oQZkJohR_f_n8/MX2ohR_fP0CohZafon8[m[oQjgIohR_f_n7[m[oQ:cJohB^
fOmmYmKoLj;Bof:Hcom4P<7o5EFSofi^K_nQXJ7o]kNgolC4a?o;bl_oc/k>om;BdP06om?Cd`04obd]
;OmOGeoodm?Com;BdP;odm?C01Go0P82ohZ:R_oEeMGod];Bocdm?Ol_;booMGEeoe5ADOm8B4Sodm?C
omGEeOl/;2co9RHVoclo?olA4A7o5ADEolO7aooCdm?oeMGEom?CdooDe=@00_oBd]803?o?cloob/[:
olG5aOnf][KoUIFEofi^K_nQXJ7o]kNgolC4a?o;bl_oc/k>om;BdPKodm?C00Ko;Bd]obHV9_m:BT[o
71`Lo`T92OnQXJ42om?Cd`0ColC4a?le=CGo61PHofEUIOmlO7coH61PobPX:?nMWIgoeMGEob`/;?lV
9RKo?clooa4A4OlE5AGoalO7om?CdooEeMGodm?ComCDe002om;BdP08olo?coo:b/[oaLG5okRh^?nQ
XJ7oWinOomCDe?oTi>CXonKViP00j?o^k^h05?o/k>cog=cLojFUYOl?E:[o?7Vmoe^Aaom^WLooNjSH
ognXe_n0Z=KoPj_Hoh>/f?n2Z]KoPZ_Foh:Ze_n0Z=CoG7VHocQ9GOm5Fg;oHX2Q0_n3ZmP01On2Z]Ko
Pj_Hoh:Ze_n2ZmSoPj_F00?oPj_H00GoPZ[Foh>[f?n2Z]KoPZ_Hoh>[eP03oh>[f005oh:Ze_n3ZmSo
PZ[Foh:[f?n3ZmH00on3ZmP03On2Z]KoPj_Hoh:Ze_n2ZmSoPj_Fob0Z=_m1EF_oPj_Hoh:Ze_n3ZmSo
PZ[Foh:[f?n3ZmH00on3ZmP01On2Z]KoPj_Hoh:Ze_n2ZmSoPj_F00?oPj_H00?oPZ[Foh>[f?n3ZmP0
0_n3[=P03on4[MWoP:SFogjWeOmiYMKoL9kBoeZ@a_lnNkoo3DfMog9bL_nIVIWo/K6aokno_oo9bLWo
c/k>olo?c`06om3@d003ohn?SonSXj?od=3@00?od=3@00WoOgmook>c/oo@d=3od=3@olc<c?nDU9Co
FEUIofi^K_nKVi/00_o@d=001On?ShooOGemoh20P?nYZJWoc/k>00Cod=3@00ood];Bom3@d?o?cloo
c<c<olW9bOnn_[ko/[:bohf=SOmbLW;oVIVIok6a/Ono_koobLW9olk>c_o?cll01_o@d=001On?Shoo
OGemogemOOnHV9Sobl_;00Cod=3@00goclo?oi2@T?mWIfOoEUIFog5aLOn>SXkoa<C4om3@d?n?Shoo
OGemoh20P?nYZJWoc/k>00Cod=3@00_od];Bom3@d?o?clooc<c<olW9bOnn_[ko];BdoiVIVOnUYJGo
g=cLonc/k03Xonk^kP00j?ooool03?omoOgokNg]okBd]?l4BZCo<G:hoeB9a_mWUlcoLYo@ogNTdomm
YMCoOZOEogjXe@?oOZSD00?oOj[Eoh2ZeOmnZ=@00omnZ=@01?moZ=CoOZSDognZeOn0Z]D4ogjXe004
ognXe?mnZ=CoOj[Eoh2Ze@CoOZSD00CoOjSDogjXe?moZ]GoP:[E1?mnZ=@01?moZ=CoOZSDognZeOn0
Z]D2ogjXe006ogbUd?mmY];oOjSDogjXe?moZ]GoP:[E1?mnZ=@01?moZ=CoOZSDognZeOn0Z]D4ogjX
e00HognXe?mnZ=CoOj[EogjXdomoZ=CoOZSDognXe_mmYMCoNJCDog:Od?mXV/goDhW4oc5`]ol3@YSo
Ogmooi:BT_n/[:co_;blolC4a?o:b/[obl_;olc<c?o>c/koclo?7_o>c/h2olc<c00?ol[:b_o4a<Co
_;blojZZZ_n7QhOoOgmooi:BT_n/[:co_;blolC4a?o:b/[obl_;olc<c?o>c/koclo?01koc/k>0_o<
c<`02?o:b/[oa<C4okbl_?n/[:coTY:BokBd]?o]kNgooOgmj?ooool00>Sok^k^00[ok>c/omoOgon]
[Jgo03nLobAU/om5P<3oG937ofbJc?mcWlooMj?@0omjY=80COmjYM?oO:ODog^WdomjY];oMjC?ogVU
d?mjY]?oO:SDog^We?mlYmCoNjOCogZVd_mgY<ooNJG@ogZVdomlZ=CoNjODogbWe?mkYm?oNZKBogNT
comiYM3oNZKCogbXe?mkYmCoO:ODog^WdomjY];oMjC?ogVUd?mjY]?oO:SDog^We?mlYmCoNjOCogZV
d_mgY<ooNJG@ogZVdomlZ=CoNjODogbWe?mkYm?oNZKBogNTcomiYM3oNZKCogbXe?mkYmCoO:ODog^W
domjY];oMjC?ogVUd?mjY]?oO:SDog^We?mlYmCoNjOCogZTd_mkYM;oNZC@og^Ud_meWlgoLio@ofbJ
c?mLTLOoAH30ob=T/Ol0>Y?oOWinoh^;RonUYJGo][Jfol30`?o5aLGob<S800;ob/[:00?oc<c<ol[:
b_o;bl/00oo<c<`01Oo:b/[obl_;olc<c?o:b/[obl_;00?oc<c<00Gob/[:ol_;boo<c<cob/[:ol_;
b`03olc<c005ol[:b_o;bl_oc<c<ol[:b_o;bl/00_o<c<`04?o;bl_ob/[:olO7aoo9bLWoaLG5ol30
`?ne]KGoXj>Soh:2P_mnOWkoRh^;ojFUYOnf][Ko`<30olG5aOo8b<P2ol[:bP03olc<c?o:b/[obl_;
00?oc<c<00Gob/[:ol_;boo<c<cob/[:ol_;b`03olc<c005ol[:b_o;bl_oc<c<ol[:b_o;bl/00oo<
c<`01Oo:b/[obl_;olc<c?o:b/[obl_;00;oc<c<00cobl_;ol[:b_o7alOobLW9olG5aOo0`<3o]KFe
ojFUYOn;Rh_o[Jf]omoOgoo/k>cXonk^kP00j?oVi^H0F_oUiNGofMWIok6a/Ol9;Xco4UNZocMc^Om>
Q/7oHI?7ofRGb_m^VlkoLIk=og6McombWlooLYo>og6NcOmaWlkoLYo?og>PcombX=3oLIk>og6Ncomb
WlkoLIk=og6Oc_mbWlooLj3?og:Pd?maW/koLIk?og:Oc_maW/goLIo>og:OcomcX<ooLZ3@og6Nc_ma
W/ooLYo>og6NcOmaWlkoLYo?og>PcombX=3oLIk>og6NcombWlkoLIk=og6Oc_mbWlooLj3?og:Pd?ma
W/koLIk?og:Oc_maW/goLIo>og:OcomcX<ooLZ3@og6Nc_maW/ooLYo>og6NcOmaWlkoLYo?og>Pcomb
X=3oLIk>og6NcombWlkoLIk=og6Oc_m`WLgoLYo?og>Nc_m`WLcoK9S:ofVGb_mPT/OoCXK3ocIc^?l?
E:Wo22b5ohR8R?mhN7SoW9bLojj^[_nh^;So`L71olC4a0?oalO700Coa/K6olS8b?o6a/KoalO70oo8
b<P2olK6aP03olS8b?o6a/KoalO700?ob<S80_o6a/H00oo8b<Soa/K6olO7a`03olS8b0;oa/K600?o
b<S8olK6a_o7alL00_o7alL2olC4a00<ol30`?ni^KWo[Zj^oiZJV_mcLg?oR8R8ogQhN?nLW9co[Zj^
okRh^?o1`L7oa<C40oo7alL01?o6a/Kob<S8olK6a_o7alL3olS8b0;oa/K600?ob<S8olK6a_o7alL0
0oo8b<P2olK6aP03olS8b?o6a/KoalO700?ob<S80_o6a/H00oo8b<Soa/K6olO7a`02olO7a`;oa<C4
00So`<30okVi^On^[ZkoVi^KogYjN_na/K7ofMWIonGUiNSoi^KV003Xonk^kP0Eong]kOoUiNGoa/K6
obPfQOl3AJ3o=g>iof:CbOmlYM?oQZkEoh^_eOn@]=SoTKGJoi2dfOnB]M[oTKGJoi6df_nB]M[oT[GK
oi6dfOn@]=WoT[GJ00;oTKGJ00KoTKCJoi:ef_nB]M_oTKCIoi2dfOnB]MX2oi6efP06oi6df_nB]M[o
T[GKoi6dfOn@]=WoT[GJ0_nA]MX01_nA]=[oT[GJoi:efonA]=WoT;CIoi:efP;oTKGJ00KoTKCJoi:e
f_nB]M_oTKCIoi2dfOnB]MX2oi6efP06oi6df_nB]M[oT[GKoi6dfOn@]=WoT[GJ0_nA]MX01_nA]=[o
T[GJoi:efonA]=WoT;CIoi:efP;oTKGJ01CoTKCJoi6dfonA]M[oT[KJoi6df?n=/MSoR:kEoh2ZeOmU
ULWo>gFio`51W_lV<WooYJFUog1`L?n?Shoo[Zj^ol;2`_o<c<codM7Aom;BdP;oe=CD0_oEeMD3omCD
e003omGEeOoDe=Codm?C00;oeMGE0ooDe=@00ooEeMGoe=CDom?Cd`02omGEe@?oe=CD00?oeMGEomCD
e?oCdm<00_oEeMD5omCDe00>om3@d?o>c/ko`/;2ok2`/?n<S8coKFe]ojFUYOm`L73oShn?ojj^[_o2
`/;oc<c<om7AdOoBd]82omCDe0;oeMGE0ooDe=@00ooEeMGoe=CDom?Cd`02omGEe@?oe=CD00?oeMGE
omCDe?oCdm<00_oEeMD3omCDe003omGEeOoDe=Codm?C00;oeMGE1OoDe=@02Oo@d=3oc/k>ol;2`_n`
/;3oSHf=og5aLOo6a/KoiNGUong]k@3Xonk^kP00jOooool03_ojn_[oinOWofUYV?l;<9GoEX[6ohjc
fOnO_mooYL?Qojc6hon/an?o[/WSojo:iOn^b>Co//[T1On_bN@00oncc>Go/L[Uok;:i005ojo9i003
ok?<iOnab^Go//[T00Go[lWT00?o/lcUok7:iOnbb^@01On_bN@00oncc>Go/L[Uok;:i005ojo9i003
ok?<iOnab^Go//[T00Go[lWT00?o/lcUok7:iOnbb^@01On_bN@00oncc>Go/L[Uok;:i002ojo9i00C
ojo:iOn^bN?o[LSSoj_6honS`^7oWkoOoi:ef_mHS<Ko1bjCofIVUOoAdM7oR8R8oh20P?nl_;coe=CD
om[Jf_oMgMgoh>3PomoOg`05on7Qh@04on3Ph?oQhN7oh>3Pon3Ph0CohN7Q00Coh>3Pon7QhOoPh>3o
h>3P1?oQhN401?oPh>3ohN7Qon3Ph?oPh>05on7Qh@0Aon3Ph?oOgmoog=cLom_KfooEeMGo_Kfmogin
O_n8R8SodM7AohR8R?n0P83o_;blomCDe?oJf][ogMgMon3Ph?oOgml01OoQhN401?oPh>3ohN7Qon3P
h?oPh>04on7Qh@04on3Ph?oQhN7oh>3Pon3Ph0CohN7Q00Coh>3Pon7QhOoPh>3oh>3P1OoQhN402_oP
h>3ogmoOomcLg?oKfm_oeMGEokfm_OmnOWkoRh^;onOWioojn_[Yooooo`00jOo^k^h03_o/k>cohn?S
okFe_olf>hWoCg:foh^af?nJ^]coYL;PojO3hOn[a>?o[<OSoj_7hon/b>CoZlOS1?n/b>@01?n[anCo
[<STojc7hon[an<4ojc8i004oj_7i?n/b>Co[<OSoj_7h`Co[<ST00CoZlOTojc8i?n/an?oZlOS1?n/
b>@01?n[anCo[<STojc7hon[an<4ojc8i004oj_7i?n/b>Co[<OSoj_7h`Co[<ST00CoZlOTojc8i?n/
an?oZlOS1?n/b>@01?n[anCo[<STojc7hon[an<3ojc8i00@ojc8hon/an?oY/?Qoj?2h?nH^McoNjGC
ocMN[?ld>HKo/k>momWIfOnh^;SoMGEeojb/[?oBd];of=SHomgMg@;ogmoO00?oh>3PomoOgooPh>00
0_oOgml4on3Ph004omoOgooPh>3ogmoOomoOg`Coh>3P00CogmoOon3Ph?oOgmoogmoO1?oPh>001?oO
gmooh>3PomoOgooOgml2on3Ph00>omkNg_oLg=cof=SHolc<c?nPX:3oLg=cokRh^?oIfMWo^;RhogEe
MOn/[:cod];BomSHf?oMgMd2omoOg`03on3Ph?oOgmooh>3P00;ogmoO1?oPh>001?oOgmooh>3PomoO
gooOgml4on3Ph004omoOgooPh>3ogmoOomoOg`Coh>3P00CogmoOon3Ph?oOgmoogmoO0_oPh>002OoN
g]kog=cLomSHf?o<c<coX:2Pog=cLonj^[[ohn?Sonc/k03Yonk^kP00j_oVi^H0A_oShn?ofMWIoiZJ
[_m4BI?oB6>bof^Ab?n4ZmGoU[SLoiZkg_nL_=koW[oNoijogonM_MkoW;cNoijmg_nN_MooWKcNoino
gonN_MkoW[gOoifmg_nL_=koW[gNoijmgonM_=koWkoOoijmg_nN_MooWKgNoiblg_nN_MkoW[gOoifl
g_nO_mooW[gNoijmgonM_MkoW;cNoijmg_nN_MooWKcNoinogonN_MkoW[gOoifmg_nL_=koW[gNoijm
gonM_=koWkoOoijmg_nN_MooWKgNoiblg_nN_MkoW[gOoiflg_nO_mooW[gNoijmgonM_MkoW;cNoijm
g_nN_MooWKcNoinogonN_MkoW[gOoifmg_nL_=h2oifmgP0Boi^lg_nJ^mkoU[SLohV]e_mTRlKo:DVR
ocPmRonJVZoofMWIon3Ph?oIfMWoYZJVoh61POnTY:Co_knoolo?cooGemOofMWI0_oJf]X00ooIfMWo
f][JomWIf@05om[JfP03omWIfOoJf][ofMWI00Gof][J00?ofMWIom[Jf_oIfMT01OoJf]X05OoIfMWo
f][JomWIfOoJf][ofMWIomOGeooAdM7o_;bloi6ATOmgMgOoYZJVomWIfOoPh>3ofMWIojJVY_n1PH7o
Y:BTokno_oo?clooemOGomWIf@02om[JfP03omWIfOoJf][ofMWI00Gof][J00?ofMWIom[Jf_oIfMT0
1OoJf]X00ooIfMWof][JomWIf@05om[JfP0=omWIfOoJf][ofMWIom[Jf_oIfMWoemOGom7AdOnl_;co
TI6AogMgMonVYZKofMWIon?Sh`3ZonKViP00j_o^k^h04Oo]kNgojn_[on?Shoo0`<WoLG6PocHmS_l?
98Ko0228o`0URol0:8go02^@o`0/TOl0;I7o02b@o`0/TOl0;93o02bA00;o02fA00Ko02fBo`0]TOl0
;93o02bAo`0/T?l0;942o`0]T@06o`0]T_l0;I7o02b@o`0/TOl0;93o02bA0_l0;I401_l0;I;o02fA
o`0/T?l0;97o02b@o`0/T@;o02fA00Ko02fBo`0]TOl0;93o02bAo`0/T?l0;942o`0]T@06o`0]T_l0
;I7o02b@o`0/TOl0;93o02bA0_l0;I401_l0;I;o02fAo`0/T?l0;97o02b@o`0/T@;o02fA01Wo02fB
o`0]TOl0;93o02fAo`0[S_l09hgo02J;o`0PR?l?98Ko=Sf>og5aX?o0`<Wohn?Son_[joo/k>cojn_[
on?Shoo5aLGoTI6AogYjN_maLG7oLW9bogIfM_mgMgOoNg]k00;oO7al00?oNg]kogalO?mkNg/00_ml
O7`01_mkNg_oO7alogalO?mkNg_oO7alog]kN`;oO7al00KoNg]kogalO?mlO7coNg]kogalO?mkNg/2
ogalO006og]kNomlO7coO7alog]kNomfMWKoMgMg0_maLG404?mjNW[oTI6AolG5aOoShn?ojn_[onc/
k?o[jn_ohn?SolG5aOnATI7oNWYjog5aLOmbLW;oMWIfogMgMomkNg/2ogalO003og]kNomlO7coNg]k
00;oO7al00KoNg]kogalO?mlO7coNg]kogalO?mkNg/2ogalO006og]kNomlO7coO7alog]kNomlO7co
Ng]k0_mlO7`01_mkNg_oO7alogalO?mkNg_oMWIfogMgM`;oLG5a00KoNWYjoi6ATOo5aLGohn?Son_[
joo]kNgZonk^kP00k?ooool01_omoOgon_[jooKfm_oalO7okno_ong]kD;ok>c/00KokNg]ono_kooa
lO7om_Kfoo[jn_omoOd3ooooo`06oogmoOojn_[om_Kfoo7alOo_knookNg]8?o/k>`01_o]kNgokno_
oo7alOofm_Kon_[joogmo@?ooooo00KooOgmoo[jn_ofm_KolO7aono_koo]kNdPonc/k006ong]kOo_
knoolO7aooKfm_ojn_[ooOgmk?ooool00>kok^k^0_o]kNe6onc/k0;okNg]1oo^k^h2ong]kBCok>c/
0_o]kNd7onk^kP;okNg]9?o/k>`2ong]kNkok^k^003oonKVi_ooi^KVQ_oVi^H00?ooOgmoFOmoOgl7
oginO_ooOgmo9_moOgl00004on_[jooVi^Koh^;RomkNgPCogMgM0ooNg]h0oooMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMg@006_oNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oLg=cogMgMom_KfooLg=cog=cM0_oMgMd0<OoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]h00_oL
g=`01OoIfMWof=SHomOGf?oHf=SofMWI00;og=cL0?oog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]h001WogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgM00?og]kN00?ogMgMomkNg_oNg]h00ooMgMd1on7Qh@7oinOW0OoZj^X00003
onc/k?oVi^Koh>3P00OofMWI00Cof=SHomKFe_oCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;
omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOG
om?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf=gofMWI0_oHf=P01_oFe]Kodm?Com?CdooDe=Co
emOGomSHf0;ofMWI00?of=SHomWIfOoIfMT00_oHf=P9omWIf@03omSHf?oIfMWofMWI00;of=SH00?o
fMWIomSHf?oHf=P00_oHf=PGomWIf@04omSHf?oFe]Kod];Bolo?c`;ocLg=00Coclo?om?CdooGemOo
f=SH3OoIfMT00ooHf=SofMWIomWIf@3oomWIf@SofMWI00?of=SHomWIfOoIfMT01_oIfMT1omkNgP7o
i^KV0Oo/k>`00007onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=codm?C
olO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?C
olO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?C
olO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`3Lon7Qh@09on3Ph?oOgmoofm_K
omKFe_oDe=Coe]KFom[Jf_oNg]koh>3P00KogmoO0ooPh>000ooOgmooh>3Pon3Ph002on3Ph0SogmoO
0_oNg]h2omoOg`?oh>3P0_oOgml2on3Ph0;ogmoO3OoPh>001OoOgmoogMgMomWIfOoEeMGodm?C00;o
d];B00?oe]KFomcLg?oPh>00oooQhN4Jon7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoTi>@1onWYj@7o
kNg]00000oo`l?3okno_oo7al@03oo3`l03oono_koo`l?3ok^k^onWYjOoKfm_o`L71ojBTY?n<S8co
Ng]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7aono_kooalO7okno_oo7akoo_knoo
lO7aong]kOoZj^[of][Jol;2`_nTY:CoS8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^So
kNg]oo7alOo_knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<S?mkNg_o
MgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]kOoalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_000Poo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo^k^kokno_on[Zj_oWinOoh>3Pon3PgooShn<2on_[j`07on[Zj_oVi^Koj>SXonOW
iooYjNOojNWYonk^kP02onc/k00<onSXj?o/k>cokNg]oo3`k_o/k>coj^[ZonKVi_oXj>SoinOWonWY
jOoXj>Sojn_Y0_oWinL03_oUiNGojNWYonWYjOo^k^kokNg]ong]jooXj>Sojn_[onc/k?o^k^kojNWY
on[Zj_o[jn_okno]0_o/k>`01_oZj^[ok^k^onc/k?o/k>coj^[Zono_k@;ok>c/0?ooj^[Zonk^k_o/
k>co[jn_ogIfM_mIFEWoKVi^okNg]ooPh>3ojNWYong]kOoalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_koo`l?3okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knl002_olO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo`l?3okno_oo3`l?o_knool?3`ono_koo`l?3okno_00Col?3`00000oobl_;o
k^k^onOWi`04onGUi@0@onCTi?oOgmoodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7o
IVIVohZ:ROna/K7odM7AomkNgP;oi>CT00?oiNGUonCTi?oUiN@00_oTi>@03ooNg]kodM7Aok6a/On:
RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7@omkNgP02onCTi03_onGUiOoT
i>CoiNGUonCTi?oTi>?og]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:
RX[o/K6aom7AdOoNg]koi>CSonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiND00_oTi>@0ooo5
aLGo:2PXodA4A?n@T8oodM7AomcLg?oKfm_oemOGomCDe?oFe]Koe=CDomGEe?oIfMWoh>3PomkNg_oJ
f][oe=CDomWIfOoNg]koh^;QomcLg?oGemOoe=CDomKFe_oDe=CoeMGEomSHf?oKfm[oemOGomKFe_oE
eMGoemOGomSHf?oNg]kogmoOomcLfooEeMGoemOGomcLg?oMgMgoemOGomKFe_oKfm_ohN7PomkNg_oK
fm_of][JomkNg_oLg=cof][Jom_KfooPh=oogmoOomcLg?oIfMWog]kNomoOgomdM7CoIfMWohf=SOmD
E5Co20P8oj:RX_oLg=coh^;RonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoShn?oiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi000
F_oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i0CoiNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o]kNd1oo;blP0000?om?Cdong]kOoWinL00_oPh>00
4ooQhN7ogmoOomkNg_oBd];o];BdohN7QomLG5coKC/eoii>@_o=KeoojH=_ole_GonNCT?oKC/foeaL
G?n7QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLofeP;?nNURkocLdoonWY
COo=cCooWYX_ofeS;OmLG5coQhN7okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaL
G?m7IbkoJ9hcoi7=AonZjEGoTLe7ofZN=?m9JRooG5aLohN7Qond];Cod];BomkNgP3Kon3Ph006omoO
goo?clooVIVIoi:BT_lI6AWoS8b<0_oEeMD07oo?cloo`/;2olk>c_o>c/koaLG5ol[:b_oJf][of=SH
om3@d?o;bl_oclo?omSHf?oJf][oeMGEolo?coo1`L7od=3@olk>c_o4a<Cobl_;omSHf?oGemOo_[jn
ok^k^ooAdM7od=3@omGEeOoHf=Sodm?Colc<c?o>c/h00_oEeMD01Oo>c/koc<c<om?CdooJf][of=SH
00;od];B00Cof=SHomOGeooAdM7odm?C0_oIfMT01_oCdm?odM7AomOGeooHf=SodM7Aom3@d0;odM7A
00CoATI6od51@OoGemOog]kN3?oPh>000ooOgmooh>3Pon3Ph03oon3Ph0Woh>3P00?ogmoOon3Ph?oO
gml00_oOgml3on3Ph003on7QhOoWinOok>c/007om?Cd00000oofm_Kol_;bon_[j`03onSXj00ConOW
iooRh^;ocLg=oinOWom[GeooScH^oneaHOoiWI3ooK6Uoofl[oom]:OonInConedHonB=booJemOoinO
Woo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinOWom^IUooTg8RongAA?oilgCooOf=oogm
UOomoHkonOQfongGAonCLb;oKVMOoinOWoo=cLgoh^;RonOWi`03onSXj00ConOWiooRh^;ocLg=oinO
WomPJ5ooBg`Soi;QBonmnG_od?fBomSmVooDoIGo`?UnoiSXCOm=P2CoH6UOoinOWoo=cLgoh^;RonOW
i`3LonSXj004onKVi_oQhN7oGEeMode=C@;ogMgM01ooD51@o`L71olE5AGoQ8B4oaHF5_m3@d?oh^;R
omgMgOnLW9co0000ohn?SooMgMgohN7Qom_Kfom0@43o20P8oaTI6On8R8So2`/;oeQHF?ng]kOo30`<
o`L71olS8b?o9bLWogemOOoJf][ogMgMomCDe?l;2`_oFEUI00;ofMWI00?oGEeMo`/;2ooCdm<00_oO
gml01_mJFU[oCTi>omkNg_oNg]ko8b<SohB4Q0;ohN7Q00coNWYjobh^;_oMgMgogMgMol;2`_m@D53o
<c<cofi^K_n3Ph?o8B4QomkNg_oVi^KoonSXj27oj>SX0Oo/k>`1oo;blP7om_Kf00000oogmoOon?Sh
ooShn003ooShn00CooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFoo^BQoonYY_oo[6UoonhZoon/jKooZRL
oo^DROo^J5WoRC4[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dm
oo_PK_onm8;oo_j:ooooT_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^ooOgm`03ooShn00C
ooOgmoo^k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSoc_j@omKoUoo@oY;oa_j9ok;eM?n8dd?oA7D[
oi2@T?o>c/kok^k^ooOgm`3LooShn00UooKfm_oalO7oPH61oalO7oo]kNgoa/K6o`000?o3`l?odm?C
oeaLG?l820Soj^[Zoo3`l?oZj^[oDU9Boa@D5?lm?CgojNWYoo3`l?n_[joo1`L7om;Bd_o=cLgoCTi>
oa/K6oo^k^kofm_Kojj^[_oXj>Sok>c/ojj^[_l0003o];Bdonc/k?n`/;3o2`/;oaXJ6P02onCTi00;
ob<S8ol>3PkoY:BTong]kOo^k^koH61PoeADE?o^k^kokNg]obHV9_n=SHd00_o`l?003?n2PX;o<C4a
onc/k?oZj^[o@d=3obl_;onLW9coLg=cobXZ:_lJ6Q[ok^k^ooKfmPOon?Sh00?omoOgooShn?ohn?P0
ooohn?P@ooShn003ooOgmoohn?Son?Sh00;on?Sh00ComoOgooWinOogmoOomoOg0Oohn?P00003oo[j
n_oemOGok^k^00;ok>c/0?oojn_[onWYjOoOgmoo^[ZjogUBD_no<RCoigAYoof9O_ooV8cooZ:FoonX
W?onY9SooiZ=ooj:Ooo^MV[o`c<TogUBD_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[k?oZj^[ogmoOokZj
^_n8IE;ohY4LooW3D?omfV?oonYbookcO_oonX;oo_Ioooo/LoongVCon/MAon:B7?n9IU?o^[ZjomoO
gooZj^[ojn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S7?nAdUGoY^MZokSiN_o0oX;oaon9ol?n
Q?nioG_oYna/oiCFEomBYQcoDVeBokZj^_oOgmooj^[Zon_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jn`004_ok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?oYjNWoiNGUogYjN_lL71cohN7Qolc<c?l30`?oX:2PomkNg_nDU9Co4a<C
on7QhOoPh>3od=3@o`H61_nQXJ7o2@T9okno_ooQhN;o^[Zjo`820_nb/[;ogMgMoh20P?lX:2Sohn?S
onOWj?oUiNGogmoOom_KfooCdm?o20P8ohF5QOoOgmooJFUZodY:B_le=CGo[Jf]okfm_Ol71`OoN7Qh
oeEEEOoOgmooh>3Poe]KFom@D5000_oQhN40oolT92CoQHF5omoOh?oQhN7oNg]kobl_;ooPh>3oe=CD
o`D51OnXZ:Sohn?Ton?ShomnOWko5QHFon7QhOoZj^[ojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[j`009oo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k007on_[j`05onc/k?o[jn_ojn_[onk^k_ofm_H00OoinOT00003oo_knooclo?okNg]00;o
iNGU0?ooi^KVonCTi?oIfMWo/[:bogT^;_o8@SCohfYLooAjKOomR7cooYN:oojKS_onV8_ooXYnooAk
KOoWJegobT8dog/^;_nb/[;of=SHonCTi?oUiNGoi^KVonGUi_oTi>Cof=SHok:b/_nFEBkojY`[oo^l
A?onc5?ooMQRookSL_onjGGoo^IcookKIOomc5?onl55onjN:onIERko/[:bomSHf?oTi>CoiNGUonKV
i_oUiNGoi>CTomSHfOnb/[;o;V8^of>]:on7bTSoUmaIojGUJOnblgOo^?IkokCeNOnWjV_oV=aIohW?
BomS[R_o;V<^ok:b/_oHf=Woi>CTonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNH004_oi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oShn?ogmoOogMgMolK6a_og=cLon7QhOnNWYko;bl_ob/[:olb<S;o4Q8BomcLg?oJf][oQ8B4
ob0P8?oPh>3oDU9BofQXJ?oJf]_og]kNoi2@T?lZ:R[o;Rh^ob`/;?lW9bOog]kNomkNgooIfMWodm?C
om3@d?mKFe_o0000okfm_OoJf][o:2PXohN7QomgMgOoJ6QXoh:2P_ll?3co`/;2o`l?3ooDe=Gof][J
oeUIFOm>CTh00_oLg=`07?lS8b?oPH61omGEe_oGemOoMgMgobh^;_oLg=coXj>So`000?o7alOof=SI
omWIfOn=SHgo5ADEomcLg?oTi>CoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^H3onGUi@3oonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KV0009onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU00;oi^KV
00?oiNGUonKVi_oVi^H00ooVi^H00ooUiNGokNg]ooCdm001oo_kn`0000?oo?clooShn?oalO400oo^
k^h04oo[jn_ohN7Qokbl_?mj5aOo`clbom=FBOoTJ5[okgM/ooB3NOohQgcomHAjoo=iKOoUJE_ofEQ:
ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl_?nUAaOoiYLbooF/<?om_47ooLUC
oog@H?okdfGooM9Pook=E?om_D;onZlbonVK<_nUAQOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Q
okbl_?lGFAOoGjPbogJm=on6cDOoU]IJoj;PIOnSh6WoXn5WoiOJG?n6cTOoMklgoen[<_lGFAOo_;bl
on7QhOo/k>`0g?o^k^h0;_o/k>coinOWog]kNolL71coi>CTonWYjOoVi^KohN7QomkNg_n=SHgo51@D
onKVi_oTi>Co=CDeogUiNOo[jn_o/[:boaDE5OoOgmooi^KVonCTi?oQhN7ogMgMogYjN_lY:BWoj>SX
onGUiOoMgMgo/K6aobHV9_l;2`_oVi^KonWYjOo<c<co0000olk>c_o3`l?o9BDUod];BomlO7coj>SX
oc4a<OnUYJGoi>CToeeMGOmADE42onOWi`0:obDU9OmYJFWogmoOomoOgomgMgOo<C4aonWYjOo1`L7o
0000ojNWY`;ogmoO00CoTi>CoaHF5_oWinOok>c/ooo^k^hPonk^kP03ong]kOobl_;on?Sh007oo?cl
0003oogmo@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh=3Coaclcom9@@ooJHUGohfiRonAb
I?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];olo?cooclo0?ooOgm01?oo?cloo?clooBd];oWR/7
omZ:=?o[VaWomJPYooRd?ooi_D[on;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?oo?cl
00?ooOgm01?oo?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3@on:cE3oSLeBoh[>D?n1adCoLKT_
of:^8?m>VcCo1d87om;Bd_oclo?oo?cl0=cooOgm02?ono_kooOgmon4Q8Co7QhNoo?clooinOWo/k>c
om3@d?oclo?oJ6QXodM7Aoojn_[oe=CDo`000?oMgMgoo?cloo_knolW9bOoZ:RXooWinOn[Zj_oeMGE
oo7alOmDE5CoGUiNooWinOodm?CoU9BDo`D51Om0@43odM7AooOgmoohn?SoUiNGob/[:`02oo[jnP0K
ob@T9?l71`Oob<S8oo_knon5QHGoHf=SooOgmomSHf?oEeMGooShn?oinOWo9bLWoaDE5On3Ph?oemOG
od92@_mSHf?ono_koo[jn_ld=3CoBDU9om_KfooUiNGoCdm?oaLG5oojn_[oo?cl0?oooOgm7_omoOd0
0oolo?cooOgmooclo003oogmo@0003[ooOgmoo[jn_oclo?ok^k^oo3`l?o_knook^k^onWYjOoCdm?o
FadMoj8d=?nd:1go`CX]olM9??o?ET[od5M;om1GB_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[o
k^k^oo3`l?o_knool?3_onk^k_oZj^[odm?Coh`U7Oo8LCCofH@MonBD5OoWWBCokZPcoo2Z=?o_ZS?o
k:0UonNG5OoLR1gob74doh`U7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`l?o^k^koj^[Yom?CdolM>1go
=88dodNE7OmJYA_oJJdZ0_md^3P0i?me^CSoJk4[oe^W7?m8VQgo=88doadh7OoCdm?oj^[Yonk^k_o`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l0;okno_0?ooj^[ZoginOOlL71coj>SXong]
kOn8R8So<30`o`l?3ola<C7o/K6`onk^k_n5QHGoCDe=ono_koo^k^kokno_ohZ:R_mIFEWok^k^ogQh
N?l[:b_o3`l?ocPh>?no_kookNg]onCThol>3PkoJFUYomoOgooShn?oiNGUon_[jomQHF7oMgMfonk^
k_o_knooMWIfobHV9_o]kNgokno_olc<c?l/;2coj^[Zofe]KOmRHV;ok>c/ong]kOlk>c_oTi>Cof9R
H_l>3Pko=3@dolC4a?o_knook^k^om7AdOll?3co2PX:obLW9om/K6co;2`/ono_koo^k^kol?3`ono_
koo`l>ookno_oo3`l?o_knool?3`onk^k_o`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knl005Sol?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_0_o`l?06ono_k`7olo?c0OoinOT1ookn
oP0000?oo_knooOgmoo`l?001?oYjNT04OoWinOofm_Kof=;Bon1<S;oYSDeokHd;Oo2CD7o`eA9olAE
B_o3E4Wo`Te1okHd;OnU=CGoPC8bof=;BooKfm_oinOW00GojNWY017oinOWom_Kfon9Bd_o[d/boleg
=OoFRbgoh9`^on2P<_oQX3Coh:0bomnJ;_oFRbgobWDeojm;<_n9Bd_ofm_KonOWi`05onWYj@0AonOW
iooKfm_oBd];oc9P<_ljRCGoDi/]of^[;om`[CSoKjhjog2]>?mZZRooDi/]ocV8=OlbH3;oBd];om_K
fooWinL0gOoYjNT01_oXj>Soi^KVog]kNolL71coi>CTonSXj0;ojNWY00?oinOWonWYjOoYjNT02ooY
jNT03?oWinOojNWYonWYjOoXj>Sof=SHo`X:2_n^[ZkogMgMomkNg_oPh>3oiNGUonSXj0SojNWY00Ko
j>SXonKVi_oShn?ohn?SonKVi_oXj>P3onWYj@03onSXj?oYjNWojNWY00CojNWY00?oinOWonWYjOoY
jNT03ooYjNT00ooXj>SojNWYonWYj@3oonWYj@_ojNWY00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07o
moOg0Oono_h00005ookno_ojn_[om?Cdono_kooalO400_o`l?004Oo_knoojn_[oiFDU?m?8b?oUEAD
ok]cLooCUIGofYbLomZNW?oIW9coe9FEok]cLonEE5CoCb<SoiFDU?oZj^[okno_00Gol?3`017okno_
on[Zj_nYU9CoPB<SokYZE?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S8onZU9Coj^[Z
ono_k`05oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCoLjEcoik6UOn/cYco[LjLojc>W?nNaYGoLjEc
oeAjE?lS:R?oU9BDon[Zj_o_knl0gOo`l?02ono_k`04oh20P?lM7Agok^k^ono_ka?ol?3`0_o_knl0
1omTI6Co:BTYoh61POmSHf?o>c/konk^k_o_knl02?o`l?001_o_knook^k^og=cLomYJFWok^k^ono_
koool?3`;oo`l?001?oalO7ol?3`ooCdm?ojn_X1ooknoP0000Cono_kooooooooooooo_kn0_ooool2
ooknoP3ooogmoOohn?SoKVi^oeXo?onaT93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSloofe]KOoh
n?Soo?clooooooono_koooooookno_ooookoo_knooooooolo?con?Shohe]KOn:?coobI6@onW@bOod
jNCom^_VooCYi?oYd<WobI6@ohTo?on=KFgon?Sgooclo?ooooooo_knooooooono_koooooookno_oo
ookoo?clooShn?m]KFgo?clooi2MT?o9eLWoi>cTonK^i_oTk>CobMG9oi2MT?lo?cooKFe]ooShn?ol
o?coooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_kn000Nooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooooogm
oOo@d<ooYJFU0_ono_h06_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_omoOgo`L71og5aLOn1PH7o[jn_
0_ono_h03?ooookoo_knooooooono_koooooookno_ooooooo_knooooo_omoOgo`/;2okbl_0;oo_kn
0?ooooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ool002_oo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn00;o
oooo00?oo_knooooooooool00oooool1onc^l00000ColO;cookno_oinOWom?Cd1OoalO403Oo_knoo
e]KFof][Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?CgoJf][omKFe_o_knl02OoalO403Oo_knoo
emKFoh=[Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<S?mb?CgoPF][omOFe_o_knl02OoalO403Oo_knoo
e]KFof][Jolm?CgoS8b<okZj^_o<cLco^[Zjohb<S?lm?CgoJf][omKFe_o_knl0oooalO7ooo7alCSo
lO7a00Col?3`oo7alOoalO7ol?3`1?oalO400oodm?Con_[jooknoP01ol38d00000GohnGWoogmoOoh
n?Sol?3`on_[j`03on[ZjP0=onWYjOoZj^[ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnK
Vi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoX9^KofYIFOm39RKo;@T9od8V9_mYFEWoX9^KonSXj?oY
jNT02ooZj^X02ooYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY0?ooj^[Z
;_oZj^X00ooYjNWoj^[Zon[ZjP3oon[ZjPooj^[Z00Cojn_[oo3`l?ohn?SooOgm0On2TYl00004ojRZ
[Oo_l?7on_[jooCdm0SolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`l?0?oo7al@;o
l?3`0oo_knl2oo3`l?oolO7aoooalO4noo7al@03oo3`l?oalO7olO7a00;olO7a00?omOGeooWinOnk
`lT00OljBUP00003ojV/[on_/K?ok^o`0?oooooooooooon0ooooo`7o^l?90Om@GfX1ob8gB@0000Ko
`lK:ojb^/OnUZ:[of]cNoo3bloojno_oooooooooooooN_ooool01Oo/k_3o`LO=oh>@W?liBECo8SM6
007o9SiA0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{644, 480},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
Defaut color is assigned at the initialization of the \
chooser.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(JavaShow[frame]\), "\[IndentingNewLine]", 
    \(\(or = java`awt`Color`orange;\)\), "\[IndentingNewLine]", 
    \(ch = NewJColorChooser[pane, or]\), "\[IndentingNewLine]", 
    \(ReleaseObject[or]\), "\[IndentingNewLine]", 
    \(pane@repaint[]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JColorChooser"] \[RightGuillemet]\),
      JLink`Objects`JavaObject124492697305089]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[TextData[{
  "To get a resulting color chosen by the user, ",
  StyleBox["getColor[]",
    FontWeight->"Bold"],
  " etc are prepared."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(cl = ch@getColor[]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.awt.Color"] \[RightGuillemet]\),
      JLink`Objects`JavaObject240518168577]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(cl@getRed[]\), "\[IndentingNewLine]", 
    \(cl@getGreen[]\), "\[IndentingNewLine]", 
    \(cl@getBlue[]\)}], "Input"],

Cell[BoxData[
    \(255\)], "Output"],

Cell[BoxData[
    \(200\)], "Output"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(ReleaseObject[cl]\)], "Input"],

Cell[BoxData[
    \(DeleteJObject[pane, ch]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["ShowColorChooser ", "Subsection"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006e0001UaP00`40o`00
0?l0003oo`000;H000000003R<2hB928B9280?m8T8RbB9280@00000000>8
`;S8h=R8`;P0ohS0^;68`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^;68
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<[/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<[/c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<[/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<[/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<[/c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<[/c<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Qcc<c<<_ooo`K<c<a8oooo1/c<c4;ooombc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^7;<c<`00fIVI/c<c6IVIP0_
IVIV00?oooo<c<c<c<`00lc<c003IVIVc<c<IVIV04EVIVH00oooolc<c<c<
c003c<c<00=VIVK<c<aVIVH0?fIVIP03ooooc<c<c<c<073<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hL/c<c003IVIVooooc<c<02k<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0A<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c00nc<c<00=VIVKoooo<c<`0LLc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Qbc<c<00=VIVKoooo<c<`0;/c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c014c<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<03k<c<`00fIVI_ooolc<c01ac<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^7;<c<`00fIVI_ooolc<c00^c<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<04C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0?/c<
c003IVIVooooc<c<077<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
L/c<c003IVIVooooc<c<02k<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0A<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00nc<c<00=VIVKo
ooo<c<`0LLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qbc<c<00=V
IVKoooo<c<`0;/c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c014c<c<
00=VIVKoooo<c<`01<c<c003IVIVooooc<c<03k<c<`00fIVI_ooolc<c01a
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^7;<c<`00fIVI_ooolc<
c00^c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<04C<c<`00fIVI_oo
olc<c004c<c<00=VIVKoooo<c<`0?/c<c003IVIVooooc<c<077<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2hL/c<c003IVIVooooc<c<013<c<`4
00000lc<c0800003c<c<0P00013<c<`00fIVI_ooolc<c004c<c<00=VIVKo
ooo<c<`04<c<c0@00003c<c<1@000003c<c<0000000000;<c<`200000/c<
c0@00003c<c<100000;<c<`200004<c<c003IVIVooooc<c<00C<c<`00fIV
I_ooolc<c00>c<c<0P0000C<c<`2000000?<c<`0000000000P0000?<c<`4
00000lc<c0@00003c<c<0P00013<c<`00fIVI_ooolc<c01ac<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^7;<c<`00fIVI_ooolc<c00?c<c<0P00
00;<c<`200000/c<c0800003c<c<0P00013<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`03lc<c0800002c<c<0P000003c<c<0000000000;<c<`2
000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P000003
c<c<0000000000;<c<`2000000?<c<`0000000004<c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c00>c<c<0P0000?<c<`2000000?<c<`000000000
0/c<c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<c<`2
000000?<c<`0000000004Lc<c003IVIVooooc<c<077<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2hL/c<c003IVIVooooc<c<00k<c<`200001<c<
c08000000lc<c00000000002c<c<0P00017<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`03/c<c0800006c<c<0P0000;<c<`2000000?<c<`00000
00000/c<c08000000lc<c00000000005c<c<0P0000G<c<`200004<c<c003
IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<0P0000?<c<`2000000?<
c<`0000000002<c<c0<000000lc<c00000000005c<c<0P00017<c<`00fIV
I_ooolc<c01ac<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^7;<c<`0
0fIVI_ooolc<c00>c<c<0P0000C<c<`2000000?<c<`0000000000/c<c080
000Ac<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`200001lc<
c08000001<c<c00000000<c<c0800002c<c<0P000003c<c<0000000000G<
c<`6000000?<c<`0000000004<c<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c00>c<c<0P0000;<c<`200000/c<c0H00002c<c<100000;<c<`60000
00?<c<`0000000004Lc<c003IVIVooooc<c<077<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hL/c<c003IVIVooooc<c<00k<c<`200001<c<c080
00000lc<c0000000000400004Lc<c003IVIVooooc<c<00C<c<`00fIVI_oo
olc<c00>c<c<0P0000S<c<`4000000?<c<`0000000000/c<c08000000lc<
c00000000005c<c<0P0000;<c<`2000000?<c<`0000000004<c<c003IVIV
ooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<1P0000;<c<`200000/c<c080
00001<c<c0000000000000C<c<`200000/c<c08000000lc<c0000000000A
c<c<00=VIVKoooo<c<`0LLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Qbc<c<00=VIVKoooo<c<`03/c<c0800004c<c<0P000003c<c<00000000
00<0000Bc<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`20000
1/c<c0040000c<c<c<c<c<c<0P000005c<c<000000000000c<c<00800000
0lc<c00000000002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0
000000004<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00>c<c<0P00
00?<c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<
0P000003c<c<0000000000;<c<`2000000?<c<`0000000004Lc<c003IVIV
ooooc<c<077<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hL/c<c003
IVIVooooc<c<00k<c<`200001<c<c08000001<c<c00000000<c<c080000B
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00k<c<`200001lc<c0@0
0002c<c<0P000003c<c<0000000000?<c<`400000lc<c0@00002c<c<0P00
013<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`03/c<c0800003c<c<
0P0000;<c<`400000lc<c0@00003c<c<10000003c<c<000000000080000@
c<c<00=VIVKoooo<c<`0LLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Qbc<c<00=VIVKoooo<c<`03lc<c0800002c<c<0P0000;<c<`200000/c<
c080000Ac<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<00o<c<`20000
0/c<c080000Mc<c<0P00013<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`03/c<c0800003c<c<0P0001K<c<`200004Lc<c003IVIVooooc<c<077<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hL/c<c003IVIVooooc<c<
013<c<`400000lc<c0800003c<c<0P00013<c<`00fIVI_ooolc<c004c<c<
00=VIVKoooo<c<`04<c<c0@0000Nc<c<0P00013<c<`00fIVI_ooolc<c004
c<c<00=VIVKoooo<c<`03/c<c0H0000Hc<c<00<0003<c<c<c<`03lc<c003
IVIVooooc<c<077<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hL/c<
c003IVIVooooc<c<02k<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0
A<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00nc<c<00=VIVKoooo<
c<`0LLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qbc<c<00=VIVKo
ooo<c<`0;/c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c014c<c<00=V
IVKoooo<c<`01<c<c003IVIVooooc<c<03k<c<`00fIVI_ooolc<c01ac<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^7;<c<`00fIVI_ooolc<c00^
c<c<00=VIVKoooo<c<`01<c<c003IVIVooooc<c<04C<c<`00fIVI_ooolc<
c004c<c<00=VIVKoooo<c<`0?/c<c003IVIVooooc<c<077<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2hL/c<c003IVIVooooc<c<02k<c<`00fIV
I_ooolc<c004c<c<00=VIVKoooo<c<`0A<c<c003IVIVooooc<c<00C<c<`0
0fIVI_ooolc<c00nc<c<00=VIVKoooo<c<`0LLc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;Qbc<c<00=VIVKoooo<c<`0;/c<c003IVIVooooc<c<
00C<c<`00fIVI_ooolc<c014c<c<00=VIVKoooo<c<`01<c<c003IVIVoooo
c<c<03k<c<`00fIVI_ooolc<c01ac<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^7;<c<`00fIVI_ooolc<c00^c<c<00=VIVKoooo<c<`01<c<c003
IVIVooooc<c<04C<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<c<`0?/c<
c003IVIVooooc<c<077<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
L/c<c003IVIVooooc<c<02k<c<`00fIVI_ooolc<c004c<c<00=VIVKoooo<
c<`0A<c<c003IVIVooooc<c<00C<c<`00fIVI_ooolc<c00nc<c<00=VIVKo
ooo<c<`0LLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Qbc<c<00=V
IVKoooooool0;_ooo`03c<c<ooooc<c<00C<c<`00fIVI_ooooooo`14oooo
00?<c<coooo<c<`01<c<c003IVIVoooooooo03koool00lc<c?ooolc<c01a
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^7;<c<`bIVIV1/c<c4QV
IVH6c<c<@VIVIW?<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c:k<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c:k<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c:k<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2holc<c:k<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2holc<c:k<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<
c:k<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c:k<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2holc<c:k<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c?nIVIVZVIVI0/c<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c:K<c<`00iVIVLc<
c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<
c<c<0?o<c<bVc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<Y/c<c003VIVIc<c<c<c<00:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<
c:K<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<0?o<c<bVc<c<00>IVIW<c<c<c<`00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c01oc<c<b?oooek<
c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<07o<c<c8ooooG/c<c003VIVIc<c<c<c<00:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0Olc<c0Goool3
gaLG1oooo`?O5aL:oooo0mlG5`Ooool00mlG5oooooooo`02oooo0]lG5`So
ool2gaLG3Oooo`03gaLGoooooooo00?oool2gaLG1oooo`03gaLGoooooooo
00Coool00mlG5oooooooo`0;oooo0mlG5`Ooool3gaLG2_ooo`?O5aL7oooo
00?O5aOoooooool00_ooo`;O5aL8oooo0]lG5`goool00mlG5oooooooo`03
oooo0]lG5`Ooool00mlG5oooooooo`04oooo00?O5aOoooooool02?oooek<
c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<07o<c<`8oooo00?O5aOoooooool01oooo`;O5aL;oooo
0]lG5`Koool01mlG5oooooooooooomlG5oooomlG5`09oooo00?O5aOooooo
ool02_ooo`03gaLGoooooooo00Goool00mlG5oooooooo`03oooo00?O5aOo
ooooool01Oooo`03gaLGoooooooo00koool00mlG5oooooooo`07oooo0]lG
5`_oool2gaLG1_ooo`07gaLGoooooooooooogaLGoooogaLG00Woool00mlG
5oooooooo`0:oooo00?O5aOoooooool01Oooo`03gaLGoooooooo00?oool0
0mlG5oooooooo`05oooo00?O5aOoooooool02?oooek<c<`00iVIVLc<c<c<
c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<
07o<c<`9oooo00?O5aOoooooool02?ooo`03gaLGoooooooo00[oool00mlG
5oooooooo`03oooo00GO5aOooooooooooooO5aL00_ooo`03gaLGoooooooo
00Ooool00mlG5oooooooo`09oooo00?O5aOoooooool01_ooo`05gaLGoooo
oooooooogaLG00Soool00mlG5oooooooo`0?oooo00?O5aOoooooool02?oo
o`03gaLGoooooooo00[oool00mlG5oooooooo`03oooo00GO5aOooooooooo
oooO5aL00_ooo`03gaLGoooooooo00Ooool00mlG5oooooooo`09oooo00?O
5aOoooooool01_ooo`05gaLGoooooooooooogaLG00Soool00mlG5ooooooo
o`08ooooG/c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<c1WO5aL5c<c<6Oooo`G<c<`I0000
1Lc<c0Woool00mlG5oooooooo`09oooo00?O5aOoooooool02_ooo`03gaLG
oooooooo00?oool01=lG5oooooooomlG5`?oool00mlG5oooooooo`06oooo
00?O5aOoooooool02Oooo`03gaLGoooooooo00Ooool00mlG5oooomlG5`09
oooo00?O5aOoooooool03oooo`03gaLGoooooooo00Woool00mlG5ooooooo
o`0:oooo00?O5aOoooooool00oooo`04gaLGoooooooogaLG0oooo`03gaLG
oooooooo00Koool00mlG5oooooooo`09oooo00?O5aOoooooool01oooo`03
gaLGoooogaLG00Woool00mlG5oooooooo`08ooooG/c<c003VIVIc<c<c<c<
00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0
9Lc<c1WO5aL5c<c<6Oooo`G<c<`I00001Lc<c0Coool00mlG5oooooooo`02
oooo00?O5aOoooooool02_ooo`03gaLGoooooooo00Woool00mlG5ooooooo
o`03oooo00CO5aOooooooooO5aL4oooo00?O5aOoooooool01Oooo`03gaLG
oooooooo00?oool;gaLG1_ooo`03gaLGoooooooo00Soool00mlG5ooooooo
o`0:oooo00?O5aOoooooool00_ooo`03gaLGoooooooo00[oool00mlG5ooo
ooooo`09oooo00?O5aOoooooool00oooo`04gaLGoooooooogaLG1?ooo`03
gaLGoooooooo00Goool00mlG5oooooooo`03oooo2mlG5`Koool00mlG5ooo
ooooo`08oooo00?O5aOoooooool02?ooo`G<c<`bgaLG9lc<c003VIVIc<c<
c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<
c<`09Lc<c1WO5aL5c<c<6Oooo`G<c<`I00001Lc<c0Coool00mlG5ooooooo
o`02oooo00?O5aOoooooool02oooo`03gaLGoooooooo00Woool00mlG5ooo
ooooo`02oooo00CO5aOooooooooO5aL4oooo00?O5aOoooooool01Oooo`03
gaLGoooooooo00Soool00mlG5oooooooo`0:oooo00?O5aOoooooool01ooo
o`03gaLGoooooooo00;O5aL8oooo00?O5aOoooooool00_ooo`03gaLGoooo
oooo00_oool00mlG5oooooooo`09oooo00?O5aOoooooool00_ooo`04gaLG
oooooooogaLG1?ooo`03gaLGoooooooo00Goool00mlG5oooooooo`08oooo
00?O5aOoooooool02_ooo`03gaLGoooooooo00Ooool00mlG5oooooooo`02
gaLG1_ooo`G<c<`bgaLG9lc<c003VIVIc<c<c<c<00:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<c1WO5aL5c<c<6Ooo
o`G<c<`I00001Lc<c0Coool00mlG5oooooooo`02oooo00?O5aOoooooool0
2oooo`03gaLGoooooooo00Woool00mlG5oooooooo`02oooo00CO5aOooooo
oooO5aL7oooo2]lG5`Koool00mlG5oooooooo`0:oooo00?O5aOoooooool0
1oooo`?O5aL:oooo00?O5aOoooooool00_ooo`03gaLGoooooooo00_oool0
0mlG5oooooooo`09oooo00?O5aOoooooool00_ooo`04gaLGoooooooogaLG
1oooo`[O5aL6oooo00?O5aOoooooool02_ooo`03gaLGoooooooo00Ooool3
gaLG2?ooo`G<c<`bgaLG9lc<c003VIVIc<c<c<c<00:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<c1WO5aL5c<c<6Ooo
o`G<c<`I00001Lc<c0;oool;gaLG2_ooo`04gaLGoooooooooooo2MlG5`Co
ool01=lG5oooooooomlG5a?oool9gaLG2Oooo`03gaLGoooooooo00Koool0
0mlG5oooooooo`08oooo2mlG5`[oool01=lG5oooooooooooo`WO5aL4oooo
00CO5aOooooooooO5aLCoooo2MlG5`Woool00mlG5oooooooo`06oooo00?O
5aOoooooool02?ooo`G<c<`bgaLG9lc<c003VIVIc<c<c<c<00:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<c1WO5aL5
c<c<1Oooo`oO5aL5oooo1Lc<c0D0000?gaLG1@0000G<c<`4oooo00?O5aOo
ooooool00_ooo`03gaLGoooooooo00Goool00mlG5oooooooo`0?oooo00?O
5aOoooooool00_ooo`04gaLGoooooooogaLG5oooo`03gaLGoooooooo00_o
ool00mlG5oooooooo`06oooo00?O5aOoooooool02_ooo`03gaLGoooooooo
00;oool00mlG5oooooooo`05oooo00?O5aOoooooool03oooo`03gaLGoooo
oooo00;oool01=lG5oooooooomlG5aOoool00mlG5oooooooo`0;oooo00?O
5aOoooooool01_ooo`03gaLGoooooooo00Soool5c<c<<]lG5bO<c<`00iVI
VLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVI
c<c<c<c<02G<c<`IgaLG1Lc<c0Goool?gaLG1Oooo`G<c<`500003mlG5`D0
0005c<c<1?ooo`03gaLGoooooooo00;oool00mlG5oooooooo`03oooo0]lG
5a7oool00mlG5oooomlG5`06oooo00?O5aOoooooool01_ooo`SO5aL7oooo
00?O5aOoooooool01Oooo`OO5aL8oooo00?O5aOoooooool02_ooo`03gaLG
oooooooo00;oool00mlG5oooooooo`03oooo0]lG5a7oool00mlG5oooomlG
5`06oooo00?O5aOoooooool01_ooo`SO5aL7oooo00?O5aOoooooool01Ooo
o`OO5aL8oooo00?O5aOoooooool02?ooo`G<c<`bgaLG9lc<c003VIVIc<c<
c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<
c<`09Lc<c1WO5aL5c<c<1Oooo`oO5aL5oooo1Lc<c0D0000?gaLG1@0000G<
c<`Soooo00?O5aOoooooool07Oooo`03gaLGoooooooo01Coool00mlG5ooo
ooooo`0Yoooo00?O5aOoooooool07Oooo`03gaLGoooooooo01Coool00mlG
5oooooooo`08oooo1Lc<c3;O5aLWc<c<00>IVIW<c<c<c<`00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c00Uc<c<6MlG5`G<
c<`5oooo3mlG5`Goool5c<c<1@0000oO5aL500001Lc<c<Soool5c<c<<]lG
5bO<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0/c<c003VIVIc<c<c<c<02G<c<`IgaLG1Lc<c0Goool?gaLG1Oooo`G<c<`5
00003mlG5`D00005c<c<b?ooo`G<c<`bgaLG9lc<c003VIVIc<c<c<c<00:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<
c1WO5aL5c<c<1Oooo`oO5aL5oooo1Lc<c0D0000?gaLG1@0000G<c<c8oooo
1Lc<c3;O5aLWc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c00Uc<c<6MlG5`G<c<`5oooo3mlG5`Go
ool5c<c<1@0000oO5aL500001Lc<c<Soool5c<c<<]lG5bO<c<`00iVIVLc<
c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<
c<c<02G<c<`IgaLG1Lc<c0Goool?gaLG1Oooo`G<c<`500003mlG5`D00005
c<c<b?ooo`G<c<`bgaLG9lc<c003VIVIc<c<c<c<00:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<c1WO5aL5c<c<1Ooo
o`oO5aL5oooo1Lc<c0D0000?gaLG1@000=;<c<`bgaLG9lc<c003VIVIc<c<
c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<
c<`09Lc<c1WO5aL5c<c<1Oooo`oO5aL5oooo1Lc<c0D0000?gaLG1@000=;<
c<`bgaLG9lc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<c1WO5aL5c<c<1Oooo`oO5aL5oooo
1Lc<c0D0000?gaLG1@000=;<c<`bgaLG9lc<c003VIVIc<c<c<c<00:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<c1WO
5aL5c<c<1Oooo`oO5aL5oooo1Lc<c0D0000?gaLG1@0000G<c<c8gaLG1Lc<
c3;O5aLWc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00iVIVLc<c<c<c00Uc<c<6MlG5`G<c<`5oooo3mlG5`Goool5
c<c<1@0000oO5aL500001Lc<c<SO5aL5c<c<<]lG5bO<c<`00iVIVLc<c<c<
c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<
02G<c<`IgaLG1Lc<c0Goool?gaLG1Oooo`G<c<`500003mlG5`D00005c<c<
1MlG5`<00007gaLG0`0000[O5aL300001mlG5`030000gaLGgaLG00;O5aL2
00002=lG5`80000=gaLG00<0003O5aOO5aL00mlG5`800007gaLG00<0003O
5aOO5aL01=lG5`030000gaLGgaLG00_O5aL300001mlG5`<0000:gaLG0`00
00OO5aL00`000=lG5mlG5`02gaLG0P0000SO5aL200003MlG5`030000gaLG
gaLG00?O5aL200001mlG5`030000gaLGgaLG00CO5aL00`000=lG5mlG5`08
gaLG1Lc<c3;O5aLWc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c00Uc<c<6MlG5`G<c<`5oooo3mlG
5`Goool5c<c<1@0000oO5aL500001Lc<c0SO5aL00`000=lG5mlG5`07gaLG
0P0000_O5aL200001]lG5`070000gaLGgaLGgaLG0000gaLG000000WO5aL0
0`000=lG5mlG5`0:gaLG00<0003O5aOO5aL01MlG5`030000gaLGgaLG00?O
5aL00`000=lG5mlG5`05gaLG00<0003O5aOO5aL03]lG5`030000gaLGgaLG
00OO5aL200002mlG5`800006gaLG00L0003O5aOO5aOO5aL0003O5aL00000
2MlG5`030000gaLGgaLG00[O5aL00`000=lG5mlG5`05gaLG00<0003O5aOO
5aL00mlG5`030000gaLGgaLG00GO5aL00`000=lG5mlG5`08gaLG1Lc<c3;O
5aLWc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0
^0;<c<`00iVIVLc<c<c<c00Uc<c<6MlG5`G<c<`Ioooo1Lc<c1T00005c<c<
2MlG5`030000gaLGgaLG00SO5aL00`000=lG5mlG5`0:gaLG00<0003O5aOO
5aL00mlG5`050000gaLGgaLGgaLG000000;O5aL00`000=lG5mlG5`07gaLG
00<0003O5aOO5aL02MlG5`030000gaLGgaLG00KO5aL01@000=lG5mlG5mlG
5`000008gaLG00<0003O5aOO5aL03mlG5`030000gaLGgaLG00SO5aL00`00
0=lG5mlG5`0:gaLG00<0003O5aOO5aL00mlG5`050000gaLGgaLGgaLG0000
00;O5aL00`000=lG5mlG5`07gaLG00<0003O5aOO5aL02MlG5`030000gaLG
gaLG00KO5aL01@000=lG5mlG5mlG5`000008gaLG00<0003O5aOO5aL02=lG
5`G<c<`bgaLG9lc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<c1WO5aL5c<c<6Oooo`G<c<`I
00001Lc<c0WO5aL00`000=lG5mlG5`09gaLG00<0003O5aOO5aL02]lG5`03
0000gaLGgaLG00?O5aL010000=lG5mlG5`0000?O5aL00`000=lG5mlG5`06
gaLG00<0003O5aOO5aL02MlG5`030000gaLGgaLG00OO5aL00`000=lG5`00
0009gaLG00<0003O5aOO5aL03mlG5`030000gaLGgaLG00WO5aL00`000=lG
5mlG5`0:gaLG00<0003O5aOO5aL00mlG5`040000gaLGgaLG00000mlG5`03
0000gaLGgaLG00KO5aL00`000=lG5mlG5`09gaLG00<0003O5aOO5aL01mlG
5`030000gaLG000000WO5aL00`000=lG5mlG5`08gaLG1Lc<c3;O5aLWc<c<
00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0iVIVLc<c<c<c00Uc<c<6MlG5`G<c<`Ioooo1Lc<c1T00005c<c<1=lG5`03
0000gaLGgaLG00;O5aL00`000=lG5mlG5`0:gaLG00<0003O5aOO5aL02MlG
5`030000gaLGgaLG00?O5aL010000=lG5mlG5`0000CO5aL00`000=lG5mlG
5`05gaLG00<0003O5aOO5aL00mlG5`/00006gaLG00<0003O5aOO5aL02=lG
5`030000gaLGgaLG00[O5aL00`000=lG5mlG5`02gaLG00<0003O5aOO5aL0
2]lG5`030000gaLGgaLG00WO5aL00`000=lG5mlG5`03gaLG00@0003O5aOO
5aL00004gaLG00<0003O5aOO5aL01MlG5`030000gaLGgaLG00?O5aL;0000
1]lG5`030000gaLGgaLG00SO5aL00`000=lG5mlG5`08gaLG1Lc<c3;O5aLW
c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c00Uc<c<6MlG5`G<c<`Ioooo1Lc<c1T00005c<c<1=lG
5`030000gaLGgaLG00;O5aL00`000=lG5mlG5`0;gaLG00<0003O5aOO5aL0
2MlG5`030000gaLGgaLG00;O5aL010000=lG5mlG5`0000CO5aL00`000=lG
5mlG5`05gaLG00<0003O5aOO5aL02=lG5`030000gaLGgaLG00[O5aL00`00
0=lG5mlG5`07gaLG00<0003O5aOO5aL00P0000SO5aL00`000=lG5mlG5`02
gaLG00<0003O5aOO5aL02mlG5`030000gaLGgaLG00WO5aL00`000=lG5mlG
5`02gaLG00@0003O5aOO5aL00004gaLG00<0003O5aOO5aL01MlG5`030000
gaLGgaLG00SO5aL00`000=lG5mlG5`0:gaLG00<0003O5aOO5aL01mlG5`03
0000gaLGgaLG00800006gaLG1Lc<c3;O5aLWc<c<00>IVIW<c<c<c<`00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c00Uc<c<
6MlG5`G<c<`Ioooo1Lc<c1T00005c<c<1=lG5`030000gaLGgaLG00;O5aL0
0`000=lG5mlG5`0;gaLG00<0003O5aOO5aL02MlG5`030000gaLGgaLG00;O
5aL010000=lG5mlG5`0000OO5aL:00001]lG5`030000gaLGgaLG00[O5aL0
0`000=lG5mlG5`07gaLG0`0000[O5aL00`000=lG5mlG5`02gaLG00<0003O
5aOO5aL02mlG5`030000gaLGgaLG00WO5aL00`000=lG5mlG5`02gaLG00@0
003O5aOO5aL00007gaLG2P0000KO5aL00`000=lG5mlG5`0:gaLG00<0003O
5aOO5aL01mlG5`<00008gaLG1Lc<c3;O5aLWc<c<00>IVIW<c<c<c<`00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c01oc<c<
0]lG5`/0000:gaLG00@0003O5aOO5aOO5aL900001=lG5`040000gaLGgaLG
00004mlG5`T00009gaLG00<0003O5aOO5aL01]lG5`030000gaLGgaLG00SO
5aL;00002]lG5`040000gaLGgaLGgaLG2@0000CO5aL010000=lG5mlG5`00
01?O5aL900002MlG5`030000gaLGgaLG00KO5aL00`000=lG5mlG5`08gaLG
1Lc<c3;O5aLWc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c01oc<c<1=lG5`030000gaLGgaLG00;O
5aL00`000=lG5mlG5`05gaLG00<0003O5aOO5aL03mlG5`030000gaLGgaLG
00;O5aL010000=lG5mlG5`0001OO5aL00`000=lG5mlG5`0;gaLG00<0003O
5aOO5aL01]lG5`030000gaLGgaLG00[O5aL00`000=lG5mlG5`02gaLG00<0
003O5aOO5aL01MlG5`030000gaLGgaLG00oO5aL00`000=lG5mlG5`02gaLG
00@0003O5aOO5aL0000GgaLG00<0003O5aOO5aL02mlG5`030000gaLGgaLG
00KO5aL00`000=lG5mlG5`08gaLG1Lc<c3;O5aLWc<c<00>IVIW<c<c<c<`0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c01o
c<c<1=lG5`030000gaLGgaLG00;O5aL00`000=lG5mlG5`03gaLG0P00017O
5aL00`000=lG5`000006gaLG00<0003O5aOO5aL01]lG5`P00007gaLG00<0
003O5aOO5aL01MlG5`L00008gaLG00<0003O5aOO5aL02]lG5`030000gaLG
gaLG00;O5aL00`000=lG5mlG5`03gaLG0P00017O5aL00`000=lG5`000006
gaLG00<0003O5aOO5aL01]lG5`P00007gaLG00<0003O5aOO5aL01MlG5`L0
0008gaLG00<0003O5aOO5aL02=lG5`G<c<`bgaLG9lc<c003VIVIc<c<c<c<
00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`0
Olc<c2?O5aL00`000=lG5mlG5`0MgaLG00<0003O5aOO5aL05=lG5`030000
gaLGgaLG02WO5aL00`000=lG5mlG5`0MgaLG00<0003O5aOO5aL05=lG5`03
0000gaLGgaLG00SO5aL5c<c<<P0002O<c<`00iVIVLc<c<c<c002R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<07o<c<c8gaLG
1Lc<c380000Wc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c00Uc<c<6Oooo`G<c<`I00001Lc<c1Wo
ool5c<c<b=lG5`G<c<`b00009lc<c003VIVIc<c<c<c<00:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<c1Woool5c<c<
6@0000G<c<`Ioooo1Lc<c<SO5aL5c<c<<P0002O<c<`00iVIVLc<c<c<c002
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<02G<
c<`Ioooo1Lc<c1T00005c<c<6Oooo`G<c<c8gaLG1Lc<c380000Wc<c<00>I
VIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c00Uc<c<6Oooo`G<c<`I00001Lc<c1Woool5c<c<b=lG5`G<c<`b
00009lc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00>IVIW<c<c<c<`09Lc<c1Woool5c<c<6@0000G<c<`Iooood/c<
c380000Wc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0
^8S0^0;<c<`00iVIVLc<c<c<c00Uc<c<1Oooo`oO5aL5oooo1Lc<c0D0000?
gaLG1@0000G<c<`5oooo3mlG5`GooooBc<c<<P0002O<c<`00iVIVLc<c<c<
c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<
02G<c<`5oooo3mlG5`Goool5c<c<1@0000oO5aL500001Lc<c0Goool?gaLG
1Oooom;<c<`b00009lc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<c0Goool?gaLG1Oooo`G<
c<`500003mlG5`D00005c<c<1Oooo`oO5aL5ooood/c<c380000Wc<c<00>I
VIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVI
VLc<c<c<c00Uc<c<1Oooo`oO5aL5oooo1Lc<c0D0000?gaLG1@0000G<c<`5
oooo3mlG5`GooooBc<c<<P0002O<c<`00iVIVLc<c<c<c002R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<02G<c<`5oooo3mlG
5`Goool5c<c<1@0000oO5aL500001Lc<c0Goool?gaLG1Oooo`[<c<`3gaLG
1lc<c0?O5aL:c<c<0mlG5`O<c<`00mlG5lc<c<c<c002c<c<0]lG5`S<c<`2
gaLG3Lc<c003gaLGc<c<c<c<00?<c<`2gaLG1lc<c003gaLGc<c<c<c<00C<
c<`00mlG5lc<c<c<c00;c<c<0mlG5`O<c<`3gaLG2/c<c0?O5aL7c<c<00?O
5aO<c<c<c<`00/c<c0;O5aL8c<c<0]lG5`g<c<`00mlG5lc<c<c<c003c<c<
0]lG5`O<c<`00mlG5lc<c<c<c004c<c<00?O5aO<c<c<c<`03Lc<c380000W
c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c00Uc<c<1Oooo`GO5aL5oooo1MlG5`Goool5c<c<1@00
00GO5aL5oooo1MlG5`D00005c<c<1Oooo`GO5aL500001MlG5`Goool=c<c<
00?O5aO<c<c<c<`01lc<c0;O5aL;c<c<0]lG5`K<c<`01mlG5lc<c<c<c<c<
c=lG5lc<c=lG5`09c<c<00?O5aO<c<c<c<`02/c<c003gaLGc<c<c<c<00G<
c<`00mlG5lc<c<c<c003c<c<00?O5aO<c<c<c<`01Lc<c003gaLGc<c<c<c<
00k<c<`00mlG5lc<c<c<c007c<c<0]lG5`_<c<`2gaLG1/c<c007gaLGc<c<
c<c<c<c<gaLGc<c<gaLG00W<c<`00mlG5lc<c<c<c00:c<c<00?O5aO<c<c<
c<`01Lc<c003gaLGc<c<c<c<00?<c<`00mlG5lc<c<c<c005c<c<00?O5aO<
c<c<c<`03Lc<c380000Wc<c<00>IVIW<c<c<c<`00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c00Uc<c<1Oooo`GO5aL5oooo
1MlG5`Goool5c<c<1@0000GO5aL5oooo1MlG5`D00005c<c<1Oooo`GO5aL5
00001MlG5`Goool>c<c<00?O5aO<c<c<c<`02<c<c003gaLGc<c<c<c<00[<
c<`00mlG5lc<c<c<c003c<c<00GO5aO<c<c<c<c<c<cO5aL00/c<c003gaLG
c<c<c<c<00O<c<`00mlG5lc<c<c<c009c<c<00?O5aO<c<c<c<`01/c<c005
gaLGc<c<c<c<c<c<gaLG00S<c<`00mlG5lc<c<c<c00?c<c<00?O5aO<c<c<
c<`02<c<c003gaLGc<c<c<c<00[<c<`00mlG5lc<c<c<c003c<c<00GO5aO<
c<c<c<c<c<cO5aL00/c<c003gaLGc<c<c<c<00O<c<`00mlG5lc<c<c<c009
c<c<00?O5aO<c<c<c<`01/c<c005gaLGc<c<c<c<c<c<gaLG00S<c<`00mlG
5lc<c<c<c00=c<c<<P0002O<c<`00iVIVLc<c<c<c002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<02G<c<`5oooo1MlG5`Go
ool5gaLG1Oooo`G<c<`500001MlG5`Goool5gaLG1@0000G<c<`5oooo1MlG
5`D00005gaLG1Oooo`k<c<`00mlG5lc<c<c<c009c<c<00?O5aO<c<c<c<`0
2/c<c003gaLGc<c<c<c<00?<c<`01=lG5lc<c<c<c=lG5`?<c<`00mlG5lc<
c<c<c006c<c<00?O5aO<c<c<c<`02Lc<c003gaLGc<c<c<c<00O<c<`00mlG
5lc<c=lG5`09c<c<00?O5aO<c<c<c<`03lc<c003gaLGc<c<c<c<00W<c<`0
0mlG5lc<c<c<c00:c<c<00?O5aO<c<c<c<`00lc<c004gaLGc<c<c<c<gaLG
0lc<c003gaLGc<c<c<c<00K<c<`00mlG5lc<c<c<c009c<c<00?O5aO<c<c<
c<`01lc<c003gaLGc<c<gaLG00W<c<`00mlG5lc<c<c<c00=c<c<<P0002O<
c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<
c003VIVIc<c<c<c<02G<c<`5oooo1MlG5`Goool5gaLG1Oooo`G<c<`50000
1MlG5`Goool5gaLG1@0000G<c<`5oooo1MlG5`D00005gaLG1Oooo`W<c<`0
0mlG5lc<c<c<c002c<c<00?O5aO<c<c<c<`02/c<c003gaLGc<c<c<c<00W<
c<`00mlG5lc<c<c<c003c<c<00CO5aO<c<c<c<cO5aL4c<c<00?O5aO<c<c<
c<`01Lc<c003gaLGc<c<c<c<00?<c<`;gaLG1/c<c003gaLGc<c<c<c<00S<
c<`00mlG5lc<c<c<c00:c<c<00?O5aO<c<c<c<`00/c<c003gaLGc<c<c<c<
00[<c<`00mlG5lc<c<c<c009c<c<00?O5aO<c<c<c<`00lc<c004gaLGc<c<
c<c<gaLG1<c<c003gaLGc<c<c<c<00G<c<`00mlG5lc<c<c<c003c<c<2mlG
5`K<c<`00mlG5lc<c<c<c008c<c<00?O5aO<c<c<c<`03Lc<c380000Wc<c<
00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`0
0iVIVLc<c<c<c00Uc<c<1Oooo`GO5aL5oooo1MlG5`Goool5c<c<1@0000GO
5aL5oooo1MlG5`D00005c<c<1Oooo`GO5aL500001MlG5`Goool9c<c<00?O
5aO<c<c<c<`00/c<c003gaLGc<c<c<c<00_<c<`00mlG5lc<c<c<c009c<c<
00?O5aO<c<c<c<`00/c<c004gaLGc<c<c<c<gaLG1<c<c003gaLGc<c<c<c<
00G<c<`00mlG5lc<c<c<c008c<c<00?O5aO<c<c<c<`02/c<c003gaLGc<c<
c<c<00O<c<`00mlG5lc<c<c<c002gaLG2<c<c003gaLGc<c<c<c<00;<c<`0
0mlG5lc<c<c<c00;c<c<00?O5aO<c<c<c<`02Lc<c003gaLGc<c<c<c<00;<
c<`01=lG5lc<c<c<c=lG5`C<c<`00mlG5lc<c<c<c005c<c<00?O5aO<c<c<
c<`02<c<c003gaLGc<c<c<c<00[<c<`00mlG5lc<c<c<c007c<c<00?O5aO<
c<c<c<`00]lG5`_<c<`b00009lc<c003VIVIc<c<c<c<00:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<c0Goool?gaLG
1Oooo`G<c<`500003mlG5`D00005c<c<1Oooo`oO5aL5oooo2Lc<c003gaLG
c<c<c<c<00;<c<`00mlG5lc<c<c<c00;c<c<00?O5aO<c<c<c<`02Lc<c003
gaLGc<c<c<c<00;<c<`01=lG5lc<c<c<c=lG5`O<c<`:gaLG1/c<c003gaLG
c<c<c<c<00[<c<`00mlG5lc<c<c<c007c<c<0mlG5`[<c<`00mlG5lc<c<c<
c002c<c<00?O5aO<c<c<c<`02lc<c003gaLGc<c<c<c<00W<c<`00mlG5lc<
c<c<c002c<c<00CO5aO<c<c<c<cO5aL7c<c<2]lG5`K<c<`00mlG5lc<c<c<
c00:c<c<00?O5aO<c<c<c<`01lc<c0?O5aL=c<c<<P0002O<c<`00iVIVLc<
c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<
c<c<02G<c<`5oooo3mlG5`Goool5c<c<1@0000oO5aL500001Lc<c0Goool?
gaLG1Oooo`O<c<`;gaLG2/c<c004gaLGc<c<c<c<c<c<2MlG5`C<c<`01=lG
5lc<c<c<c=lG5a?<c<`9gaLG2Lc<c003gaLGc<c<c<c<00K<c<`00mlG5lc<
c<c<c008c<c<2mlG5`[<c<`01=lG5lc<c<c<c<c<c0WO5aL4c<c<00CO5aO<
c<c<c<cO5aLCc<c<2MlG5`W<c<`00mlG5lc<c<c<c006c<c<00?O5aO<c<c<
c<`03Lc<c380000Wc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0
^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c00Uc<c<1Oooo`oO5aL5oooo1Lc<
c0D0000?gaLG1@0000G<c<`5oooo3mlG5`Goool9c<c<00?O5aO<c<c<c<`0
0/c<c003gaLGc<c<c<c<00G<c<`00mlG5lc<c<c<c00?c<c<00?O5aO<c<c<
c<`00/c<c004gaLGc<c<c<c<gaLG5lc<c003gaLGc<c<c<c<00_<c<`00mlG
5lc<c<c<c006c<c<00?O5aO<c<c<c<`02/c<c003gaLGc<c<c<c<00;<c<`0
0mlG5lc<c<c<c005c<c<00?O5aO<c<c<c<`03lc<c003gaLGc<c<c<c<00;<
c<`01=lG5lc<c<c<c=lG5aO<c<`00mlG5lc<c<c<c00;c<c<00?O5aO<c<c<
c<`01/c<c003gaLGc<c<c<c<00g<c<`b00009lc<c003VIVIc<c<c<c<00:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<
c0Goool?gaLG1Oooo`G<c<`500003mlG5`D00005c<c<1Oooo`oO5aL5oooo
2Lc<c003gaLGc<c<c<c<00;<c<`00mlG5lc<c<c<c003c<c<0]lG5a7<c<`0
0mlG5lc<c=lG5`06c<c<00?O5aO<c<c<c<`01/c<c0SO5aL7c<c<00?O5aO<
c<c<c<`01Lc<c0OO5aL8c<c<00?O5aO<c<c<c<`02/c<c003gaLGc<c<c<c<
00;<c<`00mlG5lc<c<c<c003c<c<0]lG5a7<c<`00mlG5lc<c=lG5`06c<c<
00?O5aO<c<c<c<`01/c<c0SO5aL7c<c<00?O5aO<c<c<c<`01Lc<c0OO5aL8
c<c<00?O5aO<c<c<c<`03Lc<c380000Wc<c<00>IVIW<c<c<c<`00XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c00Uc<c<1Ooo
o`oO5aL5oooo1Lc<c0D0000?gaLG1@0000G<c<`5oooo3mlG5`GooolXc<c<
00?O5aO<c<c<c<`07Lc<c003gaLGc<c<c<c<01C<c<`00mlG5lc<c<c<c00Y
c<c<00?O5aO<c<c<c<`07Lc<c003gaLGc<c<c<c<01C<c<`00mlG5lc<c<c<
c00=c<c<<P0002O<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003VIVIc<c<c<c<02G<c<`Ioooo1Lc<c1T00005c<c<
6Oooom;<c<`b00009lc<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<c1Woool5c<c<6@0000G<
c<`Iooood/c<c380000Wc<c<00>IVIW<c<c<c<`00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c00Uc<c<6Oooo`G<c<`I0000
1Lc<c1WooooBc<c<<P0002O<c<`00iVIVLc<c<c<c002R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<02G<c<`Ioooo1Lc<c1T0
0005c<c<6Oooom;<c<`b00009lc<c003VIVIc<c<c<c<00:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`09Lc<c1Woool5c<c<
6@0000G<c<`Iooood/c<c380000Wc<c<00>IVIW<c<c<c<`00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c03oc<c<Y/c<c003
VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00>I
VIW<c<c<c<`0olc<c:K<c<`00iVIVLc<c<c<c002R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<bVc<c<00>IVIW<c<c<
c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<
c03oc<c<Y/c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2c<c<00>IVIW<c<c<c<`0olc<c:K<c<`00iVIVLc<c<c<c002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<c<c<0?o<c<bV
c<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<
c<`00iVIVLc<c<c<c03oc<c<Y/c<c003VIVIc<c<c<c<00:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2c<c<00>IVIW<c<c<c<`01/c<c0030000c<c<
c<c<0?o<c<bMc<c<00>IVIW<c<c<c<`00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0;<c<`00iVIVLc<c<c<c006c<c<100000W<c<`400002<c<c0P0
0004c<c<2@000?o<c<abc<c<00>IVIW<c<c<c<`00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0;<c<`00iVIVLc<c<c<c008c<c<0`0000S<c<`20000
00C<c<`0000000000006c<c<0P0000o<c<`20000olc<c7C<c<`00iVIVLc<
c<c<c002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003VIVIc<c<
c<c<00[<c<`200001lc<c0800003c<c<0P0000G<c<`200003lc<c080003o
c<c<M<c<c003VIVIc<c<c<c<00:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2c<c<00>IVIW<c<c<c<`02lc<c0800006c<c<0P0000C<c<`200001<c<
c080000?c<c<0P000?o<c<adc<c<00>IVIW<c<c<c<`00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0;<c<`5VIVI2Lc<c0<00005c<c<0P0000G<c<`2
00000lc<c080000?c<c<0P0000G<c<`;000000?<c<bIVIVIVIT0oiVIVF:I
VIT2c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^17<c<`200001Lc<
c0800005c<c<00<0003<c<c<c<`00/c<c0P00005c<c<1P000?o<c<agc<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^17<c<`200001Lc<c080000:
c<c<0P0000?<c<`20000olc<c8?<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h2/c<c0T00005c<c<0P0000[<c<`200001<c<c0030000c<c<c<c<
0?o<c<b1c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^17<c<`40000
5<c<c0@0003oc<c<PLc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PA
c<c<100001C<c<`30000olc<c8;<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h:/c<c0030000c<c<c<c<0?o<c<b1c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?o<c<b^c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<b^c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?mVIVJ^
IVIV0XS0^058T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<[<c<c004
IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c:c<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<b/c<c<
00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<[<c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<c:c<
c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<c<b/
c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3oc<c<
[<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0olc<
c:c<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?o<
c<b/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3o
c<c<[<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0
olc<c:c<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo
0?o<c<b/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3oc<c<[<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;So
ool0olc<c:c<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo0?o<c<b/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0
^?ooo`0[c<c<C`4007T10@4Jc<c<4?l028k<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo02_<c<`X0`00CP<10Dl30P830`<36/c<
c13o00n>c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`0[c<c<6`@003@40@4d1082=@@30a0410@Jc<c<4?l05hk<c<`016IVIXS0
^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo02_<c<`D1@009`D10BP5
0P8W1@<39`D411L51@DJc<c<4?l07hk<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo02_<c<`@1P0080H10Al60P8O1P<380H411l6
1@DK1PH66/c<c13o02J>c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SP
f8S0^8S0^?ooo`0[c<c<3PP001X80@4J20826PP30aX810@J20D56PP61Q/8
1`L320P86/c<c13o02j>c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SP
f8S0^8S0^?ooo`0[c<c<30T001H90@4G2@825PT30aH910@G2@D55PT61QL9
1`LF2@P82@T92A[<c<`@o`0fS/c<c004IVIVR<2hR<2hB9280@00000000F8
`;S8h=R8`;R8`;Soool0:lc<c0X:000D2P4150X20Q<:0`<D2P@44`X51A@:
1PHD2PL74`X821@:2@T=2PX:6/c<c13o03f>c<c<00AVIVJ8`;R8`;Q8T8P1
000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<2@/0018;0@4A2`824P/30a4;
10@A2`D54P/61Q4;1`LB2`P84@/92A8;2PX@2`/;6/c<c13o04F>c<c<00AV
IVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<20d0010=
0@4@3@823`d30a0=10@@3@D53`d61Q0=1`L@3@P840d92@l=2PX@3@/;40d<
30<=3@dJc<c<4?l0CHk<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3H
R<2hR<2hoooo02_<c<`83P003Ph10@h>0P8>3P<33`h410h>1@D>3PH63Ph7
1`l>20P>3PT93Ph:2Ph>2`/?3P`<3Ph=3@L>3PhJc<c<4?l0E8k<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo02_<c<`73`003@l1
0@d?0P8=3`<33@l410d?1@D=3`H63Pl71`d?20P=3`T93@l:2Pd?2`/=3``<
3@l=3@d?3Ph:3`l?6/c<c13o05b>c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`0[c<c<1a4000`A0@4<4@8231430``A10@<4@D5
31461P`A1`L<4@P831492@`A2PX<4@/;314<30`A3@d<4@h>3A4?3``A410J
c<c<4?l0Hhk<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo02_<c<`64P002a810@`B0P8;4P<32a8410/B1@D;4PH631871`/B20P;
4PT92a8:2P/B2`/<4P`<2a8=3@/B3Ph;4Pl?2a8@40`B4A434Q8B6/c<c13o
06^>c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[
c<c<1Q<000XC0@4;4`822Q<30`/C10@:4`D52Q<61P/C1`L:4`P82a<92@XC
2PX;4`/;2Q<<30/C3@d:4`h>2a<?3`XC410;4a4A2Q<B4PHC4a<Jc<c<4?l0
Lhk<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo02_<
c<`550002Q@10@XD0P8:50<32Q@410TD1@D:50H62Q@71`XD20P:50T92A@:
2PXD2`/:50`<2Q@=3@XD3Ph950l?2Q@@40XD4A4:518B2Q@C4`PD51@Jc<c<
4?l0NXk<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo
02_<c<`55P002AH10@XF0P895P<32AH410TF1@D95PH62QH71`TF20P95PT9
2AH:2PXF2`/95P`<2AH=3@TF3Ph:5Pl?2AH@40TF4A495Q8B2AHC4`XF51@9
5QDE00<F5QK<c<c<c<`06<c<c13o08:>c<c<00AVIVJ8`;R8`;Q8T8P10000
00001HS0^<SPf8S0^8S0^?ooo`0[c<c<1AL000TG0@485`822AL30`TG10@8
5`D52AL61PTG1`L95`P821L92@TG2PX95`/;21L<30TG3@d95`h>2AL?3`PG
41095a4A2ALB4PPG4a<95a@D2ALE5@TG5QH35aLG6/c<c13o08Z>c<c<00AV
IVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<1AP000PH
0@48608221P30`TH10@860D521P61PPH1`L960P821P92@PH2PX860/;2AP<
30PH3@d860h>21P?3`TH4108614A21PB4PPH4a<961@D21PE5@PH5QH961LG
1APH61[<c<`@o`2AS/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0:lc<c0@J00086P4121X20PPJ0`<86P@421X51@LJ1PH86PL7
21X820PJ2@T86PX:21X;2`PJ30`76Pd=21X>3PPJ3`l86Q0@21XA4@PJ4Q87
6Q<C21XD50PJ5AD86QHF21XG5`PJ61P76QTI6/c<c13o09V>c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<11/000PK0@47
6`8221/30`LK10@86`D51a/61PPK1`L76`P81a/92@PK2PX76`/;21/<30LK
3@d86`h>1a/?3`PK41076a4A21/B4PLK4a<86a@D1a/E5@PK5QH76aLG21/H
60LK6AT76aXJ0Q/K6a[<c<`@o`2QS/c<c004IVIVR<2hR<2hB9280@000000
00F8`;S8h=R8`;R8`;Soool0:lc<c0@L000770411a`20PLL0`<870@41a`5
1@LL1PH770L71a`820LL2@T770X:1a`;2`PL30`770d=1a`>3PLL3`l7710@
1a`A4@LL4Q8871<C1a`D50LL5AD771HF1a`G5`LL61P771TI1a`J6PPL6a/3
71`L6/c<c13o0:R>c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^?ooo`0[c<c<11d000LM0@477@821Qd30`LM10@77@D51ad61PLM1`L6
7@P81ad92@LM2PX77@/;1ad<30LM3@d67@h>1ad?3`LM41077A4A1adB4PHM
4a<77A@D1adE5@LM5QH77ALG1adH60HM6AT77AXJ1adK6`LM71`57AdM6/c<
c13o0;2>c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`0[c<c<11l000HO0@477`821Ql30`LO10@67`D51al61PLO1`L67`P81al9
2@HO2PX77`/;1Ql<30LO3@d67`h>1al?3`HO41077a4A1QlB4PLO4a<67a@D
1alE5@LO5QH67aLG1alH60HO6AT77aXJ1QlK6`LO71`67adM1alN7Q[<c<`@
o`2hS/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0
:lc<c0@P000680411R020PHP0`<780@41R051@HP1PH780L71R0820HP2@T6
80X:1b0;2`HP30`680d=1R0>3PLP3`l6810@1R0A4@LP4Q8681<C1R0D50HP
5AD781HF1R0G5`HP61P681TI1b0J6PHP6a/681`L1b0M7@HP7Qh681lO0R0P
81[<c<`@o`2oS/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8
`;Soool0:lc<c0@Q00068@411R420PHQ0`<68@@41R451@HQ1PH68@L71R48
20HQ2@T68@X:1R4;2`HQ30`68@d=1R4>3PHQ3`l68A0@1R4A4@HQ4Q868A<C
1R4D50HQ5AD68AHF1R4G5`HQ61P68ATI1R4J6PHQ6a/68A`L1R4M7@LQ7Qh6
8AlO1R4P80<Q8B4Jc<c<4?l0ahk<c<`016IVIXS0^8S0^4R@R04000000005
R<2hb>3HR<2hR<2hoooo02_<c<`38P001R810@HR0P868P<31R8410DR1@D6
8PH61R871`HR20P68PT91R8:2PDR2`/68P`<1R8=3@HR3Ph68Pl?1B8@40HR
4A468Q8B1R8C4`HR51@58QDE1R8F5PHR5aL68QPH1R8I6@DR6QX68Q/K1R8L
70HR7Ad68QhN1R8O7`DR82068R4Q1B8R8Q[<c<`@o`3?S/c<c004IVIVR<2h
R<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c0<T000690411R@2
0PDT0`<690@41B@51@HT1PH690L71B@820HT2@T590X:1R@;2`HT30`590d=
1R@>3PDT3`l6910@1R@A4@DT4Q8691<C1B@D50HT5AD691HF1B@G5`HT61P5
91TI1R@J6PHT6a/591`L1R@M7@DT7Qh691lO1R@P80DT8B46928R1B@S8`03
92@Tc<c<c<c<01S<c<`@o`3FS/c<c004IVIVR<2hR<2hB9280@00000000F8
`;S8h=R8`;R8`;Soool0:lc<c0<U00069@411BD20PDU0`<69@@41BD51@HU
1PH59@L71BD820HU2@T59@X:1RD;2`DU30`69@d=1BD>3PDU3`l69A0@1BDA
4@HU4Q859A<C1BDD50HU5AD59AHF1RDG5`DU61P59ATI1RDJ6PDU6a/69A`L
1BDM7@DU7Qh69AlO1BDP80HU8B459B8R1RDS8`DU92@29BDU6/c<c13o0=j>
c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<
0bH000DV0@469P821BH30`DV10@59PD51BH61PHV1`L59PP81BH92@DV2PX6
9P/;1BH<30DV3@d59Ph>1RH?3`DV41059Q4A1BHB4PDV4a<69Q@D1BHE5@DV
5QH59QLG1RHH60DV6AT59QXJ1BHK6`HV71`59QdM1BHN7PDV7al59R0P1RHQ
8@DV8R859R<S1BHT90HV9BD39RHV6/c<c13o0>J>c<c<00AVIVJ8`;R8`;Q8
T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0bP000DX0@45:0821BP3
0`DX10@5:0D51BP61PDX1`L6:0P81BP92@DX2PX5:0/;1BP<30DX3@d5:0h>
1BP?3`DX4105:14A1BPB4PDX4a<5:1@D1BPE5@DX5QH5:1LG1BPH60HX6AT5
:1XJ1BPK6`DX71`5:1dM1BPN7PDX7al5:20P1BPQ8@DX8R85:2<S1BPT90DX
9BD5:2HV1BPW9a[<c<`@o`3]S/c<c004IVIVR<2hR<2hB9280@00000000F8
`;S8h=R8`;R8`;Soool0:lc<c0<Y0005:@411BT20PDY0`<5:@@412T51@DY
1PH5:@L71BT820DY2@T5:@X:1BT;2`DY30`5:@d=1BT>3P@Y3`l5:A0@1BTA
4@DY4Q85:A<C1BTD50DY5AD5:AHF1BTG5`DY61P4:ATI1BTJ6PDY6a/5:A`L
1BTM7@DY7Qh5:AlO1BTP80DY8B45:B8R1BTS8`@Y92@5:BDU1BTV9PDY9bL5
:BPX00<Y:BW<c<c<c<`06<c<c13o0?F>c<c<00AVIVJ8`;R8`;Q8T8P10000
00001HS0^<SPf8S0^8S0^?ooo`0[c<c<0bX000DZ0@44:P821BX30`DZ10@5
:PD512X61PDZ1`L5:PP81BX92@@Z2PX5:P/;1BX<30DZ3@d4:Ph>1BX?3`DZ
4105:Q4A12XB4PDZ4a<5:Q@D1BXE5@@Z5QH5:QLG1BXH60DZ6AT4:QXJ1BXK
6`DZ71`5:QdM12XN7PDZ7al5:R0P1BXQ8@@Z8R85:R<S1BXT90DZ9BD5:RHV
12XW9`DZ:2P5:RTY0RXZ:Q[<c<`@o`3lS/c<c004IVIVR<2hR<2hB9280@00
000000F8`;S8h=R8`;R8`;Soool0:lc<c0<[0004:`411B/20PD[0`<4:`@4
1B/51@@[1PH5:`L71B/820@[2@T5:`X:1B/;2`@[30`5:`d=12/>3PD[3`l5
:a0@12/A4@D[4Q84:a<C1B/D50D[5AD4:aHF1B/G5`D[61P4:aTI1B/J6P@[
6a/5:a`L1B/M7@@[7Qh5:alO12/P80D[8B45:b8R12/S8`D[92@5:bDU12/V
9PD[9bL4:bPX1B/Y:@D[:RX3:b/[6/c<c13j0?n>c<c<00AVIVJ8`;R8`;Q8
T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0bd000@]0@45;@8212d3
0`D]10@4;@D51Bd61P@]1`L5;@P812d92@D]2PX4;@/;1Bd<30@]3@d4;@h>
1Bd?3`@]4105;A4A12dB4PD]4a<4;A@D1BdE5@@]5QH5;ALG12dH60D]6AT4
;AXJ1BdK6`@]71`5;AdM12dN7PD]7al4;B0P1BdQ8@@]8R85;B<S12dT90D]
9BD4;BHV1BdW9`@]:2P4;BTY1BdZ:P@]:b/5;B`/6/c<c13b0?n>c<c<00AV
IVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0bh000@^
0@44;P821Bh30`@^10@4;PD51Bh61P@^1`L5;PP812h92@@^2PX5;P/;12h<
30@^3@d5;Ph>12h?3`@^4105;Q4A12hB4P@^4a<5;Q@D12hE5@D^5QH4;QLG
12hH60D^6AT4;QXJ12hK6`D^71`4;QdM12hN7PD^7al4;R0P12hQ8@D^8R84
;R<S1BhT90@^9BD4;RHV1BhW9`@^:2P4;RTY1BhZ:P@^:b/4;R`/1Bh];@03
;Rh^c<c<c<c<01S<c<`@j`3oS/c<c004IVIVR<2hR<2hB9280@00000000F8
`;S8h=R8`;R8`;Soool0:lc<c0<_0004;`4112l20P@_0`<5;`@412l51@@_
1PH4;`L71Bl820@_2@T4;`X:12l;2`@_30`5;`d=12l>3P@_3`l4;a0@1BlA
4@@_4Q84;a<C12lD50D_5AD4;aHF12lG5`@_61P5;aTI12lJ6P@_6a/4;a`L
1BlM7@@_7Qh4;alO12lP80D_8B44;b8R12lS8`@_92@4;bDU1BlV9P@_9bL4
;bPX12lY:@D_:RX4;b/[12l/;0@_;Bd5;bh^0Rl_;a[<c<`@h`3oS/c<c004
IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c0<`0004
<04113020P@`0`<4<0@413051@@`1PH4<0L71C0820@`2@T4<0X:130;2`@`
30`4<0d=130>3P@`3`l5<10@130A4@@`4Q84<1<C130D50@`5AD4<1HF1C0G
5`@`61P4<1TI130J6P@`6a/4<1`L130M7@@`7Qh5<1lO130P80@`8B44<28R
130S8`@`92@4<2DU130V9PD`9bL4<2PX130Y:@@`:RX4<2/[130/;0@`;Bd4
<2h^1C0_;`<`<30Jc<c<4=/0ohk<c<`016IVIXS0^8S0^4R@R04000000005
R<2hb>3HR<2hR<2hoooo02_<c<`3<P0013810@@b0P84<P<3138410@b1@D4
<PH613871`@b20P4<PT9138:2P@b2`/4<P`<138=3@@b3Ph4<Pl?138@40@b
4A44<Q8B138C4`@b51@4<QDE138F5P@b5aL4<QPH138I6@@b6QX4<Q/K138L
70@b7Ad4<QhN138O7`@b8204<R4Q138R8P@b8b<4<R@T138U9@@b9RH4<RLW
138X:0@b:BT4<RXZ138[:`@b;2`5<Rd]138^;P@b;bl4<S0`138a<A[<c<`@
e03oS/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0
:lc<c08c0004<`4113<20P@c0`<4<`@413<51@@c1PH4<`L713<820@c2@T4
<`X:13<;2`@c30`3<`d=13<>3P@c3`l4<a0@13<A4@@c4Q84<a<C13<D50@c
5AD4<aHF13<G5`@c61P4<aTI0c<J6P@c6a/4<a`L13<M7@@c7Qh4<alO13<P
80@c8B44<b8R13<S8`@c92@4<bDU0c<V9P@c9bL4<bPX13<Y:@@c:RX4<b/[
13</;0@c;Bd4<bh^13<_;`@c<304<c4a13<b<P03<c<cc<c<c<c<01S<c<`@
c03oS/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0
:lc<c08d0004=04113@20P@d0`<4=0@413@51@<d1PH4=0L713@820@d2@T4
=0X:0c@;2`@d30`4=0d=13@>3P@d3`l4=10@0c@A4@@d4Q84=1<C13@D50@d
5AD4=1HF0c@G5`@d61P4=1TI13@J6P@d6a/4=1`L0c@M7@@d7Qh4=1lO13@P
80@d8B43=28R13@S8`@d92@4=2DU13@V9P@d9bL3=2PX13@Y:@@d:RX4=2/[
13@/;0@d;Bd3=2h^13@_;`@d<304=34a13@b<P@d<c<2=3@d6/c<c1340?n>
c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<
0SH000@f0@44=P8213H30`<f10@4=PD513H61P@f1`L3=PP813H92@@f2PX3
=P/;13H<30@f3@d4=Ph>0cH?3`@f4104=Q4A13HB4P<f4a<4=Q@D13HE5@@f
5QH3=QLG13HH60@f6AT3=QXJ13HK6`@f71`4=QdM0cHN7P@f7al4=R0P13HQ
8@<f8R84=R<S13HT90@f9BD3=RHV13HW9`@f:2P3=RTY13HZ:P@f:b/4=R`/
0cH];@@f;Rh4=Rl_13H`<0<f<C44=S8b13Hc<`@f=3@3=SDe6/c<c12m0?n>
c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<
0SL000@g0@44=`820cL30`@g10@4=`D50cL61P@g1`L4=`P80cL92@@g2PX3
=`/;13L<30@g3@d3=`h>13L?3`@g4103=a4A13LB4P@g4a<3=a@D13LE5@@g
5QH3=aLG13LH60@g6AT3=aXJ13LK6`<g71`4=adM13LN7P<g7al4=b0P13LQ
8@<g8R84=b<S13LT90<g9BD4=bHV13LW9`<g:2P4=bTY13LZ:P<g:b/4=b`/
0cL];@@g;Rh4=bl_0cL`<0@g<C44=c8b0cLc<`@g=3@4=cDe0cLf=P03=cLg
c<c<c<c<01S<c<`@]@3o5<c<c26IVIUIc<c<00AVIVJ8`;R8`;Q8T8P10000
00001HS0^<SPf8S0^8S0^?ooo`0[c<c<0SP000@h0@43>08213P30`@h10@3
>0D513P61P<h1`L4>0P80cP92@@h2PX3>0/;13P<30@h3@d3>0h>13P?3`<h
4104>14A0cPB4P@h4a<4>1@D0cPE5@@h5QH3>1LG13PH60<h6AT4>1XJ13PK
6`<h71`4>1dM0cPN7P@h7al3>20P13PQ8@<h8R84>2<S13PT90<h9BD4>2HV
0cPW9`@h:2P3>2TY13PZ:P@h:b/3>2`/13P];@<h;Rh4>2l_0cP`<0@h<C44
>38b0cPc<`@h=3@3>3De13Pf=P<h=cL2>3Ph6/c<c12]0?lDc<c<00>IVIW<
c<c<c<`07Lc<c003VIVIc<c<c<c<05O<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo02_<c<`2>@0013T10@<i0P84>@<30cT410@i
1@D3>@H613T71`<i20P4>@T90cT:2P@i2`/3>@`<13T=3@<i3Ph4>@l?0cT@
40@i4A43>A8B0cTC4`@i51@3>ADE13TF5P<i5aL4>APH0cTI6@@i6QX3>A/K
13TL70<i7Ad4>AhN0cTO7`@i8203>B4Q13TR8P<i8b<4>B@T0cTU9@@i9RH3
>BLW13TX:0<i:BT4>BXZ0cT[:`@i;2`3>Bd]13T^;P<i;bl4>C0`0cTa<@@i
<S83>C<c13Td=0<i=CD3>CHf13Tg=`<i>3P3>CTi6/c<c12V0?lDc<c<00>I
VIW<c<c<c<`07Lc<c003VIVIc<c<c<c<05O<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo02_<c<`2>`0013/10@<k0P83>`<313/4
10<k1@D4>`H60c/71`<k20P4>`T90c/:2P@k2`/3>``<13/=3@<k3Ph3>`l?
13/@40<k4A44>a8B0c/C4`<k51@4>aDE0c/F5P@k5aL3>aPH0c/I6@@k6QX3
>a/K13/L70<k7Ad4>ahN0c/O7`<k8204>b4Q0c/R8P@k8b<3>b@T0c/U9@@k
9RH3>bLW13/X:0<k:BT3>bXZ13/[:`<k;2`4>bd]0c/^;P<k;bl4>c0`0c/a
<@@k<S83>c<c13/d=0<k=CD3>cHf13/g=`<k>3P4>cTi0c/j>Q[<c<`@WP3o
5<c<c003VIVIc<c<c<c<01g<c<`00iVIVLc<c<c<c01Gc<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0S`000@l0@43?082
0c`30`@l10@3?0D50c`61P@l1`L3?0P80c`92@@l2PX3?0/;0c`<30@l3@d3
?0h>0c`?3`@l4103?14A0c`B4P@l4a<3?1@D0c`E5@@l5QH3?1LG0c`H60@l
6AT3?1XJ0c`K6`@l71`3?1dM0c`N7P@l7al3?20P0c`Q8@@l8R83?2<S0c`T
90@l9BD3?2HV0c`W9`@l:2P3?2TY0c`Z:P@l:b/3?2`/0c`];@@l;Rh3?2l_
0c``<0@l<C43?38b0c`c<`@l=3@3?3De0c`f=P@l=cL3?3Ph0c`i>@@l>SX3
?3/k00<l?3c<c<c<c<`06<c<c12F0?lDc<c<00>IVIW<c<c<c<`07Lc<c003
VIVIc<c<c<c<05O<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo02_<c<`2?@000cd10@@m0P83?@<30cd410<m1@D4?@H60cd71`<m
20P4?@T90cd:2P<m2`/3?@`<13d=3@<m3Ph3?@l?0cd@40@m4A43?A8B0cdC
4`<m51@4?ADE0cdF5P<m5aL4?APH0cdI6@<m6QX3?A/K13dL70<m7Ad3?AhN
0cdO7`@m8203?B4Q0cdR8P@m8b<3?B@T0cdU9@<m9RH4?BLW0cdX:0<m:BT3
?BXZ13d[:`<m;2`3?Bd]0cd^;P@m;bl3?C0`0cda<@@m<S83?C<c0cdd=0<m
=CD4?CHf0cdg=`<m>3P3?CTi13dj>P<m>c/3?C`l0Sdm?A[<c<`@S`3o2/c<
c0H00004c<c<00>IVIW<c<c<c<`03/c<c0D00003c<c<0`0000C<c<`00iVI
VLc<c<c<c01Gc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0
^?ooo`0[c<c<0Sh000<n0@44?P820ch30`<n10@3?PD50ch61P@n1`L3?PP8
0ch92@<n2PX3?P/;13h<30<n3@d3?Ph>0ch?3`<n4104?Q4A0chB4P<n4a<3
?Q@D0chE5@@n5QH3?QLG0chH60<n6AT3?QXJ13hK6`<n71`3?QdM0chN7P<n
7al4?R0P0chQ8@<n8R83?R<S0chT90@n9BD3?RHV0chW9`<n:2P3?RTY13hZ
:P<n:b/3?R`/0ch];@<n;Rh4?Rl_0ch`<0<n<C43?S8b0chc<`@n=3@3?SDe
0chf=P<n=cL3?SPh13hi>@<n>SX3?S/k0chl?0<n?Cd3?Shn6/c<c1270?l:
c<c<0P0000?<c<`200000lc<c003VIVIc<c<c<c<00o<c<`00`000<c<c<c<
c003c<c<00D0003<c<c<c<c<c<`000000lc<c003VIVIc<c<c<c<05O<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo02_<c<`2@000
0d010@=00P83@0<3140410=01@D3@0H60d071`=020P3@0T90d0:2PA02`/3
@0`<0d0=3@=03Ph3@0l?0d0@40=04A44@18B0d0C4`=051@3@1DE0d0F5P=0
5aL3@1PH140I6@=06QX3@1/K0d0L70=07Ad3@1hN0d0O7`=08204@24Q0d0R
8P=08b<3@2@T0d0U9@=09RH3@2LW140X:0=0:BT3@2XZ0d0[:`=0;2`3@2d]
0d0^;PA0;bl3@30`0d0a<@=0<S83@3<c0d0d=0=0=CD3@3Hf140g=`=0>3P3
@3Ti0d0j>P=0>c/3@3`l0d0m?@A0?Sh3@3lo6/c<c1200?l:c<c<0P0000?<
c<`200000lc<c003VIVIc<c<c<c<013<c<`00`000<c<c<c<c006c<c<00D0
003<c<c<c<c<c<bIVIT0FLc<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0:lc<c0910003@@410d420P=10`<3@@@40d451@=11PH4
@@L70d4820=12@T3@@X:0d4;2`=130`3@@d=0d4>3P=13`l3@A0@0d4A4@=1
4Q83@A<C144D50=15AD3@AHF0d4G5`=161P3@ATI0d4J6P=16a/3@A`L0d4M
7@=17Qh3@AlO0d4P80A18B43@B8R0d4S8`=192@3@BDU0d4V9P=19bL3@BPX
0d4Y:@=1:RX3@B/[0d4/;0=1;Bd4@Bh^0d4_;`=1<303@C4a0d4b<P=1<c<3
@C@d0d4e=@=1=SH3@CLg0d4h>0=1>CT3@CXj144k>`=1?3`3@Cdm0d4n?P=1
?cl3@D1000=1@D7<c<c<c<`06<c<c11h0?l:c<c<0P0000?<c<`200000lc<
c003VIVIc<c<c<c<017<c<`00`000<c<c<c<c005c<c<00D0003<c<c<c<c<
c<bIVIT0FLc<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;So
ool0:lc<c0920003@P410d820P=20`<3@P@40d851@=21PH3@PL70d8820=2
2@T3@PX:0d8;2`=230`3@Pd=0d8>3P=23`l3@Q0@0d8A4@=24Q83@Q<C0d8D
50=25AD3@QHF0d8G5`=261P3@QTI0d8J6P=26a/3@Q`L0d8M7@A27Qh3@QlO
0d8P80=28B43@R8R0d8S8`=292@3@RDU0d8V9P=29bL3@RPX0d8Y:@=2:RX3
@R/[0d8/;0=2;Bd3@Rh^0d8_;`=2<303@S4a0d8b<P=2<c<3@S@d0d8e=@=2
=SH3@SLg0d8h>0=2>CT3@SXj0d8k>`=2?3`3@Sdm0d8n?P=2?cl3@T100d91
@@92@T8Jc<c<4700o`[<c<`600001<c<c003VIVIc<c<c<c<017<c<`00`00
0<c<c<c<c003c<c<0P0000C<c<`00iVIVLc<c<c<c01Gc<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0T@000=40@43A082
0d@30`=410@3A0D50d@61P=41`L3A0P80d@92@=42PX3A0/;0T@<30=43@d3
A0h>0d@?3`=44103A14A0d@B4P=44a<3A1@D0d@E5@=45QH3A1LG0d@H60=4
6AT3A1XJ0d@K6`=471`3A1dM0d@N7P=47al3A20P0d@Q8@=48R83A2<S0d@T
90949BD3A2HV0d@W9`=4:2P3A2TY0d@Z:P=4:b/3A2`/0d@];@=4;Rh3A2l_
0d@`<0=4<C43A38b0d@c<`=4=3@3A3De0d@f=P=4=cL3A3Ph0d@i>@=4>SX3
A3/k0d@l?0=4?Cd2A3hn0d@o?`=4@403A4510dA2@P=4@d<Jc<c<46T0o`[<
c<`200000lc<c0800003c<c<00>IVIW<c<c<c<`04/c<c0030000c<c<c<c<
00C<c<`01@000<c<c<c<c<c<c9VIV@1Ic<c<00AVIVJ8`;R8`;Q8T8P10000
00001HS0^<SPf8S0^8S0^?ooo`0[c<c<0TD000=50@43A@820dD30`=510@2
A@D50dD61P=51`L3A@P80dD92@=52PX3A@/;0dD<30=53@d3A@h>0dD?3`95
4103AA4A0dDB4P=54a<3AA@D0dDE5@=55QH3AALG0dDH60=56AT2AAXJ0dDK
6`=571`3AAdM0dDN7P=57al3AB0P0dDQ8@=58R83AB<S0dDT90959BD3ABHV
0dDW9`=5:2P3ABTY0dDZ:P=5:b/3AB`/0dD];@=5;Rh2ABl_0dD`<0=5<C43
AC8b0dDc<`=5=3@3ACDe0dDf=P=5=cL3ACPh0dDi>@95>SX3AC/k0dDl?0=5
?Cd3AChn0dDo?`=5@403AD510dE2@P=5@d<2ADA400=5ADG<c<c<c<`06<c<
c11Q0?l:c<c<0P0000?<c<`200000lc<c003VIVIc<c<c<c<01;<c<`00`00
0<c<c<c<c004c<c<00D0003<c<c<c<c<c<bIVIT0FLc<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c0960003AP410dH20P96
0`<3AP@40dH51@=61PH3APL70dH820=62@T2APX:0dH;2`=630`3APd=0dH>
3P=63`l3AQ0@0THA4@=64Q83AQ<C0dHD50=65AD3AQHF0dHG5`9661P3AQTI
0dHJ6P=66a/3AQ`L0dHM7@967Qh3AQlO0dHP80=68B43AR8R0dHS8`=692@2
ARDU0dHV9P=69bL3ARPX0dHY:@=6:RX3AR/[0TH/;0=6;Bd3ARh^0dH_;`=6
<303AS4a0dHb<P96<c<3AS@d0dHe=@=6=SH3ASLg0dHh>096>CT3ASXj0dHk
>`=6?3`3ASdm0dHn?P=6?cl2AT100dI1@@=6@T83AT=30dI4A0=6ADD00dI6
A/c<c<c<c00Hc<c<45T0o`[<c<`200000lc<c0800003c<c<00>IVIW<c<c<
c<`03/c<c0050000c<c<c<c<c<c<000000;<c<`01@000<c<c<c<c<c<c000
0003c<c<00>IVIW<c<c<c<`0Elc<c004IVIVR<2hR<2hB9280@00000000F8
`;S8h=R8`;R8`;Soool0:lc<c0970003A`410dL20P970`<3A`@40dL51@=7
1PH3A`L70TL820=72@T3A`X:0dL;2`=730`2A`d=0dL>3P=73`l3Aa0@0dLA
4@974Q83Aa<C0dLD50=75AD3AaHF0TLG5`=761P3AaTI0dLJ6P=76a/2Aa`L
0dLM7@=77Qh3AalO0dLP80978B43Ab8R0dLS8`=792@3AbDU0TLV9P=79bL3
AbPX0dLY:@=7:RX2Ab/[0dL/;0=7;Bd3Abh^0dL_;`97<303Ac4a0dLb<P=7
<c<3Ac@d0TLe=@=7=SH3AcLg0dLh>0=7>CT2AcXj0dLk>`=7?3`3Acdm0dLn
?P97?cl3Ad100dM1@@=7@T83Ad=30TM4A0=7ADD3AdI60TM7Aa[<c<`@DP3o
2/c<c0H00004c<c<00>IVIW<c<c<c<`03lc<c0<00004c<c<0`0000C<c<`0
0iVIVLc<c<c<c01Gc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^?ooo`0[c<c<0TT000=90@42B@820dT30`=910@3B@D50TT61P=91`L3
B@P80dT92@992PX3B@/;0dT<30=93@d2B@h>0dT?3`=94103BA4A0TTB4P=9
4a<3BA@D0dTE5@995QH3BALG0dTH60=96AT2BAXJ0dTK6`=971`3BAdM0TTN
7P=97al3BB0P0dTQ8@998R83BB<S0dTT90=99BD2BBHV0dTW9`=9:2P3BBTY
0TTZ:P=9:b/3BB`/0dT];@99;Rh3BBl_0dT`<0=9<C42BC8b0dTc<`=9=3@3
BCDe0TTf=P=9=cL3BCPh0dTi>@99>SX3BC/k0dTl?0=9?Cd2BChn0dTo?`=9
@403BD510dU2@P99@d<3BDA40dU5A@=9ATH2BDM70dU8B1[<c<`@BP3o5<c<
c003VIVIc<c<c<c<01g<c<`00iVIVLc<c<c<c01Gc<c<00AVIVJ8`;R8`;Q8
T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0TX000=:0@42BP820dX3
0`=:10@2BPD50dX61P=:1`L2BPP80dX92@=:2PX3BP/;0TX<30=:3@d3BPh>
0TX?3`=:4103BQ4A0dXB4P9:4a<3BQ@D0dXE5@9:5QH3BQLG0dXH609:6AT3
BQXJ0dXK6`=:71`2BQdM0dXN7P=:7al2BR0P0dXQ8@=:8R83BR<S0TXT90=:
9BD3BRHV0TXW9`=::2P3BRTY0TXZ:P=::b/3BR`/0dX];@9:;Rh3BRl_0dX`
<09:<C43BS8b0dXc<`9:=3@3BSDe0dXf=P=:=cL2BSPh0dXi>@=:>SX2BS/k
0dXl?0=:?Cd3BShn0TXo?`=:@403BT510TY2@P=:@d<3BTA40TY5A@=:ATH3
BTM70dY8B09:BDT00dY:B/c<c<c<c00Hc<c<4480oaC<c<`00iVIVLc<c<c<
c00Mc<c<00>IVIW<c<c<c<`0Elc<c004IVIVR<2hR<2hB9280@00000000F8
`;S8h=R8`;R8`;Soool0:lc<c09;0002B`410d/20P=;0`<2B`@40d/51@=;
1PH2B`L70d/820=;2@T2B`X:0d/;2`=;30`2B`d=0d/>3P=;3`l2Ba0@0d/A
4@=;4Q82Ba<C0d/D50=;5AD2BaHF0d/G5`=;61P2BaTI0d/J6P=;6a/2Ba`L
0d/M7@=;7Qh2BalO0d/P80=;8B42Bb8R0d/S8`=;92@2BbDU0d/V9P=;9bL2
BbPX0d/Y:@9;:RX3Bb/[0d//;09;;Bd3Bbh^0d/_;`9;<303Bc4a0d/b<P9;
<c<3Bc@d0d/e=@9;=SH3BcLg0d/h>09;>CT3BcXj0d/k>`9;?3`3Bcdm0d/n
?P9;?cl3Bd100d]1@@9;@T83Bd=30d]4A09;ADD3BdI60d]7A`9;B4P3BdU9
0d]:BP03Bd];c<c<c<c<01S<c<`@>`3o5<c<c003VIVIc<c<c<c<01g<c<`0
0iVIVLc<c<c<c01Gc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^?ooo`0[c<c<0Td0009=0@43C@820dd30`9=10@3C@D50Td61P==1`L3
C@P80Td92@==2PX3C@/;0Td<30==3@d2C@h>0dd?3`==4102CA4A0ddB4P9=
4a<3CA@D0ddE5@9=5QH3CALG0ddH609=6AT3CAXJ0TdK6`==71`3CAdM0TdN
7P==7al2CB0P0ddQ8@==8R82CB<S0ddT90==9BD2CBHV0ddW9`9=:2P3CBTY
0ddZ:P9=:b/3CB`/0Td];@==;Rh3CBl_0Td`<0==<C43CC8b0Tdc<`===3@2
CCDe0ddf=P===cL2CCPh0ddi>@9=>SX3CC/k0ddl?09=?Cd3CChn0ddo?`9=
@403CD510Te2@P==@d<3CDA40Te5A@==ATH2CDM70de8B0==BDT2CDY:0de;
B`9=C4`Jc<c<43<0oaC<c<`00iVIVLc<c<c<c00Mc<c<00>IVIW<c<c<c<`0
Elc<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<
c09>0002CP410dh20P=>0`<2CP@40dh51@9>1PH3CPL70Th820=>2@T3CPX:
0Th;2`=>30`2CPd=0dh>3P9>3`l3CQ0@0dhA4@9>4Q83CQ<C0ThD50=>5AD2
CQHF0dhG5`=>61P2CQTI0dhJ6P9>6a/3CQ`L0ThM7@=>7Qh3CQlO0ThP80=>
8B42CR8R0dhS8`9>92@3CRDU0dhV9P9>9bL3CRPX0ThY:@=>:RX2CR/[0dh/
;0=>;Bd2CRh^0dh_;`9><303CS4a0Thb<P=><c<3CS@d0The=@=>=SH2CSLg
0dhh>09>>CT3CSXj0dhk>`9>?3`3CSdm0Thn?P=>?cl2CT100di1@@=>@T82
CT=30di4A09>ADD3CTI60Ti7A`=>B4P3CTU90Ti:BP=>Bd/2CTa<0di=CA[<
c<`@:`3o5<c<c003VIVIc<c<c<c<01g<c<`00iVIVLc<c<c<c01Gc<c<00AV
IVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0Tl0009?
0@43C`820Tl30`=?10@2C`D50dl61P9?1`L3C`P80dl92@9?2PX3C`/;0Tl<
30=?3@d2C`h>0dl?3`9?4103Ca4A0TlB4P=?4a<2Ca@D0dlE5@9?5QH3CaLG
0TlH60=?6AT3CaXJ0TlK6`=?71`2CadM0dlN7P9?7al3Cb0P0TlQ8@=?8R82
Cb<S0dlT909?9BD3CbHV0TlW9`=?:2P2CbTY0dlZ:P=?:b/2Cb`/0dl];@9?
;Rh3Cbl_0Tl`<0=?<C42Cc8b0dlc<`9?=3@3CcDe0Tlf=P=?=cL2CcPh0dli
>@=?>SX2Cc/k0dll?09??Cd3Cchn0Tlo?`=?@402Cd510dm2@P9?@d<3CdA4
0Tm5A@=?ATH2CdM70dm8B09?BDT3CdY:0dm;B`9?C4`3Cde=0Tm>CP03Cdm?
c<c<c<c<01S<c<`@903o5<c<c26IVIUIc<c<00AVIVJ8`;R8`;Q8T8P10000
00001HS0^<SPf8S0^8S0^?ooo`0[c<c<0U00009@0@43D0820U030`=@10@2
D0D50e061P9@1`L3D0P80U092@=@2PX2D0/;0e0<309@3@d3D0h>0U0?3`=@
4102D14A0e0B4P9@4a<3D1@D0U0E5@=@5QH2D1LG0e0H609@6AT2D1XJ0e0K
6`9@71`3D1dM0U0N7P=@7al2D20P0e0Q8@9@8R83D2<S0U0T90=@9BD2D2HV
0e0W9`9@:2P3D2TY0U0Z:P=@:b/2D2`/0e0];@9@;Rh3D2l_0U0`<0=@<C42
D38b0e0c<`9@=3@3D3De0U0f=P=@=cL2D3Ph0e0i>@9@>SX3D3/k0U0l?0=@
?Cd2D3hn0e0o?`9@@403D4510U12@P=@@d<2D4A40e15A@9@ATH3D4M70U18
B0=@BDT2D4Y:0U1;B`=@C4`2D4e=0e1>CP9@Cdl2D51@6/c<c10L0?n>c<c<
00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0U80
009B0@43DP820U830`=B10@2DPD50U861P=B1`L2DPP80e892@9B2PX3DP/;
0U8<30=B3@d2DPh>0U8?3`=B4102DQ4A0e8B4P9B4a<3DQ@D0U8E5@=B5QH2
DQLG0e8H609B6AT2DQXJ0e8K6`9B71`3DQdM0U8N7P=B7al2DR0P0e8Q8@9B
8R83DR<S0U8T909B9BD3DRHV0U8W9`=B:2P2DRTY0e8Z:P9B:b/3DR`/0U8]
;@9B;Rh3DRl_0U8`<0=B<C42DS8b0e8c<`9B=3@3DSDe0U8f=P=B=cL2DSPh
0U8i>@=B>SX2DS/k0e8l?09B?Cd3DShn0U8o?`=B@402DT510U92@P=B@d<2
DTA40e95A@9BATH3DTM70U98B0=BBDT2DTY:0e9;B`9BC4`2DTe=0e9>CP9B
Cdl3DU1@0U9ADA[<c<`@503oS/c<c004IVIVR<2hR<2hB9280@00000000F8
`;S8h=R8`;R8`;Soool0:lc<c09C0002D`410e<20P9C0`<2D`@40e<51@9C
1PH3D`L70U<8209C2@T3D`X:0U<;2`=C30`2D`d=0U<>3P=C3`l2Da0@0e<A
4@9C4Q83Da<C0U<D509C5AD3DaHF0U<G5`=C61P2DaTI0U<J6P=C6a/2Da`L
0e<M7@9C7Qh3DalO0U<P809C8B43Db8R0U<S8`=C92@2DbDU0U<V9P=C9bL2
DbPX0e<Y:@9C:RX2Db/[0e</;09C;Bd3Dbh^0U<_;`=C<302Dc4a0U<b<P=C
<c<2Dc@d0e<e=@9C=SH2DcLg0e<h>09C>CT3DcXj0U<k>`=C?3`2Dcdm0U<n
?P=C?cl2Dd100e=1@@9C@T82Dd=30e=4A09CADD3DdI60U=7A`9CB4P3DdU9
0U=:BP=CBd/2Dda<0e==C@9CCTh2Ddm?0e=@D09CDE43De9B6/c<c10=0?lD
c<c<8IVIVEW<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo02_<c<`2E0000U@10@9D0P83E0<30U@410=D1@D2E0H60U@71`=D20P2
E0T90U@:2P=D2`/2E0`<0e@=3@9D3Ph2E0l?0e@@409D4A42E18B0e@C4`9D
51@3E1DE0U@F5P9D5aL3E1PH0U@I6@9D6QX3E1/K0U@L70=D7Ad2E1hN0U@O
7`=D8202E24Q0U@R8P=D8b<2E2@T0e@U9@9D9RH2E2LW0e@X:09D:BT3E2XZ
0U@[:`9D;2`3E2d]0U@^;P9D;bl3E30`0U@a<@=D<S82E3<c0U@d=0=D=CD2
E3Hf0U@g=`=D>3P2E3Ti0e@j>P9D>c/2E3`l0e@m?@9D?Sh2E3lo0eA0@09D
@D43E4920UA3@`9DA4@3E4E50UA6AP9DAdL3E4Q80UA9B@=DBTX2E4];0UA<
C0=DCDd2E4i>0UA?C`=DD502E55A0eABDP9DDe<00eADE<c<c<c<c00Hc<c<
40D0oaC<c<`00iVIVLc<c<c<c00Mc<c<00>IVIW<c<c<c<`0Elc<c004IVIV
R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c09E0002E@41
0UD20P=E0`<2E@@40UD51@=E1PH2E@L70UD820=E2@T2E@X:0UD;2`=E30`2
E@d=0UD>3P=E3`l2EA0@0UDA4@=E4Q82EA<C0UDD50=E5AD2EAHF0eDG5`9E
61P2EATI0eDJ6P9E6a/2EA`L0eDM7@9E7Qh2EAlO0eDP809E8B42EB8R0eDS
8`9E92@2EBDU0eDV9P9E9bL2EBPX0eDY:@9E:RX2EB/[0eD/;09E;Bd2EBh^
0eD_;`9E<302EC4a0eDb<P9E<c<2EC@d0eDe=@9E=SH2ECLg0eDh>09E>CT2
ECXj0eDk>`9E?3`2ECdm0eDn?P9E?cl3ED100UE1@@9E@T83ED=30UE4A09E
ADD3EDI60UE7A`9EB4P3EDU90UE:BP9EBd/3EDa<0UE=C@9ECTh3EDm?0UE@
D09EDE43EE9B0UECD`9EE5@2EEEE6/c<c1000olDc<c<00>IVIW<c<c<c<`0
7Lc<c003VIVIc<c<c<c<05O<c<`016IVIXS0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hoooo02_<c<`2E`000UL10@9G0P83E`<30UL4109G1@D2E`H6
0eL71`9G20P2E`T90eL:2P9G2`/2E``<0eL=3@9G3Ph2E`l?0eL@409G4A42
Ea8B0ULC4`=G51@2EaDE0ULF5P=G5aL2EaPH0ULI6@=G6QX2Ea/K0ULL70=G
7Ad2EahN0ULO7`9G8203Eb4Q0ULR8P9G8b<3Eb@T0ULU9@9G9RH3EbLW0ULX
:09G:BT3EbXZ0UL[:`9G;2`2Ebd]0eL^;P9G;bl2Ec0`0eLa<@9G<S82Ec<c
0eLd=09G=CD2EcHf0eLg=`9G>3P2EcTi0ULj>P=G>c/2Ec`l0ULm?@=G?Sh2
Eclo0UM0@0=G@D42Ed920UM3@`=GA4@2EdE50UM6AP9GAdL3EdQ80UM9B@9G
BTX3Ed];0UM<C09GCDd3Edi>0UM?C`9GD503Ee5A0UMBDP9GDe<2EeAD0eME
E@9GEUHJc<c<400:oaC<c<`00iVIVLc<c<c<c00Mc<c<00>IVIW<c<c<c<`0
Elc<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<
c09H0002F0410UP20P9H0`<3F0@40UP51@9H1PH3F0L70UP8209H2@T2F0X:
0eP;2`9H30`2F0d=0UP>3P=H3`l2F10@0UPA4@=H4Q82F1<C0UPD509H5AD3
F1HF0UPG5`9H61P2F1TI0ePJ6P9H6a/2F1`L0ePM7@9H7Qh2F1lO0UPP80=H
8B42F28R0UPS8`9H92@3F2DU0UPV9P9H9bL3F2PX0UPY:@9H:RX2F2/[0eP/
;09H;Bd2F2h^0UP_;`=H<302F34a0UPb<P=H<c<2F3@d0UPe=@9H=SH3F3Lg
0UPh>09H>CT2F3Xj0ePk>`9H?3`2F3dm0ePn?P9H?cl2F4100UQ1@@=H@T82
F4=30UQ4A09HADD3F4I60UQ7A`9HB4P3F4U90UQ:BP9HBd/2F4a<0eQ=C@9H
CTh2F4m?0eQ@D09HDE42F59B0UQCD`=HE5@2F5EE0UQFEP9HEeL00eQHF<c<
c<c<c00Hc<c<400BoaC<c<`00iVIVLc<c<c<c00Mc<c<00>IVIW<c<c<c<`0
Elc<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<
c09I0002F@410UT20P9I0`<3F@@40UT51@9I1PH2F@L70eT8209I2@T2F@X:
0UT;2`=I30`2F@d=0UT>3P9I3`l2FA0@0eTA4@9I4Q82FA<C0UTD50=I5AD2
FAHF0UTG5`9I61P3FATI0UTJ6P9I6a/2FA`L0eTM7@9I7Qh2FAlO0UTP80=I
8B42FB8R0UTS8`9I92@3FBDU0UTV9P9I9bL2FBPX0UTY:@=I:RX2FB/[0UT/
;09I;Bd3FBh^0UT_;`9I<302FC4a0eTb<P9I<c<2FC@d0UTe=@=I=SH2FCLg
0UTh>09I>CT3FCXj0UTk>`9I?3`2FCdm0eTn?P9I?cl2FD100UU1@@=I@T82
FD=30UU4A09IADD2FDI60eU7A`9IB4P2FDU90UU:BP=IBd/2FDa<0UU=C@9I
CTh3FDm?0UU@D09IDE42FE9B0eUCD`9IE5@2FEEE0UUFEP=IEeL2FEQH00=I
FEW<c<c<c<`06<c<c1006_l<c<c<100000C<c<`00iVIVLc<c<c<c00>c<c<
1@0000?<c<`300001<c<c003VIVIc<c<c<c<05O<c<`016IVIXS0^8S0^4R@
R04000000005R<2hb>3HR<2hR<2hoooo02_<c<`2F`000U/10@9K0P82F`<3
0U/410=K1@D2F`H60U/71`9K20P2F`T90e/:2P9K2`/2F``<0U/=3@=K3Ph2
F`l?0U/@409K4A42Fa8B0e/C4`9K51@2FaDE0U/F5P9K5aL3FaPH0U/I6@9K
6QX2Fa/K0U/L70=K7Ad2FahN0U/O7`9K8203Fb4Q0U/R8P9K8b<2Fb@T0U/U
9@=K9RH2FbLW0U/X:09K:BT2FbXZ0e/[:`9K;2`2Fbd]0U/^;P9K;bl3Fc0`
0U/a<@9K<S82Fc<c0U/d=0=K=CD2FcHf0U/g=`9K>3P3FcTi0U/j>P9K>c/2
Fc`l0U/m?@=K?Sh2Fclo0U]0@09K@D42Fd920e]3@`9KA4@2FdE50U]6AP9K
AdL3FdQ80U]9B@9KBTX2Fd];0e]<C09KCDd2Fdi>0U]?C`9KD503Fe5A0U]B
DP9KDe<2FeAD0U]EE@=KEUH2FeMG0U]HF09KFET2FeYJ6/c<c1008Ol;c<c<
0P0000;<c<`200000lc<c003VIVIc<c<c<c<00o<c<`00`000<c<c<c<c003
c<c<00D0003<c<c<c<c<c<`000000lc<c003VIVIc<c<c<c<05O<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo02_<c<`2G0000U`1
0@9L0P82G0<30U`4109L1@D3G0H60U`71`9L20P2G0T90U`:2P=L2`/2G0`<
0U`=3@9L3Ph2G0l?0U`@40=L4A42G18B0U`C4`9L51@2G1DE0e`F5P9L5aL2
G1PH0U`I6@9L6QX2G1/K0e`L709L7Ad2G1hN0U`O7`9L8202G24Q0e`R8P9L
8b<2G2@T0U`U9@9L9RH3G2LW0U`X:09L:BT2G2XZ0U`[:`9L;2`3G2d]0U`^
;P9L;bl2G30`0U`a<@=L<S82G3<c0U`d=09L=CD2G3Hf0U`g=`=L>3P2G3Ti
0U`j>P9L>c/2G3`l0U`m?@=L?Sh2G3lo0Ua0@09L@D42G4920ea3@`9LA4@2
G4E50Ua6AP9LAdL2G4Q80ea9B@9LBTX2G4];0Ua<C09LCDd3G4i>0Ua?C`9L
D502G55A0UaBDP9LDe<3G5AD0UaEE@9LEUH2G5MG0UaHF09LFET3G5YJ0UaK
Fa[<c<`@02Wo2/c<c0800003c<c<0P0000?<c<`00iVIVLc<c<c<c00@c<c<
00<0003<c<c<c<`01/c<c0050000c<c<c<c<c<c<VIVI05W<c<`016IVIXS0
^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo02_<c<`2G@000Ud10@9M
0P82G@<30Ud4109M1@D2G@H60ed71`9M20P2G@T90Ud:2P9M2`/2G@`<0ed=
3@9M3Ph2G@l?0Ud@409M4A42GA8B0UdC4`=M51@2GADE0UdF5P9M5aL2GAPH
0UdI6@9M6QX3GA/K0UdL709M7Ad2GAhN0UdO7`9M8202GB4Q0edR8P9M8b<2
GB@T0UdU9@9M9RH2GBLW0edX:09M:BT2GBXZ0Ud[:`9M;2`2GBd]0Ud^;P=M
;bl2GC0`0Uda<@9M<S82GC<c0Udd=09M=CD3GCHf0Udg=`9M>3P2GCTi0Udj
>P9M>c/3GC`l0Udm?@9M?Sh2GClo0Ue0@09M@D42GD920ee3@`9MA4@2GDE5
0Ue6AP9MAdL2GDQ80Ue9B@=MBTX2GD];0Ue<C09MCDd2GDi>0Ue?C`9MD503
GE5A0UeBDP9MDe<2GEAD0UeEE@9MEUH3GEMG0UeHF09MFET2GEYJ0UeKF`9M
G5`00eeMGLc<c<c<c00Hc<c<400`o`[<c<`200000lc<c0800003c<c<00>I
VIW<c<c<c<`04Lc<c0030000c<c<c<c<00G<c<`01@000<c<c<c<c<c<c9VI
V@1Ic<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[
c<c<0Uh0009N0@42GP820Uh30`9N10@2GPD50Uh61P9N1`L3GPP80Uh92@9N
2PX2GP/;0Uh<309N3@d2GPh>0Uh?3`9N4103GQ4A0UhB4P9N4a<2GQ@D0UhE
5@9N5QH2GQLG0UhH60=N6AT2GQXJ0UhK6`9N71`2GQdM0UhN7P9N7al2GR0P
0ehQ8@9N8R82GR<S0UhT909N9BD2GRHV0UhW9`9N:2P2GRTY0ehZ:P9N:b/2
GR`/0Uh];@9N;Rh2GRl_0Uh`<09N<C43GS8b0Uhc<`9N=3@2GSDe0Uhf=P9N
=cL2GSPh0Uhi>@=N>SX2GS/k0Uhl?09N?Cd2GShn0Uho?`9N@402GT510Ui2
@P=N@d<2GTA40Ui5A@9NATH2GTM70Ui8B09NBDT2GTY:0ei;B`9NC4`2GTe=
0Ui>CP9NCdl2GU1@0UiAD@9NDU83GU=C0UiDE09NEED2GUIF0UiGE`9NF5P2
GUUI0UiJFP9NFe/3GUaL0UiMG@03GUiNc<c<c<c<01S<c<`@03So2/c<c080
0002c<c<0`0000?<c<`00iVIVLc<c<c<c00Ac<c<00<0003<c<c<c<`00lc<
c0800004c<c<00>IVIW<c<c<c<`0Elc<c004IVIVR<2hR<2hB9280@000000
00F8`;S8h=R8`;R8`;Soool0:lc<c09P0002H0410V020P9P0`<2H0@40V05
1@9P1PH2H0L70V08209P2@T2H0X:0f0;2`9P30`2H0d=0V0>3P9P3`l2H10@
0V0A4@9P4Q82H1<C0V0D509P5AD3H1HF0V0G5`9P61P2H1TI0V0J6P9P6a/2
H1`L0V0M7@9P7Qh2H1lO0V0P80=P8B42H28R0V0S8`9P92@2H2DU0V0V9P9P
9bL2H2PX0V0Y:@9P:RX2H2/[0f0/;09P;Bd2H2h^0V0_;`9P<302H34a0V0b
<P9P<c<2H3@d0V0e=@9P=SH3H3Lg0V0h>09P>CT2H3Xj0V0k>`9P?3`2H3dm
0V0n?P9P?cl2H4100V11@@=P@T82H4=30V14A09PADD2H4I60V17A`9PB4P2
H4U90V1:BP9PBd/2H4a<0f1=C@9PCTh2H4m?0V1@D09PDE42H59B0V1CD`9P
E5@2H5EE0V1FEP=PEeL2H5QH0V1IF@9PFUX2H5]K0V1LG09PGEd2H5iN0V1O
Ga[<c<`@043o2/c<c0800008c<c<00>IVIW<c<c<c<`04/c<c0030000c<c<
c<c<00C<c<`01@000<c<c<c<c<c<c9VIV@1Ic<c<00AVIVJ8`;R8`;Q8T8P1
000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0V40009Q0@42H@820V430`9Q
10@2H@D50V461P9Q1`L2H@P80V492@9Q2PX2H@/;0V4<309Q3@d2H@h>0V4?
3`=Q4102HA4A0V4B4P9Q4a<2HA@D0V4E5@9Q5QH2HALG0V4H609Q6AT2HAXJ
0V4K6`9Q71`2HAdM0V4N7P=Q7al2HB0P0V4Q8@9Q8R82HB<S0V4T909Q9BD2
HBHV0V4W9`9Q:2P2HBTY0V4Z:P9Q:b/2HB`/0V4];@9Q;Rh3HBl_0V4`<09Q
<C42HC8b0V4c<`9Q=3@2HCDe0V4f=P9Q=cL2HCPh0V4i>@9Q>SX2HC/k0V4l
?09Q?Cd2HChn0f4o?`9Q@402HD510V52@P9Q@d<2HDA40V55A@9QATH2HDM7
0V58B09QBDT2HDY:0V5;B`9QC4`2HDe=0f5>CP9QCdl2HE1@0V5AD@9QDU82
HE=C0V5DE09QEED2HEIF0V5GE`9QF5P2HEUI0V5JFP9QFe/2HEaL0V5MG@=Q
GUh2HEmO0V5PH1[<c<`@04Oo2/c<c0800008c<c<00>IVIW<c<c<c<`04/c<
c0030000c<c<c<c<00C<c<`01@000<c<c<c<c<c<c9VIV@1Ic<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0V80009R0@42
HP820V830`9R10@2HPD50V861P9R1`L2HPP80V892@9R2PX2HP/;0V8<309R
3@d2HPh>0V8?3`9R4102HQ4A0V8B4P9R4a<2HQ@D0V8E5@9R5QH2HQLG0V8H
609R6AT2HQXJ0f8K6`9R71`2HQdM0V8N7P9R7al2HR0P0V8Q8@9R8R82HR<S
0V8T909R9BD2HRHV0V8W9`9R:2P2HRTY0V8Z:P9R:b/2HR`/0V8];@9R;Rh2
HRl_0V8`<09R<C42HS8b0V8c<`9R=3@2HSDe0f8f=P9R=cL2HSPh0V8i>@9R
>SX2HS/k0V8l?09R?Cd2HShn0V8o?`9R@402HT510V92@P9R@d<2HTA40V95
A@9RATH2HTM70V98B09RBDT2HTY:0V9;B`9RC4`2HTe=0V9>CP9RCdl2HU1@
0f9AD@9RDU82HU=C0V9DE09REED2HUIF0V9GE`9RF5P2HUUI0V9JFP9RFe/2
HUaL0V9MG@9RGUh2HUmO0V9PH09RHF400f9RH/c<c<c<c00Hc<c<401?o`_<
c<`200000/c<c0800003c<c<00>IVIW<c<c<c<`03/c<c0050000c<c<c<c<
c<c<000000;<c<`01@000<c<c<c<c<c<c0000003c<c<00>IVIW<c<c<c<`0
Elc<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<
c09S0002H`410V<20P9S0`<2H`@40V<51@9S1PH2H`L70V<8209S2@T2H`X:
0V<;2`9S30`2H`d=0V<>3P9S3`l2Ha0@0V<A4@9S4Q82Ha<C0V<D509S5AD2
HaHF0V<G5`9S61P2HaTI0V<J6P9S6a/2Ha`L0V<M7@9S7Qh2HalO0V<P809S
8B42Hb8R0V<S8`9S92@2HbDU0V<V9P9S9bL2HbPX0V<Y:@9S:RX2Hb/[0V</
;09S;Bd2Hbh^0V<_;`9S<302Hc4a0V<b<P9S<c<2Hc@d0V<e=@9S=SH2HcLg
0V<h>09S>CT2HcXj0V<k>`9S?3`2Hcdm0V<n?P9S?cl2Hd100V=1@@9S@T82
Hd=30V=4A09SADD2HdI60V=7A`9SB4P2HdU90V=:BP9SBd/2Hda<0V==C@9S
CTh2Hdm?0V=@D09SDE42He9B0V=CD`9SE5@2HeEE0V=FEP9SEeL2HeQH0V=I
F@=SFUX2He]K0V=LG09SGEd2HeiN0V=OG`9SH602Hf5Q0V=RHP03Hf=Sc<c<
c<c<01S<c<`@05Oo3<c<c0@00004c<c<00>IVIW<c<c<c<`03lc<c0<00004
c<c<0`0000C<c<`00iVIVLc<c<c<c01Gc<c<00AVIVJ8`;R8`;Q8T8P10000
00001HS0^<SPf8S0^8S0^?ooo`0[c<c<00=U001U0@5U0@400VD20P9U0`<2
I@@40VD51@9U1PH2I@L70VD8209U2@T2I@X:0VD;2`9U30`2I@d=0VD>3P9U
3`l2IA0@0VDA4@9U4Q82IA<C0VDD509U5AD2IAHF0VDG5`9U61P2IATI0VDJ
6P9U6a/2IA`L0VDM7@9U7Qh2IAlO0VDP809U8B42IB8R0VDS8`9U92@2IBDU
0VDV9P9U9bL2IBPX0VDY:@9U:RX2IB/[0VD/;09U;Bd2IBh^0VD_;`9U<302
IC4a0VDb<P9U<c<2IC@d0VDe=@9U=SH2ICLg0VDh>09U>CT2ICXj0VDk>`9U
?3`2ICdm0VDn?P9U?cl2ID100VE1@@9U@T82ID=30VE4A003IDE5IDI6IDI6
009UAdL2IDQ80VE9B@9UBTX2ID];0VE<C09UCDd2IDi>0VE?C`9UD502IE5A
0VEBDP9UDe<2IEAD0VEEE@9UEUH2IEMG0VEHF09UFET2IEYJ0VEKF`9UG5`2
IEeM0VENGP9UGel2IF1P0VEQH@9UHV82IF=S0VETI1[<c<`@05ko5<c<c003
VIVIc<c<c<c<01g<c<`00iVIVLc<c<c<c01Gc<c<00AVIVJ8`;R8`;Q8T8P1
000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<00=V001V0@5V0@400VH20P9V
0`<2IP@40VH51@9V1PH2IPL70VH8209V2@T2IPX:0VH;2`9V30`2IPd=0VH>
3P9V3`l2IQ0@0VHA4@9V4Q82IQ<C0VHD509V5AD2IQHF0VHG5`9V61P2IQTI
00=V6QYV6a]V6a/00VHL709V7Ad2IQhN0VHO7`9V8202IR4Q0VHR8P9V8b<2
IR@T0VHU9@9V9RH2IRLW0VHX:09V:BT2IRXZ0VH[:`9V;2`2IRd]0VH^;P9V
;bl2IS0`0VHa<@9V<S800fHc<fHd=6Hd=002ISDe0VHf=P9V=cL2ISPh0VHi
>@9V>SX2IS/k0VHl?09V?Cd2IShn0VHo?`9V@402IT510VI2@P9V@d<2ITA4
0VI5A@9VATH2ITM70VI8B09VBDT2ITY:0VI;B`9VC4`00fI=CFI>CVI>CP02
ITm?0VI@D09VDE42IU9B0VICD`9VE5@2IUEE0VIFEP9VEeL2IUQH0VIIF@9V
FUX2IU]K0VILG09VGEd2IUiN0VIOG`9VH602IV5Q0VIRHP9VHf<2IVAT0VIU
IA[<c<`@06Ko5<c<c003VIVIc<c<c<c<01g<c<`00iVIVLc<c<c<c01Gc<c<
00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<00=W
001W0@5W0@400VL20P9W0`<2I`@40VL51@9W1PH2I`L70VL8209W2@T2I`X:
0VL;2`9W30`2I`d=0VL>3P9W3`l00fL@46LA4FLA4@02Ia8B0VLC4`9W51@2
IaDE0VLF5P9W5aL2IaPH0VLI6@9W6QX2Ia/K0VLL709W7Ad2IahN0VLO7`03
Ib0PIb4QIb4Q009W8R82Ib<S0VLT909W9BD2IbHV0VLW9`9W:2P2IbTY0VLZ
:P9W:b/2Ib`/0VL];@9W;Rh00fL_;fL`<6L`<002Ic4a0VLb<P9W<c<2Ic@d
0VLe=@9W=SH2IcLg0VLh>09W>CT2IcXj0VLk>`9W?3`2Icdm0VLn?P03Iclo
Id10Id10009W@D42Id920VM3@`9WA4@2IdE50VM6AP9WAdL2IdQ80VM9B@9W
BTX2Id];0VM<C09WCDd2Idi>00=WCdmWD51WD5000VMAD@9WDU82Ie=C0VMD
E09WEED2IeIF0VMGE`9WF5P2IeUI0VMJFP9WFe/2IeaL0VMMG@9WGUh00fMO
GfMPH6MPH002If5Q0VMRHP9WHf<2IfAT0VMUI@9WIVH00fMWIlc<c<c<c00H
c<c<401^oaC<c<`00iVIVLc<c<c<c00Mc<c<00>IVIW<c<c<c<`0Elc<c004
IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c003J@00
J@41J@41009Y0P82J@<30VT4109Y1@D2J@H60VT71`9Y20P2J@T90VT:2P03
J@/;J@`<J@`<009Y3@d2J@h>0VT?3`9Y4102JA4A0VTB4P9Y4a<2JA@D0VTE
5@9Y5QH00fTG5fTH66TH6002JATI0VTJ6P9Y6a/2JA`L0VTM7@9Y7Qh2JAlO
0VTP809Y8B400fTR8VTS8fTS8`02JB@T0VTU9@9Y9RH2JBLW0VTX:09Y:BT2
JBXZ0VT[:`9Y;2`2JBd]00=Y;RiY;bmY;bl00VT`<09Y<C42JC8b0VTc<`9Y
=3@2JCDe0VTf=P9Y=cL2JCPh00=Y>CUY>SYY>SX00VTk>`9Y?3`2JCdm0VTn
?P9Y?cl2JD100VU1@@9Y@T82JD=30VU4A003JDE5JDI6JDI6009YAdL2JDQ8
0VU9B@9YBTX2JD];0VU<C09YCDd2JDi>0VU?C`03JE1@JE5AJE5A009YDU82
JE=C0VUDE09YEED2JEIF0VUGE`9YF5P2JEUI0VUJFP9YFe/00fULG6UMGFUM
G@02JEiN0VUOG`9YH602JF5Q0VURHP9YHf<2JFAT0VUUI@9YIVH00fUWIfUX
J6UXJ00Jc<c<401eoaC<c<`00iVIVLc<c<c<c00Mc<c<00>IVIW<c<c<c<`0
Elc<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<
c003JP00JP41JP41009Z0P82JP<30VX4109Z1@D2JPH60VX71`9Z20P00fX9
2FX:2VX:2P02JP/;0VX<309Z3@d2JPh>0VX?3`9Z4102JQ4A00=Z4Q9Z4a=Z
4a<00VXD509Z5AD2JQHF0VXG5`9Z61P2JQTI0VXJ6P03JQ/KJQ`LJQ`L009Z
7Ad2JQhN0VXO7`9Z8202JR4Q0VXR8P9Z8b<00fXT96XU9FXU9@02JRHV0VXW
9`9Z:2P2JRTY0VXZ:P9Z:b/2JR`/00=Z;BeZ;RiZ;Rh00VX_;`9Z<302JS4a
0VXb<P9Z<c<2JS@d0VXe=@9Z=SH00fXg=fXh>6Xh>002JSTi0VXj>P9Z>c/2
JS`l0VXm?@9Z?Sh2JSlo00=Z@41Z@D5Z@D400VY2@P9Z@d<2JTA40VY5A@9Z
ATH2JTM70VY8B003JTU9JTY:JTY:009ZBd/2JTa<0VY=C@9ZCTh2JTm?0VY@
D09ZDE400fYBDVYCDfYCD`02JUAD0VYEE@9ZEUH2JUMG0VYHF09ZFET2JUYJ
00=ZFe]ZG5aZG5`00VYMG@9ZGUh2JUmO0VYPH09ZHF42JV9R0VYSH`03JVAT
JVEUJVEU009ZIVH2JVMW0VYXJ09ZJFTJc<c<401moaC<c<`00iVIVLc<c<c<
c00Mc<c<00>IVIW<c<c<c<`0Elc<c004IVIVR<2hR<2hB9280@00000000F8
`;S8h=R8`;R8`;Soool0:lc<c003J`00J`41J`41009[0P82J`<30V/4109[
1@D2J`H60V/71`03J`P8J`T9J`T9009[2PX2J`/;0V/<309[3@d2J`h>00=[
3`m[411[41000V/A4@9[4Q82Ja<C0V/D509[5AD2JaHF00=[5aM[61Q[61P0
0V/I6@9[6QX2Ja/K0V/L709[7Ad00f/N7V/O7f/O7`02Jb0P0V/Q8@9[8R82
Jb<S0V/T909[9BD00f/V9V/W9f/W9`02JbPX0V/Y:@9[:RX2Jb/[0V//;003
Jbd]Jbh^Jbh^009[;bl2Jc0`0V/a<@9[<S82Jc<c0V/d=003JcDeJcHfJcHf
009[=cL2JcPh0V/i>@9[>SX2Jc/k00=[?3a[?Ce[?Cd00V/n?P9[?cl2Jd10
0V]1@@9[@T82Jd=300=[A4A[ADE[ADD00V]6AP9[AdL2JdQ80V]9B@9[BTX0
0f];Bf]<C6]<C002Jde=0V]>CP9[Cdl2Je1@0V]AD@9[DU800f]CDf]DE6]D
E002JeEE0V]FEP9[EeL2JeQH0V]IF@9[FUX00f]KFf]LG6]LG002JeeM0V]N
GP9[Gel2Jf1P0V]QH@03Jf9RJf=SJf=S009[I6@2JfEU0V]VIP9[IfL2JfQX
0V]YJ@03JfYZJf][c<c<01W<c<`@08Go5<c<c26IVIUIc<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<00=/001/0@5/0@40
0V`20P9/0`<2K0@40V`51@03K0H6K0L7K0L7009/20P2K0T90V`:2P9/2`/2
K0`<00=/3@e/3Pi/3Ph00V`?3`9/4102K14A0V`B4P03K1<CK1@DK1@D009/
5AD2K1HF0V`G5`9/61P2K1TI00=/6QY/6a]/6a/00V`L709/7Ad2K1hN0V`O
7`03K20PK24QK24Q009/8R82K2<S0V`T909/9BD2K2HV00=/9bM/:2Q/:2P0
0V`Y:@9/:RX2K2/[0V`/;003K2d]K2h^K2h^009/;bl2K30`0V`a<@9/<S82
K3<c00=/=3A/=CE/=CD00V`f=P9/=cL2K3Ph0V`i>@03K3XjK3/kK3/k009/
?3`2K3dm0V`n?P9/?cl2K41000=/@D5/@T9/@T800Va3@`9/A4@2K4E50Va6
AP03K4M7K4Q8K4Q8009/BDT2K4Y:0Va;B`9/C4`2K4e=00=/CTi/Cdm/Cdl0
0Va@D09/DE42K59B0VaCD`03K5ADK5EEK5EE009/EUH2K5MG0VaHF09/FET2
K5YJ00=/Fe]/G5a/G5`00VaMG@9/GUh2K5mO0VaPH003K65QK69RK69R009/
Hf<2K6AT0VaUI@9/IVH2K6MW00=/J6Q/JFU/JFT00VaZJP9/Jf/00fa/K<c<
c<c<c00Hc<c<402<ohk<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3H
R<2hR<2hoooo02_<c<`00fh006h10Fh10@02KP820Vh30`9^10@2KPD500=^
1PI^1`M^1`L00Vh8209^2@T2KPX:00=^2`]^30a^30`00Vh=3@9^3Ph2KPl?
0Vh@4003KQ4AKQ8BKQ8B009^4a<2KQ@D0VhE5@9^5QH00fhG5fhH66hH6002
KQTI0VhJ6P9^6a/00fhL76hM7FhM7@02KQhN0VhO7`9^8202KR4Q00=^8R9^
8b=^8b<00VhT909^9BD2KRHV0VhW9`03KRPXKRTYKRTY009^:RX2KR/[0Vh/
;003KRd]KRh^KRh^009^;bl2KS0`0Vha<@9^<S800fhc<fhd=6hd=002KSDe
0Vhf=P9^=cL2KSPh00=^>CU^>SY^>SX00Vhk>`9^?3`2KSdm00=^?Si^?cm^
?cl00Vi0@09^@D42KT920Vi3@`03KTA4KTE5KTE5009^ATH2KTM70Vi8B09^
BDT00fi:BVi;Bfi;B`02KTa<0Vi=C@9^CTh2KTm?00=^D51^DE5^DE400ViB
DP9^De<2KUAD00=^EEE^EUI^EUH00ViGE`9^F5P2KUUI0ViJFP03KU]KKUaL
KUaL009^GEd2KUiN0ViOG`9^H6000fiQHFiRHViRHP02KV=S0ViTI09^IFD0
0fiVIViWIfiWI`02KVQX0ViYJ@9^JVX2KV][00=^K6a^KFe^KFd06/c<c100
U?n>c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[
c<c<00=_001_0@5_0@400Vl20P9_0`<2K`@400=_1@E_1PI_1PH00Vl71`9_
20P2K`T900=_2PY_2`]_2`/00Vl<309_3@d2K`h>00=_3`m_411_41000VlA
4@9_4Q82Ka<C00=_51A_5AE_5AD00VlF5P9_5aL2KaPH00=_6AU_6QY_6QX0
0VlK6`9_71`2KadM00=_7Qi_7am_7al00VlP809_8B42Kb8R0VlS8`03Kb@T
KbDUKbDU009_9RH2KbLW0VlX:003KbTYKbXZKbXZ009_:b/2Kb`/0Vl];@03
Kbh^Kbl_Kbl_009_<302Kc4a0Vlb<P03Kc<cKc@dKc@d009_=CD2KcHf0Vlg
=`03KcPhKcTiKcTi009_>SX2Kc/k0Vll?003KcdmKchnKchn009_?cl2Kd10
0Vm1@@03Kd92Kd=3Kd=3009_A4@2KdE50Vm6AP03KdM7KdQ8KdQ8009_BDT2
KdY:0Vm;B`03Kda<Kde=Kde=009_CTh2Kdm?0Vm@D003Ke5AKe9BKe9B009_
De<2KeAD0VmEE@03KeIFKeMGKeMG009_F5P2KeUI0VmJFP03Ke]KKeaLKeaL
009_GEd2KeiN0VmOG`03Kf1PKf5QKf5Q009_HV82Kf=S0VmTI09_IFD00fmV
IVmWIfmWI`02KfQX0VmYJ@9_JVX00fm[Jfm/K6m/K002Kfe]0Vm^KQ[<c<`@
09co5<c<c26IVIUIc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^?ooo`0[c<c<00=`001`0@5`0@400W020P9`0`<2L0@400=`1@E`1PI`
1PH00W071`9`20P00g092G0:2W0:2P02L0/;0W0<309`3@d00g0>3W0?3g0?
3`02L10@0W0A4@03L18BL1<CL1<C009`51@2L1DE0W0F5P03L1LGL1PHL1PH
009`6AT2L1XJ0W0K6`03L1`LL1dML1dM009`7Qh2L1lO00=`821`8B5`8B40
0W0R8P9`8b<2L2@T00=`9BE`9RI`9RH00W0W9`9`:2P00g0Y:G0Z:W0Z:P02
L2/[0W0/;09`;Bd00g0^;W0_;g0_;`02L30`0W0a<@9`<S800g0c<g0d=70d
=002L3De0W0f=P03L3LgL3PhL3Ph009`>CT2L3Xj0W0k>`03L3`lL3dmL3dm
009`?Sh2L3lo00=`@41`@D5`@D400W12@P9`@d<2L4A400=`ADE`ATI`ATH0
0W17A`9`B4P2L4U900=`BTY`Bd]`Bd/00W1<C09`CDd00g1>CW1?Cg1?C`02
L51@0W1AD@9`DU800g1CDg1DE71DE002L5EE0W1FEP03L5MGL5QHL5QH009`
FET2L5YJ0W1KF`03L5aLL5eML5eM009`GUh2L5mO0W1PH003L65QL69RL69R
009`Hf<2L6AT00=`IFE`IVI`IVH00W1WI`9`J6P2L6UY00=`JVY`Jf]`Jf/0
0W1/K09`KFd0171^KW1_Kg1_Kg1`L1[<c<`@0:?o5<c<c003VIVIc<c<c<c<
01g<c<`00iVIVLc<c<c<c01Gc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`0[c<c<00=a001a0@5a0@400W420P9a0`<00g441745
1G451@02L@H60W471`03L@P8L@T9L@T9009a2PX2L@/;0W4<3003L@d=L@h>
L@h>009a3`l2LA0@00=a4A5a4Q9a4Q800W4C4`9a51@00g4E5G4F5W4F5P02
LALG0W4H6003LATILAXJLAXJ009a6a/2LA`L00=a7Aea7Qia7Qh00W4O7`9a
8202LB4Q00=a8R9a8b=a8b<00W4T909a9BD00g4V9W4W9g4W9`02LBPX0W4Y
:@03LBXZLB/[LB/[009a;2`2LBd]00=a;Ria;bma;bl00W4`<09a<C42LC8b
00=a<c=a=3Aa=3@00W4e=@9a=SH00g4g=g4h>74h>002LCTi0W4j>P03LC/k
LC`lLC`l009a?Cd2LChn00=a?cma@41a@4000W51@@9a@T800g53@g54A754
A002LDE50W56AP9aAdL00g58B759BG59B@02LDY:0W5;B`03LDa<LDe=LDe=
009aCTh2LDm?00=aD51aDE5aDE400W5BDP9aDe<00g5DE75EEG5EE@02LEIF
0W5GE`03LEQHLEUILEUI009aFUX2LE]K0W5LG003LEeMLEiNLEiN009aGel2
LF1P00=aHF5aHV9aHV800W5SH`9aI6@00g5UIG5VIW5VIP02LFMW0W5XJ003
LFUYLFYZLFYZ009aJf/2LFa/00=aKFeaKViaKVh00W5_K`9aL7000g5aLLc<
c<c<c00Hc<c<402[oaC<c<`00iVIVLc<c<c<c00Mc<c<00>IVIW<c<c<c<`0
Elc<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<
c003L`00L`41L`41009c0P82L`<300=c10Ac1@Ec1@D00W<61P9c1`L00g<8
27<92G<92@02L`X:0W<;2`03L``<L`d=L`d=009c3Ph2L`l?00=c411c4A5c
4A400W<B4P03La<CLa@DLa@D009c5AD2LaHF00=c5aMc61Qc61P00W<I6@9c
6QX00g<K6g<L77<L7002LadM0W<N7P03LalOLb0PLb0P009c8B42Lb8R00=c
8b=c92Ac92@00W<U9@9c9RH00g<W9g<X:7<X:002LbTY0W<Z:P03Lb/[Lb`/
Lb`/009c;Bd2Lbh^00=c;bmc<31c<3000W<a<@9c<S800g<c<g<d=7<d=002
LcDe00=c=SIc=cMc=cL00W<h>09c>CT00g<j>W<k>g<k>`02Lc`l0W<m?@03
LchnLcloLclo009c@402Ld5100=c@T9c@d=c@d<00W=4A09cADD00g=6AW=7
Ag=7A`02LdQ80W=9B@03LdY:Ld];Ld];009cC4`2Lde=00=cCTicCdmcCdl0
0W=@D09cDE400g=BDW=CDg=CD`02LeAD0W=EE@03LeIFLeMGLeMG009cF5P0
0g=IFG=JFW=JFP02Le]K0W=LG003LeeMLeiNLeiN009cGel2Lf1P00=cHF5c
HV9cHV800W=SH`9cI6@00g=UIG=VIW=VIP02LfMW0W=XJ003LfUYLfYZLfYZ
009cJf/2Lfa/00=cKFecKVicKVh00W=_K`9cL7000g=aLG=bLW=bLP0Jc<c<
402boaC<c<`00iVIVLc<c<c<c00Mc<c<00>IVIW<c<c<c<`0Elc<c004IVIV
R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c003M000M041
M041009d0P82M0<300=d10Ad1@Ed1@D00W@61P03M0L7M0P8M0P8009d2@T2
M0X:00=d2`]d30ad30`00W@=3@03M0h>M0l?M0l?009d4102M14A00=d4Q9d
4a=d4a<00W@D509d5AD00g@F5W@G5g@G5`02M1PH00=d6AUd6QYd6QX00W@K
6`9d71`00g@M7G@N7W@N7P02M1lO0W@P8003M24QM28RM28R009d8b<00g@T
97@U9G@U9@02M2HV0W@W9`03M2PXM2TYM2TY009d:RX00g@[:g@/;7@/;002
M2d]0W@^;P03M2l_M30`M30`009d<C42M38b00=d<c=d=3Ad=3@00W@e=@03
M3HfM3LgM3Lg009d>3P2M3Ti00=d>SYd>c]d>c/00W@l?09d?Cd00g@n?W@o
?g@o?`02M41000=d@D5d@T9d@T800WA3@`9dA4@00gA5AGA6AWA6AP02M4M7
00=dB4QdBDUdBDT00WA:BP9dBd/00gA<C7A=CGA=C@02M4i>0WA?C`03M51@
M55AM55A009dDU800gACDgADE7ADE002M5EE0WAFEP03M5MGM5QHM5QH009d
FET2M5YJ00=dFe]dG5adG5`00WAMG@03M5iNM5mOM5mO009dH602M65Q00=d
HV9dHf=dHf<00WATI003M6EUM6IVM6IV009dIfL2M6QX00=dJFUdJVYdJVX0
0WA[J`9dK6`00gA]KGA^KWA^KP02M6m_00=dL71dLG5dLG400WAbLP9dLg<J
c<c<402joaC<c<`00iVIVLc<c<c<c00Mc<c<00>IVIW<c<c<c<`0Elc<c004
IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c003M@00
M@41M@41009e0P800gD30gD417D41002M@D50WD61P03M@L7M@P8M@P8009e
2@T00gD:2WD;2gD;2`02M@`<0WD=3@03M@h>M@l?M@l?009e41000gDA4GDB
4WDB4P02MA<C00=e51Ae5AEe5AD00WDF5P9e5aL00gDH67DI6GDI6@02MAXJ
00=e6a]e71ae71`00WDM7@9e7Qh00gDO7gDP87DP8002MB4Q00=e8R9e8b=e
8b<00WDT9003MBDUMBHVMBHV009e9bL2MBPX00=e:BUe:RYe:RX00WD[:`03
MB`/MBd]MBd]009e;Rh00gD_;gD`<7D`<002MC4a0WDb<P03MC<cMC@dMC@d
009e=CD00gDf=WDg=gDg=`02MCPh0WDi>@03MCXjMC/kMC/k009e?3`00gDm
?GDn?WDn?P02MClo00=e@41e@D5e@D400WE2@P9e@d<00gE4A7E5AGE5A@02
MDI600=eAdMeB4QeB4P00WE9B@9eBTX00gE;BgE<C7E<C002MDe=00=eCTie
CdmeCdl00WE@D003ME5AME9BME9B009eDe<2MEAD00=eEEEeEUIeEUH00WEG
E`03MEQHMEUIMEUI009eFUX2ME]K00=eG5aeGEeeGEd00WENGP03MEmOMF1P
MF1P009eHF400gERHWESHgESH`02MFAT0WEUI@03MFIVMFMWMFMW009eJ6P0
0gEYJGEZJWEZJP02MF][00=eK6aeKFeeKFd00WE^KP9eKfl00gE`L7EaLGEa
L@02MG9b00AeLg=eM7AeM7AeMGDJc<c<4032o`[<c<`200001<c<c0800002
c<c<00>IVIW<c<c<c<`01lc<c0D00002c<c<1@0000?<c<`300001<c<c003
VIVIc<c<c<c<05O<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo02_<c<`00gL007L10GL10@02M`8200=g0`=g10Ag10@00WL51@03
M`H6M`L7M`L7009g20P2M`T900=g2PYg2`]g2`/00WL<3003M`d=M`h>M`h>
009g3`l00gL@47LA4GLA4@02Ma8B00=g4a=g51Ag51@00WLE5@03MaHFMaLG
MaLG009g61P2MaTI00=g6QYg6a]g6a/00WLL7003MadMMahNMahN009g7al0
0gLP87LQ8GLQ8@02Mb8R00=g8b=g92Ag92@00WLU9@03MbHVMbLWMbLW009g
:2P00gLY:GLZ:WLZ:P02Mb/[0WL/;003Mbd]Mbh^Mbh^009g;bl00gL`<7La
<GLa<@02Mc8b00=g<c=g=3Ag=3@00WLe=@03McHfMcLgMcLg009g>3P00gLi
>GLj>WLj>P02Mc/k0WLl?003McdmMchnMchn009g?cl00gM0@7M1@GM1@@02
Md9200=g@d=gA4AgA4@00WM5A@03MdI6MdM7MdM7009gB4P00gM9BGM:BWM:
BP02Md];0WM<C003Mde=Mdi>Mdi>009gCdl00gM@D7MADGMAD@02Me9B00=g
De=gE5AgE5@00WMEE@03MeIFMeMGMeMG009gF5P00gMIFGMJFWMJFP02Me]K
0WMLG003MeeMMeiNMeiN009gGel00gMPH7MQHGMQH@02Mf9R00=gHf=gI6Ag
I6@00WMUI@03MfIVMfMWMfMW009gJ6P00gMYJGMZJWMZJP02Mf][0WM/K003
Mfe]Mfi^Mfi^009gKfl00gM`L7MaLGMaL@02Mg9b00=gLg=gM7AgM7@00WMe
M@03MgIfc<c<c<c<01S<c<`@0<Wo2/c<c0800003c<c<0P0000?<c<`00iVI
VLc<c<c<c008c<c<00<0003<c<c<c<`01<c<c0030000c<c<c<c<00?<c<`0
1@000<c<c<c<c<c<c0000003c<c<00>IVIW<c<c<c<`0Elc<c004IVIVR<2h
R<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c003N000N041N041
009h0P800gP30gP417P41002N0D500=h1PIh1`Mh1`L00WP82003N0T9N0X:
N0X:009h2`/00gP<37P=3GP=3@02N0h>00=h3`mh411h41000WPA4@03N18B
N1<CN1<C009h51@00gPE5GPF5WPF5P02N1LG00=h61Qh6AUh6AT00WPJ6P03
N1/KN1`LN1`L009h7Ad00gPN7WPO7gPO7`02N20P00=h8B5h8R9h8R800WPS
8`03N2@TN2DUN2DU009h9RH00gPW9gPX:7PX:002N2TY00=h:RYh:b]h:b/0
0WP/;003N2d]N2h^N2h^009h;bl00gP`<7Pa<GPa<@02N38b00=h<c=h=3Ah
=3@00WPe=@03N3HfN3LgN3Lg009h>3P00gPi>GPj>WPj>P02N3/k00=h?3ah
?Ceh?Cd00WPn?P03N3loN410N410009h@D400gQ2@WQ3@gQ3@`02N4A400=h
ADEhATIhATH00WQ7A`03N4Q8N4U9N4U9009hBTX00gQ;BgQ<C7Q<C002N4e=
00=hCTihCdmhCdl00WQ@D09hDE400gQBDWQCDgQCD`02N5AD00=hEEEhEUIh
EUH00WQGE`03N5QHN5UIN5UI009hFUX00gQKFgQLG7QLG002N5eM00=hGUih
GemhGel00WQPH003N65QN69RN69R009hHf<00gQTI7QUIGQUI@02N6IV00=h
IfMhJ6QhJ6P00WQYJ@03N6YZN6][N6][009hK6`00gQ]KGQ^KWQ^KP02N6m_
00=hL71hLG5hLG400WQbLP03N7=cN7AdN7Ad009hMGD00gQfMWQgMgQgM`0J
c<c<403Ao`[<c<`200000lc<c0800003c<c<00>IVIW<c<c<c<`02Lc<c003
0000c<c<c<c<00C<c<`00`000<c<c<c<c006c<c<00D0003<c<c<c<c<c<bI
VIT0FLc<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0
:lc<c003N@00N@41N@41009i0P800gT30gT417T41002N@D500=i1PIi1`Mi
1`L00WT82004N@T9N@X:N@X:N@/;0WT<309i3@d00gT>3WT?3gT?3`02NA0@
00=i4A5i4Q9i4Q800WTC4`03NA@DNADENADE009i5QH00gTG5gTH67TH6002
NATI00=i6QYi6a]i6a/00WTL7003NAdMNAhNNAhN009i7al017TP87TQ8GTQ
8GTR8P9i8b<2NB@T00=i9BEi9RIi9RH00WTW9`03NBPXNBTYNBTY009i:RX0
0gT[:gT/;7T/;002NBd]00=i;Rii;bmi;bl00WT`<003NC4aNC8bNC8b009i
<c<017Td=7Te=GTe=GTf=P9i=cL2NCPh00=i>CUi>SYi>SX00WTk>`03NC`l
NCdmNCdm009i?Sh00gTo?gU0@7U0@002ND5100=i@T9i@d=i@d<00WU4A003
NDE5NDI6NDI6009iAdL00gU8B7U9BGU9B@02NDY:00AiBd]iC4aiC4aiCDd2
NDi>0WU?C`03NE1@NE5ANE5A009iDU800gUCDgUDE7UDE002NEEE00=iEUIi
EeMiEeL00WUHF003NEUINEYJNEYJ009iFe/00gULG7UMGGUMG@02NEiN00Ai
GemiH61iH61iHF42NF9R0WUSH`03NFATNFEUNFEU009iIVH00gUWIgUXJ7UX
J002NFUY00=iJVYiJf]iJf/00WU/K003NFe]NFi^NFi^009iKfl00gU`L7Ua
LGUaL@02NG9b00=iLg=iM7AiM7@00WUeM@05NGIfNGMgNGMgNGQhNGUi01[<
c<`@0=Wo2/c<c0800002c<c<0P0000C<c<`00iVIVLc<c<c<c00:c<c<00<0
003<c<c<c<`01<c<c0030000c<c<c<c<00G<c<`01@000<c<c<c<c<c<c9VI
V@1Ic<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[
c<c<00=j001j0@5j0@400WX20P04NP<3NP@4NP@4NPD50WX61P9j1`L00gX8
27X92GX92@02NPX:00=j2`]j30aj30`00WX=3@04NPh>NPl?NPl?NQ0@0WXA
4@9j4Q800gXC4gXD57XD5002NQDE00=j5QIj5aMj5aL00WXH6004NQTINQXJ
NQXJNQ/K0WXL709j7Ad00gXN7WXO7gXO7`02NR0P00=j8B5j8R9j8R800WXS
8`04NR@TNRDUNRDUNRHV0WXW9`9j:2P00gXY:GXZ:WXZ:P02NR/[00Aj;2aj
;Bej;Bej;Rh2NRl_0WX`<003NS4aNS8bNS8b009j<c<00gXd=7Xe=GXe=@02
NSHf00Aj=cMj>3Qj>3Qj>CT2NSXj0WXk>`03NS`lNSdmNSdm009j?Sh00gXo
?gY0@7Y0@002NT5100Aj@T9j@d=j@d=jA4@2NTE50WY6AP03NTM7NTQ8NTQ8
009jBDT017Y:BWY;BgY;BgY<C09jCDd2NTi>00=jCdmjD51jD5000WYAD@03
NU9BNU=CNU=C009jE5@017YEEGYFEWYFEWYGE`9jF5P2NUUI00=jFUYjFe]j
Fe/00WYLG003NUeMNUiNNUiN009jGel017YPH7YQHGYQHGYRHP9jHf<2NVAT
00=jIFEjIVIjIVH00WYWI`03NVQXNVUYNVUY009jJVX017Y[JgY/K7Y/K7Y]
K@9jKVh2NVm_00=jL71jLG5jLG400WYbLP04NW=cNWAdNWAdNWEe0WYfMP9j
MgL017YhN7YiNGYiNGYjNQ[<c<`@0>3o2/c<c0H00004c<c<00>IVIW<c<c<
c<`02/c<c0030000c<c<c<c<00C<c<`00`000<c<c<c<c003c<c<0P0000C<
c<`00iVIVLc<c<c<c01Gc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SP
f8S0^8S0^?ooo`0[c<c<00=l001l0@5l0@400W`20P04O0<3O0@4O0@4O0D5
0W`61P9l1`L017`827`92G`92G`:2P9l2`/2O0`<00=l3@el3Pil3Ph00W`?
3`04O10@O14AO14AO18B0W`C4`9l51@00g`E5G`F5W`F5P02O1LG00Al61Ql
6AUl6AUl6QX2O1/K0W`L7004O1dMO1hNO1hNO1lO0W`P809l8B400g`R8W`S
8g`S8`02O2@T00Al9BEl9RIl9RIl9bL2O2PX0W`Y:@04O2XZO2/[O2/[O2`/
0W`];@9l;Rh00g`_;g``<7``<002O34a00Al<S9l<c=l<c=l=3@2O3De0W`f
=P04O3LgO3PhO3PhO3Ti0W`j>P9l>c/00g`l?7`m?G`m?@02O3hn00Al?cml
@41l@41l@D42O4920Wa3@`03O4A4O4E5O4E5009lATH017a7Aga8B7a8B7a9
B@9lBTX2O4];00AlC4alCDelCDelCTh2O4m?0Wa@D003O55AO59BO59B009l
De<017aDE7aEEGaEEGaFEP9lEeL2O5QH00AlFEUlFUYlFUYlFe/2O5aL0WaM
G@03O5iNO5mOO5mO009lH60017aQHGaRHWaRHWaSH`9lI6@2O6EU00AlIVIl
IfMlIfMlJ6P2O6UY0WaZJP03O6][O6a/O6a/009lKFd017a^KWa_Kga_Kga`
L09lLG42O79b00=lLg=lM7AlM7@00WaeM@04O7IfO7MgO7MgO7Qh0WaiN@9l
NWX00gakNlc<c<c<c00Hc<c<403Xo`[<c<`200000lc<c0800003c<c<00>I
VIW<c<c<c<`02lc<c0030000c<c<c<c<00C<c<`00`000<c<c<c<c004c<c<
00D0003<c<c<c<c<c<bIVIT0FLc<c004IVIVR<2hR<2hB9280@00000000F8
`;S8h=R8`;R8`;Soool0:lc<c003O@00O@41O@41009m0P8017d30gd417d4
17d51@9m1PH2O@L700Am20Qm2@Um2@Um2PX2O@/;0Wd<3004O@d=O@h>O@h>
O@l?0Wd@409m4A4017dB4WdC4gdC4gdD509m5AD2OAHF00Am5aMm61Qm61Qm
6AT2OAXJ0WdK6`04OA`LOAdMOAdMOAhN0WdO7`9m820017dQ8GdR8WdR8WdS
8`9m92@2OBDU00Am9RIm9bMm9bMm:2P2OBTY0WdZ:P04OB/[OB`/OB`/OBd]
0Wd^;P9m;bl017d`<7da<Gda<Gdb<P9m<c<2OC@d00Am=CEm=SIm=SIm=cL2
OCPh0Wdi>@04OCXjOC/kOC/kOC`l0Wdm?@9m?Sh017do?ge0@7e0@7e1@@9m
@T82OD=300AmA4AmADEmADEmATH2ODM70We8B004ODU9ODY:ODY:OD];0We<
C09mCDd017e>CWe?Cge?Cge@D09mDE42OE9B00AmDe=mE5AmE5AmEED2OEIF
0WeGE`04OEQHOEUIOEUIOEYJ0WeKF`9mG5`017eMGGeNGWeNGWeOG`9mH602
OF5Q00AmHV9mHf=mHf=mI6@2OFEU0WeVIP04OFMWOFQXOFQXOFUY0WeZJP9m
Jf/017e/K7e]KGe]KGe^KP9mKfl2OG1`00AmLG5mLW9mLW9mLg<2OGAd0Wee
M@04OGIfOGMgOGMgOGQh0WeiN@9mNWX00gekNgelO7elO00Jc<c<403`o`[<
c<`200000lc<c0800003c<c<00>IVIW<c<c<c<`02lc<c0030000c<c<c<c<
00C<c<`00`000<c<c<c<c004c<c<00D0003<c<c<c<c<c<bIVIT0FLc<c004
IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c004OP00
OP41OP41OP820Wh30`9n10@017h51Gh61Wh61Wh71`9n20P2OPT900An2PYn
2`]n2`]n30`2OPd=00=n3Pin3`mn3`l00Wh@4004OQ4AOQ8BOQ8BOQ<C0WhD
509n5AD017hF5WhG5ghG5ghH609n6AT00ghJ6WhK6ghK6`02OQ`L00An7Aen
7Qin7Qin7al2OR0P0WhQ8@04OR8ROR<SOR<SOR@T0WhU9@9n9RH017hW9ghX
:7hX:7hY:@9n:RX00gh[:gh/;7h/;002ORd]00An;Rin;bmn;bmn<302OS4a
0Whb<P04OS<cOS@dOS@dOSDe0Whf=P03OSLgOSPhOSPh009n>CT017hj>Whk
>ghk>ghl?09n?Cd2OShn00An?cmn@41n@41n@D42OT9200=n@d=nA4AnA4@0
0Wi5A@04OTI6OTM7OTM7OTQ80Wi9B@9nBTX017i;Bgi<C7i<C7i=C@9nCTh0
0gi?Cgi@D7i@D002OU5A00AnDU9nDe=nDe=nE5@2OUEE0WiFEP04OUMGOUQH
OUQHOUUI0WiJFP03OU]KOUaLOUaL009nGEd017iNGWiOGgiOGgiPH09nHF42
OV9R00AnHf=nI6AnI6AnIFD2OVIV00=nIfMnJ6QnJ6P00WiYJ@04OVYZOV][
OV][OVa/0Wi]K@9nKVh017i_Kgi`L7i`L7iaL@9nLW82OW=c00AnM7AnMGEn
MGEnMWH2OWMg00=nN7QnNGUnNGT00WijNP05OW]kOWalOWalOWemOWin01[<
c<`@0?Oo2/c<c0800003c<c<0P0000?<c<`00iVIVLc<c<c<c007c<c<00D0
003<c<c<c<c<c<`000000/c<c0050000c<c<c<c<c<c<000000;<c<`01@00
0<c<c<c<c<c<c0000003c<c<00>IVIW<c<c<c<`0Elc<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c004P000P041P041P082
0X030`:010@018051H061X061X071`:020P00h092H0:2X0:2P02P0/;00B0
30b03@f03@f03Ph2P0l?00>041204A604A400X0B4P04P1<CP1@DP1@DP1DE
0X0F5P03P1LGP1PHP1PH00:06AT0180J6X0K6h0K6h0L70:07Ad0180N7X0O
7h0O7h0P80:08B42P28R00B08b>092B092B09BD2P2HV00>09bN0:2R0:2P0
0X0Y:@04P2XZP2/[P2/[P2`/0X0];@03P2h^P2l_P2l_00:0<300180a<H0b
<X0b<X0c<`:0=3@00h0e=H0f=X0f=P02P3Lg00B0>3R0>CV0>CV0>SX2P3/k
00>0?3b0?Cf0?Cd00X0n?P04P3loP410P410P4510X12@P03P4=3P4A4P4A4
00:0ADD01816AX17Ah17Ah18B0:0BDT0181:BX1;Bh1;Bh1<C0:0CDd2P4i>
00B0Cdn0D520D520DE42P59B00>0De>0E5B0E5@00X1EE@04P5IFP5MGP5MG
P5QH0X1IF@03P5YJP5]KP5]K00:0G5`0181MGH1NGX1NGX1OG`:0H6000h1Q
HH1RHX1RHP02P6=S00B0I6B0IFF0IFF0IVH2P6MW00>0J6R0JFV0JFT00X1Z
JP04P6][P6a/P6a/P6e]0X1^KP03P6m_P71`P71`00:0LG40181bLX1cLh1c
Lh1dM0:0MGD00h1fMX1gMh1gM`02P7Qh00B0NGV0NWZ0NWZ0Ng/2P7al00B0
OGf0OWj0OWj0OglJc<c<403oo`[<c<`600001<c<c003VIVIc<c<c<c<00S<
c<`300001<c<c0<00004c<c<0`0000C<c<`00iVIVLc<c<c<c01Gc<c<00AV
IVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<00B10021
0@610@610P82P@<300>110B11@F11@D00X461P04P@L7P@P8P@P8P@T90X4:
2P04P@/;P@`<P@`<P@d=0X4>3P:13`l0184@484A4H4A4H4B4P:14a<0184D
584E5H4E5H4F5P:15aL2PAPH00B16AV16QZ16QZ16a/2PA`L00B17Af17Qj1
7Qj17al2PB0P0X4Q8@04PB8RPB<SPB<SPB@T0X4U9@04PBHVPBLWPBLWPBPX
0X4Y:@:1:RX0184[:h4/;84/;84];@:1;Rh0184_;h4`<84`<84a<@:1<S80
0h4c<h4d=84d=002PCDe00B1=SJ1=cN1=cN1>3P2PCTi00B1>SZ1>c^1>c^1
?3`2PCdm0X4n?P04PCloPD10PD10PD510X52@P04PD=3PDA4PDA4PDE50X56
AP:1AdL01858B859BH59BH5:BP:1Bd/0185<C85=CH5=CH5>CP:1Cdl2PE1@
00B1DE61DU:1DU:1De<2PEAD00B1EEF1EUJ1EUJ1EeL2PEQH0X5IF@04PEYJ
PE]KPE]KPEaL0X5MG@04PEiNPEmOPEmOPF1P0X5QH@03PF9RPF=SPF=S00:1
I6@0185UIH5VIX5VIX5WI`:1J6P0185YJH5ZJX5ZJX5[J`:1K6`2PFe]00B1
KVj1Kfn1Kfn1L702PG5a00B1LW:1Lg>1Lg>1M7@2PGEe0X5fMP04PGMgPGQh
PGQhPGUi0X5jNP04PG]kPGalPGalPGem0X5nOP:1Ogl00h60P<c<c<c<c00H
c<c<403omaC<c<`00iVIVLc<c<c<c00Mc<c<00>IVIW<c<c<c<`0Elc<c004
IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c004PP00
PP41PP41PP820X830`04PP@4PPD5PPD5PPH60X871`:220P018892H8:2X8:
2X8;2`:230`0188=3H8>3X8>3X8?3`:24100188A4H8B4X8B4X8C4`:251@2
PQDE00B25QJ25aN25aN261P2PQTI00B26QZ26a^26a^271`2PQdM00B27Qj2
7an27an28202PR4Q0X8R8P04PR<SPR@TPR@TPRDU0X8V9P04PRLWPRPXPRPX
PRTY0X8Z:P04PR/[PR`/PR`/PRd]0X8^;P:2;bl0188`<88a<H8a<H8b<P:2
<c<0188d=88e=H8e=H8f=P:2=cL0188h>88i>H8i>H8j>P:2>c/2PS`l00B2
?Cf2?Sj2?Sj2?cl2PT1000B2@D62@T:2@T:2@d<2PTA400B2ADF2ATJ2ATJ2
AdL2PTQ80X99B@04PTY:PT];PT];PTa<0X9=C@04PTi>PTm?PTm?PU1@0X9A
D@04PU9BPU=CPU=CPUAD0X9EE@:2EUH0189GEh9HF89HF89IF@:2FUX0189K
Fh9LG89LG89MG@:2GUh0189OGh9PH89PH89QH@:2HV82PV=S00B2I6B2IFF2
IFF2IVH2PVMW00B2J6R2JFV2JFV2JVX2PV][00B2K6b2KFf2KFf2KVh2PVm_
0X9`L004PW5aPW9bPW9bPW=c0X9dM004PWEePWIfPWIfPWMg0X9hN004PWUi
PWYjPWYjPW]k0X9lO0:2OGd0189nOX9oOh9oOh:0P0:2PH4Jc<c<403ol1C<
c<`00iVIVLc<c<c<c00Mc<c<00>IVIW<c<c<c<`0Elc<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c004P`00P`41P`41P`82
0X<30`04P`@4P`D5P`D5P`H60X<71`04P`P8P`T9P`T9P`X:0X<;2`:330`0
18<=3H<>3X<>3X<?3`:3410018<A4H<B4X<B4X<C4`:351@018<E5H<F5X<F
5X<G5`:361P018<I6H<J6X<J6X<K6`:371`018<M7H<N7X<N7X<O7`:38202
Pb4Q00B38R:38b>38b>392@2PbDU00B39RJ39bN39bN3:2P2PbTY00B3:RZ3
:b^3:b^3;2`2Pbd]00B3;Rj3;bn3;bn3<302Pc4a00B3<S:3<c>3<c>3=3@2
PcDe0X<f=P04PcLgPcPhPcPhPcTi0X<j>P04Pc/kPc`lPc`lPcdm0X<n?P04
PcloPd10Pd10Pd510X=2@P04Pd=3PdA4PdA4PdE50X=6AP04PdM7PdQ8PdQ8
PdU90X=:BP03Pd];Pda<Pda<00:3CDd018=>CX=?Ch=?Ch=@D0:3DE4018=B
DX=CDh=CDh=DE0:3EED018=FEX=GEh=GEh=HF0:3FET018=JFX=KFh=KFh=L
G0:3GEd018=NGX=OGh=OGh=PH0:3HF42Pf9R00B3Hf>3I6B3I6B3IFD2PfIV
00B3IfN3J6R3J6R3JFT2PfYZ00B3Jf^3K6b3K6b3KFd2Pfi^00B3Kfn3L723
L723LG42Pg9b00B3Lg>3M7B3M7B3MGD2PgIf00>3MgN3N7R3N7P00X=iN@04
PgYjPg]kPg]kPgal0X=mO@04PginPgmoPgmoPh200X>1P@03Ph:2Ph>3c<c<
01W<c<`@0?oX5<c<c003VIVIc<c<c<c<01g<c<`00iVIVLc<c<c<c01Gc<c<
00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<00B5
00250@650@650P82Q@<300B510B51@F51@F51PH2Q@L700B520R52@V52@V5
2PX2Q@/;00B530b53@f53@f53Ph2Q@l?00B541254A654A654Q82QA<C00B5
51B55AF55AF55QH2QALG00B561R56AV56AV56QX2QA/K00>571b57Af57Ad0
0XDN7P04QAlOQB0PQB0PQB4Q0XDR8P04QB<SQB@TQB@TQBDU0XDV9P04QBLW
QBPXQBPXQBTY0XDZ:P04QB/[QB`/QB`/QBd]0XD^;P04QBl_QC0`QC0`QC4a
0XDb<P04QC<cQC@dQC@dQCDe0XDf=P04QCLgQCPhQCPhQCTi0XDj>P04QC/k
QC`lQC`lQCdm0XDn?P04QCloQD10QD10QD510XE2@P04QD=3QDA4QDA4QDE5
0XE6AP04QDM7QDQ8QDQ8QDU90XE:BP04QD];QDa<QDa<QDe=0XE>CP04QDm?
QE1@QE1@QE5A0XEBDP04QE=CQEADQEADQEEE0XEFEP04QEMGQEQHQEQHQEUI
0XEJFP:5Fe/018ELG8EMGHEMGHENGP:5Gel018EPH8EQHHEQHHERHP:5Hf<0
18ETI8EUIHEUIHEVIP:5IfL018EXJ8EYJHEYJHEZJP:5Jf/018E/K8E]KHE]
KHE^KP:5Kfl018E`L8EaLHEaLHEbLP:5Lg<018EdM8EeMHEeMHEfMP:5MgL0
18EhN8EiNHEiNHEjNP:5Ng/018ElO8EmOHEmOHEnOP:5Ogl018F0P8F1PHF1
PHF2PP:5Ph<00hF4Q<c<c<c<c00Hc<c<403oh1C<c<`00iVIVLc<c<c<c00M
c<c<00>IVIW<c<c<c<`0Elc<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0:lc<c004QP00QP41QP41QP820XH30`04QP@4QPD5QPD5
QPH60XH71`04QPP8QPT9QPT9QPX:0XH;2`04QP`<QPd=QPd=QPh>0XH?3`04
QQ0@QQ4AQQ4AQQ8B0XHC4`04QQ@DQQDEQQDEQQHF0XHG5`04QQPHQQTIQQTI
QQXJ0XHK6`04QQ`LQQdMQQdMQQhN0XHO7`04QR0PQR4QQR4QQR8R0XHS8`04
QR@TQRDUQRDUQRHV0XHW9`05QRPXQRTYQRXZQRXZQR/[00:6;2`018H];HH^
;XH^;XH_;`:6<30018Ha<HHb<XHb<XHc<`:6=3@018He=HHf=XHf=XHg=`:6
>3P018Hi>HHj>XHj>XHk>`:6?3`018Hm?HHn?XHn?XHo?`:6@40018I1@HI2
@XI2@XI3@`:6A4@018I5AHI6AXI6AXI7A`:6B4P018I9BHI:BXI:BXI;B`:6
C4`018I=CHI>CXI>CXI?C`:6D50018IADHIBDXIBDXICD`:6E5@018IEEHIF
EXIFEXIGE`:6F5P018IIFHIJFXIJFXIKF`:6G5`018IMGHINGXINGXIOG`:6
H60018IQHHIRHXIRHXISH`:6I6@018IUIHIVIXIVIXIWI`:6J6P018IYJHIZ
JXIZJXI[J`:6K6`018I]KHI^KXI^KXI_K`:6L70018IaLHIbLXIbLXIcL`:6
M7@018IeMHIfMXIfMXIgM`:6N7P01HIiNHIjNXIjNXIkNhIlO002QWem00B6
OWj6Ogn6Ogn6P802QX6100B6PX:6Ph>6Ph>6Q8@2QXF56/c<c100omTDc<c<
00>IVIW<c<c<c<`07Lc<c003VIVIc<c<c<c<05O<c<`016IVIXS0^8S0^4R@
R04000000005R<2hb>3HR<2hR<2hoooo02_<c<`018L008L10HL10HL20P:7
0`<018L418L51HL51HL61P:71`L018L828L92HL92HL:2P:72`/01HL<38L=
3HL>3XL>3XL?3`02Qa0@00B74A674Q:74Q:74a<2Qa@D00B75AF75QJ75QJ7
5aL2QaPH00B76AV76QZ76QZ76a/2Qa`L00B77Af77Qj77Qj77al2Qb0P00B7
8B678R:78R:78b<2Qb@T00F79BF79RJ79bN79bN7:2P00XLY:@04QbXZQb/[
Qb/[Qb`/0XL];@04Qbh^Qbl_Qbl_Qc0`0XLa<@04Qc8bQc<cQc<cQc@d0XLe
=@04QcHfQcLgQcLgQcPh0XLi>@04QcXjQc/kQc/kQc`l0XLm?@05QchnQclo
Qd10Qd10Qd5100:7@T8018M3@hM4A8M4A8M5A@:7ATH018M7AhM8B8M8B8M9
B@:7BTX018M;BhM<C8M<C8M=C@:7CTh018M?ChM@D8M@D8MAD@:7DU8018MC
DhMDE8MDE8MEE@:7EUH01HMGEhMHF8MIFHMIFHMJFP02Qe]K00B7G5b7GEf7
GEf7GUh2QemO00B7H627HF67HF67HV82Qf=S00B7I6B7IFF7IFF7IVH2QfMW
00B7J6R7JFV7JFV7JVX2Qf][00B7K6b7KFf7KFf7KVh2Qfm_00F7L727LG67
LW:7LW:7Lg<00XMdM004QgEeQgIfQgIfQgMg0XMhN004QgUiQgYjQgYjQg]k
0XMlO004QgemQginQginQgmo0XN0P004Qh61Qh:2Qh:2Qh>30XN4Q003QhF5
QhJ6QhJ601[<c<`@0?oA5<c<c26IVIUIc<c<00AVIVJ8`;R8`;Q8T8P10000
00001HS0^<SPf8S0^8S0^?ooo`0[c<c<00B800280@680@680P82R0<300F8
10B81@F81@F81PJ81`L00XP82004R0T9R0X:R0X:R0/;0XP<3004R0d=R0h>
R0h>R0l?0XP@4004R14AR18BR18BR1<C0XPD5005R1DER1HFR1LGR1LGR1PH
00:86AT018PJ6XPK6hPK6hPL70:87Ad018PN7XPO7hPO7hPP80:88B401HPR
8XPS8hPS8hPT98PU9@02R2HV00B89bN8:2R8:2R8:BT2R2XZ00B8:b^8;2b8
;2b8;Bd2R2h^00B8;bn8<328<328<C42R38b00F8<c>8=3B8=CF8=CF8=SH0
0XPg=`04R3PhR3TiR3TiR3Xj0XPk>`04R3`lR3dmR3dmR3hn0XPo?`05R410
R451R451R492R4=300:8A4@018Q5AHQ6AXQ6AXQ7A`:8B4P018Q9BHQ:BXQ:
BXQ;B`:8C4`018Q=CHQ>CXQ>CXQ?C`:8D5001HQADHQBDXQCDhQCDhQDE002
R5EE00B8EUJ8EeN8EeN8F5P2R5UI00B8FUZ8Fe^8Fe^8G5`2R5eM00F8GUj8
Gen8Gen8H628HF400XQRHP04R6=SR6ATR6ATR6EU0XQVIP04R6MWR6QXR6QX
R6UY0XQZJP05R6][R6a/R6a/R6e]R6i^00:8Kfl018Q`L8QaLHQaLHQbLP:8
Lg<018QdM8QeMHQeMHQfMP:8MgL018QhN8QiNHQiNHQjNP:8Ng/01HQlO8Qm
OHQnOXQnOXQoO`02R82000B8PH68PX:8PX:8Ph<2R8B400F8QHF8QXJ8QXJ8
QhN8R8P06/c<c100olV>c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SP
f8S0^8S0^?ooo`0[c<c<00B:002:0@6:0@6:0P82RP<300F:10B:1@F:1PJ:
1PJ:1`L00XX82004RPT9RPX:RPX:RP/;0XX<3005RPd=RPh>RPh>RPl?RQ0@
00::4A4018XB4XXC4hXC4hXD50::5AD018XF5XXG5hXG5hXH60::6AT01HXJ
6XXK6hXL78XL78XM7@02RQhN00B:7an:822:822:8B42RR8R00F:8b>:92B:
92B:9BF:9RH00XXW9`04RRPXRRTYRRTYRRXZ0XX[:`05RR`/RRd]RRd]RRh^
RRl_00::<30018Xa<HXb<XXb<XXc<`::=3@018Xe=HXf=XXf=XXg=`::>3P0
1HXi>HXj>XXk>hXk>hXl?002RSdm00B:?Sj:?cn:?cn:@402RT5100F:@T::
@d>:@d>:A4B:ADD00XY6AP04RTM7RTQ8RTQ8RTU90XY:BP04RT];RTa<RTa<
RTe=0XY>CP05RTm?RU1@RU5ARU5ARU9B00::De<018YDE8YEEHYEEHYFEP::
EeL01HYHF8YIFHYJFXYJFXYKF`02RUaL00B:GEf:GUj:GUj:Gel2RV1P00F:
HF6:HV::HV::Hf>:I6@00XYUI@04RVIVRVMWRVMWRVQX0XYYJ@04RVYZRV][
RV][RVa/0XY]K@05RVi^RVm_RW1`RW1`RW5a00::LW8018YcLhYdM8YdM8Ye
M@::MWH01HYgMhYhN8YhN8YiNHYjNP02RW]k00B:O7b:OGf:OGf:OWh2RWmo
00F:P82:PH6:PH6:PX::Ph<00XZ4Q004RXF5RXJ6RXJ6RXN70XZ8R003RXV9
c<c<c<c<01S<c<`@0?o2S/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0:lc<c004R`00R`41R`41R`820X/30`05R`@4R`D5R`H6
R`H6R`L700:;20P01H/92H/:2X/:2X/;2h/<3002R`d=00B;3Pj;3`n;3`n;
4102Ra4A00F;4Q:;4a>;4a>;51B;5AD00X/F5P04RaLGRaPHRaPHRaTI0X/J
6P05Ra/KRa`LRa`LRadMRahN00:;7al018/P88/Q8H/Q8H/R8P:;8b<01H/T
98/U9H/V9X/V9X/W9`02RbPX00B;:BV;:RZ;:RZ;:b/2Rb`/00F;;Bf;;Rj;
;bn;;bn;<3000X/a<@05Rc8bRc<cRc<cRc@dRcDe00:;=SH018/g=h/h>8/h
>8/i>@:;>SX01H/k>h/l?8/l?8/m?H/n?P02Rclo00B;@42;@D6;@D6;@T82
Rd=300F;A4B;ADF;ADF;ATJ;AdL00X]8B004RdU9RdY:RdY:Rd];0X]<C005
Rde=Rdi>Rdm?Rdm?Re1@00:;DE4018]BDX]CDh]CDh]DE0:;EED01H]FEX]G
Eh]HF8]HF8]IF@02ReYJ00F;Fe^;G5b;G5b;GEf;GUh00X]OG`04Rf1PRf5Q
Rf5QRf9R0X]SH`05RfATRfEURfEURfIVRfMW00:;J6P018]YJH]ZJX]ZJX][
J`:;K6`01H]]KH]^KX]^KX]_Kh]`L002Rg5a00B;LW:;Lg>;Lg>;M7@2RgEe
00F;MWJ;MgN;N7R;N7R;NGT00X]jNP04Rg]kRgalRgalRgem0X]nOP05Rgmo
Rh20Rh61Rh61Rh:200:;Ph<01H^4Q8^5QH^5QH^6QX^7Q`02RhR800>;RHV;
RXZ;RXX06/c<c100okZ>c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SP
f8S0^8S0^?ooo`0[c<c<00F<002<0@6<0@6<0P:<0`<00X`41004S0D5S0H6
S0H6S0L70X`82005S0T9S0X:S0/;S0/;S0`<00:<3@d01H`>3X`?3h`?3h`@
48`A4@02S18B00B<4a><51B<51B<5AD2S1HF00F<5aN<61R<6AV<6AV<6QX0
0X`K6`05S1`LS1dMS1dMS1hNS1lO00:<820018`Q8H`R8X`R8X`S8`:<92@0
1H`U9H`V9X`W9h`W9h`X:002S2TY00F<:RZ<:b^<:b^<;2b<;Bd00X`^;P04
S2l_S30`S30`S34a0X`b<P05S3<cS3@dS3DeS3DeS3Hf00:<=cL01H`h>8`i
>H`j>X`j>X`k>`02S3`l00F<?Cf<?Sj<?Sj<?cn<@4000Xa1@@04S492S4=3
S4=3S4A40Xa5A@05S4I6S4M7S4Q8S4Q8S4U900:<BTX01Ha;Bha<C8a<C8a=
CHa>CP02S4m?00B<D52<DE6<DE6<DU82S5=C00F<E5B<EEF<EUJ<EUJ<EeL0
0XaHF005S5UIS5YJS5YJS5]KS5aL00:<GEd018aNGXaOGhaOGhaPH0:<HF40
1HaRHXaSHhaTI8aTI8aUI@02S6IV00F<IfN<J6R<J6R<JFV<JVX00Xa[J`04
S6a/S6e]S6e]S6i^0Xa_K`05S71`S75aS79bS79bS7=c00:<M7@01HaeMHaf
MXagMhagMhahN002S7Ui00F<NWZ<Ng^<Ng^<O7b<OGd00XanOP04S7moS820
S820S8610Xb2PP05S8>3S8B4S8F5S8F5S8J600:<QhL01Xb8R8b9RHb9RHb:
RXb;Rhb<S1[<c<`@0?nbS/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0:lc<c005SP00SP41SP41SP82SP<300:>10@018h51Hh6
1Xh61Xh71`:>20P01Hh92Hh:2Xh;2hh;2hh<3002SPd=00F>3Pj>3`n>412>
412>4A400XhB4P05SQ<CSQ@DSQDESQDESQHF00:>5aL01HhH68hI6HhI6HhJ
6XhK6`02SQ`L00F>7Af>7Qj>7Qj>7an>82000XhQ8@05SR8RSR<SSR<SSR@T
SRDU00:>9RH018hW9hhX:8hX:8hY:@:>:RX01Hh[:hh/;8h];Hh];Hh^;P02
SRl_00F><32><C6><S:><S:><c<00Xhd=005SSDeSSHfSSHfSSLgSSPh00:>
>CT01Hhj>Xhk>hhk>hhl?8hm?@02SShn00F>?cn>@42>@42>@D6>@T800Xi3
@`04STA4STE5STE5STI60Xi7A`05STQ8STU9STY:STY:ST];00:>C4`01Hi=
CHi>CXi?Chi?Chi@D002SU5A00F>DU:>De>>De>>E5B>EED00XiFEP05SUMG
SUQHSUQHSUUISUYJ00:>Fe/01HiLG8iMGHiMGHiNGXiOG`02SV1P00B>HF6>
HV:>HV:>Hf<2SVAT00F>IFF>IVJ>IfN>IfN>J6P00XiYJ@05SVYZSV][SVa/
SVa/SVe]00:>KVh01Hi_Khi`L8iaLHiaLHibLP02SW=c00F>M7B>MGF>MGF>
MWJ>MgL00XihN005SWUiSWYjSWYjSW]kSWal00:>OGd018inOXioOhioOhj0
P0:>PH401Hj2PXj3Phj4Q8j4Q8j5Q@02SXJ600F>QhN>R8R>RHV>RHV>RXX0
0Xj;R`03SXb<SXf=c<c<01W<c<`@0?n[S/c<c004IVIVR<2hR<2hB9280@00
000000F8`;S8h=R8`;R8`;Soool0:lc<c005S`00S`41S`41S`82S`<300:?
10@01Hl51Hl61Xl61Xl71hl82002S`T900F?2PZ?2`^?2`^?30b?3@d00Xl>
3P05S`l?Sa0@Sa0@Sa4ASa8B00:?4a<01HlD58lE5HlE5HlF5XlG5`02SaPH
00F?6AV?6QZ?6QZ?6a^?71`00XlM7@05SahNSalOSalOSb0PSb4Q00:?8R80
1HlS8hlT98lT98lU9HlV9P02SbLW00F?:2R?:BV?:BV?:RZ?:b/00Xl/;005
Sbd]Sbh^Sbh^Sbl_Sc0`00:?<C401Hlb<Xlc<hlc<hld=8le=@02ScHf00F?
=cN?>3R?>3R?>CV?>SX00Xlk>`05Sc`lScdmScdmSchnSclo00:?@4001Hm1
@Hm2@Xm2@Xm3@hm4A002SdE500F?ATJ?AdN?AdN?B4R?BDT00Xm:BP05Sd];
Sda<Sda<Sde=Sdi>00:?Cdl01Hm@D8mADHmADHmBDXmCD`02SeAD00F?EEF?
EUJ?EUJ?EeN?F5P00XmIF@05SeYJSe]KSe]KSeaLSeeM00:?GUh01HmOGhmP
H8mPH8mQHHmRHP02Sf=S00F?I6B?IFF?IFF?IVJ?IfL00XmXJ005SfUYSfYZ
SfYZSf][Sfa/00:?KFd01Hm^KXm_Khm_Khm`L8maL@02Sg9b00F?Lg>?M7B?
M7B?MGF?MWH00XmgM`05SgQhSgUiSgUiSgYjSg]k00:?O7`01HmmOHmnOXmn
OXmoOhn0P002Sh6100F?PX:?Ph>?Ph>?Q8B?QHD00Xn6QP05ShN7ShR8ShR8
ShV9ShZ:00:?Rh/018n<S8n=SHn=SHn>SQ[<c<`@0?nSS/c<c004IVIVR<2h
R<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c005T000T041T041
T082T0<300:@10@01I051I061Y061Y071i082002T0T900F@2PZ@2`^@30b@
30b@3@d00Y0>3P05T0l?T10@T14AT14AT18B00:@4a<01I0D590E5I0F5Y0F
5Y0G5`02T1PH00J@6AV@6QZ@6a^@6a^@71b@7Ad2T1hN00F@7an@822@822@
8B6@8R800Y0S8`05T2@TT2DUT2DUT2HVT2LW00:@:2P01I0Y:I0Z:Y0[:i0[
:i0/;002T2d]00F@;Rj@;bn@<32@<32@<C400Y0b<P05T3<cT3@dT3DeT3De
T3Hf00:@=cL01Y0h>90i>I0j>Y0j>Y0k>i0l?0:@?Cd01I0n?Y0o?i0o?i10
@911@@02T49200F@@d>@A4B@A4B@ADF@ATH00Y17A`05T4Q8T4U9T4U9T4Y:
T4];00:@C4`01I1=CI1>CY1?Ci1?Ci1@D002T55A00F@DU:@De>@E5B@E5B@
EED00Y1FEP05T5MGT5QHT5UIT5UIT5YJ00:@Fe/01Y1LG91MGI1NGY1NGY1O
Gi1PH0:@HF401I1RHY1SHi1SHi1TI91UI@02T6IV00F@IfN@J6R@J6R@JFV@
JVX00Y1[J`05T6a/T6e]T6e]T6i^T6m_00:@L7001I1aLI1bLY1cLi1cLi1d
M002T7Ee00F@MWJ@MgN@N7R@N7R@NGT00Y1jNP06T7]kT7alT7emT7emT7in
T7mo0Y20P005T861T8:2T8:2T8>3T8B400:@QHD01I26QY27Qi27Qi28R929
R@02T8Z:00F@Rh^@S8b@S8b@SHf@SXh00Y2?Sa[<c<`@0?nLS/c<c004IVIV
R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c005T@00T@41
T@41T@82T@<300:A10@01I451I461Y471i471i482002T@T900JA2PZA2`^A
30bA30bA3@fA3Ph2T@l?00FA412A4A6A4A6A4Q:A4a<00Y4D5005TADETAHF
TALGTALGTAPH00:A6AT01Y4J6Y4K6i4L794L794M7I4N7P:A7al01I4P894Q
8I4Q8I4R8Y4S8`02TB@T00FA9BFA9RJA9bNA9bNA:2P00Y4Y:@06TBXZTB/[
TB`/TB`/TBd]TBh^0Y4_;`05TC0`TC4aTC4aTC8bTC<c00:A=3@01I4e=I4f
=Y4g=i4g=i4h>002TCTi00JA>SZA>c^A?3bA?3bA?CfA?Sh2TClo00FA@42A
@D6A@D6A@T:A@d<00Y54A005TDE5TDI6TDI6TDM7TDQ800:ABDT01I5:BY5;
Bi5<C95<C95=C@02TDi>00JACdnAD52ADE6ADE6ADU:ADe<2TEAD00FAEEFA
EUJAEUJAEeNAF5P00Y5IF@05TEYJTE]KTEaLTEaLTEeM00:AGUh01Y5OGi5P
H95QHI5QHI5RHY5SH`:AI6@01I5UII5VIY5VIY5WIi5XJ002TFUY00FAJVZA
Jf^AK6bAK6bAKFd00Y5^KP06TFm_TG1`TG5aTG5aTG9bTG=c0Y5dM005TGEe
TGIfTGIfTGMgTGQh00:ANGT01I5jNY5kNi5lO95lO95mO@02TGin00JAOgnA
P82APH6APH6APX:APh<2THB400FAQHFAQXJAQXJAQhNAR8P00Y69R@05THZ:
TH^;THb<THb<THf=00:ASXh00i6?Si6@T96AT@0Jc<c<403oU8k<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo02_<c<`01I<009<1
0I<10I<20Y<30`02T`@400JC1@FC1PJC1`NC1`NC20RC2@T2T`X:00FC2`^C
30bC30bC3@fC3Ph00Y<?3`06Ta0@Ta4ATa8BTa8BTa<CTa@D0Y<E5@05TaHF
TaLGTaLGTaPHTaTI00:C6QX01Y<K6i<L79<M7I<M7I<N7Y<O7`:C82001I<Q
8I<R8Y<R8Y<S8i<T9002TbDU00JC9RJC9bNC:2RC:2RC:BVC:RX2Tb/[00FC
;2bC;BfC;BfC;RjC;bl00Y<`<006Tc4aTc8bTc<cTc<cTc@dTcDe0Y<f=P05
TcLgTcPhTcPhTcTiTcXj00:C>c/01Y<l?9<m?I<n?Y<n?Y<o?i=0@0:C@D40
1I=2@Y=3@i=3@i=4A9=5A@02TdI600JCAdNCB4RCBDVCBDVCBTZCBd/2Tda<
00FCCDfCCTjCCTjCCdnCD5000Y=AD@06Te9BTe=CTeADTeADTeEETeIF0Y=G
E`05TeQHTeUITeUITeYJTe]K00:CG5`01Y=MGI=NGY=OGi=OGi=PH9=QH@:C
HV801I=SHi=TI9=TI9=UII=VIP02TfMW00JCJ6RCJFVCJVZCJVZCJf^CK6`2
Tfe]00FCKVjCKfnCKfnCL72CLG400Y=bLP05Tg=cTgAdTgEeTgEeTgIf00:C
MgL01Y=hN9=iNI=jNY=jNY=kNi=lO0:COGd01I=nOY=oOi>0P9>0P9>1P@02
Th:200JCPh>CQ8BCQHFCQHFCQXJCQhL2ThR800FCRHVCRXZCRh^CRh^CS8`0
0Y>=S@06Thj>Thn?Ti2@Ti2@Ti6ATi:B6/c<c100ohb>c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<00FD002D0@6D0@6D
0P:D0`<00Y@41006U0D5U0H6U0L7U0L7U0P8U0T90Y@:2P06U0/;U0`<U0d=
U0d=U0h>U0l?0Y@@4005U14AU18BU18BU1<CU1@D00:D5AD01Y@F5Y@G5i@H
69@H69@I6I@J6P:D6a/01Y@L79@M7I@N7Y@N7Y@O7i@P80:D8B401I@R8Y@S
8i@S8i@T99@U9@02U2HV00JD9bND:2RD:BVD:BVD:RZD:b/2U2`/00JD;BfD
;RjD;bnD;bnD<32D<C42U38b00FD<c>D=3BD=CFD=CFD=SH00Y@g=`06U3Ph
U3TiU3XjU3XjU3/kU3`l0Y@m?@06U3hnU3loU410U410U451U4920YA3@`05
U4A4U4E5U4I6U4I6U4M700:DB4P01YA9BIA:BYA;BiA;BiA<C9A=C@:DCTh0
1YA?CiA@D9AADIAADIABDYACD`:DE5@01IAEEIAFEYAGEiAGEiAHF002U5UI
00JDFUZDFe^DG5bDG5bDGEfDGUh2U5mO00JDH62DHF6DHV:DHV:DHf>DI6@2
U6EU00FDIVJDIfNDJ6RDJ6RDJFT00YAZJP06U6][U6a/U6e]U6e]U6i^U6m_
0YA`L006U75aU79bU7=cU7=cU7AdU7Ee0YAfMP05U7MgU7QhU7UiU7UiU7Yj
00:DNg/01YAlO9AmOIAnOYAnOYAoOiB0P0:DPH401YB2PYB3PiB4Q9B4Q9B5
QIB6QP:DQhL01YB8R9B9RIB:RYB:RYB;RiB<S0:DSHd01IB>SYB?SiB?SiB@
T9BAT@02U9:B00>DTi?<c<c<c<`06<c<c100ohF>c<c<00AVIVJ8`;R8`;Q8
T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<00FE002E0@6E0@6E0P:E
0`<00YD41006U@D5U@H6U@L7U@L7U@P8U@T90YD:2P06U@/;U@`<U@d=U@d=
U@h>U@l?0YD@4006UA4AUA8BUA<CUA<CUA@DUADE0YDF5P06UALGUAPHUATI
UATIUAXJUA/K0YDL7006UAdMUAhNUAlOUAlOUB0PUB4Q0YDR8P06UB<SUB@T
UBDUUBDUUBHVUBLW0YDX:005UBTYUBXZUB/[UB/[UB`/00:E;Bd01YD^;YD_
;iD`<9D`<9Da<IDb<P:E<c<01YDd=9De=IDf=YDf=YDg=iDh>0:E>CT01YDj
>YDk>iDl?9Dl?9Dm?IDn?P:E?cl01YE0@9E1@IE2@YE2@YE3@iE4A0:EADD0
1YE6AYE7AiE8B9E8B9E9BIE:BP:EBd/01YE<C9E=CIE>CYE>CYE?CiE@D0:E
DE401YEBDYECDiEDE9EDE9EEEIEFEP:EEeL01IEHF9EIFIEJFYEJFYEKF`02
UEaL00JEGEfEGUjEGenEGenEH62EHF42UF9R00JEHf>EI6BEIFFEIFFEIVJE
IfL2UFQX00JEJFVEJVZEJf^EJf^EK6bEKFd2UFi^00JEKfnEL72ELG6ELG6E
LW:ELg<2UGAd00JEMGFEMWJEMgNEMgNEN7RENGT2UGYj00JENg^EO7bEOGfE
OGfEOWjEOgl2UH2000JEPH6EPX:EPh>EPh>EQ8BEQHD2UHJ600FEQhNER8RE
R8RERHVERXX00YF;R`06UHb<UHf=UHj>UHj>UHn?UI2@0YFAT@04UI:BUI>C
UIBDUIBD6/c<c100ogf>c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SP
f8S0^8S0^?ooo`0[c<c<00JF002F0@6F0P:F0P:F0`>F10@2UPD500JF1PJF
1`NF20RF20RF2@VF2PX2UP/;00JF30bF3@fF3PjF3PjF3`nF4102UQ4A00JF
4Q:F4a>F51BF51BF5AFF5QH2UQLG00JF61RF6AVF6QZF6QZF6a^F71`2UQdM
00JF7QjF7anF822F822F8B6F8R82UR<S00JF92BF9BFF9RJF9RJF9bNF:2P2
URTY00JF:RZF:b^F;2bF;2bF;BfF;Rh2URl_00JF<32F<C6F<S:F<S:F<c>F
=3@2USDe00JF=SJF=cNF>3RF>3RF>CVF>SX2US/k00JF?3bF?CfF?SjF?SjF
?cnF@402UT5100JF@T:F@d>FA4BFA4BFADFFATH2UTM700JFB4RFBDVFBTZF
BTZFBd^FC4`2UTe=00JFCTjFCdnFD52FD52FDE6FDU82UU=C00>FE5BFEEFF
EUH00YIGE`06UUQHUUUIUUYJUUYJUU]KUUaL0YIMG@06UUiNUUmOUV1PUV1P
UV5QUV9R0YISH`06UVATUVEUUVIVUVIVUVMWUVQX0YIYJ@06UVYZUV][UVa/
UVa/UVe]UVi^0YI_K`06UW1`UW5aUW9bUW9bUW=cUWAd0YIeM@06UWIfUWMg
UWQhUWQhUWUiUWYj0YIkN`06UWalUWemUWinUWinUWmoUX200YJ1P@06UX:2
UX>3UXB4UXB4UXF5UXJ60YJ7Q`06UXR8UXV9UXZ:UXZ:UX^;UXb<0YJ=S@06
UXj>UXn?UY2@UY2@UY6AUY:B0YJCT`03UYBDUYFEUYJF01[<c<`@0?meS/c<
c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c006
V000V041V082V082V0<3V0@40YP51@06V0H6V0L7V0P8V0P8V0T9V0X:0YP;
2`06V0`<V0d=V0h>V0h>V0l?V10@0YPA4@07V18BV1<CV1@DV1@DV1DEV1HF
V1LG00:H61P01YPI6IPJ6YPK6iPK6iPL79PM7@:H7Qh01YPO7iPP89PQ8IPQ
8IPR8YPS8`:H92@01YPU9IPV9YPW9iPW9iPX:9PY:@:H:RX00iP[:iP/;9P]
;@02V2h^00JH;bnH<32H<C6H<C6H<S:H<c<2V3@d00JH=CFH=SJH=cNH=cNH
>3RH>CT2V3Xj00JH>c^H?3bH?CfH?CfH?SjH?cl2V41000>H@D6H@T:H@d<0
0YQ4A006V4E5V4I6V4M7V4M7V4Q8V4U90YQ:BP06V4];V4a<V4e=V4e=V4i>
V4m?0YQ@D006V55AV59BV5=CV5=CV5ADV5EE0YQFEP03V5MGV5QHV5UI00:H
FUX01YQKFiQLG9QMGIQMGIQNGYQOG`:HH6001YQQHIQRHYQSHiQSHiQTI9QU
I@:HIVH01YQWIiQXJ9QYJIQYJIQZJYQ[J`:HK6`00iQ]KIQ^KYQ_K`02V71`
00JHLG6HLW:HLg>HLg>HM7BHMGD2V7If00JHMgNHN7RHNGVHNGVHNWZHNg/2
V7al00JHOGfHOWjHOgnHOgnHP82HPH42V8:200>HPh>HQ8BHQHD00YR6QP06
V8N7V8R8V8V9V8V9V8Z:V8^;0YR<S006V8f=V8j>V8n?V8n?V92@V96A0YRB
TP06V9>CV9BDV9FEV9FEV9JFV9NG6/c<c100ofj>c<c<00AVIVJ8`;R8`;Q8
T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<00JI002I0@6I0P:I0P:I
0`>I10@2V@D500JI1PJI1`NI20RI20RI2@VI2PX2V@/;00>I30bI3@fI3Ph0
0YT?3`06VA0@VA4AVA8BVA8BVA<CVA@D0YTE5@07VAHFVALGVAPHVAPHVATI
VAXJVA/K00:I71`01YTM7ITN7YTO7iTO7iTP89TQ8@:I8R801iTS8iTT99TU
9ITU9ITV9YTW9iTX:002VBTY00JI:RZI:b^I;2bI;2bI;BfI;Rh2VBl_00NI
<32I<C6I<S:I<S:I<c>I=3BI=CD00YTf=P06VCLgVCPhVCTiVCTiVCXjVC/k
0YTl?007VCdmVChnVCloVCloVD10VD51VD9200:I@d<01YU4A9U5AIU6AYU6
AYU7AiU8B0:IBDT00iU:BYU;BiU<C002VDe=00JICTjICdnID52ID52IDE6I
DU82VE=C00NIE5BIEEFIEUJIEUJIEeNIF5RIFET00YUJFP06VE]KVEaLVEeM
VEeMVEiNVEmO0YUPH007VF5QVF9RVF=SVF=SVFATVFEUVFIV00:IIfL01YUX
J9UYJIUZJYUZJYU[JiU/K0:IKFd01iU^KYU_KiU`L9U`L9UaLIUbLYUcL`02
VGAd00JIMGFIMWJIMgNIMgNIN7RINGT2VGYj00NINg^IO7bIOGfIOGfIOWjI
OgnIP8000YV1P@06VH:2VH>3VHB4VHB4VHF5VHJ60YV7Q`07VHR8VHV9VHZ:
VHZ:VH^;VHb<VHf=00:ISXh01YV?SiV@T9VATIVATIVBTYVCT`:IU9@01IVE
UIVFUYVGUiVGUiVHV00Jc<c<403oIXk<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo02_<c<`01YX009X10IX20YX20YX30iX410:J
1@D01iX61YX71iX829X829X92IX:2YX;2`02VP`<00NJ3@fJ3PjJ3`nJ3`nJ
412J4A6J4Q800YXC4`06VQ@DVQDEVQHFVQHFVQLGVQPH0YXI6@03VQXJVQ/K
VQ`L00:J7Ad01YXN7YXO7iXP89XP89XQ8IXR8P:J8b<00iXT99XU9IXV9P02
VRLW00NJ:2RJ:BVJ:RZJ:RZJ:b^J;2bJ;Bd00YX^;P06VRl_VS0`VS4aVS4a
VS8bVS<c0YXd=003VSDeVSHfVSLg00:J>3P01YXi>IXj>YXk>iXk>iXl?9Xm
?@:J?Sh00iXo?iY0@9Y1@@02VT9200NJ@d>JA4BJADFJADFJATJJAdNJB4P0
0YY9B@06VTY:VT];VTa<VTa<VTe=VTi>0YY?C`03VU1@VU5AVU9B00:JDe<0
1YYDE9YEEIYFEYYFEYYGEiYHF0:JFET00iYJFYYKFiYLG002VUeM00NJGUjJ
GenJH62JH62JHF6JHV:JHf<00YYTI006VVEUVVIVVVMWVVMWVVQXVVUY0YYZ
JP03VV][VVa/VVe]00:JKVh01YY_KiY`L9YaLIYaLIYbLYYcL`:JM7@00iYe
MIYfMYYgM`02VWQh00NJNGVJNWZJNg^JNg^JO7bJOGfJOWh00YYoO`06VX20
VX61VX:2VX:2VX>3VXB40YZ5Q@03VXJ6VXN7VXR800:JRHT01YZ:RYZ;RiZ<
S9Z<S9Z=SIZ>SP:JShl00iZ@T9ZATIZBTP02VY>C00RJU9BJUIFJUYJJUYJJ
UiNJV9RJVIVJVYXJc<c<403oGXk<c<`016IVIXS0^8S0^4R@R04000000005
R<2hb>3HR<2hR<2hoooo02_<c<`01Y`009`10I`20Y`20Y`30i`410:L1@D0
0i`61Y`71i`82002W0T900NL2PZL2`^L30bL30bL3@fL3PjL3`l00Y`@4007
W14AW18BW1<CW1<CW1@DW1DEW1HF00:L5aL01i`H69`I6I`J6Y`J6Y`K6i`L
79`M7@02W1hN00NL7anL822L8B6L8B6L8R:L8b>L92@00Y`U9@07W2HVW2LW
W2PXW2PXW2TYW2XZW2/[00:L;2`01i`];I`^;Y`_;i`_;i``<9`a<I`b<P02
W3<c00NL=3BL=CFL=SJL=SJL=cNL>3RL>CT00Y`j>P07W3/kW3`lW3dmW3dm
W3hnW3loW41000:L@D401ia2@Ya3@ia4A9a4A9a5AIa6AYa7A`02W4Q800NL
BDVLBTZLBd^LBd^LC4bLCDfLCTh00Ya?C`07W51@W55AW59BW59BW5=CW5AD
W5EE00:LEUH01iaGEiaHF9aIFIaIFIaJFYaKFiaLG002W5eM00NLGUjLGenL
H62LH62LHF6LHV:LHf<00YaTI007W6EUW6IVW6MWW6MWW6QXW6UYW6YZ00:L
Jf/01ia/K9a]KIa^KYa^KYa_Kia`L9aaL@02W79b00NLLg>LM7BLMGFLMGFL
MWJLMgNLN7P00YaiN@07W7YjW7]kW7alW7alW7emW7inW7mo00:LP8001ib1
PIb2PYb3Pib3Pib4Q9b5QIb6QP02W8N700NLR8RLRHVLRXZLRXZLRh^LS8bL
SHd00Yb>SP07W8n?W92@W96AW96AW9:BW9>CW9BD00:LUID01ibFUYbGUibH
V9bHV9bIVIbJVYbKV`0Jc<c<403oEhk<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo02_<c<`01Yd009d10Id20Yd20Yd30id410:M
1@D00id61Yd71id82002W@T900>M2PZM2`^M30`00Yd=3@07W@h>W@l?WA0@
WA0@WA4AWA8BWA<C00:M51@00idE5IdF5YdG5`02WAPH00NM6AVM6QZM6a^M
6a^M71bM7AfM7Qh00YdO7`03WB0PWB4QWB8R00:M8b<01idT99dU9IdV9YdV
9YdW9idX:9dY:@02WBXZ00NM:b^M;2bM;BfM;BfM;RjM;bnM<3000Yda<@03
WC8bWC<cWC@d00:M=CD01idf=Ydg=idh>9dh>9di>Idj>Ydk>`02WC`l00>M
?CfM?SjM?cl00Ye0@007WD51WD92WD=3WD=3WDA4WDE5WDI600:MAdL01ie8
B9e9BIe:BYe:BYe;Bie<C9e=C@02WDi>00>MCdnMD52MDE400YeBDP07WE=C
WEADWEEEWEEEWEIFWEMGWEQH00:MFET00ieJFYeKFieLG002WEeM00NMGUjM
GenMH62MH62MHF6MHV:MHf<00YeTI003WFEUWFIVWFMW00:MJ6P01ieYJIeZ
JYe[Jie[Jie/K9e]KIe^KP02WFm_00NML72MLG6MLW:MLW:MLg>MM7BMMGD0
0YefMP03WGMgWGQhWGUi00:MNWX01iekNielO9emOIemOIenOYeoOif0P002
WH6100>MPX:MPh>MQ8@00Yf5Q@07WHJ6WHN7WHR8WHR8WHV9WHZ:WH^;00:M
S8`01if=SIf>SYf?Sif?Sif@T9fATIfBTP02WI>C00>MU9BMUIFMUYH00YfG
U`06WIRHWIVIWIZJWIZJWI^KWIbL6/c<c100odn>c<c<00AVIVJ8`;R8`;Q8
T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<00NN002N0@6N0P:N0P:N
0`>N10BN1@D00Yh61P07WPL7WPP8WPT9WPT9WPX:WP/;WP`<00:N3@d00ih>
3Yh?3ih@4002WQ4A00>N4Q:N4a>N51@00YhE5@03WQHFWQLGWQPH00:N6AT0
1ihJ6YhK6ihL79hL79hM7IhN7YhO7`02WR0P00>N8B6N8R:N8b<00YhT9003
WRDUWRHVWRLW00:N:2P01ihY:IhZ:Yh[:ih[:ih/;9h];Ih^;P02WRl_00>N
<32N<C6N<S800Yhc<`03WS@dWSDeWSHf00:N=cL01ihh>9hi>Ihj>Yhj>Yhk
>ihl?9hm?@02WShn00>N?cnN@42N@D400Yi2@P03WT=3WTA4WTE500:NATH0
0ii7Aii8B9i9B@02WTY:00NNBd^NC4bNCDfNCDfNCTjNCdnND5000YiAD@03
WU9BWU=CWUAD00:NEED00iiFEYiGEiiHF002WUUI00NNFUZNFe^NG5bNG5bN
GEfNGUjNGel00YiPH003WV5QWV9RWV=S00:NI6@00iiUIIiVIYiWI`02WVQX
00>NJFVNJVZNJf/00Yi/K007WVe]WVi^WVm_WVm_WW1`WW5aWW9b00:NLg<0
0iidM9ieMIifMP02WWMg00>NN7RNNGVNNWX00YikN`07WWalWWemWWinWWin
WWmoWX20WX6100:NPX800ij3Pij4Q9j5Q@02WXJ600>NQhNNR8RNRHT00Yj:
RP07WX^;WXb<WXf=WXf=WXj>WXn?WY2@00:NTI400ijBTYjCTijDU002WYFE
00>NUYJNUiNNV9P00YjIV@03WYZJWY^KWYbL00:NWIdJc<c<403oAhk<c<`0
16IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo02_<c<`01il0
09l10Il20Yl20Yl30il419l51@02W`H600>O1`NO20RO2@T00Yl:2P03W`/;
W``<W`d=00:O3Ph00il?3il@49lA4@02Wa8B00>O4a>O51BO5AD00YlF5P07
WaLGWaPHWaTIWaTIWaXJWa/KWa`L00:O7Ad00ilN7YlO7ilP8002Wb4Q00>O
8R:O8b>O92@00YlU9@03WbHVWbLWWbPX00:O:BT00ilZ:Yl[:il/;002Wbd]
00>O;RjO;bnO<3000Yla<@03Wc8bWc<cWc@d00:O=CD00ilf=Ylg=ilh>002
WcTi00>O>SZO>c^O?3`00Ylm?@03WchnWcloWd1000:O@D400im2@Ym3@im4
A002WdE500>OATJOAdNOB4P00Ym9B@03WdY:Wd];Wda<00:OCDd01im>CYm?
Cim@D9m@D9mADImBDYmCD`02WeAD00>OEEFOEUJOEeL00YmHF003WeUIWeYJ
We]K00:OG5`00imMGImNGYmOG`02Wf1P00>OHF6OHV:OHf<00YmTI003WfEU
WfIVWfMW00:OJ6P00imYJImZJYm[J`02Wfa/00>OKFfOKVjOKfl00Ym`L003
Wg5aWg9bWg=c00:OM7@00imeMImfMYmgM`02WgQh00>ONGVONWZONg/00Yml
O003WgemWginWgmo00:OP8001in1PIn2PYn3Pin3Pin4Q9n5QIn6QP02WhN7
00>OR8RORHVORXX00Yn;R`03Whb<Whf=Whj>00:OShl00in@T9nATInBTP02
Wi>C00>OU9BOUIFOUYH00YnGU`03WiRHWiVIWiZJ00:OVi/019nLW9nMWInN
WYnOWa[<c<`@0?m0S/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0:lc<c007X@00X@41X@82X@82X@<3X@@4X@D500:Q1PH00j47
1j482:492@02X@X:00>Q2`^Q30bQ3@d00Z4>3P03X@l?XA0@XA4A00:Q4Q80
0j4C4j4D5:4E5@02XAHF00BQ5aNQ61RQ6AVQ6QX2XA/K00>Q71bQ7AfQ7Qh0
0Z4O7`03XB0PXB4QXB8R00:Q8b<00j4T9:4U9J4V9P02XBLW00>Q:2RQ:BVQ
:RX00Z4[:`03XB`/XBd]XBh^00:Q;bl00j4`<:4a<J4b<P02XC<c00>Q=3BQ
=CFQ=SH00Z4g=`03XCPhXCTiXCXj00:Q>c/00j4l?:4m?J4n?P02XClo00>Q
@42Q@D6Q@T800Z53@`03XDA4XDE5XDI600:QAdL01:58B:59BJ5:BZ5;B`:Q
C4`00j5=CJ5>CZ5?C`02XE1@00>QDE6QDU:QDe<00Z5DE003XEEEXEIFXEMG
00:QF5P00j5IFJ5JFZ5KF`02XEaL00>QGEfQGUjQGel00Z5PH003XF5QXF9R
XF=S00:QI6@00j5UIJ5VIZ5WI`02XFQX00>QJFVQJVZQJf/00Z5/K003XFe]
XFi^XFm_00:QL7000j5aLJ5bLZ5cL`02XGAd00>QMGFQMWJQMgL00Z5hN004
XGUiXGYjXG]kXGal0Z5mO@03XGinXGmoXH2000:QPH400j62PZ63Pj64Q002
XHF500>QQXJQQhNQR8P00Z69R@03XHZ:XH^;XHb<00:QSHd00j6>SZ6?Sj6@
T002XI6A00>QTY:QTi>QU9@00Z6EU@03XIJFXINGXIRH00:QVIT00j6JVZ6K
Vj6LW002XIfM00>QWYjQWinQX:006/c<c100ocR>c<c<00AVIVJ8`;R8`;Q8
T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<00NR002R0@6R0P:R0P:R
0`>R10BR1@D00Z861P04XPL7XPP8XPT9XPX:0Z8;2`03XP`<XPd=XPh>00:R
3`l00j8@4:8A4J8B4P02XQ<C00>R51BR5AFR5QH00Z8G5`04XQPHXQTIXQXJ
XQ/K0Z8L7003XQdMXQhNXQlO00:R82000j8Q8J8R8Z8S8`02XR@T00>R9BFR
9RJR9bL00Z8X:004XRTYXRXZXR/[XR`/0Z8];@03XRh^XRl_XS0`00:R<C40
0j8b<Z8c<j8d=002XSDe00>R=SJR=cNR>3P00Z8i>@04XSXjXS/kXS`lXSdm
0Z8n?P03XSloXT10XT5100:R@T800j93@j94A:95A@02XTI600>RAdNRB4RR
BDT00Z9:BP04XT];XTa<XTe=XTi>0Z9?C`03XU1@XU5AXU9B00:RDe<00j9D
E:9EEJ9FEP02XUMG00>RF5RRFEVRFUX00Z9KF`04XUaLXUeMXUiNXUmO0Z9P
H003XV5QXV9RXV=S00:RI6@00j9UIJ9VIZ9WI`02XVQX00>RJFVRJVZRJf/0
0Z9/K004XVe]XVi^XVm_XW1`0Z9aL@03XW9bXW=cXWAd00:RMGD00j9fMZ9g
Mj9hN002XWUi00>RNWZRNg^RO7`00Z9mO@04XWinXWmoXX20XX610Z:2PP03
XX>3XXB4XXF500:RQXH00j:7Qj:8R::9R@02XXZ:00>RRh^RS8bRSHd00Z:>
SP04XXn?XY2@XY6AXY:B0Z:CT`03XYBDXYFEXYJF00:RUiL00j:HV::IVJ:J
VP02XY^K00>RW9bRWIfRWYh00Z:OW`03XZ2PXZ6Qc<c<01W<c<`@0?l`;Lc<
c003SXj>oooooooo03;oool/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`0[c<c<00RS002S0@6S0P:S0P:S0`>S10BS1@FS1PH2
X`L700>S20RS2@VS2PX00Z<;2`04X``<X`d=X`h>X`l?0Z<@4003Xa4AXa8B
Xa<C00:S51@00j<E5J<F5Z<G5`02XaPH00BS6AVS6QZS6a^S71`2XadM00>S
7QjS7anS82000Z<Q8@04Xb8RXb<SXb@TXbDU0Z<V9P03XbLWXbPXXbTY00:S
:RX01:<[:j</;:<];J<^;P:S;bl00j<`<:<a<J<b<P02Xc<c00>S=3BS=CFS
=SH00Z<g=`04XcPhXcTiXcXjXc/k0Z<l?003XcdmXchnXclo00:S@4001:=1
@J=2@Z=3@j=4A0:SADD00j=6AZ=7Aj=8B002XdU900BSBTZSBd^SC4bSCDd2
Xdi>00>SCdnSD52SDE400Z=BDP03Xe=CXeADXeEE00:SEUH01:=GEj=HF:=I
FJ=JFP:SFe/00j=LG:=MGJ=NGP02XemO00BSH62SHF6SHV:SHf<2XfAT00>S
IFFSIVJSIfL00Z=XJ004XfUYXfYZXf][Xfa/0Z=]K@03Xfi^Xfm_Xg1`00:S
LG401:=bLZ=cLj=dM:=eM@:SMWH00j=gMj=hN:=iN@02XgYj00>SNg^SO7bS
OGd00Z=nOP04XgmoXh20Xh61Xh:20Z>3P`03XhB4XhF5XhJ600:SQhL01:>8
R:>9RJ>:RZ>;R`:SS8`00j>=SJ>>SZ>?S`02Xi2@00BSTI6STY:STi>SU9@2
XiFE00>SUYJSUiNSV9P00Z>IV@03XiZJXi^KXibL00:SWId01:>NWZ>OWj>P
X:>QX@:SXZ8Jc<c<403o:Bg<c<`00hj>SV=SHoooo`0boooo;<c<c004IVIV
R<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c008Y000Y041
Y082Y082Y0<3Y0@4Y0D5Y0H60Z@71`04Y0P8Y0T9Y0X:Y0/;0Z@<3003Y0d=
Y0h>Y0l?00:T41001:@A4J@B4Z@C4j@D50:T5AD00j@F5Z@G5j@H6002Y1TI
00BT6QZT6a^T71bT7Ad2Y1hN00BT7anT822T8B6T8R82Y2<S00>T92BT9BFT
9RH00Z@W9`04Y2PXY2TYY2XZY2/[0Z@/;004Y2d]Y2h^Y2l_Y30`0Z@a<@03
Y38bY3<cY3@d00:T=CD01:@f=Z@g=j@h>:@i>@:T>SX01:@k>j@l?:@m?J@n
?P:T?cl00jA0@:A1@JA2@P02Y4=300BTA4BTADFTATJTAdL2Y4Q800>TBDVT
BTZTBd/00ZA<C004Y4e=Y4i>Y4m?Y51@0ZAAD@04Y59BY5=CY5ADY5EE0ZAF
EP03Y5MGY5QHY5UI00:TFUX01:AKFjALG:AMGJANGP:TGel01:APH:AQHJAR
HZASH`:TI6@00jAUIJAVIZAWI`02Y6QX00BTJFVTJVZTJf^TK6`2Y6e]00>T
KVjTKfnTL7000ZAaL@04Y79bY7=cY7AdY7Ee0ZAfMP04Y7MgY7QhY7UiY7Yj
0ZAkN`03Y7alY7emY7in00:TOgl01:B0P:B1PJB2PZB3P`:TQ8@01:B5QJB6
QZB7QjB8R0:TRHT00jB:RZB;RjB<S002Y8f=00BTSXjTShnTT92TTI42Y9:B
00>TTi>TU9BTUID00ZBFUP04Y9NGY9RHY9VIY9ZJ0ZBKV`04Y9bLY9fMY9jN
Y9nO0ZBPX004Y:6QY::RY:>SY:BT6/c<c100ob4]c<c<00>>SXiSHf?<c<`0
8?oooa1VIVH2oooo;<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0:lc<c008YP00YP41YP82YP82YP<3YP@4YPD5YPH60ZH71`04
YPP8YPT9YPX:YP/;0ZH<3004YPd=YPh>YPl?YQ0@0ZHA4@04YQ8BYQ<CYQ@D
YQDE0ZHF5P04YQLGYQPHYQTIYQXJ0ZHK6`03YQ`LYQdMYQhN00:V7al01:HP
8:HQ8JHR8ZHS8`:V92@01:HU9JHV9ZHW9jHX:0:V:BT01:HZ:ZH[:jH/;:H]
;@:V;Rh01:H_;jH`<:Ha<JHb<P:V<c<01:Hd=:He=JHf=ZHg=`:V>3P00jHi
>JHj>ZHk>`02YS`l00BV?CfV?SjV?cnV@402YT5100BV@T:V@d>VA4BVADD2
YTI600BVAdNVB4RVBDVVBTX2YT];00BVC4bVCDfVCTjVCdl2YU1@00BVDE6V
DU:VDe>VE5@2YUEE00BVEUJVEeNVF5RVFET2YUYJ00>VFe^VG5bVGEd00ZIN
GP04YUmOYV1PYV5QYV9R0ZISH`04YVATYVEUYVIVYVMW0ZIXJ004YVUYYVYZ
YV][YVa/0ZI]K@04YVi^YVm_YW1`YW5a0ZIbLP04YW=cYWAdYWEeYWIf0ZIg
M`03YWQhYWUiYWYj00:VNg/01:IlO:ImOJInOZIoO`:VP8001:J1PJJ2PZJ3
PjJ4Q0:VQHD01:J6QZJ7QjJ8R:J9R@:VRXX01:J;RjJ<S:J=SJJ>SP:VShl0
1:J@T:JATJJBTZJCT`:VU9@00jJEUJJFUZJGU`02YYRH00BVVIVVVYZVVi^V
W9`2YYfM00BVWYjVWinVX:2VXJ42YZ:R00>VXj>VY:BVYJD06/c<c100oaT]
c<c<00B>SXiSHf=VIVK<c<`NIVIV00?oooo<c<bIVIT03IVIV@03IVIVoooo
oooo02c<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo
02_<c<`00jL00:L10JL20P02Y`<300BW10BW1@FW1PJW1`L2Y`P800BW2@VW
2PZW2`^W30`2Y`d=00BW3PjW3`nW412W4A42Ya8B00BW4a>W51BW5AFW5QH2
YaLG00BW61RW6AVW6QZW6a/2Ya`L00BW7AfW7QjW7anW8202Yb4Q00BW8R:W
8b>W92BW9BD2YbHV00BW9bNW:2RW:BVW:RX2Yb/[00BW;2bW;BfW;RjW;bl2
Yc0`00BW<C6W<S:W<c>W=3@2YcDe00BW=SJW=cNW>3RW>CT2YcXj00BW>c^W
?3bW?CfW?Sh2Yclo00BW@42W@D6W@T:W@d<2YdA400BWADFWATJWAdNWB4P2
YdU900FWBTZWBd^WC4bWCDfWCTh00ZM?C`04Ye1@Ye5AYe9BYe=C0ZMDE004
YeEEYeIFYeMGYeQH0ZMIF@04YeYJYe]KYeaLYeeM0ZMNGP04YemOYf1PYf5Q
Yf9R0ZMSH`04YfATYfEUYfIVYfMW0ZMXJ004YfUYYfYZYf][Yfa/0ZM]K@04
Yfi^Yfm_Yg1`Yg5a0ZMbLP04Yg=cYgAdYgEeYgIf0ZMgM`04YgQhYgUiYgYj
Yg]k0ZMlO004YgemYginYgmoYh200ZN1P@04Yh:2Yh>3YhB4YhF50ZN6QP04
YhN7YhR8YhV9YhZ:0ZN;R`04Yhb<Yhf=Yhj>Yhn?0ZN@T004Yi6AYi:BYi>C
YiBD0ZNEU@04YiJFYiNGYiRHYiVI0ZNJVP05Yi^KYibLYifMYijNYinO00:W
X:001:NQXJNRXZNSXjNTY0:WYJD00jNVY/c<c<c<c00Hc<c<403o4Rg<c<`0
0hj>SV=SHfIVIP0Noooo00AVIVKoooo<c<coool<c<c<00BIVIUVIVKooooo
ool/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[
c<c<00>X002X0@6X0P800ZP30`04Z0@4Z0D5Z0H6Z0L70ZP82004Z0T9Z0X:
Z0/;Z0`<0ZP=3@05Z0h>Z0l?Z10@Z14AZ18B00:X4a<01:PD5:PE5JPF5ZPG
5`:X61P01:PI6JPJ6ZPK6jPL70:X7Ad01JPN7ZPO7jPP8:PQ8JPR8P02Z2<S
00BX92BX9BFX9RJX9bL2Z2PX00BX:BVX:RZX:b^X;2`2Z2d]00BX;RjX;bnX
<32X<C42Z38b00FX<c>X=3BX=CFX=SJX=cL00ZPh>004Z3TiZ3XjZ3/kZ3`l
0ZPm?@04Z3hnZ3loZ410Z4510ZQ2@P05Z4=3Z4A4Z4E5Z4I6Z4M700:XB4P0
1:Q9BJQ:BZQ;BjQ<C0:XCDd01:Q>CZQ?CjQ@D:QAD@:XDU801JQCDjQDE:QE
EJQFEZQGE`02Z5QH00BXFEVXFUZXFe^XG5`2Z5eM00BXGUjXGenXH62XHF42
Z69R00FXHf>XI6BXIFFXIVJXIfL00ZQXJ004Z6UYZ6YZZ6][Z6a/0ZQ]K@04
Z6i^Z6m_Z71`Z75a0ZQbLP04Z7=cZ7AdZ7EeZ7If0ZQgM`05Z7QhZ7UiZ7Yj
Z7]kZ7al00:XOGd01:QnOZQoOjR0P:R1P@:XPX801:R3PjR4Q:R5QJR6QP:X
QhL01JR8R:R9RJR:RZR;RjR<S002Z8f=00BXSXjXShnXT92XTI42Z9:B00BX
Ti>XU9BXUIFXUYH2Z9NG00FXV9RXVIVXVYZXVi^XW9`00ZRMW@04Z9jNZ9nO
Z:2PZ:6Q0ZRRXP04Z:>SZ:BTZ:FUZ:JV0ZRWYa[<c<`@0?l:3/c<c0CooolK
c<c<00>>SXiSHf=VIVH07_ooo`04IVIVooooc<c<oooo3<c<c004VIVIIVIV
oooooooo;<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;So
ool0:lc<c003ZP00ZP41ZP8200:Z0`<01:X41:X51JX61ZX71`:Z20P01JX9
2JX:2ZX;2jX<3:X=3@02ZPh>00FZ3`nZ412Z4A6Z4Q:Z4a<00ZXD5004ZQDE
ZQHFZQLGZQPH0ZXI6@05ZQXJZQ/KZQ`LZQdMZQhN00:Z7al01:XP8:XQ8JXR
8ZXS8`:Z92@01JXU9JXV9ZXW9jXX::XY:@02ZRXZ00BZ:b^Z;2bZ;BfZ;Rh2
ZRl_00FZ<32Z<C6Z<S:Z<c>Z=3@00ZXe=@05ZSHfZSLgZSPhZSTiZSXj00:Z
>c/01:Xl?:Xm?JXn?ZXo?`:Z@4001JY1@JY2@ZY3@jY4A:Y5A@02ZTI600BZ
AdNZB4RZBDVZBTX2ZT];00FZC4bZCDfZCTjZCdnZD5000ZYAD@04ZU9BZU=C
ZUADZUEE0ZYFEP05ZUMGZUQHZUUIZUYJZU]K00:ZG5`01JYMGJYNGZYOGjYP
H:YQH@02ZV9R00BZHf>ZI6BZIFFZIVH2ZVMW00FZJ6RZJFVZJVZZJf^ZK6`0
0ZY]K@04ZVi^ZVm_ZW1`ZW5a0ZYbLP05ZW=cZWAdZWEeZWIfZWMg00:ZN7P0
1:YiNJYjNZYkNjYlO0:ZOGd01JYnOZYoOjZ0P:Z1PJZ2PP02ZX>300FZQ8BZ
QHFZQXJZQhNZR8P00ZZ9R@04ZXZ:ZX^;ZXb<ZXf=0ZZ>SP05ZXn?ZY2@ZY6A
ZY:BZY>C00:ZU9@01:ZEUJZFUZZGUjZHV0:ZVIT01JZJVZZKVjZLW:ZMWJZN
WP02ZYnO00BZX:2ZXJ6ZXZ:ZXj<2ZZBT00FZYJFZYZJZYjNZZ:RZZJT06/c<
c100o`<<c<c<0_ooo`AVIVH2oooo6Lc<c003SXj>Hf=SIVIV01koool016IV
I_ooolc<c?ooo`G<c<`00fIVI/c<c<c<c004c<c<00BIVIUVIVKoooooool/
c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<
00>[002[0@6[0P800Z/30`05Z`@4Z`D5Z`H6Z`L7Z`P800:[2@T01J/:2Z/;
2j/<3:/=3J/>3P02Z`l?00F[412[4A6[4Q:[4a>[51@00Z/E5@04ZaHFZaLG
ZaPHZaTI0Z/J6P05Za/KZa`LZadMZahNZalO00:[82001J/Q8J/R8Z/S8j/T
9:/U9@02ZbHV00F[9bN[:2R[:BV[:RZ[:b/00Z//;005Zbd]Zbh^Zbl_Zc0`
Zc4a00:[<S801J/c<j/d=:/e=J/f=Z/g=`02ZcPh00F[>CV[>SZ[>c^[?3b[
?Cd00Z/n?P04ZcloZd10Zd51Zd920Z]3@`05ZdA4ZdE5ZdI6ZdM7ZdQ800:[
BDT01J]:BZ];Bj]<C:]=CJ]>CP02Zdm?00F[D52[DE6[DU:[De>[E5@00Z]E
E@05ZeIFZeMGZeQHZeUIZeYJ00:[Fe/01J]LG:]MGJ]NGZ]OGj]PH002Zf5Q
00F[HV:[Hf>[I6B[IFF[IVH00Z]WI`04ZfQXZfUYZfYZZf][0Z]/K005Zfe]
Zfi^Zfm_Zg1`Zg5a00:[LW801J]cLj]dM:]eMJ]fMZ]gM`02ZgQh00F[NGV[
NWZ[Ng^[O7b[OGd00Z]nOP05ZgmoZh20Zh61Zh:2Zh>300:[Q8@01J^5QJ^6
QZ^7Qj^8R:^9R@02ZhZ:00F[Rh^[S8b[SHf[SXj[Shl00Z^@T004Zi6AZi:B
Zi>CZiBD0Z^EU@05ZiJFZiNGZiRHZiVIZiZJ00:[Vi/01J^LW:^MWJ^NWZ^O
Wj^PX002Zj6Q00F[XZ:[Xj>[Y:B[YJF[YZH00Z^WY`03ZjRXZjVYZjZZ01[<
c<`@1Ol03<c<c09VIVH4c<c<0VIVIP03ooooc<c<c<c<00C<c<`600003<c<
c003SXj>Hf=SIVIV017oool300001?ooo`<00003oooo00AVIVKoooo<c<co
ool4c<c<0fIVIPG<c<`019VIVFIVI_ooooooobc<c<`016IVIXS0^8S0^4R@
R04000000005R<2hb>3HR<2hR<2hoooo02_<c<`00j`00:`10J`20P02[0<3
00F/10B/1@F/1PJ/1`N/20P00Z`92@05[0X:[0/;[0`<[0d=[0h>00:/3`l0
1Z`@4:`A4J`B4Z`C4j`D5:`E5@:/5QH01J`G5j`H6:`I6J`J6Z`K6`02[1`L
00F/7Af/7Qj/7an/822/8B400Z`R8P05[2<S[2@T[2DU[2HV[2LW00:/:2P0
1J`Y:J`Z:Z`[:j`/;:`];@02[2h^00F/;bn/<32/<C6/<S:/<c<00Z`d=006
[3De[3Hf[3Lg[3Ph[3Ti[3Xj0Z`k>`05[3`l[3dm[3hn[3lo[41000:/@D40
1Ja2@Za3@ja4A:a5AJa6AP02[4M700F/B4R/BDV/BTZ/Bd^/C4`00Za=C@05
[4i>[4m?[51@[55A[59B00:/De<01ZaDE:aEEJaFEZaGEjaHF:aIF@:/FUX0
1JaKFjaLG:aMGJaNGZaOG`02[61P00F/HF6/HV:/Hf>/I6B/IFD00ZaVIP05
[6MW[6QX[6UY[6YZ[6][00:/K6`01Ja]KJa^KZa_Kja`L:aaL@02[79b00F/
Lg>/M7B/MGF/MWJ/MgL00ZahN006[7Ui[7Yj[7]k[7al[7em[7in0ZaoO`05
[820[861[8:2[8>3[8B400:/QHD01Jb6QZb7Qjb8R:b9RJb:RP02[8^;00F/
S8b/SHf/SXj/Shn/T9000ZbAT@05[9:B[9>C[9BD[9FE[9JF00:/UiL01JbH
V:bIVJbJVZbKVjbLW002[9fM00J/WYj/Win/X:2/XJ6/XZ:/Xj<2[:BT00F/
YJF/YZJ/YjN/Z:R/ZJT00ZbZZP03[:^[c<c<c<c<01S<c<`@3Ol02lc<c003
IVIVooooc<c<00K<c<`00fIVI_ooolc<c004c<c<0P0000?<c<`200002lc<
c003SXj>Hf=SIVIV013oool01@000?ooooooooooo`000002oooo00D0003o
ooooooooool000000_ooo`04IVIVooooc<c<oooo3<c<c004VIVIIVIVoooo
oooo;<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0
:lc<c003[@00[@41[@8200:]0`<01Zd41:d51Jd61Zd71jd82:d92@:]2PX0
1Jd;2jd<3:d=3Jd>3Zd?3`02[A0@00J]4A6]4Q:]4a>]51B]5AF]5QH2[ALG
00F]61R]6AV]6QZ]6a^]71`00ZdM7@06[AhN[AlO[B0P[B4Q[B8R[B<S0ZdT
9005[BDU[BHV[BLW[BPX[BTY00:]:RX01Zd[:jd/;:d];Jd^;Zd_;jd`<0:]
<C401Jdb<Zdc<jdd=:de=Jdf=P02[CLg00J]>3R]>CV]>SZ]>c^]?3b]?Cd2
[Chn00F]?cn]@42]@D6]@T:]@d<00Ze4A006[DE5[DI6[DM7[DQ8[DU9[DY:
0Ze;B`05[Da<[De=[Di>[Dm?[E1@00:]DE401ZeBDZeCDjeDE:eEEJeFEZeG
E`:]F5P01ZeIFJeJFZeKFjeLG:eMGJeNGP:]Gel01JePH:eQHJeRHZeSHjeT
I002[FEU00J]IVJ]IfN]J6R]JFV]JVZ]Jf/2[Fa/00F]KFf]KVj]Kfn]L72]
LG400ZebLP06[G=c[GAd[GEe[GIf[GMg[GQh0ZeiN@05[GYj[G]k[Gal[Gem
[Gin00:]Ogl01Zf0P:f1PJf2PZf3Pjf4Q:f5Q@:]QXH01Jf7Qjf8R:f9RJf:
RZf;R`02[Hb<00J]SHf]SXj]Shn]T92]TI6]TY82[I>C00F]U9B]UIF]UYJ]
UiN]V9P00ZfIV@06[IZJ[I^K[IbL[IfM[IjN[InO0ZfPX005[J6Q[J:R[J>S
[JBT[JFU00:]YZH01jfWYjfXZ:fYZJfZZZf[Zjf/[:f][@0Jc<c<41Co00_<
c<`00fIVI_ooolc<c006c<c<00=VIVKoooo<c<`01<c<c0800003c<c<0P00
00_<c<`00hj>SV=SHfIVIP0@oooo00D0003oooooooooool000000_ooo`05
0000oooooooooooo000000;oool016IVI_ooolc<c?ooo`c<c<`019VIVFIV
I_ooooooobc<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo02_<c<`00jl00:l10Jl20P02[`<300J_10B_1@F_1PJ_1`N_20R_2@T2
[`X:00J_2`^_30b_3@f_3Pj_3`n_4102[a4A00J_4Q:_4a>_51B_5AF_5QJ_
5aL2[aPH00J_6AV_6QZ_6a^_71b_7Af_7Qh2[alO00J_822_8B6_8R:_8b>_
92B_9BD2[bHV00J_9bN_:2R_:BV_:RZ_:b^_;2`2[bd]00J_;Rj_;bn_<32_
<C6_<S:_<c<2[c@d00J_=CF_=SJ_=cN_>3R_>CV_>SX2[c/k00J_?3b_?Cf_
?Sj_?cn_@42_@D42[d9200F_@d>_A4B_ADF_ATJ_AdL00Zm8B006[dU9[dY:
[d];[da<[de=[di>0Zm?C`06[e1@[e5A[e9B[e=C[eAD[eEE0ZmFEP06[eMG
[eQH[eUI[eYJ[e]K[eaL0ZmMG@06[eiN[emO[f1P[f5Q[f9R[f=S0ZmTI006
[fEU[fIV[fMW[fQX[fUY[fYZ0Zm[J`06[fa/[fe][fi^[fm_[g1`[g5a0Zmb
LP06[g=c[gAd[gEe[gIf[gMg[gQh0ZmiN@06[gYj[g]k[gal[gem[gin[gmo
0Zn0P005[h61[h:2[h>3[hB4[hF500:_QXH01Zn7Qjn8R:n9RJn:RZn;Rjn<
S0:_SHd01Zn>SZn?Sjn@T:nATJnBTZnCT`:_U9@01ZnEUJnFUZnGUjnHV:nI
VJnJVP:_Vi/01ZnLW:nMWJnNWZnOWjnPX:nQX@:_XZ801ZnSXjnTY:nUYJnV
YZnWYjnXZ0:_ZJT01JnZZZn[Zjn/[:n][Jn^[P0Jc<c<41co00[<c<`00fIV
I_ooolc<c008c<c<00=VIVKoooo<c<`00lc<c0800003c<c<0P0000_<c<`0
0hj>SV=SHfIVIP0@oooo00D0003oooooooooool000000_ooo`050000oooo
oooooooo000000;oool00fIVI_ooolc<c00=oooo00BIVIUVIVKoooooool/
c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<
00B`002`0@6`0P:`0`<2/0@400J`1@F`1PJ`1`N`20R`2@V`2PX2/0/;00J`
30b`3@f`3Pj`3`n`412`4A42/18B00N`4a>`51B`5AF`5QJ`5aN`61R`6AT0
0[0J6P06/1/K/1`L/1dM/1hN/1lO/20P0[0Q8@06/28R/2<S/2@T/2DU/2HV
/2LW0[0X:007/2TY/2XZ/2/[/2`//2d]/2h^/2l_00:`<3001[0a<K0b<[0c
<k0d=;0e=K0f=P:`=cL01[0h>;0i>K0j>[0k>k0l?;0m?@:`?Sh01k0o?k10
@;11@K12@[13@k14A;15A@02/4I600J`AdN`B4R`BDV`BTZ`Bd^`C4`2/4e=
00J`CTj`Cdn`D52`DE6`DU:`De<2/5AD00J`EEF`EUJ`EeN`F5R`FEV`FUX2
/5]K00N`G5b`GEf`GUj`Gen`H62`HF6`HV800[1SH`06/6AT/6EU/6IV/6MW
/6QX/6UY0[1ZJP06/6][/6a//6e]/6i^/6m_/71`0[1aL@07/79b/7=c/7Ad
/7Ee/7If/7Mg/7Qh00:`NGT01[1jN[1kNk1lO;1mOK1nO[1oO`:`P8001[21
PK22P[23Pk24Q;25QK26QP:`QhL01k28R;29RK2:R[2;Rk2<S;2=SK2>SP02
/8n?00J`T92`TI6`TY:`Ti>`U9B`UID2/9JF00J`UiN`V9R`VIV`VYZ`Vi^`
W9`2/9fM00N`WYj`Win`X:2`XJ6`XZ:`Xj>`Y:@00[2UY@06/:JV/:NW/:RX
/:VY/:ZZ/:^[0[2/[003/:f]/:j^/:n_01[<c<`@9?l02/c<c003IVIVoooo
c<c<00S<c<`00fIVI_ooolc<c003c<c<1P0000c<c<`00hj>SV=SHfIVIP0A
oooo0`0000Coool300000oooo`03IVIVooooc<c<00k<c<`00fIVI_oooooo
o`0/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[
c<c<00Ba002a0@6a0P:a0`<2/@@400Na1@Fa1PJa1`Na20Ra2@Va2PZa2`/0
0[4<3006/@d=/@h>/@l?/A0@/A4A/A8B0[4C4`07/A@D/ADE/AHF/ALG/APH
/ATI/AXJ00:a6a/01k4L7;4M7K4N7[4O7k4P8;4Q8K4R8P02/B<S00Na92Ba
9BFa9RJa9bNa:2Ra:BVa:RX00[4[:`07/B`//Bd]/Bh^/Bl_/C0`/C4a/C8b
00:a<c<01[4d=;4e=K4f=[4g=k4h>;4i>@:a>SX01k4k>k4l?;4m?K4n?[4o
?k50@;51@@02/D9200Na@d>aA4BaADFaATJaAdNaB4RaBDT00[5:BP07/D];
/Da</De=/Di>/Dm?/E1@/E5A00:aDU801[5CDk5DE;5EEK5FE[5GEk5HF0:a
FET01k5JF[5KFk5LG;5MGK5NG[5OGk5PH002/F5Q00NaHV:aHf>aI6BaIFFa
IVJaIfNaJ6P00[5YJ@07/FYZ/F][/Fa//Fe]/Fi^/Fm_/G1`00:aLG401k5b
L[5cLk5dM;5eMK5fM[5gMk5hN002/GUi00JaNWZaNg^aO7baOGfaOWjaOgl2
/H2000NaPH6aPX:aPh>aQ8BaQHFaQXJaQhL00[68R007/HV9/HZ:/H^;/Hb<
/Hf=/Hj>/Hn?00:aT9001k6ATK6BT[6CTk6DU;6EUK6FU[6GU`02/IRH00Na
VIVaVYZaVi^aW9baWIfaWYjaWil00[6PX006/J6Q/J:R/J>S/JBT/JFU/JJV
0[6WY`07/JRX/JVY/JZZ/J^[/Jb//Jf]/Jj^00:a[jl00k6`/<c<c<c<c00H
c<c<42_o00[<c<`00fIVI_ooolc<c008c<c<00=VIVKoooo<c<`00lc<c080
0003c<c<0P0000_<c<`00hj>SV=SHfIVIP0@oooo00D0003oooooooooool0
00000_ooo`050000oooooooooooo000000;oool00fIVI_ooofIVIP0?IVIV
0_ooobc<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo
02_<c<`01;<00;<10K<20[<30`:c10@01k<51K<61[<71k<82;<92K<:2[<;
2`02/``<00Rc3@fc3Pjc3`nc412c4A6c4Q:c4a>c51@2/aDE00Nc5QJc5aNc
61Rc6AVc6QZc6a^c71`00[<M7@07/ahN/alO/b0P/b4Q/b8R/b<S/b@T00:c
9BD02;<V9[<W9k<X:;<Y:K<Z:[<[:k</;;<];@:c;Rh01k<_;k<`<;<a<K<b
<[<c<k<d=;<e=@02/cHf00Nc=cNc>3Rc>CVc>SZc>c^c?3bc?Cd00[<n?P08
/clo/d10/d51/d92/d=3/dA4/dE5/dI60[=7A`07/dQ8/dU9/dY:/d];/da<
/de=/di>00:cCdl01k=@D;=ADK=BD[=CDk=DE;=EEK=FEP02/eMG00NcF5Rc
FEVcFUZcFe^cG5bcGEfcGUh00[=OG`08/f1P/f5Q/f9R/f=S/fAT/fEU/fIV
/fMW0[=XJ007/fUY/fYZ/f][/fa//fe]/fi^/fm_00:cL7001k=aLK=bL[=c
Lk=dM;=eMK=fM[=gM`02/gQh00RcNGVcNWZcNg^cO7bcOGfcOWjcOgncP802
/h6100NcPX:cPh>cQ8BcQHFcQXJcQhNcR8P00[>9R@07/hZ:/h^;/hb</hf=
/hj>/hn?/i2@00:cTI402;>BT[>CTk>DU;>EUK>FU[>GUk>HV;>IV@:cVYX0
1k>KVk>LW;>MWK>NW[>OWk>PX;>QX@02/j:R00NcXj>cY:BcYJFcYZJcYjNc
Z:RcZJT00[>ZZP08/j^[/jb//jf]/jj^/jn_/k2`/k6a/k:b6/c<c10co`0:
c<c<00=VIVKoooo<c<`02<c<c003IVIVooooc<c<00?<c<`200000lc<c080
000;c<c<00>>SXiSHf=VIVH04?ooo`050000oooooooooooo000000;oool0
1@000?ooooooooooo`000002oooo00=VIVKoooo<c<`03YVIV@03IVIVoooo
oooo02c<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo
02_<c<`01;@00;@10K@20[@30`:d10@02;@51K@61[@71k@82;@92K@:2[@;
2k@<30:d3@d02;@>3[@?3k@@4;@A4K@B4[@C4k@D5;@E5@:d5QH02;@G5k@H
6;@I6K@J6[@K6k@L7;@M7K@N7P:d7al02;@P8;@Q8K@R8[@S8k@T9;@U9K@V
9[@W9`:d:2P02;@Y:K@Z:[@[:k@/;;@];K@^;[@_;k@`<0:d<C402;@b<[@c
<k@d=;@e=K@f=[@g=k@h>;@i>@:d>SX02;@k>k@l?;@m?K@n?[@o?kA0@;A1
@KA2@P:d@d<02;A4A;A5AKA6A[A7AkA8B;A9BKA:B[A;B`:dC4`01kA=CKA>
C[A?CkA@D;AADKABD[ACD`02]5AD00RdEEFdEUJdEeNdF5RdFEVdFUZdFe^d
G5`2]5eM00RdGUjdGendH62dHF6dHV:dHf>dI6BdIFD2]6IV00RdIfNdJ6Rd
JFVdJVZdJf^dK6bdKFfdKVh2]6m_00RdL72dLG6dLW:dLg>dM7BdMGFdMWJd
MgL2]7Qh00RdNGVdNWZdNg^dO7bdOGfdOWjdOgndP802]86100RdPX:dPh>d
Q8BdQHFdQXJdQhNdR8RdRHT2]8Z:00RdRh^dS8bdSHfdSXjdShndT92dTI6d
TY82]9>C00RdU9BdUIFdUYJdUiNdV9RdVIVdVYZdVi/2]9bL00NdWIfdWYjd
WindX:2dXJ6dXZ:dXj<00[BTY008]:FU]:JV]:NW]:RX]:VY]:ZZ]:^[]:b/
0[B][@06]:j^]:n_];2`];6a];:b];>c6/c<c10ko`0;c<c<00=VIVKoooo<
c<`01/c<c003IVIVooooc<c<00C<c<`200000lc<c080000;c<c<00>>SXiS
Hf=VIVH04?ooo`050000oooooooooooo000000;oool01@000?oooooooooo
o`000002oooo00AVIVKoooo<c<coool<c<c<00BIVIUVIVKoooooool/c<c<
00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<00Fe
002e0@6e0P:e0`>e10@00[D51@08]@H6]@L7]@P8]@T9]@X:]@/;]@`<]@d=
0[D>3P09]@l?]A0@]A4A]A8B]A<C]A@D]ADE]AHF]ALG00:e61P02;DI6KDJ
6[DK6kDL7;DM7KDN7[DO7kDP80:e8B402KDR8[DS8kDT9;DU9KDV9[DW9kDX
:;DY:KDZ:P02]B/[00Ve;2be;Bfe;Rje;bne<32e<C6e<S:e<c>e=3@00[De
=@08]CHf]CLg]CPh]CTi]CXj]C/k]C`l]Cdm0[Dn?P09]Clo]D10]D51]D92
]D=3]DA4]DE5]DI6]DM700:eB4P02;E9BKE:B[E;BkE<C;E=CKE>C[E?CkE@
D0:eDE402KEBD[ECDkEDE;EEEKEFE[EGEkEHF;EIFKEJFP02]E]K00ReG5be
GEfeGUjeGeneH62eHF6eHV:eHf<2]FAT00VeIFFeIVJeIfNeJ6ReJFVeJVZe
Jf^eK6beKFd00[E^KP08]Fm_]G1`]G5a]G9b]G=c]GAd]GEe]GIf0[EgM`09
]GQh]GUi]GYj]G]k]Gal]Gem]Gin]Gmo]H2000:ePH402KF2P[F3PkF4Q;F5
QKF6Q[F7QkF8R;F9RKF:RP02]H^;00ReS8beSHfeSXjeShneT92eTI6eTY:e
Ti<2]IBD00VeUIFeUYJeUiNeV9ReVIVeVYZeVi^eW9beWId00[FNWP08]InO
]J2P]J6Q]J:R]J>S]JBT]JFU]JJV0[FWY`09]JRX]JVY]JZZ]J^[]Jb/]Jf]
]Jj^]Jn_]K2`00:e/K400kFb/[Fc/kFd]00Jc<c<44;o00_<c<`00fIVI_oo
ooooo`04c<c<0_ooo`03IVIVooooc<c<00C<c<`600003<c<c003SXj>Hf=S
IVIV017oool300001?ooo`<00003oooo00AVIVKoooo<c<coool<c<c<00BI
VIUVIVKoooooool/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^?ooo`0[c<c<00Ff002f0@6f0P:f0`>f10@00[H51@09]PH6]PL7]PP8
]PT9]PX:]P/;]P`<]Pd=]Ph>00:f3`l02[H@4;HA4KHB4[HC4kHD5;HE5KHF
5[HG5kHH6;HI6@:f6QX02KHK6kHL7;HM7KHN7[HO7kHP8;HQ8KHR8[HS8`02
]R@T00Vf9BFf9RJf9bNf:2Rf:BVf:RZf:b^f;2bf;Bd00[H^;P0:]Rl_]S0`
]S4a]S8b]S<c]S@d]SDe]SHf]SLg]SPh0[Hi>@09]SXj]S/k]S`l]Sdm]Shn
]Slo]T10]T51]T9200:f@d<02KI4A;I5AKI6A[I7AkI8B;I9BKI:B[I;BkI<
C002]Te=00ZfCTjfCdnfD52fDE6fDU:fDe>fE5BfEEFfEUJfEeL2]UQH00Vf
FEVfFUZfFe^fG5bfGEffGUjfGenfH62fHF400[IRHP09]V=S]VAT]VEU]VIV
]VMW]VQX]VUY]VYZ]V][00:fK6`02[I]KKI^K[I_KkI`L;IaLKIbL[IcLkId
M;IeMKIfMP:fMgL02KIhN;IiNKIjN[IkNkIlO;ImOKInO[IoOkJ0P002]X61
00VfPX:fPh>fQ8BfQHFfQXJfQhNfR8RfRHVfRXX00[J;R`0:]Xb<]Xf=]Xj>
]Xn?]Y2@]Y6A]Y:B]Y>C]YBD]YFE0[JFUP09]YNG]YRH]YVI]YZJ]Y^K]YbL
]YfM]YjN]YnO00:fX:002KJQXKJRX[JSXkJTY;JUYKJVY[JWYkJXZ;JYZ@02
]ZZZ00ZfZj^f[:bf[Jff[Zjf[jnf/;2f/K6f/[:f/k>f];@2][Fe6/c<c11:
o`0<c<c<0VIVIPCoool2IVIV00?oooo<c<c<c<`05/c<c003SXj>Hf=SIVIV
01koool016IVI_ooolc<c?ooo`C<c<`3IVIV1Lc<c004VIVIIVIVoooooooo
;<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<
c006^000^041^082^0<3^0@4^0D50[P61P0:^0L7^0P8^0T9^0X:^0/;^0`<
^0d=^0h>^0l?^10@0[PA4@0:^18B^1<C^1@D^1DE^1HF^1LG^1PH^1TI^1XJ
^1/K0[PL700:^1dM^1hN^1lO^20P^24Q^28R^2<S^2@T^2DU^2HV0[PW9`0:
^2PX^2TY^2XZ^2/[^2`/^2d]^2h^^2l_^30`^34a0[Pb<P0;^3<c^3@d^3De
^3Hf^3Lg^3Ph^3Ti^3Xj^3/k^3`l^3dm00:h?Sh02[Po?kQ0@;Q1@KQ2@[Q3
@kQ4A;Q5AKQ6A[Q7AkQ8B0:hBDT02[Q:B[Q;BkQ<C;Q=CKQ>C[Q?CkQ@D;QA
DKQBD[QCD`:hE5@02[QEEKQFE[QGEkQHF;QIFKQJF[QKFkQLG;QMGKQNGP:h
Gel02[QPH;QQHKQRH[QSHkQTI;QUIKQVI[QWIkQXJ;QYJ@:hJVX02kQ[JkQ/
K;Q]KKQ^K[Q_KkQ`L;QaLKQbL[QcLkQdM;QeM@02^7If00ZhMgNhN7RhNGVh
NWZhNg^hO7bhOGfhOWjhOgnhP802^86100ZhPX:hPh>hQ8BhQHFhQXJhQhNh
R8RhRHVhRXZhRh/2^8b<00ZhSHfhSXjhShnhT92hTI6hTY:hTi>hU9BhUIFh
UYH2^9NG00ZhV9RhVIVhVYZhVi^hW9bhWIfhWYjhWinhX:2hXJ42^::R00^h
Xj>hY:BhYJFhYZJhYjNhZ:RhZJVhZZZhZj^h[:bh[Jd00[R^[P09^:n_^;2`
^;6a^;:b^;>c^;Bd^;Fe^;Jf^;Ng01[<c<`@D_l03/c<c0AVIVHKc<c<00>>
SXiSHf=VIVH07_ooo`04IVIVooooc<c<oooo1Lc<c003IVIVc<c<c<c<00C<
c<`019VIVFIVI_ooooooobc<c<`016IVIXS0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hoooo02_<c<`01[T00;T10KT20[T30kT41;T51@:i1PH02kT7
1kT82;T92KT:2[T;2kT<3;T=3KT>3[T?3kT@4;TA4@02^A8B00bi4a>i51Bi
5AFi5QJi5aNi61Ri6AVi6QZi6a^i71bi7Afi7Qh2^AlO00^i822i8B6i8R:i
8b>i92Bi9BFi9RJi9bNi:2Ri:BVi:RX00[T[:`0;^B`/^Bd]^Bh^^Bl_^C0`
^C4a^C8b^C<c^C@d^CDe^CHf00:i=cL02kTh>;Ti>KTj>[Tk>kTl?;Tm?KTn
?[To?kU0@;U1@KU2@P02^D=300^iA4BiADFiATJiAdNiB4RiBDViBTZiBd^i
C4biCDfiCTh00[U?C`0<^E1@^E5A^E9B^E=C^EAD^EEE^EIF^EMG^EQH^EUI
^EYJ^E]K0[ULG00;^EeM^EiN^EmO^F1P^F5Q^F9R^F=S^FAT^FEU^FIV^FMW
00:iJ6P02kUYJKUZJ[U[JkU/K;U]KKU^K[U_KkU`L;UaLKUbL[UcL`02^GAd
00^iMGFiMWJiMgNiN7RiNGViNWZiNg^iO7biOGfiOWjiOgl00[V0P00<^H61
^H:2^H>3^HB4^HF5^HJ6^HN7^HR8^HV9^HZ:^H^;^Hb<0[V=S@0;^Hj>^Hn?
^I2@^I6A^I:B^I>C^IBD^IFE^IJF^ING^IRH00:iVIT02kVJV[VKVkVLW;VM
WKVNW[VOWkVPX;VQXKVRX[VSXkVTY002^JFU00^iYZJiYjNiZ:RiZJViZZZi
Zj^i[:bi[Jfi[Zji[jni/;000[Va/@07^K:b^K>c^KBd^KFe^KJf^KNg^KRh
01[<c<`@FOl0;Lc<c003SXj>Hf=SIVIV01koool016IVI_ooolc<c?ooo`c<
c<`019VIVFIVI_ooooooobc<c<`016IVIXS0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hoooo02_<c<`01kX00;X10KX20[X30kX41;X51KX61P02^PL7
00bj20Rj2@Vj2PZj2`^j30bj3@fj3Pjj3`nj412j4A6j4Q:j4a<2^Q@D00fj
5AFj5QJj5aNj61Rj6AVj6QZj6a^j71bj7Afj7Qjj7anj822j8B400[XR8P0<
^R<S^R@T^RDU^RHV^RLW^RPX^RTY^RXZ^R/[^R`/^Rd]^Rh^0[X_;`0<^S0`
^S4a^S8b^S<c^S@d^SDe^SHf^SLg^SPh^STi^SXj^S/k0[Xl?00=^Sdm^Shn
^Slo^T10^T51^T92^T=3^TA4^TE5^TI6^TM7^TQ8^TU900:jBTX03;Y;BkY<
C;Y=CKY>C[Y?CkY@D;YADKYBD[YCDkYDE;YEEKYFEP:jEeL03KYHF;YIFKYJ
F[YKFkYLG;YMGKYNG[YOGkYPH;YQHKYRH[YSHkYTI002^VEU00bjIVJjIfNj
J6RjJFVjJVZjJf^jK6bjKFfjKVjjKfnjL72jLG42^W9b00fjLg>jM7BjMGFj
MWJjMgNjN7RjNGVjNWZjNg^jO7bjOGfjOWjjOgl00[Z0P00<^X61^X:2^X>3
^XB4^XF5^XJ6^XN7^XR8^XV9^XZ:^X^;^Xb<0[Z=S@0=^Xj>^Xn?^Y2@^Y6A
^Y:B^Y>C^YBD^YFE^YJF^YNG^YRH^YVI^YZJ00:jVi/03;ZLW;ZMWKZNW[ZO
WkZPX;ZQXKZRX[ZSXkZTY;ZUYKZVY[ZWY`:jZ:P03;ZYZKZZZ[Z[ZkZ/[;Z]
[KZ^[[Z_[kZ`/;Za/KZb/[Zc/kZd]0:j]KD01;Zf][Zg]kZh^;Zi^A[<c<`@
HOl0;Lc<c003SXj>Hf=SIVIV01koool016IVI_ooolc<c?ooo`c<c<`019VI
VFIVI_ooooooobc<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo02_<c<`01k/00;/10K/20[/30k/41;/51K/61P02^`L700jk20Rk
2@Vk2PZk2`^k30bk3@fk3Pjk3`nk412k4A6k4Q:k4a>k51Bk5AD2^aHF00jk
5aNk61Rk6AVk6QZk6a^k71bk7Afk7Qjk7ank822k8B6k8R:k8b>k92@2^bDU
00jk9RJk9bNk:2Rk:BVk:RZk:b^k;2bk;Bfk;Rjk;bnk<32k<C6k<S:k<c<2
^c@d00jk=CFk=SJk=cNk>3Rk>CVk>SZk>c^k?3bk?Cfk?Sjk?cnk@42k@D6k
@T82^d=300jkA4BkADFkATJkAdNkB4RkBDVkBTZkBd^kC4bkCDfkCTjkCdnk
D52kDE42^e9B00jkDe>kE5BkEEFkEUJkEeNkF5RkFEVkFUZkFe^kG5bkGEfk
GUjkGenkH602^f5Q00jkHV:kHf>kI6BkIFFkIVJkIfNkJ6RkJFVkJVZkJf^k
K6bkKFfkKVjkKfl2^g1`00jkLG6kLW:kLg>kM7BkMGFkMWJkMgNkN7RkNGVk
NWZkNg^kO7bkOGfkOWh2^gmo00jkP82kPH6kPX:kPh>kQ8BkQHFkQXJkQhNk
R8RkRHVkRXZkRh^kS8bkSHd2^hj>00fkShnkT92kTI6kTY:kTi>kU9BkUIFk
UYJkUiNkV9RkVIVkVYZkVi/00[^LW00>^ifM^ijN^inO^j2P^j6Q^j:R^j>S
^jBT^jFU^jJV^jNW^jRX^jVY^jZZ0[^[Z`0>^jb/^jf]^jj^^jn_^k2`^k6a
^k:b^k>c^kBd^kFe^kJf^kNg^kRh^kVi0[^j^Q[<c<`@JOl0;Lc<c003SXj>
Hf=SIVIV01koool00lc<c?ooolc<c00=oooo00BIVIUVIVKoooooool/c<c<
00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<00Rm
002m0@6m0P:m0`>m10Bm1@Fm1PJm1`L2_@P8012m2@Vm2PZm2`^m30bm3@fm
3Pjm3`nm412m4A6m4Q:m4a>m51Bm5AFm5QJm5aNm61P2_ATI012m6QZm6a^m
71bm7Afm7Qjm7anm822m8B6m8R:m8b>m92Bm9BFm9RJm9bNm:2Rm:BT2_BXZ
00nm:b^m;2bm;Bfm;Rjm;bnm<32m<C6m<S:m<c>m=3Bm=CFm=SJm=cNm>3Rm
>CT00[dj>P0@_C/k_C`l_Cdm_Chn_Clo_D10_D51_D92_D=3_DA4_DE5_DI6
_DM7_DQ8_DU9_DY:0[e;B`0@_Da<_De=_Di>_Dm?_E1@_E5A_E9B_E=C_EAD
_EEE_EIF_EMG_EQH_EUI_EYJ_E]K0[eLG00@_EeM_EiN_EmO_F1P_F5Q_F9R
_F=S_FAT_FEU_FIV_FMW_FQX_FUY_FYZ_F][_Fa/0[e]K@0?_Fi^_Fm__G1`
_G5a_G9b_G=c_GAd_GEe_GIf_GMg_GQh_GUi_GYj_G]k_Gal00:mOGd04;en
O[eoOkf0P;f1PKf2P[f3Pkf4Q;f5QKf6Q[f7Qkf8R;f9RKf:R[f;Rkf<S;f=
S@:mSXh04;f?Skf@T;fATKfBT[fCTkfDU;fEUKfFU[fGUkfHV;fIVKfJV[fK
VkfLW;fMWKfNWP:mWil03kfPX;fQXKfRX[fSXkfTY;fUYKfVY[fWYkfXZ;fY
ZKfZZ[f[Zkf/[;f][Kf^[P02_Jn_00fm/;2m/K6m/[:m/k>m];Bm]KFm][Jm
]kNm^;Rm^KVm^[Zm^k^m_;`06/c<c11`o`0]c<c<00>>SXiSHf=VIVH07fIV
IQ3<c<`00fIVI_ooooooo`0/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`0[c<c<00Vn002n0@6n0P:n0`>n10Bn1@Fn1PJn1`Nn
20P00[h92@0B_PX:_P/;_P`<_Pd=_Ph>_Pl?_Q0@_Q4A_Q8B_Q<C_Q@D_QDE
_QHF_QLG_QPH_QTI_QXJ_Q/K0[hL700B_QdM_QhN_QlO_R0P_R4Q_R8R_R<S
_R@T_RDU_RHV_RLW_RPX_RTY_RXZ_R/[_R`/_Rd]_Rh^0[h_;`0B_S0`_S4a
_S8b_S<c_S@d_SDe_SHf_SLg_SPh_STi_SXj_S/k_S`l_Sdm_Shn_Slo_T10
_T510[i2@P0B_T=3_TA4_TE5_TI6_TM7_TQ8_TU9_TY:_T];_Ta<_Te=_Ti>
_Tm?_U1@_U5A_U9B_U=C_UAD0[iEE@0B_UIF_UMG_UQH_UUI_UYJ_U]K_UaL
_UeM_UiN_UmO_V1P_V5Q_V9R_V=S_VAT_VEU_VIV_VMW0[iXJ00B_VUY_VYZ
_V][_Va/_Ve]_Vi^_Vm__W1`_W5a_W9b_W=c_WAd_WEe_WIf_WMg_WQh_WUi
_WYj0[ikN`0B_Wal_Wem_Win_Wmo_X20_X61_X:2_X>3_XB4_XF5_XJ6_XN7
_XR8_XV9_XZ:_X^;_Xb<_Xf=0[j>SP0B_Xn?_Y2@_Y6A_Y:B_Y>C_YBD_YFE
_YJF_YNG_YRH_YVI_YZJ_Y^K_YbL_YfM_YjN_YnO_Z2P0[jQX@0B_Z:R_Z>S
_ZBT_ZFU_ZJV_ZNW_ZRX_ZVY_ZZZ_Z^[_Zb/_Zf]_Zj^_Zn__[2`_[6a_[:b
_[>c0[jd]009_[Fe_[Jf_[Ng_[Rh_[Vi_[Zj_[^k_[bl_[fm01[<c<`@N?l0
;Lc<c003SXj>Hf=SHf=S035SHf<00oooolc<c<c<c00Zc<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<00^o002o0@6o0P:o
0`>o10Bo1@Fo1PJo1`No20Ro2@Vo2PX00[l;2`0E_``<_`d=_`h>_`l?_a0@
_a4A_a8B_a<C_a@D_aDE_aHF_aLG_aPH_aTI_aXJ_a/K_a`L_adM_ahN_alO
_b0P00:o8B405KlR8[lS8klT9;lU9KlV9[lW9klX:;lY:KlZ:[l[:kl/;;l]
;Kl^;[l_;kl`<;la<Klb<[lc<kld=;le=Klf=P02_cLg01Bo>3Ro>CVo>SZo
>c^o?3bo?Cfo?Sjo?cno@42o@D6o@T:o@d>oA4BoADFoATJoAdNoB4RoBDVo
BTZoBd/2_da<01FoCDfoCTjoCdnoD52oDE6oDU:oDe>oE5BoEEFoEUJoEeNo
F5RoFEVoFUZoFe^oG5boGEfoGUjoGenoH62oHF400[mRHP0E_f=S_fAT_fEU
_fIV_fMW_fQX_fUY_fYZ_f][_fa/_fe]_fi^_fm__g1`_g5a_g9b_g=c_gAd
_gEe_gIf_gMg00:oN7P05KmiNKmjN[mkNkmlO;mmOKmnO[moOkn0P;n1PKn2
P[n3Pkn4Q;n5QKn6Q[n7Qkn8R;n9RKn:R[n;Rkn<S;n=S@02_hj>01FoShno
T92oTI6oTY:oTi>oU9BoUIFoUYJoUiNoV9RoVIVoVYZoVi^oW9boWIfoWYjo
WinoX:2oXJ6oXZ:oXj<00[nTY00E_jFU_jJV_jNW_jRX_jVY_jZZ_j^[_jb/
_jf]_jj^_jn__k2`_k6a_k:b_k>c_kBd_kFe_kJf_kNg_kRh_kVi00:o^[X0
1;nk^knl_;nm_Knn_Q[<c<`@P?l0;Lc<c3F>SXh/c<c<00AVIVJ8`;R8`;Q8
T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<00g100310@710P;10`?1
10C11@G11PK11`O120S12@W12P[12`_130`00/4=3@0I`@h>`@l?`A0@`A4A
`A8B`A<C`A@D`ADE`AHF`ALG`APH`ATI`AXJ`A/K`A`L`AdM`AhN`AlO`B0P
`B4Q`B8R`B<S`B@T`BDU`BHV00;19bL06<4X:<4Y:L4Z:/4[:l4/;<4];L4^
;/4_;l4`<<4a<L4b</4c<l4d=<4e=L4f=/4g=l4h><4i>L4j>/4k>l4l?<4m
?L4n?/4o?`;1@4006L51@L52@/53@l54A<55AL56A/57Al58B<59BL5:B/5;
Bl5<C<5=CL5>C/5?Cl5@D<5ADL5BD/5CDl5DE<5EEL5FE/5GEl5HF<5IF@02
`EYJ01W1Fe_1G5c1GEg1GUk1Geo1H631HF71HV;1Hf?1I6C1IFG1IVK1IfO1
J6S1JFW1JV[1Jf_1K6c1KFg1KVk1Kfo1L731LG71LW;1Lg<00/5dM00I`GEe
`GIf`GMg`GQh`GUi`GYj`G]k`Gal`Gem`Gin`Gmo`H20`H61`H:2`H>3`HB4
`HF5`HJ6`HN7`HR8`HV9`HZ:`H^;`Hb<`Hf=00;1SXh06<6?Sl6@T<6ATL6B
T/6CTl6DU<6EUL6FU/6GUl6HV<6IVL6JV/6KVl6LW<6MWL6NW/6OWl6PX<6Q
XL6RX/6SXl6TY<6UYL6VYP;1YjL06L6XZ<6YZL6ZZ/6[Zl6/[<6][L6^[/6_
[l6`/<6a/L6b//6c/l6d]<6e]L6f]/6g]l6h^<6i^L6j^/6k^l6l_<6m_L6n
_/6o_l70`00Jc<c<48Oo08k<c<`016IVIXS0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hoooo02_<c<`04<800<810L820/830l841<851L861/871l88
2<892L8:2/8;2l8<3<8=3L8>3/8?3`;241007/8A4L8B4/8C4l8D5<8E5L8F
5/8G5l8H6<8I6L8J6/8K6l8L7<8M7L8N7/8O7l8P8<8Q8L8R8/8S8l8T9<8U
9L8V9/8W9l8X:<8Y:L8Z:/8[:l8/;<8];L8^;P;2;bl07/8`<<8a<L8b</8c
<l8d=<8e=L8f=/8g=l8h><8i>L8j>/8k>l8l?<8m?L8n?/8o?l90@<91@L92
@/93@l94A<95AL96A/97Al98B<99BL9:B/9;Bl9<C<9=C@;2CTh07/9?Cl9@
D<9ADL9BD/9CDl9DE<9EEL9FE/9GEl9HF<9IFL9JF/9KFl9LG<9MGL9NG/9O
Gl9PH<9QHL9RH/9SHl9TI<9UIL9VI/9WIl9XJ<9YJL9ZJ/9[Jl9/K0;2KFd0
7l9^K/9_Kl9`L<9aLL9bL/9cLl9dM<9eML9fM/9gMl9hN<9iNL9jN/9kNl9l
O<9mOL9nO/9oOl:0P<:1PL:2P/:3Pl:4Q<:5QL:6Q/:7Ql:8R<:9RL::R/:;
Rl:<S002`Xf=01k2SXk2Sho2T932TI72TY;2Ti?2U9C2UIG2UYK2UiO2V9S2
VIW2VY[2Vi_2W9c2WIg2WYk2Wio2X:32XJ72XZ;2Xj?2Y:C2YJG2YZK2YjO2
Z:S2ZJW2ZZ[2Zj/2`Zb/01G2[Jg2[Zk2[jo2/;32/K72/[;2/k?2];C2]KG2
][K2]kO2^;S2^KW2^[[2^k_2_;c2_Kg2_[k2_ko2`<32`L406/c<c12?o`2>
c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<
01C300330@730P;30`?310C31@G31PK31`O320S32@W32P[32`_330c33@g3
3Pk33`o341334A734Q;34a<2`a@D02K35AG35QK35aO361S36AW36Q[36a_3
71c37Ag37Qk37ao382338B738R;38b?392C39BG39RK39bO3:2S3:BW3:R[3
:b_3;2c3;Bg3;Rk3;bo3<333<C73<S;3<c?3=3C3=CG3=SK3=cO3>3S3>CW3
>SX2`c/k02O3?3c3?Cg3?Sk3?co3@433@D73@T;3@d?3A4C3ADG3ATK3AdO3
B4S3BDW3BT[3Bd_3C4c3CDg3CTk3Cdo3D533DE73DU;3De?3E5C3EEG3EUK3
EeO3F5S3FEW3FU[3Fe_3G5c3GEg3GUk3Geo3H633HF73HV800/=SH`0W`fAT
`fEU`fIV`fMW`fQX`fUY`fYZ`f][`fa/`fe]`fi^`fm_`g1``g5a`g9b`g=c
`gAd`gEe`gIf`gMg`gQh`gUi`gYj`g]k`gal`gem`gin`gmo`h20`h61`h:2
`h>3`hB4`hF5`hJ6`hN7`hR8`hV9`hZ:00;3Rh/09/><S<>=SL>>S/>?Sl>@
T<>ATL>BT/>CTl>DU<>EUL>FU/>GUl>HV<>IVL>JV/>KVl>LW<>MWL>NW/>O
Wl>PX<>QXL>RX/>SXl>TY<>UYL>VY/>WYl>XZ<>YZL>ZZ/>[Zl>/[<>][L>^
[/>_[l>`/<>a/@;3/[804<>c/l>d]<>e]L>f]/>g]l>h^<>i^L>j^/>k^l>l
_<>m_L>n_/>o_l?0`<?1`L?2`Q[<c<`@U_l0;Lc<c003SXj>oooooooo03;o
ool/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[
c<c<01_400340@740P;40`?410C41@G41PK41`O420S42@W42P[42`_430c4
3@g43Pk43`o441344A744Q;44a?451C45AG45QK45aO461S46AW46QX00/@K
6`0ea1`La1dMa1hNa1lOa20Pa24Qa28Ra2<Sa2@Ta2DUa2HVa2LWa2PXa2TY
a2XZa2/[a2`/a2d]a2h^a2l_a30`a34aa38ba3<ca3@da3Dea3Hfa3Lga3Ph
a3Tia3Xja3/ka3`la3dma3hna3loa410a451a492a4=3a4A4a4E5a4I6a4M7
a4Q8a4U9a4Y:a4];a4a<a4e=a4i>a4m?a51@00;4DE40=<ABD/ACDlADE<AE
ELAFE/AGElAHF<AIFLAJF/AKFlALG<AMGLANG/AOGlAPH<AQHLARH/ASHlAT
I<AUILAVI/AWIlAXJ<AYJLAZJ/A[JlA/K<A]KLA^K/A_KlA`L<AaLLAbL/Ac
LlAdM<AeMLAfM/AgMlAhN<AiNLAjN/AkNlAlO<AmOLAnO/AoOlB0P<B1PLB2
P/B3PlB4Q<B5Q@;4QXH0=LB7QlB8R<B9RLB:R/B;RlB<S<B=SLB>S/B?SlB@
T<BATLBBT/BCTlBDU<BEULBFU/BGUlBHV<BIVLBJV/BKVlBLW<BMWLBNW/BO
WlBPX<BQXLBRX/BSXlBTY<BUYLBVY/BWYlBXZ<BYZLBZZ/B[ZlB/[<B][LB^
[/B_[lB`/<Ba/LBb//Bc/lBd]<Be]LBf]/Bg]lBh^<Bi^LBj^/Bk^`02a;bl
00O4_Kg4_[k4_ko4`<34`L74`/;4`l<06/c<c12No`0]c<c<00>>SXiSHf?o
ool0<_ooobc<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2h
oooo02_<c<`0:/H00<H10LH20/H30lH41<H51LH61/H71lH82<H92LH:2/H;
2lH<3<H=3LH>3/H?3lH@4<HA4LHB4/HC4lHD5<HE5LHF5/HG5lHH6<HI6LHJ
6/HK6lHL7<HM7LHN7/HO7lHP8<HQ8LHR8/HS8lHT9<HU9LHV9/HW9lHX:<HY
:@;6:RX0D/H[:lH/;<H];LH^;/H_;lH`<<Ha<LHb</Hc<lHd=<He=LHf=/Hg
=lHh><Hi>LHj>/Hk>lHl?<Hm?LHn?/Ho?lI0@<I1@LI2@/I3@lI4A<I5ALI6
A/I7AlI8B<I9BLI:B/I;BlI<C<I=CLI>C/I?ClI@D<IADLIBD/ICDlIDE<IE
ELIFE/IGElIHF<IIFLIJF/IKFlILG<IMGLING/IOGlIPH<IQHLIRH/ISHlIT
I<IUILIVI/IWIlIXJ<IYJLIZJ/I[JlI/K<I]KLI^K/I_KlI`L<IaLLIbL/Ic
LlIdM<IeMLIfM/IgMlIhN<IiNLIjN/IkNlIlO0;6OGd0B<InO/IoOlJ0P<J1
PLJ2P/J3PlJ4Q<J5QLJ6Q/J7QlJ8R<J9RLJ:R/J;RlJ<S<J=SLJ>S/J?SlJ@
T<JATLJBT/JCTlJDU<JEULJFU/JGUlJHV<JIVLJJV/JKVlJLW<JMWLJNW/JO
WlJPX<JQXLJRX/JSXlJTY<JUYLJVY/JWYlJXZ<JYZLJZZ/J[ZlJ/[<J][LJ^
[/J_[lJ`/<Ja/LJb//Jc/lJd]<Je]LJf]/Jg]lJh^<Ji^LJj^/Jk^lJl_<Jm
_LJn_/Jo_lK0`<K1`LK2`/K3`lK4a<K5aA[<c<`@Y_l0;Lc<c003SXj>Hf=S
c<c<023oool@IVIV0_ooobc<c<`016IVIXS0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hoooo02_<c<`0F/L00<L10LL20/L30lL41<L51LL61/L71lL8
2<L92LL:2/L;2lL<3<L=3LL>3/L?3lL@4<LA4LLB4/LC4lLD5<LE5LLF5/LG
5lLH6<LI6LLJ6/LK6lLL7<LM7LLN7/LO7lLP8<LQ8LLR8/LS8lLT9<LU9LLV
9/LW9lLX:<LY:LLZ:/L[:lL/;<L];LL^;/L_;lL`<<La<LLb</Lc<lLd=<Le
=LLf=/Lg=lLh><Li>LLj>/Lk>lLl?<Lm?LLn?/Lo?lM0@<M1@LM2@/M3@lM4
A<M5ALM6A/M7AlM8B<M9BLM:B/M;BlM<C<M=CLM>C/M?ClM@D<MADLMBD/MC
DlMDE<MEELMFE/MGElMHF<MIF@;7FUX0K<MKFlMLG<MMGLMNG/MOGlMPH<MQ
HLMRH/MSHlMTI<MUILMVI/MWIlMXJ<MYJLMZJ/M[JlM/K<M]KLM^K/M_KlM`
L<MaLLMbL/McLlMdM<MeMLMfM/MgMlMhN<MiNLMjN/MkNlMlO<MmOLMnO/Mo
OlN0P<N1PLN2P/N3PlN4Q<N5QLN6Q/N7QlN8R<N9RLN:R/N;RlN<S<N=SLN>
S/N?SlN@T<NATLNBT/NCTlNDU<NEULNFU/NGUlNHV<NIVLNJV/NKVlNLW<NM
WLNNW/NOWlNPX<NQXLNRX/NSXlNTY<NUYLNVY/NWYlNXZ<NYZLNZZ/N[ZlN/
[<N][LN^[/N_[lN`/<Na/LNb//Nc/lNd]<Ne]LNf]/Ng]lNh^<Ni^LNj^/Nk
^lNl_<Nm_LNn_/No_lO0`<O1`LO2`/O3`lO4a<O5aLO6aQ[<c<`@[Ol0;Lc<
c004SXj>Hf=SIVIVc<c<7VIVIP03ooooc<c<VIVI00fIVIT00fIVI_oooooo
o`0/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[
c<c<0<S800380@780P;80`?810C81@G81PK81`O820S82@W82P[82`_830c8
3@g83Pk83`o841384A784Q;84a?851C85AG85QK85aO861S86AW86Q[86a_8
71c87Ag87Qk87ao882388B788R;88b?892C89BG89RK89bO8:2S8:BW8:R[8
:b_8;2c8;Bg8;Rk8;bo8<338<C78<S;8<c?8=3C8=CG8=SK8=cO8>3S8>CW8
>S[8>c_8?3c8?Cg8?Sk8?co8@438@D78@T;8@d?8A4C8ADG8ATK8AdO8B4S8
BDW8BT[8Bd_8C4c8CDg8CTk8Cdo8D538DE78DU;8De?8E5C8EEG8EUK8EeO8
F5S8FEW8FU[8Fe_8G5c8GEg8GUk8Geo8H638HF78HV;8Hf?8I6C8IFG8IVK8
IfO8J6S8JFW8JV[8Jf_8K6c8KFg8KVk8Kfo8L738LG78LW;8Lg?8M7C8MGG8
MWK8MgO8N7S8NGW8NW[8Ng_8O7c8OGg8OWk8Ogo8P838PH78PX;8Ph?8Q8C8
QHG8QXK8QhO8R8S8RHW8RX[8Rh_8S8c8SHg8SXk8Sho8T938TI78TY;8Ti?8
U9C8UIG8UYK8UiO8V9S8VIW8VY[8Vi_8W9c8WIg8WYk8Wio8X:38XJ78XZ;8
Xj?8Y:C8YJG8YZK8YjO8Z:S8ZJW8ZZ[8Zj_8[:c8[Jg8[Zk8[jo8/;38/K78
/[;8/k?8];C8]KG8][K8]kO8^;S8^KW8^[[8^k_8_;c8_Kg8_[k8_ko8`<38
`L78`/;8`l?8a<C8aLG8a/K8alLJc<c<4;Go02g<c<`00hj>SV=SHfIVIP0N
oooo00AVIVKoooo<c<coool<c<c<00BIVIUVIVKoooooool/c<c<00AVIVJ8
`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0<S900390@79
0P;90`?910C91@G91PK91`O920S92@W92P[92`_930c93@g93Pk93`o94139
4A794Q;94a?951C95AG95QK95aO961S96AW96Q[96a_971c97Ag97Qk97ao9
82398B798R;98b?992C99BG99RK99bO9:2S9:BW9:R[9:b_9;2c9;Bg9;Rk9
;bo9<339<C79<S;9<c?9=3C9=CG9=SK9=cO9>3S9>CW9>S[9>c_9?3c9?Cg9
?Sk9?co9@439@D79@T;9@d?9A4C9ATK9AdO9B4S9BDW9BT[9Bd_9C4c9CDg9
CTk9Cdo9D539DE79DU;9De?9E5C9EEG9EUK9EeO9F5S9FEW9FU[9Fe_9G5c9
GEg9GUk9Geo9H639HF79HV;9Hf?9I6C9IFG9IVK9IfO9J6S9JFW9JV[9Jf_9
K6c9KFg9KVk9Kfo9L739LG79LW;9Lg?9M7C9MGG9MWK9MgO9N7S9NGW9NW[9
Ng_9O7c9OGg9OWk9Ogo9P839PH79PX;9Ph?9Q8C9QHG9QXK9QhO9R8S9RHW9
RX[9Rh_9S8c9SHg9SXk9Sho9T939TI79TY;9Ti?9U9C9UIG9UYK9UiO9V9S9
VIW9VY[9Vi_9W9c9WIg9WYk9Wio9X:39XJ79XZ;9Xj?9Y:C9YJG9YZK9YjO9
Z:S9ZJW9ZZ[9Zj_9[:c9[Jg9[Zk9[jo9/;39/K79/[;9/k?9];C9]KG9][K9
]kO9^;S9^KW9^[[9^k_9_;c9_Kg9_[k9_ko9`<39`L79`/;9`l?9a<C9aLG9
a/K9alO9b<PJc<c<4;go00k<c<`4oooo6lc<c003SXj>Hf=SIVIV01koool0
16IVI_ooolc<c?ooo`c<c<`019VIVFIVI_ooooooobc<c<`016IVIXS0^8S0
^4R@R04000000005R<2hb>3HR<2hR<2hoooo02_<c<`0b</00</10L/20//3
0l/41</51L/61//71l/82</92L/:2//;2l/<3</=3L/>3//?3l/@4</A4L/B
4//C4l/D5</E5L/F5//G5l/H6</I6L/J6//K6l/L7</M7L/N7//O7l/P8</Q
8L/R8//S8l/T9</V9//W9l/X:</Y:L/Z://[:l//;</];L/^;//_;l/`<</a
<L/b<//c<l/d=</e=L/f=//g=l/h></i>L/j>//k>l/l?</m?L/n?//o?l]0
@<]1@L]2@/]3@l]4A<]5AL]6A/]7Al]8B<]9BL]:B/];Bl]<C<]=CL]>C/]?
Cl]@D<]ADL]BD/]CDl]DE<]EEL]FE/]GEl]HF<]IFL]JF/]KFl]LG<]MGL]N
G/]OGl]PH<]QHL]RH/]SHl]TI<]UIL]VI/]WIl]XJ<]YJL]ZJ/][Jl]/K<]]
KL]^K/]_Kl]aLL]bL/]cLl]dM<]eML]fM/]gMl]hN<]iNL]jN/]kNl]lO<]m
OL]nO/]oOl^0P<^1PL^2P/^3Pl^4Q<^5QL^6Q/^7Ql^8R<^9RL^:R/^;Rl^<
S<^=SL^>S/^?Sl^@T<^ATL^BT/^CTl^DU<^EUL^FU/^GUl^HV<^IVL^JV/^K
Vl^LW<^MWL^NW/^OWl^PX<^QXL^RX/^SXl^TY<^UYL^VY/^WYl^XZ<^YZL^Z
Z/^[Zl^/[<^][L^^[/^_[l^`/<^a/L^b//^c/l^d]<^e]L^f]/^g]l^h^<^i
^L^k^l^l_<^m_L^n_/^o_l_0`<_1`L_2`/_3`l_4a<_5aL_6a/_7al_8b<_9
bL_:bQ[<c<`@a?l03<c<c0;oool4IVIV0_oooaW<c<`00hj>SV=SHfIVIP0N
oooo00AVIVKoooo<c<coool5c<c<00=VIVK<c<c<c<`01<c<c004VIVIIVIV
oooooooo;<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;So
ool0:lc<c038c000c041c082c0<3c0@4c0D5c0H6c0L7c0P8c0T9c0X:c0/;
c0`<c0d=c0h>c0l?c10@c14Ac18Bc1<Cc1@Dc1DEc1HFc1LGc1PHc1XJc1/K
c1`Lc1dMc1hNc1lOc20Pc24Qc28Rc2<Sc2@Tc2DUc2HVc2LWc2PXc2TYc2XZ
c2/[c2`/c2d]c2h^c2l_c30`c34ac38bc3<cc3@dc3Dec3Hfc3Lgc3Phc3Ti
c3Xjc3/kc3`lc3dmc3hnc3loc410c451c492c4=3c4A4c4E5c4I6c4M7c4Q8
c4U9c4Y:c4];c4e=c4i>c4m?c51@c55Ac59Bc5=Cc5ADc5EEc5IFc5MGc5QH
c5UIc5YJc5]Kc5aLc5eMc5iNc5mOc61Pc65Qc69Rc6=Sc6ATc6EUc6IVc6MW
c6QXc6UYc6YZc6][c6a/c6e]c6i^c6m_c71`c75ac79bc7=cc7Adc7Eec7If
c7Mgc7Qhc7Uic7Yjc7]kc7alc7emc7inc820c861c8:2c8>3c8B4c8F5c8J6
c8N7c8R8c8V9c8Z:c8^;c8b<c8f=c8j>c8n?c92@c96Ac9:Bc9>Cc9BDc9FE
c9JFc9NGc9RHc9VIc9ZJc9^Kc9bLc9fMc9jNc9nOc:2Pc:6Qc::Rc:>Sc:BT
c:FUc:JVc:NWc:RXc:VYc:ZZc:^[c:b/c:f]c:j^c:n_c;2`c;6ac;>cc;Bd
c;Fec;Jfc;Ngc;Rhc;Vic;Zjc;^kc;blc;fmc;jnc;noc<30c<71c<;2c<?3
c<C4c<G5c<K6c<O7c<S8c<W9c<[:c<_;6/c<c13<o`0<c<c<0VIVIPC<c<`2
IVIV00?oooo<c<c<c<`01Lc<c0D0000<c<c<00>>SXiSHf=VIVH04Oooo`<0
0004oooo0`0000?oool016IVI_ooolc<c?ooo`C<c<`3IVIV1Lc<c004VIVI
IVIVoooooooo;<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8
`;Soool0:lc<c038c@00c@41c@82c@<3c@@4c@D5c@H6c@L7c@P8c@T9c@X:
c@/;c@`<c@d=c@h>c@l?cA0@cA4AcA8BcA@DcADEcAHFcALGcAPHcATIcAXJ
cA/KcA`LcAdMcAhNcAlOcB0PcB4QcB8RcB<ScB@TcBDUcBHVcBLWcBPXcBTY
cBXZcB/[cB`/cBd]cBh^cBl_cC0`cC4acC8bcC<ccC@dcCDecCHfcCLgcCPh
cCTicC/kcC`lcCdmcChncClocD10cD51cD92cD=3cDA4cDE5cDI6cDM7cDQ8
cDU9cDY:cD];cDa<cDe=cDi>cDm?cE1@cE5AcE9BcE=CcEADcEEEcEIFcEMG
cEQHcEUIcEYJcE]KcEaLcEeMcEiNcEmOcF1PcF9RcF=ScFATcFEUcFIVcFMW
cFQXcFUYcFYZcF][cFa/cFe]cFi^cFm_cG1`cG5acG9bcG=ccGAdcGEecGIf
cGMgcGQhcGUicGYjcG]kcGalcGemcGincGmocH20cH61cH:2cH>3cHB4cHF5
cHJ6cHN7cHV9cHZ:cH^;cHb<cHf=cHj>cHn?cI2@cI6AcI:BcI>CcIBDcIFE
cIJFcINGcIRHcIVIcIZJcI^KcIbLcIfMcIjNcInOcJ2PcJ6QcJ:RcJ>ScJBT
cJFUcJJVcJNWcJRXcJVYcJZZcJ^[cJb/cJf]cJj^cK2`cK6acK:bcK>ccKBd
cKFecKJfcKNgcKRhcKVicKZjcK^kcKblcKfmcKjncKnocL30cL71cL;2cL?3
cLC4cLG5cLK6cLO7cLS8cLW9cL[:cL_;cLc<6/c<c13Do`0;c<c<00=VIVKo
ooo<c<`01/c<c003IVIVooooc<c<00C<c<`200000lc<c080000;c<c<00>>
SXiSHf=VIVH04?ooo`050000oooooooooooo000000;oool01@000?oooooo
ooooo`000002oooo00AVIVKoooo<c<coool<c<c<00BIVIUVIVKoooooool/
c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<
0<S?003?0@7?0P;?0`??10C?1@G?1PK?1`O?20S?2@W?2P[?2`_?30c?3@g?
3Pk?3`o?4A7?4Q;?4a??51C?5AG?5QK?5aO?61S?6AW?6Q[?6a_?71c?7Ag?
7Qk?7ao?823?8B7?8R;?8b??92C?9BG?9RK?9bO?:2S?:BW?:R[?:b_?;2c?
;Bg?;Rk?<33?<C7?<S;?<c??=3C?=CG?=SK?=cO?>3S?>CW?>S[?>c_??3c?
?Cg??Sk??co?@43?@D7?@T;?@d??A4C?ADG?ATK?AdO?B4S?BDW?BT[?Bd_?
C4c?CDg?CTk?D53?DE7?DU;?De??E5C?EEG?EUK?EeO?F5S?FEW?FU[?Fe_?
G5c?GEg?GUk?Geo?H63?HF7?HV;?Hf??I6C?IFG?IVK?IfO?J6S?JFW?JV[?
Jf_?K6c?KFg?Kfo?L73?LG7?LW;?Lg??M7C?MGG?MWK?MgO?N7S?NGW?NW[?
Ng_?O7c?OGg?OWk?Ogo?P83?PH7?PX;?Ph??Q8C?QHG?QXK?QhO?R8S?RHW?
RX[?Rh_?S8c?SHg?Sho?T93?TI7?TY;?Ti??U9C?UIG?UYK?UiO?V9S?VIW?
VY[?Vi_?W9c?WIg?WYk?Wio?X:3?XJ7?XZ;?Xj??Y:C?YJG?YZK?YjO?Z:S?
ZJW?ZZ[?Zj_?[:c?[Zk?[jo?/;3?/K7?/[;?/k??];C?]KG?][K?]kO?^;S?
^KW?^[[?^k_?_;c?_Kg?_[k?_ko?`<3?`L7?`/;?`l??a<C?aLG?a/K?alO?
b<S?bLW?b/[?bl_?c<c?c/hJc<c<4=_o00_<c<`00fIVI_ooolc<c006c<c<
00=VIVKoooo<c<`02Lc<c080000;c<c<00>>SXiSHf=VIVH05?ooo`040000
oooooooo00000oooo`070000ooooooooIVIVooooc<c<oooo00c<c<`019VI
VFIVI_ooooooobc<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo02_<c<`0b=000=010M020]030m041=051M061]071m082=092M0:
2]0;2m0<3=0>3]0?3m0@4=0A4M0B4]0C4m0D5=0E5M0F5]0G5m0H6=0I6M0J
6]0K6m0L7=0M7M0N7]0O7m0P8=0Q8M0R8]0S8m0T9=0U9M0V9]0W9m0Y:M0Z
:]0[:m0/;=0];M0^;]0_;m0`<=0a<M0b<]0c<m0d==0e=M0f=]0g=m0h>=0i
>M0j>]0k>m0l?=0m?M0n?]0o?m10@=11@M13@m14A=15AM16A]17Am18B=19
BM1:B]1;Bm1<C=1=CM1>C]1?Cm1@D=1ADM1BD]1CDm1DE=1EEM1FE]1GEm1H
F=1IFM1JF]1KFm1LG=1NG]1OGm1PH=1QHM1RH]1SHm1TI=1UIM1VI]1WIm1X
J=1YJM1ZJ]1[Jm1/K=1]KM1^K]1_Km1`L=1aLM1bL]1cLm1dM=1eMM1fM]1g
Mm1iNM1jN]1kNm1lO=1mOM1nO]1oOm20P=21PM22P]23Pm24Q=25QM26Q]27
Qm28R=29RM2:R]2;Rm2<S=2=SM2>S]2?Sm2@T=2ATM2CTm2DU=2EUM2FU]2G
Um2HV=2IVM2JV]2KVm2LW=2MWM2NW]2OWm2PX=2QXM2RX]2SXm2TY=2UYM2V
Y]2WYm2XZ=2YZM2ZZ]2[Zm2/[=2^[]2_[m2`/=2a/M2b/]2c/m2d]=2e]M2f
]]2g]m2h^=2i^M2j^]2k^m2l_=2m_M2n_]2o_m30`=31`M32`]33`m34a=35
aM36a]38b=39bM3:b]3;bm3<c=3=cM3>c]3?ca[<c<`@hol02/c<c003IVIV
ooooc<c<00S<c<`00fIVI_ooolc<c006c<c<100000_<c<`00hj>SV=SHfIV
IP0Aoooo0P000005oooo0000oooooooo000000?oool01P000?ooooooofIV
I_ooolc<c0goool019VIVFIVI_ooooooobc<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo02_<c<`0b=400=410M420]430m441=45
1M461]471m482=492M4:2]4<3=4=3M4>3]4?3m4@4=4A4M4B4]4C4m4D5=4E
5M4F5]4G5m4H6=4I6M4J6]4K6m4L7=4M7M4N7]4O7m4P8=4Q8M4S8m4T9=4U
9M4V9]4W9m4X:=4Y:M4Z:]4[:m4/;=4];M4^;]4_;m4`<=4a<M4b<]4c<m4d
==4e=M4f=]4g=m4h>=4j>]4k>m4l?=4m?M4n?]4o?m50@=51@M52@]53@m54
A=55AM56A]57Am58B=59BM5:B]5;Bm5<C=5=CM5>C]5?Cm5ADM5BD]5CDm5D
E=5EEM5FE]5GEm5HF=5IFM5JF]5KFm5LG=5MGM5NG]5OGm5PH=5QHM5RH]5S
Hm5TI=5UIM5VI]5XJ=5YJM5ZJ]5[Jm5/K=5]KM5^K]5_Km5`L=5aLM5bL]5c
Lm5dM=5eMM5fM]5gMm5hN=5iNM5jN]5kNm5lO=5mOM5oOm60P=61PM62P]63
Pm64Q=65QM66Q]67Qm68R=69RM6:R]6;Rm6<S=6=SM6>S]6?Sm6@T=6ATM6B
T]6CTm6DU=6FU]6GUm6HV=6IVM6JV]6KVm6LW=6MWM6NW]6OWm6PX=6QXM6R
X]6SXm6TY=6UYM6VY]6WYm6XZ=6YZM6ZZ]6[Zm6][M6^[]6_[m6`/=6a/M6b
/]6c/m6d]=6e]M6f]]6g]m6h^=6i^M6j^]6k^m6l_=6m_M6n_]6o_m70`=71
`M72`]74a=75aM76a]77am78b=79bM7:b]7;bm7<c=7=cM7>c]7?cm7@d1[<
c<`@jol02/c<c003IVIVooooc<c<00S<c<`00fIVI_ooolc<c004c<c<1@00
00c<c<`00hj>SV=SHfIVIP0@oooo00<0003oooooool00P0000;oool01@00
0?ooooooooooo`000002oooo00=VIVKoooo<c<`03/c<c003IVIVoooooooo
02c<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo02_<
c<`0b=800=810M820]830m841=851M861]871m882=892M8;2m8<3=8=3M8>
3]8?3m8@4=8A4M8B4]8C4m8D5=8E5M8F5]8G5m8H6=8I6M8J6]8K6m8L7=8M
7M8O7m8P8=8Q8M8R8]8S8m8T9=8U9M8V9]8W9m8X:=8Y:M8Z:]8[:m8/;=8]
;M8^;]8_;m8`<=8a<M8b<]8d==8e=M8f=]8g=m8h>=8i>M8j>]8k>m8l?=8m
?M8n?]8o?m90@=91@M92@]93@m94A=95AM96A]98B=99BM9:B]9;Bm9<C=9=
CM9>C]9?Cm9@D=9ADM9BD]9CDm9DE=9EEM9FE]9GEm9HF=9IFM9JF]9LG=9M
GM9NG]9OGm9PH=9QHM9RH]9SHm9TI=9UIM9VI]9WIm9XJ=9YJM9ZJ]9[Jm9/
K=9]KM9^K]9_Km9aLM9bL]9cLm9dM=9eMM9fM]9gMm9hN=9iNM9jN]9kNm9l
O=9mOM9nO]9oOm:0P=:1PM:2P]:3Pm:5QM:6Q]:7Qm:8R=:9RM::R]:;Rm:<
S=:=SM:>S]:?Sm:@T=:ATM:BT]:CTm:DU=:EUM:FU]:GUm:IVM:JV]:KVm:L
W=:MWM:NW]:OWm:PX=:QXM:RX]:SXm:TY=:UYM:VY]:WYm:XZ=:YZM:ZZ]:[
Zm:][M:^[]:_[m:`/=:a/M:b/]:c/m:d]=:e]M:f]]:g]m:h^=:i^M:j^]:k
^m:l_=:m_M:n_]:o_m;0`=;2`];3`m;4a=;5aM;6a];7am;8b=;9bM;:b];;
bm;<c=;=cM;>c];?cm;@d=;AdA[<c<`@l_l02/c<c003IVIVooooc<c<00S<
c<`00fIVI_ooolc<c003c<c<100000k<c<`00hj>SV=SHfIVIP0@oooo00D0
003oooooooooool000000_ooo`050000oooooooooooo000000;oool00fIV
I_ooofIVIP0?IVIV0_ooobc<c<`016IVIXS0^8S0^4R@R04000000005R<2h
b>3HR<2hR<2hoooo02_<c<`0b=@00=@10M@20]@30m@41=@51M@61]@71m@8
2=@:2]@;2m@<3=@=3M@>3]@?3m@@4=@A4M@B4]@C4m@D5=@E5M@F5]@G5m@H
6=@I6M@J6]@L7=@M7M@N7]@O7m@P8=@Q8M@R8]@S8m@T9=@U9M@V9]@W9m@X
:=@Y:M@Z:]@[:m@/;=@^;]@_;m@`<=@a<M@b<]@c<m@d==@e=M@f=]@g=m@h
>=@i>M@j>]@k>m@l?=@m?M@n?]@o?mA1@MA2@]A3@mA4A=A5AMA6A]A7AmA8
B=A9BMA:B]A;BmA<C=A=CMA>C]A?CmA@D=AADMACDmADE=AEEMAFE]AGEmAH
F=AIFMAJF]AKFmALG=AMGMANG]AOGmAPH=AQHMARH]ASHmAUIMAVI]AWImAX
J=AYJMAZJ]A[JmA/K=A]KMA^K]A_KmA`L=AaLMAbL]AcLmAdM=AeMMAgMmAh
N=AiNMAjN]AkNmAlO=AmOMAnO]AoOmB0P=B1PMB2P]B3PmB4Q=B5QMB6Q]B7
QmB9RMB:R]B;RmB<S=B=SMB>S]B?SmB@T=BATMBBT]BCTmBDU=BEUMBFU]BG
UmBHV=BIVMBKVmBLW=BMWMBNW]BOWmBPX=BQXMBRX]BSXmBTY=BUYMBVY]BW
YmBXZ=BYZMBZZ]B[ZmB/[=B^[]B_[mB`/=Ba/MBb/]Bc/mBd]=Be]MBf]]Bg
]mBh^=Bi^MBj^]Bk^mBl_=Bm_MBn_]C0`=C1`MC2`]C3`mC4a=C5aMC6a]C7
amC8b=C9bMC:b]C;bmC<c=C=cMC>c]C?cmC@d=CBd]CCda[<c<`@n_l02/c<
c003IVIVooooc<c<00S<c<`00fIVI_ooolc<c003c<c<0P00013<c<`00hj>
SV=SHfIVIP0@oooo00D0003oooooooooool000000_ooo`050000oooooooo
oooo000000;oool00fIVI_ooolc<c00>VIVI00=VIVKoooooool0;<c<c004
IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c038e@00
e@41e@82e@<3e@@4e@D5e@H6e@L7e@T9e@X:e@/;e@`<e@d=e@h>e@l?eA0@
eA4AeA8BeA<CeA@DeADEeAHFeALGeAPHeAXJeA/KeA`LeAdMeAhNeAlOeB0P
eB4QeB8ReB<SeB@TeBDUeBHVeBLWeBPXeBXZeB/[eB`/eBd]eBh^eBl_eC0`
eC4aeC8beC<ceC@deCDeeCHfeCLgeCPheCTieC/keC`leCdmeChneCloeD10
eD51eD92eD=3eDA4eDE5eDI6eDM7eDQ8eDU9eD];eDa<eDe=eDi>eDm?eE1@
eE5AeE9BeE=CeEADeEEEeEIFeEMGeEQHeEUIeEYJeEaLeEeMeEiNeEmOeF1P
eF5QeF9ReF=SeFATeFEUeFIVeFMWeFQXeFUYeFYZeFa/eFe]eFi^eFm_eG1`
eG5aeG9beG=ceGAdeGEeeGIfeGMgeGQheGUieGYjeG]keGemeGineGmoeH20
eH61eH:2eH>3eHB4eHF5eHJ6eHN7eHR8eHV9eHZ:eH^;eHf=eHj>eHn?eI2@
eI6AeI:BeI>CeIBDeIFEeIJFeINGeIRHeIVIeIZJeI^KeIbLeIjNeInOeJ2P
eJ6QeJ:ReJ>SeJBTeJFUeJJVeJNWeJRXeJVYeJZZeJ^[eJb/eJj^eJn_eK2`
eK6aeK:beK>ceKBdeKFeeKJfeKNgeKRheKVieKZjeK^keKbleKjneKnoeL30
eL71eL;2eL?3eLC4eLG5eLK6eLO7eLS8eLW9eL[:eL_;eLc<eLg=eLo?eM3@
eM7AeM;BeM?CeMCD6/c<c13oo00;c<c<00=VIVKoooo<c<`01/c<c003IVIV
ooooc<c<00C<c<`200000lc<c080000;c<c<00>>SXiSHf=VIVH04?ooo`05
0000oooooooooooo000000;oool01@000?ooooooooooo`000002oooo00AV
IVKoooo<c<coool<c<c<00BIVIUVIVKoooooool/c<c<00AVIVJ8`;R8`;Q8
T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0<SF003F0@7F0P;F0`?F
10CF1@GF1PKF1`OF2@WF2P[F2`_F30cF3@gF3PkF3`oF413F4A7F4Q;F4a?F
51CF5AGF5QKF61SF6AWF6Q[F6a_F71cF7AgF7QkF7aoF823F8B7F8R;F8b?F
92CF9BGF9bOF:2SF:BWF:R[F:b_F;2cF;BgF;RkF;boF<33F<C7F<S;F<c?F
=3CF=SKF=cOF>3SF>CWF>S[F>c_F?3cF?CgF?SkF?coF@43F@D7F@T;F@d?F
ADGFATKFAdOFB4SFBDWFBT[FBd_FC4cFCDgFCTkFCdoFD53FDE7FDU;FE5CF
EEGFEUKFEeOFF5SFFEWFFU[FFe_FG5cFGEgFGUkFGeoFH63FHF7FHf?FI6CF
IFGFIVKFIfOFJ6SFJFWFJV[FJf_FK6cFKFgFKVkFKfoFL73FLW;FLg?FM7CF
MGGFMWKFMgOFN7SFNGWFNW[FNg_FO7cFOGgFOWkFOgoFPH7FPX;FPh?FQ8CF
QHGFQXKFQhOFR8SFRHWFRX[FRh_FS8cFSHgFSXkFT93FTI7FTY;FTi?FU9CF
UIGFUYKFUiOFV9SFVIWFVY[FVi_FW9cFWIgFWioFX:3FXJ7FXZ;FXj?FY:CF
YJGFYZKFYjOFZ:SFZJWFZZ[FZj_F[:cF[ZkF[joF/;3F/K7F/[;F/k?F];CF
]KGF][KF]kOF^;SF^KWF^[[F^k_F_;cF_[kF_koF`<3F`L7F`/;F`l?Fa<CF
aLGFa/KFalOFb<SFbLWFb/[Fbl_FcLgFc/kFcloFd=3FdM7Fd];Fdm?Fe=CF
eMDJc<c<4?oe00_<c<`00fIVI_ooooooo`04c<c<0_ooo`03IVIVooooc<c<
00G<c<`500003<c<c003SXj>Hf=SIVIV017oool300001?ooo`<00003oooo
00AVIVKoooo<c<coool<c<c<00BIVIUVIVKoooooool/c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0<SG003G0@7G0P;G
0`?G10CG1@GG1PKG20SG2@WG2P[G2`_G30cG3@gG3PkG3`oG413G4A7G4Q;G
4a?G51CG5QKG5aOG61SG6AWG6Q[G6a_G71cG7AgG7QkG7aoG823G8B7G8R;G
92CG9BGG9RKG9bOG:2SG:BWG:R[G:b_G;2cG;BgG;RkG;boG<33G<S;G<c?G
=3CG=CGG=SKG=cOG>3SG>CWG>S[G>c_G?3cG?CgG?SkG@43G@D7G@T;G@d?G
A4CGADGGATKGAdOGB4SGBDWGBT[GBd_GC4cGCTkGCdoGD53GDE7GDU;GDe?G
E5CGEEGGEUKGEeOGF5SGFEWGFU[GG5cGGEgGGUkGGeoGH63GHF7GHV;GHf?G
I6CGIFGGIVKGIfOGJFWGJV[GJf_GK6cGKFgGKVkGKfoGL73GLG7GLW;GLg?G
M7CGMGGGMgOGN7SGNGWGNW[GNg_GO7cGOGgGOWkGOgoGP83GPH7GPX;GPh?G
QHGGQXKGQhOGR8SGRHWGRX[GRh_GS8cGSHgGSXkGShoGT93GTI7GTi?GU9CG
UIGGUYKGUiOGV9SGVIWGVY[GVi_GW9cGWIgGWYkGWioGXJ7GXZ;GXj?GY:CG
YJGGYZKGYjOGZ:SGZJWGZZ[GZj_G[:cG[JgG[joG/;3G/K7G/[;G/k?G];CG
]KGG][KG]kOG^;SG^KWG^[[G^k_G_KgG_[kG_koG`<3G`L7G`/;G`l?Ga<CG
aLGGa/KGalOGb<SGbLWGbl_Gc<cGcLgGc/kGcloGd=3GdM7Gd];Gdm?Ge=CG
eMGGe]HJc<c<4?o]00c<c<`2IVIV1?ooo`9VIVH00oooolc<c<c<c00Fc<c<
00>>SXiSHf=VIVH07_ooo`04IVIVooooc<c<oooo1<c<c0=VIVH5c<c<00BI
VIUVIVKoooooool/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^?ooo`0[c<c<0<SI003I0@7I0P;I0`?I10CI1@GI1`OI20SI2@WI2P[I
2`_I30cI3@gI3PkI3`oI413I4A7I4Q;I51CI5AGI5QKI5aOI61SI6AWI6Q[I
6a_I71cI7AgI7QkI7aoI8B7I8R;I8b?I92CI9BGI9RKI9bOI:2SI:BWI:R[I
:b_I;2cI;RkI;boI<33I<C7I<S;I<c?I=3CI=CGI=SKI=cOI>3SI>CWI>c_I
?3cI?CgI?SkI?coI@43I@D7I@T;I@d?IA4CIADGIATKIB4SIBDWIBT[IBd_I
C4cICDgICTkICdoID53IDE7IDU;IDe?IEEGIEUKIEeOIF5SIFEWIFU[IFe_I
G5cIGEgIGUkIGeoIH63IHV;IHf?II6CIIFGIIVKIIfOIJ6SIJFWIJV[IJf_I
K6cIKFgIKfoIL73ILG7ILW;ILg?IM7CIMGGIMWKIMgOIN7SINGWINW[IO7cI
OGgIOWkIOgoIP83IPH7IPX;IPh?IQ8CIQHGIQXKIQhOIRHWIRX[IRh_IS8cI
SHgISXkIShoIT93ITI7ITY;ITi?IU9CIUYKIUiOIV9SIVIWIVY[IVi_IW9cI
WIgIWYkIWioIX:3IXJ7IXj?IY:CIYJGIYZKIYjOIZ:SIZJWIZZ[IZj_I[:cI
[JgI[ZkI/;3I/K7I/[;I/k?I];CI]KGI][KI]kOI^;SI^KWI^[[I^k_I_KgI
_[kI_koI`<3I`L7I`/;I`l?Ia<CIaLGIa/KIalOIb<SIb/[Ibl_Ic<cIcLgI
c/kIcloId=3IdM7Id];Idm?Ie=CIeMGIemOIf=PJc<c<4?oV00k<c<`4IVIV
6lc<c003SXj>Hf=SIVIV01koool016IVI_ooolc<c?ooo`G<c<`00fIVI/c<
c<c<c004c<c<00BIVIUVIVKoooooool/c<c<00AVIVJ8`;R8`;Q8T8P10000
00001HS0^<SPf8S0^8S0^?ooo`0[c<c<01CJ003J0@7J0P;J0`?J10CJ1@GJ
1`OJ20SJ2@WJ2P[J2`_J30cJ3@gJ3PkJ3`oJ413J4A7J4a?J51CJ5AD3oooo
0;7J6AWJ6Q[J6a_J71cJ7AgJ7aoJ823J8B7J8R;J8b?J92CJ9BGJ9RKJ9bOJ
:2SJ:BWJ:b_J;2cJ;BgJ;RkJ;boJ<33J<C7J<S;J<c?J=3CJ=CGJ=cOJ>3SJ
>CWJ>S[J>c_J?3cJ?CgJ?SkJ?coJ@43J@D7J@T;JA4CJADGJATKJAdOJB4SJ
BDWJBT[JBd_JC4cJCDgJCTkJD53JDE7JDU;JDe?JE5CJEEGJEUKJEeOJF5SJ
FEWJFU[JG5cJGEgJGUkJGeoJH63JHF7JHV;JHf?JI6CJIFGJIVKJJ6SJJFWJ
JV[JJf_JK6cJKFgJKVkJKfoJL73JLG7JLW;JM7CJMGGJMWKJMgOJN7SJNGWJ
NW[JNg_JO7cJOGgJOWkJP83JPH7JPX;JPh?JQ8CJQHGJQXKJQhOJR8SJRHWJ
RX[JS8cJSHgJSXkJShoJT93JTI7JTY;JTi?JU9CJUIGJUYKJV9SJVIWJVY[J
Vi_JW9cJWIgJWYkJWioJX:3JXJ7JXZ;JY:CJYJGJYZKJYjOJZ:SJZJWJZZ[J
Zj_J[:cJ[JgJ[ZkJ/;3J/K7J/[;J/k?J];CJ]KGJ][KJ]kOJ^;SJ^KWJ^[[J
_;cJ_KgJ_[kJ_koJ`<3J`L7J`/;J`l?Ja<CJaLGJa/KJalOJbLWJb/[Jbl_J
c<cJcLgJc/kJcloJd=3JdM7Jd];Jdm?JeMGJe]KJemOJf=SJfMT06/c<c13o
gP0]c<c<00>>SXiSHf=VIVH07_ooo`04IVIVooooc<c<oooo3<c<c004VIVI
IVIVoooooooo;<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8
`;Soool0:lc<c00Bf`00f`41f`82f`<3f`@4f`D5f`L7f`P8f`T9f`X:f`/;
f``<f`d=f`h>f`l?fa0@fa8Bfa<C0_ooo`03faHFfaLGfaPH00;oool0[m/K
6m/M7M/N7]/O7m/P8=/Q8M/R8]/S8m/T9=/U9M/V9]/W9m/Y:M/Z:]/[:m//
;=/];M/^;]/_;m/`<=/a<M/b<]/d==/e=M/f=]/g=m/h>=/i>M/j>]/k>m/l
?=/m?M/o?m]0@=]1@M]2@]]3@m]4A=]5AM]6A]]7Am]8B=]9BM];Bm]<C=]=
CM]>C]]?Cm]@D=]ADM]BD]]CDm]DE=]FE]]GEm]HF=]IFM]JF]]KFm]LG=]M
GM]NG]]OGm]PH=]RH]]SHm]TI=]UIM]VI]]WIm]XJ=]YJM]ZJ]][Jm]]KM]^
K]]_Km]`L=]aLM]bL]]cLm]dM=]eMM]fM]]hN=]iNM]jN]]kNm]lO=]mOM]n
O]]oOm^0P=^1PM^2P]^4Q=^5QM^6Q]^7Qm^8R=^9RM^:R]^;Rm^<S=^=SM^?
Sm^@T=^ATM^BT]^CTm^DU=^EUM^FU]^GUm^HV=^JV]^KVm^LW=^MWM^NW]^O
Wm^PX=^QXM^RX]^SXm^TY=^VY]^WYm^XZ=^YZM^ZZ]^[Zm^/[=^][M^^[]^_
[m^a/M^b/]^c/m^d]=^e]M^f]]^g]m^h^=^i^M^j^]^l_=^m_M^n_]^o_m_0
`=_1`M_2`]_3`m_4a=_5aM_6a]_8b=_9bM_:b]_;bm_<c=_=cM_>c]_?cm_@
d=_AdM_Cdm_De=_EeM_Fe]_Gem_Hf=_IfM_JfP0Jc<c<4?oF02g<c<`00hj>
SV=SHfIVIP0Noooo00AVIVKoooo<c<coool<c<c<00BIVIUVIVKoooooool/
c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<
0<SM003M0@7M0P;M0`?M10CM1PKM1`OM20SM2@WM2P[M2`_M30cM3@gM3PkM
3`oM4A7M4Q;M4a?ooooM5AGM5QKM5aOM61SM6AWooooM71cM7AgM7QkM7aoM
823M8B7M8R;M8b?M92CM9BGM9bOM:2SM:BWM:R[M:b_M;2cM;BgM;RkM;boM
<C7M<S;M<c?M=3CM=CGM=SKM=cOM>3SM>CWM>S[M?3cM?CgM?SkM?coM@43M
@D7M@T;M@d?MA4CMADGMAdOMB4SMBDWMBT[MBd_MC4cMCDgMCTkMCdoMDE7M
DU;MDe?ME5CMEEGMEUKMEeOMF5SMFEWMFU[MG5cMGEgMGUkMGeoMH63MHF7M
HV;MHf?MI6CMIFGMIfOMJ6SMJFWMJV[MJf_MK6cMKFgMKVkMKfoML73MLW;M
Lg?MM7CMMGGMMWKMMgOMN7SMNGWMNW[MO7cMOGgMOWkMOgoMP83MPH7MPX;M
Ph?MQ8CMQHGMQhOMR8SMRHWMRX[MRh_MS8cMSHgMSXkMShoMT93MTY;MTi?M
U9CMUIGMUYKMUiOMV9SMVIWMVY[MW9cMWIgMWYkMWioMX:3MXJ7MXZ;MXj?M
Y:CMYJGMYjOMZ:SMZJWMZZ[MZj_M[:cM[JgM[ZkM[joM/;3M/[;M/k?M];CM
]KGM][KM]kOM^;SM^KWM^[[M^k_M_KgM_[kM_koM`<3M`L7M`/;M`l?Ma<CM
aLGMalOMb<SMbLWMb/[Mbl_Mc<cMcLgMc/kMcloMd=3Md];Mdm?Me=CMeMGM
e]KMemOMf=SMfMWMf][Mfm/Jc<c<4?o?02g<c<`00hj>SV=SHfIVIP0Noooo
00?<c<coooo<c<`03Oooo`04VIVIIVIVoooooooo;<c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c038gP00gP41gP82gP<3
gP@4gPH6gPL7gPP8gPT9gPX:gP/;gP`<gPd=gPh>gQ0@gQ4AgQ8BoooogQ@D
gQDEgQHFgQLGgQPHgQXJgQ/KoooogQdMgQhNgQlOgR0PgR4QgR8RgR<SgRDU
gRHVgRLWgRPXgRTYgRXZgR/[gR`/gRd]gRl_gS0`gS4agS8bgS<cgS@dgSDe
gSHfgSLggSTigSXjgS/kgS`lgSdmgShngSlogT10gT51gT=3gTA4gTE5gTI6
gTM7gTQ8gTU9gTY:gT];gTe=gTi>gTm?gU1@gU5AgU9BgU=CgUADgUEEgUMG
gUQHgUUIgUYJgU]KgUaLgUeMgUiNgUmOgV5QgV9RgV=SgVATgVEUgVIVgVMW
gVQXgVUYgVYZgVa/gVe]gVi^gVm_gW1`gW5agW9bgW=cgWAdgWIfgWMggWQh
gWUigWYjgW]kgWalgWemgWingX20gX61gX:2gX>3gXB4gXF5gXJ6gXN7gXR8
gXZ:gX^;gXb<gXf=gXj>gXn?gY2@gY6AgY:BgYBDgYFEgYJFgYNGgYRHgYVI
gYZJgY^KgYbLgYjNgYnOgZ2PgZ6QgZ:RgZ>SgZBTgZFUgZJVgZNWgZVYgZZZ
gZ^[gZb/gZf]gZj^gZn_g[2`g[6ag[>cg[Bdg[Feg[Jfg[Ngg[Rhg[Vig[Zj
g[^kg[fmg[jng[nog/30g/71g/;2g/?3g/C4g/G5g/O7g/S8g/W9g/[:g/_;
g/c<g/g=g/k>g/o?g]7Ag];Bg]?Cg]CDg]GEg]KFg]OGg]SHg]WIg]_Kg]cL
g]gM6/c<c13oa`0]c<c<00>>SXiSHf=VIVH07fIVIQ3<c<`00fIVI_oooooo
o`0/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[
c<c<0<SO003O0@7O0P;O0`?O10CO1PKO1`OO20SO2@WO2P[O2`_O30cO3@gO
3`oO413O4A7O4Q;ooooO51CO5AGO5QKO5aOO6AWO6Q[O6a_ooooO7AgO7QkO
7aoO823O8B7O8b?O92CO9BGO9RKO9bOO:2SO:BWO:R[O;2cO;BgO;RkO;boO
<33O<C7O<S;O<c?O=3CO=SKO=cOO>3SO>CWO>S[O>c_O?3cO?CgO?SkO@43O
@D7O@T;O@d?OA4COADGOATKOAdOOBDWOBT[OBd_OC4cOCDgOCTkOCdoOD53O
DE7ODe?OE5COEEGOEUKOEeOOF5SOFEWOFU[OFe_OGEgOGUkOGeoOH63OHF7O
HV;OHf?OI6COIVKOIfOOJ6SOJFWOJV[OJf_OK6cOKFgOKVkOL73OLG7OLW;O
Lg?OM7COMGGOMWKOMgOON7SONW[ONg_OO7cOOGgOOWkOOgoOP83OPH7OPh?O
Q8COQHGOQXKOQhOOR8SORHWORX[ORh_OSHgOSXkOShoOT93OTI7OTY;OTi?O
U9COUIGOUiOOV9SOVIWOVY[OVi_OW9cOWIgOWYkOX:3OXJ7OXZ;OXj?OY:CO
YJGOYZKOYjOOZ:SOZZ[OZj_O[:cO[JgO[ZkO[joO/;3O/K7O/k?O];CO]KGO
][KO]kOO^;SO^KWO^[[O^k_O_KgO_[kO_koO`<3O`L7O`/;O`l?Oa<COaLGO
alOOb<SObLWOb/[Obl_Oc<cOcLgOc/kOd=3OdM7Od];Odm?Oe=COeMGOe]KO
emOOf=SOf][Ofm_Og=cOgMgOg]hJc<c<4?no02g<c<`00hj>SV=SHf=SH`0a
Hf=S00?oooo<c<c<c<`0:/c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0:lc<c038h000h041h082h0<3h0@4h0H6h0L7h0P8h0T9
h0X:h0/;h0`<h0d=h0l?h10@h14Ah18Booooh1@Dh1DEh1HFh1PHh1TIh1XJ
h1/Kooooh1dMh1hNh1lOh24Qh28Rh2<Sh2@Th2DUh2HVh2LWh2PXh2XZh2/[
h2`/h2d]h2h^h2l_h30`h34ah38bh3@dh3Deh3Hfh3Lgh3Phh3Tih3Xjh3/k
h3dmh3hnh3loh410h451h492h4=3h4A4h4I6h4M7h4Q8h4U9h4Y:h4];h4a<
h4e=h4m?h51@h55Ah59Bh5=Ch5ADh5EEh5IFh5QHh5UIh5YJh5]Kh5aLh5eM
h5iNh5mOh61Ph69Rh6=Sh6ATh6EUh6IVh6MWh6QXh6UYh6][h6a/h6e]h6i^
h6m_h71`h75ah79bh7Adh7Eeh7Ifh7Mgh7Qhh7Uih7Yjh7]kh7emh7inh7mo
h820h861h8:2h8>3h8B4h8J6h8N7h8R8h8V9h8Z:h8^;h8b<h8f=h8j>h92@
h96Ah9:Bh9>Ch9BDh9FEh9JFh9NGh9VIh9ZJh9^Kh9bLh9fMh9jNh9nOh:2P
h::Rh:>Sh:BTh:FUh:JVh:NWh:RXh:VYh:^[h:b/h:f]h:j^h:n_h;2`h;6a
h;:bh;Bdh;Feh;Jfh;Ngh;Rhh;Vih;Zjh;^kh;blh;jnh;noh<30h<71h<;2
h<?3h<C4h<G5h<O7h<S8h<W9h<[:h<_;h<c<h<g=h<k>h=3@h=7Ah=;Bh=?C
h=CDh=GEh=KFh=OGh=WIh=[Jh=_Kh=cLh=gMh=kNh=oO6/c<c13o^00]c<c<
=Hj>SRc<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo
02_<c<`0b>800>810N820^830n851N861^871n882>892N8:2^8;2n8<3>8>
3^8?3n8@4>8A4N8B4^8C4oooon8E5N8G5n8H6>8I6N8J6_ooon8L7>8M7N8N
7^8P8>8Q8N8R8^8S8n8T9>8U9N8V9^8W9n8Y:N8Z:^8[:n8/;>8];N8^;^8_
;n8a<N8b<^8c<n8d=>8e=N8f=^8g=n8h>>8j>^8k>n8l?>8m?N8n?^8o?n90
@>91@N93@n94A>95AN96A^97An98B>99BN9:B^9<C>9=CN9>C^9?Cn9@D>9A
DN9BD^9CDn9EEN9FE^9GEn9HF>9IFN9JF^9KFn9MGN9NG^9OGn9PH>9QHN9R
H^9SHn9TI>9VI^9WIn9XJ>9YJN9ZJ^9[Jn9/K>9]KN9_Kn9`L>9aLN9bL^9c
Ln9dM>9eMN9fM^9hN>9iNN9jN^9kNn9lO>9mON9nO^:0P>:1PN:2P^:3Pn:4
Q>:5QN:6Q^:7Qn:9RN::R^:;Rn:<S>:=SN:>S^:?Sn:@T>:BT^:CTn:DU>:E
UN:FU^:GUn:HV>:IVN:KVn:LW>:MWN:NW^:OWn:PX>:QXN:RX^:TY>:UYN:V
Y^:WYn:XZ>:YZN:ZZ^:/[>:][N:^[^:_[n:`/>:a/N:b/^:c/n:e]N:f]^:g
]n:h^>:i^N:j^^:k^n:l_>:n_^:o_n;0`>;1`N;2`^;3`n;4a>;5aN;7an;8
b>;9bN;:b^;;bn;<c>;=cN;>c^;@d>;AdN;Bd^;Cdn;De>;EeN;Fe^;Hf>;I
fN;Jf^;Kfn;Lg>;MgN;Ng^;Ogn;QhA[<c<`@ok00S/c<c004IVIVR<2hR<2h
B9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<c00Bh`00h`41h`82h`<3
h`D5h`H6h`L7h`P8h`T9h`X:h`/;h``<h`h>h`l?ha0@ha4Aha8Bha<C0_oo
o`03haLGhaPHhaTI00;oool0[n<L7><N7^<O7n<P8><Q8N<R8^<S8n<T9><U
9N<W9n<X:><Y:N<Z:^<[:n</;><];N<_;n<`<><a<N<b<^<c<n<d=><e=N<f
=^<h>><i>N<j>^<k>n<l?><m?N<n?^=0@>=1@N=2@^=3@n=4A>=5AN=6A^=7
An=9BN=:B^=;Bn=<C>==CN=>C^=?Cn=ADN=BD^=CDn=DE>=EEN=FE^=GEn=I
FN=JF^=KFn=LG>=MGN=NG^=OGn=PH>=RH^=SHn=TI>=UIN=VI^=WIn=XJ>=Z
J^=[Jn=/K>=]KN=^K^=_Kn=`L>=aLN=cLn=dM>=eMN=fM^=gMn=hN>=iNN=k
Nn=lO>=mON=nO^=oOn>0P>>1PN>2P^>4Q>>5QN>6Q^>7Qn>8R>>9RN>:R^><
S>>=SN>>S^>?Sn>@T>>ATN>BT^>DU>>EUN>FU^>GUn>HV>>IVN>JV^>KVn>M
WN>NW^>OWn>PX>>QXN>RX^>SXn>UYN>VY^>WYn>XZ>>YZN>ZZ^>[Zn>/[>>^
[^>_[n>`/>>a/N>b/^>c/n>d]>>f]^>g]n>h^>>i^N>j^^>k^n>l_>>n_^>o
_n?0`>?1`N?2`^?3`n?4a>?5aN?7an?8b>?9bN?:b^?;bn?<c>?=cN??cn?@
d>?AdN?Bd^?Cdn?De>?EeN?Fe^?Hf>?IfN?Jf^?Kfn?Lg>?MgN?Ng^?Ph>?Q
hN?RhP0Jc<c<4?nX08k<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3H
R<2hR<2hoooo02_<c<`05>@00>@10N@20^@30n@51N@61^@71n@82>@92N@:
2^@;2n@=3N@>3^@?3n@@4>@A4N@B4^@C4n@E5N@F5P?oool0/N@J6^@K6n@M
7N@N7^@O7n@P8>@Q8N@R8^@S8n@U9N@V9^@W9n@X:>@Y:N@Z:^@[:n@];N@^
;^@_;n@`<>@a<N@b<^@c<n@d=>@f=^@g=n@h>>@i>N@j>^@k>n@l?>@n?^@o
?nA0@>A1@NA2@^A3@nA4A>A6A^A7AnA8B>A9BNA:B^A;BnA<C>A>C^A?CnA@
D>AADNABD^ACDnADE>AFE^AGEnAHF>AIFNAJF^AKFnALG>ANG^AOGnAPH>AQ
HNARH^ASHnATI>AVI^AWInAXJ>AYJNAZJ^A[JnA/K>A^K^A_KnA`L>AaLNAb
L^AcLnAdM>AfM^AgMnAhN>AiNNAjN^AkNnAlO>AnO^AoOnB0P>B1PNB2P^B3
PnB4Q>B6Q^B7QnB8R>B9RNB:R^B;RnB<S>B=SNB?SnB@T>BATNBBT^BCTnBD
U>BEUNBGUnBHV>BIVNBJV^BKVnBLW>BMWNBOWnBPX>BQXNBRX^BSXnBTY>BU
YNBWYnBXZ>BYZNBZZ^B[ZnB/[>B][NB_[nB`/>Ba/NBb/^Bc/nBd]>Be]NBg
]nBh^>Bi^NBj^^Bk^nBl_>Bm_NBo_nC0`>C1`NC2`^C3`nC4a>C5aNC7anC8
b>C9bNC:b^C;bnC<c>C=cNC?cnC@d>CAdNCBd^CCdnCDe>CEeNCGenCHf>CI
fNCJf^CKfnCLg>CMgNCOgnCPh>CQhNCRh^CSh`0Jc<c<4?nQ02g<c<`00hj>
S_ooooooo`0boooo;<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0:lc<c038iP00iP41iP82iP<3iPD5iPH6iPL7iPP8iPT9iPX:
iP/;iPd=iPh>iPl?iQ0@iQ4AiQ8BiQ@DiQDEiQHFiQLGiQPHiQTIiQXJiQ`L
iQdMiQhNiQlOiR0PiR4QiR8RiR@TiRDUiRHViRLWiRPXiRTYiRXZiR`/iRd]
iRh^iRl_iS0`iS4aiS8biS@diSDeiSHfiSLgiSPhiSTiiS/kiS`liSdmiShn
iSloiT10iT51iT=3iTA4iTE5iTI6iTM7iTQ8iTU9iT];iTa<iTe=iTi>iTm?
iU1@iU5AiU=CiUADiUEEiUIFiUMGiUQHiUYJiU]KiUaLiUeMiUiNiUmOiV1P
iV9RiV=SiVATiVEUiVIViVMWiVQXiVYZiV][iVa/iVe]iVi^iVm_iW1`iW9b
iW=ciWAdiWEeiWIfiWMgiWQhiWYjiW]kiWaliWemiWiniWmoiX61iX:2iX>3
iXB4iXF5iXJ6iXN7iXV9iXZ:iX^;iXb<iXf=iXj>iXn?iY6AiY:BiY>CiYBD
iYFEiYJFiYNGiYVIiYZJiY^KiYbLiYfMiYjNiZ2PiZ6QiZ:RiZ>SiZBTiZFU
iZJViZRXiZVYiZZZiZ^[iZb/iZf]iZj^i[2`i[6ai[:bi[>ci[Bdi[Fei[Jf
i[Rhi[Vii[Zji[^ki[bli[fmi[jni/30i/71i/;2i/?3i/C4i/G5i/O7i/S8
i/W9i/[:i/_;i/c<i/g=i/o?i]3@i]7Ai];Bi]?Ci]CDi]GEi]OGi]SHi]WI
i][Ji]_Ki]cLi]gMi]oOi^3Pi^7Qi^;Ri^?Si^CT6/c<c13oV@0]c<c<00>>
SXiSHf?oool0<_ooobc<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3H
R<2hR<2hoooo02_<c<`0b>L00>L10NL20^L30nL51NL61^L71nL82>L92NL:
2^L<3>L=3NL>3^L?3nL@4>LA4NLB4^LD5>LE5NLF5^LG5nLH6>LI6NLK6nLL
7>LM7NLN7^LO7nLP8>LQ8NLS8nLT9>LU9NLV9^LW9nLX:>LZ:^L[:nL/;>L]
;NL^;^L_;nL`<>Lb<^Lc<nLd=>Le=NLf=^Lg=nLi>NLj>^Lk>nLl?>Lm?NLn
?^Lo?nM1@NM2@^M3@nM4A>M5ANM6A^M8B>M9BNM:B^M;BnM<C>M=CNM>C^M@
D>MADNMBD^MCDnMDE>MEENMGEnMHF>MIFNMJF^MKFnMLG>MMGNMOGnMPH>MQ
HNMRH^MSHnMTI>MVI^MWInMXJ>MYJNMZJ^M[JnM/K>M^K^M_KnM`L>MaLNMb
L^McLnMeMNMfM^MgMnMhN>MiNNMjN^MkNnMmONMnO^MoOnN0P>N1PNN2P^N4
Q>N5QNN6Q^N7QnN8R>N9RNN:R^N<S>N=SNN>S^N?SnN@T>NATNNCTnNDU>NE
UNNFU^NGUnNHV>NIVNNKVnNLW>NMWNNNW^NOWnNPX>NRX^NSXnNTY>NUYNNV
Y^NWYnNXZ>NZZ^N[ZnN/[>N][NN^[^N_[nNa/NNb/^Nc/nNd]>Ne]NNf]^Ng
]nNi^NNj^^Nk^nNl_>Nm_NNn_^O0`>O1`NO2`^O3`nO4a>O5aNO6a^O8b>O9
bNO:b^O;bnO<c>O=cNO?cnO@d>OAdNOBd^OCdnODe>OEeNOGenOHf>OIfNOJ
f^OKfnOLg>ONg^OOgnOPh>OQhNORh^OShnOTi>OViQ[<c<`@oi40;Lc<c003
SXj>Hf=Sc<c<023oool@IVIV0_ooobc<c<`016IVIXS0^8S0^4R@R0400000
0005R<2hb>3HR<2hR<2hoooo02_<c<`0b>P00>P10NP20^P30nP51NP61^P7
1nP82>P92NP:2^P<3>P=3NP>3^P?3nP@4>PA4NPC4nPD5>PE5NPF5^PG5nPH
6>PJ6^PK6nPL7>PM7NPN7^PO7nPP8>PR8^PS8nPT9>PU9NPV9^PW9nPY:NPZ
:^P[:nP/;>P];NP^;^P`<>Pa<NPb<^Pc<nPd=>Pe=NPg=nPh>>Pi>NPj>^Pk
>nPl?>Pm?NPo?nQ0@>Q1@NQ2@^Q3@nQ4A>Q6A^Q7AnQ8B>Q9BNQ:B^Q;BnQ=
CNQ>C^Q?CnQ@D>QADNQBD^QDE>QEENQFE^QGEnQHF>QIFNQJF^QLG>QMGNQN
G^QOGnQPH>QQHNQSHnQTI>QUINQVI^QWInQXJ>QZJ^Q[JnQ/K>Q]KNQ^K^Q_
KnQaLNQbL^QcLnQdM>QeMNQfM^QhN>QiNNQjN^QkNnQlO>QmONQnO^R0P>R1
PNR2P^R3PnR4Q>R5QNR7QnR8R>R9RNR:R^R;RnR<S>R>S^R?SnR@T>RATNRB
T^RCTnREUNRFU^RGUnRHV>RIVNRJV^RKVnRMWNRNW^ROWnRPX>RQXNRRX^RT
Y>RUYNRVY^RWYnRXZ>RYZNR[ZnR/[>R][NR^[^R_[nR`/>Rb/^Rc/nRd]>Re
]NRf]^Rg]nRh^>Rj^^Rk^nRl_>Rm_NRn_^Ro_nS1`NS2`^S3`nS4a>S5aNS6
a^S8b>S9bNS:b^S;bnS<c>S=cNS?cnS@d>SAdNSBd^SCdnSDe>SEeNSGenSH
f>SIfNSJf^SKfnSLg>SNg^SOgnSPh>SQhNSRh^SShnSUiNSVi^SWia[<c<`@
ohX0;Lc<c004SXj>Hf=SIVIVc<c<7VIVIP03ooooc<c<VIVI00fIVIT00fIV
I_ooooooo`0/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0
^?ooo`0[c<c<0<SY003Y0@7Y0P;Y0`?Y1@GY1PKY1`OY20SY2@WY2P[Y30cY
3@gY3PkY3`oY413Y4A7Y4a?Y51CY5AGY5QKY5aOY61SY6Q[Y6a_Y71cY7AgY
7QkY7aoY8B7Y8R;Y8b?Y92CY9BGY9RKY:2SY:BWY:R[Y:b_Y;2cY;BgY;boY
<33Y<C7Y<S;Y<c?Y=3CY=SKY=cOY>3SY>CWY>S[Y>c_Y?CgY?SkY?coY@43Y
@D7Y@T;YA4CYADGYATKYAdOYB4SYBDWYBd_YC4cYCDgYCTkYCdoYD53YDU;Y
De?YE5CYEEGYEUKYEeOYFEWYFU[YFe_YG5cYGEgYGUkYH63YHF7YHV;YHf?Y
I6CYIFGYIfOYJ6SYJFWYJV[YJf_YK6cYKVkYKfoYL73YLG7YLW;YLg?YMGGY
MWKYMgOYN7SYNGWYNW[YO7cYOGgYOWkYOgoYP83YPH7YPh?YQ8CYQHGYQXKY
QhOYR8SYRX[YRh_YS8cYSHgYSXkYShoYTI7YTY;YTi?YU9CYUIGYUYKYV9SY
VIWYVY[YVi_YW9cYWIgYWioYX:3YXJ7YXZ;YXj?YY:CYYZKYYjOYZ:SYZJWY
ZZ[YZj_Y[JgY[ZkY[joY/;3Y/K7Y/[;Y];CY]KGY][KY]kOY^;SY^KWY^k_Y
_;cY_KgY_[kY_koY`<3Y`/;Y`l?Ya<CYaLGYa/KYalOYbLWYb/[Ybl_Yc<cY
cLgYc/kYd=3YdM7Yd];Ydm?Ye=CYeMGYemOYf=SYfMWYf][Yfm_Yg=cYg]kY
gmoYh>3YhN7Yh^;Yhn?YiNGYi^KYinOYj>PJc<c<4?n202g<c<`00hj>SV=S
HfIVIP0Noooo00AVIVKoooo<c<coool<c<c<00BIVIUVIVKoooooool/c<c<
00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0<S[
003[0@7[0P;[10C[1@G[1PK[1`O[20S[2@W[2`_[30c[3@g[3Pk[3`o[413[
4Q;[4a?[51C[5AG[5QK[5aO[6AW[6Q[[6a_[71c[7Ag[7Qk[823[8B7[8R;[
8b?[92C[9RK[9bO[:2S[:BW[:R[[:b_[;Bg[;Rk[;bo[<33[<C7[<S;[=3C[
=CG[=SK[=cO[>3S[>CW[>c_[?3c[?Cg[?Sk[?co[@D7[@T;[@d?[A4C[ADG[
ATK[B4S[BDW[BT[[Bd_[C4c[CDg[Cdo[D53[DE7[DU;[De?[E5C[EUK[EeO[
F5S[FEW[FU[[Fe_[GEg[GUk[Geo[H63[HF7[Hf?[I6C[IFG[IVK[IfO[J6S[
JV[[Jf_[K6c[KFg[KVk[Kfo[LG7[LW;[Lg?[M7C[MGG[MWK[N7S[NGW[NW[[
Ng_[O7c[OWk[Ogo[P83[PH7[PX;[Ph?[QHG[QXK[QhO[R8S[RHW[RX[[S8c[
SHg[SXk[Sho[T93[TI7[Ti?[U9C[UIG[UYK[UiO[V9S[VY[[Vi_[W9c[WIg[
WYk[X:3[XJ7[XZ;[Xj?[Y:C[YJG[YjO[Z:S[ZJW[ZZ[[Zj_[[:c[[Zk[[jo[
/;3[/K7[/[;[/k?[]KG[][K[]kO[^;S[^KW[^k_[_;c[_Kg[_[k[_ko[`<3[
`/;[`l?[a<C[aLG[a/K[alO[bLW[b/[[bl_[c<c[cLg[c/k[d=3[dM7[d];[
dm?[e=C[eMG[emO[f=S[fMW[f][[fm_[gMg[g]k[gmo[h>3[hN7[h^;[i>C[
iNG[i^K[inO[j>S[jNTJc<c<4?mj00k<c<`4oooo6lc<c003SXj>Hf=SIVIV
01koool016IVI_ooolc<c?ooo`c<c<`019VIVFIVI_ooooooobc<c<`016IV
IXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo02_<c<`0b>`00>`1
0N`20^`41>`51N`61^`71n`82>`92N`;2n`<3>`=3N`>3^`?3n`A4N`B4^`C
4n`D5>`E5N`F5^`H6>`I6N`J6^`K6n`L7>`M7N`O7n`P8>`Q8N`R8^`S8n`U
9N`V9^`W9n`X:>`Y:N`Z:^`/;>`];N`^;^`_;n``<>`b<^`c<n`d=>`e=N`f
=^`g=n`i>N`j>^`k>n`l?>`m?N`o?na0@>a1@Na2@^a3@na4A>a6A^a7Ana8
B>a9BNa:B^a;Bna=CNa>C^a?Cna@D>aADNaCDnaDE>aEENaFE^aGEnaHF>aJ
F^aKFnaLG>aMGNaNG^aPH>aQHNaRH^aSHnaTI>aUINaWInaXJ>aYJNaZJ^a[
Jna]KNa^K^a_Kna`L>aaLNabL^adM>aeMNafM^agMnahN>aiNNakNnalO>am
ONanO^aoOnb1PNb2P^b3Pnb4Q>b5QNb6Q^b8R>b9RNb:R^b;Rnb<S>b>S^b?
Snb@T>bATNbBT^bCTnbEUNbFU^bGUnbHV>bIVNbJV^bLW>bMWNbNW^bOWnbP
X>bRX^bSXnbTY>bUYNbVY^bWYnbYZNbZZ^b[Znb/[>b][Nb_[nb`/>ba/Nbb
/^bc/nbd]>bf]^bg]nbh^>bi^Nbj^^bl_>bm_Nbn_^bo_nc0`>c1`Nc3`nc4
a>c5aNc6a^c7anc8b>c:b^c;bnc<c>c=cNc>c^c@d>cAdNcBd^cCdncDe>cE
eNcGencHf>cIfNcJf^cKfncMgNcNg^cOgncPh>cQhNcRh^cTi>cUiNcVi^cW
incXj>cZj^c[ja[<c<`@og<03<c<c0;oool4IVIV0_oooaW<c<`00hj>SV=S
HfIVIP0Noooo00AVIVKoooo<c<coool5c<c<00=VIVK<c<c<c<`01<c<c004
VIVIIVIVoooooooo;<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0:lc<c038k@00k@41k@82k@@4k@D5k@H6k@L7k@P8k@T9k@/;
k@`<k@d=k@h>k@l?kA4AkA8BkA<CkA@DkADEkALGkAPHkATIkAXJkA/KkA`L
kAhNkAlOkB0PkB4QkB8RkB@TkBDUkBHVkBLWkBPXkBXZkB/[kB`/kBd]kBh^
kBl_kC4akC8bkC<ckC@dkCDekCLgkCPhkCTikCXjkC/kkC`lkChnkClokD10
kD51kD92kDA4kDE5kDI6kDM7kDQ8kDY:kD];kDa<kDe=kDi>kDm?kE5AkE9B
kE=CkEADkEEEkEMGkEQHkEUIkEYJkE]KkEaLkEiNkEmOkF1PkF5QkF9RkFAT
kFEUkFIVkFMWkFQXkFYZkF][kFa/kFe]kFi^kFm_kG5akG9bkG=ckGAdkGEe
kGMgkGQhkGUikGYjkG]kkGemkGinkGmokH20kH61kH:2kHB4kHF5kHJ6kHN7
kHR8kHZ:kH^;kHb<kHf=kHj>kHn?kI6AkI:BkI>CkIBDkIFEkINGkIRHkIVI
kIZJkI^KkIfMkIjNkInOkJ2PkJ6QkJ:RkJBTkJFUkJJVkJNWkJRXkJZZkJ^[
kJb/kJf]kJj^kJn_kK6akK:bkK>ckKBdkKFekKNgkKRhkKVikKZjkK^kkKfm
kKjnkKnokL30kL71kL;2kLC4kLG5kLK6kLO7kLS8kL[:kL_;kLc<kLg=kLk>
kM3@kM7AkM;BkM?CkMCDkMGEkMOGkMSHkMWIkM[JkM_KkMgMkMkNkMoOkN3P
kN7QkN;RkNCTkNGUkNKVkNOWkNSXkN[ZkN_[kNc/6/c<c13oJ`0<c<c<0VIV
IPC<c<`2IVIV00?oooo<c<c<c<`01<c<c0800003c<c<0P0000_<c<`00hj>
SV=SHfIVIP0Hoooo0`0000?oool016IVI_ooolc<c?ooo`C<c<`3IVIV1Lc<
c004VIVIIVIVoooooooo;<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0:lc<c038kP00kP41kP82kP@4kPD5kPH6kPL7kPP8kPX:
kP/;kP`<kPd=kPh>kPl?kQ4AkQ8BkQ<CkQ@DkQDEkQLGkQPHkQTIkQXJkQ/K
kQdMkQhNkQlOkR0PkR4QkR<SkR@TkRDUkRHVkRLWkRTYkRXZkR/[kR`/kRd]
kRh^kS0`kS4akS8bkS<ckS@dkSHfkSLgkSPhkSTikSXjkS`lkSdmkShnkSlo
kT10kT92kT=3kTA4kTE5kTI6kTQ8kTU9kTY:kT];kTa<kTe=kTm?kU1@kU5A
kU9BkU=CkUEEkUIFkUMGkUQHkUUIkU]KkUaLkUeMkUiNkUmOkV5QkV9RkV=S
kVATkVEUkVMWkVQXkVUYkVYZkV][kVa/kVi^kVm_kW1`kW5akW9bkWAdkWEe
kWIfkWMgkWQhkWYjkW]kkWalkWemkWinkX20kX61kX:2kX>3kXB4kXJ6kXN7
kXR8kXV9kXZ:kX^;kXf=kXj>kXn?kY2@kY6AkY>CkYBDkYFEkYJFkYNGkYVI
kYZJkY^KkYbLkYfMkYnOkZ2PkZ6QkZ:RkZ>SkZFUkZJVkZNWkZRXkZVYkZZZ
kZb/kZf]kZj^kZn_k[2`k[:bk[>ck[Bdk[Fek[Jfk[Rhk[Vik[Zjk[^kk[bl
k[jnk[nok/30k/71k/;2k/C4k/G5k/K6k/O7k/S8k/W9k/_;k/c<k/g=k/k>
k/o?k]7Ak];Bk]?Ck]CDk]GEk]OGk]SHk]WIk][Jk]_Kk]gMk]kNk]oOk^3P
k^7Qk^?Sk^CTk^GUk^KVk^OWk^SXk^[Zk^_[k^c/k^g]6/c<c13oH`0;c<c<
00=VIVKoooo<c<`01/c<c003IVIVooooc<c<00C<c<`200000lc<c080000;
c<c<00>>SXiSHf=VIVH05oooo`050000oooooooooooo000000;oool016IV
I_ooolc<c?ooo`c<c<`019VIVFIVI_ooooooobc<c<`016IVIXS0^8S0^4R@
R04000000005R<2hb>3HR<2hR<2hoooo02_<c<`0b?000?010O020_041?05
1O061_071o082?0:2_0;2o0<3?0=3O0>3_0@4?0A4O0B4_0C4o0D5?0F5_0G
5o0H6?0I6O0J6_0L7?0M7O0N7_0O7o0P8?0R8_0S8o0T9?0U9O0V9_0X:?0Y
:O0Z:_0[:o0/;?0^;_0_;o0`<?0a<O0b<_0d=?0e=O0f=_0g=o0h>?0j>_0k
>o0l??0m?O0n?_10@?11@O12@_13@o14A?16A_17Ao18B?19BO1:B_1<C?1=
CO1>C_1?Co1@D?1ADO1CDo1DE?1EEO1FE_1GEo1IFO1JF_1KFo1LG?1MGO1O
Go1PH?1QHO1RH_1SHo1UIO1VI_1WIo1XJ?1YJO1[Jo1/K?1]KO1^K_1_Ko1a
LO1bL_1cLo1dM?1eMO1gMo1hN?1iNO1jN_1kNo1mOO1nO_1oOo20P?21PO23
Po24Q?25QO26Q_27Qo29RO2:R_2;Ro2<S?2=SO2?So2@T?2ATO2BT_2CTo2E
UO2FU_2GUo2HV?2IVO2KVo2LW?2MWO2NW_2OWo2QXO2RX_2SXo2TY?2UYO2W
Yo2XZ?2YZO2ZZ_2[Zo2][O2^[_2_[o2`/?2a/O2c/o2d]?2e]O2f]_2g]o2i
^O2j^_2k^o2l_?2m_O2o_o30`?31`O32`_33`o35aO36a_37ao38b?39bO3;
bo3<c?3=cO3>c_3?co3AdO3Bd_3Cdo3De?3EeO3Geo3Hf?3IfO3Jf_3Kfo3M
gO3Ng_3Ogo3Ph?3QhO3Sho3Ti?3UiO3Vi_3Wio3YjO3Zj_3[jo3/k?3]kO3_
ka[<c<`@oe`02lc<c003IVIVooooc<c<00@00002c<c<00=VIVKoooo<c<`0
1<c<c0800003c<c<0P0000_<c<`00hj>SV=SHfIVIP0Goooo00D0003ooooo
ooooool000000_ooo`04IVIVooooc<c<oooo3<c<c004VIVIIVIVoooooooo
;<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0:lc<
c038l@00l@41l@82l@@4l@D5l@H6l@L7l@P8l@X:l@/;l@`<l@d=l@h>lA0@
lA4AlA8BlA<ClA@DlAHFlALGlAPHlATIlA/KlA`LlAdMlAhNlAlOlB4QlB8R
lB<SlB@TlBDUlBLWlBPXlBTYlBXZlB/[lBd]lBh^lBl_lC0`lC4alC<clC@d
lCDelCHflCLglCTilCXjlC/klC`llCdmlClolD10lD51lD92lD=3lDE5lDI6
lDM7lDQ8lDU9lD];lDa<lDe=lDi>lE1@lE5AlE9BlE=ClEADlEIFlEMGlEQH
lEUIlEYJlEaLlEeMlEiNlEmOlF1PlF9RlF=SlFATlFEUlFIVlFQXlFUYlFYZ
lF][lFa/lFi^lFm_lG1`lG5alG9blGAdlGEelGIflGMglGQhlGYjlG]klGal
lGemlGmolH20lH61lH:2lH>3lHF5lHJ6lHN7lHR8lHV9lH^;lHb<lHf=lHj>
lHn?lI6AlI:BlI>ClIBDlIFElINGlIRHlIVIlIZJlI^KlIfMlIjNlInOlJ2P
lJ6QlJ>SlJBTlJFUlJJVlJNWlJVYlJZZlJ^[lJb/lJj^lJn_lK2`lK6alK:b
lKBdlKFelKJflKNglKRhlKZjlK^klKbllKfmlKjnlL30lL71lL;2lL?3lLC4
lLK6lLO7lLS8lLW9lL[:lLc<lLg=lLk>lLo?lM3@lM;BlM?ClMCDlMGElMKF
lMSHlMWIlM[JlM_KlMcLlMkNlMoOlN3PlN7QlN?SlNCTlNGUlNKVlNOWlNWY
lN[ZlN_[lNc/lNg]lNo_lO3`6/c<c13oE00:c<c<00=VIVKoooo<c<`01P00
00;<c<`00fIVI_ooolc<c003c<c<0P0000?<c<`200002lc<c003SXj>Hf=S
IVIV01Ooool01@000?ooooooooooo`000002oooo00=VIVKoooo<c<`03Ooo
o`04VIVIIVIVoooooooo;<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0:lc<c038lP00lP41lP82lP@4lPD5lPH6lPL7lPP8lPX:
lP/;lP`<lPd=lPl?lQ0@lQ4AlQ8BlQ<ClQDElQHFlQLGlQPHlQTIlQ/KlQ`L
lQdMlQhNlQlOlR4QlR8RlR<SlR@TlRHVlRLWlRPXlRTYlRXZlR`/lRd]lRh^
lRl_lS0`lS8blS<clS@dlSDelSLglSPhlSTilSXjlS/klSdmlShnlSlolT10
lT51lT=3lTA4lTE5lTI6lTM7lTU9lTY:lT];lTa<lTi>lTm?lU1@lU5AlU9B
lUADlUEElUIFlUMGlUQHlUYJlU]KlUaLlUeMlUiNlV1PlV5QlV9RlV=SlVEU
lVIVlVMWlVQXlVUYlV][lVa/lVe]lVi^lVm_lW5alW9blW=clWAdlWEelWMg
lWQhlWUilWYjlWallWemlWinlWmolX20lX:2lX>3lXB4lXF5lXJ6lXR8lXV9
lXZ:lX^;lXf=lXj>lXn?lY2@lY6AlY>ClYBDlYFElYJFlYNGlYVIlYZJlY^K
lYbLlYfMlYnOlZ2PlZ6QlZ:RlZBTlZFUlZJVlZNWlZRXlZZZlZ^[lZb/lZf]
lZj^l[2`l[6al[:bl[>cl[Bdl[Jfl[Ngl[Rhl[Vil[^kl[bll[fml[jnl[no
l/71l/;2l/?3l/C4l/G5l/O7l/S8l/W9l/[:l/_;l/g=l/k>l/o?l]3@l];B
l]?Cl]CDl]GEl]KFl]SHl]WIl][Jl]_Kl]cLl]kNl]oOl^3Pl^7Ql^?Sl^CT
l^GUl^KVl^OWl^WYl^[Zl^_[l^c/l^g]l^o_l_3`l_7a6/c<c13oC00:c<c<
00=VIVKoooo<c<`01P0000;<c<`00fIVI_ooolc<c003c<c<1`0000_<c<`0
0hj>SV=SHfIVIP0Goooo00D0003oooooooooool000000_ooo`03IVIVoooo
c<c<00k<c<`00fIVI_ooooooo`0/c<c<00AVIVJ8`;R8`;Q8T8P100000000
1HS0^<SPf8S0^8S0^?ooo`0[c<c<0<Sd003d0@7d0P;d10Cd1@Gd1PKd1`Od
2@Wd2P[d2`_d30cd3@gd3`od413d4A7d4Q;d4a?d5AGd5QKd5aOd61Sd6Q[d
6a_d71cd7Agd7Qkd823d8B7d8R;d8b?d9BGd9RKd9bOd:2Sd:BWd:b_d;2cd
;Bgd;Rkd;bod<C7d<S;d<c?d=3Cd=SKd=cOd>3Sd>CWd>S[d?3cd?Cgd?Skd
?cod@D7d@T;d@d?dA4CdADGdAdOdB4SdBDWdBT[dBd_dCDgdCTkdCdodD53d
DU;dDe?dE5CdEEGdEUKdF5SdFEWdFU[dFe_dGEgdGUkdGeodH63dHF7dHf?d
I6CdIFGdIVKdIfOdJFWdJV[dJf_dK6cdKVkdKfodL73dLG7dLW;dM7CdMGGd
MWKdMgOdNGWdNW[dNg_dO7cdOGgdOgodP83dPH7dPX;dQ8CdQHGdQXKdQhOd
R8SdRX[dRh_dS8cdSHgdSXkdT93dTI7dTY;dTi?dUIGdUYKdUiOdV9SdVIWd
Vi_dW9cdWIgdWYkdX:3dXJ7dXZ;dXj?dY:CdYZKdYjOdZ:SdZJWdZZ[d[:cd
[Jgd[Zkd[jod/K7d/[;d/k?d];Cd]KGd]kOd^;Sd^KWd^[[d_;cd_Kgd_[kd
_kod`<3d`/;d`l?da<CdaLGda/Kdb<SdbLWdb/[dbl_dcLgdc/kdclodd=3d
dM7ddm?de=CdeMGde]Kdf=SdfMWdf][dfm_dg=cdg]kdgmodh>3dhN7dh^;d
i>CdiNGdi^KdinOdjNWdj^[djn_dk>cdkNgdknodl?3dlO7dl_8Jc<c<4?m5
00[<c<`00fIVI_ooolc<c00600000/c<c003IVIVooooc<c<00?<c<`20000
0lc<c080000;c<c<00>>SXiSHf=VIVH05oooo`050000oooooooooooo0000
00;oool00fIVI_ooofIVIP0?IVIV0_ooobc<c<`016IVIXS0^8S0^4R@R040
00000005R<2hb>3HR<2hR<2hoooo02_<c<`0b?D00?D10OD20_D41?D51OD6
1_D71oD92OD:2_D;2oD<3?D=3OD?3oD@4?DA4ODB4_DD5?DE5ODF5_DG5oDH
6?DJ6_DK6oDL7?DM7ODO7oDP8?DQ8ODR8_DS8oDU9ODV9_DW9oDX:?DZ:_D[
:oD/;?D];OD_;oD`<?Da<ODb<_Dc<oDe=ODf=_Dg=oDh>?Dj>_Dk>oDl??Dm
?ODn?_E0@?E1@OE2@_E3@oE5AOE6A_E7AoE8B?E9BOE;BoE<C?E=COE>C_E@
D?EADOEBD_ECDoEDE?EFE_EGEoEHF?EIFOEKFoELG?EMGOENG_EOGoEQHOER
H_ESHoETI?EVI_EWIoEXJ?EYJOEZJ_E/K?E]KOE^K_E_KoEaLOEbL_EcLoEd
M?EfM_EgMoEhN?EiNOEjN_ElO?EmOOEnO_EoOoF1POF2P_F3PoF4Q?F5QOF7
QoF8R?F9ROF:R_F<S?F=SOF>S_F?SoF@T?FBT_FCToFDU?FEUOFGUoFHV?FI
VOFJV_FKVoFMWOFNW_FOWoFPX?FRX_FSXoFTY?FUYOFVY_FXZ?FYZOFZZ_F[
ZoF][OF^[_F_[oF`/?Fa/OFc/oFd]?Fe]OFf]_Fh^?Fi^OFj^_Fk^oFl_?Fn
__Fo_oG0`?G1`OG3`oG4a?G5aOG6a_G8b?G9bOG:b_G;boG<c?G>c_G?coG@
d?GAdOGCdoGDe?GEeOGFe_GGeoGIfOGJf_GKfoGLg?GNg_GOgoGPh?GQhOGR
h_GTi?GUiOGVi_GWioGYjOGZj_G[joG/k?G]kOG_koG`l?GalOGbl_Gdm1[<
c<`@ocd02/c<c003IVIVooooc<c<00H00002c<c<00=VIVKoooo<c<`00lc<
c0800003c<c<0P0000_<c<`00hj>SV=SHfIVIP0Goooo00D0003ooooooooo
ool000000_ooo`03IVIVooooc<c<00jIVIT00fIVI_ooooooo`0/c<c<00AV
IVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0<Sf003f
0@7f0P;f10Cf1@Gf1PKf1`Of2@Wf2P[f2`_f30cf3Pkf3`of413f4A7f4Q;f
51Cf5AGf5QKf5aOf6AWf6Q[f6a_f71cf7Qkf7aof823f8B7f8R;f92Cf9BGf
9RKf9bOf:BWf:R[f:b_f;2cf;Rkf;bof<33f<C7f<S;f=3Cf=CGf=SKf=cOf
>CWf>S[f>c_f?3cf?Skf?cof@43f@D7f@T;fA4CfADGfATKfAdOfBDWfBT[f
Bd_fC4cfCTkfCdofD53fDE7fDU;fE5CfEEGfEUKfEeOfFEWfFU[fFe_fG5cf
GUkfGeofH63fHF7fHV;fI6CfIFGfIVKfIfOfJFWfJV[fJf_fK6cfKVkfKfof
L73fLG7fLW;fM7CfMGGfMWKfMgOfNGWfNW[fNg_fO7cfOGgfOgofP83fPH7f
PX;fQ8CfQHGfQXKfQhOfRHWfRX[fRh_fS8cfSHgfShofT93fTI7fTY;fU9Cf
UIGfUYKfUiOfVIWfVY[fVi_fW9cfWIgfWiofX:3fXJ7fXZ;fY:CfYJGfYZKf
YjOfZJWfZZ[fZj_f[:cf[Jgf[jof/;3f/K7f/[;f];Cf]KGf][Kf]kOf^KWf
^[[f^k_f_;cf_Kgf_kof`<3f`L7f`/;fa<CfaLGfa/KfalOfbLWfb/[fbl_f
c<cfcLgfclofd=3fdM7fd];fe=CfeMGfe]KfemOffMWff][ffm_fg=cfgMgf
gmofh>3fhN7fh^;fi>CfiNGfi^KfinOfjNWfj^[fjn_fk>cfkNgfknofl?3f
lO7fl_;fm?CfmOD6c<c<200000c<c<`@ocH02lc<c003IVIVooooc<c<00@0
0002c<c<00=VIVKoooo<c<`01<c<c0800003c<c<0P0000_<c<`00hj>SV=S
HfIVIP0Goooo00D0003oooooooooool000000_ooo`04IVIVooooc<c<oooo
3<c<c004VIVIIVIVoooooooo;<c<c004IVIVR<2hR<2hB9280@00000000F8
`;S8h=R8`;R8`;Soool0:lc<c038m`00m`41m`82m`@4m`D5m`H6m`L7m`T9
m`X:m`/;m``<m`h>m`l?ma0@ma4Ama<Cma@DmaDEmaHFmaLGmaTImaXJma/K
ma`LmahNmalOmb0Pmb4Qmb<Smb@TmbDUmbHVmbPXmbTYmbXZmb/[mbd]mbh^
mbl_mc0`mc4amc<cmc@dmcDemcHfmcPhmcTimcXjmc/kmcdmmchnmclomd10
md92md=3mdA4mdE5mdI6mdQ8mdU9mdY:md];mde=mdi>mdm?me1@me9Bme=C
meADmeEEmeMGmeQHmeUImeYJmeaLmeeMmeiNmemOmf1Pmf9Rmf=SmfATmfEU
mfMWmfQXmfUYmfYZmfa/mfe]mfi^mfm_mg5amg9bmg=cmgAdmgEemgMgmgQh
mgUimgYjmgalmgemmginmgmomh61mh:2mh>3mhB4mhJ6mhN7mhR8mhV9mh^;
mhb<mhf=mhj>mhn?mi6Ami:Bmi>CmiBDmiJFmiNGmiRHmiVImi^KmibLmifM
mijNmj2Pmj6Qmj:Rmj>SmjBTmjJVmjNWmjRXmjVYmj^[mjb/mjf]mjj^mk2`
mk6amk:bmk>cmkFemkJfmkNgmkRhmkZjmk^kmkblmkfmmkjnml30ml71ml;2
ml?3mlG5mlK6mlO7mlS8ml[:ml_;mlc<mlg=mlo?mm3@mm7Amm;Bmm?CmmGE
mmKFmmOGmmSHmm[Jmm_KmmcLmmgMmmoOmn3Pmn7Qmn;RmnCTmnGUmnKVmnOW
mnWYmn[Zmn_[mnc/mng]mno_mo3`mo7amo;bmoCdmoGemoKf1Lc<c0030000
ooooc<c<00K<c<`00`000<c<c<c<c009c<c<4?l^00_<c<`00fIVI_oooooo
o`04c<c<0_ooo`03IVIVooooc<c<00C<c<`200000lc<c080000;c<c<00>>
SXiSHf=VIVH06?ooo`<00003oooo00AVIVKoooo<c<coool<c<c<00BIVIUV
IVKoooooool/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0
^?ooo`0[c<c<0<Si003i0@7i0P;i10Ci1@Gi1PKi1`Oi2@Wi2P[i2`_i30ci
3Pki3`oi413i4A7i4a?i51Ci5AGi5QKi61Si6AWi6Q[i6a_i7Agi7Qki7aoi
823i8R;i8b?i92Ci9BGi9bOi:2Si:BWi:R[i;2ci;Bgi;Rki;boi<33i<S;i
<c?i=3Ci=CGi=cOi>3Si>CWi>S[i?3ci?Cgi?Ski?coi@D7i@T;i@d?iA4Ci
ATKiAdOiB4SiBDWiBd_iC4ciCDgiCTkiD53iDE7iDU;iDe?iEEGiEUKiEeOi
F5SiFU[iFe_iG5ciGEgiGUkiH63iHF7iHV;iHf?iIFGiIVKiIfOiJ6SiJV[i
Jf_iK6ciKFgiKfoiL73iLG7iLW;iM7CiMGGiMWKiMgOiNGWiNW[iNg_iO7ci
OWkiOgoiP83iPH7iPh?iQ8CiQHGiQXKiR8SiRHWiRX[iRh_iS8ciSXkiShoi
T93iTI7iTi?iU9CiUIGiUYKiV9SiVIWiVY[iVi_iWIgiWYkiWioiX:3iXZ;i
Xj?iY:CiYJGiYjOiZ:SiZJWiZZ[i[:ci[Jgi[Zki[joi/K7i/[;i/k?i];Ci
]KGi]kOi^;Si^KWi^[[i_;ci_Kgi_[ki_koi`L7i`/;i`l?ia<Cia/KialOi
b<SibLWibl_ic<cicLgic/kid=3idM7id];idm?ieMGie]KiemOif=Sif][i
fm_ig=cigMgigmoih>3ihN7ih^;ihn?iiNGii^KiinOij>Sij^[ijn_ik>ci
kNgiknoil?3ilO7il_;im?CimOGim_KimoL5c<c<00<0003oooo<c<`01lc<
c0030000c<c<c<c<00S<c<`@obH03<c<c09VIVH4oooo0VIVIP03ooooc<c<
c<c<01K<c<`00hj>SV=SHfIVIP0Noooo00AVIVKoooo<c<coool4c<c<0fIV
IPG<c<`019VIVFIVI_ooooooobc<c<`016IVIXS0^8S0^4R@R04000000005
R<2hb>3HR<2hR<2hoooo02_<c<`0b?X00?X10OX20_X41?X51OX61_X71oX9
2OX:2_X;2oX<3?X>3_X?3oX@4?XA4OXC4oXD5?XE5OXF5_XH6?XI6OXJ6_XK
6oXM7OXN7_XO7oXP8?XR8_XS8oXT9?XU9OXW9oXX:?XY:OXZ:_X/;?X];OX^
;_X_;oXa<OXb<_Xc<oXd=?Xf=_Xg=oXh>?Xi>OXk>oXl??Xm?OXn?_Y0@?Y1
@OY2@_Y3@oY5AOY6A_Y7AoY8B?Y:B_Y;BoY<C?Y=COY?CoY@D?YADOYBD_YD
E?YEEOYFE_YGEoYIFOYJF_YKFoYLG?YNG_YOGoYPH?YQHOYSHoYTI?YUIOYV
I_YXJ?YYJOYZJ_Y[JoY]KOY^K_Y_KoY`L?YbL_YcLoYdM?YeMOYgMoYhN?Yi
NOYjN_YlO?YmOOYnO_YoOoZ1POZ2P_Z3PoZ4Q?Z6Q_Z7QoZ8R?Z9ROZ;RoZ<
S?Z=SOZ>S_Z@T?ZATOZBT_ZCToZEUOZFU_ZGUoZHV?ZJV_ZKVoZLW?ZMWOZO
WoZPX?ZQXOZRX_ZTY?ZUYOZVY_ZWYoZYZOZZZ_Z[ZoZ/[?Z^[_Z_[oZ`/?Za
/OZc/oZd]?Ze]OZf]_Zh^?Zi^OZj^_Zk^oZm_OZn__Zo_o[0`?[2`_[3`o[4
a?[5aO[7ao[8b?[9bO[:b_[<c?[=cO[>c_[?co[AdO[Bd_[Cdo[De?[Fe_[G
eo[Hf?[IfO[Kfo[Lg?[MgO[Ng_[Ph?[QhO[Rh_[Sho[UiO[Vi_[Wio[Xj?[Z
j_[[jo[/k?[]kO[_ko[`l?[alO[bl_[dm?[emO[fm_[gmo[in@G<c<`01000
0?ooolc<c00000?<c<`01@000<c<c<c<c<c<c0000009c<c<4?lO00k<c<`4
IVIV6lc<c003SXj>Hf=SIVIV01koool016IVI_ooolc<c?ooo`G<c<`00fIV
I/c<c<c<c004c<c<00BIVIUVIVKoooooool/c<c<00AVIVJ8`;R8`;Q8T8P1
000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0<Sk003k0@7k0`?k10Ck1@Gk
1PKk20Sk2@Wk2P[k2`_k3@gk3Pkk3`ok413k4Q;k4a?k51Ck5AGk5aOk61Sk
6AWk6Q[k71ck7Agk7Qkk7aok8B7k8R;k8b?k92Ck9RKk9bOk:2Sk:BWk:b_k
;2ck;Bgk;Rkk<33k<C7k<S;k<c?k=CGk=SKk=cOk>CWk>S[k>c_k?3ck?Skk
?cok@43k@D7k@d?kA4CkADGkATKkB4SkBDWkBT[kBd_kCDgkCTkkCdokD53k
DU;kDe?kE5CkEEGkEeOkF5SkFEWkFU[kG5ckGEgkGUkkGeokHF7kHV;kHf?k
I6CkIVKkIfOkJ6SkJFWkJf_kK6ckKFgkKfokL73kLG7kLW;kM7CkMGGkMWKk
MgOkNGWkNW[kNg_kO7ckOWkkOgokP83kPH7kPh?kQ8CkQHGkQXKkR8SkRHWk
RX[kRh_kSHgkSXkkShokT93kTY;kTi?kU9CkUIGkUiOkV9SkVIWkVY[kW9ck
WIgkWYkkWiokXJ7kXZ;kXj?kYJGkYZKkYjOkZ:SkZZ[kZj_k[:ck[Jgk[jok
/;3k/K7k/[;k];Ck]KGk][Kk]kOk^KWk^[[k^k_k_;ck_[kk_kok`<3k`L7k
`l?ka<CkaLGka/Kkb<SkbLWkb/[kbl_kcLgkc/kkclokd=3kd];kdm?ke=Ck
eMGkemOkf=SkfMWkfm_kg=ckgMgkg]kkh>3khN7kh^;khn?kiNGki^KkinOk
j>Skj^[kjn_kk>ckkNgkknokl?3klO7kl_;km?CkmOGkm_KkmoOknOWkn_X5
c<c<00<0003oooooool00lc<c003ooooc<c<c<c<00?<c<`00`000<c<c<c<
c006c<c<4?lG02g<c<`00hj>SV=SHfIVIP0Noooo00AVIVKoooo<c<coool<
c<c<00BIVIUVIVKoooooool/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0
^<SPf8S0^8S0^?ooo`0[c<c<0<Sl003l0@7l0`?l10Cl1@Gl1PKl20Sl2@Wl
2P[l2`_l3@gl3Pkl3`ol413l4Q;l4a?l51Cl5AGl5aOl61Sl6AWl6a_l71cl
7Agl7Qkl823l8B7l8R;l8b?l9BGl9RKl9bOl:2Sl:R[l:b_l;2cl;Bgl;bol
<33l<C7l<S;l=3Cl=CGl=SKl>3Sl>CWl>S[l>c_l?Cgl?Skl?col@43l@T;l
@d?lA4ClADGlAdOlB4SlBDWlBT[lC4clCDglCTklD53lDE7lDU;lDe?lEEGl
EUKlEeOlF5SlFU[lFe_lG5clGEglGeolH63lHF7lHV;lI6ClIFGlIVKlJ6Sl
JFWlJV[lJf_lKFglKVklKfolL73lLW;lLg?lM7ClMGGlMgOlN7SlNGWlNW[l
O7clOGglOWklOgolPH7lPX;lPh?lQHGlQXKlQhOlR8SlRX[lRh_lS8clSHgl
SholT93lTI7lTY;lU9ClUIGlUYKlUiOlVIWlVY[lVi_lWIglWYklWiolX:3l
XZ;lXj?lY:ClYJGlYjOlZ:SlZJWlZZ[l[:cl[Jgl[Zkl[jol/K7l/[;l/k?l
]KGl][Kl]kOl^;Sl^[[l^k_l_;cl_Kgl_kol`<3l`L7l`/;la<ClaLGla/Kl
alOlbLWlb/[lbl_lc<clc/klclold=3ld];ldm?le=CleMGlemOlf=SlfMWl
f][lg=clgMglg]klgmolhN7lh^;lhn?li>Cli^KlinOlj>Slj^[ljn_lk>cl
kNglknoll?3llO7ll_;lm?ClmOGlm_KlmoOlnOWln_[lno/5c<c<00<0003o
ooo<c<`00/c<c0030000c<c<c<c<00G<c<`00`000<c<c<c<c005c<c<4?l?
02g<c<`00hj>SV=SHfIVIP0Noooo00AVIVKoooo<c<coool<c<c<00BIVIUV
IVKoooooool/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0
^?ooo`0[c<c<0<Sn003n0@7n0`?n10Cn1@Gn1PKn20Sn2@Wn2P[n2`_n3@gn
3Pkn3`on413n4Q;n4a?n51Cn5QKn5aOn61Sn6AWn6a_n71cn7Agn7Qkn823n
8B7n8R;n92Cn9BGn9RKn9bOn:BWn:R[n:b_n;2cn;Rkn;bon<33n<C7n<c?n
=3Cn=CGn=cOn>3Sn>CWn>S[n?3cn?Cgn?Skn?con@D7n@T;n@d?nADGnATKn
AdOnB4SnBT[nBd_nC4cnCDgnCdonD53nDE7nDU;nE5CnEEGnEUKnF5SnFEWn
FU[nFe_nGEgnGUknGeonH63nHV;nHf?nI6CnIFGnIfOnJ6SnJFWnJf_nK6cn
KFgnKVknL73nLG7nLW;nLg?nMGGnMWKnMgOnNGWnNW[nNg_nO7cnOWknOgon
P83nPH7nPh?nQ8CnQHGnQXKnR8SnRHWnRX[nS8cnSHgnSXknShonTI7nTY;n
Ti?nU9CnUYKnUiOnV9SnVY[nVi_nW9cnWIgnWionX:3nXJ7nXZ;nY:CnYJGn
YZKnYjOnZJWnZZ[nZj_n[Jgn[Zkn[jon/;3n/[;n/k?n];Cn]KGn]kOn^;Sn
^KWn^[[n_;cn_Kgn_[kn`<3n`L7n`/;n`l?naLGna/KnalOnb<Snb/[nbl_n
c<cnc/knclond=3ndM7ndm?ne=CneMGne]Knf=SnfMWnf][nfm_ngMgng]kn
gmonhN7nh^;nhn?ni>Cni^KninOnj>SnjNWnjn_nk>cnkNgnknonl?3nlO7n
l_;nm?CnmOGnm_KnmoOnnOWnn_[nno_no?`5c<c<00D0003oooo<c<c<c<co
ool02Lc<c0030000c<c<c<c<00C<c<`@o`P0;Lc<c003SXj>Hf=SIVIV01ko
ool00lc<c?ooolc<c00=oooo00BIVIUVIVKoooooool/c<c<00AVIVJ8`;R8
`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`0[c<c<0<So003o0@7o0`?o
10Co1@Go1PKo20So2@Wo2P[o2`_o3@go3Pko3`oo4A7o4Q;o4a?o51Co5QKo
5aOo61So6Q[o6a_o71co7Ago7aoo823o8B7o8R;o92Co9BGo9RKo:2So:BWo
:R[o:b_o;Bgo;Rko;boo<33o<S;o<c?o=3Co=SKo=cOo>3So>CWo>c_o?3co
?Cgo?Sko@43o@D7o@T;oA4CoADGoATKoAdOoBDWoBT[oBd_oCDgoCTkoCdoo
D53oDU;oDe?oE5CoEEGoEeOoF5SoFEWoFe_oG5coGEgoGUkoH63oHF7oHV;o
Hf?oIFGoIVKoIfOoJFWoJV[oJf_oK6coKVkoKfooL73oLG7oLg?oM7CoMGGo
MgOoN7SoNGWoNW[oO7coOGgoOWkoP83oPH7oPX;oPh?oQHGoQXKoQhOoR8So
RX[oRh_oS8coSXkoShooT93oTI7oTi?oU9CoUIGoUYKoV9SoVIWoVY[oW9co
WIgoWYkoWiooXJ7oXZ;oXj?oY:CoYZKoYjOoZ:SoZZ[oZj_o[:co[Jgo[joo
/;3o/K7o/k?o];Co]KGo][Ko^;So^KWo^[[o^k_o_Kgo_[ko_koo`L7o`/;o
`l?oa<Coa/KoalOob<SobLWobl_oc<cocLgoclood=3odM7od];oe=CoeMGo
e]KoemOofMWof][ofm_ogMgog]kogmooh>3oh^;ohn?oi>Coi^KoinOoj>So
jNWojn_ok>cokNgok^kol?3olO7ol_;om?ComOGom_KomoOonOWon_[ono_o
o?coo_h5c<c<00@0003oooo<c<`00003c<c<00<0003<c<c<c<`01Lc<c003
0000c<c<c<c<00?<c<`@o`00;Lc<c003SXj>Hf=SIVIV01mVIVH@c<c<00=V
IVKoooooool0;<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8
`;Soool0n<c<c0030000oooooooo00?<c<`00oooolc<c<c<c005c<c<00<0
003<c<c<c<`0@Lc<c003SXj>Hf=SHf=S035SHf<00oooolc<c<c<c00Zc<c<
00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?ooo`3hc<c<00<0
003oooo<c<`00/c<c0030000c<c<c<c<00G<c<`00`000<c<c<c<c012c<c<
=Hj>SRc<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2hR<2hoooo
0?S<c<`01@000?ooolc<c<c<c?ooo`07c<c<00<0003<c<c<c<`0Y<c<c004
IVIVR<2hR<2hB9280@00000000F8`;S8h=R8`;R8`;Soool0n<c<c0040000
ooooc<c<00000lc<c0050000c<c<c<c<c<c<00000:O<c<`016IVIXS0^8S0
^4R@R04000000005R<2hb>3HR<2hR<2hoooo0?S<c<`00`000?ooooooo`03
c<c<00Goooo<c<c<c<c<c<`00000Z<c<c004IVIVR<2hR<2hB9280@000000
00F8`;S8h=R8`;R8`;Soool0n<c<c0030000oooooooo00Koool00`000<c<
c<c<c02Wc<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0^8S0^?oo
o`3ic<c<20000:[<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hoooo0?o<c<b/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SPf8S0
^8S0^?ooo`3oc<c<[<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8h=R8
`;R8`;Soool0olc<c:c<c<`016IVIXS0^8S0^4R@R04000000005R<2hb>3H
R<2hR<2hoooo0?o<c<b/c<c<00AVIVJ8`;R8`;Q8T8P1000000001HS0^<SP
f8S0^8S0^?ooo`3oc<c<[<c<c004IVIVR<2hR<2hB9280@00000000F8`;S8
h=R8`;R8`;Soool0olc<c:c<c<`016IVIXS0^8S0^4R@R04000000004R<2h
b>3HR<2hR<2hC?ooob_<c<cooooo=_ooo`04IVIVR<2hR<2hB9280@000000
00B8`;S8h=R8`;R8`;P2c<c<00=VIVK<c<bIVIT0AIVIV@03IVIVooooc<c<
02[<c<`00fIVI/c<c9VIV@0YVIVI00=VIVK<c<c<c<`0olc<c0S<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVIVc<c<VIVI04FIVIT0
0fIVI_ooofIVV@0ZIVJI00=VIVK<c<bIVIT0:IVIV@03IVIVc<c<c<c<0?o<
c<`8c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVI/c<
c9VIV@08VIVI3@00032IVIT00fIVI_ooofIVV@07c<c<200001[<c<`00fIV
VFIVI/c<c00@VIVI200001:IVIT00fIVI/c<c<c<c03oc<c<2<c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIVK<c<bIVIT0AIVIV@03
IVIVooooIVJI02W<c<`00fIVVFIVI/c<c00ZVIVI00=VIVK<c<c<c<`0olc<
c0S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVIVc<c<
VIVI00bIVIT200002IVIV@030000VIVIVIVI00ZIVIT00`0009VIVIVIV@09
VIVI00<0002IVIVIVIT04YVIV@03IVIVooooIVJI02W<c<`00fIVVFIVI/c<
c00ZVIVI00=VIVK<c<c<c<`0olc<c0S<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0/c<c003IVIVc<c<VIVI00fIVIT300001iVIV@D00008VIVI
100000NIVIT300000YVIV@<0000>VIVI00=VIVKooomVIYT01lc<c0800003
c<c<0P0000;<c<`500000/c<c0H0000<c<c<00=VIYUVIVK<c<`029VIV@80
0004VIVI0P0000:IVIT400000YVIV@H0000<VIVI00=VIVK<c<c<c<`0olc<
c0S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVIVc<c<
VIVI00jIVIT300002IVIV@@00008VIVI0`0000NIVIT200000YVIV@@0000=
VIVI00=VIVKooomVIYT01lc<c0800003c<c<0P000003c<c<0000000000?<
c<`2000000?<c<`0000000000lc<c080000;c<c<00=VIYUVIVK<c<`029VI
V@800003VIVI0P0000:IVIT200000YVIV@8000000iVIV@0000000003VIVI
0P0000^IVIT00fIVI/c<c<c<c03oc<c<2<c<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2c<c<00=VIVK<c<bIVIT03iVIV@80000;VIVI0`0000VI
VIT200001iVIV@80000019VIV@00000009VIV@<0000;VIVI00=VIVKooomV
IYT01lc<c0800003c<c<0P0000K<c<`2000000?<c<`0000000000lc<c080
000;c<c<00=VIYUVIVK<c<`029VIV@800003VIVI0P000003VIVI00000000
00>IVIT2000000>IVIT0000000000iVIV@80000;VIVI00=VIVK<c<c<c<`0
olc<c0S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0/c<c003IVIV
c<c<VIVI00^IVIT200000YVIV@80000<VIVI0`0000VIVIT200001YVIV@80
00000iVIV@0000000002VIVI0P0000^IVIT00fIVI_ooofIVV@07c<c<0P00
00?<c<`200001<c<c0@000000lc<c00000000003c<c<0P0000_<c<`00fIV
VFIVI/c<c008VIVI0P0000:IVIT200000YVIV@800003VIVI0P000003VIVI
0000000000>IVIT200002iVIV@03IVIVc<c<c<c<0?o<c<`8c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVI/c<c9VIV@0;VIVI0P00
00>IVIT2000039VIV@<00008VIVI0`0000FIVIT2000000>IVIT000000000
0iVIV@030000VIVIVIVI00VIVIT00fIVI_ooofIVV@07c<c<1`0000;<c<`5
00000/c<c0H0000<c<c<00=VIYUVIVK<c<`029VIV@H00002VIVI0P0000:I
VIT3000000>IVIT000000000100000bIVIT00fIVI/c<c<c<c03oc<c<2<c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2c<c<00=VIVK<c<bIVIT0
2IVIV@/00005VIVI0P0000BIVIT200002IVIV@800005VIVI0P000003VIVI
0000000000nIVIT00fIVI_ooofIVV@07c<c<0P0000?<c<`2000000?<c<`0
000000000P0000C<c<`200000lc<c080000;c<c<00=VIYUVIVK<c<`029VI
V@800003VIVI0P000003VIVI0000000000JIVIT200000iVIV@80000;VIVI
00=VIVK<c<c<c<`0olc<c0S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0/c<c003IVIVc<c<VIVI00^IVIT200000YVIV@800007VIVI0`0000BI
VIT00`0009VIVIVIV@08VIVI0P0000FIVIT2000000>IVIT0000000003iVI
V@03IVIVooooIVJI00O<c<`200000lc<c08000000lc<c00000000006c<c<
0P0000?<c<`200002lc<c003IVJIIVIVc<c<00RIVIT200000iVIV@800000
0iVIV@0000000006VIVI0P0000>IVIT200002iVIV@03IVIVc<c<c<c<0?o<
c<`8c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0;<c<`00fIVI/c<
c9VIV@0;VIVI0P0000:IVIT200001YVIV@<00009VIVI2@0000FIVIT20000
00>IVIT0000000003iVIV@03IVIVooooIVJI00O<c<`200000lc<c0800000
0lc<c00000000003c<c<0P000003c<c<0000000000?<c<`200002lc<c003
IVJIIVIVc<c<00RIVIT200000iVIV@800002VIVI0P0000:IVIT2000000>I
VIT0000000000iVIV@80000;VIVI00=VIVK<c<c<c<`0olc<c0S<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0lc<c003IVIVc<c<VIVI00ZIVIT3
000000BIVIT0000000000006VIVI00<0002IVIVIVIT03iVIV@@0000GVIVI
0VIVIP03ooooIVJIc<c<00G<c<`200000lc<c0800002c<c<1@0000;<c<`6
00003<c<c004IVJIIVIVIVIVc<c<1iVIV@H00004VIVI100000:IVIT60000
39VIV@03IVIVc<c<c<c<0?o<c<`8c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0C<c<`00fIVI/c<c9VIV@0XVIVI100001NIVIT01FIVI/c<c6IV
I_ooofIVV@0Wc<c<00EVIYUVIVK<c<aVIVK<c<`0:9VIV@03IVIVc<c<c<c<
0?o<c<`8c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0G<c<`00fIV
I/c<c9VIV@12VIVI00IVIVK<c<c<c<aVIVKooomVIYTVc<c<00IVIYUVIVK<
c<c<c<aVIVK<c<`WVIVI00=VIVK<c<c<c<`0olc<c0S<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h1/c<c003IVIVc<c<VIVI046IVIT01VIVI/c<
c<c<c<c<c6IVI_ooobMVIYT01VIVI/c<c<c<c<c<c6IVI/c<c2JIVIT00fIV
I/c<c<c<c03oc<c<2<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P7
c<c<00=VIVK<c<c<c<`0@<c<c003IVIVc<c<c<c<00;<c<`00fIVI_oooooo
o`0Uoooo00=VIVK<c<c<c<`00/c<c003IVIVc<c<c<c<0?o<c<`_c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0S<c<a3IVIV1Lc<c2QVIVH5c<c<
9fIVI_o<c<`:c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<b^
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<b^c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<b^c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?o<c<b^c<c<0XS0^058T8P1000000000hS0^<SPf8S0
^03oR<2h/HS0^058T8P10000000018S0^<SPf8S0^8S0^1@0080200600P02
P0800h4200B10P05P@801X801007PP47PP48PP48P`812H<20@Z300@12h<1
2h@138@138@20@f40P4>Q@823hD20Q250P8AQP824XH20Q>60P8DQ`825HL0
108FQ`<FR0<GR0<GR08368P010<IR0<IR@<JR@<JR@836hT20ab:0P<MRP84
7XX211n;0P@PR`04126;126<12:<12:<0P@SS00412B<12B=12F=1BF=0PDV
S@041BN=1BN>1BR>1BR>0PDYSP85:Xl21B^?0PD/S`86;I021Rj@00@6;i06
;i46<946<9421S6A00H6<Y46<Y86<i86<i86=987=9821cFC0PLfT`87=i<2
1cRD0PLiU087>Y@21c^E00<8?9D8?ID8?ID00PPnUP88?iH2242F0PQ1U`88
@YL010Q3U`U3V0U4V0U4V089AIP010U6V0U6V@U7V@U7V@89B9T010U9V@U9
VPU:VPU:VP8:BiX22TbK0PY=V`8:CY/22TnL0PY@W0042U6L2U6M2U:M2e:M
0P]CW@042eBM2eBN2eFN2eFN0P]FWP8;Eil22eRO0P]IW`8<FZ0235^P0PaL
X08<GJ4235jQ00P<Gj4<Gj8<H:8<H:8<HJ8=HJ8=HZ8=HZ<23F>S0PeTX`8=
IJ@23FJT0PeWY08=J:D23VVU00@>JZD>JZH>JjH>JjH23VbV00@>KJH>KJL>
KZL>KZL23VnW00@>L:L?L:P?LJP?LJP23g:X0PmcZ@8?M:T23gFY0PmfZP8?
MjX00a1hZQ1iZa1iZ`0247Z[0Q1kZ`8@O:`247f/0Q1n[00647n]4Gn]4H2]
4H2]4H6]4H6^0Q62[P8APjh01164[Q64[a65[a65[`8AQZl24XN`0Q:8/08B
RK024XZa0Q:;/@084Xba4Xbb4Xfb4Xfb4Xjb4hjb4hnb4hnc0Q>@/`8CTK<0
11>B/a>B]1>C]1>C]08CU;@24iFe0QBF]@8DUkD259Rf0QBI]P0459Zf59Zg
59^g59^g0QBL]`0459fg5Ifh5Ijh5Ijh0QFO^08EX;T25J6i0QFR^@8EXkX2
5JBj0QJU^P8FY[/25ZNk00@FZ;/FZ;`FZK`FZK`25ZZl00@FZk`FZkdF[;dG
[;d25jfm0QN^_P8G[kh25k2n0QNa_`8G/[l00aNc_aRd`1Rd`00d6;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0@008000i^WlC=3YC=3Y@09<d>U
1000P0800H0200:00P03P@80184200F10P06PP0400N20@N20@R20@R30P49
P`812X<0104;P`4;Q04<Q04<Q0813H@20@j50P8?Q@8248D20Q660P8BQP82
4hH20QB70P8EQ`040QJ70aJ80aN80aN80P<HR0040aV80aV90aZ90aZ90P<K
R@8378X20af:0P@NRP847h/2122;00@48H/48H`48X`48X`212><00@498`4
98d49Hd59Hd21BJ=00@59hd59hh5:8h5:8h21BV>0PDZS`85:hl21Bb?0PH]
T086;Y0010H_T0H_T@H`T@H`T@86<I401PHbT@HbTPHcTPHcTPHdTPLdTP87
=I<21cJC0PLgT`87>9@21cVD0PLjU087>iD00`PlU@PmU@PmU@0223jF0PPo
UP88@9H2246G0PQ2U`0424>G2D>H2DBH2DBH0PU5V0042DJH2DJI2DNI2DNI
0PU8V@042DVI2DVJ2DZJ2DZJ0PY;VP8:C9/22TfK0PY>V`8:Ci`22U2L00@:
DI`:DId:DYd;DYd22e>M00@;E9d;E9h;EIh;EIh22eJN0P]GW`8;F9l22eVO
0PaJX08<Fj0235bP0PaMX@8<GZ4020aOX@aOXPaPXPaPXPaQXPeQXPeRXPeR
X`8=Hj<23FBS0PeUY08=IZ@23FNT0PeXY@8>JJD010iZY@iZYPi[YPi[YP8>
K:H010i]YPi]Y`i^Y`i^Y`8>KjL010i`Y`m`Z0maZ0maZ08?LZP23g>Y0Pmd
Z@8?MJT23gJZ0PmgZP0347RZ47V[47V[008@NZ/247^[0Q1l[08@OJ`247j/
00H@OjdAOjdAP:dAP:dAPJdAPJh24H:^0Q63[P044HB^4HB_4HF_4HF_0Q66
[`8BQk024XR`0Q:9/08BR[424X^a00PBS;4BS;8BSK8BSK8BS[8CS[8CSk8C
Sk<24i2c0Q>A/`044i:c4i:d4i>d4i>d0Q>D]08CUKD259Je0QBG]@8DV;H2
59Vf00@DV[HDV[LDVkLDVkL259bg00@DWKLEWKPEW[PEW[P25Inh0QFP^@8E
XKT25J:i0QFS^P8EY;X25ZFj0QJV^`8FYk/011JX^aJX_1JY_1JY_08FZ[`0
11J[_1J[_AJ/_AN/_@8G[Kd25jjn0QN__P8G/;h25k6o0QNb_`035k>o6;C0
6;C003@H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P007VjOa
ooooSWZfYY_4/jWBZ9g8/jWB00:VVl@01KbhgNk^m>[YlOoooc=3Y@030020
0P01P0800X0200>10P04P@801H4200J200@01h811h81288128<20@V30P4:
P`040@^30@^40@b40@b40P4=Q0813XD20Pn50P8@Q@824HH20Q:60P8CQP82
58L20QF700@25XL35XP35hP35hP20aR800@36HP36HT36XT36XT20a^90P<L
RP837HX211j:0P@OR`8488/010@QR`@QS0@RS0@RS0848h`010@TS0@TS@@U
S@DUS@859Xd010DWS@DWSPDXSPDXSP85:Hh21BZ?0PD[S`85;8l21Rf@0PH^
T0041Rn@1RnA1S2A1S2A0PHaT@061S:A1S:B1S>B1S>B1SBB1cBB0PLeT`87
=Y<21cNC0PLhU087>I@21cZD0PLkU@0323bE23fE23fE0088?YH223nF0PQ0
UP88@IL224:G00@8@iL9@iP9A9P9A9P22DFH00@9AYP9AYT9AiT9AiT22DRI
00@9BIT9BIX9BYX9BYX22T^J0PY<V`8:CI/22TjK0PY?W08:D9`010YAW0YA
W@YBW@]BW@8;Did010]DW@]DWP]EWP]EWP8;EYh22eNO0P]HW`8;FIl235ZP
0PaKX08<G:0235fQ0PaNX@0835nQ35nR362R362R366R3F6R3F:R3F:S0PeS
X`8=I:<23FFT0PeVY08=Ij@23FRU0PiYY@043VZU3VZV3V^V3V^V0Pi/YP04
3VfV3VfW3VjW3VjW0Pi_Y`043W2W3g2X3g6X3g6X0PmbZ08?LjT23gBY0Pme
Z@8?MZX23gNZ00<@N:X@NJ/@NJ/00Q1jZ`8@Nj/247b/0Q1m[08@OZ`01Q1o
[A5o[A60[A60[A61[A61[P8APZh24H>^00@AQ:hAQ:lAQJlAQJl24HJ_0Q:7
/08BR;024XV`0Q::/@8BRk4021:</A:</Q:=/Q:=/Q:>/Q>>/Q>?/Q>?/`8C
T;<24i6c00@CT[<CT[@CTk@CTk@24iBd0Q>E]@8DU[D259Ne0QBH]P8DVKH0
11BJ]QBJ]aBK]aBK]`8DW;L011BM]aFM^1FN^1FN^08EWkP25J2i0QFQ^@8E
X[T25J>j0QFT^P8FYKX25ZJk0QJW^`045ZRk5ZRl5ZVl5ZVl0QJZ_0045Z^l
5Z^m5Zbm5jbm0QN]_@8G[[h25jnn0QN`_P8G/Kl25k:o00<G/klH]<0H]<00
8000008H]<0@00000QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
002000BKYo7ooom/FZF_YLX2_;SM00[ooOncZM;ooooooonl^=fGR[bXWLSV
i^cooolc@jD200200P01P0800X0200>10P04P@801H4200J200@01h811h81
288128<20@V30P4:P`040@^30@^40@b40@b40P4=Q0813XD20Pn50P8@Q@82
4HH20Q:60P8CQP8258L20QF700@25XL35XP35hP35hP20aR800@36HP36HT3
6XT36XT20a^90P<LRP837HX211j:0P@OR`8488/010@QR`@QS0@RS0@RS084
8h`010@TS0@TS@@US@DUS@859Xd010DWS@DWSPDXSPDXSP85:Hh21BZ?0PD[
S`85;8l21Rf@0PH^T0041Rn@1RnA1S2A1S2A0PHaT@061S:A1S:B1S>B1S>B
1SBB1cBB0PLeT`87=Y<21cNC0PLhU087>I@21cZD0PLkU@0323bE23fE23fE
0088?YH223nF0PQ0UP88@IL224:G00@8@iL9@iP9A9P9A9P22DFH00@9AYP9
AYT9AiT9AiT22DRI00@9BIT9BIX9BYX9BYX22T^J0PY<V`8:CI/22TjK0PY?
W08:D9`010YAW0YAW@YBW@]BW@8;Did010]DW@]DWP]EWP]EWP8;EYh22eNO
0P]HW`8;FIl235ZP0PaKX08<G:0235fQ0PaNX@0835nQ35nR362R362R366R
3F6R3F:R3F:S0PeSX`8=I:<23FFT0PeVY08=Ij@23FRU0PiYY@043VZU3VZV
3V^V3V^V0Pi/YP043VfV3VfW3VjW3VjW0Pi_Y`043W2W3g2X3g6X3g6X0Pmb
Z08?LjT23gBY0PmeZ@8?MZX23gNZ00<@N:X@NJ/@NJ/00Q1jZ`8@Nj/247b/
0Q1m[08@OZ`01Q1o[A5o[A60[A60[A61[A61[P8APZh24H>^00@AQ:hAQ:lA
QJlAQJl24HJ_0Q:7/08BR;024XV`0Q::/@8BRk4021:</A:</Q:=/Q:=/Q:>
/Q>>/Q>?/Q>?/`8CT;<24i6c00@CT[<CT[@CTk@CTk@24iBd0Q>E]@8DU[D2
59Ne0QBH]P8DVKH011BJ]QBJ]aBK]aBK]`8DW;L011BM]aFM^1FN^1FN^08E
WkP25J2i0QFQ^@8EX[T25J>j0QFT^P8FYKX25ZJk0QJW^`045ZRk5ZRl5ZVl
5ZVl0QJZ_0045Z^l5Z^m5Zbm5jbm0QN]_@8G[[h25jnn0QN`_P8G/Kl25k:o
00@G/klH]<0H]<38h=P>B92800<00038h=Q8T8P03DR@R00400006;C06;C0
b>3H3TR@R00300006;C06;C000:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2002000^KYo7ooonXWLSoooncZM9PC9Z>N[IhIJjXWLSooooooOl00ooo
o`04<d>U0020002000200P01P0800X0200>10P04P@801H4200J200@01h81
1h81288128<20@V30P4:P`040@^30@^40@b40@b40P4=Q0813XD20Pn50P8@
Q@824HH20Q:60P8CQP8258L20QF700@25XL35XP35hP35hP20aR800@36HP3
6HT36XT36XT20a^90P<LRP837HX211j:0P@OR`8488/010@QR`@QS0@RS0@R
S0848h`010@TS0@TS@@US@DUS@859Xd010DWS@DWSPDXSPDXSP85:Hh21BZ?
0PD[S`85;8l21Rf@0PH^T0041Rn@1RnA1S2A1S2A0PHaT@061S:A1S:B1S>B
1S>B1SBB1cBB0PLeT`87=Y<21cNC0PLhU087>I@21cZD0PLkU@0323bE23fE
23fE0088?YH223nF0PQ0UP88@IL224:G00@8@iL9@iP9A9P9A9P22DFH00@9
AYP9AYT9AiT9AiT22DRI00@9BIT9BIX9BYX9BYX22T^J0PY<V`8:CI/22TjK
0PY?W08:D9`010YAW0YAW@YBW@]BW@8;Did010]DW@]DWP]EWP]EWP8;EYh2
2eNO0P]HW`8;FIl235ZP0PaKX08<G:0235fQ0PaNX@0835nQ35nR362R362R
366R3F6R3F:R3F:S0PeSX`8=I:<23FFT0PeVY08=Ij@23FRU0PiYY@043VZU
3VZV3V^V3V^V0Pi/YP043VfV3VfW3VjW3VjW0Pi_Y`043W2W3g2X3g6X3g6X
0PmbZ08?LjT23gBY0PmeZ@8?MZX23gNZ00<@N:X@NJ/@NJ/00Q1jZ`8@Nj/2
47b/0Q1m[08@OZ`01Q1o[A5o[A60[A60[A61[A61[P8APZh24H>^00@AQ:hA
Q:lAQJlAQJl24HJ_0Q:7/08BR;024XV`0Q::/@8BRk4021:</A:</Q:=/Q:=
/Q:>/Q>>/Q>?/Q>?/`8CT;<24i6c00@CT[<CT[@CTk@CTk@24iBd0Q>E]@8D
U[D259Ne0QBH]P8DVKH011BJ]QBJ]aBK]aBK]`8DW;L011BM]aFM^1FN^1FN
^08EWkP25J2i0QFQ^@8EX[T25J>j0QFT^P8FYKX25ZJk0QJW^`045ZRk5ZRl
5ZVl5ZVl0QJZ_0045Z^l5Z^m5Zbm5jbm0QN]_@8G[[h25jnn0QN`_P8G/Kl2
5k:o00@G/klH]<0H]<38h=P=R<2h00=8T8P00038h=P03HS0^005B9280000
6;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2002000jKYo7ooooooooKg>aPC9ZCQKZcZM:l^=ePC9ZI
SkjVVlC8`moooolc@jD400200P01P0?oool01003P@04P@04P@05P@?oool0
1007PP47PP48P_ooo`812H<3oooo00<12h@138Coool00P4=Q0813XD20Pn5
0P8@Q@040Q66oooooooooooo0P8CQP060QB7oooo0QF70QF70QJ7oooo0P<G
R0?oool00`<IR@<JR@<JR@03oooo00<378X37HX37HX00oooo`0311n;122;
122;00?oool01`@RS0@SS?ooo`@TS0@TS@@US@DUS@021BJ=00@59hd59hh5
:8h5:8h21BV>0PDZS`85:hl21Bb?0PH]T086;Y0010H_T0H_T@H`T@H`T@86
<I401PHbT@HbTPHcTPHcTPHdTPLdTP87=I<21cJC0PLgT`87>9@21cVD0PLj
U087>iD00`PlU@PmU@PmU@0223jF0PPoUP88@9H2246G0PQ2U`0424>G2D>H
2DBH2DBH0PU5V0042DJH2DJI2DNI2DNI0PU8V@042DVI2DVJ2DZJ2DZJ0PY;
VP8:C9/22TfK0PY>V`8:Ci`22U2L00@:DI`:DId:DYd;DYd22e>M00@;E9d;
E9h;EIh;EIh22eJN0P]GW`8;F9l22eVO0PaJX08<Fj0235bP0PaMX@8<GZ40
20aOX@aOXPaPXPaPXPaQXPeQXPeRXPeRX`8=Hj<23FBS0PeUY08=IZ@23FNT
0PeXY@8>JJD010iZY@iZYPi[YPi[YP8>K:H010i]YPi]Y`i^Y`i^Y`8>KjL0
10i`Y`m`Z0maZ0maZ08?LZP23g>Y0PmdZ@8?MJT23gJZ0PmgZP0347RZ47V[
47V[008@NZ/247^[0Q1l[08@OJ`247j/00H@OjdAOjdAP:dAP:dAPJdAPJh2
4H:^0Q63[P044HB^4HB_4HF_4HF_0Q66[`8BQk024XR`0Q:9/08BR[424X^a
00PBS;4BS;8BSK8BSK8BS[8CS[8CSk8CSk<24i2c0Q>A/`044i:c4i:d4i>d
4i>d0Q>D]08CUKD259Je0QBG]@8DV;H259Vf00@DV[HDV[LDVkLDVkL259bg
00@DWKLEWKPEW[PEW[P25Inh0QFP^@8EXKT25J:i0QFS^P8EY;X25ZFj0QJV
^`8FYk/011JX^aJX_1JY_1JY_08FZ[`011J[_1J[_AJ/_AN/_@8G[Kd25jjn
0QN__P8G/;h25k6o0QNb_`045k>o6;C06;C0b>3H0hS0^0H00004R<2h00=8
T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H]<38h=P03HS0^004
B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<00800
3Y^WlOoookbhgIV?__ooomKAgM_Lk??nojJKa>k^m8Ef/9>5^_oooc=3Y@<0
08001P01P?ooo`02P002P003POooo`8018402_ooo`05P@06PP06P_ooo`47
PP48P_ooo`49Poooo`812X<0104;Poooo`4<Q?ooo`813H@20@j50P8?Q@82
48D02?ooo`8AQP8BQP8BQ_ooo`8CQP8DQoooo`825HL0108FQoooo`<GR?oo
o`8368P010<IR?ooo`<JROooo`836hT010<LR_ooo`<MR_ooo`847XX03P@O
Roooo`@PRoooo`@QR`@QS0@RS?ooo`@SS?ooo`@TS0@TS@@US@DUS@859Xd0
10DWS@DWSPDXSPDXSP85:Hh21BZ?0PD[S`85;8l21Rf@0PH^T0041Rn@1RnA
1S2A1S2A0PHaT@061S:A1S:B1S>B1S>B1SBB1cBB0PLeT`87=Y<21cNC0PLh
U087>I@21cZD0PLkU@0323bE23fE23fE0088?YH223nF0PQ0UP88@IL224:G
00@8@iL9@iP9A9P9A9P22DFH00@9AYP9AYT9AiT9AiT22DRI00@9BIT9BIX9
BYX9BYX22T^J0PY<V`8:CI/22TjK0PY?W08:D9`010YAW0YAW@YBW@]BW@8;
Did010]DW@]DWP]EWP]EWP8;EYh22eNO0P]HW`8;FIl235ZP0PaKX08<G:02
35fQ0PaNX@0835nQ35nR362R362R366R3F6R3F:R3F:S0PeSX`8=I:<23FFT
0PeVY08=Ij@23FRU0PiYY@043VZU3VZV3V^V3V^V0Pi/YP043VfV3VfW3VjW
3VjW0Pi_Y`043W2W3g2X3g6X3g6X0PmbZ08?LjT23gBY0PmeZ@8?MZX23gNZ
00<@N:X@NJ/@NJ/00Q1jZ`8@Nj/247b/0Q1m[08@OZ`01Q1o[A5o[A60[A60
[A61[A61[P8APZh24H>^00@AQ:hAQ:lAQJlAQJl24HJ_0Q:7/08BR;024XV`
0Q::/@8BRk4021:</A:</Q:=/Q:=/Q:>/Q>>/Q>?/Q>?/`8CT;<24i6c00@C
T[<CT[@CTk@CTk@24iBd0Q>E]@8DU[D259Ne0QBH]P8DVKH011BJ]QBJ]aBK
]aBK]`8DW;L011BM]aFM^1FN^1FN^08EWkP25J2i0QFQ^@8EX[T25J>j0QFT
^P8FYKX25ZJk0QJW^`045ZRk5ZRl5ZVl5ZVl0QJZ_0045Z^l5Z^m5Zbm5jbm
0QN]_@8G[[h25jnn0QN`_P8G/Kl25k:o00@G/klH]<0H]<38h=P3R<2h1P00
00B8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2h
R<2hB9280000008H]<001<SPf8S0^8S0^8S0^0800004R<2h0P0000:8`;P0
14R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P30020
00nKYo7ooonISkjGR[cDdnS_[;?oMW_^Wj]KF:FVVlBFWm9PC9Zl^=gooolc
@jD00P00P004oooo006000:000:00P03P@04oooo00B1oooo00F10P06PP06
oooo0@N20@R2oooo0@V3oooo0P4:P`040@^3oooo0@b4oooo0P4=Q0813XD2
0Pn500@248Goool24HH24HH20Q:600@24hKoool258Ooool20QF700@25XOo
ool35hSoool20aR800@36HSoool36XWoool20a^900D378[oool37HX37HX4
7XX00_ooo`0511n;122;oooo126;126<00848X`01P@SS?ooo`@TS0@TS@@U
S@DUS@859Xd010DWS@DWSPDXSPDXSP85:Hh21BZ?0PD[S`85;8l21Rf@0PH^
T0041Rn@1RnA1S2A1S2A0PHaT@061S:A1S:B1S>B1S>B1SBB1cBB0PLeT`87
=Y<21cNC0PLhU087>I@21cZD0PLkU@0323bE23fE23fE0088?YH223nF0PQ0
UP88@IL224:G00@8@iL9@iP9A9P9A9P22DFH00@9AYP9AYT9AiT9AiT22DRI
00@9BIT9BIX9BYX9BYX22T^J0PY<V`8:CI/22TjK0PY?W08:D9`010YAW0YA
W@YBW@]BW@8;Did010]DW@]DWP]EWP]EWP8;EYh22eNO0P]HW`8;FIl235ZP
0PaKX08<G:0235fQ0PaNX@0835nQ35nR362R362R366R3F6R3F:R3F:S0PeS
X`8=I:<23FFT0PeVY08=Ij@23FRU0PiYY@043VZU3VZV3V^V3V^V0Pi/YP04
3VfV3VfW3VjW3VjW0Pi_Y`043W2W3g2X3g6X3g6X0PmbZ08?LjT23gBY0Pme
Z@8?MZX23gNZ00<@N:X@NJ/@NJ/00Q1jZ`8@Nj/247b/0Q1m[08@OZ`01Q1o
[A5o[A60[A60[A61[A61[P8APZh24H>^00@AQ:hAQ:lAQJlAQJl24HJ_0Q:7
/08BR;024XV`0Q::/@8BRk4021:</A:</Q:=/Q:=/Q:>/Q>>/Q>?/Q>?/`8C
T;<24i6c00@CT[<CT[@CTk@CTk@24iBd0Q>E]@8DU[D259Ne0QBH]P8DVKH0
11BJ]QBJ]aBK]aBK]`8DW;L011BM]aFM^1FN^1FN^08EWkP25J2i0QFQ^@8E
X[T25J>j0QFT^P8FYKX25ZJk0QJW^`045ZRk5ZRl5ZVl5ZVl0QJZ_0045Z^l
5Z^m5Zbm5jbm0QN]_@8G[[h25jnn0QN`_P8G/Kl25k:o00@G/klH]<0H]<38
h=P=R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0
^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h0P0000>8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2
002000ZKYo7ooonGR[ajK:ZcanRYKZ38`mnCQKYKAY>ISkh2N6F^00A29hF_
YL[ooolc@jD2002000Coool00H000X000X0200>100Coool0187oool01H42
00J200Koool11h8128;oool12H?oool20@Z300@12h?oool138Coool20@f4
0P4>Q@823hD0108@QOooo`8AQP8AQP824XH0108CQ_ooo`8DQoooo`825HL0
108FQoooo`<GR?ooo`8368P010<IR?ooo`<JROooo`836hT01P<LR_ooo`<M
RP<MR_ooo`@NRP847h/00`@PRoooooooo`03oooo00H48hcoool498`498d4
9Hd59Hd21BJ=00@59hd59hh5:8h5:8h21BV>0PDZS`85:hl21Bb?0PH]T086
;Y0010H_T0H_T@H`T@H`T@86<I401PHbT@HbTPHcTPHcTPHdTPLdTP87=I<2
1cJC0PLgT`87>9@21cVD0PLjU087>iD00`PlU@PmU@PmU@0223jF0PPoUP88
@9H2246G0PQ2U`0424>G2D>H2DBH2DBH0PU5V0042DJH2DJI2DNI2DNI0PU8
V@042DVI2DVJ2DZJ2DZJ0PY;VP8:C9/22TfK0PY>V`8:Ci`22U2L00@:DI`:
DId:DYd;DYd22e>M00@;E9d;E9h;EIh;EIh22eJN0P]GW`8;F9l22eVO0PaJ
X08<Fj0235bP0PaMX@8<GZ4020aOX@aOXPaPXPaPXPaQXPeQXPeRXPeRX`8=
Hj<23FBS0PeUY08=IZ@23FNT0PeXY@8>JJD010iZY@iZYPi[YPi[YP8>K:H0
10i]YPi]Y`i^Y`i^Y`8>KjL010i`Y`m`Z0maZ0maZ08?LZP23g>Y0PmdZ@8?
MJT23gJZ0PmgZP0347RZ47V[47V[008@NZ/247^[0Q1l[08@OJ`247j/00H@
OjdAOjdAP:dAP:dAPJdAPJh24H:^0Q63[P044HB^4HB_4HF_4HF_0Q66[`8B
Qk024XR`0Q:9/08BR[424X^a00PBS;4BS;8BSK8BSK8BS[8CS[8CSk8CSk<2
4i2c0Q>A/`044i:c4i:d4i>d4i>d0Q>D]08CUKD259Je0QBG]@8DV;H259Vf
00@DV[HDV[LDVkLDVkL259bg00@DWKLEWKPEW[PEW[P25Inh0QFP^@8EXKT2
5J:i0QFS^P8EY;X25ZFj0QJV^`8FYk/011JX^aJX_1JY_1JY_08FZ[`011J[
_1J[_AJ/_AN/_@8G[Kd25jjn0QN__P8G/;h25k6o0QNb_`045k>o6;C06;C0
b>3H3HS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028
`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8`;P4000018S0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008000i^W
lOooooooo`02oooo00[o[K3oMW_icMCmkNkooonVVlB5M[2l^=gooolc@jD3
002000Coool00H000X000X0200>10P04P@0:oooo00F100J200J2oooo0@N2
0@R2oooo0@V3oooo0P4:P`030@^3oooo0@b400;oool00`4=Q04>Q@4>Q@02
0Pn500@248Goool24HH24HH20Q:60P8CQP080QB7oooooooo0QF70QJ7oooo
0aN8oooo0P<HR0040aV8oooo0aZ9oooo0P<KR@040ab:oooo0af:oooo0P@N
RP0911n;oooo122;oooo126;126<12:<oooo12><00;oool00`@TS@@US@DU
S@021BJ=00@59hd59hh5:8h5:8h21BV>0PDZS`85:hl21Bb?0PH]T086;Y00
10H_T0H_T@H`T@H`T@86<I401PHbT@HbTPHcTPHcTPHdTPLdTP87=I<21cJC
0PLgT`87>9@21cVD0PLjU087>iD00`PlU@PmU@PmU@0223jF0PPoUP88@9H2
246G0PQ2U`0424>G2D>H2DBH2DBH0PU5V0042DJH2DJI2DNI2DNI0PU8V@04
2DVI2DVJ2DZJ2DZJ0PY;VP8:C9/22TfK0PY>V`8:Ci`22U2L00@:DI`:DId:
DYd;DYd22e>M00@;E9d;E9h;EIh;EIh22eJN0P]GW`8;F9l22eVO0PaJX08<
Fj0235bP0PaMX@8<GZ4020aOX@aOXPaPXPaPXPaQXPeQXPeRXPeRX`8=Hj<2
3FBS0PeUY08=IZ@23FNT0PeXY@8>JJD010iZY@iZYPi[YPi[YP8>K:H010i]
YPi]Y`i^Y`i^Y`8>KjL010i`Y`m`Z0maZ0maZ08?LZP23g>Y0PmdZ@8?MJT2
3gJZ0PmgZP0347RZ47V[47V[008@NZ/247^[0Q1l[08@OJ`247j/00H@OjdA
OjdAP:dAP:dAPJdAPJh24H:^0Q63[P044HB^4HB_4HF_4HF_0Q66[`8BQk02
4XR`0Q:9/08BR[424X^a00PBS;4BS;8BSK8BSK8BS[8CS[8CSk8CSk<24i2c
0Q>A/`044i:c4i:d4i>d4i>d0Q>D]08CUKD259Je0QBG]@8DV;H259Vf00@D
V[HDV[LDVkLDVkL259bg00@DWKLEWKPEW[PEW[P25Inh0QFP^@8EXKT25J:i
0QFS^P8EY;X25ZFj0QJV^`8FYk/011JX^aJX_1JY_1JY_08FZ[`011J[_1J[
_AJ/_AN/_@8G[Kd25jjn0QN__P8G/;h25k6o0QNb_`045k>o6;C06;C0b>3H
3HS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028`;R8
`;Q8T8P000000QRd`003b>3HR<2hR<2h00B8`;P200001HS0^004B9280000
6;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008002Z6/l_W=
e>8V??Be_n8V??A]OOcSjOoooog]k_n]/0;oool00c=3Y@00P000P0020020
00Coool00H000X000X0200>10P04P@0800F1oooooooooooo00N20@N20@R2
oooo0P49P`?oool01@4;Q04<Q?ooo`4=Q?ooo`020@j50P8?Q@040Q25oooo
0Q660Q660P8BQP824hH00`8DQoooo`8EQ`02oooo00<35XP35hP35hP00ooo
o`030aV90aZ90aZ900?oool00`<LRP<MRP<MRP03oooo00<47h/488/488/0
0oooo`0712:<12><oooo12B<oooo12F=1BF=00859Xd010DWS@DWSPDXSPDX
SP85:Hh21BZ?0PD[S`85;8l21Rf@0PH^T0041Rn@1RnA1S2A1S2A0PHaT@06
1S:A1S:B1S>B1S>B1SBB1cBB0PLeT`87=Y<21cNC0PLhU087>I@21cZD0PLk
U@0323bE23fE23fE0088?YH223nF0PQ0UP88@IL224:G00@8@iL9@iP9A9P9
A9P22DFH00@9AYP9AYT9AiT9AiT22DRI00@9BIT9BIX9BYX9BYX22T^J0PY<
V`8:CI/22TjK0PY?W08:D9`010YAW0YAW@YBW@]BW@8;Did010]DW@]DWP]E
WP]EWP8;EYh22eNO0P]HW`8;FIl235ZP0PaKX08<G:0235fQ0PaNX@0835nQ
35nR362R362R366R3F6R3F:R3F:S0PeSX`8=I:<23FFT0PeVY08=Ij@23FRU
0PiYY@043VZU3VZV3V^V3V^V0Pi/YP043VfV3VfW3VjW3VjW0Pi_Y`043W2W
3g2X3g6X3g6X0PmbZ08?LjT23gBY0PmeZ@8?MZX23gNZ00<@N:X@NJ/@NJ/0
0Q1jZ`8@Nj/247b/0Q1m[08@OZ`01Q1o[A5o[A60[A60[A61[A61[P8APZh2
4H>^00@AQ:hAQ:lAQJlAQJl24HJ_0Q:7/08BR;024XV`0Q::/@8BRk4021:<
/A:</Q:=/Q:=/Q:>/Q>>/Q>?/Q>?/`8CT;<24i6c00@CT[<CT[@CTk@CTk@2
4iBd0Q>E]@8DU[D259Ne0QBH]P8DVKH011BJ]QBJ]aBK]aBK]`8DW;L011BM
]aFM^1FN^1FN^08EWkP25J2i0QFQ^@8EX[T25J>j0QFT^P8FYKX25ZJk0QJW
^`045ZRk5ZRl5ZVl5ZVl0QJZ_0045Z^l5Z^m5Zbm5jbm0QN]_@8G[[h25jnn
0QN`_P8G/Kl25k:o00@G/klH]<0H]<38h=P=R<2h00=8T8P00038h=P00XS0
^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8
`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0P00P00=VjOaoNg^hRHlo_GhmhVGm69^lj2^m69^
oogoojf`o>?Yoooo<d>U00D008001?ooo`01P002P002P0800h401?ooo`04
P@05P@05P@801X801007PP47PP48P_ooo`812H<20@Z300@12h<12h@138@1
38@20@f40P4>Q@823hD0108@QOooo`8AQP8AQP824XH0108CQ_ooo`8DQooo
o`825HL0108FQ`<FR0<GR0<GR08368P010<IR0<IR@<JR@<JR@836hT20ab:
0P<MRP847XX211n;0P@PR`04126;126<12:<12:<0P@SS00412B<12B=12F=
1BF=0PDVS@041BN=1BN>1BR>1BR>0PDYSP85:Xl21B^?0PD/S`86;I021Rj@
00@6;i06;i46<946<9421S6A00H6<Y46<Y86<i86<i86=987=9821cFC0PLf
T`87=i<21cRD0PLiU087>Y@21c^E00<8?9D8?ID8?ID00PPnUP88?iH2242F
0PQ1U`88@YL010Q3U`U3V0U4V0U4V089AIP010U6V0U6V@U7V@U7V@89B9T0
10U9V@U9VPU:VPU:VP8:BiX22TbK0PY=V`8:CY/22TnL0PY@W0042U6L2U6M
2U:M2e:M0P]CW@042eBM2eBN2eFN2eFN0P]FWP8;Eil22eRO0P]IW`8<FZ02
35^P0PaLX08<GJ4235jQ00P<Gj4<Gj8<H:8<H:8<HJ8=HJ8=HZ8=HZ<23F>S
0PeTX`8=IJ@23FJT0PeWY08=J:D23VVU00@>JZD>JZH>JjH>JjH23VbV00@>
KJH>KJL>KZL>KZL23VnW00@>L:L?L:P?LJP?LJP23g:X0PmcZ@8?M:T23gFY
0PmfZP8?MjX00a1hZQ1iZa1iZ`0247Z[0Q1kZ`8@O:`247f/0Q1n[00647n]
4Gn]4H2]4H2]4H6]4H6^0Q62[P8APjh01164[Q64[a65[a65[`8AQZl24XN`
0Q:8/08BRK024XZa0Q:;/@084Xba4Xbb4Xfb4Xfb4Xjb4hjb4hnb4hnc0Q>@
/`8CTK<011>B/a>B]1>C]1>C]08CU;@24iFe0QBF]@8DUkD259Rf0QBI]P04
59Zf59Zg59^g59^g0QBL]`0459fg5Ifh5Ijh5Ijh0QFO^08EX;T25J6i0QFR
^@8EXkX25JBj0QJU^P8FY[/25ZNk00@FZ;/FZ;`FZK`FZK`25ZZl00@FZk`F
ZkdF[;dG[;d25jfm0QN^_P8G[kh25k2n0QNa_`8G/[l011Nc_aRd`1Rd`<SP
f0f8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2h
R<2hB9280000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^080
08000i^WlOK8c>8V?002ojf`00OO92koY9kf_<Go[K3^Nhcooolc@jD01P00
P0060060oooo00:000:000>1oooo0P04P@801H4200J200@01h811h8128;o
ool20@V30P4:P`040@^30@^40@b40@b40P4=Q0813XD20Pn50P8@Q@08oooo
0Q660Q:60Q:6oooo0Q>60QB7oooo0P8EQ`040QJ70aJ80aN80aN80P<HR004
0aV80aV90aZ90aZ90P<KR@8378X20af:0P@NRP847h/2122;00@48H/48H`4
8X`48X`212><00@498`498d49Hd59Hd21BJ=00@59hd59hh5:8h5:8h21BV>
0PDZS`85:hl21Bb?0PH]T086;Y0010H_T0H_T@H`T@H`T@86<I401PHbT@Hb
TPHcTPHcTPHdTPLdTP87=I<21cJC0PLgT`87>9@21cVD0PLjU087>iD00`Pl
U@PmU@PmU@0223jF0PPoUP88@9H2246G0PQ2U`0424>G2D>H2DBH2DBH0PU5
V0042DJH2DJI2DNI2DNI0PU8V@042DVI2DVJ2DZJ2DZJ0PY;VP8:C9/22TfK
0PY>V`8:Ci`22U2L00@:DI`:DId:DYd;DYd22e>M00@;E9d;E9h;EIh;EIh2
2eJN0P]GW`8;F9l22eVO0PaJX08<Fj0235bP0PaMX@8<GZ4020aOX@aOXPaP
XPaPXPaQXPeQXPeRXPeRX`8=Hj<23FBS0PeUY08=IZ@23FNT0PeXY@8>JJD0
10iZY@iZYPi[YPi[YP8>K:H010i]YPi]Y`i^Y`i^Y`8>KjL010i`Y`m`Z0ma
Z0maZ08?LZP23g>Y0PmdZ@8?MJT23gJZ0PmgZP0347RZ47V[47V[008@NZ/2
47^[0Q1l[08@OJ`247j/00H@OjdAOjdAP:dAP:dAPJdAPJh24H:^0Q63[P04
4HB^4HB_4HF_4HF_0Q66[`8BQk024XR`0Q:9/08BR[424X^a00PBS;4BS;8B
SK8BSK8BS[8CS[8CSk8CSk<24i2c0Q>A/`044i:c4i:d4i>d4i>d0Q>D]08C
UKD259Je0QBG]@8DV;H259Vf00@DV[HDV[LDVkLDVkL259bg00@DWKLEWKPE
W[PEW[P25Inh0QFP^@8EXKT25J:i0QFS^P8EY;X25ZFj0QJV^`8FYk/011JX
^aJX_1JY_1JY_08FZ[`011J[_1J[_AJ/_AN/_@8G[Kd25jjn0QN__P8G/;h2
5k6o0QNb_`045k>o6;C06;C0b>3H3HS0^003B9280000b>3H00:8`;P90000
0XS0^005B92800006;C06;C0b>3H00>8`;P2000018S0^0800002R<2h00A8
T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003
VjOanLgDmhVG00;oool01on]/>4F=?mfNonTW^8V??n9Oc=3Y@0600200P01
P0?oool00`03P@04P@04P@0200F10P06PP0400N20@N20@R2oooo0P49P`81
2X<0104;P`4;Q04<Q04<Q0813H@20@j50P8?Q@8248D0108AQ_oooooooooo
o`824hH01P8DQoooo`8EQ`8EQ`8FQ`<FR0835hP20aR800@36HP36HT36XT3
6XT20a^90P<LRP837HX211j:0P@OR`8488/010@QR`@QS0@RS0@RS0848h`0
10@TS0@TS@@US@DUS@859Xd010DWS@DWSPDXSPDXSP85:Hh21BZ?0PD[S`85
;8l21Rf@0PH^T0041Rn@1RnA1S2A1S2A0PHaT@061S:A1S:B1S>B1S>B1SBB
1cBB0PLeT`87=Y<21cNC0PLhU087>I@21cZD0PLkU@0323bE23fE23fE0088
?YH223nF0PQ0UP88@IL224:G00@8@iL9@iP9A9P9A9P22DFH00@9AYP9AYT9
AiT9AiT22DRI00@9BIT9BIX9BYX9BYX22T^J0PY<V`8:CI/22TjK0PY?W08:
D9`010YAW0YAW@YBW@]BW@8;Did010]DW@]DWP]EWP]EWP8;EYh22eNO0P]H
W`8;FIl235ZP0PaKX08<G:0235fQ0PaNX@0835nQ35nR362R362R366R3F6R
3F:R3F:S0PeSX`8=I:<23FFT0PeVY08=Ij@23FRU0PiYY@043VZU3VZV3V^V
3V^V0Pi/YP043VfV3VfW3VjW3VjW0Pi_Y`043W2W3g2X3g6X3g6X0PmbZ08?
LjT23gBY0PmeZ@8?MZX23gNZ00<@N:X@NJ/@NJ/00Q1jZ`8@Nj/247b/0Q1m
[08@OZ`01Q1o[A5o[A60[A60[A61[A61[P8APZh24H>^00@AQ:hAQ:lAQJlA
QJl24HJ_0Q:7/08BR;024XV`0Q::/@8BRk4021:</A:</Q:=/Q:=/Q:>/Q>>
/Q>?/Q>?/`8CT;<24i6c00@CT[<CT[@CTk@CTk@24iBd0Q>E]@8DU[D259Ne
0QBH]P8DVKH011BJ]QBJ]aBK]aBK]`8DW;L011BM]aFM^1FN^1FN^08EWkP2
5J2i0QFQ^@8EX[T25J>j0QFT^P8FYKX25ZJk0QJW^`045ZRk5ZRl5ZVl5ZVl
0QJZ_0045Z^l5Z^m5Zbm5jbm0QN]_@8G[[h25jnn0QN`_P8G/Kl25k:o00@G
/klH]<0H]<38h=P=R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0
000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008001i^WlOoooo>P[_ARK_ooooN9UoW=e002oooo
00?cX:kooolc@jD01P00P0800H0200:00P03P@80184200F10P06PP0400N2
0@N20@R20@R30P49P`812X<0104;P`4;Q04<Q04<Q0813H@20@j50P8?Q@82
48D20Q660P8BQP824hH20QB70P8EQ`040QJ70aJ80aN80aN80P<HR0040aV8
0aV90aZ90aZ90P<KR@8378X20af:0P@NRP847h/2122;00@48H/48H`48X`4
8X`212><00@498`498d49Hd59Hd21BJ=00@59hd59hh5:8h5:8h21BV>0PDZ
S`85:hl21Bb?0PH]T086;Y0010H_T0H_T@H`T@H`T@86<I401PHbT@HbTPHc
TPHcTPHdTPLdTP87=I<21cJC0PLgT`87>9@21cVD0PLjU087>iD00`PlU@Pm
U@PmU@0223jF0PPoUP88@9H2246G0PQ2U`0424>G2D>H2DBH2DBH0PU5V004
2DJH2DJI2DNI2DNI0PU8V@042DVI2DVJ2DZJ2DZJ0PY;VP8:C9/22TfK0PY>
V`8:Ci`22U2L00@:DI`:DId:DYd;DYd22e>M00@;E9d;E9h;EIh;EIh22eJN
0P]GW`8;F9l22eVO0PaJX08<Fj0235bP0PaMX@8<GZ4020aOX@aOXPaPXPaP
XPaQXPeQXPeRXPeRX`8=Hj<23FBS0PeUY08=IZ@23FNT0PeXY@8>JJD010iZ
Y@iZYPi[YPi[YP8>K:H010i]YPi]Y`i^Y`i^Y`8>KjL010i`Y`m`Z0maZ0ma
Z08?LZP23g>Y0PmdZ@8?MJT23gJZ0PmgZP0347RZ47V[47V[008@NZ/247^[
0Q1l[08@OJ`247j/00H@OjdAOjdAP:dAP:dAPJdAPJh24H:^0Q63[P044HB^
4HB_4HF_4HF_0Q66[`8BQk024XR`0Q:9/08BR[424X^a00PBS;4BS;8BSK8B
SK8BS[8CS[8CSk8CSk<24i2c0Q>A/`044i:c4i:d4i>d4i>d0Q>D]08CUKD2
59Je0QBG]@8DV;H259Vf00@DV[HDV[LDVkLDVkL259bg00@DWKLEWKPEW[PE
W[P25Inh0QFP^@8EXKT25J:i0QFS^P8EY;X25ZFj0QJV^`8FYk/011JX^aJX
_1JY_1JY_08FZ[`011J[_1J[_AJ/_AN/_@8G[Kd25jjn0QN__P8G/;h25k6o
0QNb_`045k>o6;C06;C0b>3H3HS0^003B9280000b>3H00f8`;P01DR@R000
01Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0`00P00;VjOaooooohUooooolj2^lI>Qoooooogolj2^
oo_l<d>U00H0080200600P02P0800h4200B10P05P@801X801007PP47PP48
PP48P`812H<20@Z300@12h<12h@138@138@20@f40P4>Q@823hD20Q250P8A
QP824XH20Q>60P8DQ`825HL0108FQ`<FR0<GR0<GR08368P010<IR0<IR@<J
R@<JR@836hT20ab:0P<MRP847XX211n;0P@PR`04126;126<12:<12:<0P@S
S00412B<12B=12F=1BF=0PDVS@041BN=1BN>1BR>1BR>0PDYSP85:Xl21B^?
0PD/S`86;I021Rj@00@6;i06;i46<946<9421S6A00H6<Y46<Y86<i86<i86
=987=9821cFC0PLfT`87=i<21cRD0PLiU087>Y@21c^E00<8?9D8?ID8?ID0
0PPnUP88?iH2242F0PQ1U`88@YL010Q3U`U3V0U4V0U4V089AIP010U6V0U6
V@U7V@U7V@89B9T010U9V@U9VPU:VPU:VP8:BiX22TbK0PY=V`8:CY/22TnL
0PY@W0042U6L2U6M2U:M2e:M0P]CW@042eBM2eBN2eFN2eFN0P]FWP8;Eil2
2eRO0P]IW`8<FZ0235^P0PaLX08<GJ4235jQ00P<Gj4<Gj8<H:8<H:8<HJ8=
HJ8=HZ8=HZ<23F>S0PeTX`8=IJ@23FJT0PeWY08=J:D23VVU00@>JZD>JZH>
JjH>JjH23VbV00@>KJH>KJL>KZL>KZL23VnW00@>L:L?L:P?LJP?LJP23g:X
0PmcZ@8?M:T23gFY0PmfZP8?MjX00a1hZQ1iZa1iZ`0247Z[0Q1kZ`8@O:`2
47f/0Q1n[00647n]4Gn]4H2]4H2]4H6]4H6^0Q62[P8APjh01164[Q64[a65
[a65[`8AQZl24XN`0Q:8/08BRK024XZa0Q:;/@084Xba4Xbb4Xfb4Xfb4Xjb
4hjb4hnb4hnc0Q>@/`8CTK<011>B/a>B]1>C]1>C]08CU;@24iFe0QBF]@8D
UkD259Rf0QBI]P0459Zf59Zg59^g59^g0QBL]`0459fg5Ifh5Ijh5Ijh0QFO
^08EX;T25J6i0QFR^@8EXkX25JBj0QJU^P8FY[/25ZNk00@FZ;/FZ;`FZK`F
ZK`25ZZl00@FZk`FZkdF[;dG[;d25jfm0QN^_P8G[kh25k2n0QNa_`8G/[l0
0aNc_aRd`1Rd`00?b>3H00<00038h=S8h=P03LSPf00300006;C06;C000o8
h=P00`0001Rd`1Rd`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1000
P0>KYo401_oooo>P[_Be_oJlaO_IfS=3Y@L0080200600P02P0800h4200B1
0P05P@801X801007PP47PP48PP48P`812H<20@Z300@12h<12h@138@138@2
0@f40P4>Q@823hD20Q250P8AQP824XH20Q>60P8DQ`825HL0108FQ`<FR0<G
R0<GR08368P010<IR0<IR@<JR@<JR@836hT20ab:0P<MRP847XX211n;0P@P
R`04126;126<12:<12:<0P@SS00412B<12B=12F=1BF=0PDVS@041BN=1BN>
1BR>1BR>0PDYSP85:Xl21B^?0PD/S`86;I021Rj@00@6;i06;i46<946<942
1S6A00H6<Y46<Y86<i86<i86=987=9821cFC0PLfT`87=i<21cRD0PLiU087
>Y@21c^E00<8?9D8?ID8?ID00PPnUP88?iH2242F0PQ1U`88@YL010Q3U`U3
V0U4V0U4V089AIP010U6V0U6V@U7V@U7V@89B9T010U9V@U9VPU:VPU:VP8:
BiX22TbK0PY=V`8:CY/22TnL0PY@W0042U6L2U6M2U:M2e:M0P]CW@042eBM
2eBN2eFN2eFN0P]FWP8;Eil22eRO0P]IW`8<FZ0235^P0PaLX08<GJ4235jQ
00P<Gj4<Gj8<H:8<H:8<HJ8=HJ8=HZ8=HZ<23F>S0PeTX`8=IJ@23FJT0PeW
Y08=J:D23VVU00@>JZD>JZH>JjH>JjH23VbV00@>KJH>KJL>KZL>KZL23VnW
00@>L:L?L:P?LJP?LJP23g:X0PmcZ@8?M:T23gFY0PmfZP8?MjX00a1hZQ1i
Za1iZ`0247Z[0Q1kZ`8@O:`247f/0Q1n[00647n]4Gn]4H2]4H2]4H6]4H6^
0Q62[P8APjh01164[Q64[a65[a65[`8AQZl24XN`0Q:8/08BRK024XZa0Q:;
/@084Xba4Xbb4Xfb4Xfb4Xjb4hjb4hnb4hnc0Q>@/`8CTK<011>B/a>B]1>C
]1>C]08CU;@24iFe0QBF]@8DUkD259Rf0QBI]P0459Zf59Zg59^g59^g0QBL
]`0459fg5Ifh5Ijh5Ijh0QFO^08EX;T25J6i0QFR^@8EXkX25JBj0QJU^P8F
Y[/25ZNk00@FZ;/FZ;`FZK`FZK`25ZZl00@FZk`FZkdF[;dG[;d25jfm0QN^
_P8G[kh25k2n0QNa_`8G/[l00aNc_aRd`1Rd`00d6;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^1@0080200600P02P0800h4200B10P05P@801X80
1007PP47PP48PP48P`812H<20@Z300@12h<12h@138@138@20@f40P4>Q@82
3hD20Q250P8AQP824XH20Q>60P8DQ`825HL0108FQ`<FR0<GR0<GR08368P0
10<IR0<IR@<JR@<JR@836hT20ab:0P<MRP847XX211n;0P@PR`04126;126<
12:<12:<0P@SS00412B<12B=12F=1BF=0PDVS@041BN=1BN>1BR>1BR>0PDY
SP85:Xl21B^?0PD/S`86;I021Rj@00@6;i06;i46<946<9421S6A00H6<Y46
<Y86<i86<i86=987=9821cFC0PLfT`87=i<21cRD0PLiU087>Y@21c^E00<8
?9D8?ID8?ID00PPnUP88?iH2242F0PQ1U`88@YL010Q3U`U3V0U4V0U4V089
AIP010U6V0U6V@U7V@U7V@89B9T010U9V@U9VPU:VPU:VP8:BiX22TbK0PY=
V`8:CY/22TnL0PY@W0042U6L2U6M2U:M2e:M0P]CW@042eBM2eBN2eFN2eFN
0P]FWP8;Eil22eRO0P]IW`8<FZ0235^P0PaLX08<GJ4235jQ00P<Gj4<Gj8<
H:8<H:8<HJ8=HJ8=HZ8=HZ<23F>S0PeTX`8=IJ@23FJT0PeWY08=J:D23VVU
00@>JZD>JZH>JjH>JjH23VbV00@>KJH>KJL>KZL>KZL23VnW00@>L:L?L:P?
LJP?LJP23g:X0PmcZ@8?M:T23gFY0PmfZP8?MjX00a1hZQ1iZa1iZ`0247Z[
0Q1kZ`8@O:`247f/0Q1n[00647n]4Gn]4H2]4H2]4H6]4H6^0Q62[P8APjh0
1164[Q64[a65[a65[`8AQZl24XN`0Q:8/08BRK024XZa0Q:;/@084Xba4Xbb
4Xfb4Xfb4Xjb4hjb4hnb4hnc0Q>@/`8CTK<011>B/a>B]1>C]1>C]08CU;@2
4iFe0QBF]@8DUkD259Rf0QBI]P0459Zf59Zg59^g59^g0QBL]`0459fg5Ifh
5Ijh5Ijh0QFO^08EX;T25J6i0QFR^@8EXkX25JBj0QJU^P8FY[/25ZNk00@F
Z;/FZ;`FZK`FZK`25ZZl00@FZk`FZkdF[;dG[;d25jfm0QN^_P8G[kh25k2n
0QNa_`8G/[l00aNc_aRd`1Rd`00d6;C00XS0^058T8P1000000000hS0^<SP
f8S0^03oR<2h/HS0^058T8P1000000000hS0^<SPf8S0^03oR<2h/HS0^058
T8P1000000000hS0^<SPf<SPf03ob>3H/LSPf058T8P10000003oR<2h]HS0
^04000000001\
\>"], "Graphics",
  ImageSize->{437, 407},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006b0001[B000`400?l0
0000o`00003oooo`l?2Too3`l003omWIfOoooooooooo00cooooo003ooo3`
l:Col?3`00CofMWIooooooooooooiNGU0oooool01OoUiNGooooooooooooo
ooooiNGU00?ooooo003ooo3`l:Col?3`00gofMWIoooooooJf][oSHf=onGU
iOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003ooo3`
l:Col?3`00kofMWIoooooooooooof][Johf=SOoUiNGoooooom[Jf_n=SHgo
iNGUoooooooJf][oSHf=onGUi@7ooooo003ooo3`l:Col?3`00gofMWIoooo
ooooooooooooom[Jf_n=SHgoiNGUoooooooJf][oSHf=onGUiOoooooof][J
00;ooooo003ooo3`l:Col?3`00?ofMWIooooooooool00_ooool01ooJf][o
SHf=onGUiOoooooof][Johf=SOoUiND00oooool00?ool?3`Y?o`l?000ooI
fMWoooooooooo`03ooooo`07om[Jf_n=SHgoiNGUoooooooJf][oSHf=onGU
i@02ooooo`00ooo`l?2Too3`l003omWIfOoooooooooo00Cooooo00Oof][J
ohf=SOoUiNGoooooomcLg?n=SHgoiNGU007ooooo003ooo3`l:Col?3`00?o
fMWIooooooooool01Oooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo
003ooo3`l:Col?3`00?ofMWIooooooooool01_ooool00ooLg=coSHf=onGU
i@03ooooo`00ooo`l?2Too3`l003omWIfOoooooooooo00Oooooo00?og=cL
ohf=SOoUiND00_ooool00?ool?3`Y?o`l?000ooIfMWoooooooooo`08oooo
o`03omcLg?n=SHgoiNGU007ooooo003ooo3`l:Col?3`00?ofMWIoooooooo
ool02Oooool1omcLg07ooooo0Oooool00?ool?3`Y?o`l?000ooIfMWooooo
ooooo`0<ooooo`00ooo`l?2Too3`l0oofMWI003ooooook?ooooo003oonk^
k[?ok^k^003oonKVi[?oi^KV003oonk^k[?ok^k^003ooooook?ooooo003o
onk^k[?ok^k^001GonKViP;oiNGU00[ohn?Son3Ph?oMgMgof][JomKFe_oA
dM7ocLg=ol[:b_o7alOoa/K60_o5aLDeolC4a0;oaLG500[oa/K6olO7aoo:
b/[ocLg=om7AdOoFe]Kof][JomgMgOoPh>3ohn?S0_oUiND8onKViP;oiNGU
00[ohn?Son3Ph?oMgMgof][JomKFe_oAdM7ocLg=ol[:b_o7alOoa/K60_o5
aLDeolC4a0;oaLG500[oa/K6olO7aoo:b/[ocLg=om7AdOoFe]Kof][JomgM
gOoPh>3ohn?S0_oUiND8onKViP;oiNGU00[ohn?Son3Ph?oMgMgof][JomKF
e_oAdM7ocLg=ol[:b_o7alOoa/K60_o5aLDeolC4a0;oaLG500[oa/K6olO7
aoo:b/[ocLg=om7AdOoFe]Kof][JomgMgOoPh>3ohn?S0_oUiNEHonKViP00
E_o^k^h2ong]k@0:on[Zj_oXj>Soh^;RomgMgOoFe]KocLg=olK6a_nn_[ko
^[ZjokJf]PCo/k>c<onb/[84ok>c/`0:okJf]_nj^[[o_[jnolK6a_o=cLgo
e]KFomgMgOoRh^;oj>SXon[ZjP;okNg]1_o^k^h2ong]k@0:on[Zj_oXj>So
h^;RomgMgOoFe]KocLg=olK6a_nn_[ko^[ZjokJf]PCo/k>c<onb/[84ok>c
/`0:okJf]_nj^[[o_[jnolK6a_o=cLgoe]KFomgMgOoRh^;oj>SXon[ZjP;o
kNg]1_o^k^h2ong]k@0:on[Zj_oXj>Soh^;RomgMgOoFe]KocLg=olK6a_nn
_[ko^[ZjokJf]PCo/k>c<onb/[84ok>c/`0:okJf]_nj^[[o_[jnolK6a_o=
cLgoe]KFomgMgOoRh^;oj>SXon[ZjP;okNg]Eoo^k^h005Kooooo00koo_kn
oo_knoohn?Sol_;bonWYjOoMgMgodM7AolG5aOnj^[[o/K6aoj^[ZonWYjOo
Xj>Soj:RXSOoXJ6Q00goXZ:Roj>SXonWYjOoZj^[ok6a/Onj^[[oaLG5om7A
dOoMgMgojNWYoo;bl_ohn?Sono_k00;oo_kn1Oooool03_ono_kono_kooSh
n?obl_;ojNWYomgMgOoAdM7oaLG5okZj^_na/K7oZj^[ojNWYonSXj?oXZ:R
=onQXJ403OnRXZ;oXj>SojNWYon[Zj_o/K6aokZj^_o5aLGodM7AomgMgOoY
jNWol_;booShn?okno/00_ono_h5ooooo`0>ookno_okno_on?Shoo;bl_oY
jNWogMgMom7AdOo5aLGo^[Zjok6a/On[Zj_oYjNWoj>SXonRXZ8goj6QX@0=
oj:RX_nSXj?oYjNWoj^[Zona/K7o^[ZjolG5aOoAdM7ogMgMonWYjOobl_;o
n?Shoo_kn`02ooknoUKooooo001Fonk^kP0>on_[jooXj>Soh^;RomSHf?o;
bl_o_[jnojj^[_nQXJ7oUIFEohb<S?n5QHGoPX:2ogmoOomnOWhgogemO@0?
oginO_moOgooPX:2ohF5QOn<S8coUIFEoj6QXOn^[Zko_[jnol_;booHf=So
h^;RonSXj?o[jn_okNg]00Gok^k^00kojn_[onSXj?oRh^;of=SHol_;bonn
_[ko[Zj^oj6QXOnEUIGoS8b<ohF5QOn2PX;oOgmooginOSOoOGem00ooOWin
ogmoOon2PX;oQHF5ohb<S?nEUIGoXJ6Qojj^[_nn_[kobl_;omSHf?oRh^;o
j>SXon_[joo]kNd01Oo^k^h03_o[jn_oj>SXon;Rh_oHf=Sobl_;okjn__n^
[ZkoXJ6QoiFEUOn<S8coQHF5oh:2P_moOgooOWin=ommOGd03omnOWkoOgmo
oh:2P_n5QHGoS8b<oiFEUOnQXJ7o[Zj^okjn__o;bl_of=SHon;Rh_oXj>So
jn_[ong]k@1Fonk^kP00E_oVi^H05?oPh>3ofm_Kom;Bd_o4a<Co];Bdoj>S
XonCTi?oSXj>oj>SXonn_[koemOGon_[joofm_KomoOgooWinOohn?SonOWi
oo[jn_oinOWomoOg0oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oi
nOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00ooh
n?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOg
m`03ooShn0;onOWi01?on_[jooWinOohn?SonOWiooShn?ogmoOokNg]omSH
f?no_kooXj>Sohj>S_nCTi?oXj>SokBd]?o4a<Cod];Bom_KfooPh>3oi>CT
00Goi^KV01Coh>3Pom_KfooBd];oa<C4okBd]?nSXj?oTi>Cohj>S_nSXj?o
_[jnomOGeoo[jn_om_KfooOgmooinOWon?ShooWinOojn_[onOWiooOgm`?o
n?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOog
moL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[o
nOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2ooWin@0C
oo[jn_oinOWon?ShooWinOohn?SomoOgong]kOoHf=So_knooj>SXon>SXko
Ti>Coj>SXond];Coa<C4om;Bd_oKfm_oh>3PonCTi005onKViP0Don3Ph?oK
fm_od];BolC4a?nd];CoXj>Soi>CTon>SXkoXj>Sokjn__oGemOojn_[ooKf
m_ogmoOonOWiooShn?oinOWon_[jooWinOogmoL3ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT0
0oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[jooWinOogmoL00oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT04oojn_[onOWiooShn?oi
nOWon?ShooOgmoo]kNgof=SHokno_onSXj?oSXj>oi>CTonSXj?o];BdolC4
a?oBd];ofm_Kon3Ph?oTi>@0E_oVi^H005Kok^k^00coiNGUomgMgOo>c/ko
_KfmojRXZ?nEUIGoYJFUolc<c?o^k^kom_Kfooclo?ono_hkooooo`0=ookn
o_olo?comoOgono_koo=cLgoYZJVoiFEUOnXZ:So_Kfmolk>c_oMgMgoiNGU
on[ZjP05onk^kP0<onGUiOoMgMgoc/k>okfm_OnXZ:SoUIFEojFUYOo<c<co
k^k^ooKfm_olo?coo_kn>oooool03Oono_koo?clooOgmoo_knoocLg=ojJV
Y_nEUIGoZ:RXokfm_Oo>c/kogMgMonGUiOoZj^X01Oo^k^h03?oUiNGogMgM
olk>c_nm_KgoZ:RXoiFEUOnUYJGoc<c<onk^k_ofm_Koo?clooknoS_ooooo
00goo_knooclo?ogmoOokno_olg=cOnVYZKoUIFEojRXZ?nm_Kgoc/k>omgM
gOoUiNGoj^[Z05Kok^k^001Fooooo`0:oo;bl_oUiNGodM7AokZj^_nTY:Co
/K6aomkNg_o[jn_om?Cdoo_kncoooooo00_ono_koo?cloo/k>cohN7QokBd
]?nTY:Co^[Zjom7AdOoUiNGol_;booWin@05ooooo`0:oo;bl_oUiNGodM7A
okZj^_nTY:Co/K6aomkNg_o[jn_om?Cdoo_kncoooooo00_ono_koo?cloo/
k>cohN7QokBd]?nTY:Co^[Zjom7AdOoUiNGol_;booWin@05ooooo`0:oo;b
l_oUiNGodM7AokZj^_nTY:Co/K6aomkNg_o[jn_om?Cdoo_kncoooooo00_o
no_koo?cloo/k>cohN7QokBd]?nTY:Co^[Zjom7AdOoUiNGol_;booWin@1F
ooooo`00E_o^k^h02_oMgMgocLg=okRh^?nQXJ7oZ:RXomCDe?oPh>3ok>c/
ooGemOomoOdoooooo`0;ookno_ofm_Kok>c/on;Rh_oIfMWo[:b/oj6QXOnh
^;SocLg=omgMgOoUiND01Oo^k^h02_oMgMgocLg=okRh^?nQXJ7oZ:RXomCD
e?oPh>3ok>c/ooGemOomoOdoooooo`0;ookno_ofm_Kok>c/on;Rh_oIfMWo
[:b/oj6QXOnh^;SocLg=omgMgOoUiND01Oo^k^h02_oMgMgocLg=okRh^?nQ
XJ7oZ:RXomCDe?oPh>3ok>c/ooGemOomoOdoooooo`0;ookno_ofm_Kok>c/
on;Rh_oIfMWo[:b/oj6QXOnh^;SocLg=omgMgOoUiND0E_o^k^h005Koi^KV
00_odM7Aokno_onXZ:SoX:2PolK6a_oDe=Coh>3Ponc/k?obl_;oo?clookn
oP0Hooooo`04ookno_oLg=cofm_KooknoR;ooooo00_on_[jooCdm?oZj^[o
hn?SomOGeoo=cLgoXj>SojRXZ?no_koodM7Aom_Kf`05onKViP0;om7AdOno
_kooZ:RXoj2PX?o6a/Koe=CDon3Ph?o/k>col_;booclo?ono_h03Oooool0
0ooShn?oe]KFooknoP04ooooo`03onc/k?omoOgooooo00;om?Cd2oooool0
0oo]kNgokno_ooooo`04ooooo`03ooCdm?oXj>Sooooo013ooooo00_on_[j
ooCdm?oZj^[ohn?SomOGeoo=cLgoXj>SojRXZ?no_koodM7Aom_Kf`05onKV
iP0;om7AdOno_kooZ:RXoj2PX?o6a/Koe=CDon3Ph?o/k>col_;booclo?on
o_h06?ooool00oodm?Coj>SXooooo`03ooooo`;ol_;b1_ooool00oodm?Co
j>SXooooo`04ooooo`03onGUiOomoOgooooo00kooooo00_on_[jooCdm?oZ
j^[ohn?SomOGeoo=cLgoXj>SojRXZ?no_koodM7Aom_Kf`1FonKViP00E_o^
k^h03ooDe=Co_knoojJVY_n/[:coa/K6om;Bd_oLg=coi^KVonc/k?oemOGo
n?Shoo[jn_omoOgoooooooclo008ooooo`03oogmoOoooooooooo00Gooooo
00[ooOgmooooooooooooY:BToa8B4_lP823o8b<So`h>3_n@T93oo_kn0_oo
ool02?lf=SKoRHV9oooooooooooolO7aobl_;olh>3Som_Kf1?ooool00oom
oOgoooooooooo`05ooooo`03oogmoOoooooooooo00;ooooo013ooOgmoooo
ooomoOgono_kooShn?odm?CokNg]onKVi_oOgmooe]KFolc<c?nb/[;oYjNW
okno_ooDe=Coh^;R1Oo^k^h03ooDe=Co_knoojJVY_n/[:coa/K6om;Bd_oL
g=coi^KVonc/k?oemOGon?Shoo[jn_omoOgoooooooclo007ooooo`0EoijN
W_lB4Q;o2@T9obLW9olK6a_oC4a<omWIfOooooooDE5Ao`L71olJ6Q[oW9bL
oa<C4omGEeOooooood10@?moOgoooOgmoooooonSXj?o71`L00;ooooo013o
iNGUod10@?l0003o4Q8BoadM7Oohn?SoooooonOWiom:BT[o0`<3ob8R8_lG
5aOo`L71oooooom0@43oOgmo0_ooool00oomoOgoooooooooo`02ooooo`0@
oogmoOoooooooOgmoo_knoohn?Som?Cdong]kOoVi^KogmoOomKFe_o<c<co
/[:bojNWYono_kooe=CDon;RhPGok^k^00ooe=CDokno_onVYZKo[:b/olK6
a_oBd];og=cLonKVi_o/k>comOGeooShn?ojn_[ooOgmooooooolo?`02?oo
ool01?omoOgoooooocHf=_mgMgL2ooooo`0@ooKfm_lV9RKoADE5ookno_oW
inOoBTY:o`<30olS8b?o5aLGol71`OomoOgo9BDUoa0@4?lP823oCDe=ooKf
mP;ooooo00_oiNGUodY:B_l30`?o8b<SoaLG5oo1`L7oooooom?CdolT92Co
7QhNokZj^P05ooooo`03oogmoOoooooooooo00;ooooo013ooOgmooooooom
oOgono_kooShn?odm?CokNg]onKVi_oOgmooe]KFolc<c?nb/[;oYjNWokno
_ooDe=Coh^;RE_o^k^h005Kooooo01?oh>3PolS8b?nXZ:So][Jfol?3`oo?
clooe]KFomoOgooVi^Koj^[Zono_kooclo?om?CdooGemOogmoOom_KfooOg
moofm_Kon?Sh00;omoOg0_ofm_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;o
m_Kf0_ogmoL04_nNWYko2@T9ok6a/OogmoOom_Kfokno_olD51CoPX:2ooKf
m_ohn?So=3@dohB4Q?ofm_Kolo?codM7AolS8b?oh^;RooShn0;omoOg0_of
m_H2ooOgm`04ooKfm_ohn?SomoOgooOgm`;om_Kf0_ogmoL04oofm_Kon?Sh
ooKfm_ogmoOom_KfooCdm?obl_;ol?3`on_[jooVi^KohN7Qom[Jf_oCdm?o
bLW9okno_on][Jgob<S8on3Ph?oalO401Oooool04ooPh>3ob<S8ojRXZ?nf
][Ko`l?3olo?cooFe]KogmoOonKVi_oZj^[okno_oo?cloodm?ComOGeooOg
moofm_KomoOgooKfm_ohn?P00_ogmoL01?nBTY;o0P82ohJ6Q_odm?@2ooKf
mP08ojb/[?oAdM7o_knoo`<30ooFe]Kog]kNoeMGEol@4102ooOgm`06ocdm
?OmjNW[omoOgooOgmonMWIgo6a/K0_ogmoL04?lo?coo:RXZolC4a?ogmoOo
d=3@ooKfm_ogmoOo@D51ocdm?OoGemOomoOgon_[jooYjNWon?Shocdm?Omk
Ng/2ooKfmP;omoOg01?om_KfooShn?ofm_KomoOgooKfm_odm?Col_;boo3`
l?o[jn_oi^KVon7QhOoJf][odm?ColW9bOno_koo[Jf]olS8b?oPh>3olO7a
00Gooooo01?oh>3PolS8b?nXZ:So][Jfol?3`oo?clooe]KFomoOgooVi^Ko
j^[Zono_kooclo?om?CdooGemOogmoOom_KfooOgmoofm_Kon?Sh00;omoOg
0_ofm_H2ooOgm`0Doc@d=?mcLg?omoOgooOgmom/K6co4a<ComoOgoogmoOo
@D51ochn?_oHf=SomoOgon[Zj_oYjNWomoOgokVi^Oobl_;omoOgoc@d=?n=
SHd2ooKfmP09od51@Olm?CgoemOGooShn?o[jn_oj^[ZooKfm_m]KFgo?Shn
00;om_Kf00?on?ShooOgmoogmoL00_ofm_H2ooOgm`0CooKfm_ohn?Som_Kf
ooOgmoofm_Kom?Cdoo;bl_o`l?3ojn_[onKVi_oQhN7of][Jom?Cdoo9bLWo
_knoojf][Oo8b<Soh>3Poo7al@1Fooooo`00E_o^k^h02oo@d=3o^;Rhoj2P
X?nc/k?o`<30olW9bOoCdm?ofMWIomgMgOoRh^;oiNGU00;oj^[Z00?ok>c/
ong]kOo]kNd01oo^k^h00oo`l?3ok^k^onk^kP05onk^kP04oo3`l?oYjNWo
6ATIodi>CPCok^k^00[oRHV9o`/;2ooMgMgok^k^oc8b<_moOgook^k^of9R
H_lD51CocLg=1_o^k^h00oo`l?3ok^k^onk^kP05onk^kP04oo3`l?o^k^ko
k^k^onk^kP;okNg]0_o/k>`03OoYjNWoi^KVon?ShooPh>3ofm_KomGEeOo=
cLgoaLG5ok^k^onWYjOo^;Rhom3@d?oPh>001Oo^k^h02oo@d=3o^;Rhoj2P
X?nc/k?o`<30olW9bOoCdm?ofMWIomgMgOoRh^;oiNGU00;oj^[Z00?ok>c/
ong]kOo]kNd01?o^k^h01?oWinOo4Q8BoeaLG?o`l?05onk^kP06ol[:b_l2
0P;o/K6aonk^k_nDU9Co7AdM0_o^k^h02olk>c_oMWIfoo3`l?o^k^koV9RH
oaXJ6_o^k^kocLg=o`000?n;Rh_ol?3`00?ok^k^00Goc/k>o`000?n[Zj_o
k^k^oo3`l003onk^kP05oc/k>omfMWKok^k^onk^k_o`l?000oo^k^h2ong]
k@;ok>c/00gojNWYonKVi_oShn?oh>3Pom_KfooEeMGocLg=olG5aOnk^k_o
YjNWokRh^?o@d=3oh>3P00Gok^k^00_od=3@okRh^?nPX:3o/k>col30`?o9
bLWodm?ComWIfOoMgMgoh^;RonGUi@02on[ZjP03onc/k?o]kNgokNg]00Oo
k^k^00col?3`onk^k_lb<S;oKfm_onk^k_ne]KGo0@41ojFUYOo`l?3oc/k>
o`000?n[Zj/4onk^kP0:oo3`l?o^k^kok^k^okNg]olD51CoRHV9onk^k_o>
c/ko0000oj^[Z`Gok^k^00?oAdM7of][Joo^k^h01_o^k^h01?o`l?3ok^k^
onk^k_o^k^h2ong]k@;ok>c/00gojNWYonKVi_oShn?oh>3Pom_KfooEeMGo
cLg=olG5aOnk^k_oYjNWokRh^?o@d=3oh>3P05Kok^k^001FonKViP0=olW9
bOnb/[;oVi^Kojb/[?nk^k_oa/K6olg=cOoCdm?oemOGom_KfooOgmoohN7Q
on;RhP02on?Sh`OoiNGU0_oVi^H6onGUi@;oi^KV00?o`<30o`000?n9RHT0
0ooUiND02_oVi^Kobl_;o`000?nWYjOoiNGUoc0`<?mkNg_oOGemo`T92One
]KD6onGUi@;oi^KV1_oUiND2onKViP?oiNGU0_oTi>@2on?Sh`0=on;Rh_oP
h>3og=cLomWIfOoFe]Kod=3@olW9bOo1`L7o]KFeojBTY?nb/[;obLW9omSH
f005onKViP0=olW9bOnb/[;oVi^Kojb/[?nk^k_oa/K6olg=cOoCdm?oemOG
om_KfooOgmoohN7Qon;RhP02on?Sh`GoiNGU00Co_[jno`000?n^[Zkoi^KV
1_oUiND01OnLW9co;Bd]obd];Ol`<33o71`L00;oiNGU00_o>CTiog9bL_oV
i^KoiNGUoi:BT_lI6AWoiNGUojZZZ_l0003o^KVionKViP03onGUi@03ojZZ
Z_l0003o=SHf00?o>3Ph00Go/;2`onGUiOli>CWoLW9bonGUi@02onKViP?o
iNGU0_oTi>@2on?Sh`0=on;Rh_oPh>3og=cLomWIfOoFe]Kod=3@olW9bOo1
`L7o]KFeojBTY?nb/[;obLW9omSHf005onKViP0=olW9bOnb/[;oVi^Kojb/
[?nk^k_oa/K6olg=cOoCdm?oemOGom_KfooOgmoohN7Qon;RhP02on?Sh`Oo
iNGU0_oVi^H01_oUiNGo<30`ofQXJ?oFe]Ko7alOoeeMG@;oi^KV00?oZZZZ
o`000?lf=SH00olh>3P02on`/;3oi^KVolc<c?m2@T;o0P82ofEUIOoLg=co
iNGUoj^[Zol0003o=SHf00?o>3Ph00Co/;2`onGUiOm5ADGoIVIV1_oUiND2
onKViP?oiNGU0_oTi>@2on?Sh`0=on;Rh_oPh>3og=cLomWIfOoFe]Kod=3@
olW9bOo1`L7o]KFeojBTY?nb/[;obLW9omSHf01FonKViP00E_o^k^h03OoA
dM7o^k^koiBDU?nWYjOo][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[J
f_oKfm/00ooLg=`2omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h3omgM
g@06omkNg_oMgMgogMgMoibLW?l0003o_;bl0_oMgMd02ooNg]kogMgMomWI
fOl0003oQHF5omgMgOl^;Rko>SXjo`820_nKVi_ogMgM00;og]kN0ooMgMd0
0ooNg]kogMgMomgMg@02omkNgP?ogMgM00?og]kNomgMgOoMgMd00_oNg]h2
omgMg@;og=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm
_Kgo/;2`oj2PX?nk^k_odM7Aon7Qh@Gok^k^00godM7Aok^k^onDU9CoYjNW
okJf]_o0`<3oa/K6olc<c?oAdM7oe=CDomOGeooJf][ofm_K00?og=cL0_oN
g]h2omgMg@04oi^KVol0003o`l?3omgMg@;og]kN0ooMgMd01_oNg]kogMgM
omgMgOoLg=coP820oa`L70;ogMgM00_o=cLgoe1@D?oMgMgog]kNohR8R?lI
6AWogMgMokfm_Ol0003oOGemomgMg@02omkNgP0<omgMgOnm_Kgo0000oiBD
U?nc/k?o[:b/o`820_o7alOogMgMocLg=om^KVkog]kN0_oMgMd2omkNgP;o
gMgM0_oLg=`03_oKfm_of][JomSHf?oFe]Kod];Bom3@d?o:b/[oaLG5okfm
_On`/;3oX:2Pok^k^ooAdM7ohN7Q1Oo^k^h03OoAdM7o^k^koiBDU?nWYjOo
][Jfol30`?o6a/Koc<c<om7AdOoDe=CoemOGom[Jf_oKfm/00ooLg=`2omkN
gP?ogMgM00Kog]kNomgMgOoMgMgog]kNobl_;ol20P82o`00000>ojRXZ?oM
gMgogMgMokjn__l0003oU9BDok>c/on/[:co0P82olK6a_oMgMgo>3PhocTi
>Onm_Kd2omgMg@0;omkNg_nm_Kgo0000oiBDU?nd];Co[:b/o`820_o6a/Ko
g]kNod92@_mRHV800_oNg]h3omgMg@03omkNg_oMgMgogMgM00;og]kN0_oM
gMd2omcLg00>om_KfooJf][of=SHomKFe_oBd];od=3@ol[:b_o5aLGo_Kfm
ok2`/?nPX:3o^k^kom7AdOoQhN5Fonk^kP00E_ooool03OoShn?ocLg=ohf=
SOnNWYko[Jf]okVi^Oo2`/;oalO7olc<c?o@d=3od];BomGEeOoFe]H00_oG
emL00ooHf=SofMWIomWIf@0>omWIf@03ojVYZOl0003o];Bd00CofMWI00So
/K6ao`000?nATI7ofMWIobd];OmTI6Co71`Loh61PACofMWI0_oHf=P2omOG
e`0=omGEeOoCdm?od=3@olk>c_o:b/[oaLG5okno_one]KGoZJVYoiVIVOo=
cLgohn?Soo?cl`05ooooo`0=on?Shoo=cLgoSHf=oijNW_n][Jgo^KViol;2
`_o7alOoc<c<om3@d?oBd];oeMGEomKFeP02omOGe`03omSHf?oIfMWofMWI
00;ofMWI00?oZJVYo`000?nb/[801ooIfMT01OnIVIWo^KViomKFe_mBDU;o
AdM700;ofMWI00Ko=SHfoa4A4OmTI6Co_;blodY:B_m1@D42omWIf@05ocDe
=OlQ8B7oXJ6QomSHf?nl_;`00_oIfMT01Ole=CGoFe]Kom;Bd_n6QXKo92@T
00;ofMWI00?o=SHfofa/K?oIfMT01OoIfMT2omSHf0;oemOG00goeMGEom?C
doo@d=3oc/k>ol[:b_o5aLGo_knookFe]OnYZJWoVIVIolg=cOoShn?olo?c
00Gooooo00gohn?Solg=cOn=SHgoWYjNojf][Oni^KWo`/;2olO7aoo<c<co
d=3@om;Bd_oEeMGoe]KF00;oemOG00?of=SHomWIfOoIfMT01ooIfMT01_l]
;BgoIFEUol71`On3Ph?o1PH6oifMW@;ofMWI00Go=CDeoe]KFooBd];oQXJ6
ob@T9002omWIf@05obh^;_moOgoofMWIolG5aOoDe=@00_oIfMT02ole=CGo
Fe]Kom;Bd_n6QXKo92@TomWIfOoCdm?o?ShnoeaLG?o?clooeMGE00WofMWI
0_oHf=P2omOGe`0=omGEeOoCdm?od=3@olk>c_o:b/[oaLG5okno_one]KGo
ZJVYoiVIVOo=cLgohn?Soo?cl`1Fooooo`00E_o^k^h03OoHf=Soa/K6ohV9
ROnCTi?oXZ:Rojn_[onj^[[o`L71olO7aoo;bl_oc/k>om3@d?oAdM400_oC
dm<3omCDe0;oeMGE00Coe]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@0DomKF
e_oEeMGoe]KFomGEe?o5aLGo0P82ohN7QooEeMGoe]KFomGEeOoFe]KoLg=b
o`000?na/K7oeMGEobd];OmbLW;o/K6ao`l?3onPX9l2omCDe0;oeMGE00Co
e]KFomGEeOoFe]KoeMGD0_oDe=@2omGEe@04omKFe_oEeMGoe]KFomGEe0;o
e=CD0_oEeMD04?oDe=Codm?Com?CdooAdM7od=3@olg=cOo:b/[o`l?3okjn
__nf][KoZj^[oifMWOnBTY;oa/K6omSHf?oRh^85onk^kP0=omSHf?o6a/Ko
RHV9oi>CTonRXZ;o[jn_okZj^_o1`L7oalO7ol_;boo>c/kod=3@om7Ad@02
om?Cd`?oe=CD0_oEeMD01?o6a/Ko0@41oh>3PooEeM@2omCDe0;oeMGE01Ko
e]KFomGEeOmcLg?o:BTYo`d=3Ol_;booXj>SomGEeOoFe]KoATI6ogEeMOmU
IFCo410@obHV9_nSXj?oeMGEomKFe_o1`L7oBDU9o``<3?l92@Wo7alO0_oE
eMD03?o1`L7o>c/ko`X:2_lG5aOoV9RHomCDe?oEeMGo=CDeofYZJ_oEeMGo
e]KFomGEe0;oe=CD0_oEeMD04?oDe=Codm?Com?CdooAdM7od=3@olg=cOo:
b/[o`l?3okjn__nf][KoZj^[oifMWOnBTY;oa/K6omSHf?oRh^85onk^kP0=
omSHf?o6a/KoRHV9oi>CTonRXZ;o[jn_okZj^_o1`L7oalO7ol_;boo>c/ko
d=3@om7Ad@02om?Cd`?oe=CD0_oEeMD09_oFe]KoeMGEomKFe_oEeMCoe=CD
ob`/;?mSHf?oeMGEomKFe_ll?3coADE5omGEe?oDe=Co_knooc/k>ol:2P[o
5aLGoiRHV?oFe]KoeMGDoijNW_l`<33o3@d=o`l?3oo2`/;oeMGEomKFe_o0
`;oo>c/ko`X:2_lG5aOoV9RHomKFe_mZJV[o1PH6o`X:2OlF5QKoT92@0_oE
eMD01?oFe]KoeMGEomKFe_oEeM@2omCDe0;oeMGE013oe=CDom?CdooCdm?o
dM7Aom3@d?o=cLgob/[:ol?3`onn_[ko][Jfoj^[ZonMWIgoTY:BolK6a_oH
f=Soh^;RE_o^k^h005Koi^KV01;oe]KFolO7aon=SHgoRHV9oiNGUonUYJGo
/[:bokno_oo;bl_odM7AomGEeOoGemOofMWIom[Jf_oKfm_of][Jom_KfooL
g=`7om_Kf`03omcLg?oKfm_ofm_K00Gofm_K00?oF5QHobDU9Oo?cll00_oK
fm/03?oEeMGo;bl_od51@OoLg=cofm_Kobh^;_meMGGofm_KoiRHV?lB4Q;o
_knoomcLg0Oofm_K00?og=cLom_KfooKfm/01OoKfm/04ooLg=cofm_Kom_K
fooKfm_of][JomWIfOoHf=Soe]KFom?Cdoo=cLgo`/;2okJf]_n/[:coWinO
oi2@T?nCTi?oalO7omKFe_oMgMd01OoVi^H04_oFe]KoalO7ohf=SOn9RHWo
UiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooIfMWof][Jom_KfooJ
f][ofm_KomcLg0?ofm_K00GoEEEEoalO7oo;bl_ofm_KomcLg006om_Kf`03
omWIfOoLg=cofm_K00Gofm_K00?of][JomcLg?oKfm/01OoKfm/00ooHf=So
g=cLom_Kf`03om_Kf`07omSHf?oKfm_ofm_KomcLg?oKfm_o=SHfofe]K@04
om_Kf`0ComcLg?oKfm_ofm_Kom_KfooJf][ofMWIomSHf?oFe]Kodm?Colg=
cOo2`/;o][Jfojb/[?nOWiooT92@oi>CToo7alOoe]KFomgMg@05onKViP0B
omKFe_o7alOoSHf=ohV9ROnGUiOoYJFUok:b/_no_koobl_;om7AdOoEeMGo
emOGomWIfOoJf][ofm_Kom[Jf_oKfm_og=cL1ooKfm/01_l^;RkoIVIVom_K
fooKfm_o;Bd]odU9B@;ofm_K00?og=cLom_KfooHf=P01OoKfm/00ooLg=co
f=SHom_Kf`05om_Kf`03omWIfOoKfm_ofm_K00;ofm_K00Co@T92of5QHOoK
fm_og=cL1ooKfm/04ooLg=cofm_Kom_KfooKfm_of][JomWIfOoHf=Soe]KF
om?Cdoo=cLgo`/;2okJf]_n/[:coWinOoi2@T?nCTi?oalO7omKFe_oMgMd0
E_oVi^H005Kok^k^00_oh^;RomKFe_nPX:3oNWYjohR8R?nFUYKoZZZZolC4
a?oEeMGofm_KomkNgP02on3Ph0?oh^;R00?oi>CTon?ShooShn<01OoShn<0
0ooTi>Cohn?Son?Sh`05on?Sh`09onCTi?oBd];o>SXjob@T9?meMGGoNWYj
obh^;_l/;2cob/[:00;ohn?S00Oo<30`ogUiNOoShn?ohn?SogQhN?lX:2So
f=SH00Kohn?S00?oi>CTon?ShooShn<01OoShn<01?oTi>Cohn?Son?ShooS
hn<2on;RhP0>on7QhOoPh>3ogmoOomcLg?oGemOoaLG5ojb/[?nNWYkoT92@
oh:2P_nTY:Coe]KFon;Rh_oXj>P5onk^kP0;on;Rh_oFe]KoX:2PogYjN_n8
R8SoUYJFojZZZ_o4a<CoeMGEom_KfooNg]h00_oPh>03on;RhP03onCTi?oS
hn?ohn?S00;ohn?S00SodM7AocTi>OlJ6Q[oKFe]ohJ6Q_mWIfOo:RXZojVY
Z@?ohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?S
h`03onCTi?oShn?ohn?S00Gohn?S00Goi>CTon?ShooShn?o>3Phog5aL@03
on?Sh`04onCTi?oShn?ohn?Son?Sh`;oh^;R00kohN7Qon3Ph?oOgmoog=cL
omOGeoo5aLGo[:b/oijNW_n@T93oPX:2ojBTY?oFe]Koh^;RonSXj0Gok^k^
00_oh^;RomKFe_nPX:3oNWYjohR8R?nFUYKoZZZZolC4a?oEeMGofm_KomkN
gP02on3Ph0?oh^;R00?oi>CTon?ShooShn<01OoShn<02OoTi>Co<30`obTY
:Om@D53o7alOo`X:2_n][Jgohn?SonCTi007on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<00ooShn<00oo7alOoaLG5onCTi007on?S
h`04onCTi?oShn?ohn?Son?Sh`;oh^;R00kohN7Qon3Ph?oOgmoog=cLomOG
eoo5aLGo[:b/oijNW_n@T93oPX:2ojBTY?oFe]Koh^;RonSXj5Kok^k^001F
ooooo`0>ooKfm_o]kNgoclo?ogmoOomhN7SoQXJ6oinOWoo5aLGof=SHomgM
gOoOgmoohN7Qon;Rh_oShn<3onCTi0CoiNGU0_oTi>@00ooUiNGoi>CTonGU
i@03onGUi@;oi>CT00[oiNGUonCTi?oUiNGohn?Soi^KVom/K6coIfMWoi>C
TooOgmooi>CT0_oUiND01onNWYko^k^konCTi?oTi>CoiNGUoi>CTonm_Kd0
0ooUiND2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@01?oUiNGoi>CT
onGUiOoUiND3onCTi00>on?ShooQhN7oh>3PomoOgooJf][oa/K6oj6QXOn=
SHgoP820ohR8R?o@d=3okNg]ooKfm_okno/5ooooo`0>ooKfm_o]kNgoclo?
ogmoOomhN7SoQXJ6oinOWoo5aLGof=SHomgMgOoOgmoohN7Qon;Rh_oShn<3
onCTi0CoiNGU00Soi>CTon?ShonOWiooLW9boeiNG_mkNg_oVi^KomOGe`;o
i>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU00?o
iNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00KoiNGUonCTi?oU
iNGoiNGUocTi>OmbLW82onCTi004onGUiOoTi>CoiNGUonGUi@?oi>CT00ko
hn?Son7QhOoPh>3ogmoOom[Jf_o6a/KoXJ6Qohf=SOn0P83oR8R8om3@d?o]
kNgom_Kfoo_kn`Gooooo00kom_Kfong]kOo?clooOgmoogQhN?n6QXKoWinO
olG5aOoHf=SogMgMomoOgooQhN7oh^;Ron?Sh`?oi>CT1?oUiND2onCTi003
onGUiOoTi>CoWYjN00;oRXZ:00GoYjNWomkNg_oTi>CoiNGUonCTi004onGU
i@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi003onGUiOoTi>CoiNGU
00?oiNGU0_oTi>@00ooUiNGoi>CTonGUi@03onGUi@;oi>CT00CoiNGUonCT
i?oUiNGoiNGU0ooTi>@03_oShn?ohN7Qon3Ph?oOgmoof][JolK6a_nQXJ7o
SHf=oh20P?n8R8Sod=3@ong]kOofm_Kono_kE_ooool005Kok^k^00_oj>SX
on;Rh_oIfMWoWinOofEUIOmcLg?oSHf=ok^k^ooDe=Cof][JomgMg@02omoO
g`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00KohN7Q00koh>3PomoOgooMgMgog=cLomGEeOni^KWoSXj>og]kNom^KVko
XZ:RomWIfOoRh^;oj>SXonc/k0Gok^k^00_oj>SXon;Rh_oIfMWoWinOofEU
IOmcLg?oSHf=ok^k^ooDe=Cof][JomgMg@02omoOg`03on3Ph?oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Q
h@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooR
h^;ohN7Qon7Qh@03on7Qh@03omgMgOoOgmooh^;R00SohN7Q00koh>3PomoO
gooMgMgog=cLomGEeOni^KWoSXj>og]kNom^KVkoXZ:RomWIfOoRh^;oj>SX
onc/k0Gok^k^00_oj>SXon;Rh_oIfMWoWinOofEUIOmcLg?oSHf=ok^k^ooD
e=Cof][JomgMg@02omoOg`03on3Ph?oQhN7ohN7Q00GohN7Q00?oh^;Ron7Q
hOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q
00GohN7Q00?oh^;Ron7QhOoQhN401OoQhN400ooRh^;ohN7Qon7Qh@05on7Q
h@03on;Rh_oQhN7ohN7Q00KohN7Q00koh>3PomoOgooMgMgog=cLomGEeOni
^KWoSXj>og]kNom^KVkoXZ:RomWIfOoRh^;oj>SXonc/k5Kok^k^001FonKV
iP0<on?ShooPh>3of][Jom3@d?n:RX[oHV9RogIfM_nTY:CoalO7om;Bd_oE
eMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooK
fm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL00?ofm_KomcL
g?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg00Dom_KfooLg=cog=cL
om_KfooLg=cofm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGoW9bLogEeMOmWIfOo
SHf=om3@d?oJf][oh>3Pon?ShooUiND5onKViP0<on?ShooPh>3of][Jom3@
d?n:RX[oHV9RogIfM_nTY:CoalO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oo
g=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003
om_KfooLg=cog=cL00Gog=cL00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_o
g=cLomcLg005omcLg00Dom_KfooLg=cog=cLom_KfooLg=cofm_Kom[Jf_oI
fMWof=SHom?Cdoo5aLGoW9bLogEeMOmWIfOoSHf=om3@d?oJf][oh>3Pon?S
hooUiND5onKViP0<on?ShooPh>3of][Jom3@d?n:RX[oHV9RogIfM_nTY:Co
alO7om;Bd_oEeMGof=SH0_oJf]X3om_Kf`Oog=cL00?ofm_KomcLg?oLg=`0
1OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg00Dom_K
fooLg=cog=cLom_KfooLg=cofm_Kom[Jf_oIfMWof=SHom?Cdoo5aLGoW9bL
ogEeMOmWIfOoSHf=om3@d?oJf][oh>3Pon?ShooUiNEFonKViP00E_o^k^h0
3_o]kNgoj^[ZonOWiooRh^;oclo?ohZ:R_mJFU[oNg]koj>SXonl_;coa/K6
ol_;boo=cLgoclo?0_oAdM45om;BdP03om7AdOoBd];odM7A00God];B00?o
dM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoB
d];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7A
d@03om;BdP;odM7A00god=3@olo?coo<c<cob<S8ok^k^onLW9coLW9boe]K
Fon=SHgoclo?on;Rh_oWinOoj^[Z00;okNg]1Oo^k^h03_o]kNgoj^[ZonOW
iooRh^;oclo?ohZ:R_mJFU[oNg]koj>SXonl_;coa/K6ol_;boo=cLgoclo?
0_oAdM45om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM40
1OoBd]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B
00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7od];Bom7Ad@03om;BdP;odM7A
00god=3@olo?coo<c<cob<S8ok^k^onLW9coLW9boe]KFon=SHgoclo?on;R
h_oWinOoj^[Z00;okNg]1Oo^k^h03_o]kNgoj^[ZonOWiooRh^;oclo?ohZ:
R_mJFU[oNg]koj>SXonl_;coa/K6ol_;boo=cLgoclo?0_oAdM45om;BdP03
om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoBd]800ooAdM7o
d];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oA
dM401OoBd]800ooAdM7od];Bom7Ad@03om;BdP;odM7A00god=3@olo?coo<
c<cob<S8ok^k^onLW9coLW9boe]KFon=SHgoclo?on;Rh_oWinOoj^[Z00;o
kNg]E_o^k^h005Kooooo0_ono_h03_okno_onOWioo?cloo/k>coYZJVog5a
LOmXJ6SoPh>3oiNGUonSXj?o[:b/ojn_[ona/K7o/[:b0_nd];@2okJf]P;o
];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];Bd
okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co
]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o
][Jf0_nd];@04one]KGo][JdokBd]?nd];Co][Jfok>c/onb/[;o/k>cojn_
[onZZZ[oW9bLoh:2P_mRHV;oLW9bojVYZOo/k>colo?cooWinOokno/00_on
o_h6ooooo`;oo_kn00kono_kooWinOoclo?ok>c/ojJVY_maLG7oJ6QXoh>3
PonGUiOoXj>Sojb/[?n_[joo/K6aok:b/P;o];Bd0_nf][H2okBd]004okFe
]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf
]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004okFe]Onf][Co
];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd
01?o]KFeokJf]?nd];Co];BdokJf]_nc/k?o/[:bok>c/on_[jooZZZZoibL
W?n2PX;oHV9Rog9bL_nYZJWok>c/oo?clooinOWono_k00;oo_kn1_ooool2
ooknoP0>oo_knooinOWolo?conc/k?nVYZKoLG5aofQXJ?n3Ph?oUiNGoj>S
Xon/[:co[jn_ok6a/Onb/[82okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd
]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]004
okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]00CokFe]Onf
][Co];BdokBd]?nf][Ko/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9R
H_mbLW;oZJVYonc/k?oclo?onOWioo_kn`02ooknoUOooooo001Gonk^kP;o
kNg]00oojn_[onSXj?oUiNGoh^;Rol_;bonNWYkoOGemof][JomTI6CoJFUY
og9bL_mdM7CoNGUiogalO?mkNg/00_mmOGd01_mlO7coNg]kogalO?mmOGco
O7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06
ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]kogalO?mm
OGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@07ogalO?mkNg_oO7alogemO?mlO7coNg]kogemO@02ogYjNP0;ogMgMomd
M7CoKVi^og5aLOmoOgooWYjNolc<c?oRh^;oiNGUonSXj?o[jn/00_o]kNd8
onk^kP;okNg]00oojn_[onSXj?oUiNGoh^;Rol_;bonNWYkoOGemof][JomT
I6CoJFUYog9bL_mdM7CoNGUiogalO?mkNg/00_mmOGd01_mlO7coNg]kogal
O?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2
ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_mlO7coNg]k
ogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mk
Ng/2ogemO@07ogalO?mkNg_oO7alogemO?mlO7coNg]kogemO@02ogYjNP0;
ogMgMomdM7CoKVi^og5aLOmoOgooWYjNolc<c?oRh^;oiNGUonSXj?o[jn/0
0_o]kNd8onk^kP;okNg]00oojn_[onSXj?oUiNGoh^;Rol_;bonNWYkoOGem
of][JomTI6CoJFUYog9bL_mdM7CoNGUiogalO?mkNg/00_mmOGd01_mlO7co
Ng]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogal
O?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd01_ml
O7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGel
ogalO?mkNg/2ogemO@07ogalO?mkNg_oO7alogemO?mlO7coNg]kogemO@02
ogYjNP0;ogMgMomdM7CoKVi^og5aLOmoOgooWYjNolc<c?oRh^;oiNGUonSX
j?o[jn/00_o]kNeHonk^kP00F?oVi^H2onGUi@0:onCTi?oRh^;oh>3PomgM
gOoKfm_of][JomSHf?oGemOoe]KFomGEeCOoe]KF00[oeMGEomKFe_oGemOo
f=SHom[Jf_oKfm_ogMgMon3Ph?oRh^;oi>CT0_oUiND:onKViP;oiNGU00[o
i>CTon;Rh_oPh>3ogMgMom_KfooJf][of=SHomOGeooFe]KoeMGE=ooFe]H0
2_oEeMGoe]KFomOGeooHf=Sof][Jom_KfooMgMgoh>3Pon;Rh_oTi>@2onGU
i@[oi^KV0_oUiND02_oTi>Coh^;Ron3Ph?oMgMgofm_Kom[Jf_oHf=SoemOG
omKFe_oEeMDgomKFeP0:omGEeOoFe]KoemOGomSHf?oJf][ofm_KomgMgOoP
h>3oh^;RonCTi0;oiNGUFOoVi^H005[ok^k^0_o]kNd00oo/k>coj^[Zon[Z
jP02onSXj0;oinOW>OoVi^H2onOWi`;oj>SX0_oZj^X00oo/k>cokNg]ong]
k@0>onk^kP;okNg]00?ok>c/on[Zj_oZj^X00_oXj>P2onOWicWoi^KV0_oW
inL2onSXj0;oj^[Z00?ok>c/ong]kOo]kNd03_o^k^h2ong]k@03onc/k?oZ
j^[oj^[Z00;oj>SX0_oWinLionKViP;oinOW0_oXj>P2on[ZjP03onc/k?o]
kNgokNg]05_ok^k^003ooooook?ooooo003oonk^k[?ok^k^003oonKVi[?o
i^KV003oonk^k[?ok^k^003ooooook?ooooo003oonk^k[?ok^k^003oonKV
i[?oi^KV0002onk^k_ooU9BD/?nDU9@1onk^kP000_ooool00onDU9Cooooo
ooooo`3oooooojcooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^
kP3oonk^kZcok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP3o
onKViZcoi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP3oonk^
kZcok^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`3oooooojco
oooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP3oonk^kZcok^k^
0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP3oonKViZcoi^KV0OnD
U9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP2Jonk^kQgooooo00?olZNW
ooK4a?ooool0D_ooool00oobYjOom/C4ooooo`0booooof[ok^k^0OnDU9@1
onk^kP000_ooool00onDU9Coooooooooo`2gooooo`03onMBD_o^Rh_ooooo
05;ooooo00?oie9Bonj;Roooool0W?ooool1oiBDU07ooooo0002onk^kP03
oiBDU?o^k^kok^k^09[ok^k^0oooool00oonoOgon]oOoo_Xj005ooooo`03
ooc]kOonoOgooooo00;ooOGe3Oooool01OoWDU;okX^;ookno_okinOoo_kn
00Wooooo00?ooOGeoocZj_ooool04?ooool00oommOGoo>[Zooooo`0<oooo
o`03oo_WioonoOgooooo00Sooooo00?oo_gmoo[Ogookj>P01Oooool00ool
kNgoo_gmooooo`02oogem@gooooo00Goie9Bonj;Roono_konnOWooknoP09
ooooo`03oogemOolj^[ooooo013ooooo00?ooOGeoocZj_ooool03?ooool0
0ookinOoo_gmooooo`02ooooof[ok^k^0OnDU9@1onk^kP000_oVi^H00onD
U9Coi^KVonKViP2JonKViP;ooooo00KomKNgon0R8_oP92CohcTionE9BOoc
[jl2ooooo`09onURH_oP823ohS0`oo:UYOoQ:R[ojFMWoooooooWDU;okX^;
00;ooooo00KokXN7onMEEOooooooooooooFk^ooP8B42ooooo`06onMBD_oX
G5cohc/kon8a<OoQ:b_om/;20_ooool02_oWDU;okX^;oooooooooooonnWY
onQKFooO6a_ohcPhon4];OogalL7ooooo`03oneoOooVBd_ooooo00?ooooo
00WonnWYonQKFooO6a_ohcPhon4];OogalOon^7Qon4[:oohd=000_ooool0
2?o_T93ohRh^oo_YjOoooooonMOGon<j>_oR=3Com/302?ooool01_oe]kOo
h28Ron0T9?oS>CWoiDU9oo>_[`;ooooo00WojF9Ron0P8?oR<33olZFUon4Z
:_oYIfOoooooonMBD_o^Rh/00_ooool01_o^QhOoieEEoooooooooooomK^k
on0Q8@;ooooo00Koie9BonQLG?oS>c_ohS4aon4[:oof`/82ooooo`0:onMB
D_o^Rh_ooooooooooookjNWoj5]KomlK6ooS>3SohBd]ooO7a`Oooooo00?o
kGmoonI;Boooool00oooool02OokjNWoj5]KomlK6ooS>3SohBd]ooO7aooj
hN7ohB/[ooS@d002ooooo`08onn@T?oR;RkonnWYoooooooiemOohcXjon8d
=?of`<03ooooof[oi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^
kP2Jonk^kP;ooooo00gonM[JooK5aOonn_[ooooooo:VY_oO71con^7QooO;
booO71con^3Poo_Xj?oZJf_ohBPX00;ooooo00Koie9Bonj;Rooooooooooo
onj7QooWEED2ooooo`0>ooFk^ooP8B7ooooooooooooWDU;oieEEooc`l?on
no_okXV9on4Z:_omm?CoooooonMBD_o^Rh/2ooooo`06onMFE_oWDU;on^;R
ooooooomm?CooO?c1oooool00oo]OgooiT];ooooo`03ooooo`0=onMFE_oW
DU;on^;Rooooooomm?CooO?coooooood/K7ohcPhoogbl_ofa<CogahNooO6
aP02ooooo`03onenO_oWDe?oo_kn00Wooooo00gonM[JooK5aOonn_[ooooo
oo:VY_oO71con^7QooO;booO71con^3Poo_Xj?oZJf_ohBPX00;ooooo00Ko
ie9Bonj;Roooooooooooonj7QooWEED2ooooo`0>ooFk^ooP8B7ooooooooo
oooWDU;oieEEooc`l?onno_okXV9on4Z:_omm?CoooooonMBD_o^Rh/2oooo
o`06onMFE_oWDU;on^;Rooooooomm?CooO?c1oooool00oo]OgooiT];oooo
o`03ooooo`0=onMFE_oWDU;on^;Rooooooomm?CooO?coooooood/K7ohcPh
oogbl_ofa<CogahNooO6aP02ooooo`03onenO_oWDe?oo_kn00CoooooJ_o^
k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooooooo03_ooooo6OoO6ATS
oooooaWo00004?ooool02Ookhn?ogaTIooFm_Oojg=coga/KooK3`ooooooo
lZRXon<e=@02ooooo`06onMBD_o^Rh_oooooooooooo^QhOoieEE0_ooool0
1_oe^k_oh24Qooooooooooooie9Bonj;R`;ooooo00[onnWYomlI6Ood]KGo
ooooonMBD_o^Rh_ooooooo[Ph?oO6AWom[jn2oooool00oo]OgooiT];oooo
o`02ooooo`03oo[Ph?oO6AWom[jn00Kooooo00CojgEeonQOGooQ;Bgoki:B
0oooool00ooXGUkokGmoooooo`0=ooooo`09oo_ShooO6AWomKfmoo[Lg?oO
6a_om/?3ooooooobZ:SohcDe00;ooooo00Koie9Bonj;Roooooooooooonj7
QooWEED2ooooo`06ooFk^ooP8B7ooooooooooooWDU;okX^;0_ooool02_ok
jNWogaTIooBe]Oooooooie9Bonj;Rooooooon^3PomlI6Oof_[h;ooooo`03
oneoOooVBd_ooooo00;ooooo00?on^3PomlI6Oof_[h01_ooool01?o[MGGo
j5mOon4];Oo_TY83ooooo`03onQNG_o]Ogoooooo06kooooo0OnDU9@1oooo
o`000_o^k^h00onDU9Cok^k^onk^kP0konk^kQWogaTI1Oo^k^hIooooo`Go
k^k^6Ol0000:onk^kPGooooo00[ooO7aonQPH?oP823ooO?coooooood]KGo
iDI6onE7AooUBDWohcDe0_ooool01_oWDU;okX^;ooooooooooookXN7onME
E@;ooooo00KomK^kon0Q8OooooooooooonMBD_o^Rh/3ooooo`09on4/;?oa
Vi_oooooonMBD_o^Rh_oooooooK4a?oO6AWoiU1@00?oiU5A00?omlW9oooo
ooooool01Oooool00oo]OgooiT];ooooo`02ooooo`03ooK4a?oO6AWoiU1@
00?oiU5A00OomlW9oooooooooooooO?con0R8_oQ9bOooOOg00?ooooo00?o
j5iNoneoOoooool03?ooool02_omlO7oj61Pon0P8?omlo?oooooooBe]OoU
ATKoiDM7onE9BOoS=CD2ooooo`06onMBD_o^Rh_oooooooooooo^QhOoieEE
0_ooool01_oe^k_oh24Qooooooooooooie9Bonj;R`?ooooo00WohB`/oo6K
Voooooooie9Bonj;Rooooooom/C4omlI6OoVD5000ooVDE400oogbLWooooo
ooooo`05ooooo`03oneoOooVBd_ooooo00;ooooo00?om/C4omlI6OoVD500
0ooVDE401oogbLWoooooooooooomlo?oh28Ron4W9oommoL00oooool00ooX
GUkokGmoooooo`04ooooo`Cok^k^:OoO6ATmonk^kP7oU9BD0Oo^k^h000;o
i^KV00?oU9BDonKVi_oVi^H0>ooVi^HIomlI6@Goi^KV6Oooool5onKViQWo
00002_oVi^H4ooooo`04ooFm_OoR<S;ohBd]ooK4a0Cooooo00?oo_gmoo6N
W_oS=SH00_ooool02_oWDU;ok7]kooooooooooookXJ6onE7Aoono_kooooo
ooFj^_oP8B42ooooo`0BonMBD_o^QhOoooooooooooolk^kogaTIooO8b?oo
ooooie9Bonj;Rooooooon]kNomlI6Ood/k?on=?CooO<c?oO6a_onnOW1ooo
ool00oo]OgooiT];ooooo`02ooooo`07oo[Ng_oO6AWom;>cooSCdoogc<co
ga/Koo_Wi`02ooooo`04onf3PooS=SKoj5YJonf2PP?ooooo00?oj5iNoneo
Ooooool02oooool01?oe_KgohS8bon4];Oofa<@4ooooo`03ookmoOoaWYko
hcHf00;ooooo00[oie9BonakNoooooooooooonj6Q_oUAdOoo_knoooooooe
^[[oh24Q0_ooool04_oWDU;okXN7ooooooooooooo>k^omlI6Oogb<Sooooo
onMBD_o^Rh_ooooooo[Ng_oO6AWom;>cooSCdoogc<coga/Koo_Wi`Oooooo
00?okGmoonI;Boooool00_ooool01oojg]kogaTIooBc/oohdm?omlc<omlK
6ookinL00_ooool01?o]Ph?ohcHfonQJF_o]PX83ooooo`03onQNG_o]Ogoo
oooo00Cooooo1?oVi^HYomlI6Cgoi^KV0OnDU9@1onKViP000_o^k^h00onD
U9Cok^k^onk^kP0konk^kQWogaTI1Oo^k^hIooooo`Gok^k^6Ol0000:onk^
kP?ooooo00Cokhf=omlI6OoYIVKonnSX0oooool01Ooe^k_on]gMooklo?o[
L73ojFAT00;ooooo00[oie9Bon4[:oo`UiOoo>[ZonIADOoR=3Cojfm_oo_T
i?o]OWkoiDM70_ooool02_oWDU;ohS4aoo6QXOojgmook7Mgon4X:?ono?co
ooooonMBD_o^Rh/2ooooo`05onIADOo/NGWooOOgoo:WYooT?cl02?ooool0
0oo]OgooiT];ooooo`03ooooo`05onIADOo/NGWooOOgoo:WYooT?cl00_oo
ool03?oe^;SogalOooS@d?oljn_ohRh^ooO9bOooooooo_WionQJF_o/Ng_o
oOGeookkn`Wooooo00Cokhf=omlI6OoYIVKonnSX0oooool01Ooe^k_on]gM
ooklo?o[L73ojFAT00;ooooo00[oie9Bon4[:oo`UiOoo>[ZonIADOoR=3Co
jfm_oo_Ti?o]OWkoiDM70_ooool02_oWDU;ohS4aoo6QXOojgmook7Mgon4X
:?ono?coooooonMBD_o^Rh/2ooooo`05onIADOo/NGWooOOgoo:WYooT?cl0
2?ooool00oo]OgooiT];ooooo`03ooooo`05onIADOo/NGWooOOgoo:WYooT
?cl00_ooool03?oe^;SogalOooS@d?oljn_ohRh^ooO9bOooooooo_WionQJ
F_o/Ng_ooOGeookkn`?ooooo1?o^k^hYomlI6Cgok^k^0OnDU9@1onk^kP00
0_ooool00onDU9Coooooooooo`0koooooaWogaTI8ooooolIo`0000cooooo
00?onnSXomlJ6_oaWId01Oooool01Oo`UIGoiDI6on4W9ooVC4comlW900;o
oooo00[ojFAToo2FU_o]OWkohBLWon@m?OoifMWolZ>Son8`<?oS=CGom;Fe
0_ooool01_oYI6Col9FEon]dM?oP92CohRl_ooB`/0;ooooo00Woie9Bonj;
Rooooooooooooo_Xj?oWFEWoh2@Ton8b<_oe_[h02?ooool00oo]OgooiT];
ooooo`03ooooo`09oo_Xj?oWFEWoh2@Ton8b<_oe_[koooooooc[jooT@43o
lJ6Q00;ooooo00Som;JfonIADOonn_[okX^;on0P8?oP8b?ohS4aooBe]@So
oooo00?onnSXomlJ6_oaWId01Oooool01Oo`UIGoiDI6on4W9ooVC4comlW9
00;ooooo00[ojFAToo2FU_o]OWkohBLWon@m?OoifMWolZ>Son8`<?oS=CGo
m;Fe0_ooool01_oYI6Col9FEon]dM?oP92CohRl_ooB`/0;ooooo00Woie9B
onj;Rooooooooooooo_Xj?oWFEWoh2@Ton8b<_oe_[h02?ooool00oo]Ogoo
iT];ooooo`03ooooo`09oo_Xj?oWFEWoh2@Ton8b<_oe_[koooooooc[jooT
@43olJ6Q00;ooooo00Som;JfonIADOonn_[okX^;on0P8?oP8b?ohS4aooBe
]@Oooooo:OoO6ATmooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^
k^h0>oo^k^hIomlI6@Gok^k^1Oooool?omlI6@Gooooo1Oo^k^h5o`0000oo
gaTI1Ol0000:onk^kP;ooooo00?on]_KomlJ6_okjNT01oooool00oonoOgo
ooooooooo`05ooooo`03ookno_oooooooooo00;ooooo00?oo_knoooooooo
ool01?ooool00oonoOgoooooooooo`02ooooo`03onMBD_o^Rh_ooooo00?o
oooo00?oo_clooooooooool02?ooool00oo]OgooiT];ooooo`05ooooo`03
ooklo?oooooooooo00[ooooo00?oj5iNoneoOoooool02Oooool00oojfm_o
gaXJoo_Yj@07ooooo`03ookmoOoooooooooo00Gooooo00?oo_knoooooooo
ool00_ooool00oono_koooooooooo`04ooooo`03ookmoOoooooooooo00;o
oooo00?oie9Bonj;Roooool00oooool00oono?coooooooooo`08ooooo`03
oneoOooVBd_ooooo00Gooooo00?oo_clooooooooool02_ooool00ooXGUko
kGmoooooo`04ooooo`Cok^k^:OoO6ATmonk^kP7oU9BD0Oo^k^h000;oi^KV
00?oU9BDonKVi_oVi^H0>ooVi^HIomlI6@Goi^KV1Oooool?omlI6@Gooooo
1OoVi^H5o`0000oogaTI1Ol0000:onKViP?ooooo00Goj5]KonI=COo`VIWo
jg5aonYXJ00Mooooo`03onMBD_o^Rh_ooooo00_ooooo00GokHB4on]dM?o[
M7Coi451on4/;003on]dM003ooc_kooooooooooo00gooooo00?onn?Soo[Q
hOooool02_ooool01OoXFe_oiTe=oo2IVOo[LG7ojVQX01gooooo00?oie9B
onj;Roooool02oooool01Oo]Q8CojgAdon]dM?oT@D7ohB`/00?ojgAd00?o
o>o_ooooooooool03Oooool00ookhn?on^7Qooooo`04ooooo`Coi^KV:OoO
6ATmonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0>oo^k^hI
omlI6@Gok^k^1Oooool?omlI6@Gooooo1Oo^k^h5o`0000oogaTI1Ol0000:
onk^kP?ooooo00Goo__kooFm_Oo/O7col9>CooK5a@0Mooooo`03onMBD_o^
Rh_ooooo00_ooooo00?oljj^oo:SXoobXj<01OobXj<00oommOGooooooooo
o`0Jooooo`05ookknooe_Kgok7aloo2CToofaLD07Oooool00ooWDU;okX^;
ooooo`0;ooooo`03oo>^[_obXj?olZ>S00GolZ>S00?ooOGeooooooooool0
5?ooool4onk^kRWogaTI?Oo^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oo
oooooooo03_ooooo6OoO6AT:ooooo`oogaTI2_ooool5o`0000oogaTI1Ol0
000_ooooo`03ookknoonoOgooooo05;ooooo00?oo__kookmoOooool0;_oo
oolYomlI6Cgooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP0k
onk^kQWogaTI1Oo^k^h5ooooo`oogaTI1Oooool5onk^kPGo00003ooO6AT5
o`0000[ok^k^Yoooool4onk^kRWogaTI?Oo^k^h1oiBDU07ok^k^0002onKV
iP03oiBDU?oVi^Koi^KV03_oi^KV6OoO6AT5onKViPGooooo3ooO6AT5oooo
o`Goi^KV1Ol0000?omlI6@Go00002_oVi^JWooooo`Coi^KV:OoO6ATmonKV
iP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0>oo^k^hIomlI6@Go
k^k^1Oooool?omlI6@Gooooo1Oo^k^h5o`0000oogaTI1Ol0000:onk^kZOo
oooo1?o^k^hYomlI6Cgok^k^0OnDU9@1onk^kP000_ooool00onDU9Cooooo
ooooo`0koooooaWogaTI2_ooool?omlI6@[ooooo1Ol0000?omlI6@Go0000
]OoooolYomlI6Cgooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^
kP0konk^kQWogaTI1Oo^k^h5ooooo`oogaTI1Oooool5onk^kPGo00003ooO
6AT5o`000;Gok^k^:OoO6ATmonk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BD
onKVi_oVi^H0>ooVi^HIomlI6@Goi^KV1Oooool?omlI6@Gooooo1OoVi^H5
o`0000oogaTI1Ol0002eonKViRWogaTI?OoVi^H1oiBDU07oi^KV0002onk^
kP03oiBDU?o^k^kok^k^03_ok^k^6OoO6AT5onk^kPGooooo3ooO6AT5oooo
o`Gok^k^1Ol0000?omlI6@Go0000]Oo^k^hYomlI6Cgok^k^0OnDU9@1onk^
kP000_ooool00onDU9Coooooooooo`0koooooaWogaTI2_ooool?omlI6@[o
oooo1Ol0000?omlI6@Go00002_oooolMomlI6@03ohX?3onV4Q;ogaTI05;o
gaTI00?oRPl?ojHB4_oO6AT0<_oO6AT4ooooobWogaTI?Oooool1oiBDU07o
oooo0002onk^kP03oiBDU?o^k^kok^k^03_ok^k^6OoO6AT5onk^kPGooooo
3ooO6AT5ooooo`Gok^k^1Ol0000?omlI6@Go00002_o^k^hMomlI6@03ocL6
1_m_30cogaTI05;ogaTI00?o=`H6ofl<3?oO6AT0<_oO6AT4onk^kRWogaTI
?Oo^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Koi^KV03_oi^KV6OoO
6AT5onKViPGooooo3ooO6AT5ooooo`Goi^KV1Ol0000?omlI6@Go00002_oV
i^H3omlI6@03omdH6?o05AGobAHF00GogaTI00?ocQLGomdH6?oO6AT00_oE
5aL=omlI6@05ocL61_m_30cogQPHolPF5_oN61P02OoO6AT00ooE5aOobQHF
omlI6@0@omlI6@03omDG5oo:5QKogaTI00cogaTI00?ob1HFomdH6?oO6AT0
2?oO6AT00ooM61So`1DEolTF5P05omlI6@03olhG5ooM61SogaTI00;oeALG
3OoO6AT01Olg1PKoK``<omhH6?o85QKogQPH00WogaTI00?oeALGolXF5_oO
6AT04?oO6AT00ooE5aOobQHFomlI6@0<omlI6@03olPF5_oM61SogaTI00;o
gaTI1?oVi^HYomlI6Cgoi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^
onk^kP0konk^kQWogaTI1Oo^k^h5ooooo`oogaTI1Oooool5onk^kPGo0000
3ooO6AT5o`0000[ok^k^0_oO6AT01_nI4A7o2000o`/10OlO0`?o;`D5oi8@
40;ogaTI00WoAPL7o`H00?lF0P;oR0l?oa010Om<20SogaTIocL61_m_30`0
0_oO6AT01_mZ2`_o>PH6omlI6OoO6AWoWA4Ao`L000;ogaTI00Ko=`H6od47
1olQ0`?o5`82oa820_nT4Q82omlI6@0:ocL61_m_30cogaTIomlI6Oo:5QKo
@0L7o`800?lN0`?o5082ojPB4POogaTI00?oH`/;oc051OoO6AT00ooO6AT0
2Oo:5QKo@0L7o`800?lN0`?o5082ojPB4_o25AGo4P82ok4C4`02omlI6@08
og<<3?lD0P;obQHFomlI6Onh51Co80<3oaX20_nR4Q88omlI6@06oiTA4Ol8
003o2`41oal30ol_1@GoTQ0@0_oO6AT02Om61`Oo1P00oaH20_n83`oo4041
od`82?oO6AWo=`H6ofl<3002omlI6@06ofX;2olj1PKogaTIomlI6OnM4A7o
1`000_oO6AT01_lg1PKo@@L7ob430olG0P;o4P82oj@B4P;ogaTI00[o=`H6
ofl<3?oO6AWogaTIolXF5_m01`Oo0P00oah30olD0P;oZ18B1ooO6AT00omS
2`_o<0D5omlI6@03omlI6@09olXF5_m01`Oo0P00oah30olD0P;oZ18Bol8E
5OlB0P;o/A<C00;ogaTI00SoL``<oa@20_o:5QKogaTIokPD5?lP0`?o6P82
oj8B4P?ogaTI1?o^k^hYomlI6Cgok^k^0OnDU9@1onk^kP000_ooool00onD
U9Coooooooooo`0koooooaWogaTI8ooooolIo`0000[ooooo0_oO6AT03Onk
51CoYa8BomXH6?oO6AWoR@l?o`<00?o25AGo[A<Co`<00?o15AGobAHFodl8
2?l>0@400_oO6AT01_lg1PKoK``<omlI6OoO6AWoJP/;ocX61P;ogaTI00ko
WA4Ao`L00?oO6AWogaTIocL61_lj1PKodALGom/H6?m]30co4041om@G5ooO
6AWo=`H6ofl<30;ogaTI00Ko>`H6ocL61_o35AGogaTIom@G5ooC5aL7omlI
6@03of<;2ol`1@GogaTI00?ogaTI00go>`H6ocL61_o35AGogaTIom@G5ooC
5aOogaTIoi<@4?lN0`?odQLGojHB4_l5003oYa8B00;ogaTI00?oHP/;ocP6
1_oN61P02OoO6AT03Onk51CoYa8BomXH6?oO6AWoR@l?o`<00?o25AGo[A<C
o`<00?o15AGobAHFodl82?l>0@400_oO6AT01_lg1PKoK``<omlI6OoO6AWo
JP/;ocX61P;ogaTI00koWA4Ao`L00?oO6AWogaTIocL61_lj1PKodALGom/H
6?m]30co4041om@G5ooO6AWo=`H6ofl<30;ogaTI00Ko>`H6ocL61_o35AGo
gaTIom@G5ooC5aL7omlI6@03of<;2ol`1@GogaTI00?ogaTI00go>`H6ocL6
1_o35AGogaTIom@G5ooC5aOogaTIoi<@4?lN0`?odQLGojHB4_l5003oYa8B
00;ogaTI00?oHP/;ocP61_oN61P01?oO6AT4ooooobWogaTI?Oooool1oiBD
U07ooooo0002onk^kP03oiBDU?o^k^kok^k^03_ok^k^6OoO6AT5onk^kQWo
oooo1Oo^k^hIo`0000[ok^k^1_oO6AT02Oo45QKo0000oilA4Onm5AGo0P00
ojDB4_oO6AWoR`l?oa/30`02omlI6@06ocL61_m_30cogaTIomlI6OmZ2`_o
>PH60_oO6AT01_nM4A7o1`00omlI6OoO6AWo=`H6ofl<30;ogaTI00[obQHF
o`000?nG413ogaTIocL61_m_30cogaTIol4E5Ol0003oX18B2ooO6AT00omS
2`_o<0D5omlI6@02omlI6@03ol4E5Ol0003oX18B00KogaTI00CoF@X:od@7
1olD0P;oMPd=0ooO6AT00om31`OoH`/;omlI6@0=omlI6@09ol@F5_l0003o
Wa4AokdE5Ol2003oYA8BomlI6On;3`oo6`<300;ogaTI00Ko=`H6ofl<3?oO
6AWogaTIofX;2olj1PH2omlI6@06oidA4Ol7003ogaTIomlI6Olg1PKoK``<
0_oO6AT02_o:5QKo0000oiL@4?oO6AWo=`H6ofl<3?oO6AWo`ADEo`000?nP
4Q8;omlI6@03of<;2ol`1@GogaTI00;ogaTI00?o`ADEo`000?nP4Q801_oO
6AT01?mI2P[oA0L7oa@20_mf3@d3omlI6@03od<71omS2`_ogaTI00CogaTI
1?o^k^hYomlI6Cgok^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKV
iP0konKViQWogaTI1OoVi^HIooooo`Goi^KV6Ol0000:onKViPGogaTI00[o
dALGodD71ol6003odaLGomlI6OnG413o:`@4ob`51Ol_1@Go6`<30_oO6AT0
1_lg1PKoK``<omlI6OoO6AWoJP/;ocX61P;ogaTI00KoWA4Ao`L00?oO6AWo
gaTIocL61_m_30`3omlI6@09oa<20_mn3PkogaTIocL61_m_30cogaTIojHB
4_l0003o=@D500?o=`H600?oZa<ComlI6OoO6AT01OoO6AT00omS2`_o<0D5
omlI6@02omlI6@03ojHB4_l0003o=@D500?o=`H600OoZa<ComlI6OoO6AWo
daLGo`P00?l=0@7of1PH00?ogaTI00?o@`L7of<;2ooO6AT03?oO6AT02_oA
5aOoA@L7o`H00?oC5aOogaTIoiL@4?l[10Co;0D5obl51OlK0`<2omlI6@06
ocL61_m_30cogaTIomlI6OmZ2`_o>PH60_oO6AT01_nM4A7o1`00omlI6OoO
6AWo=`H6ofl<30?ogaTI00Wo4`82ogh>3_oO6AWo=`H6ofl<3?oO6AWoYQ8B
o`000?le1@D00olg1PH00on[4a?ogaTIomlI6@05omlI6@03of<;2ol`1@Go
gaTI00;ogaTI00?oYQ8Bo`000?le1@D00olg1PH01on[4a?ogaTIomlI6OoC
5aOo2000o`d10OoH61P00ooO6AT00om31`OoH`/;omlI6@04omlI6@Coi^KV
:OoO6ATmonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0>oo^
k^hIomlI6@Gok^k^6Oooool5onk^kQWo00002_o^k^h4omlI6@04oilA4OlH
0P;o5082ojHB4PCogaTI00?ogAPHoh4>3_lL0`<00_oO6AT02_lg1PKoG`X:
omlI6OoO6AWoJ@/;ob`51OoN61SogaTIoi`A4Ol70002omlI6@0BocL61_mZ
2`_ogaTIomlI6Oo?5aOo0000ojXC4ooO6AWo=`H6ofl<3?oO6AWo_aDEo`00
0?nE413o]A@DojhC4ol2003ob1HF1ooO6AT00omS2`_o<0D5omlI6@02omlI
6@07oklE5Ol0003oUA0@okDD5?n^4a?o0P00olPF5P02omlI6@04ofL;2olL
0`?o?`L7ofH;2`?ogaTI00?o@`L7of<;2ooO6AT02ooO6AT01?nO4A7o6082
oa@20_nV4Q84omlI6@03omdH6?n13Pko70<300;ogaTI00[o=`H6oel:2_oO
6AWogaTIofT;2ol/1@GogQPHomlI6OnL4A7o1`000_oO6AT04_lg1PKoJP/;
omlI6OoO6AWocaLGo`000?nZ4a?ogaTIocL61_m_30cogaTIoklE5Ol0003o
UA0@okDD5?n^4a?o0P00olPF5POogaTI00?oH`/;oc051OoO6AT00_oO6AT0
1ono5AGo0000oiD@4?ne51Co[Q<Co`800?o85QH00_oO6AT01?mW2`_o70<3
ocl71omV2`/3omlI6@03od<71omS2`_ogaTI00CogaTI1?o^k^hYomlI6Cgo
k^k^0OnDU9@1onk^kP000_ooool00onDU9Coooooooooo`0koooooaWogaTI
8ooooolIo`0000[ooooo0ooO6AT01?m`30co0000od/82?o95QH3omlI6@05
oidA4Onn5AGog1PHoe@92Om920P00_oO6AT02_lg1PKo4P82ogX=3Oo:5QKo
=`H6oa/30omC2@WoaAHFof8;2ol/1@D2omlI6@0:ocL61_lG0P;oQ0h>ol0E
5OmK2P[o3P41om`H6?oO6AWo=`H6ofl<30;ogaTI00Go=`H6oed:2_oH61So
RPl?obD41008omlI6@03of<;2ol`1@GogaTI00?ogaTI00Go=`H6oed:2_oH
61SoRPl?obD41002omlI6@0<oiXA4Ol6003o/A<Col/F5_lD0P;oZa<ComlI
6OoI61So?`L7oel:2_oE5aOofaPH2OoO6AT01?m`30co0000od/82?o95QH3
omlI6@05oidA4Onn5AGog1PHoe@92Om920P00_oO6AT02_lg1PKo4P82ogX=
3Oo:5QKo=`H6oa/30omC2@WoaAHFof8;2ol/1@D2omlI6@0:ocL61_lG0P;o
Q0h>ol0E5OmK2P[o3P41om`H6?oO6AWo=`H6ofl<30;ogaTI00Go=`H6oed:
2_oH61SoRPl?obD41008omlI6@03of<;2ol`1@GogaTI00?ogaTI00Go=`H6
oed:2_oH61SoRPl?obD41002omlI6@0<oiXA4Ol6003o/A<Col/F5_lD0P;o
Za<ComlI6OoI61So?`L7oel:2_oE5aOofaPH0ooO6AT4ooooobWogaTI?Ooo
ool1oiBDU07ooooo0002onk^kP03oiBDU?o^k^kok^k^09[ok^k^0_oO6AT0
0oo95QKo0@00oh0>3P05omlI6@05ogP=3Ol[10Co3@41oc451On[4a<00_oO
6AT02_m920SoN@d=of8;2ol=0@7o8P<3okXD5?n63`oo5P82oa/30onG4102
omlI6@06odT82?mh3@goF0T9o`/10OlE0P;oTQ0@0_oO6AT02Olg1PKoK``<
omlI6OoO6AWobAHFoch61_l;0@7o6082oj0A4@08omlI6@03of<;2ol`1@Go
gaTI00?ogaTI00WobAHFoch61_l;0@7o6082oj0A4OoO6AWobaHFobH41?n4
3Ph00_oO6AT02?nI4A7o=`H6omXH6?m_30co1P00o`X10OlG0P;oV14A2?oO
6AT00oo95QKo0@00oh0>3P05omlI6@05ogP=3Ol[10Co3@41oc451On[4a<0
0_oO6AT02_m920SoN@d=of8;2ol=0@7o8P<3okXD5?n63`oo5P82oa/30onG
4102omlI6@06odT82?mh3@goF0T9o`/10OlE0P;oTQ0@0_oO6AT02Olg1PKo
K``<omlI6OoO6AWobAHFoch61_l;0@7o6082oj0A4@08omlI6@03of<;2ol`
1@GogaTI00?ogaTI00WobAHFoch61_l;0@7o6082oj0A4OoO6AWobaHFobH4
1?n43Ph00_oO6AT02?nI4A7o=`H6omXH6?m_30co1P00o`X10OlG0P;oV14A
0ooO6AT4onk^kRWogaTI?Oo^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oV
i^Koi^KV09[oi^KV0_oO6AT00onl5AGo0@00olXF5P07omlI6@03omdH6?oO
6AWogaTI00GogaTI00?ogQPHomlI6OoO6AT00_oO6AT00ooN61SogaTIomlI
6@04omlI6@03omdH6?oO6AWogaTI00;ogaTI00?o=`H6ofl<3?oO6AT00ooO
6AT00ooL61SogaTIomlI6@08omlI6@03of<;2ol`1@GogaTI00GogaTI00?o
g1PHomlI6OoO6AT02_oO6AT00om31`OoH`/;omlI6@09omlI6@03ok`E5Ol1
003obQHF00OogaTI00?ogAPHomlI6OoO6AT01OoO6AT00ooN61SogaTIomlI
6@02omlI6@03omhH6?oO6AWogaTI00CogaTI00?ogAPHomlI6OoO6AT00_oO
6AT00olg1PKoK``<omlI6@03omlI6@03om`H6?oO6AWogaTI00SogaTI00?o
H`/;oc051OoO6AT01OoO6AT00ooL61SogaTIomlI6@0:omlI6@03od<71omS
2`_ogaTI00CogaTI1?oVi^HYomlI6Cgoi^KV0OnDU9@1onKViP000_o^k^h0
0onDU9Cok^k^onk^kP2Jonk^kP?ogaTI00Go@0L7oc851Oml3@goE@T9od`8
200MomlI6@03ocL61_m_30cogaTI00_ogaTI00GoJ0/;oeP92OmH2@Wo9`@4
oa<20P03oeP92@03om0G5ooO6AWogaTI00gogaTI00?o`aDEol8E5OoO6AT0
2_oO6AT01Om01`Oo<PD5og`=3OmE2@WoC0P801gogaTI00?o=`H6ofl<3?oO
6AT02ooO6AT01OmX2`_oF0T9oeP92OlW10Co4`8200?oF0T900?od1LGomlI
6OoO6AT03OoO6AT00oo35AGo`QDEomlI6@04omlI6@Cok^k^:OoO6ATmonk^
kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0V_ooool3omlI6@05
om/H6?nO4A7oH0X:ogH=3OnW4Q807OoO6AT00olg1PKoK``<omlI6@0;omlI
6@03oi4@4?n63`ooQPl?00GoQPl?00?oeALGomlI6OoO6AT06_oO6AT01OoK
61SoWa4Aof0:2_mf3@goYa8B01gogaTI00?o=`H6ofl<3?oO6AT02ooO6AT0
0onA413oQPl?ohH?3`05ohH?3`03omDG5ooO6AWogaTI01CogaTI1?oooolY
o`0003gooooo0OnDU9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP2Jonk^
kRGogaTI00?ofaPHomdH6?oO6AT0D_oO6AT00ooK61SogAPHomlI6@0ZomlI
6@Cok^k^:Ol0000monk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oV
i^H0>ooVi^HIooooo`Goi^KV6Ol00005onKViQWooooo2_oVi^JWomlI6@Co
i^KV:Ol0000monKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0
>oo^k^hIooooo`Gok^k^6Ol00005onk^kQWooooo2_o^k^jWomlI6@Cok^k^
:Ol0000monk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0FOoo
oolIo`0002SoooooYooO6AT4ooooobWo0000?Oooool1oiBDU07ooooo0002
onk^kP03oiBDU?o^k^kok^k^03_ok^k^6Oooool5onk^kQWo00001Oo^k^hI
ooooo`[ok^k^YooO6AT4onk^kRWo0000?Oo^k^h1oiBDU07ok^k^0002onKV
iP03oiBDU?oVi^Koi^KV03_oi^KV6Oooool5onKViQWo00001OoVi^HIoooo
okGoi^KV:Ol0000monKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^
k^h0>oo^k^h5ooooo`oogaTI1Oooool5onk^kPGo00003ooO6AT5o`0000Go
k^k^1Oooool?omlI6@Gooooo]Oo^k^hYo`0003gok^k^0OnDU9@1onk^kP00
0_ooool00onDU9Coooooooooo`10ooooo`oogaTI2_ooool5o`0000oogaTI
1Ol0000:ooooo`oogaTI^_oooolYo`0003gooooo0OnDU9@1ooooo`000_o^
k^h00onDU9Cok^k^onk^kP0konk^kPGooooo3ooO6AT5ooooo`Gok^k^1Ol0
000?omlI6@Go00001Oo^k^h5ooooo`oogaTI1OoooolUonk^kP03onRLW?oZ
]kOok^k^05;ok^k^00?oj9bLonZg]oo^k^h0>?o^k^hYo`0003gok^k^0OnD
U9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP0konKViPGooooo3ooO6AT5
ooooo`Goi^KV1Ol0000?omlI6@Go00001OoVi^H5ooooo`oogaTI1OoooolU
onKViP03on1<C?oROgooi^KV05;oi^KV00?oh4a<on9oOooVi^H0>?oVi^HY
o`0003goi^KV0OnDU9@1onKViP000_o^k^h00onDU9Cok^k^onk^kP0konk^
kPGooooo3ooO6AT5ooooo`Gok^k^1Ol0000?omlI6@Go00001Oo^k^h5oooo
o`oogaTI1Oooool;onk^kP03ong/k?o[d=3ok=WI00Gok^k^00?ok=kNong/
k?o^k^h00_o]i>@=onk^kP05on9>C_oVPh?okNg]oncHf?o]kNd02Oo^k^h0
0oo]i>Cok=[Jonk^kP0@onk^kP03ongTi?o/f][ok^k^00cok^k^00?ok=SH
ong/k?o^k^h02?o^k^h00oo]k>cojm3@oncIf@05onk^kP03oncNg_o]k>co
k^k^00;okNCT3Oo^k^h01OoRCTkoiX>3ong]kOo/f=SokNg]00Wok^k^00?o
kNCToncJf_o^k^h04?o^k^h00oo]i>Cok=[Jonk^kP0<onk^kP03oncHf?o]
k>cok^k^00Sok^k^:Ol0000monk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BD
ooooooooool0@?ooool5omlI6@Gooooo1OoO6AT:ooooo`Go00001OoO6AT5
ooooo`GogaTI1Ol0000:ooooo`GogaTI1Ol00005omlI6@oooooo00KomKNg
on0R8_oP92CohcTionE9BOoc[jl2ooooo`09onURH_oP823ohS0`oo:UYOoQ
:R[ojFMWoooooooWDU;okX^;00;ooooo00KokXN7onMEEOooooooooooooFk
^ooP8B42ooooo`06onMBD_oXG5cohc/kon8a<OoQ:b_om/;20_ooool02_oW
DU;okX^;oooooooooooonnWYonQKFooO6a_ohcPhon4];OogalL7ooooo`03
oneoOooVBd_ooooo00?ooooo00WonnWYonQKFooO6a_ohcPhon4];OogalOo
n^7Qon4[:oohd=000_ooool02?o_T93ohRh^oo_YjOoooooonMOGon<j>_oR
=3Com/302?ooool01_oe]kOoh28Ron0T9?oS>CWoiDU9oo>_[`;ooooo00Wo
jF9Ron0P8?oR<33olZFUon4Z:_oYIfOoooooonMBD_o^Rh/00_ooool01_o^
QhOoieEEoooooooooooomK^kon0Q8@;ooooo00Koie9BonQLG?oS>c_ohS4a
on4[:oof`/82ooooo`0:onMBD_o^Rh_ooooooooooookjNWoj5]KomlK6ooS
>3SohBd]ooO7a`Oooooo00?okGmoonI;Boooool00oooool02OokjNWoj5]K
omlK6ooS>3SohBd]ooO7aoojhN7ohB/[ooS@d002ooooo`08onn@T?oR;Rko
nnWYoooooooiemOohcXjon8d=?of`<09ooooobWo0000?Oooool1oiBDU07o
oooo0002onk^kP03oiBDU?o^k^kok^k^03_ok^k^1Oooool5omlI6@Gooooo
1OoO6AT5ooooo`Gok^k^1Ol00005omlI6@Gooooo1OoO6AT5o`0000Gok^k^
1Oooool5omlI6@Go00001OoO6AT5ooooo`[ok^k^00gojl_;onZh^?o]jNWo
k^k^onRLW?oO71cok=;BonZn__oO71cok=7AoncIfOoTIFGoh2LW00;ok^k^
00KohTi>onJ3Poo^k^kok^k^onInO_oRD502onk^kP0>onV_[ooO823ok^k^
onk^k_oRCTkohU1@ongPh?o]j^[oiX61on0X:?o]hn?ok^k^on9>C_oVPh<2
onk^kP04on=ADOoRCTkok=?Conk^kP;okN?S1oo^k^h00ooUN7SohTM7onk^
kP03onk^kP04on=ADOoRCTkok=?Conk^kP;okN?S00Ook^k^onRVY_oQ=SKo
kN;RonZg]ooO7Qkoj[Vi00;ok^k^00?oiGMgon9?Coo]kNd02Oo^k^h03Oo[
bl_oj[RhongYjOo^k^koj9bLomlL7?o/d];oj[jnomlL7?o/dM7ok=WIonAU
IOoP9bL00_o^k^h01_oRCTkoiX>3onk^k_o^k^koiWinon9@D0;ok^k^00ko
jJn_omlP8?o^k^kok^k^on9>C_oRD53okN3PongZj_oVPH7oh2PXongShoo^
k^kohTi>onJ3P`;ok^k^00Cohe5Aon9>C_o/dm?ok^k^0_o]hn<7onk^kP03
onEhN?oRAdOok^k^00?ok^k^00Cohe5Aon9>C_o/dm?ok^k^0_o]hn<01oo^
k^koj:JVon4f=_o]h^;oj[NgomlN7_oZ^KT00_o^k^h00ooUMgOohTm?ong]
k@0:onk^kRWo0000?Oo^k^h1oiBDU07ok^k^0002onKViP03oiBDU?oVi^Ko
i^KV03_oi^KV1Oooool5omlI6@Gooooo1OoO6AT5ooooo`Goi^KV1Ol00005
omlI6@Gooooo1OoO6AT5o`0000Goi^KV1Oooool5omlI6@Go00001OoO6AT5
ooooo`koi^KV00WoiLg=omlI6OoSZj_oi<O7omlK6ooT/;3oi^KVon>HV?oO
<S800_oVi^H01_oPC4cohWmoonKVi_oVi^KohW]kon1>CP;oi^KV00KohjVY
omlP8?oVi^Koi^KVon1<C?oROgl2onKViP0:onGBd_oO6AWohjBTonKVi_oP
C4cohWmoonKVi_oUb/[ogaTIonB/[0_oi^KV00?ohWAdon16A_oVi^H00_oV
i^H00ooUb/[ogaTIonB/[006onKViP04on5[JooQEeOogb/[on:5Q@?oi^KV
00?ohEIFon9dM?oVi^H03OoVi^H02OoUcLgogaTIon>[ZooTalOoga/KonB`
/?oVi^KohiRHomlb<P02onKViP06on1<C?oROgooi^KVonKVi_oRNg_oh4i>
0_oVi^H01_oSZJWogb0PonKVi_oVi^Koh4a<on9oO`;oi^KV00[oiM;BomlI
6OoSY:Coi^KVon1<C?oROgooi^KVonG:b_oO6AWoi:b/2ooVi^H00ooRM7Co
h4I6onKViP02onKViP03onG:b_oO6AWoi:b/00Koi^KV00CohF][on5GEooO
:b_ohXF50ooVi^H00ooQEUKohWAdonKViP0:onKViRWo0000?OoVi^H1oiBD
U07oi^KV0002onk^kP03oiBDU?o^k^kok^k^03_ok^k^1Oooool5omlI6@Go
oooo1OoO6AT5ooooo`Gok^k^1Ol00005omlI6@Gooooo1OoO6AT5o`0000Go
k^k^1Oooool5omlI6@Go00001OoO6AT5ooooo`gok^k^00[okN7Qon=JF_oO
7aookN?Sonk^k_oYZJWohD92on93@ooRATKoh3<c0_o^k^h01_oRCTkoiX>3
onk^k_o^k^koiWinon9@D0;ok^k^00KojJn_omlP8?o^k^kok^k^on9>C_oV
Ph<3onk^kP09on0[:ooWTY;ok^k^on9>C_oVPh?ok^k^onZg]ooO6AWohT];
00?ohTe=00?oj[blonk^k_o^k^h01Oo^k^h00ooUN7SohTM7onk^kP02onk^
kP03onZg]ooO6AWohT];00?ohTe=00Ooj[blonk^k_o^k^kokN?SomlQ8OoO
9RKokNOW00?ok^k^00?oheUIonEhN?o^k^h03?o^k^h02_o]hN7oheYJomlO
7oo]hn?ok^k^onVYZOoQ@T;ohT=3on96A_oP<c<2onk^kP06on9>C_oVPh?o
k^k^onk^k_oVOWkohU1@0_o^k^h01_oY[joogb0Ponk^k_o^k^kohTi>onJ3
P`?ok^k^00Woh2/[onNBT_o^k^kohTi>onJ3Poo^k^koj[NgomlI6OoRBd/0
0ooRCDd00ooZ_;cok^k^onk^kP05onk^kP03onEhN?oRAdOok^k^00;ok^k^
00?oj[NgomlI6OoRBd/00ooRCDd01ooZ_;cok^k^onk^k_o]hn?ogb4QomlV
9_o]inL00oo^k^h00ooSFEWoiGQhonk^kP0:onk^kRWo0000?Oo^k^h1oiBD
U07ok^k^0002ooooo`03oiBDU?oooooooooo043ooooo1OoO6AT5ooooo`Go
gaTI2_ooool5o`0000GogaTI1Oooool5omlI6@Go00002_ooool5omlI6@Go
00001OoO6ATAooooo`04ooFm_OoR<S;ohBd]ooK4a0Cooooo00?oo_gmoo6N
W_oS=SH00_ooool02_oWDU;ok7]kooooooooooookXJ6onE7Aoono_kooooo
ooFj^_oP8B42ooooo`0BonMBD_o^QhOoooooooooooolk^kogaTIooO8b?oo
ooooie9Bonj;Rooooooon]kNomlI6Ood/k?on=?CooO<c?oO6a_onnOW1ooo
ool00oo]OgooiT];ooooo`02ooooo`07oo[Ng_oO6AWom;>cooSCdoogc<co
ga/Koo_Wi`02ooooo`04onf3PooS=SKoj5YJonf2PP?ooooo00?oj5iNoneo
Ooooool02oooool01?oe_KgohS8bon4];Oofa<@4ooooo`03ookmoOoaWYko
hcHf00;ooooo00[oie9BonakNoooooooooooonj6Q_oUAdOoo_knoooooooe
^[[oh24Q0_ooool04_oWDU;okXN7ooooooooooooo>k^omlI6Oogb<Sooooo
onMBD_o^Rh_ooooooo[Ng_oO6AWom;>cooSCdoogc<coga/Koo_Wi`Oooooo
00?okGmoonI;Boooool00_ooool01oojg]kogaTIooBc/oohdm?omlc<omlK
6ookinL00_ooool01?o]Ph?ohcHfonQJF_o]PX83ooooo`03onQNG_o]Ogoo
oooo00[ooooo:Ol0000mooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^
k_o^k^h0>oo^k^h5ooooo`oogaTI1Oooool5onk^kPGo00003ooO6AT5o`00
00Gok^k^1Oooool?omlI6@Gooooo2oo^k^h01?oVQ8CogaTIonAPH?o/fMT3
onk^kP05onV_[oo[clookN_[onAZJ_oSGel00_o^k^h02_oRCTkoh2XZonN=
SOo/f][ohTe=on0b<_oTJFWok=GEonEgMooR@d<2onk^kP0:on9>C_oP;boo
iiNGon_@d?oUL73oh2LWong[joo^k^kohTi>onJ3P`;ok^k^00GohTe=onEb
L_o]inOoj9bLon4l?008onk^kP03onEhN?oRAdOok^k^00?ok^k^00GohTe=
onEbL_o]inOoj9bLon4l?002onk^kP0<onV/[?oO7Qkoj/;2oncKfooP;Bgo
j[blonk^k_o]j>SoheEEonEdM?o]i>CokN[Z2Oo^k^h01?oVQ8CogaTIonAP
H?o/fMT3onk^kP05onV_[oo[clookN_[onAZJ_oSGel00_o^k^h02_oRCTko
h2XZonN=SOo/f][ohTe=on0b<_oTJFWok=GEonEgMooR@d<2onk^kP0:on9>
C_oP;booiiNGon_@d?oUL73oh2LWong[joo^k^kohTi>onJ3P`;ok^k^00Go
hTe=onEbL_o]inOoj9bLon4l?008onk^kP03onEhN?oRAdOok^k^00?ok^k^
00GohTe=onEbL_o]inOoj9bLon4l?002onk^kP0<onV/[?oO7Qkoj/;2oncK
fooP;Bgoj[blonk^k_o]j>SoheEEonEdM?o]i>CokN[Z2Oo^k^hYo`0003go
k^k^0OnDU9@1onk^kP000_oVi^H00onDU9Coi^KVonKViP0konKViPGooooo
3ooO6AT5ooooo`Goi^KV1Ol0000?omlI6@Go00001OoVi^H5ooooo`oogaTI
1Oooool:onKViP03onGAdOoO6Q[ohhn?00Goi^KV00GohXN7on11@OoO9BGo
h4I6onBf]P02onKViP0:on5LG?oRR8SohW=comlU9OoP>CWoi<C4on>DU?oO
;Bgogc8bon>TY0;oi^KV00KohEaLon:7QooQJV[ogb<Soml];OoSX:02onKV
iP09on1<C?oROgooi^KVonKVi_oUdM7oh59BomlS8ooO;booi:b/00Soi^KV
00?ohWAdon16A_oVi^H00ooVi^H02OoUdM7oh59BomlS8ooO;booi:b/onKV
i_oUe=Coh3`lon>BTP02onKViP08on>UYOoPBd_oiN7Qon9oOooO7aoogb8R
oml^;_oSY:@8onKViP03onGAdOoO6Q[ohhn?00Goi^KV00GohXN7on11@OoO
9BGoh4I6onBf]P02onKViP0:on5LG?oRR8SohW=comlU9OoP>CWoi<C4on>D
U?oO;Bgogc8bon>TY0;oi^KV00KohEaLon:7QooQJV[ogb<Soml];OoSX:02
onKViP09on1<C?oROgooi^KVonKVi_oUdM7oh59BomlS8ooO;booi:b/00So
i^KV00?ohWAdon16A_oVi^H00ooVi^H02OoUdM7oh59BomlS8ooO;booi:b/
onKVi_oUe=Coh3`lon>BTP02onKViP08on>UYOoPBd_oiN7Qon9oOooO7aoo
gb8Roml^;_oSY:@9onKViRWo0000?OoVi^H1oiBDU07oi^KV0002onk^kP03
oiBDU?o^k^kok^k^03_ok^k^1Oooool?omlI6@Gooooo1Oo^k^h5o`0000oo
gaTI1Ol00005onk^kPGooooo3ooO6AT5ooooo`[ok^k^00?ojlg=omlJ6_o/
fMT01oo^k^h00oo]k>cok^k^onk^kP05onk^kP03ong]kOo^k^kok^k^00;o
k^k^00?okNg]onk^k_o^k^h01?o^k^h00oo]k>cok^k^onk^kP02onk^kP03
on9>C_oVPh?ok^k^00?ok^k^00?okN_[onk^k_o^k^h02?o^k^h00ooUN7So
hTM7onk^kP05onk^kP03ong[joo^k^kok^k^00[ok^k^00?oheUIonEhN?o^
k^h02Oo^k^h00oo[cLgogaXJoncIf@07onk^kP03ong/k?o^k^kok^k^00Go
k^k^00?okNg]onk^k_o^k^h00_o^k^h00oo]kNgok^k^onk^kP04onk^kP03
ong/k?o^k^kok^k^00;ok^k^00?ohTi>onJ3Poo^k^h00oo^k^h00oo]jn_o
k^k^onk^kP08onk^kP03onEhN?oRAdOok^k^00Gok^k^00?okN_[onk^k_o^
k^h02_o^k^h00ooSFEWoiGQhonk^kP0:onk^kRWo0000?Oo^k^h1oiBDU07o
k^k^0002ooooo`03oiBDU?oooooooooo043ooooo3ooO6AT:ooooo`Go0000
3ooO6AT5o`0000[ooooo3ooO6AT@ooooo`05onQKFooVCDgol9VIon]aLOoZ
J6P07Oooool00ooWDU;okX^;ooooo`0;ooooo`05onf4Q?o[M7CojgAdonA1
@OoQ;2`00oo[M7@00oolknooooooooooo`0=ooooo`03oo_ShoojhN7ooooo
00[ooooo00Goj5]KonI=COo`VIWojg5aonYXJ00Mooooo`03onMBD_o^Rh_o
oooo00_ooooo00GokHB4on]dM?o[M7Coi451on4/;003on]dM003ooc_kooo
oooooooo00gooooo00?onn?Soo[QhOooool02_oooolYo`0003gooooo0OnD
U9@1ooooo`000_o^k^h00onDU9Cok^k^onk^kP0konk^kPGooooo3ooO6AT5
ooooo`Gok^k^1Ol0000?omlI6@Go00001Oo^k^h5ooooo`oogaTI1Oooool;
onk^kP05ongZj_oY/K7oiGAdonN:R_oZ^;P07Oo^k^h00ooRCTkoiX>3onk^
kP0;onk^kP03onRSXooXVIWoj9VI00Goj9VI00?okNCTonk^k_o^k^h06_o^
k^h01Oo]j^[ojK6aonEdM?oWRX[oj[Rh01gok^k^00?ohTi>onJ3Poo^k^h0
2oo^k^h00ooXXj?oj9VIonRIV@05onRIV@03ongTi?o^k^kok^k^01[ok^k^
:Ol0000monk^kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0>ooV
i^HIooooo`Goi^KV6Ol00005onKViQWooooo;OoVi^H00ooUh^;oiNCTonKV
iP1BonKViP03onGRh_oUi>Coi^KV033oi^KV:Ol0000monKViP7oU9BD0OoV
i^H000;ok^k^00?oU9BDonk^k_o^k^h0>oo^k^hIooooo`Gok^k^6Ol00005
onk^kQWooooo]Oo^k^hYo`0003gok^k^0OnDU9@1onk^kP000_ooool00onD
U9Coooooooooo`1IoooooaWo0000dooooolYo`0003gooooo0OnDU9@1oooo
o`000_o^k^h00onDU9Cok^k^onk^kP0konk^kQWooooo1Oo^k^hIo`0000Go
k^k^6Oooooneonk^kRWo0000?Oo^k^h1oiBDU07ok^k^0002onKViP03oiBD
U?oVi^Koi^KV03_oi^KV6Oooool5onKViQWo00001OoVi^HIoooookGoi^KV
:Ol0000monKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^
k^j/onk^kP7oU9BD0Oo^k^h000;ooooo00?oU9BDooooooooool0oooooon/
ooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^j/onk^
kP7oU9BD0Oo^k^h000;oi^KV00?oU9BDonKVi_oVi^H0oooVi^J/onKViP7o
U9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^j/onk^kP7oU9BD
0Oo^k^h000;ooooo00?oU9BDooooooooool0oooooon/ooooo`7oU9BD0Ooo
ool000;ok^k^00?oU9BDonk^k_o^k^h0ooo^k^j/onk^kP7oU9BD0Oo^k^h0
00;oi^KV00?oU9BDonKVi_oVi^H04ooVi^H00ooLg=codM7AonKViP0?onKV
iP03omcLg?oAdM7oi^KV0?ooi^KVQ?oVi^H1oiBDU07oi^KV0002onk^kP03
oiBDU?o^k^kok^k^00Gok^k^00?o<S8bofm_Koo^k^h01?o^k^h00olk>c_o
MWIfonk^kP02onk^kP06omOGeom5ADGo0P82ob0P8?lE5AGo];Bd0_o^k^h0
0omdM7Co0000olk>cP03onk^kP0>oc/k>omfMWKok^k^onk^k_oGemOoADE5
o`820_lP823o5ADEokBd]?o^k^koe]KFo`000?mnOWh2onk^kP03odA4A?lU
9BGok^k^0?ook^k^N_o^k^h1oiBDU07ok^k^0002ooooo`03oiBDU?oooooo
oooo00Gooooo00?o=SHfogMgMoooool01?ooool00om0@43oOgmoooooo`02
ooooo`0;odA4A?m0@43ogmoOoooooooclo?ol_;booooooono_ko7alOoaDE
5OmjNWX00oooool04om0@43oOgmoooooooooooooA4A4od10@?oOgmoooooo
oo?cloobl_;ooooooijNW_l?3`oo>CTiooooooohn?So2PX:o`l?3ooDe=@0
oooooomjooooo`7oU9BD0Oooool000;ok^k^00?oU9BDonk^k_o^k^h01Oo^
k^h00olb<S;oKfm_onk^kP04onk^kP07oc/k>omfMWKok^k^onk^k_o>c/ko
0000oj^[Z`05onk^kP05ok:b/_l:2P[oZ:RXoaLG5ooZj^X00_o^k^h01_lk
>c_oMWIfonk^k_o>c/ko0000oj^[Z`Gok^k^00SoCdm?of][JolJ6Q[of=SH
ok2`/?lN7QkoIVIVogQhN?ook^k^N_o^k^h1oiBDU07ok^k^0002onKViP03
oiBDU?oVi^Koi^KV00Goi^KV00Co<30`odi>C_nd];Coe=CD0ooVi^H01oli
>CWoLW9bonKVi_oVi^KoZj^[o`000?lg=cL00olh>3P01on`/;3oi^KVoeIF
E_mCDe?oi^KVob8R8_nNWYh00_oVi^H01_li>CWoLW9bonKVi_n[Zj_o0000
ocLg=`?o>3Ph00[o/;2`on;Rh_l=3@goZZZZoeeMGOn:RX[oJf][oeaLG?n]
[Jgo:2PXoooVi^IjonKViP7oU9BD0OoVi^H000;ok^k^00?oU9BDonk^k_o^
k^h01Oo^k^h02Olb<S;o71`LoahN7_l0003oE5ADon?Shoo^k^ko>c/kof9R
HP02onk^kP0=olc<c?l0003oWinOol71`Oni^KWo0P82omGEeOoShn?o2PX:
ok2`/?o^k^koP820odI6AP02onk^kP0Doc/k>omfMWKok^k^olc<c?l0003o
WinOol71`Oni^KWo0P82omGEeOnf][Ko2`/;onSXj?nYZJWoATI6obd];OnN
WYkok>c/oa@D5?o;bl_oonk^kWWok^k^0OnDU9@1onk^kP000_ooool7oiBD
U00Moooooolf=SKoMgMgoooooooCdm?o30`<ofYZJ_oooooo@410oa<C4onA
TI7oi>CToogmoOlo?cooJf][ooOgmonNWYko:b/[oooooonRXZ;o7alOookn
o_oooooojNWYo`P82?oRh^;ooooood10@?moOgl00_ooool04?lo?cooJf][
ooOgmonNWYko:b/[oooooomiNGWoCDe=ooooooohn?So4Q8Bo`<30oo]kNgo
ooooofIVI_n6QXKooiBDU7[oU9BD0Oooool000[ok^k^01Co<S8bofm_Koo^
k^kok^k^of1PH?lM7Agok^k^odi>C_moOgooEUIFo`P82?oPh>3oe]KFod92
@_l<30co6QXJojZZZ_o^k^koE5ADogemO@?ok^k^00GoFUYJohV9ROo^k^ko
CTi>oh>3P`02onk^kP08omKFe_m2@T;o30`<oaXJ6_nZZZ[ok^k^odE5AOnC
Ti<2onk^kP06oeYJF_m0@43ok^k^onk^k_n`/;3oAdM7ooo^k^ikonk^kP00
2_oVi^H01_l`<33oJf][onKVi_oVi^Ko?Shnocdm?@Coi^KV00Gohn?SonKV
i_oVi^Koi^KVon?Sh`0AonKViP03on?ShooVi^Koi^KV0?ooi^KVQ_oVi^H0
00[ok^k^00Ko<S8bob/[:omDE5Co92@To`410OnRXZ8Donk^kP03oeADE?n8
R8Sok^k^0?ook^k^S?o^k^h000[ooooo00Go/;2`oiZJV_nKVi_o[Jf]omkN
gP0Eooooo`03okBd]?o=cLgooooo0?ooooooS?ooool00?ook^k^/oo^k^h0
0?ooi^KV/ooVi^H00?ook^k^/oo^k^h00?oooooo/oooool000CohN7QoooK
fm^Zom_Kf`CohN7Q0Oo^k^h00004om[Jf_oCdm?odm?Com?Cdooob<S8Z_o8
b<P3om?Cd`7oi^KV0OoJf]X00004on7QhOoJf][oclo?olo?cooo_KfmZ_nm
_Kd2olo?c`7ok^k^0OoJf]X1on7Qh@0000Col_;bon[Zj_oNg]kobl_;oon/
[:bZojb/[004ol_;booooooog]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?
conm_Kgo=cLg0?ooMWIfZOmfMWH01?m_Kfoo_Kfmolo?cooJf]X1on7Qh@00
00Gof][Jom?Cdoo8b<So]kNgoifMW@3oonKViZWoi^KV00CoWIfMokNg]oo8
b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^jYonk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o
[jn_0?ooooooZOooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Q
om[Jf_o?cloo_Kfmoj>SX`3oonk^kZWok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^JYonKViP04oifM
WOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?oo
k^k^ZOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oN
g]kobl_;ojn_[`3oooooojWooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_80
0005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^jYonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVZOoV
i^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfm
oj>SX`3oonk^kZWok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;b
l_oZj^[og]kNol_;bon_[jl0oooooonYooooo`04ojn_[oo;bl_og]kNon[Z
jP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S0?ook^k^ZOo^k^h01?nS
Xj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@3o
onKViZWoi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][o
clo?okfm_OnSXj<0;_o^k^jMo`4002_o0@417Oo^k^h@ool01hGok^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0
;_oooom?o`8004ko0P41:ol20P8Moooooa3oo`0?QOooool01?n_[joobl_;
omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kSGo
0`00=?l30@4do`<20R_o0`<37Oo^k^h@ool05XGok^k^00CoXj>Sokfm_Oo?
cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0;_oVi^HXo`D0
02Oo1@419ol50P8Wo`D30bSo1@@40ol51@DMonKViQ3oo`0NQOoVi^H01?nM
WIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^
onk^kR3o1P007ol60@4Po`H20Qoo1P<37ol610@Po`H51@_o1PH67Oo^k^h@
ool09XGok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[o
g]kNol_;bon_[jl0;_oooolKo`L001[o1`416_l70P8Jo`L30a[o1`@46_l7
1@DKo`L61Q3o1`L77Oooool@ool0;HGooooo00Co[jn_ol_;booNg]koj^[Z
0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^hGo`P001Ko2041
5ol80P8Fo`P30aOo20@45_l81@DFo`P61QOo20L75?l820PMonk^kQ3oo`0e
QOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So
]kNgoifMW@0^onKViQCo2P005?l:0@4Co`X20QCo2P<35?l:10@Co`X51ACo
2PH64ol:1`LDo`X821Co2PT90ol:2PXMonKViQ3oo`0mQOoVi^H01?nMWIgo
]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^
kQ;o2`004Ol;0@4Bo`/20Q7o2`<34_l;10@Ao`/51A;o2`H64Ol;1`LAo`/8
21;o2`T94Ol;2PX8o`/;2agok^k^4?oo04B5onk^kP04oj>SXonm_Kgoclo?
om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_02kooooo4?l<000@
o``10A3o30823ol<0`<@o``4113o30D53ol<1PH@o``71a3o30P83ol<2@T@
o``:2Q3o30/;2ol<30`Moooooa3oo`1<QOooool01?n_[joobl_;omkNg_oZ
j^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kPoo3P003_l>
0@4>o`h20Poo3P<33_l>10@>o`h51@ko3PH63ol>1`L>o`h820ko3PT93_l>
2PX?o`h;2`ko3P`<3_l>3@dMonk^kQ3oo`1DQOo^k^h01?nSXj?o_Kfmolo?
cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@0^onKViPko3`00
3Ol?0@4=o`l20Pgo3`<33Ol?10@=o`l51@go3`H63Ol?1`L=o`l820go3`T9
3Ol?2PX=o`l;2`go3``<3_l?3@d=o`l>3P?o3`l?7OoVi^H@ool0FhGoi^KV
00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnS
Xj<0;_o^k^h=oa0000co40413?l@0P8<oa030`co40@43?l@1@D<oa061Pco
40L73?l@20P<oa092@co40X:3?l@2`/<oa0<30co40d=3?l@3Ph=oa0?3`Ko
410@7Oo^k^h@ool0HhGok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005
oo;bl_oZj^[og]kNol_;bon_[jl0;_ooool<oa4000_o4@412olA0P8;oa43
0`co4@@42olA1@D;oa461P_o4@L72olA20P<oa492@_o4@X:2olA2`/;oa4<
30_o4@d=3?lA3Ph;oa4?3`_o4A0@2OlA4A4Moooooa3oo`1[QOooool01?n_
[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^
onk^kP_o4`002_lC0@4;oa<20P[o4`<32olC10@:oa<51@_o4`H62_lC1`L;
oa<820[o4`T92olC2PX:oa<;2`[o4``<2olC3@d:oa<>3P_o4`l?2_lC410;
oa<A4@[o4a8B00?o4a<Conk^k_o^k^h06oo^k^h@ool0LXGok^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0;_oV
i^H:oa@000[o50412_lD0P8:oa@30`[o50@42OlD1@D:oa@61P[o50L72_lD
20P:oa@92@Wo50X:2_lD2`/:oa@<30[o50d=2_lD3Ph9oa@?3`[o510@2_lD
4A4:oa@B4P[o51<C0olD51@MonKViQ3oo`1jQOoVi^H01?nMWIgo]kNgolS8
b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kP[o5@00
2OlE0@49oaD20PWo5@<32_lE10@9oaD51@Wo5@H62OlE1`L:oaD820Wo5@T9
2OlE2PX9oaD;2`Wo5@`<2_lE3@d9oaD>3PWo5@l?2OlE410:oaDA4@Wo5A8B
2OlE4a<9oaDD50Ko5ADE7Oo^k^h@ool0PXGok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0;_ooool9oaH000Wo
5P412OlF0P88oaH30`Wo5P@42OlF1@D9oaH61PSo5PL72OlF20P9oaH92@So
5PX:2OlF2`/9oaH<30Wo5Pd=2?lF3Ph9oaH?3`Wo5Q0@2?lF4A49oaHB4PWo
5Q<C2OlF51@8oaHE5@So5QHF7Oooool@ool0RHGooooo00Co[jn_ol_;booN
g]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h9oaP0
00So60412?lH0P89oaP30`So60@42?lH1@D8oaP61PWo60L72?lH20P8oaP9
2@So60X:2OlH2`/8oaP<30So60d=2?lH3Ph9oaP?3`So610@2?lH4A48oaPB
4PWo61<C2?lH51@8oaPE5@So61HF2OlH5aL00olH61Sok^k^onk^kP0Konk^
kQ3oo`2AQOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?C
doo8b<So]kNgoifMW@0^onKViPSo6@002?lI0@48oaT20PSo6@<32?lI10@8
oaT51@Oo6@H62?lI1`L8oaT820So6@T92?lI2PX8oaT;2`Oo6@`<2?lI3@d8
oaT>3PSo6@l?2?lI4108oaTA4@So6A8B1olI4a<8oaTD50So6ADE2?lI5QH8
oaTG5`So6APH0olI6ATMonKViQ3oo`2IQOoVi^H01?nMWIgo]kNgolS8b?oC
dm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kPSo6P001olJ
0@48oaX20POo6P<32?lJ10@7oaX51@So6PH61olJ1`L8oaX820Oo6PT92?lJ
2PX7oaX;2`So6P`<1olJ3@d8oaX>3POo6Pl?1olJ4108oaXA4@Oo6Q8B2?lJ
4a<7oaXD50So6QDE1olJ5QH8oaXG5`Oo6QPH2?lJ6AT5oaXJ6Qgok^k^4?oo
0:25onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkN
g_o;bl_o[jn_02kooooo2?lL0007oa`10@Oo70821olL0`<7oa`410Oo70D5
1olL1PH8oa`71`Oo70P81olL2@T7oa`:2POo70/;1olL30`7oa`=3@Oo70h>
2?lL3`l7oa`@40Oo714A1olL4Q87oa`C4`Oo71@D1olL5AD7oa`F5PSo71LG
1olL61P7oa`I6@Oo71XJ1olL6a/Moooooa3oo`2XQOooool01?n_[joobl_;
omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kPOo
7@001olM0@47oad20POo7@<31olM10@6oad51@Oo7@H61olM1`L7oad820Oo
7@T91olM2PX6oad;2`Oo7@`<1olM3@d7oad>3POo7@l?1_lM4107oadA4@Oo
7A8B1olM4a<7oadD50Oo7ADE1_lM5QH7oadG5`Oo7APH1olM6AT7oadJ6PKo
7A/K1olM71`2oadM7Agok^k^4?oo0:n5onk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM02koi^KV1olN0007oah1
0@Ko7P821olN0`<6oah410Oo7PD51_lN1PH7oah71`Ko7PP81olN2@T6oah:
2POo7P/;1_lN30`7oah=3@Oo7Ph>1_lN3`l7oah@40Ko7Q4A1olN4Q86oahC
4`Oo7Q@D1_lN5AD7oahF5PKo7QLG1olN61P6oahI6@Oo7QXJ1olN6a/6oahL
70Oo7QdM0olN7QhMonKViQ3oo`2gQOoVi^H01?nMWIgo]kNgolS8b?oCdm<1
om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kPOo7`001_lO0@46
oal20POo7`<31_lO10@6oal51@Ko7`H61olO1`L6oal820Ko7`T91olO2PX6
oal;2`Ko7``<1_lO3@d7oal>3PKo7`l?1_lO4106oalA4@Oo7a8B1_lO4a<6
oalD50Oo7aDE1_lO5QH6oalG5`Ko7aPH1olO6AT6oalJ6PKo7a/K1_lO71`7
oalM7@Ko7ahN1OlO7alMonk^kQ3oo`2oQOo^k^h01?nSXj?o_Kfmolo?cooJ
f]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`0^ooooo`Oo8@001_lQ
0@46ob420PKo8@<31_lQ10@6ob451@Ko8@H61_lQ1`L6ob4820Ko8@T91_lQ
2PX6ob4;2`Ko8@`<1_lQ3@d6ob4>3PKo8@l?1_lQ4106ob4A4@Ko8A8B1_lQ
4a<6ob4D50Ko8ADE1_lQ5QH6ob4G5`Ko8APH1_lQ6AT6ob4J6PKo8A/K1_lQ
71`6ob4M7@Oo8AhN1_lQ7al6ob4P81gooooo4?oo0<J5ooooo`04ojn_[oo;
bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S02kok^k^
1_lR0006ob810@Ko8P821_lR0`<6ob8410Go8PD51_lR1PH6ob871`Ko8PP8
1_lR2@T5ob8:2PKo8P/;1_lR30`6ob8=3@Ko8Ph>1OlR3`l6ob8@40Ko8Q4A
1_lR4Q86ob8C4`Ko8Q@D1OlR5AD6ob8F5PKo8QLG1_lR61P6ob8I6@Go8QXJ
1_lR6a/6ob8L70Ko8QdM1_lR7Qh5ob8O7`Ko8R0P1_lR8B42ob8R8Qgok^k^
4?oo0<j5onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?C
olS8b?ng]kOoWIfM02koi^KV1_lS0006ob<10@Go8`821_lS0`<6ob<410Go
8`D51_lS1PH5ob<71`Ko8`P81_lS2@T5ob<:2PKo8`/;1OlS30`6ob<=3@Ko
8`h>1OlS3`l6ob<@40Go8a4A1_lS4Q86ob<C4`Go8a@D1_lS5AD5ob<F5PKo
8aLG1_lS61P5ob<I6@Ko8aXJ1OlS6a/6ob<L70Ko8adM1OlS7Qh6ob<O7`Go
8b0P1_lS8B46ob<R8P?o8b<S7OoVi^H@ool0eXGoi^KV00CoWIfMokNg]oo8
b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h6ob@0
00Go90411_lT0P85ob@30`Ko90@41OlT1@D5ob@61PKo90L71OlT20P6ob@9
2@Go90X:1OlT2`/6ob@<30Go90d=1_lT3Ph5ob@?3`Go910@1_lT4A45ob@B
4PKo91<C1OlT51@5ob@E5@Ko91HF1OlT5aL6ob@H60Go91TI1_lT6QX5ob@K
6`Go91`L1_lT7Ad5ob@N7PKo91lO1OlT8205ob@Q8@Ko928R1OlT8b<5ob@T
91gok^k^4?oo0=f5onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oob
l_;oj^[ZomkNg_o;bl_o[jn_02kooooo1_lV0005obH10@Go9P821OlV0`<6
obH410Go9PD51OlV1PH5obH71`Ko9PP81OlV2@T5obH:2PGo9P/;1OlV30`6
obH=3@Go9Ph>1OlV3`l5obH@40Ko9Q4A1OlV4Q85obHC4`Go9Q@D1_lV5AD5
obHF5PGo9QLG1OlV61P5obHI6@Ko9QXJ1OlV6a/5obHL70Go9QdM1_lV7Qh5
obHO7`Go9R0P1OlV8B46obHR8PGo9R<S1OlV92@5obHU9@03obHV9_oooooo
oooo01_ooooo4?oo0>F5ooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b0000
1OoQhN7of][Jolo?conm_KgoXj>S02kok^k^1_lW0005obL10@Go9`821OlW
0`<5obL410Go9`D51OlW1PH5obL71`Go9`P81OlW2@T5obL:2PGo9`/;1OlW
30`5obL=3@Go9`h>1OlW3`l6obL@40Go9a4A1OlW4Q85obLC4`Go9a@D1OlW
5AD5obLF5PGo9aLG1OlW61P5obLI6@Go9aXJ1OlW6a/5obLL70Go9adM1OlW
7Qh5obLO7`Go9b0P1_lW8B45obLR8PGo9b<S1OlW92@5obLU9@Go9bHV0_lW
9bLMonk^kQ3oo`3]QOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Go
f][Jom?Cdoo8b<So]kNgoifMW@0^onKViPGo:0001OlX0@45obP20PGo:0<3
1OlX10@5obP51@Go:0H61OlX1`L5obP820Go:0T91?lX2PX5obP;2`Go:0`<
1OlX3@d5obP>3PGo:0l?1OlX4105obPA4@Go:18B1OlX4a<4obPD50Go:1DE
1OlX5QH5obPG5`Go:1PH1OlX6AT5obPJ6PGo:1/K1OlX71`5obPM7@Co:1hN
1OlX7al5obPP80Go:24Q1OlX8R85obPS8`Go:2@T1OlX9BD5obPV9PGo:2LW
0olX:2PMonKViQ3oo`3dQOoVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00
00GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kPGo:P001OlZ0@45obX20PGo
:P<31?lZ10@5obX51@Go:PH61OlZ1`L4obX820Go:PT91OlZ2PX5obX;2`Co
:P`<1OlZ3@d5obX>3PGo:Pl?1?lZ4105obXA4@Go:Q8B1OlZ4a<4obXD50Go
:QDE1OlZ5QH5obXG5`Co:QPH1OlZ6AT5obXJ6PGo:Q/K1?lZ71`5obXM7@Go
:QhN1OlZ7al4obXP80Go:R4Q1OlZ8R85obXS8`Co:R@T1OlZ9BD5obXV9PGo
:RLW1?lZ:2P5obXY:Agok^k^4?oo0?b5onk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_02kooooo1Ol[0005ob/1
0@Co:`821Ol[0`<5ob/410Co:`D51Ol[1PH4ob/71`Go:`P81Ol[2@T4ob/:
2PGo:`/;1?l[30`5ob/=3@Go:`h>1?l[3`l5ob/@40Go:a4A1?l[4Q85ob/C
4`Co:a@D1Ol[5AD5ob/F5PCo:aLG1Ol[61P4ob/I6@Go:aXJ1Ol[6a/4ob/L
70Go:adM1Ol[7Qh4ob/O7`Go:b0P1?l[8B45ob/R8PGo:b<S1?l[92@5ob/U
9@Co:bHV1Ol[9bL5ob/X:0Co:bTY1Ol[:RX00ol[:b_oooooooooo`0Koooo
oa3on@3oQOooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[J
f_o?cloo_Kfmoj>SX`0^onk^kPGo;0001?l/0@45ob`20PCo;0<31Ol/10@4
ob`51@Go;0H61?l/1`L5ob`820Co;0T91Ol/2PX4ob`;2`Go;0`<1?l/3@d5
ob`>3PCo;0l?1Ol/4104ob`A4@Go;18B1?l/4a<5ob`D50Co;1DE1Ol/5QH4
ob`G5`Go;1PH1?l/6AT5ob`J6PCo;1/K1?l/71`5ob`M7@Co;1hN1Ol/7al4
ob`P80Go;24Q1?l/8R85ob`S8`Co;2@T1Ol/9BD4ob`V9PGo;2LW1?l/:2P5
ob`Y:@Co;2XZ1Ol/:b/2ob`/;1gok^k^4?ob0?n5onk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM02koi^KV1Ol]
0004obd10@Go;@821?l]0`<4obd410Go;@D51?l]1PH4obd71`Go;@P81?l]
2@T4obd:2PGo;@/;1?l]30`5obd=3@Co;@h>1?l]3`l5obd@40Co;A4A1?l]
4Q85obdC4`Co;A@D1?l]5AD5obdF5PCo;ALG1?l]61P5obdI6@Co;AXJ1Ol]
6a/4obdL70Co;AdM1Ol]7Qh4obdO7`Co;B0P1Ol]8B44obdR8PCo;B<S1Ol]
92@4obdU9@Co;BHV1Ol]9bL4obdX:0Go;BTY1?l]:RX4obd[:`Go;B`/0ol]
;BdMonKViQ3ojP3oQOoVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000Go
hN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kPGo;`001?l_0@44obl20PCo;`<3
1Ol_10@4obl51@Co;`H61?l_1`L5obl820Co;`T91?l_2PX4obl;2`Go;``<
1?l_3@d4obl>3PCo;`l?1Ol_4104oblA4@Co;a8B1?l_4a<5oblD50Co;aDE
1?l_5QH4oblG5`Co;aPH1Ol_6AT4oblJ6PCo;a/K1?l_71`5oblM7@Co;ahN
1?l_7al4oblP80Go;b4Q1?l_8R84oblS8`Co;b@T1Ol_9BD4oblV9PCo;bLW
1?l_:2P5oblY:@Co;bXZ1?l_:b/4obl/;0Go;bd]1?l_;RhMonk^kQ3ohP3o
QOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]ko
bl_;ojn_[`0^ooooo`Go<0001?l`0@44oc020PCo<0<31?l`10@4oc051@Co
<0H61Ol`1`L4oc0820Co<0T91?l`2PX4oc0;2`Co<0`<1?l`3@d4oc0>3PGo
<0l?1?l`4104oc0A4@Co<18B1?l`4a<4oc0D50Co<1DE1?l`5QH5oc0G5`Co
<1PH1?l`6AT4oc0J6PCo<1/K1?l`71`4oc0M7@Co<1hN1Ol`7al4oc0P80Co
<24Q1?l`8R84oc0S8`Co<2@T1?l`9BD4oc0V9PGo<2LW1?l`:2P4oc0Y:@Co
<2XZ1?l`:b/4oc0/;0Co<2d]1Ol`;Rh4oc0_;`03oc0`<?oooooooooo01_o
oooo4?oK0?n5ooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7o
f][Jolo?conm_KgoXj>S02kok^k^1Ola0004oc410@Co<@821?la0`<4oc44
10Co<@D51?la1PH4oc471`Co<@P81?la2@T4oc4:2PCo<@/;1?la30`4oc4=
3@Co<@h>1?la3`l4oc4@40Co<A4A1?la4Q84oc4C4`Co<A@D1?la5AD4oc4F
5PCo<ALG1?la61P4oc4I6@Co<AXJ1?la6a/4oc4L70Co<AdM1?la7Qh4oc4O
7`Co<B0P1?la8B44oc4R8PCo<B<S1?la92@4oc4U9@Co<BHV1?la9bL4oc4X
:0Co<BTY1?la:RX4oc4[:`Co<B`/1Ola;Bd4oc4^;PCo<Bl_1?la<302oc4a
<Agok^k^4?oC0?n5onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJ
f][odm?ColS8b?ng]kOoWIfM02koi^KV1?lb0004oc810@Co<P821?lb0`<4
oc8410Co<PD51?lb1PH4oc871`Co<PP81?lb2@T4oc8:2PCo<P/;0olb30`4
oc8=3@Co<Ph>1?lb3`l4oc8@40Co<Q4A1?lb4Q84oc8C4`Co<Q@D1?lb5AD4
oc8F5PCo<QLG1?lb61P3oc8I6@Co<QXJ1?lb6a/4oc8L70Co<QdM1?lb7Qh4
oc8O7`Co<R0P1?lb8B44oc8R8PCo<R<S1?lb92@4oc8U9@?o<RHV1?lb9bL4
oc8X:0Co<RTY1?lb:RX4oc8[:`Co<R`/1?lb;Bd4oc8^;PCo<Rl_1?lb<304
oc8a<@?o<S8b7OoVi^H@ol/0ohGoi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJ
f]X00005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h4oc@000Co=0411?ld
0P84oc@30`Co=0@40old1@D4oc@61PCo=0L71?ld20P4oc@92@Co=0X:0old
2`/4oc@<30Co=0d=1?ld3Ph4oc@?3`Co=10@0old4A44oc@B4PCo=1<C1?ld
51@4oc@E5@?o=1HF1?ld5aL4oc@H60Co=1TI1?ld6QX4oc@K6`?o=1`L1?ld
7Ad4oc@N7PCo=1lO1?ld8204oc@Q8@?o=28R1?ld8b<4oc@T90Co=2DU1?ld
9RH4oc@W9`?o=2PX1?ld:BT4oc@Z:PCo=2/[1?ld;2`3oc@];@Co=2h^1?ld
;bl4oc@`<0Co=34a1?ld<S83oc@c<`03oc@d=?o^k^kok^k^01_ok^k^4?o4
0?n5onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkN
g_o;bl_o[jn_02kooooo1?le0004ocD10@Co=@820ole0`<4ocD410Co=@D5
1?le1PH3ocD71`Co=@P81?le2@T4ocD:2P?o=@/;1?le30`4ocD=3@Co=@h>
0ole3`l4ocD@40Co=A4A0ole4Q84ocDC4`Co=A@D1?le5AD3ocDF5PCo=ALG
1?le61P4ocDI6@?o=AXJ1?le6a/4ocDL70Co=AdM0ole7Qh4ocDO7`Co=B0P
0ole8B44ocDR8PCo=B<S1?le92@3ocDU9@Co=BHV1?le9bL4ocDX:0?o=BTY
1?le:RX4ocD[:`Co=B`/0ole;Bd4ocD^;PCo=Bl_1?le<303ocDa<@Co=C8b
1?le<c<3ocDd=0;o=CDe7Oooool@ok`0ohGooooo00Co[jn_ol_;booNg]ko
j^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h4ocH000Co
=P410olf0P84ocH30`Co=P@40olf1@D4ocH61PCo=PL70olf20P4ocH92@Co
=PX:0olf2`/4ocH<30Co=Pd=0olf3Ph4ocH?3`Co=Q0@0olf4A44ocHB4P?o
=Q<C1?lf51@4ocHE5@?o=QHF1?lf5aL4ocHH60?o=QTI1?lf6QX4ocHK6`?o
=Q`L1?lf7Ad4ocHN7P?o=QlO1?lf8204ocHQ8@?o=R8R1?lf8b<3ocHT90Co
=RDU1?lf9RH3ocHW9`Co=RPX1?lf:BT3ocHZ:PCo=R/[1?lf;2`3ocH];@Co
=Rh^1?lf;bl3ocH`<0Co=S4a1?lf<S83ocHc<`Co=S@d0olf=CD3ocHf=Qgo
k^k^4?ne0?n5onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][o
dm?ColS8b?ng]kOoWIfM02koi^KV1?lh0004ocP10@?o>0821?lh0`<3ocP4
10Co>0D50olh1PH4ocP71`Co>0P80olh2@T4ocP:2P?o>0/;1?lh30`3ocP=
3@Co>0h>1?lh3`l3ocP@40Co>14A0olh4Q84ocPC4`?o>1@D1?lh5AD3ocPF
5PCo>1LG1?lh61P3ocPI6@Co>1XJ0olh6a/4ocPL70?o>1dM1?lh7Qh4ocPO
7`?o>20P1?lh8B43ocPR8PCo>2<S0olh92@4ocPU9@Co>2HV0olh9bL4ocPX
:0?o>2TY1?lh:RX3ocP[:`Co>2`/0olh;Bd4ocP^;PCo>2l_0olh<304ocPa
<@?o>38b1?lh<c<3ocPd=0Co>3De1?lh=SH3ocPg=agoi^KV4?n]0?n5onKV
iP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_Kgo
Xj>S02kok^k^1?li0003ocT10@Co>@820oli0`<4ocT410?o>@D51?li1PH3
ocT71`Co>@P80oli2@T4ocT:2P?o>@/;1?li30`3ocT=3@Co>@h>0oli3`l4
ocT@40?o>A4A1?li4Q83ocTC4`Co>A@D0oli5AD4ocTF5P?o>ALG1?li61P3
ocTI6@Co>AXJ0oli6a/4ocTL70?o>AdM1?li7Qh3ocTO7`Co>B0P0oli8B44
ocTR8P?o>B<S0oli92@4ocTU9@?o>BHV1?li9bL3ocTX:0Co>BTY0oli:RX4
ocT[:`?o>B`/1?li;Bd3ocT^;PCo>Bl_0oli<304ocTa<@?o>C8b1?li<c<3
ocTd=0Co>CDe0oli=SH4ocTg=`?o>CPh00?o>CTionk^k_o^k^h06oo^k^h@
ojD0ohGok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[o
g]kNol_;bon_[jl0;_ooool4ocX000?o>P411?lj0P83ocX30`Co>P@40olj
1@D3ocX61PCo>PL70olj20P4ocX92@?o>PX:0olj2`/4ocX<30?o>Pd=1?lj
3Ph3ocX?3`?o>Q0@1?lj4A43ocXB4PCo>Q<C0olj51@4ocXE5@?o>QHF0olj
5aL4ocXH60?o>QTI1?lj6QX3ocXK6`?o>Q`L1?lj7Ad3ocXN7PCo>QlO0olj
8203ocXQ8@Co>R8R0olj8b<4ocXT90?o>RDU0olj9RH4ocXW9`?o>RPX1?lj
:BT3ocXZ:PCo>R/[0olj;2`3ocX];@Co>Rh^0olj;bl4ocX`<0?o>S4a0olj
<S84ocXc<`?o>S@d1?lj=CD3ocXf=P?o>SLg1?lj>3P3ocXi>@;o>SXj7Ooo
ool@oih0ohGooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJ
f][oclo?okfm_OnSXj<0;_o^k^h4oc/000?o>`411?lk0P83oc/30`?o>`@4
1?lk1@D3oc/61P?o>`L71?lk20P3oc/92@?o>`X:1?lk2`/3oc/<30?o>`d=
1?lk3Ph3oc/?3`?o>a0@1?lk4A43oc/B4P?o>a<C1?lk51@3oc/E5@?o>aHF
1?lk5aL3oc/H60?o>aTI1?lk6QX3oc/K6`?o>a`L1?lk7Ad3oc/N7P?o>alO
1?lk8203oc/Q8@?o>b8R1?lk8b<3oc/T90?o>bDU1?lk9RH3oc/W9`?o>bPX
1?lk:BT3oc/Z:P?o>b/[1?lk;2`3oc/];@?o>bh^1?lk;bl3oc/`<0?o>c4a
1?lk<S83oc/c<`?o>c@d1?lk=CD3oc/f=P?o>cLg1?lk>3P3oc/i>@?o>cXj
0olk>c/Monk^kQ3oUP3oQOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00
00Gof][Jom?Cdoo8b<So]kNgoifMW@0^onKViPCo?@000olm0@43ocd20PCo
?@<30olm10@3ocd51@?o?@H61?lm1`L3ocd820?o?@T90olm2PX4ocd;2`?o
?@`<0olm3@d4ocd>3P?o?@l?0olm4103ocdA4@Co?A8B0olm4a<3ocdD50?o
?ADE1?lm5QH3ocdG5`?o?APH0olm6AT4ocdJ6P?o?A/K0olm71`4ocdM7@?o
?AhN0olm7al3ocdP80Co?B4Q0olm8R83ocdS8`?o?B@T1?lm9BD3ocdV9P?o
?BLW0olm:2P4ocdY:@?o?BXZ0olm:b/4ocd/;0?o?Bd]0olm;Rh3ocd_;`Co
?C0`0olm<C43ocdb<P?o?C<c1?lm=3@3ocde=@?o?CHf1?lm=cL3ocdh>0?o
?CTi0olm>SX4ocdk>`?o?C`l7OoVi^H@ohh0ohGoi^KV00CoWIfMokNg]oo8
b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h4och0
00?o?P410oln0P83och30`Co?P@40oln1@D3och61P?o?PL70oln20P4och9
2@?o?PX:0oln2`/3och<30?o?Pd=1?ln3Ph3och?3`?o?Q0@0oln4A43ochB
4PCo?Q<C0oln51@3ochE5@?o?QHF0oln5aL4ochH60?o?QTI0oln6QX3ochK
6`?o?Q`L1?ln7Ad3ochN7P?o?QlO0oln8203ochQ8@Co?R8R0oln8b<3ochT
90?o?RDU0oln9RH4ochW9`?o?RPX0oln:BT3ochZ:P?o?R/[1?ln;2`3och]
;@?o?Rh^0oln;bl3och`<0Co?S4a0oln<S83ochc<`?o?S@d0oln=CD4ochf
=P?o?SLg0oln>3P3ochi>@?o?SXj1?ln>c/3ochl?0?o?Sdm00?o?Shnonk^
k_o^k^h06oo^k^h@ohL0ohGok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN40
0005oo;bl_oZj^[og]kNol_;bon_[jl0;_ooool4ocl000?o?`410olo0P83
ocl30`?o?`@40olo1@D3ocl61PCo?`L70olo20P3ocl92@?o?`X:0olo2`/3
ocl<30?o?`d=1?lo3Ph3ocl?3`?o?a0@0olo4A43oclB4P?o?a<C0olo51@4
oclE5@?o?aHF0olo5aL3oclH60?o?aTI0olo6QX3oclK6`?o?a`L1?lo7Ad3
oclN7P?o?alO0olo8203oclQ8@?o?b8R0olo8b<4oclT90?o?bDU0olo9RH3
oclW9`?o?bPX0olo:BT3oclZ:PCo?b/[0olo;2`3ocl];@?o?bh^0olo;bl3
ocl`<0?o?c4a0olo<S84oclc<`?o?c@d0olo=CD3oclf=P?o?cLg0olo>3P3
ocli>@Co?cXj0olo>c/3ocll?0?o?cdm0olo?Sh2oclo?agooooo4?mo0?n5
ooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm
_KgoXj>S02kok^k^1?m10003od410@?o@@820om10`<3od4410?o@@D50om1
1PH3od471`?o@@P80om12@T3od4:2P?o@@/;0om130`4od4=3@?o@@h>0om1
3`l3od4@40?o@A4A0om14Q83od4C4`?o@A@D0om15AD3od4F5P?o@ALG0om1
61P3od4I6@Co@AXJ0om16a/3od4L70?o@AdM0om17Qh3od4O7`?o@B0P0om1
8B43od4R8P?o@B<S0om192@3od4U9@?o@BHV1?m19bL3od4X:0?o@BTY0om1
:RX3od4[:`?o@B`/0om1;Bd3od4^;P?o@Bl_0om1<303od4a<@?o@C8b0om1
<c<4od4d=0?o@CDe0om1=SH3od4g=`?o@CPh0om1>CT3od4j>P?o@C/k0om1
?3`3od4m?@?o@Chn0om1?cl3od50@1gok^k^4?mg0?n5onk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM02koi^KV
1?m20003od810@?o@P820om20`<3od8410?o@PD50om21PH3od871`?o@PP8
0om22@T3od8:2P?o@P/;0om230`3od8=3@?o@Ph>0om23`l3od8@40?o@Q4A
0om24Q83od8C4`?o@Q@D0om25AD3od8F5P?o@QLG0om261P3od8I6@?o@QXJ
0om26a/3od8L70?o@QdM0om27Qh3od8O7`?o@R0P0om28B43od8R8P?o@R<S
0om292@3od8U9@?o@RHV0om29bL3od8X:0?o@RTY0om2:RX3od8[:`?o@R`/
0om2;Bd3od8^;P?o@Rl_0om2<303od8a<@?o@S8b0om2<c<3od8d=0?o@SDe
0om2=SH3od8g=`?o@SPh0om2>CT3od8j>P?o@S/k1?m2?3`3od8m?@?o@Shn
0om2?cl3od90@0?o@T517OoVi^H@og00ohGoi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h3od<000?o
@`410om30P83od<30`?o@`@40om31@D3od<61P?o@`L70om320P3od<92@?o
@`X:0om32`/3od<<30?o@`d=0om33Ph3od<?3`?o@a0@0om34A43od<B4P?o
@a<C0om351@3od<E5@?o@aHF0om35aL2od<H60?o@aTI0om36QX3od<K6`?o
@a`L0om37Ad3od<N7P?o@alO0om38203od<Q8@?o@b8R0om38b<3od<T90?o
@bDU0om39RH3od<W9`?o@bPX0om3:BT3od<Z:P?o@b/[0om3;2`3od<];@?o
@bh^0om3;bl3od<`<0;o@c4a0om3<S83od<c<`?o@c@d0om3=CD3od<f=P?o
@cLg0om3>3P3od<i>@?o@cXj0om3>c/3od<l?0?o@cdm0om3?Sh3od<o?`?o
@d100om3@D43od=2@P03od=3@oo^k^kok^k^01_ok^k^4?mX0?n5onk^kP04
oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_
02kooooo0om40003od@10@?oA0820om40`<3od@410?oA0D50om41PH3od@7
1`?oA0P80om42@T2od@:2P?oA0/;0om430`3od@=3@?oA0h>0om43`l3od@@
40?oA14A0om44Q83od@C4`?oA1@D0_m45AD3od@F5P?oA1LG0om461P3od@I
6@?oA1XJ0om46a/3od@L70?oA1dM0om47Qh2od@O7`?oA20P0om48B43od@R
8P?oA2<S0om492@3od@U9@?oA2HV0om49bL3od@X:0?oA2TY0_m4:RX3od@[
:`?oA2`/0om4;Bd3od@^;P?oA2l_0om4<303od@a<@?oA38b0om4<c<2od@d
=0?oA3De0om4=SH3od@g=`?oA3Ph0om4>CT3od@j>P?oA3/k0om4?3`3od@m
?@?oA3hn0_m4?cl3odA0@0?oA4510om4@T83odA3@`;oA4A47Oooool@of00
ohGooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?
okfm_OnSXj<0;_o^k^h3odH000?oAP410om60P83odH30`?oAP@40om61@D2
odH61P?oAPL70om620P3odH92@?oAPX:0om62`/3odH<30;oAPd=0om63Ph3
odH?3`?oAQ0@0om64A43odHB4P?oAQ<C0_m651@3odHE5@?oAQHF0om65aL3
odHH60?oAQTI0om66QX2odHK6`?oAQ`L0om67Ad3odHN7P?oAQlO0om68202
odHQ8@?oAR8R0om68b<3odHT90?oARDU0om69RH3odHW9`;oARPX0om6:BT3
odHZ:P?oAR/[0om6;2`3odH];@?oARh^0_m6;bl3odH`<0?oAS4a0om6<S83
odHc<`?oAS@d0om6=CD2odHf=P?oASLg0om6>3P3odHi>@?oASXj0om6>c/2
odHl?0?oASdm0om6?Sh3odHo?`?oAT100om6@D43odI2@P;oAT=30om6A4@3
odI5AAgok^k^4?mI0?n5onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0000
1OoJf][odm?ColS8b?ng]kOoWIfM02koi^KV0om70003odL10@?oA`820om7
0`<3odL410;oA`D50om71PH3odL71`?oA`P80om72@T2odL:2P?oA`/;0om7
30`3odL=3@?oA`h>0_m73`l3odL@40?oAa4A0om74Q83odLC4`;oAa@D0om7
5AD3odLF5P?oAaLG0om761P2odLI6@?oAaXJ0om76a/3odLL70?oAadM0_m7
7Qh3odLO7`?oAb0P0om78B43odLR8P;oAb<S0om792@3odLU9@?oAbHV0om7
9bL2odLX:0?oAbTY0om7:RX3odL[:`?oAb`/0_m7;Bd3odL^;P?oAbl_0om7
<303odLa<@;oAc8b0om7<c<3odLd=0?oAcDe0om7=SH2odLg=`?oAcPh0om7
>CT3odLj>P?oAc/k0_m7?3`3odLm?@?oAchn0om7?cl3odM0@0;oAd510om7
@T83odM3@`?oAdA40om7ADD2odM6AP03odM7AooVi^Koi^KV01_oi^KV4?mA
0?n5onKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?
conm_KgoXj>S02kok^k^0om80003odP10@?oB0820om80`<2odP410?oB0D5
0om81PH3odP71`;oB0P80om82@T3odP:2P?oB0/;0_m830`3odP=3@?oB0h>
0om83`l2odP@40?oB14A0om84Q83odPC4`;oB1@D0om85AD3odPF5P?oB1LG
0_m861P3odPI6@?oB1XJ0om86a/2odPL70?oB1dM0om87Qh3odPO7`;oB20P
0om88B43odPR8P?oB2<S0_m892@3odPU9@?oB2HV0om89bL2odPX:0?oB2TY
0om8:RX3odP[:`;oB2`/0om8;Bd3odP^;P?oB2l_0_m8<303odPa<@?oB38b
0om8<c<2odPd=0?oB3De0om8=SH3odPg=`;oB3Ph0om8>CT3odPj>P?oB3/k
0_m8?3`3odPm?@?oB3hn0om8?cl2odQ0@0?oB4510om8@T83odQ3@`;oB4A4
0om8ADD3odQ6AP?oB4M700?oB4Q8onk^k_o^k^h06oo^k^h@odT0ohGok^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_
[jl0;_ooool3odT000?oB@410om90P82odT30`?oB@@40om91@D2odT61P?o
B@L70om920P3odT92@;oB@X:0om92`/3odT<30;oB@d=0om93Ph3odT?3`;o
BA0@0om94A43odTB4P?oBA<C0_m951@3odTE5@?oBAHF0_m95aL3odTH60?o
BATI0om96QX2odTK6`?oBA`L0om97Ad2odTN7P?oBAlO0om98202odTQ8@?o
BB8R0om98b<3odTT90;oBBDU0om99RH3odTW9`;oBBPX0om9:BT3odTZ:P;o
BB/[0om9;2`3odT];@?oBBh^0_m9;bl3odT`<0?oBC4a0_m9<S83odTc<`?o
BC@d0om9=CD2odTf=P?oBCLg0om9>3P2odTi>@?oBCXj0om9>c/2odTl?0?o
BCdm0om9?Sh3odTo?`;oBD100om9@D43odU2@P;oBD=30om9A4@3odU5A@?o
BDI60_m9AdL3odU8B0;oBDU97Oooool@od80ohGooooo00Co[jn_ol_;booN
g]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h3od/0
00?oB`410_m;0P83od/30`?oB`@40_m;1@D3od/61P?oB`L70_m;20P3od/9
2@?oB`X:0_m;2`/3od/<30?oB`d=0_m;3Ph3od/?3`?oBa0@0_m;4A43od/B
4P?oBa<C0_m;51@3od/E5@?oBaHF0_m;5aL3od/H60?oBaTI0_m;6QX3od/K
6`?oBa`L0_m;7Ad3od/N7P?oBalO0_m;8203od/Q8@?oBb8R0_m;8b<3od/T
90?oBbDU0_m;9RH3od/W9`?oBbPX0_m;:BT3od/Z:P;oBb/[0om;;2`3od/]
;@;oBbh^0om;;bl3od/`<0;oBc4a0om;<S83od/c<`;oBc@d0om;=CD3od/f
=P;oBcLg0om;>3P3od/i>@;oBcXj0om;>c/3od/l?0;oBcdm0om;?Sh3od/o
?`;oBd100om;@D43od]2@P;oBd=30om;A4@3od]5A@;oBdI60om;AdL3od]8
B0;oBdU90om;BTXMonk^kQ3o>P3oQOo^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@0^onKViP?oC0000om<0@42
od`20P?oC0<30om<10@2od`51@?oC0H60_m<1`L3od`820?oC0T90_m<2PX3
od`;2`;oC0`<0om<3@d3od`>3P;oC0l?0om<4103od`A4@;oC18B0om<4a<2
od`D50?oC1DE0om<5QH2od`G5`?oC1PH0_m<6AT3od`J6P?oC1/K0_m<71`3
od`M7@?oC1hN0_m<7al3od`P80;oC24Q0om<8R83od`S8`;oC2@T0om<9BD2
od`V9P?oC2LW0om<:2P2od`Y:@?oC2XZ0om<:b/2od`/;0?oC2d]0_m<;Rh3
od`_;`?oC30`0_m<<C43od`b<P;oC3<c0om<=3@3od`e=@;oC3Hf0om<=cL3
od`h>0;oC3Ti0om<>SX2od`k>`?oC3`l0om<?Cd2od`n?P?oC3lo0_m<@403
oda1@@?oC4920_m<@d<3oda4A0?oC4E50_m<ATH3oda7A`;oC4Q80om<BDT3
oda:BP;oC4];00?oC4a<onKVi_oVi^H06ooVi^H@oc80ohGoi^KV00CoWIfM
okNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0;_o^
k^h3odd000?oC@410_m=0P83odd30`;oC@@40om=1@D3odd61P;oC@L70om=
20P2odd92@?oC@X:0_m=2`/3odd<30?oC@d=0_m=3Ph3odd?3`;oCA0@0om=
4A42oddB4P?oCA<C0om=51@2oddE5@?oCAHF0_m=5aL3oddH60;oCATI0om=
6QX3oddK6`;oCA`L0om=7Ad2oddN7P?oCAlO0_m=8203oddQ8@?oCB8R0_m=
8b<3oddT90;oCBDU0om=9RH2oddW9`?oCBPX0om=:BT2oddZ:P?oCB/[0_m=
;2`3odd];@;oCBh^0om=;bl3odd`<0;oCC4a0om=<S82oddc<`?oCC@d0_m=
=CD3oddf=P?oCCLg0_m=>3P3oddi>@;oCCXj0om=>c/2oddl?0?oCCdm0om=
?Sh2oddo?`?oCD100_m=@D43ode2@P;oCD=30om=A4@3ode5A@;oCDI60om=
AdL2ode8B0?oCDU90_m=BTX3ode;B`?oCDa<00?oCDe=onk^k_o^k^h06oo^
k^h@ob/0oaGok^k^00?o];Bdolo?coo?cll03Oo?cll00oo5aLGo];Bdonk^
kP1Monk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkN
g_o;bl_o[jn_02kooooo0om?0003odl10@;oC`820om?0`<2odl410?oC`D5
0_m?1PH3odl71`;oC`P80om?2@T2odl:2P?oC`/;0_m?30`3odl=3@;oC`h>
0om?3`l3odl@40;oCa4A0om?4Q82odlC4`?oCa@D0_m?5AD3odlF5P;oCaLG
0om?61P2odlI6@?oCaXJ0_m?6a/3odlL70;oCadM0om?7Qh2odlO7`?oCb0P
0om?8B42odlR8P?oCb<S0_m?92@3odlU9@;oCbHV0om?9bL2odlX:0?oCbTY
0_m?:RX3odl[:`;oCb`/0om?;Bd2odl^;P?oCbl_0_m?<303odla<@?oCc8b
0_m?<c<3odld=0;oCcDe0om?=SH2odlg=`?oCcPh0_m?>CT3odlj>P;oCc/k
0om??3`2odlm?@?oCchn0_m??cl3odm0@0;oCd510om?@T83odm3@`;oCdA4
0om?ADD2odm6AP?oCdM70_m?B4P3odm9B@;oCdY:0om?Bd/2odm<C0?oCde=
0_m?CThMoooooa3o8`3o5Oooool00oni^KWogMgMonc/k004onc/k0Cok^k^
1Oo/k>`00ooMgMgo^KViooooo`1Mooooo`04ojn_[oo;bl_og]kNon[ZjP7o
l_;b00001OoQhN7of][Jolo?conm_KgoXj>S02kok^k^0om@0002oe010@?o
D0820_m@0`<3oe0410;oD0D50om@1PH2oe071`?oD0P80_m@2@T3oe0:2P;o
D0/;0om@30`2oe0=3@?oD0h>0_m@3`l3oe0@40;oD14A0om@4Q82oe0C4`?o
D1@D0_m@5AD3oe0F5P;oD1LG0om@61P2oe0I6@?oD1XJ0_m@6a/3oe0L70;o
D1dM0om@7Qh2oe0O7`?oD20P0_m@8B43oe0R8P;oD2<S0om@92@2oe0U9@?o
D2HV0_m@9bL3oe0X:0;oD2TY0om@:RX2oe0[:`?oD2`/0_m@;Bd3oe0^;P;o
D2l_0om@<302oe0a<@;oD38b0om@<c<2oe0d=0?oD3De0_m@=SH3oe0g=`;o
D3Ph0om@>CT2oe0j>P?oD3/k0_m@?3`3oe0m?@;oD3hn0om@?cl2oe10@0?o
D4510_m@@T83oe13@`;oD4A40om@ADD2oe16AP?oD4M70_m@B4P3oe19B@;o
D4Y:0om@Bd/2oe1<C0?oD4e=0_m@CTh3oe1?Cagok^k^4?lL0?lEonk^kP03
okVi^OoShn?omOGe00ComoOg1?ojn_X5ooOgm`03on?Shoni^KWok^k^05go
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg
]onMWId0;_oVi^H3oe4000;oD@410omA0P82oe430`?oD@@40_mA1@D3oe46
1P;oD@L70omA20P2oe492@;oD@X:0omA2`/2oe4<30?oD@d=0_mA3Ph3oe4?
3`;oDA0@0omA4A42oe4B4P?oDA<C0_mA51@2oe4E5@?oDAHF0_mA5aL3oe4H
60;oDATI0omA6QX2oe4K6`?oDA`L0_mA7Ad2oe4N7P?oDAlO0_mA8203oe4Q
8@;oDB8R0omA8b<2oe4T90?oDBDU0_mA9RH3oe4W9`;oDBPX0_mA:BT3oe4Z
:P;oDB/[0omA;2`2oe4];@?oDBh^0_mA;bl3oe4`<0;oDC4a0omA<S82oe4c
<`;oDC@d0omA=CD2oe4f=P?oDCLg0_mA>3P3oe4i>@;oDCXj0omA>c/2oe4l
?0;oDCdm0omA?Sh2oe4o?`?oDD100_mA@D43oe52@P;oDD=30omAA4@2oe55
A@?oDDI60_mAAdL2oe58B0?oDDU90_mABTX3oe5;B`;oDDa<0omACDd2oe5>
CP?oDDm?0_mAD5000omADE7oi^KVonKViP0KonKViQ3o503o5OoVi^H00oni
^KWohn?SooGem@0<ooooo`03ooOgmooShn?o^KVi05koi^KV00CoWIfMokNg
]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h3
oe8000;oDP410omB0P82oe830`?oDP@40_mB1@D2oe861P?oDPL70_mB20P3
oe892@;oDPX:0_mB2`/3oe8<30;oDPd=0omB3Ph2oe8?3`?oDQ0@0_mB4A42
oe8B4P?oDQ<C0_mB51@3oe8E5@;oDQHF0_mB5aL3oe8H60;oDQTI0omB6QX2
oe8K6`;oDQ`L0omB7Ad2oe8N7P?oDQlO0_mB8203oe8Q8@;oDR8R0_mB8b<3
oe8T90;oDRDU0omB9RH2oe8W9`;oDRPX0omB:BT2oe8Z:P?oDR/[0_mB;2`3
oe8];@;oDRh^0_mB;bl3oe8`<0;oDS4a0omB<S82oe8c<`;oDS@d0omB=CD2
oe8f=P?oDSLg0_mB>3P2oe8i>@?oDSXj0_mB>c/3oe8l?0;oDSdm0omB?Sh2
oe8o?`;oDT100omB@D42oe92@P?oDT=30_mBA4@2oe95A@?oDTI60_mBAdL3
oe98B0;oDTU90_mBBTX3oe9;B`;oDTa<0omBCDd2oe9>CP?oDTm?0_mBD502
oe9AD@;oDU9B7Oo^k^h@o``0oaGok^k^00?o^KVion?ShooemOD00_ooool0
0oofm_Koe]KFono_k`07ooooo`03ooOgmooShn?o^KVi05kok^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0;_oo
ool3oe@000;oE0410omD0P82oe@30`;oE0@40omD1@D2oe@61P?oE0L70_mD
20P2oe@92@?oE0X:0_mD2`/2oe@<30?oE0d=0_mD3Ph3oe@?3`;oE10@0_mD
4A43oe@B4P;oE1<C0_mD51@3oe@E5@;oE1HF0omD5aL2oe@H60;oE1TI0omD
6QX2oe@K6`;oE1`L0omD7Ad2oe@N7P?oE1lO0_mD8202oe@Q8@?oE28R0_mD
8b<2oe@T90?oE2DU0_mD9RH3oe@W9`;oE2PX0_mD:BT3oe@Z:P;oE2/[0_mD
;2`3oe@];@;oE2h^0omD;bl2oe@`<0;oE34a0omD<S82oe@c<`;oE3@d0omD
=CD2oe@f=P?oE3Lg0_mD>3P2oe@i>@?oE3Xj0_mD>c/2oe@l?0?oE3dm0_mD
?Sh3oe@o?`;oE4100_mD@D43oeA2@P;oE4=30_mDA4@3oeA5A@;oE4I60omD
AdL2oeA8B0;oE4U90omDBTX2oeA;B`?oE4a<0_mDCDd2oeA>CP?oE4m?0_mD
D502oeAAD@?oE59B0_mDDe<Moooooa3o1@3o2oooool01_lf=SKo0000o`00
0?lA4A7oATI6on7Qh@Cooooo00?o^KVion?ShooemOD00_ooool01OmmOGgo
>CTiocHf=_m1@D7o_;bl00Gooooo00?omoOgon?Shoni^KT0G_ooool01?n_
[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^
onk^kP?oE@000_mE0@43oeD20P;oE@<30_mE10@3oeD51@;oE@H60_mE1`L3
oeD820;oE@T90_mE2PX3oeD;2`;oE@`<0_mE3@d3oeD>3P;oE@l?0_mE4103
oeDA4@;oEA8B0_mE4a<3oeDD50;oEADE0_mE5QH3oeDG5`;oEAPH0_mE6AT3
oeDJ6P;oEA/K0_mE71`3oeDM7@;oEAhN0_mE7al3oeDP80;oEB4Q0_mE8R83
oeDS8`;oEB@T0_mE9BD3oeDV9P;oEBLW0_mE:2P3oeDY:@;oEBXZ0omE:b/2
oeD/;0;oEBd]0omE;Rh2oeD_;`;oEC0`0omE<C42oeDb<P;oEC<c0omE=3@2
oeDe=@;oECHf0omE=cL2oeDh>0;oECTi0omE>SX2oeDk>`;oEC`l0omE?Cd2
oeDn?P;oEClo0omE@402oeE1@@;oED920omE@d<2oeE4A0;oEDE50omEATH2
oeE7A`;oEDQ80omEBDT2oeE:BP;oED];0omEC4`2oeE=C@;oEDi>0omECdl2
oeE@D0;oEE5A0omEDU82oeECD`?oEEAD7Oo^k^h@o`02o`_ok^k^00Ko<S8b
ofm_KooYjNWoa/K6obDU9OmDE5@4onk^kP03okVi^OoShn?omOGe00Gooooo
00?oRHV9oa8B4_olo?`01?ooool00oogmoOohn?SokVi^@1Nonk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM02ko
i^KV0omF0002oeH10@;oEP820omF0`<2oeH410;oEPD50omF1PH2oeH71`;o
EPP80omF2@T2oeH:2P;oEP/;0_mF30`3oeH=3@;oEPh>0_mF3`l3oeH@40;o
EQ4A0_mF4Q83oeHC4`;oEQ@D0_mF5AD3oeHF5P;oEQLG0_mF61P2oeHI6@?o
EQXJ0_mF6a/2oeHL70?oEQdM0_mF7Qh2oeHO7`?oER0P0_mF8B42oeHR8P?o
ER<S0_mF92@2oeHU9@;oERHV0omF9bL2oeHX:0;oERTY0omF:RX2oeH[:`;o
ER`/0omF;Bd2oeH^;P;oERl_0omF<302oeHa<@;oES8b0_mF<c<3oeHd=0;o
ESDe0_mF=SH3oeHg=`;oESPh0_mF>CT3oeHj>P;oES/k0_mF?3`3oeHm?@;o
EShn0_mF?cl2oeI0@0?oET510_mF@T82oeI3@`?oETA40_mFADD2oeI6AP?o
ETM70_mFB4P2oeI9B@?oETY:0_mFBd/2oeI<C0;oETe=0omFCTh2oeI?C`;o
EU1@0omFDE42oeIBDP;oEU=C0omFE5@2oeIEE@03oeIFE_oVi^Koi^KV01_o
i^KV4?l02_l;onKViP06oc0`<?m[Jf_oi^KVonKVi_mQHF7o92@T1?oVi^H0
0oni^KWohn?Soo[jnP05ooooo`03omGEeOl0003oh^;R00Cooooo00?on_[j
on?Shoni^KT0G_oVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Q
om[Jf_o?cloo_Kfmoj>SX`0^onk^kP?oE`000_mG0@42oeL20P?oE`<30_mG
10@2oeL51@;oE`H60omG1`L2oeL820;oE`T90omG2PX2oeL;2`;oE``<0_mG
3@d3oeL>3P;oE`l?0_mG4102oeLA4@?oEa8B0_mG4a<2oeLD50?oEaDE0_mG
5QH2oeLG5`;oEaPH0omG6AT2oeLJ6P;oEa/K0_mG71`3oeLM7@;oEahN0_mG
7al3oeLP80;oEb4Q0_mG8R82oeLS8`?oEb@T0_mG9BD2oeLV9P;oEbLW0omG
:2P2oeLY:@;oEbXZ0omG:b/2oeL/;0;oEbd]0_mG;Rh3oeL_;`;oEc0`0_mG
<C42oeLb<P?oEc<c0_mG=3@2oeLe=@?oEcHf0_mG=cL2oeLh>0;oEcTi0omG
>SX2oeLk>`;oEc`l0_mG?Cd3oeLn?P;oEclo0_mG@403oeM1@@;oEd920_mG
@d<2oeM4A0?oEdE50_mGATH2oeM7A`;oEdQ80omGBDT2oeM:BP;oEd];0omG
C4`2oeM=C@;oEdi>0_mGCdl3oeM@D0;oEe5A0_mGDU82oeMCD`?oEeAD0_mG
EED2oeMFEP;oEeMG7Oo^k^h@o`0Ao`_ok^k^00Ko<S8bofm_Koo^k^koeMGE
o`d=3OmeMGD4onk^kP03okVi^OoShn?on_[j00Gooooo00?oOWinoa4A4Oom
oOd01?ooool00oojn_[ohn?SokVi^@1Nonk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_02kooooo0omI0002oeT1
0@;oF@820_mI0`<3oeT410;oF@D50_mI1PH2oeT71`?oF@P80_mI2@T2oeT:
2P;oF@/;0omI30`2oeT=3@;oF@h>0_mI3`l3oeT@40;oFA4A0_mI4Q82oeTC
4`?oFA@D0_mI5AD2oeTF5P;oFALG0omI61P2oeTI6@;oFAXJ0_mI6a/2oeTL
70?oFAdM0_mI7Qh2oeTO7`;oFB0P0omI8B42oeTR8P;oFB<S0_mI92@3oeTU
9@;oFBHV0_mI9bL2oeTX:0?oFBTY0_mI:RX2oeT[:`;oFB`/0omI;Bd2oeT^
;P;oFBl_0_mI<303oeTa<@;oFC8b0_mI<c<2oeTd=0?oFCDe0_mI=SH2oeTg
=`;oFCPh0_mI>CT3oeTj>P;oFC/k0_mI?3`2oeTm?@?oFChn0_mI?cl2oeU0
@0;oFD510omI@T82oeU3@`;oFDA40_mIADD3oeU6AP;oFDM70_mIB4P2oeU9
B@?oFDY:0_mIBd/2oeU<C0;oFDe=0omICTh2oeU?C`;oFE1@0_mIDE42oeUB
DP?oFE=C0_mIE5@2oeUEE@;oFEIF0omIEeL2oeUHF1gooooo4?l06Ol;oooo
o`06ocHf=_lb<S;o?clooaHF5_nIVIWooOgm1?ooool00oni^KWohn?Soo[j
nP02ooooo`05ol[:b_m/K6co<C4aobl_;one]KD01Oooool00oojn_[ohn?S
okVi^@1Nooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][J
olo?conm_KgoXj>S02kok^k^0omJ0002oeX10@;oFP820_mJ0`<3oeX410;o
FPD50_mJ1PH2oeX71`;oFPP80omJ2@T2oeX:2P;oFP/;0_mJ30`2oeX=3@?o
FPh>0_mJ3`l2oeX@40;oFQ4A0_mJ4Q83oeXC4`;oFQ@D0_mJ5AD2oeXF5P?o
FQLG0_mJ61P2oeXI6@;oFQXJ0_mJ6a/3oeXL70;oFQdM0_mJ7Qh2oeXO7`;o
FR0P0omJ8B42oeXR8P;oFR<S0_mJ92@2oeXU9@?oFRHV0_mJ9bL2oeXX:0;o
FRTY0omJ:RX2oeX[:`;oFR`/0_mJ;Bd2oeX^;P?oFRl_0_mJ<302oeXa<@;o
FS8b0_mJ<c<3oeXd=0;oFSDe0_mJ=SH2oeXg=`;oFSPh0omJ>CT2oeXj>P;o
FS/k0_mJ?3`2oeXm?@?oFShn0_mJ?cl2oeY0@0;oFT510omJ@T82oeY3@`;o
FTA40_mJADD2oeY6AP?oFTM70_mJB4P2oeY9B@;oFTY:0_mJBd/3oeY<C0;o
FTe=0_mJCTh2oeY?C`;oFU1@0omJDE42oeYBDP;oFU=C0_mJE5@3oeYEE@;o
FUIF0_mJEeL2oeYHF0;oFUUI00?oFUYJonk^k_o^k^h06oo^k^h@o`0Qo`_o
k^k^00Ko<S8boe5ADOn:RX[o>c/kog1`L?oZj^X4onk^kP03okVi^OoShn?o
n_[j00;ooooo00?oVi^Kod92@_oPh>001oooool00oojn_[ohn?SokVi^@1N
onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng
]kOoWIfM02koi^KV0omK0002oe/10@;oF`820_mK0`<2oe/410?oF`D50_mK
1PH2oe/71`;oF`P80_mK2@T2oe/:2P?oF`/;0_mK30`2oe/=3@;oF`h>0_mK
3`l3oe/@40;oFa4A0_mK4Q82oe/C4`;oFa@D0_mK5AD3oe/F5P;oFaLG0_mK
61P2oe/I6@;oFaXJ0omK6a/2oe/L70;oFadM0_mK7Qh2oe/O7`;oFb0P0omK
8B42oe/R8P;oFb<S0_mK92@2oe/U9@;oFbHV0omK9bL2oe/X:0;oFbTY0_mK
:RX2oe/[:`?oFb`/0_mK;Bd2oe/^;P;oFbl_0_mK<302oe/a<@?oFc8b0_mK
<c<2oe/d=0;oFcDe0_mK=SH3oe/g=`;oFcPh0_mK>CT2oe/j>P;oFc/k0_mK
?3`3oe/m?@;oFchn0_mK?cl2oe]0@0;oFd510_mK@T83oe]3@`;oFdA40_mK
ADD2oe]6AP;oFdM70omKB4P2oe]9B@;oFdY:0_mKBd/2oe]<C0;oFde=0omK
CTh2oe]?C`;oFe1@0_mKDE42oe]BDP?oFe=C0_mKE5@2oe]EE@;oFeIF0_mK
EeL2oe]HF0?oFeUI0_mKFUX00omKFe_oi^KVonKViP0KonKViQ3o02So2ooV
i^H01_l`<33oJf][onKVi_oDe=Co2@T9oj>SX`Coi^KV00?o^KVion?Shooj
n_X00_ooool00onKVi_oHF5Qooooo`07ooooo`03oo[jn_oShn?o^KVi05ko
i^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm
_OnSXj<0;_o^k^h3oed000;oG@410_mM0P82oed30`;oG@@40_mM1@D3oed6
1P;oG@L70_mM20P2oed92@;oG@X:0_mM2`/2oed<30?oG@d=0_mM3Ph2oed?
3`;oGA0@0_mM4A42oedB4P;oGA<C0omM51@2oedE5@;oGAHF0_mM5aL2oedH
60;oGATI0omM6QX2oedK6`;oGA`L0_mM7Ad2oedN7P;oGAlO0_mM8203oedQ
8@;oGB8R0_mM8b<2oedT90;oGBDU0_mM9RH2oedW9`?oGBPX0_mM:BT2oedZ
:P;oGB/[0_mM;2`2oed];@;oGBh^0omM;bl2oed`<0;oGC4a0_mM<S82oedc
<`;oGC@d0omM=CD2oedf=P;oGCLg0_mM>3P2oedi>@;oGCXj0_mM>c/3oedl
?0;oGCdm0_mM?Sh2oedo?`;oGD100_mM@D42oee2@P?oGD=30_mMA4@2oee5
A@;oGDI60_mMAdL2oee8B0?oGDU90_mMBTX2oee;B`;oGDa<0_mMCDd2oee>
CP;oGDm?0omMD502oeeAD@;oGE9B0_mMDe<2oeeDE0;oGEEE0_mMEUH3oeeG
E`;oGEQH0_mMFET2oeeJFP;oGE]K0_mMG5`Monk^kQ3o033o2oo^k^h01_lb
<S;oKfm_onk^k_oHf=So2@T9ohJ6QPCok^k^00?o^KVion?ShooemOD00_oo
ool00onKVi_o@410ojZZZP02ojZZZPGooooo00?omoOgon?Shoni^KT0G_o^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;
ojn_[`0^ooooo`?oGP000_mN0@42oeh20P;oGP<30_mN10@2oeh51@;oGPH6
0_mN1`L3oeh820;oGPT90_mN2PX2oeh;2`;oGP`<0_mN3@d2oeh>3P;oGPl?
0omN4102oehA4@;oGQ8B0_mN4a<2oehD50;oGQDE0_mN5QH2oehG5`;oGQPH
0omN6AT2oehJ6P;oGQ/K0_mN71`2oehM7@;oGQhN0_mN7al2oehP80?oGR4Q
0_mN8R82oehS8`;oGR@T0_mN9BD2oehV9P;oGRLW0_mN:2P3oehY:@;oGRXZ
0_mN:b/2oeh/;0;oGRd]0_mN;Rh2oeh_;`;oGS0`0_mN<C43oehb<P;oGS<c
0_mN=3@2oehe=@;oGSHf0_mN=cL2oehh>0;oGSTi0omN>SX2oehk>`;oGS`l
0_mN?Cd2oehn?P;oGSlo0_mN@402oei1@@?oGT920_mN@d<2oei4A0;oGTE5
0_mNATH2oei7A`;oGTQ80_mNBDT2oei:BP?oGT];0_mNC4`2oei=C@;oGTi>
0_mNCdl2oei@D0;oGU5A0_mNDU83oeiCD`;oGUAD0_mNEED2oeiFEP;oGUMG
0_mNF5P2oeiIF@;oGUYJ0omNFe/2oeiLG0;oGUeM7Oooool@o`0ho`_ooooo
00Ko=SHfobl_;om=CDgo5ADEoaXJ6_oalO44ooooo`03okVi^OoShn?omOGe
00;ooooo00Go_;bloe=CDomCDe?oDe=CoeEEE@05ooooo`03ooOgmooShn?o
^KVi05kooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][o
clo?okfm_OnSXj<0;_o^k^h3oel000;oG`410_mO0P82oel30`;oG`@40_mO
1@D2oel61P;oG`L70_mO20P2oel92@?oG`X:0_mO2`/2oel<30;oG`d=0_mO
3Ph2oel?3`;oGa0@0_mO4A42oelB4P;oGa<C0_mO51@3oelE5@;oGaHF0_mO
5aL2oelH60;oGaTI0_mO6QX2oelK6`;oGa`L0_mO7Ad2oelN7P;oGalO0omO
8202oelQ8@;oGb8R0_mO8b<2oelT90;oGbDU0_mO9RH2oelW9`;oGbPX0_mO
:BT2oelZ:P?oGb/[0_mO;2`2oel];@;oGbh^0_mO;bl2oel`<0;oGc4a0_mO
<S82oelc<`;oGc@d0_mO=CD3oelf=P;oGcLg0_mO>3P2oeli>@;oGcXj0_mO
>c/2oell?0;oGcdm0_mO?Sh2oelo?`;oGd100omO@D42oem2@P;oGd=30_mO
A4@2oem5A@;oGdI60_mOAdL2oem8B0;oGdU90_mOBTX2oem;B`?oGda<0_mO
CDd2oem>CP;oGdm?0_mOD502oemAD@;oGe9B0_mODe<2oemDE0;oGeEE0_mO
EUH3oemGE`;oGeQH0_mOFET2oemJFP;oGe]K0_mOG5`2oemMG@;oGeiN00?o
GemOonk^k_o^k^h06oo^k^h@o`0oo`_ok^k^00GoY:BTohn?SonCTi?o`/;2
onc/k005onk^kP03okVi^OoShn?omOGe00cooooo00?omoOgon?Shoni^KT0
G_o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So
]kNgoifMW@0^onKViP?oH0000_mP0@42of020P;oH0<30_mP10@2of051@;o
H0H60_mP1`L2of0820;oH0T90_mP2PX2of0;2`;oH0`<0_mP3@d2of0>3P?o
H0l?0_mP4102of0A4@;oH18B0_mP4a<2of0D50;oH1DE0_mP5QH2of0G5`;o
H1PH0_mP6AT2of0J6P;oH1/K0_mP71`2of0M7@;oH1hN0omP7al2of0P80;o
H24Q0_mP8R82of0S8`;oH2@T0_mP9BD2of0V9P;oH2LW0_mP:2P2of0Y:@;o
H2XZ0_mP:b/2of0/;0;oH2d]0omP;Rh2of0_;`;oH30`0_mP<C42of0b<P;o
H3<c0_mP=3@2of0e=@;oH3Hf0_mP=cL2of0h>0;oH3Ti0_mP>SX2of0k>`;o
H3`l0_mP?Cd3of0n?P;oH3lo0_mP@402of11@@;oH4920_mP@d<2of14A0;o
H4E50_mPATH2of17A`;oH4Q80_mPBDT2of1:BP;oH4];0_mPC4`2of1=C@?o
H4i>0_mPCdl2of1@D0;oH55A0_mPDU82of1CD`;oH5AD0_mPEED2of1FEP;o
H5MG0_mPF5P2of1IF@;oH5YJ0_mPFe/2of1LG0?oH5eM0_mPGUh2of1OG`03
of1PH?oVi^Koi^KV01_oi^KV4?l0AolEonKViP03okVi^OoShn?omOGe00Co
oooo1?ojn_X4ooooo`03ooOgmooShn?o^KVi05koi^KV00CoWIfMokNg]oo8
b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h3of80
00;oHP410_mR0P82of830`;oHP@40_mR1@D2of861P;oHPL70_mR20P2of89
2@;oHPX:0_mR2`/2of8<30;oHPd=0_mR3Ph2of8?3`;oHQ0@0_mR4A42of8B
4P;oHQ<C0_mR51@2of8E5@;oHQHF0_mR5aL2of8H60;oHQTI0omR6QX2of8K
6`;oHQ`L0_mR7Ad2of8N7P;oHQlO0_mR8202of8Q8@;oHR8R0_mR8b<2of8T
90;oHRDU0_mR9RH2of8W9`;oHRPX0_mR:BT2of8Z:P;oHR/[0_mR;2`2of8]
;@;oHRh^0_mR;bl2of8`<0;oHS4a0_mR<S82of8c<`;oHS@d0omR=CD2of8f
=P;oHSLg0_mR>3P2of8i>@;oHSXj0_mR>c/2of8l?0;oHSdm0_mR?Sh2of8o
?`;oHT100_mR@D42of92@P;oHT=30_mRA4@2of95A@;oHTI60_mRAdL2of98
B0;oHTU90_mRBTX2of9;B`;oHTa<0_mRCDd2of9>CP;oHTm?0omRD502of9A
D@;oHU9B0_mRDe<2of9DE0;oHUEE0_mREUH2of9GE`;oHUQH0_mRFET2of9J
FP;oHU]K0_mRG5`2of9MG@;oHUiN0_mRGel2of9PH0;oHV5Q7Oo^k^h@o`1?
oaGok^k^00?o^KViomgMgOoZj^X01?oZj^X4oo3`l0Goj^[Z00?ogMgMokVi
^Oo^k^h0GOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Z
j_oNg]kobl_;ojn_[`0^ooooo`?oH`000_mS0@42of<20P;oH`<30_mS10@2
of<51@;oH`H60_mS1`L2of<820;oH`T90_mS2PX2of<;2`;oH``<0_mS3@d2
of<>3P;oH`l?0_mS4102of<A4@;oHa8B0_mS4a<2of<D50;oHaDE0_mS5QH2
of<G5`;oHaPH0_mS6AT2of<J6P;oHa/K0_mS71`2of<M7@;oHahN0_mS7al2
of<P80;oHb4Q0_mS8R82of<S8`;oHb@T0_mS9BD2of<V9P;oHbLW0_mS:2P2
of<Y:@;oHbXZ0_mS:b/2of</;0;oHbd]0_mS;Rh2of<_;`;oHc0`0_mS<C42
of<b<P;oHc<c0_mS=3@2of<e=@;oHcHf0_mS=cL2of<h>0;oHcTi0_mS>SX2
of<k>`;oHc`l0_mS?Cd2of<n?P;oHclo0_mS@402of=1@@;oHd920_mS@d<2
of=4A0;oHdE50_mSATH2of=7A`;oHdQ80_mSBDT2of=:BP;oHd];0_mSC4`2
of==C@;oHdi>0_mSCdl2of=@D0;oHe5A0_mSDU82of=CD`;oHeAD0_mSEED2
of=FEP;oHeMG0_mSF5P2of=IF@?oHeYJ0_mSFe/2of=LG0;oHeeM0_mSGUh2
of=OG`;oHf1P0_mSHF42of=RHQgooooo4?l0E_lEooooo`03oiZJV_ni^KWo
`/;200Co`/;21?o3`l<5ol;2`P03okVi^OnJVY[ooooo05gooooo00Co[jn_
ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0;_o^
k^h2of@000;oI0410_mT0P82of@30`;oI0@40_mT1@D2of@61P;oI0L70_mT
20P2of@92@;oI0X:0_mT2`/2of@<30;oI0d=0_mT3Ph2of@?3`;oI10@0_mT
4A42of@B4P;oI1<C0_mT51@2of@E5@;oI1HF0_mT5aL2of@H60;oI1TI0_mT
6QX2of@K6`;oI1`L0_mT7Ad2of@N7P;oI1lO0_mT8202of@Q8@;oI28R0_mT
8b<2of@T90;oI2DU0_mT9RH2of@W9`;oI2PX0_mT:BT2of@Z:P;oI2/[0_mT
;2`2of@];@;oI2h^0_mT;bl2of@`<0;oI34a0_mT<S82of@c<`;oI3@d0_mT
=CD2of@f=P;oI3Lg0_mT>3P2of@i>@;oI3Xj0_mT>c/2of@l?0;oI3dm0_mT
?Sh2of@o?`;oI4100_mT@D42ofA2@P;oI4=30_mTA4@00omTADGoI4I6ofA6
AP02ofA7A`;oI4Q80_mTBDT2ofA:BP;oI4];0_mTC4`2ofA=C@;oI4i>0_mT
Cdl2ofA@D0;oI55A0_mTDU82ofACD`;oI5AD0_mTEED2ofAFEP;oI5MG0_mT
F5P2ofAIF@;oI5YJ0_mTFe/2ofALG0;oI5eM0_mTGUh2ofAOG`;oI61P0_mT
HF42ofARHP;oI6=S00?oI6ATonk^k_o^k^h06oo^k^h@o`1NoaGok^k^00?o
JFUYogMgMomkNg/01?mkNg/4ogalO0GoNg]k00?oMgMgofUYJOo^k^h0GOo^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNg
oifMW@0^onKViP;oI@000_mU0@42ofD20P;oI@<30_mU10@2ofD51@;oI@H6
0_mU1`L2ofD820;oI@T90_mU2PX2ofD;2`;oI@`<0_mU3@d2ofD>3P;oI@l?
0_mU4102ofDA4@;oIA8B0_mU4a<2ofDD50;oIADE0_mU5QH2ofDG5`;oIAPH
00?oIATIofDJ6_mU6QX00_mU6a/2ofDL70;oIAdM0_mU7Qh2ofDO7`;oIB0P
0_mU8B42ofDR8P;oIB<S0_mU92@2ofDU9@;oIBHV0_mU9bL2ofDX:0;oIBTY
0_mU:RX2ofD[:`;oIB`/0_mU;Bd2ofD^;P;oIBl_0_mU<302ofDa<@;oIC8b
00?oIC<cofDd=?mU=3@00_mU=CD2ofDf=P;oICLg0_mU>3P2ofDi>@;oICXj
0_mU>c/2ofDl?0;oICdm0_mU?Sh2ofDo?`;oID100_mU@D42ofE2@P;oID=3
0_mUA4@2ofE5A@;oIDI60_mUAdL2ofE8B0;oIDU90_mUBTX2ofE;B`03ofE<
C?mUCDgoIDe=00;oIDi>0_mUCdl2ofE@D0;oIE5A0_mUDU82ofECD`;oIEAD
0_mUEED2ofEFEP;oIEMG0_mUF5P2ofEIF@;oIEYJ0_mUFe/2ofELG0;oIEeM
0_mUGUh2ofEOG`;oIF1P0_mUHF42ofERHP;oIF=S0_mUI6@00omUIFGoi^KV
onKViP0KonKViQ3o06KoQOoVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00
00GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kP;oI`000_mW0@42ofL20P;o
I`<30_mW10@2ofL51@;oI`H60_mW1`L2ofL820;oI`T90_mW2PX2ofL;2`;o
I``<0_mW3@d2ofL>3P03ofL?3omW413oIa0@00;oIa4A0_mW4Q82ofLC4`;o
Ia@D0_mW5AD2ofLF5P;oIaLG0_mW61P2ofLI6@;oIaXJ0_mW6a/2ofLL70;o
IadM0_mW7Qh00omW7aooIb0PofLP8002ofLQ8@;oIb8R0_mW8b<2ofLT90;o
IbDU0_mW9RH2ofLW9`;oIbPX0_mW:BT2ofLZ:P;oIb/[0_mW;2`2ofL];@;o
Ibh^00?oIbl_ofL`<?mW<3000_mW<C42ofLb<P;oIc<c0_mW=3@2ofLe=@;o
IcHf0_mW=cL2ofLh>0;oIcTi0_mW>SX2ofLk>`;oIc`l0_mW?Cd2ofLn?P03
ofLo?omW@43oId1000;oId510_mW@T82ofM3@`;oIdA40_mWADD2ofM6AP;o
IdM70_mWB4P2ofM9B@;oIdY:0_mWBd/2ofM<C0;oIde=00?oIdi>ofM?ComW
Cdl00_mWD502ofMAD@;oIe9B0_mWDe<2ofMDE0;oIeEE0_mWEUH2ofMGE`;o
IeQH0_mWFET2ofMJFP;oIe]K0_mWG5`2ofMMG@03ofMNG_mWGeooIemO00;o
If1P0_mWHF42ofMRHP;oIf=S0_mWI6@2ofMUI@;oIfIV7Oo^k^h@o`1]ohGo
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;
bon_[jl0;_ooool2ofP000;oJ0410_mX0P82ofP30`;oJ0@40_mX1@D2ofP6
1P;oJ0L70_mX20P2ofP92@;oJ0X:00?oJ0/;ofP<3?mX30`00_mX3@d2ofP>
3P;oJ0l?0_mX4102ofPA4@;oJ18B0_mX4a<2ofPD50;oJ1DE00?oJ1HFofPG
5omX5aL00_mX61P2ofPI6@;oJ1XJ0_mX6a/2ofPL70;oJ1dM0_mX7Qh2ofPO
7`;oJ20P0_mX8B400omX8R;oJ2<SofPS8`02ofPT90;oJ2DU0_mX9RH2ofPW
9`;oJ2PX0_mX:BT2ofPZ:P;oJ2/[0_mX;2`00omX;BgoJ2h^ofP^;P02ofP_
;`;oJ30`0_mX<C42ofPb<P;oJ3<c0_mX=3@2ofPe=@;oJ3Hf0_mX=cL2ofPh
>003ofPi>OmX>S[oJ3Xj00;oJ3/k0_mX?3`2ofPm?@;oJ3hn0_mX?cl2ofQ0
@0;oJ4510_mX@T82ofQ3@`03ofQ4A?mXADGoJ4E500;oJ4I60_mXAdL2ofQ8
B0;oJ4U90_mXBTX2ofQ;B`;oJ4a<0_mXCDd2ofQ>CP;oJ4m?00?oJ51@ofQA
DOmXDE400_mXDU82ofQCD`;oJ5AD0_mXEED2ofQFEP;oJ5MG0_mXF5P2ofQI
F@;oJ5YJ00?oJ5]KofQLG?mXG5`00_mXGEd2ofQNGP;oJ5mO0_mXH602ofQQ
H@;oJ69R0_mXHf<2ofQTI0;oJ6EU0_mXIVH00omXIfOoJ6QXooooo`0Loooo
oa3o07Go5Oooool00ond];Coclo?olo?c`0=olo?c`03olG5aOnd];Cooooo
05gooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?
okfm_OnSXj<0;_o^k^h2ofT000;oJ@410_mY0P82ofT30`;oJ@@40_mY1@D2
ofT61P;oJ@L70_mY20P00omY2@WoJ@X:ofT:2P02ofT;2`;oJ@`<0_mY3@d2
ofT>3P;oJ@l?0_mY4102ofTA4@03ofTB4_mY4a?oJA<C00;oJA@D0_mY5AD2
ofTF5P;oJALG0_mY61P2ofTI6@;oJAXJ00?oJA/KofTL7?mY71`00_mY7Ad2
ofTN7P;oJAlO0_mY8202ofTQ8@;oJB8R0_mY8b<00omY92CoJBDUofTU9@02
ofTV9P;oJBLW0_mY:2P2ofTY:@;oJBXZ0_mY:b/2ofT/;003ofT];OmY;Rko
JBh^00;oJBl_0_mY<302ofTa<@;oJC8b0_mY<c<2ofTd=0;oJCDe00?oJCHf
ofTg=omY=cL00_mY>3P2ofTi>@;oJCXj0_mY>c/2ofTl?0;oJCdm0_mY?Sh0
0omY?cooJD10ofU0@002ofU1@@;oJD920_mY@d<2ofU4A0;oJDE50_mYATH2
ofU7A`03ofU8B?mYBDWoJDU900;oJDY:0_mYBd/2ofU<C0;oJDe=0_mYCTh2
ofU?C`;oJE1@00?oJE5AofUBD_mYDU800_mYDe<2ofUDE0;oJEEE0_mYEUH2
ofUGE`;oJEQH0_mYFET00omYFU[oJE]KofUKF`02ofULG0;oJEeM0_mYGUh2
ofUOG`;oJF1P0_mYHF42ofURHP03ofUSHomYI6CoJFAT00;oJFEU0_mYIVH2
ofUWI`;oJFQX00?oJFUYonk^k_o^k^h06oo^k^h@o`1loaGok^k^00?o^KVi
omgMgOo/k>`01?o/k>`4onk^kPGok>c/00?ogMgMokVi^Oo^k^h0GOo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifM
W@0^onKViP;oJ`000_m[0@42of/20P;oJ`<30_m[10@2of/51@;oJ`H600?o
J`L7of/82?m[20P00_m[2@T2of/:2P;oJ`/;0_m[30`2of/=3@;oJ`h>00?o
J`l?of/@4?m[41000_m[4A42of/B4P;oJa<C0_m[51@2of/E5@03of/F5_m[
5aOoJaLG00;oJaPH0_m[6AT2of/J6P;oJa/K0_m[71`2of/M7@03of/N7_m[
7aooJalO00;oJb0P0_m[8B42of/R8P;oJb<S0_m[92@00om[9BGoJbHVof/V
9P02of/W9`;oJbPX0_m[:BT2of/Z:P;oJb/[0_m[;2`00om[;BgoJbh^of/^
;P02of/_;`;oJc0`0_m[<C42of/b<P;oJc<c00?oJc@dof/e=Om[=CD00_m[
=SH2of/g=`;oJcPh0_m[>CT2of/j>P;oJc/k00?oJc`lof/m?Om[?Cd00_m[
?Sh2of/o?`;oJd100_m[@D42of]2@P03of]3@om[A4CoJdA400;oJdE50_m[
ATH2of]7A`;oJdQ80_m[BDT2of]:BP03of];Bom[C4coJda<00;oJde=0_m[
CTh2of]?C`;oJe1@0_m[DE400om[DU;oJe=Cof]CD`02of]DE0;oJeEE0_m[
EUH2of]GE`;oJeQH0_m[FET00om[FU[oJe]Kof]KF`02of]LG0;oJeeM0_m[
GUh2of]OG`;oJf1P0_m[HF400om[HV;oJf=Sof]SH`02of]TI0;oJfEU0_m[
IVH2of]WI`;oJfQX00?oJfUYof]ZJ_m[JVX07OoVi^H@o`24oaGoi^KV00?o
^KVion?ShooemOD01?ogmoL4oo[jnPGomoOg00?ohn?SokVi^OoVi^H0GOoV
i^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfm
oj>SX`0^onk^kP;oK0000_m/0@42of`20P;oK0<30_m/10@2of`51@03of`6
1_m/1`OoK0L700;oK0P80_m/2@T2of`:2P;oK0/;00?oK0`<of`=3Om/3@d0
0_m/3Ph2of`?3`;oK10@0_m/4A42of`B4P03of`C4om/51CoK1@D00;oK1DE
0_m/5QH2of`G5`;oK1PH00?oK1TIof`J6_m/6QX00_m/6a/2of`L70;oK1dM
0_m/7Qh2of`O7`03of`P8?m/8B7oK24Q00;oK28R0_m/8b<2of`T90;oK2DU
00?oK2HVof`W9om/9bL00_m/:2P2of`Y:@;oK2XZ0_m/:b/2of`/;003of`]
;Om/;RkoK2h^00;oK2l_0_m/<302of`a<@;oK38b00?oK3<cof`d=?m/=3@0
0_m/=CD2of`f=P;oK3Lg0_m/>3P2of`i>@03of`j>_m/>c_oK3/k00;oK3`l
0_m/?Cd2of`n?P;oK3lo00?oK410ofa1@Om/@D400_m/@T82ofa3@`;oK4A4
0_m/ADD2ofa6AP03ofa7Aom/B4SoK4Q800;oK4U90_m/BTX2ofa;B`;oK4a<
00?oK4e=ofa>C_m/CTh00_m/Cdl2ofa@D0;oK55A0_m/DU82ofaCD`03ofaD
E?m/EEGoK5EE00;oK5IF0_m/EeL2ofaHF0;oK5UI00?oK5YJofaKFom/Fe/0
0_m/G5`2ofaMG@;oK5iN0_m/Gel2ofaPH003ofaQHOm/HV;oK69R00;oK6=S
0_m/I6@2ofaUI@;oK6IV00?oK6MWofaXJ?m/J6P00_m/JFT2ofaZJP;oK6][
7Oo^k^h@o`2<oaGok^k^00?o^KVion?ShooemOD03?ooool00oogmoOohn?S
okVi^@1Nonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[Z
omkNg_o;bl_o[jn_02kooooo0_m]0002ofd10@;oK@820_m]0`<2ofd41003
ofd51Om]1PKoK@H600;oK@L70_m]20P2ofd92@;oK@X:00?oK@/;ofd<3?m]
30`00_m]3@d2ofd>3P;oK@l?0_m]41000om]4A7oKA8BofdB4P02ofdC4`;o
KA@D0_m]5AD00om]5QKoKALGofdG5`02ofdH60;oKATI0_m]6QX2ofdK6`03
ofdL7?m]7AgoKAdM00;oKAhN0_m]7al2ofdP80;oKB4Q00?oKB8RofdS8om]
8b<00_m]92@2ofdU9@;oKBHV00?oKBLWofdX:?m]:2P00_m]:BT2ofdZ:P;o
KB/[0_m];2`00om];BgoKBh^ofd^;P02ofd_;`;oKC0`0_m]<C42ofdb<P03
ofdc<om]=3CoKC@d00;oKCDe0_m]=SH2ofdg=`03ofdh>?m]>CWoKCTi00;o
KCXj0_m]>c/2ofdl?0;oKCdm00?oKChnofdo?om]?cl00_m]@402ofe1@@;o
KD920_m]@d<00om]A4CoKDE5ofe5A@02ofe6AP;oKDM70_m]B4P00om]BDWo
KDY:ofe:BP02ofe;B`;oKDa<0_m]CDd2ofe>CP03ofe?Com]D53oKE1@00;o
KE5A0_m]DU82ofeCD`;oKEAD00?oKEEEofeFE_m]EUH00_m]EeL2ofeHF0;o
KEUI00?oKEYJofeKFom]Fe/00_m]G5`2ofeMG@;oKEiN0_m]Gel00om]H63o
KF5QofeQH@02ofeRHP;oKF=S0_m]I6@2ofeUI@03ofeVI_m]IfOoKFMW00;o
KFQX0_m]JFT2ofeZJP04ofe[Jom]K6coKFa/ofe]KAgooooo4?l0Tol>oooo
o`03onCTi?o@d=3om?Cd00Cooooo00?o^KVion?ShooemOD00_ooool00oof
m_Koe]KFono_k`07ooooo`03ooOgmooShn?o^KVi05kooooo00Co[jn_ol_;
booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h2
ofh000;oKP410_m^0P82ofh30`;oKP@400?oKPD5ofh61_m^1PH00_m^1`L2
ofh820;oKPT900?oKPX:ofh;2om^2`/00_m^30`2ofh=3@;oKPh>00?oKPl?
ofh@4?m^41000_m^4A42ofhB4P;oKQ<C00?oKQ@DofhE5Om^5AD00_m^5QH2
ofhG5`;oKQPH00?oKQTIofhJ6_m^6QX00_m^6a/2ofhL70;oKQdM00?oKQhN
ofhO7om^7al00_m^8202ofhQ8@;oKR8R00?oKR<SofhT9?m^92@00_m^9BD2
ofhV9P;oKRLW00?oKRPXofhY:Om^:BT00_m^:RX2ofh[:`;oKR`/00?oKRd]
ofh^;_m^;Rh00_m^;bl2ofh`<0;oKS4a00?oKS8bofhc<om^<c<00_m^=3@2
ofhe=@;oKSHf00?oKSLgofhh>?m^>3P00_m^>CT2ofhj>P;oKS/k00?oKS`l
ofhm?Om^?Cd00_m^?Sh2ofho?`;oKT1000?oKT51ofi2@_m^@T800_m^@d<2
ofi4A0;oKTE50_m^ATH00om^AdOoKTQ8ofi8B002ofi9B@;oKTY:0_m^Bd/0
0om^C4coKTe=ofi=C@02ofi>CP;oKTm?0_m^D5000om^DE7oKU9BofiBDP02
ofiCD`;oKUAD0_m^EED00om^EUKoKUMGofiGE`02ofiHF0;oKUUI0_m^FUX0
0om^Fe_oKUaLofiLG002ofiMG@;oKUiN0_m^Gel00om^H63oKV5QofiQH@02
ofiRHP;oKV=S0_m^I6@00om^IFGoKVIVofiVIP02ofiWI`;oKVQX0_m^JFT0
0om^JV[oKV][ofi[J`02ofi/K0;oKVe]00?oKVi^onk^k_o^k^h06oo^k^h@
o`2Ko`cok^k^00OoTi>Coa8B4_l>3Pko;Rh^oa<C4olM7Ago_;bl00;ok^k^
00?o^KVion?ShooemOD00_ooool01OmmOGgo>CTiocHf=_m1@D7o_;bl00Go
oooo00?omoOgon?Shoni^KT0G_o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Q
h@0000Gof][Jom?Cdoo8b<So]kNgoifMW@0^onKViP;oL0000_m`0@42og02
0P;oL0<300?oL0@4og051Om`1@D00_m`1PH2og071`;oL0P800?oL0T9og0:
2_m`2PX00_m`2`/2og0<3003og0=3Om`3PkoL0h>00;oL0l?0_m`4102og0A
4@03og0B4_m`4a?oL1<C00;oL1@D0_m`5AD00om`5QKoL1LGog0G5`02og0H
60;oL1TI0_m`6QX00om`6a_oL1`Log0L7002og0M7@;oL1hN0_m`7al00om`
823oL24Qog0Q8@02og0R8P;oL2<S00?oL2@Tog0U9Om`9BD00_m`9RH2og0W
9`;oL2PX00?oL2TYog0Z:_m`:RX00_m`:b/2og0/;003og0];Om`;RkoL2h^
00;oL2l_0_m`<302og0a<@03og0b<_m`<c?oL3<c00;oL3@d0_m`=CD2og0f
=P03og0g=om`>3SoL3Ph00;oL3Ti0_m`>SX00om`>c_oL3`log0l?002og0m
?@;oL3hn0_m`?cl00om`@43oL451og11@@02og12@P;oL4=300?oL4A4og15
AOm`ADD00_m`ATH2og17A`;oL4Q800?oL4U9og1:B_m`BTX00_m`Bd/2og1<
C0;oL4e=00?oL4i>og1?Com`Cdl00_m`D502og1AD@03og1BD_m`De?oL5=C
00;oL5AD0_m`EED2og1FEP03og1GEom`F5SoL5QH00;oL5UI0_m`FUX00om`
Fe_oL5aLog1LG002og1MG@;oL5iN0_m`Gel00om`H63oL65Qog1QH@02og1R
HP;oL6=S0_m`I6@00om`IFGoL6IVog1VIP02og1WI`;oL6QX00?oL6UYog1Z
J_m`JVX00_m`Jf/2og1/K0;oL6e]00?oL6i^og1_Kom`Kfl07OoVi^H@o`2S
o`_oi^KV00?oR8R8o`<30on5QHD00_oVi^H00ooIfMWo0000ojNWY`02onKV
iP03okVi^OoShn?omOGe00Gooooo00?oRHV9oa8B4_olo?`01?ooool00oog
moOohn?SokVi^@1NonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQ
hN7of][Jolo?conm_KgoXj>S02kok^k^0_ma0002og410@;oL@820_ma0`<0
0oma10CoL@D5og451@02og461P;oL@L700?oL@P8og492Oma2@T00_ma2PX2
og4;2`03og4<3?ma3@goL@d=00;oL@h>0_ma3`l00oma413oLA4Aog4A4@02
og4B4P;oLA<C0_ma51@00oma5AGoLAHFog4F5P02og4G5`;oLAPH00?oLATI
og4J6_ma6QX00_ma6a/2og4L7003og4M7Oma7QkoLAhN00;oLAlO0_ma8200
0oma8B7oLB8Rog4R8P02og4S8`;oLB@T00?oLBDUog4V9_ma9RH00_ma9bL2
og4X:0;oLBTY00?oLBXZog4[:oma:b/00_ma;2`2og4];@03og4^;_ma;boo
LBl_00;oLC0`0_ma<C400oma<S;oLC<cog4c<`02og4d=0;oLCDe00?oLCHf
og4g=oma=cL00_ma>3P2og4i>@03og4j>_ma>c_oLC/k00;oLC`l0_ma?Cd2
og4n?P03og4o?oma@43oLD1000;oLD510_ma@T800oma@d?oLDA4og54A002
og55A@;oLDI600?oLDM7og58B?maB4P00_maBDT2og5:BP03og5;BomaC4co
LDa<00;oLDe=0_maCTh2og5?C`03og5@D?maDE7oLE5A00;oLE9B0_maDe<0
0omaE5CoLEEEog5EE@02og5FEP;oLEMG00?oLEQHog5IFOmaFET00_maFUX2
og5KF`03og5LG?maGEgoLEeM00;oLEiN0_maGel00omaH63oLF5Qog5QH@02
og5RHP;oLF=S0_maI6@00omaIFGoLFIVog5VIP02og5WI`;oLFQX00?oLFUY
og5ZJ_maJVX00_maJf/2og5/K003og5]KOmaKVkoLFi^00;oLFm_0_maL70M
onk^kQ3o0:[o2_o^k^h00ooWinOo4Q8Bof5QH@03onk^kP03on3Ph?l0003o
[Jf]00;ok^k^00?o^KVion?Shoojn_X01Oooool00ooEeMGo0000on;RhP04
ooooo`03oo[jn_oShn?o^KVi05kok^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN400005oo;bl_oZj^[og]kNol_;bon_[jl0;_ooool2og8000;oLP410_mb
0P800omb0`?oLP@4og841002og851@;oLPH600?oLPL7og882?mb20P00_mb
2@T2og8:2P03og8;2omb30coLP`<00;oLPd=0_mb3Ph00omb3`ooLQ0@og8@
4002og8A4@;oLQ8B00?oLQ<Cog8D5?mb51@00_mb5AD2og8F5P03og8G5omb
61SoLQPH00;oLQTI0_mb6QX00omb6a_oLQ`Log8L7002og8M7@;oLQhN00?o
LQlOog8P8?mb82000_mb8B42og8R8P03og8S8omb92CoLR@T00;oLRDU00?o
LRHVog8W9omb9bL00_mb:2P2og8Y:@03og8Z:_mb:b_oLR/[00;oLR`/0_mb
;Bd00omb;RkoLRl_og8_;`02og8`<0;oLS4a00?oLS8bog8c<omb<c<00_mb
=3@2og8e=@03og8f=_mb=cOoLSLg00;oLSPh0_mb>CT00omb>S[oLS/kog8k
>`02og8l?0;oLSdm00?oLShnog8o?omb?cl00_mb@402og91@@03og92@_mb
@d?oLT=300;oLTA40_mbADD00ombATKoLTM7og97A`02og98B003og99BOmb
BT[oLTY:00;oLT];0_mbC4`00ombCDgoLTi>og9>CP02og9?C`;oLU1@00?o
LU5Aog9BD_mbDU800_mbDe<2og9DE003og9EEOmbEUKoLUIF00;oLUMG0_mb
F5P00ombFEWoLUYJog9JFP02og9KF`;oLUaL00?oLUeMog9NG_mbGUh00_mb
Gel2og9PH003og9QHOmbHV;oLV9R00;oLV=S0_mbI6@00ombIFGoLVIVog9V
IP02og9WI`;oLVQX00?oLVUYog9ZJ_mbJVX00_mbJf/00ombK6coLVe]og9]
K@02og9^KP;oLVm_00CoLW1`og9aLOmbLG7oLW9b7Oooool@o`2bo`[ooooo
00?oe=CDo`000?o3`l<00oooool00ooalO7o0000okZj^P02ooooo`03okVi
^OoShn?on_[j00Gooooo00?oOWinoa4A4OomoOd01?ooool00oojn_[ohn?S
okVi^@1Nooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][J
olo?conm_KgoXj>S02kok^k^0_md0002og@10@;oM08200?oM0<3og@41?md
10@00_md1@D2og@61P03og@71omd20SoM0P800;oM0T900?oM0X:og@;2omd
2`/00_md30`2og@=3@03og@>3_md3`ooM0l?00;oM10@0_md4A400omd4Q;o
M1<Cog@C4`02og@D5003og@E5Omd5QKoM1HF00;oM1LG0_md61P00omd6AWo
M1XJog@J6P02og@K6`03og@L7?md7AgoM1dM00;oM1hN0_md7al00omd823o
M24Qog@Q8@02og@R8P;oM2<S00?oM2@Tog@U9Omd9BD00_md9RH00omd9bOo
M2PXog@X:002og@Y:@;oM2XZ00?oM2/[og@/;?md;2`00_md;Bd2og@^;P03
og@_;omd<33oM30`00;oM34a00?oM38bog@c<omd<c<00_md=3@2og@e=@03
og@f=_md=cOoM3Lg00;oM3Ph00?oM3Tiog@j>_md>SX00_md>c/2og@l?003
og@m?Omd?SkoM3hn00;oM3lo0_md@4000omd@D7oM492ogA2@P02ogA3@`03
ogA4A?mdADGoM4E500;oM4I60_mdAdL00omdB4SoM4U9ogA9B@02ogA:BP;o
M4];00?oM4a<ogA=COmdCDd00_mdCTh00omdCdooM51@ogA@D002ogAAD@;o
M59B00?oM5=CogADE?mdE5@00_mdEED00omdEUKoM5MGogAGE`02ogAHF0;o
M5UI00?oM5YJogAKFomdFe/00_mdG5`2ogAMG@03ogANG_mdGeooM5mO00;o
M61P00?oM65QogARH_mdHV800_mdHf<2ogATI003ogAUIOmdIVKoM6IV00;o
M6MW00?oM6QXogAYJOmdJFT00_mdJVX2ogA[J`03ogA/K?mdKFgoM6e]00;o
M6i^0_mdKfl00omdL73oM75aogAaL@02ogAbLP03ogAcLoo^k^kok^k^01_o
k^k^4?l0^_l:onk^kP03ojNWYol0003od];B00Cok^k^00Ooh>3Pon_[joo^
k^kok^k^okVi^OoShn?on_[j00;ooooo00Gob/[:ofa/K?la<C7o;bl_okFe
]@05ooooo`03oo[jn_oShn?o^KVi05kok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0;_oVi^H2ogD000;oM@41
0_me0P800ome0`?oM@@4ogD41002ogD51@03ogD61_me1`OoM@L700;oM@P8
0_me2@T00ome2P[oM@/;ogD;2`02ogD<3003ogD=3Ome3PkoM@h>00;oM@l?
00?oMA0@ogDA4Ome4A400_me4Q82ogDC4`03ogDD5?me5AGoMADE00;oMAHF
00?oMALGogDH6?me61P00_me6AT2ogDJ6P03ogDK6ome71coMA`L00;oMAdM
00?oMAhNogDO7ome7al00_me82000ome8B7oMB8RogDR8P02ogDS8`;oMB@T
00?oMBDUogDV9_me9RH00_me9bL00ome:2SoMBTYogDY:@02ogDZ:P;oMB/[
00?oMB`/ogD];Ome;Bd00_me;Rh00ome;booMC0`ogD`<002ogDa<@03ogDb
<_me<c?oMC<c00;oMC@d0_me=CD00ome=SKoMCLgogDg=`02ogDh>003ogDi
>Ome>S[oMCXj00;oMC/k0_me?3`00ome?CgoMChnogDn?P02ogDo?`03ogE0
@?me@D7oMD5100;oMD9200?oMD=3ogE4A?meA4@00_meADD2ogE6AP03ogE7
AomeB4SoMDQ800;oMDU900?oMDY:ogE;BomeBd/00_meC4`00omeCDgoMDi>
ogE>CP02ogE?C`;oME1@00?oME5AogEBD_meDU800_meDe<00omeE5CoMEEE
ogEEE@02ogEFEP;oMEMG00?oMEQHogEIFOmeFET00_meFUX00omeFe_oMEaL
ogELG002ogEMG@03ogENG_meGeooMEmO00;oMF1P0_meHF400omeHV;oMF=S
ogESH`02ogETI003ogEUIOmeIVKoMFIV00;oMFMW0_meJ6P00omeJFWoMFYZ
ogEZJP02ogE[J`03ogE/K?meKFgoMFe]00;oMFi^00?oMFm_ogE`L?meL700
0_meLG42ogEbLP03ogEcLomeM7CoMGAd01goi^KV4?l0`Ol:onKViP03ok:b
/_l0003o_Kfm00Soi^KV00?o^KVion?Shoojn_X00_ooool00onKVi_o@T92
on3Ph007ooooo`03oo[jn_oShn?o^KVi05koi^KV00CoWIfMokNg]oo8b<So
dm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h2ogH000;o
MP410_mf0P800omf0`?oMP@4ogH41002ogH51@03ogH61_mf1`OoMPL700;o
MPP800?oMPT9ogH:2_mf2PX00_mf2`/00omf30coMPd=ogH=3@02ogH>3P03
ogH?3omf413oMQ0@00;oMQ4A0_mf4Q800omf4a?oMQ@DogHD5002ogHE5@03
ogHF5_mf5aOoMQLG00;oMQPH00?oMQTIogHJ6_mf6QX00_mf6a/00omf71co
MQdMogHM7@02ogHN7P03ogHO7omf823oMR0P00;oMR4Q0_mf8R800omf8b?o
MR@TogHT9002ogHU9@03ogHV9_mf9bOoMRLW00;oMRPX00?oMRTYogHZ:_mf
:RX00_mf:b/00omf;2coMRd]ogH];@02ogH^;P03ogH_;omf<33oMS0`00;o
MS4a0_mf<S800omf<c?oMS@dogHd=002ogHe=@03ogHf=_mf=cOoMSLg00;o
MSPh00?oMSTiogHj>_mf>SX00_mf>c/00omf?3coMSdmogHm?@02ogHn?P03
ogHo?omf@43oMT1000;oMT510_mf@T800omf@d?oMTA4ogI4A002ogI5A@03
ogI6A_mfAdOoMTM700;oMTQ800?oMTU9ogI:B_mfBTX00_mfBd/00omfC4co
MTe=ogI=C@02ogI>CP03ogI?ComfD53oMU1@00;oMU5A00?oMU9BogICDomf
De<00_mfE5@2ogIEE@03ogIFE_mfEeOoMUMG00;oMUQH00?oMUUIogIJF_mf
FUX00_mfFe/00omfG5coMUeMogIMG@02ogINGP03ogIOGomfH63oMV1P00;o
MV5Q00?oMV9RogISHomfHf<00_mfI6@2ogIUI@03ogIVI_mfIfOoMVMW00;o
MVQX00?oMVUYogIZJ_mfJVX00_mfJf/00omfK6coMVe]ogI]K@02ogI^KP03
ogI_KomfL73oMW1`00;oMW5a00?oMW9bogIcLomfLg<00_mfM7@2ogIeMAgo
k^k^4?l0bOl:onk^kP03omgMgOl0003oTY:B00Sok^k^00?o^KVion?Shooj
n_X00_ooool00onKVi_oHF5Qooooo`07ooooo`03oo[jn_oShn?o^KVi05ko
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;
bon_[jl0;_ooool2ogL000;oM`410_mg0P800omg0`?oM`@4ogL41002ogL5
1@03ogL61_mg1`OoM`L700;oM`P800?oM`T9ogL:2_mg2PX00_mg2`/00omg
30coM`d=ogL=3@02ogL>3P03ogL?3omg413oMa0@00;oMa4A00?oMa8BogLC
4omg4a<00_mg51@00omg5AGoMaHFogLF5P02ogLG5`03ogLH6?mg6AWoMaTI
00;oMaXJ00?oMa/KogLL7?mg71`00_mg7Ad00omg7QkoMalOogLO7`02ogLP
8003ogLQ8Omg8R;oMb8R00;oMb<S00?oMb@TogLU9Omg9BD00_mg9RH00omg
9bOoMbPXogLX:002ogLY:@03ogLZ:_mg:b_oMb/[00;oMb`/00?oMbd]ogL^
;_mg;Rh00_mg;bl00omg<33oMc4aogLa<@02ogLb<P03ogLc<omg=3CoMc@d
00;oMcDe00?oMcHfogLg=omg=cL00_mg>3P00omg>CWoMcXjogLj>P02ogLk
>`03ogLl??mg?CgoMcdm00;oMchn00?oMcloogM0@?mg@4000_mg@D400omg
@T;oMd=3ogM3@`02ogM4A003ogM5AOmgATKoMdI600;oMdM700?oMdQ8ogM9
BOmgBDT00_mgBTX00omgBd_oMda<ogM<C002ogM=C@03ogM>C_mgCdooMdm?
00;oMe1@00?oMe5AogMBD_mgDU800_mgDe<00omgE5CoMeEEogMEE@02ogMF
EP03ogMGEomgF5SoMeQH00;oMeUI00?oMeYJogMKFomgFe/00_mgG5`00omg
GEgoMeiNogMNGP02ogMOG`03ogMPH?mgHF7oMf5Q00;oMf9R00?oMf=SogMT
I?mgI6@00_mgIFD00omgIVKoMfMWogMWI`02ogMXJ003ogMYJOmgJV[oMfYZ
00;oMf][00?oMfa/ogM]KOmgKFd00_mgKVh00omgKfooMg1`ogM`L002ogMa
L@03ogMbL_mgLg?oMg=c00;oMgAd00CoMgEeogMfM_mgMWKoMgMg7Oooool@
o`3Ao`_ooooo00?oHf=Sob@T9?o/k>`01oooool00oni^KWohn?SooGem@02
ooooo`03oi^KVom0@43oZZZZ00;oZZZZ1Oooool00oogmoOohn?SokVi^@1N
ooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm
_KgoXj>S02kok^k^0_mi0002ogT10@03ogT20_mi0`?oN@<300;oN@@400?o
N@D5ogT61_mi1PH00_mi1`L00omi20SoN@T9ogT92@02ogT:2P03ogT;2omi
30coN@`<00;oN@d=00?oN@h>ogT?3omi3`l00_mi41000omi4A7oNA8BogTB
4P02ogTC4`04ogTD5?mi5AGoNADEogTF5P;oNALG0_mi61P00omi6AWoNAXJ
ogTJ6P02ogTK6`03ogTL7?mi7AgoNAdM00;oNAhN00?oNAlOogTP8?mi8200
0_mi8B400omi8R;oNB<SogTS8`02ogTT9003ogTU9Omi9RKoNBHV00;oNBLW
00?oNBPXogTY:Omi:BT00_mi:RX01?mi:b_oNB`/ogT/;?mi;Bd2ogT^;P;o
NBl_00?oNC0`ogTa<Omi<C400_mi<S800omi<c?oNC@dogTd=002ogTe=@03
ogTf=_mi=cOoNCLg00;oNCPh00?oNCTiogTj>_mi>SX00_mi>c/00omi?3co
NCdmogTm?@02ogTn?P04ogTo?omi@43oND10ogU1@@;oND920_mi@d<00omi
A4CoNDE5ogU5A@02ogU6AP03ogU7AomiB4SoNDQ800;oNDU900?oNDY:ogU;
BomiBd/00_miC4`00omiCDgoNDi>ogU>CP02ogU?C`03ogU@D?miDE7oNE5A
00;oNE9B00?oNE=CogUDE?miE5@00_miEED01?miEUKoNEMGogUGEomiF5P2
ogUIF@;oNEYJ00?oNE]KogULG?miG5`00_miGEd00omiGUkoNEmOogUOG`02
ogUPH003ogUQHOmiHV;oNF9R00;oNF=S00?oNFATogUUIOmiIFD00_miIVH0
0omiIfOoNFQXogUXJ002ogUYJ@04ogUZJ_miJf_oNF][ogU/K0;oNFe]0_mi
KVh00omiKfooNG1`ogU`L002ogUaL@03ogUbL_miLg?oNG=c00;oNGAd00?o
NGEeogUfM_miMWH00_miMgL00omiN7Sok^k^onk^kP0Konk^kQ3o0=So2oo^
k^h02?oKfm_o?3`loa`L7?mbLW;oS8b<ofe]KOl];Bgo/K6a0_o^k^h00oni
^KWohn?SooGem@02ooooo`05okbl_?mCDe?oDe=Coe=CDomEEED01Oooool0
0oogmoOohn?SokVi^@1Nonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0000
1OoJf][odm?ColS8b?ng]kOoWIfM02koi^KV0_mj0002ogX10@03ogX20_mj
0`?oNP<300;oNP@400?oNPD5ogX61_mj1PH00_mj1`L01?mj20SoNPT9ogX9
2Omj2PX2ogX;2`;oNP`<00?oNPd=ogX>3_mj3Ph00_mj3`l00omj413oNQ4A
ogXA4@02ogXB4P04ogXC4omj51CoNQ@DogXE5@;oNQHF0_mj5aL00omj61So
NQTIogXI6@02ogXJ6P03ogXK6omj71coNQ`L00;oNQdM00CoNQhNogXO7omj
7aooNR0P0_mj8B42ogXR8P03ogXS8omj92CoNR@T00;oNRDU00CoNRHVogXW
9omj9bOoNRPX0_mj:BT2ogXZ:P03ogX[:omj;2coNR`/00;oNRd]00?oNRh^
ogX_;omj;bl00_mj<3001?mj<C7oNS8bogXb<_mj<c<2ogXd=0;oNSDe00?o
NSHfogXg=omj=cL00_mj>3P00omj>CWoNSXjogXj>P02ogXk>`04ogXl??mj
?CgoNSdmogXn?P;oNSlo0_mj@4000omj@D7oNT92ogY2@P02ogY3@`03ogY4
A?mjADGoNTE500;oNTI600CoNTM7ogY8B?mjB4SoNTU90_mjBTX2ogY;B`03
ogY<C?mjCDgoNTe=00;oNTi>00CoNTm?ogY@D?mjD53oNU5A0_mjDU82ogYC
D`03ogYDE?mjEEGoNUEE00;oNUIF00?oNUMGogYHF?mjF5P00_mjFET01?mj
FU[oNU]KogYKFomjG5`2ogYMG@;oNUiN00?oNUmOogYPH?mjH6000_mjHF40
0omjHV;oNV=SogYSH`02ogYTI004ogYUIOmjIVKoNVIVogYWI`;oNVQX0_mj
JFT00omjJV[oNV][ogY[J`02ogY/K003ogY]KOmjKVkoNVi^00;oNVm_00Co
NW1`ogYaLOmjLG7oNW9b0_mjLg<2ogYdM003ogYeMOmjMWKoNWIf00;oNWMg
00?oNWQhogYiNOmjNGT07OoVi^H@o`3Po`coi^KV00OoiNGUoinOWombLW;o
GemOogemOOnMWIgofMWI00;oi^KV00?o^KVion?ShooemOD03?ooool00oog
moOohn?SokVi^@1NonKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQ
hN7of][Jolo?conm_KgoXj>S02kok^k^0_mk0002og/10@03og/20_mk0`?o
N`<300;oN`@400CoN`D5og/61_mk1PKoN`L70_mk20P2og/92@03og/:2_mk
2`_oN`/;00;oN``<00CoN`d=og/>3_mk3PkoN`l?0_mk4102og/A4@04og/B
4_mk4a?oNa<Cog/D50;oNaDE0_mk5QH00omk5aOoNaPHog/H6002og/I6@04
og/J6_mk6a_oNa/Kog/L70;oNadM0_mk7Qh01?mk7aooNb0Pog/P8?mk8B42
og/R8P;oNb<S00?oNb@Tog/U9Omk9BD00_mk9RH01?mk9bOoNbPXog/X:?mk
:BT2og/Z:P;oNb/[00?oNb`/og/];Omk;Bd00_mk;Rh01?mk;booNc0`og/`
<?mk<C42og/b<P;oNc<c00CoNc@dog/e=Omk=CGoNcHf0_mk=cL2og/h>003
og/i>Omk>S[oNcXj00;oNc/k00CoNc`log/m?Omk?CgoNchn0_mk?cl2og]0
@004og]1@Omk@T;oNd92og]3@`;oNdA40_mkADD00omkATKoNdM7og]7A`02
og]8B004og]9BOmkBT[oNdY:og];B`;oNda<0_mkCDd01?mkCTkoNdm?og]?
ComkD502og]AD@;oNe9B00?oNe=Cog]DE?mkE5@00_mkEED01?mkEUKoNeMG
og]GEomkF5P2og]IF@;oNeYJ00?oNe]Kog]LG?mkG5`00_mkGEd01?mkGUko
NemOog]OGomkH602og]QH@;oNf9R00CoNf=Sog]TI?mkI6CoNfEU0_mkIVH2
og]WI`03og]XJ?mkJFWoNfUY00;oNfYZ00CoNf][og]/K?mkK6coNfe]0_mk
KVh2og]_K`04og]`L?mkLG7oNg5aog]bLP;oNg=c0_mkM7@00omkMGGoNgIf
og]fMP02og]gM`05og]hN?mkNGWoNgUiog]jN_mkNg/07Oo^k^h@o`3XoaGo
k^k^00?o^KVion?ShooemOD01?ooool4oo[jnPCooooo00?omoOgon?Shoni
^KT0G_o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oN
g]kobl_;ojn_[`0^ooooo`;oO0000_ml0@400oml0P;oO0<3og`30`02og`4
1004og`51Oml1PKoO0H6og`71`;oO0P80_ml2@T01?ml2P[oO0/;og`;2oml
30`2og`=3@;oO0h>00CoO0l?og`@4?ml413oO14A0_ml4Q82og`C4`04og`D
5?ml5AGoO1DEog`F5P;oO1LG0_ml61P01?ml6AWoO1XJog`J6_ml6a/2og`L
70;oO1dM00CoO1hNog`O7oml7aooO20P0_ml8B42og`R8P04og`S8oml92Co
O2@Tog`U9@;oO2HV0_ml9bL01?ml:2SoO2TYog`Y:Oml:RX2og`[:`;oO2`/
00CoO2d]og`^;_ml;RkoO2l_0_ml<302og`a<@04og`b<_ml<c?oO3<cog`d
=0;oO3De0_ml=SH01?ml=cOoO3Phog`h>?ml>CT2og`j>P;oO3/k00CoO3`l
og`m?Oml?CgoO3hn0_ml?cl2oga0@004oga1@Oml@T;oO492oga3@`;oO4A4
0_mlADD01?mlATKoO4M7oga7AomlB4P2oga9B@;oO4Y:00CoO4];oga<C?ml
C4coO4e=0_mlCTh2oga?C`04oga@D?mlDE7oO55AogaBDP;oO5=C0_mlE5@0
1?mlEEGoO5IFogaFE_mlEeL2ogaHF0;oO5UI00CoO5YJogaKFomlFe_oO5aL
0_mlGEd2ogaNGP04ogaOGomlH63oO61PogaQH@;oO69R0_mlHf<01?mlI6Co
O6EUogaUIOmlIVH2ogaWI`;oO6QX00CoO6UYogaZJ_mlJV[oO6][0_mlK6`2
oga]K@04oga^K_mlKfooO6m_oga`L0;oO75a0_mlLW801?mlLg?oO7Adogad
M?mlMGD2ogafMP;oO7Mg00CoO7QhogaiNOmlNGWoO7Yj0_mlNg/00omlO7co
ooooooooo`0Koooooa3o0>oo5Oooool00oni^KWogMgMon[ZjP04on[ZjPCo
l?3`1OoZj^X00ooMgMgo^KViooooo`1Mooooo`04ojn_[oo;bl_og]kNon[Z
jP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S02kok^k^0_mn0002ogh1
0@04ogh20_mn0`?oOP<3ogh410;oOPD50_mn1PH01?mn1`OoOPP8ogh82?mn
2@T2ogh:2P;oOP/;00CoOP`<ogh=3Omn3@goOPh>0_mn3`l00omn413oOQ4A
oghA4@02oghB4P04oghC4omn51CoOQ@DoghE5@;oOQHF0_mn5aL01?mn61So
OQTIoghI6Omn6QX2oghK6`03oghL7?mn7AgoOQdM00;oOQhN00CoOQlOoghP
8?mn823oOR4Q0_mn8R82oghS8`04oghT9?mn9BGoORDUoghV9P;oORLW00?o
ORPXoghY:Omn:BT00_mn:RX01?mn:b_oOR`/ogh/;?mn;Bd2ogh^;P;oORl_
00CoOS0`ogha<Omn<C7oOS8b0_mn<c<00omn=3CoOSDeoghe=@02oghf=P04
oghg=omn>3SoOSPhoghi>@;oOSXj0_mn>c/01?mn?3coOSdmoghm?Omn?Sh2
ogho?`03ogi0@?mn@D7oOT5100;oOT9200CoOT=3ogi4A?mnA4CoOTE50_mn
ATH2ogi7A`04ogi8B?mnBDWoOTU9ogi:BP;oOT];0_mnC4`01?mnCDgoOTi>
ogi>C_mnCdl2ogi@D003ogiADOmnDU;oOU9B00;oOU=C00CoOUADogiEEOmn
EEGoOUIF0_mnEeL2ogiHF004ogiIFOmnFU[oOUYJogiKF`;oOUaL00?oOUeM
ogiNG_mnGUh00_mnGel01?mnH63oOV5QogiQHOmnHV82ogiSH`;oOVAT00Co
OVEUogiVI_mnIVKoOVMW0_mnJ6P00omnJFWoOVYZogiZJP02ogi[J`04ogi/
K?mnKFgoOVe]ogi^KP;oOVm_0_mnL7001?mnLG7oOW9bogibL_mnLg<2ogid
M003ogieMOmnMWKoOWIf00;oOWMg00CoOWQhogiiNOmnNGWoOWYj0_mnNg/2
ogilO003ogimOOo^k^kok^k^01_ok^k^4?l0molEonk^kP03oiZJV_ni^KWo
`/;200Co`/;21?o3`l<5ol;2`P03okVi^OnJVY[ok^k^05gok^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0;_oV
i^H2ogl000;oO`4100CoO`82ogl30omo0`?oO`@40_mo1@D00omo1PKoO`L7
ogl71`02ogl82004ogl92Omo2P[oO`X:ogl;2`;oO``<00?oO`d=ogl>3_mo
3Ph00_mo3`l01?mo413oOa4AoglA4Omo4Q82oglC4`03oglD5?mo5AGoOaDE
00;oOaHF00CoOaLGoglH6?mo61SoOaTI0_mo6QX00omo6a_oOa`LoglL7002
oglM7@04oglN7_mo7aooOalOoglP80;oOb4Q00?oOb8RoglS8omo8b<00_mo
92@01?mo9BGoObHVoglV9_mo9bL2oglX:003oglY:Omo:R[oObXZ00;oOb/[
00CoOb`/ogl];Omo;BgoObh^0_mo;bl00omo<33oOc4aogla<@02oglb<P04
oglc<omo=3CoOc@dogle=@;oOcHf00CoOcLgoglh>?mo>3SoOcTi0_mo>SX2
oglk>`04ogll??mo?CgoOcdmogln?P;oOclo00?oOd10ogm1@Omo@D400_mo
@T801?mo@d?oOdA4ogm4A?moADD2ogm6AP03ogm7AomoB4SoOdQ800;oOdU9
00CoOdY:ogm;BomoBd_oOda<0_moCDd00omoCTkoOdm?ogm?C`02ogm@D004
ogmADOmoDU;oOe9BogmCD`;oOeAD00?oOeEEogmFE_moEUH00_moEeL01?mo
F5SoOeUIogmIFOmoFUX2ogmKF`03ogmLG?moGEgoOeeM00;oOeiN00CoOemO
ogmPH?moH63oOf5Q0_moHV801?moHf?oOfATogmTI?moIFD2ogmVIP;oOfMW
00CoOfQXogmYJOmoJFWoOfYZ0_moJf/00omoK6coOfe]ogm]K@02ogm^KP04
ogm_KomoL73oOg1`ogmaL@;oOg9b00?oOg=cogmdM?moM7@00_moMGD01?mo
MWKoOgMgogmgMomoN7P2ogmiN@03ogmjN_moNg_oOg]k00;oOgal00?oOgem
ogmnO_moOWh07OoVi^H@o`3ooaGoi^KV00?oJFUYogMgMomkNg/01?mkNg/4
ogalO0GoNg]k00?oMgMgofUYJOoVi^H0GOoVi^H01?nMWIgo]kNgolS8b?oC
dm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kP;oP0000_n0
0@401?n00P;oP0<3oh030on010@2oh051@04oh061_n01`OoP0L7oh0820;o
P0T90_n02PX01?n02`_oP0`<oh0<3?n03@d2oh0>3P04oh0?3on0413oP10@
oh0A4@;oP18B0_n04a<01?n051CoP1DEoh0E5On05QH2oh0G5`04oh0H6?n0
6AWoP1TIoh0J6P;oP1/K0_n071`01?n07AgoP1hNoh0N7_n07al2oh0P8004
oh0Q8On08R;oP28Roh0S8`;oP2@T0_n09BD01?n09RKoP2LWoh0W9on0:2P2
oh0Y:@04oh0Z:_n0:b_oP2/[oh0/;0;oP2d]00?oP2h^oh0_;on0;bl00_n0
<3001?n0<C7oP38boh0b<_n0<c<2oh0d=004oh0e=On0=SKoP3Hfoh0g=`;o
P3Ph0_n0>CT01?n0>S[oP3/koh0k>on0?3`2oh0m?@04oh0n?_n0?cooP3lo
oh10@0;oP4510_n0@T801?n0@d?oP4A4oh14A?n0ADD2oh16AP04oh17Aon0
B4SoP4Q8oh19B@;oP4Y:0_n0Bd/01?n0C4coP4e=oh1=COn0CTh2oh1?C`04
oh1@D?n0DE7oP55Aoh1BDP;oP5=C0_n0E5@01?n0EEGoP5IFoh1FE_n0EeL2
oh1HF004oh1IFOn0FU[oP5YJoh1KF`;oP5aL00?oP5eMoh1NG_n0GUh00_n0
Gel01?n0H63oP65Qoh1QHOn0HV82oh1SH`04oh1TI?n0IFGoP6EUoh1VIP;o
P6MW0_n0J6P01?n0JFWoP6YZoh1ZJ_n0Jf/2oh1/K004oh1]KOn0KVkoP6i^
oh1_K`;oP71`0_n0LG401?n0LW;oP7=coh1cLon0M7@2oh1eM@04oh1fM_n0
MgOoP7Mgoh1hN0;oP7Ui0_n0NWX01?n0Ng_oP7aloh1lO?n0OGd2oh1nOP03
oh1oOon0P83ok^k^01cok^k^4?l0ooN5onk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_02kooooo0_n20002oh81
0@04oh820_n20`?oPP<3oh8410;oPPD500CoPPH6oh871on21`OoPPP80_n2
2@T01?n22P[oPP/;oh8;2on230`2oh8=3@;oPPh>00CoPPl?oh8@4?n2413o
PQ4A0_n24Q801?n24a?oPQ@Doh8D5?n25AD2oh8F5P04oh8G5on261SoPQPH
oh8I6@;oPQXJ0_n26a/01?n271coPQdMoh8M7On27Qh2oh8O7`04oh8P8?n2
8B7oPR4Qoh8R8P;oPR<S00CoPR@Toh8U9On29BGoPRHV0_n29bL2oh8X:004
oh8Y:On2:R[oPRXZoh8[:`;oPR`/00CoPRd]oh8^;_n2;RkoPRl_0_n2<300
1?n2<C7oPS8boh8b<_n2<c<2oh8d=0;oPSDe00CoPSHfoh8g=on2=cOoPSPh
0_n2>CT01?n2>S[oPS/koh8k>on2?3`2oh8m?@04oh8n?_n2?cooPSlooh90
@0;oPT510_n2@T801?n2@d?oPTA4oh94A?n2ADD2oh96AP04oh97Aon2B4So
PTQ8oh99B@;oPTY:00CoPT];oh9<C?n2C4coPTe=0_n2CTh2oh9?C`04oh9@
D?n2DE7oPU5Aoh9BDP;oPU=C00CoPUADoh9EEOn2EEGoPUIF0_n2EeL01?n2
F5SoPUUIoh9IFOn2FUX2oh9KF`;oPUaL00CoPUeMoh9NG_n2GUkoPUmO0_n2
H6001?n2HF7oPV9Roh9RH_n2Hf<2oh9TI004oh9UIOn2IVKoPVIVoh9WI`;o
PVQX0_n2JFT01?n2JV[oPV][oh9[Jon2K6`2oh9]K@04oh9^K_n2KfooPVm_
oh9`L0;oPW5a00CoPW9boh9cLon2Lg?oPWAd0_n2MGD2oh9fMP04oh9gMon2
N7SoPWQhoh9iN@;oPWYj00CoPW]koh9lO?n2O7coPWem0_n2OWh01?n2Ogoo
PX20oh:0P?n2PH4Moooooa3o0?o_QOooool01?n_[joobl_;omkNg_oZj^X1
oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kP;oP`000_n30@40
1?n30P;oP`<3oh<30on310@2oh<51@04oh<61_n31`OoP`L7oh<820;oP`T9
00CoP`X:oh<;2on32`_oP``<0_n33@d01?n33PkoP`l?oh<?3on34102oh<A
4@04oh<B4_n34a?oPa<Coh<D50;oPaDE0_n35QH01?n35aOoPaPHoh<H6?n3
6AT2oh<J6P04oh<K6on371coPa`Loh<M7@;oPahN00CoPalOoh<P8?n3823o
Pb4Q0_n38R801?n38b?oPb@Toh<T9?n39BD2oh<V9P04oh<W9on3:2SoPbPX
oh<Y:@;oPbXZ0_n3:b/01?n3;2coPbd]oh<];On3;Rh2oh<_;`04oh<`<?n3
<C7oPc4aoh<b<P;oPc<c00CoPc@doh<e=On3=CGoPcHf0_n3=cL01?n3>3So
PcTioh<i>On3>SX2oh<k>`04oh<l??n3?CgoPcdmoh<n?P;oPclo00?oPd10
oh=1@On3@D400_n3@T801?n3@d?oPdA4oh=4A?n3ADD2oh=6AP04oh=7Aon3
B4SoPdQ8oh=9B@;oPdY:00CoPd];oh=<C?n3C4coPde=0_n3CTh01?n3Cdoo
Pe1@oh=@D?n3DE42oh=BDP04oh=CDon3E5CoPeADoh=EE@;oPeIF0_n3EeL0
1?n3F5SoPeUIoh=IFOn3FUX2oh=KF`04oh=LG?n3GEgoPeeMoh=NGP;oPemO
00CoPf1Poh=QHOn3HF7oPf9R0_n3Hf<01?n3I6CoPfEUoh=UIOn3IVH2oh=W
I`04oh=XJ?n3JFWoPfUYoh=ZJP;oPf][0_n3K6`01?n3KFgoPfi^oh=^K_n3
Kfl2oh=`L004oh=aLOn3LW;oPg9boh=cL`;oPgAd00CoPgEeoh=fM_n3MWKo
PgMg0_n3N7P01?n3NGWoPgYjoh=jN_n3Ng/2oh=lO004oh=mOOn3OWkoPgin
oh=oO`;oPh2000?oPh61oh>2P_n3PX807Oo^k^h@o`3oj1Gok^k^00?o];Bd
olo?coo?cll03Oo?cll00oo5aLGo];Bdonk^kP1Monk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM02koi^KV0_n4
0002oh@10@04oh@20_n40`?oQ0<3oh@410;oQ0D500CoQ0H6oh@71on41`Oo
Q0P80_n42@T01?n42P[oQ0/;oh@;2on430`2oh@=3@04oh@>3_n43`ooQ0l?
oh@@40;oQ14A00CoQ18Boh@C4on44a?oQ1@D0_n45AD01?n45QKoQ1LGoh@G
5on461P2oh@I6@04oh@J6_n46a_oQ1/Koh@L70;oQ1dM00CoQ1hNoh@O7on4
7aooQ20P0_n48B401?n48R;oQ2<Soh@S8on492@2oh@U9@04oh@V9_n49bOo
Q2LWoh@X:0;oQ2TY00CoQ2XZoh@[:on4:b_oQ2`/0_n4;Bd01?n4;RkoQ2l_
oh@_;on4<302oh@a<@04oh@b<_n4<c?oQ3<coh@d=0;oQ3De00CoQ3Hfoh@g
=on4=cOoQ3Ph0_n4>CT00on4>S[oQ3/koh@k>`02oh@l?004oh@m?On4?Sko
Q3hnoh@o?`;oQ41000CoQ451ohA2@_n4@T;oQ4=30_n4A4@01?n4ADGoQ4I6
ohA6A_n4AdL2ohA8B004ohA9BOn4BT[oQ4Y:ohA;B`;oQ4a<00CoQ4e=ohA>
C_n4CTkoQ4m?0_n4D5001?n4DE7oQ59BohABD_n4De<2ohADE004ohAEEOn4
EUKoQ5IFohAGE`;oQ5QH00CoQ5UIohAJF_n4FU[oQ5]K0_n4G5`01?n4GEgo
Q5iNohANG_n4Gel2ohAPH004ohAQHOn4HV;oQ69RohASH`;oQ6AT00CoQ6EU
ohAVI_n4IVKoQ6MW0_n4J6P01?n4JFWoQ6YZohAZJ_n4Jf/2ohA/K004ohA]
KOn4KVkoQ6i^ohA_K`;oQ71`00CoQ75aohAbL_n4LW;oQ7=c0_n4M7@01?n4
MGGoQ7IfohAfM_n4MgL2ohAhN0;oQ7Ui00CoQ7YjohAkNon4Ng_oQ7al0_n4
OGd01?n4OWkoQ7moohAoOon4P802ohB1P@03ohB2P_n4Ph?oQ8>301goi^KV
4?l0on0EonKViP03okVi^OoMgMgok>c/00Cok>c/1?o^k^h5onc/k003omgM
gOni^KWoi^KV05goi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7Q
hOoJf][oclo?okfm_OnSXj<0;_o^k^h2ohD00004ohD10On50P;oQ@82ohD3
0`;oQ@@400CoQ@D5ohD61_n51PKoQ@L70_n520P01?n52@WoQ@X:ohD:2_n5
2`/2ohD<3004ohD=3On53PkoQ@h>ohD?3`;oQA0@00CoQA4AohDB4_n54Q;o
QA<C0_n551@01?n55AGoQAHFohDF5_n55aL2ohDH6004ohDI6On56Q[oQAXJ
ohDK6`;oQA`L00CoQAdMohDN7_n57QkoQAlO0_n582001?n58B7oQB8RohDR
8_n58b<2ohDT9004ohDU9On59RKoQBHVohDW9`;oQBPX00CoQBTYohDZ:_n5
:R[oQB/[0_n5;2`01?n5;BgoQBh^ohD^;_n5;bl2ohD`<004ohDa<On5<S;o
QC8bohDc<`;oQC@d00CoQCDeohDf=_n5=SKoQCLg0_n5>3P01?n5>CWoQCXj
ohDj>_n5>c/2ohDl?004ohDm?On5?SkoQChnohDo?`;oQD1000CoQD51ohE2
@_n5@T;oQD=30_n5A4@01?n5ADGoQDI6ohE6A_n5AdL2ohE8B004ohE9BOn5
BT[oQDY:ohE;B`;oQDa<00CoQDe=ohE>C_n5CTkoQDm?0_n5D5001On5DE7o
QE9BohECDon5De?oQEAD00;oQEEE00CoQEIFohEGEon5EeOoQEQH0_n5FET0
1?n5FU[oQE]KohEKFon5G5`2ohEMG@04ohENG_n5GeooQEmOohEPH0;oQF5Q
00CoQF9RohESHon5Hf?oQFAT0_n5IFD01?n5IVKoQFMWohEWIon5J6P2ohEY
J@04ohEZJ_n5Jf_oQF][ohE/K0;oQFe]00CoQFi^ohE_Kon5KfooQG1`0_n5
LG401?n5LW;oQG=cohEcLon5M7@2ohEeM@04ohEfM_n5MgOoQGMgohEhN0;o
QGUi00CoQGYjohEkNon5Ng_oQGal0_n5OGd01?n5OWkoQGmoohEoOon5P802
ohF1P@05ohF2P_n5Ph?oQH>3ohF4Q?n5QHD07Oo^k^h@o`3of1Gok^k^00?o
^KVion?ShooemOD01?ogmoL4oo[jnPGomoOg00?ohn?SokVi^Oo^k^h0GOo^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;
ojn_[`0^ooooo`;oQ`0000CoQ`41ohL20_n70P;oQ`<30_n710@01?n71@Go
Q`H6ohL61_n71`L2ohL82004ohL92On72P[oQ`X:ohL;2`;oQ``<00CoQ`d=
ohL>3_n73PkoQ`l?0_n741001?n74A7oQa8BohLB4_n74a<2ohLD5005ohLE
5On75QKoQaHFohLG5on761P00_n76AT01?n76Q[oQa/KohLK6on771`2ohLM
7@04ohLN7_n77aooQalOohLP80;oQb4Q00CoQb8RohLS8on78b?oQb@T0_n7
9BD01?n79RKoQbLWohLW9on7:2P2ohLY:@04ohLZ:_n7:b_oQb/[ohL/;0;o
Qbd]00GoQbh^ohL_;on7;booQc0`ohLa<@02ohLb<P04ohLc<on7=3CoQc@d
ohLe=@;oQcHf00CoQcLgohLh>?n7>3SoQcTi0_n7>SX01?n7>c_oQc`lohLl
??n7?Cd2ohLn?P04ohLo?on7@43oQd10ohM1@@;oQd9200CoQd=3ohM4A?n7
A4CoQdE50_n7ATH01On7AdOoQdQ8ohM8B?n7BDWoQdY:00;oQd];00CoQda<
ohM=COn7CDgoQdi>0_n7Cdl01?n7D53oQe5AohMADOn7DU82ohMCD`04ohMD
E?n7EEGoQeEEohMFEP;oQeMG00CoQeQHohMIFOn7FEWoQeYJ0_n7Fe/01?n7
G5coQeeMohMMGOn7GUh2ohMOG`05ohMPH?n7HF7oQf5QohMRH_n7Hf<00_n7
I6@01?n7IFGoQfIVohMVI_n7IfL2ohMXJ004ohMYJOn7JV[oQfYZohM[J`;o
Qfa/00CoQfe]ohM^K_n7KVkoQfm_0_n7L7001?n7LG7oQg9bohMbL_n7Lg<2
ohMdM004ohMeMOn7MWKoQgIfohMgM`;oQgQh00GoQgUiohMjN_n7NW[oQg]k
ohMlO002ohMmO@04ohMnO_n7OgooQgmoohN0P0;oQh6100CoQh:2ohN3Pon7
Ph?oQhB40_n7QHD00on7QXKoooooooooo`0Koooooa3o0?oA5Oooool00oni
^KWohn?SooGem@0<ooooo`03ooOgmooShn?o^KVi05kooooo00Co[jn_ol_;
booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h2
ohP00004ohP10On80P;oR082ohP30`;oR0@400CoR0D5ohP61_n81PKoR0L7
0_n820P01?n82@WoR0X:ohP:2_n82`/2ohP<3005ohP=3On83PkoR0l?ohP?
3on841000_n84A401?n84Q;oR1<CohPC4on851@2ohPE5@04ohPF5_n85aOo
R1LGohPH60;oR1TI00GoR1XJohPK6on86a_oR1`LohPM7@02ohPN7P04ohPO
7on8823oR20PohPQ8@;oR28R00CoR2<SohPT9?n892CoR2DU0_n89RH01?n8
9bOoR2PXohPX:?n8:BT2ohPZ:P05ohP[:on8;2coR2d]ohP];On8;Rh00_n8
;bl01?n8<33oR34aohPa<On8<S82ohPc<`04ohPd=?n8=CGoR3DeohPf=P;o
R3Lg00GoR3PhohPi>On8>CWoR3XjohPk>`02ohPl?004ohPm?On8?SkoR3hn
ohPo?`;oR41000CoR451ohQ2@_n8@T;oR4=30_n8A4@01?n8ADGoR4I6ohQ6
A_n8AdL2ohQ8B005ohQ9BOn8BT[oR4];ohQ;Bon8C4`00_n8CDd01?n8CTko
R4m?ohQ?Con8D502ohQAD@04ohQBD_n8De?oR5=CohQDE0;oR5EE00GoR5IF
ohQGEon8EeOoR5QHohQIF@02ohQJFP04ohQKFon8G5coR5aLohQMG@;oR5iN
00CoR5mOohQPH?n8H63oR65Q0_n8HV801On8Hf?oR6ATohQTI?n8IFGoR6IV
00;oR6MW00CoR6QXohQYJOn8JFWoR6YZ0_n8Jf/01?n8K6coR6e]ohQ]KOn8
KVh2ohQ_K`04ohQ`L?n8LG7oR75aohQbLP;oR7=c00GoR7AdohQeMOn8MWKo
R7IfohQgM`02ohQhN004ohQiNOn8NW[oR7YjohQkN`;oR7al00CoR7emohQn
O_n8OWkoR7mo0_n8P8001On8PH7oR8:2ohR2P_n8Ph?oR8B400;oR8F500?o
R8J6ohR7Qon8QhL07Oo^k^h@o`3obAGok^k^00?o^KVion?ShooemOD00_oo
ool00oono_kohn?Son3Ph007ooooo`03ooOgmooShn?o^KVi05kok^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0
;_oVi^H2ohT00004ohT10On90P;oR@82ohT30`;oR@@400CoR@D5ohT61_n9
1PKoR@L70_n920P01On92@WoR@X:ohT;2on92`_oR@`<00;oR@d=00CoR@h>
ohT?3on93`ooRA0@0_n94A401On94Q;oRA<CohTC4on951CoRADE00;oRAHF
00CoRALGohTH6?n961SoRATI0_n96QX01?n96a_oRA`LohTL7?n97Ad2ohTN
7P05ohTO7on9823oRB4QohTQ8On98R800_n98b<01?n992CoRBDUohTU9On9
9RH2ohTW9`05ohTX:?n9:BWoRBTYohTZ:_n9:b/00_n9;2`01?n9;BgoRBh^
ohT^;_n9;bl2ohT`<005ohTa<On9<S;oRC8bohTc<on9=3@00_n9=CD01?n9
=SKoRCLgohTg=on9>3P2ohTi>@04ohTj>_n9>c_oRC/kohTl?0;oRCdm00Go
RChnohTo?on9@43oRD10ohU1@@02ohU2@P04ohU3@on9A4CoRDA4ohU5A@;o
RDI600GoRDM7ohU8B?n9B4SoRDU9ohU:BP02ohU;B`04ohU<C?n9CDgoRDe=
ohU>CP;oRDm?00CoRE1@ohUADOn9DE7oRE9B0_n9De<01On9E5CoREEEohUF
E_n9EUKoREMG00;oREQH00CoREUIohUJF_n9FU[oRE]K0_n9G5`01On9GEgo
REiNohUOGon9GeooRF1P00;oRF5Q00CoRF9RohUSHon9Hf?oRFAT0_n9IFD0
1On9IVKoRFMWohUWIon9J6SoRFUY00;oRFYZ00CoRF][ohU/K?n9K6coRFe]
0_n9KVh01?n9KfooRG1`ohU`L?n9LG42ohUbLP05ohUcLon9M7CoRGEeohUe
MOn9MWH00_n9MgL01?n9N7SoRGUiohUiNOn9NWX2ohUkN`05ohUlO?n9OGgo
RGemohUnO_n9Ogl00_n9P8001?n9PH7oRH:2ohV2P_n9Ph<2ohV4Q006ohV5
QOn9QXKoRHJ6ohV7Qon9R8SoRHV97OoVi^H@o`3o`@_oi^KV00So<30`of][
JooVi^Koi^KVomgMgOlR8R;o?cloonGUi@;oi^KV00?o^KVion?ShooemOD0
0_ooool01Olm?Cgo;Rh^ocTi>Ol^;RkoWinO00Gooooo00?omoOgon?Shoni
^KT0G_oVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?
cloo_Kfmoj>SX`0^onk^kP;oRP0000CoRP41ohX20_n:0P;oRP<30_n:10@0
1On:1@GoRPH6ohX61_n:1`OoRPP800;oRPT900CoRPX:ohX;2on:2`_oRP`<
0_n:3@d01On:3PkoRPl?ohX?3on:413oRQ4A00;oRQ8B00CoRQ<CohXD5?n:
51CoRQDE0_n:5QH01On:5aOoRQPHohXI6On:6AWoRQXJ00;oRQ/K00CoRQ`L
ohXM7On:7AgoRQhN0_n:7al01On:823oRR4QohXR8_n:8R;oRR<S00;oRR@T
00CoRRDUohXV9_n:9RKoRRLW0_n::2P01On::BWoRRXZohX[:on::b_oRR`/
00;oRRd]00GoRRh^ohX_;on:;booRS0`ohXa<@02ohXb<P04ohXc<on:=3Co
RS@dohXe=@;oRSHf00GoRSLgohXh>?n:>3SoRSTiohXj>P02ohXk>`04ohXl
??n:?CgoRSdmohXn?P;oRSlo00GoRT10ohY1@On:@T;oRT92ohY3@`02ohY4
A004ohY5AOn:ATKoRTI6ohY7A`;oRTQ800GoRTU9ohY:B_n:Bd_oRT];ohY<
C002ohY=C@04ohY>C_n:CdooRTm?ohY@D0;oRU5A00GoRU9BohYCDon:E5Co
RUADohYEE@02ohYFEP05ohYGEon:F5SoRUQHohYIFOn:FUX00_n:Fe/01?n:
G5coRUeMohYMGOn:GUh2ohYOG`05ohYPH?n:HF7oRV5QohYRH_n:Hf<00_n:
I6@01?n:IFGoRVIVohYVI_n:IfL2ohYXJ005ohYYJOn:JV[oRV][ohY[Jon:
K6`00_n:KFd01?n:KVkoRVm_ohY_Kon:L702ohYaL@05ohYbL_n:Lg?oRWAd
ohYdM?n:MGD00_n:MWH01?n:MgOoRWQhohYhN?n:NGT2ohYjNP05ohYkNon:
O7coRWemohYmOOn:OWh00_n:Ogl01On:P83oRX61ohZ1POn:PX;oRX>300;o
RXB400CoRXF5ohZ6Q_n:QXKoRXN70_n:R8P00on:RHWoRXZ:onk^kP0Lonk^
kQ3o0?nj2oo^k^h01olb<S;oKfm_onk^k_o^k^koJ6QXoa8B4_oGemL00oo^
k^h00oni^KWohn?SooGem@02ooooo`06ooGemOooooooooooojJVY_l410Co
i^KV1?ooool00oogmoOohn?SokVi^@1Nonk^kP04oj>SXonm_Kgoclo?om[J
fP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_02kooooo0_n<00001?n<
0@7oS082oh`20_n<0`<2oh`41005oh`51On<1PKoS0L7oh`71on<20P00_n<
2@T01On<2P[oS0/;oh`;2on<30coS0d=00;oS0h>00CoS0l?oh`@4?n<413o
S14A0_n<4Q801On<4a?oS1@Doh`E5On<5AGoS1HF00;oS1LG00GoS1PHoh`I
6On<6AWoS1XJoh`K6`02oh`L7004oh`M7On<7QkoS1hNoh`O7`;oS20P00Go
S24Qoh`R8_n<8b?oS2<Soh`T9002oh`U9@05oh`V9_n<9bOoS2LWoh`X:?n<
:BT00_n<:RX01?n<:b_oS2`/oh`/;?n<;Bd2oh`^;P05oh`_;on<<33oS34a
oh`a<On<<S800_n<<c<01On<=3CoS3Deoh`e=On<=SKoS3Lg00;oS3Ph00Go
S3Tioh`j>_n<>S[oS3/koh`l?002oh`m?@04oh`n?_n<?cooS3looha0@0;o
S45100GoS492oha3@on<A4CoS4A4oha5A@02oha6AP05oha7Aon<B4SoS4Q8
oha9BOn<BTX00_n<Bd/01?n<C4coS4e=oha=COn<CTh2oha?C`05oha@D?n<
DE7oS59BohaBD_n<De<00_n<E5@01On<EEGoS5IFohaFE_n<EeOoS5QH00;o
S5UI00CoS5YJohaKFon<Fe_oS5aL0_n<GEd01On<GUkoS5mOohaPH?n<H63o
S65Q00;oS69R00GoS6=SohaTI?n<I6CoS6EUohaVIP02ohaWI`04ohaXJ?n<
JFWoS6UYohaZJP;oS6][00GoS6a/oha]KOn<KVkoS6i^oha_K`02oha`L005
ohaaLOn<LW;oS7=cohacLon<M7@00_n<MGD01On<MWKoS7MgohagMon<N7So
S7Ui00;oS7Yj00CoS7]kohalO?n<O7coS7em0_n<OWh01On<OgooS820ohb1
POn<PH7oS8:200;oS8>300GoS8B4ohb5QOn<QHGoS8J6ohb7Q`02ohb8R004
ohb9ROn<RX[oS8Z:ohb;Ragooooo4?l0ok8;ooooo`06ocHf=_mgMgOooooo
ol;2`_l20P;o/K6a1?ooool00oni^KWohn?Soo[jnP05ooooo`03on[Zj_l0
003ocLg=00Cooooo00?on_[jon?Shoni^KT0G_ooool01?n_[joobl_;omkN
g_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kP;oS@00
00CoS@41ohd20_n=0P;oS@<30_n=10@01On=1@GoS@H6ohd71on=1`OoS@P8
00;oS@T900GoS@X:ohd;2on=30coS@`<ohd=3@02ohd>3P05ohd?3on=413o
SA0@ohdA4On=4Q800_n=4a<01On=51CoSADEohdE5On=5QKoSALG00;oSAPH
00GoSATIohdJ6_n=6Q[oSA/KohdL7002ohdM7@04ohdN7_n=7aooSAlOohdP
80;oSB4Q00GoSB8RohdS8on=92CoSB@TohdU9@02ohdV9P05ohdW9on=:2So
SBTYohdY:On=:RX00_n=:b/01On=;2coSBd]ohd];On=;RkoSBl_00;oSC0`
00GoSC4aohdb<_n=<S;oSC<cohdd=002ohde=@05ohdf=_n==cOoSCLgohdh
>?n=>CT00_n=>SX01?n=>c_oSC`lohdl??n=?Cd2ohdn?P05ohdo?on=@43o
SD51ohe1@On=@T800_n=@d<01On=A4CoSDE5ohe6A_n=ATKoSDM700;oSDQ8
00GoSDU9ohe:B_n=Bd_oSD];ohe<C002ohe=C@05ohe>C_n=CdooSDm?ohe@
D?n=DE400_n=DU801On=De?oSEADoheDE?n=EEGoSEIF00;oSEMG00CoSEQH
oheIFOn=FEWoSEYJ0_n=Fe/01On=G5coSEeMoheNG_n=GUkoSEmO00;oSF1P
00GoSF5QoheRH_n=Hf?oSF=SoheTI002oheUI@05oheVI_n=IfOoSFQXoheX
J?n=JFT00_n=JVX01On=Jf_oSFa/ohe/K?n=KFgoSFi^00;oSFm_00GoSG1`
oheaLOn=LG7oSG9bohecL`02ohedM005oheeMOn=MWKoSGIfohegMon=N7P0
0_n=NGT01?n=NW[oSG]kohekNon=O7`2ohemO@05ohenO_n=OgooSH20ohf0
P?n=PH400_n=PX801On=Ph?oSHB4ohf5QOn=QHGoSHJ600;oSHN700GoSHR8
ohf9ROn=RHWoSHZ:ohf;R`02ohf<S1gok^k^4?l0ojX;onk^kP05oc8b<_m/
K6cogmoOob0P8?mQHF401Oo^k^h00oni^KWohn?Soo[jnP04ooooo`04ooCd
m?mdM7Co8B4QooknoPCooooo00?on_[jon?Shoni^KT0G_o^k^h01?nSXj?o
_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@0^onKV
iP;oSP0000CoSP41ohh20_n>0P;oSP<30_n>10@01On>1@GoSPH6ohh71on>
1`OoSPP800;oSPT900GoSPX:ohh;2on>30coSP`<ohh=3@02ohh>3P05ohh?
3on>413oSQ4AohhA4On>4Q800_n>4a<01On>51CoSQDEohhF5_n>5QKoSQLG
00;oSQPH00GoSQTIohhJ6_n>6a_oSQ/KohhL7002ohhM7@05ohhN7_n>7aoo
SR0PohhP8?n>8B400_n>8R801On>8b?oSR@TohhU9On>9BGoSRHV00;oSRLW
00GoSRPXohhY:On>:R[oSRXZohh[:`02ohh/;005ohh];On>;RkoSRl_ohh_
;on><3000_n><C401On><S;oSS<cohhd=?n>=3CoSSDe00;oSSHf00GoSSLg
ohhh>?n>>CWoSSTiohhj>P02ohhk>`05ohhl??n>?CgoSShnohhn?_n>?cl0
0_n>@4001On>@D7oST92ohi3@on>@d?oSTA400;oSTE500GoSTI6ohi7Aon>
B4SoSTQ8ohi9B@02ohi:BP05ohi;Bon>C4coSTe=ohi=COn>CTh00_n>Cdl0
1On>D53oSU5AohiBD_n>DU;oSU=C00;oSUAD00GoSUEEohiFE_n>EeOoSUMG
ohiHF002ohiIF@05ohiJF_n>Fe_oSUaLohiLG?n>GEd00_n>GUh01On>Geoo
SV1PohiQHOn>HF7oSV9R00;oSV=S00GoSVATohiUIOn>IVKoSVIVohiWI`02
ohiXJ005ohiYJOn>JV[oSV][ohi[Jon>K6`00_n>KFd01On>KVkoSVm_ohi`
L?n>L73oSW5a00;oSW9b00GoSW=cohidM?n>MGGoSWEeohifMP02ohigM`05
ohihN?n>NGWoSWYjohijN_n>Ng/00_n>O7`01On>OGgoSWinohioOon>Ogoo
SX2000;oSX6100GoSX:2ohj3Pon>Q8CoSXB4ohj5Q@02ohj6QP05ohj7Qon>
R8SoSXV9ohj9ROn>RXX00_n>Rh/00on>S8coSXf=ohj>SP0MonKViQ3o0?nS
2ooVi^H01Ol`<33o0P82o`000?l0003o[Zj^00Goi^KV00?o^KVion?Shooj
n_X00oooool01?lc<c?o10@4oeYJF_o]kNd5ooooo`03oo[jn_oShn?o^KVi
05koi^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?
okfm_OnSXj<0;_o^k^h2oi000005oi010On@0P;oT082oi030on@10@00_n@
1@D01On@1PKoT0L7oi071on@20SoT0T900;oT0X:00GoT0/;oi0<3?n@30co
T0d=oi0>3P02oi0?3`05oi0@4?n@4A7oT18Boi0B4_n@4a<00_n@51@01On@
5AGoT1HFoi0G5on@5aOoT1PH00;oT1TI00GoT1XJoi0K6on@71coT1`Loi0M
7@02oi0N7P06oi0O7on@823oT24Qoi0Q8On@8R;oT2<S0_n@92@01On@9BGo
T2HVoi0V9_n@9bOoT2PX00;oT2TY00GoT2XZoi0[:on@:b_oT2`/oi0];@02
oi0^;P05oi0_;on@<33oT30`oi0a<On@<S800_n@<c<01On@=3CoT3Deoi0f
=_n@=SKoT3Lg00;oT3Ph00GoT3Tioi0j>_n@>c_oT3/koi0l?002oi0m?@05
oi0n?_n@?cooT410oi10@?n@@D400_n@@T801_n@@d?oT4A4oi15AOn@ADGo
T4I6oi17A`;oT4Q800GoT4U9oi1:B_n@BT[oT4];oi1<C002oi1=C@05oi1>
C_n@CdooT4m?oi1@D?n@DE400_n@DU801On@De?oT5ADoi1EEOn@EEGoT5IF
00;oT5MG00GoT5QHoi1IFOn@FU[oT5YJoi1KF`02oi1LG005oi1MGOn@GUko
T5mOoi1OGon@H6000_n@HF401_n@HV;oT6=Soi1TI?n@I6CoT6EUoi1VIP;o
T6MW00GoT6QXoi1YJOn@JFWoT6YZoi1[J`02oi1/K005oi1]KOn@KVkoT6i^
oi1_Kon@L7000_n@LG401On@LW;oT7=coi1cLon@M7CoT7Ee00;oT7If00Go
T7Mgoi1hN?n@NGWoT7Uioi1jNP02oi1kN`05oi1lO?n@OGgoT7inoi1nO_n@
Ogl00_n@P8001On@PH7oT8:2oi23Pon@Ph?oT8B400;oT8F500KoT8J6oi27
Qon@R8SoT8R8oi29ROn@RXX2oi2;R`05oi2<S?n@SHgoT8f=oi2>S_n@Shl0
7Oo^k^h@o`3oV`_ok^k^00Ko<S8bofm_KooCdm?oShn?o`L71on/[:`4onk^
kP03okVi^OoShn?on_[j00?ooooo00Com_Kfokno_om1@D7oYJFU1Oooool0
0oojn_[ohn?SokVi^@1Nonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0000
1Oobl_;oj^[ZomkNg_o;bl_o[jn_02kooooo0_nA00001OnA0@7oT@82oi42
0_nA0`?oT@@400;oT@D500GoT@H6oi471onA1`OoT@P8oi492@02oi4:2P05
oi4;2onA30coT@d=oi4=3OnA3Ph00_nA3`l01_nA413oTA4Aoi4B4_nA4Q;o
TA<Coi4D50;oTADE00GoTAHFoi4G5onA5aOoTAPHoi4I6@02oi4J6P05oi4K
6onA71coTAdMoi4M7OnA7Qh00_nA7al01_nA823oTB4Qoi4R8_nA8R;oTB<S
oi4T90;oTBDU00GoTBHVoi4W9onA9bOoTBPXoi4Y:@02oi4Z:P05oi4[:onA
;2coTBd]oi4];OnA;Rh00_nA;bl01_nA<33oTC4aoi4b<_nA<S;oTC<coi4d
=0;oTCDe00GoTCHfoi4g=onA=cOoTCPhoi4i>@02oi4j>P05oi4k>onA?3co
TCdmoi4m?OnA?Sh00_nA?cl01_nA@43oTD51oi52@_nA@T;oTD=3oi54A0;o
TDE500GoTDI6oi57AonAAdOoTDQ8oi59B@02oi5:BP05oi5;BonAC4coTDe=
oi5=COnACTh00_nACdl01_nAD53oTE5Aoi5BD_nADU;oTE=Coi5DE0;oTEEE
00GoTEIFoi5GEonAEeOoTEQHoi5IF@02oi5JFP05oi5KFonAG5coTEeMoi5M
GOnAGUh00_nAGel01_nAH63oTF5Qoi5RH_nAHV;oTF=Soi5TI0;oTFEU00Go
TFIVoi5WIonAIfOoTFQXoi5YJ@02oi5ZJP05oi5[JonAK6coTFe]oi5]KOnA
KVh00_nAKfl01_nAL73oTG5aoi5bL_nALW;oTG=coi5dM0;oTGEe00GoTGIf
oi5gMonAMgOoTGQhoi5iN@02oi5jNP05oi5kNonAO7coTGemoi5mOOnAOWh0
0_nAOgl01OnAP83oTH61oi62P_nAPX;oTH>300;oTHB400KoTHF5oi66Q_nA
QhOoTHN7oi68R?nARHT2oi6:RP05oi6;RonAS8coTHb<oi6=SOnASXh00_nA
Shl00onAT93oooooooooo`0Koooooa3o0?nC2oooool01_lf=SKoMgMgoooo
ooooooooBDU9oe=CD`Cooooo00?o^KVion?Shoojn_X01Oooool00onb/[;o
9RHVooooo`04ooooo`03oo[jn_oShn?o^KVi05kooooo00Co[jn_ol_;booN
g]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h2oi80
0005oi810OnB0P;oTP82oi830onB10@00_nB1@D01OnB1PKoTPL7oi882?nB
20SoTPT900;oTPX:00KoTP/;oi8<3?nB3@goTPd=oi8>3_nB3`l2oi8@4005
oi8A4OnB4Q;oTQ<Coi8C4onB51@00_nB5AD01_nB5QKoTQLGoi8H6?nB61So
TQTIoi8J6P;oTQ/K00GoTQ`Loi8M7OnB7QkoTQhNoi8O7`02oi8P8006oi8Q
8OnB8R;oTR<Soi8S8onB92CoTRDU0_nB9RH01OnB9bOoTRPXoi8Y:OnB:BWo
TRXZ00;oTR/[00KoTR`/oi8];OnB;RkoTRh^oi8_;onB<302oi8a<@05oi8b
<_nB<c?oTS@doi8d=?nB=CD00_nB=SH01_nB=cOoTSPhoi8i>OnB>CWoTSXj
oi8k>`;oTS`l00GoTSdmoi8n?_nB?cooTSlooi90@002oi91@@06oi92@_nB
@d?oTTA4oi94A?nBADGoTTI60_nBAdL01OnBB4SoTTU9oi9:B_nBBT[oTT];
00;oTTa<00KoTTe=oi9>C_nBCdooTTm?oi9@D?nBDE42oi9BDP05oi9CDonB
E5CoTUEEoi9EEOnBEUH00_nBEeL01_nBF5SoTUUIoi9JF_nBFU[oTU]Koi9L
G0;oTUeM00GoTUiNoi9OGonBH63oTV1Poi9QH@02oi9RHP06oi9SHonBI6Co
TVEUoi9UIOnBIVKoTVMW0_nBJ6P01OnBJFWoTVYZoi9[JonBJf_oTVa/00;o
TVe]00KoTVi^oi9_KonBL73oTW1`oi9aLOnBLW82oi9cL`05oi9dM?nBMGGo
TWIfoi9fM_nBMgL00_nBN7P01_nBNGWoTWYjoi9kNonBNg_oTWaloi9mO@;o
TWin00GoTWmooi:0P?nBPH7oTX61oi:2PP02oi:3P`06oi:4Q?nBQHGoTXJ6
oi:6Q_nBQhOoTXR80_nBRHT01OnBRX[oTX^;oi:<S?nBS8coTXf=00;oTXj>
00CoTXn?oi:@T?nBTI7oTY6A7Oo^k^h@o`3oS0_ok^k^00Ko<S8bofm_Koo^
k^kok^k^oc4a<Om?Cdl4onk^kP03okVi^OoShn?omOGe00;ooooo00Go_kno
omCDe?o^k^koJf][oda<C005ooooo`03ooOgmooShn?o^KVi05kok^k^00Co
Xj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0
;_oVi^H2oi<00005oi<10OnC0P;oT`82oi<30onC10@00_nC1@D01_nC1PKo
T`L7oi<82?nC20SoT`T9oi<:2P;oT`/;00KoT``<oi<=3OnC3PkoT`h>oi<?
3onC4102oi<A4@05oi<B4_nC4a?oTa<Coi<D5?nC5AD00_nC5QH01_nC5aOo
TaPHoi<I6OnC6AWoTaXJoi<K6`;oTa`L00KoTadMoi<N7_nC7aooTalOoi<P
8?nC8B42oi<R8P05oi<S8onC92CoTb@Toi<U9OnC9RH00_nC9bL01_nC:2So
TbTYoi<Z:_nC:R[oTb/[oi</;0;oTbd]00KoTbh^oi<_;onC<33oTc0`oi<a
<OnC<S82oi<c<`05oi<d=?nC=CGoTcDeoi<f=_nC=cL00_nC>3P01_nC>CWo
TcXjoi<k>onC>c_oTc`loi<m?@;oTchn00KoTclooi=0@?nC@D7oTd51oi=2
@_nC@d<2oi=4A005oi=5AOnCATKoTdI6oi=7AonCB4P00_nCBDT01_nCBT[o
Td];oi=<C?nCC4coTde=oi=>CP;oTdm?00KoTe1@oi=ADOnCDU;oTe9Boi=C
DonCE5@2oi=EE@05oi=FE_nCEeOoTeQHoi=HF?nCFET00_nCFUX01_nCFe_o
TeaLoi=MGOnCGEgoTeiNoi=OG`;oTf1P00KoTf5Qoi=RH_nCHf?oTf=Soi=T
I?nCIFD2oi=VIP05oi=WIonCJ6SoTfUYoi=YJOnCJVX00_nCJf/01_nCK6co
Tfe]oi=^K_nCKVkoTfm_oi=`L0;oTg5a00KoTg9boi=cLonCM7CoTgAdoi=e
MOnCMWH2oi=gM`05oi=hN?nCNGWoTgYjoi=jN_nCNg/00_nCO7`01_nCOGgo
Tginoi=oOonCOgooTh20oi>1P@;oTh:200KoTh>3oi>4Q?nCQHGoThF5oi>6
Q_nCQhL2oi>8R005oi>9ROnCRX[oTh^;oi>;RonCS8`00_nCSHd01onCSXko
Thn?oi>@T?nCT93oTi6Aoi>BT_nCTi<07OoVi^H@o`3oQ0_oi^KV00Ko<30`
obXZ:_mADE7o7alOo`X:2_n_[jl4onKViP03okVi^OoShn?omOGe00;ooooo
00GoVIVIod51@Ol^;RkoJf][omSHf005ooooo`03ooOgmooShn?o^KVi05ko
i^KV00CoWIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm
_OnSXj<0;_o^k^h2oiD00005oiD10OnE0P;oU@82oiD30onE10@00_nE1@D0
1_nE1PKoU@L7oiD82?nE20SoU@T9oiD:2P;oU@/;00KoU@`<oiD=3OnE3Pko
U@h>oiD?3onE4102oiDA4@06oiDB4_nE4a?oUA@DoiDD5?nE5AGoUAHF0_nE
5aL01_nE61SoUATIoiDJ6_nE6Q[oUA/KoiDL70;oUAdM00KoUAhNoiDO7onE
823oUB0PoiDQ8OnE8R82oiDS8`06oiDT9?nE9BGoUBHVoiDV9_nE9bOoUBPX
0_nE:BT01OnE:R[oUB/[oiD/;?nE;2coUBd]00;oUBh^00KoUBl_oiD`<?nE
<C7oUC4aoiDb<_nE<c<2oiDd=006oiDe=OnE=SKoUCLgoiDg=onE>3SoUCTi
0_nE>SX01_nE>c_oUC`loiDm?OnE?CgoUChnoiDo?`;oUD1000KoUD51oiE2
@_nE@d?oUD=3oiE4A?nEADD2oiE6AP06oiE7AonEB4SoUDU9oiE9BOnEBT[o
UD];0_nEC4`01_nECDgoUDi>oiE?ConECdooUE1@oiEAD@;oUE9B00KoUE=C
oiEDE?nEEEGoUEEEoiEFE_nEEeL2oiEHF005oiEIFOnEFU[oUEYJoiEKFonE
G5`00_nEGEd01_nEGUkoUEmOoiEPH?nEH63oUF5QoiERHP;oUF=S00KoUFAT
oiEUIOnEIVKoUFIVoiEWIonEJ6P2oiEYJ@06oiEZJ_nEJf_oUFa/oiE/K?nE
KFgoUFi^0_nEKfl01_nEL73oUG5aoiEbL_nELW;oUG=coiEdM0;oUGEe00Ko
UGIfoiEgMonEN7SoUGQhoiEiNOnENWX2oiEkN`06oiElO?nEOGgoUGinoiEn
O_nEOgooUH200_nEPH401_nEPX;oUH>3oiF4Q?nEQ8CoUHF5oiF6QP;oUHN7
00GoUHR8oiF9ROnERHWoUHZ:oiF;R`02oiF<S006oiF=SOnESXkoUHn?oiF?
SonET93oUI6A0_nETY800onETi?oUIBDonk^kP0Lonk^kQ3o0?ml2oo^k^h0
1OnTY:CoShn?ohn?Son^[Zkoj>SX00Gok^k^00?o^KVion?ShooemOD03?oo
ool00oogmoOohn?SokVi^@1Nonk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
00001Oobl_;oj^[ZomkNg_o;bl_o[jn_02kooooo0_nF00001_nF0@7oUP82
oiH30onF0`?oUP@4oiH51@;oUPH600KoUPL7oiH82?nF2@WoUPT9oiH:2_nF
2`/2oiH<3006oiH=3OnF3PkoUPl?oiH?3onF413oUQ4A0_nF4Q801_nF4a?o
UQ@DoiHE5OnF5AGoUQHFoiHG5`;oUQPH00KoUQTIoiHJ6_nF6a_oUQ/KoiHL
7?nF7Ad2oiHN7P06oiHO7onF823oUR4QoiHQ8OnF8R;oUR<S0_nF92@01_nF
9BGoURHVoiHW9onF9bOoURPXoiHY:@;oURXZ00KoUR/[oiH/;?nF;BgoURd]
oiH^;_nF;bl2oiH`<006oiHa<OnF<S;oUS<coiHc<onF=3CoUSDe0_nF=SH0
1_nF=cOoUSPhoiHi>OnF>CWoUSXjoiHk>`;oUS`l00KoUSdmoiHn?_nF?coo
USlooiI0@?nF@D42oiI2@P06oiI3@onFA4CoUTE5oiI5AOnFATKoUTM70_nF
B4P01_nFBDWoUTY:oiI;BonFBd_oUTa<oiI=C@;oUTi>00OoUTm?oiI@D?nF
DE7oUU5AoiIBD_nFDe?oUUAD00;oUUEE00KoUUIFoiIGEonFF5SoUUQHoiII
FOnFFUX2oiIKF`06oiILG?nFGEgoUUiNoiING_nFGeooUV1P0_nFHF401_nF
HV;oUV=SoiITI?nFI6CoUVEUoiIVIP;oUVMW00KoUVQXoiIYJOnFJV[oUVYZ
oiI[JonFK6`2oiI]K@06oiI^K_nFKfooUW1`oiI`L?nFLG7oUW9b0_nFLg<0
1_nFM7CoUWEeoiIfM_nFMWKoUWMgoiIhN0;oUWUi00KoUWYjoiIkNonFO7co
UWaloiImOOnFOWh2oiIoO`06oiJ0P?nFPH7oUX:2oiJ2P_nFPh?oUXB40_nF
QHD01_nFQXKoUXN7oiJ8R?nFR8SoUXV9oiJ:RP;oUX^;00KoUXb<oiJ=SOnF
SXkoUXj>oiJ?SonFT902oiJAT@05oiJBT_nFTi?oUYBDoiJDU?nFUID07Ooo
ool@o`3oMAGooooo00?o^KVion?ShooemOD01?ooool4oo[jnPCooooo00?o
moOgon?Shoni^KT0G_ooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000Go
hN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kP;oU`0000KoU`41oiL20_nG0`?o
U`<3oiL41?nG1@D2oiL61P06oiL71onG20SoU`T9oiL92OnG2P[oU`/;0_nG
30`01_nG3@goU`h>oiL?3onG3`ooUa0@oiLA4@;oUa8B00?oUa<CoiLD5?nG
5AD00_nG5QH01_nG5aOoUaPHoiLI6OnG6AWoUaXJoiLK6`;oUa`L00KoUadM
oiLN7_nG7aooUalOoiLP8?nG8B42oiLR8P06oiLS8onG92CoUbDUoiLU9OnG
9RKoUbLW0_nG:2P00onG:BWoUbXZoiL[:`02oiL/;006oiL];OnG;RkoUbl_
oiL_;onG<33oUc4a0_nG<S801_nG<c?oUc@doiLe=OnG=CGoUcHfoiLg=`;o
UcPh00KoUcTioiLj>_nG>c_oUc/koiLl??nG?Cd2oiLn?P03oiLo?onG@43o
Ud5100;oUd9200KoUd=3oiM4A?nGADGoUdE5oiM6A_nGAdL2oiM8B006oiM9
BOnGBT[oUd];oiM;BonGC4coUde=0_nGCTh01_nGCdooUe1@oiMADOnGDE7o
Ue9BoiMCD`;oUeAD00?oUeEEoiMFE_nGEeL00_nGF5P01_nGFEWoUeYJoiMK
FonGFe_oUeaLoiMMG@;oUeiN00KoUemOoiMPH?nGHF7oUf5QoiMRH_nGHf<2
oiMTI006oiMUIOnGIVKoUfMWoiMWIonGJ6SoUfUY0_nGJVX00onGJf_oUfa/
oiM]K@02oiM^KP06oiM_KonGL73oUg5aoiMaLOnGLW;oUg=c0_nGM7@01_nG
MGGoUgIfoiMgMonGMgOoUgQhoiMiN@;oUgYj00KoUg]koiMlO?nGOGgoUgem
oiMnO_nGOgl2oiN0P003oiN1POnGPX;oUh>300;oUhB400KoUhF5oiN6Q_nG
QhOoUhN7oiN8R?nGRHT2oiN:RP06oiN;RonGS8coUhf=oiN=SOnGSXkoUhn?
0_nGT9001_nGTI7oUi:BoiNCTonGTi?oUiBDoiNEU@;oUiJF7Oo^k^h@o`3o
KAGok^k^00?o^KViomgMgOoZj^X01?oZj^X4oo3`l0Goj^[Z00?ogMgMokVi
^Oo^k^h0GOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?C
doo8b<So]kNgoifMW@0^onKViP;oV@0000KoV@41oiT20_nI0`?oV@<3oiT4
1?nI1@D2oiT61P07oiT71onI20SoV@T9oiT92OnI2P[oV@/;oiT<3002oiT=
3@06oiT>3_nI3`ooVA0@oiT@4?nI4A7oVA8B0_nI4a<01onI51CoVADEoiTF
5_nI5QKoVALGoiTH6?nI6AT00_nI6QX01_nI6a_oVA`LoiTM7OnI7AgoVAhN
oiTO7`;oVB0P00OoVB4QoiTR8_nI8b?oVB<SoiTT9?nI9BGoVBHV00;oVBLW
00KoVBPXoiTY:OnI:R[oVBXZoiT[:onI;2`2oiT];@07oiT^;_nI;booVC0`
oiT`<?nI<C7oVC8boiTc<`02oiTd=006oiTe=OnI=SKoVCLgoiTg=onI>3So
VCTi0_nI>SX01onI>c_oVC`loiTm?OnI?CgoVChnoiTo?onI@4000_nI@D40
1_nI@T;oVD=3oiU4A?nIA4CoVDE5oiU6AP;oVDM700OoVDQ8oiU9BOnIBT[o
VDY:oiU;BonIC4coVDe=00;oVDi>00KoVDm?oiU@D?nIDE7oVE5AoiUBD_nI
De<2oiUDE007oiUEEOnIEUKoVEMGoiUGEonIF5SoVEUIoiUJFP02oiUKF`06
oiULG?nIGEgoVEiNoiUNG_nIGeooVF1P0_nIHF401onIHV;oVF=SoiUTI?nI
I6CoVFEUoiUVI_nIIfL00_nIJ6P01_nIJFWoVFYZoiU[JonIJf_oVFa/oiU]
K@;oVFi^00OoVFm_oiU`L?nILG7oVG5aoiUbL_nILg?oVGAd00;oVGEe00Ko
VGIfoiUgMonIN7SoVGQhoiUiNOnINWX2oiUkN`07oiUlO?nIOGgoVGinoiUn
O_nIOgooVH20oiV1P@02oiV2PP06oiV3PonIQ8CoVHF5oiV5QOnIQXKoVHN7
0_nIR8P01onIRHWoVHZ:oiV;RonIRh_oVHb<oiV=SOnISXh00_nIShl01_nI
T93oVI6AoiVBT_nITY;oVI>CoiVDU0;oVIFE00?oVIJFoiVGUonIV9P07OoV
i^H@o`3oIAGoi^KV00?oVYZJokVi^Oo2`/801?o2`/84ol?3``Go`/;200?o
^KVioiZJV_oVi^H0GOoVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000Go
hN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kP;oVP0000KoVP41oiX20_nJ0`?o
VP<3oiX41?nJ1@D2oiX61P03oiX71onJ20SoVPT900;oVPX:00KoVP/;oiX<
3?nJ3@goVPd=oiX>3_nJ3`l2oiX@4003oiXA4OnJ4Q;oVQ<C00;oVQ@D00Ko
VQDEoiXF5_nJ5aOoVQLGoiXH6?nJ6AT2oiXJ6P03oiXK6onJ71coVQdM00;o
VQhN00OoVQlOoiXP8?nJ8B7oVR4QoiXR8_nJ8b?oVR@T00;oVRDU00KoVRHV
oiXW9onJ:2SoVRPXoiXY:OnJ:RX2oiX[:`03oiX/;?nJ;BgoVRh^00;oVRl_
00KoVS0`oiXa<OnJ<S;oVS8boiXc<onJ=3@2oiXe=@03oiXf=_nJ=cOoVSPh
00;oVSTi00OoVSXjoiXk>onJ?3coVS`loiXm?OnJ?SkoVSlo00;oVT1000Ko
VT51oiY2@_nJ@d?oVT=3oiY4A?nJADD2oiY6AP03oiY7AonJB4SoVTU900;o
VTY:00KoVT];oiY<C?nJCDgoVTe=oiY>C_nJCdl2oiY@D003oiYADOnJDU;o
VU=C00;oVUAD00OoVUEEoiYFE_nJEeOoVUMGoiYHF?nJFEWoVUYJ00;oVU]K
00KoVUaLoiYMGOnJGUkoVUiNoiYOGonJH602oiYQH@03oiYRH_nJHf?oVVAT
00;oVVEU00KoVVIVoiYWIonJJ6SoVVQXoiYYJOnJJVX2oiY[J`03oiY/K?nJ
KFgoVVi^00;oVVm_00OoVW1`oiYaLOnJLW;oVW9boiYcLonJM7CoVWEe00;o
VWIf00KoVWMgoiYhN?nJNGWoVWUioiYjN_nJNg/2oiYlO003oiYmOOnJOWko
VWmo00;oVX2000KoVX61oiZ2P_nJPh?oVX>3oiZ4Q?nJQHD2oiZ6QP03oiZ7
QonJR8SoVXV900;oVXZ:00OoVX^;oiZ<S?nJSHgoVXf=oiZ>S_nJShooVY2@
00;oVY6A00KoVY:BoiZCTonJU9CoVYBDoiZEUOnJUYH2oiZGU`03oiZHV?nJ
VIWok^k^01cok^k^4?l0oehEonk^kP03ofUYJOmgMgOoNg]k00CoNg]k1?ml
O7`5og]kN`03ogMgMomYJFWok^k^05gok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0;_ooool2oi/00006oi/1
0OnK0P;oV`<3oi/30onK10CoV`D50_nK1PH00onK1`OoV`P8oi/92@02oi/:
2P07oi/;2onK30coV`d=oi/=3OnK3PkoV`l?oi/@4002oi/A4@07oi/B4_nK
4a?oVa@Doi/D5?nK5AGoVaHFoi/G5`02oi/H6007oi/I6OnK6Q[oVa/Koi/K
6onK71coVadMoi/N7P02oi/O7`07oi/P8?nK8B7oVb8Roi/R8_nK8b?oVb@T
oi/U9@02oi/V9P07oi/W9onK:2SoVbTYoi/Y:OnK:R[oVb/[oi//;002oi/]
;@07oi/^;_nK;booVc0`oi/`<?nK<C7oVc8boi/c<`02oi/d=007oi/e=OnK
=SKoVcLgoi/g=onK>3SoVcTioi/j>P02oi/k>`07oi/l??nK?CgoVchnoi/n
?_nK?cooVd10oi]1@@02oi]2@P07oi]3@onKA4CoVdE5oi]5AOnKATKoVdM7
oi]8B002oi]9B@07oi]:B_nKBd_oVda<oi]<C?nKCDgoVdi>oi]?C`02oi]@
D007oi]ADOnKDU;oVe=Coi]CDonKE5CoVeEEoi]FEP02oi]GE`07oi]HF?nK
FEWoVeYJoi]JF_nKFe_oVeaLoi]MG@02oi]NGP07oi]OGonKH63oVf5Qoi]Q
HOnKHV;oVf=Soi]TI002oi]UI@07oi]VI_nKIfOoVfQXoi]XJ?nKJFWoVfYZ
oi][J`02oi]/K007oi]]KOnKKVkoVfm_oi]_KonKL73oVg5aoi]bLP02oi]c
L`07oi]dM?nKMGGoVgIfoi]fM_nKMgOoVgQhoi]iN@02oi]jNP07oi]kNonK
O7coVgemoi]mOOnKOWkoVgmooi^0P002oi^1P@07oi^2P_nKPh?oVhB4oi^4
Q?nKQHGoVhJ6oi^7Q`02oi^8R007oi^9ROnKRX[oVh^;oi^;RonKS8coVhf=
oi^>SP02oi^?S`07oi^@T?nKTI7oVi:Boi^BT_nKTi?oViBDoi^EU@02oi^F
UP05oi^GUonKV9SoViVIoi^IVOnKVYX07Oooool@o`3oEXGooooo00Co[jn_
ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][oclo?okfm_OnSXj<0;_o^
k^h2oi`00007oi`10OnL0P;oW0<3oi`30onL10CoW0D5oi`61P02oi`71`07
oi`82?nL2@WoW0X:oi`:2_nL2`_oW0`<oi`=3@02oi`>3P03oi`?3onL413o
W14A00;oW18B00OoW1<Coi`D5?nL5AGoW1DEoi`F5_nL5aOoW1PH00;oW1TI
00?oW1XJoi`K6onL71`00_nL7Ad01onL7QkoW1lOoi`P8?nL823oW24Qoi`R
8_nL8b<00_nL92@01onL9BGoW2HVoi`W9onL9bOoW2PXoi`Y:OnL:RX00_nL
:b/00onL;2coW2d]oi`^;P02oi`_;`07oi``<?nL<C7oW38boi`b<_nL<c?o
W3@doi`e=@02oi`f=P03oi`g=onL>3SoW3Ti00;oW3Xj00OoW3/koi`l??nL
?CgoW3dmoi`n?_nL?cooW41000;oW45100?oW492oia3@onLA4@00_nLADD0
1onLATKoW4M7oia8B?nLB4SoW4U9oia:B_nLBd/00_nLC4`01onLCDgoW4i>
oia?ConLCdooW51@oiaADOnLDU800_nLDe<00onLE5CoW5EEoiaFEP02oiaG
E`07oiaHF?nLFEWoW5YJoiaJF_nLFe_oW5aLoiaMG@02oiaNGP03oiaOGonL
H63oW65Q00;oW69R00OoW6=SoiaTI?nLIFGoW6EUoiaVI_nLIfOoW6QX00;o
W6UY00OoW6YZoia[JonLK6coW6a/oia]KOnLKVkoW6m_00;oW71`00?oW75a
oiabL_nLLg<00_nLM7@01onLMGGoW7IfoiagMonLMgOoW7QhoiaiNOnLNWX0
0_nLNg/00onLO7coW7emoianOP02oiaoO`07oib0P?nLPH7oW8:2oib2P_nL
Ph?oW8B4oib5Q@02oib6QP03oib7QonLR8SoW8V900;oW8Z:00OoW8^;oib<
S?nLSHgoW8f=oib>S_nLShooW92@00;oW96A00OoW9:BoibCTonLU9CoW9BD
oibEUOnLUYKoW9NG00;oW9RH00CoW9VIoibJV_nLVi_oW9bL7Oo^k^h@o`3o
ChGok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8
okNg]onMWId0;_oVi^H2oih00007oih10OnN0P;oWP<3oih30onN10CoWPD5
oih61P02oih71`03oih82?nN2@WoWPX:00;oWP/;00?oWP`<oih=3OnN3Ph0
0_nN3`l01onN413oWQ4AoihB4_nN4Q;oWQ<CoihD5?nN5AD00_nN5QH00onN
5aOoWQPHoihI6@02oihJ6P03oihK6onN71coWQdM00;oWQhN00OoWQlOoihP
8?nN8B7oWR4QoihR8_nN8b?oWR@T00;oWRDU00?oWRHVoihW9onN:2P00_nN
:BT00onN:R[oWR/[oih/;002oih];@03oih^;_nN;booWS0`00;oWS4a00Oo
WS8boihc<onN=3CoWS@doihe=OnN=SKoWSLg00;oWSPh00?oWSTioihj>_nN
>c/00_nN?3`00onN?CgoWShnoiho?`02oii0@007oii1@OnN@T;oWT=3oii3
@onNA4CoWTE5oii6AP02oii7A`03oii8B?nNBDWoWTY:00;oWT];00?oWTa<
oii=COnNCTh00_nNCdl00onND53oWU5AoiiBDP02oiiCD`07oiiDE?nNEEGo
WUIFoiiFE_nNEeOoWUQHoiiIF@02oiiJFP03oiiKFonNG5coWUeM00;oWUiN
00?oWUmOoiiPH?nNHF400_nNHV801onNHf?oWVAToiiUIOnNIFGoWVIVoiiW
IonNJ6P00_nNJFT00onNJV[oWV][oii/K002oii]K@03oii^K_nNKfooWW1`
00;oWW5a00OoWW9boiicLonNM7CoWWAdoiieMOnNMWKoWWMg00;oWWQh00?o
WWUioiijN_nNNg/00_nNO7`00onNOGgoWWinoiioO`02oij0P003oij1POnN
PX;oWX>300;oWXB400OoWXF5oij6Q_nNQhOoWXN7oij8R?nNRHWoWXZ:00;o
WX^;00?oWXb<oij=SOnNSXh00_nNShl00onNT93oWY6AoijBTP02oijCT`07
oijDU?nNUIGoWYJFoijFU_nNUiOoWYRHoijIV@02oijJVP03oijKVonNW9co
WYfM01goi^KV4?l0odN5onKViP04oifMWOng]kOob<S8om?Cd`7of][J0000
1OoQhN7of][Jolo?conm_KgoXj>S02kok^k^0_nO00001onO0@7oW`82oil3
0onO0`?oW`@4oil51OnO1PH00_nO1`L00onO20SoW`T9oil:2P02oil;2`03
oil<3?nO3@goW`h>00;oW`l?00?oWa0@oilA4OnO4Q800_nO4a<00onO51Co
WaDEoilF5P02oilG5`03oilH6?nO6AWoWaXJ00;oWa/K00?oWa`LoilM7OnO
7Qh00_nO7al00onO823oWb4QoilR8P02oilS8`03oilT9?nO9BGoWbHV00;o
WbLW00?oWbPXoilY:OnO:RX00_nO:b/00onO;2coWbd]oil^;P02oil_;`07
oil`<?nO<C7oWc8boilb<_nO<c?oWc@doile=@02oilf=P03oilg=onO>3So
WcTi00;oWcXj00?oWc/koill??nO?Cd00_nO?Sh00onO?cooWd10oim1@@02
oim2@P03oim3@onOA4CoWdE500;oWdI600?oWdM7oim8B?nOBDT00_nOBTX0
0onOBd_oWda<oim=C@02oim>CP03oim?ConOD53oWe5A00;oWe9B00?oWe=C
oimDE?nOEED00_nOEUH00onOEeOoWeQHoimIF@02oimJFP03oimKFonOG5co
WeeM00;oWeiN00?oWemOoimPH?nOHF400_nOHV801onOHf?oWfAToimUIOnO
IFGoWfIVoimWIonOJ6P00_nOJFT00onOJV[oWf][oim/K002oim]K@03oim^
K_nOKfooWg1`00;oWg5a00?oWg9boimcLonOM7@00_nOMGD00onOMWKoWgMg
oimhN002oimiN@03oimjN_nONg_oWgal00;oWgem00?oWginoimoOonOP800
0_nOPH400onOPX;oWh>3oin4Q002oin5Q@03oin6Q_nOQhOoWhR800;oWhV9
00?oWhZ:oin;RonOS8`00_nOSHd00onOSXkoWhn?oin@T002oinAT@03oinB
T_nOTi?oWiBD00;oWiFE00OoWiJFoinGUonOV9SoWiRHoinIVOnOVY[oWi^K
00;oWibL00?oWifMoinNW_o^k^h07?o^k^h@o`3o?hGok^k^00CoXj>Sokfm
_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0;_ooool2
oj000003oj010OnP0P;oX0<300;oX0@400?oX0D5oj061_nP1`L00_nP20P0
0onP2@WoX0X:oj0;2`02oj0<3003oj0=3OnP3PkoX0l?00;oX10@00?oX14A
oj0B4_nP4a<00_nP51@00onP5AGoX1HFoj0G5`02oj0H6003oj0I6OnP6Q[o
X1/K00;oX1`L00?oX1dMoj0N7_nP7al00_nP82000onP8B7oX28Roj0S8`02
oj0T9003oj0U9OnP9RKoX2LW00;oX2PX00?oX2TYoj0Z:_nP:b/00_nP;2`0
0onP;BgoX2h^oj0_;`02oj0`<004oj0a<OnP<S;oX3<coj0d=0;oX3De00?o
X3Hfoj0g=onP>3P00_nP>CT00onP>S[oX3/koj0l?002oj0m?@03oj0n?_nP
?cooX41000;oX45100?oX492oj13@onPA4@00_nPADD00onPATKoX4M7oj18
B002oj19B@03oj1:B_nPBd_oX4a<00;oX4e=00?oX4i>oj1?ConPD5000_nP
DE400onPDU;oX5=Coj1DE002oj1EE@03oj1FE_nPEeOoX5QH00;oX5UI00?o
X5YJoj1KFonPG5`00_nPGEd00onPGUkoX5mOoj1PH002oj1QH@04oj1RH_nP
Hf?oX6AToj1UI@;oX6IV00?oX6MWoj1XJ?nPJFT00_nPJVX00onPJf_oX6a/
oj1]K@02oj1^KP03oj1_KonPL73oX75a00;oX79b00?oX7=coj1dM?nPMGD0
0_nPMWH00onPMgOoX7Qhoj1iN@02oj1jNP03oj1kNonPO7coX7em00;oX7in
00?oX7mooj20P?nPPH400_nPPX800onPPh?oX8B4oj25Q@02oj26QP03oj27
QonPR8SoX8V900;oX8Z:00?oX8^;oj2<S?nPSHd00_nPSXh00onPShooX92@
oj2AT@02oj2BTP04oj2CTonPU9CoX9FEoj2FUP;oX9NG00?oX9RHoj2IVOnP
VYX00_nPVi/00onPW9coX9fMoj2NWP02oj2OWagooooo4?l0ocR5ooooo`04
ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S
02kok^k^0_nQ00000onQ0@7oX@82oj430`02oj441003oj451OnQ1PKoX@L7
00;oX@P800?oX@T9oj4:2_nQ2`/00_nQ30`01?nQ3@goX@h>oj4?3onQ4102
oj4A4@03oj4B4_nQ4a?oXA@D00;oXADE00?oXAHFoj4G5onQ61P00_nQ6AT0
0onQ6Q[oXA/Koj4L7002oj4M7@04oj4N7_nQ7aooXB0Poj4Q8@;oXB8R00?o
XB<Soj4T9?nQ9BD00_nQ9RH00onQ9bOoXBPXoj4Y:@02oj4Z:P03oj4[:onQ
;2coXBd]00;oXBh^00CoXBl_oj4`<?nQ<C7oXC8b0_nQ<c<00onQ=3CoXCDe
oj4f=P02oj4g=`03oj4h>?nQ>CWoXCXj00;oXC/k00?oXC`loj4m?OnQ?Sh0
0_nQ?cl01?nQ@43oXD51oj52@_nQ@d<2oj54A003oj55AOnQATKoXDM700;o
XDQ800?oXDU9oj5:B_nQBd/00_nQC4`00onQCDgoXDi>oj5?C`02oj5@D004
oj5ADOnQDU;oXE=Coj5DE0;oXEEE00?oXEIFoj5GEonQF5P00_nQFET00onQ
FU[oXE]Koj5LG002oj5MG@03oj5NG_nQGeooXF1P00;oXF5Q00CoXF9Roj5S
HonQI6CoXFEU0_nQIVH00onQIfOoXFQXoj5YJ@02oj5ZJP03oj5[JonQK6co
XFe]00;oXFi^00?oXFm_oj5`L?nQLG400_nQLW801?nQLg?oXGAdoj5eMOnQ
MWH2oj5gM`03oj5hN?nQNGWoXGYj00;oXG]k00?oXGaloj5mOOnQOWh00_nQ
Ogl00onQP83oXH61oj62PP02oj63P`04oj64Q?nQQHGoXHJ6oj67Q`;oXHR8
00?oXHV9oj6:R_nQRh/00_nQS8`00onQSHgoXHj>oj6?S`02oj6@T003oj6A
TOnQTY;oXI>C00;oXIBD00CoXIFEoj6FU_nQUiOoXIRH0_nQVIT00onQVY[o
XI^Koj6LW002oj6MW@04oj6NW_nQWiooXJ2Poj6QXAgok^k^4?l0oc25onk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOo
WIfM02koi^KV0_nS00000onS0@7oX`82oj<30`02oj<41003oj<51OnS1PKo
X`L700;oX`P800CoX`T9oj<:2_nS2`_oX``<0_nS3@d00onS3PkoX`l?oj<@
4002oj<A4@04oj<B4_nS4a?oXa@Doj<E5@;oXaHF00?oXaLGoj<H6?nS6AT0
0_nS6QX01?nS6a_oXa`Loj<M7OnS7Qh2oj<O7`03oj<P8?nS8B7oXb8R00;o
Xb<S00?oXb@Toj<U9OnS9RH00_nS9bL01?nS:2SoXbTYoj<Z:_nS:b/2oj</
;003oj<];OnS;RkoXbl_00;oXc0`00CoXc4aoj<b<_nS<c?oXc@d0_nS=CD0
0onS=SKoXcLgoj<h>002oj<i>@04oj<j>_nS>c_oXc`loj<m?@;oXchn00?o
Xclooj=0@?nS@D400_nS@T800onS@d?oXdA4oj=5A@02oj=6AP04oj=7AonS
B4SoXdU9oj=:BP;oXd];00?oXda<oj==COnSCTh00_nSCdl01?nSD53oXe5A
oj=BD_nSDe<2oj=DE003oj=EEOnSEUKoXeMG00;oXeQH00CoXeUIoj=JF_nS
Fe_oXeaL0_nSGEd00onSGUkoXemOoj=PH002oj=QH@03oj=RH_nSHf?oXfAT
00;oXfEU00CoXfIVoj=WIonSJ6SoXfUY0_nSJVX00onSJf_oXfa/oj=]K@02
oj=^KP04oj=_KonSL73oXg5aoj=bLP;oXg=c00?oXgAdoj=eMOnSMWH00_nS
MgL01?nSN7SoXgUioj=jN_nSNg/2oj=lO003oj=mOOnSOWkoXgmo00;oXh20
00CoXh61oj>2P_nSPh?oXhB40_nSQHD00onSQXKoXhN7oj>8R002oj>9R@03
oj>:R_nSRh_oXhb<00;oXhf=00CoXhj>oj>?SonST93oXi6A0_nSTY800onS
Ti?oXiBDoj>EU@02oj>FUP04oj>GUonSV9SoXiVIoj>JVP;oXi^K00?oXibL
oj>MWOnSWYh00_nSWil00onSX:3oXj6Qoj>RXP0MonKViQ3o0?lXQOoVi^H0
1?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>S
X`0^onk^kP;oY00000?oY041oj@20_nT0`<00_nT10@01?nT1@GoY0H6oj@7
1onT20P2oj@92@03oj@:2_nT2`_oY0`<00;oY0d=00CoY0h>oj@?3onT413o
Y14A0_nT4Q801?nT4a?oY1@Doj@E5OnT5QH2oj@G5`03oj@H6?nT6AWoY1XJ
00;oY1/K00CoY1`Loj@M7OnT7QkoY1lO0_nT82001?nT8B7oY28Roj@S8onT
92@2oj@U9@03oj@V9_nT9bOoY2PX00;oY2TY00CoY2XZoj@[:onT;2coY2d]
0_nT;Rh00onT;booY30`oj@a<@02oj@b<P04oj@c<onT=3CoY3Deoj@f=P;o
Y3Lg00CoY3Phoj@i>OnT>S[oY3/k0_nT?3`00onT?CgoY3hnoj@o?`02ojA0
@004ojA1@OnT@T;oY4=3ojA4A0;oY4E500CoY4I6ojA7AonTB4SoY4U90_nT
BTX00onTBd_oY4a<ojA=C@02ojA>CP04ojA?ConTD53oY55AojABDP;oY5=C
00?oY5ADojAEEOnTEUH00_nTEeL01?nTF5SoY5UIojAJF_nTFe/2ojALG004
ojAMGOnTGUkoY5mOojAPH0;oY65Q00?oY69RojASHonTI6@00_nTIFD01?nT
IVKoY6MWojAXJ?nTJFT2ojAZJP04ojA[JonTK6coY6e]ojA^KP;oY6m_00?o
Y71`ojAaLOnTLW800_nTLg<01?nTM7CoY7EeojAfM_nTMgL2ojAhN004ojAi
NOnTNW[oY7]kojAlO0;oY7em00?oY7inojAoOonTP8000_nTPH401?nTPX;o
Y8>3ojB4Q?nTQHD2ojB6QP03ojB7QonTR8SoY8V900;oY8Z:00CoY8^;ojB<
S?nTSHgoY8j>0_nTShl01?nTT93oY96AojBBT_nTTi<2ojBDU003ojBEUOnT
UYKoY9NG00;oY9RH00CoY9VIojBJV_nTVi_oY9bL0_nTWId01?nTWYkoY9nO
ojBPX?nTXJ42ojBRXP03ojBSXoo^k^kok^k^01_ok^k^4?l0ob65onk^kP04
oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_
02kooooo0_nU00000onU0@7oY@82ojD30`02ojD41004ojD51OnU1PKoY@L7
ojD820;oY@T900CoY@X:ojD;2onU30coY@d=0_nU3Ph01?nU3`ooYA0@ojDA
4OnU4Q82ojDC4`04ojDD5?nU5AGoYAHFojDG5`;oYAPH00CoYATIojDJ6_nU
6a_oYA`L0_nU7Ad00onU7QkoYAlOojDP8002ojDQ8@04ojDR8_nU8b?oYB@T
ojDU9@;oYBHV00CoYBLWojDX:?nU:BWoYBXZ0_nU:b/01?nU;2coYBd]ojD^
;_nU;bl2ojD`<004ojDa<OnU<S;oYC<cojDd=0;oYCDe00CoYCHfojDg=onU
>3SoYCTi0_nU>SX00onU>c_oYC`lojDm?@02ojDn?P04ojDo?onU@43oYD51
ojE2@P;oYD=300CoYDA4ojE5AOnUATKoYDM70_nUB4P01?nUBDWoYDY:ojE;
BonUC4`2ojE=C@04ojE>C_nUCdooYE1@ojEAD@;oYE9B00CoYE=CojEDE?nU
EEGoYEIF0_nUEeL00onUF5SoYEUIojEJFP02ojEKF`04ojELG?nUGEgoYEiN
ojEOG`;oYF1P00CoYF5QojERH_nUHf?oYFAT0_nUIFD01?nUIVKoYFMWojEX
J?nUJFT2ojEZJP04ojE[JonUK6coYFe]ojE^KP;oYFm_00CoYG1`ojEaLOnU
LW;oYG=c0_nUM7@00onUMGGoYGIfojEgM`02ojEhN004ojEiNOnUNW[oYG]k
ojElO0;oYGem00CoYGinojEoOonUP83oYH610_nUPX801?nUPh?oYHB4ojF5
QOnUQXH2ojF7Q`04ojF8R?nURHWoYHZ:ojF;R`;oYHb<00CoYHf=ojF>S_nU
ShooYI2@0_nUTI401?nUTY;oYI>CojFDU?nUUID2ojFFUP03ojFGUonUV9So
YIVI00;oYIZJ00CoYI^KojFLW?nUWIgoYIjN0_nUWil01?nUX:3oYJ6QojFR
X_nUXj<2ojFTY1gooooo4?l0oaV5ooooo`04ojn_[oo;bl_og]kNon[ZjP7o
l_;b00001OoQhN7of][Jolo?conm_KgoXj>S02kok^k^0_nW00001?nW0@7o
Y`82ojL30onW10@2ojL51@04ojL61_nW1`OoY`P8ojL92@;oY`X:00CoY`/;
ojL<3?nW3@goY`h>0_nW3`l01?nW413oYa4AojLB4_nW4a<2ojLD5004ojLE
5OnW5QKoYaLGojLH60;oYaTI00CoYaXJojLK6onW71coYadM0_nW7Qh01?nW
7aooYb0PojLQ8OnW8R82ojLS8`04ojLT9?nW9BGoYbHVojLW9`;oYbPX00Co
YbTYojLZ:_nW:b_oYb`/0_nW;Bd01?nW;RkoYbl_ojL`<?nW<C42ojLb<P04
ojLc<onW=3CoYcDeojLf=P;oYcLg00CoYcPhojLi>OnW>S[oYc/k0_nW?3`0
1?nW?CgoYchnojLo?onW@402ojM1@@04ojM2@_nW@d?oYdA4ojM5A@;oYdI6
00CoYdM7ojM8B?nWBDWoYdY:0_nWBd/01OnWC4coYde=ojM>C_nWCdooYe1@
00;oYe5A00CoYe9BojMCDonWE5CoYeEE0_nWEUH01?nWEeOoYeQHojMIFOnW
FUX2ojMKF`04ojMLG?nWGEgoYeiNojMOG`;oYf1P00CoYf5QojMRH_nWHf?o
YfAT0_nWIFD01?nWIVKoYfMWojMXJ?nWJFT2ojMZJP04ojM[JonWK6coYfe]
ojM^KP;oYfm_00CoYg1`ojMaLOnWLW;oYg=c0_nWM7@01?nWMGGoYgIfojMg
MonWN7P2ojMiN@04ojMjN_nWNg_oYgalojMmO@;oYgin00CoYgmoojN0P?nW
PH7oYh:20_nWPh<01?nWQ8CoYhF5ojN6Q_nWQhL2ojN8R004ojN9ROnWRX[o
Yh^;ojN<S0;oYhf=00CoYhj>ojN?SonWT93oYi6A0_nWTY801?nWTi?oYiBD
ojNEUOnWUYH2ojNGU`05ojNHV?nWVIWoYiZJojNKVonWW9`00_nWWId01?nW
WYkoYinOojNPX?nWXJ42ojNRXP04ojNSXonWY:CoYjFUojNVYQgok^k^4?l0
oa65onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8
b?ng]kOoWIfM02koi^KV0_nX00001?nX0@7oZ082ojP30onX10@2ojP51@04
ojP61_nX1`OoZ0P8ojP92@;oZ0X:00CoZ0/;ojP<3?nX3@goZ0h>0_nX3`l0
1OnX413oZ14AojPB4_nX4a?oZ1@D00;oZ1DE00CoZ1HFojPG5onX61SoZ1TI
0_nX6QX01?nX6a_oZ1`LojPM7OnX7Qh2ojPO7`05ojPP8?nX8B7oZ28RojPS
8onX92@00_nX9BD01?nX9RKoZ2LWojPX:?nX:BT2ojPZ:P04ojP[:onX;2co
Z2d]ojP^;P;oZ2l_00GoZ30`ojPa<OnX<S;oZ3<cojPd=002ojPe=@04ojPf
=_nX=cOoZ3PhojPi>@;oZ3Xj00CoZ3/kojPl??nX?CgoZ3hn0_nX?cl01OnX
@43oZ451ojQ2@_nX@d?oZ4A400;oZ4E500CoZ4I6ojQ7AonXB4SoZ4U90_nX
BTX01?nXBd_oZ4a<ojQ=COnXCTh2ojQ?C`04ojQ@D?nXDE7oZ59BojQCD`;o
Z5AD00GoZ5EEojQFE_nXEeOoZ5QHojQIF@02ojQJFP04ojQKFonXG5coZ5eM
ojQNGP;oZ5mO00CoZ61PojQQHOnXHV;oZ6=S0_nXI6@01OnXIFGoZ6IVojQW
IonXJ6SoZ6UY00;oZ6YZ00CoZ6][ojQ/K?nXKFgoZ6i^0_nXKfl01?nXL73o
Z75aojQbL_nXLg<2ojQdM005ojQeMOnXMWKoZ7MgojQhN?nXNGT00_nXNWX0
1?nXNg_oZ7alojQmOOnXOWh2ojQoO`04ojR0P?nXPH7oZ8:2ojR3P`;oZ8B4
00GoZ8F5ojR6Q_nXQhOoZ8R8ojR9R@02ojR:RP04ojR;RonXS8coZ8f=ojR>
SP;oZ8n?00CoZ92@ojRATOnXTY;oZ9>C0_nXU9@01?nXUIGoZ9JFojRGUonX
V9P2ojRIV@05ojRJV_nXVi_oZ9bLojRMWOnXWYh00_nXWil01?nXX:3oZ:6Q
ojRRX_nXXj<2ojRTY003ojRUYOnXYZKoZ:NW01goi^KV4?l0o`Z5onKViP04
oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S
02kok^k^0_nY00001?nY0@7oZ@82ojT30onY10@2ojT51@05ojT61_nY1`Oo
Z@P8ojT92OnY2PX00_nY2`/01?nY30coZ@d=ojT>3_nY3`l2ojT@4005ojTA
4OnY4Q;oZA<CojTD5?nY5AD00_nY5QH01?nY5aOoZAPHojTI6OnY6QX2ojTK
6`05ojTL7?nY7AgoZAhNojTO7onY82000_nY8B401OnY8R;oZB<SojTT9?nY
9BGoZBHV00;oZBLW00CoZBPXojTY:OnY:R[oZB/[0_nY;2`01OnY;BgoZBh^
ojT_;onY<33oZC4a00;oZC8b00CoZC<cojTd=?nY=CGoZCHf0_nY=cL01OnY
>3SoZCTiojTj>_nY>c_oZC`l00;oZCdm00CoZChnojTo?onY@43oZD510_nY
@T801OnY@d?oZDA4ojU5AOnYATKoZDM700;oZDQ800GoZDU9ojU:B_nYBd_o
ZDa<ojU=C@02ojU>CP04ojU?ConYD53oZE5AojUBDP;oZE=C00GoZEADojUE
EOnYEUKoZEMGojUHF002ojUIF@04ojUJF_nYFe_oZEaLojUMG@;oZEiN00Go
ZEmOojUPH?nYHF7oZF9RojUSH`02ojUTI004ojUUIOnYIVKoZFMWojUXJ0;o
ZFUY00GoZFYZojU[JonYK6coZFe]ojU^KP02ojU_K`05ojU`L?nYLG7oZG9b
ojUcLonYM7@00_nYMGD01?nYMWKoZGMgojUhN?nYNGT2ojUjNP05ojUkNonY
O7coZGemojUnO_nYOgl00_nYP8001?nYPH7oZH:2ojV3PonYQ8@2ojV5Q@05
ojV6Q_nYQhOoZHR8ojV9ROnYRXX00_nYRh/01?nYS8coZHf=ojV>S_nYShl2
ojV@T005ojVATOnYTY;oZI>CojVDU?nYUID00_nYUYH01OnYUiOoZIRHojVI
VOnYVY[oZI^K00;oZIbL00CoZIfMojVNW_nYWiooZJ2P0_nYXJ401OnYXZ;o
ZJ>SojVTY?nYYJGoZJJV00;oZJNW00?oZJRXonk^k_o^k^h06oo^k^h@o`3o
0XGok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kN
ol_;bon_[jl0;_ooool2ojX00004ojX10OnZ0P;oZP<3ojX410;oZPD500Go
ZPH6ojX71onZ20SoZPT9ojX:2P02ojX;2`05ojX<3?nZ3@goZPh>ojX?3onZ
41000_nZ4A401OnZ4Q;oZQ<CojXD5?nZ5AGoZQHF00;oZQLG00GoZQPHojXI
6OnZ6Q[oZQ/KojXL7002ojXM7@05ojXN7_nZ7aooZR0PojXQ8OnZ8R800_nZ
8b<01OnZ92CoZRDUojXV9_nZ9bOoZRPX00;oZRTY00CoZRXZojX[:onZ;2co
ZRd]0_nZ;Rh01OnZ;booZS0`ojXa<OnZ<S;oZS<c00;oZS@d00GoZSDeojXf
=_nZ=cOoZSPhojXi>@02ojXj>P05ojXk>onZ?3coZSdmojXn?_nZ?cl00_nZ
@4001OnZ@D7oZT92ojY3@onZA4CoZTE500;oZTI600GoZTM7ojY8B?nZBDWo
ZTY:ojY;B`02ojY<C005ojY=COnZCTkoZTm?ojY@D?nZDE400_nZDU801?nZ
De?oZUADojYEEOnZEUH2ojYGE`05ojYHF?nZFEWoZUYJojYKFonZG5`00_nZ
GEd01OnZGUkoZUmOojYPH?nZHF7oZV9R00;oZV=S00GoZVATojYUIOnZIVKo
ZVMWojYXJ002ojYYJ@05ojYZJ_nZJf_oZVa/ojY]KOnZKVh00_nZKfl01OnZ
L73oZW5aojYbL_nZLg?oZWAd00;oZWEe00GoZWIfojYgMonZN7SoZWUiojYj
NP02ojYkN`04ojYlO?nZOGgoZWinojYoO`;oZX2000GoZX61ojZ2P_nZPh?o
ZXB4ojZ5Q@02ojZ6QP05ojZ7QonZR8SoZXV9ojZ:R_nZRh/00_nZS8`01OnZ
SHgoZXj>ojZ?SonZT93oZY6A00;oZY:B00GoZY>CojZDU?nZUIGoZYJFojZG
U`02ojZHV005ojZIVOnZVY[oZY^KojZLW?nZWId00_nZWYh01OnZWiooZZ2P
ojZQXOnZXZ;oZZ>S00;oZZBT00CoZZFUojZVY_nZYjOoZZRX0_nZZJTMoooo
oa3o1Ol0QOooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[J
f_o?cloo_Kfmoj>SX`0^onk^kP;o[00000Go[041oj`20_n/0`?o[0@4oj`5
1@02oj`61P05oj`71on/20So[0T9oj`:2_n/2`/00_n/30`01On/3@go[0h>
oj`?3on/413o[14A00;o[18B00Go[1<Coj`D5?n/5AGo[1HFoj`G5`02oj`H
6005oj`I6On/6Q[o[1/Koj`L7?n/7Ad00_n/7Qh01_n/7aoo[20Poj`Q8On/
8R;o[2<Soj`T90;o[2DU00Go[2HVoj`W9on/:2So[2TYoj`Z:P02oj`[:`05
oj`/;?n/;Bgo[2h^oj`_;on/<3000_n/<C401On/<S;o[3<coj`d=?n/=CGo
[3Hf00;o[3Lg00Go[3Phoj`i>On/>S[o[3/koj`l?002oj`m?@05oj`n?_n/
?coo[410oja1@On/@T800_n/@d<01_n/A4Co[4E5oja6A_n/AdOo[4Q8oja9
B@;o[4Y:00Go[4];oja<C?n/CDgo[4i>oja?C`02oja@D005ojaADOn/DU;o
[5=CojaDE?n/EED00_n/EUH01On/EeOo[5QHojaIFOn/FU[o[5]K00;o[5aL
00Go[5eMojaNG_n/Geoo[61PojaQH@02ojaRHP05ojaSHon/I6Co[6EUojaV
I_n/IfL00_n/J6P01_n/JFWo[6YZoja[Jon/K6co[6e]oja^KP;o[6m_00Go
[71`ojaaLOn/LW;o[7=cojadM002ojaeM@05ojafM_n/MgOo[7QhojaiNOn/
NWX00_n/Ng/01On/O7co[7emojanO_n/Ogoo[82000;o[86100Go[8:2ojb3
Pon/Q8Co[8F5ojb6QP02ojb7Q`06ojb8R?n/RHWo[8Z:ojb;Ron/S8co[8f=
0_n/SXh01On/Shoo[92@ojbATOn/TY;o[9>C00;o[9BD00Go[9FEojbFU_n/
UiOo[9RHojbIV@02ojbJVP05ojbKVon/W9co[9fMojbNW_n/Wil00_n/X:00
1On/XJ7o[::RojbSXon/Y:Co[:FU00;o[:JV00Go[:NWojbXZ?n/ZJWo[:ZZ
ojb[Z`0Monk^kQ3o3?l0QOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00
00Gof][Jom?Cdoo8b<So]kNgoifMW@0^onKViP;o[@0000Go[@41ojd20_n]
0`?o[@@4ojd51@02ojd61P06ojd71on]20So[@T9ojd:2_n]2`_o[@`<0_n]
3@d01On]3Pko[@l?ojd@4?n]4A7o[A8B00;o[A<C00Ko[A@DojdE5On]5QKo
[ALGojdH6?n]6AT2ojdJ6P05ojdK6on]71co[AdMojdN7_n]7al00_n]8200
1_n]8B7o[B8RojdS8on]92Co[BDUojdV9P;o[BLW00Go[BPXojdY:On]:R[o
[B/[ojd/;002ojd];@06ojd^;_n];boo[C0`ojda<On]<S;o[C<c0_n]=3@0
1On]=CGo[CHfojdg=on]>3So[CTi00;o[CXj00Ko[C/kojdl??n]?Cgo[Chn
ojdo?on]@402oje1@@05oje2@_n]@d?o[DA4oje5AOn]ATH00_n]AdL01_n]
B4So[DU9oje:B_n]Bd_o[Da<oje=C@;o[Di>00Go[Dm?oje@D?n]DE7o[E9B
ojeCD`02ojeDE006ojeEEOn]EUKo[EMGojeHF?n]FEWo[EYJ0_n]Fe/01On]
G5co[EeMojeNG_n]Geoo[F1P00;o[F5Q00Ko[F9RojeSHon]I6Co[FEUojeV
I_n]IfL2ojeXJ005ojeYJOn]JV[o[F][oje/K?n]KFd00_n]KVh01_n]Kfoo
[G1`ojeaLOn]LW;o[G=cojedM0;o[GEe00Go[GIfojegMon]N7So[GUiojej
NP02ojekN`06ojelO?n]OGgo[GinojeoOon]P83o[H610_n]PX801On]Ph?o
[HB4ojf5QOn]QXKo[HN700;o[HR800Ko[HV9ojf:R_n]Rh_o[Hb<ojf=SOn]
SXh2ojf?S`05ojf@T?n]TI7o[I:BojfCTon]U9@00_n]UID01_n]UYKo[ING
ojfHV?n]VIWo[IZJojfKV`;o[IbL00Go[IfMojfNW_n]Wioo[J2PojfQX@02
ojfRXP06ojfSXon]Y:Co[JFUojfVY_n]YjOo[JRX0_n]ZJT00on]ZZ[o[J^[
ojf/[00MonKViQ3o5?l0QOoVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP00
00GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kP;o[P0000Go[P41ojh20_n^
0`?o[P@4ojh51@02ojh61P06ojh71on^20So[PT9ojh:2_n^2`_o[P`<0_n^
3@d01_n^3Pko[Pl?ojh@4?n^4A7o[Q8BojhC4`;o[Q@D00Ko[QDEojhF5_n^
5aOo[QPHojhI6On^6QX2ojhK6`06ojhL7?n^7Ago[QhNojhO7on^823o[R4Q
0_n^8R801_n^8b?o[R@TojhU9On^9RKo[RLWojhX:0;o[RTY00Ko[RXZojh[
:on^;2co[Rd]ojh^;_n^;bl2ojh`<006ojha<On^<S;o[S<cojhd=?n^=CGo
[SHf0_n^=cL01_n^>3So[STiojhj>_n^>c_o[S`lojhm?@;o[Shn00Go[Slo
oji0@?n^@D7o[T92oji3@`02oji4A006oji5AOn^ATKo[TM7oji8B?n^BDWo
[TY:0_n^Bd/01_n^C4co[Te=oji>C_n^Cdoo[U1@ojiAD@;o[U9B00Ko[U=C
ojiDE?n^EEGo[UIFojiGEon^F5P2ojiIF@06ojiJF_n^Fe_o[UaLojiMGOn^
GUko[UmO0_n^H6001_n^HF7o[V9RojiSHon^I6Co[VEUojiVIP;o[VMW00Ko
[VQXojiYJOn^JV[o[V][oji/K?n^KFd2oji^KP06oji_Kon^L73o[W5aojib
L_n^Lg?o[WAd0_n^MGD01_n^MWKo[WMgojihN?n^NGWo[WYjojikN`;o[Wal
00Ko[WemojinO_n^Ogoo[X20ojj1POn^PX82ojj3P`05ojj4Q?n^QHGo[XJ6
ojj7Qon^R8P00_n^RHT01_n^RX[o[X^;ojj<S?n^SHgo[Xj>ojj?S`;o[Y2@
00Ko[Y6AojjBT_n^Ti?o[YBDojjEUOn^UYH2ojjGU`06ojjHV?n^VIWo[YZJ
ojjKVon^W9co[YfM0_n^WYh01_n^Wioo[Z2PojjQXOn^XZ;o[Z>SojjTY0;o
[ZFU00Ko[ZJVojjWYon^Z:So[ZVYojjZZ_n^Zj/2ojj/[003ojj][Oo^k^ko
k^k^01_ok^k^4?lLo`25onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q0000
1Oobl_;oj^[ZomkNg_o;bl_o[jn_02kooooo0_n_00001_n_0@7o[`82ojl3
0on_10Co[`D5ojl61P;o[`L700Ko[`P8ojl92On_2P[o[`/;ojl<3?n_3@d2
ojl>3P06ojl?3on_413o[a4AojlB4_n_4a?o[a@D0_n_5AD01on_5QKo[aLG
ojlH6?n_6AWo[aXJojlK6on_71`00_n_7Ad01_n_7Qko[alOojlP8?n_8B7o
[b8RojlS8`;o[b@T00Ko[bDUojlV9_n_9bOo[bPXojlY:On_:RX2ojl[:`07
ojl/;?n_;Bgo[bh^ojl_;on_<33o[c4aojlb<P02ojlc<`06ojld=?n_=CGo
[cHfojlg=on_>3So[cTi0_n_>SX01_n_>c_o[c`lojlm?On_?Sko[cloojm0
@0;o[d5100Oo[d92ojm3@on_A4Co[dE5ojm6A_n_AdOo[dQ800;o[dU900Ko
[dY:ojm;Bon_C4co[de=ojm>C_n_Cdl2ojm@D006ojmADOn_DU;o[e=CojmD
E?n_EEGo[eIF0_n_EeL01on_F5So[eUIojmJF_n_Fe_o[eaLojmMGOn_GUh0
0_n_Gel01_n_H63o[f5QojmRH_n_Hf?o[fATojmUI@;o[fIV00Ko[fMWojmX
J?n_JFWo[fYZojm[Jon_K6`2ojm]K@07ojm^K_n_Kfoo[g1`ojmaLOn_LW;o
[g=cojmdM002ojmeM@06ojmfM_n_MgOo[gQhojmiNOn_NW[o[g]k0_n_O7`0
1_n_OGgo[ginojmoOon_P83o[h61ojn2PP;o[h>300Oo[hB4ojn5QOn_QXKo
[hN7ojn8R?n_RHWo[hZ:00;o[h^;00Ko[hb<ojn=SOn_SXko[hn?ojn@T?n_
TI42ojnBTP06ojnCTon_U9Co[iFEojnFU_n_UiOo[iRH0_n_VIT01_n_VY[o
[i^KojnLW?n_WIgo[ijNojnOW`;o[j2P00Oo[j6QojnRX_n_Xj?o[jBTojnU
YOn_YZKo[jNW00;o[jRX00Oo[jVYojnZZ_n_Zj_o[jb/ojn][On_[Zko[jn_
01gooooo4?lSo`25ooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQ
hN7of][Jolo?conm_KgoXj>S02kok^k^0_na00001_na0@7o/@82ok430ona
10Co/@D5ok461P;o/@L700Oo/@P8ok492Ona2P[o/@/;ok4<3?na3@go/@h>
00;o/@l?00Oo/A0@ok4A4Ona4Q;o/A<Cok4D5?na5AGo/AHF00;o/ALG00Oo
/APHok4I6Ona6Q[o/A/Kok4L7?na7Ago/AhN00;o/AlO00Ko/B0Pok4Q8Ona
8R;o/B<Sok4T9?na9BD2ok4V9P07ok4W9ona:2So/BTYok4Z:_na:b_o/B`/
ok4];@02ok4^;P07ok4_;ona<33o/C4aok4b<_na<c?o/C@dok4e=@02ok4f
=P07ok4g=ona>3So/CTiok4j>_na>c_o/C`lok4m?@02ok4n?P07ok4o?ona
@43o/D51ok52@_na@d?o/DA4ok55A@02ok56AP06ok57AonaB4So/DU9ok5:
B_naBd_o/Da<0_naCDd01onaCTko/Dm?ok5@D?naDE7o/E9Bok5CDonaE5@0
0_naEED01onaEUKo/EMGok5HF?naFEWo/EYJok5KFonaG5`00_naGEd01ona
GUko/EmOok5PH?naHF7o/F9Rok5SHonaI6@00_naIFD01_naIVKo/FMWok5X
J?naJFWo/FYZok5[J`;o/Fa/00Oo/Fe]ok5^K_naKfoo/G1`ok5aLOnaLW;o
/G=c00;o/GAd00Oo/GEeok5fM_naMgOo/GQhok5iNOnaNW[o/G]k00;o/Gal
00Oo/Gemok5nO_naOgoo/H20ok61POnaPX;o/H>300;o/HB400Oo/HF5ok66
Q_naQhOo/HR8ok69ROnaRX[o/H^;00;o/Hb<00Ko/Hf=ok6>S_naShoo/I2@
ok6ATOnaTY82ok6CT`07ok6DU?naUIGo/IJFok6GUonaV9So/IVIok6JVP02
ok6KV`07ok6LW?naWIgo/IjNok6OWonaX:3o/J6Qok6RXP02ok6SX`07ok6T
Y?naYJGo/JJVok6WYonaZ:So/JVYok6ZZP02ok6[Z`05ok6/[?na[Jgo/Jj^
ok6_[ona/;007Oo^k^h@ob_o08Gok^k^00CoXj>Sokfm_Oo?cloof][J0OoQ
hN400005om[Jf_oCdm?ob<S8okNg]onMWId0;_oVi^H2ok800007ok810Onb
0P;o/P<3ok841?nb1@Go/PH6ok871`02ok882007ok892Onb2P[o/P/;ok8<
3?nb3@go/Ph>ok8?3`02ok8@4007ok8A4Onb4Q;o/Q<Cok8D5?nb5AGo/QHF
ok8G5`02ok8H6008ok8I6Onb6Q[o/Q/Kok8L7?nb7Ago/QhNok8O7onb8202
ok8Q8@07ok8R8_nb8b?o/R@Tok8U9Onb9RKo/RLWok8X:002ok8Y:@07ok8Z
:_nb:b_o/R`/ok8];Onb;Rko/Rl_ok8`<002ok8a<@08ok8b<_nb<c?o/S@d
ok8e=Onb=SKo/SLgok8h>?nb>CT2ok8j>P07ok8k>onb?3co/Sdmok8n?_nb
?coo/T10ok91@@02ok92@P07ok93@onbA4Co/TE5ok96A_nbAdOo/TQ8ok99
B@02ok9:BP08ok9;BonbC4co/Te=ok9>C_nbCdoo/U1@ok9ADOnbDU82ok9C
D`07ok9DE?nbEEGo/UIFok9GEonbF5So/UUIok9JFP02ok9KF`07ok9LG?nb
GEgo/UiNok9OGonbH63o/V5Qok9RHP02ok9SH`07ok9TI?nbIFGo/VIVok9W
IonbJ6So/VUYok9ZJP02ok9[J`08ok9/K?nbKFgo/Vi^ok9_KonbL73o/W5a
ok9bL_nbLg<2ok9dM007ok9eMOnbMWKo/WMgok9hN?nbNGWo/WYjok9kN`02
ok9lO007ok9mOOnbOWko/Wmook:0P?nbPH7o/X:2ok:3P`02ok:4Q008ok:5
QOnbQXKo/XN7ok:8R?nbRHWo/XZ:ok:;RonbS8`2ok:=S@07ok:>S_nbShoo
/Y2@ok:ATOnbTY;o/Y>Cok:DU002ok:EU@07ok:FU_nbUiOo/YRHok:IVOnb
VY[o/Y^Kok:LW002ok:MW@08ok:NW_nbWioo/Z2Pok:QXOnbXZ;o/Z>Sok:T
Y?nbYJD2ok:VYP07ok:WYonbZ:So/ZVYok:ZZ_nbZj_o/Zb/ok:][@02ok:^
[P03ok:_[onb/;3o/[6a01goi^KV4?lco`25onKViP04oifMWOng]kOob<S8
om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S02kok^k^0_nc0000
1onc0@7o/`82ok<30onc10Co/`D5ok<61_nc1`L00_nc20P02?nc2@Wo/`X:
ok<;2onc30co/`d=ok<>3_nc3`oo/a0@0_nc4A402?nc4Q;o/a<Cok<D5?nc
5AGo/aHFok<G5onc61So/aTI0_nc6QX02?nc6a_o/a`Lok<M7Onc7Qko/alO
ok<P8?nc8B7o/b8R0_nc8b<02?nc92Co/bDUok<V9_nc9bOo/bPXok<Y:Onc
:R[o/b/[0_nc;2`02?nc;Bgo/bh^ok<_;onc<33o/c4aok<b<_nc<c?o/c@d
0_nc=CD02?nc=SKo/cLgok<h>?nc>CWo/cXjok<k>onc?3co/cdm0_nc?Sh0
2?nc?coo/d10ok=1@Onc@T;o/d=3ok=4A?ncADGo/dI60_ncAdL01oncB4So
/dU9ok=:B_ncBd_o/da<ok==COncCTh00_ncCdl02?ncD53o/e5Aok=BD_nc
De?o/eADok=EEOncEUKo/eMG0_ncF5P02?ncFEWo/eYJok=KFoncG5co/eeM
ok=NG_ncGeoo/f1P0_ncHF402?ncHV;o/f=Sok=TI?ncIFGo/fIVok=WIonc
J6So/fUY0_ncJVX02?ncJf_o/fa/ok=]KOncKVko/fm_ok=`L?ncLG7o/g9b
0_ncLg<02?ncM7Co/gEeok=fM_ncMgOo/gQhok=iNOncNW[o/g]k0_ncO7`0
2?ncOGgo/ginok=oOoncP83o/h61ok>2P_ncPh?o/hB40_ncQHD02?ncQXKo
/hN7ok>8R?ncRHWo/hZ:ok>;RoncS8co/hf=0_ncSXh02?ncShoo/i2@ok>A
TOncTY;o/i>Cok>DU?ncUIGo/iJF0_ncUiL01oncV9So/iVIok>JV_ncVi_o
/ibLok>MWOncWYh00_ncWil02?ncX:3o/j6Qok>RX_ncXj?o/jBTok>UYOnc
YZKo/jNW0_ncZ:P02?ncZJWo/jZZok>[Zonc[:co/jf]ok>^[_nc[joo/k2`
0_nc/K400onc/[;ok^k^onk^kP0Konk^kQ3o>_l0QOo^k^h01?nSXj?o_Kfm
olo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`0^ooooo`;o
]@0000So]@41okD20_ne0`?o]@@4okD51One1PKo]@L7okD820;o]@T900Wo
]@X:okD;2one30co]@d=okD>3_ne3`oo]A0@okDA4One4Q800_ne4a<02?ne
51Co]ADEokDF5_ne5aOo]APHokDI6One6Q[o]A/K0_ne71`02One7Ago]AhN
okDO7one823o]B4QokDR8_ne8b?o]B@TokDU9@02okDV9P08okDW9one:2So
]BTYokDZ:_ne:b_o]B`/okD];One;Rh2okD_;`09okD`<?ne<C7o]C8bokDc
<one=3Co]CDeokDf=_ne=cOo]CPh00;o]CTi00So]CXjokDk>one?3co]Cdm
okDn?_ne?coo]D10okE1@@;o]D9200Wo]D=3okE4A?neADGo]DI6okE7Aone
B4So]DU9okE:B_neBd/00_neC4`02?neCDgo]Di>okE?ConeD53o]E5AokEB
D_neDe?o]EAD0_neEED02OneEUKo]EMGokEHF?neFEWo]EYJokEKFoneG5co
]EeMokENGP02okEOG`09okEPH?neHF7o]F9RokESHoneI6Co]FEUokEVI_ne
IfOo]FQX00;o]FUY00So]FYZokE[JoneK6co]Fe]okE^K_neKfoo]G1`okEa
L@;o]G9b00Wo]G=cokEdM?neMGGo]GIfokEgMoneN7So]GUiokEjN_neNg/0
0_neO7`02?neOGgo]GinokEoOoneP83o]H61okF2P_nePh?o]HB40_neQHD0
2OneQXKo]HN7okF8R?neRHWo]HZ:okF;RoneS8co]Hf=okF>SP02okF?S`08
okF@T?neTI7o]I:BokFCToneU9Co]IFEokFFU_neUiL2okFHV009okFIVOne
VY[o]I^KokFLW?neWIgo]IjNokFOWoneX:3o]J6Q00;o]J:R00So]J>SokFT
Y?neYJGo]JJVokFWYoneZ:So]JVYokFZZP;o]J^[00Wo]Jb/okF][One[Zko
]Jn_okF`/?ne/K7o]K:bokFc/one];@07Oooool@od;o02cooooo00?o];Bd
olo?coo?cll09oo?cll00oo5aLGo];Bdooooo`0/ooooo`04ojn_[oo;bl_o
g]kNon[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S02kok^k^0_nf
00002Onf0@7o]P82okH30onf10Co]PD5okH61_nf1`Oo]PP8okH92@02okH:
2P09okH;2onf30co]Pd=okH>3_nf3`oo]Q0@okHA4Onf4Q;o]Q<C00;o]Q@D
00Wo]QDEokHF5_nf5aOo]QPHokHI6Onf6Q[o]Q/KokHL7?nf7Ad00_nf7Qh0
2_nf7aoo]R0PokHQ8Onf8R;o]R<SokHT9?nf9BGo]RHVokHW9onf:2P2okHY
:@09okHZ:_nf:b_o]R`/okH];Onf;Rko]Rl_okH`<?nf<C7o]S8b00;o]S<c
00Wo]S@dokHe=Onf=SKo]SLgokHh>?nf>CWo]SXjokHk>onf?3`00_nf?Cd0
2_nf?Sko]SlookI0@?nf@D7o]T92okI3@onfA4Co]TE5okI6A_nfAdL2okI8
B009okI9BOnfBT[o]T];okI<C?nfCDgo]Ti>okI?ConfD53o]U5A00;o]U9B
00Wo]U=CokIDE?nfEEGo]UIFokIGEonfF5So]UUIokIJF_nfFe/00_nfG5`0
2_nfGEgo]UiNokIOGonfH63o]V5QokIRH_nfHf?o]VATokIUIOnfIVH2okIW
I`09okIXJ?nfJFWo]VYZokI[JonfK6co]Ve]okI^K_nfKfoo]W1`00;o]W5a
00Wo]W9bokIcLonfM7Co]WEeokIfM_nfMgOo]WQhokIiNOnfNWX00_nfNg/0
2_nfO7co]WemokInO_nfOgoo]X20okJ1POnfPX;o]X>3okJ4Q?nfQHD2okJ6
QP09okJ7QonfR8So]XV9okJ:R_nfRh_o]Xb<okJ=SOnfSXko]Xn?00;o]Y2@
00Wo]Y6AokJBT_nfTi?o]YBDokJEUOnfUYKo]YNGokJHV?nfVIT00_nfVYX0
2_nfVi_o]YbLokJMWOnfWYko]YnOokJPX?nfXJ7o]Z:RokJSXonfY:@2okJU
Y@09okJVY_nfYjOo]ZRXokJYZOnfZZ[o]Z^[okJ/[?nf[Jgo]Zj^00;o]Zn_
00Ko][2`okJa/Onf/[;o][>cokJd]?nf]KDMonk^kQ3oBOl03_o^k^h01?o]
kNgojNWYon;Rh_oNg]h2om[JfP04omkNg_oQhN7oj>SXong]kACok^k^00?o
^KViomgMgOo/k>`01?o/k>`Nonk^kPGok>c/00?ogMgMokVi^Oo^k^h0;?o^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNg
oifMW@0^onKViP;o]`0000[o]`41okL20_ng0`?o]`@4okL51Ong1PKo]`L7
okL82?ng2@Wo]`X:0_ng2`/02_ng30co]`d=okL>3_ng3`oo]a0@okLA4Ong
4Q;o]a<CokLD5?ng5AD2okLF5P0:okLG5ong61So]aTIokLJ6_ng6a_o]a`L
okLM7Ong7Qko]alOokLP80;o]b4Q00[o]b8RokLS8ong92Co]bDUokLV9_ng
9bOo]bPXokLY:Ong:R[o]b/[0_ng;2`02_ng;Bgo]bh^okL_;ong<33o]c4a
okLb<_ng<c?o]c@dokLe=Ong=SH2okLg=`0;okLh>?ng>CWo]cXjokLk>ong
?3co]cdmokLn?_ng?coo]d10okM1@Ong@T800_ng@d<02_ngA4Co]dE5okM6
A_ngAdOo]dQ8okM9BOngBT[o]d];okM<C?ngCDd2okM>CP0:okM?CongD53o
]e5AokMBD_ngDe?o]eADokMEEOngEUKo]eMGokMHF0;o]eUI00[o]eYJokMK
FongG5co]eeMokMNG_ngGeoo]f1PokMQHOngHV;o]f=S0_ngI6@02_ngIFGo
]fIVokMWIongJ6So]fUYokMZJ_ngJf_o]fa/okM]KOngKVh2okM_K`0;okM`
L?ngLG7o]g9bokMcLongM7Co]gEeokMfM_ngMgOo]gQhokMiNOngNWX00_ng
Ng/02_ngO7co]gemokMnO_ngOgoo]h20okN1POngPX;o]h>3okN4Q?ngQHD2
okN6QP0:okN7QongR8So]hV9okN:R_ngRh_o]hb<okN=SOngSXko]hn?okN@
T0;o]i6A00[o]i:BokNCTongU9Co]iFEokNFU_ngUiOo]iRHokNIVOngVY[o
]i^K0_ngW9`02_ngWIgo]ijNokNOWongX:3o]j6QokNRX_ngXj?o]jBTokNU
YOngYZH2okNWY`0;okNXZ?ngZJWo]jZZokN[Zong[:co]jf]okN^[_ng[joo
]k2`okNa/Ong/[800_ng/k<00ong];Co]kFeokNf]P0MonKViQ3oDOl03?oV
i^H03_oUiNGohn?SomcLg?o;bl_o]kNgojFUYOnKVi_oVYZJoj:RX_nd];Co
b<S8om[Jf_oShn?oiNGU4_oVi^H00oni^KWohn?SooGem@04ooOgmakon_[j
1OogmoL00ooShn?o^KVionKViP0/onKViP04oifMWOng]kOob<S8om?Cd`7o
f][J00001OoQhN7of][Jolo?conm_KgoXj>S02kok^k^0_nh00002onh0@7o
^082okP30onh10Co^0D5okP61_nh1`Oo^0P8okP92Onh2P[o^0/;00;o^0`<
00_o^0d=okP>3_nh3`oo^10@okPA4Onh4Q;o^1<CokPD5?nh5AGo^1HFokPG
5`02okPH600;okPI6Onh6Q[o^1/KokPL7?nh7Ago^1hNokPO7onh823o^24Q
okPR8_nh8b<00_nh92@02onh9BGo^2HVokPW9onh:2So^2TYokPZ:_nh:b_o
^2`/okP];Onh;Rko^2l_00;o^30`00co^34aokPb<_nh<c?o^3@dokPe=Onh
=SKo^3LgokPh>?nh>CWo^3XjokPk>onh?3`2okPm?@0;okPn?_nh?coo^410
okQ1@Onh@T;o^4=3okQ4A?nhADGo^4I6okQ7AonhB4P00_nhBDT02onhBT[o
^4];okQ<C?nhCDgo^4i>okQ?ConhD53o^55AokQBD_nhDe?o^5AD00;o^5EE
00_o^5IFokQGEonhF5So^5UIokQJF_nhFe_o^5aLokQMGOnhGUko^5mOokQP
H002okQQH@0<okQRH_nhHf?o^6ATokQUIOnhIVKo^6MWokQXJ?nhJFWo^6YZ
okQ[JonhK6co^6e]0_nhKVh02onhKfoo^71`okQaLOnhLW;o^7=cokQdM?nh
MGGo^7IfokQgMonhN7So^7Ui00;o^7Yj00_o^7]kokQlO?nhOGgo^7inokQo
OonhP83o^861okR2P_nhPh?o^8B4okR5Q@02okR6QP0;okR7QonhR8So^8V9
okR:R_nhRh_o^8b<okR=SOnhSXko^8n?okR@T?nhTI400_nhTY802onhTi?o
^9BDokREUOnhUYKo^9NGokRHV?nhVIWo^9ZJokRKVonhW9co^9fM00;o^9jN
00co^9nOokRPX?nhXJ7o^::RokRSXonhY:Co^:FUokRVY_nhYjOo^:RXokRY
ZOnhZZX2okR[Z`0;okR/[?nh[Jgo^:j^okR_[onh/;3o^;6aokRb/_nh/k?o
^;BdokRe]Onh][H00_nh]kLMonk^kQ3oFOl02oo^k^h04?o]kNgojn_[on3P
h?o6a/KoXZ:Roh:2P_m^KVkoHf=Sof9RH_m[Jf_oOWinoifMWOo2`/;ogmoO
on_[joo]kNdAonk^kP03okVi^OoShn?omOGe02Kooooo00?omoOgon?Shoni
^KT0;Oo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oN
g]kobl_;ojn_[`0^ooooo`;o^P0000co^P41okX20_nj0`?o^P@4okX51Onj
1PKo^PL7okX82?nj2@Wo^PX:okX;2onj30`2okX=3@0<okX>3_nj3`oo^Q0@
okXA4Onj4Q;o^Q<CokXD5?nj5AGo^QHFokXG5onj61So^QTI0_nj6QX03Onj
6a_o^Q`LokXM7Onj7Qko^QlOokXP8?nj8B7o^R8RokXS8onj92Co^RDUokXV
9_nj9bL00_nj:2P03?nj:BWo^RXZokX[:onj;2co^Rd]okX^;_nj;boo^S0`
okXa<Onj<S;o^S<cokXd=0;o^SDe00go^SHfokXg=onj>3So^STiokXj>_nj
>c_o^S`lokXm?Onj?Sko^SlookY0@?nj@D7o^T9200;o^T=300co^TA4okY5
AOnjATKo^TM7okY8B?njBDWo^TY:okY;BonjC4co^Te=okY>C_njCdl2okY@
D00=okYADOnjDU;o^U=CokYDE?njEEGo^UIFokYGEonjF5So^UUIokYJF_nj
Fe_o^UaLokYMG@02okYNGP0<okYOGonjH63o^V5QokYRH_njHf?o^VATokYU
IOnjIVKo^VMWokYXJ?njJFWo^VYZ0_njJf/03?njK6co^Ve]okY^K_njKfoo
^W1`okYaLOnjLW;o^W=cokYdM?njMGGo^WIfokYgM`;o^WQh00go^WUiokYj
N_njNg_o^WalokYmOOnjOWko^WmookZ0P?njPH7o^X:2okZ3PonjQ8Co^XF5
00;o^XJ600co^XN7okZ8R?njRHWo^XZ:okZ;RonjS8co^Xf=okZ>S_njShoo
^Y2@okZATOnjTY82okZCT`0=okZDU?njUIGo^YJFokZGUonjV9So^YVIokZJ
V_njVi_o^YbLokZMWOnjWYko^YnOokZPX002okZQX@0<okZRX_njXj?o^ZBT
okZUYOnjYZKo^ZNWokZXZ?njZJWo^ZZZokZ[Zonj[:co^Zf]0_nj[Zh02onj
[joo^[2`okZa/Onj/[;o^[>cokZd]?nj]KGo^[JfokZg]onj^;So^[Vi01go
oooo4?mPo`0;ooooo`0@ookno_odm?CoeMGEojJVY_mhN7SoNg]koifMWOnj
^[[o_[jnoj2PX?n0P83oM7AdoinOWoo@d=3olO7aoogmoA7ooooo00?o^KVi
on?ShooemOD01Oooool00ooWinOol_;booooo`05ooooo`03onOWioobl_;o
oooo01Kooooo00?omoOgon?Shoni^KT0;Oooool01?n_[joobl_;omkNg_oZ
j^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kP;o^`0000go
^`41ok/20_nk0`?o^`@4ok/51Onk1PKo^`L7ok/82?nk2@Wo^`X:ok/;2onk
30co^`d=00;o^`h>00ko^`l?ok/@4?nk4A7o^a8Bok/C4onk51Co^aDEok/F
5_nk5aOo^aPHok/I6Onk6Q[o^a/Kok/L70;o^adM00ko^ahNok/O7onk823o
^b4Qok/R8_nk8b?o^b@Tok/U9Onk9RKo^bLWok/X:?nk:BWo^bXZok/[:`;o
^b`/00ko^bd]ok/^;_nk;boo^c0`ok/a<Onk<S;o^c<cok/d=?nk=CGo^cHf
ok/g=onk>3So^cTiok/j>P;o^c/k00ko^c`lok/m?Onk?Sko^clook]0@?nk
@D7o^d92ok]3@onkA4Co^dE5ok]6A_nkAdOo^dQ8ok]9B@;o^dY:00ko^d];
ok]<C?nkCDgo^di>ok]?ConkD53o^e5Aok]BD_nkDe?o^eADok]EEOnkEUKo
^eMGok]HF0;o^eUI00ko^eYJok]KFonkG5co^eeMok]NG_nkGeoo^f1Pok]Q
HOnkHV;o^f=Sok]TI?nkIFGo^fIVok]WI`;o^fQX00ko^fUYok]ZJ_nkJf_o
^fa/ok]]KOnkKVko^fm_ok]`L?nkLG7o^g9bok]cLonkM7Co^gEeok]fMP;o
^gMg00ko^gQhok]iNOnkNW[o^g]kok]lO?nkOGgo^ginok]oOonkP83o^h61
ok^2P_nkPh?o^hB4ok^5Q@;o^hJ600ko^hN7ok^8R?nkRHWo^hZ:ok^;Ronk
S8co^hf=ok^>S_nkShoo^i2@ok^ATOnkTY;o^i>Cok^DU0;o^iFE00go^iJF
ok^GUonkV9So^iVIok^JV_nkVi_o^ibLok^MWOnkWYko^inOok^PX?nkXJ7o
^j:R00;o^j>S00ko^jBTok^UYOnkYZKo^jNWok^XZ?nkZJWo^jZZok^[Zonk
[:co^jf]ok^^[_nk[joo^k2`ok^a/@;o^k:b00So^k>cok^d]?nk]KGo^kJf
ok^g]onk^;So^kViok^j^Qgok^k^4?mXo`0:onk^kP08ong]kOoYjNWoeMGE
ojJVY_mgMgOoXZ:Rong]kOono_h3ooooo`07oo?clon/[:coMWIfoijNW_o@
d=3oinOWong]k@05onk^kP06oc8b<_l0003o0000o`l?3om1@D7od];B1Oo^
k^h00oni^KWohn?SooGem@03ooooo`06om;Bd_lh>3So<S8boc<c<om=CDgo
hN7Q0_ooool01_oBd];o>3Phoc8b<_lc<c?oCDe=on7QhAGooooo00?omoOg
on?Shoni^KT0;Oo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][J
om?Cdoo8b<So]kNgoifMW@0^onKViP;o_00000oo_041ok`20_nl0`?o_0@4
ok`51Onl1PKo_0L7ok`82?nl2@Wo_0X:ok`;2onl30co_0d=ok`>3_nl3`l0
0_nl41004?nl4A7o_18Bok`C4onl51Co_1DEok`F5_nl5aOo_1PHok`I6Onl
6Q[o_1/Kok`L7?nl7Ago_1hNok`O7onl8202ok`Q8@0@ok`R8_nl8b?o_2@T
ok`U9Onl9RKo_2LWok`X:?nl:BWo_2XZok`[:onl;2co_2d]ok`^;_nl;boo
_30`ok`a<@;o_38b00oo_3<cok`d=?nl=CGo_3Hfok`g=onl>3So_3Tiok`j
>_nl>c_o_3`lok`m?Onl?Sko_3looka0@?nl@D400_nl@T804?nl@d?o_4A4
oka5AOnlATKo_4M7oka8B?nlBDWo_4Y:oka;BonlC4co_4e=oka>C_nlCdoo
_51@okaADOnlDU82okaCD`0@okaDE?nlEEGo_5IFokaGEonlF5So_5UIokaJ
F_nlFe_o_5aLokaMGOnlGUko_5mOokaPH?nlHF7o_69RokaSH`;o_6AT00oo
_6EUokaVI_nlIfOo_6QXokaYJOnlJV[o_6][oka/K?nlKFgo_6i^oka_Konl
L73o_75aokabL_nlLg<00_nlM7@04?nlMGGo_7IfokagMonlN7So_7Uiokaj
N_nlNg_o_7alokamOOnlOWko_7mookb0P?nlPH7o_8:2okb3PonlQ8@2okb5
Q@0@okb6Q_nlQhOo_8R8okb9ROnlRX[o_8^;okb<S?nlSHgo_8j>okb?Sonl
T93o_96AokbBT_nlTi?o_9BDokbEU@;o_9JF00oo_9NGokbHV?nlVIWo_9ZJ
okbKVonlW9co_9fMokbNW_nlWioo_:2PokbQXOnlXZ;o_:>SokbTY?nlYJD0
0_nlYZH04?nlYjOo_:RXokbYZOnlZZ[o_:^[okb/[?nl[Jgo_:j^okb_[onl
/;3o_;6aokbb/_nl/k?o_;Bdokbe]Onl][H2okbg]`04okbh^?nl^KWo_;Zj
okbk^agoi^KV4?m`o`0:onKViP07onGUiOoLg=co_[jnoh:2P_nVYZKok^k^
oo_kn`02ooknoP09oogmoOono_kon?Shoo3`l?n`/;3oOWinokRh^?oIfMWo
i>CT00Goi^KV00Ko<30`of][JooQhN7o`<30ob@T9?mBDU85onKViP03okVi
^OoShn?omOGe00?ooooo00KoE5ADogQhN?ooooooooooof5QHOmFEUH2oooo
o`06oeADE?mhN7SooooooooooomQHF7oEUIF5Oooool00oogmoOohn?SokVi
^@0]onKViP04oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?
conm_KgoXj>S02kok^k^0_nm00004Onm0@7o_@82okd30onm10Co_@D5okd6
1_nm1`Oo_@P8okd92Onm2P[o_@/;okd<3?nm3@go_@h>okd?3onm413o_A4A
00;o_A8B01;o_A<CokdD5?nm5AGo_AHFokdG5onm61So_ATIokdJ6_nm6a_o
_A`LokdM7Onm7Qko_AlOokdP8?nm8B7o_B8RokdS8onm92@2okdU9@0BokdV
9_nm9bOo_BPXokdY:Onm:R[o_B/[okd/;?nm;Bgo_Bh^okd_;onm<33o_C4a
okdb<_nm<c?o_C@dokde=Onm=SKo_CLg0_nm>3P04_nm>CWo_CXjokdk>onm
?3co_Cdmokdn?_nm?coo_D10oke1@Onm@T;o_D=3oke4A?nmADGo_DI6oke7
AonmB4So_DU9oke:BP;o_D];01;o_Da<oke=COnmCTko_Dm?oke@D?nmDE7o
_E9BokeCDonmE5Co_EEEokeFE_nmEeOo_EQHokeIFOnmFU[o_E]KokeLG?nm
GEd2okeNGP0BokeOGonmH63o_F5QokeRH_nmHf?o_FATokeUIOnmIVKo_FMW
okeXJ?nmJFWo_FYZoke[JonmK6co_Fe]oke^K_nmKfoo_G1`0_nmLG404_nm
LW;o_G=cokedM?nmMGGo_GIfokegMonmN7So_GUiokejN_nmNg_o_Galokem
OOnmOWko_Gmookf0P?nmPH7o_H:2okf3P`;o_HB401;o_HF5okf6Q_nmQhOo
_HR8okf9ROnmRX[o_H^;okf<S?nmSHgo_Hj>okf?SonmT93o_I6AokfBT_nm
Ti?o_IBDokfEUOnmUYH2okfGU`0BokfHV?nmVIWo_IZJokfKVonmW9co_IfM
okfNW_nmWioo_J2PokfQXOnmXZ;o_J>SokfTY?nmYJGo_JJVokfWYonmZ:So
_JVY0_nmZZX04onmZj_o_Jb/okf][Onm[Zko_Jn_okf`/?nm/K7o_K:bokfc
/onm];Co_KFeokff]_nm]kOo_KRhokfi^Onm^[[o_K^kokfl_?nm_Kd07Oo^
k^h@ogOo00[ok^k^01;ok>c/on3Ph?n`/;3oSXj>om[Jf_o[jn_olo?coo[j
n_ooooooo?clooOgmooalO7oj>SXom_KfonDU9CoYZJVomkNg_o[jn/5onk^
kP06oc8b<_m_Kfook^k^onk^k_mTI6Co9RHV1Oo^k^h00oni^KWohn?Soo[j
nP03ooooo`06obLW9onj^[[ooooooooooommOGgoADE50_ooool01_lW9bOo
^[ZjooooooooooooOGemodE5AAGooooo00?on_[jon?Shoni^KT0;Oo^k^h0
1?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_
[`0^ooooo`;o_`0001Co_`41okl20_no0`?o_`@4okl51Ono1PKo_`L7okl8
2?no2@Wo_`X:okl;2ono30co_`d=okl>3_no3`oo_a0@oklA4Ono4Q;o_a<C
oklD50;o_aDE01Go_aHFoklG5ono61So_aTIoklJ6_no6a_o_a`LoklM7Ono
7Qko_alOoklP8?no8B7o_b8RoklS8ono92Co_bDUoklV9_no9bOo_bPXoklY
:Ono:RX00_no:b/05Ono;2co_bd]okl^;_no;boo_c0`okla<Ono<S;o_c<c
okld=?no=CGo_cHfoklg=ono>3So_cTioklj>_no>c_o_c`loklm?Ono?Sko
_clookm0@002okm1@@0Eokm2@_no@d?o_dA4okm5AOnoATKo_dM7okm8B?no
BDWo_dY:okm;BonoC4co_de=okm>C_noCdoo_e1@okmADOnoDU;o_e=CokmD
E?noEEGo_eIF00;o_eMG01Go_eQHokmIFOnoFU[o_e]KokmLG?noGEgo_eiN
okmOGonoH63o_f5QokmRH_noHf?o_fATokmUIOnoIVKo_fMWokmXJ?noJFWo
_fYZokm[JonoK6`00_noKFd05OnoKVko_fm_okm`L?noLG7o_g9bokmcLono
M7Co_gEeokmfM_noMgOo_gQhokmiNOnoNW[o_g]kokmlO?noOGgo_ginokmo
OonoP83o_h61okn2PP02okn3P`0Eokn4Q?noQHGo_hJ6okn7QonoR8So_hV9
okn:R_noRh_o_hb<okn=SOnoSXko_hn?okn@T?noTI7o_i:BoknCTonoU9Co
_iFEoknFU_noUiOo_iRH00;o_iVI01Co_iZJoknKVonoW9co_ifMoknNW_no
Wioo_j2PoknQXOnoXZ;o_j>SoknTY?noYJGo_jJVoknWYonoZ:So_jVYoknZ
Z_noZj_o_jb/okn][@;o_jj^013o_jn_okn`/?no/K7o_k:boknc/ono];Co
_kFeoknf]_no]kOo_kRhokni^Ono^[[o_k^koknl_?no_Kgo_kjn7Oooool@
ogoo00[ooooo01;ono_koo?clon[Zj_o/;2`om[Jf_oRh^;ojn_[ono_koob
l_;ol?3`ong]kOoZj^[ohN7QomSHf?ne]KGoX:2Poo3`l?okno/5ooooo`06
ocHf=_mgMgOoooooonGUiOl>3PkoOWin1Oooool00oni^KWohn?Soo[jnP03
ooooo`06ohN7QomGEeOono_koh^;Rol71`OoZj^[0_ooool01_n7QhOoEeMG
oo_knon;Rh_o1`L7oj^[ZaGooooo00?on_[jon?Shoni^KT0;Oooool01?n_
[joobl_;omkNg_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^
onk^kP;o`00001So`041ol020_o00`?o`0@4ol051Oo01PKo`0L7ol082?o0
2@Wo`0X:ol0;2oo030co`0d=ol0>3_o03`oo`10@ol0A4Oo04Q;o`1<Col0D
5?o05AGo`1HFol0G5oo061P2ol0I6@0Iol0J6_o06a_o`1`Lol0M7Oo07Qko
`1lOol0P8?o08B7o`28Rol0S8oo092Co`2DUol0V9_o09bOo`2PXol0Y:Oo0
:R[o`2/[ol0/;?o0;Bgo`2h^ol0_;oo0<33o`34aol0b<P02ol0c<`0Iol0d
=?o0=CGo`3Hfol0g=oo0>3So`3Tiol0j>_o0>c_o`3`lol0m?Oo0?Sko`3lo
ol10@?o0@D7o`492ol13@oo0A4Co`4E5ol16A_o0AdOo`4Q8ol19BOo0BT[o
`4];ol1<C002ol1=C@0Iol1>C_o0Cdoo`51@ol1ADOo0DU;o`5=Col1DE?o0
EEGo`5IFol1GEoo0F5So`5UIol1JF_o0Fe_o`5aLol1MGOo0GUko`5mOol1P
H?o0HF7o`69Rol1SHoo0I6Co`6EUol1VIP02ol1WI`0Hol1XJ?o0JFWo`6YZ
ol1[Joo0K6co`6e]ol1^K_o0Kfoo`71`ol1aLOo0LW;o`7=col1dM?o0MGGo
`7Ifol1gMoo0N7So`7Uiol1jN_o0Ng_o`7alol1mOOo0OWko`7mo0_o0P800
6Oo0PH7o`8:2ol23Poo0Q8Co`8F5ol26Q_o0QhOo`8R8ol29ROo0RX[o`8^;
ol2<S?o0SHgo`8j>ol2?Soo0T93o`96Aol2BT_o0Ti?o`9BDol2EUOo0UYKo
`9NGol2HV?o0VIT00_o0VYX06Oo0Vi_o`9bLol2MWOo0WYko`9nOol2PX?o0
XJ7o`::Rol2SXoo0Y:Co`:FUol2VY_o0YjOo`:RXol2YZOo0ZZ[o`:^[ol2/
[?o0[Jgo`:j^ol2_[oo0/;3o`;6aol2b/_o0/k<00_o0];@02oo0]KGo`;Jf
ol2g]oo0^;So`;Viol2j^_o0^k_o`;blol2m_Oo0_[ko`;no01gok^k^4?n7
o`0:onk^kP08onWYjOoVi^KoVYZJokNg]oo>c/kof=SHon3Ph?oQhN42onCT
i008on?ShooNg]kofMWIol_;bonh^;SoT92@on;Rh_oYjNT5onk^kP06oc8b
<_l^;Rko>SXjoa@D5?n>SXkok>c/1Oo^k^h00oni^KWohn?Soo[jnP04oooo
o`04ofe]KOlF5QKo0`<3okRh^0Cooooo00CoKFe]oaHF5_l30`?o^;Rh5_oo
ool00oojn_[ohn?SokVi^@0]onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q
00001OoJf][odm?ColS8b?ng]kOoWIfM02koi^KV0_o100007_o10@7o`@82
ol430oo110Co`@D5ol461_o11`Oo`@P8ol492Oo12P[o`@/;ol4<3?o13@go
`@h>ol4?3oo1413o`A4Aol4B4_o14a?o`A@Dol4E5Oo15QKo`ALGol4H6?o1
6AWo`AXJol4K6oo171co`AdMol4N7P;o`AlO01ko`B0Pol4Q8Oo18R;o`B<S
ol4T9?o19BGo`BHVol4W9oo1:2So`BTYol4Z:_o1:b_o`B`/ol4];Oo1;Rko
`Bl_ol4`<?o1<C7o`C8bol4c<oo1=3Co`CDeol4f=_o1=cOo`CPhol4i>Oo1
>S[o`C/kol4l??o1?Cd2ol4n?P0Nol4o?oo1@43o`D51ol52@_o1@d?o`DA4
ol55AOo1ATKo`DM7ol58B?o1BDWo`DY:ol5;Boo1C4co`De=ol5>C_o1Cdoo
`E1@ol5ADOo1DU;o`E=Col5DE?o1EEGo`EIFol5GEoo1F5So`EUIol5JF_o1
Fe_o`EaL0_o1GEd07oo1GUko`EmOol5PH?o1HF7o`F9Rol5SHoo1I6Co`FEU
ol5VI_o1IfOo`FQXol5YJOo1JV[o`F][ol5/K?o1KFgo`Fi^ol5_Koo1L73o
`G5aol5bL_o1Lg?o`GAdol5eMOo1MWKo`GMgol5hN?o1NGWo`GYjol5kNoo1
O7`00_o1OGd07_o1OWko`Gmool60P?o1PH7o`H:2ol63Poo1Q8Co`HF5ol66
Q_o1QhOo`HR8ol69ROo1RX[o`H^;ol6<S?o1SHgo`Hj>ol6?Soo1T93o`I6A
ol6BT_o1Ti?o`IBDol6EUOo1UYKo`INGol6HV?o1VIWo`IZJol6KV`;o`IbL
01ko`IfMol6NW_o1Wioo`J2Pol6QXOo1XZ;o`J>Sol6TY?o1YJGo`JJVol6W
Yoo1Z:So`JVYol6ZZ_o1Zj_o`Jb/ol6][Oo1[Zko`Jn_ol6`/?o1/K7o`K:b
ol6c/oo1];Co`KFeol6f]_o1]kOo`KRhol6i^Oo1^[X2ol6k^`05ol6l_?o1
_Kgo`Kjnol6o_oo1`<007OoVi^H@ohko00[oi^KV01;oh>3PonGUiOnDU9Co
];Bdol;2`_o<c<cod];Bom?CdooEeMGoe=CDom;Bd_o?cloocLg=ol30`?nc
/k?oQhN7onCTi?oQhN45onKViP06oc0`<?m>CTkoQHF5ocTi>Om]KFgoh^;R
1OoVi^H00oni^KWohn?Soo[jnP03ooooo`06on3Ph?lI6AWoIVIVoinOWomB
DU;onOWi0_ooool01_oPh>3o6ATIofIVI_nOWiooDU9BooWinAGooooo00?o
n_[jon?Shoni^KT0;OoVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000Go
hN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kP;o``0002Ko``41ol<20_o30`?o
``@4ol<51Oo31PKo``L7ol<82?o32@Wo``X:ol<;2oo330co``d=ol<>3_o3
3`oo`a0@ol<A4Oo34Q;o`a<Col<D5?o35AGo`aHFol<G5oo361So`aTIol<J
6_o36a_o`a`Lol<M7Oo37Qko`alOol<P8?o38B7o`b8Rol<S8oo392Co`bDU
ol<V9P;o`bLW02Oo`bPXol<Y:Oo3:R[o`b/[ol</;?o3;Bgo`bh^ol<_;oo3
<33o`c4aol<b<_o3<c?o`c@dol<e=Oo3=SKo`cLgol<h>?o3>CWo`cXjol<k
>oo3?3co`cdmol<n?_o3?coo`d10ol=1@Oo3@T;o`d=3ol=4A?o3ADGo`dI6
ol=7Aoo3B4So`dU9ol=:B_o3Bd_o`da<ol==COo3CTh00_o3Cdl09_o3D53o
`e5Aol=BD_o3De?o`eADol=EEOo3EUKo`eMGol=HF?o3FEWo`eYJol=KFoo3
G5co`eeMol=NG_o3Geoo`f1Pol=QHOo3HV;o`f=Sol=TI?o3IFGo`fIVol=W
Ioo3J6So`fUYol=ZJ_o3Jf_o`fa/ol=]KOo3KVko`fm_ol=`L?o3LG7o`g9b
ol=cLoo3M7Co`gEe0_o3MWH09oo3MgOo`gQhol=iNOo3NW[o`g]kol=lO?o3
OGgo`ginol=oOoo3P83o`h61ol>2P_o3Ph?o`hB4ol>5QOo3QXKo`hN7ol>8
R?o3RHWo`hZ:ol>;Roo3S8co`hf=ol>>S_o3Shoo`i2@ol>ATOo3TY;o`i>C
ol>DU?o3UIGo`iJFol>GUoo3V9So`iVIol>JV_o3Vi_o`ibLol>MW@02ol>N
WP0Tol>OWoo3X:3o`j6Qol>RX_o3Xj?o`jBTol>UYOo3YZKo`jNWol>XZ?o3
ZJWo`jZZol>[Zoo3[:co`jf]ol>^[_o3[joo`k2`ol>a/Oo3/[;o`k>col>d
]?o3]KGo`kJfol>g]oo3^;So`kViol>j^_o3^k_o`kblol>m_Oo3_[ko`kno
ol?0`?o3`L7o`l;27Oo^k^h@oiKo00[ok^k^01;oinOWonk^k_nRXZ;oVi^K
ok6a/Onm_Kgo`l?3olC4a?o3`l?o`L71ol;2`_o1`L7o_Kfmok2`/?nHV9So
TI6Aonk^k_oYjNT5onk^kP06oc8b<_m_Kfook^k^omcLg?l92@WoZ:RX1Oo^
k^h00oni^KWohn?Soo[jnP03ooooo`06oi:BT_m;Bd_ooooooooooomADE7o
[Zj^0_ooool01_nBTY;oBd];ooooooooooooDE5Aojj^[QGooooo00?on_[j
on?Shoni^KT0;Oo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;b
on[Zj_oNg]kobl_;ojn_[`0^ooooo`;oa00003Coa041ol@20_o40`?oa0@4
ol@51Oo41PKoa0L7ol@82?o42@Woa0X:ol@;2oo430coa0d=ol@>3_o43`oo
a10@ol@A4Oo44Q;oa1<Col@D5?o45AGoa1HFol@G5oo461Soa1TIol@J6_o4
6a_oa1`Lol@M7Oo47Qkoa1lOol@P8?o48B7oa28Rol@S8oo492Coa2DUol@V
9_o49bOoa2PXol@Y:Oo4:R[oa2/[ol@/;?o4;Bgoa2h^ol@_;oo4<33oa34a
ol@b<_o4<c?oa3@d0_o4=CD0=Oo4=SKoa3Lgol@h>?o4>CWoa3Xjol@k>oo4
?3coa3dmol@n?_o4?cooa410olA1@Oo4@T;oa4=3olA4A?o4ADGoa4I6olA7
Aoo4B4Soa4U9olA:B_o4Bd_oa4a<olA=COo4CTkoa4m?olA@D?o4DE7oa59B
olACDoo4E5Coa5EEolAFE_o4EeOoa5QHolAIFOo4FU[oa5]KolALG?o4GEgo
a5iNolAOGoo4H63oa65QolARH_o4Hf?oa6ATolAUIOo4IVKoa6MWolAXJ?o4
JFWoa6YZ00;oa6][03Goa6a/olA]KOo4KVkoa6m_olA`L?o4LG7oa79bolAc
Loo4M7Coa7EeolAfM_o4MgOoa7QholAiNOo4NW[oa7]kolAlO?o4OGgoa7in
olAoOoo4P83oa861olB2P_o4Ph?oa8B4olB5QOo4QXKoa8N7olB8R?o4RHWo
a8Z:olB;Roo4S8coa8f=olB>S_o4Shooa92@olBATOo4TY;oa9>ColBDU?o4
UIGoa9JFolBGUoo4V9Soa9VIolBJV_o4Vi_oa9bLolBMWOo4WYkoa9nOolBP
X002olBQX@0RolBRX_o4Xj?oa:BTolBUYOo4YZKoa:NWolBXZ?o4ZJWoa:ZZ
olB[Zoo4[:coa:f]olB^[_o4[jooa;2`olBa/Oo4/[;oa;>colBd]?o4]KGo
a;JfolBg]oo4^;Soa;ViolBj^_o4^k_oa;blolBm_Oo4_[koa;noolC0`?o4
`L7oa<;2olC3`agooooo4?nNo`0:ooooo`07oo[jn_oooooob<S8ohR8R?nK
Vi_o/;2`okbl_002ol30`009ol71`Ono_koo^k^kok:b/_nJVY[oOgmookFe
]Ooooooono_k00Gooooo00Ko=SHfogMgMoooooooj>SXo`X:2_n@T905oooo
o`03okVi^OoShn?omOGe00?ooooo00KofMWIobd];OoPh>3ogMgMobDU9Onn
_[h2ooooo`06omWIfOl];Bgoh>3PomgMgOlU9BGo_[jn5Oooool00oogmoOo
hn?SokVi^@0]ooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQhN7o
f][Jolo?conm_KgoXj>S02kok^k^0_o50000D_o50@7oa@82olD30oo510Co
a@D5olD61_o51`Ooa@P8olD92Oo52P[oa@/;olD<3?o53@goa@h>olD?3oo5
413oaA4AolDB4_o54a?oaA@DolDE5Oo55QKoaALGolDH6?o56AWoaAXJolDK
6oo571coaAdMolDN7_o57aooaB0PolDQ8Oo58R;oaB<SolDT9?o59BGoaBHV
olDW9oo5:2SoaBTYolDZ:_o5:b_oaB`/olD];Oo5;RkoaBl_olD`<?o5<C7o
aC8bolDc<oo5=3CoaCDeolDf=_o5=cOoaCPholDi>Oo5>S[oaC/kolDl??o5
?CgoaChnolDo?oo5@43oaD51olE2@_o5@d?oaDA4olE5AOo5ATKoaDM7olE8
B?o5BDWoaDY:olE;Boo5C4coaDe=olE>C_o5CdooaE1@olEADOo5DU82olEC
D`1BolEDE?o5EEGoaEIFolEGEoo5F5SoaEUIolEJF_o5Fe_oaEaLolEMGOo5
GUkoaEmOolEPH?o5HF7oaF9RolESHoo5I6CoaFEUolEVI_o5IfOoaFQXolEY
JOo5JV[oaF][olE/K?o5KFgoaFi^olE_Koo5L73oaG5aolEbL_o5Lg?oaGAd
olEeMOo5MWKoaGMgolEhN?o5NGWoaGYjolEkNoo5O7coaGemolEnO_o5Ogoo
aH20olF1POo5PX;oaH>3olF4Q?o5QHGoaHJ6olF7Qoo5R8SoaHV9olF:R_o5
Rh_oaHb<olF=SOo5SXkoaHn?olF@T?o5TI7oaI:BolFCToo5U9CoaIFEolFF
U_o5UiOoaIRHolFIVOo5VY[oaI^KolFLW?o5WIgoaIjNolFOWoo5X:3oaJ6Q
olFRX_o5Xj?oaJBTolFUY@;oaJJV01koaJNWolFXZ?o5ZJWoaJZZolF[Zoo5
[:coaJf]olF^[_o5[jooaK2`olFa/Oo5/[;oaK>colFd]?o5]KGoaKJfolFg
]oo5^;SoaKViolFj^_o5^k_oaKblolFm_Oo5_[koaKnoolG0`?o5`L7oaL;2
olG3`oo5a<@Monk^kQ3oYOl02_o^k^h04_o[jn_ok^k^omoOgon>SXkoOgmo
ojBTY?nn_[koc<c<om7AdOoDe=Cod];BolO7aonXZ:SoO7alogIfM_oDe=Co
k^k^onc/k0Gok^k^00Ko<S8bob/[:om7AdOo4a<CoaPH6?oPh>05onk^kP03
okVi^OoShn?omOGe00Cooooo00CoZ:RXoda<C?lk>c_oSHf=1?ooool01?nX
Z:SoC4a<oc/k>on=SHdFooooo`03ooOgmooShn?o^KVi02gok^k^00CoXj>S
okfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0;_oV
i^H2olH0002colH10Oo60P;oaP<3olH41?o61@GoaPH6olH71oo620SoaPT9
olH:2_o62`_oaP`<olH=3Oo63PkoaPl?olH@4?o64A7oaQ8BolHC4oo651Co
aQDEolHF5_o65aOoaQPHolHI6Oo66Q[oaQ/KolHL7?o67AgoaQhNolHO7oo6
823oaR4QolHR8_o68b?oaR@TolHU9Oo69RKoaRLWolHX:?o6:BWoaRXZolH[
:oo6;2coaRd]olH^;_o6;booaS0`olHa<Oo6<S;oaS<colHd=?o6=CGoaSHf
olHg=oo6>3SoaSTiolHj>_o6>c_oaS`lolHm?Oo6?SkoaSloolI0@?o6@D7o
aT92olI3@oo6A4CoaTE5olI6A_o6AdOoaTQ8olI9BOo6BT[oaT];olI<C?o6
CDgoaTi>olI?Coo6D53oaU5AolIBD_o6De?oaUADolIEEOo6EUKoaUMGolIH
F?o6FEWoaUYJolIKFoo6G5coaUeMolING_o6GeooaV1PolIQHOo6HV;oaV=S
olITI?o6IFGoaVIVolIWIoo6J6SoaVUYolIZJ_o6Jf_oaVa/olI]KOo6KVko
aVm_olI`L?o6LG7oaW9bolIcLoo6M7CoaWEeolIfM_o6MgOoaWQholIiNOo6
NW[oaW]kolIlO?o6OGgoaWinolIoOoo6P83oaX61olJ2P_o6Ph?oaXB4olJ5
QOo6QXKoaXN7olJ8R?o6RHWoaXZ:olJ;Roo6S8coaXf=olJ>S_o6ShooaY2@
olJATOo6TY;oaY>ColJDU?o6UIGoaYJFolJGUoo6V9SoaYVIolJJV_o6Vi_o
aYbLolJMWOo6WYkoaYnOolJPX?o6XJ7oaZ:RolJSXoo6Y:CoaZFUolJVY_o6
YjOoaZRXolJYZOo6ZZ[oaZ^[olJ/[?o6[JgoaZj^olJ_[oo6/;3oa[6aolJb
/_o6/k<00_o6];@04Oo6]KGoa[JfolJg]oo6^;Soa[ViolJj^_o6^k_oa[bl
olJm_Oo6_[koa[noolK0`?o6`L7oa/;2olK3`oo6a<Coa/G501goi^KV4?n]
o`0;onKViP0@on?ShooVi^Ko^k^kog5aLOmoOgooZJVYolC4a?oAdM7odm?C
olS8b?nd];CoQXJ6of=SHonYZJWoi^KVon?Sh`Koi^KV00GoWYjNohZ:R_n>
SXko^k^konCTi006onKViP03okVi^OoShn?omOGe02Kooooo00?omoOgon?S
honi^KT0;OoVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[J
f_o?cloo_Kfmoj>SX`0^onk^kP38olP00?o80@7ob082olP30oo810Cob0D5
olP61_o81`Oob0P8olP92Oo82P[ob0/;olP<3?o83@gob0h>olP?3oo8413o
b14AolPB4_o84a?ob1@DolPE5Oo85QKob1LGolPH6?o86AWob1XJolPK6oo8
71cob1dMolPN7_o87aoob20PolPQ8Oo88R;ob2<SolPT9?o89BGob2HVolPW
9oo8:2Sob2TYolPZ:_o8:b_ob2`/olP];Oo8;Rkob2l_olP`<?o8<C7ob38b
olPc<oo8=3Cob3DeolPf=_o8=cOob3PholPi>Oo8>S[ob3/kolPl??o8?Cgo
b3hnolPo?oo8@43ob451olQ2@_o8@d?ob4A4olQ5AOo8ATKob4M7olQ8B?o8
BDWob4Y:olQ;Boo8C4cob4e=olQ>C_o8Cdoob51@olQADOo8DU;ob5=ColQD
E?o8EEGob5IFolQGEoo8F5Sob5UIolQJF_o8Fe_ob5aLolQMGOo8GUkob5mO
olQPH?o8HF7ob69RolQSHoo8I6Cob6EUolQVI_o8IfOob6QXolQYJOo8JV[o
b6][olQ/K?o8KFgob6i^olQ_Koo8L73ob75aolQbL_o8Lg?ob7AdolQeMOo8
MWKob7MgolQhN?o8NGWob7YjolQkNoo8O7cob7emolQnO_o8Ogoob820olR1
POo8PX;ob8>3olR4Q?o8QHGob8J6olR7Qoo8R8Sob8V9olR:R_o8Rh_ob8b<
olR=SOo8SXkob8n?olR@T?o8TI7ob9:BolRCToo8U9Cob9FEolRFU_o8UiOo
b9RHolRIVOo8VY[ob9^KolRLW?o8WIgob9jNolROWoo8X:3ob:6QolRRX_o8
Xj?ob:BTolRUYOo8YZKob:NWolRXZ?o8ZJWob:ZZolR[Zoo8[:cob:f]olR^
[_o8[joob;2`olRa/Oo8/[;ob;>colRd]?o8]KGob;JfolRg]oo8^;Sob;Vi
olRj^_o8^k_ob;blolRm_Oo8_[kob;noolS0`?o8`L7ob<;2olS3`oo8a<Co
b<G5olS6a_o8alLMonk^kQ3o]Ol03?o^k^h2ong]k@04ok>c/omRHV;oG5aL
oh>3P`;oVIVI00KoQXJ6of9RH_mEEEGoXJ6QonWYjOo]kNdBonk^kP03okVi
^OoShn?omOGe00Cooooo7_ojn_X4ooooo`03ooOgmooShn?o^KVi02gok^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_
[jl0;_ooool0b?o9003ob@41olT20_o90`?ob@@4olT51Oo91PKob@L7olT8
2?o92@Wob@X:olT;2oo930cob@d=olT>3_o93`oobA0@olTA4Oo94Q;obA<C
olTD5?o95AGobAHFolTG5oo961SobATIolTJ6_o96a_obA`LolTM7Oo97Qko
bAlOolTP8?o98B7obB8RolTS8oo992CobBDUolTV9_o99bOobBPXolTY:Oo9
:R[obB/[olT/;?o9;BgobBh^olT_;oo9<33obC4aolTb<_o9<c?obC@dolTe
=Oo9=SKobCLgolTh>?o9>CWobCXjolTk>oo9?3cobCdmolTn?_o9?coobD10
olU1@Oo9@T;obD=3olU4A?o9ADGobDI6olU7Aoo9B4SobDU9olU:B_o9Bd_o
bDa<olU=COo9CTkobDm?olU@D?o9DE7obE9BolUCDoo9E5CobEEEolUFE_o9
EeOobEQHolUIFOo9FU[obE]KolULG?o9GEgobEiNolUOGoo9H63obF5QolUR
H_o9Hf?obFATolUUIOo9IVKobFMWolUXJ?o9JFWobFYZolU[Joo9K6cobFe]
olU^K_o9KfoobG1`olUaLOo9LW;obG=colUdM?o9MGGobGIfolUgMoo9N7So
bGUiolUjN_o9Ng_obGalolUmOOo9OWkobGmoolV0P?o9PH7obH:2olV3Poo9
Q8CobHF5olV6Q_o9QhOobHR8olV9ROo9Rh_obHb<olV=SOo9SXkobHn?olV@
T?o9TI7obI:BolVCToo9U9CobIFEolVFU_o9UiOobIRHolVIVOo9VY[obI^K
olVLW?o9WIgobIjNolVOWoo9X:3obJ6QolVRX_o9Xj?obJBTolVUYOo9YZKo
bJNWolVXZ?o9ZJWobJZZolV[Zoo9[:cobJf]olV^[_o9[joobK2`olVa/Oo9
/[;obK>colVd]?o9]KGobKJfolVg]oo9^;SobKViolVj^_o9^k_obKblolVm
_Oo9_[kobKnoolW0`?o9`L7obL;2olW3`oo9a<CobLG5olW6a_o9alOobLS8
7Oooool@okco00cooooo0oono_h02ooKfm_oRHV9oeiNG_m6ATKo@T92oe]K
FomoOgooc/k>oogmoOooooooo_kn01;ooooo00?o^KViomgMgOoZj^X01?oZ
j^XNoo3`l0Goj^[Z00?ogMgMokVi^Oooool0;?ooool01?n_[joobl_;omkN
g_oZj^X1oo;blP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kP38olX0
0?o:0@7obP82olX30oo:10CobPD5olX61_o:1`OobPP8olX92Oo:2P[obP/;
olX<3?o:3@gobPh>olX?3oo:413obQ4AolXB4_o:4a?obQ@DolXE5Oo:5QKo
bQLGolXH6?o:6AWobQXJolXK6oo:71cobQdMolXN7_o:7aoobR0PolXQ8Oo:
8R;obR<SolXT9?o:9BGobRHVolXW9oo::2SobRTYolXZ:_o::b_obR`/olX]
;Oo:;RkobRl_olX`<?o:<C7obS8bolXc<oo:=3CobSDeolXf=_o:=cOobSPh
olXi>Oo:>S[obS/kolXl??o:?CgobShnolXo?oo:@43obT51olY2@_o:@d?o
bTA4olY5AOo:ATKobTM7olY8B?o:BDWobT];olY<C?o:CDgobTi>olY?Coo:
D53obU5AolYBD_o:De?obUADolYEEOo:EUKobUMGolYHF?o:FEWobUYJolYK
Foo:G5cobUeMolYNG_o:GeoobV1PolYQHOo:HV;obV=SolYTI?o:IFGobVIV
olYWIoo:J6SobVUYolYZJ_o:Jf_obVa/olY]KOo:KVkobVm_olY`L?o:LG7o
bW9bolYcLoo:M7CobWEeolYfM_o:MgOobWQholYiNOo:NW[obW]kolYlO?o:
OGgobWinolYoOoo:P83obX61olZ2P_o:Ph?obXB4olZ5QOo:QXKobXN7olZ8
R?o:RHWobXZ:olZ;Roo:S8cobXf=olZ>S_o:ShoobY2@olZATOo:TY;obY>C
olZEUOo:UYKobYNGolZHV?o:VIWobYZJolZKVoo:W9cobYfMolZNW_o:Wioo
bZ2PolZQXOo:XZ;obZ>SolZTY?o:YJGobZJVolZWYoo:Z:SobZVYolZZZ_o:
Zj_obZb/olZ][Oo:[ZkobZn_olZ`/?o:/K7ob[:bolZc/oo:];Cob[FeolZf
]_o:]kOob[RholZi^Oo:^[[ob[^kolZl_?o:_Kgob[jnolZo_oo:`<3ob/71
ol[2`_o:`l?ob/C4ol[5aOo:a/Kob/O7ol[8b?o:bLTMonk^kQ3oa?l03Oo^
k^h2ong]k@08onk^k_o]kNgogMgMom3@d?o?cloof][Jon_[joo^k^h2ong]
kA?ok^k^00?oVYZJokVi^Oo2`/801?o2`/8Nol?3``Go`/;200?o^KVioiZJ
V_o^k^h0;?o^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?C
doo8b<So]kNgoifMW@0^onKViP38ol`00?o<0@7oc082ol`30oo<10Coc0D5
ol`61_o<1`Ooc0P8ol`92Oo<2P[oc0/;ol`<3?o<3@goc0h>ol`?3oo<413o
c14Aol`B4_o<4a?oc1@Dol`E5Oo<5QKoc1LGol`H6?o<6AWoc1XJol`K6oo<
71coc1dMol`N7_o<7aooc20Pol`Q8Oo<8R;oc2<Sol`T9?o<9BGoc2HVol`W
9oo<:2Soc2TYol`Z:_o<:b_oc2`/ol`];Oo<;Rkoc2l_ol``<?o<<C7oc3<c
ol`d=?o<=CGoc3Hfol`g=oo<>3Soc3Tiol`j>_o<>c_oc3`lol`m?Oo<?Sko
c3loola0@?o<@D7oc492ola3@oo<A4Coc4E5ola6A_o<AdOoc4Q8ola9BOo<
BT[oc4];ola<C?o<CDgoc4i>ola?Coo<D53oc55AolaBD_o<De?oc5ADolaE
EOo<EUKoc5MGolaHF?o<FEWoc5YJolaKFoo<G5coc5eMolaNG_o<Geooc61P
olaQHOo<HV;oc6=SolaTI?o<IVKoc6MWolaXJ?o<JFWoc6YZola[Joo<K6co
c6e]ola^K_o<Kfooc71`olaaLOo<LW;oc7=coladM?o<MGGoc7IfolagMoo<
N7Soc7UiolajN_o<Ng_oc7alolamOOo<OWkoc7moolb0P?o<PH7oc8:2olb3
Poo<Q8Coc8F5olb6Q_o<QhOoc8R8olb9ROo<RX[oc8^;olb<S?o<SHgoc8j>
olb?Soo<T93oc96AolbBT_o<Ti?oc9BDolbEUOo<UYKoc9NGolbIVOo<VY[o
c9^KolbLW?o<WIgoc9jNolbOWoo<X:3oc:6QolbRX_o<Xj?oc:BTolbUYOo<
YZKoc:NWolbXZ?o<ZJWoc:ZZolb[Zoo<[:coc:f]olb^[_o<[jooc;2`olba
/Oo</[;oc;>colbd]?o<]KGoc;Jfolbg]oo<^;Soc;Violbj^_o<^k_oc;bl
olbm_Oo<_[koc;noolc0`?o<`L7oc<;2olc3`oo<a<Coc<G5olc6a_o<alOo
c<S8olc9bOo<b/XMonKViQ3oc?l0;?oVi^H00omYJFWoMgMgog]kN`04og]k
NakoO7al1OmkNg/00omgMgOoJFUYonKViP0/onKViP04oifMWOng]kOob<S8
om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S02kok^k^0<Soc@00
old10Oo=0P;oc@<3old41?o=1@Goc@H6old71oo=20Soc@T9old:2_o=2`_o
c@`<old=3Oo=3Pkoc@l?old@4?o=4A7ocA8BoldC4oo=51CocADEoldF5_o=
5aOocAPHoldI6Oo=6Q[ocA/KoldL7?o=7AgocAhNoldO7oo=823ocB4QoldR
8_o=8b?ocB@ToldU9Oo=9bOocBPXoldY:Oo=:R[ocB/[old/;?o=;BgocBh^
old_;oo=<33ocC4aoldb<_o=<c?ocC@dolde=Oo==SKocCLgoldh>?o=>CWo
cCXjoldk>oo=?3cocCdmoldn?_o=?coocD10ole1@Oo=@T;ocD=3ole4A?o=
ADGocDI6ole7Aoo=B4SocDU9ole:B_o=Bd_ocDa<ole>C_o=CdoocE1@oleA
DOo=DU;ocE=ColeDE?o=EEGocEIFoleGEoo=F5SocEUIoleJF_o=Fe_ocEaL
oleMGOo=GUkocEmOolePH?o=HF7ocF9RoleSHoo=I6CocFEUoleVI_o=IfOo
cFQXoleYJOo=JV[ocF][ole/K?o=KFgocFi^ole_Koo=L73ocG5aolebL_o=
Lg?ocGEeolefM_o=MgOocGQholeiNOo=NW[ocG]kolelO?o=OGgocGinoleo
Ooo=P83ocH61olf2P_o=Ph?ocHB4olf5QOo=QXKocHN7olf8R?o=RHWocHZ:
olf;Roo=S8cocHf=olf>S_o=ShoocI2@olfATOo=TY;ocI>ColfDU?o=UIGo
cIJFolfGUoo=V9SocIVIolfJV_o=W9cocIfMolfNW_o=WioocJ2PolfQXOo=
XZ;ocJ>SolfTY?o=YJGocJJVolfWYoo=Z:SocJVYolfZZ_o=Zj_ocJb/olf]
[Oo=[ZkocJn_olf`/?o=/K7ocK:bolfc/oo=];CocKFeolff]_o=]kOocKRh
olfi^Oo=^[[ocK^kolfl_?o=_KgocKjnolfo_oo=`<3ocL71olg3`oo=a<Co
cLG5olg6a_o=alOocLS8olg9bOo=b/[ocL_;olg<c1gok^k^4?oCo`25onk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o
[jn_02kooooo0<SocP00olh10Oo>0P;ocP<3olh41?o>1@GocPH6olh71oo>
20SocPT9olh:2_o>2`_ocP`<olh=3Oo>3PkocPl?olh@4?o>4A7ocQ8BolhC
4oo>51CocQDEolhF5_o>5aOocQPHolhI6Oo>6Q[ocQ/KolhL7?o>7AgocQhN
olhP8?o>8B7ocR8RolhS8oo>92CocRDUolhV9_o>9bOocRPXolhY:Oo>:R[o
cR/[olh/;?o>;BgocRh^olh_;oo><33ocS4aolhb<_o><c?ocS@dolhe=Oo>
=SKocSLgolhh>?o>>CWocSXjolhk>oo>?3cocSdmolhn?_o>@43ocT51oli2
@_o>@d?ocTA4oli5AOo>ATKocTM7oli8B?o>BDWocTY:oli;Boo>C4cocTe=
oli>C_o>CdoocU1@oliADOo>DU;ocU=ColiDE?o>EEGocUIFoliGEoo>F5So
cUUIoliJF_o>Fe_ocUaLoliMGOo>GeoocV1PoliQHOo>HV;ocV=SoliTI?o>
IFGocVIVoliWIoo>J6SocVUYoliZJ_o>Jf_ocVa/oli]KOo>KVkocVm_oli`
L?o>LG7ocW9bolicLoo>M7CocWEeolifM_o>MgOocWQholiiNOo>NW[ocW]k
olilO?o>OGgocWmoolj0P?o>PH7ocX:2olj3Poo>Q8CocXF5olj6Q_o>QhOo
cXR8olj9ROo>RX[ocX^;olj<S?o>SHgocXj>olj?Soo>T93ocY6AoljBT_o>
Ti?ocYBDoljEUOo>UYKocYNGoljHV?o>VIWocYZJoljKVoo>W9cocYjNoljO
Woo>X:3ocZ6QoljRX_o>Xj?ocZBToljUYOo>YZKocZNWoljXZ?o>ZJWocZZZ
olj[Zoo>[:cocZf]olj^[_o>[jooc[2`olja/Oo>/[;oc[>coljd]?o>]KGo
c[Jfoljg]oo>^;Soc[Violjj^_o>^k_oc[bloljn__o>_kooc/30olk1`Oo>
`/;oc/?3olk4a?o>aLGoc/K6olk7aoo>b<Soc/W9olk:b_o>bl_oc/c<olk=
cAgooooo4?oKo`25ooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQ
hN7of][Jolo?conm_KgoXj>S02kok^k^0<Soc`00oll10Oo?0P;oc`<3oll4
1?o?1@Goc`H6oll71oo?20Soc`T9oll:2_o?2`_oc``<oll=3Oo?3Pkoc`l?
oll@4?o?4A7oca8BollC4oo?51CocaDEollF5_o?5aOocaPHollI6Oo?6a_o
ca`LollM7Oo?7QkocalOollP8?o?8B7ocb8RollS8oo?92CocbDUollV9_o?
9bOocbPXollY:Oo?:R[ocb/[oll/;?o?;Bgocbh^oll_;oo?<33occ4aollb
<_o?<c?occ@dollf=_o?=cOoccPholli>Oo?>S[occ/kolll??o??Cgocchn
ollo?oo?@43ocd51olm2@_o?@d?ocdA4olm5AOo?ATKocdM7olm8B?o?BDWo
cdY:olm;Boo?C4cocde=olm>C_o?D53oce5AolmBD_o?De?oceADolmEEOo?
EUKoceMGolmHF?o?FEWoceYJolmKFoo?G5coceeMolmNG_o?Geoocf1PolmQ
HOo?HV;ocf=SolmTI?o?IFGocfIVolmWIoo?J6SocfUYolm[Joo?K6cocfe]
olm^K_o?Kfoocg1`olmaLOo?LW;ocg=colmdM?o?MGGocgIfolmgMoo?N7So
cgUiolmjN_o?Ng_ocgalolmmOOo?OWkocgmooln0P?o?PH7och:2oln3Poo?
QHGochJ6oln7Qoo?R8SochV9oln:R_o?Rh_ochb<oln=SOo?SXkochn?oln@
T?o?TI7oci:BolnCToo?U9CociFEolnFU_o?UiOociRHolnIVOo?VY[oci^K
olnLW?o?WIgocijNolnPX?o?XJ7ocj:RolnSXoo?Y:CocjFUolnVY_o?YjOo
cjRXolnYZOo?ZZ[ocj^[oln/[?o?[Jgocjj^oln_[oo?/;3ock6aolnb/_o?
/k?ockBdolne]Oo?][KockNgolnh^?o?^[[ock^kolnl_?o?_Kgockjnolno
_oo?`<3ocl71olo2`_o?`l?oclC4olo5aOo?a/KoclO7olo8b?o?bLWocl[:
olo;boo?c<coclg=olo>cQgok^k^4?oRo`0/onk^kP03okBd]?o?clooclo?
02Ooclo?00?oaLG5okBd]?o^k^h0;?o^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@0^onKViP38om400?oA0@7o
d@82om430ooA10Cod@D5om461_oA1`Ood@P8om492OoA2P[od@/;om4<3?oA
3@god@h>om4?3ooA413odA4Aom4B4_oA4a?odA@Dom4E5OoA5aOodAPHom4I
6OoA6Q[odA/Kom4L7?oA7AgodAhNom4O7ooA823odB4Qom4R8_oA8b?odB@T
om4U9OoA9RKodBLWom4X:?oA:BWodBXZom4[:ooA;2codBh^om4_;ooA<33o
dC4aom4b<_oA<c?odC@dom4e=OoA=SKodCLgom4h>?oA>CWodCXjom4k>ooA
?3codCdmom4n?_oA?coodD10om51@OoA@T;odD=3om55AOoAATKodDM7om58
B?oABDWodDY:om5;BooAC4codDe=om5>C_oACdoodE1@om5ADOoADU;odE=C
om5DE?oAEEGodEIFom5GEooAF5SodEUIom5JF_oAG5codEeMom5NG_oAGeoo
dF1Pom5QHOoAHV;odF=Som5TI?oAIFGodFIVom5WIooAJ6SodFUYom5ZJ_oA
Jf_odFa/om5]KOoAKVkodFm_om5`L?oALG7odG=com5dM?oAMGGodGIfom5g
MooAN7SodGUiom5jN_oANg_odGalom5mOOoAOWkodGmoom60P?oAPH7odH:2
om63PooAQ8CodHF5om66Q_oAQhOodHR8om6:R_oARh_odHb<om6=SOoASXko
dHn?om6@T?oATI7odI:Bom6CTooAU9CodIFEom6FU_oAUiOodIRHom6IVOoA
VY[odI^Kom6LW?oAWIgodIjNom6OWooAXJ7odJ:Rom6SXooAY:CodJFUom6V
Y_oAYjOodJRXom6YZOoAZZ[odJ^[om6/[?oA[JgodJj^om6_[ooA/;3odK6a
om6b/_oA/k?odKBdom6e]OoA][KodKRhom6i^OoA^[[odK^kom6l_?oA_Kgo
dKjnom6o_ooA`<3odL71om72`_oA`l?odLC4om75aOoAa/KodLO7om78b?oA
bLWodL[:om7;booAc<codLg=om7?cooAd=0MonKViQ3oj_l03_oVi^H01?oU
iNGohN7Qom_KfooFe]H2om?Cd`04omKFe_oJf][oh>3PonGUiACoi^KV00?o
^KViomgMgOo/k>`01?o/k>`Nonk^kPGok>c/00?ogMgMokVi^OoVi^H0;?oV
i^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfm
oj>SX`0^onk^kP38om800?oB0@7odP82om830ooB10CodPD5om861_oB1`Oo
dPP8om892OoB2P[odP/;om8<3?oB3@godPh>om8?3ooB413odQ4Aom8B4_oB
4a?odQDEom8F5_oB5aOodQPHom8I6OoB6Q[odQ/Kom8L7?oB7AgodQhNom8O
7ooB823odR4Qom8R8_oB8b?odR@Tom8U9OoB9RKodRLWom8Y:OoB:R[odR/[
om8/;?oB;BgodRh^om8_;ooB<33odS4aom8b<_oB<c?odS@dom8e=OoB=SKo
dSLgom8h>?oB>CWodSXjom8k>ooB?CgodShnom8o?ooB@43odT51om92@_oB
@d?odTA4om95AOoBATKodTM7om98B?oBBDWodTY:om9;BooBC4codTe=om9>
C_oBCdoodU1@om9BD_oBDe?odUADom9EEOoBEUKodUMGom9HF?oBFEWodUYJ
om9KFooBG5codUeMom9NG_oBGeoodV1Pom9QHOoBHV;odV=Som9TI?oBIVKo
dVMWom9XJ?oBJFWodVYZom9[JooBK6codVe]om9^K_oBKfoodW1`om9aLOoB
LW;odW=com9dM?oBMGGodWIfom9gMooBN7SodWYjom9kNooBO7codWemom9n
O_oBOgoodX20om:1POoBPX;odX>3om:4Q?oBQHGodXJ6om:7QooBR8SodXV9
om::R_oBRh_odXb<om:>S_oBShoodY2@om:ATOoBTY;odY>Com:DU?oBUIGo
dYJFom:GUooBV9SodYVIom:JV_oBVi_odYbLom:MWOoBWYkodYnOom:PX?oB
XJ7odZ>Som:TY?oBYJGodZJVom:WYooBZ:SodZVYom:ZZ_oBZj_odZb/om:]
[OoB[ZkodZn_om:`/?oB/K7od[:bom:c/ooB];Cod[Feom:g]ooB^;Sod[Vi
om:j^_oB^k_od[blom:m_OoB_[kod[noom;0`?oB`L7od/;2om;3`ooBa<Co
d/G5om;6a_oBalOod/S8om;9bOoBbl_od/c<om;=cOoBc/kod/o?om;@d?oB
dM4Monk^kQ3ol_l03?o^k^h03_o]kNgojn_[onCTi?oBd];o_KfmojZZZ_nP
X:3oWinOojRXZ?nj^[[oclo?on7QhOo[jn_okNg]4_o^k^h00oni^KWohn?S
ooGem@04ooOgmakon_[j1OogmoL00ooShn?o^KVionk^kP0/onk^kP04oj>S
Xonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o[jn_02ko
oooo0<Sod`00om<10OoC0P;od`<3om<41?oC1@God`H6om<71ooC20Sod`T9
om<:2_oC2`_od``<om<=3OoC3Pkod`l?om<@4?oC4A7oda<Com<D5?oC5AGo
daHFom<G5ooC61SodaTIom<J6_oC6a_oda`Lom<M7OoC7QkodalOom<P8?oC
8B7odb8Rom<S8ooC9BGodbHVom<W9ooC:2SodbTYom<Z:_oC:b_odb`/om<]
;OoC;Rkodbl_om<`<?oC<C7odc8bom<c<ooC=3CodcDeom<g=ooC>3SodcTi
om<j>_oC>c_odc`lom<m?OoC?Skodcloom=0@?oC@D7odd92om=3@ooCA4Co
ddE5om=6A_oCAdOoddU9om=:B_oCBd_odda<om==COoCCTkoddm?om=@D?oC
DE7ode9Bom=CDooCE5CodeEEom=FE_oCEeOodeQHom=IFOoCFe_odeaLom=M
GOoCGUkodemOom=PH?oCHF7odf9Rom=SHooCI6CodfEUom=VI_oCIfOodfQX
om=YJOoCJV[odf][om=/K?oCKVkodfm_om=`L?oCLG7odg9bom=cLooCM7Co
dgEeom=fM_oCMgOodgQhom=iNOoCNW[odg]kom=lO?oCOGgodginom>0P?oC
PH7odh:2om>3PooCQ8CodhF5om>6Q_oCQhOodhR8om>9ROoCRX[odh^;om><
S?oCSHgodhj>om>?SooCT93odi:Bom>CTooCU9CodiFEom>FU_oCUiOodiRH
om>IVOoCVY[odi^Kom>LW?oCWIgodijNom>OWooCX:3odj6Qom>RX_oCY:Co
djFUom>VY_oCYjOodjRXom>YZOoCZZ[odj^[om>/[?oC[Jgodjj^om>_[ooC
/;3odk6aom>b/_oC/k?odkBdom>f]_oC]kOodkRhom>i^OoC^[[odk^kom>l
_?oC_Kgodkjnom>o_ooC`<3odl71om?2`_oC`l?odlC4om?5aOoCa/KodlS8
om?9bOoCb/[odl_;om?<c?oCcLgodlk>om??cooCd=3odm7Aom?BdQgooooo
4?oio`0;ooooo`0@ookno_olo?colO7aomGEeOn^[ZkoS8b<ogIfM_m[Jf_o
JVYZog=cLon8R8SoZJVYom3@d?o_knooo?clooknoQ7ooooo00?o^KVion?S
hooemOD09_ooool00oogmoOohn?SokVi^@0]ooooo`04ojn_[oo;bl_og]kN
on[ZjP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S02kok^k^0<Soe000
om@10OoD0P;oe0<3om@41?oD1@Goe0H6om@71ooD20Soe0T9om@:2_oD2`_o
e0`<om@=3OoD3Pkoe0l?om@A4OoD4Q;oe1<Com@D5?oD5AGoe1HFom@G5ooD
61Soe1TIom@J6_oD6a_oe1`Lom@M7OoD7Qkoe1lOom@Q8OoD8R;oe2<Som@T
9?oD9BGoe2HVom@W9ooD:2Soe2TYom@Z:_oD:b_oe2`/om@];OoD;Rkoe2l_
om@`<?oD<S;oe3<com@d=?oD=CGoe3Hfom@g=ooD>3Soe3Tiom@j>_oD>c_o
e3`lom@m?OoD?Skoe3loomA0@?oD@T;oe4=3omA4A?oDADGoe4I6omA7AooD
B4Soe4U9omA:B_oDBd_oe4a<omA=COoDCTkoe4m?omA@D?oDDE7oe5=ComAD
E?oDEEGoe5IFomAGEooDF5Soe5UIomAJF_oDFe_oe5aLomAMGOoDGUkoe5mO
omAPH?oDHF7oe6=SomATI?oDIFGoe6IVomAWIooDJ6Soe6UYomAZJ_oDJf_o
e6a/omA]KOoDKVkoe6m_omA`L?oDLG7oe79bomAdM?oDMGGoe7IfomAgMooD
N7Soe7UiomAjN_oDNg_oe7alomAmOOoDOWkoe7moomB0P?oDPH7oe8:2omB4
Q?oDQHGoe8J6omB7QooDR8Soe8V9omB:R_oDRh_oe8b<omB=SOoDSXkoe8n?
omB@T?oDTI7oe9:BomBCTooDUIGoe9JFomBGUooDV9Soe9VIomBJV_oDVi_o
e9bLomBMWOoDWYkoe9nOomBPX?oDXJ7oe::RomBSXooDYJGoe:JVomBWYooD
Z:Soe:VYomBZZ_oDZj_oe:b/omB][OoD[Zkoe:n_omB`/?oD/K7oe;:bomBc
/ooD];Coe;JfomBg]ooD^;Soe;ViomBj^_oD^k_oe;blomBm_OoD_[koe;no
omC0`?oD`L7oe<;2omC3`ooDa<Coe<K6omC7aooDb<Soe<W9omC:b_oDbl_o
e<c<omC=cOoDc/koe<o?omC@d?oDdM7oe=;BomCCdagok^k^4?ooo00;onk^
kP0@ong]kOoShn?oa/K6oiZJV_m`L73oMWIfoiZJV_nh^;So_;bloifMWOml
O7coK6a/oiBDU?o2`/;oh>3Ponc/k0Kok^k^00?ok>c/olg=cOoFe]H02?o^
k^h00oni^KWohn?SooGem@05ooooo`03onOWioobl_;ooooo00?ooooo00?o
o_knon7QhOoMgMd06?ooool00oogmoOohn?SokVi^@0]onk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM02koi^KV
0<SoeP00omH10OoF0P;oeP<3omH41?oF1@GoePH6omH71ooF20SoePT9omH:
2_oF2`_oeP`<omH=3OoF3PkoeQ0@omHA4OoF4Q;oeQ<ComHD5?oF5AGoeQHF
omHG5ooF61SoeQTIomHJ6_oF6a_oeQ`LomHM7OoF7aooeR0PomHQ8OoF8R;o
eR<SomHT9?oF9BGoeRHVomHW9ooF:2SoeRTYomHZ:_oF:b_oeR`/omH^;_oF
;booeS0`omHa<OoF<S;oeS<comHd=?oF=CGoeSHfomHg=ooF>3SoeSTiomHj
>_oF>c_oeSdmomHn?_oF?cooeT10omI1@OoF@T;oeT=3omI4A?oFADGoeTI6
omI7AooFB4SoeTU9omI:B_oFC4coeTe=omI>C_oFCdooeU1@omIADOoFDU;o
eU=ComIDE?oFEEGoeUIFomIGEooFF5SoeUUIomIKFooFG5coeUeMomING_oF
GeooeV1PomIQHOoFHV;oeV=SomITI?oFIFGoeVIVomIWIooFJ6SoeVYZomI[
JooFK6coeVe]omI^K_oFKfooeW1`omIaLOoFLW;oeW=comIdM?oFMGGoeWIf
omIgMooFNGWoeWYjomIkNooFO7coeWemomInO_oFOgooeX20omJ1POoFPX;o
eX>3omJ4Q?oFQHGoeXJ6omJ8R?oFRHWoeXZ:omJ;RooFS8coeXf=omJ>S_oF
ShooeY2@omJATOoFTY;oeY>ComJDU?oFUIGoeYNGomJHV?oFVIWoeYZJomJK
VooFW9coeYfMomJNW_oFWiooeZ2PomJQXOoFXZ;oeZ>SomJTY?oFYZKoeZNW
omJXZ?oFZJWoeZZZomJ[ZooF[:coeZf]omJ^[_oF[jooe[2`omJa/OoF/[;o
e[>comJd]?oF][Koe[NgomJh^?oF^KWoe[ZjomJk^ooF_;coe[fmomJn__oF
_kooe/30omK1`OoF`/;oe/?3omK5aOoFa/Koe/O7omK8b?oFbLWoe/[:omK;
booFc<coe/g=omK>c_oFclooe]3@omKAdOoFd];oe]CDomKEeAgoi^KV4?oo
m00:onKViP08onGUiOoQhN7oc/k>oj2PX?mdM7CoXJ6Qong]kOono_h3oooo
o`07oo?clon[Zj_oLg=coiVIVOo9bLWogmoOonGUi@04onKViP06oijNW_l9
2@Wo2`/;ob0P8?l`<33oUYJF1_oVi^H00oni^KWohn?SooGem@03ooooo`06
om;Bd_lh>3So<S8boc<c<om=CDgohN7Q0_ooool01OmUIFGo<c<codI6A_lX
:2Sobl_;01Kooooo00?omoOgon?Shoni^KT0;OoVi^H01?nMWIgo]kNgolS8
b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfmoj>SX`0^onk^kP38omL0
0?oG0@7oe`82omL30ooG10Coe`D5omL61_oG1`Ooe`P8omL92OoG2P[oe`/;
omL<3?oG3Pkoe`l?omL@4?oG4A7oea8BomLC4ooG51CoeaDEomLF5_oG5aOo
eaPHomLI6OoG6Q[oea`LomLM7OoG7QkoealOomLP8?oG8B7oeb8RomLS8ooG
92CoebDUomLV9_oG9bOoebPXomLZ:_oG:b_oeb`/omL];OoG;Rkoebl_omL`
<?oG<C7oec8bomLc<ooG=3CoecDeomLf=_oG>3SoecTiomLj>_oG>c_oec`l
omLm?OoG?SkoecloomM0@?oG@D7oed92omM3@ooGA4CoedI6omM7AooGB4So
edU9omM:B_oGBd_oeda<omM=COoGCTkoedm?omM@D?oGDE7oee9BomMDE?oG
EEGoeeIFomMGEooGF5SoeeUIomMJF_oGFe_oeeaLomMMGOoGGUkoeemOomMP
H?oGHV;oef=SomMTI?oGIFGoefIVomMWIooGJ6SoefUYomMZJ_oGJf_oefa/
omM]KOoGKVkoeg1`omMaLOoGLW;oeg=comMdM?oGMGGoegIfomMgMooGN7So
egUiomMjN_oGNg_oegalomMnO_oGOgooeh20omN1POoGPX;oeh>3omN4Q?oG
QHGoehJ6omN7QooGR8SoehV9omN:R_oGS8coehf=omN>S_oGShooei2@omNA
TOoGTY;oei>ComNDU?oGUIGoeiJFomNGUooGV9SoeiZJomNKVooGW9coeifM
omNNW_oGWiooej2PomNQXOoGXZ;oej>SomNTY?oGYJGoejJVomNXZ?oGZJWo
ejZZomN[ZooG[:coejf]omN^[_oG[jooek2`omNa/OoG/[;oek>comNd]?oG
][KoekNgomNh^?oG^KWoekZjomNk^ooG_;coekfmomNn__oG_kooel30omO1
`OoG`l?oelC4omO5aOoGa/KoelO7omO8b?oGbLWoel[:omO;booGc<coelg=
omO>c_oGclooem7AomOBd_oGdm?oemCDomOEeOoGe]HMonk^kQ3oond02_o^
k^h01oo]kNgohn?SolC4a?n6QXKoYjNWonk^k_okno/00_ono_h02OomoOgo
o_knooShn?o`l?3o/K6aoh61POnn_[koh>3Ponc/k004onk^kP07olO7aonb
/[;ojNWYonk^k_nBTY;o0`<3olo?c`05onk^kP03okVi^OoShn?omOGe00?o
oooo00KoE5ADogQhN?ooooooooooof5QHOmFEUH5ooooo`03olK6a_l?3`oo
kno_01Gooooo00?omoOgon?Shoni^KT0;Oo^k^h01?nSXj?o_Kfmolo?cooJ
f]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`0^ooooo`38omP00?oH
0@7of082omP30ooH10Cof0D5omP61_oH1`Oof0P8omP92OoH2P[of0/;omP=
3OoH3Pkof0l?omP@4?oH4A7of18BomPC4ooH51Cof1DEomPF5_oH5aOof1PH
omPJ6_oH6a_of1`LomPM7OoH7Qkof1lOomPP8?oH8B7of28RomPS8ooH92Co
f2DUomPW9ooH:2Sof2TYomPZ:_oH:b_of2`/omP];OoH;Rkof2l_omP`<?oH
<C7of38bomPd=?oH=CGof3HfomPg=ooH>3Sof3TiomPj>_oH>c_of3`lomPm
?OoH?Skof3loomQ1@OoH@T;of4=3omQ4A?oHADGof4I6omQ7AooHB4Sof4U9
omQ:B_oHBd_of4a<omQ>C_oHCdoof51@omQADOoHDU;of5=ComQDE?oHEEGo
f5IFomQGEooHF5Sof5UIomQKFooHG5cof5eMomQNG_oHGeoof61PomQQHOoH
HV;of6=SomQTI?oHIFGof6IVomQXJ?oHJFWof6YZomQ[JooHK6cof6e]omQ^
K_oHKfoof71`omQaLOoHLW;of7=comQeMOoHMWKof7MgomQhN?oHNGWof7Yj
omQkNooHO7cof7emomQnO_oHOgoof820omR2P_oHPh?of8B4omR5QOoHQXKo
f8N7omR8R?oHRHWof8Z:omR;RooHS8cof8f=omR?SooHT93of96AomRBT_oH
Ti?of9BDomREUOoHUYKof9NGomRHV?oHVIWof9ZJomRLW?oHWIgof9jNomRO
WooHX:3of:6QomRRX_oHXj?of:BTomRUYOoHYZKof:NWomRYZOoHZZ[of:^[
omR/[?oH[Jgof:j^omR_[ooH/;3of;6aomRb/_oH/k?of;BdomRf]_oH]kOo
f;RhomRi^OoH^[[of;^komRl_?oH_Kgof;jnomRo_ooH`<3of<71omS3`ooH
a<Cof<G5omS6a_oHalOof<S8omS9bOoHb/[of<_;omS<c?oHcLgof<k>omS@
d?oHdM7of=;BomSCdooHe=Cof=GEomSFe_oHemLMoooooa3oonD02_ooool0
4_omoOgolO7aokfm_OnCTi?of][Jonc/k?oclo?on_[jooooooolo?comoOg
oo7alOoYjNWofm_KoiRHV?nb/[;ok^k^ooclo0Sooooo00?ohN7Qo`000?nf
][H01Oooool00oni^KWohn?Soo[jnP03ooooo`06obLW9onj^[[ooooooooo
oommOGgoADE51_ooool00olU9BGoR8R8ooooo`0Dooooo`03oo[jn_oShn?o
^KVi02gooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][o
clo?okfm_OnSXj<0;_o^k^h0b?oJ003ofP41omX20_oJ0`?ofP@4omX51OoJ
1PKofPL7omX82?oJ2@WofPX:omX;2ooJ3@gofPh>omX?3ooJ413ofQ4AomXB
4_oJ4a?ofQ@DomXE5OoP@43oj7=conQeMOoP@d?ofQ/KomXL7?oJ7AgofQhN
omXO7ooJ823ofR4QomXR8_oJ8b?ofRDUomXV9_oJ9bOofRPXomXY:OoJ:R[o
fR/[omX/;?oJ;BgofRh^omX_;ooJ<C7ofS8bomXc<ooJ=3CofSDeomXf=_oJ
=cOofSPhomXi>OoJ>S[ofS/komXm?OoJ?SkofSloomY0@?oJ@D7ofT92omY3
@ooJA4CofTE5omY6A_oJAdOofTU9omY:B_oJBd_ofTa<omY=COoJCTkofTm?
omY@D?oJDE7ofU9BomYCDooJEEGofUIFomYGEooJF5SofUUIomYJF_oJFe_o
fUaLomYMGOoJGUkofUmOomYQHOoJHV;ofV=SomYTI?oJIFGofVIVomYWIooJ
J6SofVUYomYZJ_oJJf_ofVe]omY^K_oJKfoofW1`omYaLOoJLW;ofW=comYd
M?oJMGGofWIfomYgMooJNGWofWYjomYkNooJO7cofWemomYnO_oJOgoofX20
omZ1POoJPX;ofX>3omZ4Q?oJQXKofXN7omZ8R?oJRHWofXZ:omZ;RooJS8co
fXf=omZ>S_oJShoofY2@omZBT_oJTi?ofYBDomZEUOoJUYKofYNGomZHV?oJ
VIWofYZJomZKVooJW9cofYjNomZOWooJX:3ofZ6QomZRX_oJXj?ofZBTomZU
YOoJYZKofZNWomZXZ?oJZZ[ofZ^[omZ/[?oJ[JgofZj^omZ_[ooJ/;3of[6a
omZb/_oJ/k?of[BdomZf]_oJ]kOof[RhomZi^OoJ^[[of[^komZl_?oJ_Kgo
f[jnomZo_ooJ`<3of/;2om[3`ooJa<Cof/G5om[6a_oJalOof/S8om[9bOoJ
b/[of/_;om[<c?oJc/kof/o?om[@d?oJdM7of];Bom[CdooJe=Cof]GEom[F
e_oJemOof]SH7Oo^k^h@oooM00[ok^k^01;oj^[Zon;Rh_nPX:3o[Zj^om[J
f_oQhN7ojn_[ono_koobl_;ol?3`ong]kOoZj^[oh>3PomSHf?nd];CoUYJF
on3Ph?oZj^X7onk^kP04on3Ph?m9BDWo1`L7on7Qh@Gok^k^00?o^KVion?S
hoojn_X00oooool01_n7QhOoEeMGoo_knon;Rh_o1`L7oj^[Z`;ooooo00Ko
inOWodm?ColQ8B7oEEEEoe5ADOmEEEDEooooo`03oo[jn_oShn?o^KVi02go
k^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg
]onMWId0;_oVi^H0b?oK003of`41om/20_oK0`?of`@4om/51OoK1PKof`L7
om/82?oK2@Wof`X:om/<3?oK3@gof`h>om/?3ooK413ofa4Aom/B4_oK4a?o
g20Poo:[Zoojh>3ol::Roo2SXoojhN7olZf]om`X:?oK7AgofahNom/O7ooK
823ofb4Qom/S8ooK92CofbDUom/V9_oK9bOofbPXom/Y:OoK:R[ofb/[om//
;?oK;Rkofbl_om/`<?oK<C7ofc8bom/c<ooK=3CofcDeom/f=_oK=cOofcTi
om/j>_oK>c_ofc`lom/m?OoK?Skofcloom]0@?oK@D7ofd92om]3@ooKADGo
fdI6om]7AooKB4SofdU9om]:B_oKBd_ofda<om]=COoKCTkofe1@om]ADOoK
DU;ofe=Com]DE?oKEEGofeIFom]GEooKF5SofeUIom]KFooKG5cofeeMom]N
G_oKGeooff1Pom]QHOoKHV;off=Som]TI?oKIFGoffMWom]XJ?oKJFWoffYZ
om][JooKK6coffe]om]^K_oKKfoofg1`om]bL_oKLg?ofgAdom]eMOoKMWKo
fgMgom]hN?oKNGWofgYjom]kNooKOGgofginom]oOooKP83ofh61om^2P_oK
Ph?ofhB4om^5QOoKQXKofhN7om^9ROoKRX[ofh^;om^<S?oKSHgofhj>om^?
SooKT93ofi6Aom^BT_oKU9CofiFEom^FU_oKUiOofiRHom^IVOoKVY[ofi^K
om^LW?oKWIgofijNom^PX?oKXJ7ofj:Rom^SXooKY:CofjFUom^VY_oKYjOo
fjRXom^YZOoKZj_ofjb/om^][OoK[Zkofjn_om^`/?oK/K7ofk:bom^c/ooK
];CofkJfom^g]ooK^;SofkViom^j^_oK^k_ofkblom^m_OoK_[kofknoom_0
`?oK`/;ofl?3om_4a?oKaLGoflK6om_7aooKb<SoflW9om_:b_oKbl_oflg=
om_>c_oKcloofm3@om_AdOoKd];ofm?Com_De?oKeMGofmKFom_Hf?oKfMWo
fm[J7OoVi^H@oooF00[oi^KV00SohN7QomkNg_nEUIGo]kNgolk>c_oHf=So
h>3Pon7Qh@;oi>CT00Sohn?SomkNg_oIfMWobl_;okRh^?n<S8cofm_Kon7Q
h@Koi^KV00CoY:BToaTI6OlD51CoZj^[1_oVi^H00oni^KWohn?Soo[jnP04
ooooo`04ofe]KOlF5QKo0`<3okRh^0?ooooo00KoJf][oeeMGOobl_;oe=CD
oaLG5oli>CTEooooo`03oo[jn_oShn?o^KVi02goi^KV00CoWIfMokNg]oo8
b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h0b?oL
003og041om`20_oL0`?og0@4om`51OoL1PKog0L7om`82?oL2@Wog0/;om`<
3?oL3@gog0h>om`?3ooL413og14Aom`B4_oL4a?olZ^[oo6WYooL7Agog1PH
om`I6OoL823olJVYoo:][OoL7Agog1hNom`O7ooL8B7og28Rom`S8ooL92Co
g2DUom`V9_oL9bOog2PXom`Y:OoL:b_og2`/om`];OoL;Rkog2l_om``<?oL
<C7og38bom`c<ooL=3Cog3Hfom`g=ooL>3Sog3Tiom`j>_oL>c_og3`lom`m
?OoL?Skog3looma1@OoL@T;og4=3oma4A?oLADGog4I6oma7AooLB4Sog4U9
oma:B_oLC4cog4e=oma>C_oLCdoog51@omaADOoLDU;og5=ComaDE?oLEUKo
g5MGomaHF?oLFEWog5YJomaKFooLG5cog5eMomaNG_oLGeoog65QomaRH_oL
Hf?og6ATomaUIOoLIVKog6MWomaXJ?oLJFWog6YZoma/K?oLKFgog6i^oma_
KooLL73og75aomabL_oLLg?og7AdomafM_oLMgOog7QhomaiNOoLNW[og7]k
omalO?oLOGgog7inomaoOooLPH7og8:2omb3PooLQ8Cog8F5omb6Q_oLQhOo
g8R8omb9ROoLRX[og8b<omb=SOoLSXkog8n?omb@T?oLTI7og9:BombCTooL
U9Cog9FEombGUooLV9Sog9VIombJV_oLVi_og9bLombMWOoLWYkog9nOombQ
XOoLXZ;og:>SombTY?oLYJGog:JVombWYooLZ:Sog:VYombZZ_oL[:cog:f]
omb^[_oL[joog;2`omba/OoL/[;og;>combd]?oL]KGog;Ngombh^?oL^KWo
g;Zjombk^ooL_;cog;fmombn__oL_koog<71omc2`_oL`l?og<C4omc5aOoL
a/Kog<O7omc8b?oLbLWog<[:omc<c?oLcLgog<k>omc?cooLd=3og=7AomcB
d_oLdm?og=CDomcEeOoLemOog=SHomcIfOoLf][og=_K7Oo^k^h@ooo>00[o
k^k^01;oj>SXong]kOnHV9So];Bdol;2`_o<c<cod];Bom?CdooEeMGoe=CD
om;Bd_o?cloocLg=ol30`?nc/k?oRXZ:onc/k?oYjNT5onk^kP04ogQhN?l0
003oD51@omKFePOok^k^00?o^KVion?Shoojn_X00oooool02_oPh>3o6ATI
ofIVI_nOWiooDU9BooWinOoooooon_[joa0@4?o7alL2ooooo`03of][Jom:
BT[ooooo01Cooooo00?on_[jon?Shoni^KT0;Oo^k^h01?nSXj?o_Kfmolo?
cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`0^ooooo`38omd0
0?oM0@7og@82omd30ooM10Cog@D5omd61_oM1`Oog@P8omd92OoM2`_og@`<
omd=3OoM3Pkog@l?omd@4?oM4A7ogA8Bon<m?Oojh>3ogA`LomdG5ooM61So
gATIomdJ6_oN8R;on^7Qon=5AOoM7aoogB0PomdQ8OoM8R;ogB<SomdT9?oM
9BGogBHVomdW9ooM:BWogBXZomd[:ooM;2cogBd]omd^;_oM;boogC0`omda
<OoM<c?ogC@domde=OoM=SKogCLgomdh>?oM>CWogCXjomdk>ooM?CgogChn
omdo?ooM@43ogD51ome2@_oM@d?ogDA4ome5AOoMATKogDQ8ome9BOoMBT[o
gD];ome<C?oMCDgogDi>ome?CooMD53ogE9BomeCDooME5CogEEEomeFE_oM
EeOogEQHomeIFOoMFU[ogEaLomeMGOoMGUkogEmOomePH?oMHF7ogF9RomeS
HooMI6CogFIVomeWIooMJ6SogFUYomeZJ_oMJf_ogFa/ome]KOoMKVkogG1`
omeaLOoMLW;ogG=comedM?oMMGGogGIfomegMooMN7SogGYjomekNooMO7co
gGemomenO_oMOgoogH20omf1POoMPX;ogHB4omf5QOoMQXKogHN7omf8R?oM
RHWogHZ:omf;RooMS8cogHf=omf?SooMT93ogI6AomfBT_oMTi?ogIBDomfE
UOoMUYKogINGomfIVOoMVY[ogI^KomfLW?oMWIgogIjNomfOWooMX:3ogJ6Q
omfSXooMY:CogJFUomfVY_oMYjOogJRXomfYZOoMZZ[ogJ^[omf][OoM[Zko
gJn_omf`/?oM/K7ogK:bomfc/ooM];CogKFeomfg]ooM^;SogKViomfj^_oM
^k_ogKblomfm_OoM_[kogKnoomg1`OoM`/;ogL?3omg4a?oMaLGogLK6omg7
aooMb<SogLW9omg:b_oMc<cogLg=omg>c_oMcloogM3@omgAdOoMd];ogM?C
omgDe?oMe]KogMOGomgHf?oMfMWogM[JomgKfooMg=`Moooooa3oolH02_oo
ool04_ohn?Soooooojf][OnKVi_o/[:bokfm_Oo3`l?oa<C4ol?3`oo1`L7o
`/;2ol71`Onm_Kgo/K6aoiRHV?nJVY[ooooooo[jnPCooooo00?oi^KVo`82
0_nCTi<02Oooool00oni^KWohn?Soo[jnP03ooooo`0:oi:BT_m;Bd_ooooo
oooooomADE7o[Zj^ooooooomoOgo2@T9ol[:bP;ooooo00?o@410ogIfM_oo
ool05?ooool00oojn_[ohn?SokVi^@0]ooooo`04ojn_[oo;bl_og]kNon[Z
jP7ol_;b00001OoQhN7of][Jolo?conm_KgoXj>S02kok^k^0<Sog`00oml1
0OoO0P;og`<3oml41?oO1@Gog`H6oml71ooO20Sog`X:oml;2ooO30cog`d=
oml>3_oO3`ooga0@omlA4OoO4Q;ojg9boo:QXOoO5QKogaLGomlH6?oO6AWo
gaXJomlK6oobY:CojgQhomlO7ooO823ogb4QomlR8_oO8b?ogb@TomlU9OoO
9bOogbPXomlY:OoO:R[ogb/[oml/;?oO;Bgogbh^oml_;ooO<C7ogc8bomlc
<ooO=3CogcDeomlf=_oO=cOogcPhomlj>_oO>c_ogc`lomlm?OoO?Skogclo
omm0@?oO@D7ogd92omm4A?oOADGogdI6omm7AooOB4SogdU9omm:B_oOBd_o
gda<omm>C_oOCdooge1@ommADOoODU;oge=CommDE?oOEEGogeMGommHF?oO
FEWogeYJommKFooOG5cogeeMommNG_oOGeoogf5QommRH_oOHf?ogfATommU
IOoOIVKogfMWommXJ?oOJFWogf][omm/K?oOKFgogfi^omm_KooOL73ogg5a
ommbL_oOM7CoggEeommfM_oOMgOoggQhommiNOoONW[ogg]kommlO?oOOWko
ggmoomn0P?oOPH7ogh:2omn3PooOQ8CoghF5omn6Q_oOR8SoghV9omn:R_oO
Rh_oghb<omn=SOoOSXkoghn?omnATOoOTY;ogi>ComnDU?oOUIGogiJFomnG
UooOV9SogiVIomnKVooOW9cogifMomnNW_oOWioogj2PomnQXOoOXZ;ogj>S
omnUYOoOYZKogjNWomnXZ?oOZJWogjZZomn[ZooO[:cogjj^omn_[ooO/;3o
gk6aomnb/_oO/k?ogkBdomne]OoO][KogkRhomni^OoO^[[ogk^komnl_?oO
_Kgogkjnomno_ooO`L7ogl;2omo3`ooOa<CoglG5omo6a_oOalOoglS8omo9
bOoObl_oglc<omo=cOoOc/koglo?omo@d?oOdM7ogm;BomoCdooOeMGogmKF
omoGeooOf=SogmWIomoJf_oOfm_ogmcLomoNgQgok^k^4?oo_`0:onk^kP07
onWYjOo^k^ko^k^kohJ6Q_nKVi_o[jn_okbl_002ol30`009ol71`Ono_koo
^k^kok6a/OnJVY[oOWinojVYZOo^k^koj^[Z00Cok^k^00?obLW9o`410OoG
emL02Oo^k^h00oni^KWohn?SooGem@03ooooo`06omWIfOl];Bgoh>3PomgM
gOlU9BGo_[jn0_ooool01_mYJFWoEEEEonCTi?nMWIgo3Ph>omoOgaGooooo
00?omoOgon?Shoni^KT0;Oo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@00
00Gof][Jom?Cdoo8b<So]kNgoifMW@0^onKViP38on000?oP0@7oh082on03
0ooP10Coh0D5on061_oP1`Ooh0P8on0:2_oP2`_oh0`<on0=3OoP3Pkoh0l?
on0@4?oP4A7oh1<ConabL_obXJ7oh1HFon0G5ooP61Soh1TIon0J6_oP71co
lZBTonahN?oP7aooh20Pon0Q8OoP8R;oh2<Son0U9OoP9RKoh2LWon0X:?oP
:BWoh2XZon0[:ooP;2coh2h^on0_;ooP<33oh34aon0b<_oP<c?oh3@don0e
=OoP=SKoh3Phon0i>OoP>S[oh3/kon0l??oP?Cgoh3hnon0o?ooP@D7oh492
on13@ooPA4Coh4E5on16A_oPAdOoh4Q8on1:B_oPBd_oh4a<on1=COoPCTko
h4m?on1@D?oPDE7oh5=Con1DE?oPEEGoh5IFon1GEooPF5Soh5UIon1JF_oP
G5coh5eMon1NG_oPGeooh61Pon1QHOoPHV;oh6=Son1TI?oPIVKoh6MWon1X
J?oPJFWoh6YZon1[JooPK6coh6e]on1_KooPL73oh75aon1bL_oPLg?oh7Ad
on1eMOoPMWKoh7Qhon1iNOoPNW[oh7]kon1lO?oPOGgoh7inon1oOooPPH7o
h8:2on23PooPQ8Coh8F5on26Q_oPQhOoh8R8on2:R_oPRh_oh8b<on2=SOoP
SXkoh8n?on2@T?oPTI7oh9:Bon2DU?oPUIGoh9JFon2GUooPV9Soh9VIon2J
V_oPVi_oh9fMon2NW_oPWiooh:2Pon2QXOoPXZ;oh:>Son2TY?oPYZKoh:NW
on2XZ?oPZJWoh:ZZon2[ZooP[:coh:f]on2_[ooP/;3oh;6aon2b/_oP/k?o
h;Bdon2e]OoP][Koh;Rhon2i^OoP^[[oh;^kon2l_?oP_Kgoh;jnon2o_ooP
`<3oh<;2on33`ooPa<Coh<G5on36a_oPalOoh<S8on39bOoPbl_oh<c<on3=
cOoPc/koh<o?on3@d?oPdM7oh=;Bon3De?oPeMGoh=KFon3GeooPf=Soh=WI
on3Jf_oPfm_oh=gMon3Ng_oPgmlMonKViQ3ookL02_oVi^H04_oShn?oi^KV
omOGeon;Rh_oOgmoojBTY?nn_[koc<c<om7AdOoDe=Cod];BolO7aonXZ:So
O7alogAdM?o<c<coi^KVonCTi0Goi^KV00Go@T92oc@d=?n0P83oF5QHodm?
C`06onKViP03okVi^OoShn?omOGe00Cooooo00CoZ:RXoda<C?lk>c_oSHf=
0oooool01Oohn?SoMgMgobd];Om6ATKoa/K601Kooooo00?omoOgon?Shoni
^KT0;OoVi^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?
cloo_Kfmoj>SX`0^onk^kP38on400?oQ0@7oh@82on430ooQ10Coh@D5on46
1_oQ1`Ooh@T9on4:2_oQ2`_oh@`<on4=3OoQ3Pkoh@l?on4@4?oQ4Q;ohA<C
onHn?_okh>3ohA`Lon4G5ooQ61SohATIon4K6ooQ8b?onn7QonI6A_oQ7aoo
hB0Pon4Q8OoQ8R;ohB@Ton4U9OoQ9RKohBLWon4X:?oQ:BWohBXZon4/;?oQ
;BgohBh^on4_;ooQ<33ohC4aon4b<_oQ<c?ohCDeon4f=_oQ=cOohCPhon4i
>OoQ>S[ohC/kon4l??oQ?SkohCloon50@?oQ@D7ohD92on53@ooQA4CohDE5
on57AooQB4SohDU9on5:B_oQBd_ohDa<on5=COoQCTkohE1@on5ADOoQDU;o
hE=Con5DE?oQEEGohEIFon5HF?oQFEWohEYJon5KFooQG5cohEeMon5NG_oQ
GeoohF5Qon5RH_oQHf?ohFATon5UIOoQIVKohFMWon5XJ?oQJV[ohF][on5/
K?oQKFgohFi^on5_KooQL73ohG5aon5cLooQM7CohGEeon5fM_oQMgOohGQh
on5iNOoQNW[ohGalon5mOOoQOWkohGmoon60P?oQPH7ohH:2on64Q?oQQHGo
hHJ6on67QooQR8SohHV9on6:R_oQRh_ohHf=on6>S_oQShoohI2@on6ATOoQ
TY;ohI>Con6DU?oQUYKohINGon6HV?oQVIWohIZJon6KVooQW9cohIfMon6O
WooQX:3ohJ6Qon6RX_oQXj?ohJBTon6UYOoQYZKohJRXon6YZOoQZZ[ohJ^[
on6/[?oQ[JgohJj^on6`/?oQ/K7ohK:bon6c/ooQ];CohKFeon6f]_oQ]kOo
hKVion6j^_oQ^k_ohKblon6m_OoQ_[kohKnoon70`?oQ`/;ohL?3on74a?oQ
aLGohLK6on77aooQb<SohLW9on7;booQc<cohLg=on7>c_oQcloohM3@on7A
dOoQdm?ohMCDon7EeOoQe]KohMOGon7Hf?oQfMWohM[Jon7Lg?oQgMgohMkN
on7OgooQh>0Monk^kQ3oojl02oo^k^h04?o[jn_ok^k^ol71`OmcLg?oOgmo
ojVYZOo4a<CodM7Aom?Cdoo8b<So];BdohJ6Q_mTI6Co[jn_onk^k_o[jn/6
onk^kP05on[Zj_nYZJWoIVIVoginO_nb/[801_o^k^h00oni^KWohn?SooGe
m@0Vooooo`03ooOgmooShn?o^KVi02gok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0;_ooool0b?oR003ohP41
on820_oR0`?ohP@4on851OoR1PKohPL7on892OoR2P[ohP/;on8<3?oR3@go
hPh>on8?3ooR4A7ohQ8Bon8C4ooR51Com:^[ooBWYooR7AgohQPHon8J6_oR
8R;om:VYooB^[_oR7QkohQlOon8P8?oR8R;ohR<Son8T9?oR9BGohRHVon8W
9ooR:2SohRTYon8[:ooR;2cohRd]on8^;_oR;boohS0`on8a<OoR<c?ohS@d
on8e=OoR=SKohSLgon8h>?oR>CWohS/kon8l??oR?CgohShnon8o?ooR@43o
hT51on92@_oRA4CohTE5on96A_oRAdOohTQ8on99BOoRBT[ohTa<on9=COoR
CTkohTm?on9@D?oRDE7ohU9Bon9CDooREEGohUIFon9GEooRF5SohUUIon9J
F_oRFe_ohUeMon9NG_oRGeoohV1Pon9QHOoRHV;ohV=Son9TI?oRIVKohVMW
on9XJ?oRJFWohVYZon9[JooRK6cohVi^on9_KooRL73ohW5aon9bL_oRLg?o
hWAdon9fM_oRMgOohWQhon9iNOoRNW[ohW]kon9lO?oROGgohWmoon:0P?oR
PH7ohX:2on:3PooRQ8CohXF5on:7QooRR8SohXV9on::R_oRRh_ohXb<on:=
SOoRSXkohY2@on:ATOoRTY;ohY>Con:DU?oRUIGohYJFon:HV?oRVIWohYZJ
on:KVooRW9cohYfMon:NW_oRWioohZ6Qon:RX_oRXj?ohZBTon:UYOoRYZKo
hZNWon:YZOoRZZ[ohZ^[on:/[?oR[JgohZj^on:_[ooR/K7oh[:bon:c/ooR
];Coh[Feon:f]_oR]kOoh[Rhon:j^_oR^k_oh[blon:m_OoR_[koh[noon;0
`?oR`/;oh/?3on;4a?oRaLGoh/K6on;7aooRb<Soh/W9on;;booRc<coh/g=
on;>c_oRclooh]3@on;AdOoRdm?oh]CDon;EeOoRe]Koh]OGon;Hf?oRfMWo
h]_Kon;Lg?oRgMgoh]kNon;OgooRh>3oh^7Q7Oooool@oonX00cooooo0_on
o_h01?no_kooIVIVoeaLG?n3Ph<2oiVIV@06ohJ6Q_mRHV;oF5QHojb/[?oj
n_[oo_kn4_ooool00oni^KWohn?SooGem@04oooooakon_[j1?ooool00oog
moOohn?SokVi^@0]ooooo`04ojn_[oo;bl_og]kNon[ZjP7ol_;b00001OoQ
hN7of][Jolo?conm_KgoXj>S02kok^k^01Koi000on@10OoT0P;oi0<3on@4
1?oT1@Goi0H6on@71ooT2@Woi0X:on@;2ooT30coi0d=on@>3_oT3`ooi14A
on@B4_oT4a?oi1@DonDQ8OoeZj_onn3P0_odXj<0/?okhN7omJf]onDY:OoT
7Qkoi1lOon@Q8OoT8R;oi2<Son@T9?oT9BGoi2HVon@W9ooT:BWoi2XZon@[
:ooT;2coi2d]on@^;_oT;booi34aon@b<_oT<c?oi3@don@e=OoT=SKoi3Lg
on@i>OoT>S[oi3/kon@l??oT?Cgoi3hnon@o?ooT@D7oi492onA3@ooTA4Co
i4E5onA6A_oTAdOoi4U9onA:B_oTBd_oi4a<onA=COoTCTkoi4m?onAADOoT
DU;oi5=ConADE?oTEEGoi5IFonAGEooTFEWoi5YJonAKFooTG5coi5eMonAN
G_oTGeooi61PonARH_oTHf?oi6ATonAUIOoTIVKoi6MWonAXJ?oTJV[oi6][
onA/K?oTKFgoi6i^onA_KooTL73oi79bonAcLooTM7Coi7EeonAfM_oTMgOo
i7QhonAjN_oTNg_oi7alonAmOOoTOWkoi7moonB0P?oTPX;oi8>3onB4Q?oT
QHGoi8J6onB7QooTR8Soi8Z:onB;RooTS8coi8f=onB>S_oTShooi92@onBB
T_oTTi?oi9BDonBEUOoTUYKoi9NGonBHV?oTVY[oi9^KonBLW?oTWIgoi9jN
onBOWooTX:3oi::RonBSXooTY:Coi:FUonBVY_oTYjOoi:RXonBZZ_oTZj_o
i:b/onB][OoT[Zkoi:n_onB`/?oT/[;oi;>conBd]?oT]KGoi;JfonBg]ooT
^;Soi;ZjonBk^ooT_;coi;fmonBn__oT_kooi<30onC1`OoT`l?oi<C4onC5
aOoTa/Koi<O7onC8b?oTbLWoi<_;onC<c?oTcLgoi<k>onC?cooTd=3oi=7A
onCCdooTe=Coi=GEonCFe_oTemOoi=SHonCIfOoTfm_oi=cLonCMgOoTg]ko
i=oOonCPh?oThN7oi>?S7Oo^k^h@oonP00cok^k^0oo]kNd02oo<c<coP820
oeUIFOm4A4Co@D51oeMGEomgMgOo`<30onc/k?o^k^kokNg]01;ok^k^00?o
^KViomgMgOoZj^X01?oZj^XNoo3`l0Goj^[Z00?ogMgMokVi^Oo^k^h0;?o^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNg
oifMW@0^onKViP0FonD00?oU0@7oi@82onD30ooU10Coi@D5onD61_oU20So
i@T9onD:2_oU2`_oi@`<onD=3OoU3PkoiA0@onDA4OoU4Q;oiA<ConDD5?oU
5AGoiAHFonU1@@;okgEe0;3ojDA4onDL7?oU7AgoiAhNonDP8?oU8B7oiB8R
onDS8ooU92CoiBDUonDW9ooU:2SoiBTYonDZ:_oU:b_oiB`/onD];OoU;boo
iC0`onDa<OoU<S;oiC<conDd=?oU=CGoiCLgonDh>?oU>CWoiCXjonDk>ooU
?3coiCdmonDo?ooU@43oiD51onE2@_oU@d?oiDA4onE5AOoUAdOoiDQ8onE9
BOoUBT[oiD];onE<C?oUCTkoiDm?onE@D?oUDE7oiE9BonECDooUE5CoiEIF
onEGEooUF5SoiEUIonEJF_oUFe_oiEaLonENG_oUGeooiF1PonEQHOoUHV;o
iF=SonETI?oUIVKoiFMWonEXJ?oUJFWoiFYZonE[JooUKFgoiFi^onE_KooU
L73oiG5aonEbL_oULg?oiGEeonEfM_oUMgOoiGQhonEiNOoUNW[oiG]konEm
OOoUOWkoiGmoonF0P?oUPH7oiH:2onF3PooUQHGoiHJ6onF7QooUR8SoiHV9
onF:R_oURh_oiHf=onF>S_oUShooiI2@onFATOoUTY;oiIBDonFEUOoUUYKo
iINGonFHV?oUVIWoiIZJonFLW?oUWIgoiIjNonFOWooUX:3oiJ6QonFRX_oU
Y:CoiJFUonFVY_oUYjOoiJRXonFYZOoUZZ[oiJb/onF][OoU[ZkoiJn_onF`
/?oU/K7oiK>conFd]?oU]KGoiKJfonFg]ooU^;SoiKVionFk^ooU_;coiKfm
onFn__oU_kooiL30onG1`OoU`l?oiLC4onG5aOoUa/KoiLO7onG8b?oUbLWo
iL_;onG<c?oUcLgoiLk>onG?cooUd=3oiM7AonGCdooUe=CoiMGEonGFe_oU
emOoiMSHonGJf_oUfm_oiMcLonGMgOoUg]koiMoOonGPh?oUh^;oiN?SonGT
i1goi^KV4?ooV00=onKViP;oiNGU00Soi^KVonGUiOoEeMGobLW9olS8b?oC
dm?ohn?SonKViP;oiNGU4ooVi^H00onJVY[o^KViol;2`P04ol;2`Qko`l?3
1Oo2`/800oni^KWoVYZJonKViP0/onKViP04oifMWOng]kOob<S8om?Cd`7o
f][J00001OoQhN7of][Jolo?conm_KgoXj>S02kok^k^0<SoiP00onH10OoV
0P;oiP<3onH41?oV1@GoiPH6onH82?oV2@WoiPX:onH;2ooV30coiPd=onH?
3ooV413oiQ4AonHB4_oV4a?oiQ@DonHE5OoV5aOoiQPHonHI6OoV6Q[oiQ/K
onHL7?oV7QkoiQlOonHP8?oV8B7oiR8RonHS8ooV92CoiRHVonHW9ooV:2So
iRTYonHZ:_oV:b_oiRd]onH^;_oV;booiS0`onHa<OoV<S;oiS<conHe=OoV
=SKoiSLgonHh>?oV>CWoiSXjonHl??oV?CgoiShnonHo?ooV@43oiT51onI2
@_oVA4CoiTE5onI6A_oVAdOoiTQ8onI9BOoVBd_oiTa<onI=COoVCTkoiTm?
onI@D?oVDE7oiU=ConIDE?oVEEGoiUIFonIGEooVF5SoiUYJonIKFooVG5co
iUeMonING_oVGeooiV1PonIRH_oVHf?oiVATonIUIOoVIVKoiVMWonIYJOoV
JV[oiV][onI/K?oVKFgoiVi^onI_KooVLG7oiW9bonIcLooVM7CoiWEeonIf
M_oVN7SoiWUionIjN_oVNg_oiWalonImOOoVOWkoiX20onJ1POoVPX;oiX>3
onJ4Q?oVQHGoiXN7onJ8R?oVRHWoiXZ:onJ;RooVS8coiXf=onJ?SooVT93o
iY6AonJBT_oVTi?oiYBDonJFU_oVUiOoiYRHonJIVOoVVY[oiY^KonJLW?oV
WYkoiYnOonJPX?oVXJ7oiZ:RonJSXooVYJGoiZJVonJWYooVZ:SoiZVYonJZ
Z_oVZj_oiZf]onJ^[_oV[jooi[2`onJa/OoV/[;oi[BdonJe]OoV][Koi[Ng
onJh^?oV^KWoi[ZjonJl_?oV_Kgoi[jnonJo_ooV`<3oi/71onK3`ooVa<Co
i/G5onK6a_oValOoi/S8onK9bOoVbl_oi/c<onK=cOoVc/koi/o?onK@d?oV
d];oi]?ConKDe?oVeMGoi]KFonKGeooVf=Soi][JonKKfooVg=coi]gMonKN
g_oVgmooi^7QonKRh_oVhn?oi^CTonKUiAgok^k^4?ooT@0/onk^kP03ofUY
JOmgMgOoNg]k00CoNg]k7_mlO7`5og]kN`03ogMgMomYJFWok^k^02cok^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_
[jl0;_ooool0b?oX003oj041onP20_oX0`?oj0@4onP51OoX1PKoj0P8onP9
2OoX2P[oj0/;onP<3?oX3@goj0l?onP@4?oX4A7oj18BonPC4ooX51Coj1HF
onPG5ooX61Soj1TIonPJ6_oX6a_oj1dMonPN7_oX7aooj20PonPQ8OoX8R;o
j2<SonPU9OoX9RKoj2LWonPX:?oX:BWoj2XZonP/;?oX;Bgoj2h^onP_;ooX
<33oj34aonPc<ooX=3Coj3DeonPf=_oX=cOoj3PhonPj>_oX>c_oj3`lonPm
?OoX?Skoj3loonQ0@?oX@T;oj4=3onQ4A?oXADGoj4I6onQ7AooXBDWoj4Y:
onQ;BooXC4coj4e=onQ>C_oXD53oj55AonQBD_oXDe?oj5ADonQEEOoXEeOo
j5QHonQIFOoXFU[oj5]KonQLG?oXGEgoj5mOonQPH?oXHF7oj69RonQSHooX
I6Coj6IVonQWIooXJ6Soj6UYonQZJ_oXJf_oj6e]onQ^K_oXKfooj71`onQa
LOoXLW;oj7AdonQeMOoXMWKoj7MgonQhN?oXNGWoj7YjonQlO?oXOGgoj7in
onQoOooXP83oj861onR3PooXQ8Coj8F5onR6Q_oXQhOoj8R8onR:R_oXRh_o
j8b<onR=SOoXSXkoj8n?onRATOoXTY;oj9>ConRDU?oXUIGoj9JFonRGUooX
VIWoj9ZJonRKVooXW9coj9fMonRNW_oXX:3oj:6QonRRX_oXXj?oj:BTonRU
YOoXYjOoj:RXonRYZOoXZZ[oj:^[onR/[?oX[Zkoj:n_onR`/?oX/K7oj;:b
onRc/ooX];Coj;JfonRg]ooX^;Soj;VionRj^_oX^k_oj;fmonRn__oX_koo
j<30onS1`OoX`/;oj<C4onS5aOoXa/Koj<O7onS8b?oXbLWoj<_;onS<c?oX
cLgoj<k>onS?cooXd=3oj=;BonSCdooXe=Coj=GEonSFe_oXemOoj=SHonSJ
f_oXfm_oj=cLonSMgOoXg]koj=oOonSQhOoXh^;oj>?SonSTi?oXiNGoj>KV
7Oooool@oon908Gooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7Q
hOoJf][oclo?okfm_OnSXj<0;_o^k^h0b?oY003oj@41onT20_oY0`?oj@@4
onT51OoY1PKoj@P8onT92OoY2P[oj@/;onT<3?oY3@goj@l?onT@4?oY4A7o
jA8BonTC4ooY51CojAHFonTG5ooY61SojATIonTJ6_oY6a_ojAdMonTN7_oY
7aoojB0PonTQ8OoY8R;ojB@TonTU9OoY9RKojBLWonTX:?oY:BWojB/[onT/
;?oY;BgojBh^onT_;ooY<33ojC8bonTc<ooY=3CojCDeonTf=_oY=cOojCTi
onTj>_oY>c_ojC`lonTm?OoY?SkojD10onU1@OoY@T;ojD=3onU4A?oYADGo
jDM7onU8B?oYBDWojDY:onU;BooYC4cojDi>onU?CooYD53ojE5AonUBD_oY
De?ojEEEonUFE_oYEeOojEQHonUIFOoYFU[ojEaLonUMGOoYGUkojEmOonUP
H?oYHF7ojF=SonUTI?oYIFGojFIVonUWIooYJ6SojFYZonU[JooYK6cojFe]
onU^K_oYKfoojG5aonUbL_oYLg?ojGAdonUeMOoYMWKojGQhonUiNOoYNW[o
jG]konUlO?oYOGgojGmoonV0P?oYPH7ojH:2onV3PooYQ8CojHJ6onV7QooY
R8SojHV9onV:R_oYRh_ojHf=onV>S_oYShoojI2@onVATOoYTY;ojIBDonVE
UOoYUYKojINGonVHV?oYVIWojI^KonVLW?oYWIgojIjNonVOWooYX:3ojJ:R
onVSXooYY:CojJFUonVVY_oYYjOojJVYonVZZ_oYZj_ojJb/onV][OoY[Zko
jK2`onVa/OoY/[;ojK>conVd]?oY]KGojKNgonVh^?oY^KWojKZjonVk^ooY
_;cojKjnonVo_ooY`<3ojL71onW2`_oY`l?ojLG5onW6a_oYalOojLS8onW9
bOoYb/[ojLc<onW=cOoYc/kojLo?onW@d?oYdM7ojM?ConWDe?oYeMGojMKF
onWGeooYf=SojM[JonWKfooYg=cojMgMonWNg_oYgmoojN7QonWRh_oYhn?o
jNCTonWUiOoYi^KojNSX7Oo^k^h@oon208Gok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0;_oVi^H0b?oZ003o
jP41onX20_oZ0`?ojP@4onX51OoZ1`OojPP8onX92OoZ2P[ojP/;onX<3?oZ
3PkojPl?onX@4?oZ4A7ojQ8BonXC4ooZ5AGojQHFonXG5ooZ61SojQTIonXJ
6_oZ71cojQdMonXN7_oZ7aoojR0PonXR8_oZ8b?ojR@TonXU9OoZ9RKojRLW
onXY:OoZ:R[ojR/[onX/;?oZ;BgojRh^onX`<?oZ<C7ojS8bonXc<ooZ=3Co
jSDeonXg=ooZ>3SojSTionXj>_oZ>c_ojS`lonXn?_oZ?coojT10onY1@OoZ
@T;ojTA4onY5AOoZATKojTM7onY8B?oZBDWojT];onY<C?oZCDgojTi>onY?
CooZD53ojU9BonYCDooZE5CojUEEonYFE_oZEeOojUUIonYJF_oZFe_ojUaL
onYMGOoZGeoojV1PonYQHOoZHV;ojV=SonYTI?oZIVKojVMWonYXJ?oZJFWo
jVYZonY[JooZKFgojVi^onY_KooZL73ojW5aonYbL_oZM7CojWEeonYfM_oZ
MgOojWQhonYiNOoZNg_ojWalonYmOOoZOWkojWmoonZ1POoZPX;ojX>3onZ4
Q?oZQHGojXJ6onZ8R?oZRHWojXZ:onZ;RooZS8cojXf=onZ?SooZT93ojY6A
onZBT_oZTi?ojYBDonZFU_oZUiOojYRHonZIVOoZVY[ojYbLonZMWOoZWYko
jYnOonZPX?oZXJ7ojZ>SonZTY?oZYJGojZJVonZWYooZZ:SojZZZonZ[ZooZ
[:cojZf]onZ^[_oZ[jooj[6aonZb/_oZ/k?oj[BdonZe]OoZ][Koj[RhonZi
^OoZ^[[oj[^konZl_?oZ_[koj[noon[0`?oZ`L7oj/;2on[3`ooZaLGoj/K6
on[7aooZb<Soj/W9on[:b_oZc<coj/g=on[>c_oZclooj]3@on[AdOoZdm?o
j]CDon[EeOoZe]Koj]OGon[IfOoZf][oj]_Kon[Lg?oZgMgoj]kNon[Ph?oZ
hN7oj^;Ron[ShooZi>Coj^GUon[WiooZj>Soj^WY7OoVi^H@oomj02coi^KV
00?o];Bdolo?coo?cll09oo?cll00oo5aLGo];BdonKViP0/onKViP04oifM
WOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S02ko
k^k^0<Soj`00on/10Oo[0P;oj`<3on/41?o[1@Goj`L7on/82?o[2@Woj`X:
on/;2oo[30coj`h>on/?3oo[413oja4Aon/B4_o[51CojaDEon/F5_o[5aOo
jaPHon/I6Oo[6a_oja`Lon/M7Oo[7QkojalOon/Q8Oo[8R;ojb<Son/T9?o[
9BGojbHVon/X:?o[:BWojbXZon/[:oo[;2cojbd]on/_;oo[<33ojc4aon/b
<_o[<c?ojcDeon/f=_o[=cOojcPhon/i>Oo[>S[ojc`lon/m?Oo[?Skojclo
on]0@?o[@T;ojd=3on]4A?o[ADGojdI6on]7Aoo[BDWojdY:on];Boo[C4co
jde=on]?Coo[D53oje5Aon]BD_o[De?ojeADon]FE_o[EeOojeQHon]IFOo[
FU[oje]Kon]MGOo[GUkojemOon]PH?o[HF7ojf=Son]TI?o[IFGojfIVon]W
Ioo[J6SojfYZon][Joo[K6cojfe]on]^K_o[L73ojg5aon]bL_o[Lg?ojgAd
on]eMOo[MgOojgQhon]iNOo[NW[ojg]kon]mOOo[OWkojgmoon^0P?o[PH7o
jh:2on^4Q?o[QHGojhJ6on^7Qoo[R8SojhV9on^;Roo[S8cojhf=on^>S_o[
Shooji6Aon^BT_o[Ti?ojiBDon^EUOo[UYKojiRHon^IVOo[VY[oji^Kon^L
W?o[WYkojinOon^PX?o[XJ7ojj:Ron^SXoo[YJGojjJVon^WYoo[Z:SojjVY
on^[Zoo[[:cojjf]on^^[_o[[joojk2`on^b/_o[/k?ojkBdon^e]Oo[][Ko
jkNgon^i^Oo[^[[ojk^kon^l_?o[_Kgojknoon_0`?o[`L7ojl;2on_3`oo[
a<CojlK6on_7aoo[b<SojlW9on_:b_o[c<cojlg=on_>c_o[cloojm3@on_A
dOo[dm?ojmCDon_EeOo[e]KojmOGon_IfOo[f][ojm_Kon_Lg?o[gMgojmkN
on_Ph?o[hN7ojn;Ron_Shoo[i>CojnGUon_Wioo[j>SojnWYon_ZjQgok^k^
4?ooLP0>onk^kP04ong]kOoYjNWoh^;RomkNgP;of][J00Cog]kNon7QhOoX
j>SokNg]5?o^k^h00oni^KWogMgMonc/k004onc/k1kok^k^1Oo/k>`00ooM
gMgo^KVionk^kP0/onk^kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oob
l_;oj^[ZomkNg_o;bl_o[jn_02kooooo0<Sok@00ond10Oo]0P;ok@<3ond4
1?o]1@Gok@L7ond82?o]2@Wok@X:ond;2oo]3@gok@h>ond?3oo]413okA4A
ondB4_o]51CokADEondF5_o]5aOokAPHondJ6_o]6a_okA`LondM7Oo]7Qko
kB0PondQ8Oo]8R;okB<SondT9?o]9BGokBLWondX:?o]:BWokBXZond[:oo]
;BgokBh^ond_;oo]<33okC4aondb<_o]=3CokCDeondf=_o]=cOokCPhondj
>_o]>c_okC`londm?Oo]?SkokD10one1@Oo]@T;okD=3one4A?o]ADGokDM7
one8B?o]BDWokDY:one;Boo]CDgokDi>one?Coo]D53okE5AoneCDoo]E5Co
kEEEoneFE_o]EeOokEQHoneJF_o]Fe_okEaLoneMGOo]GUkokF1PoneQHOo]
HV;okF=SoneTI?o]IFGokFMWoneXJ?o]JFWokFYZone[Joo]KFgokFi^one_
Koo]L73okG5aonecLoo]M7CokGEeonefM_o]MgOokGQhonejN_o]Ng_okGal
onemOOo]OWkokH20onf1POo]PX;okH>3onf4Q?o]QHGokHN7onf8R?o]RHWo
kHZ:onf;Roo]SHgokHj>onf?Soo]T93okI6AonfCToo]U9CokIFEonfFU_o]
UiOokIRHonfJV_o]Vi_okIbLonfMWOo]WYkokJ2PonfQXOo]XZ;okJ>SonfT
Y?o]YZKokJNWonfXZ?o]ZJWokJZZonf[Zoo][JgokJj^onf_[oo]/;3okK6a
onfc/oo]];CokKFeonff]_o]]kOokKRhonfj^_o]^k_okKblonfm_Oo]_[ko
kL30ong1`Oo]`/;okL?3ong4a?o]a/KokLO7ong8b?o]bLWokL[:ong;boo]
cLgokLk>ong?coo]d=3okM7AongCdoo]e=CokMGEongFe_o]emOokMSHongJ
f_o]fm_okMcLongMgOo]g]kokN3PongQhOo]h^;okN?SongTi?o]i^KokNOW
ongXj?o]jNWokN[Zong[jagooooo4?ooJ`0<ooooo`0>ookno_olo?comOGe
on;Rh_o;bl_o]kNhojb/[?n[Zj_o];BeolS8b?oNg]kol_;booclo?ono_hB
ooooo`03okVi^OoShn?omOGe00ComoOg7_ojn_X5ooOgm`03on?Shoni^KWo
oooo02cooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7QhOoJf][o
clo?okfm_OnSXj<0;_o^k^h0b?o^003okP41onh20_o^0`?okP@4onh51Oo^
1`OokPP8onh92Oo^2P[okP/;onh=3Oo^3PkokPl?onh@4?o^4A7okQ<ConhD
5?o^5AGokQHFonhG5oo^6AWokQXJonhK6oo^71cokQdMonhN7_o^823okR4Q
onhR8_o^8b?okR@TonhV9_o^9bOokRPXonhY:Oo^:R[okR`/onh];Oo^;Rko
kRl_onh`<?o^<S;okS<conhd=?o^=CGokSHfonhh>?o^>CWokSXjonhk>oo^
?3cokSdmonho?oo^@43okT51oni2@_o^@d?okTE5oni6A_o^AdOokTQ8oni9
BOo^Bd_okTa<oni=COo^CTkokTm?oniADOo^DU;okU=ConiDE?o^EEGokUMG
oniHF?o^FEWokUYJoniKFoo^G5cokUiNoniOGoo^H63okV5QoniRH_o^I6Co
kVEUoniVI_o^IfOokVQXoniZJ_o^Jf_okVa/oni]KOo^KVkokW1`oniaLOo^
LW;okW=conidM?o^MWKokWMgonihN?o^NGWokWYjonikNoo^OGgokWinonio
Ooo^P83okX61onj3Poo^Q8CokXF5onj6Q_o^QhOokXV9onj:R_o^Rh_okXb<
onj=SOo^ShookY2@onjATOo^TY;okY>ConjEUOo^UYKokYNGonjHV?o^VIWo
kYZJonjLW?o^WIgokYjNonjOWoo^X:3okZ:RonjSXoo^Y:CokZFUonjVY_o^
Z:SokZVYonjZZ_o^Zj_okZb/onj^[_o^[jook[2`onja/Oo^/[;ok[Bdonje
]Oo^][Kok[Ngonjh^?o^^KWok[^konjl_?o^_Kgok[jnonjo_oo^`L7ok/;2
onk3`oo^a<Cok/G5onk7aoo^b<Sok/W9onk:b_o^bl_ok/g=onk>c_o^cloo
k]3@onkAdOo^dm?ok]CDonkEeOo^e]Kok]OGonkHf?o^f][ok]_KonkLg?o^
gMgok]kNonkPh?o^hN7ok^;RonkShoo^i>Cok^KVonkWioo^j>Sok^WYonkZ
j_o^k>cok^g]7Oo^k^h@oomS00_ok^k^013okNg]on_[jooPh>3oa/K6oj:R
X_n2PX;oKVi^of=SHomRHV;oJf][oginO_nMWIgo`/;2omoOgoo[jn_okNg]
4Oo^k^h00oni^KWohn?SooGem@0Vooooo`03ooOgmooShn?o^KVi02gok^k^
00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onM
WId0;_oVi^H0b?o_003ok`41onl20_o_0`?ok`@4onl51Oo_1`Ook`P8onl9
2Oo_2P[ok`/;onl=3Oo_3Pkok`l?onl@4?o_4A7oka<ConlD5?o_5AGokaHF
onlG5oo_6AWokaXJonlK6oo_71cokadMonlO7oo_823okb4QonlR8_o_8b?o
kbDUonlV9_o_9bOokbPXonlY:Oo_:b_okb`/onl];Oo_;Rkokbl_onla<Oo_
<S;okc<conld=?o_=CGokcLgonlh>?o_>CWokcXjonlk>oo_?Cgokchnonlo
?oo_@43okd51onm3@oo_A4CokdE5onm6A_o_AdOokdU9onm:B_o_Bd_okda<
onm=COo_Cdooke1@onmADOo_DU;oke=ConmEEOo_EUKokeMGonmHF?o_FEWo
ke]KonmLG?o_GEgokeiNonmOGoo_HF7okf9RonmSHoo_I6CokfEUonmWIoo_
J6SokfUYonmZJ_o_Jf_okfe]onm^K_o_Kfookg1`onmaLOo_Lg?okgAdonme
MOo_MWKokgMgonmiNOo_NW[okg]konmlO?o_OGgokgmoonn0P?o_PH7okh:2
onn3Poo_QHGokhJ6onn7Qoo_R8SokhV9onn;Roo_S8cokhf=onn>S_o_Shoo
ki6AonnBT_o_Ti?okiBDonnEUOo_UiOokiRHonnIVOo_VY[oki^KonnMWOo_
WYkokinOonnPX?o_XJ7okj:RonnTY?o_YJGokjJVonnWYoo_Z:SokjZZonn[
Zoo_[:cokjf]onn^[_o_/;3okk6aonnb/_o_/k?okkBdonnf]_o_]kOokkRh
onni^Oo_^[[okkblonnm_Oo__[kokknoono0`?o_`/;okl?3ono4a?o_aLGo
klK6ono8b?o_bLWokl[:ono;boo_c<coklk>ono?coo_d=3okm7AonoBd_o_
e=CokmGEonoFe_o_emOokmSHonoJf_o_fm_okmcLonoMgOo_g]kokn3PonoQ
hOo_h^;okn?SonoTi?o_i^KoknOWonoXj?o_jNWokn[Zono/k?o_kNgoknk^
7OoVi^H@oomK00_oi^KV013oiNGUomcLg?o0`<3oUIFEofUZK?mXLg[oQ9ZU
oinn`onS`LKoQijYofahP_mVIf[oShn?ok^k^ooIfMWoi>CT4OoVi^H00oni
^KWohn?SooGem@0Vooooo`03ooOgmooShn?o^KVi02goi^KV00CoWIfMokNg
]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h0
b?o`003ol041oo020_o`0`?ol0@4oo061_o`1`Ool0P8oo092Oo`2P[ol0`<
oo0=3Oo`3Pkol0l?oo0@4?o`4Q;ol1<Coo0D5?o`5AGol1HFoo0H6?o`6AWo
l1XJoo0K6oo`71col1hNoo0O7oo`823ol24Qoo0R8_o`92Col2DUoo0V9_o`
9bOol2PXoo0Z:_o`:b_ol2`/oo0];Oo`;Rkol30`oo0a<Oo`<S;ol3<coo0e
=Oo`=SKol3Lgoo0h>?o`>CWol3/koo0l??o`?Cgol3hnoo0o?oo`@D7ol492
oo13@oo`A4Col4E5oo17Aoo`B4Sol4U9oo1:B_o`Bd_ol4e=oo1>C_o`Cdoo
l51@oo1ADOo`De?ol5ADoo1EEOo`EUKol5MGoo1IFOo`FU[ol5]Koo1LG?o`
GEgol5mOoo1PH?o`HF7ol69Roo1TI?o`IFGol6IVoo1WIoo`J6Sol6YZoo1[
Joo`K6col6e]oo1^K_o`L73ol75aoo1bL_o`Lg?ol7Adoo1fM_o`MgOol7Qh
oo1iNOo`NW[ol7aloo1mOOo`OWkol7mooo20P?o`PX;ol8>3oo24Q?o`QHGo
l8J6oo28R?o`RHWol8Z:oo2;Roo`S8col8j>oo2?Soo`T93ol96Aoo2BT_o`
U9Col9FEoo2FU_o`UiOol9VIoo2JV_o`Vi_ol9bLoo2MWOo`Wiool:2Poo2Q
XOo`XZ;ol:>Soo2UYOo`YZKol:NWoo2XZ?o`ZJWol:^[oo2/[?o`[Jgol:j^
oo2_[oo`/K7ol;:boo2c/oo`];Col;Feoo2g]oo`^;Sol;Vioo2j^_o`^k_o
l;fmoo2n__o`_kool<30oo31`Oo``l?ol<C4oo35aOo`a/Kol<S8oo39bOo`
b/[ol<_;oo3<c?o`c/kol<o?oo3@d?o`dM7ol=;Boo3De?o`eMGol=KFoo3G
eoo`f=Sol=[Joo3Kfoo`g=col=gMoo3Ng_o`h>3ol>7Qoo3Rh_o`hn?ol>CT
oo3Vi_o`inOol>SXoo3YjOo`j^[ol>c/oo3]kOo`k^kol>o_7Oo^k^h@oomD
00[ok^k^01;okNg]onWYjOoEeMGoYZJVofmdNon0V[7o_^[iomGooooJoooo
f?ooom;noonok?ooRJ>nofedNonNWYkod=3@onOWioo]kNd5onk^kP03oc8b
<_m/K6cok^k^00?ok^k^00?o0P82oi^KVoo^k^h00_o^k^h00oni^KWohn?S
ooGem@0Vooooo`03ooOgmooShn?o^KVi02gok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN400005oo;bl_oZj^[og]kNol_;bon_[jl0;_ooool0b?ob003o
lP41oo820_ob0`?olP@4oo861_ob1`OolPP8oo892Oob2P[olP`<oo8=3Oob
3PkolPl?oo8@4?ob4Q;olQ<Coo8D5?ob5AGolQLGoo8H6?ob6AWolQXJoo8K
6oob7AgolQhNoo8O7oob823olR4Qoo8S8oob92ColRDUoo8V9_ob9bOolRTY
oo8Z:_ob:b_olR`/oo8^;_ob;boolS0`oo8a<Oob<S;olS@doo8e=Oob=SKo
lSLgoo8h>?ob>S[olS/koo8l??ob?CgolShnoo90@?ob@D7olT92oo93@oob
ADGolTI6oo97AoobB4SolTU9oo9;BoobC4colTe=oo9>C_obCdoolU5Aoo9B
D_obDe?olUADoo9EEOobEeOolUQHoo9IFOobFU[olUaLoo9MGOobGUkolUmO
oo9PH?obHV;olV=Soo9TI?obIFGolVIVoo9XJ?obJFWolVYZoo9[JoobKFgo
lVi^oo9_KoobL73olW5aoo9cLoobM7ColWEeoo9fM_obMgOolWUioo9jN_ob
Ng_olWaloo9mOOobOgoolX20oo:1POobPX;olXB4oo:5QOobQXKolXN7oo:8
R?obRX[olX^;oo:<S?obSHgolXj>oo:@T?obTI7olY:Boo:CToobU9ColYJF
oo:GUoobV9SolYVIoo:KVoobW9colYfMoo:NW_obWioolZ6Qoo:RX_obXj?o
lZBToo:UYOobYjOolZRXoo:YZOobZZ[olZ^[oo:][Oob[ZkolZn_oo:`/?ob
/[;ol[>coo:d]?ob]KGol[Jfoo:h^?ob^KWol[Zjoo:k^oob_;col[jnoo:o
_oob`<3ol/71oo;3`ooba<Col/G5oo;6a_obalOol/W9oo;:b_obbl_ol/c<
oo;=cOobclool]3@oo;AdOobd];ol]?Coo;EeOobe]Kol]OGoo;Hf?obf][o
l]_Koo;Lg?obgMgol]kNoo;Ph?obhN7ol^;Roo;Shoobi>Col^KVoo;Wioob
j>Sol^WYoo;Zj_obk>col^g]oo;^k_obknool_7a7Oooool@oom<00[ooooo
01;oo_knooCdm?oCdm?oRHf@ognL_onehooo`o3ookoZo?ndg_?o/]cbokOU
nonljooo]nCoohJVbon0QXcoc<c<oo7alOomoOd5ooooo`03ocHf=_mdM7Co
oooo00?ooooo00?o0`<3ojNWYoooool00_ooool00oni^KWohn?SooGem@0V
ooooo`03ooOgmooShn?o^KVi02gooooo00Co[jn_ol_;booNg]koj^[Z0Oob
l_800005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h0b?oc003ol`41oo<2
0_oc0`?ol`@4oo<61_oc1`Ool`P8oo<92Ooc2P[ol``<oo<=3Ooc3Pkol`l?
oo<A4Ooc4Q;ola<Coo<D5?oc5AGolaLGoo<H6?oc6AWolaXJoo<L7?oc7Ago
lahNoo<O7ooc823olb8Roo<S8ooc92ColbDUoo<V9_oc:2SolbTYoo<Z:_oc
:b_olbd]oo<^;_oc;boolc0`oo<a<Ooc<c?olc@doo<e=Ooc=SKolcPhoo<i
>Ooc>S[olc/koo<l??oc?Skolclooo=0@?oc@D7old92oo=4A?ocADGoldI6
oo=7AoocBDWoldY:oo=;BoocC4colde=oo=?CoocD53ole5Aoo=BD_ocE5Co
leEEoo=FE_ocEeOoleQHoo=JF_ocFe_oleaLoo=MGOocGUkolf1Poo=QHOoc
HV;olf=Soo=UIOocIVKolfMWoo=XJ?ocJFWolf][oo=/K?ocKFgolfi^oo=`
L?ocLG7olg9boo=cLoocM7ColgIfoo=gMoocN7SolgUioo=jN_ocO7colgem
oo=nO_ocOgoolh61oo>2P_ocPh?olhB4oo>5QOocQhOolhR8oo>9ROocRX[o
lhb<oo>=SOocSXkolhn?oo>@T?ocTY;oli>Coo>DU?ocUIGoliJFoo>HV?oc
VIWoliZJoo>KVoocWIgolijNoo>OWoocX:3olj6Qoo>SXoocY:ColjFUoo>V
Y_ocZ:SoljVYoo>ZZ_ocZj_oljb/oo>^[_oc[joolk2`oo>a/Ooc/[;olkBd
oo>e]Ooc][KolkNgoo>i^Ooc^[[olk^koo>l_?oc_Kgolknooo?0`?oc`L7o
ll;2oo?4a?ocaLGollK6oo?7aoocb<Soll[:oo?;boocc<collg=oo?>c_oc
d=3olm7Aoo?Bd_ocdm?olmGEoo?Fe_ocemOolmSHoo?IfOocfm_olmcLoo?M
gOocg]koln3Poo?QhOoch^;oln?Soo?Ti?oci^KolnOWoo?Xj?ocjNWoln_[
oo?/k?ockNgolnk^oo?_kooclO7olo;b2oo^k^h01oo]kNgojn_[onGUiOoT
i>CoiNGUon_[joo]kNd02oo^k^h@oom400[ok^k^01;ok>c/on3Ph?n_/;3o
Kh>Hoi_:mon`gOko/=_noj;9jonE^]KoT[SDoi[1j?nXeOcoZM[noiO7o?m/
QJ3oXjBVomkNg_o[jn/5onk^kP03oc8b<_m/K6cok^k^00?ok^k^00?o0P82
oi^KVoo^k^h00_o^k^h00oni^KWohn?Soo[jnP0Vooooo`03oo[jn_oShn?o
^KVi02gok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005om[Jf_oCdm?o
b<S8okNg]onMWId0;_oVi^H0b?od003om041oo@20_od0`?om0@4oo@61_od
1`Oom0P8oo@92Ood2`_om0`<oo@=3Ood3Pkom0l?oo@A4Ood4Q;om1<Coo@D
5?od5QKom1LGoo@H6?od6AWom1XJoo@L7?od7Agom1hNoo@O7ood8B7om28R
oo@S8ood92Com2DUoo@W9ood:2Som2TYoo@Z:_od;2com2d]oo@^;_od;boo
m30`oo@b<_od<c?om3@doo@e=Ood=cOom3Phoo@i>Ood>S[om3/koo@m?Ood
?Skom3loooA0@?od@T;om4=3ooA4A?odADGom4I6ooA8B?odBDWom4Y:ooA;
BoodCDgom4i>ooA?CoodD53om59BooACDoodE5Com5EEooAFE_odF5Som5UI
ooAJF_odFe_om5eMooANG_odGeoom61PooAQHOodHf?om6ATooAUIOodIVKo
m6QXooAYJOodJV[om6][ooA/K?odKVkom6m_ooA`L?odLG7om7=cooAdM?od
MGGom7IfooAgMoodNGWom7YjooAkNoodO7com7inooAoOoodP83om861ooB2
P_odQ8Com8F5ooB6Q_odQhOom8V9ooB:R_odRh_om8b<ooB=SOodShoom92@
ooBATOodTY;om9BDooBEUOodUYKom9NGooBHV?odVY[om9^KooBLW?odWIgo
m9nOooBPX?odXJ7om::RooBTY?odYJGom:JVooBWYoodZ:Som:ZZooB[Zood
[:com:f]ooB_[ood/;3om;6aooBb/_od/k?om;FeooBf]_od]kOom;RhooBj
^_od^k_om;blooBm_Ood_[kom<30ooC1`Ood`/;om<?3ooC5aOoda/Kom<O7
ooC8b?odbLWom<_;ooC<c?odcLgom<k>ooC@d?oddM7om=;BooCCdoode=Co
m=KFooCGeoodf=Som=WIooCKfoodg=com=gMooCNg_odgmoom>7QooCRh_od
hn?om>CTooCVi_odinOom>SXooCYjOodjn_om>c/ooC]kOodk^kom>o_ooCa
lOodl_;om??c2_oVi^H02OoNg]kocLg=oj2PX?n6QXKoL71`ohJ6Q_nUYJGo
cLg=omkNgP0:onKViQ3oocd02_oVi^H04_oRh^;ofm_KoiFIWOm`Ul;oU/Sm
oj;Ao_nMb?KoLi:bodEFIom0D63oJHJUoiFok_nJc?koSl?joffIb?n7S9?o
f=SHon;RhPGoi^KV00?o<30`ofQXJ?oVi^H00ooVi^H00ol20P;oUYJFonKV
iP02onKViP03okVi^OoShn?on_[j02Kooooo00?on_[jon?Shoni^KT0;OoV
i^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfm
oj>SX`0^onk^kP38ooH00?of0@7omP82ooH30oof10ComPH6ooH71oof20So
mPT9ooH;2oof30comPd=ooH>3_of3`oomQ4AooHB4_of4a?omQ@DooHF5_of
5aOomQPHooHI6Oof6a_omQ`LooHM7Oof7QkomQlOooHQ8Oof8R;omR<SooHT
9?of9RKomRLWooHX:?of:BWomR/[ooH/;?of;BgomRh^ooH_;oof<C7omS8b
ooHc<oof=3ComSHfooHg=oof>3SomSTiooHk>oof?3comSdmooHn?_of?coo
mT51ooI2@_of@d?omTA4ooI6A_ofAdOomTQ8ooI9BOofBd_omTa<ooI=COof
CTkomTm?ooIADOofDU;omU=CooIDE?ofEUKomUMGooIHF?ofFEWomU]KooIL
G?ofGEgomUiNooIOGoofHF7omV9RooISHoofI6ComVIVooIWIoofJ6SomVUY
ooI[JoofK6comVe]ooI^K_ofKfoomW5aooIbL_ofLg?omWAdooIfM_ofMgOo
mWQhooIiNOofNg_omWalooImOOofOWkomWmoooJ1POofPX;omX>3ooJ4Q?of
QXKomXN7ooJ8R?ofRHWomX^;ooJ<S?ofSHgomXj>ooJ?SoofTI7omY:BooJC
ToofU9ComYJFooJGUoofV9SomYVIooJKVoofW9comYfMooJNW_ofWioomZ6Q
ooJRX_ofXj?omZBTooJVY_ofYjOomZRXooJYZOofZj_omZb/ooJ][Oof[Zko
mZn_ooJa/Oof/[;om[>cooJd]?of][Kom[NgooJh^?of^KWom[^kooJl_?of
_Kgom[jnooJo_oof`L7om/;2ooK3`oofa<Com/K6ooK7aoofb<Som/W9ooK;
boofc<com/g=ooK>c_ofcloom]7AooKBd_ofdm?om]CDooKFe_ofemOom]SH
ooKIfOoffm_om]cLooKMgOofg]kom]oOooKQhOofh^;om^?SooKTi?ofi^Ko
m^OWooKXj?ofjNWom^_[ooK/k?ofkNgom^k^ooK_kooflO7om_;booKcloof
m?@9onk^kP0;onCTi?nl_;coOX21ogR<SOnI]KGo//g<oiVe]OmiS8koOX21
okbl_?oTi>@02Oo^k^h@oole00[ok^k^00SojNWYonKVi_n@UYcoIYO?ohFi
lOnCaO_oRKCRobPd@`;o000000So72HaogZQd?n?`__oOk;]of6EdOmkQY?o
h^;RonWYj@Gok^k^00?o<S8bobh^;_mWIfL00omWIfL00ol0003oVi^Konk^
kP02onk^kP03okVi^OoShn?on_[j02Kooooo00?on_[jon?Shoni^KT0;Oo^
k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;
ojn_[`0^ooooo`38ooL00?og0@7om`82ooL30oog10Com`H6ooL71oog20So
m`T9ooL;2oog30com`d=ooL>3_og413oma4AooLB4_og4a?omaDEooLF5_og
5aOomaPHooLI6Oog6a_oma`LooLM7Oog7Qkomb0PooLQ8Oog8R;omb<SooLU
9Oog9RKombLWooLX:?og:R[omb/[ooL/;?og;Bgombh^ooL`<?og<C7omc8b
ooLc<oog=CGomcHfooLg=oog>3SomcXjooLk>oog?3comcdmooLo?oog@43o
md51ooM2@_ogA4ComdE5ooM6A_ogAdOomdQ8ooM:B_ogBd_omda<ooM=COog
Cdoome1@ooMADOogDU;omeADooMEEOogEUKomeMGooMIFOogFU[ome]KooML
G?ogGEgomemOooMPH?ogHF7omf9RooMTI?ogIFGomfIVooMWIoogJFWomfYZ
ooM[JoogK6comfi^ooM_KoogL73omg5aooMcLoogM7ComgEeooMfM_ogMgOo
mgUiooMjN_ogNg_omgalooMnO_ogOgoomh20ooN1POogPh?omhB4ooN5QOog
QXKomhR8ooN9ROogRX[omh^;ooN<S?ogSXkomhn?ooN@T?ogTI7omi>CooND
U?ogUIGomiJFooNHV?ogVIWomiZJooNKVoogWIgomijNooNOWoogX:3omj:R
ooNSXoogY:ComjFUooNVY_ogZ:SomjVYooNZZ_ogZj_omjf]ooN^[_og[joo
mk2`ooNb/_og/k?omkBdooNe]Oog]kOomkRhooNi^Oog^[[omk^kooNm_Oog
_[komknoooO0`?og`/;oml?3ooO4a?ogaLGomlO7ooO8b?ogbLWoml[:ooO<
c?ogcLgomlk>ooO?coogdM7omm;BooOCdooge=CommGEooOGeoogf=SommWI
ooOJf_ogg=commgMooONg_oggmoomn7QooORh_oghn?omnCTooOVi_oginOo
mnSXooOYjOogj^[omnc/ooO]kOogk^komno_ooOalOogl_;omo?cooOdm?og
m_H7ooooo`0>ookno_ogmoOobLW9ogImQOn4X[Wo_N_domWoo_oZoooofOon
okg[m?n4X[WoMWf5olW9bOogmoL8oooooa3oobd02_ooool01ooinOWoo_kn
oiFLY?mDS<[oLZGPogbck_mdY=L00_l10@802Ol310Ko0000of28]omn]oGo
Jj7Modf6bomgQIKooOgmoo[jnP05ooooo`03ocHf=_m1@D7oT92@00?oT92@
00?o0P82ojNWYoooool00_ooool00oni^KWohn?Soo[jnP0Vooooo`03oo[j
n_oShn?o^KVi02gooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7Q
hOoJf][oclo?okfm_OnSXj<0;_o^k^h0b?oh003on041ooP20_oh0`?on0@4
ooP61_oh1`Oon0P8ooP92Ooh2`_on0`<ooP=3Ooh3Pkon10@ooPA4Ooh4Q;o
n1<CooPE5Ooh5QKon1LGooPH6?oh6Q[on1/KooPL7?oh7Agon1lOooPP8?oh
8B7on28RooPT9?oh9BGon2HVooPW9ooh:BWon2XZooP[:ooh;2con2d]ooP_
;ooh<33on34aooPb<_oh=3Con3DeooPf=_oh=cOon3TiooPj>_oh>c_on3`l
ooPn?_oh?coon410ooQ1@Ooh@d?on4A4ooQ5AOohATKon4Q8ooQ9BOohBT[o
n4];ooQ=COohCTkon4m?ooQ@D?ohDU;on5=CooQDE?ohEEGon5MGooQHF?oh
FEWon5YJooQKFoohGEgon5iNooQOGoohH63on69RooQSHoohI6Con6EUooQW
IoohJ6Son6UYooQZJ_ohK6con6e]ooQ^K_ohKfoon75aooQbL_ohLg?on7Ad
ooQfM_ohMgOon7QhooQiNOohNg_on7alooQmOOohOWkon820ooR1POohPX;o
n8>3ooR5QOohQXKon8N7ooR8R?ohRHWon8^;ooR<S?ohSHgon8j>ooR@T?oh
TI7on9:BooRCToohUIGon9JFooRGUoohV9Son9ZJooRKVoohW9con9fMooRO
WoohX:3on:6QooRRX_ohY:Con:FUooRVY_ohYjOon:VYooRZZ_ohZj_on:b/
ooR^[_oh[joon;2`ooRa/Ooh/k?on;BdooRe]Ooh][Kon;NgooRi^Ooh^[[o
n;^kooRl_?oh_[kon;noooS0`?oh`L7on<?3ooS4a?ohaLGon<K6ooS8b?oh
bLWon<[:ooS;boohcLgon<k>ooS?coohd=3on=;BooSCdoohe=Con=GEooSG
eoohf=Son=WIooSJf_ohg=con=gMooSNg_ohgmoon>7QooSRh_ohhn?on>CT
ooSUiOohinOon>SXooSYjOohj^[on>c/ooS]kOohk^kon>o_ooSalOohl_;o
n??cooSdm?ohm_Kon?Og1oo^k^h03_oYjNWodm?Cogb2ROmgWLKoZm_kok[Y
ooo0k?ooa?3ool3/oonjjOooZm_kogNMa_mlPXWodm?C2?o^k^h@oolV00[o
k^k^00SoinOWonk^k_nGWJCo<f^_odn:c?mOVN3oHIWIoa/X=P;o104000So
4Q/SoeN;a_mNVn?oBHK:obMT[_mjQICok^k^onWYj@Gok^k^00?o<S8bofa/
K?o^k^h00oo^k^h00ol20P;oVi^Konk^kP02onk^kP03okVi^OoShn?on_[j
02Kooooo00?on_[jon?Shoni^KT0;Oo^k^h01?nSXj?o_Kfmolo?cooJf]X1
on7Qh@0000Gof][Jom?Cdoo8b<So]kNgoifMW@0^onKViP38ooT00?oi0@7o
n@82ooT30ooi10Con@H6ooT71ooi20Son@T9ooT;2ooi30con@d=ooT>3_oi
413onA4AooTB4_oi4a?onADEooTF5_oi5aOonAPHooTJ6_oi6a_onA`LooTM
7Ooi7aoonB0PooTQ8Ooi8R;onB@TooTU9Ooi9RKonBLWooTY:Ooi:R[onB/[
ooT/;?oi;RkonBl_ooT`<?oi<C7onC<cooTd=?oi=CGonCHfooTh>?oi>CWo
nCXjooTk>ooi?CgonChnooTo?ooi@43onD92ooU3@ooiA4ConDE5ooU7Aooi
B4SonDU9ooU:B_oiC4conDe=ooU>C_oiCdoonE5AooUBD_oiDe?onEADooUF
E_oiEeOonEQHooUIFOoiFe_onEaLooUMGOoiGUkonF1PooUQHOoiHV;onF=S
ooUUIOoiIVKonFMWooUXJ?oiJV[onF][ooU/K?oiKFgonFm_ooU`L?oiLG7o
nG9booUdM?oiMGGonGIfooUgMooiNGWonGYjooUkNooiO7conGinooUoOooi
P83onH61ooV3PooiQ8ConHF5ooV6Q_oiR8SonHV9ooV:R_oiRh_onHf=ooV>
S_oiShoonI2@ooVBT_oiTi?onIBDooVEUOoiUiOonIRHooVIVOoiVY[onIbL
ooVMWOoiWYkonInOooVQXOoiXZ;onJ>SooVTY?oiYZKonJNWooVXZ?oiZJWo
nJ^[ooV/[?oi[JgonJj^ooV`/?oi/K7onK:booVc/ooi]KGonKJfooVg]ooi
^;SonKZjooVk^ooi_;conKfmooVo_ooi`<3onL71ooW2`_oia<ConLG5ooW6
a_oialOonLW9ooW:b_oibl_onLc<ooW>c_oicloonM3@ooWAdOoidm?onMCD
ooWEeOoie]KonMSHooWIfOoif][onM_KooWMgOoig]konMoOooWPh?oih^;o
nN?SooWTi?oiiNGonNOWooWXj?oijNWonN[ZooW/k?oikNgonNk^ooW_kooi
lO7onO;booWclooim?ConOKfooWgmooin?P7onKViP0?omWIfOnTYZSoHGjM
ohBgkonIaoWoXlojojkGooncg?oo[]Oooj??n_nIaoWoQ;O_of5nWOnTYZSo
iNGU00Ooi^KV4?oo7P0:onKViP0Bon7QhOoVi^Ko[[6eobIHTolXJKCoA8?=
oe^Ff_mIQkSoA5Q/od9DIOmEOjcoF9GFodB6d?lTI[?o54N@oiRMY_oVi^Ko
h^;R1OoVi^H00ol`<33oJ6QXonKViP03onKViP03o`820_nFUYKoi^KV00;o
i^KV00?o^KVion?ShooemOD09_ooool00oogmoOohn?SokVi^@0]onKViP04
oifMWOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S
02kok^k^0<Son`00oo/10Ook0P;on`<3oo/51Ook1PKon`L7oo/82?ok2P[o
n`/;oo/<3?ok3@gon`l?oo/@4?ok4A7ona8Boo/D5?ok5AGonaHFoo/G5ook
6AWonaXJoo/K6ook71conahNoo/O7ook823onb4Qoo/S8ook92ConbDUoo/V
9_ok:2SonbTYoo/Z:_ok:b_onbd]oo/^;_ok;boonc0`oo/b<_ok<c?onc@d
oo/f=_ok=cOoncPhoo/i>Ook>c_onc`loo/m?Ook?Skond10oo]1@Ook@T;o
nd=3oo]5AOokATKondM7oo]8B?okBT[ond];oo]<C?okCDgondm?oo]@D?ok
DE7one9Boo]DE?okEEGoneIFoo]GEookFEWoneYJoo]KFookG5coneiNoo]O
GookH63onf5Qoo]SHookI6ConfEUoo]VI_okJ6SonfUYoo]ZJ_okK6confe]
oo]^K_okKfoong5aoo]bL_okLg?ongAdoo]fM_okMgOongQhoo]iNOokNg_o
ngaloo]mOOokOWkonh20oo^1POokPX;onh>3oo^5QOokQXKonhN7oo^8R?ok
RX[onh^;oo^<S?okSHgonhn?oo^@T?okTI7oni:Boo^DU?okUIGoniJFoo^G
UookVIWoniZJoo^KVookW9conijNoo^OWookX:3onj:Roo^SXookY:ConjFU
oo^WYookZ:SonjVYoo^ZZ_ok[:conjf]oo^^[_ok[joonk6aoo^b/_ok/k?o
nkBdoo^f]_ok]kOonkRhoo^i^Ook^k_onkbloo^m_Ook_[konl30oo_1`Ook
`/;onl?3oo_5aOoka/KonlO7oo_8b?okb/[onl_;oo_<c?okcLgonlo?oo_@
d?okdM7onm;Boo_De?okeMGonmKFoo_Hf?okfMWonm[Joo_KfookgMgonmkN
oo_Ogookh>3onn;Roo_Shooki>ConnGUoo_Wiookj>SonnWYoo_Zj_okk>co
nng]oo_^k_okknoono7aoo_bl_oklo?onoCdoo_fm_okmoOonoShoo_in@Oo
k^k^00ooemOGohZAVOmAPk[oL:KSohBbiOnD`>koW/Keoj;;n?nNa_GoU<3^
ohBbiOm`Y^?oDH>johZAVOoZj^X01oo^k^h@oolF00[ok^k^01;ojn_[onk^
k_oNg]ooDffEoa58U?llMKkoMJ3MoiNik?nXaOSo[<_loj73m?n3ZnCoAg[3
oa8nU?lkBX?od];Eonk^k_o/k>`5onk^kP03oc8b<_m/K6cok^k^00?ok^k^
00?o0P82oi^KVoo^k^h00_o^k^h00oni^KWohn?SooGem@0Vooooo`03ooOg
mooShn?o^KVi02gok^k^00CoXj>Sokfm_Oo?cloof][J0OoQhN400005oo;b
l_oZj^[og]kNol_;bon_[jl0;_ooool0b?ol003oo041oo`20_ol0`?oo0D5
oo`61_ol1`Ooo0P8oo`:2_ol2`_oo0`<oo`=3Ool3`ooo10@oo`A4Ool4Q;o
o1@Doo`E5Ool5QKoo1LGoo`I6Ool6Q[oo1/Koo`M7Ool7Qkoo1lOoo`P8?ol
8R;oo2<Soo`T9?ol9BGoo2LWoo`X:?ol:BWoo2XZoo`/;?ol;Bgoo2h^oo`_
;ool<C7oo38boo`c<ool=CGoo3Hfoo`g=ool>3Soo3Xjoo`k>ool?3coo3dm
oo`o?ool@43oo451ooa2@_olA4Coo4E5ooa6A_olAdOoo4U9ooa:B_olBd_o
o4a<ooa>C_olCdooo51@ooaBD_olDe?oo5ADooaEEOolEeOoo5QHooaIFOol
FU[oo5aLooaMGOolGUkoo5mOooaQHOolHV;oo6=SooaTI?olIVKoo6MWooaX
J?olJV[oo6][ooa/K?olKFgoo6m_ooa`L?olLG7oo79booadM?olMGGoo7If
ooagMoolNGWoo7YjooakNoolO7coo7inooaoOoolP83oo8:2oob3PoolQ8Co
o8F5oob7QoolR8Soo8V9oob:R_olS8coo8f=oob>S_olShooo96AoobBT_ol
Ti?oo9BDoobFU_olUiOoo9RHoobIVOolVi_oo9bLoobMWOolWiooo:2PoobQ
XOolXZ;oo:BToobUYOolYZKoo:NWoobYZOolZZ[oo:^[oob/[?ol[Zkoo:n_
oob`/?ol/K7oo;>coobd]?ol]KGoo;Ngoobh^?ol^KWoo;Zjoobl_?ol_Kgo
o;jnoobo_ool`L7oo<;2ooc3`oola<Coo<K6ooc7aoolb<Soo<W9ooc;bool
c<coo<g=ooc?coold=3oo=7AoocBd_ole=Coo=GEoocFe_olemOoo=WIoocJ
f_olfm_oo=cLoocNg_olgmooo>3PoocQhOolhn?oo>CToocUiOoli^Koo>SX
oocYjOolj^[oo>c/ooc]kOolk^koo>o_oocalOoll_;oo??coocdm?olm_Ko
o?Ogoochn?olnOWoo?_k1oooool03ooShn?oPhjLocag_?mESlooK9kFog^Z
gOn7/nGoSKSYohNciOmkZmgoK9kFoeJ?collMkcoPhjLooWin@07oooooa3o
o`l02oooool04?olo?coooooolC7d?ld@h?o=DBFogn3a?ng]^;odlo_om[E
l?o8aNSoVYgAodmDWOl`<GKo[jnoooooooolo?`6ooooo`03ok2`/?o8b<So
oooo00?ooooo00?oW9bLomcLg?ooool00_ooool00oni^KWohn?SooGem@0V
ooooo`03ooOgmooShn?o^KVi02gooooo00Co[jn_ol_;booNg]koj^[Z0Oob
l_800005on7QhOoJf][oclo?okfm_OnSXj<0;_o^k^h0b?om003oo@41ood2
0_om0`?oo@D5ood61_om1`Ooo@P8ood:2_om2`_oo@`<ood=3Oom3`oooA0@
oodA4Oom4a?ooA@DoodE5Oom5QKooAPHoodI6Oom6Q[ooA/KoodM7Oom7Qko
oAlOoodP8?om8R;ooB<SoodT9?om9RKooBLWoodX:?om:BWooB/[ood/;?om
;BgooBh^ood`<?om<C7ooC8boodd=?om=CGooCHfoodg=oom>CWooCXjoodk
>oom?3cooChnoodo?oom@43ooD51ooe3@oomA4CooDE5ooe7AoomB4SooDU9
ooe:B_omC4cooDe=ooe>C_omCdoooE5AooeBD_omDe?ooEADooeFE_omEeOo
oEQHooeJF_omFe_ooEaLooeMGOomGeoooF1PooeQHOomHV;ooFATooeUIOom
IVKooFQXooeYJOomJV[ooF][ooe]KOomKVkooFm_ooe`L?omLW;ooG=cooed
M?omMGGooGMgooehN?omNGWooG]kooelO?omOGgooGinoof0P?omPH7ooH:2
oof3PoomQHGooHJ6oof7QoomRHWooHZ:oof;RoomS8cooHj>oof?SoomT93o
oI6AoofCToomU9CooIFEoofFU_omV9SooIVIoofJV_omW9cooIfMoofNW_om
WioooJ6QoofRX_omXj?ooJBToofVY_omYjOooJRXoofYZOomZj_ooJb/oof]
[Oom[joooK2`oofa/Oom/[;ooKBdoofe]Oom][KooKNgoofi^Oom^[[ooK^k
oofm_Oom_[kooKnooog0`?om`/;ooL?3oog4a?omaLGooLO7oog8b?ombLWo
oL[:oog<c?omcLgooLk>oog@d?omdM7ooM;BoogCdoomeMGooMKFoogGeoom
f=SooM[JoogKfoomg=cooMkNoogOgoomh>3ooN7QoogShoomi>CooNGUoogV
i_omj>SooNWYoogZj_omjn_ooNg]oog^k_omknoooO7aoogbl_omlo?ooOCd
oogfm_ommoOooOShooginOomno_ooOcl1oo^k^h03ooGemOoNHFEob1P[ole
MKgoChO4oenDc_m]W]GoM:CHofjOe_mQU<ooChO4ocIe_OlPH;3oNHFDon_[
j`07onk^kQ3oo`L03?o^k^h2ong]k@0<ojRW]_m1?g;oA4=eogQhU?nEUZKo
UiRPoh20TOmBDWCo?cmVoiNGYooYjNWokNg]4_o^k^h00oni^KWohn?SooGe
m@04oooooakon_[j1?ooool00oogmoOohn?SokVi^@0]onk^kP04oj>SXonm
_Kgoclo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM02koi^KV
0<Soo`00ool10Ooo0P;oo`<3ool51Ooo1PKoo`L7ool82?oo2P[oo`/;ool<
3?oo3Pkoo`l?ool@4?oo4A7ooa<CoolD5?oo5AGooaHFoolH6?oo6AWooaXJ
oolL7?oo7AgooahNoolO7ooo8B7oob8RoolS8ooo92CoobHVoolW9ooo:2So
obXZool[:ooo;2coobd]ool_;ooo<33ooc4aoolb<_oo=3CoocDeoolf=_oo
>3SoocTioolj>_oo>c_oocdmooln?_oo?coood51oom2@_oo@d?oodA4oom6
A_ooAdOoodQ8oom9BOooBd_ooda<oom=COooCdoooe1@oomADOooDU;ooeAD
oomEEOooEUKooeMGoomIFOooFU[ooe]KoomMGOooGUkooemOoomPH?ooHV;o
of=SoomTI?ooIFGoofMWoomXJ?ooJFWoof][oom/K?ooKFgoofi^oom`L?oo
LG7oog9boomdM?ooMGGoogIfoomgMoooNGWoogYjoomkNoooO7cooginoomo
OoooP83ooh:2oon3PoooQ8CoohF5oon7QoooR8SoohV9oon:R_ooS8coohf=
oon>S_ooT93ooi6AoonBT_ooTi?ooiFEoonFU_ooUiOooiVIoonJV_ooVi_o
oibLoonNW_ooWioooj2PoonQXOooXj?oojBToonUYOooYjOoojRXoonYZOoo
ZZ[oojb/oon][Ooo[Zkoojn_oona/Ooo/[;ook>coone]Ooo][KookNgoonh
^?oo^[[ook^koonl_?oo_Kgooknoooo0`?oo`L7ool?3ooo4a?ooaLGoolK6
ooo8b?oobLWool[:ooo<c?oocLgoolk>ooo?cooodM7oom;BoooCdoooe=Co
omKFoooGeooof=Soom[JoooKfooog=coomgMoooOgoooh>3oon7QoooRh_oo
i>CoonGUoooVi_ooj>SoonWYoooZj_oojn_oong]ooo^k_ooknoooo3`ooob
l_oolo?oooCdooofm_oomoOoooShoooinOoono_oooclooomo@Ooi^KV00ko
g=cLohZ>VolEBY_o762bocUg^omLT<WoKioAogFRdom_WM7oH9?;od1k_?lK
H;7o5DRIohZ>V`Soi^KV4?oo000<onKViP?oiNGU00_o`/;7ogQhQ_m@D5Ko
=cLioc8b<_m;BdcoKVigokRh_OoTi>Coi^KVonGUi@0BonKViP03okVi^OoM
gMgoj^[Z00Coj^[Z7_o`l?05on[ZjP03omgMgOni^KWoi^KV02coi^KV00Co
WIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0
oOo^k^h03_o]kNgo^[Zooc58SolNE:coDhS4ohJ]e_nD^=coU[SLoi>ffon;
/MSoG8g6oaeBZ_laAXko^[Zo9Oo^k^h2ong]k@08onk^k_o]kNgogMgMom3@
d?o?cloof][Jon_[joo^k^h2ong]kA?ok^k^00?oVYZJokVi^Oo2`/801?o2
`/8Nol?3``Go`/;200?o^KVioiZJV_o^k^h0;?o^k^h01?nSXj?o_Kfmolo?
cooJf]X1on7Qh@0000Gol_;bon[Zj_oNg]kobl_;ojn_[`3nooooo`0=oo[j
n_n;S:So<dBMog2:aon[`N7o/<OSojg6hon`an?oZKoPofZ4`ol]@9WoRhbX
oo[jnP14ooooo`03ofUYJOmgMgOoNg]k00CoNg]k7_mlO7`5og]kN`03ogMg
MomYJFWooooo02cooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_800005on7Q
hOoJf][oclo?okfm_OnSXj<0ooo^k^h02ooJf]_oL76GodQ:V_miO[ooUj7B
oj2/f?nFWm;oLWVnod54Uom`KiKof][K09kok^k^00CoXj>Sokfm_Oo?cloo
f][J0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^H1onKViP09
om?Ce?nCTjOoFUV=odE6Q?m7B8SoADF4oeUHSOnCTjOodm?D09ooi^KV00Co
WIfMokNg]oo8b<Sodm?C0OoJf]X00005on7QhOoJf][oclo?okfm_OnSXj<0
ooo^k^h2onk^kP07onCTi?o0`<?oXJ6YoiNGX?nQXJWo`<33onCTi02Ponk^
kP04oj>SXonm_Kgoclo?om[JfP7ohN7Q00001Oobl_;oj^[ZomkNg_o;bl_o
[jn_0?ooooooZOooool01?n_[joobl_;omkNg_oZj^X1oo;blP0000GohN7Q
om[Jf_o?cloo_Kfmoj>SX`3oonk^kZWok^k^00CoXj>Sokfm_Oo?cloof][J
0OoQhN400005om[Jf_oCdm?ob<S8okNg]onMWId0oooVi^JYonKViP04oifM
WOng]kOob<S8om?Cd`7of][J00001OoQhN7of][Jolo?conm_KgoXj>S0?oo
k^k^ZOo^k^h01?nSXj?o_Kfmolo?cooJf]X1on7Qh@0000Gol_;bon[Zj_oN
g]kobl_;ojn_[`3oooooojWooooo00Co[jn_ol_;booNg]koj^[Z0Oobl_80
0005on7QhOoJf][oclo?okfm_OnSXj<0ooo^k^jYonk^kP04oj>SXonm_Kgo
clo?om[JfP7ohN7Q00001OoJf][odm?ColS8b?ng]kOoWIfM0?ooi^KVZOoV
i^H01?nMWIgo]kNgolS8b?oCdm<1om[JfP0000GohN7Qom[Jf_o?cloo_Kfm
oj>SX`3oofi^KZWoKVi^00CoXj>Sokfm_Oo?cloof][J0OoQhN40000:oo;b
l_oZj^[og]kNol_;bon_[joo^>cook__oonllOoo^^kookW^o`?o^noo00Go
^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^ooni
k_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__
oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onk
kol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo
^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01Onk
lOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^
o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noo
okcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__
o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonj
k_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_a
oonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko
00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo
_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo
00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^
oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7o
ok__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l0
0onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonl
lOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol0
1OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^ko
okW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo
^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03
ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookca
oonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05
ok_aoonkkooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo
^Nko00?o^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonk
kooo_?7ook[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o
^noo00Go^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7o
ok[^oonik_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go
^o7ook__oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^ooni
k_l00onkkol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__
oonllOoo^^kookW^o`03ok__o`05ok_aoonkkooo_?7ook[^oonik_l00onk
kol01OnklOoo^noookcaoonjk_oo^Nko00?o^noo00Go^o7ook__oonllOoo
^^kookW^o`02ok__o`05okS/oon_[joobl_;omkNg_oZj^X00Oobl_800005
on7QhOoJf][oclo?okfm_OnSXj<00_nKc_l0oonGc?ooUl[ooiW=oonLcooo
V/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonK
c_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=
oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oo
oiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?oo
Ul[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJ
cOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>
oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgo
oic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcooo
V<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonG
b_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=
oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlko
oiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOoo
W<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonH
c_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:
oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/go
oic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_oo
UlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonL
coooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>
oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[o
oiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOoo
W<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonG
c?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?
oonJcOooW<oooiS>o`00ZonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcooo
V<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonG
b_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=
oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlko
oiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:oonIcOoo
W<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/gooic?oonH
c_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_ooUlcooiO:
oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonLcoooV/go
oic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>oonKc_oo
UlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[ooiW=oonL
coooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOooW<oooiS>
oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonGc?ooUl[o
oiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?oonJcOoo
W<oooiS>oonKc_ooUlcooiO:oonIcOooW<oooi[=oonLcoooV<kooi_>oonG
c?ooUl[ooiW=oonLcoooV/gooic?oonHc_ooVlkooiO<oonGb_ooVLgooic?
oonJcOooVlkooj>SXonm_Kgoclo?om[JfP01on7Qh@0000Oof][Jom?Cdoo8
b<So]kNgoifMWOmk/NcoNJk[00;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^
jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh
[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/
ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/0
1_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nko
NJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg
[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi
[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[
0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]
j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^Wo
NJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[
ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi
[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00Ko
N:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^
k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[
00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^
ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;o
Mjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf[N[o
NJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkYogV^
j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^jomf
[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^coNJkY
ogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06ogR^
jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi[^co
NJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^j`06
ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_k_mi
[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2ogN^
j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZogV_
k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi[^/2
ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_oMZgZ
ogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^jOmi
[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh[^_o
MZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/ogV^
jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/01_mh
[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nkoNJk/
ogV^jOmi[^/2ogN^j`06ogR^jomf[N[oNJo^ogV^k?mi[^WoNJk[0_mg[^/0
1_mh[^_oMZgZogV_k_mi[^coNJkYogV^j`;oMjk[00KoN:k[ogJ]j_mi[nko
NJk/ogV^jOmi[^/2ogN^j`08ogR^jomf[N[oNJo^og^ak?nMWIgo]kNgolS8
b?oCdm<1om[JfP000?oohN7Qom[Jf_o?cloo_Kfmoj>SXomGT]Go^M?^okSC
konidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^
okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko
^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkong
d^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSB
konfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_
okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko
]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_ni
dnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOB
konhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_
okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo
^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nf
d>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWC
k_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_
okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo
]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkoni
dnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@
k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^
okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo
^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonf
d^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWC
kongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^
okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnh0
0;;o^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOB
konhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_
okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo
^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nf
d>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo]];^okWC
k_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkonidnoo]m;_
okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@k_nhd^oo
]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^okSCkoni
dnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo^=;^okK@
k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonfd^ko^M?^
okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWCkongd^oo
^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^okSBkonf
d^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko^=?_okWC
kongd^oo^=;^okK@k_nhd^oo]];^okWCk_nhdnoo^M?_okOBkonhd^ko]]3^
okSBkonfd^ko^M?^okSCkonidnoo]m;_okSBk_nfd>ko^=;_okKBk_nidnko
^=?_okWCkongd^oo^=;^okK@k_mGT]GoXj>Sokfm_Oo?cloof][J0OoQhN40
0008oo;bl_oZj^[og]kNol_;bon_[joo<7;0ojK6i_nS`^@2ojG4iP06ojC4
i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>Ko
Y/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06
ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnU
a>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4
iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3
iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2
ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KV
ojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS
`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>Ko
Y/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6
i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H01_nT
a>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGoYLCV
ojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nUa>H0
1_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT`nGo
YLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nU
a>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT
`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T
0_nUa>H02onTa>KoXlCUoic1jOnQb>koZLo`ojcBkon_e?3o/=?`ojoDl?n`
eO3o/=C_00;o/=G`00Wo[m?_ok7El?naeO3o[mC`ok3El?n`e>oo/=C`ok3E
l?n_dnl00_naeO001_n_e?3o/=G`ok3Dkon`e?3o/=G`ojoCk`;o/MG`01Ko
[mC`ok3El?n`e>oo/=C`ok7Gl?n_eNoo/=G`ok7El?n`eO3o/=K`oj_AkonX
c_3oX/[^oi_0jOnR`^GoYLCVojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T0_nU
a>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6i_nT
`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^KoXl;T
0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CVojK6
i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nVa^Ko
Xl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00KoY<CV
ojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4i_nV
a^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV00Ko
Y<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?UojG4
i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;oYLCV
00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^KoY<?U
ojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2i0;o
YLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP06ojC4i_nVa^Ko
Y<?UojG4i_nVa^KoXl;T0_nUa>H01_nTa>KoY/KVojC3iOnUa>KoY/KVoj?2
i0;oYLCV00KoY<CVojK6i_nT`nGoYLCVojK6i_nS`^@2ojG4iP07ojC4i_nV
a^Ko<7;0ojn_[oo;bl_og]kNon[ZjP01oo;blP000=[ohN7Qom[Jf_o?cloo
_Kfmoj>SXol?E[7o2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;
Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D
/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^
o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo
3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=
E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C
[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`
o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko
3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?
EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD
[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^
o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o
2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=
E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE
[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^
o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko
3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;
E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD
[_l;Djko3eJ_o`mE[ol;E;3o2eBaoeRWoon:c_ooZnCool3aooo9n_ooc_ko
omCoo`;oco_o01Wod?koom;oooo@ooood_ooom3ooooBoooocogoom3oooo?
nooodoooom3ooooBooood?ooom;oooo?oOood?ooolokoooCooood?ooom;o
ooo@ooood_ooolomooo@ooooco_o00;odooo0;[ocokoolkjooo?noood?oo
olknooo8nOoo_o3oojgWoon;c_ooF:Ooo`]D/?l;E;7o3EB^o`YA[_l=E:ko
2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;
E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA
[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_
o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o
3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;
Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D
/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=E:ko2U6^
o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C[_l?EZoo
3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`o`]D/Ol=
E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko3EB^o`]C
[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?EJoo2eB`
o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD[_l:DJko
3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`YA[_l=E:ko2e>^o`mF[ol?
EJoo2eB`o`]D/Ol=E:ko2U6^o`eD[_l;Djko3eJ_o`mE[ol;E;3o2eBao`eD
[_l:DJko3EB^o`]C[_l?EZoo3eF_o`]D/?l;E;7o3EB^o`mF/OnSXj?o_Kfm
olo?cooJf]X1on7Qh@0000Gof][Jom?Cdoo8b<So]kNgogUiN@1jol71`@05
okno_onb/[;oQHF5on3Ph?odm?@0C?ooool03?ofm_Koclo?oeaLG?mIY?ko
S<Wooj[Noonjjooo`_7oolScooo<m_oocOKoolgho`?ocoWo00GocOWoolki
ooo>n?ooc_Soolgfo`02olojo`03oloiooo=nOooc_Wo00;oc_So00KocOKo
olojooo?n_oocoWoolgiooo>nOl2olkho`0Aolgfooo?n_ooco[oolojooo>
n?ooc?Kooloiooo?n_oobOGoolKfoonkjooo[N7oohW:oOmBUn_oG5aLon3P
h?odm?@0:_ooool01Oohn?Soh>3PohF5QOnb/[;o_kno07[o`L7100CoT92@
okNg]oo8b<Sodm?C0OoJf]X000?ok^k^00?ohN7QomGEeOoEeMD0NOoEeMD0
1_oCdm?oaLG5oi>CTooJf][okno_ooWinD[ooooo00konOWionk^k_o:b/[o
IVIVoeJPlOn7`oooY=KookGQoonoj_oo`n_oolK^ooo6koooa^koolK`o`;o
`nko01Koao3oolSaooo6l?oo`nkoolSaooo6k_ooa_3ool?^ooo7l?oob?7o
olK`ooo3k_oob?7oolK^ooo6l?oo`nkoolO`ooo8lOooa_3ool?^ooo8lOoo
a^ko0_o6l?l03_o2j_oob?7oolO_ooo6kooo`^_ool3[oonhi?ooXmSoohO4
oOm?U>3oIVIVom[Jf_o_knoonOWi:?ooool01_oinOWol?3`om_KfonCTi?o
aLG5om?Cdg[oeMGE00?ohN7Qonk^k_o^k^h00_o^k^h000;ooooo0_ogmoMk
ono_k`08ong]kOoMgMgoYJFUomCDe?oYjNWolo?cooWinOomoOd2ooknoPWo
oooo00?oo_knooooooooool01Oooool00oono_koooooooooo`05ooooo`03
ookno_oooooooooo00Gooooo00?oo_knooooooooool01Oooool00oono_ko
ooooooooo`05ooooo`03ookno_oooooooooo00Gooooo00?oo_knoooooooo
ool01_ooool04oono_kooOgmoo[jn_ohn?Sol_;bonGUiOo4a<CoLW9boe6K
jon2_OgoW/oook7Loonhhooo_NGookgTooo0i_oo`^[ookgTooo1iol00_o0
i_l2ol7Wo`;o_nGo1?o0i_l2ol7Wo`;o_nGo1?o0i_l2ol7Wo`;o_nGo0_o0
i_l04Oo1iooo`>Kool3Vooo1jOoo_>?ook_Tooneh?oo[m_ooig>oomn^OOo
BXoJog9bL_oDe=CojNWYoo?clooinOWooOgm00;oo_kn2Oooool00oono_ko
ooooooooo`05ooooo`03ookno_oooooooooo00Gooooo00?oo_knoooooooo
ool01?ooool02_ono_kooOgmoo[jn_ohn?Sol_;bonOWiooDe=CoYJFUomgM
gOo]kNejono_k`;omoOg0oooool00004onk^k_oYjNWojNWYonWYjG_oi>CT
00[oh^;Rom?CdonNWYkod=3@on3Ph?o_knoolO7aooWinOojn_[on?Sh0_ol
o?`00ooinOWon_[jooclo002ooWin@06oogmoOoinOWon_[jooWinOojn_[o
o?cl0_oinOT01_omoOgonOWioo[jn_oinOWon_[jooclo0;onOWi00KooOgm
ooWinOojn_[onOWioo[jn_olo?`2ooWin@06oogmoOoinOWon_[jooWinOoj
n_[oo?cl0_oinOT01_omoOgonOWioo[jn_oinOWon_[jooclo0;onOWi00Ko
oOgmooWinOojn_[onOWioo[jn_olo?`2ooWin@06oogmoOoinOWon_[jooWi
nOojn_[oo?cl0_oinOT04_omoOgon?ShooShn?oinOWomoOgooShn?odm?Co
k^k^omoOgoo0`<3oKFe]oe:GiOmm]O?oV/[nojSDoondgooo^^7ookSOo`;o
_>?o00Oo^=oookWPoonkhOoo^^3ookWPoonmi?oo^N3o00;o^^3o00Ko]]co
ok_Qoonjh?oo^N3ookgToonih?l2ok[Po`06okKLoonkhOoo^^3ookWPoonm
i?oo^N3o0_njh?l05?nfg?oo_>?ook[Qoonhgooo^MoookSOoonfg_oo/M_o
oj[EoonGbOgoOKCbodZ<eOm]KFgod=3@on3Ph?o_knoolO7aooWinOojn_[o
n?Sh0_olo?`00ooinOWon_[jooclo002ooWin@06oogmoOoinOWon_[jooWi
nOojn_[oo?cl0_oinOT01_omoOgonOWioo[jn_oinOWon_[jooclo0;onOWi
00OooOgmooWinOojn_[onOWioo[jn_olo?conOWi00;on?Sh00[onOWiooOg
moohn?Som?Cdonk^k_oQhN7od=3@oijNW_oCdm?oh^;RN_oTi>@3onWYj@;o
k^k^0004on?Shg_oh>3P00Sog]kNolo?conKVi_ob<S8omgMgOoZj^[ok^k^
oo;blP;omOGe00?om?CdooGemOogmoL00_ofm_H01_oclo?oe=CDomcLg?oe
mOGom?CdooOgm`;om_Kf00KomOGeooKfm_odm?ComOGeooCdm?ogmoL2ooKf
mP0FooGemOofm_KohN7Qoo?cloodm?Cok>c/on_[joofm_KomOGeooKfm_oK
fm_olo?cooCdm?ogmoOom_KfonCTi?oUiNGom_KfooCdm?oemOGom?CdooOg
m`;om_Kf00komOGeooKfm_odm?ComOGeooCdm?ogmoOojn_[omoOgooemOGo
m_KfooCdm?oemOGoinOWon[ZjP;om_Kf00ComOGeooKfm_odm?ComOGe0_of
m_H03?oclo?om?Cdono_koo[jn_ofMWIokVi^Om[Jf_oC93NogVakonCa?So
Y<okojcEo`;o/][o01_o]=Wook?JoondfOoo/m[ookCKooncf_oo]McookCI
oondf_oo/m[ookGLoonefooo]=_ook?Jooneg?oo/]Omoi^lg?nQa>Ko]Mco
okGKoondfooo/m[ookGLoondfOoo]=[ook?Jooneg?l00onefol03oncf_oo
]M_ook?Koon_f?oo[MSoojG@oOnDa?SoMZcYodJ5cOm[Jf_ob<S8omgMgOoZ
j^[ok^k^oo;blP02ooGem@03ooCdm?oemOGomoOg00;om_Kf00KomOGeooKf
m_odm?ComOGeooCdm?ogmoL2ooKfmP06ooGemOofm_Kom?Cdom_Kfoo7alOo
k>c/0_ofm_H01_oemOGom_KfooCdm?oemOGom?CdooOgm`;om_Kf0_oemOD2
ooKfmP09oo?cloodm?Cokno_on_[jooKfm_ob<S8oi^KVoo?cloog]kN07[o
h>3P1?oShn<1onKViP00Ooo^k^h07_o/k>cog=cLojFUYOo5aLGofMWIonKV
i_oYjNWokNg]ono_kooalO7okno_oo;bl_oalO7okno_ojFUYOl92@Wo30`<
ob8R8_lb<S;oWYjNoo7alOo_knoof=SHo`000?n1PH7ol_;boo3`l?m5ADGo
9BDUono_k`;ol?3`02SoC4a<o`L71olH61SoU9BDoa4A4OmADE7ol?3`olK6
a_lS8b?o71`Lojn_[oobl_;of=SHoc/k>ol0003o410@oa/K6oo[jn_ol?3`
oc`l??mhN7Sokno_oo3`l?nIVIWo6QXJoo;bl_o`l?3ofm_KodE5AOl20P;o
820PoaDE5Ong]kOol_;bob8R8_l?3`oo7QhNodQ8B?oWinOol?3`0oobl_80
9oo`l?3okno_oo3`l?o]kNgojn_[onGUiOoGemOo]kNgog9bL_m6RmSoMJgY
ohjolOnObOGoYM3jojcCn_n^eOgo[]Ckok7Fo_n^e?_o/]Sook7EoOlT;3Go
D69dok7Fo_n^e?_o/]SoojkDnol20P;oLh^UojkDnomjUK3o1PP9o`P:3?lI
7RCo92`eog6:Y?naeOgo[]CkobD]=P02o`00000]o`/>4Ol_>TCoVK_Mok;H
oon_eOgo[]KnojkDnon/do[oZmCkojK@n_nPc?SoS[oaog>ZiOm3Pl[oLW9b
olG5aOoIfMWoi^KVonWYjOo]kNgokno_oo7alOo_knool_;boo7alOo_knoo
l?3`oc8b<_m`L73ol_;boo3`l?oYjNWo8b<Sod51@Oo_knool?3`oiFEUOlB
4Q;o3Ph>obl_;olC4a?o7AdMokjn__o`l?3o<c<c00;o000000?o410@od92
@_oBd]800_o`l?003?obl_;ol?3`ono_koo`l?3okNg]on_[jooUiNGofMWI
olK6a_nUYJGog=cLonc/k7ook^k^001oooooo`07oogmoOo/k>co/K6aol;2
`_oEeMGoh^;RonKViP02on[ZjP1nonc/k?o[jn_ojn_[onk^k_o[jn_oa/K6
ok2`/?oVi^Kok>c/oi:BT_l30`?oclo?on_[jonBTY;o3@d=oc@d=?o/k>co
inOWo`T92Ol>3Pko`l?3onc/k?ng]kOo0`<3olc<c?oFe]KoE5ADo`l?3oo[
jn_ok>c/ofQXJ?lk>c_ojn_[onk^k_o/k>co?CdmobPX:?nk^k_ok>c/olO7
aooZj^[ok^k^oc/k>omfMWKojn_[onc/k?nFUYKo6ATIonc/k?o^k^ko?Shn
oc/k>oo=cLgok>c/on3Ph?oOgmook>c/ok>c/ooXj>SokNg]oc4a<On7QhOo
k>c/on_[joo/k>cokNg]onWYjOo/k>coj>SXonWYjOoVi^KohN7Qom?Cdonb
/[;oNWYjod>9e?m`Z>?oRk_/oi_6lOnTc?GoY/keojS?mOnZcoGoZ/ofoj[?
mOn[d_WoZloeob@[<om<GVooZ/oeoj_@nOn[coKoZ]3fo`420_m_Qj3oZ/oe
ohb]c_moVkOoYl_doj_?m_mXP9Oo0P<3oiBdeOnZcoGo8b/dodmPL_nWboCo
SZc=oaXP9_lkBEOoZ/gdoj[@m_nZcoKoZ<gcojS>mOnUc??oX/ceoi_6lOn:
^^_oKjGQocima?mjNW[o`/;2omGEeOoRh^;oi^KV0_oZj^X07Oo/k>cojn_[
on_[joo^k^kojn_[onc/k?la<C7oKFe]onc/k?o^k^koIfMWoa8B4_oDe=Co
k>c/oh^;Rol30`?oR8R8onk^k_o/k>coh>3Po`000?n/[:cok>c/oc4a<Om^
KVkojNWYolG5aOlU9BGoDe=C00;ok>c/00cokNg]onWYjOo/k>coj>SXonWY
jOoVi^KohN7QomGEeOo1`L7o/K6aonc/k?omoOeoooooo`00Ooo^k^h0:Oo/
k>cog=cLojFUYOnm_Kgoc/k>omcLg?oQhN7oi>CTonGUiOoVi^KoiNGUonKV
i_oXj>SoinOWonSXj?oYjNWoinOWonKVi_o:b/[o0000ojFUYOoWinOoCDe=
ofUYJOlI6AWodM7AojZZZ_lM7AgoI6ATogAdM?oXj>Soa/K6o`820_nZZZ[o
i^KVohn?SolM7AgoinOWonSXj?m6ATKoIfMW00;oi^KV00Koa/K6o`000?n6
QXKoj>SXonWYjOoWinL2onKViP0>ocTi>OmcLg?oinOWonSXj?nDU9Co6ATI
onKVi_o7alOo0000ojNWYooWinOoj>SXonWYjOoWinL3onKViP06ok>c/olC
4a?oQHF5onWYjOoWinOoi^KV0ooWinL03OoVi^KoiNGUon7QhOoMgMgoc/k>
ojj^[_mbLW;o?X;=ofVPf_n6]>KoUL7[oic4k_nRanh00_nSb>l01_nUb>oo
YLW`ojK:lOnWc??o8RXcod]KK@CoY<S_00Co0@82off5WonUb_7oYLW`0onT
b>l01_n@/=;o0000ogNA[OnUb_7o8RXbodaMK`;oY<S_00GoAEAUoaXP9_nS
b>ooYLccojG9l002ojC9l00Moj?8konMa^ooUL7[ohJeiomYXMco>WVoog9b
L_nm_Kgoc/k>omcLg?oQhN7oi>CTonGUiOoVi^KoiNGUonKVi_oXj>SoinOW
onSXj?la<C7oJf][onKVi_n^[Zko0@41oj6QXOoWinOohN7Qoa8B4_mNGUh0
0ooVi^H01_oKfm_o0000ojVYZOoYjNWo<30`of][J`;oi^KV00CoHV9RobDU
9OoXj>SojNWY0ooWinL02OoVi^KoiNGUon7QhOoMgMgod=3@okfm_OnUYJGo
g=cLonc/k01oonk^kP00OooVi^H02OoTi>Coe=CDoinOWonh^;Sobl_;omOG
eooKfm_oh>3Pon;RhP08on?Sh`0=omGEeOm6ATKo1`L7omOGeooOgmoo3@d=
ojRXZ?mLG5coRHV9ofUYJOmJFU[oZZZZobPX:002on?Sh`05oiZJV_l/;2co
;Bd]oc0`<?lL71`00_oShn<01om4A4CoIFEUon?ShooShn?oZJVYo`000?ng
]kL01OoShn<02_lh>3SoLG5aon?ShooShn?oTI6AoaPH6?oShn?oZJVYo`00
0?lf=SH3ocPh>007ojj^[_oShn?ob/[:od51@Ol20P;oI6ATom[JfP04on?S
h`0Bon;Rh_oShn?ohN7Qon3Ph?oKfm_ofMWIolW9bOnZZZ[oKVi^ocUmbOmT
WMKoOZoPoi2jhonG`>[oW/?[oig2jonPa^_oWlC[0_nPa>/02_nRa>co8RTa
odQIJ_nOa>_oX/K/oio3k?nPa>co0@82ofZ0V_nRa>`2oio4j`0Noj;6k?nE
]mko<Ca9o`D61onI^]ooX/C/ob4Y<Om:FfgoX/K/ohj_dol82PcoCf1doj34
jonOa>coX/C/oik3j_nPa^coWL;ZoiO0j_n>^NCoPK7Tof>Je_lbL[[oKVi^
okRh^?o;bl_oemOGom_KfooPh>3oh^;R1_oShn<01Ol`<33oIfMWomCDe?lO
7aooG5aL00;ohn?S00?o_;blo`000?n][Jd00ooShn<02_oFe]Ko0000ojFU
YOoShn?o<30`ofUYJOoShn?obl_;o``<3?m`L703on?Sh`0;on;Rh_oShn?o
hN7Qon3Ph?oKfm_ofMWIol_;bonh^;SoWinOomCDe?oTi>@0OooVi^H007oo
k^k^00Sok>c/omcLg?nUYJGo/k>colS8b?oCdm?ofMWIom_Kf`;og]kN01oo
hN7QomgMgOoOgmoog]kNomoOgooPh>3oWYjNoaPH6?lD51CoYZJVomoOgonY
ZJWo2PX:om[Jf_nNWYko@D51obXZ:_nDU9CogMgMoa<C4onn_[koh>3PomkN
g_oOgmoogMgMoh61POlL71cog]kNomoOgom3@d?oHf=S00;ogmoO00Ko_kno
o`000?mnOWkogmoOon3Ph?oNg]h2omoOg`0GocLg=omADE7og]kNomoOgon9
RHWo6ATIomoOgono_koo0000oiFEUOnd];Co[Zj^o`820_o7alOogmoOocPh
>?li>CWo_knoomkNg_oOgmooh>3PomkNg_oOgml00_oPh>03omkNgP0Com[J
f_oEeMGoa<C4ojNWYombLW;o<gK4oenFdomjZ=_oR[GPoi2jhonG_NGoV<3U
oi_1jOnG_NCoV/3Woi^oi_nJ`>Ko82P`oadU;002od=CI0;o@eAT02;o0000
ofAmU_nK`>OoV;oUoi_0i_m]R:Co41DIo`dA5?mcSj_oV/3Voi_0iolP:33o
7RD]obH_>?l=41?oGG>:oiVoi?nK`>OoV[gUoi_0ionK`NOoUkgUoiRmiOnC
_>OoRkSSogb/gomMTm3o<6neog9bL_nc/k?ob<S8om?CdooIfMWofm_K0_oN
g]h01ooQhN7ogMgMomoOgooNg]kogmoOobl_;ol20P800_l000001_nXZ:So
gmoOomkNg_nLW9co0000olC4a0CogmoO00[odM7AomcLg?oPh>3o;bl_ob/[
:olg=cOo4a<CohF5QOoLg=cogmoO0ooPh>03omkNgP07om[Jf_oEeMGoa/K6
okFe]OnUYJGog=cLonc/k01oonk^kP00Ooooool02OomoOgok>c/ok6a/On`
/;3oaLG5om7AdOoGemOof][Jom_Kf`03omcLg0;ofm_K05Cog=cLofm_Kol0
003oBTY:olK6a_oJf][ofm_KofMWIom2@T;ogMgMomCDe?l?3`oo0P82ol[:
b_oKfm_oEeMGog=cLooMgMgoVYZJokbl_?oIfMWoDU9BodQ8B?oKfm_oe]KF
oclo?omMGEgodm?ComSHf?oJf][o=SHfob4Q8OnSXj?og=cLokjn__oMgMgo
g=cLocHf=_lA4A7oIFEUokno_om;Bd_o@T92omgMgOoLg=co=CDeoe]KFooD
e=CoR8R8obDU9OoKfm_ogMgMobl_;on0P83ofm_KolO7aooGemOogMgMom_K
fooMgMgog=cLom_KfooLg=cofm_KomSHf?oFe]Kod=3@ol71`OnQXJ7oNWYj
obib`OmIT];oMJGIohNdgon=^>7oTk_QoiFli?nF_>CoUKcSoiFjhOnD^n7o
U[cToalX<?lU;cT2oeAZP00Uoe=XO_mDJH3o0@41of9kUOnF_NCoU;_Qod]O
Lol0003o<Ci;ohJXc?nF_NCoU[cToiJmi?lO9boo<d1=oeI]PolU;SSoAUQ[
oi>jh?nD^n7oU;[QoiJli?nD^n7oTk_Soi>jhOn;]]ooQ[;Log>Uf?mIT<go
:FR`ogYjN_n`/;3oaLG5om7AdOoGemOof][Jom_Kf`03omcLg0;ofm_K00ko
g=cLobh^;_mVIVKoa<C4ohB4Q?l61PKoWYjNom_KfonZZZ[o0000okBd]?oM
gMgog=cLom[JfP;ofm_K01Kog=cLomgMgOl^;RkoBd];ogmoOolf=SKoIfMW
omOGeooLg=cogMgMomcLg?oKfm_og=cLom_KfooHf=Soe]KFom3@d?o3`l?o
[Zj^ok6a/Oo/k>cooOgmOoooool007ook^k^00[ok>c/omcLg?nUYJGoZj^[
ol30`?o>c/kod];BomKFe_oGemOof][J0_oIfMT2om[JfP09ol?3`ol10@7o
O7alomSHf?oJf][ofMWIom[Jf_lo?cooQXJ600;of=SH02OoDU9BocXj>_oI
fMWof][Joj6QXOm1@D7of=SHogAdM?lZ:R[o3@d=oc0`<?nWYjOof][Jofa/
K?l61PKo2PX:oaHF5_nDU9CofMWIolK6a_m:BT[o30`<o`T92OlP823of=SH
om[Jf_lf=SKoJf][ofMWIolA4A7o9RHVojJVY_oHf=Sof][Jol?3`oll?3co
2`/;oaLG5onKVi/00_oHf=P01OnSXj?o<C4ao`d=3Ol@413oaLG500?of=SH
0_oIfMT03_oKfm_oemOGomOGeooBd];oc/k>okbl_?nNWYkoLW9bobE/_?mD
SLcoL:;Eoh2/fOn8/mkoSKKL0_n@^>007?n@]]ooT;SOoi2hh?n@^>3o7RH_
od5CIOnA^=ooTKWQoi6hh?nA^=oo0@82oeihT_n@]]koPJG9o`410OmCJX7o
TKSPoi6hgon@]]koT;SPoi2fg_lN9Roo@eEXoi6ihOn6Z/oo1@L8ofJ1WOn@
]]h3oi2hh00?oi6jhon=]]coRKCOogn/f?m_X=CoDX_8ob9T[_mbLW;oZj^[
ol30`?o>c/kod];BomKFe_oGemOof][J00;ofMWI0_oJf]X03_oIfMWo;Bd]
ofATI?oHf=Sof][Jochn?_m6ATKof][JolW9bOl0003oQ8B4omSHf?oJf][o
fMWI0_oJf]X02_oIfMWof=SHobd];OmTI6Cof][JolS8b?l820SoVYZJomWI
fOoHf=P2omWIf@0:om_KfooGemOoemOGom;Bd_o>c/ko_[jnoj^[ZonUYJGo
g=cLonc/k7ook^k^001oonKViP07onCTi?oDe=CoWinOojJVY_nk^k_obLW9
om3@d003omCDe007omOGeooFe]Koe=CDomCDe?nd];Co0@41ol30`002omKF
eP04omOGeooDe=Coe=CDomGEe@;oe=CD0_oFe]H01?oGemOoe=CDomCDe?oE
eMD2omCDe003omKFe_oDe=CoemOG00;oe=CD00?oeMGEod10@?mNGUh00_oF
e]H01_oGemOoe=CDomCDe?oEeMGodM7AomCDe0;oe]KF00?o=CDeofUYJOoD
e=@00ooDe=@2omKFeP04omOGeooDe=CodM7AomGEe@;oe=CD0_oFe]H01?oG
emOodM7AomCDe?oEeMD2omCDe00ComKFe_oEeMGoe]KFomKFe_oEeMGodm?C
om3@d?o8b<So^;RhoiZJV_m^KVko7VFfodZ7b?m[W=;oOJOHohB]f_n9/]Wo
RK7Kohfeg003ohbdg003ohbcfolM9Bko?e1S00;oS;CK02?oS;CNohfeg?l1
0P;oFgF?oh^bfomeU[Wo0@41ogjSa_n<]=koSKGLoh^cf_n</m_oRk;KoadU
;_m1E6KoS;CKognSbOl51`SoCVEkohbcfon;/m[oS;?Kohbdg?n;/mcoR[?J
oh>]fOmlYmKoJI_@odZ5a?lMH:[oKVi^ojJVY_nk^k_obLW9om3@d003omCD
e007omOGeooFe]Koe=CDomCDe?oEeMGo;2`/of9RHP02omKFeP09ob`/;?m6
ATKoe=CDomGEeOmBDU;o7AdMolK6a_oFe]KoemOG00;oe=CD00_oeMGEomCD
e?l/;2coHf=SomKFe_o3`l?o20P8ogMgMooEeMGoe=CDomGEe@02omKFeP09
omGEeOoCdm?od=3@olS8b?nj^[[oYjNWoinOWooDe=Coi>CT07ooi^KV001o
onk^kP09onc/k?oLg=coYJFUoj6QXOng]kOoa<C4ol_;boo>c/kod];B00Ko
dm?C00Go?Cdmobl_;omeMGGoD51@odQ8B003om?Cd`04omGEeOoBd];odm?C
om;BdPCodm?C00CoeMGEom;Bd_oCdm?od];B1?oCdm<01?nk^k_o][Jfom?C
dooBd]84om?Cd`06omGEeOoBd];odm?Com;Bd_ld=3CoJFUY0_oCdm<01?oE
eMGod];Bom?CdooBd]84om?Cd`04omGEeOoBd];odm?Com;BdPCodm?C00Go
eMGEom;Bd_oCdm?odm?ComCDe002om;BdP0=olo?coo:b/[oaLG5okJf]_nE
UIGoLW9boaUM[_m5P/;oHYS>og>Sd_mlYMGoQ:kIohJ^fP02ohR_fP0/ohN]
fOn7[m[oR:oJoadU;_lmCf;oR:oJohJ^f_n8[m[oR;7Jo`420_mILXkoR[7K
ohR^fOlW<Soo7RLaod]QNOldA5?o;Sa;ohR_f_n:/M_o72@]oaTP:?lX=47o
2`hAo`dB5_n0YLkoR:oJohN]fOn8[m[oQjoJohB/f_n4[]WoOJOFog>Rd_mR
V<ooA831oaEEXombLW;oXJ6QokNg]oo4a<Cobl_;olk>c_oBd]86om?Cd`06
obd];OlV9RKoBTY:oa`L7?l92@WoXJ6Q0_oCdm<04oo4a<Co=CDeoaPH6?mU
IFGoO7alof1PH?lX:2SoWIfMomGEeOl/;2co9RHVoclo?olA4A7o5ADEolO7
aooCdm?oeMGEom?CdooDe=@00_oBd]802?o?cloob/[:olG5aOnh^;SoXJ6Q
ojFUYOoLg=cok>c/Ooo^k^h007oooooo00WooOgmonc/k?na/K7oVIVIok6a
/Ono_koobLW9olk>c_o?cll01_o@d=001Oo<c<coU9BDoeUIFOm^KVkoVi^K
01ood=3@00?o=3@dofMWIoo@d=005Oo@d=006OoBd];od=3@olo?coo<c<co
bLW9okjn__nb/[;oSHf=ogYjN_l?E:[o?7Vmoe^Aaom^WLooNjSHognXe_n0
Z=KoPj_Hoh>/f?n2Z]KoPZ_Foh:Ze_mJMYGoIHFWoh:[f?n3ZmH00_n3ZmP0
4?m@J8CoL9:hoh>[f?n2Z]KoOjSDoeejV?lhBEgoAE]cof:0XOn2Z]KoPj_H
oeUeTom>Ih;oDFV4ofZ;/?n1ZMH2oh>[f0;oPjcH00ooQ:gIoh2Xe_mnYmGo
NJGFog2Nd_mJT<Ko?W^oo`e=WOmjNW[oVIVIok6a/Ono_koobLW9olk>c_o?
cll01_o@d=001On?ShooOGemogemOOnHV9Sobl_;00Cod=3@00goclo?oi2@
T?mWIfOoEUIFog5aLOn>SXkoa<C4om3@d?n?ShooOGemoh20P?nYZJWoc/k>
00Cod=3@00_od];Bom3@d?o?clooc<c<olW9bOnn_[ko];BdoiVIVOna/K7o
k>c/oogmo@1oooooo`00Ooo^k^h03?o/k>cogMgMojRXZ?nBTY;o[:b/okbl
_?o4a<Cob/[:ol_;boo<c<coc/k>olo?cbOoc/k>00?ob/[:olc<c?o>c/h0
5_o>c/h2olc<c00?ol[:b_o4a<Co_;blojZZZ_n7QhOoMWIfo`A:Y?laL[So
E8W6ofNGc?mbWm3oMjCCogfUe?mnYmGoOZSE00?oOZSD00?oOj[Eoh2ZeOmn
Z=@00omnZ=@01?moZ=CoOZSDognZeOn0Z]D4ogjXe004ognXe?mnZ=CoOj[E
oh2Ze@CoOZSD01KoOjSDogjXdomoZ=CoOZSDognXe_mmYMCoNJCDog:Od?mX
V/goDhW4oc5`]ol3@YSoMWIfoi:BT_n/[:co_;blolC4a?o:b/[obl_;olc<
c?o>c/koclo?7_o>c/h2olc<c008ol[:b_o4a<Co_;blojb/[?nBTY;oZ:RX
omgMgOo/k>aoonk^kP00OooVi^H02OoTi>CoemOGojNWYon;Rh_oYJFUokJf
]_o0`<3oaLG5olS8b002ol[:bP03olc<c?o:b/[obl_;00?oc<c<00Gob/[:
ol_;boo<c<cob/[:ol_;b`03olc<c005ol[:b_o;bl_oc<c<ol[:b_o;bl/0
0oo<c<`01Oo:b/[obl_;olc<c?o:b/[obl_;00?oc<c<00Gob/[:ol_;boo<
c<cob/[:ol_;b`03olc<c005ol[:b_o;bl_oc<c<ol[:b_o;bl/00oo<c<`0
1Oo:b/[obl_;olc<c?o:b/[obl_;00?oc<c<00Gob/[:ol_;boo<c<cob/[:
ol_;b`03olc<c00Bol[:b_o;bl_ob/[:olO7aoo9bLWoaLG5ol30`?ne]KGo
Xj>Soh:2P_miNGWo03nLobAU/om5P<3oG937ofbJc?mcWlooMj?@0omjY=80
:omjYM?oO:ODog^WdomjY];oMjC?ogVUd?mjY]?oO:SDog^We?mlYmCoNjOC
ogZVd_mgY<ooNJG@ogZVdomlZ=CoNjODogbWe?mkYm?oNZKBogNTcomiYM3o
NZKCogbXe?mkYmCoNZCBog^Ud_mjY=3oNjGBogFOcOmcWm3oK9[<oebAaom5
P<3o8fBao`0jTomiNGWoRh^;ojFUYOnf][Ko`<30olG5aOo8b<P00_o:b/X0
0oo<c<cob/[:ol_;b`03olc<c005ol[:b_o;bl_oc<c<ol[:b_o;bl/00oo<
c<`01Oo:b/[obl_;olc<c?o:b/[obl_;00?oc<c<00Gob/[:ol_;boo<c<co
b/[:ol_;b`02olc<c00<ol_;boo:b/[oalO7olW9bOo5aLGo`<30okFe]OnU
YJGoRh^;ojNWYooGemOoi>CTOooVi^H007ook^k^00WokNg]on3Ph?ng]kOo
NGUioibLW?n^[Zko^;Rhol71`Oo4a<@00oo7alL01?o6a/Kob<S8olK6a_o7
alL3olS8b0;oa/K600?ob<S8olK6a_o7alL00oo8b<P2olK6aP03olS8b?o6
a/KoalO700?ob<S80_o6a/H00oo8b<Soa/K6olO7a`03olS8b0;oa/K600?o
b<S8olK6a_o7alL00oo8b<P2olK6aP03olS8b?o6a/KoalO700?ob<S80_o6
a/H00oo8b<Soa/K6olO7a`03olS8b0;oa/K600?ob<S8olK6a_o7alL00_o8
b<P2olO7a`;oa<C403_o`<30okVi^On^[ZkoVYZJogAdM?n=SHgo2Bj<oa9G
Z_lgLkWoCXK1of6CaomXUl[oKY_>og6NcOmaWLooLYo?og:Oc_maW/goLIo>
og:OcomcX<ooLZ3@og6Nc_maW/ooLYo>og6NcOmaWlkoLYo?og>PcombX=3o
LIk>og6NcombWlkoLIk=og6Oc_mbWlooLj3?og:Pd?maW/koLIk?og:Oc_m`
WLgoLYo?og>Nc_m`WLcoK9S:ofVGb_mPT/OoCXK3ocIc^?l?E:Wo2Bf6ohf=
SOmhN7SoW9bLojj^[_nh^;So`L71olC4a003olO7a`04olK6a_o8b<Soa/K6
olO7a`?ob<S80_o6a/H00oo8b<Soa/K6olO7a`03olS8b0;oa/K600?ob<S8
olK6a_o7alL00oo8b<P2olK6aP03olS8b?o6a/KoalO700;oalO70_o4a<@0
2?o0`<3o^KViojj^[_nKVi_oNg]kokNg]ooPh>3okNg]Ooo^k^h007oooooo
00[oo_knooKfm_oEeMGoMGEeohn?Son^[Zko`/;2olc<c?oAdM7od];B0_oD
e=@2omGEe@?oe=CD00?oeMGEomCDe?oCdm<00_oEeMD3omCDe003omGEeOoD
e=Codm?C00;oeMGE0ooDe=@00ooEeMGoe=CDom?Cd`02omGEe@?oe=CD00?o
eMGEomCDe?oCdm<00_oEeMD3omCDe003omGEeOoDe=Codm?C00;oeMGE0ooD
e=@00ooEeMGoe=CDom?Cd`02omGEe@?oe=CD00?oeMGEomCDe?oCdm<00_oE
eMD3omCDe00MomGEeOoDe=Coe=CDomCDe?o@d=3oc/k>ol;2`_n`/;3oS8b<
ofm_Kona/K7o:CN6o`=5X?lgLkWoHY?9ogbUdon6[]GoRjoEoi2df?nA]M[o
T;CIoi:ef_nA]M[oTKCJoi:ef_nB]M_oTKCIoi2dfOnB]MX00_nA]MX01_nA
]=[oT[GJoi:efonA]=WoT;CIoi:efP;oTKGJ01[oTKCJoi:ef_nB]M_oTKCI
oi2dfOnB]M[oTKGJoi6dfonA]M[oT[KJoi6df?n=/MSoR:kEoh2ZeOmUULWo
>gFio`51W_lY=H;o/K6aog=cLon?Shoo[Zj^ol;2`_o<c<codM7Aom;BdP;o
e=CD0_oEeMD3omCDe003omGEeOoDe=Codm?C00;oeMGE0ooDe=@00ooEeMGo
e=CDom?Cd`02omGEe@?oe=CD00?oeMGEomCDe?oCdm<00_oEeMD5omCDe009
om3@d?o>c/ko`/;2ok2`/?n=SHgoM7AdomGEeOofm_Koo_kn07oooooo0020
onk^kP0:onWYjOoGemOoQ8B4oh20P?nl_;coe=CDom[Jf_oMgMgoh>3PomoO
g`GohN7Q00Coh>3Pon7QhOoPh>3oh>3P1?oQhN401?oPh>3ohN7Qon3Ph?oP
h>04on7Qh@04on3Ph?oQhN7oh>3Pon3Ph0CohN7Q00Coh>3Pon7QhOoPh>3o
h>3P1?oQhN401?oPh>3ohN7Qon3Ph?oPh>04on7Qh@04on3Ph?oQhN7oh>3P
on3Ph0CohN7Q00Coh>3Pon7QhOoPh>3oh>3P1?oQhN406?oPh>3ohN7Qon7Q
hOoPh>3ogmoOomcLg?oKfm_oeMGEokfm_OmnOWkoPH61ol;2`_mOGhko2c2E
oeJ:a_n>/mWoWkoOojG3hOn/a^?o[<OSojk9hon_b^Go[/STok;:i0Go[lWT
00?o/lcUok7:iOnbb^@01On_bN@00oncc>Go/L[Uok;:i005ojo9i00Fok?<
iOnab^Go[lWTojo:iOn^bN?o[LSSoj_6honS`^7oWkoOoi:ef_mHS<Ko1bjC
of1PS_o2`/;oPH61oh20P?nl_;coe=CDom[Jf_oMgMgoh>3PomoOg`GohN7Q
00Coh>3Pon7QhOoPh>3oh>3P1?oQhN401?oPh>3ohN7Qon3Ph?oPh>04on7Q
h@04on3Ph?oQhN7oh>3Pon3Ph0GohN7Q00[oh>3PomoOgooLg=cofm_KomGE
eOnm_KgoOWinohB4Q?oGemOojNWYP?o^k^h0083oi^KV00Soi>CTomcLg?nc
/k?oLg=cojb/[?oBd];of=SHomgMg@;ogmoO00?oh>3PomoOgooPh>000_oO
gml4on3Ph004omoOgooPh>3ogmoOomoOg`Coh>3P00CogmoOon3Ph?oOgmoo
gmoO1?oPh>001?oOgmooh>3PomoOgooOgml4on3Ph004omoOgooPh>3ogmoO
omoOg`Coh>3P00CogmoOon3Ph?oOgmoogmoO1?oPh>001?oOgmooh>3PomoO
gooOgml4on3Ph004omoOgooPh>3ogmoOomoOg`Coh>3P01Cog]kNomcLg?oH
f=Soc<c<oj2PX?maLG7o/K6aom;Bd_n][KOo=3V7odmb]_n;/MSoV[[LojG2
h?nW`n7oZlCSojc7hon[an?o[<SToj_7h`Co[<ST00CoZlOTojc8i?n/an?o
ZlOS1?n/b>@01?n[anCo[<STojc7hon[an<4ojc8i003oj_7i?n/b>Co[<OS
00;o[<ST013o[<SSojc7honV`n7oXl;PoiRig?mkYM?o=ej/oc8gQ?n/[;Ko
d];Bok:b/_mcLg?o[:b/om;Bd_oHf=SogMgM0_oOgml00ooPh>3ogmoOon3P
h002omoOg`Coh>3P00CogmoOon3Ph?oOgmoogmoO1?oPh>001?oOgmooh>3P
omoOgooOgml4on3Ph004omoOgooPh>3ogmoOomoOg`;oh>3P00Wog]kNomcL
g?oHf=Soc<c<oj2PX?maLG7o/k>comcLg?oTi>@0P?oVi^H0087ok^k^00Wo
jn_[on3Ph?n[Zj_oPh>3ojBTY?no_kooclo?omOGeooIfMT00_oJf]X00ooI
fMWof][JomWIf@05om[JfP03omWIfOoJf][ofMWI00Gof][J00?ofMWIom[J
f_oIfMT01OoJf]X00ooIfMWof][JomWIf@05om[JfP03omWIfOoJf][ofMWI
00Gof][J00?ofMWIom[Jf_oIfMT01OoJf]X00ooIfMWof][JomWIf@05om[J
fP03omWIfOoJf][ofMWI00?of][J02cofMWIomOGeooAdM7o_;bloi6ATOmi
NGWoZj^[on3Ph?oXj>Soh>3PoinO/om6BiGoB6>bof^Ab?n4ZmGoU[SLoiZk
g_nL_=koW[oNoijogonM_MkoW;cNoijmg_nN_MooWKcNoinogonN_MkoW[gO
oifmg_nL_=koW[gNoijmgonM_=koWkoOoijmg_nN_MooWKgNoiblg_nN_Mko
W[gOoiflg_nO_mooW[gNoijmg`;oWKgN01;oVkcNoiZkg_nF^=coRJgFofB;
a_lYBJ;o>Sn=oinO]?oPh>3oj>SXon3Ph?n[Zj_oPh>3ojBTY?no_kooclo?
omOGeooIfMT2om[JfP03omWIfOoJf][ofMWI00Gof][J00?ofMWIom[Jf_oI
fMT01OoJf]X00ooIfMWof][JomWIf@05om[JfP0=omWIfOoJf][ofMWIom[J
f_oIfMWoemOGom7AdOnl_;coTI6AogUiNOn[Zj_oh>3Pon_[j`21onk^kP00
POooool02oono_koo?clooCdm?oCdm?oVYZJoginO_mcLg?oLW9bogIfM_mg
MgOoNg]k00;oO7al00?oNg]kogalO?mkNg/00_mlO7`01_mkNg_oO7alogal
O?mkNg_oO7alog]kN`;oO7al00KoNg]kogalO?mlO7coNg]kogalO?mkNg/2
ogalO006og]kNomlO7coO7alog]kNomlO7coNg]k0_mlO7`01_mkNg_oO7al
ogalO?mkNg_oO7alog]kN`;oO7al00KoNg]kogalO?mlO7coNg]kogalO?mk
Ng/2ogalO006og]kNomlO7coO7alog]kNomlO7coNg]k0_mlO7`08?mkNg_o
O7alogalO?mkNg_oO7alog]kNomfMWKoMgMgog5aLOmcLg?oOWinoiZJV_oC
dm?om?Cdooclo?omoOgoo?clooCdm?o>c]OoNWZYocY1T_lA9XSo0228o`0U
Rol0:8go02^@o`0/TOl0;I7o02b@o`0/TOl0;93o02bA0_l0;I401_l0;I;o
02fAo`0/T?l0;97o02b@o`0/T@;o02fA00Ko02fBo`0]TOl0;93o02bAo`0/
T?l0;942o`0]T@0Go`0]T_l0;I7o02^>o`0WSOl09X_o0228oa4VR?lj@I;o
NWZYolk>eoodm?Coo?cloogmoOolo?com?Cdom?CdonJVY[oOWinog=cLomb
LW;oMWIfogMgMomkNg/00_mlO7`00omkNg_oO7alog]kN`02ogalO006og]k
NomlO7coO7alog]kNomlO7coNg]k0_mlO7`01_mkNg_oO7alogalO?mkNg_o
O7alog]kN`;oO7al00koNg]kogalO?mlO7coNg]kogIfM_mgMgOoLG5aog=c
LomnOWkoVYZJom?Cdoodm?Coo?clooknoX7ooooo0023onk^kP06onc/k?oY
jNWoiNGUon3Ph?oOgmoogMgM@_oLg=`01_oMgMgogmoOon3Ph?oUiNGojNWY
onc/k0?ok^k^00Kok>c/onWYjOoUiNGoh>3PomoOgooMgMdPomcLg006omgM
gOoOgmooh>3PonGUiOoYjNWok>c/0oo^k^h01_o/k>cojNWYonGUiOoPh>3o
gmoOomgMgB3og=cL00KogMgMomoOgooPh>3oiNGUonWYjOo/k>b3onk^kP00
QOoVi^H2onGUiDKoi>CT0_oUiND7onKViP;oiNGU9?oTi>@2onGUi@Ooi^KV
0_oUiNDTonCTi0;oiNGUQOoVi^H00?ook^k^/oo^k^h00?ooOgmo/omoOgl0
0004on_[jooVi^Koh^;RomkNgPCogMgM0ooNg]h0oooMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMg@00W?oNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMg@?og]kN00?ogMgMomkNg_oNg]h00ooMgMd1on7Qh@7o
inOW0OoZj^X00003onc/k?oVi^Koh>3P00OofMWI00Cof=SHomKFe_oCdm?o
d=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?C
om3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?C
doo@d=03olg=c@04om3@d?oCdm?oemOGomSHf6gofMWI1?oHf=P5omWIf@;o
f=SH2OoIfMT3omSHf0oofMWI1?oHf=P=omWIf@;of=SH1_oIfMT2omSHf0Go
fMWI0_oHf=P6omWIf@;of=SHZ?oIfMT00ooHf=SofMWIomWIf@06omWIf@7o
g]kN0OoVi^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoPh>3oh^;R
00;ohN7Q00gog]kNomcLg?oCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_o
alO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_KfooCdm?oalO7ok^k^onb
/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoOom_K
fooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO
06[ohN7Q00?oh>3PomoOgooOgml00ooNg]h01OoOgmooh>3Pon3Ph?oPh>3o
gmoO00;og]kN00?ogmoOon3Ph?oPh>001_oPh>001?oOgmoog]kNomkNg_oO
gml3on3Ph003omoOgooPh>3oh>3P00KohN7Q0_oPh>001OoOgmoog]kNomkN
g_oNg]kogmoO00Ooh>3P00GogmoOon3Ph?oPh>3oh>3PomoOg`02omkNgP03
omoOgooPh>3oh>3P00;oh>3P00CogmoOomkNg_oNg]kogmoO0ooPh>02omoO
g`03omkNg_oOgmooh>3P00?oh>3P00CogmoOomkNg_oNg]kogmoO1_oPh>2S
on7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoTi>@1onWYj@7okNg]00000oo`
l?3okno_oo7al@03oo3`l02^ono_koo`l?3ok^k^onWYjOoKfm_o`L71ojBT
Y?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7a
ono_kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2`_nTY:Co
S8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<
S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]kOoalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo3`k_o/k>cojn_[onKVi_oWinOoiNGUonSXj?oYjNWokNg[0_o/k>`2
onOWi`04onGUiOoYjNWojn_[ono_k@;ok>c/00[oj^[Zonk^k_o/k>cok>c/
onOWiooWinGoi^KVon[Zj_o[jn_okno_0oo[jn/03?o_kngok^k^oo7alOo_
knoolO7aono_koo`l?3okNg]onc/j_oVi^KoinOWonGUi@;oj>SX00GokNg]
on_[joo/k>[oj^[Zonk^kP02ong]k@04onWYjOo]kNgokNg]ong]j`;oj>SX
00ooiNGUonWYjOoZj^[okno_ong]kOo]kN_oj>SXonOWiooUiNGojNWYon[Z
j_o_knook>c/on_[jOoVi^H00_oXj>P2ong]k@04ono_kooZj^[ojNWWonGU
i@;oj>SX0:ookNg]onc/k?o/k>coj^[Zonk^k?o^k^kolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo`l?3okno_oo3`l?o_knool?3`ono_koo`l?3okno_00Col?3`00000oob
l_;ok^k^onOWi`04onGUi@0@onCTi?oOgmoodM7Aok6a/On:RX[oIVIVoe5A
DOm5ADGo@T92odE5AOmADE7oIVIVohZ:ROna/K7odM7AomkNgP;oi>CT00?o
iNGUonCTi?oUiN@00_oTi>@03ooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5
ADGo@T92odE5AOmADE7oIVIVohZ:R_na/K7odM7@omkNgP02onCTi027onGU
iOoTi>CoiNGUonCTi?oTi>?og]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5
od92@_m5ADGoDE5AofIVI_n:RX[o/K6aom7AdOoNg]koi>CSonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUon?ShooR
h^7og=cLomSHf?oDe=CoeMGEomKFe_oHf=Sof][JomkNgOoNg]kofm_K00;o
eMGE00Goe=CDomKFe_oJf][ogmoNomgMg@02om[JfP0AomoOgooMgMgof][J
omGEeOoEeMCoe=CDomOGeooKfm_oh>3PomcLg?oIfMWofm_Kon;RhOoShn?o
iNGUonCTi?oUiND00_oShn<00ooMgMgofMWHomCDe002omGEe@0BomSHf?oI
fMWogMgMomcLg?oJf]Wof][JomoOgooPh>3og=cLomSHf?oMgMgogmoOomcL
fooFe]KoeMGEomCDe?oFe]KofMWI0_oOgml02_oLg=_oe]KFomGEeOoDe=Co
e]KFomWIfOoOgmoog]kNomcLfooGemL2omKFeP0:omcLg?oOgmoogmoOom[J
f_oFe]GoeMGEomOGeooJf][ogmoOomcLg0;of][J0:Coh>3Oon?ShooUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi0CoiNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o]kNd1
oo;blP0000?om?Cdong]kOoWinL00_oPh>004ooQhN7ogmoOomkNg_oBd];o
];BdohN7QomLG5coKC/eoii>@_o=KeoojH=_ole_GonNCT?oKC/foeaLG?n7
QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLofeP
;?nNURkocLdoonWYCOo=cCooWYX_ofeS;OmLG5coQhN7okBd]?oBd];og]kN
00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m7IbkoJ9hcoi7=AonZjEGo
TLe7ofZN=?m9JRooG5aLohN7Qond];Cod];BomkNgP1Von3Ph00AomkNg_oJ
f][odm?Colo?cooAdM7o_[jnokFe]OoGemOof=SHomWIfOoGemOodM7Aom3@
d?o4a<Coa/K6om3@d?oAdM400_oGemL04?oAdM7od];BomSHf?oEeMGod=3@
om7AdOnn_[kobl_;om3@d?oBd];of=SHomKFe_oAdM7oe=CDom_KfooOgml3
on3Ph00;omoOgooKfm_oe=CDolo?cooAdM7o`l?3ok6a/OoDe=Cof=SHomWI
fOoHf=P00_oBd]802_oHf=Sof][JomGEeOoAdM7oe]KFomSHf?oBd];oclo?
olW9bOo0`<02om7Ad@06omGEeOoGemOodM7Aom3@d?o9bLWo`<300_oAdM40
5?oFe]Kof][JomSHf?o@d=3o`l?3om3@d?oCdm?of=SHomKFe_oAdM7od=3@
olG5aOo9bLWof=SHom[Jf_oHf=SodM7Aom;Bd_oIfMWog]kNXOoPh>000ooO
gmooh>3PomoOg`02omoOg`?oh>3P00?ohN7QonOWioo/k>`00Oodm?@00003
ooKfm_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgoWinOof]OGon?=Rko
kG5QooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=cOoR
h^;oinOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOofiVGonCLR;okM54ooWc
M?omoHgooOfEoogmS_oin7KokMM7oi=c8_m^IeooWinOolg=cOoRh^;oinOW
00?oj>SX01?oinOWon;Rh_o=cLgoWinOof1XGom;O2?oT^5;okgiNoo@oI;o
f?fKomCmUOo0nGkoV>Q=odf09?mPJEooWinOolg=cOoRh^;oinOW06Coj>SX
01WoinOWonGUiOoNg]koe]KFohR8R?lA4A7o20P8ob<S8olH61SoA4A4ol71
`OoMgMgo^KViobh^;_l<30co2PX:oc8b<_nk^k_og=cLomgMgOld=3CoLg=c
omgMgOoIfMWoVi^K00;o5ADE00Wo10@4oeADE?o?cloogMgMomOGeol0003o
[:b/on?ShooWinL00ooXj>P0=OoVi^Koh>3PomOGeonNWYko7AdMo`@41?lR
8R;o5aLGoc`l??n][Jgoh>3PoeYJF_m>CTkoh>3Pon;Rh_n^[Zko0000omGE
eOoMgMgoc<c<od];Bol51@Go4a<Coa/K6onSXj?ofMWIom_Kfoo:b/[oBDU9
o`D51OlC4a?o7AdMojBTY?oKfm_ohN7QodU9BOl:2P[o7alOoc@d=?nm_Kgo
g]kNom[Jf_na/K7o;2`/o`D51OlM7Ago6QXJolg=cOoOgmooATI6of9RH_oQ
hN7oi^KV0:[oj>SX0Oo/k>`1oo;blP7om_Kf00000oogmoOon?ShooShn003
ooShn00CooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFoo^BQoonYY_oo[6Uoonh
Zoon/jKooZRLoo^DROo^J5WoRC4[oi2@T?o>c/kok^k^ooOgm`03ooShn00C
ooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_PK_onm8;oo_j:ooooT_onoXco
o_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^
k^koc/k>oi2@T?m2Lb_oQ<i3ojg_Loo2oXSoc_j@omKoUoo@oY;oa_j9ok;e
M?n8dd?oA7D[oi2@T?o>c/kok^k^ooOgm`1TooShn00SooOgmoodm?Cok>c/
ohb<S?l20P;oQHF5ooCdm?ogmoOom_Kfojb/[?o>c/kojNWYobl_;om?Cdoo
hn?Son;Rh_m@D53o=3@donWYjOo/k>co>3PhogalO?o/k>cod=3@o`T92On1
PH7ol?3`olk>c_lU9BGoKfm_onc/k?oVi^Ko0000okRh^?oclo<00_ogmoL0
2?ohn?SomoOgooGemOo]kNgo[Zj^o`000?mWIfOokNg]0_ogmoL0;_nk^k_o
_[jnoo3`l?mPH63oE5ADono_kooalO7o^[Zjo`000?oShn?ojn_[of=SHolY
:BWodM7Aonk^k_mkNg_o3`l?omGEeOoXj>SoH61Pob`/;?oBd];okNg]ogQh
N?lA4A7ofMWIono_konj^[[og]kNonKVi_mOGeooGEeMono_kooOgmoo7AdM
oeaLG?oFe]Koj>SXomSHf?oZj^[ok^k^od];BomYJFWol?3`ooKfm_ogmoNR
ooShn003ooOgmoohn?Son?Sh00;on?Sh00ComoOgooWinOogmoOomoOg0Ooh
n?P00003oo[jn_oemOGok^k^00;ok>c/0:cojn_[onWYjOoOgmoo^[ZjogUB
D_no<RCoigAYoof9O_ooV8cooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<T
ogUBD_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[k?oZj^[ogmoOokZj^_n8IE;o
hY4LooW3D?omfV?oonYbookcO_oonX;oo_Ioooo/LoongVCon/MAon:B7?n9
IU?o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S
7?nAdUGoY^MZokSiN_o0oX;oaon9ol?nQ?nioG_oYna/oiCFEomBYQcoDVeB
okZj^_oOgmooj^[Zon_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?oZj^[oinOWomSHf?lB4Q;oFEUIonSXj?oZj^[ok>c/0_o[jn/0
DooWinSo_[jno`000?nSXj?oh^;Ron?ShonOWioo0000ol;2`ooPh>3o=CDe
ogIfM_oOgmooQ8B4o`@41?oFe]Kohn?Ton;Rh_mWIfOo71`Lon3Ph?oJf][o
0000ojf][OoRh^?ojNWYon[Zj_o[jn_oj^[ZonWYjOoOgmoo<30`ocDe=OoV
i^Koj^[Zonc/k?o[jn_ok>c/onWYjOoTi>CoFe]Kodm?CooOgmooh^;Rojn_
[ol0003of=SHon7QhOl>3PkoLG5aon7QhOoTi>Coclo?o`000?n@T93ogmoO
o`/;2omdM7CohN7QonCTi?o<c<co0000oiBDU?oRh^;og]kOom[Jf_no_koo
;2`/oeYJF_oVi^KoVIVIo`820_o2`/;og=cLomWIfOoLg=cohN7Qon;Rh_m5
ADGoHf=Son3PhOoWinOojNWY00;ojn_[09gok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/00Oojn_[00Gok>c/on_[joo[jn_o
k^k^ooKfmP01ooWin@0000?ono_koo?cloo]kNd00_oUiND0[?oVi^Koi>CT
omWIfOnb/[;oNBh^olQ2=?oSJUcom7Y]oof8O?onUh[ooY^>oojHRoonRWko
m7]]onM[GOo:@SCoNbh^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGVonCTi?oH
f=So/[:boiIE;_oZW2_onka4ook<Doomf6;oo^=bookYMOoniW?oo]]Uoog<
Dook`DGokYh[oiUF;_nb/[;of=SHonCTi?oUiNGoi^KVonGUiOoTi>Cof=SI
ok:b/_l^HRkoHjd[ohO:B?nGg5WoYNEYok;cMonhmW_o]?EiojOZJonHg5Wo
RLm;of>^:ol^Hbko/[:bomSHfOoTi>CoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonCTi?oRh^;o][Jfo`000?nVYZKohN7QonCT
i?oVi^H2onGUi@18on?Si?nUYJGo0000ol;2`_oGemOof=SHokfm_Ol0003o
ZJVZomcLg?ld=3CoLW9bomcLg?m[Jf_o92@TomKFe_oHf=WoemOGohV9ROl4
10CogMgMomKFe_l0003oYZJVomSHfOoNg]koh^;RonGUiOoTi>Cohn?SomGE
eOl20P;oQ8B4on3Ph?oShn?oi^KVonGUiOoVi^Kohn?SomkNg_mHF5WoCDe=
omCDe?oGemOoZZZZo`000?oDe=CoeMGEo`000?nEUIGoemOGomWIfOoEeMGo
6ATIogMgMooAdM7o0000oiRHV?oGemOofMWIomGEeOlE5AGoNg]komkNg_o>
c/ooFUYJo`820_m8B4Sob/[:on7QhOmmOGgo20P81?lg=cL0Yoo8b<SogMgM
odE5AOmQHF7oe]KGomcLg?oQhN7oiNGUonCTi?oVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU00;oi^KV00?oiNGUonKV
i_oVi^H00ooVi^H00ooUiNGokNg]ooCdm001oo_kn`0000?oo?clooShn?oa
lO400oo^k^h04oo[jn_ohN7Qokbl_?mj5aOo`clbom=FBOoTJ5[okgM/ooB3
NOohQgcomHAjoo=iKOoUJE_ofEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^
k^h04oo/k>cohN7Qokbl_?nUAaOoiYLbooF/<?om_47ooLUCoog@H?okdfGo
oM9Pook=E?om_D;onZlbonVK<_nUAQOo_;blon7QhOo/k>`00oo^k^h04oo/
k>cohN7Qokbl_?lGFAOoGjPbogJm=on6cDOoU]IJoj;PIOnSh6WoXn5WoiOJ
G?n6cTOoMklgoen[<_lGFAOo_;blon7QhOo/k>`0I?o^k^h01oo]kNgojn_[
oj6QXOl0003oa/K6onKVi_o[jn/01?o/k>`00oo8b<So0000oj6QX@02omoO
g`0:oijNW_l0003ocLg=onGUiOlf=SKoMgMgonKVi_n<S8co0`<3omGEe@;o
gmoO017oI6ATob0P8?oYjNWoh>3Po`000?nLW9coh>3PonCTi?oYjNWokNg]
onk^k_o/k>coaLG5o`000?nTY:CoiNGUon_[j`04onc/k00;onKVi_mLG5co
=3@dom[Jf_oOgmoo[Jf]o`000?oPh>3oj^[Zoa8B4_m`L7000_oOgml06?o<
c<co0000oiZJV_oZj^[o3Ph>og=cLooOgmoog]kNol[:b_l0003oWIfMonWY
jOmWIfOo8b<Sojn_[ooRh^;oinOWon_[jonMWIgo1`L7ok:b/_nf][KoTY:B
oa@D50;oj>SX00OoB4Q8oe5ADOoPh>3oh^;RonSXj?o/k>cokNg]0:Kok^k^
00?okNg]oo;bl_ohn?P00Oolo?`000?ooOgm01Koo?cloogmoOomoOgoo?cl
oo?clooAdM7oJ0L7okPd=?o7?c?odU13omYREOoSKV;oi79TonA_H_oLI5Oo
de53ola1=?ni=3CoJ`L7om;Bd_oclo?oo?cl0oomoOd04oolo?colo?com;B
d_nN:`OofXXdon^K6OoeZ2Won;@oooVmB_oh_dgon[m:ooVh?oofZR[okihI
om^;=?nR;@Ood];Boo?cloolo?`00oomoOd04oolo?colo?com;Bd_l7@0Oo
CIXdoen[8?m`^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^BooHZhPodjK=?l7
@POod];Boo?cloolo?`0I?omoOd0;Oolo?cono_kol30`?l0003oa<C4oo3`
l?oemOGomoOgooKfm_ogmoOonOWioo[jn_lo?cooAdM7omKFe_oDe=CoA4A4
odE5AOojn_[om?CdocTi>OmnOWkom_KfonOWiol@413oMGEeonOWionk^k_o
7QhNohB4Q?okno_om?Cdo`000?lW9bOo/K6aonKVi_ojn_[oo?cloogmoOok
no_oi^KVo`000?nPX:3okno_ooCdm004ooOgm`07ooCdm?mRHV;o4a<CoeQH
F?o?clooMGEeobHV9P02oo_kn`0SogIfM_lU9BGo`<30onCTi?m[Jf_o61PH
ono_koolo?coLg=cobLW9oo2`/;ohn?SofQXJ?lJ6Q[ol?3`oo_knomUIFGo
I6ATooCdm?oWinOok>c/oo_knooalO7o6ATIohn?Soo_knooL71`oeQHF?ok
no_on_[jode=COl@413oPX:2om[Jf_ofm_H00_olo?bToogmo@03ooclo?om
oOgoo?cl00?ooOgm0000>_omoOgon_[joo?cloo^k^kol?3`ono_koo^k^ko
jNWYom?CdomK7AgoXS@dok@X7Oo1>RgoadTlolmFB_o@Ed_od5M:olY:?_o3
>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>ook^k^on[Z
j_oCdm?oS2DMolQa=?oIQ1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/X2GoiiLE
omb87Oo8LCCoS2DMom?CdooZj^[ok^k^oo3`l?o_knool?3`onk^k_oZj^Wo
dm?Coadh7OldPSCoAiDMoeZU6omY[BX2ogBh>01cogFi>?m[/B_oFjLLodRJ
7OldPSCo7CPMom?CdooZj^Wok^k^oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3ok^k^omcLfol10@7oSHf=on3Ph002on;R
hP;ohn?S00CojNWXonc/k?oHf=SoC4a<0_l>3Ph07_m?Cdoof][Jonk^kOoW
inOo=SHfogMgMooZj^[okNg]okbl_?la<C7o2PX:oaDE5OmcLg?oj^[Zono_
kooXj>So6ATIoj>SXolc<c?o=CDeono_koo^k^kol?3`onk^k_o]kNgo5ADE
ofYZJ_oOgmoohN7Qon;RhP;ohn?S0<koinOWonGUiOmMGEgoDE5AohV9ROlJ
6Q[o7QhNoinOWoo_knook^k^onSXiomZJV[o4Q8Bo`/;2olg=cOo`l?3ono_
koo^k^koinOVofQXJ?lB4Q;o30`<ocPh>?o4a<Cokno_onk^k_o>c/go@d=3
oa8B4_l=3@go/K6aonk^k_o_knoo`/;2obh^;_l92@Wo:RXZolG5aOo_knoo
kNg]oeYJF_meMGGoHF5Qo`X:2_oBd];ok^k^oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_k`;ol?3`1_o_
knl1oo?cl`7onOWi0Oono_h00003ookno_ogmoOol?3`00CojNWY017oinOW
om_KfomSBd_oPC8bojHe=Onf=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2go
YCDeoh4b<_mSBd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oRD];ojm;<_o=
McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;oRD];om_K
fooWinL01OoYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[ZbooL:dh
ofn^>_m`[CSoJZX_oe>K;OliR3Go<V0bod];BooKfm_oinOW06KojNWY00Go
j>SXonOWiomIFEWo8B4Qolk>cP02omgMg@06omkNg_oOgmoohn?SonOWiooX
j>SojNWY0_oXj>P2onWYj@06onOWiooShn?o=CDeogEeMOoTi>Coj>SX0_oY
jNT00ooWinOojNWYonWYj@06onWYj@03onKVi_oYjNWojNWY00;ojNWY00Co
j>SXogemOOl;2`_o`<300ooMgMd01_oOgmooh^;Ron;Rh_mKFe_oCdm?on?S
h`;oj>SX1_oYjNT00ooWinOojNWYonWYj@05onWYj@03onOWiooYjNWojNWY
00CojNWY00?oi^KVonWYjOoYjNT01?oYjNT00ooVi^KojNWYonWYj@05onWY
j@03onKVi_oYjNWojNWY0:7ojNWY00?oj>SXonWYjOoYjNT01?oYjNT1oo3`
l07omoOg0Oono_h00005ookno_ojn_[om?Cdono_kooalO400_o`l?004Oo_
knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZNW?oIW9coe9FEok]c
LonEE5CoCb<SoiFDU?oZj^[okno_00Gol?3`017okno_on[Zj_nYU9CoPB<S
okYZE?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S8onZU9Co
j^[Zono_k`05oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCoLjEcoik6UOn/
cYco[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Zj_o_knl0Ioo`l?00
2Oo_knoog=cLoc`l??lL71coLW9boh^;Rom[Jf_o;2`/ok6a/@02ono_k`Go
l?3`00Kokno_ong]kOlg=cOoNWYjonk^k_o_knl@oo3`l00>ono_kooZj^[o
E5ADo`h>3_mZJV[oRh^;og=cLolg=cOoSXj>ong]kOmOGeooDe=Cong]kOo_
kno>oo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn0003ooooo`03ookno_oo
oooooooo00;oo_kn0?oooOgmooShn?m^KVkoFSlook6@T?oNbLWol>CToo?V
i_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?coooooookno_ooooooo_kn
ooooo_ono_koooooooclo?ohn?SoSFe]ohXo?oo9TI3ojM39ooCYi?ofjnKo
m>WTonW@bOo9TI3oRCloohe]KOohn?Ooo?clooooooono_koooooookno_oo
ooooo_knooooo_olo?con?Shofe]KOlo?cooT9f@olWEbOoTk>Coi^kVonC/
i?o9eLWoT9f@oclo?om]KFgon?Shooclo?ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
oOgmok2`/?moOgooJ6QXohR8R?n[Zj_okno^oogmoOooooooo_knooooooon
o_koooooookno_ono_gooOgmocXj>_n2PX;oo_knoogmoOooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ono_go_knoohJ6Q_mWIfOoPh>3ojFUYOoTi>Co
oOgmofEUIOmHF5Soo_knoogmoOooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_h0
0:;oooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_h2ooooo`03ookno_oooooooooo00Cooooo
00001?ojn_[oo_knoo[jn_odm?@5oo7al@0=ono_kooFe]KoJf][od<m?OnK
S8coa[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7al@0=ono_
kooGe]KoPf][og@m?OneS8coeKZjon7<c?oF^[[o]Xb<og8m?On1Jf_oemKF
ono_k`09oo7al@0=ono_kooFe]KoJf][ocdm?On<S8co^[Zjolc=c?nj^[[o
S8b<ocdm?Om[Jf_oe]KFono_k`1koo7al@03ong]kOo_knoolO7a01_olO7a
0_o^k^k9oo7al@04oo3`l?oalO7olO7aoo3`l0ColO7a00?om?Cdoo[jn_on
o_h00OoinOT00005onSXj?omoOgon?Shoo3`l?o[jn/00ooZj^X03OoYjNWo
j^[ZonWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oY
jNT02ooZj^X02ooYjNWoj>SXoj2KVomZFEWo@bHVobd92Om29RKoJEUIoj2K
VooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHV
oeUIFOnKVi_oj>SXonWYj@3oon[ZjVgoj^[Z00Cojn_[oo3`l?ohn?SooOgm
0OoWinL00004ok^k^oohn?Son_[jooCdm0SolO7a0_o`l?03ono_k`;ol?3`
3ooalO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l?oolO7a
JooalO400oo`l?3olO7aoo7al@02oo7al@03ooGemOojn_[on?Sh007o^k^k
00000ooEeMGoc/k>ooooo`3oooooojkooooo0Oo>c/h1omCDe00000Koh^;R
olK6a_nk^k_ok>c/oo[jn_omoOgoooooojOooooo00GooOgmoo[jn_o[jn_o
^k^kolK6aP01on;RhP00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{434, 429},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(col = ShowColorChooser[]\)], "Input"],

Cell[BoxData[
    \({223, 25, 25}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[
        Graphics[\[IndentingNewLine]{\[IndentingNewLine]{RGBColor @@ \((col/
                    255. )\), 
              Disk[{0, 0}, {1, 
                  1}]}\[IndentingNewLine]}, \[IndentingNewLine]AspectRatio \
\[Rule] Automatic, \[IndentingNewLine]Axes \[Rule] 
            None, \[IndentingNewLine]PlotRange \[Rule] {{\(-3\), 3}, {\(-2\), 
                2}}\[IndentingNewLine]]];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .66667 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.166667 0.333333 0.166667 [
[ 0 0 0 0 ]
[ 1 .66667 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .66667 L
0 .66667 L
closepath
clip
newpath
.875 .098 .098 r
.5 .33333 m
.5 .33333 .16667 0 365.73 arc
F
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 192},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000`1P00`40o`000?l0003oooooob7oool0
0?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool0
0?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool0
0?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool0
0?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool0
0?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool0
0?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool0
0?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool0
0?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool0
08[oool;gaTIRoooo`00PooooaWO6AV4oooo0021oooo7MlI6H;oool007oooolQgaTIP?ooo`00Nooo
obWO6AUloooo001joooo:mlI6G_oool007Soool_gaTINOooo`00M_oooc?O6AUgoooo001doooo=mlI
6GGoool007?oooligaTIM?ooo`00L_oooc_O6AUcoooo001`oooo?mlI6G7oool006oooom0gaTILOoo
o`00Kooood7O6AU`oooo001^oooo@mlI6Fooool006gooom5gaTIK_ooo`00JoooodWO6AU/oooo001Z
ooooB]lI6Fcoool006[ooom;gaTIJoooo`00JOooodcO6AU[oooo001YooooCMlI6F[oool006Sooom?
gaTIJOooo`00Iooooe7O6AUXoooo001VooooD]lI6FSoool006KooomCgaTIIoooo`00IOoooeCO6AUW
oooo001UooooEMlI6FKoool006CooomFgaTII_ooo`00I?oooeOO6AUUoooo001SooooF=lI6FGoool0
06?ooomIgaTII?ooo`00H_oooe[O6AUToooo001RooooF]lI6FCoool006;ooomKgaTIHoooo`00HOoo
oecO6AUSoooo001QooooG=lI6F?oool0067ooomLgaTIHoooo`00HOoooegO6AURoooo001PooooG]lI
6F;oool0063ooomNgaTIH_ooo`00H?oooekO6AURoooo001PooooG]lI6F;oool0063ooomOgaTIHOoo
o`00Goooof3O6AUQoooo001OooooH=lI6F7oool005oooomPgaTIHOooo`00Goooof3O6AUQoooo001O
ooooH=lI6F7oool005oooomPgaTIHOooo`00Goooof3O6AUQoooo001OooooH=lI6F7oool005oooomP
gaTIHOooo`00Goooof3O6AUQoooo001OooooH=lI6F7oool0063ooomOgaTIHOooo`00H?oooekO6AUR
oooo001PooooG]lI6F;oool0063ooomNgaTIH_ooo`00HOoooegO6AURoooo001QooooG=lI6F?oool0
067ooomLgaTIHoooo`00HOoooecO6AUSoooo001QooooG=lI6F?oool006;ooomKgaTIHoooo`00H_oo
oe[O6AUToooo001SooooFMlI6FCoool006?ooomHgaTIIOooo`00HooooeSO6AUUoooo001TooooEmlI
6FGoool006CooomFgaTII_ooo`00IOoooeGO6AUVoooo001UooooE=lI6FOoool006KooomCgaTIIooo
o`00Iooooe7O6AUXoooo001XooooCmlI6FWoool006Sooom>gaTIJ_ooo`00JOooodgO6AUZoooo001Y
ooooC=lI6F_oool006[ooom;gaTIJoooo`00K?ooodOO6AU]oooo001]ooooAMlI6Fkoool006kooom3
gaTIKoooo`00K_oood;O6AU`oooo001_oooo@MlI6G3oool0077ooolmgaTIL_ooo`00L_oooc_O6AUc
oooo001coooo>MlI6GCoool007GooolegaTIM_ooo`00Mooooc7O6AUhoooo001ioooo;MlI6G[oool0
07[oool[gaTINoooo`00NoooobWO6AUloooo0020oooo7mlI6H7oool008;ooolKgaTIPoooo`00Q?oo
oaOO6AV5oooo002;oooo2MlI6Hcoool00?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQ
oooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQ
oooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQ
oooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQ
oooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQ
oooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQ
oooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQ
oooo003ooooo8Oooo`00ooooob7oool00?oooolQoooo003ooooo8Oooo`00ooooob7oool00?oooolQ
oooo003ooooo8Oooo`00\
\>"],
  ImageRangeCache->{{{112, 399}, {367.188, 176.188}} -> {-5.35085, 1.68982, \
0.0209427, 0.0209427}}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JTree <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:90001jaP00`40o`00
0?l0003oo`000?l0002;000000000hS0^4R@R4R@R03oB928odR@R8M8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^8J8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;R6R<2h0DR@R04000000005R<2hb>3HR<2hR<2hc<c<
0?ooooooooooP_ooo`:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVK<
c<coIVIVofIVIX1VIVH01?ooohS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV027oool00nogmoooonogm`02oooo00?_moOooooo
ool00_ooo`03koOgooookoOg00;oool00nogmoooooooo`3oooooooooodgo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0K
oooo00?_inOgmno_inL06noWi`04e]KWknOWknOWe]KW1^oWi`03koOgoooo
oooo0?oooooooooo>_ooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV01[oool03_OgkmkNg/k>g[fm_KFmc/k6]KFmc/k6]KFm
c/k6]Kfm_KFmc/k6]KFmcP>m_Kd01lk>c[fm_LJm_KFmc/k6]LJm_KFmcP02
_Kfm00G6_Kfe_Ljm_Kg6_Kfe_Lh00kfm_@09c/k>_Kfm_Kfma[fm]Kg>_Kfm
c/k>c]KNknOW0?oooooooooo>oooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV01[oool01MkNg/k>cZf]YJf]YIbLY@0AW9bL
00>LW:F]YIBLW:D00YbLW007[JFDW9bUW9bLW9bL[JfUW9bLW9bU00:LW9`0
0jf]YIbLW9bLW002[JfU00?>c/kNg]k_moL0ooooooooooljoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06_ooo`03knOW
g]kNoooo02Koool2g]kN00?_inOoooooool0oooooooooolhoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06_ooo`03g]kN
c]K>oooo01?oool00oOgkoooooooo`02oooo00GWkoOoooooooooooo_inL0
0_ooo`03knOWooooinog00;oool01>ogmoooonOWg/k>c_oooooooooo>ooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01Wo
ool00nO_mnOWg/kFgP02oooo00?_moOoooooool02oooo`03koOgoooooooo
00?oool00nO_moooooooo`0:oooo00O_inOooooooooooooNg]k>e]k_inL0
ooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH06_ooo`03g]kNg/k6oooo017oool00nogmoooooooo`02oooo
00?gknOoooooool00_ooo`04inogooooooooinog1Oooo`05knOWooooknOW
c/k>koOg0?oooooooooo>_ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV01Woool00oOgknONg/kFgP0>oooo00?_moOooooo
ool01?ooo`03moO_oooooooo00[oool00nogmoooonO_m`02oooo00?Ng]k>
e/k_inL0ooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH06_ooo`03g]kNc/k>oooo00?oool02^oWilk>c^oW
inogmoooonO_moooonoWilk>c^oWi`;oool00nogmoooomkNgP05g]kN00KF
c]J4Ng>LJf>]Nf?>_JFDS8`2[G]S00Zm_Kg>a[GNg/k>a[Fm_JgWkoOooooN
g]k>c/k_moOooooooooooc[oool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP0Joooo00CFe^ONg/koooo_inL2_Kfm00G>c/jL
W9b]]KG>c/k_moL00Zf]Y@:LW9`07Hb<S;fm_Jf]YNoWioooonOWg^oWioOg
knoWioO_inOWg]k>aU9:@W/@28@H4:ekHiA2<G<H49`a8LjUQ=kNc^oWc]kN
c/k6]NoWioooomkNg/kFg^oWi`3ooooooooooc[oool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0Ioooo00?gmnoWimk>e]h0
0_ooo`03e/kFg]kNknOW00;Ng]h01noWioooomKFinoWilkFc]kNg[fm_@02
g]kN0_ooo`0Hc/k>Q9BDW9bUW9bLNhB4Jg=cFV][BQPHLaP@W34QQ3TaHaPH
Q24HYG=J[G]SW9bUW8AkU8aS[KFemoO_ooooknOWc/k>koOgoooooooooolj
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
6_ooo`03e]KWe/kFoooo00Ooool00nogmoooooooo`02oooo00?WkoOooooo
ool00_ooo`0>g/k6S8b<S8b<Jf][S8b<[JFDJf][DPP8Jc4YW34Q[G]SQ1P@
Q24HJc4Y0TYBFP08FUYJDTY2Jg=cknOWoooog]kNc]KNknOWoooooooooolj
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
6_ooo`05g]kNc]K>oooomnoW[KFe00:m_Kd01kFmc[fm[NoWilk>cZf]YNoW
ijfe]@02_Kfm01?Ng]je_Lk>a[Goooo>e]jm_Kf][JFLU8b]YIC>a[EkLf<H
411B20R]Nf><JdZ48AQk<BUB>C4Y:BT00cTi<@06FUY2knOWooooinONc/k>
koOgooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH06Oooo`0]koOginONc/k>ooookoOg_Kfm[JfUc/kNc/Je
c/k>knOWc/k>_KfmknOW[JfU_Kfmc/k>g]kNc/k>[KFeoooog]k>_Kf][JfU
W9bL[Ib4c[fULf]S8AP@DTY2Hd8iBS4YDSTaDSTYNg]kNhB4FUYJBU8iBTXa
BU8iknOWooooe]KWc]K>knOW0?oooooooooo>_ooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV01[oool02=kNg/kFg_oooooo
onogmoooonoWinO_m`Goool00nogmoooooooo`02oooo00W_inOoooo>c]jm
_Jfm_KfDS8acLeZ]W8AcJf<00U8i<@0?@RTQDSTaFT8iDSTaS8acS8b<Ng]k
Jf=BJf]:FV=JknOWooooinONc/kNmoO_0?oooooooooo>_ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01Woool2knOW00?F
c]Koooo_inL00/k>cP09W9bU[JFD]Kg>c/Jeg]kNc]KNc/k>g]kNc]KN00;>
c/h03<Jm_LkFg_ooolk6]Hb<S8b<LeYJ@Xb<S<k6]G=[He9:@S4H409B>C40
17=JDU8i<EYJ@W]cH`9[JdX01eYJ@V][B^oWinogmnoWilkFc^oWi`3ooooo
oooooc[oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP0Joooo00KNg]k>e/kooooooon][JF]]KD4_Kfm00KNg]jm_Kg>a[G>
e]k>a[F]]KD2_Kfm016][JGooon]]KE:BTYBBT9[He:<S7>LQ7]JFUYB>BU2
:B5[BT9JFT9cFU9SFTXY:APi>AP00UYB:@06>CTHNf=:knOWoooog]kNc/k>
oooooooooolkoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH06Oooo`06koOginONc/k>ooookoOgknOW2Oooo`0NknOWinON
ooookoOgknOWoooo[JfU:C4Y:BTHBTXY[JFDa[fm>CTa@RTQDSTaDTY2NeY:
Jf=BFT8i:BTHBS4YBTXYLg=JBS4YDV=2e]KWooooinONc]KNknOWoooooooo
ooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH06_ooo`0:g]kNc]KNooooknOWc]KNg]kNc/k>g]kNc/k>knOW0/kFgP0P
knOWg]kNc]KNc/k>e/kFknOWc]KNkoOg[JFD0000:BTH>B4HW9B<c/J]Ng=S
:BTH@RTQ[G]SU6]JJc4Y>CTH:BTH<CTQBTXYBTXa>CTHBTXaknOWkoOgknOW
c/k>koOgooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH06Oooo`0]koOgknOWc/k>oooog]kN_Kfm[JfU[KFe
[JfUW9bL]LKF[JfU_Kf]c]KNc/k>W9bU[JfU_Kfmc]K>_KfmknOW[JfU4000
:BTH<CTQ_Kf]g/jmS8ac:BTHLeYB[G]SaZfLQ7]c<CTQ610@>CTHBU8iBUY2
:BTY>D8aknOWooooe]KWc]K>knOW0?oooooooooo>_ooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01Woool2knOW00?>e/ko
ooooool00nogm`04moO_c]KNinONknOW1^ogm`?oool06:f]YBTY62TY62TY
68b<LljmYDYJ@RTY63TQ67]SBXa[BUYJ@SU2<BTa:BTQ24YB>HBDU7^4Q5YS
F^oWinogmnOWg/k>g_Ogkooooooooooo>_ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV01[oool00mkNg/k>g_ooo`04knOW
00CFe^O_inOWimkFe^L6knOW00GFe^OgknOooon][JDa>B400TYJ@P09U8aS
_Kf][KFeJg=c4108>B4H<AP@610@FV][009JHeX02F=cS:fe]IbegZFec^oW
inogmmkNg/kFc^oWi`3ooooooooooc[oool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP0Joooo00KNg]kNg/koooo>e]jm_Kfe
[Jd2[JfU01F<S8be_Ljm_JfLW:F][JF]]KFm_Kf][JF]]KF][JGWkoOoooo>
c/iSLhakQ8A[He9kNg^m_Jf]YIB<S8`Y:BT00P00000=BU9JW;GNYKG>W;GN
YKgNW;GW]LKFW;GNknOWmoO_g]kNc/k>koOg0?oooooooooo>_ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01[oool01MkN
g/kFg_ooonoWimkNgP02koOg00?_inO>c/k_moL00^oWi`03c/k>knOWc]KN
00;_inL01>O_moO_ioOgkmKFi`:L[Kd01YbLYJf]YKfm_KFmc[G6eZFecP9S
Lh`6W;GN00NL]NNU]Lk_inOooooNg]k>e]k_inL0ooooooooooljoooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06Oooo`;_
inL01LkFc_ooonoWinoWinogm`02knOW00>]]KG_inO_moL01NoWi`05inog
mnoWinogooooc]KN00:]_NL00jg6mib]_Lk6[@03W;GW00F]a^nL]NNL]MjL
]MjL]NL01IbegP05c]KNkoOgg]kNc/k>koOg00_oool00`000?ooooooo`06
oooo0`0000Coool01@000?ooooooooooo`000004oooo0`0000?oool01@00
0?ooooooooooo`000002oooo00@0003oooooool00003oooo0P000003oooo
0000oooo00;oool20000ooooooSoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP0Joooo00SWimk>c]koooo>e]jLW9c>a[Fe
_Lj]]KD2[JfU00>LW:F][JFLW9`00/k>cP0@[KFe[JfUS8b<c/k>oooo]LKF
W:gNW;GNW:gNW:fm[JfUW:gNW:g>W;GNW:gNW:g>0Yb]gP06W:g>W:gNW:gN
W:g>W:gNW:g>0^oWi`03g]kNc]K>knOW00_oool00`000?ooooooo`05oooo
00D0003oooooooooool000000oooo`050000oooooooooooo000000?oool0
1@000?ooooooooooo`000002oooo00D0003oooooooooool000000_ooo`04
0000oooooooo00000_ooo`030000oooooooo00800002oooo00@0003ooooo
ool0003ooooomoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV01Woool02>ogmmkNg]kNc_ooonoWilkFg^oWioOgk`?_inL0
1LkFg^oWinOWg]KFinoWi`03g]kN00G_inO_moO_inO>e]kNg]h00/kFgP04
g/k6e]KWg]kNe]KW0/kFgP03g]kNc]KNc]KN00C>e]h01KG6e^oWioOgklkF
g/k>cP0<oooo00<0003oooooool01Oooo`050000oooooooooooo000000;o
ool01`000?ooo`000?ooo`000?ooo`000002oooo00<0003oooooool01?oo
o`0;0000oooooooooooo0000oooo0000oooo0000oooo000000;oool01@00
0?ooooooooooo`000002oooo00<0003oooooool0ooooooSoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0Joooo0]kNgP0>
ooooknOWooooooooe]KWc/k>knOWmoO_oooomoO_inogknOW_Kfmg]kN0_oo
o`0:inogknOWkoOgooooknOWoooomnoWooooinogkoOg0^oWi`04ooooknOW
inogmoO_0^oWi`03g]kNknOWkoOg00;_inL00mkNg/kFc^oWi`0;oooo00<0
003oooooool01Oooo`050000oooooooooooo000000;oool01`000?ooo`00
0?ooo`000?ooo`000002oooo1@0000;oool02`000?ooooooooooo`000?oo
o`000?ooo`000?ooo`000003oooo100000;oool00`000?ooooooo`3ooooo
n?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool:c<co2?ooo`;_inL04<kFg_ooonogmjf]YKfm_Lk>cXb<S:f]YKFm
c^oWiibLW:f]YHb<S8BDU9B<S:fe]@:][JD02Lk>c^oWinO_mmkNgYbLYLk>
cZfe]Jf]YIbLW002c/k>00RLW9cNg]j]YIC>c]j][JFLW:F4U9C>e/h2knOW
00C_moO>c]k>c/k_moL;oooo1@0000?oool01@000?ooooooooooo`000002
oooo00L0003oool0003oool0003oool000000_ooo`050000oooooooooooo
000000;oool02`000?ooooooooooo`000?ooo`000?ooo`000?ooo`000006
oooo00@0003oooooool0003ooooon_ooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0@oooo00GN
g]k>e/koooo_inO>c/h00mkNgP0:c]KNknOWknOWg]kNc]KNc/k>e/kF[KFe
g]k>c]KN0/k>cP07ooooknOW[KFeS8b<_Kfm[JfUg]kN00;>c/h02MkNg/k>
c]kNg/k>c]kNg]K>e/kFc/k>c]KFi`03knOW00?Ng/k>e]k_inL02oooo`03
0000oooooooo00;oool010000?ooooooo`0000?oool00`000?ooo`000003
oooo00L0003oooooooooool0003oool000000oooo`030000oooooooo0080
0002oooo00L0003oool0003oool0003oool000000_ooo`050000oooooooo
oooo000000;oool010000?ooooooo`000?ooooogoooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo
013oool01>OWg/kFg_ooonogm`?oool01NoWioooonO_moooooO_i`03oooo
00S_inO_moO_inOoooo_inOooooNg]k>c/h2g]kN00[_inOooooWkoOoooo_
inOWkoOgknOWkoO_inOWkoL4knOW00GFe^O_inO>e]kNc/K_moL02oooo`03
0000oooooooo00;oool010000?ooooooooooo`<00002oooo00D0003ooooo
ooooool000000oooo`030000oooooooo00<00003oooo00@0003oool0003o
ool200000oooo`800003oooo0`0000Coool20000ooooooSoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oo
ooooool04?ooo`05e]KWc/k>ooooknOW[JfU00:]]KD02Kfm_Jfe]MkNg[fm
_Jfe]NOWgZf]YKFmcZf]Y@02c/k>00Ne[Jfm_Kf]]KFLW9b<S8bm_Jg>c]h0
0Zfe]@:][JD01/k>g[fm_Jf]YKfm_Lk>cZf]Y@:]]KD2[JfU00G>c/k_inO>
e/k>c/kWkoL02oooo`030000oooooooo00;oool00`000?ooooooo`0Koooo
0P0000?oool20000ooooooooool5oooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00ooool02?Og
knOWg]kNg_ooonoWijfe]Jf]YLk>cP:m_Kd01=kNg/k>cZf]YMKFi`:][JD0
1/k>c]kNg[fm_IbLW<k>c/Jm_@:m_Kd02/k>c]kNgZfUU:fe]Lk>c[fm_Lk>
cZf]YKFmc/k>cP:m_Kd01Zf]YLk>c[fm_Jf]YKfm_NoWi`;>c/h00oOgkooo
ooooo`09oooo1@0001koool00`000?ooooooo`03oooo00<0003oooooool0
ooooooooool3oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo013oool01=KFilkFc_ooonogm`?_
inL01]kNg_ooooooonoWioooonogm`;_inL01_ooooOgkoOgkmKFioO_inO_
m`;gmnl00nO_mnogmnoWi`02knOW00KWkoO_inONg]kWkoO_inO>e]h3knOW
00OFe^ONg]kNg]kWimk>c/k>e]k_inL0ooooooooooljoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooo
oooo00ooool01oOgknOWg]K>e_ooonoWilk>cZfe]@02W9bL00Z][JFm_KgN
g]k>c/jm_KgNc/K>e]jm_Kfe_Ljm_Kd2c/k>00nm_Kfe_Lk>c/k>a[G>e]jm
_Kf]]KG>c]kNg/jm_Kf]]KFm_Kf]]KFm_Kg>c/h00[fm_@04c/k>[JfU_Kfm
c/kN0/k>c_oooooooooo>oooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0@oooo00OFe^O>e/ko
ooo_inNLW9bm_Kf][JD00[fm_@05[KFec/k>_Kfm_Kfmc]KN00:]]KD01Zf]
YJfe]Jf]YJfe]Kfm_Jf]Y@:m_Kd02=kNgYb]_Jf]YLk6]LkFgXBDU:f]YJfe
]@:][JD02/k>c[fm_IbLW;fm_Hb<S9bLW=kNg/k>c]k>a^O_mooooooooooo
>_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0?oooo00KgmnoWimk>c]kgmno_inONg]h2inog
00K_inO_moO_inOWkoO_inO_moL2knOW00C>c]k_inOgmno>e]h2g]kN2noW
i`06g]kNknOWg]kNg]kNc/k>e/kF0/k>cP04c]KNc/k>c/k>mnoWoooooooo
ooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH01oooo`03c<cooooooooo013oool01=KFilk>c_ooomKFi`G>c/h01=kN
g/k>c/k>c^ONgPC>c/h03<k>g/k>c/k>cXBDU;fm_Lk>c/kFg/k>c[fm_Lk>
c[fm_Lk>gP;>c/h01kfm_Lk>c[fm_Lk>c[fm_KF][Jfe]@02_Kfm00CNc/Jm
_Kg>c/k_moOooooooooooc[oool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04?ooo`04g]kNc/k>
ooooc]KN0jf]Y@0=W9bUS8b<c/k>W9bL[JfU]LKF_KfmQ9BD[JFD[JfUc/k>
[KFec/k>00:][JD019bLW;fm_Lk>cZf]Y@:<S8`04<Jm_IbLW8b<S9bLW9bL
YHb<S;fm_Hb<S9bLW9B<S9bLW8b<S;Fmc[fm_MkNc^oWiooooooooooo>_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0?oooo00C_moO_inO>c/k_moL3knOW00GNg]k_inO>
c/k>e/kNg]h01NoWi`03inONknOWknOW00;_inL01]KFimkNg/kFc^oWinOW
g]KFi`?>c/h02;fm[Lk>g/k>c]k>a[Fmc[fm_Lk>c[FmcP>m_Kd00kfm[LkF
g_ooo`3ooooooooooc[oool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03oooo`04mnoWe]KWg]k>
oooo1=kNgP07c/k>g]kNc/kNg]kNg]k>g]kNc]KN00;Ng]h00lk>g]kNg]kN
gP02g]kN00[>c/k_inO>c]kNg/je_LkNc/J][JFLW:Fe_Lje[Jd2[JfU00>]
]KF][JF][JD00Zf]Y@06W9bU[JfU[KFe_KfmknOWkoOgooooooooooljoooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01ooo
o`03c<cooooooooo013oool01>oWilk>c^ogmlk>cP:][JD00ibLYIbLW8b<
S002[JfU00f4U9BLW:F][JF][JFLW:F][JFLW:G>a[FLW:F<S8bLW9c>c/j<
S8`00ibLW004[JfUS8b<Ng]kNg]k0V][J`0:W9bLJf][Jf][Ng]kS8b<FUYJ
W9bL[JfUc/kNknOWoooooooooolkoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00ooool01^O_
mnOWg/k>c_ooolk>c/kFgP?Ng]h02[fm_MkNg]kNg]kNg[fm_MkNg/k>c/kF
c]kNg^OWgP;>c/h00kfm_Lk>c]kNgP02g]kN00c>c/k>e]k>c/jm_Kf][JFL
W9b<S8akNg^<S8akNg]kQ8AkNg/2S8b<00>LW9bm_Kg_inL0ooooooooooll
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
1oooo`03c<cooooooooo013oool01>OWg/k>c^ogmnoWi`CNg]h2_Kfm00SW
imkNg]kNg]kNg]kWimkFe^ONg]kFe^L6g]kN00S>c]kNg]kNc/K>c/jm_KfL
W9b<S8a[Lg<4Jf][00EkNg]kQ8BLW9bm_KgNg]h0oooooooooolmoooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03
c<cooooooooo00ooool02_OgkmKFilkFc^O_mnoWihb<S:f]YLk>cXBDU;F]
[@FLW9`01Lk>cZfUU:f]YHb<S9bLY@02[JfU00>LW9b][JF<S8`00YbLW003
NhB4_KfmNg]k00=[Jf/00hb<S7]kNhb<S002[JfU0/k>cP03g]kNoooooooo
0?oooooooooo??ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Ooool00lc<ooooooooo`0@oooo00ONg]k>c/k_moO_inO>
c/k>e/kWimh00]kNgP09c]KNc/k>c/k>c]KNc/k>g]kNc/k>c/kNg]k>00?>
c/h00jfe]Lk>c/k>cP02c/k>00G6_Kfe_Lj][JF<S8bm_Kd01?ooo`04knOW
g]kNc/k>g]kNoooooooooolooooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013oool01mkNg/k>
c^oWinoWimkNg]KFinoWi`02g]kN00[Wg]k_inO_inO_inONg]k>c]kWimkN
g]kFe^O_inL6g]kN0lk>cP03[KFeU8b<c/k>00?oool2g]kN00?>c/kNg]ko
ool0oooooooooolooooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00ooool06>O_mnOWg/k>c^og
mlk6]Lj<Hmk>_NoWimjm[LIkB/k6[LkFgZf]YHBDU:fe]IbLW<k>cZfe]JfU
U8BDU:fe]IbDS<k>cYbLY@BLW9`02Zf]YG^4Q6][Jkfm_OooonogmnOWg]kN
g/k>c]kNg_oooooooooo@Oooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0@oooo01S>e]k>c/k_
moO_inO6[IcNg/k_inO6[Ic>S6?_inOFe^Nm_Jg>c/j]]KG>c/kNg]k>a[Fe
_Lk6_Kg>a[Fe_Lk>a[F][JF]]KD2_Kfm00ZLW9b][JF<S8akQ8C>c/koooo_
inO>e]k>c/kNg]kooooooooood;oool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03oooo`0=koOg
knOWc/k>knOWinONc]K>cZF4c/JeaW]:c[fUknOWinONc]KN00;_inL00nOW
g]kNg]kNgP04g]kN00?>c]k>c/kNg]h00]kNgP09a[fm]Kg>[JfUS8b<c/kN
knOWg]kNc/k>g]kN0?oooooooooo@oooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0@oooo00WN
g]k>c/kgmnoFe^O_inOF]Ic>a[G6Nd[>e]h00^oWi`03inONe]KWinON00GN
g]h01<k>g]kNg]kNc]kNgPC>c/h2[JfU00F<S8cNc/KNg]k>c/kNg]h0oooo
oooooom4oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo00ooool00nO_mnOWg/k>cP03knOW00?>
a[G>S6?>W7/00^oWi`03inONg]kNg]kN00?Ng]h02<kFg]kNg]kNg]kNg]kN
c]K>e/k>c]kNgP;>c/h2_Kfm0YbLW003c]KNc/k>g]kN0?ooooooooooAOoo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0@oooo00cNg]k>c/k_inO_inO>e]kWimjeLe[>aZg_
inOWimkFe^OWimh5g]kN00KNg/k>c]kNg/k>c]kNg/k>c]h3c/k>00Jm_Kf]
]KFLW9bm_Kg>c/kNg]koooooooooodKoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03oooo`05
koOgknOWc/k>moO_c]KN00;_inL01<k6]NOWg^OWg]KFi`GNg]h01lk>g]kN
g/kFg]kNc/k>g]kNc/kFgP03c/k>00Jm_Kf]]KF][JF]]KG>a[GNg]kooooo
ooooodOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04?ooo`0;knOWc]KNknOWinONc]KNknOW
inONe]KWinONg]kNinON00?Ng]h01mkNc]kNg]kNc]K>e]kNg/k>c/kFgP02
c/k>00O>a[Fe_Ljm_Kfm_Jf][JF]]KGFe^L0oooooooooom8oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo013oool04>ogmnoWioOgkmKFinoWinOWg]KFinOWg/kFg^OWg/kF
g]kNg/kFg]kNg/kFg]kNgP;>e]h00lkFc/kFg/k>cP03c/k>00Fm_Kf]]KF]
]KG>c/k_inL0oooooooooom9oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool>knOW00SN
g]k_inO_inO_inONg]k_inONg]k_inL2g]kN0^oWioooooooooooBoooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`3oooooooooogKoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0oooooooooomf
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
1oooo`03c<cooooooooo0?ooooooooooM_ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`3ooooo
ooooogKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool0oooooooooomfoooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo
0?ooooooooooM_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Ooool00lc<ooooooooo`0:oooo00[_kno_g^OWknOFimjU
W:ESDV>DU9Bee/KFg]kWinL5oooo00?Wkmkoooooool0oooooooooomJoooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01ooo
o`03c<cooooooooo00[oool03^o_knoNilk>cXB4Q10@648i@QPQ67>LNf]c
Jg^4NibUW;Fm_MKFg^O_ioooooooooooG_ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0:oooo
01;_knoFe]J][JdY:BV][Jg_inlH<AQk_Hac_G]S]G]SW7=SS6]SQ6^4S8BU
[JG>a/KNg]kWinOooooooooooe[oool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool02_ooo`0EinoW
a/K6S8B4<C4aknO_kno_BV]:JlikLnN4JnMkJmIkF/IcHkEcFZE[FXa[Hhac
Ng]kU9BD[Jf]c/k>g]kN0?ooooooooooEoooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0:oooo
00[Fg]Jm_KF4Q8ABDU;WknO_g^MJJeYc_G>4gXakkh@3Nmj<00a[ihA[gXAJ
eW]S]G=JYF]JS6=SS6]cS7^DU9Bm]KgNe]KWg^L2oooo00?_g^Ooooooool0
0_ooo`;WknL6oooo00?WknOoooooool0oooooooooom1oooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooo
oooo00[oool03=KNg/k>aYbDW6=SHnO_inoWkf=cJhc>Q:GWW:GWU9CWS7__
Q0:4gX`03g__S7_NS7?FQ7?>Q6_>Nf^mQ6>UNf>LLf>UNf>DLg^DNiB]U;G6
]MKFe_ooo`03kmkWoooooooooom<oooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00[oool02>OW
imK>cZFLYEYJHmK>c/K6aTYJDV^eJ`9kkh@019c_U9cNU:GWU9c_U0:DgX`0
0hC_S7_WQ7_WQ002Nmj<00]kiiASeXaSeXaJYF]SU6]JS6=SS7>4W8bUYJG6
a/KWg^L01?ooo`03inoWoooooooo0?ooooooooooAOooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0:oooo00S_knoWinN][Je[Jf_Fc/k6a/IBHeY[]F/2HnMc00Ucig]kig]k
khBDihbLkiBUkibLgYBDkiB4kh`00g_WQ008LmikJmikNmj<JmJ4HlIkJkf4
JjekHjEk0V^<L`04U:FL]KFea/k>inOW0^oNi`;We]h2oooo00?WknOWinOo
ool0oooooooooolooooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00[oool02>o_knOWikFm_G=k
NnO_g]kFeW>4LhC>Q09kig/027?WNf?NLf_>Lf_WNg?WQ7__S9C_U9cWW0>U
ki`019C_U9CWS8c>Q7_WQ0Acih@02f_FQ5[6Lf>eLf>UNf>LLf^<Lg>DNhbU
U:fm[MKFe^oWk`3oooooooooodCoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool02_ooo`08kno_
kmkWa/K6Lg]kg]KFe/kFNhAkS<j40YCWS00BNnn4NnN4Nnn4NnN4LnMkLnN4
LlikNnN4S>NDQ>n<U>N<YNnLYNNLYNnLYNNLW>nDQ>n<NnMk0W?WN`0?Lmik
HnMcNmj<HmJ<HlIkHkEkHjecHiacLiAkLiakYJfU]Kfme]kFooooinOW00;_
g^L00nONioooooooo`3ooooooooooc[oool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool02_ooo`0;
knO_inOW]KFeJg=ca/Jm_KfmHg=[JkE[Nnn4NnN4Nnn400:4kh`01iCWS9CW
U9CNS8CNS8C_S8CNS7_WQ002Q=j<0XC_S003W>nDYNnLYNNL00:Lki@058C_
S7_WNg_WNg__Q7_WQ7?NQ7_NS7_FS6^mQ6_>Nf>eNf>LLf>DJf^<LhBUQ:F]
YKg>_MkNg^oNinOWiooooooooooo>oooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0:oooo00[_
knoWknO6a/J4Q8CNe]KFc/icNg]c_G=kkhAkih@2NnMk00N4gXb<iiBDkiBD
kiBDiiBLkiBLgY@018C_S006Nmj<LmikQ=j<Nnn4U>NDW=jD0YcWW005W>nD
Q>n<NnN4NnMkQ=j<009kih@017?NNg?NQ7?>Q6^mQ09[[G/01f>LLf><Jg>D
NhBUU;Fe]LK6a]kNgP3oooooooooocWoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool02_ooo`0>
inOWkno_]KFeQ8B4inOWg]kNS9b<Q:F<YNnLW>nDS>NDU>N<Q>n<Q=j<0XcW
U003YNNDW=jDYNND00:Uii`00jG_W9c_U9CWU002Q>n<00QkgXacig]cig]k
ig]kihB4khb<iiBDih`2Q>n<0W__Q003NnN4LnMkLnMk009cgW/2JmIk00mS
aW]JaW=B_F]SU6]SU7=[S7>D[IBma[g>c/kWg^O_g^OWinO_inoooooWg^L0
ooooooooool`oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo00[oool02>oWknOWikg6_G=cLmK>
e/K6aW^4Ng^DN`:Uii`01:G_W9cWW9cWW9c_U0:Dii@3S>ND00N4khbDkiBL
gYBLiibUkibLiibDki@00YCWS003Q=j<NnMkLmik009[cW<01G?NNg_WQ8C_
S8C_S8CNS002Q>n<00IkihAkkhakihAkihAcihAkgX`2Lmj400ac_G]c]G]S
[G=SU6]SS6][S7>4YHBU[JFm_Kg>e/kWkmkWinL2oooo00?_g^Ooooooool0
ooooooooool[oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo00[oool02NoNino_kkg6_G=kLmK>
e[fm_G^4Nf^<JjGWU002W=jD00>LiibUkibUkjD00Zg_Y@06YNnUYNnLYNnL
W>NLU>nDS>ND0YCWU003W=jDW>nDW>NL00:Lki@069C_U8C_S9CWS7__Q7_W
Q6_>Lf?FLf_>Lg?WNg__Q8CNS7__Q7_WQ7__Q7__S7__Q7__S7_NS7?WQ7?N
Q7?WQ7?FQ6_FNf_>N`9S[G<025ZUJg>4LhBUS;gW_NoNinO_ioooonoNkooo
oooooooo;Oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV00Ooool00lc<ooooooooo`0:oooo00[_ino_knnea[EkNg_Wg^OF
e]JDW9ASS6^UkibDii@2S>ND00VDkibLiibLiibUkjFmijFegZfmkjfegZfe
kjd00ZG_W003W>NLW=jDU>N<00:Dih`018CWU8cWU9C_U9C_U0:<ii@01XC_
S7__S7?WQ6_NNf?FLe[FJ`9SgV/01W?NNg__Q7_WQ8CNS7__S7_WQ0Acih@0
2G_NS7?WQ6_NQ6_FQ7>eNf>]LicNW>oWknoNi`3oooooooooobooool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool02_ooo`0;knO_inOW_LJmNg]kimkWe]KNYJfUJhA[_NNe]Nn]
YNnL00:Lii`05YcNU9CWW9CWW:GWW:G_W:g_YKG_[LKW[LkW]KgW]LKW[Jg_
YJG_YIcWW8cWU9CWS8CNS8C_S8CNS8C_S8CNS9CWS0:4kh`01G_NS7__Q7?W
Q6?NLf?NJ`02F/iS00ASgV]SgW=cig]kih@2Nnn40g__S009Nmj<Nnn<Nmj<
NnN4JlicLlike]kFinOWinoW0?oooooooooo;_ooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0<
oooo012ma[ecLg?Fc]K6a[fU[JEJNeZmkjfmijFegZfekjfmijf]kjfmijFe
gZfUkjFUgZD2YNNL00N]kjfekjfekjfegZfmijg6ijfekjd00Zg_Y@03YNnL
W=jDQ=j<00=kih@00g_NS7__S8C_S002Nnn<0W?WQ004JnN4HmicHmIcF/i[
0U;>H`0<HmIcJmikLnN4Nmj<Nnn<Q>n<Nnn<Q>NDLnMkHnMcHmIca]k6oooo
ooooool`oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo00[oool02^oWkooookg6_G=cLmKFe/K6
aZF]YDY[B[gWYJGNY@:]kjD02;G_[Kg_]KgW]Lk__LkW]Kg_]KgW[KGN[@:U
kjD01jGNYJG_YJg_YJg_YJGNYKgWYKG_[@03[NnU00FLiibDkiB4gXakig]c
cW/00f_NN`09Nnn<LnN4LnN4LnN4JnN4JnMkJmikHmicF]Ic009BcV/02e;>
He[>Jf?FLf_NNg__Q7?WQ7?WNf?WLkGF]NONinoNi`3oooooooooobkoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo
00?<c?ooooooool03?ooo`0?_KfmNhAkknO_g]kN]LJeBV]:_Nne]Nn]YNNL
YNnLW=jUYNNL[NnU_NN][Nne00:mkkD01lk__LkW]LkW_KgW]LkW]JgW[JGN
Y@03W>NL00BUkibUgZFUkjFLgY@2U>nD00Z<iiB4khb4khacihA[gW]JeW][
eW][gW][gXAcig/4LnN40V_WN`0;F]I[D/iSB/iJB/iJHmi[LnMkHnMcLnMk
_NNmkmkWinOW0?oooooooooo;_ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0;oooo00CWinNm
a[ekQ7_Ng]h2e]kF00UBFU;FilJmkkFmkkFmikFmkkFegZfUgZFekjd00kGN
[@:mkkD02Lk__LkW_MK__MK__Lk__KgW]Jg_YJGNYIcWW002U>ND00bDkiBD
iibDkibDkiBDkibDkiB<iiB4khakkhacihA[gW]SeW<2F]I[00=JeW=SeW=[
gW/00V_NN`04JnMkJmikJmikJmik0V_WN`03Q=j<HnMc_NNe0?oooooooooo
<?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0<oooo00jm_Ke[Lf_>e/k6c/Je]KDi@SW>kkfm
g[FmikFmkkG>kkg>ikfmkkG>kkd2_Nne00BmijfegZfegZfmijd2_NNe00^m
kkFmikG6kkfmkkFmikFekjfUkjFLgZFDkibDiiB<ii@00hCNS00>Q>NDQ=j<
Q>NDQ>n<Nnn<Nmj<JnN4JmikHmicF]IcD/iSF]I[F/IcHmic0V_WN`06JnN4
Nnn<LnN4Nmj<LnMk[NN]ooooooooool`oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00coool0
1lK6aW^4NmkNg/kFc/K>aS4i<LK__@02_NN]00>mikFegZfmkkD00/kW_@;F
ilH2c^nm00K6kkfmikFmikFmijfmg[G6ijd2_NN]00Rekjf]kkFmkjfekjfU
kjFLiibDiiB<ii@2Q=j<00EkihAceXAkihAkihAkgX`00g__S09cih@036_W
Q6_NNf?FLe[>Je:mJe[>Je[6Lf_NNg__Q8CNS7?WNjg_]Ooooooooooo<?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0<oooo00bm_Kf4Q8C_knoNg]k>e/hi@SWFilJmkkFm
ikFmijfegZfmijd2_NNe00?6kkg>ikgFilH01=KWaP04c^o6c^Nm_NNe_NN]
0[GN[@03_NNU[NN]]Mj]00:]kjD2YNnU00BLiibDkib4iiB4gX`3Lmj400I[
eW][gW][gW]cgXAcihAkgX`2LnN400][gW][eW]SeW=SeW=[eW]kkhB4gXac
ig^]kkGooooWinL0ooooooooool^oooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00coool01[fm
_G]kNnOWimKNg]KFeT9:@P?FilH02/k_a/kW_LK__Lk__KgW]LK__KgW]LKN
a/kW_Lk_aPGFilH01<k__LK__KgW]KGN[@:UgZD2W=jL00FDiiBDiibLiibL
iibDii@00YC_W008Q>NDNmj<Lmj4JmIkHmIcJmIkHmIcJmIk0W?NQ009LnN4
Nmj<Lmj4Lmj4LnN4NnMkQ=j<LnMk[Nn]0?oooooooooo<?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0:oooo00c_knoooonm_KecLg?Ne]K6c/k6a/Hi@T:mikG>ikg>klKF
ilH2c^o61=KWaP;>klH3c^Nm00?FilK>ikgFilH00]KWaP06c^o6c^Nm_Nne
_NNe[NnUW=jL0YCNU003Q=j<S>NDQ>ND00:<ii@01IC_W8cWU8cWU8CWU7__
S002Lmj400a[eW]JeW]SaW]SeW=[eW][gXAcgXB4iiAkkhB4gXakkhBUeZd8
oooo00@0003oooooool00002oooo00@0003oooooooooool2000000?oool0
003oool00_ooo`800005oooo0`0000Goool400001Oooo`030000oooooooo
00?oool00`000?ooooooo`3ooooomOooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0<oooo00O6
a/IkNg_WinOFe]K6c/IBDU:egZd00/K__@05_Mjec^Nma^nme^nme^O600;F
klh01=k_c]KWc]k_c]KWcP;Nklh2a^nm00Bmg[G6kkg6kkg6kkd2c^nm0[g_
]@06[NN]W>NLU>NUU>NLQ=JDNnND0W?FQ003NmJ<Nmj<Nmj<009kgX`03G__
S7_NS7_WU7?NQ6_NQ6_FNf?6Nf?FLg?FQ7__Q8CNS7_WNjG_[@08oooo00@0
003oooooool00002oooo00@0003oooooool00002oooo0P0000;oool01000
0?ooooooo`0000?oool01@000?ooooooooooo`000003oooo00<0003ooooo
ool00_ooo`030000oooooooo00?oool01@000?ooooooooooo`00003ooooo
n?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Koool400003?ooo`07_KfmNg]kkno_inOWe]KFHf=S]Mj]00;>klH01LK_
_Lk_a/kW_LKNa/kW_@03e^O600SNklkFilkNklkFilkNklkFilk>klK6kkd2
_NNe0kGN[@:]ijd01Zg_YJg_[JG_YJG_YIC_W9CWW0:4ii@017_WQ7?FQ7?>
Ng?FQ0MkgX`2LmJ400EcgXAkig^4gXakkhBUgZD02?ooo`070000oooo0000
oooo0000oooo000000;oool01@000?ooooooooooo`000002oooo00<0003o
ooooool00oooo`030000oooooooo00?oool010000?ooooooo`0000Coool0
0`000?ooooooo`03oooo00@0003oooooool0003ooooonOooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Goool00`0009VI
c9VIc002VIW<00<0003oooooool02Oooo`0:_KfmLg=cg]kNe]KFc/k>Q8B4
W:fDe^O>g^o>e^O60]K_cP;Filh00mKWa/KNa/k_aP02e^O6017FklkNklkF
klkNklkFklkFilkFilK>ikg6kkfmijfegZf]kjFUgZFUkjFLgZFUkjFLgZD0
0ZG_Y@:DijD01YCWW8cFW7_WU7_NS6_FQ6_>N`9ceX@2NmJ<00EkiiAkgXak
iiB4iiB<ii@00XCNS004S>NDooooooooinoW1Oooo`070000oooo0000oooo
0000oooo000000?oool400000_ooo`030000oooooooo00?oool00`000?oo
ooooo`03oooo00<0003oooooool01Oooo`030000oooooooo00Coool00`00
0?ooo`00003ooooonOooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00Coool0100006IVVIVIc<c<o`;oool00iVIc0000<c<
o`04c<co1Oooo`08a/K6Q8B4e]KFc/k>]KFeNg]kQ9akc^o60]KWaP03g^o>
e^o>g^o>00?NkmH2e^O>00?NklkFilkFilh00mKWaP?>klH3c^Nm00F]kkFe
kjfUgZFLgZFLii`019CWW003U>nLU>NLU>nL00:Dki`01ICWW8CWU7_NS7?F
Q6_FQ003Jlik00UkeXakiiB<iiAkkhB<gYB<iiCooooWinOWknL01Oooo`07
0000oooo0000oooo0000oooo000000Koool010000?ooooooo`0000Goool0
0`000?ooooooo`03oooo00@0003oooooooooool400002?ooo`030000oooo
oooo0?ooooohoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01?ooo`030000IVJIc<co008000000ooooiVIc00000040000
1_ooo`07_KfmQ8B4inOWg]kNa/K6U9BDJha[00;Filh00lKNa]KWa]KWcP02
e^O>00CNkmKNklkNkmKNklh5e^O>00CFilK>ikg6kkg>ikd3a^nm00VmkkFm
ikF]kkFekjfUkjfLgZFDkibDiib<eY`00XCFU003Q=j<Q=JDQ>ND00:4ii@0
19C_W8CWU7_WU7_NS09ceX@02G?>Nf_FQ9CWW7_NS8cWU8CNS>O_inoWknO_
i`05oooo00L0003oool0003oool0003oool000000_ooo`050000oooooooo
oooo000000;oool010000?ooooooo`0000;oool00`000?ooooooo`03oooo
00@0003oooooool0000;oooo00<0003oool00000ooooooWoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP04oooo00<0001V
IYW<c?l00P000003c<coVIW<000000@00006oooo00Nm_KekNg__knoWinON
g]jm_KeSLeX00]k_eP04c^o6e^O>e^O6c^o60]KWcP03e^o>e^O>e^O>00CN
kmH3e^O>0/k_aP06a^nm_Mje_NN]_NNe[Nn]]Nn]0jg_[@05YNn]W=jUU>NU
U>NLQ=JD009keX`04G_NS7?FQ7_FS7_NS7_WU8CFU9CWW8CWU8CFU7_WU8CF
U9C_W8C_S8cNU8CNS>O_inOWi`06oooo0P0000?oool200000oooo`<00004
oooo0P0000?oool00`000?ooooooo`03oooo00@0003oooooool00004oooo
00<0003oooooool00oooo`040000oooooooo0000ooooooWoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP04oooo00<0001V
IYVIVL`00/c<o`:IVL`00`000?ooooooo`08oooo00^m_KekNg_Ng]k>c/k6
a/Je]KE:FT[WkmkNkmKNklkNkmH00]KWcP03g^o>g^oFg]KF00;NkmH01]k_
c]k_e]k_c]k_e]k_c]k_eP;Nklh01]KWa/k_a/K__KgW]KGN[JgW[@:UgZD0
0icNYIcW[JG_Y@03YNnU0YCWY@04U>NLQ=JDQ=JDNmJ<0W?>Q00;LmJ4NmJ<
NmJ<Nmj<Q=JDQ>NDW=jUQ>NDS>NDQ=j<e]kF00Ooool200000oooo`80000@
oooo00D0003oooooooooool000000oooo`030000oooooooo00;oool00`00
0?ooooooo`03oooo00D0003oooooooooool00000ooooooSoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP05oooo00<0001V
IYUVIYT00VIVV@030000oooooooo00Woool03;fm_G]kNnOWimKFe[fm_KFe
]CUB>MKNe]k_e]KWc]k_e]k_cP;NkmH00nO_g]k_e^O_gP02g^oF00GNe]KN
kmKNkmKNkmKFilh00]K_cP0=e^O>e^O6e^O6c^o6a^nm_NNm]Nn][NN]YMjU
W=jUU>NLU=jLU>NU00>Dii`00iC_W9CWYICWW002Q>ND00b4gXakeXaceXAc
cXAccW]ccXAceXBLgZF4iiB<iiAkkhcFg]H7oooo00<0003oooooool00ooo
o`030000oooooooo00ooool300001Oooo`@00005oooo00<0003oooooool0
0oooo`030000oooooooo0?oooooeoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01_ooo`@0000<oooo00Vm_Kf4Q8C_knoW
inOFe]K6a/Ha>C7NkmkNkmH00]KWcP0=e^o>e^O>e^O>g^oFinoNg^oFg]kN
inoNg^oFinoNg]kNg^oFg^o>00;Filh2c^o61LK__@05[Nne[Nn]YNn]W=jU
U=jU00:<gY@3Q=JD0hCWU005U>NLS=JLQ>NDQ=JDNnND00=keX`01IcW[ICW
S8CWU7__S<kFcP3oooooooooobooool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03?ooo`08a/K6
Ng]kkno_inOWg]kNe]KF@TY2inoW0mk_eP04e^O>g^o>g^o>e]kF0]k_eP04
inoNg^oFg^oFinoN0mk_eP0:g^o>e^O>e^O6c^o6a^nm_Mje_NNe]Mj][Nne
]Mj]0Zg_[@>Ukjd019cNYICWYHcWU8cNU0EkeX`02hCNS8CFU9CWW8CFU8CW
U9CWW9cNYHCWU8cWU8CNS<kFcP3oooooooooobooool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
3?ooo`0>_KfmQ8B4g]kNe]KFc/k>a/K6BU9:e^O>inOWinoNg]KFinoNg]kN
inoN1]k_eP0?g^o>g^oFg^o>e]kFg^o>g^oFe^o>g^o>e^O>c^o>_NNm_NNe
[NN]YNn]YMJ]00BUkjd2W>N]0iCWY@:<eY`2NmJ<00Ak_HakeXakeXakeX`2
Q=JD00NLgZFDgYbLijfDijFUkjgoooo_inl0ooooooooool]oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo00coool02kfm_G]kNnOWimkNg/k>c[Fe]F=[F[fm]Mk_e]KNe^O_
gP03g^oF1>O_gPCNkmH2g^o>1MKWcP;>klH01LK__KgW_KgW]Jg_]JG_[@02
W=jU0YCWW0:DgY`2U>NL00FDijFDiibDijFDiiakii@00g_FS09ccX@01IcW
W9CNYIcNYICWYJGNY@3oooooooooobooool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03?ooo`0?
_KfmQ8B4inOWkno_g]kNc/k>NhAkS9b<inoWg]kNinoWe^O>inoNg]KFg]kN
00CNkmH00nO_g]kNg]k_gP02g^oF00CNklkFilk>klK>klH2a^nm0kgW_@08
_Nne[Nne]Mj]YNn]YNNeU>NUU=jLS=JL0XCFU0:<eY`2U>NL0XcFW0:Dii`3
Q=JD00FDiibDijFLijfDgZFUkjD0ooooooooool_oooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo
00coool00kFe]HB4Q>o_k`02inOW00?Fe]JLYIb<U8`00^O_i`04inoNg]kN
g^oFinoN0]k_eP08g]kNg^oNinoNg^oNg^oFinoNg^oFg]kN0mk_eP08e^O>
c^o6a]k6_Nne_NNe[NN][Nne[NN]0Zg_]@07[Nn]YNn]W>N]YNnUU>NUU=jL
S=jD00:4eY@00hCNS8CFU8CFU005S=JL00JDiibLgZFLijfDgZFLgZGWknOo
ooooooooobkoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool03?ooo`0A_KfmQ8B4inOWg]kNc/k>
a/K6_LJmBU9:inoWinOWinoNinoWinOWg^oFinoWinOWinoW00;Wkmh2g]kN
00?NkmKWkmkNkmH01=k_eP;Fklh02<KNa[gW_KgW]JgW[JGF[JG_[JGNYIcW
[@:LgZD00jG_YIcW[IcW[@02U>NU00>4eYB<eYb4eY@01G_FS007Q=JDU=jL
U>NUW>N]U=jUW>NLinoN0?oooooooooo;_ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0<oooo
00Fm_Kf4Q8CWinONg]kFe]H00/K6aP088BTQe]KFinoWinoWinOWg^oFinoW
inOW0^O_i`07kmkWinOWinoNinoNinOWinoNg]kN00;NkmH2e^o>00KFilkF
ilK>klK>klK6kkfmikd2[Nne00ZUeZfLijfLgZFDgYbDgZFDgYbDgZFDijfU
kjFLijd2U>NU00BDiib<eYb4eYB4eY@2NmJ<00JDiibUkjFLijfDijFDgYcF
g]Koooooooooobkoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP07oooo00?<c?ooooooool03?ooo`0@]KFeQ8B4kno_kno_
inOWg]kNa/k>YJfU<CTa_LJminoWinoNinoWinoNinoWinOW1>O_i`06inOW
inoWinoNinoNg]kNe]kF0]KWcP04c^o6c^Nma^o6a^o60kgW_@09_NNe[Nne
[NneYNn]YMJ]U=jUU=jLS=JLS=jD00F<eY`2U>NU00VDiib<eYb<gYBDijFL
gZFLijfLgZFDgYcFg]H0ooooooooool^oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00coool0
1;fm_HB4Q>o_kno_k`?WinL02/kFc[Fe]E9JDSU2>EYJFXB<Q=kNg^o_knO_
ino_k`;WknL01NOWinO_inOWinOWinO_i`02inoN00ONkmKFilkFilk>klJm
ikfmikFee[D01Jg_]@>Ukjd00icW[IcNYICWY@02S=JL00F4eYB4eXakeXb4
cYB4eY@00XcFW007U>NUW=jUYNnUW>N]U>N]U=jDe]KF0?oooooooooo;_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0<oooo00>m_Kf4Q8CNg]h00]KFeP04c/k>e]KFc/k>
c/k>0]KFeP07_KfmS8b<Hf=SBUY:FV]JS9b<a/k600;WknL01Mk_g^O_inO_
g^OWinO_gP02g^oF00SWkmkNkmKFilkFilkFilK6kkfmikFee[D2[Nne00>L
ijfUeZfLijd019cNY@05W>NLU=jLU=jUU=jUS=jD00:4cY@02XCFU8C>U8CF
U9cW[ICNYKgW_IcNYICWW;gWa^O_iooooooooooo;Oooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0;oooo00CWinOFe]I[Jf__knl2inOW01;>c/k6a/Jm_Kfe]KFm_Kg6a/K>
c/k>e/k>c/k6c/Jmc[fL[Ia[Lf]2BT9:FU:4S8Bma[gWknL3inoN00GNkmKF
ilkNklkNkmKFklh00lk_aP04_NNm[Nne[Nne[Nne0YcW[@:DgZD019cW[IcN
YICW[ICNY@:DijD00iCW[ICNYICWY@02S=JL00R4cYBUkjfLgZFUikFLgZFD
iiBmklKWknOoooooooooobgoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03Oooo`05BTY:inOW
kno_inOWkno_00;Fe]H01/k>c[fm_Kfm_Kfm_Kfe_KFe]@?6a/H03Lk>c]KF
e/K>aYbLW6]cLdYJ@TYBBW=kLjfm[Mk_e^O_g]k_e/k>aP02e^O>00K>klk>
klK6klK>kkfmikF]kjd2[Nne00>UkjfUikFLijd00iCFY@03S=JLU=jUS=JL
00>DgZD2U>NU00NLijfLgZFUikFLgZFDiibmikgWknL0ooooooooool]oooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01ooo
o`03c<cooooooooo00goool00ibLW6][Jno_k`02inOW00?_knoWinONg]h0
0]KFeP03c/k>a/K6a/K600:m]Kd2]KFe00Rm]Kg6a/K>a/K>c/kFe]K>e/j]
]JecNf/2@TY200]cNf^L[IC>klK>klk>klJmg[FegZf]ijf]kkFmikFekjd0
0jgW[@0CYNn]W=jUW=jUW=jUU=JUS<JDS=JLQ=JDQ<jDS=JLU=jUS=JLW>N]
YMjUYNn]W=jUU>nL_NNmg^oN0?oooooooooo;Oooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0>
oooo00A[Jf^U[JGWg^ONg]h3c/k>00KFe]KNg]kNg]kNg]kFe]KFc]H2c/k>
00K6a/Jm]Kfm]Kfe]KFm]Kfe]KD2_Kfm00c6c/KFg]K>e/j]]Jf4S8A:FTXi
FSUBJe:4YHBee[G>klJmikD2YMjU0ZGWW004W=jUYMJ]YNn]YNn]0YcW[@03
U=jLU=JUU=jL00:<eY`2Q<jD0YcNY@05YNNeYMjUW>NLYMJ]g^oN0?oooooo
oooo;Oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0>oooo00CFg]I:BT[WknOWinL2e]KF00K6
a/Jm_Kfm_Kg6a/K>c/kFe]H3g]kN01KFe]KFc]K>c/k>c/k6a/Jm_Kfm_KFm
_Kfm]Kfm_Kfma[g6a/K6c/K>e/kFe]Jmc[f<W8aBFU8aFSU:HdYSQ6>LgZD2
YNNe00BUkjfLijfDijFLijd2YNn]00>LijfUkjfLijd00YCNY@09U=jLS=JL
W=jUYNNLYNNeYMjUW>NLYNNee]kF0?oooooooooo;Oooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0;oooo0^OWi`;oool0248i@^o_knOWino_knOWimkNg]KFe/k>cP;6a/H0
2[g6_Kfm_LK6a/k6a/k>c]KFe]kNg]KNe]KFe]K>eP;>c/h00lK>c/K6a[fm
_@02_Kfm00g6a/K6a[g6a/K6a/K>e/kFe]Jm_KfUYJEJJf=:FU9BJe9SS6^<
_I@00ZGF[@04W>N]S<JDU=jUW=jU0YCNY@:Lijd029cNYJGNYIcNW:gW[IcN
YIC_U:GF[Lk_c_oooooooooo;Oooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0=oooo00SWinOo
oomJFU[Ng]kWinO_knoWinO_knl3inOW0]KFeP09c/k>a/k>a/K6_LJm_Kfm
_LJma/K6c/k>e]KF00;Ne]h2g]kN00?Ne]kFe]kFe]H00/K6aP04_KFma/K6
a/K6_Kfm0/K>cP;Fc]H00lk>cZf][F]cL`02>E8i011JJeY[_HBDgYbLgZFD
gZF<eYbDgYb<eYbDgZFUkjfLgYbUikFUgZFDkibUikG>e/koooooooooobgo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07
oooo00?<c?ooooooool03Oooo`05g]kNooooS8b<W9bLkno_00;Ng]h01=KF
e]kNg^OWinOWi`;_knl2inOW00GNg]k>c/k>c/k>c/k6a/H00kfm_@;>c/h5
inOW00GNg]kFe]KFe]K>c/k6a/H01Kfm_@0Da/K6c/k>c/k>c/k>[Jf]NhAk
BU9:>E8iDW=BJhacS<JDW=jUS=JLYMJ]YNn]YMjUU>NLW>NLW=jD_NNmoooo
ooooool]oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo00ooool03=KFeTY:B]KFe^OWino_knOW
imKFe/k>c]KFe]kNg]KFe]kNgPCWinL2g]kN0]KFeP07c/k>a/K6Q8B4FUYJ
Q8B4a/K6inOW00?_knl03>OWimkNg]KFe]KFe]kNg/k>c/K6a[fm_KFe]Kfm
_KFe]Kfm_@;6a/H02LkFc]KFe[Fe]HBUQ59SFS5J>D9J@V><JhbmU003YMjU
00>Ukjf]kkGoool0ooooooooool/oooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013oool01Kfm
_DY:BYBDU;fm_NOWi`02kno_00?WinONg]kFe]H01=KFeP03g]kNinOWinOW
00?WinL02]kNg^OWioooolk>cYBDU7=cLeYJFW]kNkFe]MkNgP;_knl00nOW
imkNg]kNgP02e]KF00C>c/k6a/Jm_Kg6a/H2]KFe00Fm[KFe]KFm_Kg6a/K6
c/h00/K6aP07S:FDNiAkBV]:>EXiFW]JU:fDe]kF0?oooooooooo;Oooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0=oooo00?Ng]kooooWinL00_ooo`07e]KF[Jf]Ng]kJf][
Ng]kYJFUe]KF00;_knl00nOWimkNg]KFeP03c/k>0]KFeP03inOWg]kNinOW
00;oool02]kNg_ooooooomkNgZf][G]kNeYJFW=cLjFUYLk>cPGWinL04MkN
g]KFe/K6a/k6a[fm_Kfe_Kf]]Jf][KFe]LK6a[Fm_LK6a^OWioooonO_imk_
e]KFeP3oooooooooobkoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03?ooo`03inOWooooinOW
00Coool02]kNg_oooooooooookfm_Hb<S6][Jg=cLibLW<k>cP;_knl2g]kN
0]KFeP03c/k>e]KFoooo00Woool01mkNgZf][HB4Q6=SHf][JiBDU;fm_@02
g]kN00WWinONg]kFg]KNkmKFg]K>c/K6a/Jm[KFe]KD00[fe_Ooooooooooo
<oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0@oooo00?WinOoooooool01?ooo`06inOWoooo
ooooooooc/k>U9BD0V][J`04U9BD_Kfmg]kNinOW0]kNgPkoool00mkNg/K6
aXb<S002Hf=S00J<S8b][Jg>e/k>e/kFg]KFimh2e]kF00C6c/K>c/jm]KgW
inL3oooo00?_inooooooool0ooooooooool/oooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00[o
ool01NOWioooooooooooomkNgP0@oooo00GFe]JUYJF4Q8B][JgWinL05?oo
o`09c/k>U9BDLg]cFUYJLg]kYIbUa/K6g]kNg]KN00;Ne]H2inOW0oooo`03
inOWoooooooo0?oooooooooo:oooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0=oooo00?WinOo
ooooool0;?ooo`06knO_[Jf]Ng=kFUYJHf=S]Kfm1Oooo`;WknOooooooooo
obgoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool0oooooooooomfoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo0?oo
ooooooooM_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00?oool01no_kjf][EY[HibLW>O6
a^OWioOgm`04oooo00?_ooogmoOoool0oooooooooom_oooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`0;g]kWU8b<
41P@BTY::B4Q[G=kNg]kU8b<[Jf]e[g6kno_0?ooooooooooLoooo`05IVIV
ooooR<2hR<2hB92800400000000GR<2hb>3HR<2hR<2hIVIVooooino__Kfm
:C4Y_LJmoooo>APQcXB<cW=kaV]c[F][W6=[S6]cW8b<_KFee]KFkno_moOg
0?ooooooooooK_ooo`05IVIVooooR<2hR<2hB928004000000009R<2hb>3H
R<2hR<2hIVIVmoOge/kFW9BL<CTi00;oool03g]BF/ikQ?mkU>mcS>MkQ<ic
Nke[LjESJjESHiA[LhB4Q9bLW;fm_MkNg_O_k`3oooooooooof_oool01FIV
I_ooohS0^8S0^4R@R001000000002HS0^<SPf8S0^8S0^6IVI^OWilK>cXbD
S5YJFP02oooo00AcFV?>NiCoS:goS:D2ohBL0_MkS00;kf=kieYcaV]c[F][
YF=SU6]cU8B4YJfUa/k>g^o_moOg00;oool00nooooooooooo`04oooo00?_
ooooooooool0oooooooooomKoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00V8`;S8h=R8`;R8`;QVIVKginOFe]jU[JE[Lf/00_ooo`0GJg=[gXb]ojG>
ojG>miBmoiBemiB]ohbUkhbLohBLkhBDgW^<eW>4cW=k_F]c[F][YF=SYF][
W8B<]IbLc/K>inOWoooo00?_ool;oooo00?_ooogmoOoool0oooooooooomB
oooo00EVIVKooon8`;R8`;Q8T8P00@0000000128`;S8h=R8`;R8`;QVIVKg
knoWknn][Je[Hf?Wg^OFg]iSBU;6LiCoU;GoW;goYLH2ojG>01CoYLKgU;g_
U;goS:goS:GgNiCgQ9CgNhcWNhC_Hg_WJg^eLg>UJg>LHf^DJg>LS8bm]KG>
g]KWmoOgmoL7oooo00?gmoOoooooool0oooooooooomEoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`0=_KfmJg=[
imkWc]KFJeYJaW>Dmf^4mg><mg>DmhBUoiBeoibmojG600;oYLh05onL_OnD
]On<[On<[On4W?MkU?McU>n4U>MkQ=IcNliSLlIcLjEcLia[LiacNjfUYKfm
_NONg_OgmnooooooooOgmnooo`07oooo00?gmoOoooooool0oooooooooom>
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
0_ooo`08a/K6Q8B4moOgino_S7]kgXb]oiBeohb]0_McU004kg><mg>DohBL
ohbU0_nUaP;o]MH05?nUc_nUa_ND_Nn<]OMkU?n4W?McS?MkS?MkU>m[Q=Ic
NliSLkEcLjE[LjEcLjEkNkFLW;fm_NOWinooooooooooooooF?ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool01/kF
cXB4Q>oWknOWiiB4Q=j<[@;oW;d01?nD]On<[On<YON4Y@;gNi@01]ikU?n4
W?nD[OnD]OnUa_nUcP;o]MH01OnUc_nUa_nD]On<YOMkU003mg>D00ggNhcW
NhCFLg_6Jg>eLg>]Jf^ULg>UNg^e[JgFc/kWinOgmoOoool00noooooooooo
ooooD?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00;oool01[g6aW]kNmK>e/k>cV]cJlikU0?oS:d00onD]OnL_OnL_@02
mibm0_n<[@09miB]mhBUmhBUmiB]ohb]oiBeojG6okGFojG>00;oYLH02OnL
_OND[ON4YOn4W?mkU?MkU?N4U>MkS=ikQ002cV=c00VULg^LJg>LLg^]S9Bm
]KGNc]Kgknooooo_ool0oooooooooom?oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`06c]K>S8b<knO_g^OWU7=k
cW^L0_n<[@;gQ:D02?n<[OnD]OnL_OnL_OnUa_nUc_nUa_nL_@;oU;D02On<
YOn4W>mkYON<YOnD]ONL_OnUa_n]c_nUaP02oibm01;_S;GgQ:G_NjGoQ9c_
NjGgNiC_Q9CWNhcFLg_6Lg^eJg^UJg>DJg>LNg^]S9C6a/KFe]Kgknoooooo
ooooodgoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP02oooo00[Fa/j<S8c_ooo_knnLU9beW9coYLkoYLKoW;goU;D3oiB]
017oU;G_YLkgW;gg[LKoYLko[LkoYLkoYLKoW;goU;GoS:goS:G_NjGgNiCg
Q:GoS:goU;D00onL_@0DoiBeohb]ohbUohbUmhBUmg^Dmg>DkhBDkg^<ig><
gV]kcV=ccUY[YF][W6]cW7=k]IbLe[g6g]kNkoOg0^ooo`;oool01>oooooo
ooooonoooooooooooooo@Oooo`05IVIVooooR<2hR<2hB92800400000000@
R<2hb>3HR<2hR<2hIVIVkoooooooc/k>Q7]kg^OWe]KFW8B<W8bDokGFojG>
ojg>0_nUaP04ojg6oibmoibmoiB]0onD]@04ojG6mjg6ojg>ojG>0_nUaP;o
W;d02?nD]NmkYNmkYNN<W>McS>n4U?n<YOn<[@;oU;D2ohb]0_n<Y@06ohBL
mg^DmhBDmg^DkhBDkg^<0/ikQ00:]F]kYF]cYF]cU7=k[HbD_JFUc/k>imkN
ooookooo0_ooo`03kooooooooooo0?oooooooooo?oooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool02]K>cXAkNmkW
ilk>cYB<S9acNnnUc^n]a_NL_On]aP;o[Lh4okGF00Co[LkoYLKoW;goU;D2
oibm00Gg[LKoYLkoYLko[LKoYLH00_nL_@08oiBeohbUohBLgW^Dkg><ig><
mg^DohbU0on<[@;oS:D2ohBL00SgNiCgQ9CgLiCoQ9cNNiCWNhc>NhBmJg<2
]G=c00NDLg^]S9Coc]k_ooogmoOoooo_ool0oooooooooom1oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`07e/k>
S8b<koOginOW[JFUU7=kojG600;gW;d01OnD]OnL_OnUa_n]a_n]cP02mkgN
0onegP03okGFojg>ojG600;gW;d4oiBe0_nL_@;oU;D01?n<[On4W?MkU?Mc
S0?WHh@01>mcS?MkU?n4W?n<[@;oS:D3ohBL0_mkU004ohBDmhBDkg^<ig^4
0/IkS003kjFeooookooo0?oooooooooo@oooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00;oool02Lk6cXB4Q?OgmnoWkkfe
]IAcNoo>konme_n]cP02ojg600?g[KggW;gg[LH00_n]cP0=okg>okGNolKW
olKWmlKWmkgWokGFojg>ojG6mibmoiBemiB]ohbU00;oS:d2oiB]00KoU;Go
S:goS:GoQ9coNiC_Lh`2if>400CNFW_WHhC_LhcgNi@7ohBL0_mkU004khbL
gW^<gW^DknO_oooooooooom4oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00f8`;S8h=R8`;R8`;QVIVK_oooooooFc/j4Ng_NinOFe]Jm]KEkHg<01?ne
gP04olKNokGNokgFmkgF0_n]cP;gYLh01Onme_neg_neg_neg_o6i`02okGN
0_neeP05ojg>mibmmjFemhBUmhbU00;gQ:D3ohbU0_n4W00Dog^Dmg^Dkg><
if>4if=kgUYkgUYckf^4kg><mg^DohBDohBLohbUohBLohbUmg^Dmg>Dif^<
kmkNkooooooooooooom3oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH00_ooo`06e/k>Q7]kg^OWc]KF_KFeLe9J0_NmeP05
mjG>okGFokGNokGNolKW00;oc^l00oo6ioneg_nmeP03ojg>00Go[LKg_MKg
_MKg_MKo]MH00_negP;o]MH02?nUa_nL_OND[Nn<W>n4U?McU>mcS>mkS0;o
Q9@3og^D00GgLhc_Lhc_JhCWFW?NHg<00]iJL`03if=kkg><mg><00;oS:D2
of^<00?Nc]KgmoOgmoL0oooooooooom2oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`09e/k>S8b<ooookno_e[g6
Ne9JolKWokgFojg>00;o[LH01?N]a_nee_neg_negP;oa^L00ooFkoo>koo>
k`02mlKW00Co]MKo[Lko[LKg[LH2ojg60_n]cP;oYLH01onL_OnD]OnD]On<
YOn4W?McU>M[N`02kf^400?WNhCgNhcoNi@00omkU003mf^4mg><kf=k00?N
FW<01NmcS?McU?mkU?n4W?NmeP02kooooooooooooom2oooo00EVIVKooon8
`;R8`;Q8T8P00@00000000j8`;S8h=R8`;R8`;QVIVKoooogmoOFc/j<NhCg
moOgknoWinMJHe[oc_L3olKW00Coa]ko]MKg_Lko]MH2mkgF0_negP0>olKW
olk_omK_olkgolk_olKWokGNokgFojg>ojG6mibmmjFeoibmmjFe0onL_@07
oiBeoiB]ohbUohBLmg^Dkg^<if>400;WHg/00nM[NnmSNnmcS002mg><00W_
LhcgLhc_JhC_JhCgLhcoNiCgQ:GgNiCo_MH0oooooooooom4oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`08c/k>
Q7]kimkNg/kFe/K>@T92olk_mkgN0_o6i`;oc^l01Oo6ioo>koo6ioo6g_Nm
gP02mkgF0_NmgP?oa^L02?o>koo6ioo6g_o6e_n]c_n]a_N]_OnL_@;gU:d0
1?NDYOND[On<[OND[@?oS:D02On4W?MkU>mcS>m[Q>MSNmiJLmiSLnMSNnm[
Q003mg><0_n4W005mhbUmg^Dokg>ooookooo0?oooooooooo@_ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool01mKF
eXb<S?O_knONg]kFeT8i>Oo6i`04mkgN00Ooa^Ooc^ooe^oog_Ooc_Ooe^oo
c^l00_o6i`;g_Mh00oNmioNmg_NmgP04okGN00[o_MKo[Lko[LKoW;ggYKGo
S:ggS:G_S9c_Q9CgNi@5ohBL0_mkU00<mg><kg><if]kgV=ccV=cgV=cif]k
kg><ohbUmhBUmg^DokgFoooooooooom4oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`0;c/k>S8b<oooomno_imkW
BSU2olkgolKWolkNmkgNmkgF00?g_Mh00oo6iooFkooNm`02omkg00Ooe^oo
c_Ooe^oge^oga^Og_Mk__MH00_NmeP;o_MH02_nee_n]c_n]c_n]c_n]a_NU
]OnD[ON<YON4U>n4U0;_Lh`04^McS>mkS?MkU?N4U?n4W?N4U?McU>mcS>m[
Q>MSQ=i[Nnm[Q?n<YON<YOMkU?nme_ooonooo`goool00`000?ooooooo`04
oooo00<0003oooooool0ooooooooool[oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`07c/k>S8b<moOgmno_inOW
BTY:omkg00;oc_L01OoNmoo6ioo>koo6ioo>gP03mlKW00Goa^Ooe^ooc_Oo
c_Oog_L00oo>m`;oa^L00oNmg^n]c^n]cP02mjg600?gW;goW;gg[Kd00_nL
_@0>mjFeoiBeoiB]khbLkhBDig^<if>4ig^4if>4ig^4kg><khBDohBLmhBD
0_MkU005mhBDohb]mhbUohbUokg>00ooool00`000?ooooooo`04oooo00<0
003oooooool0ooooooooool[oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00j8`;S8h=R8`;R8`;QVIVK_ooooooo>c/ikNg__knoNg]kFe]I2@T;ga^L2
omK_00Ooc_Ooe^ooe^oog_Ooc_Oog_Ooc_L00_oFk`?ge^l04OoFkooNmooF
kooFkoo>mooFkoo>koo6ioo6g_n]c_N]a^nU_NnL]OND[ONL[ONDYOn<Y@03
oiB]0_n<Y@05ohBLmg^Dkg^<if>4ig^400;NJg/02>MkQ>McS?MkU?n4W?n<
YNmkYOn<YONeaPOoool00`000?ooooooo`03oooo00@0003oool0003oool2
00000oooo`040000oooo000000000oooo`040000oooooooooooo0`000?oo
oooooooo8?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV00;oool01lkFeXb<S?ooonOWimkFeUYJF_NmcP02olKW00Gga^Og
e^Ooc^ooe^ooc_L02?oNm`;oa^L03_O6ioOFioo6iooFkoo6ioo>koo6ione
g_nmc_n]a_N]_OnD]ONDYNn<W0;WS9@00nn<W?n4W>n<W003khbL00GoQ9Cg
Q9C_NhcWLhcWNh@00]i[N`05ig><ohbUmiB]ohbUmjfm00Ooool00`000?oo
ooooo`03oooo00@0003oool000000002oooo00<0003oooooool00P0000;o
ool010000?ooooooo`0000;oool01@000?ooooooooooo`00003ooooooooo
oaooool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP02oooo00O>c/j<S8coooogmoOWinMcHf___MH00_oFk`05olKWomK_mlKW
mlKWmmK_00;oe^l7omkg00?oe^ooa^Og_Mh00_NmeP05mkgNmkgFokGFokGF
okgF00;o[Lh02?n]a_nL_ONU]OnD[On<YNn<W>N<U>MkS0;_Q9@01?n4W?N4
U>n<W?n4W0;gQ9@2kg^<00GgQ9CoS:ggU:goS:g_YKd02?ooo`050000oooo
oooooooo000000;oool01@000?ooooooooooo`000002oooo00D0003ooooo
ooooool000000_ooo`040000oooooooo0000oooooooooolSoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`07c/k>
Q8B4kno_inOWg]kNS9B<_Ibe00Oog_L01OOWkooFkoOFkoOFkooFk`07omkg
00Ooc_Ooa^Og_Mkg_MKg_Lkg]LKg[LH00_N]_@03ojg6mjfmmjfm00;gYKD0
1_NL[ONDYONDYNn4U>MkS=ikS0?WNh`02Nn4U?N4U>n4U>n<W>nDW?nD[On<
YNnL[OnD]@08oooo1@0000;oool01@000?ooooooooooo`000002oooo00D0
003oooooooooool000000_ooo`030000oooooooo00D0003ooooooooooaoo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02
oooo00OFe]J<S8c_knoNg]k6a/J<NhBLU9`00ooFk`_og_L00ooFkooNmooF
k`04omK_0_o>k`04olKNokgFojg>ojg60_NU]@CgW:d4oiB]00GoS:GoQ9c_
Q9C_NhcWNh@00]ikQ009ig^4kg^<mhBDoiBeohbUkib]oiB]oooomoOg00Ko
ool01@000?ooooooooooo`000002oooo00D0003oooooooooool000000_oo
o`050000oooooooooooo000000;oool010000?ooooooo`0000?oool00`00
0?ooooooo`3ooooooooooagoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP02oooo00O>c/j<S8coooo_knoFe]JUYJFDLg/0
0_oNm`03omK_olkgomK_00_og_L00ooFkoOFkoo6i`02olKW00Koc^ooa^Oo
a^Ooa]koa]Ko_MH2ojg600CgYKGoU:ggU:G_U:D2khbL00C_U:GgS:GoS:Gg
U:D2ohbU00[_U9c_Q9C_NhcWNhcNNhcWNhcoU;GoS:G_W:goU;D9oooo00<0
003oool000000oooo`800002oooo00<0003oooooool00P0000;oool01000
0?ooooooo`0000;oool01@000?ooooooooooo`00003ooooooooooaooool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo
00O>c/j4Q8CoooogmoO_kno6c/ikHg<00_oNm`05mnO_omkgmnO_omK_mnO_
00Gog_L00oOgmooNmoOgm`03omkg0_oFk`03olKWolKNmkgF00;o_MH01?o6
e_nme_nme_n]cP;o[LH01?NU]OnD[NnDW>n<W0?WS9@01^n4U>n<W>n<W>n<
W?n<YNnDW0;_S9`00oN4U?NU]On<Y@02miB]00?gknooooooool01_ooo`03
0000oooo000000?oool010000?ooo`00000000?oool010000?ooo`000000
00?oool010000?ooooooooooo`<0003oooooooooob3oool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00S>c/j4Q8Cg
moOWinOFe]K>a/ISDU[ooolComkg00Ooe^oge^Ooa^Ooa]Kg_LkgYLkg]LH0
1ON]_@;gYKD04_nD[ONDYONDYNn<W>N<U=ikQ=ikS>MkS=ikU>n<W>n4U>n<
W?N<YONU]OnD[ONL[On<YOOWi`Soool00`000?ooo`00000Aoooo00<0003o
ooooool0oooooooooolToooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH00_ooo`09c/k>Q8B4moOginOWc/k>_LJmDT92omkg
moOg00Gog_L01?oooooNmooWooOgm`[og_L02?o>mooFkoo6ioo>g_o6e_n]
a_N]a_N]_@;gYKD4mib]0_nD[@04ohbUmiBUmhbUkhbL0^N<U0?NNh`01^N<
U?NU]On<YOND[On<[NoNgPWoool00`000?ooooooo`0@oooo00<0003ooooo
ool0oooooooooolToooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH00_ooo`07c/k>S8b<ooooooooinOWe]KFBSU200Sog_L0
2_oooooNmooWoooNmooWoooooooNmooWoooNmoOWk`?oe^l03_OFioo6iooF
koo6ioo>g_o6g_nme_n]a_N]_ONU]ONL[ONDYNnDYNnDW0;_U:D00oN<YOND
YONDY@02miBU00?_U9c_S9cWS9@00^N<U005mjfmmiB]mib]ohbUmmkN0?oo
oooooooo@oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV00;oool02=KFeXb<S?ooooooono_knOWieY2B_ooo`Kog_L02_Og
mooNmoooooooooOgmooooooNmooooooNmoooo`;og_L2omK_00Koa^Ooc]kg
_MKg_MKo_MKoa]H3okg>00Oo[LKg[Kgg[KgoU:ggW:ggU:G_U9`00nN<U005
ihbLkhbLmiBUmiBUkiBU00;gU:D01ONU]OnD[ONL[On<YNoNgP3ooooooooo
od?oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP02oooo00S>c/j<S8c_knoWinONg]kFe]IJBU;Wg^L2oooo00?og_Oooooo
ool01ooNm`03onOoomkgomkg00Gog_L01OOWkooFkoo6ioo>g_NmcP02mkG6
0_N]_@03ojg6mjfmmjfm00;gYKD2mib]00K_W:G_U9cWS9cWS9CNQ8cNNi@2
ihbD0^n<W007mjfmmib]mib]mib]ojg>ooookooo0?oooooooooo@Oooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool0
2lk>cXb<S?ooono_kmkNg/K6aW=SJmK>c_oNmoOWkoOgm`02omkg00Kooooo
ioogmoOooooog_Ooiol3omkg00Koiooog_Oog_Oog_Oginoog_L3omK_0_o6
i`04olKFokg>ojg6mjfm0oNU]@04mib]kib]mib]miBU0_NL[@06oiB]kibU
kiBLihbLihbDgW^D0]j4S005mjfmmib]kjfemib]ojg60?oooooooooo@ooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;o
ool05/k>cXb<S?ooooooooOgmmkNgYB<S9bDW?oooooNmoooonoWkooooooN
moOgmooWoooNmooWooOgmooWooOgmooWo`Cog_L2omK_00?ge^Oga^Ooc]h0
0_o>gP05olKNolKFokgFojg6mjfm00;gYKD01NnLYNNLYNnDYNnDYNnLY@06
miBU00S_U9cWS9cWS9cgW;ggW:ggYKG_[KGo[LKooooooooood?oool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00S>
c/j<S8coooooooogmoO_knn][JfLU9`3oooo0_oNm`0DmoOgomkgmoOgomkg
ooooomkgooooomkgooooomkgonOoomkgmoOgomkgomK_onOWolKWolkNolKF
mkgF0onmcP03mkg6okg>ojg600;g[Kd01OnD[ONL[NnLYNn<W>N<U003ihbL
00G_U9c_W:G_U:G_U:GgU:D00oNU]@03mib]ojg6oooo0?oooooooooo@_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;o
ool02<k>cXb<S?Ogmno_kmkNg]KFe]kFeUY:DP;oool04OoNmooooooooooN
mooooooWoooooooNmooooooNmoOgmooNmooooooNmooWoooNmoOgm`03omkg
00Kge^Ooc]koa]Kg_Lkg]LKo[LH2mjfm0_NU]@;g[Kd2mjFe00K_YJG_W:G_
W:GWS9cWS9CNNi@3ihbD00OWS9cgYKGgYKGgYKGgW:gg[KggmoL0oooooooo
oom2oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH00_ooo`09c/k>S8b<oooomoOginOWe]KFe/k>:B4QimkW00?oool00oO_
kooWooooo`04oooo00Cog_Oooooog_Ooool2moOg0ooNm`Coe^l01OOFioo>
g_o6e_Nma_n]aP03mjFe00C_W:ggW:ggW:ggYKD2mib]00WoU:ggU:G_U:G_
W:G_U9cWS9CNNiCWS9Cg[Kd00_NU]@03mib]kjFmmno_0?oooooooooo@_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;o
ool00lk>cXb<S?ooo`02oooo00O_knoNg]jm]KE2>CWFc/kooooog_L02_oo
o`05onOoomkgomkgomkgmno_00;oe^l2mmKW00_oa^Ooc]koa^Ooc]koa]Ko
a/ko_Lkg_LKg[KggYKG_YJD00^NLY@G_W:D2mib]00?gU:G_W:G_W:D01ONU
]@03knO_oooooooo0?oooooooooo@?ooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00;oool00lk>cXb<S?ooo`02oooo00Wg
moOgknoWinO>a/ISDUY2@T9cHf^DU9Cginl01Oooo`03onOooooooooo00?o
ool02OoWoooNmooNmooNmooFkoo>g_o>e_Nme_O6cP04okg>0oN]_@;gYKD0
1?NL[NnLYNN<W>N<W0;WS9@2ihbL0^nLY@03mib]mjfmmjFe00;gYKD00nnU
]NOWioooo`3ooooooooood7oool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP02oooo00O>c/jDU9CgmoO_knoWinONg]kWinL0
0]kNgP;WinL01lk>cYbLW6][JeY:DW=JHibDW>oNgP02oooo00SgmoOooooo
g_OoooooioogmoOog_OgmoL2omkg00Goe^oog_Ooa^Og_MKg_Lh00_NmaP03
kjfemjfmmjfm00Cg[Kd2mjFe00?_W:ggW:gWW:D01NN<U0;gYKD01?Nma^nU
_OnL_Oo>e_oooooooooo@_ooo`05IVIVooooR<2hR<2hB928004000000009
R<2hb>3HR<2hR<2hIVIVoooomoOgkno_Lg=c00;oool01oOgmnOWilk>c/k>
c/K6a/k>c]KFeP03g]kN00SWg]kNc]Je[JecLg=:BTYSDUZLS9CFa/h2oooo
00?gmoOog_Oog_L00_oNm`0:onOoomkgomK_onOWomK_olkNolK>ojg6olK>
mjFe1_NL[@07kjFUmib]mib]mib]miBUkjFUkiBL00;WS9`01_NU]ON]_ONU
]Nn]]ONU]Oo6c_oooooooooo@_ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00?oool00e9:D_ooooooo`02oooo00?_knoW
inONg]h01<k>cP0Aa/K6e]KFe]KFg]KFg]kNinOWg]KF[JFUNg]kFTYBHe9J
S7^4a/K6omkgoooommK_imkW00Goe^l01Oo6ioo>g_nme_nmc_NmaP02mjfm
00CgYKG_YJGWW:GWW:D3kibU00__W:g_YJGgU:G_YJGgU:GgYKGg[Kgg_LK_
[KGoW;goa/h0oooooooooom2oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH00oooo`03[Jf]Ng]koooo00?oool01OOgmno_
knOWinOWimkNgP02e]KF00K>c/k6c/k6a/K6a/K6c/k>e]H2g]kN013WinOW
g^Nm_Kf4LhAJ@U9J@TZ4LhBmW;Gge^Ooe^oge^Og_Mkg_Lko_MKoa]ko]Mh2
okgF01Go_Lko[LKg[Kg_[KGgW:g_[KG_YJGWS9cWW:GWS9cNU:GWS9c_YJG_
W:GgYKGg]LKgYKG_YKgg[Kgg_LKgmoL0oooooooooom1oooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01?ooo`04Lg=c_KFe
moOgkno_0]kNgP;WinL05>o_koOgmno_knOWimkWimkNg]KNg/kFe/K>c/K6
a[g6a/K>c/K6a/k6c]K>c]kNg^OWinONikfm_IBDU09SBU801g=JHkFLW>nm
e_oWioNmg_Nmc^n]cP02mjg600Wg]LKo[LKg_LKg_LKgYKGg[KggW:g_W:G_
YJD00^NLY@09gYBUihbDmjFemjg6mjfmmkG6oibmmkg6omkg0?oooooooooo
@Oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Coool01nOWie9:D_ooooooono_kmkNg]KFeP02c/k>00?Fe]KNg]kWinL0
0no_k`;WinL00mkWimKNg]KFeP05c/k>00cFc/kFe]KWg]kWinOWg^ONc]JL
U9acFV=J>D9[BUZ<Jg?_[KD2mkg600Kg[KggYKGgW:ggYKGg[KggYKD2mjfm
00WgYKGgW:ggW:g_W:GWW:Gg[Kgg]LKg[Kgg[LH00_N]_@03mnO_oooooooo
0?oooooooooo?oooo`05IVIVooooR<2hR<2hB928004000000006R<2hb>3H
R<2hR<2hIVIVoooo0_Ogm`;oool00dY:B_ooooooo`02oooo00?gmoOWinON
g]h00mKFeP05c/k>e]KFg]kNg]kNinOW00;_knl00nOWimkWimkNgP02e]kN
00GFe]K>e/k>c/k>c/kFc/h00]KFeP06g]KFimkWinOWe/k>_KFeLeYS0W=:
DP0:U6]caYBLijfekjFmijfegYBUkib]mjFekjfekib]0oNU]@04mjfmkjg6
mjfmmkG60_N]_@03mnOWoooooooo0?oooooooooo?oooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00?oool01OOgmoooof=S
Hno_koOgm`05oooo00KgmoO_knoWinOWg]kNg]kFe]H2c/k>00GFc/kNe]KN
g]kWinOWknl01>o_k`;WinL00mKNg/kFe/K>cP03c]K>00OFc/kFe]KNinON
inONg]jm_Kf4Ng/00UY2BP04Q6=[cXB<kib]kjFe0^nL[@0:kibUiibUkib]
mkG6kjFmmkg6mjfmoibmmjfmkmkNoooooooooom1oooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00oooo`06moOgooooW9bL
YJfUoooomoOg0no_k`04moOgoooooooooooo0_Ogm`05kno_inOWg]kNg]kN
e]KF00?>c/h2g]kN00?gmoOoooogmoL00oOgm`04kno_inOWg]kNe]KF1<k>
cP03c]KFc/k>g]kN00;Ng]h02[fm_IB<S5Y2BUY2@W]BFZEcLmJLYNn]]NNL
YNnU_@;o[LH01?NL_On]a_NL_Oo>g_oooooooooo@Oooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Goool01>OWie9:D^o_
koOgm`;oool01No_knONg^OWino_knOWi`02moOg0_ooo`;gmoL2kno_00ON
g]kWinOFe]JDU9ASHf><S8cFe]H01Oooo`06moOgkno_kno_kno_g^OWe/k>
0lk>cP04a/K6c/k>e]KFc]KF0^OWi`0<e[g6W8bDLe9JHcTiJd9:W6]caYbU
kjg6mjg6mkg>kjg>mkg>oooooooooom1oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01_ooo`05e]KFDTYBYJFUc/k>moOg
00;oool01>ooooO_knOWinO_k`?WinL04>o_koOgmoOgmoOgmoooooOgmno_
koOgmoooomkNgYbLW8B4Q6=SHhB4Q;fm_No_k`;oool2moOg00GgknoWknoW
inONg]kFe]H00/k>cP06c/K6_LK6_LK6_LK6c/k>e]KF0mkFeP07]IbLW8B<
Le9JJd9:S6=[aYbUonOW0?oooooooooo@Oooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00?oool00oOgmoooooOgm`02oooo
00O_knnm_Kf<S8acLg><S8bm]KGWinL00_ooo`;gmoL2inOW0]kNgP;WinL3
moOg0_ooo`0:moOgooooooookno__KfmQ8B4Hf=SNg]k_KFee]kN0_Ogm`0@
oooomoOgmoOgmoOgkno_e]KFe]KNc/k>a/k>_LK6_Kfm_LK6c]K>_LK6e]KF
moOg0_ooo`03mno_knO_oooo0?oooooooooo@Oooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00;oool00oOgmoooooOgm`04
oooo00[gmoOoooooooooooo>c/jLW9akNg^4Q8BUYJGNg]h2oooo00KgmoOW
knoWinO_knoNg]k_knl:oooo00?_knnm_Kf<S8`00W=cL`04YJFUc/k>kno_
kno_0_Ogm`07imkWmoOgknO_g]kNe]KFa/k>_LK600;6c/h00noooooooooo
o`3oooooooooodCoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP06oooo00?gmoOoooooool01?ooo`06moOgoooooooooooo
g]kNYJFU0W]kN`06W9bLc/k>kno_moOgkno_moOg3_ooo`09moOge]KFW9bL
Lg=cJf][U9BD_KfminOWkmkN00;gknl01oOWknOWimkNg]KFg/kFe_ooonoo
o`02oooo00?_ooooooooool0oooooooooom0oooo00EVIVKooon8`;R8`;Q8
T8P00@00000000J8`;S8h=R8`;R8`;QVIVKgmoL3oooo00?gmoOoooooool0
3_ooo`05kno__KFeS8b<a/K6moOg01Coool01mkNgZFUYHAkNf=SHhAkNjf]
[MKFeP02kno_00?_inoWknogmoL01?ooo`03moOgoooooooo0?oooooooooo
?oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00?oool00oOgmoooooooo`0/oooo00K_oonma[f4Q8ASHf=[Lf_6a/Kooooo
ooooodSoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP3ooooooooooh3oool01Lc<c?ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP3ooooooooooh3oool01FIVI_ooohS0^8S0^4R@R001
0000000018S0^<SPf8S0^8S0^?mVIVKoIVIVPVIVIP04c<c<R<2hR<2hB928
0@00000000>8`;S8h=R8`;P0ohS0^?n8`;R6R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h5P00P0<00H0200:000@00X400h400h400h4300B10P05P@03
00F200J200J200801X801007PP47PP47PP48PP8128<30@V30`4:P`030@^3
0@^40@^400@138@30@f40`4>Q@<23hD30Q250`8AQP@24XH20Q>600@24hL2
58L258L258L30QF70P8FQ`040aJ80aN80aN80aN810<HR0030aV80aV90aV9
00<36XT30a^90`<LRP<37HX311j:10@OR`<488/2126;00@48H`48X`48X`4
8X`312><0P@TS00312B=12F=12F=00859Hd31BJ=00<59hd59hh59hh00`DX
SP<5:Hh00`DZSPDZS`DZS`041B^?0`D/S`<6;I031Rj@0`H_T0<6<9441S6A
0PHbT@051S:B1S>B1S>B1S>B1SBB0087=9800`LeTPLeT`LeT`031cJC10Lg
T`<7>9@31cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G
246G246G0`Q2U`88@iL00`U3V0U4V0U4V0022DBH0`U5V0032DJH2DJI2DJI
00<9AiT32DRI00<9BIT9BIX9BIX010U:VP<:BiX32TbK0`Y=V`8:CY/010Y>
W0Y?W0Y?W0Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;
E9h00`]EWP@;EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<G:0435fQ0`aNX@8<
Gj4010aOXPaPXPaPXPaPXP8<HJ8010eQXPeRXPeRXPeRX`@=Hj<33FBS00<=
IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU10iYY@8>JZD010iZYPi[YPi[YPi[YP<>
K:H23VfV00@>KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?L:P00`maZ0<?LZP0
0`mcZ0mcZ@mcZ@033gBY10meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`@@
O:`347f/0Q1n[00447j]47n]47n]4Gn]0a60[@034H6]4H6^4H6^00@APZh3
4H>^0a64[`<AQJl34HJ_0a:7/0@BR;024XV`00@BRK4BR[4BR[4BR[434X^a
0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`034i2c0a>A
/`034i:c4i:d4i:d00<CTk@44iBd0a>E]@<DU[D359Ne0aBH]P<DVKH259Zf
00<DV[LDVkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO^0035J2h
5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`F
ZK`FZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn
00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0@008000i^WlC=3YC=3Y@09<d>U1P00P0<00H02
00:000@00X400h400h400h4300B10P05P@0300F200J200J200801X801007
PP47PP47PP48PP8128<30@V30`4:P`030@^30@^40@^400@138@30@f40`4>
Q@<23hD30Q250`8AQP@24XH20Q>600@24hL258L258L258L30QF70P8FQ`04
0aJ80aN80aN80aN810<HR0030aV80aV90aV900<36XT30a^90`<LRP<37HX3
11j:10@OR`<488/2126;00@48H`48X`48X`48X`312><0P@TS00312B=12F=
12F=00859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`04
1B^?0`D/S`<6;I031Rj@0`H_T0<6<9441S6A0PHbT@051S:B1S>B1S>B1S>B
1SBB0087=9800`LeTPLeT`LeT`031cJC10LgT`<7>9@31cVD0`LjU0<7>iD3
23bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL00`U3
V0U4V0U4V0022DBH0`U5V0032DJH2DJI2DJI00<9AiT32DRI00<9BIT9BIX9
BIX010U:VP<:BiX32TbK0`Y=V`8:CY/010Y>W0Y?W0Y?W0Y?W0@:D9`010YA
W0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP@;EYh32eNO0`]H
W`<;FIl335ZP0`aKX0<<G:0435fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<
HJ8010eQXPeRXPeRXPeRX`@=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@3
3FRU10iYY@8>JZD010iZYPi[YPi[YPi[YP<>K:H23VfV00@>KJL>KZL>KZL>
KZL43VnW00<>L:L?L:P?L:P00`maZ0<?LZP00`mcZ0mcZ@mcZ@033gBY10me
Z@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`@@O:`347f/0Q1n[00447j]47n]
47n]4Gn]0a60[@034H6]4H6^4H6^00@APZh34H>^0a64[`<AQJl34HJ_0a:7
/0@BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb
0Q:>/P8CS[800a>?/Q>?/a>?/`034i2c0a>A/`034i:c4i:d4i:d00<CTk@4
4iBd0a>E]@<DU[D359Ne0aBH]P<DVKH259Zf00<DV[LDVkLDVkL00QBK]`<D
W;L00aBM]aFM^1FM^0035Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS
^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`FZK`FZK`35ZZl0QJ[_004
5Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG
/Kl00aNb_`<G/klf6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<0
08001i^WlOooohij]ZJKa;>YdZRMb;>YdP02YY_400Fl^=g^k_CZjO7ooolc
@jD01@00P0<00H0200:000@00X400h400h400h4300B10P05P@0300F200J2
00J200801X801007PP47PP47PP48PP8128<30@V30`4:P`030@^30@^40@^4
00@138@30@f40`4>Q@<23hD30Q250`8AQP@24XH20Q>600@24hL258L258L2
58L30QF70P8FQ`040aJ80aN80aN80aN810<HR0030aV80aV90aV900<36XT3
0a^90`<LRP<37HX311j:10@OR`<488/2126;00@48H`48X`48X`48X`312><
0P@TS00312B=12F=12F=00859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh0
0`DZSPDZS`DZS`041B^?0`D/S`<6;I031Rj@0`H_T0<6<9441S6A0PHbT@05
1S:B1S>B1S>B1S>B1SBB0087=9800`LeTPLeT`LeT`031cJC10LgT`<7>9@3
1cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G
0`Q2U`88@iL00`U3V0U4V0U4V0022DBH0`U5V0032DJH2DJI2DJI00<9AiT3
2DRI00<9BIT9BIX9BIX010U:VP<:BiX32TbK0`Y=V`8:CY/010Y>W0Y?W0Y?
W0Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]E
WP@;EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<G:0435fQ0`aNX@8<Gj4010aO
XPaPXPaPXPaPXP8<HJ8010eQXPeRXPeRXPeRX`@=Hj<33FBS00<=IJ<=IJ@=
IJ@00`eVY0<=Ij@33FRU10iYY@8>JZD010iZYPi[YPi[YPi[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?L:P00`maZ0<?LZP00`mcZ0mc
Z@mcZ@033gBY10meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`@@O:`347f/
0Q1n[00447j]47n]47n]4Gn]0a60[@034H6]4H6^4H6^00@APZh34H>^0a64
[`<AQJl34HJ_0a:7/0@BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@04
4Xbb4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`034i2c0a>A/`034i:c
4i:d4i:d00<CTk@44iBd0a>E]@<DU[D359Ne0aBH]P<DVKH259Zf00<DV[LD
VkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO^0035J2h5J2i5J2i
00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`FZK`F
ZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C08000008H]<0@00000QRd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000BKYo7ooom/FZF_YLX2
_;SM00[ooOncZM;ooooooonl^=fGR[bXWLSVi^cooolc@jD400200`01P080
0X001002P@03P@03P@03P@<0184200F100<01H801X801X800P06PP0400N2
0@N20@N20@R20P48P`<12H<30@Z300<12h<12h@12h@0104<Q0<13H@30@j5
0`8?Q@<248D30Q66108BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP40aR800<36HP36HT36HT00`<JR@<36hT30ab:0`<MRP<4
7XX411n;0`@PR`848H/010@QS0@RS0@RS0@RS0<48h`212B<00<498d49Hd4
9Hd00PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00@5
:hl31Bb?0`H]T0<6;Y031Rn@0`H`T@@6<I421S:A00D6<Y86<i86<i86<i86
=9800PLdTP031cFB1cFC1cFC00<7=Y<41cNC0`LhU0<7>I@31cZD0`LkU@<8
?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`032D>H
2DBH2DBH0089A9P32DFH00<9AYP9AYT9AYT00`U7V@<9B9T00`U9V@U9VPU9
VP042DZJ0`Y;VP<:C9/32TfK0PY>V`042TjL2TnL2TnL2TnL10Y@W0042U6L
2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN10]FWP<;Eil32eRO
0`]IW`<<FZ0335^P0`aLX0@<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP043F6R3F:R3F:R3F:S10eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=
J:D43VVU0PiZY@043VZV3V^V3V^V3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`@>KjL00`i`Y`m`Z0m`Z0033g6X0`mbZ0033g>X3g>Y3g>Y00<?M:T43gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[111l[0<@OJ`247j/00@@OZd@Ojd@
OjdAOjd34H2]00<APJdAPJhAPJh01162[P<APjh34HB_0a65[`<AQZl34XN`
11:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK82
4Xjb0Q>>/P034hnb4hnc4hnc00<CT;<34i6c00<CT[<CT[@CT[@00a>C]0@C
U;@34iFe0aBF]@<DUkD359Rf0aBI]P8DV[H00aBJ]aBK]aBK]`0259^g0aBL
]`0359fg5Ifh5Ifh00<EW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j
0aFT^P<FYKX35ZJk11JW^`8FZ;/011JX_1JY_1JY_1JY_0<FZ[`25Z^l00@F
ZkdF[;dF[;dG[;d45jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_`8H]<000lSPf4R@R4R@R00<B92800<00038h=Q8T8P03DR@
R00400006;C06;C0b>3H3TR@R00300006;C06;C000:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2002000^KYo7ooonXWLSoooncZM9PC9Z>N[IhIJjX
WLSooooooOl00oooo`03<d>U0020002000<0080300600P02P00400:100>1
00>100>10`04P@801H400`05PP06PP06PP0200J200@01h811h811h812882
0@R30`49P`<12X<00`4;P`4;Q04;Q0040@b40`4=Q0<13XD30Pn500@248Go
ooooooooool20Q66108BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP40aR800<36HP36HT36HT00`<JR@<36hT30ab:0`<MRP<4
7XX411n;0`@PR`848H/010@QS0@RS0@RS0@RS0<48h`212B<00<498d49Hd4
9Hd00PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00@5
:hl31Bb?0`H]T0<6;Y031Rn@0`H`T@@6<I421S:A00D6<Y86<i86<i86<i86
=9800PLdTP031cFB1cFC1cFC00<7=Y<41cNC0`LhU0<7>I@31cZD0`LkU@<8
?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`032D>H
2DBH2DBH0089A9P32DFH00<9AYP9AYT9AYT00`U7V@<9B9T00`U9V@U9VPU9
VP042DZJ0`Y;VP<:C9/32TfK0PY>V`042TjL2TnL2TnL2TnL10Y@W0042U6L
2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN10]FWP<;Eil32eRO
0`]IW`<<FZ0335^P0`aLX0@<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP043F6R3F:R3F:R3F:S10eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=
J:D43VVU0PiZY@043VZV3V^V3V^V3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`@>KjL00`i`Y`m`Z0m`Z0033g6X0`mbZ0033g>X3g>Y3g>Y00<?M:T43gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[111l[0<@OJ`247j/00@@OZd@Ojd@
OjdAOjd34H2]00<APJdAPJhAPJh01162[P<APjh34HB_0a65[`<AQZl34XN`
11:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK82
4Xjb0Q>>/P034hnb4hnc4hnc00<CT;<34i6c00<CT[<CT[@CT[@00a>C]0@C
U;@34iFe0aBF]@<DUkD359Rf0aBI]P8DV[H00aBJ]aBK]aBK]`0259^g0aBL
]`0359fg5Ifh5Ifh00<EW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j
0aFT^P<FYKX35ZJk11JW^`8FZ;/011JX_1JY_1JY_1JY_0<FZ[`25Z^l00@F
ZkdF[;dF[;dG[;d45jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P03HS0
^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2002000jKYo7ooooooooKg>aPC9ZCQKZc
ZM:l^=ePC9ZISkjVVlC8`moooolc@jD600200oooo`800X000`02POoooooo
o`02oooo0P04P@0300F1oooo00F200<01X84oooo00<1288128?oool00ooo
o`<12X<01Oooo`4;Q04;Q04<Q?ooo`020@b400@13HCoool13HCoool20@j5
00@23hGoool23hGoool20Q2500<24HKoool24HH0108BQP824hH0108CQ`8D
Q`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP40aR800<36HP36HT36HT0
0`<JR@<36hT30ab:0`<MRP<47XX411n;0`@PR`848H/010@QS0@RS0@RS0@R
S0<48h`212B<00<498d49Hd49Hd00PDUS@<59Xd00`DWS@DWSPDWSP031BR>
0`DYSP031BZ>1BZ?1BZ?00@5:hl31Bb?0`H]T0<6;Y031Rn@0`H`T@@6<I42
1S:A00D6<Y86<i86<i86<i86=9800PLdTP031cFB1cFC1cFC00<7=Y<41cNC
0`LhU0<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`032D>H2DBH2DBH0089A9P32DFH00<9AYP9AYT9AYT0
0`U7V@<9B9T00`U9V@U9VPU9VP042DZJ0`Y;VP<:C9/32TfK0PY>V`042TjL
2TnL2TnL2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN10]FWP<;Eil32eRO0`]IW`<<FZ0335^P0`aLX0@<GJ4335jQ0PaO
X@0435nR362R362R362R0PaQXP043F6R3F:R3F:R3F:S10eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D43VVU0PiZY@043VZV3V^V3V^V3V^V0`i/
YP8>KJH010i]Y`i^Y`i^Y`i^Y`@>KjL00`i`Y`m`Z0m`Z0033g6X0`mbZ003
3g>X3g>Y3g>Y00<?M:T43gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[111l
[0<@OJ`247j/00@@OZd@Ojd@OjdAOjd34H2]00<APJdAPJhAPJh01162[P<A
Pjh34HB_0a65[`<AQZl34XN`11:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb0Q>>/P034hnb4hnc4hnc00<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0@CU;@34iFe0aBF]@<DUkD359Rf0aBI]P8DV[H0
0aBJ]aBK]aBK]`0259^g0aBL]`0359fg5Ifh5Ifh00<EW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk11JW^`8FZ;/011JX_1JY
_1JY_1JY_0<FZ[`25Z^l00@FZkdF[;dF[;dG[;d45jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<001<SPf8S0^8S0^8S0
^0H00004R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H
]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0<008003Y^WlOoookbhgIV?__ooomKAgM_Lk??nojJKa>k^m8Ef
/9>5^_oooc=3Y@@008001oooo`01P001P001P?ooo`02P?ooo`0300>100Ko
ool0184018401H7oool01H8200J200Soool01X801h811h;oool128;oool1
28<30@V300Coool12X<12X?oool20@^400P138Coool138@138@13HCoool1
3HCoool20@j500<23hGoool23hD01?ooo`824HH40Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0@368P00`<IR0<IR@<IR@03
0aZ90`<KR@<378X30af:0`@NRP@47h/3122;0P@QR`04126<12:<12:<12:<
0`@SS08498`00`@TS@@US@@US@021BF=0`DVS@031BN=1BN>1BN>00<5:8h3
1BV>00<5:Xh5:Xl5:Xl010D[S`<5;8l31Rf@0`H^T0<6;i031S2A10HaT@86
<Y401@HbTPHcTPHcTPHcTPHdTP021cBB00<7=I87=I<7=I<00`LfT`@7=i<3
1cRD0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00<9@iP9A9P9A9P00PU4V0<9AIP00`U6V0U6V@U6V@03
2DNI0`U8V@032DVI2DVJ2DVJ00@9BYX32T^J0`Y<V`<:CI/22TjK00@:CY`:
Ci`:Ci`:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN
00<;EIh42eJN0`]GW`<;F9l32eVO0`aJX0<<Fj0335bP10aMX@<<GZ4235nQ
00@<Gj8<H:8<H:8<H:82366R00@=HJ8=HZ8=HZ8=HZ<43F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@@>JJD23VZU00@>JZH>JjH>JjH>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW10i_Y`033W2W3g2X3g2X00<?LJP33g:X00<?
LjP?LjT?LjT00`mdZ@@?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/447b/
0a1m[08@OZ`0111n[A1o[A1o[A5o[@<AP:d00a61[A61[Q61[P044H:^0a63
[P<AQ:l34HF_0a66[`<BQk044XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[824hjb00<CSk8CSk<CSk<00a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d11>D]0<CUKD359Je0aBG]@<DV;H359Vf0QBJ]P03
59Zg59^g59^g008DVkL359bg00<DWKLEWKPEWKP00aFN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl
5ZVl5ZVl0aJZ_08FZk`011J[_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P03
5jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`004b>3HR<2hR<2hR<2h
1P0000B8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000
R<2hR<2hB9280000008H]<001<SPf8S0^8S0^8S0^0800004R<2h0P0000:8
`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3
002000nKYo7ooonISkjGR[cDdnS_[;?oMW_^Wj]KF:FVVlBFWm9PC9Zl^=go
oolc@jD00`00P007oooo006000600060oooo00:0oooo00<00h401_ooo`04
P@04POooo`05POooo`801X802?ooo`06PP07PP47P_ooo`48P_ooo`48P`<1
2H<03_ooo`4:Poooo`4;Poooo`4;Q?ooo`4<Q?ooo`4<Q04=Q?ooo`4=Q?oo
o`813XD0108?QOooo`8?QOooo`8248D30Q66108BQP824hH0108CQ`8DQ`8D
Q`8DQ`<25HL20QJ700@35XP35hP35hP35hP40aR800<36HP36HT36HT00`<J
R@<36hT30ab:0`<MRP<47XX411n;0`@PR`848H/010@QS0@RS0@RS0@RS0<4
8h`212B<00<498d49Hd49Hd00PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DY
SP031BZ>1BZ?1BZ?00@5:hl31Bb?0`H]T0<6;Y031Rn@0`H`T@@6<I421S:A
00D6<Y86<i86<i86<i86=9800PLdTP031cFB1cFC1cFC00<7=Y<41cNC0`Lh
U0<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8
@IL324:G0PQ3U`032D>H2DBH2DBH0089A9P32DFH00<9AYP9AYT9AYT00`U7
V@<9B9T00`U9V@U9VPU9VP042DZJ0`Y;VP<:C9/32TfK0PY>V`042TjL2TnL
2TnL2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP03
2eFN10]FWP<;Eil32eRO0`]IW`<<FZ0335^P0`aLX0@<GJ4335jQ0PaOX@04
35nR362R362R362R0PaQXP043F6R3F:R3F:R3F:S10eSX`<=I:<00`eUX`eU
Y0eUY0033FJT0`eWY0<=J:D43VVU0PiZY@043VZV3V^V3V^V3V^V0`i/YP8>
KJH010i]Y`i^Y`i^Y`i^Y`@>KjL00`i`Y`m`Z0m`Z0033g6X0`mbZ0033g>X
3g>Y3g>Y00<?M:T43gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[111l[0<@
OJ`247j/00@@OZd@Ojd@OjdAOjd34H2]00<APJdAPJhAPJh01162[P<APjh3
4HB_0a65[`<AQZl34XN`11:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba
00@BS;8BSK8BSK8BSK824Xjb0Q>>/P034hnb4hnc4hnc00<CT;<34i6c00<C
T[<CT[@CT[@00a>C]0@CU;@34iFe0aBF]@<DUkD359Rf0aBI]P8DV[H00aBJ
]aBK]aBK]`0259^g0aBL]`0359fg5Ifh5Ifh00<EW[P35Inh00<EX;PEX;TE
X;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk11JW^`8FZ;/011JX_1JY_1JY
_1JY_0<FZ[`25Z^l00@FZkdF[;dF[;dG[;d45jfm00<G[[dG[[hG[[h00aN_
_P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h
00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@
R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h0P0000>8`;P014R@
R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000ZK
Yo7ooonGR[ajK:ZcanRYKZ38`mnCQKYKAY>ISkh2N6F^00A29hF_YL[ooolc
@jD400200`01P003oooo00:000:100Coool200B100?oool01H7oool00`06
PPCoool00`48PP48P`48P`030@V300koool12X?oool12h?oool12hCoool1
38Coool138@13HCoool13HCoool20@j500<23hGoool23hD01?ooo`824HH4
0Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0@3
68P00`<IR0<IR@<IR@030aZ90`<KR@<378X30af:0`@NRP@47h/3122;0P@Q
R`04126<12:<12:<12:<0`@SS08498`00`@TS@@US@@US@021BF=0`DVS@03
1BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl010D[S`<5;8l31Rf@0`H^
T0<6;i031S2A10HaT@86<Y401@HbTPHcTPHcTPHcTPHdTP021cBB00<7=I87
=I<7=I<00`LfT`@7=i<31cRD0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`Po
UP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00<9@iP9A9P9A9P00PU4V0<9
AIP00`U6V0U6V@U6V@032DNI0`U8V@032DVI2DVJ2DVJ00@9BYX32T^J0`Y<
V`<:CI/22TjK00@:CY`:Ci`:Ci`:Ci`42U2L00@:DI`:DId:DId:DYd22e:M
0`]CW@032eBM2eBN2eBN00<;EIh42eJN0`]GW`<;F9l32eVO0`aJX0<<Fj03
35bP10aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00@=HJ8=HZ8=HZ8=
HZ<43F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@@>JJD23VZU00@>
JZH>JjH>JjH>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW10i_Y`033W2W3g2X
3g2X00<?LJP33g:X00<?LjP?LjT?LjT00`mdZ@@?MJT33gJZ0`mgZP<@N:X3
47V[0a1jZ`<@Nj/447b/0a1m[08@OZ`0111n[A1o[A1o[A5o[@<AP:d00a61
[A61[Q61[P044H:^0a63[P<AQ:l34HF_0a66[`<BQk044XR`0Q:9/0044XVa
4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[824hjb00<CSk8C
Sk<CSk<00a>@/`<CTK<00a>B/a>B]1>B]0034i>d11>D]0<CUKD359Je0aBG
]@<DV;H359Vf0QBJ]P0359Zg59^g59^g008DVkL359bg00<DWKLEWKPEWKP0
0aFN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/4
5ZNk0QJX^`045ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`011J[_AJ/_AJ/_AN/_@@G
[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd
`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P0
1HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^003R<2h1000
00B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2002000>KYo7oooooool00_ooo`0:ojf`ogIknLgDoNg^ooooYY_4QGJ`
_;SMoooo<d>U1@00P0<00H000oooo`02P002P@0300>100?oool0187oool0
0P05P@0300F2oooo00J200801X801007PP47P_ooo`48PP8128<3oooo0P4:
P`0;oooo0@^3oooo0@^4oooo0@b4oooo0@b40@f4oooo0@f400;oool01@4>
Q@8?QOooo`8?QOooo`020Q2500?oool24HH24HH0108BQP824hH0108CQ`8D
Q`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP40aR800<36HP36HT36HT0
0`<JR@<36hT30ab:0`<MRP<47XX411n;0`@PR`848H/010@QS0@RS0@RS0@R
S0<48h`212B<00<498d49Hd49Hd00PDUS@<59Xd00`DWS@DWSPDWSP031BR>
0`DYSP031BZ>1BZ?1BZ?00@5:hl31Bb?0`H]T0<6;Y031Rn@0`H`T@@6<I42
1S:A00D6<Y86<i86<i86<i86=9800PLdTP031cFB1cFC1cFC00<7=Y<41cNC
0`LhU0<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`032D>H2DBH2DBH0089A9P32DFH00<9AYP9AYT9AYT0
0`U7V@<9B9T00`U9V@U9VPU9VP042DZJ0`Y;VP<:C9/32TfK0PY>V`042TjL
2TnL2TnL2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN10]FWP<;Eil32eRO0`]IW`<<FZ0335^P0`aLX0@<GJ4335jQ0PaO
X@0435nR362R362R362R0PaQXP043F6R3F:R3F:R3F:S10eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D43VVU0PiZY@043VZV3V^V3V^V3V^V0`i/
YP8>KJH010i]Y`i^Y`i^Y`i^Y`@>KjL00`i`Y`m`Z0m`Z0033g6X0`mbZ003
3g>X3g>Y3g>Y00<?M:T43gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[111l
[0<@OJ`247j/00@@OZd@Ojd@OjdAOjd34H2]00<APJdAPJhAPJh01162[P<A
Pjh34HB_0a65[`<AQZl34XN`11:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb0Q>>/P034hnb4hnc4hnc00<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0@CU;@34iFe0aBF]@<DUkD359Rf0aBI]P8DV[H0
0aBJ]aBK]aBK]`0259^g0aBL]`0359fg5Ifh5Ifh00<EW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk11JW^`8FZ;/011JX_1JY
_1JY_1JY_0<FZ[`25Z^l00@FZkdF[;dF[;dG[;d45jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;
R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0
^4R@R00000026;C000?8h=R8`;R8`;P018S0^0800005R<2h00A8T8P0000H
]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00:XJcbnLgD
hRHlm;FohRHlm6emo>?YoooooNg^ojf`0_ooo`03<d>U0020002000@00803
006000?oool00X000X400oooo`8018401Oooo`05P@05P@05P_ooo`0200J2
0oooo`040@N20@R20@R3oooo0`49P`812X<01?ooo`4;P`4;Q?ooo`8138@0
1oooo`4<Q04=Q?ooo`4=Q?ooo`4>Q@02oooo0P8?Q@030Q25oooooooo00;o
ool00`8AQP8BQP8BQP020Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0@368P00`<IR0<IR@<IR@030aZ90`<KR@<378X30af:
0`@NRP@47h/3122;0P@QR`04126<12:<12:<12:<0`@SS08498`00`@TS@@U
S@@US@021BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl0
10D[S`<5;8l31Rf@0`H^T0<6;i031S2A10HaT@86<Y401@HbTPHcTPHcTPHc
TPHdTP021cBB00<7=I87=I<7=I<00`LfT`@7=i<31cRD0`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00<9
@iP9A9P9A9P00PU4V0<9AIP00`U6V0U6V@U6V@032DNI0`U8V@032DVI2DVJ
2DVJ00@9BYX32T^J0`Y<V`<:CI/22TjK00@:CY`:Ci`:Ci`:Ci`42U2L00@:
DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh42eJN0`]GW`<;
F9l32eVO0`aJX0<<Fj0335bP10aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82
366R00@=HJ8=HZ8=HZ8=HZ<43F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@@>JJD23VZU00@>JZH>JjH>JjH>JjH33VbV0Pi]YP043VfW3VjW3VjW
3VjW10i_Y`033W2W3g2X3g2X00<?LJP33g:X00<?LjP?LjT?LjT00`mdZ@@?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/447b/0a1m[08@OZ`0111n[A1o
[A1o[A5o[@<AP:d00a61[A61[Q61[P044H:^0a63[P<AQ:l34HF_0a66[`<B
Qk044XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[824hjb00<CSk8CSk<CSk<00a>@/`<CTK<00a>B/a>B]1>B]0034i>d
11>D]0<CUKD359Je0aBG]@<DV;H359Vf0QBJ]P0359Zg59^g59^g008DVkL3
59bg00<DWKLEWKPEWKP00aFN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`0
11J[_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o
5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002
R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSP
f8S0^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P2002000fKYo7mkNkR9ScnmOSgRIOdHVkcX:kd
HVkooOoo[K3lhnWooolc@jD01`00P0<00H000oooo`02P002P@0300>10`04
P@801H400`05PP06PP06PP0200J200H01h811h811h8128;oool128<30@V3
0`4:P`030@^30@^40@^400@138@30@f40`4>Q@<23hD30Q250`8AQP@24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN810<HR003
0aV80aV90aV900<36XT30a^90`<LRP<37HX311j:10@OR`<488/2126;00@4
8H`48X`48X`48X`312><0P@TS00312B=12F=12F=00859Hd31BJ=00<59hd5
9hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`041B^?0`D/S`<6;I031Rj@0`H_
T0<6<9441S6A0PHbT@051S:B1S>B1S>B1S>B1SBB0087=9800`LeTPLeT`Le
T`031cJC10LgT`<7>9@31cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0
UP04242G246G246G246G0`Q2U`88@iL00`U3V0U4V0U4V0022DBH0`U5V003
2DJH2DJI2DJI00<9AiT32DRI00<9BIT9BIX9BIX010U:VP<:BiX32TbK0`Y=
V`8:CY/010Y>W0Y?W0Y?W0Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M
00<;E9d;E9h;E9h00`]EWP@;EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<G:04
35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ8010eQXPeRXPeRXPeRX`@=
Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU10iYY@8>JZD010iZYPi[
YPi[YPi[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?L:P0
0`maZ0<?LZP00`mcZ0mcZ@mcZ@033gBY10meZ@<?MZX33gNZ0a1hZP<@NJ/3
47Z[0a1kZ`@@O:`347f/0Q1n[00447j]47n]47n]4Gn]0a60[@034H6]4H6^
4H6^00@APZh34H>^0a64[`<AQJl34HJ_0a:7/0@BR;024XV`00@BRK4BR[4B
R[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?/a>?
/`034i2c0a>A/`034i:c4i:d4i:d00<CTk@44iBd0a>E]@<DU[D359Ne0aBH
]P<DVKH259Zf00<DV[LDVkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh
0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/2
5ZRk00@FZ;`FZK`FZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8
h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h
00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8`;P200000XS0
^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0P00P003VjOam/S<hRHl00;o[K001mlT;_nTW_JlaOn]/>ikS?oo
oc=3Y@0800200`01P003oooo00:000:100<00h4300B10P05P@0300F200J2
00J200801X801P07PP47PP47PP48P_ooo`48P`<12H<01?ooo`4:P`4:P`4;
P`812h@40@b40`4=Q0<13XD30Pn50`8@Q@<24HH40Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0@368P00`<IR0<IR@<IR@03
0aZ90`<KR@<378X30af:0`@NRP@47h/3122;0P@QR`04126<12:<12:<12:<
0`@SS08498`00`@TS@@US@@US@021BF=0`DVS@031BN=1BN>1BN>00<5:8h3
1BV>00<5:Xh5:Xl5:Xl010D[S`<5;8l31Rf@0`H^T0<6;i031S2A10HaT@86
<Y401@HbTPHcTPHcTPHcTPHdTP021cBB00<7=I87=I<7=I<00`LfT`@7=i<3
1cRD0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00<9@iP9A9P9A9P00PU4V0<9AIP00`U6V0U6V@U6V@03
2DNI0`U8V@032DVI2DVJ2DVJ00@9BYX32T^J0`Y<V`<:CI/22TjK00@:CY`:
Ci`:Ci`:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN
00<;EIh42eJN0`]GW`<;F9l32eVO0`aJX0<<Fj0335bP10aMX@<<GZ4235nQ
00@<Gj8<H:8<H:8<H:82366R00@=HJ8=HZ8=HZ8=HZ<43F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@@>JJD23VZU00@>JZH>JjH>JjH>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW10i_Y`033W2W3g2X3g2X00<?LJP33g:X00<?
LjP?LjT?LjT00`mdZ@@?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/447b/
0a1m[08@OZ`0111n[A1o[A1o[A5o[@<AP:d00a61[A61[Q61[P044H:^0a63
[P<AQ:l34HF_0a66[`<BQk044XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[824hjb00<CSk8CSk<CSk<00a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d11>D]0<CUKD359Je0aBG]@<DV;H359Vf0QBJ]P03
59Zg59^g59^g008DVkL359bg00<DWKLEWKPEWKP00aFN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl
5ZVl5ZVl0aJZ_08FZk`011J[_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P03
5jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8
`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf003
R<2h0P0000B8`;P200000XS0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^08008000i^WlOW=e?N9U`02oooo00Oo[K3Q5SCo
MW_oY9kR9ScoRGlc@jD02000P0<00H000oooo`02P002P@0300>10`04P@80
1H400`05PP06PP06PP0200J200D01h811h811h81288128<01?ooo`<12X<0
0`4;P`4;Q04;Q0040@b400<13HCoool13H@00`4>Q@<23hD30Q250`8AQP@2
4XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN810<H
R0030aV80aV90aV900<36XT30a^90`<LRP<37HX311j:10@OR`<488/2126;
00@48H`48X`48X`48X`312><0P@TS00312B=12F=12F=00859Hd31BJ=00<5
9hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`041B^?0`D/S`<6;I031Rj@
0`H_T0<6<9441S6A0PHbT@051S:B1S>B1S>B1S>B1SBB0087=9800`LeTPLe
T`LeT`031cJC10LgT`<7>9@31cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF
0PQ0UP04242G246G246G246G0`Q2U`88@iL00`U3V0U4V0U4V0022DBH0`U5
V0032DJH2DJI2DJI00<9AiT32DRI00<9BIT9BIX9BIX010U:VP<:BiX32TbK
0`Y=V`8:CY/010Y>W0Y?W0Y?W0Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd3
2e>M00<;E9d;E9h;E9h00`]EWP@;EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<
G:0435fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ8010eQXPeRXPeRXPeR
X`@=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU10iYY@8>JZD010iZ
YPi[YPi[YPi[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?
L:P00`maZ0<?LZP00`mcZ0mcZ@mcZ@033gBY10meZ@<?MZX33gNZ0a1hZP<@
NJ/347Z[0a1kZ`@@O:`347f/0Q1n[00447j]47n]47n]4Gn]0a60[@034H6]
4H6^4H6^00@APZh34H>^0a64[`<AQJl34HJ_0a:7/0@BR;024XV`00@BRK4B
R[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?
/a>?/`034i2c0a>A/`034i:c4i:d4i:d00<CTk@44iBd0a>E]@<DU[D359Ne
0aBH]P<DVKH259Zf00<DV[LDVkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^003
5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@F
Yk/25ZRk00@FZ;`FZK`FZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]
_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C0
00?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P900000XS0^005B928
00006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2002000NKYo7oooocX:kdHVkoooogRIOicM@00_oo
o`03lj2^oooo<d>U00P0080300600P02P00400:100>100>100>10`04P@80
1H400`05PP06PP06PP0200J200@01h811h811h8128820@R30`49P`<12X<0
0`4;P`4;Q04;Q0040@b40`4=Q0<13XD30Pn50`8@Q@<24HH40Q:60P8CQP04
0Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0@368P00`<IR0<I
R@<IR@030aZ90`<KR@<378X30af:0`@NRP@47h/3122;0P@QR`04126<12:<
12:<12:<0`@SS08498`00`@TS@@US@@US@021BF=0`DVS@031BN=1BN>1BN>
00<5:8h31BV>00<5:Xh5:Xl5:Xl010D[S`<5;8l31Rf@0`H^T0<6;i031S2A
10HaT@86<Y401@HbTPHcTPHcTPHcTPHdTP021cBB00<7=I87=I<7=I<00`Lf
T`@7=i<31cRD0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00<9@iP9A9P9A9P00PU4V0<9AIP00`U6V0U6
V@U6V@032DNI0`U8V@032DVI2DVJ2DVJ00@9BYX32T^J0`Y<V`<:CI/22TjK
00@:CY`:Ci`:Ci`:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM
2eBN2eBN00<;EIh42eJN0`]GW`<;F9l32eVO0`aJX0<<Fj0335bP10aMX@<<
GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00@=HJ8=HZ8=HZ8=HZ<43F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@@>JJD23VZU00@>JZH>JjH>JjH>
JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW10i_Y`033W2W3g2X3g2X00<?LJP3
3g:X00<?LjP?LjT?LjT00`mdZ@@?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@
Nj/447b/0a1m[08@OZ`0111n[A1o[A1o[A5o[@<AP:d00a61[A61[Q61[P04
4H:^0a63[P<AQ:l34HF_0a66[`<BQk044XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[824hjb00<CSk8CSk<CSk<00a>@
/`<CTK<00a>B/a>B]1>B]0034i>d11>D]0<CUKD359Je0aBG]@<DV;H359Vf
0QBJ]P0359Zg59^g59^g008DVkL359bg00<DWKLEWKPEWKP00aFN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/45ZNk0QJX^`04
5ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`011J[_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^
_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2h
R<2h00^8`;P00dR@R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P03HS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<0
08002i^WlOoooon9Oooooo>P[_6CXOooooomoo>P[_oko3=3Y@0800200`01
P0800X001002P@03P@03P@03P@<0184200F100<01H801X801X800P06PP04
00N20@N20@N20@R20P48P`<12H<30@Z300<12h<12h@12h@0104<Q0<13H@3
0@j50`8?Q@<248D30Q66108BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ7
00@35XP35hP35hP35hP40aR800<36HP36HT36HT00`<JR@<36hT30ab:0`<M
RP<47XX411n;0`@PR`848H/010@QS0@RS0@RS0@RS0<48h`212B<00<498d4
9Hd49Hd00PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?
00@5:hl31Bb?0`H]T0<6;Y031Rn@0`H`T@@6<I421S:A00D6<Y86<i86<i86
<i86=9800PLdTP031cFB1cFC1cFC00<7=Y<41cNC0`LhU0<7>I@31cZD0`Lk
U@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`03
2D>H2DBH2DBH0089A9P32DFH00<9AYP9AYT9AYT00`U7V@<9B9T00`U9V@U9
VPU9VP042DZJ0`Y;VP<:C9/32TfK0PY>V`042TjL2TnL2TnL2TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN10]FWP<;Eil3
2eRO0`]IW`<<FZ0335^P0`aLX0@<GJ4335jQ0PaOX@0435nR362R362R362R
0PaQXP043F6R3F:R3F:R3F:S10eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eW
Y0<=J:D43VVU0PiZY@043VZV3V^V3V^V3V^V0`i/YP8>KJH010i]Y`i^Y`i^
Y`i^Y`@>KjL00`i`Y`m`Z0m`Z0033g6X0`mbZ0033g>X3g>Y3g>Y00<?M:T4
3gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[111l[0<@OJ`247j/00@@OZd@
Ojd@OjdAOjd34H2]00<APJdAPJhAPJh01162[P<APjh34HB_0a65[`<AQZl3
4XN`11:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8B
SK824Xjb0Q>>/P034hnb4hnc4hnc00<CT;<34i6c00<CT[<CT[@CT[@00a>C
]0@CU;@34iFe0aBF]@<DUkD359Rf0aBI]P8DV[H00aBJ]aBK]aBK]`0259^g
0aBL]`0359fg5Ifh5Ifh00<EW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T3
5J>j0aFT^P<FYKX35ZJk11JW^`8FZ;/011JX_1JY_1JY_1JY_0<FZ[`25Z^l
00@FZkdF[;dF[;dG[;d45jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa
_aNa_`035k:o0aNc_`8H]<0?b>3H00<00038h=S8h=P03LSPf00300006;C0
6;C000o8h=P00`0001Rd`1Rd`002R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h1000P0>KYo401_oooo>P[_Be_oJlaO_IfS=3Y@T0080300600P02P004
00:100>100>100>10`04P@801H400`05PP06PP06PP0200J200@01h811h81
1h8128820@R30`49P`<12X<00`4;P`4;Q04;Q0040@b40`4=Q0<13XD30Pn5
0`8@Q@<24HH40Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0@368P00`<IR0<IR@<IR@030aZ90`<KR@<378X30af:0`@NRP@4
7h/3122;0P@QR`04126<12:<12:<12:<0`@SS08498`00`@TS@@US@@US@02
1BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl010D[S`<5
;8l31Rf@0`H^T0<6;i031S2A10HaT@86<Y401@HbTPHcTPHcTPHcTPHdTP02
1cBB00<7=I87=I<7=I<00`LfT`@7=i<31cRD0`LiU0<7>Y@31c^E0`PlU@<8
?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00<9@iP9A9P9
A9P00PU4V0<9AIP00`U6V0U6V@U6V@032DNI0`U8V@032DVI2DVJ2DVJ00@9
BYX32T^J0`Y<V`<:CI/22TjK00@:CY`:Ci`:Ci`:Ci`42U2L00@:DI`:DId:
DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh42eJN0`]GW`<;F9l32eVO
0`aJX0<<Fj0335bP10aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00@=
HJ8=HZ8=HZ8=HZ<43F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@@>
JJD23VZU00@>JZH>JjH>JjH>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW10i_
Y`033W2W3g2X3g2X00<?LJP33g:X00<?LjP?LjT?LjT00`mdZ@@?MJT33gJZ
0`mgZP<@N:X347V[0a1jZ`<@Nj/447b/0a1m[08@OZ`0111n[A1o[A1o[A5o
[@<AP:d00a61[A61[Q61[P044H:^0a63[P<AQ:l34HF_0a66[`<BQk044XR`
0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[82
4hjb00<CSk8CSk<CSk<00a>@/`<CTK<00a>B/a>B]1>B]0034i>d11>D]0<C
UKD359Je0aBG]@<DV;H359Vf0QBJ]P0359Zg59^g59^g008DVkL359bg00<D
WKLEWKPEWKP00aFN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj
0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`011J[_AJ/
_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;PF00200`01
P0800X001002P@03P@03P@03P@<0184200F100<01H801X801X800P06PP04
00N20@N20@N20@R20P48P`<12H<30@Z300<12h<12h@12h@0104<Q0<13H@3
0@j50`8?Q@<248D30Q66108BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ7
00@35XP35hP35hP35hP40aR800<36HP36HT36HT00`<JR@<36hT30ab:0`<M
RP<47XX411n;0`@PR`848H/010@QS0@RS0@RS0@RS0<48h`212B<00<498d4
9Hd49Hd00PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?
00@5:hl31Bb?0`H]T0<6;Y031Rn@0`H`T@@6<I421S:A00D6<Y86<i86<i86
<i86=9800PLdTP031cFB1cFC1cFC00<7=Y<41cNC0`LhU0<7>I@31cZD0`Lk
U@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`03
2D>H2DBH2DBH0089A9P32DFH00<9AYP9AYT9AYT00`U7V@<9B9T00`U9V@U9
VPU9VP042DZJ0`Y;VP<:C9/32TfK0PY>V`042TjL2TnL2TnL2TnL10Y@W004
2U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN10]FWP<;Eil3
2eRO0`]IW`<<FZ0335^P0`aLX0@<GJ4335jQ0PaOX@0435nR362R362R362R
0PaQXP043F6R3F:R3F:R3F:S10eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eW
Y0<=J:D43VVU0PiZY@043VZV3V^V3V^V3V^V0`i/YP8>KJH010i]Y`i^Y`i^
Y`i^Y`@>KjL00`i`Y`m`Z0m`Z0033g6X0`mbZ0033g>X3g>Y3g>Y00<?M:T4
3gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[111l[0<@OJ`247j/00@@OZd@
Ojd@OjdAOjd34H2]00<APJdAPJhAPJh01162[P<APjh34HB_0a65[`<AQZl3
4XN`11:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8B
SK824Xjb0Q>>/P034hnb4hnc4hnc00<CT;<34i6c00<CT[<CT[@CT[@00a>C
]0@CU;@34iFe0aBF]@<DUkD359Rf0aBI]P8DV[H00aBJ]aBK]aBK]`0259^g
0aBL]`0359fg5Ifh5Ifh00<EW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T3
5J>j0aFT^P<FYKX35ZJk11JW^`8FZ;/011JX_1JY_1JY_1JY_0<FZ[`25Z^l
00@FZkdF[;dF[;dG[;d45jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa
_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R04000000003R<2hb>3HR<2h0?n8
`;SoR<2hQXS0^058T8P1000000000hS0^<SPf8S0^03oR<2hohS0^8J8`;P1
B9280@00000000>8`;S8h=S8h=P0olSPf?o8h=R6b>3H0DR@R04000000?n8
`;SoR<2hRXS0^04000000001\
\>"], "Graphics",
  ImageSize->{649, 491},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:90001jaP00`40o`00
0?l0003oo`000?l0002;000000000hS0^4R@R4R@R03oB928odR@R8M8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^8J8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;R6R<2h0DR@R04000000005R<2hb>3HR<2hR<2hc<c<
0?ooooooooooP_ooo`:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVK<
c<coIVIVofIVIX1VIVH01?ooohS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV027oool00nogmooo
onogm`02oooo00?_moOoooooool00_ooo`03koOgooookoOg00;oool00nog
moooooooo`3oooooooooodgoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP0Koooo00?_inOgmno_inL06noWi`04e]KWknOW
knOWe]KW1^oWi`03koOgoooooooo0?oooooooooo>_ooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01[oool03_OgkmkNg/k>
g[fm_KFmc/k6]KFmc/k6]KFmc/k6]Kfm_KFmc/k6]KFmcP>m_Kd01lk>c[fm
_LJm_KFmc/k6]LJm_KFmcP02_Kfm00G6_Kfe_Ljm_Kg6_Kfe_Lh00kfm_@09
c/k>_Kfm_Kfma[fm]Kg>_Kfmc/k>c]KNknOW0?oooooooooo>oooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01[oool01MkN
g/k>cZf]YJf]YIbLY@0AW9bL00>LW:F]YIBLW:D00YbLW007[JFDW9bUW9bL
W9bL[JfUW9bLW9bU00:LW9`00jf]YIbLW9bLW002[JfU00?>c/kNg]k_moL0
ooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH06_ooo`03knOWg]kNoooo02Koool2g]kN00?_inOoooooool0
oooooooooolhoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH06_ooo`03g]kNc]K>oooo01?oool00oOgkoooooooo`02oooo
00GWkoOoooooooooooo_inL00_ooo`03knOWooooinog00;oool01>ogmooo
onOWg/k>c_oooooooooo>oooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV01Woool00nO_mnOWg/kFgP02oooo00?_moOooooo
ool02oooo`03koOgoooooooo00?oool00nO_moooooooo`0:oooo00O_inOo
oooooooooooNg]k>e]k_inL0ooooooooooljoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06_ooo`03g]kNg/k6oooo017o
ool00nogmoooooooo`02oooo00?gknOoooooool00_ooo`04inogoooooooo
inog1Oooo`05knOWooooknOWc/k>koOg0?oooooooooo>_ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01Woool00oOgknON
g/kFgP0>oooo00?_moOoooooool01?ooo`03moO_oooooooo00[oool00nog
moooonO_m`02oooo00?Ng]k>e/k_inL0ooooooooooljoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06_ooo`03g]kNc/k>
oooo00?oool02^oWilk>c^oWinogmoooonO_moooonoWilk>c^oWi`;oool0
0nogmoooomkNgP05g]kN00KFc]J4Ng>LJf>]Nf?>_JFDS8`2[G]S00Zm_Kg>
a[GNg/k>a[Fm_JgWkoOooooNg]k>c/k_moOooooooooooc[oool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0Joooo00CFe^ON
g/koooo_inL2_Kfm00G>c/jLW9b]]KG>c/k_moL00Zf]Y@:LW9`07Hb<S;fm
_Jf]YNoWioooonOWg^oWioOgknoWioO_inOWg]k>aU9:@W/@28@H4:ekHiA2
<G<H49`a8LjUQ=kNc^oWc]kNc/k6]NoWioooomkNg/kFg^oWi`3ooooooooo
oc[oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP0Ioooo00?gmnoWimk>e]h00_ooo`03e/kFg]kNknOW00;Ng]h01noWiooo
omKFinoWilkFc]kNg[fm_@02g]kN0_ooo`0Hc/k>Q9BDW9bUW9bLNhB4Jg=c
FV][BQPHLaP@W34QQ3TaHaPHQ24HYG=J[G]SW9bUW8AkU8aS[KFemoO_oooo
knOWc/k>koOgooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH06_ooo`03e]KWe/kFoooo00Ooool00nogmooo
ooooo`02oooo00?WkoOoooooool00_ooo`0>g/k6S8b<S8b<Jf][S8b<[JFD
Jf][DPP8Jc4YW34Q[G]SQ1P@Q24HJc4Y0TYBFP08FUYJDTY2Jg=cknOWoooo
g]kNc]KNknOWooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH06_ooo`05g]kNc]K>oooomnoW[KFe00:m_Kd0
1kFmc[fm[NoWilk>cZf]YNoWijfe]@02_Kfm01?Ng]je_Lk>a[Goooo>e]jm
_Kf][JFLU8b]YIC>a[EkLf<H411B20R]Nf><JdZ48AQk<BUB>C4Y:BT00cTi
<@06FUY2knOWooooinONc/k>koOgooooooooooljoooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06Oooo`0]koOginONc/k>
ooookoOg_Kfm[JfUc/kNc/Jec/k>knOWc/k>_KfmknOW[JfU_Kfmc/k>g]kN
c/k>[KFeoooog]k>_Kf][JfUW9bL[Ib4c[fULf]S8AP@DTY2Hd8iBS4YDSTa
DSTYNg]kNhB4FUYJBU8iBTXaBU8iknOWooooe]KWc]K>knOW0?oooooooooo
>_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
01[oool02=kNg/kFg_ooooooonogmoooonoWinO_m`Goool00nogmooooooo
o`02oooo00W_inOoooo>c]jm_Jfm_KfDS8acLeZ]W8AcJf<00U8i<@0?@RTQ
DSTaFT8iDSTaS8acS8b<Ng]kJf=BJf]:FV=JknOWooooinONc/kNmoO_0?oo
oooooooo>_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV01Woool2knOW00?Fc]Koooo_inL00/k>cP09W9bU[JFD]Kg>c/Je
g]kNc]KNc/k>g]kNc]KN00;>c/h03<Jm_LkFg_ooolk6]Hb<S8b<LeYJ@Xb<
S<k6]G=[He9:@S4H409B>C4017=JDU8i<EYJ@W]cH`9[JdX01eYJ@V][B^oW
inogmnoWilkFc^oWi`3ooooooooooc[oool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP0Joooo00KNg]k>e/kooooooon][JF]
]KD4_Kfm00KNg]jm_Kg>a[G>e]k>a[F]]KD2_Kfm016][JGooon]]KE:BTYB
BT9[He:<S7>LQ7]JFUYB>BU2:B5[BT9JFT9cFU9SFTXY:APi>AP00UYB:@06
>CTHNf=:knOWoooog]kNc/k>oooooooooolkoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06Oooo`06koOginONc/k>oooo
koOgknOW2Oooo`0NknOWinONooookoOgknOWoooo[JfU:C4Y:BTHBTXY[JFD
a[fm>CTa@RTQDSTaDTY2NeY:Jf=BFT8i:BTHBS4YBTXYLg=JBS4YDV=2e]KW
ooooinONc]KNknOWooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH06_ooo`0:g]kNc]KNooooknOWc]KNg]kN
c/k>g]kNc/k>knOW0/kFgP0PknOWg]kNc]KNc/k>e/kFknOWc]KNkoOg[JFD
0000:BTH>B4HW9B<c/J]Ng=S:BTH@RTQ[G]SU6]JJc4Y>CTH:BTH<CTQBTXY
BTXa>CTHBTXaknOWkoOgknOWc/k>koOgooooooooooljoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06Oooo`0]koOgknOW
c/k>oooog]kN_Kfm[JfU[KFe[JfUW9bL]LKF[JfU_Kf]c]KNc/k>W9bU[JfU
_Kfmc]K>_KfmknOW[JfU4000:BTH<CTQ_Kf]g/jmS8ac:BTHLeYB[G]SaZfL
Q7]c<CTQ610@>CTHBU8iBUY2:BTY>D8aknOWooooe]KWc]K>knOW0?oooooo
oooo>_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV01Woool2knOW00?>e/koooooool00nogm`04moO_c]KNinONknOW1^og
m`?oool06:f]YBTY62TY62TY68b<LljmYDYJ@RTY63TQ67]SBXa[BUYJ@SU2
<BTa:BTQ24YB>HBDU7^4Q5YSF^oWinogmnOWg/k>g_Ogkooooooooooo>_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01[o
ool00mkNg/k>g_ooo`04knOW00CFe^O_inOWimkFe^L6knOW00GFe^OgknOo
oon][JDa>B400TYJ@P09U8aS_Kf][KFeJg=c4108>B4H<AP@610@FV][009J
HeX02F=cS:fe]IbegZFec^oWinogmmkNg/kFc^oWi`3ooooooooooc[oool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0Joooo
00KNg]kNg/koooo>e]jm_Kfe[Jd2[JfU01F<S8be_Ljm_JfLW:F][JF]]KFm
_Kf][JF]]KF][JGWkoOoooo>c/iSLhakQ8A[He9kNg^m_Jf]YIB<S8`Y:BT0
0P00000=BU9JW;GNYKG>W;GNYKgNW;GW]LKFW;GNknOWmoO_g]kNc/k>koOg
0?oooooooooo>_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV01[oool01MkNg/kFg_ooonoWimkNgP02koOg00?_inO>c/k_
moL00^oWi`03c/k>knOWc]KN00;_inL01>O_moO_ioOgkmKFi`:L[Kd01YbL
YJf]YKfm_KFmc[G6eZFecP9SLh`6W;GN00NL]NNU]Lk_inOooooNg]k>e]k_
inL0ooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH06Oooo`;_inL01LkFc_ooonoWinoWinogm`02knOW00>]
]KG_inO_moL01NoWi`05inogmnoWinogooooc]KN00:]_NL00jg6mib]_Lk6
[@03W;GW00F]a^nL]NNL]MjL]MjL]NL01IbegP05c]KNkoOgg]kNc/k>koOg
00_oool00`000?ooooooo`06oooo0`0000Coool01@000?ooooooooooo`00
0004oooo0`0000?oool01@000?ooooooooooo`000002oooo00@0003ooooo
ool00003oooo0P000003oooo0000oooo00;oool20000ooooooSoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0Joooo00SW
imk>c]koooo>e]jLW9c>a[Fe_Lj]]KD2[JfU00>LW:F][JFLW9`00/k>cP0@
[KFe[JfUS8b<c/k>oooo]LKFW:gNW;GNW:gNW:fm[JfUW:gNW:g>W;GNW:gN
W:g>0Yb]gP06W:g>W:gNW:gNW:g>W:gNW:g>0^oWi`03g]kNc]K>knOW00_o
ool00`000?ooooooo`05oooo00D0003oooooooooool000000oooo`050000
oooooooooooo000000?oool01@000?ooooooooooo`000002oooo00D0003o
ooooooooool000000_ooo`040000oooooooo00000_ooo`030000oooooooo
00800002oooo00@0003oooooool0003ooooomoooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV01Woool02>ogmmkNg]kNc_oo
onoWilkFg^oWioOgk`?_inL01LkFg^oWinOWg]KFinoWi`03g]kN00G_inO_
moO_inO>e]kNg]h00/kFgP04g/k6e]KWg]kNe]KW0/kFgP03g]kNc]KNc]KN
00C>e]h01KG6e^oWioOgklkFg/k>cP0<oooo00<0003oooooool01Oooo`05
0000oooooooooooo000000;oool01`000?ooo`000?ooo`000?ooo`000002
oooo00<0003oooooool01?ooo`0;0000oooooooooooo0000oooo0000oooo
0000oooo000000;oool01@000?ooooooooooo`000002oooo00<0003ooooo
ool0ooooooSoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP0Joooo0]kNgP0>ooooknOWooooooooe]KWc/k>knOWmoO_oooo
moO_inogknOW_Kfmg]kN0_ooo`0:inogknOWkoOgooooknOWoooomnoWoooo
inogkoOg0^oWi`04ooooknOWinogmoO_0^oWi`03g]kNknOWkoOg00;_inL0
0mkNg/kFc^oWi`0;oooo00<0003oooooool01Oooo`050000oooooooooooo
000000;oool01`000?ooo`000?ooo`000?ooo`000002oooo1@0000;oool0
2`000?ooooooooooo`000?ooo`000?ooo`000?ooo`000003oooo100000;o
ool00`000?ooooooo`3ooooon?ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool:c<co2?ooo`;_inL04<kFg_ooonog
mjf]YKfm_Lk>cXb<S:f]YKFmc^oWiibLW:f]YHb<S8BDU9B<S:fe]@:][JD0
2Lk>c^oWinO_mmkNgYbLYLk>cZfe]Jf]YIbLW002c/k>00RLW9cNg]j]YIC>
c]j][JFLW:F4U9C>e/h2knOW00C_moO>c]k>c/k_moL;oooo1@0000?oool0
1@000?ooooooooooo`000002oooo00L0003oool0003oool0003oool00000
0_ooo`050000oooooooooooo000000;oool02`000?ooooooooooo`000?oo
o`000?ooo`000?ooo`000006oooo00@0003oooooool0003ooooon_ooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0@oooo00GNg]k>e/koooo_inO>c/h00mkNgP0:c]KNknOW
knOWg]kNc]KNc/k>e/kF[KFeg]k>c]KN0/k>cP07ooooknOW[KFeS8b<_Kfm
[JfUg]kN00;>c/h02MkNg/k>c]kNg/k>c]kNg]K>e/kFc/k>c]KFi`03knOW
00?Ng/k>e]k_inL02oooo`030000oooooooo00;oool010000?ooooooo`00
00?oool00`000?ooo`000003oooo00L0003oooooooooool0003oool00000
0oooo`030000oooooooo00800002oooo00L0003oool0003oool0003oool0
00000_ooo`050000oooooooooooo000000;oool010000?ooooooo`000?oo
ooogoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH01oooo`03c<cooooooooo013oool01>OWg/kFg_ooonogm`?oool01NoW
ioooonO_moooooO_i`03oooo00S_inO_moO_inOoooo_inOooooNg]k>c/h2
g]kN00[_inOooooWkoOoooo_inOWkoOgknOWkoO_inOWkoL4knOW00GFe^O_
inO>e]kNc/K_moL02oooo`030000oooooooo00;oool010000?oooooooooo
o`<00002oooo00D0003oooooooooool000000oooo`030000oooooooo00<0
0003oooo00@0003oool0003oool200000oooo`800003oooo0`0000Coool2
0000ooooooSoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool04?ooo`05e]KWc/k>ooooknOW[JfU
00:]]KD02Kfm_Jfe]MkNg[fm_Jfe]NOWgZf]YKFmcZf]Y@02c/k>00Ne[Jfm
_Kf]]KFLW9b<S8bm_Jg>c]h00Zfe]@:][JD01/k>g[fm_Jf]YKfm_Lk>cZf]
Y@:]]KD2[JfU00G>c/k_inO>e/k>c/kWkoL02oooo`030000oooooooo00;o
ool00`000?ooooooo`0Koooo0P0000?oool20000ooooooooool5oooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03
c<cooooooooo00ooool02?OgknOWg]kNg_ooonoWijfe]Jf]YLk>cP:m_Kd0
1=kNg/k>cZf]YMKFi`:][JD01/k>c]kNg[fm_IbLW<k>c/Jm_@:m_Kd02/k>
c]kNgZfUU:fe]Lk>c[fm_Lk>cZf]YKFmc/k>cP:m_Kd01Zf]YLk>c[fm_Jf]
YKfm_NoWi`;>c/h00oOgkoooooooo`09oooo1@0001koool00`000?oooooo
o`03oooo00<0003oooooool0ooooooooool3oooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013o
ool01=KFilkFc_ooonogm`?_inL01]kNg_ooooooonoWioooonogm`;_inL0
1_ooooOgkoOgkmKFioO_inO_m`;gmnl00nO_mnogmnoWi`02knOW00KWkoO_
inONg]kWkoO_inO>e]h3knOW00OFe^ONg]kNg]kWimk>c/k>e]k_inL0oooo
ooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo00ooool01oOgknOWg]K>e_ooonoWilk>
cZfe]@02W9bL00Z][JFm_KgNg]k>c/jm_KgNc/K>e]jm_Kfe_Ljm_Kd2c/k>
00nm_Kfe_Lk>c/k>a[G>e]jm_Kf]]KG>c]kNg/jm_Kf]]KFm_Kf]]KFm_Kg>
c/h00[fm_@04c/k>[JfU_Kfmc/kN0/k>c_oooooooooo>oooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0@oooo00OFe^O>e/koooo_inNLW9bm_Kf][JD00[fm_@05[KFec/k>
_Kfm_Kfmc]KN00:]]KD01Zf]YJfe]Jf]YJfe]Kfm_Jf]Y@:m_Kd02=kNgYb]
_Jf]YLk6]LkFgXBDU:f]YJfe]@:][JD02/k>c[fm_IbLW;fm_Hb<S9bLW=kN
g/k>c]k>a^O_mooooooooooo>_ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0?oooo00KgmnoW
imk>c]kgmno_inONg]h2inog00K_inO_moO_inOWkoO_inO_moL2knOW00C>
c]k_inOgmno>e]h2g]kN2noWi`06g]kNknOWg]kNg]kNc/k>e/kF0/k>cP04
c]KNc/k>c/k>mnoWooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013oool01=KF
ilk>c_ooomKFi`G>c/h01=kNg/k>c/k>c^ONgPC>c/h03<k>g/k>c/k>cXBD
U;fm_Lk>c/kFg/k>c[fm_Lk>c[fm_Lk>gP;>c/h01kfm_Lk>c[fm_Lk>c[fm
_KF][Jfe]@02_Kfm00CNc/Jm_Kg>c/k_moOooooooooooc[oool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oo
ooooool04?ooo`04g]kNc/k>ooooc]KN0jf]Y@0=W9bUS8b<c/k>W9bL[JfU
]LKF_KfmQ9BD[JFD[JfUc/k>[KFec/k>00:][JD019bLW;fm_Lk>cZf]Y@:<
S8`04<Jm_IbLW8b<S9bLW9bLYHb<S;fm_Hb<S9bLW9B<S9bLW8b<S;Fmc[fm
_MkNc^oWiooooooooooo>_ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0?oooo00C_moO_inO>
c/k_moL3knOW00GNg]k_inO>c/k>e/kNg]h01NoWi`03inONknOWknOW00;_
inL01]KFimkNg/kFc^oWinOWg]KFi`?>c/h02;fm[Lk>g/k>c]k>a[Fmc[fm
_Lk>c[FmcP>m_Kd00kfm[LkFg_ooo`3ooooooooooc[oool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool03oooo`04mnoWe]KWg]k>oooo1=kNgP07c/k>g]kNc/kNg]kNg]k>g]kN
c]KN00;Ng]h00lk>g]kNg]kNgP02g]kN00[>c/k_inO>c]kNg/je_LkNc/J]
[JFLW:Fe_Lje[Jd2[JfU00>]]KF][JF][JD00Zf]Y@06W9bU[JfU[KFe_Kfm
knOWkoOgooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013oool01>oWilk>c^og
mlk>cP:][JD00ibLYIbLW8b<S002[JfU00f4U9BLW:F][JF][JFLW:F][JFL
W:G>a[FLW:F<S8bLW9c>c/j<S8`00ibLW004[JfUS8b<Ng]kNg]k0V][J`0:
W9bLJf][Jf][Ng]kS8b<FUYJW9bL[JfUc/kNknOWoooooooooolkoooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03
c<cooooooooo00ooool01^O_mnOWg/k>c_ooolk>c/kFgP?Ng]h02[fm_MkN
g]kNg]kNg[fm_MkNg/k>c/kFc]kNg^OWgP;>c/h00kfm_Lk>c]kNgP02g]kN
00c>c/k>e]k>c/jm_Kf][JFLW9b<S8akNg^<S8akNg]kQ8AkNg/2S8b<00>L
W9bm_Kg_inL0oooooooooolloooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013oool01>OWg/k>
c^ogmnoWi`CNg]h2_Kfm00SWimkNg]kNg]kNg]kWimkFe^ONg]kFe^L6g]kN
00S>c]kNg]kNc/K>c/jm_KfLW9b<S8a[Lg<4Jf][00EkNg]kQ8BLW9bm_KgN
g]h0oooooooooolmoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00ooool02_OgkmKFilkFc^O_
mnoWihb<S:f]YLk>cXBDU;F][@FLW9`01Lk>cZfUU:f]YHb<S9bLY@02[JfU
00>LW9b][JF<S8`00YbLW003NhB4_KfmNg]k00=[Jf/00hb<S7]kNhb<S002
[JfU0/k>cP03g]kNoooooooo0?oooooooooo??ooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0@
oooo00ONg]k>c/k_moO_inO>c/k>e/kWimh00]kNgP09c]KNc/k>c/k>c]KN
c/k>g]kNc/k>c/kNg]k>00?>c/h00jfe]Lk>c/k>cP02c/k>00G6_Kfe_Lj]
[JF<S8bm_Kd01?ooo`04knOWg]kNc/k>g]kNoooooooooolooooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo013oool01mkNg/k>c^oWinoWimkNg]KFinoWi`02g]kN00[Wg]k_
inO_inO_inONg]k>c]kWimkNg]kFe^O_inL6g]kN0lk>cP03[KFeU8b<c/k>
00?oool2g]kN00?>c/kNg]koool0oooooooooolooooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo
00ooool06>O_mnOWg/k>c^ogmlk6]Lj<Hmk>_NoWimjm[LIkB/k6[LkFgZf]
YHBDU:fe]IbLW<k>cZfe]JfUU8BDU:fe]IbDS<k>cYbLY@BLW9`02Zf]YG^4
Q6][Jkfm_OooonogmnOWg]kNg/k>c]kNg_oooooooooo@Oooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0@oooo01S>e]k>c/k_moO_inO6[IcNg/k_inO6[Ic>S6?_inOFe^Nm
_Jg>c/j]]KG>c/kNg]k>a[Fe_Lk6_Kg>a[Fe_Lk>a[F][JF]]KD2_Kfm00ZL
W9b][JF<S8akQ8C>c/koooo_inO>e]k>c/kNg]kooooooooood;oool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool03oooo`0=koOgknOWc/k>knOWinONc]K>cZF4c/JeaW]:c[fU
knOWinONc]KN00;_inL00nOWg]kNg]kNgP04g]kN00?>c]k>c/kNg]h00]kN
gP09a[fm]Kg>[JfUS8b<c/kNknOWg]kNc/k>g]kN0?oooooooooo@oooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0@oooo00WNg]k>c/kgmnoFe^O_inOF]Ic>a[G6Nd[>e]h0
0^oWi`03inONe]KWinON00GNg]h01<k>g]kNg]kNc]kNgPC>c/h2[JfU00F<
S8cNc/KNg]k>c/kNg]h0oooooooooom4oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00ooool0
0nO_mnOWg/k>cP03knOW00?>a[G>S6?>W7/00^oWi`03inONg]kNg]kN00?N
g]h02<kFg]kNg]kNg]kNg]kNc]K>e/k>c]kNgP;>c/h2_Kfm0YbLW003c]KN
c/k>g]kN0?ooooooooooAOooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0@oooo00cNg]k>c/k_
inO_inO>e]kWimjeLe[>aZg_inOWimkFe^OWimh5g]kN00KNg/k>c]kNg/k>
c]kNg/k>c]h3c/k>00Jm_Kf]]KFLW9bm_Kg>c/kNg]koooooooooodKoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo
00?<c?ooooooool03oooo`05koOgknOWc/k>moO_c]KN00;_inL01<k6]NOW
g^OWg]KFi`GNg]h01lk>g]kNg/kFg]kNc/k>g]kNc/kFgP03c/k>00Jm_Kf]
]KF][JF]]KG>a[GNg]koooooooooodOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04?ooo`0;
knOWc]KNknOWinONc]KNknOWinONe]KWinONg]kNinON00?Ng]h01mkNc]kN
g]kNc]K>e]kNg/k>c/kFgP02c/k>00O>a[Fe_Ljm_Kfm_Jf][JF]]KGFe^L0
oooooooooom8oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo013oool04>ogmnoWioOgkmKFinoW
inOWg]KFinOWg/kFg^OWg/kFg]kNg/kFg]kNg/kFg]kNgP;>e]h00lkFc/kF
g/k>cP03c/k>00Fm_Kf]]KF]]KG>c/k_inL0oooooooooom9oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo017oool>knOW00SNg]k_inO_inO_inONg]k_inONg]k_inL2g]kN
0^oWioooooooooooBoooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`3oooooooooogKoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool0oooooooooomfoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo0?ooooooooooM_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`3oooooooooogKoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0oooooooo
oomfoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH01oooo`03c<cooooooooo0?ooooooooooM_ooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0[
oooo00?_moOoooo_moL00_ooo`03koOgoooooooo00;oool00nogmoooonog
m`02oooo00?_moOoooooool0oooooooooolioooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo02Go
ool00noWioOgknoWi`0KknOW00CFe^O_inO_inOFe^L6knOW00?_moOooooo
ool0oooooooooolVoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo02Coool03_OgkmkNg/k>g[fm
_KFmc/k6]KFmc/k6]KFmc/k6]Kfm_KFmc/k6]KFmcP>m_Kd01lk>c[fm_LJm
_KFmc/k6]LJm_KFmcP02_Kfm00G6_Kfe_Ljm_Kg6_Kfe_Lh00kfm_@09c/k>
_Kfm_Kfma[fm]Kg>_Kfmc/k>c]KNknOW0?oooooooooo9oooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0Toooo00GNg]k>c/j][JF][JFLW:D04IbLW003W9bU[JFDW9bU00:L
W9`01jfUU9bLYIbLW9bLW:f]YIbLW9bLY@02W9bL00>][JFLW9bLW9`00Zf]
Y@03c/k>g]kNkoOg0?oooooooooo9_ooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Toooo00?_
inONg]koool09_ooo`;Ng]h00noWioooooooo`3oooooooooobCoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool09?ooo`03g]kNc]K>oooo01?oool00oOgkoooooooo`02oooo
00GWkoOoooooooooooo_inL00_ooo`03knOWooooinog00;oool01>ogmooo
onOWg/k>c_oooooooooo9oooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Soooo00?WkoOWimk>
e]h00_ooo`03koOgoooooooo00_oool00nogmoooooooo`03oooo00?WkoOo
ooooool02_ooo`07knOWoooooooooooog]kNc]KNknOW0?oooooooooo9_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0Toooo00?Ng]kNc/Koool04Oooo`03koOgoooooooo
00;oool00oO_ioooooooo`02oooo00CWkoOooooooooWkoL5oooo00G_inOo
ooo_inO>c/k_moL0oooooooooolVoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo02?oool00oOg
knONg/kFgP0>oooo00?_moOoooooool01?ooo`03moO_oooooooo00[oool0
0nogmoooonO_m`02oooo00?Ng]k>e/k_inL0oooooooooolVoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo02Coool00mkNg/k>c_ooo`03oooo00[_inO>c/k_inO_moOooooW
koOoooo_inO>c/k_inL2oooo00?_moOooooNg]h01MkNgP06e/kFQ7]cW6]S
[G]Sc[fUU8b<0ZekH`0:_Kfmc/Jeg]k>c/Je_Kf]inogoooog]kNc/k>koOg
oooooooooolVoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo02Coool01=KFimkNc_ooonoWi`:m
_Kd01Lk>cYbLW:fe]Lk>c^ogm`02[JfU0YbLW00MS8b<_Kfm[JfUknOWoooo
inONknOWmoO_knOWmnoWinONg/k6DTY2Na08Q1P@[G]SU48aLaP@W34QcZF4
g]k>knO>g]k>c/JeknOWoooog]kNc]KNknOW0?oooooooooo9_ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`0Soooo00?gmnoWimk>e]h00_ooo`03e/kFg]kNknOW00;Ng]h0
1noWioooomKFinoWilkFc]kNg[fm_@02g]kN0_ooo`0Hc/k>Q9BDW9bUW9bL
NhB4Jg=cFV][BQPHLaP@W34QQ3TaHaPHQ24HYG=J[G]SW9bUW8AkU8aS[KFe
moO_ooooknOWc/k>koOgoooooooooolVoooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo02Coool0
0mKFimK>e_ooo`07oooo00?_moOoooooool00_ooo`03inogoooooooo00;o
ool03]k>aXb<S8b<S6][Jhb<S:fUU6][Je8826/a:I`a8JekHh@H48@Q66/a
:@9:DUX025YJFU9:@V]cLnoWioooomkNg/kFg^oWiooooooooooo9_ooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0Toooo00GNg]k>e/koooogknN]]KD00[fm_@07]Kg>_Kf]
knOWc/k>[JfUknOW[KFe00:m_Kd04mkNg[Fmc/k6]OooolkFg[fm_Jf]YIbD
S:fUU<k6]G]cHaP@45882:ekHha[BX@Q67/a:E8i<BTY:@03>CTa00IJFT;_
inOooooWimk>c/k_moOoooooooooobKoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool08oooo`0]
koOginONc/k>ooookoOg_Kfm[JfUc/kNc/Jec/k>knOWc/k>_KfmknOW[JfU
_Kfmc/k>g]kNc/k>[KFeoooog]k>_Kf][JfUW9bL[Ib4c[fULf]S8AP@DTY2
Hd8iBS4YDSTaDSTYNg]kNhB4FUYJBU8iBTXaBU8iknOWooooe]KWc]K>knOW
0?oooooooooo9_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Ooool00lc<ooooooooo`0Toooo00SNg]k>e]koooooooo_
moOoooo_inOWkoL5oooo00?_moOoooooool00_ooo`09knOWooooc/kN_Kf]
_KfmU8b<Lg=J[Ib4Lf]S009B>C403d8Y8E8i<EY2>E8i<Hb<Lhb<S7]kNf]S
DV][BUYSF^oWioooonOWg/k>g_Ogk`3oooooooooobKoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool08oooo`;_inL00mK>e_ooonoWi`02c/k>00VLW:F]YIBe_Lk>a[GNg]k>
e]k>c/kNg]k>e]h00/k>cP0<a[fmc]KNooooc/JeS8b<S8acFUY2S8b<c/Je
Lf]SDTY2<AP@0U8i<@04LeYBDSTaFUY2Ng=S0V][BP07FUY2Jf]:knOWkoOg
knOWc]K>knOW0?oooooooooo9_ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Toooo00KNg]k>
e/kooooooon][JF]]KD4_Kfm00KNg]jm_Kg>a[G>e]k>a[F]]KD2_Kfm016]
[JGooon]]KE:BTYBBT9[He:<S7>LQ7]JFUYB>BU2:B5[BT9JFT9cFU9SFTXY
:APi>AP00UYB:@06>CTHNf=:knOWoooog]kNc/k>oooooooooolWoooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03
c<cooooooooo02?oool01^ogmnOWg/k>c_ooonogmnoWi`Woool07^oWinOW
g_ooonogmnoWioooojf]YBTa:BTY64Y::JfUU<Jm_CTi<D8Y8E8i<E9:@W]J
BV]SDUY2>BTY64Xa:DY::G=cFTXa:E9S@]KFioooonOWg/kFg^oWiooooooo
oooo9_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Toooo00[Ng]k>e]koooo_inO>e]kNg]k>
c/kNg]k>c/k_inL2c]KN023_inONg]k>e]k>c/kFc]K_inO>e]k_moN]YI@0
000Y:APi8ARLU8c>aZekLf<Y:AQ2:B6]Nf>DJeY[<BTi>APY:APa>B5:BRU:
BS4i>AQ:BS7_inO_moO_inO>c/k_moOoooooooooobKoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool08oooo`0]koOgknOWc/k>oooog]kN_Kfm[JfU[KFe[JfUW9bL]LKF[JfU
_Kf]c]KNc/k>W9bU[JfU_Kfmc]K>_KfmknOW[JfU4000:BTH<CTQ_Kf]g/jm
S8ac:BTHLeYB[G]SaZfLQ7]c<CTQ610@>CTHBU8iBUY2:BTY>D8aknOWoooo
e]KWc]K>knOW0?oooooooooo9_ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Soooo0^oWi`03
c]K>oooooooo00?_moL01?OgklkFg^OWg^oWi`K_moL3oooo01R][JDY:APY
:APY:AR<S7?>_JE:FT8Y:APi8AQkHdZ<JdYJFT8i@S4Y<BTY8@Q:DSV4U9Ak
Q8AJHe[_inO_moOWimk>c]kgmnooooooooooobKoool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
9?ooo`03g]kNc/kNoooo00C_inL01=KFinoWinOWg]KFi`K_inL01MKFioO_
ioooojf]YC4i8@02BUY200VDS6>m_Jf]]KE[Lg<@40Pi8APa610H411JJf/0
0UYSFP09Hg><[KFeW;GNYKG>knOWkoOgg]kNc]K>knOW0?oooooooooo9_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0Toooo00KNg]kNg/koooo>e]jm_Kfe[Jd2[JfU01F<
S8be_Ljm_JfLW:F][JF]]KFm_Kf][JF]]KF][JGWkoOoooo>c/iSLhakQ8A[
He9kNg^m_Jf]YIB<S8`Y:BT00P00000=BU9JW;GNYKG>W;GNYKgNW;GW]LKF
W;GNknOWmoO_g]kNc/k>koOg0?oooooooooo9_ooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0T
oooo00GNg]k>e]koooo_inONg]h00^ogm`03knOWc/k>koOg00;_inL00lk>
c^oWilkFgP02knOW00CWkoOgknOgmnoFe^L2W:fm00JLW:F][JFm_Kfe_Lje
a]JU]Lh2Hg><1YbegP07W;GWYKG>knOWoooog]kNc]KNknOW0?oooooooooo
9_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0Soooo0^oWi`05c]K>ooooknOWknOWkoOg00;_
inL00jfe]NoWinogm`05knOW00GWkoOgknOWkoOoooo>e]h00Zfmi`03[LKg
W:fmc/J]00>L]NL01Jg6kibeiibegYbegYbei`05W;GN00G>e]k_moONg]k>
c/k_moL02oooo`<00004oooo0P000003oooo0000oooo00;oool00`000?oo
ooooo`02oooo0P000003oooo0000oooo0?oooooooooo0oooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0Toooo00SWimk>c]koooo>e]jLW9c>a[Fe_Lj]]KD2[JfU00>LW:F]
[JFLW9`00/k>cP0@[KFe[JfUS8b<c/k>oooo]LKFW:gNW;GNW:gNW:fm[JfU
W:gNW:g>W;GNW:gNW:g>0Yb]gP06W:g>W:gNW:gNW:g>W:gNW:g>0^oWi`03
g]kNc]K>knOW00[oool01@000?ooooooooooo`000002oooo00<0003ooooo
ool00P0000?oool01@000?ooooooooooo`000002oooo0P000?oooooooooo
1?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0Soooo00S_moONg]kNg/koooo_inO>e]k_inOg
mnl3knOW00G>e]k_inOWimkFe^O_inL00mkNgP05knOWkoOgknOWc]KNg]kN
00;>e]h01=k>a]KFimkNg]KFi`;>e]h00mkNg/kFg/kFgP04c]KN00Fea]K_
inOgmno>e]k>c/h02oooo`050000oooooooooooo000000;oool01@000?oo
ooooooooo`000002oooo00<0003oool000000_ooo`050000oooooooooooo
00000?oooooooooo1?ooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Toooo0]kNgP0>ooooknOW
ooooooooe]KWc/k>knOWmoO_oooomoO_inogknOW_Kfmg]kN0_ooo`0:inog
knOWkoOgooooknOWoooomnoWooooinogkoOg0^oWi`04ooooknOWinogmoO_
0^oWi`03g]kNknOWkoOg00;_inL00mkNg/kFc^oWi`0>oooo00@0003ooooo
ooooool400000_ooo`030000oooo000000?oool40000ooooooooool4oooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01ooo
o`03c<cooooooooo017oool:c<co2?ooo`;_inL04<kFg_ooonogmjf]YKfm
_Lk>cXb<S:f]YKFmc^oWiibLW:f]YHb<S8BDU9B<S:fe]@:][JD02Lk>c^oW
inO_mmkNgYbLYLk>cZfe]Jf]YIbLW002c/k>00RLW9cNg]j]YIC>c]j][JFL
W:F4U9C>e/h2knOW00C_moO>c]k>c/k_moL>oooo00<0003oooooool01?oo
o`060000oooooooo0000oooo00001_ooo`030000oooooooo0?oooooooooo
0_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`05g]kNc]K>
ooooknOWc/k>00?Ng]h02/kFg^oWinoWimkNg/kFg/k>c]K>eZfe]MkNc/kF
gP;>c/h01oooonoWijfe]Hb<S;fm_Jf]YMkNgP02c/k>00WNg]k>c/kNg]k>
c/kNg]kFc]K>e/k>c/kFe^L00noWi`03g]k>c]KNknOW00koool010000?oo
ooooo`0000?oool00`000?ooo`000003oooo00<0003oool000000oooo`03
0000oooooooo0?oooooooooo0_ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?oo
ooooool04?ooo`04inONc]KNooookoOg0oooo`05knOWooooinogoooomnoW
00?oool02>oWinogmnoWioooonoWioooomkNg/k>cP;Ng]h02^oWioooonO_
moooonoWinO_moO_inO_mnoWinO_m`C_inL01MKFinoWilkFg]k>a^ogm`0>
oooo00@0003oooooooooool300000_ooo`050000oooooooooooo000000;o
ool30000ooooooooool5oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<oooooooo
o`0@oooo00GFe^O>c/koooo_inN][JD00Zfe]@09_Kfm[KFeg]kN_Kfm[KFe
inON[JfU]Kg>[JfU00;>c/h01kF][Kfm_Jfe]IbLW8b<S;fm[Lk>gP02[KFe
0Zf]Y@06c/kN_Kfm[JfU_Kfmc/k>[JfU0Zfe]@:][JD01Lk>c^oWilkFc/k>
c^O_m`0>oooo00<0003oooooool0oooooooooolEoooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo
017oool00lc<ooooooooo`0?oooo00SgmnoWimkNg]koooo_inN]]KF][JG>
c/h2_Kfm00CNg]k>c/j][JGFe^L2[JfU00K>c/kNg]jm_KfLW9c>c/k6_Kd2
_Kfm00[>c/kNg]j]YIB]]KG>c/jm_Kg>c/j][JFe_Lk>c/h2_Kfm00J][JG>
c/jm_Kf][JFm_Kg_inL2c/k>00?gmnooooooool03?ooo`030000oooooooo
0?oooooooooo5Oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?oo
o`04e]KWc]K>ooookoOg0noWi`06g]kNooooooooknOWooookoOg0^oWi`06
oooomoO_moO_e]KWmnoWinog0_Ogk`03inogkoOgknOW00;_inL01^O_mnoW
imkNg^O_mnoWilkFgP?_inL01mKFimkNg]kNg^OWg/k>c/kFg^oWi`3ooooo
ooooobKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool01oOg
knOWg]K>e_ooonoWilk>cZfe]@02W9bL00Z][JFm_KgNg]k>c/jm_KgNc/K>
e]jm_Kfe_Ljm_Kd2c/k>00nm_Kfe_Lk>c/k>a[G>e]jm_Kf]]KG>c]kNg/jm
_Kf]]KFm_Kf]]KFm_Kg>c/h00[fm_@04c/k>[JfU_Kfmc/kN0/k>c_oooooo
oooo9oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`07e]KW
c]K>ooooknOWW9bL_Kfm[JfU00:m_Kd01Jfe]Lk>c[fm_Kfm_LkFgP02[KFe
00J][JF]]KF][JF]]KFm_Kf][JD2_Kfm00SNg]jL[Kf][JG>a[G>e]j4U9B]
[JF]]KD2[JfU00[>c/jm_KfLW9bm_Kf<S8bLW9cNg]k>c/kNc/KWkoOooooo
ooooobKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool01_Og
knOWg/k>g_OgknoWimkNgP;WkoL01^oWinogmnoWinO_mnoWinogm`;_inL0
1<k>g^oWioOgklkFgP;Ng]h;knOW00KNg]k_inONg]kNg]k>c/kFc]H2c/k>
00C>e]k>c/k>c/kgknOoooooooooobKoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03
c<cooooooooo013oool01=KFilk>c_ooomKFi`G>c/h01=kNg/k>c/k>c^ON
gPC>c/h03<k>g/k>c/k>cXBDU;fm_Lk>c/kFg/k>c[fm_Lk>c[fm_Lk>gP;>
c/h01kfm_Lk>c[fm_Lk>c[fm_KF][Jfe]@02_Kfm00CNc/Jm_Kg>c/k_moOo
ooooooooobKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool0
1=kNg/k>c_ooolkFgP>][JD03IbLYHb<S<k>cYbLW:f]YKG6e[fm_HBDU:fU
U:f]YLk>cZfe]Lk>cP02[JfU00BLW9bm_Kg>c/j][JD2S8b<0136_KfLW9b<
S8bLW9bLW:F<S8bm_Kf<S8bLW9bDS8bLW9b<S8be_Ljm_KgNg/k_inOooooo
ooooobKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool01>og
mnoWilk>c^ogm`?_inL01MkNg^oWilk>c/kFc]kNgP05knOW00?Wimk_inO_
inL00^oWi`06e]KWg]kNc]K>knOWinONe]KW0lk>cP08_Kf]c/kNc/k>g/k6
]Kg>_Kfmc/k>]Kg>0kfm_@03_Kf]c]KNoooo0?oooooooooo9_ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`0Aoooo00?<c?ooooooool03oooo`04mnoWe]KWg]k>oooo1=kN
gP07c/k>g]kNc/kNg]kNg]k>g]kNc]KN00;Ng]h00lk>g]kNg]kNgP02g]kN
00[>c/k_inO>c]kNg/je_LkNc/J][JFLW:Fe_Lje[Jd2[JfU00>]]KF][JF]
[JD00Zf]Y@06W9bU[JfU[KFe_KfmknOWkoOgoooooooooolVoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo017oool00lc<ooooooooo`0@oooo00C_inO>c/k_moO>c/h2[JfU
00>LW:FLW9b<S8`00Zf]Y@0=Q9BDW9bU[JfU[JfUW9bU[JfUW9bUc/JeW9bU
S8b<W9bLc/k>S8b<00>LW9`01:f]YHb<S7]kNg]kN`9[Jf/02YbLW6][Jf][
Jg]kNhb<S5YJFYbLW:f]YLk>g^oWiooooooooooo9oooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0Aoooo00?<c?ooooooool03oooo`06inoginONc/k>ooooc/k>c]KN0mkN
gP0:_Kfmg]kNg]kNg]kN_Kfmg]kNc/k>c]K>g]kNinON0/k>cP03_Kfmc/k>
g]kN00;Ng]h03<k>c/kFg/k>c[fm_Jf]YIbLW8b<S7]kNhb<S7]kNg^4Q7]k
N`:<S8`00ibLW;fm_NoWi`3oooooooooobSoool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Ooo
o`03c<cooooooooo013oool01>OWg/k>c^ogmnoWi`CNg]h2_Kfm00SWimkN
g]kNg]kNg]kWimkFe^ONg]kFe^L6g]kN00S>c]kNg]kNc/K>c/jm_KfLW9b<
S8a[Lg<4Jf][00EkNg]kQ8BLW9bm_KgNg]h0oooooooooolYoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo017oool00lc<ooooooooo`0?oooo00[gmnoFe^O>e/kWkoO_inN<
S8b][JG>c/j4U9Be[Jd5W9bL00G>c/j]YIB][JF<S8bLW:D00Zf]Y@03W9bL
[JfUS8b<00:LW9`00g^4Q;fm_G]kN`03Jf][00><S8akNg^<S8`00Zf]Y@;>
c/h00mkNg_ooooooo`3oooooooooobSoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03
c<cooooooooo013oool01mkNg/k>c^ogmnoWilk>c/kFc^OWgP02g]kN00W>
e]k>c/k>c/k>e]k>c/kNg]k>c/k>c]kNg/h00lk>cP03[KFec/k>c/k>00;>
c/h01LJm_KFmcZf]YHb<S;fm_@04oooo00C_inONg]k>c/kNg]kooooooooo
ob_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool01mkNg/k>
c^oWinoWimkNg]KFinoWi`02g]kN00[Wg]k_inO_inO_inONg]k>c]kWimkN
g]kFe^O_inL6g]kN0lk>cP03[KFeU8b<c/k>00?oool2g]kN00?>c/kNg]ko
ool0ooooooooool[oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0?
oooo01SWkoOWimk>c/k_moO>a[G>S6?Nc[g_inON_Jg6Nd[>aZg>e]j][JF4
U9B]]KFLW9c>c/j]]KF]YIB4U9B]]KFLU8c>c/jLW:D4W9bL00Z][JEkQ8A[
Jf^m_Kgoooo_moOWimkNg]k>c/kNg]koooooooooobgoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool04Oooo`03c<cooooooooo013oool06<kFg/k>c^ogmnoWilJ]W=kNc^oW
ilJ]W<j<HnoWimKFikfm[Lk>cZfe]Lk>c]kNg/k6]KFmc/Jm_Lk6]KFmc/k6
]Jf]YJfe]@:m_Kd02YbLW:f]YHb<S7^4Q<k>c_ooonoWilkFg/k>c]kNg_oo
oooooooo;_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool03oooo`0=
koOgknOWc/k>knOWinONc]K>cZF4c/JeaW]:c[fUknOWinONc]KN00;_inL0
0nOWg]kNg]kNgP04g]kN00?>c]k>c/kNg]h00]kNgP09a[fm]Kg>[JfUS8b<
c/kNknOWg]kNc/k>g]kN0?oooooooooo;oooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo
00?<c?ooooooool04?ooo`09g]kNc/k>moO_e]KWknOWe[FLc/JeaW]:c]KN
00;_inL00nOWg]KFinOWgP05g]kN00C>c]kNg]kNg/kNg]h4c/k>0Zf]Y@05
S8b<g/k6g]kNc/k>g]kN0?oooooooooo<?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo
00?<c?ooooooool03oooo`03inoginONc/k>00?_inL00lk6]Lj<HljLN`02
knOW00?WimkNg]kNg]h00mkNgP08c]KNg]kNg]kNg]kNg]k>e/kFc/k>g]kN
0/k>cP:m_Kd2W9bL00?>e]k>c/kNg]h0oooooooooolaoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooo
oooo017oool00lc<ooooooooo`0@oooo00cNg]k>c/k_inO_inO>e]kWimje
Le[>aZg_inOWimkFe^OWimh5g]kN00KNg/k>c]kNg/k>c]kNg/k>c]h3c/k>
00Jm_Kf]]KFLW9bm_Kg>c/kNg]kooooooooooc;oool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
4Oooo`03c<cooooooooo00ooool01NogmnoWilk>c_OgklkFgP02knOW00C>
a[GWimkWimkFe^L5g]kN00O>c]kNg]k>e]kNg/k>c]kNg/k>e]h00lk>cP06
_Kfm[KFe[JfU[KFec/Jeg]kNoooooooooolcoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017o
ool00lc<ooooooooo`0@oooo00__inO>e]k_inOWimk>e]k_inOWimkFe^OW
imkNg]kWimh00mkNgP07g]k>g]kNg]k>e/kFg]kNc/k>c]KN00;>c/h01lk6
]KFmc[fm_Kfm[Jf]YJfe]MKFi`3oooooooooocCoool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
4Oooo`03c<cooooooooo013oool04>ogmnoWioOgkmKFinoWinOWg]KFinOW
g/kFg^OWg/kFg]kNg/kFg]kNg/kFg]kNgP;>e]h00lkFc/kFg/k>cP03c/k>
00Fm_Kf]]KF]]KG>c/k_inL0ooooooooooleoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017o
ool00lc<ooooooooo`0Aoooo3^oWi`08g]kNknOWknOWknOWg]kNknOWg]kN
knOW0]kNgP;_inOoooooooooocOoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<co
oooooooo0?ooooooooooH_ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?oooooo
ool0oooooooooomRoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`3o
ooooooooof;oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo0?oooooo
ooooH_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool0oooooooooomR
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
1oooo`03c<cooooooooo017oool00lc<ooooooooo`3oooooooooof;oool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo
00?<c?ooooooool04Oooo`03c<cooooooooo01Ooool00nogmoooonogm`02
oooo00?_moOoooooool00_ooo`03koOgooookoOg00;oool00nogmooooooo
o`3oooooooooocWoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo017o
ool00noWioOgknoWi`0KknOW00CFe^O_inO_inOFe^L6knOW00?_moOooooo
ool0oooooooooolVoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0@
oooo00kgmnoNg]k>c]jm_Kfe_Lk>a[Fe_Lk>a[Fe_Lk>a[Fm_Kfe_Lk>a[Fe
_Lh3_Kfm00O>c/jm_Kg6_Kfe_Lk>a[G6_Kfe_Lh00[fm_@05a[fm]Kg>_Kfm
a[fm]Kg>00>m_Kd02Lk>c[fm_Kfm_LJm_KFmc[fm_Lk>c/kFg^oWi`3ooooo
ooooobOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool01MkN
g/k>cZf]YJf]YIbLY@0AW9bL00>LW:F]YIBLW:D00YbLW007[JFDW9bUW9bL
W9bL[JfUW9bLW9bU00:LW9`00jf]YIbLW9bLW002[JfU00?>c/kNg]k_moL0
oooooooooolVoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0@oooo
00?_inONg]koool09_ooo`;Ng]h00noWioooooooo`3oooooooooobCoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo
00?<c?ooooooool04Oooo`03c<cooooooooo013oool00mkNg/kFc_ooo`0C
oooo00?gmnooooooool00_ooo`05inogooooooooooooknOW00;oool00noW
ioooonO_m`02oooo00C_moOooooWimk>c/koooooooooobOoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oo
ooooool04Oooo`03c<cooooooooo00ooool00nO_mnOWg/kFgP02oooo00?_
moOoooooool02oooo`03koOgoooooooo00?oool00nO_moooooooo`0:oooo
00O_inOooooooooooooNg]k>e]k_inL0oooooooooolVoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooo
oooo017oool00lc<ooooooooo`0@oooo00?Ng]kNc/Koool04Oooo`03koOg
oooooooo00;oool00oO_ioooooooo`02oooo00CWkoOooooooooWkoL5oooo
00G_inOoooo_inO>c/k_moL0oooooooooolVoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017o
ool00lc<ooooooooo`0?oooo00?gmnoWg]k>e]h03_ooo`03koOgoooooooo
00Coool00oOgkoooooooo`0:oooo00?_moOooooWkoL00_ooo`03g]kNc]K>
knOW0?oooooooooo9_ooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool0
4?ooo`03g]kNc/k>oooo00?oool02^oWilk>c^oWinogmoooonO_moooonoW
ilk>c^oWi`;oool00nogmoooomkNgP05g]kN00KFc]J4Ng>LJf>]Nf?>_JFD
S8`2[G]S00Zm_Kg>a[GNg/k>a[Fm_JgWkoOooooNg]k>c/k_moOooooooooo
obKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool01=KFimkN
c_ooonoWi`:m_Kd01Lk>cYbLW:fe]Lk>c^ogm`02[JfU0YbLW00MS8b<_Kfm
[JfUknOWooooinONknOWmoO_knOWmnoWinONg/k6DTY2Na08Q1P@[G]SU48a
LaP@W34QcZF4g]k>knO>g]k>c/JeknOWoooog]kNc]KNknOW0?oooooooooo
9_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool03oooo`03moO_inON
c]KN00;oool00mK>e]kNg^oWi`02g]kN00O_inOooooFe^O_inO>e/kNg]jm
_Kd00]kNgP;oool06<k>cXBDU9bLYIbLW7^4Q6]cLeY[JdXH67<H49`a8H@i
<F<H68@Q6:EcFZekHibLYIb4NiB<Hjfe]OOgkoooonoWilk>c^ogmooooooo
oooo9_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`03e]KW
e/kFoooo00Ooool00nogmoooooooo`02oooo00?WkoOoooooool00_ooo`0>
g/k6S8b<S8b<Jf][S8b<[JFDJf][DPP8Jc4YW34Q[G]SQ1P@Q24HJc4Y0TYB
FP08FUYJDTY2Jg=cknOWoooog]kNc]KNknOWoooooooooolVoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo017oool00lc<ooooooooo`0@oooo00GNg]k>e/koooogknN]]KD0
0[fm_@07]Kg>_Kf]knOWc/k>[JfUknOW[KFe00:m_Kd04mkNg[Fmc/k6]Ooo
olkFg[fm_Jf]YIbDS:fUU<k6]G]cHaP@45882:ekHha[BX@Q67/a:E8i<BTY
:@03>CTa00IJFT;_inOooooWimk>c/k_moOoooooooooobKoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oo
ooooool04Oooo`03c<cooooooooo00ooool0;NogmnOWg/k>c_ooonogmkfm
_Jf]YLk>g/k6]Lk>c^oWilk>c[fm_NoWijf]YKfm_Lk>c]kNg/k>cZfe]Ooo
omkNc[fm[Jf]YIbLW:fLQ<jmYG=[Hb4H459:@V=2>DXa:E8i<E8i:G]kNg^4
Q5YJFTYB>DY:<DYB>NoWioooomKFilkFc^oWi`3oooooooooobKoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool04Oooo`03c<cooooooooo013oool02=kNg/kFg_ooooooonog
moooonoWinO_m`Goool00nogmoooooooo`02oooo00W_inOoooo>c]jm_Jfm
_KfDS8acLeZ]W8AcJf<00U8i<@0?@RTQDSTaFT8iDSTaS8acS8b<Ng]kJf=B
Jf]:FV=JknOWooooinONc/kNmoO_0?oooooooooo9_ooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0Aoooo00?<c?ooooooool03oooo`;_inL00mK>e_ooonoWi`02c/k>00VL
W:F]YIBe_Lk>a[GNg]k>e]k>c/kNg]k>e]h00/k>cP0<a[fmc]KNooooc/Je
S8b<S8acFUY2S8b<c/JeLf]SDTY2<AP@0U8i<@04LeYBDSTaFUY2Ng=S0V][
BP07FUY2Jf]:knOWkoOgknOWc]K>knOW0?oooooooooo9_ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0Aoooo00?<c?ooooooool04?ooo`06g]kNc]K>oooooooo[JfU[KFe
1;fm_@06g]kN_Kfmc/Jec]KNc/Je[KFe0[fm_@0A[JfUoooo[KFeBTY:DTY2
Jf=BS8acW8AkFUYJDSTY@RTQJdY2FUY2LeYBHeY::BTH>CTH009JDRT01STi
67]SB^oWioooomkNg/k>c_oooooooooo9oooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo
00?<c?ooooooool03oooo`06koOginONc/k>ooookoOgknOW2Oooo`0NknOW
inONooookoOgknOWoooo[JfU:C4Y:BTHBTXY[JFDa[fm>CTa@RTQDSTaDTY2
NeY:Jf=BFT8i:BTHBS4YBTXYLg=JBS4YDV=2e]KWooooinONc]KNknOWoooo
oooooolVoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0@oooo00[N
g]k>e]koooo_inO>e]kNg]k>c/kNg]k>c/k_inL2c]KN023_inONg]k>e]k>
c/kFc]K_inO>e]k_moN]YI@0000Y:APi8ARLU8c>aZekLf<Y:AQ2:B6]Nf>D
JeY[<BTi>APY:APa>B5:BRU:BS4i>AQ:BS7_inO_moO_inO>c/k_moOooooo
ooooobKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool0;Nog
mnoWilk>c_ooomkNg[fm_Jf]YJfe]Jf]YIbLW;G6eZf]YKfm[LkFg/k>cYbL
YJf]YKfm_LkFc[fm_NoWijf]YA0002TY634i8Kfm[Mk>_Hb<LbTY67=JDZek
HlJ]W8AkLc4i8AP@43Ti64YB>DYJ@RTY:CU2<NoWioooomKFilkFc^oWi`3o
ooooooooobKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool2
knOW00?>e/koooooool00nogm`04moO_c]KNinONknOW1^ogm`?oool06:f]
YBTY62TY62TY68b<LljmYDYJ@RTY63TQ67]SBXa[BUYJ@SU2<BTa:BTQ24YB
>HBDU7^4Q5YSF^oWinogmnOWg/k>g_Ogkooooooooooo9_ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0Aoooo00?<c?ooooooool04?ooo`03g]kNc/kNoooo00C_inL01=KF
inoWinOWg]KFi`K_inL01MKFioO_ioooojf]YC4i8@02BUY200VDS6>m_Jf]
]KE[Lg<@40Pi8APa610H411JJf/00UYSFP09Hg><[KFeW;GNYKG>knOWkoOg
g]kNc]K>knOW0?oooooooooo9_ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?oo
ooooool04?ooo`06g]kNg]k>ooooc]KN_Kfm]Jf]0Zf]Y@0ES8b<]Kg>_Kf]
W9bU[JfU[KFe_Kfm[JfU[KFe[JfUinogooooc/k>Hg><NhB4Jf=BNg]k_Kf]
[JFDS8b<:BTY008000003DYBFYbegZFecYbegZFmgYbeikG6eYbeg^oWioOg
kmkNg/k>c^ogm`3oooooooooobKoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<co
oooooooo013oool01MkNg/kFg_ooonoWimkNgP02koOg00?_inO>c/k_moL0
0^oWi`03c/k>knOWc]KN00;_inL01>O_moO_ioOgkmKFi`:L[Kd01YbLYJf]
YKfm_KFmc[G6eZFecP9SLh`6W;GN00NL]NNU]Lk_inOooooNg]k>e]k_inL0
oooooooooolVoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0?oooo
0^oWi`05c]K>ooooknOWknOWkoOg00;_inL00jfe]NoWinogm`05knOW00GW
koOgknOWkoOoooo>e]h00Zfmi`03[LKgW:fmc/J]00>L]NL01Jg6kibeiibe
gYbegYbei`05W;GN00G>e]k_moONg]k>c/k_moL03Oooo`<000000oooo`00
0?ooo`02oooo0P000005oooo0000oooooooo000000?oool200000oooo`05
0000oooooooooooo000000?oool00`000?ooooooo`02oooo00@0003ooooo
ool00003oooo00D0003oooooooooool000000oooo`<0003oooooh_ooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`08inONc/kNooooc]KN
W9bLc/Je]Kg>[KFe0Zf]Y@03W9bU[JfUW9bL00;>c/h04:fe]Jf]YHb<S<k>
c_oookG6eYb]gYbegYb]gYb]_Jf]YIb]gYb]cYbegYb]gYb]cP:L[Mh01Yb]
cYb]gYb]gYb]cYb]gYb]cP;_inL00mkNg/kFc^oWi`0<oooo00D0003ooooo
ooooool000000oooo`030000oooooooo00800002oooo00@0003oooooool0
0002oooo00@0003oooooool00002oooo00<0003oooooool00_ooo`030000
oooooooo00;oool010000?ooooooo`0000?oool01@000?ooooooooooo`00
0002oooo00D0003oooooooooool00000ooooon7oool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
4Oooo`03c<cooooooooo00ooool02>ogmmkNg]kNc_ooonoWilkFg^oWioOg
k`?_inL01LkFg^oWinOWg]KFinoWi`03g]kN00G_inO_moO_inO>e]kNg]h0
0/kFgP04g/k6e]KWg]kNe]KW0/kFgP03g]kNc]KNc]KN00C>e]h01KG6e^oW
ioOgklkFg/k>cP0<oooo00<0003oooooool00P000005oooo0000oooooooo
000000?oool010000?ooooooo`0000;oool00`000?ooooooo`03oooo00@0
003oooooool00004oooo00<0003oooooool00_ooo`040000oooooooo0000
0oooo`050000oooooooooooo000000;oool00`000?ooooooo`3ooooohooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`;Ng]h03_ooonoW
ioooooooomKFilk>c^oWioOgkoooooOgknO_mnoWikfm_MkNgP;oool02^O_
mnoWinogmoooonoWioooooO_ioooonO_mnogm`;_inL01?ooonoWinO_moOg
k`;_inL00mkNg^oWinogm`02knOW00?Ng]k>e/k_inL02oooo`030000oooo
oooo00?oool010000?ooooooo`0000?oool010000?ooooooo`0000;oool0
0`000?ooooooo`03oooo0`0000Goool00`000?ooooooo`02oooo00@0003o
ooooool00003oooo00D0003oooooooooool000000_ooo`D0003ooooohOoo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0Aoooo2/c<o`Soool2knOW013>e]koooo_moN][JFm
_Kg>c/j<S8b][JFe_Lk_inNLW9b][JF<S8b4U9BDS8b]]KD2[JfU00W>c/k_
inOWkoONg]jLW:G>c/j]]KF][JFLW9`00/k>cP08W9bLg]kN[JFDc/kN[JfU
W9bUQ9BDc]K>0^oWi`04koOgc/kNc/k>koOg2oooo`030000oooooooo00?o
ool010000?ooooooo`0000?oool010000?ooooooo`0000;oool00`000?oo
ooooo`03oooo00<0003oool000001Oooo`030000oooooooo00;oool01000
0?ooooooo`0000?oool01@000?ooooooooooo`000002oooo00D0003ooooo
ooooool00000ooooon7oool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo
013oool01MkNg/kFc_ooonoWilk>cP03g]kN00[>e]k_inO_inONg]k>e]k>
c/kFc]J]]KGNg/k>e]h2c/k>00Ooooo_inN]]KF<S8bm_Kf][JGNg]h00/k>
cP09g]kNc/k>g]kNc/k>g]kNe/kFc]K>c/k>e]KW00?_inL00mkNc/kFg^oW
i`0;oooo00<0003oooooool00oooo`040000oooooooo00000oooo`040000
oooooooo00000_ooo`040000oooooooo00000_ooo`040000oooooooo0000
1?ooo`030000oooooooo00;oool00`000?ooooooo`0200000_ooo`800002
oooo00@0003oooooool00003oooo00<0003oooooool0ooooomooool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool04Oooo`03c<cooooooooo013oool01>OWg/kFg_ooonogm`?o
ool01NoWioooonO_moooooO_i`03oooo00S_inO_moO_inOoooo_inOooooN
g]k>c/h2g]kN00[_inOooooWkoOoooo_inOWkoOgknOWkoO_inOWkoL4knOW
00GFe^O_inO>e]kNc/K_moL02oooo`030000oooooooo00?oool010000?oo
ooooo`0000?oool010000?ooooooo`0000?oool200000oooo`050000oooo
oooooooo000000?oool00`000?ooooooo`02oooo00D0003oooooool0003o
ool00P0000;oool200001?ooo`<0003oooooh_ooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0A
oooo00?<c?ooooooool04?ooo`05e]KWc/k>ooooknOW[JfU00:]]KD02Kfm
_Jfe]MkNg[fm_Jfe]NOWgZf]YKFmcZf]Y@02c/k>00Ne[Jfm_Kf]]KFLW9b<
S8bm_Jg>c]h00Zfe]@:][JD01/k>g[fm_Jf]YKfm_Lk>cZf]Y@:]]KD2[JfU
00G>c/k_inO>e/k>c/kWkoL03?ooo`050000oooooooooooo000001?oool0
0`000?ooooooo`05oooo00<0003oooooool0ooooooKoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool04Oooo`03c<cooooooooo00ooool02?OgknOWg]kNg_ooonoWijfe]Jf]
YLk>cP:m_Kd01=kNg/k>cZf]YMKFi`:][JD01/k>c]kNg[fm_IbLW<k>c/Jm
_@:m_Kd02/k>c]kNgZfUU:fe]Lk>c[fm_Lk>cZf]YKFmc/k>cP:m_Kd01Zf]
YLk>c[fm_Jf]YKfm_NoWi`;>c/h00oOgkoooooooo`0;oooo0`0000_oool0
0`000?ooooooo`06oooo00<0003oooooool00_ooo`L000000oooo`000?oo
o`3oooool_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`04
e]KWc]K>ooookoOg0noWi`06g]kNooooooooknOWooookoOg0^oWi`06oooo
moO_moO_e]KWmnoWinog0_Ogk`03inogkoOgknOW00;_inL01^O_mnoWimkN
g^O_mnoWilkFgP?_inL01mKFimkNg]kNg^OWg/k>c/kFg^oWi`3ooooooooo
obKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool01oOgknOW
g]K>e_ooonoWilk>cZfe]@02W9bL00Z][JFm_KgNg]k>c/jm_KgNc/K>e]jm
_Kfe_Ljm_Kd2c/k>00nm_Kfe_Lk>c/k>a[G>e]jm_Kf]]KG>c]kNg/jm_Kf]
]KFm_Kf]]KFm_Kg>c/h00[fm_@04c/k>[JfU_Kfmc/kN0/k>c_oooooooooo
9oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`07e]KWc]K>
ooooknOWW9bL_Kfm[JfU00:m_Kd01Jfe]Lk>c[fm_Kfm_LkFgP02[KFe00J]
[JF]]KF][JF]]KFm_Kf][JD2_Kfm00SNg]jL[Kf][JG>a[G>e]j4U9B][JF]
]KD2[JfU00[>c/jm_KfLW9bm_Kf<S8bLW9cNg]k>c/kNc/KWkoOooooooooo
obKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool01_OgknOW
g/k>g_OgknoWimkNgP;WkoL01^oWinogmnoWinO_mnoWinogm`;_inL01<k>
g^oWioOgklkFgP;Ng]h;knOW00KNg]k_inONg]kNg]k>c/kFc]H2c/k>00C>
e]k>c/k>c/kgknOoooooooooobKoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<co
oooooooo013oool01=KFilk>c_ooomKFi`G>c/h01=kNg/k>c/k>c^ONgPC>
c/h03<k>g/k>c/k>cXBDU;fm_Lk>c/kFg/k>c[fm_Lk>c[fm_Lk>gP;>c/h0
1kfm_Lk>c[fm_Lk>c[fm_KF][Jfe]@02_Kfm00CNc/Jm_Kg>c/k_moOooooo
ooooobKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool01=kN
g/k>c_ooolkFgP>][JD03IbLYHb<S<k>cYbLW:f]YKG6e[fm_HBDU:fUU:f]
YLk>cZfe]Lk>cP02[JfU00BLW9bm_Kg>c/j][JD2S8b<0136_KfLW9b<S8bL
W9bLW:F<S8bm_Kf<S8bLW9bDS8bLW9b<S8be_Ljm_KgNg/k_inOooooooooo
obKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool01>ogmnoW
ilk>c^ogm`?_inL01MkNg^oWilk>c/kFc]kNgP05knOW00?Wimk_inO_inL0
0^oWi`06e]KWg]kNc]K>knOWinONe]KW0lk>cP08_Kf]c/kNc/k>g/k6]Kg>
_Kfmc/k>]Kg>0kfm_@03_Kf]c]KNoooo0?oooooooooo9_ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0Aoooo00?<c?ooooooool03oooo`04mnoWe]KWg]k>oooo1=kNgP07
c/k>g]kNc/kNg]kNg]k>g]kNc]KN00;Ng]h00lk>g]kNg]kNgP02g]kN00[>
c/k_inO>c]kNg/je_LkNc/J][JFLW:Fe_Lje[Jd2[JfU00>]]KF][JF][JD0
0Zf]Y@06W9bU[JfU[KFe_KfmknOWkoOgoooooooooolVoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooo
oooo017oool00lc<ooooooooo`0@oooo00C_inO>c/k_moO>c/h2[JfU00>L
W:FLW9b<S8`00Zf]Y@0=Q9BDW9bU[JfU[JfUW9bU[JfUW9bUc/JeW9bUS8b<
W9bLc/k>S8b<00>LW9`01:f]YHb<S7]kNg]kN`9[Jf/02YbLW6][Jf][Jg]k
Nhb<S5YJFYbLW:f]YLk>g^oWiooooooooooo9oooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0A
oooo00?<c?ooooooool03oooo`06inoginONc/k>ooooc/k>c]KN0mkNgP0:
_Kfmg]kNg]kNg]kN_Kfmg]kNc/k>c]K>g]kNinON0/k>cP03_Kfmc/k>g]kN
00;Ng]h03<k>c/kFg/k>c[fm_Jf]YIbLW8b<S7]kNhb<S7]kNg^4Q7]kN`:<
S8`00ibLW;fm_NoWi`3oooooooooobSoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03
c<cooooooooo013oool01>OWg/k>c^ogmnoWi`CNg]h2_Kfm00SWimkNg]kN
g]kNg]kWimkFe^ONg]kFe^L6g]kN00S>c]kNg]kNc/K>c/jm_KfLW9b<S8a[
Lg<4Jf][00EkNg]kQ8BLW9bm_KgNg]h0oooooooooolYoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooo
oooo017oool00lc<ooooooooo`0?oooo00[gmnoFe^O>e/kWkoO_inN<S8b]
[JG>c/j4U9Be[Jd5W9bL00G>c/j]YIB][JF<S8bLW:D00Zf]Y@03W9bL[JfU
S8b<00:LW9`00g^4Q;fm_G]kN`03Jf][00><S8akNg^<S8`00Zf]Y@;>c/h0
0mkNg_ooooooo`3oooooooooobSoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<co
oooooooo013oool01mkNg/k>c^ogmnoWilk>c/kFc^OWgP02g]kN00W>e]k>
c/k>c/k>e]k>c/kNg]k>c/k>c]kNg/h00lk>cP03[KFec/k>c/k>00;>c/h0
1LJm_KFmcZf]YHb<S;fm_@04oooo00C_inONg]k>c/kNg]koooooooooob_o
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07
oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool01mkNg/k>c^oW
inoWimkNg]KFinoWi`02g]kN00[Wg]k_inO_inO_inONg]k>c]kWimkNg]kF
e^O_inL6g]kN0lk>cP03[KFeU8b<c/k>00?oool2g]kN00?>c/kNg]koool0
ooooooooool[oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0?oooo
01SWkoOWimk>c/k_moO>a[G>S6?Nc[g_inON_Jg6Nd[>aZg>e]j][JF4U9B]
]KFLW9c>c/j]]KF]YIB4U9B]]KFLU8c>c/jLW:D4W9bL00Z][JEkQ8A[Jf^m
_Kgoooo_moOWimkNg]k>c/kNg]koooooooooobgoool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
4Oooo`03c<cooooooooo013oool06<kFg/k>c^ogmnoWilJ]W=kNc^oWilJ]
W<j<HnoWimKFikfm[Lk>cZfe]Lk>c]kNg/k6]KFmc/Jm_Lk6]KFmc/k6]Jf]
YJfe]@:m_Kd02YbLW:f]YHb<S7^4Q<k>c_ooonoWilkFg/k>c]kNg_oooooo
oooo;_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool03oooo`0=koOg
knOWc/k>knOWinONc]K>cZF4c/JeaW]:c[fUknOWinONc]KN00;_inL00nOW
g]kNg]kNgP04g]kN00?>c]k>c/kNg]h00]kNgP09a[fm]Kg>[JfUS8b<c/kN
knOWg]kNc/k>g]kN0?oooooooooo;oooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<
c?ooooooool04?ooo`09g]kNc/k>moO_e]KWknOWe[FLc/JeaW]:c]KN00;_
inL00nOWg]KFinOWgP05g]kN00C>c]kNg]kNg/kNg]h4c/k>0Zf]Y@05S8b<
g/k6g]kNc/k>g]kN0?oooooooooo<?ooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<
c?ooooooool03oooo`03inoginONc/k>00?_inL00lk6]Lj<HljLN`02knOW
00?WimkNg]kNg]h00mkNgP08c]KNg]kNg]kNg]kNg]k>e/kFc/k>g]kN0/k>
cP:m_Kd2W9bL00?>e]k>c/kNg]h0oooooooooolaoooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo
017oool00lc<ooooooooo`0@oooo00cNg]k>c/k_inO_inO>e]kWimjeLe[>
aZg_inOWimkFe^OWimh5g]kN00KNg/k>c]kNg/k>c]kNg/k>c]h3c/k>00Jm
_Kf]]KFLW9bm_Kg>c/kNg]kooooooooooc;oool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Ooo
o`03c<cooooooooo00ooool01NogmnoWilk>c_OgklkFgP02knOW00C>a[GW
imkWimkFe^L5g]kN00O>c]kNg]k>e]kNg/k>c]kNg/k>e]h00lk>cP06_Kfm
[KFe[JfU[KFec/Jeg]kNoooooooooolcoooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool0
0lc<ooooooooo`0@oooo00__inO>e]k_inOWimk>e]k_inOWimkFe^OWimkN
g]kWimh00mkNgP07g]k>g]kNg]k>e/kFg]kNc/k>c]KN00;>c/h01lk6]KFm
c[fm_Kfm[Jf]YJfe]MKFi`3oooooooooocCoool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Ooo
o`03c<cooooooooo013oool04>ogmnoWioOgkmKFinoWinOWg]KFinOWg/kF
g^OWg/kFg]kNg/kFg]kNg/kFg]kNgP;>e]h00lkFc/kFg/k>cP03c/k>00Fm
_Kf]]KF]]KG>c/k_inL0ooooooooooleoooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool0
0lc<ooooooooo`0Aoooo3^oWi`08g]kNknOWknOWknOWg]kNknOWg]kNknOW
0]kNgP;_inOoooooooooocOoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooo
oooo0?ooooooooooH_ooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool0
oooooooooomRoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`3ooooo
ooooof;oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo0?oooooooooo
H_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`3oooooooooogKoool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0oooo
oooooomfoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo00goool01no_kjf][EY[HibLW>O6a^OW
ioOgm`04oooo00?_ooogmoOoool0oooooooooomKoooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo
00coool02mkNiiB<S10H44Y:BRTQ8JecNg]kNiB<S:f][MJma^o_k`3ooooo
oooooeooool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool02oooo`0Aino__Kfm:C4Y_LJmoooo>APQ
cXB<cW=kaV]c[F][W6=[S6]cW8b<_KFee]KFkno_moOg0?ooooooooooF_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0:oooo00CgmoOFc]JLU9`a>CT2oooo00mkDU[>NhCo
NiC_LhcWNhC>Lg^mJg>UHf^UHf>DJg>4Q8BLW9bm_KgNg]kgknl0oooooooo
oomGoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH01oooo`03c<cooooooooo00[oool01>OWilK>cXbDS5YJFP;oool017=J
HlikU?n<[On<Y@;oQ9`2mg^<00__Hg_WFW?6Jg>]Jf^UHf>DJg>DQ8BU[JG6
c/kNknogmoL00_ooo`03kooooooooooo00Coool00nooooooooooo`3ooooo
ooooodOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool02_ooo`04mnOWe]KNYJfUJg=[0_ooo`0G
Jg=[gXb]ojG>ojG>miBmoiBemiB]ohbUkhbLohBLkhBDgW^<eW>4cW=k_F]c
[F][YF=SYF][W8B<]IbLc/K>inOWoooo00?_ool;oooo00?_ooogmoOoool0
oooooooooolnoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo00[oool02oO_knO_kjf][F]SHnON
imKNgV=:D/IcU?nD]OnL_OnUaP02ojG>01CoYLKgU;g_U;goS:goS:GgNiCg
Q9CgNhcWNhC_Hg_WJg^eLg>UJg>LHf^DJg>LS8bm]KG>g]KWmoOgmoL7oooo
00?gmoOoooooool0oooooooooom1oooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00coool03Kfm
_F]cJnONilkFeV]JF/IcU?M[Q?McS?McU?N4YOnD]OnL_OnUaP02ojG>01Oo
W;goU;GoS:goS:goQ9cgNiCgLiC_Q9CWNhCFLg_>Hg?6Lg>ULg>LJg>LLg^]
YJFm_KgWg]kgmoO_ooooooogmoO_ool01oooo`03moOgoooooooo0?oooooo
oooo>_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0<oooo00S6a/J4Q8CgmoOWknn<Ng_NS:go
U;GoS:d2mg>D00C_LhcgLiCoQ9coS:D2ojG60_neeP0DojG>ojG6miBmkhbe
mg^DohBLmg><mg^<mg^Dkf^4eW=kcV=c]G=cYF]cYG=cYG]k]IbL_KfminOW
kooooooooooooom4oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00coool01/kFcXB4Q>oWknOW
iiB4Q=j<[@;oW;d01?nD]On<[On<YON4Y@;gNi@01]ikU?n4W?nD[OnD]OnU
a_nUcP;o]MH01OnUc_nUa_nD]On<YOMkU003mg>D00ggNhcWNhCFLg_6Jg>e
Lg>]Jf^ULg>UNg^e[JgFc/kWinOgmoOoool00noooooooooooooo??ooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0<oooo00Jma/IkNg_Fc]K>c/i[Lf_>Ni@3ohb]00?oU;Go
W;goW;d00_NL_@;oS:d02OND[ON4YON4YOND[On<[OnD]OnUa_nee_nUcP02
ojG600WoW;ggU:ggQ:GoQ9coNiCgNiCgQ9CWNhcNNh@00/iSL`09YG=kW6]c
W7=k[HbD_KFeg/kFmno_ooookooo0?oooooooooo>oooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0<oooo00K>e/j<S8c_inoNinNDLg_>Ni`2ohb]0_N4Y@08ohb]oiBeoibm
oibmojG6ojG>ojG6oibm0_nD]@09ohbUohBLkg^UmhbUoiBemibmojG6ojg>
ojG600;oW;d04^n<]ON4YNmkYOn4W>mkYOMkU>n4U>MkS=IcNlIcNkE[NjE[
LiA[LiakNjf<U<K6a]KFe_O_kooooooooooo>Oooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0<
oooo00[Fa/j<S8c_ooo_knnLU9beW9coYLkoYLKoW;goU;D3oiB]017oU;G_
YLkgW;gg[LKoYLko[LkoYLkoYLKoW;goU;GoS:goS:G_NjGgNiCgQ:GoS:go
U;D00onL_@0DoiBeohb]ohbUohbUmhBUmg^Dmg>DkhBDkg^<ig><gV]kcV=c
cUY[YF][W6]cW7=k]IbLe[g6g]kNkoOg0^ooo`;oool01>ooooooooooonoo
oooooooooooo;Oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Ooool00lc<ooooooooo`0:oooo00__ooooooo>c/j4Ng_N
inOFe]JLQ8bLS9Co]MKoYLko[Lh00_nUaP04ojg6oibmoibmoiB]0onD]@04
ojG6mjg6ojg>ojG>0_nUaP;oW;d02?nD]NmkYNmkYNN<W>McS>n4U?n<YOn<
[@;oU;D2ohb]0_n<Y@06ohBLmg^DmhBDmg^DkhBDkg^<0/ikQ00:]F]kYF]c
YF]cU7=k[HbD_JFUc/k>imkNooookooo0_ooo`03kooooooooooo0?oooooo
oooo:oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0<oooo00[Fc/j4Ng_NinO>c/jDS8bLLg__
YLk_[LKgW;go[LH2ojg>1?neeP04ojg>ojG6oibmoiBe0_nL_@05mjg6ojG>
ojG>ojg6ojG600;oW;d02?nD]On<YOn4W=ikU>mcS>McS?MkU?n<Y@?oS:d2
ohbU0_n4W008mg^DmhBDmg>DohBLgW^Dig^<cW^4_F]c0[EcL`07U7=k[HbD
olkNkooomoOgooookooo0?oooooooooo;Oooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0<oooo
00OFc/j<S8c_moOWinN]YJFDLg_oYLH00_NL_@05oiBeoibmojG6ojg6ojg>
00;g_Mh3okGN00?o]MKo[LkoYLH00_NL_@CoU;D2oibm0_nD]@04ohb]ohBL
mg^Dmg><0nMSQ004kg><mg^DohBLohb]0_n<Y@?oQ9`2og^D00CoQ9CgQ9C_
NhcWNh@2aW^<00?_YKGoooo_ool0ooooooooool_oooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo
00coool02Lk6cXB4Q?OgmnoWkkfe]IAcNoo>konme_n]cP02ojg600?g[Kgg
W;gg[LH00_n]cP0=okg>okGNolKWolKWmlKWmkgWokGFojg>ojG6mibmoiBe
miB]ohbU00;oS:d2oiB]00KoU;GoS:goS:GoQ9coNiC_Lh`2if>400CNFW_W
HhC_LhcgNi@7ohBL0_mkU004khbLgW^<gW^DknO_ooooooooool`oooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03
c<cooooooooo00[oool02>ooooooomK>cXAkNmkWimKFe[fe]G]SL`Co]Mh0
1?o6g_neg_nme_NmeP;o[Lh2mjG>00Go_MKo]Mko]Mko]Mkoa^L00_negP;o
]MH01On]c_NL_ONU]ON4YON<Y@02mhBU0on<Y@;oQ9`05?mkU?MkU>mcS>MS
Q>MSNmiJNmiJLnm[Q>mcS?MkU?n4U?n4W?n<YOn4W?n<YOMkU?McU>M[S>oN
g^oooooooooooooo;oooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0<oooo00KFc/j4Ng_NinO>
e]Jm]KEcDUX2mkgF00GgYLko]MKo]Mko]Mkoa^L00_o>k`03olKWokGNokgF
00?o[Lh01On]a_Nme_Nme_Nme_neeP02okGN0_neeP08ojG6oibmmiB]khbL
khBDmg>Dkg><kg^<0_n4U0?oNi@01OMcS>mcS>m[Q>MJLmiSL`02gUYc00?W
Hg__LhcgLh`00_n<Y@;oJh`00mk>e_OgmoOgm`3oooooooooobkoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool03?ooo`09e/k>S8b<ooookno_e[g6Ne9JolKWokgFojg>00;o
[LH01?N]a_nee_neg_negP;oa^L00ooFkoo>koo>k`02mlKW00Co]MKo[Lko
[LKg[LH2ojg60_n]cP;oYLH01onL_OnD]OnD]On<YOn4W?McU>M[N`02kf^4
00?WNhCgNhcoNi@00omkU003mf^4mg><kf=k00?NFW<01NmcS?McU?mkU?n4
W?NmeP02koooooooooooool^oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00_oool02?OgmmK>
cXakQ?OgmoO_knOWieYSF_o>m`?oa^L01?o6g_nee_Nmc_neeP;g_MH2okGN
00koa^Ooc^ooe^ooc_Ooc^ooa^Oo]Mko_MKo[LkoYLKgW;ggYKGoW;ggYKD3
oibm00OoU;GoU:goS:GoQ9cgNiC_NhcWHh@00^MSN`03if]kkf=kkg><00;g
Lh`02NmcS?McS>m[Q>m[Q?McS?mkU?N4YOMkU?nmeP3ooooooooooc3oool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo
00?<c?ooooooool03?ooo`08c/k>Q7]kimkNg/kFe/K>@T92olk_mkgN0_o6
i`;oc^l01Oo6ioo>koo6ioo6g_NmgP02mkgF0_NmgP?oa^L02?o>koo6ioo6
g_o6e_n]c_n]a_N]_OnL_@;gU:d01?NDYOND[On<[OND[@?oS:D02On4W?Mk
U>mcS>m[Q>MSNmiJLmiSLnMSNnm[Q003mg><0_n4W005mhbUmg^Dokg>oooo
kooo0?oooooooooo;_ooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0<oooo00OFe]J<S8cgknoW
g]kNe]I2>CWoa^L01?NmgP07olKWolk_omK_omkgolkgomK_olk_00;oa^L2
mkgN00?g_NOg_Mkg_Mh01?negP0:okgFojg>ojg6oibmmjFeohb]mhbUkhbL
khBDmg^D1On4W0;oNi@03?McS>mcS>M[NmiSLliSLmiSLnM[NnmcS?n<YON4
YOMkU?nme_oooooooooo<?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool200003Oooo`0;c/k>S8b<oooomno_imkW
BSU2olkgolKWolkNmkgNmkgF00?g_Mh00oo6iooFkooNm`02omkg00Ooe^oo
c_Ooe^oge^oga^Og_Mk__MH00_NmeP;o_MH02_nee_n]c_n]c_n]c_n]a_NU
]OnD[ON<YON4U>n4U0;_Lh`04^McS>mkS?MkU?N4U?n4W?N4U?McU>mcS>m[
Q>MSQ=i[Nnm[Q?n<YON<YOMkU?nme_ooonoooooooooooooo;_ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool20000
3Oooo`07c/k>S8b<moOgmno_inOWBTY:omkg00;oc_L01OoNmoo6ioo>koo6
ioo>gP03mlKW00Goa^Ooe^ooc_Ooc_Oog_L00oo>m`;oa^L00oNmg^n]c^n]
cP02mjg600?gW;goW;gg[Kd00_nL_@0>mjFeoiBeoiB]khbLkhBDig^<if>4
ig^4if>4ig^4kg><khBDohBLmhBD0_MkU005mhBDohb]mhbUohbUokg>0?oo
oooooooo<?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV00Ooool200002oooo`09koooooooc/k>Ng]kkno_g]kNe]KF@T92
mlKW00;oe^l01oo>mooFkooFkooNmoo>mooNmoo>m`02omK_0oOFk`0AomK_
omkgomK_omK_olkgomK_olk_olKWolKNojg>mjg6kjFmkibemiB]mib]miBU
ohbU00?oU:d2ohbU00GoQ9cgNiC_NhcWHhCWNh@00]i[N`08ig^4ig><mg^D
ohBLohbUkg^UohbUmkG62?ooo`040000oooooooo00000_ooo`040000oooo
oooooooo0P000003oooo0000oooo00;oool200001Oooo`<00005oooo1000
00Goool00`000?ooooooo`03oooo00<0003oooooool0ooooooGoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo0P00
00goool01lkFeXb<S?ooonOWimkFeUYJF_NmcP02olKW00Gga^Oge^Ooc^oo
e^ooc_L02?oNm`;oa^L03_O6ioOFioo6iooFkoo6ioo>koo6ioneg_nmc_n]
a_N]_OnD]ONDYNn<W0;WS9@00nn<W?n4W>n<W003khbL00GoQ9CgQ9C_NhcW
LhcWNh@00]i[N`05ig><ohbUmiB]ohbUmjfm00Soool010000?ooooooo`00
00;oool010000?ooooooo`0000;oool200000_ooo`040000oooooooo0000
0oooo`050000oooooooooooo000000?oool00`000?ooooooo`02oooo00<0
003oooooool00oooo`050000oooooooooooo00000?ooooohoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01_ooo`@0000<
oooo00O>c/j<S8coooogmoOWinMcHf___MH00_oFk`05olKWomK_mlKWmlKW
mmK_00;oe^l7omkg00?oe^ooa^Og_Mh00_NmeP05mkgNmkgFokGFokGFokgF
00;o[Lh02?n]a_nL_ONU]OnD[On<YNn<W>N<U>MkS0;_Q9@01?n4W?N4U>n<
W?n4W0;gQ9@2kg^<00GgQ9CoS:ggU:goS:g_YKd02?ooo`070000oooo0000
oooo0000oooo000000;oool01@000?ooooooooooo`000002oooo00<0003o
ooooool00oooo`030000oooooooo00?oool010000?ooooooo`0000Coool0
0`000?ooooooo`03oooo00@0003oooooool0003ooooonOooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Goool00`0009VI
c9VIc002VIW<00<0003oooooool02Oooo`07c/k>Q8B4kno_inOWg]kNS9B<
_Ibe00Oog_L01OOWkooFkoOFkoOFkooFk`07omkg00Ooc_Ooa^Og_Mkg_MKg
_Lkg]LKg[LH00_N]_@03ojg6mjfmmjfm00;gYKD01_NL[ONDYONDYNn4U>Mk
S=ikS0?WNh`02Nn4U?N4U>n4U>n<W>nDW?nD[On<YNnL[OnD]@08oooo00L0
003oool0003oool0003oool000000oooo`@00002oooo00<0003oooooool0
0oooo`030000oooooooo00?oool00`000?ooooooo`05oooo00<0003ooooo
ool01?ooo`030000oooo00000?oooooioooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01?ooo`040000IVJIVIW<c<co0_oo
o`03VIW<0000c<co00C<c?l5oooo00OFe]J<S8c_knoNg]k6a/J<NhBLU9`0
0ooFk`_og_L00ooFkooNmooFk`04omK_0_o>k`04olKNokgFojg>ojg60_NU
]@CgW:d4oiB]00GoS:GoQ9c_Q9C_NhcWNh@00]ikQ009ig^4kg^<mhBDoiBe
ohbUkib]oiB]oooomoOg00Koool01`000?ooo`000?ooo`000?ooo`000006
oooo00@0003oooooool00005oooo00<0003oooooool00oooo`040000oooo
oooooooo100000Soool00`000?ooooooo`3ooooon?ooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Coool00`0006IVVLc<
o`02000000?ooonIVL`000002_ooo`07c/k>S8b<ooookno_e]KFYJFUU7=k
00;og_L00ooFkoo>mooFk`0;omkg00?oe^oge^ooa^L00_o6i`06olk_olKW
olKWolKNolKFokgF0_n]aP04mjFeoiB]miBUkiBU0^n<W004kiBUmhbUohbU
miBU0_n<Y@0:kiBLkhBDkg^<ig^<gW^<ig^<oiBeohbUkib]oiBe2?ooo`07
0000oooo0000oooo0000oooo000000;oool01@000?ooooooooooo`000002
oooo00@0003oooooool00002oooo00<0003oooooool00oooo`040000oooo
oooo00002oooo`030000oooo00000?oooooioooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01?ooo`030000IVJIc<co0080
00000lc<oiVIc000000:oooo00O>c/j4Q8CoooogmoO_kno6c/ikHg<00_oN
m`05mnO_omkgmnO_omK_mnO_00Gog_L00oOgmooNmoOgm`03omkg0_oFk`03
olKWolKNmkgF00;o_MH01?o6e_nme_nme_n]cP;o[LH01?NU]OnD[NnDW>n<
W0?WS9@01^n4U>n<W>n<W>n<W?n<YNnDW0;_S9`00oN4U?NU]On<Y@02miB]
00?gknooooooool01Oooo`800003oooo0P0000?oool300001?ooo`800003
oooo00<0003oooooool00oooo`040000oooooooo00001?ooo`030000oooo
oooo00?oool010000?ooooooo`000?oooooioooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01?ooo`030000IVJIVIW<00;<
c?l2VIW<00<0003oooooool02?ooo`08c/k>Q8B4moOginOWe]KFc/K6He9J
oooo4ooNm`07omK_mmKWolKWolKFmkg>mjG>mkG600Gg[Kd2mjFe01;oU:gg
U:GgU:G_S9cWS9CNNhCNNhcWNhcNNiC_S9c_Q9C_S9cgS:GgYKGoU:ggW:go
S:GginL7oooo0P0000?oool200004?ooo`050000oooooooooooo000000?o
ool00`000?ooooooo`02oooo00<0003oooooool00oooo`050000oooooooo
oooo00000?ooooohoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01Oooo`030000IVJIIVJI009VIYT00`000?ooooooo`09
oooo00W>c/j4Q8CgmoOWinO>c/jma[eB@T;og_OgmoL01OoNm`04ooooomkg
onOomoOg2_oNm`08olkgomK_olKWolkNolKFojg6mjg6mjfm0_NU]@CgW:d2
oiB]00CoS:GgU:GgS:G_S9`2ihbD0mikS006ihbDmjFeohbUmiB]ohb]kmkN
1oooo`030000oooooooo00?oool00`000?ooooooo`0?oooo0`0000Goool4
00001Oooo`030000oooooooo00?oool00`000?ooooooo`3ooooomOooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Koool4
00003?ooo`07c/k>S8b<ooooooooinOWe]KFBSU200Sog_L02_oooooNmooW
oooNmooWoooooooNmooWoooNmoOWk`?oe^l03_OFioo6iooFkoo6ioo>g_o6
g_nme_n]a_N]_ONU]ONL[ONDYNnDYNnDW0;_U:D00oN<YONDYONDY@02miBU
00?_U9c_S9cWS9@00^N<U005mjfmmiB]mib]ohbUmmkN0?oooooooooo;ooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0<oooo00SFe]J<S8coooooooo_knoWinMJ@T[oool6
omkg00[gmoOog_OoooooooogmoOooooog_Oooooog_Ooool2omkg0_oFk`06
olKWolkNmkgFmkgFokgFolKF0onmcP07ojg6mjfmmjfmoiB]mib]miBUkiBL
00?WS9@01NN<W>n<W?NDYONDYNnDY@02miBU00GgYKGoU:ggW:goS:G_g]h0
ooooooooool_oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo00coool02<k>cXb<S>o_knOWimkN
g]KFeUY:D^ONi`;oool00ooNmoooooooo`07omkg00?oiooog_Oog_L01OoN
m`05mnO_omK_olKWolkNmkg>00;g]LH2mjfm00?o[LKg[Kgg[Kd00_NU]@;g
W:d01^nLYNnDW>N<W>N<U=j4S=ikU0;WS9@2khbL00Og[KggW:ggW:ggW:go
[Lkoooo_ool0ooooooooool]oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00coool02lk>cXb<
S?ooono_kmkNg/K6aW=SJmK>c_oNmoOWkoOgm`02omkg00KoooooioogmoOo
oooog_Ooiol3omkg00Koiooog_Oog_Oog_Oginoog_L3omK_0_o6i`04olKF
okg>ojg6mjfm0oNU]@04mib]kib]mib]miBU0_NL[@06oiB]kibUkiBLihbL
ihbDgW^D0]j4S005mjfmmib]kjfemib]ojg60?oooooooooo;oooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`0<oooo01K>c/j<S8coooooooogmoONg]jDS8bLU9cooooog_Oo
ooo_inoooooog_OgmoOoiooog_OoioogmoOoioogmoOoiol4omkg0_oFk`03
mmKWmlKWolkN00;oc]h01Oo6g_o6e_nme_n]a_N]_@02mjFe00G_W:GWW:G_
U:G_U:G_W:D01_NDY@08kiBLihbLihbLmibmmib]mjFekjfeojg6oooooooo
ool_oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH01oooo`03c<cooooooooo00coool02<k>cXb<S?ooooooooOgmno_kjf]
[IbDW0?oool2omkg01CgmoOog_OgmoOog_Oooooog_Oooooog_Oooooog_Oo
iooog_OgmoOog_Ooe^ooinOoa^Ooc]koa]Kg_MH3okg>00?g_LKo_Lko[LH0
0_N]_@05oiB]mib]kibUkhbLihbD00?WS9`01NnDW>nLYNnDYNnDYONDY@03
mjFe00?gW:go[LKoool0ooooooooool^oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00coool0
2<k>cXb<S?Ogmno_kmkNg]KFe]kFeUY:DP;oool04OoNmooooooooooNmooo
oooWoooooooNmooooooNmoOgmooNmooooooNmooWoooNmoOgm`03omkg00Kg
e^Ooc]koa]Kg_Lkg]LKo[LH2mjfm0_NU]@;g[Kd2mjFe00K_YJG_W:G_W:GW
S9cWS9CNNi@3ihbD00OWS9cgYKGgYKGgYKGgW:gg[KggmoL0ooooooooool^
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
1oooo`03c<cooooooooo00coool02Lk>cXb<S?ooooOgmnOWimKFe]K>cRTQ
8NONi`03oooo00?gknooioooool01?ooo`04omkgooooomkgoooo0_Ogm`?o
g_L4omK_00Gge^Ooc]koa]Kg_LKo[LH00oNU]@04kib]mib]mib]mjFe0_NL
[@09oiB]miBUkiBUkibUkiBLihbDgW^DihbDmjfm00;gYKD00oNL[NnU_OO_
k`3oooooooooobkoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP07oooo00?<c?ooooooool03?ooo`03c/k>S8b<oooo00;o
ool01no_kmkNg[fe]D8i>MK>c_oooooNm`0:oooo00Goiooog_Oog_Oog_Og
knl00_oFk`;ge^L02oo6ioo>g_o6ioo>g_o6e_o6c_nmc_Nma_N]_ONU]NnU
Y@02iibU1NnLY@;gW:d00oNDYNnLYNnLY@05mjFe00?_inooooooool0oooo
ooooool/oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo00coool00lk>cXb<S?ooo`02oooo00Wg
moOgknoWinO>a/ISDUY2@T9cHf^DU9Cginl01Oooo`03onOooooooooo00?o
ool02OoWoooNmooNmooNmooFkoo>g_o>e_Nme_O6cP04okg>0oN]_@;gYKD0
1?NL[NnLYNN<W>N<W0;WS9@2ihbL0^nLY@03mib]mjfmmjFe00;gYKD00nnU
]NOWioooo`3oooooooooobgoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03?ooo`07c/k>U9BD
moOgkno_inOWg]kNinOW00;Ng]h2inOW00O>c/jLW9a[Jf]JBU9cFV>LU9c_
g]h00_ooo`08moOgooooomkgooooonOomoOgomkgmoOg0_oNm`05omK_omkg
olKWmkgFmkg>00;g_LH00nn]]ON]_ON]_@04mjfm0_NU]@03kib]mib]iibU
00GWS9@2mjFe00Cg_LK_YKgoW;goc]Koooooooooobkoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool02oooo`03moOgkno_Lg=c00;oool01oOgmnOWilk>c/k>c/K6a/k>c]KF
eP03g]kN00SWg]kNc]Je[JecLg=:BTYSDUZLS9CFa/h2oooo00?gmoOog_Oo
g_L00_oNm`0:onOoomkgomK_onOWomK_olkNolK>ojg6olK>mjFe1_NL[@07
kjFUmib]mib]mib]miBUkjFUkiBL00;WS9`01_NU]ON]_ONU]Nn]]ONU]Oo6
c_oooooooooo;_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Ooool00lc<ooooooooo`0=oooo00=BBU;oooooool00_oo
o`03kno_inOWg]kN00C>c/h04LK6a]KFe]KFe]kFe]kNg^OWimkFeZfUYG]k
NeY:DV=BFXakQ<K6a_oNmoooooOFknONi`05omK_00Goa^Ooc]ko_MKo_Lkg
_LH00_N]_@04mjFekjFUiibUiibU0nnLY@0;kib]kjFUmiBUkjFUmiBUmjFe
mjfmmkg6kjfeoibmolK>0?oooooooooo;_ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0=oooo
00>][JekNg_oool00oooo`05moOgkno_inOWinOWg]kN00;Fe]H01/k>c/K>
c/K6a/K6a/K>c/kFeP;Ng]h04>OWinONikfm_HAcQ5Y2DUY2BXAcQ;fL]OOF
iooFkoOFioNmg_Nmc_nme_o6g_negP;o_MH05Onmc_n]a_N]_Nn]]ONL[Nn]
]NnUYNN<W>NLYNN<W=jDYNN<W>nUYNnLYONU]ONea_NU]NnU_ON]_ONma_Og
m`3oooooooooobgoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP07oooo00?<c?ooooooool03_ooo`04Lg=c_KFemoOgkno_
0]kNgP;WinL05>o_koOgmno_knOWimkWimkNg]KNg/kFe/K>c/K6a[g6a/K>
c/K6a/k6c]K>c]kNg^OWinONikfm_IBDU09SBU801g=JHkFLW>nme_oWioNm
g_Nmc^n]cP02mjg600Wg]LKo[LKg_LKg_LKgYKGg[KggW:g_W:G_YJD00^NL
Y@09gYBUihbDmjFemjg6mjfmmkG6oibmmkg6omkg0?oooooooooo;Oooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0>oooo00OWinMBBU;oooooooo_knoNg]kFe]H00/k>cP03
e]KFg]kNinOW00?_knl2inOW00?NinOFg]kFe]H01Lk>cP0<e/k>e]KFimkN
inOWimkWg/kFW9BLLeYSFSU2JdYJS6]ckjfe0_NmaP06mjfmmjFemib]mjFe
mjfmmjFe0_N]_@09mjFemib]mib]kibUiibUmjfmmkG6mjfmmjg600;g[Kd0
0oOWkoooooooo`3oooooooooob_oool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool02oooo`;gmoL2
oooo00=:BT[oooooool00_ooo`03moOginOWg]kN00?Fe]H01Lk>c]KFe]kN
g]kNg^OWi`02kno_00?WinONinONg]h00]KNgP05e]KFc]K>c/k>c/k>e/k>
00;Fe]H01]kFe^ONinOWimK>c[fe]G=JH`9cBU802YA[LlJDW>N]]NnU_NN]
]MjDYNnL[ONU]Nn]]NnL[@?gYKD01?N]_Nn]a_N]_ONeaP;g[Kd00oOWiooo
ooooo`3oooooooooob_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03Oooo`05moOgooooHf=S
kno_moOg00Goool01_Ogmno_knOWinONg]kNg]KFeP;>c/h01MK>c]kFe]kN
g^OWinO_k`04kno_0^OWi`03e]kNc]KFa/k>00?>e/h01mK>c]KFe]kWimkW
imkNg[fm_HAkN`02FT9:00B4Hf_>Q8c_W:g_YKD2kib]00[_W:GWW:G_W:gg
]LK_YKgg_LKg[KgoW;gg[Kg_g]koooooooooobgoool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
3Oooo`06moOgooooW9bLYJfUoooomoOg0no_k`04moOgoooooooooooo0_Og
m`05kno_inOWg]kNg]kNe]KF00?>c/h2g]kN00?gmoOoooogmoL00oOgm`04
kno_inOWg]kNe]KF1<k>cP03c]KFc/k>g]kN00;Ng]h02[fm_IB<S5Y2BUY2
@W]BFZEcLmJLYNn]]NNLYNnU_@;o[LH01?NL_On]a_NL_Oo>g_oooooooooo
;Oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0?oooo00CWinMBBU;_knogmoL2oooo00G_knoW
g]kWinO_knoWinL00_Ogm`;oool2moOg0^o_k`07g]kNinOWe]KFU9BDHf=S
S8b<e]KF00Goool01_Ogmno_kno_kno_kmkWimK>cP?>c/h01<K6a/k>c]KF
e/kFeP;WinL03=JmaYb<U7=BFV<i>F]2BYa[LlJLYNn]a_N]a_Nmc^n]c_Nm
c_oooooooooo;Oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Ooool00lc<ooooooooo`0@oooo00GFe]IBBU:UYJG>c/kg
moL00_ooo`04kooomno_inOWino_0nOWi`0@kno_moOgmoOgmoOgoooomoOg
kno_moOgoooog]kNW9bLQ8B4Hf=SQ8B4_Kfmkno_0_ooo`;gmoL01OO_knO_
knOWimkNg]KFeP02c/k>00K>a/Jma/Jma/Jma/K>c/kFe]H3g]KF00NeW9bL
Q8acDUY[@TZ<Hf_6W:GoinL0ooooooooool]oooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00go
ool00oOgmoooooOgm`02oooo00O_knnm_Kf<S8acLg><S8bm]KGWinL00_oo
o`;gmoL2inOW0]kNgP;WinL3moOg0_ooo`0:moOgooooooookno__KfmQ8B4
Hf=SNg]k_KFee]kN0_Ogm`0@oooomoOgmoOgmoOgkno_e]KFe]KNc/k>a/k>
_LK6_Kfm_LK6c]K>_LK6e]KFmoOg0_ooo`03mno_knO_oooo0?oooooooooo
;Oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0<oooo00?gmoOoooogmoL01?ooo`0:moOgoooo
ooooooooc/k>W9bLNg]kQ8B4YJFUg]kN0_ooo`06moOgino_inOWkno_g]kN
kno_2_ooo`03kno__KfmS8b<009cLg<01:FUYLk>c^o_kno_k`;gmoL01nON
ioOgmnoWkmkNg]KFe/K>c[g6aP02a/k>00?_ooooooooool0ooooooooool`
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
1oooo`03c<cooooooooo013oool00oOgmoooooooo`04oooo00KgmoOooooo
oooooooNg]jUYJD2Ng]k00JLW9c>c/k_knogmoO_knogmoL>oooo00WgmoOF
e]JLW9acLg=[Jf^DU9Bm_KgWinO_g]h00_O_k`07mnO_inOWg]kNe]KNc]KF
ooookooo00;oool00nooooooooooo`3oooooooooobcoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool02_ooo`05moOgoooooooooooomoOg013oool01No_kkfe]Hb<S<K6a_Og
m`0Doooo00ONg]jUYJF4Ng]SHf>4Ng^][JgFe]H00^o_k`03knO_ino_moOg
00Coool00oOgmoooooooo`3oooooooooob_oool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03Ooo
o`03moOgoooooooo02coool01^oookg6_HB4Q6=SHf]cJlK6a_oooooooooo
=?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`3oooooooooogKoool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0oooo
oooooomfoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH0oooooooooon0oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH0oooooooooon0oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH00oooo`07kno_[Jf]FV]SW9bLilK6
inOWmoOg00Coool00nooooOgmoooo`3oooooooooofooool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00_Ng^NDS8`@
611:BTXY8B6]Lg]kNg^DS8b][JgF_LK_knl0oooooooooomcoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000001N8`;S8h=R8`;R8`;QVIVKooooWknnm_KdY
<BVma[goooli627>Q8c>Lg_6Jg>]Jf^LHf^<Jg>LS8bm]KGFe]K_knogmoL0
oooooooooom^oooo00EVIVKooon8`;R8`;Q8T8P00@00000000V8`;S8h=R8
`;R8`;QVIVKgmoOFc]JLU9`a>CT00_ooo`0?Ne9JcW^4og^Dkg><ig^4cW=k
_F]cYF=[YF=SU6]cQ8B4W9bL_Kfmg]kNmno_0?ooooooooooJoooo`05IVIV
ooooR<2hR<2hB928004000000009R<2hb>3HR<2hR<2hIVIVinOWa/k>S9B<
FUYJ00;oool017=JHlikU?n<[On<Y@;oQ9`2mg^<00__Hg_WFW?6Jg>]Jf^U
Hf>DJg>DQ8BU[JG6c/kNknogmoL00_ooo`03kooooooooooo00Coool00noo
ooooooooo`3ooooooooooe_oool01FIVI_ooohS0^8S0^4R@R00100000000
2HS0^<SPf8S0^8S0^6IVI_OWimKFgZF]YF]cJ`02oooo01M[Lf_NS:goYLko
YLkgU;goU;GgU:goS:G_S9coQ9c_Q9CNNhcFLhC>Lg^mJg>]Jf^UHf>UJf^L
Q8beW9c>a/kWinOoool00nooo`_oool00nooooOgmoooo`3ooooooooooe;o
ool01FIVI_ooohS0^8S0^4R@R0010000000048S0^<SPf8S0^8S0^6IVI_O_
knO_kjf][F]SHnONimKNgV=:D/IcU?nD]OnL_OnUaP;oYLh05?nUa_ND_NnD
_On<[On<YOMkU?N4U?MkS>MkQ>mSNnM[NkEcLjE[LiaSJiA[Lib<S;fe]LkN
e^OgmoOgm`Ooool00oOgmoooooooo`3ooooooooooeGoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00fm_Ke[Lf_W
g^O>e]I[FU[6LiCgJhCgLhcgLiCgQ:GoU;GoW;goYLH00_nUcP0GoibmoiBe
ohb]ohb]ohBLmg^Dmg>DkhBDig^4eW=kcV=caW=cYG=cW6]cW7=k[JFU_Kfm
imkNmoOgkooooooomoOgkooo00Ooool00oOgmoooooooo`3oooooooooodko
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02
oooo00S6a/J4Q8CgmoOWknn<Ng_NS:goU;GoS:d2mg>D00C_LhcgLiCoQ9co
S:D2ojG60_neeP0DojG>ojG6miBmkhbemg^DohBLmg><mg^<mg^Dkf^4eW=k
cV=c]G=cYF]cYG=cYG]k]IbL_KfminOWkooooooooooooomHoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`06c]K>
Q8B4knO_inOWU8B4gXb]0_nL_@04oiBeohb]ohbUmhBU0_MkU006gW^DohBL
oiB]oiBeojG6ojG>0_neeP05ojG>ojG6oiBeohbUmg^D00?gLi@03OMkS>Mk
Q=IcNlI[LkEcLje[JjEcLjEkNkF][MK>c^OWioOgmoooo`03kooooooooooo
oom@oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH00_ooo`06_LK6Ng]ke/kFc/k>Jg=[cW^D0on<[@03oiBeoibmoibm00;g
W;d2ohb]00WgU:ggQ:GgQ:GgU:goS:goU;GoYLKo]MKoYLh00_nUaP09oibm
miB]mhBUohBLog^Dmg^DmhBDig^<gW^400;>Hg<02JEcNia[LiacNjf<U;fe
]Mk>e_O_koooonooo`3oooooooooodooool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP02oooo00K>e/j<S8c_inoNinNDLg_>
Ni`2ohb]0_N4Y@08ohb]oiBeoibmoibmojG6ojG>ojG6oibm0_nD]@09ohbU
ohBLkg^UmhbUoiBemibmojG6ojg>ojG600;oW;d04^n<]ON4YNmkYOn4W>mk
YOMkU>n4U>MkS=IcNlIcNkE[NjE[LiA[LiakNjf<U<K6a]KFe_O_kooooooo
ooooCOooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00;oool02]K6cXb<S>ooono_kibDW;FLW?nUc_nUa_nL_OnD]@?oU:d0
4OnD]NnUc_NL_ON]a_nUc_n]c_nUc_nUa_nL_OnD]On<[On<YNmkYOMkU?N4
YOn<[OnD]@03oibm01CoU;GoS:goS:GoS:GgQ:GgNiCgLiC_Q9C_NhcWLhcN
Jg_>Hg?>FV^UJf^LJg>LLg^eW9cF_LKNg]k_moL2kooo0_ooo`04kooooooo
ooookooooooooooooom1oooo00EVIVKooon8`;R8`;Q8T8P00@0000000128
`;S8h=R8`;R8`;QVIVK_ooooooo>c/j4Ng_NinOFe]JLQ8bLS9Co]MKoYLko
[Lh2ojG600Co[LKoW;goW;goU:d3oiBe00CoYLKg[LKo[LkoYLh2ojG60_nL
_@08oiBekg^Ukg^UihbLig><khBDohbUohb]0_nD]@;oS:d2ohbU00KoQ9cg
NiCgQ9CgNiC_Q9C_Nh`2cW^400ZeJg^UJg>UJg>DLg^]S9BmYJG>c/kWg]ko
ooo_ool2oooo00?_ooooooooool0oooooooooolooooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`0:e/k>Q7]kg^OW
c/k>U8b<W7=kkjG>kjg6mibmojg60_n]cPCo]MH01?n]c_nUa_nL_OnD]@;o
W;d01ON]a_nUc_nUc_n]a_nUaP02oibm00SoU;GoS:GoQ9cNNiC_LhcWLhcg
NiCoS:D3ohb]0_n<Y@;oQ9`02?MkU?N4U?McU?n4W=ikU>MkS<ikQ;e[L`:e
Lg<01iAcNjf<U?o>g^ooooOgmoooonooo`3ooooooooood7oool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00OFc/j<
S8c_moOWinN]YJFDLg_oYLH00_NL_@05oiBeoibmojG6ojg6ojg>00;g_Mh3
okGN00?o]MKo[LkoYLH00_NL_@CoU;D2oibm0_nD]@04ohb]ohBLmg^Dmg><
0nMSQ004kg><mg^DohBLohb]0_n<Y@?oQ9`2og^D00CoQ9CgQ9C_NhcWNh@2
aW^<00?_YKGoooo_ool0oooooooooom3oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`09c/K>Q8B4moOgknO__KFe
U7=kolk_okgFojg>00;o[LH00oN]_ONL_ON]aP02ojg>00go_Lko]Mkoa^Oo
a^Oga^Og_NOo]MKo[LkoYLKgW;goU;GgU:goS:D00_n<[@;oU:d01_nD]On<
[On<YOn4W?mkU>mcS0;WHh@01=iJNnMSQ>mcS?MkU0OoQ9`2og^D00C_S9cN
NhcNNiC_inooooooooooodCoool01FIVI_ooohS0^8S0^4R@R00100000000
3HS0^<SPf8S0^8S0^6IVI^ooooooomK>cXAkNmkWimKFe[fe]G]SL`04okGN
00Coa]ko]Mko_MKg_MH2ojg>0_NUcP05okgFokGNokGNokGNolKW00;o]Mh2
okGF00Go[LkgW;ggYKGgQ:GgS:D00_N4Y@?oS:D2ohBL01CoNiCgNiC_LhcW
HhCWHg_NFW_NFW?_JhC_LhcgNiCoQ9CoQ9coS:GoQ9coS:GgNiCgLiCWJhc_
g]k_oooooooooooood?oool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP02oooo00KFc/j4Ng_NinO>e]Jm]KEcDUX2mkgF00Gg
YLko]MKo]Mko]Mkoa^L00_o>k`03olKWokGNokgF00?o[Lh01On]a_Nme_Nm
e_Nme_neeP02okGN0_neeP08ojG6oibmmiB]khbLkhBDmg>Dkg><kg^<0_n4
U0?oNi@01OMcS>mcS>m[Q>MJLmiSL`02gUYc00?WHg__LhcgLh`00_n<Y@;o
Jh`00mk>e_OgmoOgm`3ooooooooood;oool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP02oooo00WFc/j<S8coooo_knoF_LIk
DU[oa^Oo_MKo[Lh00_n]aP04mjg6okGFokGNokGN0_o6i`03omK_olk_olk_
00;ga^L01?nee_n]c_n]a_N]aP;o[LH2ojg>0_nUaP07oibmoiBeoiBeohbU
ohBLmg>Dif]k00;_Jh@00nMkQ?MkS?mkU003og^D00?gJhCgLhc_Hg/00miJ
L`05kg><mg>Dog^DohBLmkgF00;_oooooooooooood;oool01FIVI_ooohS0
^8S0^4R@R001000000003XS0^<SPf8S0^8S0^6IVI_ooooOgmmK>cXakQ?Og
moO_knOWieYSF_o>m`?oa^L01?o6g_nee_Nmc_neeP;g_MH2okGN00koa^Oo
c^ooe^ooc_Ooc^ooa^Oo]Mko_MKo[LkoYLKgW;ggYKGoW;ggYKD3oibm00Oo
U;GoU:goS:GoQ9cgNiC_NhcWHh@00^MSN`03if]kkf=kkg><00;gLh`02Nmc
S?McS>m[Q>m[Q?McS?mkU?N4YOMkU?nmeP3oooooooooodCoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00S>c/j4
Ng_Wg]kNc]KFa/i2@T;oc^og_Mh2olKW0_o>k`05olKWolk_olKWolKNmkgN
00;g_MH2mkgN0oo6i`08olk_olKWolKNolKFojg>ojg6mjfmoibm0_ND[@04
miBUmiB]ohb]miB]0on<Y@09ohBLmg^Dkg><kf^4if=kgUYcgV=cif=kkf^4
00?gLh`2ohBL00GgS:GgNiCo_Lkoooo_ool0oooooooooom2oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`07e]KF
S8b<mno_imkNg]KF@STiolKW00Cg_Mh01oo6ioo>kooFkooNmoo>mooFkoo>
k`02olKW0_NmgP03mkgWmkgNmkgN00Co]Mh02_nme_n]c_n]a_nL_ONU]On<
[ON<YNn<W>n4U?MkU0GoQ9`2og^D00cgLhc_LhcWJg_NHg?>Hg?NHg?WJg__
LhcoS:GgQ:GgNiCo_MKoooooooooodCoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP02oooo00_>c/j<S8coooogknoWg^M:
>D;oc_Ooa^Ooc]kg_Mkg_MH00oNmgP03olKWomK_omkg00;og_L01ooFkoo>
mooFkoOFkoO6ioNmg^nmeP02mkgF0_nmeP0:okGFojg>ojg>ojg>ojg6mjFe
oiB]mhbUmhBDkhBD0^mcS00Big><kg^<mg^DmhBDohBLmhBDmg>Dkg><kf^4
if>4gV]kkf^4ohbUmhbUmg^DokgFooookooo3Oooo`030000oooooooo00Co
ool00`000?ooooooo`3oooooooooob_oool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP02oooo00O>c/j<S8cgmoOgknoWinM:
BT[og_L00_o>m`05omkgolKWolk_olKWolkN00?ga^L01Oo6iooFkoo>moo>
mooNm`03olkg0_o6i`03mkgNkjg>kjg>00;g[LH00oNL_OnL_ON]_@02oibm
00kgYKGoU;GoU:g_S9c_Q9CWNhcWHhCWNhCWHhCWNhC_Lhc_Q9CoQ9cgQ9@2
mg^D00GgQ9CoS:ggS:GoS:Go_Lh03oooo`030000oooooooo00Coool00`00
0?ooooooo`3oooooooooob_oool01FIVI_ooohS0^8S0^4R@R00100000000
3XS0^<SPf8S0^8S0^6IVI^ooooooolk>cW]kNno_kmkNg]KFeT92@_O6i`;o
e^l01oo>mooFkooFkooNmoo>mooNmoo>m`02omK_0oOFk`0AomK_omkgomK_
omK_olkgomK_olk_olKWolKNojg>mjg6kjFmkibemiB]mib]miBUohbU00?o
U:d2ohbU00GoQ9cgNiC_NhcWHhCWNh@00]i[N`08ig^4ig><mg^DohBLohbU
kg^UohbUmkG61oooo`030000oooooooo00?oool010000?ooo`000?ooo`80
0003oooo00@0003oool000000003oooo00@0003oooooooooool30000oooo
oooooolPoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH00_ooo`07c]KFS8b<ooooinOWg]KFFUYJmkg>00;oa^L01OO6ioOF
ioo>kooFkoo>m`08omkg0_o6i`0>mlKWmmKWolKWomK_olKWolk_olKWokGN
okg>ojg6mjfmoiBemiBUkhbL0^N<U003khbLohBLkhbL00?_S9`01On4U?N4
U>mkS>McS>MkQ002gV]k00GWLhcoS:GgU:goS:Gg[Kd01oooo`030000oooo
oooo00?oool010000?ooo`00000000;oool00`000?ooooooo`0200000_oo
o`040000oooooooo00000_ooo`050000oooooooooooo00000?oooooooooo
7oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00;oool01lk>cXb<S?ooooOgmnOWig=SJnnmeP02omK_00Goa^Ooe^oga^Og
a^Oge^l00_oFk`Oog_L00ooFkoo6ioNmgP02mkgF00Gg_Mkg_MKo]MKo]MKo
_MH00_n]cP08ojg6oibmmjFeoiB]ohbUkhbLihbDig^<0^n4U004ohBLmhBD
khbLohBL0_N4U0;_Nh`01ON4U?n<[OND[On<[NnU_@08oooo00D0003ooooo
ooooool000000_ooo`050000oooooooooooo000000;oool01@000?oooooo
ooooo`000002oooo00@0003oooooool0003oooooooooob?oool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00O>c/j4
Q8C_knoWinONg]j<U8bmW;D01ooNm`05mnO_omK_mmK_mmK_omK_00Oog_L0
1oo>moo6ioNmg_Nme_Nmc_Nea_N]aP02mjfm00?o[LKg[Kgg[Kd00_NU]@06
mib]miBUmiBUkhBDig^<gW^<0nMkS009khBDmhBDkhBDkhbLkiBLoiB]ohbU
kib]oiBe00Soool500000_ooo`050000oooooooooooo000000;oool01@00
0?ooooooooooo`000002oooo00<0003oooooool01@000?oooooooooo7ooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;o
ool01mKFeXb<S>o_kmkNg/K6aXakQ9bDW003omK_2ooNm`03omK_omkgomK_
00Coe^l2olk_00Coa]ko_MKo[Lko[LH2mjFe1?NL[@CoU:d01On<YOn4W>n4
U>mkS>MkQ002gW^400WWNhC_NhcgQ9CoU;GoS:G_W:goU:goooogmoL01_oo
o`050000oooooooooooo000000;oool01@000?ooooooooooo`000002oooo
00D0003oooooooooool000000_ooo`040000oooooooo00000oooo`030000
oooooooo0?oooooooooo7Oooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00;oool01lk>cXb<S?ooono_kmKFeZFUYIAcN`02
omkg00?oe^ooc_Ooe^l02ooNm`03omK_mmK_olKW00;oa^L01_o>koo6ioo6
ioo6g_o6e_nmeP;o[LH01?NU]OnD[ONDYNnDY@;_S9`01>nDYON<YOn<YOND
Y@;oS:D02^nDW>n4U>mkS>MkS=ikS>MkS?nD]On<YNnL[OnD]@Woool00`00
0?ooo`000003oooo0P0000;oool00`000?ooooooo`0200000_ooo`040000
oooooooo00000_ooo`050000oooooooooooo00000?oooooooooo7oooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool0
1lk>cXB4Q?ooooOgmno_klK>cW]SL`02omkg00Gginoog_Oginooe^oginl0
1OoNm`03moOgomkgmoOg00?og_L2omK_00?oa^Ooa]kg_MH00_nmeP04olKF
okgFokgFojg>0_n]aP04mjFeoiB]kiBLkhbL0nN<U006khBDkhbLkhbLkhbL
ohbUkiBL0^n<W003mhBDmjFeohbU00;gU:d00oO_koooooooo`06oooo00<0
003oool000000oooo`040000oooo000000000oooo`040000oooo00000000
0oooo`040000oooooooooooo0`000?oooooooooo8?ooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool02<k>cXB4Q?Og
mnOWimKFe/k6aV=BF_oooa?og_L01ooFkoOFioo6ioo6e_Nmc_NUc_NeaP05
mjfm0_NU]@0BoiB]miBUmiBUkhbLihbDgW^4gW^<ig^<gW^DkhbLkhBDkhbL
mhbUmjFeoiB]mib]ohbUmnOW2?ooo`030000oooo0000017oool00`000?oo
ooooo`3oooooooooobCoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP02oooo00W>c/j4Q8CgmoOWinO>c/jma[eB@T;og_Og
moL01OoNm`04ooooomkgonOomoOg2_oNm`08olkgomK_olKWolkNolKFojg6
mjg6mjfm0_NU]@CgW:d2oiB]00CoS:GgU:GgS:G_S9`2ihbD0mikS006ihbD
mjFeohbUmiB]ohb]kmkN2Oooo`030000oooooooo013oool00`000?oooooo
o`3oooooooooobCoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP02oooo00O>c/j<S8cooooooooWinOFe]I:>D802?oNm`0:
ooooomkgonOoomkgonOoooooomkgonOoomkgmnO_0ooFk`0>mmKWolKWomK_
olKWolkNolKNokgFojg6mjfmmjFemib]miBUkiBUkiBL0^nDY@03mhbUmiBU
miBU00;gU:D00nnDW>n<W>N<U002ihbD00Gg[KggU:ggW:goS:Ggg]h0oooo
oooooom3oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH00_ooo`08e]KFS8b<ooooooookno_inOWFT9:oooo1_oNm`0:moOg
omkgoooooooomoOgooooomkgooooomkgoooo0_oNm`;oe^l01_o6ioo>g_Nm
e_Nme_nme_o6eP?o_Lh01on]a_N]_ON]_OnD[ONL[ONDYNnDW003ihbD00GW
S9c_S9cgU:GgU:G_U:D00_NDY@05mjFeoiB]mib]ohbUkmkN0?oooooooooo
@oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00;oool02<k>cXb<S>o_knOWimkNg]KFeUY:D^ONi`;oool00ooNmooooooo
o`07omkg00?oiooog_Oog_L01OoNm`05mnO_omK_olKWolkNmkg>00;g]LH2
mjfm00?o[LKg[Kgg[Kd00_NU]@;gW:d01^nLYNnDW>N<W>N<U=j4S=ikU0;W
S9@2khbL00Og[KggW:ggW:ggW:go[Lkoooo_ool0oooooooooom1oooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`0;
c/k>S8b<ooookno_g]kNa/K6Lf=[e/k>omkgmnO_moOg00;og_L01_oooooW
ooOgmooooooNmooWo`?og_L01_oWoooNmooNmooNmoOWkooNm`?oe^l2olKW
00Coa]Ko_Lko[LKg[Kd3mjFe00CgW:g_W:ggW:ggU:D2mib]00KoU:g_W:G_
U9cWS9cWS9CNNi@2gXB<00Gg[KggW:g_[KGgW:go[LH0oooooooooom3oooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_oo
o`0Fc/k>S8b<oooooooomoOgg]kNU8b<W9BLooooomkgooooknO_ooooomkg
moOgonOoomkgonOomoOgonOomoOgonOo1?oNm`;oe^l00oOFioO6ioo>gP02
olkN00Goa]koa]Ko_MKo[LKg[Kd00_NU]@05kibUiibUkiBUkiBUkibU00Kg
U:D02>nDW>N<W>N<W?NL_ONL[ONU]Nn]]On]a_oooooooooo@oooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool02<k>
cXb<S?ooooooooOgmno_kjf][IbDW0?oool2omkg01CgmoOog_OgmoOog_Oo
oooog_Oooooog_Oooooog_Ooiooog_OgmoOog_Ooe^ooinOoa^Ooc]koa]Kg
_MH3okg>00?g_LKo_Lko[LH00_N]_@05oiB]mib]kibUkhbLihbD00?WS9`0
1NnDW>nLYNnDYNnDYONDY@03mjFe00?gW:go[LKoool0oooooooooom2oooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_oo
o`08c/k>S8b<moOgkno_g]kNe]KFg]KFFTYB0_ooo`0Aomkgooooooooomkg
ooooonOoooooomkgooooomkgmoOgomkgooooomkgonOoomkgmoOg00?og_L0
1_OFioo>g_o6e_Nmc_Nea_n]aP;g[Kd2mjFe0_N]_@;gYKD01^nUYNnLYNnL
YNN<W>N<U=ikU0?WS9@01nN<W?NU]ONU]ONU]ONL[ON]_OOgm`3ooooooooo
od;oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP02oooo00W>c/j<S8coooogmoOWinOFe]KFc/hY8B7Wg^L00oooo`03mno_
onOooooo00Coool01?oNmooooooNmoooo`;gmoL3omkg1?oFk`05mmKWolkN
olKFmkg6ojg600?gYKD01>nL[ONL[ONL[ONU]@;gW:d02OnD[ONDYNnDYNnL
YNnDW>N<U=ikU>N<U?N]_@02mjFe00?gW:g_YKggknl0oooooooooom2oooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_oo
o`03c/k>S8b<oooo00;oool01no_kmkNg[fe]D8i>MK>c_oooooNm`0:oooo
00Goiooog_Oog_Oog_Ogknl00_oFk`;ge^L02oo6ioo>g_o6ioo>g_o6e_o6
c_nmc_Nma_N]_ONU]NnUY@02iibU1NnLY@;gW:d00oNDYNnLYNnLY@05mjFe
00?_inooooooool0oooooooooom0oooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH00_ooo`03c/k>S8b<oooo00;oool02OOg
moO_knOWilk6aV=BFT92@W=SJiBDU?OWk`05oooo00?oioooooooool00ooo
o`09onOoomkgomkgomkgomK_olkNolkFmkgFmlK>00Co_Lh3mjfm0_NU]@04
mib]kibUihbLihbL0^N<U0;WS9`2kibU00?gW:gg[KggYKD00_NU]@03kjFe
inOWoooo0?oooooooooo@Oooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00;oool01lk>cYBDU?Ogmno_knOWimkNg^OWi`02
g]kN0^OWi`07c/k>W9bLJf][FTYBLeYSW9BLkmkN00;oool02?OgmooooooN
mooooooWooOgmooNmoOgm`;og_L01OoFkooNmoo6ioNme_NmcP02mkg600?_
[KGg[Kgg[Kd01?N]_@;gYKD00nnL[ONL[NNLY@05ihbD0_NU]@04mkg6kjFm
oibmolkFoooooooooom2oooo00EVIVKooon8`;R8`;Q8T8P00@00000000V8
`;S8h=R8`;R8`;QVIVKoooogmoO_knmcLg<00_ooo`07moOginOWc/k>c/k>
a/K6c/k>e]KF00?Ng]h02>ONg]k>e[F][G=cLdY:BV=BFYb<U=K6cP;oool0
0oOgmooNmooNm`02omkg00[oiooog_Ooe^ooinOoe^ooc]koa/ko[LKoa/kg
YKD6mib]00O_YJGgW:ggW:ggW:ggU:G_YJG_U9`00^N<W006mjFemjfmmjFe
kjfemjFeolK>oooooooooom2oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH00oooo`03DTYBoooooooo00;oool00no_knOW
imkNgP04c/k>0176a/KFe]KFe]KNe]KNg]kWinONe]J]YJEkNg]JBU9SDUZ<
NhC6a/Kog_Oooooge^oWg^L01OoFk`05olKWolkNokgFokg>mkg600;g[Kd0
1?NU]NnUYNNLYNNLY@?_W:D02nnL[NnUYONDYNnUYONDYONU]ON]_ONma^n]
]OnL_Oo6cP3ooooooooood;oool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP03oooo00>][JekNg_oool00oooo`05moOgkno_
inOWinOWg]kN00;Fe]H01/k>c/K>c/K6a/K6a/K>c/kFeP;Ng]h04>OWinON
ikfm_HAcQ5Y2DUY2BXAcQ;fL]OOFiooFkoOFioNmg_Nmc_nme_o6g_negP;o
_MH05Onmc_n]a_N]_Nn]]ONL[Nn]]NnUYNN<W>NLYNN<W=jDYNN<W>nUYNnL
YONU]ONea_NU]NnU_ON]_ONma_Ogm`3ooooooooood7oool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP04oooo00AcLg>m]KGg
moO_knl2g]kN0^OWi`0Dkno_moOgkno_inOWg^OWg]kNe]kNc]KFa/k>a/K6
_LK6a/k>a/K6c/K>e/k>g]kNinOWimkW_KfmU9BD0V=:DP07LeYS]IbLkkgF
onOWmkgNmkg>kjg>00;g[LH02ONea_n]a_Nma_Nma_NU]ON]_ONL[NnLYNnU
Y@02iibU00WNU:GWS9CgYKGg[LKg[Kgg]LKoW;gg_LKog_L0oooooooooom1
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
1?ooo`07inOWDTYBooooooookno_g]kNe]KF00;>c/h00mKFe]kNg^OWi`03
kno_0^OWi`03g^OWe]kNe]KF00G>c/h03=K>c]KFe^ONg^OWinONimk>eYbD
W7=JHeXi@V]:FXa[Lnn]]@;g_LH01_N]_ONU]ONL[ONU]ON]_ONU]@;g[Kd0
2ONU]ONL[ONL[NnLYNNLYON]_ONea_N]_ON]aP02mjfm00?ginooooooool0
oooooooooolooooo00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8
`;R8`;QVIVKoool2moOg0_ooo`03BTY:oooooooo00;oool00oOgmnOWimkN
gP03e]KF00G>c/kFe]KNg]kNg]kWinL00^o_k`03inOWg^OWg]kN00;Fg]h0
1MKFe/kFc/k>c/k>c]K>cP02e]KF00KNe]KWg^OWinOFc/jm]KEcFV<2LdYB
00ZDJg?6U9cW[KG_YKgW[KGNU:G_W:ggYKG_[KG_W:d3mjFe00Cg[Kg_[LKg
[Kgg]LH2mjfm00?ginOoooooool0oooooooooolooooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00oooo`05moOgooooHf=S
kno_moOg00Goool01_Ogmno_knOWinONg]kNg]KFeP;>c/h01MK>c]kFe]kN
g^OWinO_k`04kno_0^OWi`03e]kNc]KFa/k>00?>e/h01mK>c]KFe]kWimkW
imkNg[fm_HAkN`02FT9:00B4Hf_>Q8c_W:g_YKD2kib]00[_W:GWW:G_W:gg
]LK_YKgg_LKg[KgoW;gg[Kg_g]kooooooooood7oool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP03oooo00KgmoOooonLW9bU
[JGoooogmoL3kno_00CgmoOoooooooooool2moOg00G_knoWinONg]kNg]kF
e]H00lk>cP;Ng]h00oOgmoooooOgm`03moOg00C_knoWinONg]kFe]H4c/k>
00?>e]K>c/kNg]h00]kNgP0:_KfmU8b<FT9:FT92Ne9JYG=ceYbUkjfeiibU
kjFm0_n]aP04mibmojg6mibmolkNoooooooooom1oooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01Oooo`04inOWDTYBkno_
moOg0_ooo`05kno_imkNinOWkno_inOW00;gmoL2oooo0_Ogm`;_knl01mkN
g^OWimKFeYBDU6=SHhb<S=KFeP05oooo00KgmoO_kno_kno_knoNinOFc/h3
c/k>00C6a/K>c/kFe]K>e]H2inOW00cF_LJLS9AcDUYS>CU[@TZLJg?6W:G_
[LKg[LKg_Lk_[Lkg_Lkooooooooood7oool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP06oooo00GFe]IBBU:UYJG>c/kgmoL0
0_ooo`04kooomno_inOWino_0nOWi`0@kno_moOgmoOgmoOgoooomoOgkno_
moOgoooog]kNW9bLQ8B4Hf=SQ8B4_Kfmkno_0_ooo`;gmoL01OO_knO_knOW
imkNg]KFeP02c/k>00K>a/Jma/Jma/Jma/K>c/kFe]H3g]KF00NeW9bLQ8ac
DUY[@TZ<Hf_6W:GoinL0oooooooooom1oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH00oooo`03moOgoooomoOg00;oool0
1no_kkfm_Hb<S7=cLhb<S;fe]NOWi`02oooo0_Ogm`;WinL2g]kN0^OWi`?g
moL2oooo00[gmoOoooooooo_knnm_Kf4Q8ASHf=kNg^m]KGFg]h2moOg013o
ooogmoOgmoOgmoO_knoFe]KFe]k>c/k6c/jma/Jm_Kfma/K>e/jma/KFe]Kg
moL2oooo00?gkno_inooool0oooooooooom1oooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`03moOgoooomoOg00Co
ool02_Ogmoooooooooooolk>cYbLW7]kNhB4Q:FUYMkNgP;oool01_OgmnO_
knOWino_kmkNg^o_k`[oool00no_kkfm_Hb<S002Lg=c00BUYJG>c/k_kno_
knl2moOg00OWg^OgmoO_inoNg]kFe]K6c/jma/H00/K>cP03kooooooooooo
0?ooooooooooA?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Koool00oOgmoooooooo`04oooo00KgmoOooooooooooooN
g]jUYJD2Ng]k00JLW9c>c/k_knogmoO_knogmoL>oooo00WgmoOFe]JLW9ac
Lg=[Jf^DU9Bm_KgWinO_g]h00_O_k`07mnO_inOWg]kNe]KNc]KFooookooo
00;oool00nooooooooooo`3ooooooooood3oool01FIVI_ooohS0^8S0^4R@
R001000000001XS0^<SPf8S0^8S0^6IVI_Ogm`?oool00oOgmoooooooo`0>
oooo00G_knnm]KF<S8c6a/KgmoL05?ooo`07g]kNYJFUQ7]kHf=SQ7]k[Jf]
e]KF00;_knl00noWknO_koOgm`04oooo00?gmoOoooooool0oooooooooolo
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
0oooo`03moOgoooooooo02coool01^oookg6_HB4Q6=SHf]cJlK6a_oooooo
ooooB?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV0?ooooooooooP?ooo`05c<c<ooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB9280040
00000004R<2hb>3HR<2hR<2hofIVI_mVIVJ2IVIV00C<c<b8`;R8`;Q8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^8J8`;P1B9280@00000000B8`;S8
h=R8`;R8`;PF00200`01P0800X001002P@03P@03P@03P@<0184200F100<0
1H801X801X800P06PP0400N20@N20@N20@R20P48P`<12H<30@Z300<12h<1
2h@12h@0104<Q0<13H@30@j50`8?Q@<248D30Q66108BQP824hH0108CQ`8D
Q`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP40aR800<36HP36HT36HT0
0`<JR@<36hT30ab:0`<MRP<47XX411n;0`@PR`848H/010@QS0@RS0@RS0@R
S0<48h`212B<00<498d49Hd49Hd00PDUS@<59Xd00`DWS@DWSPDWSP031BR>
0`DYSP031BZ>1BZ?1BZ?00@5:hl31Bb?0`H]T0<6;Y031Rn@0`H`T@@6<I42
1S:A00D6<Y86<i86<i86<i86=9800PLdTP031cFB1cFC1cFC00<7=Y<41cNC
0`LhU0<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8
@IL8@IL324:G0PQ3U`032D>H2DBH2DBH0089A9P32DFH00<9AYP9AYT9AYT0
0`U7V@<9B9T00`U9V@U9VPU9VP042DZJ0`Y;VP<:C9/32TfK0PY>V`042TjL
2TnL2TnL2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]D
WP032eFN10]FWP<;Eil32eRO0`]IW`<<FZ0335^P0`aLX0@<GJ4335jQ0PaO
X@0435nR362R362R362R0PaQXP043F6R3F:R3F:R3F:S10eSX`<=I:<00`eU
X`eUY0eUY0033FJT0`eWY0<=J:D43VVU0PiZY@043VZV3V^V3V^V3V^V0`i/
YP8>KJH010i]Y`i^Y`i^Y`i^Y`@>KjL00`i`Y`m`Z0m`Z0033g6X0`mbZ003
3g>X3g>Y3g>Y00<?M:T43gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[111l
[0<@OJ`247j/00@@OZd@Ojd@OjdAOjd34H2]00<APJdAPJhAPJh01162[P<A
Pjh34HB_0a65[`<AQZl34XN`11:8/08BRK0011:9/A::/A::/A::/@<BRk42
4Xba00@BS;8BSK8BSK8BSK824Xjb0Q>>/P034hnb4hnc4hnc00<CT;<34i6c
00<CT[<CT[@CT[@00a>C]0@CU;@34iFe0aBF]@<DUkD359Rf0aBI]P8DV[H0
0aBJ]aBK]aBK]`0259^g0aBL]`0359fg5Ifh5Ifh00<EW[P35Inh00<EX;PE
X;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk11JW^`8FZ;/011JX_1JY
_1JY_1JY_0<FZ[`25Z^l00@FZkdF[;dF[;dG[;d45jfm00<G[[dG[[hG[[h0
0aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h1000P003VjOa<d>U<d>U00Tc@jD600200`01P080
0X001002P@03P@03P@03P@<0184200F100<01H801X801X800P06PP0400N2
0@N20@N20@R20P48P`<12H<30@Z300<12h<12h@12h@0104<Q0<13H@30@j5
0`8?Q@<248D30Q66108BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@3
5XP35hP35hP35hP40aR800<36HP36HT36HT00`<JR@<36hT30ab:0`<MRP<4
7XX411n;0`@PR`848H/010@QS0@RS0@RS0@RS0<48h`212B<00<498d49Hd4
9Hd00PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00@5
:hl31Bb?0`H]T0<6;Y031Rn@0`H`T@@6<I421S:A00D6<Y86<i86<i86<i86
=9800PLdTP031cFB1cFC1cFC00<7=Y<41cNC0`LhU0<7>I@31cZD0`LkU@<8
?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`032D>H
2DBH2DBH0089A9P32DFH00<9AYP9AYT9AYT00`U7V@<9B9T00`U9V@U9VPU9
VP042DZJ0`Y;VP<:C9/32TfK0PY>V`042TjL2TnL2TnL2TnL10Y@W0042U6L
2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN10]FWP<;Eil32eRO
0`]IW`<<FZ0335^P0`aLX0@<GJ4335jQ0PaOX@0435nR362R362R362R0PaQ
XP043F6R3F:R3F:R3F:S10eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=
J:D43VVU0PiZY@043VZV3V^V3V^V3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^
Y`@>KjL00`i`Y`m`Z0m`Z0033g6X0`mbZ0033g>X3g>Y3g>Y00<?M:T43gFY
0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[111l[0<@OJ`247j/00@@OZd@Ojd@
OjdAOjd34H2]00<APJdAPJhAPJh01162[P<APjh34HB_0a65[`<AQZl34XN`
11:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK82
4Xjb0Q>>/P034hnb4hnc4hnc00<CT;<34i6c00<CT[<CT[@CT[@00a>C]0@C
U;@34iFe0aBF]@<DUkD359Rf0aBI]P8DV[H00aBJ]aBK]aBK]`0259^g0aBL
]`0359fg5Ifh5Ifh00<EW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j
0aFT^P<FYKX35ZJk11JW^`8FZ;/011JX_1JY_1JY_1JY_0<FZ[`25Z^l00@F
ZkdF[;dF[;dG[;d45jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa
_`035k:o0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00
P007VjOaooooSWZfYY_4/jWBZ9g8/jWB00:VVl@01KbhgNk^m>[YlOoooc=3
Y@0500200`01P0800X001002P@03P@03P@03P@<0184200F100<01H801X80
1X800P06PP0400N20@N20@N20@R20P48P`<12H<30@Z300<12h<12h@12h@0
104<Q0<13H@30@j50`8?Q@<248D30Q66108BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP40aR800<36HP36HT36HT00`<JR@<3
6hT30ab:0`<MRP<47XX411n;0`@PR`848H/010@QS0@RS0@RS0@RS0<48h`2
12B<00<498d49Hd49Hd00PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP03
1BZ>1BZ?1BZ?00@5:hl31Bb?0`H]T0<6;Y031Rn@0`H`T@@6<I421S:A00D6
<Y86<i86<i86<i86=9800PLdTP031cFB1cFC1cFC00<7=Y<41cNC0`LhU0<7
>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL3
24:G0PQ3U`032D>H2DBH2DBH0089A9P32DFH00<9AYP9AYT9AYT00`U7V@<9
B9T00`U9V@U9VPU9VP042DZJ0`Y;VP<:C9/32TfK0PY>V`042TjL2TnL2TnL
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
10]FWP<;Eil32eRO0`]IW`<<FZ0335^P0`aLX0@<GJ4335jQ0PaOX@0435nR
362R362R362R0PaQXP043F6R3F:R3F:R3F:S10eSX`<=I:<00`eUX`eUY0eU
Y0033FJT0`eWY0<=J:D43VVU0PiZY@043VZV3V^V3V^V3V^V0`i/YP8>KJH0
10i]Y`i^Y`i^Y`i^Y`@>KjL00`i`Y`m`Z0m`Z0033g6X0`mbZ0033g>X3g>Y
3g>Y00<?M:T43gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[111l[0<@OJ`2
47j/00@@OZd@Ojd@OjdAOjd34H2]00<APJdAPJhAPJh01162[P<APjh34HB_
0a65[`<AQZl34XN`11:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@B
S;8BSK8BSK8BSK824Xjb0Q>>/P034hnb4hnc4hnc00<CT;<34i6c00<CT[<C
T[@CT[@00a>C]0@CU;@34iFe0aBF]@<DUkD359Rf0aBI]P8DV[H00aBJ]aBK
]aBK]`0259^g0aBL]`0359fg5Ifh5Ifh00<EW[P35Inh00<EX;PEX;TEX;T0
11FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk11JW^`8FZ;/011JX_1JY_1JY_1JY
_0<FZ[`25Z^l00@FZkdF[;dF[;dG[;d45jfm00<G[[dG[[hG[[h00aN__P<G
/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<0P00000QRd`10000026;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^080080019^WlOooofaJYJnUbP:l
^=d02_omok>Yd_oooooookbhgIN:_:RMb>KVk?oooc=3Y@@0080300600P02
P00400:100>100>100>10`04P@801H400`05PP06PP06PP0200J200@01h81
1h811h8128820@R30`49P`<12X<00`4;P`4;Q04;Q0040@b40`4=Q0<13XD3
0Pn50`8@Q@<24HH40Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<F
R0<GR0<GR0<GR0@368P00`<IR0<IR@<IR@030aZ90`<KR@<378X30af:0`@N
RP@47h/3122;0P@QR`04126<12:<12:<12:<0`@SS08498`00`@TS@@US@@U
S@021BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl010D[
S`<5;8l31Rf@0`H^T0<6;i031S2A10HaT@86<Y401@HbTPHcTPHcTPHcTPHd
TP021cBB00<7=I87=I<7=I<00`LfT`@7=i<31cRD0`LiU0<7>Y@31c^E0`Pl
U@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00<9@iP9
A9P9A9P00PU4V0<9AIP00`U6V0U6V@U6V@032DNI0`U8V@032DVI2DVJ2DVJ
00@9BYX32T^J0`Y<V`<:CI/22TjK00@:CY`:Ci`:Ci`:Ci`42U2L00@:DI`:
DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh42eJN0`]GW`<;F9l3
2eVO0`aJX0<<Fj0335bP10aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R
00@=HJ8=HZ8=HZ8=HZ<43F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eX
Y@@>JJD23VZU00@>JZH>JjH>JjH>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW
10i_Y`033W2W3g2X3g2X00<?LJP33g:X00<?LjP?LjT?LjT00`mdZ@@?MJT3
3gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/447b/0a1m[08@OZ`0111n[A1o[A1o
[A5o[@<AP:d00a61[A61[Q61[P044H:^0a63[P<AQ:l34HF_0a66[`<BQk04
4XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8B
S[824hjb00<CSk8CSk<CSk<00a>@/`<CTK<00a>B/a>B]1>B]0034i>d11>D
]0<CUKD359Je0aBG]@<DV;H359Vf0QBJ]P0359Zg59^g59^g008DVkL359bg
00<DWKLEWKPEWKP00aFN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX3
5JBj0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`011J[
_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o
00<G/[l35k>o0QRd`003b>3HB928B92800a8T8P00`000<SPf4R@R00=B928
00@0000H]<0H]<38h=P>B92800<0000H]<0H]<000XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008002i^WlOooojRMb?oook>YdV1<VXij]WQU[ZRM
b?ooooomo`03oooo00<c@jD0080008000`00P0<00H0200:000@00X400h40
0h400h4300B10P05P@0300F200J200J200801X801007PP47PP47PP48PP81
28<30@V30`4:P`030@^30@^40@^400@138@30@f40`4>Q@<23hD0108@QOoo
ooooooooo`824HH40Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<F
R0<GR0<GR0<GR0@368P00`<IR0<IR@<IR@030aZ90`<KR@<378X30af:0`@N
RP@47h/3122;0P@QR`04126<12:<12:<12:<0`@SS08498`00`@TS@@US@@U
S@021BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl010D[
S`<5;8l31Rf@0`H^T0<6;i031S2A10HaT@86<Y401@HbTPHcTPHcTPHcTPHd
TP021cBB00<7=I87=I<7=I<00`LfT`@7=i<31cRD0`LiU0<7>Y@31c^E0`Pl
U@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00<9@iP9
A9P9A9P00PU4V0<9AIP00`U6V0U6V@U6V@032DNI0`U8V@032DVI2DVJ2DVJ
00@9BYX32T^J0`Y<V`<:CI/22TjK00@:CY`:Ci`:Ci`:Ci`42U2L00@:DI`:
DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh42eJN0`]GW`<;F9l3
2eVO0`aJX0<<Fj0335bP10aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R
00@=HJ8=HZ8=HZ8=HZ<43F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eX
Y@@>JJD23VZU00@>JZH>JjH>JjH>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW
10i_Y`033W2W3g2X3g2X00<?LJP33g:X00<?LjP?LjT?LjT00`mdZ@@?MJT3
3gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/447b/0a1m[08@OZ`0111n[A1o[A1o
[A5o[@<AP:d00a61[A61[Q61[P044H:^0a63[P<AQ:l34HF_0a66[`<BQk04
4XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8B
S[824hjb00<CSk8CSk<CSk<00a>@/`<CTK<00a>B/a>B]1>B]0034i>d11>D
]0<CUKD359Je0aBG]@<DV;H359Vf0QBJ]P0359Zg59^g59^g008DVkL359bg
00<DWKLEWKPEWKP00aFN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX3
5JBj0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`011J[
_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o
00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf00=R<2h
00E8T8P0000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P1
0000000018S0^<SPf8S0^8S0^08008003Y^WlOooooooom_Lk61<VY>5^[>Y
d[bhgF1<VYV?_ZJKa<S3gooooc=3Y@H00803oooo0P02P00300:1oooooooo
00;oool200B100<01H7oool01H800`06PPCoool00`48PP48Poooo`03oooo
0`4:P`05oooo0@^40@^40@b4oooo008138@0104=Q?ooo`4=Q?ooo`813XD0
108?QOooo`8?QOooo`8248D00`8AQ_ooo`8AQP040Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0@368P00`<IR0<IR@<IR@03
0aZ90`<KR@<378X30af:0`@NRP@47h/3122;0P@QR`04126<12:<12:<12:<
0`@SS08498`00`@TS@@US@@US@021BF=0`DVS@031BN=1BN>1BN>00<5:8h3
1BV>00<5:Xh5:Xl5:Xl010D[S`<5;8l31Rf@0`H^T0<6;i031S2A10HaT@86
<Y401@HbTPHcTPHcTPHcTPHdTP021cBB00<7=I87=I<7=I<00`LfT`@7=i<3
1cRD0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00<9@iP9A9P9A9P00PU4V0<9AIP00`U6V0U6V@U6V@03
2DNI0`U8V@032DVI2DVJ2DVJ00@9BYX32T^J0`Y<V`<:CI/22TjK00@:CY`:
Ci`:Ci`:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN
00<;EIh42eJN0`]GW`<;F9l32eVO0`aJX0<<Fj0335bP10aMX@<<GZ4235nQ
00@<Gj8<H:8<H:8<H:82366R00@=HJ8=HZ8=HZ8=HZ<43F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@@>JJD23VZU00@>JZH>JjH>JjH>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW10i_Y`033W2W3g2X3g2X00<?LJP33g:X00<?
LjP?LjT?LjT00`mdZ@@?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/447b/
0a1m[08@OZ`0111n[A1o[A1o[A5o[@<AP:d00a61[A61[Q61[P044H:^0a63
[P<AQ:l34HF_0a66[`<BQk044XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[824hjb00<CSk8CSk<CSk<00a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d11>D]0<CUKD359Je0aBG]@<DV;H359Vf0QBJ]P03
59Zg59^g59^g008DVkL359bg00<DWKLEWKPEWKP00aFN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl
5ZVl5ZVl0aJZ_08FZk`011J[_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P03
5jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`004b>3HR<2hR<2hR<2h
1P0000B8`;P00dR@R0000<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd
`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0`00P00>VjOaoooo_;SMVHnnooooe]7Mfmc/lokoYY_4k^kdQGJ`
ThFjoooo<d>U1000P007oooo006000600060oooo00:0oooo00<00h401_oo
o`04P@04P@05POooo`05PP801X802?ooo`06PP07PP47P_ooo`48P_ooo`48
P`<12H<01?ooo`4:P`4:Poooo`812h@0204<Q?ooo`4<Q04<Q04=Q?ooo`4=
Q?ooo`813XD00`8?QOooo`8?Q@04oooo0P8AQP@24XH20Q>600@24hL258L2
58L258L30QF70P8FQ`040aJ80aN80aN80aN810<HR0030aV80aV90aV900<3
6XT30a^90`<LRP<37HX311j:10@OR`<488/2126;00@48H`48X`48X`48X`3
12><0P@TS00312B=12F=12F=00859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`041B^?0`D/S`<6;I031Rj@0`H_T0<6<9441S6A0PHb
T@051S:B1S>B1S>B1S>B1SBB0087=9800`LeTPLeT`LeT`031cJC10LgT`<7
>9@31cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G
246G0`Q2U`88@iL00`U3V0U4V0U4V0022DBH0`U5V0032DJH2DJI2DJI00<9
AiT32DRI00<9BIT9BIX9BIX010U:VP<:BiX32TbK0`Y=V`8:CY/010Y>W0Y?
W0Y?W0Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h0
0`]EWP@;EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<G:0435fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ8010eQXPeRXPeRXPeRX`@=Hj<33FBS00<=IJ<=
IJ@=IJ@00`eVY0<=Ij@33FRU10iYY@8>JZD010iZYPi[YPi[YPi[YP<>K:H2
3VfV00@>KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?L:P00`maZ0<?LZP00`mc
Z0mcZ@mcZ@033gBY10meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`@@O:`3
47f/0Q1n[00447j]47n]47n]4Gn]0a60[@034H6]4H6^4H6^00@APZh34H>^
0a64[`<AQJl34HJ_0a:7/0@BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:<
/@044Xbb4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`034i2c0a>A/`03
4i:c4i:d4i:d00<CTk@44iBd0a>E]@<DU[D359Ne0aBH]P<DVKH259Zf00<D
V[LDVkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO^0035J2h5J2i
5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`F
ZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn00<G
[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000C8h=R8`;R8`;R8`;P6
000018S0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D00028
`;R8`;Q8T8P000000QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<0
08003i^WlOoooiV?_YN:_=CCj>n//omfNnjOZe]HYJJKa9JOdV1<V[bhgOoo
oc=3Y@03002000Ooool00H000H000H3oool00X3oool00`03P@06oooo00B1
00B1oooo00F1oooo0P06PP08oooo00J200N20@N2oooo0@R2oooo0@R30`49
P`0>oooo0@Z3oooo0@^3oooo0@^4oooo0@b4oooo0@b40@f4oooo0@f4oooo
0P4>Q@040Pn5oooo0Pn5oooo0P8@Q@<24HH40Q:60P8CQP040Q>70QB70QB7
0QB70`8EQ`825XL010<FR0<GR0<GR0<GR0@368P00`<IR0<IR@<IR@030aZ9
0`<KR@<378X30af:0`@NRP@47h/3122;0P@QR`04126<12:<12:<12:<0`@S
S08498`00`@TS@@US@@US@021BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>
00<5:Xh5:Xl5:Xl010D[S`<5;8l31Rf@0`H^T0<6;i031S2A10HaT@86<Y40
1@HbTPHcTPHcTPHcTPHdTP021cBB00<7=I87=I<7=I<00`LfT`@7=i<31cRD
0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1
U`<8@YL224>G00<9@iP9A9P9A9P00PU4V0<9AIP00`U6V0U6V@U6V@032DNI
0`U8V@032DVI2DVJ2DVJ00@9BYX32T^J0`Y<V`<:CI/22TjK00@:CY`:Ci`:
Ci`:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;
EIh42eJN0`]GW`<;F9l32eVO0`aJX0<<Fj0335bP10aMX@<<GZ4235nQ00@<
Gj8<H:8<H:8<H:82366R00@=HJ8=HZ8=HZ8=HZ<43F>S0`eTX`033FFS3FFT
3FFT00<=IZ@33FNT0`eXY@@>JJD23VZU00@>JZH>JjH>JjH>JjH33VbV0Pi]
YP043VfW3VjW3VjW3VjW10i_Y`033W2W3g2X3g2X00<?LJP33g:X00<?LjP?
LjT?LjT00`mdZ@@?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/447b/0a1m
[08@OZ`0111n[A1o[A1o[A5o[@<AP:d00a61[A61[Q61[P044H:^0a63[P<A
Q:l34HF_0a66[`<BQk044XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;40
11:</Q:=/Q:=/Q:=/P8BS[824hjb00<CSk8CSk<CSk<00a>@/`<CTK<00a>B
/a>B]1>B]0034i>d11>D]0<CUKD359Je0aBG]@<DV;H359Vf0QBJ]P0359Zg
59^g59^g008DVkL359bg00<DWKLEWKPEWKP00aFN^0<EWkP00aFP^1FP^AFP
^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl5ZVl
5ZVl0aJZ_08FZk`011J[_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P035jnn
0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P0
0dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2hB928
0000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P200000hS0^004B928
00006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008002Y^W
lOoooiN:_7Y/Z[?7j:U^X<S3gi>5^U]6TiV?_P9hIJh0148WQJnUb_oooc=3
Y@@00803006000?oool00X000X401?ooo`8018400oooo`05POooo`0300J2
1?ooo`030@R20@R30@R300<12H<03_ooo`4:Poooo`4;Poooo`4;Q?ooo`4<
Q?ooo`4<Q04=Q?ooo`4=Q?ooo`813XD00`8?QOooo`8?Q@04oooo0P8AQP@2
4XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN810<H
R0030aV80aV90aV900<36XT30a^90`<LRP<37HX311j:10@OR`<488/2126;
00@48H`48X`48X`48X`312><0P@TS00312B=12F=12F=00859Hd31BJ=00<5
9hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`041B^?0`D/S`<6;I031Rj@
0`H_T0<6<9441S6A0PHbT@051S:B1S>B1S>B1S>B1SBB0087=9800`LeTPLe
T`LeT`031cJC10LgT`<7>9@31cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF
0PQ0UP04242G246G246G246G0`Q2U`88@iL00`U3V0U4V0U4V0022DBH0`U5
V0032DJH2DJI2DJI00<9AiT32DRI00<9BIT9BIX9BIX010U:VP<:BiX32TbK
0`Y=V`8:CY/010Y>W0Y?W0Y?W0Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd3
2e>M00<;E9d;E9h;E9h00`]EWP@;EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<
G:0435fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ8010eQXPeRXPeRXPeR
X`@=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU10iYY@8>JZD010iZ
YPi[YPi[YPi[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?
L:P00`maZ0<?LZP00`mcZ0mcZ@mcZ@033gBY10meZ@<?MZX33gNZ0a1hZP<@
NJ/347Z[0a1kZ`@@O:`347f/0Q1n[00447j]47n]47n]4Gn]0a60[@034H6]
4H6^4H6^00@APZh34H>^0a64[`<AQJl34HJ_0a:7/0@BR;024XV`00@BRK4B
R[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?
/a>?/`034i2c0a>A/`034i:c4i:d4i:d00<CTk@44iBd0a>E]@<DU[D359Ne
0aBH]P<DVKH259Zf00<DV[LDVkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^003
5Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@F
Yk/25ZRk00@FZ;`FZK`FZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]
_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C0
00?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005
R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8`;P40000
18S0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^08008000i^WlOooooooo`02oooo00[o[K3oMW_icMCmkNkooonVVlB5M[2l
^=gooolc@jD500200`01P003oooo00:000:100<00h400oooo`04POooo`02
00F100<01H;oool01X800P06PP0400N20@N2oooo0@R20P48P`?oool20@Z3
00_oool12h?oool12hCoool138Coool138@13HCoool13H@00_ooo`050@j5
0Pn5oooo0Pn5oooo008248D00oooo`8AQP8AQP040Q:60P8CQP040Q>70QB7
0QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0@368P00`<IR0<IR@<IR@03
0aZ90`<KR@<378X30af:0`@NRP@47h/3122;0P@QR`04126<12:<12:<12:<
0`@SS08498`00`@TS@@US@@US@021BF=0`DVS@031BN=1BN>1BN>00<5:8h3
1BV>00<5:Xh5:Xl5:Xl010D[S`<5;8l31Rf@0`H^T0<6;i031S2A10HaT@86
<Y401@HbTPHcTPHcTPHcTPHdTP021cBB00<7=I87=I<7=I<00`LfT`@7=i<3
1cRD0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1
U`Q1U`<8@YL224>G00<9@iP9A9P9A9P00PU4V0<9AIP00`U6V0U6V@U6V@03
2DNI0`U8V@032DVI2DVJ2DVJ00@9BYX32T^J0`Y<V`<:CI/22TjK00@:CY`:
Ci`:Ci`:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN
00<;EIh42eJN0`]GW`<;F9l32eVO0`aJX0<<Fj0335bP10aMX@<<GZ4235nQ
00@<Gj8<H:8<H:8<H:82366R00@=HJ8=HZ8=HZ8=HZ<43F>S0`eTX`033FFS
3FFT3FFT00<=IZ@33FNT0`eXY@@>JJD23VZU00@>JZH>JjH>JjH>JjH33VbV
0Pi]YP043VfW3VjW3VjW3VjW10i_Y`033W2W3g2X3g2X00<?LJP33g:X00<?
LjP?LjT?LjT00`mdZ@@?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/447b/
0a1m[08@OZ`0111n[A1o[A1o[A5o[@<AP:d00a61[A61[Q61[P044H:^0a63
[P<AQ:l34HF_0a66[`<BQk044XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8B
S;4011:</Q:=/Q:=/Q:=/P8BS[824hjb00<CSk8CSk<CSk<00a>@/`<CTK<0
0a>B/a>B]1>B]0034i>d11>D]0<CUKD359Je0aBG]@<DV;H359Vf0QBJ]P03
59Zg59^g59^g008DVkL359bg00<DWKLEWKPEWKP00aFN^0<EWkP00aFP^1FP
^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl
5ZVl5ZVl0aJZ_08FZk`011J[_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P03
5jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`003b>3HR<2hR<2h00^8
`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^0050000R<2hR<2h
B9280000008H]<000lSPf8S0^8S0^004R<2h0P0000F8`;P014R@R00001Rd
`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P3002000ZQ[?;icMCR
9Scd]KoR9ScdKGglhnWoooomkNko[K02oooo00<c@jD0080008001000P0<0
0H000oooo`02P002P@03oooo0P04P@05oooo00F100F100F2oooo00801X83
oooo00@11h81288128?oool30@V30P4:P`04oooo0@^30@^4oooo0P4<Q007
oooo0@b40@f4oooo0@f4oooo0@j500;oool20Pn500<248Goooooool00_oo
o`030Q660Q:60Q:600824XH20Q>600@24hL258L258L258L30QF70P8FQ`04
0aJ80aN80aN80aN810<HR0030aV80aV90aV900<36XT30a^90`<LRP<37HX3
11j:10@OR`<488/2126;00@48H`48X`48X`48X`312><0P@TS00312B=12F=
12F=00859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`04
1B^?0`D/S`<6;I031Rj@0`H_T0<6<9441S6A0PHbT@051S:B1S>B1S>B1S>B
1SBB0087=9800`LeTPLeT`LeT`031cJC10LgT`<7>9@31cVD0`LjU0<7>iD3
23bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL00`U3
V0U4V0U4V0022DBH0`U5V0032DJH2DJI2DJI00<9AiT32DRI00<9BIT9BIX9
BIX010U:VP<:BiX32TbK0`Y=V`8:CY/010Y>W0Y?W0Y?W0Y?W0@:D9`010YA
W0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP@;EYh32eNO0`]H
W`<;FIl335ZP0`aKX0<<G:0435fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<
HJ8010eQXPeRXPeRXPeRX`@=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@3
3FRU10iYY@8>JZD010iZYPi[YPi[YPi[YP<>K:H23VfV00@>KJL>KZL>KZL>
KZL43VnW00<>L:L?L:P?L:P00`maZ0<?LZP00`mcZ0mcZ@mcZ@033gBY10me
Z@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`@@O:`347f/0Q1n[00447j]47n]
47n]4Gn]0a60[@034H6]4H6^4H6^00@APZh34H>^0a64[`<AQJl34HJ_0a:7
/0@BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb
0Q:>/P8CS[800a>?/Q>?/a>?/`034i2c0a>A/`034i:c4i:d4i:d00<CTk@4
4iBd0a>E]@<DU[D359Ne0aBH]P<DVKH259Zf00<DV[LDVkLDVkL00QBK]`<D
W;L00aBM]aFM^1FM^0035Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS
^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`FZK`FZK`35ZZl0QJ[_004
5Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG
/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B9280000b>3H00:8
`;P00`0008S0^8S0^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3H
R<2hR<2h00>8`;P4000018S0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_AR
K_omoon]/?cSjOoooc=3Y@0700200`01P003oooo00:000:100<00h4300B1
0P05P@0300F200J200J200801X801P07PP47PP47PP48P_ooo`48P`<12H<3
0@Z300<12h<12h@12h@0104<Q0<13H@30@j50`8?Q@<248D30Q66108BQP82
4hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP40aR800<3
6HP36HT36HT00`<JR@<36hT30ab:0`<MRP<47XX411n;0`@PR`848H/010@Q
S0@RS0@RS0@RS0<48h`212B<00<498d49Hd49Hd00PDUS@<59Xd00`DWS@DW
SPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00@5:hl31Bb?0`H]T0<6;Y031Rn@
0`H`T@@6<I421S:A00D6<Y86<i86<i86<i86=9800PLdTP031cFB1cFC1cFC
00<7=Y<41cNC0`LhU0<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F
00@8@9L8@IL8@IL8@IL324:G0PQ3U`032D>H2DBH2DBH0089A9P32DFH00<9
AYP9AYT9AYT00`U7V@<9B9T00`U9V@U9VPU9VP042DZJ0`Y;VP<:C9/32TfK
0PY>V`042TjL2TnL2TnL2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN10]FWP<;Eil32eRO0`]IW`<<FZ0335^P0`aLX0@<
GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP043F6R3F:R3F:R3F:S10eS
X`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D43VVU0PiZY@043VZV3V^V
3V^V3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`@>KjL00`i`Y`m`Z0m`Z003
3g6X0`mbZ0033g>X3g>Y3g>Y00<?M:T43gFY0`mfZP<?MjX347RZ0a1iZ`<@
NZ/347^[111l[0<@OJ`247j/00@@OZd@Ojd@OjdAOjd34H2]00<APJdAPJhA
PJh01162[P<APjh34HB_0a65[`<AQZl34XN`11:8/08BRK0011:9/A::/A::
/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb0Q>>/P034hnb4hnc4hnc
00<CT;<34i6c00<CT[<CT[@CT[@00a>C]0@CU;@34iFe0aBF]@<DUkD359Rf
0aBI]P8DV[H00aBJ]aBK]aBK]`0259^g0aBL]`0359fg5Ifh5Ifh00<EW[P3
5Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk11JW^`8F
Z;/011JX_1JY_1JY_1JY_0<FZ[`25Z^l00@FZkdF[;dF[;dG[;d45jfm00<G
[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSP
f8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P0
1@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002R<2h
0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000>KYo7fb<cR9S`00_n]/007gb@^ojBNm[c5ojf`kW^<oooo
<d>U00P00803006000?oool00X000X400`03P@<0184200F100<01H801X80
1X800P06PP0600N20@N20@N20@R2oooo0@R30`49P`04oooo0@Z30@Z30@^3
0P4;Q0@138@30@f40`4>Q@<23hD30Q250`8AQP@24XH20Q>600@24hL258L2
58L258L30QF70P8FQ`040aJ80aN80aN80aN810<HR0030aV80aV90aV900<3
6XT30a^90`<LRP<37HX311j:10@OR`<488/2126;00@48H`48X`48X`48X`3
12><0P@TS00312B=12F=12F=00859Hd31BJ=00<59hd59hh59hh00`DXSP<5
:Hh00`DZSPDZS`DZS`041B^?0`D/S`<6;I031Rj@0`H_T0<6<9441S6A0PHb
T@051S:B1S>B1S>B1S>B1SBB0087=9800`LeTPLeT`LeT`031cJC10LgT`<7
>9@31cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G
246G0`Q2U`88@iL00`U3V0U4V0U4V0022DBH0`U5V0032DJH2DJI2DJI00<9
AiT32DRI00<9BIT9BIX9BIX010U:VP<:BiX32TbK0`Y=V`8:CY/010Y>W0Y?
W0Y?W0Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h0
0`]EWP@;EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<G:0435fQ0`aNX@8<Gj40
10aOXPaPXPaPXPaPXP8<HJ8010eQXPeRXPeRXPeRX`@=Hj<33FBS00<=IJ<=
IJ@=IJ@00`eVY0<=Ij@33FRU10iYY@8>JZD010iZYPi[YPi[YPi[YP<>K:H2
3VfV00@>KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?L:P00`maZ0<?LZP00`mc
Z0mcZ@mcZ@033gBY10meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`@@O:`3
47f/0Q1n[00447j]47n]47n]4Gn]0a60[@034H6]4H6^4H6^00@APZh34H>^
0a64[`<AQJl34HJ_0a:7/0@BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:<
/@044Xbb4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`034i2c0a>A/`03
4i:c4i:d4i:d00<CTk@44iBd0a>E]@<DU[D359Ne0aBH]P<DVKH259Zf00<D
V[LDVkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO^0035J2h5J2i
5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`F
ZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn00<G
[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0
^003B9280000b>3H00:8`;P900000XS0^005B92800006;C06;C0b>3H00>8
`;P2000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0P00P003VjOanLgDmhVG00;oool01on]/>4F=?mf
NonTW^8V??n9Oc=3Y@0800200`01P003oooo00:000:100<00h4300B10P05
P@0300F200J200J200801X801@07PP47PP47PP48PP48P`04oooo0`4:P`03
0@^30@^40@^400@138@00`4=Q?ooo`4=Q0030@j50`8?Q@<248D30Q66108B
QP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP40aR8
00<36HP36HT36HT00`<JR@<36hT30ab:0`<MRP<47XX411n;0`@PR`848H/0
10@QS0@RS0@RS0@RS0<48h`212B<00<498d49Hd49Hd00PDUS@<59Xd00`DW
S@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00@5:hl31Bb?0`H]T0<6;Y03
1Rn@0`H`T@@6<I421S:A00D6<Y86<i86<i86<i86=9800PLdTP031cFB1cFC
1cFC00<7=Y<41cNC0`LhU0<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2
242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`032D>H2DBH2DBH0089A9P32DFH
00<9AYP9AYT9AYT00`U7V@<9B9T00`U9V@U9VPU9VP042DZJ0`Y;VP<:C9/3
2TfK0PY>V`042TjL2TnL2TnL2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;
Did00`]DW@]DWP]DWP032eFN10]FWP<;Eil32eRO0`]IW`<<FZ0335^P0`aL
X0@<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP043F6R3F:R3F:R3F:S
10eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D43VVU0PiZY@043VZV
3V^V3V^V3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`@>KjL00`i`Y`m`Z0m`
Z0033g6X0`mbZ0033g>X3g>Y3g>Y00<?M:T43gFY0`mfZP<?MjX347RZ0a1i
Z`<@NZ/347^[111l[0<@OJ`247j/00@@OZd@Ojd@OjdAOjd34H2]00<APJdA
PJhAPJh01162[P<APjh34HB_0a65[`<AQZl34XN`11:8/08BRK0011:9/A::
/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb0Q>>/P034hnb4hnc
4hnc00<CT;<34i6c00<CT[<CT[@CT[@00a>C]0@CU;@34iFe0aBF]@<DUkD3
59Rf0aBI]P8DV[H00aBJ]aBK]aBK]`0259^g0aBL]`0359fg5Ifh5Ifh00<E
W[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk11JW
^`8FZ;/011JX_1JY_1JY_1JY_0<FZ[`25Z^l00@FZkdF[;dF[;dG[;d45jfm
00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<00
0lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0
000H]<0H]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^08008001i^WlOoooo>P[_ARK_ooooN9UoW=e002oooo
00?cX:kooolc@jD02000P0<00H0200:000@00X400h400h400h4300B10P05
P@0300F200J200J200801X801007PP47PP47PP48PP8128<30@V30`4:P`03
0@^30@^40@^400@138@30@f40`4>Q@<23hD30Q250`8AQP@24XH20Q>600@2
4hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN810<HR0030aV80aV9
0aV900<36XT30a^90`<LRP<37HX311j:10@OR`<488/2126;00@48H`48X`4
8X`48X`312><0P@TS00312B=12F=12F=00859Hd31BJ=00<59hd59hh59hh0
0`DXSP<5:Hh00`DZSPDZS`DZS`041B^?0`D/S`<6;I031Rj@0`H_T0<6<944
1S6A0PHbT@051S:B1S>B1S>B1S>B1SBB0087=9800`LeTPLeT`LeT`031cJC
10LgT`<7>9@31cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G
246G246G246G0`Q2U`88@iL00`U3V0U4V0U4V0022DBH0`U5V0032DJH2DJI
2DJI00<9AiT32DRI00<9BIT9BIX9BIX010U:VP<:BiX32TbK0`Y=V`8:CY/0
10Y>W0Y?W0Y?W0Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;
E9h;E9h00`]EWP@;EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<G:0435fQ0`aN
X@8<Gj4010aOXPaPXPaPXPaPXP8<HJ8010eQXPeRXPeRXPeRX`@=Hj<33FBS
00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU10iYY@8>JZD010iZYPi[YPi[YPi[
YP<>K:H23VfV00@>KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?L:P00`maZ0<?
LZP00`mcZ0mcZ@mcZ@033gBY10meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1k
Z`@@O:`347f/0Q1n[00447j]47n]47n]4Gn]0a60[@034H6]4H6^4H6^00@A
PZh34H>^0a64[`<AQJl34HJ_0a:7/0@BR;024XV`00@BRK4BR[4BR[4BR[43
4X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`034i2c
0a>A/`034i:c4i:d4i:d00<CTk@44iBd0a>E]@<DU[D359Ne0aBH]P<DVKH2
59Zf00<DV[LDVkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO^003
5J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@F
Z;`FZK`FZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn
5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h
00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00
P00;VjOaooooohUooooolj2^lI>Qoooooogolj2^oo_l<d>U00P008030060
0P02P00400:100>100>100>10`04P@801H400`05PP06PP06PP0200J200@0
1h811h811h8128820@R30`49P`<12X<00`4;P`4;Q04;Q0040@b40`4=Q0<1
3XD30Pn50`8@Q@<24HH40Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0@368P00`<IR0<IR@<IR@030aZ90`<KR@<378X30af:
0`@NRP@47h/3122;0P@QR`04126<12:<12:<12:<0`@SS08498`00`@TS@@U
S@@US@021BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl0
10D[S`<5;8l31Rf@0`H^T0<6;i031S2A10HaT@86<Y401@HbTPHcTPHcTPHc
TPHdTP021cBB00<7=I87=I<7=I<00`LfT`@7=i<31cRD0`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00<9
@iP9A9P9A9P00PU4V0<9AIP00`U6V0U6V@U6V@032DNI0`U8V@032DVI2DVJ
2DVJ00@9BYX32T^J0`Y<V`<:CI/22TjK00@:CY`:Ci`:Ci`:Ci`42U2L00@:
DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh42eJN0`]GW`<;
F9l32eVO0`aJX0<<Fj0335bP10aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82
366R00@=HJ8=HZ8=HZ8=HZ<43F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@@>JJD23VZU00@>JZH>JjH>JjH>JjH33VbV0Pi]YP043VfW3VjW3VjW
3VjW10i_Y`033W2W3g2X3g2X00<?LJP33g:X00<?LjP?LjT?LjT00`mdZ@@?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/447b/0a1m[08@OZ`0111n[A1o
[A1o[A5o[@<AP:d00a61[A61[Q61[P044H:^0a63[P<AQ:l34HF_0a66[`<B
Qk044XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[824hjb00<CSk8CSk<CSk<00a>@/`<CTK<00a>B/a>B]1>B]0034i>d
11>D]0<CUKD359Je0aBG]@<DV;H359Vf0QBJ]P0359Zg59^g59^g008DVkL3
59bg00<DWKLEWKPEWKP00aFN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`0
11J[_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o
5k6o00<G/[l35k>o0QRd`0o8h=P00`000<SPf<SPf00=b>3H00<0000H]<0H
]<003lSPf00300006;C06;C000:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P400200i^Wl@06oooolj2^m;Fom[c5nmWJ<d>U2@00P0<00H0200:000@0
0X400h400h400h4300B10P05P@0300F200J200J200801X801007PP47PP47
PP48PP8128<30@V30`4:P`030@^30@^40@^400@138@30@f40`4>Q@<23hD3
0Q250`8AQP@24XH20Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN8
0aN80aN810<HR0030aV80aV90aV900<36XT30a^90`<LRP<37HX311j:10@O
R`<488/2126;00@48H`48X`48X`48X`312><0P@TS00312B=12F=12F=0085
9Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`041B^?0`D/
S`<6;I031Rj@0`H_T0<6<9441S6A0PHbT@051S:B1S>B1S>B1S>B1SBB0087
=9800`LeTPLeT`LeT`031cJC10LgT`<7>9@31cVD0`LjU0<7>iD323bE0`Pm
U@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2U`88@iL00`U3V0U4V0U4
V0022DBH0`U5V0032DJH2DJI2DJI00<9AiT32DRI00<9BIT9BIX9BIX010U:
VP<:BiX32TbK0`Y=V`8:CY/010Y>W0Y?W0Y?W0Y?W0@:D9`010YAW0YAW@YA
W@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP@;EYh32eNO0`]HW`<;FIl3
35ZP0`aKX0<<G:0435fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ8010eQ
XPeRXPeRXPeRX`@=Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU10iY
Y@8>JZD010iZYPi[YPi[YPi[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL43VnW
00<>L:L?L:P?L:P00`maZ0<?LZP00`mcZ0mcZ@mcZ@033gBY10meZ@<?MZX3
3gNZ0a1hZP<@NJ/347Z[0a1kZ`@@O:`347f/0Q1n[00447j]47n]47n]4Gn]
0a60[@034H6]4H6^4H6^00@APZh34H>^0a64[`<AQJl34HJ_0a:7/0@BR;02
4XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P8C
S[800a>?/Q>?/a>?/`034i2c0a>A/`034i:c4i:d4i:d00<CTk@44iBd0a>E
]@<DU[D359Ne0aBH]P<DVKH259Zf00<DV[LDVkLDVkL00QBK]`<DW;L00aBM
]aFM^1FM^0035Ijh0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X3
5ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`FZK`FZK`35ZZl0QJ[_0045Z^m5Zbm
5Zbm5jbm11N]_@035jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb
_`<G/klf6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^1H008030060
0P02P00400:100>100>100>10`04P@801H400`05PP06PP06PP0200J200@0
1h811h811h8128820@R30`49P`<12X<00`4;P`4;Q04;Q0040@b40`4=Q0<1
3XD30Pn50`8@Q@<24HH40Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL0
10<FR0<GR0<GR0<GR0@368P00`<IR0<IR@<IR@030aZ90`<KR@<378X30af:
0`@NRP@47h/3122;0P@QR`04126<12:<12:<12:<0`@SS08498`00`@TS@@U
S@@US@021BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl0
10D[S`<5;8l31Rf@0`H^T0<6;i031S2A10HaT@86<Y401@HbTPHcTPHcTPHc
TPHdTP021cBB00<7=I87=I<7=I<00`LfT`@7=i<31cRD0`LiU0<7>Y@31c^E
0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00<9
@iP9A9P9A9P00PU4V0<9AIP00`U6V0U6V@U6V@032DNI0`U8V@032DVI2DVJ
2DVJ00@9BYX32T^J0`Y<V`<:CI/22TjK00@:CY`:Ci`:Ci`:Ci`42U2L00@:
DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh42eJN0`]GW`<;
F9l32eVO0`aJX0<<Fj0335bP10aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82
366R00@=HJ8=HZ8=HZ8=HZ<43F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT
0`eXY@@>JJD23VZU00@>JZH>JjH>JjH>JjH33VbV0Pi]YP043VfW3VjW3VjW
3VjW10i_Y`033W2W3g2X3g2X00<?LJP33g:X00<?LjP?LjT?LjT00`mdZ@@?
MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/447b/0a1m[08@OZ`0111n[A1o
[A1o[A5o[@<AP:d00a61[A61[Q61[P044H:^0a63[P<AQ:l34HF_0a66[`<B
Qk044XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=
/P8BS[824hjb00<CSk8CSk<CSk<00a>@/`<CTK<00a>B/a>B]1>B]0034i>d
11>D]0<CUKD359Je0aBG]@<DV;H359Vf0QBJ]P0359Zg59^g59^g008DVkL3
59bg00<DWKLEWKPEWKP00aFN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<E
XkX35JBj0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`0
11J[_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o
5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0
^?n8`;R6R<2h0DR@R04000000003R<2hb>3HR<2h0?n8`;SoR<2hQXS0^058
T8P1000000000hS0^<SPf<SPf03ob>3HolSPf8K8h=P1B9280@000000ohS0
^?n8`;R:R<2h0@000000\
\>"], "Graphics",
  ImageSize->{649, 491},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009o0001hB000`400?l00000o`00003oooo`l?3o
oo3`l87ol?3`003ooo3`l?ool?3`POo`l?000?ool?3`ooo`l?21oo3`l000ooo`l?3ooo3`l87ol?3`
003ooo3`l?ool?3`POo`l?000?ool?3`ooo`l?21oo3`l000ooo`l?3ooo3`l87ol?3`003ooo3`l?oo
l?3`POo`l?000?ool?3`ooo`l?21oo3`l000ooo`l?3ooo3`l87ol?3`003ooo3`l?ool?3`POo`l?00
0?ool?3`ooo`l?21oo3`l000ooo`l?3ooo3`l87ol?3`003ooo3`l?ool?3`POo`l?000?ool?3`ooo`
l?21oo3`l000oooooooooooooh7ooooo003oonk^k_ook^k^POo^k^h000?oi^KVooo?clooolo?cgco
clo?0_oVi^H000?ok^k^00?o^KVionk^k_o^k^h0ooo^k^koonk^kWSok^k^0Oni^KT1onk^kP7ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomf
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomf
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomf
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomf
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomf
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomf
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomf
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomf
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomf
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomf
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomf
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
oooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooo
oomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomf
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo023ooooo00?okoOgooooooo_moL00_ooool00oo_moOoooooooooo`02ooooo`03onogmooo
ooookoOg00;ooooo00?okoOgooooooooool0ooooooooooooodCooooo00?ok^k^on?Shoni^KT00_o^
k^h000?oi^KV00?o^KVion?Shoooool06_ooool00oo_inOomoO_onoWi`0KonoWi`04omKFioo_inOo
knOWomKFi`KoknOW00?okoOgooooooooool0oooooooooooooc7ooooo00?oi^KVon?Shoni^KT00_oV
i^H000?ok^k^00?o^KVion?Shoooool06Oooool03_ogmnoog]kNolk>g_nm_Kgo]Kg>olk6]One_Lko
c/JeokFmc_o>a[Go_KfmokFmc_o>a[Go]Kg>0onm_Kd01oo>c/ko_KfmolJm_One_Lkoc/JeolJm_One
_Lh00_nm_Kd01Oo6_Kgo]Kg>okfm_Oo6_Kgo]Kg>00?o_Kfm00Woc/k>okfm_Onm_Kgoa[fmokFmc_nm
_Kgoc/k>olkFg_o_inL0oooooooooooooc;ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o
^KVion?Shoooool06Oooool01OoNg]koc/k>ojf]YOn][JGoW9bU017oW9bL00?oW9bUojfUU?nLW:D0
0_nLW9`01on]YICoW9bUoibLW?nLW9co[JfUoibLW?nLW:D00_nLW9`00on][JGoW9bLoibLW002ojf]
Y@03olk>c_oNg]kokoOg0?oooooooooooolbooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03
okVi^OoShn?ooooo01Wooooo00?oknOWomkNg_ooool09_ooool2omkNgP03onoWiooooooooooo0?oo
ooooooooool_ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Wooooo
00?og]kNolkFc_ooool04oooool00oogmnooooooooooo`02ooooo`05onO_moooooooooooooooooo_
inL00_ooool00oo_inOoooooonO_m`02ooooo`04onogmoooooooinONolk>c_oooooooooooolboooo
o`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo01Sooooo00?oinogonOWg_o>
e]h00_ooool00oo_moOoooooooooo`0;ooooo`03onogmooooooooooo00?ooooo00?oinogoooooooo
ool02_ooool01oo_inOooooooooooooooooog]kNolkFg_o_inL0oooooooooooooc7ooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool06Oooool00ooNg]kog/k6ooooo`0Aoooo
o`03onogmooooooooooo00;ooooo00?omnoWooooooooool00_ooool01?oWkoOooooooooooooWkoL5
ooooo`05onoWioooooooknOWolk>c_o_moL0oooooooooooooc;ooooo00?ohn?SokVi^Oooool00Ooo
ool000?ok^k^00?o^KVion?Shoooool06?ooool00oogmnooimkNolkFgP0>ooooo`03onogmooooooo
oooo00Cooooo00?omoO_ooooooooool02_ooool00oo_moOoooooonO_m`02ooooo`03omkNg_o>e/ko
knOW0?oooooooooooolaooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo
01Wooooo00?og]kNolk>c_ooool00oooool02_o_inOoc/k>onoWioo_moOoooooonO_moooooooknOW
olk>c_o_inL2ooooo`03onogmooooooog]kN00Gog]kN00Koe/kFohAkLonLJf?o[G]SoljmYOnDS8`2
ojekH`0:okfm_Oo>a[Gog]k>olk6]Onm_JgoinogoooooooNg]koc/k>onogmooooooooooooolaoooo
o`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo01Wooooo00Coe]KWomkNc_oo
ooooknOW0_nm_Kd01Oo>c/koW9bLojfe]Oo>c/kokoOg00;o[JfU0_nLW9`07On<S8co_Kfmojf]YOo_
inOoooooonOWg_o_inOomoO_onoWioogknOoinONomk>a_mBBT;oNa08oh@H4?n]Nf?oU48aog<H4?nL
<B7ocZF4omkNc_o_ilkog]k>olk6]Oo_inOoooooomkNg_o>e]koknOW0?oooooooooooolaooooo`03
onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo01Sooooo00?omoO_onOWg_o>e]h0
0_ooool00ooFc]Kog]kNonoWi`02omkNgP07onoWioooooooe]KWonoWioo>e/kog]kNokfm_@02omkN
gP;ooooo01Soc/k>ohBDU?nLW:GoW9bLog^4Q?m[Lg?oFV][odXH6?mc613oW34Qoh@i<OmS61SoQ24H
ojEcF_n]Nf?oW9bUoib4NonDS6?o[KFeooOgkoooooooknOWolk>c_o_moOooooooooooooo<_ooool0
0ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0Iooooo`03omKFiooFc]Kooooo
00Oooooo00?okoOgooooooooool00_ooool00ooWkoOoooooooooo`02ooooo`0>omk>a_n<S8coS8b<
of][Jon<S8co[JFDof][JomB20SoJc4Yoi`a8On]Nf?oQ1P@oh@Q6?m[<BT2odYBFP08oeYJF_mBBT;o
Jg=conoWiooooooog]kNolkFg_o_inOooooooooooooo<Oooool00oo^k^kohn?SokVi^@02onk^kP00
0ooVi^H00oni^KWohn?Sooooo`0Iooooo`05omkNg_o>e/koooooooO_ion]]KD00_nm_Kd01one_Lko
_Kf]onoWioo>c/ko[JfUonoWion]]KD00_nm_Kd04ooNg]ko]Kg>olk6]Oooooooc]KNokfm_On][JGo
W9B<ojfUU?o>a[GoNg=SoaP@4?mB20So[G]Soha[B_n48ASoNc4Yoe8i<OlY:BT00oli>C401_mJFT;o
knOWoooooooWimkoc/k>onogmooooooooooooolaooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^
kP03okVi^OoShn?ooooo01Sooooo02gokoOgonOWg_o>c/koooooonogmonm_Kgo[JfUolk>g_o>a[Go
c/k>onoWioo>c/ko_KfmonoWion][JGo_Kfmolk>c_oNg]koc/k>ojfe]Ooooooog]k>okfm[On][JGo
W9bLojfLQ?o>_JGoLf]Sob4H4?mBBT;oHd8iodXa:OmB>C7oDSTYog]kNomkQ8CoFUYJodYB>Om:BS7o
BU8ionoWioooooooe]KWolkFc_o_inL0oooooooooooooc7ooooo00?ok^k^on?Shoni^KT00_o^k^h0
00?ooooo00?o^KVion?Shoooool06Oooool02?oNg]koc]KNooooooooooookoOgooooooo_inOoinog
1Oooool00oo_moOoooooooooo`02ooooo`09onoWioooooooc/kNokfm[Onm_KgoU8b<og=cF_n]W8Co
Lf]S00;oDSTa00oo@RTQoe8i<OmJ@SWoDSTaohb<Lon<S8coNg]kof]SD_m[Jd[oFV=JonoWiooooooo
inONolk>g_ogmnl0oooooooooooooc;ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVi
on?Shoooool06?ooool2onoWi`03omK>e_ooooooknOW00;oc/k>00WoW9bUojfUU?ne_Lkoc/JeomkN
g_o>e]koc/k>omkNg_o>e]h00_o>c/h03?o6_Kgoc]KNooooooo>a[GoS8b<ohb<LomJFT;oS8b<olk6
]OmcJf?oDTY2oc4H40;oDSTa00CoLeYBoe8i<OmJFT;oNg=S0_m[JdX01omJFT;oJf]:onoWioo_moOo
knOWolkFc_o_inL0oooooooooooooc7ooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVi
on?Shoooool06Oooool01_oNg]koc]K>oooooooooooo[JfUojfe]@Co_Kfm00Kog]kNokfm_Oo>a[Go
c]KNolk6]On]]KD2okfm_@0Aojf]YOoooooo[KFeodY:B_mBBT;oJf=Bohb<LonLQ7_oFUYJoe8i:Om2
:B7oJdY2oeYJ@_mcFU;oHeY:obTY6?li>AP00_mJDRT01_li>ASoNf=:onoWiooooooog]kNolk>c_oo
oooooooooolbooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo01Sooooo
00KokoOgonOWg_o>c/koooooonogmoo_inL9ooooo`0NonoWiooWimkoooooonogmoo_inOoooooojf]
YOlY<BWo:BTHodY::On]YICoa[fmocTi<Om2:B7oDSTaoe9:@_mkFT[oJf=BoeY2>OlY:ASoBS4YodY:
:OmcLe[oBS4Yoe9S@_oFe^OoooooonOWg_o>e]koknOWoooooooooooooc7ooooo00?ok^k^on?Shoni
^KT00_o^k^h000?ooooo00?o^KVion?Shoooool06Oooool02_oNg]koc]KNooooooo_inOoc]KNomkN
g_o>c/kog]kNolk>c_o_inL2olkFgP0PonoWiooNg]koc]KNolk>c_oFc]KoknOWolkFg_o_moOo[JFD
o`000?lY:ASo>B4HoibDS?o>aZgoNg=SobTY6?m2:B7o[G]SoiA[F_m[<BWo>CTHobTY6?la>B7oBTXY
odY:<Oli>ASoBTXaonoWioo_moOoknOWolk>c_o_moOooooooooooooo<_ooool00ooShn?o^KVioooo
o`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0Hooooo`0]onogmoo_inOoc/k>oooooooNg]ko_Kfm
ojf]YOn]]KGo[JfUoibLW?nea]Ko[JfUokfm[Oo>e]koc/k>oibLYOn][JGo_KfmolkFc_nm_KgoknOW
ojf]YOl@003o:BTHoc4i8Onm_Jgog/jmohb<LolY:ASoLeYBojekHoo6[IcoQ7]coc4i8OlH413o>CTH
odYB>Om:FT;o:BTYocU2<Oo_inOoooooomKFioo>e/koknOW0?oooooooooooolaooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Sooooo0_o_inL00oo>e/koooooooooo`03
onogm`04ooOgkoo>e]koinONonoWi`KokoOg0oooool06?n][JGo:BTHobTY6?lY:ASoS8acoljmYOm:
FT;o:BTHocTQ6?mkHd[oS6]:oeYJ@_li@S7o:C4YobTQ2?m:DSWoQ9BDog^4Q?mJHe[oknOWonogmooW
imkoc/kNooOgkooooooooooooolaooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoS
hn?ooooo01Wooooo00?og]kNolk>g_ooool01?o_inL01?oFe^OoknOWonOWg_oFe^L6onoWi`05omKF
ioogknOoooooojf]YOla>B400_m:FT802OnDS6?o_Kf]ojfe]Om[Lg?o4108ocTQ6?la613o610@oeY[
J`02oeYSFP09of=cS?n]]KGoW;GNojFec_o_inOokoOgomkNg_o>e/koknOW0?oooooooooooolaoooo
o`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo01Wooooo00Kog]kNomkNc_oo
ooooc]KNokfm_One[Jd2ojf]Y@0Eohb<S?ne_Lko_Kf]oibLYOn][JGo[KFeokfm_On][JGo[KFeojf]
YOoWkoOoooooolk>c_mSLhcoNhB4of]SD_mkNg_o_Kf]ojfUU?n<S8co:BTY00;o000000goBU9Joibe
g_nU]LkoW;GNojFmg_nL]NOo]LKFoibeg_o_inOomoO_omkNg_o>c/kokoOg0?oooooooooooolboooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo01Wooooo00Gog]kNolkFg_oo
ooooknOWomkNgP02onogm`03onoWioo>c/kokoOg00;oknOW00?oc/k>onoWioo>e]h00_o_inL01?oW
koOomnoWooOgkooFe^L2oib]_@06oibLYOn][JGo_KfmokFmc_nea]KoYKG>0_mSLh`6oibegP07oibe
ionU]LkoknOWoooooooNg]koc]KNonoWi`3ooooooooooooo<Oooool00oo^k^kohn?SokVi^@02onk^
kP000ooVi^H00oni^KWohn?Sooooo`0Hooooo`;oknOW00Goc]K>ooooooo_inOoknOWonogm`02onoW
i`03ojfe]Oo_inOokoOg00GoknOW00GoinogooO_iooWkoOoooooolkFgP02ojfmi`03ojg6monL[Kgo
c/J]00?oW;GW00Go[LK_oibeionL]MkoW;GNoibei`05oibegP05olkFg_o_moOog]kNolk>c_o_moL0
4_ooool00oolo?coj^[Zooooo`0<ooooo`03ookno_oYjNWoo_kn017ooooo00ColO7aooooooojn_[o
m?Cd0_ooool00oomoOgoj^[Zooooo`3ooooooo;ooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^
00?o^KVion?Shoooool06Oooool02?oWimkoc/kNooooooo>e]koW9bLolk6]One_Lko[KFe0_n][JD0
0onLW:Go[JfUoibLW002olk>cP0@ojfe]On][JGoS8b<olk>c_oooooo]LKFoib]g_nL]MkoW:gNoib]
_On][JGoW:gNoib]c_nL]MkoW:gNoib]cP;oW:gN00KoW:g>oib]g_nL[MkoW:g>oib]g_nL[Lh2onoW
i`03omkNg_o>e/koknOW00_ooooo00?o1PH6om_Kfoooool00oooool01OnQXJ7o4Q8BocLg=olQ8B7o
bl_;00;ooooo00KoUiNGo`l?3oojn_[ooooooda<C?mFEUH2ooooo`08ok6a/OlG5aOo>CTioc@d=?ni
^KWoooooo`h>3_oRh^83ooooo`0Do`P82?ooooooooooohb<S?oLg=coooooofIVI_n;Rh_ok>c/obHV
9_l/;2coFUYJoc8b<_mcLg?oooooojj^[_l@413o;2`/ob<S8ooXj>Sooooooo7ooooo00?ok^k^on?S
honi^KT00_o^k^h000?ooooo00?o^KVion?Shoooool06?ooool02?o_moOog]kNomkNc_ooooooknOW
olkFg_o_inOomoO_0oo_inL01Oo>e]koknOWonOWg_oFe^OoknOW00?og]kN00GoknOWonogmoo_inOo
c]KNomkNgP02olkFgP04omk>a_oFe^Oog]kNomKFi`;oc]KN00?og]kNolkFg_o>e]h01?o>e]h01One
a]KoknOWooOgkoo>e]koc/k>00cooooo00?o1PH6om_Kfoooool00_ooool01_olo?co5QHFomWIfOoo
ooooXZ:Roe5AD@;ooooo00[oCTi>ob<S8onk^k_on_[joaLG5olT92Com_KfonKVi_l;2`_oalO71?oo
ool00ol>3Pkoh^;Rooooo`02ooooo`0Bo`P82?ooooooaLG5o`<30om^KVkoooooofIVI_n;Rh_oXJ6Q
od=3@ooooooobl_;o`@41?olo?coo_knoadM7OnYZJWooooo0_omoOgooooooo;ooooo00?ohn?SokVi
^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool06Oooool2omkNgP0>ooooooo_inOooooooooo
oooFe^Ooc/k>onoWioogmnooooooooOgkooWkoOoknOWokfm_OoNg]h2ooooo`0:onO_moo_inOokoOg
ooooooo_inOoooooooO_ioooooooinogonogm`;oknOW00CoooooonoWiooWkoOomoO_0_o_inL00ooN
g]koknOWonogm`02onoWi`03omkNg_o>e/koknOW00_ooooo00?o1PH6om_Kfoooool00_ooool04Onm
_Kgo:RXZooooooooooookNg]o`T92Ooclo?onOWio`l?3on^[ZkoK6a/ol30`?m:BT[oJFUYojn_[on[
Zj_o8B4Q00?o_kno00CojNWYooooool>3Pkoh^;R0oooool04Ol820SoooooofYZJ_m_Kfoo9bLWoo_k
nomVIVKoRh^;on7QhOlN7QkoTY:BokVi^Ol820Sooooool71`OlF5QKooOgm0?oooooom?ooool00oo^
k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0Hooooo`;oknOW013oc]KNooooooo_
moOo[JfUokfm_Oo>c/koS8b<ojf]YOne_LkoknOWoibLW?n][JGoS8b<ohBDU?nDS8co[KFe0_n][JD0
2Oo>c/koknOWonO_mooNg]koW9bUolk>c_n]]KGo[JfUoibLW002olk>cP08oibLW?oNg]ko[JFDolk>
g_n][JGoW9bUohBDU?o>e/h2onoWi`04onogmoo>c]koc/k>onogm`_ooooo00Oo1PH6obLW9omZJV[o
^;RhoogmoOo:b/[o8R8R00;ooooo00goiNGUo`l?3ooinOWo^k^kocdm?Ookno_o;Rh^ogUiNOn>SXko
_;bloeaLG?o7alOo5aLG00;oM7Ad00Go6a/Kol71`Ooooooo3Ph>omoOg`03ooooo`0Ao`P82?ojn_[o
4a<Com7AdOmZJV[o/K6aofIVI_n;Rh_oooooooclo?o?clooSHf=o`P82?oooooobLW9o`h>3_ojn_X0
ooooooodooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo01Wooooo00Go
g]kNolkFc_ooooooknOWolk>cP03omkNgP0:olkFg_o_inOoknOWomkNg_o>e]koc/k>omK>e_n]]KGo
g]k>olkFgP;oc/k>00OoooooonoWion]]KGoS8b<okfm_On][JGog]kN00;oc/k>00Wog]kNolk>c_oN
g]koc/k>omkNg_oFc]Koc]K>olk>c_oFe^L00oo_inL00ooNg/koc]KNonoWi`0;ooooo`0]o`H61_oB
d];o^;Rhob@T9?n6QXKoooooob4Q8Onl_;coo?cloh:2P_mOGeooooooog9bL_n5QHGooooooeYJF_lC
4a?odm?Coo_knolR8R;on?Shob8R8_oPh>3okno_oadM7Oojn_[oooooo`h>3_mKFe_ok>c/ookno_oo
oooo20P8ok>c/ol];BgoooooolW9bOmCDe?oIVIVoh^;Roooooooc<c<oogmoOo7alOo9bLW00;ooooo
00Go8R8Rohj>S_okno_on?ShooknoP3ooooooo7ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo
00?o^KVion?Shoooool06Oooool01?oWimkoc]KNooooooo_moL3ooooo`05onoWioooooooinogoooo
ooogknL00oooool02?o_inOokoOgonoWioooooooknOWoooooooNg]koc/k>0_oNg]h02_o_inOooooo
onO_moooooooknOWonO_moogknOoinogonoWiooWkoL4onoWi`05omKFioo_inOoc]KNomk>a_o_moL0
2oooool04Ol61PKofm_Koooooon?Shoo<30`ooooooo1`L7o=CDeobDU9Om;Bd_ohN7QoooooomBDU;o
dM7Aoooooona/K7o>SXj00;ooooo00KoMWIfolO7aonk^k_o<C4aoclo?on_[jl2ooooo`08ocLg=onU
YJGo;2`/ok^k^ooooooo20P8oeQHF?n8R8P2ooooo`08obh^;_mDE5CoRh^;oooooomXJ6So>SXjoc8b
<_nVYZH2ooooo`05om3@d?mZJV[o;2`/ob`/;?ogmoL0ooooooobooooo`03on?Shoni^KWooooo007o
oooo0003onk^kP03okVi^OoShn?ooooo01Wooooo00Goe]KWolk>c_ooooooknOWojf]Y@02ojfe]@09
okfm_On]]KGog]kNokfm_On]]KGoinONojf]YOne_Lko[JfU00;oc/k>00Oo]Jf]okfm_On]]KGoW9bL
ohb<S?nm_Jgoc/kN00;o[KFe0_n][JD01_o>c]ko_Kfmojf]YOnm_Kgoc/k>ojf]Y@;o[KFe0_n][JD0
1Oo>c/koknOWolkFc_o>c/koinog00_ooooo00Go1PH6om_Kfooclo?oFe]KoeaLG00Kooooo`03o`L7
1ol;2`_ohn?S00;ooooo00?oQHF5o`X:2_n;Rh/0ooooooomooooo`03onk^k_oShn?o^KVi00;ok^k^
0003onKViP03okVi^OoShn?ooooo01Sooooo00SomoO_onOWg_oNg]koooooonoWion]]KGo[JfUolk>
cP;o_Kfm00Cog]kNolk>c_n][JGoe]KW0_n][JD01_o>c/kog]kNokfm_OnLW9coc/k>olJm_@;o_Kfm
00[oc/k>omkNg_n]YICo[KFeolk>c_nm_Kgoc/k>ojf]YOne_Lkoc/k>0_nm_Kd01_n][JGoc/k>okfm
_On][JGo_KfmonoWi`;oc/k>00?omoO_ooooooooool02Oooool01OlC4a?o8b<SoaPH6?ll?3cod];B
01_ooooo00?o4a<CodM7Aoooool00_ooool00ooRh^;o3@d=oi6AT@3ooooooogooooo00?oi^KVon?S
honi^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool06Oooool01?oFe^Ooc]K>ooooooo_moL3onoW
i`06omkNg_ooooooooooonoWioooooookoOg0_o_inL01_oooooomoO_ooOgkooFe^OomnoWonO_m`;o
moO_00?oinogonogmoo_inL00_o_inL01_oWkoOoknOWomkNg_oWkoOoknOWolkFgP?oknOW00Ooe]KW
omkNg_oNg]koinONolk>c_o>e]koknOW0?oooooooooooolaooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo01Sooooo00OomoO_onOWg_oFc]KoooooonoWioo>c/ko[KFe00;o
W9bL00[o[JfUokfm_OoNg]koc/k>okfm_OoNc/Koc]KNokfm_One_Lko_Kfm0_o>c/h03onm_Kgo]Kg>
olk>c_o>a[Goc]KNokfm_On]]KGoc/kNomkNc_nm_Kgo[KFeokfm_On]]KGo_Kfmolk>cP02okfm_@04
olk>c_n][JGo_Kfmolk>gP;oc/k>oooooooooooooc?ooooo00?ohn?SokVi^Oooool00Oooool000?o
k^k^00?o^KVion?Shoooool06Oooool01ooFe^Ooc]K>ooooooo_inOoW9bLokfm_On][JD00_nm_Kd0
1On]]KGoc/k>okfm_Onm_Kgoc]KN00;o[KFe00Ko[JfUojfe]On][JGo[KFeokfm_On][JD2okfm_@08
omkNg_nL[Kgo[JfUolk6]Oo>e]koQ9BDojf]YOn]]KD2ojf]Y@0:olk>c_nm_KgoW9bLokfm_On<S8co
W9bLomkNg_o>c/kog/k6onO_mooooooooooooolaooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo01Sooooo00KomoO_onOWg_o>c]komoO_onoWiooNg]h2onO_m`06onoWioo_
moOoknOWonO_moo_inOokoOg0_o_inL01?o>c]koknOWooOgkoo>e]h2omkNgP_oknOW00Kog]kNonoW
iooNg]kog]kNolk>c_oFc]H2olk>cP04olkFg_o>c/koc/k>ooO_iooooooooooooolaooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo01Wooooo00Coe]KWolk>c_ooooooe]KW
1Oo>c/h01?oNg]koc/k>olk>c_oWg]h4olk>cP0<olk>g_o>c/koc/k>ohBDU?nm_Kgoc/k>olkFg_o>
c/ko_Kfmolk>c_nm_Kgoc/kN0_o>c/h01onm_Kgoc/k>okfm_Oo>c/ko_KfmokF][On]]KD00_nm_Kd0
1?oNc/Ko_Kfmolk>c_o_moOooooooooooooo<Oooool00oo^k^kohn?SokVi^@02onk^kP000oooool0
0oni^KWohn?Sooooo`0Iooooo`04omkNg_o>c/koooooolkFgP?o[JfU00goW9bUohb<S?o>c/koW9bL
ojf]YOnea]Ko_KfmohBDU?n]YICo[JfUolk>c_n]]KGoc/k>00;o[JfU00CoW9bLokfm_Oo>c/ko[JfU
0_n<S8`04?o6_KgoW9bLohb<S?nLW9coW9bUohb<S?nm_KgoS8b<oibLW?nDS8coW9bLohb<S?ne_Lko
_KfmomkNc_o_inOooooooooooooo<_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWo
hn?Sooooo`0Hooooo`04onogmoo_inOoc/k>onogm`?oknOW00Gog]kNonoWioo>c/koc]K>omkNgP05
onoWi`03onOWg_o_inOoknOW00;oknOW00Koe]KWomkNg_o>e/koknOWonOWg_oFe^L3olk>cP08okfm
[Oo>c]koc/k>omk>a_ne_Lko_Kfmolk>c_ne_Lh3okfm_@03okfm[Oo>e]kooooo0?oooooooooooola
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Sooooo00ComnoWomKF
iooNg/kooooo1?oNg]h01oo>c/kog]kNolk>g_oNg]kog]k>omkNg_o>e]h00_oNg]h00oo>c]kog]kN
omkNgP02omkNgP0:olk>c_o_inOoc/kNomkNc_ne_Lkog/k6ojf]YOnLW:Go]Kg>okF][@;o[JfU00?o
[KFeojf]YOn][JD00_n][JD01_nLW:Go[JfUojfe]Onm_KgoknOWonogmooooooooooooolaooooo`03
onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo01Wooooo00CoknOWolk>c_o_moOo
c/k>0_n][JD00onLW:GoW9bLohb<S002ojf]Y@0=ohBDU?nLW:Go[JfUojf]YOnLW:Go[JfUoibLYOo>
a[GoW9bUohb<S?nLW9coc/k>ohb<S003oibLW004ojf]YOn<S8coNg]kog]kN`;oJf][00[oW9bLof][
Jom[Jf_oNg]kohb<S?mJFU[oW9bLojf]YOo>c]koknOWoooooooooooooc;ooooo00?ok^k^on?Shoni
^KT00_o^k^h000?ooooo00?o^KVion?Shoooool06?ooool01_oWkoOoinONolk>c_ooooooc/k>olkF
gP?og]kN00[o_KfmomkNg_oNg]kog]kNokfm_OoNg]koc/k>olkFc_oNg]koinON0_o>c/h00onm_Kgo
c/k>omkNgP02omkNgP0<olk>c_o>e]koc/k>okfm_On][JGoW9bLohb<S?mkNg_oS8b<og]kNomkQ8Co
Ng]k0_n<S8`00onLW9co_KfmonoWi`3ooooooooooooo=?ooool00ooShn?o^KViooooo`01ooooo`00
0oo^k^h00oni^KWohn?Sooooo`0Iooooo`04onOWg_o>c/kokoOgonoWi`Cog]kN0_nm_Kd02?oWimko
g]kNomkNg_oNg]koinONomKFiooNg]koe]KW1_oNg]h02?o>c]kog]kNomk>a_o>c/ko_KfmoibLW?n<
S8coJg=c1?m[Jf/01OmkNg_oNhB4oibLW?nm_Kgog]kN0?ooooooooooooldooooo`03onk^k_oShn?o
^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Sooooo00[omoO_omKFioo>e/koinogonoWion<
S8co[JfUolk>c_n4U9Co]Jf]1OnLW9`01Oo>c/ko[JFDojf]YOn<S8coW9bU00;o[JfU00?oW9bLojf]
YOn<S8`00_nLW9`00omkQ8Co_Kfmog]kN`03of][J`03ohb<S?mkNg_oS8b<00;o[JfU0_o>c/h00ooN
g]koooooooooo`3ooooooooooooo<oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWo
hn?Sooooo`0Iooooo`07omkNg_o>c/kokoOgonoWioo>c/koc]K>onOWgP02omkNgP09olkFg_o>c/ko
c/k>olkFg_o>c/kog]kNolk>c_o>c]kog]k>00?oc/k>00?o[KFeolk>c_o>c/h00_o>c/h01Oo6_Kgo
]Kg>ojf]YOn<S8co_Kfm00Cooooo00CoknOWomkNg_o>c/kog]kNooooooooooooocKooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool06Oooool01ooNg]koc/k>onoWioo_inOo
g]kNomKFioo_inL00_oNg]h02_oWg]koknOWonoWioo_inOog]kNolk>g_oWimkog]kNomKFioo_inL6
omkNgP?oc/k>00?o[KFeoiB<S?o>c/h00oooool2omkNgP03olk>c_oNg]kooooo0?oooooooooooolg
ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo01Sooooo01SoinogonOW
g_o>c/kokoOgolk6]Oo>S6?og/jmonoWiooN_JgoaW]:olk6[Oo>e]ko[JfUohBDU?n]]KGoW9bLolk>
c_n]]KGo[JFDohBDU?n]]KGoW9B<olk>c_nLW:D4oibLW00:ojf]YOmkQ8CoJf][okfm_OooooookoOg
onOWg_oNg]koc/k>omkNg_oooooooooooolhooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03
okVi^OoShn?ooooo01Wooooo01Soc]KNolk>c_o_moOoknOWolJ]W?oNg/koknOWolJ]W?o>S6?oknOW
omKFionm_Jgoc/k>ojfe]Oo>c/kog]kNolk6]One_Lkoa[fmolk6]One_Lkoc/Jeojf]YOn]]KD2okfm
_@0:oibLW?n][JGoS8b<og^4Q?o>c/koooooonoWioo>e]koc/k>omkNg_ooooooooooooliooooo`03
onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo01Sooooo00gokoOgonoWioo>c/ko
knOWonOWg_o>e/kocZF4olk6]Oo6Nd[oc[fUonoWiooWimkoc]KN00;oknOW00?oinONomkNg_oNg]h0
1?oNg]h00oo>c]koc/k>omkNgP02omkNgP09olJm_One_Lko[JfUohb<S?o>c]koknOWomkNg_o>c/ko
g]kN0?ooooooooooooljooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo
01Wooooo00Wog]kNolk>c_ogmnooe]KWonoWiooF]Icoc/JeolIkB_o>e]h00_o_inL00ooWimkoe]KW
onOWgP05omkNgP04olk>g_oNg]kog]k>omkNgPCoc/k>0_n][JD01On<S8cog/k6omkNg_o>c/kog]kN
0?oooooooooooollooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo01So
oooo00?oinogonOWg_o>c/h00oo_inL00oo>a[GocXaSoljLN`02onoWi`03onOWg_oNg]kog]kN00?o
g]kN00Soc]KNomkNg_oNg]kog]kNomkNc_oFc]Koc/k>omkNgP;oc/k>0_nm_Kd2oibLW003olkFg_o>
c/kog]kN0?oooooooooooollooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo01Wooooo00cog]kNolk>c_o_inOoknOWolkFg_oWimko]G=Jolk6[Oo_inOoinONomKFiooWimh5
omkNgP06omkNc_o>c]kog]k>olk>g_oNg/koc/kN0oo>c/h01_nm_Kgo[KFeoibLW?nm_Kgoc/k>omkN
g_oooooooooooolmooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo01So
oooo00GokoOgonoWioo>c/komoO_olkFgP02onoWi`04olk6]OoWimkoinONomKFi`Gog]kN00Ooc/kN
omkNg_o>e]kog]k>olk>g_oNg/koc]KN00?oc/k>00Ko_Kfmojfe]On][JGo[KFeolk6]OoNg]kooooo
oooooooo?_ooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Iooooo`0;
onoWioo>e]koknOWonOWg_o>e]koknOWonOWg_oFe^OoinONomkNg_oWimh00ooNg]h01ooNg/kog]kN
omkNc_oFc]Kog]kNolk>c_o>e]h00_o>c/h01oo>a[Go]Kg>okfm_Onm_Jgo[JfUojfe]OoFe^L0oooo
oooooooood3ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool06Oooool0
4?o_moOoknOWooOgkooFe^OoknOWonOWg_oFe^OoinONolkFg_oWimkoc]KNomkNg_o>e]kog]kNolkF
g_oNg]h2olkFgP03olkFc_o>e]koc/k>00?oc/k>00Go_Kfmojfe]On]]KGoc/k>onoWi`3ooooooooo
oooo@?ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0Jooooo`koknOW
00Sog]kNonoWioo_inOoknOWomkNg_o_inOog]kNonoWi`;og]kN0_o_inOooooooooooooo@_ooool0
0ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`3oooooooooooooM_ooool00oo^
k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`3oooooooooooooMoooool00ooShn?o
^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`3oooooooooooooM_ooool00oo^k^kohn?S
okVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`3oooooooooooooM_ooool00ooVi^Kohn?SokVi
^@02onKViP000oo^k^h00oni^KWohn?Sooooo`3oooooooooooooM_ooool00oo^k^kohn?SokVi^@02
onk^kP000oooool00oni^KWohn?Sooooo`3oooooooooooooMoooool00ooShn?o^KViooooo`01oooo
o`000oo^k^h00oni^KWohn?Sooooo`0Cooooo`0:ono_koo_g^OoinoWomKWg_nUW:GoHe9SoiBDU?ne
e/Koe]kNonOWi`Gooooo00?oinoNooooooooool0oooooooooooooe7ooooo00?ok^k^on?Shoni^KT0
0_o^k^h000?oi^KV00?o^KVion?Shoooool04oooool03_o_knookmkWolk>c_n4Q8Co410Hod8i@_lH
8ASoLiakof]cJomkQ7_oW:FLokFm_OoFe]koinoWoooooooooooooeGooooo00?oi^KVon?Shoni^KT0
0_oVi^H000?ok^k^00?o^KVion?Shoooool04oooool04_o_knooe]KFojf][OlY:BWo[Jf]onoWkolH
<ASoNkf<og>mNomS]G_oHiacof><JomSQ6_oQ8b4ojF]YOo>a/Kog]kNonOWiooooooooooooomAoooo
o`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo01?ooooo01GoinoWolK6a_n<
Q8Co<C4aonoWkoo_knooBV]:of_>NomcihCoJnMkof_FNomJaW?oHkEcoeZUJomJS6_oHhacog]kNonD
U9Co[Jf]olk>c_oNg]h0ooooooooooooodoooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o
^KVion?Shoooool04oooool02_oFg]Ko_KfeohB4Q?mBDU;oinoWonoNiomJJe[oLkecohCNS?mkkh@3
og_NS00<of_WQ?m[gXCoF]Ikof>eLomJYF_oFXaSof><JomcS7_oU9BDokfe_OoNe]KoimkW0_ooool0
0oo_g^Ooooooooooo`02ooooo`;oinoW1_ooool00ooWknOoooooooooo`3ooooooooooooo>?ooool0
0oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0Cooooo`0<omKNg_o>c/KoW9BL
of=SHooWknOoknO_of=cJon<cXCoYNNLojGWU?nDihcoNnn40_n4gX`03omkkhcoNmj<og?FQ?mccXCo
Jlikof^mQ?mSYG_oHiacof>UNomSU7?oNiAkoiB]U?nea[Goe]KFooooo`03onoNiooooooooooooom3
ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo01?ooooo00SoinOWomK>
c_nUW:GoFUYSomK>c_o6a/KoBUYBof^eJ`;oNnn400CoW>nDoicNU?nUiiCoW>nD0_nDgX`00on4khco
NnN4og_WQ002og_NS00;og_WU?mSeXcoHmJ<oeZUJomSU6_oFXaSof><Lon4W8coYJFUolK6a_oWg^L0
1?ooool00ooWknOoooooooooo`3ooooooooooooo??ooool00oo^k^kohn?SokVi^@02onk^kP000ooo
ool00oni^KWohn?Sooooo`0Cooooo`08ono_kooWinOo[Jf]of][JooFc/koa/K6oe9SF_m[]F/2of?W
L`09og?WNomkig_oNnn4oiCWS?nLkiCoYNnLoicNU?nDkiCoQ>n<00?oNnN400SoLmikof_NNomkgXco
JmJ4of?6Nom[_HCoJjekof>UN`;oJhac00CoU:FLokFe]Oo6c/koinOW0_o_g^L2onOFgP;ooooo00?o
inoWonOWioooool0ooooooooooooocOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVi
on?Shoooool04oooool02?o_knooinOWokFm_OmcNg_oinoNomkFe_mcQ7?oQ<j40_mkig/02?mcig_o
Hmicof_>Lom[ig_oLnN4og__S?nDkiCoW>NL0onUki`01?nDkiCoU>N<ohc>Q?mkih@4og?WQ00;of_F
Q?mJaW?oHkEcof>UNomSW7?oJhacog>DNon<YICo[Kf]omKFe_o_inl0oooooooooooooc_ooooo00?o
k^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool04oooool02?o_knookmkWolK6a_mc
Ng_og]KFomK>e_mkQ7_oS<j40_nDih`04_mkkhCoNnN4og__Q?mkihCoLnMkog?WQ?mccW_oNnN4ohcW
U?n4khcoU>N<ojG_W?nUiicoYNnLojGWW?nLkiCoQ>n<og_WN`;oLnMk00ooLmikof?WLomkgXcoHmJ<
of?6NomS]G_oHjecof>LLomcU7_oLiakojF]YOne_Kgoe]kFoooooooWinL00_o_g^L00ooWg^Oooooo
ooooo`3ooooooooooooo<Oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Soooo
o`0Cooooo`0;onoWkooWinOo]KFeof]cLoo6a[go_Kfmof=cJom[]F_oNnn4og_WQ?mkkh@00_n4kh`0
1onDihcoU>NDoiCNS?n4gXcoQ>n<ohCNS?mkih@00_n4gX`2ohC_S003oic_U?nUkicoYNNL00;oW>nD
01CoQ>n<og_WNomkig_oNnn4og_WQ?mcgXCoNmj<og_FS?m[_HCoJlikof>eNomSW7?oHiA[of^<Lon4
YHCoYJfUokg>_OoNg]kokmkWonOWiooooooooooooolbooooo`03onk^k_oShn?o^KVi00;ok^k^0003
ooooo`03okVi^OoShn?ooooo01?ooooo00[okno_onO_ioo6a/KoQ8B4omkFe_oFc/koLg]kog>mLomk
khCoNnN40_mkig/01on4gXcoS>NDoiC_U?nDkiCoU>NDoic_U?nLgY@01?n4kh`01_mkgXcoLmikohCN
S?mkkhCoU>NDoicNU0;oW>NL00GoW>nDohC_S?mkihCoNnMkohCNS002og_WQ004og?NNomcgXCoLlj4
of^mQ0;oJjek00OoHiacof><JomcU7_oQ:FDokFe]Oo6a/Kog]kN0?oooooooooooolaooooo`03on?S
honi^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo01?ooooo00koinOWono_kone]KGoQ8B4
onOWiooNg]koS9b<ohBUS?nUkicoW>nDohcWU?nDihcoQ>n<ohCNS0;oS>ND00?oYNNDoicNU?nUii@0
0_nUii`00onUkicoW>nDoiCWU002ohC_S008og_NS?mcig_oLnMkog_WNomkihCoQ>n<ohcWU?nDih`2
ohC_S0;oNnn400?oNnN4og?WNomcig/00_mcgW/2of_FN`0?of?6NomJaW?oD[e[of>DJomSU7?oJhac
oiB]U?nma[goc/k>onONioo_g^OoinOWonoWkoooooooimkW0?oooooooooooolWooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01?ooooo00SoknO_onOWionma[goLg=comK>
e_o6a/KoNhAkog^DN`;oYNNL00CoYNnLoicWW?nLiicoW>nD0_nDii@3ohcWU007ohC_S?nDkiCoW=jD
oicWW?nUkicoW>NLoiC_U002oiCWS003ohCNS?mkig_oLmik00;oJlic00GoLmikog_WQ?n4khcoQ>n<
ohCNS002ohC_S006og_WQ?mkkhcoNnN4og_WQ?mcihCoNmj<0_mcgX@03?mc_G_oLkEkof>]LomSU6_o
Hha[of^<Lon4YHCoYJfUokfm_Oo>e/koinoNonOWi`;ooooo00?okmkWooooooooool0oooooooooooo
ob;ooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool04oooool02Oo_g^Oo
kno_okg6_OmcNg?oe/kFokfm_OmkQ7_oJha[ojGWU002oicNU003oicWW?nUkicoYNnU00;o[NnU00Ko
YNnUojG_W?nUkicoW>NLoiC_U?n<ii@2oiCWU003oicNU?nLkiCoW>NL00;oW>nD01SoU>nDohC_S?nD
ihcoNnn4og_WQ?m[cW?oHmIcof_>Lomcig_oNnn4ohCNS?mkkhCoNnN4og__Q?mkkhcoNnn4og__S?mk
gXcoLnN4og?NQ?mcihCoLmJ4of_FNom[cW/2of>]L`08oeZUJomcQ7?oQ:F<okgW_Oo_g^OoinoWoooo
ooo_g^oooooooooooooo9?ooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Soooo
o`0Cooooo`0:onoWkoo_knoo]LJeog]kNooWg^Ooe]KFoiBLU?mSS6_oYNnLoiCWU0;oS>ND00WoU>nL
oicWW?nLiicoYNnUokgWYOnegZgo_Nn]okGN[Onekjd00_nUki`00onLiicoW=jDoiCWS002oiCWS004
ohCWU?n<iiCoU>nDoiC_U0;oS>ND00KoQ>n<og__S?mcihCoJmikof?FLomJeV/2of?NJ`06og?NNomk
khCoNnN4ohCNS?mkkhcoNnN41?mcih@02OmkgXcoLnN4of_NQ?m[eXCoLkEkof>]LonLgYcoknO_onoN
i`3ooooooooooooo9oooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0C
ooooo`0;onoWkooWinOo_LJmog]kNooWg^Ooe]KNojF]YOm[Q6_o_NNeokG_[OnUki`00_nLii`05_nL
gYCoU>NLoiCWW?nUiicoYNnLojg_YOnekjgoa^N]olkW]OnmikGoa^N]ojg_YOnUkjGoW>NLohcWU?nD
ihcoQ=j<ohC_S?n4gXcoQ>n<ohCNS?nDih`2ohC_S005og_NS?mkkhCoLnN4of?NLomSgV/00_mJcV<0
1?mSgV_oHmicog?WNomkih@2og__Q0?oNnn<00WoNmj<og__S?mkgXcoNnN4of_>LomccW_oe]kFonOW
iooWknL0ooooooooooooobGooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shooo
ool05Oooool04?nma[goLg=comK>e_o6a[goYJfUoeYkF_nmkjgo_NNUokGN[Onekjgo_NN]ojg_[Onm
ijGo]Mj]ojG_YOnUgZD2ojGWW007ojg_[Onekjgo]Nn]okGN[Onmijgoa^N]okG_[@02ojg_Y@03ojG_
W?nLgYCoQ=j<00?oNnN400?oNmj<og__S?n4kh`00_mkkh`2og?WQ004of_WQ?mSgW?oHmIcoe[>J`;o
D/iS00coHmIcof_NNomcihCoNmj<og__S?n4khcoNnn<ohCWU?mcig_oHnMcof?FLoo6g/Kooooooooo
oooo9oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0Cooooo`0:onoW
kooooooo_LJmog=cLooFe]Koa/K6ojF]YOm:Jd[o_NNUojGNY@;o[NnU00So]Nn]okg_]OnmikGoc^nm
olkW]OnmkkGo_NN]okGN[@;oYNnU00OoYMjUojG_YOn]kjGo[NnUojGNYOnmijGo]Nn]00?o[NnU00Go
W>NLoiC_U?n4gXcoNnMkog?>N`03of_NN`09og__S?mcihCoLnN4og?WQ?m[ihCoJnMkof_NNomSgW?o
F]Ic00;oD/i[00_oD/iSoe[>JomSeW?oJmikog__Q?mcihCoLnMkof?WLonee[GoimkWonoNi`3ooooo
oooooooo9Oooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Eooooo`0?
okfm_OmkQ7_oknO_omkNg_nea[GoBV]:okg_]OnekjgoYNNLojG_W?nLgZGoYNNLojg_YOnmijgo[Nne
00;o_Nne00Ooc^nmolkW]Oo>ikgo_NNeolkW]On]ijgoYMjU00?oW>NL00CoYNnLojGNYOnUkjGoW=jD
0_nDki@02_n<iiCoQ>n<ohC_S?mcihCoJmikoe[FNom[eW_oJmikof_NQ?mcig/4og?WQ0;oJnMk00_o
F]I[oe;>Hom:cU[oB/iJof?NJomcig_oHnMcog?WNonmikgokmkWonOWi`3ooooooooooooo9_ooool0
0ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0Dooooo`04onOWionma[goNhAk
omkNgP;oe]kF00WoDUYBomKWa_nmkkGo_NneokgW]OnmkkGo]Mj]ojGNYOnekjd00onegZd2okg_]@09
olk__Oo>ikgoe^nmomK__Oo>kkgo_NNeojg_YOnUgZGoW>NL00;oU>ND00coU>nDoiCWW?nDkicoU>nD
oiC_W?nDkiCoS>NDohC_S?mkkhcoLnN4of_NNomSeW<2oe[FJ`03oe[FLomSeW?oJmik00;oJmik00Co
JnMkof_NNom[gW_oJmik0_m[ig/00on4gXcoHnMcokgW]@3ooooooooooooo9oooool00oo^k^kohn?S
okVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0Eooooo`0>okfm_Om[Lf_oc]K>olK>a_ne]KGo
>D8iolk__Onmg[Go_NNeokg_]Oo>kkgoc^Nmokg_]Oo>kkd2okg_]@04okgW[OnegZgo]Mj]okgW[@;o
_NNe00_o_NneokgW]Oo6kkgo_NneokgW]OnekjgoYNnUoicNYOnDkicoU>NDohcWU003ohCNS00>ohCW
U?n4gXcoQ>NDohC_S?mkkhcoNmj<of_WQ?m[gW_oHmicoe[FLomBcV?oF]I[oe[6LomSgW<2of_WN`06
of_WQ?mkkhcoLnN4og_NS?mcig_o[NN]ooooooooooooobOooooo00?oi^KVon?Shoni^KT00_oVi^H0
00?ok^k^00?o^KVion?Shoooool05Oooool01oo6a/KoNhAkomkNg_o>e/koa/k6oc4i<Oo6kkd00_nm
ijd00onmikGo]Mj]okg_]@02olkW_@;oe^O60_o>kkd01_o6kkgo_NNeokgW]Onmijgo_MjeolKW[@;o
_NN]00So]Nn]ojg_]Onmkjgo]Nn]ojG_YOnLiicoU>NDohcWU0;oQ=j<00GoNnN4og?FQ?mkihCoNnN4
og_NS003og__S0;oLnN400coJnN4of_NNomSeW?oF/i[oe:mJomJcV_oF/Icof_NNomkkhCoQ=j<og?W
Non]kkGooooooooooooo9oooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Soooo
o`0Eooooo`0<okfm_On4Q8Cokno_omkNg_o>e/ko>D8iomKWa_nmkkGo_NNeokgW[OnegZgo_NN]0_nm
ikD00oo6kkgoc^NmomKWaP04omKWaP04olk_a_o>ikgo_NNeokgW[@;o]Mj]00?o_NNUojgW[OnegZd0
0_n]kjD2ojG_Y@04oicWW?nDkicoQ>NDohCNS0?oLmj400KoJmIkof_NNom[gW_oLmj4og?WQ?mkgX`2
og?WQ00;of_NNom[eW_oHmIcof?FLom[eW_oNnn4ohCNS?mcig_o[NneoooooooWinL0oooooooooooo
obKooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool05Oooool01_nm_Kgo
Ng]konOWiooFg]koe]KFod9:@P?oe^O600[oc^o6olkW_Oo6kkgoc^nmokgW]Oo6kkgo_NNeolKNa_o>
ikgoc^o61OoFilH01?o>kkgoa^nmokgW]OnegZd2ojGNY@;oW=jL00GoU>NDoiCWW?nLiicoW>NLoiCW
U002oiC_W008ohCWU?mkgXcoLmj4of_FNomSeW?oJmIkof?FLom[eW/2og?NQ009og?WQ?mkgXcoLmj4
og?NQ?mcihCoNnMkohCNS?mcig_o[Nn]0?oooooooooooolWooooo`03onk^k_oShn?o^KVi00;ok^k^
0003onKViP03okVi^OoShn?ooooo01?ooooo00cokno_oooooonm_KgoLg=comkFe_o6c/koa/K6ocU2
@_nmikGoc^Nmolk_a_oFilH2olk_aPCoe^O60_o>klH3olkW_@03omKWa_o>ikgoe^O600;oe^O600Ko
c^o6olkW_OnmkkGo_NNeojg_YOnLgY`2oiCNU003ohCNS?n<iiCoQ>ND00;oS>ND00GoU>nLohcWU?n<
iiCoQ>NDog__S002og?NQ00<of_FNomJeW_oHlIkof?FLom[eW_oJmj4og?NQ?n4iiCoNnn4ohCNS?mk
khCoYMJ]4_ooool01?oalO7ooooooo[jn_odm?@2ooooo`03oogmoOoZj^[ooooo00Cooooo00?ol?3`
omcLg?omoOd01?ooool00oohn?Sofm_Koogmo@3ooooooogooooo00?oi^KVon?Shoni^KT00_oVi^H0
00?ok^k^00Go^KVion?Shoooooooooooom7Ad@0Cooooo`07olK6a_mkNg_oinOWomKFe_o6c/KoDU9B
okGN[@02olK__@05okgN]Oo>ikgoa^nmomK__OoFilH00_oFklh01?oNklkoe^O>omk_c_oFilh2omk_
cP;oa^nm00Co_MjeolK__Oo6kkgoa^nm0_o>kkd2okg_]@06ojgW[OnLiicoU>NUoiCWW?n4eYCoNnND
0_mceX@00omkeXcoNmj<og_NS002og_NS00=og__S?mkgXcoNnNDog?NQ?m[gXCoJmIkof?6NomSeW?o
LmJ4og__Q?n4gXcoNnMkojG_[@08ooooo`0Ko`P82?ooooooooooohb<S?oLg=coooooofIVI_n;Rh_o
k>c/obHV9_l/;2coFUYJoc8b<_mcLg?oooooojj^[_l@413o;2`/ob<S8ooXj>SoooooonSXj?m7AdOo
<30`odY:B_lO7aooUiNG00;ooooo00GoUYJFo`d=3Om4A4Co=CDeohB4Q004ooooo`07ofYZJ_n3Ph?o
oooooooooooShn?o3@d=okRh^03ooooooo7ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00Oo
^KVion?Shooooooooooooi:BT_nGUiOoi^KV017ooooo00Oo_Kfmog]kNoo_knooinOWomKFe_mSHf?o
]Mj]00;oc^o600Goa^nmolk_a_o>ikgoa]k6olkW_@03omKWaP08omk_c_oFilkog^o>omKWc_oNklko
e^O>olk_a_o6kkd2okgW]@?o]Mj]0_n]ijd01_n]kjGo[Nn]ojG_YOnUkjGoU>nLoiCWW0;oQ>ND00Co
NnN4og?FQ?mccW_oLmJ41omkgX`2og?FQ005og?NQ?mkig_oQ=j<og__Q?nUgZD02?ooool04_l820So
ooooolG5aOl30`?oKVi^oooooomVIVKoRh^;oj6QXOm3@d?ooooool_;bol410Coo?clookno_lM7Ago
ZJVYooooo`;ooOgm00?ooooood10@?maLG400_ooool02_oTi>Co6ATIok:b/_ooooooj>SXooOgmooo
oooom_KfoaLG5ooQhN43ooooo`06oo?clolV9RKodm?Coooooom=CDgoFUYJooooooocooooo`03on?S
honi^KWooooo007ooooo0003onk^kP04okVi^OoShn?oooooooooo`;oLg=c00?oPh>3ojj^[_odm?@0
3oooool02_nm_KgoLg=comkNg_oFe]Koc/k>ohB4Q?nL[ICoe^O>omk_c_oFilH2omK_cP;oe^O>00?o
e^O6olKNa_o>klH00_oFilH04OoFklkog^o>omK_c_oNklkoe^o>omKWc_oFilKoc^NmolK__Onmijgo
]Mj]ojg_YOnUgZGoYNnUoicNYOnUkjGoW=jU00;oYNnU0_nDijD01_nDiicoS=JLog_WU?mkgXcoJmJ4
of_>N`;oLmJ40_mkeX`01OmkiiCoNmj<og_WU?n4iiCoS>ND00;oQ=j<00CoS>NDooooooooooooinoW
1Oooool04Ol820SoooooofYZJ_m_Kfoo9bLWoo_knomVIVKoRh^;on7QhOlN7QkoTY:BokVi^Ol820So
oooool71`OlF5QKooOgm00?ooooo00?obl_;o`000?oGemL00oooool00omTI6Co?Cdmooooo`03oooo
o`03ong]kOl>3Pko`/;200Cooooo00Go^k^koc@d=?nUYJGo4Q8Bon[ZjP3ooooooo;ooooo00?ok^k^
on?Shoni^KT00_o^k^h000?oi^KV00Co^KVion?Shooooooooooo1?mcLg<00on0P83oaLG5ooclo00=
ooooo`08olK6a_n4Q8Coe]KFolk>c_ne]KGoNg]kohBLNoo>klH2omKWaP03omk_c_oFklkog^o>00?o
g^oF0_oFilh00ooNklkoe^O>omKWcP03omKWaP?oc^o60oo>ikd01On]kkGo]Nn]ojGNYOnLgZGoW>NL
00CoU>NL00?oU>nLoiCWW?nDki`00_nDki`01OnDiicoQ>NDog_NS?mceXCoJmJ400?oJlik00WoNmJ<
og_WU?n<iiCoNnn4ohcNU?n<iiCoooooonOWiooWknL01Oooool04Ol820Son_[joa<C4ooAdM7oJVYZ
ok6a/OmVIVKoRh^;ooooooolo?coclo?ohf=SOl820SoooooolW9bOl>3Pkon_[j00?ooooo00?oXJ6Q
oadM7Oooool00oooool00onXZ:So51@Dooooo`02ooooo`04okVi^OlN7QkoC4a<oogmo@Gooooo00?o
IVIVo`<30onOWil0ooooooocooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP04okVi^OoShn?o
ooooooooo`KoLg=c00?oRh^;omWIfOogmoL02oooool01onm_KgoQ8B4onOWiooNg]koa/K6oiBDU?m[
S6/00_oFilh00oo6g/Koe^O6omKWcP02omKWcP04omk_e_oNklkog^oFomk_cPGoe^O>00Coe^O6olkW
_Oo6kkgoc^Nm0oo6kkd02OnmkkGo_NNeojg_]OnekjgoYNn]oicNYOnDkicoU>NLohcFW002ohCFU003
ohCNS?n4eYCoQ>ND00;oQ>ND00CoU>nLohCWU?mkiiCoNmj<0_mceX@02OmccW_oJmJ4oiCWW?mkgXco
S>NDohCNS?oWknOoknO_onO_i`05ooooo`0=o`P82?nc/k?o;Bd]ooooooo9bLWoDe=CofIVI_n;Rh_o
ooooolc<c?omoOgoalO7obLW9`02ooooo`07ob8R8_n>SXkono_kooShn?ono_koXZ:RoaXJ6P04oooo
o`08ojRXZ?lE5AGoooooookno_mfMWKo30`<ohf=SOono_h6ooooo`03ofIVI_l0003o_[jn0?oooooo
loooool00oo^k^kohn?SokVi^@02onk^kP000oooool01?ni^KWohn?Sooooooooool7og=cL`03ogMg
MonNWYkooooo00[ooooo00Oo_Kfmog]kNoo_knooinOWomkNg_nm_KgoHg=J00;og^oF00Coc^o6omKW
c_oFilKoc^o60_oFilh00ooFklkoe^O>omKWcP04omk_eP?oe^O>0_o>klH01_o6kkgo_MjeokgW[Onm
ikGo[Nn]okG_[@?o[Nn]00GoYNn]oicNYOnDijGoU>NLohCFU002og_FS00Aog_NS?mceXCoNmJ<og_N
S?mkiiCoQ=JDoiCWW?n4iiCoQ=JDog_WU?n4eYCoU>nLohC_S?n<gYCoQ=j<onO_iooWinL01_ooool0
0ol820SoF5QHohR8R002ooooo`08obh^;_mDE5CoRh^;oooooomXJ6So>SXjoc8b<_nVYZH2ooooo`08
om3@d?mZJV[o;2`/ob`/;?ogmoOoc/k>o`000?oDe=@3ooooo`06of5QHOm0@43oooooolC4a?lD51Co
fMWI1oooool01Oo2`/;o2PX:ojVYZOlW9bOom?Cd0?ooooooloooool00ooShn?o^KViooooo`01oooo
o`000oo^k^h01?ni^KWohn?Sooooooooool6og=cL`03oh^;RooIfMWomoOg00_ooooo00_o_Kfmog]k
NooNg]koc/k>olK6a_ne]KGoBUY:onO_g_oNkmKog^o>omk_eP02omKWcP03omk_c_oNkmKog]KF00;o
g^oF00Kog^o>omk_e_oNklkog^oFomk_c_oNkmH2omk_cP06omKWa_o>klKoa^nmokgW]OnegZgo[NN]
0_nUgZD00onLgZGoW>N]ojG_Y@03ojG_Y@;oU>NU00CoU>NLohCFU?n4eYCoNmJ<0_mccX@02omceXCo
NmJ<og_FS?mkgXcoQ=JDohCWU?nLgZGoQ>NDohcWU?n4gXcoe]kF00Oooooo00?o1`L7o`/;2ooShn<0
0_ooool00on5QHGo2PX:oh^;R`0=ooooo`0:odM7AomXJ6Soo_knoooooooNg]ko5QHFokZj^_oooooo
b<S8obh^;P;ooooo00?ok^k^ooooooooool00_ooool01_oinOWo:2PXohN7QoooooooOgmoofe]KOoo
ooool_ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H01?ni^KWohn?Sooooooooool4og=cL`03
oh20P?o5aLGoo?cl00gooooo00co_Kfmog]kNooWinOoe]KFokfm_One]KGo>E8iomKNe_oNkmKoe^O>
omk_e_oNklh2omk_eP03onO_g_oNkmKoinoN00;og^oF00Gog]KFomk_e_oNkmKog^oFomKWcP02omK_
cP0=omKWc_oFilKoe^O6olk_a_o6kkgo_NNmokG_[On]ijgoYMjUoicNYOnDiicoU=jLoiCWY@03oiCW
W003oiC_W?nDijGoU>NL00;oQ>ND00coQ=j<og_FS?mceXCoLlj4og?>NomccXCoLmJ4oicNYOn4iiCo
S>NDog__S?oFg]H7ooooo`03oa<C4om7AdOooooo00;ooooo00?oh^;Ro`d=3OnATI403Oooool01_o]
kNgoEEEEobLW9oln?Sko8b<SojBTY0?ooooo00CoJVYZoc0`<?l];Bgo<c<c1?ooool01on:RX[o=SHf
oo_knooooooon_[jocPh>?o9bLT0oooooooaooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP04
okVi^OoShn?oooooooooo`;oLg=c00?oPh>3ojj^[_odm?@03oooool02Onm_KgoQ8B4ono_kooWinOo
e]KFolK6a_la>C7og^oNomk_eP02omKWcP0=omK_c_oFilkoe^O>omk_e_oWkmkog^oFomkNg_oWkmko
g^oFonO_g_oNg]kog^oFomk_cP02omKWcP;oc^o61Oo6kkd01On]kkGo[Nn]ojG_[OnLgZGoU=jU00;o
S=jD0on4eY@3ohCWU005oiCWW?n<eYcoQ>NDohCFU?mkii@00omkeX`01OnLijgoU>N<ohCWU?mkkhco
c]K>01kooooo00?onOWionSXj?ooool01Oooool00ooemOGol?3`ooooo`3ooooooocooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00Oo^KVion?Shooooooooooooi:BT_nGUiOoi^KV017ooooo00So
a/K6og]kNoo_knooinOWomkNg_oFe]Ko@TY2onO_i`?og^oF00Coe^O>omk_c_oNklkoe]kF0_oNkmH0
1?oWkmkog^oFomk_e_oWkmh3omk_eP0:omk_c_oFilkoe^O6olk_a_o6kkgo_MjeokgW]OnegZgo[Nne
okGN[@;o[Nn]0onUkjd01?nLgZGoU>NUohcWU?n<gY@5og_FS00;ohCNS?n4eYCoU>NLohCFU?n4iiCo
U>NLoicNYOn4iiCoS>NDohCNS?o>e/h0ooooooooooooobOooooo00?ohn?SokVi^Oooool00Oooool0
00?ok^k^00Go^KVion?Shoooooooooooom7Ad@0Cooooo`0>okfm_On4Q8Cog]kNomKFe_o>c/koa/K6
odYBB_oFilkoinOWonO_g_oNe]KoinoNomkNg_oWkmh6omk_eP0?omk_c_oNkmKog^o>omKNe_oNklko
g^oFomK_c_oNklkoe^O>olk_c_nmikgo_NNeojgW[OnUkjgoYMJ]00CoYNn]0_nLijd3oiCWY@;oS=JL
0_mkeX`01?mk_HcoNmJ<og_FS?mkeX`2ohCFU007oicNYOnDgYcoW>N]oiCWYOnUkjgoooooonoWk`3o
oooooooooooo9?ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0Eoooo
o`0;okfm_OmkNg_oinOWomkNg_o>c/ko]KFeof=[F_nm_KGog^oFomKNe_oWkmh00ooNkmH4onO_gPCo
g^oF0_oNklh5omKWcP;oc^o600Goa^nmokgW_OnmikGo[NneojG_[@02oicNY@;oU>NL0_nDgY`2oiCW
W005oiCWYOnDiicoU>NUoiCWW?mkii@00omkeX`2og?>Q005oicWW?nDgZGoW=jUoiCWYOnUgZD0oooo
ooooooooobKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool05Oooool0
3onm_KgoQ8B4onOWioo_knoog]kNolk>c_mkQ7_oS9b<onO_iooNg]koinoWomKWc_oWkmkog]KFomkN
gP04omk_eP03onO_g_oNg]kog^oN00;og^oF00Cog^o>omKWc_o>klKoc^o60_o6kkd3okgW_@08okg_
]On]kkGo]Mj]ojG_[OnUikGoU>NUoiCNW?n<eY`2ohCFU0;oS=JL0_nDii`2ohcFW0;oU>NL0on4eY@0
1OnDiicoU>NUoicW[OnDgZGoYNnU0?oooooooooooolVooooo`03onk^k_oShn?o^KVi00;ok^k^0003
ooooo`03okVi^OoShn?ooooo01Gooooo00?o]KFeohB4Q?o_knl00_oWinL00ooFe]KoW:FLohbDS002
onO_i`04onO_g_oNg]kog^oFonO_gP;og^oF00Sog]kNomk_g_oWkmkog^oNomk_e_oWkmkog^oFomkN
gP?og^oF00Soe^O>olk_a_o6g/Ko_NneokgW]On]ijgo[NneojgW[@;o[Nne00Oo[Nn]ojG_[OnLijgo
YNnUoiCWYOnDgYcoS=jD00;oQ=JD00?oQ=j<ohCFU?n4eY@01On<eY`01_nDiicoW=jUoicW[OnDgZGo
W=jUonO_iooooooooooooolVooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?o
oooo01Gooooo017o_KfmohB4Q?oWinOog]kNolk>c_o6a/Ko_LJmodYBB_oWknOoinOWonO_g_oWknOo
inOWomk_e_oWknOoinOWonO_i`02onO_gP;og]kN00?og^oFonO_g_oNkmH01?oNkmH2omK_cP08olKN
a_nmikgo_NNeojgW[OnUeZgoYNn]ojGNYOnLijd2oicNY@03ojG_YOnLijgoW>N]00;oU>NU00?oQ=JD
ohcFW?n4eY@01OmkeX`01on4eYCoU=jLoiCWYOnLijgoU=jUoicWW?oWkmh0ooooooooooooobGooooo
00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool05Oooool01Onm_KgoQ8B4onOW
iooNg]koe]KF00;oa/K600So8BTQomKFe_oWknOoinoWonOWiooNkmKoinoWonOWi`;oinoW00OokmkW
onOWiooWkmkoinoNonOWiooWkmkog]kN00;og^oF0_oFklh01_oFilkoe^O6olk_a_o>klKoa^nmokgW
_@;o[Nne00[oYMJ]oicW[OnLgZGoU=jLoiCNYOnDgYcoU=jUoiCW[OnUkjGoW>N]0_nDijD01?nDiico
S=JLohCFU?n4eY@2og_FS006oiCWW?nUkjGoW>N]oiCWYOnDgYcoe]kFooooooooooooobGooooo00?o
i^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool05Oooool04?ne]KGoQ8B4ono_koo_
knooinOWomkNg_o6c/koYJfUoc4i<Onma[goinoWonO_g_oWknOoinoNonO_iooWinL4onO_i`06onOW
iooWknOoinoNonO_g_oNg]koe]kF0_oFilh01?o>klKoc^NmolK_a_o6klH3okgW_@09okgW]On]kkGo
[NneojG_[OnUeZgoU=jUoiCNW?n<eYcoS=jD00GoS=JL0_nDijD02OnDiicoS=JLohcNU?nDijGoW=jU
oicW[OnLgZGoU=jLomKNeP3ooooooooooooo9Oooool00oo^k^kohn?SokVi^@02onk^kP000oooool0
0oni^KWohn?Sooooo`0Eooooo`04okfm_On4Q8Cokno_ono_k`?oinOW00[oc]K>okFe]OmBFU;o>D8i
oeYJF_n4S8Cog]kNono_kooWknOokno_0_oWknL01OoWinOoinoWonOWiooWinOoinoW00;oinoN00Oo
g^oFomKWc_oFilkoc^o6okgW_OnmikGo]MJe00Go[Nne0onUkjd00onLijgoW=jUoiCWY@02ohcFW005
ohCFU?n4eXcoNmJ<ohC>U?n4eY@00_n<eY`01onDijGoW=jUojG_YOnLijgoU>N]oiCNU?oFe]H0oooo
ooooooooobKooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool05Oooool0
0onm_KgoQ8B4omkNgP02omKFeP04olk>c_oFe]Koc/k>olk>cP;oe]KF00Oo_Kfmohb<S?mSHf?oBUY:
oeY[F_n<W8coa/k600;oinoW00Gog^oNonO_iooWkmkoinOWonO_gP02omk_eP08onO_g_oNkmKoe^O>
omKWc_oFilKoa^nmokgW]Onee[D2ojg_]@03oicW[OnUeZgoW>N]00CoW=jU00GoW>NLoiCNW?nDgZGo
U=jUohcNU002ohC>U00:ohCFU?n4cYCoQ=JDoicW[OnDgZGo_NNmoicNYOnDiico_NO6onO_iooooooo
oooooolTooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Cooooo00Co
inOWomKFe_m[Jf_okno_0_oWinL04_o>c/koa/K6okfm_One]KGo_KfmolK6a_o>c/koc]K>olk>c_o6
c/Ko_Ljmoib]W?m[Lf_o@TY2odYJD_n4S8Co_LJmonO_i`?oinoN00Gog^oFomKWc_oNklkog^oFomK_
cP03olk_aP04okgW_On]kkGo[Nneojg_]@;oW>N]0_nDgZD01?nLijgoW=jUoiCW[OnDgZD2oiCWY@03
oiCW[OnDgZGoU>NU00;oS=JL00SoQ<jDojG_[OnLgZGoYNNeoicNYOnDiiCo_No6onO_iooooooooooo
oolTooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo01Kooooo00GoBTY:
onOWioo_knooinOWono_k`02omKFeP06olk>c_nm_Kgo_Kfmokfm_Onm]Kgo]KFe0oo6a/H03Oo>c/ko
e]KFolK>a_nLW9coJg=codYJ@_m:DT[oLg]cojfm[OoNkmKoinoNomk_e_o>c/H00_oFilh01_o>klko
c^o6olK_a_o>kkgo_NNeojg_[@;o[Nne00?oYNn]ojGW]OnLijd00onDeZD00on<eYcoU=jUohcFW003
oiCNY@;oU>NU00OoW>N]oicNYOnUikGoW=jUoiCWW?nmikgoinoW0?oooooooooooolTooooo`03onk^
k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo01Kooooo00?oW9bLof][Joo_knl00_oW
inL00oo_knooinOWomkNgP02omKFeP03olk>c_o6a/Koa/K600;o_KFm0_ne]KD02?nm]Kgoa/K6olk6
a_o>c/koe]KFolkFc_n]]JgoLg][0_m2BT802omcNf_oW:fDolk_a_o>klkoc^o6okgN]OnegZgo[NN]
ojg_]OnmikGo]Nn]00?o[NN]01?oYNn]oicNYOnLgZGoW=jUoiCFYOn<aYCoS=JLohCFU?n4cYCoS=JL
oiCNYOn<eYcoW>N]ojGNYOnUkjgoW=jUoiC_W?nmikgog^oN0?oooooooooooolUooooo`03on?Shoni
^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo01Oooooo00CoJf][ojF]YOoWg^Oog]kN0oo>
c/h01_oFe]Kog]kNomkNg_oNg]koe]KFomK>eP;oc/k>00Koa/K6okfe_Onm]Kgo]KFeokfe_One]KD2
okfm_@0<olK>a_oFg]Koc]K>ojfe[On4S8CoBUY:ocUJ>OmBJe;oQ:F4okGF]Oo>klKo_NNe0_nUgZD2
ojGWW004oicNYOnUeZgoYNn]ojG_[@;oW>N]00?oU=jLoiCFYOnDgY`00_n<eY`2ohC>U0;oW=jU00Go
YNNeojGNYOnLiicoYMJ]omk_gP3ooooooooooooo9?ooool00oo^k^kohn?SokVi^@02onk^kP000ooV
i^H00oni^KWohn?Sooooo`0Gooooo`04omKNe_m:BT[oinoWonOWi`;oe]KF00Koa/K6okfm_Onm_Kgo
a/K6olk>c_oFe]H3omkNgP0FomKFe_oFc]Koc/k>olk>c_o6a/Ko_Kfmokfm]Onm_Kgo_KFmokfm_Onm
a[goa/K6olK>a_o>e/koe]KFokg>_On<W8coDUYBoc5J>Om:Hd[oHhASoicNY@;oYNNe00CoYNn]oicW
[OnDijGoW>N]0_nUkjd00onLijgoYNn]oicW[@02oiCNY@09oiCNW?n<eYcoW=jUojGWW?nUikGoYMjU
oicWW?nUikGoe]kF0?oooooooooooolTooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi
^OoShn?ooooo01Cooooo0_oWinL2ooooo`08od8i@_o_knooinOWono_kooWinOog]kNomKFe_o>c/h2
olK6aP0:okg6_Onm_Kgoa/K6olk6a_o>c/koe]KFomkNg_oFg]Koe]KFomK>eP;oc/k>00?oa/k>olK6
a_nm_Kd00_nm_Kd03Oo6a/Koa/JmolK6a_o6a/Koc]K>omKFe_nm_KgoYJFUoeY[Hom:FU;oDV]Bof><
Jon<_I@00_nUeZd01?nLijgoS<JDoiCNYOnLgZD2oiCNY@;oW>N]00SoW=jUojGNYOnLgYco[NN]oicN
YOnDkiCoYMJ]olk_c_oooooooooooolTooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo01Kooooo00SoinOWoooooomJFU[og]kNonOWioo_knooinOWono_k`?oinOW0_oFe]H0
2Oo>c/koa/k>olK6a_nma[go_Kfmokg6_Oo6a/Koc/k>omKFeP02omkFgP;og]kN00?og]KNomKFg_oF
e]H00_o6a/H01?nm]Kgoa/K6olK6a_nm_Kd2olK>cP;oe/kF00?oc/k>ojf][Om[Lg<00_liDST04?mJ
Je[oJkf4oiCNW?nLgZGoU=jUohcFW?nDgYcoS=JLoiCNYOnUkjgoW=jLojGW]OnUgZGoU>nLojGW]Oo>
e/kooooooooooooo9Oooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0F
ooooo`05omkNg_ooooooS8b<oibLW?o_knl00_oNg]h01?oFe]Kog]kNonOWiooWinL2ono_k`;oinOW
00Gog]kNolk>c_o>c/koc/k>olK6aP03okfm_@;oc/k>1OoWinL01OoNg]koe]KFomKFe_o>c/koa/K6
00Go_Kfm01Coa/K6olk>c_o>c/koc/k>ojf][OmkQ7_oBU9:ocUB>OmBLe;oJhacohc6U?nLgZGoS=JL
ojGF[OnUkjgoYMjUoiCWW?nLiicoW=jDokgW_OoooooooooooolTooooo`03onk^k_oShn?o^KVi00;o
k^k^0003onKViP03okVi^OoShn?ooooo01Sooooo00coe]KFodY:B_oFe]KoinOWono_kooWinOoe]KF
olk>c_oFe]Kog]kNomKFe_oNg]h4onOWi`;og]kN0_oFe]H01oo>c/koa/K6ohB4Q?mJFU[oQ8B4olK6
a_oWinL00oo_knl03?oWinOog]kNomKFe_oFe]Kog]kNolk>c_o6a/Ko_KfmokFe]Onm_Kgo]KFeokfm
_@;oa/K600Woc]K>omKFe_ne]KGoQ:F4oe9SF_laFSWo@UY2of><Jon<_I@00onUgZD00onUkjgo[Nne
ooooo`3ooooooooooooo8oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Soooo
o`0Iooooo`05okfm_Om:BT[oU9BDokfm_OoWinL00_o_knl00ooWinOog]kNomKFeP04omKFeP03omkN
g_oWinOoinOW00?oinOW00[og]kNonOWioooooooc/k>oiBDU?mcLg?oFUYJog]kNone]KGog]kN0_o_
knl00ooWinOog]kNomkNgP02omKFeP04olk>c_o6a/Ko_KfmolK6aP;o]KFe00Go_JfeokFe]Onm_Kgo
a/K6olK>cP02olK6aP07ohbUU?mkU7_oBV]:ocUJ>OmJNe[oU:fDomKNeP3ooooooooooooo9?ooool0
0oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Fooooo`03omkNg_ooooooinOW
00;ooooo00Ooe]KFojf][OmkNg_oJf][og]kNonUYJGoe]KF00;okno_00?oinOWomkNg_oFe]H00oo>
c/h2omKFeP03onOWiooNg]koinOW00;ooooo00[og]kNoooooooooooog]kNojf][OmkNg_oFUYJog=c
LonUYJGoc/k>1OoWinL04OoNg]koe]KFolK6a_o>a/Ko_Kfmokfe_Onm[KGo[Jf]okFe]Oo6a/Ko]Kfm
olK6a_oWinOoooooonO_iooNkmKoe]KF0?oooooooooooolVooooo`03on?Shoni^KWooooo007ooooo
0003onk^kP03okVi^OoShn?ooooo01Gooooo00?oinOWoooooooWinL01?ooool02_oNg]kooooooooo
oooooooo_Kfmohb<S?m[Jf_oLg=coibLW?o>c/h2ono_k`;og]kN0_oFe]H00oo>c/koe]KFooooo`09
ooooo`07omkNg_n][JgoQ8B4of=SHom[Jf_oU9BDokfm_@02omkNgP09onOWiooNg]koe]kFomk_e_oF
g]Koc/k6olK6a_nm[KGo]KFe00;o_KFmooooooooooooob[ooooo00?ok^k^on?Shoni^KT00_o^k^h0
00?oi^KV00?o^KVion?Shoooool06Oooool00ooWinOoooooooooo`04ooooo`06onOWiooooooooooo
ooooooo>c/koU9BD0_m[Jf/01?nDU9Co_KfmomkNg_oWinL2omkNgPkooooo00?og]kNolK6a_n<S8`0
0_mSHf<01_n<S8co[Jf]olkFc_o>e/koe]kFomKWgP;oe]kF00Coa/k6olk>c_nm]KgoinOW0oooool0
0oo_inooooooooooo`3ooooooooooooo8oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni
^KWohn?Sooooo`0Cooooo`05onOWiooooooooooooooooooNg]h04?ooool01OoFe]KoYJFUohB4Q?n]
[JgoinOW01Cooooo00Woc/k>oiBDU?mcNg?oFUYJog=kNonUW:Goa/K6omkNg_oNe]h00_oNe]H2onOW
i`?ooooo00?oinOWooooooooool0ooooooooooooob;ooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
oooo00?o^KVion?Shoooool05_ooool00ooWinOoooooooooo`0/ooooo`06onoWkon][JgoNg=koeYJ
F_mSHf?o]Kfm1Oooool2onO_iooooooooooooolUooooo`03on?Shoni^KWooooo007ooooo0003onk^
kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03
okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi
^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoS
hn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?o
oooo00;ooooo00Ookno_ojf][OmJJf?oW9bLonO6a_oWinOomoOg00Cooooo00?okoooooOgmoooool0
ooooooooooooofKooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00oo^KVion?Shooooooooooo
omkNionDS8co41P@odY:B_lY8B7o[G=kog]kNonDS8co[Jf]omJma_o_knl0ooooooooooooof[ooooo
00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^01Co^KVion?Shoooooooino_okfm_OlY<BWo_LJmoooo
ooli627ocXB<olicNoo6Jg?o[F][oiaSJon<Jg?oW8b<okfe]OoFe]Kokno_ooOgmooooooooooooomU
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`06okVi^OoShn?omoOgomK>e_nLU9co<CTi0_oo
ool03omkDU[ocW^4oomkU?o_Lhcoig^4olicNonmJg?oYF=[ojESHonDJg?oQ8B4oibLW?nm_Kgog]kN
ooO_k`3oooooooooooooHoooool00ooShn?o^KViooooo`01ooooo`000oo^k^h01_ni^KWohn?SonOW
ioo6c/koS9B<oeYJFP;ooooo00CoLeYSolikU?ooS:goohbU0_ooQ9`2ooMkS00;onmSNooWFW?oaV]c
oje[JonUHf?oU6]coiB4Q?nU[JGoa/k>omk_koogmoL00_ooool00oo_ooooooooooooo`04ooooo`03
onoooooooooooooo0?oooooooooooomBooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP06okVi
^OoShn?omnOWomKFg_nU[JGoJg=[0_ooool05om[Lf_ogXb]oonUc_ooYLkomiBmoonD]OogU:goohbU
onn<W?ooQ9cokhBDomikS?oFLhCocW=koke[Lon]Jf_oYF=SojE[JonLQ8co]IbLolk6c_oWinOooooo
00?okooo2oooool00oo_oooomoOgooooo`3oooooooooooooBOooool00ooVi^Kohn?SokVi^@02onKV
iP000oo^k^h03Oni^KWohn?SooO_kooWknoo[Jf]of]SHooWg^Ooe]kNof=:D_o6LiCooiBeoonL_Ooo
YLH00_ooYLh05?ooYLKomiBmonnD_OooS:goohbUooMkU?ogQ9Comg^<onMkQ?o_Hg_oif]kokEcLonU
Jg?oW6=[oiA[LonLS8co_KFeolkNe_oWmoOomoOg1oooool00oogmoOoooooooooo`3ooooooooooooo
C?ooool00oo^k^kohn?SokVi^@02onk^kP000oooool04Oni^KWohn?Soooooooooooo_Kfmof]cJooW
g^Ooc]KFof]JF_o6LiComf^4ooMcS?ogLiComhBUoonD]OooW;goojG600;oojG>01OooibmoonD]Ooo
S:goohb]oon4W?ogNiComg>Donn4U?oWNhCoeW=koliSLoo6Lg?oYG=coia[LonLLg_o[JFUokfm_OoW
g]komoOgonoooooooooomoOgonooo`07ooooo`03ooOgmooooooooooo0?oooooooooooom6ooooo`03
on?Shoni^KWooooo007ooooo0003onk^kP0<okVi^OoShn?oooooooooooo6a/KoQ8B4ooOgmooWknoo
S7]komj<[OooU;Goohb]0_ogLi@01?o_Lhcomg>Doon4W?ooS:D2oonUaP;ookGF01CoojG>oonUa_og
U;gokhbeooMkU?ooQ9comg><ooMkS?ogNiCokf^4omIcNoo>Hg?o]G=cojE[LonULg?oYG]kokFLW?nm
_KgoinOWonoooooooooooooooom?ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP0:okVi^OoS
hn?oooooooooooo>e/koQ8B4onoWkooWinOoU8B4omj<[@;ooibm00CooiBeoon<[OooS:GomhBU0_og
Ni@01_oNNiCoohBLoonD[OooU;GoojG6oonUcP;ookGF00GoojG>oonUa_ooU;GoohbUooMkU003ooMc
U00=ooMkS?oWNhCoeW=kolI[LoneLg?o[F][ojEcLonUNg_o]Jf]omK>c_oWinOomoOgooooo`03onoo
oooooooooooooom7ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP0:okVi^OoShn?ooooooooo
oonma/KoNg]komK>e_o>c/koJg=[olikU0?oohb]00?ooiBeoonL_OooW;d00_ogW;d2oon<[@09ooND
[OogQ:GomhBUooND[OooS:gooiBeoonUa_oo]MKoojG>00;oojG600WooibmooND[OogQ:GoohBLoomk
U?ogNiComhBDonMkS?oNNh@00_o>Hg<02OnULg_oW6]coiacNon]S9Co_KFeomk>e_ogknooooooonoo
o`3oooooooooooooA_ooool00oo^k^kohn?SokVi^@02onk^kP000oooool02_ni^KWohn?Soooooooo
ooooc]K>ohb<S?o_inoog^OWoiAcNoo>Ni`2oon<[@;omhBU00Soohb]oonD]OooW;gooibmoonUa_oo
YLkoojG6oonL_@;ooiBe00WoohbUoon4W?o_NjGomhbUoonD]OogW;goojG6oon]c_ooYLH00_ooW;d0
4_o_S;GomhBUonmkYOooQ9cokg^UooMkU?o_Q9Coig^<omIcNoo6Lg_o]F]kojE[LonDJg?oW7]kojf<
U?o6a/Koe]KFooO_kooooooooooooom5ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP0>okVi
^OoShn?ooooooooooooFa/koS8b<onooooo_knooW9BLokFLW?ooYLkoojG6oonL_OooU;D3oonD[@0A
oonD]Oo_YLkomibmooN]a_ooYLkoojg>oonUc_ooYLKooibmoonD]OooS:goohbUonmkYOogNiComhBU
oon<[OooU;D00oooW;d05?ooU;Goohb]oon<YOooS:GomhBUooMkU?ogLiCokhBDonmkS?oWLhcogV]k
oliSLoo>FV_oYF][oia[LonLLg_o]IbLomJma_oNg]kokoOg0_o_ool2ooooo`04onoooooooooooooo
onoooooooooooooooolhooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP0=okVi^OoShn?okooo
ooooooo>c/koQ7]komkWiooFe]KoW8B<oib<U?oo]MKoojG>oon]cP02oonUaP04oon]a_ooW;gooibm
oonD[@?ooiBe00CoojG6ooN]a_oo[LkoojG>0_ooYLH2oonL_@08oonD]Oo_NjGokg^UonN<W?oWLhco
khBDoon<YOooS:d2oonD]@;oohb]0_ooS:D01_ooQ9comg^DooN4U?ogNiCokhBDonmkS0;ocW^400[o
]F]kojE[LonUJg?oU7=kojf<U?nmYJGoc/k>onONg_ooooookooo0_ooool00oo_ooooooooooooo`3o
oooooooooooo=_ooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h03_ni^KWohn?Soooooooooooo
e/k>ohAkNooNinOoc/k>oiB<S?nLLg_okjG>onn]a_ogW;goojg60_oo[Lh4ooneeP04oon]c_ooYLKo
oibmoonD]@;ooibm00Gomjg6oonUc_ooYLkoojg6oonUaP02oonL_@08oonD]OooS:GoohBLomikU?o_
Lhcoig><ooMkU?ooS:D3oon<[@;oohbU0_ooQ9`02?ogNiComhBDooMcU?ooQ9cogW^DonMkS?o>NhCo
_F]c0_neLg<01onDLg_o[HbDooo>g_o_oooomoOgooooooo_ool0ooooooooooooocSooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00_o^KVion?ShoooooooooooomK>c_n<S8cokoOgonOWion]YJGo
U7=koonUaP02ooNL_@05oonD]OooW;goojG6oon]a_oo[Lh00_og_Mh3oonegP03oonee_oo[LkoojG6
00;omibm1?ooU;D2oonL_@;ooiBe00Coohb]oon4W?ogNiComg><0ooWHh@01?o_Lhcomg^Doon4W?oo
S:d2oon<Y@?oohBL0_ooNi@01?ooQ9ComhBDonmkS?oWNh@2olIkS003onnU]Oooooookooo0?oooooo
oooooolkooooo`03on?Shoni^KWooooo007ooooo0003onk^kP0=okVi^OoShn?oooooooooooo>a/ko
Q8B4ooOgmoo_inoo_KFeoiAcNoooc^oookgFoon]cP02oon]aP03ooN]_OogW;gomjg600;oojg>00go
okg>ooneg_ooa^OoolKWooO6ioog_NOookGFoon]c_ooYLKomibmoonD]OogU:goohbU00;oohb]0_oo
U:d01_ooU;Goohb]oon<YOooQ9coog^DonmcS0;oif>400CogUYkonMSQ?o_Lhcomg^D1oooQ9`2oomk
U004onn<W?oNNhcogW^DonoWkooooooooooooolkooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP0:okVi^OoShn?okooooooooooFc/koQ7]komkWiooFe]Ko_KFeog]SL`CookGN00CoolKNooneg_oo
_MKomkgF0_oo[Lh2ooNUcP05oonme_oo]MkookGNooneg_ooa^L00_oo]Mh2ooneeP05oon]c_ogW;go
mjFeooN4YOogS:D00_ogQ:D3oon<Y@;oohBL01Coog^DooMkU?o_Lhcoif>4onMSNooNFW_ogUYconm[
Q?o_Lhcomg^Doon4U?ooQ9coohbUoon4W?ooS:Gomg^DooMcU?oWJhcokmkNonoooooooooooooooolj
ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP0:okVi^OoShn?ooooooooooooFc/koQ7]komkW
ioo>e]Ko_KFeog=BFP;omkgF00GomjG>oonee_oo]MkookGNooo6i`02ooo>k`03ooo6iooo]MkookgF
00?oojg>00Goojg6ooNme_og_MKomkgFooneeP02oonegP;ookGF00SoojG6oonL_OogU:gokhbLonn4
U?ogLiCokg><onmkS0;oohBD0oooNi@01OogLhcokg><onm[Q?oWFW?ogV=c00;ogUYc00?oif=konmc
S?ogLh`00_ooS:D2oom[S003omk>e_ogmoOomoOg0?ooooooooooooliooooo`03onk^k_oShn?o^KVi
00;ok^k^0003ooooo`0=okVi^OoShn?ooooooooooooFc/koS8b<ooooooo_knooe[g6og]BF_ooa^Oo
okgFoon]cP02oon]aP04ooN]a_oo]MKookGNoonegP;oolKW00?oomK_ooo>koooc^l00_oga^L01?oo
]MKoojg>oon]a_og[LH2oon]aP;oojg>0_ooYLH01oooW;gooiBeoonD]OooS:GoohBLooMcU?oWJg/0
0_o_Jh@00ooWNhComg^<oomkU003oomkU003ooM[Q?ogLhcokf=k00?ogUYc00Gokg><ooMcU?ooNiCo
ohBLooNmeP02onooooooooooooooooljooooo`03on?Shoni^KWooooo007ooooo0003onk^kP0;okVi
^OoShn?oooooooOgmooFc/koS7^4ooOgmoogknooinOWoeYSF_ooc_L00oooa^L01?ooa]kookGFooNm
c_oo]MH2ooNmeP;ookGN00koolKWooo>koooe^ooolkgooo>koooa^OookGNoonme_oo[LkoojG6ooNL
_OogYKGooibmooNU]@?ooibm00OooiBeoonD[OooS:GoohBLooMkU?o_Nhcoif>400;oif=k00?oif]k
onmSNoo_Lh`00_ogLh`02Oo_Lhcomg><onm[Q?o_JhComg><oomkU?ogQ:Gomg^DoonmeP3ooooooooo
oooo>oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H03?ni^KWohn?Sooooooooooooc/k>ohAk
NooWg]kog/kFomK6c_m2@T;oolk_ooNmgP;oolKW0_ooc^l01Oooa^Ooolk_ooo6ioooa]komkgN00;o
mkgF0_og_Mh3ooo6i`08ooo>koooa^OoolKNooo6e_oo[Lkoojg6ooN]_OooW;d2ooND[@04ooNDYOog
U:goohb]ooND[@?oohbU00WoohBLooMkU?o_Lhcokf^4onMSNooNFW?ogV=conMSNoo_Jh@00oogLh`2
oon4W005ooN<YOogNiCookg>ooooooo_ool0ooooooooooooocWooooo00?oi^KVon?Shoni^KT00_oV
i^H000?ok^k^00_o^KVion?ShoooooooooooomKFe_n<S8comno_onONg_oNe]Ko@STiooo6i`04ooNm
gP07ooo6ioooc^ooomK_oooNmoooc_OoomK_ooo>k`02ooo6i`;omkgN00?omkgWooNmg_og_Mh01?oo
]Mh02_oo_MKoojg>oon]a_ooW;gomjFeoon<[OogS:GokhbLonn4U?ogNi@5oon4W0;oog^D00comg><
onmcS?oWJg_ogV=coliSLooNHg?oif]konmcS?ooS:GomhBUooMkU?oo_MKooooooooooooo>oooool0
0oo^k^kohn?SokVi^@02onk^kP000oooool03oni^KWohn?Sooooooooooooc/k>ohb<S?oooooomno_
onONiom:>D;oolkgooo6ioooc]komkgNooNmeP03ooNmgP03ooo6ioooe^ooomkg00;oomkg00OoomK_
ooo>moooe^oommK_ooO6ioog_MkokkgF00;omkgF0_oo_MH02_oo]MKoojg>oon]c_oo[Lkoojg6ooNU
]OooU:gomhbUooN4U?o_Q9@2onmcS00BonMcS?o_Nhcomg^DooN4U?ooQ9comhBDooMcU?o_Lhcokf^4
onMSQ?oNJg_okf^4oon<YOogS:Gomg^Doonme_ooooookooo3_ooool00ooRh^;oo?clooooo`04oooo
o`03on;Rh_olo?cooooo0?oooooooooooolRooooo`03on?Shoni^KWooooo007ooooo0003onk^kP0;
okVi^OoShn?oooooooooooo>c/koS8b<ooOgmoogknooinOWodY:B_oog_L00_ooc_L01Ooog_OoolKW
ooo>koooa^OoolkN00?omlKW00GoolKWoooFkoooc_OoolkgoooNm`03ooo>m`;oolKW00?omkgNonn]
c_o_[Lh00_og[LH00oogW;gooibmooN]_@02oonL_@0>ooNU]OooU;GooiB]onn<W?o_Q9Coig^<onMS
Q?oWNhCoif>4onMkQ?o_LhcokhBDoon4W?ogQ9@2ooMkU005ooN4U?ooS:gomhbUoon<YOoo_Lh04?oo
ool00ol>3Pkoh^;Rooooo`04ooooo`03o`h>3_oRh^;ooooo0?oooooooooooolQooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003onKViP0;okVi^OoShn?okoooooooooo>c/koNg]kono_kooNg]koe]KFod92
@_oga^L00_ooe^l01oooc_OoomK_oooFkooog_OoolkgoooNmoooc_L00_ooe^l3ooOFk`0AoooFkooo
g_OoomK_oooFkoooc_OoomK_ooo>koooa^OoolKNoon]c_og[LKokjFmonnL]OogU:gomib]ooNDYOoo
S:D00oooU:d2oon<Y@05oon4W?ogNiCokg^<onMSQ?oWNh@00_oNJg/02?oWNhCoig><ooMkU?ooQ9co
ohbUonmkYOooS:GomkG64?ooool01?l>3Pkoh^;RooKfm_ojn_X3ooooo`04o`h>3_oRh^;om_Kfoo[j
nPOooooo00?oo_knonWYjOono_h0oooooooooooooaKooooo00?oi^KVon?Shoni^KT00_oVi^H000?o
k^k^00_o^KVion?ShoooooooooooolkFe_n<S8coooooonOWiooNe]KoFUYJooNmcP02ooo6i`05ooO6
iooge^Ooolk_oooFkoooc_L02?oog_L2ooo6i`0>ooO6iooge^OoolKWoooFkoooa^Ooolk_ooo6iooo
]Mkookg>oon]a_og[KgooiBeooNDYOo_S9`2onN<U003onn<W?ooQ9cokhbL00?okhbL00GoohBDooN4
U?o_Nhcoig><onMkQ002omi[N`05onMcS?ooS:GomiB]oon<YOog[Kd01oooool00om:BT[oZJVYoooo
o`02ooooo`09ooWinOlC4a?o^[Zjooooool>3PkoIfMWodI6A_l@413oZJVY00;ooooo00Go3Ph>ofMW
Iom6ATKo410@ojVYZ@02ooooo`08o`h>3_oRh^;ooooook6a/OlG5aOo>CTioc@d=?ni^KWooooooooo
oooo5Oooool00oo^k^kohn?SokVi^@02onk^kP000oooool02oni^KWohn?Sooooooooooooc/k>ohb<
S?oooooomoOgonOWiomcHf_okkgF00;oomK_00GoolKWoooFkooga^OomlKWooOFk`02oooFk`Ooomkg
00?oomK_ooo6ioog_Mh00_og_MH01Oog_MkomkgFoonee_oo]MKookgF00;oojg>00Soojg6oonL_Oog
YKGooiB]oon<YOo_S9coihbDonMkS0;okhBD00CoohBLooN4U?o_S9coohBL0_ogQ9@2onmkS005ooN4
U?ooS:gomiB]oon<[Oo_YKd01oooool00on_[joo@d=3ooooo`02ooooo`09ojRXZ?lP823oo_knoooo
ool>3Pko^;Rhooooooo;bl_o8b<S00;ooooo00Go3Ph>okRh^?oooooobl_;ob<S8`02ooooo`05o`h>
3_oRh^;oi^KVo`/;2oo7alL0oooooooooooooaWooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^
00_o^KVion?Shoooooooooooolk>c_n4Q8Cokno_onOWiooNg]koS9B<okfL]@07oooNm`05ooOWkooo
e^oommK_ooOFkoooe^l01ooog_L01oooc_OoolKWooNmg_og_MKomkg>ooNea_og[LH00_og[Kd00ooo
[LKomjfmooN]_@02ooNU]@06ooNL[OogU:GomiBUonn4U?oWNhcogW^<0ooWNh`02Oo_Q9ComhBDonn4
U?o_S9cokiBLoonD[OooS:Gokib]oonD]@07ooooo`03oo_knolJ6Q[o<c<c00;o<c<c00Ko5ADEoh:2
P_ooooooooooo`h>3_oRh^82ooooo`05oaHF5_oHf=Soooooo`h>3_oRh^800_ooool01olF5QKof=SH
ooooool>3Pkoh^;Roj^[ZolQ8B400ono_kl00ooYjNWoooooooooo`3ooooooooooooo4oooool00oo^
k^kohn?SokVi^@02onk^kP000ooVi^H02oni^KWohn?Sooooooooooooe]KFohb<S?o_knoog]kNolK6
a_n<NhCoW9BL00?oomK_2ooog_L00oooe^ooomkgoooFk`04oooFk`;oolk_00CoolKNoonme_oo[Lko
ojg60_ogYKD4ooNL[@CooiB]00GoohbUoon4W?o_Q9Cokg^<onMkQ002omikQ009onMkQ?o_NhcomhBD
oonD]OooS:Gokib]oonD[OoooooomoOg00Kooooo00KoNWYjog9bL_oemOGodm?Co`<30ooTi>@2oooo
o`09o`h>3_oRh^;ooooooooooolF5QKob/[:ooooool>3Pkoh^;R00;ooooo00Oo5QHFol[:b_oooooo
3Ph>on;Rh_o7alOo5aLG00;oM7Ad00?o6a/Kol71`Oooool0oooooooooooooaCooooo00?oi^KVon?S
honi^KT00_oVi^H000?ok^k^00_o^KVion?Shoooooooooooolk>c_n<S8coooooono_kooFe]KoYJFU
oiAcN`02oooNm`03oooFkoooc_OoomK_00_oomkg00?oomK_ooOFkoooa^L00_ooa^L01_ooc^ooolKW
ooo6ioooa]koolKFoonmeP;oojg600ComjFeoonD[OogU:GokiBU0_o_S9`01?o_U:GomhbUoon<YOog
U:D2oon<Y@0:onnDW?o_Q9Cokg^<onMkS?oNNhcoig^<oonD]OooS:Gokib]oonD]@Sooooo00Gog]kN
oaXJ6_okno_oNWYjodY:BP03ooooo`0Fo`h>3_m]KFgok^k^oj^[ZolE5AGoo_knooooool>3PkoKFe]
onk^k_n[Zj_o5ADEookno_oooooo3Ph>on;Rh_ono_ko8R8Ron3Ph?o_knoo7AdMoo[jn_oooooooooo
oolEooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`0;okVi^OoShn?oooooooooooo>c/koQ8B4
ooooooogmoOokno_olK>c_mkHg<00_oog_L01OoginooomkgooOWkoooe^oomnO_00Goomkg00?omoOg
oooNmoogmoL00ooog_L2oooFk`03ooo6ioooa]komkgF00;ookgF00CoolKFoonme_oo_MKoojg>0_oo
[LH01?ogYKGooiB]onnDW?o_S9`3onN<U006onn4U?o_S9cokhbLonn<W?ooS:GokiBL0_o_S9`00oog
Q9ComjFeoon<Y@02ooND[@03ooO_kooooooooooo00Kooooo00CoADE5ojZZZ_lI6AWo[Zj^0oooool0
1Olg=cOoZZZZoc4a<Olm?Cgo^k^k00;ooooo00Go=cLgojZZZ_la<C7o?Cdmok^k^`02ooooo`07o`h>
3_oRh^;ooooook^k^ola<C7o?cloojn_[`3ooooooooooooo5oooool00ooShn?o^KViooooo`01oooo
o`000oo^k^h03?ni^KWohn?Sooooooooooooc/k>ohB4Q?ogmoOoinOWomKFe_o>a/KoHe9Joooooa?o
omkg00OoomK_ooOFioooa^OoolKFooNmc_ogYLkomkG600Gomjfm0_ogYKD04_ooU:gomiBUooNDYOo_
S9coihbDomikQ?oNNhcoig^<omikU?o_S9cokhBDonn<W?ogS:GomjFeoonD[OogW:goohbUooOWi`So
oooo00CoZj^[oaHF5_lG5aOono_k4Oooool00ol>3Pkoh^;Rooooo`3ooooooooooooo6_ooool00oo^
k^kohn?SokVi^@02onk^kP000ooVi^H03Oni^KWohn?Sooooooooooooc/k>ohB4Q?ogmoOoinOWolk>
c_nma[goDT92oooNmoogmoL01Ooog_L01?ooooooomkgoooWooogmoL:oooNm`08ooo>moooe^ooolKW
ooo>g_ooa]Koojg6ooN]a_og[Kd2ooNU]@Comib]0_ooU:d01?ooS:GomiBUooN<YOo_S9`2onN<U0?o
gW^<00KoihbDooNU]OooS:GomiB]oon<[Oo_g]h8ooooo`03oo[jn_lO7aooNg]k01;ooooo00?o3Ph>
on;Rh_ooool0oooooooooooooa[ooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00Ko^KVion?S
hoooooooooooolk>c_n<S8`2ooooo`03onOWiooFe]KoBSU200Soomkg00[ooooooooNmoooioooomkg
oooWooooooooomkgoooWoooog_OomnO_0oooe^l03_oge^OoolKWoooFkoooa^OoolkNooo6g_oo_MKo
ojg6ooN]_OogYKGomib]ooNDYOo_U:GokiBL0_o_U:D00oogS:GomiBUooNDY@02ooNDY@03onnDW?o_
S9coihbD00;oihbD00GomjfmooND[OogW:goohbUooONgP0Mooooo`03ohb<S?oalO7ooooo0?oooooo
oooooolJooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`06okVi^OoShn?ooooooooooooFe]Ko
S8b<0_ooool01?o_knooinOWoeY2B_ooool6oooNm`0:ooOgmooog_OoooooooooooogmoOooooooooN
moooooooomkgooooo`;oomkg0_ooe^l01_ooa^OoolkNooNme_og_MKookgFooo6eP?ookg>00Ooojg6
ooN]_Oog[KgooiB]ooNL[OogU:GokiBL00?oihbD00GoihbLonn<W?ogU:GomiBUonnDY@02ooNDY@05
ooNU]OooU:gomib]oon<YOo_g]h0oooooooooooooc_ooooo00?ohn?SokVi^Oooool00Oooool000?o
k^k^00co^KVion?Shoooooooooooolk>c_n<S8cokno_onOWiooNg]koe]KFoeY:D_oWg^L2ooooo`03
oooNmooooooooooo00Ooomkg00?oonOooooNmooog_L01Ooog_L01OoginooomK_ooo6ioooc]komkg>
00;omkG60_og[Kd00ooo[LKomjfmooN]_@02ooNU]@;omib]00KokibUonnDW?oWS9coihbDomj4S?oN
Ni@2onN<U0;okhbL00OomjfmooNL[OogW:gomib]oon]c_ooooookooo0?oooooooooooolhooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP0?okVi^OoShn?oooooooooooo>c/koS8b<ooooooo_knoo
g]kNolK6a_mcHf_oe/k>oooNmooginoomoOg00;oomkg00KooooooooWooogmoOooooooooNmoooiol3
oooNm`06oooWoooog_OoomkgoooNmooginooomkg0oooe^l2ooo6i`04ooo6e_oo_Lkoojg6ooN]_@?o
mjFe00Comib]onnL[OogW:gomiBU0_ogW:d01_ooU:gokibUonnDW?oWS9coihbDomikU0;ogXB<00Go
mjfmooNL[Oo_[KGomib]oon]aP3ooooooooooooo>_ooool00ooVi^Kohn?SokVi^@02onKViP000oo^
k^h01_ni^KWohn?Sooooooooooooc/k>ohb<S0;ooooo01;omoOgomkNg_nDS8coW9BLoooooooog_Oo
ooooonoWkoooooooomkgooOgmoooioooomkgoooWooogmoOoonOoooOgmoooiol4oooNm`;oomK_00?o
mmKWooO6ioooc]h00_ooc]h01Oooa]koolKFoonme_oo[LKomjfm00;omjFe00GokibUonNLYOo_U:Go
kiBUonnLY@06ooNDY@08onnDW?oWS9coihbLooNL_OogW:gomjFeonn]]Ooo[LKooooooooooooo>_oo
ool00oo^k^kohn?SokVi^@02onk^kP000oooool01_ni^KWohn?Sooooooooooooc/k>ohb<S0;ooooo
00ComoOgono_kon][JgoW9BL0oooool2oooNm`0DooOgmooog_OomoOgoooNmoooooooomkgoooooooo
g_OooooooooNmoooioooomkgooOgmooog_OoomK_oooWioooa^OoolkNooo6e_og_MH3oonmcP03ooNm
a_oo_Lkoojg600;omjfm00GooiB]ooNL[Oo_W:GokhbLonN<U003onN<W005onnDW?o_W:GokiBUonnD
YOogU:D00oogYKD00oogW:goojg6ooooo`3ooooooooooooo>_ooool00ooShn?o^KViooooo`01oooo
o`000oo^k^h03?ni^KWohn?Sooooooooooooc/k>ohb<S?ogmoOokno_omkNg_oFe]Kog]KFoeY:DP;o
oooo017oomkgooooooooooooomkgooooooooiooooooooooNmoooooooomkgooOgmooog_OooooooooN
moooioooomkgooOgm`03oooNm`06ooOFioooc]koolKFooNmc_og]LKoojg60_og[Kd2ooNU]@;omjfm
0_ogYKD01_o_YJGokibUonnLYOoWS9coihbDomikU0?oihbD00OoihbLooNU]OogYKGomjFeooNL[Oog
[KgomoOg0?ooooooooooooliooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP0=okVi^OoShn?o
ooooooooooo>c/koS8b<ooooooogmoOoinOWomKFe_oFc/ko:B4QonONi`03ooooo`03ooO_koooiooo
oooo00Cooooo00Coomkgoooooooog_Oooooo0_ogmoL3oooNm`CoomK_00GommKWooo>g_ooa]Komkg6
oon]aP03ooNU]@04onnL[OogW:gomib]ooNU]@;omib]00WooiB]ooNDYOo_U:GokibUonnDW?oWS9Co
gW^DonN<U?og[Kd00_ogYKD00oogW:gokjFmooO_k`3ooooooooooooo>Oooool00ooVi^Kohn?SokVi
^@02onKViP000oo^k^h01_ni^KWohn?Sooooooooooooc/k>ohb<S0?ooooo00Ookno_omkNg_nm]KGo
@STiomK>c_ooooooomkg00[ooooo00GoonOooooNmooog_OoomkgooO_k`02oooFk`;ommKW00_oolKW
ooo>g_ooa^OoolkNooo6e_ooa/kookg>ooNma_og[KgomjFeonnUY@02onNLY@GokibU0_ogW:d00oog
U:GokibUonnLY@05ooNU]@03onoWkooooooooooo0?oooooooooooolgooooo`03onk^k_oShn?o^KVi
00;ok^k^0003ooooo`06okVi^OoShn?oooooooooooo>c/koS8b<0oooool02OogmoOomno_onOWioo>
a/KoHe9Jod92@_mcHf_oU9BDooOWk`05ooooo`03oooWoooooooooooo00?ooooo00WoonOooooNmooo
g_OoomkgoooFkoooc]koolkFooNme_oga/h01?oo_Lh3ooN]_@;omjFe00Comib]onnLYOoWS9coihbL
0_oWS9@2onN<W0;okibU00?omib]ooN]_OogYKD00_ogYKD00oo_YKGoinOWooooo`3ooooooooooooo
>Oooool00ooShn?o^KViooooo`01ooooo`000oo^k^h02oni^KWohn?Sooooooooooooc/k>oiBDU?og
moOokno_onOWiooNg]koinOW00;og]kN0_oWinL01oo>c/koW9bLof][JomJBU;oLeYSoibDW?o_g]h0
0_ooool02?ogmoOooooooooNmoooooooonOoooOgmooog_OomoOg0_oog_L01Oooe^ooomkgooo6ioog
_MKomkg>00;omkg600?okjfeooN]_Oog[Kd01?og[Kd2ooNU]@03onnL[OogW:goiibU00GoihbD0_og
YKD01?og_LKokjFmoonL_Oooc]Kooooooooooooo>Oooool00oo^k^kohn?SokVi^@02onk^kP000ooV
i^H01_ni^KWohn?SooooooogmoOokno_og=cL`;ooooo00OomoOgonOWioo>c/koc/k>olK6a_o>c/ko
e]KF00?og]kN00SoimkNomk>e_ne[JgoLg=codY:B_mSDU[oW8bDomK6cP;ooooo00?omoOgoooNmooo
g_L00_oog_L02_ooioooomkgoooFkoooinOoomK_ooo>g_ooa/koojg6ooo6c_ogYKD6ooNL[@07onnU
YOogW:gomib]ooNL[OogU:GokjFUonnDW002onN<W006ooNU]Oog[KgomjFeonn]]OogYKGoolK>oooo
ooooooooocWooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool00_ooool0
0omBBU;oooooooooo`02ooooo`03ono_kooWinOog]kN00Coc/k>017oa/K6omKFe_oFe]Kog]KFomkN
g_oWinOog]KFojfUYOmkNg_oFTYBof=BF_n<NhCoa/K6oooNmooooooommK_onONi`05oooFk`05ooo6
ioooc]kookgFoonmc_og_LH00_og[Kd01?ogYKGokjFUonNLYOoWW:D3onnLY@0;onnL[Oo_YJGomiBU
onnUYOogU:GomjFeooN]_Oog_LKokjfeoonL_Oooa/h0ooooooooooooocWooooo00?ok^k^on?Shoni
^KT00_o^k^h000?ooooo00?o^KVion?Shoooool00_ooool00on][JgoNg]kooooo`03ooooo`05ooOg
moo_knooinOWonOWiooNg]h00_oFe]H01_o>c/koa/k>olK6a_o6a/Koa/k>olkFeP;og]kN013oinOW
onONionm_KgoQ7>4oeY2D_mJ@T[oQ7>4okfL]Ooge^OoomK_ooOFioog_Mkomkg>oonme_ooa]kookGN
0_oo_MH05Ooo_Lkoojg6ooN]_Oo_[KGomib]onn]]Oo_YJGoihbLonNLYOoWS9cogYBUonN<W?o_YJGo
kibUooNU]Oog]LKomjFeonnU_Oog[Kgomkg6ooOgm`3ooooooooooooo>Oooool00ooShn?o^KVioooo
o`01ooooo`000oo^k^h00oni^KWohn?Sooooo`03ooooo`04og=cLonm]KGomoOgono_k`;og]kN0_oW
inL05?o_knoomoOgono_kooWinOog^OWomkNg_oFg]koc]KFolK>c_o6a/Ko_LK6olK>c_o6a/Koc/K>
omK>c_oNg]koinOWonONionm_KgoU9BD0_mSBU801omcFV?o]IbLonnme_ooinOomkgNooNmc_o_[Lh0
0_og[LH02Oog]LKoojg6ooNma_og_LKomjFeooN]_OogW:gokibUonnUY@02onNLY@09omjDYOoWS9Co
mjFeooN]a_og[KgomkG6oonL_Oog_LKoomkg0?oooooooooooolhooooo`03onk^k_oShn?o^KVi00;o
k^k^0003onKViP03okVi^OoShn?ooooo00?ooooo00OoinOWoe9:D_ooooooooooono_kooNg]koe]KF
00;oc/k>00?oe]KFomkNg_oWinL00oo_knl2onOWi`03omkWiooFg]koe]KF00Goc/k>00coe/k>omKF
e_oWg]koinOWonONiooNc]KoW9BLog=JHomJ>D;oJdYJoha[Loo_[KD2ooNmaP06ooN]_OogYKGomib]
ooNU]Oog[KgomjFe0_og[Kd02OogYKGomib]ooNL[Oo_W:GoiibUooN]_Oog]LKomjfmooN]aP02ooN]
_@03ooOWkooooooooooo0?oooooooooooolfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo00;omoOg0_ooool00om:BT[oooooooooo`02ooooo`03ooOgmooWinOog]kN00?o
e]KF00Goc/k>omKFe_oNg]kog]kNonOWi`02ono_k`03onOWiooNinOog]kN00;oe]kN00Goe]KFolkF
c_o>c/koc/k>omK>cP02omKFeP06omkFe_oWg^OoinOWomK>c_nm]KGoLeYS0_mcBU802_nDJg?oaYBL
onN]]Oo_YKgoijfeomjDYOo_W:gomjFeonn]]Oo_W:d3ooNU]@04ooN]_Oo_[LKomjfmooNeaP;omjfm
00?omnOWooooooooool0ooooooooooooocKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o
^KVion?Shoooool00_ooool01OogmoOoooooof=SHoo_knoomoOg00Gooooo00KomoOgono_kooWinOo
imkNomkNg_oFe]H2olk>cP05omK>c_oNe]Kog]kNonOWiooWknl01?o_knl2onOWi`03omKNg_o>e]Ko
a/k>00?oc]K>00Ooe/k>omKFe_oNinOog^OWomkNg_nm_KgoQ7]k00;oFT9:00CoQ6=[olj4S?o_W:go
kjFe0_o_W:d02_o_W:GoiibUonnL[Oog]LKokjFmooNma_og[KgooibmooN]_Oo_g]kooooooooooooo
>Oooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`02ooooo`06ooOgmooo
ooooW9bLojF]YOoooooomoOg0oo_knl01?ogmoOoooooooooooooool2ooOgm`05ono_kooWinOog]kN
omkNg_oFe]H00oo>c/h2omkNgP03ooOgmooooooomoOg00?omoOg00Cokno_onOWiooNg]koe]KF1?o>
c/h00oo>e]Koc/k>omkNgP02omkNgP0:okfm_OnDS8coFT9:oeY2@_mkDU[oYG=comJLYOo_[KGoiibU
onnU_@;oojg600Comibmoon]a_ogW;goolkNooooooooooooocSooooo00?ok^k^on?Shoni^KT00_o^
k^h000?oi^KV00?o^KVion?Shoooool01?ooool01?oWinOoDTYBono_koogmoL2ooooo`05ono_kooW
g]koinOWono_kooWinL00_ogmoL2ooooo`;omoOg0_o_knl01ooNg]koinOWomKFe_nDU9CoHf=Sohb<
S?oFe]H01Oooool01_ogmoOokno_ono_koo_knoog^OWomK>cP?oc/k>00Coa/K6olk>c_oFe]Koc]KF
0_oWinL03?oF_LKoW8bDog=BF_mS>CWoJd9:oia[Loo6W:Gokjg6ooN]a_og_Lkokjg>ooNmc_oooooo
oooooolhooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo00Gooooo00Go
e]KFoe9:D_nUYJGoc/k>ooOgm`02ooooo`04onooooogknooinOWonO_k`?oinOW013okno_ooOgmoog
moOomoOgooooooogmoOokno_ooOgmooooooog]kNoibLW?n4Q8CoHf=SohB4Q?nm_Kgokno_0_ooool2
ooOgm`05ooO_kooWknooinOWomkNg_oFe]H00_o>c/h01_o>a/Ko_LK6okg6a_nma/Koc/k>omKFeP?o
g]KF00Oo]IbLoib4S?mcDU[oJd9:ohaSJoo6W:GoonOW0?oooooooooooolhooooo`03onk^k_oShn?o
^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo00;ooooo00?omoOgooooooogmoL00_ooool01oo_
knoo_Kfmohb<S?mcLg?oS8b<okfe]OoWinL00_ooool2ooOgm`;oinOW0_oNg]h2onOWi`?omoOg0_oo
ool02_ogmoOoooooooooooo_knoo_KfmohB4Q?mSHf?oNg]kokfe]OoFg]h2ooOgm`0@ooooooogmoOo
moOgooOgmoo_knooe]KFomKFg_o>c/koa/k>okg6a_nm_Kgo_LK6olkFc_nma/Koe]KFooOgm`;ooooo
00?omno_onoWkoooool0ooooooooooooocWooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00Oo
^KVion?ShoooooooooooooOgmooooooomoOg00Cooooo00[omoOgooooooooooooooooolk>c_nLW9co
Ng]kohB4Q?nUYJGog]kN0_ooool01_ogmoOoino_onOWioo_knoog]kNono_k`[ooooo00?okno_okfm
_On<S8`00_mcLg<01?nUYJGoc/k>ono_koo_knl2ooOgm`07onONioogmoOoknO_omkNg_oFe]Koa/k>
okg6aP02olK>cP03onoooooooooooooo0?oooooooooooolkooooo`03onk^k_oShn?o^KVi00;ok^k^
0003onKViP03okVi^OoShn?ooooo00Gooooo00?omoOgooooooooool01?ooool01_ogmoOooooooooo
oooooooog]kNojFUY@;oNg]k00KoW9bLolk>c_o_knoomoOgono_koogmoL>ooooo`09ooOgmooFe]Ko
W9bLog=cLom[Jf_oU9BDokfm_OoWinOokmkN00;omno_00OomnO_onOWiooNg]koe]KNolkFe_oooooo
kooo00;ooooo00?okoooooooooooool0ooooooooooooocOooooo00?oi^KVon?Shoni^KT00_oVi^H0
00?ok^k^00?o^KVion?ShoogmoL00oooool00oogmoOoooooooooo`0>ooooo`05ono_konm]KGoS8b<
olK6a_ogmoL05?ooool01ooNg]koYJFUohAkNomSHf?oQ7]kojf][OoFe]H00_o_knl00oo_inooino_
ooOgm`04ooooo`03ooOgmooooooooooo0?oooooooooooolfooooo`03onk^k_oShn?o^KVi00;ok^k^
0003ooooo`03okVi^OoShn?ooooo00;ooooo00?omoOgooooooooool0;?ooool01_o_oooo_LJmohB4
Q?mSHf?oJg=[olK6a_oooooooooooom0ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi
^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoS
hn?ooooo0?oooooooooooomfooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^Oo3`l?o
`l?30?oo`l?3ooo3`l=hol?3``7o^KVi0Oo^k^h1onk^kP000oooooooogalO?ooO7alO?mlO7`2oooo
o`00ooo^k^koonk^kX7ok^k^003oonKVi_ooi^KVPOoVi^H00?ook^k^ooo^k^j1onk^kP00oomoOgmF
ogmoO`OoOWinoomoOglTogmoO`0000Cojn_[onKVi_oRh^;og]kN1?oMgMd3omkNgP3oomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM000ComkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomgMg@02omcLg00mom_KfooMgMgog=cLomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkogMgMom_KfooJ
f][oemOGomSHf?oGemOof][Jom_Kg002omgMg@0WomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kN00?ogMgM0>[og]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMd4omkNgP03omgM
gOoNg]kog]kN00?ogMgM0OoQhN41onOWi`7oj^[Z00000oo/k>coi^KVon3Ph007omWIf@04omSHf?oF
e]Kodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?Cdoo@d=03olg=
c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd01?o@d=3odm?ComOG
eooHf=SJomWIf@;of=SH00Koe]KFom?CdooCdm?oe=CDomOGeooHf=P2omWIf@03omSHf?oIfMWofMWI
00;of=SH2OoIfMT00ooHf=SofMWIomWIf@02omSHf003omWIfOoHf=Sof=SH00;of=SH5ooIfMT01?oH
f=Soe]KFom;Bd_o?cll2olg=c@04olo?cooCdm?oemOGomSHf?oofMWI5_oIfMT00ooHf=SofMWIomWI
f@06omWIf@7og]kN0OoVi^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoPh>3oh^;R00;ohN7Q
00gog]kNomcLg?oCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q
00gogmoOom_KfooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q
00gogmoOom_KfooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO0=WohN7Q
00Woh>3PomoOgooKfm_oe]KFomCDe?oFe]Kof][JomkNg_oPh>001_oOgml3on3Ph003omoOgooPh>3o
h>3P00;oh>3P2?oOgml2omkNgP;ogmoO0ooPh>02omoOg`;oh>3P0_oOgml=on3Ph005omoOgooMgMgo
fMWIomGEeOoCdm<00_oBd]800ooFe]Kog=cLon3Ph03oon7QhASohN7Q00?oh^;Ron7QhOoRh^801?oQ
hN41onCTi07ojNWY0Oo]kNd00003oo3`l?o_knoolO7a00?ol?3`0?ookno_oo3`l?o^k^kojNWYom_K
foo1`L7oY:BTohb<S?mkNg_oMgMgog]kNon<S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_oNg]kogMgMomkNg_oS8b<ojBT
Y?o2`/;of][Jon[Zj?o]kNgolO7aono_kooalO7okno_oo7alOo_knoolO7_ong]kOoZj^[of][Jol;2
`_nTY:CoS8b<og]kNomgMgKoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^[okNg]oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knl001oolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo3`k_o]kNgok>c/onGUiOoRh^;ogmoOonGUiOoYjNWokNg[00;oj>SX00Koi^KV
onWYjOoWinOojn_[onc/k?o^k^`3on[ZjP09ono_koo^k^kok^k^onSXj?oXj>Koi^KVonWYjOoWinOo
j^[Z00;ojNWY00goiNGUonOWiOoWinOojn_[onc/k?o_knoojn_[on[Zj_oYjNWok^k/onc/k?o[jn_o
j>SX00;okNg]01Cok^k^on[Zj_o/k>[ok>c/onk^k_oZj^[ok>c/ong]kOo^k^koj^[Zonc/j_o/k>co
k^k^ojf][OmgMgOoFEUIofm_Konf][KohN7PonOWi`;okno_0?oolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7ok^k^oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO4001gokno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`04oo3`l00000?ol_;bonk^k_oWinL0
1?oUiND04?oTi>CogmoOom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RXWo
/K6aom7AdOoNg]h2onCTi003onGUiOoTi>CoiNGT00;oi>CT00oog]kNom7AdOna/K7oRXZ:ofIVI_mA
DE7oADE5od92@_m5ADGoDE5AofIVI_n:RX[o/K6aom7Ad?oNg]h00_oTi>@0m_oUiNGoi>CTonGUiOoT
i>Coi>CSomkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoA
dM7og]kNonCThooTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oShn?oa/K6obPX:?m5ADGoShn?om;Bd_oK
fm_og=cKomKFeP?oeMGE01Woe=CDom[Jf_oOgmoogmoNomWIfOoEeMGof=SHomoOgooQhN7ogMgMomKF
e_oEeMCoe=CDomGEeOoDe=CofMWIom[Jf_oHf=SoeMGEomKFeOoFe]KofMWIomgMgOoPh>3ofm_K00;o
e]KF00WogMgLomcLg?oHf=SoeMGEomcLg?oPh>3ogmoOom[Jf_oKfmX00_oMgMd0oooIfMWog=cLomoO
gooPh>3ofm_Kom[JfOoMgMgoh>3Pog=cLomXJ6SoSHf=oeADE?l820SoXj>Rom_KfooShn?oi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi0009OoUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiND00_oTi>@4onGUi@06onCTi?oUiNGoiNGUonGUiOoXj>SokNg]0Oob
l_800003ooCdm?o]kNgoinOW00;oh>3P01?ohN7QomoOgooNg]kod];BokBd]?n7QhOoG5aLofdk=OnN
CT;ocFmOonV3Koo=KeooWTi3ofdk=_mLG5coQhN7okBd]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd
];CoQhN7oeaLG?m]H2coWYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aLohN7Qond];Cod];BomkNgP05
on3Ph00AomkNg_oBd];o];BdohN7QomLG5coAfL^ofRN<onAcDOoZ^UEoi7=AomZWSCoBFX_oeaLG?n7
QhOo];Bdom;Bd_oNg]h0f?oPh>001_oOgmooclo?oiVIVOnBTY;o6ATIohb<S0;oeMGE01ooclo?ol;2
`_o>c/koc/k>olG5aOo:b/[of][JomSHf?o@d=3obl_;olo?cooHf=Sof][JomGEeOo?cloo`L71om3@
d?o>c/koa<C4ol_;booHf=SoemOGokjn__nk^k_odM7Aom3@d?oEeMGof=SHom?Cdoo<c<coc/k>00;o
eMGE00Goc/k>olc<c?oCdm?of][JomSHf002om;BdP04omSHf?oGemOodM7Aom?Cd`;ofMWI00Kodm?C
om7AdOoGemOof=SHom7AdOo@d=02om7Ad@04odI6A_m1@D7oemOGomkNgRSoh>3P00?ogmoOon3Ph?oP
h>000ooPh>000ooOgmooh>3Pon3Ph03Ton3Ph003omoOgooPh>3ogmoO00;ogmoO0ooPh>000ooQhN7o
inOWonc/k001ooCdm00000?om_Kfoo;bl_o[jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWiooJemOohlf
;_o]LF7onIf@oofaYOom_:oooKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;Rh_oWinL00ooXj>P0
4ooWinOoh^;Rolg=cOnOWiooKVIOoi=b8_o]dDConO=doogmSOomoIGooOf>ooWhM_o]edOoTg<RofiW
GonOWioocLg=on;Rh_oWinL00ooXj>P04ooWinOoh^;Rolg=cOnOWiooH6QOod]l8onBhD_o_OUkom3m
T_oHoI_oe?fEol3iO_nHj4goCH0Tof1YGonOWioocLg=on;Rh_oWinL0fOoXj>P01?oVi^KohN7QoeeM
GOm=CDd2omgMg@0Ooe1@D?l71`Oo5ADEohB4Q?lF5QKo@d=3on;Rh_oMgMgoW9bLo`000?n?ShoogMgM
on7QhOoKfm_o@410o`P82?lI6AWoR8R8o`/;2omHF5So]kNgo``<3?l71`Oo8b<SobLW9ommOGgof][J
omgMgOoDe=Co2`/;oeUIF@02omWIf@03oeeMGOl;2`_odm?C00;ogmoO00KoFUYJodi>C_oNg]kog]kN
ob<S8on4Q8@2on7Qh@0<ogYjN_l^;RkogMgMomgMgOo2`/;oD51@oc<c<om^KVkoPh>3ob4Q8OoNg]ko
i^KVoooXj>POonSXj07ok>c/0Oobl_81ooKfmP0000?omoOgooShn?ohn?P00oohn?P04oogmoOok^k^
olk>c_n@T93oQBl[onUTE_okTXOooZJKoojaYOoo^:_oo[>VoojXW?okU8WokVQIohTa:on@T93oc/k>
onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93oVFT[oo2m?Ookh6koo_B2ooknR_oooi;oo_j<
ookhPookiG3ol<8noiUZ:on@T93oc/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93o@W<[
ohC>@on]kg?o`_j8olknT?oFoiOod?jBolKnROnbmGCoR==3odAe:on@T93oc/k>onk^k_ogmoL0fOoh
n?P09Oofm_KolO7aoh61POlO7aookNg]olK6a_l0003o`l?3om?CdomLG5co20P8on[Zj_o`l?3oj^[Z
oe9BD_lD51Co?CdmonWYjOo`l?3o[jn_o`L71ooBd];ocLg=odi>C_lK6a_ok^k^om_Kfon^[Zkoj>SX
onc/k?n^[Zko0000okBd]?o/k>co/;2`o`/;2olJ6QX00_oTi>@02olS8b?o3Ph>ojBTY?o]kNgok^k^
of1PH?mDE5Cok^k^ong]kOlV9RKoSHf=00;ol?3`00coPX:2oc4a<Oo/k>coj^[Zod=3@ol_;booW9bL
og=cLolZ:R[o6QXJonk^k_ofm_KoooShn1Son?Sh00?omoOgooShn?ohn?P00_ohn?P01?ogmoOonOWi
ooOgmoogmoL1ooShn00000?on_[jooGemOo^k^h00_o/k>`0ooo[jn_ojNWYomoOgonj^[[oNE9Boklb
9?oWM6WooHUnoonHS?onXYKoojRLoojTV?ooVXgooXYoonifJ_o3<bCoNE9BokZj^_oOgmooj^[Zon_[
joo/k>cojn_/on[Zj_oOgmoo^[ZjohQUD_oRTAconL=@oogJHooojW;oo_=nooojP_onmWooonacookN
I?ojae7ohY8LohUVDonj^[[ogmoOon[Zj_o[jn_ok>c/on_[jooZj^[ogmoOokZj^_mBKE;oDJ<Loi7B
EOnVif[o^?Ujol3nP_o7ohWo`oj4okWmNonWk6coU=IGoe:V7?mBKE;o^[ZjomoOgooZj^[ojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k000A?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[on[Zj_oTi>CoNWYjoa`L7?oRh^;obl_<o`<30onOWioogmoO
oiBDU?lC4a?oh>3Pon7QhOo@d=3o1PH6oj6QXOl92@Wo_[jnon;Rh_ni^KWo0P82ok6a/_oNg]koP820
obTY:OoRh^;oj>SXonCTi?oOgmoof][KomCDe?l820SoQXJ6omoOgomZJV[oBDU9ocDe=On/[:go_[jn
o`L71omhN7SoEEEE0_oOgml01_mKFe_oCdm@on;Rh_oPh>3o92@TohB4Q0;oh>3P0?ooNg]kobl_;ooQ
hN7oe=CDo`D51OnWYjOoi>CTon;Rh_moOgoo5ADFon;Rh_oYjNWok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/
k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>`002;ojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/1_o[jn/01Oo/k>cojn_[on_[joo^k^kom_Kf007onOWi00000ookno_olo?cong]k@02
onGUi@3oonKVi_oTi>CofMWIok:b/_mi;Rkob48don=ZG?odNVgooHQloojGR_onVhkooYR;ooj:O_od
Nfgoif]MolY2=?mk;Rko/[:bomSHf?oTi>CoiNGUonKVi_oUiNKoi>CTomSHf?nb/[;oUUD^onZL:ook
_4Coo/aCoogHH_onhg;oo^UeookVLoonffGooLaCoo_1AOo^WR_oVEH^ok:b/_oHf=Soi>CTonGUiOoV
i^KoiNGUonCTi?oHf=Wo/[:bobiR;_mS[B_oQlY8oiOLFOnUiFWo/_=gokSfNondmGWoYnY[oiSLFOn9
cd_oHjh[obiS;_nb/[;of=SIonCTi?oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGV000UonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi>CTomkN
g_mgMgOo6a/KomcLg?oPh>7oWYjNobh^;_l[:b_o<S8boa8B4P02om_Kf`0UohB4Q?lQ8B7ogmoOoe=C
DomWIfOofm_KomgMgOn@T93o:BTZobl_;ol/;2co:2PXomgMgOoOgmoof=SHomCDe?o?cm3oFe]Ko`00
0?nn_[kofMWIobPX:?n6QXKoN7QhofQXJ?n2PX;o?3`lol?3`ol?3`ooeMGEomWIfOmIFEWoCTi>omgM
gOoLg=co8b<Soh61P@02omKFeP0jogMgMol^;RkogMgMoj:RX_l0003oa/K6omWIfOoHf=SoSXj>oaDE
5OoMgMgohn?SonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonCTi@;oiNGU0>Coi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiND3onKViP03onGUiOoVi^Koi^KV00?oi^KV00?o
iNGUong]kOodm?@00Oojn_X00003ooclo?ohn?SolO7a00?ok^k^01?ojn_[on7QhOnl_;coNQLGol<o
<_oCETWoi6QJonmgK?odPgWon8MlooF4N_ocNFgoiFUKomUHB_o4?c;oO1LGokbl_?oQhN7ok>c/00?o
k^k^01?ok>c/on7QhOnl_;coYDLGonJG<_oe[33ooKa1oog9Doomd63onm=UoogBH?oncECooKe2ooZ_
<_oYVc;oYDHGokbl_?oQhN7ok>c/00?ok^k^01?ok>c/on7QhOnl_;co5eTGoenX<_mf_COoQ/e7oiKF
F_nRh6GoXn1Yoj?QIonGfUcoQ/i7ogNo=omOZc;o5eTGokbl_?oQhN7ok>c/0=Wok^k^02kok>c/onOW
iomkNg_o71`LonCTi?oYjNWoi^KVon7QhOoNg]koSHf=oa@D5?oVi^Koi>CTocDe=OmiNGWojn_[ok:b
/_lE5AGogmoOonKVi_oTi>CohN7QomgMgOmjNW[o:BTYonSXj?oUiNGogMgMok6a/OlV9RKo2`/;oi^K
VooYjNWoc<c<o`000?o>c/ko`l?3obDU9Om;Bd_oO7alonSXj?la<C7oYJFUonCTi?mMGEgoDE5A0_oW
inL02_lU9BGoJFUYomoOgooOgmooMgMgoc4a<OoYjNWo`L71o`000?nWYjL2omoOg`04oi>CTolF5QKo
inOWonc/k?ook^k^7_o^k^h00oo]kNgol_;booShn001ooclo0000oomoOd05_olo?cooOgmoogmoOol
o?colo?com7AdOmX1`Oo^3@dolLo<ooBD4?ofV9Eon=^H_oTLVCoi6mRomaTEooCDD?oc44dokTd=?m[
1`Ood];Boo?cloolo?`3oogmo@0Cooclo?oclo?od];Boih[1ooJRSCoji/IooFX:Ooh]3oonKe:ooRo
COoj_d[onKPoooJZ:_o_WQWofh/doj8]1ooBd];olo?cooclo003oogmo@0Cooclo?oclo?od];Bo`M0
1om=VSCoGj/Pog2h;omo`d?oR/e@ohg=D_n:cU3oPLM4og6i;omR[R3oCY/do`M21ooBd];olo?coocl
o03Ioogmo@0Soo_knoogmoOoQ8B4oahN7_oclo?onOWiok>c/oo@d=3olo?cofQXJ?m7AdOon_[jomCD
e?l0003ogMgMooclo?okno_o9bLWojRXZ?oinOWoZj^[omGEeOoalO7oE5ADoeiNG_oinOWom?CdoiBD
U?l51@Go@410om7AdOogmoOon?ShoiNGUol[:b/00_ojn_X06olT92Co1`L7olS8b?okno_oQHF5of=S
HoogmoOoHf=SoeMGEoohn?SonOWiobLW9olE5AGoPh>3omOGeom2@T;oHf=Soo_knoojn_[o=3@dodU9
BOoKfm_oiNGUodm?ColG5aOon_[jooclo03ooogmoAcooOgm00?oo?cloogmoOolo?`00oomoOd0000j
oogmoOojn_[olo?conk^k_o`l?3okno_onk^k_oYjNWodm?Coe/M7OnR=3Co]2PMol4j;Oo7BCcoceI:
om1GBoo@Ed[obTXnol<k;_nf:1goXS@doe`M7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`koo^k^koj^[Z
om?Cdon<9Agob74domV47OoTU1GoiidTonjX<oo`ZSCokjXconbP9OoWUaGog8PMolQa=?n<9Agodm?C
on[Zj_o^k^kol?3`ono_koo`l?3ok^k^on[ZjOoCdm?o7CPMocB2=?m7UAgoFZDKofV]:P;oM;Ph0?oo
MKThof^a:omKYacoB9XMocB2=?lM>1godm?Con[ZjOo^k^kol?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`onk^k_o[jn_oOGemoa`L7?oWinOok^k]ohR8R?l`<33o3Ph>oc4a<On`/;3okno_ohB4Q?m=CDgo
k^k^ono_koo^k^koRXZ:oeUIFOo_knooN7Qhob`/:ol=3@go>3Phokjn__o^k^kohn?So`h>3_mYJFT0
00[oh>3Oon;Rh_oVi^Koj^[Zof5QHOmfMWKokno_onk^k_mgMgKo9RHV0_o^k^h05_o=cLgo;2`/on_[
jom/K6coHf=Ron_[joo^k^ko>SXjoiBDU?mRHV;o3Ph>oc@d=?o4a<Cok^k^ono_kooAdM7o?3`lo`X:
2_lW9bOoK6a/ob`/;?o^k^h2ono_k`3ooo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`000Dono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?02ono_k`;ol?3`1_o_
knl1oo?cl`7onOWi0Oono_h00003ookno_ogmoOol?3`00CojNWY017oinOWom_KfomSBd_oPC8bojHe
=Onf=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mSBd_ofm_KonOWi`05onWYj@0AonOW
iooKfm_oRD];ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;oRD];om_K
fooWinL01OoYjNT04OoWinOofm_Kod];BolbH3;o>XTeoe>K;Om[ZbooL:dhofn^>_m`[CSoJZX_oe>K
;OliR3Go<V0bod];BooKfm_oinOW0=[ojNWY00Koj>SXonKVi_mkNg_o71`LonCTi?oXj>P2onWYj@03
onOWiooYjNWojNWY00_ojNWY00coinOWonWYjOoYjNWoj>SXomSHf?l:2P[o[Zj^omgMgOoNg]koh>3P
onGUiOoXj>P8onWYj@06onSXj?oVi^Kohn?Son?ShooVi^Koj>SX0ooYjNT00ooXj>SojNWYonWYj@04
onWYj@03onOWiooYjNWojNWY02_ojNWY00?oj>SXonWYjOoYjNT0k?oYjNT00ooXj>SojNWYonWYj@04
onWYj@7ol?3`0Oofm_H1ooknoP0000Goo_knoo[jn_odm?Cokno_oo7al@02oo3`l00Aono_koo[jn_o
UIBDodlS8onEE5Co^g=com>EUOoJW9cofYjLomVLW?oDUIGo^g=coiEDE?m?8b?oUIBDon[Zj_o_knl0
1Oo`l?004Oo_knooj^[ZojVDU?n18b?o^VYDomBJLooT_9Goj/NLonW7W?oZaicoiKbEomBJLonkJUCo
PB<SojZDU?oZj^[okno_00Gol?3`017okno_on[Zj_nDU9Co8bXSoeAjE?mcYG?oW/JEojc>W?n]cYco
[<jLoik6UOmcYG?oE7YDob<Z8onDU9Coj^[Zono_k`3Joo3`l0;okno_00CoP820oadM7Oo^k^kokno_
4oo`l?02ono_k`07ofATI?lY:BWoPH61of=SHolk>c_ok^k^ono_k`08oo3`l006ono_koo^k^koLg=c
ofUYJOo^k^kokno_?_o`l?000oo_knool?3`oo3`l03[oo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn
00001?omoOgoooooooooooono_h2ooooo`;oo_kn0?oooOgmooShn?m^KVkoFSlook6@T?oNbLWol>CT
oo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?coooooookno_ooooooo_knooooo_ono_kooooo
ooclo?ohn?SoSFe]ohXo?oo9TI3ojM39ooCYi?ofjnKom>WTonW@bOo9TI3oRCloohe]KOohn?Ooo?cl
ooooooono_koooooookno_ooooooo_knooooo_olo?con?Shofe]KOlo?cooT9f@olWEbOoTk>Coi^kV
onC/i?o9eLWoT9f@oclo?om]KFgon?Shooclo?ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_h001Ooooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooo`02ooknoP0Holo?conVYZKooOgmooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo0_ono_h03_o0
`<3oLG5aoh20P?n`/;3ooOgmooooooono_koooooookno_ooookoo_knooooooono_kooooo0_ono_h0
ooo1`L7o_KfloogmoOooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
oP00:Oooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo00;oo_kn00Gooooo
ookno_ooooooooooooknoP05ooooo`7ojng_00001?oem_Koo_knooWinOodm?@5oo7al@0=ono_kooF
e]KoJf][od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7al@0=ono_kooG
e]KoPf][og@m?OneS8coeKZjon7<c?oF^[[o]Xb<og8m?On1Jf_oemKFono_k`09oo7al@0=ono_kooF
e]KoJf][ocdm?On<S8co^[Zjolc=c?nj^[[oS8b<ocdm?Om[Jf_oe]KFono_k`3ooo7alDGolO7a00?o
l?3`oo7alOoalO40j_oalO401?o`l?3olO7aoo7alOo`l?04oo7al@03ooCdm?ojn_[oo_kn007o_lG<
00001OoVinSooOgmooShn?o`l?3ojn_[00?oj^[Z00gojNWYon[Zj_oYjNWoj>SXoi^KVomIFEWo9RHV
o`T92OlV9RKoFEUIoi^KVooXj>SojNWY00_oj^[Z00_ojNWYonSXj?nPVi_oJUUIod<V9_l]2@Wo@RHV
ofUIFOnPVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^K
onSXj?oYjNT0oooZj^[oon[ZjS_oj^[Z00Cojn_[oo3`l?ohn?SooOgm0On1RiD00004okfn_ooin_[o
n_[joo?cl`SolO7a0_o`l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_
knl2oo3`l?oolO7aoooalO4ioo7al@03oo3`l?oalO7olO7a00;olO7a00?omOGeoo[jn_ng_/<00Olc
@D`00003olW:boo5a/Oon_[k0?oooooooooooomkooooo`7o^Ko30Om=Ef01oah/>P0000Ko4QdVoa4I
8OlX<3OoMgj3okRl_ooYj^_oooooooooooooMOooool01OoZk>go_<;6ogf6S_l`>dGo6bPc007o7blk
0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{639, 481},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009o0001hB000`400?l00000o`00003oooo`l?3o
oo3`l7;ol?3`00?ofMWIooooooooool03?ooool00?ool?3`ooo`l?1boo3`l004omWIfOoooooooooo
onGUi@?ooooo00GoiNGUooooooooooooooooonGUi@03ooooo`00ooo`l?3ooo3`l7;ol?3`00gofMWI
oooooooJf][oSHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003ooo3`
l?ool?3`L_o`l?003_oIfMWooooooooooooJf][oSHf=onGUiOoooooof][Johf=SOoUiNGoooooom[J
f_n=SHgoiNGU0Oooool00?ool?3`ooo`l?1boo3`l00=omWIfOoooooooooooooooooJf][oSHf=onGU
iOoooooof][Johf=SOoUiNGoooooom[JfP02ooooo`00ooo`l?3ooo3`l7;ol?3`00?ofMWIoooooooo
ool00_ooool01ooJf][oSHf=onGUiOoooooof][Johf=SOoUiND00oooool00?ool?3`ooo`l?1boo3`
l003omWIfOoooooooooo00?ooooo00Oof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003o
oo3`l?ool?3`L_o`l?000ooIfMWoooooooooo`04ooooo`07om[Jf_n=SHgoiNGUoooooooLg=coSHf=
onGUi@01ooooo`00ooo`l?3ooo3`l7;ol?3`00?ofMWIooooooooool01Oooool01OoJf][oSHf=onGU
iOoooooog=cL00;ooooo003ooo3`l?ool?3`L_o`l?000ooIfMWoooooooooo`06ooooo`03omcLg?n=
SHgoiNGU00?ooooo003ooo3`l?ool?3`L_o`l?000ooIfMWoooooooooo`07ooooo`03omcLg?n=SHgo
iNGU00;ooooo003ooo3`l?ool?3`L_o`l?000ooIfMWoooooooooo`08ooooo`03omcLg?n=SHgoiNGU
007ooooo003ooo3`l?ool?3`L_o`l?000ooIfMWoooooooooo`09ooooo`7og=cL0Oooool1ooooo`00
ooo`l?3ooo3`l7;ol?3`00?ofMWIooooooooool03?ooool00?ool?3`ooo`l?1boo3`l0oofMWI003o
ooooooooooooPOooool00?ook^k^ooo^k^j1onk^kP000ooVi^Koolo?coooclo?O?o?cll2onKViP00
0oo^k^h00oni^KWok^k^onk^kP3oonk^k_ook^k^N?o^k^h1okVi^@7ok^k^0Oo^k^h000?ooooo00?o
^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVi
on?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?S
hoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shooo
ool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0
ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0oooo
ooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0oooooooo
ooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0oooooooooooo
ogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOo
oooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo
00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?o
i^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi
^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni
^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT0
0_oVi^H000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^
k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool0
00?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
i^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^
00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o
^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVi
on?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?S
hoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shooo
ool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0
ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0oooo
ooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0oooooooo
ooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0oooooooooooo
ogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOo
oooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo
00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?o
i^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi
^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni
^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT0
0_oVi^H000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^
k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool0
00?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
i^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^
00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o
^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVi
on?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?S
hoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shooo
ool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0
ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0oooo
ooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0oooooooo
ooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0oooooooooooo
ogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOo
oooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo
00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?o
i^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi
^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni
^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT0
0_oVi^H000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^
k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool0
00?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
i^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^
00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o
^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVi
on?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?S
hoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shooo
ool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0
ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0oooo
ooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0oooooooo
ooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0oooooooooooo
ogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOo
oooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo
00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?o
i^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi
^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni
^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT0
0_oVi^H000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^
k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool0
00?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
i^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^
00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o
^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVi
on?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?S
hoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shooo
ool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0
ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0oooo
ooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0oooooooo
ooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0oooooooooooo
ogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOo
oooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo
00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?o
i^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi
^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni
^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT0
0_oVi^H000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^
k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool0
00?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
i^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^
00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o
^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVi
on?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?S
hoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shooo
ool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0
ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0oooo
ooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0oooooooo
ooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0oooooooooooo
ogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOo
oooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo
00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?o
i^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi
^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni
^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0ooooooooooooogKooooo00?oi^KVon?Shoni^KT0
0_oVi^H000?ok^k^00?o^KVion?Shoooool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^
k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool0
00?ok^k^00?o^KVion?Shoooool08?ooool00oo_moOoooooonogm`02ooooo`03onogmooooooooooo
00;ooooo00?okoOgooooooo_moL00_ooool00oo_moOoooooooooo`3oooooooooooooA?ooool00oo^
k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0Jooooo`03onoWioogmnooknOW01_o
knOW00Coe]KWonoWioo_inOoe]KW1_o_inL00oo_moOoooooooooo`3ooooooooooooo<Oooool00ooV
i^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0Iooooo`0>ooOgkooNg]koc/kNokfm
_One_Lkoc/JeokFmc_o>a[Go]Kg>olk6]Onm_Kgo]Kg>olk6]One_Lh3okfm_@07olk>c_nm_Kgoa[fm
okFmc_o>a[Goa[fmokFmcP02okfm_@05olJm_One_Lko_KfmolJm_One_Lh00onm_Kd02Oo>c/ko_Kfm
okfm_Oo6_Kgo]Kg>okfm_Oo>c/koc]KNonoWi`3ooooooooooooo<_ooool00oo^k^kohn?SokVi^@02
onk^kP000oooool00oni^KWohn?Sooooo`0Iooooo`05omkNg_o>c/ko[JfUojf]YOnLW:D04OnLW9`0
0onLW:Go[JFDoibLY@02oibLW007ojfUU?nLW:GoW9bLoibLW?n][JGoW9bLoibLY@02oibLW003ojf]
YOnLW9coW9bL00;o[JfU00?oc/k>omkNg_o_moL0oooooooooooooc;ooooo00?ohn?SokVi^Oooool0
0Oooool000?ok^k^00?o^KVion?Shoooool06Oooool00oo_inOog]kNooooo`0Vooooo`;og]kN00?o
knOWooooooooool0oooooooooooooboooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVi
on?Shoooool06Oooool00ooNg]koc]K>ooooo`0Cooooo`03ooOgkooooooooooo00;ooooo00Goinog
ooooooooooooooooonoWi`02ooooo`03onoWioooooooinog00;ooooo00CokoOgoooooooWimkoc/k>
oooooooooooooc;ooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool06?oo
ool00ooWkoOoinONolkFgP02ooooo`03onogmooooooooooo00_ooooo00?okoOgooooooooool00ooo
ool00ooWkoOoooooooooo`0:ooooo`07onoWiooooooooooooooooooNg]koc]KNonoWi`3ooooooooo
oooo<Oooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Iooooo`03omkN
g_oNc/Kooooo017ooooo00?okoOgooooooooool00_ooool00oogknOoooooooooo`02ooooo`04onO_
moooooooooooonO_m`Gooooo00GoknOWooooooo_inOoc/k>onogm`3ooooooooooooo<_ooool00ooS
hn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0Hooooo`03ooOgkooWg]koc]KN00ko
oooo00?okoOgooooooooool01?ooool00oogmnooooooooooo`0:ooooo`03onogmoooooooinog00;o
oooo00?og]kNolkFc_o_inL0oooooooooooooc7ooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV
00?o^KVion?Shoooool06Oooool00ooNg]koc/k>ooooo`03ooooo`0:onoWioo>c/koknOWonogmooo
ooooinogooooooo_inOoc/k>onoWi`;ooooo00?okoOgoooooooNg]h01OoNg]h01_oFc]KoQ7]coia[
Hon]Nf?oc[fUoiB<S0;o[G]S00[o_Kfmolk6]OoNg/koc/Jeokfm[OoWkoOoooooomkNg_o>c/kokoOg
oooooooooooooc7ooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool06Ooo
ool01?oFe^Oog]k>ooooooo_inL2okfm_@05olk>c_nLW9co[KFeolk>c_o_moL00_n][JD2oibLW00M
ohb<S?nm_Kgo[JfUonoWioooooooinONonoWioogmnooknOWooO_iooWimkog/k6oe9:@_mk40SoQ1P@
ojekHonD@S7oLaP@oi`a8Oo>YHCog]k>onoWc_oNg/koc/JeonoWiooooooog]kNolkFg_o_inL0oooo
oooooooooc7ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool06?ooool0
0oogmnooinONolkFgP02ooooo`03omK>e_oNg]koknOW00;og]kN00OoknOWoooooooFe^OoknOWolkF
c_oNg]ko_Kfm00;og]kN0_ooool06?o>c/koQ9BDoibLYOnLW9coNhB4of]cLomJJf_oBQPHog<H4?nL
<B7oQ3Taof<H6?n48ASoYG=JojekHonLW:GoW8AkoiB<Hon]]KGomoO_ooooooo_inOoc/k>onogmooo
oooooooooolbooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo01Wooooo
00?oe]KWomK>e_ooool01oooool00oo_moOoooooooooo`02ooooo`03onO_mooooooooooo00;ooooo
00kog/k6ohb<S?n<S8coJf][ohb<S?n]YICoJf][oe882?m[<BWoW34QojekHon4613oQ24Hof/a:@;o
BU9J00SoFUYJoe9:@_m[Lg?oknOWoooooooNg]koc]KNonoWiooooooooooooolaooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Wooooo00Gog]kNolkFc_oooooomnoWojfe
]@02okfm_@07okFmc_nm_JgoknOWolk>c_n][JGoknOWojfe]@02okfm_@0ComkNg_ne_Lkoc/Jeoooo
ooo>e]ko_Kfmojf]YOnLU8co[JFDolk6]OmkLf?o610@oe882?n]Nf?oS6]:oh@Q6?mk<BWoDSTaobTY
:@03ocTi<@06oeYJ@_o_inOoooooonOWg_o>c/kokoOgoooooooooooooc7ooooo00?oi^KVon?Shoni
^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool06?ooool0;Oo_moOoinONolk>c_ooooookoOgokfm
_On][JGoc/kNolk6]Oo>c/koknOWolk>c_nm_KgoknOWojf]YOnm_Kgoc/k>omkNg_o>c/ko[KFeoooo
oooNg/ko_Kf]ojf]YOnLW9co[Ib4oljmYOmcJf?o8AP@oe9:@_mS@SWoBS4Yoe8i<OmB>BWoNg]kog^4
Q?mJFU[oBU8iodY:<Om:DSWoknOWoooooooFe^Ooc]K>onoWi`3ooooooooooooo<Oooool00oo^k^ko
hn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Iooooo`08omkNg_o>e]koooooooooooo_
moOoooooonoWiooWkoL5ooooo`03onogmooooooooooo00;ooooo00WoknOWooooooo>c]ko_Kf]okfm
_OnDS8coLg=JojfLQ?mcJf<00_mB>C403om2:B7oDSTaoeY2>OmB>C7oS8acohb<S?mkNg_oJf=Bof][
B_mJHe[oknOWoooooooWimkoc/kNooOgk`3ooooooooooooo<_ooool00ooShn?o^KViooooo`01oooo
o`000oo^k^h00oni^KWohn?Sooooo`0Hooooo`;oknOW00?oe/kFooooooo_inL00_o>c/h02OnLW:Go
[JFDokFmc_o>a[Gog]kNolkFg_o>c/kog]kNolkFgP02olk>cP0<olJm_Oo>e]koooooolk6]On<S8co
S8acoeYJ@_n<S8coc/Jeog=[HomBBT;o<AP@0_mB>C401?mcFU;oDSTaoeYJ@_mkLf<2of][BP07oeYJ
@_m[Jd[oknOWonogmoo_inOoc]K>onoWi`3ooooooooooooo<Oooool00oo^k^kohn?SokVi^@02onk^
kP000ooVi^H00oni^KWohn?Sooooo`0Iooooo`06omkNg_o>e/kooooooooooon][JGo[KFe1?nm_Kd0
1_oNg]ko_Kfmolk6]Oo>e]koc/Jeojfe]@;o_Kfm017o[JfUoooooon]]KGoBTY:oe9:@_m[He;oS8ac
oib4NomJFU[oDSTYod8Y8Om[BT;oFUY2og=JD_mSFT[o:BTHocTi6002oeYB:@06ocTi6?mkHd[oknOW
oooooooNg]koc/k>oooooooooooooc;ooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVi
on?Shoooool06?ooool01_o_moOoinONolk>c_ooooookoOgonoWi`Wooooo01koknOWonOWg_oooooo
koOgonoWiooooooo[JfUobTa:OlY:ASoBTXYojfUU?o6_Kgo>CTaod8Y8OmB>C7oDTY2og]JB_m[He;o
FT8iobTY6?m:<BWoBTXYog=cF_m:<BWoDV=2omKFioooooooinONolkFg_o_inOooooooooooooo<Ooo
ool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Iooooo`0:omkNg_o>e]ko
ooooonoWioo>e]kog]kNolk>c_oNg]koc/k>onoWi`;oc]KN023oknOWomkNg_o>e]koc/k>omK>e_o_
inOoc]KNonogmon]YICo0000obTY6?li8ASoW9B<olk6[OmkLf?o:BTHod8Y8On]Nf?oU6]Jof/a:Oli
>ASo:BTHoc4i8Om:BRWoBTXaocTi6?m:BS7oknOWonogmoo_inOoc/k>onogmooooooooooooolboooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo01Sooooo02gokoOgonoWioo>
c/koooooomkNg_nm_Kgo[JfUojfe]On][JGoW9bLokG6e_n][JGo_Kf]olkFg_o>c/koW9bUojf]YOnm
_Kgoc]K>okfm_Oo_inOo[JfUoa000?lY:ASo<CTQokfm[OoNc[goS8acobTY6?mcFU;o[G]SolJ]W?n4
Ng?o<CTQoaP@4?li>ASoBU8iodYJ@_lY:BWo>D8aonoWioooooooe]KWolkFc_o_inL0oooooooooooo
oc7ooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool06?ooool2onoWi`03
olkFc_oooooooooo00?okoOg00ComoO_olkFg_oWimkoknOW1_o_moL3ooooo`0Hojf]YOlY:ASo:BTH
obTY6?n<S7?oc[fUodYJ@_lY:ASo>B4Hog]SB_n<Jd[oFUY2ocU2<OlY<BWo:B48odYB>On4U9CoNhB4
oeYSF_o_inOokoOgonOWg_o>c]komoO_oooooooooooooc7ooooo00?oi^KVon?Shoni^KT00_oVi^H0
00?ok^k^00?o^KVion?Shoooool06Oooool00ooNg]koc/kNooooo`04onoWi`04omKFioo_inOoinON
omKFi`KoknOW00Goe]KWooO_iooooooo[JfUoc4i8@02odYJ@P09oiB<Honm_Jgo[KFeof]cLol@40So
>B4Hoc4H4?lH413oFV][00;oFV=J00WoHg><ojfe]OnL]MkoYKG>onoWioo_moOog]kNolkFc_o_inL0
oooooooooooooc7ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool06Ooo
ool01_oNg]kog]k>ooooooo>e]ko_KfmokF][@;o[JfU01GoS8b<okFmc_nm_JgoW9bUojf]YOn]]KGo
_Kfmojf]YOn]]KGo[JfUonO_moooooooc/k>of=cS?mkQ8CoJf=Bog]kNonm_Jgo[JFDohb<S?lY:BT0
0_l000003Om:DU[oW;GNojFec_nL]MkoYKgNoibeionea]KoW;GNonoWioogmnoog]kNolk>c_o_moL0
oooooooooooooc;ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool06Ooo
ool01OoNg]koc]KNooooooo_inOog]kN00;okoOg00?oknOWolk>c_o_moL00_o_inL00oo>c/koknOW
olkFgP02onoWi`04onO_moogknOomoO_omKFi`;oW:fm00KoW9bUojf]YOnm_Kgo]Kg>okG6e_nU]Lh2
of=cS0KoW;GN00OoW;GWojFec_o_inOoooooomkNg_o>e]koknOW0?oooooooooooolaooooo`03onk^
k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Sooooo0_o_inL01Oo>e/koooooonoW
ioo_inOokoOg00;oknOW00?o[KFeonoWioo_moL01Oo_inL01OoWkoOomnoWonO_moooooooc]KN00;o
[KgW00?o[LKgoib]_Oo>aZd00onL]NL01On]a^ooW;GWoibeg_nL]MkoW;GW00GoW;GN00Goc]KNonog
mooNg]koc/k>onogm`0Booooo`03ooclo?oZj^[ooooo00cooooo00?oo_knonWYjOono_h04Oooool0
1?oalO7ooooooo[jn_odm?@2ooooo`03oogmoOoZj^[ooooo0?ooooool_ooool00ooVi^Kohn?SokVi
^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0Iooooo`08onOWg_o>c]koooooolkFg_nLW9coc/Je
okFmc_n]]KD2ojf]Y@03oibLYOn][JGoW9bL00;oc/k>013o[KFeojf]YOn<S8coc/k>oooooonea]Ko
W:gNoibeg_nL[MkoW:fmojf]YOnL[MkoW:g>oibeg_nL[MkoW:g>0_nL[Mh01_nL[LkoW:gNoib]g_nL
[LkoW:gNoib]cP;oknOW00?og]kNolkFc_o_inL02oooool00ol61PKofm_Kooooo`03ooooo`05oj6Q
XOlB4Q;o=cLgob4Q8Oo;bl/00_ooool01_nGUiOo3`l?oo[jn_ooooooC4a<oeIFEP;ooooo00So/K6a
oaLG5oli>CWo=3@dokVi^Ooooooo3Ph>on;RhP?ooooo01Co20P8ooooooooooooS8b<omcLg?oooooo
IVIVoh^;Roo/k>co9RHVob`/;?mJFU[o<S8bog=cLooooooo[Zj^oa0@4?l/;2co8b<SonSXj?oooooo
lOooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Hooooo`08onogmooN
g]kog]k>ooooooo_inOoc]KNonoWioogmnl3onoWi`05olkFg_o_inOoinONomKFioo_inL00ooNg]h0
1Oo_inOokoOgonoWioo>e]kog]kN00;oc]KN00Cog/k6omKFiooNg]koe]KW0_o>e]h00ooNg]koc]KN
olkFgP04olkFgP05okG6e_o_inOomoO_olkFg_o>c/h03?ooool00ol61PKofm_Kooooo`02ooooo`06
ooclo?lF5QKofMWIoooooonRXZ;oDE5A0_ooool02_m>CTko8b<Sok^k^oojn_[o5aLGob@T9?ofm_Ko
i^KVo`/;2oo7alL4ooooo`03o`h>3_oRh^;ooooo00;ooooo01;o20P8ooooooo5aLGo0`<3ofi^K_oo
ooooIVIVoh^;RonQXJ7o@d=3ooooooo;bl_o10@4ooclo?ono_ko7AdMojVYZOooool2oogmoOoooooo
l_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0Iooooo`;og]kN00ko
ooooonoWioooooooooooomKFioo>c/koknOWooOgkooooooomoO_onO_moo_inOo_KfmomkNgP;ooooo
00[oinogonoWioo_moOoooooonoWiooooooomnoWoooooooWkoOokoOg0_o_inL01?ooooooknOWonO_
moogmnl2onoWi`03omkNg_o_inOokoOg00;oknOW00?og]kNolkFc_o_inL02oooool00ol61PKofm_K
ooooo`02ooooo`0Aokfm_OlZ:R[oooooooooooo]kNgo2@T9oo?clooinOWo3`l?ojj^[_m/K6co`<30
odY:B_mYJFWo[jn_oj^[ZolQ8B400ono_kl01?oYjNWoooooo`h>3_oRh^83ooooo`0Ao`P82?oooooo
JVYZofm_KolW9bOono_kofIVI_n;Rh_ohN7QoahN7_nBTY;o^KVio`P82?oooooo`L71oaHF5_omoOd0
ooooooodooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Sooooo0_o_
inL04?o>e]koooooonogmon][JGo_Kfmolk>c_n<S8co[JfUokFmc_o_inOoW9bLojf]YOn<S8coQ9BD
oiB<S?n]]KD2ojf]Y@09olk>c_o_inOoinogomkNg_nLW:Goc/k>ojfe]On][JGoW9bL00;oc/k>00So
W9bLomkNg_n]YICoc/kNojf]YOnLW:GoQ9BDolkFcP;oknOW00CokoOgolk>g_o>c/kokoOg2oooool0
1ol61PKo9bLWofYZJ_nh^;SooOgmol[:b_lR8R800_ooool03OoUiNGo3`l?ooWinOnk^k_o?Cdmoo_k
nol^;RkoNGUiohj>S_nl_;coG5aLolO7aolG5aL00_mdM7@01OlK6a_o`L71ooooool>3PkogmoO00?o
oooo017o20P8oo[jn_lC4a?odM7AofYZJ_na/K7oIVIVoh^;Roooooooo?clolo?con=SHgo20P8oooo
ooo9bLWo3Ph>oo[jnP3oooooooCooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?S
hoooool06Oooool01OoNg]koc]K>ooooooo_inOoc/k>00?og]kN00[oc]KNonoWioo_inOog]kNolkF
g_o>c/koe/kFojfe]OoNg/koc]KN0_o>c/h01oooooooknOWojfe]On<S8co_Kfmojf]YOoNg]h00_o>
c/h02OoNg]koc/k>omkNg_o>c/kog]kNomK>e_o>e/koc/k>omKFi`03onoWi`03omkNc_o>e]koknOW
00_ooooo02go1PH6om;Bd_nh^;So92@TohJ6Q_oooooo8B4Qokbl_?olo?coPX:2oemOGoooooooLW9b
ohF5QOooooooFUYJoa<C4ooCdm?ono_kob8R8_ohn?So8R8Ron3Ph?o_knoo7AdMoo[jn_oooooo3Ph>
oe]KFoo/k>coo_knooooool820So/k>cobd];OoooooobLW9oe=CDomVIVKoRh^;ooooooo<c<cooOgm
olO7aolW9bL00_ooool01OlR8R;oSXj>oo_knoohn?Soo_kn0?oooooolOooool00oo^k^kohn?SokVi
^@02onk^kP000oooool00oni^KWohn?Sooooo`0Iooooo`04onOWg_o>e]koooooonogm`?ooooo00Go
knOWoooooooWkoOoooooooO_i`03ooooo`08onoWioo_moOoknOWooooooo_inOoooooomkNg_o>c/h2
omkNgP0:onoWioooooooinogooooooo_inOoinogooO_iooWkoOoknOWonO_m`CoknOW00Goe]KWonoW
ioo>e]kog/k6onogm`0;ooooo`0Ao`H61_oKfm_oooooohn?Sol`<33ooooool71`Ole=CGo9BDUod];
BooQhN7ooooooe9BD_oAdM7ooooook6a/Olj>SX00_ooool01_mfMWKoalO7ok^k^ola<C7o?cloojn_
[`;ooooo00So=cLgojFUYOl/;2co^k^kooooool820SoF5QHohR8R0;ooooo00So;Rh^oeADE?n;Rh_o
ooooofQXJ?lj>S[o<S8bojJVYP;ooooo00God=3@ofYZJ_l/;2co;2`/ooOgm`3ooooooo;ooooo00?o
hn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool06Oooool01OoFe^Ooc/k>ooooooo_
inOo[JfU00;o[KFe00Wo_Kfmojfe]OoNg]ko_Kfmojfe]OoWimko[JfUokFmc_n][JD00_o>c/h01one
[Jgo_Kfmojfe]OnLW9coS8b<okfm[Oo>c]h00_n]]KD2ojf]Y@06olk>g_nm_Kgo[JfUokfm_Oo>c/ko
[JfU0_n]]KD2ojf]Y@05olk>c_o_inOoc]K>olk>c_oWkoL02oooool01Ol61PKofm_Koo?clomKFe_o
G5aL01_ooooo00?o1`L7o`/;2ooShn<00_ooool00on5QHGo2PX:oh^;R`3ooooooogooooo00?ok^k^
on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool06?ooool02?ogmnooinONomkNg_oooooo
knOWojfe]On][JGoc/k>0_nm_Kd01?oNg]koc/k>ojf]YOoFe^L2ojf]Y@06olk>c_oNg]ko_KfmoibL
W?o>c/koa[fm0_nm_Kd02_o>c/kog]kNojfUU?n]]KGoc/k>okfm_Oo>c/ko[JfUokFmc_o>c/h2okfm
_@06ojf]YOo>c/ko_Kfmojf]YOnm_KgoknOW0_o>c/h00oogmnooooooooooo`09ooooo`05oa<C4olS
8b?o61PHoc`l??oBd]806oooool00olC4a?oAdM7ooooo`02ooooo`03on;Rh_l=3@goTI6A0?oooooo
oOooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0Iooooo`04omKFioo>
e/koooooonogm`?oknOW00Kog]kNooooooooooooknOWooooooo_moL2onoWi`06ooooooogmnoomoO_
omKFioogknOoinog0_ogmnl00ooWkoOokoOgonoWi`02onoWi`06onO_moo_inOog]kNonO_moo_inOo
c]KN0oo_inL01ooFe^Oog]kNomkNg_oWimkoc/k>olkFg_o_inL0oooooooooooooc7ooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool06?ooool01oogmnooinONomK>e_oooooo
knOWolk>c_n]]KD00_nLW9`02_n][JGo_KfmomkNg_o>c/ko_Kfmomk>a_o>e]ko_KfmokFmc_nm_Kd2
olk>cP0?okfm_One_Lkoc/k>olk6]Oo>e]ko_Kfmojfe]Oo>c]kog]k>okfm_On]]KGo_Kfmojfe]Onm
_Kgoc/k>00;o_Kfm00Coc/k>ojf]YOnm_Kgoc/kN0_o>c/kooooooooooooo<oooool00ooShn?o^KVi
ooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0Iooooo`07omKFioo>e/koooooonoWionLW9co
_Kfmojf]Y@02okfm_@05ojfe]Oo>c/ko_Kfmokfm_Oo>e]h00_n]]KD01_n][JGo[KFeojf]YOn]]KGo
_Kfmojf]Y@;o_Kfm00Sog]kNoib]_On][JGoc/JeolkFg_n4U9Co[JfUojfe]@;o[JfU00[oc/k>okfm
_OnLW9co_Kfmohb<S?nLW9cog]kNolk>c_oNc/Koinogoooooooooooooc7ooooo00?ok^k^on?Shoni
^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool06?ooool01_ogmnooinONolk>g_ogmnooknOWomkN
gP;oinog00KoknOWonogmoo_inOoinogonoWioo_moL2onoWi`04olk>g_o_inOomoO_olkFgP;og]kN
2oo_inL01_oNg]koknOWomkNg_oNg]koc/k>omK>eP;oc/k>00Coc]KNolk>c_o>c/komnoWoooooooo
oooooc7ooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool06Oooool01?oF
e^Ooc/k>oooooooFe^L5olk>cP04omkNg_o>c/koc/k>onONgPCoc/k>00coc/kNolk>c_o>c/koQ9BD
okfm_Oo>c/koc]KNolk>c_nm_Kgoc/k>okfm_Oo>c]h2olk>cP07okfm_Oo>c/ko_Kfmolk>c_nm_Kgo
]Jf]ojfe]@02okfm_@04omk>a_nm_Kgoc/k>onogmooooooooooooolaooooo`03onk^k_oShn?o^KVi
00;ok^k^0003ooooo`03okVi^OoShn?ooooo01Wooooo00Cog]kNolk>c_ooooooc]KN0on][JD03OnL
W:GoS8b<olk>c_nLW9co[JfUokG6e_nm_KgoQ9BDojfUU?n][JGoc/k>ojfe]Oo>c/h00_n][JD01?nL
W9co_Kfmolk>c_n][JD2ohb<S00@olJm_OnLW9coS8b<oibLW?nLW:GoS8b<okfm_On<S8coW9bLoiB<
S?nLW9coS8b<okFmc_nm_Kgog]k>onoWiooooooooooooolbooooo`03on?Shoni^KWooooo007ooooo
0003onk^kP03okVi^OoShn?ooooo01Sooooo00CokoOgonoWioo>c/kokoOg0oo_inL01OoNg]koknOW
olk>c_o>e/kog]kN00GoknOW00?oinONonoWioo_inL00_o_inL01_oFe^Oog]kNolkFc_o_inOoinON
omKFi`?oc/k>00So_Kf]olk>g_o>c/kog/k6okFmc_nm_Kgoc/k>okFmcP?o_Kfm00?o_Kf]olkFg_oo
ool0oooooooooooooc7ooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0
6?ooool01?ogknOoe]KWomkNc_ooool4omkNgP07olk>c_oNg]koc/kNomkNg_oNg/kog]kNolkFgP02
omkNgP03olk>g_oNg]kog]kN00;og]kN00[oc/k>onoWioo>c]kog]k>okFmc_oNc/Ko[JfUoibLYOne
_Lko]Jf]0_n][JD00on]]KGo[JfUojf]Y@02ojf]Y@06oibLYOn][JGo[KFeokfm_Oo_inOokoOgoooo
oooooooooc7ooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool06Oooool0
1?o_inOoc/k>onogmoo>c/h2ojf]Y@03oibLYOnLW9coS8b<00;o[JfU00goQ9BDoibLYOn][JGo[JfU
oibLYOn][JGoW9bUolk6]OnLW:GoS8b<oibLW?o>c/koS8b<00?oW9bL00Co[JfUohb<S?mkNg_oNg]k
0_m[Jf/02_nLW9coJf][of][JomkNg_oS8b<oeYJF_nLW9co[JfUolk>g_o_inOooooooooooooo<_oo
ool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Hooooo`06onO_mooWimko
c/k>ooooooo>c/koc]KN0ooNg]h02_nm_Kgog]kNomkNg_oNg]ko_KfmomkNg_o>c/koc]K>omkNg_oW
imh2olk>cP03okfm_Oo>c/kog]kN00;og]kN00coc/k>olkFg_o>c/ko_Kfmojf]YOnLW9coS8b<og]k
Non<S8coNg]kog^4Q?mkNg/2ohb<S003oibLW?nm_KgoknOW0?ooooooooooooldooooo`03on?Shoni
^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo01Wooooo00CoinONolk>c_o_moOoknOW1?oN
g]h2okfm_@08onOWg_oNg]kog]kNomkNg_oWimkoe]KWomkNg_oFe^L6omkNgP08olk>g_oNg]kog/k6
olk>c_nm_KgoW9bLohb<S?m[Lg<4of][J`05og]kNomkQ8CoW9bLokfm_OoNg]h0ooooooooooooocCo
oooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool06?ooool02_ogmnooe]KW
olkFc_oWkoOoknOWohb<S?n][JGoc/k>ohBDU?ne[Jd5oibLW005olk>c_n]YICo[JfUohb<S?nLW:D0
0_n][JD00onLW9co[JfUohb<S002oibLW003og^4Q?nm_KgoNg]k00?oJf][00?oS8b<og]kNon<S8`0
0_n][JD2olk>cP03omkNg_oooooooooo0?oooooooooooolcooooo`03onKVi_oShn?o^KVi00;oi^KV
0003onk^kP03okVi^OoShn?ooooo01Wooooo00Oog]kNolk>c_o_moOoknOWolk>c_o>e/koinON00;o
g]kN00Woc]KNolk>c_o>c/koc]KNolk>c_oNg]koc/k>olk>g_oNg/h00oo>c/h00on]]KGoc/k>olk>
cP02olk>cP05olJm_One_Lko[JfUohb<S?nm_Kd01?ooool01?o_inOog]kNolk>c_oNg]kooooooooo
oooo=_ooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Iooooo`07omkN
g_o>c/koknOWonoWiooNg]koe]KWonoWi`02omkNgP0:onONg_o_inOoknOWonoWiooNg]koc/kNonOW
g_oNg]koe]KWonoWi`Kog]kN0oo>c/h00on]]KGoU8b<olk>cP03ooooo`;og]kN00?oc/k>omkNg_oo
ool0ooooooooooooocOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0
6?ooool06?oWkoOoinONolk>c_o_moOoc/Jeolj<HooNc[goknOWomjm[Oo6Nd[oc/J]olkFg_n][JGo
Q9BDojfe]OnLW9coc/k>ojfe]On]YICoQ9BDojfe]OnLU8coc/k>oibLY@CoW9bL00[o[JfUog^4Q?m[
Jf_o_Kfmooooooo_moOoinONomkNg_o>c/kog]kNooooooooooooocSooooo00?ok^k^on?Shoni^KT0
0_o^k^h000?oi^KV00?o^KVion?Shoooool06Oooool06?o>e]koc/k>onogmoo_inOoaZfLomkNc_o_
inOoaZfLolj<Hoo_inOoe]KWokfm[Oo>c/ko[KFeolk>c_oNg]koc/JeokFmc_o6_Kgoc/JeokFmc_o>
a[Go[JfUojfe]@;o_Kfm00[oW9bLojf]YOn<S8coNhB4olk>c_ooooooknOWolkFg_o>c/kog]kNoooo
ooooooooocWooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool06?ooool0
3Oo_moOoknOWolk>c_o_inOoinONolkFc_o>YHCoc/JeolIkB_o>_JGoknOWonOWg_o>e]h00_o_inL0
0ooWimkog]kNomkNgP04omkNgP03olk>g_o>c/kog]kN00;og]kN00Woa[fmokFmc_n][JGoS8b<olk>
g_o_inOog]kNolk>c_oNg]h0oooooooooooooc[ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo
00?o^KVion?Shoooool06Oooool02OoNg]koc/k>ooOgkooFe^OoknOWomJeW?o>a[GoaW]:olkFgP02
onoWi`03onOWg_oFe^OoinON00Gog]kN00Coc/kNomkNg_oNg/kog]kN1?o>c/h2ojf]Y@05ohb<S?oN
c/Kog]kNolk>c_oNg]h0oooooooooooooccooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o
^KVion?Shoooool06?ooool00ooWkoOoinONolk>cP03onoWi`03olk6]Oo>S6?ocYak00;oknOW00?o
inONomkNg_oNg]h00ooNg]h02?o>e]kog]kNomkNg_oNg]kog]k>omK>e_o>c/kog]kN0_o>c/h2okfm
_@;oW9bL00?oc]KNolk>c_oNg]h0oooooooooooooccooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
i^KV00?o^KVion?Shoooool06Oooool03?oNg]koc/k>onoWioo_inOoc]KNonOWg_neLe[oc/J]onoW
iooWimkoe]KWonOWgPGog]kN00Kog]k>olk>g_oNg/koc/kNomkNc_o>c]h3olk>cP06okfm_On]]KGo
W9bLokfm_Oo>c/kog]kNooooooooooooocgooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o
^KVion?Shoooool06?ooool01Oo_moOoknOWolk>c_ogmnooc]KN00;oknOW00Coc/JeonOWg_oWimko
e]KW1OoNg]h01oo>c]kog]kNolkFg_oNg/koc/kNomkNc_o>e]h00oo>c/h01_nm_Kgo[KFeojf]YOn]
]KGoc/JeomkNg_oooooooooooolnooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoS
hn?ooooo01Wooooo00_oknOWolkFg_o_inOoinONolkFg_o_inOoinONomKFiooWimkog]kNonOWgP03
omkNgP07omkNc_oNg]kog]k>omK>e_oNg]koc/k>olkFgP02olk>cP07olk6]One_Lko_Kfmokfm[On]
[JGo[KFeomKFi`3ooooooooooooo@?ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWo
hn?Sooooo`0Iooooo`0@onogmoo_inOomoO_omKFioo_inOoinONomKFiooWimkoc]KNonOWg_o>e]ko
g]kNolkFg_oNg]koc]KNomkNgP;oc]KN00?oc]K>olkFg_o>c/h00oo>c/h01Onm_Kgo[KFeojfe]Oo>
c/koknOW0?oooooooooooom0ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo01[ooooo3_o_inL02?oNg]koknOWonoWioo_inOog]kNonoWiooNg]koknOW0_oNg]h2onoWiooo
oooooooooom2ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooo
oooooomfooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooo
oomgooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomf
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfoooo
o`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03
onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?S
honi^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo03Cooooo00?okoOgooooooo_moL00_oo
ool00oo_moOoooooooooo`02ooooo`03onogmoooooookoOg00;ooooo00?okoOgooooooooool0oooo
oooooooooc3ooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0;_ooool0
0oo_inOomoO_onoWi`0KonoWi`04omKFioo_inOoknOWomKFi`KoknOW00?okoOgooooooooool0oooo
oooooooooagooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0;Oooool0
3_ogmnoog]kNolk>g_nm_Kgo]Kg>olk6]One_Lkoc/JeokFmc_o>a[Go_KfmokFmc_o>a[Go]Kg>0onm
_Kd01oo>c/ko_KfmolJm_One_Lkoc/JeolJm_One_Lh00_nm_Kd01Oo6_Kgo]Kg>okfm_Oo6_Kgo]Kg>
00?o_Kfm00Woc/k>okfm_Onm_Kgoa[fmokFmc_nm_Kgoc/k>olkFg_o_inL0oooooooooooooakooooo
00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0;Oooool01OoNg]koc/k>ojf]
YOn][JGoW9bU017oW9bL00?oW9bUojfUU?nLW:D00_nLW9`01on]YICoW9bUoibLW?nLW9co[JfUoibL
W?nLW:D00_nLW9`00on][JGoW9bLoibLW002ojf]Y@03olk>c_oNg]kokoOg0?oooooooooooolNoooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo02gooooo00?oknOWomkNg_oo
ool09_ooool2omkNgP03onoWiooooooooooo0?oooooooooooolKooooo`03onk^k_oShn?o^KVi00;o
k^k^0003onKViP03okVi^OoShn?ooooo02gooooo00?og]kNolkFc_ooool04oooool00oogmnoooooo
ooooo`02ooooo`05onO_moooooooooooooooooo_inL00_ooool00oo_inOoooooonO_m`02ooooo`04
onogmoooooooinONolk>c_oooooooooooolNooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo02cooooo00?oinogonOWg_o>e]h00_ooool00oo_moOoooooooooo`0;ooooo`03
onogmooooooooooo00?ooooo00?oinogooooooooool02_ooool01oo_inOooooooooooooooooog]kN
olkFg_o_inL0oooooooooooooagooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?S
hoooool0;Oooool00ooNg]kog/k6ooooo`0Aooooo`03onogmooooooooooo00;ooooo00?omnoWoooo
ooooool00_ooool01?oWkoOooooooooooooWkoL5ooooo`05onoWioooooooknOWolk>c_o_moL0oooo
oooooooooakooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0;?ooool0
0oogmnooimkNolkFgP0>ooooo`03onogmooooooooooo00Cooooo00?omoO_ooooooooool02_ooool0
0oo_moOoooooonO_m`02ooooo`03omkNg_o>e/koknOW0?oooooooooooolMooooo`03onk^k_oShn?o
^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo02gooooo00?og]kNolk>c_ooool00oooool02_o_
inOoc/k>onoWioo_moOoooooonO_moooooooknOWolk>c_o_inL2ooooo`03onogmooooooog]kN00Go
g]kN00Koe/kFohAkLonLJf?o[G]SoljmYOnDS8`2ojekH`0:okfm_Oo>a[Gog]k>olk6]Onm_Jgoinog
oooooooNg]koc/k>onogmooooooooooooolMooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo02gooooo00Coe]KWomkNc_ooooooknOW0_nm_Kd01Oo>c/koW9bLojfe]Oo>c/ko
koOg00;o[JfU0_nLW9`07On<S8co_Kfmojf]YOo_inOoooooonOWg_o_inOomoO_onoWioogknOoinON
omk>a_mBBT;oNa08oh@H4?n]Nf?oU48aog<H4?nL<B7ocZF4omkNc_o_ilkog]k>olk6]Oo_inOooooo
omkNg_o>e]koknOW0?oooooooooooolMooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo02cooooo00?omoO_onOWg_o>e]h00_ooool00ooFc]Kog]kNonoWi`02omkNgP07onoW
ioooooooe]KWonoWioo>e/kog]kNokfm_@02omkNgP;ooooo01Soc/k>ohBDU?nLW:GoW9bLog^4Q?m[
Lg?oFV][odXH6?mc613oW34Qoh@i<OmS61SoQ24HojEcF_n]Nf?oW9bUoib4NonDS6?o[KFeooOgkooo
ooooknOWolk>c_o_moOooooooooooooo7_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni
^KWohn?Sooooo`0]ooooo`03omKFiooFc]Kooooo00Oooooo00?okoOgooooooooool00_ooool00ooW
koOoooooooooo`02ooooo`0>omk>a_n<S8coS8b<of][Jon<S8co[JFDof][JomB20SoJc4Yoi`a8On]
Nf?oQ1P@oh@Q6?m[<BT2odYBFP08oeYJF_mBBT;oJg=conoWiooooooog]kNolkFg_o_inOooooooooo
oooo7Oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0]ooooo`05omkN
g_o>e/koooooooO_ion]]KD00_nm_Kd01one_Lko_Kf]onoWioo>c/ko[JfUonoWion]]KD00_nm_Kd0
4ooNg]ko]Kg>olk6]Oooooooc]KNokfm_On][JGoW9B<ojfUU?o>a[GoNg=SoaP@4?mB20So[G]Soha[
B_n48ASoNc4Yoe8i<OlY:BT00oli>C401_mJFT;oknOWoooooooWimkoc/k>onogmooooooooooooolM
ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo02cooooo02gokoOgonOW
g_o>c/koooooonogmonm_Kgo[JfUolk>g_o>a[Goc/k>onoWioo>c/ko_KfmonoWion][JGo_Kfmolk>
c_oNg]koc/k>ojfe]Ooooooog]k>okfm[On][JGoW9bLojfLQ?o>_JGoLf]Sob4H4?mBBT;oHd8iodXa
:OmB>C7oDSTYog]kNomkQ8CoFUYJodYB>Om:BS7oBU8ionoWioooooooe]KWolkFc_o_inL0oooooooo
oooooagooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0;Oooool02?oN
g]koc]KNooooooooooookoOgooooooo_inOoinog1Oooool00oo_moOoooooooooo`02ooooo`09onoW
ioooooooc/kNokfm[Onm_KgoU8b<og=cF_n]W8CoLf]S00;oDSTa00oo@RTQoe8i<OmJ@SWoDSTaohb<
Lon<S8coNg]kof]SD_m[Jd[oFV=JonoWioooooooinONolk>g_ogmnl0oooooooooooooakooooo00?o
hn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0;?ooool2onoWi`03omK>e_oooooo
knOW00;oc/k>00WoW9bUojfUU?ne_Lkoc/JeomkNg_o>e]koc/k>omkNg_o>e]h00_o>c/h03?o6_Kgo
c]KNooooooo>a[GoS8b<ohb<LomJFT;oS8b<olk6]OmcJf?oDTY2oc4H40;oDSTa00CoLeYBoe8i<OmJ
FT;oNg=S0_m[JdX01omJFT;oJf]:onoWioo_moOoknOWolkFc_o_inL0oooooooooooooagooooo00?o
k^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0;Oooool01_oNg]koc]K>oooooooo
oooo[JfUojfe]@Co_Kfm00Kog]kNokfm_Oo>a[Goc]KNolk6]On]]KD2okfm_@0Aojf]YOoooooo[KFe
odY:B_mBBT;oJf=Bohb<LonLQ7_oFUYJoe8i:Om2:B7oJdY2oeYJ@_mcFU;oHeY:obTY6?li>AP00_mJ
DRT01_li>ASoNf=:onoWiooooooog]kNolk>c_oooooooooooolNooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo02cooooo00KokoOgonOWg_o>c/koooooonogmoo_inL9oooo
o`0NonoWiooWimkoooooonogmoo_inOoooooojf]YOlY<BWo:BTHodY::On]YICoa[fmocTi<Om2:B7o
DSTaoe9:@_mkFT[oJf=BoeY2>OlY:ASoBS4YodY::OmcLe[oBS4Yoe9S@_oFe^OoooooonOWg_o>e]ko
knOWoooooooooooooagooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0
;Oooool02_oNg]koc]KNooooooo_inOoc]KNomkNg_o>c/kog]kNolk>c_o_inL2olkFgP0PonoWiooN
g]koc]KNolk>c_oFc]KoknOWolkFg_o_moOo[JFDo`000?lY:ASo>B4HoibDS?o>aZgoNg=SobTY6?m2
:B7o[G]SoiA[F_m[<BWo>CTHobTY6?la>B7oBTXYodY:<Oli>ASoBTXaonoWioo_moOoknOWolk>c_o_
moOooooooooooooo7_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0/
ooooo`0]onogmoo_inOoc/k>oooooooNg]ko_Kfmojf]YOn]]KGo[JfUoibLW?nea]Ko[JfUokfm[Oo>
e]koc/k>oibLYOn][JGo_KfmolkFc_nm_KgoknOWojf]YOl@003o:BTHoc4i8Onm_Jgog/jmohb<LolY
:ASoLeYBojekHoo6[IcoQ7]coc4i8OlH413o>CTHodYB>Om:FT;o:BTYocU2<Oo_inOoooooomKFioo>
e/koknOW0?oooooooooooolMooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo02cooooo0_o_inL00oo>e/koooooooooo`03onogm`04ooOgkoo>e]koinONonoWi`KokoOg0ooo
ool06?n][JGo:BTHobTY6?lY:ASoS8acoljmYOm:FT;o:BTHocTQ6?mkHd[oS6]:oeYJ@_li@S7o:C4Y
obTQ2?m:DSWoQ9BDog^4Q?mJHe[oknOWonogmooWimkoc/kNooOgkooooooooooooolMooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo02gooooo00?og]kNolk>g_ooool01?o_
inL01?oFe^OoknOWonOWg_oFe^L6onoWi`05omKFioogknOoooooojf]YOla>B400_m:FT802OnDS6?o
_Kf]ojfe]Om[Lg?o4108ocTQ6?la613o610@oeY[J`02oeYSFP09of=cS?n]]KGoW;GNojFec_o_inOo
koOgomkNg_o>e/koknOW0?oooooooooooolMooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03
okVi^OoShn?ooooo02gooooo00Kog]kNomkNc_ooooooc]KNokfm_One[Jd2ojf]Y@0Eohb<S?ne_Lko
_Kf]oibLYOn][JGo[KFeokfm_On][JGo[KFeojf]YOoWkoOoooooolk>c_mSLhcoNhB4of]SD_mkNg_o
_Kf]ojfUU?n<S8co:BTY00;o000000goBU9Joibeg_nU]LkoW;GNojFmg_nL]NOo]LKFoibeg_o_inOo
moO_omkNg_o>c/kokoOg0?oooooooooooolNooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03
okVi^OoShn?ooooo02gooooo00Gog]kNolkFg_ooooooknOWomkNgP02onogm`03onoWioo>c/kokoOg
00;oknOW00?oc/k>onoWioo>e]h00_o_inL01?oWkoOomnoWooOgkooFe^L2oib]_@06oibLYOn][JGo
_KfmokFmc_nea]KoYKG>0_mSLh`6oibegP07oibeionU]LkoknOWoooooooNg]koc]KNonoWi`09oooo
o`03ogQhN?nHV9Sok>c/0?oooooooooooolAooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03
okVi^OoShn?ooooo02cooooo0_o_inL01Oo>e/koooooonoWioo_inOokoOg00;oknOW00?o[KFeonoW
ioo_moL01Oo_inL01OoWkoOomnoWonO_moooooooc]KN00;o[KgW00?o[LKgoib]_Oo>aZd00onL]NL0
1On]a^ooW;GWoibeg_nL]MkoW;GW00GoW;GN00Goc]KNonogmooNg]koc/k>onogm`09ooooo`04oi:B
T_n9RHWo61PHoo[jnP;ooooo00ColO7aooooooojn_[om?Cd2?ooool01?oalO7ooooooo[jn_odm?Co
oooooogooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0;Oooool02?oW
imkoc/kNooooooo>e]koW9bLolk6]One_Lko[KFe0_n][JD00onLW:Go[JfUoibLW002olk>cP0@ojfe
]On][JGoS8b<olk>c_oooooo]LKFoib]g_nL]MkoW:gNoib]_On][JGoW:gNoib]c_nL]MkoW:gNoib]
cP;oW:gN00KoW:g>oib]g_nL[MkoW:g>oib]g_nL[Lh2onoWi`03omkNg_o>e/koknOW00_ooooo00co
=SHfokVi^Oo/k>co9RHVob`/;?mJFU[o<S8bog=cLoooooooo?cloaLG5omjNWX2ooooo`06onc/k?lV
9RKo;2`/oeYJF_lb<S;oLg=cooooooomooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo02cooooo00SokoOgomkNg_oNg/koooooonoWioo>e]koknOWooOgk`?oknOW00Goc]KN
onoWiooWimkoe]KWonoWi`03omkNgP05onoWioo_moOoknOWolkFg_oNg]h00_o>e]h01?oNc/Koe]KW
omkNg_oFe^L2olkFgP03omkNg_o>e]koc]KN00Coc]KN00Go]LKFonoWioogmnooc]KNolk>cP0<oooo
o`0Dodi>C_nATI7oXJ6Qod=3@ooooooobl_;o`@41?olo?cooooookFe]Ol[:b_o7QhNoo_knooooooo
XJ6Qod=3@ooooooobl_;o`@41?olo?coooooookooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^
00?o^KVion?Shoooool0;Oooool2omkNgP0>ooooooo_inOooooooooooooFe^Ooc/k>onoWioogmnoo
ooooooOgkooWkoOoknOWokfm_OoNg]h2ooooo`0:onO_moo_inOokoOgooooooo_inOoooooooO_iooo
ooooinogonogm`;oknOW00CoooooonoWiooWkoOomoO_0_o_inL00ooNg]koknOWonogm`02onoWi`03
omkNg_o>e/koknOW00_ooooo00OoCTi>oi6ATOoQhN7o7QhNoi:BT_ni^KWo20P800;ooooo00[oEUIF
oiVIVOmCDe?o/;2`oooooooQhN7o7QhNoi:BT_ni^KWo20P8ooooooonooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo02cooooo0_o_inL04?o>e]koooooonogmon][JGo_Kfm
olk>c_n<S8co[JfUokFmc_o_inOoW9bLojf]YOn<S8coQ9BDoiB<S?n]]KD2ojf]Y@09olk>c_o_inOo
inogomkNg_nLW:Goc/k>ojfe]On][JGoW9bL00;oc/k>00SoW9bLomkNg_n]YICoc/kNojf]YOnLW:Go
Q9BDolkFcP;oknOW00CokoOgolk>g_o>c/kokoOg2oooool03Om>CTkoTI6Aooooooolo?coclo?ohf=
SOl820Soooooono_kol?3`ool?3`okRh^?m:BTX00_ooool01?olo?coclo?ohf=SOl820Soooooooko
oooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0;Oooool01OoNg]koc]K>
ooooooo_inOoc/k>00?og]kN00[oc]KNonoWioo_inOog]kNolkFg_o>c/koe/kFojfe]OoNg/koc]KN
0_o>c/h01oooooooknOWojfe]On<S8co_Kfmojf]YOoNg]h00_o>c/h02OoNg]koc/k>omkNg_o>c/ko
g]kNomK>e_o>e/koc/k>omKFi`03onoWi`03omkNc_o>e]koknOW00_ooooo01?oCTi>oi6ATOoooooo
c<c<oogmoOo7alOo9bLWoooooonGUiOoF5QHooooooomoOgo8R8Ron;Rh_ooooooc<c<oogmoOo7alOo
9bLW0?ooooooo_ooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0]oooo
o`04onOWg_o>e]koooooonogm`?ooooo00GoknOWoooooooWkoOoooooooO_i`03ooooo`08onoWioo_
moOoknOWooooooo_inOoooooomkNg_o>c/h2omkNgP0:onoWioooooooinogooooooo_inOoinogooO_
iooWkoOoknOWonO_m`CoknOW00Goe]KWonoWioo>e]kog/k6onogm`0;ooooo`0:odi>C_nATI7ooooo
ofQXJ?lj>S[o<S8bojJVY_ooooooH61Pokfm_@;ooooo00OoT92@oibLW?ooooooJ6QXocXj>_lb<S;o
YZJV0?ooooooooooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0]oooo
o`05omKFioo>c/koooooonoWion][JD00_n]]KD02Onm_Kgo[KFeomkNg_nm_Kgo[KFeonOWg_n][JGo
]Kg>ojf]Y@02olk>cP07okF][Onm_Kgo[KFeoibLW?n<S8co_Kf]olk>gP02ojfe]@;o[JfU00Koc/kN
okfm_On][JGo_Kfmolk>c_n][JD2ojfe]@;o[JfU00Goc/k>onoWioo>e/koc/k>onO_m`0;ooooo`03
odi>C_nATI7ooooo0?ooooooooooool?ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi
^OoShn?ooooo02cooooo00SomoO_onOWg_oNg]koooooonoWion]]KGo[JfUolk>cP;o_Kfm00Cog]kN
olk>c_n][JGoe]KW0_n][JD01_o>c/kog]kNokfm_OnLW9coc/k>olJm_@;o_Kfm00[oc/k>omkNg_n]
YICo[KFeolk>c_nm_Kgoc/k>ojf]YOne_Lkoc/k>0_nm_Kd01_n][JGoc/k>okfm_On][JGo_KfmonoW
i`;oc/k>00?omoO_ooooooooool02Oooool00omGEeOoUYJFooooo`3ooooooooooooo3oooool00ooV
i^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0]ooooo`04omKFioo>e/koooooonog
m`?oknOW00Kog]kNooooooooooooknOWooooooo_moL2onoWi`06ooooooogmnoomoO_omKFioogknOo
inog0_ogmnl00ooWkoOokoOgonoWi`02onoWi`06onO_moo_inOog]kNonO_moo_inOoc]KN0oo_inL0
1ooFe^Oog]kNomkNg_oWimkoc/k>olkFg_o_inL0oooooooooooooagooooo00?ok^k^on?Shoni^KT0
0_o^k^h000?ooooo00?o^KVion?Shoooool0;?ooool01oogmnooinONomK>e_ooooooknOWolk>c_n]
]KD00_nLW9`02_n][JGo_KfmomkNg_o>c/ko_Kfmomk>a_o>e]ko_KfmokFmc_nm_Kd2olk>cP0?okfm
_One_Lkoc/k>olk6]Oo>e]ko_Kfmojfe]Oo>c]kog]k>okfm_On]]KGo_Kfmojfe]Onm_Kgoc/k>00;o
_Kfm00Coc/k>ojf]YOnm_Kgoc/kN0_o>c/kooooooooooooo7oooool00ooShn?o^KViooooo`01oooo
o`000oo^k^h00oni^KWohn?Sooooo`0]ooooo`07omKFioo>e/koooooonoWionLW9co_Kfmojf]Y@02
okfm_@05ojfe]Oo>c/ko_Kfmokfm_Oo>e]h00_n]]KD01_n][JGo[KFeojf]YOn]]KGo_Kfmojf]Y@;o
_Kfm00Sog]kNoib]_On][JGoc/JeolkFg_n4U9Co[JfUojfe]@;o[JfU00[oc/k>okfm_OnLW9co_Kfm
ohb<S?nLW9cog]kNolk>c_oNc/Koinogoooooooooooooagooooo00?ok^k^on?Shoni^KT00_o^k^h0
00?oi^KV00?o^KVion?Shoooool0;?ooool01_ogmnooinONolk>g_ogmnooknOWomkNgP;oinog00Ko
knOWonogmoo_inOoinogonoWioo_moL2onoWi`04olk>g_o_inOomoO_olkFgP;og]kN2oo_inL01_oN
g]koknOWomkNg_oNg]koc/k>omK>eP;oc/k>00Coc]KNolk>c_o>c/komnoWoooooooooooooagooooo
00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0;Oooool01?oFe^Ooc/k>oooo
oooFe^L5olk>cP04omkNg_o>c/koc/k>onONgPCoc/k>00coc/kNolk>c_o>c/koQ9BDokfm_Oo>c/ko
c]KNolk>c_nm_Kgoc/k>okfm_Oo>c]h2olk>cP07okfm_Oo>c/ko_Kfmolk>c_nm_Kgo]Jf]ojfe]@02
okfm_@04omk>a_nm_Kgoc/k>onogmooooooooooooolMooooo`03onk^k_oShn?o^KVi00;ok^k^0003
ooooo`03okVi^OoShn?ooooo02gooooo00Cog]kNolk>c_ooooooc]KN0on][JD03OnLW:GoS8b<olk>
c_nLW9co[JfUokG6e_nm_KgoQ9BDojfUU?n][JGoc/k>ojfe]Oo>c/h00_n][JD01?nLW9co_Kfmolk>
c_n][JD2ohb<S00@olJm_OnLW9coS8b<oibLW?nLW:GoS8b<okfm_On<S8coW9bLoiB<S?nLW9coS8b<
okFmc_nm_Kgog]k>onoWiooooooooooooolNooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03
okVi^OoShn?ooooo02cooooo00CokoOgonoWioo>c/kokoOg0oo_inL01OoNg]koknOWolk>c_o>e/ko
g]kN00GoknOW00?oinONonoWioo_inL00_o_inL01_oFe^Oog]kNolkFc_o_inOoinONomKFi`?oc/k>
00So_Kf]olk>g_o>c/kog/k6okFmc_nm_Kgoc/k>okFmcP?o_Kfm00?o_Kf]olkFg_ooool0oooooooo
oooooagooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0;?ooool01?og
knOoe]KWomkNc_ooool4omkNgP07olk>c_oNg]koc/kNomkNg_oNg/kog]kNolkFgP02omkNgP03olk>
g_oNg]kog]kN00;og]kN00[oc/k>onoWioo>c]kog]k>okFmc_oNc/Ko[JfUoibLYOne_Lko]Jf]0_n]
[JD00on]]KGo[JfUojf]Y@02ojf]Y@06oibLYOn][JGo[KFeokfm_Oo_inOokoOgoooooooooooooago
oooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0;Oooool01?o_inOoc/k>
onogmoo>c/h2ojf]Y@03oibLYOnLW9coS8b<00;o[JfU00goQ9BDoibLYOn][JGo[JfUoibLYOn][JGo
W9bUolk6]OnLW:GoS8b<oibLW?o>c/koS8b<00?oW9bL00Co[JfUohb<S?mkNg_oNg]k0_m[Jf/02_nL
W9coJf][of][JomkNg_oS8b<oeYJF_nLW9co[JfUolk>g_o_inOooooooooooooo7_ooool00oo^k^ko
hn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0/ooooo`06onO_mooWimkoc/k>ooooooo>
c/koc]KN0ooNg]h02_nm_Kgog]kNomkNg_oNg]ko_KfmomkNg_o>c/koc]K>omkNg_oWimh2olk>cP03
okfm_Oo>c/kog]kN00;og]kN00coc/k>olkFg_o>c/ko_Kfmojf]YOnLW9coS8b<og]kNon<S8coNg]k
og^4Q?mkNg/2ohb<S003oibLW?nm_KgoknOW0?oooooooooooolPooooo`03on?Shoni^KWooooo007o
oooo0003onk^kP03okVi^OoShn?ooooo02gooooo00CoinONolk>c_o_moOoknOW1?oNg]h2okfm_@08
onOWg_oNg]kog]kNomkNg_oWimkoe]KWomkNg_oFe^L6omkNgP08olk>g_oNg]kog/k6olk>c_nm_Kgo
W9bLohb<S?m[Lg<4of][J`05og]kNomkQ8CoW9bLokfm_OoNg]h0ooooooooooooob3ooooo00?ok^k^
on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0;?ooool02_ogmnooe]KWolkFc_oWkoOo
knOWohb<S?n][JGoc/k>ohBDU?ne[Jd5oibLW005olk>c_n]YICo[JfUohb<S?nLW:D00_n][JD00onL
W9co[JfUohb<S002oibLW003og^4Q?nm_KgoNg]k00?oJf][00?oS8b<og]kNon<S8`00_n][JD2olk>
cP03omkNg_oooooooooo0?oooooooooooolOooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo02gooooo00Oog]kNolk>c_o_moOoknOWolk>c_o>e/koinON00;og]kN00Woc]KN
olk>c_o>c/koc]KNolk>c_oNg]koc/k>olk>g_oNg/h00oo>c/h00on]]KGoc/k>olk>cP02olk>cP05
olJm_One_Lko[JfUohb<S?nm_Kd01?ooool01?o_inOog]kNolk>c_oNg]kooooooooooooo8_ooool0
0oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0]ooooo`07omkNg_o>c/koknOW
onoWiooNg]koe]KWonoWi`02omkNgP0:onONg_o_inOoknOWonoWiooNg]koc/kNonOWg_oNg]koe]KW
onoWi`Kog]kN0oo>c/h00on]]KGoU8b<olk>cP03ooooo`;og]kN00?oc/k>omkNg_ooool0oooooooo
ooooob?ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0;?ooool06?oW
koOoinONolk>c_o_moOoc/Jeolj<HooNc[goknOWomjm[Oo6Nd[oc/J]olkFg_n][JGoQ9BDojfe]OnL
W9coc/k>ojfe]On]YICoQ9BDojfe]OnLU8coc/k>oibLY@CoW9bL00[o[JfUog^4Q?m[Jf_o_Kfmoooo
ooo_moOoinONomkNg_o>c/kog]kNooooooooooooobCooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
i^KV00?o^KVion?Shoooool0;Oooool06?o>e]koc/k>onogmoo_inOoaZfLomkNc_o_inOoaZfLolj<
Hoo_inOoe]KWokfm[Oo>c/ko[KFeolk>c_oNg]koc/JeokFmc_o6_Kgoc/JeokFmc_o>a[Go[JfUojfe
]@;o_Kfm00[oW9bLojf]YOn<S8coNhB4olk>c_ooooooknOWolkFg_o>c/kog]kNooooooooooooobGo
oooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0;?ooool03Oo_moOoknOW
olk>c_o_inOoinONolkFc_o>YHCoc/JeolIkB_o>_JGoknOWonOWg_o>e]h00_o_inL00ooWimkog]kN
omkNgP04omkNgP03olk>g_o>c/kog]kN00;og]kN00Woa[fmokFmc_n][JGoS8b<olk>g_o_inOog]kN
olk>c_oNg]h0ooooooooooooobKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?S
hoooool0;Oooool02OoNg]koc/k>ooOgkooFe^OoknOWomJeW?o>a[GoaW]:olkFgP02onoWi`03onOW
g_oFe^OoinON00Gog]kN00Coc/kNomkNg_oNg/kog]kN1?o>c/h2ojf]Y@05ohb<S?oNc/Kog]kNolk>
c_oNg]h0ooooooooooooobSooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shooo
ool0;?ooool00ooWkoOoinONolk>cP03onoWi`03olk6]Oo>S6?ocYak00;oknOW00?oinONomkNg_oN
g]h00ooNg]h02?o>e]kog]kNomkNg_oNg]kog]k>omK>e_o>c/kog]kN0_o>c/h2okfm_@;oW9bL00?o
c]KNolk>c_oNg]h0ooooooooooooobSooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVi
on?Shoooool0;Oooool03?oNg]koc/k>onoWioo_inOoc]KNonOWg_neLe[oc/J]onoWiooWimkoe]KW
onOWgPGog]kN00Kog]k>olk>g_oNg/koc/kNomkNc_o>c]h3olk>cP06okfm_On]]KGoW9bLokfm_Oo>
c/kog]kNooooooooooooobWooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shooo
ool0;?ooool01Oo_moOoknOWolk>c_ogmnooc]KN00;oknOW00Coc/JeonOWg_oWimkoe]KW1OoNg]h0
1oo>c]kog]kNolkFg_oNg/koc/kNomkNc_o>e]h00oo>c/h01_nm_Kgo[KFeojf]YOn]]KGoc/JeomkN
g_oooooooooooolZooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo02go
oooo00_oknOWolkFg_o_inOoinONolkFg_o_inOoinONomKFiooWimkog]kNonOWgP03omkNgP07omkN
c_oNg]kog]k>omK>e_oNg]koc/k>olkFgP02olk>cP07olk6]One_Lko_Kfmokfm[On][JGo[KFeomKF
i`3ooooooooooooo;?ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0]
ooooo`0@onogmoo_inOomoO_omKFioo_inOoinONomKFiooWimkoc]KNonOWg_o>e]kog]kNolkFg_oN
g]koc]KNomkNgP;oc]KN00?oc]K>olkFg_o>c/h00oo>c/h01Onm_Kgo[KFeojfe]Oo>c/koknOW0?oo
ooooooooool/ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo02kooooo
3_o_inL02?oNg]koknOWonoWioo_inOog]kNonoWiooNg]koknOW0_oNg]h2onoWioooooooooooool^
ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfoooo
o`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03
on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^
k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onKVi_oS
hn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oooooooooooomfooooo`03onk^k_oShn?o
^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oooooooooooomgooooo`03on?Shoni^KWooooo
007ooooo0003onk^kP03okVi^OoShn?ooooo03Cooooo00?okoOgooooooo_moL00_ooool00oo_moOo
ooooooooo`02ooooo`03onogmoooooookoOg00;ooooo00?okoOgooooooooool0oooooooooooooc3o
oooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0;_ooool00oo_inOomoO_
onoWi`0KonoWi`04omKFioo_inOoknOWomKFi`KoknOW00?okoOgooooooooool0oooooooooooooago
oooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0;Oooool03_ogmnoog]kN
olk>g_nm_Kgo]Kg>olk6]One_Lkoc/JeokFmc_o>a[Go_KfmokFmc_o>a[Go]Kg>0onm_Kd01oo>c/ko
_KfmolJm_One_Lkoc/JeolJm_One_Lh00_nm_Kd01Oo6_Kgo]Kg>okfm_Oo6_Kgo]Kg>00?o_Kfm00Wo
c/k>okfm_Onm_Kgoa[fmokFmc_nm_Kgoc/k>olkFg_o_inL0oooooooooooooakooooo00?ok^k^on?S
honi^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0;Oooool01OoNg]koc/k>ojf]YOn][JGoW9bU
017oW9bL00?oW9bUojfUU?nLW:D00_nLW9`01on]YICoW9bUoibLW?nLW9co[JfUoibLW?nLW:D00_nL
W9`00on][JGoW9bLoibLW002ojf]Y@03olk>c_oNg]kokoOg0?oooooooooooolNooooo`03on?Shoni
^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo02gooooo00?oknOWomkNg_ooool09_ooool2
omkNgP03onoWiooooooooooo0?oooooooooooolKooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo02gooooo00?og]kNolkFc_ooool04oooool00oogmnooooooooooo`02oooo
o`05onO_moooooooooooooooooo_inL00_ooool00oo_inOoooooonO_m`02ooooo`04onogmooooooo
inONolk>c_oooooooooooolNooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?o
oooo02cooooo00?oinogonOWg_o>e]h00_ooool00oo_moOoooooooooo`0;ooooo`03onogmooooooo
oooo00?ooooo00?oinogooooooooool02_ooool01oo_inOooooooooooooooooog]kNolkFg_o_inL0
oooooooooooooagooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0;Ooo
ool00ooNg]kog/k6ooooo`0Aooooo`03onogmooooooooooo00;ooooo00?omnoWooooooooool00_oo
ool01?oWkoOooooooooooooWkoL5ooooo`05onoWioooooooknOWolk>c_o_moL0oooooooooooooako
oooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0;?ooool00oogmnooimkN
olkFgP0>ooooo`03onogmooooooooooo00Cooooo00?omoO_ooooooooool02_ooool00oo_moOooooo
onO_m`02ooooo`03omkNg_o>e/koknOW0?oooooooooooolMooooo`03onk^k_oShn?o^KVi00;ok^k^
0003onKViP03okVi^OoShn?ooooo02gooooo00?og]kNolk>c_ooool00oooool02_o_inOoc/k>onoW
ioo_moOoooooonO_moooooooknOWolk>c_o_inL2ooooo`03onogmooooooog]kN00Gog]kN00Koe/kF
ohAkLonLJf?o[G]SoljmYOnDS8`2ojekH`0:okfm_Oo>a[Gog]k>olk6]Onm_JgoinogoooooooNg]ko
c/k>onogmooooooooooooolMooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?o
oooo02gooooo00Coe]KWomkNc_ooooooknOW0_nm_Kd01Oo>c/koW9bLojfe]Oo>c/kokoOg00;o[JfU
0_nLW9`07On<S8co_Kfmojf]YOo_inOoooooonOWg_o_inOomoO_onoWioogknOoinONomk>a_mBBT;o
Na08oh@H4?n]Nf?oU48aog<H4?nL<B7ocZF4omkNc_o_ilkog]k>olk6]Oo_inOoooooomkNg_o>e]ko
knOW0?oooooooooooolMooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo
02cooooo00?omoO_onOWg_o>e]h00_ooool00ooFc]Kog]kNonoWi`02omkNgP07onoWioooooooe]KW
onoWioo>e/kog]kNokfm_@02omkNgP;ooooo01Soc/k>ohBDU?nLW:GoW9bLog^4Q?m[Lg?oFV][odXH
6?mc613oW34Qoh@i<OmS61SoQ24HojEcF_n]Nf?oW9bUoib4NonDS6?o[KFeooOgkoooooooknOWolk>
c_o_moOooooooooooooo7_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Soooo
o`0]ooooo`03omKFiooFc]Kooooo00Oooooo00?okoOgooooooooool00_ooool00ooWkoOooooooooo
o`02ooooo`0>omk>a_n<S8coS8b<of][Jon<S8co[JFDof][JomB20SoJc4Yoi`a8On]Nf?oQ1P@oh@Q
6?m[<BT2odYBFP08oeYJF_mBBT;oJg=conoWiooooooog]kNolkFg_o_inOooooooooooooo7Oooool0
0oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0]ooooo`05omkNg_o>e/kooooo
ooO_ion]]KD00_nm_Kd01one_Lko_Kf]onoWioo>c/ko[JfUonoWion]]KD00_nm_Kd04ooNg]ko]Kg>
olk6]Oooooooc]KNokfm_On][JGoW9B<ojfUU?o>a[GoNg=SoaP@4?mB20So[G]Soha[B_n48ASoNc4Y
oe8i<OlY:BT00oli>C401_mJFT;oknOWoooooooWimkoc/k>onogmooooooooooooolMooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo02cooooo02gokoOgonOWg_o>c/kooooo
onogmonm_Kgo[JfUolk>g_o>a[Goc/k>onoWioo>c/ko_KfmonoWion][JGo_Kfmolk>c_oNg]koc/k>
ojfe]Ooooooog]k>okfm[On][JGoW9bLojfLQ?o>_JGoLf]Sob4H4?mBBT;oHd8iodXa:OmB>C7oDSTY
og]kNomkQ8CoFUYJodYB>Om:BS7oBU8ionoWioooooooe]KWolkFc_o_inL0oooooooooooooagooooo
00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0;Oooool02?oNg]koc]KNoooo
ooooooookoOgooooooo_inOoinog1Oooool00oo_moOoooooooooo`02ooooo`09onoWioooooooc/kN
okfm[Onm_KgoU8b<og=cF_n]W8CoLf]S00;oDSTa00oo@RTQoe8i<OmJ@SWoDSTaohb<Lon<S8coNg]k
of]SD_m[Jd[oFV=JonoWioooooooinONolk>g_ogmnl0oooooooooooooakooooo00?ohn?SokVi^Ooo
ool00Oooool000?ok^k^00?o^KVion?Shoooool0;?ooool2onoWi`03omK>e_ooooooknOW00;oc/k>
00WoW9bUojfUU?ne_Lkoc/JeomkNg_o>e]koc/k>omkNg_o>e]h00_o>c/h03?o6_Kgoc]KNooooooo>
a[GoS8b<ohb<LomJFT;oS8b<olk6]OmcJf?oDTY2oc4H40;oDSTa00CoLeYBoe8i<OmJFT;oNg=S0_m[
JdX01omJFT;oJf]:onoWioo_moOoknOWolkFc_o_inL0oooooooooooooagooooo00?ok^k^on?Shoni
^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0;Oooool01_oNg]koc]K>oooooooooooo[JfUojfe
]@Co_Kfm00Kog]kNokfm_Oo>a[Goc]KNolk6]On]]KD2okfm_@0Aojf]YOoooooo[KFeodY:B_mBBT;o
Jf=Bohb<LonLQ7_oFUYJoe8i:Om2:B7oJdY2oeYJ@_mcFU;oHeY:obTY6?li>AP00_mJDRT01_li>ASo
Nf=:onoWiooooooog]kNolk>c_oooooooooooolNooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^
kP03okVi^OoShn?ooooo02cooooo00KokoOgonOWg_o>c/koooooonogmoo_inL9ooooo`0NonoWiooW
imkoooooonogmoo_inOoooooojf]YOlY<BWo:BTHodY::On]YICoa[fmocTi<Om2:B7oDSTaoe9:@_mk
FT[oJf=BoeY2>OlY:ASoBS4YodY::OmcLe[oBS4Yoe9S@_oFe^OoooooonOWg_o>e]koknOWoooooooo
oooooagooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0;Oooool02_oN
g]koc]KNooooooo_inOoc]KNomkNg_o>c/kog]kNolk>c_o_inL2olkFgP0PonoWiooNg]koc]KNolk>
c_oFc]KoknOWolkFg_o_moOo[JFDo`000?lY:ASo>B4HoibDS?o>aZgoNg=SobTY6?m2:B7o[G]SoiA[
F_m[<BWo>CTHobTY6?la>B7oBTXYodY:<Oli>ASoBTXaonoWioo_moOoknOWolk>c_o_moOooooooooo
oooo7_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0/ooooo`0]onog
moo_inOoc/k>oooooooNg]ko_Kfmojf]YOn]]KGo[JfUoibLW?nea]Ko[JfUokfm[Oo>e]koc/k>oibL
YOn][JGo_KfmolkFc_nm_KgoknOWojf]YOl@003o:BTHoc4i8Onm_Jgog/jmohb<LolY:ASoLeYBojek
Hoo6[IcoQ7]coc4i8OlH413o>CTHodYB>Om:FT;o:BTYocU2<Oo_inOoooooomKFioo>e/koknOW0?oo
oooooooooolMooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo02cooooo
0_o_inL00oo>e/koooooooooo`03onogm`04ooOgkoo>e]koinONonoWi`KokoOg0oooool06?n][JGo
:BTHobTY6?lY:ASoS8acoljmYOm:FT;o:BTHocTQ6?mkHd[oS6]:oeYJ@_li@S7o:C4YobTQ2?m:DSWo
Q9BDog^4Q?mJHe[oknOWonogmooWimkoc/kNooOgkooooooooooooolMooooo`03onKVi_oShn?o^KVi
00;oi^KV0003onk^kP03okVi^OoShn?ooooo02gooooo00?og]kNolk>g_ooool01?o_inL01?oFe^Oo
knOWonOWg_oFe^L6onoWi`05omKFioogknOoooooojf]YOla>B400_m:FT802OnDS6?o_Kf]ojfe]Om[
Lg?o4108ocTQ6?la613o610@oeY[J`02oeYSFP09of=cS?n]]KGoW;GNojFec_o_inOokoOgomkNg_o>
e/koknOW0?oooooooooooolMooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?o
oooo02gooooo00Kog]kNomkNc_ooooooc]KNokfm_One[Jd2ojf]Y@0Eohb<S?ne_Lko_Kf]oibLYOn]
[JGo[KFeokfm_On][JGo[KFeojf]YOoWkoOoooooolk>c_mSLhcoNhB4of]SD_mkNg_o_Kf]ojfUU?n<
S8co:BTY00;o000000goBU9Joibeg_nU]LkoW;GNojFmg_nL]NOo]LKFoibeg_o_inOomoO_omkNg_o>
c/kokoOg0?oooooooooooolNooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?o
oooo02gooooo00Gog]kNolkFg_ooooooknOWomkNgP02onogm`03onoWioo>c/kokoOg00;oknOW00?o
c/k>onoWioo>e]h00_o_inL01?oWkoOomnoWooOgkooFe^L2oib]_@06oibLYOn][JGo_KfmokFmc_ne
a]KoYKG>0_mSLh`6oibegP07oibeionU]LkoknOWoooooooNg]koc]KNonoWi`0@ooooo`03oogmoOn]
[Jgod=3@0?ooooooooooool:ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo02cooooo0_o_inL01Oo>e/koooooonoWioo_inOokoOg00;oknOW00?o[KFeonoWioo_moL01Oo_
inL01OoWkoOomnoWonO_moooooooc]KN00;o[KgW00?o[LKgoib]_Oo>aZd00onL]NL01On]a^ooW;GW
oibeg_nL]MkoW;GW00GoW;GN00Goc]KNonogmooNg]koc/k>onogm`0=ooooo`06onk^k_oCdm?oVIVI
obl_;om<C4co/[:b0_ooool00oobl_;oooooooooo`07ooooo`03oogmoOoZj^[ooooo01gooooo00?o
o_knonWYjOono_h0oooooooJooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?o
oooo02gooooo00SoinONolk>g_ooooooc]KNoibLW?o>a[Go]Kg>ojfe]@;o[JfU00?oW9bUojf]YOnL
W9`00_o>c/h04?n]]KGo[JfUohb<S?o>c/kooooookG6e_nL[MkoW;GNoib]g_nL[Kgo[JfUoib]g_nL
[LkoW;GNoib]g_nL[Lh2oib]gP06oib]c_nL[MkoW:gNoib]c_nL[MkoW:g>0_o_inL00ooNg]koc]K>
onoWi`0;ooooo`06onSXj?m6ATKo;bl_odY:B_lA4A7oXZ:R0oooool01On0P83o6ATIobXZ:_n5QHGo
?3`l00;ooooo01?o3Ph>on;Rh_oooooo[Zj^oa0@4?l/;2co8b<SonSXj?oooooo3Ph>on;Rh_oooooo
IfMWodA4A?oinOWoooooon[Zj_l0003om?Cd00?ooooo00So3Ph>on;Rh_oooooo3Ph>on;Rh_oooooo
XZ:Rode=C@;ooooo00So=SHfokVi^Ooooooo/K6aoaLG5oli>CWo=3@dokVi^OoooooofOooool00oo^
k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0/ooooo`08onogmooNg]kog]k>oooo
ooo_inOoc]KNonoWioogmnl3onoWi`05olkFg_o_inOoinONomKFioo_inL00ooNg]h01Oo_inOokoOg
onoWioo>e]kog]kN00;oc]KN00Cog/k6omKFiooNg]koe]KW0_o>e]h00ooNg]koc]KNolkFgP04olkF
gP05okG6e_o_inOomoO_olkFg_o>c/h03?ooool01om1@D7oLG5aooooooooooooi>CToadM7Onc/k<0
0_ooool00olA4A7of=SHoo?cl`02oc`l?0;ooooo00Ko3Ph>on;Rh_ono_ko7AdMojVYZOooool2oogm
o@06ooooool>3Pkoh^;RogalO?le=CGolo?c0_ooool00ooZj^[o0000ooCdm003ooooo`08o`h>3_oR
h^;oooooo`h>3_oRh^;ooooooj:RX_m=CDd2ooooo`05ocHf=_ni^KWoi^KVo`/;2oo7alL0oooooooM
ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo02gooooo0_oNg]h03_oo
ooooknOWooooooooooooe]KWolk>c_o_inOomoO_ooooooogmnooinogonoWionm_Kgog]kN0_ooool0
2_oWkoOoknOWonogmoooooooknOWooooooogknOoooooonO_moo_moL2onoWi`04ooooooo_inOoinog
ooOgk`;oknOW00?og]kNonoWioo_moL00_o_inL00ooNg]koc]K>onoWi`0:ooooo`03ol_;bol0003o
emOG00?ooooo00WoI6AToe=CDoooooooo_kno`000?obl_;ooooookBd]?ll?3`00_ooool01Ol>3Pko
h^;Rol71`OlF5QKooOgm00Cooooo00Co3Ph>og=cLolW9bOojn_[0oooool00ooZj^[o0000ooCdm003
ooooo`08o`h>3_oRh^;oooooo`h>3_oRh^;ooooooj:RX_m=CDd2ooooo`04ocHf=_ni^KWoZj^[ob4Q
8@?o_kno00?ojNWYooooooooool0oooooooGooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03
okVi^OoShn?ooooo02cooooo0_o_inL04?o>e]koooooonogmon][JGo_Kfmolk>c_n<S8co[JfUokFm
c_o_inOoW9bLojf]YOn<S8coQ9BDoiB<S?n]]KD2ojf]Y@09olk>c_o_inOoinogomkNg_nLW:Goc/k>
ojfe]On][JGoW9bL00;oc/k>00SoW9bLomkNg_n]YICoc/kNojf]YOnLW:GoQ9BDolkFcP;oknOW00Co
koOgolk>g_o>c/kokoOg2_ooool00onQXJ7o7AdMooooo`03ooooo`09ojVYZOlK6a_oooooookno_l0
003ol_;boooooond];Co?3`l00;ooooo00Go3Ph>on;Rh_o9bLWo3Ph>oo[jnP04ooooo`04o`h>3_m_
KfooBd];oogmo@?ooooo00?oj^[Zo`000?odm?@00oooool02?l>3Pkoh^;Rooooool>3PkohN7Qoooo
oonRXZ;oC4a<0_ooool01?lf=SKo^KViolO7aolG5aL2ogAdM003oa/K6oo1`L7ooooo0?oooooof?oo
ool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0]ooooo`05omkNg_o>e/ko
ooooonoWioo>c/h00ooNg]h02_o>e]koknOWonoWiooNg]koc]KNolk>c_oFc]Ko[KFeomkNc_o>e]h2
olk>cP07ooooooo_inOo[KFeohb<S?nm_Kgo[JfUomkNgP02olk>cP09omkNg_o>c/kog]kNolk>c_oN
g]koe/kFolkFc_o>c/koe]KW00?oknOW00?og]k>olkFg_o_inL02_ooool00onRXZ;o6QXJooooo`03
ooooo`09ojNWYolF5QKoooooookno_l0003ol_;boooooond];Co?3`l00;ooooo00go3Ph>on;Rh_oo
oooo8R8Rohj>S_okno_on?Shookno_oooooo3Ph>on;Rh_m/K6coKFe]00?ooooo00?oj^[Zo`000?od
m?@00oooool04_l>3Pkoh^;Rooooool>3PkoF5QHono_kommOGgo4a<CojFUYOoemOGo6QXJom7AdOon
o_ko8R8Ron3Ph?o_knoo7AdMoo[jn_oooooofOooool00oo^k^kohn?SokVi^@02onk^kP000oooool0
0oni^KWohn?Sooooo`0]ooooo`04onOWg_o>e]koooooonogm`?ooooo00GoknOWoooooooWkoOooooo
ooO_i`03ooooo`08onoWioo_moOoknOWooooooo_inOoooooomkNg_o>c/h2omkNgP0:onoWiooooooo
inogooooooo_inOoinogooO_iooWkoOoknOWonO_m`CoknOW00Goe]KWonoWioo>e]kog/k6onogm`0:
ooooo`03olk>c_l0003oe=CD00?ooooo00WoHF5Qod51@Oooooooo_knobXZ:_odm?Cooooool71`OmM
GEd00_ooool01Olg=cOoinOWooooooo@d=3oJVYZ00;o;2`/00OomoOgooooool>3Pkoh^;RoogmoOmM
GEgo/[:b00;ooooo00?oj^[Zo`000?odm?@00oooool02olg=cOoinOWoooooolg=cOo/[:bocTi>OlZ
:R[obl_;og]kNolQ8B7oHF5Q00;ooooo00Co^k^koc4a<Olo?coo[jn_oooooooKooooo`03on?Shoni
^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo02gooooo00Goe]KWolk>c_ooooooknOWojf]
Y@02ojfe]@09okfm_On]]KGog]kNokfm_On]]KGoinONojf]YOne_Lko[JfU00;oc/k>00Oo]Jf]okfm
_On]]KGoW9bLohb<S?nm_Jgoc/kN00;o[KFe0_n][JD01_o>c]ko_Kfmojf]YOnm_Kgoc/k>ojf]Y@;o
[KFe0_n][JD01Oo>c/koknOWolkFc_o>c/koinog00_ooooo00OoAdM7ofQXJ?ono_koooooomkNg_lF
5QKo^[Zj00Wooooo00?oiNGUooclo?ooool01_ooool00ol>3Pkoh^;Rooooo`04ooooo`03on[Zj_l0
003om?Cd00?ooooo00?oiNGUooclo?ooool0oooooooXooooo`03onk^k_oShn?o^KVi00;ok^k^0003
onKViP03okVi^OoShn?ooooo02cooooo00SomoO_onOWg_oNg]koooooonoWion]]KGo[JfUolk>cP;o
_Kfm00Cog]kNolk>c_n][JGoe]KW0_n][JD01_o>c/kog]kNokfm_OnLW9coc/k>olJm_@;o_Kfm00[o
c/k>omkNg_n]YICo[KFeolk>c_nm_Kgoc/k>ojf]YOne_Lkoc/k>0_nm_Kd01_n][JGoc/k>okfm_On]
[JGo_KfmonoWi`;oc/k>00?omoO_ooooooooool02Oooool01_o]kNgoEEEEobLW9oln?Sko8R8RojBT
Y0[ooooo00?o6a/Kon?Shoooool01_ooool00ol>3Pkoh^;Rooooo`02ooooo`0:oc`l??lX:2So9BDU
o``<3?lV9RKo:2PXodE5AOoooooo6a/Kon?ShooooooojOooool00ooVi^Kohn?SokVi^@02onKViP00
0oo^k^h00oni^KWohn?Sooooo`0]ooooo`04omKFioo>e/koooooonogm`?oknOW00Kog]kNoooooooo
ooooknOWooooooo_moL2onoWi`06ooooooogmnoomoO_omKFioogknOoinog0_ogmnl00ooWkoOokoOg
onoWi`02onoWi`06onO_moo_inOog]kNonO_moo_inOoc]KN0oo_inL01ooFe^Oog]kNomkNg_oWimko
c/k>olkFg_o_inL03Oooool00ooinOWoj>SXooooo`0Dooooo`03ohb<S?oalO7ooooo0?oooooomOoo
ool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0/ooooo`07ooOgkooWimko
e/kFooooooo_inOoc/k>ojfe]@02oibLW00:ojf]YOnm_Kgog]kNolk>c_nm_Kgog/k6olkFg_nm_Kgo
]Kg>okfm_@;oc/k>00oo_KfmokFmc_o>c/koc/JeolkFg_nm_Kgo[KFeolk>g_oNg/ko_Kfmojfe]Onm
_Kgo[KFeokfm_Oo>c/h00_nm_Kd01?o>c/ko[JfUokfm_Oo>c]h2olk>c_oooooooooooolOooooo`03
on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo02gooooo00Ooe]KWolkFc_oooooo
knOWoibLW?nm_Kgo[JfU00;o_Kfm00Go[KFeolk>c_nm_Kgo_KfmolkFgP02ojfe]@06ojf]YOn]]KGo
[JfUojfe]Onm_Kgo[JfU0_nm_Kd02?oNg]koW:fmojf]YOo>a[Goc]KNohBDU?n][JGo[KFe0_n][JD0
2_o>c/ko_KfmoibLW?nm_KgoS8b<oibLW?oNg]koc/k>omk>a_oWkoOooooooooooooo7Oooool00oo^
k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0/ooooo`06ooOgkooWimkoc/kNooOg
koo_inOog]kN0_oWkoL01_o_inOokoOgonoWiooWkoOoknOWonogm`;oknOW00Coc/kNonoWioogmnoo
c]KN0_oNg]h;onoWi`06omkNg_o_inOog]kNomkNg_o>c/koe/kF0_o>c/h01?o>e]koc/k>olk>c_og
knOooooooooooooo7Oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0]
ooooo`04omKFioo>c/koooooomKFi`Goc/k>00Cog]kNolk>c_o>c/koimkN1?o>c/h03?o>c]koc/k>
olk>c_n4U9Co_Kfmolk>c_o>e]koc/k>okfm_Oo>c/ko_Kfmolk>gP;oc/k>00Oo_Kfmolk>c_nm_Kgo
c/k>okfm_One[Jgo[KFe00;o_Kfm00Cog/k6okfm_Oo>c/kokoOgoooooooooooooagooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0;Oooool01?oNg]koc/k>ooooooo>e]h3
ojf]Y@0=oibLYOn<S8coc/k>oibLW?n][JGo]LKFokfm_On4U9Co[JFDojf]YOo>c/ko[KFeolk>cP02
ojf]Y@04oibLW?nm_Kgoc/k>ojf]Y@;oS8b<013oa[fmoibLW?n<S8coW9bLoibLYOn<S8co_Kfmohb<
S?nLW9coU8b<oibLW?n<S8co]Kg>okfm_OoNg/koknOWoooooooooooooakooooo00?ohn?SokVi^Ooo
ool00Oooool000?ok^k^00?o^KVion?Shoooool0;?ooool01?o_moOoknOWolk>c_o_moL3onoWi`05
omkNg_o_inOoc/k>olkFc_oNg]h01Oo_inL00ooWimkoknOWonoWi`02onoWi`06omKFiooNg]koc]K>
onoWiooWimkoe]KW0oo>c/h02?nm_Jgoc/kNolk>c_oNc/Ko]Kg>okfm_Oo>c/ko]Kg>0onm_Kd00onm
_Jgoc]KNooooo`3ooooooooooooo7Oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWo
hn?Sooooo`0/ooooo`04ooO_iooFe^Oog]k>ooooo`Cog]kN00Ooc/k>omkNg_o>c]kog]kNomkNc_oN
g]koc]KN00;og]kN00?oc/kNomkNg_oNg]h00_oNg]h02_o>c/koknOWolk>g_oNg/ko]Kg>omk>a_n]
[JGoW9bUokFmc_ne[Jd2ojf]Y@03ojfe]On][JGo[JfU00;o[JfU00KoW9bUojf]YOn]]KGo_KfmonoW
ioo_moOooooooooooooo7Oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Soooo
o`0]ooooo`04onoWioo>c/kokoOgolk>cP;o[JfU00?oW9bUoibLW?n<S8`00_n][JD03On4U9CoW9bU
ojf]YOn][JGoW9bUojf]YOnLW:Goc/JeoibLYOn<S8coW9bLolk>c_n<S8`00onLW9`01?n][JGoS8b<
og]kNomkNg/2of][J`0:oibLW?m[Jf_oJf][og]kNon<S8coFUYJoibLW?n][JGoc/kNonoWiooooooo
oooooolNooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo02cooooo00Ko
inogonOWg_o>c/koooooolk>c_o>e]h3omkNgP0:okfm_OoNg]kog]kNomkNg_nm_Kgog]kNolk>c_o>
e/kog]kNonOWgP;oc/k>00?o_Kfmolk>c_oNg]h00_oNg]h03?o>c/koc]KNolk>c_nm_Kgo[JfUoibL
W?n<S8coNg]kohb<S?mkNg_oNhB4og]kN`;oS8b<00?oW9bLokfm_Oo_inL0ooooooooooooob3ooooo
00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0;Oooool01?oWimkoc/k>onog
moo_inL4omkNgP;o_Kfm00SoinONomkNg_oNg]kog]kNonOWg_oFe^Oog]kNomKFi`Kog]kN00Soc/kN
omkNg_oNc/Koc/k>okfm_OnLW9coS8b<of]cL`CoJf][00GoNg]kog^4Q?nLW9co_KfmomkNgP3ooooo
oooooooo8?ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0/ooooo`0:
ooOgkooFe^Ooc]K>onO_moo_inOoS8b<ojf]YOo>c/koQ9BDokF][@GoW9bL00Goc/k>ojfUU?n][JGo
S8b<oibLY@02ojf]Y@03oibLW?n][JGoS8b<00;oW9bL00?oNhB4okfm_OmkNg/00om[Jf/00on<S8co
Ng]kohb<S002ojf]Y@;oc/k>00?og]kNooooooooool0oooooooooooooaoooooo00?oi^KVon?Shoni
^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0;Oooool01ooNg]koc/k>onogmoo_inOoc/k>olkF
c_oWimh00_oNg]h02Oo>e]koc/k>olk>c_o>e]koc/k>omkNg_o>c/koc/kNomkNcP03olk>cP03ojfe
]Oo>c/koc/k>00;oc/k>00Goa[fmokFmc_n][JGoS8b<okfm_@04ooooo`04onoWiooNg]koc/k>omkN
g_oooooooooooolRooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo02go
oooo00Oog]kNolk>c_o_inOoknOWomkNg_oFe^OoknOW00;og]kN00[oimkNonoWioo_inOoknOWomkN
g_o>c]koinONomkNg_oFe^OoknOW1_oNg]h3olk>cP03ojfe]OnDS8coc/k>00?ooooo0_oNg]h00oo>
c/kog]kNooooo`3ooooooooooooo8oooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWo
hn?Sooooo`0/ooooo`0HonO_mooWimkoc/k>onogmoo>a[GocXaSomk>_Oo_inOog[f]olIkB_o>aZgo
c]KNojf]YOn4U9Co[KFeoibLW?o>c/ko[KFeojfUU?n4U9Co[KFeoibDS?o>c/koW9bU1?nLW9`02_n]
[JGoNhB4of][Jonm_KgoooooonogmooWimkog]kNolk>c_oNg]kooooooooooooo9?ooool00oo^k^ko
hn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0]ooooo`0HolkFg_o>c/kokoOgonoWioo6
[Icog]k>onoWioo6[IcocXaSonoWiooFe^Oo_Kf]olk>c_n]]KGoc/k>omkNg_o>a[Go]Kg>olJm_Oo>
a[Go]Kg>olk6]On][JGo[KFe0_nm_Kd02_nLW9co[JfUohb<S?mkQ8Coc/k>ooooooo_inOoc]KNolk>
c_oNg]kooooooooooooo9Oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Soooo
o`0/ooooo`0=onogmoo_inOoc/k>onoWiooWimkoc]K>oljUQ?o>a[GoaW]:oljmYOo_inOoinONolkF
gP02onoWi`03onOWg_oNg]kog]kN00Cog]kN00?oc/kNolk>c_oNg]h00_oNg]h02Oo6_Kgo]Kg>ojf]
YOn<S8coc/kNonoWiooNg]koc/k>omkNgP3ooooooooooooo9_ooool00oo^k^kohn?SokVi^@02onk^
kP000oooool00oni^KWohn?Sooooo`0]ooooo`09omkNg_o>c/komoO_omKFioo_inOoe[FLolk6]Oo6
Nd[oc]KN00;oknOW00?oinONomKFiooWimh01OoNg]h01?o>c]kog]kNomkNc_oNg]h4olk>cP;o[JfU
00GoS8b<omk>a_oNg]koc/k>omkNgP3ooooooooooooo:?ooool00ooShn?o^KViooooo`01ooooo`00
0oo^k^h00oni^KWohn?Sooooo`0/ooooo`03onO_mooWimkoc/k>00?oknOW00?oc/Jeolj<Hoo>W7/0
0_o_inL00ooWimkog]kNomkNgP03omkNgP08olkFg_oNg]kog]kNomkNg_oNg/koe/kFolk>c_oNg]h2
olk>cP;o_Kfm0_nLW9`00oo>e]koc/k>omkNgP3ooooooooooooo:?ooool00oo^k^kohn?SokVi^@02
onk^kP000ooVi^H00oni^KWohn?Sooooo`0]ooooo`0<omkNg_o>c/koknOWonoWioo>e]koinONokEc
F_o>aZgoknOWonOWg_oFe^OoinON1OoNg]h01_oNg/koc/kNomkNc_o>c]kog]k>olk>gP?oc/k>00Ko
_Kfmojfe]OnLW9co_Kfmolk>c_oNg]kooooooooooooo:Oooool00ooVi^Kohn?SokVi^@02onKViP00
0oo^k^h00oni^KWohn?Sooooo`0/ooooo`05onogmoo_inOoc/k>ooOgkoo>e]h00_o_inL01?o>a[Go
inONonOWg_oFe^L5omkNgP07olk>g_oNg]koc]KNomkNc_o>c]kog]k>olkFgP03olk>cP06okfm_On]
]KGo[JfUojfe]Oo>a[Gog]kNooooooooooooob[ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo
00?o^KVion?Shoooool0;Oooool02oo_inOoc]KNonoWiooWimkoc]KNonoWiooWimkoe]KWonOWg_oN
g]koinON00?og]kN00Oog]k>omkNg_oNg/koe/kFomkNg_o>c/koc]KN00;oc/k>00Ooc/JeokFmc_nm
_Kgo_Kf]ojf]YOn]]KGoe]KW0?ooooooooooool/ooooo`03on?Shoni^KWooooo007ooooo0003onk^
kP03okVi^OoShn?ooooo02gooooo013okoOgonoWioogmnooe]KWonoWiooWimkoe]KWonOWg_o>e]ko
inONolkFg_oNg]koc]KNomkNg_o>e]kog]kN0_o>e]h00oo>e/koc]KNolk>cP03olk>cP05okfm_On]
]KGo[KFeolk>c_o_inL0ooooooooooooobcooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o
^KVion?Shoooool0;_ooool>onoWi`08omkNg_o_inOoknOWonoWiooNg]koknOWomkNg_o_inL2omkN
gP;oknOWooooooooooooobkooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shooo
ool0ooooooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0
ooooooooooooogOooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0oooo
ooooooooogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0oooooooo
ooooogKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0oooooooooooo
ogKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0ooooooooooooogOo
oooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool05_ooool01oo_knoo[Jf]
oeY[HonLW9coilK6onOWioogmoL01?ooool00oo_oooomoOgooooo`3oooooooooooooD_ooool00oo^
k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0Eooooo`0;omkNionDS8co41P@odY:
B_lY8B7o[G=kog]kNonDS8co[Jf]omJma_o_knl0oooooooooooooeKooooo00?oi^KVon?Shoni^KT0
0_oVi^H000?ok^k^00?o^KVion?Shoooool05?ooool04OoWknoo_KfmobTa:Onma[goooooocTH8Oo>
Q8cocW=kolI[Lon]Jf_oW6=[oha[LonLS8co_KFeomKFe_o_knoomoOg0?oooooooooooomAooooo`03
onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo01?ooooo00ComoOgomK>e_nLU9co
<CTi0_ooool03omkDU[ocW^4oomkU?o_Lhcoig^4olicNonmJg?oYF=[ojESHonDJg?oQ8B4oibLW?nm
_Kgog]kNooO_k`3oooooooooooooCoooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWo
hn?Sooooo`0Cooooo`04onOWioo6c/koS9B<oeYJFP;ooooo00CoLeYSolikU?ooS:goohbU0_ooQ9`2
ooMkS00;onmSNooWFW?oaV]coje[JonUHf?oU6]coiB4Q?nU[JGoa/k>omk_koogmoL00_ooool00oo_
ooooooooooooo`04ooooo`03onoooooooooooooo0?oooooooooooolnooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo01?ooooo00ComnOWomKFg_nU[JGoJg=[0_ooool05om[
Lf_ogXb]oonUc_ooYLkomiBmoonD]OogU:goohbUonn<W?ooQ9cokhBDomikS?oFLhCocW=koke[Lon]
Jf_oYF=SojE[JonLQ8co]IbLolk6c_oWinOooooo00?okooo2oooool00oo_oooomoOgooooo`3ooooo
oooooooo=Oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0Cooooo`0;
ooO_kooWknoo[Jf]of]SHooWg^Ooe]kNof=:D_o6LiCooiBeoonL_OooYLH00_ooYLh05?ooYLKomiBm
onnD_OooS:goohbUooMkU?ogQ9Comg^<onMkQ?o_Hg_oif]kokEcLonUJg?oW6=[oiA[LonLS8co_KFe
olkNe_oWmoOomoOg1oooool00oogmoOoooooooooo`3ooooooooooooo>?ooool00oo^k^kohn?SokVi
^@02onk^kP000oooool00oni^KWohn?Sooooo`0Eooooo`0=okfm_Om[Lf_oimkWolkFe_m[FU[oaW>D
ooM[Q?ogLhcomg>DooN4YOooU;GooibmoonUaP02oonUcP0GoonL_OooU;Goohb]oon<[OooQ9comg^D
ooMcU?o_Q9Coig^4omIcNoo>Hg?oaW=cojEcLonLJg?oW7=kojfUYOnm_KgoimkNooOgmoo_oooooooo
ooOgmoo_ool01oooool00oogmoOoooooooooo`3ooooooooooooo<_ooool00ooShn?o^KViooooo`01
ooooo`000oo^k^h00oni^KWohn?Sooooo`0Eooooo`08olK6a_n4Q8ComoOgonO_kon<Ng_ogXb]oonD
]OooS:d2ooMcU004onmcS?ogLiCoohBLoon<Y@;oojG60_oo]MH05?ooYLkoojG6ooND_Oo_S;Gomg^D
oon4W?ogLhcomg^<ooMkU?o_JhCoeW=koliSLoneLg?oYF]cojEcLonUNg_o]IbLokfm_OoWinOokooo
oooooooooooooc_ooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool05Ooo
ool01_o>e/koQ8B4onoWkooWinOoU8B4omj<[@;ooibm00CooiBeoon<[OooS:GomhBU0_ogNi@01_oN
NiCoohBLoonD[OooU;GoojG6oonUcP;ookGF00GoojG>oonUa_ooU;GoohbUooMkU003ooMcU00=ooMk
S?oWNhCoeW=kolI[LoneLg?o[F][ojEcLonUNg_o]Jf]omK>c_oWinOomoOgooooo`03onoooooooooo
oooooolcooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo01Gooooo00Ko
_LK6og]kNooFc]Koc/k>of]cJoo>Ni@3oon<[@03oonD]OooW;gooibm00;omibm0_ooS:d02OogU:go
mhBUooN4YOogU:goohb]oonD]OooYLKookGFoonUcP02oonUaP09oonL_OogU:gomhBUoon4W?ooNiCo
mg^DooN4U?oWNhcogW^400;ocV=c00WoYG=koia[LonLLg_o[HbDokfe]OoNc]Komno_ooooooo_ool0
oooooooooooooc;ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool05Ooo
ool01_o>e/koS8b<onoWkooNinOoU7=kolikW0;oohb]0_ogQ:D02?ooS:gooiBeoonL_OooW;goojG6
oonUc_ooYLKooibm0_ooU;D02OooS:GoohBLonmkYOogS:GooiBeooNL_OooYLKoojg>oonUaP02oonL
_@0Bonn<]OogQ:Gokg^Uoon4W?o_NjGomg^Donn4U?oWNhcoeW=kolIcNoneJg_oYF]coiA[LonLNg_o
[HbDolK6a_oFe]Komno_oooooooooooooc7ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o
^KVion?Shoooool05Oooool02_oFa/koS8b<onooooo_knooW9BLokFLW?ooYLkoojG6oonL_OooU;D3
oonD[@0AoonD]Oo_YLkomibmooN]a_ooYLkoojg>oonUc_ooYLKooibmoonD]OooS:goohbUonmkYOog
NiComhBUoon<[OooU;D00oooW;d05?ooU;Goohb]oon<YOooS:GomhBUooMkU?ogLiCokhBDonmkS?oW
LhcogV]koliSLoo>FV_oYF][oia[LonLLg_o]IbLomJma_oNg]kokoOg0_o_ool2ooooo`04onoooooo
ooooooooonoooooooooooooooolTooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoS
hn?ooooo01?ooooo00_okoooooooooo>c/koQ7]komkWiooFe]KoW8B<oib<U?oo]MKoojG>oon]cP02
oonUaP04oon]a_ooW;gooibmoonD[@?ooiBe00CoojG6ooN]a_oo[LkoojG>0_ooYLH2oonL_@08oonD
]Oo_NjGokg^UonN<W?oWLhcokhBDoon<YOooS:d2oonD]@;oohb]0_ooS:D01_ooQ9comg^DooN4U?og
NiCokhBDonmkS0;ocW^400[o]F]kojE[LonUJg?oU7=kojf<U?nmYJGoc/k>onONg_ooooookooo0_oo
ool00oo_ooooooooooooo`3ooooooooooooo8_ooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h0
0oni^KWohn?Sooooo`0Eooooo`0:omK>c_n4Ng_og^OWolk>c_nDS8coW7=konnUc_o_[LKomibmoon]
aP;oojg>1?oo]MH01?oo[LkoojG6oonL_OooU;D2oonL_@05ooN]a_ooYLkoojG>oon]a_ooYLH00_oo
W;d02?ooU;GoohbUoon4W?oNNiCokg><onMcS?ogNiCoohbU0oooS:d2oon<Y@;oohBL00Somg^DooN4
U?ogLiCoohBLomikU?oWNhcocW^4oke[L`;o]G=c00OoU7=kojf<U?ooc]kokoooooOgmoooooookooo
0?oooooooooooolTooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo01Go
oooo00Ooe/k>ohb<S?o_moOoinOWojfUYOnDLg_oojG600;omibm00GooiBeoonL_OooYLKoojg6oon]
cP02ooNmgP?ookGN00?ookGFoon]c_ooYLH00_ogW;d4oonD]@;ooibm0_ooU;D01?ooS:goohBLooMk
U?ogLh`3onMSQ004onmcS?ogNiCoohBLoon<[@;oohbU0oooQ9`2oomkU004oon4U?ogQ9Cokg^<onMk
Q0;oaW^<00?okjFeooooooo_ool0ooooooooooooobOooooo00?ohn?SokVi^Oooool00Oooool000?o
k^k^00?o^KVion?Shoooool05Oooool02Oo>a/koQ8B4ooOgmoo_inoo_KFeoiAcNoooc^oookgFoon]
cP02oon]aP03ooN]_OogW;gomjg600;oojg>00gookg>ooneg_ooa^OoolKWooO6ioog_NOookGFoon]
c_ooYLKomibmoonD]OogU:goohbU00;oohb]0_ooU:d01_ooU;Goohb]oon<YOooQ9coog^DonmcS0;o
if>400CogUYkonMSQ?o_Lhcomg^D1oooQ9`2oomkU004onn<W?oNNhcogW^DonoWkooooooooooooolW
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01?ooooo00Sokooooooo
oooFc/koQ7]komkWiooFe]Ko_KFeog]SL`CookGN00CoolKNooneg_oo_MKomkgF0_oo[Lh2ooNUcP05
oonme_oo]MkookGNooneg_ooa^L00_oo]Mh2ooneeP05oon]c_ogW;gomjFeooN4YOogS:D00_ogQ:D3
oon<Y@;oohBL01Coog^DooMkU?o_Lhcoif>4onMSNooNFW_ogUYconm[Q?o_Lhcomg^Doon4U?ooQ9co
ohbUoon4W?ooS:Gomg^DooMcU?oWJhcokmkNonoooooooooooooooolVooooo`03onKVi_oShn?o^KVi
00;oi^KV0003onk^kP03okVi^OoShn?ooooo01Gooooo00Koe/k>ohAkNooNinOoc]KFokfe]OmcDUX2
ooNmeP05ooNUc_oo]MKookGNooneg_ooa^L00_ooc^l00oooa^OookGNoonmeP03oon]cP05oon]a_og
_MKomkgFooNme_oo]MH00_oo]Mh2ooneeP08oonUa_ooW;gomiB]onn<W?o_Q9Comg>DonmcS?o_Nh`2
oon4U0?oog^D00Gomg><onmcS?o_JhCoieYcomiSL`02omiJL`03onMSNoo_Lhcomg><00;oohbU0_oo
Jh`00ooNc]KomoOgooOgm`3ooooooooooooo9Oooool00oo^k^kohn?SokVi^@02onk^kP000oooool0
0oni^KWohn?Sooooo`0Eooooo`09omK>c_n<S8coooooono_kooF_LKoNe9Jooo6iooo_MKoojg>00;o
ojg600Comjg6oonee_oo]MkookGN0_ooa^L00oooe^ooolk_ooo>k`02ooO6i`04oonee_oo[Lkoojg6
ooN]aP;oojg60_oo[Lh2oonUaP07oonL_OooU;GooiBeoon<YOooQ9comg>DonM[N`02onm[Q003onMk
Q?ogNhcoog^D00?oog^D00?omf^4ooMcS?o_Hg/00ooNFW<01Oo_Lhcomg>DoomkU?ooQ9comkgF00;o
koooooooooooooooobKooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0
5?ooool02?ogmoOoe/k>ohakQ?ogmoOomno_onOWiomJHe[oolkg0oooa^L01?ooa]kookGFooNmc_oo
]MH2ooNmeP;ookGN00koolKWooo>koooe^ooolkgooo>koooa^OookGNoonme_oo[LkoojG6ooNL_Oog
YKGooibmooNU]@?ooibm00OooiBeoonD[OooS:GoohBLooMkU?o_Nhcoif>400;oif=k00?oif]konmS
Noo_Lh`00_ogLh`02Oo_Lhcomg><onm[Q?o_JhComg><oomkU?ogQ:Gomg^DoonmeP3ooooooooooooo
9oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0Eooooo`08olk>c_n4
Ng_oimkNomk>e_oFa/ko@T92ooo>koog_Mh2ooo6i`;oolk_00GoolKWooo>koooa^OoolKNooNmgP02
ooNmeP;omkgN0oooa^L02?ooc^ooolKWooo6g_ooa]Koojg>oon]a_og[Kgooibm0_ogU:d01?ogU:Go
miB]oon<[OogU:d3oon<Y@09oon4W?ogNiCokg><onm[Q?oWHg_ogUYcomiSLooWHg_okf^400?omg><
0_ooQ9`01OogS:Gomg^Doonmc_ooooookooo0?oooooooooooolUooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo01Gooooo00Ooe]KFohb<S?ogknooimkNomkFe_m2>CWoolKW
00ComkgN00OoolKWooo>koooe^ooomkgooo>moooe^ooolk_00;oolKW0_og_Mh00oog_NOomkgNooNm
gP04oonegP0:oonme_oo[Lkoojg6oonL_OogYKGoohb]ooN<YOo_S9cokhBDooMkU0GoohBL0_ooNi@0
3?ogLhcokg><onM[NooNHg?ocV=comiSLooWJg_okg><oon<YOogQ:Gomg^Doonme_oooooooooooolW
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo01Gooooo00_oc/k>ohb<
S?oooooomno_onONiom:>D;oolkgooo6ioooc]komkgNooNmeP03ooNmgP03ooo6ioooe^ooomkg00;o
omkg00OoomK_ooo>moooe^oommK_ooO6ioog_MkokkgF00;omkgF0_oo_MH02_oo]MKoojg>oon]c_oo
[Lkoojg6ooNU]OooU:gomhbUooN4U?o_Q9@2onmcS00BonMcS?o_Nhcomg^DooN4U?ooQ9comhBDooMc
U?o_Lhcokf^4onMSQ?oNJg_okf^4oon<YOogS:Gomg^Doonme_ooooookoooooooooooooooobKooooo
00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool05Oooool01oo>c/koS8b<ooOg
moogknooinOWodY:B_oog_L00_ooc_L01Ooog_OoolKWooo>koooa^OoolkN00?omlKW00GoolKWoooF
koooc_OoolkgoooNm`03ooo>m`;oolKW00?omkgNonn]c_o_[Lh00_og[LH00oogW;gooibmooN]_@02
oonL_@0>ooNU]OooU;GooiB]onn<W?o_Q9Coig^<onMSQ?oWNhCoif>4onMkQ?o_LhcokhBDoon4W?og
Q9@2ooMkU005ooN4U?ooS:gomhbUoon<YOoo_Lh0ooooooooooooobOooooo00?ok^k^on?Shoni^KT0
0_o^k^h000?oi^KV00?o^KVion?Shoooool04oooool02Oo_ooooooooolk>c_mkNg_okno_omkNg_oF
e]Ko@T92ooO6i`02oooFk`07ooo>moooe^ooomK_oooNmoooc_Ooomkgooo>m`02oooFk`?ommK_017o
omK_oooNmoooe^ooomK_ooo>moooe^ooolk_ooo6ioooa]koojg>ooN]a_o_YKgokibeooND[OogW:go
miBUoon<Y@03oonD[@;oohbU00GoohBLooMkU?o_Nhcoif>4onMkQ002omi[N`08onMkQ?oWLhcomg^D
oon4W?ooS:Gokg^Uoon<YOog]LHBooooo`04oo7alOoooooon_[jooCdm0;ooooo00?ooOgmon[Zj_oo
ool01?ooool00oo`l?3og=cLoogmo@04ooooo`03ooShn?oKfm_ooOgm0?oooooooOooool00ooVi^Ko
hn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`04ooooo`03ooOgmonNWYkomoOg00kooooo
00Ooc]KFohb<S?ooooooinOWomkFe_mJFU[omkg>00;oolKW00GomlKWooOFioooc^ooomK_ooo>m`08
oooNm`;oolKW00komlKWooOFioooa^OoomK_ooo6ioooc^ooolKWooneg_oo_Lkoojg6ooN]_OooU;Go
miBUonn<W0;oihbD00?okhbLoon4W?o_S9`00oo_S9`01OooQ9ComhBDonmkS?oWLhcoig^400;ogV]k
00Goig><oon<YOogU:goohbUooN]_@08ooooo`0Ko`P82?ooooooooooohb<S?oLg=coooooofIVI_n;
Rh_ok>c/obHV9_l/;2coFUYJoc8b<_mcLg?oooooojj^[_l@413o;2`/ob<S8ooXj>SoooooonSXj?m7
AdOo<30`odY:B_lO7aooUiNG00;ooooo00GoUYJFo`d=3Om4A4Co=CDeohB4Q004ooooo`07ofYZJ_n3
Ph?ooooooooooooShn?o3@d=okRh^03ooooooo7ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo
00?o^KVion?Shoooool01?ooool00ooIfMWoMgMgomWIf@0>ooooo`07olk>c_n<S8coooooooOgmooW
inOoLf=[onnmeP02oooFk`05ooo6ioooe^oomlKWooO6iooge^l00_ooe^l7oooNm`03oooFkoooa^Oo
mkgN00;omkgF00GomkgNooNme_oo]MKookGFoonmeP02oon]cP08oon]a_ooW;gomjFeoonD[OooS:Go
khbLonN<U?oWNh`2onn4U004oon4W?ogQ9CokhbLoon4W0;omhBD0_o_Nh`01OogQ9Coohb]ooND[Ooo
S:gokjFm00Sooooo01;o20P8ooooooo5aLGo0`<3ofi^K_ooooooIVIVoh^;RonQXJ7o@d=3ooooooo;
bl_o10@4ooclo?ono_ko7AdMojVYZOooool2oogmo@03oooooom0@43oLG5a00;ooooo00[oi>CToaTI
6Onb/[;oooooonSXj?ogmoOoooooooKfm_lG5aOohN7Q0oooool01_oclo?o9RHVom?CdoooooooCDe=
oeYJF_ooooooloooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`03oooo
o`05ooclo?n;Rh_oLg=coh^;Roolo?`03Oooool01oo>c/koQ8B4ono_kooWinOog]kNohbDS?nmW;D0
1ooog_L01OoginooomK_ooOFkooge^ooomK_00Ooomkg00Ooolkgooo6ioog_MkomkgFooNmc_og]LKo
mjg600;omjfm00?oojg6ooN]_Oog[Kd00_ogYKD01_ogW:gomiBUooNDYOo_Q9Coig^<omikS0?oig^<
00WokhBDooN4U?o_Q9CokhbLonnDW?ooU:goohbUonnL[OooU;D02?ooool04Ol820SoooooofYZJ_m_
Kfoo9bLWoo_knomVIVKoRh^;on7QhOlN7QkoTY:BokVi^Ol820Sooooool71`OlF5QKooOgm00?ooooo
00?obl_;o`000?oGemL00oooool00omTI6Co?Cdmooooo`03ooooo`03ong]kOl>3Pko`/;200Cooooo
00Go^k^koc@d=?nUYJGo4Q8Bon[ZjP3ooooooo;ooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV
00?o^KVion?Shoooool00oooool01Oo5aLGoLg=cog=cLomcLg?oaLG500gooooo00Ooe]KFohb<S?o_
knoog]kNolK6a_n<NhCoW9BL00?oomK_2ooog_L00oooe^ooomkgoooFk`04oooFk`;oolk_00CoolKN
oonme_oo[Lkoojg60_ogYKD4ooNL[@CooiB]00GoohbUoon4W?o_Q9Cokg^<onMkQ002omikQ009onMk
Q?o_NhcomhBDoonD]OooS:Gokib]oonD[OoooooomoOg00Kooooo017o20P8oo[jn_lC4a?odM7AofYZ
J_na/K7oIVIVoh^;Roooooooo?clolo?con=SHgo20P8ooooooo9bLWo3Ph>oo[jnP03ooooo`03oj6Q
XOlM7Agooooo00?ooooo00?oZ:RXoa@D5?ooool00_ooool01?ni^KWo7QhNoda<C?omoOd5ooooo`03
ofIVI_l30`?oWinO0?ooooooloooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?S
ooooo`02ooooo`03ooCdm?n0P83oLg=c00;oLg=c00?oP820ooCdm?ooool02oooool01oo>c/koS8b<
ooooooo_knooe]KFojFUYOnDLg/00_oog_L00oooe^ooolkgoooFk`0;oooNm`03oooFkooge^ooolKW
00;oolKW00Koolk_ooo6ioooa^OoolKNooo6e_oo_MH2oon]aP04ooNU]OooU:gomiBUonnDY@;okhbL
00CokiBUooN<YOooS:GomiBU0_ooS:D02_o_U9cokhBDonmkS?oWNhcogW^<onMkS?ooU;GoohbUonnL
[OooU;D8ooooo`0=o`P82?nc/k?o;Bd]ooooooo9bLWoDe=CofIVI_n;Rh_oooooolc<c?omoOgoalO7
obLW9`02ooooo`07ob8R8_n>SXkono_kooShn?ono_koXZ:RoaXJ6P04ooooo`08ojRXZ?lE5AGooooo
ookno_mfMWKo30`<ohf=SOono_h6ooooo`03ofIVI_l0003o_[jn0?ooooooloooool00oo^k^kohn?S
okVi^@02onk^kP000oooool00oni^KWohn?Sooooo`02ooooo`03ojj^[_mcLg?oLg=c00?oLg=c00?o
[Zj^ooooooooool02_ooool01oo>c/koQ8B4ooooooogmoOokno_olK>c_mkHg<00_oog_L01Ooginoo
omkgooOWkoooe^oomnO_00Goomkg00?omoOgoooNmoogmoL00ooog_L2oooFk`03ooo6ioooa]komkgF
00;ookgF00CoolKFoonme_oo_MKoojg>0_oo[LH01?ogYKGooiB]onnDW?o_S9`3onN<U006onn4U?o_
S9cokhbLonn<W?ooS:GokiBL0_o_S9`00oogQ9ComjFeoon<Y@02ooND[@03ooO_kooooooooooo00Go
oooo00?o20P8oeQHF?n8R8P00_ooool02?l^;RkoE5ADoh^;RoooooooJ6QXocXj>_lb<S;oYZJV0_oo
ool02?o@d=3oJVYZob`/;?l/;2comoOgolk>c_l0003oe=CD0oooool01_mQHF7o@410ooooooo4a<Co
51@DomWIf@Oooooo00Go`/;2o`X:2_nYZJWo9bLWooCdm03ooooooo?ooooo00?ohn?SokVi^Oooool0
0Oooool000?ok^k^00Ko^KVion?ShoooooooooooonKVi_n3Ph<5og=cL`03oh>3PooVi^Kooooo00[o
oooo00Soc/k>ohB4Q?ogmoOoinOWomKFe_o>a/KoHe9Joooooa?oomkg00OoomK_ooOFioooa^OoolKF
ooNmc_ogYLkomkG600Gomjfm0_ogYKD04_ooU:gomiBUooNDYOo_S9coihbDomikQ?oNNhcoig^<omik
U?o_S9cokhBDonn<W?ogS:GomjFeoonD[OogW:goohbUooOWi`Oooooo00?o1`L7o`/;2ooShn<00_oo
ool00on5QHGo2PX:oh^;R`0=ooooo`0:odM7AomXJ6Soo_knoooooooNg]ko5QHFokZj^_oooooob<S8
obh^;P;ooooo00?ok^k^ooooooooool00_ooool01_oinOWo:2PXohN7QoooooooOgmoofe]KOoooooo
l_ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H01Oni^KWohn?SooooooooooooUiNG00OoLg=c
00?oUiNGooooooooool02Oooool02Oo>c/koQ8B4ooOgmooWinOoc/k>okg6_OmB@T;oomkgooOgm`05
oooNm`04oooooooog_OoonOoooOgm`[oomkg00SoolkgoooFkoooa^OoolkNooo6e_oo[LKomjg6ooN]
_@;omjFe1?ogW:d2oonD[@04oon<YOogU:GomhbUonn<W0;oihbD0ooNNh`01_oWS9ComjFeoon<YOog
U:goohb]onoNgPOooooo00?o4a<CodM7Aoooool00_ooool00ooRh^;o3@d=oi6AT@0=ooooo`06ong]
kOmEEEGo9bLWochn?_lS8b?oY:BT0oooool01?mZJV[o<30`obd];Olc<c<4ooooo`07ohZ:R_lf=SKo
no_kooooooojn_[o>3PholW9b@3ooooooo7ooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00Go
^KVion?ShooooooodM7Aoi:BTP07og=cL`03oi:BT_oAdM7ooooo00Wooooo00Ooc/k>ohb<S?oooooo
ooooonOWiooFe]KoBSU200Soomkg00[ooooooooNmoooioooomkgoooWooooooooomkgoooWoooog_Oo
mnO_0oooe^l03_oge^OoolKWoooFkoooa^OoolkNooo6g_oo_MKoojg6ooN]_OogYKGomib]ooNDYOo_
U:GokiBL0_o_U:D00oogS:GomiBUooNDY@02ooNDY@03onnDW?o_S9coihbD00;oihbD00GomjfmooND
[OogW:goohbUooONgP0Nooooo`03ooWinOoXj>Sooooo00Gooooo00?omOGeoo3`l?ooool0oooooool
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo01Gooooo00Soe]KFohb<
S?ooooooooooono_kooWinOoFT9:ooooo`Koomkg00[omoOgoooNmoooooooooooooOgmoooooooomkg
oooooooog_Oooooo0_oog_L2oooFk`06ooo6ioooc]komkgFooNme_oo_MKoolKF0ooo_Lh01ooo[LKo
mjfmooN]_OooU:gomib]ooNDYOo_U9`00ooWS9@01OoWS9cokhbLooNDYOogU:GokiBU00;omiBU00Go
mjFeoonD[OogW:goohbUonoNgP3ooooooooooooo9oooool00ooShn?o^KViooooo`01ooooo`000oo^
k^h00oni^KWohn?Sooooo`0Eooooo`08olk>c_n<S8cokno_onOWiooNg]koe]KFoeY:D_oWg^L2oooo
o`03oooNmooooooooooo00Ooomkg00?oonOooooNmooog_L01Ooog_L01OoginooomK_ooo6ioooc]ko
mkg>00;omkG60_og[Kd00ooo[LKomjfmooN]_@02ooNU]@;omib]00KokibUonnDW?oWS9coihbDomj4
S?oNNi@2onN<U0;okhbL00OomjfmooNL[OogW:gomib]oon]c_ooooookooo0?oooooooooooolToooo
o`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Gooooo00_oc/k>ohb<S?oo
ooookno_omkNg_o6a/KoLf=[omK>c_oog_OomnO_ooOgm`02oooNm`06ooooooooiooomoOgoooooooo
g_OoonOo0ooog_L01_ooioooomkgoooNmooog_OomnO_oooNm`?oomK_0_ooa^L01?ooa]Kookg>oon]
a_og[Kd3ooNU]@04ooNL[Oo_W:gomib]ooNDY@;omib]00KooiB]onnLYOo_U9coihbLonN<U?oNNi@2
omj4S005ooN]_OogW:gokjfeooNL[Ooo[LH0ooooooooooooobKooooo00?oi^KVon?Shoni^KT00_oV
i^H000?ok^k^00?o^KVion?Shoooool05Oooool05_o>c/koS8b<oooooooooooomoOgomkNg_nDS8co
W9BLoooooooog_OoooooonoWkoooooooomkgooOgmoooioooomkgoooWooogmoOoonOoooOgmoooiol4
oooNm`;oomK_00?ommKWooO6ioooc]h00_ooc]h01Oooa]koolKFoonme_oo[LKomjfm00;omjFe00Go
kibUonNLYOo_U:GokiBUonnLY@06ooNDY@08onnDW?oWS9coihbLooNL_OogW:gomjFeonn]]Ooo[LKo
oooooooooooo9_ooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Eoooo
o`08olk>c_n<S8coooooooooooogmoOokno_ojf][OnLU9`3ooooo`;oomkg01ComoOgoooNmoogmoOo
omkgoooooooog_OooooooooNmoooooooomkgoooWoooog_OomoOgoooNmoooe^ooonOWooo6ioooc]ko
olKFooNmeP?ookg>00?omkg6oonmc_oo[LH00_og[Kd01OooU:gomib]onnLYOo_S9coihbD00?oihbL
00GokiBLonnLYOo_U:GokiBUooNDY@03ooNU]@03ooNL[Ooo[LKooooo0?oooooooooooolVooooo`03
on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo01Gooooo00Soc/k>ohb<S?ogmoOo
kno_omkNg_oFe]Kog]KFoeY:DP;ooooo017oomkgooooooooooooomkgooooooooiooooooooooNmooo
ooooomkgooOgmooog_OooooooooNmoooioooomkgooOgm`03oooNm`06ooOFioooc]koolKFooNmc_og
]LKoojg60_og[Kd2ooNU]@;omjfm0_ogYKD01_o_YJGokibUonnLYOoWS9coihbDomikU0?oihbD00Oo
ihbLooNU]OogYKGomjFeooNL[Oog[KgomoOg0?oooooooooooolUooooo`03onk^k_oShn?o^KVi00;o
k^k^0003onKViP03okVi^OoShn?ooooo01Gooooo00Woc/k>ohb<S?oooooomoOgonOWiooFe]Koe/k>
obTQ8OoWg^L00oooool00oogknooonOoooooo`04ooooo`04oooNmoooooooomkgooooo`;omoOg0ooo
g_L4oooFk`05ooOFioooc]koolKFooNma_oo[LH00oogYKD01?o_W:gomib]ooNL[OogYKD2ooNL[@09
oonD[OogU:GokiBUonnLYOo_U9coihbDomikU?oWS9Comjfm00;omjFe00?omib]onnU_Oogknl0oooo
ooooooooobGooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool05Oooool0
0oo>c/koS8b<ooooo`02ooooo`07ono_kooNg]ko_KFeod8i>OoFc/kooooooooNm`0:ooooo`05oooW
oooog_OoomkgoooNmoogknl00_ooe^l2ooOFi`0;ooo6ioooc]koolKWooo>g_ooa]KoolK>oonmc_og
_LKomjfmooNU]Oo_YJD00_oWW:D5onnLY@;omib]00?omiBUonnLYOo_W:D01OogYKD00oo_inoooooo
ooooo`3ooooooooooooo8oooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Soooo
o`0Eooooo`03olk>c_n<S8cooooo00;ooooo00WomoOgooO_kooWinOoc/K6of=BF_m2@T;oLf=[oiBD
U?oginl01Oooool00oooioooooooooooo`03ooooo`09oooWoooog_OoomkgoooNmoooe^ooolkNooo>
e_og_MKomlK>00Cookg>0oog[Kd2ooNU]@04ooNL[Oo_W:GoihbLonN<W0;oihbD0_oWS9`2onnLY@03
ooNL[Oog[KgomjFe00;omjFe00?okjFeonOWioooool0ooooooooooooobGooooo00?ohn?SokVi^Ooo
ool00Oooool000?ok^k^00?o^KVion?Shoooool05Oooool01oo>c/koU9BDooOgmoo_knooinOWomkN
g_oWinL00_oNg]h2onOWi`07olk>c_nLW9coJf][oeY:D_mcFV?oW9BLonoNgP02ooooo`08ooOgmooo
ooooomkgooooooooiooomoOgoooNmoogmoL2oooNm`05oooFkooog_OoolKWooNme_og_Lh00_og_LH0
0oo_[KGomjfmooN]_@04ooN]_@;omjFe00?okib]ooNL[OoWW:D01OoWS9@2ooNU]@04ooNma_o_YKgo
oibmooo>e_oooooooooooolUooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo01Cooooo00?omoOgono_komcLg<00_ooool01oogmoOoinOWolk>c_o>c/koa/K6olk>c_oFe]H0
0ooNg]h02?oWg]kog/kFokF][OmcLg?oBTY:of=BF_nLS9Coe/K>0_ooool00oogmoOoomkgoooNm`02
oooNm`0:oooWoooog_OoomK_oooWioooe^ooolkNooo6c_oo[LKoolK>ooNU]@Komib]00OokjFUooNL
[OogW:gomib]ooNDYOo_YJGokiBL00;oihbL00KomjFeooN]_OogYKGokjfeooNU]Oooa/kooooooooo
oooo9Oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0Fooooo`03oe9:
D_oooooooooo00;ooooo00?okno_onOWiooNg]h01?o>c/h04Oo6a/Koe]KFomKFe_oNe]Kog]kNonOW
iooNe]Ko[JFUog]kNomJBU;oHe9JohakQ?o6a/Koomkgoooooooge^ooimkW00GoomK_00GoolKWooo>
g_oo_MKookg>ooNmaP02ooN]_@04ooNU]Oo_YJGoiibUonNLY@?okibU00_okib]onnUYOogU:GokjFU
ooNDYOogYKGomjfmooNma_o_[KGooibmooo6cP3ooooooooooooo9Oooool00oo^k^kohn?SokVi^@02
onk^kP000oooool00oni^KWohn?Sooooo`0Fooooo`03ojf][OmkNg_ooooo00?ooooo00GomoOgono_
kooWinOoinOWomkNgP02omKFeP06olk>c_o6c/koa/K6olK6a_o6c/koc]KF0_oNg]h04?oWinOoimkW
okfm_On4LhCoFT9BoeY2B_n4LhCo_IbeooOFioooe^oommKWooNmg_og_LkookgFooo6g_oo]Mh2oonm
eP0Eoonmc_oo[LKomjfmonn]]OogW:gokjfeonnUYOoWS9coiibUonN<W?oNU:GoihbLonnUYOo_W:Go
mjFeooNea_ogYKGokjFmooN]_Oog_LKomoOg0?oooooooooooolUooooo`03on?Shoni^KWooooo007o
oooo0003onk^kP03okVi^OoShn?ooooo01Oooooo00CoLg=cokfe]OogmoOokno_0_oNg]h2onOWi`0D
ono_koogmoOokno_onOWiooNinOog]kNomKNg_o>e]Koa/k>olK6a_nma/Koa/k>olK6a_o>a/koe/k>
omkNg_oWinOoimkWokfm_OnDU9@2of=:DP07og=JHoneW9cokkgFoooWioog_Mkomkg>onn]cP02ooN]
aP09ooNea_oo[LKomkg6ooNma_ogYKGomjfmooNL[Oo_W:GokjFU00;oiibU00WogYBUonN<U?ogYKGo
mjg6ooN]_Oog]LKooibmooNma_oog_L0ooooooooooooobCooooo00?ok^k^on?Shoni^KT00_o^k^h0
00?oi^KV00?o^KVion?Shoooool05oooool01ooWinOoDTYBooooooooooookno_omkNg_oFe]H00_o>
c/h00ooFe]Kog]kNonOWi`03ono_k`;oinOW00?og^OWomKNg_oFe]H01Oo>c/h03?oFc/koe]KFonON
g_oWinOoimkWomk>e_nLU9coLeYSoeXi@_m[BU[oS6]conn]]@;omkg600KomjfmooNU]OogW:gomjFe
ooN]_OogYKD2ooN]_@09ooNU]OogW:gomib]onnLYOoWW:GomjfmooNea_og[Kgomjg600;omjfm00?o
mnO_ooooooooool0ooooooooooooob;ooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVi
on?Shoooool05?ooool2ooOgm`;ooooo00?oBTY:ooooooooool00_ooool00oogmoOoinOWomkNgP03
omKFeP05olk>c_oFe]Kog]kNomkNg_oWinL00_o_knl00ooWinOog^OWomkNgP02omKNgP05omKFe_o>
e/koc/k>olk>c_oFc/h00_oFe]H01_oNe]KoimkWonOWiooFc/ko_KFeog=JH`;oLdYB00[oU6]colJD
W?oW[KGokjFmonN]]OoNU:Gokib]ooNU]Oo_[KGokib]0oogYKD01?og[Kgokjg6ooN]_Oog]LH2ooN]
_@03ooOWiooooooooooo0?oooooooooooolRooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03
okVi^OoShn?ooooo01Kooooo00GomoOgoooooomSHf?okno_ooOgm`05ooooo`06ooOgmoo_knooinOW
onONg_oNg]koe]KF0_o>c/h01OoFc/kog]KFomkNg_oWinOoino_00Cokno_0_oWinL00ooFg]koc]KF
olK>cP03olkFcP07omK>c_oFe]Kog^OWomkWiooNg]ko_KfmohAkN`02oeY2BP04ohASJoo>Q8cokib]
onnU]@;okib]00[okibUonNLYOo_W:gomkG6onnU_Oog_LKomjfmoonL_Oog[KgokmkNoooooooooooo
obGooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool05_ooool01_ogmoOo
oooooibLW?nU[JGoooooooOgm`?okno_00ComoOgoooooooooooooooo0_ogmoL01Oo_knooinOWomkN
g_oNg]koe]KF00?oc/k>0_oNg]h00oogmoOoooooooOgm`03ooOgm`04ono_kooWinOog]kNomKFePCo
c/k>00?oc]KFolk>c_oNg]h00_oNg]h02_nm_KgoU8b<oeY2B_mJ@T;oNe9JojEcLooFW:GokjfeonNL
YOo_YKd2oon]aP04ooNL_Ooo[LKomibmooo>g_oooooooooooolTooooo`03onk^k_oShn?o^KVi00;o
k^k^0003onKViP03okVi^OoShn?ooooo01Sooooo00CoinOWoe9:D_o_knoomoOg0_ooool01Oo_knoo
imkNonOWioo_knooinOW00;omoOg0_ooool2ooOgm`;okno_00Oog]kNonOWiooFe]KoU9BDof=SHon<
S8coe]KF00Gooooo00KomoOgono_koo_knookno_omkWiooFc/h3olk>cP04olK6a_o>c/koe]KFolkF
eP;oinOW00coe[g6oib<U?mcDU[oHcTiof]2B_nLJg?oaYbUonn]a_og[LKomkg>onn]c_og_Lkooooo
oooooooo9?ooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0Iooooo`05
omKFe_mBBU;oYJFUolk>c_ogmoL00_ooool01?o_oooomno_onOWiooWknl3onOWi`0@ono_koogmoOo
moOgooOgmooooooomoOgono_koogmoOoooooomkNg_nLW9coQ8B4of=SHon4Q8Co_Kfmono_k`;ooooo
0_ogmoL01Oogknooino_onOWiooNg]koe]KF00;oc/k>00Koc/K6okg6a_nma/Ko_LK6olk>c_oFe]H3
omkFeP07okFLW?nLQ8coLe9Jof]2B_n<Hf_oaYbUoooWi`3ooooooooooooo9?ooool00oo^k^kohn?S
okVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Fooooo`03ooOgmooooooomoOg00;ooooo00Oo
kno_okfm_On<S8coLg=cohb<S?nm]KGoinOW00;ooooo0_ogmoL2onOWi`;og]kN0_oWinL3ooOgm`;o
oooo00[omoOgooooooooooookno_okfm_On4Q8CoHf=Sog]kNonm]KGoe]kN0_ogmoL04?oooooomoOg
ooOgmoogmoOokno_omKFe_oFe]koc/k>olK>c_nma/Ko_Kfmokg6a_o>e/ko_LK6omKFe_ogmoL2oooo
o`03ooO_koo_inoooooo0?oooooooooooolUooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03
okVi^OoShn?ooooo01Gooooo00?omoOgooooooogmoL01?ooool02_ogmoOoooooooooooooooooc/k>
oibLW?mkNg_oQ8B4ojFUYOoNg]h2ooooo`06ooOgmooWknooinOWono_kooNg]kokno_2_ooool00oo_
knoo_Kfmohb<S002og=cL`04ojFUYOo>c/kokno_ono_k`;omoOg00OoimkWooOgmoo_inoog]kNomKF
e_o6c/ko_LK600;oa/k>00?okoooooooooooool0ooooooooooooobOooooo00?ok^k^on?Shoni^KT0
0_o^k^h000?oi^KV00?o^KVion?Shoooool06Oooool00oogmoOoooooooooo`04ooooo`06ooOgmooo
oooooooooooooooNg]koYJFU0_mkNg/01_nLW9coc/k>ono_koogmoOokno_ooOgm`kooooo00WomoOg
omKFe_nLW9coLg=cof][JonDU9Co_KfmonOWioo_g]h00_ogknl01ooginooinOWomkNg_oFe]koc]KF
ooooooo_ool00_ooool00oo_ooooooooooooo`3ooooooooooooo8oooool00ooVi^Kohn?SokVi^@02
onKViP000oo^k^h00oni^KWohn?Sooooo`0Cooooo`05ooOgmoooooooooooooooooogmoL04?ooool0
1Oo_knoo_KFeohb<S?o6a/KomoOg01Cooooo00Oog]kNojFUYOn4Ng_oHf=SohAkNon][Jgoe]KF00;o
kno_00?oknO_onO_koogmoL01?ooool00oogmoOoooooooooo`3ooooooooooooo8_ooool00oo^k^ko
hn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Fooooo`03ooOgmooooooooooo02cooooo
00Kokooookg6_On4Q8CoHf=Sof]cJoo6a/Kooooooooooooo;?ooool00ooShn?o^KViooooo`01oooo
o`000oo^k^h00oni^KWohn?Sooooo`3oooooooooooooM_ooool00oo^k^kohn?SokVi^@02onk^kP00
0ooVi^H00oni^KWohn?Sooooo`3oooooooooooooM_ooool00ooVi^Kohn?SokVi^@02onKViP000oo^
k^h00oni^KWohn?Sooooo`3oooooooooooooM_ooool00oo^k^kohn?SokVi^@02onk^kP000oooool0
0oni^KWohn?Sooooo`3oooooooooooooMoooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni
^KWohn?Sooooo`02ooooo`07ono_kon][JgoFV]SoibLW?oWa/KoinOWooOgm`04ooooo`03onooooog
moOooooo0?oooooooooooomVooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP0?okVi^OoShn?o
oooooooooooNg^OoU8b<oa0H4?m:BT[o:B4QojecNomkNg_oU8b<ojf][OoF_LKokno_0?oooooooooo
oomZooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP0DokVi^OoShn?oooooonO_konm_Kgo:C4Y
okg6_Ooooooo>APQolj4S?o>Lg_oaV]coje[JonLHf_oS6]coib<S?nm]KGoe]KFono_koogmoOooooo
ooooooooIOooool00oo^k^kohn?SokVi^@02onk^kP000oooool01_ni^KWohn?SooOgmooFc]KoW9BL
oc4i>@;ooooo00ooNe9JolikQ?ooNiCokg><onMkQ?o>Lg_o_F]cojESJonUHf?oU6]cohB4Q?nLW9co
_KfmomkNg_ogknl0ooooooooooooof?ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00Ko^KVi
on?ShooWinOoa/k>ohbDS?mJFUX2ooooo`04og=JHoo>NiCoohb]oon<Y@;oohBL0_ogNh`02oo_Hg_o
ieYcolI[Lon]Jf_oYF=SoiA[LonDQ8CoYJfUolK>c_oNknoomoOg00;ooooo00?okoooooooooooool0
1?ooool00oo_ooooooooooooo`3oooooooooooooD_ooool00oo^k^kohn?SokVi^@02onk^kP000ooV
i^H01_ni^KWohn?SooOWiooFe]koYJfUof]cJ`;ooooo01OoJg=[omj<[OooYLkoojG>ooND_OooU;Go
miB]oon<YOo_S9coohBLonn4U?oNNhcoeW>4olicNonmJg?o[F][ojESHonUJf_oW8B<okFLW?o>a/ko
inOWooooo`03onooo`_ooooo00?okoooooOgmoooool0ooooooooooooodWooooo00?oi^KVon?Shoni
^KT00_oVi^H000?ok^k^00go^KVion?Shoogknooino_ojf][Om[Hf?oimkWomKNg_mSBU;oaW>DoonD
]OooW;goojG600;oojG>01CoojG6ooND_Oo_U;goohb]oon<YOogNiComhBDooMkS?oWNhCokf=konM[
NoneLg?oYF]coiaSJonDJg?oW8b<okfe]Oo>g]KoioOgooOgm`Oooooo00?omoOgooooooooool0oooo
ooooooooodcooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo017o^KVion?Shooooooooooookfm
_Om[Lf_oimkWolkFe_m[FU[oaW>DooM[Q?ogLhcomg>DooN4YOooU;GooibmoonUaP02oonUcP0GoonL
_OooU;Goohb]oon<[OooQ9comg^DooMcU?o_Q9Coig^4omIcNoo>Hg?oaW=cojEcLonLJg?oW7=kojfU
YOnm_KgoimkNooOgmoo_ooooooooooOgmoo_ool01oooool00oogmoOoooooooooo`3ooooooooooooo
A_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h03?ni^KWohn?Sooooooooooooa/K6ohB4Q?og
moOoino_ohakNooNS:gooiBeoon<[@;omg>D00Cokg><ooMcU?ooQ9coohbU0_ooYLH2ooneeP0DoonU
c_ooYLKomiBmonn<]OogNiCoohBLooMcS?ogNhcomg^Donm[Q?oFLg_ocV=cokEcLonUJg?oYG=cojEk
NoneW9co_KfmonOWioo_ooooooooooooooooCoooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H0
2_ni^KWohn?Sooooooooooooc]K>ohB4Q?o_inooinOWoiB4Q?oNS:d2oonL_@04oonD]OooS:goohbU
ooN4Y@;omg^D00KogW^Doon4W?ooU:gooiBeoonUa_ooYLh2ooneeP05oonUc_ooYLKooiBeoon<YOog
Ni@00oogLi@03OogNhcoig^4omIcNoo6Jg?o]G=coje[JonULg?oYG]kokF][OoFc/koinOWooOgmooo
ool00oo_ooooooooooooooooAoooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h02_ni^KWohn?S
oooooooooooo_LK6og]kNooFc]Koc/k>of]cJoo>Ni@3oon<[@03oonD]OooW;gooibm00;omibm0_oo
S:d02OogU:gomhBUooN4YOogU:goohb]oonD]OooYLKookGFoonUcP02oonUaP09oonL_OogU:gomhBU
oon4W?ooNiComg^DooN4U?oWNhcogW^400;ocV=c00WoYG=koia[LonLLg_o[HbDokfe]OoNc]Komno_
ooooooo_ool0ooooooooooooodKooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00[o^KVion?S
hoooooooooooolkFc_n<S8coknO_omkWionDLg_ocW^L0_ooS:d2ooN4Y@08oon<[OooU;GooibmoonL
_OooYLKoojG>oonUa_ooW;d2oonD]@09oon<YOooQ9cokg^UooN<YOooU;GomibmoonUa_oo[LkoojG6
00;ooibm01;okhbeooN4YOo_NjGoohBLonmkYOogNiCokhBDonMkS?oFLg_oaW=kokE[NonUJg?oU6]c
oiakNon]S9Coa/K6omKFe_ogknooooooooooooooAOooool00ooShn?o^KViooooo`01ooooo`000oo^
k^h03_ni^KWohn?Sooooooooooooe/K>ohb<S?o_ooookno_oibDW?neW9coojG>oonUa_ooW;gooiBe
0oooU:d04OooU;GokjG>ooNL_Oog[LKoojG>oon]c_ooYLkoojG6oonL_OooU;Goohb]oon<YOo_NjGo
mg^DooN4YOooS:gooiBe00?ooibm01CooiBeoon<[OooS:GoohbUooN4YOogNiComg>Donn4U?o_Nhco
ig><omi[Noo>Hg?ocUY[ojE[JonLJg?oW7=kokFLW?oF_LKog]kNonogm`;okooo0_ooool01?o_oooo
ooooooooooo_oooooooooooooooo>?ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H03Oni^KWo
hn?Sonooooooooooc/k>ohAkNooNinOoe]KFoib4S?nLS9CookGFoonUc_oo[Lh00_ooYLH01?oo[LKo
oibmoonL_OooU:d3oonD]@04oonUa_og[LKoojg>oonUcP;oojG60_ooW;d02?ooU;Gokg^UonmkYOoW
S9coig><onn4U?ooS:Goohb]0_ooU;D2oon<[@;oohbU00KoohBLooMkU?ogQ9Comg^Donn4U?o_Nh`2
olikQ00:okE[NonUJg?oYF]coiAcNon]S9Co_JFUolk>c_oWg]koooooonooo`;ooooo00?okooooooo
ooooool0ooooooooooooocKooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00ko^KVion?Shooo
ooooooooomK>c_n4Ng_og^OWolk>c_nDS8coW7=konnUc_o_[LKomibmoon]aP;oojg>1?oo]MH01?oo
[LkoojG6oonL_OooU;D2oonL_@05ooN]a_ooYLkoojG>oon]a_ooYLH00_ooW;d02?ooU;GoohbUoon4
W?oNNiCokg><onMcS?ogNiCoohbU0oooS:d2oon<Y@;oohBL00Somg^DooN4U?ogLiCoohBLomikU?oW
NhcocW^4oke[L`;o]G=c00OoU7=kojf<U?ooc]kokoooooOgmoooooookooo0?oooooooooooolhoooo
o`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`0;okVi^OoShn?ooooooooooooFc/koS8b<onogmooW
inOo[JFUoiAcNoooYLH00_ogW;d01OooU;GooibmoonUa_oo[LKoojg>00;omkgN0ooo]Mh00ooo]MKo
ojg>oonUaP02ooNL_@CooiBe0_ooW;d2oonD]@04oon<[OooQ9comg^DooMcS0?oif>400Cokg><ooMk
U?ooQ9coohb]0_ooS:D3oon4W0;oog^D00CoohBDooN4U?o_Nhcoig^40_o6Nh`00oo_YKGoooooonoo
o`3ooooooooooooo>oooool00ooShn?o^KViooooo`01ooooo`000oo^k^h03Oni^KWohn?Soooooooo
ooooc/K>ohB4Q?ogmoOoknO_okfe]OnDLg_oolk_oonme_oo[Lh00_oo[LH00oog[KgomibmooN]aP02
oon]cP0=oonmc_oo]MkoolKWooo6iooga^OomkgWoonee_oo[LkoojG6ooNL_OooU;GomiB]oon<Y@02
oon<[@;ooiB]00KooiBeoon<[OooS:GoohBLoomkU?o_Lh`2onMSQ004omiJNooWHhCokg><ooMkU0Oo
ohBL0_ooNi@01?o_S9cogW^<omikU?o_inoooooooooooooo>oooool00oo^k^kohn?SokVi^@02onk^
kP000ooVi^H02_ni^KWohn?Sonooooooooooe/k>ohAkNooNinOoe]KFokfe]OmkHg<4oonegP04ooo6
g_oo]MkookgFooNmeP;oojg>0_ogYLh01Ooo_MKookGNooneg_oo]MkoolKW00;ookGN0_oo]MH01Ooo
[LkomibmooNU]OogQ:GomhbU00;omhBU0oooS:D2oon4W00DoomkU?ogNiCokg><onMSQ?oWHg_ogUYk
omiJLoo_JhCokg><ooMkU?ooQ9CoohBLoon<YOooQ9coohbUooMkU?ogLiCoif^<onoNg_o_oooooooo
oooooooo>_ooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h02_ni^KWohn?Sooooooooooooe/k>
ohAkNooNinOoc]KFokfe]OmcDUX2ooNmeP05ooNUc_oo]MKookGNooneg_ooa^L00_ooc^l00oooa^Oo
okGNoonmeP03oon]cP05oon]a_og_MKomkgFooNme_oo]MH00_oo]Mh2ooneeP08oonUa_ooW;gomiB]
onn<W?o_Q9Comg>DonmcS?o_Nh`2oon4U0?oog^D00Gomg><onmcS?o_JhCoieYcomiSL`02omiJL`03
onMSNoo_Lhcomg><00;oohbU0_ooJh`00ooNc]KomoOgooOgm`3ooooooooooooo>Oooool00oo^k^ko
hn?SokVi^@02onk^kP000oooool03Oni^KWohn?Sooooooooooooe/k>ohb<S?ooooookno_omJma_mk
DU[oolKWoonme_oo[Lh00_oo[LH01?og[LKookGFooneg_oo]Mh2ooo6i`03oooFkoooc^ooolk_00;o
mlKW00CookGFoon]c_oo[LKomjg60_oo[LH2oon]cP;oojG600OooibmoonD]OooU;GoohbUoon4W?og
LiCoif]k00;okf^400?oig^4ooMkS?ooNi@00oooNi@00oogJhComg><onmSN`03omiJL`05onmcS?og
LiCoog^Doon4W?og_MH00_o_oooooooooooooooo>_ooool00ooShn?o^KViooooo`01ooooo`000oo^
k^h02oni^KWohn?SooooooogmoOoe/k>ohakQ?ogmoOomno_onOWiomJHe[oolkg00?oolKW00CoolKN
oonee_og_LkookGF0_og_MH2oonegP0>ooo6ioooc^ooomK_ooo>moooc^ooolKWooneg_oo_MKoojg>
oonUa_ogW;gomjFeoonL_OogYKD3oonL_@07oonD]OooU:goohbUoon4W?ogNiCokg^<onMSQ002onMS
N`03onM[Noo_Hg_okg><00;omg><00Wokg><ooMcS?o_JhCokf^4ooMcS?ooNiComhBUooMkU?oo_MH0
oooooooooooooc_ooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00co^KVion?Shooooooooooo
olk>c_n4Ng_oimkNomk>e_oFa/ko@T92ooo>koog_Mh2ooo6i`;oolk_00GoolKWooo>koooa^OoolKN
ooNmgP02ooNmeP;omkgN0oooa^L02?ooc^ooolKWooo6g_ooa]Koojg>oon]a_og[Kgooibm0_ogU:d0
1?ogU:GomiB]oon<[OogU:d3oon<Y@09oon4W?ogNiCokg><onm[Q?oWHg_ogUYcomiSLooWHg_okf^4
00?omg><0_ooQ9`01OogS:Gomg^Doonmc_ooooookooo0?ooooooooooooliooooo`03onKVi_oShn?o
^KVi00;oi^KV0003onk^kP0;okVi^OoShn?ooooooooooooFe]KoS8b<ooO_kooWg]kog]KFod8i>Ooo
a^L01?og_Mh01oooa^Ooolk_oooFkooog_OoolkgoooFkoooc^l00_ooa^L2ooNmgP03ooNmioog_Mko
mkgN00CookGN00[ookgFoon]c_oo[LKooibmooNU]OooS:gomhbUonn<W?o_Q9Comg^D1OooQ9`2oomk
U00<ooMcS?o_Lhcoif]komiSLoo>Hg?ogV=conM[Noo_LhcoohbUooN4YOogNiCookgFoooooooooooo
oc_ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00oo^KVion?Shoooooooooooolk>c_n<S8co
ooooooO_kooWg^OoBSU2ooo>moooa^OoolkNooNmg_og_MH00oog_Mh00oooa^OoomK_oooNm`02oooN
m`07oooFkoooc_OoomK_ooOFkooga^OomkgNonnmeP02ooNmeP;ookgF00[ookGFoon]c_oo[Lkoojg>
oon]a_ogYKGooiB]ooN<YOogQ9CokhBD0_o_Lh`04_oWLhcokg^<ooMkU?ogQ9CoohBLooN4U?ogLiCo
kg><onm[Q?oWHhCogV]konm[Q?ooS:GomhbUooMkU?oo_MKoooooonooo`kooooo00?oh^;Rooclo?oo
ool01?ooool00ooRh^;oo?clooooo`3ooooooooooooo8_ooool00ooShn?o^KViooooo`01ooooo`00
0oo^k^h02oni^KWohn?Sooooooooooooc/k>ohb<S?ogmoOomno_onOWiom:BT[oomkg00;oolkg00Go
omkgooo6ioooc^ooolKWooo>gP03ooO6i`05ooo6ioooe^ooolkgooo>mooog_L00oooc_L2ooo6i`03
ooNmg_o_[Lkokjg>00;omjg600?omibmoonL_Oog[Kd00_ooW;d03_ogYKGooiBeoonD[Oo_S9cokhBD
onMkS?oWHhCoig^4onMSQ?oWNhCokg><onn4U?ooQ9comhBD0_ogNi@01OogQ9Coohb]ooN<YOooS:Go
okg>013ooooo00?o3Ph>on;Rh_ooool01?ooool00ol>3Pkoh^;Rooooo`3ooooooooooooo8Oooool0
0oo^k^kohn?SokVi^@02onk^kP000ooVi^H02oni^KWohn?Sonooooooooooc/k>og]kNoo_knoog]kN
omKFe_m2@T;omlKW00;oomK_00OoolkgoooFkoooe^ooomkgooo>mooog_Ooolkg00;oomK_0ooge^l0
4Oooe^ooomkgoooFkoooe^ooolkgoooFkoooc^ooolKWooo6g_oo[Lkomjg6onnU_Oo_W;GomiB]ooNL
[OogU:GoohbU00?ooiB]0_ooS:D01OooQ9comg^DonmkS?oWHhCoig^400;ogV]k00Soig^4onMcS?og
NiCoohBLoon<YOo_NjGoohbUooNeaQ3ooooo00Co3Ph>on;Rh_ofm_Kon_[j0oooool01?l>3Pkoh^;R
ooKfm_ojn_X7ooooo`03ookno_oYjNWoo_kn0?oooooooooooolFooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP0;okVi^OoShn?oooooooooooo>e]KoS8b<oooooooWinOog]KFoeYJF_og_Lh00_oo
a^L01Ooga^OommKWooo>koooe^ooolkg00Soomkg0_ooa^L03_oga^OommKWooo6ioooe^ooolKWooo>
koooa^OookGNoonmc_oo[LKomjfmoonD]OogU:GokhbL0_oWS9@00oo_S9coohBLonn<W003onn<W005
oon4U?ogQ9Cokg^<onMcS?oWNh@00_oNJg/01OoWLhcoohbUooND[OooS:Gomjfm00Oooooo00?oBTY:
ojVYZOooool00_ooool02OoinOWo4a<CokZj^_oooooo3Ph>ofMWIom6ATKo410@ojVYZ@02ooooo`05
o`h>3_mWIfOoATI6oa0@4?nYZJT00_ooool02?l>3Pkoh^;Roooooona/K7o5aLGocTi>Old=3Co^KVi
oooooooooooooaGooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00_o^KVion?Shooooooooooo
olk>c_n<S8coooooooOgmooWinOoLf=[onnmeP02oooFk`05ooo6ioooe^oomlKWooO6iooge^l00_oo
e^l7oooNm`03oooFkoooa^OomkgN00;omkgF00GomkgNooNme_oo]MKookGFoonmeP02oon]cP08oon]
a_ooW;gomjFeoonD[OooS:GokhbLonN<U?oWNh`2onn4U004oon4W?ogQ9CokhbLoon4W0;omhBD0_o_
Nh`01OogQ9Coohb]ooND[OooS:gokjFm00Oooooo00?o[jn_od=3@oooool00_ooool02OnXZ:So820P
ookno_oooooo3Ph>okRh^?oooooobl_;ob<S8`02ooooo`05o`h>3_nh^;Sooooool_;bolS8b<00_oo
ool01Ol>3Pkoh^;RonKVi_l;2`_oalO70?oooooooooooolIooooo`03on?Shoni^KWooooo007ooooo
0003onk^kP0;okVi^OoShn?oooooooooooo>c/koQ8B4ono_kooWinOog]kNohbDS?nmW;D01ooog_L0
1OoginooomK_ooOFkooge^ooomK_00Ooomkg00Ooolkgooo6ioog_MkomkgFooNmc_og]LKomjg600;o
mjfm00?oojg6ooN]_Oog[Kd00_ogYKD01_ogW:gomiBUooNDYOo_Q9Coig^<omikS0?oig^<00WokhBD
ooN4U?o_Q9CokhbLonnDW?ooU:goohbUonnL[OooU;D01oooool00ookno_o6QXJoc<c<`02oc<c<`06
oaDE5On2PX;oooooooooool>3Pkoh^;R0_ooool01OlF5QKof=SHooooool>3Pkoh^;R00;ooooo00Oo
5QHFomSHf?oooooo3Ph>on;Rh_n[Zj_o8B4Q00?o_kno00?ojNWYooooooooool0oooooooooooooa?o
oooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00_o^KVion?ShoooooooooooomKFe_n<S8cokno_
omkNg_o6a/KoS7^4oibDW003oooFk`_oomkg00?oomK_oooNmoooe^l01?ooe^l2ooo>k`04ooo6g_oo
_MKoojg>oon]aP;omjFe1?ogW:d4oonD[@05oon<YOooQ9cokhBDonmkS?oWNh@00_oNNh@02OoWNhCo
kg^<ooN4U?ooU;GoohbUonnL[OooU:goooooooOgm`06ooooo`06ogYjN_mbLW;omOGeom?Cdol30`?o
i>CT0_ooool02Ol>3Pkoh^;Roooooooooooo5QHFol[:b_oooooo3Ph>on;RhP02ooooo`07oaHF5_o:
b/[oooooo`h>3_oRh^;oalO7oaLG5`02ogAdM003oa/K6oo1`L7ooooo0?oooooooooooolDooooo`03
onKVi_oShn?o^KVi00;oi^KV0003onk^kP0;okVi^OoShn?oooooooooooo>c/koS8b<ooooooo_knoo
e]KFojFUYOnDLg/00_oog_L00oooe^ooolkgoooFk`0;oooNm`03oooFkooge^ooolKW00;oolKW00Ko
olk_ooo6ioooa^OoolKNooo6e_oo_MH2oon]aP04ooNU]OooU:gomiBUonnDY@;okhbL00CokiBUooN<
YOooS:GomiBU0_ooS:D02_o_U9cokhBDonmkS?oWNhcogW^<onMkS?ooU;GoohbUonnL[OooU;D8oooo
o`05omkNg_lJ6Q[ono_kogYjN_m:BTX00oooool05_l>3PkoKFe]onk^k_n[Zj_o5ADEookno_oooooo
3Ph>ofe]KOo^k^koZj^[oaDE5Oono_koooooo`h>3_oRh^;oo_knob8R8_oPh>3okno_oadM7Oojn_[o
oooooooooooo5Oooool00oo^k^kohn?SokVi^@02onk^kP000oooool02oni^KWohn?Soooooooooooo
c/k>ohB4Q?oooooomoOgono_koo6c/koNf=c00;oomkg00GomnO_oooNmooginooomK_ooOWk`05oooN
m`03ooOgmooog_OomoOg00?oomkg0_ooe^l00oooa^OoolKNooNmeP02oonmeP04ooo6e_oo_MKookgF
oon]cP;oojg600ComjFeoonD[Oo_U9cokhbL0ooWS9@01_o_Q9CokhbLonn<W?o_S9coohbUonnDW0;o
khbL00?omhBDooNU]OooS:D00_ogU:d00oogknooooooooooo`06ooooo`04odE5AOnZZZ[o6ATIojj^
[P?ooooo00Go=cLgojZZZ_la<C7o?Cdmok^k^`02ooooo`05ocLg=onZZZ[o<C4aocdm?Onk^k/00_oo
ool01ol>3Pkoh^;Roooooonk^k_o<C4aoclo?on_[jl0oooooooooooooaOooooo00?ohn?SokVi^Ooo
ool00Oooool000?ok^k^00co^KVion?Shoooooooooooolk>c_n4Q8ComoOgonOWiooFe]Koc/K6of=B
F_oooolCoooNm`07oooFkooge^OoolKWooo6e_og_LkomjG>ooNeaP05ooN]_@;omjFe01;ooiB]ooND
YOogU:GokhbLonN<U?oNNhCogW^<onMkS?oNNiCokhbLonn4U?o_S9comhbUooNU]OooU:gomib]oon<
YOoginL8ooooo`04oj^[ZolF5QKo5aLGoo_kna7ooooo00?o3Ph>on;Rh_ooool0oooooooooooooa[o
oooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00go^KVion?Shoooooooooooolk>c_n4Q8ComoOg
onOWioo>c/ko_LJmoe92@_oog_OomoOg00Goomkg00CooooooooNmoooiooomoOg2_oog_L02?ooc_Oo
omK_ooo6ioooc]koolKFoon]a_og[LKomjfm0_ogYKD4ooNL[@;ooiB]00CoohbUooNDYOogS:GokhbL
0_oWS9@3omikS006onN<U?ogYKGoohbUooND[OooS:gokmkN2?ooool00oojn_[o7alOog]kN`0Boooo
o`03o`h>3_oRh^;ooooo0?oooooooooooolJooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP06
okVi^OoShn?oooooooooooo>c/koS8b<0_ooool00ooWinOoe]KFodXi@P08oooNm`0:oooooooog_Oo
onOooooNmoooiooooooooooNmoooioooomkgooOWk`?oomK_00kommKWooo6ioooe^ooolKWooo>g_oo
a]kookgFoon]a_og[KgomjFeooNL[OogU:GokiBUonnDW0;okiBU00?omhbUooNDYOogU:D00_ogU:D0
0oo_U9cokhbLonN<U002onN<U005ooN]_OogU:gomib]oon<YOogg]h07Oooool00on<S8colO7aoooo
o`3ooooooooooooo6_ooool00oo^k^kohn?SokVi^@02onk^kP000oooool01_ni^KWohn?Soooooooo
ooooe]KFohb<S0;ooooo00Cokno_onOWiomJ@T[ooooo1_oog_L02_ogmoOoomkgoooooooooooomoOg
oooooooog_OooooooooNmoooool2oooNm`;oomK_00KoolKWooo>g_og_MKomkgFoonme_ooa]H3oonm
cP07oon]a_og[KgomjfmoonD[OogW:gomiBUonnDW003onN<U005onN<W?o_S9comiBUooNDYOo_U:D0
0_ogU:D01OogYKGooiB]ooNL[OooS:GokmkN0?oooooooooooolkooooo`03on?Shoni^KWooooo007o
oooo0003onk^kP0<okVi^OoShn?oooooooooooo>c/koS8b<ono_kooWinOog]kNomKFe_mJBU;oimkW
0_ooool00ooog_Ooooooooooo`07oooNm`03oooWoooog_Ooomkg00Goomkg00GomnO_oooFkoooa^Oo
olkNooNmcP02ooNeaP;omjfm00?oojg6ooN]_Oog[Kd00_ogYKD2ooNL[@06onnLYOo_U9coihbLonN<
U?oNQ8cogW^D0_oWS9@2onn<W007ooN]_OogW:gomib]ooNL[Ooo[Lkoooooonooo`3ooooooooooooo
>?ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H03oni^KWohn?Sooooooooooooc/k>ohb<S?oo
ooookno_omkNg_o6a/KoLf=[omK>c_oog_OomnO_ooOgm`02oooNm`06ooooooooiooomoOgoooooooo
g_OoonOo0ooog_L01_ooioooomkgoooNmooog_OomnO_oooNm`?oomK_0_ooa^L01?ooa]Kookg>oon]
a_og[Kd3ooNU]@04ooNL[Oo_W:gomib]ooNDY@;omib]00KooiB]onnLYOo_U9coihbLonN<U?oNNi@2
omj4S005ooN]_OogW:gokjfeooNL[Ooo[LH0oooooooooooooc[ooooo00?oi^KVon?Shoni^KT00_oV
i^H000?ok^k^00Ko^KVion?Shoooooooooooolk>c_n<S8`2ooooo`0BooOgmooNg]koU8b<oibDW?oo
ooooomkgooooooo_inoooooooooNmoogmoOoonOooooNmoooiooomoOgoooWooogmoOoonOo1?oog_L2
oooFk`03ooOFiooga^OoolkN00;oolkN00GoolKNooo6e_oo_MKoojg6ooN]_@02ooNU]@05onnLYOoW
W:GokiBUonnDYOo_W:D01_ogU:D02?o_U9coihbLonN<W?ogW;gomib]ooNU]Oo_[KGoojg6oooooooo
oooooc[ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00Ko^KVion?Shoooooooooooolk>c_n<
S8`2ooooo`04ooOgmoo_knoo[Jf]oibDW0?ooooo0_oog_L05?ogmoOoomkgooOgmooog_OooooooooN
moooooooomkgoooooooog_OoonOooooNmoogmoOoomkgoooFkoooinOoolKWooo>g_ooa]KomkgF0ooo
_Lh00oog_LKookg>oon]aP02ooN]_@05oonD[OogW:gokibUonn<W?oWS9@00ooWS9`01Oo_U9cokibU
onnDYOo_U:GomiBU00?omjFe00?omib]oon]a_ooool0oooooooooooooc[ooooo00?ohn?SokVi^Ooo
ool00Oooool000?ok^k^00co^KVion?Shoooooooooooolk>c_n<S8comoOgono_kooNg]koe]KFomkF
e_mJBU82ooooo`0AoooNmooooooooooooooNmoooooooonOooooooooog_OooooooooNmoogmoOoomkg
oooooooog_OoonOooooNmoogmoL00ooog_L01_oge^OoolkNooo6e_og_LkomkG6oon]aP;omjfm0_og
YKD2ooN]_@;omjFe00KokjFUonnLYOo_W:GoihbLonN<U?oNNi@3onN<U007onN<W?ogYKGomjFeooNU
]OogW:gomjfmooOgm`3ooooooooooooo>Oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H03Oni
^KWohn?Sooooooooooooc/k>ohb<S?oooooomoOgonOWiooFe]Koe/k>obTQ8OoWg^L00oooool00oog
knooonOoooooo`04ooooo`04oooNmoooooooomkgooooo`;omoOg0ooog_L4oooFk`05ooOFioooc]ko
olKFooNma_oo[LH00oogYKD01?o_W:gomib]ooNL[OogYKD2ooNL[@09oonD[OogU:GokiBUonnLYOo_
U9coihbDomikU?oWS9Comjfm00;omjFe00?omib]onnU_Oogknl0ooooooooooooocWooooo00?oi^KV
on?Shoni^KT00_oVi^H000?ok^k^00Ko^KVion?Shoooooooooooolk>c_n<S8`3ooooo`07ono_kooN
g]ko_KFeod8i>OoFc/kooooooooNm`0:ooooo`05oooWoooog_OoomkgoooNmoogknl00_ooe^l2ooOF
i`0;ooo6ioooc]koolKWooo>g_ooa]KoolK>oonmc_og_LKomjfmooNU]Oo_YJD00_oWW:D5onnLY@;o
mib]00?omiBUonnLYOo_W:D01OogYKD00oo_inooooooooooo`3ooooooooooooo=oooool00oo^k^ko
hn?SokVi^@02onk^kP000oooool01_ni^KWohn?Sooooooooooooc/k>ohb<S0?ooooo00WomoOgooO_
kooWinOoc/K6of=BF_m2@T;oLf=[oiBDU?oginl01Oooool00oooioooooooooooo`03ooooo`09oooW
oooog_OoomkgoooNmoooe^ooolkNooo>e_og_MKomlK>00Cookg>0oog[Kd2ooNU]@04ooNL[Oo_W:Go
ihbLonN<W0;oihbD0_oWS9`2onnLY@03ooNL[Oog[KgomjFe00;omjFe00?okjFeonOWioooool0oooo
ooooooooocWooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00_o^KVion?Shoooooooooooolk>
c_nDU9ComoOgono_kooWinOog]kNonOWi`02omkNgP;oinOW00Ooc/k>oibLW?m[Jf_oFTYBog=JHonL
U9cokmkN00;ooooo00SomoOgoooooooog_OooooooooWooogmoOoomkgooOgm`;oomkg00GoomK_oooN
moooa^OomkgFooNmcP02ooNmaP03onn]]Oog[Kgomjfm00Comjfm0_ogYKD00oo_W:gomib]onNLY@05
onN<U0;omjFe00Comkg6onnU_OooW;goolkFooooooooooooocWooooo00?ok^k^on?Shoni^KT00_o^
k^h000?oi^KV00Ko^KVion?ShooooooomoOgono_komcLg<2ooooo`07ooOgmooWinOoc/k>olk>c_o6
a/Koc/k>omKFeP03omkNgP08onONg_oNc]Ko]Jf]og=cLom:BT[oHe9Joib<U?oFa/h2ooooo`03ooOg
mooog_Ooomkg00;oomkg00[oonOooooNmoooe^ooonOWoooFkoooc]koolK>oon]a_ooa/komjFe1_og
W:d01oo_YJGomib]ooNL[OogW:gomiBUonnUYOo_U9`00_oWS9`01_ogYKGomjfmooNU]Oo_[KGomjFe
ooo6c_ooooooooooooliooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
00;ooooo00?oDTYBooooooooool00_ooool00oo_knooinOWomkNgP04olk>cP0AolK6a_oFe]Koe]KF
omkFe_oNg]koinOWomkFe_n]YJGoNg]koeY:D_mSDU[oS7^4olK6a_oog_OoooooooOFkooWg^L01Ooo
e^l01Oooa^OoolkNoonme_oo_Lkomkg600;omjfm00ComjFeonnUYOoWW:GoiibU0oo_W:D02oo_W:go
kjFUooNDYOo_YJGomiBUooNU]Oog[Kgomkg6onn]]OooW;goolK>0?ooooooooooooliooooo`03onk^
k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo00;ooooo00?o[Jf]og]kNoooool00ooo
ool01OogmoOokno_onOWiooWinOog]kN00;oe]KF00Koc/k>olK>c_o6a/Koa/K6olK>c_o>e]H2omkN
gP0@onOWiooWg^Oo_KfmohAcQ?mJ@U;oFT9:ohAcQ?nmW;GommKWoooFkooge^OomkgNooNmc_oo_MKo
olKNoonegP;ookgF01Gookg>oon]a_og[KgokjfeooNL[Oo_[KGokjFUonN<W?oWW:GoihbLomjDYOoW
S9cokjFUonnLYOogYKGomkG6ooNU]Oo_YKgomjfmooNma_ogmoL0ooooooooooooocWooooo00?ohn?S
okVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool00oooool01?mcLg?o_KFeooOgmoo_knl2
omkNgP;oinOW01Cokno_ooOgmoo_knooinOWomkWiooNg]koe]kNolkFe_o6c/koa/K6okg6a_o6c/ko
a/K6olk6c_oFc/kog]kNonOWiooWg^Oo_KfmoiBDU0;oHdYB00OoLeYSokFLW?o__MKoonOWooNmg_og
_Lkokjg>00;omjg600WomkG6oon]a_og_LKomkg6ooNU]Oog[Kgomib]onnLYOo_YJD00_oWW:D02OoN
U:GoihbDooNU]Oog[LKomjfmooNea_ooW;gomkg6oooNm`3ooooooooooooo>?ooool00oo^k^kohn?S
okVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`03ooooo`07onOWiomBBU;oooooooooooo_knoo
g]kNomKFeP02olk>cP03omKFe_oNg]koinOW00?okno_0_oWinL00ooNinOoe]kNomKFeP05olk>cP0<
omK>c_oFe]KoimkNonOWiooWg^Oog/kFoibDW?mcFV?oFSU2of]:F_n<Jg?okjfe0_og_LH01_og[Kgo
mjFeooNL[OogYKGomjfmooNU]@;omjfm00WomjFeooNL[OogW:gokibUonNLYOog[KgomkG6ooN]_Oog
[LH00_og[Kd00ooginooooooooooo`3ooooooooooooo=_ooool00ooVi^Kohn?SokVi^@02onKViP00
0oo^k^h00oni^KWohn?Sooooo`02ooOgm`;ooooo00?oBTY:ooooooooool00_ooool00oogmoOoinOW
omkNgP03omKFeP05olk>c_oFe]Kog]kNomkNg_oWinL00_o_knl00ooWinOog^OWomkNgP02omKNgP05
omKFe_o>e/koc/k>olk>c_oFc/h00_oFe]H01_oNe]KoimkWonOWiooFc/ko_KFeog=JH`;oLdYB00[o
U6]colJDW?oW[KGokjFmonN]]OoNU:Gokib]ooNU]Oo_[KGokib]0oogYKD01?og[Kgokjg6ooN]_Oog
]LH2ooN]_@03ooOWiooooooooooo0?oooooooooooolfooooo`03onk^k_oShn?o^KVi00;ok^k^0003
ooooo`03okVi^OoShn?ooooo00;ooooo00GomoOgoooooomSHf?okno_ooOgm`05ooooo`06ooOgmoo_
knooinOWonONg_oNg]koe]KF0_o>c/h01OoFc/kog]KFomkNg_oWinOoino_00Cokno_0_oWinL00ooF
g]koc]KFolK>cP03olkFcP07omK>c_oFe]Kog^OWomkWiooNg]ko_KfmohAkN`02oeY2BP04ohASJoo>
Q8cokib]onnU]@;okib]00[okibUonNLYOo_W:gomkG6onnU_Oog_LKomjfmoonL_Oog[KgokmkNoooo
ooooooooocWooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool00_ooool0
1_ogmoOooooooibLW?nU[JGoooooooOgm`?okno_00ComoOgoooooooooooooooo0_ogmoL01Oo_knoo
inOWomkNg_oNg]koe]KF00?oc/k>0_oNg]h00oogmoOoooooooOgm`03ooOgm`04ono_kooWinOog]kN
omKFePCoc/k>00?oc]KFolk>c_oNg]h00_oNg]h02_nm_KgoU8b<oeY2B_mJ@T;oNe9JojEcLooFW:Go
kjfeonNLYOo_YKd2oon]aP04ooNL_Ooo[LKomibmooo>g_oooooooooooolhooooo`03onk^k_oShn?o
^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo00Cooooo00CoinOWoe9:D_o_knoomoOg0_ooool0
1Oo_knooimkNonOWioo_knooinOW00;omoOg0_ooool2ooOgm`;okno_00Oog]kNonOWiooFe]KoU9BD
of=SHon<S8coe]KF00Gooooo00KomoOgono_koo_knookno_omkWiooFc/h3olk>cP04olK6a_o>c/ko
e]KFolkFeP;oinOW00coe[g6oib<U?mcDU[oHcTiof]2B_nLJg?oaYbUonn]a_og[LKomkg>onn]c_og
_Lkooooooooooooo>?ooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`05
ooooo`05omKFe_mBBU;oYJFUolk>c_ogmoL00_ooool01?o_oooomno_onOWiooWknl3onOWi`0@ono_
koogmoOomoOgooOgmooooooomoOgono_koogmoOoooooomkNg_nLW9coQ8B4of=SHon4Q8Co_Kfmono_
k`;ooooo0_ogmoL01Oogknooino_onOWiooNg]koe]KF00;oc/k>00Koc/K6okg6a_nma/Ko_LK6olk>
c_oFe]H3omkFeP07okFLW?nLQ8coLe9Jof]2B_n<Hf_oaYbUoooWi`3ooooooooooooo>?ooool00oo^
k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`02ooooo`03ooOgmooooooomoOg00;o
oooo00Ookno_okfm_On<S8coLg=cohb<S?nm]KGoinOW00;ooooo0_ogmoL2onOWi`;og]kN0_oWinL3
ooOgm`;ooooo00[omoOgooooooooooookno_okfm_On4Q8CoHf=Sog]kNonm]KGoe]kN0_ogmoL04?oo
oooomoOgooOgmoogmoOokno_omKFe_oFe]koc/k>olK>c_nma/Ko_Kfmokg6a_o>e/ko_LK6omKFe_og
moL2ooooo`03ooO_koo_inoooooo0?ooooooooooooliooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP07okVi^OoShn?oooooooooooogmoOoooooooOgm`04ooooo`0:ooOgmoooooooooooooooooo>
c/koW9bLog]kNon4Q8CoYJFUomkNgP;ooooo00KomoOgonO_kooWinOokno_omkNg_o_knl:ooooo`03
ono_konm_KgoS8b<00;oLg=c00CoYJFUolk>c_o_knookno_0_ogmoL01ooWg^OomoOgonoWkooNg]ko
e]KFolK>c_nma/H00_o6c/h00oo_ooooooooooooo`3ooooooooooooo>oooool00oo^k^kohn?SokVi
^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`05ooooo`03ooOgmooooooooooo00Cooooo00KomoOg
ooooooooooooooooomkNg_nUYJD2og]kN`06oibLW?o>c/kokno_ooOgmoo_knoomoOg3_ooool02Oog
moOoe]KFoibLW?mcLg?oJf][oiBDU?nm_KgoinOWonoNgP02ooO_k`07ooOWkooWinOog]kNomKFg_o>
e]Koooooonooo`02ooooo`03onoooooooooooooo0?oooooooooooolgooooo`03onKVi_oShn?o^KVi
00;oi^KV0003onk^kP03okVi^OoShn?omoOg00?ooooo00?omoOgooooooooool03_ooool01Oo_knoo
_KFeohb<S?o6a/KomoOg01Cooooo00Oog]kNojFUYOn4Ng_oHf=SohAkNon][Jgoe]KF00;okno_00?o
knO_onO_koogmoL01?ooool00oogmoOoooooooooo`3ooooooooooooo=_ooool00oo^k^kohn?SokVi
^@02onk^kP000oooool00oni^KWohn?Sooooo`02ooooo`03ooOgmooooooooooo02cooooo00Kokooo
okg6_On4Q8CoHf=Sof]cJoo6a/Kooooooooooooo@?ooool00ooShn?o^KViooooo`01ooooo`000oo^
k^h00oni^KWohn?Sooooo`3oooooooooooooM_ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H0
0oni^KWohn?Sooooo`3oooooooooooooM_ooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni
^KWo`l?3ol?3``3ool?3`ooo`l?3N?o3`l<1okVi^@7ok^k^0Oo^k^h000?ooooooomlO7coogalO7co
O7al0_ooool00?ook^k^ooo^k^j1onk^kP00oooVi^KoonKViX7oi^KV003oonk^k_ook^k^POo^k^h0
0?ooOgmoE_moOgl7oginO_ooOgmo9?moOgl00004on_[jooVi^Koh^;RomkNgPCogMgM0ooNg]h0oooM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMg@00
4ooNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oMgMd00_oLg=`0?OoKfm_ogMgMomcLg?oNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomgM
gOoKfm_of][JomOGeooHf=SoemOGom[Jf_oKfm`00_oMgMd09ooNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNgP03omgMg@3ZomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM1?oN
g]h00ooMgMgog]kNomkNgP03omgMg@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>001ooIfMT0
1?oHf=Soe]KFom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooCdm?o
d=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=00Cod=3@
om?CdooGemOof=SHf_oIfMT2omSHf006omKFe_oCdm?odm?ComCDe?oGemOof=SH0_oIfMT00ooHf=So
fMWIomWIf@02omSHf0WofMWI00?of=SHomWIfOoIfMT00_oHf=P00ooIfMWof=SHomSHf002omSHf1Oo
fMWI00Cof=SHomKFe_oBd];oclo?0_o=cLd01?o?cloodm?ComOGeooHf=SoomWIfAKofMWI00?of=SH
omWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;R
hP02on7Qh@0=omkNg_oLg=codm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoO
g`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoO
g`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoO
g`3Ion7Qh@09on3Ph?oOgmoofm_KomKFe_oDe=Coe]KFom[Jf_oNg]koh>3P00KogmoO0ooPh>000ooO
gmooh>3Pon3Ph002on3Ph0SogmoO0_oNg]h2omoOg`?oh>3P0_oOgml2on3Ph0;ogmoO3OoPh>001OoO
gmoogMgMomWIfOoEeMGodm?C00;od];B00?oe]KFomcLg?oPh>00oooQhN4Hon7Qh@03on;Rh_oQhN7o
h^;R00CohN7Q0OoTi>@1onWYj@7okNg]00000oo`l?3okno_oo7al@03oo3`l03oono_koo`l?3ok^k^
onWYjOoKfm_o`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7a
ono_kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2`_nTY:CoS8b;og]kNomgMgOoNg]k
ohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo7alOo_knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Z
om[Jf_o2`/;oY:BTohb<S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]kOoalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_000Ooo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_koo`l>kokNg]onc/k?oUiNGoh^;RomoOgooUiNGojNWYong]j`02onSX
j006onKVi_oYjNWoinOWon_[joo/k>cok^k/0ooZj^X02Oo_knook^k^onk^k_oXj>Soj>SVonKVi_oY
jNWoinOWon[ZjP02onWYj@0=onGUiOoWinGoinOWon_[joo/k>cokno_on_[jooZj^[ojNWYonk^k?o/
k>cojn_[onSXj002ong]k@0Donk^k_oZj^[ok>cZonc/k?o^k^koj^[Zonc/k?o]kNgok^k^on[Zj_o/
k>[ok>c/onk^k_n][JgoMgMgoeUIFOm_Kfoo][Jfon7Qh?oWinL2ono_k`3ooo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aonk^k_oalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a000Mono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`l?o_knl01?o`l?000003oo;bl_o^
k^koinOW00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmV
IVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@00ooUiNGoi>CTonGUi002onCTi00?omkNg_oAdM7o/K6aohZ:
R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT0?KoiNGUonCT
i?oUiNGoi>CTonCThooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7oIVIVohZ:
R_na/K7odM7AomkNg_oTi>?oi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCohn?SolK6a_lX:2SoADE5ohn?
SooBd];ofm_KomcLfooFe]H3omGEe@0IomCDe?oJf][ogmoOomoOg_oIfMWoeMGEomSHf?oOgmoohN7Q
omgMgOoFe]KoeMGDomCDe?oEeMGoe=CDomWIfOoJf][of=SHomGEeOoFe]Goe]KFomWIfOoMgMgoh>3P
om_Kf`02omKFeP09omgMg?oLg=cof=SHomGEeOoLg=coh>3PomoOgooJf][ofm_J00;ogMgM0?oofMWI
omcLg?oOgmooh>3Pom_KfooJf]WogMgMon3Ph?mcLg?oJ6QXohf=SOmDE5Co20P8oj>SX_oKfm_ohn?S
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>@002Go
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU00;oi>CT1?oUiND01_oTi>CoiNGUonGUiOoUiNGoj>SX
ong]k@7ol_;b00000oodm?CokNg]onOWi`02on3Ph00Con7QhOoOgmoog]kNom;Bd_nd];CoQhN7oeaL
G?m]>cGoWTi2ole_GooYPfoocFmOoii>@om]>cKoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomkN
g_oBd];o];BdohN7QomLG5coKF0/oijF;_o=cCoojNU=olg=?onNVRooKF<]oeaLG?n7QhOo];Bdom;B
d_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLodMW;_mXWS?oTLe7oj[YEOnAcDOoJYhdodUZ
;omLG5coQhN7okBd]?oBd];og]kN0=Soh>3P00KogmoOolo?conIVIWoTY:BoaTI6On<S8`2omGEe@0O
olo?coo2`/;oc/k>olk>c_o5aLGob/[:om[Jf_oHf=Sod=3@ol_;boo?cloof=SHom[Jf_oEeMGoclo?
ol71`Oo@d=3oc/k>olC4a?o;bl_of=SHomOGeonn_[ko^k^kom7AdOo@d=3oeMGEomSHf?oCdm?oc<c<
olk>cP02omGEe@05olk>c_o<c<codm?Com[Jf_oHf=P00_oBd]801?oHf=SoemOGom7AdOoCdm<2omWI
f@06om?CdooAdM7oemOGomSHf?oAdM7od=3@0_oAdM401?m6ATKo@D51omOGeooNg]hXon3Ph003omoO
gooPh>3oh>3P00?oh>3P00?ogmoOon3Ph?oPh>00i?oPh>000ooOgmooh>3PomoOg`02omoOg`?oh>3P
00?ohN7QonOWioo/k>`00Oodm?@00003ooKfm_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgoWinO
of]OGon?=RkokG5QooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=cOoRh^;oinOW
00?oj>SX01?oinOWon;Rh_o=cLgoWinOofiVGonCLR;okM54ooWcM?omoHgooOfEoogmS_oin7KokMM7
oi=c8_m^IeooWinOolg=cOoRh^;oinOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOof1XGom;O2?oT^5;
okgiNoo@oI;of?fKomCmUOo0nGkoV>Q=odf09?mPJEooWinOolg=cOoRh^;oinOW0=Woj>SX00Coi^KV
on7QhOmMGEgoCDe=0_oMgMd07om@D53o1`L7oaDE5On4Q8Co5QHFod=3@ooRh^;ogMgMoibLW?l0003o
Shn?omgMgOoQhN7ofm_Kod10@?l820So6ATIohR8R?l;2`_oF5QHokNg]ol<30co1`L7ob<S8olW9bOo
OGemom[Jf_oMgMgoe=CDo`/;2omIFET00_oIfMT00omMGEgo2`/;om?Cd`02omoOg`06oeYJF_m>CTko
g]kNomkNg_lS8b?oQ8B40_oQhN403?mjNW[o;Rh^omgMgOoMgMgo`/;2oe1@D?lc<c?oKVi^oh>3PolQ
8B7og]kNonKVi_ooj>SX7ooXj>P1onc/k07ol_;b0Oofm_H00003ooOgmoohn?Son?Sh00?on?Sh01?o
moOgonk^k_o>c/koT92@ohD_:ooYI5Koni:7oojVVoon/JGookR[oojcY_onZ9coniB9oniXFOn9<B_o
T92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@oiUY:oo`_Cgonn1^ookdP_onoX[o
oonBooknS?onn8?onnE`oo32?_nIJR_oT92@olk>c_o^k^komoOg00?on?Sh01?omoOgonk^k_o>c/ko
T92@od9c:on4cT?o[Nmcol;nR?o>oY3oe_nGom3nT_o6oXWo/_EdohSC@om4MB_oT92@olk>c_o^k^ko
moOg0=Won?Sh02Gom_Kfoo7alOn1PH7o7alOong]kOo6a/Ko0000ol?3`ooCdm?oG5aLo`P82?oZj^[o
l?3`on[Zj_mBDU;o51@Docdm?OoYjNWol?3`ojn_[ol71`Ood];Bolg=cOm>CTko6a/Konk^k_oKfm_o
[Zj^onSXj?o/k>co[Zj^o`000?nd];Cok>c/ok2`/?l;2`_o6QXJ00;oi>CT00_o8b<So`h>3_nTY:Co
kNg]onk^k_mPH63oE5ADonk^k_o]kNgo9RHVohf=S@02oo3`l00<oh:2P_la<C7ok>c/on[Zj_m3@d?o
;bl_oibLW?mcLg?o:RXZoaXJ6_o^k^kom_Kfooohn?PHooShn003ooOgmoohn?Son?Sh00;on?Sh00Co
moOgooWinOogmoOomoOg0Oohn?P00003oo[jn_oemOGok^k^00;ok>c/0?oojn_[onWYjOoOgmoo^[Zj
ogUBD_no<RCoigAYoof9O_ooV8cooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<TogUBD_nj^[[ogmoO
on[Zj_o[jn_ok>c/on_[k?oZj^[ogmoOokZj^_n8IE;ohY4LooW3D?omfV?oonYbookcO_oonX;oo_Io
ooo/LoongVCon/MAon:B7?n9IU?o^[ZjomoOgooZj^[ojn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeB
oe6S7?nAdUGoY^MZokSiN_o0oX;oaon9ol?nQ?nioG_oYna/oiCFEomBYQcoDVeBokZj^_oOgmooj^[Z
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jn`004Cok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[jooZj^[oi>CTogYjN_lL71coh^;Rol_;c?l30`?o
WinOomoOgonDU9Co4a<Con3Ph?oQhN7od=3@o`H61_nQXJ7o2@T9okjn__oRh^;o^KVio`820_na/K;o
g]kNoh20P?lY:BWoh^;RonSXj?oTi>CogmoOom[JfooDe=Co20P8ohJ6Q_oOgmooJVYZodU9BOle=CGo
[:b]okjn__l71`OoN7QhoeEEE@;ogmoO00KoFe]Kodm?D?oRh^;oh>3Pob@T9?n4Q8@2on3Ph03oog]k
Nol_;boohN7QomCDe?l51@GoYjNWonCTi?oRh^;oOgmooaDE5_oRh^;ojNWYonc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/000R
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k0Kojn_[00Gok>c/on_[joo[jn_ok^k^ooKfmP01ooWin@0000?ono_koo?c
loo]kNd00_oUiND0oooVi^Koi>CTomWIfOnb/[;oNBh^olQ2=?oSJUcom7Y]oof8O?onUh[ooY^>oojH
RoonRWkom7]]onM[GOo:@SCoNbh^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGVonCTi?oHf=So/[:boiIE
;_oZW2_onka4ook<Doomf6;oo^=bookYMOoniW?oo]]Uoog<Dook`DGokYh[oiUF;_nb/[;of=SHonCT
i?oUiNGoi^KVonGUiOoTi>Cof=SIok:b/_l^HRkoHjd[ohO:B?nGg5WoYNEYok;cMonhmW_o]?EiojOZ
JonHg5WoRLm;of>^:ol^Hbko/[:bomSHfOoTi>CoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUiP009OoVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onCTi?oNg]koMgMgoa/K6ooLg=coh>3QoijNW_l^;Rko:b/[oc8b<_lB4Q800_oKfm/09On4Q8Co8B4Q
omoOgomCDe?oIfMWom_KfooMgMgoT92@obTY:_l_;boo;2`/obPX:?oMgMgogmoOomSHf?oDe=Coclo@
oe]KFol0003o_[jnomWIfOlX:2SoQXJ6ogQhN?mXJ6SoPX:2oc`l??o3`l?o3`l?omGEeOoIfMWoFEUI
odi>C_oMgMgog=cLob<S8on1PH400_oFe]H0>_mgMgOo;Rh^omgMgOnRXZ;o0000olK6a_oIfMWof=SH
ohj>S_lE5AGogMgMon?ShooVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oTi>D2onGUi@3TonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^Ko
iNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU0ooVi^H00ooUiNGoi^KVonKViP03
onKViP03onGUiOo]kNgom?Cd007on_[j00000oolo?con?Shoo7al@03onk^kP0Con_[jooQhN7o_;bl
ogXG5oo3?c;odeI9onAXF_o_Mfcom8=iooR7O?oeQ7[olgU]onEYFooIF4[oa3lbog`G5onl_;cohN7Q
onc/k003onk^kP0Conc/k?oQhN7o_;blojE75ooVUc;omJ``oofl@OombE?ooM1Poo_CIOomdV3oo/eD
oofm@_oj[c;ojI/bojE65onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;bloaMI5omOZ3;oM[dg
ohK=AonFeU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg_cOoGj/boaMI5onl_;cohN7Qonc/k03Ionk^kP0^
onc/k?oWinOoNg]koa`L7?oTi>CojNWYonKVi_oQhN7og]kNohf=SOlD51Coi^KVonCTi?le=CGoNGUi
on_[jonb/[;o5ADEomoOgooVi^Koi>CTon7QhOoMgMgoNWYjobTY:OoXj>SoiNGUomgMgOna/K7o9RHV
o`/;2onKVi_ojNWYolc<c?l0003oc/k>ol?3`olU9BGoBd];ogalO?oXj>So<C4aojFUYOoTi>CoGEeM
oe5AD@;oinOW00[o9BDUofUYJOoOgmoogmoOogMgMola<C7ojNWYol71`Ol0003oYjNW0_oOgml01?nC
Ti?o5QHFonOWioo/k>coonk^kQkok^k^00?okNg]oo;bl_ohn?P00Oolo?`000?ooOgm01Koo?cloogm
oOomoOgoo?cloo?clooAdM7oJ0L7okPd=?o7?c?odU13omYREOoSKV;oi79TonA_H_oLI5Oode53ola1
=?ni=3CoJ`L7om;Bd_oclo?oo?cl0oomoOd04oolo?colo?com;Bd_nN:`OofXXdon^K6OoeZ2Won;@o
ooVmB_oh_dgon[m:ooVh?oofZR[okihIom^;=?nR;@Ood];Boo?cloolo?`00oomoOd04oolo?colo?c
om;Bd_l7@0OoCIXdoen[8?m`^2ooOl=3oh[=D?n=cE;oR/i@oh77A?ma^BooHZhPodjK=?l7@POod];B
oo?cloolo?`0fOomoOd08ookno_omoOgohB4Q?lN7Qkolo?cooWinOnc/k?od=3@oo?clomXJ6SoAdM7
oo[jn_oDe=Co0000omgMgOolo?cono_kobLW9onXZ:SonOWioj^[ZooEeMGolO7aoeADE?mNGUkonOWi
ooCdm?nDU9Co1@D5od10@?oAdM7omoOgooShn?nGUiOo:b/[00;on_[j01_o92@To`L71oo8b<Sono_k
ohF5QOmSHf?omoOgof=SHomGEeOon?ShooWinOlW9bOo5ADEoh>3PooGemOo@T92of=SHookno_on_[j
oc@d=?m9BDWofm_KonGUiOm?Cdoo5aLGoo[jn_olo?`0ooomoOdLoogmo@03ooclo?omoOgoo?cl00?o
oOgm0000>_omoOgon_[joo?cloo^k^kol?3`ono_koo^k^kojNWYom?CdomK7AgoXS@dok@X7Oo1>Rgo
adTlolmFB_o@Ed_od5M:olY:?_o3>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>oo
k^k^on[Zj_oCdm?oS2DMolQa=?oIQ1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/X2GoiiLEomb87Oo8LCCo
S2DMom?CdooZj^[ok^k^oo3`l?o_knool?3`onk^k_oZj^Wodm?Coadh7OldPSCoAiDMoeZU6omY[BX2
ogBh>03oogFi>?m[/B_oFjLLodRJ7OldPSCo7CPMom?CdooZj^Wok^k^oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o^k^kojn_[ogemOOlL71coinOWonk^kOn8R8So<30`o`h>3_la<C7o/;2`ono_kon4
Q8CoCDe=onk^k_o_knook^k^ohZ:R_mIFEWokno_ogQhN?l/;2_o3@d=ocPh>?nn_[kok^k^on?Shol>
3PkoJFUY000:on3PgooRh^;oi^KVon[Zj_mQHF7oMWIfono_koo^k^koMgMfobHV9P;ok^k^01KocLg=
ob`/;?o[jn_oK6a/of=SH_o[jn_ok^k^ocXj>_nDU9CoHV9Ro`h>3_ld=3Coa<C4onk^k_o_knoodM7A
oc`l??l:2P[o9bLWofa/K?l/;2cok^k^0_o_knl0ooo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l0005?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`0_o_knl2
oo3`l0Kokno_0Ooclo<1ooWin@7oo_kn00000oono_komoOgoo3`l004onWYj@0AonOWiooKfm_oHd];
oh4b<_nV=CGo]S@]ol9=@Oo3E4Woa5E:ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooWinL01OoY
jNT04OoWinOofm_KohU;Bon_Bc;ocGLeomJ;;OoPW2koh:0bon6P=?oPX3;ogiX^omJ;;Oo:MCGo[d/b
ohU;BooKfm_oinOW00GojNWY017oinOWom_Kfom;Bd_o<V0bocZ9=OmCVbgoJj/_og2]>?m_[S[oL:dh
ofZZ;omCVbgo>HPeoc9P<_m;Bd_ofm_KonOWi`3JonWYj@06onSXj?oVi^KoNg]koa`L7?oTi>Coj>SX
0_oYjNT00ooWinOojNWYonWYj@0;onWYj@0<onOWiooYjNWojNWYonSXj?oHf=So2PX:ojj^[_oMgMgo
g]kNon3Ph?oUiNGoj>SX2?oYjNT01_oXj>Soi^KVon?ShooShn?oi^KVonSXj0?ojNWY00?oj>SXonWY
jOoYjNT01?oYjNT00ooWinOojNWYonWYj@0[onWYj@03onSXj?oYjNWojNWY0>cojNWY00?oj>SXonWY
jOoYjNT01?oYjNT1oo3`l07om_Kf0Oono_h00005ookno_ojn_[om?Cdono_kooalO400_o`l?004Oo_
knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZNW?oIW9coe9FEok]cLonEE5CoCb<SoiFDU?oZ
j^[okno_00Gol?3`017okno_on[Zj_nYU9CoPB<SokYZE?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoD
VW?o^fYDoh4S8onZU9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCoLjEcoik6UOn/
cYco[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Zj_o_knl0f_o`l?02ono_k`04oh20P?lM7Ago
k^k^ono_ka?ol?3`0_o_knl01omTI6Co:BTYoh61POmSHf?o>c/konk^k_o_knl02?o`l?001_o_knoo
k^k^og=cLomYJFWok^k^ono_kckol?3`00?okno_oo3`l?o`l?00joo`l?001?oalO7ol?3`ooCdm?oj
n_X1ooknoP0000CooOgmooooooooooooo_kn0_ooool2ooknoP3ooogmoOohn?SoKVi^oeXo?onaT93o
g/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSloofe]KOohn?Soo?clooooooono_koooooookno_ooooko
o_knooooooolo?con?Shohe]KOn:?coobI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo?on=KFgo
n?Sgooclo?ooooooo_knooooooono_koooooookno_ooookoo?clooShn?m]KFgo?clooi2MT?o9eLWo
i>cTonK^i_oTk>CobMG9oi2MT?lo?cooKFe]ooShn?olo?coooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn000Gooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooool00_ono_h06?o?clooYZJVoogmoOooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooo`;o
o_kn00ko`<30og5aLOn0P83o/;2`oogmoOooooooo_knooooooono_koooonookno_ooooooo_knoooo
o`;oo_kn0?oo`L71okfm_?omoOgoooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_h002Woooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooo`02ookn
oP05ooooooono_koooooooooooono_h01Oooool1on_]k`0000ComOKfookno_oinOWom?Cd1OoalO40
3Oo_knooe]KFof][Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?CgoJf][omKFe_o_knl02OoalO40
3Oo_knooemKFoh=[Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<S?mb?CgoPF][omOFe_o_knl02OoalO40
3Oo_knooe]KFof][Jolm?CgoS8b<okZj^_o<cLco^[Zjohb<S?lm?CgoJf][omKFe_o_knl0oooalO55
oo7al@03oo3`l?oalO7olO7a0>[olO7a00Col?3`oo7alOoalO7ol?3`1?oalO400oodm?Con_[jookn
oP01oko5c00000Goi^OXoogmoOohn?Sol?3`on_[j`03on[ZjP0=onWYjOoZj^[ojNWYonSXj?nKVi_o
FEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoX9^KofYIFOm39RKo
;@T9od8V9_mYFEWoX9^KonSXj?oYjNT02ooZj^X02ooYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKo
FEUIoi^KVooXj>SojNWY0?ooj^[ZoooZj^Xkon[ZjP04on_[joo`l?3on?Shoogmo@7oPH^E00001?nm
_[oonO[joo[jn_oclo<8oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;ol?3`3ooalO42
oo3`l0?okno_0_o`l?3ooo7alOoolO7a>OoalO400oo`l?3olO7aoo7al@02oo7al@03ooGemOojn_[o
]kk3007o<d5<00000oo9b/_oaLK7oo[jn`3oooooooooooooNoooool1okVo``7oCEMP0OlN;3X00006
oa8M9_lA6B7o:30gogMnPonh_;oojN[[ooooooooooooogGooooo00Goj^c]okc2a_mmQXko<3]5oa/X
<`01oal_>`00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{639, 481},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(s0 = 
      JavaNew["\<java.lang.String\>", "\<Apple\>"]\), "\[IndentingNewLine]", 
    \(s1 = 
      JavaNew["\<java.lang.String\>", "\<MacOS X\>"]\), \
"\[IndentingNewLine]", 
    \(s2 = 
      JavaNew["\<java.lang.String\>", "\<PowerMac\>"]\), \
"\[IndentingNewLine]", 
    \(s3 = 
      JavaNew["\<java.lang.String\>", "\<QuickTime\>"]\), \
"\[IndentingNewLine]", 
    \(s4 = JavaNew["\<java.lang.String\>", "\<Java\>"]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.lang.String"] \[RightGuillemet]\),
      JLink`Objects`JavaObject1064959588958209]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.lang.String"] \[RightGuillemet]\),
      JLink`Objects`JavaObject30295793957076993]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.lang.String"] \[RightGuillemet]\),
      JLink`Objects`JavaObject15488468817805313]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.lang.String"] \[RightGuillemet]\),
      JLink`Objects`JavaObject16613284715167745]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.lang.String"] \[RightGuillemet]\),
      JLink`Objects`JavaObject38612863287297]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(h0 = 
      JavaNew["\<javax.swing.tree.DefaultMutableTreeNode\>", s0]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.tree.DefaultMutableTreeNode"] \[RightGuillemet]\),
      JLink`Objects`JavaObject6163059965953]], "Output"]
}, Open  ]],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(h11 = 
      JavaNew["\<javax.swing.tree.DefaultMutableTreeNode\>", s1]\), "\n", 
    \(h12 = 
      JavaNew["\<javax.swing.tree.DefaultMutableTreeNode\>", s2]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.tree.DefaultMutableTreeNode"] \[RightGuillemet]\),
      JLink`Objects`JavaObject140522488332289]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.tree.DefaultMutableTreeNode"] \[RightGuillemet]\),
      JLink`Objects`JavaObject45721067716609]], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(h0@add[h11]\), "\[IndentingNewLine]", 
    \(h0@add[h12]\)}], "Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(h21 = 
      JavaNew["\<javax.swing.tree.DefaultMutableTreeNode\>", s3]\), "\n", 
    \(h22 = 
      JavaNew["\<javax.swing.tree.DefaultMutableTreeNode\>", s4]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.tree.DefaultMutableTreeNode"] \[RightGuillemet]\),
      JLink`Objects`JavaObject7456549765121]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.tree.DefaultMutableTreeNode"] \[RightGuillemet]\),
      JLink`Objects`JavaObject66040239226881]], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(h11@add[h21]\), "\[IndentingNewLine]", 
    \(h11@add[h22]\)}], "Input"],

Cell[BoxData[
    \( (**) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(icon1 = 
      JavaNew["\<javax.swing.ImageIcon\>", 
        StringJoin[$JavaSwingMaterial, "\<file.gif\>"]]\), "\
\[IndentingNewLine]", 
    \(icon2 = 
      JavaNew["\<javax.swing.ImageIcon\>", 
        StringJoin[$JavaSwingMaterial, "\<0_red.gif\>"]]\), "\
\[IndentingNewLine]", 
    \(icon3 = 
      JavaNew["\<javax.swing.ImageIcon\>", 
        StringJoin[$JavaSwingMaterial, "\<3_green.gif\>"]]\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject82720264814593]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject74635374755841]], "Output"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.ImageIcon"] \[RightGuillemet]\),
      JLink`Objects`JavaObject3665687478273]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(tree = NewJTree[Null, h0, icon1, icon2, icon3]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JTree"] \[RightGuillemet]\),
      JLink`Objects`JavaObject113966269333505]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(scrl = NewJScrollPane[pane, tree]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "javax.swing.JScrollPane"] \[RightGuillemet]\),
      JLink`Objects`JavaObject50010985070593]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(JavaShow[frame]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Selected Path", "Subsection"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:90001jaP00`40o`00
0?l0003oo`000?l0002;000000000hS0^4R@R4R@R03oB928odR@R8M8T8P1
000000000hS0^<SPf8S0^03oR<2hohS0^8J8`;P1B9280@00000000>8`;S8
h=R8`;P0ohS0^?n8`;R6R<2h0DR@R04000000005R<2hb>3HR<2hR<2hc<c<
0?ooooooooooP_ooo`:8`;P1B9280@00000000J8`;S8h=R8`;R8`;QVIVK<
c<coIVIVofIVIX1VIVH01?ooohS0^8S0^4R@R04000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
ooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV0?ooooooooooP?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV027oool00nogmooo
onogm`02oooo00?_moOoooooool00_ooo`03koOgooookoOg00;oool00nog
moooooooo`3oooooooooodgoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP0Koooo00?_inOgmno_inL06noWi`04e]KWknOW
knOWe]KW1^oWi`03koOgoooooooo0?oooooooooo>_ooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01[oool03_OgkmkNg/k>
g[fm_KFmc/k6]KFmc/k6]KFmc/k6]Kfm_KFmc/k6]KFmcP>m_Kd01lk>c[fm
_LJm_KFmc/k6]LJm_KFmcP02_Kfm00G6_Kfe_Ljm_Kg6_Kfe_Lh00kfm_@09
c/k>_Kfm_Kfma[fm]Kg>_Kfmc/k>c]KNknOW0?oooooooooo>oooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01[oool01MkN
g/k>cZf]YJf]YIbLY@0AW9bL00>LW:F]YIBLW:D00YbLW007[JFDW9bUW9bL
W9bL[JfUW9bLW9bU00:LW9`00jf]YIbLW9bLW002[JfU00?>c/kNg]k_moL0
ooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH06_ooo`03knOWg]kNoooo02Koool2g]kN00?_inOoooooool0
oooooooooolhoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH06_ooo`03g]kNc]K>oooo01?oool00oOgkoooooooo`02oooo
00GWkoOoooooooooooo_inL00_ooo`03knOWooooinog00;oool01>ogmooo
onOWg/k>c_oooooooooo>oooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV01Woool00nO_mnOWg/kFgP02oooo00?_moOooooo
ool02oooo`03koOgoooooooo00?oool00nO_moooooooo`0:oooo00O_inOo
oooooooooooNg]k>e]k_inL0ooooooooooljoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06_ooo`03g]kNg/k6oooo017o
ool00nogmoooooooo`02oooo00?gknOoooooool00_ooo`04inogoooooooo
inog1Oooo`05knOWooooknOWc/k>koOg0?oooooooooo>_ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01Woool00oOgknON
g/kFgP0>oooo00?_moOoooooool01?ooo`03moO_oooooooo00[oool00nog
moooonO_m`02oooo00?Ng]k>e/k_inL0ooooooooooljoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06_ooo`03g]kNc/k>
oooo00?oool02^oWilk>c^oWinogmoooonO_moooonoWilk>c^oWi`;oool0
0nogmoooomkNgP05g]kN00KFc]J4Ng>LJf>]Nf?>_JFDS8`2[G]S00Zm_Kg>
a[GNg/k>a[Fm_JgWkoOooooNg]k>c/k_moOooooooooooc[oool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0Joooo00CFe^ON
g/koooo_inL2_Kfm00G>c/jLW9b]]KG>c/k_moL00Zf]Y@:LW9`07Hb<S;fm
_Jf]YNoWioooonOWg^oWioOgknoWioO_inOWg]k>aU9:@W/@28@H4:ekHiA2
<G<H49`a8LjUQ=kNc^oWc]kNc/k6]NoWioooomkNg/kFg^oWi`3ooooooooo
oc[oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP0Ioooo00?gmnoWimk>e]h00_ooo`03e/kFg]kNknOW00;Ng]h01noWiooo
omKFinoWilkFc]kNg[fm_@02g]kN0_ooo`0Hc/k>Q9BDW9bUW9bLNhB4Jg=c
FV][BQPHLaP@W34QQ3TaHaPHQ24HYG=J[G]SW9bUW8AkU8aS[KFemoO_oooo
knOWc/k>koOgooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH06_ooo`03e]KWe/kFoooo00Ooool00nogmooo
ooooo`02oooo00?WkoOoooooool00_ooo`0>g/k6S8b<S8b<Jf][S8b<[JFD
Jf][DPP8Jc4YW34Q[G]SQ1P@Q24HJc4Y0TYBFP08FUYJDTY2Jg=cknOWoooo
g]kNc]KNknOWooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH06_ooo`05g]kNc]K>oooomnoW[KFe00:m_Kd0
1kFmc[fm[NoWilk>cZf]YNoWijfe]@02_Kfm01?Ng]je_Lk>a[Goooo>e]jm
_Kf][JFLU8b]YIC>a[EkLf<H411B20R]Nf><JdZ48AQk<BUB>C4Y:BT00cTi
<@06FUY2knOWooooinONc/k>koOgooooooooooljoooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06Oooo`0]koOginONc/k>
ooookoOg_Kfm[JfUc/kNc/Jec/k>knOWc/k>_KfmknOW[JfU_Kfmc/k>g]kN
c/k>[KFeoooog]k>_Kf][JfUW9bL[Ib4c[fULf]S8AP@DTY2Hd8iBS4YDSTa
DSTYNg]kNhB4FUYJBU8iBTXaBU8iknOWooooe]KWc]K>knOW0?oooooooooo
>_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
01[oool02=kNg/kFg_ooooooonogmoooonoWinO_m`Goool00nogmooooooo
o`02oooo00W_inOoooo>c]jm_Jfm_KfDS8acLeZ]W8AcJf<00U8i<@0?@RTQ
DSTaFT8iDSTaS8acS8b<Ng]kJf=BJf]:FV=JknOWooooinONc/kNmoO_0?oo
oooooooo>_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV01Woool2knOW00?Fc]Koooo_inL00/k>cP09W9bU[JFD]Kg>c/Je
g]kNc]KNc/k>g]kNc]KN00;>c/h03<Jm_LkFg_ooolk6]Hb<S8b<LeYJ@Xb<
S<k6]G=[He9:@S4H409B>C4017=JDU8i<EYJ@W]cH`9[JdX01eYJ@V][B^oW
inogmnoWilkFc^oWi`3ooooooooooc[oool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP0Joooo00KNg]k>e/kooooooon][JF]
]KD4_Kfm00KNg]jm_Kg>a[G>e]k>a[F]]KD2_Kfm016][JGooon]]KE:BTYB
BT9[He:<S7>LQ7]JFUYB>BU2:B5[BT9JFT9cFU9SFTXY:APi>AP00UYB:@06
>CTHNf=:knOWoooog]kNc/k>oooooooooolkoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06Oooo`06koOginONc/k>oooo
koOgknOW2Oooo`0NknOWinONooookoOgknOWoooo[JfU:C4Y:BTHBTXY[JFD
a[fm>CTa@RTQDSTaDTY2NeY:Jf=BFT8i:BTHBS4YBTXYLg=JBS4YDV=2e]KW
ooooinONc]KNknOWooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH06_ooo`0:g]kNc]KNooooknOWc]KNg]kN
c/k>g]kNc/k>knOW0/kFgP0PknOWg]kNc]KNc/k>e/kFknOWc]KNkoOg[JFD
0000:BTH>B4HW9B<c/J]Ng=S:BTH@RTQ[G]SU6]JJc4Y>CTH:BTH<CTQBTXY
BTXa>CTHBTXaknOWkoOgknOWc/k>koOgooooooooooljoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06Oooo`0]koOgknOW
c/k>oooog]kN_Kfm[JfU[KFe[JfUW9bL]LKF[JfU_Kf]c]KNc/k>W9bU[JfU
_Kfmc]K>_KfmknOW[JfU4000:BTH<CTQ_Kf]g/jmS8ac:BTHLeYB[G]SaZfL
Q7]c<CTQ610@>CTHBU8iBUY2:BTY>D8aknOWooooe]KWc]K>knOW0?oooooo
oooo>_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV01Woool2knOW00?>e/koooooool00nogm`04moO_c]KNinONknOW1^og
m`?oool06:f]YBTY62TY62TY68b<LljmYDYJ@RTY63TQ67]SBXa[BUYJ@SU2
<BTa:BTQ24YB>HBDU7^4Q5YSF^oWinogmnOWg/k>g_Ogkooooooooooo>_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01[o
ool00mkNg/k>g_ooo`04knOW00CFe^O_inOWimkFe^L6knOW00GFe^OgknOo
oon][JDa>B400TYJ@P09U8aS_Kf][KFeJg=c4108>B4H<AP@610@FV][009J
HeX02F=cS:fe]IbegZFec^oWinogmmkNg/kFc^oWi`3ooooooooooc[oool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0Joooo
00KNg]kNg/koooo>e]jm_Kfe[Jd2[JfU01F<S8be_Ljm_JfLW:F][JF]]KFm
_Kf][JF]]KF][JGWkoOoooo>c/iSLhakQ8A[He9kNg^m_Jf]YIB<S8`Y:BT0
0P00000=BU9JW;GNYKG>W;GNYKgNW;GW]LKFW;GNknOWmoO_g]kNc/k>koOg
0?oooooooooo>_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV01[oool01MkNg/kFg_ooonoWimkNgP02koOg00?_inO>c/k_
moL00^oWi`03c/k>knOWc]KN00;_inL01>O_moO_ioOgkmKFi`:L[Kd01YbL
YJf]YKfm_KFmc[G6eZFecP9SLh`6W;GN00NL]NNU]Lk_inOooooNg]k>e]k_
inL0ooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH06Oooo`;_inL01LkFc_ooonoWinoWinogm`02knOW00>]
]KG_inO_moL01NoWi`05inogmnoWinogooooc]KN00:]_NL00jg6mib]_Lk6
[@03W;GW00F]a^nL]NNL]MjL]MjL]NL01IbegP05c]KNkoOgg]kNc/k>koOg
00_oool00`000?ooooooo`06oooo0`0000Coool01@000?ooooooooooo`00
0004oooo0`0000?oool01@000?ooooooooooo`000002oooo00@0003ooooo
ool00003oooo0P000003oooo0000oooo00;oool20000ooooooSoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0Joooo00SW
imk>c]koooo>e]jLW9c>a[Fe_Lj]]KD2[JfU00>LW:F][JFLW9`00/k>cP0@
[KFe[JfUS8b<c/k>oooo]LKFW:gNW;GNW:gNW:fm[JfUW:gNW:g>W;GNW:gN
W:g>0Yb]gP06W:g>W:gNW:gNW:g>W:gNW:g>0^oWi`03g]kNc]K>knOW00_o
ool00`000?ooooooo`05oooo00D0003oooooooooool000000oooo`050000
oooooooooooo000000?oool01@000?ooooooooooo`000002oooo00D0003o
ooooooooool000000_ooo`040000oooooooo00000_ooo`030000oooooooo
00800002oooo00@0003oooooool0003ooooomoooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV01Woool02>ogmmkNg]kNc_oo
onoWilkFg^oWioOgk`?_inL01LkFg^oWinOWg]KFinoWi`03g]kN00G_inO_
moO_inO>e]kNg]h00/kFgP04g/k6e]KWg]kNe]KW0/kFgP03g]kNc]KNc]KN
00C>e]h01KG6e^oWioOgklkFg/k>cP0<oooo00<0003oooooool01Oooo`05
0000oooooooooooo000000;oool01`000?ooo`000?ooo`000?ooo`000002
oooo00<0003oooooool01?ooo`0;0000oooooooooooo0000oooo0000oooo
0000oooo000000;oool01@000?ooooooooooo`000002oooo00<0003ooooo
ool0ooooooSoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP0Joooo0]kNgP0>ooooknOWooooooooe]KWc/k>knOWmoO_oooo
moO_inogknOW_Kfmg]kN0_ooo`0:inogknOWkoOgooooknOWoooomnoWoooo
inogkoOg0^oWi`04ooooknOWinogmoO_0^oWi`03g]kNknOWkoOg00;_inL0
0mkNg/kFc^oWi`0;oooo00<0003oooooool01Oooo`050000oooooooooooo
000000;oool01`000?ooo`000?ooo`000?ooo`000002oooo1@0000;oool0
2`000?ooooooooooo`000?ooo`000?ooo`000?ooo`000003oooo100000;o
ool00`000?ooooooo`3ooooon?ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool:c<co2?ooo`;_inL04<kFg_ooonog
mjf]YKfm_Lk>cXb<S:f]YKFmc^oWiibLW:f]YHb<S8BDU9B<S:fe]@:][JD0
2Lk>c^oWinO_mmkNgYbLYLk>cZfe]Jf]YIbLW002c/k>00RLW9cNg]j]YIC>
c]j][JFLW:F4U9C>e/h2knOW00C_moO>c]k>c/k_moL;oooo1@0000?oool0
1@000?ooooooooooo`000002oooo00L0003oool0003oool0003oool00000
0_ooo`050000oooooooooooo000000;oool02`000?ooooooooooo`000?oo
o`000?ooo`000?ooo`000006oooo00@0003oooooool0003ooooon_ooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0@oooo00GNg]k>e/koooo_inO>c/h00mkNgP0:c]KNknOW
knOWg]kNc]KNc/k>e/kF[KFeg]k>c]KN0/k>cP07ooooknOW[KFeS8b<_Kfm
[JfUg]kN00;>c/h02MkNg/k>c]kNg/k>c]kNg]K>e/kFc/k>c]KFi`03knOW
00?Ng/k>e]k_inL02oooo`030000oooooooo00;oool010000?ooooooo`00
00?oool00`000?ooo`000003oooo00L0003oooooooooool0003oool00000
0oooo`030000oooooooo00800002oooo00L0003oool0003oool0003oool0
00000_ooo`050000oooooooooooo000000;oool010000?ooooooo`000?oo
ooogoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH01oooo`03c<cooooooooo013oool01>OWg/kFg_ooonogm`?oool01NoW
ioooonO_moooooO_i`03oooo00S_inO_moO_inOoooo_inOooooNg]k>c/h2
g]kN00[_inOooooWkoOoooo_inOWkoOgknOWkoO_inOWkoL4knOW00GFe^O_
inO>e]kNc/K_moL02oooo`030000oooooooo00;oool010000?oooooooooo
o`<00002oooo00D0003oooooooooool000000oooo`030000oooooooo00<0
0003oooo00@0003oool0003oool200000oooo`800003oooo0`0000Coool2
0000ooooooSoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool04?ooo`05e]KWc/k>ooooknOW[JfU
00:]]KD02Kfm_Jfe]MkNg[fm_Jfe]NOWgZf]YKFmcZf]Y@02c/k>00Ne[Jfm
_Kf]]KFLW9b<S8bm_Jg>c]h00Zfe]@:][JD01/k>g[fm_Jf]YKfm_Lk>cZf]
Y@:]]KD2[JfU00G>c/k_inO>e/k>c/kWkoL02oooo`030000oooooooo00;o
ool00`000?ooooooo`0Koooo0P0000?oool20000ooooooooool5oooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03
c<cooooooooo00ooool02?OgknOWg]kNg_ooonoWijfe]Jf]YLk>cP:m_Kd0
1=kNg/k>cZf]YMKFi`:][JD01/k>c]kNg[fm_IbLW<k>c/Jm_@:m_Kd02/k>
c]kNgZfUU:fe]Lk>c[fm_Lk>cZf]YKFmc/k>cP:m_Kd01Zf]YLk>c[fm_Jf]
YKfm_NoWi`;>c/h00oOgkoooooooo`09oooo1@0001koool00`000?oooooo
o`03oooo00<0003oooooool0ooooooooool3oooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013o
ool01=KFilkFc_ooonogm`?_inL01]kNg_ooooooonoWioooonogm`;_inL0
1_ooooOgkoOgkmKFioO_inO_m`;gmnl00nO_mnogmnoWi`02knOW00KWkoO_
inONg]kWkoO_inO>e]h3knOW00OFe^ONg]kNg]kWimk>c/k>e]k_inL0oooo
ooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo00ooool01oOgknOWg]K>e_ooonoWilk>
cZfe]@02W9bL00Z][JFm_KgNg]k>c/jm_KgNc/K>e]jm_Kfe_Ljm_Kd2c/k>
00nm_Kfe_Lk>c/k>a[G>e]jm_Kf]]KG>c]kNg/jm_Kf]]KFm_Kf]]KFm_Kg>
c/h00[fm_@04c/k>[JfU_Kfmc/kN0/k>c_oooooooooo>oooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0@oooo00OFe^O>e/koooo_inNLW9bm_Kf][JD00[fm_@05[KFec/k>
_Kfm_Kfmc]KN00:]]KD01Zf]YJfe]Jf]YJfe]Kfm_Jf]Y@:m_Kd02=kNgYb]
_Jf]YLk6]LkFgXBDU:f]YJfe]@:][JD02/k>c[fm_IbLW;fm_Hb<S9bLW=kN
g/k>c]k>a^O_mooooooooooo>_ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0?oooo00KgmnoW
imk>c]kgmno_inONg]h2inog00K_inO_moO_inOWkoO_inO_moL2knOW00C>
c]k_inOgmno>e]h2g]kN2noWi`06g]kNknOWg]kNg]kNc/k>e/kF0/k>cP04
c]KNc/k>c/k>mnoWooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013oool01=KF
ilk>c_ooomKFi`G>c/h01=kNg/k>c/k>c^ONgPC>c/h03<k>g/k>c/k>cXBD
U;fm_Lk>c/kFg/k>c[fm_Lk>c[fm_Lk>gP;>c/h01kfm_Lk>c[fm_Lk>c[fm
_KF][Jfe]@02_Kfm00CNc/Jm_Kg>c/k_moOooooooooooc[oool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oo
ooooool04?ooo`04g]kNc/k>ooooc]KN0jf]Y@0=W9bUS8b<c/k>W9bL[JfU
]LKF_KfmQ9BD[JFD[JfUc/k>[KFec/k>00:][JD019bLW;fm_Lk>cZf]Y@:<
S8`04<Jm_IbLW8b<S9bLW9bLYHb<S;fm_Hb<S9bLW9B<S9bLW8b<S;Fmc[fm
_MkNc^oWiooooooooooo>_ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0?oooo00C_moO_inO>
c/k_moL3knOW00GNg]k_inO>c/k>e/kNg]h01NoWi`03inONknOWknOW00;_
inL01]KFimkNg/kFc^oWinOWg]KFi`?>c/h02;fm[Lk>g/k>c]k>a[Fmc[fm
_Lk>c[FmcP>m_Kd00kfm[LkFg_ooo`3ooooooooooc[oool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool03oooo`04mnoWe]KWg]k>oooo1=kNgP07c/k>g]kNc/kNg]kNg]k>g]kN
c]KN00;Ng]h00lk>g]kNg]kNgP02g]kN00[>c/k_inO>c]kNg/je_LkNc/J]
[JFLW:Fe_Lje[Jd2[JfU00>]]KF][JF][JD00Zf]Y@06W9bU[JfU[KFe_Kfm
knOWkoOgooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013oool01>oWilk>c^og
mlk>cP:][JD00ibLYIbLW8b<S002[JfU00f4U9BLW:F][JF][JFLW:F][JFL
W:G>a[FLW:F<S8bLW9c>c/j<S8`00ibLW004[JfUS8b<Ng]kNg]k0V][J`0:
W9bLJf][Jf][Ng]kS8b<FUYJW9bL[JfUc/kNknOWoooooooooolkoooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03
c<cooooooooo00ooool01^O_mnOWg/k>c_ooolk>c/kFgP?Ng]h02[fm_MkN
g]kNg]kNg[fm_MkNg/k>c/kFc]kNg^OWgP;>c/h00kfm_Lk>c]kNgP02g]kN
00c>c/k>e]k>c/jm_Kf][JFLW9b<S8akNg^<S8akNg]kQ8AkNg/2S8b<00>L
W9bm_Kg_inL0oooooooooolloooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013oool01>OWg/k>
c^ogmnoWi`CNg]h2_Kfm00SWimkNg]kNg]kNg]kWimkFe^ONg]kFe^L6g]kN
00S>c]kNg]kNc/K>c/jm_KfLW9b<S8a[Lg<4Jf][00EkNg]kQ8BLW9bm_KgN
g]h0oooooooooolmoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00ooool02_OgkmKFilkFc^O_
mnoWihb<S:f]YLk>cXBDU;F][@FLW9`01Lk>cZfUU:f]YHb<S9bLY@02[JfU
00>LW9b][JF<S8`00YbLW003NhB4_KfmNg]k00=[Jf/00hb<S7]kNhb<S002
[JfU0/k>cP03g]kNoooooooo0?oooooooooo??ooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0@
oooo00ONg]k>c/k_moO_inO>c/k>e/kWimh00]kNgP09c]KNc/k>c/k>c]KN
c/k>g]kNc/k>c/kNg]k>00?>c/h00jfe]Lk>c/k>cP02c/k>00G6_Kfe_Lj]
[JF<S8bm_Kd01?ooo`04knOWg]kNc/k>g]kNoooooooooolooooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo013oool01mkNg/k>c^oWinoWimkNg]KFinoWi`02g]kN00[Wg]k_
inO_inO_inONg]k>c]kWimkNg]kFe^O_inL6g]kN0lk>cP03[KFeU8b<c/k>
00?oool2g]kN00?>c/kNg]koool0oooooooooolooooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo
00ooool06>O_mnOWg/k>c^ogmlk6]Lj<Hmk>_NoWimjm[LIkB/k6[LkFgZf]
YHBDU:fe]IbLW<k>cZfe]JfUU8BDU:fe]IbDS<k>cYbLY@BLW9`02Zf]YG^4
Q6][Jkfm_OooonogmnOWg]kNg/k>c]kNg_oooooooooo@Oooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0@oooo01S>e]k>c/k_moO_inO6[IcNg/k_inO6[Ic>S6?_inOFe^Nm
_Jg>c/j]]KG>c/kNg]k>a[Fe_Lk6_Kg>a[Fe_Lk>a[F][JF]]KD2_Kfm00ZL
W9b][JF<S8akQ8C>c/koooo_inO>e]k>c/kNg]kooooooooood;oool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool03oooo`0=koOgknOWc/k>knOWinONc]K>cZF4c/JeaW]:c[fU
knOWinONc]KN00;_inL00nOWg]kNg]kNgP04g]kN00?>c]k>c/kNg]h00]kN
gP09a[fm]Kg>[JfUS8b<c/kNknOWg]kNc/k>g]kN0?oooooooooo@oooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0@oooo00WNg]k>c/kgmnoFe^O_inOF]Ic>a[G6Nd[>e]h0
0^oWi`03inONe]KWinON00GNg]h01<k>g]kNg]kNc]kNgPC>c/h2[JfU00F<
S8cNc/KNg]k>c/kNg]h0oooooooooom4oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00ooool0
0nO_mnOWg/k>cP03knOW00?>a[G>S6?>W7/00^oWi`03inONg]kNg]kN00?N
g]h02<kFg]kNg]kNg]kNg]kNc]K>e/k>c]kNgP;>c/h2_Kfm0YbLW003c]KN
c/k>g]kN0?ooooooooooAOooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0@oooo00cNg]k>c/k_
inO_inO>e]kWimjeLe[>aZg_inOWimkFe^OWimh5g]kN00KNg/k>c]kNg/k>
c]kNg/k>c]h3c/k>00Jm_Kf]]KFLW9bm_Kg>c/kNg]koooooooooodKoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo
00?<c?ooooooool03oooo`05koOgknOWc/k>moO_c]KN00;_inL01<k6]NOW
g^OWg]KFi`GNg]h01lk>g]kNg/kFg]kNc/k>g]kNc/kFgP03c/k>00Jm_Kf]
]KF][JF]]KG>a[GNg]koooooooooodOoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04?ooo`0;
knOWc]KNknOWinONc]KNknOWinONe]KWinONg]kNinON00?Ng]h01mkNc]kN
g]kNc]K>e]kNg/k>c/kFgP02c/k>00O>a[Fe_Ljm_Kfm_Jf][JF]]KGFe^L0
oooooooooom8oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo013oool04>ogmnoWioOgkmKFinoW
inOWg]KFinOWg/kFg^OWg/kFg]kNg/kFg]kNg/kFg]kNgP;>e]h00lkFc/kF
g/k>cP03c/k>00Fm_Kf]]KF]]KG>c/k_inL0oooooooooom9oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo017oool>knOW00SNg]k_inO_inO_inONg]k_inONg]k_inL2g]kN
0^oWioooooooooooBoooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`3oooooooooogKoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool0oooooooooomfoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo0?ooooooooooM_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`3oooooooooogKoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0oooooooo
oomfoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH01oooo`03c<cooooooooo0?ooooooooooM_ooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0[
oooo00?_moOoooo_moL00_ooo`03koOgoooooooo00;oool00nogmoooonog
m`02oooo00?_moOoooooool0oooooooooolioooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo02Go
ool00noWioOgknoWi`0KknOW00CFe^O_inO_inOFe^L6knOW00?_moOooooo
ool0oooooooooolVoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo02Coool03_OgkmkNg/k>g[fm
_KFmc/k6]KFmc/k6]KFmc/k6]Kfm_KFmc/k6]KFmcP>m_Kd01lk>c[fm_LJm
_KFmc/k6]LJm_KFmcP02_Kfm00G6_Kfe_Ljm_Kg6_Kfe_Lh00kfm_@09c/k>
_Kfm_Kfma[fm]Kg>_Kfmc/k>c]KNknOW0?oooooooooo9oooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0Toooo00GNg]k>c/j][JF][JFLW:D04IbLW003W9bU[JFDW9bU00:L
W9`01jfUU9bLYIbLW9bLW:f]YIbLW9bLY@02W9bL00>][JFLW9bLW9`00Zf]
Y@03c/k>g]kNkoOg0?oooooooooo9_ooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Toooo00?_
inONg]koool09_ooo`;Ng]h00noWioooooooo`3oooooooooobCoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool09?ooo`03g]kNc]K>oooo01?oool00oOgkoooooooo`02oooo
00GWkoOoooooooooooo_inL00_ooo`03knOWooooinog00;oool01>ogmooo
onOWg/k>c_oooooooooo9oooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Soooo00?WkoOWimk>
e]h00_ooo`03koOgoooooooo00_oool00nogmoooooooo`03oooo00?WkoOo
ooooool02_ooo`07knOWoooooooooooog]kNc]KNknOW0?oooooooooo9_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0Toooo00?Ng]kNc/Koool04Oooo`03koOgoooooooo
00;oool00oO_ioooooooo`02oooo00CWkoOooooooooWkoL5oooo00G_inOo
ooo_inO>c/k_moL0oooooooooolVoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo02?oool00oOg
knONg/kFgP0>oooo00?_moOoooooool01?ooo`03moO_oooooooo00[oool0
0nogmoooonO_m`02oooo00?Ng]k>e/k_inL0oooooooooolVoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo02Coool00mkNg/k>c_ooo`03oooo00[_inO>c/k_inO_moOooooW
koOoooo_inO>c/k_inL2oooo00?_moOooooNg]h01MkNgP06e/kFQ7]cW6]S
[G]Sc[fUU8b<0ZekH`0:_Kfmc/Jeg]k>c/Je_Kf]inogoooog]kNc/k>koOg
oooooooooolVoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo02Coool01=KFimkNc_ooonoWi`:m
_Kd01Lk>cYbLW:fe]Lk>c^ogm`02[JfU0YbLW00MS8b<_Kfm[JfUknOWoooo
inONknOWmoO_knOWmnoWinONg/k6DTY2Na08Q1P@[G]SU48aLaP@W34QcZF4
g]k>knO>g]k>c/JeknOWoooog]kNc]KNknOW0?oooooooooo9_ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`0Soooo00?gmnoWimk>e]h00_ooo`03e/kFg]kNknOW00;Ng]h0
1noWioooomKFinoWilkFc]kNg[fm_@02g]kN0_ooo`0Hc/k>Q9BDW9bUW9bL
NhB4Jg=cFV][BQPHLaP@W34QQ3TaHaPHQ24HYG=J[G]SW9bUW8AkU8aS[KFe
moO_ooooknOWc/k>koOgoooooooooolVoooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo02Coool0
0mKFimK>e_ooo`07oooo00?_moOoooooool00_ooo`03inogoooooooo00;o
ool03]k>aXb<S8b<S6][Jhb<S:fUU6][Je8826/a:I`a8JekHh@H48@Q66/a
:@9:DUX025YJFU9:@V]cLnoWioooomkNg/kFg^oWiooooooooooo9_ooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0Toooo00GNg]k>e/koooogknN]]KD00[fm_@07]Kg>_Kf]
knOWc/k>[JfUknOW[KFe00:m_Kd04mkNg[Fmc/k6]OooolkFg[fm_Jf]YIbD
S:fUU<k6]G]cHaP@45882:ekHha[BX@Q67/a:E8i<BTY:@03>CTa00IJFT;_
inOooooWimk>c/k_moOoooooooooobKoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool08oooo`0]
koOginONc/k>ooookoOg_Kfm[JfUc/kNc/Jec/k>knOWc/k>_KfmknOW[JfU
_Kfmc/k>g]kNc/k>[KFeoooog]k>_Kf][JfUW9bL[Ib4c[fULf]S8AP@DTY2
Hd8iBS4YDSTaDSTYNg]kNhB4FUYJBU8iBTXaBU8iknOWooooe]KWc]K>knOW
0?oooooooooo9_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Ooool00lc<ooooooooo`0Toooo00SNg]k>e]koooooooo_
moOoooo_inOWkoL5oooo00?_moOoooooool00_ooo`09knOWooooc/kN_Kf]
_KfmU8b<Lg=J[Ib4Lf]S009B>C403d8Y8E8i<EY2>E8i<Hb<Lhb<S7]kNf]S
DV][BUYSF^oWioooonOWg/k>g_Ogk`3oooooooooobKoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool08oooo`;_inL00mK>e_ooonoWi`02c/k>00VLW:F]YIBe_Lk>a[GNg]k>
e]k>c/kNg]k>e]h00/k>cP0<a[fmc]KNooooc/JeS8b<S8acFUY2S8b<c/Je
Lf]SDTY2<AP@0U8i<@04LeYBDSTaFUY2Ng=S0V][BP07FUY2Jf]:knOWkoOg
knOWc]K>knOW0?oooooooooo9_ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Toooo00KNg]k>
e/kooooooon][JF]]KD4_Kfm00KNg]jm_Kg>a[G>e]k>a[F]]KD2_Kfm016]
[JGooon]]KE:BTYBBT9[He:<S7>LQ7]JFUYB>BU2:B5[BT9JFT9cFU9SFTXY
:APi>AP00UYB:@06>CTHNf=:knOWoooog]kNc/k>oooooooooolWoooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03
c<cooooooooo02?oool01^ogmnOWg/k>c_ooonogmnoWi`Woool07^oWinOW
g_ooonogmnoWioooojf]YBTa:BTY64Y::JfUU<Jm_CTi<D8Y8E8i<E9:@W]J
BV]SDUY2>BTY64Xa:DY::G=cFTXa:E9S@]KFioooonOWg/kFg^oWiooooooo
oooo9_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Toooo00[Ng]k>e]koooo_inO>e]kNg]k>
c/kNg]k>c/k_inL2c]KN023_inONg]k>e]k>c/kFc]K_inO>e]k_moN]YI@0
000Y:APi8ARLU8c>aZekLf<Y:AQ2:B6]Nf>DJeY[<BTi>APY:APa>B5:BRU:
BS4i>AQ:BS7_inO_moO_inO>c/k_moOoooooooooobKoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool08oooo`0]koOgknOWc/k>oooog]kN_Kfm[JfU[KFe[JfUW9bL]LKF[JfU
_Kf]c]KNc/k>W9bU[JfU_Kfmc]K>_KfmknOW[JfU4000:BTH<CTQ_Kf]g/jm
S8ac:BTHLeYB[G]SaZfLQ7]c<CTQ610@>CTHBU8iBUY2:BTY>D8aknOWoooo
e]KWc]K>knOW0?oooooooooo9_ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Soooo0^oWi`03
c]K>oooooooo00?_moL01?OgklkFg^OWg^oWi`K_moL3oooo01R][JDY:APY
:APY:AR<S7?>_JE:FT8Y:APi8AQkHdZ<JdYJFT8i@S4Y<BTY8@Q:DSV4U9Ak
Q8AJHe[_inO_moOWimk>c]kgmnooooooooooobKoool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
9?ooo`03g]kNc/kNoooo00C_inL01=KFinoWinOWg]KFi`K_inL01MKFioO_
ioooojf]YC4i8@02BUY200VDS6>m_Jf]]KE[Lg<@40Pi8APa610H411JJf/0
0UYSFP09Hg><[KFeW;GNYKG>knOWkoOgg]kNc]K>knOW0?oooooooooo9_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0Toooo00KNg]kNg/koooo>e]jm_Kfe[Jd2[JfU01F<
S8be_Ljm_JfLW:F][JF]]KFm_Kf][JF]]KF][JGWkoOoooo>c/iSLhakQ8A[
He9kNg^m_Jf]YIB<S8`Y:BT00P00000=BU9JW;GNYKG>W;GNYKgNW;GW]LKF
W;GNknOWmoO_g]kNc/k>koOg0?oooooooooo9_ooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0T
oooo00GNg]k>e]koooo_inONg]h00^ogm`03knOWc/k>koOg00;_inL00lk>
c^oWilkFgP02knOW00CWkoOgknOgmnoFe^L2W:fm00JLW:F][JFm_Kfe_Lje
a]JU]Lh2Hg><1YbegP07W;GWYKG>knOWoooog]kNc]KNknOW0?oooooooooo
9_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0Soooo0^oWi`05c]K>ooooknOWknOWkoOg00;_
inL00jfe]NoWinogm`05knOW00GWkoOgknOWkoOoooo>e]h00Zfmi`03[LKg
W:fmc/J]00>L]NL01Jg6kibeiibegYbegYbei`05W;GN00G>e]k_moONg]k>
c/k_moL02oooo`<00004oooo0P000003oooo0000oooo00;oool00`000?oo
ooooo`02oooo0P000003oooo0000oooo0?oooooooooo0oooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0Toooo00SWimk>c]koooo>e]jLW9c>a[Fe_Lj]]KD2[JfU00>LW:F]
[JFLW9`00/k>cP0@[KFe[JfUS8b<c/k>oooo]LKFW:gNW;GNW:gNW:fm[JfU
W:gNW:g>W;GNW:gNW:g>0Yb]gP06W:g>W:gNW:gNW:g>W:gNW:g>0^oWi`03
g]kNc]K>knOW00[oool01@000?ooooooooooo`000002oooo00<0003ooooo
ool00P0000?oool01@000?ooooooooooo`000002oooo0P000?oooooooooo
1?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0Soooo00S_moONg]kNg/koooo_inO>e]k_inOg
mnl3knOW00G>e]k_inOWimkFe^O_inL00mkNgP05knOWkoOgknOWc]KNg]kN
00;>e]h01=k>a]KFimkNg]KFi`;>e]h00mkNg/kFg/kFgP04c]KN00Fea]K_
inOgmno>e]k>c/h02oooo`050000oooooooooooo000000;oool01@000?oo
ooooooooo`000002oooo00<0003oool000000_ooo`050000oooooooooooo
00000?oooooooooo1?ooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Toooo0]kNgP0>ooooknOW
ooooooooe]KWc/k>knOWmoO_oooomoO_inogknOW_Kfmg]kN0_ooo`0:inog
knOWkoOgooooknOWoooomnoWooooinogkoOg0^oWi`04ooooknOWinogmoO_
0^oWi`03g]kNknOWkoOg00;_inL00mkNg/kFc^oWi`0>oooo00@0003ooooo
ooooool400000_ooo`030000oooo000000?oool40000ooooooooool4oooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01ooo
o`03c<cooooooooo017oool:c<co2?ooo`;_inL04<kFg_ooonogmjf]YKfm
_Lk>cXb<S:f]YKFmc^oWiibLW:f]YHb<S8BDU9B<S:fe]@:][JD02Lk>c^oW
inO_mmkNgYbLYLk>cZfe]Jf]YIbLW002c/k>00RLW9cNg]j]YIC>c]j][JFL
W:F4U9C>e/h2knOW00C_moO>c]k>c/k_moL>oooo00<0003oooooool01?oo
o`060000oooooooo0000oooo00001_ooo`030000oooooooo0?oooooooooo
0_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`05g]kNc]K>
ooooknOWc/k>00?Ng]h02/kFg^oWinoWimkNg/kFg/k>c]K>eZfe]MkNc/kF
gP;>c/h01oooonoWijfe]Hb<S;fm_Jf]YMkNgP02c/k>00WNg]k>c/kNg]k>
c/kNg]kFc]K>e/k>c/kFe^L00noWi`03g]k>c]KNknOW00koool010000?oo
ooooo`0000?oool00`000?ooo`000003oooo00<0003oool000000oooo`03
0000oooooooo0?oooooooooo0_ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?oo
ooooool04?ooo`04inONc]KNooookoOg0oooo`05knOWooooinogoooomnoW
00?oool02>oWinogmnoWioooonoWioooomkNg/k>cP;Ng]h02^oWioooonO_
moooonoWinO_moO_inO_mnoWinO_m`C_inL01MKFinoWilkFg]k>a^ogm`0>
oooo00@0003oooooooooool300000_ooo`050000oooooooooooo000000;o
ool30000ooooooooool5oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<oooooooo
o`0@oooo00GFe^O>c/koooo_inN][JD00Zfe]@09_Kfm[KFeg]kN_Kfm[KFe
inON[JfU]Kg>[JfU00;>c/h01kF][Kfm_Jfe]IbLW8b<S;fm[Lk>gP02[KFe
0Zf]Y@06c/kN_Kfm[JfU_Kfmc/k>[JfU0Zfe]@:][JD01Lk>c^oWilkFc/k>
c^O_m`0>oooo00<0003oooooool0oooooooooolEoooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo
017oool00lc<ooooooooo`0?oooo00SgmnoWimkNg]koooo_inN]]KF][JG>
c/h2_Kfm00CNg]k>c/j][JGFe^L2[JfU00K>c/kNg]jm_KfLW9c>c/k6_Kd2
_Kfm00[>c/kNg]j]YIB]]KG>c/jm_Kg>c/j][JFe_Lk>c/h2_Kfm00J][JG>
c/jm_Kf][JFm_Kg_inL2c/k>00?gmnooooooool03?ooo`030000oooooooo
0?oooooooooo5Oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?oo
o`04e]KWc]K>ooookoOg0noWi`06g]kNooooooooknOWooookoOg0^oWi`06
oooomoO_moO_e]KWmnoWinog0_Ogk`03inogkoOgknOW00;_inL01^O_mnoW
imkNg^O_mnoWilkFgP?_inL01mKFimkNg]kNg^OWg/k>c/kFg^oWi`3ooooo
ooooobKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool01oOg
knOWg]K>e_ooonoWilk>cZfe]@02W9bL00Z][JFm_KgNg]k>c/jm_KgNc/K>
e]jm_Kfe_Ljm_Kd2c/k>00nm_Kfe_Lk>c/k>a[G>e]jm_Kf]]KG>c]kNg/jm
_Kf]]KFm_Kf]]KFm_Kg>c/h00[fm_@04c/k>[JfU_Kfmc/kN0/k>c_oooooo
oooo9oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`07e]KW
c]K>ooooknOWW9bL_Kfm[JfU00:m_Kd01Jfe]Lk>c[fm_Kfm_LkFgP02[KFe
00J][JF]]KF][JF]]KFm_Kf][JD2_Kfm00SNg]jL[Kf][JG>a[G>e]j4U9B]
[JF]]KD2[JfU00[>c/jm_KfLW9bm_Kf<S8bLW9cNg]k>c/kNc/KWkoOooooo
ooooobKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool01_Og
knOWg/k>g_OgknoWimkNgP;WkoL01^oWinogmnoWinO_mnoWinogm`;_inL0
1<k>g^oWioOgklkFgP;Ng]h;knOW00KNg]k_inONg]kNg]k>c/kFc]H2c/k>
00C>e]k>c/k>c/kgknOoooooooooobKoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03
c<cooooooooo013oool01=KFilk>c_ooomKFi`G>c/h01=kNg/k>c/k>c^ON
gPC>c/h03<k>g/k>c/k>cXBDU;fm_Lk>c/kFg/k>c[fm_Lk>c[fm_Lk>gP;>
c/h01kfm_Lk>c[fm_Lk>c[fm_KF][Jfe]@02_Kfm00CNc/Jm_Kg>c/k_moOo
ooooooooobKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool0
1=kNg/k>c_ooolkFgP>][JD03IbLYHb<S<k>cYbLW:f]YKG6e[fm_HBDU:fU
U:f]YLk>cZfe]Lk>cP02[JfU00BLW9bm_Kg>c/j][JD2S8b<0136_KfLW9b<
S8bLW9bLW:F<S8bm_Kf<S8bLW9bDS8bLW9b<S8be_Ljm_KgNg/k_inOooooo
ooooobKoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool01>og
mnoWilk>c^ogm`?_inL01MkNg^oWilk>c/kFc]kNgP05knOW00?Wimk_inO_
inL00^oWi`06e]KWg]kNc]K>knOWinONe]KW0lk>cP08_Kf]c/kNc/k>g/k6
]Kg>_Kfmc/k>]Kg>0kfm_@03_Kf]c]KNoooo0?oooooooooo9_ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`0Aoooo00?<c?ooooooool03oooo`04mnoWe]KWg]k>oooo1=kN
gP07c/k>g]kNc/kNg]kNg]k>g]kNc]KN00;Ng]h00lk>g]kNg]kNgP02g]kN
00[>c/k_inO>c]kNg/je_LkNc/J][JFLW:Fe_Lje[Jd2[JfU00>]]KF][JF]
[JD00Zf]Y@06W9bU[JfU[KFe_KfmknOWkoOgoooooooooolVoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo017oool00lc<ooooooooo`0@oooo00C_inO>c/k_moO>c/h2[JfU
00>LW:FLW9b<S8`00Zf]Y@0=Q9BDW9bU[JfU[JfUW9bU[JfUW9bUc/JeW9bU
S8b<W9bLc/k>S8b<00>LW9`01:f]YHb<S7]kNg]kN`9[Jf/02YbLW6][Jf][
Jg]kNhb<S5YJFYbLW:f]YLk>g^oWiooooooooooo9oooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0Aoooo00?<c?ooooooool03oooo`06inoginONc/k>ooooc/k>c]KN0mkN
gP0:_Kfmg]kNg]kNg]kN_Kfmg]kNc/k>c]K>g]kNinON0/k>cP03_Kfmc/k>
g]kN00;Ng]h03<k>c/kFg/k>c[fm_Jf]YIbLW8b<S7]kNhb<S7]kNg^4Q7]k
N`:<S8`00ibLW;fm_NoWi`3oooooooooobSoool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Ooo
o`03c<cooooooooo013oool01>OWg/k>c^ogmnoWi`CNg]h2_Kfm00SWimkN
g]kNg]kNg]kWimkFe^ONg]kFe^L6g]kN00S>c]kNg]kNc/K>c/jm_KfLW9b<
S8a[Lg<4Jf][00EkNg]kQ8BLW9bm_KgNg]h0oooooooooolYoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo017oool00lc<ooooooooo`0?oooo00[gmnoFe^O>e/kWkoO_inN<
S8b][JG>c/j4U9Be[Jd5W9bL00G>c/j]YIB][JF<S8bLW:D00Zf]Y@03W9bL
[JfUS8b<00:LW9`00g^4Q;fm_G]kN`03Jf][00><S8akNg^<S8`00Zf]Y@;>
c/h00mkNg_ooooooo`3oooooooooobSoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03
c<cooooooooo013oool01mkNg/k>c^ogmnoWilk>c/kFc^OWgP02g]kN00W>
e]k>c/k>c/k>e]k>c/kNg]k>c/k>c]kNg/h00lk>cP03[KFec/k>c/k>00;>
c/h01LJm_KFmcZf]YHb<S;fm_@04oooo00C_inONg]k>c/kNg]kooooooooo
ob_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool01mkNg/k>
c^oWinoWimkNg]KFinoWi`02g]kN00[Wg]k_inO_inO_inONg]k>c]kWimkN
g]kFe^O_inL6g]kN0lk>cP03[KFeU8b<c/k>00?oool2g]kN00?>c/kNg]ko
ool0ooooooooool[oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0?
oooo01SWkoOWimk>c/k_moO>a[G>S6?Nc[g_inON_Jg6Nd[>aZg>e]j][JF4
U9B]]KFLW9c>c/j]]KF]YIB4U9B]]KFLU8c>c/jLW:D4W9bL00Z][JEkQ8A[
Jf^m_Kgoooo_moOWimkNg]k>c/kNg]koooooooooobgoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool04Oooo`03c<cooooooooo013oool06<kFg/k>c^ogmnoWilJ]W=kNc^oW
ilJ]W<j<HnoWimKFikfm[Lk>cZfe]Lk>c]kNg/k6]KFmc/Jm_Lk6]KFmc/k6
]Jf]YJfe]@:m_Kd02YbLW:f]YHb<S7^4Q<k>c_ooonoWilkFg/k>c]kNg_oo
oooooooo;_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool03oooo`0=
koOgknOWc/k>knOWinONc]K>cZF4c/JeaW]:c[fUknOWinONc]KN00;_inL0
0nOWg]kNg]kNgP04g]kN00?>c]k>c/kNg]h00]kNgP09a[fm]Kg>[JfUS8b<
c/kNknOWg]kNc/k>g]kN0?oooooooooo;oooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo
00?<c?ooooooool04?ooo`09g]kNc/k>moO_e]KWknOWe[FLc/JeaW]:c]KN
00;_inL00nOWg]KFinOWgP05g]kN00C>c]kNg]kNg/kNg]h4c/k>0Zf]Y@05
S8b<g/k6g]kNc/k>g]kN0?oooooooooo<?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo
00?<c?ooooooool03oooo`03inoginONc/k>00?_inL00lk6]Lj<HljLN`02
knOW00?WimkNg]kNg]h00mkNgP08c]KNg]kNg]kNg]kNg]k>e/kFc/k>g]kN
0/k>cP:m_Kd2W9bL00?>e]k>c/kNg]h0oooooooooolaoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooo
oooo017oool00lc<ooooooooo`0@oooo00cNg]k>c/k_inO_inO>e]kWimje
Le[>aZg_inOWimkFe^OWimh5g]kN00KNg/k>c]kNg/k>c]kNg/k>c]h3c/k>
00Jm_Kf]]KFLW9bm_Kg>c/kNg]kooooooooooc;oool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
4Oooo`03c<cooooooooo00ooool01NogmnoWilk>c_OgklkFgP02knOW00C>
a[GWimkWimkFe^L5g]kN00O>c]kNg]k>e]kNg/k>c]kNg/k>e]h00lk>cP06
_Kfm[KFe[JfU[KFec/Jeg]kNoooooooooolcoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017o
ool00lc<ooooooooo`0@oooo00__inO>e]k_inOWimk>e]k_inOWimkFe^OW
imkNg]kWimh00mkNgP07g]k>g]kNg]k>e/kFg]kNc/k>c]KN00;>c/h01lk6
]KFmc[fm_Kfm[Jf]YJfe]MKFi`3oooooooooocCoool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
4Oooo`03c<cooooooooo013oool04>ogmnoWioOgkmKFinoWinOWg]KFinOW
g/kFg^OWg/kFg]kNg/kFg]kNg/kFg]kNgP;>e]h00lkFc/kFg/k>cP03c/k>
00Fm_Kf]]KF]]KG>c/k_inL0ooooooooooleoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017o
ool00lc<ooooooooo`0Aoooo3^oWi`08g]kNknOWknOWknOWg]kNknOWg]kN
knOW0]kNgP;_inOoooooooooocOoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<co
oooooooo0?ooooooooooH_ooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?oooooo
ool0oooooooooomRoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`3o
ooooooooof;oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo0?oooooo
ooooH_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool0AOooocnIVLco
oooogOooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool0AOooo`03VIW<
c<coc<co03_<c?l00iVIc?ooooooo`3ooooofoooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0A
oooo00?<c?ooooooool05oooo`03koOgooookoOg00;oool00nogmooooooo
o`02oooo00?_moOoooo_moL00_ooo`03koOgoooooooo01coool00iVIc<c<
olc<o`0kc<co00>IVLcoooooool0ooooom_oool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Ooo
o`03c<cooooooooo017oool00noWioOgknoWi`0KknOW00CFe^O_inO_inOF
e^L6knOW00?_moOoooooool02Oooo`03VIW<c<coc<co03_<c?l00iVIc?oo
ooooo`3ooooofoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?oo
o`0>moO_g]kNc/kN_Kfm]Kg>c/Je]Kg>c/Je]Kg>c/Je_Kfm]Kg>c/Je]Kg>
0kfm_@07c/k>_Kfma[fm]Kg>c/Jea[fm]Kg>00:m_Kd01LJm_KFmc[fm_LJm
_KFmcP03_Kfm00W>c/jm_Kfm_Kg6_Kfe_Ljm_Kg>c/k>e]k_inL02_ooo`03
VIW<c<coc<co03_<c?l00iVIc?ooooooo`3ooooofoooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0Aoooo00?<c?ooooooool04?ooo`05g]kNc/k>[JfU[JfUW9bU016LW9`0
0ibLYJfUU9bLY@02W9bL00N]YIBLW:FLW9bLW9b][JFLW9bLW:D00YbLW003
[JfUW9bLW9bL00:][JD00lk>c]kNg^ogm`09oooo00>IVLc<c?o<c?l0>lc<
o`03VIW<oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<oooo
ooooo`0@oooo00?_inONg]koool09_ooo`;Ng]h00noWioooooooo`07oooo
00>IVLc<c?o<c?l0>lc<o`03VIW<oooooooo0?oooooKoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooo
oooo017oool00lc<ooooooooo`0@oooo00?Ng]k>e/koool04oooo`03moO_
oooooooo00;oool01NO_moooooooooooonoWi`02oooo00?_inOooooWkoL0
0_ooo`04koOgooooinONc/k>2_ooo`03VIW<c<coc<co03_<c?l00iVIc?oo
ooooo`3ooooofoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool03ooo
o`03inoginONc]KN00;oool00nogmoooooooo`0;oooo00?_moOoooooool0
0oooo`03inogoooooooo00[oool01noWioooooooooooomkNg/kFg^oWi`09
oooo00>IVLc<c?o<c?l0>lc<o`03VIW<oooooooo0?oooooKoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo017oool00lc<ooooooooo`0@oooo00?Ng]kNc/Koool04Oooo`03
koOgoooooooo00;oool00oO_ioooooooo`02oooo00CWkoOooooooooWkoL5
oooo00G_inOoooo_inO>c/k_moL02Oooo`03VIW<c<coc<co03_<c?l00iVI
c?ooooooo`3ooooofoooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool0
3oooo`03moO_imkNc]KN00koool00nogmoooooooo`04oooo00?gmnoooooo
ool02_ooo`03koOgooooinog00;oool00mkNg/kFc^oWi`09oooo00>IVLc<
c?o<c?l0>lc<o`03VIW<oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017o
ool00lc<ooooooooo`0@oooo00?Ng]k>c/koool00oooo`0:knOWc/k>knOW
koOgooooinogooooknOWc/k>knOW0_ooo`03koOgoooog]kN00GNg]h01]K>
eXAkLia[HjekHljmYIB<S0:]Nf<02[fm_Lk6]MkNc/k6]Kfm[NO_moooomkN
g/k>c^ogm`Woool00iVIc<c<olc<o`0kc<co00>IVLcoooooool0ooooom_o
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07
oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool01=KFimkNc_oo
onoWi`:m_Kd01Lk>cYbLW:fe]Lk>c^ogm`02[JfU0YbLW00MS8b<_Kfm[JfU
knOWooooinONknOWmoO_knOWmnoWinONg/k6DTY2Na08Q1P@[G]SU48aLaP@
W34QcZF4g]k>knO>g]k>c/JeknOWoooog]kNc]KNknOW00Woool00iVIc<c<
olc<o`0kc<co00>IVLcoooooool0ooooom_oool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Ooo
o`03c<cooooooooo00ooool00oOgknOWg/kFgP02oooo00?Fc]KNg]k_inL0
0]kNgP07knOWooooe]KWknOWc]K>g]kN_Kfm00;Ng]h2oooo01S>c/j4U9BL
W:FLW9akQ8A[Lg=JJf]:61Qc612L<B64>C5S61R48ARULeZ]Nf>LW:FLQ7^D
S6>]]KGgmnooooo_inO>c/k_moL9oooo00>IVLc<c?o<c?l0>lc<o`03VIW<
oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0@
oooo00?Fe^OFc]Koool01oooo`03koOgoooooooo00;oool00nO_mooooooo
o`02oooo00kNc/J<S8b<S8a[Jf^<S8b]YIA[Jf]B20Q[<BVL<B6]Nf>46124
8AQ[<BT2BU9J00QJFUYBBT9[Lg?_inOooooNg]k>e]k_inL9oooo00>IVLc<
c?o<c?l0>lc<o`03VIW<oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017o
ool00lc<ooooooooo`0@oooo00GNg]k>e/koooogknN]]KD00[fm_@07]Kg>
_Kf]knOWc/k>[JfUknOW[KFe00:m_Kd04mkNg[Fmc/k6]OooolkFg[fm_Jf]
YIbDS:fUU<k6]G]cHaP@45882:ekHha[BX@Q67/a:E8i<BTY:@03>CTa00IJ
FT;_inOooooWimk>c/k_moL9oooo00>IVLc<c?o<c?l0>lc<o`03VIW<oooo
oooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0?oooo
02g_moOWimk>c/koooo_moNm_Kf][JG>c]k>a[G>c/k_inO>c/jm_Kg_inN]
[JFm_Kg>c/kNg]k>c/j]]KGooooNg/jm_Jf][JFLW9b]W8C>_JEcJf<Q611B
BT9S@SU:<BUB>C5B>BUkNg]kQ8AJFUY:DSU:BS5:DSW_inOooooFe^O>e/k_
inL02Oooo`03VIW<c<coc<co03_<c?l00iVIc?ooooooo`3ooooofoooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`08g]kNc]KNoooooooo
koOgooooknOWinog1Oooo`03koOgoooooooo00;oool02NoWioooolk>g[fm
[Kfm_IB<S7=cFZfLQ7=[H`02DSTa00m2:B5B>C5J@SUB>C6<S7><S8akNg][
He9[JdYJHe[_inOooooWimk>c]kgmnl02Oooo`03VIW<c<coc<co03_<c?l0
0iVIc?ooooooo`3ooooofoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?oooooo
ool03oooo`;_inL00mK>e_ooonoWi`02c/k>00VLW:F]YIBe_Lk>a[GNg]k>
e]k>c/kNg]k>e]h00/k>cP0<a[fmc]KNooooc/JeS8b<S8acFUY2S8b<c/Je
Lf]SDTY2<AP@0U8i<@04LeYBDSTaFUY2Ng=S0V][BP07FUY2Jf]:knOWkoOg
knOWc]K>knOW00Woool00iVIc<c<olc<o`0kc<co00>IVLcoooooool0oooo
om_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool01]kNg/kF
c_ooooooojf]YJfe]@Bm_Kd01]kNg[fm_Lk6]LkFg/k6]Jfe]@:m_Kd04Jf]
YOooojfe]DY:BU9:@V]SDXb<Lib4NeYJFU8i:D8Y8F]:@UYJ@W=JDV=JBRTY
63Ti6002FU8Y00Hi>AQkHd[_inOooooNg]k>c/h:oooo00>IVLc<c?o<c?l0
>lc<o`03VIW<oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<
ooooooooo`0?oooo00K_moOWimk>c/koooo_moO_inL9oooo01k_inOWimko
ooo_moO_inOooon][JDY<BTY:AQ:BRV]YIC6_Kdi>C52:B5B>C5BBT9kFTY[
He9J@STY:AQ:<BU:BRUcLeY:<BUBHd;Fe^OooooWimk>e]k_inL9oooo00>I
VLc<c?o<c?l0>lc<o`03VIW<oooooooo0?oooooKoooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo
017oool00lc<ooooooooo`0@oooo00[Ng]k>e]koooo_inO>e]kNg]k>c/kN
g]k>c/k_inL2c]KN023_inONg]k>e]k>c/kFc]K_inO>e]k_moN]YI@0000Y
:APi8ARLU8c>aZekLf<Y:AQ2:B6]Nf>DJeY[<BTi>APY:APa>B5:BRU:BS4i
>AQ:BS7_inO_moO_inO>c/k_moL9oooo00>IVLc<c?o<c?l0>lc<o`03VIW<
oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0?
oooo02g_moO_inO>c/kooooNg]jm_Kf][JF]]KF][JFLW9bea]J][JFm_Jg>
e]k>c/jLW:F][JFm_Kg>e/jm_Kg_inN][JD@000Y:APa>B6m_JgNc[f<S7<Y
:AQcFU:]Nf?6[Ib4Ng<a>B4H410i>AQ:DSU:FT8Y:BTi@S7_inOooooFe^O>
e/k_inL02Oooo`03VIW<c<coc<co03_<c?l00iVIc?ooooooo`3ooooofooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0Aoooo00?<c?ooooooool03oooo`;_inL00lkFc_oo
ooooo`03koOg00Cgmno>e]kWimk_inL6koOg0oooo`0H[JfU:BTH:BTH:BTH
S8acc[fUBUY2:BTH>B4HNf=:S6]:FUY2>D8a:C4Y:B48BU8iQ9BDNhB4FV=J
knOWkoOginONc/kNmoO_2Oooo`03VIW<c<coc<co03_<c?l00iVIc?oooooo
o`3ooooofoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`03
g]kNc/kNoooo00C_inL01=KFinoWinOWg]KFi`K_inL01MKFioO_ioooojf]
YC4i8@02BUY200VDS6>m_Jf]]KE[Lg<@40Pi8APa610H411JJf/00UYSFP09
Hg><[KFeW;GNYKG>knOWkoOgg]kNc]K>knOW00Woool00iVIc<c<olc<o`0k
c<co00>IVLcoooooool0ooooom_oool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<co
oooooooo013oool01]kNg]kNc_ooolkFg[fm_KF][@:][JD05Hb<S;Fmc[fm
[IbLYJf]YJfe]Kfm_Jf]YJfe]Jf]YNO_moooolk>cV=cS7^4Q6]SDW]kNkfm
[JfUU8b<S2TY:@02000000e:DUZL]MjU]LjL]MjU_MjL]NNea]JL]Mk_inOg
mnoNg]k>c/k_moL02Oooo`03VIW<c<coc<co03_<c?l00iVIc?ooooooo`3o
oooofoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`05g]kN
c]KNooooknOWg]kN00;_moL00noWilk>c^ogm`02knOW00?>c/k_inO>e]h0
0^oWi`04inogmnoWmoO_e]KW0Yb]_@06W9bU[JfU_Kfm]Kg>]LKFYKG>0V=c
S0JL]Mh01ibeijFec^oWioooomkNg/kFg^oWi`09oooo00>IVLc<c?o<c?l0
>lc<o`03VIW<oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<
ooooooooo`0?oooo0^oWi`05c]K>ooooknOWknOWkoOg00;_inL00jfe]NoW
inogm`05knOW00GWkoOgknOWkoOoooo>e]h00Zfmi`03[LKgW:fmc/J]00>L
]NL01Jg6kibeiibegYbegYbei`05W;GN00G>e]k_moONg]k>c/k_moL02Ooo
o`04VIW<c<coc<coc<co0`000003c<co0000c<co00;<c?l2000000G<c?l0
003<c?o<c?l000000lc<o`800003c<co00D0003<c?o<c?o<c?l000000lc<
o`030000c<coc<co00;<c?l010000<c<olc<o`0000?<c?l01@000<c<olc<
olc<o`000003c<co0`0000C<c?l00iVIc?ooooooo`3ooooofoooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`0Aoooo00?<c?ooooooool04?ooo`08inONc/kNooooc]KNW9bL
c/Je]Kg>[KFe0Zf]Y@03W9bU[JfUW9bL00;>c/h04:fe]Jf]YHb<S<k>c_oo
okG6eYb]gYbegYb]gYb]_Jf]YIb]gYb]cYbegYb]gYb]cP:L[Mh01Yb]cYb]
gYb]gYb]cYb]gYb]cP;_inL00mkNg/kFc^oWi`09oooo00BIVLc<c?o<c?l0
0003c<co00D0003<c?o<c?o<c?l000000/c<o`800002c<co00@0003<c?o<
c?l00002c<co00@0003<c?o<c?l00002c<co00<0003<c?o<c?l00/c<o`03
0000c<coc<co00;<c?l010000<c<olc<o`0000?<c?l01@000<c<olc<olc<
o`000002c<co00D0003<c?o<c?o<c?l000000lc<o`03VIW<oooooooo0?oo
oooKoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0?oooo00S_moON
g]kNg/koooo_inO>e]k_inOgmnl3knOW00G>e]k_inOWimkFe^O_inL00mkN
gP05knOWkoOgknOWc]KNg]kN00;>e]h01=k>a]KFimkNg]KFi`;>e]h00mkN
g/kFg/kFgP04c]KN00Fea]K_inOgmno>e]k>c/h02_ooo`03VIW<c<co0000
00;<c?l2000000G<c?l0003<c?o<c?l000000lc<o`040000c<coc<co0000
0/c<o`030000c<coc<co00?<c?l010000<c<olc<o`0000C<c?l00`000<c<
olc<o`02c<co00@0003<c?o<c?l00003c<co00D0003<c?o<c?o<c?l00000
0/c<o`030000c<coc<co00G<c?l00iVIc?ooooooo`3ooooofoooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`0Aoooo00?<c?ooooooool04?ooo`;Ng]h03_ooonoWiooooooo
omKFilk>c^oWioOgkoooooOgknO_mnoWikfm_MkNgP;oool02^O_mnoWinog
moooonoWioooooO_ioooonO_mnogm`;_inL01?ooonoWinO_moOgk`;_inL0
0mkNg^oWinogm`02knOW00?Ng]k>e/k_inL02Oooo`03VIW<c<co000000G<
c?l010000<c<olc<o`0000?<c?l010000<c<olc<o`0000;<c?l00`000<c<
olc<o`03c<co0`0000G<c?l00`000<c<olc<o`02c<co00@0003<c?o<c?l0
0003c<co00D0003<c?o<c?o<c?l000000/c<o`D00003c<co00>IVLcooooo
ool0ooooom_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`[<c?l8oooo0^oWi`0@c]KN
ooookoOg[JfU_Kfmc/k>S8b<[JfU]Kg>knOWW9bL[JfUS8b<Q9BDU8b<[KFe
0Zf]Y@09c/k>knOWinogg]kNW9bUc/k>[KFe[JfUW9bL00;>c/h029bLW=kN
gZfUU<k>gZf]YIbLYHBDU<kFcP;_inL01>ogmlk>g/k>c^ogm`Woool00iVI
c<c<o`000005c<co00@0003<c?o<c?l00003c<co00@0003<c?o<c?l00002
c<co00<0003<c?o<c?l00lc<o`030000c<co000000G<c?l00`000<c<olc<
o`02c<co00@0003<c?o<c?l00003c<co00D0003<c?o<c?o<c?l000000/c<
o`050000c<coc<coc<co000000?<c?l00iVIc?ooooooo`3ooooofoooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`05g]kNc]K>ooooknOW
c/k>00?Ng]h02/kFg^oWinoWimkNg/kFg/k>c]K>eZfe]MkNc/kFgP;>c/h0
1oooonoWijfe]Hb<S;fm_Jf]YMkNgP02c/k>00WNg]k>c/kNg]k>c/kNg]kF
c]K>e/k>c/kFe^L00noWi`03g]k>c]KNknOW00Woool00iVIc<c<o`000005
c<co00@0003<c?o<c?l00003c<co00@0003<c?o<c?l00002c<co00@0003<
c?o<c?l00002c<co00@0003<c?o<c?l00004c<co00<0003<c?o<c?l00/c<
o`030000c<coc<co00800002c<co0P0000;<c?l010000<c<olc<o`0000?<
c?l01@000<c<olc<olc<oiVIc03ooooogOooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo
00?<c?ooooooool04?ooo`04inONc]KNooookoOg0oooo`05knOWooooinog
oooomnoW00?oool02>oWinogmnoWioooonoWioooomkNg/k>cP;Ng]h02^oW
ioooonO_moooonoWinO_moO_inO_mnoWinO_m`C_inL01MKFinoWilkFg]k>
a^ogm`09oooo00>IVLc<c?l000001Lc<o`040000c<coc<co00000lc<o`04
0000c<coc<co00000lc<o`800003c<co00D0003<c?o<c?o<c?l000000lc<
o`030000c<coc<co00;<c?l01@000<c<olc<o`000<c<o`0200000/c<o`80
0004c<co0`0000C<c?l00iVIc?ooooooo`3ooooofoooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0Aoooo00?<c?ooooooool04?ooo`05e]KWc/k>ooooknOW[JfU00:]]KD0
2Kfm_Jfe]MkNg[fm_Jfe]NOWgZf]YKFmcZf]Y@02c/k>00Ne[Jfm_Kf]]KFL
W9b<S8bm_Jg>c]h00Zfe]@:][JD01/k>g[fm_Jf]YKfm_Lk>cZf]Y@:]]KD2
[JfU00G>c/k_inO>e/k>c/kWkoL02Oooo`04VIW<c<coc<co00000lc<o`03
0000c<coc<co017<c?l00`000<c<olc<o`05c<co00<0003<c?o<c?l06<c<
o`03VIW<oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<oooo
ooooo`0?oooo00SgmnoWimkNg]koooo_inN]]KF][JG>c/h2_Kfm00CNg]k>
c/j][JGFe^L2[JfU00K>c/kNg]jm_KfLW9c>c/k6_Kd2_Kfm00[>c/kNg]j]
YIB]]KG>c/jm_Kg>c/j][JFe_Lk>c/h2_Kfm00J][JG>c/jm_Kf][JFm_Kg_
inL2c/k>00?gmnooooooool01oooo`04VIW<c<coc<coc<co0`0000_<c?l0
0`000<c<olc<o`06c<co00<0003<c?o<c?l00/c<o`L000000lc<o`000<c<
o`0Dc<co00>IVLcoooooool0ooooom_oool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03
c<cooooooooo013oool01=KFilkFc_ooonogm`?_inL01]kNg_ooooooonoW
ioooonogm`;_inL01_ooooOgkoOgkmKFioO_inO_m`;gmnl00nO_mnogmnoW
i`02knOW00KWkoO_inONg]kWkoO_inO>e]h3knOW00OFe^ONg]kNg]kWimk>
c/k>e]k_inL02Oooo`03VIW<c<coc<co03_<c?l00iVIc?ooooooo`3ooooo
foooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool03oooo`07moO_inON
e/kFooooknOWc/k>[KFe00:LW9`02Zf]YKfm_MkNg/k>c[fm_Mk>a/kFg[fm
_KFmc[fm_@;>c/h03kfm_KFmc/k>c/k6]LkFg[fm_Jfe]Lk>g]kNc[fm_Jfe
]Kfm_Jfe]Kfm_Lk>cP02_Kfm00C>c/j][JFm_Kg>c]h2c/k>2_ooo`03VIW<
c<coc<co03_<c?l00iVIc?ooooooo`3ooooofoooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0A
oooo00?<c?ooooooool04?ooo`07e]KWc]K>ooooknOWW9bL_Kfm[JfU00:m
_Kd01Jfe]Lk>c[fm_Kfm_LkFgP02[KFe00J][JF]]KF][JF]]KFm_Kf][JD2
_Kfm00SNg]jL[Kf][JG>a[G>e]j4U9B][JF]]KD2[JfU00[>c/jm_KfLW9bm
_Kf<S8bLW9cNg]k>c/kNc/KWkoL9oooo00>IVLc<c?o<c?l0>lc<o`03VIW<
oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0?
oooo00KgmnoWimk>c]kgmno_inONg]h2inog00K_inO_moO_inOWkoO_inO_
moL2knOW00C>c]k_inOgmno>e]h2g]kN2noWi`06g]kNknOWg]kNg]kNc/k>
e/kF0/k>cP04c]KNc/k>c/k>mnoW2Oooo`03VIW<c<coc<co03_<c?l00iVI
c?ooooooo`3ooooofoooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool0
4?ooo`04e]KWc/k>ooooe]KW1Lk>cP04g]kNc/k>c/k>imkN1<k>cP0<c/kN
c/k>c/k>Q9BD_Kfmc/k>c]KNc/k>_Kfmc/k>_Kfmc/kN0/k>cP07_Kfmc/k>
_Kfmc/k>_Kfm]Jf][KFe00:m_Kd01=k>a[fm_Lk>c^ogm`Woool00iVIc<c<
olc<o`0kc<co00>IVLcoooooool0ooooom_oool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Ooo
o`03c<cooooooooo013oool01=kNg/k>c_ooolkFgP>][JD03IbLYHb<S<k>
cYbLW:f]YKG6e[fm_HBDU:fUU:f]YLk>cZfe]Lk>cP02[JfU00BLW9bm_Kg>
c/j][JD2S8b<0136_KfLW9b<S8bLW9bLW:F<S8bm_Kf<S8bLW9bDS8bLW9b<
S8be_Ljm_KgNg/k_inL9oooo00>IVLc<c?o<c?l0>lc<o`03VIW<oooooooo
0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0?oooo00C_
moO_inO>c/k_moL3knOW00GNg]k_inO>c/k>e/kNg]h01NoWi`03inONknOW
knOW00;_inL01]KFimkNg/kFc^oWinOWg]KFi`?>c/h02;fm[Lk>g/k>c]k>
a[Fmc[fm_Lk>c[FmcP>m_Kd00kfm[LkFg_ooo`09oooo00>IVLc<c?o<c?l0
>lc<o`03VIW<oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<
ooooooooo`0?oooo00CgknOFe^ONg/koool4g]kN00O>c/kNg]k>c]kNg]kN
g/kNg]k>e]h00]kNgP03c/kNg]kNg]kN00;Ng]h02/k>c^oWilk>g]kNc[Fm
c]k>aZf]YIbLYKFmc[F][@:][JD00jfe]Jf]YJf]Y@02[JfU00JLW:F][JF]
]KFm_Kg_inO_moL9oooo00>IVLc<c?o<c?l0>lc<o`03VIW<oooooooo0?oo
oooKoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0@oooo00C_inO>
c/k_moO>c/h2[JfU00>LW:FLW9b<S8`00Zf]Y@0=Q9BDW9bU[JfU[JfUW9bU
[JfUW9bUc/JeW9bUS8b<W9bLc/k>S8b<00>LW9`01:f]YHb<S7]kNg]kN`9[
Jf/02YbLW6][Jf][Jg]kNhb<S5YJFYbLW:f]YLk>g^oWi`[oool00iVIc<c<
olc<o`0kc<co00>IVLcoooooool0ooooom_oool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Ooo
o`03c<cooooooooo00ooool01^O_mnOWg/k>c_ooolk>c/kFgP?Ng]h02[fm
_MkNg]kNg]kNg[fm_MkNg/k>c/kFc]kNg^OWgP;>c/h00kfm_Lk>c]kNgP02
g]kN00c>c/k>e]k>c/jm_Kf][JFLW9b<S8akNg^<S8akNg]kQ8AkNg/2S8b<
00>LW9bm_Kg_inL02oooo`03VIW<c<coc<co03_<c?l00iVIc?ooooooo`3o
oooofoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`04inON
c/k>koOgknOW1=kNgP:m_Kd02>OWg]kNg]kNg]kNg^OWg]KFimkNg]KFi`KN
g]h02<k>g]kNg]k>a/k>c[fm_IbLW8b<S6]cL`A[Jf/01G]kNg^4Q9bLW;fm
_MkNgP0<oooo00>IVLc<c?o<c?l0>lc<o`03VIW<oooooooo0?oooooKoooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01ooo
o`03c<cooooooooo017oool00lc<ooooooooo`0?oooo00[gmnoFe^O>e/kW
koO_inN<S8b][JG>c/j4U9Be[Jd5W9bL00G>c/j]YIB][JF<S8bLW:D00Zf]
Y@03W9bL[JfUS8b<00:LW9`00g^4Q;fm_G]kN`03Jf][00><S8akNg^<S8`0
0Zf]Y@;>c/h00mkNg_ooooooo`0;oooo00>IVLc<c?o<c?l0>lc<o`03VIW<
oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0@
oooo00ONg]k>c/k_moO_inO>c/k>e/kWimh00]kNgP09c]KNc/k>c/k>c]KN
c/k>g]kNc/k>c/kNg]k>00?>c/h00jfe]Lk>c/k>cP02c/k>00G6_Kfe_Lj]
[JF<S8bm_Kd01?ooo`04knOWg]kNc/k>g]kN3_ooo`03VIW<c<coc<co03_<
c?l00iVIc?ooooooo`3ooooofoooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?oo
ooooool04?ooo`07g]kNc/k>knOWknOWg]kNe]KWknOW00;Ng]h02^ONg^oW
inoWinoWimkNg/k>g^OWg]kNg]KFinoWi`KNg]h3c/k>00>]]KFDS8c>c/h0
0oooo`;Ng]h00lk>c]kNg_ooo`0>oooo00>IVLc<c?o<c?l0>lc<o`03VIW<
oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0?
oooo01SWkoOWimk>c/k_moO>a[G>S6?Nc[g_inON_Jg6Nd[>aZg>e]j][JF4
U9B]]KFLW9c>c/j]]KF]YIB4U9B]]KFLU8c>c/jLW:D4W9bL00Z][JEkQ8A[
Jf^m_Kgoooo_moOWimkNg]k>c/kNg]h@oooo00>IVLc<c?o<c?l0>lc<o`03
VIW<oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<oooooooo
o`0@oooo01S>e]k>c/k_moO_inO6[IcNg/k_inO6[Ic>S6?_inOFe^Nm_Jg>
c/j]]KG>c/kNg]k>a[Fe_Lk6_Kg>a[Fe_Lk>a[F][JF]]KD2_Kfm00ZLW9b]
[JF<S8akQ8C>c/koooo_inO>e]k>c/kNg]hAoooo00>IVLc<c?o<c?l0>lc<
o`03VIW<oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<oooo
ooooo`0?oooo00g_moO_inO>c/k_inOWimk>e/k>YHC>a[G6Nd[>_JG_inOW
imk>e]h00^oWi`03inONg]kNg]kN00CNg]h00lk>g/k>c]kNgP02g]kN00W6
_Kfe_Lj][JF<S8c>c]k_inONg]k>c/kNg]h04_ooo`03VIW<c<coc<co03_<
c?l00iVIc?ooooooo`3ooooofoooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?oo
ooooool04?ooo`09g]kNc/k>moO_e]KWknOWe[FLc/JeaW]:c]KN00;_inL0
0nOWg]KFinOWgP05g]kN00C>c]kNg]kNg/kNg]h4c/k>0Zf]Y@05S8b<g/k6
g]kNc/k>g]kN01?oool00iVIc<c<olc<o`0kc<co00>IVLcoooooool0oooo
om_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool00nO_mnOW
g/k>cP03knOW00?>a[G>S6?>W7/00^oWi`03inONg]kNg]kN00?Ng]h02<kF
g]kNg]kNg]kNg]kNc]K>e/k>c]kNgP;>c/h2_Kfm0YbLW003c]KNc/k>g]kN
01Coool00iVIc<c<olc<o`0kc<co00>IVLcoooooool0ooooom_oool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool04Oooo`03c<cooooooooo013oool03=kNg/k>c^oWinoWilkF
g^OWg[EcF/k6[NoWinOWg]KFinOWgPGNg]h01]kNc/k>g]kNc/k>g]kNc/k>
gP?>c/h01[fm_Jfe]IbLW;fm_Lk>c]kNgQGoool00iVIc<c<olc<o`0kc<co
00>IVLcoooooool0ooooom_oool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooo
oooo00ooool01NogmnoWilk>c_OgklkFgP02knOW00C>a[GWimkWimkFe^L5
g]kN00O>c]kNg]k>e]kNg/k>c]kNg/k>e]h00lk>cP06_Kfm[KFe[JfU[KFe
c/Jeg]kN5_ooo`03VIW<c<coc<co03_<c?l00iVIc?ooooooo`3ooooofooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`0;knOWc]KNknOW
inONc]KNknOWinONe]KWinONg]kNinON00?Ng]h01mkNc]kNg]kNc]K>e]kN
g/k>c/kFgP02c/k>00O>a[Fe_Ljm_Kfm_Jf][JF]]KGFe^L05oooo`03VIW<
c<coc<co03_<c?l00iVIc?ooooooo`3ooooofoooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0A
oooo00?<c?ooooooool04?ooo`0@koOgknOWmoO_e]KWknOWinONe]KWinON
c]KNinONc]KNg]kNc]KNg]kNc]KNg]kN0/kFgP03c]K>c]KNc/k>00?>c/h0
1Kfm_Jfe]Jfe]Lk>c^oWi`0Hoooo00>IVLc<c?o<c?l0>lc<o`03VIW<oooo
oooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0Aoooo
3^oWi`08g]kNknOWknOWknOWg]kNknOWg]kNknOW0]kNgP;_inLJoooo00>I
VLc<c?o<c?l0>lc<o`03VIW<oooooooo0?oooooKoooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo
017oool00lc<ooooooooo`15oooo00>IVLc<c?o<c?l0>lc<o`03VIW<oooo
oooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`15oooo
00>IVLc<c?o<c?l0>lc<o`03VIW<oooooooo0?oooooKoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooo
oooo017oool00lc<ooooooooo`15oooo00>IVLc<c?o<c?l0>lc<o`03VIW<
oooooooo0?oooooKoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`15
oooo?iVIc?oooooMoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo0?ooooooooooM_ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`3oooooooooogKoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03Oooo`07kno_[Jf]
FV]SW9bLilK6inOWmoOg00Coool00nooooOgmoooo`3ooooooooooe_oool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo
00?<c?ooooooool03?ooo`0;g]kWU8b<41P@BTY::B4Q[G=kNg]kU8b<[Jf]
e[g6kno_0?ooooooooooGoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0;oooo017Wknnm_KdY
<BVma[goooli627>Q8c>Lg_6Jg>]Jf^LHf^<Jg>LS8bm]KGFe]K_knogmoL0
oooooooooomJoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo00[oool01?OgmmK>eYbDW34i>@;o
ool03g]BF/ikQ?mkU>mcS>MkQ<icNke[LjESJjESHiA[LhB4Q9bLW;fm_MkN
g_O_k`3ooooooooooeOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool02_ooo`04inOWa/k>S9B<
FUYJ0_ooo`04LeYScW^Dohb]ohbU0_n4W0;gNh`02nmSNnMJLlI[Lje[JjES
HiA[LiB4Q:F]YLK>c]k_koOgm`02oooo00?_ooooooooool01?ooo`03kooo
oooooooo0?ooooooooooAoooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0:oooo00CginOFe]jU
[JE[Lf/2oooo01M[Lf_NS:goYLkoYLkgU;goU;GgU:goS:G_S9coQ9c_Q9CN
NhcFLhC>Lg^mJg>]Jf^UHf>UJf^LQ8beW9c>a/kWinOoool00nooo`_oool0
0nooooOgmoooo`3oooooooooockoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool02_ooo`0;mno_
ino_[Jf]Jf=SimkWe]kNHdYBaW>DoiBeoibmojG600;oYLh05?nUa_ND_NnD
_On<[On<YOMkU?N4U?MkS>MkQ>mSNnM[NkEcLjE[LiaSJiA[Lib<S;fe]LkN
e^OgmoOgm`Ooool00oOgmoooooooo`3ooooooooood7oool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool03?ooo`0=_KfmJg=[imkWc]KFJeYJaW>Dmf^4mg><mg>DmhBUoiBeoibm
ojG600;oYLh05onL_OnD]On<[On<[On4W?MkU?McU>n4U>MkQ=IcNliSLlIc
LjEcLia[LiacNjfUYKfm_NONg_OgmnooooooooOgmnooo`07oooo00?gmoOo
ooooool0ooooooooooljoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00coool02<K6aXB4Q?Og
mnO_khakNmj<[OnD]On<[@;gLi@01>mcS?McU?n4W?n<Y@;oYLH2okGF01Co
YLkoYLKgU;g_S;GgNiCoQ9cgLhcgNhcgNiC_JhCFLg_>Hg>eLg>UJg>ULg>U
Ng^eW9bm_KgWinO_ooooooooooooodCoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03?ooo`06
c]K>Q8B4knO_inOWU8B4gXb]0_nL_@04oiBeohb]ohbUmhBU0_MkU006gW^D
ohBLoiB]oiBeojG6ojG>0_neeP05ojG>ojG6oiBeohbUmg^D00?gLi@03OMk
S>MkQ=IcNlI[LkEcLje[JjEcLjEkNkF][MK>c^OWioOgmoooo`03kooooooo
oooooolloooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo00coool01[g6aW]kNmK>e/k>cV]cJlik
U0?oS:d00onD]OnL_OnL_@02mibm0_n<[@09miB]mhBUmhBUmiB]ohb]oiBe
ojG6okGFojG>00;oYLH02OnL_OND[ON4YOn4W?mkU?MkU?N4U>MkS=ikQ002
cV=c00VULg^LJg>LLg^]S9Bm]KGNc]Kgknooooo_ool0oooooooooolkoooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01ooo
o`03c<cooooooooo00coool01/kFcXb<S>oWkmkWiiAcNlikW0;oS:d2mhBU
00SoS:goU;GoW;goW;goYLKoYLkoYLKoW;d2oiBe00WoS:GoQ9c_NjGgS:Go
U;GgW;goYLKo[LkoYLH00_nL_@0BkhbemhBUkg^UohBLkg^Umg^DkhBDig^<
eW=kaW=k]F]kYF]cU6]cW7]k[HbDa/K6e]KFmno_oooooooooolioooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03
c<cooooooooo00coool02]K6cXb<S>ooono_kibDW;FLW?nUc_nUa_nL_OnD
]@?oU:d04OnD]NnUc_NL_ON]a_nUc_n]c_nUc_nUa_nL_OnD]On<[On<YNmk
YOMkU?N4YOn<[OnD]@03oibm01CoU;GoS:goS:GoS:GgQ:GgNiCgLiC_Q9C_
NhcWLhcNJg_>Hg?>FV^UJf^LJg>LLg^eW9cF_LKNg]k_moL2kooo0_ooo`04
koooooooooookoooooooooooool]oooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00[oool02noo
ooooolk>cXAkNmkWimKFeYb4S9b<U?nee_nUc_n]cP02ojG600Co[LKoW;go
W;goU:d3oiBe00CoYLKg[LKo[LkoYLh2ojG60_nL_@08oiBekg^Ukg^UihbL
ig><khBDohbUohb]0_nD]@;oS:d2ohbU00KoQ9cgNiCgQ9CgNiC_Q9C_Nh`2
cW^400ZeJg^UJg>UJg>DLg^]S9BmYJG>c/kWg]koooo_ool2oooo00?_oooo
ooooool0ooooooooool[oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00coool02]K>cXAkNmkW
ilk>cYB<S9acNnnUc^n]a_NL_On]aP;o[Lh4okGF00Co[LkoYLKoW;goU;D2
oibm00Gg[LKoYLkoYLko[LKoYLH00_nL_@08oiBeohbUohBLgW^Dkg><ig><
mg^DohbU0on<[@;oS:D2ohBL00SgNiCgQ9CgLiCoQ9cNNiCWNhc>NhBmJg<2
]G=c00NDLg^]S9Coc]k_ooogmoOoooo_ool0ooooooooool]oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo00coool01mK>cXb<S>ogmnOWijfUYIAcNonUaP02mibm00GoU;Go
W;goYLKo[LKo[Lh00_NmgP?o]Mh00onee_n]c_nUaP02mibm1?nD]@;oW;d2
oiBe00CoS:goQ9cgNiCgLh`3if>400C_LhcgNiCoQ9coS:d2ohbU0on4W0;o
Ni@01?n4U?N4U>mkS>MkQ0;6Nh`00nnU]Oooonooo`3oooooooooobooool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo
00?<c?ooooooool03?ooo`09c/K>Q8B4moOgknO__KFeU7=kolk_okgFojg>
00;o[LH00oN]_ONL_ON]aP02ojg>00go_Lko]Mkoa^Ooa^Oga^Og_NOo]MKo
[LkoYLKgW;goU;GgU:goS:D00_n<[@;oU:d01_nD]On<[On<YOn4W?mkU>mc
S0;WHh@01=iJNnMSQ>mcS?MkU0OoQ9`2og^D00C_S9cNNhcNNiC_inoooooo
oooooc3oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool02_ooo`08koooooooe/k>Q7]kg^OWe]KF
_KFeNf=c1?negP04olKNokGNokgFmkgF0_n]cP;gYLh01Onme_neg_neg_ne
g_o6i`02okGN0_neeP05ojg>mibmmjFemhBUmhbU00;gQ:D3ohbU0_n4W00D
og^Dmg^Dkg><if>4if=kgUYkgUYckf^4kg><mg^DohBDohBLohbUohBLohbU
mg^Dmg>Dif^<kmkNkoooooooooooool_oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00coool0
1]K>cXAkNmkWilkFe[fe]G=BFP;g_MH01ONUc_nee_neg_neg_o6i`02olk_
00?oa^Oo]Mko_MH00on]cP05ojg6mkgFmkgFmkgFokGF00;o]Mh2okGF00So
YLKoW;ggU:g_S9c_Q9CgLiC_Lhc_Nh`2ohBD0omkU005mg><kg><kf^4ieYc
gV=c00;NFW<00nMSNnmcS?McS002ohbU0_m[S003g/kFmoOgmoOg0?oooooo
oooo;_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0<oooo00WFc/j<S8coooo_knoF_LIkDU[o
a^Oo_MKo[Lh00_n]aP04mjg6okGFokGNokGN0_o6i`03omK_olk_olk_00;g
a^L01?nee_n]c_n]a_N]aP;o[LH2ojg>0_nUaP07oibmoiBeoiBeohbUohBL
mg>Dif]k00;_Jh@00nMkQ?MkS?mkU003og^D00?gJhCgLhc_Hg/00miJL`05
kg><mg>Dog^DohBLmkgF00;_ooooooooooooobkoool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
2oooo`08moOge/k>S7^4moOgmno_inOWFV=Jolkg0oo6i`04olKNokGFmkg>
okGF0_NmeP;o]Mh03_o6ioo>kooFkoo>moo>koo6ioneg_nme_n]c_nUa_NL
_ONU]OnL_ONU]@?oW;d01onD]OnD[On<YOn4W?MkU>mkS>MSQ002if=k00?W
Jg__Hg__Lh`00_McS009kg><mg><kf^4kf^4mg><og^DmhBUmg^DokgF0?oo
oooooooo<?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV00Ooool00lc<ooooooooo`0<oooo00S>c/j4Ng_Wg]kNc]KFa/i2
@T;oc^og_Mh2olKW0_o>k`05olKWolk_olKWolKNmkgN00;g_MH2mkgN0oo6
i`08olk_olKWolKNolKFojg>ojg6mjfmoibm0_ND[@04miBUmiB]ohb]miB]
0on<Y@09ohBLmg^Dkg><kf^4if=kgUYcgV=cif=kkf^400?gLh`2ohBL00Gg
S:GgNiCo_Lkoooo_ool0ooooooooool^oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00coool0
1mKFeXb<S?O_knONg]kFeT8i>Oo6i`04mkgN00Ooa^Ooc^ooe^oog_Ooc_Oo
e^ooc^l00_o6i`;g_Mh00oNmioNmg_NmgP04okGN00[o_MKo[Lko[LKoW;gg
YKGoS:ggS:G_S9c_Q9CgNi@5ohBL0_mkU00<mg><kg><if]kgV=ccV=cgV=c
if]kkg><ohbUmhBUmg^DokgFooooooooool`oooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`80000=oooo00_>c/j<
S8coooogknoWg^M:>D;oc_Ooa^Ooc]kg_Mkg_MH00oNmgP03olKWomK_omkg
00;og_L01ooFkoo>mooFkoOFkoO6ioNmg^nmeP02mkgF0_nmeP0:okGFojg>
ojg>ojg>ojg6mjFeoiB]mhbUmhBDkhBD0^mcS00Big><kg^<mg^DmhBDohBL
mhBDmg>Dkg><kf^4if>4gV]kkf^4ohbUmhbUmg^DokgFooookooooooooooo
ool^oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH01oooo`80000=oooo00O>c/j<S8cgmoOgknoWinM:BT[og_L00_o>m`05
omkgolKWolk_olKWolkN00?ga^L01Oo6iooFkoo>moo>mooNm`03olkg0_o6
i`03mkgNkjg>kjg>00;g[LH00oNL_OnL_ON]_@02oibm00kgYKGoU;GoU:g_
S9c_Q9CWNhcWHhCWNhCWHhCWNhC_Lhc_Q9CoQ9cgQ9@2mg^D00GgQ9CoS:gg
S:GoS:Go_Lh0ooooooooool`oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`80000;oooo00W_ooooooo>c/ikNg__
knoNg]kFe]I2@T;ga^L00_oFk`07olkgomK_omK_omkgolkgomkgolkg00;o
e^l3mmK_017oe^oog_Ooe^ooe^ooc_Ooe^ooc^ooa^Ooa]ko[Lkg[LK_YKg_
W;GgU:ggW:ggU:GoS:D00onD[@;oS:D01On4W?MkU>mkS>MSQ>MkQ002gV]k
00SWNhCWLhcgNiCoQ9coS:G_NjGoS:Gg]LH8oooo00@0003oooooool00002
oooo00@0003oooooooooool2000000?oool0003oool00_ooo`800005oooo
0`0000Goool400001Oooo`030000oooooooo00?oool00`000?ooooooo`3o
oooomOooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool200003Oooo`07c]KFS8b<ooooinOWg]KFFUYJmkg>00;oa^L0
1OO6ioOFioo>kooFkoo>m`08omkg0_o6i`0>mlKWmmKWolKWomK_olKWolk_
olKWokGNokg>ojg6mjfmoiBemiBUkhbL0^N<U003khbLohBLkhbL00?_S9`0
1On4U?N4U>mkS>McS>MkQ002gV]k00GWLhcoS:GgU:goS:Gg[Kd02?ooo`04
0000oooooooo00000_ooo`040000oooooooo00000_ooo`800002oooo00@0
003oooooool00003oooo00D0003oooooooooool000000oooo`030000oooo
oooo00;oool00`000?ooooooo`03oooo00D0003oooooooooool00000oooo
ooSoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP06oooo100000coool01lk>cXb<S?ooooOgmnOWig=SJnnmeP02omK_00Go
a^Ooe^oga^Oga^Oge^l00_oFk`Oog_L00ooFkoo6ioNmgP02mkgF00Gg_Mkg
_MKo]MKo]MKo_MH00_n]cP08ojg6oibmmjFeoiB]ohbUkhbLihbDig^<0^n4
U004ohBLmhBDkhbLohBL0_N4U0;_Nh`01ON4U?n<[OND[On<[NnU_@08oooo
00L0003oool0003oool0003oool000000_ooo`050000oooooooooooo0000
00;oool00`000?ooooooo`03oooo00<0003oooooool00oooo`040000oooo
oooo00001?ooo`030000oooooooo00?oool010000?ooooooo`000?oooooi
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
1Oooo`030000VIW<VIW<00:IVL`00`000?ooooooo`09oooo00O>c/j4Q8C_
knoWinONg]j<U8bmW;D01ooNm`05mnO_omK_mmK_mmK_omK_00Oog_L01oo>
moo6ioNmg_Nme_Nmc_Nea_N]aP02mjfm00?o[LKg[Kgg[Kd00_NU]@06mib]
miBUmiBUkhBDig^<gW^<0nMkS009khBDmhBDkhBDkhbLkiBLoiB]ohbUkib]
oiBe00Soool01`000?ooo`000?ooo`000?ooo`000003oooo100000;oool0
0`000?ooooooo`03oooo00<0003oooooool00oooo`030000oooooooo00Go
ool00`000?ooooooo`04oooo00<0003oool00000ooooooWoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP04oooo00@0001V
IYVIVLc<c?l2oooo00>IVL`0003<c?l01<c<o`Goool01mKFeXb<S>o_kmkN
g/K6aXakQ9bDW003omK_2ooNm`03omK_omkgomK_00Coe^l2olk_00Coa]ko
_MKo[Lko[LH2mjFe1?NL[@CoU:d01On<YOn4W>n4U>mkS>MkQ002gW^400WW
NhC_NhcgQ9CoU;GoS:G_W:goU:goooogmoL01_ooo`070000oooo0000oooo
0000oooo000000Koool010000?ooooooo`0000Goool00`000?ooooooo`03
oooo00@0003oooooooooool400002?ooo`030000oooooooo0?ooooohoooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01?oo
o`030000IVJIc<co008000000ooooiVIc000000:oooo00O>c/j<S8coooo_
knoFe]JUYJFDLg/00_oNm`03omK_olkgomK_00_og_L00ooFkoOFkoo6i`02
olKW00Koc^ooa^Ooa^Ooa]koa]Ko_MH2ojg600CgYKGoU:ggU:G_U:D2khbL
00C_U:GgS:GoS:GgU:D2ohbU00[_U9c_Q9C_NhcWNhcNNhcWNhcoU;GoS:G_
W:goU;D8oooo00L0003oool0003oool0003oool000000_ooo`050000oooo
oooooooo000000;oool010000?ooooooo`0000;oool00`000?ooooooo`03
oooo00@0003oooooool0000;oooo00<0003oool00000ooooooWoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP04oooo00<0
001VIYW<c?l00P000003c<coVIW<000000[oool01lk>cXB4Q?ooooOgmno_
klK>cW]SL`02omkg00Gginoog_Oginooe^oginl01OoNm`03moOgomkgmoOg
00?og_L2omK_00?oa^Ooa]kg_MH00_nmeP04olKFokgFokgFojg>0_n]aP04
mjFeoiB]kiBLkhbL0nN<U006khBDkhbLkhbLkhbLohbUkiBL0^n<W003mhBD
mjFeohbU00;gU:d00oO_koooooooo`05oooo0P0000?oool200000oooo`<0
0004oooo0P0000?oool00`000?ooooooo`03oooo00@0003oooooool00004
oooo00<0003oooooool00oooo`040000oooooooo0000ooooooWoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP04oooo00<0
001VIYVIVL`00/c<o`:IVL`00`000?ooooooo`08oooo00S>c/j4Q8CgmoOW
inOFe]K>a/ISDU[ooolComkg00Ooe^oge^Ooa^Ooa]Kg_LkgYLkg]LH01ON]
_@;gYKD04_nD[ONDYONDYNn<W>N<U=ikQ=ikS>MkS=ikU>n<W>n4U>n<W?N<
YONU]OnD[ONL[On<YOOWi`Ooool200000oooo`80000@oooo00D0003ooooo
ooooool000000oooo`030000oooooooo00;oool00`000?ooooooo`03oooo
00D0003oooooooooool00000ooooooSoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP05oooo00<0001VIYUVIYT00VIVV@03
0000oooooooo00Woool02Lk>cXB4Q?OgmnOWilk>c[g6_E92@_oNmoOgm`05
omkg00Cooooog_OoioogmoL:omkg00Soc_Ooe^ooa^Ooc]koa]Ko[LKg[LKg
[Kd2mjFe1?NL[@;oU:d01?n<YONDYON<YNn<W0;WS9@3gW^<00KWS9CgYKGo
S:GgU:goS:g_g]h7oooo00<0003oooooool00oooo`030000oooooooo00oo
ool300001Oooo`@00005oooo00<0003oooooool00oooo`030000oooooooo
0?oooooeoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01_ooo`@0000<oooo00O>c/j<S8cooooooooWinOFe]I:>D802?oN
m`0:ooooomkgonOoomkgonOoooooomkgonOoomkgmnO_0ooFk`0>mmKWolKW
omK_olKWolkNolKNokgFojg6mjfmmjFemib]miBUkiBUkiBL0^nDY@03mhbU
miBUmiBU00;gU:D00nnDW>n<W>N<U002ihbD00Gg[KggU:ggW:goS:Ggg]h0
ooooooooool_oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo00coool02=KFeXb<S?ooooooono_
knOWieY2B_ooo`Kog_L02_OgmooNmoooooooooOgmooooooNmooooooNmooo
o`;og_L2omK_00Koa^Ooc]kg_MKg_MKo_MKoa]H3okg>00Oo[LKg[Kgg[Kgo
U:ggW:ggU:G_U9`00nN<U005ihbLkhbLmiBUmiBUkiBU00;gU:D01ONU]OnD
[ONL[On<YNoNgP3oooooooooobooool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03?ooo`08c/k>
S8b<kno_inOWg]kNe]KFFTYBimkW0_ooo`03omkgoooooooo00Oog_L00ooW
oooNmooNm`05omkg00Gginooe^ooa^Ooc]kg_Lh00_NeaP;g[Kd00on]a_N]
_ON]_@02mjFe0_NL[@06kibUkiBLihbLihbDgXB<gW^D0^N<U0;_S9`01oN]
_ONL[ONL[ONL[On]c_ooonooo`3oooooooooobgoool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
3?ooo`0;c/k>S8b<ooookno_g]kNa/K6Lf=[e/k>omkgmnO_moOg00;og_L0
1_oooooWooOgmooooooNmooWo`?og_L01_oWoooNmooNmooNmoOWkooNm`?o
e^l2olKW00Coa]Ko_Lko[LKg[Kd3mjFe00CgW:g_W:ggW:ggU:D2mib]00Ko
U:g_W:G_U9cWS9cWS9CNNi@2gXB<00Gg[KggW:g_[KGgW:go[LH0oooooooo
ool_oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH01oooo`03c<cooooooooo00coool05/k>cXb<S?ooooooooOgmmkNgYB<
S9bDW?oooooNmoooonoWkooooooNmoOgmooWoooNmooWooOgmooWooOgmooW
o`Cog_L2omK_00?ge^Oga^Ooc]h00_o>gP05olKNolKFokgFojg6mjfm00;g
YKD01NnLYNNLYNnDYNnDYNnLY@06miBU00S_U9cWS9cWS9cgW;ggW:ggYKG_
[KGo[LKoooooooooobooool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03?ooo`08c/k>S8b<oooo
oooomoOgkno_[Jf]W9BL0oooo`;og_L05?OgmooNmoOgmooNmooooooNmooo
oooNmooooooNmooWoooNmoOgmooNmooFkooWioo6ioo>g_o6e_NmeP?o_Lh0
0oNma_nmc_n]aP02mjfm00GoU:ggW:g_W:G_S9cWS9@00nN<W005kiBLkibU
kiBUkiBUmiBU00?gYKD00oNL[On]a_ooo`3oooooooooobkoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oo
ooooool03?ooo`08c/k>S8b<moOgkno_g]kNe]KFg]KFFTYB0_ooo`0Aomkg
ooooooooomkgooooonOoooooomkgooooomkgmoOgomkgooooomkgonOoomkg
moOg00?og_L01_OFioo>g_o6e_Nmc_Nea_n]aP;g[Kd2mjFe0_N]_@;gYKD0
1^nUYNnLYNnLYNN<W>N<U=ikU0?WS9@01nN<W?NU]ONU]ONU]ONL[ON]_OOg
m`3oooooooooobkoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP07oooo00?<c?ooooooool03?ooo`09c/k>S8b<oooomoOg
inOWe]KFe/k>:B4QimkW00?oool00oO_kooWooooo`04oooo00Cog_Oooooo
g_Ooool2moOg0ooNm`Coe^l01OOFioo>g_o6e_Nma_n]aP03mjFe00C_W:gg
W:ggW:ggYKD2mib]00WoU:ggU:G_U:G_W:G_U9cWS9CNNiCWS9Cg[Kd00_NU
]@03mib]kjFmmno_0?oooooooooo;_ooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0<oooo00?>
c/j<S8coool00_ooo`07kno_g]kN_KFe@STie/k>ooooomkg00[oool01OoW
oooNmooNmooNmoO_k`02omK_0_OFi`0;olKWolkNolKWolkNolKFolK>okg>
mkg6mjfmmjFekjFU00;WW:D5kibU0_NL[@03miBUkibUkibU00GgYKD00noW
koooooooo`3oooooooooobcoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03?ooo`03c/k>S8b<
oooo00;oool02OOgmoO_knOWilk6aV=BFT92@W=SJiBDU?OWk`05oooo00?o
ioooooooool00oooo`09onOoomkgomkgomkgomK_olkNolkFmkgFmlK>00Co
_Lh3mjfm0_NU]@04mib]kibUihbLihbL0^N<U0;WS9`2kibU00?gW:gg[Kgg
YKD00_NU]@03kjFeinOWoooo0?oooooooooo;Oooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0<
oooo00O>c/jDU9CgmoO_knoWinONg]kWinL00]kNgP;WinL01lk>cYbLW6][
JeY:DW=JHibDW>oNgP02oooo00SgmoOooooog_OoooooioogmoOog_OgmoL2
omkg00Goe^oog_Ooa^Og_MKg_Lh00_NmaP03kjfemjfmmjfm00Cg[Kd2mjFe
00?_W:ggW:gWW:D01NN<U0;gYKD01?Nma^nU_OnL_Oo>e_oooooooooo;_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0;oooo00?gmoO_knmcLg<00_ooo`07moOginOWc/k>
c/k>a/K6c/k>e]KF00?Ng]h02>ONg]k>e[F][G=cLdY:BV=BFYb<U=K6cP;o
ool00oOgmooNmooNm`02omkg00[oiooog_Ooe^ooinOoe^ooc]koa/ko[LKo
a/kgYKD6mib]00O_YJGgW:ggW:ggW:ggU:G_YJG_U9`00^N<W006mjFemjfm
mjFekjfemjFeolK>ooooooooool^oooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00goool00e9:
D_ooooooo`02oooo00?_knoWinONg]h01<k>cP0Aa/K6e]KFe]KFg]KFg]kN
inOWg]KF[JFUNg]kFTYBHe9JS7^4a/K6omkgoooommK_imkW00Goe^l01Oo6
ioo>g_nme_nmc_NmaP02mjfm00CgYKG_YJGWW:GWW:D3kibU00__W:g_YJGg
U:G_YJGgU:GgYKGg[Kgg_LK_[KGoW;goa/h0ooooooooool^oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo00goool00jf][G]kNoooo`03oooo00GgmoO_knoWinOWinONg]h0
0]KFeP06c/k>a/k>a/K6a/K6a/k>c]KF0]kNgP0@inOWimkW_KfmQ7>4FT9B
FT9:Q7>4_IbemmKWomK_mmKWmkgNmkg>okgFolKNokGN0_nmeP0Eokg>ojg6
mjfmkjfemib]kjfekjFUihbLiibUihbLgYBUihbLkjFUkibUmjFemkG6mjFe
kjFmmjfmmkg6moOg0?oooooooooo;Oooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0>oooo00Ac
Lg>m]KGgmoO_knl2g]kN0^OWi`0Dkno_moOgkno_inOWg^OWg]kNe]kNc]KF
a/k>a/K6_LK6a/k>a/K6c/K>e/k>g]kNinOWimkW_KfmU9BD0V=:DP07LeYS
]IbLkkgFonOWmkgNmkg>kjg>00;g[LH02ONea_n]a_Nma_Nma_NU]ON]_ONL
[NnLYNnUY@02iibU00WNU:GWS9CgYKGg[LKg[Kgg]LKoW;gg_LKog_L0oooo
ooooool]oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo00koool01nOWie9:D_ooooooono_kmkN
g]KFeP02c/k>00?Fe]KNg]kWinL00no_k`;WinL00mkWimKNg]KFeP05c/k>
00cFc/kFe]KWg]kWinOWg^ONc]JLU9acFV=J>D9[BUZ<Jg?_[KD2mkg600Kg
[KggYKGgW:ggYKGg[KggYKD2mjfm00WgYKGgW:ggW:g_W:GWW:Gg[Kgg]LKg
[Kgg[LH00_N]_@03mnO_oooooooo0?oooooooooo:oooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0;oooo0_Ogm`;oool00dY:B_ooooooo`02oooo00?gmoOWinONg]h00mKF
eP05c/k>e]KFg]kNg]kNinOW00;_knl00nOWimkWimkNgP02e]kN00GFe]K>
e/k>c/k>c/kFc/h00]KFeP06g]KFimkWinOWe/k>_KFeLeYS0W=:DP0:U6]c
aYBLijfekjFmijfegYBUkib]mjFekjfekib]0oNU]@04mjfmkjg6mjfmmkG6
0_N]_@03mnOWoooooooo0?oooooooooo:oooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0=oooo
00GgmoOooomSHf?_knogmoL01Oooo`06moOgkno_inOWimkNg]kNe]KF0/k>
cP05e/k>g]KFg]kNinOWino_00C_knl2inOW00?Fg]k>e]K6c/h00lkFcP07
e/k>e]KFg^OWg^OWg]kN_KfmQ7]k009J@TX018ASJlj4S>nL[NnU]@;_W:d0
2^nLYNNLYNnL[ONea^nU_ONma_N]_OnL_ON]_NoNg_oooooooooo;Oooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0=oooo00KgmoOooonLW9bU[JGoooogmoL3kno_00CgmoOo
ooooooooool2moOg00G_knoWinONg]kNg]kFe]H00lk>cP;Ng]h00oOgmooo
ooOgm`03moOg00C_knoWinONg]kFe]H4c/k>00?>e]K>c/kNg]h00]kNgP0:
_KfmU8b<FT9:FT92Ne9JYG=ceYbUkjfeiibUkjFm0_n]aP04mibmojg6mibm
olkNooooooooool]oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00ooool01>OWie9:D^o_koOg
m`;oool01No_knONg^OWino_knOWi`02moOg0_ooo`;gmoL2kno_00ONg]kW
inOFe]JDU9ASHf><S8cFe]H01Oooo`06moOgkno_kno_kno_g^OWe/k>0lk>
cP04a/K6c/k>e]KFc]KF0^OWi`0<e[g6W8bDLe9JHcTiJd9:W6]caYbUkjg6
mjg6mkg>kjg>mkg>ooooooooool]oooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013oool01MKF
eU9:DZFUYLk>c_Ogm`02oooo00C_ooogknoWinOWknl3inOW013_knogmoOg
moOgmoOoooogmoO_knogmoOooooNg]jLW9b4Q8ASHf>4Q8Bm_Kg_knl2oooo
0_Ogm`05mno_ino_inOWg]kNe]KF00;>c/h01/k6a[g6a[g6a[g6a/k>c]KF
eP?Ne]H01kFLW9b4S7=BFV]2BXaSJlJLYOoWi`3oooooooooobgoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool03Oooo`03moOgoooomoOg00;oool01no_kkfm_Hb<S7=cLhb<
S;fe]NOWi`02oooo0_Ogm`;WinL2g]kN0^OWi`?gmoL2oooo00[gmoOooooo
ooo_knnm_Kf4Q8ASHf=kNg^m]KGFg]h2moOg013oooogmoOgmoOgmoO_knoF
e]KFe]k>c/k6c/jma/Jm_Kfma/K>e/jma/KFe]KgmoL2oooo00?gkno_inoo
ool0ooooooooool]oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00coool00oOgmoooooOgm`04
oooo00[gmoOoooooooooooo>c/jLW9akNg^4Q8BUYJGNg]h2oooo00KgmoOW
knoWinO_knoNg]k_knl:oooo00?_knnm_Kf<S8`00W=cL`04YJFUc/k>kno_
kno_0_Ogm`07imkWmoOgknO_g]kNe]KFa/k>_LK600;6c/h00noooooooooo
o`3ooooooooooc3oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP07oooo00?<c?ooooooool04?ooo`03moOgoooooooo00Co
ool01_OgmoooooooooooomkNgZFUY@9kNg/01YbLW<k>c^o_koOgmno_koOg
m`koool02OOgmmKFeYbLW7=cLf][JiBDU;fm_NOWinoNgP02mno_00OginoW
inONg]kFe]k>e]Koooo_ool00_ooo`03kooooooooooo0?oooooooooo;?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0:oooo00GgmoOoooooooooooogmoL04?ooo`05kno_
_KFeS8b<a/K6moOg01Coool01mkNgZFUYHAkNf=SHhAkNjf][MKFeP02kno_
00?_inoWknogmoL01?ooo`03moOgoooooooo0?oooooooooo:oooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`0=oooo00?gmoOoooooool0;?ooo`06kooo_LJmQ8B4Hf=SJg=[
a/K6ooooooooooldoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo0?ooooooooooM_ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`3oooooooooogKoool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP3ooooooooooh3oool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP3ooooooooooh3oool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP03oooo00O_knn]
[JeJJf>LW9cWa/KWinOgmoL01?ooo`03kooomoOgoooo0?ooooooooooKooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;o
ool02mkNiiB<S10H44Y:BRTQ8JecNg]kNiB<S:f][MJma^o_k`3ooooooooo
og?oool01FIVI_ooohS0^8S0^4R@R001000000005hS0^<SPf8S0^8S0^6IV
I_ooonO_kkfm_BTa:Kg6_OooocTH8Lj4S<icNlI[Lje[JiaSJha[Lib<S;fe
]MKFe^o_koOgm`3oooooooooofkoool01FIVI_ooohS0^8S0^4R@R0010000
00002HS0^<SPf8S0^8S0^6IVI_OgmmK>eYbDW34i>@02oooo00mkDU[>NhCo
NiC_LhcWNhC>Lg^mJg>UHf^UHf>DJg>4Q8BLW9bm_KgNg]kgknl0oooooooo
oom[oooo00EVIVKooon8`;R8`;Q8T8P00@00000000V8`;S8h=R8`;R8`;QV
IVKWinO6c/j<U8aJFUX00_ooo`04LeYScW^Dohb]ohbU0_n4W0;gNh`02nmS
NnMJLlI[Lje[JjESHiA[LiB4Q:F]YLK>c]k_koOgm`02oooo00?_oooooooo
ool01?ooo`03kooooooooooo0?ooooooooooFoooo`05IVIVooooR<2hR<2h
B928004000000009R<2hb>3HR<2hR<2hIVIVmnOWe]KNYJfUJg=[00;oool0
5f]cJmj<[OnUc_nUc_ND_OnD]OND[On<YNn<W?n4W>n4U=ikS=IcQ<icNke[
Lje[JjESHjE[Jib4S;FLW<k6c^OWioooo`03kooo2oooo`03kooomoOgoooo
0?ooooooooooD_ooo`05IVIVooooR<2hR<2hB92800400000000@R<2hb>3H
R<2hR<2hIVIVmno_ino_[Jf]Jf=SimkWe]kNHdYBaW>DoiBeoibmojG60_nU
cP0DojG6miBmkiBmohb]ohbUmg^DmhBDmg^<ig^4kf=kif]k]G=cYF]cW6=[
U6]cW8b<_KFec]kFioOgmoOg1oooo`03moOgoooooooo0?ooooooooooEOoo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;o
ool03Kfm_F]cJnONilkFeV]JF/IcU?M[Q?McS?McU?N4YOnD]OnL_OnUaP02
ojG>01OoW;goU;GoS:goS:goQ9cgNiCgLiC_Q9CWNhCFLg_>Hg?6Lg>ULg>L
Jg>LLg^]YJFm_KgWg]kgmoO_ooooooogmoO_ool01oooo`03moOgoooooooo
0?ooooooooooC_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00;oool02<K6aXB4Q?OgmnO_khakNmj<[OnD]On<[@;gLi@0
1>mcS?McU?n4W?n<Y@;oYLH2okGF01CoYLkoYLKgU;g_S;GgNiCoQ9cgLhcg
NhcgNiC_JhCFLg_>Hg>eLg>UJg>ULg>UNg^eW9bm_KgWinO_oooooooooooo
oeSoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP02oooo00K>e/j4Q8C_inoWinNDQ8CNS:d2oibm00CoU;GoS:goS:GgQ:D2
mg^D00KNNiCoQ9coU:goU;GoYLKoYLh2okGF00GoYLkoYLKoU;GoS:GgNi@0
0oMcU00=mg^<ig^4eW=kaV]c]G=c[F][YG=cYG]k]Jf]e/k>inOWmoOgoooo
00?_oooooooooooooe3oool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP02oooo00Jma/IkNg_Fc]K>c/i[Lf_>Ni@3ohb]00?o
U;GoW;goW;d00_NL_@;oS:d02OND[ON4YON4YOND[On<[OnD]OnUa_nee_nU
cP02ojG600WoW;ggU:ggQ:GoQ9coNiCgNiCgQ9CWNhcNNh@00/iSL`09YG=k
W6]cW7=k[HbD_KFeg/kFmno_ooookooo0?ooooooooooCoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool01/kFcXb<
S>oWkmkWiiAcNlikW0;oS:d2mhBU00SoS:goU;GoW;goW;goYLKoYLkoYLKo
W;d2oiBe00WoS:GoQ9c_NjGgS:GoU;GgW;goYLKo[LkoYLH00_nL_@0Bkhbe
mhBUkg^UohBLkg^Umg^DkhBDig^<eW=kaW=k]F]kYF]cU6]cW7]k[HbDa/K6
e]KFmno_oooooooooom=oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH00_ooo`0:e/K>S8b<koookno_W9BL]IbLojG>ojG6
oibmoiBe0onD[@0AoiBekjG>mibmmjg6ojG>ojg>ojG>ojG6oibmoiBeohb]
ohbUkg^Umg^DmhBUohb]oiBe00?oW;d05?nD]On<[On<YOn<YON4YOMkU?Mc
U>n4U>mkS>McS=i[NliSLliJJjE[Jia[LiacNkFLW=Jma]kNg^ogm`;_ool2
oooo00C_ooooooooooo_oooooooooooood7oool01FIVI_ooohS0^8S0^4R@
R0010000000048S0^<SPf8S0^8S0^6IVI^ooooooolk>cXAkNmkWimKFeYb4
S9b<U?nee_nUc_n]cP;oYLH01?n]a_nL_OnL_OnD[@?oU;D01?nUa_N]a_n]
c_nUcP;oYLH2oibm00SoU;G_NjG_NjGWS9cWLhc_Q9CoS:GoS:d2oiBe0_n<
[@;oS:D01_n4W?MkU?N4U?MkU>n4U>mkS0;>Nh@02[E[NjE[LjE[LiAcNjf<
U;fUYLk>c^ONg_ooonooo`;oool00nooooooooooo`3oooooooooocooool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo
00[Fc/j4Ng_NinO>c/jDS8bLLg__YLk_[LKgW;go[LH2ojg>1?neeP04ojg>
ojG6oibmoiBe0_nL_@05mjg6ojG>ojG>ojg6ojG600;oW;d02?nD]On<YOn4
W=ikU>mcS>McS?MkU?n<Y@?oS:d2ohbU0_n4W008mg^DmhBDmg>DohBLgW^D
ig^<cW^4_F]c0[EcL`07U7=k[HbDolkNkooomoOgooookooo0?oooooooooo
@Oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00;oool01mK>cXb<S>ogmnOWijfUYIAcNonUaP02mibm00GoU;GoW;goYLKo
[LKo[Lh00_NmgP?o]Mh00onee_n]c_nUaP02mibm1?nD]@;oW;d2oiBe00Co
S:goQ9cgNiCgLh`3if>400C_LhcgNiCoQ9coS:d2ohbU0on4W0;oNi@01?n4
U?N4U>mkS>MkQ0;6Nh`00nnU]Oooonooo`3ooooooooood?oool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00W>a/j4
Q8CgmoO_innm]KFDLg_oc^oo_MKo[Lh00_n]aP03mjfmmibmmjg600;o[Lh0
3Onmc_neg_o6ioo6ioO6ioNmionee_n]c_nUa_NL_OnD]OND[On<Y@02ohb]
0_nD[@06oiBeohb]ohbUohBLog^Dkg><0^MSQ004gUYkif>4kg><mg^D1on4
W0;oNi@01>n<W=ikS=ikU>oWkoooooooooooA?ooo`05IVIVooooR<2hR<2h
B92800400000000=R<2hb>3HR<2hR<2hIVIVkoooooooe/k>Q7]kg^OWe]KF
_KFeNf=c00Co]Mh01?o6g_neg_nme_NmeP;o[Lh2mjG>00Go_MKo]Mko]Mko
]Mkoa^L00_negP;o]MH01On]c_NL_ONU]ON4YON<Y@02mhBU0on<Y@;oQ9`0
5?mkU?MkU>mcS>MSQ>MSNmiJNmiJLnm[Q>mcS?MkU?n4U?n4W?n<YOn4W?n<
YOMkU?McU>M[S>oNg^oooooooooooooo@oooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00;oool01]K>cXAkNmkWilkFe[fe
]G=BFP;g_MH01ONUc_nee_neg_neg_o6i`02olk_00?oa^Oo]Mko_MH00on]
cP05ojg6mkgFmkgFmkgFokGF00;o]Mh2okGF00SoYLKoW;ggU:g_S9c_Q9Cg
LiC_Lhc_Nh`2ohBD0omkU005mg><kg><kf^4ieYcgV=c00;NFW<00nMSNnmc
S?McS002ohbU0_m[S003g/kFmoOgmoOg0?oooooooooo@_ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool02MK>cXb<
S?ooono_kmJmaW]BF_o6ionme_n]cP02ojg600Cg[LKo]MKo]Mko]Mh2olKW
00?oe^ooc^ooc^l00_O6i`04okGFojg>ojg6mjg60_n]aP;o[Lh2ojG600Oo
W;goU;GoU;GoS:GoQ9cgLiCWJg/00^m[Q003ig^4mg^<og^D00?oNi@00oM[
Q?McS>mSN`03gUYc00G_LhcgLiCoNiCoQ9cg_MH00^oooooooooooooo@_oo
o`05IVIVooooR<2hR<2hB92800400000000>R<2hb>3HR<2hR<2hIVIVoooo
moOge/k>S7^4moOgmno_inOWFV=Jolkg0oo6i`04olKNokGFmkg>okGF0_Nm
eP;o]Mh03_o6ioo>kooFkoo>moo>koo6ioneg_nme_n]c_nUa_NL_ONU]OnL
_ONU]@?oW;d01onD]OnD[On<YOn4W?MkU>mkS>MSQ002if=k00?WJg__Hg__
Lh`00_McS009kg><mg><kf^4kf^4mg><og^DmhBUmg^DokgF0?oooooooooo
A?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00;oool02<k>cXAkNnONg]k>e]K6cT92@_o>koNmgP;oa^L2olk_00Goa^Oo
c^ooa^Ooa]kg_Mh00_NmeP;g_Mh3olKW00Soc^ooa^Ooa]koa]Ko[Lko[LKg
[KgoW;d2miB]00CgU:GgU:goS:ggU:d3ohbU00WoQ9cgNiC_Lhc_JhCWHg_N
FW?NHg?WHg__Jh@00oMcS0;oQ9`01ON<YOMkU?nmc_ooonooo`3ooooooooo
od;oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP02oooo00OFe]J<S8cgknoWg]kNe]I2>CWoa^L01?NmgP07olKWolk_omK_
omkgolkgomK_olk_00;oa^L2mkgN00?g_NOg_Mkg_Mh01?negP0:okgFojg>
ojg6oibmmjFeohb]mhbUkhbLkhBDmg^D1On4W0;oNi@03?McS>mcS>M[NmiS
LliSLmiSLnM[NnmcS?n<YON4YOMkU?nme_ooooooooooA?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool02lk>cXb<
S?ooooO_knONidXi@_o>moo6ioo>g_Nmg_NmeP03mkgN00?oa^Ooe^oog_L0
0_oNm`07omK_olkgomK_mmK_mlKWmkgNkkgF00;g_MH2okgF00[o]MKo[Lko
[Lko[Lko[LKgYKGoU:ggS:GgQ9C_Q9@2kg><01;WLhc_NhcgNiCgQ9CoQ9cg
Q9CgLiC_Lhc_JhCWHhCNJg__JhCoS:GgS:GgNiCo_MKoooo_ool=oooo00<0
003oooooool01?ooo`030000oooooooo0?oooooooooo:oooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool01lk>cXb<
S?OgmoO_knOWidY:B_oNm`02olkg00Gog_Ooa^Ooc^ooa^Ooc]h00oO6i`05
olKWomK_olkgolkgomkg00?oc_L2olKW00?g_Mk_[Lk_[Lh00_N]aP03mibm
oibmmjfm00;oW;d03_NU]OnD]OnD[Nn<W>n4U>MkS>MSQ>MkQ>MSQ>MkQ>mc
S>n4U?n4W?N4U0;gNi@01ON4U?n<[ON<YOn<YOnmcP0?oooo00<0003ooooo
ool01?ooo`030000oooooooo0?oooooooooo:oooo`05IVIVooooR<2hR<2h
B92800400000000>R<2hb>3HR<2hR<2hIVIVkoooooooc/k>Ng]kkno_g]kN
e]KF@T92mlKW0_oFk`07olkgomK_omK_omkgolkgomkgolkg00;oe^l3mmK_
017oe^oog_Ooe^ooe^ooc_Ooe^ooc^ooa^Ooa]ko[Lkg[LK_YKg_W;GgU:gg
W:ggU:GoS:D00onD[@;oS:D01On4W?MkU>mkS>MSQ>MkQ002gV]k00SWNhCW
LhcgNiCoQ9coS:G_NjGoS:Gg]LH7oooo00<0003oooooool00oooo`040000
oooo0000oooo0P0000?oool010000?ooo`00000000?oool010000?oooooo
ooooo`<0003oooooooooob3oool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP02oooo00O>e]J<S8cooooWinONe]IJFU[g_Lh0
0_o6i`05mlKWmmKWolk_omK_olkg00Sog_L2olKW00kga^Oge^Ooa^Ooe^oo
a^Ooc^ooa^Oo]Mko_Lko[LKg[KgoU;GgU:G_S9`2ihbD00?_S9coQ9c_S9`0
0nn<W005ohBDmhBDkg^<ig><ig^400;NJg/01NMcS?n<YOND[On<YON]_@07
oooo00<0003oooooool00oooo`040000oooo000000000_ooo`030000oooo
oooo00800002oooo00@0003oooooool00002oooo00D0003oooooooooool0
0000oooooooooolOoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH00_ooo`07c/k>S8b<oooomoOginOWLf=[kkgF00;oe^l0
1Oo6iooFkoO6ioO6ioOFk`02omK_1ooNm`03omK_olKWmkgN00;g_MH01ONm
g_Nme_nee_nee_nmeP02ojg>00So[LKoW;ggYKGoU:goS:G_S9cWS9CWNh`2
khBD00CoQ9cgQ9C_S9coQ9`2mhBD0^mkS005mhBDohb]miB]ohb]kjFm00So
ool01@000?ooooooooooo`000002oooo00D0003oooooooooool000000_oo
o`050000oooooooooooo000000;oool010000?ooooooo`000?oooooooooo
8oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00;oool01lk>cXB4Q>o_knOWimkNgXbDS;fL]@07omkg00Gginooe^oge^og
e^ooe^l01ooNm`07olkgolKWmkgNmkgFmkg>mkG6mjg600;g[Kd00on]a_N]
_ON]_@02mjFe00KgW:ggU:GgU:G_Q9CWNhcNNh`3ig^<00W_Q9CgQ9C_Q9C_
S9c_U9coU:goS:G_W:goU;D02?ooo`D00002oooo00D0003oooooooooool0
00000_ooo`050000oooooooooooo000000;oool00`000?ooooooo`050000
oooooooooolOoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH00_ooo`07e]KFS8b<kno_g]kNa/K6S7^4W9BL00?oe^l;omkg
00?oe^oog_Ooe^l01?oFk`;oc^l01?o6g_nme_n]c_n]aP;gYKD4mib]1?nD
[@05ohbUohBLkhBDkg^<ig^400;NNh@02NMkQ>mkS?N4U?nD]On<YNnL[OnD
[OooooOgm`06oooo00D0003oooooooooool000000_ooo`050000oooooooo
oooo000000;oool01@000?ooooooooooo`000002oooo00@0003oooooool0
0003oooo00<0003oooooool0oooooooooolMoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`07c/k>S8b<ooookno_
e]KFYJFUU7=k00;og_L00ooFkoo>mooFk`0;omkg00?oe^oge^ooa^L00_o6
i`06olk_olKWolKWolKNolKFokgF0_n]aP04mjFeoiB]miBUkiBU0^n<W004
kiBUmhbUohbUmiBU0_n<Y@0:kiBLkhBDkg^<ig^<gW^<ig^<oiBeohbUkib]
oiBe2Oooo`030000oooo000000?oool200000_ooo`030000oooooooo0080
0002oooo00@0003oooooool00002oooo00D0003oooooooooool00000oooo
oooooolOoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH00_ooo`07c/k>Q8B4oooomoOgkno_a/k>Nf=c00;og_L01OOWkooN
moOWkooFkoOWk`05omkg00?gmoOog_OgmoL00ooNm`;oe^l00oo6ioo6g_Nm
eP02okgF00Coa]Ko_MKo_MKo[Lh2ojg600CgYKGoU:g_U9c_S9`3ihbD00K_
Q9C_S9c_S9c_S9coS:G_U9`2khbL00?gQ9CgYKGoS:D00_ND[@03mno_oooo
oooo00Koool00`000?ooo`000003oooo00@0003oool000000003oooo00@0
003oool000000003oooo00@0003oooooooooool30000oooooooooolPoooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_oo
o`08c/k>Q8B4moOginOWe]KFc/K6He9Joooo4ooNm`07omK_mmKWolKWolKF
mkg>mjG>mkG600Gg[Kd2mjFe01;oU:ggU:GgU:G_S9cWS9CNNhCNNhcWNhcN
NiC_S9c_Q9C_S9cgS:GgYKGoU:ggW:goS:GginL8oooo00<0003oool00000
4Oooo`030000oooooooo0?oooooooooo9?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00;oool02Lk>cXB4Q?OgmnOWilk>
c[g6_E92@_oNmoOgm`05omkg00Cooooog_OoioogmoL:omkg00Soc_Ooe^oo
a^Ooc]koa]Ko[LKg[LKg[Kd2mjFe1?NL[@;oU:d01?n<YONDYON<YNn<W0;W
S9@3gW^<00KWS9CgYKGoS:GgU:goS:g_g]h9oooo00<0003oooooool04?oo
o`030000oooooooo0?oooooooooo9?ooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00;oool01lk>cXb<S?ooooooonOWimKF
eTXi@P08omkg00[ooooog_Ooiooog_Ooiooooooog_Ooiooog_Oginl3omK_
00kge^Ooa^Ooe^ooa^Ooc]koa]ko_MKo[LKg[KggYKGgW:ggU:G_U:G_U9`2
kiBU00?gS:GgU:GgU:D00_NDY@03kiBLkhbLihbD00;WS9@01ON]_OND[ONL
[On<YOONgP3ooooooooood?oool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP02oooo00SFe]J<S8coooooooo_knoWinMJ@T[o
ool6omkg00[gmoOog_OoooooooogmoOooooog_Oooooog_Ooool2omkg0_oF
k`06olKWolkNmkgFmkgFokgFolKF0onmcP07ojg6mjfmmjfmoiB]mib]miBU
kiBL00?WS9@01NN<W>n<W?NDYONDYNnDY@02miBU00GgYKGoU:ggW:goS:G_
g]h0oooooooooom3oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH00_ooo`08c/k>S8b<kno_inOWg]kNe]KFFTYBimkW0_oo
o`03omkgoooooooo00Oog_L00ooWoooNmooNm`05omkg00Gginooe^ooa^Oo
c]kg_Lh00_NeaP;g[Kd00on]a_N]_ON]_@02mjFe0_NL[@06kibUkiBLihbL
ihbDgXB<gW^D0^N<U0;_S9`01oN]_ONL[ONL[ONL[On]c_ooonooo`3ooooo
oooood7oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP02oooo00_>c/j<S8coooo_knoNg]k6a/IcHf_Fc/kog_OginogmoL0
0_oNm`06ooooonOomoOgooooomkgonOo0ooNm`06onOoomkgomkgomkgmnO_
omkg0ooFk`;oa^L01?o6e_nmc_n]a_N]_@?gYKD01?NL[NnL[ONL[ONDY@;g
W:d01_nD[NnLYNnDW>N<W>N<U=ikU0;NQ8`01ON]_ONL[Nn]]ONL[On]aP3o
oooooooood?oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP02oooo01K>c/j<S8coooooooogmoONg]jDS8bLU9cooooog_Oo
ooo_inoooooog_OgmoOoiooog_OoioogmoOoioogmoOoiol4omkg0_oFk`03
mmKWmlKWolkN00;oc]h01Oo6g_o6e_nme_n]a_N]_@02mjFe00G_W:GWW:G_
U:G_U:G_W:D01_NDY@08kiBLihbLihbLmibmmib]mjFekjfeojg6oooooooo
oom3oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH00_ooo`08c/k>S8b<oooooooomoOgkno_[Jf]W9BL0oooo`;og_L05?Og
mooNmoOgmooNmooooooNmooooooNmooooooNmooWoooNmoOgmooNmooFkooW
ioo6ioo>g_o6e_NmeP?o_Lh00oNma_nmc_n]aP02mjfm00GoU:ggW:g_W:G_
S9cWS9@00nN<W005kiBLkibUkiBUkiBUmiBU00?gYKD00oNL[On]a_ooo`3o
oooooooood;oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP02oooo00S>c/j<S8cgmoO_knoNg]kFe]KNe]IJBU82oooo017o
g_Oooooooooog_Ooooooiooooooog_Oooooog_OgmoOog_Oooooog_Ooiooo
g_OgmoL00ooNm`06mmKWolkNolKFmkg>mkG6ojg60_N]_@;gYKD2mjfm0_NU
]@06kjFUkibUkibUihbLihbDgW^D0nN<U007ihbLmjFemjFemjFemib]mjfm
moOg0?oooooooooo@_ooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00;oool02Lk>cXb<S?ooooOgmnOWimKFe]K>cRTQ8NON
i`03oooo00?gknooioooool01?ooo`04omkgooooomkgoooo0_Ogm`?og_L4
omK_00Gge^Ooc]koa]Kg_LKo[LH00oNU]@04kib]mib]mib]mjFe0_NL[@09
oiB]miBUkiBUkibUkiBLihbDgW^DihbDmjfm00;gYKD00oNL[NnU_OO_k`3o
oooooooood;oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP02oooo00?>c/j<S8coool00_ooo`07kno_g]kN_KFe@STie/k>
ooooomkg00[oool01OoWoooNmooNmooNmoO_k`02omK_0_OFi`0;olKWolkN
olKWolkNolKFolK>okg>mkg6mjfmmjFekjFU00;WW:D5kibU0_NL[@03miBU
kibUkibU00GgYKD00noWkoooooooo`3ooooooooood3oool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00?>c/j<S8co
ool00_ooo`09moOgmno_inOWc/K6He9J@T92Lf=[U9BDmnO_00Goool00ooW
ooooooooo`03oooo00Woiooog_Oog_Oog_Ooe^ooc]koc]Kg_MKga/h01?nm
cP?g[Kd2mjFe00CgW:g_W:GWS9cWS9`2ihbD0^N<W0;_W:D00oNL[ON]_ONU
]@02mjFe00?_YKGWinOoool0oooooooooom1oooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`07c/k>U9BDmoOgkno_
inOWg]kNinOW00;Ng]h2inOW00O>c/jLW9a[Jf]JBU9cFV>LU9c_g]h00_oo
o`08moOgooooomkgooooonOomoOgomkgmoOg0_oNm`05omK_omkgolKWmkgF
mkg>00;g_LH00nn]]ON]_ON]_@04mjfm0_NU]@03kib]mib]iibU00GWS9@2
mjFe00Cg_LK_YKgoW;goc]Kooooooooood;oool01FIVI_ooohS0^8S0^4R@
R001000000002HS0^<SPf8S0^8S0^6IVI_ooooOgmno_kg=cL`02oooo00Og
moOWinO>c/k>c/k6a/K>c/kFe]H00mkNgP08imkNg/kF]Jf]Lg=cBTY:He9J
W8bDe/K>0_ooo`03moOgomkgomkg00;og_L02_oWoooNmooFkooWiooFkoo>
g_o6c_n]a_o6c_NU]@KgW:d01nnUYONL[ONL[ONL[ONDYNnUYNnDW002ihbL
00KgYKGg[KggYKG_[KGgYKGoa/kooooooooood;oool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP03oooo00=BBU;oooooool0
0_ooo`03kno_inOWg]kN00C>c/h04LK6a]KFe]KFe]kFe]kNg^OWimkFeZfU
YG]kNeY:DV=BFXakQ<K6a_oNmoooooOFknONi`05omK_00Goa^Ooc]ko_MKo
_Lkg_LH00_N]_@04mjFekjFUiibUiibU0nnLY@0;kib]kjFUmiBUkjFUmiBU
mjFemjfmmkg6kjfeoibmolK>0?oooooooooo@_ooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00?oool00jf][G]kNoooo`03
oooo00GgmoO_knoWinOWinONg]h00]KFeP06c/k>a/k>a/K6a/K6a/k>c]KF
0]kNgP0@inOWimkW_KfmQ7>4FT9BFT9:Q7>4_IbemmKWomK_mmKWmkgNmkg>
okgFolKNokGN0_nmeP0Eokg>ojg6mjfmkjfemib]kjfekjFUihbLiibUihbL
gYBUihbLkjFUkibUmjFemkG6mjFekjFmmjfmmkg6moOg0?oooooooooo@Ooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Co
ool017=cLkfe]OOgmno_k`;Ng]h2inOW01C_knogmoO_knoWinONinONg]kF
g]k>e]K6c/k6a/Jma/K6c/k6a/K>a/kFc/kNg]kWinOWg^Nm_KfDU9@2HdYB
00McFV>eW9c__MKoinOg_Mkg_Lk_[Lh00_N]aP09mkG6ojg6mkg6mkg6mjFe
mjfmmib]kibUkjFU00;WW:D02MjDYNN<U?NU]ON]a_N]_ONea_nL_ONma_oN
m`3ooooooooood7oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP04oooo00OWinMBBU;oooooooo_knoNg]kFe]H00/k>cP03
e]KFg]kNinOW00?_knl2inOW00?NinOFg]kFe]H01Lk>cP0<e/k>e]KFimkN
inOWimkWg/kFW9BLLeYSFSU2JdYJS6]ckjfe0_NmaP06mjfmmjFemib]mjFe
mjfmmjFe0_N]_@09mjFemib]mib]kibUiibUmjfmmkG6mjfmmjg600;g[Kd0
0oOWkoooooooo`3oooooooooocooool01FIVI_ooohS0^8S0^4R@R0010000
00001XS0^<SPf8S0^8S0^6IVI_ooo`;gmoL2oooo00=:BT[oooooool00_oo
o`03moOginOWg]kN00?Fe]H01Lk>c]KFe]kNg]kNg^OWi`02kno_00?WinON
inONg]h00]KNgP05e]KFc]K>c/k>c/k>e/k>00;Fe]H01]kFe^ONinOWimK>
c[fe]G=JH`9cBU802YA[LlJDW>N]]NnU_NN]]MjDYNnL[ONU]Nn]]NnL[@?g
YKD01?N]_Nn]a_N]_ONeaP;g[Kd00oOWioooooooo`3oooooooooocooool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP03oooo
00GgmoOooomSHf?_knogmoL01Oooo`06moOgkno_inOWimkNg]kNe]KF0/k>
cP05e/k>g]KFg]kNinOWino_00C_knl2inOW00?Fg]k>e]K6c/h00lkFcP07
e/k>e]KFg^OWg^OWg]kN_KfmQ7]k009J@TX018ASJlj4S>nL[NnU]@;_W:d0
2^nLYNNLYNnL[ONea^nU_ONma_N]_OnL_ON]_NoNg_oooooooooo@Oooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00?oool0
1_OgmooooibLW:F]YOooooOgm`?_knl01?Ogmoooooooooooo`;gmoL01No_
knOWimkNg]kNg]KFeP03c/k>0]kNgP03moOgoooomoOg00?gmoL01>o_knOW
imkNg]KFePC>c/h00lkFe/k>c]kNgP02g]kN00Zm_KfDS8aJ@TYJ@T9kDUZU
Lg?FW:G_[KGWW:G_YKd2ojg600CgW;go[LKgW;goc]kooooooooood7oool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP05oooo
00CWinMBBU;_knogmoL2oooo00G_knoWg]kWinO_knoWinL00_Ogm`;oool2
moOg0^o_k`07g]kNinOWe]KFU9BDHf=SS8b<e]KF00Goool01_Ogmno_kno_
kno_kmkWimK>cP?>c/h01<K6a/k>c]KFe/kFeP;WinL03=JmaYb<U7=BFV<i
>F]2BYa[LlJLYNn]a_N]a_Nmc^n]c_Nmc_oooooooooo@Oooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Koool01MKFeU9:
DZFUYLk>c_Ogm`02oooo00C_ooogknoWinOWknl3inOW013_knogmoOgmoOg
moOoooogmoO_knogmoOooooNg]jLW9b4Q8ASHf>4Q8Bm_Kg_knl2oooo0_Og
m`05mno_ino_inOWg]kNe]KF00;>c/h01/k6a[g6a[g6a[g6a/k>c]KFeP?N
e]H01kFLW9b4S7=BFV]2BXaSJlJLYOoWi`3ooooooooood7oool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP03oooo00?gmoOo
ooogmoL00_ooo`07kno__KfmS8b<Lg=cS8b<_KFeinOW00;oool2moOg0^OW
i`;Ng]h2inOW0oOgm`;oool02_Ogmoooooooono_kkfm_HB4Q6=SHg]kNkfe
]MKNgP;gmoL04?ooooOgmoOgmoOgmno_kmKFe]KFg/k>c/K>c[g6a[fm_Kg6
a/kFc[g6a]KFe_Ogm`;oool00oO_knoWkoooo`3ooooooooood7oool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00?g
moOoooogmoL01?ooo`0:moOgooooooooooooc/k>W9bLNg]kQ8B4YJFUg]kN
0_ooo`06moOgino_inOWkno_g]kNkno_2_ooo`03kno__KfmS8b<009cLg<0
1:FUYLk>c^o_kno_k`;gmoL01nONioOgmnoWkmkNg]KFe/K>c[g6aP02a/k>
00?_ooooooooool0oooooooooom4oooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01_ooo`03moOgoooooooo00Coool01_Og
moooooooooooomkNgZFUY@9kNg/01YbLW<k>c^o_koOgmno_koOgm`koool0
2OOgmmKFeYbLW7=cLf][JiBDU;fm_NOWinoNgP02mno_00OginoWinONg]kF
e]k>e]Koooo_ool00_ooo`03kooooooooooo0?oooooooooo@?ooo`05IVIV
ooooR<2hR<2hB928004000000006R<2hb>3HR<2hR<2hIVIVmoOg0oooo`03
moOgoooooooo00koool01No_kkfe]Hb<S<K6a_Ogm`0Doooo00ONg]jUYJF4
Ng]SHf>4Ng^][JgFe]H00^o_k`03knO_ino_moOg00Coool00oOgmooooooo
o`3oooooooooocooool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP03oooo00?gmoOoooooool0;?ooo`06kooo_LJmQ8B4Hf=S
Jg=[a/K6oooooooooom8oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH0oooooooooon0oooo00G<c<cooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH0oooooooooon0oooo00EVIVKooon8
`;R8`;Q8T8P00@00000000B8`;S8h=R8`;R8`;SoIVIVofIVIX9VIVH01<c<
c8S0^8S0^4R@R04000000003R<2hb>3HR<2h0?n8`;SoR<2hQXS0^058T8P1
0000000018S0^<SPf8S0^8S0^1H0080300600P02P00400:100>100>100>1
0`04P@801H400`05PP06PP06PP0200J200@01h811h811h8128820@R30`49
P`<12X<00`4;P`4;Q04;Q0040@b40`4=Q0<13XD30Pn50`8@Q@<24HH40Q:6
0P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0@368P0
0`<IR0<IR@<IR@030aZ90`<KR@<378X30af:0`@NRP@47h/3122;0P@QR`04
126<12:<12:<12:<0`@SS08498`00`@TS@@US@@US@021BF=0`DVS@031BN=
1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl010D[S`<5;8l31Rf@0`H^T0<6
;i031S2A10HaT@86<Y401@HbTPHcTPHcTPHcTPHdTP021cBB00<7=I87=I<7
=I<00`LfT`@7=i<31cRD0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88
@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00<9@iP9A9P9A9P00PU4V0<9AIP0
0`U6V0U6V@U6V@032DNI0`U8V@032DVI2DVJ2DVJ00@9BYX32T^J0`Y<V`<:
CI/22TjK00@:CY`:Ci`:Ci`:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]C
W@032eBM2eBN2eBN00<;EIh42eJN0`]GW`<;F9l32eVO0`aJX0<<Fj0335bP
10aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00@=HJ8=HZ8=HZ8=HZ<4
3F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@@>JJD23VZU00@>JZH>
JjH>JjH>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW10i_Y`033W2W3g2X3g2X
00<?LJP33g:X00<?LjP?LjT?LjT00`mdZ@@?MJT33gJZ0`mgZP<@N:X347V[
0a1jZ`<@Nj/447b/0a1m[08@OZ`0111n[A1o[A1o[A5o[@<AP:d00a61[A61
[Q61[P044H:^0a63[P<AQ:l34HF_0a66[`<BQk044XR`0Q:9/0044XVa4XZa
4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[824hjb00<CSk8CSk<C
Sk<00a>@/`<CTK<00a>B/a>B]1>B]0034i>d11>D]0<CUKD359Je0aBG]@<D
V;H359Vf0QBJ]P0359Zg59^g59^g008DVkL359bg00<DWKLEWKPEWKP00aFN
^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/45ZNk
0QJX^`045ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`011J[_AJ/_AJ/_AN/_@@G[Kd0
0aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P4002000>KYo4c@jDc@jD02C=3
Y@H0080300600P02P00400:100>100>100>10`04P@801H400`05PP06PP06
PP0200J200@01h811h811h8128820@R30`49P`<12X<00`4;P`4;Q04;Q004
0@b40`4=Q0<13XD30Pn50`8@Q@<24HH40Q:60P8CQP040Q>70QB70QB70QB7
0`8EQ`825XL010<FR0<GR0<GR0<GR0@368P00`<IR0<IR@<IR@030aZ90`<K
R@<378X30af:0`@NRP@47h/3122;0P@QR`04126<12:<12:<12:<0`@SS084
98`00`@TS@@US@@US@021BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5
:Xh5:Xl5:Xl010D[S`<5;8l31Rf@0`H^T0<6;i031S2A10HaT@86<Y401@Hb
TPHcTPHcTPHcTPHdTP021cBB00<7=I87=I<7=I<00`LfT`@7=i<31cRD0`Li
U0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8
@YL224>G00<9@iP9A9P9A9P00PU4V0<9AIP00`U6V0U6V@U6V@032DNI0`U8
V@032DVI2DVJ2DVJ00@9BYX32T^J0`Y<V`<:CI/22TjK00@:CY`:Ci`:Ci`:
Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh4
2eJN0`]GW`<;F9l32eVO0`aJX0<<Fj0335bP10aMX@<<GZ4235nQ00@<Gj8<
H:8<H:8<H:82366R00@=HJ8=HZ8=HZ8=HZ<43F>S0`eTX`033FFS3FFT3FFT
00<=IZ@33FNT0`eXY@@>JJD23VZU00@>JZH>JjH>JjH>JjH33VbV0Pi]YP04
3VfW3VjW3VjW3VjW10i_Y`033W2W3g2X3g2X00<?LJP33g:X00<?LjP?LjT?
LjT00`mdZ@@?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@Nj/447b/0a1m[08@
OZ`0111n[A1o[A1o[A5o[@<AP:d00a61[A61[Q61[P044H:^0a63[P<AQ:l3
4HF_0a66[`<BQk044XR`0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:<
/Q:=/Q:=/Q:=/P8BS[824hjb00<CSk8CSk<CSk<00a>@/`<CTK<00a>B/a>B
]1>B]0034i>d11>D]0<CUKD359Je0aBG]@<DV;H359Vf0QBJ]P0359Zg59^g
59^g008DVkL359bg00<DWKLEWKPEWKP00aFN^0<EWkP00aFP^1FP^AFP^@04
5J6i0aFR^@<EXkX35JBj0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl5ZVl5ZVl
0aJZ_08FZk`011J[_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P035jnn0aN`
_P035k6n5k6o5k6o00<G/[l35k>o=QRd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3002000NKYo7ooon>N[JVVlBcZM:XWLRcZM800ZJKa005_;SM
k^kdj^Waoooo<d>U00D0080300600P02P00400:100>100>100>10`04P@80
1H400`05PP06PP06PP0200J200@01h811h811h8128820@R30`49P`<12X<0
0`4;P`4;Q04;Q0040@b40`4=Q0<13XD30Pn50`8@Q@<24HH40Q:60P8CQP04
0Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<GR0<GR0@368P00`<IR0<I
R@<IR@030aZ90`<KR@<378X30af:0`@NRP@47h/3122;0P@QR`04126<12:<
12:<12:<0`@SS08498`00`@TS@@US@@US@021BF=0`DVS@031BN=1BN>1BN>
00<5:8h31BV>00<5:Xh5:Xl5:Xl010D[S`<5;8l31Rf@0`H^T0<6;i031S2A
10HaT@86<Y401@HbTPHcTPHcTPHcTPHdTP021cBB00<7=I87=I<7=I<00`Lf
T`@7=i<31cRD0`LiU0<7>Y@31c^E0`PlU@<8?ID423jF0`PoUP88@9H010Q0
U`Q1U`Q1U`Q1U`<8@YL224>G00<9@iP9A9P9A9P00PU4V0<9AIP00`U6V0U6
V@U6V@032DNI0`U8V@032DVI2DVJ2DVJ00@9BYX32T^J0`Y<V`<:CI/22TjK
00@:CY`:Ci`:Ci`:Ci`42U2L00@:DI`:DId:DId:DYd22e:M0`]CW@032eBM
2eBN2eBN00<;EIh42eJN0`]GW`<;F9l32eVO0`aJX0<<Fj0335bP10aMX@<<
GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00@=HJ8=HZ8=HZ8=HZ<43F>S0`eT
X`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@@>JJD23VZU00@>JZH>JjH>JjH>
JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW10i_Y`033W2W3g2X3g2X00<?LJP3
3g:X00<?LjP?LjT?LjT00`mdZ@@?MJT33gJZ0`mgZP<@N:X347V[0a1jZ`<@
Nj/447b/0a1m[08@OZ`0111n[A1o[A1o[A5o[@<AP:d00a61[A61[Q61[P04
4H:^0a63[P<AQ:l34HF_0a66[`<BQk044XR`0Q:9/0044XVa4XZa4XZa4XZa
0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[824hjb00<CSk8CSk<CSk<00a>@
/`<CTK<00a>B/a>B]1>B]0034i>d11>D]0<CUKD359Je0aBG]@<DV;H359Vf
0QBJ]P0359Zg59^g59^g008DVkL359bg00<DWKLEWKPEWKP00aFN^0<EWkP0
0aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU^P<FY[/45ZNk0QJX^`04
5ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`011J[_AJ/_AJ/_AN/_@@G[Kd00aN^_AN^
_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l35k>o0QRd`20000026;C0
4000008H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P004VjOa
ooooK5ZU[jG:0[bhg@0:oogo/jWBoooooooo_;SMUhZlZ9g8i^K/oooo<d>U
1000P0<00H0200:000@00X400h400h400h4300B10P05P@0300F200J200J2
00801X801007PP47PP47PP48PP8128<30@V30`4:P`030@^30@^40@^400@1
38@30@f40`4>Q@<23hD30Q250`8AQP@24XH20Q>600@24hL258L258L258L3
0QF70P8FQ`040aJ80aN80aN80aN810<HR0030aV80aV90aV900<36XT30a^9
0`<LRP<37HX311j:10@OR`<488/2126;00@48H`48X`48X`48X`312><0P@T
S00312B=12F=12F=00859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZ
SPDZS`DZS`041B^?0`D/S`<6;I031Rj@0`H_T0<6<9441S6A0PHbT@051S:B
1S>B1S>B1S>B1SBB0087=9800`LeTPLeT`LeT`031cJC10LgT`<7>9@31cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL00`U3V0U4V0U4V0022DBH0`U5V0032DJH2DJI2DJI00<9AiT32DRI
00<9BIT9BIX9BIX010U:VP<:BiX32TbK0`Y=V`8:CY/010Y>W0Y?W0Y?W0Y?
W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP@;
EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<G:0435fQ0`aNX@8<Gj4010aOXPaP
XPaPXPaPXP8<HJ8010eQXPeRXPeRXPeRX`@=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU10iYY@8>JZD010iZYPi[YPi[YPi[YP<>K:H23VfV00@>
KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?L:P00`maZ0<?LZP00`mcZ0mcZ@mc
Z@033gBY10meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`@@O:`347f/0Q1n
[00447j]47n]47n]4Gn]0a60[@034H6]4H6^4H6^00@APZh34H>^0a64[`<A
QJl34HJ_0a:7/0@BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`034i2c0a>A/`034i:c4i:d
4i:d00<CTk@44iBd0a>E]@<DU[D359Ne0aBH]P<DVKH259Zf00<DV[LDVkLD
VkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`FZK`FZK`3
5ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn00<G[kh35k2n
00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=Q8T8Q8T8P034R@R0030000
b>3HB92800e8T8P0100001Rd`1Rd`<SPf0i8T8P00`0001Rd`1Rd`002R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00;VjOaooooZ9g8oooo/jWB
H4bJSWZfN6F^Z9g8oooooogo00?oool00c=3Y@00P000P00300200`01P080
0X001002P@03P@03P@03P@<0184200F100<01H801X801X800P06PP0400N2
0@N20@N20@R20P48P`<12H<30@Z300<12h<12h@12h@0104<Q0<13H@30@j5
0`8?Q@040Q25oooooooooooo0P8AQP@24XH20Q>600@24hL258L258L258L3
0QF70P8FQ`040aJ80aN80aN80aN810<HR0030aV80aV90aV900<36XT30a^9
0`<LRP<37HX311j:10@OR`<488/2126;00@48H`48X`48X`48X`312><0P@T
S00312B=12F=12F=00859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh00`DZ
SPDZS`DZS`041B^?0`D/S`<6;I031Rj@0`H_T0<6<9441S6A0PHbT@051S:B
1S>B1S>B1S>B1SBB0087=9800`LeTPLeT`LeT`031cJC10LgT`<7>9@31cVD
0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G0`Q2
U`88@iL00`U3V0U4V0U4V0022DBH0`U5V0032DJH2DJI2DJI00<9AiT32DRI
00<9BIT9BIX9BIX010U:VP<:BiX32TbK0`Y=V`8:CY/010Y>W0Y?W0Y?W0Y?
W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]EWP@;
EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<G:0435fQ0`aNX@8<Gj4010aOXPaP
XPaPXPaPXP8<HJ8010eQXPeRXPeRXPeRX`@=Hj<33FBS00<=IJ<=IJ@=IJ@0
0`eVY0<=Ij@33FRU10iYY@8>JZD010iZYPi[YPi[YPi[YP<>K:H23VfV00@>
KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?L:P00`maZ0<?LZP00`mcZ0mcZ@mc
Z@033gBY10meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`@@O:`347f/0Q1n
[00447j]47n]47n]4Gn]0a60[@034H6]4H6^4H6^00@APZh34H>^0a64[`<A
QJl34HJ_0a:7/0@BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@044Xbb
4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`034i2c0a>A/`034i:c4i:d
4i:d00<CTk@44iBd0a>E]@<DU[D359Ne0aBH]P<DVKH259Zf00<DV[LDVkLD
VkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO^0035J2h5J2i5J2i00@E
XKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`FZK`FZK`3
5ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn00<G[kh35k2n
00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8`;R8`;P02hS0^003B928
0000b>3H00f8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00>VjOaoooooooo
fmc/H4bJThFj/jWB_;SMH4bJVHnnYY_4b<?Ooooo<d>U1P00P0?oool200:0
00<00X7oooooool00_ooo`8018400`05POooo`05PP0300J21?ooo`030@R2
0@R3oooo00?oool30@Z300Goool12h@12h@138Coool00P4<Q0040@f4oooo
0@f4oooo0P4>Q@040Pn5oooo0Pn5oooo0P8@Q@030Q66oooo0Q6600@24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN810<HR003
0aV80aV90aV900<36XT30a^90`<LRP<37HX311j:10@OR`<488/2126;00@4
8H`48X`48X`48X`312><0P@TS00312B=12F=12F=00859Hd31BJ=00<59hd5
9hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`041B^?0`D/S`<6;I031Rj@0`H_
T0<6<9441S6A0PHbT@051S:B1S>B1S>B1S>B1SBB0087=9800`LeTPLeT`Le
T`031cJC10LgT`<7>9@31cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0
UP04242G246G246G246G0`Q2U`88@iL00`U3V0U4V0U4V0022DBH0`U5V003
2DJH2DJI2DJI00<9AiT32DRI00<9BIT9BIX9BIX010U:VP<:BiX32TbK0`Y=
V`8:CY/010Y>W0Y?W0Y?W0Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M
00<;E9d;E9h;E9h00`]EWP@;EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<G:04
35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ8010eQXPeRXPeRXPeRX`@=
Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU10iYY@8>JZD010iZYPi[
YPi[YPi[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?L:P0
0`maZ0<?LZP00`mcZ0mcZ@mcZ@033gBY10meZ@<?MZX33gNZ0a1hZP<@NJ/3
47Z[0a1kZ`@@O:`347f/0Q1n[00447j]47n]47n]4Gn]0a60[@034H6]4H6^
4H6^00@APZh34H>^0a64[`<AQJl34HJ_0a:7/0@BR;024XV`00@BRK4BR[4B
R[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?/a>?
/`034i2c0a>A/`034i:c4i:d4i:d00<CTk@44iBd0a>E]@<DU[D359Ne0aBH
]P<DVKH259Zf00<DV[LDVkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh
0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/2
5ZRk00@FZ;`FZK`FZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000C8
h=R8`;R8`;R8`;P6000018S0^003B9280000b>3H00:8`;P900000XS0^005
B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P3002000jKYo7ooonl^=fISkkooooFdMgKg>cc
o_nVVlC^k_B5M[2CQK[ooolc@jD4002000Ooool00H000H000H3oool00X3o
ool00`03P@06oooo00B100B100F1oooo00F20P06PP08oooo00J200N20@N2
oooo0@R2oooo0@R30`49P`04oooo0@Z30@Z3oooo0P4;Q0080@b4oooo0@b4
0@b40@f4oooo0@f4oooo0P4>Q@030Pn5oooo0Pn500Coool20Q66108BQP82
4hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP40aR800<3
6HP36HT36HT00`<JR@<36hT30ab:0`<MRP<47XX411n;0`@PR`848H/010@Q
S0@RS0@RS0@RS0<48h`212B<00<498d49Hd49Hd00PDUS@<59Xd00`DWS@DW
SPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00@5:hl31Bb?0`H]T0<6;Y031Rn@
0`H`T@@6<I421S:A00D6<Y86<i86<i86<i86=9800PLdTP031cFB1cFC1cFC
00<7=Y<41cNC0`LhU0<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F
00@8@9L8@IL8@IL8@IL324:G0PQ3U`032D>H2DBH2DBH0089A9P32DFH00<9
AYP9AYT9AYT00`U7V@<9B9T00`U9V@U9VPU9VP042DZJ0`Y;VP<:C9/32TfK
0PY>V`042TjL2TnL2TnL2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN10]FWP<;Eil32eRO0`]IW`<<FZ0335^P0`aLX0@<
GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP043F6R3F:R3F:R3F:S10eS
X`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D43VVU0PiZY@043VZV3V^V
3V^V3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`@>KjL00`i`Y`m`Z0m`Z003
3g6X0`mbZ0033g>X3g>Y3g>Y00<?M:T43gFY0`mfZP<?MjX347RZ0a1iZ`<@
NZ/347^[111l[0<@OJ`247j/00@@OZd@Ojd@OjdAOjd34H2]00<APJdAPJhA
PJh01162[P<APjh34HB_0a65[`<AQZl34XN`11:8/08BRK0011:9/A::/A::
/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb0Q>>/P034hnb4hnc4hnc
00<CT;<34i6c00<CT[<CT[@CT[@00a>C]0@CU;@34iFe0aBF]@<DUkD359Rf
0aBI]P8DV[H00aBJ]aBK]aBK]`0259^g0aBL]`0359fg5Ifh5Ifh00<EW[P3
5Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk11JW^`8F
Z;/011JX_1JY_1JY_1JY_0<FZ[`25Z^l00@FZkdF[;dF[;dG[;d45jfm00<G
[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<001<SP
f8S0^8S0^8S0^0H00004R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h
00F8`;P01@0008S0^8S0^4R@R00000026;C000C8h=R8`;R8`;R8`;P20000
18S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0`00P00?VjOaooooVHnnUhZle=?XkjbcogIkkYn[FeRUYY_4
UYoBH4bJ_;SMoooo<d>U00<008001oooo`01P001P001P?ooo`02P?ooo`03
00>100Koool01840187oool01H7oool200J200Soool01X801h811h;oool1
28;oool128<30@V300koool12X?oool12h?oool12hCoool138Coool138@1
3HCoool13HCoool20@j500@23hGoool23hGoool20Q250`8AQP@24XH20Q>6
00@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN810<HR0030aV8
0aV90aV900<36XT30a^90`<LRP<37HX311j:10@OR`<488/2126;00@48H`4
8X`48X`48X`312><0P@TS00312B=12F=12F=00859Hd31BJ=00<59hd59hh5
9hh00`DXSP<5:Hh00`DZSPDZS`DZS`041B^?0`D/S`<6;I031Rj@0`H_T0<6
<9441S6A0PHbT@051S:B1S>B1S>B1S>B1SBB0087=9800`LeTPLeT`LeT`03
1cJC10LgT`<7>9@31cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04
242G246G246G246G0`Q2U`88@iL00`U3V0U4V0U4V0022DBH0`U5V0032DJH
2DJI2DJI00<9AiT32DRI00<9BIT9BIX9BIX010U:VP<:BiX32TbK0`Y=V`8:
CY/010Y>W0Y?W0Y?W0Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;
E9d;E9h;E9h00`]EWP@;EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<G:0435fQ
0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ8010eQXPeRXPeRXPeRX`@=Hj<3
3FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU10iYY@8>JZD010iZYPi[YPi[
YPi[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?L:P00`ma
Z0<?LZP00`mcZ0mcZ@mcZ@033gBY10meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[
0a1kZ`@@O:`347f/0Q1n[00447j]47n]47n]4Gn]0a60[@034H6]4H6^4H6^
00@APZh34H>^0a64[`<AQJl34HJ_0a:7/0@BR;024XV`00@BRK4BR[4BR[4B
R[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`03
4i2c0a>A/`034i:c4i:d4i:d00<CTk@44iBd0a>E]@<DU[D359Ne0aBH]P<D
VKH259Zf00<DV[LDVkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO
^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk
00@FZ;`FZK`FZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm
5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8h=R8
`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h00D0
0028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8`;P200000XS0^080
0003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h0P00P00:VjOaooooUhZlNVbZ/lOXZFjPb<?OThFjFdJCVHnn0WQU[P04
@RN5[jG:oooo<d>U1000P0<00H000oooo`02P002P@04oooo0P04P@03oooo
00F1oooo00<01X84oooo00<1288128<128<00`49P`0>oooo0@Z3oooo0@^3
oooo0@^4oooo0@b4oooo0@b40@f4oooo0@f4oooo0P4>Q@030Pn5oooo0Pn5
00Coool20Q66108BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP3
5hP35hP35hP40aR800<36HP36HT36HT00`<JR@<36hT30ab:0`<MRP<47XX4
11n;0`@PR`848H/010@QS0@RS0@RS0@RS0<48h`212B<00<498d49Hd49Hd0
0PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00@5:hl3
1Bb?0`H]T0<6;Y031Rn@0`H`T@@6<I421S:A00D6<Y86<i86<i86<i86=980
0PLdTP031cFB1cFC1cFC00<7=Y<41cNC0`LhU0<7>I@31cZD0`LkU@<8?9D3
23fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`032D>H2DBH
2DBH0089A9P32DFH00<9AYP9AYT9AYT00`U7V@<9B9T00`U9V@U9VPU9VP04
2DZJ0`Y;VP<:C9/32TfK0PY>V`042TjL2TnL2TnL2TnL10Y@W0042U6L2U6M
2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN10]FWP<;Eil32eRO0`]I
W`<<FZ0335^P0`aLX0@<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP04
3F6R3F:R3F:R3F:S10eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D4
3VVU0PiZY@043VZV3V^V3V^V3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`@>
KjL00`i`Y`m`Z0m`Z0033g6X0`mbZ0033g>X3g>Y3g>Y00<?M:T43gFY0`mf
ZP<?MjX347RZ0a1iZ`<@NZ/347^[111l[0<@OJ`247j/00@@OZd@Ojd@OjdA
Ojd34H2]00<APJdAPJhAPJh01162[P<APjh34HB_0a65[`<AQZl34XN`11:8
/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb
0Q>>/P034hnb4hnc4hnc00<CT;<34i6c00<CT[<CT[@CT[@00a>C]0@CU;@3
4iFe0aBF]@<DUkD359Rf0aBI]P8DV[H00aBJ]aBK]aBK]`0259^g0aBL]`03
59fg5Ifh5Ifh00<EW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT
^P<FYKX35ZJk11JW^`8FZ;/011JX_1JY_1JY_1JY_0<FZ[`25Z^l00@FZkdF
[;dF[;dG[;d45jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`03
5k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^003
0000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8
`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h0P00P003VjOaoooooooo00;oool02_n]/?mfNoW=e?g]
k_ooojJKa8Ef/;bhgOoooc=3Y@D00803006000?oool00X000X400`03P@03
oooo00B1oooo00801H400`05P_ooo`06PP0200J200@01h811h;oool12882
0@R30oooo`812X<02oooo`4;Poooo`4;Q?ooo`4<Q?ooo`4<Q04=Q?ooo`4=
Q002oooo00D13XD23hGoool23hGoool00P8@Q@03oooo0Q660Q6600@24XH2
0Q>600@24hL258L258L258L30QF70P8FQ`040aJ80aN80aN80aN810<HR003
0aV80aV90aV900<36XT30a^90`<LRP<37HX311j:10@OR`<488/2126;00@4
8H`48X`48X`48X`312><0P@TS00312B=12F=12F=00859Hd31BJ=00<59hd5
9hh59hh00`DXSP<5:Hh00`DZSPDZS`DZS`041B^?0`D/S`<6;I031Rj@0`H_
T0<6<9441S6A0PHbT@051S:B1S>B1S>B1S>B1SBB0087=9800`LeTPLeT`Le
T`031cJC10LgT`<7>9@31cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0
UP04242G246G246G246G0`Q2U`88@iL00`U3V0U4V0U4V0022DBH0`U5V003
2DJH2DJI2DJI00<9AiT32DRI00<9BIT9BIX9BIX010U:VP<:BiX32TbK0`Y=
V`8:CY/010Y>W0Y?W0Y?W0Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M
00<;E9d;E9h;E9h00`]EWP@;EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<G:04
35fQ0`aNX@8<Gj4010aOXPaPXPaPXPaPXP8<HJ8010eQXPeRXPeRXPeRX`@=
Hj<33FBS00<=IJ<=IJ@=IJ@00`eVY0<=Ij@33FRU10iYY@8>JZD010iZYPi[
YPi[YPi[YP<>K:H23VfV00@>KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?L:P0
0`maZ0<?LZP00`mcZ0mcZ@mcZ@033gBY10meZ@<?MZX33gNZ0a1hZP<@NJ/3
47Z[0a1kZ`@@O:`347f/0Q1n[00447j]47n]47n]4Gn]0a60[@034H6]4H6^
4H6^00@APZh34H>^0a64[`<AQJl34HJ_0a:7/0@BR;024XV`00@BRK4BR[4B
R[4BR[434X^a0Q:</@044Xbb4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?/a>?
/`034i2c0a>A/`034i:c4i:d4i:d00<CTk@44iBd0a>E]@<DU[D359Ne0aBH
]P<DVKH259Zf00<DV[LDVkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh
0aFO^0035J2h5J2i5J2i00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/2
5ZRk00@FZ;`FZK`FZK`FZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@03
5jjm5jjn5jjn00<G[kh35k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C000?8
h=R8`;R8`;P02hS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005R<2h
00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00B8`;P200001HS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<0
08002Z6/l_W=e>8V??Be_n8V??A]OOcSjOoooog]k_n]/0;oool00c=3Y@00
P000P00400200`01P003oooo00:000:100?oool200B100Goool01H401H40
1H;oool00P06PP?oool01047PP48PP48Poooo`<12H<20@Z300Coool12h<1
2hCoool20@b400Ooool138@13HCoool13HCoool13XD00_ooo`823hD00`8@
QOooooooo`02oooo00<24HH24XH24XH00P8BQP824hH0108CQ`8DQ`8DQ`8D
Q`<25HL20QJ700@35XP35hP35hP35hP40aR800<36HP36HT36HT00`<JR@<3
6hT30ab:0`<MRP<47XX411n;0`@PR`848H/010@QS0@RS0@RS0@RS0<48h`2
12B<00<498d49Hd49Hd00PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP03
1BZ>1BZ?1BZ?00@5:hl31Bb?0`H]T0<6;Y031Rn@0`H`T@@6<I421S:A00D6
<Y86<i86<i86<i86=9800PLdTP031cFB1cFC1cFC00<7=Y<41cNC0`LhU0<7
>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL3
24:G0PQ3U`032D>H2DBH2DBH0089A9P32DFH00<9AYP9AYT9AYT00`U7V@<9
B9T00`U9V@U9VPU9VP042DZJ0`Y;VP<:C9/32TfK0PY>V`042TjL2TnL2TnL
2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN
10]FWP<;Eil32eRO0`]IW`<<FZ0335^P0`aLX0@<GJ4335jQ0PaOX@0435nR
362R362R362R0PaQXP043F6R3F:R3F:R3F:S10eSX`<=I:<00`eUX`eUY0eU
Y0033FJT0`eWY0<=J:D43VVU0PiZY@043VZV3V^V3V^V3V^V0`i/YP8>KJH0
10i]Y`i^Y`i^Y`i^Y`@>KjL00`i`Y`m`Z0m`Z0033g6X0`mbZ0033g>X3g>Y
3g>Y00<?M:T43gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[111l[0<@OJ`2
47j/00@@OZd@Ojd@OjdAOjd34H2]00<APJdAPJhAPJh01162[P<APjh34HB_
0a65[`<AQZl34XN`11:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@B
S;8BSK8BSK8BSK824Xjb0Q>>/P034hnb4hnc4hnc00<CT;<34i6c00<CT[<C
T[@CT[@00a>C]0@CU;@34iFe0aBF]@<DUkD359Rf0aBI]P8DV[H00aBJ]aBK
]aBK]`0259^g0aBL]`0359fg5Ifh5Ifh00<EW[P35Inh00<EX;PEX;TEX;T0
11FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk11JW^`8FZ;/011JX_1JY_1JY_1JY
_0<FZ[`25Z^l00@FZkdF[;dF[;dG[;d45jfm00<G[[dG[[hG[[h00aN__P<G
/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8
T8P00038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R000
00026;C000?8h=R8`;R8`;P00hS0^0@00004R<2h00A8T8P0000H]<0H]<02
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00=VjOaoNg^hRHlo_Gh
mhVGm69^lj2^m69^oogoojf`o>?Yoooo<d>U00L00803006000?oool00X00
0X400`03P@<0184200F100<01H801X801X800P06PP0600N20@N20@N20@R2
oooo0@R30`49P`<12X<00`4;P`4;Q04;Q0040@b40`4=Q0<13XD30Pn50`8@
Q@<24HH40Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<GR0<G
R0<GR0@368P00`<IR0<IR@<IR@030aZ90`<KR@<378X30af:0`@NRP@47h/3
122;0P@QR`04126<12:<12:<12:<0`@SS08498`00`@TS@@US@@US@021BF=
0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl010D[S`<5;8l3
1Rf@0`H^T0<6;i031S2A10HaT@86<Y401@HbTPHcTPHcTPHcTPHdTP021cBB
00<7=I87=I<7=I<00`LfT`@7=i<31cRD0`LiU0<7>Y@31c^E0`PlU@<8?ID4
23jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00<9@iP9A9P9A9P0
0PU4V0<9AIP00`U6V0U6V@U6V@032DNI0`U8V@032DVI2DVJ2DVJ00@9BYX3
2T^J0`Y<V`<:CI/22TjK00@:CY`:Ci`:Ci`:Ci`42U2L00@:DI`:DId:DId:
DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh42eJN0`]GW`<;F9l32eVO0`aJ
X0<<Fj0335bP10aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00@=HJ8=
HZ8=HZ8=HZ<43F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@@>JJD2
3VZU00@>JZH>JjH>JjH>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW10i_Y`03
3W2W3g2X3g2X00<?LJP33g:X00<?LjP?LjT?LjT00`mdZ@@?MJT33gJZ0`mg
ZP<@N:X347V[0a1jZ`<@Nj/447b/0a1m[08@OZ`0111n[A1o[A1o[A5o[@<A
P:d00a61[A61[Q61[P044H:^0a63[P<AQ:l34HF_0a66[`<BQk044XR`0Q:9
/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[824hjb
00<CSk8CSk<CSk<00a>@/`<CTK<00a>B/a>B]1>B]0034i>d11>D]0<CUKD3
59Je0aBG]@<DV;H359Vf0QBJ]P0359Zg59^g59^g008DVkL359bg00<DWKLE
WKPEWKP00aFN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj0aJU
^P<FY[/45ZNk0QJX^`045ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`011J[_AJ/_AJ/
_AN/_@@G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G/[l3
5k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00<00028
`;R8`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^002
R<2h0P0000:8`;P200000hS0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^08008000i^WlOK8c>8V?002ojf`00OO92koY9kf
_<Go[K3^Nhcooolc@jD02000P0<00H000oooo`02P002P@0300>10`04P@80
1H400`05PP06PP06PP0200J200H01h811h811h8128;oool128<30@V300Co
ool12X<12X<12h<20@^4104<Q0<13H@30@j50`8?Q@<248D30Q66108BQP82
4hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP40aR800<3
6HP36HT36HT00`<JR@<36hT30ab:0`<MRP<47XX411n;0`@PR`848H/010@Q
S0@RS0@RS0@RS0<48h`212B<00<498d49Hd49Hd00PDUS@<59Xd00`DWS@DW
SPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00@5:hl31Bb?0`H]T0<6;Y031Rn@
0`H`T@@6<I421S:A00D6<Y86<i86<i86<i86=9800PLdTP031cFB1cFC1cFC
00<7=Y<41cNC0`LhU0<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8?iH2242F
00@8@9L8@IL8@IL8@IL324:G0PQ3U`032D>H2DBH2DBH0089A9P32DFH00<9
AYP9AYT9AYT00`U7V@<9B9T00`U9V@U9VPU9VP042DZJ0`Y;VP<:C9/32TfK
0PY>V`042TjL2TnL2TnL2TnL10Y@W0042U6L2U6M2U6M2U:M0P]BW@<;Did0
0`]DW@]DWP]DWP032eFN10]FWP<;Eil32eRO0`]IW`<<FZ0335^P0`aLX0@<
GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP043F6R3F:R3F:R3F:S10eS
X`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D43VVU0PiZY@043VZV3V^V
3V^V3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`@>KjL00`i`Y`m`Z0m`Z003
3g6X0`mbZ0033g>X3g>Y3g>Y00<?M:T43gFY0`mfZP<?MjX347RZ0a1iZ`<@
NZ/347^[111l[0<@OJ`247j/00@@OZd@Ojd@OjdAOjd34H2]00<APJdAPJhA
PJh01162[P<APjh34HB_0a65[`<AQZl34XN`11:8/08BRK0011:9/A::/A::
/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb0Q>>/P034hnb4hnc4hnc
00<CT;<34i6c00<CT[<CT[@CT[@00a>C]0@CU;@34iFe0aBF]@<DUkD359Rf
0aBI]P8DV[H00aBJ]aBK]aBK]`0259^g0aBL]`0359fg5Ifh5Ifh00<EW[P3
5Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk11JW^`8F
Z;/011JX_1JY_1JY_1JY_0<FZ[`25Z^l00@FZkdF[;dF[;dG[;d45jfm00<G
[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H]<000lSP
f8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H
]<0H]<38h=P00hS0^0800004R<2h0P0000:8`;P014R@R00001Rd`1Rd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7icMCgRIL00_oo
o`07ojf`hAHdogIkojBNhRHlohUo<d>U00P00803006000?oool00X000X40
0`03P@<0184200F100<01H801X801X800P06PP0500N20@N20@N20@R20@R3
00Coool30@Z300<12h<12h@12h@0104<Q0030@f4oooo0@f400<13XD30Pn5
0`8@Q@<24HH40Q:60P8CQP040Q>70QB70QB70QB70`8EQ`825XL010<FR0<G
R0<GR0<GR0@368P00`<IR0<IR@<IR@030aZ90`<KR@<378X30af:0`@NRP@4
7h/3122;0P@QR`04126<12:<12:<12:<0`@SS08498`00`@TS@@US@@US@02
1BF=0`DVS@031BN=1BN>1BN>00<5:8h31BV>00<5:Xh5:Xl5:Xl010D[S`<5
;8l31Rf@0`H^T0<6;i031S2A10HaT@86<Y401@HbTPHcTPHcTPHcTPHdTP02
1cBB00<7=I87=I<7=I<00`LfT`@7=i<31cRD0`LiU0<7>Y@31c^E0`PlU@<8
?ID423jF0`PoUP88@9H010Q0U`Q1U`Q1U`Q1U`<8@YL224>G00<9@iP9A9P9
A9P00PU4V0<9AIP00`U6V0U6V@U6V@032DNI0`U8V@032DVI2DVJ2DVJ00@9
BYX32T^J0`Y<V`<:CI/22TjK00@:CY`:Ci`:Ci`:Ci`42U2L00@:DI`:DId:
DId:DYd22e:M0`]CW@032eBM2eBN2eBN00<;EIh42eJN0`]GW`<;F9l32eVO
0`aJX0<<Fj0335bP10aMX@<<GZ4235nQ00@<Gj8<H:8<H:8<H:82366R00@=
HJ8=HZ8=HZ8=HZ<43F>S0`eTX`033FFS3FFT3FFT00<=IZ@33FNT0`eXY@@>
JJD23VZU00@>JZH>JjH>JjH>JjH33VbV0Pi]YP043VfW3VjW3VjW3VjW10i_
Y`033W2W3g2X3g2X00<?LJP33g:X00<?LjP?LjT?LjT00`mdZ@@?MJT33gJZ
0`mgZP<@N:X347V[0a1jZ`<@Nj/447b/0a1m[08@OZ`0111n[A1o[A1o[A5o
[@<AP:d00a61[A61[Q61[P044H:^0a63[P<AQ:l34HF_0a66[`<BQk044XR`
0Q:9/0044XVa4XZa4XZa4XZa0a:;/@8BS;4011:</Q:=/Q:=/Q:=/P8BS[82
4hjb00<CSk8CSk<CSk<00a>@/`<CTK<00a>B/a>B]1>B]0034i>d11>D]0<C
UKD359Je0aBG]@<DV;H359Vf0QBJ]P0359Zg59^g59^g008DVkL359bg00<D
WKLEWKPEWKP00aFN^0<EWkP00aFP^1FP^AFP^@045J6i0aFR^@<EXkX35JBj
0aJU^P<FY[/45ZNk0QJX^`045ZRl5ZVl5ZVl5ZVl0aJZ_08FZk`011J[_AJ/
_AJ/_AN/_@@G[Kd00aN^_AN^_QN^_P035jnn0aN`_P035k6n5k6o5k6o00<G
/[l35k>o0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h2@00
00:8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0000H]<0H]<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0P00P007VjOaoooolj2^m69^oooo
mhVGnLgD00;oool00o>P[_oooc=3Y@0800200`01P0800X001002P@03P@03
P@03P@<0184200F100<01H801X801X800P06PP0400N20@N20@N20@R20P48
P`<12H<30@Z300<12h<12h@12h@0104<Q0<13H@30@j50`8?Q@<248D30Q66
108BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL20QJ700@35XP35hP35hP35hP4
0aR800<36HP36HT36HT00`<JR@<36hT30ab:0`<MRP<47XX411n;0`@PR`84
8H/010@QS0@RS0@RS0@RS0<48h`212B<00<498d49Hd49Hd00PDUS@<59Xd0
0`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?1BZ?00@5:hl31Bb?0`H]T0<6
;Y031Rn@0`H`T@@6<I421S:A00D6<Y86<i86<i86<i86=9800PLdTP031cFB
1cFC1cFC00<7=Y<41cNC0`LhU0<7>I@31cZD0`LkU@<8?9D323fE10PnUP<8
?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3U`032D>H2DBH2DBH0089A9P3
2DFH00<9AYP9AYT9AYT00`U7V@<9B9T00`U9V@U9VPU9VP042DZJ0`Y;VP<:
C9/32TfK0PY>V`042TjL2TnL2TnL2TnL10Y@W0042U6L2U6M2U6M2U:M0P]B
W@<;Did00`]DW@]DWP]DWP032eFN10]FWP<;Eil32eRO0`]IW`<<FZ0335^P
0`aLX0@<GJ4335jQ0PaOX@0435nR362R362R362R0PaQXP043F6R3F:R3F:R
3F:S10eSX`<=I:<00`eUX`eUY0eUY0033FJT0`eWY0<=J:D43VVU0PiZY@04
3VZV3V^V3V^V3V^V0`i/YP8>KJH010i]Y`i^Y`i^Y`i^Y`@>KjL00`i`Y`m`
Z0m`Z0033g6X0`mbZ0033g>X3g>Y3g>Y00<?M:T43gFY0`mfZP<?MjX347RZ
0a1iZ`<@NZ/347^[111l[0<@OJ`247j/00@@OZd@Ojd@OjdAOjd34H2]00<A
PJdAPJhAPJh01162[P<APjh34HB_0a65[`<AQZl34XN`11:8/08BRK0011:9
/A::/A::/A::/@<BRk424Xba00@BS;8BSK8BSK8BSK824Xjb0Q>>/P034hnb
4hnc4hnc00<CT;<34i6c00<CT[<CT[@CT[@00a>C]0@CU;@34iFe0aBF]@<D
UkD359Rf0aBI]P8DV[H00aBJ]aBK]aBK]`0259^g0aBL]`0359fg5Ifh5Ifh
00<EW[P35Inh00<EX;PEX;TEX;T011FQ^@<EX[T35J>j0aFT^P<FYKX35ZJk
11JW^`8FZ;/011JX_1JY_1JY_1JY_0<FZ[`25Z^l00@FZkdF[;dF[;dG[;d4
5jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa_QNa_aNa_`035k:o0aNc_`8H
]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P03HS0^005B92800006;C0
6;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P3002000^KYo7oooooRGooooocX:kaTj7ooooooOocX:kono`c
@jD02000P0<00H0200:000@00X400h400h400h4300B10P05P@0300F200J2
00J200801X801007PP47PP47PP48PP8128<30@V30`4:P`030@^30@^40@^4
00@138@30@f40`4>Q@<23hD30Q250`8AQP@24XH20Q>600@24hL258L258L2
58L30QF70P8FQ`040aJ80aN80aN80aN810<HR0030aV80aV90aV900<36XT3
0a^90`<LRP<37HX311j:10@OR`<488/2126;00@48H`48X`48X`48X`312><
0P@TS00312B=12F=12F=00859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh0
0`DZSPDZS`DZS`041B^?0`D/S`<6;I031Rj@0`H_T0<6<9441S6A0PHbT@05
1S:B1S>B1S>B1S>B1SBB0087=9800`LeTPLeT`LeT`031cJC10LgT`<7>9@3
1cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G
0`Q2U`88@iL00`U3V0U4V0U4V0022DBH0`U5V0032DJH2DJI2DJI00<9AiT3
2DRI00<9BIT9BIX9BIX010U:VP<:BiX32TbK0`Y=V`8:CY/010Y>W0Y?W0Y?
W0Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]E
WP@;EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<G:0435fQ0`aNX@8<Gj4010aO
XPaPXPaPXPaPXP8<HJ8010eQXPeRXPeRXPeRX`@=Hj<33FBS00<=IJ<=IJ@=
IJ@00`eVY0<=Ij@33FRU10iYY@8>JZD010iZYPi[YPi[YPi[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?L:P00`maZ0<?LZP00`mcZ0mc
Z@mcZ@033gBY10meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`@@O:`347f/
0Q1n[00447j]47n]47n]4Gn]0a60[@034H6]4H6^4H6^00@APZh34H>^0a64
[`<AQJl34HJ_0a:7/0@BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@04
4Xbb4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`034i2c0a>A/`034i:c
4i:d4i:d00<CTk@44iBd0a>E]@<DU[D359Ne0aBH]P<DVKH259Zf00<DV[LD
VkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO^0035J2h5J2i5J2i
00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`FZK`F
ZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/kl26;C03lSPf0030000b>3Hb>3H00g8
h=P00`0001Rd`1Rd`00?b>3H00<0000H]<0H]<000XS0^058T8P100000000
18S0^<SPf8S0^8S0^0@00803VjOa00KoooocX:kd]Kof_<GkfMXc@jD90020
0`01P0800X001002P@03P@03P@03P@<0184200F100<01H801X801X800P06
PP0400N20@N20@N20@R20P48P`<12H<30@Z300<12h<12h@12h@0104<Q0<1
3H@30@j50`8?Q@<248D30Q66108BQP824hH0108CQ`8DQ`8DQ`8DQ`<25HL2
0QJ700@35XP35hP35hP35hP40aR800<36HP36HT36HT00`<JR@<36hT30ab:
0`<MRP<47XX411n;0`@PR`848H/010@QS0@RS0@RS0@RS0<48h`212B<00<4
98d49Hd49Hd00PDUS@<59Xd00`DWS@DWSPDWSP031BR>0`DYSP031BZ>1BZ?
1BZ?00@5:hl31Bb?0`H]T0<6;Y031Rn@0`H`T@@6<I421S:A00D6<Y86<i86
<i86<i86=9800PLdTP031cFB1cFC1cFC00<7=Y<41cNC0`LhU0<7>I@31cZD
0`LkU@<8?9D323fE10PnUP<8?iH2242F00@8@9L8@IL8@IL8@IL324:G0PQ3
U`032D>H2DBH2DBH0089A9P32DFH00<9AYP9AYT9AYT00`U7V@<9B9T00`U9
V@U9VPU9VP042DZJ0`Y;VP<:C9/32TfK0PY>V`042TjL2TnL2TnL2TnL10Y@
W0042U6L2U6M2U6M2U:M0P]BW@<;Did00`]DW@]DWP]DWP032eFN10]FWP<;
Eil32eRO0`]IW`<<FZ0335^P0`aLX0@<GJ4335jQ0PaOX@0435nR362R362R
362R0PaQXP043F6R3F:R3F:R3F:S10eSX`<=I:<00`eUX`eUY0eUY0033FJT
0`eWY0<=J:D43VVU0PiZY@043VZV3V^V3V^V3V^V0`i/YP8>KJH010i]Y`i^
Y`i^Y`i^Y`@>KjL00`i`Y`m`Z0m`Z0033g6X0`mbZ0033g>X3g>Y3g>Y00<?
M:T43gFY0`mfZP<?MjX347RZ0a1iZ`<@NZ/347^[111l[0<@OJ`247j/00@@
OZd@Ojd@OjdAOjd34H2]00<APJdAPJhAPJh01162[P<APjh34HB_0a65[`<A
QZl34XN`11:8/08BRK0011:9/A::/A::/A::/@<BRk424Xba00@BS;8BSK8B
SK8BSK824Xjb0Q>>/P034hnb4hnc4hnc00<CT;<34i6c00<CT[<CT[@CT[@0
0a>C]0@CU;@34iFe0aBF]@<DUkD359Rf0aBI]P8DV[H00aBJ]aBK]aBK]`02
59^g0aBL]`0359fg5Ifh5Ifh00<EW[P35Inh00<EX;PEX;TEX;T011FQ^@<E
X[T35J>j0aFT^P<FYKX35ZJk11JW^`8FZ;/011JX_1JY_1JY_1JY_0<FZ[`2
5Z^l00@FZkdF[;dF[;dG[;d45jfm00<G[[dG[[hG[[h00aN__P<G/;h00aNa
_QNa_aNa_`035k:o0aNc_cHH]<02R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h5P00P0<00H0200:000@00X400h400h400h4300B10P05P@0300F200J2
00J200801X801007PP47PP47PP48PP8128<30@V30`4:P`030@^30@^40@^4
00@138@30@f40`4>Q@<23hD30Q250`8AQP@24XH20Q>600@24hL258L258L2
58L30QF70P8FQ`040aJ80aN80aN80aN810<HR0030aV80aV90aV900<36XT3
0a^90`<LRP<37HX311j:10@OR`<488/2126;00@48H`48X`48X`48X`312><
0P@TS00312B=12F=12F=00859Hd31BJ=00<59hd59hh59hh00`DXSP<5:Hh0
0`DZSPDZS`DZS`041B^?0`D/S`<6;I031Rj@0`H_T0<6<9441S6A0PHbT@05
1S:B1S>B1S>B1S>B1SBB0087=9800`LeTPLeT`LeT`031cJC10LgT`<7>9@3
1cVD0`LjU0<7>iD323bE0`PmU@@8?YH323nF0PQ0UP04242G246G246G246G
0`Q2U`88@iL00`U3V0U4V0U4V0022DBH0`U5V0032DJH2DJI2DJI00<9AiT3
2DRI00<9BIT9BIX9BIX010U:VP<:BiX32TbK0`Y=V`8:CY/010Y>W0Y?W0Y?
W0Y?W0@:D9`010YAW0YAW@YAW@YBW@8;DYd32e>M00<;E9d;E9h;E9h00`]E
WP@;EYh32eNO0`]HW`<;FIl335ZP0`aKX0<<G:0435fQ0`aNX@8<Gj4010aO
XPaPXPaPXPaPXP8<HJ8010eQXPeRXPeRXPeRX`@=Hj<33FBS00<=IJ<=IJ@=
IJ@00`eVY0<=Ij@33FRU10iYY@8>JZD010iZYPi[YPi[YPi[YP<>K:H23VfV
00@>KJL>KZL>KZL>KZL43VnW00<>L:L?L:P?L:P00`maZ0<?LZP00`mcZ0mc
Z@mcZ@033gBY10meZ@<?MZX33gNZ0a1hZP<@NJ/347Z[0a1kZ`@@O:`347f/
0Q1n[00447j]47n]47n]4Gn]0a60[@034H6]4H6^4H6^00@APZh34H>^0a64
[`<AQJl34HJ_0a:7/0@BR;024XV`00@BRK4BR[4BR[4BR[434X^a0Q:</@04
4Xbb4Xfb4Xfb4Xfb0Q:>/P8CS[800a>?/Q>?/a>?/`034i2c0a>A/`034i:c
4i:d4i:d00<CTk@44iBd0a>E]@<DU[D359Ne0aBH]P<DVKH259Zf00<DV[LD
VkLDVkL00QBK]`<DW;L00aBM]aFM^1FM^0035Ijh0aFO^0035J2h5J2i5J2i
00@EXKT35J:i0aFS^P<EY;X35ZFj0aJV^`@FYk/25ZRk00@FZ;`FZK`FZK`F
ZK`35ZZl0QJ[_0045Z^m5Zbm5Zbm5jbm11N]_@035jjm5jjn5jjn00<G[kh3
5k2n00<G/KhG/KlG/Kl00aNb_`<G/klf6;C00XS0^058T8P1000000000hS0
^<SPf8S0^03oR<2hohS0^8J8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0
^?n8`;R6R<2h0DR@R04000000003R<2hb>3Hb>3H0?o8h=Sob>3HQ/SPf058
T8P10000003oR<2hohS0^8Z8`;P100000000\
\>"], "Graphics",
  ImageSize->{649, 491},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009o0001hB000`400?l0
0000o`00003oooo`l?3ooo3`l7;ol?3`00?ofMWIooooooooool03?ooool0
0?ool?3`ooo`l?1boo3`l004omWIfOooooooooooonGUi@?ooooo00GoiNGU
ooooooooooooooooonGUi@03ooooo`00ooo`l?3ooo3`l7;ol?3`00gofMWI
oooooooJf][oSHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgo
iNGU00;ooooo003ooo3`l?ool?3`L_o`l?003_oIfMWooooooooooooJf][o
SHf=onGUiOoooooof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU0Oooool0
0?ool?3`ooo`l?1boo3`l00=omWIfOoooooooooooooooooJf][oSHf=onGU
iOoooooof][Johf=SOoUiNGoooooom[JfP02ooooo`00ooo`l?3ooo3`l7;o
l?3`00?ofMWIooooooooool00_ooool01ooJf][oSHf=onGUiOoooooof][J
ohf=SOoUiND00oooool00?ool?3`ooo`l?1boo3`l003omWIfOoooooooooo
00?ooooo00Oof][Johf=SOoUiNGoooooom[Jf_n=SHgoiNGU00;ooooo003o
oo3`l?ool?3`L_o`l?000ooIfMWoooooooooo`04ooooo`07om[Jf_n=SHgo
iNGUoooooooLg=coSHf=onGUi@01ooooo`00ooo`l?3ooo3`l7;ol?3`00?o
fMWIooooooooool01Oooool01OoJf][oSHf=onGUiOoooooog=cL00;ooooo
003ooo3`l?ool?3`L_o`l?000ooIfMWoooooooooo`06ooooo`03omcLg?n=
SHgoiNGU00?ooooo003ooo3`l?ool?3`L_o`l?000ooIfMWoooooooooo`07
ooooo`03omcLg?n=SHgoiNGU00;ooooo003ooo3`l?ool?3`L_o`l?000ooI
fMWoooooooooo`08ooooo`03omcLg?n=SHgoiNGU007ooooo003ooo3`l?oo
l?3`L_o`l?000ooIfMWoooooooooo`09ooooo`7og=cL0Oooool1ooooo`00
ooo`l?3ooo3`l7;ol?3`00?ofMWIooooooooool03?ooool00?ool?3`ooo`
l?1boo3`l0oofMWI003oooooooooooooPOooool00?ook^k^ooo^k^j1onk^
kP000ooVi^Koogj]fOooOZgIO?mn[MT2onKViP000oo^k^h00omn[MWok^k^
onk^kP3oonk^k_ook^k^N?o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?o
OZgIooooooooool0ooooooooooooogSooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomfooooo`;ok^k^0Omn[MT1
onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomfoooo
o`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oo
oooooooooomfooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]
fOoooooooooo0?oooooooooooomhooooo`7oOZgI0Oooool1ooooo`000oo^
k^h00omn[MWok^k^ooooo`3oooooooooooooM_ooool2onk^kP7oOZgI0Oo^
k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`3oooooooooooooM_ooool2
onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`3ooooo
ooooooooM_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWo
ooooooooo`3oooooooooooooN?ooool1ogj]f@7ooooo0Oooool000?ok^k^
00?oOZgIonk^k_ooool0ooooooooooooogKooooo0_o^k^h1ogj]f@7ok^k^
0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool0ooooooooooooogKooooo0_oV
i^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool0oooooooo
ooooogKooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIoooo
ooooool0ooooooooooooogSooooo0Omn[MT1ooooo`7ooooo0003onk^kP03
ogj]fOo^k^kooooo0?oooooooooooomfooooo`;ok^k^0Omn[MT1onk^kP7o
k^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomfooooo`;oi^KV
0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooo
oomfooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomhooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn
[MWok^k^ooooo`3oooooooooooooM_ooool2onk^kP7oOZgI0Oo^k^h1onk^
kP000ooVi^H00omn[MWoi^KVooooo`3oooooooooooooM_ooool2onKViP7o
OZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`3ooooooooooooo
M_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWooooooooo
o`3oooooooooooooN?ooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgI
onk^k_ooool0ooooooooooooogKooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h0
00?oi^KV00?oOZgIonKVi_ooool0ooooooooooooogKooooo0_oVi^H1ogj]
f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool0ooooooooooooogKo
oooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool0
ooooooooooooogSooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^
k^kooooo0?oooooooooooomfooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo0?oooooooooooomfooooo`;oi^KV0Omn[MT1
onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomfoooo
o`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oo
oooooooooomhooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^
ooooo`3oooooooooooooM_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooV
i^H00omn[MWoi^KVooooo`3oooooooooooooM_ooool2onKViP7oOZgI0OoV
i^H1onKViP000oo^k^h00omn[MWok^k^ooooo`3oooooooooooooM_ooool2
onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`3ooooo
ooooooooN?ooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_oo
ool0ooooooooooooogKooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV
00?oOZgIonKVi_ooool0ooooooooooooogKooooo0_oVi^H1ogj]f@7oi^KV
0OoVi^H000?ok^k^00?oOZgIonk^k_ooool0ooooooooooooogKooooo0_o^
k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool0oooooooo
ooooogSooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo
0?oooooooooooomfooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03
ogj]fOoVi^Kooooo0?oooooooooooomfooooo`;oi^KV0Omn[MT1onKViP7o
i^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomfooooo`;ok^k^
0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooo
oomhooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^ooooo`3o
ooooooooooooM_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn
[MWoi^KVooooo`3oooooooooooooM_ooool2onKViP7oOZgI0OoVi^H1onKV
iP000oo^k^h00omn[MWok^k^ooooo`3oooooooooooooM_ooool2onk^kP7o
OZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`3ooooooooooooo
N?ooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_ooool0oooo
ooooooooogKooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgI
onKVi_ooool0ooooooooooooogKooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H0
00?ok^k^00?oOZgIonk^k_ooool0ooooooooooooogKooooo0_o^k^h1ogj]
f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool0ooooooooooooogSo
oooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooo
oooooomfooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoV
i^Kooooo0?oooooooooooomfooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomfooooo`;ok^k^0Omn[MT1
onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomhoooo
o`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^ooooo`3ooooooooo
ooooM_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KV
ooooo`3oooooooooooooM_ooool2onKViP7oOZgI0OoVi^H1onKViP000oo^
k^h00omn[MWok^k^ooooo`3oooooooooooooM_ooool2onk^kP7oOZgI0Oo^
k^h1onk^kP000oooool00omn[MWoooooooooo`3oooooooooooooN?ooool1
ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_ooool0oooooooooooo
ogKooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_oo
ool0ooooooooooooogKooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^
00?oOZgIonk^k_ooool0ooooooooooooogKooooo0_o^k^h1ogj]f@7ok^k^
0Oo^k^h000?ooooo00?oOZgIooooooooool0ooooooooooooogSooooo0Omn
[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomf
ooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo
0?oooooooooooomfooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03
ogj]fOo^k^kooooo0?oooooooooooomfooooo`;ok^k^0Omn[MT1onk^kP7o
k^k^0003ooooo`03ogj]fOoooooooooo0?oooooooooooomhooooo`7oOZgI
0Oooool1ooooo`000oo^k^h00omn[MWok^k^ooooo`3oooooooooooooM_oo
ool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`3o
ooooooooooooM_ooool2onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn
[MWok^k^ooooo`3oooooooooooooM_ooool2onk^kP7oOZgI0Oo^k^h1onk^
kP000oooool00omn[MWoooooooooo`3oooooooooooooN?ooool1ogj]f@7o
oooo0Oooool000?ok^k^00?oOZgIonk^k_ooool0ooooooooooooogKooooo
0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool0oooo
ooooooooogKooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgI
onk^k_ooool0ooooooooooooogKooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h0
00?ooooo00?oOZgIooooooooool0ooooooooooooogSooooo0Omn[MT1oooo
o`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomfooooo`;o
k^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooo
oooooomfooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^
k^kooooo0?oooooooooooomfooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo0?oooooooooooomhooooo`7oOZgI0Oooool1
ooooo`000oo^k^h00omn[MWok^k^ooooo`3oooooooooooooM_ooool2onk^
kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`3ooooooooo
ooooM_ooool2onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^
ooooo`3oooooooooooooM_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooo
ool00omn[MWoooooooooo`3oooooooooooooN?ooool1ogj]f@7ooooo0Ooo
ool000?ok^k^00?oOZgIonk^k_ooool0ooooooooooooogKooooo0_o^k^h1
ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool0oooooooooooo
ogKooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_oo
ool0ooooooooooooogKooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo
00?oOZgIooooooooool0ooooooooooooogSooooo0Omn[MT1ooooo`7ooooo
0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomfooooo`;ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomf
ooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo
0?oooooooooooomfooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03
ogj]fOoooooooooo0?oooooooooooomhooooo`7oOZgI0Oooool1ooooo`00
0oo^k^h00omn[MWok^k^ooooo`3oooooooooooooM_ooool2onk^kP7oOZgI
0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`3oooooooooooooM_oo
ool2onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`3o
ooooooooooooM_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn
[MWoooooooooo`3oooooooooooooN?ooool1ogj]f@7ooooo0Oooool000?o
k^k^00?oOZgIonk^k_ooool0ooooooooooooogKooooo0_o^k^h1ogj]f@7o
k^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool0ooooooooooooogKooooo
0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool0oooo
ooooooooogKooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgI
ooooooooool0ooooooooooooogSooooo0Omn[MT1ooooo`7ooooo0003onk^
kP03ogj]fOo^k^kooooo0?oooooooooooomfooooo`;ok^k^0Omn[MT1onk^
kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomfooooo`;o
i^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooo
oooooomfooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoo
oooooooo0?oooooooooooomhooooo`7oOZgI0Oooool1ooooo`000oo^k^h0
0omn[MWok^k^ooooo`3oooooooooooooM_ooool2onk^kP7oOZgI0Oo^k^h1
onk^kP000ooVi^H00omn[MWoi^KVooooo`3oooooooooooooM_ooool2onKV
iP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`3ooooooooo
ooooM_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWooooo
ooooo`3oooooooooooooN?ooool1ogj]f@7ooooo0Oooool000?ok^k^00?o
OZgIonk^k_ooool0ooooooooooooogKooooo0_o^k^h1ogj]f@7ok^k^0Oo^
k^h000?oi^KV00?oOZgIonKVi_ooool0ooooooooooooogKooooo0_oVi^H1
ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool0oooooooooooo
ogKooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIoooooooo
ool0ooooooooooooogSooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]
fOo^k^kooooo0?oooooooooooomfooooo`;ok^k^0Omn[MT1onk^kP7ok^k^
0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomfooooo`;oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooooomf
ooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo
0?oooooooooooomhooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWo
k^k^ooooo`3oooooooooooooM_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP00
0ooVi^H00omn[MWoi^KVooooo`3oooooooooooooM_ooool2onKViP7oOZgI
0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`3oooooooooooooM_oo
ool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`3o
ooooooooooooN?ooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^
k_ooool08?ooool00oo_moOoooooonogm`02ooooo`03onogmooooooooooo
00;ooooo00?okoOgooooooo_moL00_ooool00oo_moOoooooooooo`3ooooo
ooooooooA?ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWo
i^KVooooo`0Jooooo`03onoWioogmnooknOW01_oknOW00Coe]KWonoWioo_
inOoe]KW1_o_inL00oo_moOoooooooooo`3ooooooooooooo<Oooool2onKV
iP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`0Iooooo`0>
ooOgkooNg]koc/kNokfm_One_Lkoc/JeokFmc_o>a[Go]Kg>olk6]Onm_Kgo
]Kg>olk6]One_Lh3okfm_@07olk>c_nm_Kgoa[fmokFmc_o>a[Goa[fmokFm
cP02okfm_@05olJm_One_Lko_KfmolJm_One_Lh00onm_Kd02Oo>c/ko_Kfm
okfm_Oo6_Kgo]Kg>okfm_Oo>c/koc]KNonoWi`3ooooooooooooo<_ooool2
onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`0Ioooo
o`05omkNg_o>c/ko[JfUojf]YOnLW:D04OnLW9`00onLW:Go[JFDoibLY@02
oibLW007ojfUU?nLW:GoW9bLoibLW?n][JGoW9bLoibLY@02oibLW003ojf]
YOnLW9coW9bL00;o[JfU00?oc/k>omkNg_o_moL0oooooooooooooc?ooooo
0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo01Wooooo00?o
knOWomkNg_ooool09_ooool2omkNgP03onoWiooooooooooo0?oooooooooo
ool_ooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo01Wooooo00?og]kNolkFc_ooool04oooool00oogmnooooooooooo`02
ooooo`05onO_moooooooooooooooooo_inL00_ooool00oo_inOoooooonO_
m`02ooooo`04onogmoooooooinONolk>c_oooooooooooolbooooo`;oi^KV
0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo01Sooooo00?o
inogonOWg_o>e]h00_ooool00oo_moOoooooooooo`0;ooooo`03onogmooo
oooooooo00?ooooo00?oinogooooooooool02_ooool01oo_inOooooooooo
oooooooog]kNolkFg_o_inL0oooooooooooooc7ooooo0_o^k^h1ogj]f@7o
k^k^0Oo^k^h000?ooooo00?oOZgIooooooooool06Oooool00ooNg]kog/k6
ooooo`0Aooooo`03onogmooooooooooo00;ooooo00?omnoWooooooooool0
0_ooool01?oWkoOooooooooooooWkoL5ooooo`05onoWioooooooknOWolk>
c_o_moL0oooooooooooooc?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03
ogj]fOo^k^kooooo01Sooooo00?omoO_onONg_o>e]h03_ooool00oo_moOo
ooooooooo`04ooooo`03ooOgkooooooooooo00[ooooo00?okoOgoooooooW
koL00_ooool00ooNg]koc]K>onoWi`3ooooooooooooo<Oooool2onk^kP7o
OZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`0Iooooo`03omkN
g_o>c/kooooo00?ooooo00[oknOWolk>c_o_inOokoOgoooooooWkoOooooo
onoWioo>c/koknOW0_ooool00oo_moOoooooomkNgP05omkNgP06omK>e_n4
Ng?oW6]SojekHoo>_JGoU8b<0_n]Nf<02_nm_Kgoc/JeomkNc_o>a[Go_Kf]
onO_mooooooog]kNolk>c_o_moOooooooooooooo<Oooool2onKViP7oOZgI
0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`0Iooooo`04omKFiooN
g/koooooonoWi`;o_Kfm00Goc/k>oibLW?n]]KGoc/k>onogm`02ojf]Y@;o
W9bL01goS8b<okfm_On][JGoknOWoooooooWimkoknOWooOgkoo_inOomnoW
onOWg_oNc/KoDTY2og/@2?n4613o[G]SoiA2<Omc613oW34QoljUQ?oNg/ko
knO>omkNc_o>a[GoknOWoooooooNg]koc]KNonoWi`3ooooooooooooo<Ooo
ool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`0H
ooooo`03ooOgkooWimkoc]KN00;ooooo00?oe/kFomkNg_o_inL00_oNg]h0
1oo_inOoooooomKFioo_inOoc]K>omkNg_nm_Kd00_oNg]h2ooooo`0Holk>
c_n4U9CoW9bUoibLW?mkQ8CoJg=coeY[Jom:61SoLaP@oi`a8On4>C7oHaPH
oh@Q6?nULe[o[G]SoibLYOnLQ7_oU8aSojfe]OogmnooooooonoWioo>c/ko
koOgoooooooooooooc?ooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]
fOo^k^kooooo01Wooooo00?oe]KWomK>e_ooool01oooool00oo_moOooooo
ooooo`02ooooo`03onO_mooooooooooo00;ooooo00kog/k6ohb<S?n<S8co
Jf][ohb<S?n]YICoJf][oe882?m[<BWoW34QojekHon4613oQ24Hof/a:@;o
BU9J00SoFUYJoe9:@_m[Lg?oknOWoooooooNg]koc]KNonoWiooooooooooo
oolaooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo01Wooooo00Gog]kNolkFc_oooooomnoWojfe]@02okfm_@07okFmc_nm
_JgoknOWolk>c_n][JGoknOWojfe]@02okfm_@0ComkNg_ne_Lkoc/Jeoooo
ooo>e]ko_Kfmojf]YOnLU8co[JFDolk6]OmkLf?o610@oe882?n]Nf?oS6]:
oh@Q6?mk<BWoDSTaobTY:@03ocTi<@06oeYJ@_o_inOoooooonOWg_o>c/ko
koOgoooooooooooooc7ooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^
00?oOZgIonk^k_ooool06?ooool0;Oo_moOoinONolk>c_ooooookoOgokfm
_On][JGoc/kNolk6]Oo>c/koknOWolk>c_nm_KgoknOWojf]YOnm_Kgoc/k>
omkNg_o>c/ko[KFeoooooooNg/ko_Kf]ojf]YOnLW9co[Ib4oljmYOmcJf?o
8AP@oe9:@_mS@SWoBS4Yoe8i<OmB>BWoNg]kog^4Q?mJFU[oBU8iodY:<Om:
DSWoknOWoooooooFe^Ooc]K>onoWi`3ooooooooooooo<Oooool2onk^kP7o
OZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`0Iooooo`08omkN
g_o>e]koooooooooooo_moOoooooonoWiooWkoL5ooooo`03onogmooooooo
oooo00;ooooo00WoknOWooooooo>c]ko_Kf]okfm_OnDS8coLg=JojfLQ?mc
Jf<00_mB>C403om2:B7oDSTaoeY2>OmB>C7oS8acohb<S?mkNg_oJf=Bof][
B_mJHe[oknOWoooooooWimkoc/kNooOgk`3ooooooooooooo<oooool1ogj]
f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_ooool06?ooool2onoWi`03
omK>e_ooooooknOW00;oc/k>00WoW9bUojfUU?ne_Lkoc/JeomkNg_o>e]ko
c/k>omkNg_o>e]h00_o>c/h03?o6_Kgoc]KNooooooo>a[GoS8b<ohb<LomJ
FT;oS8b<olk6]OmcJf?oDTY2oc4H40;oDSTa00CoLeYBoe8i<OmJFT;oNg=S
0_m[JdX01omJFT;oJf]:onoWioo_moOoknOWolkFc_o_inL0oooooooooooo
oc7ooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_oo
ool06Oooool01_oNg]koc]K>oooooooooooo[JfUojfe]@Co_Kfm00Kog]kN
okfm_Oo>a[Goc]KNolk6]On]]KD2okfm_@0Aojf]YOoooooo[KFeodY:B_mB
BT;oJf=Bohb<LonLQ7_oFUYJoe8i:Om2:B7oJdY2oeYJ@_mcFU;oHeY:obTY
6?li>AP00_mJDRT01_li>ASoNf=:onoWiooooooog]kNolk>c_oooooooooo
oolbooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo01Sooooo00KokoOgonOWg_o>c/koooooonogmoo_inL9ooooo`0NonoW
iooWimkoooooonogmoo_inOoooooojf]YOlY<BWo:BTHodY::On]YICoa[fm
ocTi<Om2:B7oDSTaoe9:@_mkFT[oJf=BoeY2>OlY:ASoBS4YodY::OmcLe[o
BS4Yoe9S@_oFe^OoooooonOWg_o>e]koknOWoooooooooooooc7ooooo0_o^
k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool06Oooool0
2_oNg]koc]KNooooooo_inOoc]KNomkNg_o>c/kog]kNolk>c_o_inL2olkF
gP0PonoWiooNg]koc]KNolk>c_oFc]KoknOWolkFg_o_moOo[JFDo`000?lY
:ASo>B4HoibDS?o>aZgoNg=SobTY6?m2:B7o[G]SoiA[F_m[<BWo>CTHobTY
6?la>B7oBTXYodY:<Oli>ASoBTXaonoWioo_moOoknOWolk>c_o_moOooooo
oooooooo<oooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_oo
ool06?ooool0;Oo_moOoknOWolk>c_oooooog]kNokfm_On][JGo[KFeojf]
YOnLW9co]LKFojf]YOnm_Jgoc]KNolk>c_nLW:Go[JfUokfm_Oo>e/ko_Kfm
onoWion][JGo4000obTY6?la>B7o_Kf]omk>_On<S7?o:BTHog=JD_n]Nf?o
aZfLohAkLola>B7o610@ocTi6?m:DSWoBUY2obTY:Oli@S7oknOWoooooooF
e^Ooc]K>onoWi`3ooooooooooooo<Oooool2onk^kP7oOZgI0Oo^k^h1onk^
kP000ooVi^H00omn[MWoi^KVooooo`0Hooooo`;oknOW00?oc]K>oooooooo
ool00oo_moL01?ogmnooc]KNonOWg_o_inL6onogm`?ooooo01So[JfUobTY
6?lY:ASo:BTHohb<Loo>_JGoBUY2obTY6?li8ASoNf=:oha[B_mJFT;o>D8a
obTa:OlY8@SoBU8iohBDU?mkQ8CoFV=JonoWioo_moOoinONolk>g_ogmnoo
oooooooooooo<Oooool2onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn
[MWok^k^ooooo`0Iooooo`03omkNg_o>c]kooooo00CoknOW00Coe]KWonoW
iooWimkoe]KW1_o_inL01OoFe^OomnoWoooooon][JGo<CTQ00;oBUY200Wo
U8aSokfm[On]]KGoJg=coa0@2?li8ASo<AP@oaP@4?mJJf/00_mJHeX02OmS
Lhco[KFeoibeg_nU]LkoknOWonogmooNg]koc]K>onoWi`3ooooooooooooo
<Oooool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWooooooooo
o`0Iooooo`06omkNg_oNg/koooooolkFg_nm_Kgo]Jf]0_n][JD05On<S8co
]Kg>okfm[OnLW:Go[JfUojfe]Onm_Kgo[JfUojfe]On][JGoinogooooooo>
c/koHg><og^4Q?m[He;oNg]kokfm[On]YICoS8b<obTY:@02o`00000=odYB
F_nL]MkoYKG>oibeg_nU_MkoW;GWokG6e_nL]MkoknOWooOgkooNg]koc/k>
onogm`3ooooooooooooo<oooool1ogj]f@7ooooo0Oooool000?ok^k^00?o
OZgIonk^k_ooool06Oooool01OoNg]koc]KNooooooo_inOog]kN00;okoOg
00?oknOWolk>c_o_moL00_o_inL00oo>c/koknOWolkFgP02onoWi`04onO_
moogknOomoO_omKFi`;oW:fm00KoW9bUojf]YOnm_Kgo]Kg>okG6e_nU]Lh2
of=cS0KoW;GN00OoW;GWojFec_o_inOoooooomkNg_o>e]koknOW0?oooooo
oooooolaooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoV
i^Kooooo01Sooooo0_o_inL01Oo>e/koooooonoWioo_inOokoOg00;oknOW
00?o[KFeonoWioo_moL01Oo_inL01OoWkoOomnoWonO_moooooooc]KN00;o
[KgW00?o[LKgoib]_Oo>aZd00onL]NL01On]a^ooW;GWoibeg_nL]MkoW;GW
00GoW;GN00Goc]KNonogmooNg]koc/k>onogm`0Booooo`03ooclo?oZj^[o
oooo00cooooo00?oo_knonWYjOono_h04Oooool01?oalO7ooooooo[jn_od
m?@2ooooo`03oogmoOoZj^[ooooo0?ooooool_ooool2onKViP7oOZgI0OoV
i^H1onKViP000oo^k^h00omn[MWok^k^ooooo`0Iooooo`08onOWg_o>c]ko
ooooolkFg_nLW9coc/JeokFmc_n]]KD2ojf]Y@03oibLYOn][JGoW9bL00;o
c/k>013o[KFeojf]YOn<S8coc/k>oooooonea]KoW:gNoibeg_nL[MkoW:fm
ojf]YOnL[MkoW:g>oibeg_nL[MkoW:g>0_nL[Mh01_nL[LkoW:gNoib]g_nL
[LkoW:gNoib]cP;oknOW00?og]kNolkFc_o_inL02oooool00ol61PKofm_K
ooooo`03ooooo`05oj6QXOlB4Q;o=cLgob4Q8Oo;bl/00_ooool01_nGUiOo
3`l?oo[jn_ooooooC4a<oeIFEP;ooooo00So/K6aoaLG5oli>CWo=3@dokVi
^Ooooooo3Ph>on;RhP?ooooo01Co20P8ooooooooooooS8b<omcLg?oooooo
IVIVoh^;Roo/k>co9RHVob`/;?mJFU[o<S8bog=cLooooooo[Zj^oa0@4?l/
;2co8b<SonSXj?oooooolOooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooo
ool00omn[MWoooooooooo`0Hooooo`08onogmooNg]kog]k>ooooooo_inOo
c]KNonoWioogmnl3onoWi`05olkFg_o_inOoinONomKFioo_inL00ooNg]h0
1Oo_inOokoOgonoWioo>e]kog]kN00;oc]KN00Cog/k6omKFiooNg]koe]KW
0_o>e]h00ooNg]koc]KNolkFgP04olkFgP05okG6e_o_inOomoO_olkFg_o>
c/h03?ooool00ol61PKofm_Kooooo`02ooooo`06ooclo?lF5QKofMWIoooo
oonRXZ;oDE5A0_ooool02_m>CTko8b<Sok^k^oojn_[o5aLGob@T9?ofm_Ko
i^KVo`/;2oo7alL4ooooo`03o`h>3_oRh^;ooooo00;ooooo01;o20P8oooo
ooo5aLGo0`<3ofi^K_ooooooIVIVoh^;RonQXJ7o@d=3ooooooo;bl_o10@4
ooclo?ono_ko7AdMojVYZOooool2oogmoOooooooloooool1ogj]f@7ooooo
0Oooool000?ok^k^00?oOZgIonk^k_ooool06Oooool2omkNgP0>ooooooo_
inOooooooooooooFe^Ooc/k>onoWioogmnooooooooOgkooWkoOoknOWokfm
_OoNg]h2ooooo`0:onO_moo_inOokoOgooooooo_inOoooooooO_iooooooo
inogonogm`;oknOW00CoooooonoWiooWkoOomoO_0_o_inL00ooNg]koknOW
onogm`02onoWi`03omkNg_o>e/koknOW00_ooooo00?o1PH6om_Kfoooool0
0_ooool04Onm_Kgo:RXZooooooooooookNg]o`T92Ooclo?onOWio`l?3on^
[ZkoK6a/ol30`?m:BT[oJFUYojn_[on[Zj_o8B4Q00?o_kno00CojNWYoooo
ool>3Pkoh^;R0oooool04Ol820SoooooofYZJ_m_Kfoo9bLWoo_knomVIVKo
Rh^;on7QhOlN7QkoTY:BokVi^Ol820Sooooool71`OlF5QKooOgm0?oooooo
m?ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVoooo
o`0Hooooo`;oknOW013oc]KNooooooo_moOo[JfUokfm_Oo>c/koS8b<ojf]
YOne_LkoknOWoibLW?n][JGoS8b<ohBDU?nDS8co[KFe0_n][JD02Oo>c/ko
knOWonO_mooNg]koW9bUolk>c_n]]KGo[JfUoibLW002olk>cP08oibLW?oN
g]ko[JFDolk>g_n][JGoW9bUohBDU?o>e/h2onoWi`04onogmoo>c]koc/k>
onogm`_ooooo00Oo1PH6obLW9omZJV[o^;RhoogmoOo:b/[o8R8R00;ooooo
00goiNGUo`l?3ooinOWo^k^kocdm?Ookno_o;Rh^ogUiNOn>SXko_;bloeaL
G?o7alOo5aLG00;oM7Ad00Go6a/Kol71`Ooooooo3Ph>omoOg`03ooooo`0A
o`P82?ojn_[o4a<Com7AdOmZJV[o/K6aofIVI_n;Rh_oooooooclo?o?cloo
SHf=o`P82?oooooobLW9o`h>3_ojn_X0ooooooodooooo`;oi^KV0Omn[MT1
onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo01Wooooo00Gog]kNolkF
c_ooooooknOWolk>cP03omkNgP0:olkFg_o_inOoknOWomkNg_o>e]koc/k>
omK>e_n]]KGog]k>olkFgP;oc/k>00OoooooonoWion]]KGoS8b<okfm_On]
[JGog]kN00;oc/k>00Wog]kNolk>c_oNg]koc/k>omkNg_oFc]Koc]K>olk>
c_oFe^L00oo_inL00ooNg/koc]KNonoWi`0;ooooo`0]o`H61_oBd];o^;Rh
ob@T9?n6QXKoooooob4Q8Onl_;coo?cloh:2P_mOGeooooooog9bL_n5QHGo
oooooeYJF_lC4a?odm?Coo_knolR8R;on?Shob8R8_oPh>3okno_oadM7Ooj
n_[oooooo`h>3_mKFe_ok>c/ookno_oooooo20P8ok>c/ol];BgoooooolW9
bOmCDe?oIVIVoh^;Roooooooc<c<oogmoOo7alOo9bLW00;ooooo00Go8R8R
ohj>S_okno_on?ShooknoP3ooooooo7ooooo0_o^k^h1ogj]f@7ok^k^0Oo^
k^h000?ooooo00?oOZgIooooooooool06Oooool01?oWimkoc]KNooooooo_
moL3ooooo`05onoWioooooooinogooooooogknL00oooool02?o_inOokoOg
onoWioooooooknOWoooooooNg]koc/k>0_oNg]h02_o_inOoooooonO_mooo
ooooknOWonO_moogknOoinogonoWiooWkoL4onoWi`05omKFioo_inOoc]KN
omk>a_o_moL02oooool04Ol61PKofm_Koooooon?Shoo<30`ooooooo1`L7o
=CDeobDU9Om;Bd_ohN7QoooooomBDU;odM7Aoooooona/K7o>SXj00;ooooo
00KoMWIfolO7aonk^k_o<C4aoclo?on_[jl2ooooo`08ocLg=onUYJGo;2`/
ok^k^ooooooo20P8oeQHF?n8R8P2ooooo`08obh^;_mDE5CoRh^;oooooomX
J6So>SXjoc8b<_nVYZH2ooooo`05om3@d?mZJV[o;2`/ob`/;?ogmoL0oooo
ooocooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^ooooo`0I
ooooo`05omKFioo>c/koooooonoWion][JD00_n]]KD02Onm_Kgo[KFeomkN
g_nm_Kgo[KFeonOWg_n][JGo]Kg>ojf]Y@02olk>cP07okF][Onm_Kgo[KFe
oibLW?n<S8co_Kf]olk>gP02ojfe]@;o[JfU00Koc/kNokfm_On][JGo_Kfm
olk>c_n][JD2ojfe]@;o[JfU00Goc/k>onoWioo>e/koc/k>onO_m`0;oooo
o`05o`H61_oKfm_olo?coe]KFomLG5`06oooool00ol71`Oo2`/;on?Sh`02
ooooo`03ohF5QOl:2P[oRh^;0?oooooooOooool2onk^kP7oOZgI0Oo^k^h1
onk^kP000ooVi^H00omn[MWoi^KVooooo`0Hooooo`08ooOgkooWimkog]kN
ooooooo_inOo[KFeojf]YOo>c/h2okfm_@04omkNg_o>c/ko[JfUomKFi`;o
[JfU00Koc/k>omkNg_nm_KgoW9bLolk>c_o6_Kd2okfm_@0:olk>c_oNg]ko
[JFDojfe]Oo>c/ko_Kfmolk>c_n][JGo]Kg>olk>cP;o_Kfm00Ko[JfUolk>
c_nm_Kgo[JfUokfm_Oo_inL2olk>cP03ooOgkooooooooooo00Wooooo00Go
4a<Cob<S8olH61So?3`lom;BdP0Kooooo`03oa<C4om7AdOooooo00;ooooo
00?oh^;Ro`d=3OnATI40ooooooomooooo`;oi^KV0Omn[MT1onKViP7oi^KV
0003onk^kP03ogj]fOo^k^kooooo01Wooooo00Coe]KWolkFc_ooooookoOg
0oo_inL01_oNg]koooooooooooo_inOoooooonogm`;oknOW00KoooooooOg
koogmnooe]KWooO_iooWkoL2ooOgk`03onO_moo_moOoknOW00;oknOW00Ko
inogonoWiooNg]koinogonoWioo>e]h3onoWi`07omKFiooNg]kog]kNonOW
g_o>c/koc]KNonoWi`3ooooooooooooo<Oooool2onk^kP7oOZgI0Oo^k^h1
onk^kP000oooool00omn[MWoooooooooo`0Hooooo`07ooOgkooWimkoe/kF
ooooooo_inOoc/k>ojfe]@02oibLW00:ojf]YOnm_Kgog]kNolk>c_nm_Kgo
g/k6olkFg_nm_Kgo]Kg>okfm_@;oc/k>00oo_KfmokFmc_o>c/koc/JeolkF
g_nm_Kgo[KFeolk>g_oNg/ko_Kfmojfe]Onm_Kgo[KFeokfm_Oo>c/h00_nm
_Kd01?o>c/ko[JfUokfm_Oo>c]h2olk>c_ooooooooooooldooooo`7oOZgI
0Oooool1ooooo`000oo^k^h00omn[MWok^k^ooooo`0Iooooo`07omKFioo>
e/koooooonoWionLW9co_Kfmojf]Y@02okfm_@05ojfe]Oo>c/ko_Kfmokfm
_Oo>e]h00_n]]KD01_n][JGo[KFeojf]YOn]]KGo_Kfmojf]Y@;o_Kfm00So
g]kNoib]_On][JGoc/JeolkFg_n4U9Co[JfUojfe]@;o[JfU00[oc/k>okfm
_OnLW9co_Kfmohb<S?nLW9cog]kNolk>c_oNc/Koinogoooooooooooooc7o
oooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool0
6?ooool01_ogmnooinONolk>g_ogmnooknOWomkNgP;oinog00KoknOWonog
moo_inOoinogonoWioo_moL2onoWi`04olk>g_o_inOomoO_olkFgP;og]kN
2oo_inL01_oNg]koknOWomkNg_oNg]koc/k>omK>eP;oc/k>00Coc]KNolk>
c_o>c/komnoWoooooooooooooc7ooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H0
00?ok^k^00?oOZgIonk^k_ooool06Oooool01?oFe^Ooc/k>oooooooFe^L5
olk>cP04omkNg_o>c/koc/k>onONgPCoc/k>00coc/kNolk>c_o>c/koQ9BD
okfm_Oo>c/koc]KNolk>c_nm_Kgoc/k>okfm_Oo>c]h2olk>cP07okfm_Oo>
c/ko_Kfmolk>c_nm_Kgo]Jf]ojfe]@02okfm_@04omk>a_nm_Kgoc/k>onog
mooooooooooooolaooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03
ogj]fOoooooooooo01Wooooo00Cog]kNolk>c_ooooooc]KN0on][JD03OnL
W:GoS8b<olk>c_nLW9co[JfUokG6e_nm_KgoQ9BDojfUU?n][JGoc/k>ojfe
]Oo>c/h00_n][JD01?nLW9co_Kfmolk>c_n][JD2ohb<S00@olJm_OnLW9co
S8b<oibLW?nLW:GoS8b<okfm_On<S8coW9bLoiB<S?nLW9coS8b<okFmc_nm
_Kgog]k>onoWiooooooooooooolcooooo`7oOZgI0Oooool1ooooo`000oo^
k^h00omn[MWok^k^ooooo`0Hooooo`04onogmoo_inOoc/k>onogm`?oknOW
00Gog]kNonoWioo>c/koc]K>omkNgP05onoWi`03onOWg_o_inOoknOW00;o
knOW00Koe]KWomkNg_o>e/koknOWonOWg_oFe^L3olk>cP08okfm[Oo>c]ko
c/k>omk>a_ne_Lko_Kfmolk>c_ne_Lh3okfm_@03okfm[Oo>e]kooooo0?oo
oooooooooolaooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]
fOoVi^Kooooo01Sooooo00ComnoWomKFiooNg/kooooo1?oNg]h01oo>c/ko
g]kNolk>g_oNg]kog]k>omkNg_o>e]h00_oNg]h00oo>c]kog]kNomkNgP02
omkNgP0:olk>c_o_inOoc/kNomkNc_ne_Lkog/k6ojf]YOnLW:Go]Kg>okF]
[@;o[JfU00?o[KFeojf]YOn][JD00_n][JD01_nLW:Go[JfUojfe]Onm_Kgo
knOWonogmooooooooooooolaooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo01Wooooo00CoknOWolk>c_o_moOoc/k>0_n]
[JD00onLW:GoW9bLohb<S002ojf]Y@0=ohBDU?nLW:Go[JfUojf]YOnLW:Go
[JfUoibLYOo>a[GoW9bUohb<S?nLW9coc/k>ohb<S003oibLW004ojf]YOn<
S8coNg]kog]kN`;oJf][00[oW9bLof][Jom[Jf_oNg]kohb<S?mJFU[oW9bL
ojf]YOo>c]koknOWoooooooooooooc;ooooo0_o^k^h1ogj]f@7ok^k^0Oo^
k^h000?ooooo00?oOZgIooooooooool06?ooool01_oWkoOoinONolk>c_oo
ooooc/k>olkFgP?og]kN00[o_KfmomkNg_oNg]kog]kNokfm_OoNg]koc/k>
olkFc_oNg]koinON0_o>c/h00onm_Kgoc/k>omkNgP02omkNgP0<olk>c_o>
e]koc/k>okfm_On][JGoW9bLohb<S?mkNg_oS8b<og]kNomkQ8CoNg]k0_n<
S8`00onLW9co_KfmonoWi`3ooooooooooooo=Oooool1ogj]f@7ooooo0Ooo
ool000?ok^k^00?oOZgIonk^k_ooool06Oooool01?oWimkoc/k>onogmoo_
inL4omkNgP;o_Kfm00SoinONomkNg_oNg]kog]kNonOWg_oFe^Oog]kNomKF
i`Kog]kN00Soc/kNomkNg_oNc/Koc/k>okfm_OnLW9coS8b<of]cL`CoJf][
00GoNg]kog^4Q?nLW9co_KfmomkNgP3ooooooooooooo=?ooool2onk^kP7o
OZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`0Hooooo`0:ooOg
kooFe^Ooc]K>onO_moo_inOoS8b<ojf]YOo>c/koQ9BDokF][@GoW9bL00Go
c/k>ojfUU?n][JGoS8b<oibLY@02ojf]Y@03oibLW?n][JGoS8b<00;oW9bL
00?oNhB4okfm_OmkNg/00om[Jf/00on<S8coNg]kohb<S002ojf]Y@;oc/k>
00?og]kNooooooooool0oooooooooooooc?ooooo0_oVi^H1ogj]f@7oi^KV
0OoVi^H000?ok^k^00?oOZgIonk^k_ooool06Oooool01ooNg]koc/k>onog
moo_inOoc/k>olkFc_oWimh00_oNg]h02Oo>e]koc/k>olk>c_o>e]koc/k>
omkNg_o>c/koc/kNomkNcP03olk>cP03ojfe]Oo>c/koc/k>00;oc/k>00Go
a[fmokFmc_n][JGoS8b<okfm_@04ooooo`04onoWiooNg]koc/k>omkNg_oo
oooooooooolfooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]
fOoooooooooo01Wooooo00Oog]kNolk>c_o_inOoknOWomkNg_oFe^OoknOW
00;og]kN00[oimkNonoWioo_inOoknOWomkNg_o>c]koinONomkNg_oFe^Oo
knOW1_oNg]h3olk>cP03ojfe]OnDS8coc/k>00?ooooo0_oNg]h00oo>c/ko
g]kNooooo`3ooooooooooooo>?ooool1ogj]f@7ooooo0Oooool000?ok^k^
00?oOZgIonk^k_ooool06?ooool06?oWkoOoinONolk>c_o_moOoc/Jeolj<
HooNc[goknOWomjm[Oo6Nd[oc/J]olkFg_n][JGoQ9BDojfe]OnLW9coc/k>
ojfe]On]YICoQ9BDojfe]OnLU8coc/k>oibLY@CoW9bL00[o[JfUog^4Q?m[
Jf_o_Kfmooooooo_moOoinONomkNg_o>c/kog]kNooooooooooooocSooooo
0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool06Ooo
ool06?o>e]koc/k>onogmoo_inOoaZfLomkNc_o_inOoaZfLolj<Hoo_inOo
e]KWokfm[Oo>c/ko[KFeolk>c_oNg]koc/JeokFmc_o6_Kgoc/JeokFmc_o>
a[Go[JfUojfe]@;o_Kfm00[oW9bLojf]YOn<S8coNhB4olk>c_ooooooknOW
olkFg_o>c/kog]kNooooooooooooocWooooo0_oVi^H1ogj]f@7oi^KV0OoV
i^H000?ok^k^00?oOZgIonk^k_ooool06?ooool03Oo_moOoknOWolk>c_o_
inOoinONolkFc_o>YHCoc/JeolIkB_o>_JGoknOWonOWg_o>e]h00_o_inL0
0ooWimkog]kNomkNgP04omkNgP03olk>g_o>c/kog]kN00;og]kN00Woa[fm
okFmc_n][JGoS8b<olk>g_o_inOog]kNolk>c_oNg]h0oooooooooooooc[o
oooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool0
6Oooool02OoNg]koc/k>ooOgkooFe^OoknOWomJeW?o>a[GoaW]:olkFgP02
onoWi`03onOWg_oFe^OoinON00Gog]kN00Coc/kNomkNg_oNg/kog]kN1?o>
c/h2ojf]Y@05ohb<S?oNc/Kog]kNolk>c_oNg]h0ooooooooooooocgooooo
0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo01Sooooo00?o
inogonOWg_o>c/h00oo_inL00oo>a[GocXaSoljLN`02onoWi`03onOWg_oN
g]kog]kN00?og]kN00Soc]KNomkNg_oNg]kog]kNomkNc_oFc]Koc/k>omkN
gP;oc/k>0_nm_Kd2oibLW003olkFg_o>c/kog]kN0?oooooooooooolloooo
o`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo01Wo
oooo00cog]kNolk>c_o_inOoknOWolkFg_oWimko]G=Jolk6[Oo_inOoinON
omKFiooWimh5omkNgP06omkNc_o>c]kog]k>olk>g_oNg/koc/kN0oo>c/h0
1_nm_Kgo[KFeoibLW?nm_Kgoc/k>omkNg_oooooooooooolmooooo`;oi^KV
0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo01Sooooo00Go
koOgonoWioo>c/komoO_olkFgP02onoWi`04olk6]OoWimkoinONomKFi`Go
g]kN00Ooc/kNomkNg_o>e]kog]k>olk>g_oNg/koc]KN00?oc/k>00Ko_Kfm
ojfe]On][JGo[KFeolk6]OoNg]kooooooooooooo?_ooool2onk^kP7oOZgI
0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`0Iooooo`0;onoWioo>
e]koknOWonOWg_o>e]koknOWonOWg_oFe^OoinONomkNg_oWimh00ooNg]h0
1ooNg/kog]kNomkNc_oFc]Kog]kNolk>c_o>e]h00_o>c/h01oo>a[Go]Kg>
okfm_Onm_Jgo[JfUojfe]OoFe^L0oooooooooooood7ooooo0Omn[MT1oooo
o`7ooooo0003onk^kP03ogj]fOo^k^kooooo01Wooooo013okoOgonoWioog
mnooe]KWonoWiooWimkoe]KWonOWg_o>e]koinONolkFg_oNg]koc]KNomkN
g_o>e]kog]kN0_o>e]h00oo>e/koc]KNolk>cP03olk>cP05okfm_On]]KGo
[KFeolk>c_o_inL0oooooooooooood3ooooo0_o^k^h1ogj]f@7ok^k^0Oo^
k^h000?oi^KV00?oOZgIonKVi_ooool06_ooool>onoWi`08omkNg_o_inOo
knOWonoWiooNg]koknOWomkNg_o_inL2omkNgP;oknOWoooooooooooood;o
oooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool0
ooooooooooooogKooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?o
OZgIooooooooool0ooooooooooooogSooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomfooooo`;ok^k^0Omn[MT1
onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomfoooo
o`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oo
oooooooooomfooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]
fOoooooooooo0?oooooooooooomhooooo`7oOZgI0Oooool1ooooo`000oo^
k^h00omn[MWok^k^ooooo`0dooooo`03onogmoooooookoOg00;ooooo00?o
koOgooooooooool00_ooool00oo_moOoooooonogm`02ooooo`03onogmooo
oooooooo0?ooooooooooool`ooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo02kooooo00?oknOWooOgkoo_inL06oo_inL0
1?oFe^OoknOWonoWiooFe^L6onoWi`03onogmooooooooooo0?oooooooooo
oolMooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^ko
oooo02gooooo00komoO_omkNg_o>c]ko_KfmokFmc_o>a[Go]Kg>olk6]One
_Lkoc/Jeokfm_One_Lkoc/JeokFmcP?o_Kfm00Ooc/k>okfm_Oo6_Kgo]Kg>
olk6]Oo6_Kgo]Kg>00;o_Kfm00Goa[fmokFmc_nm_Kgoa[fmokFmcP03okfm
_@09olk>c_nm_Kgo_KfmolJm_One_Lko_Kfmolk>c_o>e]koknOW0?oooooo
oooooolNooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoo
oooooooo02gooooo00Gog]kNolk>c_n][JGo[JfUoibLY@0AoibLW003oibL
YOn]YICoW9bU00;oW9bL00Oo[JFDoibLYOnLW9coW9bLojf]YOnLW9coW9bU
00;oW9bL00?o[JfUoibLW?nLW9`00_n][JD00oo>c/kog]kNonogm`3ooooo
oooooooo7oooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_oo
ool0;Oooool00oo_inOog]kNooooo`0Vooooo`;og]kN00?oknOWoooooooo
ool0oooooooooooooa_ooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV
00?oOZgIonKVi_ooool0;Oooool00ooNg]koc]K>ooooo`0Cooooo`03ooOg
kooooooooooo00;ooooo00GoinogooooooooooooooooonoWi`02ooooo`03
onoWioooooooinog00;ooooo00CokoOgoooooooWimkoc/k>oooooooooooo
oakooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_oo
ool0;?ooool00ooWkoOoinONolkFgP02ooooo`03onogmooooooooooo00_o
oooo00?okoOgooooooooool00oooool00ooWkoOoooooooooo`0:ooooo`07
onoWiooooooooooooooooooNg]koc]KNonoWi`3ooooooooooooo7Oooool2
onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`0]oooo
o`03omkNg_oNc/Kooooo017ooooo00?okoOgooooooooool00_ooool00oog
knOoooooooooo`02ooooo`04onO_moooooooooooonO_m`Gooooo00GoknOW
ooooooo_inOoc/k>onogm`3ooooooooooooo7oooool1ogj]f@7ooooo0Ooo
ool000?ok^k^00?oOZgIonk^k_ooool0;?ooool00oogmnooimkNolkFgP0>
ooooo`03onogmooooooooooo00Cooooo00?omoO_ooooooooool02_ooool0
0oo_moOoooooonO_m`02ooooo`03omkNg_o>e/koknOW0?oooooooooooolM
ooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo
02gooooo00?og]kNolk>c_ooool00oooool02_o_inOoc/k>onoWioo_moOo
ooooonO_moooooooknOWolk>c_o_inL2ooooo`03onogmooooooog]kN00Go
g]kN00Koe/kFohAkLonLJf?o[G]SoljmYOnDS8`2ojekH`0:okfm_Oo>a[Go
g]k>olk6]Onm_JgoinogoooooooNg]koc/k>onogmooooooooooooolMoooo
o`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo02go
oooo00Coe]KWomkNc_ooooooknOW0_nm_Kd01Oo>c/koW9bLojfe]Oo>c/ko
koOg00;o[JfU0_nLW9`07On<S8co_Kfmojf]YOo_inOoooooonOWg_o_inOo
moO_onoWioogknOoinONomk>a_mBBT;oNa08oh@H4?n]Nf?oU48aog<H4?nL
<B7ocZF4omkNc_o_ilkog]k>olk6]Oo_inOoooooomkNg_o>e]koknOW0?oo
oooooooooolMooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]
fOoooooooooo02cooooo00?omoO_onOWg_o>e]h00_ooool00ooFc]Kog]kN
onoWi`02omkNgP07onoWioooooooe]KWonoWioo>e/kog]kNokfm_@02omkN
gP;ooooo01Soc/k>ohBDU?nLW:GoW9bLog^4Q?m[Lg?oFV][odXH6?mc613o
W34Qoh@i<OmS61SoQ24HojEcF_n]Nf?oW9bUoib4NonDS6?o[KFeooOgkooo
ooooknOWolk>c_o_moOooooooooooooo7oooool1ogj]f@7ooooo0Oooool0
00?ok^k^00?oOZgIonk^k_ooool0;Oooool00ooFe^Ooe/kFooooo`07oooo
o`03onogmooooooooooo00;ooooo00?oinogooooooooool00_ooool03_oN
c/KoS8b<ohb<S?m[Jf_oS8b<ojfUU?m[Jf_oDPP8of/a:OnL<B7o[G]Soh@H
4?n48ASoJc4Y0_m:DUX02?mJFU[oDTY2of]cLoo_inOoooooomkNg_o>e]ko
knOWoooooooooooooagooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV
00?oOZgIonKVi_ooool0;Oooool01OoNg]koc]K>ooooooogknOo[KFe00;o
_Kfm00Oo]Kg>okfm[Oo_inOoc/k>ojf]YOo_inOo[KFe00;o_Kfm01?og]kN
okFmc_o>a[GoooooolkFg_nm_Kgo[JfUoibDS?n]YICoc/Jeog]cHolH413o
DPP8ojekHon<Jd[oQ24Hog/a:OmB>C7o:BTY00?o>CTa00KoFUY2onoWiooo
ooooinONolk>c_o_moOooooooooooooo7Oooool2onKViP7oOZgI0OoVi^H1
onKViP000oo^k^h00omn[MWok^k^ooooo`0/ooooo`0]onogmooWimkoc/k>
ooooooo_moOo_Kfmojf]YOo>c]koc/Jeolk>c_o_inOoc/k>okfm_Oo_inOo
[JfUokfm_Oo>c/kog]kNolk>c_n]]KGoooooomkNc_nm_Jgo[JfUoibLW?n]
W8Coc[fUog=[HolQ613oDTY2of=2>Om:<BWoDSTaoe8i:OmkNg_oNhB4oeYJ
F_m:DSWoBTXaodYB>Oo_inOoooooomKFioo>e/koknOW0?oooooooooooolM
ooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo
02gooooo00Sog]kNolkFg_ooooooooooonogmoooooooknOWonO_m`Gooooo
00?okoOgooooooooool00_ooool02Oo_inOoooooolk>g_nm_Jgo_KfmoiB<
S?mcLe[o[Ib4og=[H`02oe8i<@0?od8Y8OmB>C7oFT8ioe8i<On<S7?oS8b<
og]kNom[He;oJf]:oeYSF_o_inOoooooonOWg_o>c]komoO_0?oooooooooo
oolOooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^ooooo`0/
ooooo`;oknOW00?oe/kFooooooo_inL00_o>c/h02OnLW:Go[JFDokFmc_o>
a[Gog]kNolkFg_o>c/kog]kNolkFgP02olk>cP0<olJm_Oo>e]koooooolk6
]On<S8coS8acoeYJ@_n<S8coc/Jeog=[HomBBT;o<AP@0_mB>C401?mcFU;o
DSTaoeYJ@_mkLf<2of][BP07oeYJ@_m[Jd[oknOWonogmoo_inOoc]K>onoW
i`3ooooooooooooo7Oooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H0
0omn[MWoi^KVooooo`0]ooooo`06omkNg_o>e/kooooooooooon][JGo[KFe
1?nm_Kd01_oNg]ko_Kfmolk6]Oo>e]koc/Jeojfe]@;o_Kfm017o[JfUoooo
oon]]KGoBTY:oe9:@_m[He;oS8acoib4NomJFU[oDSTYod8Y8Om[BT;oFUY2
og=JD_mSFT[o:BTHocTi6002oeYB:@06ocTi6?mkHd[oknOWoooooooNg]ko
c/k>oooooooooooooakooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^
00?oOZgIonk^k_ooool0;?ooool01_o_moOoinONolk>c_ooooookoOgonoW
i`Wooooo01koknOWonOWg_ooooookoOgonoWiooooooo[JfUobTa:OlY:ASo
BTXYojfUU?o6_Kgo>CTaod8Y8OmB>C7oDTY2og]JB_m[He;oFT8iobTY6?m:
<BWoBTXYog=cF_m:<BWoDV=2omKFioooooooinONolkFg_o_inOooooooooo
oooo7Oooool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWooooo
ooooo`0]ooooo`0:omkNg_o>e]koooooonoWioo>e]kog]kNolk>c_oNg]ko
c/k>onoWi`;oc]KN023oknOWomkNg_o>e]koc/k>omK>e_o_inOoc]KNonog
mon]YICo0000obTY6?li8ASoW9B<olk6[OmkLf?o:BTHod8Y8On]Nf?oU6]J
of/a:Oli>ASo:BTHoc4i8Om:BRWoBTXaocTi6?m:BS7oknOWonogmoo_inOo
c/k>onogmooooooooooooolOooooo`7oOZgI0Oooool1ooooo`000oo^k^h0
0omn[MWok^k^ooooo`0/ooooo`0]onogmoo_inOoc/k>oooooooNg]ko_Kfm
ojf]YOn]]KGo[JfUoibLW?nea]Ko[JfUokfm[Oo>e]koc/k>oibLYOn][JGo
_KfmolkFc_nm_KgoknOWojf]YOl@003o:BTHoc4i8Onm_Jgog/jmohb<LolY
:ASoLeYBojekHoo6[IcoQ7]coc4i8OlH413o>CTHodYB>Om:FT;o:BTYocU2
<Oo_inOoooooomKFioo>e/koknOW0?oooooooooooolMooooo`;ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo02cooooo0_o_inL0
0oo>e/koooooooooo`03onogm`04ooOgkoo>e]koinONonoWi`KokoOg0ooo
ool06?n][JGo:BTHobTY6?lY:ASoS8acoljmYOm:FT;o:BTHocTQ6?mkHd[o
S6]:oeYJ@_li@S7o:C4YobTQ2?m:DSWoQ9BDog^4Q?mJHe[oknOWonogmooW
imkoc/kNooOgkooooooooooooolMooooo`;oi^KV0Omn[MT1onKViP7oi^KV
0003onk^kP03ogj]fOo^k^kooooo02gooooo00?og]kNolk>g_ooool01?o_
inL01?oFe^OoknOWonOWg_oFe^L6onoWi`05omKFioogknOoooooojf]YOla
>B400_m:FT802OnDS6?o_Kf]ojfe]Om[Lg?o4108ocTQ6?la613o610@oeY[
J`02oeYSFP09of=cS?n]]KGoW;GNojFec_o_inOokoOgomkNg_o>e/koknOW
0?oooooooooooolMooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03
ogj]fOoooooooooo02gooooo00Kog]kNomkNc_ooooooc]KNokfm_One[Jd2
ojf]Y@0Eohb<S?ne_Lko_Kf]oibLYOn][JGo[KFeokfm_On][JGo[KFeojf]
YOoWkoOoooooolk>c_mSLhcoNhB4of]SD_mkNg_o_Kf]ojfUU?n<S8co:BTY
00;o000000goBU9Joibeg_nU]LkoW;GNojFmg_nL]NOo]LKFoibeg_o_inOo
moO_omkNg_o>c/kokoOg0?oooooooooooolOooooo`7oOZgI0Oooool1oooo
o`000oo^k^h00omn[MWok^k^ooooo`0]ooooo`05omkNg_o>e]koooooonoW
iooNg]h00_o_moL00oo_inOoc/k>onogm`02onoWi`03olk>c_o_inOoc]KN
00;oknOW00CoinogooO_ioogmnooe]KW0_nL[Kd01_nLW:Go[JfUokfm_One
_Lko]LKFojFecP;oHg><1_nL]Mh01onL]NOoYKG>onoWiooooooog]kNolkF
g_o_inL02Oooool00omhN7SoV9RHonc/k03ooooooooooooo4Oooool2onk^
kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`0/ooooo`;o
knOW00Goc]K>ooooooo_inOoknOWonogm`02onoWi`03ojfe]Oo_inOokoOg
00GoknOW00GoinogooO_iooWkoOoooooolkFgP02ojfmi`03ojg6monL[Kgo
c/J]00?oW;GW00Go[LK_oibeionL]MkoW;GNoibei`05oibegP05olkFg_o_
moOog]kNolk>c_o_moL02Oooool01?nBTY;oRHV9oaPH6?ojn_X2ooooo`04
oo7alOoooooon_[jooCdm0Sooooo00ColO7aooooooojn_[om?Cdooooooom
ooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo
02gooooo00SoinONolk>g_ooooooc]KNoibLW?o>a[Go]Kg>ojfe]@;o[JfU
00?oW9bUojf]YOnLW9`00_o>c/h04?n]]KGo[JfUohb<S?o>c/kooooookG6
e_nL[MkoW;GNoib]g_nL[Kgo[JfUoib]g_nL[LkoW;GNoib]g_nL[Lh2oib]
gP06oib]c_nL[MkoW:gNoib]c_nL[MkoW:g>0_o_inL00ooNg]koc]K>onoW
i`0;ooooo`0<ocHf=_ni^KWok>c/obHV9_l/;2coFUYJoc8b<_mcLg?ooooo
ooclo?lG5aOoNWYj0_ooool01_o/k>co9RHVob`/;?mJFU[o<S8bog=cLooo
oooooOooool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWooooo
ooooo`0/ooooo`08onogmooNg]kog]k>ooooooo_inOoc]KNonoWioogmnl3
onoWi`05olkFg_o_inOoinONomKFioo_inL00ooNg]h01Oo_inOokoOgonoW
ioo>e]kog]kN00;oc]KN00Cog/k6omKFiooNg]koe]KW0_o>e]h00ooNg]ko
c]KNolkFgP04olkFgP05okG6e_o_inOomoO_olkFg_o>c/h03?ooool05?m>
CTkoTI6Aoj6QXOm3@d?ooooool_;bol410Coo?cloooooone]KGo:b/[oahN
7_okno_ooooooj6QXOm3@d?ooooool_;bol410Coo?clooooooooooooo`7o
OZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^ooooo`0]ooooo`;og]kN
00koooooonoWioooooooooooomKFioo>c/koknOWooOgkooooooomoO_onO_
moo_inOo_KfmomkNgP;ooooo00[oinogonoWioo_moOoooooonoWiooooooo
mnoWoooooooWkoOokoOg0_o_inL01?ooooooknOWonO_moogmnl2onoWi`03
omkNg_o_inOokoOg00;oknOW00?og]kNolkFc_o_inL02oooool01om>CTko
TI6Aon7QhOlN7QkoTY:BokVi^Ol820P00_ooool02_mFEUKoVIVIoe=CDon`
/;3oooooon7QhOlN7QkoTY:BokVi^Ol820Soooooookooooo0_o^k^h1ogj]
f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool0;?ooool2onoWi`0@
olkFg_ooooookoOgojf]YOnm_Kgoc/k>ohb<S?n][JGo]Kg>onoWionLW9co
[JfUohb<S?n4U9CoU8b<ojfe]@;o[JfU00Woc/k>onoWiooWkoOog]kNoibL
YOo>c/ko[KFeojf]YOnLW9`00_o>c/h02?nLW9cog]kNojfUU?o>c]ko[JfU
oibLYOn4U9Coc]K>0_o_inL01?o_moOoc/kNolk>c_o_moL;ooooo`0=odi>
C_nATI7oooooooclo?o?clooSHf=o`P82?ooooookno_o`l?3oo`l?3o^;Rh
odY:BP02ooooo`04ooclo?o?clooSHf=o`P82?ooooooo_ooool2onKViP7o
OZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`0]ooooo`05omkN
g_o>e/koooooonoWioo>c/h00ooNg]h02_o>e]koknOWonoWiooNg]koc]KN
olk>c_oFc]Ko[KFeomkNc_o>e]h2olk>cP07ooooooo_inOo[KFeohb<S?nm
_Kgo[JfUomkNgP02olk>cP09omkNg_o>c/kog]kNolk>c_oNg]koe/kFolkF
c_o>c/koe]KW00?oknOW00?og]k>olkFg_o_inL02oooool04om>CTkoTI6A
ooooooo<c<cooOgmolO7aolW9bOooooooiNGUomHF5SooooooogmoOlR8R;o
h^;Rooooooo<c<cooOgmolO7aolW9bL0ooooooonooooo`;ok^k^0Omn[MT1
onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo02gooooo00CoinONolkF
g_ooooookoOg0oooool01Oo_inOoooooonO_mooooooomnoW00?ooooo00So
knOWonogmoo_inOoooooonoWiooooooog]kNolk>cP;og]kN00[oknOWoooo
oooWkoOoooooonoWiooWkoOomnoWonO_moo_inOoinog1?o_inL01OoFe^Oo
knOWolkFg_oNc/KokoOg00_ooooo00[oCTi>oi6ATOooooooJ6QXocXj>_lb
<S;oYZJVoooooomPH63o_Kfm0_ooool01on@T93oW9bLoooooomXJ6So>SXj
oc8b<_nVYZH0ooooooooooooo`7ooooo0Omn[MT1ooooo`7ooooo0003onk^
kP03ogj]fOo^k^kooooo02gooooo00Goe]KWolk>c_ooooooknOWojf]Y@02
ojfe]@09okfm_On]]KGog]kNokfm_On]]KGoinONojf]YOne_Lko[JfU00;o
c/k>00Oo]Jf]okfm_On]]KGoW9bLohb<S?nm_Jgoc/kN00;o[KFe0_n][JD0
1_o>c]ko_Kfmojf]YOnm_Kgoc/k>ojf]Y@;o[KFe0_n][JD01Oo>c/koknOW
olkFc_o>c/koinog00_ooooo00?oCTi>oi6ATOooool0ooooooooooooo`oo
oooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool0
;?ooool02?ogmnooinONomkNg_ooooooknOWojfe]On][JGoc/k>0_nm_Kd0
1?oNg]koc/k>ojf]YOoFe^L2ojf]Y@06olk>c_oNg]ko_KfmoibLW?o>c/ko
a[fm0_nm_Kd02_o>c/kog]kNojfUU?n]]KGoc/k>okfm_Oo>c/ko[JfUokFm
c_o>c/h2okfm_@06ojf]YOo>c/ko_Kfmojf]YOnm_KgoknOW0_o>c/h00oog
mnooooooooooo`09ooooo`03oeMGEonFUYKooooo0?ooooooooooool?oooo
o`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo02go
oooo00Coe]KWolkFc_ooooookoOg0oo_inL01_oNg]koooooooooooo_inOo
ooooonogm`;oknOW00KoooooooOgkoogmnooe]KWooO_iooWkoL2ooOgk`03
onO_moo_moOoknOW00;oknOW00KoinogonoWiooNg]koinogonoWioo>e]h3
onoWi`07omKFiooNg]kog]kNonOWg_o>c/koc]KNonoWi`3ooooooooooooo
7Oooool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWooooooooo
o`0/ooooo`07ooOgkooWimkoe/kFooooooo_inOoc/k>ojfe]@02oibLW00:
ojf]YOnm_Kgog]kNolk>c_nm_Kgog/k6olkFg_nm_Kgo]Kg>okfm_@;oc/k>
00oo_KfmokFmc_o>c/koc/JeolkFg_nm_Kgo[KFeolk>g_oNg/ko_Kfmojfe
]Onm_Kgo[KFeokfm_Oo>c/h00_nm_Kd01?o>c/ko[JfUokfm_Oo>c]h2olk>
c_oooooooooooolPooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWo
k^k^ooooo`0]ooooo`07omKFioo>e/koooooonoWionLW9co_Kfmojf]Y@02
okfm_@05ojfe]Oo>c/ko_Kfmokfm_Oo>e]h00_n]]KD01_n][JGo[KFeojf]
YOn]]KGo_Kfmojf]Y@;o_Kfm00Sog]kNoib]_On][JGoc/JeolkFg_n4U9Co
[JfUojfe]@;o[JfU00[oc/k>okfm_OnLW9co_Kfmohb<S?nLW9cog]kNolk>
c_oNc/Koinogoooooooooooooagooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h0
00?oi^KV00?oOZgIonKVi_ooool0;?ooool01_ogmnooinONolk>g_ogmnoo
knOWomkNgP;oinog00KoknOWonogmoo_inOoinogonoWioo_moL2onoWi`04
olk>g_o_inOomoO_olkFgP;og]kN2oo_inL01_oNg]koknOWomkNg_oNg]ko
c/k>omK>eP;oc/k>00Coc]KNolk>c_o>c/komnoWoooooooooooooagooooo
0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool0;Ooo
ool01?oFe^Ooc/k>oooooooFe^L5olk>cP04omkNg_o>c/koc/k>onONgPCo
c/k>00coc/kNolk>c_o>c/koQ9BDokfm_Oo>c/koc]KNolk>c_nm_Kgoc/k>
okfm_Oo>c]h2olk>cP07okfm_Oo>c/ko_Kfmolk>c_nm_Kgo]Jf]ojfe]@02
okfm_@04omk>a_nm_Kgoc/k>onogmooooooooooooolMooooo`;ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo02gooooo00Cog]kN
olk>c_ooooooc]KN0on][JD03OnLW:GoS8b<olk>c_nLW9co[JfUokG6e_nm
_KgoQ9BDojfUU?n][JGoc/k>ojfe]Oo>c/h00_n][JD01?nLW9co_Kfmolk>
c_n][JD2ohb<S00@olJm_OnLW9coS8b<oibLW?nLW:GoS8b<okfm_On<S8co
W9bLoiB<S?nLW9coS8b<okFmc_nm_Kgog]k>onoWiooooooooooooolOoooo
o`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^ooooo`0/ooooo`04
onogmoo_inOoc/k>onogm`?oknOW00Gog]kNonoWioo>c/koc]K>omkNgP05
onoWi`03onOWg_o_inOoknOW00;oknOW00Koe]KWomkNg_o>e/koknOWonOW
g_oFe^L3olk>cP08okfm[Oo>c]koc/k>omk>a_ne_Lko_Kfmolk>c_ne_Lh3
okfm_@03okfm[Oo>e]kooooo0?oooooooooooolMooooo`;ok^k^0Omn[MT1
onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo02cooooo00ComnoWomKF
iooNg/kooooo1?oNg]h01oo>c/kog]kNolk>g_oNg]kog]k>omkNg_o>e]h0
0_oNg]h00oo>c]kog]kNomkNgP02omkNgP0:olk>c_o_inOoc/kNomkNc_ne
_Lkog/k6ojf]YOnLW:Go]Kg>okF][@;o[JfU00?o[KFeojf]YOn][JD00_n]
[JD01_nLW:Go[JfUojfe]Onm_KgoknOWonogmooooooooooooolMooooo`;o
i^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo02gooooo
00CoknOWolk>c_o_moOoc/k>0_n][JD00onLW:GoW9bLohb<S002ojf]Y@0=
ohBDU?nLW:Go[JfUojf]YOnLW:Go[JfUoibLYOo>a[GoW9bUohb<S?nLW9co
c/k>ohb<S003oibLW004ojf]YOn<S8coNg]kog]kN`;oJf][00[oW9bLof][
Jom[Jf_oNg]kohb<S?mJFU[oW9bLojf]YOo>c]koknOWoooooooooooooako
oooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool0
;?ooool01_oWkoOoinONolk>c_ooooooc/k>olkFgP?og]kN00[o_KfmomkN
g_oNg]kog]kNokfm_OoNg]koc/k>olkFc_oNg]koinON0_o>c/h00onm_Kgo
c/k>omkNgP02omkNgP0<olk>c_o>e]koc/k>okfm_On][JGoW9bLohb<S?mk
Ng_oS8b<og]kNomkQ8CoNg]k0_n<S8`00onLW9co_KfmonoWi`3ooooooooo
oooo8Oooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_ooool0
;Oooool01?oWimkoc/k>onogmoo_inL4omkNgP;o_Kfm00SoinONomkNg_oN
g]kog]kNonOWg_oFe^Oog]kNomKFi`Kog]kN00Soc/kNomkNg_oNc/Koc/k>
okfm_OnLW9coS8b<of]cL`CoJf][00GoNg]kog^4Q?nLW9co_KfmomkNgP3o
oooooooooooo8?ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn
[MWoi^KVooooo`0/ooooo`0:ooOgkooFe^Ooc]K>onO_moo_inOoS8b<ojf]
YOo>c/koQ9BDokF][@GoW9bL00Goc/k>ojfUU?n][JGoS8b<oibLY@02ojf]
Y@03oibLW?n][JGoS8b<00;oW9bL00?oNhB4okfm_OmkNg/00om[Jf/00on<
S8coNg]kohb<S002ojf]Y@;oc/k>00?og]kNooooooooool0oooooooooooo
oaoooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_oo
ool0;Oooool01ooNg]koc/k>onogmoo_inOoc/k>olkFc_oWimh00_oNg]h0
2Oo>e]koc/k>olk>c_o>e]koc/k>omkNg_o>c/koc/kNomkNcP03olk>cP03
ojfe]Oo>c/koc/k>00;oc/k>00Goa[fmokFmc_n][JGoS8b<okfm_@04oooo
o`04onoWiooNg]koc/k>omkNg_oooooooooooolRooooo`;ok^k^0Omn[MT1
onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo02gooooo00Oog]kNolk>
c_o_inOoknOWomkNg_oFe^OoknOW00;og]kN00[oimkNonoWioo_inOoknOW
omkNg_o>c]koinONomkNg_oFe^OoknOW1_oNg]h3olk>cP03ojfe]OnDS8co
c/k>00?ooooo0_oNg]h00oo>c/kog]kNooooo`3ooooooooooooo9?ooool1
ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_ooool0;?ooool06?oW
koOoinONolk>c_o_moOoc/Jeolj<HooNc[goknOWomjm[Oo6Nd[oc/J]olkF
g_n][JGoQ9BDojfe]OnLW9coc/k>ojfe]On]YICoQ9BDojfe]OnLU8coc/k>
oibLY@CoW9bL00[o[JfUog^4Q?m[Jf_o_Kfmooooooo_moOoinONomkNg_o>
c/kog]kNooooooooooooobCooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?o
i^KV00?oOZgIonKVi_ooool0;Oooool06?o>e]koc/k>onogmoo_inOoaZfL
omkNc_o_inOoaZfLolj<Hoo_inOoe]KWokfm[Oo>c/ko[KFeolk>c_oNg]ko
c/JeokFmc_o6_Kgoc/JeokFmc_o>a[Go[JfUojfe]@;o_Kfm00[oW9bLojf]
YOn<S8coNhB4olk>c_ooooooknOWolkFg_o>c/kog]kNooooooooooooobGo
oooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool0
;?ooool03Oo_moOoknOWolk>c_o_inOoinONolkFc_o>YHCoc/JeolIkB_o>
_JGoknOWonOWg_o>e]h00_o_inL00ooWimkog]kNomkNgP04omkNgP03olk>
g_o>c/kog]kN00;og]kN00Woa[fmokFmc_n][JGoS8b<olk>g_o_inOog]kN
olk>c_oNg]h0ooooooooooooobKooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h0
00?ooooo00?oOZgIooooooooool0;Oooool02OoNg]koc/k>ooOgkooFe^Oo
knOWomJeW?o>a[GoaW]:olkFgP02onoWi`03onOWg_oFe^OoinON00Gog]kN
00Coc/kNomkNg_oNg/kog]kN1?o>c/h2ojf]Y@05ohb<S?oNc/Kog]kNolk>
c_oNg]h0ooooooooooooobWooooo0Omn[MT1ooooo`7ooooo0003onk^kP03
ogj]fOo^k^kooooo02cooooo00?oinogonOWg_o>c/h00oo_inL00oo>a[Go
cXaSoljLN`02onoWi`03onOWg_oNg]kog]kN00?og]kN00Soc]KNomkNg_oN
g]kog]kNomkNc_oFc]Koc/k>omkNgP;oc/k>0_nm_Kd2oibLW003olkFg_o>
c/kog]kN0?oooooooooooolXooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003
onKViP03ogj]fOoVi^Kooooo02gooooo00cog]kNolk>c_o_inOoknOWolkF
g_oWimko]G=Jolk6[Oo_inOoinONomKFiooWimh5omkNgP06omkNc_o>c]ko
g]k>olk>g_oNg/koc/kN0oo>c/h01_nm_Kgo[KFeoibLW?nm_Kgoc/k>omkN
g_oooooooooooolYooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03
ogj]fOo^k^kooooo02cooooo00GokoOgonoWioo>c/komoO_olkFgP02onoW
i`04olk6]OoWimkoinONomKFi`Gog]kN00Ooc/kNomkNg_o>e]kog]k>olk>
g_oNg/koc]KN00?oc/k>00Ko_Kfmojfe]On][JGo[KFeolk6]OoNg]kooooo
oooooooo:_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWo
ooooooooo`0]ooooo`0;onoWioo>e]koknOWonOWg_o>e]koknOWonOWg_oF
e^OoinONomkNg_oWimh00ooNg]h01ooNg/kog]kNomkNc_oFc]Kog]kNolk>
c_o>e]h00_o>c/h01oo>a[Go]Kg>okfm_Onm_Jgo[JfUojfe]OoFe^L0oooo
ooooooooobgooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^ko
oooo02gooooo013okoOgonoWioogmnooe]KWonoWiooWimkoe]KWonOWg_o>
e]koinONolkFg_oNg]koc]KNomkNg_o>e]kog]kN0_o>e]h00oo>e/koc]KN
olk>cP03olk>cP05okfm_On]]KGo[KFeolk>c_o_inL0ooooooooooooobco
oooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool0
;_ooool>onoWi`08omkNg_o_inOoknOWonoWiooNg]koknOWomkNg_o_inL2
omkNgP;oknOWooooooooooooobkooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H0
00?ok^k^00?oOZgIonk^k_ooool0ooooooooooooogKooooo0_o^k^h1ogj]
f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool0ooooooooooooogSo
oooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo0?oooooo
oooooomfooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoV
i^Kooooo0?oooooooooooomfooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo06;ooooo?Oo2`/;oooooomKooooo0_o^k^h1
ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool0H_oooolmol;2
`_oooooof?ooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_oo
ool0=?ooool00oo_moOoooooonogm`02ooooo`03onogmooooooooooo00;o
oooo00?okoOgooooooo_moL00_ooool00oo_moOoooooooooo`0Looooocgo
`/;2oooooooFooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]
fOoVi^Kooooo02kooooo00?oknOWooOgkoo_inL06oo_inL01?oFe^OoknOW
onoWiooFe^L6onoWi`03onogmooooooooooo00Wooooo?Oo2`/;oooooomKo
oooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool0
;Oooool03_ogmnoog]kNolk>g_nm_Kgo]Kg>olk6]One_Lkoc/JeokFmc_o>
a[Go_KfmokFmc_o>a[Go]Kg>0onm_Kd01oo>c/ko_KfmolJm_One_Lkoc/Je
olJm_One_Lh00_nm_Kd01Oo6_Kgo]Kg>okfm_Oo6_Kgo]Kg>00?o_Kfm00Wo
c/k>okfm_Onm_Kgoa[fmokFmc_nm_Kgoc/k>olkFg_o_inL02_oooolmol;2
`_ooooooe_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWo
ooooooooo`0]ooooo`05omkNg_o>c/ko[JfUojf]YOnLW:D04OnLW9`00onL
W:Go[JFDoibLY@02oibLW007ojfUU?nLW:GoW9bLoibLW?n][JGoW9bLoibL
Y@02oibLW003ojf]YOnLW9coW9bL00;o[JfU00?oc/k>omkNg_o_moL02Ooo
oolmol;2`_oooooof?ooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgI
onk^k_ooool0;Oooool00oo_inOog]kNooooo`0Vooooo`;og]kN00?oknOW
ooooooooool01ooooolmol;2`_ooooooe_ooool2onk^kP7oOZgI0Oo^k^h1
onk^kP000ooVi^H00omn[MWoi^KVooooo`0]ooooo`03omkNg_o>e/kooooo
01?ooooo00?omoO_ooooooooool00_ooool01OoWkoOooooooooooooooooo
knOW00;ooooo00?oknOWoooooooWkoL00_ooool01?o_moOoooooonOWg_o>
c/h:ooooocgo`/;2oooooooFooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo02cooooo00?oinogonOWg_o>e]h00_ooool0
0oo_moOoooooooooo`0;ooooo`03onogmooooooooooo00?ooooo00?oinog
ooooooooool02_ooool01oo_inOooooooooooooooooog]kNolkFg_o_inL0
2Ooooolmol;2`_ooooooe_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooo
ool00omn[MWoooooooooo`0]ooooo`03omkNg_oNc/Kooooo017ooooo00?o
koOgooooooooool00_ooool00oogknOoooooooooo`02ooooo`04onO_mooo
ooooooooonO_m`Gooooo00GoknOWooooooo_inOoc/k>onogm`09ooooocgo
`/;2oooooooHooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^
ooooo`0/ooooo`03ooOgkooWg]koc]KN00kooooo00?okoOgooooooooool0
1?ooool00oogmnooooooooooo`0:ooooo`03onogmoooooooinog00;ooooo
00?og]kNolkFc_o_inL02Ooooolmol;2`_ooooooe_ooool2onk^kP7oOZgI
0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`0]ooooo`03omkNg_o>
c/kooooo00?ooooo00[oknOWolk>c_o_inOokoOgoooooooWkoOoooooonoW
ioo>c/koknOW0_ooool00oo_moOoooooomkNgP05omkNgP06omK>e_n4Ng?o
W6]SojekHoo>_JGoU8b<0_n]Nf<02_nm_Kgoc/JeomkNc_o>a[Go_Kf]onO_
mooooooog]kNolk>c_o_moL9ooooocgo`/;2oooooooFooooo`;oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo02gooooo00Coe]KW
omkNc_ooooooknOW0_nm_Kd01Oo>c/koW9bLojfe]Oo>c/kokoOg00;o[JfU
0_nLW9`07On<S8co_Kfmojf]YOo_inOoooooonOWg_o_inOomoO_onoWioog
knOoinONomk>a_mBBT;oNa08oh@H4?n]Nf?oU48aog<H4?nL<B7ocZF4omkN
c_o_ilkog]k>olk6]Oo_inOoooooomkNg_o>e]koknOW00Wooooo?Oo2`/;o
ooooomKooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIoooo
ooooool0;?ooool00oogmnooinONolkFgP02ooooo`03omK>e_oNg]koknOW
00;og]kN00OoknOWoooooooFe^OoknOWolkFc_oNg]ko_Kfm00;og]kN0_oo
ool06?o>c/koQ9BDoibLYOnLW9coNhB4of]cLomJJf_oBQPHog<H4?nL<B7o
Q3Taof<H6?n48ASoYG=JojekHonLW:GoW8AkoiB<Hon]]KGomoO_ooooooo_
inOoc/k>onogm`Wooooo?Oo2`/;oooooomSooooo0Omn[MT1ooooo`7ooooo
0003onk^kP03ogj]fOo^k^kooooo02gooooo00?oe]KWomK>e_ooool01ooo
ool00oo_moOoooooooooo`02ooooo`03onO_mooooooooooo00;ooooo00ko
g/k6ohb<S?n<S8coJf][ohb<S?n]YICoJf][oe882?m[<BWoW34QojekHon4
613oQ24Hof/a:@;oBU9J00SoFUYJoe9:@_m[Lg?oknOWoooooooNg]koc]KN
onoWi`Wooooo?Oo2`/;oooooomKooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h0
00?oi^KV00?oOZgIonKVi_ooool0;Oooool01OoNg]koc]K>ooooooogknOo
[KFe00;o_Kfm00Oo]Kg>okfm[Oo_inOoc/k>ojf]YOo_inOo[KFe00;o_Kfm
01?og]kNokFmc_o>a[GoooooolkFg_nm_Kgo[JfUoibDS?n]YICoc/Jeog]c
HolH413oDPP8ojekHon<Jd[oQ24Hog/a:OmB>C7o:BTY00?o>CTa00KoFUY2
onoWioooooooinONolk>c_o_moL9ooooocgo`/;2oooooooFooooo`;oi^KV
0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo02cooooo02go
koOgonOWg_o>c/koooooonogmonm_Kgo[JfUolk>g_o>a[Goc/k>onoWioo>
c/ko_KfmonoWion][JGo_Kfmolk>c_oNg]koc/k>ojfe]Ooooooog]k>okfm
[On][JGoW9bLojfLQ?o>_JGoLf]Sob4H4?mBBT;oHd8iodXa:OmB>C7oDSTY
og]kNomkQ8CoFUYJodYB>Om:BS7oBU8ionoWioooooooe]KWolkFc_o_inL0
2Ooooolmol;2`_ooooooe_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooo
ool00omn[MWoooooooooo`0]ooooo`08omkNg_o>e]koooooooooooo_moOo
ooooonoWiooWkoL5ooooo`03onogmooooooooooo00;ooooo00WoknOWoooo
ooo>c]ko_Kf]okfm_OnDS8coLg=JojfLQ?mcJf<00_mB>C403om2:B7oDSTa
oeY2>OmB>C7oS8acohb<S?mkNg_oJf=Bof][B_mJHe[oknOWoooooooWimko
c/kNooOgk`09ooooocgo`/;2oooooooHooooo`7oOZgI0Oooool1ooooo`00
0oo^k^h00omn[MWok^k^ooooo`0/ooooo`;oknOW00?oe/kFooooooo_inL0
0_o>c/h02OnLW:Go[JFDokFmc_o>a[Gog]kNolkFg_o>c/kog]kNolkFgP02
olk>cP0<olJm_Oo>e]koooooolk6]On<S8coS8acoeYJ@_n<S8coc/Jeog=[
HomBBT;o<AP@0_mB>C401?mcFU;oDSTaoeYJ@_mkLf<2of][BP07oeYJ@_m[
Jd[oknOWonogmoo_inOoc]K>onoWi`09ooooocgo`/;2oooooooFooooo`;o
k^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo02gooooo
00Kog]kNolkFc_ooooooooooojf]YOn]]KD4okfm_@06omkNg_nm_Kgoc/Je
olkFg_o>a[Go[KFe0_nm_Kd04On][JGoooooojfe]Om:BT[oDTY2of]SD_n<
S7?oW8AkoeYJF_mB>BWo@RTQof]:@_mJFT;oLeYBof=JB_lY:ASo>CTH00;o
FU8Y00Ko>CTHog]SB_o_inOoooooomkNg_o>c/h:ooooocgo`/;2oooooooF
ooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo
02cooooo00KokoOgonOWg_o>c/koooooonogmoo_inL9ooooo`0NonoWiooW
imkoooooonogmoo_inOoooooojf]YOlY<BWo:BTHodY::On]YICoa[fmocTi
<Om2:B7oDSTaoe9:@_mkFT[oJf=BoeY2>OlY:ASoBS4YodY::OmcLe[oBS4Y
oe9S@_oFe^OoooooonOWg_o>e]koknOW2Ooooolmol;2`_ooooooe_ooool2
onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`0]oooo
o`0:omkNg_o>e]koooooonoWioo>e]kog]kNolk>c_oNg]koc/k>onoWi`;o
c]KN023oknOWomkNg_o>e]koc/k>omK>e_o_inOoc]KNonogmon]YICo0000
obTY6?li8ASoW9B<olk6[OmkLf?o:BTHod8Y8On]Nf?oU6]Jof/a:Oli>ASo
:BTHoc4i8Om:BRWoBTXaocTi6?m:BS7oknOWonogmoo_inOoc/k>onogm`Wo
oooo?Oo2`/;oooooomSooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]
fOo^k^kooooo02cooooo02gokoOgonoWioo>c/koooooomkNg_nm_Kgo[JfU
ojfe]On][JGoW9bLokG6e_n][JGo_Kf]olkFg_o>c/koW9bUojf]YOnm_Kgo
c]K>okfm_Oo_inOo[JfUoa000?lY:ASo<CTQokfm[OoNc[goS8acobTY6?mc
FU;o[G]SolJ]W?n4Ng?o<CTQoaP@4?li>ASoBU8iodYJ@_lY:BWo>D8aonoW
ioooooooe]KWolkFc_o_inL02Ooooolmol;2`_ooooooe_ooool2onk^kP7o
OZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`0/ooooo`;oknOW
00?oc]K>ooooooooool00oo_moL01?ogmnooc]KNonOWg_o_inL6onogm`?o
oooo01So[JfUobTY6?lY:ASo:BTHohb<Loo>_JGoBUY2obTY6?li8ASoNf=:
oha[B_mJFT;o>D8aobTa:OlY8@SoBU8iohBDU?mkQ8CoFV=JonoWioo_moOo
inONolk>g_ogmnl9ooooocgo`/;2oooooooFooooo`;oi^KV0Omn[MT1onKV
iP7oi^KV0003onk^kP03ogj]fOo^k^kooooo02gooooo00?og]kNolk>g_oo
ool01?o_inL01?oFe^OoknOWonOWg_oFe^L6onoWi`05omKFioogknOooooo
ojf]YOla>B400_m:FT802OnDS6?o_Kf]ojfe]Om[Lg?o4108ocTQ6?la613o
610@oeY[J`02oeYSFP09of=cS?n]]KGoW;GNojFec_o_inOokoOgomkNg_o>
e/koknOW00Wooooo?Oo2`/;oooooomKooooo0_o^k^h1ogj]f@7ok^k^0Oo^
k^h000?ooooo00?oOZgIooooooooool0;Oooool01_oNg]kog]k>ooooooo>
e]ko_KfmokF][@;o[JfU01GoS8b<okFmc_nm_JgoW9bUojf]YOn]]KGo_Kfm
ojf]YOn]]KGo[JfUonO_moooooooc/k>of=cS?mkQ8CoJf=Bog]kNonm_Jgo
[JFDohb<S?lY:BT00_l000003Om:DU[oW;GNojFec_nL]MkoYKgNoibeione
a]KoW;GNonoWioogmnoog]kNolk>c_o_moL02Ooooolmol;2`_oooooof?oo
ool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_ooool0;Oooool0
1OoNg]koc]KNooooooo_inOog]kN00;okoOg00?oknOWolk>c_o_moL00_o_
inL00oo>c/koknOWolkFgP02onoWi`04onO_moogknOomoO_omKFi`;oW:fm
00KoW9bUojf]YOnm_Kgo]Kg>okG6e_nU]Lh2of=cS0KoW;GN00OoW;GWojFe
c_o_inOoooooomkNg_o>e]koknOW00Wooooo1oo2`/800oo0`<3oPh>3oijN
WP0col;2`_ooooooe_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H0
0omn[MWoi^KVooooo`0/ooooo`;oknOW00Goc]K>ooooooo_inOoknOWonog
m`02onoWi`03ojfe]Oo_inOokoOg00GoknOW00GoinogooO_iooWkoOooooo
olkFgP02ojfmi`03ojg6monL[Kgoc/J]00?oW;GW00Go[LK_oibeionL]Mko
W;GNoibei`05oibegP05olkFg_o_moOog]kNolk>c_o_moL02Oooool4ol;2
`P06okFe]OnPX:3oM7Adob<S8oli>CWoQhN70_o2`/800onh^;So`/;2ol;2
`P07ol;2`P03ol30`?nb/[;o`/;201go`/;200?o`L71ok6a/Oo1`L401?o2
`/;oooooomKooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgI
onk^k_ooool0;Oooool02?oWimkoc/kNooooooo>e]koW9bLolk6]One_Lko
[KFe0_n][JD00onLW:Go[JfUoibLW002olk>cP0@ojfe]On][JGoS8b<olk>
c_oooooo]LKFoib]g_nL]MkoW:gNoib]_On][JGoW:gNoib]c_nL]MkoW:gN
oib]cP;oW:gN00KoW:g>oib]g_nL[MkoW:g>oib]g_nL[Lh2onoWi`03omkN
g_o>e/koknOW00Wooooo0_o2`/801_n`/;3o=CDeob<S8olh>3So30`<og]k
N`?o`/;200GoHF5Qoa<C4olO7aooIFEUobd];@02ol;2`P0Co`X:2_n[Zj_o
`/;2ohB4Q?l<30co8B4QoaXJ6_n`/;3o`/;2o`X:2_n[Zj_o`/;2odi>C_lc
<c?o_Kfmol;2`_nb/[;o0000okVi^@03ol;2`P08o`X:2_n[Zj_o`/;2o`X:
2_n[Zj_o`/;2og]kNolj>SX2ol;2`P08obTY:On<S8co`/;2ohJ6Q_lA4A7o
:b/[obLW9on<S8`3ol;2`_ooooooe_ooool2onk^kP7oOZgI0Oo^k^h1onk^
kP000oooool00omn[MWoooooooooo`0/ooooo`08onogmooNg]kog]k>oooo
ooo_inOoc]KNonoWioogmnl3onoWi`05olkFg_o_inOoinONomKFioo_inL0
0ooNg]h01Oo_inOokoOgonoWioo>e]kog]kN00;oc]KN00Cog/k6omKFiooN
g]koe]KW0_o>e]h00ooNg]koc]KNolkFgP04olkFgP05okG6e_o_inOomoO_
olkFg_o>c/h02_ooool2ol;2`P07oc4a<OmEEEGo`/;2ol;2`_n][Jgo5QHF
ohR8R002ol;2`P03o``<3?nTY:Co^;Rh00;o;Bd]0_o2`/801_l:2P[oZj^[
ol71`OlF5QKoP820ol;2`P;o`<3000Ko`/;2o`X:2_n[Zj_oGUiNobPX:?nh
^;P2ol;2`P03ok:b/_l0003o^KVi00?o`/;200So2PX:oj^[Zoo2`/;o2PX:
oj^[Zoo2`/;oNg]kocXj>P;o`/;200Go:BTYohb<S?n^[Zko20P8oiNGU`06
ol;2`_oooooof?ooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^
k_ooool0;Oooool2omkNgP0>ooooooo_inOooooooooooooFe^Ooc/k>onoW
ioogmnooooooooOgkooWkoOoknOWokfm_OoNg]h2ooooo`0:onO_moo_inOo
koOgooooooo_inOoooooooO_ioooooooinogonogm`;oknOW00CoooooonoW
iooWkoOomoO_0_o_inL00ooNg]koknOWonogm`02onoWi`03omkNg_o>e/ko
knOW00Wooooo00Co`/;2oiZJV_l0003oXj>S0oo2`/802Om<C4co?clool;2
`_o1`L7o0000okRh^?o2`/;oR8R8obd];@02ol;2`P05o`X:2_n[Zj_oTY:B
oa0@4?o0`<001?o2`/801?l:2P[oEeMGoadM7Onb/[83ol;2`P03ok:b/_l0
003o^KVi00?o`/;200So2PX:oj^[Zoo2`/;o2PX:oj^[Zoo2`/;oNg]kocXj
>P;o`/;200Co:BTYohb<S?n2PX;o6ATI0onATI401?na/K7o`/;2ol;2`_o2
`/;oooooomKooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgI
onKVi_ooool0;?ooool2onoWi`0@olkFg_ooooookoOgojf]YOnm_Kgoc/k>
ohb<S?n][JGo]Kg>onoWionLW9co[JfUohb<S?n4U9CoU8b<ojfe]@;o[JfU
00Woc/k>onoWiooWkoOog]kNoibLYOo>c/ko[KFeojf]YOnLW9`00_o>c/h0
2?nLW9cog]kNojfUU?o>c]ko[JfUoibLYOn4U9Coc]K>0_o_inL01?o_moOo
c/kNolk>c_o_moL9ooooo`03ol;2`_mjNW[o5QHF00Co`/;200WoP820oa@D
5?o2`/;o`L71o`000?nh^;So`/;2ohR8R?l];Bd00_o2`/801Ol:2P[oZj^[
oiRHV?l:2P[o_[jn00Co`/;200Co2PX:oeADE?li>CWo`<300oo2`/800onb
/[;o0000okVi^@03ol;2`P08o`X:2_n[Zj_o`/;2o`X:2_n[Zj_o`/;2og]k
Noli>CT2ol;2`P04obTY:On<S8coUiNGoa4A4@;oF5QH00?o51@Doi:BT_o2
`/800_o2`/;oooooomKooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^
00?oOZgIonk^k_ooool0;Oooool01OoNg]koc]K>ooooooo_inOoc/k>00?o
g]kN00[oc]KNonoWioo_inOog]kNolkFg_o>c/koe/kFojfe]OoNg/koc]KN
0_o>c/h01oooooooknOWojfe]On<S8co_Kfmojf]YOoNg]h00_o>c/h02OoN
g]koc/k>omkNg_o>c/kog]kNomK>e_o>e/koc/k>omKFi`03onoWi`03omkN
c_o>e]koknOW00Wooooo00?o`/;2og]kNolC4a<01?o2`/802OmoOgoo410@
ol;2`_o1`L7o0000okRh^?o2`/;oR8R8obd];@02ol;2`P0;o`X:2_n[Zj_o
`/;2oaTI6Om/K6co_[jnokbl_?o1`L7o`/;2o`X:2_n[Zj/00_mBDU83ol;2
`P03ok:b/_l0003o^KVi00?o`/;201;o2PX:oj^[Zoo2`/;o2PX:od92@_ne
]KGoGemOo`h>3_mmOGgo^[Zjoa<C4onOWioo`L71oaTI6OnZZZ[o]KFeoaHF
5_nn_[h3ol;2`_ooooooe_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooo
ool00omn[MWoooooooooo`0]ooooo`04onOWg_o>e]koooooonogm`?ooooo
00GoknOWoooooooWkoOoooooooO_i`03ooooo`08onoWioo_moOoknOWoooo
ooo_inOoooooomkNg_o>c/h2omkNgP0:onoWioooooooinogooooooo_inOo
inogooO_iooWkoOoknOWonO_m`CoknOW00Goe]KWonoWioo>e]kog/k6onog
m`09ooooo`04ol;2`_nLW9co0000oj6QX@?o`/;200WoBDU9oc4a<Oo2`/;o
`L71oalO7oni^KWo`/;2oi:BT_m6ATH00_o2`/801OlY:BWo[jn_ol;2`_nN
WYkoD51@00;o8B4Q00Oo^k^kol;2`_l:2P[oZj^[ol30`?m6ATKoQhN700;o
`/;200?o/[:bo`000?ni^KT00oo2`/802olY:BWo[jn_ol;2`_lY:BWoQhN7
ob/[:olO7aooVYZJoeeMGOlI6AWoBDU900;o`/;200CoSXj>obDU9Ol_;boo
QHF51?o2`/;oooooomSooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]
fOo^k^kooooo02gooooo00Goe]KWolk>c_ooooooknOWojf]Y@02ojfe]@09
okfm_On]]KGog]kNokfm_On]]KGoinONojf]YOne_Lko[JfU00;oc/k>00Oo
]Jf]okfm_On]]KGoW9bLohb<S?nm_Jgoc/kN00;o[KFe0_n][JD01_o>c]ko
_Kfmojf]YOnm_Kgoc/k>ojf]Y@;o[KFe0_n][JD01Oo>c/koknOWolkFc_o>
c/koinog00Wooooo0_o2`/801olf=SKoCdm?ol71`Oo2`/;oZ:RXoa0@4?n=
SHd02Oo2`/800on^[Zko_knool;2`P06ol;2`P03o`X:2_n[Zj_o`/;200Co
`/;200?o/[:bo`000?ni^KT00oo2`/800on^[Zko_knool;2`P0Bol;2`_oo
ooooe_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KV
ooooo`0/ooooo`08ooOgkooWimkog]kNooooooo_inOo[KFeojf]YOo>c/h2
okfm_@04omkNg_o>c/ko[JfUomKFi`;o[JfU00Koc/k>omkNg_nm_KgoW9bL
olk>c_o6_Kd2okfm_@0:olk>c_oNg]ko[JFDojfe]Oo>c/ko_Kfmolk>c_n]
[JGo]Kg>olk>cP;o_Kfm00Ko[JfUolk>c_nm_Kgo[JfUokfm_Oo_inL2olk>
cP03ooOgkooooooooooo00Oooooo0_o2`/801_nd];Co@410oadM7Ol_;boo
6ATIogalO0[o`/;200?o51@Dojb/[?o2`/801_o2`/800ol:2P[oZj^[ol;2
`P02ol;2`P0:obd];OlN7Qko71`Lo`T92OlL71co7QhNoc@d=?o2`/;o51@D
ojb/[1?o`/;2oooooooFooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^
kP03ogj]fOo^k^kooooo02gooooo00Coe]KWolkFc_ooooookoOg0oo_inL0
1_oNg]koooooooooooo_inOoooooonogm`;oknOW00KoooooooOgkoogmnoo
e]KWooO_iooWkoL2ooOgk`03onO_moo_moOoknOW00;oknOW00KoinogonoW
iooNg]koinogonoWioo>e]h3onoWi`07omKFiooNg]kog]kNonOWg_o>c/ko
c]KNonoWi`09ooooo`Co`/;200?o_Kfmok2`/?o2`/805?o2`/800omZJV[o
]kNgol;2`P0Ool;2`_ooooooe_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP00
0oooool00omn[MWoooooooooo`0/ooooo`07ooOgkooWimkoe/kFooooooo_
inOoc/k>ojfe]@02oibLW00:ojf]YOnm_Kgog]kNolk>c_nm_Kgog/k6olkF
g_nm_Kgo]Kg>okfm_@;oc/k>00oo_KfmokFmc_o>c/koc/JeolkFg_nm_Kgo
[KFeolk>g_oNg/ko_Kfmojfe]Onm_Kgo[KFeokfm_Oo>c/h00_nm_Kd01?o>
c/ko[JfUokfm_Oo>c]h2olk>cP[ooooo?Oo2`/;oooooomSooooo0Omn[MT1
ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo02gooooo00Ooe]KWolkF
c_ooooooknOWoibLW?nm_Kgo[JfU00;o_Kfm00Go[KFeolk>c_nm_Kgo_Kfm
olkFgP02ojfe]@06ojf]YOn]]KGo[JfUojfe]Onm_Kgo[JfU0_nm_Kd02?oN
g]koW:fmojf]YOo>a[Goc]KNohBDU?n][JGo[KFe0_n][JD02_o>c/ko_Kfm
oibLW?nm_KgoS8b<oibLW?oNg]koc/k>omk>a_oWkoL9ooooocgo`/;2oooo
oooFooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Ko
oooo02cooooo00KomoO_onOWg_o>c]komoO_onoWiooNg]h2onO_m`06onoW
ioo_moOoknOWonO_moo_inOokoOg0_o_inL01?o>c]koknOWooOgkoo>e]h2
omkNgP_oknOW00Kog]kNonoWiooNg]kog]kNolk>c_oFc]H2olk>cP04olkF
g_o>c/koc/k>ooO_i`Wooooo?Oo2`/;oooooomKooooo0_oVi^H1ogj]f@7o
i^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool0;Oooool01?oFe^Ooc/k>
oooooooFe^L5olk>cP04omkNg_o>c/koc/k>onONgPCoc/k>00coc/kNolk>
c_o>c/koQ9BDokfm_Oo>c/koc]KNolk>c_nm_Kgoc/k>okfm_Oo>c]h2olk>
cP07okfm_Oo>c/ko_Kfmolk>c_nm_Kgo]Jf]ojfe]@02okfm_@04omk>a_nm
_Kgoc/k>onogm`Wooooo?Oo2`/;oooooomKooooo0_o^k^h1ogj]f@7ok^k^
0Oo^k^h000?ooooo00?oOZgIooooooooool0;Oooool01?oNg]koc/k>oooo
ooo>e]h3ojf]Y@0=oibLYOn<S8coc/k>oibLW?n][JGo]LKFokfm_On4U9Co
[JFDojf]YOo>c/ko[KFeolk>cP02ojf]Y@04oibLW?nm_Kgoc/k>ojf]Y@;o
S8b<013oa[fmoibLW?n<S8coW9bLoibLYOn<S8co_Kfmohb<S?nLW9coU8b<
oibLW?n<S8co]Kg>okfm_OoNg/koknOW2Ooooolmol;2`_oooooof?ooool1
ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_ooool0;?ooool01?o_
moOoknOWolk>c_o_moL3onoWi`05omkNg_o_inOoc/k>olkFc_oNg]h01Oo_
inL00ooWimkoknOWonoWi`02onoWi`06omKFiooNg]koc]K>onoWiooWimko
e]KW0oo>c/h02?nm_Jgoc/kNolk>c_oNc/Ko]Kg>okfm_Oo>c/ko]Kg>0onm
_Kd00onm_Jgoc]KNooooo`09ooooocgo`/;2oooooooFooooo`;ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo02cooooo00ComnoW
omKFiooNg/kooooo1?oNg]h01oo>c/kog]kNolk>g_oNg]kog]k>omkNg_o>
e]h00_oNg]h00oo>c]kog]kNomkNgP02omkNgP0:olk>c_o_inOoc/kNomkN
c_ne_Lkog/k6ojf]YOnLW:Go]Kg>okF][@;o[JfU00?o[KFeojf]YOn][JD0
0_n][JD01_nLW:Go[JfUojfe]Onm_KgoknOWonogm`Wooooo?Oo2`/;ooooo
omKooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_oo
ool0;Oooool01?o_inOoc/k>onogmoo>c/h2ojf]Y@03oibLYOnLW9coS8b<
00;o[JfU00goQ9BDoibLYOn][JGo[JfUoibLYOn][JGoW9bUolk6]OnLW:Go
S8b<oibLW?o>c/koS8b<00?oW9bL00Co[JfUohb<S?mkNg_oNg]k0_m[Jf/0
2_nLW9coJf][of][JomkNg_oS8b<oeYJF_nLW9co[JfUolk>g_o_inL:oooo
ocgo`/;2oooooooFooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03
ogj]fOoooooooooo02cooooo00KoinogonOWg_o>c/koooooolk>c_o>e]h3
omkNgP0:okfm_OoNg]kog]kNomkNg_nm_Kgog]kNolk>c_o>e/kog]kNonOW
gP;oc/k>00?o_Kfmolk>c_oNg]h00_oNg]h03?o>c/koc]KNolk>c_nm_Kgo
[JfUoibLW?n<S8coNg]kohb<S?mkNg_oNhB4og]kN`;oS8b<00?oW9bLokfm
_Oo_inL02ooooolmol;2`_oooooof?ooool1ogj]f@7ooooo0Oooool000?o
k^k^00?oOZgIonk^k_ooool0;Oooool01?oWimkoc/k>onogmoo_inL4omkN
gP;o_Kfm00SoinONomkNg_oNg]kog]kNonOWg_oFe^Oog]kNomKFi`Kog]kN
00Soc/kNomkNg_oNc/Koc/k>okfm_OnLW9coS8b<of]cL`CoJf][00GoNg]k
og^4Q?nLW9co_KfmomkNgP0<ooooocgo`/;2oooooooFooooo`;ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo02cooooo00[omoO_
omKFioo>e/koinogonoWion<S8co[JfUolk>c_n4U9Co]Jf]1OnLW9`01Oo>
c/ko[JFDojf]YOn<S8coW9bU00;o[JfU00?oW9bLojf]YOn<S8`00_nLW9`0
0omkQ8Co_Kfmog]kN`03of][J`03ohb<S?mkNg_oS8b<00;o[JfU0_o>c/h0
0ooNg]koooooooooo`0;ooooocgo`/;2oooooooFooooo`;oi^KV0Omn[MT1
onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo02gooooo00Oog]kNolk>
c_o_moOoknOWolk>c_o>e/koinON00;og]kN00Woc]KNolk>c_o>c/koc]KN
olk>c_oNg]koc/k>olk>g_oNg/h00oo>c/h00on]]KGoc/k>olk>cP02olk>
cP05olJm_One_Lko[JfUohb<S?nm_Kd01?ooool01?o_inOog]kNolk>c_oN
g]h>ooooocgo`/;2oooooooFooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003
ooooo`03ogj]fOoooooooooo02gooooo00Oog]kNolk>c_o_inOoknOWomkN
g_oFe^OoknOW00;og]kN00[oimkNonoWioo_inOoknOWomkNg_o>c]koinON
omkNg_oFe^OoknOW1_oNg]h3olk>cP03ojfe]OnDS8coc/k>00?ooooo0_oN
g]h00oo>c/kog]kNooooo`0>ooooocgo`/;2oooooooHooooo`7oOZgI0Ooo
ool1ooooo`000oo^k^h00omn[MWok^k^ooooo`0/ooooo`0HonO_mooWimko
c/k>onogmoo>a[GocXaSomk>_Oo_inOog[f]olIkB_o>aZgoc]KNojf]YOn4
U9Co[KFeoibLW?o>c/ko[KFeojfUU?n4U9Co[KFeoibDS?o>c/koW9bU1?nL
W9`02_n][JGoNhB4of][Jonm_KgoooooonogmooWimkog]kNolk>c_oNg]h@
ooooocgo`/;2oooooooFooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKV
iP03ogj]fOoVi^Kooooo02gooooo01Soc]KNolk>c_o_moOoknOWolJ]W?oN
g/koknOWolJ]W?o>S6?oknOWomKFionm_Jgoc/k>ojfe]Oo>c/kog]kNolk6
]One_Lkoa[fmolk6]One_Lkoc/Jeojf]YOn]]KD2okfm_@0:oibLW?n][JGo
S8b<og^4Q?o>c/koooooonoWioo>e]koc/k>omkNgQ7ooooo?Oo2`/;ooooo
omKooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_oo
ool0;?ooool03Oo_moOoknOWolk>c_o_inOoinONolkFc_o>YHCoc/JeolIk
B_o>_JGoknOWonOWg_o>e]h00_o_inL00ooWimkog]kNomkNgP04omkNgP03
olk>g_o>c/kog]kN00;og]kN00Woa[fmokFmc_n][JGoS8b<olk>g_o_inOo
g]kNolk>c_oNg]h04_oooolmol;2`_ooooooe_ooool2onk^kP7oOZgI0Oo^
k^h1onk^kP000oooool00omn[MWoooooooooo`0]ooooo`09omkNg_o>c/ko
moO_omKFioo_inOoe[FLolk6]Oo6Nd[oc]KN00;oknOW00?oinONomKFiooW
imh01OoNg]h01?o>c]kog]kNomkNc_oNg]h4olk>cP;o[JfU00GoS8b<omk>
a_oNg]koc/k>omkNgP0Cooooocgo`/;2oooooooHooooo`7oOZgI0Oooool1
ooooo`000oo^k^h00omn[MWok^k^ooooo`0/ooooo`03onO_mooWimkoc/k>
00?oknOW00?oc/Jeolj<Hoo>W7/00_o_inL00ooWimkog]kNomkNgP03omkN
gP08olkFg_oNg]kog]kNomkNg_oNg/koe/kFolk>c_oNg]h2olk>cP;o_Kfm
0_nLW9`00oo>e]koc/k>omkNgP0Dooooocgo`/;2oooooooFooooo`;ok^k^
0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo02gooooo00co
g]kNolk>c_o_inOoknOWolkFg_oWimko]G=Jolk6[Oo_inOoinONomKFiooW
imh5omkNgP06omkNc_o>c]kog]k>olk>g_oNg/koc/kN0oo>c/h01_nm_Kgo
[KFeoibLW?nm_Kgoc/k>omkNgQGooooo?Oo2`/;oooooomKooooo0_oVi^H1
ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool0;?ooool01Oo_
moOoknOWolk>c_ogmnooc]KN00;oknOW00Coc/JeonOWg_oWimkoe]KW1OoN
g]h01oo>c]kog]kNolkFg_oNg/koc/kNomkNc_o>e]h00oo>c/h01_nm_Kgo
[KFeojf]YOn]]KGoc/JeomkNgQKooooo?Oo2`/;oooooomKooooo0_o^k^h1
ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool0;Oooool02oo_
inOoc]KNonoWiooWimkoc]KNonoWiooWimkoe]KWonOWg_oNg]koinON00?o
g]kN00Oog]k>omkNg_oNg/koe/kFomkNg_o>c/koc]KN00;oc/k>00Ooc/Je
okFmc_nm_Kgo_Kf]ojf]YOn]]KGoe]KW01Oooooo?Oo2`/;oooooomSooooo
0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo02gooooo013o
koOgonoWioogmnooe]KWonoWiooWimkoe]KWonOWg_o>e]koinONolkFg_oN
g]koc]KNomkNg_o>e]kog]kN0_o>e]h00oo>e/koc]KNolk>cP03olk>cP05
okfm_On]]KGo[KFeolk>c_o_inL06?oooolmol;2`_ooooooe_ooool2onk^
kP7oOZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`0^ooooo`ko
knOW00Sog]kNonoWioo_inOoknOWomkNg_o_inOog]kNonoWi`;og]kN0_o_
inLJooooocgo`/;2oooooooFooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003
onk^kP03ogj]fOo^k^kooooo06;ooooo?Oo2`/;oooooomKooooo0_o^k^h1
ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool0H_oooolmol;2
`_oooooof?ooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_oo
ool0H_oooolmol;2`_ooooooe_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP00
0ooVi^H00omn[MWoi^KVooooo`1Rooooocgo`/;2oooooooFooooo`;oi^KV
0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oooooooooo
oomfooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooo
oooo0?oooooooooooomhooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn
[MWok^k^ooooo`0Fooooo`07ono_kon][JgoFV]SoibLW?oWa/KoinOWooOg
m`04ooooo`03onooooogmoOooooo0?oooooooooooomBooooo`;ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo01Gooooo00_og]kW
oiB<S?l@613oBTY:obTQ8On]Lg_oNg]koiB<S?n][Jgoe[g6ono_k`3ooooo
ooooooooE_ooool2onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWo
k^k^ooooo`0Dooooo`0AonO_konm_Kgo:C4Yokg6_Ooooooo>APQolj4S?o>
Lg_oaV]coje[JonLHf_oS6]coib<S?nm]KGoe]KFono_koogmoL0oooooooo
oooooe7ooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIoooo
ooooool04oooool01?ogmoOoe/kFoibDW?la>CT2ooooo`0?og]BF_o>NhCo
og^DonmcS?oWNhCocW=koke[LonUHf_oYF=SoiA[Lon4Q8CoW9bLokfm_OoN
g]komno_0?oooooooooooom@ooooo`7oOZgI0Oooool1ooooo`000oo^k^h0
0omn[MWok^k^ooooo`0Cooooo`04onOWioo6c/koS9B<oeYJFP;ooooo00Co
LeYSolikU?ooS:goohbU0_ooQ9`2ooMkS00;onmSNooWFW?oaV]coje[JonU
Hf?oU6]coiB4Q?nU[JGoa/k>omk_koogmoL00_ooool00oo_oooooooooooo
o`04ooooo`03onoooooooooooooo0?oooooooooooolnooooo`;ok^k^0Omn
[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo01?ooooo00ComnOW
omKFg_nU[JGoJg=[0_ooool05om[Lf_ogXb]oonUc_ooYLkomiBmoonD]Oog
U:goohbUonn<W?ooQ9cokhBDomikS?oFLhCocW=koke[Lon]Jf_oYF=SojE[
JonLQ8co]IbLolk6c_oWinOooooo00?okooo2oooool00oo_oooomoOgoooo
o`3ooooooooooooo=Oooool2onKViP7oOZgI0OoVi^H1onKViP000oo^k^h0
0omn[MWok^k^ooooo`0Cooooo`0;ooO_kooWknoo[Jf]of]SHooWg^Ooe]kN
of=:D_o6LiCooiBeoonL_OooYLH00_ooYLh05?ooYLKomiBmonnD_OooS:go
ohbUooMkU?ogQ9Comg^<onMkQ?o_Hg_oif]kokEcLonUJg?oW6=[oiA[LonL
S8co_KFeolkNe_oWmoOomoOg1oooool00oogmoOoooooooooo`3ooooooooo
oooo>?ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWooooo
ooooo`0Eooooo`0=okfm_Om[Lf_oimkWolkFe_m[FU[oaW>DooM[Q?ogLhco
mg>DooN4YOooU;GooibmoonUaP02oonUcP0GoonL_OooU;Goohb]oon<[Ooo
Q9comg^DooMcU?o_Q9Coig^4omIcNoo>Hg?oaW=cojEcLonLJg?oW7=kojfU
YOnm_KgoimkNooOgmoo_ooooooooooOgmoo_ool01oooool00oogmoOooooo
ooooo`3ooooooooooooo<oooool1ogj]f@7ooooo0Oooool000?ok^k^00?o
OZgIonk^k_ooool05Oooool02?o6a/KoQ8B4ooOgmooWknooS7]komj<[Ooo
U;Goohb]0_ogLi@01?o_Lhcomg>Doon4W?ooS:D2oonUaP;ookGF01CoojG>
oonUa_ogU;gokhbeooMkU?ooQ9comg><ooMkS?ogNiCokf^4omIcNoo>Hg?o
]G=cojE[LonULg?oYG]kokFLW?nm_KgoinOWonoooooooooooooooolkoooo
o`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo01Go
oooo00Koc]K>ohB4Q?o_inooinOWoiB4Q?oNS:d2oonL_@04oonD]OooS:go
ohbUooN4Y@;omg^D00KogW^Doon4W?ooU:gooiBeoonUa_ooYLh2ooneeP05
oonUc_ooYLKooiBeoon<YOogNi@00oogLi@03OogNhcoig^4omIcNoo6Jg?o
]G=coje[JonULg?oYG]kokF][OoFc/koinOWooOgmoooool00oo_oooooooo
oooooooo<oooool2onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWo
k^k^ooooo`0Eooooo`06okg6a_mkNg_oe/kFolk>c_m[Lf_ocW^D0oooS:d0
0oooU;GooibmoonL_@02ooNL_@;oohb]00WomiB]ooN4YOogQ:GomiB]oon<
[OooU;GoojG6oonee_ooYLh00_ooYLH02OooW;gomiB]ooN4YOooQ9coog^D
ooMkU?ogQ9Coig^<omikQ002oliSL`09ojEcNonLJg?oW7=kojf<U?nm]KGo
g/kFooO_koooooookooo0?oooooooooooolbooooo`;ok^k^0Omn[MT1onk^
kP7ok^k^0003ooooo`03ogj]fOoooooooooo01Gooooo00Koc]K>ohb<S?o_
inoog^OWoiAcNoo>Ni`2oon<[@;omhBU00Soohb]oonD]OooW;gooibmoonU
a_ooYLkoojG6oonL_@;ooiBe00WoohbUoon4W?o_NjGomhbUoonD]OogW;go
ojG6oon]c_ooYLH00_ooW;d04_o_S;GomhBUonmkYOooQ9cokg^UooMkU?o_
Q9Coig^<omIcNoo6Lg_o]F]kojE[LonDJg?oW7]kojf<U?o6a/Koe]KFooO_
kooooooooooooolbooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWo
k^k^ooooo`0Eooooo`0:omK6c_n<S8cokoooono_konLU9co]IbLoonUc_oo
YLKooibmoonD]@?ooiB]017ooiBeonnUc_ogW;gomjg6oonUc_oo[LkoojG>
oonUa_ooW;gooiBeoon<[OooS:Gokg^UooMkU?ogQ:Goohb]oonD]@03oonL
_@0DoonD]OooS:goohbUoon<YOogQ:Gomg^DooMcU?o_Q9Cokg^<onMcS?oN
Jg_ocV=coliJJonUJf_oW6]coiacNoneW9coe[g6omkNg_o_moL2onooo`;o
oooo00CokoooooooooooooookoooooooooooooooobCooooo0_o^k^h1ogj]
f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool04oooool02oo_oooo
ooooolk>c_n4Ng_og^OWomKFe_nLQ8coW8bDoonee_ooYLkoojg>00;oojG6
00Coojg6oonL_OooW;gooiB]0oooU;D01?ooYLKomjg6oon]c_ooYLh2oonU
aP;ooibm00SooiBeonmkYOo_NjGoihbLonMcS?o_Q9CoohbUoon<[@;ooiBe
0_ooS:d2oon<Y@06oon4W?ogNiComhBDooMkU?o_Q9Cokg^<0_o>Nh@02_ne
Jg_oYF]cojE[LonDLg_o[HbDokfUYOo>c/koimkNooooooo_ool2ooooo`03
onoooooooooooooo0?oooooooooooolRooooo`;oi^KV0Omn[MT1onKViP7o
i^KV0003onk^kP03ogj]fOo^k^kooooo01Gooooo00[oe/k>ohAkNooNinOo
c/k>oiB<S?nLLg_okjG>onn]a_ogW;goojg60_oo[Lh4ooneeP04oon]c_oo
YLKooibmoonD]@;ooibm00Gomjg6oonUc_ooYLkoojg6oonUaP02oonL_@08
oonD]OooS:GoohBLomikU?o_Lhcoig><ooMkU?ooS:D3oon<[@;oohbU0_oo
Q9`02?ogNiComhBDooMcU?ooQ9cogW^DonMkS?o>NhCo_F]c0_neLg<01onD
Lg_o[HbDooo>g_o_oooomoOgooooooo_ool0ooooooooooooobCooooo0_o^
k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool05Oooool0
1ooFc/koS8b<onogmooWinOo[JFUoiAcNoooYLH00_ogW;d01OooU;Gooibm
oonUa_oo[LKoojg>00;omkgN0ooo]Mh00ooo]MKoojg>oonUaP02ooNL_@Co
oiBe0_ooW;d2oonD]@04oon<[OooQ9comg^DooMcS0?oif>400Cokg><ooMk
U?ooQ9coohb]0_ooS:D3oon4W0;oog^D00CoohBDooN4U?o_Nhcoig^40_o6
Nh`00oo_YKGoooooonooo`3ooooooooooooo:?ooool1ogj]f@7ooooo0Ooo
ool000?ok^k^00?oOZgIonk^k_ooool05Oooool02Oo>a/koQ8B4ooOgmoo_
inoo_KFeoiAcNoooc^oookgFoon]cP02oon]aP03ooN]_OogW;gomjg600;o
ojg>00gookg>ooneg_ooa^OoolKWooO6ioog_NOookGFoon]c_ooYLKomibm
oonD]OogU:goohbU00;oohb]0_ooU:d01_ooU;Goohb]oon<YOooQ9coog^D
onmcS0;oif>400CogUYkonMSQ?o_Lhcomg^D1oooQ9`2oomkU004onn<W?oN
NhcogW^DonoWkooooooooooooolWooooo`;ok^k^0Omn[MT1onk^kP7ok^k^
0003onKViP03ogj]fOoVi^Kooooo01?ooooo00SokooooooooooFc/koQ7]k
omkWiooFe]Ko_KFeog]SL`CookGN00CoolKNooneg_oo_MKomkgF0_oo[Lh2
ooNUcP05oonme_oo]MkookGNooneg_ooa^L00_oo]Mh2ooneeP05oon]c_og
W;gomjFeooN4YOogS:D00_ogQ:D3oon<Y@;oohBL01Coog^DooMkU?o_Lhco
if>4onMSNooNFW_ogUYconm[Q?o_Lhcomg^Doon4U?ooQ9coohbUoon4W?oo
S:Gomg^DooMcU?oWJhcokmkNonoooooooooooooooolVooooo`;oi^KV0Omn
[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo01Gooooo00Koe/k>
ohAkNooNinOoc]KFokfe]OmcDUX2ooNmeP05ooNUc_oo]MKookGNooneg_oo
a^L00_ooc^l00oooa^OookGNoonmeP03oon]cP05oon]a_og_MKomkgFooNm
e_oo]MH00_oo]Mh2ooneeP08oonUa_ooW;gomiB]onn<W?o_Q9Comg>Donmc
S?o_Nh`2oon4U0?oog^D00Gomg><onmcS?o_JhCoieYcomiSL`02omiJL`03
onMSNoo_Lhcomg><00;oohbU0_ooJh`00ooNc]KomoOgooOgm`3ooooooooo
oooo9Oooool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWooooo
ooooo`0Eooooo`09omK>c_n<S8coooooono_kooF_LKoNe9Jooo6iooo_MKo
ojg>00;oojg600Comjg6oonee_oo]MkookGN0_ooa^L00oooe^ooolk_ooo>
k`02ooO6i`04oonee_oo[Lkoojg6ooN]aP;oojg60_oo[Lh2oonUaP07oonL
_OooU;GooiBeoon<YOooQ9comg>DonM[N`02onm[Q003onMkQ?ogNhcoog^D
00?oog^D00?omf^4ooMcS?o_Hg/00ooNFW<01Oo_Lhcomg>DoomkU?ooQ9co
mkgF00;okoooooooooooooooobOooooo0Omn[MT1ooooo`7ooooo0003onk^
kP03ogj]fOo^k^kooooo01Cooooo00SomoOgomK>c_n<NhComoOgooO_kooW
inOoFV=Jooo>m`?oolKW00CoolKNoonee_og_LkookGF0_og_MH2oonegP0>
ooo6ioooc^ooomK_ooo>moooc^ooolKWooneg_oo_MKoojg>oonUa_ogW;go
mjFeoonL_OogYKD3oonL_@07oonD]OooU:goohbUoon4W?ogNiCokg^<onMS
Q002onMSN`03onM[Noo_Hg_okg><00;omg><00Wokg><ooMcS?o_JhCokf^4
ooMcS?ooNiComhBUooMkU?oo_MH0ooooooooooooobOooooo0_o^k^h1ogj]
f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool05Oooool02?o>c/ko
Q7]konONg_oNc]Koe/K>od92@_ooc^oomkgN0_ooa^L2ooo>k`05ooo6iooo
c^ooolKWooo6g_og_Mh00_og_MH2ooNmgP?oolKW00Soolk_ooo6ioooa]ko
olKFoon]c_oo[LKomjfmoonL_@;omiB]00ComiBUooND[OooS:gomiB]0ooo
S:D02OooQ9comg^DonmcS?o_JhCoif=komiJLooNHg?oif=konm[Q003ooMc
S0;oohBL00GomhbUooMkU?oo_Lkoooooonooo`3ooooooooooooo9Oooool2
onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`0Eoooo
o`07omKFe_n<S8comno_onONg_oNe]Ko@STiooo6i`04ooNmgP07ooo6iooo
c^ooomK_oooNmoooc_OoomK_ooo>k`02ooo6i`;omkgN00?omkgWooNmg_og
_Mh01?oo]Mh02_oo_MKoojg>oon]a_ooW;gomjFeoon<[OogS:GokhbLonn4
U?ogNi@5oon4W0;oog^D00comg><onmcS?oWJg_ogV=coliSLooNHg?oif]k
onmcS?ooS:GomhBUooMkU?oo_MKooooooooooooo9oooool2onk^kP7oOZgI
0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`0Eooooo`0;olk>c_n<
S8coooooooO_kooWg^OoBSU2ooo>moooa^OoolkNooNmg_og_MH00oog_Mh0
0oooa^OoomK_oooNm`02oooNm`07oooFkoooc_OoomK_ooOFkooga^OomkgN
onnmeP02ooNmeP;ookgF00[ookGFoon]c_oo[Lkoojg>oon]a_ogYKGooiB]
ooN<YOogQ9CokhBD0_o_Lh`04_oWLhcokg^<ooMkU?ogQ9CoohBLooN4U?og
LiCokg><onm[Q?oWHhCogV]konm[Q?ooS:GomhbUooMkU?oo_MKoooooonoo
oooooooooooooolWooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWo
k^k^ooooo`0Eooooo`07olk>c_n<S8comoOgooO_kooWinOoBTY:oooNm`02
ooo>m`05oooNmoooa^Ooolk_ooo6ioooc]h00ooga^L01Oooa^OoomK_ooo>
moooc_Ooomkg00?oolkg0_ooa^L00oog_Mkokjg>onn]cP02ooN]aP03ooNL
_OooW;gomjfm00;ooibm00komjFeoonD]OooU:gokhbLonn4U?oWNhcoif>4
onMkQ?oWHhCoig^4onmcS?o_Q9CoohBLooN4U0;omg^D00GomhBDoon<[Oog
S:GoohbUoonmcP3ooooooooooooo9oooool2onk^kP7oOZgI0Oo^k^h1onk^
kP000ooVi^H00omn[MWoi^KVooooo`0Cooooo`09onooooooooooc/k>og]k
Noo_knoog]kNomKFe_m2@T;omlKW00;oomK_00OoolkgoooFkoooe^ooomkg
ooo>mooog_Ooolkg00;oomK_0ooge^l04Oooe^ooomkgoooFkoooe^ooolkg
oooFkoooc^ooolKWooo6g_oo[Lkomjg6onnU_Oo_W;GomiB]ooNL[OogU:Go
ohbU00?ooiB]0_ooS:D01OooQ9comg^DonmkS?oWHhCoig^400;ogV]k00So
ig^4onMcS?ogNiCoohBLoon<YOo_NjGoohbUooNeaQ;ooooo00ColO7aoooo
ooojn_[om?Cd0_ooool00oomoOgoj^[Zooooo`04ooooo`03oo3`l?oLg=co
oOgm00Cooooo00?on?Shom_KfoomoOd0ooooooomooooo`;oi^KV0Omn[MT1
onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo00Cooooo00?omoOgoijN
W_ogmoL03_ooool01oo>e]KoS8b<oooooooWinOog]KFoeYJF_og_Lh00_oo
a^L01Ooga^OommKWooo>koooe^ooolkg00Soomkg0_ooa^L03_oga^OommKW
ooo6ioooe^ooolKWooo>koooa^OookGNoonmc_oo[LKomjfmoonD]OogU:Go
khbL0_oWS9@00oo_S9coohBLonn<W003onn<W005oon4U?ogQ9Cokg^<onMc
S?oWNh@00_oNJg/01OoWLhcoohbUooND[OooS:Gomjfm00Sooooo01_o20P8
ooooooooooooS8b<omcLg?ooooooIVIVoh^;Roo/k>co9RHVob`/;?mJFU[o
<S8bog=cLooooooo[Zj^oa0@4?l/;2co8b<SonSXj?ooooooj>SXodM7Aol`
<33oBTY:oalO7onGUiL00_ooool01OnFUYKo3@d=odA4A?le=CGoQ8B400Co
oooo00OoJVYZoh>3Poooooooooooon?Shol=3@go^;Rh0?oooooolOooool2
onk^kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`04oooo
o`03omWIfOmgMgOofMWI00kooooo00Ooc/k>ohb<S?oooooomoOgonOWiomc
Hf_okkgF00;oomK_00GoolKWoooFkooga^OomlKWooOFk`02oooFk`Ooomkg
00?oomK_ooo6ioog_Mh00_og_MH01Oog_MkomkgFoonee_oo]MKookgF00;o
ojg>00Soojg6oonL_OogYKGooiB]oon<YOo_S9coihbDonMkS0;okhBD00Co
ohBLooN4U?o_S9coohBL0_ogQ9@2onmkS005ooN4U?ooS:gomiB]oon<[Oo_
YKd02?ooool04_l820SoooooolG5aOl30`?oKVi^oooooomVIVKoRh^;oj6Q
XOm3@d?ooooool_;bol410Coo?clookno_lM7AgoZJVYooooo`;ooOgm00?o
oooood10@?maLG400_ooool02_oTi>Co6ATIok:b/_ooooooj>SXooOgmooo
oooom_KfoaLG5ooQhN43ooooo`06oo?clolV9RKodm?Coooooom=CDgoFUYJ
ooooooodooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^oooo
o`03ooooo`05ooclo?n;Rh_oLg=coh^;Roolo?`03Oooool01oo>c/koQ8B4
ono_kooWinOog]kNohbDS?nmW;D01ooog_L01OoginooomK_ooOFkooge^oo
omK_00Ooomkg00Ooolkgooo6ioog_MkomkgFooNmc_og]LKomjg600;omjfm
00?oojg6ooN]_Oog[Kd00_ogYKD01_ogW:gomiBUooNDYOo_Q9Coig^<omik
S0?oig^<00WokhBDooN4U?o_Q9CokhbLonnDW?ooU:goohbUonnL[OooU;D0
2?ooool04Ol820SoooooofYZJ_m_Kfoo9bLWoo_knomVIVKoRh^;on7QhOlN
7QkoTY:BokVi^Ol820Sooooool71`OlF5QKooOgm00?ooooo00?obl_;o`00
0?oGemL00oooool00omTI6Co?Cdmooooo`03ooooo`03ong]kOl>3Pko`/;2
00Cooooo00Go^k^koc@d=?nUYJGo4Q8Bon[ZjP3ooooooo;ooooo0_o^k^h1
ogj]f@7ok^k^0Oo^k^h000?oi^KV00?oOZgIonKVi_ooool00oooool01Oo5
aLGoLg=cog=cLomcLg?oaLG500gooooo00Ooe]KFohb<S?o_knoog]kNolK6
a_n<NhCoW9BL00?oomK_2ooog_L00oooe^ooomkgoooFk`04oooFk`;oolk_
00CoolKNoonme_oo[Lkoojg60_ogYKD4ooNL[@CooiB]00GoohbUoon4W?o_
Q9Cokg^<onMkQ002omikQ009onMkQ?o_NhcomhBDoonD]OooS:Gokib]oonD
[OoooooomoOg00Kooooo017o20P8oo[jn_lC4a?odM7AofYZJ_na/K7oIVIV
oh^;Roooooooo?clolo?con=SHgo20P8ooooooo9bLWo3Ph>oo[jnP03oooo
o`03oj6QXOlM7Agooooo00?ooooo00?oZ:RXoa@D5?ooool00_ooool01?ni
^KWo7QhNoda<C?omoOd5ooooo`03ofIVI_l30`?oWinO0?ooooooloooool2
onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`02oooo
o`03ooCdm?n0P83oLg=c00;oLg=c00?oP820ooCdm?ooool02oooool01oo>
c/koS8b<ooooooo_knooe]KFojFUYOnDLg/00_oog_L00oooe^ooolkgoooF
k`0;oooNm`03oooFkooge^ooolKW00;oolKW00Koolk_ooo6ioooa^OoolKN
ooo6e_oo_MH2oon]aP04ooNU]OooU:gomiBUonnDY@;okhbL00CokiBUooN<
YOooS:GomiBU0_ooS:D02_o_U9cokhBDonmkS?oWNhcogW^<onMkS?ooU;Go
ohbUonnL[OooU;D8ooooo`0=o`P82?nc/k?o;Bd]ooooooo9bLWoDe=CofIV
I_n;Rh_oooooolc<c?omoOgoalO7obLW9`02ooooo`07ob8R8_n>SXkono_k
ooShn?ono_koXZ:RoaXJ6P04ooooo`08ojRXZ?lE5AGoooooookno_mfMWKo
30`<ohf=SOono_h6ooooo`03ofIVI_l0003o_[jn0?ooooooloooool2onk^
kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`02ooooo`03
ojj^[_mcLg?oLg=c00?oLg=c00?o[Zj^ooooooooool02_ooool01oo>c/ko
Q8B4ooooooogmoOokno_olK>c_mkHg<00_oog_L01OoginooomkgooOWkooo
e^oomnO_00Goomkg00?omoOgoooNmoogmoL00ooog_L2oooFk`03ooo6iooo
a]komkgF00;ookgF00CoolKFoonme_oo_MKoojg>0_oo[LH01?ogYKGooiB]
onnDW?o_S9`3onN<U006onn4U?o_S9cokhbLonn<W?ooS:GokiBL0_o_S9`0
0oogQ9ComjFeoon<Y@02ooND[@03ooO_kooooooooooo00Gooooo00?o20P8
oeQHF?n8R8P00_ooool02?l^;RkoE5ADoh^;RoooooooJ6QXocXj>_lb<S;o
YZJV0_ooool02?o@d=3oJVYZob`/;?l/;2comoOgolk>c_l0003oe=CD0ooo
ool01_mQHF7o@410ooooooo4a<Co51@DomWIf@Oooooo00Go`/;2o`X:2_nY
ZJWo9bLWooCdm03oooooooCooooo0Omn[MT1ooooo`7ooooo0003onk^kP06
ogj]fOo^k^kooooooooooooVi^KoPh>31OmcLg<00on3Ph?oi^KVooooo`0:
ooooo`08olk>c_n4Q8ComoOgonOWiooFe]Koc/K6of=BF_oooolCoooNm`07
oooFkooge^OoolKWooo6e_og_LkomjG>ooNeaP05ooN]_@;omjFe01;ooiB]
ooNDYOogU:GokhbLonN<U?oNNhCogW^<onMkS?oNNiCokhbLonn4U?o_S9co
mhbUooNU]OooU:gomib]oon<YOoginL7ooooo`03o`L71ol;2`_ohn?S00;o
oooo00?oQHF5o`X:2_n;Rh/03Oooool02_m7AdOoJ6QXookno_oooooog]kN
oaHF5_nj^[[oooooolS8b?l^;Rh2ooooo`03onk^k_oooooooooo00;ooooo
00KonOWiobPX:?n7QhOoooooogmoOom]KFgooooooo;ooooo0_o^k^h1ogj]
f@7ok^k^0Oo^k^h000?oi^KV00GoOZgIonKVi_oooooooooooiNGU`07og=c
L`03oiNGUooooooooooo00Wooooo00Woc/k>ohB4Q?ogmoOoinOWolk>c_nm
a[goDT92oooNmoogmoL01Ooog_L01?ooooooomkgoooWooogmoL:oooNm`08
ooo>moooe^ooolKWooo>g_ooa]Koojg6ooN]a_og[Kd2ooNU]@Comib]0_oo
U:d01?ooS:GomiBUooN<YOo_S9`2onN<U0?ogW^<00KoihbDooNU]OooS:Go
miB]oon<[Oo_g]h7ooooo`03oa<C4om7AdOooooo00;ooooo00?oh^;Ro`d=
3OnATI403Oooool01_o]kNgoEEEEobLW9oln?Sko8b<SojBTY0?ooooo00Co
JVYZoc0`<?l];Bgo<c<c1?ooool01on:RX[o=SHfoo_knooooooon_[jocPh
>?o9bLT0oooooooaooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP05
ogj]fOo^k^koooooom7AdOnBTY801omcLg<00onBTY;odM7Aooooo`09oooo
o`07olk>c_n<S8cooooooooooooWinOoe]KFodXi@P08oooNm`0:oooooooo
g_OoonOooooNmoooiooooooooooNmoooioooomkgooOWk`?oomK_00kommKW
ooo6ioooe^ooolKWooo>g_ooa]kookgFoon]a_og[KgomjFeooNL[OogU:Go
kiBUonnDW0;okiBU00?omhbUooNDYOogU:D00_ogU:D00oo_U9cokhbLonN<
U002onN<U005ooN]_OogU:gomib]oon<YOogg]h07_ooool00ooinOWoj>SX
ooooo`05ooooo`03ooGemOo`l?3ooooo0?ooooooo?ooool2onk^kP7oOZgI
0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`0Eooooo`08omKFe_n<
S8coooooooooooo_knooinOWoeY2B_ooool6oooNm`0:ooOgmooog_Oooooo
ooooooogmoOooooooooNmoooooooomkgooooo`;oomkg0_ooe^l01_ooa^Oo
olkNooNme_og_MKookgFooo6eP?ookg>00Ooojg6ooN]_Oog[KgooiB]ooNL
[OogU:GokiBL00?oihbD00GoihbLonn<W?ogU:GomiBUonnDY@02ooNDY@05
ooNU]OooU:gomib]oon<YOo_g]h0ooooooooooooobSooooo0Omn[MT1oooo
o`7ooooo0003onk^kP03ogj]fOo^k^kooooo01Gooooo00Soc/k>ohb<S?o_
knooinOWomkNg_oFe]KoFTYBonONi`;ooooo00?oomkgooooooooool01ooo
g_L00oooioooomkgoooNm`05oooNm`05ooOWkoooe^ooolKWooo>g_og_Lh0
0_og]LH2ooN]_@03oon]a_og[Kgomjfm00;omjFe0_ogW:d01_o_W:GokiBL
onN<W?oWS9CogXB<omikU0;oihbD0_o_S9`01oog[Kgomib]ooNL[OogW:go
ojg>ooooooo_ool0ooooooooooooobCooooo0_o^k^h1ogj]f@7ok^k^0Oo^
k^h000?oi^KV00?oOZgIonKVi_ooool05Oooool02oo>c/koS8b<ooooooo_
knoog]kNolK6a_mcHf_oe/k>oooNmooginoomoOg00;oomkg00KooooooooW
ooogmoOooooooooNmoooiol3oooNm`06oooWoooog_OoomkgoooNmooginoo
omkg0oooe^l2ooo6i`04ooo6e_oo_Lkoojg6ooN]_@?omjFe00Comib]onnL
[OogW:gomiBU0_ogW:d01_ooU:gokibUonnDW?oWS9coihbDomikU0;ogXB<
00GomjfmooNL[Oo_[KGomib]oon]aP3ooooooooooooo9_ooool2onKViP7o
OZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`0Eooooo`0Folk>
c_n<S8coooooooooooogmoOog]kNoiB<S?nLU9cooooooooNmoooooooknO_
oooooooog_OomoOgoooWoooog_OoonOoooOgmoooiooomoOgoooWo`Coomkg
0_ooe^l00ooge^OomlKWooo>gP02ooo>gP05ooo6g_ooa]KookgFoon]a_og
[Kd00_ogYKD01Oo_W:GoiibUonnDYOo_U:GokibU00KomiBU00SokiBLonN<
W?oWS9comibmooNL[OogYKGokjfeoon]a_oooooooooooolVooooo`;ok^k^
0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo01Gooooo00So
c/k>ohb<S?ooooooooooooOgmoo_knoo[Jf]oibDW0?ooooo0_oog_L05?og
moOoomkgooOgmooog_OooooooooNmoooooooomkgoooooooog_OoonOooooN
moogmoOoomkgoooFkoooinOoolKWooo>g_ooa]KomkgF0ooo_Lh00oog_LKo
okg>oon]aP02ooN]_@05oonD[OogW:gokibUonn<W?oWS9@00ooWS9`01Oo_
U9cokibUonnDYOo_U:GomiBU00?omjFe00?omib]oon]a_ooool0oooooooo
ooooobOooooo0Omn[MT1ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo
01Gooooo00Soc/k>ohb<S?ogmoOokno_omkNg_oFe]Kog]KFoeY:DP;ooooo
017oomkgooooooooooooomkgooooooooiooooooooooNmoooooooomkgooOg
mooog_OooooooooNmoooioooomkgooOgm`03oooNm`06ooOFioooc]koolKF
ooNmc_og]LKoojg60_og[Kd2ooNU]@;omjfm0_ogYKD01_o_YJGokibUonnL
YOoWS9coihbDomikU0?oihbD00OoihbLooNU]OogYKGomjFeooNL[Oog[Kgo
moOg0?oooooooooooolUooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKV
iP03ogj]fOoVi^Kooooo01Gooooo00Woc/k>ohb<S?oooooomoOgonOWiooF
e]Koe/k>obTQ8OoWg^L00oooool00oogknooonOoooooo`04ooooo`04oooN
moooooooomkgooooo`;omoOg0ooog_L4oooFk`05ooOFioooc]koolKFooNm
a_oo[LH00oogYKD01?o_W:gomib]ooNL[OogYKD2ooNL[@09oonD[OogU:Go
kiBUonnLYOo_U9coihbDomikU?oWS9Comjfm00;omjFe00?omib]onnU_Oog
knl0ooooooooooooobGooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^
00?oOZgIonk^k_ooool05Oooool00oo>c/koS8b<ooooo`02ooooo`07ono_
kooNg]ko_KFeod8i>OoFc/kooooooooNm`0:ooooo`05oooWoooog_Ooomkg
oooNmoogknl00_ooe^l2ooOFi`0;ooo6ioooc]koolKWooo>g_ooa]KoolK>
oonmc_og_LKomjfmooNU]Oo_YJD00_oWW:D5onnLY@;omib]00?omiBUonnL
YOo_W:D01OogYKD00oo_inooooooooooo`3ooooooooooooo8oooool2onk^
kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`0Eooooo`03
olk>c_n<S8cooooo00;ooooo00WomoOgooO_kooWinOoc/K6of=BF_m2@T;o
Lf=[oiBDU?oginl01Oooool00oooioooooooooooo`03ooooo`09oooWoooo
g_OoomkgoooNmoooe^ooolkNooo>e_og_MKomlK>00Cookg>0oog[Kd2ooNU
]@04ooNL[Oo_W:GoihbLonN<W0;oihbD0_oWS9`2onnLY@03ooNL[Oog[Kgo
mjFe00;omjFe00?okjFeonOWioooool0ooooooooooooobKooooo0Omn[MT1
ooooo`7ooooo0003onk^kP03ogj]fOo^k^kooooo01Gooooo00Ooc/k>oiBD
U?ogmoOokno_onOWiooNg]koinOW00;og]kN0_oWinL01oo>c/koW9bLof][
JomJBU;oLeYSoibDW?o_g]h00_ooool02?ogmoOooooooooNmoooooooonOo
ooOgmooog_OomoOg0_oog_L01Oooe^ooomkgooo6ioog_MKomkg>00;omkg6
00?okjfeooN]_Oog[Kd01?og[Kd2ooNU]@03onnL[OogW:goiibU00GoihbD
0_ogYKD01?og_LKokjFmoonL_Oooc]Kooooooooooooo9Oooool2onk^kP7o
OZgI0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`0Dooooo`03ooOg
moo_knooLg=c00;ooooo00OomoOgonOWioo>c/koc/k>olK6a_o>c/koe]KF
00?og]kN00SoimkNomk>e_ne[JgoLg=codY:B_mSDU[oW8bDomK6cP;ooooo
00?omoOgoooNmooog_L00_oog_L02_ooioooomkgoooFkoooinOoomK_ooo>
g_ooa/koojg6ooo6c_ogYKD6ooNL[@07onnUYOogW:gomib]ooNL[OogU:Go
kjFUonnDW002onN<W006ooNU]Oog[KgomjFeonn]]OogYKGoolK>oooooooo
ooooobGooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^
k_ooool05_ooool00omBBU;oooooooooo`02ooooo`03ono_kooWinOog]kN
00Coc/k>017oa/K6omKFe_oFe]Kog]KFomkNg_oWinOog]KFojfUYOmkNg_o
FTYBof=BF_n<NhCoa/K6oooNmooooooommK_onONi`05oooFk`05ooo6iooo
c]kookgFoonmc_og_LH00_og[Kd01?ogYKGokjFUonNLYOoWW:D3onnLY@0;
onnL[Oo_YJGomiBUonnUYOogU:GomjFeooN]_Oog_LKokjfeoonL_Oooa/h0
ooooooooooooobGooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?o
OZgIooooooooool05_ooool00on][JgoNg]kooooo`03ooooo`05ooOgmoo_
knooinOWonOWiooNg]h00_oFe]H01_o>c/koa/k>olK6a_o6a/Koa/k>olkF
eP;og]kN013oinOWonONionm_KgoQ7>4oeY2D_mJ@T[oQ7>4okfL]Ooge^Oo
omK_ooOFioog_Mkomkg>oonme_ooa]kookGN0_oo_MH05Ooo_Lkoojg6ooN]
_Oo_[KGomib]onn]]Oo_YJGoihbLonNLYOoWS9cogYBUonN<W?o_YJGokibU
ooNU]Oog]LKomjFeonnU_Oog[Kgomkg6ooOgm`3ooooooooooooo9_ooool1
ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_ooool05oooool01?mc
Lg?o_KFeooOgmoo_knl2omkNgP;oinOW01Cokno_ooOgmoo_knooinOWomkW
iooNg]koe]kNolkFe_o6c/koa/K6okg6a_o6c/koa/K6olk6c_oFc/kog]kN
onOWiooWg^Oo_KfmoiBDU0;oHdYB00OoLeYSokFLW?o__MKoonOWooNmg_og
_Lkokjg>00;omjg600WomkG6oon]a_og_LKomkg6ooNU]Oog[Kgomib]onnL
YOo_YJD00_oWW:D02OoNU:GoihbDooNU]Oog[LKomjfmooNea_ooW;gomkg6
oooNm`3ooooooooooooo9?ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooV
i^H00omn[MWoi^KVooooo`0Gooooo`07onOWiomBBU;oooooooooooo_knoo
g]kNomKFeP02olk>cP03omKFe_oNg]koinOW00?okno_0_oWinL00ooNinOo
e]kNomKFeP05olk>cP0<omK>c_oFe]KoimkNonOWiooWg^Oog/kFoibDW?mc
FV?oFSU2of]:F_n<Jg?okjfe0_og_LH01_og[KgomjFeooNL[OogYKGomjfm
ooNU]@;omjfm00WomjFeooNL[OogW:gokibUonNLYOog[KgomkG6ooN]_Oog
[LH00_og[Kd00ooginooooooooooo`3ooooooooooooo8_ooool2onKViP7o
OZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`0Dooooo`;omoOg
0_ooool00om:BT[oooooooooo`02ooooo`03ooOgmooWinOog]kN00?oe]KF
00Goc/k>omKFe_oNg]kog]kNonOWi`02ono_k`03onOWiooNinOog]kN00;o
e]kN00Goe]KFolkFc_o>c/koc/k>omK>cP02omKFeP06omkFe_oWg^OoinOW
omK>c_nm]KGoLeYS0_mcBU802_nDJg?oaYBLonN]]Oo_YKgoijfeomjDYOo_
W:gomjFeonn]]Oo_W:d3ooNU]@04ooN]_Oo_[LKomjfmooNeaP;omjfm00?o
mnOWooooooooool0ooooooooooooob;ooooo0_o^k^h1ogj]f@7ok^k^0Oo^
k^h000?ooooo00?oOZgIooooooooool05_ooool01OogmoOoooooof=SHoo_
knoomoOg00Gooooo00KomoOgono_kooWinOoimkNomkNg_oFe]H2olk>cP05
omK>c_oNe]Kog]kNonOWiooWknl01?o_knl2onOWi`03omKNg_o>e]Koa/k>
00?oc]K>00Ooe/k>omKFe_oNinOog^OWomkNg_nm_KgoQ7]k00;oFT9:00Co
Q6=[olj4S?o_W:gokjFe0_o_W:d02_o_W:GoiibUonnL[Oog]LKokjFmooNm
a_og[KgooibmooN]_Oo_g]kooooooooooooo9_ooool1ogj]f@7ooooo0Ooo
ool000?ok^k^00?oOZgIonk^k_ooool05_ooool01_ogmoOooooooibLW?nU
[JGoooooooOgm`?okno_00ComoOgoooooooooooooooo0_ogmoL01Oo_knoo
inOWomkNg_oNg]koe]KF00?oc/k>0_oNg]h00oogmoOoooooooOgm`03ooOg
m`04ono_kooWinOog]kNomKFePCoc/k>00?oc]KFolk>c_oNg]h00_oNg]h0
2_nm_KgoU8b<oeY2B_mJ@T;oNe9JojEcLooFW:GokjfeonNLYOo_YKd2oon]
aP04ooNL_Ooo[LKomibmooo>g_oooooooooooolTooooo`;ok^k^0Omn[MT1
onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo01Sooooo00CoinOWoe9:
D_o_knoomoOg0_ooool01Oo_knooimkNonOWioo_knooinOW00;omoOg0_oo
ool2ooOgm`;okno_00Oog]kNonOWiooFe]KoU9BDof=SHon<S8coe]KF00Go
oooo00KomoOgono_koo_knookno_omkWiooFc/h3olk>cP04olK6a_o>c/ko
e]KFolkFeP;oinOW00coe[g6oib<U?mcDU[oHcTiof]2B_nLJg?oaYbUonn]
a_og[LKomkg>onn]c_og_Lkooooooooooooo9?ooool2onKViP7oOZgI0OoV
i^H1onKViP000oo^k^h00omn[MWok^k^ooooo`0Iooooo`05omKFe_mBBU;o
YJFUolk>c_ogmoL00_ooool01?o_oooomno_onOWiooWknl3onOWi`0@ono_
koogmoOomoOgooOgmooooooomoOgono_koogmoOoooooomkNg_nLW9coQ8B4
of=SHon4Q8Co_Kfmono_k`;ooooo0_ogmoL01Oogknooino_onOWiooNg]ko
e]KF00;oc/k>00Koc/K6okg6a_nma/Ko_LK6olk>c_oFe]H3omkFeP07okFL
W?nLQ8coLe9Jof]2B_n<Hf_oaYbUoooWi`3ooooooooooooo9?ooool2onk^
kP7oOZgI0Oo^k^h1onk^kP000oooool00omn[MWoooooooooo`0Fooooo`03
ooOgmooooooomoOg00;ooooo00Ookno_okfm_On<S8coLg=cohb<S?nm]KGo
inOW00;ooooo0_ogmoL2onOWi`;og]kN0_oWinL3ooOgm`;ooooo00[omoOg
ooooooooooookno_okfm_On4Q8CoHf=Sog]kNonm]KGoe]kN0_ogmoL04?oo
oooomoOgooOgmoogmoOokno_omKFe_oFe]koc/k>olK>c_nma/Ko_Kfmokg6
a_o>e/ko_LK6omKFe_ogmoL2ooooo`03ooO_koo_inoooooo0?oooooooooo
oolVooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWok^k^ooooo`0E
ooooo`03ooOgmooooooomoOg00Cooooo00[omoOgooooooooooooooooolk>
c_nLW9coNg]kohB4Q?nUYJGog]kN0_ooool01_ogmoOoino_onOWioo_knoo
g]kNono_k`[ooooo00?okno_okfm_On<S8`00_mcLg<01?nUYJGoc/k>ono_
koo_knl2ooOgm`07onONioogmoOoknO_omkNg_oFe]Koa/k>okg6aP02olK>
cP03onoooooooooooooo0?oooooooooooolWooooo`;ok^k^0Omn[MT1onk^
kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo01Wooooo00?omoOgoooooooo
ool01?ooool01_ogmoOooooooooooooooooog]kNojFUY@;oNg]k00KoW9bL
olk>c_o_knoomoOgono_koogmoL>ooooo`09ooOgmooFe]KoW9bLog=cLom[
Jf_oU9BDokfm_OoWinOokmkN00;omno_00OomnO_onOWiooNg]koe]KNolkF
e_ooooookooo00;ooooo00?okoooooooooooool0ooooooooooooob?ooooo
0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool04ooo
ool01OogmoOooooooooooooooooomoOg013ooooo00Gokno_okfe]On<S8co
a/K6ooOgm`0Dooooo`07omkNg_nUYJGoQ7]kof=SHon4Ng_o[Jf]omKFeP02
ono_k`03onoWkooWknoomoOg00Cooooo00?omoOgooooooooool0oooooooo
ooooob;ooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIoooo
ooooool05_ooool00oogmoOoooooooooo`0/ooooo`06onoooonma[goQ8B4
of=SHom[Lf_oa/K6ooooooooooooobgooooo0Omn[MT1ooooo`7ooooo0003
onk^kP03ogj]fOo^k^kooooo0?oooooooooooomfooooo`;ok^k^0Omn[MT1
onk^kP7ok^k^0003onKViP03ogj]fOoVi^Kooooo0?oooooooooooomfoooo
o`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP03ogj]fOo^k^kooooo0?oo
oooooooooomfooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]
fOoooooooooo0?oooooooooooomhooooo`7oOZgI0Oooool1ooooo`000oo^
k^h00omn[MWok^k^ooooo`02ooooo`07ono_kon][JgoFV]SoibLW?oWa/Ko
inOWooOgm`04ooooo`03onooooogmoOooooo0?oooooooooooomVooooo`;o
k^k^0Omn[MT1onk^kP7ok^k^0003onKViP0?ogj]fOoVi^KooooooooooooN
g^OoU8b<oa0H4?m:BT[o:B4QojecNomkNg_oU8b<ojf][OoF_LKokno_0?oo
oooooooooomZooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP0Dogj]
fOo^k^koooooonO_konm_Kgo:C4Yokg6_Ooooooo>APQolj4S?o>Lg_oaV]c
oje[JonLHf_oS6]coib<S?nm]KGoe]KFono_koogmoOoooooooooooooIOoo
ool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool01_mn[MWoooooooOgmooF
c]KoW9BLoc4i>@;ooooo00ooNe9JolikQ?ooNiCokg><onMkQ?o>Lg_o_F]c
ojESJonUHf?oU6]cohB4Q?nLW9co_KfmomkNg_ogknl0ooooooooooooofCo
oooo0Omn[MT1ooooo`7ooooo0003onk^kP06ogj]fOo^k^koinOWolK>c_n<
U8coFUYJ0_ooool01?mcFV?ocW^Doon<[OooS:D2oon4W0;omg^<00_okf=k
onMJLoo6Jg?o[F][ojESHonDJg?oU8B4ojF]YOo6c/kog^o_ooOgm`02oooo
o`03onoooooooooooooo00Cooooo00?okoooooooooooool0oooooooooooo
oe;ooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00KoOZgIonKVi_og
inOoe]KNojF]YOm[Lf/2ooooo`0Gof]cJooNS:goojG>oonUc_ogU;gooiBe
ooND[OooS:GokhbLoon4W?o_Q9CogW^<omIcQ?o>Lg_o_F]coje[JonUHf?o
YF][oib4S?neW9coc/K>onOWioooool00oo_ool;ooooo`03onooooogmoOo
oooo0?oooooooooooom9ooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^
kP0=ogj]fOo^k^komno_onO_kon][JgoJf=SonONiooFg]koHdYBolIcU?oo
U;GooibmoonUaP02oonUcP0DoonUa_ogU;gokiBmoon<[OooS:Gomg^DooN4
U?ogNhcoig^4onmSNooWJg_o]G=cojE[LonLHf_oU6]coib<S?nm]KGoc]kF
onOgmoogmoL7ooooo`03ooOgmooooooooooo0?oooooooooooom<ooooo`;o
k^k^0Omn[MT1onk^kP7ok^k^0003ooooo`0Aogj]fOoooooooooooooooonm
_KgoJg=[onONioo>e]KoJeYJolIcU?ogJhComg><ooMcU?ogQ:GooiBeoonL
_OooYLH00_ooYLh05oooW;gooiBeoon<[OooS:goohBLooMkU?ogLiCokhBD
onMkQ?oFLg_ocV=colIcLonULg?oW6]coiacNon]YJGo_KfmonONg_ogmoOo
koooooooooogmoOokooo00Oooooo00?omoOgooooooooool0oooooooooooo
odOooooo0Omn[MT1ooooo`7ooooo0003onk^kP0<ogj]fOo^k^kooooooooo
ooo6a/KoQ8B4ooOgmooWknooS7]komj<[OooU;Goohb]0_ogLi@01?o_Lhco
mg>Doon4W?ooS:D2oonUaP;ookGF01CoojG>oonUa_ogU;gokhbeooMkU?oo
Q9comg><ooMkS?ogNiCokf^4omIcNoo>Hg?o]G=cojE[LonULg?oYG]kokFL
W?nm_KgoinOWonoooooooooooooooom?ooooo`;ok^k^0Omn[MT1onk^kP7o
k^k^0003onKViP0:ogj]fOoVi^Koooooooooooo>e/koQ8B4onoWkooWinOo
U8B4omj<[@;ooibm00CooiBeoon<[OooS:GomhBU0_ogNi@01_oNNiCoohBL
oonD[OooU;GoojG6oonUcP;ookGF00GoojG>oonUa_ooU;GoohbUooMkU003
ooMcU00=ooMkS?oWNhCoeW=kolI[LoneLg?o[F][ojEcLonUNg_o]Jf]omK>
c_oWinOomoOgooooo`03onoooooooooooooooom7ooooo`;oi^KV0Omn[MT1
onKViP7oi^KV0003onk^kP0:ogj]fOo^k^kooooooooooonma/KoNg]komK>
e_o>c/koJg=[olikU0?oohb]00?ooiBeoonL_OooW;d00_ogW;d2oon<[@09
ooND[OogQ:GomhBUooND[OooS:gooiBeoonUa_oo]MKoojG>00;oojG600Wo
oibmooND[OogQ:GoohBLoomkU?ogNiComhBDonMkS?oNNh@00_o>Hg<02OnU
Lg_oW6]coiacNon]S9Co_KFeomk>e_ogknooooooonooo`3ooooooooooooo
A_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP000oooool02_mn[MWooooooooo
ooooooooc]K>ohb<S?o_inoog^OWoiAcNoo>Ni`2oon<[@;omhBU00Soohb]
oonD]OooW;gooibmoonUa_ooYLkoojG6oonL_@;ooiBe00WoohbUoon4W?o_
NjGomhbUoonD]OogW;goojG6oon]c_ooYLH00_ooW;d04_o_S;GomhBUonmk
YOooQ9cokg^UooMkU?o_Q9Coig^<omIcNoo6Lg_o]F]kojE[LonDJg?oW7]k
ojf<U?o6a/Koe]KFooO_kooooooooooooom6ooooo`7oOZgI0Oooool1oooo
o`000oo^k^h03_mn[MWok^k^ooooooooooooe/K>ohb<S?o_ooookno_oibD
W?neW9coojG>oonUa_ooW;gooiBe0oooU:d04OooU;GokjG>ooNL_Oog[LKo
ojG>oon]c_ooYLkoojG6oonL_OooU;Goohb]oon<YOo_NjGomg^DooN4YOoo
S:gooiBe00?ooibm01CooiBeoon<[OooS:GoohbUooN4YOogNiComg>Donn4
U?o_Nhcoig><omi[Noo>Hg?ocUY[ojE[JonLJg?oW7=kokFLW?oF_LKog]kN
onogm`;okooo0_ooool01?o_ooooooooooooooo_oooooooooooooooo>?oo
ool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H03Omn[MWoi^KVonoooooo
ooooc/k>ohAkNooNinOoe]KFoib4S?nLS9CookGFoonUc_oo[Lh00_ooYLH0
1?oo[LKooibmoonL_OooU:d3oonD]@04oonUa_og[LKoojg>oonUcP;oojG6
0_ooW;d02?ooU;Gokg^UonmkYOoWS9coig><onn4U?ooS:Goohb]0_ooU;D2
oon<[@;oohbU00KoohBLooMkU?ogQ9Comg^Donn4U?o_Nh`2olikQ00:okE[
NonUJg?oYF]coiAcNon]S9Co_JFUolk>c_oWg]koooooonooo`;ooooo00?o
koooooooooooool0ooooooooooooocKooooo0_oVi^H1ogj]f@7oi^KV0OoV
i^H000?ok^k^00koOZgIonk^k_ooooooooooomK>c_n4Ng_og^OWolk>c_nD
S8coW7=konnUc_o_[LKomibmoon]aP;oojg>1?oo]MH01?oo[LkoojG6oonL
_OooU;D2oonL_@05ooN]a_ooYLkoojG>oon]a_ooYLH00_ooW;d02?ooU;Go
ohbUoon4W?oNNiCokg><onMcS?ogNiCoohbU0oooS:d2oon<Y@;oohBL00So
mg^DooN4U?ogLiCoohBLomikU?oWNhcocW^4oke[L`;o]G=c00OoU7=kojf<
U?ooc]kokoooooOgmoooooookooo0?oooooooooooolhooooo`;ok^k^0Omn
[MT1onk^kP7ok^k^0003ooooo`0;ogj]fOoooooooooooooooooFc/koS8b<
onogmooWinOo[JFUoiAcNoooYLH00_ogW;d01OooU;GooibmoonUa_oo[LKo
ojg>00;omkgN0ooo]Mh00ooo]MKoojg>oonUaP02ooNL_@CooiBe0_ooW;d2
oonD]@04oon<[OooQ9comg^DooMcS0?oif>400Cokg><ooMkU?ooQ9coohb]
0_ooS:D3oon4W0;oog^D00CoohBDooN4U?o_Nhcoig^40_o6Nh`00oo_YKGo
ooooonooo`3ooooooooooooo??ooool1ogj]f@7ooooo0Oooool000?ok^k^
00goOZgIonk^k_ooooooooooolk6c_n4Q8ComoOgonoWkonm]KGoU7=kooo>
kooo_MKoojg>00;oojg600?omjfmooNL_Oog[LH00_oo[Lh03Ooo_LkookGN
ooo6ioooa^OomlKWooNmiooo]MKoojg>oonUa_ogW;gooiBeooND[OooS:D0
0_ooS:d2oonD[@06oonD]OooS:goohbUoon4W?ooNiCokg><0_oWHh@01?oN
FW_oif>4onmcS?ogNi@7oon4W0;oog^D00CokhbLomikS?oNNiCoknO_oooo
oooooooooc_ooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00[oOZgI
onKVi_o_ooooooooomK>c_n4Ng_og^OWomKFe_nm]KGoNf=c1?oo]Mh01?oo
a]kookGNoonme_og_MH2oon]cP;omjG>00GookgFooneg_oo]MkookGNooo6
i`02oonegP;ookGF00Goojg>ooNL_OogYKGomhBUooN<Y@02ooN4Y@?oohbU
0_ooQ9`05?ooNiComg^DonmcS?oWHhCoif=komiJNooNFW?okf^4onmcS?og
NiCoohBDoon4W?ooS:GoohBLoon<YOogNiComg>DonM[S?o_g]kokooooooo
oooooooooc[ooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00[oOZgI
onk^k_ooooooooooomK>c_n4Ng_og^OWolkFe_nm]KGoLe9J0_og_MH01Oog
YLkookGFooneg_oo]MkoolKW00;oolk_00?oolKWooneg_oo_MH00ooo[Lh0
1Ooo[LKomkgFooNme_og_MKookGF00;ookGN0_oo]MH02?ooYLKooibmooND
[Oo_S9cokhBDooMcU?o_Lhcokg^<0_ooQ9@3oomkU005ooMcS?o_Lhcokf^4
onMJLooNHg<00_oNFW<00ooWHg_okg><ooMcS002oon<Y@;oof^<00?og/kF
ooOgmoogmoL0ooooooooooooocWooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h0
00?ooooo00goOZgIooooooooooooooooomK>c_n<S8coooooono_kooF_LKo
Ne9Jooo6iooo_MKoojg>00;oojg600Comjg6oonee_oo]MkookGN0_ooa^L0
0oooe^ooolk_ooo>k`02ooO6i`04oonee_oo[Lkoojg6ooN]aP;oojg60_oo
[Lh2oonUaP07oonL_OooU;GooiBeoon<YOooQ9comg>DonM[N`02onm[Q003
onMkQ?ogNhcoog^D00?oog^D00?omf^4ooMcS?o_Hg/00ooNFW<01Oo_Lhco
mg>DoomkU?ooQ9comkgF00;okooooooooooooooooc_ooooo0Omn[MT1oooo
o`7ooooo0003onk^kP0;ogj]fOo^k^koooooooOgmooFc/koS7^4ooOgmoog
knooinOWoeYSF_ooc_L00oooa^L01?ooa]kookGFooNmc_oo]MH2ooNmeP;o
okGN00koolKWooo>koooe^ooolkgooo>koooa^OookGNoonme_oo[LkoojG6
ooNL_OogYKGooibmooNU]@?ooibm00OooiBeoonD[OooS:GoohBLooMkU?o_
Nhcoif>400;oif=k00?oif]konmSNoo_Lh`00_ogLh`02Oo_Lhcomg><onm[
Q?o_JhComg><oomkU?ogQ:Gomg^DoonmeP3ooooooooooooo>oooool2onk^
kP7oOZgI0Oo^k^h1onk^kP000ooVi^H03?mn[MWoi^KVooooooooooooc/k>
ohAkNooWg]kog/kFomK6c_m2@T;oolk_ooNmgP;oolKW0_ooc^l01Oooa^Oo
olk_ooo6ioooa]komkgN00;omkgF0_og_Mh3ooo6i`08ooo>koooa^OoolKN
ooo6e_oo[Lkoojg6ooN]_OooW;d2ooND[@04ooNDYOogU:goohb]ooND[@?o
ohbU00WoohBLooMkU?o_Lhcokf^4onMSNooNFW?ogV=conMSNoo_Jh@00oog
Lh`2oon4W005ooN<YOogNiCookg>ooooooo_ool0ooooooooooooocWooooo
0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00_oOZgIonk^k_oooooooooo
omKFe_n<S8comno_onONg_oNe]Ko@STiooo6i`04ooNmgP07ooo6ioooc^oo
omK_oooNmoooc_OoomK_ooo>k`02ooo6i`;omkgN00?omkgWooNmg_og_Mh0
1?oo]Mh02_oo_MKoojg>oon]a_ooW;gomjFeoon<[OogS:GokhbLonn4U?og
Ni@5oon4W0;oog^D00comg><onmcS?oWJg_ogV=coliSLooNHg?oif]konmc
S?ooS:GomhBUooMkU?oo_MKooooooooooooo>oooool2onk^kP7oOZgI0Oo^
k^h1onk^kP000oooool03omn[MWoooooooooooooooooc/k>ohb<S?oooooo
mno_onONiom:>D;oolkgooo6ioooc]komkgNooNmeP03ooNmgP03ooo6iooo
e^ooomkg00;oomkg00OoomK_ooo>moooe^oommK_ooO6ioog_MkokkgF00;o
mkgF0_oo_MH02_oo]MKoojg>oon]c_oo[Lkoojg6ooNU]OooU:gomhbUooN4
U?o_Q9@2onmcS00BonMcS?o_Nhcomg^DooN4U?ooQ9comhBDooMcU?o_Lhco
kf^4onMSQ?oNJg_okf^4oon<YOogS:Gomg^Doonme_ooooookooo3_ooool0
0ooRh^;oo?clooooo`04ooooo`03on;Rh_olo?cooooo0?oooooooooooolS
ooooo`7oOZgI0Oooool1ooooo`000oo^k^h02omn[MWok^k^oooooooooooo
c/k>ohb<S?ogmoOomno_onOWiom:BT[oomkg00;oolkg00Goomkgooo6iooo
c^ooolKWooo>gP03ooO6i`05ooo6ioooe^ooolkgooo>mooog_L00oooc_L2
ooo6i`03ooNmg_o_[Lkokjg>00;omjg600?omibmoonL_Oog[Kd00_ooW;d0
3_ogYKGooiBeoonD[Oo_S9cokhBDonMkS?oWHhCoig^4onMSQ?oWNhCokg><
onn4U?ooQ9comhBD0_ogNi@01OogQ9Coohb]ooN<YOooS:Gookg>013ooooo
00?o3Ph>on;Rh_ooool01?ooool00ol>3Pkoh^;Rooooo`3ooooooooooooo
8Oooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H02omn[MWoi^KVonoo
ooooooooc/k>og]kNoo_knoog]kNomKFe_m2@T;omlKW00;oomK_00Ooolkg
oooFkoooe^ooomkgooo>mooog_Ooolkg00;oomK_0ooge^l04Oooe^ooomkg
oooFkoooe^ooolkgoooFkoooc^ooolKWooo6g_oo[Lkomjg6onnU_Oo_W;Go
miB]ooNL[OogU:GoohbU00?ooiB]0_ooS:D01OooQ9comg^DonmkS?oWHhCo
ig^400;ogV]k00Soig^4onMcS?ogNiCoohBLoon<YOo_NjGoohbUooNeaQ3o
oooo00Co3Ph>on;Rh_ofm_Kon_[j0oooool01?l>3Pkoh^;RooKfm_ojn_X7
ooooo`03ookno_oYjNWoo_kn0?oooooooooooolFooooo`;oi^KV0Omn[MT1
onKViP7oi^KV0003onk^kP0;ogj]fOo^k^koooooooooooo>e]KoS8b<oooo
oooWinOog]KFoeYJF_og_Lh00_ooa^L01Ooga^OommKWooo>koooe^ooolkg
00Soomkg0_ooa^L03_oga^OommKWooo6ioooe^ooolKWooo>koooa^OookGN
oonmc_oo[LKomjfmoonD]OogU:GokhbL0_oWS9@00oo_S9coohBLonn<W003
onn<W005oon4U?ogQ9Cokg^<onMcS?oWNh@00_oNJg/01OoWLhcoohbUooND
[OooS:Gomjfm00Oooooo00?oBTY:ojVYZOooool00_ooool02OoinOWo4a<C
okZj^_oooooo3Ph>ofMWIom6ATKo410@ojVYZ@02ooooo`05o`h>3_mWIfOo
ATI6oa0@4?nYZJT00_ooool02?l>3Pkoh^;Roooooona/K7o5aLGocTi>Old
=3Co^KVioooooooooooooaGooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?o
oooo00_oOZgIooooooooooooooooolk>c_n<S8coooooooOgmooWinOoLf=[
onnmeP02oooFk`05ooo6ioooe^oomlKWooO6iooge^l00_ooe^l7oooNm`03
oooFkoooa^OomkgN00;omkgF00GomkgNooNme_oo]MKookGFoonmeP02oon]
cP08oon]a_ooW;gomjFeoonD[OooS:GokhbLonN<U?oWNh`2onn4U004oon4
W?ogQ9CokhbLoon4W0;omhBD0_o_Nh`01OogQ9Coohb]ooND[OooS:gokjFm
00Oooooo00?o[jn_od=3@oooool00_ooool02OnXZ:So820Pookno_oooooo
3Ph>okRh^?oooooobl_;ob<S8`02ooooo`05o`h>3_nh^;Sooooool_;bolS
8b<00_ooool01Ol>3Pkoh^;RonKVi_l;2`_oalO70?oooooooooooolJoooo
o`7oOZgI0Oooool1ooooo`000oo^k^h02omn[MWok^k^ooooooooooooc/k>
ohB4Q?o_knooinOWomkNg_n<U8co_Ibe00Ooomkg00GomnO_oooFkooge^oo
mmK_oooFk`07oooNm`07ooo>moooa^OomkgNooNme_og_LkomkG6ooN]aP02
ooN]_@03oon]a_og[Kgomjfm00;omjFe00Komib]ooNDYOogU:GokhBDonMk
S?oNNh`3onMkS009onn4U?ogQ9CokhBDonn<W?o_U9cooiB]oon<YOo_W:go
oiBe00Oooooo00?ono_koaXJ6_lc<c<00_lc<c<01_lE5AGoPX:2oooooooo
oooo3Ph>on;RhP;ooooo00Go5QHFomSHf?oooooo3Ph>on;RhP02ooooo`07
oaHF5_oHf=Soooooo`h>3_oRh^;oZj^[ob4Q8@03okno_`03onWYjOoooooo
oooo0?oooooooooooolCooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003onKV
iP0;ogj]fOoVi^KooooooooooooFe]KoS8b<ono_kooNg]koa/K6ohakQ?nL
U9`00oooe^l;oooNm`03oooFkooog_OoomK_00CoomK_0_ooc^l01?ooa]ko
okgFoon]c_oo[LH2ooNU]@Comib]1?ooU:d01OooS:GoohBLonn4U?o_Nhco
ig^400;ogW^400Woig^4onmkS?ogQ9CooiBeoon<YOo_W:gooiB]ooooooog
moL01_ooool01_mjNW[oLW9booGemOoCdm?o0`<3onCTi0;ooooo00Wo3Ph>
on;Rh_oooooooooooaHF5_o:b/[oooooo`h>3_oRh^800_ooool01olF5QKo
b/[:ooooool>3Pkoh^;RolO7aolG5aL00_mdM7@00olK6a_o`L71ooooo`3o
oooooooooooo5?ooool2onKViP7oOZgI0OoVi^H1onKViP000oo^k^h02omn
[MWok^k^ooooooooooooc/k>ohb<S?ooooookno_omKFe_nUYJGoU7=k00;o
omkg00?oomK_ooo>moooe^l02ooog_L00oooe^oommK_ooo6i`02ooo6i`06
ooo>koooa^OoolKWooo6g_ooa]KookgF0_oo[LH01?ogYKGooiB]ooNDYOo_
U:D2onn<W004onnDYOogS:GoohbUooNDY@;oohbU00[okiBLonn4U?o_Nhco
ig^<omikS?oWNhcooiBeoon<YOo_W:gooiBe2?ooool01OoNg]ko6QXJoo_k
nomjNW[oBTY:00?ooooo01Ko3Ph>ofe]KOo^k^koZj^[oaDE5Oono_kooooo
o`h>3_m]KFgok^k^oj^[ZolE5AGoo_knooooool>3Pkoh^;Rookno_lR8R;o
h>3Pono_kolM7Agon_[joooooooooooooaGooooo0_o^k^h1ogj]f@7ok^k^
0Oo^k^h000?ooooo00_oOZgIooooooooooooooooolk>c_n4Q8CoooooooOg
moo_knooa/k>og]SL`02oooNm`05ooOWkooog_OomnO_oooFkooginl01Ooo
g_L00oogmoOoomkgooOgm`03oooNm`;oomK_00?oolKWooo6g_og_MH00_oo
_MH01?ooa]KookgFoonme_oo[Lh2oon]aP04ooNU]OooU:gokiBLonn<W0?o
ihbD00KokhBDonn<W?o_S9cokhbLoon<YOo_U9`2onn<W003ooN4U?ogYKGo
ohbU00;omiB]00?omno_ooooooooool01_ooool01?m5ADGoZZZZoaTI6On^
[Zh3ooooo`05ocLg=onZZZ[o<C4aocdm?Onk^k/00_ooool01Olg=cOoZZZZ
oc4a<Olm?Cgo^k^k00;ooooo00Oo3Ph>on;Rh_oooooo^k^koc4a<Olo?coo
[jn_0?oooooooooooolHooooo`7oOZgI0Oooool1ooooo`000oo^k^h03?mn
[MWok^k^ooooooooooooc/k>ohB4Q?ogmoOoinOWomKFe_o>a/KoHe9Joooo
oa?oomkg00OoomK_ooOFioooa^OoolKFooNmc_ogYLkomkG600Gomjfm0_og
YKD04_ooU:gomiBUooNDYOo_S9coihbDomikQ?oNNhcoig^<omikU?o_S9co
khBDonn<W?ogS:GomjFeoonD[OogW:goohbUooOWi`Sooooo00CoZj^[oaHF
5_lG5aOono_k4Oooool00ol>3Pkoh^;Rooooo`3ooooooooooooo6_ooool2
onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H03Omn[MWoi^KVoooooooooooo
c/k>ohB4Q?ogmoOoinOWolk>c_nma[goDT92oooNmoogmoL01Ooog_L01?oo
ooooomkgoooWooogmoL:oooNm`08ooo>moooe^ooolKWooo>g_ooa]Koojg6
ooN]a_og[Kd2ooNU]@Comib]0_ooU:d01?ooS:GomiBUooN<YOo_S9`2onN<
U0?ogW^<00KoihbDooNU]OooS:GomiB]oon<[Oo_g]h8ooooo`03oo[jn_lO
7aooNg]k01;ooooo00?o3Ph>on;Rh_ooool0oooooooooooooa[ooooo0_oV
i^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00KoOZgIonk^k_ooooooooooolk>
c_n<S8`2ooooo`03onOWiooFe]KoBSU200Soomkg00[ooooooooNmoooiooo
omkgoooWooooooooomkgoooWoooog_OomnO_0oooe^l03_oge^OoolKWoooF
koooa^OoolkNooo6g_oo_MKoojg6ooN]_OogYKGomib]ooNDYOo_U:GokiBL
0_o_U:D00oogS:GomiBUooNDY@02ooNDY@03onnDW?o_S9coihbD00;oihbD
00GomjfmooND[OogW:goohbUooONgP0Mooooo`03ohb<S?oalO7ooooo0?oo
oooooooooolJooooo`;ok^k^0Omn[MT1onk^kP7ok^k^0003ooooo`06ogj]
fOoooooooooooooooooFe]KoS8b<0_ooool01?o_knooinOWoeY2B_ooool6
oooNm`0:ooOgmooog_OoooooooooooogmoOooooooooNmoooooooomkgoooo
o`;oomkg0_ooe^l01_ooa^OoolkNooNme_og_MKookgFooo6eP?ookg>00Oo
ojg6ooN]_Oog[KgooiB]ooNL[OogU:GokiBL00?oihbD00GoihbLonn<W?og
U:GomiBUonnDY@02ooNDY@05ooNU]OooU:gomib]oon<YOo_g]h0oooooooo
oooooccooooo0Omn[MT1ooooo`7ooooo0003onk^kP0<ogj]fOo^k^kooooo
ooooooo>c/koS8b<ono_kooWinOog]kNomKFe_mJBU;oimkW0_ooool00ooo
g_Ooooooooooo`07oooNm`03oooWoooog_Ooomkg00Goomkg00GomnO_oooF
koooa^OoolkNooNmcP02ooNeaP;omjfm00?oojg6ooN]_Oog[Kd00_ogYKD2
ooNL[@06onnLYOo_U9coihbLonN<U?oNQ8cogW^D0_oWS9@2onn<W007ooN]
_OogW:gomib]ooNL[Ooo[Lkoooooonooo`3ooooooooooooo>?ooool2onk^
kP7oOZgI0Oo^k^h1onk^kP000ooVi^H03omn[MWoi^KVooooooooooooc/k>
ohb<S?ooooookno_omkNg_o6a/KoLf=[omK>c_oog_OomnO_ooOgm`02oooN
m`06ooooooooiooomoOgoooooooog_OoonOo0ooog_L01_ooioooomkgoooN
mooog_OomnO_oooNm`?oomK_0_ooa^L01?ooa]Kookg>oon]a_og[Kd3ooNU
]@04ooNL[Oo_W:gomib]ooNDY@;omib]00KooiB]onnLYOo_U9coihbLonN<
U?oNNi@2omj4S005ooN]_OogW:gokjfeooNL[Ooo[LH0oooooooooooooc[o
oooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00KoOZgIonk^k_oooooo
ooooolk>c_n<S8`2ooooo`0BooOgmooNg]koU8b<oibDW?ooooooomkgoooo
ooo_inoooooooooNmoogmoOoonOooooNmoooiooomoOgoooWooogmoOoonOo
1?oog_L2oooFk`03ooOFiooga^OoolkN00;oolkN00GoolKNooo6e_oo_MKo
ojg6ooN]_@02ooNU]@05onnLYOoWW:GokiBUonnDYOo_W:D01_ogU:D02?o_
U9coihbLonN<W?ogW;gomib]ooNU]Oo_[KGoojg6oooooooooooooc[ooooo
0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00KoOZgIoooooooooooooooo
olk>c_n<S8`2ooooo`04ooOgmoo_knoo[Jf]oibDW0?ooooo0_oog_L05?og
moOoomkgooOgmooog_OooooooooNmoooooooomkgoooooooog_OoonOooooN
moogmoOoomkgoooFkoooinOoolKWooo>g_ooa]KomkgF0ooo_Lh00oog_LKo
okg>oon]aP02ooN]_@05oonD[OogW:gokibUonn<W?oWS9@00ooWS9`01Oo_
U9cokibUonnDYOo_U:GomiBU00?omjFe00?omib]oon]a_ooool0oooooooo
oooooc_ooooo0Omn[MT1ooooo`7ooooo0003onk^kP0<ogj]fOo^k^kooooo
ooooooo>c/koS8b<ooOgmoo_knoog]kNomKFe_oNe]KoFTYB0_ooool04Ooo
g_Oooooooooooooog_OooooooooWooooooooomkgoooooooog_OomoOgoooN
moooooooomkgoooWoooog_OomoOg00?oomkg00KommKWooo>g_ooa]Komkg>
ooNea_oo[LH2ooN]_@;omjFe0_og[Kd2ooNU]@06onnUYOo_W:GokibUonN<
W?oWS9CogW^D0ooWS9@01ooWS9comjFeooNU]OogYKGomib]ooN]_OogmoL0
ooooooooooooocWooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?oi^KV00go
OZgIonKVi_ooooooooooolk>c_n<S8coooooooOgmooWinOoe]KFomK>c_lY
8B7oimkW00?ooooo00?omno_oooWooooool01?ooool01?oog_OooooooooN
moooool2ooOgm`?oomkg1?ooe^l01Ooge^OoolkNooo6e_og_LKoojg600?o
mjFe00Cokib]ooNL[OogW:gomjFe0_ogW:d02OooU:gomiBUonnDYOo_W:Go
kiBLonN<U?oNNiCoihbDooN]_@02ooNU]@03ooNL[Oo_YKgomno_0?oooooo
ooooooliooooo`;oi^KV0Omn[MT1onKViP7oi^KV0003onk^kP06ogj]fOo^
k^koooooooooooo>c/koS8b<0oooool01oo_knoog]kNokfe]Om2>CWoe/k>
oooooooog_L02_ooool01OooioooomkgoooNmooog_Oomno_00;oomK_0_og
e^L02oooa^OoolkNooo6ioooc]koolKFooo6c_oo_Lkomkg6ooN]_OogYKGo
kjFU00;oiibU1Oo_W:D2ooNL[@03ooNDYOo_W:GokibU00GomjFe00?oknO_
ooooooooool0ooooooooooooocOooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h0
00?ooooo00KoOZgIooooooooooooooooolk>c_n<S8`3ooooo`09ooOgmoog
knooinOWolk6a_mSDU[o@T92og=SJonDU9ComnO_00Gooooo00?oonOooooo
ooooool00oooool02OooioooomkgoooNmooog_OoomK_ooo>g_ooc]KomkgF
ooO6cP04oonmcP?omjfm0_ogYKD01?ogW:gokibUonN<W?oWS9`2onN<U0;o
ihbL0_o_W:D00oogW:gomjfmooNU]@02ooNU]@03onnU]OoWinOooooo0?oo
ooooooooooljooooo`7oOZgI0Oooool1ooooo`000oo^k^h02omn[MWok^k^
ooooooooooooc/k>oiBDU?ogmoOokno_onOWiooNg]koinOW00;og]kN0_oW
inL01oo>c/koW9bLof][JomJBU;oLeYSoibDW?o_g]h00_ooool02?ogmoOo
oooooooNmoooooooonOoooOgmooog_OomoOg0_oog_L01Oooe^ooomkgooo6
ioog_MKomkg>00;omkg600?okjfeooN]_Oog[Kd01?og[Kd2ooNU]@03onnL
[OogW:goiibU00GoihbD0_ogYKD01?og_LKokjFmoonL_Oooc]Kooooooooo
oooo>Oooool2onk^kP7oOZgI0Oo^k^h1onk^kP000ooVi^H01_mn[MWoi^KV
ooooooogmoOokno_og=cL`;ooooo00OomoOgonOWioo>c/koc/k>olK6a_o>
c/koe]KF00?og]kN00SoimkNomk>e_ne[JgoLg=codY:B_mSDU[oW8bDomK6
cP;ooooo00?omoOgoooNmooog_L00_oog_L02_ooioooomkgoooFkoooinOo
omK_ooo>g_ooa/koojg6ooo6c_ogYKD6ooNL[@07onnUYOogW:gomib]ooNL
[OogU:GokjFUonnDW002onN<W006ooNU]Oog[KgomjFeonn]]OogYKGoolK>
ooooooooooooocWooooo0_oVi^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?o
OZgIonk^k_ooool00_ooool00omBBU;oooooooooo`02ooooo`03ono_kooW
inOog]kN00Coc/k>017oa/K6omKFe_oFe]Kog]KFomkNg_oWinOog]KFojfU
YOmkNg_oFTYBof=BF_n<NhCoa/K6oooNmooooooommK_onONi`05oooFk`05
ooo6ioooc]kookgFoonmc_og_LH00_og[Kd01?ogYKGokjFUonNLYOoWW:D3
onnLY@0;onnL[Oo_YJGomiBUonnUYOogU:GomjFeooN]_Oog_LKokjfeoonL
_Oooa/h0ooooooooooooocWooooo0_o^k^h1ogj]f@7ok^k^0Oo^k^h000?o
oooo00?oOZgIooooooooool00_ooool00on][JgoNg]kooooo`03ooooo`05
ooOgmoo_knooinOWonOWiooNg]h00_oFe]H01_o>c/koa/k>olK6a_o6a/Ko
a/k>olkFeP;og]kN013oinOWonONionm_KgoQ7>4oeY2D_mJ@T[oQ7>4okfL
]Ooge^OoomK_ooOFioog_Mkomkg>oonme_ooa]kookGN0_oo_MH05Ooo_Lko
ojg6ooN]_Oo_[KGomib]onn]]Oo_YJGoihbLonNLYOoWS9cogYBUonN<W?o_
YJGokibUooNU]Oog]LKomjFeonnU_Oog[Kgomkg6ooOgm`3ooooooooooooo
>_ooool1ogj]f@7ooooo0Oooool000?ok^k^00?oOZgIonk^k_ooool00ooo
ool01?mcLg?o_KFeooOgmoo_knl2omkNgP;oinOW01Cokno_ooOgmoo_knoo
inOWomkWiooNg]koe]kNolkFe_o6c/koa/K6okg6a_o6c/koa/K6olk6c_oF
c/kog]kNonOWiooWg^Oo_KfmoiBDU0;oHdYB00OoLeYSokFLW?o__MKoonOW
ooNmg_og_Lkokjg>00;omjg600WomkG6oon]a_og_LKomkg6ooNU]Oog[Kgo
mib]onnLYOo_YJD00_oWW:D02OoNU:GoihbDooNU]Oog[LKomjfmooNea_oo
W;gomkg6oooNm`3ooooooooooooo>?ooool2onk^kP7oOZgI0Oo^k^h1onk^
kP000ooVi^H00omn[MWoi^KVooooo`03ooooo`07onOWiomBBU;ooooooooo
ooo_knoog]kNomKFeP02olk>cP03omKFe_oNg]koinOW00?okno_0_oWinL0
0ooNinOoe]kNomKFeP05olk>cP0<omK>c_oFe]KoimkNonOWiooWg^Oog/kF
oibDW?mcFV?oFSU2of]:F_n<Jg?okjfe0_og_LH01_og[KgomjFeooNL[Oog
YKGomjfmooNU]@;omjfm00WomjFeooNL[OogW:gokibUonNLYOog[KgomkG6
ooN]_Oog[LH00_og[Kd00ooginooooooooooo`3ooooooooooooo=_ooool2
onKViP7oOZgI0OoVi^H1onKViP000oo^k^h00omn[MWok^k^ooooo`02ooOg
m`;ooooo00?oBTY:ooooooooool00_ooool00oogmoOoinOWomkNgP03omKF
eP05olk>c_oFe]Kog]kNomkNg_oWinL00_o_knl00ooWinOog^OWomkNgP02
omKNgP05omKFe_o>e/koc/k>olk>c_oFc/h00_oFe]H01_oNe]KoimkWonOW
iooFc/ko_KFeog=JH`;oLdYB00[oU6]colJDW?oW[KGokjFmonN]]OoNU:Go
kib]ooNU]Oo_[KGokib]0oogYKD01?og[Kgokjg6ooN]_Oog]LH2ooN]_@03
ooOWiooooooooooo0?oooooooooooolfooooo`;ok^k^0Omn[MT1onk^kP7o
k^k^0003ooooo`03ogj]fOoooooooooo00;ooooo00GomoOgoooooomSHf?o
kno_ooOgm`05ooooo`06ooOgmoo_knooinOWonONg_oNg]koe]KF0_o>c/h0
1OoFc/kog]KFomkNg_oWinOoino_00Cokno_0_oWinL00ooFg]koc]KFolK>
cP03olkFcP07omK>c_oFe]Kog^OWomkWiooNg]ko_KfmohAkN`02oeY2BP04
ohASJoo>Q8cokib]onnU]@;okib]00[okibUonNLYOo_W:gomkG6onnU_Oog
_LKomjfmoonL_Oog[KgokmkNoooooooooooooc[ooooo0Omn[MT1ooooo`7o
oooo0003onk^kP03ogj]fOo^k^kooooo00;ooooo00KomoOgoooooonLW9co
YJfUooooooogmoL3ono_k`04ooOgmoooooooooooooooo`;omoOg00Gokno_
onOWiooNg]kog]kNomKFeP03olk>cP;og]kN00?omoOgooooooogmoL00oog
moL01?o_knooinOWomkNg_oFe]H4olk>cP03olkFe_o>c/kog]kN00;og]kN
00[o_KfmoiB<S?mJ@T[oFT92og]BF_nULg?oeYbUonn]]OoWW:GokjFm0_oo
[LH01?ogW;goojg6ooNL_Oooc]kooooooooooooo>?ooool2onk^kP7oOZgI
0Oo^k^h1onk^kP000ooVi^H00omn[MWoi^KVooooo`04ooooo`04onOWiomB
BU;okno_ooOgm`;ooooo00Gokno_onONg_oWinOokno_onOWi`02ooOgm`;o
oooo0_ogmoL2ono_k`07omkNg_oWinOoe]KFoiBDU?mSHf?oS8b<omKFeP05
ooooo`06ooOgmoo_knookno_ono_kooNinOoe/k>0oo>c/h01?o6a/Koc/k>
omKFe_o>e]H2onOWi`0<omJma_nLS9CoLe9Jof<i>Om[@T[oW6]colJLYOo_
[LKomjg6ooNmc_o_[Lkomkg>ooooooooooooocSooooo0_oVi^H1ogj]f@7o
i^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ooool01Oooool01OoFe]KoDTYB
ojFUYOo>c/komoOg00;ooooo00CokoooooO_kooWinOoino_0ooWinL04?o_
knoomoOgooOgmoogmoOoooooooOgmoo_knoomoOgoooooooNg]koW9bLohB4
Q?mSHf?oQ8B4okfm_Oo_knl2ooooo`;omoOg00Gomno_onO_kooWinOog]kN
omKFeP02olk>cP06olk6a_nma/Ko_LK6okg6a_o>c/koe]KF0ooNe]H01one
W9coW8B<og=BF_m[@T[oS6=[olJLYOooinL0ooooooooooooocSooooo0_o^
k^h1ogj]f@7ok^k^0Oo^k^h000?ooooo00?oOZgIooooooooool00_ooool0
0oogmoOoooooooOgm`02ooooo`07ono_konm_KgoS8b<og=cLon<S8co_KFe
onOWi`02ooooo`;omoOg0_oWinL2omkNgP;oinOW0oogmoL2ooooo`0:ooOg
moooooooooooono_konm_KgoQ8B4of=SHomkNg_o_KFeomKNgP;omoOg013o
ooooooOgmoogmoOomoOgono_kooFe]Koe]KNolk>c_o6c/ko_LK6okfm_Onm
a/Koc]K>okg6a_oFe]KomoOg0_ooool00oogknooknO_ooooo`3ooooooooo
oooo>_ooool1ogj]f@7ooooo0Oooool000?ok^k^00OoOZgIonk^k_oooooo
ooooooOgmooooooomoOg00Cooooo00[omoOgooooooooooooooooolk>c_nL
W9coNg]kohB4Q?nUYJGog]kN0_ooool01_ogmoOoino_onOWioo_knoog]kN
ono_k`[ooooo00?okno_okfm_On<S8`00_mcLg<01?nUYJGoc/k>ono_koo_
knl2ooOgm`07onONioogmoOoknO_omkNg_oFe]Koa/k>okg6aP02olK>cP03
onoooooooooooooo0?oooooooooooolkooooo`;ok^k^0Omn[MT1onk^kP7o
k^k^0003onKViP03ogj]fOoVi^Kooooo00Gooooo00?omoOgooooooooool0
1?ooool01_ogmoOooooooooooooooooog]kNojFUY@;oNg]k00KoW9bLolk>
c_o_knoomoOgono_koogmoL>ooooo`09ooOgmooFe]KoW9bLog=cLom[Jf_o
U9BDokfm_OoWinOokmkN00;omno_00OomnO_onOWiooNg]koe]KNolkFe_oo
ooookooo00;ooooo00?okoooooooooooool0ooooooooooooocOooooo0_oV
i^H1ogj]f@7oi^KV0OoVi^H000?ok^k^00?oOZgIonk^k_ogmoL00oooool0
0oogmoOoooooooooo`0>ooooo`05ono_konm]KGoS8b<olK6a_ogmoL05?oo
ool01ooNg]koYJFUohAkNomSHf?oQ7]kojf][OoFe]H00_o_knl00oo_inoo
ino_ooOgm`04ooooo`03ooOgmooooooooooo0?oooooooooooolfooooo`;o
k^k^0Omn[MT1onk^kP7ok^k^0003ooooo`03ogj]fOoooooooooo00;ooooo
00?omoOgooooooooool0;?ooool01_o_oooo_LJmohB4Q?mSHf?oJg=[olK6
a_oooooooooooom1ooooo`7oOZgI0Oooool1ooooo`000oo^k^h00omn[MWo
k^k^ooooo`3oooooooooooooM_ooool2onk^kP7oOZgI0Oo^k^h1onk^kP00
0ooVi^H00omn[MWoi^KVooooo`3oooooooooooooM_ooool2onKViP7oOZgI
0OoVi^H1onKViP000oo^k^h00omn[MWok^k^onk^kP3oonk^k_ook^k^N?o^
k^h1ogj]f@7ok^k^0Oo^k^h000?ooooooomn[MWoogj]fGcoOZgI0_ooool0
0?ook^k^ooo^k^j1onk^kP00oooVi^KoonKViX7oi^KV003oonk^k_ook^k^
POo^k^h00?ooOgmoE_moOgl7oginO_ooOgmo9?moOgl00004on_[jooVi^Ko
h^;RomkNgPCogMgM0ooNg]h0oooMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMg@004ooNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oMgMd00_oLg=`0
?OoKfm_ogMgMomcLg?oNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomgMgOoKfm_of][J
omOGeooHf=SoemOGom[Jf_oKfm`00_oMgMd09ooNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNgP03omgMg@3ZomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgM1?oNg]h00ooMgMgog]kNomkNgP03omgMg@7ohN7Q0OoWinL1on[ZjP00
00?ok>c/onKVi_oPh>001ooIfMT01?oHf=Soe]KFom?Cdoo@d=03olg=c@04
om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooCdm?od=3@0oo=cLd0
1?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?Com3@d0?ocLg=
00Cod=3@om?CdooGemOof=SHf_oIfMT2omSHf006omKFe_oCdm?odm?ComCD
e?oGemOof=SH0_oIfMT00ooHf=SofMWIomWIf@02omSHf0WofMWI00?of=SH
omWIfOoIfMT00_oHf=P00ooIfMWof=SHomSHf002omSHf1OofMWI00Cof=SH
omKFe_oBd];oclo?0_o=cLd01?o?cloodm?ComOGeooHf=SoomWIfAKofMWI
00?of=SHomWIfOoIfMT01_oIfMT1omkNgP7oi^KV0Oo/k>`00007onk^k_oY
jNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=codm?ColO7
aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=
omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?o
fm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb
/[;o^k^kolO7aooCdm?ofm_KomoOg`3Ion7Qh@09on3Ph?oOgmoofm_KomKF
e_oDe=Coe]KFom[Jf_oNg]koh>3P00KogmoO0ooPh>000ooOgmooh>3Pon3P
h002on3Ph0SogmoO0_oNg]h2omoOg`?oh>3P0_oOgml2on3Ph0;ogmoO3OoP
h>001OoOgmoogMgMomWIfOoEeMGodm?C00;od];B00?oe]KFomcLg?oPh>00
oooQhN4Hon7Qh@03on;Rh_oQhN7oh^;R00CohN7Q0OoTi>@1onWYj@7okNg]
00000oo`l?3okno_oo7al@03oo3`l03oono_koo`l?3ok^k^onWYjOoKfm_o
`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]
kNgolO7aono_kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2
`_nTY:CoS8b;og]kNomgMgOoNg]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;o
Y:BTohb<S?mkNg_oMgMfog]kNon<S8coY:BTol;2`_oJf][oj^[Zong]kOoa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7a
koo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_000Ooo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_
knoolO7aono_koo`l>kokNg]onc/k?oUiNGoh^;RomoOgooUiNGojNWYong]
j`02onSXj006onKVi_oYjNWoinOWon_[joo/k>cok^k/0ooZj^X02Oo_knoo
k^k^onk^k_oXj>Soj>SVonKVi_oYjNWoinOWon[ZjP02onWYj@0=onGUiOoW
inGoinOWon_[joo/k>cokno_on_[jooZj^[ojNWYonk^k?o/k>cojn_[onSX
j002ong]k@0Donk^k_oZj^[ok>cZonc/k?o^k^koj^[Zonc/k?o]kNgok^k^
on[Zj_o/k>[ok>c/onk^k_n][JgoMgMgoeUIFOm_Kfoo][Jfon7Qh?oWinL2
ono_k`3ooo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aonk^k_oalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_
oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7o
kno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_
kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a000Mono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`l?o_knl01?o`l?000003oo;bl_o^k^koinOW00Co
iNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5
oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@00ooUiNGoi>CTonGUi002
onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5A
DOmVIVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT0?KoiNGUonCTi?oUiNGoi>CT
onCThooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7o
IVIVohZ:R_na/K7odM7AomkNg_oTi>?oi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>Co
iNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGU
i?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGo
i>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCohn?SolK6a_lX:2So
ADE5ohn?SooBd];ofm_KomcLfooFe]H3omGEe@0IomCDe?oJf][ogmoOomoO
g_oIfMWoeMGEomSHf?oOgmoohN7QomgMgOoFe]KoeMGDomCDe?oEeMGoe=CD
omWIfOoJf][of=SHomGEeOoFe]Goe]KFomWIfOoMgMgoh>3Pom_Kf`02omKF
eP09omgMg?oLg=cof=SHomGEeOoLg=coh>3PomoOgooJf][ofm_J00;ogMgM
0?oofMWIomcLg?oOgmooh>3Pom_KfooJf]WogMgMon3Ph?mcLg?oJ6QXohf=
SOmDE5Co20P8oj>SX_oKfm_ohn?SonCTi?oUiNGoi>CTonGUiOoTi>CoiNGT
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>@002GoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGU00;oi>CT1?oUiND01_oTi>CoiNGUonGUiOoUiNGoj>SXong]k@7ol_;b
00000oodm?CokNg]onOWi`02on3Ph00Con7QhOoOgmoog]kNom;Bd_nd];Co
QhN7oeaLG?m]>cGoWTi2ole_GooYPfoocFmOoii>@om]>cKoG5aLohN7Qond
];Cod];BomkNgP05on3Ph00AomkNg_oBd];o];BdohN7QomLG5coKF0/oijF
;_o=cCoojNU=olg=?onNVRooKF<]oeaLG?n7QhOo];Bdom;Bd_oNg]h01OoP
h>004OoNg]kod];BokBd]?n7QhOoG5aLodMW;_mXWS?oTLe7oj[YEOnAcDOo
JYhdodUZ;omLG5coQhN7okBd]?oBd];og]kN0=Soh>3P00KogmoOolo?conI
VIWoTY:BoaTI6On<S8`2omGEe@0Oolo?coo2`/;oc/k>olk>c_o5aLGob/[:
om[Jf_oHf=Sod=3@ol_;boo?cloof=SHom[Jf_oEeMGoclo?ol71`Oo@d=3o
c/k>olC4a?o;bl_of=SHomOGeonn_[ko^k^kom7AdOo@d=3oeMGEomSHf?oC
dm?oc<c<olk>cP02omGEe@05olk>c_o<c<codm?Com[Jf_oHf=P00_oBd]80
1?oHf=SoemOGom7AdOoCdm<2omWIf@06om?CdooAdM7oemOGomSHf?oAdM7o
d=3@0_oAdM401?m6ATKo@D51omOGeooNg]hXon3Ph003omoOgooPh>3oh>3P
00?oh>3P00?ogmoOon3Ph?oPh>00i?oPh>000ooOgmooh>3PomoOg`02omoO
g`?oh>3P00?ohN7QonOWioo/k>`00Oodm?@00003ooKfm_obl_;ojn_[00?o
j>SX01?oinOWon;Rh_o=cLgoWinOof]OGon?=RkokG5QooVMT?om/JGooKb_
oofdYooiWi?okGASoi8g;om[GeooWinOolg=cOoRh^;oinOW00?oj>SX01?o
inOWon;Rh_o=cLgoWinOofiVGonCLR;okM54ooWcM?omoHgooOfEoogmS_oi
n7KokMM7oi=c8_m^IeooWinOolg=cOoRh^;oinOW00?oj>SX01?oinOWon;R
h_o=cLgoWinOof1XGom;O2?oT^5;okgiNoo@oI;of?fKomCmUOo0nGkoV>Q=
odf09?mPJEooWinOolg=cOoRh^;oinOW0=Woj>SX00Coi^KVon7QhOmMGEgo
CDe=0_oMgMd07om@D53o1`L7oaDE5On4Q8Co5QHFod=3@ooRh^;ogMgMoibL
W?l0003oShn?omgMgOoQhN7ofm_Kod10@?l820So6ATIohR8R?l;2`_oF5QH
okNg]ol<30co1`L7ob<S8olW9bOoOGemom[Jf_oMgMgoe=CDo`/;2omIFET0
0_oIfMT00omMGEgo2`/;om?Cd`02omoOg`06oeYJF_m>CTkog]kNomkNg_lS
8b?oQ8B40_oQhN403?mjNW[o;Rh^omgMgOoMgMgo`/;2oe1@D?lc<c?oKVi^
oh>3PolQ8B7og]kNonKVi_ooj>SX7ooXj>P1onc/k07ol_;b0Oofm_H00003
ooOgmoohn?Son?Sh00?on?Sh01?omoOgonk^k_o>c/koT92@ohD_:ooYI5Ko
ni:7oojVVoon/JGookR[oojcY_onZ9coniB9oniXFOn9<B_oT92@olk>c_o^
k^komoOg00?on?Sh01?omoOgonk^k_o>c/koT92@oiUY:oo`_Cgonn1^ookd
P_onoX[ooonBooknS?onn8?onnE`oo32?_nIJR_oT92@olk>c_o^k^komoOg
00?on?Sh01?omoOgonk^k_o>c/koT92@od9c:on4cT?o[Nmcol;nR?o>oY3o
e_nGom3nT_o6oXWo/_EdohSC@om4MB_oT92@olk>c_o^k^komoOg0=Won?Sh
02Gom_Kfoo7alOn1PH7o7alOong]kOo6a/Ko0000ol?3`ooCdm?oG5aLo`P8
2?oZj^[ol?3`on[Zj_mBDU;o51@Docdm?OoYjNWol?3`ojn_[ol71`Ood];B
olg=cOm>CTko6a/Konk^k_oKfm_o[Zj^onSXj?o/k>co[Zj^o`000?nd];Co
k>c/ok2`/?l;2`_o6QXJ00;oi>CT00_o8b<So`h>3_nTY:CokNg]onk^k_mP
H63oE5ADonk^k_o]kNgo9RHVohf=S@02oo3`l00<oh:2P_la<C7ok>c/on[Z
j_m3@d?o;bl_oibLW?mcLg?o:RXZoaXJ6_o^k^kom_Kfooohn?PHooShn003
ooOgmoohn?Son?Sh00;on?Sh00ComoOgooWinOogmoOomoOg0Oohn?P00003
oo[jn_oemOGok^k^00;ok>c/0?oojn_[onWYjOoOgmoo^[ZjogUBD_no<RCo
igAYoof9O_ooV8cooZ:FoonXW?onY9SooiZ=ooj:Ooo^MV[o`c<TogUBD_nj
^[[ogmoOon[Zj_o[jn_ok>c/on_[k?oZj^[ogmoOokZj^_n8IE;ohY4LooW3
D?omfV?oonYbookcO_oonX;oo_Ioooo/LoongVCon/MAon:B7?n9IU?o^[Zj
omoOgooZj^[ojn_[onc/k?o[jn_oj^[ZomoOgonj^[[oDVeBoe6S7?nAdUGo
Y^MZokSiN_o0oX;oaon9ol?nQ?nioG_oYna/oiCFEomBYQcoDVeBokZj^_oO
gmooj^[Zon_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jnco
k>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[
jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jn`004Cok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[jooZj^[oi>CTogYjN_lL71coh^;Rol_;
c?l30`?oWinOomoOgonDU9Co4a<Con3Ph?oQhN7od=3@o`H61_nQXJ7o2@T9
okjn__oRh^;o^KVio`820_na/K;og]kNoh20P?lY:BWoh^;RonSXj?oTi>Co
gmoOom[JfooDe=Co20P8ohJ6Q_oOgmooJVYZodU9BOle=CGo[:b]okjn__l7
1`OoN7QhoeEEE@;ogmoO00KoFe]Kodm?D?oRh^;oh>3Pob@T9?n4Q8@2on3P
h03oog]kNol_;boohN7QomCDe?l51@GoYjNWonCTi?oRh^;oOgmooaDE5_oR
h^;ojNWYonc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_o
k>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[
jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[
onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/000Ron_[joo/k>co
jn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k0Kojn_[00Go
k>c/on_[joo[jn_ok^k^ooKfmP01ooWin@0000?ono_koo?cloo]kNd00_oU
iND0oooVi^Koi>CTomWIfOnb/[;oNBh^olQ2=?oSJUcom7Y]oof8O?onUh[o
oY^>oojHRoonRWkom7]]onM[GOo:@SCoNbh^ok:b/_oHf=Soi>CTonGUiOoV
i^KoiNGVonCTi?oHf=So/[:boiIE;_oZW2_onka4ook<Doomf6;oo^=bookY
MOoniW?oo]]Uoog<Dook`DGokYh[oiUF;_nb/[;of=SHonCTi?oUiNGoi^KV
onGUiOoTi>Cof=SIok:b/_l^HRkoHjd[ohO:B?nGg5WoYNEYok;cMonhmW_o
]?EiojOZJonHg5WoRLm;of>^:ol^Hbko/[:bomSHfOoTi>CoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oU
iNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUiP009OoVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonCTi?oNg]koMgMgoa/K6ooLg=coh>3QoijNW_l^;Rko:b/[oc8b
<_lB4Q800_oKfm/09On4Q8Co8B4QomoOgomCDe?oIfMWom_KfooMgMgoT92@
obTY:_l_;boo;2`/obPX:?oMgMgogmoOomSHf?oDe=Coclo@oe]KFol0003o
_[jnomWIfOlX:2SoQXJ6ogQhN?mXJ6SoPX:2oc`l??o3`l?o3`l?omGEeOoI
fMWoFEUIodi>C_oMgMgog=cLob<S8on1PH400_oFe]H0>_mgMgOo;Rh^omgM
gOnRXZ;o0000olK6a_oIfMWof=SHohj>S_lE5AGogMgMon?ShooVi^KoiNGU
onKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oTi>D2onGU
i@3TonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGo
i^KVonGUiOoVi^KoiNGU0ooVi^H00ooUiNGoi^KVonKViP03onKViP03onGU
iOo]kNgom?Cd007on_[j00000oolo?con?Shoo7al@03onk^kP0Con_[jooQ
hN7o_;blogXG5oo3?c;odeI9onAXF_o_Mfcom8=iooR7O?oeQ7[olgU]onEY
FooIF4[oa3lbog`G5onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;bl
ojE75ooVUc;omJ``oofl@OombE?ooM1Poo_CIOomdV3oo/eDoofm@_oj[c;o
jI/bojE65onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;bloaMI5omO
Z3;oM[dgohK=AonFeU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg_cOoGj/boaMI
5onl_;cohN7Qonc/k03Ionk^kP0^onc/k?oWinOoNg]koa`L7?oTi>CojNWY
onKVi_oQhN7og]kNohf=SOlD51Coi^KVonCTi?le=CGoNGUion_[jonb/[;o
5ADEomoOgooVi^Koi>CTon7QhOoMgMgoNWYjobTY:OoXj>SoiNGUomgMgOna
/K7o9RHVo`/;2onKVi_ojNWYolc<c?l0003oc/k>ol?3`olU9BGoBd];ogal
O?oXj>So<C4aojFUYOoTi>CoGEeMoe5AD@;oinOW00[o9BDUofUYJOoOgmoo
gmoOogMgMola<C7ojNWYol71`Ol0003oYjNW0_oOgml01?nCTi?o5QHFonOW
ioo/k>coonk^kQkok^k^00?okNg]oo;bl_ohn?P00Oolo?`000?ooOgm01Ko
o?cloogmoOomoOgoo?cloo?clooAdM7oJ0L7okPd=?o7?c?odU13omYREOoS
KV;oi79TonA_H_oLI5Oode53ola1=?ni=3CoJ`L7om;Bd_oclo?oo?cl0oom
oOd04oolo?colo?com;Bd_nN:`OofXXdon^K6OoeZ2Won;@oooVmB_oh_dgo
n[m:ooVh?oofZR[okihIom^;=?nR;@Ood];Boo?cloolo?`00oomoOd04ool
o?colo?com;Bd_l7@0OoCIXdoen[8?m`^2ooOl=3oh[=D?n=cE;oR/i@oh77
A?ma^BooHZhPodjK=?l7@POod];Boo?cloolo?`0fOomoOd08ookno_omoOg
ohB4Q?lN7Qkolo?cooWinOnc/k?od=3@oo?clomXJ6SoAdM7oo[jn_oDe=Co
0000omgMgOolo?cono_kobLW9onXZ:SonOWioj^[ZooEeMGolO7aoeADE?mN
GUkonOWiooCdm?nDU9Co1@D5od10@?oAdM7omoOgooShn?nGUiOo:b/[00;o
n_[j01_o92@To`L71oo8b<Sono_kohF5QOmSHf?omoOgof=SHomGEeOon?Sh
ooWinOlW9bOo5ADEoh>3PooGemOo@T92of=SHookno_on_[joc@d=?m9BDWo
fm_KonGUiOm?Cdoo5aLGoo[jn_olo?`0ooomoOdLoogmo@03ooclo?omoOgo
o?cl00?ooOgm0000>_omoOgon_[joo?cloo^k^kol?3`ono_koo^k^kojNWY
om?CdomK7AgoXS@dok@X7Oo1>RgoadTlolmFB_o@Ed_od5M:olY:?_o3>bko
]RPMoj8d=?mL7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>ook^k^on[Zj_oC
dm?oS2DMolQa=?oIQ1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/X2GoiiLEomb8
7Oo8LCCoS2DMom?CdooZj^[ok^k^oo3`l?o_knool?3`onk^k_oZj^Wodm?C
oadh7OldPSCoAiDMoeZU6omY[BX2ogBh>03oogFi>?m[/B_oFjLLodRJ7Old
PSCo7CPMom?CdooZj^Wok^k^oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_
koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`
ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o^k^kojn_[ogemOOlL
71coinOWonk^kOn8R8So<30`o`h>3_la<C7o/;2`ono_kon4Q8CoCDe=onk^
k_o_knook^k^ohZ:R_mIFEWokno_ogQhN?l/;2_o3@d=ocPh>?nn_[kok^k^
on?Shol>3PkoJFUY000:on3PgooRh^;oi^KVon[Zj_mQHF7oMWIfono_koo^
k^koMgMfobHV9P;ok^k^01KocLg=ob`/;?o[jn_oK6a/of=SH_o[jn_ok^k^
ocXj>_nDU9CoHV9Ro`h>3_ld=3Coa<C4onk^k_o_knoodM7Aoc`l??l:2P[o
9bLWofa/K?l/;2cok^k^0_o_knl0ooo`l?3okno_oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knoo
l?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_
oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>oo
kno_oo3`l0005?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`
0_o_knl2oo3`l0Kokno_0Ooclo<1ooWin@7oo_kn00000oono_komoOgoo3`
l004onWYj@0AonOWiooKfm_oHd];oh4b<_nV=CGo]S@]ol9=@Oo3E4Woa5E:
ol=DBOo2CD7o]S@]ojDe=On1<S;oHd];om_KfooWinL01OoYjNT04OoWinOo
fm_KohU;Bon_Bc;ocGLeomJ;;OoPW2koh:0bon6P=?oPX3;ogiX^omJ;;Oo:
MCGo[d/bohU;BooKfm_oinOW00GojNWY017oinOWom_Kfom;Bd_o<V0bocZ9
=OmCVbgoJj/_og2]>?m_[S[oL:dhofZZ;omCVbgo>HPeoc9P<_m;Bd_ofm_K
onOWi`3JonWYj@06onSXj?oVi^KoNg]koa`L7?oTi>Coj>SX0_oYjNT00ooW
inOojNWYonWYj@0;onWYj@0<onOWiooYjNWojNWYonSXj?oHf=So2PX:ojj^
[_oMgMgog]kNon3Ph?oUiNGoj>SX2?oYjNT01_oXj>Soi^KVon?ShooShn?o
i^KVonSXj0?ojNWY00?oj>SXonWYjOoYjNT01?oYjNT00ooWinOojNWYonWY
j@0[onWYj@03onSXj?oYjNWojNWY0>cojNWY00?oj>SXonWYjOoYjNT01?oY
jNT1oo3`l07om_Kf0Oono_h00005ookno_ojn_[om?Cdono_kooalO400_o`
l?004Oo_knoojn_[oiFDU?m?8b?oUEADok]cLooCUIGofYbLomZNW?oIW9co
e9FEok]cLonEE5CoCb<SoiFDU?oZj^[okno_00Gol?3`017okno_on[Zj_nY
U9CoPB<SokYZE?oDVW?oi;bEon[7W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S
8onZU9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oU9BDob<Z8omDNUCoLjEc
oik6UOn/cYco[LjLojc>W?nNaYGoLjEcoeAjE?lS:R?oU9BDon[Zj_o_knl0
f_o`l?02ono_k`04oh20P?lM7Agok^k^ono_ka?ol?3`0_o_knl01omTI6Co
:BTYoh61POmSHf?o>c/konk^k_o_knl02?o`l?001_o_knook^k^og=cLomY
JFWok^k^ono_kckol?3`00?okno_oo3`l?o`l?00joo`l?001?oalO7ol?3`
ooCdm?ojn_X1ooknoP0000CooOgmooooooooooooo_kn0_ooool2ooknoP3o
oogmoOohn?SoKVi^oeXo?onaT93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93o
FSloofe]KOohn?Soo?clooooooono_koooooookno_ooookoo_knoooooool
o?con?Shohe]KOn:?coobI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo
?on=KFgon?Sgooclo?ooooooo_knooooooono_koooooookno_ooookoo?cl
ooShn?m]KFgo?clooi2MT?o9eLWoi>cTonK^i_oTk>CobMG9oi2MT?lo?coo
KFe]ooShn?olo?coooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_kn000Gooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooool00_ono_h06?o?
clooYZJVoogmoOooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooo`;oo_kn00ko`<30og5aLOn0P83o/;2`oogmoOooooooo_knooooooon
o_koooonookno_ooooooo_knooooo`;oo_kn0?oo`L71okfm_?omoOgooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_h002Woooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knoooo
o`02ooknoP05ooooooono_koooooooooooono_h01Oooool1on_]k`0000Co
mOKfookno_oinOWom?Cd1OoalO403Oo_knooe]KFof][Jom3?CgoVhb<olJj
^_oFc<coakZjoi^<S?m3?CgoJf][omKFe_o_knl02OoalO403Oo_knooemKF
oh=[Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<S?mb?CgoPF][omOFe_o_knl0
2OoalO403Oo_knooe]KFof][Jolm?CgoS8b<okZj^_o<cLco^[Zjohb<S?lm
?CgoJf][omKFe_o_knl0oooalO55oo7al@03oo3`l?oalO7olO7a0>[olO7a
00Col?3`oo7alOoalO7ol?3`1?oalO400oodm?Con_[jooknoP01oko5c000
00Goi^OXoogmoOohn?Sol?3`on_[j`03on[ZjP0=onWYjOoZj^[ojNWYonSX
j?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0;on[ZjP0;
onWYjOoXj>SoX9^KofYIFOm39RKo;@T9od8V9_mYFEWoX9^KonSXj?oYjNT0
2ooZj^X02ooYjNWoj>SXoi^KVomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooX
j>SojNWY0?ooj^[ZoooZj^Xkon[ZjP04on_[joo`l?3on?Shoogmo@7oPH^E
00001?nm_[oonO[joo[jn_oclo<8oo7al@;ol?3`0oo_knl2oo3`l0oolO7a
0_o`l?03ono_k`;ol?3`3ooalO42oo3`l0?okno_0_o`l?3ooo7alOoolO7a
>OoalO400oo`l?3olO7aoo7al@02oo7al@03ooGemOojn_[o]kk3007o<d5<
00000oo9b/_oaLK7oo[jn`3oooooooooooooNoooool1okVo``7oCEMP0OlN
;3X00006oa8M9_lA6B7o:30gogMnPonh_;oojN[[ooooooooooooogGooooo
00Goj^c]okc2a_mmQXko<3]5oa/X<`01oal_>`00\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{639, 481},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
If there exists a selected node, names of its parents and path is \
constructed as follows.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(p = tree@getLastSelectedPathComponent[];\)\), "\[IndentingNewLine]", 
    \(If[p =!= Null, \[IndentingNewLine]s = 
        p@toString[]; \[IndentingNewLine]Print[
        p@toString[]]; \[IndentingNewLine]While[\[IndentingNewLine]p@
            isRoot[] === False, \[IndentingNewLine]p = 
          p@getParent[]; \[IndentingNewLine]s = 
          StringJoin[p@toString[], "\</\>", s]; \[IndentingNewLine]Print[
          p@toString[]];\[IndentingNewLine]]; \[IndentingNewLine]Print[
        s]\[IndentingNewLine]]\)}], "Input"],

Cell[BoxData[
    \("QuickTime"\)], "Print"],

Cell[BoxData[
    \("MacOS X"\)], "Print"],

Cell[BoxData[
    \("Apple"\)], "Print"],

Cell[BoxData[
    \("Apple/MacOS X/QuickTime"\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(ReleaseObject[s0]\), "\[IndentingNewLine]", 
    \(ReleaseObject[s1]\), "\[IndentingNewLine]", 
    \(ReleaseObject[s2]\), "\[IndentingNewLine]", 
    \(ReleaseObject[s3]\), "\[IndentingNewLine]", 
    \(ReleaseObject[s4]\)}], "Input"],

Cell[BoxData[{
    \(ReleaseObject[h0]\), "\[IndentingNewLine]", 
    \(ReleaseObject[h11]\), "\[IndentingNewLine]", 
    \(ReleaseObject[h12]\), "\[IndentingNewLine]", 
    \(ReleaseObject[h21]\), "\[IndentingNewLine]", 
    \(ReleaseObject[h22]\)}], "Input"],

Cell[BoxData[{
    \(ReleaseObject[icon1]\), "\[IndentingNewLine]", 
    \(ReleaseObject[icon2]\), "\[IndentingNewLine]", 
    \(ReleaseObject[icon3]\)}], "Input"],

Cell[BoxData[
    \(DeleteJObject[scrl, tree]\)], "Input"],

Cell[BoxData[
    \(DeleteJObject[pane, scrl]\)], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["<<< SimpleJTree >>>",
  FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006O0001I1P00`40o`00
0?l0003oo`000:0000000003R<2hB928B9280?m8T8RLB9280@00000000>8
`;S8h=R8`;P0ohS0^9^8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^9^8
`;P1B9280@00000000F8`;S8h=R8`;R8`;S<c<`0oooooiOoool2R<2h0DR@
R04000000006R<2hb>3HR<2hR<2hIVIVc<c<ofIVIYEVIVH01?ooohS0^8S0
^4R@R04000000005R<2hb>3HR<2hR<2hIVIV0?oooonEoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0oooooiGoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP3oooooUOoo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oo
oonEoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH0oooooiGoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP3oooooUOooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV0?oooonEoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH0oooooiGoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP0Qoooo00?_moOoooo_moL00_ooo`03
koOgoooooooo00;oool00nogmoooonogm`02oooo00?_moOoooooool0oooo
of;oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP0Koooo00?_inOgmno_inL06noWi`04e]KWknOWknOWe]KW1^oWi`03koOg
oooooooo0?oooom?oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH06_ooo`0>moO_g]kNc/kN_Kfm]Kg>c/Je]Kg>c/Je]Kg>
c/Je_Kfm]Kg>c/Je]Kg>0kfm_@07c/k>_Kfma[fm]Kg>c/Jea[fm]Kg>00:m
_Kd01LJm_KFmc[fm_LJm_KFmcP03_Kfm00W>c/jm_Kfm_Kg6_Kfe_Ljm_Kg>
c/k>e]k_inL0oooooe3oool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP0Joooo00GNg]k>c/j][JF][JFLW:D04IbLW003W9bU
[JFDW9bU00:LW9`01jfUU9bLYIbLW9bLW:f]YIbLW9bLY@02W9bL00>][JFL
W9bLW9`00Zf]Y@03c/k>g]kNkoOg0?oooom?oooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06_ooo`03knOWg]kNoooo02Ko
ool2g]kN00?_inOoooooool0ooooodgoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP0Joooo00?Ng]k>e/koool04oooo`03
moO_oooooooo00;oool01NO_moooooooooooonoWi`02oooo00?_inOooooW
koL00_ooo`04koOgooooinONc/k>oooooe3oool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP0Ioooo00?WkoOWimk>e]h00_oo
o`03koOgoooooooo00_oool00nogmoooooooo`03oooo00?WkoOoooooool0
2_ooo`07knOWoooooooooooog]kNc]KNknOW0?oooom?oooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06_ooo`03g]kNg/k6
oooo017oool00nogmoooooooo`02oooo00?gknOoooooool00_ooo`04inog
ooooooooinog1Oooo`05knOWooooknOWc/k>koOg0?oooom?oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06Oooo`03moO_
imkNc]KN00koool00nogmoooooooo`04oooo00?gmnooooooool02_ooo`03
koOgooooinog00;oool00mkNg/kFc^oWi`3oooooCoooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01[oool00mkNg/k>c_oo
o`03oooo00[_inO>c/k_inO_moOooooWkoOoooo_inO>c/k_inL2oooo00?_
moOooooNg]h01MkNgP06e/kFQ7]cW6]S[G]Sc[fUU8b<0ZekH`0:_Kfmc/Je
g]k>c/Je_Kf]inogoooog]kNc/k>koOgooooodooool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0Joooo00CFe^ONg/koooo_
inL2_Kfm00G>c/jLW9b]]KG>c/k_moL00Zf]Y@:LW9`07Hb<S;fm_Jf]YNoW
ioooonOWg^oWioOgknoWioO_inOWg]k>aU9:@W/@28@H4:ekHiA2<G<H49`a
8LjUQ=kNc^oWc]kNc/k6]NoWioooomkNg/kFg^oWi`3oooooCoooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01Woool00oOg
knOWg/kFgP02oooo00?Fc]KNg]k_inL00]kNgP07knOWooooe]KWknOWc]K>
g]kN_Kfm00;Ng]h2oooo01S>c/j4U9BLW:FLW9akQ8A[Lg=JJf]:61Qc612L
<B64>C5S61R48ARULeZ]Nf>LW:FLQ7^DS6>]]KGgmnooooo_inO>c/k_moOo
ooooCoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV01[oool00mKFimK>e_ooo`07oooo00?_moOoooooool00_ooo`03inog
oooooooo00;oool03]k>aXb<S8b<S6][Jhb<S:fUU6][Je8826/a:I`a8Jek
Hh@H48@Q66/a:@9:DUX025YJFU9:@V]cLnoWioooomkNg/kFg^oWiooooom?
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
6_ooo`05g]kNc]K>oooomnoW[KFe00:m_Kd01kFmc[fm[NoWilk>cZf]YNoW
ijfe]@02_Kfm01?Ng]je_Lk>a[Goooo>e]jm_Kf][JFLU8b]YIC>a[EkLf<H
411B20R]Nf><JdZ48AQk<BUB>C4Y:BT00cTi<@06FUY2knOWooooinONc/k>
koOgooooodooool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP0Ioooo02g_moOWimk>c/koooo_moNm_Kf][JG>c]k>a[G>c/k_
inO>c/jm_Kg_inN][JFm_Kg>c/kNg]k>c/j]]KGooooNg/jm_Jf][JFLW9b]
W8C>_JEcJf<Q611BBT9S@SU:<BUB>C5B>BUkNg]kQ8AJFUY:DSU:BS5:DSW_
inOooooFe^O>e/k_inL0ooooodooool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP0Joooo00SNg]k>e]koooooooo_moOoooo_
inOWkoL5oooo00?_moOoooooool00_ooo`09knOWooooc/kN_Kf]_KfmU8b<
Lg=J[Ib4Lf]S009B>C403d8Y8E8i<EY2>E8i<Hb<Lhb<S7]kNf]SDV][BUYS
F^oWioooonOWg/k>g_Ogk`3oooooCoooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV01Woool2knOW00?Fc]Koooo_inL00/k>
cP09W9bU[JFD]Kg>c/Jeg]kNc]KNc/k>g]kNc]KN00;>c/h03<Jm_LkFg_oo
olk6]Hb<S8b<LeYJ@Xb<S<k6]G=[He9:@S4H409B>C4017=JDU8i<EYJ@W]c
H`9[JdX01eYJ@V][B^oWinogmnoWilkFc^oWi`3oooooCoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01[oool01]kNg/kF
c_ooooooojf]YJfe]@Bm_Kd01]kNg[fm_Lk6]LkFg/k6]Jfe]@:m_Kd04Jf]
YOooojfe]DY:BU9:@V]SDXb<Lib4NeYJFU8i:D8Y8F]:@UYJ@W=JDV=JBRTY
63Ti6002FU8Y00Hi>AQkHd[_inOooooNg]k>c/koooooD?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01Woool01^ogmnOW
g/k>c_ooonogmnoWi`Woool07^oWinOWg_ooonogmnoWioooojf]YBTa:BTY
64Y::JfUU<Jm_CTi<D8Y8E8i<E9:@W]JBV]SDUY2>BTY64Xa:DY::G=cFTXa
:E9S@]KFioooonOWg/kFg^oWiooooom?oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH06_ooo`0:g]kNc]KNooooknOWc]KN
g]kNc/k>g]kNc/k>knOW0/kFgP0PknOWg]kNc]KNc/k>e/kFknOWc]KNkoOg
[JFD0000:BTH>B4HW9B<c/J]Ng=S:BTH@RTQ[G]SU6]JJc4Y>CTH:BTH<CTQ
BTXYBTXa>CTHBTXaknOWkoOgknOWc/k>koOgooooodooool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0Ioooo02g_moO_inO>
c/kooooNg]jm_Kf][JF]]KF][JFLW9bea]J][JFm_Jg>e]k>c/jLW:F][JFm
_Kg>e/jm_Kg_inN][JD@000Y:APa>B6m_JgNc[f<S7<Y:AQcFU:]Nf?6[Ib4
Ng<a>B4H410i>AQ:DSU:FT8Y:BTi@S7_inOooooFe^O>e/k_inL0ooooodoo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0I
oooo0^oWi`03c]K>oooooooo00?_moL01?OgklkFg^OWg^oWi`K_moL3oooo
01R][JDY:APY:APY:AR<S7?>_JE:FT8Y:APi8AQkHdZ<JdYJFT8i@S4Y<BTY
8@Q:DSV4U9AkQ8AJHe[_inO_moOWimk>c]kgmnooooooCoooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV01[oool00mkNg/k>
g_ooo`04knOW00CFe^O_inOWimkFe^L6knOW00GFe^OgknOooon][JDa>B40
0TYJ@P09U8aS_Kf][KFeJg=c4108>B4H<AP@610@FV][009JHeX02F=cS:fe
]IbegZFec^oWinogmmkNg/kFc^oWi`3oooooCoooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV01[oool01]kNg]kNc_ooolkF
g[fm_KF][@:][JD05Hb<S;Fmc[fm[IbLYJf]YJfe]Kfm_Jf]YJfe]Jf]YNO_
moooolk>cV=cS7^4Q6]SDW]kNkfm[JfUU8b<S2TY:@02000000e:DUZL]MjU
]LjL]MjU_MjL]NNea]JL]Mk_inOgmnoNg]k>c/k_moL0ooooodooool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0Joooo00GN
g]k>e]koooo_inONg]h00^ogm`03knOWc/k>koOg00;_inL00lk>c^oWilkF
gP02knOW00CWkoOgknOgmnoFe^L2W:fm00JLW:F][JFm_Kfe_Ljea]JU]Lh2
Hg><1YbegP07W;GWYKG>knOWoooog]kNc]KNknOW0?oooom?oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH06Oooo`;_inL0
1LkFc_ooonoWinoWinogm`02knOW00>]]KG_inO_moL01NoWi`05inogmnoW
inogooooc]KN00:]_NL00jg6mib]_Lk6[@03W;GW00F]a^nL]NNL]MjL]MjL
]NL01IbegP05c]KNkoOgg]kNc/k>koOg00_oool00`000?ooooooo`06oooo
0`0000Coool01@000?ooooooooooo`000004oooo0`0000?oool01@000?oo
ooooooooo`000002oooo00@0003oooooool00003oooo0P000003oooo0000
oooo00;oool20000ooooo`koool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP0Joooo00SWimk>c]koooo>e]jLW9c>a[Fe_Lj]
]KD2[JfU00>LW:F][JFLW9`00/k>cP0@[KFe[JfUS8b<c/k>oooo]LKFW:gN
W;GNW:gNW:fm[JfUW:gNW:g>W;GNW:gNW:g>0Yb]gP06W:g>W:gNW:gNW:g>
W:gNW:g>0^oWi`03g]kNc]K>knOW00_oool00`000?ooooooo`05oooo00D0
003oooooooooool000000oooo`050000oooooooooooo000000?oool01@00
0?ooooooooooo`000002oooo00D0003oooooooooool000000_ooo`040000
oooooooo00000_ooo`030000oooooooo00800002oooo00@0003oooooool0
003ooooo3Oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV01Woool02>ogmmkNg]kNc_ooonoWilkFg^oWioOgk`?_inL01LkF
g^oWinOWg]KFinoWi`03g]kN00G_inO_moO_inO>e]kNg]h00/kFgP04g/k6
e]KWg]kNe]KW0/kFgP03g]kNc]KNc]KN00C>e]h01KG6e^oWioOgklkFg/k>
cP0<oooo00<0003oooooool01Oooo`050000oooooooooooo000000;oool0
1`000?ooo`000?ooo`000?ooo`000002oooo00<0003oooooool01?ooo`0;
0000oooooooooooo0000oooo0000oooo0000oooo000000;oool01@000?oo
ooooooooo`000002oooo00<0003oooooool0ooooo`koool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP0Joooo0]kNgP0>oooo
knOWooooooooe]KWc/k>knOWmoO_oooomoO_inogknOW_Kfmg]kN0_ooo`0:
inogknOWkoOgooooknOWoooomnoWooooinogkoOg0^oWi`04ooooknOWinog
moO_0^oWi`03g]kNknOWkoOg00;_inL00mkNg/kFc^oWi`0;oooo00<0003o
ooooool01Oooo`050000oooooooooooo000000;oool01`000?ooo`000?oo
o`000?ooo`000002oooo1@0000;oool02`000?ooooooooooo`000?ooo`00
0?ooo`000?ooo`000003oooo100000;oool00`000?ooooooo`3ooooo3_oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool:c<co2?ooo`;_inL04<kFg_ooonogmjf]YKfm_Lk>cXb<S:f]YKFmc^oW
iibLW:f]YHb<S8BDU9B<S:fe]@:][JD02Lk>c^oWinO_mmkNgYbLYLk>cZfe
]Jf]YIbLW002c/k>00RLW9cNg]j]YIC>c]j][JFLW:F4U9C>e/h2knOW00C_
moO>c]k>c/k_moL;oooo1@0000?oool01@000?ooooooooooo`000002oooo
00L0003oool0003oool0003oool000000_ooo`050000oooooooooooo0000
00;oool02`000?ooooooooooo`000?ooo`000?ooo`000?ooo`000006oooo
00@0003oooooool0003ooooo4?ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0@oooo00GNg]k>
e/koooo_inO>c/h00mkNgP0:c]KNknOWknOWg]kNc]KNc/k>e/kF[KFeg]k>
c]KN0/k>cP07ooooknOW[KFeS8b<_Kfm[JfUg]kN00;>c/h02MkNg/k>c]kN
g/k>c]kNg]K>e/kFc/k>c]KFi`03knOW00?Ng/k>e]k_inL02oooo`030000
oooooooo00;oool010000?ooooooo`0000?oool00`000?ooo`000003oooo
00L0003oooooooooool0003oool000000oooo`030000oooooooo00800002
oooo00L0003oool0003oool0003oool000000_ooo`050000oooooooooooo
000000;oool010000?ooooooo`000?ooool=oooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013o
ool01>OWg/kFg_ooonogm`?oool01NoWioooonO_moooooO_i`03oooo00S_
inO_moO_inOoooo_inOooooNg]k>c/h2g]kN00[_inOooooWkoOoooo_inOW
koOgknOWkoO_inOWkoL4knOW00GFe^O_inO>e]kNc/K_moL02oooo`030000
oooooooo00;oool010000?ooooooooooo`<00002oooo00D0003ooooooooo
ool000000oooo`030000oooooooo00<00003oooo00@0003oool0003oool2
00000oooo`800003oooo0`0000Coool20000ooooo`koool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool04?ooo`05e]KWc/k>ooooknOW[JfU00:]]KD02Kfm_Jfe]MkNg[fm_Jfe
]NOWgZf]YKFmcZf]Y@02c/k>00Ne[Jfm_Kf]]KFLW9b<S8bm_Jg>c]h00Zfe
]@:][JD01/k>g[fm_Jf]YKfm_Lk>cZf]Y@:]]KD2[JfU00G>c/k_inO>e/k>
c/kWkoL02oooo`030000oooooooo00;oool00`000?ooooooo`0Koooo0P00
00?oool20000oooooa[oool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03oooo`08moO_inONg]kN
ooooknOW[KFe[JfUc/k>0[fm_@04g]kNc/k>[JfUe]KW0Zf]Y@06c/k>g]kN
_KfmW9bLc/k>a[fm0[fm_@0:c/k>g]kN[JFD[KFec/k>_Kfmc/k>[JfU]Kg>
c/k>0[fm_@06[JfUc/k>_Kfm[JfU_KfmknOW0/k>cP03moO_oooooooo00Wo
ool500007_ooo`030000oooooooo00?oool00`000?ooooooo`3ooooo6?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0@oooo00CFe^O>e/koooo_moL3knOW00KNg]kooooo
ooo_inOoooo_moL2knOW00KoooogmnogmnoFe^OgknOWkoL2moO_00?WkoO_
moO_inL00^oWi`06inogknOWg]kNinogknOWc]KN0noWi`07e]KWg]kNg]kN
inONc/k>c]KNknOW0?oooom?oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00ooool01oOgknOW
g]K>e_ooonoWilk>cZfe]@02W9bL00Z][JFm_KgNg]k>c/jm_KgNc/K>e]jm
_Kfe_Ljm_Kd2c/k>00nm_Kfe_Lk>c/k>a[G>e]jm_Kf]]KG>c]kNg/jm_Kf]
]KFm_Kf]]KFm_Kg>c/h00[fm_@04c/k>[JfU_Kfmc/kN0/k>c_oooom@oooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01ooo
o`03c<cooooooooo013oool01mKFilkFc_ooonoWiibLW;fm_Jf]Y@02_Kfm
00F]]KG>c/jm_Kfm_Kg>e]h00Zfe]@06[JfU[KFe[JfU[KFe_Kfm[JfU0[fm
_@08g]kNW:fm[JfUc/Jec]KNQ9BD[JfU[KFe0Zf]Y@0:c/k>_KfmW9bL_Kfm
S8b<W9bLg]kNc/k>g/k6inogooooodooool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03oooo`06
moO_inONc/kNmoO_knOWg]kN0^O_m`06knOWkoOgknOWinogknOWkoOg0^oW
i`04c/kNknOWmoO_c]KN0]kNgP__inL01]kNg^oWimkNg]kNg/k>c]K>eP;>
c/h01<kFg/k>c/k>c_O_iooooom?oooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013oool01=KF
ilk>c_ooomKFi`G>c/h01=kNg/k>c/k>c^ONgPC>c/h03<k>g/k>c/k>cXBD
U;fm_Lk>c/kFg/k>c[fm_Lk>c[fm_Lk>gP;>c/h01kfm_Lk>c[fm_Lk>c[fm
_KF][Jfe]@02_Kfm00CNc/Jm_Kg>c/k_moOoooooCoooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0@oooo00CNg]k>c/koooo>e]h3[JfU00fLW:F<S8c>c/jLW9b][JFea]Jm
_Kf4U9B]YIB][JG>c/j]]KG>c/h00Zf]Y@04W9bL_Kfmc/k>[JfU0Xb<S00@
a[fmW9bLS8b<W9bLW9bUS8b<_KfmS8b<W9bLU8b<W9bLS8b<]Kg>_Kfmg]k>
knOWooooodooool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool03oooo`04koOgknOWc/k>koOg0noW
i`05g]kNknOWc/k>c]K>g]kN00G_inL00nOWg^oWinoWi`02knOW00KFe^ON
g]k>e/k_inOWimkFe^L3c/k>00Rm_Jg>c]k>c/kNc/Je_Ljm_Kg>c/je_Lh3
_Kfm00>m_Jg>e]koool0ooooodooool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03oooo`04mnoW
e]KWg]k>oooo1=kNgP07c/k>g]kNc/kNg]kNg]k>g]kNc]KN00;Ng]h00lk>
g]kNg]kNgP02g]kN00[>c/k_inO>c]kNg/je_LkNc/J][JFLW:Fe_Lje[Jd2
[JfU00>]]KF][JF][JD00Zf]Y@06W9bU[JfU[KFe_KfmknOWkoOgooooodoo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07
oooo00?<c?ooooooool04?ooo`04knOWc/k>koOgc/k>0Zf]Y@03W9bUW9bL
S8b<00:][JD03HBDU9bLYJf]YJf]YIbLYJf]YIbLYLk6]IbLYHb<S9bLW<k>
cXb<S003W9bL00B][JF<S8akNg]kNg/2Jf][00ZLW9a[Jf][Jf]kNg^<S8aJ
FUZLW9b][JG>c]k_inOoooooD?ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0?oooo00KWkoOW
imk>c/koooo>c/k>e]h3g]kN00Zm_KgNg]kNg]kNg]jm_KgNg]k>c/k>e/kN
g]kWimh2c/k>00>m_Kg>c/kNg]h00]kNgP0<c/k>c]KNc/k>_Kfm[JfUW9bL
S8b<Ng]kS8b<Ng]kNhB4Ng]k0Xb<S003W9bL_KfmknOW0?oooomAoooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03
c<cooooooooo013oool01>OWg/k>c^ogmnoWi`CNg]h2_Kfm00SWimkNg]kN
g]kNg]kWimkFe^ONg]kFe^L6g]kN00S>c]kNg]kNc/K>c/jm_KfLW9b<S8a[
Lg<4Jf][00EkNg]kQ8BLW9bm_KgNg]h0oooooe;oool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
3oooo`0:moO_e]KWc]K>inogknOWS8b<[JfUc/k>Q9BD]Jf]1IbLW005c/k>
[JFD[JfUS8b<W9bU00:][JD00ibLW:f]YHb<S002W9bL00=kQ8Bm_KekNg/0
0f][J`03S8b<Ng]kS8b<00:][JD2c/k>00?Ng]koooooool0oooooe7oool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo
00?<c?ooooooool04?ooo`07g]kNc/k>koOgknOWc/k>c]K>inON00;Ng]h0
2LkFg/k>c/k>c/kFg/k>c]kNg/k>c/k>g]kNcP03c/k>00>]]KG>c/k>c/h0
0/k>cP05a[fm]Kg>[JfUS8b<_Kfm00Coool01>oWimkNg/k>c]kNg_oooomD
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
1oooo`03c<cooooooooo013oool01mkNg/k>c^oWinoWimkNg]KFinoWi`02
g]kN00[Wg]k_inO_inO_inONg]k>c]kWimkNg]kFe^O_inL6g]kN0lk>cP03
[KFeU8b<c/k>00?oool2g]kN00?>c/kNg]koool0oooooeCoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oo
ooooool03oooo`0HinoginONc/k>koOgc/JecXaSg/jmknOWg[f]aW]:c/J]
c]KN[JfUQ9BD[KFeW9bLc/k>[KFe[JFDQ9BD[KFeW9B<c/k>W9bU19bLW00:
[JfUNhB4Jf][_KfmooookoOginONg]kNc/k>g]kNoooooeKoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oo
ooooool04?ooo`0Hc]KNc/k>koOgknOWaZfLg]k>knOWaZfLcXaSknOWe]KW
_Kf]c/k>[KFec/k>g]kNc/Je]Kg>a[fmc/Je]Kg>c/Je[JfU[KFe0[fm_@0:
W9bL[JfUS8b<NhB4c/k>ooooknOWc]KNc/k>g]kNoooooeOoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oo
ooooool03oooo`0=koOgknOWc/k>knOWinONc]K>cZF4c/JeaW]:c[fUknOW
inONc]KN00;_inL00nOWg]kNg]kNgP04g]kN00?>c]k>c/kNg]h00]kNgP09
a[fm]Kg>[JfUS8b<c/kNknOWg]kNc/k>g]kN0?oooomHoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooo
oooo013oool02MkNg/k>c_OgkmKFinoWimJeW<k6]LIkB/kFgP02knOW00?W
imkFe^OWimh01MkNgP04c/kNg]kNg]k>g]kN1<k>cP:][JD01Hb<S=k>a]kN
g/k>c]kNgP3oooooFOooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0?oooo00?WkoOWimk>c/h0
0noWi`03c/JecXaScYak00;_inL00nOWg]kNg]kNgP03g]kN00S>e]kNg]kN
g]kNg]kNg/kFc]K>c/kNg]h2c/k>0[fm_@:LW9`00lkFg/k>c]kNgP3ooooo
F_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0@oooo00cNg]k>c/k_inO_inO>e]kWimjeLe[>
aZg_inOWimkFe^OWimh5g]kN00KNg/k>c]kNg/k>c]kNg/k>c]h3c/k>00Jm
_Kf]]KFLW9bm_Kg>c/kNg]koooooFoooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0?oooo00G_
moO_inO>c/kgmno>e]h00^oWi`04c/JeinONinONe]KW1MkNgP07c/kNg]kN
c]KNg]k>c/kNg]k>c]KN00?>c/h01[fm_Jfe]Jf]YJfe]Lk6]MkNg_oooomL
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
1oooo`03c<cooooooooo013oool02noWilkFg^oWinOWg/kFg^oWinOWg]KF
inOWg]kNg^OWgP03g]kN00ONg/kNg]kNg/kFc]KNg]k>c/k>e]h00/k>cP07
c/Je]Kg>_Kfm_Kf][JfU[KFee]KW0?oooomMoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013o
ool04>ogmnoWioOgkmKFinoWinOWg]KFinOWg/kFg^OWg/kFg]kNg/kFg]kN
g/kFg]kNgP;>e]h00lkFc/kFg/k>cP03c/k>00Fm_Kf]]KF]]KG>c/k_inL0
oooooekoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`k_inL02=kNg^oWinoWinoWimkN
g^oWimkNg^oWi`;Ng]h2knOWooooof3oool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0oooooh_o
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07
oooo00?<c?ooooooool0oooooh_oool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0oooooh_oool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo
00?<c?ooooooool0oooooh_oool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0oooooh_oool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool0oooooh_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0:oooo`03koOgooookoOg
00;oool00nogmoooooooo`02oooo00?_moOoooo_moL00_ooo`03koOgoooo
oooo0?oooom>oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo02Goool00noWioOgknoWi`0KknOW
00CFe^O_inO_inOFe^L6knOW00?_moOoooooool0oooooc_oool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oo
ooooool09?ooo`0>moO_g]kNc/kN_Kfm]Kg>c/Je]Kg>c/Je]Kg>c/Je_Kfm
]Kg>c/Je]Kg>0kfm_@07c/k>_Kfma[fm]Kg>c/Jea[fm]Kg>00:m_Kd01LJm
_KFmc[fm_LJm_KFmcP03_Kfm00W>c/jm_Kfm_Kg6_Kfe_Ljm_Kg>c/k>e]k_
inL0oooooccoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool09?ooo`05g]kNc/k>[JfU[JfUW9bU
016LW9`00ibLYJfUU9bLY@02W9bL00N]YIBLW:FLW9bLW9b][JFLW9bLW:D0
0YbLW003[JfUW9bLW9bL00:][JD00lk>c]kNg^ogm`3ooooo>oooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`0Toooo00?_inONg]koool09_ooo`;Ng]h00noWioooooooo`3o
oooo>Oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Toooo00?Ng]k>e/koool04oooo`03moO_
oooooooo00;oool01NO_moooooooooooonoWi`02oooo00?_inOooooWkoL0
0_ooo`04koOgooooinONc/k>oooooccoool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool08oooo`03
inoginONc]KN00;oool00nogmoooooooo`0;oooo00?_moOoooooool00ooo
o`03inogoooooooo00[oool01noWioooooooooooomkNg/kFg^oWi`3ooooo
>oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0Toooo00?Ng]kNc/Koool04Oooo`03koOgoooo
oooo00;oool00oO_ioooooooo`02oooo00CWkoOooooooooWkoL5oooo00G_
inOoooo_inO>c/k_moL0oooooc_oool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool08oooo`03moO_
imkNc]KN00koool00nogmoooooooo`04oooo00?gmnooooooool02_ooo`03
koOgooooinog00;oool00mkNg/kFc^oWi`3ooooo>oooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0Toooo00?Ng]k>c/koool00oooo`0:knOWc/k>knOWkoOgooooinogoooo
knOWc/k>knOW0_ooo`03koOgoooog]kN00GNg]h01]K>eXAkLia[HjekHljm
YIB<S0:]Nf<02[fm_Lk6]MkNc/k6]Kfm[NO_moooomkNg/k>c^ogmooooolk
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
1oooo`03c<cooooooooo02Coool01=KFimkNc_ooonoWi`:m_Kd01Lk>cYbL
W:fe]Lk>c^ogm`02[JfU0YbLW00MS8b<_Kfm[JfUknOWooooinONknOWmoO_
knOWmnoWinONg/k6DTY2Na08Q1P@[G]SU48aLaP@W34QcZF4g]k>knO>g]k>
c/JeknOWoooog]kNc]KNknOW0?oooolkoooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo02?oool0
0oOgknOWg/kFgP02oooo00?Fc]KNg]k_inL00]kNgP07knOWooooe]KWknOW
c]K>g]kN_Kfm00;Ng]h2oooo01S>c/j4U9BLW:FLW9akQ8A[Lg=JJf]:61Qc
612L<B64>C5S61R48ARULeZ]Nf>LW:FLQ7^DS6>]]KGgmnooooo_inO>c/k_
moOooooo>oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV00Ooool00lc<ooooooooo`0Toooo00?Fe^OFc]Koool01oooo`03
koOgoooooooo00;oool00nO_moooooooo`02oooo00kNc/J<S8b<S8a[Jf^<
S8b]YIA[Jf]B20Q[<BVL<B6]Nf>461248AQ[<BT2BU9J00QJFUYBBT9[Lg?_
inOooooNg]k>e]k_inOooooo>oooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Toooo00GNg]k>
e/koooogknN]]KD00[fm_@07]Kg>_Kf]knOWc/k>[JfUknOW[KFe00:m_Kd0
4mkNg[Fmc/k6]OooolkFg[fm_Jf]YIbDS:fUU<k6]G]cHaP@45882:ekHha[
BX@Q67/a:E8i<BTY:@03>CTa00IJFT;_inOooooWimk>c/k_moOooooo>ooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0Soooo02g_moOWimk>c/koooo_moNm_Kf][JG>c]k>
a[G>c/k_inO>c/jm_Kg_inN][JFm_Kg>c/kNg]k>c/j]]KGooooNg/jm_Jf]
[JFLW9b]W8C>_JEcJf<Q611BBT9S@SU:<BUB>C5B>BUkNg]kQ8AJFUY:DSU:
BS5:DSW_inOooooFe^O>e/k_inL0oooooc_oool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool09?oo
o`08g]kNc]KNooooooookoOgooooknOWinog1Oooo`03koOgoooooooo00;o
ool02NoWioooolk>g[fm[Kfm_IB<S7=cFZfLQ7=[H`02DSTa00m2:B5B>C5J
@SUB>C6<S7><S8akNg][He9[JdYJHe[_inOooooWimk>c]kgmnl0oooooc_o
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07
oooo00?<c?ooooooool08oooo`;_inL00mK>e_ooonoWi`02c/k>00VLW:F]
YIBe_Lk>a[GNg]k>e]k>c/kNg]k>e]h00/k>cP0<a[fmc]KNooooc/JeS8b<
S8acFUY2S8b<c/JeLf]SDTY2<AP@0U8i<@04LeYBDSTaFUY2Ng=S0V][BP07
FUY2Jf]:knOWkoOgknOWc]K>knOW0?oooolkoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo02Co
ool01]kNg/kFc_ooooooojf]YJfe]@Bm_Kd01]kNg[fm_Lk6]LkFg/k6]Jfe
]@:m_Kd04Jf]YOooojfe]DY:BU9:@V]SDXb<Lib4NeYJFU8i:D8Y8F]:@UYJ
@W=JDV=JBRTY63Ti6002FU8Y00Hi>AQkHd[_inOooooNg]k>c/kooooo??oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0Soooo00K_moOWimk>c/koooo_moO_inL9oooo01k_
inOWimkoooo_moO_inOooon][JDY<BTY:AQ:BRV]YIC6_Kdi>C52:B5B>C5B
BT9kFTY[He9J@STY:AQ:<BU:BRUcLeY:<BUBHd;Fe^OooooWimk>e]k_inOo
oooo>oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Toooo00[Ng]k>e]koooo_inO>e]kNg]k>
c/kNg]k>c/k_inL2c]KN023_inONg]k>e]k>c/kFc]K_inO>e]k_moN]YI@0
000Y:APi8ARLU8c>aZekLf<Y:AQ2:B6]Nf>DJeY[<BTi>APY:APa>B5:BRU:
BS4i>AQ:BS7_inO_moO_inO>c/k_moOooooo>oooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0S
oooo02g_moO_inO>c/kooooNg]jm_Kf][JF]]KF][JFLW9bea]J][JFm_Jg>
e]k>c/jLW:F][JFm_Kg>e/jm_Kg_inN][JD@000Y:APa>B6m_JgNc[f<S7<Y
:AQcFU:]Nf?6[Ib4Ng<a>B4H410i>AQ:DSU:FT8Y:BTi@S7_inOooooFe^O>
e/k_inL0oooooc_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP07oooo00?<c?ooooooool08oooo`;_inL00lkFc_oooooo
o`03koOg00Cgmno>e]kWimk_inL6koOg0oooo`0H[JfU:BTH:BTH:BTHS8ac
c[fUBUY2:BTH>B4HNf=:S6]:FUY2>D8a:C4Y:B48BU8iQ9BDNhB4FV=JknOW
koOginONc/kNmoO_oooooc_oool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool09?ooo`03g]kNc/kN
oooo00C_inL01=KFinoWinOWg]KFi`K_inL01MKFioO_ioooojf]YC4i8@02
BUY200VDS6>m_Jf]]KE[Lg<@40Pi8APa610H411JJf/00UYSFP09Hg><[KFe
W;GNYKG>knOWkoOgg]kNc]K>knOW0?oooolkoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo02Co
ool01]kNg]kNc_ooolkFg[fm_KF][@:][JD05Hb<S;Fmc[fm[IbLYJf]YJfe
]Kfm_Jf]YJfe]Jf]YNO_moooolk>cV=cS7^4Q6]SDW]kNkfm[JfUU8b<S2TY
:@02000000e:DUZL]MjU]LjL]MjU_MjL]NNea]JL]Mk_inOgmnoNg]k>c/k_
moL0oooooc_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool09?ooo`05g]kNc]KNooooknOWg]kN
00;_moL00noWilk>c^ogm`02knOW00?>c/k_inO>e]h00^oWi`04inogmnoW
moO_e]KW0Yb]_@06W9bU[JfU_Kfm]Kg>]LKFYKG>0V=cS0JL]Mh01ibeijFe
c^oWioooomkNg/kFg^oWi`3ooooo>oooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Soooo0^oW
i`05c]K>ooooknOWknOWkoOg00;_inL00jfe]NoWinogm`05knOW00GWkoOg
knOWkoOoooo>e]h00Zfmi`03[LKgW:fmc/J]00>L]NL01Jg6kibeiibegYbe
gYbei`05W;GN00G>e]k_moONg]k>c/k_moL02oooo`<00004oooo0P000003
oooo0000oooo00;oool00`000?ooooooo`02oooo0P000003oooo0000oooo
0?oooolHoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo02Coool02>OWg/k>g_ooolkFgYbLW<k6
]KFmcZfe]@:][JD00ibLYJf]YIbLW002c/k>012]]KF][JF<S8c>c/kooone
a]JL[MjL]MjL[MjL[Kf][JFL[MjL[LjL]MjL[MjL[Lh2W:gN00JL[LjL[MjL
[MjL[LjL[MjL[Lh2knOW00?Ng]k>e/k_inL02_ooo`050000oooooooooooo
000000;oool00`000?ooooooo`0200000oooo`050000oooooooooooo0000
00;oool20000oooooaWoool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool08oooo`08koOgg]kNg]k>
ooooknOWc]KNknOWmoO_0noWi`05c]KNknOWinONe]KWknOW00?Ng]h01NoW
inogmnoWilkFg]kNgP02c]KN00CNc/KFe^ONg]kFe^L2c]KN00?Ng]k>e]k>
e]h01<kFgP05]LKFknOWmoO_c]KNc/k>00_oool01@000?ooooooooooo`00
0002oooo00D0003oooooooooool000000_ooo`030000oooo000000;oool0
1@000?ooooooooooo`00003ooooo6Oooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Toooo0]kN
gP0>ooooknOWooooooooe]KWc/k>knOWmoO_oooomoO_inogknOW_Kfmg]kN
0_ooo`0:inogknOWkoOgooooknOWoooomnoWooooinogkoOg0^oWi`04oooo
knOWinogmoO_0^oWi`03g]kNknOWkoOg00;_inL00mkNg/kFc^oWi`0>oooo
00@0003oooooooooool400000_ooo`030000oooo000000?oool40000oooo
oaWoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool04Oooo`[<c?l8oooo0^oWi`0@c]KNooookoOg
[JfU_Kfmc/k>S8b<[JfU]Kg>knOWW9bL[JfUS8b<Q9BDU8b<[KFe0Zf]Y@09
c/k>knOWinogg]kNW9bUc/k>[KFe[JfUW9bL00;>c/h029bLW=kNgZfUU<k>
gZf]YIbLYHBDU<kFcP;_inL01>ogmlk>g/k>c^ogm`koool00`000?oooooo
o`04oooo00H0003oooooool0003oool00006oooo00<0003oooooool0oooo
oaOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool01MkNg/kF
c_ooonoWilk>cP03g]kN00[>e]k_inO_inONg]k>e]k>c/kFc]J]]KGNg/k>
e]h2c/k>00Ooooo_inN]]KF<S8bm_Kf][JGNg]h00/k>cP09g]kNc/k>g]kN
c/k>g]kNe/kFc]K>c/k>e]KW00?_inL00mkNc/kFg^oWi`0>oooo00@0003o
ooooool00003oooo00<0003oool000000oooo`030000oooo000000?oool0
0`000?ooooooo`3ooooo5oooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?oooooo
ool04?ooo`04inONc]KNooookoOg0oooo`05knOWooooinogoooomnoW00?o
ool02>oWinogmnoWioooonoWioooomkNg/k>cP;Ng]h02^oWioooonO_mooo
onoWinO_moO_inO_mnoWinO_m`C_inL01MKFinoWilkFg]k>a^ogm`0>oooo
00@0003oooooooooool300000_ooo`050000oooooooooooo000000;oool3
0000oooooa[oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool0
1MKFilk>c_ooonoWijf]Y@02[KFe00Vm_Kf]]KGNg]jm_Kf]]KGWimj][JFe
_Lj][JD00/k>cP07]Jf]_Kfm[KFeW9bLS8b<_Kf]c/kN00:]]KD2[JfU00K>
c]jm_Kf][JFm_Kg>c/j][JD2[KFe0Zf]Y@05c/k>knOWc]K>c/k>inog00ko
ool00`000?ooooooo`3ooooo:_ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?oo
ooooool03oooo`08moO_inONg]kNooooknOW[KFe[JfUc/k>0[fm_@04g]kN
c/k>[JfUe]KW0Zf]Y@06c/k>g]kN_KfmW9bLc/k>a[fm0[fm_@0:c/k>g]kN
[JFD[KFec/k>_Kfmc/k>[JfU]Kg>c/k>0[fm_@06[JfUc/k>_Kfm[JfU_Kfm
knOW0/k>cP03moO_oooooooo00coool00`000?ooooooo`3ooooo:_ooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`04e]KWc]K>ooookoOg
0noWi`06g]kNooooooooknOWooookoOg0^oWi`06oooomoO_moO_e]KWmnoW
inog0_Ogk`03inogkoOgknOW00;_inL01^O_mnoWimkNg^O_mnoWilkFgP?_
inL01mKFimkNg]kNg^OWg/k>c/kFg^oWi`3ooooo>oooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0Aoooo00?<c?ooooooool03oooo`07moO_inONe/kFooooknOWc/k>[KFe
00:LW9`02Zf]YKfm_MkNg/k>c[fm_Mk>a/kFg[fm_KFmc[fm_@;>c/h03kfm
_KFmc/k>c/k6]LkFg[fm_Jfe]Lk>g]kNc[fm_Jfe]Kfm_Jfe]Kfm_Lk>cP02
_Kfm00C>c/j][JFm_Kg>c]h2c/k>oooooccoool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Ooo
o`03c<cooooooooo013oool01mKFilkFc_ooonoWiibLW;fm_Jf]Y@02_Kfm
00F]]KG>c/jm_Kfm_Kg>e]h00Zfe]@06[JfU[KFe[JfU[KFe_Kfm[JfU0[fm
_@08g]kNW:fm[JfUc/Jec]KNQ9BD[JfU[KFe0Zf]Y@0:c/k>_KfmW9bL_Kfm
S8b<W9bLg]kNc/k>g/k6inogoooooc_oool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03
c<cooooooooo00ooool01_OgknOWg/k>g_OgknoWimkNgP;WkoL01^oWinog
mnoWinO_mnoWinogm`;_inL01<k>g^oWioOgklkFgP;Ng]h;knOW00KNg]k_
inONg]kNg]k>c/kFc]H2c/k>00C>e]k>c/k>c/kgknOooooo>oooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`0Aoooo00?<c?ooooooool04?ooo`04e]KWc/k>ooooe]KW1Lk>
cP04g]kNc/k>c/k>imkN1<k>cP0<c/kNc/k>c/k>Q9BD_Kfmc/k>c]KNc/k>
_Kfmc/k>_Kfmc/kN0/k>cP07_Kfmc/k>_Kfmc/k>_Kfm]Jf][KFe00:m_Kd0
1=k>a[fm_Lk>c^ogmooooolkoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<oooo
ooooo`0@oooo00CNg]k>c/koooo>e]h3[JfU00fLW:F<S8c>c/jLW9b][JFe
a]Jm_Kf4U9B]YIB][JG>c/j]]KG>c/h00Zf]Y@04W9bL_Kfmc/k>[JfU0Xb<
S00@a[fmW9bLS8b<W9bLW9bUS8b<_KfmS8b<W9bLU8b<W9bLS8b<]Kg>_Kfm
g]k>knOWoooooc_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00oo
ool01>ogmnoWilk>c^ogm`?_inL01MkNg^oWilk>c/kFc]kNgP05knOW00?W
imk_inO_inL00^oWi`06e]KWg]kNc]K>knOWinONe]KW0lk>cP08_Kf]c/kN
c/k>g/k6]Kg>_Kfmc/k>]Kg>0kfm_@03_Kf]c]KNoooo0?oooolkoooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03
c<cooooooooo017oool00lc<ooooooooo`0?oooo00CgknOFe^ONg/koool4
g]kN00O>c/kNg]k>c]kNg]kNg/kNg]k>e]h00]kNgP03c/kNg]kNg]kN00;N
g]h02/k>c^oWilk>g]kNc[Fmc]k>aZf]YIbLYKFmc[F][@:][JD00jfe]Jf]
YJf]Y@02[JfU00JLW:F][JF]]KFm_Kg_inO_moOooooo>oooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0Aoooo00?<c?ooooooool04?ooo`04knOWc/k>koOgc/k>0Zf]Y@03
W9bUW9bLS8b<00:][JD03HBDU9bLYJf]YJf]YIbLYJf]YIbLYLk6]IbLYHb<
S9bLW<k>cXb<S003W9bL00B][JF<S8akNg]kNg/2Jf][00ZLW9a[Jf][Jf]k
Ng^<S8aJFUZLW9b][JG>c]k_inOooooo??ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo
00?<c?ooooooool03oooo`06inoginONc/k>ooooc/k>c]KN0mkNgP0:_Kfm
g]kNg]kNg]kN_Kfmg]kNc/k>c]K>g]kNinON0/k>cP03_Kfmc/k>g]kN00;N
g]h03<k>c/kFg/k>c[fm_Jf]YIbLW8b<S7]kNhb<S7]kNg^4Q7]kN`:<S8`0
0ibLW;fm_NoWi`3ooooo?Oooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?oooooo
ool04?ooo`04inONc/k>koOgknOW1=kNgP:m_Kd02>OWg]kNg]kNg]kNg^OW
g]KFimkNg]KFi`KNg]h02<k>g]kNg]k>a/k>c[fm_IbLW8b<S6]cL`A[Jf/0
1G]kNg^4Q9bLW;fm_MkNgP3ooooo?_ooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<
c?ooooooool03oooo`0:moO_e]KWc]K>inogknOWS8b<[JfUc/k>Q9BD]Jf]
1IbLW005c/k>[JFD[JfUS8b<W9bU00:][JD00ibLW:f]YHb<S002W9bL00=k
Q8Bm_KekNg/00f][J`03S8b<Ng]kS8b<00:][JD2c/k>00?Ng]koooooool0
ooooocgoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool01mkN
g/k>c^ogmnoWilk>c/kFc^OWgP02g]kN00W>e]k>c/k>c/k>e]k>c/kNg]k>
c/k>c]kNg/h00lk>cP03[KFec/k>c/k>00;>c/h01LJm_KFmcZf]YHb<S;fm
_@04oooo00C_inONg]k>c/kNg]kooooo@?ooo`05IVIVooooR<2hR<2hB928
004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo
00?<c?ooooooool04?ooo`07g]kNc/k>knOWknOWg]kNe]KWknOW00;Ng]h0
2^ONg^oWinoWinoWimkNg/k>g^OWg]kNg]KFinoWi`KNg]h3c/k>00>]]KFD
S8c>c/h00oooo`;Ng]h00lk>c]kNg_ooo`3ooooo@?ooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0Aoooo00?<c?ooooooool03oooo`0HinoginONc/k>koOgc/JecXaSg/jm
knOWg[f]aW]:c/J]c]KN[JfUQ9BD[KFeW9bLc/k>[KFe[JFDQ9BD[KFeW9B<
c/k>W9bU19bLW00:[JfUNhB4Jf][_KfmooookoOginONg]kNc/k>g]kNoooo
od;oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool06<kFg/k>
c^ogmnoWilJ]W=kNc^oWilJ]W<j<HnoWimKFikfm[Lk>cZfe]Lk>c]kNg/k6
]KFmc/Jm_Lk6]KFmc/k6]Jf]YJfe]@:m_Kd02YbLW:f]YHb<S7^4Q<k>c_oo
onoWilkFg/k>c]kNg_oooom3oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<oooo
ooooo`0?oooo00g_moO_inO>c/k_inOWimk>e/k>YHC>a[G6Nd[>_JG_inOW
imk>e]h00^oWi`03inONg]kNg]kN00CNg]h00lk>g/k>c]kNgP02g]kN00W6
_Kfe_Lj][JF<S8c>c]k_inONg]k>c/kNg]h0ooooodCoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool04Oooo`03c<cooooooooo013oool02MkNg/k>c_OgkmKFinoWimJeW<k6
]LIkB/kFgP02knOW00?WimkFe^OWimh01MkNgP04c/kNg]kNg]k>g]kN1<k>
cP:][JD01Hb<S=k>a]kNg/k>c]kNgP3oooooAOooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0A
oooo00?<c?ooooooool03oooo`03inoginONc/k>00?_inL00lk6]Lj<HljL
N`02knOW00?WimkNg]kNg]h00mkNgP08c]KNg]kNg]kNg]kNg]k>e/kFc/k>
g]kN0/k>cP:m_Kd2W9bL00?>e]k>c/kNg]h0ooooodKoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool04Oooo`03c<cooooooooo013oool03=kNg/k>c^oWinoWilkFg^OWg[Ec
F/k6[NoWinOWg]KFinOWgPGNg]h01]kNc/k>g]kNc/k>g]kNc/k>gP?>c/h0
1[fm_Jfe]IbLW;fm_Lk>c]kNg_oooom7oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool0
0lc<ooooooooo`0?oooo00G_moO_inO>c/kgmno>e]h00^oWi`04c/JeinON
inONe]KW1MkNgP07c/kNg]kNc]KNg]k>c/kNg]k>c]KN00?>c/h01[fm_Jfe
]Jf]YJfe]Lk6]MkNg_oooom8oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<oooo
ooooo`0@oooo00__inO>e]k_inOWimk>e]k_inOWimkFe^OWimkNg]kWimh0
0mkNgP07g]k>g]kNg]k>e/kFg]kNc/k>c]KN00;>c/h01lk6]KFmc[fm_Kfm
[Jf]YJfe]MKFi`3oooooBOooo`05IVIVooooR<2hR<2hB928004000000005
R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?oooooo
ool04?ooo`0@koOgknOWmoO_e]KWknOWinONe]KWinONc]KNinONc]KNg]kN
c]KNg]kNc]KNg]kN0/kFgP03c]K>c]KNc/k>00?>c/h01Kfm_Jfe]Jfe]Lk>
c^oWi`3oooooB_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04Ooo
o`k_inL02=kNg^oWinoWinoWimkNg^oWimkNg^oWi`;Ng]h2knOWooooodco
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07
oooo00?<c?ooooooool04Oooo`03c<cooooooooo0?oooomgoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo017oool00lc<ooooooooo`3oooooMoooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0A
oooo00?<c?ooooooool0ooooogOoool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<co
oooooooo0?oooomgoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`3o
ooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool0ooooogOoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo
00?<c?ooooooool04Oooo`03c<cooooooooo01Ooool00nogmoooonogm`02
oooo00?_moOoooooool00_ooo`03koOgooookoOg00;oool00nogmooooooo
o`3oooooC_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04Oooo`03
knOWmoO_knOW01__inL01=KFinoWinoWimKFi`K_inL00nogmoooooooo`3o
oooo>oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`0>moO_
g]kNc/kN_Kfm]Kg>c/Je]Kg>c/Je]Kg>c/Je_Kfm]Kg>c/Je]Kg>0kfm_@07
c/k>_Kfma[fm]Kg>c/Jea[fm]Kg>00:m_Kd01LJm_KFmc[fm_LJm_KFmcP03
_Kfm00W>c/jm_Kfm_Kg6_Kfe_Ljm_Kg>c/k>e]k_inL0oooooccoool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool04Oooo`03c<cooooooooo013oool01MkNg/k>cZf]YJf]YIbL
Y@0AW9bL00>LW:F]YIBLW:D00YbLW007[JFDW9bUW9bLW9bL[JfUW9bLW9bU
00:LW9`00jf]YIbLW9bLW002[JfU00?>c/kNg]k_moL0oooooc_oool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool04Oooo`03c<cooooooooo013oool00noWimkNg_ooo`0Voooo
0]kNgP03knOWoooooooo0?oooolioooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<
ooooooooo`0@oooo00?Ng]k>e/koool04oooo`03moO_oooooooo00;oool0
1NO_moooooooooooonoWi`02oooo00?_inOooooWkoL00_ooo`04koOgoooo
inONc/k>oooooccoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00oo
ool00nO_mnOWg/kFgP02oooo00?_moOoooooool02oooo`03koOgoooooooo
00?oool00nO_moooooooo`0:oooo00O_inOooooooooooooNg]k>e]k_inL0
oooooc_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool00mkN
g]k>a_ooo`0Aoooo00?_moOoooooool00_ooo`03mnoWoooooooo00;oool0
1>O_moooooooonO_m`Goool01NoWioooonoWilk>c^ogm`3ooooo>oooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0Aoooo00?<c?ooooooool03oooo`03moO_imkNc]KN00ko
ool00nogmoooooooo`04oooo00?gmnooooooool02_ooo`03koOgooooinog
00;oool00mkNg/kFc^oWi`3ooooo>oooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<
c?ooooooool04?ooo`03g]kNc/k>oooo00?oool02^oWilk>c^oWinogmooo
onO_moooonoWilk>c^oWi`;oool00nogmoooomkNgP05g]kN00KFc]J4Ng>L
Jf>]Nf?>_JFDS8`2[G]S00Zm_Kg>a[GNg/k>a[Fm_JgWkoOooooNg]k>c/k_
moOooooo>oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`04
e]KWg]k>ooooknOW0[fm_@05c/k>W9bL[KFec/k>koOg00:][JD2W9bL01f<
S8bm_Kf][JG_inOooooWimk_inOgmno_inOgknOWimkNc/IBBT9k40R4612]
Nf>D@S5c612L<B7>YHCNg/k_ilkNg/k>a[G_inOooooNg]k>e]k_inL0oooo
oc_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool00oOgknOW
g/kFgP02oooo00?Fc]KNg]k_inL00]kNgP07knOWooooe]KWknOWc]K>g]kN
_Kfm00;Ng]h2oooo01S>c/j4U9BLW:FLW9akQ8A[Lg=JJf]:61Qc612L<B64
>C5S61R48ARULeZ]Nf>LW:FLQ7^DS6>]]KGgmnooooo_inO>c/k_moOooooo
>oooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`03e]KWe/kF
oooo00Ooool00nogmoooooooo`02oooo00?WkoOoooooool00_ooo`0>g/k6
S8b<S8b<Jf][S8b<[JFDJf][DPP8Jc4YW34Q[G]SQ1P@Q24HJc4Y0TYBFP08
FUYJDTY2Jg=cknOWoooog]kNc]KNknOWoooooc_oool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
4Oooo`03c<cooooooooo013oool01MkNg/kFc_ooooO_ijfe]@02_Kfm00Ne
_Ljm_Jg_inO>c/j][JG_inN]]KD00[fm_@0Cg]kN]Kg>c/Jeooooc]KN_Kfm
[JfUW9B<[JFDc/JeNg=S610@DPP8[G]SS6]:Q24HNc4YDSTa:BTY00<i>C40
1UYJ@^oWioooonOWg/k>c^ogmooooolkoooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool0
0lc<ooooooooo`0?oooo02g_moOWimk>c/koooo_moNm_Kf][JG>c]k>a[G>
c/k_inO>c/jm_Kg_inN][JFm_Kg>c/kNg]k>c/j]]KGooooNg/jm_Jf][JFL
W9b]W8C>_JEcJf<Q611BBT9S@SU:<BUB>C5B>BUkNg]kQ8AJFUY:DSU:BS5:
DSW_inOooooFe^O>e/k_inL0oooooc_oool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03
c<cooooooooo013oool02=kNg/kFg_ooooooonogmoooonoWinO_m`Goool0
0nogmoooooooo`02oooo00W_inOoooo>c]jm_Jfm_KfDS8acLeZ]W8AcJf<0
0U8i<@0?@RTQDSTaFT8iDSTaS8acS8b<Ng]kJf=BJf]:FV=JknOWooooinON
c/kNmoO_0?oooolkoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0?
oooo0^oWi`03e/kFooooknOW00;>c/h02IbLYJfUU;Fmc/k6]MkNg/kFg/k>
c]kNg/kFgP02c/k>00c6_Kg>e]koooo>a[F<S8b<S7=JFT:<S8c>a[EcJf=B
BT8a6102DSTa00AcFU9B>C5JFT9kLf<2Jf]:00MJFT9[Jd[_inO_moO_inO>
e/k_inL0oooooc_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013o
ool01]kNg/kFc_ooooooojf]YJfe]@Bm_Kd01]kNg[fm_Lk6]LkFg/k6]Jfe
]@:m_Kd04Jf]YOooojfe]DY:BU9:@V]SDXb<Lib4NeYJFU8i:D8Y8F]:@UYJ
@W=JDV=JBRTY63Ti6002FU8Y00Hi>AQkHd[_inOooooNg]k>c/kooooo??oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0Aoooo00?<c?ooooooool03oooo`06koOginONc/k>
ooookoOgknOW2Oooo`0NknOWinONooookoOgknOWoooo[JfU:C4Y:BTHBTXY
[JFDa[fm>CTa@RTQDSTaDTY2NeY:Jf=BFT8i:BTHBS4YBTXYLg=JBS4YDV=2
e]KWooooinONc]KNknOWoooooc_oool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<co
oooooooo013oool02]kNg/kFg_ooonoWilkFg]kNg/k>c]kNg/k>c^oWi`;>
e]h08>oWimkNg/kFg/k>c]K>e^oWilkFg^ogmjfUU00002TY63TQ69bDS<k6
[G]cHbTY648Y8JekHiA[FV/a:CTi62TY634i8DY::DY:<CTi64Y:<NoWinog
mnoWilk>c^ogmooooolkoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<oooooooo
o`0?oooo02g_moO_inO>c/kooooNg]jm_Kf][JF]]KF][JFLW9bea]J][JFm
_Jg>e]k>c/jLW:F][JFm_Kg>e/jm_Kg_inN][JD@000Y:APa>B6m_JgNc[f<
S7<Y:AQcFU:]Nf?6[Ib4Ng<a>B4H410i>AQ:DSU:FT8Y:BTi@S7_inOooooF
e^O>e/k_inL0oooooc_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo
00ooool2knOW00?>e/koooooool00nogm`04moO_c]KNinONknOW1^ogm`?o
ool06:f]YBTY62TY62TY68b<LljmYDYJ@RTY63TQ67]SBXa[BUYJ@SU2<BTa
:BTQ24YB>HBDU7^4Q5YSF^oWinogmnOWg/k>g_Ogkooooolkoooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo017oool00lc<ooooooooo`0@oooo00?Ng]k>c]koool01>oWi`04
e]KWknOWinONe]KW1^oWi`05e]KWmnoWoooo[JfU<CTQ009:FT802IB<Hkfm
[Jfe]F]cLa0@23TQ634H41P@45Y[J`02FV=J00USLhb]]KFL]MjU]Lk_inO_
moONg]k>e/k_inL0oooooc_oool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooo
oooo013oool01]kNg]kNc_ooolkFg[fm_KF][@:][JD05Hb<S;Fmc[fm[IbL
YJf]YJfe]Kfm_Jf]YJfe]Jf]YNO_moooolk>cV=cS7^4Q6]SDW]kNkfm[JfU
U8b<S2TY:@02000000e:DUZL]MjU]LjL]MjU_MjL]NNea]JL]Mk_inOgmnoN
g]k>c/k_moL0oooooc_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo
013oool01MkNg/kFg_ooonoWimkNgP02koOg00?_inO>c/k_moL00^oWi`03
c/k>knOWc]KN00;_inL01>O_moO_ioOgkmKFi`:L[Kd01YbLYJf]YKfm_KFm
c[G6eZFecP9SLh`6W;GN00NL]NNU]Lk_inOooooNg]k>e]k_inL0oooooc_o
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07
oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool2knOW00G>e/ko
ooo_inO_inO_moL00^oWi`03[KFeknOWkoOg00G_inL01NO_moO_inO_mooo
olkFgP02[KgW00>]a_NL[Kg>aZd00ibei`05[LK_W;GWW;GNW;GNW;GW00FL
]Mh01LkFg^ogmmkNg/k>c^ogm`0=oooo0`000003oooo0000oooo00;oool2
000000Goool0003oooooool000000oooo`800003oooo00D0003ooooooooo
ool000000oooo`030000oooooooo00;oool010000?ooooooo`0000?oool0
1@000?ooooooooooo`000003oooo0`000?Ooool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Ooo
o`03c<cooooooooo013oool02>OWg/k>g_ooolkFgYbLW<k6]KFmcZfe]@:]
[JD00ibLYJf]YIbLW002c/k>012]]KF][JF<S8c>c/kooonea]JL[MjL]MjL
[MjL[Kf][JFL[MjL[LjL]MjL[MjL[Lh2W:gN00JL[LjL[MjL[MjL[LjL[MjL
[Lh2knOW00?Ng]k>e/k_inL03?ooo`050000oooooooooooo000000?oool0
0`000?ooooooo`0200000_ooo`040000oooooooo00000_ooo`040000oooo
oooo00000_ooo`030000oooooooo00;oool00`000?ooooooo`02oooo00@0
003oooooool00003oooo00D0003oooooooooool000000_ooo`050000oooo
oooooooo00000?Koool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00oo
ool02>ogmmkNg]kNc_ooonoWilkFg^oWioOgk`?_inL01LkFg^oWinOWg]KF
inoWi`03g]kN00G_inO_moO_inO>e]kNg]h00/kFgP04g/k6e]KWg]kNe]KW
0/kFgP03g]kNc]KNc]KN00C>e]h01KG6e^oWioOgklkFg/k>cP0<oooo00<0
003oooooool00P000005oooo0000oooooooo000000?oool010000?oooooo
o`0000;oool00`000?ooooooo`03oooo00@0003oooooool00004oooo00<0
003oooooool00_ooo`040000oooooooo00000oooo`050000oooooooooooo
000000;oool00`000?ooooooo`3hoooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<
ooooooooo`0@oooo0]kNgP0>ooooknOWooooooooe]KWc/k>knOWmoO_oooo
moO_inogknOW_Kfmg]kN0_ooo`0:inogknOWkoOgooooknOWoooomnoWoooo
inogkoOg0^oWi`04ooooknOWinogmoO_0^oWi`03g]kNknOWkoOg00;_inL0
0mkNg/kFc^oWi`0;oooo00<0003oooooool00oooo`040000oooooooo0000
0oooo`040000oooooooo00000_ooo`030000oooooooo00?oool300001Ooo
o`030000oooooooo00;oool010000?ooooooo`0000?oool01@000?oooooo
ooooo`000002oooo1@000?Koool01FIVI_ooohS0^8S0^4R@R00100000000
1HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`[<c?l8oooo
0^oWi`0@c]KNooookoOg[JfU_Kfmc/k>S8b<[JfU]Kg>knOWW9bL[JfUS8b<
Q9BDU8b<[KFe0Zf]Y@09c/k>knOWinogg]kNW9bUc/k>[KFe[JfUW9bL00;>
c/h029bLW=kNgZfUU<k>gZf]YIbLYHBDU<kFcP;_inL01>ogmlk>g/k>c^og
m`_oool00`000?ooooooo`03oooo00@0003oooooool00003oooo00@0003o
ooooool00002oooo00<0003oooooool00oooo`030000oooo000000Goool0
0`000?ooooooo`02oooo00@0003oooooool00003oooo00D0003ooooooooo
ool000000_ooo`050000oooooooooooo00000?Koool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
4Oooo`03c<cooooooooo013oool01MkNg/kFc_ooonoWilk>cP03g]kN00[>
e]k_inO_inONg]k>e]k>c/kFc]J]]KGNg/k>e]h2c/k>00Ooooo_inN]]KF<
S8bm_Kf][JGNg]h00/k>cP09g]kNc/k>g]kNc/k>g]kNe/kFc]K>c/k>e]KW
00?_inL00mkNc/kFg^oWi`0;oooo00<0003oooooool00oooo`040000oooo
oooo00000oooo`040000oooooooo00000_ooo`040000oooooooo00000_oo
o`040000oooooooo00001?ooo`030000oooooooo00;oool00`000?oooooo
o`0200000_ooo`800002oooo00@0003oooooool00003oooo00<0003ooooo
ool0m?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool04?ooo`04inON
c]KNooookoOg0oooo`05knOWooooinogoooomnoW00?oool02>oWinogmnoW
ioooonoWioooomkNg/k>cP;Ng]h02^oWioooonO_moooonoWinO_moO_inO_
mnoWinO_m`C_inL01MKFinoWilkFg]k>a^ogm`0;oooo00<0003oooooool0
0oooo`040000oooooooo00000oooo`040000oooooooo00000oooo`800003
oooo00D0003oooooooooool000000oooo`030000oooooooo00;oool01@00
0?ooooooo`000?ooo`0200000_ooo`800004oooo0`000?Ooool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oo
ooooool04Oooo`03c<cooooooooo013oool01MKFilk>c_ooonoWijf]Y@02
[KFe00Vm_Kf]]KGNg]jm_Kf]]KGWimj][JFe_Lj][JD00/k>cP07]Jf]_Kfm
[KFeW9bLS8b<_Kf]c/kN00:]]KD2[JfU00K>c]jm_Kf][JFm_Kg>c/j][JD2
[KFe0Zf]Y@05c/k>knOWc]K>c/k>inog00coool01@000?ooooooooooo`00
000Coooo00<0003oooooool01Oooo`030000oooooooo0?ooool<oooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03
c<cooooooooo017oool00lc<ooooooooo`0?oooo00SgmnoWimkNg]koooo_
inN]]KF][JG>c/h2_Kfm00CNg]k>c/j][JGFe^L2[JfU00K>c/kNg]jm_KfL
W9c>c/k6_Kd2_Kfm00[>c/kNg]j]YIB]]KG>c/jm_Kg>c/j][JFe_Lk>c/h2
_Kfm00J][JG>c/jm_Kf][JFm_Kg_inL2c/k>00?gmnooooooool02oooo`<0
000;oooo00<0003oooooool01_ooo`030000oooooooo00;oool7000000?o
ool0003oool0ooooo`Soool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo
013oool01=KFilkFc_ooonogm`?_inL01]kNg_ooooooonoWioooonogm`;_
inL01_ooooOgkoOgkmKFioO_inO_m`;gmnl00nO_mnogmnoWi`02knOW00KW
koO_inONg]kWkoO_inO>e]h3knOW00OFe^ONg]kNg]kWimk>c/k>e]k_inL0
oooooc_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool01oOg
knOWg]K>e_ooonoWilk>cZfe]@02W9bL00Z][JFm_KgNg]k>c/jm_KgNc/K>
e]jm_Kfe_Ljm_Kd2c/k>00nm_Kfe_Lk>c/k>a[G>e]jm_Kf]]KG>c]kNg/jm
_Kf]]KFm_Kf]]KFm_Kg>c/h00[fm_@04c/k>[JfU_Kfmc/kN0/k>c_ooooll
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
1oooo`03c<cooooooooo017oool00lc<ooooooooo`0@oooo00OFe^O>e/ko
ooo_inNLW9bm_Kf][JD00[fm_@05[KFec/k>_Kfm_Kfmc]KN00:]]KD01Zf]
YJfe]Jf]YJfe]Kfm_Jf]Y@:m_Kd02=kNgYb]_Jf]YLk6]LkFgXBDU:f]YJfe
]@:][JD02/k>c[fm_IbLW;fm_Hb<S9bLW=kNg/k>c]k>a^O_mooooolkoooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01ooo
o`03c<cooooooooo017oool00lc<ooooooooo`0?oooo00KgmnoWimk>c]kg
mno_inONg]h2inog00K_inO_moO_inOWkoO_inO_moL2knOW00C>c]k_inOg
mno>e]h2g]kN2noWi`06g]kNknOWg]kNg]kNc/k>e/kF0/k>cP04c]KNc/k>
c/k>mnoWoooooc_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013o
ool01=KFilk>c_ooomKFi`G>c/h01=kNg/k>c/k>c^ONgPC>c/h03<k>g/k>
c/k>cXBDU;fm_Lk>c/kFg/k>c[fm_Lk>c[fm_Lk>gP;>c/h01kfm_Lk>c[fm
_Lk>c[fm_KF][Jfe]@02_Kfm00CNc/Jm_Kg>c/k_moOooooo>oooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`0Aoooo00?<c?ooooooool04?ooo`04g]kNc/k>ooooc]KN0jf]
Y@0=W9bUS8b<c/k>W9bL[JfU]LKF_KfmQ9BD[JFD[JfUc/k>[KFec/k>00:]
[JD019bLW;fm_Lk>cZf]Y@:<S8`04<Jm_IbLW8b<S9bLW9bLYHb<S;fm_Hb<
S9bLW9B<S9bLW8b<S;Fmc[fm_MkNc^oWiooooolkoooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo
017oool00lc<ooooooooo`0?oooo00C_moO_inO>c/k_moL3knOW00GNg]k_
inO>c/k>e/kNg]h01NoWi`03inONknOWknOW00;_inL01]KFimkNg/kFc^oW
inOWg]KFi`?>c/h02;fm[Lk>g/k>c]k>a[Fmc[fm_Lk>c[FmcP>m_Kd00kfm
[LkFg_ooo`3ooooo>oooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool0
3oooo`04mnoWe]KWg]k>oooo1=kNgP07c/k>g]kNc/kNg]kNg]k>g]kNc]KN
00;Ng]h00lk>g]kNg]kNgP02g]kN00[>c/k_inO>c]kNg/je_LkNc/J][JFL
W:Fe_Lje[Jd2[JfU00>]]KF][JF][JD00Zf]Y@06W9bU[JfU[KFe_KfmknOW
koOgoooooc_oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool0
1>oWilk>c^ogmlk>cP:][JD00ibLYIbLW8b<S002[JfU00f4U9BLW:F][JF]
[JFLW:F][JFLW:G>a[FLW:F<S8bLW9c>c/j<S8`00ibLW004[JfUS8b<Ng]k
Ng]k0V][J`0:W9bLJf][Jf][Ng]kS8b<FUYJW9bL[JfUc/kNknOWooooocco
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07
oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool01^O_mnOWg/k>
c_ooolk>c/kFgP?Ng]h02[fm_MkNg]kNg]kNg[fm_MkNg/k>c/kFc]kNg^OW
gP;>c/h00kfm_Lk>c]kNgP02g]kN00c>c/k>e]k>c/jm_Kf][JFLW9b<S8ak
Ng^<S8akNg]kQ8AkNg/2S8b<00>LW9bm_Kg_inL0ooooocgoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oo
ooooool04Oooo`03c<cooooooooo013oool01>OWg/k>c^ogmnoWi`CNg]h2
_Kfm00SWimkNg]kNg]kNg]kWimkFe^ONg]kFe^L6g]kN00S>c]kNg]kNc/K>
c/jm_KfLW9b<S8a[Lg<4Jf][00EkNg]kQ8BLW9bm_KgNg]h0ooooockoool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo
00?<c?ooooooool04Oooo`03c<cooooooooo00ooool02_OgkmKFilkFc^O_
mnoWihb<S:f]YLk>cXBDU;F][@FLW9`01Lk>cZfUU:f]YHb<S9bLY@02[JfU
00>LW9b][JF<S8`00YbLW003NhB4_KfmNg]k00=[Jf/00hb<S7]kNhb<S002
[JfU0/k>cP03g]kNoooooooo0?oooolmoooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool0
0lc<ooooooooo`0@oooo00ONg]k>c/k_moO_inO>c/k>e/kWimh00]kNgP09
c]KNc/k>c/k>c]KNc/k>g]kNc/k>c/kNg]k>00?>c/h00jfe]Lk>c/k>cP02
c/k>00G6_Kfe_Lj][JF<S8bm_Kd01?ooo`04knOWg]kNc/k>g]kNoooood3o
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07
oooo00?<c?ooooooool04Oooo`03c<cooooooooo013oool01mkNg/k>c^oW
inoWimkNg]KFinoWi`02g]kN00[Wg]k_inO_inO_inONg]k>c]kWimkNg]kF
e^O_inL6g]kN0lk>cP03[KFeU8b<c/k>00?oool2g]kN00?>c/kNg]koool0
oooood3oool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool06>O_
mnOWg/k>c^ogmlk6]Lj<Hmk>_NoWimjm[LIkB/k6[LkFgZf]YHBDU:fe]IbL
W<k>cZfe]JfUU8BDU:fe]IbDS<k>cYbLY@BLW9`02Zf]YG^4Q6][Jkfm_Ooo
onogmnOWg]kNg/k>c]kNg_oooom2oooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<
ooooooooo`0@oooo01S>e]k>c/k_moO_inO6[IcNg/k_inO6[Ic>S6?_inOF
e^Nm_Jg>c/j]]KG>c/kNg]k>a[Fe_Lk6_Kg>a[Fe_Lk>a[F][JF]]KD2_Kfm
00ZLW9b][JF<S8akQ8C>c/koooo_inO>e]k>c/kNg]kooooo@oooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`0Aoooo00?<c?ooooooool03oooo`0=koOgknOWc/k>knOWinON
c]K>cZF4c/JeaW]:c[fUknOWinONc]KN00;_inL00nOWg]kNg]kNgP04g]kN
00?>c]k>c/kNg]h00]kNgP09a[fm]Kg>[JfUS8b<c/kNknOWg]kNc/k>g]kN
0?oooom4oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0@oooo00WN
g]k>c/kgmnoFe^O_inOF]Ic>a[G6Nd[>e]h00^oWi`03inONe]KWinON00GN
g]h01<k>g]kNg]kNc]kNgPC>c/h2[JfU00F<S8cNc/KNg]k>c/kNg]h0oooo
odGoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo00ooool00nO_mnOW
g/k>cP03knOW00?>a[G>S6?>W7/00^oWi`03inONg]kNg]kN00?Ng]h02<kF
g]kNg]kNg]kNg]kNc]K>e/k>c]kNgP;>c/h2_Kfm0YbLW003c]KNc/k>g]kN
0?oooom6oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo017oool00lc<ooooooooo`0@oooo00cN
g]k>c/k_inO_inO>e]kWimjeLe[>aZg_inOWimkFe^OWimh5g]kN00KNg/k>
c]kNg/k>c]kNg/k>c]h3c/k>00Jm_Kf]]KFLW9bm_Kg>c/kNg]koooooAooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0Aoooo00?<c?ooooooool03oooo`05koOgknOWc/k>
moO_c]KN00;_inL01<k6]NOWg^OWg]KFi`GNg]h01lk>g]kNg/kFg]kNc/k>
g]kNc/kFgP03c/k>00Jm_Kf]]KF][JF]]KG>a[GNg]koooooB?ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`0Aoooo00?<c?ooooooool04?ooo`0;knOWc]KNknOWinONc]KN
knOWinONe]KWinONg]kNinON00?Ng]h01mkNc]kNg]kNc]K>e]kNg/k>c/kF
gP02c/k>00O>a[Fe_Ljm_Kfm_Jf][JF]]KGFe^L0ooooodWoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oo
ooooool04Oooo`03c<cooooooooo013oool04>ogmnoWioOgkmKFinoWinOW
g]KFinOWg/kFg^OWg/kFg]kNg/kFg]kNg/kFg]kNgP;>e]h00lkFc/kFg/k>
cP03c/k>00Fm_Kf]]KF]]KG>c/k_inL0oooood[oool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
4Oooo`03c<cooooooooo017oool>knOW00SNg]k_inO_inO_inONg]k_inON
g]k_inL2g]kN0^oWiooooom<oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo017oool00lc<oooo
ooooo`3oooooMoooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Ooool00lc<ooooooooo`0Aoooo00?<c?ooooooool0oooo
ogOoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool04Oooo`03c<cooooooooo0?oooomgoooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03
c<cooooooooo017oool00lc<ooooooooo`3oooooMoooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`1<oooo=IVIc?ooool:oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo04coool00iVIc<c<olc<
o`0ac<co00>IVLcoooooool0ooooo`Soool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03Oooo`07
kno_[Jf]FV]SW9bLilK6inOWmoOg00Coool00nooooOgmoooo`0aoooo00>I
VLc<c?o<c?l0<Lc<o`03VIW<oooooooo0?ooool8oooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo
00coool02mkNiiB<S10H44Y:BRTQ8JecNg]kNiB<S:f][MJma^o_k`0eoooo
00>IVLc<c?o<c?l0<Lc<o`03VIW<oooooooo0?ooool8oooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooo
oooo00_oool04NO_kkfm_BTa:Kg6_OooocTH8Lj4S<icNlI[Lje[JiaSJha[
Lib<S;fe]MKFe^o_koOgm`0`oooo00>IVLc<c?o<c?l0<Lc<o`03VIW<oooo
oooo0?ooool8oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo00[oool01?OgmmK>eYbDW34i>@;o
ool03g]BF/ikQ?mkU>mcS>MkQ<icNke[LjESJjESHiA[LhB4Q9bLW;fm_MkN
g_O_k`0]oooo00>IVLc<c?o<c?l0<Lc<o`03VIW<oooooooo0?ooool8oooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01ooo
o`03c<cooooooooo00[oool01>OWilK>cXbDS5YJFP;oool017=JHlikU?n<
[On<Y@;oQ9`2mg^<00__Hg_WFW?6Jg>]Jf^UHf>DJg>DQ8BU[JG6c/kNknog
moL00_ooo`03kooooooooooo00Coool00nooooooooooo`0Moooo00>IVLc<
c?o<c?l0<Lc<o`03VIW<oooooooo0?ooool8oooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00[o
ool01?OWimKFgZF]YF]cJ`;oool05f]cJmj<[OnUc_nUc_ND_OnD]OND[On<
YNn<W?n4W>n4U=ikS=IcQ<icNke[Lje[JjESHjE[Jib4S;FLW<k6c^OWiooo
o`03kooo2oooo`03kooomoOgoooo01Coool00iVIc<c<olc<o`0ac<co00>I
VLcoooooool0ooooo`Soool01FIVI_ooohS0^8S0^4R@R001000000001HS0
^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool02_ooo`0;mno_ino_[Jf]
Jf=SimkWe]kNHdYBaW>DoiBeoibmojG600;oYLh05?nUa_ND_NnD_On<[On<
YOMkU?N4U?MkS>MkQ>mSNnM[NkEcLjE[LiaSJiA[Lib<S;fe]LkNe^OgmoOg
m`Ooool00oOgmoooooooo`0Goooo00>IVLc<c?o<c?l0<Lc<o`03VIW<oooo
oooo0?ooool8oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH01oooo`03c<cooooooooo00coool03Kfm_F]cJnONilkFeV]J
F/IcU?M[Q?McS?McU?N4YOnD]OnL_OnUaP02ojG>01OoW;goU;GoS:goS:go
Q9cgNiCgLiC_Q9CWNhCFLg_>Hg?6Lg>ULg>LJg>LLg^]YJFm_KgWg]kgmoO_
ooooooogmoO_ool01oooo`03moOgoooooooo013oool00iVIc<c<olc<o`0a
c<co00>IVLcoooooool0ooooo`Soool01FIVI_ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool03?ooo`08a/K6
Q8B4moOgino_S7]kgXb]oiBeohb]0_McU004kg><mg>DohBLohbU0_nUaP;o
]MH05?nUc_nUa_ND_Nn<]OMkU?n4W?McS?MkS?MkU>m[Q=IcNliSLkEcLjE[
LjEcLjEkNkFLW;fm_NOWinoooa[oool00iVIc<c<olc<o`0ac<co00>IVLco
ooooool0ooooo`Soool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP07oooo00?<c?ooooooool03?ooo`06c]K>Q8B4knO_inOW
U8B4gXb]0_nL_@04oiBeohb]ohbUmhBU0_MkU006gW^DohBLoiB]oiBeojG6
ojG>0_neeP05ojG>ojG6oiBeohbUmg^D00?gLi@03OMkS>MkQ=IcNlI[LkEc
Lje[JjEcLjEkNkF][MK>c^OWioOgmoooo`03kooo4_ooo`03VIW<c<coc<co
037<c?l00iVIc?ooooooo`3ooooo2?ooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0<oooo00Jm
a/IkNg_Fc]K>c/i[Lf_>Ni@3ohb]00?oU;GoW;goW;d00_NL_@;oS:d02OND
[ON4YON4YOND[On<[OnD]OnUa_nee_nUcP02ojG600WoW;ggU:ggQ:GoQ9co
NiCgNiCgQ9CWNhcNNh@00/iSL`09YG=kW6]cW7=k[HbD_KFeg/kFmno_oooo
kooo017oool00iVIc<c<olc<o`0ac<co00>IVLcoooooool0ooooo`Soool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo
00?<c?ooooooool03?ooo`06c]K>S8b<knO_g^OWU7=kcW^L0_n<[@;gQ:D0
2?n<[OnD]OnL_OnL_OnUa_nUc_nUa_nL_@;oU;D02On<YOn4W>mkYON<YOnD
]ONL_OnUa_n]c_nUaP02oibm01;_S;GgQ:G_NjGoQ9c_NjGgNiC_Q9CWNhcF
Lg_6Lg^eJg^UJg>DJg>LNg^]S9C6a/KFe]Kgknl?oooo00>IVLc<c?o<c?l0
<Lc<o`03VIW<oooooooo0?ooool8oooo00EVIVKooon8`;R8`;Q8T8P00@00
000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00coool02]K6
cXb<S>ooono_kibDW;FLW?nUc_nUa_nL_OnD]@?oU:d04OnD]NnUc_NL_ON]
a_nUc_n]c_nUc_nUa_nL_OnD]On<[On<YNmkYOMkU?N4YOn<[OnD]@03oibm
01CoU;GoS:goS:GoS:GgQ:GgNiCgLiC_Q9C_NhcWLhcNJg_>Hg?>FV^UJf^L
Jg>LLg^eW9cF_LKNg]k_moL2kooo0_ooo`04koooooooooookooo0oooo`03
VIW<c<coc<co037<c?l00iVIc?ooooooo`3ooooo2?ooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooooooo
o`0:oooo00__ooooooo>c/j4Ng_NinOFe]JLQ8bLS9Co]MKoYLko[Lh00_nU
aP04ojg6oibmoibmoiB]0onD]@04ojG6mjg6ojg>ojG>0_nUaP;oW;d02?nD
]NmkYNmkYNN<W>McS>n4U?n<YOn<[@;oU;D2ohb]0_n<Y@06ohBLmg^DmhBD
mg^DkhBDkg^<0/ikQ00:]F]kYF]cYF]cU7=k[HbD_JFUc/k>imkNooookooo
0_ooo`05koooooooooooooooVIW<03?<c?l00iVIc?ooooooo`3ooooo2?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Oo
ool00lc<ooooooooo`0<oooo00[Fc/j4Ng_NinO>c/jDS8bLLg__YLk_[LKg
W;go[LH2ojg>1?neeP04ojg>ojG6oibmoiBe0_nL_@05mjg6ojG>ojG>ojg6
ojG600;oW;d02?nD]On<YOn4W=ikU>mcS>McS?MkU?n<Y@?oS:d2ohbU0_n4
W008mg^DmhBDmg>DohBLgW^Dig^<cW^4_F]c0[EcL`07U7=k[HbDolkNkooo
moOgooookooo00?oool00iVIc<c<olc<o`0ac<co00>IVLcoooooool0oooo
o`Soool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP07oooo00?<c?ooooooool03?ooo`07e/k>S8b<koOginOW[JFUU7=kojG6
00;gW;d01OnD]OnL_OnUa_n]a_n]cP02mkgN0onegP03okGFojg>ojG600;g
W;d4oiBe0_nL_@;oU;D01?n<[On4W?MkU?McS0?WHh@01>mcS?MkU?n4W?n<
[@;oS:D3ohBL0_mkU004ohBDmhBDkg^<ig^40/IkS003kjFeooookooo00Go
ool00iVIc<c<olc<o`0ac<co00>IVLcoooooool0ooooo`Soool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oo
ooooool03?ooo`09c/K>Q8B4moOgknO__KFeU7=kolk_okgFojg>00;o[LH0
0oN]_ONL_ON]aP02ojg>00go_Lko]Mkoa^Ooa^Oga^Og_NOo]MKo[LkoYLKg
W;goU;GgU:goS:D00_n<[@;oU:d01_nD]On<[On<YOn4W?mkU>mcS0;WHh@0
1=iJNnMSQ>mcS?MkU0OoQ9`2og^D00C_S9cNNhcNNiC_inl6oooo00>IVLc<
c?o<c?l0<Lc<o`03VIW<oooooooo0?ooool8oooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00[o
ool02>ooooooomK>cXAkNmkWimKFe[fe]G]SL`Co]Mh01?o6g_neg_nme_Nm
eP;o[Lh2mjG>00Go_MKo]Mko]Mko]Mkoa^L00_negP;o]MH01On]c_NL_ONU
]ON4YON<Y@02mhBU0on<Y@;oQ9`05?mkU?MkU>mcS>MSQ>MSNmiJNmiJLnm[
Q>mcS?MkU?n4U?n4W?n<YOn4W?n<YOMkU?McU>M[S>oNg^ooo`Goool00iVI
c<c<olc<o`0ac<co00>IVLcoooooool0ooooo`Soool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?ooooooool0
3?ooo`06e/k>Q7]kg^OWc]KF_KFeLe9J0_NmeP05mjG>okGFokGNokGNolKW
00;oc^l00oo6ioneg_nmeP03ojg>00Go[LKg_MKg_MKg_MKo]MH00_negP;o
]MH02?nUa_nL_OND[Nn<W>n4U?McU>mcS>mkS0;oQ9@3og^D00GgLhc_Lhc_
JhCWFW?NHg<00]iJL`03if=kkg><mg><00;oS:D2of^<00?Nc]KgmoOgmoL0
1?ooo`03VIW<c<coc<co037<c?l00iVIc?ooooooo`3ooooo2?ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<
ooooooooo`0<oooo00WFc/j<S8coooo_knoF_LIkDU[oa^Oo_MKo[Lh00_n]
aP04mjg6okGFokGNokGN0_o6i`03omK_olk_olk_00;ga^L01?nee_n]c_n]
a_N]aP;o[LH2ojg>0_nUaP07oibmoiBeoiBeohbUohBLmg>Dif]k00;_Jh@0
0nMkQ?MkS?mkU003og^D00?gJhCgLhc_Hg/00miJL`05kg><mg>Dog^DohBL
mkgF00;_ool4oooo00>IVLc<c?o<c?l0<Lc<o`03VIW<oooooooo0?ooool8
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
1oooo`03c<cooooooooo00_oool02?OgmmK>cXakQ?OgmoO_knOWieYSF_o>
m`?oa^L01?o6g_nee_Nmc_neeP;g_MH2okGN00koa^Ooc^ooe^ooc_Ooc^oo
a^Oo]Mko_MKo[LkoYLKgW;ggYKGoW;ggYKD3oibm00OoU;GoU:goS:GoQ9cg
NiC_NhcWHh@00^MSN`03if]kkf=kkg><00;gLh`02NmcS?McS>m[Q>m[Q?Mc
S?mkU?N4YOMkU?nmeP06oooo00>IVLc<c?o<c?l0<Lc<o`03VIW<oooooooo
0?ooool8oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo00coool02<k>cXAkNnONg]k>e]K6cT92
@_o>koNmgP;oa^L2olk_00Goa^Ooc^ooa^Ooa]kg_Mh00_NmeP;g_Mh3olKW
00Soc^ooa^Ooa]koa]Ko[Lko[LKg[KgoW;d2miB]00CgU:GgU:goS:ggU:d3
ohbU00WoQ9cgNiC_Lhc_JhCWHg_NFW?NHg?WHg__Jh@00oMcS0;oQ9`01ON<
YOMkU?nmc_ooonooo`04oooo00>IVLc<c?o<c?l0<Lc<o`03VIW<oooooooo
0?ooool8oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo00coool01mKFeXb<S?O_knONg]kFeT8i
>Oo6i`04mkgN00Ooa^Ooc^ooe^oog_Ooc_Ooe^ooc^l00_o6i`;g_Mh00oNm
ioNmg_NmgP04okGN00[o_MKo[Lko[LKoW;ggYKGoS:ggS:G_S9c_Q9CgNi@5
ohBL0_mkU00<mg><kg><if]kgV=ccV=cgV=cif]kkg><ohbUmhBUmg^DokgF
1_ooo`03VIW<c<coc<co037<c?l00iVIc?ooooooo`3ooooo2?ooo`05IVIV
ooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool20000
3Oooo`0;c/k>S8b<oooomno_imkWBSU2olkgolKWolkNmkgNmkgF00?g_Mh0
0oo6iooFkooNm`02omkg00Ooe^ooc_Ooe^oge^oga^Og_Mk__MH00_NmeP;o
_MH02_nee_n]c_n]c_n]c_n]a_NU]OnD[ON<YON4U>n4U0;_Lh`04^McS>mk
S?MkU?N4U?n4W?N4U?McU>mcS>m[Q>MSQ=i[Nnm[Q?n<YON<YOMkU?nme_oo
onooo`Coool00iVIc<c<olc<o`0ac<co00>IVLcoooooool0ooooo`Soool0
1FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo
0P0000goool01lk>cXb<S?OgmoO_knOWidY:B_oNm`02olkg00Gog_Ooa^Oo
c^ooa^Ooc]h00oO6i`05olKWomK_olkgolkgomkg00?oc_L2olKW00?g_Mk_
[Lk_[Lh00_N]aP03mibmoibmmjfm00;oW;d03_NU]OnD]OnD[Nn<W>n4U>Mk
S>MSQ>MkQ>MSQ>MkQ>mcS>n4U?n4W?N4U0;gNi@01ON4U?n<[ON<YOn<YOnm
cP06oooo00>IVLc<c?o<c?l0<Lc<o`03VIW<oooooooo0?ooool8oooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`80
000;oooo00W_ooooooo>c/ikNg__knoNg]kFe]I2@T;ga^L00_oFk`07olkg
omK_omK_omkgolkgomkgolkg00;oe^l3mmK_017oe^oog_Ooe^ooe^ooc_Oo
e^ooc^ooa^Ooa]ko[Lkg[LK_YKg_W;GgU:ggW:ggU:GoS:D00onD[@;oS:D0
1On4W?MkU>mkS>MSQ>MkQ002gV]k00SWNhCWLhcgNiCoQ9coS:G_NjGoS:Gg
]LH6oooo00>IVLc<c?l000000/c<o`040000c<coc<co00000lc<o`800000
0lc<o`000<c<o`02c<co0P0000G<c?l300001Lc<o`@00005c<co00<0003<
c?o<c?l00lc<o`040000c<coc<coVIW<ooooo`[oool01FIVI_ooohS0^8S0
^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo0P0000goool01lkF
eXb<S?ooonOWimkFeUYJF_NmcP02olKW00Gga^Oge^Ooc^ooe^ooc_L02?oN
m`;oa^L03_O6ioOFioo6iooFkoo6ioo>koo6ioneg_nmc_n]a_N]_OnD]OND
YNn<W0;WS9@00nn<W?n4W>n<W003khbL00GoQ9CgQ9C_NhcWLhcWNh@00]i[
N`05ig><ohbUmiB]ohbUmjfm00Koool00iVIc<c<o`000002c<co00@0003<
c?o<c?l00002c<co00<0003<c?o<c?l00P0000;<c?l010000<c<olc<o`00
00?<c?l01@000<c<olc<olc<o`000003c<co00<0003<c?o<c?l00/c<o`03
0000c<coc<co00?<c?l01@000<c<olc<olc<o`000003c<co00>IVLcooooo
ool0ooooo`Soool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP06oooo100000coool01lk>cXb<S?ooooOgmnOWig=SJnnmeP02
omK_00Goa^Ooe^oga^Oga^Oge^l00_oFk`Oog_L00ooFkoo6ioNmgP02mkgF
00Gg_Mkg_MKo]MKo]MKo_MH00_n]cP08ojg6oibmmjFeoiB]ohbUkhbLihbD
ig^<0^n4U004ohBLmhBDkhbLohBL0_N4U0;_Nh`01ON4U?n<[OND[On<[NnU
_@06oooo00VIVLc<c?l0003<c?l0003<c?l0003<c?l000000/c<o`050000
c<coc<coc<co000000;<c?l00`000<c<olc<o`03c<co00<0003<c?o<c?l0
0lc<o`040000c<coc<co00001<c<o`030000c<coc<co00?<c?l010000<c<
olc<o`0000C<c?l00iVIc?ooooooo`3ooooo2?ooo`05IVIVooooR<2hR<2h
B928004000000005R<2hb>3HR<2hR<2hIVIV00Goool00`0009VIc9VIc002
VIW<00<0003oooooool02Oooo`07c/k>Q8B4kno_inOWg]kNS9B<_Ibe00Oo
g_L01OOWkooFkoOFkoOFkooFk`07omkg00Ooc_Ooa^Og_Mkg_MKg_Lkg]LKg
[LH00_N]_@03ojg6mjfmmjfm00;gYKD01_NL[ONDYONDYNn4U>MkS=ikS0?W
Nh`02Nn4U?N4U>n4U>n<W>nDW?nD[On<YNnL[OnD]@06oooo00VIVLc<c?l0
003<c?l0003<c?l0003<c?l000000lc<o`@00002c<co00<0003<c?o<c?l0
0lc<o`030000c<coc<co00?<c?l00`000<c<olc<o`05c<co00<0003<c?o<
c?l01<c<o`030000c<co000000C<c?l00iVIc?ooooooo`3ooooo2?ooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Coool0
100006IVVIVIc<c<o`;oool00iVIc0000<c<o`04c<co1Oooo`07e]KFS8b<
kno_g]kNa/K6S7^4W9BL00?oe^l;omkg00?oe^oog_Ooe^l01?oFk`;oc^l0
1?o6g_nme_n]c_n]aP;gYKD4mib]1?nD[@05ohbUohBLkhBDkg^<ig^400;N
Nh@02NMkQ>mkS?N4U?nD]On<YNnL[OnD[OooooOgm`04oooo00VIVLc<c?l0
003<c?l0003<c?l0003<c?l000001/c<o`040000c<coc<co00001Lc<o`03
0000c<coc<co00?<c?l010000<c<olc<olc<o`@00008c<co00<0003<c?o<
c?l00lc<o`03VIW<oooooooo0?ooool8oooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01?ooo`030000IVJIc<co00800000
0ooooiVIc000000:oooo00O>c/j<S8coooo_knoFe]JUYJFDLg/00_oNm`03
omK_olkgomK_00_og_L00ooFkoOFkoo6i`02olKW00Koc^ooa^Ooa^Ooa]ko
a]Ko_MH2ojg600CgYKGoU:ggU:G_U:D2khbL00C_U:GgS:GoS:GgU:D2ohbU
00[_U9c_Q9C_NhcWNhcNNhcWNhcoU;GoS:G_W:goU;D6oooo00VIVLc<c?l0
003<c?l0003<c?l0003<c?l000000/c<o`050000c<coc<coc<co000000;<
c?l010000<c<olc<o`0000;<c?l00`000<c<olc<o`03c<co00@0003<c?o<
c?l0000;c<co00<0003<c?l000001<c<o`03VIW<oooooooo0?ooool8oooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01?oo
o`030000IVJIc<co008000000lc<oiVIc000000:oooo00O>c/j4Q8Coooog
moO_kno6c/ikHg<00_oNm`05mnO_omkgmnO_omK_mnO_00Gog_L00oOgmooN
moOgm`03omkg0_oFk`03olKWolKNmkgF00;o_MH01?o6e_nme_nme_n]cP;o
[LH01?NU]OnD[NnDW>n<W0?WS9@01^n4U>n<W>n<W>n<W?n<YNnDW0;_S9`0
0oN4U?NU]On<Y@02miB]00?gknooooooool00oooo`04VIW<c<co00000000
0lc<o`800003c<co0`0000C<c?l200000lc<o`030000c<coc<co00?<c?l0
10000<c<olc<o`0000C<c?l00`000<c<olc<o`03c<co00@0003<c?o<c?l0
0004c<co00>IVLcoooooool0ooooo`Soool01FIVI_ooohS0^8S0^4R@R001
000000001HS0^<SPf8S0^8S0^6IVIP04oooo00<0001VIYVIVL`00/c<o`:I
VL`00`000?ooooooo`08oooo00S>c/j4Q8CgmoOWinOFe]K>a/ISDU[ooolC
omkg00Ooe^oge^Ooa^Ooa]Kg_LkgYLkg]LH01ON]_@;gYKD04_nD[ONDYOND
YNn<W>N<U=ikQ=ikS>MkS=ikU>n<W>n4U>n<W?N<YONU]OnD[ONL[On<YOOW
i`Goool019VIc<c<o`00000000?<c?l200004<c<o`050000c<coc<coc<co
000000?<c?l00`000<c<olc<o`02c<co00<0003<c?o<c?l00lc<o`050000
c<coc<coc<co000000?<c?l00iVIc?ooooooo`3ooooo2?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Goool00`0006IV
VFIVV@02IVJI00<0003oooooool02Oooo`09c/k>Q8B4moOginOWc/k>_LJm
DT92omkgmoOg00Gog_L01?oooooNmooWooOgm`[og_L02?o>mooFkoo6ioo>
g_o6e_n]a_N]a_N]_@;gYKD4mib]0_nD[@04ohbUmiBUmhbUkhbL0^N<U0?N
Nh`01^N<U?NU]On<YOND[On<[NoNgPGoool00iVIc<c<o`000005c<co00<0
003<c?o<c?l03lc<o`<00005c<co100000G<c?l00`000<c<olc<o`03c<co
00@0003<c?o<c?nIVLcooooo2_ooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00Koool400003?ooo`07c/k>S8b<oooooooo
inOWe]KFBSU200Sog_L02_oooooNmooWoooNmooWoooooooNmooWoooNmoOW
k`?oe^l03_OFioo6iooFkoo6ioo>g_o6g_nme_n]a_N]_ONU]ONL[ONDYNnD
YNnDW0;_U:D00oN<YONDYONDY@02miBU00?_U9c_S9cWS9@00^N<U005mjfm
miB]mib]ohbUmmkN00Goool00iVIc<c<olc<o`0ac<co00>IVLcoooooool0
ooooo`Soool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP07oooo00?<c?ooooooool03?ooo`08e]KFS8b<ooooooookno_inOW
FT9:oooo1_oNm`0:moOgomkgoooooooomoOgooooomkgooooomkgoooo0_oN
m`;oe^l01_o6ioo>g_Nme_Nme_nme_o6eP?o_Lh01on]a_N]_ON]_OnD[ONL
[ONDYNnDW003ihbD00GWS9c_S9cgU:GgU:G_U:D00_NDY@05mjFeoiB]mib]
ohbUkmkN00Goool00iVIc<c<olc<o`0ac<co00>IVLcoooooool0ooooo`So
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07
oooo00?<c?ooooooool03?ooo`08c/k>S8b<kno_inOWg]kNe]KFFTYBimkW
0_ooo`03omkgoooooooo00Oog_L00ooWoooNmooNm`05omkg00Gginooe^oo
a^Ooc]kg_Lh00_NeaP;g[Kd00on]a_N]_ON]_@02mjFe0_NL[@06kibUkiBL
ihbLihbDgXB<gW^D0^N<U0;_S9`01oN]_ONL[ONL[ONL[On]c_ooonooo`03
oooo00>IVLc<c?o<c?l0<Lc<o`03VIW<oooooooo0?ooool8oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo00coool02lk>cXb<S?ooono_kmkNg/K6aW=SJmK>c_oNmoOWkoOg
m`02omkg00KoooooioogmoOooooog_Ooiol3omkg00Koiooog_Oog_Oog_Og
inoog_L3omK_0_o6i`04olKFokg>ojg6mjfm0oNU]@04mib]kib]mib]miBU
0_NL[@06oiB]kibUkiBLihbLihbDgW^D0]j4S005mjfmmib]kjfemib]ojg6
00Goool00iVIc<c<olc<o`0ac<co00>IVLcoooooool0ooooo`Soool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<
c?ooooooool03?ooo`0Fc/k>S8b<oooooooomoOgg]kNU8b<W9BLooooomkg
ooooknO_ooooomkgmoOgonOoomkgonOomoOgonOomoOgonOo1?oNm`;oe^l0
0oOFioO6ioo>gP02olkN00Goa]koa]Ko_MKo[LKg[Kd00_NU]@05kibUiibU
kiBUkiBUkibU00KgU:D02>nDW>N<W>N<W?NL_ONL[ONU]Nn]]On]aPGoool0
0iVIc<c<olc<o`0ac<co00>IVLcoooooool0ooooo`Soool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool03?ooo`08c/k>S8b<oooooooomoOgkno_[Jf]W9BL0oooo`;og_L05?Og
mooNmoOgmooNmooooooNmooooooNmooooooNmooWoooNmoOgmooNmooFkooW
ioo6ioo>g_o6e_NmeP?o_Lh00oNma_nmc_n]aP02mjfm00GoU:ggW:g_W:G_
S9cWS9@00nN<W005kiBLkibUkiBUkiBUmiBU00?gYKD00oNL[On]a_ooo`04
oooo00>IVLc<c?o<c?l0<Lc<o`03VIW<oooooooo0?ooool8oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo00coool02<k>cXb<S?Ogmno_kmkNg]KFe]kFeUY:DP;oool04OoN
mooooooooooNmooooooWoooooooNmooooooNmoOgmooNmooooooNmooWoooN
moOgm`03omkg00Kge^Ooc]koa]Kg_Lkg]LKo[LH2mjfm0_NU]@;g[Kd2mjFe
00K_YJG_W:G_W:GWS9cWS9CNNi@3ihbD00OWS9cgYKGgYKGgYKGgW:gg[Kgg
moL01?ooo`03VIW<c<coc<co037<c?l00iVIc?ooooooo`3ooooo2?ooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool0
0lc<ooooooooo`0<oooo00W>c/j<S8coooogmoOWinOFe]KFc/hY8B7Wg^L0
0oooo`03mno_onOooooo00Coool01?oNmooooooNmoooo`;gmoL3omkg1?oF
k`05mmKWolkNolKFmkg6ojg600?gYKD01>nL[ONL[ONL[ONU]@;gW:d02OnD
[ONDYNnDYNnLYNnDW>N<U=ikU>N<U?N]_@02mjFe00?gW:g_YKggknl01?oo
o`03VIW<c<coc<co037<c?l00iVIc?ooooooo`3ooooo2?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0<oooo00?>c/j<S8coool00_ooo`07kno_g]kN_KFe@STie/k>oooo
omkg00[oool01OoWoooNmooNmooNmoO_k`02omK_0_OFi`0;olKWolkNolKW
olkNolKFolK>okg>mkg6mjfmmjFekjFU00;WW:D5kibU0_NL[@03miBUkibU
kibU00GgYKD00noWkoooooooo`02oooo00>IVLc<c?o<c?l0<Lc<o`03VIW<
oooooooo0?ooool8oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH01oooo`03c<cooooooooo00coool00lk>cXb<S?ooo`02
oooo00WgmoOgknoWinO>a/ISDUY2@T9cHf^DU9Cginl01Oooo`03onOooooo
oooo00?oool02OoWoooNmooNmooNmooFkoo>g_o>e_Nme_O6cP04okg>0oN]
_@;gYKD01?NL[NnLYNN<W>N<W0;WS9@2ihbL0^nLY@03mib]mjfmmjFe00;g
YKD00nnU]NOWioooo`03oooo00>IVLc<c?o<c?l0<Lc<o`03VIW<oooooooo
0?ooool8oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH01oooo`03c<cooooooooo00coool01lk>cYBDU?Ogmno_knOWimkN
g^OWi`02g]kN0^OWi`07c/k>W9bLJf][FTYBLeYSW9BLkmkN00;oool02?Og
mooooooNmooooooWooOgmooNmoOgm`;og_L01OoFkooNmoo6ioNme_NmcP02
mkg600?_[KGg[Kgg[Kd01?N]_@;gYKD00nnL[ONL[NNLY@05ihbD0_NU]@04
mkg6kjFmoibmolkF1?ooo`03VIW<c<coc<co037<c?l00iVIc?ooooooo`3o
oooo2?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2h
IVIV00Ooool00lc<ooooooooo`0;oooo00?gmoO_knmcLg<00_ooo`07moOg
inOWc/k>c/k>a/K6c/k>e]KF00?Ng]h02>ONg]k>e[F][G=cLdY:BV=BFYb<
U=K6cP;oool00oOgmooNmooNm`02omkg00[oiooog_Ooe^ooinOoe^ooc]ko
a/ko[LKoa/kgYKD6mib]00O_YJGgW:ggW:ggW:ggU:G_YJG_U9`00^N<W006
mjFemjfmmjFekjfemjFeolK>1?ooo`03VIW<c<coc<co037<c?l00iVIc?oo
ooooo`3ooooo2?ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Ooool00lc<ooooooooo`0=oooo00=BBU;oooooool00_oo
o`03kno_inOWg]kN00C>c/h04LK6a]KFe]KFe]kFe]kNg^OWimkFeZfUYG]k
NeY:DV=BFXakQ<K6a_oNmoooooOFknONi`05omK_00Goa^Ooc]ko_MKo_Lkg
_LH00_N]_@04mjFekjFUiibUiibU0nnLY@0;kib]kjFUmiBUkjFUmiBUmjFe
mjfmmkg6kjfeoibmolK>00Coool00iVIc<c<olc<o`0ac<co00>IVLcooooo
ool0ooooo`Soool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0
^8S0^6IVIP07oooo00?<c?ooooooool03Oooo`03[Jf]Ng]koooo00?oool0
1OOgmno_knOWinOWimkNgP02e]KF00K>c/k6c/k6a/K6a/K6c/k>e]H2g]kN
013WinOWg^Nm_Kf4LhAJ@U9J@TZ4LhBmW;Gge^Ooe^oge^Og_Mkg_Lko_MKo
a]ko]Mh2okgF01Go_Lko[LKg[Kg_[KGgW:g_[KG_YJGWS9cWW:GWS9cNU:GW
S9c_YJG_W:GgYKGg]LKgYKG_YKgg[Kgg_LKgmoL00oooo`03VIW<c<coc<co
037<c?l00iVIc?ooooooo`3ooooo2?ooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<ooooooooo`0>oooo00Ac
Lg>m]KGgmoO_knl2g]kN0^OWi`0Dkno_moOgkno_inOWg^OWg]kNe]kNc]KF
a/k>a/K6_LK6a/k>a/K6c/K>e/k>g]kNinOWimkW_KfmU9BD0V=:DP07LeYS
]IbLkkgFonOWmkgNmkg>kjg>00;g[LH02ONea_n]a_Nma_Nma_NU]ON]_ONL
[NnLYNnUY@02iibU00WNU:GWS9CgYKGg[LKg[Kgg]LKoW;gg_LKog_L00ooo
o`03VIW<c<coc<co037<c?l00iVIc?ooooooo`3ooooo2?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0>oooo00OWinMBBU;oooooooo_knoNg]kFe]H00/k>cP03e]KFg]kN
inOW00?_knl2inOW00?NinOFg]kFe]H01Lk>cP0<e/k>e]KFimkNinOWimkW
g/kFW9BLLeYSFSU2JdYJS6]ckjfe0_NmaP06mjfmmjFemib]mjFemjfmmjFe
0_N]_@09mjFemib]mib]kibUiibUmjfmmkG6mjfmmjg600;g[Kd01OOWkooo
oooooooooiVIc00cc<co00>IVLcoooooool0ooooo`Soool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07oooo00?<c?oooooo
ool02oooo`;gmoL2oooo00=:BT[oooooool00_ooo`03moOginOWg]kN00?F
e]H01Lk>c]KFe]kNg]kNg^OWi`02kno_00?WinONinONg]h00]KNgP05e]KF
c]K>c/k>c/k>e/k>00;Fe]H01]kFe^ONinOWimK>c[fe]G=JH`9cBU802YA[
LlJDW>N]]NnU_NN]]MjDYNnL[ONU]Nn]]NnL[@?gYKD01?N]_Nn]a_N]_ONe
aP;g[Kd01OOWiooooooooooooiVIc00cc<co00>IVLcoooooool0ooooo`So
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP07
oooo00?<c?ooooooool03Oooo`05moOgooooHf=Skno_moOg00Goool01_Og
mno_knOWinONg]kNg]KFeP;>c/h01MK>c]kFe]kNg^OWinO_k`04kno_0^OW
i`03e]kNc]KFa/k>00?>e/h01mK>c]KFe]kWimkWimkNg[fm_HAkN`02FT9:
00B4Hf_>Q8c_W:g_YKD2kib]00[_W:GWW:G_W:gg]LK_YKgg_LKg[KgoW;gg
[Kg_g]h3oooo00>IVLc<c?o<c?l0<Lc<o`03VIW<oooooooo0?ooool8oooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01ooo
o`03c<cooooooooo00goool01_OgmooooibLW:F]YOooooOgm`?_knl01?Og
moooooooooooo`;gmoL01No_knOWimkNg]kNg]KFeP03c/k>0]kNgP03moOg
oooomoOg00?gmoL01>o_knOWimkNg]KFePC>c/h00lkFe/k>c]kNgP02g]kN
00Zm_KfDS8aJ@TYJ@T9kDUZULg?FW:G_[KGWW:G_YKd2ojg600CgW;go[LKg
W;goc]h3oooo00>IVLc<c?o<c?l0<Lc<o`03VIW<oooooooo0?ooool8oooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01ooo
o`03c<cooooooooo00ooool01>OWie9:D^o_koOgm`;oool01No_knONg^OW
ino_knOWi`02moOg0_ooo`;gmoL2kno_00ONg]kWinOFe]JDU9ASHf><S8cF
e]H01Oooo`06moOgkno_kno_kno_g^OWe/k>0lk>cP04a/K6c/k>e]KFc]KF
0^OWi`0<e[g6W8bDLe9JHcTiJd9:W6]caYbUkjg6mjg6mkg>kjg>mkg>0ooo
o`03VIW<c<coc<co037<c?l00iVIc?ooooooo`3ooooo2?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0@oooo00GFe]IBBU:UYJG>c/kgmoL00_ooo`04kooomno_inOWino_
0nOWi`0@kno_moOgmoOgmoOgoooomoOgkno_moOgoooog]kNW9bLQ8B4Hf=S
Q8B4_Kfmkno_0_ooo`;gmoL01OO_knO_knOWimkNg]KFeP02c/k>00K>a/Jm
a/Jma/Jma/K>c/kFe]H3g]KF00NeW9bLQ8acDUY[@TZ<Hf_6W:GoinL00ooo
o`03VIW<c<coc<co037<c?l00iVIc?ooooooo`3ooooo2?ooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00Ooool00lc<oooo
ooooo`0=oooo00?gmoOoooogmoL00_ooo`07kno__KfmS8b<Lg=cS8b<_KFe
inOW00;oool2moOg0^OWi`;Ng]h2inOW0oOgm`;oool02_Ogmoooooooono_
kkfm_HB4Q6=SHg]kNkfe]MKNgP;gmoL04?ooooOgmoOgmoOgmno_kmKFe]KF
g/k>c/K>c[g6a[fm_Kg6a/kFc[g6a]KFe_Ogm`;oool00oO_knoWkoooo`03
oooo00>IVLc<c?o<c?l0<Lc<o`03VIW<oooooooo0?ooool8oooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<co
oooooooo00coool00oOgmoooooOgm`04oooo00[gmoOoooooooooooo>c/jL
W9akNg^4Q8BUYJGNg]h2oooo00KgmoOWknoWinO_knoNg]k_knl:oooo00?_
knnm_Kf<S8`00W=cL`04YJFUc/k>kno_kno_0_Ogm`07imkWmoOgknO_g]kN
e]KFa/k>_LK600;6c/h00nooooooooooo`06oooo00>IVLc<c?o<c?l0<Lc<
o`03VIW<oooooooo0?ooool8oooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooooooo013oool00oOgmooo
ooooo`04oooo00KgmoOooooooooooooNg]jUYJD2Ng]k00JLW9c>c/k_knog
moO_knogmoL>oooo00WgmoOFe]JLW9acLg=[Jf^DU9Bm_KgWinO_g]h00_O_
k`07mnO_inOWg]kNe]KNc]KFooookooo00;oool00nooooooooooo`02oooo
00>IVLc<c?o<c?l0<Lc<o`03VIW<oooooooo0?ooool8oooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01oooo`03c<cooooo
oooo00[oool01OOgmoooooooooooooOgm`0@oooo00G_knnm]KF<S8c6a/Kg
moL05?ooo`07g]kNYJFUQ7]kHf=SQ7]k[Jf]e]KF00;_knl00noWknO_koOg
m`04oooo00GgmoOooooooooooonIVL`0<lc<o`03VIW<oooooooo0?ooool8
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
1oooo`03c<cooooooooo00goool00oOgmoooooooo`0/oooo00K_oonma[f4
Q8ASHf=[Lf_6a/H:oooo00>IVLc<c?o<c?l0<Lc<o`03VIW<oooooooo0?oo
ool8oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QV
IVH01oooo`03c<cooooooooo04coool00iVIc<c<olc<o`0ac<co00>IVLco
ooooool0ooooo`Soool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SP
f8S0^8S0^6IVIP07oooo00?<c?ooooooool0C?ooocFIVLcooooo2_ooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV0?oooonE
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
oooooiGoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP03oooo00O_knn][JeJJf>LW9cWa/KWinOgmoL01?ooo`03kooomoOg
oooo0?oooon4oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH00_ooo`0;g]kWU8b<41P@BTY::B4Q[G=kNg]kU8b<[Jf]e[g6
kno_0?oooon8oooo00EVIVKooon8`;R8`;Q8T8P00@00000001N8`;S8h=R8
`;R8`;QVIVKooooWknnm_KdY<BVma[goooli627>Q8c>Lg_6Jg>]Jf^LHf^<
Jg>LS8bm]KGFe]K_knogmoL0oooooh?oool01FIVI_ooohS0^8S0^4R@R001
000000002HS0^<SPf8S0^8S0^6IVI_OgmmK>eYbDW34i>@02oooo00mkDU[>
NhCoNiC_LhcWNhC>Lg^mJg>UHf^UHf>DJg>4Q8BLW9bm_KgNg]kgknl0oooo
oh3oool01FIVI_ooohS0^8S0^4R@R001000000002HS0^<SPf8S0^8S0^6IV
I^OWilK>cXbDS5YJFP02oooo00AcFV?>NiCoS:goS:D2ohBL0_MkS00;kf=k
ieYcaV]c[F][YF=SU6]cU8B4YJfUa/k>g^o_moOg00;oool00noooooooooo
o`04oooo00?_ooooooooool0ooooog3oool01FIVI_ooohS0^8S0^4R@R001
000000002HS0^<SPf8S0^8S0^6IVI_OWimKFgZF]YF]cJ`02oooo01M[Lf_N
S:goYLkoYLkgU;goU;GgU:goS:G_S9coQ9c_Q9CNNhcFLhC>Lg^mJg>]Jf^U
Hf>UJf^LQ8beW9c>a/kWinOoool00nooo`_oool00nooooOgmoooo`3ooooo
Ioooo`05IVIVooooR<2hR<2hB92800400000000@R<2hb>3HR<2hR<2hIVIV
mno_ino_[Jf]Jf=SimkWe]kNHdYBaW>DoiBeoibmojG60_nUcP0DojG6miBm
kiBmohb]ohbUmg^DmhBDmg^<ig^4kf=kif]k]G=cYF]cW6=[U6]cW8b<_KFe
c]kFioOgmoOg1oooo`03moOgoooooooo0?oooomZoooo00EVIVKooon8`;R8
`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`0=_KfmJg=[imkW
c]KFJeYJaW>Dmf^4mg><mg>DmhBUoiBeoibmojG600;oYLh05onL_OnD]On<
[On<[On4W?MkU?McU>n4U>MkQ=IcNliSLlIcLjEcLia[LiacNjfUYKfm_NON
g_OgmnooooooooOgmnooo`07oooo00?gmoOoooooool0ooooof?oool01FIV
I_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00S6
a/J4Q8CgmoOWknn<Ng_NS:goU;GoS:d2mg>D00C_LhcgLiCoQ9coS:D2ojG6
0_neeP0DojG>ojG6miBmkhbemg^DohBLmg><mg^<mg^Dkf^4eW=kcV=c]G=c
YF]cYG=cYG]k]IbL_KfminOWkoooooooofgoool01FIVI_ooohS0^8S0^4R@
R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00K>e/j4Q8C_inoWinND
Q8CNS:d2oibm00CoU;GoS:goS:GgQ:D2mg^D00KNNiCoQ9coU:goU;GoYLKo
YLh2okGF00GoYLkoYLKoU;GoS:GgNi@00oMcU00=mg^<ig^4eW=kaV]c]G=c
[F][YG=cYG]k]Jf]e/k>inOWmoOgoooo00?_ooooooooIOooo`05IVIVoooo
R<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool01[g6aW]k
NmK>e/k>cV]cJlikU0?oS:d00onD]OnL_OnL_@02mibm0_n<[@09miB]mhBU
mhBUmiB]ohb]oiBeojG6okGFojG>00;oYLH02OnL_OND[ON4YOn4W?mkU?Mk
U?N4U>MkS=ikQ002cV=c00VULg^LJg>LLg^]S9Bm]KGNc]Kgknooooo_ool0
ooooofCoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0
^6IVIP02oooo00K>e/j<S8c_inoNinNDLg_>Ni`2ohb]0_N4Y@08ohb]oiBe
oibmoibmojG6ojG>ojG6oibm0_nD]@09ohbUohBLkg^UmhbUoiBemibmojG6
ojg>ojG600;oW;d04^n<]ON4YNmkYOn4W>mkYOMkU>n4U>MkS=IcNlIcNkE[
NjE[LiA[LiakNjf<U<K6a]KFe_O_kooooomRoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`0:e/K>S8b<koookno_
W9BL]IbLojG>ojG6oibmoiBe0onD[@0AoiBekjG>mibmmjg6ojG>ojg>ojG>
ojG6oibmoiBeohb]ohbUkg^Umg^DmhBUohb]oiBe00?oW;d05?nD]On<[On<
YOn<YON4YOMkU?McU>n4U>mkS>McS=i[NliSLliJJjE[Jia[LiacNkFLW=Jm
a]kNg^ogm`;_ool2oooo00C_ooooooooooo_ooooooooE_ooo`05IVIVoooo
R<2hR<2hB92800400000000@R<2hb>3HR<2hR<2hIVIVkoooooooc/k>Q7]k
g^OWe]KFW8B<W8bDokGFojG>ojg>0_nUaP04ojg6oibmoibmoiB]0onD]@04
ojG6mjg6ojg>ojG>0_nUaP;oW;d02?nD]NmkYNmkYNN<W>McS>n4U?n<YOn<
[@;oU;D2ohb]0_n<Y@06ohBLmg^DmhBDmg^DkhBDkg^<0/ikQ00:]F]kYF]c
YF]cU7=k[HbD_JFUc/k>imkNooookooo0_ooo`03kooooooooooo0?oooomD
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH0
0_ooo`0:e/k>Q7]kg^OWc/k>U8b<W7=kkjG>kjg6mibmojg60_n]cPCo]MH0
1?n]c_nUa_nL_OnD]@;oW;d01ON]a_nUc_nUc_n]a_nUaP02oibm00SoU;Go
S:GoQ9cNNiC_LhcWLhcgNiCoS:D3ohb]0_n<Y@;oQ9`02?MkU?N4U?McU?n4
W=ikU>MkS<ikQ;e[L`:eLg<01iAcNjf<U?o>g^ooooOgmoooonooo`3ooooo
E_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00;oool01mK>cXb<S>ogmnOWijfUYIAcNonUaP02mibm00GoU;GoW;goYLKo
[LKo[Lh00_NmgP?o]Mh00onee_n]c_nUaP02mibm1?nD]@;oW;d2oiBe00Co
S:goQ9cgNiCgLh`3if>400C_LhcgNiCoQ9coS:d2ohbU0on4W0;oNi@01?n4
U?N4U>mkS>MkQ0;6Nh`00nnU]Oooonooo`3oooooF?ooo`05IVIVooooR<2h
R<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;oool02Lk6cXB4Q?Og
mnoWkkfe]IAcNoo>konme_n]cP02ojg600?g[KggW;gg[LH00_n]cP0=okg>
okGNolKWolKWmlKWmkgWokGFojg>ojG6mibmoiBemiB]ohbU00;oS:d2oiB]
00KoU;GoS:goS:GoQ9coNiC_Lh`2if>400CNFW_WHhC_LhcgNi@7ohBL0_mk
U004khbLgW^<gW^DknO_oooooeWoool01FIVI_ooohS0^8S0^4R@R0010000
00003HS0^<SPf8S0^8S0^6IVI^ooooooomK>cXAkNmkWimKFe[fe]G]SL`04
okGN00Coa]ko]Mko_MKg_MH2ojg>0_NUcP05okgFokGNokGNokGNolKW00;o
]Mh2okGF00Go[LkgW;ggYKGgQ:GgS:D00_N4Y@?oS:D2ohBL01CoNiCgNiC_
LhcWHhCWHg_NFW_NFW?_JhC_LhcgNiCoQ9CoQ9coS:GoQ9coS:GgNiCgLiCW
Jhc_g]k_ooooooooF?ooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00;oool01]K>cXAkNmkWilkFe[fe]G=BFP;g_MH01ONU
c_nee_neg_neg_o6i`02olk_00?oa^Oo]Mko_MH00on]cP05ojg6mkgFmkgF
mkgFokGF00;o]Mh2okGF00SoYLKoW;ggU:g_S9c_Q9CgLiC_Lhc_Nh`2ohBD
0omkU005mg><kg><kf^4ieYcgV=c00;NFW<00nMSNnmcS?McS002ohbU0_m[
S003g/kFmoOgmoOg0?oooomGoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH00_ooo`09e/k>S8b<ooookno_e[g6Ne9JolKW
okgFojg>00;o[LH01?N]a_nee_neg_negP;oa^L00ooFkoo>koo>k`02mlKW
00Co]MKo[Lko[LKg[LH2ojg60_n]cP;oYLH01onL_OnD]OnD]On<YOn4W?Mc
U>M[N`02kf^400?WNhCgNhcoNi@00omkU003mf^4mg><kf=k00?NFW<01Nmc
S?McU?mkU?n4W?NmeP02kooooooooeOoool01FIVI_ooohS0^8S0^4R@R001
000000003XS0^<SPf8S0^8S0^6IVI_ooooOgmmK>cXakQ?OgmoO_knOWieYS
F_o>m`?oa^L01?o6g_nee_Nmc_neeP;g_MH2okGN00koa^Ooc^ooe^ooc_Oo
c^ooa^Oo]Mko_MKo[LkoYLKgW;ggYKGoW;ggYKD3oibm00OoU;GoU:goS:Go
Q9cgNiC_NhcWHh@00^MSN`03if]kkf=kkg><00;gLh`02NmcS?McS>m[Q>m[
Q?McS?mkU?N4YOMkU?nmeP3oooooFOooo`05IVIVooooR<2hR<2hB9280040
00000005R<2hb>3HR<2hR<2hIVIV00;oool02<k>cXAkNnONg]k>e]K6cT92
@_o>koNmgP;oa^L2olk_00Goa^Ooc^ooa^Ooa]kg_Mh00_NmeP;g_Mh3olKW
00Soc^ooa^Ooa]koa]Ko[Lko[LKg[KgoW;d2miB]00CgU:GgU:goS:ggU:d3
ohbU00WoQ9cgNiC_Lhc_JhCWHg_NFW?NHg?WHg__Jh@00oMcS0;oQ9`01ON<
YOMkU?nmc_ooonooo`3oooooEoooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00;oool01mKFeXb<S?O_knONg]kFeT8i>Oo6
i`04mkgN00Ooa^Ooc^ooe^oog_Ooc_Ooe^ooc^l00_o6i`;g_Mh00oNmioNm
g_NmgP04okGN00[o_MKo[Lko[LKoW;ggYKGoS:ggS:G_S9c_Q9CgNi@5ohBL
0_mkU00<mg><kg><if]kgV=ccV=cgV=cif]kkg><ohbUmhBUmg^DokgFoooo
oeWoool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IV
IP02oooo00_>c/j<S8coooogknoWg^M:>D;oc_Ooa^Ooc]kg_Mkg_MH00oNm
gP03olKWomK_omkg00;og_L01ooFkoo>mooFkoOFkoO6ioNmg^nmeP02mkgF
0_nmeP0:okGFojg>ojg>ojg>ojg6mjFeoiB]mhbUmhBDkhBD0^mcS00Big><
kg^<mg^DmhBDohBLmhBDmg>Dkg><kf^4if>4gV]kkf^4ohbUmhbUmg^DokgF
ooookooo3Oooo`030000oooooooo00Coool00`000?ooooooo`3ooooo@?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;o
ool01lk>cXb<S?OgmoO_knOWidY:B_oNm`02olkg00Gog_Ooa^Ooc^ooa^Oo
c]h00oO6i`05olKWomK_olkgolkgomkg00?oc_L2olKW00?g_Mk_[Lk_[Lh0
0_N]aP03mibmoibmmjfm00;oW;d03_NU]OnD]OnD[Nn<W>n4U>MkS>MSQ>Mk
Q>MSQ>MkQ>mcS>n4U?n4W?N4U0;gNi@01ON4U?n<[ON<YOn<YOnmcP0?oooo
00<0003oooooool01?ooo`030000oooooooo0?oooom0oooo00EVIVKooon8
`;R8`;Q8T8P00@00000000j8`;S8h=R8`;R8`;QVIVK_ooooooo>c/ikNg__
knoNg]kFe]I2@T;ga^L2omK_00Ooc_Ooe^ooe^oog_Ooc_Oog_Ooc_L00_oF
k`?ge^l04OoFkooNmooFkooFkoo>mooFkoo>koo6ioo6g_n]c_N]a^nU_NnL
]OND[ONL[ONDYOn<Y@03oiB]0_n<Y@05ohBLmg^Dkg^<if>4ig^400;NJg/0
2>MkQ>McS?MkU?n4W?n<YNmkYOn<YONeaPOoool00`000?ooooooo`03oooo
00@0003oool0003oool200000oooo`040000oooo000000000oooo`040000
oooooooooooo0`000?ooooleoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH00_ooo`07c]KFS8b<ooooinOWg]KFFUYJmkg>
00;oa^L01OO6ioOFioo>kooFkoo>m`08omkg0_o6i`0>mlKWmmKWolKWomK_
olKWolk_olKWokGNokg>ojg6mjfmoiBemiBUkhbL0^N<U003khbLohBLkhbL
00?_S9`01On4U?N4U>mkS>McS>MkQ002gV]k00GWLhcoS:GgU:goS:Gg[Kd0
1oooo`030000oooooooo00?oool010000?ooo`00000000;oool00`000?oo
ooooo`0200000_ooo`040000oooooooo00000_ooo`050000oooooooooooo
00000?ooooldoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH00_ooo`07c/k>S8b<oooomoOginOWLf=[kkgF00;oe^l01Oo6
iooFkoO6ioO6ioOFk`02omK_1ooNm`03omK_olKWmkgN00;g_MH01ONmg_Nm
e_nee_nee_nmeP02ojg>00So[LKoW;ggYKGoU:goS:G_S9cWS9CWNh`2khBD
00CoQ9cgQ9C_S9coQ9`2mhBD0^mkS005mhBDohb]miB]ohb]kjFm00Soool0
1@000?ooooooooooo`000002oooo00D0003oooooooooool000000_ooo`05
0000oooooooooooo000000;oool010000?ooooooo`000?oooolhoooo00EV
IVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`07
c/k>Q8B4kno_inOWg]kNS9B<_Ibe00Oog_L01OOWkooFkoOFkoOFkooFk`07
omkg00Ooc_Ooa^Og_Mkg_MKg_Lkg]LKg[LH00_N]_@03ojg6mjfmmjfm00;g
YKD01_NL[ONDYONDYNn4U>MkS=ikS0?WNh`02Nn4U?N4U>n4U>n<W>nDW?nD
[On<YNnL[OnD]@08oooo1@0000;oool01@000?ooooooooooo`000002oooo
00D0003oooooooooool000000_ooo`030000oooooooo00D0003ooooo=?oo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;o
ool01mKFeXb<S>o_kmkNg/K6aXakQ9bDW003omK_2ooNm`03omK_omkgomK_
00Coe^l2olk_00Coa]ko_MKo[Lko[LH2mjFe1?NL[@CoU:d01On<YOn4W>n4
U>mkS>MkQ002gW^400WWNhC_NhcgQ9CoU;GoS:G_W:goU:goooogmoL01_oo
o`050000oooooooooooo000000;oool01@000?ooooooooooo`000002oooo
00D0003oooooooooool000000_ooo`040000oooooooo00000oooo`030000
oooooooo0?oooolboooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8
h=R8`;R8`;QVIVH00_ooo`07c/k>S8b<ooookno_e]KFYJFUU7=k00;og_L0
0ooFkoo>mooFk`0;omkg00?oe^oge^ooa^L00_o6i`06olk_olKWolKWolKN
olKFokgF0_n]aP04mjFeoiB]miBUkiBU0^n<W004kiBUmhbUohbUmiBU0_n<
Y@0:kiBLkhBDkg^<ig^<gW^<ig^<oiBeohbUkib]oiBe2Oooo`030000oooo
000000?oool200000_ooo`030000oooooooo00800002oooo00@0003ooooo
ool00002oooo00D0003oooooooooool00000ooooocCoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00O>c/j4Q8Co
ooogmoO_kno6c/ikHg<00_oNm`05mnO_omkgmnO_omK_mnO_00Gog_L00oOg
mooNmoOgm`03omkg0_oFk`03olKWolKNmkgF00;o_MH01?o6e_nme_nme_n]
cP;o[LH01?NU]OnD[NnDW>n<W0?WS9@01^n4U>n<W>n<W>n<W?n<YNnDW0;_
S9`00oN4U?NU]On<Y@02miB]00?gknooooooool01_ooo`030000oooo0000
00?oool010000?ooo`00000000?oool010000?ooo`00000000?oool01000
0?ooooooooooo`<0003ooooo=Oooo`05IVIVooooR<2hR<2hB92800400000
0005R<2hb>3HR<2hR<2hIVIV00;oool02<k>cXB4Q?OgmnOWimKFe/k6aV=B
F_oooa?og_L01ooFkoOFioo6ioo6e_Nmc_NUc_NeaP05mjfm0_NU]@0BoiB]
miBUmiBUkhbLihbDgW^4gW^<ig^<gW^DkhbLkhBDkhbLmhbUmjFeoiB]mib]
ohbUmnOW2?ooo`030000oooo0000017oool00`000?ooooooo`3ooooo>Ooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;o
ool02Lk>cXB4Q?OgmnOWilk>c[g6_E92@_oNmoOgm`05omkg00Cooooog_Oo
ioogmoL:omkg00Soc_Ooe^ooa^Ooc]koa]Ko[LKg[LKg[Kd2mjFe1?NL[@;o
U:d01?n<YONDYON<YNn<W0;WS9@3gW^<00KWS9CgYKGoS:GgU:goS:g_g]h9
oooo00<0003oooooool04?ooo`030000oooooooo0?oooolioooo00EVIVKo
oon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`07c/k>
S8b<ooooooooinOWe]KFBSU200Sog_L02_oooooNmooWoooNmooWoooooooN
mooWoooNmoOWk`?oe^l03_OFioo6iooFkoo6ioo>g_o6g_nme_n]a_N]_ONU
]ONL[ONDYNnDYNnDW0;_U:D00oN<YONDYONDY@02miBU00?_U9c_S9cWS9@0
0^N<U005mjfmmiB]mib]ohbUmmkN0?oooomHoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_ooo`08e]KFS8b<oooooooo
kno_inOWFT9:oooo1_oNm`0:moOgomkgoooooooomoOgooooomkgooooomkg
oooo0_oNm`;oe^l01_o6ioo>g_Nme_Nme_nme_o6eP?o_Lh01on]a_N]_ON]
_OnD[ONL[ONDYNnDW003ihbD00GWS9c_S9cgU:GgU:G_U:D00_NDY@05mjFe
oiB]mib]ohbUkmkN0?oooomHoooo00EVIVKooon8`;R8`;Q8T8P00@000000
00F8`;S8h=R8`;R8`;QVIVH00_ooo`08c/k>S8b<kno_inOWg]kNe]KFFTYB
imkW0_ooo`03omkgoooooooo00Oog_L00ooWoooNmooNm`05omkg00Gginoo
e^ooa^Ooc]kg_Lh00_NeaP;g[Kd00on]a_N]_ON]_@02mjFe0_NL[@06kibU
kiBLihbLihbDgXB<gW^D0^N<U0;_S9`01oN]_ONL[ONL[ONL[On]c_ooonoo
o`3oooooE_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2h
R<2hIVIV00;oool02lk>cXb<S?ooono_kmkNg/K6aW=SJmK>c_oNmoOWkoOg
m`02omkg00KoooooioogmoOooooog_Ooiol3omkg00Koiooog_Oog_Oog_Og
inoog_L3omK_0_o6i`04olKFokg>ojg6mjfm0oNU]@04mib]kib]mib]miBU
0_NL[@06oiB]kibUkiBLihbLihbDgW^D0]j4S005mjfmmib]kjfemib]ojg6
0?oooomHoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8
`;QVIVH00_ooo`0Fc/k>S8b<oooooooomoOgg]kNU8b<W9BLooooomkgoooo
knO_ooooomkgmoOgonOoomkgonOomoOgonOomoOgonOo1?oNm`;oe^l00oOF
ioO6ioo>gP02olkN00Goa]koa]Ko_MKo[LKg[Kd00_NU]@05kibUiibUkiBU
kiBUkibU00KgU:D02>nDW>N<W>N<W?NL_ONL[ONU]Nn]]On]a_oooomHoooo
00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00_oo
o`08c/k>S8b<oooooooomoOgkno_[Jf]W9BL0oooo`;og_L05?OgmooNmoOg
mooNmooooooNmooooooNmooooooNmooWoooNmoOgmooNmooFkooWioo6ioo>
g_o6e_NmeP?o_Lh00oNma_nmc_n]aP02mjfm00GoU:ggW:g_W:G_S9cWS9@0
0nN<W005kiBLkibUkiBUkiBUmiBU00?gYKD00oNL[On]a_ooo`3oooooEooo
o`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00;o
ool02<k>cXb<S?Ogmno_kmkNg]KFe]kFeUY:DP;oool04OoNmooooooooooN
mooooooWoooooooNmooooooNmoOgmooNmooooooNmooWoooNmoOgm`03omkg
00Kge^Ooc]koa]Kg_Lkg]LKo[LH2mjfm0_NU]@;g[Kd2mjFe00K_YJG_W:G_
W:GWS9cWS9CNNi@3ihbD00OWS9cgYKGgYKGgYKGgW:gg[KggmoL0oooooeOo
ool01FIVI_ooohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02
oooo00W>c/j<S8coooogmoOWinOFe]KFc/hY8B7Wg^L00oooo`03mno_onOo
oooo00Coool01?oNmooooooNmoooo`;gmoL3omkg1?oFk`05mmKWolkNolKF
mkg6ojg600?gYKD01>nL[ONL[ONL[ONU]@;gW:d02OnD[ONDYNnDYNnLYNnD
W>N<U=ikU>N<U?N]_@02mjFe00?gW:g_YKggknl0oooooeOoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP02oooo00?>c/j<
S8coool00_ooo`07kno_g]kN_KFe@STie/k>ooooomkg00[oool01OoWoooN
mooNmooNmoO_k`02omK_0_OFi`0;olKWolkNolKWolkNolKFolK>okg>mkg6
mjfmmjFekjFU00;WW:D5kibU0_NL[@03miBUkibUkibU00GgYKD00noWkooo
ooooo`3oooooEOooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00;oool00lk>cXb<S?ooo`02oooo00WgmoOgknoWinO>a/IS
DUY2@T9cHf^DU9Cginl01Oooo`03onOooooooooo00?oool02OoWoooNmooN
mooNmooFkoo>g_o>e_Nme_O6cP04okg>0oN]_@;gYKD01?NL[NnLYNN<W>N<
W0;WS9@2ihbL0^nLY@03mib]mjfmmjFe00;gYKD00nnU]NOWioooo`3ooooo
E_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00;oool01lk>cYBDU?Ogmno_knOWimkNg^OWi`02g]kN0^OWi`07c/k>W9bL
Jf][FTYBLeYSW9BLkmkN00;oool02?OgmooooooNmooooooWooOgmooNmoOg
m`;og_L01OoFkooNmoo6ioNme_NmcP02mkg600?_[KGg[Kgg[Kd01?N]_@;g
YKD00nnL[ONL[NNLY@05ihbD0_NU]@04mkg6kjFmoibmolkFoooooeOoool0
1FIVI_ooohS0^8S0^4R@R001000000002HS0^<SPf8S0^8S0^6IVI_ooooOg
mno_kg=cL`02oooo00OgmoOWinO>c/k>c/k6a/K>c/kFe]H00mkNgP08imkN
g/kF]Jf]Lg=cBTY:He9JW8bDe/K>0_ooo`03moOgomkgomkg00;og_L02_oW
oooNmooFkooWiooFkoo>g_o6c_n]a_o6c_NU]@KgW:d01nnUYONL[ONL[ONL
[ONDYNnUYNnDW002ihbL00KgYKGg[KggYKG_[KGgYKGoa/koooooEoooo`05
IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV00?oool0
0e9:D_ooooooo`02oooo00?_knoWinONg]h01<k>cP0Aa/K6e]KFe]KFg]KF
g]kNinOWg]KF[JFUNg]kFTYBHe9JS7^4a/K6omkgoooommK_imkW00Goe^l0
1Oo6ioo>g_nme_nmc_NmaP02mjfm00CgYKG_YJGWW:GWW:D3kibU00__W:g_
YJGgU:G_YJGgU:GgYKGg[Kgg_LK_[KGoW;goa/h0oooooeOoool01FIVI_oo
ohS0^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP03oooo00>][Jek
Ng_oool00oooo`05moOgkno_inOWinOWg]kN00;Fe]H01/k>c/K>c/K6a/K6
a/K>c/kFeP;Ng]h04>OWinONikfm_HAcQ5Y2DUY2BXAcQ;fL]OOFiooFkoOF
ioNmg_Nmc_nme_o6g_negP;o_MH05Onmc_n]a_N]_Nn]]ONL[Nn]]NnUYNN<
W>NLYNN<W=jDYNN<W>nUYNnLYONU]ONea_NU]NnU_ON]_ONma_Ogm`3ooooo
E_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3HR<2hR<2hIVIV
00Coool017=cLkfe]OOgmno_k`;Ng]h2inOW01C_knogmoO_knoWinONinON
g]kFg]k>e]K6c/k6a/Jma/K6c/k6a/K>a/kFc/kNg]kWinOWg^Nm_KfDU9@2
HdYB00McFV>eW9c__MKoinOg_Mkg_Lk_[Lh00_N]aP09mkG6ojg6mkg6mkg6
mjFemjfmmib]kibUkjFU00;WW:D02MjDYNN<U?NU]ON]a_N]_ONea_nL_ONm
a_oNm`3oooooE_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00Coool01nOWie9:D_ooooooono_kmkNg]KFeP02c/k>00?F
e]KNg]kWinL00no_k`;WinL00mkWimKNg]KFeP05c/k>00cFc/kFe]KWg]kW
inOWg^ONc]JLU9acFV=J>D9[BUZ<Jg?_[KD2mkg600Kg[KggYKGgW:ggYKGg
[KggYKD2mjfm00WgYKGgW:ggW:g_W:GWW:Gg[Kgg]LKg[Kgg[LH00_N]_@03
mnO_oooooooo0?oooomDoooo00EVIVKooon8`;R8`;Q8T8P00@00000000J8
`;S8h=R8`;R8`;QVIVKoool2moOg0_ooo`03BTY:oooooooo00;oool00oOg
mnOWimkNgP03e]KF00G>c/kFe]KNg]kNg]kWinL00^o_k`03inOWg^OWg]kN
00;Fg]h01MKFe/kFc/k>c/k>c]K>cP02e]KF00KNe]KWg^OWinOFc/jm]KEc
FV<2LdYB00ZDJg?6U9cW[KG_YKgW[KGNU:G_W:ggYKG_[KG_W:d3mjFe00Cg
[Kg_[LKg[Kgg]LH2mjfm00?ginOoooooool0oooooeCoool01FIVI_ooohS0
^8S0^4R@R001000000001HS0^<SPf8S0^8S0^6IVIP03oooo00GgmoOooomS
Hf?_knogmoL01Oooo`06moOgkno_inOWimkNg]kNe]KF0/k>cP05e/k>g]KF
g]kNinOWino_00C_knl2inOW00?Fg]k>e]K6c/h00lkFcP07e/k>e]KFg^OW
g^OWg]kN_KfmQ7]k009J@TX018ASJlj4S>nL[NnU]@;_W:d02^nLYNNLYNnL
[ONea^nU_ONma_N]_OnL_ON]_NoNg_oooomFoooo00EVIVKooon8`;R8`;Q8
T8P00@00000000F8`;S8h=R8`;R8`;QVIVH00oooo`06moOgooooW9bLYJfU
oooomoOg0no_k`04moOgoooooooooooo0_Ogm`05kno_inOWg]kNg]kNe]KF
00?>c/h2g]kN00?gmoOoooogmoL00oOgm`04kno_inOWg]kNe]KF1<k>cP03
c]KFc/k>g]kN00;Ng]h02[fm_IB<S5Y2BUY2@W]BFZEcLmJLYNn]]NNLYNnU
_@;o[LH01?NL_On]a_NL_Oo>g_oooomFoooo00EVIVKooon8`;R8`;Q8T8P0
0@00000000F8`;S8h=R8`;R8`;QVIVH01Oooo`04inOWDTYBkno_moOg0_oo
o`05kno_imkNinOWkno_inOW00;gmoL2oooo0_Ogm`;_knl01mkNg^OWimKF
eYBDU6=SHhb<S=KFeP05oooo00KgmoO_kno_kno_knoNinOFc/h3c/k>00C6
a/K>c/kFe]K>e]H2inOW00cF_LJLS9AcDUYS>CU[@TZLJg?6W:G_[LKg[LKg
_Lk_[Lkg_LkoooooE_ooo`05IVIVooooR<2hR<2hB928004000000005R<2h
b>3HR<2hR<2hIVIV00Koool01MKFeU9:DZFUYLk>c_Ogm`02oooo00C_ooog
knoWinOWknl3inOW013_knogmoOgmoOgmoOoooogmoO_knogmoOooooNg]jL
W9b4Q8ASHf>4Q8Bm_Kg_knl2oooo0_Ogm`05mno_ino_inOWg]kNe]KF00;>
c/h01/k6a[g6a[g6a[g6a/k>c]KFeP?Ne]H01kFLW9b4S7=BFV]2BXaSJlJL
YOoWi`3oooooE_ooo`05IVIVooooR<2hR<2hB928004000000005R<2hb>3H
R<2hR<2hIVIV00?oool00oOgmoooooOgm`02oooo00O_knnm_Kf<S8acLg><
S8bm]KGWinL00_ooo`;gmoL2inOW0]kNgP;WinL3moOg0_ooo`0:moOgoooo
ooookno__KfmQ8B4Hf=SNg]k_KFee]kN0_Ogm`0@oooomoOgmoOgmoOgkno_
e]KFe]KNc/k>a/k>_LK6_Kfm_LK6c]K>_LK6e]KFmoOg0_ooo`03mno_knO_
oooo0?oooomFoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8`;S8h=R8
`;R8`;QVIVH00_ooo`03moOgoooomoOg00Coool02_Ogmoooooooooooolk>
cYbLW7]kNhB4Q:FUYMkNgP;oool01_OgmnO_knOWino_kmkNg^o_k`[oool0
0no_kkfm_Hb<S002Lg=c00BUYJG>c/k_kno_knl2moOg00OWg^OgmoO_inoN
g]kFe]K6c/jma/H00/K>cP03kooooooooooo0?oooomIoooo00EVIVKooon8
`;R8`;Q8T8P00@00000000F8`;S8h=R8`;R8`;QVIVH01_ooo`03moOgoooo
oooo00Coool01_OgmoooooooooooomkNgZFUY@9kNg/01YbLW<k>c^o_koOg
mno_koOgm`koool02OOgmmKFeYbLW7=cLf][JiBDU;fm_NOWinoNgP02mno_
00OginoWinONg]kFe]k>e]Koooo_ool00_ooo`03kooooooooooo0?oooomE
oooo00EVIVKooon8`;R8`;Q8T8P00@00000000J8`;S8h=R8`;R8`;QVIVKg
moL3oooo00?gmoOoooooool03_ooo`05kno__KFeS8b<a/K6moOg01Coool0
1mkNgZFUYHAkNf=SHhAkNjf][MKFeP02kno_00?_inoWknogmoL01?ooo`03
moOgoooooooo0?oooomDoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH00oooo`03moOgoooooooo02coool01^oookg6_HB4
Q6=SHf]cJlK6a_oooomMoooo00EVIVKooon8`;R8`;Q8T8P00@00000000F8
`;S8h=R8`;R8`;QVIVH0oooooiGoool01Lc<c?ooohS0^8S0^4R@R0010000
00001HS0^<SPf8S0^8S0^6IVIP3oooooUOooo`05IVIVooooR<2hR<2hB928
004000000004R<2hb>3HR<2hR<2hofIVIYMVIVH01<c<c8S0^8S0^4R@R040
00000003R<2hb>3HR<2h0?n8`;RKR<2h0DR@R04000000004R<2hb>3HR<2h
R<2h5000P0800H0200:00P03P@8018401`05P@05PP06PP06PP47PP48PP48
P`020@V30P4:P`812h@20@b40P4=Q0030@j50Pn50Pn5008248D20Q660P8B
QP070Q>60Q>70QB70QB70QF70QJ70aJ800835hP20aR800@36HP36HT36XT3
6XT20a^900<378X37HX37HX00P@NRP847h/2122;00@48H/48H`48X`48X`2
12><00<498`49Hd59Hd00PDVS@041BN=1BN>1BR>1BR>0PDYSP85:Xl00`D[
S`D/S`D/S`021Rf@0PH^T0041Rn@1RnA1S2A1S2A0PHaT@071S:A1S>B1S>B
1SBB1cBB1cFB1cFC0087=Y<21cNC0PLhU0031cVD1cZD1cZD0087>iD223bE
0PPmU@88?YH223nF00<8@9H8@IL8@IL00PQ2U`0424>G2D>H2DBH2DBH0PU5
V089AYT22DNI00<9B9T9BIT9BIX00PU:VP8:BiX22TbK0PY=V`032TjK2TjL
2TnL008:D9`010YAW0YAW@YBW@]BW@8;Did01`]DW@]DWP]EWP]EWP]FWP]G
WP]GW`022eRO0P]IW`8<FZ0235^P00<<G:0<G:4<GJ400PaNX@0835nQ35nR
362R362R366R3F6R3F:R3F:S0PeSX`033FBS3FFS3FFT008=IZ@23FNT0PeX
Y@8>JJD01@iZY@iZYPi[YPi[YPi/YP023VfV0Pi^Y`8>KjL010i`Y`m`Z0ma
Z0maZ08?LZP00`mcZ@mdZ@mdZ@023gFY0PmfZP8?MjX247RZ0Q1iZ`0347Z[
47^[47^[008@O:`247f/00@@OZ`@OZd@OjdAOjd24H2]00<APJhAPZhAPZh0
0Q63[P044HB^4HB_4HF_4HF_0Q66[`8BQk000a:8/1:9/1:9/0024XZa0Q:;
/@064Xba4Xbb4Xfb4Xfb4Xjb4hjb0Q>?/`054i2c4i6c4i6c4i:c4i:d008C
Tk@24iBd0Q>E]@8DU[D00aBG]ABH]QBH]P0259Vf00@DV[HDV[LDVkLDVkL2
59bg00<DWKLEWKPEW[P00QFO^0045J2h5J2i5J6i5J6i0QFR^@8EXkX25JBj
00<FYKXFY[/FY[/00QJW^`8FZ;/25ZVl0QJZ_0035Z^l5Z^m5Zbm008G[Kd0
11N^_AN^_QN__QN__P8G/;h25k6o0QNb_`035k>o6;C06;C003@H]<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h1000P003VjOa<d>U<d>U00Tc@jD4
00200P01P0800X0200>10P04P@0700F100F200J200J20@N20@R20@R30081
2H<20@Z30P4;Q08138@20@f400<13XD23hD23hD00P8@Q@824HH20Q:600L2
4hH24hL258L258L25HL25XL35XP00P<GR08368P010<IR0<IR@<JR@<JR@83
6hT00`<LRP<MRP<MRP0211j:0P@OR`8488/010@QR`@QS0@RS0@RS0848h`0
0`@TS0@US@DUS@021BJ=00@59hd59hh5:8h5:8h21BV>0PDZS`031B^?1Bb?
1Bb?0086;I021Rj@00@6;i06;i46<946<9421S6A00L6<Y46<i86<i86=987
=987=I87=I<00PLfT`87=i<21cRD00<7>I@7>Y@7>Y@00PLkU@88?9D223fE
0PPnUP88?iH00`Q0UPQ1U`Q1U`0224:G00@8@iL9@iP9A9P9A9P22DFH0PU6
V@89AiT00`U8V@U9V@U9VP022DZJ0PY;VP8:C9/22TfK00<:CY/:CY`:Ci`0
0PY@W0042U6L2U6M2U:M2e:M0P]CW@072eBM2eBN2eFN2eFN2eJN2eNN2eNO
008;F9l22eVO0PaJX08<Fj000`aLX0aLX@aMX@0235jQ00P<Gj4<Gj8<H:8<
H:8<HJ8=HJ8=HZ8=HZ<23F>S00<=I:<=IJ<=IJ@00PeVY08=Ij@23FRU0PiY
Y@053VZU3VZV3V^V3V^V3VbV008>KJH23VjW0Pi_Y`043W2W3g2X3g6X3g6X
0PmbZ0033g>Y3gBY3gBY008?MJT23gJZ0PmgZP8@N:X247V[00<@NZ/@Nj/@
Nj/00Q1l[08@OJ`0111n[11n[A1o[A5o[@8AP:d00a61[Q62[Q62[P024H>^
00@AQ:hAQ:lAQJlAQJl24HJ_0Q:7/0034XR`4XV`4XV`008BR[424X^a00HB
S;4BS;8BSK8BSK8BS[8CS[824hnc00DCT;<CTK<CTK<CT[<CT[@00Q>C]08C
U;@24iFe0QBF]@0359Ne59Rf59Rf008DVKH011BJ]QBJ]aBK]aBK]`8DW;L0
0aBM]aFM^1FN^0025Inh00@EX;PEX;TEXKTEXKT25J:i0QFS^P8EY;X00aJU
^QJV^aJV^`025ZNk0QJX^`8FZK`25ZZl00<FZk`FZkdF[;d00QN]_@045jjm
5jjn5jnn5jnn0QN`_P8G/Kl25k:o00<G/klH]<0H]<00=1Rd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P3002000NKYo7ooon>N[JVVlBcZM:XWLRc
ZM800ZJKa005_;SMk^kdj^Waoooo<d>U00<0080200600P02P0800h4200B1
00L01H401H801X801X811h81288128<00P49P`812X<20@^40P4<Q0813H@0
0`4>Q@8?Q@8?Q@020Q250P8AQP824XH01`8CQP8CQ`8DQ`8DQ`8EQ`8FQ`<F
R0020aN80P<HR0040aV80aV90aZ90aZ90P<KR@030ab:0af:0af:00847XX2
11n;0P@PR`04126;126<12:<12:<0P@SS00312B<12F=1BF=00859Xd010DW
S@DWSPDXSPDXSP85:Hh21BZ?00<5:hl5;8l5;8l00PH]T086;Y0010H_T0H_
T@H`T@H`T@86<I401`HbT@HcTPHcTPHdTPLdTPLeTPLeT`021cJC0PLgT`87
>9@00`LiU0LjU0LjU0021c^E0PPlU@88?ID223jF0PPoUP03242F246G246G
0088@YL010Q3U`U3V0U4V0U4V089AIP22DJI0PU7V@032DRI2DVI2DVJ0089
BYX22T^J0PY<V`8:CI/00`Y>V`Y>W0Y?W0022U2L00@:DI`:DId:DYd;DYd2
2e>M00L;E9d;E9h;EIh;EIh;EYh;Eih;Eil00P]HW`8;FIl235ZP0PaKX003
35bP35bQ35fQ008<GZ4020aOX@aOXPaPXPaPXPaQXPeQXPeRXPeRX`8=Hj<0
0`eTX`eUX`eUY0023FJT0PeWY08=J:D23VVU00D>JZD>JZH>JjH>JjH>K:H0
0Pi]YP8>KZL23VnW00@>L:L?L:P?LJP?LJP23g:X00<?LjT?M:T?M:T00Pme
Z@8?MZX23gNZ0Q1hZP8@NJ/00a1jZa1kZa1kZ`0247b/0Q1m[00447j/47j]
47n]4Gn]0Q60[@034H6^4H:^4H:^008APjh01164[Q64[a65[a65[`8AQZl2
4XN`00<BR;0BRK0BRK000Q::/@8BRk401Q:</A:</Q:=/Q:=/Q:>/Q>>/P8C
Sk<01A>@/a>A/a>A/a>B/a>B]0024i>d0Q>D]08CUKD259Je00<DUkDDV;HD
V;H00QBI]P0459Zf59Zg59^g59^g0QBL]`0359fg5Ifh5Ijh008EWkP011FP
^1FP^AFQ^AFQ^@8EX[T25J>j0QFT^P035ZFj5ZJk5ZJk008FYk/25ZRk0QJY
_08FZ[`00aJ[_1J[_AJ/_@025jfm00@G[[dG[[hG[khG[kh25k2n0QNa_`8G
/[l00aNc_aRd`1Rd`00P00000QRd`10000026;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^080080019^WlOooofaJYJnUbP:l^=d02_omok>Yd_oo
oooookbhgIN:_:RMb>KVk?oooc=3Y@80080200600P02P0800h4200B100L0
1H401H801X801X811h81288128<00P49P`812X<20@^40P4<Q0813H@00`4>
Q@8?Q@8?Q@020Q250P8AQP824XH01`8CQP8CQ`8DQ`8DQ`8EQ`8FQ`<FR002
0aN80P<HR0040aV80aV90aZ90aZ90P<KR@030ab:0af:0af:00847XX211n;
0P@PR`04126;126<12:<12:<0P@SS00312B<12F=1BF=00859Xd010DWS@DW
SPDXSPDXSP85:Hh21BZ?00<5:hl5;8l5;8l00PH]T086;Y0010H_T0H_T@H`
T@H`T@86<I401`HbT@HcTPHcTPHdTPLdTPLeTPLeT`021cJC0PLgT`87>9@0
0`LiU0LjU0LjU0021c^E0PPlU@88?ID223jF0PPoUP03242F246G246G0088
@YL010Q3U`U3V0U4V0U4V089AIP22DJI0PU7V@032DRI2DVI2DVJ0089BYX2
2T^J0PY<V`8:CI/00`Y>V`Y>W0Y?W0022U2L00@:DI`:DId:DYd;DYd22e>M
00L;E9d;E9h;EIh;EIh;EYh;Eih;Eil00P]HW`8;FIl235ZP0PaKX00335bP
35bQ35fQ008<GZ4020aOX@aOXPaPXPaPXPaQXPeQXPeRXPeRX`8=Hj<00`eT
X`eUX`eUY0023FJT0PeWY08=J:D23VVU00D>JZD>JZH>JjH>JjH>K:H00Pi]
YP8>KZL23VnW00@>L:L?L:P?LJP?LJP23g:X00<?LjT?M:T?M:T00PmeZ@8?
MZX23gNZ0Q1hZP8@NJ/00a1jZa1kZa1kZ`0247b/0Q1m[00447j/47j]47n]
4Gn]0Q60[@034H6^4H:^4H:^008APjh01164[Q64[a65[a65[`8AQZl24XN`
00<BR;0BRK0BRK000Q::/@8BRk401Q:</A:</Q:=/Q:=/Q:>/Q>>/P8CSk<0
1A>@/a>A/a>A/a>B/a>B]0024i>d0Q>D]08CUKD259Je00<DUkDDV;HDV;H0
0QBI]P0459Zf59Zg59^g59^g0QBL]`0359fg5Ifh5Ijh008EWkP011FP^1FP
^AFQ^AFQ^@8EX[T25J>j0QFT^P035ZFj5ZJk5ZJk008FYk/25ZRk0QJY_08F
Z[`00aJ[_1J[_AJ/_@025jfm00@G[[dG[[hG[khG[kh25k2n0QNa_`8G/[l0
11Nc_aRd`1Rd`<SPf0i8T8P00`000<SPf4R@R00=B92800@0000H]<0H]<38
h=P>B92800<0000H]<0H]<000XS0^058T8P10000000018S0^<SPf8S0^8S0
^08008002i^WlOooojRMb?oook>YdV1<VXij]WQU[ZRMb?ooooomo`03oooo
00@c@jD008000800080200600P02P0800h4200B100L01H401H801X801X81
1h81288128<00P49P`812X<20@^40P4<Q0813H@00`4>Q@8?Q@8?Q@020Q25
0P8AQP824XH01`8CQP8CQ`8DQ`8DQ`8EQ`8FQ`<FR0020aN80P<HR0040aV8
0aV90aZ90aZ90P<KR@030ab:0af:0af:00847XX211n;0P@PR`04126;126<
12:<12:<0P@SS00312B<12F=1BF=00859Xd010DWS@DWSPDXSPDXSP85:Hh2
1BZ?00<5:hl5;8l5;8l00PH]T086;Y0010H_T0H_T@H`T@H`T@86<I401`Hb
T@HcTPHcTPHdTPLdTPLeTPLeT`021cJC0PLgT`87>9@00`LiU0LjU0LjU002
1c^E0PPlU@88?ID223jF0PPoUP03242F246G246G0088@YL010Q3U`U3V0U4
V0U4V089AIP22DJI0PU7V@032DRI2DVI2DVJ0089BYX22T^J0PY<V`8:CI/0
0`Y>V`Y>W0Y?W0022U2L00@:DI`:DId:DYd;DYd22e>M00L;E9d;E9h;EIh;
EIh;EYh;Eih;Eil00P]HW`8;FIl235ZP0PaKX00335bP35bQ35fQ008<GZ40
20aOX@aOXPaPXPaPXPaQXPeQXPeRXPeRX`8=Hj<00`eTX`eUX`eUY0023FJT
0PeWY08=J:D23VVU00D>JZD>JZH>JjH>JjH>K:H00Pi]YP8>KZL23VnW00@>
L:L?L:P?LJP?LJP23g:X00<?LjT?M:T?M:T00PmeZ@8?MZX23gNZ0Q1hZP8@
NJ/00a1jZa1kZa1kZ`0247b/0Q1m[00447j/47j]47n]4Gn]0Q60[@034H6^
4H:^4H:^008APjh01164[Q64[a65[a65[`8AQZl24XN`00<BR;0BRK0BRK00
0Q::/@8BRk401Q:</A:</Q:=/Q:=/Q:>/Q>>/P8CSk<01A>@/a>A/a>A/a>B
/a>B]0024i>d0Q>D]08CUKD259Je00<DUkDDV;HDV;H00QBI]P0459Zf59Zg
59^g59^g0QBL]`0359fg5Ifh5Ijh008EWkP011FP^1FP^AFQ^AFQ^@8EX[T2
5J>j0QFT^P035ZFj5ZJk5ZJk008FYk/25ZRk0QJY_08FZ[`00aJ[_1J[_AJ/
_@025jfm00@G[[dG[[hG[khG[kh25k2n0QNa_`8G/[l011Nc_aRd`1Rd`<SP
f0f8`;P00dR@R0000<SPf00=R<2h00E8T8P0000H]<0H]<38h=P03HS0^004
B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0800800
3Y^WlOooooooom_Lk61<VY>5^[>Yd[bhgF1<VYV?_ZJKa<S3gooooc=3Y@@0
08001001P?ooo`02P002P0800h401004POooo`05P@05PPCoool01`48P`49
P`49Poooo`4:Poooo`4;Q0020@b400Coool13H@13XD23hD3oooo0P8AQP04
0Q:6oooo0Q>60Q>70P8DQ`030QF7oooo0aJ800835hP00`<HR?ooooooo`02
oooo00H36XT36hWoool378X37H[oool211j:00?oool47h/488/00oooo`84
8X`212><00<498`49Hd59Hd00PDVS@041BN=1BN>1BR>1BR>0PDYSP85:Xl0
0`D[S`D/S`D/S`021Rf@0PH^T0041Rn@1RnA1S2A1S2A0PHaT@071S:A1S>B
1S>B1SBB1cBB1cFB1cFC0087=Y<21cNC0PLhU0031cVD1cZD1cZD0087>iD2
23bE0PPmU@88?YH223nF00<8@9H8@IL8@IL00PQ2U`0424>G2D>H2DBH2DBH
0PU5V089AYT22DNI00<9B9T9BIT9BIX00PU:VP8:BiX22TbK0PY=V`032TjK
2TjL2TnL008:D9`010YAW0YAW@YBW@]BW@8;Did01`]DW@]DWP]EWP]EWP]F
WP]GWP]GW`022eRO0P]IW`8<FZ0235^P00<<G:0<G:4<GJ400PaNX@0835nQ
35nR362R362R366R3F6R3F:R3F:S0PeSX`033FBS3FFS3FFT008=IZ@23FNT
0PeXY@8>JJD01@iZY@iZYPi[YPi[YPi/YP023VfV0Pi^Y`8>KjL010i`Y`m`
Z0maZ0maZ08?LZP00`mcZ@mdZ@mdZ@023gFY0PmfZP8?MjX247RZ0Q1iZ`03
47Z[47^[47^[008@O:`247f/00@@OZ`@OZd@OjdAOjd24H2]00<APJhAPZhA
PZh00Q63[P044HB^4HB_4HF_4HF_0Q66[`8BQk000a:8/1:9/1:9/0024XZa
0Q:;/@064Xba4Xbb4Xfb4Xfb4Xjb4hjb0Q>?/`054i2c4i6c4i6c4i:c4i:d
008CTk@24iBd0Q>E]@8DU[D00aBG]ABH]QBH]P0259Vf00@DV[HDV[LDVkLD
VkL259bg00<DWKLEWKPEW[P00QFO^0045J2h5J2i5J6i5J6i0QFR^@8EXkX2
5JBj00<FYKXFY[/FY[/00QJW^`8FZ;/25ZVl0QJZ_0035Z^l5Z^m5Zbm008G
[Kd011N^_AN^_QN__QN__P8G/;h25k6o0QNb_`045k>o6;C06;C0b>3H0hS0
^0H00004R<2h00=8T8P00038h=P00XS0^0T00002R<2h00E8T8P0000H]<0H
]<38h=P03HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SP
f8S0^8S0^0<008003Y^WlOoookbhgIV?__ooomKAgM_Lk??nojJKa>k^m8Ef
/9>5^_oooc=3Y@<008002P01P?ooo`02P002P?ooo`03P@04POooo`05POoo
o`801X801@47P_ooo`48P`49Poooo`020@Z300Woool12h@138@138Coool1
3H@13XGoool23hD00P8@Q@06oooo0Q660Q:6oooo0Q>60Q>70P8DQ`030QF7
oooo0aJ800835hP02oooo`<HR0<IR0<IROooo`<JR@<KROooo`<LRP<MR_oo
o`0211j:00Soool47h_oool488/48H/48Hcoool48X`212><00<498`49Hd5
9Hd00PDVS@041BN=1BN>1BR>1BR>0PDYSP85:Xl00`D[S`D/S`D/S`021Rf@
0PH^T0041Rn@1RnA1S2A1S2A0PHaT@071S:A1S>B1S>B1SBB1cBB1cFB1cFC
0087=Y<21cNC0PLhU0031cVD1cZD1cZD0087>iD223bE0PPmU@88?YH223nF
00<8@9H8@IL8@IL00PQ2U`0424>G2D>H2DBH2DBH0PU5V089AYT22DNI00<9
B9T9BIT9BIX00PU:VP8:BiX22TbK0PY=V`032TjK2TjL2TnL008:D9`010YA
W0YAW@YBW@]BW@8;Did01`]DW@]DWP]EWP]EWP]FWP]GWP]GW`022eRO0P]I
W`8<FZ0235^P00<<G:0<G:4<GJ400PaNX@0835nQ35nR362R362R366R3F6R
3F:R3F:S0PeSX`033FBS3FFS3FFT008=IZ@23FNT0PeXY@8>JJD01@iZY@iZ
YPi[YPi[YPi/YP023VfV0Pi^Y`8>KjL010i`Y`m`Z0maZ0maZ08?LZP00`mc
Z@mdZ@mdZ@023gFY0PmfZP8?MjX247RZ0Q1iZ`0347Z[47^[47^[008@O:`2
47f/00@@OZ`@OZd@OjdAOjd24H2]00<APJhAPZhAPZh00Q63[P044HB^4HB_
4HF_4HF_0Q66[`8BQk000a:8/1:9/1:9/0024XZa0Q:;/@064Xba4Xbb4Xfb
4Xfb4Xjb4hjb0Q>?/`054i2c4i6c4i6c4i:c4i:d008CTk@24iBd0Q>E]@8D
U[D00aBG]ABH]QBH]P0259Vf00@DV[HDV[LDVkLDVkL259bg00<DWKLEWKPE
W[P00QFO^0045J2h5J2i5J6i5J6i0QFR^@8EXkX25JBj00<FYKXFY[/FY[/0
0QJW^`8FZ;/25ZVl0QJZ_0035Z^l5Z^m5Zbm008G[Kd011N^_AN^_QN__QN_
_P8G/;h25k6o0QNb_`045k>o6;C06;C0b>3H0hS0^0H00004R<2h00=8T8P0
0038h=P00XS0^0030000R<2hR<2h00F8`;P01@0008S0^8S0^4R@R0000002
6;C000C8h=R8`;R8`;R8`;P2000018S0^0800002R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00?VjOaooooVHnn
UhZle=?XkjbcogIkkYn[FeRUYY_4UYoBH4bJ_;SMoooo<d>U008008002P01
P?ooo`02P002P?ooo`03P@04POooo`05POooo`801X801@47P_ooo`48P`49
Poooo`020@Z300Woool12h@138@138Coool13H@13XGoool23hD00P8@Q@06
oooo0Q660Q:6oooo0Q>60Q>70P8DQ`030QF7oooo0aJ800835hP02oooo`<H
R0<IR0<IROooo`<JR@<KROooo`<LRP<MR_ooo`0211j:00Koool47h_oool4
88/48H/48H`212:<0P@SS00312B<12F=1BF=00859Xd010DWS@DWSPDXSPDX
SP85:Hh21BZ?00<5:hl5;8l5;8l00PH]T086;Y0010H_T0H_T@H`T@H`T@86
<I401`HbT@HcTPHcTPHdTPLdTPLeTPLeT`021cJC0PLgT`87>9@00`LiU0Lj
U0LjU0021c^E0PPlU@88?ID223jF0PPoUP03242F246G246G0088@YL010Q3
U`U3V0U4V0U4V089AIP22DJI0PU7V@032DRI2DVI2DVJ0089BYX22T^J0PY<
V`8:CI/00`Y>V`Y>W0Y?W0022U2L00@:DI`:DId:DYd;DYd22e>M00L;E9d;
E9h;EIh;EIh;EYh;Eih;Eil00P]HW`8;FIl235ZP0PaKX00335bP35bQ35fQ
008<GZ4020aOX@aOXPaPXPaPXPaQXPeQXPeRXPeRX`8=Hj<00`eTX`eUX`eU
Y0023FJT0PeWY08=J:D23VVU00D>JZD>JZH>JjH>JjH>K:H00Pi]YP8>KZL2
3VnW00@>L:L?L:P?LJP?LJP23g:X00<?LjT?M:T?M:T00PmeZ@8?MZX23gNZ
0Q1hZP8@NJ/00a1jZa1kZa1kZ`0247b/0Q1m[00447j/47j]47n]4Gn]0Q60
[@034H6^4H:^4H:^008APjh01164[Q64[a65[a65[`8AQZl24XN`00<BR;0B
RK0BRK000Q::/@8BRk401Q:</A:</Q:=/Q:=/Q:>/Q>>/P8CSk<01A>@/a>A
/a>A/a>B/a>B]0024i>d0Q>D]08CUKD259Je00<DUkDDV;HDV;H00QBI]P04
59Zf59Zg59^g59^g0QBL]`0359fg5Ifh5Ijh008EWkP011FP^1FP^AFQ^AFQ
^@8EX[T25J>j0QFT^P035ZFj5ZJk5ZJk008FYk/25ZRk0QJY_08FZ[`00aJ[
_1J[_AJ/_@025jfm00@G[[dG[[hG[khG[kh25k2n0QNa_`8G/[l011Nc_aRd
`1Rd`<SPf0f8`;P00dR@R0000<SPf002R<2h00<00028`;R8`;P01HS0^005
0000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^002R<2h0P0000:8`;P2
00000hS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0
^8S0^08008002Y^WlOoooiN:_7Y/Z[?7j:U^X<S3gi>5^U]6TiV?_P9hIJh0
148WQJnUb_oooc=3Y@8008002P01P?ooo`02P?ooo`03POooo`04POooo`05
P@05PPCoool00`48P`49Poooo`020@Z300Ooool12h@138@138Coool13H@1
3XD00P8?Q@8248D01_ooo`8AQP8BQ_ooo`8CQP8CQ`8258L00`8EQoooo`<F
R0020aN800<368Soooooool00_ooo`060aZ90a^9oooo0ab:0af:oooo0P@N
RP03oooo11n;oooo00Coool01P@RS0@SS0@SS0@TS0@US@DUS@859Xd010DW
S@DWSPDXSPDXSP85:Hh21BZ?00<5:hl5;8l5;8l00PH]T086;Y0010H_T0H_
T@H`T@H`T@86<I401`HbT@HcTPHcTPHdTPLdTPLeTPLeT`021cJC0PLgT`87
>9@00`LiU0LjU0LjU0021c^E0PPlU@88?ID223jF0PPoUP03242F246G246G
0088@YL010Q3U`U3V0U4V0U4V089AIP22DJI0PU7V@032DRI2DVI2DVJ0089
BYX22T^J0PY<V`8:CI/00`Y>V`Y>W0Y?W0022U2L00@:DI`:DId:DYd;DYd2
2e>M00L;E9d;E9h;EIh;EIh;EYh;Eih;Eil00P]HW`8;FIl235ZP0PaKX003
35bP35bQ35fQ008<GZ4020aOX@aOXPaPXPaPXPaQXPeQXPeRXPeRX`8=Hj<0
0`eTX`eUX`eUY0023FJT0PeWY08=J:D23VVU00D>JZD>JZH>JjH>JjH>K:H0
0Pi]YP8>KZL23VnW00@>L:L?L:P?LJP?LJP23g:X00<?LjT?M:T?M:T00Pme
Z@8?MZX23gNZ0Q1hZP8@NJ/00a1jZa1kZa1kZ`0247b/0Q1m[00447j/47j]
47n]4Gn]0Q60[@034H6^4H:^4H:^008APjh01164[Q64[a65[a65[`8AQZl2
4XN`00<BR;0BRK0BRK000Q::/@8BRk401Q:</A:</Q:=/Q:=/Q:>/Q>>/P8C
Sk<01A>@/a>A/a>A/a>B/a>B]0024i>d0Q>D]08CUKD259Je00<DUkDDV;HD
V;H00QBI]P0459Zf59Zg59^g59^g0QBL]`0359fg5Ifh5Ijh008EWkP011FP
^1FP^AFQ^AFQ^@8EX[T25J>j0QFT^P035ZFj5ZJk5ZJk008FYk/25ZRk0QJY
_08FZ[`00aJ[_1J[_AJ/_@025jfm00@G[[dG[[hG[khG[kh25k2n0QNa_`8G
/[l011Nc_aRd`1Rd`<SPf0f8`;P00dR@R0000<SPf002R<2h00<00028`;R8
`;P01HS0^0050000R<2hR<2hB9280000008H]<000lSPf8S0^8S0^003R<2h
100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000>KYo7oooooool00_ooo`0:ojf`ogIknLgDoNg^ooooYY_4
QGJ`_;SMoooo<d>U0`00P00:0060oooo00:0oooo00>1oooo00B1oooo00F1
00F20P06PP050@N2oooo0@R30@V3oooo00812X<2oooo0P4<Q003oooo0@f4
0@j500823hD20Q2500?oool24HH24XH01?ooo`040QB70QF7oooooooo0P<G
R08368P01@<IR0<IROooo`<JR@<KR@02oooo00`37H[oooooool47X[oool4
7h_oool488/48H/48Hcoool48X`212><00<498`49Hd59Hd00PDVS@041BN=
1BN>1BR>1BR>0PDYSP85:Xl00`D[S`D/S`D/S`021Rf@0PH^T0041Rn@1RnA
1S2A1S2A0PHaT@071S:A1S>B1S>B1SBB1cBB1cFB1cFC0087=Y<21cNC0PLh
U0031cVD1cZD1cZD0087>iD223bE0PPmU@88?YH223nF00<8@9H8@IL8@IL0
0PQ2U`0424>G2D>H2DBH2DBH0PU5V089AYT22DNI00<9B9T9BIT9BIX00PU:
VP8:BiX22TbK0PY=V`032TjK2TjL2TnL008:D9`010YAW0YAW@YBW@]BW@8;
Did01`]DW@]DWP]EWP]EWP]FWP]GWP]GW`022eRO0P]IW`8<FZ0235^P00<<
G:0<G:4<GJ400PaNX@0835nQ35nR362R362R366R3F6R3F:R3F:S0PeSX`03
3FBS3FFS3FFT008=IZ@23FNT0PeXY@8>JJD01@iZY@iZYPi[YPi[YPi/YP02
3VfV0Pi^Y`8>KjL010i`Y`m`Z0maZ0maZ08?LZP00`mcZ@mdZ@mdZ@023gFY
0PmfZP8?MjX247RZ0Q1iZ`0347Z[47^[47^[008@O:`247f/00@@OZ`@OZd@
OjdAOjd24H2]00<APJhAPZhAPZh00Q63[P044HB^4HB_4HF_4HF_0Q66[`8B
Qk000a:8/1:9/1:9/0024XZa0Q:;/@064Xba4Xbb4Xfb4Xfb4Xjb4hjb0Q>?
/`054i2c4i6c4i6c4i:c4i:d008CTk@24iBd0Q>E]@8DU[D00aBG]ABH]QBH
]P0259Vf00@DV[HDV[LDVkLDVkL259bg00<DWKLEWKPEW[P00QFO^0045J2h
5J2i5J6i5J6i0QFR^@8EXkX25JBj00<FYKXFY[/FY[/00QJW^`8FZ;/25ZVl
0QJZ_0035Z^l5Z^m5Zbm008G[Kd011N^_AN^_QN__QN__P8G/;h25k6o0QNb
_`045k>o6;C06;C0b>3H3HS0^003B9280000b>3H00:8`;P00`0008S0^8S0
^005R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00B8`;P2
00001HS0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0
^8S0^0<008002Z6/l_W=e>8V??Be_n8V??A]OOcSjOoooog]k_n]/0;oool0
0c=3Y@00P000P002002000X00H3oool00X3oool00h7oool0187oool01H40
1H83oooo00<1288128?oool00_ooo`030@Z3oooo0@^400;oool20@f400<1
3XD23hD23hD00P8@Q@06oooo0Q660Q:6oooo0Q>60Q>70P8DQ`060QF7oooo
0aJ8oooo0aN80aR80oooo`836XT00`<KROooo`<LRP02oooo00D47X[oool4
7h/47h/488/00oooo`848X`212><00<498`49Hd59Hd00PDVS@041BN=1BN>
1BR>1BR>0PDYSP85:Xl00`D[S`D/S`D/S`021Rf@0PH^T0041Rn@1RnA1S2A
1S2A0PHaT@071S:A1S>B1S>B1SBB1cBB1cFB1cFC0087=Y<21cNC0PLhU003
1cVD1cZD1cZD0087>iD223bE0PPmU@88?YH223nF00<8@9H8@IL8@IL00PQ2
U`0424>G2D>H2DBH2DBH0PU5V089AYT22DNI00<9B9T9BIT9BIX00PU:VP8:
BiX22TbK0PY=V`032TjK2TjL2TnL008:D9`010YAW0YAW@YBW@]BW@8;Did0
1`]DW@]DWP]EWP]EWP]FWP]GWP]GW`022eRO0P]IW`8<FZ0235^P00<<G:0<
G:4<GJ400PaNX@0835nQ35nR362R362R366R3F6R3F:R3F:S0PeSX`033FBS
3FFS3FFT008=IZ@23FNT0PeXY@8>JJD01@iZY@iZYPi[YPi[YPi/YP023VfV
0Pi^Y`8>KjL010i`Y`m`Z0maZ0maZ08?LZP00`mcZ@mdZ@mdZ@023gFY0Pmf
ZP8?MjX247RZ0Q1iZ`0347Z[47^[47^[008@O:`247f/00@@OZ`@OZd@OjdA
Ojd24H2]00<APJhAPZhAPZh00Q63[P044HB^4HB_4HF_4HF_0Q66[`8BQk00
0a:8/1:9/1:9/0024XZa0Q:;/@064Xba4Xbb4Xfb4Xfb4Xjb4hjb0Q>?/`05
4i2c4i6c4i6c4i:c4i:d008CTk@24iBd0Q>E]@8DU[D00aBG]ABH]QBH]P02
59Vf00@DV[HDV[LDVkLDVkL259bg00<DWKLEWKPEW[P00QFO^0045J2h5J2i
5J6i5J6i0QFR^@8EXkX25JBj00<FYKXFY[/FY[/00QJW^`8FZ;/25ZVl0QJZ
_0035Z^l5Z^m5Zbm008G[Kd011N^_AN^_QN__QN__P8G/;h25k6o0QNb_`04
5k>o6;C06;C0b>3H3HS0^003B9280000b>3H00:8`;P00`0008S0^8S0^005
R<2h00D00028`;R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00>8`;P40000
18S0^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0
^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_ARK_omoon]/?cSjOoooc=3
Y@05002000@00H3oooooool00X0200>10_ooo`0900F100F200J200J20@N2
0@R20@R30@V3oooo00812X<01?ooo`4;Q04<Q04<Q0813H@00`4>Q@8?Q@8?
Q@020Q2500Koool24HH24XKoool24hH24hL20QB700<25HL25XL35XP00P<G
R08368P010<IR0<IR@<JR@<JR@836hT00`<LRP<MRP<MRP0211j:0P@OR`84
88/010@QR`@QS0@RS0@RS0848h`00`@TS0@US@DUS@021BJ=00@59hd59hh5
:8h5:8h21BV>0PDZS`031B^?1Bb?1Bb?0086;I021Rj@00@6;i06;i46<946
<9421S6A00L6<Y46<i86<i86=987=987=I87=I<00PLfT`87=i<21cRD00<7
>I@7>Y@7>Y@00PLkU@88?9D223fE0PPnUP88?iH00`Q0UPQ1U`Q1U`0224:G
00@8@iL9@iP9A9P9A9P22DFH0PU6V@89AiT00`U8V@U9V@U9VP022DZJ0PY;
VP8:C9/22TfK00<:CY/:CY`:Ci`00PY@W0042U6L2U6M2U:M2e:M0P]CW@07
2eBM2eBN2eFN2eFN2eJN2eNN2eNO008;F9l22eVO0PaJX08<Fj000`aLX0aL
X@aMX@0235jQ00P<Gj4<Gj8<H:8<H:8<HJ8=HJ8=HZ8=HZ<23F>S00<=I:<=
IJ<=IJ@00PeVY08=Ij@23FRU0PiYY@053VZU3VZV3V^V3V^V3VbV008>KJH2
3VjW0Pi_Y`043W2W3g2X3g6X3g6X0PmbZ0033g>Y3gBY3gBY008?MJT23gJZ
0PmgZP8@N:X247V[00<@NZ/@Nj/@Nj/00Q1l[08@OJ`0111n[11n[A1o[A5o
[@8AP:d00a61[Q62[Q62[P024H>^00@AQ:hAQ:lAQJlAQJl24HJ_0Q:7/003
4XR`4XV`4XV`008BR[424X^a00HBS;4BS;8BSK8BSK8BS[8CS[824hnc00DC
T;<CTK<CTK<CT[<CT[@00Q>C]08CU;@24iFe0QBF]@0359Ne59Rf59Rf008D
VKH011BJ]QBJ]aBK]aBK]`8DW;L00aBM]aFM^1FN^0025Inh00@EX;PEX;TE
XKTEXKT25J:i0QFS^P8EY;X00aJU^QJV^aJV^`025ZNk0QJX^`8FZK`25ZZl
00<FZk`FZkdF[;d00QN]_@045jjm5jjn5jnn5jnn0QN`_P8G/Kl25k:o00@G
/klH]<0H]<38h=P=R<2h00=8T8P00038h=P00XS0^0030000R<2hR<2h00F8
`;P01@0008S0^8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002
R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P2002000>KYo7fb<cR9S`00_n]/007gb@^ojBNm[c5ojf`kW^<
oooo<d>U00H008001001P?ooooooo`02P0800h42oooo00T01H401H801X80
1X811h81288128<12H?oool00P4:P`04oooo0@^40@b40@b40P4=Q0030@j5
0Pn50Pn5008248D01_ooo`8AQP8BQ_ooo`8CQP8CQ`8258L00`8EQ`8FQ`<F
R0020aN80P<HR0040aV80aV90aZ90aZ90P<KR@030ab:0af:0af:00847XX2
11n;0P@PR`04126;126<12:<12:<0P@SS00312B<12F=1BF=00859Xd010DW
S@DWSPDXSPDXSP85:Hh21BZ?00<5:hl5;8l5;8l00PH]T086;Y0010H_T0H_
T@H`T@H`T@86<I401`HbT@HcTPHcTPHdTPLdTPLeTPLeT`021cJC0PLgT`87
>9@00`LiU0LjU0LjU0021c^E0PPlU@88?ID223jF0PPoUP03242F246G246G
0088@YL010Q3U`U3V0U4V0U4V089AIP22DJI0PU7V@032DRI2DVI2DVJ0089
BYX22T^J0PY<V`8:CI/00`Y>V`Y>W0Y?W0022U2L00@:DI`:DId:DYd;DYd2
2e>M00L;E9d;E9h;EIh;EIh;EYh;Eih;Eil00P]HW`8;FIl235ZP0PaKX003
35bP35bQ35fQ008<GZ4020aOX@aOXPaPXPaPXPaQXPeQXPeRXPeRX`8=Hj<0
0`eTX`eUX`eUY0023FJT0PeWY08=J:D23VVU00D>JZD>JZH>JjH>JjH>K:H0
0Pi]YP8>KZL23VnW00@>L:L?L:P?LJP?LJP23g:X00<?LjT?M:T?M:T00Pme
Z@8?MZX23gNZ0Q1hZP8@NJ/00a1jZa1kZa1kZ`0247b/0Q1m[00447j/47j]
47n]4Gn]0Q60[@034H6^4H:^4H:^008APjh01164[Q64[a65[a65[`8AQZl2
4XN`00<BR;0BRK0BRK000Q::/@8BRk401Q:</A:</Q:=/Q:=/Q:>/Q>>/P8C
Sk<01A>@/a>A/a>A/a>B/a>B]0024i>d0Q>D]08CUKD259Je00<DUkDDV;HD
V;H00QBI]P0459Zf59Zg59^g59^g0QBL]`0359fg5Ifh5Ijh008EWkP011FP
^1FP^AFQ^AFQ^@8EX[T25J>j0QFT^P035ZFj5ZJk5ZJk008FYk/25ZRk0QJY
_08FZ[`00aJ[_1J[_AJ/_@025jfm00@G[[dG[[hG[khG[kh25k2n0QNa_`8G
/[l011Nc_aRd`1Rd`<SPf0f8`;P00dR@R0000<SPf002R<2h2@0000:8`;P0
1DR@R00001Rd`1Rd`<SPf003R<2h0P0000B8`;P200000XS0^004B9280000
6;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008000i^WlOW=
e?N9U`02oooo00Oo[K3Q5SCoMW_oY9kR9ScoRGlc@jD01P00P0040060oooo
00:000:00P03P@0400B1oooo00F100F20P06PP030@N20@R20@R300812H<2
0@Z300Coool12h@138@138@20@f400<13XD23hD23hD00P8@Q@03oooo0Q66
0Q:600Goool00`8EQ`8FQ`<FR0020aN80P<HR0040aV80aV90aZ90aZ90P<K
R@030ab:0af:0af:00847XX211n;0P@PR`04126;126<12:<12:<0P@SS003
12B<12F=1BF=00859Xd010DWS@DWSPDXSPDXSP85:Hh21BZ?00<5:hl5;8l5
;8l00PH]T086;Y0010H_T0H_T@H`T@H`T@86<I401`HbT@HcTPHcTPHdTPLd
TPLeTPLeT`021cJC0PLgT`87>9@00`LiU0LjU0LjU0021c^E0PPlU@88?ID2
23jF0PPoUP03242F246G246G0088@YL010Q3U`U3V0U4V0U4V089AIP22DJI
0PU7V@032DRI2DVI2DVJ0089BYX22T^J0PY<V`8:CI/00`Y>V`Y>W0Y?W002
2U2L00@:DI`:DId:DYd;DYd22e>M00L;E9d;E9h;EIh;EIh;EYh;Eih;Eil0
0P]HW`8;FIl235ZP0PaKX00335bP35bQ35fQ008<GZ4020aOX@aOXPaPXPaP
XPaQXPeQXPeRXPeRX`8=Hj<00`eTX`eUX`eUY0023FJT0PeWY08=J:D23VVU
00D>JZD>JZH>JjH>JjH>K:H00Pi]YP8>KZL23VnW00@>L:L?L:P?LJP?LJP2
3g:X00<?LjT?M:T?M:T00PmeZ@8?MZX23gNZ0Q1hZP8@NJ/00a1jZa1kZa1k
Z`0247b/0Q1m[00447j/47j]47n]4Gn]0Q60[@034H6^4H:^4H:^008APjh0
1164[Q64[a65[a65[`8AQZl24XN`00<BR;0BRK0BRK000Q::/@8BRk401Q:<
/A:</Q:=/Q:=/Q:>/Q>>/P8CSk<01A>@/a>A/a>A/a>B/a>B]0024i>d0Q>D
]08CUKD259Je00<DUkDDV;HDV;H00QBI]P0459Zf59Zg59^g59^g0QBL]`03
59fg5Ifh5Ijh008EWkP011FP^1FP^AFQ^AFQ^@8EX[T25J>j0QFT^P035ZFj
5ZJk5ZJk008FYk/25ZRk0QJY_08FZ[`00aJ[_1J[_AJ/_@025jfm00@G[[dG
[[hG[khG[kh25k2n0QNa_`8G/[l011Nc_aRd`1Rd`<SPf0f8`;P00dR@R000
0<SPf002R<2h2@0000:8`;P01DR@R00001Rd`1Rd`<SPf00=R<2h00A8T8P0
000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P007VjOa
oooolj2^m69^oooomhVGnLgD00;oool00o>P[_oooc=3Y@0600200P01P080
0X0200>10P04P@0700F100F200J200J20@N20@R20@R300812H<20@Z30P4;
Q08138@20@f400<13XD23hD23hD00P8@Q@824HH20Q:600L24hH24hL258L2
58L25HL25XL35XP00P<GR08368P010<IR0<IR@<JR@<JR@836hT00`<LRP<M
RP<MRP0211j:0P@OR`8488/010@QR`@QS0@RS0@RS0848h`00`@TS0@US@DU
S@021BJ=00@59hd59hh5:8h5:8h21BV>0PDZS`031B^?1Bb?1Bb?0086;I02
1Rj@00@6;i06;i46<946<9421S6A00L6<Y46<i86<i86=987=987=I87=I<0
0PLfT`87=i<21cRD00<7>I@7>Y@7>Y@00PLkU@88?9D223fE0PPnUP88?iH0
0`Q0UPQ1U`Q1U`0224:G00@8@iL9@iP9A9P9A9P22DFH0PU6V@89AiT00`U8
V@U9V@U9VP022DZJ0PY;VP8:C9/22TfK00<:CY/:CY`:Ci`00PY@W0042U6L
2U6M2U:M2e:M0P]CW@072eBM2eBN2eFN2eFN2eJN2eNN2eNO008;F9l22eVO
0PaJX08<Fj000`aLX0aLX@aMX@0235jQ00P<Gj4<Gj8<H:8<H:8<HJ8=HJ8=
HZ8=HZ<23F>S00<=I:<=IJ<=IJ@00PeVY08=Ij@23FRU0PiYY@053VZU3VZV
3V^V3V^V3VbV008>KJH23VjW0Pi_Y`043W2W3g2X3g6X3g6X0PmbZ0033g>Y
3gBY3gBY008?MJT23gJZ0PmgZP8@N:X247V[00<@NZ/@Nj/@Nj/00Q1l[08@
OJ`0111n[11n[A1o[A5o[@8AP:d00a61[Q62[Q62[P024H>^00@AQ:hAQ:lA
QJlAQJl24HJ_0Q:7/0034XR`4XV`4XV`008BR[424X^a00HBS;4BS;8BSK8B
SK8BS[8CS[824hnc00DCT;<CTK<CTK<CT[<CT[@00Q>C]08CU;@24iFe0QBF
]@0359Ne59Rf59Rf008DVKH011BJ]QBJ]aBK]aBK]`8DW;L00aBM]aFM^1FN
^0025Inh00@EX;PEX;TEXKTEXKT25J:i0QFS^P8EY;X00aJU^QJV^aJV^`02
5ZNk0QJX^`8FZK`25ZZl00<FZk`FZkdF[;d00QN]_@045jjm5jjn5jnn5jnn
0QN`_P8G/Kl25k:o00@G/klH]<0H]<38h=P=R<2h00=8T8P00038h=P03HS0
^005B92800006;C06;C0b>3H00f8`;P014R@R00001Rd`1Rd`0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P3002000^KYo7oooooRGooooocX:kaTj7o
oooooOocX:kono`c@jD01P00P0800H0200:00P03P@8018401`05P@05PP06
PP06PP47PP48PP48P`020@V30P4:P`812h@20@b40P4=Q0030@j50Pn50Pn5
008248D20Q660P8BQP070Q>60Q>70QB70QB70QF70QJ70aJ800835hP20aR8
00@36HP36HT36XT36XT20a^900<378X37HX37HX00P@NRP847h/2122;00@4
8H/48H`48X`48X`212><00<498`49Hd59Hd00PDVS@041BN=1BN>1BR>1BR>
0PDYSP85:Xl00`D[S`D/S`D/S`021Rf@0PH^T0041Rn@1RnA1S2A1S2A0PHa
T@071S:A1S>B1S>B1SBB1cBB1cFB1cFC0087=Y<21cNC0PLhU0031cVD1cZD
1cZD0087>iD223bE0PPmU@88?YH223nF00<8@9H8@IL8@IL00PQ2U`0424>G
2D>H2DBH2DBH0PU5V089AYT22DNI00<9B9T9BIT9BIX00PU:VP8:BiX22TbK
0PY=V`032TjK2TjL2TnL008:D9`010YAW0YAW@YBW@]BW@8;Did01`]DW@]D
WP]EWP]EWP]FWP]GWP]GW`022eRO0P]IW`8<FZ0235^P00<<G:0<G:4<GJ40
0PaNX@0835nQ35nR362R362R366R3F6R3F:R3F:S0PeSX`033FBS3FFS3FFT
008=IZ@23FNT0PeXY@8>JJD01@iZY@iZYPi[YPi[YPi/YP023VfV0Pi^Y`8>
KjL010i`Y`m`Z0maZ0maZ08?LZP00`mcZ@mdZ@mdZ@023gFY0PmfZP8?MjX2
47RZ0Q1iZ`0347Z[47^[47^[008@O:`247f/00@@OZ`@OZd@OjdAOjd24H2]
00<APJhAPZhAPZh00Q63[P044HB^4HB_4HF_4HF_0Q66[`8BQk000a:8/1:9
/1:9/0024XZa0Q:;/@064Xba4Xbb4Xfb4Xfb4Xjb4hjb0Q>?/`054i2c4i6c
4i6c4i:c4i:d008CTk@24iBd0Q>E]@8DU[D00aBG]ABH]QBH]P0259Vf00@D
V[HDV[LDVkLDVkL259bg00<DWKLEWKPEW[P00QFO^0045J2h5J2i5J6i5J6i
0QFR^@8EXkX25JBj00<FYKXFY[/FY[/00QJW^`8FZ;/25ZVl0QJZ_0035Z^l
5Z^m5Zbm008G[Kd011N^_AN^_QN__QN__P8G/;h25k6o0QNb_`035k>o6;C0
6;C000o8h=P00`000<SPf<SPf00=b>3H00<0000H]<0H]<003lSPf0030000
6;C06;C000:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P400200i^Wl@06
oooolj2^m;Fom[c5nmWJ<d>U1`00P0800H0200:00P03P@8018401`05P@05
PP06PP06PP47PP48PP48P`020@V30P4:P`812h@20@b40P4=Q0030@j50Pn5
0Pn5008248D20Q660P8BQP070Q>60Q>70QB70QB70QF70QJ70aJ800835hP2
0aR800@36HP36HT36XT36XT20a^900<378X37HX37HX00P@NRP847h/2122;
00@48H/48H`48X`48X`212><00<498`49Hd59Hd00PDVS@041BN=1BN>1BR>
1BR>0PDYSP85:Xl00`D[S`D/S`D/S`021Rf@0PH^T0041Rn@1RnA1S2A1S2A
0PHaT@071S:A1S>B1S>B1SBB1cBB1cFB1cFC0087=Y<21cNC0PLhU0031cVD
1cZD1cZD0087>iD223bE0PPmU@88?YH223nF00<8@9H8@IL8@IL00PQ2U`04
24>G2D>H2DBH2DBH0PU5V089AYT22DNI00<9B9T9BIT9BIX00PU:VP8:BiX2
2TbK0PY=V`032TjK2TjL2TnL008:D9`010YAW0YAW@YBW@]BW@8;Did01`]D
W@]DWP]EWP]EWP]FWP]GWP]GW`022eRO0P]IW`8<FZ0235^P00<<G:0<G:4<
GJ400PaNX@0835nQ35nR362R362R366R3F6R3F:R3F:S0PeSX`033FBS3FFS
3FFT008=IZ@23FNT0PeXY@8>JJD01@iZY@iZYPi[YPi[YPi/YP023VfV0Pi^
Y`8>KjL010i`Y`m`Z0maZ0maZ08?LZP00`mcZ@mdZ@mdZ@023gFY0PmfZP8?
MjX247RZ0Q1iZ`0347Z[47^[47^[008@O:`247f/00@@OZ`@OZd@OjdAOjd2
4H2]00<APJhAPZhAPZh00Q63[P044HB^4HB_4HF_4HF_0Q66[`8BQk000a:8
/1:9/1:9/0024XZa0Q:;/@064Xba4Xbb4Xfb4Xfb4Xjb4hjb0Q>?/`054i2c
4i6c4i6c4i:c4i:d008CTk@24iBd0Q>E]@8DU[D00aBG]ABH]QBH]P0259Vf
00@DV[HDV[LDVkLDVkL259bg00<DWKLEWKPEW[P00QFO^0045J2h5J2i5J6i
5J6i0QFR^@8EXkX25JBj00<FYKXFY[/FY[/00QJW^`8FZ;/25ZVl0QJZ_003
5Z^l5Z^m5Zbm008G[Kd011N^_AN^_QN__QN__P8G/;h25k6o0QNb_`035k>o
6;C06;C003@H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h5000P080
0H0200:00P03P@8018401`05P@05PP06PP06PP47PP48PP48P`020@V30P4:
P`812h@20@b40P4=Q0030@j50Pn50Pn5008248D20Q660P8BQP070Q>60Q>7
0QB70QB70QF70QJ70aJ800835hP20aR800@36HP36HT36XT36XT20a^900<3
78X37HX37HX00P@NRP847h/2122;00@48H/48H`48X`48X`212><00<498`4
9Hd59Hd00PDVS@041BN=1BN>1BR>1BR>0PDYSP85:Xl00`D[S`D/S`D/S`02
1Rf@0PH^T0041Rn@1RnA1S2A1S2A0PHaT@071S:A1S>B1S>B1SBB1cBB1cFB
1cFC0087=Y<21cNC0PLhU0031cVD1cZD1cZD0087>iD223bE0PPmU@88?YH2
23nF00<8@9H8@IL8@IL00PQ2U`0424>G2D>H2DBH2DBH0PU5V089AYT22DNI
00<9B9T9BIT9BIX00PU:VP8:BiX22TbK0PY=V`032TjK2TjL2TnL008:D9`0
10YAW0YAW@YBW@]BW@8;Did01`]DW@]DWP]EWP]EWP]FWP]GWP]GW`022eRO
0P]IW`8<FZ0235^P00<<G:0<G:4<GJ400PaNX@0835nQ35nR362R362R366R
3F6R3F:R3F:S0PeSX`033FBS3FFS3FFT008=IZ@23FNT0PeXY@8>JJD01@iZ
Y@iZYPi[YPi[YPi/YP023VfV0Pi^Y`8>KjL010i`Y`m`Z0maZ0maZ08?LZP0
0`mcZ@mdZ@mdZ@023gFY0PmfZP8?MjX247RZ0Q1iZ`0347Z[47^[47^[008@
O:`247f/00@@OZ`@OZd@OjdAOjd24H2]00<APJhAPZhAPZh00Q63[P044HB^
4HB_4HF_4HF_0Q66[`8BQk000a:8/1:9/1:9/0024XZa0Q:;/@064Xba4Xbb
4Xfb4Xfb4Xjb4hjb0Q>?/`054i2c4i6c4i6c4i:c4i:d008CTk@24iBd0Q>E
]@8DU[D00aBG]ABH]QBH]P0259Vf00@DV[HDV[LDVkLDVkL259bg00<DWKLE
WKPEW[P00QFO^0045J2h5J2i5J6i5J6i0QFR^@8EXkX25JBj00<FYKXFY[/F
Y[/00QJW^`8FZ;/25ZVl0QJZ_0035Z^l5Z^m5Zbm008G[Kd011N^_AN^_QN_
_QN__P8G/;h25k6o0QNb_`035k>o6;C06;C003@H]<02R<2h0DR@R0400000
0003R<2hb>3HR<2h0?n8`;RKR<2h0DR@R04000000003R<2hb>3HR<2h0?n8
`;RKR<2h0DR@R04000000003R<2hb>3Hb>3H0?o8h=RKb>3H0DR@R0400000
0?n8`;ROR<2h0@000000\
\>"], "Graphics",
  ImageSize->{415, 356},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006T0001PB000`400?l0
0000o`00003oooo`l?2Uoo3`l000ooo`l?2Uoo3`l000ooo`l?2Uoo3`l000
ooo`l?2Uoo3`l000ooo`l?2Uoo3`l000ooo`l?2Uoo3`l000ooo`l?2Uoo3`
l000ooo`l?2Uoo3`l000ooo`l?2Uoo3`l000ooo`l?2Uoo3`l000ooo`l?2U
oo3`l000ooo`l?2Uoo3`l000ooo`l?2Uoo3`l000ooo`l?2Uoo3`l000ooo`
l?2Uoo3`l000oooooonUooooo`00ooo^k^jUonk^kP000ooVi^Koolo?cj3o
clo?0_oVi^H000?ok^k^00?o^KVionk^k_o^k^h0ooo^k^jLonk^kP7o^KVi
0Oo^k^h1onk^kP000oooool00oni^KWohn?Sooooo`3ooooooi_ooooo00?o
hn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0oooooonJ
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo
0?ooooooV_ooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWo
hn?Sooooo`3ooooooi[ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo
00?o^KVion?Shoooool0oooooonKooooo`03on?Shoni^KWooooo007ooooo
0003onk^kP03okVi^OoShn?ooooo0?ooooooV_ooool00oo^k^kohn?SokVi
^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`3ooooooi[ooooo00?oi^KV
on?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0oooooonJoooo
o`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?oo
ooooVoooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?S
ooooo`3ooooooi[ooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o
^KVion?Shoooool0oooooonJooooo`03onKVi_oShn?o^KVi00;oi^KV0003
onk^kP03okVi^OoShn?ooooo0?ooooooV_ooool00oo^k^kohn?SokVi^@02
onk^kP000oooool00oni^KWohn?Sooooo`3ooooooi_ooooo00?ohn?SokVi
^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0oooooonJooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo0?oooooo
V_ooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Soooo
o`3ooooooi[ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVi
on?Shoooool0oooooonKooooo`03on?Shoni^KWooooo007ooooo0003onk^
kP03okVi^OoShn?ooooo0?ooooooV_ooool00oo^k^kohn?SokVi^@02onk^
kP000ooVi^H00oni^KWohn?Sooooo`3ooooooi[ooooo00?oi^KVon?Shoni
^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0oooooonJooooo`03onk^
k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?ooooooVooo
ool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0P
ooooo`03onogmoooooookoOg00;ooooo00?okoOgooooooooool00_ooool0
0oo_moOoooooonogm`02ooooo`03onogmooooooooooo0?ooooooJ?ooool0
0oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0Joooo
o`03onoWioogmnooknOW01_oknOW00Coe]KWonoWioo_inOoe]KW1_o_inL0
0oo_moOoooooooooo`3ooooooeGooooo00?oi^KVon?Shoni^KT00_oVi^H0
00?ok^k^00?o^KVion?Shoooool06Oooool03_ogmnoog]kNolk>g_nm_Kgo
]Kg>olk6]One_Lkoc/JeokFmc_o>a[Go_KfmokFmc_o>a[Go]Kg>0onm_Kd0
1oo>c/ko_KfmolJm_One_Lkoc/JeolJm_One_Lh00_nm_Kd01Oo6_Kgo]Kg>
okfm_Oo6_Kgo]Kg>00?o_Kfm00Woc/k>okfm_Onm_Kgoa[fmokFmc_nm_Kgo
c/k>olkFg_o_inL0oooooomFooooo`03onk^k_oShn?o^KVi00;ok^k^0003
ooooo`03okVi^OoShn?ooooo01Wooooo00Gog]kNolk>c_n][JGo[JfUoibL
Y@0AoibLW003oibLYOn]YICoW9bU00;oW9bL00Oo[JFDoibLYOnLW9coW9bL
ojf]YOnLW9coW9bU00;oW9bL00?o[JfUoibLW?nLW9`00_n][JD00oo>c/ko
g]kNonogm`3ooooooeKooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^
00?o^KVion?Shoooool06Oooool00oo_inOog]kNooooo`0Vooooo`;og]kN
00?oknOWooooooooool0oooooomCooooo`03onk^k_oShn?o^KVi00;ok^k^
0003onKViP03okVi^OoShn?ooooo01Wooooo00?og]kNolkFc_ooool04ooo
ool00oogmnooooooooooo`02ooooo`05onO_moooooooooooooooooo_inL0
0_ooool00oo_inOoooooonO_m`02ooooo`04onogmoooooooinONolk>c_oo
ooooE_ooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?S
ooooo`0Hooooo`03onO_mooWimkoc]KN00;ooooo00?okoOgooooooooool0
2oooool00oo_moOoooooooooo`03ooooo`03onO_mooooooooooo00[ooooo
00OoknOWooooooooooooooooomkNg_o>e]koknOW0?ooooooEOooool00oo^
k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Iooooo`03
omkNg_oNc/Kooooo017ooooo00?okoOgooooooooool00_ooool00oogknOo
ooooooooo`02ooooo`04onO_moooooooooooonO_m`Gooooo00GoknOWoooo
ooo_inOoc/k>onogm`3ooooooeKooooo00?ohn?SokVi^Oooool00Oooool0
00?ok^k^00?o^KVion?Shoooool06?ooool00oogmnooimkNolkFgP0>oooo
o`03onogmooooooooooo00Cooooo00?omoO_ooooooooool02_ooool00oo_
moOoooooonO_m`02ooooo`03omkNg_o>e/koknOW0?ooooooEOooool00oo^
k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0Iooooo`03
omkNg_o>c/kooooo00?ooooo00[oknOWolk>c_o_inOokoOgoooooooWkoOo
ooooonoWioo>c/koknOW0_ooool00oo_moOoooooomkNgP05omkNgP06omK>
e_n4Ng?oW6]SojekHoo>_JGoU8b<0_n]Nf<02_nm_Kgoc/JeomkNc_o>a[Go
_Kf]onO_mooooooog]kNolk>c_o_moOooooooeGooooo00?oi^KVon?Shoni
^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool06Oooool01?oFe^Oog]k>
ooooooo_inL2okfm_@05olk>c_nLW9co[KFeolk>c_o_moL00_n][JD2oibL
W00Mohb<S?nm_Kgo[JfUonoWioooooooinONonoWioogmnooknOWooO_iooW
imkog/k6oe9:@_mk40SoQ1P@ojekHonD@S7oLaP@oi`a8Oo>YHCog]k>onoW
c_oNg/koc/JeonoWiooooooog]kNolkFg_o_inL0oooooomEooooo`03onk^
k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo01Sooooo00?o
moO_onOWg_o>e]h00_ooool00ooFc]Kog]kNonoWi`02omkNgP07onoWiooo
ooooe]KWonoWioo>e/kog]kNokfm_@02omkNgP;ooooo01Soc/k>ohBDU?nL
W:GoW9bLog^4Q?m[Lg?oFV][odXH6?mc613oW34Qoh@i<OmS61SoQ24HojEc
F_n]Nf?oW9bUoib4NonDS6?o[KFeooOgkoooooooknOWolk>c_o_moOooooo
oeKooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shooo
ool06Oooool00ooFe^Ooe/kFooooo`07ooooo`03onogmooooooooooo00;o
oooo00?oinogooooooooool00_ooool03_oNc/KoS8b<ohb<S?m[Jf_oS8b<
ojfUU?m[Jf_oDPP8of/a:OnL<B7o[G]Soh@H4?n48ASoJc4Y0_m:DUX02?mJ
FU[oDTY2of]cLoo_inOoooooomkNg_o>e]koknOWoooooomEooooo`03onk^
k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Wooooo00Go
g]kNolkFc_oooooomnoWojfe]@02okfm_@07okFmc_nm_JgoknOWolk>c_n]
[JGoknOWojfe]@02okfm_@0ComkNg_ne_Lkoc/Jeooooooo>e]ko_Kfmojf]
YOnLU8co[JFDolk6]OmkLf?o610@oe882?n]Nf?oS6]:oh@Q6?mk<BWoDSTa
obTY:@03ocTi<@06oeYJ@_o_inOoooooonOWg_o>c/kokoOgoooooomEoooo
o`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo01So
oooo02gokoOgonOWg_o>c/koooooonogmonm_Kgo[JfUolk>g_o>a[Goc/k>
onoWioo>c/ko_KfmonoWion][JGo_Kfmolk>c_oNg]koc/k>ojfe]Ooooooo
g]k>okfm[On][JGoW9bLojfLQ?o>_JGoLf]Sob4H4?mBBT;oHd8iodXa:OmB
>C7oDSTYog]kNomkQ8CoFUYJodYB>Om:BS7oBU8ionoWioooooooe]KWolkF
c_o_inL0oooooomEooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03
okVi^OoShn?ooooo01Wooooo00Sog]kNolkFg_ooooooooooonogmooooooo
knOWonO_m`Gooooo00?okoOgooooooooool00_ooool02Oo_inOoooooolk>
g_nm_Jgo_KfmoiB<S?mcLe[o[Ib4og=[H`02oe8i<@0?od8Y8OmB>C7oFT8i
oe8i<On<S7?oS8b<og]kNom[He;oJf]:oeYSF_o_inOoooooonOWg_o>c]ko
moO_0?ooooooE_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni
^KWohn?Sooooo`0Hooooo`;oknOW00?oe/kFooooooo_inL00_o>c/h02OnL
W:Go[JFDokFmc_o>a[Gog]kNolkFg_o>c/kog]kNolkFgP02olk>cP0<olJm
_Oo>e]koooooolk6]On<S8coS8acoeYJ@_n<S8coc/Jeog=[HomBBT;o<AP@
0_mB>C401?mcFU;oDSTaoeYJ@_mkLf<2of][BP07oeYJ@_m[Jd[oknOWonog
moo_inOoc]K>onoWi`3ooooooeGooooo00?ok^k^on?Shoni^KT00_o^k^h0
00?oi^KV00?o^KVion?Shoooool06Oooool01_oNg]koc]K>oooooooooooo
[JfUojfe]@Co_Kfm00Kog]kNokfm_Oo>a[Goc]KNolk6]On]]KD2okfm_@0A
ojf]YOoooooo[KFeodY:B_mBBT;oJf=Bohb<LonLQ7_oFUYJoe8i:Om2:B7o
JdY2oeYJ@_mcFU;oHeY:obTY6?li>AP00_mJDRT01_li>ASoNf=:onoWiooo
oooog]kNolk>c_ooooooE_ooool00ooVi^Kohn?SokVi^@02onKViP000oo^
k^h00oni^KWohn?Sooooo`0Hooooo`06onogmooWimkoc/k>ooooooo_moOo
knOW2Oooool07_o_inOoinONooooooo_moOoknOWoooooon][JGo:C4YobTY
6?m:BRWo[JFDolJm_Oli>C7o@RTQoe8i<OmBBT;oNeY:of]SD_mJ@SWo:BTH
odXa:Om:BRWoLg=JodXa:OmBHd;oe]KWoooooooWimkoc]KNonoWiooooooo
EOooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Soooo
o`0Iooooo`0:omkNg_o>e]koooooonoWioo>e]kog]kNolk>c_oNg]koc/k>
onoWi`;oc]KN023oknOWomkNg_o>e]koc/k>omK>e_o_inOoc]KNonogmon]
YICo0000obTY6?li8ASoW9B<olk6[OmkLf?o:BTHod8Y8On]Nf?oU6]Jof/a
:Oli>ASo:BTHoc4i8Om:BRWoBTXaocTi6?m:BS7oknOWonogmoo_inOoc/k>
onogmoooooooE_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni
^KWohn?Sooooo`0Hooooo`0]onogmoo_inOoc/k>oooooooNg]ko_Kfmojf]
YOn]]KGo[JfUoibLW?nea]Ko[JfUokfm[Oo>e]koc/k>oibLYOn][JGo_Kfm
olkFc_nm_KgoknOWojf]YOl@003o:BTHoc4i8Onm_Jgog/jmohb<LolY:ASo
LeYBojekHoo6[IcoQ7]coc4i8OlH413o>CTHodYB>Om:FT;o:BTYocU2<Oo_
inOoooooomKFioo>e/koknOW0?ooooooEOooool00oo^k^kohn?SokVi^@02
onk^kP000ooVi^H00oni^KWohn?Sooooo`0Hooooo`;oknOW00?oc]K>oooo
ooooool00oo_moL01?ogmnooc]KNonOWg_o_inL6onogm`?ooooo01So[JfU
obTY6?lY:ASo:BTHohb<Loo>_JGoBUY2obTY6?li8ASoNf=:oha[B_mJFT;o
>D8aobTa:OlY8@SoBU8iohBDU?mkQ8CoFV=JonoWioo_moOoinONolk>g_og
mnoooooooeGooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVi
on?Shoooool06Oooool00ooNg]koc/kNooooo`04onoWi`04omKFioo_inOo
inONomKFi`KoknOW00Goe]KWooO_iooooooo[JfUoc4i8@02odYJ@P09oiB<
Honm_Jgo[KFeof]cLol@40So>B4Hoc4H4?lH413oFV][00;oFV=J00WoHg><
ojfe]OnL]MkoYKG>onoWioo_moOog]kNolkFc_o_inL0oooooomEooooo`03
onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo01Wooooo
00Kog]kNomkNc_ooooooc]KNokfm_One[Jd2ojf]Y@0Eohb<S?ne_Lko_Kf]
oibLYOn][JGo[KFeokfm_On][JGo[KFeojf]YOoWkoOoooooolk>c_mSLhco
NhB4of]SD_mkNg_o_Kf]ojfUU?n<S8co:BTY00;o000000goBU9Joibeg_nU
]LkoW;GNojFmg_nL]NOo]LKFoibeg_o_inOomoO_omkNg_o>c/kokoOg0?oo
ooooE_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?S
ooooo`0Iooooo`05omkNg_o>e]koooooonoWiooNg]h00_o_moL00oo_inOo
c/k>onogm`02onoWi`03olk>c_o_inOoc]KN00;oknOW00CoinogooO_ioog
mnooe]KW0_nL[Kd01_nLW:Go[JfUokfm_One_Lko]LKFojFecP;oHg><1_nL
]Mh01onL]NOoYKG>onoWiooooooog]kNolkFg_o_inL0oooooomEooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Sooooo
0_o_inL01Oo>e/koooooonoWioo_inOokoOg00;oknOW00?o[KFeonoWioo_
moL01Oo_inL01OoWkoOomnoWonO_moooooooc]KN00;o[KgW00?o[LKgoib]
_Oo>aZd00onL]NL01On]a^ooW;GWoibeg_nL]MkoW;GW00GoW;GN00Goc]KN
onogmooNg]koc/k>onogm`0Booooo`03ooclo?oZj^[ooooo00cooooo00?o
o_knonWYjOono_h04Oooool01?oalO7ooooooo[jn_odm?@2ooooo`03oogm
oOoZj^[ooooo0?oooooo5oooool00ooVi^Kohn?SokVi^@02onKViP000oo^
k^h00oni^KWohn?Sooooo`0Iooooo`08onOWg_o>c]koooooolkFg_nLW9co
c/JeokFmc_n]]KD2ojf]Y@03oibLYOn][JGoW9bL00;oc/k>013o[KFeojf]
YOn<S8coc/k>oooooonea]KoW:gNoibeg_nL[MkoW:fmojf]YOnL[MkoW:g>
oibeg_nL[MkoW:g>0_nL[Mh01_nL[LkoW:gNoib]g_nL[LkoW:gNoib]cP;o
knOW00?og]kNolkFc_o_inL02oooool00ol61PKofm_Kooooo`03ooooo`05
oj6QXOlB4Q;o=cLgob4Q8Oo;bl/00_ooool01_nGUiOo3`l?oo[jn_oooooo
C4a<oeIFEP;ooooo00So/K6aoaLG5oli>CWo=3@dokVi^Ooooooo3Ph>on;R
hP?ooooo01Co20P8ooooooooooooS8b<omcLg?ooooooIVIVoh^;Roo/k>co
9RHVob`/;?mJFU[o<S8bog=cLooooooo[Zj^oa0@4?l/;2co8b<SonSXj?oo
oooo5_ooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?S
ooooo`0Hooooo`08onogmooNg]kog]k>ooooooo_inOoc]KNonoWioogmnl3
onoWi`05olkFg_o_inOoinONomKFioo_inL00ooNg]h01Oo_inOokoOgonoW
ioo>e]kog]kN00;oc]KN00Cog/k6omKFiooNg]koe]KW0_o>e]h00ooNg]ko
c]KNolkFgP04olkFgP05okG6e_o_inOomoO_olkFg_o>c/h03?ooool00ol6
1PKofm_Kooooo`02ooooo`06ooclo?lF5QKofMWIoooooonRXZ;oDE5A0_oo
ool02_m>CTko8b<Sok^k^oojn_[o5aLGob@T9?ofm_Koi^KVo`/;2oo7alL4
ooooo`03o`h>3_oRh^;ooooo00;ooooo01;o20P8ooooooo5aLGo0`<3ofi^
K_ooooooIVIVoh^;RonQXJ7o@d=3ooooooo;bl_o10@4ooclo?ono_ko7AdM
ojVYZOooool2oogmoOoooooo5oooool00ooShn?o^KViooooo`01ooooo`00
0oo^k^h00oni^KWohn?Sooooo`0Iooooo`;og]kN00koooooonoWiooooooo
ooooomKFioo>c/koknOWooOgkooooooomoO_onO_moo_inOo_KfmomkNgP;o
oooo00[oinogonoWioo_moOoooooonoWiooooooomnoWoooooooWkoOokoOg
0_o_inL01?ooooooknOWonO_moogmnl2onoWi`03omkNg_o_inOokoOg00;o
knOW00?og]kNolkFc_o_inL02oooool00ol61PKofm_Kooooo`02ooooo`0A
okfm_OlZ:R[oooooooooooo]kNgo2@T9oo?clooinOWo3`l?ojj^[_m/K6co
`<30odY:B_mYJFWo[jn_oj^[ZolQ8B400ono_kl01?oYjNWoooooo`h>3_oR
h^83ooooo`0Ao`P82?ooooooJVYZofm_KolW9bOono_kofIVI_n;Rh_ohN7Q
oahN7_nBTY;o^KVio`P82?oooooo`L71oaHF5_omoOd0oooooolIooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Sooooo
0_o_inL04?o>e]koooooonogmon][JGo_Kfmolk>c_n<S8co[JfUokFmc_o_
inOoW9bLojf]YOn<S8coQ9BDoiB<S?n]]KD2ojf]Y@09olk>c_o_inOoinog
omkNg_nLW:Goc/k>ojfe]On][JGoW9bL00;oc/k>00SoW9bLomkNg_n]YICo
c/kNojf]YOnLW:GoQ9BDolkFcP;oknOW00CokoOgolk>g_o>c/kokoOg2ooo
ool01ol61PKo9bLWofYZJ_nh^;SooOgmol[:b_lR8R800_ooool03OoUiNGo
3`l?ooWinOnk^k_o?Cdmoo_knol^;RkoNGUiohj>S_nl_;coG5aLolO7aolG
5aL00_mdM7@01OlK6a_o`L71ooooool>3PkogmoO00?ooooo017o20P8oo[j
n_lC4a?odM7AofYZJ_na/K7oIVIVoh^;Roooooooo?clolo?con=SHgo20P8
ooooooo9bLWo3Ph>oo[jnP3ooooooaWooooo00?oi^KVon?Shoni^KT00_oV
i^H000?ok^k^00?o^KVion?Shoooool06Oooool01OoNg]koc]K>ooooooo_
inOoc/k>00?og]kN00[oc]KNonoWioo_inOog]kNolkFg_o>c/koe/kFojfe
]OoNg/koc]KN0_o>c/h01oooooooknOWojfe]On<S8co_Kfmojf]YOoNg]h0
0_o>c/h02OoNg]koc/k>omkNg_o>c/kog]kNomK>e_o>e/koc/k>omKFi`03
onoWi`03omkNc_o>e]koknOW00_ooooo02go1PH6om;Bd_nh^;So92@TohJ6
Q_oooooo8B4Qokbl_?olo?coPX:2oemOGoooooooLW9bohF5QOooooooFUYJ
oa<C4ooCdm?ono_kob8R8_ohn?So8R8Ron3Ph?o_knoo7AdMoo[jn_oooooo
3Ph>oe]KFoo/k>coo_knooooool820So/k>cobd];OoooooobLW9oe=CDomV
IVKoRh^;ooooooo<c<cooOgmolO7aolW9bL00_ooool01OlR8R;oSXj>oo_k
noohn?Soo_kn0?oooooo5_ooool00oo^k^kohn?SokVi^@02onk^kP000ooo
ool00oni^KWohn?Sooooo`0Iooooo`04onOWg_o>e]koooooonogm`?ooooo
00GoknOWoooooooWkoOoooooooO_i`03ooooo`08onoWioo_moOoknOWoooo
ooo_inOoooooomkNg_o>c/h2omkNgP0:onoWioooooooinogooooooo_inOo
inogooO_iooWkoOoknOWonO_m`CoknOW00Goe]KWonoWioo>e]kog/k6onog
m`0;ooooo`0Ao`H61_oKfm_oooooohn?Sol`<33ooooool71`Ole=CGo9BDU
od];BooQhN7ooooooe9BD_oAdM7ooooook6a/Olj>SX00_ooool01_mfMWKo
alO7ok^k^ola<C7o?cloojn_[`;ooooo00So=cLgojFUYOl/;2co^k^koooo
ool820SoF5QHohR8R0;ooooo00So;Rh^oeADE?n;Rh_oooooofQXJ?lj>S[o
<S8bojJVYP;ooooo00God=3@ofYZJ_l/;2co;2`/ooOgm`3ooooooaOooooo
00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool06Ooo
ool01OoFe^Ooc/k>ooooooo_inOo[JfU00;o[KFe00Wo_Kfmojfe]OoNg]ko
_Kfmojfe]OoWimko[JfUokFmc_n][JD00_o>c/h01one[Jgo_Kfmojfe]OnL
W9coS8b<okfm[Oo>c]h00_n]]KD2ojf]Y@06olk>g_nm_Kgo[JfUokfm_Oo>
c/ko[JfU0_n]]KD2ojf]Y@05olk>c_o_inOoc]K>olk>c_oWkoL02oooool0
1Ol61PKofm_Koo?clomKFe_oG5aL01_ooooo00?o1`L7o`/;2ooShn<00_oo
ool00on5QHGo2PX:oh^;R`3oooooob;ooooo00?ok^k^on?Shoni^KT00_o^
k^h000?oi^KV00?o^KVion?Shoooool06?ooool02?ogmnooinONomkNg_oo
ooooknOWojfe]On][JGoc/k>0_nm_Kd01?oNg]koc/k>ojf]YOoFe^L2ojf]
Y@06olk>c_oNg]ko_KfmoibLW?o>c/koa[fm0_nm_Kd02_o>c/kog]kNojfU
U?n]]KGoc/k>okfm_Oo>c/ko[JfUokFmc_o>c/h2okfm_@06ojf]YOo>c/ko
_Kfmojf]YOnm_KgoknOW0_o>c/h00oogmnooooooooooo`09ooooo`05oa<C
4olS8b?o61PHoc`l??oBd]806oooool00olC4a?oAdM7ooooo`02ooooo`03
on;Rh_l=3@goTI6A0?oooooo8_ooool00ooVi^Kohn?SokVi^@02onKViP00
0oo^k^h00oni^KWohn?Sooooo`0Iooooo`04omKFioo>e/koooooonogm`?o
knOW00Kog]kNooooooooooooknOWooooooo_moL2onoWi`06ooooooogmnoo
moO_omKFioogknOoinog0_ogmnl00ooWkoOokoOgonoWi`02onoWi`06onO_
moo_inOog]kNonO_moo_inOoc]KN0oo_inL01ooFe^Oog]kNomkNg_oWimko
c/k>olkFg_o_inL0oooooomEooooo`03onk^k_oShn?o^KVi00;ok^k^0003
ooooo`03okVi^OoShn?ooooo01Sooooo00OomoO_onOWg_oFc]KoooooonoW
ioo>c/ko[KFe00;oW9bL00[o[JfUokfm_OoNg]koc/k>okfm_OoNc/Koc]KN
okfm_One_Lko_Kfm0_o>c/h03onm_Kgo]Kg>olk>c_o>a[Goc]KNokfm_On]
]KGoc/kNomkNc_nm_Kgo[KFeokfm_On]]KGo_Kfmolk>cP02okfm_@04olk>
c_n][JGo_Kfmolk>gP;oc/k>oooooomGooooo`03on?Shoni^KWooooo007o
oooo0003onk^kP03okVi^OoShn?ooooo01Wooooo00Ooe]KWolkFc_oooooo
knOWoibLW?nm_Kgo[JfU00;o_Kfm00Go[KFeolk>c_nm_Kgo_KfmolkFgP02
ojfe]@06ojf]YOn]]KGo[JfUojfe]Onm_Kgo[JfU0_nm_Kd02?oNg]koW:fm
ojf]YOo>a[Goc]KNohBDU?n][JGo[KFe0_n][JD02_o>c/ko_KfmoibLW?nm
_KgoS8b<oibLW?oNg]koc/k>omk>a_oWkoOooooooeGooooo00?ok^k^on?S
honi^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool06?ooool01_ogmnoo
inONolk>g_ogmnooknOWomkNgP;oinog00KoknOWonogmoo_inOoinogonoW
ioo_moL2onoWi`04olk>g_o_inOomoO_olkFgP;og]kN2oo_inL01_oNg]ko
knOWomkNg_oNg]koc/k>omK>eP;oc/k>00Coc]KNolk>c_o>c/komnoWoooo
oomEooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?o
oooo01Wooooo00Coe]KWolk>c_ooooooe]KW1Oo>c/h01?oNg]koc/k>olk>
c_oWg]h4olk>cP0<olk>g_o>c/koc/k>ohBDU?nm_Kgoc/k>olkFg_o>c/ko
_Kfmolk>c_nm_Kgoc/kN0_o>c/h01onm_Kgoc/k>okfm_Oo>c/ko_KfmokF]
[On]]KD00_nm_Kd01?oNc/Ko_Kfmolk>c_o_moOooooooeGooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool06Oooool01?oN
g]koc/k>ooooooo>e]h3ojf]Y@0=oibLYOn<S8coc/k>oibLW?n][JGo]LKF
okfm_On4U9Co[JFDojf]YOo>c/ko[KFeolk>cP02ojf]Y@04oibLW?nm_Kgo
c/k>ojf]Y@;oS8b<013oa[fmoibLW?n<S8coW9bLoibLYOn<S8co_Kfmohb<
S?nLW9coU8b<oibLW?n<S8co]Kg>okfm_OoNg/koknOWoooooomFooooo`03
on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo01Sooooo
00CokoOgonoWioo>c/kokoOg0oo_inL01OoNg]koknOWolk>c_o>e/kog]kN
00GoknOW00?oinONonoWioo_inL00_o_inL01_oFe^Oog]kNolkFc_o_inOo
inONomKFi`?oc/k>00So_Kf]olk>g_o>c/kog/k6okFmc_nm_Kgoc/k>okFm
cP?o_Kfm00?o_Kf]olkFg_ooool0oooooomEooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo01Sooooo00ComnoWomKFiooN
g/kooooo1?oNg]h01oo>c/kog]kNolk>g_oNg]kog]k>omkNg_o>e]h00_oN
g]h00oo>c]kog]kNomkNgP02omkNgP0:olk>c_o_inOoc/kNomkNc_ne_Lko
g/k6ojf]YOnLW:Go]Kg>okF][@;o[JfU00?o[KFeojf]YOn][JD00_n][JD0
1_nLW:Go[JfUojfe]Onm_KgoknOWonogmoooooooEOooool00ooVi^Kohn?S
okVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0Iooooo`04onoWioo>
c/kokoOgolk>cP;o[JfU00?oW9bUoibLW?n<S8`00_n][JD03On4U9CoW9bU
ojf]YOn][JGoW9bUojf]YOnLW:Goc/JeoibLYOn<S8coW9bLolk>c_n<S8`0
0onLW9`01?n][JGoS8b<og]kNomkNg/2of][J`0:oibLW?m[Jf_oJf][og]k
Non<S8coFUYJoibLW?n][JGoc/kNonoWioooooooE_ooool00oo^k^kohn?S
okVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Hooooo`06onO_mooW
imkoc/k>ooooooo>c/koc]KN0ooNg]h02_nm_Kgog]kNomkNg_oNg]ko_Kfm
omkNg_o>c/koc]K>omkNg_oWimh2olk>cP03okfm_Oo>c/kog]kN00;og]kN
00coc/k>olkFg_o>c/ko_Kfmojf]YOnLW9coS8b<og]kNon<S8coNg]kog^4
Q?mkNg/2ohb<S003oibLW?nm_KgoknOW0?ooooooF?ooool00ooShn?o^KVi
ooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0Iooooo`04onOWg_o>
c/kokoOgonoWi`Cog]kN0_nm_Kd02?oWimkog]kNomkNg_oNg]koinONomKF
iooNg]koe]KW1_oNg]h02?o>c]kog]kNomk>a_o>c/ko_KfmoibLW?n<S8co
Jg=c1?m[Jf/01OmkNg_oNhB4oibLW?nm_Kgog]kN0?ooooooF?ooool00oo^
k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0Hooooo`0:
ooOgkooFe^Ooc]K>onO_moo_inOoS8b<ojf]YOo>c/koQ9BDokF][@GoW9bL
00Goc/k>ojfUU?n][JGoS8b<oibLY@02ojf]Y@03oibLW?n][JGoS8b<00;o
W9bL00?oNhB4okfm_OmkNg/00om[Jf/00on<S8coNg]kohb<S002ojf]Y@;o
c/k>00?og]kNooooooooool0oooooomGooooo`03onKVi_oShn?o^KVi00;o
i^KV0003onk^kP03okVi^OoShn?ooooo01Wooooo00Oog]kNolk>c_o_moOo
knOWolk>c_o>e/koinON00;og]kN00Woc]KNolk>c_o>c/koc]KNolk>c_oN
g]koc/k>olk>g_oNg/h00oo>c/h00on]]KGoc/k>olk>cP02olk>cP05olJm
_One_Lko[JfUohb<S?nm_Kd01?ooool01?o_inOog]kNolk>c_oNg]kooooo
oe[ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shooo
ool06Oooool01ooNg]koc/k>onoWioo_inOog]kNomKFioo_inL00_oNg]h0
2_oWg]koknOWonoWioo_inOog]kNolk>g_oWimkog]kNomKFioo_inL6omkN
gP?oc/k>00?o[KFeoiB<S?o>c/h00oooool2omkNgP03olk>c_oNg]kooooo
0?ooooooFoooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWo
hn?Sooooo`0Hooooo`0HonO_mooWimkoc/k>onogmoo>a[GocXaSomk>_Oo_
inOog[f]olIkB_o>aZgoc]KNojf]YOn4U9Co[KFeoibLW?o>c/ko[KFeojfU
U?n4U9Co[KFeoibDS?o>c/koW9bU1?nLW9`02_n][JGoNhB4of][Jonm_Kgo
ooooonogmooWimkog]kNolk>c_oNg]kooooooecooooo00?ok^k^on?Shoni
^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool06Oooool06?o>e]koc/k>
onogmoo_inOoaZfLomkNc_o_inOoaZfLolj<Hoo_inOoe]KWokfm[Oo>c/ko
[KFeolk>c_oNg]koc/JeokFmc_o6_Kgoc/JeokFmc_o>a[Go[JfUojfe]@;o
_Kfm00[oW9bLojf]YOn<S8coNhB4olk>c_ooooooknOWolkFg_o>c/kog]kN
oooooomMooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoS
hn?ooooo01Sooooo00gokoOgonoWioo>c/koknOWonOWg_o>e/kocZF4olk6
]Oo6Nd[oc[fUonoWiooWimkoc]KN00;oknOW00?oinONomkNg_oNg]h01?oN
g]h00oo>c]koc/k>omkNgP02omkNgP09olJm_One_Lko[JfUohb<S?o>c]ko
knOWomkNg_o>c/kog]kN0?ooooooG_ooool00oo^k^kohn?SokVi^@02onk^
kP000oooool00oni^KWohn?Sooooo`0Iooooo`09omkNg_o>c/komoO_omKF
ioo_inOoe[FLolk6]Oo6Nd[oc]KN00;oknOW00?oinONomKFiooWimh01OoN
g]h01?o>c]kog]kNomkNc_oNg]h4olk>cP;o[JfU00GoS8b<omk>a_oNg]ko
c/k>omkNgP3oooooof3ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^
00?o^KVion?Shoooool06?ooool00ooWkoOoinONolk>cP03onoWi`03olk6
]Oo>S6?ocYak00;oknOW00?oinONomkNg_oNg]h00ooNg]h02?o>e]kog]kN
omkNg_oNg]kog]k>omK>e_o>c/kog]kN0_o>c/h2okfm_@;oW9bL00?oc]KN
olk>c_oNg]h0oooooomPooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo01Wooooo00cog]kNolk>c_o_inOoknOWolkFg_oW
imko]G=Jolk6[Oo_inOoinONomKFiooWimh5omkNgP06omkNc_o>c]kog]k>
olk>g_oNg/koc/kN0oo>c/h01_nm_Kgo[KFeoibLW?nm_Kgoc/k>omkNg_oo
ooooHOooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?S
ooooo`0Hooooo`05onogmoo_inOoc/k>ooOgkoo>e]h00_o_inL01?o>a[Go
inONonOWg_oFe^L5omkNgP07olk>g_oNg]koc]KNomkNc_o>c]kog]k>olkF
gP03olk>cP06okfm_On]]KGo[JfUojfe]Oo>a[Gog]kNoooooomRooooo`03
onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo01Wooooo
00_oknOWolkFg_o_inOoinONolkFg_o_inOoinONomKFiooWimkog]kNonOW
gP03omkNgP07omkNc_oNg]kog]k>omK>e_oNg]koc/k>olkFgP02olk>cP07
olk6]One_Lko_Kfmokfm[On][JGo[KFeomKFi`3oooooofCooooo00?ohn?S
okVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool06Oooool04?o_
moOoknOWooOgkooFe^OoknOWonOWg_oFe^OoinONolkFg_oWimkoc]KNomkN
g_o>e]kog]kNolkFg_oNg]h2olkFgP03olkFc_o>e]koc/k>00?oc/k>00Go
_Kfmojfe]On]]KGoc/k>onoWi`3oooooofCooooo00?ok^k^on?Shoni^KT0
0_o^k^h000?oi^KV00?o^KVion?Shoooool06_ooool>onoWi`08omkNg_o_
inOoknOWonoWiooNg]koknOWomkNg_o_inL2omkNgP;oknOWoooooomVoooo
o`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?oo
ooooV_ooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?S
ooooo`3ooooooi_ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o
^KVion?Shoooool0oooooonJooooo`03onk^k_oShn?o^KVi00;ok^k^0003
onKViP03okVi^OoShn?ooooo0?ooooooV_ooool00ooVi^Kohn?SokVi^@02
onKViP000oo^k^h00oni^KWohn?Sooooo`3ooooooi[ooooo00?ok^k^on?S
honi^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0oooooonKooooo`03
on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo03Cooooo
00?okoOgooooooo_moL00_ooool00oo_moOoooooooooo`02ooooo`03onog
moooooookoOg00;ooooo00?okoOgooooooooool0oooooomDooooo`03onk^
k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo02kooooo00?o
knOWooOgkoo_inL06oo_inL01?oFe^OoknOWonoWiooFe^L6onoWi`03onog
mooooooooooo0?oooooo@Oooool00ooVi^Kohn?SokVi^@02onKViP000oo^
k^h00oni^KWohn?Sooooo`0]ooooo`0>ooOgkooNg]koc/kNokfm_One_Lko
c/JeokFmc_o>a[Go]Kg>olk6]Onm_Kgo]Kg>olk6]One_Lh3okfm_@07olk>
c_nm_Kgoa[fmokFmc_o>a[Goa[fmokFmcP02okfm_@05olJm_One_Lko_Kfm
olJm_One_Lh00onm_Kd02Oo>c/ko_Kfmokfm_Oo6_Kgo]Kg>okfm_Oo>c/ko
c]KNonoWi`3ooooood;ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo
00?o^KVion?Shoooool0;Oooool01OoNg]koc/k>ojf]YOn][JGoW9bU017o
W9bL00?oW9bUojfUU?nLW:D00_nLW9`01on]YICoW9bUoibLW?nLW9co[JfU
oibLW?nLW:D00_nLW9`00on][JGoW9bLoibLW002ojf]Y@03olk>c_oNg]ko
koOg0?oooooo@_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni
^KWohn?Sooooo`0]ooooo`03onoWiooNg]kooooo02Kooooo0_oNg]h00oo_
inOoooooooooo`3oooooocoooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
i^KV00?o^KVion?Shoooool0;Oooool00ooNg]koc]K>ooooo`0Cooooo`03
ooOgkooooooooooo00;ooooo00GoinogooooooooooooooooonoWi`02oooo
o`03onoWioooooooinog00;ooooo00CokoOgoooooooWimkoc/k>oooooom2
ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo
02cooooo00?oinogonOWg_o>e]h00_ooool00oo_moOoooooooooo`0;oooo
o`03onogmooooooooooo00?ooooo00?oinogooooooooool02_ooool01oo_
inOooooooooooooooooog]kNolkFg_o_inL0oooooom1ooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo02gooooo00?og]kN
omk>a_ooool04Oooool00oo_moOoooooooooo`02ooooo`03ooO_iooooooo
oooo00;ooooo00Coinogooooooooooooinog1Oooool01Oo_inOoooooonoW
ioo>c/kokoOg0?oooooo@_ooool00ooShn?o^KViooooo`01ooooo`000oo^
k^h00oni^KWohn?Sooooo`0/ooooo`03ooOgkooWg]koc]KN00kooooo00?o
koOgooooooooool01?ooool00oogmnooooooooooo`0:ooooo`03onogmooo
ooooinog00;ooooo00?og]kNolkFc_o_inL0oooooom1ooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo02gooooo00?og]kN
olk>c_ooool00oooool02_o_inOoc/k>onoWioo_moOoooooonO_mooooooo
knOWolk>c_o_inL2ooooo`03onogmooooooog]kN00Gog]kN00Koe/kFohAk
LonLJf?o[G]SoljmYOnDS8`2ojekH`0:okfm_Oo>a[Gog]k>olk6]Onm_Jgo
inogoooooooNg]koc/k>onogmooooooo@Oooool00ooVi^Kohn?SokVi^@02
onKViP000oo^k^h00oni^KWohn?Sooooo`0]ooooo`04omKFiooNg/kooooo
onoWi`;o_Kfm00Goc/k>oibLW?n]]KGoc/k>onogm`02ojf]Y@;oW9bL01go
S8b<okfm_On][JGoknOWoooooooWimkoknOWooOgkoo_inOomnoWonOWg_oN
c/KoDTY2og/@2?n4613o[G]SoiA2<Omc613oW34QoljUQ?oNg/koknO>omkN
c_o>a[GoknOWoooooooNg]koc]KNonoWi`3ooooood7ooooo00?ok^k^on?S
honi^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0;?ooool00oogmnoo
inONolkFgP02ooooo`03omK>e_oNg]koknOW00;og]kN00OoknOWoooooooF
e^OoknOWolkFc_oNg]ko_Kfm00;og]kN0_ooool06?o>c/koQ9BDoibLYOnL
W9coNhB4of]cLomJJf_oBQPHog<H4?nL<B7oQ3Taof<H6?n48ASoYG=Jojek
HonLW:GoW8AkoiB<Hon]]KGomoO_ooooooo_inOoc/k>onogmooooooo@_oo
ool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0]
ooooo`03omKFiooFc]Kooooo00Oooooo00?okoOgooooooooool00_ooool0
0ooWkoOoooooooooo`02ooooo`0>omk>a_n<S8coS8b<of][Jon<S8co[JFD
of][JomB20SoJc4Yoi`a8On]Nf?oQ1P@oh@Q6?m[<BT2odYBFP08oeYJF_mB
BT;oJg=conoWiooooooog]kNolkFg_o_inOooooood7ooooo00?ok^k^on?S
honi^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0;Oooool01OoNg]ko
c]K>ooooooogknOo[KFe00;o_Kfm00Oo]Kg>okfm[Oo_inOoc/k>ojf]YOo_
inOo[KFe00;o_Kfm01?og]kNokFmc_o>a[GoooooolkFg_nm_Kgo[JfUoibD
S?n]YICoc/Jeog]cHolH413oDPP8ojekHon<Jd[oQ24Hog/a:OmB>C7o:BTY
00?o>CTa00KoFUY2onoWioooooooinONolk>c_o_moOooooood7ooooo00?o
i^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0;?ooool0
;Oo_moOoinONolk>c_ooooookoOgokfm_On][JGoc/kNolk6]Oo>c/koknOW
olk>c_nm_KgoknOWojf]YOnm_Kgoc/k>omkNg_o>c/ko[KFeoooooooNg/ko
_Kf]ojf]YOnLW9co[Ib4oljmYOmcJf?o8AP@oe9:@_mS@SWoBS4Yoe8i<OmB
>BWoNg]kog^4Q?mJFU[oBU8iodY:<Om:DSWoknOWoooooooFe^Ooc]K>onoW
i`3ooooood7ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVi
on?Shoooool0;Oooool02?oNg]koc]KNooooooooooookoOgooooooo_inOo
inog1Oooool00oo_moOoooooooooo`02ooooo`09onoWioooooooc/kNokfm
[Onm_KgoU8b<og=cF_n]W8CoLf]S00;oDSTa00oo@RTQoe8i<OmJ@SWoDSTa
ohb<Lon<S8coNg]kof]SD_m[Jd[oFV=JonoWioooooooinONolk>g_ogmnl0
oooooom2ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo02cooooo0_o_inL00ooFc]KoooooonoWi`02olk>cP09oibLYOn]
YICo]Kg>olk6]OoNg]koc]KNolk>c_oNg]koc]KN00;oc/k>00coa[fmolkF
g_ooooooc/Jeohb<S?n<S7?oFUY2ohb<S?o>a[GoLf]Soe9:@_la6102oe8i
<@04og=JD_mB>C7oFUY2og]cH`;oJf]:00OoFUY2of][B_o_inOokoOgonoW
ioo>e/koknOW0?oooooo@Oooool00oo^k^kohn?SokVi^@02onk^kP000ooV
i^H00oni^KWohn?Sooooo`0]ooooo`06omkNg_o>e/kooooooooooon][JGo
[KFe1?nm_Kd01_oNg]ko_Kfmolk6]Oo>e]koc/Jeojfe]@;o_Kfm017o[JfU
oooooon]]KGoBTY:oe9:@_m[He;oS8acoib4NomJFU[oDSTYod8Y8Om[BT;o
FUY2og=JD_mSFT[o:BTHocTi6002oeYB:@06ocTi6?mkHd[oknOWoooooooN
g]koc/k>oooooom2ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo02cooooo00KokoOgonOWg_o>c/koooooonogmoo_inL9
ooooo`0NonoWiooWimkoooooonogmoo_inOoooooojf]YOlY<BWo:BTHodY:
:On]YICoa[fmocTi<Om2:B7oDSTaoe9:@_mkFT[oJf=BoeY2>OlY:ASoBS4Y
odY::OmcLe[oBS4Yoe9S@_oFe^OoooooonOWg_o>e]koknOWoooooom1oooo
o`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo02go
oooo00[og]kNolkFg_ooooooknOWolkFg_oNg]koc/k>omkNg_o>c/koknOW
0_o>e]h08?o_inOog]kNolkFg_o>c/koe/kFonoWioo>e]kokoOgojfUU?l0
003o:BTHocTQ6?nLU8coc/J]og]cHolY:ASo@RTQojekHonDJe[oJc4YocTi
6?lY:ASo<CTQodY::Om:BS7o>CTHodY:<Oo_inOokoOgonoWioo>c/kokoOg
oooooom2ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo02cooooo02gokoOgonoWioo>c/koooooomkNg_nm_Kgo[JfUojfe
]On][JGoW9bLokG6e_n][JGo_Kf]olkFg_o>c/koW9bUojf]YOnm_Kgoc]K>
okfm_Oo_inOo[JfUoa000?lY:ASo<CTQokfm[OoNc[goS8acobTY6?mcFU;o
[G]SolJ]W?n4Ng?o<CTQoaP@4?li>ASoBU8iodYJ@_lY:BWo>D8aonoWiooo
ooooe]KWolkFc_o_inL0oooooom1ooooo`03onk^k_oShn?o^KVi00;ok^k^
0003onKViP03okVi^OoShn?ooooo02cooooo0_o_inL00oo>e/kooooooooo
o`03onogm`04ooOgkoo>e]koinONonoWi`KokoOg0oooool06?n][JGo:BTH
obTY6?lY:ASoS8acoljmYOm:FT;o:BTHocTQ6?mkHd[oS6]:oeYJ@_li@S7o
:C4YobTQ2?m:DSWoQ9BDog^4Q?mJHe[oknOWonogmooWimkoc/kNooOgkooo
oooo@Oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?S
ooooo`0]ooooo`03omkNg_o>c]kooooo00CoknOW00Coe]KWonoWiooWimko
e]KW1_o_inL01OoFe^OomnoWoooooon][JGo<CTQ00;oBUY200WoU8aSokfm
[On]]KGoJg=coa0@2?li8ASo<AP@oaP@4?mJJf/00_mJHeX02OmSLhco[KFe
oibeg_nU]LkoknOWonogmooNg]koc]K>onoWi`3ooooood7ooooo00?ok^k^
on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0;Oooool01_oN
g]kog]k>ooooooo>e]ko_KfmokF][@;o[JfU01GoS8b<okFmc_nm_JgoW9bU
ojf]YOn]]KGo_Kfmojf]YOn]]KGo[JfUonO_moooooooc/k>of=cS?mkQ8Co
Jf=Bog]kNonm_Jgo[JFDohb<S?lY:BT00_l000003Om:DU[oW;GNojFec_nL
]MkoYKgNoibeionea]KoW;GNonoWioogmnoog]kNolk>c_o_moL0oooooom2
ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo
02gooooo00Gog]kNolkFg_ooooooknOWomkNgP02onogm`03onoWioo>c/ko
koOg00;oknOW00?oc/k>onoWioo>e]h00_o_inL01?oWkoOomnoWooOgkooF
e^L2oib]_@06oibLYOn][JGo_KfmokFmc_nea]KoYKG>0_mSLh`6oibegP07
oibeionU]LkoknOWoooooooNg]koc]KNonoWi`09ooooo`03ogQhN?nHV9So
k>c/0?oooooo=Oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni
^KWohn?Sooooo`0/ooooo`;oknOW00Goc]K>ooooooo_inOoknOWonogm`02
onoWi`03ojfe]Oo_inOokoOg00GoknOW00GoinogooO_iooWkoOoooooolkF
gP02ojfmi`03ojg6monL[Kgoc/J]00?oW;GW00Go[LK_oibeionL]MkoW;GN
oibei`05oibegP05olkFg_o_moOog]kNolk>c_o_moL02Oooool01?nBTY;o
RHV9oaPH6?ojn_X2ooooo`04oo7alOoooooon_[jooCdm0Sooooo00ColO7a
ooooooojn_[om?CdoooooolRooooo`03onKVi_oShn?o^KVi00;oi^KV0003
onk^kP03okVi^OoShn?ooooo02gooooo00SoinONolk>g_ooooooc]KNoibL
W?o>a[Go]Kg>ojfe]@;o[JfU00?oW9bUojf]YOnLW9`00_o>c/h04?n]]KGo
[JfUohb<S?o>c/kooooookG6e_nL[MkoW;GNoib]g_nL[Kgo[JfUoib]g_nL
[LkoW;GNoib]g_nL[Lh2oib]gP06oib]c_nL[MkoW:gNoib]c_nL[MkoW:g>
0_o_inL00ooNg]koc]K>onoWi`0;ooooo`0<ocHf=_ni^KWok>c/obHV9_l/
;2coFUYJoc8b<_mcLg?oooooooclo?lG5aOoNWYj0_ooool01_o/k>co9RHV
ob`/;?mJFU[o<S8bog=cLooooooo8_ooool00oo^k^kohn?SokVi^@02onk^
kP000oooool00oni^KWohn?Sooooo`0/ooooo`08onogmooNg]kog]k>oooo
ooo_inOoc]KNonoWioogmnl3onoWi`05olkFg_o_inOoinONomKFioo_inL0
0ooNg]h01Oo_inOokoOgonoWioo>e]kog]kN00;oc]KN00Cog/k6omKFiooN
g]koe]KW0_o>e]h00ooNg]koc]KNolkFgP04olkFgP05okG6e_o_inOomoO_
olkFg_o>c/h03?ooool05?m>CTkoTI6Aoj6QXOm3@d?ooooool_;bol410Co
o?cloooooone]KGo:b/[oahN7_okno_ooooooj6QXOm3@d?ooooool_;bol4
10Coo?cloooooolSooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03
okVi^OoShn?ooooo02gooooo0_oNg]h03_ooooooknOWooooooooooooe]KW
olk>c_o_inOomoO_ooooooogmnooinogonoWionm_Kgog]kN0_ooool02_oW
koOoknOWonogmoooooooknOWooooooogknOoooooonO_moo_moL2onoWi`04
ooooooo_inOoinogooOgk`;oknOW00?og]kNonoWioo_moL00_o_inL00ooN
g]koc]K>onoWi`0;ooooo`07odi>C_nATI7ohN7QoahN7_nBTY;o^KVio`P8
2002ooooo`0:oeIFE_nIVIWoDe=Cok2`/?oooooohN7QoahN7_nBTY;o^KVi
o`P82?oooooo8oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni
^KWohn?Sooooo`0/ooooo`;oknOW013oc]KNooooooo_moOo[JfUokfm_Oo>
c/koS8b<ojf]YOne_LkoknOWoibLW?n][JGoS8b<ohBDU?nDS8co[KFe0_n]
[JD02Oo>c/koknOWonO_mooNg]koW9bUolk>c_n]]KGo[JfUoibLW002olk>
cP08oibLW?oNg]ko[JFDolk>g_n][JGoW9bUohBDU?o>e/h2onoWi`04onog
moo>c]koc/k>onogm`_ooooo00goCTi>oi6ATOooooooo?clolo?con=SHgo
20P8ooooooo_knoo3`l?oo3`l?nh^;SoBTY:00;ooooo00Coo?clolo?con=
SHgo20P8oooooolSooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo02gooooo00Gog]kNolkFc_ooooooknOWolk>cP03omkN
gP0:olkFg_o_inOoknOWomkNg_o>e]koc/k>omK>e_n]]KGog]k>olkFgP;o
c/k>00OoooooonoWion]]KGoS8b<okfm_On][JGog]kN00;oc/k>00Wog]kN
olk>c_oNg]koc/k>omkNg_oFc]Koc]K>olk>c_oFe^L00oo_inL00ooNg/ko
c]KNonoWi`0;ooooo`0Codi>C_nATI7oooooolc<c?omoOgoalO7obLW9ooo
ooooUiNGoeQHF?oooooooOgmob8R8_oRh^;oooooolc<c?omoOgoalO7obLW
9`3oooooob?ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVi
on?Shoooool0;Oooool01?oWimkoc]KNooooooo_moL3ooooo`05onoWiooo
ooooinogooooooogknL00oooool02?o_inOokoOgonoWioooooooknOWoooo
oooNg]koc/k>0_oNg]h02_o_inOoooooonO_moooooooknOWonO_moogknOo
inogonoWiooWkoL4onoWi`05omKFioo_inOoc]KNomk>a_o_moL02oooool0
2_m>CTkoTI6AoooooomXJ6So>SXjoc8b<_nVYZKoooooof1PH?nm_Kd2oooo
o`07oi2@T?nLW9coooooofQXJ?lj>S[o<S8bojJVYP3oooooobCooooo00?o
hn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shoooool0;Oooool0
1OoFe^Ooc/k>ooooooo_inOo[JfU00;o[KFe00Wo_Kfmojfe]OoNg]ko_Kfm
ojfe]OoWimko[JfUokFmc_n][JD00_o>c/h01one[Jgo_Kfmojfe]OnLW9co
S8b<okfm[Oo>c]h00_n]]KD2ojf]Y@06olk>g_nm_Kgo[JfUokfm_Oo>c/ko
[JfU0_n]]KD2ojf]Y@05olk>c_o_inOoc]K>olk>c_oWkoL02oooool00om>
CTkoTI6Aooooo`3ooooooc?ooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
i^KV00?o^KVion?Shoooool0;?ooool02?ogmnooinONomkNg_ooooooknOW
ojfe]On][JGoc/k>0_nm_Kd01?oNg]koc/k>ojf]YOoFe^L2ojf]Y@06olk>
c_oNg]ko_KfmoibLW?o>c/koa[fm0_nm_Kd02_o>c/kog]kNojfUU?n]]KGo
c/k>okfm_Oo>c/ko[JfUokFmc_o>c/h2okfm_@06ojf]YOo>c/ko_Kfmojf]
YOnm_KgoknOW0_o>c/h00oogmnooooooooooo`09ooooo`03oeMGEonFUYKo
oooo0?oooooo<oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni
^KWohn?Sooooo`0]ooooo`04omKFioo>e/koooooonogm`?oknOW00Kog]kN
ooooooooooooknOWooooooo_moL2onoWi`06ooooooogmnoomoO_omKFioog
knOoinog0_ogmnl00ooWkoOokoOgonoWi`02onoWi`06onO_moo_inOog]kN
onO_moo_inOoc]KN0oo_inL01ooFe^Oog]kNomkNg_oWimkoc/k>olkFg_o_
inL0oooooom1ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo02cooooo00OomoO_onOWg_oFc]KoooooonoWioo>c/ko[KFe
00;oW9bL00[o[JfUokfm_OoNg]koc/k>okfm_OoNc/Koc]KNokfm_One_Lko
_Kfm0_o>c/h03onm_Kgo]Kg>olk>c_o>a[Goc]KNokfm_On]]KGoc/kNomkN
c_nm_Kgo[KFeokfm_On]]KGo_Kfmolk>cP02okfm_@04olk>c_n][JGo_Kfm
olk>gP;oc/k>oooooom3ooooo`03on?Shoni^KWooooo007ooooo0003onk^
kP03okVi^OoShn?ooooo02gooooo00Ooe]KWolkFc_ooooooknOWoibLW?nm
_Kgo[JfU00;o_Kfm00Go[KFeolk>c_nm_Kgo_KfmolkFgP02ojfe]@06ojf]
YOn]]KGo[JfUojfe]Onm_Kgo[JfU0_nm_Kd02?oNg]koW:fmojf]YOo>a[Go
c]KNohBDU?n][JGo[KFe0_n][JD02_o>c/ko_KfmoibLW?nm_KgoS8b<oibL
W?oNg]koc/k>omk>a_oWkoOooooood7ooooo00?ok^k^on?Shoni^KT00_o^
k^h000?oi^KV00?o^KVion?Shoooool0;?ooool01_ogmnooinONolk>g_og
mnooknOWomkNgP;oinog00KoknOWonogmoo_inOoinogonoWioo_moL2onoW
i`04olk>g_o_inOomoO_olkFgP;og]kN2oo_inL01_oNg]koknOWomkNg_oN
g]koc/k>omK>eP;oc/k>00Coc]KNolk>c_o>c/komnoWoooooom1ooooo`03
onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo02gooooo
00Coe]KWolk>c_ooooooe]KW1Oo>c/h01?oNg]koc/k>olk>c_oWg]h4olk>
cP0<olk>g_o>c/koc/k>ohBDU?nm_Kgoc/k>olkFg_o>c/ko_Kfmolk>c_nm
_Kgoc/kN0_o>c/h01onm_Kgoc/k>okfm_Oo>c/ko_KfmokF][On]]KD00_nm
_Kd01?oNc/Ko_Kfmolk>c_o_moOooooood7ooooo00?ok^k^on?Shoni^KT0
0_o^k^h000?ooooo00?o^KVion?Shoooool0;Oooool01?oNg]koc/k>oooo
ooo>e]h3ojf]Y@0=oibLYOn<S8coc/k>oibLW?n][JGo]LKFokfm_On4U9Co
[JFDojf]YOo>c/ko[KFeolk>cP02ojf]Y@04oibLW?nm_Kgoc/k>ojf]Y@;o
S8b<013oa[fmoibLW?n<S8coW9bLoibLYOn<S8co_Kfmohb<S?nLW9coU8b<
oibLW?n<S8co]Kg>okfm_OoNg/koknOWoooooom2ooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo02cooooo00CokoOgonoW
ioo>c/kokoOg0oo_inL01OoNg]koknOWolk>c_o>e/kog]kN00GoknOW00?o
inONonoWioo_inL00_o_inL01_oFe^Oog]kNolkFc_o_inOoinONomKFi`?o
c/k>00So_Kf]olk>g_o>c/kog/k6okFmc_nm_Kgoc/k>okFmcP?o_Kfm00?o
_Kf]olkFg_ooool0oooooom1ooooo`03onk^k_oShn?o^KVi00;ok^k^0003
onKViP03okVi^OoShn?ooooo02cooooo00ComnoWomKFiooNg/kooooo1?oN
g]h01oo>c/kog]kNolk>g_oNg]kog]k>omkNg_o>e]h00_oNg]h00oo>c]ko
g]kNomkNgP02omkNgP0:olk>c_o_inOoc/kNomkNc_ne_Lkog/k6ojf]YOnL
W:Go]Kg>okF][@;o[JfU00?o[KFeojf]YOn][JD00_n][JD01_nLW:Go[JfU
ojfe]Onm_KgoknOWonogmooooooo@Oooool00ooVi^Kohn?SokVi^@02onKV
iP000oo^k^h00oni^KWohn?Sooooo`0]ooooo`04onoWioo>c/kokoOgolk>
cP;o[JfU00?oW9bUoibLW?n<S8`00_n][JD03On4U9CoW9bUojf]YOn][JGo
W9bUojf]YOnLW:Goc/JeoibLYOn<S8coW9bLolk>c_n<S8`00onLW9`01?n]
[JGoS8b<og]kNomkNg/2of][J`0:oibLW?m[Jf_oJf][og]kNon<S8coFUYJ
oibLW?n][JGoc/kNonoWiooooooo@_ooool00oo^k^kohn?SokVi^@02onk^
kP000oooool00oni^KWohn?Sooooo`0/ooooo`06onO_mooWimkoc/k>oooo
ooo>c/koc]KN0ooNg]h02_nm_Kgog]kNomkNg_oNg]ko_KfmomkNg_o>c/ko
c]K>omkNg_oWimh2olk>cP03okfm_Oo>c/kog]kN00;og]kN00coc/k>olkF
g_o>c/ko_Kfmojf]YOnLW9coS8b<og]kNon<S8coNg]kog^4Q?mkNg/2ohb<
S003oibLW?nm_KgoknOW0?ooooooA?ooool00ooShn?o^KViooooo`01oooo
o`000oo^k^h00oni^KWohn?Sooooo`0]ooooo`04onOWg_o>c/kokoOgonoW
i`Cog]kN0_nm_Kd02?oWimkog]kNomkNg_oNg]koinONomKFiooNg]koe]KW
1_oNg]h02?o>c]kog]kNomk>a_o>c/ko_KfmoibLW?n<S8coJg=c1?m[Jf/0
1OmkNg_oNhB4oibLW?nm_Kgog]kN0?ooooooA?ooool00oo^k^kohn?SokVi
^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0/ooooo`0:ooOgkooFe^Oo
c]K>onO_moo_inOoS8b<ojf]YOo>c/koQ9BDokF][@GoW9bL00Goc/k>ojfU
U?n][JGoS8b<oibLY@02ojf]Y@03oibLW?n][JGoS8b<00;oW9bL00?oNhB4
okfm_OmkNg/00om[Jf/00on<S8coNg]kohb<S002ojf]Y@;oc/k>00?og]kN
ooooooooool0oooooom3ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^
kP03okVi^OoShn?ooooo02gooooo00Oog]kNolk>c_o_moOoknOWolk>c_o>
e/koinON00;og]kN00Woc]KNolk>c_o>c/koc]KNolk>c_oNg]koc/k>olk>
g_oNg/h00oo>c/h00on]]KGoc/k>olk>cP02olk>cP05olJm_One_Lko[JfU
ohb<S?nm_Kd01?ooool01?o_inOog]kNolk>c_oNg]koooooodKooooo00?o
k^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0;Oooool0
1ooNg]koc/k>onoWioo_inOog]kNomKFioo_inL00_oNg]h02_oWg]koknOW
onoWioo_inOog]kNolk>g_oWimkog]kNomKFioo_inL6omkNgP?oc/k>00?o
[KFeoiB<S?o>c/h00oooool2omkNgP03olk>c_oNg]kooooo0?ooooooAooo
ool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0/
ooooo`0HonO_mooWimkoc/k>onogmoo>a[GocXaSomk>_Oo_inOog[f]olIk
B_o>aZgoc]KNojf]YOn4U9Co[KFeoibLW?o>c/ko[KFeojfUU?n4U9Co[KFe
oibDS?o>c/koW9bU1?nLW9`02_n][JGoNhB4of][Jonm_KgoooooonogmooW
imkog]kNolk>c_oNg]koooooodSooooo00?ok^k^on?Shoni^KT00_o^k^h0
00?oi^KV00?o^KVion?Shoooool0;Oooool06?o>e]koc/k>onogmoo_inOo
aZfLomkNc_o_inOoaZfLolj<Hoo_inOoe]KWokfm[Oo>c/ko[KFeolk>c_oN
g]koc/JeokFmc_o6_Kgoc/JeokFmc_o>a[Go[JfUojfe]@;o_Kfm00[oW9bL
ojf]YOn<S8coNhB4olk>c_ooooooknOWolkFg_o>c/kog]kNoooooom9oooo
o`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo02co
oooo00gokoOgonoWioo>c/koknOWonOWg_o>e/kocZF4olk6]Oo6Nd[oc[fU
onoWiooWimkoc]KN00;oknOW00?oinONomkNg_oNg]h01?oNg]h00oo>c]ko
c/k>omkNgP02omkNgP09olJm_One_Lko[JfUohb<S?o>c]koknOWomkNg_o>
c/kog]kN0?ooooooB_ooool00oo^k^kohn?SokVi^@02onk^kP000oooool0
0oni^KWohn?Sooooo`0]ooooo`09omkNg_o>c/komoO_omKFioo_inOoe[FL
olk6]Oo6Nd[oc]KN00;oknOW00?oinONomKFiooWimh01OoNg]h01?o>c]ko
g]kNomkNc_oNg]h4olk>cP;o[JfU00GoS8b<omk>a_oNg]koc/k>omkNgP3o
ooooodcooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?S
hoooool0;?ooool00ooWkoOoinONolk>cP03onoWi`03olk6]Oo>S6?ocYak
00;oknOW00?oinONomkNg_oNg]h00ooNg]h02?o>e]kog]kNomkNg_oNg]ko
g]k>omK>e_o>c/kog]kN0_o>c/h2okfm_@;oW9bL00?oc]KNolk>c_oNg]h0
oooooom<ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoS
hn?ooooo02gooooo00cog]kNolk>c_o_inOoknOWolkFg_oWimko]G=Jolk6
[Oo_inOoinONomKFiooWimh5omkNgP06omkNc_o>c]kog]k>olk>g_oNg/ko
c/kN0oo>c/h01_nm_Kgo[KFeoibLW?nm_Kgoc/k>omkNg_ooooooCOooool0
0ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0/oooo
o`05onogmoo_inOoc/k>ooOgkoo>e]h00_o_inL01?o>a[GoinONonOWg_oF
e^L5omkNgP07olk>g_oNg]koc]KNomkNc_o>c]kog]k>olkFgP03olk>cP06
okfm_On]]KGo[JfUojfe]Oo>a[Gog]kNoooooom>ooooo`03onk^k_oShn?o
^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo02gooooo00_oknOWolkF
g_o_inOoinONolkFg_o_inOoinONomKFiooWimkog]kNonOWgP03omkNgP07
omkNc_oNg]kog]k>omK>e_oNg]koc/k>olkFgP02olk>cP07olk6]One_Lko
_Kfmokfm[On][JGo[KFeomKFi`3ooooooe3ooooo00?ohn?SokVi^Oooool0
0Oooool000?ok^k^00?o^KVion?Shoooool0;Oooool04?o_moOoknOWooOg
kooFe^OoknOWonOWg_oFe^OoinONolkFg_oWimkoc]KNomkNg_o>e]kog]kN
olkFg_oNg]h2olkFgP03olkFc_o>e]koc/k>00?oc/k>00Go_Kfmojfe]On]
]KGoc/k>onoWi`3ooooooe3ooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
i^KV00?o^KVion?Shoooool0;_ooool>onoWi`08omkNg_o_inOoknOWonoW
iooNg]koknOWomkNg_o_inL2omkNgP;oknOWoooooomBooooo`03onKVi_oS
hn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo0?ooooooV_ooool0
0oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`3ooooo
oi_ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shooo
ool0oooooonJooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi
^OoShn?ooooo0?ooooooV_ooool00ooVi^Kohn?SokVi^@02onKViP000oo^
k^h00oni^KWohn?Sooooo`3ooooooi[ooooo00?ok^k^on?Shoni^KT00_o^
k^h000?ooooo00?o^KVion?Shoooool0oooooonKooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo03Cooooo00?okoOgoooo
ooo_moL00_ooool00oo_moOoooooooooo`02ooooo`03onogmoooooookoOg
00;ooooo00?okoOgooooooooool0oooooomDooooo`03onk^k_oShn?o^KVi
00;ok^k^0003onKViP03okVi^OoShn?ooooo02kooooo00?oknOWooOgkoo_
inL06oo_inL01?oFe^OoknOWonoWiooFe^L6onoWi`03onogmooooooooooo
0?oooooo@Oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWo
hn?Sooooo`0]ooooo`0>ooOgkooNg]koc/kNokfm_One_Lkoc/JeokFmc_o>
a[Go]Kg>olk6]Onm_Kgo]Kg>olk6]One_Lh3okfm_@07olk>c_nm_Kgoa[fm
okFmc_o>a[Goa[fmokFmcP02okfm_@05olJm_One_Lko_KfmolJm_One_Lh0
0onm_Kd02Oo>c/ko_Kfmokfm_Oo6_Kgo]Kg>okfm_Oo>c/koc]KNonoWi`3o
oooood;ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?S
hoooool0;Oooool01OoNg]koc/k>ojf]YOn][JGoW9bU017oW9bL00?oW9bU
ojfUU?nLW:D00_nLW9`01on]YICoW9bUoibLW?nLW9co[JfUoibLW?nLW:D0
0_nLW9`00on][JGoW9bLoibLW002ojf]Y@03olk>c_oNg]kokoOg0?oooooo
@_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Soooo
o`0]ooooo`03onoWiooNg]kooooo02Kooooo0_oNg]h00oo_inOooooooooo
o`3oooooocoooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVi
on?Shoooool0;Oooool00ooNg]koc]K>ooooo`0Cooooo`03ooOgkooooooo
oooo00;ooooo00GoinogooooooooooooooooonoWi`02ooooo`03onoWiooo
ooooinog00;ooooo00CokoOgoooooooWimkoc/k>oooooom2ooooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo02cooooo00?o
inogonOWg_o>e]h00_ooool00oo_moOoooooooooo`0;ooooo`03onogmooo
oooooooo00?ooooo00?oinogooooooooool02_ooool01oo_inOooooooooo
oooooooog]kNolkFg_o_inL0oooooom1ooooo`03onk^k_oShn?o^KVi00;o
k^k^0003ooooo`03okVi^OoShn?ooooo02gooooo00?og]kNomk>a_ooool0
4Oooool00oo_moOoooooooooo`02ooooo`03ooO_iooooooooooo00;ooooo
00Coinogooooooooooooinog1Oooool01Oo_inOoooooonoWioo>c/kokoOg
0?oooooo@_ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWo
hn?Sooooo`0/ooooo`03ooOgkooWg]koc]KN00kooooo00?okoOgoooooooo
ool01?ooool00oogmnooooooooooo`0:ooooo`03onogmoooooooinog00;o
oooo00?og]kNolkFc_o_inL0oooooom1ooooo`03onk^k_oShn?o^KVi00;o
k^k^0003onKViP03okVi^OoShn?ooooo02gooooo00?og]kNolk>c_ooool0
0oooool02_o_inOoc/k>onoWioo_moOoooooonO_moooooooknOWolk>c_o_
inL2ooooo`03onogmooooooog]kN00Gog]kN00Koe/kFohAkLonLJf?o[G]S
oljmYOnDS8`2ojekH`0:okfm_Oo>a[Gog]k>olk6]Onm_JgoinogoooooooN
g]koc/k>onogmooooooo@Oooool00ooVi^Kohn?SokVi^@02onKViP000oo^
k^h00oni^KWohn?Sooooo`0]ooooo`04omKFiooNg/koooooonoWi`;o_Kfm
00Goc/k>oibLW?n]]KGoc/k>onogm`02ojf]Y@;oW9bL01goS8b<okfm_On]
[JGoknOWoooooooWimkoknOWooOgkoo_inOomnoWonOWg_oNc/KoDTY2og/@
2?n4613o[G]SoiA2<Omc613oW34QoljUQ?oNg/koknO>omkNc_o>a[GoknOW
oooooooNg]koc]KNonoWi`3ooooood7ooooo00?ok^k^on?Shoni^KT00_o^
k^h000?ooooo00?o^KVion?Shoooool0;?ooool00oogmnooinONolkFgP02
ooooo`03omK>e_oNg]koknOW00;og]kN00OoknOWoooooooFe^OoknOWolkF
c_oNg]ko_Kfm00;og]kN0_ooool06?o>c/koQ9BDoibLYOnLW9coNhB4of]c
LomJJf_oBQPHog<H4?nL<B7oQ3Taof<H6?n48ASoYG=JojekHonLW:GoW8Ak
oiB<Hon]]KGomoO_ooooooo_inOoc/k>onogmooooooo@_ooool00ooShn?o
^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0]ooooo`03omKF
iooFc]Kooooo00Oooooo00?okoOgooooooooool00_ooool00ooWkoOooooo
ooooo`02ooooo`0>omk>a_n<S8coS8b<of][Jon<S8co[JFDof][JomB20So
Jc4Yoi`a8On]Nf?oQ1P@oh@Q6?m[<BT2odYBFP08oeYJF_mBBT;oJg=conoW
iooooooog]kNolkFg_o_inOooooood7ooooo00?ok^k^on?Shoni^KT00_o^
k^h000?oi^KV00?o^KVion?Shoooool0;Oooool01OoNg]koc]K>ooooooog
knOo[KFe00;o_Kfm00Oo]Kg>okfm[Oo_inOoc/k>ojf]YOo_inOo[KFe00;o
_Kfm01?og]kNokFmc_o>a[GoooooolkFg_nm_Kgo[JfUoibDS?n]YICoc/Je
og]cHolH413oDPP8ojekHon<Jd[oQ24Hog/a:OmB>C7o:BTY00?o>CTa00Ko
FUY2onoWioooooooinONolk>c_o_moOooooood7ooooo00?oi^KVon?Shoni
^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0;?ooool0;Oo_moOoinON
olk>c_ooooookoOgokfm_On][JGoc/kNolk6]Oo>c/koknOWolk>c_nm_Kgo
knOWojf]YOnm_Kgoc/k>omkNg_o>c/ko[KFeoooooooNg/ko_Kf]ojf]YOnL
W9co[Ib4oljmYOmcJf?o8AP@oe9:@_mS@SWoBS4Yoe8i<OmB>BWoNg]kog^4
Q?mJFU[oBU8iodY:<Om:DSWoknOWoooooooFe^Ooc]K>onoWi`3ooooood7o
oooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0
;Oooool02?oNg]koc]KNooooooooooookoOgooooooo_inOoinog1Oooool0
0oo_moOoooooooooo`02ooooo`09onoWioooooooc/kNokfm[Onm_KgoU8b<
og=cF_n]W8CoLf]S00;oDSTa00oo@RTQoe8i<OmJ@SWoDSTaohb<Lon<S8co
Ng]kof]SD_m[Jd[oFV=JonoWioooooooinONolk>g_ogmnl0oooooom2oooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo02co
oooo0_o_inL00ooFc]KoooooonoWi`02olk>cP09oibLYOn]YICo]Kg>olk6
]OoNg]koc]KNolk>c_oNg]koc]KN00;oc/k>00coa[fmolkFg_ooooooc/Je
ohb<S?n<S7?oFUY2ohb<S?o>a[GoLf]Soe9:@_la6102oe8i<@04og=JD_mB
>C7oFUY2og]cH`;oJf]:00OoFUY2of][B_o_inOokoOgonoWioo>e/koknOW
0?oooooo@Oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWo
hn?Sooooo`0]ooooo`06omkNg_o>e/kooooooooooon][JGo[KFe1?nm_Kd0
1_oNg]ko_Kfmolk6]Oo>e]koc/Jeojfe]@;o_Kfm017o[JfUoooooon]]KGo
BTY:oe9:@_m[He;oS8acoib4NomJFU[oDSTYod8Y8Om[BT;oFUY2og=JD_mS
FT[o:BTHocTi6002oeYB:@06ocTi6?mkHd[oknOWoooooooNg]koc/k>oooo
oom2ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?o
oooo02cooooo00KokoOgonOWg_o>c/koooooonogmoo_inL9ooooo`0NonoW
iooWimkoooooonogmoo_inOoooooojf]YOlY<BWo:BTHodY::On]YICoa[fm
ocTi<Om2:B7oDSTaoe9:@_mkFT[oJf=BoeY2>OlY:ASoBS4YodY::OmcLe[o
BS4Yoe9S@_oFe^OoooooonOWg_o>e]koknOWoooooom1ooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo02gooooo00[og]kN
olkFg_ooooooknOWolkFg_oNg]koc/k>omkNg_o>c/koknOW0_o>e]h08?o_
inOog]kNolkFg_o>c/koe/kFonoWioo>e]kokoOgojfUU?l0003o:BTHocTQ
6?nLU8coc/J]og]cHolY:ASo@RTQojekHonDJe[oJc4YocTi6?lY:ASo<CTQ
odY::Om:BS7o>CTHodY:<Oo_inOokoOgonoWioo>c/kokoOgoooooom2oooo
o`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo02co
oooo02gokoOgonoWioo>c/koooooomkNg_nm_Kgo[JfUojfe]On][JGoW9bL
okG6e_n][JGo_Kf]olkFg_o>c/koW9bUojf]YOnm_Kgoc]K>okfm_Oo_inOo
[JfUoa000?lY:ASo<CTQokfm[OoNc[goS8acobTY6?mcFU;o[G]SolJ]W?n4
Ng?o<CTQoaP@4?li>ASoBU8iodYJ@_lY:BWo>D8aonoWioooooooe]KWolkF
c_o_inL0oooooom1ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03
okVi^OoShn?ooooo02cooooo0_o_inL00oo>e/koooooooooo`03onogm`04
ooOgkoo>e]koinONonoWi`KokoOg0oooool06?n][JGo:BTHobTY6?lY:ASo
S8acoljmYOm:FT;o:BTHocTQ6?mkHd[oS6]:oeYJ@_li@S7o:C4YobTQ2?m:
DSWoQ9BDog^4Q?mJHe[oknOWonogmooWimkoc/kNooOgkooooooo@Oooool0
0ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0]oooo
o`03omkNg_o>c]kooooo00CoknOW00Coe]KWonoWiooWimkoe]KW1_o_inL0
1OoFe^OomnoWoooooon][JGo<CTQ00;oBUY200WoU8aSokfm[On]]KGoJg=c
oa0@2?li8ASo<AP@oaP@4?mJJf/00_mJHeX02OmSLhco[KFeoibeg_nU]Lko
knOWonogmooNg]koc]K>onoWi`3ooooood7ooooo00?ok^k^on?Shoni^KT0
0_o^k^h000?ooooo00?o^KVion?Shoooool0;Oooool01_oNg]kog]k>oooo
ooo>e]ko_KfmokF][@;o[JfU01GoS8b<okFmc_nm_JgoW9bUojf]YOn]]KGo
_Kfmojf]YOn]]KGo[JfUonO_moooooooc/k>of=cS?mkQ8CoJf=Bog]kNonm
_Jgo[JFDohb<S?lY:BT00_l000003Om:DU[oW;GNojFec_nL]MkoYKgNoibe
ionea]KoW;GNonoWioogmnoog]kNolk>c_o_moL0oooooom2ooooo`03on?S
honi^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo02gooooo00Go
g]kNolkFg_ooooooknOWomkNgP02onogm`03onoWioo>c/kokoOg00;oknOW
00?oc/k>onoWioo>e]h00_o_inL01?oWkoOomnoWooOgkooFe^L2oib]_@06
oibLYOn][JGo_KfmokFmc_nea]KoYKG>0_mSLh`6oibegP07oibeionU]Lko
knOWoooooooNg]koc]KNonoWi`0@ooooo`03oogmoOn][Jgod=3@0?oooooo
;_ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Soooo
o`0/ooooo`;oknOW00Goc]K>ooooooo_inOoknOWonogm`02onoWi`03ojfe
]Oo_inOokoOg00GoknOW00GoinogooO_iooWkoOoooooolkFgP02ojfmi`03
ojg6monL[Kgoc/J]00?oW;GW00Go[LK_oibeionL]MkoW;GNoibei`05oibe
gP05olkFg_o_moOog]kNolk>c_o_moL03Oooool01_o^k^kodm?CoiVIVOl_
;booC4a<ok:b/P;ooooo00?ol_;booooooooool01oooool00oomoOgoj^[Z
ooooo`0Mooooo`03ookno_oYjNWoo_kn0?kooooo00?oi^KVon?Shoni^KT0
0_oVi^H000?ok^k^00?o^KVion?Shoooool0;Oooool02?oWimkoc/kNoooo
ooo>e]koW9bLolk6]One_Lko[KFe0_n][JD00onLW:Go[JfUoibLW002olk>
cP0@ojfe]On][JGoS8b<olk>c_oooooo]LKFoib]g_nL]MkoW:gNoib]_On]
[JGoW:gNoib]c_nL]MkoW:gNoib]cP;oW:gN00KoW:g>oib]g_nL[MkoW:g>
oib]g_nL[Lh2onoWi`03omkNg_o>e/koknOW00_ooooo00Koj>SXodI6A_l_
;booBTY:oa4A4OnRXZ83ooooo`05oh20P?lI6AWo:RXZohF5QOll?3`00_oo
ool04ol>3Pkoh^;Roooooon^[Zko410@ob`/;?lS8b?oj>SXooooool>3Pko
h^;RoooooomWIfOoA4A4ooWinOooooooj^[Zo`000?odm?@00oooool02?l>
3Pkoh^;Rooooool>3Pkoh^;RoooooonRXZ;oCDe=0_ooool02?lf=SKo^KVi
oooooona/K7o5aLGocTi>Old=3Co^KVioOooool00oo^k^kohn?SokVi^@02
onk^kP000oooool00oni^KWohn?Sooooo`0/ooooo`08onogmooNg]kog]k>
ooooooo_inOoc]KNonoWioogmnl3onoWi`05olkFg_o_inOoinONomKFioo_
inL00ooNg]h01Oo_inOokoOgonoWioo>e]kog]kN00;oc]KN00Cog/k6omKF
iooNg]koe]KW0_o>e]h00ooNg]koc]KNolkFgP04olkFgP05okG6e_o_inOo
moO_olkFg_o>c/h03?ooool01om1@D7oLG5aooooooooooooi>CToadM7Onc
/k<00_ooool00olA4A7of=SHoo?cl`02oc`l?0;ooooo00Ko3Ph>on;Rh_on
o_ko7AdMojVYZOooool2oogmo@06ooooool>3Pkoh^;RogalO?le=CGolo?c
0_ooool00ooZj^[o0000ooCdm003ooooo`08o`h>3_oRh^;oooooo`h>3_oR
h^;ooooooj:RX_m=CDd2ooooo`05ocHf=_ni^KWoi^KVo`/;2oo7alL0oooo
ool2ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoShn?o
oooo02gooooo0_oNg]h03_ooooooknOWooooooooooooe]KWolk>c_o_inOo
moO_ooooooogmnooinogonoWionm_Kgog]kN0_ooool02_oWkoOoknOWonog
moooooooknOWooooooogknOoooooonO_moo_moL2onoWi`04ooooooo_inOo
inogooOgk`;oknOW00?og]kNonoWioo_moL00_o_inL00ooNg]koc]K>onoW
i`0:ooooo`03ol_;bol0003oemOG00?ooooo00WoI6AToe=CDoooooooo_kn
o`000?obl_;ooooookBd]?ll?3`00_ooool01Ol>3Pkoh^;Rol71`OlF5QKo
oOgm00Cooooo00Co3Ph>og=cLolW9bOojn_[0oooool00ooZj^[o0000ooCd
m003ooooo`08o`h>3_oRh^;oooooo`h>3_oRh^;ooooooj:RX_m=CDd2oooo
o`04ocHf=_ni^KWoZj^[ob4Q8@?o_kno00?ojNWYooooooooool0noooool0
0oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0/oooo
o`;oknOW013oc]KNooooooo_moOo[JfUokfm_Oo>c/koS8b<ojf]YOne_Lko
knOWoibLW?n][JGoS8b<ohBDU?nDS8co[KFe0_n][JD02Oo>c/koknOWonO_
mooNg]koW9bUolk>c_n]]KGo[JfUoibLW002olk>cP08oibLW?oNg]ko[JFD
olk>g_n][JGoW9bUohBDU?o>e/h2onoWi`04onogmoo>c]koc/k>onogm`[o
oooo00?oXJ6QoadM7Oooool00oooool02OnYZJWo6a/Kooooooono_ko0000
oo;bl_oooooo];Bdoc`l?002ooooo`05o`h>3_oRh^;obLW9o`h>3_ojn_X0
1?ooool01?l>3PkoKfm_od];BoomoOd3ooooo`03on[Zj_l0003om?Cd00?o
oooo00So3Ph>on;Rh_oooooo3Ph>on7QhOooooooXZ:Roda<C0;ooooo00Co
=SHfokVi^Oo7alOo5aLG0_mdM7@00olK6a_o`L71ooooo`3looooo`03onKV
i_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo02gooooo00Go
g]kNolkFc_ooooooknOWolk>cP03omkNgP0:olkFg_o_inOoknOWomkNg_o>
e]koc/k>omK>e_n]]KGog]k>olkFgP;oc/k>00OoooooonoWion]]KGoS8b<
okfm_On][JGog]kN00;oc/k>00Wog]kNolk>c_oNg]koc/k>omkNg_oFc]Ko
c]K>olk>c_oFe^L00oo_inL00ooNg/koc]KNonoWi`0:ooooo`03oj:RX_lJ
6Q[ooooo00?ooooo00WoYjNWoaHF5_ooooooo_kno`000?obl_;ooooookBd
]?ll?3`00_ooool03Ol>3Pkoh^;RoooooolR8R;oSXj>oo_knoohn?Soo_kn
ooooool>3Pkoh^;Rofa/K?m]KFd00oooool00ooZj^[o0000ooCdm003oooo
o`0Bo`h>3_oRh^;oooooo`h>3_mHF5Sokno_ogemOOlC4a?oYJFUooGemOlJ
6Q[odM7Aookno_lR8R;oh>3Pono_kolM7Agon_[joOooool00oo^k^kohn?S
okVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0]ooooo`04onOWg_o>
e]koooooonogm`?ooooo00GoknOWoooooooWkoOoooooooO_i`03ooooo`08
onoWioo_moOoknOWooooooo_inOoooooomkNg_o>c/h2omkNgP0:onoWiooo
ooooinogooooooo_inOoinogooO_iooWkoOoknOWonO_m`CoknOW00Goe]KW
onoWioo>e]kog/k6onogm`0:ooooo`03olk>c_l0003oe=CD00?ooooo00Wo
HF5Qod51@Oooooooo_knobXZ:_odm?Cooooool71`OmMGEd00_ooool01Olg
=cOoinOWooooooo@d=3oJVYZ00;o;2`/00OomoOgooooool>3Pkoh^;Roogm
oOmMGEgo/[:b00;ooooo00?oj^[Zo`000?odm?@00oooool02olg=cOoinOW
oooooolg=cOo/[:bocTi>OlZ:R[obl_;og]kNolQ8B7oHF5Q00;ooooo00Co
^k^koc4a<Olo?coo[jn_ooooool00ooShn?o^KViooooo`01ooooo`000oo^
k^h00oni^KWohn?Sooooo`0]ooooo`05omKFioo>c/koooooonoWion][JD0
0_n]]KD02Onm_Kgo[KFeomkNg_nm_Kgo[KFeonOWg_n][JGo]Kg>ojf]Y@02
olk>cP07okF][Onm_Kgo[KFeoibLW?n<S8co_Kf]olk>gP02ojfe]@;o[JfU
00Koc/kNokfm_On][JGo_Kfmolk>c_n][JD2ojfe]@;o[JfU00Goc/k>onoW
ioo>e/koc/k>onO_m`0;ooooo`07odM7AomXJ6Soo_knoooooooNg]ko5QHF
okZj^P09ooooo`03onGUiOolo?cooooo00Kooooo00?o3Ph>on;Rh_ooool0
1?ooool00ooZj^[o0000ooCdm003ooooo`03onGUiOolo?cooooo0?oooooo
3Oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Soooo
o`0/ooooo`08ooOgkooWimkog]kNooooooo_inOo[KFeojf]YOo>c/h2okfm
_@04omkNg_o>c/ko[JfUomKFi`;o[JfU00Koc/k>omkNg_nm_KgoW9bLolk>
c_o6_Kd2okfm_@0:olk>c_oNg]ko[JFDojfe]Oo>c/ko_Kfmolk>c_n][JGo
]Kg>olk>cP;o_Kfm00Ko[JfUolk>c_nm_Kgo[JfUokfm_Oo_inL2olk>cP03
ooOgkooooooooooo00Wooooo00KokNg]oeEEEOlW9bOo?Shnob8R8_nTY:@:
ooooo`03oa/K6ooShn?ooooo00Kooooo00?o3Ph>on;Rh_ooool00_ooool0
2_ll?3co:2PXobDU9Ol<30co9RHVobPX:?m5ADGooooooa/K6ooShn?ooooo
o`kooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shooo
ool0;Oooool01?oFe^Ooc]K>ooooooo_moL3onoWi`06omkNg_oooooooooo
onoWioooooookoOg0_o_inL01_oooooomoO_ooOgkooFe^OomnoWonO_m`;o
moO_00?oinogonogmoo_inL00_o_inL01_oWkoOoknOWomkNg_oWkoOoknOW
olkFgP?oknOW00Ooe]KWomkNg_oNg]koinONolk>c_o>e]koknOW00gooooo
00?onOWionSXj?ooool05?ooool00on<S8colO7aooooo`3ooooooa[ooooo
00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool0;?oo
ool01oogmnooinONomK>e_ooooooknOWolk>c_n]]KD00_nLW9`02_n][JGo
_KfmomkNg_o>c/ko_Kfmomk>a_o>e]ko_KfmokFmc_nm_Kd2olk>cP0?okfm
_One_Lkoc/k>olk6]Oo>e]ko_Kfmojfe]Oo>c]kog]k>okfm_On]]KGo_Kfm
ojfe]Onm_Kgoc/k>00;o_Kfm00Coc/k>ojf]YOnm_Kgoc/kN0_o>c/kooooo
od?ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shooo
ool0;Oooool01ooFe^Ooc]K>ooooooo_inOoW9bLokfm_On][JD00_nm_Kd0
1On]]KGoc/k>okfm_Onm_Kgoc]KN00;o[KFe00Ko[JfUojfe]On][JGo[KFe
okfm_On][JD2okfm_@08omkNg_nL[Kgo[JfUolk6]Oo>e]koQ9BDojf]YOn]
]KD2ojf]Y@0:olk>c_nm_KgoW9bLokfm_On<S8coW9bLomkNg_o>c/kog/k6
onO_mooooooo@Oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni
^KWohn?Sooooo`0/ooooo`06ooOgkooWimkoc/kNooOgkoo_inOog]kN0_oW
koL01_o_inOokoOgonoWiooWkoOoknOWonogm`;oknOW00Coc/kNonoWioog
mnooc]KN0_oNg]h;onoWi`06omkNg_o_inOog]kNomkNg_o>c/koe/kF0_o>
c/h01?o>e]koc/k>olk>c_ogknOooooood7ooooo00?oi^KVon?Shoni^KT0
0_oVi^H000?ok^k^00?o^KVion?Shoooool0;Oooool01?oFe^Ooc/k>oooo
oooFe^L5olk>cP04omkNg_o>c/koc/k>onONgPCoc/k>00coc/kNolk>c_o>
c/koQ9BDokfm_Oo>c/koc]KNolk>c_nm_Kgoc/k>okfm_Oo>c]h2olk>cP07
okfm_Oo>c/ko_Kfmolk>c_nm_Kgo]Jf]ojfe]@02okfm_@04omk>a_nm_Kgo
c/k>onogmooooooo@Oooool00oo^k^kohn?SokVi^@02onk^kP000oooool0
0oni^KWohn?Sooooo`0]ooooo`04omkNg_o>c/koooooolkFgP?o[JfU00go
W9bUohb<S?o>c/koW9bLojf]YOnea]Ko_KfmohBDU?n]YICo[JfUolk>c_n]
]KGoc/k>00;o[JfU00CoW9bLokfm_Oo>c/ko[JfU0_n<S8`04?o6_KgoW9bL
ohb<S?nLW9coW9bUohb<S?nm_KgoS8b<oibLW?nDS8coW9bLohb<S?ne_Lko
_KfmomkNc_o_inOooooood;ooooo00?ohn?SokVi^Oooool00Oooool000?o
k^k^00?o^KVion?Shoooool0;?ooool01?o_moOoknOWolk>c_o_moL3onoW
i`05omkNg_o_inOoc/k>olkFc_oNg]h01Oo_inL00ooWimkoknOWonoWi`02
onoWi`06omKFiooNg]koc]K>onoWiooWimkoe]KW0oo>c/h02?nm_Jgoc/kN
olk>c_oNc/Ko]Kg>okfm_Oo>c/ko]Kg>0onm_Kd00onm_Jgoc]KNooooo`3o
oooood7ooooo00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?S
hoooool0;?ooool01?ogknOoe]KWomkNc_ooool4omkNgP07olk>c_oNg]ko
c/kNomkNg_oNg/kog]kNolkFgP02omkNgP03olk>g_oNg]kog]kN00;og]kN
00[oc/k>onoWioo>c]kog]k>okFmc_oNc/Ko[JfUoibLYOne_Lko]Jf]0_n]
[JD00on]]KGo[JfUojf]Y@02ojf]Y@06oibLYOn][JGo[KFeokfm_Oo_inOo
koOgoooooom1ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi
^OoShn?ooooo02gooooo00CoknOWolk>c_o_moOoc/k>0_n][JD00onLW:Go
W9bLohb<S002ojf]Y@0=ohBDU?nLW:Go[JfUojf]YOnLW:Go[JfUoibLYOo>
a[GoW9bUohb<S?nLW9coc/k>ohb<S003oibLW004ojf]YOn<S8coNg]kog]k
N`;oJf][00[oW9bLof][Jom[Jf_oNg]kohb<S?mJFU[oW9bLojf]YOo>c]ko
knOWoooooom2ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo02cooooo00KoinogonOWg_o>c/koooooolk>c_o>e]h3omkN
gP0:okfm_OoNg]kog]kNomkNg_nm_Kgog]kNolk>c_o>e/kog]kNonOWgP;o
c/k>00?o_Kfmolk>c_oNg]h00_oNg]h03?o>c/koc]KNolk>c_nm_Kgo[JfU
oibLW?n<S8coNg]kohb<S?mkNg_oNhB4og]kN`;oS8b<00?oW9bLokfm_Oo_
inL0oooooom4ooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi
^OoShn?ooooo02gooooo00CoinONolk>c_o_moOoknOW1?oNg]h2okfm_@08
onOWg_oNg]kog]kNomkNg_oWimkoe]KWomkNg_oFe^L6omkNgP08olk>g_oN
g]kog/k6olk>c_nm_KgoW9bLohb<S?m[Lg<4of][J`05og]kNomkQ8CoW9bL
okfm_OoNg]h0oooooom4ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKV
iP03okVi^OoShn?ooooo02cooooo00[omoO_omKFioo>e/koinogonoWion<
S8co[JfUolk>c_n4U9Co]Jf]1OnLW9`01Oo>c/ko[JFDojf]YOn<S8coW9bU
00;o[JfU00?oW9bLojf]YOn<S8`00_nLW9`00omkQ8Co_Kfmog]kN`03of][
J`03ohb<S?mkNg_oS8b<00;o[JfU0_o>c/h00ooNg]koooooooooo`3ooooo
od?ooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shooo
ool0;Oooool01ooNg]koc/k>onogmoo_inOoc/k>olkFc_oWimh00_oNg]h0
2Oo>e]koc/k>olk>c_o>e]koc/k>omkNg_o>c/koc/kNomkNcP03olk>cP03
ojfe]Oo>c/koc/k>00;oc/k>00Goa[fmokFmc_n][JGoS8b<okfm_@04oooo
o`04onoWiooNg]koc/k>omkNg_ooooooA_ooool00oo^k^kohn?SokVi^@02
onk^kP000oooool00oni^KWohn?Sooooo`0]ooooo`07omkNg_o>c/koknOW
onoWiooNg]koe]KWonoWi`02omkNgP0:onONg_o_inOoknOWonoWiooNg]ko
c/kNonOWg_oNg]koe]KWonoWi`Kog]kN0oo>c/h00on]]KGoU8b<olk>cP03
ooooo`;og]kN00?oc/k>omkNg_ooool0oooooom7ooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo02cooooo01SoinogonOW
g_o>c/kokoOgolk6]Oo>S6?og/jmonoWiooN_JgoaW]:olk6[Oo>e]ko[JfU
ohBDU?n]]KGoW9bLolk>c_n]]KGo[JFDohBDU?n]]KGoW9B<olk>c_nLW:D4
oibLW00:ojf]YOmkQ8CoJf][okfm_OooooookoOgonOWg_oNg]koc/k>omkN
g_ooooooB?ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWo
hn?Sooooo`0]ooooo`0HolkFg_o>c/kokoOgonoWioo6[Icog]k>onoWioo6
[IcocXaSonoWiooFe^Oo_Kf]olk>c_n]]KGoc/k>omkNg_o>a[Go]Kg>olJm
_Oo>a[Go]Kg>olk6]On][JGo[KFe0_nm_Kd02_nLW9co[JfUohb<S?mkQ8Co
c/k>ooooooo_inOoc]KNolk>c_oNg]koooooodWooooo00?oi^KVon?Shoni
^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0;?ooool03Oo_moOoknOW
olk>c_o_inOoinONolkFc_o>YHCoc/JeolIkB_o>_JGoknOWonOWg_o>e]h0
0_o_inL00ooWimkog]kNomkNgP04omkNgP03olk>g_o>c/kog]kN00;og]kN
00Woa[fmokFmc_n][JGoS8b<olk>g_o_inOog]kNolk>c_oNg]h0oooooom:
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo
02gooooo00Wog]kNolk>c_ogmnooe]KWonoWiooF]Icoc/JeolIkB_o>e]h0
0_o_inL00ooWimkoe]KWonOWgP05omkNgP04olk>g_oNg]kog]k>omkNgPCo
c/k>0_n][JD01On<S8cog/k6omkNg_o>c/kog]kN0?ooooooC?ooool00ooS
hn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0/ooooo`03
onO_mooWimkoc/k>00?oknOW00?oc/Jeolj<Hoo>W7/00_o_inL00ooWimko
g]kNomkNgP03omkNgP08olkFg_oNg]kog]kNomkNg_oNg/koe/kFolk>c_oN
g]h2olk>cP;o_Kfm0_nLW9`00oo>e]koc/k>omkNgP3oooooodcooooo00?o
k^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0;Oooool0
3?oNg]koc/k>onoWioo_inOoc]KNonOWg_neLe[oc/J]onoWiooWimkoe]KW
onOWgPGog]kN00Kog]k>olk>g_oNg/koc/kNomkNc_o>c]h3olk>cP06okfm
_On]]KGoW9bLokfm_Oo>c/kog]kNoooooom=ooooo`03onKVi_oShn?o^KVi
00;oi^KV0003onk^kP03okVi^OoShn?ooooo02cooooo00GokoOgonoWioo>
c/komoO_olkFgP02onoWi`04olk6]OoWimkoinONomKFi`Gog]kN00Ooc/kN
omkNg_o>e]kog]k>olk>g_oNg/koc]KN00?oc/k>00Ko_Kfmojfe]On][JGo
[KFeolk6]OoNg]koooooodkooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
oooo00?o^KVion?Shoooool0;Oooool02oo_inOoc]KNonoWiooWimkoc]KN
onoWiooWimkoe]KWonOWg_oNg]koinON00?og]kN00Oog]k>omkNg_oNg/ko
e/kFomkNg_o>c/koc]KN00;oc/k>00Ooc/JeokFmc_nm_Kgo_Kf]ojf]YOn]
]KGoe]KW0?ooooooD?ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h0
0oni^KWohn?Sooooo`0]ooooo`0@onogmoo_inOomoO_omKFioo_inOoinON
omKFiooWimkoc]KNonOWg_o>e]kog]kNolkFg_oNg]koc]KNomkNgP;oc]KN
00?oc]K>olkFg_o>c/h00oo>c/h01Onm_Kgo[KFeojfe]Oo>c/koknOW0?oo
ooooD?ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?S
ooooo`0^ooooo`koknOW00Sog]kNonoWioo_inOoknOWomkNg_o_inOog]kN
onoWi`;og]kN0_o_inOooooooe;ooooo00?oi^KVon?Shoni^KT00_oVi^H0
00?ok^k^00?o^KVion?Shoooool0oooooonJooooo`03onk^k_oShn?o^KVi
00;ok^k^0003ooooo`03okVi^OoShn?ooooo0?ooooooVoooool00ooShn?o
^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`3ooooooi[ooooo
00?ok^k^on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0oooo
oonJooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?o
oooo05Gooooo<_o2`/;ooooooa?ooooo00?ok^k^on?Shoni^KT00_o^k^h0
00?ooooo00?o^KVion?Shoooool0EOoooolbol;2`_oooooo5?ooool00ooS
hn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0Fooooo`07
ono_kon][JgoFV]SoibLW?oWa/KoinOWooOgm`04ooooo`03onooooogmoOo
oooo037ooooo<_o2`/;ooooooa?ooooo00?ok^k^on?Shoni^KT00_o^k^h0
00?oi^KV00?o^KVion?Shoooool05Oooool02ooNg^OoU8b<oa0H4?m:BT[o
:B4QojecNomkNg_oU8b<ojf][OoF_LKokno_03Gooooo<_o2`/;ooooooa?o
oooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0
5?ooool04OoWknoo_KfmobTa:Onma[goooooocTH8Oo>Q8cocW=kolI[Lon]
Jf_oW6=[oha[LonLS8co_KFeomKFe_o_knoomoOg033ooooo<_o2`/;ooooo
oa?ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shooo
ool04oooool01?ogmoOoe/kFoibDW?la>CT2ooooo`0?og]BF_o>NhCoog^D
onmcS?oWNhCocW=koke[LonUHf_oYF=SoiA[Lon4Q8CoW9bLokfm_OoNg]ko
mno_02gooooo<_o2`/;ooooooaCooooo00?ohn?SokVi^Oooool00Oooool0
00?ok^k^00?o^KVion?Shoooool04oooool01?oWinOoa/k>ohbDS?mJFUX2
ooooo`04og=JHoo>NiCoohb]oon<Y@;oohBL0_ogNh`02oo_Hg_oieYcolI[
Lon]Jf_oYF=SoiA[LonDQ8CoYJfUolK>c_oNknoomoOg00;ooooo00?okooo
ooooooooool01?ooool00oo_ooooooooooooo`0Moooooc;o`/;2oooooolC
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo
01?ooooo00ComnOWomKFg_nU[JGoJg=[0_ooool05om[Lf_ogXb]oonUc_oo
YLkomiBmoonD]OogU:goohbUonn<W?ooQ9cokhBDomikS?oFLhCocW=koke[
Lon]Jf_oYF=SojE[JonLQ8co]IbLolk6c_oWinOooooo00?okooo2oooool0
0oo_oooomoOgooooo`0Doooooc;o`/;2oooooolCooooo`03onKVi_oShn?o
^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo01?ooooo00_omno_onO_
kon][JgoJf=SonONiooFg]koHdYBolIcU?ooU;GooibmoonUaP02oonUcP0D
oonUa_ogU;gokiBmoon<[OooS:Gomg^DooN4U?ogNhcoig^4onmSNooWJg_o
]G=cojE[LonLHf_oU6]coib<S?nm]KGoc]kFonOgmoogmoL7ooooo`03ooOg
mooooooooooo01Oooooo<_o2`/;ooooooa?ooooo00?ok^k^on?Shoni^KT0
0_o^k^h000?ooooo00?o^KVion?Shoooool05Oooool03Onm_KgoJg=[onON
ioo>e]KoJeYJolIcU?ogJhComg><ooMcU?ogQ:GooiBeoonL_OooYLH00_oo
YLh05oooW;gooiBeoon<[OooS:goohBLooMkU?ogLiCokhBDonMkQ?oFLg_o
cV=colIcLonULg?oW6]coiacNon]YJGo_KfmonONg_ogmoOokoooooooooog
moOokooo00Oooooo00?omoOgooooooooool04?oooolbol;2`_oooooo5?oo
ool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`0E
ooooo`08olK6a_n4Q8ComoOgonO_kon<Ng_ogXb]oonD]OooS:d2ooMcU004
onmcS?ogLiCoohBLoon<Y@;oojG60_oo]MH05?ooYLkoojG6ooND_Oo_S;Go
mg^Doon4W?ogLhcomg^<ooMkU?o_JhCoeW=koliSLoneLg?oYF]cojEcLonU
Ng_o]IbLokfm_OoWinOokooo6_oooolbol;2`_oooooo4oooool00oo^k^ko
hn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?Sooooo`0Eooooo`06olkF
c_n4Q8CoknO_onOWionDQ8CogXb]0_ooW;d01?ooU;Goohb]oon<YOogQ:D2
ooMkU006omikU?ooQ9cooiB]oonD]OooYLKoojG>0_oo]MH01OooYLkoojG6
oonD]OooS:Gomg^D00?omg>D00gomg^<onMkQ?oFLg_oaV]cokEcLon]Jf_o
YG=cojEkNone[Jgoe/k>onOWioogmoOooooo00?okooo4_oooolbol;2`_oo
oooo4oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?S
ooooo`0Eooooo`06okg6a_mkNg_oe/kFolk>c_m[Lf_ocW^D0oooS:d00ooo
U;GooibmoonL_@02ooNL_@;oohb]00WomiB]ooN4YOogQ:GomiB]oon<[Ooo
U;GoojG6oonee_ooYLh00_ooYLH02OooW;gomiB]ooN4YOooQ9coog^DooMk
U?ogQ9Coig^<omikQ002oliSL`09ojEcNonLJg?oW7=kojf<U?nm]KGog/kF
ooO_koooooookooo017ooooo<_o2`/;ooooooa?ooooo00?ok^k^on?Shoni
^KT00_o^k^h000?ooooo00?o^KVion?Shoooool05Oooool01_o>e/koS8b<
onoWkooNinOoU7=kolikW0;oohb]0_ogQ:D02?ooS:gooiBeoonL_OooW;go
ojG6oonUc_ooYLKooibm0_ooU;D02OooS:GoohBLonmkYOogS:GooiBeooNL
_OooYLKoojg>oonUaP02oonL_@0Bonn<]OogQ:Gokg^Uoon4W?o_NjGomg^D
onn4U?oWNhcoeW=kolIcNoneJg_oYF]coiA[LonLNg_o[HbDolK6a_oFe]Ko
mno_3ooooolbol;2`_oooooo5?ooool00ooShn?o^KViooooo`01ooooo`00
0oo^k^h00oni^KWohn?Sooooo`0Eooooo`0:omK6c_n<S8cokoooono_konL
U9co]IbLoonUc_ooYLKooibmoonD]@?ooiB]017ooiBeonnUc_ogW;gomjg6
oonUc_oo[LkoojG>oonUa_ooW;gooiBeoon<[OooS:Gokg^UooMkU?ogQ:Go
ohb]oonD]@03oonL_@0DoonD]OooS:goohbUoon<YOogQ:Gomg^DooMcU?o_
Q9Cokg^<onMcS?oNJg_ocV=coliJJonUJf_oW6]coiacNoneW9coe[g6omkN
g_o_moL2onooo`;ooooo00Cokoooooooooooooookooo0ooooolbol;2`_oo
oooo4oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWohn?S
ooooo`0Cooooo`0;onooooooooooc/k>ohAkNooNinOoe]KFoib4S?nLS9Co
okGFoonUc_oo[Lh00_ooYLH01?oo[LKooibmoonL_OooU:d3oonD]@04oonU
a_og[LKoojg>oonUcP;oojG60_ooW;d02?ooU;Gokg^UonmkYOoWS9coig><
onn4U?ooS:Goohb]0_ooU;D2oon<[@;oohbU00KoohBLooMkU?ogQ9Comg^D
onn4U?o_Nh`2olikQ00:okE[NonUJg?oYF]coiAcNon]S9Co_JFUolk>c_oW
g]koooooonooo`;ooooo00Cokooooooooooooooooooo<_o2`/;ooooooa?o
oooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool0
5Oooool02_oFc/koQ7]komkWioo>c/koU8b<oiacNoo_YLkokjg6ooNL_Ooo
[LH2oon]cPCookGF00Coojg>oonUa_ooW;gooiBe0_ooW;d01Oog[LKoojG>
oonUc_oo[LKoojG600;ooibm00SooiBeoon<YOooQ9cogW^DonmcS?oWLhco
mg^Doon<Y@?oohb]0_ooS:D2oon4W008ooMkU?ogQ9Comg>Doon4W?oNNiCo
ig^<olikQ?nmJg<2okEcL`07oiAcNon]S9CoolkNonooooogmoOoooooonoo
o`03oooooc;o`/;2oooooolCooooo`03onk^k_oShn?o^KVi00;ok^k^0003
ooooo`03okVi^OoShn?ooooo01Gooooo00Ooe/k>ohb<S?o_moOoinOWojfU
YOnDLg_oojG600;omibm00GooiBeoonL_OooYLKoojg6oon]cP02ooNmgP?o
okGN00?ookGFoon]c_ooYLH00_ogW;d4oonD]@;ooibm0_ooU;D01?ooS:go
ohBLooMkU?ogLh`3onMSQ004onmcS?ogNiCoohBLoon<[@;oohbU0oooQ9`2
oomkU004oon4U?ogQ9Cokg^<onMkQ0;oaW^<00?okjFeooooooo_ool01Ooo
oolbol;2`_oooooo5?ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h0
0oni^KWohn?Sooooo`0Eooooo`09olk6c_n4Q8ComoOgonoWkonm]KGoU7=k
ooo>kooo_MKoojg>00;oojg600?omjfmooNL_Oog[LH00_oo[Lh03Ooo_Lko
okGNooo6ioooa^OomlKWooNmiooo]MKoojg>oonUa_ogW;gooiBeooND[Ooo
S:D00_ooS:d2oonD[@06oonD]OooS:goohbUoon4W?ooNiCokg><0_oWHh@0
1?oNFW_oif>4onmcS?ogNi@7oon4W0;oog^D00CokhbLomikS?oNNiCoknO_
1_oooolbol;2`_oooooo4oooool00oo^k^kohn?SokVi^@02onk^kP000ooV
i^H00oni^KWohn?Sooooo`0Cooooo`08onooooooooooe/k>ohAkNooNinOo
e]KFokfe]OmkHg<4oonegP04ooo6g_oo]MkookgFooNmeP;oojg>0_ogYLh0
1Ooo_MKookGNooneg_oo]MkoolKW00;ookGN0_oo]MH01Ooo[LkomibmooNU
]OogQ:GomhbU00;omhBU0oooS:D2oon4W00DoomkU?ogNiCokg><onMSQ?oW
Hg_ogUYkomiJLoo_JhCokg><ooMkU?ooQ9CoohBLoon<YOooQ9coohbUooMk
U?ogLiCoif^<onoNg_o_ool5oooooc;o`/;2oooooolCooooo`03onKVi_oS
hn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?ooooo01Gooooo00Koe/k>
ohAkNooNinOoc]KFokfe]OmcDUX2ooNmeP05ooNUc_oo]MKookGNooneg_oo
a^L00_ooc^l00oooa^OookGNoonmeP03oon]cP05oon]a_og_MKomkgFooNm
e_oo]MH00_oo]Mh2ooneeP08oonUa_ooW;gomiB]onn<W?o_Q9Comg>Donmc
S?o_Nh`2oon4U0?oog^D00Gomg><onmcS?o_JhCoieYcomiSL`02omiJL`03
onMSNoo_Lhcomg><00;oohbU0_ooJh`00ooNc]KomoOgooOgm`04oooooc;o
`/;2oooooolCooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi
^OoShn?ooooo01Gooooo00Woe/k>ohb<S?ooooookno_omJma_mkDU[oolKW
oonme_oo[Lh00_oo[LH01?og[LKookGFooneg_oo]Mh2ooo6i`03oooFkooo
c^ooolk_00;omlKW00CookGFoon]c_oo[LKomjg60_oo[LH2oon]cP;oojG6
00OooibmoonD]OooU;GoohbUoon4W?ogLiCoif]k00;okf^400?oig^4ooMk
S?ooNi@00oooNi@00oogJhComg><onmSN`03omiJL`05onmcS?ogLiCoog^D
oon4W?og_MH00_o_ool4oooooc;o`/;2oooooolDooooo`03on?Shoni^KWo
oooo007ooooo0003onk^kP03okVi^OoShn?ooooo01Cooooo00SomoOgomK>
c_n<NhComoOgooO_kooWinOoFV=Jooo>m`?oolKW00CoolKNoonee_og_Lko
okGF0_og_MH2oonegP0>ooo6ioooc^ooomK_ooo>moooc^ooolKWooneg_oo
_MKoojg>oonUa_ogW;gomjFeoonL_OogYKD3oonL_@07oonD]OooU:goohbU
oon4W?ogNiCokg^<onMSQ002onMSN`03onM[Noo_Hg_okg><00;omg><00Wo
kg><ooMcS?o_JhCokf^4ooMcS?ooNiComhBUooMkU?oo_MH01_oooolbol;2
`_oooooo4oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni^KWo
hn?Sooooo`0Eooooo`08olk>c_n4Ng_oimkNomk>e_oFa/ko@T92ooo>koog
_Mh2ooo6i`;oolk_00GoolKWooo>koooa^OoolKNooNmgP02ooNmeP;omkgN
0oooa^L02?ooc^ooolKWooo6g_ooa]Koojg>oon]a_og[Kgooibm0_ogU:d0
1?ogU:GomiB]oon<[OogU:d3oon<Y@09oon4W?ogNiCokg><onm[Q?oWHg_o
gUYcomiSLooWHg_okf^400?omg><0_ooQ9`01OogS:Gomg^Doonmc_oooooo
kooo00Cooooo<_o2`/;ooooooa?ooooo00?oi^KVon?Shoni^KT00_oVi^H0
00?ok^k^00?o^KVion?Shoooool05Oooool01ooFe]KoS8b<ooO_kooWg]ko
g]KFod8i>Oooa^L01?og_Mh01oooa^Ooolk_oooFkooog_OoolkgoooFkooo
c^l00_ooa^L2ooNmgP03ooNmioog_MkomkgN00CookGN00[ookgFoon]c_oo
[LKooibmooNU]OooS:gomhbUonn<W?o_Q9Comg^D1OooQ9`2oomkU00<ooMc
S?o_Lhcoif]komiSLoo>Hg?ogV=conM[Noo_LhcoohbUooN4YOogNiCookgF
1_oooolbol;2`_oooooo4oooool00oo^k^kohn?SokVi^@02onk^kP000ooo
ool00oni^KWohn?Sooooo`0Eooooo`0;olk>c_n<S8coooooooO_kooWg^Oo
BSU2ooo>moooa^OoolkNooNmg_og_MH00oog_Mh00oooa^OoomK_oooNm`02
oooNm`07oooFkoooc_OoomK_ooOFkooga^OomkgNonnmeP02ooNmeP;ookgF
00[ookGFoon]c_oo[Lkoojg>oon]a_ogYKGooiB]ooN<YOogQ9CokhBD0_o_
Lh`04_oWLhcokg^<ooMkU?ogQ9CoohBLooN4U?ogLiCokg><onm[Q?oWHhCo
gV]konm[Q?ooS:GomhbUooMkU?oo_MKoooooonooo`Cooooo<_o2`/;ooooo
oaCooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?Shooo
ool05Oooool01oo>c/koS8b<ooOgmoogknooinOWodY:B_oog_L00_ooc_L0
1Ooog_OoolKWooo>koooa^OoolkN00?omlKW00GoolKWoooFkoooc_Ooolkg
oooNm`03ooo>m`;oolKW00?omkgNonn]c_o_[Lh00_og[LH00oogW;gooibm
ooN]_@02oonL_@0>ooNU]OooU;GooiB]onn<W?o_Q9Coig^<onMSQ?oWNhCo
if>4onMkQ?o_LhcokhBDoon4W?ogQ9@2ooMkU005ooN4U?ooS:gomhbUoon<
YOoo_Lh01_oooolbol;2`_oooooo4oooool00oo^k^kohn?SokVi^@02onk^
kP000ooVi^H00oni^KWohn?Sooooo`0Cooooo`09onooooooooooc/k>og]k
Noo_knoog]kNomKFe_m2@T;omlKW00;oomK_00OoolkgoooFkoooe^ooomkg
ooo>mooog_Ooolkg00;oomK_0ooge^l04Oooe^ooomkgoooFkoooe^ooolkg
oooFkoooc^ooolKWooo6g_oo[Lkomjg6onnU_Oo_W;GomiB]ooNL[OogU:Go
ohbU00?ooiB]0_ooS:D01OooQ9comg^DonmkS?oWHhCoig^400;ogV]k00So
ig^4onMcS?ogNiCoohBLoon<YOo_NjGoohbUooNeaPKooooo3?o2`/801?ng
]kOo`/;2okjn__ni^KT2ol;2`P03ol30`?nb/[;o`/;200Co`/;200?o][Jf
ojNWYoo0`<001?o2`/800onl_;coYZJVol30`00?ol;2`_oooooo4oooool0
0ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`04oooo
o`03ooOgmonNWYkomoOg00kooooo00Ooc]KFohb<S?ooooooinOWomkFe_mJ
FU[omkg>00;oolKW00GomlKWooOFioooc^ooomK_ooo>m`08oooNm`;oolKW
00komlKWooOFioooa^OoomK_ooo6ioooc^ooolKWooneg_oo_Lkoojg6ooN]
_OooU;GomiBUonn<W0;oihbD00?okhbLoon4W?o_S9`00oo_S9`01OooQ9Co
mhBDonmkS?oWLhcoig^400;ogV]k00Goig><oon<YOogU:goohbUooN]_@06
ooooo`;o`/;201_o1PH6ol;2`_o2`/;oJVYZojNWYoo2`/;oCDe=ofUYJOnc
/k?o71`Lob4Q8Om4A4Co9RHVoeMGEoo2`/;oQ8B4o``<3?lQ8B7o6QXJok2`
/?o2`/;o/;2`ocHf=_lT92Co>3PhoaLG5ombLW800_o2`/801OmbLW;o2@T9
oc<c<olX:2SoI6AT00Co`/;200OoD51@of=SHoo2`/;o`/;2ojb/[?l92@Wo
Rh^;00?o`/;2oooooolCooooo`03onk^k_oShn?o^KVi00;ok^k^0003oooo
o`03okVi^OoShn?ooooo00Cooooo00?ofMWIogMgMooIfMT03_ooool01oo>
c/koS8b<ooooooogmoOoinOWog=SJoo__MH00_ooe^l01Oooa^OoomK_ooO6
iooga^OommK_00;oomK_1ooog_L00oooe^ooolKWooNmgP02ooNmeP05ooNm
g_og_MKookGFoonee_oo_MH00_oo[Lh02?oo[LKooibmooNU]OooU:goohbU
onn<W?oWS9Coig^<0_o_Q9@01?ooQ9comhBDonn<W?ooQ9`2ooN4U0;okg^<
00GomhBDoon<[OogU:goohb]onnU_@06ooooo`;o`/;201;o1PH6ol;2`_nE
UIGo0P82oe=CDoo2`/;oCDe=ofUYJOmjNW[o<S8bol;2`_nJVY[o0`<3okno
_oo1`L7o5QHFoh20P?o2`/82ol30`003ol;2`_l`<33oEEEE00;o`/;200[o
[Jf]oa<C4on7QhOo`/;2ok2`/?nk^k_o`/;2ok^k^olA4A7oZj^[0oo2`/80
1_nh^;So71`Loj2PX?o2`/;o>SXjodA4A0Co`/;2oooooolDooooo`03on?S
honi^KWooooo007ooooo0003onk^kP03okVi^OoShn?ooooo00?ooooo00Go
o?cloh^;RomcLg?oRh^;ooclo00=ooooo`07olk>c_n4Q8Cokno_onOWiooN
g]koS9B<okfL]@07oooNm`05ooOWkoooe^oommK_ooOFkoooe^l01ooog_L0
1oooc_OoolKWooNmg_og_MKomkg>ooNea_og[LH00_og[Kd00ooo[LKomjfm
ooN]_@02ooNU]@06ooNL[OogU:GomiBUonn4U?oWNhcogW^<0ooWNh`02Oo_
Q9ComhBDonn4U?o_S9cokiBLoonD[OooS:Gokib]oonD]@06ooooo`;o`/;2
017o1PH6ol;2`_m@D53oE5ADoadM7Onn_[koCDe=ofUYJOn[Zj_o5QHFofm_
Kon<S8co1PH6ol;2`_nBTY;o410@ol30`003ol;2`P03oiZJV_l0003oXj>S
00?o`/;200?oC4a<obh^;_o2`/800oo2`/800ond];Co2PX:oi>CT`04ol;2
`P05ohj>S_lW9bOoOGemo`d=3Onb/[801?o2`/;ooooooa?ooooo00?ok^k^
on?Shoni^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool00oooool01Oo5
aLGoLg=cog=cLomcLg?oaLG500gooooo00Ooe]KFohb<S?o_knoog]kNolK6
a_n<NhCoW9BL00?oomK_2ooog_L00oooe^ooomkgoooFk`04oooFk`;oolk_
00CoolKNoonme_oo[Lkoojg60_ogYKD4ooNL[@CooiB]00GoohbUoon4W?o_
Q9Cokg^<onMkQ002omikQ009onMkQ?o_NhcomhBDoonD]OooS:Gokib]oonD
[OoooooomoOg00Cooooo0_o2`/804Ol61PKo_[jno`h>3_nOWiooD51@ohJ6
Q_m=CDgoJFUYol;2`_no_kooWIfMof][Jol61PKo`/;2oiRHV?l:2P[o_[jn
00?o`/;200?oNWYjoaHF5_o2`/800oo2`/800omoOgoo3`l?ol;2`P02ol;2
`P04ohb<S?lF5QKo>CTiol30`0Go`/;200?oCDe=o`820_mhN7P01Oo2`/;o
oooooa?ooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?S
hoooool00_ooool00oodm?CoP820og=cL`02og=cL`03oh20P?odm?Cooooo
00_ooooo00Ooc/k>ohb<S?ooooookno_omKFe_nUYJGoU7=k00;oomkg00?o
omK_ooo>moooe^l02ooog_L00oooe^oommK_ooo6i`02ooo6i`06ooo>kooo
a^OoolKWooo6g_ooa]KookgF0_oo[LH01?ogYKGooiB]ooNDYOo_U:D2onn<
W004onnDYOogS:GoohbUooNDY@;oohbU00[okiBLonn4U?o_Nhcoig^<omik
S?oWNhcooiBeoon<YOo_W:gooiBe1_ooool2ol;2`P0=o`H61_n8R8So8R8R
ol;2`_nHV9So?cloode=COmYJFWo`/;2oi^KVoo0`<3oUiNGoadM7@02ol;2
`P07oaTI6Om/K6co_[jnokbl_?o1`L7oNg]koa<C4`04ol;2`P08ogmoOol?
3`oo`/;2ol71`OmIFEWo2@T9of][Joo1`L46ol;2`P03ode=COl0003oT92@
00Go`/;2oooooolCooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03
okVi^OoShn?ooooo00;ooooo00?o[Zj^og=cLomcLg<00omcLg<00on^[Zko
ooooooooo`0:ooooo`07olk>c_n4Q8CoooooooOgmoo_knooa/k>og]SL`02
oooNm`05ooOWkooog_OomnO_oooFkooginl01Ooog_L00oogmoOoomkgooOg
m`03oooNm`;oomK_00?oolKWooo6g_og_MH00_oo_MH01?ooa]KookgFoonm
e_oo[Lh2oon]aP04ooNU]OooU:gokiBLonn<W0?oihbD00KokhBDonn<W?o_
S9cokhbLoon<YOo_U9`2onn<W003ooN4U?ogYKGoohbU00;omiB]00?omno_
ooooooooool00oooool2ol;2`P03o`H61_m2@T;oIfMW00;o`/;200So8R8R
oclo?omYJFWo`/;2odm?Col/;2co9RHVoginOP;o`/;200SoWYjNoe1@D?lQ
8B7o8B4Qok^k^onLW9co0000oj6QX@?o`/;200KoBDU9oc0`<?o2`/;oUIFE
o`l?3onUYJD7ol;2`P05oi>CTol71`OoP820oadM7Oni^KT01?o2`/;ooooo
oaCooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00Ko^KVion?Shooo
ooooooooonKVi_n3Ph<5og=cL`03oh>3PooVi^Kooooo00[ooooo00Soc/k>
ohB4Q?ogmoOoinOWomKFe_o>a/KoHe9Joooooa?oomkg00OoomK_ooOFiooo
a^OoolKFooNmc_ogYLkomkG600Gomjfm0_ogYKD04_ooU:gomiBUooNDYOo_
S9coihbDomikQ?oNNhcoig^<omikU?o_S9cokhBDonn<W?ogS:GomjFeoonD
[OogW:goohbUooOWi`Gooooo0_o2`/800ol51@Go20P8ojb/[002ol;2`P03
ofEUIOl71`OoJFUY00go`/;200[o=SHfodm?Coo1`L7o`/;2ojRXZ?l@413o
SHf=ol;2`_nHV9So8R8R0_o2`/800one]KGo`/;2ol;2`P02ol;2`P06okfm
_OlN7QkoIVIVol;2`_mPH63oDU9B1?o2`/;ooooooa?ooooo00?ok^k^on?S
honi^KT00_o^k^h000?oi^KV00Go^KVion?ShooooooooooooiNGU`07og=c
L`03oiNGUooooooooooo00Wooooo00Woc/k>ohB4Q?ogmoOoinOWolk>c_nm
a[goDT92oooNmoogmoL01Ooog_L01?ooooooomkgoooWooogmoL:oooNm`08
ooo>moooe^ooolKWooo>g_ooa]Koojg6ooN]a_og[Kd2ooNU]@Comib]0_oo
U:d01?ooS:GomiBUooN<YOo_S9`2onN<U0?ogW^<00KoihbDooNU]OooS:Go
miB]oon<[Oo_g]h5ooooo`;o`/;200?o3Ph>ocHf=_o2`/800_o2`/800on[
Zj_o2@T9ofi^KP0=ol;2`P06okBd]?m0@43o7AdMobl_;olJ6Q[oO7al0oo2
`/801?m@D53o92@Tob8R8_lV9RH4ol;2`P07ofQXJ?lY:BWo_[jnol;2`_nn
_[ko:RXZoiRHV003ol;2`_oooooo4oooool00ooVi^Kohn?SokVi^@02onKV
iP000oo^k^h01Oni^KWohn?SoooooooAdM7oTY:B00OoLg=c00?oTY:Bom7A
dOooool02Oooool01oo>c/koS8b<ooooooooooooinOWomKFe_m:>D802?oo
g_L02_ooooooomkgoooWoooog_OoonOooooooooog_OoonOooooNmooginl3
oooFk`0>ooOFioooa^OoomK_ooo6ioooc]koolKNoonme_oo[LKomjfmooNU
]OogW:gomiBUonnDYOo_U9`2onnDY@03ooN<YOogU:GomiBU00;omiBU00?o
kiBLonn<W?oWS9@00_oWS9@01Oog[KgomiB]ooNL[OooS:GommkN00Gooooo
6Oo2`/800onm_Kgo/;2`ol;2`P05ol;2`P03okZj^_nf][Ko`/;200ko`/;2
oooooolCooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoS
hn?ooooo01Gooooo00Soe]KFohb<S?ooooooooooono_kooWinOoFT9:oooo
o`Koomkg00[omoOgoooNmoooooooooooooOgmoooooooomkgoooooooog_Oo
oooo0_oog_L2oooFk`06ooo6ioooc]komkgFooNme_oo_MKoolKF0ooo_Lh0
1ooo[LKomjfmooN]_OooU:gomib]ooNDYOo_U9`00ooWS9@01OoWS9cokhbL
ooNDYOogU:GokiBU00;omiBU00GomjFeoonD[OogW:goohbUonoNgP05oooo
oc;o`/;2oooooolDooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03
okVi^OoShn?ooooo01Gooooo00Soc/k>ohb<S?o_knooinOWomkNg_oFe]Ko
FTYBonONi`;ooooo00?oomkgooooooooool01ooog_L00oooioooomkgoooN
m`05oooNm`05ooOWkoooe^ooolKWooo>g_og_Lh00_og]LH2ooN]_@03oon]
a_og[Kgomjfm00;omjFe0_ogW:d01_o_W:GokiBLonN<W?oWS9CogXB<omik
U0;oihbD0_o_S9`01oog[Kgomib]ooNL[OogW:goojg>ooooooo_ool00ooo
oolbol;2`_oooooo4oooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H0
0oni^KWohn?Sooooo`0Eooooo`0;olk>c_n<S8coooooono_kooNg]koa/K6
og=SJooFc/koomkgooOWkoogmoL00_oog_L01_ooooooonOoooOgmooooooo
omkgoooWo`?oomkg00KoonOooooNmooog_OoomkgooOWkooog_L3oooFk`;o
olKW00CoolKFoonmc_oo[LKomjfm0oogYKD01?ogW:gokib]ooNL[OogU:D2
ooNL[@06oonD[Oo_W:GokiBLonN<W?oWS9CogW^D0_oNQ8`01Oog[Kgomib]
onn]]OogW:goojg600Gooooo<_o2`/;ooooooa?ooooo00?oi^KVon?Shoni
^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool05Oooool05_o>c/koS8b<
oooooooooooomoOgomkNg_nDS8coW9BLoooooooog_OoooooonoWkooooooo
omkgooOgmoooioooomkgoooWooogmoOoonOoooOgmoooiol4oooNm`;oomK_
00?ommKWooO6ioooc]h00_ooc]h01Oooa]koolKFoonme_oo[LKomjfm00;o
mjFe00GokibUonNLYOo_U:GokiBUonnLY@06ooNDY@08onnDW?oWS9coihbL
ooNL_OogW:gomjFeonn]]Ooo[LH5oooooc;o`/;2oooooolCooooo`03onk^
k_oShn?o^KVi00;ok^k^0003ooooo`03okVi^OoShn?ooooo01Gooooo00So
c/k>ohb<S?ooooooooooooOgmoo_knoo[Jf]oibDW0?ooooo0_oog_L05?og
moOoomkgooOgmooog_OooooooooNmoooooooomkgoooooooog_OoonOooooN
moogmoOoomkgoooFkoooinOoolKWooo>g_ooa]KomkgF0ooo_Lh00oog_LKo
okg>oon]aP02ooN]_@05oonD[OogW:gokibUonn<W?oWS9@00ooWS9`01Oo_
U9cokibUonnDYOo_U:GomiBU00?omjFe00?omib]oon]a_ooool01?oooolb
ol;2`_oooooo5?ooool00ooShn?o^KViooooo`01ooooo`000oo^k^h00oni
^KWohn?Sooooo`0Eooooo`08olk>c_n<S8comoOgono_kooNg]koe]KFomkF
e_mJBU82ooooo`0AoooNmooooooooooooooNmoooooooonOooooooooog_Oo
oooooooNmoogmoOoomkgoooooooog_OoonOooooNmoogmoL00ooog_L01_og
e^OoolkNooo6e_og_LkomkG6oon]aP;omjfm0_ogYKD2ooN]_@;omjFe00Ko
kjFUonnLYOo_W:GoihbLonN<U?oNNi@3onN<U007onN<W?ogYKGomjFeooNU
]OogW:gomjfmooOgm`04oooooc;o`/;2oooooolCooooo`03onk^k_oShn?o
^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Gooooo00Woc/k>ohb<
S?oooooomoOgonOWiooFe]Koe/k>obTQ8OoWg^L00oooool00oogknooonOo
ooooo`04ooooo`04oooNmoooooooomkgooooo`;omoOg0ooog_L4oooFk`05
ooOFioooc]koolKFooNma_oo[LH00oogYKD01?o_W:gomib]ooNL[OogYKD2
ooNL[@09oonD[OogU:GokiBUonnLYOo_U9coihbDomikU?oWS9Comjfm00;o
mjFe00?omib]onnU_Oogknl01?oooolbol;2`_oooooo4oooool00ooVi^Ko
hn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Sooooo`0Eooooo`03olk>
c_n<S8cooooo00;ooooo00Ookno_omkNg_nm]KGo@STiomK>c_ooooooomkg
00[ooooo00GoonOooooNmooog_OoomkgooO_k`02oooFk`;ommKW00_oolKW
ooo>g_ooa^OoolkNooo6e_ooa/kookg>ooNma_og[KgomjFeonnUY@02onNL
Y@GokibU0_ogW:d00oogU:GokibUonnLY@05ooNU]@03onoWkooooooooooo
00;ooooo<_o2`/;ooooooa?ooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
oooo00?o^KVion?Shoooool05Oooool00oo>c/koS8b<ooooo`02ooooo`09
ooOgmoogknooinOWolk6a_mSDU[o@T92og=SJonDU9ComnO_00Gooooo00?o
onOoooooooooool00oooool02OooioooomkgoooNmooog_OoomK_ooo>g_oo
c]KomkgFooO6cP04oonmcP?omjfm0_ogYKD01?ogW:gokibUonN<W?oWS9`2
onN<U0;oihbL0_o_W:D00oogW:gomjfmooNU]@02ooNU]@03onnU]OoWinOo
oooo00?ooooo<_o2`/;ooooooaCooooo00?ohn?SokVi^Oooool00Oooool0
00?ok^k^00?o^KVion?Shoooool05Oooool01oo>c/koU9BDooOgmoo_knoo
inOWomkNg_oWinL00_oNg]h2onOWi`07olk>c_nLW9coJf][oeY:D_mcFV?o
W9BLonoNgP02ooooo`08ooOgmoooooooomkgooooooooiooomoOgoooNmoog
moL2oooNm`05oooFkooog_OoolKWooNme_og_Lh00_og_LH00oo_[KGomjfm
ooN]_@04ooN]_@;omjFe00?okib]ooNL[OoWW:D01OoWS9@2ooNU]@04ooNm
a_o_YKgooibmooo>ePCooooo<_o2`/;ooooooa?ooooo00?ok^k^on?Shoni
^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool05?ooool00oogmoOokno_
og=cL`02ooooo`07ooOgmooWinOoc/k>olk>c_o6a/Koc/k>omKFeP03omkN
gP08onONg_oNc]Ko]Jf]og=cLom:BT[oHe9Joib<U?oFa/h2ooooo`03ooOg
mooog_Ooomkg00;oomkg00[oonOooooNmoooe^ooonOWoooFkoooc]koolK>
oon]a_ooa/komjFe1_ogW:d01oo_YJGomib]ooNL[OogW:gomiBUonnUYOo_
U9`00_oWS9`01_ogYKGomjfmooNU]Oo_[KGomjFeooo6cPCooooo<_o2`/;o
oooooa?ooooo00?oi^KVon?Shoni^KT00_oVi^H000?ok^k^00?o^KVion?S
hoooool05_ooool00omBBU;oooooooooo`02ooooo`03ono_kooWinOog]kN
00Coc/k>017oa/K6omKFe_oFe]Kog]KFomkNg_oWinOog]KFojfUYOmkNg_o
FTYBof=BF_n<NhCoa/K6oooNmooooooommK_onONi`05oooFk`05ooo6iooo
c]kookgFoonmc_og_LH00_og[Kd01?ogYKGokjFUonNLYOoWW:D3onnLY@0;
onnL[Oo_YJGomiBUonnUYOogU:GomjFeooN]_Oog_LKokjfeoonL_Oooa/h0
1?oooolbol;2`_oooooo4oooool00oo^k^kohn?SokVi^@02onk^kP000ooo
ool00oni^KWohn?Sooooo`0Fooooo`03ojf][OmkNg_ooooo00?ooooo00Go
moOgono_kooWinOoinOWomkNgP02omKFeP06olk>c_o6c/koa/K6olK6a_o6
c/koc]KF0_oNg]h04?oWinOoimkWokfm_On4LhCoFT9BoeY2B_n4LhCo_Ibe
ooOFioooe^oommKWooNmg_og_LkookgFooo6g_oo]Mh2oonmeP0Eoonmc_oo
[LKomjfmonn]]OogW:gokjfeonnUYOoWS9coiibUonN<W?oNU:GoihbLonnU
YOo_W:GomjFeooNea_ogYKGokjFmooN]_Oog_LKomoOg00?ooooo<_o2`/;o
oooooaCooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVion?S
hoooool05oooool01?mcLg?o_KFeooOgmoo_knl2omkNgP;oinOW01Cokno_
ooOgmoo_knooinOWomkWiooNg]koe]kNolkFe_o6c/koa/K6okg6a_o6c/ko
a/K6olk6c_oFc/kog]kNonOWiooWg^Oo_KfmoiBDU0;oHdYB00OoLeYSokFL
W?o__MKoonOWooNmg_og_Lkokjg>00;omjg600WomkG6oon]a_og_LKomkg6
ooNU]Oog[Kgomib]onnLYOo_YJD00_oWW:D02OoNU:GoihbDooNU]Oog[LKo
mjfmooNea_ooW;gomkg6oooNm`03oooooc;o`/;2oooooolCooooo`03onk^
k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo01Oooooo00Oo
inOWoe9:D_ooooooooooono_kooNg]koe]KF00;oc/k>00?oe]KFomkNg_oW
inL00oo_knl2onOWi`03omkWiooFg]koe]KF00Goc/k>00coe/k>omKFe_oW
g]koinOWonONiooNc]KoW9BLog=JHomJ>D;oJdYJoha[Loo_[KD2ooNmaP06
ooN]_OogYKGomib]ooNU]Oog[KgomjFe0_og[Kd02OogYKGomib]ooNL[Oo_
W:GoiibUooN]_Oog]LKomjfmooN]aP02ooN]_@04ooOWkooooooooooooooo
oc;o`/;2oooooolCooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03
okVi^OoShn?ooooo01Cooooo0_ogmoL2ooooo`03odY:B_oooooooooo00;o
oooo00?omoOgonOWiooNg]h00ooFe]H01Oo>c/koe]KFomkNg_oNg]koinOW
00;okno_00?oinOWomkWiooNg]h00_oFg]h01OoFe]Koc]K>olk>c_o>c/ko
e/k>00;oe]KF00Kog]KFonONiooWinOoe/k>okfe]OmcFV<2og=:DP0:oiA[
Loo6U9coijfeonnU_OoW[KGogYBUonnL[OogYKGokjfeonnL[@?omjFe00Co
mjfmonn]a_og[KgomkG60_og[Kd01?oginOooooooooooooooolbol;2`_oo
oooo4oooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?S
ooooo`0Fooooo`05ooOgmoooooooHf=Sono_koogmoL01Oooool01_ogmoOo
kno_onOWiooWg]kog]kNomKFeP;oc/k>00Goe/k>omkFe_oNg]koinOWonO_
k`04ono_k`;oinOW00?oe]kNolkFe_o6c/h00oo>e/h01ooFc/koe]KFomkW
iooNinOog]kNokfm_On4Ng/00_mJ@TX01?n4Hf_ocXB<onnL[Oo_YKD2onnL
[@0:onnLYOoWW:Gokib]ooNea_o_YKgomkg6ooN]_OooW;gomjfmonoNgP?o
oooo<_o2`/;ooooooaCooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^
00?o^KVion?Shoooool05_ooool01_ogmoOooooooibLW?nU[JGoooooooOg
m`?okno_00ComoOgoooooooooooooooo0_ogmoL01Oo_knooinOWomkNg_oN
g]koe]KF00?oc/k>0_oNg]h00oogmoOoooooooOgm`03ooOgm`04ono_kooW
inOog]kNomKFePCoc/k>00?oc]KFolk>c_oNg]h00_oNg]h02_nm_KgoU8b<
oeY2B_mJ@T;oNe9JojEcLooFW:GokjfeonNLYOo_YKd2oon]aP04ooNL_Ooo
[LKomibmooo>gP?ooooo<_o2`/;ooooooa?ooooo00?ok^k^on?Shoni^KT0
0_o^k^h000?oi^KV00?o^KVion?Shoooool06?ooool01?oWinOoDTYBono_
koogmoL2ooooo`05ono_kooWg]koinOWono_kooWinL00_ogmoL2ooooo`;o
moOg0_o_knl01ooNg]koinOWomKFe_nDU9CoHf=Sohb<S?oFe]H01Oooool0
1_ogmoOokno_ono_koo_knoog^OWomK>cP?oc/k>00Coa/K6olk>c_oFe]Ko
c]KF0_oWinL03?oF_LKoW8bDog=BF_mS>CWoJd9:oia[Loo6W:Gokjg6ooN]
a_og_Lkokjg>ooNmcP?ooooo<_o2`/;ooooooa?ooooo00?oi^KVon?Shoni
^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool06Oooool01OoFe]KoDTYB
ojFUYOo>c/komoOg00;ooooo00CokoooooO_kooWinOoino_0ooWinL04?o_
knoomoOgooOgmoogmoOoooooooOgmoo_knoomoOgoooooooNg]koW9bLohB4
Q?mSHf?oQ8B4okfm_Oo_knl2ooooo`;omoOg00Gomno_onO_kooWinOog]kN
omKFeP02olk>cP06olk6a_nma/Ko_LK6okg6a_o>c/koe]KF0ooNe]H01one
W9coW8B<og=BF_m[@T[oS6=[olJLYOooinL00ooooolbol;2`_oooooo4ooo
ool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0F
ooooo`03ooOgmooooooomoOg00;ooooo00Ookno_okfm_On<S8coLg=cohb<
S?nm]KGoinOW00;ooooo0_ogmoL2onOWi`;og]kN0_oWinL3ooOgm`;ooooo
00[omoOgooooooooooookno_okfm_On4Q8CoHf=Sog]kNonm]KGoe]kN0_og
moL04?oooooomoOgooOgmoogmoOokno_omKFe_oFe]koc/k>olK>c_nma/Ko
_Kfmokg6a_o>e/ko_LK6omKFe_ogmoL2ooooo`03ooO_koo_inoooooo00?o
oooo<_o2`/;ooooooaCooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^
00?o^KVion?Shoooool05Oooool00oogmoOoooooooOgm`04ooooo`0:ooOg
moooooooooooooooooo>c/koW9bLog]kNon4Q8CoYJFUomkNgP;ooooo00Ko
moOgonO_kooWinOokno_omkNg_o_knl:ooooo`03ono_konm_KgoS8b<00;o
Lg=c00CoYJFUolk>c_o_knookno_0_ogmoL01ooWg^OomoOgonoWkooNg]ko
e]KFolK>c_nma/H00_o6c/h00oo_ooooooooooooo`06oooooc;o`/;2oooo
oolCooooo`03onk^k_oShn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?o
oooo01Wooooo00?omoOgooooooooool01?ooool01_ogmoOooooooooooooo
oooog]kNojFUY@;oNg]k00KoW9bLolk>c_o_knoomoOgono_koogmoL>oooo
o`09ooOgmooFe]KoW9bLog=cLom[Jf_oU9BDokfm_OoWinOokmkN00;omno_
00OomnO_onOWiooNg]koe]KNolkFe_ooooookooo00;ooooo00?okooooooo
ooooool00_oooolbol;2`_oooooo4oooool00ooVi^Kohn?SokVi^@02onKV
iP000oo^k^h00oni^KWohn?Sooooo`0Cooooo`05ooOgmooooooooooooooo
ooogmoL04?ooool01Oo_knoo_KFeohb<S?o6a/KomoOg01Cooooo00Oog]kN
ojFUYOn4Ng_oHf=SohAkNon][Jgoe]KF00;okno_00?oknO_onO_koogmoL0
1?ooool01?ogmoOooooooooooooooolbol;2`_oooooo4oooool00oo^k^ko
hn?SokVi^@02onk^kP000oooool00oni^KWohn?Sooooo`0Fooooo`03ooOg
mooooooooooo02cooooo00Kokooookg6_On4Q8CoHf=Sof]cJoo6a/H:oooo
oc;o`/;2oooooolDooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03
okVi^OoShn?ooooo05Gooooo<_o2`/;ooooooa?ooooo00?ok^k^on?Shoni
^KT00_o^k^h000?oi^KV00?o^KVion?Shoooool0EOoooolbol;2`_oooooo
4oooool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h00oni^KWohn?Soooo
o`3ooooooi[ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVi
on?Shoooool0oooooonKooooo`03on?Shoni^KWooooo007ooooo0003onk^
kP03okVi^OoShn?ooooo00;ooooo00Ookno_ojf][OmJJf?oW9bLonO6a_oW
inOomoOg00Cooooo00?okoooooOgmoooool0oooooon:ooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003onKViP0?okVi^OoShn?ooooooooooooNg^OoU8b<
oa0H4?m:BT[o:B4QojecNomkNg_oU8b<ojf][OoF_LKokno_0?ooooooS_oo
ool00ooVi^Kohn?SokVi^@02onKViP000oo^k^h05?ni^KWohn?SoooooooW
knoo_KfmobTa:Onma[goooooocTH8Oo>Q8cocW=kolI[Lon]Jf_oW6=[oha[
LonLS8co_KFeomKFe_o_knoomoOgoooooon9ooooo`03onk^k_oShn?o^KVi
00;ok^k^0003ooooo`06okVi^OoShn?omoOgomK>e_nLU9co<CTi0_ooool0
3omkDU[ocW^4oomkU?o_Lhcoig^4olicNonmJg?oYF=[ojESHonDJg?oQ8B4
oibLW?nm_Kgog]kNooO_k`3oooooohOooooo00?ohn?SokVi^Oooool00Ooo
ool000?ok^k^00Ko^KVion?ShooWinOoa/k>ohbDS?mJFUX2ooooo`04og=J
Hoo>NiCoohb]oon<Y@;oohBL0_ogNh`02oo_Hg_oieYcolI[Lon]Jf_oYF=S
oiA[LonDQ8CoYJfUolK>c_oNknoomoOg00;ooooo00?okoooooooooooool0
1?ooool00oo_ooooooooooooo`3oooooogKooooo00?ok^k^on?Shoni^KT0
0_o^k^h000?oi^KV00Ko^KVion?ShooginOoe]KNojF]YOm[Lf/2ooooo`0G
of]cJooNS:goojG>oonUc_ogU;gooiBeooND[OooS:GokhbLoon4W?o_Q9Co
gW^<omIcQ?o>Lg_o_F]coje[JonUHf?oYF][oib4S?neW9coc/K>onOWiooo
ool00oo_ool;ooooo`03onooooogmoOooooo0?ooooooKOooool00ooVi^Ko
hn?SokVi^@02onKViP000oo^k^h03Oni^KWohn?SooO_kooWknoo[Jf]of]S
HooWg^Ooe]kNof=:D_o6LiCooiBeoonL_OooYLH00_ooYLh05?ooYLKomiBm
onnD_OooS:goohbUooMkU?ogQ9Comg^<onMkQ?o_Hg_oif]kokEcLonUJg?o
W6=[oiA[LonLS8co_KFeolkNe_oWmoOomoOg1oooool00oogmoOooooooooo
o`3oooooog3ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo017o^KVi
on?Shooooooooooookfm_Om[Lf_oimkWolkFe_m[FU[oaW>DooM[Q?ogLhco
mg>DooN4YOooU;GooibmoonUaP02oonUcP0GoonL_OooU;Goohb]oon<[Ooo
Q9comg^DooMcU?o_Q9Coig^4omIcNoo>Hg?oaW=cojEcLonLJg?oW7=kojfU
YOnm_KgoimkNooOgmoo_ooooooooooOgmoo_ool01oooool00oogmoOooooo
ooooo`3oooooof[ooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00co
^KVion?ShoooooooooooolK6a_n4Q8ComoOgonO_kon<Ng_ogXb]oonD]Ooo
S:d2ooMcU004onmcS?ogLiCoohBLoon<Y@;oojG60_oo]MH05?ooYLkoojG6
ooND_Oo_S;Gomg^Doon4W?ogLhcomg^<ooMkU?o_JhCoeW=koliSLoneLg?o
YF]cojEcLonUNg_o]IbLokfm_OoWinOokooooooooomcooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003onKViP0:okVi^OoShn?oooooooooooo>e/koQ8B4
onoWkooWinOoU8B4omj<[@;ooibm00CooiBeoon<[OooS:GomhBU0_ogNi@0
1_oNNiCoohBLoonD[OooU;GoojG6oonUcP;ookGF00GoojG>oonUa_ooU;Go
ohbUooMkU003ooMcU00=ooMkS?oWNhCoeW=kolI[LoneLg?o[F][ojEcLonU
Ng_o]Jf]omK>c_oWinOomoOgooooo`03onooooooooooJoooool00ooVi^Ko
hn?SokVi^@02onKViP000oo^k^h02_ni^KWohn?Soooooooooooo_LK6og]k
NooFc]Koc/k>of]cJoo>Ni@3oon<[@03oonD]OooW;gooibm00;omibm0_oo
S:d02OogU:gomhBUooN4YOogU:goohb]oonD]OooYLKookGFoonUcP02oonU
aP09oonL_OogU:gomhBUoon4W?ooNiComg^DooN4U?oWNhcogW^400;ocV=c
00WoYG=koia[LonLLg_o[HbDokfe]OoNc]Komno_ooooooo_ool0oooooomZ
ooooo`03onk^k_oShn?o^KVi00;ok^k^0003ooooo`0:okVi^OoShn?ooooo
ooooooo>e/koS8b<onoWkooNinOoU7=kolikW0;oohb]0_ogQ:D02?ooS:go
oiBeoonL_OooW;goojG6oonUc_ooYLKooibm0_ooU;D02OooS:GoohBLonmk
YOogS:GooiBeooNL_OooYLKoojg>oonUaP02oonL_@0Bonn<]OogQ:Gokg^U
oon4W?o_NjGomg^Donn4U?oWNhcoeW=kolIcNoneJg_oYF]coiA[LonLNg_o
[HbDolK6a_oFe]Komno_oooooomYooooo`03on?Shoni^KWooooo007ooooo
0003onk^kP0>okVi^OoShn?ooooooooooooFa/koS8b<onooooo_knooW9BL
okFLW?ooYLkoojG6oonL_OooU;D3oonD[@0AoonD]Oo_YLkomibmooN]a_oo
YLkoojg>oonUc_ooYLKooibmoonD]OooS:goohbUonmkYOogNiComhBUoon<
[OooU;D00oooW;d05?ooU;Goohb]oon<YOooS:GomhBUooMkU?ogLiCokhBD
onmkS?oWLhcogV]koliSLoo>FV_oYF][oia[LonLLg_o]IbLomJma_oNg]ko
koOg0_o_ool2ooooo`04onooooooooooooooonooooooooooG?ooool00oo^
k^kohn?SokVi^@02onk^kP000ooVi^H03Oni^KWohn?Sonooooooooooc/k>
ohAkNooNinOoe]KFoib4S?nLS9CookGFoonUc_oo[Lh00_ooYLH01?oo[LKo
oibmoonL_OooU:d3oonD]@04oonUa_og[LKoojg>oonUcP;oojG60_ooW;d0
2?ooU;Gokg^UonmkYOoWS9coig><onn4U?ooS:Goohb]0_ooU;D2oon<[@;o
ohbU00KoohBLooMkU?ogQ9Comg^Donn4U?o_Nh`2olikQ00:okE[NonUJg?o
YF]coiAcNon]S9Co_JFUolk>c_oWg]koooooonooo`;ooooo00?okooooooo
ooooool0oooooomJooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP0>
okVi^OoShn?ooooooooooooFc/koQ7]komkWioo>c/koU8b<oiacNoo_YLko
kjg6ooNL_Ooo[LH2oon]cPCookGF00Coojg>oonUa_ooW;gooiBe0_ooW;d0
1Oog[LKoojG>oonUc_oo[LKoojG600;ooibm00SooiBeoon<YOooQ9cogW^D
onmcS?oWLhcomg^Doon<Y@?oohb]0_ooS:D2oon4W008ooMkU?ogQ9Comg>D
oon4W?oNNiCoig^<olikQ?nmJg<2okEcL`07oiAcNon]S9CoolkNonooooog
moOoooooonooo`3ooooooecooooo00?ok^k^on?Shoni^KT00_o^k^h000?o
oooo00_o^KVion?ShoooooooooooomK>c_n<S8cokoOgonOWion]YJGoU7=k
oonUaP02ooNL_@05oonD]OooW;goojG6oon]a_oo[Lh00_og_Mh3oonegP03
oonee_oo[LkoojG600;omibm1?ooU;D2oonL_@;ooiBe00Coohb]oon4W?og
NiComg><0ooWHh@01?o_Lhcomg^Doon4W?ooS:d2oon<Y@?oohBL0_ooNi@0
1?ooQ9ComhBDonmkS?oWNh@2olIkS003onnU]Oooooookooo0?ooooooGooo
ool00ooShn?o^KViooooo`01ooooo`000oo^k^h03Oni^KWohn?Soooooooo
ooooc/K>ohB4Q?ogmoOoknO_okfe]OnDLg_oolk_oonme_oo[Lh00_oo[LH0
0oog[KgomibmooN]aP02oon]cP0=oonmc_oo]MkoolKWooo6iooga^OomkgW
oonee_oo[LkoojG6ooNL_OooU;GomiB]oon<Y@02oon<[@;ooiB]00KooiBe
oon<[OooS:GoohBLoomkU?o_Lh`2onMSQ004omiJNooWHhCokg><ooMkU0Oo
ohBL0_ooNi@01?o_S9cogW^<omikU?o_inoooooooeoooooo00?ok^k^on?S
honi^KT00_o^k^h000?oi^KV00[o^KVion?Shoo_ooooooooomK>c_n4Ng_o
g^OWomKFe_nm]KGoNf=c1?oo]Mh01?ooa]kookGNoonme_og_MH2oon]cP;o
mjG>00GookgFooneg_oo]MkookGNooo6i`02oonegP;ookGF00Goojg>ooNL
_OogYKGomhBUooN<Y@02ooN4Y@?oohbU0_ooQ9`05?ooNiComg^DonmcS?oW
HhCoif=komiJNooNFW?okf^4onmcS?ogNiCoohBDoon4W?ooS:GoohBLoon<
YOogNiComg>DonM[S?o_g]kokooooooooomNooooo`03onKVi_oShn?o^KVi
00;oi^KV0003onk^kP0:okVi^OoShn?ooooooooooooFc/koQ7]komkWioo>
e]Ko_KFeog=BFP;omkgF00GomjG>oonee_oo]MkookGNooo6i`02ooo>k`03
ooo6iooo]MkookgF00?oojg>00Goojg6ooNme_og_MKomkgFooneeP02oone
gP;ookGF00SoojG6oonL_OogU:gokhbLonn4U?ogLiCokg><onmkS0;oohBD
0oooNi@01OogLhcokg><onm[Q?oWFW?ogV=c00;ogUYc00?oif=konmcS?og
Lh`00_ooS:D2oom[S003omk>e_ogmoOomoOg0?ooooooGOooool00oo^k^ko
hn?SokVi^@02onk^kP000oooool03Oni^KWohn?Sooooooooooooe/k>ohb<
S?ooooookno_omJma_mkDU[oolKWoonme_oo[Lh00_oo[LH01?og[LKookGF
ooneg_oo]Mh2ooo6i`03oooFkoooc^ooolk_00;omlKW00CookGFoon]c_oo
[LKomjg60_oo[LH2oon]cP;oojG600OooibmoonD]OooU;GoohbUoon4W?og
LiCoif]k00;okf^400?oig^4ooMkS?ooNi@00oooNi@00oogJhComg><onmS
N`03omiJL`05onmcS?ogLiCoog^Doon4W?og_MH00_o_oooooooooekooooo
00?ohn?SokVi^Oooool00Oooool000?ok^k^00_o^KVion?ShooooooomoOg
omK>c_n<NhComoOgooO_kooWinOoFV=Jooo>m`03ooo6i`04ooo6g_oo]MKo
mkg>ooneeP;omkgF0_oo]Mh03_ooa^Ooolk_oooFkoooc_Ooolk_ooo6iooo
]MkookgFoon]c_ooYLKomibmooNU]OooW;gomjFe0oooW;d01oooU;GooiB]
oon<YOooQ9comg^DonmkS?oWHh@00_oWHg/00ooWJg_okf=konmcS002ooMc
S009onmcS?ogLhcokf^4onm[Q?ogLhcoog^DooN4YOogNiCookgF0?oooooo
Goooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H03?ni^KWohn?Soooo
ooooooooc/k>ohAkNooWg]kog/kFomK6c_m2@T;oolk_ooNmgP;oolKW0_oo
c^l01Oooa^Ooolk_ooo6ioooa]komkgN00;omkgF0_og_Mh3ooo6i`08ooo>
koooa^OoolKNooo6e_oo[Lkoojg6ooN]_OooW;d2ooND[@04ooNDYOogU:go
ohb]ooND[@?oohbU00WoohBLooMkU?o_Lhcokf^4onMSNooNFW?ogV=conMS
Noo_Jh@00oogLh`2oon4W005ooN<YOogNiCookg>ooooooo_ool0oooooomM
ooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP0;okVi^OoShn?ooooo
oooooooFe]KoS8b<ooO_kooWg]kog]KFod8i>Oooa^L01?og_Mh01oooa^Oo
olk_oooFkooog_OoolkgoooFkoooc^l00_ooa^L2ooNmgP03ooNmioog_Mko
mkgN00CookGN00[ookgFoon]c_oo[LKooibmooNU]OooS:gomhbUonn<W?o_
Q9Comg^D1OooQ9`2oomkU00<ooMcS?o_Lhcoif]komiSLoo>Hg?ogV=conM[
Noo_LhcoohbUooN4YOogNiCookgFoooooomOooooo`03onk^k_oShn?o^KVi
00;ok^k^0003ooooo`0?okVi^OoShn?oooooooooooo>c/koS8b<ooooooog
knooimkWodXi@_ooc_OoolKWooo>g_og_MkomkgF00?omkgN00?oolKWoooF
kooog_L00_oog_L01oooe^ooolkgoooFkooge^oomlKWooNmg_o__MH00_og
_MH2oonmeP0:oonee_oo[Lkoojg>oon]c_oo[LKomjFeoonD[OogS:GomhBD
onn4U0;okg><01;oig><onmkS?ogNiComhBDoon4W?ogQ9Comg>DonmcS?o_
JhCoif>4omi[Noo_JhCoohbUooN<YOogNiCookgFooooooo_ool>ooooo`03
on;Rh_olo?cooooo00Cooooo00?oh^;Rooclo?ooool0oooooom6ooooo`03
on?Shoni^KWooooo007ooooo0003onk^kP0;okVi^OoShn?oooooooooooo>
c/koS8b<ooOgmoogknooinOWodY:B_oog_L00_ooc_L01Ooog_OoolKWooo>
koooa^OoolkN00?omlKW00GoolKWoooFkoooc_OoolkgoooNm`03ooo>m`;o
olKW00?omkgNonn]c_o_[Lh00_og[LH00oogW;gooibmooN]_@02oonL_@0>
ooNU]OooU;GooiB]onn<W?o_Q9Coig^<onMSQ?oWNhCoif>4onMkQ?o_Lhco
khBDoon4W?ogQ9@2ooMkU005ooN4U?ooS:gomhbUoon<YOoo_Lh04?ooool0
0ol>3Pkoh^;Rooooo`04ooooo`03o`h>3_oRh^;ooooo0?ooooooAOooool0
0oo^k^kohn?SokVi^@02onk^kP000ooVi^H02oni^KWohn?Sonoooooooooo
c/k>og]kNoo_knoog]kNomKFe_m2@T;omlKW00;oomK_00OoolkgoooFkooo
e^ooomkgooo>mooog_Ooolkg00;oomK_0ooge^l04Oooe^ooomkgoooFkooo
e^ooolkgoooFkoooc^ooolKWooo6g_oo[Lkomjg6onnU_Oo_W;GomiB]ooNL
[OogU:GoohbU00?ooiB]0_ooS:D01OooQ9comg^DonmkS?oWHhCoig^400;o
gV]k00Soig^4onMcS?ogNiCoohBLoon<YOo_NjGoohbUooNeaQ3ooooo00Co
3Ph>on;Rh_ofm_Kon_[j0oooool01?l>3Pkoh^;RooKfm_ojn_X7ooooo`03
ookno_oYjNWoo_kn0?oooooo>_ooool00ooVi^Kohn?SokVi^@02onKViP00
0oo^k^h02oni^KWohn?Sooooooooooooc]KFohb<S?ooooooinOWomkFe_mJ
FU[omkg>00;oolKW00GomlKWooOFioooc^ooomK_ooo>m`08oooNm`;oolKW
00komlKWooOFioooa^OoomK_ooo6ioooc^ooolKWooneg_oo_Lkoojg6ooN]
_OooU;GomiBUonn<W0;oihbD00?okhbLoon4W?o_S9`00oo_S9`01OooQ9Co
mhBDonmkS?oWLhcoig^400;ogV]k00Goig><oon<YOogU:goohbUooN]_@07
ooooo`03odY:B_nYZJWooooo00;ooooo00WonOWioa<C4onj^[[oooooo`h>
3_mWIfOoATI6oa0@4?nYZJT00_ooool01Ol>3PkoIfMWodI6A_l@413oZJVY
00;ooooo00So3Ph>on;Rh_oooooo/K6aoaLG5oli>CWo=3@dokVi^Ooooooo
>Oooool00oo^k^kohn?SokVi^@02onk^kP000oooool02oni^KWohn?Soooo
ooooooooc/k>ohb<S?oooooomoOgonOWiomcHf_okkgF00;oomK_00GoolKW
oooFkooga^OomlKWooOFk`02oooFk`Ooomkg00?oomK_ooo6ioog_Mh00_og
_MH01Oog_MkomkgFoonee_oo]MKookgF00;oojg>00Soojg6oonL_OogYKGo
oiB]oon<YOo_S9coihbDonMkS0;okhBD00CoohBLooN4U?o_S9coohBL0_og
Q9@2onmkS005ooN4U?ooS:gomiB]oon<[Oo_YKd01oooool00on_[joo@d=3
ooooo`02ooooo`09ojRXZ?lP823oo_knooooool>3Pko^;Rhooooooo;bl_o
8b<S00;ooooo00Go3Ph>okRh^?oooooobl_;ob<S8`02ooooo`05o`h>3_oR
h^;oi^KVo`/;2oo7alL0oooooolmooooo`03on?Shoni^KWooooo007ooooo
0003onk^kP0;okVi^OoShn?oooooooooooo>c/koQ8B4ono_kooWinOog]kN
ohbDS?nmW;D01ooog_L01OoginooomK_ooOFkooge^ooomK_00Ooomkg00Oo
olkgooo6ioog_MkomkgFooNmc_og]LKomjg600;omjfm00?oojg6ooN]_Oog
[Kd00_ogYKD01_ogW:gomiBUooNDYOo_Q9Coig^<omikS0?oig^<00WokhBD
ooN4U?o_Q9CokhbLonnDW?ooU:goohbUonnL[OooU;D01oooool00ookno_o
6QXJoc<c<`02oc<c<`06oaDE5On2PX;oooooooooool>3Pkoh^;R0_ooool0
1OlF5QKof=SHooooool>3Pkoh^;R00;ooooo00Oo5QHFomSHf?oooooo3Ph>
on;Rh_n[Zj_o8B4Q00?o_kno00?ojNWYooooooooool0oooooolgooooo`03
onk^k_oShn?o^KVi00;ok^k^0003onKViP0;okVi^OoShn?ooooooooooooF
e]KoS8b<ono_kooNg]koa/K6ohakQ?nLU9`00oooe^l;oooNm`03oooFkooo
g_OoomK_00CoomK_0_ooc^l01?ooa]kookgFoon]c_oo[LH2ooNU]@Comib]
1?ooU:d01OooS:GoohBLonn4U?o_Nhcoig^400;ogW^400Woig^4onmkS?og
Q9CooiBeoon<YOo_W:gooiB]ooooooogmoL01_ooool01_mjNW[oLW9booGe
mOoCdm?o0`<3onCTi0;ooooo00Wo3Ph>on;Rh_oooooooooooaHF5_o:b/[o
ooooo`h>3_oRh^800_ooool01olF5QKob/[:ooooool>3Pkoh^;RolO7aolG
5aL00_mdM7@00olK6a_o`L71ooooo`3oooooocSooooo00?oi^KVon?Shoni
^KT00_oVi^H000?ok^k^00_o^KVion?Shoooooooooooolk>c_n<S8cooooo
ono_kooFe]KoYJFUoiAcN`02oooNm`03oooFkoooc_OoomK_00_oomkg00?o
omK_ooOFkoooa^L00_ooa^L01_ooc^ooolKWooo6ioooa]koolKFoonmeP;o
ojg600ComjFeoonD[OogU:GokiBU0_o_S9`01?o_U:GomhbUoon<YOogU:D2
oon<Y@0:onnDW?o_Q9Cokg^<onMkS?oNNhcoig^<oonD]OooS:Gokib]oonD
]@Sooooo00Gog]kNoaXJ6_okno_oNWYjodY:BP03ooooo`0Fo`h>3_m]KFgo
k^k^oj^[ZolE5AGoo_knooooool>3PkoKFe]onk^k_n[Zj_o5ADEookno_oo
oooo3Ph>on;Rh_ono_ko8R8Ron3Ph?o_knoo7AdMoo[jn_oooooo>Oooool0
0oo^k^kohn?SokVi^@02onk^kP000oooool02oni^KWohn?Soooooooooooo
c/k>ohB4Q?oooooomoOgono_koo6c/koNf=c00;oomkg00GomnO_oooNmoog
inooomK_ooOWk`05oooNm`03ooOgmooog_OomoOg00?oomkg0_ooe^l00ooo
a^OoolKNooNmeP02oonmeP04ooo6e_oo_MKookgFoon]cP;oojg600ComjFe
oonD[Oo_U9cokhbL0ooWS9@01_o_Q9CokhbLonn<W?o_S9coohbUonnDW0;o
khbL00?omhBDooNU]OooS:D00_ogU:d00oogknooooooooooo`06ooooo`04
odE5AOnZZZ[o6ATIojj^[P?ooooo00Go=cLgojZZZ_la<C7o?Cdmok^k^`02
ooooo`05ocLg=onZZZ[o<C4aocdm?Onk^k/00_ooool01ol>3Pkoh^;Roooo
oonk^k_o<C4aoclo?on_[jl0oooooolkooooo`03on?Shoni^KWooooo007o
oooo0003onk^kP0<okVi^OoShn?oooooooooooo>c/koQ8B4ooOgmooWinOo
e]KFolk6a_mSDU[ooooo4ooog_L01oooe^oommKWooo6ioooa]Komkg>ooNU
c_og]LH01Oog[Kd2ooNU]@0BoonD[OogU:GomiBUonn<W?oWS9CogW^4omik
S?oWNhcogW^Donn<W?o_Q9CokhbLooN<YOogYKGooiB]ooNL[OooS:GomnOW
2?ooool01?n[Zj_o5QHFoaLG5ookno/Aooooo`03o`h>3_oRh^;ooooo0?oo
oooo?_ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H03Oni^KWohn?S
ooooooooooooc/k>ohB4Q?ogmoOoinOWolk>c_nma[goDT92oooNmoogmoL0
1Ooog_L01?ooooooomkgoooWooogmoL:oooNm`08ooo>moooe^ooolKWooo>
g_ooa]Koojg6ooN]a_og[Kd2ooNU]@Comib]0_ooU:d01?ooS:GomiBUooN<
YOo_S9`2onN<U0?ogW^<00KoihbDooNU]OooS:GomiB]oon<[Oo_g]h8oooo
o`03oo[jn_lO7aooNg]k01;ooooo00?o3Ph>on;Rh_ooool0oooooolnoooo
o`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP06okVi^OoShn?ooooooooo
ooo>c/koS8b<0_ooool00ooWinOoe]KFodXi@P08oooNm`0:oooooooog_Oo
onOooooNmoooiooooooooooNmoooioooomkgooOWk`?oomK_00kommKWooo6
ioooe^ooolKWooo>g_ooa]kookgFoon]a_og[KgomjFeooNL[OogU:GokiBU
onnDW0;okiBU00?omhbUooNDYOogU:D00_ogU:D00oo_U9cokhbLonN<U002
onN<U005ooN]_OogU:gomib]oon<YOogg]h07Oooool00on<S8colO7aoooo
o`3oooooockooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00Ko^KVi
on?ShoooooooooooomKFe_n<S8`2ooooo`04ono_kooWinOoFT9:ooooo`Ko
omkg00[omoOgoooNmoooooooooooooOgmoooooooomkgoooooooog_Oooooo
0_oog_L2oooFk`06ooo6ioooc]komkgFooNme_oo_MKoolKF0ooo_Lh01ooo
[LKomjfmooN]_OooU:gomib]ooNDYOo_U9`00ooWS9@01OoWS9cokhbLooND
YOogU:GokiBU00;omiBU00GomjFeoonD[OogW:goohbUonoNgP3ooooooeoo
oooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00co^KVion?Shooooooo
ooooolk>c_n<S8cokno_onOWiooNg]koe]KFoeY:D_oWg^L2ooooo`03oooN
mooooooooooo00Ooomkg00?oonOooooNmooog_L01Ooog_L01OoginooomK_
ooo6ioooc]komkg>00;omkG60_og[Kd00ooo[LKomjfmooN]_@02ooNU]@;o
mib]00KokibUonnDW?oWS9coihbDomj4S?oNNi@2onN<U0;okhbL00Oomjfm
ooNL[OogW:gomib]oon]c_ooooookooo0?ooooooG?ooool00oo^k^kohn?S
okVi^@02onk^kP000ooVi^H03oni^KWohn?Sooooooooooooc/k>ohb<S?oo
ooookno_omkNg_o6a/KoLf=[omK>c_oog_OomnO_ooOgm`02oooNm`06oooo
ooooiooomoOgoooooooog_OoonOo0ooog_L01_ooioooomkgoooNmooog_Oo
mnO_oooNm`?oomK_0_ooa^L01?ooa]Kookg>oon]a_og[Kd3ooNU]@04ooNL
[Oo_W:gomib]ooNDY@;omib]00KooiB]onnLYOo_U9coihbLonN<U?oNNi@2
omj4S005ooN]_OogW:gokjfeooNL[Ooo[LH0oooooomNooooo`03onKVi_oS
hn?o^KVi00;oi^KV0003onk^kP06okVi^OoShn?oooooooooooo>c/koS8b<
0_ooool04_ogmoOog]kNoiB<S?nLU9cooooooooNmoooooooknO_oooooooo
g_OomoOgoooWoooog_OoonOoooOgmoooiooomoOgoooWo`Coomkg0_ooe^l0
0ooge^OomlKWooo>gP02ooo>gP05ooo6g_ooa]KookgFoon]a_og[Kd00_og
YKD01Oo_W:GoiibUonnDYOo_U:GokibU00KomiBU00SokiBLonN<W?oWS9co
mibmooNL[OogYKGokjfeoon]a_ooooooG_ooool00oo^k^kohn?SokVi^@02
onk^kP000oooool01_ni^KWohn?Sooooooooooooc/k>ohb<S0;ooooo00Co
moOgono_kon][JgoW9BL0oooool2oooNm`0DooOgmooog_OomoOgoooNmooo
ooooomkgoooooooog_OooooooooNmoooioooomkgooOgmooog_OoomK_oooW
ioooa^OoolkNooo6e_og_MH3oonmcP03ooNma_oo_Lkoojg600;omjfm00Go
oiB]ooNL[Oo_W:GokhbLonN<U003onN<W005onnDW?o_W:GokiBUonnDYOog
U:D00oogYKD00oogW:goojg6ooooo`3ooooooekooooo00?ohn?SokVi^Ooo
ool00Oooool000?ok^k^00co^KVion?Shoooooooooooolk>c_n<S8comoOg
ono_kooNg]koe]KFomkFe_mJBU82ooooo`0AoooNmooooooooooooooNmooo
ooooonOooooooooog_OooooooooNmoogmoOoomkgoooooooog_OoonOooooN
moogmoL00ooog_L01_oge^OoolkNooo6e_og_LkomkG6oon]aP;omjfm0_og
YKD2ooN]_@;omjFe00KokjFUonnLYOo_W:GoihbLonN<U?oNNi@3onN<U007
onN<W?ogYKGomjFeooNU]OogW:gomjfmooOgm`3ooooooegooooo00?ok^k^
on?Shoni^KT00_o^k^h000?oi^KV00go^KVion?Shoooooooooooolk>c_n<
S8coooooooOgmooWinOoe]KFomK>c_lY8B7oimkW00?ooooo00?omno_oooW
ooooool01?ooool01?oog_OooooooooNmoooool2ooOgm`?oomkg1?ooe^l0
1Ooge^OoolkNooo6e_og_LKoojg600?omjFe00Cokib]ooNL[OogW:gomjFe
0_ogW:d02OooU:gomiBUonnDYOo_W:GokiBLonN<U?oNNiCoihbDooN]_@02
ooNU]@03ooNL[Oo_YKgomno_0?ooooooGOooool00ooVi^Kohn?SokVi^@02
onKViP000oo^k^h01_ni^KWohn?Sooooooooooooc/k>ohb<S0?ooooo00Oo
kno_omkNg_nm]KGo@STiomK>c_ooooooomkg00[ooooo00GoonOooooNmooo
g_OoomkgooO_k`02oooFk`;ommKW00_oolKWooo>g_ooa^OoolkNooo6e_oo
a/kookg>ooNma_og[KgomjFeonnUY@02onNLY@GokibU0_ogW:d00oogU:Go
kibUonnLY@05ooNU]@03onoWkooooooooooo0?ooooooFoooool00oo^k^ko
hn?SokVi^@02onk^kP000oooool01_ni^KWohn?Sooooooooooooc/k>ohb<
S0?ooooo00WomoOgooO_kooWinOoc/K6of=BF_m2@T;oLf=[oiBDU?oginl0
1Oooool00oooioooooooooooo`03ooooo`09oooWoooog_OoomkgoooNmooo
e^ooolkNooo>e_og_MKomlK>00Cookg>0oog[Kd2ooNU]@04ooNL[Oo_W:Go
ihbLonN<W0;oihbD0_oWS9`2onnLY@03ooNL[Oog[KgomjFe00;omjFe00?o
kjFeonOWioooool0oooooomMooooo`03on?Shoni^KWooooo007ooooo0003
onk^kP0;okVi^OoShn?oooooooooooo>c/koU9BDooOgmoo_knooinOWomkN
g_oWinL00_oNg]h2onOWi`07olk>c_nLW9coJf][oeY:D_mcFV?oW9BLonoN
gP02ooooo`08ooOgmoooooooomkgooooooooiooomoOgoooNmoogmoL2oooN
m`05oooFkooog_OoolKWooNme_og_Lh00_og_LH00oo_[KGomjfmooN]_@04
ooN]_@;omjFe00?okib]ooNL[OoWW:D01OoWS9@2ooNU]@04ooNma_o_YKgo
oibmooo>e_ooooooGOooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H0
1_ni^KWohn?SooooooogmoOokno_og=cL`;ooooo00OomoOgonOWioo>c/ko
c/k>olK6a_o>c/koe]KF00?og]kN00SoimkNomk>e_ne[JgoLg=codY:B_mS
DU[oW8bDomK6cP;ooooo00?omoOgoooNmooog_L00_oog_L02_ooioooomkg
oooFkoooinOoomK_ooo>g_ooa/koojg6ooo6c_ogYKD6ooNL[@07onnUYOog
W:gomib]ooNL[OogU:GokjFUonnDW002onN<W006ooNU]Oog[KgomjFeonn]
]OogYKGoolK>oooooomMooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^
kP03okVi^OoShn?ooooo00;ooooo00?oDTYBooooooooool00_ooool00oo_
knooinOWomkNgP04olk>cP0AolK6a_oFe]Koe]KFomkFe_oNg]koinOWomkF
e_n]YJGoNg]koeY:D_mSDU[oS7^4olK6a_oog_OoooooooOFkooWg^L01Ooo
e^l01Oooa^OoolkNoonme_oo_Lkomkg600;omjfm00ComjFeonnUYOoWW:Go
iibU0oo_W:D02oo_W:gokjFUooNDYOo_YJGomiBUooNU]Oog[Kgomkg6onn]
]OooW;goolK>0?ooooooGOooool00oo^k^kohn?SokVi^@02onk^kP000ooo
ool00oni^KWohn?Sooooo`02ooooo`03ojf][OmkNg_ooooo00?ooooo00Go
moOgono_kooWinOoinOWomkNgP02omKFeP06olk>c_o6c/koa/K6olK6a_o6
c/koc]KF0_oNg]h04?oWinOoimkWokfm_On4LhCoFT9BoeY2B_n4LhCo_Ibe
ooOFioooe^oommKWooNmg_og_LkookgFooo6g_oo]Mh2oonmeP0Eoonmc_oo
[LKomjfmonn]]OogW:gokjfeonnUYOoWS9coiibUonN<W?oNU:GoihbLonnU
YOo_W:GomjFeooNea_ogYKGokjFmooN]_Oog_LKomoOg0?ooooooGOooool0
0ooShn?o^KViooooo`01ooooo`000oo^k^h00oni^KWohn?Sooooo`03oooo
o`04og=cLonm]KGomoOgono_k`;og]kN0_oWinL05?o_knoomoOgono_kooW
inOog^OWomkNg_oFg]koc]KFolK>c_o6a/Ko_LK6olK>c_o6a/Koc/K>omK>
c_oNg]koinOWonONionm_KgoU9BD0_mSBU801omcFV?o]IbLonnme_ooinOo
mkgNooNmc_o_[Lh00_og[LH02Oog]LKoojg6ooNma_og_LKomjFeooN]_Oog
W:gokibUonnUY@02onNLY@09omjDYOoWS9ComjFeooN]a_og[KgomkG6oonL
_Oog_LKoomkg0?ooooooG?ooool00oo^k^kohn?SokVi^@02onk^kP000ooV
i^H00oni^KWohn?Sooooo`03ooooo`07onOWiomBBU;oooooooooooo_knoo
g]kNomKFeP02olk>cP03omKFe_oNg]koinOW00?okno_0_oWinL00ooNinOo
e]kNomKFeP05olk>cP0<omK>c_oFe]KoimkNonOWiooWg^Oog/kFoibDW?mc
FV?oFSU2of]:F_n<Jg?okjfe0_og_LH01_og[KgomjFeooNL[OogYKGomjfm
ooNU]@;omjfm00WomjFeooNL[OogW:gokibUonNLYOog[KgomkG6ooN]_Oog
[LH00_og[Kd00ooginooooooooooo`3ooooooe[ooooo00?oi^KVon?Shoni
^KT00_oVi^H000?ok^k^00?o^KVion?Shoooool00_ogmoL2ooooo`03odY:
B_oooooooooo00;ooooo00?omoOgonOWiooNg]h00ooFe]H01Oo>c/koe]KF
omkNg_oNg]koinOW00;okno_00?oinOWomkWiooNg]h00_oFg]h01OoFe]Ko
c]K>olk>c_o>c/koe/k>00;oe]KF00Kog]KFonONiooWinOoe/k>okfe]Omc
FV<2og=:DP0:oiA[Loo6U9coijfeonnU_OoW[KGogYBUonnL[OogYKGokjfe
onnL[@?omjFe00Comjfmonn]a_og[KgomkG60_og[Kd00ooginOooooooooo
o`3ooooooe[ooooo00?ok^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVi
on?Shoooool00_ooool01OogmoOoooooof=SHoo_knoomoOg00Gooooo00Ko
moOgono_kooWinOoimkNomkNg_oFe]H2olk>cP05omK>c_oNe]Kog]kNonOW
iooWknl01?o_knl2onOWi`03omKNg_o>e]Koa/k>00?oc]K>00Ooe/k>omKF
e_oNinOog^OWomkNg_nm_KgoQ7]k00;oFT9:00CoQ6=[olj4S?o_W:gokjFe
0_o_W:d02_o_W:GoiibUonnL[Oog]LKokjFmooNma_og[KgooibmooN]_Oo_
g]kooooooegooooo00?ohn?SokVi^Oooool00Oooool000?ok^k^00?o^KVi
on?Shoooool00_ooool01_ogmoOooooooibLW?nU[JGoooooooOgm`?okno_
00ComoOgoooooooooooooooo0_ogmoL01Oo_knooinOWomkNg_oNg]koe]KF
00?oc/k>0_oNg]h00oogmoOoooooooOgm`03ooOgm`04ono_kooWinOog]kN
omKFePCoc/k>00?oc]KFolk>c_oNg]h00_oNg]h02_nm_KgoU8b<oeY2B_mJ
@T;oNe9JojEcLooFW:GokjfeonNLYOo_YKd2oon]aP04ooNL_Ooo[LKomibm
ooo>g_ooooooG?ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H00oni
^KWohn?Sooooo`04ooooo`04onOWiomBBU;okno_ooOgm`;ooooo00Gokno_
onONg_oWinOokno_onOWi`02ooOgm`;ooooo0_ogmoL2ono_k`07omkNg_oW
inOoe]KFoiBDU?mSHf?oS8b<omKFeP05ooooo`06ooOgmoo_knookno_ono_
kooNinOoe/k>0oo>c/h01?o6a/Koc/k>omKFe_o>e]H2onOWi`0<omJma_nL
S9CoLe9Jof<i>Om[@T[oW6]colJLYOo_[LKomjg6ooNmc_o_[Lkomkg>oooo
oomLooooo`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?o
oooo00Gooooo00Goe]KFoe9:D_nUYJGoc/k>ooOgm`02ooooo`04onooooog
knooinOWonO_k`?oinOW013okno_ooOgmoogmoOomoOgooooooogmoOokno_
ooOgmooooooog]kNoibLW?n4Q8CoHf=SohB4Q?nm_Kgokno_0_ooool2ooOg
m`05ooO_kooWknooinOWomkNg_oFe]H00_o>c/h01_o>a/Ko_LK6okg6a_nm
a/Koc/k>omKFeP?og]KF00Oo]IbLoib4S?mcDU[oJd9:ohaSJoo6W:GoonOW
0?ooooooG?ooool00oo^k^kohn?SokVi^@02onk^kP000oooool00oni^KWo
hn?Sooooo`02ooooo`03ooOgmooooooomoOg00;ooooo00Ookno_okfm_On<
S8coLg=cohb<S?nm]KGoinOW00;ooooo0_ogmoL2onOWi`;og]kN0_oWinL3
ooOgm`;ooooo00[omoOgooooooooooookno_okfm_On4Q8CoHf=Sog]kNonm
]KGoe]kN0_ogmoL04?oooooomoOgooOgmoogmoOokno_omKFe_oFe]koc/k>
olK>c_nma/Ko_Kfmokg6a_o>e/ko_LK6omKFe_ogmoL2ooooo`03ooO_koo_
inoooooo0?ooooooGOooool00ooShn?o^KViooooo`01ooooo`000oo^k^h0
1oni^KWohn?SoooooooooooomoOgooooooogmoL01?ooool02_ogmoOooooo
ooooooooooooc/k>oibLW?mkNg_oQ8B4ojFUYOoNg]h2ooooo`06ooOgmooW
knooinOWono_kooNg]kokno_2_ooool00oo_knoo_Kfmohb<S002og=cL`04
ojFUYOo>c/kokno_ono_k`;omoOg00OoimkWooOgmoo_inoog]kNomKFe_o6
c/ko_LK600;oa/k>00?okoooooooooooool0oooooomOooooo`03onk^k_oS
hn?o^KVi00;ok^k^0003onKViP03okVi^OoShn?ooooo00Gooooo00?omoOg
ooooooooool01?ooool01_ogmoOooooooooooooooooog]kNojFUY@;oNg]k
00KoW9bLolk>c_o_knoomoOgono_koogmoL>ooooo`09ooOgmooFe]KoW9bL
og=cLom[Jf_oU9BDokfm_OoWinOokmkN00;omno_00OomnO_onOWiooNg]ko
e]KNolkFe_ooooookooo00;ooooo00?okoooooooooooool0oooooomKoooo
o`03onKVi_oShn?o^KVi00;oi^KV0003onk^kP03okVi^OoShn?omoOg00?o
oooo00?omoOgooooooooool03_ooool01Oo_knoo_KFeohb<S?o6a/KomoOg
01Cooooo00Oog]kNojFUYOn4Ng_oHf=SohAkNon][Jgoe]KF00;okno_00?o
knO_onO_koogmoL01?ooool00oogmoOoooooooooo`3ooooooe[ooooo00?o
k^k^on?Shoni^KT00_o^k^h000?ooooo00?o^KVion?Shoooool00_ooool0
0oogmoOoooooooooo`0/ooooo`06onoooonma[goQ8B4of=SHom[Lf_oa/K6
oooooomTooooo`03on?Shoni^KWooooo007ooooo0003onk^kP03okVi^OoS
hn?ooooo0?ooooooV_ooool00oo^k^kohn?SokVi^@02onk^kP000ooVi^H0
0oni^KWohn?Sooooo`3ooooooi[ooooo00?oi^KVon?Shoni^KT00_oVi^H0
00?ok^k^00?o^KViol?3`oo3`l<0ooo3`l>Lol?3``7o^KVi0Oo^k^h1onk^
kP000oooooooogalO:3oO7al0_ooool00?ook^k^YOo^k^h00?ooi^KVYOoV
i^H00?ook^k^YOo^k^h00?ooOgmoYOmoOgl00004on_[jooVi^Koh^;RomkN
gPCogMgM0ooNg]h0_?oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
0_oMgMd2omcLg003om_Kg?oMgMgog=cL00;ogMgM0<Sog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgM
gOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kN
omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkN
g_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM
omkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgM
g_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkN
g_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMg@?og]kN00?ogMgMomkNg_oNg]h00ooM
gMd1on7Qh@7oinOW0OoZj^X00003onc/k?oVi^Koh>3P00OofMWI00Cof=SH
omKFe_oCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSH
f?oGemOodm?Com3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oH
f=SoemOGom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf7SofMWI0_oH
f=P00ooIfMWof=SHomSHf003omWIf@;of=SH1OoIfMT00ooHf=Soe]KFom?C
d`02om?Cd`03omKFe_oHf=Sof=SH00kofMWI00Cof=SHomWIfOoIfMWof=SH
4?oIfMT2omSHf:CofMWI00?of=SHomWIfOoIfMT01_oIfMT1omkNgP7oi^KV
0Oo/k>`00007onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=
omkNg_oLg=codm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?o
fm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o/[:bojj^[_nb
/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7
aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`1Yon7Qh@[o
h>3P00?ogmoOon3Ph?oPh>001_oOgml2on3Ph0?ogmoO1OoPh>001ooOgmoo
fm_KomOGeooDe=CoeMGEomWIfOoMgMd00_oPh>000ooOgmooh>3Pon3Ph002
on7Qh@Ooh>3P1_oOgml00ooPh>3ogmoOon3Ph00;on3Ph004omoOgooNg]ko
g]kNomoOg`;oh>3P>?oQhN400ooPh>3ohN7Qon7Qh@1Xon7Qh@03on;Rh_oQ
hN7oh^;R00CohN7Q0OoTi>@1onWYj@7okNg]00000oo`l?3okno_oo7al@03
oo3`l02Vono_koo`l?3ok^k^onWYjOoKfm_o`L71ojBTY?n<S8coNg]kogMg
MomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7aono_kooalO7okno_
oo7akoo_knoolO7aong]kOoZj^[of][Jol;2`_nTY:CoS8b;og]kNomgMgOo
Ng]kohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo7alOo_knoolO7aono_kooa
lO7okno_oo7akoo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<S?mkNg_oMgMfog]k
Non<S8coY:BTol;2`_oJf][oj^[Zong]kOoalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo3`kP;ok>c/
00Oojn_[onk^k_o/k>cokNg]onc/k?o^k^coj^[Z00;ojn_[00[ok^k^onWY
jOoXj>Soi^KVonWYiooVi^Koj^[Zon_[joo]kNgoj>SX0_oYjNT05_o]kN_o
j^[Zonc/k?o/k>cokno_on[Zj_oXj>Sohn?Son?ShOoOgmoohn?SonSXj?o]
kNgoj^[Zon_[joo/k>col?3^ono_koo`l?3okNg]onc/k?oZj^X2onk^kP06
ono_kOoZj^[ojNWYonKVi_oXj>SoinOW0_oYjNT01_o/k>[ojNWYonc/k?o]
kNgok^k^on[ZjP;ok>c/00[ok^k/on[Zj_o/k>cok>c/ono_koo[jn_ojNWY
onKVi_oXj>Koj>SX0_o]kNd0ZOo`l?3okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_
kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_
ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_
knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7a
lOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooa
lO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_
kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_
knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7a
lOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aoo3`l?o_knool?3`
ono_koo`l?3okno_oo3`l?o_knl01?o`l?000003oo;bl_o^k^koinOW00Co
iNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5
oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@00ooUiNGoi>CTonGUi002
onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5A
DOmVIVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT07koiNGUonCTi?oUiNGoi>CT
onCThooNg]kodM7Aok6a/On:RX[oIVIVoe5ADOm5ADGo@T92odE5AOmADE7o
IVIVohZ:R_na/K7odM7AomkNg_oTi>?oi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTon?Sh_oNg]h2om_Kf`0:
omkNg_oLg=cofm_KomcLg?oOgmkofm_KomWIfOoLg=cogMgMomOGe`;oeMGE
00?oeMGDomCDe?oIfMT00_oMgMd2omOGe`0Bom_KfooMgMcof][Jom[Jf_oN
g]kohN7Qom_KfooHf=SoATI6oc0`<?mhN7So`/;2om[Jf_oNg]kof][JomWI
fOoMgMgohn?R0_oTi>@04?oOgmoog=cLomWIfOoOgmooh^;Ron7Qh?oKfm_o
e]KFomCDe?oFe]Koe=CDomKFe_oKfm_og=cKomSHf?oLg=`2omoOg`04omWI
fOoKfm_og]kNomoOgP;of][J00WogMgMon3Ph?oKfm_oemOGomGEeOoGemKo
fMWIomoOgooRh^800_oTi>@0X?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CT
onGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oU
iNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGU
onCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>Co
iNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>@4onGUi@06onCTi?oUiNGo
iNGUonGUiOoXj>SokNg]0Oobl_800003ooCdm?o]kNgoinOW00;oh>3P01?o
hN7QomoOgooNg]kod];BokBd]?n7QhOoG5aLofdk=OnNCT;ocFmOonV3Koo=
KeooWTi3ofdk=_mLG5coQhN7okBd]?oBd];og]kN00Goh>3P017og]kNom;B
d_nd];CoQhN7oeaLG?m]H2coWYH^olg=?ooYjDgocLdooijJ;om]HbgoG5aL
ohN7Qond];Cod];BomkNgP05on3Ph00AomkNg_oBd];o];BdohN7QomLG5co
AfL^ofRN<onAcDOoZ^UEoi7=AomZWSCoBFX_oeaLG?n7QhOo];Bdom;Bd_oN
g]h0IooPh>00@ooNg]kof=SHom;Bd_oDe=Coe]KFom;Bd_o?clood];BomKF
e_oCdm?odM7AomGEeOoFe]Kod=3@olC4a?o;bl_oclo?olW9bOo4a<Cof=SH
omGEeOo@d=3oa<C4om3@d?oHf=Sod];Bom7AdOoHf=Sofm_KomKFe_oAdM7o
UIFEoj2PX?ln?SkoBd];omCDe?oHf=Sod];Bom7AdOoHf=Sog]kNon3Ph?oO
gmoof][Jom?CdooAdM7of=SHomgMgOoJf][odm?Colo?coo0`<3od=3@olg=
cOno_kooe=CDomKFe_oAdM7oe=CDomWIfOoHf=SodM7Aom;Bd_oHf=SofMWI
om?CdooAdM400_oGemL02?oAdM7oclo?olS8b?o4a<Cof=SHom_KfooNg]ko
gmoOX?oPh>000ooOgmooh>3PomoOg`02omoOg`?oh>3P00?ohN7QonOWioo/
k>`00Oodm?@00003ooKfm_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgo
WinOof]OGon?=RkokG5QooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[
GeooWinOolg=cOoRh^;oinOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOofiV
GonCLR;okM54ooWcM?omoHgooOfEoogmS_oin7KokMM7oi=c8_m^IeooWinO
olg=cOoRh^;oinOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOof1XGom;O2?o
T^5;okgiNoo@oI;of?fKomCmUOo0nGkoV>Q=odf09?mPJEooWinOolg=cOoR
h^;oinOW06Koj>SX02Woi^KVomoOgol`<33oShn?om_Kfoo7alOoR8R8olG5
aOoKfm_oYJFUo`410OoMgMgog]kNofe]KOl820So4A4Aog=cLol`<33o92@T
omgMgOoKfm_oBd];o``<3?mRHV;ohN7Qofe]KOlj>S[ogmoOon?Shoo3`l?o
0000ol71`OoQhN7oX:2Po`d=3OoGemOog]kNogemOOlG5aOogMgMonCTi002
onKViP0Don;Rh_moOgoo:2PXomoOgooUiNGohn?SokJf]_lO7aoo2@T9ocHf
=_mdM7Co20P8oiJFU_oMgMgo3`l?oiNGUooQhN7ogmoOod92@_mTI6@2on3P
h00<ogEeMOlb<S;ogMgMom_Kfonn_[ko?3`lo`820_lO7aoo5ADEokBd]?oV
i^KoinOW>?oXj>P00ooWinOoj>SXonSXj01^onSXj07ok>c/0Oobl_81ooKf
mP0000?omoOgooShn?ohn?P00oohn?P04oogmoOok^k^olk>c_n@T93oQBl[
onUTE_okTXOooZJKoojaYOoo^:_oo[>VoojXW?okU8WokVQIohTa:on@T93o
c/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93oVFT[oo2m?Ook
h6koo_B2ooknR_oooi;oo_j<ookhPookiG3ol<8noiUZ:on@T93oc/k>onk^
k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93o@W<[ohC>@on]kg?o`_j8
olknT?oFoiOod?jBolKnROnbmGCoR==3odAe:on@T93oc/k>onk^k_ogmoL0
I_ohn?P0;oofm_Kokno_oc<c<onIVIWoinOWoh>3Pol0003oO7alonSXj?n`
/;3o0@41ong]kOoShn?o1PH6oj:RX_oMgMgoMgMgo`000?o>c/kol?3`ol;2
`_l0003odM7AooCdm?oalO7oMGEeochn?_o^k^kol_;bom3@d?l0003oclo?
oo7alOo8b<So0000ol?3`oo^k^koQXJ6oaTI6OoYjNWokno_oo;bl_odm?Co
lO7aohR8R?l[:b_ok^k^00;omOGe01coI6AToclo?ooUiNGo/k>coalO7omW
IfOokno_ong]kOl@413oXZ:Roo3`l?o_knooAdM7of][Joo_knool?3`ogin
O_le=CGojn_[onSXj?lg=cOoA4A4olk>c_oWinOogMgMonCTi?oemOGomoOg
X_ohn?P00oogmoOon?ShooShn002ooShn004ooOgmooinOWomoOgooOgm`7o
n?Sh00000oojn_[omOGeonk^kP02onc/k03oon_[jooYjNWogmoOokZj^_mi
DU;o_c8TonMdJOomRGkooiR<oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c
9?miDU;o^[ZjomoOgooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EB
on:A7?oi`e3ooMYSoooZL_onlgkoooZ2ookfOoook7?oo]iToo[7DOoRTQco
RFICokZj^_oOgmooj^[Zon_[joo/k>cojn_[on[Zj_oOgmoo^[Zjoe9]D_mA
XacoTM9EojKWJ_nhnG[o`?j2olOoROo3oXCo^OekojO/K?nDeUOoDZHLoe9]
D_nj^[[ogmoOon[Zj_o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?oYjN[ohn?Soc0`<?n@T93of=SHobd];Om0@43o
8b<Som[JfonVYZKo0@41on7QhOoShn?o410@ogalO?oOgmoo];Beo`000?oA
dM7oi>CToiRHV?l?3`ooh>3PonOWiooShnCoKfm_oc/k>ooOgmoohN7Qol?3
`ol0003oaLG5onCTiOno_koo0000okRh^?oQhN7oOgmooaLG5ooIfMWogMgN
on7QhOoUiNGoi>CToh61POlX:2SogmoOonKVi_oXj>WoM7AdoalO7ooIfMWo
g=cLoc/k>om_Kfooi>CTon3PhOl?3`ooV9RHon7QhOoOgmoo@d=3ofEUIOoP
h>3oh>3QogMgMolb<S;oh>3PokRh^?l0003oZ:RXomcLg?oIfM[ofm_Kon7Q
hOoYjNWoj^[Zonc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
on_[joo/k>cojn_/002Conc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>co
jn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/
k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_o
k>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[
jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>co
jn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/
k>cojn_/onc/k?o[jn_ok>c/00Oojn_[00Gok>c/on_[joo[jn_ok^k^ooKf
mP01ooWin@0000?ono_koo?cloo]kNd00_oUiND0k?oVi^Koi>CTomWIfOnb
/[;oNBh^olQ2=?oSJUcom7Y]oof8O?onUh[ooY^>oojHRoonRWkom7]]onM[
GOo:@SCoNbh^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGVonCTi?oHf=So/[:b
oiIE;_oZW2_onka4ook<Doomf6;oo^=bookYMOoniW?oo]]Uoog<Dook`DGo
kYh[oiUF;_nb/[;of=SHonCTi?oUiNGoi^KVonGUiOoTi>Cof=SIok:b/_l^
HRkoHjd[ohO:B?nGg5WoYNEYok;cMonhmW_o]?EiojOZJonHg5WoRLm;of>^
:ol^Hbko/[:bomSHfOoTi>CoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^Kohn?TomgMgOl_;booRh^;ok6a/Ol0003o
]kNgobDU9OnXZ:WoX:2Po`410OoLg=coh>3Pok:b/_li>CWo9BDUoc/k??l0
003ocLg=omgMgOnCTi?o410@omKFe_oNg]kog=cMofa/K?li>CWoe=CDomKF
e_nl_;co0000ol;2`_oOgn3o^k^ko`000?nd];Cog=cLogalO?lG5aOoe]KF
om[JfooNg]koh>3PomoOgommOGgo9bLWomGEeOoLg=cog]kOom_KfomTI6Co
820Poc`l??lC4a?oKFe]on3Ph?oLg=co3`l?oi>CTooGemOoeMGEod51@OmR
HV;oemOGomKFeomcLg?o<C4aomgMgOnJVY[o00001?lg=cL0Xonb/[;oi>CT
onCTi?oVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGo
i^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oV
i^KoiNGUonKVi_oUiND00_oVi^H00ooUiNGoi^KVonKViP03onKViP03onGU
iOo]kNgom?Cd007ono_k00000oolo?con?Shoo7al@03onk^kP0Con_[jooQ
hN7o_;blogXG5oo3?c;odeI9onAXF_o_Mfcom8=iooR7O?oeQ7[olgU]onEY
FooIF4[oa3lbog`G5onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;bl
ojE75ooVUc;omJ``oofl@OombE?ooM1Poo_CIOomdV3oo/eDoofm@_oj[c;o
jI/bojE65onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;bloaMI5omO
Z3;oM[dgohK=AonFeU[oX^1Uoj?PJOnShFOoUmYLohK>Aomg_cOoGj/boaMI
5onl_;cohN7Qonc/k01Vonk^kP0Wonc/k?oUiNGo<C4aohn?Som^KVko;2`/
onSXj?mmOGgoGUiNojBTY?l10@7ohn?SonWYjOoVi^Koh^;Ron3Ph?n][Jgo
0000omOGeooTi>CoV9RHoa0@4?oMgMgohn?SonCTi?m`L73o92@TomKFe_oO
gmoo_knoo`000?o;bl_ojNWYol71`Ol0003o^[ZjonCTi?n1PH7o1PH600?o
?Shn02;obl_;onWYjOn4Q8Co6QXJom[Jf_oRh^;oiNGUonOWiooShn?oh>3P
omSHf?lg=cOoLW9bon[Zj_oWinOo3`l?ohZ:R_oOgmoog]kNod=3@omFEUKo
h>3PomoOgomgMgOo<c<conWYjOnn_[ko0000oj2PX?nf][KoZZZZo`820_oI
fMWokNg]>?o^k^h00oo]kNgok^k^onk^kP1^onk^kP03ong]kOobl_;on?Sh
007oo?cl0003oogmo@0Fooclo?omoOgooOgmooclo?oclo?odM7AofP71onh
=3Coaclcom9@@ooJHUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/7
1ooBd];olo?cooclo0?ooOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWo
mJPYooRd?ooi_D[on;m=ooZoB_oi^3oomZXZonnN6OoKRcCoXRd7om;Bd_oc
lo?oo?cl00?ooOgm01?oo?cloo?clooBd];o1d07odfJ=?mOZb3oL;P_ogo3
@on:cE3oSLeBoh[>D?n1adCoLKT_of:^8?m>VcCo1d87om;Bd_oclo?oo?cl
06KooOgm04cono_kooCdm?ld=3CoUiNGoalO7on7QhOon_[jomgMgOlC4a?o
ZJVYo`410Oobl_;onOWiol30`?o4a<Colo?cohb<S?lQ8B7on_[jooGemOnM
WIgo410@onKVi_o^k^kom?CdogQhN?lA4A7oC4a<ol[:b_n9RHWo51@DooKf
m_oinOWoc/k>o`000?o6a/Kolo?cohV9ROlC4a?o][JfokVi^Onj^[[okNg]
ooWinOn?Shoo30`<oeMGEooAdM7okNg]onc/k?nVYZKoi^KVonCTi?lB4Q;o
[Jf]oo_knoojn_[o410@oahN7_nUYJGog=cLoaXJ6_lP823oOGemomkNg_m7
AdOoGemOoo_knoojn_[o=3@dog5aLOo^k^koSXj>ocDe=Ookno_oo?clYoom
oOd00oolo?cooOgmooclo003oogmo@0003[ooOgmoo[jn_oclo?ok^k^oo3`
l?o_knook^k^onWYjOoCdm?oFadMoj8d=?nd:1go`CX]olM9??o?ET[od5M;
om1GB_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knoo
l?3_onk^k_oZj^[odm?Coh`U7Oo8LCCofH@MonBD5OoWWBCokZPcoo2Z=?o_
ZS?ok:0UonNG5OoLR1gob74doh`U7OoCdm?oj^[Zonk^k_o`l?3okno_oo3`
l?o^k^koj^[Yom?CdolM>1go=88dodNE7OmJYA_oJJdZ0_md^3P0^Ome^CSo
Jk4[oe^W7?m8VQgo=88doadh7OoCdm?oj^[Yonk^k_o`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`
koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_
ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo^k^goinOWoc4a
<OmOGeoo0@41om;Bd_o^k^kok>c/od51@?mQHF7o0@41onKVi_o^k^koX:2P
ocTi>OlA4A7o9RHVoiRHV?o_knooaLG5oa0@4?l10@7o6ATIoe9BD_oYjNSo
LG5aocdm?OnGUiOo7alOoaPH6?nATI7ok^k^ong]k?o3`l?o0000okbl_?oX
j>SoPX:2oaPH6?oOgmooh^;Qon?ShooWinOojn_[oi>CTolo?cooTY:BoaLG
5onDU9?oh>3Podm?ColO7aoo4A4Aodm?CooXj>Sok^k^ono_k_lW9bOoX:2P
odi>C_l92@Wo=SHfon3Ph?m^KVko3`l>ob`/;?nn_[kok^k^ono_kooBd];o
?3`lo`/;2olM7Ago/[:b00;okno_0:;ol?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`
l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_
oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3ok^k^oo3`l?o_knool?3_ono_
koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`
ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_
knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`
l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_
oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_
koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knl2oo3`
l0Kokno_0Ooclo<1ooWin@7oo_kn00000oono_komoOgoo3`l004onWYj@0A
onOWiooKfm_oHd];oh4b<_nV=CGo]S@]ol9=@Oo3E4Woa5E:ol=DBOo2CD7o
]S@]ojDe=On1<S;oHd];om_KfooWinL01OoYjNT04OoWinOofm_KohU;Bon_
Bc;ocGLeomJ;;OoPW2koh:0bon6P=?oPX3;ogiX^omJ;;Oo:MCGo[d/bohU;
BooKfm_oinOW00GojNWY017oinOWom_Kfom;Bd_o<V0bocZ9=OmCVbgoJj/_
og2]>?m_[S[oL:dhofZZ;omCVbgo>HPeoc9P<_m;Bd_ofm_KonOWi`1WonWY
j@0=onSXj?oTi>Co<30`oa8B4_ll?3coi^KVonSXj?oWinOoTi>Coa4A4Ol1
0@7ohn?SonOWi`02onWYj@03onOWiooYjNWojNWY00;oj>SX01CoWIfMoa0@
4?oWinOoinOWonCTi?m_Kfoo>c/kon?ShooWinOoj>SXonWYjOoXj>SoinOW
ol;2`_l0003o^[ZjonCTi?n0P83o5aLGomgMg@;og]kN00?ohN7QonKVi_oX
j>P00_oYjNT00ooXj>SoinOWonWYj@02onWYj@03onOWiooYjNWojNWY00Go
jNWY00Goj>SXonWYjOoYjNWojNWYonOWi`06onWYj@03onKVi_oYjNWojNWY
0:GojNWY00?oj>SXonWYjOoYjNT01?oYjNT1oo3`l07omoOg0Oono_h00005
ookno_ojn_[om?Cdono_kooalO400_o`l?004Oo_knoojn_[oiFDU?m?8b?o
UEADok]cLooCUIGofYbLomZNW?oIW9coe9FEok]cLonEE5CoCb<SoiFDU?oZ
j^[okno_00Gol?3`017okno_on[Zj_nYU9CoPB<SokYZE?oDVW?oi;bEon[7
W?oYaicoj/NLonFlUOoDVW?o^fYDoh4S8onZU9Coj^[Zono_k`05oo3`l00A
ono_kooZj^[oU9BDob<Z8omDNUCoLjEcoik6UOn/cYco[LjLojc>W?nNaYGo
LjEcoeAjE?lS:R?oU9BDon[Zj_o_knl0Ioo`l?001Oo_knook^k^oc8b<_l0
003oTi>C00?okno_00Goi>CTo`/;2ol10@7ok^k^ono_k`07oo3`l009on?S
hono_kookno_ono_koo^k^koM7Adocdm?Oo]kNgokno_00?ol?3`00Ookno_
ol[:b_l0003o`l?3onk^k_n6QXKo2@T900?oGUiN00?oNGUionk^k_o_knl0
F?o`l?000oo_knool?3`oo3`l01/oo3`l004oo7alOo`l?3om?Cdoo[jnP7o
o_kn00001?o]kNgoooooooooooono_h2ooooo`;oo_kn0;oooOgmooShn?m^
KVkoFSlook6@T?oNbLWol>CToo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooSh
n?olo?coooooookno_ooooooo_knooooo_ono_koooooooclo?ohn?SoSFe]
ohXo?oo9TI3ojM39ooCYi?ofjnKom>WTonW@bOo9TI3oRCloohe]KOohn?Oo
o?clooooooono_koooooookno_ooooooo_knooooo_olo?con?Shofe]KOlo
?cooT9f@olWEbOoTk>Coi^kVonC/i?o9eLWoT9f@oclo?om]KFgon?Shoocl
o?ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_on
o_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knoooo
ooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_omoOgo[jn_oiRHV?oalO7ooOgmooooooono_ko
o_kmokBd]?nJVY[ooOgmooooooono_koooooookno_ooookoo_knooooooon
o_koooooookno_oooooooOgmooknoOmlO7co@D51oogmo@02ooknoP3Boooo
ooono_koo_kmonk^k_nIVIWojn_[ookno_oAdM7oVIVIoiRHV?nIVISoV9RH
ojb/[?omoOgoooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooon
o_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_kn0_ooool00oono_kooooooooo
o`04ooooo`0000Colo?cookno_ojn_[om?Cd1OoalO403Oo_knooe]KFof][
Jom3?CgoVhb<olJj^_oFc<coakZjoi^<S?m3?CgoJf][omKFe_o_knl02Ooa
lO403Oo_knooemKFoh=[Jomd?Cgo]Hb<omFj^_oQc<coe[ZjokJ<S?mb?Cgo
PF][omOFe_o_knl02OoalO403Oo_knooe]KFof][Jolm?CgoS8b<okZj^_o<
cLco^[Zjohb<S?lm?CgoJf][omKFe_o_knl0P_oalO400oo^k^kokNg]oo7a
l@1Yoo7al@03oo3`l?oalO7olO7a06GolO7a00Col?3`oo7alOoalO7ol?3`
1?oalO400oodm?Con_[jooknoP01oo[jnP0000Goj>SXoogmoOohn?Sol?3`
on_[j`03on[ZjP0=onWYjOoZj^[ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo
9RHVoeUIFOnKVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoX9^KofYIFOm3
9RKo;@T9od8V9_mYFEWoX9^KonSXj?oYjNT02ooZj^X02ooYjNWoj>SXoi^K
VomIFEWo9RHVo`T92OlV9RKoFEUIoi^KVooXj>SojNWY0?ooj^[ZGooZj^X0
1?o[jn_ol?3`ooShn?omoOd1onOWi`0000Co]KFeooKfm_ojn_[om?Cd2?oa
lO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`
l?03ono_k`;ol?3`l?oalO400oo`l?3olO7aoo7al@1Yoo7al@03oo3`l?oa
lO7olO7a00;olO7a00?omOGeoo[jn_ohn?P00Onk^k/000;o_kno00?omoOg
ooooooooool0oooooonNooooo`7ocLg=0OoDe=@00006om[Jf_no_koo][Jf
onOWioohn?SooOgmoooooonIooooo`05oogmoOojn_[ojn_[ok^k^oo6a/H0
0OoRh^800001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{420, 385},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
To respond to the tree selection, MathSwingTreeSelectionListener \
was defined.\
\>", "Text"],

Cell[TextData[StyleBox["package JLinkProgramming.JavaSwing;\n\nimport \
com.wolfram.jlink.*;\nimport javax.swing.event.*;\n\npublic class \
MathSwingTreeSelectionListener extends MathListener implements \
TreeSelectionListener {\n\n\tpublic MathSwingTreeSelectionListener() {\n\t\t\
super();\n\t}\n\n\tpublic MathSwingTreeSelectionListener(KernelLink ml) {\n\t\
\tsuper(ml);\n\t}\n\n\tpublic MathSwingTreeSelectionListener(String func) {\n\
\t\tthis();\n\t\tsetHandler(\"valueChanged\", func);\n\t}\n\n\tpublic void \
valueChanged(TreeSelectionEvent e) {\n\t\tExpr result = \
callMathHandler(\"valueChanged\", new Object[]{e});\n\t\tif (result != null)\n\
\t\t\tresult.dispose();\n\t}\n}",
  FontFamily->"Courier New",
  Background->GrayLevel[0.900008]]], "Text",
  Background->GrayLevel[0.900008]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleJTree",
        ButtonData:>{"SimpleJTree.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SimpleJTree[]\)], "Input"],

Cell[BoxData[
    \("Not Leaf:MacOS X"\)], "Print"],

Cell[BoxData[
    \("Leaf:QuickTime"\)], "Print"],

Cell[BoxData[
    \("Leaf:PowerMac"\)], "Print"],

Cell[BoxData[
    \("Not Leaf:Apple"\)], "Print"],

Cell[BoxData[
    \("Leaf:Java"\)], "Print"],

Cell[BoxData[
    \("Not Leaf:MacOS X"\)], "Print"],

Cell[BoxData[
    \("Leaf:QuickTime"\)], "Print"],

Cell[BoxData[
    \("Not Leaf:MacOS X"\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.JProgressBar <<< from J/Link \
Examples",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004/0000KQP00`40o`00
0?l0003oo`0002d000000003R<2hB928B9280?m8T8PYB9280@00000000>8
`;S8h=R8`;P0ohS0^2R8`;P1B9280@00000000>8`;S8h=R8`;P0olc<c2O<
c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`Wc<c<0HS0^058T8P1
000000000hS0^<SPf8S0^03oc<c<9lc<c068`;P1B9280@00000000>8`;S8
h=R8`;P0olc<c2O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`W
c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<9lc<c068`;P1B928
0@00000000>8`;S8h=R8`;P0olc<c2O<c<`1R<2h0DR@R04000000003R<2h
b>3HR<2h0?o<c<`Wc<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<
9lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c2O<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h0?o<c<`Wc<c<0HS0^058T8P1000000000hS0
^<SPf8S0^03oc<c<9lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<
c2O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`Wc<c<0HS0^058
T8P1000000000hS0^<SPf8S0^03oc<c<9lc<c068`;P1B9280@00000000>8
`;S8h=R8`;P05<c<c?mVIVH5IVIV3/c<c068`;P1B9280@00000000>8`;S8
h=R8`;P05<c<c003IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<c<c<c<`03<c<
c068`;P1B9280@00000000>8`;S8h=R8`;P05<c<c003IVIVIVJIVIW<09VI
VLaWc<c<00=VIVK<c<c<c<`03<c<c068`;P1B9280@00000000>8`;S8h=R8
`;P05<c<c003IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<c<c<c<`03<c<c068
`;P1B9280@00000000>8`;S8h=R8`;P05<c<c003IVIVIVJIVIW<09VIVLaW
c<c<00=VIVK<c<c<c<`03<c<c068`;P1B9280@00000000>8`;S8h=R8`;P0
5<c<c003IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<c<c<c<`03<c<c068`;P1
B9280@00000000>8`;S8h=R8`;P05<c<c003IVIVIVJIVIW<09VIVLaWc<c<
00=VIVK<c<c<c<`03<c<c068`;P1B9280@00000000>8`;S8h=R8`;P05<c<
c003IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<c<c<c<`03<c<c068`;P1B928
0@00000000>8`;S8h=R8`;P05<c<c003IVIVIVJIVIW<09VIVLaWc<c<00=V
IVK<c<c<c<`03<c<c068`;P1B9280@00000000>8`;S8h=R8`;P05<c<c003
IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<c<c<c<`03<c<c068`;P1B9280@00
000000>8`;S8h=R8`;P05<c<c003IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<
c<c<c<`03<c<c068`;P1B9280@00000000>8`;S8h=R8`;P05<c<c003IVIV
IVJIVIW<09VIVLaWc<c<00=VIVK<c<c<c<`03<c<c068`;P1B9280@000000
00>8`;S8h=R8`;P05<c<c003IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<c<c<
c<`03<c<c068`;P1B9280@00000000>8`;S8h=R8`;P05<c<c003IVIVIVJI
VIW<09VIVLaWc<c<00=VIVK<c<c<c<`03<c<c068`;P1B9280@00000000>8
`;S8h=R8`;P05<c<c003IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<c<c<c<`0
3<c<c068`;P1B9280@00000000>8`;S8h=R8`;P05<c<c003IVIVIVJIVIW<
09VIVLaWc<c<00=VIVK<c<c<c<`03<c<c068`;P1B9280@00000000>8`;S8
h=R8`;P05<c<c003IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<c<c<c<`03<c<
c068`;P1B9280@00000000>8`;S8h=R8`;P05<c<c003IVIVIVJIVIW<09VI
VLaWc<c<00=VIVK<c<c<c<`03<c<c068`;P1B9280@00000000>8`;S8h=R8
`;P05<c<c003IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<c<c<c<`03<c<c068
`;P1B9280@00000000>8`;S8h=R8`;P05<c<c003IVIVIVJIVIW<09VIVLaW
c<c<00=VIVK<c<c<c<`03<c<c068`;P1B9280@00000000>8`;S8h=R8`;P0
5<c<c003IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<c<c<c<`03<c<c068`;P1
B9280@00000000>8`;S8h=R8`;P05<c<c003IVIVIVJIVIW<09VIVLaWc<c<
00=VIVK<c<c<c<`03<c<c068`;P1B9280@00000000>8`;S8h=R8`;P05<c<
c003IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<c<c<c<`03<c<c068`;P1B928
0@00000000>8`;S8h=R8`;P05<c<c003IVIVIVJIVIW<09VIVLaWc<c<00=V
IVK<c<c<c<`03<c<c068`;P1B9280@00000000>8`;S8h=R8`;P05<c<c003
IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<c<c<c<`03<c<c068`;P1B9280@00
000000>8`;S8h=R8`;P05<c<c003IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<
c<c<c<`03<c<c068`;P1B9280@00000000>8`;S8h=R8`;P05<c<c003IVIV
IVJIVIW<09VIVLaWc<c<00=VIVK<c<c<c<`03<c<c068`;P1B9280@000000
00>8`;S8h=R8`;P05<c<c003IVIVIVJIVIW<09VIVLaWc<c<00=VIVK<c<c<
c<`03<c<c068`;P1B9280@00000000>8`;S8h=R8`;P05<c<c003IVIVIVJI
IVJI09UVIYUWVIVI00=VIVK<c<c<c<`03<c<c068`;P1B9280@00000000>8
`;S8h=R8`;P05<c<c?mVIVH5IVIV3/c<c068`;P1B9280@00000000>8`;S8
h=R8`;P0olc<c2O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`W
c<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<9lc<c068`;P1B928
0@00000000>8`;S8h=R8`;P0olc<c2O<c<`1R<2h0DR@R04000000003R<2h
b>3HR<2h0?o<c<`Wc<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<
9lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c2O<c<`1R<2h0DR@
R04000000003R<2hb>3HR<2h0?o<c<`Wc<c<0HS0^058T8P1000000000hS0
^<SPf8S0^03oc<c<9lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<
c2O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`Wc<c<0HS0^058
T8P1000000000hS0^<SPf8S0^03oc<c<9lc<c068`;P1B9280@00000000>8
`;S8h=R8`;P0olc<c2O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h05g<
c<`20000alc<c068`;P1B9280@00000000>8`;S8h=R8`;P0GLc<c0800037
c<c<0HS0^058T8P1000000000hS0^<SPf8S0^00Dc<c<0P0000O<c<`40000
0/c<c0800004c<c<100000?<c<`400000/c<c0800002c<c<0P0000;<c<`2
00001Lc<c0@00003c<c<100000;<c<`200000/c<c0800002c<c<0P000004
c<c<00000000c<c<0P0000;<c<`200000/c<c0@00003c<c<0P0000;<c<`4
00000/c<c080002[c<c<0HS0^058T8P1000000000hS0^<SPf8S0^00Dc<c<
0P0000K<c<`200000/c<c08000000lc<c00000000003c<c<0P0000;<c<`2
000000?<c<`0000000000/c<c08000000lc<c00000000002c<c<0P000003
c<c<0000000000G<c<`200000/c<c08000000lc<c00000000002c<c<0P00
0003c<c<0000000000;<c<`200000/c<c08000001Lc<c000000000000<c<
c002000000C<c<`00000003<c<`200000/c<c08000000lc<c00000000002
c<c<0P0000;<c<`2000000?<c<`000000000Zlc<c068`;P1B9280@000000
00>8`;S8h=R8`;P05<c<c0800006c<c<0P0000G<c<`200000lc<c0800005
c<c<0P0000G<c<`200000/c<c08000000lc<c00000000005c<c<0P0000G<
c<`200000/c<c08000000lc<c00000000002c<c<0P0000;<c<`2000000?<
c<`0000000000/c<c08000001<c<c00000000<c<c0800005c<c<0P0000;<
c<`20000//c<c068`;P1B9280@00000000>8`;S8h=R8`;P05<c<c0H00002
c<c<1P000003c<c<0000000000?<c<`200001Lc<c0H000000lc<c0000000
0002c<c<0P000003c<c<0000000000G<c<`200001Lc<c0800002c<c<0P00
0003c<c<0000000000;<c<`200000/c<c08000000lc<c00000000002c<c<
0P000004c<c<00000000c<c<1P000003c<c<0000000000;<c<`60000[/c<
c068`;P1B9280@00000000>8`;S8h=R8`;P05<c<c0800003c<c<0P000003
c<c<0000000000;<c<`2000000?<c<`0000000000lc<c0800005c<c<0P00
00;<c<`2000000?<c<`0000000000/c<c08000000lc<c00000000005c<c<
0P0000G<c<`200000/c<c08000000lc<c00000000002c<c<0P0000;<c<`2
000000?<c<`0000000000/c<c08000001<c<c00000000<c<c0800002c<c<
0P000003c<c<0000000000;<c<`200000/c<c080002^c<c<0HS0^058T8P1
000000000hS0^<SPf8S0^00Dc<c<0P0000?<c<`2000000?<c<`000000000
0/c<c08000000lc<c00000000003c<c<0P0000;<c<`2000000?<c<`00000
00000/c<c08000001Lc<c000000000000<c<c002000000?<c<`000000000
1Lc<c0800002c<c<0P0000;<c<`00`000<c<c<c<c002000000G<c<`00000
0000003<c<`00`000004c<c<00000000c<c<0`000004c<c<00000000c<c<
0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c0800002
c<c<0P000003c<c<000000000:_<c<`1R<2h0DR@R04000000003R<2hb>3H
R<2h01C<c<`200000lc<c0800002c<c<100000;<c<`400000/c<c0@00003
c<c<100000;<c<`2000000C<c<`00000003<c<`400001Lc<c0@00003c<c<
100000;<c<`2000000?<c<`0000000000/c<c0800002c<c<0P000003c<c<
0000000000;<c<`200000/c<c0@000000lc<c0000000000200000/c<c0@0
0002c<c<0P000:_<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h01C<c<`2
00000lc<c080000Rc<c<0P0002G<c<`200002<c<c080002fc<c<0HS0^058
T8P1000000000hS0^<SPf8S0^00Dc<c<1P0002C<c<`00`000<c<c<c<c00S
c<c<0P0000W<c<`00`000<c<c<c<c02dc<c<0HS0^058T8P1000000000hS0
^<SPf8S0^03oc<c<9lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<
c2O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`Wc<c<0HS0^058
T8P1000000000hS0^<SPf8S0^03oc<c<9lc<c068`;P1B9280@00000000>8
`;S8h=R8`;P0olc<c2O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<
c<`Wc<c<0HS0^058T8P1000000000hS0^<SPf8S0^03oc<c<9lc<c068`;P1
B9280@00000000>8`;S8h=R8`;P0olc<c2O<c<`1R<2h0DR@R04000000003
R<2hb>3HR<2h0?o<c<`Wc<c<0HS0^058T8P1000000000hS0^<SPf8S0^03o
c<c<9lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0olc<c2O<c<`1R<2h
0DR@R04000000003R<2hb>3HR<2h0?o<c<`Wc<c<0HS0^058T8P100000000
0hS0^<SPf8S0^03oc<c<9lc<c068`;P1B9280@00000000>8`;S8h=R8`;P0
olc<c2O<c<`1R<2h0DR@R04000000003R<2hb>3HR<2h0?o<c<`Wc<c<0HS0
^058T8P1000000000hS0^<SPf8S0^03oc<c<9lc<c068`;P1B9280@000000
00>8`;S8h=R8`;P0ohS0^2R8`;P1B9280@00000000>8`;S8h=R8`;P05000
P003006000:000>1008018402005PP06PP07PP48PP48P`49P`4:P`4;Q081
38@0104=Q04>Q@8?Q@8@Q@824HH00`8BQP8CQP8DQ`020QF700P35XP35hP3
68P36HP36HT36XT36hT378X20af:00@47XX47h/488/48H/212:<00<48h`4
98`49Hd00PDVS@0>1BN>1BR>1BV>1BZ>1BZ?1B^?1Bb?1Rf@1Rj@1Rn@1RnA
1S2A1S6A1S:A0PHcTP031cBB1cFC1cJC0087=i<00`LhU0LiU0LjU0021c^E
00T8?9D8?ID8?YH8?iH8@9H8@9L8@IL8@YL8@iL00PU4V0032DFH2DJI2DNI
0089B9T010U9VPU:VPY;VPY<V`8:CI/020Y>V`Y?W0Y@W0YAW0YAW@]BW@]C
W@]DW@8;EIh00`]FWP]GW`]HW`022eVO00@<FZ0<Fj0<G:0<GJ4235jQ00P<
Gj8<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ@23FJT00@=Ij@=J:D>JJD>JZD23V^V
00<>K:H>KJH>KZL00Pi_Y`083g2X3g6X3g:X3g>X3g>Y3gBY3gFY3gJZ0Pmg
ZP0447RZ47V[47Z[47^[0Q1l[00347f/47j/47n]008AP:d03Q61[Q62[Q63
[Q64[Q64[a65[a66[a:7/1:8/1:9/1:9/A::/A:;/A:</@8BSK800a>>/Q>?
/a>@/`024i6c00<CT[@CTk@CU;@00Q>E]@0959Je59Ne59Rf59Vf59Zf59Zg
59^g59bg59fg008EW[P00aFO^1FP^AFQ^@025J:i00@EXkXEY;XFYKXFY[/2
5ZNk00PFZ;/FZK`FZ[`FZk`FZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG
/klf6;C00HS0^058T8P1000000000hS0^<SPf8S0^004002000>KYo4c@jDc
@jD02C=3Y@@008000`01P002P003P@0200B100P01H801X801h81288128<1
2H<12X<12h@20@b400@13H@13XD23hD248D20Q6600<24XH24hH258L00P8E
Q`080aJ80aN80aR80aV80aV90aZ90a^90ab:0P<MRP0411j:11n;122;126;
0P@RS00312><12B<12F=00859Xd03PDWSPDXSPDYSPDZSPDZS`D[S`D/S`H]
T0H^T0H_T0H_T@H`T@HaT@HbT@86<i800`LdTPLeT`LfT`021cNC00<7>9@7
>I@7>Y@00PLkU@0923bE23fE23jF23nF242F242G246G24:G24>G0089A9P0
0`U5V0U6V@U7V@022DRI00@9BIX9BYX:BiX:C9/22TfK00P:CY/:Ci`:D9`:
DI`:DId;DYd;Did;E9d22eFN00<;EYh;Eil;F9l00P]IW`0435ZP35^P35bP
35fQ0PaNX@0835nR362R366R3F:R3F:S3F>S3FBS3FFT0PeVY0043FNT3FRU
3VVU3VZU0Pi[YP033VbV3VfV3VjW008>KjL020m`Z0maZ0mbZ0mcZ0mcZ@md
Z@meZ@mfZP8?MjX0111hZQ1iZa1jZa1kZ`8@O:`00a1m[11n[11o[@024H2]
00hAPJhAPZhAPjhAQ:hAQ:lAQJlAQZlBQk0BR;0BRK0BRK4BR[4BRk4BS;42
4Xfb00<CS[8CSk<CT;<00Q>A/`034i:d4i>d4iBd008CUKD02ABF]ABG]ABH
]QBI]QBJ]QBJ]aBK]aBL]aBM]`025Ijh00<EWkPEX;TEXKT00QFR^@045J>j
5JBj5ZFj5ZJk0QJW^`085ZRk5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm0QN__P04
5k2n5k6o5k:o5k>o=QRd`068`;P1B9280@00000000>8`;S8h=R8`;P00`00
P007VjOaooooSWZfYY_4/jWBZ9g8/jWB00:VVl@01KbhgNk^m>[YlOoooc=3
Y@03002000<00H000X000h400P04P@0800F200J200N20@R20@R30@V30@Z3
0@^40P4<Q0040@f40@j50Pn50Q250P8AQP030Q:60Q>60QB700825HL020<F
R0<GR0<HR0<IR0<IR@<JR@<KR@<LRP837HX010@NRP@OR`@PR`@QR`848X`0
0`@SS0@TS0@US@021BJ=00h59hh5:8h5:Hh5:Xh5:Xl5:hl5;8l6;I06;Y06
;i06;i46<946<I46<Y421S>B00<7=987=I<7=Y<00PLgT`031cRD1cVD1cZD
0087>iD02@PlU@PmU@PnUPPoUPQ0UPQ0U`Q1U`Q2U`Q3U`022DBH00<9AIP9
AYT9AiT00PU8V@042DVJ2DZJ2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M
2e:M2e>M2eBM0P]EWP032eJN2eNO2eRO008;FIl010aJX0aKX0aLX0aMX@8<
GZ4020aOXPaPXPaQXPeRXPeRX`eSX`eTX`eUY08=IZ@010eWY0eXY@iYY@iZ
Y@8>JjH00`i/YPi]YPi^Y`023VnW00P?L:P?LJP?LZP?LjP?LjT?M:T?MJT?
MZX23gNZ00@@N:X@NJ/@NZ/@Nj/247b/00<@OJ`@OZ`@Ojd00Q60[@0>4H6^
4H:^4H>^4HB^4HB_4HF_4HJ_4XN`4XR`4XV`4XVa4XZa4X^a4Xba0Q:=/P03
4hjb4hnc4i2c008CTK<00a>B]1>C]1>D]0024iFe00TDU[DDUkDDV;HDVKHD
V[HDV[LDVkLDW;LDWKL00QFN^0035Inh5J2i5J6i008EX[T011FS^QFT^QJU
^QJV^`8FYk/021JX^aJY_1JZ_1J[_1J[_AN/_AN]_AN^_@8G[kh011N`_QNa
_aNb_aNc_`8H]<0P00000QRd`10000026;C00HS0^058T8P1000000000hS0
^<SPf8S0^002002000BKYo7ooom/FZF_YLX2_;SM00[ooOncZM;ooooooonl
^=fGR[bXWLSVi^cooolc@jD2002000<00H000X000h400P04P@0800F200J2
00N20@R20@R30@V30@Z30@^40P4<Q0040@f40@j50Pn50Q250P8AQP030Q:6
0Q>6oooo00825HL020<FR0<GR0<HR0<IR0<IR@<JR@<KR@<LRP837HX010@N
RP@OR`@PR`@QR`848X`00`@SS0@TS0@US@021BJ=00h59hh5:8h5:Hh5:Xh5
:Xl5:hl5;8l6;I06;Y06;i06;i46<946<I46<Y421S>B00<7=987=I<7=Y<0
0PLgT`031cRD1cVD1cZD0087>iD02@PlU@PmU@PnUPPoUPQ0UPQ0U`Q1U`Q2
U`Q3U`022DBH00<9AIP9AYT9AiT00PU8V@042DVJ2DZJ2T^J2TbK0PY=V`08
2TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN2eNO2eRO008;FIl0
10aJX0aKX0aLX0aMX@8<GZ4020aOXPaPXPaQXPeRXPeRX`eSX`eTX`eUY08=
IZ@010eWY0eXY@iYY@iZY@8>JjH00`i/YPi]YPi^Y`023VnW00P?L:P?LJP?
LZP?LjP?LjT?M:T?MJT?MZX23gNZ00@@N:X@NJ/@NZ/@Nj/247b/00<@OJ`@
OZ`@Ojd00Q60[@0>4H6^4H:^4H>^4HB^4HB_4HF_4HJ_4XN`4XR`4XV`4XVa
4XZa4X^a4Xba0Q:=/P034hjb4hnc4i2c008CTK<00a>B]1>C]1>D]0024iFe
00TDU[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LDWKL00QFN^0035Inh5J2i5J6i
008EX[T011FS^QFT^QJU^QJV^`8FYk/021JX^aJY_1JZ_1J[_1J[_AN/_AN]
_AN^_@8G[kh011N`_QNa_aNb_aNc_`8H]<000lSPf4R@R4R@R00<B92800<0
0038h=Q8T8P03DR@R00400006;C06;C0b>3H3TR@R00500006;C06;C0R<2h
B928004000000003R<2hb>3HR<2h008008002i^WlOooojRMb?oook>YdV1<
VXij]WQU[ZRMb?ooooomo`03oooo00Lc@jD00800080008000H000X000h40
0P04P@0800F200J200N20@R20@R30@V30@Z30@^40P4<Q0040@f40@j50Pn5
0Q250P8AQP030Q:60Q>6oooo00825HL020<FR0<GR0<HR0<IR0<IR@<JR@<K
R@<LRP837HX010@NRP@OR`@PR`@QR`848X`00`@SS0@TS0@US@021BJ=00h5
9hh5:8h5:Hh5:Xh5:Xl5:hl5;8l6;I06;Y06;i06;i46<946<I46<Y421S>B
00<7=987=I<7=Y<00PLgT`031cRD1cVD1cZD0087>iD02@PlU@PmU@PnUPPo
UPQ0UPQ0U`Q1U`Q2U`Q3U`022DBH00<9AIP9AYWoool00_ooo`042DVJ2DZJ
2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN
2eNO2eRO008;FIl010aJX0aKX0aLX0aMX@8<GZ4020aOXPaPXPaQXPeRXPeR
X`eSX`eTX`eUY08=IZ@010eWY0eXY@iYY@iZY@8>JjH00`i/YPi]YPi^Y`02
3VnW00P?L:P?LJP?LZP?LjP?LjT?M:T?MJT?MZX23gNZ00@@N:X@NJ/@NZ/@
Nj/247b/00<@OJ`@OZ`@Ojd00Q60[@0>4H6^4H:^4H>^4HB^4HB_4HF_4HJ_
4XN`4XR`4XV`4XVa4XZa4X^a4Xba0Q:=/P034hjb4hnc4i2c008CTK<00a>B
]1>C]1>D]0024iFe00TDU[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LDWKL00QFN
^0035Inh5J2i5J6i008EX[T011FS^QFT^QJU^QJV^`8FYk/021JX^aJY_1JZ
_1J[_1J[_AN/_AN]_AN^_@8G[kh011N`_QNa_aNb_aNc_`8H]<000lSPf8S0
^8S0^00;R<2h00=8T8P00038h=P00hS0^0W8h=P00hS0^4R@R00000026;C0
00?8h=R8`;R8`;P02hS0^006B92800006;C06;C0R<2hB9280@00000000>8
`;S8h=R8`;P00P00P00>VjOaoooooooofmc/H4bJThFj/jWB_;SMH4bJVHnn
YY_4b<?Ooooo<d>U1000P003006000:0oooo00;oool01005PP06PP07PP48
PP?oool01`4;Q04<Q04<Q?ooo`4>Q@8?QOooo`020Q6600?oool24hKoool0
0oooo`030aN80aR80aV800;oool020<KROooo`<MRP<MRP@NR_ooo`@PR`@Q
R`Coool02@@US@DVS@DVSOooo`DXSPDYS_ooo`DZS`D[S`03oooo00X6;i06
;i7oool6<I46<Y46<i;oool7=987=I<7=Y<21cNC00<7>9Coool7>Y@00PLk
U@0723bE23fEoooo23nF242F242G246G00?oool010U4V0U5V?ooo`U7V@89
B9T01?ooo`U:V_ooo`Y<V`8:CI/01`Y>Voooooooooooo`YAW@]BW@]CW@03
oooo00<;EYh;Eil;F9l00oooo`0335^P35bP35fQ008<GZ4020aOXPaPXPaQ
XPeRXPeRX`eSX`eTX`eUY08=IZ@010eWY0eXY@iYY@iZY@8>JjH00`i/YPi]
YPi^Y`023VnW00P?L:P?LJP?LZP?LjP?LjT?M:T?MJT?MZX23gNZ00@@N:X@
NJ/@NZ/@Nj/247b/00<@OJ`@OZ`@Ojd00Q60[@0>4H6^4H:^4H>^4HB^4HB_
4HF_4HJ_4XN`4XR`4XV`4XVa4XZa4X^a4Xba0Q:=/P034hjb4hnc4i2c008C
TK<00a>B]1>C]1>D]0024iFe00TDU[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LD
WKL00QFN^0035Inh5J2i5J6i008EX[T011FS^QFT^QJU^QJV^`8FYk/021JX
^aJY_1JZ_1J[_1J[_AN/_AN]_AN^_@8G[kh011N`_QNa_aNb_aNc_`8H]<00
1<SPf8S0^8S0^8S0^0H00004R<2h00=8T8P00038h=P00XS0^0U8T8P01<SP
f8S0^4R@R000008H]<000lSPf8S0^8S0^00;R<2h00I8T8P0000H]<0H]<28
`;Q8T8P1000000000hS0^<SPf8S0^003002000jKYo7ooonl^=fISkkooooF
dMgKg>cco_nVVlC^k_B5M[2CQK[ooolc@jD3002000<00H3oool00h400P04
P@08oooo00J200N2oooo0@R30@V30@Z3oooo0P4<Q004oooo0@j50Pn5oooo
0P8AQP03oooo0Q>6oooo00825HL01P<FR?ooo`<HR?ooo`<IR@<JR@;oool2
0af:00Coool47h/488_oool212:<01P48hcoool49Hd59Xgoool59hh5:8h5
:Hkoool5:Xooool5;8l6;I06;Y3oool6;i7oool6<I46<Y46<i;oool7=987
=I<7=Y<21cNC00<7>9Coool7>Y@00PLkU@0<23bE23fEoooo23nF242F242G
oooo24:G24>G2DBHoooo2DFH1?ooo`042DVJ2DZJoooo2TbK0PY=V`08oooo
2TnL2U2L2U6Loooo2e:Moooo2eBM0P]EWP03oooo2eNOoooo008;FIl010aJ
X?ooo`aLX0aMX@8<GZ4020aOXPaPXPaQXPeRXPeRX`eSX`eTX`eUY08=IZ@0
10eWY0eXY@iYY@iZY@8>JjH00`i/YPi]YPi^Y`023VnW00P?L:P?LJP?LZP?
LjP?LjT?M:T?MJT?MZX23gNZ00@@N:X@NJ/@NZ/@Nj/247b/00<@OJ`@OZ`@
Ojd00Q60[@0>4H6^4H:^4H>^4HB^4HB_4HF_4HJ_4XN`4XR`4XV`4XVa4XZa
4X^a4Xba0Q:=/P034hjb4hnc4i2c008CTK<00a>B]1>C]1>D]0024iFe00TD
U[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LDWKL00QFN^0035Inh5J2i5J6i008E
X[T011FS^QFT^QJU^QJV^`8FYk/021JX^aJY_1JZ_1J[_1J[_AN/_AN]_AN^
_@8G[kh011N`_QNa_aNb_aNc_`8H]<001<SPf8S0^8S0^8S0^0H00004R<2h
00=8T8P00038h=P00XS0^003B928b>3HR<2h00F8`;P01DR@R<SPf8S0^4R@
R00000026;C000C8h=R8`;R8`;R8`;P2000018S0^0800002R<2h00I8T8P0
000H]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^003002000nKYo7ooonI
SkjGR[cDdnS_[;?oMW_^Wj]KF:FVVlBFWm9PC9Zl^=gooolc@jD00P00P003
oooo00:000>1008018402005P_ooo`07P_ooo`48P`49P`4:Poooo`8138@0
1?ooo`4>Q@8?QOooo`824HH00oooo`8CQ_ooo`020QF700P35XSoool368So
ool36HT36XT36hWoool20af:00Coool47h/488_oool212:<01P48hcoool4
9Hd59Xgoool59hh5:8h5:Hkoool5:Xooool5;8l6;I06;Y3oool6;i7oool6
<I46<Y46<i;oool7=987=I<7=Y<21cNC00<7>9Coool7>Y@00PLkU@0>23bE
23fEoooo23nF242F242Goooo24:G24>G2DBHoooo2DFHoooo2DNI0PU8V@04
2DVJ2DZJoooo2TbK0PY=V`08oooo2TnL2U2L2U6L2U6M2e:M2e>M2eBM0_oo
o`042eJN2eNO2eRO2eVO0_ooo`0335^P35bP35fQ008<GZ4020aOXPaPXPaQ
XPeRXPeRX`eSX`eTX`eUY08=IZ@010eWY0eXY@iYY@iZY@8>JjH00`i/YPi]
YPi^Y`023VnW00P?L:P?LJP?LZP?LjP?LjT?M:T?MJT?MZX23gNZ00@@N:X@
NJ/@NZ/@Nj/247b/00<@OJ`@OZ`@Ojd00Q60[@0>4H6^4H:^4H>^4HB^4HB_
4HF_4HJ_4XN`4XR`4XV`4XVa4XZa4X^a4Xba0Q:=/P034hjb4hnc4i2c008C
TK<00a>B]1>C]1>D]0024iFe00TDU[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LD
WKL00QFN^0035Inh5J2i5J6i008EX[T011FS^QFT^QJU^QJV^`8FYk/021JX
^aJY_1JZ_1J[_1J[_AN/_AN]_AN^_@8G[kh011N`_QNa_aNb_aNc_`8H]<00
0lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^003B928b>3HR<2h00F8
`;P01DR@R<SPf8S0^4R@R00000026;C000?8h=R8`;R8`;P00XS0^0800002
R<2h0P0000>8`;P01TR@R00001Rd`1Rd`8S0^4R@R04000000003R<2hb>3H
R<2h008008002Y^WlOoooiN:_7Y/Z[?7j:U^X<S3gi>5^U]6TiV?_P9hIJh0
148WQJnUb_oooc=3Y@8008000oooo`02P003P@0200B100P01H;oool01h;o
ool128<12H<12X?oool20@b400Coool13XD23hGoool20Q6600?oool24hKo
ool00P8EQ`080aJ8oooo0aR8oooo0aV90aZ90a^9oooo0P<MRP04oooo11n;
122;126;1?ooo`0F12F=1BJ=oooo1BN>1BR>1BV>oooo1BZ?oooo1Bb?1Rf@
1Rj@oooo1RnAoooo1S6A1S:A1S>Boooo1cBB1cFC1cJC0PLgT`031cRDoooo
1cZD0087>iD030PlU@PmUOooo`PoUPQ0UPQ0Uoooo`Q2U`Q3U`U4V?ooo`U5
V0Coool010U9VPU:V_ooo`Y<V`8:CI/5oooo00<;DYd;Digoool00P]EWP09
2eJN2eNO2eROoooo2eVO35ZP35^P35bP35fQ008<GZ4020aOXPaPXPaQXPeR
XPeRX`eSX`eTX`eUY08=IZ@010eWY0eXY@iYY@iZY@8>JjH00`i/YPi]YPi^
Y`023VnW00P?L:P?LJP?LZP?LjP?LjT?M:T?MJT?MZX23gNZ00@@N:X@NJ/@
NZ/@Nj/247b/00<@OJ`@OZ`@Ojd00Q60[@0>4H6^4H:^4H>^4HB^4HB_4HF_
4HJ_4XN`4XR`4XV`4XVa4XZa4X^a4Xba0Q:=/P034hjb4hnc4i2c008CTK<0
0a>B]1>C]1>D]0024iFe00TDU[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LDWKL0
0QFN^0035Inh5J2i5J6i008EX[T011FS^QFT^QJU^QJV^`8FYk/021JX^aJY
_1JZ_1J[_1J[_AN/_AN]_AN^_@8G[kh011N`_QNa_aNb_aNc_`8H]<000lSP
f8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^003B928b>3HR<2h00F8`;P0
1DR@R<SPf8S0^4R@R00000026;C000?8h=R8`;R8`;P00hS0^0@00004R<2h
00I8T8P0000H]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^002002000>K
Yo7oooooool00_ooo`0:ojf`ogIknLgDoNg^ooooYY_4QGJ`_;SMoooo<d>U
0`00P003oooo00:000>1008018402005PP06PP07P_ooo`48P`49P`4:Pooo
o`8138@2oooo00L23hGoooooool24HKoool24hKoool00P8EQ`080aJ8oooo
0aR8oooo0aV90aZ90a^9oooo0P<MRP04oooo11n;122;126;0P@RS00@12><
oooo12F=1BJ=oooo1BN>1BR>1BV>oooo1BZ?oooo1Bb?1Rf@1Rj@oooo1RnA
0_ooo`061S:A1S>Boooo1cBB1cFC1cJC0PLgT`031cRDoooooooo00;oool0
4PPlU@PmUOooooooo`Q0UPQ0Uoooo`Q2U`Q3U`U4V?ooo`U5V?ooo`U7V@U8
VOooo`U9VPU:VP;oool22TfK00Soool:Ci`:D9`:DIcoool;DYgoool;E9d2
2eFN00?oool;Eiooool00P]IW`0435ZPoooo35bP35fQ0PaNX@0835nR362R
366R3F:R3F:S3F>S3FBS3FFT0PeVY0043FNT3FRU3VVU3VZU0Pi[YP033VbV
3VfV3VjW008>KjL020m`Z0maZ0mbZ0mcZ0mcZ@mdZ@meZ@mfZP8?MjX0111h
ZQ1iZa1jZa1kZ`8@O:`00a1m[11n[11o[@024H2]00hAPJhAPZhAPjhAQ:hA
Q:lAQJlAQZlBQk0BR;0BRK0BRK4BR[4BRk4BS;424Xfb00<CS[8CSk<CT;<0
0Q>A/`034i:d4i>d4iBd008CUKD02ABF]ABG]ABH]QBI]QBJ]QBJ]aBK]aBL
]aBM]`025Ijh00<EWkPEX;TEXKT00QFR^@045J>j5JBj5ZFj5ZJk0QJW^`08
5ZRk5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm0QN__P045k2n5k6o5k:o5k>o0QRd
`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h00=8T8S8h=R8`;P0
1HS0^005B928b>3HR<2hB9280000008H]<000lSPf8S0^8S0^004R<2h0P00
00F8`;P01TR@R00001Rd`1Rd`8S0^4R@R04000000003R<2hb>3HR<2h00<0
08002Z6/l_W=e>8V??Be_n8V??A]OOcSjOoooog]k_n]/0;oool00c=3Y@00
P000P002002000?oool00X000h400P04P@0400F200J200N20@R20oooo`05
0@^40@b40@b4oooo0@j500;oool0108AQ_ooo`8BQP8CQPCoool020<GR0<H
R?ooo`<IR@<JR@<KROooo`<MRP?oool00`@PR`@QRoooo`02oooo00<498`4
9Hgoool00_ooo`051BR>1BV>oooo1BZ?1B^?00?oool010H_T0H_TOooo`Ha
T@;oool010HcTPLdTPLeT`LfT`87=i<00`LhU?ooo`LjU0021c^E00Ooool8
?IGoool8?iKoool8@9L8@IL00oooo`032DBH2DFH2DJI00Coool01PU:V_oo
o`Y<Voooo`Y=V`Y>V`?oool00`YAW@]BW@]CW@03oooo00<;EYh;Eil;F9l0
0oooo`0335^P35bP35fQ008<GZ4020aOXPaPXPaQXPeRXPeRX`eSX`eTX`eU
Y08=IZ@010eWY0eXY@iYY@iZY@8>JjH00`i/YPi]YPi^Y`023VnW00P?L:P?
LJP?LZP?LjP?LjT?M:T?MJT?MZX23gNZ00@@N:X@NJ/@NZ/@Nj/247b/00<@
OJ`@OZ`@Ojd00Q60[@0>4H6^4H:^4H>^4HB^4HB_4HF_4HJ_4XN`4XR`4XV`
4XVa4XZa4X^a4Xba0Q:=/P034hjb4hnc4i2c008CTK<00a>B]1>C]1>D]002
4iFe00TDU[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LDWKL00QFN^0035Inh5J2i
5J6i008EX[T011FS^QFT^QJU^QJV^`8FYk/021JX^aJY_1JZ_1J[_1J[_AN/
_AN]_AN^_@8G[kh011N`_QNa_aNb_aNc_`8H]<000lSPf8S0^8S0^00;R<2h
00=8T8P00038h=P00XS0^003B928b>3HR<2h00F8`;P01DR@R<SPf8S0^4R@
R00000026;C000?8h=R8`;R8`;P00hS0^0@00004R<2h00I8T8P0000H]<0H
]<28`;Q8T8P1000000000hS0^<SPf8S0^002002000fKYo7mkNkR9ScnmOSg
RIOdHVkcX:kdHVkooOoo[K3lhnWooolc@jD01@00P003oooo00:000>10080
18402005P_ooo`07PP48PP48P`49P`4:P`4;Q08138@0104=Q04>Q@8?Q@8@
Q@824HH00`8BQP8CQP8DQ`020QF700P35XP35hP368P36HP36HT36XT36hT3
78X20af:00Coool47h/488/48H/212:<01<48h`498`49Hd59Xgoool59hh5
:8h5:Hh5:Xh5:Xl5:hl5;8l6;I06;Y06;i06;i46<946<I46<Y400PHcTP03
1cBB1cFC1cJC0087=i<00`LhU?ooo`LjU0021c^E00Woool8?ID8?YH8?iH8
@9H8@9L8@IL8@YL8@iL00PU4V0032DFH2DJI2DNI0089B9T010U9VPU:VPY;
VPY<V`8:CI/020Y>V`Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@8;EIh00`]FWP]G
W`]HW`022eVO00@<FZ0<Fj0<G:0<GJ4235jQ00P<Gj8<H:8<HJ8=HZ8=HZ<=
Hj<=I:<=IJ@23FJT00@=Ij@=J:D>JJD>JZD23V^V00<>K:H>KJH>KZL00Pi_
Y`083g2X3g6X3g:X3g>X3g>Y3gBY3gFY3gJZ0PmgZP0447RZ47V[47Z[47^[
0Q1l[00347f/47j/47n]008AP:d03Q61[Q62[Q63[Q64[Q64[a65[a66[a:7
/1:8/1:9/1:9/A::/A:;/A:</@8BSK800a>>/Q>?/a>@/`024i6c00<CT[@C
Tk@CU;@00Q>E]@0959Je59Ne59Rf59Vf59Zf59Zg59^g59bg59fg008EW[P0
0aFO^1FP^AFQ^@025J:i00@EXkXEY;XFYKXFY[/25ZNk00PFZ;/FZK`FZ[`F
Zk`FZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG/kl26;C000?8h=R8`;R8
`;P02hS0^003B9280000b>3H00:8`;P00dR@R<SPf<SPf005b>3H00E8T8S8
h=R8`;Q8T8P000000QRd`003b>3HR<2hR<2h00:8`;P200000XS0^0800003
R<2h00I8T8P0000H]<0H]<28`;Q8T8P1000000000hS0^<SPf8S0^0020020
00>KYo7fb<cR9S`00_n]/007gb@^ojBNm[c5ojf`kW^<oooo<d>U00H00800
0`01P?ooo`03P@0200B100Soool01X801h81288128<12H<12X<12h@20@b4
00@13H@13XD23hD248D20Q6600<24XH24hH258L00P8EQ`080aJ80aN80aR8
0aV80aV90aZ90a^90ab:0P<MRP04oooo11n;122;126;0P@RS00C12><12B<
12F=1BJ=oooo1BN>1BR>1BV>1BZ>1BZ?1B^?1Bb?1Rf@1Rj@1Rn@1RnA1S2A
1S6A1S:A0086<i800`LdTPLeT`LfT`021cNC00<7>9Coool7>Y@00PLkU@09
oooo23fE23jF23nF242F242G246G24:G24>G0089A9P00`U5V0U6V@U7V@02
2DRI00@9BIX9BYX:BiX:C9/22TfK00P:CY/:Ci`:D9`:DI`:DId;DYd;Did;
E9d22eFN00<;EYh;Eil;F9l00P]IW`0435ZP35^P35bP35fQ0PaNX@0835nR
362R366R3F:R3F:S3F>S3FBS3FFT0PeVY0043FNT3FRU3VVU3VZU0Pi[YP03
3VbV3VfV3VjW008>KjL020m`Z0maZ0mbZ0mcZ0mcZ@mdZ@meZ@mfZP8?MjX0
111hZQ1iZa1jZa1kZ`8@O:`00a1m[11n[11o[@024H2]00hAPJhAPZhAPjhA
Q:hAQ:lAQJlAQZlBQk0BR;0BRK0BRK4BR[4BRk4BS;424Xfb00<CS[8CSk<C
T;<00Q>A/`034i:d4i>d4iBd008CUKD02ABF]ABG]ABH]QBI]QBJ]QBJ]aBK
]aBL]aBM]`025Ijh00<EWkPEX;TEXKT00QFR^@045J>j5JBj5ZFj5ZJk0QJW
^`085ZRk5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm0QN__P045k2n5k6o5k:o5k>o
0QRd`003b>3HR<2hR<2h00^8`;P00dR@R0000<SPf002R<2h2DR@R004b>3H
R<2hB92800000QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0^006
B92800006;C06;C0R<2hB9280@00000000>8`;S8h=R8`;P00P00P003VjOa
nLgDmhVG00;oool01on]/>4F=?mfNonTW^8V??n9Oc=3Y@06002000<00H00
0X3oool00_ooo`0800F200J200N20@R20@R30@V30@Z30@^40P4<Q0040@f4
0@j50Pn50Q250P8AQP030Q:60Q>60QB700825HL020<FR0<GR0<HR0<IR0<I
R@<JR@<KR@<LRP837HX010@NRP@OR`@PR`@QR`848X`00`@SS0@TS0@US@02
1BJ=00h59hh5:8h5:Hkoool5:Xl5:hl5;8l6;I06;Y06;i06;i46<946<I46
<Y421S>B00<7=987=I<7=Y<00PLgT`031cRDoooooooo00;oool02@PlU@Pm
U@PnUPPoUPQ0UPQ0U`Q1U`Q2U`Q3U`022DBH00<9AIP9AYT9AiT00PU8V@04
2DVJ2DZJ2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]E
WP032eJN2eNO2eRO008;FIl010aJX0aKX0aLX0aMX@8<GZ4020aOXPaPXPaQ
XPeRXPeRX`eSX`eTX`eUY08=IZ@010eWY0eXY@iYY@iZY@8>JjH00`i/YPi]
YPi^Y`023VnW00P?L:P?LJP?LZP?LjP?LjT?M:T?MJT?MZX23gNZ00@@N:X@
NJ/@NZ/@Nj/247b/00<@OJ`@OZ`@Ojd00Q60[@0>4H6^4H:^4H>^4HB^4HB_
4HF_4HJ_4XN`4XR`4XV`4XVa4XZa4X^a4Xba0Q:=/P034hjb4hnc4i2c008C
TK<00a>B]1>C]1>D]0024iFe00TDU[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LD
WKL00QFN^0035Inh5J2i5J6i008EX[T011FS^QFT^QJU^QJV^`8FYk/021JX
^aJY_1JZ_1J[_1J[_AN/_AN]_AN^_@8G[kh011N`_QNa_aNb_aNc_`8H]<00
0lSPf8S0^8S0^00;R<2h00=8T8P00038h=P00XS0^0U8T8P2R<2h00E8T8P0
000H]<0H]<38h=P03HS0^006B92800006;C06;C0R<2hB9280@00000000>8
`;S8h=R8`;P00P00P007VjOaoooolj2^m69^oooomhVGnLgD00;oool00o>P
[_oooc=3Y@06002000<00H000X000h400P04P@0800F200J200N20@R20@R3
0@V30@Z30@^40P4<Q0040@f40@j50Pn50Q250P8AQP030Q:60Q>60QB70082
5HL020<FR0<GR0<HR0<IR0<IR@<JR@<KR@<LRP837HX010@NRP@OR`@PR`@Q
R`848X`00`@SS0@TS0@US@021BJ=00h59hh5:8h5:Hh5:Xh5:Xl5:hl5;8l6
;I06;Y06;i06;i46<946<I46<Y421S>B00<7=987=I<7=Y<00PLgT`031cRD
1cVD1cZD0087>iD02@PlU@PmU@PnUPPoUPQ0UPQ0U`Q1U`Q2U`Q3U`022DBH
00<9AIP9AYT9AiT00PU8V@042DVJ2DZJ2T^J2TbK0PY=V`082TjK2TnL2U2L
2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN2eNO2eRO008;FIl010aJX0aKX0aL
X0aMX@8<GZ4020aOXPaPXPaQXPeRXPeRX`eSX`eTX`eUY08=IZ@010eWY0eX
Y@iYY@iZY@8>JjH00`i/YPi]YPi^Y`023VnW00P?L:P?LJP?LZP?LjP?LjT?
M:T?MJT?MZX23gNZ00@@N:X@NJ/@NZ/@Nj/247b/00<@OJ`@OZ`@Ojd00Q60
[@0>4H6^4H:^4H>^4HB^4HB_4HF_4HJ_4XN`4XR`4XV`4XVa4XZa4X^a4Xba
0Q:=/P034hjb4hnc4i2c008CTK<00a>B]1>C]1>D]0024iFe00TDU[DDUkDD
V;HDVKHDV[HDV[LDVkLDW;LDWKL00QFN^0035Inh5J2i5J6i008EX[T011FS
^QFT^QJU^QJV^`8FYk/021JX^aJY_1JZ_1J[_1J[_AN/_AN]_AN^_@8G[kh0
11N`_QNa_aNb_aNc_`8H]<000lSPf8S0^8S0^00;R<2h00=8T8P00038h=P0
3HS0^005B92800006;C06;C0b>3H00f8`;P01TR@R00001Rd`1Rd`8S0^4R@
R04000000003R<2hb>3HR<2h00<008002i^WlOoooon9Oooooo>P[_6CXOoo
ooomoo>P[_oko3=3Y@06002000<00H000X000h400P04P@0800F200J200N2
0@R20@R30@V30@Z30@^40P4<Q0040@f40@j50Pn50Q250P8AQP030Q:60Q>6
0QB700825HL020<FR0<GR0<HR0<IR0<IR@<JR@<KR@<LRP837HX010@NRP@O
R`@PR`@QR`848X`00`@SS0@TS0@US@021BJ=00h59hh5:8h5:Hh5:Xh5:Xl5
:hl5;8l6;I06;Y06;i06;i46<946<I46<Y421S>B00<7=987=I<7=Y<00PLg
T`031cRD1cVD1cZD0087>iD02@PlU@PmU@PnUPPoUPQ0UPQ0U`Q1U`Q2U`Q3
U`022DBH00<9AIP9AYT9AiT00PU8V@042DVJ2DZJ2T^J2TbK0PY=V`082TjK
2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN2eNO2eRO008;FIl010aJ
X0aKX0aLX0aMX@8<GZ4020aOXPaPXPaQXPeRXPeRX`eSX`eTX`eUY08=IZ@0
10eWY0eXY@iYY@iZY@8>JjH00`i/YPi]YPi^Y`023VnW00P?L:P?LJP?LZP?
LjP?LjT?M:T?MJT?MZX23gNZ00@@N:X@NJ/@NZ/@Nj/247b/00<@OJ`@OZ`@
Ojd00Q60[@0>4H6^4H:^4H>^4HB^4HB_4HF_4HJ_4XN`4XR`4XV`4XVa4XZa
4X^a4Xba0Q:=/P034hjb4hnc4i2c008CTK<00a>B]1>C]1>D]0024iFe00TD
U[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LDWKL00QFN^0035Inh5J2i5J6i008E
X[T011FS^QFT^QJU^QJV^`8FYk/021JX^aJY_1JZ_1J[_1J[_AN/_AN]_AN^
_@8G[kh011N`_QNa_aNb_aNc_`8H]<0?b>3H00<00038h=S8h=P03LSPf003
00006;C06;C000o8h=P01@0001Rd`1Rd`8S0^4R@R001000000000hS0^<SP
f8S0^00400200i^Wl@06oooolj2^m;Fom[c5nmWJ<d>U1`00P003006000:0
00>1008018402005PP06PP07PP48PP48P`49P`4:P`4;Q08138@0104=Q04>
Q@8?Q@8@Q@824HH00`8BQP8CQP8DQ`020QF700P35XP35hP368P36HP36HT3
6XT36hT378X20af:00@47XX47h/488/48H/212:<00<48h`498`49Hd00PDV
S@0>1BN>1BR>1BV>1BZ>1BZ?1B^?1Bb?1Rf@1Rj@1Rn@1RnA1S2A1S6A1S:A
0PHcTP031cBB1cFC1cJC0087=i<00`LhU0LiU0LjU0021c^E00T8?9D8?ID8
?YH8?iH8@9H8@9L8@IL8@YL8@iL00PU4V0032DFH2DJI2DNI0089B9T010U9
VPU:VPY;VPY<V`8:CI/020Y>V`Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@8;EIh0
0`]FWP]GW`]HW`022eVO00@<FZ0<Fj0<G:0<GJ4235jQ00P<Gj8<H:8<HJ8=
HZ8=HZ<=Hj<=I:<=IJ@23FJT00@=Ij@=J:D>JJD>JZD23V^V00<>K:H>KJH>
KZL00Pi_Y`083g2X3g6X3g:X3g>X3g>Y3gBY3gFY3gJZ0PmgZP0447RZ47V[
47Z[47^[0Q1l[00347f/47j/47n]008AP:d03Q61[Q62[Q63[Q64[Q64[a65
[a66[a:7/1:8/1:9/1:9/A::/A:;/A:</@8BSK800a>>/Q>?/a>@/`024i6c
00<CT[@CTk@CU;@00Q>E]@0959Je59Ne59Rf59Vf59Zf59Zg59^g59bg59fg
008EW[P00aFO^1FP^AFQ^@025J:i00@EXkXEY;XFYKXFY[/25ZNk00PFZ;/F
ZK`FZ[`FZk`FZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG/klf6;C00HS0
^058T8P1000000000hS0^<SPf8S0^00D002000<00H000X000h400P04P@08
00F200J200N20@R20@R30@V30@Z30@^40P4<Q0040@f40@j50Pn50Q250P8A
QP030Q:60Q>60QB700825HL020<FR0<GR0<HR0<IR0<IR@<JR@<KR@<LRP83
7HX010@NRP@OR`@PR`@QR`848X`00`@SS0@TS0@US@021BJ=00h59hh5:8h5
:Hh5:Xh5:Xl5:hl5;8l6;I06;Y06;i06;i46<946<I46<Y421S>B00<7=987
=I<7=Y<00PLgT`031cRD1cVD1cZD0087>iD02@PlU@PmU@PnUPPoUPQ0UPQ0
U`Q1U`Q2U`Q3U`022DBH00<9AIP9AYT9AiT00PU8V@042DVJ2DZJ2T^J2TbK
0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN2eNO2eRO
008;FIl010aJX0aKX0aLX0aMX@8<GZ4020aOXPaPXPaQXPeRXPeRX`eSX`eT
X`eUY08=IZ@010eWY0eXY@iYY@iZY@8>JjH00`i/YPi]YPi^Y`023VnW00P?
L:P?LJP?LZP?LjP?LjT?M:T?MJT?MZX23gNZ00@@N:X@NJ/@NZ/@Nj/247b/
00<@OJ`@OZ`@Ojd00Q60[@0>4H6^4H:^4H>^4HB^4HB_4HF_4HJ_4XN`4XR`
4XV`4XVa4XZa4X^a4Xba0Q:=/P034hjb4hnc4i2c008CTK<00a>B]1>C]1>D
]0024iFe00TDU[DDUkDDV;HDVKHDV[HDV[LDVkLDW;LDWKL00QFN^0035Inh
5J2i5J6i008EX[T011FS^QFT^QJU^QJV^`8FYk/021JX^aJY_1JZ_1J[_1J[
_AN/_AN]_AN^_@8G[kh011N`_QNa_aNb_aNc_cHH]<01R<2h0DR@R0400000
0003R<2hb>3HR<2h0?n8`;PXR<2h0DR@R04000000003R<2hb>3Hb>3H0?o8
h=PXb>3H0DR@R04000000?n8`;P/R<2h0@000000\
\>"], "Graphics",
  ImageSize->{300, 110},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004/0000OB000`400?l0
0000o`00003oooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00
ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]oooo
o`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]
ooooo`00ooooool]ooooo`00ooooool]ooooo`00ooooool]ooooo`00oooo
ool]ooooo`00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKViP00
ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]onKV
iP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooVi^H]
onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00oooV
i^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^kP00
oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]onk^
kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^k^h]
onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00ooo^
k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP00ooooool]ooooo`00
ooo^k^h]onk^kP00oooVi^H]onKViP00ooo^k^h]onk^kP005?ooool00ooj
n_[okno_on[ZjP3oon[ZjP03ono_koojn_[ooooo01?ooooo000Donk^kP03
omoOgoo2`/;o/k>c0?oo/k>c00?o`/;2omoOgoo^k^h04oo^k^h001Coi^KV
09coPL[oogS3oom`_OooK;[oog:noomha?ooP/[oohS>oon1b_ooN<?oog2m
oom/^_ooL[koogS4oon2b_ooR<kooh7:oomh`oooL;goofbjoomb__ooN<Co
oh;:oon8c_ooPL[oogS3oom`_OooK;[oog:noomha?ooP/[oohS>oon1b_oo
N<?oog2moom/^_ooL[koogS4oon2b_ooR<kooh7:oomh`oooL;goofbjoomb
__ooN<Cooh;:oon8c_ooPL[oogS3oom`_OooK;[oog:noomha?ooP/[oohS>
oon1b_ooN<?oog2moom/^_ooL[koogS4oon2b_ooR<kooh7:oomh`oooL;go
ofbjoomb__ooN<Cooh;:oon8c_ooPL[oogS3oom`_OooK;[oog:noomha?oo
P/[oohS>oon1b_ooN<?oog2moom/^_ooL[koogS4oon2b_ooR<kooh7:oomh
`oooL;goofbjoomb__ooN<Cooh;:oon8c_ooPL[oogS3oom`_OooK;[oog:n
oomha?ooP/[oohS>oon1b_ooN<?oog2moom/^_ooL[koogS4oon2b_ooR<ko
oh7:oomh`oooL;goofbjoomb__ooN<Cooh;:oon8c_ooPL[oogS3oom`_Ooo
K;[oog:noomha?ooP/[oohS>oon1b_ooN<?oog2moom/^_ooL[koogS4oon2
b_ooR<kooh7:oomh`oooL;goofbjoomb__ooN<Cooh;:oon8c_ooPL[oogS3
oom`_OooK;[oog:noomha?ooP/[oohS>oon1b_ooN<?oog2moom/^_mWomkN
gP03om?CdooVi^Koi^KV01;oi^KV000Donk^kP2Logk=oomfaOooK/3oofVn
oom]`?ooM/Koogo=oon6d_ooO/googK5oom^`?ooJKkoofg0oomfa_ooOlgo
ohKBoomncOooM/Goofk0oomY__ooKL3oogK6oomocOooQ];oogk=oomfaOoo
K/3oofVnoom]`?ooM/Koogo=oon6d_ooO/googK5oom^`?ooJKkoofg0oomf
a_ooOlgoohKBoomncOooM/Goofk0oomY__ooKL3oogK6oomocOooQ];oogk=
oomfaOooK/3oofVnoom]`?ooM/Koogo=oon6d_ooO/googK5oom^`?ooJKko
ofg0oomfa_ooOlgoohKBoomncOooM/Goofk0oomY__ooKL3oogK6oomocOoo
Q];oogk=oomfaOooK/3oofVnoom]`?ooM/Koogo=oon6d_ooO/googK5oom^
`?ooJKkoofg0oomfa_ooOlgoohKBoomncOooM/Goofk0oomY__ooKL3oogK6
oomocOooQ];oogk=oomfaOooK/3oofVnoom]`?ooM/Koogo=oon6d_ooO/go
ogK5oom^`?ooJKkoofg0oomfa_ooOlgoohKBoomncOooM/Goofk0oomY__oo
KL3oogK6oomocOooQ];oogk=oomfaOooK/3oofVnoom]`?ooM/Koogo=oon6
d_ooO/googK5oom^`?ooJKkoofg0oomfa_ooOlgoohKBoomncOooM/Goofk0
oomY__ooKL3oogK6oomocOooQ];oogk=oomfaOooK/3oofVnoom]`?ooM/Ko
ogo=oon6d_ooO/googK5oom^`?ooJKkoIoojn_X00ooJf][ok^k^onk^kP0B
onk^kP005?ooool0W?m`__ooIkSoof2aoomH[?ooG[3oofJfoom^_?ooMl;o
og2noomW^?ooH;7ooeR/oomN/?ooI[Koofjloomg`_ooL;koofNhoomP/Ooo
F:cooej`oomV]_ooK[coogO2oom`__ooIkSoof2aoomH[?ooG[3oofJfoom^
_?ooMl;oog2noomW^?ooH;7ooeR/oomN/?ooI[Koofjloomg`_ooL;koofNh
oomP/OooF:cooej`oomV]_ooK[coogO2oom`__ooIkSoof2aoomH[?ooG[3o
ofJfoom^_?ooMl;oog2noomW^?ooH;7ooeR/oomN/?ooI[Koofjloomg`_oo
L;koofNhoomP/OooF:cooej`oomV]_ooK[coogO2oom`__ooIkSoof2aoomH
[?ooG[3oofJfoom^_?ooMl;oog2noomW^?ooH;7ooeR/oomN/?ooI[Koofjl
oomg`_ooL;koofNhoomP/OooF:cooej`oomV]_ooK[coogO2oom`__ooIkSo
of2aoomH[?ooG[3oofJfoom^_?ooMl;oog2noomW^?ooH;7ooeR/oomN/?oo
I[Koofjloomg`_ooL;koofNhoomP/OooF:cooej`oomV]_ooK[coogO2oom`
__ooIkSoof2aoomH[?ooG[3oofJfoom^_?ooMl;oog2noomW^?ooH;7ooeR/
oomN/?ooI[Koofjloomg`_ooL;koofNhoomP/OooF:cooej`oomV]_ooK[co
ogO2oom`__ooIkSoof2aoomH[?ooG[3oofJfoom^_?ooMl;oog2noomW^?oo
H;7ooeR/ofOomOGe00?oj^[Zooooooooool04_ooool001Cok^k^09coGJWl
oeFSn_m;VoSoAYOfodjMmomDX_WoFjSkofB^oOmMZOcoEJ?jod^Kn?m6UoKo
CYggoeBRnOmKZ?_oI:kmoefYo?mEXo[oBi_hodJGm_m>WOOoE:;ioe^XnomT
[_goGJWloeFSn_m;VoSoAYOfodjMmomDX_WoFjSkofB^oOmMZOcoEJ?jod^K
n?m6UoKoCYggoeBRnOmKZ?_oI:kmoefYo?mEXo[oBi_hodJGm_m>WOOoE:;i
oe^XnomT[_goGJWloeFSn_m;VoSoAYOfodjMmomDX_WoFjSkofB^oOmMZOco
EJ?jod^Kn?m6UoKoCYggoeBRnOmKZ?_oI:kmoefYo?mEXo[oBi_hodJGm_m>
WOOoE:;ioe^XnomT[_goGJWloeFSn_m;VoSoAYOfodjMmomDX_WoFjSkofB^
oOmMZOcoEJ?jod^Kn?m6UoKoCYggoeBRnOmKZ?_oI:kmoefYo?mEXo[oBi_h
odJGm_m>WOOoE:;ioe^XnomT[_goGJWloeFSn_m;VoSoAYOfodjMmomDX_Wo
FjSkofB^oOmMZOcoEJ?jod^Kn?m6UoKoCYggoeBRnOmKZ?_oI:kmoefYo?mE
Xo[oBi_hodJGm_m>WOOoE:;ioe^XnomT[_goGJWloeFSn_m;VoSoAYOfodjM
momDX_WoFjSkofB^oOmMZOcoEJ?jod^Kn?m6UoKoCYggoeBRnOmKZ?_oI:km
oefYo?mEXo[oBi_hodJGm_m>WOOoE:;ioe^XnomT[_goGJWloeFSn_m;VoSo
AYOfodjMmomDX_WoFjSkofB^oOmMZOcoEJ?jod^Kn?m6UoIWono_k`03om[J
f_o^k^kok^k^01;ok^k^000DonKViP2LodZFjom4TNWo?8[WocF4i?lkR>Ko
@XoXodVEj_m?VNcoBYK[odBAjOllR^Oo=HCToc^8i_m2SnSoBIGZodnIk?m:
U^_oA97Yocb:ioleQ>Co>hSVod:?j?m9UN[oCiW/odZFjom4TNWo?8[WocF4
i?lkR>Ko@XoXodVEj_m?VNcoBYK[odBAjOllR^Oo=HCToc^8i_m2SnSoBIGZ
odnIk?m:U^_oA97Yocb:ioleQ>Co>hSVod:?j?m9UN[oCiW/odZFjom4TNWo
?8[WocF4i?lkR>Ko@XoXodVEj_m?VNcoBYK[odBAjOllR^Oo=HCToc^8i_m2
SnSoBIGZodnIk?m:U^_oA97Yocb:ioleQ>Co>hSVod:?j?m9UN[oCiW/odZF
jom4TNWo?8[WocF4i?lkR>Ko@XoXodVEj_m?VNcoBYK[odBAjOllR^Oo=HCT
oc^8i_m2SnSoBIGZodnIk?m:U^_oA97Yocb:ioleQ>Co>hSVod:?j?m9UN[o
CiW/odZFjom4TNWo?8[WocF4i?lkR>Ko@XoXodVEj_m?VNcoBYK[odBAjOll
R^Oo=HCToc^8i_m2SnSoBIGZodnIk?m:U^_oA97Yocb:ioleQ>Co>hSVod:?
j?m9UN[oCiW/odZFjom4TNWo?8[WocF4i?lkR>Ko@XoXodVEj_m?VNcoBYK[
odBAjOllR^Oo=HCToc^8i_m2SnSoBIGZodnIk?m:U^_oA97Yocb:ioleQ>Co
>hSVod:?j?m9UN[oCiW/odZFjom4TNWo?8[WocF4i?lkR>Ko@XoXodVEj_m?
VNcoBYK[odBAjOllR^Oo=HCTIooUiND00ooCdm?oi^KVonKViP0BonKViP00
5?o^k^h0W?mKVn?oE9KQod^@gom8S=coBXkOoe:Dh?mJV^7oGIgRoe^KhomD
U^7oBi3OodR<g?m:S]ooDYCPoeZJhOmMWN;oFi_SoeBFhOm;T=ooB8cLodZ>
gomBU>3oFY[QoefMh_mKVn?oE9KQod^@gom8S=coBXkOoe:Dh?mJV^7oGIgR
oe^KhomDU^7oBi3OodR<g?m:S]ooDYCPoeZJhOmMWN;oFi_SoeBFhOm;T=oo
B8cLodZ>gomBU>3oFY[QoefMh_mKVn?oE9KQod^@gom8S=coBXkOoe:Dh?mJ
V^7oGIgRoe^KhomDU^7oBi3OodR<g?m:S]ooDYCPoeZJhOmMWN;oFi_SoeBF
hOm;T=ooB8cLodZ>gomBU>3oFY[QoefMh_mKVn?oE9KQod^@gom8S=coBXkO
oe:Dh?mJV^7oGIgRoe^KhomDU^7oBi3OodR<g?m:S]ooDYCPoeZJhOmMWN;o
Fi_SoeBFhOm;T=ooB8cLodZ>gomBU>3oFY[QoefMh_mKVn?oE9KQod^@gom8
S=coBXkOoe:Dh?mJV^7oGIgRoe^KhomDU^7oBi3OodR<g?m:S]ooDYCPoeZJ
hOmMWN;oFi_SoeBFhOm;T=ooB8cLodZ>gomBU>3oFY[QoefMh_mKVn?oE9KQ
od^@gom8S=coBXkOoe:Dh?mJV^7oGIgRoe^KhomDU^7oBi3OodR<g?m:S]oo
DYCPoeZJhOmMWN;oFi_SoeBFhOm;T=ooB8cLodZ>gomBU>3oFY[QoefMh_mK
Vn?oE9KQod^@gom8S=coBXkOoe:Dh?mJV^7oGIgRoe^KhomDU^7oBi3OodR<
g6Oofm_K00?of][Jonk^k_o^k^h04_o^k^h001Cooooo09coQ;?Uogf^homg
Zn7oM:WPogNZh_mm[N?oP[7TohJdiOn4/nGoOJkSogN[hOmdZN3oMj[Rogf]
hon2/NCoQ[CUohBciOmm[^?oMj_QogBYh?mgZ^;oOJgSoh:ai?n6]>GoQ;?U
ogf^homgZn7oM:WPogNZh_mm[N?oP[7TohJdiOn4/nGoOJkSogN[hOmdZN3o
Mj[Rogf]hon2/NCoQ[CUohBciOmm[^?oMj_QogBYh?mgZ^;oOJgSoh:ai?n6
]>GoQ;?Uogf^homgZn7oM:WPogNZh_mm[N?oP[7TohJdiOn4/nGoOJkSogN[
hOmdZN3oMj[Rogf]hon2/NCoQ[CUohBciOmm[^?oMj_QogBYh?mgZ^;oOJgS
oh:ai?n6]>GoQ;?Uogf^homgZn7oM:WPogNZh_mm[N?oP[7TohJdiOn4/nGo
OJkSogN[hOmdZN3oMj[Rogf]hon2/NCoQ[CUohBciOmm[^?oMj_QogBYh?mg
Z^;oOJgSoh:ai?n6]>GoQ;?Uogf^homgZn7oM:WPogNZh_mm[N?oP[7TohJd
iOn4/nGoOJkSogN[hOmdZN3oMj[Rogf]hon2/NCoQ[CUohBciOmm[^?oMj_Q
ogBYh?mgZ^;oOJgSoh:ai?n6]>GoQ;?Uogf^homgZn7oM:WPogNZh_mm[N?o
P[7TohJdiOn4/nGoOJkSogN[hOmdZN3oMj[Rogf]hon2/NCoQ[CUohBciOmm
[^?oMj_QogBYh?mgZ^;oOJgSoh:ai?n6]>GoQ;?Uogf^homgZn7oM:WPogNZ
h_mm[N?oP[7TohJdiOn4/nGoOJkSogN[hOmdZN1WomkNgP03on[Zj_oooooo
oooo01;ooooo000Donk^kP2LoiBmi_n?^NKoSKOUohVdhon=]nCoSk[UoiBl
i_nI_nOoU;gVohnii_n=]nGoRKCSohfgi?n?^^GoU;cVoiVoionD_NKoSkWV
ohfgiOn9]>?oSKOTohnjiOnD_>KoVKoWoiBmi_n?^NKoSKOUohVdhon=]nCo
Sk[UoiBli_nI_nOoU;gVohnii_n=]nGoRKCSohfgi?n?^^GoU;cVoiVoionD
_NKoSkWVohfgiOn9]>?oSKOTohnjiOnD_>KoVKoWoiBmi_n?^NKoSKOUohVd
hon=]nCoSk[UoiBli_nI_nOoU;gVohnii_n=]nGoRKCSohfgi?n?^^GoU;cV
oiVoionD_NKoSkWVohfgiOn9]>?oSKOTohnjiOnD_>KoVKoWoiBmi_n?^NKo
SKOUohVdhon=]nCoSk[UoiBli_nI_nOoU;gVohnii_n=]nGoRKCSohfgi?n?
^^GoU;cVoiVoionD_NKoSkWVohfgiOn9]>?oSKOTohnjiOnD_>KoVKoWoiBm
i_n?^NKoSKOUohVdhon=]nCoSk[UoiBli_nI_nOoU;gVohnii_n=]nGoRKCS
ohfgi?n?^^GoU;cVoiVoionD_NKoSkWVohfgiOn9]>?oSKOTohnjiOnD_>Ko
VKoWoiBmi_n?^NKoSKOUohVdhon=]nCoSk[UoiBli_nI_nOoU;gVohnii_n=
]nGoRKCSohfgi?n?^^GoU;cVoiVoionD_NKoSkWVohfgiOn9]>?oSKOTohnj
iOnD_>KoVKoWoiBmi_n?^NKoSKOUohVdhon=]nCoSk[UoiBli_nI_nOoU;gV
ohnii_n=]nGoRKCSIooXj>P00ooJf][ok^k^onk^kP0Bonk^kP005?oVi^H0
W?mn[=ooO:SMogfTfon0X][oOJCLogjXgOmnZmooP:kOogj/gomlZ=goOJCK
oh2Rf_mmY=coOZSMogj[gon0[]ooOZcOogbXgOmmY=_oP:;JogfTg?mnZ=go
OZ_Ooh2^gomn[=ooO:SMogfTfon0X][oOJCLogjXgOmnZmooP:kOogj/goml
Z=goOJCKoh2Rf_mmY=coOZSMogj[gon0[]ooOZcOogbXgOmmY=_oP:;JogfT
g?mnZ=goOZ_Ooh2^gomn[=ooO:SMogfTfon0X][oOJCLogjXgOmnZmooP:kO
ogj/gomlZ=goOJCKoh2Rf_mmY=coOZSMogj[gon0[]ooOZcOogbXgOmmY=_o
P:;JogfTg?mnZ=goOZ_Ooh2^gomn[=ooO:SMogfTfon0X][oOJCLogjXgOmn
ZmooP:kOogj/gomlZ=goOJCKoh2Rf_mmY=coOZSMogj[gon0[]ooOZcOogbX
gOmmY=_oP:;JogfTg?mnZ=goOZ_Ooh2^gomn[=ooO:SMogfTfon0X][oOJCL
ogjXgOmnZmooP:kOogj/gomlZ=goOJCKoh2Rf_mmY=coOZSMogj[gon0[]oo
OZcOogbXgOmmY=_oP:;JogfTg?mnZ=goOZ_Ooh2^gomn[=ooO:SMogfTfon0
X][oOJCLogjXgOmnZmooP:kOogj/gomlZ=goOJCKoh2Rf_mmY=coOZSMogj[
gon0[]ooOZcOogbXgOmmY=_oP:;JogfTg?mnZ=goOZ_Ooh2^gomn[=ooO:SM
ogfTfon0X][oOJCLogjXgOmnZmooP:kOogj/gomlZ=goOJCKoh2RfVOohn?S
00?oemOGonKVi_oVi^H04_oVi^H001Cok^k^09co=FW1ocAQ_oldF[_o=eZk
oc=J_?leH[oo<fS1oc=/`_leJL7o=66oocAJ^olgF[_o<eZlocER_olcJ<7o
<fc2ocEY`OldHKoo=5ZkocMJ^olcF[co=F:ooc=X`OlcK<;o=FW1ocAQ_old
F[_o=eZkoc=J_?leH[oo<fS1oc=/`_leJL7o=66oocAJ^olgF[_o<eZlocER
_olcJ<7o<fc2ocEY`OldHKoo=5ZkocMJ^olcF[co=F:ooc=X`OlcK<;o=FW1
ocAQ_oldF[_o=eZkoc=J_?leH[oo<fS1oc=/`_leJL7o=66oocAJ^olgF[_o
<eZlocER_olcJ<7o<fc2ocEY`OldHKoo=5ZkocMJ^olcF[co=F:ooc=X`Olc
K<;o=FW1ocAQ_oldF[_o=eZkoc=J_?leH[oo<fS1oc=/`_leJL7o=66oocAJ
^olgF[_o<eZlocER_olcJ<7o<fc2ocEY`OldHKoo=5ZkocMJ^olcF[co=F:o
oc=X`OlcK<;o=FW1ocAQ_oldF[_o=eZkoc=J_?leH[oo<fS1oc=/`_leJL7o
=66oocAJ^olgF[_o<eZlocER_olcJ<7o<fc2ocEY`OldHKoo=5ZkocMJ^olc
F[co=F:ooc=X`OlcK<;o=FW1ocAQ_oldF[_o=eZkoc=J_?leH[oo<fS1oc=/
`_leJL7o=66oocAJ^olgF[_o<eZlocER_olcJ<7o<fc2ocEY`OldHKoo=5Zk
ocMJ^olcF[co=F:ooc=X`OlcK<;o=FW1ocAQ_oldF[_o=eZkoc=J_?leH[oo
<fS1oc=/`_leJL7o=66oocAJ^olgF[]WokBd]003onWYjOo^k^kok^k^01;o
k^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV003oonk^
kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV003o
onk^kRgok^k^003oooooobgooooo003oonk^kRgok^k^003oonKViRgoi^KV
003oonk^kRgok^k^001Rooooo`03oijNW_nn_[kooooo0<Oooooo001Ronk^
kP03oc/k>omfMWKok^k^0<Ook^k^000NonKViP03omcLg?oAdM7oi^KV00Wo
i^KV00?oeMGEomOGeooVi^H01?oVi^H00ooLg=codM7AonKViP0<onKViP03
olk>c_oTi>Coi^KV00Koi^KV00?oeMGEomOGeooVi^H01?oVi^H00ooDe=Co
emOGonKViP0?onKViP05ocTi>OmbLW;oiNGUolk>c_oUiND02OoVi^H00ooL
g=codM7AonKViP04onKViP03olk>c_oTi>Coi^KV00;oi^KV00?og=cLom7A
dOoVi^H0[OoVi^H001Gok^k^00?o<S8bofm_Koo^k^h01?o^k^h02OoGemOo
ADE5o`820_lP823o5ADEokBd]?o^k^ko>c/kogIfMP03onk^kP0@omGEeOlk
>c_o0000oa0@4?lK6a_oinOWonk^k_oGemOoADE5o`820_lP823o5ADEokBd
]?o^k^ko>c/kogIfMP;ok^k^00SoV9RHoaXJ6_o^k^kok^k^olC4a?lR8R;o
71`Lojf][@Gok^k^00goeMGEoc/k>ol0003o410@oa/K6ooWinOok^k^olc<
c?la<C7o3@d=o`/;2ole=CGocLg=00;ok^k^00Ko>c/kogIfM_o^k^kok^k^
og5aLOln?Sh2onk^kP0:ojRXZ?l820Sok^k^onk^k_lk>c_oATI6ob<S8olI
6AWo4a<Cojn_[`;ok^k^01Wo>c/kogIfM_o^k^kok^k^omOGeom5ADGo0P82
ob0P8?lE5AGo];Bdonk^k_o4a<Co8R8Roa`L7?n][Jgok^k^omOGeom5ADGo
0P82ob0P8?lE5AGo];Bdonk^k_mUIFGoC4a<0:Wok^k^000Eooooo`03ocHf
=_mgMgOooooo00Cooooo00WoA4A4od10@?oOgmoooooooo?cloobl_;ooooo
od10@?moOgl00oooool04?m2@T;o;2`/ol_;booooooof=SHoogmoOoooooo
A4A4od10@?oOgmoooooooo?cloobl_;ooooood10@?moOgl2ooooo`07oj>S
XolL71cooooooooooomaLG7o@D51ooknoP06ooooo`09od92@_l/;2cobl_;
oooooooHf=SooOgmookno_ld=3CoDU9B00;ok^k^00KoEEEEocDe=Oono_ko
oooood10@?moOgl2ooooo`06ogYjN_m3@d?ooooooooooond];Co2@T90_oo
ool02_m0@43o@d=3ono_kookno_oOGemoa<C4ooclo?ooooood10@?moOgl2
ooooo`0:odA4A?m0@43ogmoOoooooooclo?ol_;boooooomaLG7o@D51ookn
oP;ooooo00WoA4A4od10@?oOgmoooooooo?cloobl_;oooooom_KfooDe=@0
ZOooool001Gok^k^00?o<S8bofm_Koo^k^h00oo^k^h00oo>c/ko0000oj^[
Z`05onk^kP07oc/k>omfMWKok^k^onk^k_o=cLgo0000oh^;R`04onk^kP03
olk>c_l0003oZj^[00Gok^k^00Ko>c/kogIfM_o^k^kok^k^oiRHV?lJ6QX2
onk^kP03odM7AomZJV[ok^k^00Gok^k^00?ocLg=o`000?n;Rh/01?o^k^h0
0oo9bLWo0000ojZZZP02onk^kP06ojZZZ_l0003ocLg=onk^k_lk>c_oMWIf
0_o^k^h01_maLG7o?Shnonk^k_o^k^koZ:RXo`P820;ok^k^00ko>c/kogIf
M_o^k^kok^k^omOGeol0003oXJ6Qonk^k_lk>c_oMWIfonk^k_o>c/ko0000
oj^[Z`Gok^k^00OoAdM7ofYZJ_o^k^kok^k^olk>c_l0003oZj^[0;3ok^k^
000EonKViP04oc0`<?m>CTko];BdomCDe0;oi^KV00?oZj^[o`000?lg=cL0
0olh>3P01?n`/;3oi^KVocTi>OmbLW82onKViP03oj^[Zol0003o^KVi00Co
i^KV00?oZj^[o`000?lg=cL00olh>3P01?n`/;3oi^KVocTi>OmbLW82onKV
iP06oi>CTolI6AWoi^KVonKVi_m5ADGoIVIV1_oVi^H00on[Zj_o0000okVi
^@04onKViP03oj^[Zol0003oclo?00;oi^KV00KocLg=o`000?n^[Zkoi^KV
ocTi>OmbLW82onKViP06ofi^K_ll?3coi^KVonKVi_nRXZ;o20P80_oVi^H0
0oli>CWoLW9bonKViP02onKViP09oa<C4on2PX;oi^KVocTi>OmbLW;oi^KV
oj^[Zol0003o=cLg00?o>3Ph00Co/;2`onKVi_m5ADGoIVIV0_oVi^H00on[
Zj_o0000ocLg=`03ocPh>003ok2`/?oVi^Koi^KV0:[oi^KV000Eonk^kP0@
oc8b<_lL71co7QhNo`000?mDE5Cohn?Solc<c?l0003oWinOol71`Oni^KWo
0P82omGEeOo^k^ko>c/kof9RHP;ok^k^00?oc<c<o`000?n7QhL01?o^k^h0
2_o<c<co0000oinOWoo1`L7o^KVio`820_oEeMGok^k^oc/k>omFEUH2onk^
kP06oi:BT_lK6a_ok^k^onk^k_m7AdOoJVYZ1_o^k^h00oo<c<co0000ohN7
Q`04onk^kP03olg=cOl0003oZ:RX00;ok^k^00KoYZJVo`000?oAdM7ok^k^
oc/k>omUIFD2onk^kP06og1`L?l_;bookNg]onk^k_nWYjOo20P80_o^k^h0
5Olk>c_oLG5aonk^k_o^k^kogMgMo`000?nf][Kok^k^oc/k>omfMWKok^k^
olc<c?l0003oWinOol71`Oni^KWo0P82omGEeOo^k^koAdM7ofYZJP02onk^
kP07olc<c?l0003oWinOol71`Oni^KWo0P82omGEe@2/onk^kP005Oooool0
3?lf=SKoMgMgoooooooCdm?o30`<ofYZJ_oooooo?cloof][JoogmoOoWYjN
ob/[:`;ooooo00[o@410oa<C4onATI7oi>CToogmoOlo?coo9bLWokjn__on
o_kog]kN0_ooool01Olo?cooJf][ooOgmonNWYko:b/[00;ooooo00co@410
oa@D5?mfMWKog]kNoeMGEom=CDgoooooooWinOm9BDWoKFe]ooCdm?okno/5
ooooo`05oclo?olW9bOo_[jnookno_oNg]h00_ooool01_m1@D7oB4Q8omkN
g_oMgMgoAdM7odA4A0;ooooo00[o@410oaDE5On<S8coj>SXoclo?olO7aoo
H61Pon;Rh_maLG7o<c<c0_ooool02_m0@43o6a/KoiNGUooLg=coJFUYoa4A
4Oolo?cooooood10@?moOgl2ooooo`0Aoclo?om[Jf_omoOgoijNW_l[:b_o
ooooooWinOm9BDWoKFe]ooCdm?okno_ooooooclo?om[Jf_omoOgoijNW_l[
:b/00_ooool00oo:b/[o`<30ooooo`2Xooooo`005Oo^k^h03?lb<S;oKfm_
onk^k_o^k^koH61PoadM7Oo^k^koe]KFod92@_l<30co6QXJojZZZP;ok^k^
00[oCTi>ogmoOomFEUKo20P8on3Ph?oHf=SoDE5Ao`h>3_l:2P[o8b<S0_o^
k^h01OoFe]Ko@T92o``<3?lJ6Q[oZZZZ00;ok^k^00coCTi>oh:2P_m`L73o
4Q8BobXZ:_nf][Kok^k^ogIfM_l71`Oo2`/;oaTI6OnRXZ85onk^kP05omSH
f?mADE7o3Ph>o`X:2_lS8b<00_o^k^h01_oHf=SoC4a<o`h>3_l>3PkoCTi>
omWIf@;ok^k^00[oCTi>oh61POmYJFWo3Ph>obDU9Oo6a/KoShn?oaPH6?lM
7AgoXJ6Q0_o^k^h01_m>CTkoP820oeiNG_l<30co5aLGoibLW0;ok^k^01Go
>c/kogIfM_o^k^kok^k^omKFe_m2@T;o30`<oaXJ6_nZZZ[ok^k^ogIfM_l7
1`Oo2`/;oaTI6OnRXZ;ok^k^omKFe_m2@T;o30`<oaXJ6_nZZZX00_o^k^h0
0omdM7CoGEeMonk^kP2Xonk^kP005OoVi^H01_l`<33oJf][onKVi_oVi^Ko
?Shnocdm?@?oi^KV00?ohn?SonKVi_oVi^H01OoVi^H00ooShn?oi^KVonKV
iP02onKViP03on?ShooVi^Koi^KV00?oi^KV00?ohn?SonKVi_oVi^H01OoV
i^H00ooUiNGoi^KVonKViP02onKViP03odE5AOmVIVKoi^KV00Woi^KV00?o
hn?SonKVi_oVi^H00ooVi^H2onGUi@Ooi^KV00?oiNGUonKVi_oVi^H00_oV
i^H00ooUiNGoi^KVonKViP04onKViP03onCTi?oVi^Koi^KV00;oi^KV00?o
>CTiog9bL_oVi^H00ooVi^H00ooShn?oi^KVonKViP02onKViP03odE5AOmV
IVKoi^KV00Coi^KV00?ohn?SonKVi_oVi^H0[OoVi^H001Gok^k^00Ko<S8b
ob/[:omDE5Co92@To`410OnRXZ8Sonk^kP03om7AdOo?clook^k^02Wok^k^
00?o>c/kogIfM_o^k^h02?o^k^h00ooAdM7oclo?onk^kP2donk^kP005Ooo
ool01On`/;3oVYZJoi^KVon][Jgog]kN053ooooo00?o@410ogmoOoooool0
_oooool006[ok^k^00?oj^[Zonc/k?o^k^h0_oo^k^h00?ooi^KV;OoVi^H0
0?ook^k^;Oo^k^h00?oooooo;Oooool00?ook^k^;Oo^k^h00?ooi^KV;OoV
i^H00?ook^k^;Oo^k^h00?oooooo;Oooool00?ook^k^;Oo^k^h00?ooi^KV
;OoVi^H00?ook^k^;Oo^k^h00?oooooo;Oooool00?ook^k^;Oo^k^h00?oo
i^KV;OoVi^H00?ook^k^;Oo^k^h006coOgmo1?mnOWi:ogmoO`OoOWinJomo
Ogl00004on_[jooVi^Koh^;RomkNgPCogMgM0ooNg]h0;_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]h2omgMg@0c
omcLgOoMgMgogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomcLgOoLg=cof][J00;ofm_K0_oMgMd0AooNg]kogMgN
omkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgM
gOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kN
omgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kN00;og=cL00GofMWJomSHf?oGemOofMWIom[JfP02omcLg00WomkN
g_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kN00;ogMgM03GogMgNomkNg_oMgMgog]kNomgM
gOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kN
omgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkN
g_oMgMgog]kNomgMg@03omkNgP03omgMgOoNg]kog]kN00?ogMgM0OoQhN41
onOWi`7oj^[Z00000oo/k>coi^KVon3Ph007omWIf@04omSHf?oFe]Kodm?C
om3@d0?ocLg=00Cod=3@om?CdooGemOof=SH2ooIfMT01?oHf=SoemOGom?C
doo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0cofMWI00Wof=SHomOGeooE
eMGoe=CDom?CdooDe=CoeMGEomOGeooHf=P04_oIfMT4omSHf0GofMWI0_oH
f=P>omWIf@05omSHf?oEeMGod];Bom;Bd_oEeMD00_oHf=P5omWIf@03omSH
f?oIfMWofMWI00GofMWI0_oHf=P2omWIf@;of=SH0_oIfMT01?oHf=SofMWI
omWIfOoIfMT2omSHf0OofMWI0_oHf=PNomWIf@?of=SH0_oIfMT01?oHf=So
eMGEom7AdOo>c/h2olg=c@04om3@d?oDe=CoemOGomSHf0OofMWI0ooHf=P3
omWIf@;of=SH1OoIfMT2omSHf4OofMWI00?of=SHomWIfOoIfMT01_oIfMT1
omkNgP7oi^KV0Oo/k>`00007onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;R
hP02on7Qh@0=omkNg_oLg=codm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^k
olO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_odm?ColO7aonk^k_o
/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=on3Ph?oO
gmoofm_KomKFe_oBd];oc/k>olc<c?o>c/kod];BomKFe_oKfm_ogmoOon3P
h00>on7Qh@03on3Ph?oOgmoogmoO00?og]kN00GogmoOon3Ph?oPh>3oh>3P
omoOg`02omkNgP03omoOgooPh>3oh>3P00[oh>3P0_oOgml01_oJf][oeMGE
omCDe?oIfMWogMgMomoOg`Coh>3P1OoOgml3on3Ph0?ogmoO00?oh>3PomoO
gooOgml01?oOgml2on3Ph0?ogmoO1_oPh>001?oOgmoog]kNomkNg_oOgml;
on3Ph0;ohN7Q1_oPh>02on7Qh@Goh>3P00CohN7Qon3Ph?oPh>3ogmoO0_oN
g]h01ooOgmooh>3Pon3Ph?oLg=cof=SHomGEeOoCdm<00_oBd]801?oHf=So
g]kNon3Ph?oOgml2on3Ph004on7QhOoPh>3oh>3PomoOg`;og]kN0_oOgml0
1OoPh>3ogmoOomoOgooNg]kogmoO00?oh>3P00CogmoOomkNg_oOgmoogmoO
0_oPh>0?on7Qh@03on3Ph?oQhN7ohN7Q03CohN7Q00?oh^;Ron7QhOoRh^80
1?oQhN41onCTi07ojNWY0Oo]kNd00003oo3`l?o_knoolO7a00?ol?3`02ko
kno_oo3`l?o^k^kojNWYom_Kfoo1`L7oY:BTohb<S?mkNg_oMgMgog]kNon<
S8coY:BTol;2`OoJf][oj^[Zong]kOoalO7okno_oo7alOo_knoolO7_ono_
kooalO7okNg]on[Zj_oJf][o`/;2ojBTY?n<S8_oNg]kogMgMomkNg_oS8b<
ojBTY?o2`/;of][Jon[Zj?o]kNgolO7aono_kooalO7okno_oo7alOo_knoo
lO7_0_o^k^h02ooVi^Kog]kNom7AdOo9bLWo`L71okno__o1`L7obLW9om7A
dOoNg]koi^KV00;ok^k^01GolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knool?3`onc/k?o[jn_oi^KVonOWiOoUiNGo
j>SXonWYjOo]kNd00_o/k>`01_oWinOoinOUonGUiOoYjNWojn_[ono_k`;o
k>c/01;oj^[Zonk^k?o/k>cok>c/on[Zj_o^k^kokNg]onc/k?oYjNWok>cZ
onOWionLW9coVi^Kon?ShooUiNGoj>SXonWYjOo_knd2ong]k@09onOWiooX
j>Soi^KVonWYjOoXj>SokNg[ong]kOo^k^koj>SX00;ojNWY00kok>c/onWY
jOoXj>Koi^KVonWYjOoWinOoj^[Zon_[joo]kNgoj>SXonWYiooYjNWokNg]
on[ZjP;ok>c/00Cokno_on_[jooYjNOoiNGU0_oWinL2ong]k@0;onk^k_oZ
j^[ok>cZonc/k?o_knooj^[Zon_[joo/k>col?3`ono_kooalNl00_o^k^h0
2OoZj^[ok>c/onc/k?o`l?3okno_oo3`k_o]kNgok>c/onWYj@02onk^kP0@
oo3`l?o]kNgojn_YonKVi_oWinOoi^KVon[Zj_o/k>cokno_on[Zj_nBTY7o
Jf][oeYJF_miNGWoclo?on7Qh@;ojn_[00_ojn_Yon[Zj_o_knook^k^oo3`
l?o[jn_oj^[ZonKVi_oWinGoinOWonc/k002on_[j`06onOWiooXj>SoinOW
onc/j_o]kNgok^k^0_oXj>P0D?oVi^Koj^[Zonc/k?o`l>kok^k^oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7a
lOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_
oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooa
lNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_
kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo`l?3okno_
oo3`l?o_knool?3`ono_koo`l?3okno_1?o`l?000003oo;bl_o^k^koinOW
00CoiNGU013oi>CTomoOgooAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;o
ADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@00ooUiNGoi>CTonGU
i002onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5
oe5ADOmVIVKoRXZ:ok6a/OoAdM3og]kN00;oi>CT02SoiNGUonCTi?oUiNGo
i>CTonGUi?oRh^;og=cLolo?coo1`L7o/K6aojVYZOnTY:CoY:BSojBTY?nY
ZJWo/K6aol71`Oo?cloog=cLon;Rh_oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUon?ShooRh^;og=cLomSHf?oDe=CoeMGD
omKFe_oHf=Sof][J0_oNg]h02?oKfm_oeMGEomGEe?oDe=Coe]KFom[Jf_oO
gmoogMgM0_oJf]X01?oOgmkog]kNom_KfooIfMT2omoOg`0=omcLg?oHf=So
gMgLom_KfomADE7oDe=Com?CdooDe=Coe]KFomSHf?oNg]goh>3PomcLg005
omGEe@03omcLfooOgmoogMgM00;oemOG00Sofm_KomcLg?oGemOoeMGDomCD
e?oEeMGoe=CDomWIf@;ogMgM00CoemOGomOGe_oKfm_ogMgM0_oJf]X01OoM
gMgogmoOom[Jf_oFe]Goe=CD00;oeMGE01gofm_KomkNg_oNg]kofMWIom_K
f_oOgmooh>3Pom_KfooJf][ogMgMon?ShooTi>CoiNGTon?ShooPh>3ofMWI
om[Jf_oNg]kohn?SonCTi?oTi>?oh>3PomcLg?oIfMWog]kNon;Rh_oShn?o
g]kNomWIf002omGEe@0KomCDe?oGemOofm_Kon7QhOoNg]koCDe<ogIfM_n6
QXKo>CTioaLG5oo;bl_ogMgMomcLg?oIfMSofm_Kon7QhOoShn?ohN7Qom_K
fooGemOoeMGEomOGe_oIfMWogMgMomkNg_oLg=coemOG00;oe]KF04kofm_J
omkNg_oOgmoof][JomOGeooEeMGof=SHomcLg?oRh^7ohn?SonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoT
i>Coi>CSonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CT
onGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>@4onGUi@06
onCTi?oUiNGoiNGUonGUiOoXj>SokNg]0Oobl_800003ooCdm?o]kNgoinOW
00;oh>3P01?ohN7QomoOgooNg]kod];BokBd]?n7QhOoG5aLofdk=OnNCT;o
cFmOonV3Koo=KeooWTi3ofdk=_mLG5coQhN7okBd]?oBd];og]kN00Goh>3P
017og]kNom;Bd_nd];CoQhN7oeaLG?m]H2coWYH^olg=?ooYjDgocLdooijJ
;om]HbgoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomoOgooJf][oc/k>
okbl_?n[Zj_o/;2`olO7aooIfMWoi>CTomWIfOo7alOo/K6aoj^[Zonl_;co
c/k>om[Jf_oOgml02_oPh>004OoNg]kof][Jom?Cdoo?cloodM7Aokjn__ne
]KGoemOGomSHf?oIfMWoemOGom7AdOo@d=3oa<C4olK6a_o@d=3odM7A00;o
emOG02oodM7Aom?CdooIfMWof=SHom;Bd_oAdM7of=SHomWIfOoDe=CodM7A
omKFe_oGemOoCdm?oe9BD_oBd];o`<30olk>c_o@d=3oeMGEomSHf?oDe=Co
d=3@ol;2`_oBd];oc/k>olg=cOoEeMGofMWIomGEeOo@d=3oa<C4om3@d?oF
e]Kod=3@olG5aOo:b/[oclo?ol[:b_o4a<Cof=SHomGEeOo@d=3oaLG5olo?
cooHf=Sod];Bom7Ad@02omOGe`06om7AdOo@d=3oaLG5olG5aOo@d=3odM7A
0_oGemL02?oAdM7od];BomWIfOoJf][oe=CDom7AdOoHf=Sog]kN0_oPh>00
1_oNg]kofMWIom7AdOoAdM7of=SHomkNgP;ogmoO00Oofm_Kom?CdooAdM7o
f=SHomgMgOoLg=coe]KF00;od=3@02So_[jnolc<c?o@d=3od];BomSHf?oF
e]KodM7Aom3@d?oAdM7obl_;o`d=3OmoOgooemOGomKFe_oAdM7oe=CDom_K
fooNg]kofMWIom7AdOo?cloobl_;ol30`?oHf=Sof][Jom_KfooIfMWodm?C
ol30`?o@d=3od];BomSHf?oKfm_of=SHolW9bOo7alOod=3@omGEeOoKfm_o
gmoO@ooPh>000ooOgmooh>3PomoOg`02omoOg`?oh>3P00?ohN7QonOWioo/
k>`00Oodm?@00003ooKfm_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgo
WinOof]OGon?=RkokG5QooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[
GeooWinOolg=cOoRh^;oinOW00?oj>SX01?oinOWon;Rh_o=cLgoWinOofiV
GonCLR;okM54ooWcM?omoHgooOfEoogmS_oin7KokMM7oi=c8_m^IeooWinO
olg=cOoRh^;oinOW00Coj>SX00Ooi^KVomgMgOo:b/[o]KFeokno_ooWinOo
kno_00?ol?3`00Ookno_onWYjOo1`L7o]KFeol[:b_oMgMgoi^KV00Woj>SX
01KoinOWonGUiOoNg]koe]KFohR8R?lA4A7o20P8ob<S8olH61SoA4A4ol71
`OoMgMgo^KViobh^;_l<30co2PX:oc8b<_nk^k_og=cLomgMgOld=3CoLg=c
0_oPh>00;omWIfOo@410omoOgooQhN7oV9RHo``<3?oMgMgog]kNoe=CDolg
=cOo:b/[oa/K6ol:2P[oT92@om[Jf_oMgMgoc/k>oc0`<?l30`?o8b<SoibL
W?l0003oa<C4on3Ph?oKfm_oBDU9o``<3?mTI6Coh>3Pog=cLol92@Wo410@
ofm_Kolf=SKo8B4QomSHf?oKfm_oDU9Bo`/;2omLG5cohN7QogAdM?lc<c?o
gMgMomcLg?nl_;co<S8b00;o2`/;00co;bl_okNg]ooLg=cogMgMoc/k>om/
K6coh>3Pon7QhOnATI7o5QHFomkNg_oVi^H2onSXj006onKVi_oPh>3oFe]K
ocdm?OoMgMgohn?S0_oVi^H0<OoRh^;oS8b<oa/K6ooNg]koiNGUon;Rh_oJ
f][oUYJFoa<C4olE5AGo10@4oeYJF_o@d=3og=cLom[Jf_nSXj?o?cloocdm
?OnCTi?oAdM7of5QHOoNg]kogMgMo`T92OnMWIgohn?SonGUiOoNg]kob/[:
odm?Col20P;o7QhNoa<C4onGUiOoi>CTofYZJ_l:2P[o820PobXZ:_nWYjOo
hN7Qon3Ph?lP823o3`l?oa`L7?m6ATKoe]KFon?ShooWinL03_oXj>P00ooW
inOoj>SXonSXj00konSXj07ok>c/0Oobl_81ooKfmP0000?omoOgooShn?oh
n?P00oohn?P04oogmoOok^k^olk>c_n@T93oQBl[onUTE_okTXOooZJKooja
YOoo^:_oo[>VoojXW?okU8WokVQIohTa:on@T93oc/k>onk^k_ogmoL00ooh
n?P04oogmoOok^k^olk>c_n@T93oVFT[oo2m?Ookh6koo_B2ooknR_oooi;o
o_j<ookhPookiG3ol<8noiUZ:on@T93oc/k>onk^k_ogmoL01?ohn?P01_od
m?CoinOWolo?coo6a/Koj^[ZooCdm0;onOWi00Won_[jooWinOoinOWom_Kf
on_[joo7alOoclo?onOWioodm?@02Oohn?P05_ogmoOom?Cdonc/k?n<S8co
0P82ohF5QOodm?ComoOgooKfm_n/[:coc/k>onWYjOl_;booCdm?on?ShooR
h^;oD51@oc@d=?oYjNWok>c/ocPh>?mlO7`2ono_k`0mofi^K_m5ADGok^k^
oo3`l?nSXj?o3@d=ong]kOo^k^koFEUIobd];OoFe]Kol_;bohn?Sol51@Go
c/k>on_[jonEUIGo5aLGon7QhOo1`L7o9bLWo`000?oBd];okno_okno_ol0
003od];BooGemOoYjNWo2@T9oiZJV_oMgMgoOWino`000?o7alOol?3`olW9
bOl0003obLW9ooCdm?oalO7oOGemocLg=oo/k>coj^[ZocLg=om8B4SogmoO
onCTi?mFEUKo;Bd]onSXj?o/k>co?cloogAdM?o_knool?3`oiZJV_lH61So
k^k^ooKfmP02ooShn00iooKfm_o`l?3oHF5Qod51@OoWinOok>c/oo3`l?oc
lo?olO7aoiJFU_lL71cok^k^ooCdm?oalO7ob/[:o`H61_n8R8SolO7aol[:
b_lO7aooN7QhonWYjOoMgMgo1`L7oeEEEOnRXZ;oD51@ob8R8_mOGeook^k^
ong]kOl92@WoZ:RXoo;bl_odm?Cok>c/oeUIFOl[:b_o`l?3onOWiooQhN7o
gmoOoo;bl_o2`/;of][JonKVi_n6QXKo=CDeoo?clooalO7o][JfonCTi?oU
iNGo<30`ohn?SooemOGomoOg04Gon?Sh00?omoOgooShn?ohn?P00_ohn?P0
1?ogmoOonOWiooOgmoogmoL1ooShn00000?on_[jooGemOo^k^h00_o/k>`0
;?o[jn_ojNWYomoOgonj^[[oNE9Boklb9?oWM6WooHUnoonHS?onXYKoojRL
oojTV?ooVXgooXYoonifJ_o3<bCoNE9BokZj^_oOgmooj^[Zon_[joo/k>co
jn_/on[Zj_oOgmoo^[ZjohQUD_oRTAconL=@oogJHooojW;oo_=nooojP_on
mWooonacookNI?ojae7ohY8LohUVDonj^[[ogmoOon[Zj_o[jn_ok>c/0_o[
jn/02OoVi^Oof=SHok^k^ooDe=Coi>CTon_[jooalO7ol_;boo?cl`02oo;b
lP06ong]kOoUiNGoeMGEok^k^ooHf=Soi^KW0_o[jn/03oo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>coj^[ZonOWiooHf=So4Q8BoeUIFOoXj>Soj^[[
onc/k002on_[j`15onOWionn_[ko0000oj>SXooRh^?ohn?SoinOWol0003o
`/;2on3Ph?le=CGoM7AdomoOh?oPh>3oIfMWod51@OoOgmooh^;RoiVIVOl<
30coh>3Qon;Rh_mDE5CoEeMGomoOgooTi>Cofm_Ko`T92OmnOWooh>3Pof][
Joll?3coh^;RonOWion_[joo0000olO7b?oShn?oUYJFoa8B4_oPh>3oj>SX
onOWiolF5QKoMWIfomoOgonk^k_o0000ol[:b_oTi>CoWYjNo`P82?oOgn3o
inOWonCTi?mfMWKo=3@don3Ph?o3`l?o0000oiZJVooShn?oh^;RojJVY_l0
003o^k^komoOgoll?3coKFe]00;oh>3P03koTY:BoaHF5_oShn?ojNWYonc/
k?o[jncoj^[Zon?ShomLG5co?CdmomSHf?oJf][ogMgMomoOh?oRh^;oSXj>
oa/K6ooNg]koiNGUon?ShomlO7co2@T9om[Jf_oTi>Coh^;RoeiNG_lU9BGo
g]kNoiZJV_l;2`_og=cLonCTi?oRh^;o?clooeQHF?oQhN7oh>3Po`T92OnN
WYkoh^;RonKVi_oHf=So0@41ohN7QooKfm_of][Kom[Jf_oOgmooi>CTomoO
gooKfm_ob/[:odA4A?ld=3CojNWYonCTi?oNg]kofMWIoj^[ZolB4Q;oRXZ:
on[Zj`;ojn_[00_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/
k>cojn_[onc/k002on_[j`0don_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_o
k>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[
jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/
k0Oojn_[00Gok>c/on_[joo[jn_ok^k^ooKfmP01ooWin@0000?ono_koo?c
loo]kNd00_oUiND0;?oVi^Koi>CTomWIfOnb/[;oNBh^olQ2=?oSJUcom7Y]
oof8O?onUh[ooY^>oojHRoonRWkom7]]onM[GOo:@SCoNbh^ok:b/_oHf=So
i>CTonGUiOoVi^KoiNGVonCTi?oHf=So/[:boiIE;_oZW2_onka4ook<Doom
f6;oo^=bookYMOoniW?oo]]Uoog<Dook`DGokYh[oiUF;_nb/[;of=SHonCT
i?oUiNGoi^KV0_oUiND04OoOgn3odM7AokJf]_oDe=CogMgMonCTi?oVi^Ko
k>c/onc/kOo/k>coj>SXonCTi?oOgmooeMGEokJf]_oAdM7ogmoP00;oiNGU
00ooi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonCTi?oRh^;o][Jfo`00
0?nVYZKohN7QonCTiOoVi^H00_oUiND0AOoShn?oYJFUo`000?o2`/;oemOH
omSHf?nm_Kgo0000ojVYZOoLg=co<c<cog5aLOoEeMKoe]KFofATI?m0@43o
eMGEomSHf?nDU9Co30`<omcLgOoMgMgoDU9BoeADE?oEeMGof=SHomCDe?l^
;RkoI6AUomgMgOmYJFWo?CdmomgMgOoQhN7o_Kfmo`000?o2`/?og=cLoi:B
T_lA4A7oe]KFomkNg_oPh>3o]KFeoc`l??lT92Co?Cdmo`000?o6a/KogMgM
oiZJV_l820Soe]KGomkNg_oMgMgoLg=coc<c<ooLg=coZj^[o`000?nk^kco
f=SHomOGeoo6a/Ko0000oj:RX_oLg=co>c/kofYZJP02omKFeP0Sohj>S_lF
5QKogmoOon?ShooVi^KoiNGVonCTi?oMgMgoFUYJobd];OnVYZKo`<30omCD
e?oDe=Gof][JohZ:R_lJ6Q[oe=CDom_KfooLg=coHf=Sobd];OoFe]Kof=SH
omOGeon1PH7o30`<omcLg?mSHf?o<30`omKFe_oIfMWof=SHoe1@D?mFEUH0
0_oLg=`01ol820SoVIVIomSHf?oMgMgo_;blo`000?l_;bl00olg=cL0DonH
V9SogmoOomOGeomaLG7o20P8oc<c<onk^kcoh^;RomkNg_o0`<3o?Shno`<3
0omVIVKof][JonCTiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^Ko
iNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoV
i^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKo
i^KVonGUiOoVi^KoiNGU00;oi^KV00?oiNGUonKVi_oVi^H00ooVi^H00ooU
iNGokNg]ooCdm001oo_kn`0000?oo?clooShn?oalO400oo^k^h04oo[jn_o
hN7Qokbl_?mj5aOo`clbom=FBOoTJ5[okgM/ooB3NOohQgcomHAjoo=iKOoU
JE_ofEQ:ol@o<_ml5aOo_;blon7QhOo/k>`00oo^k^h04oo/k>cohN7Qokbl
_?nUAaOoiYLbooF/<?om_47ooLUCoog@H?okdfGooM9Pook=E?om_D;onZlb
onVK<_nUAQOo_;blon7QhOo/k>`00oo^k^h02?o]kNgojNWYom[Jf_ni^KWo
emOGomkNg_oShn?oi^KV0ooZj^X02?oXj>Soi>CTomkNg_oHf=So^KViom[J
f_oYjNWokNg]2?o^k^h01oo]kNgojn_[oj6QXOl0003oa/K6onKVi_o[jn/0
1?o/k>`00oo8b<So0000oj6QX@02omoOg`0:oijNW_l0003oc/k>onOWiolf
=SKoIfMWomoOgooNg]koJ6QXoc8b<P;ogmoO00KoVYZJo`d=3OoXj>Soj>SX
oeEEEOmCDe<2omoOg`0SomcLg?l=3@goUiNGonSXj?m^KVko@410onSXj?oZ
j^[oalO7o`000?o;bl_ohn?SoiJFU_lB4Q;ogMgMonCTi?oXj>Soi^KVon;R
h_oPh>3o];Bdo`000?oAdM7oiNGUoinOWol92@Wog=cLon?ShooVi^KoNGUi
ocDe=OoWinOoclo?o`000?nJVYX00_oOgml01_nTY:Co0000olG5aOoWinOo
?Cdmoe1@D0;ogmoO00CoShn?oaLG5ooYjNWokNg]0_o^k^h04Oo/k>coi^KV
oeiNG_l@413o:BTYo`000?li>CWo`/;2on3Ph?nATI7o410@omOGeooQhN7o
iNGUoh:2P_l71`Oof][J00;ogmoO00KoFe]KobTY:OoZj^[oOWino`X:2_oK
fm/2omoOg`0;oe=CDomIFEWoinOWonKVi_l92@WoSHf=on3Ph?oShn?ogMgM
o`000?n5QHD00_nf][H04Ol@413o]kNgon[Zj_n=SHgo4Q8BoibLW?oPh>3o
i^KVon[Zj_oYjNWo=cLgod10@?o3`l?ohn?SonWYjOo/k>cokNg]00gok^k^
00?okNg]onk^k_o^k^h0>oo^k^h00oo]kNgol_;booShn001ooclo0000oom
oOd05_olo?cooOgmoogmoOolo?colo?com7AdOmX1`Oo^3@dolLo<ooBD4?o
fV9Eon=^H_oTLVCoi6mRomaTEooCDD?oc44dokTd=?m[1`Ood];Boo?clool
o?`3oogmo@0Cooclo?oclo?od];Boih[1ooJRSCoji/IooFX:Ooh]3oonKe:
ooRoCOoj_d[onKPoooJZ:_o_WQWofh/doj8]1ooBd];olo?cooclo004oogm
o@07ooWinOo/k>co^;Rhom_KfooQhN7oiNGUonWYj@02onc/k008ong]kOoZ
j^[oiNGUon;Rh_oKfm_o^KVionc/k?oinOT9oogmo@1Eooclo?okno_o`<30
o`000?o4a<Col?3`ooGemOogmoOom_KfooOgmooinOWon_[joclo?om7AdOo
e]KFomCDe?m4A4CoADE5oo_knoojn_[o>SXjoaDE5On;Rh_og]kNocXj>_lN
7QkoHF5Qom[Jf_mZJV[o=cLgoo_knoojn_[oG5aLoa@D5?n1PH7oe=CDogal
O?l10@7oj>SXoo[jn_mgMgOoA4A4oo[jn_okno_oemOGo`000?oMgMgom?Cd
oi^KVolB4Q;oi^KVono_kooinOWo`/;2ol?3`ooclo?oTi>CoaXJ6_oinOWo
m_KfojFUYOl820Soi^KVonk^k_ogmoOoPH61ocTi>Oohn?Sono_kodM7Aom2
@T;odm?ComOGeom:BT[o?3`loo_knoojn_[o@D51oa<C4om`L73oeMGEoeQH
F?m8B4Sono_kooclo002oogmo@0Moo_knoofm_KoI6ATod92@_o^k^koeMGE
ob`/;?lf=SKol_;boifMWOl92@WoD51@olg=cOo/k>cohN7Qo``<3?mlO7co
j>SXokRh^?lI6AWoSXj>ooclo?oNg]ko1`L7oginO_o]kNgobl_;ob8R8_mP
H6000_ojn_X04Ol92@Wo820PojZZZ_oShn?onOWioeUIFOmBDU;oj>SXokBd
]?l@413onOWioo_knon>SXko?Shnoo7alOo]kNgoi^KV00;ono_k00Ko<30`
oiJFU_oemOGogmoOooKfm_olo?a:oogmo@03ooclo?omoOgoo?cl00?ooOgm
0000EOomoOgon_[joo?cloo^k^kol?3`ono_koo^k^kojNWYom?CdomK7Ago
XS@dok@X7Oo1>RgoadTlolmFB_o@Ed_od5M:olY:?_o3>bko]RPMoj8d=?mL
7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>ook^k^on[Zj_oCdm?oS2DMolQa
=?oIQ1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/X2GoiiLEomb87Oo8LCCoS2DM
om?CdooZj^[ok^k^oo3`l?o_knool?3`ono_koo^k^gohn?Sojb/[?o:b/[o
d];BomOGeooJf][ogMgMomkNgOoMgMgog=cLomOGeooDe=Cob/[:ojb/[?oS
hn?ok^k]ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`
l?o^k^kog=cLo`410On=SHgoh>3Pon;RhOoRh^800_oShn<01?oYjNWok>c/
omSHf?m<C4`2o`h>3P0Codm?CooJf][okno_onk^k_m:BT[oQHF5ofIVIOl>
3Pko9RHVol[:b_n<S8co5aLGoahN7_nTY:Cokno^onk^k_mXJ6SoJVYZog=c
L`02oa4A4@0RohJ6Q_o_knkok^k^oginO_mDE5Cokno_onk^k_oAdM7o6ATI
omOGe_o3`l?o410@o`410OlI6AWoE5ADono_konUYJGo>c/joa8B4_lT92Co
TY:Bono_koo<c<co4A4Ao`000?lI6AWoBd];onc/k?n5QHGoBDU9on[Zj_o_
knoofm_Koe1@D0;o3Ph>08_oBd];omSHf?o^k^kokno_oe5ADOn0P7ooLW9b
oa8B4_lZ:R[o];Bdonk^k_o`l?3okno_oo3`koo^k^koj^[ZoemOGolo?coo
g]kNomoOgon8R8So0000omWIfOnOWioo<S8boibLW?lJ6Q[oQXJ6onk^k_ng
]kKo;Bd]o`T92OlG5aOoNGUion_[joo_knook^k^ojb/ZolQ8B7o3@d=od=3
@om@D53oJVYZono_koo^k^ko8B4QoibLW?lk>c_o9RHVono_kooPh>3oD51@
o`h>3_lC4a?oUiNGono_koo^k^kohn?Sodi>C_lG5aOo2`/;ohj>SOo^k^ko
kno_ojn_[old=3Co3Ph>oa4A4OoLg=cokno^ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_ono_
k_o_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_
oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`
l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_
koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_00;ol?3`1_o_knl1
oo?cl`7onOWi0Oono_h00003ookno_ogmoOol?3`00CojNWY017oinOWom_K
fomSBd_oPC8bojHe=Onf=2go`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDe
oh4b<_mSBd_ofm_KonOWi`05onWYj@0AonOWiooKfm_oRD];ojm;<_o=McGo
eX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;oRD];om_KfooW
inL01OoYjNT01_oXj>Sohn?Soj^[Zoni^KWobLW9olo?c`;oeMGE00Woe]KF
omGEeOoDe=Coclo?olS8b?ni^KWoZj^[on?ShooXj>P02_oYjNT01OoXj>So
inOWoeUIFOlQ8B7oc/k>00;ogMgM00Kog]kNomoOgooShn?oinOWonSXj?oY
jNT2onSXj0OojNWY00?oj>SXonWYjOoYjNT00_oYjNT00ooXj>SojNWYonWY
j@04onWYj@03onSXj?oYjNWojNWY00SojNWY0_oXj>P01?nKVi_o4Q8BonOW
iooXj>P3onWYj@03onOWiooYjNWojNWY00;oj>SX00WoXj>So`T92OoWinOo
j>SXonKVi_oShn?oh^;RonKVi_oXj>P00_oYjNT2onSXj0OojNWY00?oj>SX
onWYjOoYjNT01?oYjNT01?oXj>SoiNGUoeeMGOlm?Cd2omgMg@04ofYZJ_lD
51CohN7QonSXj0?ojNWY00Goi^KVonWYjOoYjNWojNWYonKViP07onWYj@03
onOWiooYjNWojNWY00KojNWY00Goi^KVonWYjOoYjNWojNWYonKViP06onWY
j@03onOWiooYjNWojNWY00CojNWY00?oi^KVonWYjOoYjNT0AooYjNT00ooX
j>SojNWYonWYj@04onWYj@7ol?3`0OogmoL1ooknoP0000Goo_knoo[jn_od
m?Cokno_oo7al@02oo3`l00Aono_koo[jn_oUIBDodlS8onEE5Co^g=com>E
UOoJW9cofYjLomVLW?oDUIGo^g=coiEDE?m?8b?oUIBDon[Zj_o_knl01Oo`
l?004Oo_knooj^[ZojVDU?n18b?o^VYDomBJLooT_9Goj/NLonW7W?oZaico
iKbEomBJLonkJUCoPB<SojZDU?oZj^[okno_00Kol?3`00Kok^k^ol_;bonW
YjOob<S8omSHf?oShn<3onKViP06on?ShooHf=Sob<S8ojNWYoo;bl_ok^k^
3?o`l?002Oo_knoog=cLoc`l??lL71coLW9boh^;Rom[Jf_o;2`/ok6a/@02
ono_kb?ol?3`00?ohn?Sol30`?o_knl02Oo`l?000ooUiNGo_[jnono_k`02
ono_k`04ohb<S?m@D53ok^k^ono_ka;ol?3`00Sokno_onk^k_mQHF7o6ATI
oeUIFOl];Bgo0`<3ogIfMP;okno_NOo`l?001?oalO7ol?3`ooCdm?ojn_X1
ooknoP0000ConO_nooooooooooooo_kn0_ooool2ooknoP24oogmoOohn?So
KVi^oeXo?onaT93og/W9oo3Ti?oci^Kol>CTomk9bOnaT93oFSloofe]KOoh
n?Soo?clooooooono_koooooookno_ooookoo_knooooooolo?con?Shohe]
KOn:?coobI6@onW@bOodjNCom^_VooCYi?oYd<WobI6@ohTo?on=KFgon?Sg
ooclo?ooooooo_knooooooono_koooooookno_ooookooOgmooclo?o5aLGo
^[ZjomgMgOoalO7on?ShooWin?ohn?SolO7aomgMgOnj^[[oaLG5ooclo?om
oOgoooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knoooo
ooono_koooooookno_omoOgo/;2`ogmoO_mXJ6SoR8R8oj^[Zoo_knoooOgm
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oo
ooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookn
o_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooon0_ono_h05_o=cLgo/K6aoogmoOoo
ooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookn
o_ooooooo_knooooooono_koooooookno_ooooh2ooknoP1mol;2`_nIVIWo
VIVIojNWYoo=cLgoo_kmookno_ooooooo_knooooooono_koooooookno_oo
ookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookn
o_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooon
o_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knoooo
o_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oo
ooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_h00_oo
ool00oono_koooooooooo`03ooooo`7ooOgm00001?oZl_coo_knoo[jn_od
m?@5oo7al@0=ono_kooFe]KoJf][od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<
od<m?Om[Jf_oe]KFono_k`09oo7al@0=ono_kooGe]KoPf][og@m?OneS8co
eKZjon7<c?oF^[[o]Xb<og8m?On1Jf_oemKFono_k`09oo7al@0=oo3`l?oV
i^Ko_Kfmok2`/?o?cloogmoOonGUiOoOgmooclo?ok2`/?nm_Kgoi^KVoo3`
l02Xoo7al@03oo3`l?oalO7olO7a03?olO7a00Col?3`oo7alOoalO7ol?3`
1?oalO400oodm?Con_[jooknoP01oo[jnP0000Gocmg_oogmoOohn?Sol?3`
on_[j`03on[ZjP0=onWYjOoZj^[ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo
9RHVoeUIFOnKVi_oj>SXonWYj@0;on[ZjP0;onWYjOoXj>SoX9^KofYIFOm3
9RKo;@T9od8V9_mYFEWoX9^KonSXj?oYjNT03?oZj^X02OoYjNWob/[:ok6a
/OnMWIgoTY:BoifMWOna/K7ob/[:onWYj@3Won[ZjP04on_[joo`l?3on?Sh
oogmo@7omOGe00001?nGZL3oinojoo[jn_odm?@8oo7al@;ol?3`0oo_knl2
oo3`l0oolO7a0_o`l?03ono_k`;ol?3`4OoalO43oo3`l:kolO7a00?ol?3`
oo7alOoalO40=OoalO400oo`l?3olO7aoo7al@02oo7al@03ooGemOojn_[o
n?Sh007o^k^k00000onI[lcoY;C8onSan`3oooooobOooooo0OogmoL1okjn
_P7o_kno00001_n^b>SoVJo<oiNY`?o?gNooj_;looSko_oooooo8Oooool0
1OomoOgonOWion_[jonk^k_oa/K6007oh^;R0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{300, 125},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleProgressBar",
        ButtonData:>{"SimpleJProgressBar.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[BoxData[
    \(SimpleProgressBar[]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.ProgressMonitor <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004>0000R1P00`40o`00
0?l0003oo`0000l000000003R<2hB928B9280?m8T8P;B9280@00000000>8
`;S8h=R8`;P0ohS0^0Z8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^0Z8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<1lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<1lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;QVc<c<>oooofG<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hILc<c003IVIVc<c<IVIV03QVIVH00oooolc<c<c<c01Sc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^6G<c<`00fIVI_ooolc<c00gc<c<00=V
IVKoooo<c<`0I<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QUc<c<
00=VIVKoooo<c<`0=lc<c003IVIVooooc<c<06C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hILc<c003IVIVooooc<c<00O<c<`XVIW<2<c<c003
IVIVooooc<c<06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hILc<
c003IVIVooooc<c<00O<c<`00iVIc<c<c<c<c00Tc<c<00>IVLc<c<c<c<`0
1/c<c003IVIVooooc<c<06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hILc<c003IVIVooooc<c<00O<c<`00iVIc<c<c<c<c00Tc<c<00>IVLc<
c<c<c<`01/c<c003IVIVooooc<c<06C<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hILc<c003IVIVooooc<c<00O<c<`00iVIc<c<c<c<c003c<c<
0`0000?<c<`01@000<c<c<c<c<c<c0000002c<c<0P0000;<c<`200001/c<
c0030000c<c<c<c<00G<c<`00iVIc<c<c<c<c006c<c<00=VIVKoooo<c<`0
I<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QUc<c<00=VIVKoooo<
c<`01lc<c003VIW<c<c<000000?<c<`700000/c<c0800002c<c<0P0000?<
c<`200001<c<c0H00003c<c<00>IVLc<c<c<c<`01/c<c003IVIVooooc<c<
06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hILc<c003IVIVoooo
c<c<00O<c<`00iVIc<c<c0000005000000C<c<`0000000000004c<c<0P00
0003c<c<0000000000?<c<`200000lc<c0800004c<c<0`000003c<c<VIW<
c<c<00O<c<`00fIVI_ooolc<c01Tc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^6G<c<`00fIVI_ooolc<c007c<c<00>IVLc<c<c<c<`00P000004
c<c<00000000c<c<0`0000C<c<`:00000lc<c0800005c<c<00@0003<c<c<
c<bIVL`8c<c<00=VIVKoooo<c<`0I<c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;QUc<c<00=VIVKoooo<c<`01lc<c003VIW<c<c<c<c<00T00005
c<c<00@0003<c<`000000003c<c<0P0000?<c<`200002<c<c003VIW<c<c<
c<c<00K<c<`00fIVI_ooolc<c01Tc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^6G<c<`00fIVI_ooolc<c007c<c<00>IVLc<c<c<c<`00P000003
c<c<0000000000@00004c<c<00<0003<c<c<c<`01`0000?<c<`200002<c<
c003VIW<c<c<c<c<00K<c<`00fIVI_ooolc<c01Tc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^6G<c<`00fIVI_ooolc<c007c<c<00>IVLc<c<c<
c<`00P000003c<c<00000000008000000lc<c00000000002c<c<0`000003
c<c<0000000000?<c<`200000lc<c0800008c<c<00>IVLc<c<c<c<`01/c<
c003IVIVooooc<c<06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
ILc<c003IVIVooooc<c<00O<c<`00iVIc<c<c<c<c007000000?<c<`00000
00000lc<c0030000c<c<c<c<00L00003c<c<0P0000S<c<`00iVIc<c<c<c<
c006c<c<00=VIVKoooo<c<`0I<c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;QUc<c<00=VIVKoooo<c<`01lc<c003VIW<c<c<c<c<008000000lc<
c0000000000500001<c<c0P00004c<c<0P0000S<c<`00iVIc<c<c<c<c006
c<c<00=VIVKoooo<c<`0I<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;QUc<c<00=VIVKoooo<c<`01lc<c003VIW<c<c<000000H00007c<c<0P00
0003c<c<0000000000D00003c<c<0P0000S<c<`00iVIc<c<c<c<c006c<c<
00=VIVKoooo<c<`0I<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QU
c<c<00=VIVKoooo<c<`01lc<c003VIW<c<c<c<c<00c<c<`01P000<c<c<c<
c<c<c0000<c<c0<0000?c<c<00>IVLc<c<c<c<`01/c<c003IVIVooooc<c<
06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hILc<c003IVIVoooo
c<c<00O<c<`00iVIc<c<c<c<c00Tc<c<00>IVLc<c<c<c<`01/c<c003IVIV
ooooc<c<06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hILc<c003
IVIVooooc<c<00O<c<`00iVIc<c<c<c<c00Tc<c<00>IVLc<c<c<c<`01/c<
c003IVIVooooc<c<06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
ILc<c003IVIVooooc<c<00O<c<`00iVIc<c<c<c<c00Tc<c<00>IVLc<c<c<
c<`01/c<c003IVIVooooc<c<06C<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2hILc<c003IVIVooooc<c<00O<c<`XVIW<2<c<c003IVIVooooc<c<
06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hILc<c003IVIVoooo
c<c<03O<c<`00fIVI_ooolc<c01Tc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^6G<c<`00fIVI_ooolc<c00gc<c<00=VIVKoooo<c<`0I<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;QUc<c<00=VIVKoooooool0=ooo
o`03c<c<ooooc<c<06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
ILc<c3]VIVIVc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<`7c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^3W<c<c3IVIV2/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pi
c<c<00=VIVIVIYVIVL`0LYVIc4g<c<`00fIVI/c<c<c<c008c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^3W<c<`00fIVIVIVVIVIc01bVIW<CLc<
c003IVIVc<c<c<c<00S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
>Lc<c003IVIVIVJIVIW<07:IVLa=c<c<00=VIVK<c<c<c<`02<c<c0:8`;P1
B9280@00000000B8`;S8h=R8`;R8`;Pic<c<00=VIVIVIYVIVL`0LYVIc4g<
c<`00fIVI/c<c<c<c008c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^3W<c<`00fIVIVIVVIVIc01bVIW<CLc<c003IVIVc<c<c<c<00S<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h>Lc<c003IVIVIVJIVIW<07:IVLa=
c<c<00=VIVK<c<c<c<`02<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;Pic<c<00=VIVIVIYVIVL`0LYVIc4g<c<`00fIVI/c<c<c<c008c<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^3W<c<`00fIVIVIVVIVIc01bVIW<
CLc<c003IVIVc<c<c<c<00S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h>Lc<c003IVIVIVJIVIW<07:IVLa=c<c<00=VIVK<c<c<c<`02<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Pic<c<00=VIVIVIYVIVL`0LYVI
c4g<c<`00fIVI/c<c<c<c008c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^3W<c<`00fIVIVIVVIVIc01bVIW<CLc<c003IVIVc<c<c<c<00S<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h>Lc<c003IVIVIVJIIVJI079V
IYU=VIVI00=VIVK<c<c<c<`02<c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;Pic<c<`fIVIP[<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
olc<c0O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c0O<c<`2
R<2h0DR@R04000000004R<2hb>3HR<2hR<2holc<c0O<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2holc<c0O<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2holc<c0O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
olc<c0O<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h>/c<c0@00003
c<c<10000<7<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h5/c<c007
[JC:TXR/Yik2Rh:TXIVkQWfMWIFe01c<c<`200000/c<c08000000lc<c000
00000002c<c<0P000<3<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
4lc<c00=^JoHWI>k]:[AUhjd[JC:TXR/Yik2Rh:TXIVkQWfMWIFeQWfMWIFe
01W<c<`200000/c<c08000000lc<c00000000002c<c<0P000<3<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h4Lc<c00AYik2_K?MYik2^JoHWI>k
]:[AUhjd[JC:TXR/Yik2Rh:TXIVkQWfMWIFeQWfMWIFeQWfM01O<c<`20000
0/c<c08000000lc<c00000000002c<c<0P000<3<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h4<c<c00CXYO1_K?MXYO1_K?MXYO1^JoHWI>k]:[A
Uhjd[JC:TXN/Yik2Rh:TXIVkQWfMWIFeQWfMWIFeQWfM01K<c<`200000/c<
c08000000lc<c00000000002c<c<0P000<3<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h3lc<c00EXYO1_K?MXYO1_K?MXYO1^JoHYik2^JoHWI>k
]:[AUhjd[JC:TXR/Yik2Rh:TXIVkQWfMWIFeQWfMWIFeQWfM01G<c<`50000
0/c<c0800002c<c<0P000<3<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h3/c<c007Yik2_K?MXYO1^JoHYik2_K?MYik200_Hb_l01HImWIfE]HIm
WIfE]HImW@0Dc<c<0P0000G<c<`200000/c<c0800030c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0g<c<`02JNN`[fcgJ:G`KfcgJNN`[V_f::G
`D4aJ:FGcP09@C5X00OHb_nQVK^6OIfMUKF6OIfMUKF6OId05<c<c0030000
c<c<c<c<008000000lc<c00000000002c<c<0P000<3<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h3<c<c009XYO1_K?MXYO1_K?MXYO1^JoHYik2
^JoH@C5X00?Hb_l03j:G`KV_f9fC^kBZdIN>]=S:ojFGc]S:oh^2Y:6I^hIm
WIfE]HImWIfE]HImW@0Dc<c<0`0000?<c<`40000`Lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P<c<c<00Ri[mNRUl6m/mfWW/:m/mfRUl6i[mRW
W/83@C5X013Hb_nm/mfWW/:i[mRMTk]1<FRUUli1<FRBR:bWW/:;PZBQVK^6
OIfMUKF6OIfMUKGOc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0_<
c<`07KBZdIfC^kV_ej:G`KfcgJ:G`KfcgJNN`[V_f::G`KV_f44aJ=S:oj:G
`KfcgJ:G`KV_f44aJ=S:oiN>]:fTbY:8[:NN`X^2Y:6I^hImWIfE]HImWIfE
]@3Nc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0_<c<`07IN>];BZ
dIfC^kV_ej:G`KfcgJ:G`KfcgJ:G`KfcgJNN`T4aJ=S:okfcgJNN`[V_f::G
`D4aJ=S:okBZdIN>]:fTbY:7[:NN`X^2Y:6I^hImWIfE]HImW@3Nc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0_<c<`07JfTbYN>];BZdIfC^kV_
ej:G`KfcgJ:G`KfcgJ:G`KV_f44aJ=S:oj:G`KfcgJNN`[fcgD4aJ=S:oifC
^kBZdIN>]:fTbY:7[:NN`X^2Y:6I^hImWIfE]@3Nc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^0[<c<`07jNN`Y:7[:fTbYN>];BZdIfC^kV_ej:G
`KfcgJNN`[fcgJNN`T4aJ=S:okfcgJ:G`KV_f:NN`T4aJ=S:okV_f9fC^kBZ
dIN>]:fTbY:8[:NN`X^2Y:6I^hImWIfE]@3Mc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0[<c<`07h^2Y:NN`Y:8[:fTbYN>]:fTbYfC^kV_ej:G
`KfcgJ:G`KfcgD4aJ=S:oj:G`KfcgJNN`[fcgD4aJ=S:oj:G`KV_f9fC^kBZ
dIN>]:fTbY:8[:NN`X^2Y:6I^hImW@3Mc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^0[<c<`07j6I^h^2Y:NN`Y:8[:fTbYN>];BZdIfC^kV_ej:G
`KfcgJ:G`D4aJ=S:okfcgJ:G`KfcgJ:G`D4aJ=S:okfcgJ:G`KV_f9fC^kBZ
dIN>]:fTbY:8[:NN`X^2Y:6I^`3Mc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0[<c<`07hImWJ6I^h^2Y:NN`Y:7[:fTbYN>];BZdIfC^kV_ej:G
`KfcgD4aJ=S:ojNN`[V_f::G`KV_f44aJ=S:ojNN`[fcgJ:G`KV_f9fC^kBZ
dIN>]:fTbY:8[:NN`X^2Y03Mc<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^0[<c<`07ifE]HImWJ6I^h^2Y:NN`Y:7[:fTbYN>]:fTbYfC^kV_ej:G
`D4aJ=S:okfcgJNN`[fcgJNN`T4aJ=S:okfcgJ:G`KV_f:NN`[V_f9fC^kBZ
dIN>]:fTbY:8[:NN`P0Zc<c<0P0003c<c<`200004/c<c0@0001Mc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^0[<c<`03HImWIfE]HImWIfC^h^2
Y:NN`Y:8[:fTbYN>];BZdIfC^kV_ed4aJ005f<[o00fUUlkHb_nRUl6m/mfW
W/:i[mRRUl6i[mRMTk^dZ]6GS[B]Y<ZBR:`0:/c<c080000lc<c<0P00017<
c<`010000<c<c<c<c<c<c080001Lc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^0[<c<`039fE]HImWIfE]HImWIfC^h^2Y:NN`Y:7[:fTbYN>];BZ
dIfC^`M1<FP03::G`KfcgJ:G`KfcgJNN`[fcgJ:G`KV_f9fC^kBZdIN>]:fT
bQ;<c<`400000lc<c0@00002c<c<0P0000;<c<`200000/c<c08000001<c<
c00000000<c<c0800003c<c<0P000003c<c<0000000000;<c<`200000/c<
c0D00002c<c<0P000003c<c<0000000000;<c<`400000/c<c0800002c<c<
0P0000C<c<`2000000?<c<`0000000000/c<c0800004c<c<0P000003c<c<
0000000000;<c<`200001<c<c0@00003c<c<0P000004c<c<00000000c<c<
0P0000C<c<`400000lc<c0@00003c<c<100000;<c<`2000000C<c<`00000
003<c<`20000>Lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P;c<c<
00fMUKF6OIfMUKF6OIfQVK^;PZBWW/:BQjb]Y<ZGS[BdZ]6MTk^i[mL00mS:
o`0=_K?MYik2^JoHXYO1_K?MXYO1_K?MXYO1_K?MXYO1^JoHWI>k]:[A01;<
c<`200000/c<c08000000lc<c00000000002c<c<0P000003c<c<00000000
00;<c<`200000/c<c08000001Lc<c000000000000<c<c002000000C<c<`0
0000003<c<`3000000?<c<`0000000000/c<c0800002c<c<0P000003c<c<
0000000000;<c<`2000000?<c<`0000000000/c<c08000000lc<c0000000
0002c<c<0P0000C<c<`2000000?<c<`0000000000/c<c0800004c<c<0`00
0004c<c<00000000c<c<0P0000?<c<`200000/c<c08000001<c<c0000000
0<c<c0<000000lc<c00000000003c<c<0P0000;<c<`2000000?<c<`00000
00000/c<c08000000lc<c00000000002c<c<0P000004c<c<00000000c<c<
0P000003c<c<0000000003W<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2h2lc<c00=QWfMWIFeQWfMWIFeQWfMXIVkRh:TYik2TXR/[JC:Uhjd]:[A
f<[o00=1<FP03MS:okfcgJNN`[V_f:NN`[V_f:NN`[fcgJ:G`KfcgJ:G`KV_
f9fC^`0Ac<c<0P0000K<c<`200000/c<c08000000lc<c00000000002c<c<
0P0000;<c<`2000000?<c<`0000000000/c<c08000000lc<c00000000002
c<c<0P000003c<c<0000000000;<c<`200000/c<c08000000lc<c0000000
0002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<
c0800004c<c<0P000003c<c<0000000000;<c<`200001<c<c0800002c<c<
0P000003c<c<0000000000?<c<`200000/c<c08000000lc<c00000000002
c<c<0P000003c<c<0000000000?<c<`200002<c<c0<00004c<c<0`0004;<
c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h2lc<c00MWIFeQWfMWIFe
QWfMWIFeQWfMWI>kRh:TYik2TXR/[JC:Uhjd@C5XWI>k^JoGXYO1@C5Xf<[o
_K?MXYO1_K?MXYO1_K?MXYO1_K?MYik2^JoHYik2^JoH017<c<`200001/c<
c0800002c<c<0P000003c<c<0000000000;<c<`200000/c<c08000000lc<
c00000000002c<c<0P000003c<c<0000000000;<c<`2000000?<c<`00000
00000lc<c08000001<c<c00000000<c<c0800002c<c<0P000003c<c<0000
000000;<c<`2000000?<c<`0000000000/c<c0800004c<c<0P000003c<c<
0000000000;<c<`200001<c<c0800002c<c<0P000003c<c<0000000000?<
c<`200000/c<c08000000lc<c00000000002c<c<0P000003c<c<00000000
00?<c<`600000/c<c0@00003c<c<100004?<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h3<c<c00KWIFeQWfMWIFeQWfMWIFeQWfMWI>kRh:TYik2
TXN/@C5Xf<[o]:[AWI>k^JoGXYO1@C5Xf<[o_K?MXYO1^JoHXYO1^JoHXYO1
_K?MYik2_K?M01;<c<`200001/c<c0800002c<c<0P000003c<c<00000000
00;<c<`200000/c<c08000000lc<c00000000002c<c<0P000003c<c<0000
000000;<c<`2000000?<c<`0000000001<c<c0@000000lc<c00000000002
c<c<0P000003c<c<0000000000;<c<`2000000?<c<`0000000000/c<c080
0004c<c<0P000003c<c<0000000000;<c<`200001<c<c0800002c<c<0P00
0003c<c<0000000000?<c<`200000/c<c08000000lc<c00000000002c<c<
0P000003c<c<0000000000?<c<`200000/c<c08000001<c<c00000000000
00C<c<`30000ALc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<
01^6OIfMUKF6OIfMUKF6OIfMUKF6OIfQVK^;PZBWW/91<FSHb_nGS[BdZ]6M
Tk^i[mM1<FSHb_nWW/:m/mfWW/:m/mfWW/:m/mfRUl6m/mfRUl404/c<c080
0007c<c<00<0003<c<c<c<`00P000005c<c<000000000000c<c<00<00000
1<c<c00000000<c<c0<000001<c<c00000000<c<c0800002c<c<0P000003
c<c<0000000000;<c<`010000<c<c<c<c<c<c08000000lc<c00000000002
c<c<0P0000;<c<`00`000<c<c<c<c002000000G<c<`000000000003<c<`0
0P0000C<c<`2000000G<c<`000000000003<c<`00P0000C<c<`3000000C<
c<`00000003<c<`200001<c<c0030000c<c<c<c<008000001<c<c0000000
0<c<c0<000000lc<c00000000003c<c<0P0000;<c<`2000000?<c<`00000
00000/c<c08000000lc<c00000000002c<c<0P0004;<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h3Lc<c00IQWfMWIFeQWfMWIFeQWfMWIFeQWfM
XIVkRh:T@C5Xf<[o[JC:Uhjd]:[AWI>k@C5Xf<[o_K?MXYO1_K?MXYO1^JoH
XYO1^JoHYik201?<c<`200001lc<c0@00002c<c<0P000003c<c<00000000
00;<c<`200000/c<c08000000lc<c00000000002c<c<0P0000;<c<`60000
0/c<c0@000000lc<c00000000002000000?<c<`0000000000/c<c0@00002
c<c<0P000003c<c<0000000000G<c<`2000000C<c<`00000003<c<`20000
1Lc<c08000000lc<c00000000002c<c<100000;<c<`400000lc<c0800000
1<c<c00000000<c<c0@00002c<c<100000?<c<`400000lc<c0@00013c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^0k<c<`02XImWIfE]HImWIfE
]HImWIfE]HImWIfC^h^2Y44aJ0?Hb_l02T4aJ=S:okV_ej:G`KfcgJ:G`Kfc
gJNN`[fcgJNN`QG<c<`200000/c<c080000Qc<c<0P0000W<c<`20000V<c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P?c<c<00V6OIfMUKF6OIfM
UKF6OIfMUKF6OIfQVK^;PZ@00d4aJ009Uhjd]:[AWI>k^JoGXYO1_K?MYik2
^JoHXYO101O<c<`400008lc<c0030000c<c<c<c<00S<c<`00`000<c<c<c<
c00200004/c<c0800020c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^13<c<`04hImWIfE]HImWIfE]HImWIfE]HImWJ6I^h^2Y:NN`Y:7[:fTbYN>
];BZdIfC^kV_ej:G`KV_f:NN`P3Sc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^17<c<`04HImWIfE]HImWIfE]HImWIfE]HImWJ6I^h^2Y:NN`Y:7
[:fTbYN>];BZdIfC^kV_ej:G`@3Tc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^1?<c<`03IfE]HImWIfE]HImWIfE]HImWJ6I^h^2Y:NN`Y:7[:fT
bYN>];BZd@3Vc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1K<c<`0
1ifE]HImWIfE]HImWJ6I^h^2Y:NN`P3Yc<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`7c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P10000000018S0
^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0
^?o<c<`7c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P1000000000hS0
^<SPf8S0^03oR<2h2XS0^058T8P10000000018S0^<SPf8S0^8S0^1@00800
0`01P002P003P@0200B100P01H401X801h81288128<12H<12X<12h<20@b4
00<13H@13XD23hD00P8@Q@030Q660Q:60Q>6008258L00`8EQ`8FQ`<GR002
0aR800P36HT36XT36hT378T378X37HX47XX47h/2122;00P48H/48X`48h`4
98`498d59Hd59Xd59hd21BR>00<5:Hh5:Xl5:hl00PD/S`041Rf@1Rj@1Rn@
1S2A0PHaT@081S:A1S>B1SBB1cFB1cFC1cJC1cNC1cRC0PLiU0031cZD1c^E
23bE0088?ID00`PnUPPoUPQ0UP02246G00<8@YL8@iL9A9P00PU5V0082DJI
2DNI2DRI2DVI2DVJ2DZJ2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M
2e>M2eBM0P]EWP032eJN2eNO2eRO008;FIl010aJX0aKX0aLX0aMX@8<GZ40
20aOX@aPXPaQXPeRXPeRX`eSX`eTX`eUX`8=IZ@00`eWY0eXY@iYY@023VZU
00<>JjH>K:H>KJH00Pi^Y`033VnW3W2W3g6X008?LZP020mcZ@mdZ@meZ@mf
Z@mfZPmgZQ1hZQ1iZ`8@NZ/0211kZa1l[11m[11n[11n[A5o[A60[A61[@8A
PZh00a63[Q64[a65[`024HJ_00@BQk0BR;0BRK0BR[424X^a00PBS;4BSK8B
S[8CSk8CSk<CT;<CTK<CT[<24i>d00<CU;@CUKDDU[D00QBG]@0359Rf59Vf
59Zf008DVkL00aBL]aBM]aFN^0025Inh00PEX;TEXKTEX[TEXkTEXkXEY;XF
YKXFY[/25ZNk00PFZ;/FZK`FZ[`FZk`FZkdG[;dG[KdG[[d25jnn00@G/;hG
/KlG/[lG/klD6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0@00800
0i^WlC=3YC=3Y@09<d>U1000P003006000:000>1008018402005P@06PP07
PP48PP48P`49P`4:P`4;P`8138@00`4=Q04>Q@8?Q@020Q2500<24HH24XH2
4hH00P8DQ`030QF70QJ70aN8008368P020<IR@<JR@<KR@<LR@<LRP<MRP@N
RP@OR`8488/020@QR`@RS0@SS0@TS0@TS@DUS@DVS@DWS@85:8h00`DYSPDZ
S`D[S`021Bb?00@6;I06;Y06;i06<9421S6A00P6<Y46<i86=987=I87=I<7
=Y<7=i<7>9<21cVD00<7>Y@7>iD8?9D00PPmU@0323jF23nF242F0088@IL0
0`Q2U`Q3U`U4V0022DFH00P9AYT9AiT9B9T9BIT9BIX9BYX:BiX:C9/22TfK
00P:CY/:Ci`:D9`:DI`:DId;DYd;Did;E9d22eFN00<;EYh;Eil;F9l00P]I
W`0435ZP35^P35bP35fQ0PaNX@0835nQ362R366R3F:R3F:S3F>S3FBS3FFS
0PeVY0033FNT3FRU3VVU008>JZD00`i[YPi/YPi]YP023VjW00<>KjL>L:L?
LJP00PmbZ0083g>Y3gBY3gFY3gJY3gJZ3gNZ47RZ47V[0Q1jZ`0847^[47b/
47f/47j/47j]4Gn]4H2]4H6]0Q62[P034H>^4HB_4HF_008AQZl011:7/1:8
/1:9/1::/@8BRk4021:</A:=/Q:>/Q>?/Q>?/a>@/a>A/a>B/`8CTk@00a>D
]1>E]ABF]@0259Ne00<DV;HDVKHDV[H00QBK]`0359bg59fg5Ijh008EWkP0
21FP^AFQ^AFR^AFS^AFS^QFT^QJU^QJV^`8FYk/021JX^aJY_1JZ_1J[_1J[
_AN/_AN]_AN^_@8G[kh011N`_QNa_aNb_aNc_a@H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0`00P007VjOaooooSWZfYY_4/jWBZ9g8/jWB00:V
Vl@01KbhgNk^m>[YlOoooc=3Y@03002000<00H000X000h400P04P@0800F1
00J200N20@R20@R30@V30@Z30@^30P4<Q0030@f40@j50Pn5008248D00`8A
QP8BQP8CQP020QB700<25HL25XL35hP00P<HR0080aV90aZ90a^90ab90ab:
0af:11j:11n;0P@PR`08126;12:<12><12B<12B=1BF=1BJ=1BN=0PDXSP03
1BV>1BZ?1B^?0085;8l010H]T0H^T0H_T0H`T@86<I4020HbT@HcTPHdTPLe
TPLeT`LfT`LgT`LhT`87>I@00`LjU0LkU@PlU@0223fE00<8?YH8?iH8@9H0
0PQ1U`0324:G24>G2DBH0089AIP020U6V@U7V@U8V@U9V@U9VPU:VPY;VPY<
V`8:CI/020Y>V`Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@8;EIh00`]FWP]GW`]H
W`022eVO00@<FZ0<Fj0<G:0<GJ4235jQ00P<Gj4<H:8<HJ8=HZ8=HZ<=Hj<=
I:<=IJ<23FJT00<=Ij@=J:D>JJD00PiZY@033V^V3VbV3VfV008>KZL00`i_
Y`i`Y`maZ0023g:X00P?LjT?M:T?MJT?MZT?MZX?MjX@N:X@NJ/247Z[00P@
Nj/@O:`@OJ`@OZ`@OZdAOjdAP:dAPJd24H:^00<APjhAQ:lAQJl00Q66[`04
4XN`4XR`4XV`4XZa0Q:;/@084Xba4Xfb4Xjb4hnb4hnc4i2c4i6c4i:c0Q>C
]0034iBd4iFe59Je008DUkD00aBH]QBI]QBJ]P0259^g00<DW;LDWKLEW[P0
0QFO^0085J2i5J6i5J:i5J>i5J>j5JBj5ZFj5ZJk0QJW^`085ZRk5ZVl5ZZl
5Z^l5Z^m5jbm5jfm5jjm0QN__P045k2n5k6o5k:o5k>o0QRd`10000026;C0
0XS0^058T8P10000000018S0^<SPf8S0^8S0^080080019^WlOooofaJYJnU
bP:l^=d02_omok>Yd_oooooookbhgIN:_:RMb>KVk?oooc=3Y@8008000`01
P002P003P@0200B100P01H401X801h81288128<12H<12X<12h<20@b400<1
3H@13XD23hD00P8@Q@030Q660Q:60Q>6008258L00`8EQ`8FQ`<GR0020aR8
00P36HT36XT36hT378T378X37HX47XX47h/2122;00P48H/48X`48h`498`4
98d59Hd59Xd59hd21BR>00<5:Hh5:Xl5:hl00PD/S`041Rf@1Rj@1Rn@1S2A
0PHaT@081S:A1S>B1SBB1cFB1cFC1cJC1cNC1cRC0PLiU0031cZD1c^E23bE
0088?ID00`PnUPPoUPQ0UP02246G00<8@YL8@iL9A9P00PU5V0082DJI2DNI
2DRI2DVI2DVJ2DZJ2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M
2eBM0P]EWP032eJN2eNO2eRO008;FIl010aJX0aKX0aLX0aMX@8<GZ4020aO
X@aPXPaQXPeRXPeRX`eSX`eTX`eUX`8=IZ@00`eWY0eXY@iYY@023VZU00<>
JjH>K:H>KJH00Pi^Y`033VnW3W2W3g6X008?LZP020mcZ@mdZ@meZ@mfZ@mf
ZPmgZQ1hZQ1iZ`8@NZ/0211kZa1l[11m[11n[11n[A5o[A60[A61[@8APZh0
0a63[Q64[a65[`024HJ_00@BQk0BR;0BRK0BR[424X^a00PBS;4BSK8BS[8C
Sk8CSk<CT;<CTK<CT[<24i>d00<CU;@CUKDDU[D00QBG]@0359Rf59Vf59Zf
008DVkL00aBL]aBM]aFN^0025Inh00PEX;TEXKTEX[TEXkTEXkXEY;XFYKXF
Y[/25ZNk00PFZ;/FZK`FZ[`FZk`FZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG
/[lG/kl26;C000?8h=Q8T8Q8T8P034R@R00300006;C06;C000:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P2002000^KYo7ooonXWLSoooncZM9PC9Z>
N[IhIJjXWLSooooooOl00oooo`08<d>U002000200020oooo00:000>100B1
1oooo`080@Z30@^3oooo0@b40@f40@j50Pn50Q250_ooo`0A0Q:60Q>60QB7
0QB70QF70QJ70aN80aR8oooo0aV90aZ90a^90ab90ab:0af:11j:11n;0084
88/020@QR`@RS0@SS0@TS0@TS@DUS@DVS@DWS@85:8h00`DYSPDZS`D[S`02
1Bb?00@6;I06;Y06;i06<9421S6A00P6<Y46<i86=987=I87=I<7=Y<7=i<7
>9<21cVD00<7>Y@7>iD8?9D00PPmU@0323jF23nF242F0088@IL00`Q2U`Q3
U`U4V0022DFH00P9AYT9AiT9B9T9BIT9BIX9BYX:BiX:C9/22TfK00P:CY/:
Ci`:D9`:DI`:DId;DYd;Did;E9d22eFN00<;EYh;Eil;F9l00P]IW`0435ZP
35^P35bP35fQ0PaNX@0835nQ362R366R3F:R3F:S3F>S3FBS3FFS0PeVY003
3FNT3FRU3VVU008>JZD00`i[YPi/YPi]YP023VjW00<>KjL>L:L?LJP00Pmb
Z0083g>Y3gBY3gFY3gJY3gJZ3gNZ47RZ47V[0Q1jZ`0847^[47b/47f/47j/
47j]4Gn]4H2]4H6]0Q62[P034H>^4HB_4HF_008AQZl011:7/1:8/1:9/1::
/@8BRk4021:</A:=/Q:>/Q>?/Q>?/a>@/a>A/a>B/`8CTk@00a>D]1>E]ABF
]@0259Ne00<DV;HDVKHDV[H00QBK]`0359bg59fg5Ijh008EWkP021FP^AFQ
^AFR^AFS^AFS^QFT^QJU^QJV^`8FYk/021JX^aJY_1JZ_1J[_1J[_AN/_AN]
_AN^_@8G[kh011N`_QNa_aNb_aNc_`8H]<000lSPf8S0^8S0^00;R<2h00A8
T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00>
VjOaoooooooofmc/H4bJThFj/jWB_;SMH4bJVHnnYY_4b<?Ooooo<d>U1000
P00B0060oooo00>1oooo00B100F100J200N20@R20@R30@V30@Z30@^3oooo
0@b40@f40@j50Pn50P8@Q@03oooo0Q:60Q>6008258L05`8EQ`8FQ`<GR0<H
R?ooo`<IR@<JR@<KR@<LR@<LRP<MR_ooo`@ORoooo`@PRoooo`@RS0@SS0@T
S0@TS@DUS@DVS@DWS@021BR>00<5:Hh5:Xl5:hl00PD/S`041Rf@1Rj@1Rn@
1S2A0PHaT@081S:A1S>B1SBB1cFB1cFC1cJC1cNC1cRC0PLiU0031cZD1c^E
23bE0088?ID00`PnUPPoUPQ0UP02246G00<8@YL8@iL9A9P00PU5V0082DJI
2DNI2DRI2DVI2DVJ2DZJ2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M
2e>M2eBM0P]EWP032eJN2eNO2eRO008;FIl010aJX0aKX0aLX0aMX@8<GZ40
20aOX@aPXPaQXPeRXPeRX`eSX`eTX`eUX`8=IZ@00`eWY0eXY@iYY@023VZU
00<>JjH>K:H>KJH00Pi^Y`033VnW3W2W3g6X008?LZP020mcZ@mdZ@meZ@mf
Z@mfZPmgZQ1hZQ1iZ`8@NZ/0211kZa1l[11m[11n[11n[A5o[A60[A61[@8A
PZh00a63[Q64[a65[`024HJ_00@BQk0BR;0BRK0BR[424X^a00PBS;4BSK8B
S[8CSk8CSk<CT;<CTK<CT[<24i>d00<CU;@CUKDDU[D00QBG]@0359Rf59Vf
59Zf008DVkL00aBL]aBM]aFN^0025Inh00PEX;TEXKTEX[TEXkTEXkXEY;XF
YKXFY[/25ZNk00PFZ;/FZK`FZ[`FZk`FZkdG[;dG[KdG[[d25jnn00@G/;hG
/KlG/[lG/kl26;C000?8h=R8`;R8`;P02hS0^004B92800006;C06;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0<008003Y^WlOoookbhgIV?__oo
omKAgM_Lk??nojJKa>k^m8Ef/9>5^_oooc=3Y@<008000`01P002P?ooo`02
00B11_ooo`070@Z30@^3oooo0@b40@f40@j50Pn5008248D00oooo`8BQP8C
QP020QB700d25HL25XL35hP368Soool36HT36XT36hT378T378X37HX47XX4
7h/00P@PR`08126;12:<12><12B<12B=1BF=1BJ=1BN=0PDXSP031BV>1BZ?
1B^?0085;8l010H]T0H^T0H_T0H`T@86<I4020HbT@HcTPHdTPLeTPLeT`Lf
T`LgT`LhT`87>I@00`LjU0LkU@PlU@0223fE00<8?YH8?iH8@9H00PQ1U`03
24:G24>G2DBH0089AIP020U6V@U7V@U8V@U9V@U9VPU:VPY;VPY<V`8:CI/0
20Y>V`Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@8;EIh00`]FWP]GW`]HW`022eVO
00@<FZ0<Fj0<G:0<GJ4235jQ00P<Gj4<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<2
3FJT00<=Ij@=J:D>JJD00PiZY@033V^V3VbV3VfV008>KZL00`i_Y`i`Y`ma
Z0023g:X00P?LjT?M:T?MJT?MZT?MZX?MjX@N:X@NJ/247Z[00P@Nj/@O:`@
OJ`@OZ`@OZdAOjdAP:dAPJd24H:^00<APjhAQ:lAQJl00Q66[`044XN`4XR`
4XV`4XZa0Q:;/@084Xba4Xfb4Xjb4hnb4hnc4i2c4i6c4i:c0Q>C]0034iBd
4iFe59Je008DUkD00aBH]QBI]QBJ]P0259^g00<DW;LDWKLEW[P00QFO^008
5J2i5J6i5J:i5J>i5J>j5JBj5ZFj5ZJk0QJW^`085ZRk5ZVl5ZZl5Z^l5Z^m
5jbm5jfm5jjm0QN__P045k2n5k6o5k:o5k>o0QRd`004b>3HR<2hR<2hR<2h
0P0000B8`;P200000XS0^004B92800006;C06;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^0<008003i^WlOoooiV?_YN:_=CCj>n//omfNnjOZe]H
YJJKa9JOdV1<V[bhgOoooc=3Y@02002000<00H000X3oool00P04P@0=oooo
00J200N2oooo0@R30@V30@Z30@^3oooo0@b40@f40@j50Pn5008248D00ooo
o`8BQP8CQP020QB700d25HL25XL35hP368Soool36HT36XT36hT378T378X3
7HX47XX47h/00P@PR`08126;12:<12><12B<12B=1BF=1BJ=1BN=0PDXSP03
1BV>1BZ?1B^?0085;8l010H]T0H^T0H_T0H`T@86<I4020HbT@HcTPHdTPLe
TPLeT`LfT`LgT`LhT`87>I@00`LjU0LkU@PlU@0223fE00<8?YH8?iH8@9H0
0PQ1U`0324:G24>G2DBH0089AIP020U6V@U7V@U8V@U9V@U9VPU:VPY;VPY<
V`8:CI/020Y>V`Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@8;EIh00`]FWP]GW`]H
W`022eVO00@<FZ0<Fj0<G:0<GJ4235jQ00P<Gj4<H:8<HJ8=HZ8=HZ<=Hj<=
I:<=IJ<23FJT00<=Ij@=J:D>JJD00PiZY@033V^V3VbV3VfV008>KZL00`i_
Y`i`Y`maZ0023g:X00P?LjT?M:T?MJT?MZT?MZX?MjX@N:X@NJ/247Z[00P@
Nj/@O:`@OJ`@OZ`@OZdAOjdAP:dAPJd24H:^00<APjhAQ:lAQJl00Q66[`04
4XN`4XR`4XV`4XZa0Q:;/@084Xba4Xfb4Xjb4hnb4hnc4i2c4i6c4i:c0Q>C
]0034iBd4iFe59Je008DUkD00aBH]QBI]QBJ]P0259^g00<DW;LDWKLEW[P0
0QFO^0085J2i5J6i5J:i5J>i5J>j5JBj5ZFj5ZJk0QJW^`085ZRk5ZVl5ZZl
5Z^l5Z^m5jbm5jfm5jjm0QN__P045k2n5k6o5k:o5k>o0QRd`003b>3HR<2h
R<2h00:8`;P200000XS0^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOXZFjP
b<?OThFjFdJCVHnn0WQU[P04@RN5[jG:oooo<d>U0P00P003006000:0oooo
00801846oooo00L12X<12h?oool138@13H@13XD23hD00P8@Q@04oooo0Q:6
0Q>60QB72oooo`030af:11j:11n;008488/020@QR`@RS0@SS0@TS0@TS@DU
S@DVS@DWS@85:8h00`DYSPDZS`D[S`021Bb?00@6;I06;Y06;i06<9421S6A
00P6<Y46<i86=987=I87=I<7=Y<7=i<7>9<21cVD00<7>Y@7>iD8?9D00PPm
U@0323jF23nF242F0088@IL00`Q2U`Q3U`U4V0022DFH00P9AYT9AiT9B9T9
BIT9BIX9BYX:BiX:C9/22TfK00P:CY/:Ci`:D9`:DI`:DId;DYd;Did;E9d2
2eFN00<;EYh;Eil;F9l00P]IW`0435ZP35^P35bP35fQ0PaNX@0835nQ362R
366R3F:R3F:S3F>S3FBS3FFS0PeVY0033FNT3FRU3VVU008>JZD00`i[YPi/
YPi]YP023VjW00<>KjL>L:L?LJP00PmbZ0083g>Y3gBY3gFY3gJY3gJZ3gNZ
47RZ47V[0Q1jZ`0847^[47b/47f/47j/47j]4Gn]4H2]4H6]0Q62[P034H>^
4HB_4HF_008AQZl011:7/1:8/1:9/1::/@8BRk4021:</A:=/Q:>/Q>?/Q>?
/a>@/a>A/a>B/`8CTk@00a>D]1>E]ABF]@0259Ne00<DV;HDVKHDV[H00QBK
]`0359bg59fg5Ijh008EWkP021FP^AFQ^AFR^AFS^AFS^QFT^QJU^QJV^`8F
Yk/021JX^aJY_1JZ_1J[_1J[_AN/_AN]_AN^_@8G[kh011N`_QNa_aNb_aNc
_`8H]<000lSPf8S0^8S0^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7oooooool00_oo
o`0:ojf`ogIknLgDoNg^ooooYY_4QGJ`_;SMoooo<d>U0`00P003006000:0
oooo008018401oooo`06PP07P_ooo`48P`49P`4:P`02oooo00@138@13H@1
3XD23hD20Q2501;oool24XH24hH258Ooool25HL25XL35hP368Soool36HT3
6XT36hT378Woool37HX47XX47h/2122;00P48H/48X`48h`498`498d59Hd5
9Xd59hd21BR>00<5:Hh5:Xl5:hl00PD/S`041Rf@1Rj@1Rn@1S2A0PHaT@08
1S:A1S>B1SBB1cFB1cFC1cJC1cNC1cRC0PLiU0031cZD1c^E23bE0088?ID0
0`PnUPPoUPQ0UP02246G00<8@YL8@iL9A9P00PU5V0082DJI2DNI2DRI2DVI
2DVJ2DZJ2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]E
WP032eJN2eNO2eRO008;FIl010aJX0aKX0aLX0aMX@8<GZ4020aOX@aPXPaQ
XPeRXPeRX`eSX`eTX`eUX`8=IZ@00`eWY0eXY@iYY@023VZU00<>JjH>K:H>
KJH00Pi^Y`033VnW3W2W3g6X008?LZP020mcZ@mdZ@meZ@mfZ@mfZPmgZQ1h
ZQ1iZ`8@NZ/0211kZa1l[11m[11n[11n[A5o[A60[A61[@8APZh00a63[Q64
[a65[`024HJ_00@BQk0BR;0BRK0BR[424X^a00PBS;4BSK8BS[8CSk8CSk<C
T;<CTK<CT[<24i>d00<CU;@CUKDDU[D00QBG]@0359Rf59Vf59Zf008DVkL0
0aBL]aBM]aFN^0025Inh00PEX;TEXKTEX[TEXkTEXkXEY;XFYKXFY[/25ZNk
00PFZ;/FZK`FZ[`FZk`FZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG/kl2
6;C000?8h=R8`;R8`;P018S0^0800005R<2h00A8T8P0000H]<0H]<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0`00P00:XJcbnLgDhRHlm;FohRHl
m6emo>?YoooooNg^ojf`0_ooo`03<d>U0020002000800803oooo0P04P@Ko
ool01@4:P`4;Poooo`4<Q04=Q007oooo00l258Ooool25HL25XL35hP368So
ool36HT36XT36hT378Woool37HX47XX47h/00P@PR`08126;12:<12><12B<
12B=1BF=1BJ=1BN=0PDXSP031BV>1BZ?1B^?0085;8l010H]T0H^T0H_T0H`
T@86<I4020HbT@HcTPHdTPLeTPLeT`LfT`LgT`LhT`87>I@00`LjU0LkU@Pl
U@0223fE00<8?YH8?iH8@9H00PQ1U`0324:G24>G2DBH0089AIP020U6V@U7
V@U8V@U9V@U9VPU:VPY;VPY<V`8:CI/020Y>V`Y?W0Y@W0YAW0YAW@]BW@]C
W@]DW@8;EIh00`]FWP]GW`]HW`022eVO00@<FZ0<Fj0<G:0<GJ4235jQ00P<
Gj4<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<23FJT00<=Ij@=J:D>JJD00PiZY@03
3V^V3VbV3VfV008>KZL00`i_Y`i`Y`maZ0023g:X00P?LjT?M:T?MJT?MZT?
MZX?MjX@N:X@NJ/247Z[00P@Nj/@O:`@OJ`@OZ`@OZdAOjdAP:dAPJd24H:^
00<APjhAQ:lAQJl00Q66[`044XN`4XR`4XV`4XZa0Q:;/@084Xba4Xfb4Xjb
4hnb4hnc4i2c4i6c4i:c0Q>C]0034iBd4iFe59Je008DUkD00aBH]QBI]QBJ
]P0259^g00<DW;LDWKLEW[P00QFO^0085J2i5J6i5J:i5J>i5J>j5JBj5ZFj
5ZJk0QJW^`085ZRk5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm0QN__P045k2n5k6o
5k:o5k>o0QRd`003b>3HR<2hR<2h00>8`;P4000018S0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^08008003I^WlOg]k^8V
??ken?N9UoARK_>P[_ARK_omoon]/?cSjOoooc=3Y@05002000@00H000X00
0h401842oooo00`01X801h;oool128<12H<12X<12h<138Coool13H@13XD2
3hD20Q2501824HH24XH24hH258Ooool25HL25XL35hP368Soool36HT36XT3
6hT378Woool37HX47XX47h/2122;00P48H/48X`48h`498`498d59Hd59Xd5
9hd21BR>00<5:Hh5:Xl5:hl00PD/S`041Rf@1Rj@1Rn@1S2A0PHaT@081S:A
1S>B1SBB1cFB1cFC1cJC1cNC1cRC0PLiU0031cZD1c^E23bE0088?ID00`Pn
UPPoUPQ0UP02246G00<8@YL8@iL9A9P00PU5V0082DJI2DNI2DRI2DVI2DVJ
2DZJ2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP03
2eJN2eNO2eRO008;FIl010aJX0aKX0aLX0aMX@8<GZ4020aOX@aPXPaQXPeR
XPeRX`eSX`eTX`eUX`8=IZ@00`eWY0eXY@iYY@023VZU00<>JjH>K:H>KJH0
0Pi^Y`033VnW3W2W3g6X008?LZP020mcZ@mdZ@meZ@mfZ@mfZPmgZQ1hZQ1i
Z`8@NZ/0211kZa1l[11m[11n[11n[A5o[A60[A61[@8APZh00a63[Q64[a65
[`024HJ_00@BQk0BR;0BRK0BR[424X^a00PBS;4BSK8BS[8CSk8CSk<CT;<C
TK<CT[<24i>d00<CU;@CUKDDU[D00QBG]@0359Rf59Vf59Zf008DVkL00aBL
]aBM]aFN^0025Inh00PEX;TEXKTEX[TEXkTEXkXEY;XFYKXFY[/25ZNk00PF
Z;/FZK`FZ[`FZk`FZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG/kl26;C0
00?8h=R8`;R8`;P00XS0^0800002R<2h0P0000>8`;P014R@R00001Rd`1Rd
`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000>KYo7fb<cR9S`0
0_n]/007gb@^ojBNm[c5ojf`kW^<oooo<d>U00H008000`01P002P003P@02
00B11_ooo`070@Z3oooo0@b40@b4oooo0@j50Pn5008248D0108AQP8BQP8C
QP8DQ`_oool00`<MRP@NRP@OR`02122;00P48H/48X`48h`498`498d59Hd5
9Xd59hd21BR>00<5:Hh5:Xl5:hl00PD/S`041Rf@1Rj@1Rn@1S2A0PHaT@08
1S:A1S>B1SBB1cFB1cFC1cJC1cNC1cRC0PLiU0031cZD1c^E23bE0088?ID0
0`PnUPPoUPQ0UP02246G00<8@YL8@iL9A9P00PU5V0082DJI2DNI2DRI2DVI
2DVJ2DZJ2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]E
WP032eJN2eNO2eRO008;FIl010aJX0aKX0aLX0aMX@8<GZ4020aOX@aPXPaQ
XPeRXPeRX`eSX`eTX`eUX`8=IZ@00`eWY0eXY@iYY@023VZU00<>JjH>K:H>
KJH00Pi^Y`033VnW3W2W3g6X008?LZP020mcZ@mdZ@meZ@mfZ@mfZPmgZQ1h
ZQ1iZ`8@NZ/0211kZa1l[11m[11n[11n[A5o[A60[A61[@8APZh00a63[Q64
[a65[`024HJ_00@BQk0BR;0BRK0BR[424X^a00PBS;4BSK8BS[8CSk8CSk<C
T;<CTK<CT[<24i>d00<CU;@CUKDDU[D00QBG]@0359Rf59Vf59Zf008DVkL0
0aBL]aBM]aFN^0025Inh00PEX;TEXKTEX[TEXkTEXkXEY;XFYKXFY[/25ZNk
00PFZ;/FZK`FZ[`FZk`FZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG/kl2
6;C000C8h=R8`;R8`;R8`;P2000018S0^0800002R<2h00A8T8P0000H]<0H
]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h0P00P003VjOanLgDmhVG
00;oool01on]/>4F=?mfNonTW^8V??n9Oc=3Y@06002000<00H000X3oool0
0P04P@0<oooo00J200N2oooo0@R30@V30@Z30@^3oooo0@b40@f40@j51Ooo
o`0@0Q>60QB70QB70QF70QJ70aN80aR8oooo0aV90aZ90a^90ab90ab:0af:
11j:11n;0P@PR`08126;12:<12><12B<12B=1BF=1BJ=1BN=0PDXSP031BV>
1BZ?1B^?0085;8l010H]T0H^T0H_T0H`T@86<I4020HbT@HcTPHdTPLeTPLe
T`LfT`LgT`LhT`87>I@00`LjU0LkU@PlU@0223fE00<8?YH8?iH8@9H00PQ1
U`0324:G24>G2DBH0089AIP020U6V@U7V@U8V@U9V@U9VPU:VPY;VPY<V`8:
CI/020Y>V`Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@8;EIh00`]FWP]GW`]HW`02
2eVO00@<FZ0<Fj0<G:0<GJ4235jQ00P<Gj4<H:8<HJ8=HZ8=HZ<=Hj<=I:<=
IJ<23FJT00<=Ij@=J:D>JJD00PiZY@033V^V3VbV3VfV008>KZL00`i_Y`i`
Y`maZ0023g:X00P?LjT?M:T?MJT?MZT?MZX?MjX@N:X@NJ/247Z[00P@Nj/@
O:`@OJ`@OZ`@OZdAOjdAP:dAPJd24H:^00<APjhAQ:lAQJl00Q66[`044XN`
4XR`4XV`4XZa0Q:;/@084Xba4Xfb4Xjb4hnb4hnc4i2c4i6c4i:c0Q>C]003
4iBd4iFe59Je008DUkD00aBH]QBI]QBJ]P0259^g00<DW;LDWKLEW[P00QFO
^0085J2i5J6i5J:i5J>i5J>j5JBj5ZFj5ZJk0QJW^`085ZRk5ZVl5ZZl5Z^l
5Z^m5jbm5jfm5jjm0QN__P045k2n5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h
00^8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;P2002000NKYo7oooocX:kdHVkoooogRIOicM@00_ooo`03lj2^oooo<d>U
00H008000`01P?ooo`03P@0200B100d01H7oool01h8128;oool12H<12X<1
2h<138Coool13H@13XD23hD00P8@Q@030Q660Q:60Q>6008258L03@8EQ`8F
Q`<GR0<HR?ooo`<IR@<JR@<KR@<LR@<LRP<MRP@NRP@OR`02122;00P48H/4
8X`48h`498`498d59Hd59Xd59hd21BR>00<5:Hh5:Xl5:hl00PD/S`041Rf@
1Rj@1Rn@1S2A0PHaT@081S:A1S>B1SBB1cFB1cFC1cJC1cNC1cRC0PLiU003
1cZD1c^E23bE0088?ID00`PnUPPoUPQ0UP02246G00<8@YL8@iL9A9P00PU5
V0082DJI2DNI2DRI2DVI2DVJ2DZJ2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L
2U6M2e:M2e>M2eBM0P]EWP032eJN2eNO2eRO008;FIl010aJX0aKX0aLX0aM
X@8<GZ4020aOX@aPXPaQXPeRXPeRX`eSX`eTX`eUX`8=IZ@00`eWY0eXY@iY
Y@023VZU00<>JjH>K:H>KJH00Pi^Y`033VnW3W2W3g6X008?LZP020mcZ@md
Z@meZ@mfZ@mfZPmgZQ1hZQ1iZ`8@NZ/0211kZa1l[11m[11n[11n[A5o[A60
[A61[@8APZh00a63[Q64[a65[`024HJ_00@BQk0BR;0BRK0BR[424X^a00PB
S;4BSK8BS[8CSk8CSk<CT;<CTK<CT[<24i>d00<CU;@CUKDDU[D00QBG]@03
59Rf59Vf59Zf008DVkL00aBL]aBM]aFN^0025Inh00PEX;TEXKTEX[TEXkTE
XkXEY;XFYKXFY[/25ZNk00PFZ;/FZK`FZ[`FZk`FZkdG[;dG[KdG[[d25jnn
00@G/;hG/KlG/[lG/kl26;C000?8h=R8`;R8`;P02hS0^004B92800006;C0
6;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<008002i^WlOoooon9
Oooooo>P[_6CXOooooomoo>P[_oko3=3Y@06002000<00H000X000h400P04
P@0800F100J200N20@R20@R30@V30@Z30@^30P4<Q0030@f40@j50Pn50082
48D00`8AQP8BQP8CQP020QB700<25HL25XL35hP00P<HR0080aV90aZ90a^9
0ab90ab:0af:11j:11n;0P@PR`08126;12:<12><12B<12B=1BF=1BJ=1BN=
0PDXSP031BV>1BZ?1B^?0085;8l010H]T0H^T0H_T0H`T@86<I4020HbT@Hc
TPHdTPLeTPLeT`LfT`LgT`LhT`87>I@00`LjU0LkU@PlU@0223fE00<8?YH8
?iH8@9H00PQ1U`0324:G24>G2DBH0089AIP020U6V@U7V@U8V@U9V@U9VPU:
VPY;VPY<V`8:CI/020Y>V`Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@8;EIh00`]F
WP]GW`]HW`022eVO00@<FZ0<Fj0<G:0<GJ4235jQ00P<Gj4<H:8<HJ8=HZ8=
HZ<=Hj<=I:<=IJ<23FJT00<=Ij@=J:D>JJD00PiZY@033V^V3VbV3VfV008>
KZL00`i_Y`i`Y`maZ0023g:X00P?LjT?M:T?MJT?MZT?MZX?MjX@N:X@NJ/2
47Z[00P@Nj/@O:`@OJ`@OZ`@OZdAOjdAP:dAPJd24H:^00<APjhAQ:lAQJl0
0Q66[`044XN`4XR`4XV`4XZa0Q:;/@084Xba4Xfb4Xjb4hnb4hnc4i2c4i6c
4i:c0Q>C]0034iBd4iFe59Je008DUkD00aBH]QBI]QBJ]P0259^g00<DW;LD
WKLEW[P00QFO^0085J2i5J6i5J:i5J>i5J>j5JBj5ZFj5ZJk0QJW^`085ZRk
5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm0QN__P045k2n5k6o5k:o5k>o0QRd`0o8
h=P00`0001Rd`1Rd`002R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1000
P0>KYo401_oooo>P[_Be_oJlaO_IfS=3Y@L008000`01P002P003P@0200B1
00P01H401X801h81288128<12H<12X<12h<20@b400<13H@13XD23hD00P8@
Q@030Q660Q:60Q>6008258L00`8EQ`8FQ`<GR0020aR800P36HT36XT36hT3
78T378X37HX47XX47h/2122;00P48H/48X`48h`498`498d59Hd59Xd59hd2
1BR>00<5:Hh5:Xl5:hl00PD/S`041Rf@1Rj@1Rn@1S2A0PHaT@081S:A1S>B
1SBB1cFB1cFC1cJC1cNC1cRC0PLiU0031cZD1c^E23bE0088?ID00`PnUPPo
UPQ0UP02246G00<8@YL8@iL9A9P00PU5V0082DJI2DNI2DRI2DVI2DVJ2DZJ
2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN
2eNO2eRO008;FIl010aJX0aKX0aLX0aMX@8<GZ4020aOX@aPXPaQXPeRXPeR
X`eSX`eTX`eUX`8=IZ@00`eWY0eXY@iYY@023VZU00<>JjH>K:H>KJH00Pi^
Y`033VnW3W2W3g6X008?LZP020mcZ@mdZ@meZ@mfZ@mfZPmgZQ1hZQ1iZ`8@
NZ/0211kZa1l[11m[11n[11n[A5o[A60[A61[@8APZh00a63[Q64[a65[`02
4HJ_00@BQk0BR;0BRK0BR[424X^a00PBS;4BSK8BS[8CSk8CSk<CT;<CTK<C
T[<24i>d00<CU;@CUKDDU[D00QBG]@0359Rf59Vf59Zf008DVkL00aBL]aBM
]aFN^0025Inh00PEX;TEXKTEX[TEXkTEXkXEY;XFYKXFY[/25ZNk00PFZ;/F
ZK`FZ[`FZk`FZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG/klD6;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^1@008000`01P002P003P@0200B1
00P01H401X801h81288128<12H<12X<12h<20@b400<13H@13XD23hD00P8@
Q@030Q660Q:60Q>6008258L00`8EQ`8FQ`<GR0020aR800P36HT36XT36hT3
78T378X37HX47XX47h/2122;00P48H/48X`48h`498`498d59Hd59Xd59hd2
1BR>00<5:Hh5:Xl5:hl00PD/S`041Rf@1Rj@1Rn@1S2A0PHaT@081S:A1S>B
1SBB1cFB1cFC1cJC1cNC1cRC0PLiU0031cZD1c^E23bE0088?ID00`PnUPPo
UPQ0UP02246G00<8@YL8@iL9A9P00PU5V0082DJI2DNI2DRI2DVI2DVJ2DZJ
2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN
2eNO2eRO008;FIl010aJX0aKX0aLX0aMX@8<GZ4020aOX@aPXPaQXPeRXPeR
X`eSX`eTX`eUX`8=IZ@00`eWY0eXY@iYY@023VZU00<>JjH>K:H>KJH00Pi^
Y`033VnW3W2W3g6X008?LZP020mcZ@mdZ@meZ@mfZ@mfZPmgZQ1hZQ1iZ`8@
NZ/0211kZa1l[11m[11n[11n[A5o[A60[A61[@8APZh00a63[Q64[a65[`02
4HJ_00@BQk0BR;0BRK0BR[424X^a00PBS;4BSK8BS[8CSk8CSk<CT;<CTK<C
T[<24i>d00<CU;@CUKDDU[D00QBG]@0359Rf59Vf59Zf008DVkL00aBL]aBM
]aFN^0025Inh00PEX;TEXKTEX[TEXkTEXkXEY;XFYKXFY[/25ZNk00PFZ;/F
ZK`FZ[`FZk`FZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG/klD6;C00XS0
^058T8P1000000000hS0^<SPf8S0^03oR<2h2XS0^058T8P1000000000hS0
^<SPf8S0^03oR<2h2XS0^058T8P1000000000hS0^<SPf<SPf03ob>3H2/SP
f058T8P10000003oR<2h3XS0^04000000001\
\>"], "Graphics",
  ImageSize->{270, 136},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000460000Ub000`400?l00000o`00003oooo`l?07
oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07
oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07
oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooooool7
ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7
onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00Z_o^k^h2ong]k@0:on_[jooX
j>SoiNGUon;Rh_oMgMgof=SHomCDe?oAdM7oc/k>olc<c0;obl_;=Oo:b/X2ol_;b`0:olc<c?o>c/ko
dM7AomCDe?oHf=SogMgMon;Rh_oUiNGoj>SXon_[j`;okNg]2oo^k^h00:Woi^KV0_oUiND02_oRh^;o
h>3Pom_KfooFe]Koc/k>olO7aono_koo^;RhokBd]?n`/;02ojj^[P;o[Jf]<on/[:`2ojf][@;o[Zj^
00[o/;2`okBd]?nh^;So_knoolO7aoo>c/koe]KFom_KfooPh>3oh^;R0_oUiND:onKViP00ZOo^k^h0
3_o]kNgoj^[ZonOWiooRh^;ofMWIolk>c_o3`l?o^;Rhojj^[_nVYZKoX:2PoibLW?nIVIWoV9RH=onG
UiL03OnHV9SoVIVIoibLW?nPX:3oYZJVojj^[_nh^;So`l?3olk>c_oIfMWoh^;RonOWiooZj^X00_o]
kNd9onk^kP00ZOooool03_olo?conOWioo;bl_oXj>Sof][Jol_;bonj^[[o[:b/oinOWonEUIGoSXj>
ohZ:R_n7QhOoQXJ6=on5QHD03on6QXKoQhN7ohZ:R_n>SXkoUIFEoinOWon/[:co^[Zjol_;booJf][o
j>SXoo;bl_oinOWoo?clooknoP09ooooo`00ZOo^k^h05?oXj>Soh^;RomWIfOo:b/[o^[ZjojRXZ?nH
V9SoTY:BojFUYOo0`<3oemOGon_[joofm_KomoOgooWinOohn?SonOWioo[jn_oinOWomoOg0oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi01?on_[jooWinOohn?SonOWiooShn?ogmoOokNg]omSHf?o1`L7oYJFUoi:BT_nHV9So
Z:RXokZj^_o:b/[ofMWIon;Rh_oXj>Sok>c/00Wok^k^002YonKViP0<omgMgOoFe]KoalO7okNg]onS
Xj?oTI6Aoj:RX_o;bl_ok^k^ooKfm_olo?coo_kn>oooool03Oono_koo?clooOgmoo_knooc<c<oj>S
XonATI7oXj>SokNg]oo7alOoe]KFomgMgOoRh^802OoVi^H00:Wok^k^00[oh^;RomKFe_o3`l?o[Zj^
oiZJV_n][Jgog]kNon_[joodm?Cono_k?oooool02ookno_olo?conc/k?oQhN7o/;2`oiZJV_n^[Zko
`l?3omKFe_oRh^;oj>SX00Wok^k^002Yooooo`0:ong]kOoLg=coaLG5ojb/[?n][Jgoe=CDon3Ph?o/
k>comOGeoogmoCoooooo00_oo_knooKfm_o/k>coh^;RomWIfOna/K7o[:b/olG5aOoLg=cokNg]ooKf
mP09ooooo`00ZOo^k^h02ooHf=Soa/K6ojj^[_nSXj?oa/K6omCDe?oPh>3ok>c/oo;bl_olo?coo_kn
00gooooo00?ohn?SomKFe_ono_h01?ooool00oo/k>cooOgmooooo`02ooCdm0_ooooo00?okNg]ono_
koooool01?ooool00oodm?Coj>SXooooo`0@ooooo`0;oo[jn_odm?Coj^[Zon?ShooGemOocLg=ojJV
Y_n^[Zkoa/K6omSHf?oRh^802Oo^k^h00:Woi^KV00oocLg=okVi^OnQXJ7oZj^[olK6a_oBd];og=cL
onKVi_o/k>comOGeooShn?ojn_[ooOgmooooooolo?`01oooool05OnNWYko4Q8Bo`T92OlW9bOo6a/K
oda<C?oIfMWooooooe5ADOl71`Oo6QXJoibLW?lC4a?oEeMGoooooom0@43oOgmooogmoOooooooXj>S
oa`L7002ooooo`0@onGUiOm0@43o0000oa8B4_lM7Agon?ShoooooooWinOoBTY:o`<30olR8R;o5aLG
ol71`Ooooooo@410ogmoO`;ooooo00?ooOgmooooooooool00_ooool04?omoOgooooooogmoOokno_o
n?ShooCdm?o]kNgoi^KVomoOgooFe]Koc<c<ok6a/OnRXZ;o^KViolg=cOoKfm/9onKViP00ZOo^k^h0
4ooAdM7o^k^koj6QXOnf][Ko`l?3olo?cooFe]KogmoOonKVi_oZj^[okno_oo?cloodm?ComOGeooOg
moofm_KomoOgooKfm_ohn?P00_ogmoL01?nBTY;o0P82ohJ6Q_odm?@2ooKfmP08ojb/[?oAdM7o_kno
o`<30ooFe]Kog]kNoeMGEol@4102ooOgm`06ocdm?OmjNW[omoOgooOgmonMWIgo6a/K0_ogmoL04?lo
?coo:RXZolC4a?ogmoOod=3@ooKfm_ogmoOo@D51ocdm?OoGemOomoOgon_[jooYjNWon?Shocdm?Omk
Ng/2ooKfmP;omoOg01?om_KfooShn?ofm_KomoOgooKfm_odm?Col_;boo3`l?o[jn_oi^KVon7QhOoJ
f][odm?ColW9bOno_kooYZJVok^k^ooAdM7ohN7Q00Wok^k^002Yooooo`0;omoOgoo5aLGoY:BTok>c
/oo0`<3obLW9om?CdooIfMWogMgMon;Rh_oUiND00_oZj^X00oo/k>cokNg]ong]k@04onk^kP04onOW
iolB4Q;oG5aLoo3`l0Gok^k^00Kob/[:o`820_na/K7ok^k^oiBDU?lM7Ad2onk^kP0;oc/k>omfMWKo
l?3`onk^k_nHV9So6QXJonk^k_o=cLgo0000oh^;Roo`l?000oo^k^h01Oo>c/ko0000oj^[Zoo^k^ko
l?3`00?ok^k^00Go>c/kogIfM_o^k^kok^k^oo3`l003onk^kP;okNg]0_o/k>`03OoYjNWoi^KVon?S
hooPh>3ofm_KomGEeOo=cLgoaLG5ok^k^on[Zj_oaLG5omoOgoo`l?002Oooool00:Wok^k^00god=3@
okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoOgooQhN7oh^;R00;ohn?S1OoUiND0
1?nn_[ko0000ojj^[_oVi^H6onGUi@05oibLW?l];Bgo;Bd]oc0`<?lL71`00_oUiND02oli>CWoLW9b
onKVi_oUiNGoTY:BoaTI6OoUiNGoZZZZo`000?ni^KWoi^KV00?oiNGU00?oZZZZo`000?lf=SH00olh
>3P01On`/;3oiNGUocTi>OmbLW;oiNGU00;oi^KV0ooUiND2onCTi0;ohn?S00goh^;Ron3Ph?oLg=co
fMWIomKFe_o@d=3obLW9ol71`One]KGoYJFUokRh^?o@d=3oh>3P00Wok^k^002YonKViP0=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0;og]kN0_oM
gMd01?nKVi_o0000ol?3`ooMgMd2omkNgP?ogMgM00Kog]kNomgMgOoMgMgog=cLoh20P?lL71`2omgM
g@0;ocLg=om@D53ogMgMomkNg_n8R8So6ATIomgMgOnm_Kgo0000ogemOOoMgMd00_oNg]h03?oMgMgo
_Kfmo`000?nDU9Co/k>cojb/[?l20P;oalO7omgMgOlg=cOoKVi^omkNgP;ogMgM0_oNg]h2omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@Woi^KV002Yonk^kP0=omCDe?no_kooS8b<oijNW_n][Jgo^KViol;2`_o7alOoc<c<om3@d?oBd];o
eMGEomKFeP02omOGe`03omSHf?oIfMWofMWI00;ofMWI00?oZJVYo`000?nb/[801ooIfMT01OnIVIWo
^KViomKFe_mBDU;oAdM700;ofMWI00Ko=SHfoa4A4OmTI6Co_;blodY:B_m1@D42omWIf@05ocDe=OlQ
8B7oXJ6QomSHf?nl_;`00_oIfMT01Ole=CGoFe]Kom;Bd_n6QXKo92@T00;ofMWI00?o=SHfofa/K?oI
fMT01OoIfMT2omSHf0;oemOG00goeMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo_knookFe]OnYZJWoV9RH
okno_ooDe=Coh^;R00Wok^k^002Yooooo`0=onSXj?oDe=CoS8b<oi>CTonRXZ;o[jn_okZj^_o1`L7o
alO7ol_;boo>c/kod=3@om7Ad@02om?Cd`?oe=CD0_oEeMD01?o6a/Ko0@41oh>3PooEeM@2omCDe0;o
eMGE01Koe]KFomGEeOmcLg?o:BTYo`d=3Ol_;booXj>SomGEeOoFe]KoATI6ogEeMOmUIFCo410@obHV
9_nSXj?oeMGEomKFe_o1`L7oBDU9o``<3?l92@Wo7alO0_oEeMD03?o1`L7o>c/ko`X:2_lG5aOoV9RH
omCDe?oEeMGo=CDeofYZJ_oEeMGoe]KFomGEe0;oe=CD0_oEeMD04?oDe=Codm?Com?CdooAdM7od=3@
olg=cOo:b/[o`l?3okjn__nf][KoZj^[oifMWOnEUIGoe=CDonSXj?oclo<9ooooo`00ZOo^k^h04_oM
gMgocLg=oi2@T?n9RHWoUiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooIfMWof][Jom_KfooJ
f][ofm_KomcLg0?ofm_K00GoEEEEoalO7oo;bl_ofm_KomcLg006om_Kf`03omWIfOoLg=cofm_K00Go
fm_K00?of][JomcLg?oKfm/01OoKfm/00ooHf=Sog=cLom_Kf`03om_Kf`07omSHf?oKfm_ofm_KomcL
g?oKfm_o=SHfofe]K@04om_Kf`0ComcLg?oKfm_ofm_Kom_KfooJf][ofMWIomSHf?oFe]Kodm?Colg=
cOo2`/;o][Jfojb/[?nOWiooT92@oiJFU_o=cLgogMgMonGUi@09onk^kP00ZOoVi^H02ooJf][oc/k>
oibLW?mjNW[oR8R8oiJFU_nZZZ[oa<C4omGEeOoKfm_og]kN00;oh>3P0ooRh^800ooTi>Cohn?Son?S
h`02on?Sh`08om7AdOli>CWo6QXJofe]KOn6QXKoIfMWobXZ:_nYZJT3on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`05onCTi?oShn?ohn?S
ocPh>?maLG400ooShn<01?oTi>Cohn?Son?ShooShn<2on;RhP0>on7QhOoPh>3ogmoOomcLg?oGemOo
aLG5ojb/[?nNWYkoT92@oh:2P_nPX:3oc/k>om[Jf_oPh>09onKViP00ZOo^k^h03_oUiNGogMgMol;2
`_mkNg_oN7QhohJ6Q_nOWiooaLG5omSHf?oMgMgogmoOon7QhOoRh^;ohn?S0ooTi>@4onGUi@08onCT
i?oShn?oWinOog9bL_mNGUkoNg]koi^KVooGemL2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@0
0ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi006onGUiOoTi>Co
iNGUonGUiOli>CWoLW9b0_oTi>@01?oUiNGoi>CTonGUiOoUiND3onCTi00>on?ShooQhN7oh>3PomoO
gooJf][oa/K6oj6QXOn=SHgoP820ohB4Q?o3`l?ogMgMonGUiOoZj^X9onk^kP00ZOooool02ooinOWo
lo?conWYjOnXZ:SoIFEUog=cLon=SHgo^k^komCDe?oJf][ogMgM00;ogmoO00?oh>3Pon7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00?ohN7Q00?ogMgMomoOgooRh^80
2?oQhN403_oPh>3ogmoOomgMgOoLg=coeMGEokVi^On>SXkoNg]kofi^K_n[Zj_ojNWYoo?clooinOWo
oOgm2Oooool00:Wok^k^00cojn_[onSXj?oRh^;oemOGohf=SOmRHV;oMWIfojBTY?o7alOod];BomGE
eOoHf=P2om[JfP?ofm_K1ooLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
01Cofm_KomcLg?oLg=cofm_KomcLg?oKfm_of][JomWIfOoHf=Sodm?ColG5aOnLW9coMGEeofMWIon@
T93oemOGon;Rh_oXj>Sojn_[ong]k@Wok^k^002YonKViP0>onGUiOoRh^;ogmoOom[Jf_o9bLWoQhN7
oeYJF_mkNg_oXj>Sokbl_?o6a/Kobl_;olg=cOo?cll2om7Ad@God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00?od];B0_oAdM403Oo@d=3oclo?olc<
c?o8b<So^k^koibLW?mbLW;oFe]KohZ:R_o9bLWof][JomoOgooRh^800_oUiND9onKViP00ZOo^k^h2
ong]k@0>on[Zj_oXj>Soh^;RomcLg?nLW9coKFe]ofQXJ?n3Ph?oUiNGoj>SXon/[:co[jn_ok6a/Onb
/[82okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]00CokFe]Onf][Co];BdokBd]?nf][Ko
/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9RH_m^KVkoWinOomcLg?oRh^;oj>SXon[ZjP02ong]
k@[ok^k^002Zooooo`;oo_kn00ooo?clooWinOofm_Kol_;bomWIfOnXZ:SoPh>3ofi^K_mUIFGoJFUY
og9bL_mdM7CoNGUiogalO?mkNg/00_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@07ogalO?mkNg_oO7alogemO?mlO7coNg]kogemO@02ogYjNP0;ogMgMomdM7CoKfm_ogAdM?n5QHGo
Z:RXom[Jf_obl_;om_KfooWinOolo?`00_ono_h;ooooo`00Zoo^k^h2ong]k@04onc/k?oZj^[oj>SX
onGUi@;oh^;R00?oh>3PomoOgooNg]h0>OoMgMd00ooNg]kogmoOon3Ph002on;RhP04onGUiOoXj>So
j^[Zonc/k0;okNg]3?o^k^h00:goi^KV0_oUiND00ooTi>Coh^;Ron;RhP02on3Ph0;ogmoO>OoNg]h2
omoOg`;oh>3P0_oRh^800ooTi>CoiNGUonGUi@0>onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00
ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00
oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00
ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00C_o^k^h00ooYjNWo
gmoOom[JfP2Yom[JfP03omoOgooYjNWok^k^00Wok^k^001>ooooo`03ono_koo@d=3o`<300:Wo`<30
00?od=3@ono_koooool02Oooool004kok^k^06SoK;[oog:noomha?ooP/[oohS>oon1b_ooN<?oog2m
oom/^_ooL[koogS4oon2b_ooR<kooh7:oomh`oooL;goofbjoomb__ooN<Cooh;:oon8c_ooPL[oogS3
oom`_OooK;[oog:noomha?ooP/[oohS>oon1b_ooN<?oog2moom/^_ooL[koogS4oon2b_ooR<kooh7:
oomh`oooL;goofbjoomb__ooN<Cooh;:oon8c_ooPL[oogS3oom`_OooK;[oog:noomha?ooP/[oohS>
oon1b_ooN<?oog2moom/^_ooL[koogS4oon2b_ooR<kooh7:oomh`oooL;goofbjoomb__ooN<Cooh;:
oon8c_ooPL[oogS3oom`_OooK;[oog:noomha?ooP/[oohS>oon1b_ooN<?oog2moom/^_ooL[koogS4
oon2b_ooR<kooh7:oomh`oooL;goofbjoomb__ooN<Cooh;:oon8c_ooPL[oogS3oom`_OooK;[oog:n
oomha?ooP/[oohS>oon1b_ooN<?oog2modGog]kN00?of][Jonk^k_o^k^h02?o^k^h004koi^KV06So
JKkoofg0oomfa_ooOlgoohKBoomncOooM/Goofk0oomY__ooKL3oogK6oomocOooQ];oogk=oomfaOoo
K/3oofVnoom]`?ooM/Koogo=oon6d_ooO/googK5oom^`?ooJKkoofg0oomfa_ooOlgoohKBoomncOoo
M/Goofk0oomY__ooKL3oogK6oomocOooQ];oogk=oomfaOooK/3oofVnoom]`?ooM/Koogo=oon6d_oo
O/googK5oom^`?ooJKkoofg0oomfa_ooOlgoohKBoomncOooM/Goofk0oomY__ooKL3oogK6oomocOoo
Q];oogk=oomfaOooK/3oofVnoom]`?ooM/Koogo=oon6d_ooO/googK5oom^`?ooJKkoofg0oomfa_oo
OlgoohKBoomncOooM/Goofk0oomY__ooKL3oogK6oomocOooQ];oogk=oomfaOooK/3oofVnoom]`?oo
M/Koogo=oon6d_ooO/googK5oom^`?ooJKkoofg0oomfa_ooOlgoohKBoomncOooM/Goofk0odGon_[j
00?odm?ConKVi_oVi^H02?oVi^H004kok^k^06SoF:cooej`oomV]_ooK[coogO2oom`__ooIkSoof2a
oomH[?ooG[3oofJfoom^_?ooMl;oog2noomW^?ooH;7ooeR/oomN/?ooI[Koofjloomg`_ooL;koofNh
oomP/OooF:cooej`oomV]_ooK[coogO2oom`__ooIkSoof2aoomH[?ooG[3oofJfoom^_?ooMl;oog2n
oomW^?ooH;7ooeR/oomN/?ooI[Koofjloomg`_ooL;koofNhoomP/OooF:cooej`oomV]_ooK[coogO2
oom`__ooIkSoof2aoomH[?ooG[3oofJfoom^_?ooMl;oog2noomW^?ooH;7ooeR/oomN/?ooI[Koofjl
oomg`_ooL;koofNhoomP/OooF:cooej`oomV]_ooK[coogO2oom`__ooIkSoof2aoomH[?ooG[3oofJf
oom^_?ooMl;oog2noomW^?ooH;7ooeR/oomN/?ooI[Koofjloomg`_ooL;koofNhoomP/OooF:cooej`
oomV]_ooK[coogO2oom`__ooIkSoof2aodGomOGe00?of][Jonk^k_o^k^h02?o^k^h004kooooo06So
AYOfodjMmomDX_WoFjSkofB^oOmMZOcoEJ?jod^Kn?m6UoKoCYggoeBRnOmKZ?_oI:kmoefYo?mEXo[o
Bi_hodJGm_m>WOOoE:;ioe^XnomT[_goGJWloeFSn_m;VoSoAYOfodjMmomDX_WoFjSkofB^oOmMZOco
EJ?jod^Kn?m6UoKoCYggoeBRnOmKZ?_oI:kmoefYo?mEXo[oBi_hodJGm_m>WOOoE:;ioe^XnomT[_go
GJWloeFSn_m;VoSoAYOfodjMmomDX_WoFjSkofB^oOmMZOcoEJ?jod^Kn?m6UoKoCYggoeBRnOmKZ?_o
I:kmoefYo?mEXo[oBi_hodJGm_m>WOOoE:;ioe^XnomT[_goGJWloeFSn_m;VoSoAYOfodjMmomDX_Wo
FjSkofB^oOmMZOcoEJ?jod^Kn?m6UoKoCYggoeBRnOmKZ?_oI:kmoefYo?mEXo[oBi_hodJGm_m>WOOo
E:;ioe^XnomT[_goGJWloeFSn_m;VoSoAYOfodjMmomDX_WoFjSkofB^oOmMZOcoEJ?jod^Kn4Gokno_
00?oj^[Zooooooooool02?ooool004kok^k^06So=HCToc^8i_m2SnSoBIGZodnIk?m:U^_oA97Yocb:
ioleQ>Co>hSVod:?j?m9UN[oCiW/odZFjom4TNWo?8[WocF4i?lkR>Ko@XoXodVEj_m?VNcoBYK[odBA
jOllR^Oo=HCToc^8i_m2SnSoBIGZodnIk?m:U^_oA97Yocb:ioleQ>Co>hSVod:?j?m9UN[oCiW/odZF
jom4TNWo?8[WocF4i?lkR>Ko@XoXodVEj_m?VNcoBYK[odBAjOllR^Oo=HCToc^8i_m2SnSoBIGZodnI
k?m:U^_oA97Yocb:ioleQ>Co>hSVod:?j?m9UN[oCiW/odZFjom4TNWo?8[WocF4i?lkR>Ko@XoXodVE
j_m?VNcoBYK[odBAjOllR^Oo=HCToc^8i_m2SnSoBIGZodnIk?m:U^_oA97Yocb:ioleQ>Co>hSVod:?
j?m9UN[oCiW/odZFjom4TNWo?8[WocF4i?lkR>Ko@XoXodVEj_m?VNcoBYK[odBAjOllR^Oo=HCToc^8
i_m2SnSoBIGZodnIk?m:U^_oA97Yocb:idGoiNGU00?of][Jonk^k_o^k^h02?o^k^h004koi^KV06So
B8cLodZ>gomBU>3oFY[QoefMh_mKVn?oE9KQod^@gom8S=coBXkOoe:Dh?mJV^7oGIgRoe^KhomDU^7o
Bi3OodR<g?m:S]ooDYCPoeZJhOmMWN;oFi_SoeBFhOm;T=ooB8cLodZ>gomBU>3oFY[QoefMh_mKVn?o
E9KQod^@gom8S=coBXkOoe:Dh?mJV^7oGIgRoe^KhomDU^7oBi3OodR<g?m:S]ooDYCPoeZJhOmMWN;o
Fi_SoeBFhOm;T=ooB8cLodZ>gomBU>3oFY[QoefMh_mKVn?oE9KQod^@gom8S=coBXkOoe:Dh?mJV^7o
GIgRoe^KhomDU^7oBi3OodR<g?m:S]ooDYCPoeZJhOmMWN;oFi_SoeBFhOm;T=ooB8cLodZ>gomBU>3o
FY[QoefMh_mKVn?oE9KQod^@gom8S=coBXkOoe:Dh?mJV^7oGIgRoe^KhomDU^7oBi3OodR<g?m:S]oo
DYCPoeZJhOmMWN;oFi_SoeBFhOm;T=ooB8cLodZ>gomBU>3oFY[QoefMh_mKVn?oE9KQod^@gdGofm_K
00?odm?ConKVi_oVi^H02?oVi^H004kok^k^06SoM:WPogNZh_mm[N?oP[7TohJdiOn4/nGoOJkSogN[
hOmdZN3oMj[Rogf]hon2/NCoQ[CUohBciOmm[^?oMj_QogBYh?mgZ^;oOJgSoh:ai?n6]>GoQ;?Uogf^
homgZn7oM:WPogNZh_mm[N?oP[7TohJdiOn4/nGoOJkSogN[hOmdZN3oMj[Rogf]hon2/NCoQ[CUohBc
iOmm[^?oMj_QogBYh?mgZ^;oOJgSoh:ai?n6]>GoQ;?Uogf^homgZn7oM:WPogNZh_mm[N?oP[7TohJd
iOn4/nGoOJkSogN[hOmdZN3oMj[Rogf]hon2/NCoQ[CUohBciOmm[^?oMj_QogBYh?mgZ^;oOJgSoh:a
i?n6]>GoQ;?Uogf^homgZn7oM:WPogNZh_mm[N?oP[7TohJdiOn4/nGoOJkSogN[hOmdZN3oMj[Rogf]
hon2/NCoQ[CUohBciOmm[^?oMj_QogBYh?mgZ^;oOJgSoh:ai?n6]>GoQ;?Uogf^homgZn7oM:WPogNZ
h_mm[N?oP[7TohJdiOn4/nGoOJkSogN[hDGog]kN00?of][Jonk^k_o^k^h02?o^k^h004kooooo06So
RKCSohfgi?n?^^GoU;cVoiVoionD_NKoSkWVohfgiOn9]>?oSKOTohnjiOnD_>KoVKoWoiBmi_n?^NKo
SKOUohVdhon=]nCoSk[UoiBli_nI_nOoU;gVohnii_n=]nGoRKCSohfgi?n?^^GoU;cVoiVoionD_NKo
SkWVohfgiOn9]>?oSKOTohnjiOnD_>KoVKoWoiBmi_n?^NKoSKOUohVdhon=]nCoSk[UoiBli_nI_nOo
U;gVohnii_n=]nGoRKCSohfgi?n?^^GoU;cVoiVoionD_NKoSkWVohfgiOn9]>?oSKOTohnjiOnD_>Ko
VKoWoiBmi_n?^NKoSKOUohVdhon=]nCoSk[UoiBli_nI_nOoU;gVohnii_n=]nGoRKCSohfgi?n?^^Go
U;cVoiVoionD_NKoSkWVohfgiOn9]>?oSKOTohnjiOnD_>KoVKoWoiBmi_n?^NKoSKOUohVdhon=]nCo
Sk[UoiBli_nI_nOoU;gVohnii_n=]nGoRKCSohfgi?n?^^GoU;cVoiVoionD_NKoSkWVohfgiDGoj>SX
00?oj^[Zooooooooool02?ooool004kok^k^06SoP:;JogfTg?mnZ=goOZ_Ooh2^gomn[=ooO:SMogfT
fon0X][oOJCLogjXgOmnZmooP:kOogj/gomlZ=goOJCKoh2Rf_mmY=coOZSMogj[gon0[]ooOZcOogbX
gOmmY=_oP:;JogfTg?mnZ=goOZ_Ooh2^gomn[=ooO:SMogfTfon0X][oOJCLogjXgOmnZmooP:kOogj/
gomlZ=goOJCKoh2Rf_mmY=coOZSMogj[gon0[]ooOZcOogbXgOmmY=_oP:;JogfTg?mnZ=goOZ_Ooh2^
gomn[=ooO:SMogfTfon0X][oOJCLogjXgOmnZmooP:kOogj/gomlZ=goOJCKoh2Rf_mmY=coOZSMogj[
gon0[]ooOZcOogbXgOmmY=_oP:;JogfTg?mnZ=goOZ_Ooh2^gomn[=ooO:SMogfTfon0X][oOJCLogjX
gOmnZmooP:kOogj/gomlZ=goOJCKoh2Rf_mmY=coOZSMogj[gon0[]ooOZcOogbXgOmmY=_oP:;JogfT
g?mnZ=goOZ_Ooh2^gomn[=ooO:SMogfTfdGohn?S00?ogmoOonk^k_o^k^h02?o^k^h004koi^KV06So
=eZkoc=J_?leH[oo<fS1oc=/`_leJL7o=66oocAJ^olgF[_o<eZlocER_olcJ<7o<fc2ocEY`OldHKoo
=5ZkocMJ^olcF[co=F:ooc=X`OlcK<;o=FW1ocAQ_oldF[_o=eZkoc=J_?leH[oo<fS1oc=/`_leJL7o
=66oocAJ^olgF[_o<eZlocER_olcJ<7o<fc2ocEY`OldHKoo=5ZkocMJ^olcF[co=F:ooc=X`OlcK<;o
=FW1ocAQ_oldF[_o=eZkoc=J_?leH[oo<fS1oc=/`_leJL7o=66oocAJ^olgF[_o<eZlocER_olcJ<7o
<fc2ocEY`OldHKoo=5ZkocMJ^olcF[co=F:ooc=X`OlcK<;o=FW1ocAQ_oldF[_o=eZkoc=J_?leH[oo
<fS1oc=/`_leJL7o=66oocAJ^olgF[_o<eZlocER_olcJ<7o<fc2ocEY`OldHKoo=5ZkocMJ^olcF[co
=F:ooc=X`OlcK<;o=FW1ocAQ_oldF[_o=eZkoc=J_?leH[oo<fS1oc=/`_leJL7o=66oocAJ^dGo];Bd
00?ohN7QonKVi_oVi^H02?oVi^H00?ook^k^1oo^k^h00?oooooo1oooool00?ook^k^1oo^k^h002Go
i^KV00?oi>CTon3Ph?oRh^80g_oVi^H002Cok^k^00Goj^[Zom_Kfonm_KgoemOGong]k@3Monk^kP00
8?ooool3ooknoP06ooOgmooMgMgoXZ:RoiBDU?o3`l?oo_kn:?ooool00ooZj^[oeMGEoo_kn`05oooo
o`03onWYjOoOgmoooooo0:[ooooo000Konk^kP0>ong]kOo[jn_oj>SXonGUiOoQhN7ogmoOomkNg_oJ
f][o^[ZjohR8R?o0`<3ob<S8ojn_[oo]kNdVonk^kP06onSXj?mDE5Co1PH6obDU9OlL71co_[jn0_o^
k^h01_o/k>coFe]Koa`L7?lY:BWo=SHfomkNgZWok^k^000IonKViP0AonGUiOoQhN7of=SHol[:b_ni
^KWoYjNWoiZJV_nCTi?oTI6Aohb<S?n9RHWohn?Soo3`l?o:b/[oY:BTon3Ph?oUiND09OoVi^H03_mj
NW[o8b<Solc<c?oVi^KoO7aloalO7ooQhN7oi^KVoh>3Pol^;Rkoh>3PonKVi_mGEeOoCTi>ZOoVi^H0
01Sok^k^00coj^[ZomkNg_o3`l?oWinOohN7Qon@T93oZZZZolC4a?o?cloodM7AomKFe_odm?@2ong]
k@05om_Kfon9RHWoa<C4omcLg?oZj^X09?o^k^h02_lN7QkoLW9bonk^k_o^k^kof][Jo`000?o2`/;o
k^k^ob@T9?n<S8`2onk^kP03ol71`Ol30`?oemOG0:Sok^k^000Fooooo`0>ookno_ofm_KofMWIojFU
YOn@T93oa<C4onk^k_oinOWom_Kfoo;bl_o_knool?3`onk^k_o/k>`2oo3`l007oo7alOo:b/[oTI6A
ojFUYOoIfMWom_KfooknoP0Qooooo`03ooWinOl0003oV9RH00;ooooo00KoemOGo`000?oKfm_omOGe
o`000?o2`/82ooooo`03oo_knol10@7o_;bl0:Sooooo000Eonk^kP09ong]kOoQhN7o^;RhohV9ROo5
aLGomoOgoo?cloo]kNgok^k^00;ol?3`00ComoOgoo7alOogmoOol_;b0ooalO401ooclo?omoOgolG5
aOn9RHWo^;Rhon7QhOo]kNd08?o^k^h02ooEeMGo0000obXZ:_o9bLWoh>3PoeiNG_lf=SKok^k^olc<
c?l0003oa<C400?ok^k^00?o30`<oiJFU_o^k^h0Yoo^k^h001Coi^KV00SoiNGUom_Kfon/[:coS8b<
onc/k?oclo?ok^k^oo7al@;ol_;b00Kol?3`ooShn?nh^;SoJVYZoifMWOodm?@3oo;blP08oo7alOo^
k^kolo?conc/k?n<S8co[:b/om_KfooUiNDOonKViP0;on7QhOl0003oOWinoc8b<_l>3Pko;2`/okRh
^?oVi^Kodm?Co`000?ne]KD00ooVi^H00ol410CoWIfMonKViP2WonKViP005?o^k^h01_oXj>So_;bl
oi:BT_ogmoOokno_oo;blP?olo?c00Wol_;booGemOoYjNWoI6AToeUIFOmDE5CocLg=oo_knooalO40
0ooclo<01_obl_;okno_ooOgmonBTY;o_;blonSXj23ok^k^00Co71`Lohb<S?o^k^kokNg]1?o^k^h0
1ol92@WoXZ:Ronk^k_o^k^kofm_Ko`000?o2`/80Z?o^k^h001?ooooo00Goo_knon;Rh_nEUIGolO7a
ono_k`05ooCdm009oo?clooemOGol?3`og5aLOm>CTkoFe]KomSHf?ojn_[olo?c00Gom?Cd00Gokno_
oo7alOnEUIGoh^;RooknoP0Oooooo`03oh:2P_lm?Cgoo_kn00Gooooo00KoI6ATof9RH_oooooooooo
oinOWol[:b^Yooooo`004oo^k^h01OoWinOoXj>Solg=cOoemOGom?Cd00KomOGe00Oom?Cdoo_knooF
e]KoUiNGol;2`_ojn_[om?Cd00KomOGe00Gom?CdooGemOo=cLgoXj>SonOWi`0Oonk^kP06on3Ph?le
=CGoBd];oiNGUomeMGGoI6AT0_o^k^h01_o@d=3o6a/Kog5aLOn9RHWo5aLGojb/[:Wok^k^000ConKV
iP04olo?con>SXkonOWioo;blPSom_Kf00GomOGeooclo?oBd];olo?cooShn008ooKfmP04oo;bl_oi
nOWoSXj>olo?cb3oi^KV00GogmoOohj>S_mQHF7oLW9bojFUY@03onKViP04ol_;bomhN7SoK6a/okRh
^:[oi^KV000Bonk^kP05ong]kOnj^[[o^KVioo[jn_ofm_H01oogmoL01oofm_KonOWioo;bl_mRHV;o
c/k>oooooooemOD01oogmoL01Oofm_Kon_[jokVi^Onj^[[okNg]0=Gok^k^000Booooo`04ooclo?n_
[joohN7QooKfmPSon?Sh00OomoOgoogmoOoVi^KoFUYJol30`?oooooom_Kf00Son?Sh00Com_Kfon7Q
hOn_[jooo?cleOooool001;ok^k^00Coj^[ZoiZJV_o^k^kom_Kf2?ojn_X01oohn?SoooooomKFe_m@
D53o[:b/ooooooogmoL02?ojn_X01?ofm_Kok^k^oiZJV_oZj^[Eonk^kP004_oVi^H01?oRh^;oTi>C
ono_koogmoL8oo_kn`07ooWinOoooooo`L71oda<C?nHV9SoooooooWin@08oo_kn`04ooOgmoo_knoo
Ti>Con;Rh]Goi^KV000Bonk^kP04on_[jonPX:3oj^[ZooWin@Soo?cl00OonOWioooooon[Zj_oD51@
oh>3Pooooooono_k00Soo?cl00ConOWion[Zj_nPX:3ojn_[eOo^k^h001;ooooo00Coo_knol71`OoE
eMGoo?cl2?omoOd02?okno_ooooooiBDU?mEEEGoLg=cooKfm_ooooooo?cl1oomoOd01?olo?coeMGE
ol71`Oono_kEooooo`004oo^k^h01?oBd];oY:BTooooooolo?`8ooknoP07oooooon0P83oG5aLofEU
IOoXj>Sooooooogmo@06ooknoP04ooclo?ooooooY:BTom;BdScok^k^00?oTi>Cok6a/Oo^k^h0A_o^
k^h00onCTi?o/K6aonk^kP0Bonk^kP05ok>c/omjNW[oFUYJog1`L?o0`<00=oo^k^h001?oi^KV00Co
gmoOoiJFU_o^k^kon_[j1_ono_h02OomoOgoooooooCdm?m_KfooHV9RoeeMGOoEeMGoooooooclo006
ooknoP04oo[jn_o^k^koUYJFomoOgccoi^KV00?o>CTiog9bL_oVi^H0A_oVi^H00oli>CWoLW9bonKV
iP0BonKViP06og]kNomZJV[oU9BDoeUIFOl92@WoZJVY=_oVi^H001Cok^k^00Cobl_;ojBTY?olo?co
o?cl1Oooool02Oono_koooooonGUiOmSHf?oIVIVoeUIFOo0`<3oooooooclo005ooooo`;oo?cl00?o
Y:BTol_;boo^k^h08_o^k^h00ooCdm?oalO7ong]k@05onk^kP03omcLg?oOgmook^k^00ook^k^00Go
>c/kogIfM_o]kNgoeMGEong]k@04onk^kP03on_[jooOgmook^k^00Kok^k^00OoeMGEonc/k?o^k^ko
k^k^omcLg?o/k>cok^k^00;ohn?S0oo^k^h00ooEeMGok>c/onk^kP06onk^kP03omcLg?oOgmook^k^
01ook^k^00Go>c/kogIfM_o]kNgoeMGEong]k@0:onk^kP03omcLg?oOgmook^k^00Ook^k^00?oE5AD
od92@_o^k^h02?o^k^h00ooShn?of=SHonk^kP03onk^kP;ohN7Q1Oo^k^h2on7QhAkok^k^000Doooo
o`05oo_knonk^k_obLW9ookno_olo?`01?ooool02OomoOgoooooomkNg_mKFe_oJFUYoeEEEOne]KGo
ooooooclo004ooooo`05ooclo?ono_kobLW9ok^k^ookno/08Oooool03_nNWYko4a<Co`T92OlW9bOo
6a/Koda<C?oIfMWoooooom_Kfole=CGo3Ph>o``<3?li>CWog=cL0_ooool01_m0@43oOgmooooooooo
ooooNWYjod=3@`;ooooo00[o];Bdo`T92Ooooooooooood10@?m;Bd_o9RHVoa/K6olE5AGo_;bl0_oo
ool01_no_koo6a/Ko`L71omBDU;oQXJ6oc0`<0;ooooo01?odm?CobDU9OlN7Qko^[ZjoooooomADE7o
20P8oaXJ6_nLW9co4a<CoeMGEooooooodm?CobDU9OlN7Qko^[Zjoooooom0@43oOgmo00;ooooo00Ko
fm_KocDe=Ol>3Pko30`<ocTi>OoLg=`2ooooo`06od10@?moOgoooooooooooonSXj?o71`L1_ooool0
1_m0@43oOgmooooooooooooo@410ogmoO`;ooooo00?oXj>Soa`L7?ooool01Oooool01_m0@43oBd];
obHV9_lK6a_o5ADEokbl_0;ooooo00?o@410ogmoOoooool00_ooool01_oKfm_o=CDeo`h>3_l<30co
>CTiomcLg0;ooooo00KoinOWoeeMGOli>CWoNWYjoifMWOlN7Qh2ooooo`03od10@?moOgoooooo00;o
oooo00coinOWodY:B_l30`?o8b<SoaLG5oo1`L7oooooobDU9Ol@413o820Pode=COofm_H2ooooo`05
obDU9Ol@413o820Pode=COofm_H00_ooool01_m5ADGo:BTYooooooooooooADE5obTY:@;ooooo00?o
ADE5obTY:Oooool03oooool001Gok^k^00Koi>CTojBTY?o;bl_ooooooo_knoono_h2ooooo`09ookn
o_oooooono_koh:2P_mFEUKoJ6QXon?Shoooooooo_kn00;ooooo00Koo_knoo_knooooooobl_;ojBT
Y?oTi>@Qonk^kP0;ohf=SOl20P;oPH61on_[joo^k^kok>c/ojJVY_o9bLWokNg]oc0`<?m<C4`00_oN
g]h01_m?Cdoo<C4aong]kOo^k^ko>c/kogIfMP;ok^k^00KoLG5aochn?_o^k^kok^k^ojRXZ?l820P2
onk^kP0>oc/k>oln?SkogmoOon[Zj_mdM7Co4A4Aon;Rh_o^k^koCTi>oe=CDooVi^KoTi>Co`h>3_l/
;2`2onk^kP0:ofUYJOll?3cokNg]onk^k_nh^;So0`<3olk>c_oFe]KoE5ADo`l?3`;ok^k^00?oJFUY
oc`l??o]kNd00_o^k^h01_lk>c_oMWIfonk^k_o]kNgo<30`oda<C0;og]kN00KoCdm?oc4a<Oo]kNgo
k^k^oc/k>omfMWH2onk^kP03oiRHV?lJ6Q[ok^k^00Gok^k^00Ko>c/kogIfM_o^k^kok^k^oc/k>omf
MWH2onk^kP03oiRHV?lJ6Q[ok^k^00Gok^k^00[o>c/kochn?_oOgmooj^[ZogAdM?lA4A7oh^;Ronk^
k_lk>c_oMWIf0_o^k^h00oo]kNgo<30`oda<C002omkNgP0:odm?Cola<C7okNg]onk^k_m7AdOo:RXZ
oiNGUomcLg?o:RXZoa8B4P;ok^k^00?o>c/kogIfM_o^k^h00_o^k^h03?lo?coo>c/kom3@d?o^k^ko
h^;Ron7QhOo^k^ko/k>con[Zj_o]kNgo<S8bohR8R0;ok^k^00Go/k>con[Zj_o]kNgo<S8bohR8R002
onk^kP06oh^;RommOGgok^k^onk^k_n;Rh_oOGem0_o^k^h00on;Rh_oOGemonk^kP0?onk^kP005_oV
i^H01ooLg=coYJFUojb/[?ogmoOooOgmoo_knoomoOd00oooool00ooemOGodM7Aon[ZjP03ooooo`07
oogmoOokno_ooOgmooOgmon/[:coYJFUomcLg00QonKViP03omoOgolB4Q;oFEUI00Koi^KV00?o`/;2
o`000?nUYJD00_oVi^H01_nUYJGo0000olK6a_oVi^Ko>CTiog9bLP;oi^KV00KoKVi^oc`l??oVi^Ko
i^KVoj:RX_l820P2onKViP0:ocTi>OmbLW;oi^KVonKVi_o@d=3o0000oibLW?oVi^Ko9bLWoh61P@;o
i^KV00KoKVi^ob/[:ooVi^Koi^KVodE5AOmVIVH2onKViP06ol?3`ol20P;oZZZZonKVi_n?Shoo71`L
0_oVi^H00om5ADGoIVIVonKViP02onKViP06ocTi>OmbLW;oi^KVol;2`_l0003oYJFU0_oVi^H01_nU
YJGo0000olK6a_oVi^Ko>CTiog9bLP;oi^KV00?oTi>CoaTI6OoVi^H01OoVi^H01_li>CWoLW9bonKV
i_oVi^Ko>CTiog9bLP;oi^KV00?oTi>CoaTI6OoVi^H01OoVi^H02_li>CWoLW9bonKVi_oVi^Kod=3@
o`000?nLW9coi^KVocTi>OmbLW82onKViP03ol;2`_l0003oYJFU00;oi^KV00KoYJFUo`000?o6a/Ko
gMgMo`P82?nVYZH2onKViP06ohN7Qol?3`ooi^KVonKVi_li>CWoLW9b0_oVi^H00oo7alOo0000ojFU
Y@07onKViP03ok6a/OlC4a?oQ8B400Coi^KV00?o/K6aoa<C4on4Q8@07?oVi^H001Ook^k^01Goj>SX
ol71`OnGUiOob/[:ooShn?oooooooOgmoo_knoojn_[oo?clooooooomoOgon_[joo_knoomoOgooooo
ooShn?o:b/[oUiNGol71`OoXj>P08_o^k^h00oo5aLGo0000okFe]@06onk^kP03ok6a/Ol0003oe]KF
00;ok^k^00Koe=CDo`000?nd];Cok^k^oc/k>omfMWH2onk^kP06og5aLOln?Skok^k^onk^k_nXZ:So
20P80_o^k^h00olk>c_oMWIfonk^kP02onk^kP05oa@D5?n7QhOok^k^obTY:On9RHT00_o^k^h01_n5
QHGo;2`/onk^k_o^k^koAdM7ofYZJP?ok^k^00GoXJ6Qobh^;_l_;boo<S8boadM7@02onk^kP03odM7
AomZJV[ok^k^00;ok^k^00Ko>c/kogIfM_o^k^ko/K6ao`000?oFe]H2onk^kP06omCDe?l0003o];Bd
onk^k_lk>c_oMWIf0_o^k^h00onHV9So6QXJonk^kP05onk^kP06oc/k>omfMWKok^k^onk^k_lk>c_o
MWIf0_o^k^h00onHV9So6QXJonk^kP05onk^kP03oc/k>omfMWKok^k^00;ok^k^00Go51@DohN7Qoo^
k^ko>c/kogIfMP02onk^kP03ok6a/Ol0003oe]KF00;ok^k^00Koe=CDo`000?nd];Co]KFeo`000?oF
e]H2onk^kP06oj2PX?l?3`ook^k^onk^k_lk>c_oMWIf0_o^k^h00ona/K7o0000ocPh>003ocXj>P07
okJf]_o^k^koe=CDodE5AOl20P;oJFUYonGUi@02onk^kP05omCDe?m5ADGo0P82ofUYJOoUiND07?o^
k^h001Sooooo00Soo_knono_koo2`/;oWinOok:b/_oLg=col_;boo_kn`?ooOgm00Sono_koo;bl_oL
g=co/[:boinOWoo2`/;okno_ooknoR?ooooo00?o/k>co`000?oRh^801_ooool00ooLg=co0000okBd
]002ooooo`06ok:b/_l0003oh>3Poooooom0@43oKFe]0_ooool01_miNGWo<c<cookno_oooooo/k>c
o`T92@;ooooo00[o@410ogYjN_ooooooooooong]kOl0003o`l?3ooooool/;2coTi>C0_ooool01_n?
Shoo<30`ooooooooooooCDe=og9bLPGooooo00?ooOgmoiBDU?lQ8B400_ooool00om=CDgoLW9boooo
o`02ooooo`06od10@?moOgooooooomcLg?l0003o];Bd0_ooool01_nb/[;o0000on3Ph?oooooo@410
oeeMG@;ooooo00?oWIfMoadM7Oooool01Oooool01_m0@43oOgmooooooooooooo@410oeeMG@;ooooo
00?oWIfMoadM7Oooool01Oooool02_m0@43oNWYjooooooooooookNg]o`000?o3`l?ooooood10@?mY
JFT2ooooo`03omcLg?l0003o];Bd00;ooooo00Ko/[:bo`000?oPh>3of][Jo`000?ne]KD2ooooo`06
ojb/[?lA4A7ooooooooooom0@43oJFUY0_ooool02ooKfm_o0000oj^[Zoo?clooalO7o`<30ooUiNGo
oooood51@Om2@T;ofm_K00Cooooo00?o@D51od92@_oKfm/07_ooool001[ok^k^00ookNg]on?Shoo=
cLgo/;2`oifMWOnGUiOoUIFEoiBDU?nEUIGoUiNGoifMWOn`/;3ocLg=on?Shoo]kNd09Oo^k^h00oni
^KWo0000olC4a007onk^kP06oc`l??m3@d?oclo?olk>c_m2@T;o?clo0_o^k^h02_lk>c_o4a<Coh:2
P_oHf=So>SXjoa`L7?mIFEWod];BofUYJOl_;bl2onk^kP0:oc/k>olI6AWoS8b<olg=cOmRHV;o3`l?
on_[joo^k^ko:BTYohV9R@;ok^k^01OoQHF5ob`/;?o^k^koj>SXodA4A?mUIFGohn?Son[Zj_o^k^ko
Z:RXol_;boo[jn_oFUYJodi>C_o^k^koj>SXodA4A?mUIFGohn?Son[Zj_o^k^ko>c/kogIfMP02onk^
kP06oc`l??m3@d?oclo?olk>c_m2@T;o?clo0_o^k^h01_lk>c_o4Q8Bofi^K_o?clooDE5AodM7A`Ko
k^k^00[o>c/kogIfM_o^k^kok^k^oc/k>olB4Q;oKVi^olo?comADE7oAdM71_o^k^h04olk>c_o6ATI
ohb<S?o=cLgoHV9Ro`l?3oo[jn_ok^k^oc/k>olA4A7oQhN7omCDe?o/k>co?3`lod=3@oo?clooc/k>
od92@_lo?cl00_o^k^h01_lg=cOo@D51om;Bd_oPh>3oD51@o`l?3`;ok^k^00[o>c/koa4A4On7QhOo
e=CDonc/k?lj>S[oHf=SonKVi_nCTi?o:2PX0_o^k^h01Olc<c?oS8b<onk^k_oHf=SojNWY00;ok^k^
00Go<c<cohb<S?o^k^kof=SHonWYj@0Lonk^kP007OoVi^H02OoUiNGoh^;RomkNg_oLg=cofm_KomcL
g?oNg]koh^;RonGUi@0XonKViP03omGEeOl10@7oSHf=00Ooi^KV00KodM7AodU9BOl=3@go3@d=od];
BooBd]82onKViP0:od];BommOGgoIFEUo`h>3_lT92Co`<30ohZ:R_lG5aOo71`LoibLW0;oi^KV00Ko
Bd];ogalO?mKFe_o2`/;oaHF5_nGUiL2onKViP0Koc`l??n>SXkoi^KVonKVi_n;Rh_o?cloonKVi_mb
LW;o1`L7o`X:2_lH61SoW9bLonKVi_mlO7co;Bd]o`h>3_lc<c?o/;2`onKVi_mbLW;o1`L7o`X:2_lH
61SoW9bLonKVi_m;Bd_oOgmo00;oi^KV00KodM7AodU9BOl=3@go3@d=od];BooBd]82onKViP06od];
BomnOWkoKFe]oa8B4_lY:BWo/;2`1_oVi^H02_m;Bd_oOgmoonKVi_oVi^KoBd];oginO_m]KFgo4Q8B
obTY:On`/;06onKViP06od];BomlO7coFe]Ko`/;2olF5QKoUiNG0_oVi^H01om;Bd_oNg]koe=CDol8
20Sof=SHom7AdOm9BDT00_l=3@d02_m;Bd_od];BonKVi_oVi^Koc<c<ocdm?Ol92@Wo92@TofYZJ_lU
9BD2onKViP0:od];BomkNg_oDe=Co`P82?oHf=Soclo?od10@?l;2`_o6ATIojFUY@;oi^KV00Go[:b/
oc@d=?l>3Pko4A4Aom7Ad@02onKViP05ojb/[?ld=3Co3Ph>oa4A4OoAdM407?oVi^H004ook^k^00?o
G5aLob8R8_oMgMd02?o^k^h2ong]k@Ook^k^00?okNg]onk^k_o^k^h00_o^k^h00oo]kNgok^k^onk^
kP04onk^kP03onc/k?o^k^kok^k^00[ok^k^00?oAdM7ofYZJ_o^k^h01?o^k^h00oo/k>cok^k^onk^
kP02onk^kP03odM7AomZJV[ok^k^00Sok^k^0_o]kNd7onk^kP03ong]kOo^k^kok^k^00gok^k^00?o
kNg]onk^k_o^k^h02Oo^k^h00oo/k>cok^k^onk^kP05onk^kP04on_[joo^k^kok^k^onk^kP;okNg]
1_o^k^h00oo/k>cok^k^onk^kP06onk^kP05on_[joo^k^kok^k^onk^k_o[jn/01_o^k^h00oo[jn_o
k^k^onk^kP04onk^kP03on_[joo^k^kok^k^01cok^k^001?ooooo`08on_[jom1@D7o7QhNog]kNonG
UiOoM7Adoc0`<?nn_[hUooooo`03on3Ph?oNg]kooooo00Wooooo00?oh>3PomkNg_ooool00_ooool0
0omKFe_oTY:Booooo`0Eooooo`03oe]KFonBTY;ooooo05kooooo001@onk^kP07ong]kOnVYZKoMgMg
of9RH_moOgooXJ6Qon3Ph00fonk^kP03ojRXZ?no_kook^k^01Gok^k^00?oZ:RXokno_oo^k^h0G_o^
k^h00?ooi^KV1ooVi^H00?ook^k^1oo^k^h00?oooooo1oooool00?ook^k^1oo^k^h00?ooi^KV1ooV
i^H00?ook^k^1oo^k^h00?oooooo1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H00?ook^k^1oo^
k^h00?oooooo1oooool00?ook^k^1oo^k^h00?ooi^KV1ooVi^H00?ook^k^1oo^k^h00?oooooo1ooo
ool00?ook^k^1oo^k^h007GoOgmo2?mnOWj9ogmoO`0000Cojn_[onKVi_oRh^;og]kN1?oMgMd3omkN
gP0^omgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNgP;ogMgM03[og=cMomgMgOoMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kN0_oLg=`2omSHf021omOGeooIfMWof][KomgMgOoLg=cog]kNomgMgOoNg]kogMgMomkNg_oM
gMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoN
g]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oM
gMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoN
g]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oM
gMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoN
g]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oM
gMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oN
g]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgM00?og]kN
00?ogMgMomkNg_oNg]h00ooMgMd1on7Qh@7oinOW0OoZj^X00003onc/k?oVi^Koh>3P00OofMWI00Co
f=SHomKFe_oCdm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P;omWIf@04omSHf?oGemOodm?Com3@
d0?ocLg=00Cod=3@om?CdooGemOof=SH3?oIfMT02OoHf=SoemOGomGEeOoDe=Codm?ComCDe?oEeMGo
emOGomSHf00`omWIf@?of=SH00GofMWIomSHf?oGemOoe=CDom3@d003olg=c@03om7AdOoEeMGof=SH
00SofMWI0_oHf=P4omWIf@;of=SH1OoIfMT2omSHf6GofMWI00?of=SHomWIfOoIfMT01_oIfMT1omkN
gP7oi^KV0Oo/k>`00007onk^k_oYjNWoi>CTon3Ph?oQhN7oh>3Pon;RhP02on7Qh@0=omkNg_oLg=co
dm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=omoOgooKfm_o
dm?ColO7aonk^k_o/[:bojj^[_nb/[;o^k^kolO7aooCdm?ofm_KomoOg`09on7Qh@0=on3Ph?oOgmoo
fm_KomKFe_oBd];oc/k>olc<c?o>c/kod];BomKFe_oKfm_ogmoOon3Ph00Non7Qh@Koh>3P00?ohN7Q
on3Ph?oPh>001_oPh>02omoOg`0?omkNg_oOgmoogmoOon3Ph?oOgmoofm_KomOGeooDe=Cod];Bom7A
dOoBd];ofMWIomkNg_oPh>3ogmoO00;oh>3P00CohN7Qon3Ph?oPh>3ogmoO0_oNg]h00ooOgmooh>3P
on3Ph002omoOg`03omkNg_oOgmooh>3P00;oh>3P00CogmoOomkNg_oOgmoogmoO0ooPh>001OoOgmoo
h>3Pon3Ph?oPh>3ogmoO00?oh>3P00CogmoOon3Ph?oPh>3oh>3PEooQhN400ooRh^;ohN7Qon;RhP04
on7Qh@7oi>CT0OoYjNT1ong]k@0000?ol?3`ono_kooalO400oo`l?00;_o_knool?3`onk^k_oYjNWo
fm_Kol71`OnTY:CoS8b<og]kNomgMgOoNg]kohb<S?nTY:Co`/;1om[Jf_oZj^[okNg]oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo]kNgoj^[Zom[Jf_o2`/;oY:BTohb<RomkNg_oMgMgog]kNon<S8co
Y:BTol;2`_oJf][oj^[Xong]kOoalO7okno_oo7alOo_knoolO7aono_kooalNl2onk^kP0;onKVi_oN
g]kodM7AolW9bOo1`L7o_knnol71`Oo9bLWodM7AomkNg_oVi^H00_o^k^h07OoalNookno_oo7alOo_
knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooa
lO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a00;ok^k^00KojNWYonc/j_o]
kNgol?3`ono_koo`l?02onc/k00Don[Zj_o^k^cok^k^oo3`l?o/k>cojn_[onKVi_oWinOoi^KVon_[
jOo/k>cokno_om[Jf_n;Rh_oI6AToeiNG_n6QXKofMWGon?Shoo/k>`3on_[j`06oo3`l?o^k^kokno]
on_[jooYjNWoiNGU0_oXj>P01?o]kNgojn_[on_[jOoVi^H2onSXj0?okNg]00Ooj>SXonSXi_oVi^Ko
jn_[onc/k?o_knooj^[Z00;ojn_[00Gok^k/on_[joo[jn_oj^[Zonk^kP02on_[j`1Pon[Zj_o_kngo
k^k^oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoo
lO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7o
kno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoo
lO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7o
kno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoo
lO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_1?o`l?000003oo;bl_o^k^koinOW00CoiNGU013oi>CTomoOgooAdM7o/K6a
ohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKoRXZ9ok6a/OoAdM7og]kN0_oTi>@00ooUiNGo
i>CTonGUi002onCTi00?omkNg_oAdM7o/K6aohZ:R_mVIVKoDE5AodE5AOm2@T;oADE5oe5ADOmVIVKo
RXZ:ok6a/OoAdM3og]kN00;oi>CT03KoiNGUonCTi?oUiNGoi>CTonGUi?oRh^;og=cLolo?coo1`L7o
/K6aojVYZOnTY:CoY:BSojBTY?nYZJWo/K6aol71`Oo?cloog=cLon;Rh_oUiNCoi>CTonGUiOoTi>Co
iNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGo
i>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUon;Rh_oOgmoofMWIom_Kf_oOgml3
onCTi004omoOgooKfm_ofMWIomoOgP;oh^;R01_og=cLomSHf?oDe=CoeMGEomCDe?oHf=Oog=cLon7Q
hOo5aLGoCDe=oh20P?mkNg_o9bLWocTi>OoFe]KogMgMom_KfooIfMWog=cLon;Rh_oShn?oh>3Oom[J
f_oFe]KoeMGEomOGeooJf]X00_oNg]h0L?oLg=_oemOGomKFe_oFe]Kog=cLomoOgooNg]kofMWIomOG
e_oEeMGofMWIomgMgOoPh>3ofm_Kom[Jf_oLg=coh>3OomcLg?oJf][ofm_Kon3Ph?oMgMgof][Jom_K
fooQhN3ohn?SonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCT
i?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCT
i?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGU
iOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>@4onGUi@06
onCTi?oUiNGoiNGUonGUiOoXj>SokNg]0Oobl_800003ooCdm?o]kNgoinOW00;oh>3P01?ohN7QomoO
gooNg]kod];BokBd]?n7QhOoG5aLofdk=OnNCT;ocFmOonV3Koo=KeooWTi3ofdk=_mLG5coQhN7okBd
]?oBd];og]kN00Goh>3P017og]kNom;Bd_nd];CoQhN7oeaLG?m]H2coWYH^olg=?ooYjDgocLdooijJ
;om]HbgoG5aLohN7Qond];Cod];BomkNgP05on3Ph00AomoOgooJf][oc/k>okbl_?n[Zj_o/;2`olO7
aooIfMWoi>CTomWIfOo7alOo/K6aoj^[Zonl_;coc/k>om[Jf_oOgml07?oPh>002OoNg]kof=SHom7A
dOoBd];ofMWIomkNg_oOgmoog]kNomWIf@02om;BdP0=omSHf?oMgMgofm_KomCDe?o@d=3oc/k>okbl
_?o>c/kod=3@omCDe?oHf=SoeMGEom3@d002om7Ad@07ok6a/Ol0003oYjNWomSHf?oEeMGodM7AomKF
eP02omgMg@06omSHf?oAdM7oclo?olO7aoo6a/Kof=SH0_oKfm/06_oHf=Soclo?olC4a?o@d=3odm?C
omWIfOoJf][of=SHol?3`oo<c<cod=3@omKFe_oJf][of=SHomOGeooIfMWofm_KomWIfOoGemOof=SH
om_KfooJf][oemOGomSHf?oLg=cogmoOEOoPh>000ooOgmooh>3PomoOg`02omoOg`?oh>3P00?ohN7Q
onOWioo/k>`00Oodm?@00003ooKfm_obl_;ojn_[00?oj>SX01?oinOWon;Rh_o=cLgoWinOof]OGon?
=RkokG5QooVMT?om/JGooKb_oofdYooiWi?okGASoi8g;om[GeooWinOolg=cOoRh^;oinOW00?oj>SX
01?oinOWon;Rh_o=cLgoWinOofiVGonCLR;okM54ooWcM?omoHgooOfEoogmS_oin7KokMM7oi=c8_m^
IeooWinOolg=cOoRh^;oinOW00Coj>SX00Ooi^KVomgMgOo:b/[o]KFeokno_ooWinOokno_00?ol?3`
00Ookno_onWYjOo1`L7o]KFeol[:b_oMgMgoi^KV01coj>SX00Koi^KVomoOgol`<33oJ6QXomkNg_oT
i>@2onKViP0Ion7QhOmQHF7oAdM7on3Ph?oUiNGohN7QomWIfOmfMWKo20P8oaLG5ol92@WoN7QhomSH
f?oLg=cofMWIohR8R?lf=SKoBDU9oj^[ZolK6a_oS8b<omkNg_nk^k_o0000olW9b@02onCTi00?omcL
g?nl_;co>3Pho`<30olO7aoo5aLGokbl_?oTi>Co@T92o`X:2_lN7Qko=cLgol;2`_oRh^;o_[jn00;o
5aLG017o6a/Kof=SHooMgMgoi>CToibLW?l0003o[:b/onKVi_nf][Ko0000oi>CTooVi^Kod=3@o`00
0?mhN7Soi^KVonOWi`1NonSXj07ok>c/0Oobl_81ooKfmP0000?omoOgooShn?ohn?P00oohn?P04oog
moOok^k^olk>c_n@T93oQBl[onUTE_okTXOooZJKoojaYOoo^:_oo[>VoojXW?okU8WokVQIohTa:on@
T93oc/k>onk^k_ogmoL00oohn?P04oogmoOok^k^olk>c_n@T93oVFT[oo2m?Ookh6koo_B2ooknR_oo
oi;oo_j<ookhPookiG3ol<8noiUZ:on@T93oc/k>onk^k_ogmoL01?ohn?P01_odm?CoinOWolo?coo6
a/Koj^[ZooCdm0;onOWi00Won_[jooWinOoinOWom_Kfon_[joo7alOoclo?onOWioodm?@07?ohn?P0
8Oofm_Kokno_oc<c<om_Kfooj>SXong]kOoalO7olo?coo3`l?mXJ6SoBd];ono_koodm?Col?3`ojFU
YOl20P;o/K6aooCdm?nf][Ko0`<3ojBTY?oYjNWo^[Zjo`<30om^KVkoWIfModE5AOlD51CoS8b<onk^
k_o8b<So0000omKFeP02oo?cl`0QonOWiol^;RkoBTY:om7AdOoXj>Sog=cLonKVi_oclo?o^[Zjon3P
h?oVi^KoF5QHofEUIOoclo?ogmoOol;2`_oWinOofMWIo``<3?no_koom_Kfol[:b_mZJV[oe=CDooOg
mooJf][oJVYZolC4a?ogmoOoj^[ZofYZJ_nd];ComoOg05Son?Sh00?omoOgooShn?ohn?P00_ohn?P0
1?ogmoOonOWiooOgmoogmoL1ooShn00000?on_[jooGemOo^k^h00_o/k>`0;?o[jn_ojNWYomoOgonj
^[[oNE9Boklb9?oWM6WooHUnoonHS?onXYKoojRLoojTV?ooVXgooXYoonifJ_o3<bCoNE9BokZj^_oO
gmooj^[Zon_[joo/k>cojn_/on[Zj_oOgmoo^[ZjohQUD_oRTAconL=@oogJHooojW;oo_=nooojP_on
mWooonacookNI?ojae7ohY8LohUVDonj^[[ogmoOon[Zj_o[jn_ok>c/0_o[jn/02OoVi^Oof=SHok^k
^ooDe=Coi>CTon_[jooalO7ol_;boo?cl`02oo;blP06ong]kOoUiNGoeMGEok^k^ooHf=Soi^KW0_o[
jn/0/oo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[on[Zj_oRh^;o<30`
ofQXJOoIfMWof][JomgMgOoPh>3oh^;Rof9RH_m8B4SogmoPonKVi_oRh^;oD51@oc0`<?oPh>3oi>CT
on3Ph?lb<S;oDU9BomkNg_m`L73o=CDeon3Ph?oTi>CofMWIoaTI6On3Ph?ohN7Qokfm_Ol0003ob/[:
on?ShooVi^Ko[jn`o`000?n`/;3og=cLomWIfOoKfm_ohN7QonCTi?oNg]oof][Jokbl_?lW9bOoHF5Q
onWYjOoRh^;og=cLomWIf_nATI7o0@41okRh^?oZj^[ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/
on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[
onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/
on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/
onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/
on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[
onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/
00Oojn_[00Gok>c/on_[joo[jn_ok^k^ooKfmP01ooWin@0000?ono_koo?cloo]kNd00_oUiND0;?oV
i^Koi>CTomWIfOnb/[;oNBh^olQ2=?oSJUcom7Y]oof8O?onUh[ooY^>oojHRoonRWkom7]]onM[GOo:
@SCoNbh^ok:b/_oHf=Soi>CTonGUiOoVi^KoiNGVonCTi?oHf=So/[:boiIE;_oZW2_onka4ook<Doom
f6;oo^=bookYMOoniW?oo]]Uoog<Dook`DGokYh[oiUF;_nb/[;of=SHonCTi?oUiNGoi^KV0_oUiND0
4OoOgn3odM7AokJf]_oDe=CogMgMonCTi?oVi^Kok>c/onc/kOo/k>coj>SXonCTi?oOgmooeMGEokJf
]_oAdM7ogmoP00;oiNGU02Koi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoTi>Cog=cLobl_;om;BdcoZj^[olK6a_oCdm?oeMGEom[Jf_mPH63oADE5omGEeP;og=cL01Oo=cLg
oeMGEooGemOof=SHomOGeomGEeSo>3PhomcLg?lh>3SoFe]KomOGeooIfMWoemOGobDU9On0P83og=cL
okZj^_l0003o`L71omWIfOoMgMgoTI6Bo`820P04ocLg=`1aokRh^?oOgmoocLg>oeIFE_l10@7oCDe=
olg=cOoRh^;og=cLojb/[?lW9bSo30`<oh61POoRh^;oi>CTonKVi_oUiNGoi^KVonGUi_oVi^KoiNGU
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KV
onGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGV
onKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KV
onGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGU
onKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KV
onGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGU
onKVi_oUiND00_oVi^H00ooUiNGoi^KVonKViP03onKViP03onGUiOo]kNgom?Cd007ono_k00000ool
o?con?Shoo7al@03onk^kP0Con_[jooQhN7o_;blogXG5oo3?c;odeI9onAXF_o_Mfcom8=iooR7O?oe
Q7[olgU]onEYFooIF4[oa3lbog`G5onl_;cohN7Qonc/k003onk^kP0Conc/k?oQhN7o_;blojE75ooV
Uc;omJ``oofl@OombE?ooM1Poo_CIOomdV3oo/eDoofm@_oj[c;ojI/bojE65onl_;cohN7Qonc/k003
onk^kP08ong]kOoYjNWof][JokVi^OoGemOog]kNon?ShooVi^H3on[ZjP08onSXj?oTi>Cog]kNomSH
f?ni^KWof][JonWYjOo]kNdKonk^kP0@onc/k?oUiNGo<C4aoa/K6olN7Qko0000oe5ADOoCdm?ohN7Q
ofATI?le=CGoh>3Pon;Rh_oVi^KoEEEEobl_;`?ogmoO00Go;bl_oeIFE_oZj^[oD51@oc<c<`03omoO
g`0MobHV9_n6QXKoinOWol;2`_l0003o]kNgon7QhOoTi>Co];Bdo`000?nWYjOo][JfojBTY?l51@Go
gmoOonWYjOmPH63o9bLWok>c/ooRh^;oinOWon_[jooRh^;o3`l?oeiNG_o@d=3oi>CTonWYjOo]kNd0
J_o^k^h00oo]kNgol_;booShn001ooclo0000oomoOd05_olo?cooOgmoogmoOolo?colo?com7AdOmX
1`Oo^3@dolLo<ooBD4?ofV9Eon=^H_oTLVCoi6mRomaTEooCDD?oc44dokTd=?m[1`Ood];Boo?clool
o?`3oogmo@0Cooclo?oclo?od];Boih[1ooJRSCoji/IooFX:Ooh]3oonKe:ooRoCOoj_d[onKPoooJZ
:_o_WQWofh/doj8]1ooBd];olo?cooclo004oogmo@07ooWinOo/k>co^;Rhom_KfooQhN7oiNGUonWY
j@02onc/k008ong]kOoZj^[oiNGUon;Rh_oKfm_o^KVionc/k?oinOTLoogmo@0Yoo_knoodm?Co=3@d
og5aLOo_knooa/K6o`/;2omUIFGolo?cofa/K?l@413oJf][omOGeooalO7o_Kfmo`820_nRXZ;ok>c/
oj:RX_l20P;o_[jnooclo?ne]KGo0`<3oj>SXooclo?o/[:bo``<3?n@T93on_[jom;Bd_l0003o>3Ph
okfm_OoYjNWom_Kfob/[:omjNW[okno_ohJ6Q_ln?Sh00_okno/03OmMGEgoK6a/ooGemOoVi^KokNg]
oo_knoo^k^ko30`<olK6a_oemOGog=cLoo[jn_olo?`0J?omoOd00oolo?cooOgmooclo003oogmo@00
09OooOgmoo[jn_oclo?ok^k^oo3`l?o_knook^k^onWYjOoCdm?oFadMoj8d=?nd:1go`CX]olM9??o?
ET[od5M;om1GB_o:BSko`c/^okHX7OnR=3CoG1dMom?CdooZj^[ok^k^oo3`l?o_knool?3_onk^k_oZ
j^[odm?Coh`U7Oo8LCCofH@MonBD5OoWWBCokZPcoo2Z=?o_ZS?ok:0UonNG5OoLR1gob74doh`U7OoC
dm?oj^[Zonk^k_o`l?3okno_oo3`l?o_knook^k]on?Shon/[:cob/[:om;Bd_oGemOof][JomgMgOoN
g]gogMgMomcLg?oGemOoe=CDol[:b_n/[:cohn?Sonk^kOo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okNg]onSXj?la<C7oJf][omkNg_oOgmooGEeMoadM7OoZ
j^[oMWIfoe]KFomhN7So3`l?okBd]?o^k^koVIVIoalO7ol820So820PoiZJV_o^k^kokno_onk^k_n9
RHWo5QHFoa4A4OmNGUko=CDeoiBDU?o_knoocLg=oaTI6On[Zj_o:BTYoe9BD_o_knkocLg=ocPh>?l:
2P[o8B4QokNg]oo_knook^k^olW9b?m1@D7o4Q8Bo`h>3_ng]kOok^k^ono_kon@T93o:2PXo`d=3Ol/
;2cok^k^00;okno_06;ol?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_
knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`
l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_
knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`
l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_
knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`
l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_k`;ol?3`1_o_knl1oo?c
l`7onOWi0Oono_h00003ookno_ogmoOol?3`00CojNWY017oinOWom_KfomSBd_oPC8bojHe=Onf=2go
`Te1ol=DBOo4ED[o`eA9ol9=@Onf=2goYCDeoh4b<_mSBd_ofm_KonOWi`05onWYj@0AonOWiooKfm_o
RD];ojm;<_o=McGoeX/]on2L;_oPX3;ohJ0don2P<_oOVRkoeX/]olYe=On_Bc;oRD];om_KfooWinL0
1OoYjNT01_oXj>Sohn?Soj^[Zoni^KWobLW9olo?c`;oeMGE00Woe]KFomGEeOoDe=Coclo?olS8b?ni
^KWoZj^[on?ShooXj>P07?oYjNT01?oXj>Soi>CToc0`<?mYJFT2omgMg@04ochn?_lm?CgoinOWonSX
j0;ojNWY00?oinOWonSXj?oYjNT00_oYjNT00ooWinOojNWYonWYj@05onWYj@03onOWiooYjNWojNWY
00KojNWY00Goi^KVonWYjOoYjNWojNWYonKViP06onWYj@03onKVi_oYjNWojNWY00CojNWY00?oi^KV
onWYjOoYjNT0IOoYjNT00ooXj>SojNWYonWYj@04onWYj@7ol?3`0OogmoL1ooknoP0000Goo_knoo[j
n_odm?Cokno_oo7al@02oo3`l00Aono_koo[jn_oUIBDodlS8onEE5Co^g=com>EUOoJW9cofYjLomVL
W?oDUIGo^g=coiEDE?m?8b?oUIBDon[Zj_o_knl01Oo`l?004Oo_knooj^[ZojVDU?n18b?o^VYDomBJ
LooT_9Goj/NLonW7W?oZaicoiKbEomBJLonkJUCoPB<SojZDU?oZj^[okno_00Kol?3`00Kok^k^ol_;
bonWYjOob<S8omSHf?oShn<3onKViP06on?ShooHf=Sob<S8ojNWYoo;bl_ok^k^7Oo`l?002Oo_knoo
k^k^oc8b<_l/;2coE5ADob@T9?l10@7oXj>Sono_k`2Hoo3`l004oo7alOo`l?3om?Cdoo[jnP7oo_kn
00001?ojn_ooooooooooooono_h2ooooo`;oo_kn05SooOgmooShn?m^KVkoFSlook6@T?oNbLWol>CT
oo?Vi_o`i>Cog/W9ok6@T?mJ?cooKFe]ooShn?olo?coooooookno_ooooooo_knooooo_ono_kooooo
ooclo?ohn?SoSFe]ohXo?oo9TI3ojM39ooCYi?ofjnKom>WTonW@bOo9TI3oRCloohe]KOohn?Ooo?cl
ooooooono_koooooookno_ooooooo_knooooo_omoOgoo?clolG5aOnj^[[ogMgMoo7alOohn?SonOWh
ooShn?oalO7ogMgMokZj^_o5aLGoo?cloogmoOooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_kooooo0_ono_h01On^[ZkoVIVHoiVIVOn/[:cog=cL00;oo_kn09Co
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_ko
ooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_oooooo
o_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_ko
ooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooko
o_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_ko
ooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_oooooo
o_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_ko
ooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_oooooo
o_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooooooo_kn0_ooool00oon
o_koooooooooo`03ooooo`7on_oo00001?o`l?ooo_knoo[jn_odm?@5oo7al@0=ono_kooFe]KoJf][
od<m?OnKS8coa[ZjomK<c?o7^[[oVhb<od<m?Om[Jf_oe]KFono_k`09oo7al@0=ono_kooGe]KoPf][
og@m?OneS8coeKZjon7<c?oF^[[o]Xb<og8m?On1Jf_oemKFono_k`09oo7al@0=oo3`l?oVi^Ko_Kfm
ok2`/?o?cloogmoOonGUiOoOgmooclo?ok2`/?nm_Kgoi^KVoo3`l02hoo7al@04oo3`l?oalO7olO7a
oo3`l0ColO7a00?om?Cdoo[jn_ono_h00Oo`ool00005omWIm?omoOgon?Shoo3`l?o[jn/00ooZj^X0
3OoYjNWoj^[ZonWYjOoXj>SoVi^KoeUIFOlV9RKo2@T9obHV9_mIFEWoVi^KonSXj?oYjNT02ooZj^X0
2ooYjNWoj>SXoj2KVomZFEWo@bHVobd92Om29RKoJEUIoj2KVooXj>SojNWY00coj^[Z00WojNWYol[:
b_na/K7oWIfMoi:BT_nMWIgo/K6aol[:b_oYjNT0`OoZj^X01?o[jn_ol?3`ooShn?omoOd1omWem@00
00CoY:C6ojb/[?ojn_[om?Cd2?oalO42oo3`l0?okno_0_o`l?0?oo7al@;ol?3`0oo_knl2oo3`l17o
lO7a0oo`l?30oo7al@03oo3`l?oalO7olO7a00;olO7a00?omOGeoo[jn_o^o_h00OnTa/H00003ojZZ
eOlg=cOoo_kn0?oooooo0Oooool1onooo`7o[lg=0OnYe=@00004oo;bl_oDe=Coa/K6ooCdm?gooooo
00Coo_knooCdm?o6a/Koe=CD0Oobl_800001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{262, 151},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleProgressMonitor",
        ButtonData:>{"SimpleProgressMonitor.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(JavaShow[frame];\)\), "\[IndentingNewLine]", 
    \(SimpleProgressMonitor[pane]\)}], "Input"],

Cell[BoxData[
    \(Java::"excptn" \(\(:\)\(\ \)\) 
      "A Java exception occurred: \!\(\"java.lang.IllegalArgumentException: \
argument type mismatch\"\)."\)], "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> javax.swing.ProgressMonitorInputStream <<<",
  FontColor->GrayLevel[0.500008]]], "Section"],

Cell[CellGroupData[{

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004>0000MAP00`40o`00
0?l0003oo`0000l000000003R<2hB928B9280?m8T8P;B9280@00000000>8
`;S8h=R8`;P0ohS0^0Z8`;P1B9280@00000000>8`;S8h=R8`;P0ohS0^0Z8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<1lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;So
c<c<1lc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;Soc<c<1lc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;QVc<c<>oooofG<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hILc<c003IVIVc<c<IVIV03QVIVH00oooolc<c<c<c01Sc<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^6G<c<`00fIVI_ooolc<c00gc<c<00=V
IVKoooo<c<`0I<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QUc<c<
00=VIVKoooo<c<`0=lc<c003IVIVooooc<c<06C<c<`2R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2hILc<c003IVIVooooc<c<00O<c<`XVIW<2<c<c003
IVIVooooc<c<06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hILc<
c003IVIVooooc<c<00O<c<`00iVIc<c<c<c<c00Tc<c<00>IVLc<c<c<c<`0
1/c<c003IVIVooooc<c<06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2h
R<2hILc<c003IVIVooooc<c<00O<c<`00iVIc<c<c<c<c00Tc<c<00>IVLc<
c<c<c<`01/c<c003IVIVooooc<c<06C<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2hILc<c003IVIVooooc<c<00O<c<`00iVIc<c<c<c<c003c<c<
0`0000?<c<`01@000<c<c<c<c<c<c0000002c<c<0P0000;<c<`200001/c<
c0030000c<c<c<c<00G<c<`00iVIc<c<c<c<c006c<c<00=VIVKoooo<c<`0
I<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QUc<c<00=VIVKoooo<
c<`01lc<c003VIW<c<c<000000?<c<`700000/c<c0800002c<c<0P0000?<
c<`200001<c<c0H00003c<c<00>IVLc<c<c<c<`01/c<c003IVIVooooc<c<
06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hILc<c003IVIVoooo
c<c<00O<c<`00iVIc<c<c0000005000000C<c<`0000000000004c<c<0P00
0003c<c<0000000000?<c<`200000lc<c0800004c<c<0`000003c<c<VIW<
c<c<00O<c<`00fIVI_ooolc<c01Tc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^6G<c<`00fIVI_ooolc<c007c<c<00>IVLc<c<c<c<`00P000004
c<c<00000000c<c<0`0000C<c<`:00000lc<c0800005c<c<00@0003<c<c<
c<bIVL`8c<c<00=VIVKoooo<c<`0I<c<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;QUc<c<00=VIVKoooo<c<`01lc<c003VIW<c<c<c<c<00T00005
c<c<00@0003<c<`000000003c<c<0P0000?<c<`200002<c<c003VIW<c<c<
c<c<00K<c<`00fIVI_ooolc<c01Tc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^6G<c<`00fIVI_ooolc<c007c<c<00>IVLc<c<c<c<`00P000003
c<c<0000000000@00004c<c<00<0003<c<c<c<`01`0000?<c<`200002<c<
c003VIW<c<c<c<c<00K<c<`00fIVI_ooolc<c01Tc<c<0XS0^058T8P10000
000018S0^<SPf8S0^8S0^6G<c<`00fIVI_ooolc<c007c<c<00>IVLc<c<c<
c<`00P000003c<c<00000000008000000lc<c00000000002c<c<0`000003
c<c<0000000000?<c<`200000lc<c0800008c<c<00>IVLc<c<c<c<`01/c<
c003IVIVooooc<c<06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
ILc<c003IVIVooooc<c<00O<c<`00iVIc<c<c<c<c007000000?<c<`00000
00000lc<c0030000c<c<c<c<00L00003c<c<0P0000S<c<`00iVIc<c<c<c<
c006c<c<00=VIVKoooo<c<`0I<c<c0:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;QUc<c<00=VIVKoooo<c<`01lc<c003VIW<c<c<c<c<008000000lc<
c0000000000500001<c<c0P00004c<c<0P0000S<c<`00iVIc<c<c<c<c006
c<c<00=VIVKoooo<c<`0I<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8
`;QUc<c<00=VIVKoooo<c<`01lc<c003VIW<c<c<000000H00007c<c<0P00
0003c<c<0000000000D00003c<c<0P0000S<c<`00iVIc<c<c<c<c006c<c<
00=VIVKoooo<c<`0I<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;QU
c<c<00=VIVKoooo<c<`01lc<c003VIW<c<c<c<c<00c<c<`01P000<c<c<c<
c<c<c0000<c<c0<0000?c<c<00>IVLc<c<c<c<`01/c<c003IVIVooooc<c<
06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hILc<c003IVIVoooo
c<c<00O<c<`00iVIc<c<c<c<c00Tc<c<00>IVLc<c<c<c<`01/c<c003IVIV
ooooc<c<06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hILc<c003
IVIVooooc<c<00O<c<`00iVIc<c<c<c<c00Tc<c<00>IVLc<c<c<c<`01/c<
c003IVIVooooc<c<06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
ILc<c003IVIVooooc<c<00O<c<`00iVIc<c<c<c<c00Tc<c<00>IVLc<c<c<
c<`01/c<c003IVIVooooc<c<06C<c<`2R<2h0DR@R04000000004R<2hb>3H
R<2hR<2hILc<c003IVIVooooc<c<00O<c<`XVIW<2<c<c003IVIVooooc<c<
06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2hILc<c003IVIVoooo
c<c<03O<c<`00fIVI_ooolc<c01Tc<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^6G<c<`00fIVI_ooolc<c00gc<c<00=VIVKoooo<c<`0I<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;QUc<c<00=VIVKoooooool0=ooo
o`03c<c<ooooc<c<06C<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
ILc<c3]VIVIVc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<`7c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^3W<c<c3IVIV2/c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;Pi
c<c<00=VIVIVIYVIVL`0NYVIc4G<c<`00fIVI/c<c<c<c008c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^1K<c<`01jfTbY:8[:NN`X^2Y:6I^hIm
WIfE]@0Lc<c<00=VIVIVIYVIVL`0NYVIc4G<c<`00fIVI/c<c<c<c008c<c<
0XS0^058T8P10000000018S0^<SPf8S0^8S0^1?<c<`03KV_f9fC^kBZdIN>
]:fTbY:8[:NN`X^2Y:6I^hImWIfE]HImWIfE]@0Ic<c<00=VIVIVIYVIVL`0
NYVIc4G<c<`00fIVI/c<c<c<c008c<c<0XS0^058T8P10000000018S0^<SP
f8S0^8S0^17<c<`04JNN`[fcgJNN`[V_f9fC^kBZdIN>]:fTbY:8[:NN`X^2
Y:6I^hImWIfE]HImWIfE]HImW@0Gc<c<00=VIVIVIYVIVL`0NYVIc4G<c<`0
0fIVI/c<c<c<c008c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^13<
c<`04j:G`KfcgJ:G`KfcgJ:G`KV_f9fC^kBZdIN>]:fTbY:7[:NN`X^2Y:6I
^hImWIfE]HImWIfE]HImW@0Fc<c<00=VIVIVIYVIVL`0NYVIc4G<c<`00fIV
I/c<c<c<c008c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0o<c<`0
5J:G`KfcgJ:G`KfcgJ:G`KV_f:NN`[V_f9fC^kBZdIN>]:fTbY:8[:NN`X^2
Y:6I^hImWIfE]HImWIfE]HImW@0Ec<c<00=VIVIVIYVIVL`0NYVIc4G<c<`0
0fIVI/c<c<c<c008c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0k<
c<`01jNN`[fcgJ:G`KV_f:NN`[fcgJNN`P0;f<[o00F6OIfMUKF6OIfMUKF6
OId05<c<c003IVIVIVJIVIW<07ZIVLa5c<c<00=VIVK<c<c<c<`02<c<c0:8
`;P1B9280@00000000B8`;S8h=R8`;R8`;P=c<c<00VWW/:m/mfRUl6m/mfW
W/:i[mRRUl51<FRUUlh02D4aJ007f<[oXIVkQWfMWIFeQWfMWIFeQWfM01?<
c<`00fIVIVIVVIVIc01jVIW<ALc<c003IVIVc<c<c<c<00S<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h3<c<c009XYO1_K?MXYO1_K?MXYO1^JoH
Yik2^JoH@C5X00?Hb_l03j:G`KV_f9fC^kBZdIN>]=S:ojFGc]S:oh^2Y:6I
^hImWIfE]HImWIfE]HImW@0Bc<c<00=VIVIVIYVIVL`0NYVIc4G<c<`00fIV
I/c<c<c<c008c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0c<c<`0
2;V_ej:G`KfcgJNN`[fcgJ:G`KV_f:NN`P=1<FP04=S:okfcgJNN`[V_f9fC
^d4aJ:FGcT4aJ9:8[:NN`X^2Y:6I^hImWIfE]HImWIfE]A;<c<`00fIVIVIV
VIVIc01jVIW<ALc<c003IVIVc<c<c<c<00S<c<`2R<2h0DR@R04000000004
R<2hb>3HR<2hR<2h2lc<c00M]:[AWI>k^JoGXYO1_K?MXYO1_K?MYik2^JoH
XYO1^JoH@C5Xf<[oXYO1_K?MXYO1^JoH@C5Xf<[oUhjd[JC:TXR/Yik2Rh:T
XIVkQWfMWIFeQWfMWIFe017<c<`00fIVIVIVVIVIc01jVIW<ALc<c003IVIV
c<c<c<c<00S<c<`2R<2h0DR@R04000000004R<2hb>3HR<2hR<2h2lc<c00M
Uhjd]:[AWI>k^JoGXYO1_K?MXYO1_K?MXYO1_K?MYik2@C5Xf<[o_K?MYik2
^JoHXYO1@C5Xf<[o]:[AUhjd[JC:TXN/Yik2Rh:TXIVkQWfMWIFeQWfM017<
c<`00fIVIVIVVFIVV@1jIVJIAIVIV@03IVIVc<c<c<c<00S<c<`2R<2h0DR@
R04000000004R<2hb>3HR<2hR<2h2lc<c00M[JC:Uhjd]:[AWI>k^JoGXYO1
_K?MXYO1_K?MXYO1^JoH@C5Xf<[oXYO1_K?MYik2_K?M@C5Xf<[oWI>k]:[A
Uhjd[JC:TXN/Yik2Rh:TXIVkQWfMWIFe017<c<c3IVIV2/c<c0:8`;P1B928
0@00000000B8`;S8h=R8`;R8`;P:c<c<01nWW/:BQjb]Y<ZGS[BdZ]6MTk^i
[mNRUl6m/mfWW/:m/mfWW/91<FSHb_nm/mfRUl6i[mRWW/91<FSHb_ni[mRM
Tk^dZ]6GS[B]Y<ZBR:bWW/:;PZBQVK^6OIfMUKD0gLc<c0:8`;P1B9280@00
000000B8`;S8h=R8`;R8`;P:c<c<01n;PZBWW/:BR:b]Y<ZGS[B]Y<ZMTk^i
[mNRUl6m/mfRUl6m/me1<FSHb_nRUl6m/mfWW/:m/me1<FSHb_nRUl6i[mRM
Tk^dZ]6GS[B]Y<ZBR:bWW/:;PZBQVK^6OId0gLc<c0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P:c<c<01nQVK^;PZBWW/:BR:b]Y<ZGS[BdZ]6MTk^i
[mNRUl6m/mfRUl51<FSHb_nm/mfRUl6m/mfRUl51<FSHb_nm/mfRUl6i[mRM
Tk^dZ]6GS[B]Y<ZBR:bWW/:;PZBQVK/0gLc<c0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P:c<c<01n6OIfQVK^;PZBWW/:BQjb]Y<ZGS[BdZ]6MTk^i
[mNRUl6m/me1<FSHb_nWW/:i[mRRUl6i[mQ1<FSHb_nWW/:m/mfRUl6i[mRM
Tk^dZ]6GS[B]Y<ZBR:bWW/:;PZ@0gLc<c0:8`;P1B9280@00000000B8`;S8
h=R8`;R8`;P:c<c<01nMUKF6OIfQVK^;PZBWW/:BQjb]Y<ZGS[B]Y<ZMTk^i
[mNRUl51<FSHb_nm/mfWW/:m/mfWW/91<FSHb_nm/mfRUl6i[mRWW/:i[mRM
Tk^dZ]6GS[B]Y<ZBR:bWW/80><c<c0@0002Qc<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^0[<c<`03HImWIfE]HImWIfC^h^2Y:NN`Y:8[:fTbYN>
];BZdIfC^kV_ed4aJ005f<[o00fUUlkHb_nRUl6m/mfWW/:i[mRRUl6i[mRM
Tk^dZ]6GS[B]Y<ZBR:`0=lc<c0040000c<c<c<c<c<c<0P000:3<c<`2R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h2/c<c00<WIFeQWfMWIFeQWfMWI>k
Rh:TYik2TXN/[JC:Uhjd]:[AWI>k1d4aJ00<XYO1_K?MXYO1_K?MYik2_K?M
XYO1^JoHWI>k]:[AUhjd[JC:4<c<c0800004c<c<0P000003c<c<00000000
00800003c<c<1@0000;<c<`2000000C<c<`00000003<c<`2000000?<c<`0
000000000/c<c0800002c<c<0P000003c<c<0000000000C<c<`200000/c<
c08000000lc<c00000000002c<c<100000;<c<`2000000C<c<`00000003<
c<`20000Plc<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P;c<c<00fM
UKF6OIfMUKF6OIfQVK^;PZBWW/:BQjb]Y<ZGS[BdZ]6MTk^i[mL00mS:o`0=
_K?MYik2^JoHXYO1_K?MXYO1_K?MXYO1_K?MXYO1^JoHWI>k]:[A017<c<`2
00000lc<c08000000lc<c00000000002c<c<0P000003c<c<0000000000;<
c<`2000000C<c<`00000003<c<`3000000C<c<`00000003<c<`200000/c<
c08000001<c<c00000000<c<c0<00004c<c<0P0000;<c<`2000000C<c<`0
0000003<c<`200000/c<c08000001<c<c00000000<c<c08000000lc<c000
00000023c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^0_<c<`03HIm
WIfE]HImWIfE]HImWJ6I^h^2Y:NN`Y:8[:fTbYN>];BZdMS:o`03@C5X00gH
b_nm/mfWW/:i[mRWW/:i[mRWW/:m/mfRUl6m/mfRUl6i[mRMTk/04Lc<c080
0003c<c<0P000003c<c<0000000000G<c<`200000/c<c08000000lc<c000
00000002c<c<0P000004c<c<00000000c<c<0P0000;<c<`2000000?<c<`0
000000000/c<c0800004c<c<0P0000;<c<`2000000C<c<`00000003<c<`2
0000T<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P;c<c<01fMUKF6
OIfMUKF6OIfMUKF6OIfMTk^;PZBWW/:BR:b]Y<ZGS[A1<FRMTk^i[mNRUl51
<FSHb_nm/mfRUl6m/mfRUl6m/mfRUl6m/mfWW/:i[mRWW/:i[mP04Lc<c080
0002c<c<0P0000;<c<`600000/c<c08000001<c<c00000000<c<c0800002
c<c<0P000004c<c<00000000c<c<0P0000;<c<`2000000?<c<`000000000
0/c<c0800004c<c<0P0000;<c<`2000000C<c<`00000003<c<`60000S<c<
c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P<c<c<01^MUKF6OIfMUKF6
OIfMUKF6OIfMTk^;PZBWW/:BQja1<FSHb_ndZ]6MTk^i[mNRUl51<FSHb_nm
/mfRUl6i[mRRUl6i[mRRUl6m/mfWW/:m/md04/c<c0H00002c<c<0P0000;<
c<`200000lc<c0@000000lc<c00000000002c<c<0P000004c<c<00000000
c<c<0P0000;<c<`2000000?<c<`0000000000/c<c0800004c<c<0P0000;<
c<`2000000C<c<`00000003<c<`200000/c<c080002<c<c<0XS0^058T8P1
0000000018S0^<SPf8S0^8S0^0c<c<`06hImWIfE]HImWIfE]HImWIfE]HIm
WJ6I^h^2Y:NN`T4aJ=S:oiN>];BZdIfC^kV_ed4aJ=S:ojNN`[fcgJNN`[fc
gJNN`[fcgJ:G`KfcgJ:G`@0Bc<c<0P0000?<c<`2000000?<c<`000000000
0/c<c08000000lc<c0000<c<c002c<c<0P000004c<c<00000000c<c<0`00
0004c<c<00000000c<c<0`000004c<c<00000000c<c<0P000004c<c<0000
000000001<c<c0800002c<c<0P000004c<c<00000000c<c<0P0000;<c<`2
0000S<c<c0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P=c<c<01V6OIfM
UKF6OIfMUKF6OIfMUKF6OIfQVK^;PZA1<FSHb_n]Y<ZGS[BdZ]6MTk]1<FSH
b_nm/mfRUl6m/mfRUl6i[mRRUl6i[mRWW/804lc<c0800003c<c<0P0000;<
c<`400000lc<c0@00003c<c<0P000004c<c<00000000c<c<0P000004c<c<
00000000c<c<0P0000?<c<`2000000?<c<`0000000000lc<c0@000001<c<
c00000000<c<c0800002c<c<100008g<c<`2R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h3/c<c00:QWfMWIFeQWfMWIFeQWfMWIFeQWfMWI>kRh:T@C5X
0mS:o`0:@C5Xf<[o^JoGXYO1_K?MXYO1_K?MYik2_K?MYik25<c<c0800003
c<c<0P0001?<c<`200005Lc<c0800005c<c<0P0009?<c<`2R<2h0DR@R040
00000004R<2hb>3HR<2hR<2h3lc<c009QWfMWIFeQWfMWIFeQWfMWIFeQWfM
XIVkRh:T00=1<FP02IN>];BZdIfC^kV_ej:G`KfcgJNN`[V_f::G`@0Ec<c<
1P0001C<c<`2000000?<c<`0000000004lc<c0D000000lc<c0000000002C
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^13<c<`04hImWIfE]HIm
WIfE]HImWIfE]HImWJ6I^h^2Y:NN`Y:7[:fTbYN>];BZdIfC^kV_ej:G`KV_
f:NN`P3Sc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^17<c<`04HIm
WIfE]HImWIfE]HImWIfE]HImWJ6I^h^2Y:NN`Y:7[:fTbYN>];BZdIfC^kV_
ej:G`@3Tc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^1?<c<`03IfE
]HImWIfE]HImWIfE]HImWJ6I^h^2Y:NN`Y:7[:fTbYN>];BZd@3Vc<c<0XS0
^058T8P10000000018S0^<SPf8S0^8S0^1K<c<`01ifE]HImWIfE]HImWJ6I
^h^2Y:NN`P3Yc<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<`7c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7
c<c<0XS0^058T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058
T8P10000000018S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P100000000
18S0^<SPf8S0^8S0^?o<c<`7c<c<0XS0^058T8P10000000018S0^<SPf8S0
^8S0^?o<c<`7c<c<0XS0^058T8P1000000000hS0^<SPf8S0^03oR<2h2XS0
^058T8P10000000018S0^<SPf8S0^8S0^1@008000`01P002P003P@0200B1
00P01H401X801h81288128<12H<12X<12h<20@b400<13H@13XD23hD00P8@
Q@030Q660Q:60Q>6008258L00`8EQ`8FQ`<GR0020aR800P36HT36XT36hT3
78T378X37HX47XX47h/2122;00P48H/48X`48h`498`498d59Hd59Xd59hd2
1BR>00<5:Hh5:Xl5:hl00PD/S`041Rf@1Rj@1Rn@1S2A0PHaT@081S:A1S>B
1SBB1cFB1cFC1cJC1cNC1cRC0PLiU0031cZD1c^E23bE0088?ID00`PnUPPo
UPQ0UP02246G00<8@YL8@iL9A9P00PU5V0082DJI2DNI2DRI2DVI2DVJ2DZJ
2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN
2eNO2eRO008;FIl010aJX0aKX0aLX0aMX@8<GZ4020aOX@aPXPaQXPeRXPeR
X`eSX`eTX`eUX`8=IZ@00`eWY0eXY@iYY@023VZU00<>JjH>K:H>KJH00Pi^
Y`033VnW3W2W3g6X008?LZP020mcZ@mdZ@meZ@mfZ@mfZPmgZQ1hZQ1iZ`8@
NZ/0211kZa1l[11m[11n[11n[A5o[A60[A61[@8APZh00a63[Q64[a65[`02
4HJ_00@BQk0BR;0BRK0BR[424X^a00PBS;4BSK8BS[8CSk8CSk<CT;<CTK<C
T[<24i>d00<CU;@CUKDDU[D00QBG]@0359Rf59Vf59Zf008DVkL00aBL]aBM
]aFN^0025Inh00PEX;TEXKTEX[TEXkTEXkXEY;XFYKXFY[/25ZNk00PFZ;/F
ZK`FZ[`FZk`FZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG/klD6;C00XS0
^058T8P10000000018S0^<SPf8S0^8S0^0@008000i^WlC=3YC=3Y@09<d>U
1000P003006000:000>1008018402005P@06PP07PP48PP48P`49P`4:P`4;
P`8138@00`4=Q04>Q@8?Q@020Q2500<24HH24XH24hH00P8DQ`030QF70QJ7
0aN8008368P020<IR@<JR@<KR@<LR@<LRP<MRP@NRP@OR`8488/020@QR`@R
S0@SS0@TS0@TS@DUS@DVS@DWS@85:8h00`DYSPDZS`D[S`021Bb?00@6;I06
;Y06;i06<9421S6A00P6<Y46<i86=987=I87=I<7=Y<7=i<7>9<21cVD00<7
>Y@7>iD8?9D00PPmU@0323jF23nF242F0088@IL00`Q2U`Q3U`U4V0022DFH
00P9AYT9AiT9B9T9BIT9BIX9BYX:BiX:C9/22TfK00P:CY/:Ci`:D9`:DI`:
DId;DYd;Did;E9d22eFN00<;EYh;Eil;F9l00P]IW`0435ZP35^P35bP35fQ
0PaNX@0835nQ362R366R3F:R3F:S3F>S3FBS3FFS0PeVY0033FNT3FRU3VVU
008>JZD00`i[YPi/YPi]YP023VjW00<>KjL>L:L?LJP00PmbZ0083g>Y3gBY
3gFY3gJY3gJZ3gNZ47RZ47V[0Q1jZ`0847^[47b/47f/47j/47j]4Gn]4H2]
4H6]0Q62[P034H>^4HB_4HF_008AQZl011:7/1:8/1:9/1::/@8BRk4021:<
/A:=/Q:>/Q>?/Q>?/a>@/a>A/a>B/`8CTk@00a>D]1>E]ABF]@0259Ne00<D
V;HDVKHDV[H00QBK]`0359bg59fg5Ijh008EWkP021FP^AFQ^AFR^AFS^AFS
^QFT^QJU^QJV^`8FYk/021JX^aJY_1JZ_1J[_1J[_AN/_AN]_AN^_@8G[kh0
11N`_QNa_aNb_aNc_a@H]<02R<2h0DR@R04000000004R<2hb>3HR<2hR<2h
0`00P007VjOaooooSWZfYY_4/jWBZ9g8/jWB00:VVl@01KbhgNk^m>[YlOoo
oc=3Y@03002000<00H000X000h400P04P@0800F100J200N20@R20@R30@V3
0@Z30@^30P4<Q0030@f40@j50Pn5008248D00`8AQP8BQP8CQP020QB700<2
5HL25XL35hP00P<HR0080aV90aZ90a^90ab90ab:0af:11j:11n;0P@PR`08
126;12:<12><12B<12B=1BF=1BJ=1BN=0PDXSP031BV>1BZ?1B^?0085;8l0
10H]T0H^T0H_T0H`T@86<I4020HbT@HcTPHdTPLeTPLeT`LfT`LgT`LhT`87
>I@00`LjU0LkU@PlU@0223fE00<8?YH8?iH8@9H00PQ1U`0324:G24>G2DBH
0089AIP020U6V@U7V@U8V@U9V@U9VPU:VPY;VPY<V`8:CI/020Y>V`Y?W0Y@
W0YAW0YAW@]BW@]CW@]DW@8;EIh00`]FWP]GW`]HW`022eVO00@<FZ0<Fj0<
G:0<GJ4235jQ00P<Gj4<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<23FJT00<=Ij@=
J:D>JJD00PiZY@033V^V3VbV3VfV008>KZL00`i_Y`i`Y`maZ0023g:X00P?
LjT?M:T?MJT?MZT?MZX?MjX@N:X@NJ/247Z[00P@Nj/@O:`@OJ`@OZ`@OZdA
OjdAP:dAPJd24H:^00<APjhAQ:lAQJl00Q66[`044XN`4XR`4XV`4XZa0Q:;
/@084Xba4Xfb4Xjb4hnb4hnc4i2c4i6c4i:c0Q>C]0034iBd4iFe59Je008D
UkD00aBH]QBI]QBJ]P0259^g00<DW;LDWKLEW[P00QFO^0085J2i5J6i5J:i
5J>i5J>j5JBj5ZFj5ZJk0QJW^`085ZRk5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm
0QN__P045k2n5k6o5k:o5k>o0QRd`10000026;C00XS0^058T8P100000000
18S0^<SPf8S0^8S0^080080019^WlOooofaJYJnUbP:l^=d02_omok>Yd_oo
oooookbhgIN:_:RMb>KVk?oooc=3Y@8008000`01P002P003P@0200B100P0
1H401X801h81288128<12H<12X<12h<20@b400<13H@13XD23hD00P8@Q@03
0Q660Q:60Q>6008258L00`8EQ`8FQ`<GR0020aR800P36HT36XT36hT378T3
78X37HX47XX47h/2122;00P48H/48X`48h`498`498d59Hd59Xd59hd21BR>
00<5:Hh5:Xl5:hl00PD/S`041Rf@1Rj@1Rn@1S2A0PHaT@081S:A1S>B1SBB
1cFB1cFC1cJC1cNC1cRC0PLiU0031cZD1c^E23bE0088?ID00`PnUPPoUPQ0
UP02246G00<8@YL8@iL9A9P00PU5V0082DJI2DNI2DRI2DVI2DVJ2DZJ2T^J
2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN2eNO
2eRO008;FIl010aJX0aKX0aLX0aMX@8<GZ4020aOX@aPXPaQXPeRXPeRX`eS
X`eTX`eUX`8=IZ@00`eWY0eXY@iYY@023VZU00<>JjH>K:H>KJH00Pi^Y`03
3VnW3W2W3g6X008?LZP020mcZ@mdZ@meZ@mfZ@mfZPmgZQ1hZQ1iZ`8@NZ/0
211kZa1l[11m[11n[11n[A5o[A60[A61[@8APZh00a63[Q64[a65[`024HJ_
00@BQk0BR;0BRK0BR[424X^a00PBS;4BSK8BS[8CSk8CSk<CT;<CTK<CT[<2
4i>d00<CU;@CUKDDU[D00QBG]@0359Rf59Vf59Zf008DVkL00aBL]aBM]aFN
^0025Inh00PEX;TEXKTEX[TEXkTEXkXEY;XFYKXFY[/25ZNk00PFZ;/FZK`F
Z[`FZk`FZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG/kl26;C000?8h=Q8
T8Q8T8P034R@R00300006;C06;C000:8`;P1B9280@00000000B8`;S8h=R8
`;R8`;P2002000^KYo7ooonXWLSoooncZM9PC9Z>N[IhIJjXWLSooooooOl0
0oooo`08<d>U002000200020oooo00:000>100B11oooo`080@Z30@^3oooo
0@b40@f40@j50Pn50Q250_ooo`0A0Q:60Q>60QB70QB70QF70QJ70aN80aR8
oooo0aV90aZ90a^90ab90ab:0af:11j:11n;008488/020@QR`@RS0@SS0@T
S0@TS@DUS@DVS@DWS@85:8h00`DYSPDZS`D[S`021Bb?00@6;I06;Y06;i06
<9421S6A00P6<Y46<i86=987=I87=I<7=Y<7=i<7>9<21cVD00<7>Y@7>iD8
?9D00PPmU@0323jF23nF242F0088@IL00`Q2U`Q3U`U4V0022DFH00P9AYT9
AiT9B9T9BIT9BIX9BYX:BiX:C9/22TfK00P:CY/:Ci`:D9`:DI`:DId;DYd;
Did;E9d22eFN00<;EYh;Eil;F9l00P]IW`0435ZP35^P35bP35fQ0PaNX@08
35nQ362R366R3F:R3F:S3F>S3FBS3FFS0PeVY0033FNT3FRU3VVU008>JZD0
0`i[YPi/YPi]YP023VjW00<>KjL>L:L?LJP00PmbZ0083g>Y3gBY3gFY3gJY
3gJZ3gNZ47RZ47V[0Q1jZ`0847^[47b/47f/47j/47j]4Gn]4H2]4H6]0Q62
[P034H>^4HB_4HF_008AQZl011:7/1:8/1:9/1::/@8BRk4021:</A:=/Q:>
/Q>?/Q>?/a>@/a>A/a>B/`8CTk@00a>D]1>E]ABF]@0259Ne00<DV;HDVKHD
V[H00QBK]`0359bg59fg5Ijh008EWkP021FP^AFQ^AFR^AFS^AFS^QFT^QJU
^QJV^`8FYk/021JX^aJY_1JZ_1J[_1J[_AN/_AN]_AN^_@8G[kh011N`_QNa
_aNb_aNc_`8H]<000lSPf8S0^8S0^00;R<2h00A8T8P0000H]<0H]<02R<2h
0DR@R04000000004R<2hb>3HR<2hR<2h0P00P00>VjOaoooooooofmc/H4bJ
ThFj/jWB_;SMH4bJVHnnYY_4b<?Ooooo<d>U1000P00B0060oooo00>1oooo
00B100F100J200N20@R20@R30@V30@Z30@^3oooo0@b40@f40@j50Pn50P8@
Q@03oooo0Q:60Q>6008258L05`8EQ`8FQ`<GR0<HR?ooo`<IR@<JR@<KR@<L
R@<LRP<MR_ooo`@ORoooo`@PRoooo`@RS0@SS0@TS0@TS@DUS@DVS@DWS@02
1BR>00<5:Hh5:Xl5:hl00PD/S`041Rf@1Rj@1Rn@1S2A0PHaT@081S:A1S>B
1SBB1cFB1cFC1cJC1cNC1cRC0PLiU0031cZD1c^E23bE0088?ID00`PnUPPo
UPQ0UP02246G00<8@YL8@iL9A9P00PU5V0082DJI2DNI2DRI2DVI2DVJ2DZJ
2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN
2eNO2eRO008;FIl010aJX0aKX0aLX0aMX@8<GZ4020aOX@aPXPaQXPeRXPeR
X`eSX`eTX`eUX`8=IZ@00`eWY0eXY@iYY@023VZU00<>JjH>K:H>KJH00Pi^
Y`033VnW3W2W3g6X008?LZP020mcZ@mdZ@meZ@mfZ@mfZPmgZQ1hZQ1iZ`8@
NZ/0211kZa1l[11m[11n[11n[A5o[A60[A61[@8APZh00a63[Q64[a65[`02
4HJ_00@BQk0BR;0BRK0BR[424X^a00PBS;4BSK8BS[8CSk8CSk<CT;<CTK<C
T[<24i>d00<CU;@CUKDDU[D00QBG]@0359Rf59Vf59Zf008DVkL00aBL]aBM
]aFN^0025Inh00PEX;TEXKTEX[TEXkTEXkXEY;XFYKXFY[/25ZNk00PFZ;/F
ZK`FZ[`FZk`FZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG/kl26;C000?8
h=R8`;R8`;P02hS0^004B92800006;C06;C00XS0^058T8P10000000018S0
^<SPf8S0^8S0^0<008003Y^WlOoookbhgIV?__ooomKAgM_Lk??nojJKa>k^
m8Ef/9>5^_oooc=3Y@<008000`01P002P?ooo`0200B11_ooo`070@Z30@^3
oooo0@b40@f40@j50Pn5008248D00oooo`8BQP8CQP020QB700d25HL25XL3
5hP368Soool36HT36XT36hT378T378X37HX47XX47h/00P@PR`08126;12:<
12><12B<12B=1BF=1BJ=1BN=0PDXSP031BV>1BZ?1B^?0085;8l010H]T0H^
T0H_T0H`T@86<I4020HbT@HcTPHdTPLeTPLeT`LfT`LgT`LhT`87>I@00`Lj
U0LkU@PlU@0223fE00<8?YH8?iH8@9H00PQ1U`0324:G24>G2DBH0089AIP0
20U6V@U7V@U8V@U9V@U9VPU:VPY;VPY<V`8:CI/020Y>V`Y?W0Y@W0YAW0YA
W@]BW@]CW@]DW@8;EIh00`]FWP]GW`]HW`022eVO00@<FZ0<Fj0<G:0<GJ42
35jQ00P<Gj4<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<23FJT00<=Ij@=J:D>JJD0
0PiZY@033V^V3VbV3VfV008>KZL00`i_Y`i`Y`maZ0023g:X00P?LjT?M:T?
MJT?MZT?MZX?MjX@N:X@NJ/247Z[00P@Nj/@O:`@OJ`@OZ`@OZdAOjdAP:dA
PJd24H:^00<APjhAQ:lAQJl00Q66[`044XN`4XR`4XV`4XZa0Q:;/@084Xba
4Xfb4Xjb4hnb4hnc4i2c4i6c4i:c0Q>C]0034iBd4iFe59Je008DUkD00aBH
]QBI]QBJ]P0259^g00<DW;LDWKLEW[P00QFO^0085J2i5J6i5J:i5J>i5J>j
5JBj5ZFj5ZJk0QJW^`085ZRk5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm0QN__P04
5k2n5k6o5k:o5k>o0QRd`004b>3HR<2hR<2hR<2h0P0000B8`;P200000XS0
^004B92800006;C06;C00XS0^058T8P10000000018S0^<SPf8S0^8S0^0<0
08003i^WlOoooiV?_YN:_=CCj>n//omfNnjOZe]HYJJKa9JOdV1<V[bhgOoo
oc=3Y@02002000<00H000X3oool00P04P@0=oooo00J200N2oooo0@R30@V3
0@Z30@^3oooo0@b40@f40@j50Pn5008248D00oooo`8BQP8CQP020QB700d2
5HL25XL35hP368Soool36HT36XT36hT378T378X37HX47XX47h/00P@PR`08
126;12:<12><12B<12B=1BF=1BJ=1BN=0PDXSP031BV>1BZ?1B^?0085;8l0
10H]T0H^T0H_T0H`T@86<I4020HbT@HcTPHdTPLeTPLeT`LfT`LgT`LhT`87
>I@00`LjU0LkU@PlU@0223fE00<8?YH8?iH8@9H00PQ1U`0324:G24>G2DBH
0089AIP020U6V@U7V@U8V@U9V@U9VPU:VPY;VPY<V`8:CI/020Y>V`Y?W0Y@
W0YAW0YAW@]BW@]CW@]DW@8;EIh00`]FWP]GW`]HW`022eVO00@<FZ0<Fj0<
G:0<GJ4235jQ00P<Gj4<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<23FJT00<=Ij@=
J:D>JJD00PiZY@033V^V3VbV3VfV008>KZL00`i_Y`i`Y`maZ0023g:X00P?
LjT?M:T?MJT?MZT?MZX?MjX@N:X@NJ/247Z[00P@Nj/@O:`@OJ`@OZ`@OZdA
OjdAP:dAPJd24H:^00<APjhAQ:lAQJl00Q66[`044XN`4XR`4XV`4XZa0Q:;
/@084Xba4Xfb4Xjb4hnb4hnc4i2c4i6c4i:c0Q>C]0034iBd4iFe59Je008D
UkD00aBH]QBI]QBJ]P0259^g00<DW;LDWKLEW[P00QFO^0085J2i5J6i5J:i
5J>i5J>j5JBj5ZFj5ZJk0QJW^`085ZRk5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm
0QN__P045k2n5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h00:8`;P200000XS0
^0800003R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2hb>3H
R<2hR<2h0P00P00:VjOaooooUhZlNVbZ/lOXZFjPb<?OThFjFdJCVHnn0WQU
[P04@RN5[jG:oooo<d>U0P00P003006000:0oooo00801846oooo00L12X<1
2h?oool138@13H@13XD23hD00P8@Q@04oooo0Q:60Q>60QB72oooo`030af:
11j:11n;008488/020@QR`@RS0@SS0@TS0@TS@DUS@DVS@DWS@85:8h00`DY
SPDZS`D[S`021Bb?00@6;I06;Y06;i06<9421S6A00P6<Y46<i86=987=I87
=I<7=Y<7=i<7>9<21cVD00<7>Y@7>iD8?9D00PPmU@0323jF23nF242F0088
@IL00`Q2U`Q3U`U4V0022DFH00P9AYT9AiT9B9T9BIT9BIX9BYX:BiX:C9/2
2TfK00P:CY/:Ci`:D9`:DI`:DId;DYd;Did;E9d22eFN00<;EYh;Eil;F9l0
0P]IW`0435ZP35^P35bP35fQ0PaNX@0835nQ362R366R3F:R3F:S3F>S3FBS
3FFS0PeVY0033FNT3FRU3VVU008>JZD00`i[YPi/YPi]YP023VjW00<>KjL>
L:L?LJP00PmbZ0083g>Y3gBY3gFY3gJY3gJZ3gNZ47RZ47V[0Q1jZ`0847^[
47b/47f/47j/47j]4Gn]4H2]4H6]0Q62[P034H>^4HB_4HF_008AQZl011:7
/1:8/1:9/1::/@8BRk4021:</A:=/Q:>/Q>?/Q>?/a>@/a>A/a>B/`8CTk@0
0a>D]1>E]ABF]@0259Ne00<DV;HDVKHDV[H00QBK]`0359bg59fg5Ijh008E
WkP021FP^AFQ^AFR^AFS^AFS^QFT^QJU^QJV^`8FYk/021JX^aJY_1JZ_1J[
_1J[_AN/_AN]_AN^_@8G[kh011N`_QNa_aNb_aNc_`8H]<000lSPf8S0^8S0
^003R<2h100000B8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@00000000B8
`;S8h=R8`;R8`;P2002000>KYo7oooooool00_ooo`0:ojf`ogIknLgDoNg^
ooooYY_4QGJ`_;SMoooo<d>U0`00P003006000:0oooo008018401oooo`06
PP07P_ooo`48P`49P`4:P`02oooo00@138@13H@13XD23hD20Q2501;oool2
4XH24hH258Ooool25HL25XL35hP368Soool36HT36XT36hT378Woool37HX4
7XX47h/2122;00P48H/48X`48h`498`498d59Hd59Xd59hd21BR>00<5:Hh5
:Xl5:hl00PD/S`041Rf@1Rj@1Rn@1S2A0PHaT@081S:A1S>B1SBB1cFB1cFC
1cJC1cNC1cRC0PLiU0031cZD1c^E23bE0088?ID00`PnUPPoUPQ0UP02246G
00<8@YL8@iL9A9P00PU5V0082DJI2DNI2DRI2DVI2DVJ2DZJ2T^J2TbK0PY=
V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN2eNO2eRO008;
FIl010aJX0aKX0aLX0aMX@8<GZ4020aOX@aPXPaQXPeRXPeRX`eSX`eTX`eU
X`8=IZ@00`eWY0eXY@iYY@023VZU00<>JjH>K:H>KJH00Pi^Y`033VnW3W2W
3g6X008?LZP020mcZ@mdZ@meZ@mfZ@mfZPmgZQ1hZQ1iZ`8@NZ/0211kZa1l
[11m[11n[11n[A5o[A60[A61[@8APZh00a63[Q64[a65[`024HJ_00@BQk0B
R;0BRK0BR[424X^a00PBS;4BSK8BS[8CSk8CSk<CT;<CTK<CT[<24i>d00<C
U;@CUKDDU[D00QBG]@0359Rf59Vf59Zf008DVkL00aBL]aBM]aFN^0025Inh
00PEX;TEXKTEX[TEXkTEXkXEY;XFYKXFY[/25ZNk00PFZ;/FZK`FZ[`FZk`F
ZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG/kl26;C000?8h=R8`;R8`;P0
18S0^0800005R<2h00A8T8P0000H]<0H]<02R<2h0DR@R04000000004R<2h
b>3HR<2hR<2h0`00P00:XJcbnLgDhRHlm;FohRHlm6emo>?YoooooNg^ojf`
0_ooo`03<d>U0020002000800803oooo0P04P@Koool01@4:P`4;Poooo`4<
Q04=Q007oooo00l258Ooool25HL25XL35hP368Soool36HT36XT36hT378Wo
ool37HX47XX47h/00P@PR`08126;12:<12><12B<12B=1BF=1BJ=1BN=0PDX
SP031BV>1BZ?1B^?0085;8l010H]T0H^T0H_T0H`T@86<I4020HbT@HcTPHd
TPLeTPLeT`LfT`LgT`LhT`87>I@00`LjU0LkU@PlU@0223fE00<8?YH8?iH8
@9H00PQ1U`0324:G24>G2DBH0089AIP020U6V@U7V@U8V@U9V@U9VPU:VPY;
VPY<V`8:CI/020Y>V`Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@8;EIh00`]FWP]G
W`]HW`022eVO00@<FZ0<Fj0<G:0<GJ4235jQ00P<Gj4<H:8<HJ8=HZ8=HZ<=
Hj<=I:<=IJ<23FJT00<=Ij@=J:D>JJD00PiZY@033V^V3VbV3VfV008>KZL0
0`i_Y`i`Y`maZ0023g:X00P?LjT?M:T?MJT?MZT?MZX?MjX@N:X@NJ/247Z[
00P@Nj/@O:`@OJ`@OZ`@OZdAOjdAP:dAPJd24H:^00<APjhAQ:lAQJl00Q66
[`044XN`4XR`4XV`4XZa0Q:;/@084Xba4Xfb4Xjb4hnb4hnc4i2c4i6c4i:c
0Q>C]0034iBd4iFe59Je008DUkD00aBH]QBI]QBJ]P0259^g00<DW;LDWKLE
W[P00QFO^0085J2i5J6i5J:i5J>i5J>j5JBj5ZFj5ZJk0QJW^`085ZRk5ZVl
5ZZl5Z^l5Z^m5jbm5jfm5jjm0QN__P045k2n5k6o5k:o5k>o0QRd`003b>3H
R<2hR<2h00>8`;P4000018S0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^08008003I^WlOg]k^8V??ken?N9UoARK_>P[_AR
K_omoon]/?cSjOoooc=3Y@05002000@00H000X000h401842oooo00`01X80
1h;oool128<12H<12X<12h<138Coool13H@13XD23hD20Q2501824HH24XH2
4hH258Ooool25HL25XL35hP368Soool36HT36XT36hT378Woool37HX47XX4
7h/2122;00P48H/48X`48h`498`498d59Hd59Xd59hd21BR>00<5:Hh5:Xl5
:hl00PD/S`041Rf@1Rj@1Rn@1S2A0PHaT@081S:A1S>B1SBB1cFB1cFC1cJC
1cNC1cRC0PLiU0031cZD1c^E23bE0088?ID00`PnUPPoUPQ0UP02246G00<8
@YL8@iL9A9P00PU5V0082DJI2DNI2DRI2DVI2DVJ2DZJ2T^J2TbK0PY=V`08
2TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN2eNO2eRO008;FIl0
10aJX0aKX0aLX0aMX@8<GZ4020aOX@aPXPaQXPeRXPeRX`eSX`eTX`eUX`8=
IZ@00`eWY0eXY@iYY@023VZU00<>JjH>K:H>KJH00Pi^Y`033VnW3W2W3g6X
008?LZP020mcZ@mdZ@meZ@mfZ@mfZPmgZQ1hZQ1iZ`8@NZ/0211kZa1l[11m
[11n[11n[A5o[A60[A61[@8APZh00a63[Q64[a65[`024HJ_00@BQk0BR;0B
RK0BR[424X^a00PBS;4BSK8BS[8CSk8CSk<CT;<CTK<CT[<24i>d00<CU;@C
UKDDU[D00QBG]@0359Rf59Vf59Zf008DVkL00aBL]aBM]aFN^0025Inh00PE
X;TEXKTEX[TEXkTEXkXEY;XFYKXFY[/25ZNk00PFZ;/FZK`FZ[`FZk`FZkdG
[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG/kl26;C000?8h=R8`;R8`;P00XS0
^0800002R<2h0P0000>8`;P014R@R00001Rd`1Rd`0:8`;P1B9280@000000
00B8`;S8h=R8`;R8`;P2002000>KYo7fb<cR9S`00_n]/007gb@^ojBNm[c5
ojf`kW^<oooo<d>U00H008000`01P002P003P@0200B11_ooo`070@Z3oooo
0@b40@b4oooo0@j50Pn5008248D0108AQP8BQP8CQP8DQ`_oool00`<MRP@N
RP@OR`02122;00P48H/48X`48h`498`498d59Hd59Xd59hd21BR>00<5:Hh5
:Xl5:hl00PD/S`041Rf@1Rj@1Rn@1S2A0PHaT@081S:A1S>B1SBB1cFB1cFC
1cJC1cNC1cRC0PLiU0031cZD1c^E23bE0088?ID00`PnUPPoUPQ0UP02246G
00<8@YL8@iL9A9P00PU5V0082DJI2DNI2DRI2DVI2DVJ2DZJ2T^J2TbK0PY=
V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN2eNO2eRO008;
FIl010aJX0aKX0aLX0aMX@8<GZ4020aOX@aPXPaQXPeRXPeRX`eSX`eTX`eU
X`8=IZ@00`eWY0eXY@iYY@023VZU00<>JjH>K:H>KJH00Pi^Y`033VnW3W2W
3g6X008?LZP020mcZ@mdZ@meZ@mfZ@mfZPmgZQ1hZQ1iZ`8@NZ/0211kZa1l
[11m[11n[11n[A5o[A60[A61[@8APZh00a63[Q64[a65[`024HJ_00@BQk0B
R;0BRK0BR[424X^a00PBS;4BSK8BS[8CSk8CSk<CT;<CTK<CT[<24i>d00<C
U;@CUKDDU[D00QBG]@0359Rf59Vf59Zf008DVkL00aBL]aBM]aFN^0025Inh
00PEX;TEXKTEX[TEXkTEXkXEY;XFYKXFY[/25ZNk00PFZ;/FZK`FZ[`FZk`F
ZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG/kl26;C000C8h=R8`;R8`;R8
`;P2000018S0^0800002R<2h00A8T8P0000H]<0H]<02R<2h0DR@R0400000
0004R<2hb>3HR<2hR<2h0P00P003VjOanLgDmhVG00;oool01on]/>4F=?mf
NonTW^8V??n9Oc=3Y@06002000<00H000X3oool00P04P@0<oooo00J200N2
oooo0@R30@V30@Z30@^3oooo0@b40@f40@j51Oooo`0@0Q>60QB70QB70QF7
0QJ70aN80aR8oooo0aV90aZ90a^90ab90ab:0af:11j:11n;0P@PR`08126;
12:<12><12B<12B=1BF=1BJ=1BN=0PDXSP031BV>1BZ?1B^?0085;8l010H]
T0H^T0H_T0H`T@86<I4020HbT@HcTPHdTPLeTPLeT`LfT`LgT`LhT`87>I@0
0`LjU0LkU@PlU@0223fE00<8?YH8?iH8@9H00PQ1U`0324:G24>G2DBH0089
AIP020U6V@U7V@U8V@U9V@U9VPU:VPY;VPY<V`8:CI/020Y>V`Y?W0Y@W0YA
W0YAW@]BW@]CW@]DW@8;EIh00`]FWP]GW`]HW`022eVO00@<FZ0<Fj0<G:0<
GJ4235jQ00P<Gj4<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<23FJT00<=Ij@=J:D>
JJD00PiZY@033V^V3VbV3VfV008>KZL00`i_Y`i`Y`maZ0023g:X00P?LjT?
M:T?MJT?MZT?MZX?MjX@N:X@NJ/247Z[00P@Nj/@O:`@OJ`@OZ`@OZdAOjdA
P:dAPJd24H:^00<APjhAQ:lAQJl00Q66[`044XN`4XR`4XV`4XZa0Q:;/@08
4Xba4Xfb4Xjb4hnb4hnc4i2c4i6c4i:c0Q>C]0034iBd4iFe59Je008DUkD0
0aBH]QBI]QBJ]P0259^g00<DW;LDWKLEW[P00QFO^0085J2i5J6i5J:i5J>i
5J>j5JBj5ZFj5ZJk0QJW^`085ZRk5ZVl5ZZl5Z^l5Z^m5jbm5jfm5jjm0QN_
_P045k2n5k6o5k:o5k>o0QRd`003b>3HR<2hR<2h00^8`;P014R@R00001Rd
`1Rd`0:8`;P1B9280@00000000B8`;S8h=R8`;R8`;P2002000NKYo7ooooc
X:kdHVkoooogRIOicM@00_ooo`03lj2^oooo<d>U00H008000`01P?ooo`03
P@0200B100d01H7oool01h8128;oool12H<12X<12h<138Coool13H@13XD2
3hD00P8@Q@030Q660Q:60Q>6008258L03@8EQ`8FQ`<GR0<HR?ooo`<IR@<J
R@<KR@<LR@<LRP<MRP@NRP@OR`02122;00P48H/48X`48h`498`498d59Hd5
9Xd59hd21BR>00<5:Hh5:Xl5:hl00PD/S`041Rf@1Rj@1Rn@1S2A0PHaT@08
1S:A1S>B1SBB1cFB1cFC1cJC1cNC1cRC0PLiU0031cZD1c^E23bE0088?ID0
0`PnUPPoUPQ0UP02246G00<8@YL8@iL9A9P00PU5V0082DJI2DNI2DRI2DVI
2DVJ2DZJ2T^J2TbK0PY=V`082TjK2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]E
WP032eJN2eNO2eRO008;FIl010aJX0aKX0aLX0aMX@8<GZ4020aOX@aPXPaQ
XPeRXPeRX`eSX`eTX`eUX`8=IZ@00`eWY0eXY@iYY@023VZU00<>JjH>K:H>
KJH00Pi^Y`033VnW3W2W3g6X008?LZP020mcZ@mdZ@meZ@mfZ@mfZPmgZQ1h
ZQ1iZ`8@NZ/0211kZa1l[11m[11n[11n[A5o[A60[A61[@8APZh00a63[Q64
[a65[`024HJ_00@BQk0BR;0BRK0BR[424X^a00PBS;4BSK8BS[8CSk8CSk<C
T;<CTK<CT[<24i>d00<CU;@CUKDDU[D00QBG]@0359Rf59Vf59Zf008DVkL0
0aBL]aBM]aFN^0025Inh00PEX;TEXKTEX[TEXkTEXkXEY;XFYKXFY[/25ZNk
00PFZ;/FZK`FZ[`FZk`FZkdG[;dG[KdG[[d25jnn00@G/;hG/KlG/[lG/kl2
6;C000?8h=R8`;R8`;P02hS0^004B92800006;C06;C00XS0^058T8P10000
000018S0^<SPf8S0^8S0^0<008002i^WlOoooon9Oooooo>P[_6CXOooooom
oo>P[_oko3=3Y@06002000<00H000X000h400P04P@0800F100J200N20@R2
0@R30@V30@Z30@^30P4<Q0030@f40@j50Pn5008248D00`8AQP8BQP8CQP02
0QB700<25HL25XL35hP00P<HR0080aV90aZ90a^90ab90ab:0af:11j:11n;
0P@PR`08126;12:<12><12B<12B=1BF=1BJ=1BN=0PDXSP031BV>1BZ?1B^?
0085;8l010H]T0H^T0H_T0H`T@86<I4020HbT@HcTPHdTPLeTPLeT`LfT`Lg
T`LhT`87>I@00`LjU0LkU@PlU@0223fE00<8?YH8?iH8@9H00PQ1U`0324:G
24>G2DBH0089AIP020U6V@U7V@U8V@U9V@U9VPU:VPY;VPY<V`8:CI/020Y>
V`Y?W0Y@W0YAW0YAW@]BW@]CW@]DW@8;EIh00`]FWP]GW`]HW`022eVO00@<
FZ0<Fj0<G:0<GJ4235jQ00P<Gj4<H:8<HJ8=HZ8=HZ<=Hj<=I:<=IJ<23FJT
00<=Ij@=J:D>JJD00PiZY@033V^V3VbV3VfV008>KZL00`i_Y`i`Y`maZ002
3g:X00P?LjT?M:T?MJT?MZT?MZX?MjX@N:X@NJ/247Z[00P@Nj/@O:`@OJ`@
OZ`@OZdAOjdAP:dAPJd24H:^00<APjhAQ:lAQJl00Q66[`044XN`4XR`4XV`
4XZa0Q:;/@084Xba4Xfb4Xjb4hnb4hnc4i2c4i6c4i:c0Q>C]0034iBd4iFe
59Je008DUkD00aBH]QBI]QBJ]P0259^g00<DW;LDWKLEW[P00QFO^0085J2i
5J6i5J:i5J>i5J>j5JBj5ZFj5ZJk0QJW^`085ZRk5ZVl5ZZl5Z^l5Z^m5jbm
5jfm5jjm0QN__P045k2n5k6o5k:o5k>o0QRd`0o8h=P00`0001Rd`1Rd`002
R<2h0DR@R04000000004R<2hb>3HR<2hR<2h1000P0>KYo401_oooo>P[_Be
_oJlaO_IfS=3Y@L008000`01P002P003P@0200B100P01H401X801h812881
28<12H<12X<12h<20@b400<13H@13XD23hD00P8@Q@030Q660Q:60Q>60082
58L00`8EQ`8FQ`<GR0020aR800P36HT36XT36hT378T378X37HX47XX47h/2
122;00P48H/48X`48h`498`498d59Hd59Xd59hd21BR>00<5:Hh5:Xl5:hl0
0PD/S`041Rf@1Rj@1Rn@1S2A0PHaT@081S:A1S>B1SBB1cFB1cFC1cJC1cNC
1cRC0PLiU0031cZD1c^E23bE0088?ID00`PnUPPoUPQ0UP02246G00<8@YL8
@iL9A9P00PU5V0082DJI2DNI2DRI2DVI2DVJ2DZJ2T^J2TbK0PY=V`082TjK
2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN2eNO2eRO008;FIl010aJ
X0aKX0aLX0aMX@8<GZ4020aOX@aPXPaQXPeRXPeRX`eSX`eTX`eUX`8=IZ@0
0`eWY0eXY@iYY@023VZU00<>JjH>K:H>KJH00Pi^Y`033VnW3W2W3g6X008?
LZP020mcZ@mdZ@meZ@mfZ@mfZPmgZQ1hZQ1iZ`8@NZ/0211kZa1l[11m[11n
[11n[A5o[A60[A61[@8APZh00a63[Q64[a65[`024HJ_00@BQk0BR;0BRK0B
R[424X^a00PBS;4BSK8BS[8CSk8CSk<CT;<CTK<CT[<24i>d00<CU;@CUKDD
U[D00QBG]@0359Rf59Vf59Zf008DVkL00aBL]aBM]aFN^0025Inh00PEX;TE
XKTEX[TEXkTEXkXEY;XFYKXFY[/25ZNk00PFZ;/FZK`FZ[`FZk`FZkdG[;dG
[KdG[[d25jnn00@G/;hG/KlG/[lG/klD6;C00XS0^058T8P10000000018S0
^<SPf8S0^8S0^1@008000`01P002P003P@0200B100P01H401X801h812881
28<12H<12X<12h<20@b400<13H@13XD23hD00P8@Q@030Q660Q:60Q>60082
58L00`8EQ`8FQ`<GR0020aR800P36HT36XT36hT378T378X37HX47XX47h/2
122;00P48H/48X`48h`498`498d59Hd59Xd59hd21BR>00<5:Hh5:Xl5:hl0
0PD/S`041Rf@1Rj@1Rn@1S2A0PHaT@081S:A1S>B1SBB1cFB1cFC1cJC1cNC
1cRC0PLiU0031cZD1c^E23bE0088?ID00`PnUPPoUPQ0UP02246G00<8@YL8
@iL9A9P00PU5V0082DJI2DNI2DRI2DVI2DVJ2DZJ2T^J2TbK0PY=V`082TjK
2TnL2U2L2U6L2U6M2e:M2e>M2eBM0P]EWP032eJN2eNO2eRO008;FIl010aJ
X0aKX0aLX0aMX@8<GZ4020aOX@aPXPaQXPeRXPeRX`eSX`eTX`eUX`8=IZ@0
0`eWY0eXY@iYY@023VZU00<>JjH>K:H>KJH00Pi^Y`033VnW3W2W3g6X008?
LZP020mcZ@mdZ@meZ@mfZ@mfZPmgZQ1hZQ1iZ`8@NZ/0211kZa1l[11m[11n
[11n[A5o[A60[A61[@8APZh00a63[Q64[a65[`024HJ_00@BQk0BR;0BRK0B
R[424X^a00PBS;4BSK8BS[8CSk8CSk<CT;<CTK<CT[<24i>d00<CU;@CUKDD
U[D00QBG]@0359Rf59Vf59Zf008DVkL00aBL]aBM]aFN^0025Inh00PEX;TE
XKTEX[TEXkTEXkXEY;XFYKXFY[/25ZNk00PFZ;/FZK`FZ[`FZk`FZkdG[;dG
[KdG[[d25jnn00@G/;hG/KlG/[lG/klD6;C00XS0^058T8P1000000000hS0
^<SPf8S0^03oR<2h2XS0^058T8P1000000000hS0^<SPf8S0^03oR<2h2XS0
^058T8P1000000000hS0^<SPf<SPf03ob>3H2/SPf058T8P10000003oR<2h
3XS0^04000000001\
\>"], "Graphics",
  ImageSize->{270, 117},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000460000S2000`400?l00000o`00003oooo`l?07
oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07
oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07
oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooo`l?07oo3`l000ooooool7
ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7
onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00Z_o^k^h2ong]k@0:on_[jooX
j>SoiNGUon;Rh_oMgMgof=SHomCDe?oAdM7oc/k>olc<c0;obl_;=Oo:b/X2ol_;b`0:olc<c?o>c/ko
dM7AomCDe?oHf=SogMgMon;Rh_oUiNGoj>SXon_[j`;okNg]2oo^k^h00:Woi^KV0_oUiND02_oRh^;o
h>3Pom_KfooFe]Koc/k>olO7aono_koo^;RhokBd]?n`/;02ojj^[P;o[Jf]<on/[:`2ojf][@;o[Zj^
00[o/;2`okBd]?nh^;So_knoolO7aoo>c/koe]KFom_KfooPh>3oh^;R0_oUiND:onKViP00ZOo^k^h0
3_o]kNgoj^[ZonOWiooRh^;ofMWIolk>c_o3`l?o^;Rhojj^[_nVYZKoX:2PoibLW?nIVIWoV9RH=onG
UiL03OnHV9SoVIVIoibLW?nPX:3oYZJVojj^[_nh^;So`l?3olk>c_oIfMWoh^;RonOWiooZj^X00_o]
kNd9onk^kP00ZOooool03_olo?conOWioo;bl_oXj>Sof][Jol_;bonj^[[o[:b/oinOWonEUIGoSXj>
ohZ:R_n7QhOoQXJ6=on5QHD03on6QXKoQhN7ohZ:R_n>SXkoUIFEoinOWon/[:co^[Zjol_;booJf][o
j>SXoo;bl_oinOWoo?clooknoP09ooooo`00ZOo^k^h05?oXj>Soh^;RomWIfOo:b/[o^[ZjojRXZ?nH
V9SoTY:BojFUYOo0`<3oemOGon_[joofm_KomoOgooWinOohn?SonOWioo[jn_oinOWomoOg0oohn?P2
ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03ooShn0;onOWi00?on_[j
ooWinOogmoL00oohn?P2ooWin@03oo[jn_oinOWomoOg00?on?Sh0_oinOT00oojn_[onOWiooOgm`03
ooShn0;onOWi01?on_[jooWinOohn?SonOWiooShn?ogmoOokNg]omSHf?o1`L7oYJFUoi:BT_nHV9So
Z:RXokZj^_o:b/[ofMWIon;Rh_oXj>Sok>c/00Wok^k^002YonKViP0<omgMgOoFe]KoalO7okNg]onS
Xj?oTI6Aoj:RX_o;bl_ok^k^ooKfm_olo?coo_kn>oooool03Oono_koo?clooOgmoo_knooc<c<oj>S
XonATI7oXj>SokNg]oo7alOoe]KFomgMgOoRh^802OoVi^H00:Wok^k^00[oh^;RomKFe_o3`l?o[Zj^
oiZJV_n][Jgog]kNon_[joodm?Cono_k?oooool02ookno_olo?conc/k?oQhN7o/;2`oiZJV_n^[Zko
`l?3omKFe_oRh^;oj>SX00Wok^k^002Yooooo`0:ong]kOoLg=coaLG5ojb/[?n][Jgoe=CDon3Ph?o/
k>comOGeoogmoCoooooo00_oo_knooKfm_o/k>coh^;RomWIfOna/K7o[:b/olG5aOoLg=cokNg]ooKf
mP09ooooo`00ZOo^k^h02ooHf=Soa/K6ojj^[_nSXj?oa/K6omCDe?oPh>3ok>c/oo;bl_olo?coo_kn
00gooooo00?ohn?SomKFe_ono_h01?ooool00oo/k>cooOgmooooo`02ooCdm0_ooooo00?okNg]ono_
koooool01?ooool00oodm?Coj>SXooooo`0@ooooo`0;oo[jn_odm?Coj^[Zon?ShooGemOocLg=ojJV
Y_n^[Zkoa/K6omSHf?oRh^802Oo^k^h00:Woi^KV00oocLg=okVi^OnQXJ7oZj^[olK6a_oBd];og=cL
onKVi_o/k>comOGeooShn?ojn_[ooOgmooooooolo?`01oooool05OnNWYko4Q8Bo`T92OlW9bOo6a/K
oda<C?oIfMWooooooe5ADOl71`Oo6QXJoibLW?lC4a?oEeMGoooooom0@43oOgmooogmoOooooooXj>S
oa`L7002ooooo`0@onGUiOm0@43o0000oa8B4_lM7Agon?ShoooooooWinOoBTY:o`<30olR8R;o5aLG
ol71`Ooooooo@410ogmoO`;ooooo00?ooOgmooooooooool00_ooool04?omoOgooooooogmoOokno_o
n?ShooCdm?o]kNgoi^KVomoOgooFe]Koc<c<ok6a/OnRXZ;o^KViolg=cOoKfm/9onKViP00ZOo^k^h0
4ooAdM7o^k^koj6QXOnf][Ko`l?3olo?cooFe]KogmoOonKVi_oZj^[okno_oo?cloodm?ComOGeooOg
moofm_KomoOgooKfm_ohn?P00_ogmoL01?nBTY;o0P82ohJ6Q_odm?@2ooKfmP08ojb/[?oAdM7o_kno
o`<30ooFe]Kog]kNoeMGEol@4102ooOgm`06ocdm?OmjNW[omoOgooOgmonMWIgo6a/K0_ogmoL04?lo
?coo:RXZolC4a?ogmoOod=3@ooKfm_ogmoOo@D51ocdm?OoGemOomoOgon_[jooYjNWon?Shocdm?Omk
Ng/2ooKfmP;omoOg01?om_KfooShn?ofm_KomoOgooKfm_odm?Col_;boo3`l?o[jn_oi^KVon7QhOoJ
f][odm?ColW9bOno_kooYZJVok^k^ooAdM7ohN7Q00Wok^k^002Yooooo`0;omoOgoo5aLGoY:BTok>c
/oo0`<3obLW9om?CdooIfMWogMgMon;Rh_oUiND00_oZj^X00oo/k>cokNg]ong]k@04onk^kP04onOW
iolB4Q;oG5aLoo3`l0Gok^k^00Kob/[:o`820_na/K7ok^k^oiBDU?lM7Ad2onk^kP0;oc/k>omfMWKo
l?3`onk^k_nHV9So6QXJonk^k_o=cLgo0000oh^;Roo`l?000oo^k^h01Oo>c/ko0000oj^[Zoo^k^ko
l?3`00?ok^k^00Go>c/kogIfM_o^k^kok^k^oo3`l003onk^kP;okNg]0_o/k>`03OoYjNWoi^KVon?S
hooPh>3ofm_KomGEeOo=cLgoaLG5ok^k^on[Zj_oaLG5omoOgoo`l?002Oooool00:Wok^k^00god=3@
okRh^?nLW9co[:b/ok^k^oo6a/KocLg=om?CdooGemOofm_KomoOgooQhN7oh^;R00;ohn?S1OoUiND0
1?nn_[ko0000ojj^[_oVi^H6onGUi@05oibLW?l];Bgo;Bd]oc0`<?lL71`00_oUiND02oli>CWoLW9b
onKVi_oUiNGoTY:BoaTI6OoUiNGoZZZZo`000?ni^KWoi^KV00?oiNGU00?oZZZZo`000?lf=SH00olh
>3P01On`/;3oiNGUocTi>OmbLW;oiNGU00;oi^KV0ooUiND2onCTi0;ohn?S00goh^;Ron3Ph?oLg=co
fMWIomKFe_o@d=3obLW9ol71`One]KGoYJFUokRh^?o@d=3oh>3P00Wok^k^002YonKViP0=ol[:b_ne
]KGoU9BDojNWYonf][Ko`<30olK6a_o<c<codM7AomCDe?oGemOof][Jom_Kf`03omcLg0;og]kN0_oM
gMd01?nKVi_o0000ol?3`ooMgMd2omkNgP?ogMgM00Kog]kNomgMgOoMgMgog=cLoh20P?lL71`2omgM
g@0;ocLg=om@D53ogMgMomkNg_n8R8So6ATIomgMgOnm_Kgo0000ogemOOoMgMd00_oNg]h03?oMgMgo
_Kfmo`000?nDU9Co/k>cojb/[?l20P;oalO7omgMgOlg=cOoKVi^omkNgP;ogMgM0_oNg]h2omgMg@;o
g=cL00kofm_Kom[Jf_oHf=Soe]KFom;Bd_o@d=3ob/[:olG5aOnm_Kgo/;2`oj2PX?ne]KGob/[:omWI
f@Woi^KV002Yonk^kP0=omCDe?no_kooS8b<oijNW_n][Jgo^KViol;2`_o7alOoc<c<om3@d?oBd];o
eMGEomKFeP02omOGe`03omSHf?oIfMWofMWI00;ofMWI00?oZJVYo`000?nb/[801ooIfMT01OnIVIWo
^KViomKFe_mBDU;oAdM700;ofMWI00Ko=SHfoa4A4OmTI6Co_;blodY:B_m1@D42omWIf@05ocDe=OlQ
8B7oXJ6QomSHf?nl_;`00_oIfMT01Ole=CGoFe]Kom;Bd_n6QXKo92@T00;ofMWI00?o=SHfofa/K?oI
fMT01OoIfMT2omSHf0;oemOG00goeMGEom?Cdoo@d=3oc/k>ol[:b_o5aLGo_knookFe]OnYZJWoV9RH
okno_ooDe=Coh^;R00Wok^k^002Yooooo`0=onSXj?oDe=CoS8b<oi>CTonRXZ;o[jn_okZj^_o1`L7o
alO7ol_;boo>c/kod=3@om7Ad@02om?Cd`?oe=CD0_oEeMD01?o6a/Ko0@41oh>3PooEeM@2omCDe0;o
eMGE01Koe]KFomGEeOmcLg?o:BTYo`d=3Ol_;booXj>SomGEeOoFe]KoATI6ogEeMOmUIFCo410@obHV
9_nSXj?oeMGEomKFe_o1`L7oBDU9o``<3?l92@Wo7alO0_oEeMD03?o1`L7o>c/ko`X:2_lG5aOoV9RH
omCDe?oEeMGo=CDeofYZJ_oEeMGoe]KFomGEe0;oe=CD0_oEeMD04?oDe=Codm?Com?CdooAdM7od=3@
olg=cOo:b/[o`l?3okjn__nf][KoZj^[oifMWOnEUIGoe=CDonSXj?oclo<9ooooo`00ZOo^k^h04_oM
gMgocLg=oi2@T?n9RHWoUiNGojFUYOnb/[;o_knool_;booAdM7oeMGEomOGeooIfMWof][Jom_KfooJ
f][ofm_KomcLg0?ofm_K00GoEEEEoalO7oo;bl_ofm_KomcLg006om_Kf`03omWIfOoLg=cofm_K00Go
fm_K00?of][JomcLg?oKfm/01OoKfm/00ooHf=Sog=cLom_Kf`03om_Kf`07omSHf?oKfm_ofm_KomcL
g?oKfm_o=SHfofe]K@04om_Kf`0ComcLg?oKfm_ofm_Kom_KfooJf][ofMWIomSHf?oFe]Kodm?Colg=
cOo2`/;o][Jfojb/[?nOWiooT92@oiJFU_o=cLgogMgMonGUi@09onk^kP00ZOoVi^H02ooJf][oc/k>
oibLW?mjNW[oR8R8oiJFU_nZZZ[oa<C4omGEeOoKfm_og]kN00;oh>3P0ooRh^800ooTi>Cohn?Son?S
h`02on?Sh`08om7AdOli>CWo6QXJofe]KOn6QXKoIfMWobXZ:_nYZJT3on?Sh`03onCTi?oShn?ohn?S
00Gohn?S00?oi>CTon?ShooShn<01OoShn<00ooTi>Cohn?Son?Sh`05on?Sh`05onCTi?oShn?ohn?S
ocPh>?maLG400ooShn<01?oTi>Cohn?Son?ShooShn<2on;RhP0>on7QhOoPh>3ogmoOomcLg?oGemOo
aLG5ojb/[?nNWYkoT92@oh:2P_nPX:3oc/k>om[Jf_oPh>09onKViP00ZOo^k^h03_oUiNGogMgMol;2
`_mkNg_oN7QhohJ6Q_nOWiooaLG5omSHf?oMgMgogmoOon7QhOoRh^;ohn?S0ooTi>@4onGUi@08onCT
i?oShn?oWinOog9bL_mNGUkoNg]koi^KVooGemL2onCTi003onGUiOoTi>CoiNGU00?oiNGU0_oTi>@0
0ooUiNGoi>CTonGUi@03onGUi@;oi>CT00?oiNGUonCTi?oUiND00ooUiND2onCTi006onGUiOoTi>Co
iNGUonGUiOli>CWoLW9b0_oTi>@01?oUiNGoi>CTonGUiOoUiND3onCTi00>on?ShooQhN7oh>3PomoO
gooJf][oa/K6oj6QXOn=SHgoP820ohB4Q?o3`l?ogMgMonGUiOoZj^X9onk^kP00ZOooool02ooinOWo
lo?conWYjOnXZ:SoIFEUog=cLon=SHgo^k^komCDe?oJf][ogMgM00;ogmoO00?oh>3Pon7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00GohN7Q00?oh^;Ron7QhOoQhN40
1OoQhN400ooRh^;ohN7Qon7Qh@05on7Qh@03on;Rh_oQhN7ohN7Q00?ohN7Q00?ogMgMomoOgooRh^80
2?oQhN403_oPh>3ogmoOomgMgOoLg=coeMGEokVi^On>SXkoNg]kofi^K_n[Zj_ojNWYoo?clooinOWo
oOgm2Oooool00:Wok^k^00cojn_[onSXj?oRh^;oemOGohf=SOmRHV;oMWIfojBTY?o7alOod];BomGE
eOoHf=P2om[JfP?ofm_K1ooLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
00?ofm_KomcLg?oLg=`01OoLg=`00ooKfm_og=cLomcLg005omcLg003om_KfooLg=cog=cL00Gog=cL
01Cofm_KomcLg?oLg=cofm_KomcLg?oKfm_of][JomWIfOoHf=Sodm?ColG5aOnLW9coMGEeofMWIon@
T93oemOGon;Rh_oXj>Sojn_[ong]k@Wok^k^002YonKViP0>onGUiOoRh^;ogmoOom[Jf_o9bLWoQhN7
oeYJF_mkNg_oXj>Sokbl_?o6a/Kobl_;olg=cOo?cll2om7Ad@God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00God];B00?odM7Aom;Bd_oAdM401OoB
d]800ooAdM7od];Bom7Ad@05om;BdP03om7AdOoBd];odM7A00?od];B0_oAdM403Oo@d=3oclo?olc<
c?o8b<So^k^koibLW?mbLW;oFe]KohZ:R_o9bLWof][JomoOgooRh^800_oUiND9onKViP00ZOo^k^h2
ong]k@0>on[Zj_oXj>Soh^;RomcLg?nLW9coKFe]ofQXJ?n3Ph?oUiNGoj>SXon/[:co[jn_ok6a/Onb
/[82okBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2okJf]P;o];Bd00Co]KFeokJf]?nd];Co
];Bd0_nf][H2okBd]004okFe]Onf][Co];BdokBd]0;o][Jf0_nd];@01?ne]KGo][JdokBd]?nd];@2
okJf]P;o];Bd00Co]KFeokJf]?nd];Co];Bd0_nf][H2okBd]00CokFe]Onf][Co];BdokBd]?nf][Ko
/k>cok:b/_nc/k?o[jn_ojZZZ_nLW9coPX:2of9RH_m^KVkoWinOomcLg?oRh^;oj>SXon[ZjP02ong]
k@[ok^k^002Zooooo`;oo_kn00ooo?clooWinOofm_Kol_;bomWIfOnXZ:SoPh>3ofi^K_mUIFGoJFUY
og9bL_mdM7CoNGUiogalO?mkNg/00_mmOGd01_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00Ko
O7alog]kNomlO7coOGelogalO?mkNg/2ogemO@06ogalO?mkNg_oO7alogemO?mlO7coNg]k0_mmOGd0
1_mlO7coNg]kogalO?mmOGcoO7alog]kN`;oOGem00KoO7alog]kNomlO7coOGelogalO?mkNg/2ogem
O@07ogalO?mkNg_oO7alogemO?mlO7coNg]kogemO@02ogYjNP0;ogMgMomdM7CoKfm_ogAdM?n5QHGo
Z:RXom[Jf_obl_;om_KfooWinOolo?`00_ono_h;ooooo`00Zoo^k^h2ong]k@04onc/k?oZj^[oj>SX
onGUi@;oh^;R00?oh>3PomoOgooNg]h0>OoMgMd00ooNg]kogmoOon3Ph002on;RhP04onGUiOoXj>So
j^[Zonc/k0;okNg]3?o^k^h00:goi^KV0_oUiND00ooTi>Coh^;Ron;RhP02on3Ph0;ogmoO>OoNg]h2
omoOg`;oh>3P0_oRh^800ooTi>CoiNGUonGUi@0>onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00
ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00
oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00
ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00
ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP009Oo^k^h00oo/k>coj>SXon[ZjP0Vonk^
kP03onWYjOoOgmoof][J0:Wof][J00?ogmoOonWYjOo^k^h02Oo^k^h002Cooooo00Gono_kon_[joo;
bl_oinOWooknoP0Uooooo`03ono_koo@d=3o`<300:Wo`<3000?od=3@ono_koooool02Oooool0023o
k^k^0oo]kNd01_oVi^Koc/k>oiNGUon?Shoo][Jfong]kBGok^k^06koL;goofbjoomb__ooN<Cooh;:
oon8c_ooPL[oogS3oom`_OooK;[oog:noomha?ooP/[oohS>oon1b_ooN<?oog2moom/^_ooL[koogS4
oon2b_ooR<kooh7:oomh`oooL;goofbjoomb__ooN<Cooh;:oon8c_ooPL[oogS3oom`_OooK;[oog:n
oomha?ooP/[oohS>oon1b_ooN<?oog2moom/^_ooL[koogS4oon2b_ooR<kooh7:oomh`oooL;goofbj
oomb__ooN<Cooh;:oon8c_ooPL[oogS3oom`_OooK;[oog:noomha?ooP/[oohS>oon1b_ooN<?oog2m
oom/^_ooL[koogS4oon2b_ooR<kooh7:oomh`oooL;goofbjoomb__ooN<Cooh;:oon8c_ooPL[oogS3
oom`_OooK;[oog:noomha?ooP/[oohS>oon1b_ooN<?oog2moom/^_ooL[koogS4oon2b_ooR<kooh7:
oomh`oooL;goofbjoomb__ooN<Cooh;:oon8c_ooPL[oogS3oom`_OooK;[oog:noomha?ooP/[oohS>
ocoog]kN00?of][Jonk^k_o^k^h02?o^k^h001_oi^KV00koiNGUon?ShooPh>3ogMgMom[Jf_oGemOo
e]KFom?Cdond];CoQ8B4okno_oo7alOoZJVYonGUiBGoi^KV06koK/3oofVnoom]`?ooM/Koogo=oon6
d_ooO/googK5oom^`?ooJKkoofg0oomfa_ooOlgoohKBoomncOooM/Goofk0oomY__ooKL3oogK6oomo
cOooQ];oogk=oomfaOooK/3oofVnoom]`?ooM/Koogo=oon6d_ooO/googK5oom^`?ooJKkoofg0oomf
a_ooOlgoohKBoomncOooM/Goofk0oomY__ooKL3oogK6oomocOooQ];oogk=oomfaOooK/3oofVnoom]
`?ooM/Koogo=oon6d_ooO/googK5oom^`?ooJKkoofg0oomfa_ooOlgoohKBoomncOooM/Goofk0oomY
__ooKL3oogK6oomocOooQ];oogk=oomfaOooK/3oofVnoom]`?ooM/Koogo=oon6d_ooO/googK5oom^
`?ooJKkoofg0oomfa_ooOlgoohKBoomncOooM/Goofk0oomY__ooKL3oogK6oomocOooQ];oogk=oomf
aOooK/3oofVnoom]`?ooM/Koogo=oon6d_ooO/googK5oom^`?ooJKkoofg0oomfa_ooOlgoohKBocoo
n_[j00?odm?ConKVi_oVi^H02?oVi^H001Wok^k^017okNg]onWYjOoPh>3od];Bol30`?n][JgoWinO
oiRHV?nEUIGoT92@ohb<S?oShn?ol?3`ol[:b_nZZZ[oj>SXong]k@0Tonk^kP1^of2aoomH[?ooG[3o
ofJfoom^_?ooMl;oog2noomW^?ooH;7ooeR/oomN/?ooI[Koofjloomg`_ooL;koofNhoomP/OooF:co
oej`oomV]_ooK[coogO2oom`__ooIkSoof2aoomH[?ooG[3oofJfoom^_?ooMl;oog2noomW^?ooH;7o
oeR/oomN/?ooI[Koofjloomg`_ooL;koofNhoomP/OooF:cooej`oomV]_ooK[coogO2oom`__ooIkSo
of2aoomH[?ooG[3oofJfoom^_?ooMl;oog2noomW^?ooH;7ooeR/oomN/?ooI[Koofjloomg`_ooL;ko
ofNhoomP/OooF:cooej`oomV]_ooK[coogO2oom`__ooIkSoof2aoomH[?ooG[3oofJfoom^_?ooMl;o
og2noomW^?ooH;7ooeR/oomN/?ooI[Koofjloomg`_ooL;koofNhoomP/OooF:cooej`oomV]_ooK[co
ogO2oom`__ooIkSoof2aoomH[?ooG[3oofJfoom^_?ooMl;oog2noomW^?ooH;7ooeR/oomN/?ooI[Ko
ofjloomg`_loooGem@03om[Jf_o^k^kok^k^00Sok^k^000Hooooo`0<oo_knoo^k^kodM7AojZZZ_n?
ShooUIFEojf][Oo6a/Kod=3@om;Bd_oGemOomOGe0_o]kNd01OoLg=coTY:Bom?Cdoo/k>cono_k02?o
oooo06koBi_hodJGm_m>WOOoE:;ioe^XnomT[_goGJWloeFSn_m;VoSoAYOfodjMmomDX_WoFjSkofB^
oOmMZOcoEJ?jod^Kn?m6UoKoCYggoeBRnOmKZ?_oI:kmoefYo?mEXo[oBi_hodJGm_m>WOOoE:;ioe^X
nomT[_goGJWloeFSn_m;VoSoAYOfodjMmomDX_WoFjSkofB^oOmMZOcoEJ?jod^Kn?m6UoKoCYggoeBR
nOmKZ?_oI:kmoefYo?mEXo[oBi_hodJGm_m>WOOoE:;ioe^XnomT[_goGJWloeFSn_m;VoSoAYOfodjM
momDX_WoFjSkofB^oOmMZOcoEJ?jod^Kn?m6UoKoCYggoeBRnOmKZ?_oI:kmoefYo?mEXo[oBi_hodJG
m_m>WOOoE:;ioe^XnomT[_goGJWloeFSn_m;VoSoAYOfodjMmomDX_WoFjSkofB^oOmMZOcoEJ?jod^K
n?m6UoKoCYggoeBRnOmKZ?_oI:kmoefYo?mEXo[oBi_hodJGm_m>WOOoE:;ioe^XnomT[_goGJWloeFS
n_m;VoSoAYOfodjMmomDX_WoFjSkofB^oCookno_00?oj^[Zooooooooool02?ooool001Kok^k^00ko
kNg]onGUiOo:b/[oVYZJohZ:R_o2`/;okNg]ooWinOofm_Kol_;bono_koo`l?3ok^k^onc/k0;ol?3`
00OolO7aolS8b?n;Rh_oVYZJol[:b_oUiNGokNg]027ok^k^06ko?8[WocF4i?lkR>Ko@XoXodVEj_m?
VNcoBYK[odBAjOllR^Oo=HCToc^8i_m2SnSoBIGZodnIk?m:U^_oA97Yocb:ioleQ>Co>hSVod:?j?m9
UN[oCiW/odZFjom4TNWo?8[WocF4i?lkR>Ko@XoXodVEj_m?VNcoBYK[odBAjOllR^Oo=HCToc^8i_m2
SnSoBIGZodnIk?m:U^_oA97Yocb:ioleQ>Co>hSVod:?j?m9UN[oCiW/odZFjom4TNWo?8[WocF4i?lk
R>Ko@XoXodVEj_m?VNcoBYK[odBAjOllR^Oo=HCToc^8i_m2SnSoBIGZodnIk?m:U^_oA97Yocb:iole
Q>Co>hSVod:?j?m9UN[oCiW/odZFjom4TNWo?8[WocF4i?lkR>Ko@XoXodVEj_m?VNcoBYK[odBAjOll
R^Oo=HCToc^8i_m2SnSoBIGZodnIk?m:U^_oA97Yocb:ioleQ>Co>hSVod:?j?m9UN[oCiW/odZFjom4
TNWo?8[WocF4i?lkR>Ko@XoXodVEj_m?VNcoBYK[odBAjOllR^Oo=HCToc^8i_m2SnSoBIGZodnIk3oo
iNGU00?of][Jonk^k_o^k^h02?o^k^h001Goi^KV00WoiNGUom[Jf_nb/[;oQHF5olC4a?ogmoOolo?c
ong]kOo^k^h00_o`l?001?ogmoOolO7aooOgmoobl_83oo7al@07oo?cloogmoOoa<C4ohF5QOnb/[;o
f][JonGUi@0PonKViP1^od^@gom8S=coBXkOoe:Dh?mJV^7oGIgRoe^KhomDU^7oBi3OodR<g?m:S]oo
DYCPoeZJhOmMWN;oFi_SoeBFhOm;T=ooB8cLodZ>gomBU>3oFY[QoefMh_mKVn?oE9KQod^@gom8S=co
BXkOoe:Dh?mJV^7oGIgRoe^KhomDU^7oBi3OodR<g?m:S]ooDYCPoeZJhOmMWN;oFi_SoeBFhOm;T=oo
B8cLodZ>gomBU>3oFY[QoefMh_mKVn?oE9KQod^@gom8S=coBXkOoe:Dh?mJV^7oGIgRoe^KhomDU^7o
Bi3OodR<g?m:S]ooDYCPoeZJhOmMWN;oFi_SoeBFhOm;T=ooB8cLodZ>gomBU>3oFY[QoefMh_mKVn?o
E9KQod^@gom8S=coBXkOoe:Dh?mJV^7oGIgRoe^KhomDU^7oBi3OodR<g?m:S]ooDYCPoeZJhOmMWN;o
Fi_SoeBFhOm;T=ooB8cLodZ>gomBU>3oFY[QoefMh_mKVn?oE9KQod^@gom8S=coBXkOoe:Dh?mJV^7o
GIgRoe^KhomDU^7oBi3OodR<g?m:S]ooDYCPoeZJhOmMWN8oom_Kf`03om?CdooVi^Koi^KV00Soi^KV
000Donk^kP08ong]kOoRh^;o/[:bohn?Soo/k>colo?conk^k_oalO42oo;blP06oo3`l?ohn?So^;Rh
ofYZJ_nMWIgom?Cd0oobl_802?oalO7ok^k^oo?cloo/k>coShn?ok:b/_oRh^;okNg]7oo^k^h0K_mg
Zn7oM:WPogNZh_mm[N?oP[7TohJdiOn4/nGoOJkSogN[hOmdZN3oMj[Rogf]hon2/NCoQ[CUohBciOmm
[^?oMj_QogBYh?mgZ^;oOJgSoh:ai?n6]>GoQ;?Uogf^homgZn7oM:WPogNZh_mm[N?oP[7TohJdiOn4
/nGoOJkSogN[hOmdZN3oMj[Rogf]hon2/NCoQ[CUohBciOmm[^?oMj_QogBYh?mgZ^;oOJgSoh:ai?n6
]>GoQ;?Uogf^homgZn7oM:WPogNZh_mm[N?oP[7TohJdiOn4/nGoOJkSogN[hOmdZN3oMj[Rogf]hon2
/NCoQ[CUohBciOmm[^?oMj_QogBYh?mgZ^;oOJgSoh:ai?n6]>GoQ;?Uogf^homgZn7oM:WPogNZh_mm
[N?oP[7TohJdiOn4/nGoOJkSogN[hOmdZN3oMj[Rogf]hon2/NCoQ[CUohBciOmm[^?oMj_QogBYh?mg
Z^;oOJgSoh:ai?n6]>GoQ;?Uogf^homgZn7oM:WPogNZh_mm[N?oP[7TohJdiOn4/nGoOJkSogN[hOmd
ZN3oMj[Rogf]hon2/NCoQ[CU?ooNg]h00ooJf][ok^k^onk^kP08onk^kP005?ooool01_oinOWob/[:
oiNGUoohn?Sokno_oo;blP?olo?c00Wol_;booGemOoYjNWoI6AToeUIFOmDE5CocLg=oo_knooalO40
0ooclo<01_obl_;okno_ooShn?nGUiOob/[:ooWinAoooooo06koSKOUohVdhon=]nCoSk[UoiBli_nI
_nOoU;gVohnii_n=]nGoRKCSohfgi?n?^^GoU;cVoiVoionD_NKoSkWVohfgiOn9]>?oSKOTohnjiOnD
_>KoVKoWoiBmi_n?^NKoSKOUohVdhon=]nCoSk[UoiBli_nI_nOoU;gVohnii_n=]nGoRKCSohfgi?n?
^^GoU;cVoiVoionD_NKoSkWVohfgiOn9]>?oSKOTohnjiOnD_>KoVKoWoiBmi_n?^NKoSKOUohVdhon=
]nCoSk[UoiBli_nI_nOoU;gVohnii_n=]nGoRKCSohfgi?n?^^GoU;cVoiVoionD_NKoSkWVohfgiOn9
]>?oSKOTohnjiOnD_>KoVKoWoiBmi_n?^NKoSKOUohVdhon=]nCoSk[UoiBli_nI_nOoU;gVohnii_n=
]nGoRKCSohfgi?n?^^GoU;cVoiVoionD_NKoSkWVohfgiOn9]>?oSKOTohnjiOnD_>KoVKoWoiBmi_n?
^NKoSKOUohVdhon=]nCoSk[UoiBli_nI_nOoU;gVohnii_n=]nGoRKCSohfgi?n?^^GoU;cVoiVoicoo
j>SX00?oj^[Zooooooooool02?ooool001?ok^k^00GokNg]om;Bd_n=SHgol?3`ono_k`05ooCdm009
oo?clooemOGol?3`og5aLOm>CTkoFe]KomSHf?ojn_[olo?c00Gom?Cd00Gokno_oo3`l?n=SHgod];B
ong]k@0Nonk^kP1^ogfTfon0X][oOJCLogjXgOmnZmooP:kOogj/gomlZ=goOJCKoh2Rf_mmY=coOZSM
ogj[gon0[]ooOZcOogbXgOmmY=_oP:;JogfTg?mnZ=goOZ_Ooh2^gomn[=ooO:SMogfTfon0X][oOJCL
ogjXgOmnZmooP:kOogj/gomlZ=goOJCKoh2Rf_mmY=coOZSMogj[gon0[]ooOZcOogbXgOmmY=_oP:;J
ogfTg?mnZ=goOZ_Ooh2^gomn[=ooO:SMogfTfon0X][oOJCLogjXgOmnZmooP:kOogj/gomlZ=goOJCK
oh2Rf_mmY=coOZSMogj[gon0[]ooOZcOogbXgOmmY=_oP:;JogfTg?mnZ=goOZ_Ooh2^gomn[=ooO:SM
ogfTfon0X][oOJCLogjXgOmnZmooP:kOogj/gomlZ=goOJCKoh2Rf_mmY=coOZSMogj[gon0[]ooOZcO
ogbXgOmmY=_oP:;JogfTg?mnZ=goOZ_Ooh2^gomn[=ooO:SMogfTfon0X][oOJCLogjXgOmnZmooP:kO
ogj/gomlZ=goOJCKoh2Rf_mmY=coOZSMogj[gon0[]loon?Sh`03omoOgoo^k^kok^k^00Sok^k^000C
onKViP05omoOgonNWYkoc<c<ooGemOodm?@01_oemOD01oodm?Cono_komKFe_nGUiOo`/;2oo[jn_od
m?@01_oemOD01Oodm?ComOGeolc<c?nNWYkogmoO01koi^KV06ko=5ZkocMJ^olcF[co=F:ooc=X`Olc
K<;o=FW1ocAQ_oldF[_o=eZkoc=J_?leH[oo<fS1oc=/`_leJL7o=66oocAJ^olgF[_o<eZlocER_olc
J<7o<fc2ocEY`OldHKoo=5ZkocMJ^olcF[co=F:ooc=X`OlcK<;o=FW1ocAQ_oldF[_o=eZkoc=J_?le
H[oo<fS1oc=/`_leJL7o=66oocAJ^olgF[_o<eZlocER_olcJ<7o<fc2ocEY`OldHKoo=5ZkocMJ^olc
F[co=F:ooc=X`OlcK<;o=FW1ocAQ_oldF[_o=eZkoc=J_?leH[oo<fS1oc=/`_leJL7o=66oocAJ^olg
F[_o<eZlocER_olcJ<7o<fc2ocEY`OldHKoo=5ZkocMJ^olcF[co=F:ooc=X`OlcK<;o=FW1ocAQ_old
F[_o=eZkoc=J_?leH[oo<fS1oc=/`_leJL7o=66oocAJ^olgF[_o<eZlocER_olcJ<7o<fc2ocEY`Old
HKoo=5ZkocMJ^olcF[co=F:ooc=X`OlcK<;o=FW1ocAQ_oldF[_o=eZkoc=J_?leH[oo<fS1oc=/`Soo
];Bd00?ohN7QonKVi_oVi^H02?oVi^H001?ok^k^00Coe]KFoi6ATOoinOWol_;b2?ofm_H01OoemOGo
o?clom;Bd_oclo?on?Sh00Som_Kf00Col_;booWinOnATI7oe]KFe_o^k^h001;ooooo00Goo_knolS8
b?nl_;con_[jooKfmP07ooOgm`07ooKfm_oinOWol_;bof9RH_o>c/koooooooGem@07ooOgm`05ooKf
m_ojn_[o_;blolS8b?ono_h0eOooool001;ok^k^00Cojn_[oj>SXooPh>3om_Kf2?ohn?P01oogmoOo
oOgmonKVi_mJFU[o`<30ooooooofm_H02?ohn?P01?ofm_Koh>3Poj>SXoo[jn_Eonk^kP004_oVi^H0
1?oRh^;oUIFEonk^k_ofm_H8oo[jnP07ooShn?ooooooe]KFoe1@D?n/[:coooooooOgm`08oo[jnP04
ooKfm_o^k^koUIFEon;RhTSoi^KV00Go[Jf]ogIfM_mGEeOoKFe]okVi^@28onKViP004_o^k^h01?oZ
j^[oV9RHono_koogmoL8oo_kn`07ooWinOoooooo`L71oda<C?nHV9SoooooooWin@08oo_kn`04ooOg
moo_knooV9RHon[ZjTSok^k^00KoOgmoofi^K_nJVY[oG5aLo`X:2_n_[jn7onk^kP004_ooool01?ol
o?coZj^[on_[jooinOT8ooclo007ooWinOooooooZj^[oe1@D?n3Ph?ooooooo_kn`08ooclo004ooWi
nOo[jn_oZj^[ooclo2Sooooo00?om?CdonSXj?ooool00oooool00oo/k>cooOgmooooo`02ooCdm0;o
oooo00?ono_konSXj?ooool05?ooool00omJFU[oAdM7ooooo`0Dooooo`03ooCdm?oXj>Sooooo06oo
oooo000Bonk^kP04ong]kOnd];Codm?Cooclo0SooOgm00Sono_koooooonDU9CoEEEEog=cLoofm_Ko
ooooooclo0OooOgm00Coo?clom?Cdond];CokNg]7_o^k^h07?lb<S;oKfm_onk^k_o^k^koiNGUob<S
8om1@D7okNg]omOGeom5ADGo0P82ob0P8?lE5AGo];Bdonk^k_m;Bd_o1`L7oaPH6?nATI7o4A4Aoe5A
DOo^k^koZ:RXo`d=3Ol10@7o:RXZohV9ROl?3`l2onk^kP06oc/k>omfMWKok^k^onk^k_lk>c_oMWIf
0_o^k^h02_nHV9So6QXJonk^k_o^k^koemOGoeIFE_le=CGoLG5aoi:BT_lL71`6onk^kP03og=cLolm
?Cgok^k^00;ok^k^00Ko>c/kogIfM_o^k^kok^k^oc/k>omfMWH2onk^kP09omOGeom5ADGo0P82ob0P
8?lE5AGo];Bdonk^k_m0@43o9RHV00;ok^k^00Ko@410obHV9_o^k^kok^k^od10@?lV9RISonk^kP00
4ooVi^H01?o:b/[oXZ:Rooooooolo?`8ooknoP07oooooon0P83oG5aLofEUIOoXj>Sooooooogmo@06
ooknoP04ooclo?ooooooXZ:Rol[:bQooi^KV01Co<30`of][JooVi^Koi^KVofEUIOlB4Q;od=3@onKV
i_lm?Cgo>CTiolW9bOoVi^Kofm_Kom[Jf_nb/[;o0`<3olO7aoo?clooDU9Bo`l?3`;oi^KV00Ko;Rh^
oe9BD_oEeMGo][JfobTY:Ol?3`l2onKViP06ocTi>OmbLW;oi^KVonKVi_li>CWoLW9b0_oVi^H02_nC
Ti?o6ATIonKVi_oVi^KoADE5obTY:OnBTY;oKfm_obPX:?lB4Q86onKViP03ofm_Kolk>c_oi^KV00;o
i^KV00Ko>CTiog9bL_oVi^Koi^KVocTi>OmbLW82onKViP09ocdm?Oli>CWobLW9onKVi_oKfm_of][J
onKVi_n6QXKoN7Qh00;oi^KV00KoQXJ6ogQhN?oVi^Koi^KVohJ6Q_mhN7QSonKViP004oo^k^h01?oW
inOoVi^Konk^k_ojn_X6ooknoP09oogmoOoooooom?Cdofm_KomRHV;oGEeMomGEeOooooooo?cl00Ko
o_kn00Con_[jonk^k_nKVi_oinOW7oo^k^h02_lb<S;oKfm_onk^k_ne]KGo0@41ojFUYOo^k^koc/k>
o`000?n[Zj/4onk^kP0:ol[:b_l20P;o/;2`onk^k_nDU9Co7AdMonk^k_oHf=So0000okNg]`;ok^k^
00KoWinOo`l?3oo^k^kok^k^oc/k>omfMWH2onk^kP0:oc/k>omfMWKok^k^onk^k_nHV9So6QXJonk^
k_oUiNGo20P8ojb/[0;ok^k^00?oS8b<o`l?3oo^k^h01Oo^k^h00omcLg?o?Cdmonk^kP02onk^kP0:
oc/k>omfMWKok^k^onk^k_lk>c_oMWIfonk^k_o>c/ko0000oj^[Zg;ok^k^000Dooooo`04om[Jf_nY
ZJWooOgmooclo0Gooooo00Woo_knoooooooUiNGoHf=SofIVI_mIFEWo`<30ooooooolo?`01Oooool0
1?olo?cooOgmojVYZOoJf]XPooooo`05ocHf=_mdM7Cokno_ob<S8omXJ6P00_ooool00onn_[ko0000
ocdm?@03oclo?`0;olC4a?oooooo[Jf]oc8b<_lc<c?o=SHfob0P8?oooooo`<30o`000?oVi^H00_oo
ool01_n/[:co4A4Aoooooooooooo@410ogmoO`;ooooo00[o@410ogmoOooooooooooooj>SXolL71co
oooool;2`_l0003oi^KV0_ooool00on/[:co4A4Aooooo`05ooooo`03ogalO?m2@T;ooooo00;ooooo
00[o@410ogmoOooooooooooood10@?moOgoooooookjn__l0003o?Cdm0olo?cl00oo4a<Cooooooooo
o`1/ooooo`005?o^k^h01OoZj^[o[jn_olK6a_ono_koo?cl00Cooooo00WooOgmoooooooNg]koFe]K
ofUYJOmEEEGo]KFeooooooolo?`01?ooool01Oolo?coo_knolK6a_n_[jooj^[Z023ok^k^00Go<S8b
o`820_l0003o0000okBd]002onk^kP07olc<c?l0003oWinOol71`Oni^KWo0P82omGEe@03onk^kP07
onc/k?n:RX[o7QhNonk^k_oAdM7o0000ojJVYP02onk^kP06oj2PX?l?3`ook^k^onk^k_lk>c_oMWIf
0_o^k^h02_lk>c_oEUIFonk^k_o^k^koTY:Boa/K6oo^k^kobl_;o`000?nXZ:P2onk^kP03oj2PX?l?
3`ook^k^00Gok^k^00?oLg=cocdm?Oo^k^h00_o^k^h03_lk>c_oMWIfonk^k_o^k^ko>c/kogIfM_o^
k^koc<c<o`000?nOWioo`L71okVi^Ol20P;oeMGEK_o^k^h001Goi^KV00Kog=cLoinOWoo:b/[ooooo
oo_knoono_h2ooooo`09ookno_oooooono_koh:2P_mFEUKoJ6QXon?Shoooooooo_kn00;ooooo00Ko
o_knoo_knooooooob/[:oinOWooLg=`QonKViP06oc0`<?m[Jf_oc<c<ohZ:R_l71`OoYZJV0_oVi^H0
1Olh>3SoH61PomkNg_n>SXko9RHV00;oi^KV00GoXZ:RolC4a?oShn?oEeMGod];B`02onKViP06oc`l
??lo?cooc<c<om?Cdom9BDWo3`l?0_oVi^H02_li>CWoLW9bonKVi_oVi^Ko>CTioa8B4_mZJV[ob<S8
odi>C_m5ADD2onKViP06ocDe=Olo?coobl_;omWIfOm=CDgo3`l?1OoVi^H02?oQhN7oJVYZocPh>?oL
g=cohN7QonKVi_li>CWoLW9b0_oVi^H02Oli>CWoLW9bonKVi_oVi^Ko>3Phof1PH?oNg]koSXj>obHV
9P1_onKViP005_o^k^h01ooShn?oZZZZojj^[_ogmoOooOgmoo_knoomoOd00oooool00ooemOGodM7A
on[ZjP03ooooo`07oogmoOokno_ooOgmooOgmon^[ZkoZZZZon?Sh`0Ronk^kP06oc8b<_m_Kfook^k^
onk^k_m4A4CoCDe=0_o^k^h01OoFe]Ko@T92o``<3?lJ6Q[oZZZZ00;ok^k^00GoP820obh^;_l>3Pko
=CDeokJf]P02onk^kP06omKFe_lo?coo2`/;obDU9OmUIFGo3`l?0_o^k^h02_m>CTkoPh>3onk^k_o^
k^koCTi>oh:2P_m`L73o4Q8BobXZ:_nf][H2onk^kP06om?Cdolo?coo2PX:obHV9_m^KVko9bLW1Oo^
k^h02?n5QHGo30`<o`H61_lI6AWoS8b<onk^k_m>CTkoPh>30_o^k^h02Olk>c_oMWIfonk^k_o^k^ko
e]KFod92@_l<30co6QXJojZZZP1_onk^kP005oooool05OoinOWoclo?oinOWoo=cLgonOWiooooooom
oOgono_koo[jn_olo?cooooooogmoOojn_[ono_koogmoOoooooonOWiolg=cOnOWiooclo?ooWin@0S
ooooo`06ocHf=_mgMgOooooooooooole=CGoEEEE1?ooool00oolo?coooooooooo`04ooooo`03oogm
oOoooooooooo00Cooooo00CooOgmoooooon/[:co4A4A2Oooool00oono_koooooooooo`04ooooo`03
oogmoOoooooooooo00Oooooo00?oOgmood51@Oooool01_ooool00om0@43oOgmoooooo`03ooooo`03
ooclo?oooooooooo06oooooo000Honk^kP08ong]kOoOgmoo]KFeoiNGUon^[Zkof][Joo7alOojn_X3
ooclo008oo[jn_oalO7of][Jojj^[_nGUiOo]KFeomoOgoo]kNdTonk^kP06oc8b<_l[:b_oE5ADob0P
8?l;2`_o][Jf5?o^k^h01_nPX:3o3`l?onk^k_o^k^koE5ADohR8R1Kok^k^00?o[:b/oa`L7?o^k^h0
0_o^k^h01_mDE5CoR8R8onk^k_o^k^ko>c/kogIfMWKok^k^000JonKViP06onGUiOoLg=coa/K6ojZZ
Z_nHV9SoTi>C0onATI401_nCTi?oV9RHojZZZ_o6a/Kog=cLonGUiBKoi^KV00GoWYjNohZ:R_n:RX[o
Z:RXon3Ph00EonKViP06oi^KVol?3`ooi^KVonKVi_nRXZ;o^;Rh5_oVi^H01ooPh>3o?ShnoalO7olI
6AWo`L71oj:RX_nh^;P00_oVi^H00oli>CWoLW9bonKViP1eonKViP007Oo^k^h02Oo]kNgoj^[ZonKV
i_oShn?oh^;Ron?ShooVi^Koj^[Zong]k@13onk^kP03ong]kOoYjNWok^k^01_ok^k^00?ofMWIomkN
g_o^k^h01?o^k^h00ooZj^[ok>c/onk^kP1eonk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00oooV
i^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^
k^h7onk^kP00ooooool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00oooo
ool7ooooo`00ooo^k^h7onk^kP00oooVi^H7onKViP00ooo^k^h7onk^kP00ooooool7ooooo`00ooo^
k^h7onk^kP00oooVi^H7onKViP00MOmoOgl8oginOXWoOgmo00001?o[jn_oi^KVon;Rh_oNg]h4omgM
g@?og]kN02kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgM
omkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kN
omgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgM
omkNg_oMgMgog]kN0_oMgMd0>_oLg=gogMgMomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]h2omcLg0;of=SH087oemOGomWIfOoJf]_ogMgMomcLg?oNg]kogMgMomkNg_oMgMgo
g]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]ko
gMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgo
g]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]ko
gMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgo
g]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]ko
gMgMomkNg_oMgMgog]kNomgMgOoNg]kogMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMko
g]kNomgMgOoNg]kogMgMomkNg_oMgMgog]kNomgMg_oNg]kogMgMomkNg_oMgMgog]kNomgMgOoNg]ko
gMgNomkNg_oMgMgog]kNomgMgOoNg]kogMgMomkNg_oMgMkog]kNomgMgOoNg]kogMgMomkNg_oMgMd0
0ooNg]h00ooMgMgog]kNomkNgP03omgMg@7ohN7Q0OoWinL1on[ZjP0000?ok>c/onKVi_oPh>001ooI
fMT01?oHf=Soe]KFom?Cdoo@d=03olg=c@04om3@d?oCdm?oemOGomSHf0_ofMWI00Cof=SHomOGeooC
dm?od=3@0oo=cLd01?o@d=3odm?ComOGeooHf=P<omWIf@09omSHf?oGemOoeMGEomCDe?oCdm?oe=CD
omGEeOoGemOof=SH033ofMWI0ooHf=P01OoIfMWof=SHomOGeooDe=Cod=3@00?ocLg=00?odM7AomGE
eOoHf=P02?oIfMT2omSHf0CofMWI0_oHf=P5omWIf@;of=SHIOoIfMT00ooHf=SofMWIomWIf@06omWI
f@7og]kN0OoVi^H1onc/k00000Ook^k^onWYjOoTi>Coh>3Pon7QhOoPh>3oh^;R00;ohN7Q00gog]kN
omcLg?oCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00gogmoO
om_KfooCdm?oalO7ok^k^onb/[;o[Zj^ok:b/_nk^k_oalO7om?CdooKfm_ogmoO00WohN7Q00goh>3P
omoOgooKfm_oe]KFom;Bd_o>c/koc<c<olk>c_oBd];oe]KFom_KfooOgmooh>3P01kohN7Q1_oPh>00
0ooQhN7oh>3Pon3Ph006on3Ph0;ogmoO00oog]kNomoOgooOgmooh>3PomoOgooKfm_oemOGomCDe?oB
d];odM7Aom;Bd_oIfMWog]kNon3Ph?oOgml00_oPh>001?oQhN7oh>3Pon3Ph?oOgml2omkNgP03omoO
gooPh>3oh>3P00;ogmoO00?og]kNomoOgooPh>000_oPh>001?oOgmoog]kNomoOgooOgml3on3Ph005
omoOgooPh>3oh>3Pon3Ph?oOgml00ooPh>001?oOgmooh>3Pon3Ph?oPh>1Gon7Qh@03on;Rh_oQhN7o
h^;R00CohN7Q0OoTi>@1onWYj@7okNg]00000oo`l?3okno_oo7al@03oo3`l00^ono_koo`l?3ok^k^
onWYjOoKfm_o`L71ojBTY?n<S8coNg]kogMgMomkNg_oS8b<ojBTY?o2`/7of][Jon[Zj_o]kNgolO7a
ono_kooalO7okno_oo7akoo_knoolO7aong]kOoZj^[of][Jol;2`_nTY:CoS8b;og]kNomgMgOoNg]k
ohb<S?nTY:Co`/;2om[Jf_oZj^SokNg]oo7alOo_knoolO7aono_kooalO7okno_oo7ak`;ok^k^00_o
i^KVomkNg_oAdM7obLW9ol71`Ono_kko`L71olW9bOoAdM7og]kNonKViP02onk^kP0Moo7akoo_knoo
lO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNoo
kno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO400_o^k^h01_oYjNWo
k>cZong]kOo`l?3okno_oo3`l0;ok>c/01Coj^[Zonk^k?o^k^kol?3`onc/k?o[jn_oi^KVonOWiooV
i^Kojn_Yonc/k?o_knoof][Joh^;RomTI6CoGUiNohJ6Q_oIfMOohn?Sonc/k0?ojn_[00Kol?3`onk^
k_o_kngojn_[onWYjOoUiND2onSXj004ong]kOo[jn_ojn_YonKViP;oj>SX0oo]kNd01ooXj>Soj>SV
onKVi_o[jn_ok>c/ono_kooZj^X00_o[jn/01Oo^k^cojn_[on_[jooZj^[ok^k^00;ojn_[063oj^[Z
ono_kOo^k^kolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7a
ono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_
oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7a
ono_kooalO7okno_oo7akoo_knoolO7aono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_
oo7alOo_knoolO7aono_kooalNookno_oo7alOo_knoolO7aono_kooalO7okno_oo7akoo_knoolO7a
ono_kooalO7okno_oo7alOo_knoolO7_ono_kooalO7okno_oo7alOo_knoolO7aoo3`l?o_knool?3`
ono_koo`l?3okno_oo3`l?o_knl4oo3`l00000?ol_;bonk^k_oWinL01?oUiND04?oTi>CogmoOom7A
dOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5AofIVI_n:RXWo/K6aom7AdOoNg]h2onCTi003
onGUiOoTi>CoiNGT00;oi>CT00oog]kNom7AdOna/K7oRXZ:ofIVI_mADE7oADE5od92@_m5ADGoDE5A
ofIVI_n:RX[o/K6aom7Ad?oNg]h00_oTi>@0=_oUiNGoi>CTonGUiOoTi>CoiNGTon;Rh_oLg=coclo?
ol71`Ona/K7oZJVYojBTY?nTY:?oY:BTojVYZOna/K7o`L71olo?cooLg=coh^;RonGUi?oTi>CoiNGU
onCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CT
onGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoh^;RomoOgooIfMWofm_J
omoOg`?oi>CT00CogmoOom_KfooIfMWogmoN0_oRh^806ooLg=cof=SHomCDe?oEeMGoe=CDomSHeooL
g=cohN7QolG5aOm=CDgoP820og]kNolW9bOo>CTiomKFe_oMgMgofm_KomWIfOoLg=coh^;Ron?ShooP
h=oof][JomKFe_oEeMGoemOGom[JfP02omkNgP1`omcLfooGemOoe]KFomKFe_oLg=cogmoOomkNg_oI
fMWoemOFomGEeOoIfMWogMgMon3Ph?oKfm_of][JomcLg?oPh=oog=cLom[Jf_oKfm_oh>3PomgMgOoJ
f][ofm_Kon7Qh?oShn?oiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoT
i>CoiNGUonCTi?oUiNGoi>CTonGUi?oTi>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oU
iNGoi>CTonGUiOoTi>CoiNGUonCTi?oUiNCoi>CTonGUiOoTi>CoiNGUonCTi?oUiNGoi>CTonGUi?oT
i>CoiNGUonCTi?oUiNGoi>CTonGUiOoTi>CoiNGTonCTi?oUiNGoi>CTonGUiOoTi>CoiNGUonCTi0Co
iNGU00Koi>CTonGUiOoUiNGoiNGUonSXj?o]kNd1oo;blP0000?om?Cdong]kOoWinL00_oPh>004ooQ
hN7ogmoOomkNg_oBd];o];BdohN7QomLG5coKC/eoii>@_o=KeoojH=_ole_GonNCT?oKC/foeaLG?n7
QhOo];Bdom;Bd_oNg]h01OoPh>004OoNg]kod];BokBd]?n7QhOoG5aLofeP;?nNURkocLdoonWYCOo=
cCooWYX_ofeS;OmLG5coQhN7okBd]?oBd];og]kN00Goh>3P017ogmoOom[Jf_o>c/ko_;bloj^[Zon`
/;3oalO7omWIfOoTi>CofMWIolO7aona/K7oZj^[okbl_?o>c/kof][JomoOg`0Lon3Ph009omkNg_oH
f=SodM7Aom;Bd_oIfMWog]kNomoOgooNg]kofMWI00;od];B00gof=SHomgMgOoKfm_oe=CDom3@d?o>
c/ko_;blolk>c_o@d=3oe=CDomSHf?oEeMGod=3@00;odM7A00Oo/K6ao`000?nWYjOof=SHomGEeOoA
dM7oe]KF00;ogMgM00Kof=SHom7AdOo?clooalO7olK6a_oHf=P2om_Kf`0JomSHf?o?clooa<C4om3@
d?oCdm?ofMWIom[Jf_oHf=So`l?3olc<c?o@d=3oe]KFom[Jf_oHf=SoemOGomWIfOoKfm_ofMWIomOG
eooHf=Sofm_Kom[Jf_oGemOof=SHomcLg?oOgmmEon3Ph003omoOgooPh>3ogmoO00;ogmoO0ooPh>00
0ooQhN7oinOWonc/k001ooCdm00000?om_Kfoo;bl_o[jn/00ooXj>P04ooWinOoh^;Rolg=cOnOWioo
JemOohlf;_o]LF7onIf@oofaYOom_:oooKBWooVOToo]M6?oTSL_of]OGonOWioocLg=on;Rh_oWinL0
0ooXj>P04ooWinOoh^;Rolg=cOnOWiooKVIOoi=b8_o]dDConO=doogmSOomoIGooOf>ooWhM_o]edOo
Tg<RofiWGonOWioocLg=on;Rh_oWinL01?oXj>P01ooVi^KogMgMol[:b_ne]KGo_knoonOWioo_knl0
0oo`l?001oo_knoojNWYol71`One]KGob/[:omgMgOoVi^H07?oXj>P01_oVi^KogmoOoc0`<?mXJ6So
g]kNonCTi0;oi^KV01WohN7Qof5QHOm7AdOoh>3PonGUiOoQhN7ofMWIogIfM_l820So5aLGo`T92Omh
N7Sof=SHomcLg?oIfMWoR8R8ocHf=_m9BDWoZj^[oa/K6on<S8cog]kNok^k^ol0003obLW900;oi>CT
00oog=cLokbl_?lh>3So0`<3oalO7olG5aOo_;blonCTi?m2@T;o2PX:oahN7_lg=cOo`/;2on;Rh_nn
_[h00_lG5aL04OlK6a_oHf=SomgMgOoTi>CoW9bLo`000?n/[:coi^KVokJf]_l0003oTi>ConKVi_o@
d=3o0000ogQhN?oVi^KoinOW05koj>SX0Oo/k>`1oo;blP7om_Kf00000oogmoOon?ShooShn003ooSh
n00CooOgmoo^k^koc/k>oi2@T?n5;b_ojFAFoo^BQoonYY_oo[6UoonhZoon/jKooZRLoo^DROo^J5Wo
RC4[oi2@T?o>c/kok^k^ooOgm`03ooShn00CooOgmoo^k^koc/k>oi2@T?nIJB_ol;dmoo_PK_onm8;o
o_j:ooooT_onoXcoo_R3oo_UL?o``SkoVFX[oi2@T?o>c/kok^k^ooOgm`04ooShn006ooCdm?oWinOo
clo?olK6a_oZj^[om?Cd0_oinOT02Oojn_[onOWiooWinOofm_Kojn_[olO7aoo?clooinOWooCdm00L
ooShn00QooKfm_o_knoo<c<cofm_KooXj>SokNg]oo7alOoclo?ol?3`ofQXJ?m;Bd_okno_ooCdm?o`
l?3oYJFUo`820_na/K7om?CdokJf]_l30`?oY:BTonWYjOnj^[[o0`<3ofi^K_nMWIgoADE5oa@D5?n<
S8cok^k^olS8b?l0003oe]KF00;olo?c027oinOWobh^;_m:BT[odM7AonSXj?oLg=coi^KVoo?clonj
^[[oh>3PonKVi_mHF5SoIFEUoo?clooOgmoo`/;2onOWiooIfMWo30`<okno_oofm_Kob/[:ofYZJ_oD
e=ComoOgom[Jf_mZJV[oa<C4ooOgmooZj^[oJVYZokBd]?ogmoL0F?ohn?P00oogmoOon?ShooShn002
ooShn004ooOgmooinOWomoOgooOgm`7on?Sh00000oojn_[omOGeonk^kP02onc/k00/on_[jooYjNWo
gmoOokZj^_miDU;o_c8TonMdJOomRGkooiR<oojRU_ooZ9cooZBHoonJSOonRWookWIZol<c9?miDU;o
^[ZjomoOgooZj^[ojn_[onc/k?o[jncoj^[ZomoOgonj^[[oR6EBon:A7?oi`e3ooMYSoooZL_onlgko
ooZ2ookfOoook7?oo]iToo[7DOoRTQcoRFICokZj^_oOgmooj^[Zon_[joo/k>`2on_[j`09onKViooH
f=So^k^komCDe?oTi>Cojn_[oo7alOobl_;olo?c00;ol_;b00KokNg]onGUiOoEeMGo^k^komSHf?oV
i^L2on_[j`2conc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_oj^[Zon;R
h_l`<33oJ6QYomWIfOoJf][ogMgMon3Ph?oRh^;oHV9RodQ8B?oOgn3oi^KVon;Rh_m@D53o<30`on3P
h?oTi>Coh>3Poc8b<_mBDU;og]kNog1`L?le=CGoh>3PonCTi?oIfMWo6ATIoh>3PooQhN7o_Kfmo`00
0?o:b/[ohn?SonKVi_n_[k3o0000ok2`/?oLg=cofMWIom_KfooQhN7oi>CTomkNgooJf][o_;blobLW
9omQHF7ojNWYon;Rh_oLg=cofMWJoi6ATOl10@7o^;Rhon[Zj_o/k>cojn_[onc/k?o[jncok>c/on_[
joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/
k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[
k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/
k?o[jncok>c/on_[joo/k>cojn_[onc/k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[
joo/k>cojn_/onc/k?o[jn_ok>c/on_[joo/k>cojn_[onc/k?o[jncok>c/on_[joo/k>cojn_[onc/
k?o[jn_ok>c/on_[k?o/k>cojn_[onc/k?o[jn_ok>c/on_[joo/k>cojn_/onc/k?o[jn_ok>c/on_[
joo/k>`01oo[jn/01Oo/k>cojn_[on_[joo^k^kom_Kf007onOWi00000ookno_olo?cong]k@02onGU
i@0/onKVi_oTi>CofMWIok:b/_mi;Rkob48don=ZG?odNVgooHQloojGR_onVhkooYR;ooj:O_odNfgo
if]MolY2=?mk;Rko/[:bomSHf?oTi>CoiNGUonKVi_oUiNKoi>CTomSHf?nb/[;oUUD^onZL:ook_4Co
o/aCoogHH_onhg;oo^UeookVLoonffGooLaCoo_1AOo^WR_oVEH^ok:b/_oHf=Soi>CTonGUiOoVi^H2
onGUi@0AomoOh?oAdM7o][JfomCDe?oMgMgoi>CTonKVi_o/k>cok>c]onc/k?oXj>Soi>CTomoOgooE
eMGo][Jfom7AdOoOgn000_oUiND09_oVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oU
iNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoV
i^KoiNGUonCTi?oLg=co;bl_od];C?n[Zj_oa/K6om?CdooEeMGof][Jof1PH?m5ADGoeMGF0_oLg=`0
5olg=cOoEeMGomOGeooHf=SoemOGoeMGF?lh>3Sog=cLocPh>?mKFe_oemOGomWIfOoGemOo9BDUoh20
P?oLg=co^[Zjo`000?o1`L7ofMWIomgMgOnATI;o0P8200Co=cLg077o^;RhomoOgoo=cLkoEUIFo`41
0Om=CDgocLg=on;Rh_oLg=co[:b/obLW:?l<30coPH61on;Rh_oTi>Coi^KVonGUiOoVi^KoiNGVonKV
i_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGU
i_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGVonKVi_oUiNGoi^KVonGUiOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKV
i_oUiNGoi^KVonGUi_oVi^KoiNGUonKVi_oUiNGoi^KVonGUiOoVi^KoiNGVonKVi_oUiNGoi^KVonGU
iOoVi^KoiNGUonKVi_oUiNKoi^KVonGUiOoVi^KoiNGUonKVi_oUiNGoi^KVonGUi_oVi^KoiNGUonKV
i_oUiNGoi^KVonGUi@02onKViP03onGUiOoVi^Koi^KV00?oi^KV00?oiNGUong]kOodm?@00Ookno/0
0003ooclo?ohn?SolO7a00?ok^k^01?ojn_[on7QhOnl_;coNQLGol<o<_oCETWoi6QJonmgK?odPgWo
n8MlooF4N_ocNFgoiFUKomUHB_o4?c;oO1LGokbl_?oQhN7ok>c/00?ok^k^01?ok>c/on7QhOnl_;co
YDLGonJG<_oe[33ooKa1oog9Doomd63onm=UoogBH?oncECooKe2ooZ_<_oYVc;oYDHGokbl_?oQhN7o
k>c/00?ok^k^00SokNg]onWYjOoJf][o^KViomOGeooNg]kohn?SonKViP?oj^[Z00Soj>SXonCTi?oN
g]kof=SHokVi^OoJf][ojNWYong]kA_ok^k^013ok>c/onGUiOla<C7o6a/KoahN7_l0003oDE5Aom?C
dooQhN7oI6ATocDe=OoPh>3oh^;RonKVi_mEEEGo;bl_0ooOgml01Ol_;booEUIFon[Zj_m@D53o<c<c
00?ogmoO01go9RHVohJ6Q_oWinOo`/;2o`000?ng]kOohN7QonCTi?nd];Co0000ojNWYonf][KoY:BT
o`D51OoOgmoojNWYof1PH?lW9bOo/k>con;Rh_oWinOojn_[on;Rh_l?3`ooGUiNom3@d?oTi>CojNWY
ong]k@1Zonk^kP03ong]kOobl_;on?Sh007oo?cl0003oogmo@0Fooclo?omoOgooOgmooclo?oclo?o
dM7AofP71onh=3Coaclcom9@@ooJHUGohfiRonAbI?oTKf;og6AGom=A@oo<@CCo^C@dof/71ooBd];o
lo?cooclo0?ooOgm01?oo?cloo?clooBd];oWR/7omZ:=?o[VaWomJPYooRd?ooi_D[on;m=ooZoB_oi
^3oomZXZonnN6OoKRcCoXRd7om;Bd_oclo?oo?cl00CooOgm00OonOWionc/k?nh^;Sofm_Kon7QhOoU
iNGojNWY00;ok>c/00SokNg]on[Zj_oUiNGoh^;Rom_Kfoni^KWok>c/ooWinAcooOgm02Wono_kooCd
m?ld=3CoLG5aono_koo6a/Ko2`/;ofEUIOoclo?oK6a/oa0@4?m[Jf_oemOGoo7alOnm_Kgo0P82oj:R
X_o/k>coXZ:Ro`820_nn_[koo?clokFe]Ol30`?oXj>Soo?clonb/[;o30`<oi2@T?ojn_[od];Bo`00
0?lh>3So_KfmonWYjOofm_Ko:b/[ogYjN_o_knooQXJ6ochn?P02oo_kn`0=oeeMGOm/K6comOGeonKV
i_o]kNgono_konk^k_l<30coa/K6ooGemOoLg=con_[jooclo01Xoogmo@03ooclo?omoOgoo?cl00?o
oOgm0000UoomoOgon_[joo?cloo^k^kol?3`ono_koo^k^kojNWYom?CdomK7AgoXS@dok@X7Oo1>Rgo
adTlolmFB_o@Ed_od5M:olY:?_o3>bko]RPMoj8d=?mL7Agodm?Con[Zj_o^k^kol?3`ono_koo`l>oo
k^k^on[Zj_oCdm?oS2DMolQa=?oIQ1goi9@EonNM9?o^Z3?ol:XdonnZ<oo/X2GoiiLEomb87Oo8LCCo
S2DMom?CdooZj^[ok^k^oo3`l?o_knool?3`ono_koo^k^gohn?Sojb/[?o:b/[od];BomOGeooJf][o
gMgMomkNgOoMgMgog=cLomOGeooDe=Cob/[:ojb/[?oShn?ok^k]ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o]kNgoj>SXoc4a<Om[Jf_og]kNomoOgomMGEgo
7AdMon[Zj_mfMWKoFe]KogQhN?l?3`oo];Bdonk^k_nIVIWo7alOo`P82?lP823oVYZJonk^k_o_knoo
k^k^ohV9ROlF5QKo4A4AoeiNG_le=CGoU9BDono_koo=cLgo6ATIoj^[ZolY:BWoDU9Bono_k_o=cLgo
>3Pho`X:2_lQ8B7o]kNgono_koo^k^kobLW8od51@OlB4Q;o3Ph>okNg]oo^k^kokno_oi2@T?lX:2So
3@d=ob`/;?o^k^h00_o_knl0H_o`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knoo
l?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3o
kno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knoo
l?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3o
kno_oo3`l?o_knool?3_ono_koo`l?3okno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knoo
l?3`ono_koo`l?3okno_oo3`koo_knool?3`ono_koo`l?3okno_oo3`l?o_knool?3_ono_koo`l?3o
kno_oo3`l?o_knool?3`ono_koo`l>ookno_oo3`l?o_knool?3`ono_koo`l?3okno_0_o`l?06ono_
k`7olo?c0OoinOT1ooknoP0000?oo_knooOgmoo`l?001?oYjNT04OoWinOofm_Kof=;Bon1<S;oYSDe
okHd;Oo2CD7o`eA9olAEB_o3E4Wo`Te1okHd;OnU=CGoPC8bof=;BooKfm_oinOW00GojNWY017oinOW
om_Kfon9Bd_o[d/boleg=OoFRbgoh9`^on2P<_oQX3Coh:0bomnJ;_oFRbgobWDeojm;<_n9Bd_ofm_K
onOWi`05onWYj@06onSXj?oShn?oZj^[okVi^Oo9bLWoclo?0_oEeMD02OoFe]KoeMGEomCDe?o?cloo
b<S8okVi^On[Zj_ohn?SonSXj00LonWYj@04onSXj?oTi>Co<30`ofUYJ@;ogMgM00Co?Shnocdm?OoW
inOoj>SX0_oYjNT00ooWinOoj>SXonWYj@02onWYj@03onOWiooYjNWojNWY00GojNWY00?oinOWonWY
jOoYjNT01_oYjNT01OoVi^KojNWYonWYjOoYjNWoi^KV00KojNWY00?oi^KVonWYjOoYjNT01?oYjNT0
0ooVi^KojNWYonWYj@1UonWYj@03onSXj?oYjNWojNWY00CojNWY0Oo`l?01ooOgm`7oo_kn00001Oon
o_kon_[jooCdm?o_knoolO7a00;ol?3`017okno_on_[jonEU9CoCb<SoiEDE?nkLg?odiFEomZLW?oJ
WYcofIbLomBEUOnkLg?oUEADodlS8onEU9Coj^[Zono_k`05oo3`l00Aono_kooZj^[oZIBDoh4S8onj
JUCoe9YconBlUOoZaicojLNLon[7W?oU_9Goe9Ycok]ZE?n18b?oZYBDon[Zj_o_knl01_o`l?001_o^
k^kobl_;ojNWYoo8b<Sof=SHon?Sh`?oi^KV00Kohn?SomSHf?o8b<SoYjNWol_;boo^k^hMoo3`l009
ono_koo^k^ko<S8bob`/;?mDE5Co92@To`410OnSXj?okno_09Sol?3`00ColO7aoo3`l?odm?Con_[j
0Oono_h00004onSXj?ooooooooooooknoP;ooooo0_ono_h0F?omoOgon?Shofi^K_mJ?coo/I2@omk9
bOo`i>ColnKVoo3Ti?oNbLWo/I2@oeXo?om]KFgon?Shooclo?ooooooo_knooooooono_koooonookn
o_ooooooo?clooShn?n=KFgoRSloolVAT?oYd<Wom>WTooK[i_odjNCojM39olVAT?n9?cooSFe]ooSh
moolo?coooooookno_ooooooo_knooooooono_koooonoogmoOolo?coaLG5okZj^_oMgMgolO7aooSh
n?oinOSon?Shoo7alOoMgMgo^[ZjolG5aOolo?cooOgmooooo_ono_koooooookno_ooooooo_knoooo
ooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookn
o_ooooooo_knooooo_ono_koooooookno_ooool2ooknoP05ojj^[_nIVISoVIVIojb/[?oLg=`00_on
o_h0U?ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_kooooo
ookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_kn
ooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooon
ookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_kn
ooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_knooooooono_kooooo
ookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooo_ono_koooooookno_ooooooo_kn
ooooooono_koooonookno_ooooooo_knooooooono_koooooookno_ooookoo_knooooooono_kooooo
ookno_ooooooo_knooooo_ono_koooooookno_ooooooo_knooooooono_koooonookno_ooooooo_kn
ooooooono_koooooookno_ooookoo_knooooooono_koooooookno_ooooooo_knooooooono_h2oooo
o`03ookno_oooooooooo00?ooooo0OoXj>P00004oo3`ooono_kon_[jooCdm0GolO7a00gokno_omKF
e_m[Jf_o@cdmoi^<S?o6^[[oe/c<olNj^_nKS8co@cdmof][JooFe]Kokno_00WolO7a00gokno_omOF
e_n3Jf_oM3dmokF<S?oE^[[ohLc<omJj^_nfS8coLSdmoh5[JooGe]Kokno_00WolO7a00gol?3`onKV
i_nm_Kgo/;2`olo?cooOgmooiNGUomoOgoo?cloo/;2`okfm_OoVi^Kol?3`0;SolO7a00Col?3`oo7a
lOoalO7ol?3`1?oalO400oodm?Con_[jooknoP01ononoP0000Gof][eoogmoOohn?Sol?3`on_[j`03
on[ZjP0=onWYjOoZj^[ojNWYonSXj?nKVi_oFEUIobHV9_l92@Wo9RHVoeUIFOnKVi_oj>SXonWYj@0;
on[ZjP0;onWYjOoXj>SoX9^KofYIFOm39RKo;@T9od8V9_mYFEWoX9^KonSXj?oYjNT03?oZj^X02OoY
jNWob/[:ok6a/OnMWIgoTY:BoifMWOna/K7ob/[:onWYj@31on[ZjP04on_[joo`l?3on?Shoogmo@7o
f_Ge00001?nTY<Ko[:b/oo[jn_odm?@8oo7al@;ol?3`0oo_knl2oo3`l0oolO7a0_o`l?03ono_k`;o
l?3`4OoalO43oo3`l<3olO7a00?ol?3`oo7alOoalO400_oalO400ooemOGon_[jongnoP01ojC6aP00
00?oZZ[DocLg=oooool0ooooool1ooooo`7ok_kn0On_cLd1oj[De00000Ko`L7bo`000?o6a/KofMWe
oo3`ooojn_ojooooo`05oo[oooo_o_kofOCdojC6a_nZeMD00Oo1l_800001\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{262, 140},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[BoxData[
    StyleBox[
      ButtonBox["SimpleProgressMonitorInputStream",
        ButtonData:>{"SimplePMInputStream.nb", None},
        ButtonStyle->"Hyperlink"],
      FontWeight->"Bold"]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(path = 
      JavaNew["\<java.lang.String\>", 
        StringJoin[$JavaSwingMaterial, "\<index.html\>"]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(\[LeftGuillemet]JavaObject[
          "java.lang.String"] \[RightGuillemet]\),
      JLink`Objects`JavaObject30144301065306113]], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\(JavaShow[frame];\)\), "\[IndentingNewLine]", 
    \(SimpleProgressMonitorInputStream[pane, path]\)}], "Input"],

Cell[BoxData[
    \(ReleaseObject[path]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> com.wolfram.jlink.MathJFrame <<<",
  FontColor->RGBColor[1, 0, 0]]], "Section"],

Cell[CellGroupData[{

Cell["Dispose", "Subsection"],

Cell[BoxData[{
    \(ReleaseObject[pane]\), "\n", 
    \(ReleaseObject[glass]\), "\n", 
    \(ReleaseObject[layer]\), "\n", 
    \(If[menubar =!= Null, ReleaseObject[menubar]]\), "\n", 
    \(frame@dispose[]\), "\n", 
    \(ReleaseObject[frame]\)}], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[">>> Quit <<<",
  FontColor->RGBColor[1, 0, 0]]], "Section"],

Cell[BoxData[{
    \(\(UninstallJava[];\)\), "\n", 
    \(Quit[]\)}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Reference:", "Section",
  CellFrame->True,
  Background->GrayLevel[0.849989]],

Cell["\<\
[1] Satyaraj Pantham, \"Pure JFC Swing\", Sams Publishing, \
1999\
\>", "Text",
  CellFrame->True,
  Background->GrayLevel[0.849989]],

Cell[BoxData[
    \(Get::"noopen" \(\(:\)\(\ \)\) 
      "Cannot open \!\(\"..\\\\FrontEnd\\\\StyleSheets\\\\JavaSwingStyle.nb\"\
\)."\)], "Message"],

Cell[BoxData[
    \(Get::"noopen" \(\(:\)\(\ \)\) 
      "Cannot open \!\(\"..\\\\FrontEnd\\\\StyleSheets\\\\JavaSwingStyle.nb\"\
\)."\)], "Message"],

Cell[BoxData[
    \(Get::"noopen" \(\(:\)\(\ \)\) 
      "Cannot open \!\(\"..\\\\FrontEnd\\\\StyleSheets\\\\JavaSwingStyle.nb\"\
\)."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \(\(:\)\(\ \)\) 
      "Further output of \!\(Get :: \"noopen\"\) will be suppressed during \
this calculation."\)], "Message"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.1 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
WindowSize->{988, 668},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{153, 155},
PrintingOptions->{"PrintingMargins"->{{54, 54}, {72, 72}},
"PrintCellBrackets"->False,
"PrintRegistrationMarks"->True,
"PrintMultipleHorizontalPages"->False},
CellLabelAutoDelete->True,
StyleDefinitions -> FrontEnd`FileName[{ParentDirectory[], "FrontEnd", \
"StyleSheets"}, "JavaSwingStyle.nb", CharacterEncoding -> "ShiftJIS"]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "animgif"->{
    Cell[7276961, 115551, 267, 6, 67, "Input",
      CellTags->"animgif"],
    Cell[7563915, 120400, 288, 6, 51, "Input",
      CellTags->"animgif"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"animgif", 16133208, 255621}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1727, 52, 62, 3, 140, "Title"],
Cell[1792, 57, 30, 0, 41, "Subtitle"],
Cell[1825, 59, 334, 5, 58, "Text"],
Cell[2162, 66, 108, 2, 29, "Text"],

Cell[CellGroupData[{
Cell[2295, 72, 245, 8, 52, "Section"],
Cell[2543, 82, 69, 1, 22, "Input"],

Cell[CellGroupData[{
Cell[2637, 87, 83, 1, 22, "Input"],
Cell[2723, 90, 55, 1, 23, "Print"],
Cell[2781, 93, 61, 1, 23, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2891, 100, 108, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[3024, 105, 55584, 913, 480, 55492, 910, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[58611, 1020, 454551, 5615, 481, 454437, 5611, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[513199, 6640, 28, 0, 39, "Subsection"],
Cell[513230, 6642, 40, 0, 29, "Text"],

Cell[CellGroupData[{
Cell[513295, 6646, 138, 2, 42, "Input"],
Cell[513436, 6650, 186, 3, 21, "Output"]
}, Open  ]],
Cell[513637, 6656, 229, 4, 50, "Text"],

Cell[CellGroupData[{
Cell[513891, 6664, 202, 4, 82, "Input"],
Cell[514096, 6670, 177, 3, 21, "Output"],
Cell[514276, 6675, 177, 3, 21, "Output"],
Cell[514456, 6680, 183, 3, 21, "Output"]
}, Open  ]],
Cell[514654, 6686, 145, 5, 29, "Text"],
Cell[514802, 6693, 113, 2, 42, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[514964, 6701, 95, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[515084, 6706, 9467, 157, 53, 9376, 154, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[524554, 6865, 21031, 348, 63, 20918, 344, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[545600, 7216, 185, 5, 29, "Text"],

Cell[CellGroupData[{
Cell[545810, 7225, 51, 1, 22, "Input"],
Cell[545864, 7228, 53, 1, 23, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[545966, 7235, 121, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[546112, 7240, 121940, 2001, 480, 121848, 1998, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[668055, 9243, 147525, 1825, 480, 147411, 1821, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[815617, 11073, 28, 0, 39, "Subsection"],
Cell[815648, 11075, 53, 0, 29, "Text"],

Cell[CellGroupData[{
Cell[815726, 11079, 369, 7, 142, "Input"],
Cell[816098, 11088, 57, 1, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[816192, 11094, 77, 1, 22, "Input"],
Cell[816272, 11097, 44, 1, 21, "Output"]
}, Open  ]],
Cell[816331, 11101, 45, 0, 29, "Text"],

Cell[CellGroupData[{
Cell[816401, 11105, 264, 4, 142, "Input"],
Cell[816668, 11111, 119, 2, 21, "Output"]
}, Open  ]],
Cell[816802, 11116, 106, 3, 29, "Text"],

Cell[CellGroupData[{
Cell[816933, 11123, 117, 3, 22, "Input"],
Cell[817053, 11128, 179, 3, 21, "Output"]
}, Open  ]],
Cell[817247, 11134, 231, 6, 50, "Text"],
Cell[817481, 11142, 764, 14, 342, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[818282, 11161, 29, 0, 39, "Subsection"],
Cell[818314, 11163, 149, 5, 29, "Text"],
Cell[818466, 11170, 225, 4, 102, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[818740, 11180, 121, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[818886, 11185, 91066, 1495, 480, 90974, 1492, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[909955, 12682, 95362, 1566, 480, 95248, 1562, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[1005354, 14253, 28, 0, 39, "Subsection"],
Cell[1005385, 14255, 148, 3, 29, "Text"],

Cell[CellGroupData[{
Cell[1005558, 14262, 64, 1, 22, "Input"],
Cell[1005625, 14265, 182, 3, 21, "Output"]
}, Open  ]],
Cell[1005822, 14271, 126, 3, 22, "Input"],
Cell[1005951, 14276, 772, 14, 342, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1006760, 14295, 29, 0, 39, "Subsection"],
Cell[1006792, 14297, 225, 4, 102, "Input"],
Cell[1007020, 14303, 61, 1, 22, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1007130, 14310, 103, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[1007258, 14315, 75588, 1241, 480, 75496, 1238, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[1082849, 15558, 74264, 1220, 480, 74150, 1216, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[1157150, 16783, 28, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[1157203, 16787, 60, 1, 22, "Input"],
Cell[1157266, 16790, 180, 3, 21, "Output"]
}, Open  ]],
Cell[1157461, 16796, 66, 1, 22, "Input"],

Cell[CellGroupData[{
Cell[1157552, 16801, 66, 1, 22, "Input"],
Cell[1157621, 16804, 176, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1157834, 16812, 66, 1, 22, "Input"],
Cell[1157903, 16815, 177, 3, 21, "Output"]
}, Open  ]],
Cell[1158095, 16821, 62, 1, 22, "Input"],
Cell[1158160, 16824, 104, 2, 42, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1158301, 16831, 29, 0, 39, "Subsection"],
Cell[1158333, 16833, 163, 3, 62, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1158545, 16842, 104, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[1158674, 16847, 487123, 7988, 409, 487031, 7985, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[1645800, 24837, 705094, 11562, 424, 704980, 11558, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[2350931, 36404, 28, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[2350984, 36408, 932, 17, 202, "Input"],
Cell[2351919, 36427, 1448, 26, 59, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2353404, 36458, 882, 17, 202, "Input"],
Cell[2354289, 36477, 1444, 26, 59, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2355770, 36508, 103, 2, 22, "Input"],
Cell[2355876, 36512, 180, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2356093, 36520, 472, 7, 202, "Input"],
Cell[2356568, 36529, 271, 4, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2356876, 36538, 205, 4, 82, "Input"],
Cell[2357084, 36544, 1419, 26, 59, "Output"]
}, Open  ]],
Cell[2358518, 36573, 327, 6, 102, "Input"],
Cell[2358848, 36581, 355, 9, 62, "Input"],
Cell[2359206, 36592, 234, 4, 82, "Input"],
Cell[2359443, 36598, 104, 2, 42, "Input"],
Cell[2359550, 36602, 45, 1, 22, "Input"],
Cell[2359598, 36605, 89, 1, 22, "Input"],
Cell[2359690, 36608, 39, 1, 22, "Input"],

Cell[CellGroupData[{
Cell[2359754, 36613, 91, 1, 22, "Input"],
Cell[2359848, 36616, 271, 4, 40, "Output"]
}, Open  ]],
Cell[2360134, 36623, 39, 1, 22, "Input"],
Cell[2360176, 36626, 66, 1, 22, "Input"],
Cell[2360245, 36629, 65, 1, 22, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2360347, 36635, 29, 0, 39, "Subsection"],
Cell[2360379, 36637, 176, 3, 82, "Input"],
Cell[2360558, 36642, 164, 3, 82, "Input"],
Cell[2360725, 36647, 166, 3, 82, "Input"],
Cell[2360894, 36652, 64, 1, 22, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2361007, 36659, 96, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[2361128, 36664, 488359, 8008, 409, 488267, 8005, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[2849490, 44674, 704488, 11552, 424, 704374, 11548, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[3553993, 56229, 213, 5, 50, "Text"],
Cell[3554209, 56236, 44, 0, 29, "Text"],
Cell[3554256, 56238, 666, 28, 518, "Text"],
Cell[3554925, 56268, 187, 5, 29, "Text"],

Cell[CellGroupData[{
Cell[3555137, 56277, 52, 1, 22, "Input"],
Cell[3555192, 56280, 58, 1, 23, "Print"],
Cell[3555253, 56283, 58, 1, 23, "Print"],
Cell[3555314, 56286, 58, 1, 23, "Print"],
Cell[3555375, 56289, 58, 1, 23, "Print"],
Cell[3555436, 56292, 58, 1, 23, "Print"],
Cell[3555497, 56295, 58, 1, 23, "Print"],
Cell[3555558, 56298, 58, 1, 23, "Print"],
Cell[3555619, 56301, 58, 1, 23, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3555726, 56308, 100, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[3555851, 56313, 61859, 1016, 409, 61767, 1013, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[3617713, 57331, 84321, 1385, 424, 84207, 1381, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[3702071, 58721, 28, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[3702124, 58725, 73, 1, 22, "Input"],
Cell[3702200, 58728, 70, 1, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3702307, 58734, 212, 3, 102, "Input"],
Cell[3702522, 58739, 43, 1, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3702602, 58745, 63, 1, 22, "Input"],
Cell[3702668, 58748, 181, 3, 21, "Output"]
}, Open  ]],
Cell[3702864, 58754, 238, 4, 102, "Input"],
Cell[3703105, 58760, 317, 6, 122, "Input"],
Cell[3703425, 58768, 39, 1, 22, "Input"],

Cell[CellGroupData[{
Cell[3703489, 58773, 58, 1, 22, "Input"],
Cell[3703550, 58776, 177, 3, 21, "Output"]
}, Open  ]],
Cell[3703742, 58782, 205, 5, 62, "Input"],
Cell[3703950, 58789, 39, 1, 22, "Input"],
Cell[3703992, 58792, 315, 6, 102, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3704344, 58803, 29, 0, 39, "Subsection"],
Cell[3704376, 58805, 174, 3, 82, "Input"],
Cell[3704553, 58810, 54, 1, 22, "Input"],
Cell[3704610, 58813, 133, 2, 42, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3704792, 58821, 100, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[3704917, 58826, 87491, 1436, 409, 87399, 1433, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[3792411, 60264, 326849, 5361, 424, 326735, 5357, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[4119297, 65630, 28, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[4119350, 65634, 63, 1, 22, "Input"],
Cell[4119416, 65637, 181, 3, 21, "Output"]
}, Open  ]],
Cell[4119612, 65643, 204, 3, 102, "Input"],
Cell[4119819, 65648, 317, 6, 122, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4120173, 65659, 29, 0, 39, "Subsection"],
Cell[4120205, 65661, 174, 3, 82, "Input"],
Cell[4120382, 65666, 133, 2, 42, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[4120564, 65674, 102, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[4120691, 65679, 92176, 1513, 480, 92084, 1510, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[4212870, 67194, 376283, 6171, 424, 376169, 6167, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[4589190, 73370, 28, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[4589243, 73374, 75, 1, 22, "Input"],
Cell[4589321, 73377, 72, 1, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4589430, 73383, 63, 1, 22, "Input"],
Cell[4589496, 73386, 181, 3, 21, "Output"]
}, Open  ]],
Cell[4589692, 73392, 209, 3, 102, "Input"],

Cell[CellGroupData[{
Cell[4589926, 73399, 310, 6, 142, "Input"],
Cell[4590239, 73407, 78, 1, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4590354, 73413, 109, 2, 22, "Input"],
Cell[4590466, 73417, 78, 1, 21, "Output"]
}, Open  ]],
Cell[4590559, 73421, 156, 4, 29, "Text"],
Cell[4590718, 73427, 394, 7, 182, "Input"],

Cell[CellGroupData[{
Cell[4591137, 73438, 66, 1, 22, "Input"],
Cell[4591206, 73441, 919, 17, 40, "Output"]
}, Open  ]],
Cell[4592140, 73461, 55, 0, 29, "Text"],
Cell[4592198, 73463, 661, 12, 262, "Input"],
Cell[4592862, 73477, 58, 0, 29, "Text"],
Cell[4592923, 73479, 685, 12, 282, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4593645, 73496, 29, 0, 39, "Subsection"],
Cell[4593677, 73498, 394, 8, 182, "Input"],
Cell[4594074, 73508, 133, 2, 42, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[4594256, 73516, 100, 1, 51, "Section"],
Cell[4594359, 73519, 44, 0, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4594440, 73524, 95, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[4594560, 73529, 375960, 6165, 538, 375868, 6162, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[4970523, 79696, 519280, 8516, 467, 519166, 8512, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[5489818, 88215, 139, 3, 25, "Input"],
Cell[5489960, 88220, 51, 1, 22, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5490048, 88226, 103, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[5490176, 88231, 80338, 1319, 409, 80246, 1316, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[5570517, 89552, 322172, 5284, 424, 322058, 5280, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[5892726, 94841, 28, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[5892779, 94845, 80, 1, 22, "Input"],
Cell[5892862, 94848, 180, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5893079, 94856, 63, 1, 22, "Input"],
Cell[5893145, 94859, 181, 3, 21, "Output"]
}, Open  ]],
Cell[5893341, 94865, 67, 1, 22, "Input"],

Cell[CellGroupData[{
Cell[5893433, 94870, 89, 1, 22, "Input"],
Cell[5893525, 94873, 185, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5893747, 94881, 84, 1, 22, "Input"],
Cell[5893834, 94884, 35, 1, 21, "Output"]
}, Open  ]],
Cell[5893884, 94888, 489, 9, 182, "Input"],

Cell[CellGroupData[{
Cell[5894398, 94901, 218, 4, 82, "Input"],
Cell[5894619, 94907, 177, 3, 21, "Output"],
Cell[5894799, 94912, 177, 3, 21, "Output"]
}, Open  ]],
Cell[5894991, 94918, 457, 8, 162, "Input"],

Cell[CellGroupData[{
Cell[5895473, 94930, 218, 4, 82, "Input"],
Cell[5895694, 94936, 177, 3, 21, "Output"],
Cell[5895874, 94941, 177, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5896088, 94949, 263, 6, 122, "Input"],
Cell[5896354, 94957, 35, 1, 21, "Output"],
Cell[5896392, 94960, 35, 1, 21, "Output"],
Cell[5896430, 94963, 35, 1, 21, "Output"],
Cell[5896468, 94966, 35, 1, 21, "Output"],
Cell[5896506, 94969, 37, 1, 21, "Output"],
Cell[5896546, 94972, 38, 1, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5896621, 94978, 218, 4, 82, "Input"],
Cell[5896842, 94984, 177, 3, 21, "Output"],
Cell[5897022, 94989, 177, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5897236, 94997, 111, 2, 42, "Input"],
Cell[5897350, 95001, 35, 1, 21, "Output"],
Cell[5897388, 95004, 35, 1, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5897460, 95010, 218, 4, 82, "Input"],
Cell[5897681, 95016, 177, 3, 21, "Output"],
Cell[5897861, 95021, 177, 3, 21, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[5898087, 95030, 29, 0, 39, "Subsection"],
Cell[5898119, 95032, 229, 4, 82, "Input"],
Cell[5898351, 95038, 117, 2, 42, "Input"],
Cell[5898471, 95042, 181, 3, 102, "Input"],
Cell[5898655, 95047, 133, 2, 42, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[5898837, 95055, 99, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[5898961, 95060, 81823, 1344, 409, 81731, 1341, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[5980787, 96406, 141567, 1751, 424, 141453, 1747, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[6122391, 98162, 28, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[6122444, 98166, 69, 1, 22, "Input"],
Cell[6122516, 98169, 66, 1, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6122619, 98175, 75, 1, 22, "Input"],
Cell[6122697, 98178, 72, 1, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6122806, 98184, 75, 1, 22, "Input"],
Cell[6122884, 98187, 173, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6123094, 98195, 47, 1, 22, "Input"],
Cell[6123144, 98198, 173, 3, 21, "Output"]
}, Open  ]],
Cell[6123332, 98204, 47, 1, 22, "Input"],

Cell[CellGroupData[{
Cell[6123404, 98209, 83, 1, 22, "Input"],
Cell[6123490, 98212, 176, 3, 21, "Output"]
}, Open  ]],
Cell[6123681, 98218, 33, 0, 29, "Text"],
Cell[6123717, 98220, 255, 4, 122, "Input"],

Cell[CellGroupData[{
Cell[6123997, 98228, 66, 1, 22, "Input"],
Cell[6124066, 98231, 178, 3, 21, "Output"]
}, Open  ]],
Cell[6124259, 98237, 60, 0, 29, "Text"],

Cell[CellGroupData[{
Cell[6124344, 98241, 143, 3, 62, "Input"],
Cell[6124490, 98246, 180, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6124707, 98254, 66, 1, 22, "Input"],
Cell[6124776, 98257, 177, 3, 21, "Output"]
}, Open  ]],
Cell[6124968, 98263, 50, 1, 22, "Input"],

Cell[CellGroupData[{
Cell[6125043, 98268, 83, 1, 22, "Input"],
Cell[6125129, 98271, 176, 3, 21, "Output"]
}, Open  ]],
Cell[6125320, 98277, 33, 0, 29, "Text"],
Cell[6125356, 98279, 255, 4, 122, "Input"],
Cell[6125614, 98285, 40, 0, 29, "Text"],

Cell[CellGroupData[{
Cell[6125679, 98289, 143, 3, 62, "Input"],
Cell[6125825, 98294, 181, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6126043, 98302, 66, 1, 22, "Input"],
Cell[6126112, 98305, 178, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6126327, 98313, 143, 3, 62, "Input"],
Cell[6126473, 98318, 181, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6126691, 98326, 66, 1, 22, "Input"],
Cell[6126760, 98329, 177, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6126974, 98337, 143, 3, 62, "Input"],
Cell[6127120, 98342, 180, 3, 21, "Output"]
}, Open  ]],
Cell[6127315, 98348, 49, 1, 22, "Input"],

Cell[CellGroupData[{
Cell[6127389, 98353, 406, 7, 162, "Input"],
Cell[6127798, 98362, 176, 3, 21, "Output"],
Cell[6127977, 98367, 180, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6128194, 98375, 66, 1, 22, "Input"],
Cell[6128263, 98378, 178, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6128478, 98386, 69, 1, 22, "Input"],
Cell[6128550, 98389, 66, 1, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6128653, 98395, 502, 9, 182, "Input"],
Cell[6129158, 98406, 180, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6129375, 98414, 66, 1, 22, "Input"],
Cell[6129444, 98417, 177, 3, 21, "Output"]
}, Open  ]],
Cell[6129636, 98423, 54, 1, 22, "Input"],

Cell[CellGroupData[{
Cell[6129715, 98428, 410, 7, 162, "Input"],
Cell[6130128, 98437, 177, 3, 21, "Output"],
Cell[6130308, 98442, 180, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6130525, 98450, 66, 1, 22, "Input"],
Cell[6130594, 98453, 177, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6130808, 98461, 272, 5, 142, "Input"],
Cell[6131083, 98468, 180, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6131300, 98476, 66, 1, 22, "Input"],
Cell[6131369, 98479, 178, 3, 21, "Output"]
}, Open  ]],
Cell[6131562, 98485, 48, 1, 22, "Input"],

Cell[CellGroupData[{
Cell[6131635, 98490, 405, 7, 162, "Input"],
Cell[6132043, 98499, 177, 3, 21, "Output"],
Cell[6132223, 98504, 180, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6132440, 98512, 66, 1, 22, "Input"],
Cell[6132509, 98515, 178, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6132724, 98523, 196, 3, 102, "Input"],
Cell[6132923, 98528, 180, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6133140, 98536, 68, 1, 22, "Input"],
Cell[6133211, 98539, 177, 3, 21, "Output"]
}, Open  ]],
Cell[6133403, 98545, 104, 2, 42, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6133544, 98552, 29, 0, 39, "Subsection"],
Cell[6133576, 98554, 736, 14, 282, "Input"],
Cell[6134315, 98570, 306, 5, 102, "Input"],
Cell[6134624, 98577, 58, 1, 22, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[6134731, 98584, 102, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[6134858, 98589, 28, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[6134911, 98593, 55, 1, 22, "Input"],
Cell[6134969, 98596, 177, 3, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6135183, 98604, 75, 1, 22, "Input"],
Cell[6135261, 98607, 72, 1, 21, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6135370, 98613, 91, 1, 22, "Input"],
Cell[6135464, 98616, 88, 1, 21, "Output"]
}, Open  ]],
Cell[6135567, 98620, 39, 1, 22, "Input"],
Cell[6135609, 98623, 66, 0, 29, "Text"],
Cell[6135678, 98625, 81897, 1014, 480, 81805, 1011, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[6217578, 99641, 50, 0, 29, "Text"],
Cell[6217631, 99643, 169565, 2097, 424, 169451, 2093, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[6387221, 101744, 104, 2, 22, "Input"],
Cell[6387328, 101748, 70, 1, 21, "Output"]
}, Open  ]],
Cell[6387413, 101752, 470, 9, 142, "Input"],

Cell[CellGroupData[{
Cell[6387908, 101765, 39, 1, 22, "Input"],

Cell[CellGroupData[{
Cell[6387972, 101770, 83310, 1031, 480, 83218, 1028, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[6471285, 102803, 58874, 730, 424, 58760, 726, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[6530208, 103539, 112, 2, 22, "Input"],
Cell[6530323, 103543, 75, 1, 21, "Output"]
}, Open  ]],
Cell[6530413, 103547, 471, 9, 142, "Input"],
Cell[6530887, 103558, 39, 1, 22, "Input"],

Cell[CellGroupData[{
Cell[6530951, 103563, 89, 1, 22, "Input"],
Cell[6531043, 103566, 817, 14, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6531897, 103585, 216, 4, 82, "Input"],
Cell[6532116, 103591, 314, 5, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6532467, 103601, 517, 10, 162, "Input"],
Cell[6532987, 103613, 171994, 2822, 424, 171880, 2818, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[6704996, 106438, 517, 10, 162, "Input"],
Cell[6705516, 106450, 25, 0, 29, "Text"],

Cell[CellGroupData[{
Cell[6705566, 106454, 95063, 1176, 480, 94971, 1173, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[6800632, 107632, 67652, 1112, 424, 67538, 1108, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[6868299, 108747, 517, 10, 162, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6868853, 108762, 29, 0, 39, "Subsection"],
Cell[6868885, 108764, 719, 13, 202, "Input"],
Cell[6869607, 108779, 115, 2, 42, "Input"],
Cell[6869725, 108783, 164, 3, 82, "Input"],
Cell[6869892, 108788, 57, 1, 22, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[6869998, 108795, 102, 1, 51, "Section"],

Cell[CellGroupData[{
Cell[6870125, 108800, 167690, 2751, 480, 167598, 2748, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[7037818, 111553, 235727, 3867, 480, 235613, 3863, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[7273582, 115425, 28, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[7273635, 115429, 288, 6, 67, "Input"],
Cell[7273926, 115437, 180, 3, 19, "Output"],
Cell[7274109, 115442, 36, 1, 19, "Output"],
Cell[7274148, 115445, 37, 1, 19, "Output"]
}, Open  ]],
Cell[7274200, 115449, 39, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[7274264, 115454, 70, 1, 19, "Input"],
Cell[7274337, 115457, 67, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7274441, 115463, 237, 4, 51, "Input"],
Cell[7274681, 115469, 208, 4, 19, "Output"],
Cell[7274892, 115475, 200, 3, 19, "Output"]
}, Open  ]],
Cell[7275107, 115481, 39, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[7275171, 115486, 76, 1, 19, "Input"],
Cell[7275250, 115489, 73, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7275360, 115495, 86, 1, 19, "Input"],
Cell[7275449, 115498, 201, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7275687, 115506, 61, 1, 19, "Input"],
Cell[7275751, 115509, 178, 3, 19, "Output"]
}, Open  ]],
Cell[7275944, 115515, 317, 5, 115, "Input"],

Cell[CellGroupData[{
Cell[7276286, 115524, 72, 1, 19, "Input"],
Cell[7276361, 115527, 178, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7276576, 115535, 76, 1, 19, "Input"],
Cell[7276655, 115538, 177, 3, 19, "Output"]
}, Open  ]],
Cell[7276847, 115544, 39, 1, 19, "Input"],
Cell[7276889, 115547, 47, 0, 28, "Text"],

Cell[CellGroupData[{
Cell[7276961, 115551, 267, 6, 67, "Input",
  CellTags->"animgif"],
Cell[7277231, 115559, 179, 3, 19, "Output"],
Cell[7277413, 115564, 36, 1, 19, "Output"],
Cell[7277452, 115567, 36, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7277525, 115573, 84, 1, 19, "Input"],
Cell[7277612, 115576, 177, 3, 19, "Output"]
}, Open  ]],
Cell[7277804, 115582, 104, 2, 35, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7277945, 115589, 29, 0, 38, "Subsection"],
Cell[7277977, 115591, 172, 3, 51, "Input"],
Cell[7278152, 115596, 167, 3, 51, "Input"],
Cell[7278322, 115601, 105, 2, 35, "Input"],
Cell[7278430, 115605, 133, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[7278612, 115613, 107, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[7278744, 115618, 636, 15, 243, "Input"],
Cell[7279383, 115635, 35, 1, 19, "Output"],
Cell[7279421, 115638, 35, 1, 19, "Output"],
Cell[7279459, 115641, 35, 1, 19, "Output"],
Cell[7279497, 115644, 35, 1, 19, "Output"],
Cell[7279535, 115647, 35, 1, 19, "Output"],
Cell[7279573, 115650, 35, 1, 19, "Output"],
Cell[7279611, 115653, 35, 1, 19, "Output"],
Cell[7279649, 115656, 35, 1, 19, "Output"],
Cell[7279687, 115659, 35, 1, 19, "Output"],
Cell[7279725, 115662, 35, 1, 19, "Output"],
Cell[7279763, 115665, 35, 1, 19, "Output"],
Cell[7279801, 115668, 35, 1, 19, "Output"],
Cell[7279839, 115671, 35, 1, 19, "Output"],
Cell[7279877, 115674, 35, 1, 19, "Output"],
Cell[7279915, 115677, 35, 1, 19, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[7279999, 115684, 99, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[7280123, 115689, 132941, 2182, 480, 132849, 2179, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[7413067, 117873, 148420, 2436, 480, 148306, 2432, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[7561524, 120314, 28, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[7561577, 120318, 278, 6, 67, "Input"],
Cell[7561858, 120326, 179, 3, 19, "Output"],
Cell[7562040, 120331, 37, 1, 19, "Output"],
Cell[7562080, 120334, 37, 1, 19, "Output"]
}, Open  ]],
Cell[7562132, 120338, 275, 4, 99, "Input"],
Cell[7562410, 120344, 29, 0, 28, "Text"],

Cell[CellGroupData[{
Cell[7562464, 120348, 74, 1, 19, "Input"],
Cell[7562541, 120351, 176, 3, 19, "Output"]
}, Open  ]],
Cell[7562732, 120357, 34, 0, 28, "Text"],

Cell[CellGroupData[{
Cell[7562791, 120361, 88, 1, 19, "Input"],
Cell[7562882, 120364, 174, 3, 19, "Output"]
}, Open  ]],
Cell[7563071, 120370, 126, 2, 51, "Input"],
Cell[7563200, 120374, 123, 2, 51, "Input"],
Cell[7563326, 120378, 195, 3, 67, "Input"],
Cell[7563524, 120383, 64, 0, 28, "Text"],
Cell[7563591, 120385, 51, 1, 19, "Input"],
Cell[7563645, 120388, 87, 1, 19, "Input"],
Cell[7563735, 120391, 113, 2, 35, "Input"],
Cell[7563851, 120395, 39, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[7563915, 120400, 288, 6, 51, "Input",
  CellTags->"animgif"],
Cell[7564206, 120408, 36, 1, 19, "Output"],
Cell[7564245, 120411, 36, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7564318, 120417, 247, 5, 67, "Input"],
Cell[7564568, 120424, 176, 3, 19, "Output"]
}, Open  ]],
Cell[7564759, 120430, 555, 9, 131, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7565351, 120444, 29, 0, 38, "Subsection"],
Cell[7565383, 120446, 110, 2, 35, "Input"],
Cell[7565496, 120450, 115, 2, 35, "Input"],
Cell[7565614, 120454, 59, 1, 19, "Input"],
Cell[7565676, 120457, 115, 2, 35, "Input"],
Cell[7565794, 120461, 133, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[7565976, 120469, 99, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[7566100, 120474, 135027, 2216, 480, 134935, 2213, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[7701130, 122692, 135858, 2230, 480, 135744, 2226, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[7837025, 124927, 28, 0, 38, "Subsection"],
Cell[7837056, 124929, 284, 4, 99, "Input"],
Cell[7837343, 124935, 39, 1, 19, "Input"],
Cell[7837385, 124938, 75, 1, 19, "Input"],
Cell[7837463, 124941, 57, 1, 19, "Input"],
Cell[7837523, 124944, 480, 8, 163, "Input"],
Cell[7838006, 124954, 56, 1, 19, "Input"],
Cell[7838065, 124957, 708, 13, 243, "Input"],
Cell[7838776, 124972, 62, 1, 19, "Input"],
Cell[7838841, 124975, 728, 13, 243, "Input"],
Cell[7839572, 124990, 56, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[7839653, 124995, 84, 1, 19, "Input"],
Cell[7839740, 124998, 81, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7839858, 125004, 83, 1, 19, "Input"],
Cell[7839944, 125007, 814, 16, 81, "Output"]
}, Open  ]],
Cell[7840773, 125026, 91, 1, 19, "Input"],
Cell[7840867, 125029, 388, 6, 115, "Input"],
Cell[7841258, 125037, 55, 1, 19, "Input"],
Cell[7841316, 125040, 201, 3, 67, "Input"],
Cell[7841520, 125045, 59, 1, 19, "Input"],
Cell[7841582, 125048, 327, 6, 115, "Input"],
Cell[7841912, 125056, 57, 1, 19, "Input"],
Cell[7841972, 125059, 411, 7, 131, "Input"],
Cell[7842386, 125068, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7842471, 125074, 29, 0, 38, "Subsection"],
Cell[7842503, 125076, 49, 1, 19, "Input"],
Cell[7842555, 125079, 133, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[7842737, 125087, 100, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[7842862, 125092, 78980, 1297, 480, 78888, 1294, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[7921845, 126391, 165512, 2716, 480, 165398, 2712, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[8087394, 129112, 28, 0, 38, "Subsection"],
Cell[8087425, 129114, 284, 4, 99, "Input"],
Cell[8087712, 129120, 84, 1, 19, "Input"],
Cell[8087799, 129123, 247, 4, 67, "Input"],
Cell[8088049, 129129, 83, 1, 19, "Input"],
Cell[8088135, 129132, 144, 2, 35, "Input"],
Cell[8088282, 129136, 48, 1, 19, "Input"],
Cell[8088333, 129139, 521, 9, 131, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8088891, 129153, 29, 0, 38, "Subsection"],
Cell[8088923, 129155, 52, 1, 19, "Input"],
Cell[8088978, 129158, 60, 1, 19, "Input"],
Cell[8089041, 129161, 105, 2, 35, "Input"],
Cell[8089149, 129165, 133, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[8089331, 129173, 89, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[8089445, 129178, 21741, 359, 53, 21650, 356, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[8111189, 129539, 34296, 565, 63, 34183, 561, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[8145500, 130107, 173, 5, 29, "Text"],

Cell[CellGroupData[{
Cell[8145698, 130116, 45, 1, 19, "Input"],
Cell[8145746, 130119, 183, 3, 21, "Print"],
Cell[8145932, 130124, 39, 1, 21, "Print"],
Cell[8145974, 130127, 184, 3, 21, "Print"],
Cell[8146161, 130132, 39, 1, 21, "Print"],
Cell[8146203, 130135, 184, 3, 21, "Print"],
Cell[8146390, 130140, 39, 1, 21, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[8146478, 130147, 120, 1, 50, "Section"],
Cell[8146601, 130150, 58960, 969, 480, 58868, 966, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[8205564, 131121, 52679, 866, 491, 52565, 862, "GraphicsData", "Bitmap", \
"Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[8258268, 131991, 28, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[8258321, 131995, 93, 1, 19, "Input"],
Cell[8258417, 131998, 90, 1, 19, "Output"]
}, Open  ]],
Cell[8258522, 132002, 182, 3, 67, "Input"],

Cell[CellGroupData[{
Cell[8258729, 132009, 657, 18, 131, "Input"],
Cell[8259389, 132029, 198, 3, 19, "Output"],
Cell[8259590, 132034, 198, 3, 19, "Output"],
Cell[8259791, 132039, 196, 3, 19, "Output"],
Cell[8259990, 132044, 197, 3, 19, "Output"]
}, Open  ]],
Cell[8260202, 132050, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8260287, 132056, 29, 0, 38, "Subsection"],
Cell[8260319, 132058, 249, 4, 67, "Input"],
Cell[8260571, 132064, 133, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[8260753, 132072, 106, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[8260884, 132077, 128736, 2113, 480, 128644, 2110, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[8389623, 134192, 272502, 4470, 480, 272388, 4466, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[8662162, 138667, 28, 0, 38, "Subsection"],
Cell[8662193, 138669, 284, 4, 99, "Input"],
Cell[8662480, 138675, 195, 3, 67, "Input"],
Cell[8662678, 138680, 459, 8, 115, "Input"],
Cell[8663140, 138690, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8663225, 138696, 29, 0, 38, "Subsection"],
Cell[8663257, 138698, 49, 1, 19, "Input"],
Cell[8663309, 138701, 133, 2, 35, "Input"],
Cell[8663445, 138705, 48, 1, 19, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[8663542, 138712, 102, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[8663669, 138717, 74672, 925, 480, 74580, 922, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[8738344, 139644, 52089, 857, 480, 51975, 853, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[8790470, 140506, 28, 0, 38, "Subsection"],
Cell[8790501, 140508, 285, 4, 99, "Input"],

Cell[CellGroupData[{
Cell[8790811, 140516, 69, 1, 19, "Input"],
Cell[8790883, 140519, 180, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8791100, 140527, 76, 1, 19, "Input"],
Cell[8791179, 140530, 180, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8791396, 140538, 241, 5, 51, "Input"],
Cell[8791640, 140545, 179, 3, 19, "Output"],
Cell[8791822, 140550, 36, 1, 19, "Output"],
Cell[8791861, 140553, 36, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8791934, 140559, 264, 6, 51, "Input"],
Cell[8792201, 140567, 179, 3, 19, "Output"],
Cell[8792383, 140572, 36, 1, 19, "Output"],
Cell[8792422, 140575, 36, 1, 19, "Output"]
}, Open  ]],
Cell[8792473, 140579, 213, 5, 48, "Text"],

Cell[CellGroupData[{
Cell[8792711, 140588, 83, 1, 19, "Input"],
Cell[8792797, 140591, 179, 3, 19, "Output"]
}, Open  ]],
Cell[8792991, 140597, 48, 1, 19, "Input"],
Cell[8793042, 140600, 52, 1, 19, "Input"],
Cell[8793097, 140603, 51, 1, 19, "Input"],
Cell[8793151, 140606, 52, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8793240, 140612, 29, 0, 38, "Subsection"],
Cell[8793272, 140614, 58, 1, 19, "Input"],
Cell[8793333, 140617, 58, 1, 19, "Input"],
Cell[8793394, 140620, 58, 1, 19, "Input"],
Cell[8793455, 140623, 52, 1, 19, "Input"],
Cell[8793510, 140626, 53, 1, 19, "Input"],
Cell[8793566, 140629, 133, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[8793748, 140637, 94, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[8793867, 140642, 15498, 256, 84, 15407, 253, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[8809368, 140900, 25684, 424, 200, 25570, 420, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[8835067, 141327, 183, 5, 29, "Text"],
Cell[8835253, 141334, 50, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8835340, 141340, 105, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[8835470, 141345, 61139, 1004, 480, 61047, 1001, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[8896612, 142351, 54598, 898, 480, 54484, 894, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[8951247, 143254, 28, 0, 38, "Subsection"],
Cell[8951278, 143256, 285, 4, 99, "Input"],

Cell[CellGroupData[{
Cell[8951588, 143264, 73, 1, 19, "Input"],
Cell[8951664, 143267, 182, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8951883, 143275, 81, 1, 19, "Input"],
Cell[8951967, 143278, 182, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8952186, 143286, 241, 5, 51, "Input"],
Cell[8952430, 143293, 179, 3, 19, "Output"],
Cell[8952612, 143298, 36, 1, 19, "Output"],
Cell[8952651, 143301, 36, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8952724, 143307, 264, 6, 51, "Input"],
Cell[8952991, 143315, 180, 3, 19, "Output"],
Cell[8953174, 143320, 36, 1, 19, "Output"],
Cell[8953213, 143323, 36, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8953286, 143329, 88, 1, 19, "Input"],
Cell[8953377, 143332, 182, 3, 19, "Output"]
}, Open  ]],
Cell[8953574, 143338, 48, 1, 19, "Input"],
Cell[8953625, 143341, 50, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8953712, 143347, 29, 0, 38, "Subsection"],
Cell[8953744, 143349, 172, 3, 51, "Input"],
Cell[8953919, 143354, 91, 2, 35, "Input"],
Cell[8954013, 143358, 133, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[8954195, 143366, 97, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[8954317, 143371, 15564, 257, 104, 15472, 254, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[8969884, 143630, 24761, 409, 200, 24647, 405, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[8994660, 144042, 189, 5, 29, "Text"],
Cell[8994852, 144049, 53, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8994942, 144055, 104, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[8995071, 144060, 64763, 1064, 480, 64671, 1061, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[9059837, 145126, 60690, 998, 480, 60576, 994, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[9120564, 146129, 28, 0, 38, "Subsection"],
Cell[9120595, 146131, 47, 0, 28, "Text"],
Cell[9120645, 146133, 253, 5, 67, "Input"],

Cell[CellGroupData[{
Cell[9120923, 146142, 118, 2, 35, "Input"],
Cell[9121044, 146146, 176, 3, 19, "Output"]
}, Open  ]],
Cell[9121235, 146152, 48, 0, 28, "Text"],

Cell[CellGroupData[{
Cell[9121308, 146156, 79, 1, 19, "Input"],
Cell[9121390, 146159, 181, 3, 19, "Output"]
}, Open  ]],
Cell[9121586, 146165, 153, 3, 51, "Input"],

Cell[CellGroupData[{
Cell[9121764, 146172, 595, 11, 163, "Input"],
Cell[9122362, 146185, 183, 3, 19, "Output"],
Cell[9122548, 146190, 183, 3, 19, "Output"],
Cell[9122734, 146195, 182, 3, 19, "Output"]
}, Open  ]],
Cell[9122931, 146201, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9123016, 146207, 29, 0, 38, "Subsection"],
Cell[9123048, 146209, 175, 3, 51, "Input"],
Cell[9123226, 146214, 53, 1, 19, "Input"],
Cell[9123282, 146217, 59, 1, 19, "Input"],
Cell[9123344, 146220, 133, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[9123526, 146228, 98, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[9123649, 146233, 65019, 1068, 480, 64927, 1065, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[9188671, 147303, 63146, 1038, 480, 63032, 1034, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[9251854, 148346, 28, 0, 38, "Subsection"],
Cell[9251885, 148348, 284, 4, 99, "Input"],

Cell[CellGroupData[{
Cell[9252194, 148356, 256, 4, 67, "Input"],
Cell[9252453, 148362, 573, 11, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9253063, 148378, 63, 1, 19, "Input"],
Cell[9253129, 148381, 175, 3, 19, "Output"]
}, Open  ]],
Cell[9253319, 148387, 39, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[9253383, 148392, 73, 1, 19, "Input"],
Cell[9253459, 148395, 168, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9253664, 148403, 63, 1, 19, "Input"],
Cell[9253730, 148406, 176, 3, 19, "Output"]
}, Open  ]],
Cell[9253921, 148412, 326, 6, 83, "Input"],
Cell[9254250, 148420, 39, 1, 19, "Input"],
Cell[9254292, 148423, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9254377, 148429, 29, 0, 38, "Subsection"],
Cell[9254409, 148431, 163, 3, 35, "Input"],
Cell[9254575, 148436, 121, 2, 35, "Input"],
Cell[9254699, 148440, 133, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[9254881, 148448, 106, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[9255012, 148453, 29920, 493, 182, 29828, 490, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[9284935, 148948, 31243, 515, 200, 31129, 511, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[9316193, 149466, 175, 5, 29, "Text"],

Cell[CellGroupData[{
Cell[9316393, 149475, 46, 1, 19, "Input"],
Cell[9316442, 149478, 44, 1, 21, "Print"],
Cell[9316489, 149481, 44, 1, 21, "Print"],
Cell[9316536, 149484, 46, 1, 21, "Print"],
Cell[9316585, 149487, 46, 1, 21, "Print"],
Cell[9316634, 149490, 46, 1, 21, "Print"],
Cell[9316683, 149493, 46, 1, 21, "Print"],
Cell[9316732, 149496, 44, 1, 21, "Print"],
Cell[9316779, 149499, 44, 1, 21, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[9316872, 149506, 122, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[9317019, 149511, 33962, 559, 185, 33870, 556, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[9350984, 150072, 32536, 536, 200, 32422, 532, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[9383535, 150611, 177, 5, 29, "Text"],

Cell[CellGroupData[{
Cell[9383737, 150620, 47, 1, 19, "Input"],
Cell[9383787, 150623, 45, 1, 21, "Print"],
Cell[9383835, 150626, 45, 1, 21, "Print"],
Cell[9383883, 150629, 49, 1, 21, "Print"],
Cell[9383935, 150632, 49, 1, 21, "Print"],
Cell[9383987, 150635, 47, 1, 21, "Print"],
Cell[9384037, 150638, 47, 1, 21, "Print"],
Cell[9384087, 150641, 49, 1, 21, "Print"],
Cell[9384139, 150644, 49, 1, 21, "Print"],
Cell[9384191, 150647, 47, 1, 21, "Print"],
Cell[9384241, 150650, 50, 1, 21, "Print"],
Cell[9384294, 150653, 45, 1, 21, "Print"],
Cell[9384342, 150656, 45, 1, 21, "Print"],
Cell[9384390, 150659, 43, 1, 21, "Print"],
Cell[9384436, 150662, 50, 1, 21, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[9384535, 150669, 102, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[9384662, 150674, 74795, 1228, 480, 74703, 1225, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[9459460, 151904, 310875, 5099, 543, 310761, 5095, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[9770372, 157008, 28, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[9770425, 157012, 267, 5, 99, "Input"],
Cell[9770695, 157019, 1250, 23, 51, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9771982, 157047, 68, 1, 19, "Input"],
Cell[9772053, 157050, 179, 3, 19, "Output"]
}, Open  ]],
Cell[9772247, 157056, 60, 1, 19, "Input"],
Cell[9772310, 157059, 56, 1, 19, "Input"],
Cell[9772369, 157062, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9772454, 157068, 29, 0, 38, "Subsection"],
Cell[9772486, 157070, 59, 1, 19, "Input"],
Cell[9772548, 157073, 93, 1, 19, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[9772690, 157080, 94, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[9772809, 157085, 45288, 745, 143, 45196, 742, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[9818100, 157832, 152049, 1881, 263, 151935, 1877, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[9970164, 159716, 183, 5, 29, "Text"],

Cell[CellGroupData[{
Cell[9970372, 159725, 50, 1, 19, "Input"],
Cell[9970425, 159728, 50, 1, 21, "Print"],
Cell[9970478, 159731, 50, 1, 21, "Print"],
Cell[9970531, 159734, 50, 1, 21, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[9970630, 159741, 99, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[9970754, 159746, 75755, 1244, 480, 75663, 1241, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[10046512, 160992, 73752, 1212, 480, 73638, 1208, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[10120301, 162209, 28, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[10120354, 162213, 69, 1, 19, "Input"],
Cell[10120426, 162216, 66, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10120529, 162222, 75, 1, 19, "Input"],
Cell[10120607, 162225, 173, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10120817, 162233, 47, 1, 19, "Input"],
Cell[10120867, 162236, 173, 3, 19, "Output"]
}, Open  ]],
Cell[10121055, 162242, 39, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[10121119, 162247, 217, 4, 51, "Input"],
Cell[10121339, 162253, 2606, 58, 67, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10123982, 162316, 271, 4, 83, "Input"],
Cell[10124256, 162322, 572, 11, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10124865, 162338, 73, 1, 19, "Input"],
Cell[10124941, 162341, 177, 3, 19, "Output"]
}, Open  ]],
Cell[10125133, 162347, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10125218, 162353, 29, 0, 38, "Subsection"],
Cell[10125250, 162355, 195, 4, 51, "Input"],
Cell[10125448, 162361, 91, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[10125564, 162366, 148, 4, 67, "Input"],
Cell[10125715, 162372, 188, 3, 19, "Output"]
}, Open  ]],
Cell[10125918, 162378, 59, 1, 19, "Input"],
Cell[10125980, 162381, 58, 1, 19, "Input"],
Cell[10126041, 162384, 210, 4, 28, "Text"],
Cell[10126254, 162390, 280, 6, 115, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[10126583, 162402, 91, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[10126699, 162407, 47402, 779, 139, 47310, 776, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[10174104, 163188, 53724, 884, 200, 53610, 880, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[10227843, 164075, 285, 7, 28, "Text"],
Cell[10228131, 164084, 816, 12, 581, "Text"],
Cell[10228950, 164098, 177, 5, 29, "Text"],

Cell[CellGroupData[{
Cell[10229152, 164107, 47, 1, 19, "Input"],
Cell[10229202, 164110, 41, 1, 21, "Print"],
Cell[10229246, 164113, 41, 1, 21, "Print"],
Cell[10229290, 164116, 41, 1, 21, "Print"],
Cell[10229334, 164119, 41, 1, 21, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[10229424, 164126, 103, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[10229552, 164131, 68492, 1125, 480, 68400, 1122, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[10298047, 165258, 67477, 1109, 480, 67363, 1105, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[10365561, 166372, 28, 0, 38, "Subsection"],
Cell[10365592, 166374, 284, 4, 99, "Input"],

Cell[CellGroupData[{
Cell[10365901, 166382, 82, 1, 19, "Input"],
Cell[10365986, 166385, 180, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10366203, 166393, 84, 1, 19, "Input"],
Cell[10366290, 166396, 180, 3, 19, "Output"]
}, Open  ]],
Cell[10366485, 166402, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10366570, 166408, 29, 0, 38, "Subsection"],
Cell[10366602, 166410, 124, 2, 35, "Input"],
Cell[10366729, 166414, 133, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[10366911, 166422, 107, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[10367043, 166427, 60660, 997, 480, 60568, 994, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[10427706, 167426, 54748, 900, 480, 54634, 896, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[10482491, 168331, 28, 0, 38, "Subsection"],
Cell[10482522, 168333, 284, 4, 99, "Input"],

Cell[CellGroupData[{
Cell[10482831, 168341, 65, 1, 19, "Input"],
Cell[10482899, 168344, 184, 3, 19, "Output"]
}, Open  ]],
Cell[10483098, 168350, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10483183, 168356, 29, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[10483237, 168360, 49, 1, 19, "Input"],
Cell[10483289, 168363, 50, 1, 19, "Output"]
}, Open  ]],
Cell[10483354, 168367, 60, 1, 19, "Input"],
Cell[10483417, 168370, 133, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[10483599, 168378, 102, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[10483726, 168383, 58114, 955, 480, 58022, 952, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[10541843, 169340, 47648, 784, 480, 47534, 780, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[10589528, 170129, 28, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[10589581, 170133, 87, 1, 19, "Input"],
Cell[10589671, 170136, 177, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10589885, 170144, 66, 1, 19, "Input"],
Cell[10589954, 170147, 180, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10590171, 170155, 59, 1, 19, "Input"],
Cell[10590233, 170158, 35, 1, 19, "Output"]
}, Open  ]],
Cell[10590283, 170162, 72, 1, 19, "Input"],
Cell[10590358, 170165, 57, 1, 19, "Input"],
Cell[10590418, 170168, 178, 5, 48, "Text"],
Cell[10590599, 170175, 54, 1, 19, "Input"],
Cell[10590656, 170178, 56, 1, 19, "Input"],
Cell[10590715, 170181, 55, 1, 19, "Input"],
Cell[10590773, 170184, 56, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10590866, 170190, 29, 0, 38, "Subsection"],
Cell[10590898, 170192, 115, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[10591062, 170200, 104, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[10591191, 170205, 84824, 1393, 480, 84732, 1390, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[10676018, 171600, 81808, 1344, 480, 81694, 1340, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[10757863, 172949, 30, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[10757918, 172953, 66, 1, 19, "Input"],
Cell[10757987, 172956, 63, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10758087, 172962, 152, 4, 35, "Input"],
Cell[10758242, 172968, 173, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10758452, 172976, 69, 1, 19, "Input"],
Cell[10758524, 172979, 182, 3, 19, "Output"]
}, Open  ]],
Cell[10758721, 172985, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10758806, 172991, 31, 0, 38, "Subsection"],
Cell[10758840, 172993, 99, 2, 35, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10758976, 173000, 30, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[10759031, 173004, 155, 4, 35, "Input"],
Cell[10759189, 173010, 176, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10759402, 173018, 69, 1, 19, "Input"],
Cell[10759474, 173021, 182, 3, 19, "Output"]
}, Open  ]],
Cell[10759671, 173027, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10759756, 173033, 31, 0, 38, "Subsection"],
Cell[10759790, 173035, 99, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[10759938, 173043, 102, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[10760065, 173048, 82416, 1353, 480, 82324, 1350, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[10842484, 174403, 142942, 2346, 480, 142828, 2342, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[10985463, 176754, 28, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[10985516, 176758, 58, 1, 19, "Input"],
Cell[10985577, 176761, 179, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10985793, 176769, 472, 9, 147, "Input"],
Cell[10986268, 176780, 180, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10986485, 176788, 484, 10, 195, "Input"],
Cell[10986972, 176800, 180, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10987189, 176808, 973, 17, 403, "Input"],
Cell[10988165, 176827, 180, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10988382, 176835, 332, 6, 131, "Input"],
Cell[10988717, 176843, 180, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10988934, 176851, 66, 1, 19, "Input"],
Cell[10989003, 176854, 196, 3, 19, "Output"]
}, Open  ]],
Cell[10989214, 176860, 39, 1, 19, "Input"],
Cell[10989256, 176863, 80, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[10989361, 176868, 144, 3, 19, "Input"],
Cell[10989508, 176873, 179, 3, 19, "Output"]
}, Open  ]],
Cell[10989702, 176879, 54, 1, 19, "Input"],
Cell[10989759, 176882, 39, 1, 19, "Input"],
Cell[10989801, 176885, 79, 1, 19, "Input"],
Cell[10989883, 176888, 79, 1, 19, "Input"],
Cell[10989965, 176891, 305, 5, 115, "Input"],
Cell[10990273, 176898, 39, 1, 19, "Input"],
Cell[10990315, 176901, 78, 1, 19, "Input"],
Cell[10990396, 176904, 341, 6, 115, "Input"],
Cell[10990740, 176912, 39, 1, 19, "Input"],
Cell[10990782, 176915, 78, 1, 19, "Input"],
Cell[10990863, 176918, 307, 5, 115, "Input"],
Cell[10991173, 176925, 50, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[10991248, 176930, 66, 1, 19, "Input"],
Cell[10991317, 176933, 181, 3, 19, "Output"]
}, Open  ]],
Cell[10991513, 176939, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10991598, 176945, 29, 0, 38, "Subsection"],
Cell[10991630, 176947, 267, 6, 99, "Input"],
Cell[10991900, 176955, 58, 1, 19, "Input"],
Cell[10991961, 176958, 93, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[10992103, 176966, 103, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[10992231, 176971, 144246, 2367, 480, 144154, 2364, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[11136480, 179340, 80921, 1329, 482, 80807, 1325, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[11217438, 180674, 28, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[11217491, 180678, 61, 1, 19, "Input"],
Cell[11217555, 180681, 181, 3, 19, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[11217785, 180690, 29, 0, 38, "Subsection"],
Cell[11217817, 180692, 60, 1, 19, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[11217926, 180699, 95, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[11218046, 180704, 26508, 437, 171, 26416, 434, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[11244557, 181143, 37298, 614, 200, 37184, 610, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[11281870, 181760, 185, 5, 29, "Text"],
Cell[11282058, 181767, 51, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11282146, 181773, 104, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[11282275, 181778, 81204, 1333, 480, 81112, 1330, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[11363482, 183113, 120901, 1985, 482, 120787, 1981, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[11484420, 185103, 28, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[11484473, 185107, 259, 5, 99, "Input"],
Cell[11484735, 185114, 1769, 32, 67, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11486541, 185151, 63, 1, 19, "Input"],
Cell[11486607, 185154, 175, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11486819, 185162, 85, 1, 19, "Input"],
Cell[11486907, 185165, 82, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11487026, 185171, 71, 1, 19, "Input"],
Cell[11487100, 185174, 13701, 304, 169, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11500838, 185483, 195, 4, 67, "Input"],
Cell[11501036, 185489, 182, 3, 19, "Output"]
}, Open  ]],
Cell[11501233, 185495, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11501318, 185501, 29, 0, 38, "Subsection"],
Cell[11501350, 185503, 285, 6, 115, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[11501684, 185515, 100, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[11501809, 185520, 64844, 1065, 480, 64752, 1062, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[11566656, 186587, 58530, 962, 482, 58416, 958, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[11625223, 187554, 28, 0, 38, "Subsection"],
Cell[11625254, 187556, 284, 4, 99, "Input"],

Cell[CellGroupData[{
Cell[11625563, 187564, 73, 1, 19, "Input"],
Cell[11625639, 187567, 70, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11625746, 187573, 59, 1, 19, "Input"],
Cell[11625808, 187576, 21429, 495, 249, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11647274, 188076, 56, 1, 19, "Input"],
Cell[11647333, 188079, 177, 3, 19, "Output"]
}, Open  ]],
Cell[11647525, 188085, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11647610, 188091, 29, 0, 38, "Subsection"],
Cell[11647642, 188093, 58, 1, 19, "Input"],
Cell[11647703, 188096, 133, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[11647885, 188104, 92, 1, 50, "Section"],
Cell[11647980, 188107, 88, 3, 28, "Text"],

Cell[CellGroupData[{
Cell[11648093, 188114, 56951, 936, 341, 56859, 933, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[11705047, 189052, 41759, 687, 200, 41645, 683, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[11746821, 189742, 179, 5, 29, "Text"],
Cell[11747003, 189749, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11747088, 189755, 166, 2, 122, "Section"],

Cell[CellGroupData[{
Cell[11747279, 189761, 86393, 1418, 480, 86301, 1415, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[11833675, 191181, 193690, 3178, 480, 193576, 3174, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[12027402, 194364, 28, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[12027455, 194368, 64, 0, 29, "Subsubsection"],

Cell[CellGroupData[{
Cell[12027544, 194372, 61, 1, 19, "Input"],
Cell[12027608, 194375, 178, 3, 19, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[12027835, 194384, 75, 0, 29, "Subsubsection"],

Cell[CellGroupData[{
Cell[12027935, 194388, 83, 1, 19, "Input"],
Cell[12028021, 194391, 176, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12028234, 194399, 101, 2, 19, "Input"],
Cell[12028338, 194403, 175, 3, 19, "Output"]
}, Open  ]],
Cell[12028528, 194409, 33, 0, 28, "Text"],
Cell[12028564, 194411, 153, 3, 51, "Input"],
Cell[12028720, 194416, 87, 3, 28, "Text"],

Cell[CellGroupData[{
Cell[12028832, 194423, 133, 3, 51, "Input"],
Cell[12028968, 194428, 176, 3, 19, "Output"]
}, Open  ]],
Cell[12029159, 194434, 125, 3, 28, "Text"],

Cell[CellGroupData[{
Cell[12029309, 194441, 153, 3, 51, "Input"],
Cell[12029465, 194446, 176, 3, 19, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[12029690, 194455, 51, 0, 29, "Subsubsection"],
Cell[12029744, 194457, 48, 1, 19, "Input"],
Cell[12029795, 194460, 24, 0, 28, "Text"],

Cell[CellGroupData[{
Cell[12029844, 194464, 425, 8, 83, "Input"],
Cell[12030272, 194474, 179, 3, 19, "Output"],
Cell[12030454, 194479, 187, 3, 19, "Output"],
Cell[12030644, 194484, 191, 3, 19, "Output"],
Cell[12030838, 194489, 190, 3, 19, "Output"],
Cell[12031031, 194494, 190, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12031258, 194502, 220, 5, 83, "Input"],
Cell[12031481, 194509, 181, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12031699, 194517, 88, 1, 19, "Input"],
Cell[12031790, 194520, 179, 3, 19, "Output"]
}, Open  ]],
Cell[12031984, 194526, 25, 0, 28, "Text"],
Cell[12032012, 194528, 150, 3, 19, "Input"],

Cell[CellGroupData[{
Cell[12032187, 194535, 125, 2, 35, "Input"],
Cell[12032315, 194539, 36, 1, 19, "Output"],
Cell[12032354, 194542, 36, 1, 19, "Output"]
}, Open  ]],
Cell[12032405, 194546, 233, 6, 99, "Input"],
Cell[12032641, 194554, 56, 1, 19, "Input"],
Cell[12032700, 194557, 48, 1, 19, "Input"],
Cell[12032751, 194560, 35, 0, 28, "Text"],
Cell[12032789, 194562, 61, 0, 28, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12032887, 194567, 84, 1, 29, "Subsubsection"],

Cell[CellGroupData[{
Cell[12032996, 194572, 88, 1, 19, "Input"],
Cell[12033087, 194575, 176, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12033300, 194583, 85, 1, 19, "Input"],
Cell[12033388, 194586, 179, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12033604, 194594, 56, 1, 19, "Input"],
Cell[12033663, 194597, 176, 3, 19, "Output"]
}, Open  ]],
Cell[12033854, 194603, 115, 2, 35, "Input"],
Cell[12033972, 194607, 48, 1, 19, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[12034069, 194614, 29, 0, 38, "Subsection"],
Cell[12034101, 194616, 52, 1, 19, "Input"],
Cell[12034156, 194619, 276, 6, 99, "Input"],
Cell[12034435, 194627, 68, 1, 19, "Input"],
Cell[12034506, 194630, 61, 1, 19, "Input"],
Cell[12034570, 194633, 61, 1, 19, "Input"],
Cell[12034634, 194636, 66, 1, 19, "Input"],
Cell[12034703, 194639, 53, 1, 19, "Input"],
Cell[12034759, 194642, 39, 1, 19, "Input"],
Cell[12034801, 194645, 55, 1, 19, "Input"],
Cell[12034859, 194648, 155, 4, 48, "Text"],
Cell[12035017, 194654, 107, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[12035173, 194662, 90, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[12035288, 194667, 53795, 884, 300, 53703, 881, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[12089086, 195553, 103626, 1702, 300, 103512, 1698, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[12192727, 197258, 175, 5, 29, "Text"],

Cell[CellGroupData[{
Cell[12192927, 197267, 46, 1, 19, "Input"],
Cell[12192976, 197270, 46, 1, 21, "Print"],
Cell[12193025, 197273, 69, 1, 21, "Print"],
Cell[12193097, 197276, 42, 1, 21, "Print"],
Cell[12193142, 197279, 65, 1, 21, "Print"],
Cell[12193210, 197282, 42, 1, 21, "Print"],
Cell[12193255, 197285, 65, 1, 21, "Print"],
Cell[12193323, 197288, 40, 1, 21, "Print"],
Cell[12193366, 197291, 63, 1, 21, "Print"],
Cell[12193432, 197294, 46, 1, 21, "Print"],
Cell[12193481, 197297, 69, 1, 21, "Print"],
Cell[12193553, 197300, 42, 1, 21, "Print"],
Cell[12193598, 197303, 65, 1, 21, "Print"],
Cell[12193666, 197306, 42, 1, 21, "Print"],
Cell[12193711, 197309, 65, 1, 21, "Print"],
Cell[12193779, 197312, 40, 1, 21, "Print"],
Cell[12193822, 197315, 63, 1, 21, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[12193934, 197322, 103, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[12194062, 197327, 33258, 547, 278, 33166, 544, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[12227323, 197876, 55383, 911, 200, 55269, 907, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[12282721, 198790, 185, 5, 29, "Text"],
Cell[12282909, 198797, 88, 3, 28, "Text"],

Cell[CellGroupData[{
Cell[12283022, 198804, 51, 1, 19, "Input"],
Cell[12283076, 198807, 38, 1, 21, "Print"],
Cell[12283117, 198810, 38, 1, 21, "Print"],
Cell[12283158, 198813, 38, 1, 21, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[12283245, 198820, 101, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[12283371, 198825, 90062, 1479, 480, 89970, 1476, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[12373436, 200306, 84236, 1384, 480, 84122, 1380, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[12457709, 201695, 28, 0, 38, "Subsection"],
Cell[12457740, 201697, 284, 4, 99, "Input"],

Cell[CellGroupData[{
Cell[12458049, 201705, 60, 1, 19, "Input"],
Cell[12458112, 201708, 178, 3, 19, "Output"]
}, Open  ]],
Cell[12458305, 201714, 39, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[12458369, 201719, 139, 3, 19, "Input"],
Cell[12458511, 201724, 179, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12458727, 201732, 78, 1, 19, "Input"],
Cell[12458808, 201735, 177, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12459022, 201743, 52, 1, 19, "Input"],
Cell[12459077, 201746, 177, 3, 19, "Output"]
}, Open  ]],
Cell[12459269, 201752, 56, 1, 19, "Input"],
Cell[12459328, 201755, 39, 1, 19, "Input"],
Cell[12459370, 201758, 55, 1, 19, "Input"],
Cell[12459428, 201761, 39, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[12459492, 201766, 141, 3, 19, "Input"],
Cell[12459636, 201771, 180, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12459853, 201779, 74, 1, 19, "Input"],
Cell[12459930, 201782, 177, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12460144, 201790, 53, 1, 19, "Input"],
Cell[12460200, 201793, 177, 3, 19, "Output"]
}, Open  ]],
Cell[12460392, 201799, 39, 1, 19, "Input"],
Cell[12460434, 201802, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12460519, 201808, 29, 0, 38, "Subsection"],
Cell[12460551, 201810, 185, 4, 67, "Input"],
Cell[12460739, 201816, 61, 1, 19, "Input"],
Cell[12460803, 201819, 133, 2, 35, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[12460985, 201827, 104, 1, 50, "Section"],
Cell[12461092, 201830, 23, 0, 28, "Text"],

Cell[CellGroupData[{
Cell[12461140, 201834, 30855, 508, 115, 30763, 505, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[12491998, 202344, 33728, 556, 140, 33614, 552, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[12525741, 202903, 50, 1, 19, "Input"],
Cell[12525794, 202906, 265, 4, 83, "Input"],
Cell[12526062, 202912, 22, 0, 28, "Text"],

Cell[CellGroupData[{
Cell[12526109, 202916, 33242, 547, 115, 33150, 544, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[12559354, 203465, 41139, 511, 140, 41025, 507, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[12600508, 203979, 50, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[12600583, 203984, 195, 3, 67, "Input"],
Cell[12600781, 203989, 35, 1, 19, "Output"]
}, Open  ]],
Cell[12600831, 203993, 29, 0, 28, "Text"],

Cell[CellGroupData[{
Cell[12600885, 203997, 35861, 590, 115, 35769, 587, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[12636749, 204589, 51390, 638, 140, 51276, 634, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[12688154, 205230, 58, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[12688237, 205235, 267, 5, 83, "Input"],
Cell[12688507, 205242, 35, 1, 19, "Output"]
}, Open  ]],
Cell[12688557, 205246, 26, 0, 28, "Text"],

Cell[CellGroupData[{
Cell[12688608, 205250, 36195, 596, 126, 36103, 593, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[12724806, 205848, 52787, 868, 220, 52695, 865, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[12777596, 206718, 48664, 604, 143, 48550, 600, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False],
Cell[12826263, 207324, 184388, 2280, 249, 184274, 2276, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[13010666, 209607, 53, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[13010744, 209612, 1099, 16, 291, "Input"],
Cell[13011846, 209630, 43, 1, 19, "Output"]
}, Open  ]],
Cell[13011904, 209634, 26, 0, 28, "Text"],

Cell[CellGroupData[{
Cell[13011955, 209638, 37618, 619, 115, 37526, 616, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[13049576, 210259, 47461, 589, 140, 47347, 585, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[13097052, 210851, 54, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[13097131, 210856, 193, 3, 67, "Input"],
Cell[13097327, 210861, 65, 1, 19, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[13097441, 210868, 134, 2, 50, "Section"],
Cell[13097578, 210872, 325, 7, 29, "Text"],

Cell[CellGroupData[{
Cell[13097928, 210883, 88630, 1455, 353, 88538, 1452, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[13186561, 212340, 132297, 1637, 337, 132183, 1633, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[13318895, 213982, 112, 2, 35, "Input"],
Cell[13319010, 213986, 56, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13319103, 213992, 26, 0, 19, "Input"],
Cell[13319132, 213994, 56, 1, 19, "Output"],

Cell[CellGroupData[{
Cell[13319213, 213999, 109822, 1359, 353, 109730, 1356, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[13429038, 215360, 136707, 1691, 337, 136593, 1687, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[13565794, 217057, 172, 4, 35, "Input"],
Cell[13565969, 217063, 63, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13566069, 217069, 175, 4, 35, "Input"],
Cell[13566247, 217075, 83, 1, 19, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[13566379, 217082, 106, 1, 50, "Section"],
Cell[13566488, 217085, 29, 0, 28, "Text"],

Cell[CellGroupData[{
Cell[13566542, 217089, 156198, 2563, 491, 156106, 2560, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[13722743, 219654, 229987, 2843, 480, 229873, 2839, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[13952745, 222500, 48, 0, 28, "Text"],

Cell[CellGroupData[{
Cell[13952818, 222504, 28, 0, 38, "Subsection"],
Cell[13952849, 222506, 131, 3, 28, "Text"],

Cell[CellGroupData[{
Cell[13953005, 222513, 159, 3, 51, "Input"],
Cell[13953167, 222518, 184, 3, 19, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[13953400, 222527, 29, 0, 38, "Subsection"],
Cell[13953432, 222529, 56, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13953525, 222535, 28, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[13953578, 222539, 192251, 2376, 491, 192159, 2373, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[14145832, 224917, 230218, 2846, 480, 230104, 2842, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[14376065, 227766, 88, 3, 28, "Text"],

Cell[CellGroupData[{
Cell[14376178, 227773, 279, 5, 83, "Input"],
Cell[14376460, 227780, 184, 3, 19, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[14376693, 227789, 29, 0, 38, "Subsection"],
Cell[14376725, 227791, 151, 5, 28, "Text"],

Cell[CellGroupData[{
Cell[14376901, 227800, 51, 1, 19, "Input"],
Cell[14376955, 227803, 170, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14377162, 227811, 139, 3, 51, "Input"],
Cell[14377304, 227816, 37, 1, 19, "Output"],
Cell[14377344, 227819, 37, 1, 19, "Output"],
Cell[14377384, 227822, 35, 1, 19, "Output"]
}, Open  ]],
Cell[14377434, 227826, 50, 1, 19, "Input"],
Cell[14377487, 227829, 56, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14377580, 227835, 39, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[14377644, 227839, 209142, 3431, 407, 209050, 3428, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[14586789, 231272, 307199, 5039, 429, 307085, 5035, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[14894025, 236316, 57, 1, 19, "Input"],
Cell[14894085, 236319, 47, 1, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14894169, 236325, 432, 8, 131, "Input"],
Cell[14894604, 236335, 4076, 87, 192, 652, 40, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[14898741, 236429, 98, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[14898864, 236434, 105393, 1730, 491, 105301, 1727, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[15004260, 238166, 130338, 2139, 491, 130246, 2136, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[15134601, 240307, 114785, 1421, 481, 114671, 1417, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False],
Cell[15249389, 241730, 141766, 1754, 481, 141652, 1750, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[15391192, 243489, 28, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[15391245, 243493, 458, 12, 83, "Input"],
Cell[15391706, 243507, 176, 3, 19, "Output"],
Cell[15391885, 243512, 177, 3, 19, "Output"],
Cell[15392065, 243517, 177, 3, 19, "Output"],
Cell[15392245, 243522, 177, 3, 19, "Output"],
Cell[15392425, 243527, 174, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15392636, 243535, 103, 2, 19, "Input"],
Cell[15392742, 243539, 196, 3, 19, "Output"]
}, Open  ]],
Cell[15392953, 243545, 39, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[15393017, 243550, 194, 4, 35, "Input"],
Cell[15393214, 243556, 198, 3, 19, "Output"],
Cell[15393415, 243561, 197, 3, 19, "Output"]
}, Open  ]],
Cell[15393627, 243567, 91, 2, 35, "Input"],
Cell[15393721, 243571, 39, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[15393785, 243576, 194, 4, 35, "Input"],
Cell[15393982, 243582, 196, 3, 19, "Output"],
Cell[15394181, 243587, 197, 3, 19, "Output"]
}, Open  ]],
Cell[15394393, 243593, 93, 2, 35, "Input"],
Cell[15394489, 243597, 39, 1, 19, "Input"],

Cell[CellGroupData[{
Cell[15394553, 243602, 435, 11, 51, "Input"],
Cell[15394991, 243615, 179, 3, 19, "Output"],
Cell[15395173, 243620, 179, 3, 19, "Output"],
Cell[15395355, 243625, 178, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15395570, 243633, 79, 1, 19, "Input"],
Cell[15395652, 243636, 176, 3, 19, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15395865, 243644, 66, 1, 19, "Input"],
Cell[15395934, 243647, 181, 3, 19, "Output"]
}, Open  ]],
Cell[15396130, 243653, 48, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15396215, 243659, 35, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[15396275, 243663, 132611, 2176, 491, 132519, 2173, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[15528889, 245841, 142092, 2332, 481, 141978, 2328, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[15670996, 248176, 115, 3, 28, "Text"],

Cell[CellGroupData[{
Cell[15671136, 248183, 551, 9, 195, "Input"],
Cell[15671690, 248194, 44, 1, 21, "Print"],
Cell[15671737, 248197, 42, 1, 21, "Print"],
Cell[15671782, 248200, 40, 1, 21, "Print"],
Cell[15671825, 248203, 58, 1, 21, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[15671932, 248210, 29, 0, 38, "Subsection"],
Cell[15671964, 248212, 256, 5, 83, "Input"],
Cell[15672223, 248219, 260, 5, 83, "Input"],
Cell[15672486, 248226, 163, 3, 51, "Input"],
Cell[15672652, 248231, 58, 1, 19, "Input"],
Cell[15672713, 248234, 58, 1, 19, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[15672820, 248241, 90, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[15672935, 248246, 116796, 1917, 356, 116704, 1914, "GraphicsData", \
"Bitmap", "Graphics"],
Cell[15789734, 250165, 124740, 2048, 385, 124626, 2044, "GraphicsData", \
"Bitmap", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[15914489, 252216, 103, 3, 28, "Text"],
Cell[15914595, 252221, 798, 12, 534, "Text"],
Cell[15915396, 252235, 175, 5, 29, "Text"],

Cell[CellGroupData[{
Cell[15915596, 252244, 46, 1, 19, "Input"],
Cell[15915645, 252247, 51, 1, 21, "Print"],
Cell[15915699, 252250, 49, 1, 21, "Print"],
Cell[15915751, 252253, 48, 1, 21, "Print"],
Cell[15915802, 252256, 49, 1, 21, "Print"],
Cell[15915854, 252259, 44, 1, 21, "Print"],
Cell[15915901, 252262, 51, 1, 21, "Print"],
Cell[15915955, 252265, 49, 1, 21, "Print"],
Cell[15916007, 252268, 51, 1, 21, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[15916107, 252275, 128, 2, 50, "Section"],

Cell[CellGroupData[{
Cell[15916260, 252281, 27451, 452, 110, 27359, 449, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[15943714, 252735, 36623, 603, 125, 36509, 599, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[15980352, 253341, 188, 5, 29, "Text"],
Cell[15980543, 253348, 52, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15980632, 253354, 108, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[15980765, 253359, 34218, 563, 136, 34126, 560, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[16014986, 253924, 43294, 538, 151, 43180, 534, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[16058295, 254465, 195, 5, 29, "Text"],

Cell[CellGroupData[{
Cell[16058515, 254474, 116, 2, 35, "Input"],
Cell[16058634, 254478, 173, 3, 21, "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[16058856, 254487, 119, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[16059000, 254492, 31453, 518, 117, 31361, 515, "GraphicsData", "Bitmap", \
"Graphics"],
Cell[16090456, 255012, 39430, 490, 140, 39316, 486, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[16129901, 255505, 204, 5, 29, "Text"],

Cell[CellGroupData[{
Cell[16130130, 255514, 137, 3, 19, "Input"],
Cell[16130270, 255519, 177, 3, 19, "Output"]
}, Open  ]],
Cell[16130462, 255525, 133, 2, 35, "Input"],
Cell[16130598, 255529, 52, 1, 19, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16130687, 255535, 107, 1, 50, "Section"],

Cell[CellGroupData[{
Cell[16130819, 255540, 29, 0, 38, "Subsection"],
Cell[16130851, 255542, 258, 6, 99, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[16131158, 255554, 83, 1, 50, "Section"],
Cell[16131244, 255557, 78, 2, 35, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16131359, 255564, 83, 2, 56, "Section"],
Cell[16131445, 255568, 143, 5, 35, "Text"],
Cell[16131591, 255575, 149, 3, 22, "Message"],
Cell[16131743, 255580, 149, 3, 22, "Message"],
Cell[16131895, 255585, 149, 3, 22, "Message"],
Cell[16132047, 255590, 163, 3, 22, "Message"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

